# Ferret
The Ferret program from NOAA/PMEL.  
See [https://ferret.pmel.noaa.gov/Ferret/](https://ferret.pmel.noaa.gov/Ferret/)
for more information about Ferret and PyFerret.

This repository is regularly synchronized with Ferret repository at PMEL
(the trunk of the ferret project in the subversion repository at PMEL)
using git-svn.

#### Legal Disclaimer
*This repository is a software product and is not official communication
of the National Oceanic and Atmospheric Administration (NOAA), or the
United States Department of Commerce (DOC).  All NOAA GitHub project
code is provided on an 'as is' basis and the user assumes responsibility
for its use.  Any claims against the DOC or DOC bureaus stemming from
the use of this GitHub project will be governed by all applicable Federal
law.  Any reference to specific commercial products, processes, or services
by service mark, trademark, manufacturer, or otherwise, does not constitute
or imply their endorsement, recommendation, or favoring by the DOC.
The DOC seal and logo, or the seal and logo of a DOC bureau, shall not
be used in any manner to imply endorsement of any commercial product
or activity by the DOC or the United States Government.*

## Ferret Documentation

For more information on using Ferret, see the Ferret documentation under
[https://ferret.pmel.noaa.gov/Ferret/](https://ferret.pmel.noaa.gov/Ferret/)

Information about the Ferret email users group, and archives of past discussions
from the group (which should be searched prior to sending a question to the email
users group) can be found at
[https://ferret.pmel.noaa.gov/Ferret/email-users-group](https://ferret.pmel.noaa.gov/Ferret/email-users-group)

## If you build Ferret from these source files:

1. We highly recommend you build and use PyFerret (see:
[https://github.com/NOAA-PMEL/PyFerret](https://github.com/NOAA-PMEL/PyFerret))
instead of Ferret.
PyFerret provides publication-quality graphics and much more funtionality while still maintaining
the Ferret command prompt and compatibility with existing Ferret scripts.
PyFerret uses Qt for displayed graphics, removing the need for X-Windows software libraries and 
header files for Ferret builds.  PyFerret maintains this Ferret repository as an upstream
source, so updates to Ferret will also be found in the "Ferret engine" within PyFerret.

2. If you still wish to build Ferret, more information on building Ferret can be found in the 
[README_build_ferret](https://github.com/NOAA-PMEL/Ferret/blob/master/README_build_ferret) 
and the 
[README_ferret_mac_homebrew.md](https://github.com/NOAA-PMEL/Ferret/blob/master/README_ferret_mac_homebrew.md)
files in this repository.
This second file can also provide some useful information about building Ferret on Linux and Unix-type systems. 

3. The `site_specific.mk.in` and `external_functions/ef_utilites/site_specific.mk.in`
files in the repository must be copied to files without the `.in` extensions, and
the contents of these `site_specific.mk` files edited for your system configuration.
The `site_specific.mk` files will be ignored by git (the name was added to
`.gitignore`) so your customized configuration files will not be added to your
repository if you have cloned this repository.

4. The definitions of CC, FC, and LD (the last only for building external
functions written in Fortran) were moved to the `site_specific.mk.in` files.
(These were previously defined in the `platform_specific.mk.*` files.)
If you already have customized `site_specific.mk` files, please appropriately
updated your customized files with these additional definitions.

As of August 2011 we now have a single make procedure for compiling, linking, and
installing Ferret.


NetCDF4.1 or higher is required for building Ferret. The library NetCDF4.2 or higher
is recommended. We recommend building NetCDF and HDF libraries yourself, so that these
libraries and Ferret are all built with the same compiler. This takes a little time, but
is not difficult. For building the libraries and Ferret, we have used gfortran. The
NetCDF downloads can be found here: http://www.unidata.ucar.edu/software/NetCDF/. Build
NetCDF4.+ with the appropriate version of hdf5 given in the NetCDF instructions; and make
sure to build it with fortran (Starting with NetCDF4.1.3 there is a separate NetCDF fortran
library). Specify the hdf5 libraries, --enable-NetCDF-4 --enable-dap for NetCDF-4 features
and OPeNDAP dataset access.

The current official release of Ferret is linked with NetCDF4.4.1 and has syntax for
writing NetCDF4 datasets (hdf5 chunking and compression.)


To build Ferret:

  * Under the FERRET directory you will find a file called "site_specific.mk.in".
  Copy this file to "site_specific.mk" and edit this copy of the file,
  inserting the locations of the HDF5, NetCDF, and readline directories.
  Similarily, in the "external_functions/ef_utility/" subdirectory of the FERRET directory
  is another "site_specific.mk.in" file that should be copied to "site_specific.mk"
  in that directory and edited to provide appropriate values.

  * Still in the top-level FERRET directory, run "make". This will compile and link Ferret,
  gksm2ps, external functions, and the fonts files. The Ferret executable is the file
  FERRET/fer/ferret_c

  * The build process creates the fonts files that will be needed for Ferret.

  * In the site_specific.mk file, you will see a section about the variable INSTALL_FER_DIR.
  It is defined there as INSTALL_FER_DIR = $(FER_DIR). If you leave it set that way, then run
  "make install" to install Ferret and the environment under that directory. It will also
  create the tar files fer_environment.tar.gz and fer_executables.tar.gz in directory $(FER_DIR).

  Alternatively you may want to set INSTALL_FER_DIR to some other directory.  Now run
  "make install".  This will install Ferret under the directory you defined and also
  create fer_environment.tar.gz and fer_executables.tar.gz as if they came from the
  Ferret distribution.  Now you can get the Datasets tar file from
  https://github.com/NOAA-PMEL/FerretDatasets
  which is needed to complete the installation by running the "bin/Finstall" script
  in the FERRET directory and selecting option 2 (generate the ferret_paths scripts).

  * Once you have installed Ferret, you'll want to test it. Running some simple scripts,
  such as "yes? go ptest" is a good place to start. If you wish, go into the FERRET/bench
  directory to run the suite of benchmark tests. There is a simple README file which will
  get you started with running the Ferret benchmark scripts. You will run a shell script
  called "run_all" which starts the benchmark job. It tests a wide variety of Ferret's
  capabilities and makes a number of plots. If it runs successfully you will see these lines:

about to run test of .ferret script
Display no longer set, about to run batch gif test
Display still not set, about to run batch ps test
Display still not set, about to run batch metafile test
Ended at Tue Nov 8 13:08:13 PST 2011
Checking PLT, GIF and PS files.......

  In all likelihood this will be followed by a number of messages starting with "plt files
  differ". The script checks the size of the image files, and it's to be expected that that
  will differ a bit from one system to another.

  Running all the way through the benchmark suite is a good test of Ferret and the Ferret
  installation. If you have questions about the results you are welcome to write us at the
  contact-Ferret email address, see http://ferret.pmel.noaa.gov/Ferret/support.

                            INTRODUCTION
                            ------------

This directory contains all source code and documentation associated
with the XGKS library.  XGKS is an X11 window system based version of
the ANSI Graphical Kernel System.  XGKS is a full GKS system (level
2C).  This library was developed at the University of Illinois, Urbana
campus, department of Computer Science and was funded by IBM TCS.  The
project was headed by Prof.  Bill Kubitz and Prof. Roy Campbell.
Development of XGKS was done by Greg Rogers, Sung Hsien Ching, and Yu
Pan.  Testing and improvements to XGKS were performed by IBM Technical
Computing Systems in Cambridge, Mass.  The IBM developers were Todd
Gill, Bruce Greer, David Owens, and Michael Wojcik, and Project Leader
Amy Pitts.

Neither the University of Illinois nor IBM support XGKS anymore.
Fortunately, however, Steve Emmerson of Boulder, Colorado has accepted
the maintenance of XGKS as a hobby.  There is also a mutual-aid-society
mailing-list for XGKS user's.  To join the mailing-list, send email to

    xgks-request@unidata.ucar.edu	(IP address: 128.117.140.3)

An archive of the XGKS mailing-list is available from the gopher(1) server
on host unidata.ucar.edu.  First select the category on Unidata support
databases, then select the category on the XGKS email archive.




                   SOURCE DIRECTORY OVERVIEW
                   -------------------------

The structure of the XGKS source directory-tree is


	       |-progs--
	       |
	       |        |-binding--
	       |-doc----|
	       |        |-userdoc--
	|-xgks-|
	       |-fontdb-
	       |
	       |        |-fortran--
	       |        |
	       |-src----|          |-cgm--
			|          |
			|-lib------|-gksm-
				   |
                                   |-x----

where:

    xgks	Is the root directory (the one containing this file)

    progs	Contains utility programs

    doc		Contains documentation (e.g. "xgks.3")

    doc/binding	Contains the source for a document describing the
		1988 C language binding for XGKS

    doc/userdoc	Contains the source for a document describing the
		GKS implementation-specific details of XGKS

    fontdb	Contains the XGKS fonts

    src		Contains the implementation of the XGKS runtime-library

    src/fortran	Contains the source for the Fortran interface to XGKS

    src/lib	Contains the source for the XGKS library.

    src/lib/cgm	Contains the source for the Compute Graphics Metafile
		"backend" to XGKS.

    src/lib/gksm
		Contains the source for the GKS Metafile (GKSM) "backend"
		to XGKS.

    src/lib/x	Contains the source for the X Window System "backend" to 
		XGKS.




                           INSTALLATION
                           ------------

Installation instructions can be found in the file INSTALL.

XGKS has been installed on many platforms, including:
    
	Apollo DN3000	under DomainOS 10.2,   BSD4.3, with C compiler
			68K Rev 6.7(316)
	Apollo DN4000	under DomainOS 10.3.2, BSD4.3, with C compiler
			68K Rev 6.8(168)
	Apollo 425T	under DomainOS 10.3.5
	VaxStation II	under Ultrix 3.5, 4.0, & 4.1
	DECstation 3100	under ULTRIX 4.1 & 4.2
	HP 9000/720	under HPUX 8.0
	Sun3		under SunOS 4.0.3, 4.1, & 4.1.1 (using both 
			    /usr/bin/cc and /usr/5bin/cc)
	Sun4		under SunOS 4.1 & 4.1.1
	IBM RS6000	under AIX 3.1
	Cray Y-MP	under UNICOS 5.1.11

The structure of the installation is nominally:

                            |-defcolors
                            |-font
                            |-mi
                  |-bin-----|-pline
                  |         |-pmark
                  |         |-hanoi
                  |         |-star
                  |         |-gksdemo
                  |
         |-prefix-|-include-|-xgks.h
                  |
                  |         |-libxgks.a
                  |-lib-----|-libfxgks.a
                  |         |-xgksfonts-
                  |
                  |-man-----|-man3-|-xgks.3

where:

    prefix      is whatever you made it when you invoked `configure' (see
		file INSTALL).

    defcolors   displays the default X colormap (set DISPLAY first);

    font        displays the fonts used by XGKS (set DISPLAY first);

    mi          is a simple GKS Metafile (GKSM) interpreter 
                (usage: mi <display> <file>);

    pline       displays the polyline types used by XGKS (set DISPLAY
                first);

    pmark       displays the marker types used by XGKS (set DISPLAY
                first);

    hanoi       is a Towers-of-Hanoi demonstration (set DISPLAY first);

    star        is a imple fortran program to draw a star (set DISPLAY first);

    gksdemo     is a Fortran program that demonstrats most of XGKS 
		capabilities (set DISPLAY first);

    xgks.h      is the header-file that every XGKS application must
                #include;

    libxgks.a   is the XGKS runtime library.

    xgksfonts   is a directory which contains the XGKS fonts;

    xgks.3      contains the XGKS man(1)ual pages.

Fonts used by XGKS are dynamically loaded when first referenced.  Thus,
the fonts must be installed on the machine where the XGKS application
executes.

The font path is compiled into the library.  However, it is possible to
move the fonts without having to recompile XGKS by setting the
environment variable "XGKSFontDir" to the new path before executing an
XGKS application.  This variable setting will tell XGKS at runtime
where to find its fonts.




                            DOCUMENTATION
                            -------------

In addition to the man(1)ual pages that will be installed during the
installation procedure, there are two other documents you should be aware
of.  The first describes the C-language binding used by XGKS.  To obtain
hardcopy, go to directory "doc/binding", edit the makefile (if necessary),
and type "make hardcopy".

The second document details the implementation-specific aspects of GKS
particular to XGKS.  To obtain hardcopy, go to directory "doc/userdoc",
edit the makefile (if necessary), and type "make hardcopy".

A good general book on GKS is "Computer Graphics Programming: GKS - The
Graphics Standard" by G. Enderle, K. Kansy, and G. Pfaff.  It's published
by Springer-Verlag and its ISBN numbers are 3-540-16317-4 and
0-387-16317-4.




                               A PLEA
                               ------

Please send any contributions to the evolution of XGKS to

	xgks-request@unidata.ucar.edu

They'll be incorporated so that the next poor grunt won't have such a tough
time.


Regards,
Steve Emmerson          xgks-request@unidata.ucar.edu

# Ferret on Mac OS X with Homebrew Packages
Information about building Ferret on Mac OS X using the Homebrew package 
manager to install required packages.
If you do not have Homebrew installed, see https://brew.sh/ for information 
on installing and using Homebrew.

## Building Ferret on Mac OS X with Homebrew Packages.

#### XQuartz

Ferret on Mac OS X requires X-Windows X11 support for displayed plots.
We have found that XQuartz (free software) works well.
See https://support.apple.com/en-us/HT201341 and https://www.xquartz.org/ 
for more information.
The `platform_specific.mk.intel-mac` configuration file assumes the required 
X11 include files and libraries are located where XQuartz installs them 
(under `/opt/X11/`).

#### Homebrew Packages

Make sure you have the Xcode application installed (available for free from 
the Apple App Store application), and have run `xcode-select --install` to 
add the command-line developer tools.

Also make sure the bin subdirectory of the Homebrew package installation 
directory (`/usr/local/bin` is the default) is in your PATH environment 
variable, for example:

    export PATH="/usr/local/bin:$PATH"

Install the `gcc`, `readline`, `hdf5`, and `netcdf` Homebrew packages.

    brew install gcc
    brew install readline
    brew install hdf5
    brew install netcdf

#### Ferret

Obtain the Ferret source code from GitHub.
You could just download the source code zip or tar.gz file for a Ferret release 
from https://github.com/NOAA-PMEL/Ferret/releases/ and extract it to the desired 
parent directory for building Ferret.
Or, if you are familiar with `git`, you can clone the Ferret repository to build 
from the latest development code:

    git clone https://github.com/NOAA-PMEL/Ferret.git $HOME/git/Ferret
    cd $HOME/git/Ferret

Working with a cloned repository allows you to quickly and easily update and 
rebuild Ferret when updates appear that you wish to use.
(If you wish to help with Ferret development, fork the NOAA-PMEL/Ferret 
repository to a repository under your own GitHub account and then clone your copy 
of the repository to your local system.)

In the Ferret source directory, copy the `site_specific.mk.in` configuration 
template file to `site_specific.mk` and edit this `site_specific.mk` configuration 
file appropriately for your system; for example:

    DIR_PREFIX = $(HOME)/git/Ferret (wherever you cloned or copied the Ferret source)
    BUILDTYPE = intel-mac
    INSTALL_FER_DIR = /usr/local/Ferret-7.4 (wherever you want Ferret installed)
    CC = $(shell which clang)
    FC = $(shell which gfortran)
    HDF5_LIBDIR =
    SZ_LIBDIR =
    NETCDF_LIBDIR = /usr/local/lib (wherever Homebrew put its netcdf library)
    READLINE_LIBDIR = /usr/local/Cellar/readline/8.0.4/lib (wherever Homebrew put its hidden readline library)

Similarly, copy `external_functions/ef_utility/site_specific.mk.in` to
`external_functions/ef_utility/site_specific.mk` and edit
`external_functions/ef_utility/site_specific.mk`:

    BUILDTYPE = intel-mac
    CC = $(shell which clang)
    FC = $(shell which gfortran)
    LD = $(shell which gfortran)

Build Ferret and install it in the location given by `INSTALL_FER_DIR`:

    make
    make install

At this point you are now where one would be if you had downloaded and extracted 
a prebuilt Ferret tar file to the Ferret installation directory.
Run the `Finstall` script under the bin subdirectory of the Ferret installation 
directory to create the ferret_paths scripts for setting environment variables 
needed by Ferret.

#### Testing

To run the benchmark tests, the `nco`, `imagemagick`, and `gs` Homebrew packages 
are needed.

    brew install nco
    brew install imagemagick
    brew install gs

Make sure the environment variables need by Ferret are assigned appropriately 
using the appropriate ferret_paths script, and that the command `which ferret` 
returns the path to the version of Ferret that you wish to test.

Change to the `bench` subdirectory of the Ferret source directory, and run 
`make check` or `make check_noremote` (to skip tests using data from remote sites).
These tests will generate image files as well as `all_..._log` (normal output), 
`all_..._err` (error output), and `all_..._ncdump` (human-readable versions of 
the created NetCDF files) output files.
These files are then compared to similar files under the `test_results` 
subdirectory to create differences files.

Any actual differences in the GIF images are show in bright red (overlaid on 
a faded original image) in any *_diff.png images created.
There usually are difference image files, but rarely do they show any actual
differences (so just the faded original image with no bright red).
Differences in the log, err, and ncdump output files are shown in the *.diff 
files, which might be empty, or might show negligable numerical differences and 
insignificant differences in system syntax.

FERRET benchmarks README file

Running the benchmarks and interpreting results.

After building Ferret, make a few simple tests for command-line reading,
script reading, file reading, for example

   > ferretdods_gui
   yes? list/L=1:5 L
   yes? go ptest

   yes? use coads_climatology
   yes? show data

When Ferret is running, the benchmark tests will verify its performance. To run the benchmarks, 
in the /bench directory we will run the script run_all. Look at the start of run_all, and if you 
like, customize the section for machine type. This information is used to make the log file, and
also to look for a machine-specific stream binary file.

Run run_all and answer the questions. When you first run the shell script run_all, you will be 
coached to create a stream binary file for the machine by compiling and running the program 
make_stream_file.F. Do this, and then run run_all again.  The benchmarks may be run with or without 
the shared-object external functions. 
If the benchmark scripts run correctly, the benchmark job will finish with 
Display no longer set, about to run batch gif test
Display still not set, about to run batch ps test
Ended at Wed Nov 1 09:35:09 PST 2006
Checking PLT, GIF and PS files.......
    PLT files look good.....
    GIF files look good.....
    PS files look good......

The output is contained in several files:

  all_01nov06at0959.sol_log
  all_01nov06at0959.sol_err
  all_01nov06at0959.sol_plt

where the name contains the date and time of the benchmark run, and the extension refers to the 
machine type or operating system. In addition a number of plot output files are created and 
compared to reference output by the benchmark script.

In the benchmark directory are "official" output files from a number of operating systems.  To 
compare your output logs, choose one to compare with your output. There are lines in the benchmark 
output which may differ from one run of the benchmarks to another and which do not indicate problems 
with the benchmark run. We may remove them by running the script "clean_ultra" and piping the output 
to a new file, for the official benchmark log file and the one just created

    > clean_ultra ansley_official.x86_64-linux_log > cleaned_ansley_official.x86_64-linux_log
    > clean_ultra all_01nov06at0959.sol_log > cleaned_all_01nov06at0959.sol_log 

    > xdiff cleaned_ansley_official.x86_64-linux_log cleaned_all_01nov06at0959.sol_log 

Some differences will still always exist: 

1) The date of the Ferret run and the operating system are included in various outputs such 
as the Ferret symbol SESSION_DATE, values of labels which are written to the logs, or file 
attributes which are listed. These differences may be ignored.

2) Values of PPL$XPIXEL and PPL$YPIXEL will differ; these are computed based on the display of the terminal where the benchmark job is run

3) If you are comparing a log from a different operating system, there may be differences in the 
values of data in output. This might show up as missing_value=-9.9999998e+33f vs missing_value=-1.e-34f, or 
listings may differ in the least-significant positions. Most all Ferret results are single-prescision, so 
diffreences of that size are OK. Try to compare with output from a similar machine (32- or 64-bit for
instance).

4) At the end of the log files, there is a collection of outputs from "spawn ncdump file.nc" commands. 
Differences in the form of ncdump output, such as differently-placed commas, may exist especially if you
are comparing logs from different operating systems.

5) Some benchmark scripts involve the output of a spawn command.  The speed with which this output is
written to the log file may vary from run to run or system to system.  Occasional garbled output is the 
result of this effect. 

This is an Eclipse Java project directory, thus the reason for
the .classpath and .project files, and .settings directory.
The Makefile was created to mimic the standard Eclipse build,
thus the reason for the separate src and bin directory trees.

To successfully create threddsBrowser.jar using Makefile, 
the environment variable JAVA_HOME needs to be defined as 
the location of a Java 6 Development Kit.  If not defined, 
the Makefile will attempt to define it if a directory 
matching /usr/local/jdk1.6* is found.

Also, the toolsUI jar file given by TOOLSUI_JAR in 
Makefile needs to be present.  The latest release version 
of the toolsUI jar file can be downloaded from 
    http://www.unidata.ucar.edu/software/netcdf-java/

The resulting threddsBrowser.jar as well as the toolsUI 
jar file need to be put into the $FER_DIR/lib directory.
The toolsUI jar file is accessed using the name toolsUI.jar,
so, if not already given by this name, add a symbolic link 
named toolsUI.jar pointing to the actual toolsUI jar file:
    ln -s <actual_name> toolsUI.jar

## FERRET benchmarks README file

Running the benchmarks and interpreting results. There are two methods 
for running the benchmarks.

The automated testing uses a script to start a new instance of ferret to run 
each test, and does not display any plots. Expected results are given under 
the `bench/test_results` directory.

The manual testing uses a script to run all the tests in a single instance of 
ferret. Plots are displayed as the tests are run. Expected results are given 
by the `bench/ansley_official*` files as well as under the `metafile_masters*` 
subdirectories.

Note that these tests expect the nco utility programs `ncdump` and `ncatted` 
to be found on the system path. If there programs do not exist the tests will 
still run results will differ, particularly all ncdump output will be missing.
The ImageMagick program `compare` is also used to compare plots.

### Automated testing

Build and install ferret, including setting the ferret environment variables 
using the appropriate `ferret_paths` script. You may wish to check that ferret
is running properly, for example:

> $ ferret  
> yes? use coads_climatology  
> yes? shade /l=5 sst  
> yes? quit  

To test, change to the `bench` subdirectory and enter `make run_tests`. 
This will test whichever ferret executable is first found on the system path 
(`which ferret`) and tests the external functions given under the directory 
specified by `$FER_EXTERNAL_FUNCTIONS`. A message is output to the console 
when each test script is run. On completion, plots and output are compared to 
expected results, with messages output to the console, differences in plots 
(using the `compare` program) saved to `*_diff.gif` files, and differences in 
output saved to `*.diff` files.

Ideally there would be no `*_diff.gif` files because all the GIF plots are 
completely identical to the expected results.  However, there are usually some 
of these plots due to inconsequential differences in the binary output. 
These `*_diff.gif` plots should be examined to see if there are any real 
differences in the plots, which are shown in bright solid red against a faded 
image of the original plot.  Also, ideally the `*.diff` files are empty; if 
not, the differences should be examined for anything of real significance.

To remove all the files generated from the testing, enter `make clean` when
in the bench subdirectory.

### Manual/Displayed testing

After building Ferret, make a few simple tests for command-line reading,
script reading, file reading, for example:

> $ ferret  
> yes? list/L=1:5 L  
> yes? go ptest  
>  
> yes? use coads_climatology  
> yes? show data  

When Ferret is running, the benchmark tests will verify its performance. To 
run the benchmarks, in the /bench directory we will run the script `run_all`. 
Look at the start of `run_all`, and if you like, customize the section for 
machine type. This information is used to make the log file, and also to look 
for a machine-specific stream binary file.

Run `run_all` and answer the questions. When you first run the shell script 
`run_all`, you may be coached to create a stream binary file for the machine 
by compiling and running the program `make_stream_file.F`. If so, do this, 
and then run `run_all` again. The benchmarks may be run with or without the 
shared-object external functions. If the benchmark scripts run correctly, 
the benchmark job will finish with:

> Display no longer set, about to run batch gif test  
> Display still not set, about to run batch ps test  
> Ended at (some date)  
> Checking PLT, GIF and PS files.......  
>     PLT files look good.....  
>     GIF files look good.....  
>     PS files look good......  

The output is contained in several files:

> all_01nov16at0959.x86_64-linux_log  
> all_01nov16at0959.x86_64-linux_err  
> all_01nov16at0959.x86_64-linux_plt  

where the name contains the date and time of the benchmark run, and the extension 
refers to the machine type or operating system. In addition a number of plot 
output files are created and compared to reference output by the benchmark script.

In the benchmark directory are "official" output files from supported operating 
systems. To compare your output logs, choose one to compare with your output. 
There are lines in the benchmark output which may differ from one run of the 
benchmarks to another and which do not indicate problems with the benchmark run. 
We may remove them by running the script `clean_ultra` (or `clean_draconian`) 
and piping the output to a new file, for the official benchmark log file and 
the one just created:

> $ clean_ultra ansley_official.x86_64-linux_log \> cleaned_ansley_official.x86_64-linux_log  
> $ clean_ultra all_01nov16at0959.x86_64-linux_log \> cleaned_all_01nov16at0959.x86_64-linux_log  
> $ diff cleaned_ansley_official.x86_64-linux_log cleaned_all_01nov16at0959.x86_64-linux_log  

Some differences will still always exist: 

1. The date of the Ferret run and the operating system are included in various 
outputs such as the Ferret symbol `SESSION_DATE`, values of labels which are 
written to the logs, or file attributes which are listed. These differences 
may be ignored.

2. Values of `PPL$XPIXEL` and `PPL$YPIXEL` will differ; these are computed 
based on the display of the terminal where the benchmark job is run.

3. If you are comparing a log from a different operating system, there 
may be differences in the values of data in output. This might show up as 
`missing_value=-9.9999998e+33f` vs `missing_value=-1.e-34f`, 
or listings may differ in the least-significant positions. Differences of 
that size are okay. 

4. At the end of the log files, there is a collection of outputs from 
`spawn ncdump file.nc` commands.  Differences in the form of ncdump output, 
such as differently-placed commas, may exist especially if you are comparing 
logs from different operating systems.

5. Some benchmark scripts involve the output of a spawn command. The speed with 
which this output is written to the log file may vary from run to run or from 
system to system. Occasional garbled output is the result of this effect. 

README file for the directory build_fonts

Ansley Manke 1/21/2009.

These are the files needed to build the Ferret fonts. 
They were copied from 
/home/porter2/davison/ppld/f1_2/source/fonts

In that directory were subdirectories /vms  and /unix.
These directories are saved under /original, and the 
/unix directory is modified for simplicity and completeness,
renaming the input files to in_fnt01a.chr, ... and changing 
the Makefile so it directly makes the binary font files with
the names that Ferret expects to find.

Also added clean and install targets.

If the environmnent variable PLOTFONTS is defined, then the 
install target installs the files where Ferret will find them.

   make		  Builds and run the program to write the binary font files

   make install	  Copies the files to the directory indicated by PLOTFONTS

   make clean     Removes the executable and the binary font files.

	SUBROUTINE HPABMV
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)hpabmv.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C	CALL HPABMV
C
C	THIS SUBROUTINE DRIVES THE HP7475 AND HP7470 PLOTTERS
C	THE CORRDINATES OF THE NEW POSITION ARE RECEIVED IN A AND B
C
C	D. DENBO   MARCH 1984
C
#ifdef unix
	include 'PLTCOM.DAT'
#else
	include 'pplinc:PLTCOM.DAT'
#endif
	IF(.NOT.PLTFLG)THEN
	CALL ZBUFFT('DF;SP1;',7)
	PLTFLG=.TRUE.
	LPEN=.NOT.PEN
	ENDIF
	IF(PEN.AND..NOT.LPEN)THEN
	CALL ZBUFFT('PD',2)
	ELSE IF(.NOT.PEN.AND.LPEN)THEN
	CALL ZBUFFT('PU',2)
	ELSE 
	CALL ZBUFFT(',',1)
	ENDIF
	DA=A-OLDHPA
	DB=B-OLDHPB
	IF(DA.EQ.0.AND.DB.EQ.0.)RETURN
	CALL HPOUT(INT(A))
	CALL ZBUFFT(',',1)
	CALL HPOUT(INT(B))
	OLDHPA=A
	OLDHPB=B
	RETURN
	END
#ifdef unix
	SUBROUTINE HPOUT(IA)
	character as*5
	DO 10 I=5,1,-1
	IA10=IA/10
	AS(I:I)=char(IA-IA10*10+48)
	IA=IA10
	IF(IA.EQ.0)GOTO 11
10	CONTINUE
	I=1
11	CALL ZBUFFT(AS(I:),6-I)
	RETURN
	END
#else
	SUBROUTINE HPOUT(IA)
	BYTE AS(5)
	DO 10 I=5,1,-1
	IA10=IA/10
	AS(I)=IA-IA10*10+48
	IA=IA10
	IF(IA.EQ.0)GOTO 11
10	CONTINUE
	I=1
11	CALL ZBUFFT(AS(I),6-I)
	RETURN
	END
#endif

      subroutine pplld_pts(npts,pplmem)
C**
C**    @(#)pplld_pts.F	1.2    9/8/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
c
c	icode	0 use both x and y
c		1 use x only
c		2 use y only
c	xt	x data
c	yt	y data
c	npts	number of xt and yt points
c	tstrt	start time, corresponds to a value of xt=1.0
c 	tref	added 11.95, a reference time (~tstart) ferret will set
c	xdt	sample rate in minutes for x
c	pplmem  data buffer for PPLUS data
c
c	tstrt and xdt are used only for TAXIS,ON.
c
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* From pplldx_envelope.  After pplldx_envelope has been called for all
* polygons by polygon_set_up, this routine is called to save the number
* of points in each polygon in the PPLUS dynamic memory.


	include 'PPLDAT.INC'


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

        REAL pplmem(*)
      	INTEGER	npts

	pplmem(ibase) = FLOAT(npts)
        ibase = ibase + 1

	RETURN
	END

	subroutine dbmopen(file,flen,lun)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)dbmsubs.f	1.2    5/26/88
C**
c**
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
* v552 *acm* 3/03 Longer strings: changes for multi-line labels
* V685 *acm* 1/13 Increase number of symbols, # short to 5000,
*                 # long to 500. Move the test for all-symbols-set
*                 outside the loop. (Should do proper error handling...)
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long

	character file*(*)
	integer flen,lun
c
	return
	end
c
	subroutine dbmstore(lun,sym,ilen,value,len,ier)
c
	integer VSHORT,VLONG
	parameter (VSHORT=5000,VLONG=500)
c
	character sym*(*),value*(*)
	integer lun,ilen,len,ier
c
c	have two regions of storage long (2048 characters)
c	and short (132 characters),  this should minimize
c	space requirements on a fortran system
c
	character syml(VLONG)*120,syms(VSHORT)*120
	character vall(VLONG)*2048,vals(VSHORT)*132
	integer lunl(VLONG),luns(VSHORT)
	integer lenl(VLONG),lens(VSHORT)
	logical long
c
	data lunl/VLONG*-1/,luns/VSHORT*-1/
	data mxlong/1/,mxshort/1/
c
c	look for sym in LONG list
c
	ier=0
	do 10 i=1,mxlong
	    if(lunl(i).eq.lun)then
		if(syml(i).eq.sym)then
		    vall(i)=value
		    lenl(i)=len
		    return
		endif
	    endif
10	continue
c
c	look for sym in SHORT list
c
	do 20 i=1,mxshort
	    if(luns(i).eq.lun)then
		if(syms(i).eq.sym)then
		    if(len.le.132)then
			vals(i)=value
			lens(i)=len
			return
		    else
c
c	insert into long list
c
			luns(i)=-1
		    endif
		endif
	    endif
20	continue
c
c	sym not found in any list
c
	if(len.le.132)then
	    do 30 i=1,mxshort+1
		if(luns(i).eq.-1)then
		    luns(i)=lun
		    syms(i)=sym
		    vals(i)=value
		    lens(i)=len
		    mxshort=max0(i,mxshort)
		    if(mxshort.gt.VSHORT)stop 'exceeded symbol storage'
		    return
		endif
30	    continue
            stop 'exceeded symbol storage'
	    return
	else
	    do 40 i=1,mxlong+1
		if(lunl(i).eq.-1)then
		    lunl(i)=lun
		    syml(i)=sym
		    vall(i)=value
		    lenl(i)=len
		    mxlong=max0(i,mxlong)
		    if(mxlong.gt.VLONG)stop 'exceeded symbol storage'
		    return
		endif
40	    continue
            stop 'exceeded symbol storage'
	    return
	endif
	return
c
	entry dbmdelete(lun,sym,ilen,ier)
c
	ier=0
	do 50 i=1,mxlong
	    if(lunl(i).eq.lun)then
		if(syml(i).eq.sym)then
		    lunl(i)=-1
		    return
		endif
	    endif
50	continue
c
	do 60 i=1,mxshort
	    if(luns(i).eq.lun)then
		if(syms(i).eq.sym)then
		    luns(i)=-1
		    return
		endif
	    endif
60	continue
	return
c
	entry dbmfetch(lun,sym,ilen,value,len,ier)
c
	ier=0
	do 70 i=1,mxlong
	    if(lunl(i).eq.lun)then
		if(syml(i).eq.sym)then
		    value=vall(i)
		    len=lenl(i)
		    return
		endif
	    endif
70	continue
c
	do 80 i=1,mxshort
	    if(luns(i).eq.lun)then
		if(syms(i).eq.sym)then
		    value=vals(i)
		    len=lens(i)
		    return
		endif
	    endif
80	continue
	len=0
	ier=1
	return
c
	entry dbmfirstkey(lun,sym,ilen,ier)
c
	ier=0
	do 90 i=1,mxlong
	    if(lunl(i).eq.lun)then
		sym=syml(i)
		ilen=lnblk(sym,120)
		inext=i+1
		long=.true.
		return
	    endif
90	continue
c
	do 100 i=1,mxshort
	    if(luns(i).eq.lun)then
		sym=syms(i)
		ilen=lnblk(sym,120)
		inext=i+1
		long=.false.
		return
	    endif
100	continue
	ier=1
	ilen=0
	return
c
	entry dbmnextkey(lun,sym,ilen,ier)
c
	ier=0
	if(long)then
	    do 110 i=inext,mxlong
		if(lunl(i).eq.lun)then
		    sym=syml(i)
		    ilen=lnblk(sym,120)
		    inext=i+1
		    long=.true.
		    return
		endif
110	    continue
	    long=.false.
	    do 115 i=1,mxshort
		if(luns(i).eq.lun)then
		    sym=syms(i)
		    ilen=lnblk(sym,120)
		    inext=i+1
		    return
		endif
115	    continue
	    ilen=0
	    ier=1
	else
	    do 120 i=inext,mxshort
		if(luns(i).eq.lun)then
		    sym=syms(i)
		    ilen=lnblk(sym,120)
		    inext=i+1
		    return
		endif
120	    continue
	endif
	ilen=0
	ier=1
	return
c
	entry dbmclose(lun)
	return
c
	entry dbmclear(lun)
c
	do 130 i=1,mxlong
	    if(lunl(i).eq.lun)lunl(i)=-1
130	continue
c
	do 140 i=1,mxshort
	    if(luns(i).eq.lun)luns(i)=-1
140	continue
	return
	end

	SUBROUTINE RDHDSV(LN,IRQ,H,IACT,ILOC)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)dsf.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
	dimension H(*)
#ifdef unix
	INCLUDE 'DSFCOM.DAT'
#else
        INCLUDE 'pplinc:DSFCOM.DAT'
#endif
        CALL CHKDSF(LN,0,I)
	IF(INXT(I).LT.0)THEN
	IACT=0
	DLEN(I)=0
	RETURN
	ENDIF
C	READ HEADER
	TEMP=INXT(I)
	READ(LN,REC=INXT(I))(BUF(J,I),J=1,128)
C
C	CHECK WHICH TYPE OF HEADER IT IS
C
	IF(IBUF(4,I).GT.0)THEN
	DLEN(I)=IBUF(4,I)
	ELSE
	DLEN(I)=LBUF(13,I)
	ENDIF
	HLEN(I)=IBUF(3,I)
	IBKWD(I)=IBUF(2,I)
	IFRWD(I)=IBUF(1,I)
	IACT=MIN0(HLEN(I)-16,IRQ)
	INXT(I)=INXT(I)+1
C	MOVE HEADER
	IHD(I)=1
	IMV=MIN0(IACT,112)
	DO 20 J=1,IMV
20	H(J+ILOC-1)=BUF(J+16,I)
C	READ THE REST
	DO 30 J=IMV+1,IACT,128
	IMV2=MIN0(127,IACT-J)
	READ(LN,REC=INXT(I))(H(K+ILOC-1),K=J,J+IMV2)
30	INXT(I)=INXT(I)+1
	INXT(I)=TEMP+(HLEN(I)-1)/128+1
	RETURN
	END

	SUBROUTINE RDDDSV(LN,IRQ,DAT,IACT,ILOC)
	dimension DAT(*)
#ifdef unix
	INCLUDE 'DSFCOM.DAT'
#else
        INCLUDE 'pplinc:DSFCOM.DAT'
#endif
	CALL CHKDSF(LN,0,I)
	IF(DLEN(I).LE.0)THEN
	IACT=0
	RETURN
	ENDIF
C	READ DATA
	IACT=MIN0(IRQ,DLEN(I))
	DLEN(I)=DLEN(I)-IACT
	J=1
	IF(IBP(I).EQ.1)GOTO 10
C	COPY PARTIAL BUFFER
	IMV=MIN0(128,IACT+IBP(I)-1)
	DO 20 J=IBP(I),IMV
20	DAT(J-IBP(I)+ILOC)=BUF(J,I)
	J=IMV-IBP(I)+2
	IBP(I)=IMV+1
	IF(IBP(I).LE.128)GOTO 40
10	KS=((IACT-J+1)/128)*128+J-1
	DO 30 K=J,KS,128
	READ(LN,REC=INXT(I))(DAT(JJ+ILOC-1),JJ=K,K+127)
30	INXT(I)=INXT(I)+1
	IF(KS.EQ.IACT)THEN
	IBP(I)=1
	ELSE
	READ(LN,REC=INXT(I))(BUF(J,I),J=1,128)
	INXT(I)=INXT(I)+1
C	MOVE THE REST
	DO 50 J=KS+1,IACT
50	DAT(J+ILOC-1)=BUF(J-KS,I)
	IBP(I)=IACT-KS+1
	ENDIF
40	RETURN
	END
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
	SUBROUTINE OPNDSF(NME,DIR,LN)
	CHARACTER NME*(*),DIR*(*),FILE*81
#ifdef unix
	INCLUDE 'DSFCOM.DAT'
#else
        INCLUDE 'pplinc:DSFCOM.DAT'
#endif

C	FIX for linux port.  Move initialization into block data
	EXTERNAL DSFCOM_INIT

C	CHECK IF FILE MATCHES
	FILE=NME
	DO 10 I=1,4
	IF(FILE.EQ.NAME(I))GOTO 11
	IF(NAME(I)(1:1).EQ.' ')GOTO 12
10	CONTINUE
C	ALL FULL DELETE A CLOSED FILE
	DO 20 I=1,4
	IF(LUN(I).EQ.0)GOTO 12
20	CONTINUE
	I=4
C	NEW FILE 
12	INXT(I)=1
	NAME(I)=FILE
	IBKWD(I)=0
	IKEY(I)=0
C	OPEN FILE
11	LUN(I)=LN
	IHD(I)=0
	IBP(I)=1
	IF(DIR.EQ.'RD')THEN
	IRW(I)=0
#ifdef unix
	OPEN(LN,FILE=FILE,STATUS='OLD',ACCESS='DIRECT',
     *	FORM='UNFORMATTED',RECL=512,ERR=200)
#else
	OPEN(LN,FILE=FILE,STATUS='OLD',readonly,ACCESS='DIRECT',
     *	FORM='UNFORMATTED',RECL=128,ERR=200)
#endif
	ELSE
	IRW(I)=1
#ifdef unix
	OPEN(LN,FILE=FILE,STATUS='OLD',ACCESS='DIRECT',
     *	FORM='UNFORMATTED',RECL=512,ERR=100)
#else
	OPEN(LN,FILE=FILE,STATUS='OLD',ACCESS='DIRECT',
     *	FORM='UNFORMATTED',RECL=128,ERR=100)
#endif
	ENDIF
	RETURN
C	NEW FILE
#ifdef unix
100	OPEN(LN,FILE=FILE,STATUS='NEW',ACCESS='DIRECT',
     *	FORM='UNFORMATTED',RECL=512,ERR=900)
#else
100	OPEN(LN,FILE=FILE,STATUS='NEW',ACCESS='DIRECT',
     *	FORM='UNFORMATTED',RECL=128,ERR=900)
#endif
	INXT(I)=-1
	IBUF(1,I)=-1
	WRITE(LN,REC=1)(IBUF(J,I),J=1,256)
	RETURN
900	STOP 'FILE OPEN ERROR'
200	continue
#ifndef unix
	CALL ERRSNS(IER)
#endif
	IF(IER.NE.44)THEN
	INXT(I)=-1
	ELSE
C	POSITION FILE AND READ FILE NAME AND POINTER
	OPEN(LN,FILE=FILE,STATUS='OLD')
	DO 300 K=1,IKEY(I)
	READ(LN,999,END=400)
999	FORMAT(A24,6X,I4)
300	CONTINUE
	IKEY(I)=IKEY(I)+1
	READ(LN,999,END=400)FILE,INXT(I)
	CLOSE(LN)
#ifdef unix
	OPEN(LN,FILE=FILE,STATUS='OLD',ACCESS='DIRECT',
     *	FORM='UNFORMATTED',RECL=512,ERR=400)
#else
	OPEN(LN,FILE=FILE,STATUS='OLD',readonly,ACCESS='DIRECT',
     *	FORM='UNFORMATTED',RECL=128,ERR=400)
#endif
	ENDIF
	RETURN
400	INXT(I)=-1
	RETURN
	END
	SUBROUTINE WRDDSF(LN,ILEN,DAT)
	DIMENSION DAT(*)
#ifdef unix
	INCLUDE 'DSFCOM.DAT'
#else
        INCLUDE 'pplinc:DSFCOM.DAT'
#endif
	CALL CHKDSF(LN,1,I)
	IF(IHD(I).NE.1)STOP 'NO HEADER'
	IF(DLEN(I).EQ.0)THEN
	DMIN(I)=1.E35
	DMAX(I)=-DMIN(I)
	DMEAN(I)=0.
	ENDIF
	DO 40 K=1,ILEN
	IF(DAT(K).GE.1.E35)GOTO 40
	IF(DMIN(I).GT.DAT(K))DMIN(I)=DAT(K)
	IF(DMAX(I).LT.DAT(K))DMAX(I)=DAT(K)
	DMEAN(I)=DMEAN(I)+DAT(K)
40	CONTINUE
	DLEN(I)=DLEN(I)+ILEN
	K=1
	IF(IBP(I).NE.1)THEN
C	PARTIAL BUFFER EXISTS
	KS=0
	IF(IBP(I)+ILEN.LE.128)GOTO 50
	K=130-IBP(I)
	DO 10 J=IBP(I),128
10	BUF(J,I)=DAT(J-IBP(I)+1)
	WRITE(LN,REC=INXT(I))(BUF(J,I),J=1,128)
	IBP(I)=1
	INXT(I)=INXT(I)+1
	ENDIF
C	WRITE OUT FULL BUFFERS
	KS=((ILEN-K+1)/128)*128+K-1
	DO 20 J=K,KS,128
	WRITE(LN,REC=INXT(I))(DAT(JJ),JJ=J,J+127)
20	INXT(I)=INXT(I)+1
C	FILL PARTIAL BUFFER
50	KS=KS+1
	IF(KS.GT.ILEN)RETURN
	DO 30 J=KS,ILEN
30	BUF(J-KS+IBP(I),I)=DAT(J)
	IBP(I)=ILEN-KS+IBP(I)+1
	RETURN
	END
	SUBROUTINE RDDDSF(LN,IRQ,DAT,IACT)
	DIMENSION DAT(*)
#ifdef unix
	INCLUDE 'DSFCOM.DAT'
#else
        INCLUDE 'pplinc:DSFCOM.DAT'
#endif
	CALL CHKDSF(LN,0,I)
	IF(DLEN(I).LE.0)THEN
	IACT=0
	RETURN
	ENDIF
C	READ DATA
	IACT=MIN0(IRQ,DLEN(I))
	DLEN(I)=DLEN(I)-IACT
	J=1
	IF(IBP(I).EQ.1)GOTO 10
C COPY PARTIAL BUFFER
	IMV=MIN0(128,IACT+IBP(I)-1)
	DO 20 J=IBP(I),IMV
20	DAT(J-IBP(I)+1)=BUF(J,I)
	J=IMV-IBP(I)+2
	IBP(I)=IMV+1
	IF(IBP(I).LE.128)GOTO 40
10	KS=((IACT-J+1)/128)*128+J-1
	DO 30 K=J,KS,128
	READ(LN,REC=INXT(I))(DAT(JJ),JJ=K,K+127)
30	INXT(I)=INXT(I)+1
	IF(KS.EQ.IACT)THEN
	IBP(I)=1
	ELSE
	READ(LN,REC=INXT(I))(BUF(J,I),J=1,128)
	INXT(I)=INXT(I)+1
C	MOVE THE REST
	DO 50 J=KS+1,IACT
50	DAT(J)=BUF(J-KS,I)
	IBP(I)=IACT-KS+1
	ENDIF
40	RETURN
	END
	SUBROUTINE WRHDSV(LN,ILEN,H,ILOC)
	CHARACTER DTE*10,TME*10,FDTE*24
	dimension H(*)
#ifdef unix
	INCLUDE 'DSFCOM.DAT'
#else
        INCLUDE 'pplinc:DSFCOM.DAT'
#endif
	CALL CHKDSF(LN,1,I)
C	POSITION FILE TO END
11	IF(INXT(I).LT.0)GOTO 20
	READ(LN,REC=INXT(I))(BUF(J,I),J=1,128)
	IBKWD(I)=INXT(I)
	INXT(I)=IBUF(1,I)
	GOTO 11
20	INXT(I)=-INXT(I)
	IHD(I)=1
	HDPT(I)=INXT(I)
C	FIRST BUFFER
	DLEN(I)=0
	HLEN(I)=ILEN+16
	IBUF(2,I)=IBKWD(I)
	IBUF(3,I)=HLEN(I)
#ifdef unix
	CALL FDATE(FDTE)
	DTE=FDTE(5:11)//FDTE(23:24)
	TME=FDTE(12:19)
#else
	call date(dte)
	call time(tme)
#endif
	READ(DTE,999)(IBUF(J,I),J=5,9)
	READ(TME,999)(IBUF(J,I),J=10,14)
999	FORMAT(5A2)
	DO 30 K=1,112
30	BUF(16+K,I)=H(K+ILOC-1)
	WRITE(LN,REC=INXT(I))(BUF(J,I),J=1,128)
	INXT(I)=INXT(I)+1
	DO 40 K=113,ILEN,128
	WRITE(LN,REC=INXT(I))(H(J+ILOC-1),J=K,K+127)
40	INXT(I)=INXT(I)+1
	RETURN
	END
	SUBROUTINE CHKDSF(LN,JRW,I)
#ifdef unix
	INCLUDE 'DSFCOM.DAT'
#else
        INCLUDE 'pplinc:DSFCOM.DAT'
#endif
	DO 10 I=1,4
	IF(LUN(I).EQ.LN)GOTO 11
10	CONTINUE
	GOTO 12
11	IF(JRW.EQ.IRW(I))RETURN
12	STOP 'DSF LN OR R/W'
	END
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
	SUBROUTINE RWDDSF(NME)
	CHARACTER NME*(*)
#ifdef unix
	INCLUDE 'DSFCOM.DAT'
#else
        INCLUDE 'pplinc:DSFCOM.DAT'
#endif
	DO 10 I=1,4
	IF(NME.EQ.NAME(I))GOTO 11
10	CONTINUE
	RETURN
11	INXT(I)=1
	IKEY(I)=0
	RETURN
	END
	SUBROUTINE CLSDSF(LN)
#ifdef unix
	INCLUDE 'DSFCOM.DAT'
#else
        INCLUDE 'pplinc:DSFCOM.DAT'
#endif
	DO 10 I=1,4
	IF(LUN(I).EQ.LN)GOTO 11
10	CONTINUE
	STOP
11	IF(IRW(I).EQ.0)THEN
C	READ STATUS
	INXT(I)=IFRWD(I)
	ELSE
	IF(IBP(I).NE.1)THEN
	WRITE(LN,REC=INXT(I))(IBUF(J,I),J=1,256)
	INXT(I)=INXT(I)+1
	ENDIF
C	READ HEADER AND UPDATE
	INXT(I)=-INXT(I)
	READ(LN,REC=HDPT(I))(IBUF(J,I),J=1,256)
	IBUF(1,I)=INXT(I)
C
C	OUTPUT NEW TYPE OF HEADER 
C
	IF(DLEN(I).GT.32767)THEN
	IBUF(4,I)=-1
	LBUF(13,I)=DLEN(I)
	ELSE
	IBUF(4,I)=DLEN(I)
	ENDIF
C
C
	BUF(17,I)=FLOAT(DLEN(I))
	BUF(18,I)=DMIN(I)
	BUF(19,I)=DMAX(I)
	IF(DLEN(I).EQ.0)THEN
	BUF(20,I)=0.
	ELSE
	BUF(20,I)=DMEAN(I)/BUF(17,I)
	ENDIF
	WRITE(LN,REC=HDPT(I))(IBUF(J,I),J=1,256)
	IF(IBKWD(I).GT.0)THEN
	READ(LN,REC=IBKWD(I))(IBUF(J,I),J=1,256)
	IBUF(1,I)=-IBUF(1,I)
	WRITE(LN,REC=IBKWD(I))(IBUF(J,I),J=1,256)
	ENDIF
	IBKWD(I)=HDPT(I)
	ENDIF
	CLOSE(LN)
	LUN(I)=0
	RETURN
	END
	SUBROUTINE WRHDSF(LN,ILEN,H)
	CHARACTER DTE*10,TME*10,FDTE*24
	DIMENSION H(*)
#ifdef unix
	INCLUDE 'DSFCOM.DAT'
#else
        INCLUDE 'pplinc:DSFCOM.DAT'
#endif
	CALL CHKDSF(LN,1,I)
C	POSITION FILE TO END
11	IF(INXT(I).LT.0)GOTO 20
	READ(LN,REC=INXT(I))(BUF(J,I),J=1,128)
	IBKWD(I)=INXT(I)
	INXT(I)=IBUF(1,I)
	GOTO 11
20	INXT(I)=-INXT(I)
	IHD(I)=1
	HDPT(I)=INXT(I)
C	FIRST BUFFER
	DLEN(I)=0
	HLEN(I)=ILEN+16
	IBUF(2,I)=IBKWD(I)
	IBUF(3,I)=HLEN(I)
#ifdef unix
	CALL FDATE(FDTE)
	DTE=FDTE(5:11)//FDTE(23:24)
	TME=FDTE(12:19)
#else
	call date(dte)
	call time(tme)
#endif
	READ(DTE,999)(IBUF(J,I),J=5,9)
	READ(TME,999)(IBUF(J,I),J=10,14)
999	FORMAT(5A2)
	DO 30 K=1,112
30	BUF(16+K,I)=H(K)
	WRITE(LN,REC=INXT(I))(BUF(J,I),J=1,128)
	INXT(I)=INXT(I)+1
	DO 40 K=113,ILEN,128
	WRITE(LN,REC=INXT(I))(H(J),J=K,K+127)
40	INXT(I)=INXT(I)+1
	RETURN
	END
	SUBROUTINE WRDDSV(LN,ILEN,DAT,ILOC)
	dimension DAT(*)
#ifdef unix
	INCLUDE 'DSFCOM.DAT'
#else
        INCLUDE 'pplinc:DSFCOM.DAT'
#endif
	CALL CHKDSF(LN,1,I)
	IF(IHD(I).NE.1)STOP 'NO HEADER'
	IF(DLEN(I).EQ.0)THEN
	DMIN(I)=1.E35
	DMAX(I)=-DMIN(I)
	DMEAN(I)=0.
	ENDIF
	DO 40 K=1,ILEN
	IF(DAT(K+ILOC-1).GE.1.E35)GOTO 40
	IF(DMIN(I).GT.DAT(K+ILOC-1))DMIN(I)=DAT(K+ILOC-1)
	IF(DMAX(I).LT.DAT(K+ILOC-1))DMAX(I)=DAT(K+ILOC-1)
	DMEAN(I)=DMEAN(I)+DAT(K+ILOC-1)
40	CONTINUE
	DLEN(I)=DLEN(I)+ILEN
	K=1
	IF(IBP(I).NE.1)THEN
C	PARTIAL BUFFER EXISTS
	KS=0
	IF(IBP(I)+ILEN.LE.128)GOTO 50
	K=130-IBP(I)
	DO 10 J=IBP(I),128
10	BUF(J,I)=DAT(J-IBP(I)+ILOC)
	WRITE(LN,REC=INXT(I))(BUF(J,I),J=1,128)
	IBP(I)=1
	INXT(I)=INXT(I)+1
	ENDIF
C	WRITE OUT FULL BUFFERS
	KS=((ILEN-K+1)/128)*128+K-1
	DO 20 J=K,KS,128
	WRITE(LN,REC=INXT(I))(DAT(JJ+ILOC-1),JJ=J,J+127)
20	INXT(I)=INXT(I)+1
C	FILL PARTIAL BUFFER
50	KS=KS+1
	IF(KS.GT.ILEN)RETURN
	DO 30 J=KS,ILEN
30	BUF(J-KS+IBP(I),I)=DAT(J+ILOC-1)
	IBP(I)=ILEN-KS+IBP(I)+1
	RETURN
	END
	SUBROUTINE RDHDSF(LN,IRQ,H,IACT)
	DIMENSION H(*)
#ifdef unix
	INCLUDE 'DSFCOM.DAT'
#else
        INCLUDE 'pplinc:DSFCOM.DAT'
#endif
	CALL CHKDSF(LN,0,I)
	IF(INXT(I).LT.0)THEN
	IACT=0
	DLEN(I)=0
	RETURN
	ENDIF
C	READ HEADER
	TEMP=INXT(I)
	READ(LN,REC=INXT(I))(BUF(J,I),J=1,128)
C
C	CHECK FOR DLEN TYPE
C
	IF(IBUF(4,I).GT.0)THEN
	DLEN(I)=IBUF(4,I)
	ELSE
	DLEN(I)=LBUF(13,I)
	ENDIF
	HLEN(I)=IBUF(3,I)
	IBKWD(I)=IBUF(2,I)
	IFRWD(I)=IBUF(1,I)
	IACT=MIN0(HLEN(I)-16,IRQ)
	INXT(I)=INXT(I)+1
C	MOVE HEADER
	IHD(I)=1
	IMV=MIN0(IACT,112)
	DO 20 J=1,IMV
20	H(J)=BUF(J+16,I)
C	READ THE REST
	DO 30 J=IMV+1,IACT,128
	IMV2=MIN0(127,IACT-J)
	READ(LN,REC=INXT(I))(H(K),K=J,J+IMV2)
30	INXT(I)=INXT(I)+1
	INXT(I)=TEMP+(HLEN(I)-1)/128+1
	RETURN
	END

	BLOCK DATA DSFCOM_INIT
#ifdef unix
	INCLUDE 'DSFCOM.DAT'
#else
        INCLUDE 'pplinc:DSFCOM.DAT'
#endif
C	FIX for linux port.  Move initialization into block data
	DATA NAME/4*' '/,INXT/4*0/,LUN/4*0/

	END

	

      SUBROUTINE SYMBOL(X,Y,DEGRES,HEIGHT,NCHAR,STRING)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)symbol.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     CALL SYMBOL(X,Y,DEGRES,HEIGHT,NCHAR,STRING)
C
C     THIS SUBROUTINE DRAWS A STRING OF CHARACTERS.
C
C     THE VARIOUS PARAMETERS AND THEIR DEFINITIONS ARE LISTED
C     BELOW:
C        X,Y    - COORDINATES OF THE LOWER LEFT-HAND CORNER OF
C                 THE FIRST CHARACTER IN USER'S UNITS.
C        DEGRES - ANGLE AT WHICH THE CHARACTERS ARE TO BE DRAWN
C                 IN DEGREES RELATIVE TO THE X-AXIS.
C        HEIGHT - HEIGHT OF THE CHARACTERS IN INCHES (OR MM).
C        NCHAR  - NUMBER OF CHARACTERS TO BE DRAWN.
C        STRING - ARRAY CONTAINING THE DISPLAY CODES OF THE
C                 CHARACTERS TO BE DRAWN.
C
C     THE TABLES THAT ARE USED TO DEFINE THE SYMBOL CHARACTER SET
C     ARE DESCRIBED BELOW:
C        TAB    - THIS TABLE CONSISTS OF A SERIES OF 6-BIT CODES
C                 WHICH CONTAIN THE ACTUAL CHARACTER DEFINITIONS.
C                 WHEN A CODE IS DIVIDED BY 7, THE TRUNCATED QUO-
C                 TIENT IS THE VERTICAL DISPLACEMENT FROM THE
C                 REFERENCE POSITION AND THE REMAINDER IS THE
C                 HORIZONTAL DISPLACEMENT.  A CODE OF 63 INDI-
C                 CATES THAT THE PEN IS TO BE RAISED.
C        PNTTAB - THIS TABLE CONTAINS POINTERS TO THE START OF
C                 EACH OF THE CHARACTER DEFINITIONS AND OTHER
C                 INFORMATION NEEDED TO DRAW THE CHARACTERS.
C                    I = 4 * CHARACTER DISPLAY CODE + 1
C                    PNTTAB(I) = WIDTH OF THE CHARACTER (BITS
C                       1-3)
C                              = VERTICAL REFERENCE TRANSLATION
C                       (BITS 4-6)
C                    PNTTAB(I+1) = NUMBER OF CODES REQUIRED TO
C                       DEFINE THE CHARACTER.
C                    PNTTAB(I+2)+PNTTAB(I+3) = POINTER TO THE
C                       FIRST CHARACTER DEFINITION CODE.
C
C
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
      LOGICAL SYMROT
C
C	RSX-11M
C
C	LOGICAL*1 STRING(120),ASCII(128),NUM(64)
C
C	END RSX-11M
C
C	VAX/VMS
C
	CHARACTER STRING*(*)
	INTEGER*2 ASCII(128),NUM(64)
C
C	END VAX/VMS
C
	INTEGER*2 TAB(2,477),TAB1(528),TAB2(426)
	INTEGER*2 IPNT(64),WDTH(64)

C	LINUX PORT
	integer*4	i4_wdth

C
#ifdef unix
	include 'PLTCOM.DAT'
#else
	include 'pplinc:PLTCOM.DAT'
#endif
	EQUIVALENCE (TAB1(1),TAB(1,1)),(TAB2(1),TAB(1,265))
C
	DATA WDTH/5,9,9,9,9,9,9,9,9,7,9,9,9,9,
     *	9,9,9,9,9,9,9,9,9,9,9,9,9,7,7,9,9,9,9,
     *	9,9,9,9,9,9,9,7,6,6,9,9,9,5,5,6,5,5,9,
     *	9,9,7,9,9,9,9,9,9,9,7,5/
	DATA NUM/11,8,11,8,7,7,6,10,8,8,6,8,3,5,
     *	6,9,7,12,11,12,5,6,5,5,9,6,6,9,6,9,11,4,
     *	10,12,4,16,12,5,2,11,2,4,4,18,5,0,8,5,3,
     *	4,4,22,7,6,12,11,6,6,3,3,6,6,2,14/
	DATA IPNT/1,12,20,31,39,46,53,59,69,77,85,
     *	91,99,102,107,113,122,129,141,152,164,169,
     *	175,180,185,194,200,206,215,221,230,241,245,
     *	255,267,271,287,299,304,306,317,319,323,327,
     *	345,0,350,358,363,366,370,374,396,403,409,421,
     *	432,438,444,447,450,456,462,464/
	DATA ASCII/32*46,55,53,61,44,52,62,49,42,43,
     *	40,38,47,39,48,41,28,29,30,31,32,33,34,35,
     *	36,37,1,64,59,45,60,56,46,2,3,4,5,6,7,8,9,10,
     *	11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,
     *	26,27,50,63,51,57,54,58,2,3,4,5,6,7,8,9,10,11,
     *	12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,
     *	27,6*46/
     	 DATA TAB1/0,13,1,14,2,13,1,12,0,13,10,0,0,17,1,18,2,17,1,16,
     *	0,17,0,0,0,5,3,8,6,5,6,0,10,0,0,3,6,3,5,4,6,3,6,1,5,0,0,0,0,8,
     * 5,8,6,7,6,5,5,4,0,4,6,2,4,0,2,0,0,2,0,6,2,8,4,8,6,6,4,8,0,8,
     *	0,0,4,0,6,2,6,6,4,8,0,4,4,4,10,0,6,8,0,8,0,0,6,0,0,4,4,4,
     *	10,0,6,8,0,8,0,0,3,3,6,3,6,2,4,0,2,0,0,2,0,6,2,8,4,8,6,6,
     *	0,0,0,8,10,0,0,4,6,4,10,0,6,8,6,0,0,0,4,0,10,0,2,0,2,8,10,0,
     *	0,8,4,8,0,3,0,2,2,0,4,0,6,2,6,8,0,8,0,0,10,0,0,2,6,8,10,0,
     *	2,4,6,0,0,8,0,0,6,0,0,0,0,8,3,2,6,8,6,0,0,0,0,8,1,8,5,0,
     *	6,0,6,8,4,0,6,2,6,6,4,8,2,8,0,6,0,2,2,0,4,0,0,0,0,8,5,8,
     *	6,7,6,5,5,4,0,4,4,0,6,2,6,6,4,8,2,8,0,6,0,2,2,0,4,0,10,0,
     *	4,2,6,0,0,0,0,8,5,8,6,7,6,5,5,4,0,4,10,0,3,4,6,1,6,0,0,1,
     *	1,0,5,0,6,1,6,3,5,4,1,4,0,5,0,7,1,8,5,8,6,7,3,0,3,8,10,0,
     *	0,8,6,8,0,8,0,2,2,0,4,0,6,2,6,8,0,8,0,6,3,0,6,6,6,8,0,8,
     *	0,0,3,3,6,0,6,8,0,8,0,7,6,1,6,0,10,0,0,0,0,1,6,7,6,8,0,8,
     *	3,5,6,8,10,0,3,5,3,0,0,8,6,8,6,7,0,1,0,0,6,0,3,0,4,1,4,7,
     *	3,8,1,8,0,7,0,1,1,0,3,0,0,6,2,8,2,0,10,0,0,0,4,0,0,6,0,7,
     *	1,8,5,8,6,7,6,6,0,1,0,0,6,0,0,1,1,0,5,0,6,1,6,4,5,5,2,5,
     *	10,0,3,5,6,8,0,8,5,0,5,8,0,3,6,3,0,1,1,0,5,0,6,1,6,4,5,5,
     *	1,5,0,4,0,8,6,8,0,3,1,4,5,4,6,3,6,1,5,0,1,0,0,1,0,7,1,8/
	DATA TAB2/
     *	5,8,6,7,0,7,0,8,6,8,2,0,1,4,0,3,0,1,1,0,5,0,6,1,6,3,5,4,
     *	1,4,0,5,0,7,1,8,5,8,6,7,6,5,5,4,0,1,1,0,5,0,6,1,6,7,5,8,
     *	1,8,0,7,0,5,1,4,5,4,6,5,0,4,6,4,10,0,3,7,3,1,0,4,6,4,0,4,
     *	6,4,10,0,3,7,3,1,10,0,1,2,5,6,10,0,1,6,5,2,0,0,4,8,2,0,0,2,
     *	0,6,2,8,0,0,2,2,2,6,0,8,1,2,2,1,4,1,5,2,5,3,4,4,2,4,1,5,
     *	1,6,2,7,4,7,5,6,10,0,4,8,4,0,10,0,2,0,2,8,0,2,6,2,10,0,0,5,
     *	6,5,0,10,1,10,2,11,2,13,1,14,0,13,1,12,2,13,0,13,1,14,
     *	2,13,1,12,0,13,1,9,2,9,1,7,2,0,0,0,0,8,2,8,
     *	0,0,2,0,2,8,0,8,0,6,0,7,1,8,2,8,3,7,3,6,2,5,1,5,0,6,10,0,
     *	0,1,6,7,10,0,6,2,6,1,5,0,4,0,3,1,3,2,4,3,5,3,6,2,1,9,2,9,
     *	1,7,10,0,4,9,5,9,4,7,3,1,0,4,3,7,10,0,0,4,6,4,2,3,3,5,3,8,
     *	1,8,1,5,2,3,10,0,2,2,3,1,2,0,1,1,2,2,1,6,3,8,5,6,3,4,3,3,
     *	10,0,3,2,4,1,3,0,2,1,3,2,0,4,3,7,6,4,10,0,3,7,3,0,3,7,3,0,
     *	3,0,0,3,3,0,6,3,6,1,0,4,6,7,0,7,6,4,0,1,0,0,6,0,10,0,6,1,
     *	0,4,6,7,0,7,6,4,0,1,10,0,0,0,6,0,0,8,4,0,0,17,1,18,2,17,
     *	1,16,0,17,10,0,0,10,1,10,2,11,2,13,1,14,0,13,1,12,2,13/
C
C     DEFINE THE SCALE FACTOR TO BE THE AMOUNT OF MAGNIFICATION
C     REQUIRED TO CONVERT THE CHARACTERS IN THE CHARACTER DEFI-
C     NITION TABLE TO THE SIZE SPECIFIED BY THE USER.
C
      SYMSC = HEIGHT * FACTOR / 8.0
100	SYMROT = .FALSE.
C
C     ROTATE THE CHARACTER STRING.
C
      IF(DEGRES .NE. 0.0)THEN
C
C     SET THE CHARACTER ROTATION FLAG.
C
        SYMROT = .TRUE.
C
C     CONVERT THE ROTATION TO RADIANS.
C
        TEMP = 0.01745329251994 * DEGRES
C
C     COMPUTE THE SINE AND COSINE.
C
        SYMSIN = SIN(TEMP)
        SYMCOS = COS(TEMP)
      ENDIF
C
C     SET VECTORS MODE.
C
      PMODE = VECTOR
C
C     START AT THE LOWER LEFT-HAND CORNER OF THE FIRST CHARACTER.
C
      XTEMP = X * XSCALE
      YTEMP = Y * YSCALE
      PENF = .FALSE.
      CALL XYZPLT
      IF(NCHAR .LE. 0)RETURN
      XORG = XTEMP
      YORG = YTEMP
      XREF = 0.0
C
C     DRAW THE CHARACTERS IN THE STRING ONE BY ONE.
C
      DO 20 I=1,NCHAR
C
C     COMPUTE THE POINTER TABLE INDEX.
C
C
C     GET CONTROL INFORMATION FROM THE POINTER TABLE.
C
C
C	RSX-11M
C
C	ICH=ASCII(STRING(I))
C
C	END RSX-11M
C
C	VAX/VMS
C
	ICH=ASCII(ICHAR(STRING(I:I)))
C
C	END VAX/VMS
C
	IPOINT=IPNT(ICH)-1

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*ORIG	WIDTH=FLOAT(WDTH(ICH)) -- LINUX PORT...
	i4_wdth = wdth(ich)
	WIDTH=FLOAT(i4_wdth)

	NUMCRD=NUM(ICH)
      IF(NUMCRD .NE. 0)THEN
        PENF = .FALSE.
C
C     DRAW THE CHARACTER.
C
        DO 10 J=1,NUMCRD
C
C     GET A CHARACTER DEFINITION CODE FROM THE TABLE.
C
	ICHX=TAB(1,IPOINT+J)
	ICHY=TAB(2,IPOINT+J)
C
C     CHECK FOR THE CHARACTER THAT INDICATES THE PEN IS TO BE
C     RAISED.
C
        IF(ICHX .EQ. 10)THEN
          PENF = .FALSE.
        ELSE
C
C     CALCULATE THE NEW PEN COORDINATES RELATIVE TO THE LOWER
C     LEFT-HAND CORNER OF THE FIRST CHARACTER.
C
          XSYM = XREF + FLOAT(ICHX)
	IF(ICHY.GE.10)THEN
	YSYM=FLOAT(ICHY-12)
	ELSE
	YSYM=FLOAT(ICHY)
	ENDIF
C
C     SCALE AND ROTATE THE NEW COORDINATES.
C
          IF(SYMROT)THEN
            XTEMP = (XSYM * SYMCOS - YSYM * SYMSIN) * SYMSC + XORG
            YTEMP = (XSYM * SYMSIN + YSYM * SYMCOS) * SYMSC + YORG
          ELSE
            XTEMP = XSYM * SYMSC + XORG
            YTEMP = YSYM * SYMSC + YORG
          ENDIF
C
C     MOVE THE PEN TO THE NEW COORDINATES.
C
          CALL XYZPLT
          PENF = .TRUE.
        ENDIF
   10   CONTINUE
      ENDIF
C
C     ADJUST THE REFERENCE POSITION TO TAKE INTO ACCOUNT THE
C     CHARACTER THAT WAS JUST DRAWN.
C
      XREF = XREF + WIDTH
   20 CONTINUE
C
C     SCALE AND ROTATE THE FINAL COORDINATES.
C
      IF(SYMROT)THEN
        XTEMP = XREF * SYMCOS * SYMSC + XORG
        YTEMP = XREF * SYMSIN * SYMSC + YORG
      ELSE
        XTEMP = XREF * SYMSC + XORG
        YTEMP = YORG
      ENDIF
C
C     PLOT TO THE END OF THE CHARACTER STRING.
C
      PENF = .FALSE.
      CALL XYZPLT
      RETURN
C
	ENTRY SYMBL(X,Y,DEGRES,HEIGHT,NCHAR,STRING)
	SYMSC=HEIGHT*YSCALE/8.0
	GOTO 100
      END

      SUBROUTINE PLTEND
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)pltend.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     CALL PLOTEND
C
C     THIS SUBROUTINE IS USED TO INDICATE THAT A DISPLAY HAS
C     BEEN COMPLETED.  ON THE TEKTERMINAL, EXECUTION IS SUS-
C     PENDED UNTIL THE USER RESPONDS BY ENTERING A CHARACTER
C     FROM THE KEYBOARD.  THEN THE SCREEN IS ERASED AND THE
C     ALPHA CURSOR IS MOVED TO THE UPPER LEFT-HAND CORNER OF
C     THE SCREEN.  ON THE PRINTRONIX PRINTER PLOTTER, THE BUFFER
C     IS DUMPED AND CONTROL IS RETURNED TO THE CALLING PROGRAM.
C     ON THE ZETA AND BENSON PLOT-
C     TERS, IF PLOTTING HAS BEEN DONE SINCE THE LAST CALL TO
C     PLOTEND OR ERASE, THE PEN IS LIFTED AND MOVED TO THE
C     LEFT MARGIN THREE INCHES ABOVE THE TOP OF THE LAST PLOT.
C
C
#ifdef unix
      include 'PLTCOM.DAT'
#else
      include 'pplinc:PLTCOM.DAT'
#endif
C
C     CHECK THE PLOT TYPE.
C
      IF(PTYPE .EQ. 1 .OR. IABS(PTYPE) .GE. 2)THEN
	IF(PTYPE.GE.3)CALL PPLGFLUSH
C
C     PAUSE UNTIL THE USER RESPONDS.
C
        CALL PAGE
        CALL CHOUT(BEL,1)
        CALL CHOUT(BEL,1)
	CALL CHDMP
        CALL CHIN(IN,1,0)
      ENDIF
C
C     TERMINATE THE PLOT.
C
      CALL ERASE
      RETURN
C
      END

      SUBROUTINE REDSF(X,NXS,NYS,NSIZE,IBASE,FILE) 
	DIMENSION X(NSIZE)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)redsf.F	1.3    9/8/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long
* V695  *acm*  9/15 Changes for hour:min labeling on time axes

	INCLUDE 'PARAMPL5.DAT'
	INCLUDE 'LINES.INC'
	INCLUDE 'HD.INC'
	INCLUDE 'PPL.INC'
	INCLUDE 'DATA.INC'
	INCLUDE 'CMRD.INC'
	INCLUDE 'CMRDL.INC'
	INCLUDE 'LABELS.INC'
	INCLUDE 'LABCOM.INC'
	INCLUDE 'AXISL.INC'
	INCLUDE 'TAXIS.INC'
	INCLUDE 'SWITCH.INC'

	REAL*8	DIFF
	character sym*120,str*120,file*(*)
C     NREC=NUMBER OF RECORDS TO BE READ 
C     NGRP=NUMBER OF GROUPS TO BE READ PER RECORD 
C     NVAR=NUMBER OF VARIABLE PER GROUP 
	IX=IBASE-1
	IY=NSIZE/2+IX
C	SAVE THE REQUESTED NUMBER OF POINTS
	NXT=NX
	LEN=0
	CALL OPNDSF(FILE,'RD',LUNN)
	IF(IFORM(1:3).EQ.'PPL')THEN
c
c	read format pplus dsf data file
c
	    call rdhdsf(lunn,367,ppts,j)
	    if(j.eq.0)goto 12
c
c	set hd values
c
	    nx=pnx
	    ny=pny
	    jtype=ptype
	    xmin=pxmin
	    ymin=pymin
	    xmax=pxmax
	    ymax=pymax
	    zmin=pzmin
	    zmax=pzmax
c
c	transfer plot labels
c
	    write(str,998)pxlab
998	    format(20a4)
	    write(sym,997)'XLAB'
997	    format('*PPL$P_',a)
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
	    if(igtlab.eq.1)xlab=str
c
	    write(str,998)pylab
	    write(sym,997)'YLAB'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
	    if(igtlab.eq.1)ylab=str
c
	    write(str,996)pmlab
996	    format(30a4)
	    write(sym,997)'LAB'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
	    if(igtlab.eq.1)lab1=str
c
c	plot file information
c
	    write(str,995)pdate
995	    format(4a4)
	    write(sym,997)'PDATE'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	    write(str,995)ptime
	    write(sym,997)'PTIME'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	    write(str,994)pident
994	    format(8a4)
	    write(sym,997)'PIDENT'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	    write(str,994)psrc
	    write(sym,997)'PSOURCE'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
c	variable informationc
c
	    write(str,994)varnme
	    write(sym,997)'VARNAME'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	    write(str,995)vmean
	    write(sym,997)'VMEAN'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	    write(str,995)vvar
	    write(sym,997)'VVAR'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	    write(str,995)vstd
	    write(sym,997)'VSTD'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	    write(str,995)vrms
	    write(sym,997)'VRMS'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	    write(str,995)vmin
	    write(sym,997)'VMIN'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	    write(str,995)vmax
	    write(sym,997)'VMAX'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	    write(str,995)vdate
	    write(sym,997)'VDATE'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	    write(str,995)vtime
	    write(sym,997)'VTIME'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	    write(str,995)vjdate
	    write(sym,997)'VJDATE'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	    write(str,994)vident
	    write(sym,997)'VIDENT'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	    write(str,995)vlat
	    write(sym,997)'VLAT'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	    write(str,995)vlong
	    write(sym,997)'VLONG'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
c	grid information
c
	    write(str,993)gtype
993	    format(2a4)
	    write(sym,997)'GTYPE'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	    write(str,993)gornt
	    write(sym,997)'GORIENT'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	    write(str,994)grid
	    write(sym,997)'GRID'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
c	misc comments and user fields
c
	    write(str,996)cmnta
	    write(sym,997)'COMMENT_A'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	    write(str,996)cmntb
	    write(sym,997)'COMMENT_B'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	    write(str,996)cmntc
	    write(sym,997)'COMMENT_C'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	    write(str,996)cmntd
	    write(sym,997)'COMMENT_D'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	    write(str,996)cmnte
	    write(sym,997)'COMMENT_E'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	    write(str,994)usera
	    write(sym,997)'USER_A'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	    write(str,994)userb
	    write(sym,997)'USER_B'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	    write(str,994)userc
	    write(sym,997)'USER_C'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	    write(str,994)userd
	    write(sym,997)'USER_D'
	    len=lnblk(str,120)
	    call putsym(sym,str,len,ier)
c
	ELSE IF(IFORM(1:3).EQ.'DSF')THEN
	    CALL RDHDSF(LUNN,IDSFRM,XPTS,J)
	    IF(J.EQ.0)GOTO 12
	    WRITE(LAB1,'(16A2)')(JLAB(I),I=1,16)
	    LAB1(NCH+1:)=' '
	    WRITE(XLAB,'(16A2)')(IXLB(I),I=1,16)
	    XLAB(NCHX+1:)=' '
	    WRITE(YLAB,'(16A2)')(IYLB(I),I=1,16)
	    YLAB(NCHY+1:)=' '
	ELSE
	    CALL RDHDSF(LUNN,20,P,J)
	    IF(J.EQ.0)GOTO 12
	    XPTS=P(1)
	    ZMIN=P(2)
	    ZMAX=P(3)
	    ZMEAN=P(4)
	    JTYPE=1
	    NX=IFIX(XPTS)
	    NY=1
	    XMIN=1
	    XMAX=NX
	    YMIN=ZMIN
	    YMAX=ZMAX
C
C	    GET DSF LABELS
C
	    IF(IGTLAB.EQ.1)CALL DSFLAB
	    IF(ITFLG.EQ.1)THEN
		CALL DSFLIM
		CALL MTMDY(P(11),IM,ID,IYR)
		WRITE(ICOM,999)IYR,IM,ID,IFIX(P(13))
999		FORMAT(3I2.2,I4.4)
		OFF=DIFF(ITSTRT,ICOM)/DT+1.
		P(14)=P(14)/DT
	    ELSE
		P(14)=1.0
		OFF=1.0
	    ENDIF
	ENDIF
        if(jtype.eq.2 .or. jtype.eq.-2)then
           if(svectr)then
              jtype=-2
              ivlen=nx*ny+nx+ny
              call rdddsv(lunn,nsize,x,j,ivlen+1)
              iv=ivlen+nx*ny
              call rdddsv(lunn,nsize,x,j,iv+1)
              call rdddsv(lunn,nsize,x,j,iv+nx+1)
           else
              call rdddsv(lunn,nsize,x,j,1)
              iv=nx*ny
              call rdddsv(lunn,nsize,x,j,iv+1)
              call rdddsv(lunn,nsize,x,j,iv+nx+1)
           endif
        else if(jtype.eq.0 .or. jtype.eq.-1)then
	    IF(SVECTR)THEN
                jtype=-1
		CALL RDDDSV(LUNN,NSIZE,X,J,NX*NY+1)
	    ELSE
		CALL RDDDSV(LUNN,NSIZE,X,J,1)
	    ENDIF
	ELSE
	    IF(IFORM(1:4).EQ.'BIBO')THEN
		CALL RDDDSV(LUNN,NXT,X,J,IY+1)
C		SET NX TO ACTUAL NUMBER OF POINTS READ
		NX=J
		DO 2001 J=1,NX
		X(IX+J)=(FLOAT(J)-1.0)*P(14)+OFF
2001		CONTINUE
	    ELSE
C		SET TO READ BIBO FORMAT
		NX=MIN0(NXT,NX)
		CALL RDDDSV(LUNN,NX,X,J,IX+1)
		ISKP=NX-NXT
		IF(ISKP.GT.0)THEN
C		    NEED TO SKIP SOME OF THE X VARIABLE USE Y AS DUMMY
		    CALL RDDDSV(LUNN,ISKP,X,J,IY+1)
		ENDIF
		CALL RDDDSV(LUNN,NX,X,J,IY+1)
	    ENDIF
	ENDIF
	LEN=NX*NY
12	CALL CLSDSF(LUNN)
	LLENG(LINEN)=LEN
	RETURN
	END 

 	SUBROUTINE SYMBEL(X,Y,DEGRES,HEIGHT,NCHAR,STRING)
C** 
C**    @(#)symbel.tplate.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C       Mod *JD* 3.19.91 for unix -- use environment variable PLOTFONTS
C       *jd* 7.92 variable IF renamed to KIF for MAC
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*       *jd* 11.94 
*       Modification uses TM_NUMBER to determine if "value" is a number rather
*       than the ERR= branch of a READ which fails on AIX/xlf

*	Mod *jd* 11.30.95 to fix ragged symbols to to precision loss
*
*       Mod *kob* 1.28.97 - Reorganization of the original code to remove
*			    an illegal (f90) fortran forward reference into
*			    the middle of a do loop.  This change was 
*		            necessary to get this routine to compile on linux
*			    and also to fix a plotting bug with the new 
*			    solaris version (v4.0) of f77.  This change has 
*			    occurred in the middle of releasing v4.45 of 
*		  	    Ferret to the world.  Aix, Sgi, HP, OSF and SunOs
*			    have already been released, and this change is
*		            not a part of them.  This change is needed
*			    to release linux and more importantly solaris.
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
C *ACM* 6/02   When there is a period or decimal point in the text, make
C              a GKS dot there too, so it'll show up in small labels.
C *acm* 7/02   Take out the MARKER calls that made dots. This caused trouble 
C              when making encapsulated postscript from postscript.  
C *acm* 10/14  Ticket 2203: on the 64-bit machines, the \\ for backspace
C              should be \ .
C
C	CALL SYMBEL(X,Y,DEGRES,HEIGHT,NCHAR,STRING)
C
C	THIS SUBROUTINE DRAWS A STRING OF CHARACTERS.
C
C	THE VARIOUS PARAMETERS AND THEIR DEFINITIONS ARE LISTED
C	BELOW:
C        X,Y    - COORDINATES OF THE LOWER LEFT-HAND CORNER OF
C                 THE FIRST CHARACTER IN USERS UNITS.
C        DEGRES - ANGLE AT WHICH THE CHARACTERS ARE TO BE DRAWN
C                 IN DEGREES RELATIVE TO THE X-AXIS.
C        HEIGHT - HEIGHT OF THE CHARACTERS IN INCHES (OR MM).
C        NCHAR  - NUMBER OF CHARACTERS TO BE DRAWN.
C        STRING - ARRAY CONTAINING THE DISPLAY CODES OF THE
C                 CHARACTERS TO BE DRAWN.
C
	DIMENSION SX(12000),SY(12000),ASCII(127,4),BASE(4),RAST(4)
	INTEGER	  nsxsy
        PARAMETER ( nsxsy = 12000 )
	DIMENSION DTYPE(35),DLEN(35),IOFF(4),IFLEN(4),ITYPE(4)
C
	LOGICAL SYMROT,READIR,DOPLOT,COLRF
c	CHARACTER PLTFIL*80
	CHARACTER ICOM*2,ICHR*1,STRING*(*),DNME(35)*2,DNUM(35)*2
	CHARACTER DNAME(35)*80,KIF(4)*2,IFN(4)*2
	CHARACTER*1 KSUB,KSUPER,KBKSP,KCALL,PENS(16)

        REAL XBASE, YBASE
        INTEGER IPT
#ifdef unix
	INTEGER*2 SX,SY

        integer       dirlen
        character*255 fontdir
#else
	byte sx,sy
#endif
	INTEGER*2 ICNT,IBASE,IRAST
*added for linux port
	INTEGER*4 IBASE4,IRAST4
	INTEGER*2 ASCII
	INTEGER*2 DTYPE,DLEN,IOFF,IFLEN,ITYPE
	INTEGER COLOLD
	LOGICAL ASCFNT
	CHARACTER*265 err_msg
	INTEGER status

C
C
	INCLUDE 'PLTCOM.DAT'
        INCLUDE 'errmsg.parm'

C
	DATA DNUM,DNME/35*'@@',35*'@@'/
#ifdef unix
	DATA KSUB,KSUPER,KBKSP,KCALL/'_','^','\\','@'/
#else
	DATA KSUB,KSUPER,KBKSP,KCALL/'_','^','\','@'/
#endif
	DATA KIF,IFN/'SR','SG','@@','@@','01','12','@@','@@'/
	DATA PENS/'1','2','3','4','5','6','7','8','9','A',
     *	'B','C','D','E','F','G'/
	DATA READIR/.FALSE./

        LOGICAL TM_NUMBER                ! ** TMAP mod 11/94 **

* Mod to specify external references for SCALE and RANGE * Linux *kob* 1.97
        external scale, size

* Initialize 

        ICHR = ' '

C
C	DEFINE THE SCALE FACTOR TO BE THE AMOUNT OF MAGNIFICATION
C	REQUIRED TO CONVERT THE CHARACTERS IN THE CHARACTER DEFI-
C	NITION TABLE TO THE SIZE SPECIFIED BY THE USER.
C
        CALL INQSCL(XSCL,YSCL,ABIAS,BBIAS,XLO,YLO) ! Bug fix? 11.95
        CALL SCALE(XSCL,YSCL,ABIAS,BBIAS,0.,0.)

	COLRF=.FALSE.
C	IF(.NOT.READIR)GOTO 2020

* kob 1/97 - old 2020 code region now contained w/in if-then below.
	IF(.NOT.READIR) THEN
#ifdef unix
C *JD* Mod below fix for unix  -- use environment variable 3.19.91	
	   call getenv ('PLOTFONTS',fontdir)
       	   dirlen = lnblk (fontdir,255)

C *kob* 1/02 - cygwin 1.3.x requires "\" for unix directory accesses
#ifdef __CYGWIN__
	   OPEN(LUSY,FILE=fontdir(:dirlen)//'\fondat.dat',
     *	        STATUS='OLD')
#else
	   OPEN(LUSY,FILE=fontdir(:dirlen)//'/fondat.dat',
     *	        STATUS='OLD',ERR=5000)
#endif

#else
	   open(lusy,file='plotfonts:fondat.dat',readonly,
     *	       status='old',err=5000)
#endif
C
C	FILE EXISTS
C
	   READ(LUSY,983,END=1009)(DNUM(IJ),DNME(IJ),DTYPE(IJ),
     *	   DLEN(IJ),DNAME(IJ),IJ=1,35)
#ifdef unix
C Mod here from A to A9 for read of DNAME *JD* 3.8.91
C983	   FORMAT(1X,2A2,I2,I5,A)
983	   FORMAT(1X,2A2,I2,I5,A9)
#else
983	   format(1x,2a2,i2,i5,a30)
#endif
1009	   NFNT=IJ-1
    	   CLOSE(LUSY)
C
C	READ DEFAULT FONT
C
	   IOFF(1)=0
	   II=1
	   ID=1
	   READIR = .TRUE.			
	   call SETFONT(fontdir,dirlen,dname,ifont,ii,kif,dnme,
     .               ifn,dnum,itype,dtype,iflen, dlen,ioff,
     .               icnt,ascii,base,rast,iadd,
     .		     sx,sy,id)
	ENDIF

2000	SYMSC = HEIGHT * FACTOR / 21.0
C
C	ROTATE THE CHARACTER STRING.
C
	IF(DEGRES .NE. 0.0)GO TO 10
C
C	RESET THE CHARACTER ROTATION FLAG.
C
	SYMROT = .FALSE.
	GO TO 20
C
C	SET THE CHARACTER ROTATION FLAG.
C
10	SYMROT = .TRUE.
C
C	CONVERT THE ROTATION TO RADIANS.
C
	TEMP = 0.01745329251994 * DEGRES
C
C	COMPUTE THE SINE AND COSINE.
C
	SYMSIN = SIN(TEMP)
	SYMCOS = COS(TEMP)
C
C	SET VECTORS MODE.
C
20	PMODE = VECTOR
C
C	START AT THE LOWER LEFT-HAND CORNER OF THE FIRST CHARACTER.
C
	IF(NCHAR .EQ. 0) GOTO 300 	! Mod 11.30, was RETURN
	XTEMP = (X - XLO) * XSCALE	! was X * XSCALE
	YTEMP = (Y - YLO) * YSCALE	! was Y * YSCALE
	PENF = .FALSE.
	DOPLOT=NCHAR.GT.0
	IF(DOPLOT)CALL XYZPLT
C
C	INITIALIZE CONTROL VARIABLES.
C
	XORG = XTEMP
	YORG = YTEMP
	XREF = 0.0
	YREF = 0.0
	CHARSC = 1.0
	WIDTH = 0.0
	SLANT = 0.0
	IFONT = 1
	ASCFNT=ITYPE(1).EQ.-1
	SYMWID=0.0
	NCH=IABS(NCHAR)
C
C	DRAW THE CHARACTERS IN THE STRING ONE BY ONE.
C
	JJ=0
	DO 170 I=1,NCH
	JJ=JJ+1
	IF(JJ.GT.NCH)GOTO 180
	ICHR = STRING(JJ:JJ)
C
C	CHECK FOR A CONTROL CHARACTER.
C
	IF(ICHAR(ICHR) .EQ.27)THEN
	    ASCFNT=.FALSE.
	    GOTO 170
	ENDIF
	IF(ICHAR(ICHR) .EQ. 0)GOTO 180
#ifdef unix
	IF(.NOT.ASCFNT.AND.(ICHR.EQ.'@'.OR.
     *		(ICHR.GE.'\\'.AND.ICHR.LE.'_')))GOTO 80
#else
	IF(.NOT.ASCFNT.AND.(ICHR.EQ.'@'.OR.
     *		(ICHR.GE.'\'.AND.ICHR.LE.'_')))GOTO 80
#endif

* Some compliers store '\\' as a single character, others see it
* as '\'.  

	IF (KBKSP.NE.'\\') THEN
	   IF(.NOT.ASCFNT.AND.(ICHR.EQ.'@'.OR.
     *		(ICHR.GE.'\'.AND.ICHR.LE.'_')))GOTO 80
	ENDIF 
C
C	CALCULATE POINTER
C
	IF(ITYPE(IFONT).LE.0)THEN
C	    CHARACTER FONT
	    ICODE = ASCII(ICHAR(ICHR),IFONT)
	ELSE
C	    SYMBOL FONT
	    ICOM = STRING(JJ:JJ+1)
	    JJ=JJ+1
	    READ(ICOM,999,IOSTAT=ISTAT)II
999	    FORMAT(I2)
	    IF(ISTAT.EQ.0)THEN
	    	ICODE = ASCII(II,IFONT)
	    ELSE
	        ICODE = 1
	    ENDIF
	ENDIF
	IPOINT = ICODE+IOFF(IFONT)
	IPT = 0

	XMN=SX(IPOINT)
	XMX=SY(IPOINT)
	IF(XMN.GT.50.)XMN=XMN-100.
	IF(XMX.GT.50.)XMX=XMX-100.
	WIDTH=(XMX-XMN)*CHARSC*RAST(IFONT)
	SYMWID=SYMWID+WIDTH
	IF(.NOT.DOPLOT)GOTO 70
	IPOINT=IPOINT+1
	IF (IPOINT .GT. NSXSY) GOTO 70
	PENF = .FALSE.
C
C	DRAW THE CHARACTER
C
 30	CONTINUE
	IX=SX(IPOINT)
	IY=SY(IPOINT)
	IF(IX.GT.50)IX=IX-100
	IF(IY.GT.50)IY=IY-100
	IY=-IY
	IPOINT=IPOINT+1
	IF (IPOINT .GT. NSXSY) GOTO 70
        IPT = IPT + 1
C
C	CHECK FOR A CONTROL BYTE.
C
	IF(IX .EQ. 50)GO TO 60
C
C	CALCULATE THE NEW PEN COORDINATES RELATIVE TO THE LOWER
C	LEFT-HAND CORNER OF THE FIRST CHARACTER.
C
	XY=FLOAT(IY)-BASE(IFONT)
	XX=FLOAT(IX)-XMN+XY*SLANT
	XSYM =XREF+XX*CHARSC*RAST(IFONT)
	YSYM =YREF+XY*CHARSC*RAST(IFONT)
C
C	SCALE AND ROTATE THE NEW COORDINATES.
C
	IF(SYMROT)GO TO 40

	XTEMP = XSYM * SYMSC + XORG
	YTEMP = YSYM * SYMSC + YORG
	GO TO 50
40	XTEMP = (XSYM * SYMCOS - YSYM * SYMSIN) * SYMSC + XORG
	YTEMP = (XSYM * SYMSIN + YSYM * SYMCOS) * SYMSC + YORG
50	CONTINUE

* for decimal points, find the average x and Y location; will
* plot a point at this location.
C  xxx  
C  xxx  Dont do this: it causes trouble with encapsulated postscript.
C  xxx  and anyway, it was to correct trouble with the postscript translation
C  xxx  for one printer...
C  xxx
C  xxx        IF (ICHR .EQ. '.') THEN
C  xxx           IF (IPT .EQ. 1) THEN
C  xxx             XBASE = 0.
C  xxx             YBASE = 0.
C  xxx           ENDIF
C  xxx           XBASE = XBASE + XTEMP
C  xxx           YBASE = YBASE + YTEMP
C  xxx        ENDIF

C
C	MOVE THE PEN TO THE NEW COORDINATES.
C

        CALL XYZPLT

	PENF = .TRUE.
	GO TO 30
C
C	CHECK FOR THE END OF THE CHARACTER.
C
60	IF(IY .EQ. -50)GO TO 70
	PENF = .FALSE.
	GO TO 30

70	CONTINUE

C  End of character
C xxx If it was a decimal point, draw a tiny dot at its center.  
C  xxx
C  xxx        IF (ICHR .EQ. '.' .AND. IPT .GT. 1) THEN
C  xxx           XBASE = XBASE/ FLOAT(IPT-1)
C  xxx           YBASE = YBASE/ FLOAT(IPT-1)
C  xxx           XBASE = XBASE/ XSCALE
C  xxx           YBASE = YBASE/ YSCALE
C  xxx           call marker (1)              ! could call with 7 for bigger dot.
C  xxx           CALL PLOT(XBASE, YBASE, 0, 0)
C  xxx           CALL MARK(99)
C  xxx           call marker (1)
C  xxx        ENDIF
C
C	ADJUST THE REFERENCE POSITION TO TAKE INTO ACCOUNT THE
C	CHARACTER THAT WAS JUST DRAWN.
C

        XREF = XREF + WIDTH
	IF(CHARSC .EQ. 1.0)GO TO 169
C	XREF = XREF - 16.*(1.-CHARSC)*RAST(IFONT)
	YREF = 0.0
	CHARSC = 1.0
	GO TO 169
C
C	PROCESS CONTROL CHARACTERS.
C
80	IF(ICHR .NE. KSUB)GO TO 150
	CHARSC = 0.75
C	XREF = XREF + 16.*(1.-CHARSC)*RAST(IFONT)
	YREF=-11.*CHARSC*RAST(IFONT)
	GO TO 169
150	IF(ICHR .NE. KSUPER)GO TO 160
	CHARSC = 0.75
C	XREF = XREF + 16.*(1.-CHARSC)*RAST(IFONT)
	YREF=21.-11.*CHARSC*RAST(IFONT)
	GO TO 169
160	IF(ICHR .NE. KBKSP)GO TO 310
	SYMWID=SYMWID-WIDTH
	XREF = XREF - WIDTH
	WIDTH = 0.0
	GOTO 169
310	IF(ICHR.NE.KCALL)GOTO 169
C
C	UNPACK COMMAND
C
	ICOM = STRING(JJ+1:JJ+2)
	JJ=JJ+2
C
C	PROCESS COMMAND
C
	CALL UPPER(ICOM,2)
	IF(ICOM.EQ.'CL')THEN
C
C	    CLEAR ALL FONTS FROM THE BUFFERS
C
	    DO 1002 II=1,4
	    IOFF(II)=12000
	    IFLEN(II)=0
	    KIF(II)='@@'
	    IFN(II)='@@'
	    ITYPE(II)=0
	    BASE(II)=-9.
1002	    RAST(II)=1.
	    IOFF(1)=0
	    GOTO 169
        ELSE IF(ICOM(1:1).EQ.'C')THEN
C
C           LOOK FOR EXTENDED COLOR COMMAND OF THE FORM
C           @Cnnn WHERE nnn IS A 3 DIGIT NUMBER
C
            IF(.NOT.COLRF)COLOLD=COLOUR
            COLRF=.TRUE.
C
C           SEE IF THE FIRST CHARACTER IS A NUMBER
C
            DO 2050 K=1,9
                IF(ICOM(2:2).EQ.PENS(K))GOTO 2051
2050        CONTINUE
C
C           NO NUMBER FOUND - MUST BE A FONT CHANGE COMMAND
C
            IF(ICOM(2:2).NE.'0')GOTO 2010
2051        JJ=JJ+2
C
C           GET THE 3 DIGIT NUMBER
C
#ifdef AIX_XLF
            IF ( .NOT.TM_NUMBER(STRING(JJ-2:JJ)) ) GOTO 169  
!** TMAP mod 11/94 **
#endif
            READ(STRING(JJ-2:JJ),'(I3)',ERR=169)K
            IF(.NOT.DOPLOT)GOTO 169
            CALL COLOR(K)
	ELSE IF(ICOM(1:1).EQ.'P')THEN
C
C	    CHANGE PEN/COLOR
C
	    IF(.NOT.DOPLOT)GOTO 169
	    IF(.NOT.COLRF)COLOLD=COLOUR
	    COLRF=.TRUE.
	    DO 2030 K=1,16
	    IF(ICOM(2:2).EQ.PENS(K))GOTO 2031
2030	    CONTINUE
	    IF(ICOM(2:2).NE.'0')GOTO 2010
	    K=1
2031	    CALL COLOR(K)
	    GOTO 169
	ELSE IF(ICOM(1:1).EQ.'Z')THEN
	    DO 2040 K=1,16
	    IF(ICOM(2:2).EQ.PENS(K))GOTO 2041
2040	    CONTINUE
	    IF(ICOM(2:2).NE.'0')GOTO 2010
	    K=0
2041	    SLANT=SIN(K*0.08726646)
	    GOTO 169
	ENDIF
C	SEARCH FOR FONT BY NAME THEN BY NUMBER
2010	DO 1003 K=1,4
	IF(ICOM.EQ.KIF(K).OR.ICOM.EQ.IFN(K))GOTO 302
1003	CONTINUE
C	NOT FOUND SEARCH MAIN DIRECTORY
	DO 1004 ID=1,NFNT
	IF(ICOM.EQ.DNME(ID).OR.ICOM.EQ.DNUM(ID))GOTO 1001
1004	CONTINUE
C	FONT NOT FOUND USE LAST FONT
	GOTO 169
1001	ILEN=DLEN(ID)
C
C	FIND WHERE FONT WILL FIT
C
	DO 1005 II=4,1,-1
	IF(ILEN+IOFF(II).LE.12000) THEN
* *kob* 1/97 setfont call takes place of branch to old 1010
	    call SETFONT(fontdir,dirlen,dname,ifont,ii,kif,dnme,
     .               ifn,dnum,itype,dtype,iflen, dlen,ioff,
     .               icnt,ascii,base,rast,iadd,
     .		     sx,sy,id)
	    goto 169
	ENDIF
1005	CONTINUE
C
C	ERROR IF NO ROOM ANYWHERE!
C
	GOTO 169
c1006	IF(.NOT.NEWFIL)THEN
c	    INQUIRE(UNIT=LUHP,NAME=PLTFIL)
c	    CLOSE(LUHP)
c	ENDIF



c	IF(.NOT.NEWFIL)THEN
c	    IF(PTYPE.EQ.0 .OR. PTYPE.EQ.2 .OR. PTYPE.EQ.4)THEN
c		OPEN(LUHP,FILE=PLTFIL,FORM='UNFORMATTED',STATUS='OLD',
c     *		ACCESS='APPEND')
c	    ELSE
c		OPEN(LUHP,FILE=PLTFIL,STATUS='OLD',ACCESS='APPEND')
c	    ENDIF
c	ENDIF
C
C	DONE
C
C	IF(READIR)GOTO 169
C	READIR=.TRUE.
C	GOTO 2000
C
C	READ DIRECTORY
C

302	IFONT=K
169	ASCFNT=ITYPE(IFONT).EQ.-1
170	CONTINUE
180	IF(.NOT.DOPLOT)THEN
	    X=SYMWID*HEIGHT/21.
	    GOTO 300 ! Mod 11.30, was RETURN
	END IF
C
C	SCALE AND ROTATE THE FINAL COORDINATES.
C
	IF(SYMROT)GO TO 190
	XTEMP = XREF * SYMSC + XORG
	YTEMP = YORG
	GO TO 200
190	XTEMP = XREF * SYMCOS * SYMSC + XORG
	YTEMP = XREF * SYMSIN * SYMSC + YORG
C
C	PLOT TO THE END OF THE CHARACTER STRING.
C
200	PENF = .FALSE.
	CALL XYZPLT
C
C	RESET COLOR
C
	IF(COLRF.AND.(COLOLD.NE.COLOUR))CALL COLOR(COLOLD)
300     CALL SCALE(XSCL,YSCL,ABIAS,BBIAS,XLO,YLO) ! bug fix(?) 11.95

	RETURN
C
 5000   IF (dirlen .GT. 1) THEN
	   CALL WARN ('Could not open font file. Check the Ferret environment.')
	   err_msg = fontdir(:dirlen)//'/fondat.dat'
	ELSE
	   CALL WARN ('Fonts directory is undefined. Check the Ferret environment.')
	   err_msg = 'fondat.dat'
	ENDIF

        CALL errmsg (ferr_file_not_found, status, err_msg, *5002)

 5002	STOP

	END
	FUNCTION SYMWID(HEIGHT,NCHAR,STRING)
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
	CHARACTER STRING*(*)
	NC=-IABS(NCHAR)
C
C	THIS FUNCTION RETURNS THE WIDTH OF THE STRING WITHOUT DRAWING IT
C
	SS=0.
	CALL SYMBEL(SS,0.,0.,HEIGHT,NC,STRING)
	SYMWID=SS
	RETURN
	END

        SUBROUTINE flowline (u, v, flag, nxs, nys, px, py, xf, yf)


C**
C**    @(#)flowline.F	    9/19/00
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*  ACM  implementing algorighm from grads -- gxstrm.c
*       draw flowlines 

C  From GrADS code, gxstrm.c
C  and based on vecfld.F

C void gxstrm (float *u, float *v, float *c, int is, int js,
C   float uund, float vund, float cund, int flag, float *shdlvs,
C   int *shdcls, int shdcnt, int den) 


*  v4 2-oct-01 remove VMS includes
*  ACM 12/01  remove ref to jscl; not used.
*  ACM 12/01  remove GET_MEMORY call.  This is now done, with other 
*             PPLUS memory allocation, in disp_set_up.F on the call 
*             from xeq_vector.  Also clean up the declarations.
* ACM  9/9/02 Make px and py declarations px(*); for regular grids these
*             are dummy arrays.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V687 *acm* 3/14 tickets 2151 and 2147: allow missing coordinate data in 3-arg 
*                 and 4-arg plot commands. (not implemented in flowline plots)


	include		'parampl5_dat.decl'
	include		'PARAMPL5.DAT'

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'vector_inc.decl'
	include 'VECTOR.INC'
        INCLUDE 'xcurvilinear.cmn'


*******************************************************************************


C  Calling argument declarations

      REAL xf, yf, px(*),py(*)
      REAL U(NXS,NYS),V(NXS,NYS), FLAG(*)
      INTEGER nxs, nys

C  Local declarations

      INTEGER siz, i, iscl, jscl


C   Size of the flag grid, allocated in disp_set_up.F

      i = MAX(NXS,NYS)
      iscl = 200/i
      iscl = iscl + density - 5
      IF (iscl .LT.  1) iscl = 1
      IF (iscl .GT. 10) iscl =10

      siz = i*i*iscl*iscl + i*iscl   ! see ii1index in flowline_sub

      CALL flowline_sub (u, v, flag, siz, density, nxs, nys, 
     .                   px, py, xf, yf)

      IF (curv_missing) THEN
 5100	 CALL ERRMSG(ferr_not_implemented, status,
     .     'Missing curvilienar coordinate data in VECTOR/FLOW command', 
     .     *5000)
      ENDIF
 5000 RETURN

      END

	DOUBLE PRECISION FUNCTION DIFF(IT1,IT2)
C** 
C**    @(#)diff.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Mod J Davison 11.20.95 for 4 digit year and seconds

	CHARACTER*(*) IT1,IT2
*  *kob*     - Need the below to stop OSF/Linux crashing of v5.4 - w/ pplldx envelopes
*              and c/fortran argument passing, need exact length strings to 
*              pass into whoi2bc
*  *kob* 1/10/02 - for some reason, also need to explicitely only use first 14
*                  chars of IT1, IT2.  This only showed up as a problem with Linux
*                  linked statically, for some odd reason
* V695  *acm*  9/15 Changes for hour:min labeling on time axes

	CHARACTER*14 IT1_14, IT2_14
	INTEGER*4 JDAY
	REAL*8 DATE2, DATE1, WHOI2BC, RDATE
	
	IT1_14 = IT1(:14)
	IT2_14 = IT2(:14)
	RDATE = WHOI2BC(IT2_14) - WHOI2BC(IT1_14)
	DIFF  = RDATE

*       Original code
*	CALL TIME3(IT1,IY1,IM1,ID1,IH1,IMN1,ISC1,ICN1)
*	CALL TIME3(IT2,IY2,IM2,ID2,IH2,IMN2,ISC2,ICN2)
*#ifdef unix
*	DIFF=DOUBLE(JDAY(IY2,IM2,ID2,IH2,IMN2,ISC2,ICN2)-
*     * JDAY(IY1,IM1,ID1,IH1,IMN1,ISC1,ICN1))
*#else
*	DIFF=FLOATJ(JDAY(IY2,IM2,ID2,IH2,IMN2,ISC2,ICN2)-
*     * JDAY(IY1,IM1,ID1,IH1,IMN1,ISC1,ICN1))
*#endif

	RETURN
	END

      SUBROUTINE DAXIS_BOX

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* revised for TMAP
* from PPLUS :
*	Directory PMEL:[PLOT5.PPLV11.PLOT]DAXIS.FOR

* search for "TMAP" to find all revisions
* *sh*  - 1/23/89 added interrupt detection from interrupts in lower routines
*	  	  no explicit declarations - use FORT/WARN=NODECLARATIONS
* *jd*  - 8.18.95 Modification of DAXIS to draw only the plot border -- no
*		  tic marks or labels, for FILL & SHADE
* *jd*  -12.18.96 Add external statement for subroutine SCALE.  Is intrinsic
*                 function in f90 on linux.

#ifdef unix
	include 'parampl5_dat.decl'
	include 'PARAMPL5.DAT'
	include 'axis_inc.decl'
	include 'AXIS.INC'
	include 'labels_inc.decl'
	include 'LABELS.INC'
	include 'labcom_inc.decl'
	include 'LABCOM.INC'
	include 'hab_inc.decl'
	include 'HAB.INC'
	include 'lines_inc.decl'
	include 'LINES.INC'
	include 'pen_inc.decl'
	include 'PEN.INC'
	include 'pltl_inc.decl'
	include 'PLTL.INC'
	include 'mplot_inc.decl'
	include 'MPLOT.INC'
	include 'taxis_inc.decl'
	include 'TAXIS.INC'
	include 'tics_inc.decl'
	include 'TICS.INC'
	include 'tics2_inc.decl'
	include 'TICS2.INC'
	include 'axisl_inc.decl'
	include 'AXISL.INC'
#else
	INCLUDE 'TMAP_PPLV11INC:PARAMPL5_DAT.DECL'
	INCLUDE 'PPLV11INC:PARAMPL5.DAT'
	INCLUDE 'TMAP_PPLV11INC:AXIS_INC.DECL'
	INCLUDE 'PPLV11INC:AXIS.INC'
	INCLUDE 'TMAP_PPLV11INC:LABELS_INC.DECL'
	INCLUDE 'PPLV11INC:LABELS.INC'
	INCLUDE 'TMAP_PPLV11INC:LABCOM_INC.DECL'
	INCLUDE 'PPLV11INC:LABCOM.INC'
	INCLUDE 'TMAP_PPLV11INC:HAB_INC.DECL'
	INCLUDE 'PPLV11INC:HAB.INC'
	INCLUDE 'TMAP_PPLV11INC:LINES_INC.DECL'
	INCLUDE 'PPLV11INC:LINES.INC'
	INCLUDE 'TMAP_PPLV11INC:PEN_INC.DECL'
	INCLUDE 'PPLV11INC:PEN.INC'
	INCLUDE 'TMAP_PPLV11INC:PLTL_INC.DECL'
	INCLUDE 'PPLV11INC:PLTL.INC'
	INCLUDE 'TMAP_PPLV11INC:MPLOT_INC.DECL'
	INCLUDE 'PPLV11INC:MPLOT.INC'
	INCLUDE 'TMAP_PPLV11INC:TAXIS_INC.DECL'
	INCLUDE 'PPLV11INC:TAXIS.INC'
	INCLUDE 'TMAP_PPLV11INC:TICS_INC.DECL'
	INCLUDE 'PPLV11INC:TICS.INC'
	INCLUDE 'TMAP_PPLV11INC:TICS2_INC.DECL'
	INCLUDE 'PPLV11INC:TICS2.INC'
	INCLUDE 'TMAP_PPLV11INC:AXISL_INC.DECL'
	INCLUDE 'PPLV11INC:AXISL.INC'
#endif
	CHARACTER IFX*20,IFY*20

* TMAP interrupt flag
#ifdef unix
	include 'xinterrupt.cmn'
#else
	INCLUDE 'tmap_pplv11inc:tmap_xinterrupt.cmn'
#endif

CCC     For linux install *jd* 12.96
        external scale

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
	
C
C     DRAW AXIS, LEFT, RIGHT Y AXIS THEN TOP, BOTTOM XAXIS
C

	IF(IWIND.GT.0)CALL WINDOW(0.,0.,0.,0.)

*	scale axis
      	call scale(1.,1.,0.,0.,0.,0.)

      IF(MYLEF.EQ.0.AND.IAXON(3).EQ.1)THEN
	call plot (xorg,yorg,0,0)
	call plot (xorg,yorg+ylen,1,0)
      END IF

	IF ( interrupted ) GOTO 3333		! TMAP interrupt
      IF(IAXON(4).EQ.1)THEN
	call plot (xorg+xlen,yorg,0,0)
	call plot (xorg+xlen,yorg+ylen,1,0)
      ENDIF

	IF ( interrupted ) GOTO 3333		! TMAP interrupt
      IF(IAXON(1).EQ.1)THEN
	call plot (xorg,yorg+ylen,0,0)
	call plot (xorg+xlen,yorg+ylen,1,0)
      END IF

	IF ( interrupted ) GOTO 3333		! TMAP interrupt
      IF(MXBOT.EQ.0.AND.IAXON(2).EQ.1)THEN
	call plot (xorg,yorg,0,0)
	call plot (xorg+xlen,yorg,1,0)
      END IF

* TMAP interrupt re-entry
 3333	CONTINUE

	RETURN
	END

      subroutine arfill_section(x, y, z, zlev, nx, ny, nlev, nnx, nny, 
     .       x_extra, y_extra, lmin, lmax, ilo, ihi, jlo, jhi, xadd, 
     .       status)

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*	
*     extracted from arfill.F, fill a section of a modulo (curvilinear) plot.
*
* ACM 4/13/05
* v68  *acm* 4/08 Allow shade, vector plots of degenerate regions - world region 
*              within a grid cell

      REAL z(nx,ny),x(nx),y(ny),zlev(nlev), x_extra, y_extra, 
     .     xadd, lmin, lmax
      INTEGER nx, ny, nlev, nnx, nny, ilo, ihi, jlo, jhi, status

      integer i, j, ii, jj
      real xt(5), yt(5), zt(5)

	include 	'ARFILL.INC'
        include         'GKSCM1.INC'
        include         'gkscm2.cmn'
        include         'miss_inc.decl'
        include         'MISS.INC'
        include         'xcurvilinear.cmn'
        include         'xinterrupt.cmn' ! 1/89 *sh*
        include         'ppl_in_ferret.cmn'
        include         'shade_vars.cmn'
        INCLUDE         'errmsg.parm'


*  check for consistency: data range 1:ny, index range jlo:jhi  
*  If inconsistent, use whole Y range given by ny

      IF (curvilinear) THEN
         IF (jlo .LT. 1 .OR. jhi .GT. nny+1) THEN  
            jlo = 1
            jtop = nny
         ELSE
            jtop = jhi 
            IF (jhi .EQ. nny+1) jtop = nny
         ENDIF
      ELSE
         jlo = 1
         jtop = nny
      ENDIF

*  Likewise for X, if this is not an x modulo plot

      IF (curvilinear .AND. (.NOT. xmodulo) ) THEN
         IF (ilo .LT. 1 .OR. ihi .GT. nnx+1) THEN  
            ilo = 1
            itop = nnx
         ELSE
            itop = ihi 
            IF (ihi .EQ. nnx+1) itop = nnx
         ENDIF
      ELSE
         ilo = 1
         itop = nnx
      ENDIF


C     Divide the region into rectangles or triangles and feed these
C     small elements to drawpoly()

      buffer_empty = .true.
      status = ferr_no_range  ! will be returned if nothing is plotted.

      do 200 j=jlo,jtop-1
         jj = j
         do 100 i=ilo,itop-1
            ii = i

            IF (interrupted) THEN
              status = ferr_interrupt
              RETURN
            ENDIF
     
C     For curvilinear modulo axes:
C     Replicate the first point in a column/row if necessary
            if (i.eq.nnx) ii = 1
            if (j.eq.nny) jj = 1

            zt(1)=z(ii,jj)
            xt(1) = x(i)
            yt(1) = y(j)

            if (sqfflg) then
c     
c     do a square
c     
               zt(2)=z(ii+1,jj)
               if (i.eq.nx) then
                  xt(2)=x_extra
                  zt(2)=z(ilo,jj)
               else
                  xt(2)=x(i+1)
               end if
               yt(2)=yt(1)
              
               zt(3)=z(ii+1,jj+1)
               if (i.eq.nx) then
                  xt(3)=x_extra
                  zt(3)=z(ilo,jj+1)
               else
                  xt(3)=x(i+1)
               end if

               if (j.eq.ny) then
                  yt(3)=y_extra
               else
                  yt(3)=y(j+1)
               endif
               
               zt(4)=z(ii,jj+1)
               xt(4)=xt(1)
               yt(4)=yt(3) 

               call drawpoly(xt,yt,zt,zlev,nlev,4,xadd,lmin,lmax)

            else
c     
c     do upper triangle
c     
              upperflg = .true.

              zt(2)=z(ii+1,jj+1)
              if (i.eq.nx) then
                 xt(2) = x_extra
                 zt(2) = z(ilo,jj+1)
              else
                 xt(2)=x(i+1)
              end if
              if (j.eq.ny) then
                 yt(2)=y_extra
              else
                 yt(2)=y(j+1)
              end if

              zt(3)=z(ii,jj+1)
              xt(3)=xt(1)
              yt(3)=yt(2)
     
              call drawpoly(xt,yt,zt,zlev,nlev,3,xadd,lmin,lmax)
c     
c     do lower triangle
c     
              upperflg = .false.

              zt(3)=z(ii+1,jj)
              xt(3)=xt(2)
              yt(3)=yt(1)
     
           call drawpoly(xt,yt,zt,zlev,nlev,3,xadd,lmin,lmax)

         endif

 100     continue
         if (.not. buffer_empty) call flush_buffered_fillpoly(xadd,
     .                     lmin, lmax)
         status = ferr_ok
 200  continue
      
      return
      end

      SUBROUTINE DATLST(LLUN,X,NSIZE,NXS,NYS) 
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)datlst.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
	DIMENSION X(NSIZE)
#ifdef unix
	INCLUDE 'PARAMPL5.DAT'
	INCLUDE 'LINES.INC'
	INCLUDE 'HD.INC'
	INCLUDE 'CMRD.INC'
#else
	INCLUDE 'pplinc:PARAMPL5.DAT'
	INCLUDE 'pplinc:LINES.INC'
	INCLUDE 'pplinc:HD.INC'
	INCLUDE 'pplinc:CMRD.INC'
#endif
	IY=NSIZE/2
	NXL=1 
	NYL=1 
	IF(M.GE.1.AND.IFLG(1).EQ.1)NXL=IFIX(P(1)) 
	IF(M.GE.3.AND.IFLG(3).EQ.1)NYL=IFIX(P(3)) 
	IF(JTYPE.LE.0.OR.JTYPE.EQ.2)THEN 
	    NXH=NX 
	    NYH=NY 
	    IF(M.GE.2.AND.IFLG(2).EQ.1)NXH=IFIX(P(2)) 
	    IF(M.GE.4.AND.IFLG(4).EQ.1)NYH=IFIX(P(4)) 
	    IF(JTYPE.EQ.-1.OR.JTYPE.EQ.2)THEN
		IF(M.GE.5.AND.IFLG(5).EQ.1.AND.P(5).EQ.2)THEN
		    WRITE(LLUN,9994)'SECOND'
9994		    FORMAT(9X,A6,' COMPONENT')
		    IVLEN=NX*NY
 	ELSE
		    WRITE(LLUN,9994)'FIRST'
		    IVLEN=0
		ENDIF
	    ELSE
		IVLEN=0
	    ENDIF
	    K=(NXH-NXL)/7+1 
	    DO 100 K1=1,K 
	    K8=(K1-1)*7+(NXL-1) 
	    IM=NXH-K8 
	    IF(IM.GT.7)IM=7 
	    WRITE(LLUN,9999)(I+K8,I=1,IM) 
9999	    FORMAT(9X,7I10) 
	    DO 101 J=NYL,NYH 
	    WRITE(LLUN,9998)J,(X(IVLEN+NXS*(J-1)+I+K8),I=1,IM) 
101	    CONTINUE
9998	    FORMAT(6X,I6,1P7E10.2) 
	    WRITE(LLUN,'(/)') 
100	    CONTINUE
	ELSE 
	    IBASE=1 
	    NXH=32000 
	    NYH=LNUM 
	    IF(M.GE.2.AND.IFLG(2).EQ.1)NXH=IFIX(P(2)) 
	    IF(M.GE.4.AND.IFLG(4).EQ.1)NYH=IFIX(P(4)) 
	    DO 300 J=1,NYL-1 
300	    IBASE=IBASE+LLENG(J) 
	    DO 200 J=NYL,NYH 
	    WRITE(LLUN,9997)J,LLENG(J) 
9997	    FORMAT(//9X,'LINE=',I4,'  LENGTH=',I6) 
	    WRITE(LLUN,9996) 
9996	    FORMAT(11X,'I',10X,'X',15X,'Y') 
	    IB=IBASE+LLENG(J)-1 
	    IF(IB.GT.IBASE+NXH-1)IB=IBASE+NXH-1 
	    WRITE(LLUN,9995)(I-IBASE+1,X(I),X(IY+I),I=IBASE+NXL-1,IB) 
9995	    FORMAT(6X,I6,1P2E15.4) 
	    IBASE=IBASE+LLENG(J) 
200	    CONTINUE 
	END IF 
	RETURN
	END 

	SUBROUTINE BOX_CENTERS( x_or_y, val1, n, centers, valid )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* PLOT+ routine for use inside FERRET:
* Supply to PLOT+ the centers of n grid boxes from X or Y axis of the contour
* data currently in PLOT+.  Pointers to the appropriate FERRET axes are in
* COMMON.

* programmer - ACM
* (Adapted from box_bounds)
*
* for FERRET V62.00: 5/2009
* V62  Fixing bug 1659, plotting with subspan modulo axis.

	include 'ferret.parm'
	include 'xbox_bounds.cmn'

* calling argument declarations:
	LOGICAL		valid
	INTEGER		n
	REAL		val1, centers(n)
	CHARACTER	x_or_y*1

* internal variable declarations:
	INTEGER	ISUBSCRIPT, i, idim, isub1, isub0
	DOUBLE PRECISION TM_WORLD

* initialize
	IF ( x_or_y .EQ. 'X' ) THEN
	   idim = bb_xaxis
	ELSEIF ( x_or_y .EQ. 'Y' ) THEN
	   idim = bb_yaxis
	ENDIF

* determine starting subscript
	isub1 = ISUBSCRIPT ( DBLE(val1), bb_grid, idim, round_dn )
	isub0 = isub1 - 1

* pass back box centers
	DO 100 i = 1, n
 100	centers(i) = SNGL( TM_WORLD (isub0+i,bb_grid,idim,box_middle) )

* always (the appearance of) success
	valid = .TRUE.
	RETURN
	END

	SUBROUTINE GET_USER_COORDS (w,v,ndc,uc,xinv,yinv)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Finds user coordinates given world coordinates and ancillary ppl info.
*	J Davison 5.17.90

#ifdef unix
	include		'axis_inc.decl'
	include		'AXIS.INC'
#else
	INCLUDE		'tmap_pplv11inc:tmap_axis.inc'
#endif

	real	 	w(4),v(4),vc(4),ndc(4),wc(4),uc(4)
	real		nax,nay,nbx,nby,wax,way,wbx,wby,uax,uay,ubx,uby
	real		xinv,yinv

********************************************************************************

*	GET VIEWPORT COORDS OF PLOT ACTIVE REGION CORNERS
	nax = (v(2) - v(1)) / (w(2) - w(1))
	nbx = v(1) - w(1)*nax
	nay = (v(4) - v(3)) / (w(4) - w(3))
	nby = v(3) - w(3)*nay
	
	vc(1) = nax* xorg*1000.0  + nbx
	vc(2) = nax*(xorg + xlen)*1000.0 + nbx
	vc(3) = nay* yorg*1000.0  + nby
	vc(4) = nay*(yorg + ylen)*1000.0 + nby

*	FIND APPROPRIATE CORNERS TO CLIP
	ndc(1) = vc(1)	
	ndc(2) = vc(2)
	ndc(3) = vc(3)
	ndc(4) = vc(4)

*	WHAT WORLD COORDINATES ARE THESE?
	wax = (w(2) - w(1)) / (v(2) - v(1))
	wbx = w(1) - v(1)*wax
	way = (w(4) - w(3)) / (v(4) - v(3))
	wby = w(3) - v(3)*way
	
	wc(1) = wax*ndc(1) + wbx
	wc(2) = wax*ndc(2) + wbx
	wc(3) = way*ndc(3) + wby
	wc(4) = way*ndc(4) + wby

*	WHAT ARE THE USER COORDS OF THESE POINTS?
	uax = (xhi - xlo) / (xlen*1000.0)
	ubx = xlo - (xorg*1000.0) * uax
	uay = (yhi - ylo) / (ylen*1000.0)
	uby = ylo - (yorg*1000.0) * uay
	
	uc(1) = uax*wc(1) + ubx
	uc(2) = uax*wc(2) + ubx
	uc(3) = uay*wc(3) + uby
	uc(4) = uay*wc(4) + uby

*	ARE AXES INVERTED?
	if (uc(1) .gt. uc(2)) then
	   xinv = -1.0
	else
	   xinv =  1.0
	endif

	if (uc(3) .gt. uc(4)) then
	   yinv = -1.0
	else
	   yinv =  1.0
	endif

	return
	end

	SUBROUTINE OPEN_GKS_WS

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Routine to open GKS if not open, the workstation.
*	Taken out of SIZE2 and modified for metafile.
*	J Davison JISAO/PMEL/TMAP
*	3.15.89
*	12.20.89 *sh* - added GKS_X_CONID code for FERRET
*       03.25.91 *jd* - mod to separate ws & metafile opening into two
*       subroutines rather than 1 with 2 entry points
*	*jd* 3.10.92 Mod to handle ATC GKS
*	*jd* 8.6.93 Mod to use XGKS
*       *sh* 3.4.97 (& 7/97) Mod to support metafile-only (no X) output
*       through a cuckoo's egg implantation of meta_wsid in place of wsid
*            8-4-97 -- substituted this edited version which didn't get
*            into CVS. This version calls open_gks_ws as long as not in
*            batch mode.
*  v5.4 *acm* 8/2001  add polymarker call for PLOT/SYMBOL=DOT 
*             here  set polymarker area attributes to bundled.
*      *acm* 10/01  remove VMS includes
*  V600 *acm* 9/05 append window_title to window name. If no title
*                   has been defined, set it to the session date:time.
*                   Save window_title in xplot_setup.cmn for use in subsequent 
*                   windows. Also define a symbol WIN_TITLE
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V6.8 *acm* 7/9/2012 For batch graphics on RHEL6, change ITS_BATCH_GRAPHICS
*                     from logical to integer, then batch = ITS_BATCH_GRAPHICS().NE.0


	integer 	ITS_BATCH_GRAPHICS, TM_LENSTR1, 
     .			s1, nlen, asf(13), error, clen
	LOGICAL         batch

        character*88    window_name

	include 'pltcom_dat.decl'! with declarations    
	include 'PLTCOM.DAT'! with declarations    
	include 'gkscm1_inc.decl'! with declarations    
	include 'GKSCM1.INC'! with declarations    
	include 'gkscm2.cmn'! with declarations    
	include 'ppl_in_ferret.cmn'
        include 'ws_types.cmn'
        include 'shade_vars.cmn'
        include 'xtoday.cmn'            ! with today_date and today_time
	include 'tmap_dims.parm'
        include 'xplot_setup.cmn'

#ifdef atc_gks
#   ifdef unix
	include        'gkspar.inc'
#   else
	INCLUDE        'atc_gksdir:gkspar.inc'
#   endif
#else
	character	GKS_X_CONID*16, xwind_id*16
	external	gks_x_conid
#   ifdef unix
  	include        'gkspar.inc'
#   else
  	INCLUDE        'sys$library:gksdefs.bnd'
#   endif
#endif
#ifdef atc_gks	
        character*80     conid_options
        character*80     conid_opt_def/' -nc 64 -ox 2 -u 2'/
#endif

#ifdef sun
        BYTE      NULL
        BYTE      cstring(64) ! c-type Hollerith string buffer
#else
        INTEGER*1 NULL
        INTEGER*1 cstring(64) ! c-type Hollerith string buffer
#endif
	PARAMETER ( NULL =  0)


******************************************************************************** initialize
	batch = ITS_BATCH_GRAPHICS() .NE. 0
	IF (batch) THEN
	   CALL GOPKS(1,-1)  
!	   xwind_id = GKS_X_CONID( wsid )	! obsolete?
	   meta_wsid = wsid  ! cuckoo's egg -- output ws will be metafile
* ... metafile will be opened and activated later
	   GOTO 500
	ENDIF

*	Opens GKS and workstation, and activates it

C   
C       OPEN AND INITIALIZE GKS     
C   
#ifdef atc_gks
	call gopks (6,0)
        conid  = 1

	if (ppl_in_ferret) then
	   conid_opt_def = '-l FERRET 1' // conid_opt_def
	else
	   conid_opt_def = '-l PPLP' // conid_opt_def
	endif

#   ifdef unix
	call getenv ('atcGKSconid',conid_options)
#   else
*	GET LOGICAL WITH TRNLNM
#   endif

	if (wstype/100 .eq. ws_xwindow/100 .and. conid_options .eq. ' ') 
     .		conid_options = conid_opt_def

******************TEST X OPEN*****************
*
*        call openxwin (640,512,ixwin,ierr)
*        if (ierr .ne. 0) stop
*
*        write (unit=conid_options,15) ixwin
* 15     format ('-w',i8,'-sw -dp -cc')
*
****************END TEST 3.20.92**************

	if (conid_options .ne. ' ') then
           call guesc050 (conid,conid_options)
           call guesc005 (conid)
	endif
	call gopwk (wsid,conid,wstype)
#else
#ifndef xgks
	CALL GOPKS(ERRFIL)  
#else
	CALL GOPKS(1,-1)  
#endif
	if (wstype .eq. ws_tek4014 .or. wstype .eq. ws_tek4107) then
*	   open (ws_lun,file=ws_file,status='old')
*	   call gopwk (wsid,ws_lun,wstype)
           CALL GOPWK(WSID, 0, 0)
	elseif ( PPL_in_FERRET .and. (wstype. eq. ws_xwindow
     .				 .or. wstype .eq. 0)) THEN
* ... remote node connection option for FERRET
	   xwind_id = GKS_X_CONID( wsid )
#   ifdef unix
#ifndef xgks
	CALL GOPWK(WSID, 0, 0)
#else
	if (ppl_in_ferret) then

* If the window title has not yet been initialized, do so using the
* date and time of the Ferret session.

           clen = 64
	   CALL TM_FTOC_STRNG( window_title, cstring, clen )
           IF (cstring(1) .EQ. NULL) THEN
              s1 = 1
              IF (today_date(1:1) .EQ. ' ') s1 = 2
              nlen = TM_LENSTR1(today_date)
              window_title = today_date(s1:nlen)//':'//today_time
           ENDIF
           nlen = TM_LENSTR1(window_title)

           IF (nlen .GT. 1 .OR. window_title .NE. '_')
     .       window_name = 'FERRET_1'//'_'//window_title
           ier = 0
           CALL SETSYM ("WIN_TITLE "//window_title(:nlen), nlen+10, ier, status)

	   call gesspn (window_name)
	else
	   call gesspn ('PPLP')
	endif
  	CALL GOPWK(WSID,6,4)       
#endif
#   else
	   CALL GKS$OPEN_WS( wsid, xwind_id, 0 )
#   endif
	else
#ifndef xgks
	   CALL GOPWK(WSID,CONID,WSTYPE)       
#else
	if (ppl_in_ferret) then
	   call gesspn ('FERRET_1',8)
	else
	   call gesspn ('PPLP',4)
	endif
	   CALL GOPWK(WSID,6,4)       
#endif
	endif
#endif
	CALL GACWK(WSID)    
    
*       SET DEFERRAL STATE TO GENERATE OUTPUT AS SOON AS POSSIBLE   
	call gsds (wsid,gasap,gsuppd) 

 500	CONTINUE	! 7/97 -- from here on BATCH mode, too

	GKSOPN=.TRUE.       
	gks_open = .true.  ! another open flag needed, PLTCOM.DAT has problems
	LPEN=.NOT.PEN       

*	SET POLYLINE AND FILL AREA ATTRIBUTES BUNDLED
	call gqasf (error,asf)				  
	if (error .ne. 0) goto 1000			     
								
	asf(1)  = gbundl					 
	asf(2)  = gbundl					 
	asf(3)  = gbundl		

*	SET POLYMARKER AREA ATTRIBUTES BUNDLED *acm* 8/2001
*       (see ws_line_bundld.F and ps_line_bundle.F)

	asf(4)  = gbundl
	asf(5)  = gbundl
	asf(6)  = gbundl
        
	if (area_bundles) then
	   asf(11) = gbundl					 
	   asf(12) = gbundl					 
	   asf(13) = gbundl					 
        else
           asf(11) = gindiv
           asf(12) = gindiv
           asf(13) = gindiv
           call gsfais (gsolid)	
        endif
	call gsasf (asf)
	
*	SET UP DEFAULT LINE BUNDLES FOR WS
	IF ( .NOT.batch ) call setup_line_bundles (wsid,wstype) 
*ATC two lines following -- commented out for now
*	call gscr (wsid,0,1.0,1.0,1.0)
*	call gscr (wsid,1,0.0,0.0,0.0)

	return

*	FATAL ERROR -- NEED GKS ERROR HANDLING IN PPL...
1000	return

	end

      subroutine gkinit
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)gkinit.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
c
c
#ifdef unix
	include 'PLTCOM.DAT'
	include 'GKSCM1.INC'
#else
	include 'pplinc:PLTCOM.DAT'
	include 'pplinc:GKSCM1.INC'
#endif
	logical shrnkx,shrnky,first
c
	if(asize.gt.bsize)then
	    fcty=bsize/asize
	    fctx=1.0
	else
	    fctx=asize/bsize
	    fcty=1.0
	endif
	if(.not.gksopn)then
c
c	open and initialize gks
c
C Mod these three JD 3.7.91	    call gopks(errfil)
C                                   call gopwk(wsid,conid,wstype)
C	                            call gacwk(wsid)

	    call gopks(1)
	    call gopwk(wsid,0,0)
	    call gacwk(wsid)
	    gksopn=.true.
	    lpen=.not.pen
	endif
	call gswn(1,0.0,asize,0.0,bsize)
	call gselnt(1)
	call gsvp(1,0.0,fctx,0.0,fcty)
c
c	set up the size of the display window
c
	call gqwkc(wsid,ier,id,itype)
	call gqdsp(itype,ier,imeter,dmaxx,dmaxy,irx,iry)
c	call gqmds(itype,ier,imeter,dmaxx,dmaxy,irx,iry)

	if(wksaut)then
	    xln=asize*2.54e-5
	    yln=bsize*2.54e-5
	    first=.true.
200	    wkxmn=dmaxx-.0127-xln
	    wkymn=.00635
c
	    shrnkx=.false.
	    shrnky=.false.
	    if(wkxmn.lt.0)then
		wkxmn=0.0
		yln=yln*dmaxx/xln
		xln=dmaxx
		shrnkx=.true.
	    endif
	    if(wkymn+yln.gt.dmaxy)then
		wkymn=0.0
		xln=xln*dmaxy/yln
		yln=dmaxy
		shrnky=.true.
	    endif
	    if(first.and.shrnkx.and.shrnky)then
		first=.false.
		goto 200
	    endif
c
	    wkxmx=wkxmn+xln
	    wkymx=wkymn+yln
c
c	set the ndc window
c
	    call gswkwn(wsid,0.0,fctx,0.0,fcty)
c
c	set device (workstation) viewport
c
	    call gswkvp(wsid,wkxmn,wkxmx,wkymn,wkymx)
	else
c
c	if not auto wkxmn and wkxmx etc are fractions of dmaxx
c	and dmaxy
c
	    call gswkwn(wsid,0.0,fctx,0.0,fcty)
	    xmn=dmaxx*wkxmn
	    xmx=dmaxx*wkxmx
	    ymn=dmaxy*wkymn
	    ymx=dmaxy*wkymx
	    call gswkvp(wsid,xmn,xmx,ymn,ymx)
	endif
c
	return
	end

	BLOCK DATA PPLDAT
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)ppldata.F	1.2    5/31/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C	LIST OF INCLUDES FOR PPLUS
C
C     Mod *JD* 3.5.91 Change output unit for terminal to 6 from 5 --
C     problem with buffered outout in unix -- see opnppl
C     Mod *jd* 1.10.95 To DATA KEYLN1,KEYLN2 (line 201) at *sh* request
C     for compatibility with Ferret use of symbols.
* V510 4/99 *jd* increased initialization sizes for bigger NLINES
* V510 9/99 *sh* increased initialization sizes for bigger NLINES
*      3/00 *sh* reduceded initialization sizes for NLINES variables
* 		(except lleng())
* V610 2/08 *acm*increase default number of contour levels to NLEV=40 (MODE NLEVELS)
* V610 2/08 *acm*keep default number of contour levels to old value of NLEV=10 
*                If this is changed, also change it in fer/dat/xprog_state_data.F
* V62  2/08 *acm*increase default number of contour levels to NLEV=30 (MODE NLEVELS)
*                If this is changed, also change it in fer/dat/xprog_state_data.F
* v691 5/14 *acm* Change name MOD to TEKMOD
* V694  *acm*  1/15 Changes to allow two time axes on plot (F-T)
* v696 *acm*	gap_var to define seperate line segments on PLOT/VS plots
*                  (LAS ticket 1597 and others)
* V697 *acm*   Fix CONSET for setting # of digits on contour plots. When did this ever work?

	INCLUDE 'PARAMPL5.DAT'
	include 'axis_inc.decl'
	INCLUDE 'AXIS.INC'
	INCLUDE 'AXISL.INC'
	INCLUDE 'AXLWID.INC'
	INCLUDE 'CMRD.INC'
	INCLUDE 'CMDCOM.INC'
	INCLUDE 'CMRDL.INC'
	INCLUDE 'COMEPL.INC'
	INCLUDE 'COMEPV.INC'
	INCLUDE 'CONLAB.INC'
	INCLUDE 'cont_inc.decl'
	INCLUDE 'CONT.INC'
	INCLUDE 'DASHZZ.INC'
	INCLUDE 'DATA.INC'
	INCLUDE 'DSFSVE.INC'
	INCLUDE 'EPICLUN.INC'
	INCLUDE 'FILNAM.INC'
	INCLUDE 'GKSCM1.INC'
	INCLUDE 'HAB.INC'
	INCLUDE 'HD.INC'
	INCLUDE 'LABCOM.INC'
	INCLUDE 'LABELS.INC'
	INCLUDE 'LINES.INC'
	INCLUDE 'LUNITS.INC'
	INCLUDE 'MISS.INC'
	INCLUDE 'MPLOT.INC'
	INCLUDE 'MPLOTS.INC'
	INCLUDE 'MPLOTX.INC'
	INCLUDE 'PEN.INC'
	INCLUDE 'PLT.INC'
	INCLUDE 'PLTL.INC'
	INCLUDE 'PPLDAT.INC'
	INCLUDE 'SWITCH.INC'
	INCLUDE 'SYMKEY.INC'
	INCLUDE 'SYSTEM.INC'
	INCLUDE 'TAXIS.INC'
	INCLUDE 'TICS.INC'
	INCLUDE 'TICS2.INC'
	INCLUDE 'XYLABP.INC'
	INCLUDE 'vector_inc.decl'
	INCLUDE 'VECTOR.INC'
	INCLUDE 'VIEW.INC'
	INCLUDE 'ZGRID.INC'
	INCLUDE 'ZGRIDD.INC'
C
	DATA XLO,XHI,XTIC,XLEN,XCSIZE,IAUTOX,ITYPEX/3*0.,8.,.10,1,1/
	DATA NMTCX,LINTX,LABELX,NSIGX,NTICX,XORG/0,2,-1,2,5,1.4/
	DATA YLO,YHI,YTIC,YLEN,YCSIZE,IAUTOY,ITYPEY/3*0.,6.0,.10,1,1/
	DATA NMTCY,LINTY,LABELY,NSIGY,NTICY,YORG/0,2,-1,2,5,1.2/
	DATA IAXON/4*1/
	DATA SHRINKY/.FALSE./
C
	DATA IFRX,IFRY,IT1,IT2,ITSTRT,ITMIN,ITMAX/2*' ',
     *	5*'71010100000019'/ 
C
	DATA P,M,N,IFLG/20*0.,22*0/ 
C
	DATA ECHLUN,CMDLUN/23,24/
C
	DATA ICOM,LABEL,IFORM,STRING/2*' ','(3F10.2)',' '/
C
	DATA IEFLG/0/
C
	DATA CONPRE,CONPST/' ',' '/
C
C
c*	DATA ZLEV,LDIG,LWGT,LCLR,NLEV,HGT/500*0.0,1500*0,40,.08/
c*	DATA ZLEV,LDIG,LWGT,LCLR,NLEV,HGT/500*0.0,1500*0,10,.08/
	DATA ZLEV,LDIG,LWGT,LCLR,NLEV,HGT/500*0.0,1500*0,30,.08/
	DATA NARC,IAUTOC,NLEV2,NSIGC,INISIG,NEWSIG,CANGLE,IVCOMP/1,1,0,2,2,0,0.0,1/
C
	DATA DASHLN,SPACLN,DSLAB/.04,.04,5.0/
C
	DATA ITYPEZ,JX,JY,JZ,LUNN,LINEN,NREC/0,1,2,0,1,0,1/
	DATA NVAR,NGRP,CAY,NRNG/2,1,5.0,5/
C
	DATA LUN1,LUN11,LUN21/1,11,21/
C
	DATA WSID,CONID,WSTYPE,ERRFIL/1,0,0,0/
	DATA CHDEV,CHPET,LCDEV,LCPET/1,1,1,3/
	DATA WKSAUT/.TRUE./
C
	DATA IPLOT,IPAUSE,IHDCPY/1,1,0/ 
C
	DATA XPTS,ZMIN,ZMAX,ZMEAN,XMIN,XMAX/6*0.0/
	DATA NX,YMIN,YMAX,NY,JTYPE/1,2*0.0,1,1/
C
	DATA HLAB1,HXLAB,HYLAB,HLABS/.16,3*.12/ 
	DATA ICOUNT,NLAB,ICROSS,IGTLAB/3*0,1/
C
C	FOR NLABS = 50
C
	DATA LAB1,XLAB,YLAB,LABS/3*' ',50*' '/
C
C	FOR NLINES=200 ! 3/00 *sh*
C
	DATA IMARK/0,2,4,18,20,22,26,28,30,48,190*0/
	DATA HMARK,ITYPE/200*0.08,0,9*4,190*0/
	DATA XOFF,YOFF,XFCT,YFCT/201*0.,201*0.,201*1.0,
     .						   201*1.0/
	DATA DN1/3*.15,.05,3*.15,.2,.1,.1,190*.15/
	DATA UP1/3*.1,.05,.05,.15,.05,.1,.05,.1,190*.1/
	DATA DN2/.15,.15,5*.05,3*.1,190*.15/
	DATA UP2/3*.1,.05,.15,.05,.05,.1,.05,.1,190*.1/
	DATA LLENG,LNUM,IWIND/100000*0,1,0/   ! lleng(NPOLYGON)
	DATA IPEN,IP/201*1,0,1,2*0/
	DATA gap_var/0/

C
C       Mod *JD* 3.91 to set default tty output to unit 6, not 5
C	DATA LTTOUT,LMULT/5,6/ original
	DATA LTTOUT,LMULT/6,5/
C
	DATA CMXLE,CMXEQ,CMXGE/0.,0.,1.E35/
	DATA XLE,XEQ,XGE/.FALSE.,.FALSE.,.TRUE./
	DATA CMYLE,CMYEQ,CMYGE/0.,0.,1.E35/
	DATA YLE,YEQ,YGE/.FALSE.,.FALSE.,.TRUE./
	DATA CMZLE,CMZEQ,CMZGE/0.,0.,1.E35/
	DATA ZLE,ZEQ,ZGE/.FALSE.,.FALSE.,.TRUE./
C
	DATA MNX,MNY,IMULT,IMCNT,DXM,DYM/4*0,10*1.4,10*1.2/
	DATA XLENM,YLENM,IXM,IYM,MXBOT,MYLEF/10*5.5,10*4.,2*0,2*0/
C
c	DATA ICODE,WIDTH,HEIGHT,TEKMOD,IR,LUN,BATMODE/
c     .		3,10.0,8.0,4010,110,8,0/
	DATA ICODE,WIDTH,HEIGHT,IR,LUN,BATMODE/
     .		3,10.0,8.0,110,8,0/
C
	DATA IBASE,PBUF/1,0/
C
	DATA NFLAGS/20/
	DATA SWITCH/'ECHO', 'DEBUG', 'OVERLAY','ERASE',
     *		    'WAIT','CENTER',   'RIGHT', 'LEFT',
     *		    'USER', 'LATCH',   'QUIET',  'LOG',
     *		   'YAXIS',  'TIME',  'OFFSET',  'CTD',
     *		    'NEXT','VECTOR',    'LINE',  'FILL'/
	DATA SMIN/       2,       1,         2,      2,
     *			 1,       1,         1,      2,
     *			 1,       2,         1,      2,
     *		         1,	  1,         2,      1,
     *			 2,       2,       2*0/
	DATA DEFLTS/.FALSE.,  .FALSE.,  .FALSE., .TRUE.,
     *		     .TRUE.,  .FALSE.,  .FALSE., .TRUE.,
     *		     .TRUE.,  .FALSE.,  .FALSE.,.FALSE.,
     *		    .FALSE.,  .FALSE.,   .TRUE.,.FALSE.,
     *		    .FALSE.,  .FALSE.,2*.FALSE./
C
C*** Mod 1.10.95 *** DATA KEYLN1,KEYLN2/21,22/
	DATA KEYLN1,KEYLN2/45,46/
C
	DATA ECHOF,DEBUGF,SMKEY2,LOGITF/.TRUE.,.FALSE.,.FALSE.,.FALSE./
	DATA QUIETF,LOGCMF/.FALSE.,.FALSE./
C
	DATA TLO,DT,TCSIZE,ITYPET/1.,1440.,.10,3/
	DATA NMTCT,LABELT,IFDB,ISDB,ITFLG/0,-1,1,1,0/
	DATA VANG,IVFLG,IAUTOT/0.,0,1/ 
	DATA TLOb,DTb,TCSIZEb,ITYPETb/1.,1440.,.10,3/
	DATA NMTCTb,LABELTb,IFDBb,ISDBb,ITFLGb/0,-1,1,1,0/
	DATA VANGb,IVFLGb,IAUTOTb/0.,0,1/ 
C
	DATA TSMX,TLX,TSMY,TLY,IX,IY/.125,.25,.125,.25,0,0/ 
C
	DATA ITX,ITY/2*-1/
C
C	FOR NLABS = 50
C
	DATA XLABS,YLABS,RLABS/50*1.E35,100*0.0/
	DATA LTYPE,XLLABS,YLLABS,LLTYPE/50*-1,100*0.0,50*0/
	DATA RHLABS/50*-1.0/
C
	DATA VAUTO,VUSER,VKEY/.TRUE.,.TRUE.,.FALSE./
	DATA VLEN/0.5/
	DATA VFRMT/'(1PG10.3)'/
	DATA VPOS/-1/,VXLOC,VYLOC/0.,0./
	DATA VSKPX,VSKPY/1,1/
	DATA VMINLN,ARMAX,ARMIN,HFACT/.01,0.5,0.1,0.25/
C
	DATA IZTYP,IZMRK,IZLEN/3*0/
C
	END

      subroutine kurv1 (n,x,y,slp1,slpn,islpsw,xp,yp,temp,s,
     *                  sigma,ierr)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*     *tc* 1.26.93  added this 'spline under tension' package.
*                   called by pplmod_contur and pplmod_arc to interpolate 
*                   on contour lines.

      integer n,islpsw,ierr
      real x(n),y(n),slp1,slpn,xp(n),yp(n),temp(n),s(n),
     *     sigma
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine determines the parameters necessary to
c compute a spline under tension forming a curve in the
c plane and passing through a sequence of pairs (x(1),y(1)),
c ...,(x(n),y(n)). for actual computation of points on the
c curve it is necessary to call the subroutine kurv2.
c
c on input--
c
c   n is the number of points to be interpolated (n.ge.2).
c
c   x is an array containing the n x-coordinates of the
c   points.
c
c   y is an array containing the n y-coordinates of the
c   points. (adjacent x-y pairs must be distinct, i. e.
c   either x(i) .ne. x(i+1) or y(i) .ne. y(i+1), for
c   i = 1,...,n-1.)
c
c   slp1 and slpn contain the desired values for the angles
c   (in radians) of the slope at (x(1),y(1)) and (x(n),y(n))
c   respectively. the angles are measured counter-clock-
c   wise from the x-axis and the positive sense of the curve
c   is assumed to be that moving from point 1 to point n.
c   the user may omit values for either or both of these
c   parameters and signal this with islpsw.
c
c   islpsw contains a switch indicating which slope data
c   should be used and which should be estimated by this
c   subroutine,
c          = 0 if slp1 and slpn are to be used,
c          = 1 if slp1 is to be used but not slpn,
c          = 2 if slpn is to be used but not slp1,
c          = 3 if both slp1 and slpn are to be estimated
c              internally.
c
c   xp and yp are arrays of length at least n.
c
c   temp is an array of length at least n which is used
c   for scratch storage.
c
c   s is an array of length at least n.
c
c and
c
c   sigma contains the tension factor. this value indicates
c   the curviness desired. if abs(sigma) is nearly zero
c   (e.g. .001) the resulting curve is approximately a cubic
c   spline. if abs(sigma) is large (e. g. 50.) the resulting
c   curve is nearly a polygonal line. if sigma equals zero a
c   cubic spline results. a standard value for sigma is
c   approximately 1. in absolute value.
c
c on output--
c
c   xp and yp contain information about the curvature of the
c   curve at the given nodes.
c
c   s contains the polygonal arclengths of the curve.
c
c   ierr contains an error flag,
c        = 0 for normal return,
c        = 1 if n is less than 2,
c        = 2 if adjacent coordinate pairs coincide.
c
c and
c
c   n, x, y, slp1, slpn, islpsw, and sigma are unaltered.
c
c this subroutine references package modules ceez, terms,
c and snhcsh.
c
c-----------------------------------------------------------
c
      nm1 = n-1
      np1 = n+1
      ierr = 0
      if (n .le. 1) go to 11
c
c determine polygonal arclengths
c
      s(1) = 0.
      do 1 i = 2,n
        im1 = i-1
    1   s(i) = s(im1)+sqrt((x(i)-x(im1))**2+
     *         (y(i)-y(im1))**2)
c
c denormalize tension factor
c
      sigmap = abs(sigma)*float(n-1)/s(n)
c
c approximate end slopes
c
      if (islpsw .ge. 2) go to 2
      slpp1x = cos(slp1)
      slpp1y = sin(slp1)
      go to 4
    2 dels1 = s(2)-s(1)
      dels2 = dels1+dels1
      if (n .gt. 2) dels2 = s(3)-s(1)
      if (dels1 .eq. 0. .or. dels2 .eq. 0.) go to 12
      call ceez (dels1,dels2,sigmap,c1,c2,c3,n)
      sx = c1*x(1)+c2*x(2)
      sy = c1*y(1)+c2*y(2)
      if (n .eq. 2) go to 3
      sx = sx+c3*x(3)
      sy = sy+c3*y(3)
    3 delt = sqrt(sx*sx+sy*sy)
      slpp1x = sx/delt
      slpp1y = sy/delt
    4 if (islpsw .eq. 1 .or. islpsw .eq. 3) go to 5
      slppnx = cos(slpn)
      slppny = sin(slpn)
      go to 7
    5 delsn = s(n)-s(nm1)
      delsnm = delsn+delsn
      if (n .gt. 2) delsnm = s(n)-s(n-2)
      if (delsn .eq. 0. .or. delsnm .eq. 0.) go to 12
      call ceez (-delsn,-delsnm,sigmap,c1,c2,c3,n)
      sx = c1*x(n)+c2*x(nm1)
      sy = c1*y(n)+c2*y(nm1)
      if (n .eq. 2) go to 6
      sx = sx+c3*x(n-2)
      sy = sy+c3*y(n-2)
    6 delt = sqrt(sx*sx+sy*sy)
      slppnx = sx/delt
      slppny = sy/delt
c
c set up right hand sides and tridiagonal system for xp and
c yp and perform forward elimination
c
    7 dx1 = (x(2)-x(1))/s(2)
      dy1 = (y(2)-y(1))/s(2)
      call terms (diag1,sdiag1,sigmap,s(2))
      xp(1) = (dx1-slpp1x)/diag1
      yp(1) = (dy1-slpp1y)/diag1
      temp(1) = sdiag1/diag1
      if (n .eq. 2) go to 9
      do 8 i = 2,nm1
        dels2 = s(i+1)-s(i)
        if (dels2 .eq. 0.) go to 12
        dx2 = (x(i+1)-x(i))/dels2
        dy2 = (y(i+1)-y(i))/dels2
        call terms (diag2,sdiag2,sigmap,dels2)
        diag = diag1+diag2-sdiag1*temp(i-1)
        diagin = 1./diag
        xp(i) = (dx2-dx1-sdiag1*xp(i-1))*diagin
        yp(i) = (dy2-dy1-sdiag1*yp(i-1))*diagin
        temp(i) = sdiag2*diagin
        dx1 = dx2
        dy1 = dy2
        diag1 = diag2
    8   sdiag1 = sdiag2
    9 diag = diag1-sdiag1*temp(nm1)
      xp(n) = (slppnx-dx1-sdiag1*xp(nm1))/diag
      yp(n) = (slppny-dy1-sdiag1*yp(nm1))/diag
c
c perform back substitution
c
      do 10 i = 2,n
        ibak = np1-i
        xp(ibak) = xp(ibak)-temp(ibak)*xp(ibak+1)
   10   yp(ibak) = yp(ibak)-temp(ibak)*yp(ibak+1)
      return
c
c too few points
c
   11 ierr = 1
      return
c
c coincident adjacent points
c
   12 ierr = 2
      return
      end
      subroutine kurv2 (t,xs,ys,n,x,y,xp,yp,s,sigma)
c
      integer n
      real t,xs,ys,x(n),y(n),xp(n),yp(n),s(n),sigma
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine performs the mapping of points in the
c interval (0.,1.) onto a curve in the plane. the subroutine
c kurv1 should be called earlier to determine certain
c necessary parameters. the resulting curve has a parametric
c representation both of whose components are splines under
c tension and functions of the polygonal arclength
c parameter.
c
c on input--
c
c   t contains a real value to be mapped to a point on the
c   curve. the interval (0.,1.) is mapped onto the entire
c   curve, with 0. mapping to (x(1),y(1)) and 1. mapping
c   to (x(n),y(n)). values outside this interval result in
c   extrapolation.
c
c   n contains the number of points which were specified
c   to determine the curve.
c
c   x and y are arrays containing the x- and y-coordinates
c   of the specified points.
c
c   xp and yp are the arrays output from kurv1 containing
c   curvature information.
c
c   s is an array containing the polygonal arclengths of
c   the curve.
c
c and
c
c   sigma contains the tension factor (its sign is ignored).
c
c the parameters n, x, y, xp, yp, s, and sigma should be
c input unaltered from the output of kurv1.
c
c on output--
c
c   xs and ys contain the x- and y-coordinates of the image
c   point on the curve.
c
c none of the input parameters are altered.
c
c this subroutine references package modules intrvl and
c snhcsh.
c
c-----------------------------------------------------------
c
c determine interval
c
      tn = s(n)*t
      im1 = intrvl(tn,s,n)
      i = im1+1
c
c denormalize tension factor
c
      sigmap = abs(sigma)*float(n-1)/s(n)
c
c set up and perform interpolation
c
      del1 = tn-s(im1)
      del2 = s(i)-tn
      dels = s(i)-s(im1)
      sumx = (x(i)*del1+x(im1)*del2)/dels
      sumy = (y(i)*del1+y(im1)*del2)/dels
      if (sigmap .ne. 0.) go to 1
      d = del1*del2/(6.*dels)
      c1 = (del1+dels)*d
      c2 = (del2+dels)*d
      xs = sumx-xp(i)*c1-xp(im1)*c2
      ys = sumy-yp(i)*c1-yp(im1)*c2
      return
    1 sigdel = sigmap*dels
      call snhcsh(ss,dummy,sigdel,-1)
      call snhcsh(s1,dummy,sigmap*del1,-1)
      call snhcsh(s2,dummy,sigmap*del2,-1)
      d = sigdel*sigmap*(1.+ss)
      c1 = del1*(s1-ss)/d
      c2 = del2*(s2-ss)/d
      xs = sumx+xp(i)*c1+xp(im1)*c2
      ys = sumy+yp(i)*c1+yp(im1)*c2
      return
      end
      subroutine ceez (del1,del2,sigma,c1,c2,c3,n)
c
      real del1,del2,sigma,c1,c2,c3
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine determines the coefficients c1, c2, and c3
c used to determine endpoint slopes. specifically, if
c function values y1, y2, and y3 are given at points x1, x2,
c and x3, respectively, the quantity c1*y1 + c2*y2 + c3*y3
c is the value of the derivative at x1 of a spline under
c tension (with tension factor sigma) passing through the
c three points and having third derivative equal to zero at
c x1. optionally, only two values, c1 and c2 are determined.
c
c on input--
c
c   del1 is x2-x1 (.gt. 0.).
c
c   del2 is x3-x1 (.gt. 0.). if n .eq. 2, this parameter is
c   ignored.
c
c   sigma is the tension factor.
c
c and
c
c   n is a switch indicating the number of coefficients to
c   be returned. if n .eq. 2 only two coefficients are
c   returned. otherwise all three are returned.
c
c on output--
c
c   c1, c2, and c3 contain the coefficients.
c
c none of the input parameters are altered.
c
c this subroutine references package module snhcsh.
c
c-----------------------------------------------------------
c
      if (n .eq. 2) go to 2
      if (sigma .ne. 0.) go to 1
      del = del2-del1
c
c tension .eq. 0.
c
      c1 = -(del1+del2)/(del1*del2)
      c2 = del2/(del1*del)
      c3 = -del1/(del2*del)
      return
c
c tension .ne. 0.
c
    1 call snhcsh (dummy,coshm1,sigma*del1,1)
      call snhcsh (dummy,coshm2,sigma*del2,1)
      delp = sigma*(del2+del1)/2.
      delm = sigma*(del2-del1)/2.
      call snhcsh (sinhmp,dummy,delp,-1)
      call snhcsh (sinhmm,dummy,delm,-1)
      denom = coshm1*(del2-del1)-2.*del1*delp*delm*
     *        (1.+sinhmp)*(1.+sinhmm)
      c1 = 2.*delp*delm*(1.+sinhmp)*(1.+sinhmm)/denom
      c2 = -coshm2/denom
      c3 = coshm1/denom
      return
c
c two coefficients
c
    2 c1 = -1./del1
      c2 = -c1
      return
      end
      subroutine snhcsh (sinhm,coshm,x,isw)
c
      integer isw
      real sinhm,coshm,x
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine returns approximations to
c       sinhm(x) = sinh(x)/x-1
c       coshm(x) = cosh(x)-1
c and
c       coshmm(x) = (cosh(x)-1-x*x/2)/(x*x)
c with relative error less than 1.0e-6
c
c on input--
c
c   x contains the value of the independent variable.
c
c   isw indicates the function desired
c           = -1 if only sinhm is desired,
c           =  0 if both sinhm and coshm are desired,
c           =  1 if only coshm is desired,
c           =  2 if only coshmm is desired,
c           =  3 if both sinhm and coshmm are desired.
c
c on output--
c
c   sinhm contains the value of sinhm(x) if isw .le. 0 or
c   isw .eq. 3 (sinhm is unaltered if isw .eq.1 or isw .eq.
c   2).
c
c   coshm contains the value of coshm(x) if isw .eq. 0 or
c   isw .eq. 1 and contains the value of coshmm(x) if isw
c   .ge. 2 (coshm is unaltered if isw .eq. -1).
c
c and
c
c   x and isw are unaltered.
c
c-----------------------------------------------------------
c
      data sp13/.3029390e-5/,
     *     sp12/.1975135e-3/,
     *     sp11/.8334261e-2/,
     *     sp10/.1666665e0/
      data sp24/.3693467e-7/,
     *     sp23/.2459974e-5/,
     *     sp22/.2018107e-3/,
     *     sp21/.8315072e-2/,
     *     sp20/.1667035e0/
      data sp33/.6666558e-5/,
     *     sp32/.6646307e-3/,
     *     sp31/.4001477e-1/,
     *     sq32/.2037930e-3/,
     *     sq31/-.6372739e-1/,
     *     sq30/.6017497e1/
      data sp43/.2311816e-4/,
     *     sp42/.2729702e-3/,
     *     sp41/.9868757e-1/,
     *     sq42/.1776637e-3/,
     *     sq41/-.7549779e-1/,
     *     sq40/.9110034e1/
      data cp4/.2982628e-6/,
     *     cp3/.2472673e-4/,
     *     cp2/.1388967e-2/,
     *     cp1/.4166665e-1/,
     *     cp0/.5000000e0/
c
      ax = abs(x)
      if (isw .ge. 0) go to 5
c
c sinhm approximation
c
      if (ax .gt. 4.45) go to 2
      xs = ax*ax
      if (ax .gt. 2.3) go to 1
c
c sinhm approximation on (0.,2.3)
c
      sinhm = xs*(((sp13*xs+sp12)*xs+sp11)*xs+sp10)
      return
c
c sinhm approximation on (2.3,4.45)
c
    1 sinhm = xs*((((sp24*xs+sp23)*xs+sp22)*xs+sp21)
     .               *xs+sp20)
      return
    2 if (ax .gt. 7.65) go to 3
c
c sinhm approximation on (4.45,7.65)
c
      xs = ax*ax
      sinhm = xs*(((sp33*xs+sp32)*xs+sp31)*xs+1.)/
     .             ((sq32*xs+sq31)*xs+sq30)
      return
    3 if (ax .gt. 10.1) go to 4
c
c sinhm approximation on (7.65,10.1)
c
      xs = ax*ax
      sinhm = xs*(((sp43*xs+sp42)*xs+sp41)*xs+1.)/
     .             ((sq42*xs+sq41)*xs+sq40)
      return
c
c sinhm approximation above 10.1
c
    4 sinhm = exp(ax)/(ax+ax)-1.
      return
c
c coshm and (possibly) sinhm approximation
c
    5 if (isw .ge. 2) go to 7
      if (ax .gt. 2.3) go to 6
      xs = ax*ax
      coshm = xs*((((cp4*xs+cp3)*xs+cp2)*xs+cp1)*xs+cp0)
      if (isw .eq. 0) sinhm = xs*(((sp13*xs+sp12)*xs+sp11)
     .                              *xs+sp10)
      return
    6 expx = exp(ax)
      coshm = (expx+1./expx)/2.-1.
      if (isw .eq. 0) sinhm = (expx-1./expx)/(ax+ax)-1.
      return
c
c coshmm and (possibly) sinhm approximation
c
    7 xs = ax*ax
      if (ax .gt. 2.3) go to 8
      coshm = xs*(((cp4*xs+cp3)*xs+cp2)*xs+cp1)
      if (isw .eq. 3) sinhm = xs*(((sp13*xs+sp12)*xs+sp11)
     .                              *xs+sp10)
      return
    8 expx = exp(ax)
      coshm = ((expx+1./expx-xs)/2.-1.)/xs
      if (isw .eq. 3) sinhm = (expx-1./expx)/(ax+ax)-1.
      return
      end
      subroutine terms (diag,sdiag,sigma,del)
c
      real diag,sdiag,sigma,del
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this subroutine computes the diagonal and superdiagonal
c terms of the tridiagonal linear system associated with
c spline under tension interpolation.
c
c on input--
c
c   sigma contains the tension factor.
c
c and
c
c   del contains the step size.
c
c on output--
c
c                sigma*del*cosh(sigma*del) - sinh(sigma*del)
c   diag = del*--------------------------------------------.
c                     (sigma*del)**2 * sinh(sigma*del)
c
c                   sinh(sigma*del) - sigma*del
c   sdiag = del*----------------------------------.
c                (sigma*del)**2 * sinh(sigma*del)
c
c and
c
c   sigma and del are unaltered.
c
c this subroutine references package module snhcsh.
c
c-----------------------------------------------------------
c
      if (sigma .ne. 0.) go to 1
      diag = del/3.
      sdiag = del/6.
      return
    1 sigdel = sigma*del
      call snhcsh (sinhm,coshm,sigdel,0)
      denom = sigma*sigdel*(1.+sinhm)
      diag = (coshm-sinhm)/denom
      sdiag = sinhm/denom
      return
      end
      function intrvl (t,x,n)
c
      integer n
      real t,x(n)
c
c                                 coded by alan kaylor cline
c                           from fitpack -- january 26, 1987
c                        a curve and surface fitting package
c                      a product of pleasant valley software
c                  8603 altus cove, austin, texas 78759, usa
c
c this function determines the index of the interval
c (determined by a given increasing sequence) in which
c a given value lies.
c
c on input--
c
c   t is the given value.
c
c   x is a vector of strictly increasing values.
c
c and
c
c   n is the length of x (n .ge. 2).
c
c on output--
c
c   intrvl returns an integer i such that
c
c          i =  1       if         e   t .lt. x(2)  ,
c          i =  n-1     if x(n-1) .le. t            ,
c          otherwise       x(i)  .le. t .le. x(i+1),
c
c none of the input parameters are altered.
c
c-----------------------------------------------------------
c
      save i
      data i /1/
c
      tt = t
c
c check for illegal i
c
      if (i .ge. n) i = n/2
c
c check old interval and extremes
c
      if (tt .lt. x(i)) then
        if (tt .le. x(2)) then
          i = 1
          intrvl = 1
          return
        else
          il = 2
          ih = i
        end if
      else if (tt .le. x(i+1)) then
        intrvl = i
        return
      else if (tt .ge. x(n-1)) then
        i = n-1
        intrvl = n-1
        return
      else
        il = i+1
        ih = n-1
      end if
c
c binary search loop
c
    1 i = (il+ih)/2
      if (tt .lt. x(i)) then
         ih = i
      else if (tt .gt. x(i+1)) then
         il = i+1
      else
         intrvl = i
         return
      end if
      go to 1
      end

	SUBROUTINE PLOTZ(Z,XF,YF,XLPLOT,YLPLOT,XHPLOT,YHPLOT)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
C**     
C**     @(#)plotz.F	1.4    9/9/88
C**     
C**     
C***********************************************************************
C**     
C**     PLOT+ Scientific Graphics System
C**     
C***********************************************************************
C**     
C**     
C       lots of places ---> PPLMOD_PPLCMD ---> PPLMOD_PLTIT ---> PPLMOD_PLOTZ
C       
C       This subroutine is called for CONTOUR, SHADE and FILL plots
C       and puts the data on the proper grid and then plots it.
C 
C       Z      - actual 2D data array
C       XF     - X factor ( page? length / X range )
C       YF     - Y factor
C       XLPLOT - lower X page? coordinate
C       YLPLOT - lower Y page? coordinate
C       XHPLOT - upper X page? coordinate
C       YHPLOT - upper Y page? coordinate
C       
*       MOD *JD* to include AREA in TMAP PPL+
*       MOD *JD* moved dimension z(nx,ny) from below subroutine statement to
*       below includes so that CONTOUR will work on the MAC -- Ed Flinchem
*       had to do this to make that work. 3.29.93 DIMENSION --> REAL as well.
*       MOD *JD* To permit use of centered levels and specify the delta Z
*       value as well.  Added variables to CONT.INC common 8.3.95  
*	*jd* 8.28 fix bug in dz specification
*	*jd* 2.96 Change centered option so that data not spanning zero
*       is centered as well.
*       *jc* 4.97 Major clean up and commenting
*       *jc* 5.97 Added code for curvilinear coordinates
* V510 4/00 *sh - corrected faulty logic for centered levels (delta wrong)
* V540 10/01 *acm Set LWGT, LDIG when using previously defined levels; have 
*                 not been set if previous call was SHADE
* V540 10/01 *acm remove VMS include statements
* V540 12/01 *acm* do NOT set LWGT, LDIG here; set them in SHADE
* V541  5/02 *acm* Check that number levels not greater than size of 
*                  LWGT, LDIG, and ZLEV; issue an error message.
* V550 11/02 *acm* For fine grids, XLPLOT, XHPLOT, YLPLOT, YHPLOT computations
*                  need to be done in double precision.
* V550 11/02 *acm* New call to create LEVELS symbols, routine setlab_syms
* V554  9/03 *acm* Fix precision bug double precision, for fine grids in 
*                  curvlinear coordinates. See also pltit.F, setax.F
* v581 *acm* 3/05 open levels (-INF) (INF)
* V581 *acm* 7/05 fix bug 1279: fill/lev=(n) gave exactly N not nlev2=approx N
* V600 *acm* 1/06 prevent values of LOG10(0.0)
* V602 *acm* 2/07 check status coming out of CONSEG; part of fix to bug 1485
* V603 *acm* 5/07 Compute sig figs for labels along contours, and dash characteristics
*                 even when re-using previous levels. Those levels may have come from
*                 a previous SHADE plot as in SHADE/LINE and therefore the levels were
*                 set but not the contour label and line characteristics.
* V603 *acm* 7/07 Fix bug 1335, zero contours not dark. zlev(i) not seen as 0. Fix by 
*                 using TM_FPEQ to compare zlev(i) to 0., within machine accuracy.
* V604 *acm& 7/07 Fix bug 1519. The setting of levels info was incorrectly resetting the
*                 highest and lowest level when doing (-inf) and (inf) levels spec.
* v68  *acm* 4/08 Allow shade, vector plots of degenerate regions - world region 
*              within a grid cell
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus
* V698 *acm* 3/16  Ticket 2375: outline color key in black even on an overlay.

	INCLUDE 'PARAMPL5.DAT'
	INCLUDE 'ZGRIDD.INC'
	INCLUDE 'ZGRID.INC'
	INCLUDE 'AXIS.INC'
	include	'cont_inc.decl'
	INCLUDE 'CONT.INC'
	INCLUDE 'HD.INC'
	INCLUDE 'TAXIS.INC'
	INCLUDE 'AXISL.INC'
	INCLUDE 'PEN.INC'
	INCLUDE 'LINES.INC'
	INCLUDE 'PLTL.INC'
	include 'xcurvilinear.cmn'
        INCLUDE 'errmsg.parm'

* Argument declarations
**	DIMENSION Z(NX,NY)
	REAL	  Z(NX,NY)
        REAL      XF,YF
        REAL*8    XLPLOT,YLPLOT,XHPLOT,YHPLOT

* Local declarations
        INTEGER   status, slen1, slen2, nlev1
        CHARACTER TM_FMT_SNGL*20, buff1*20, buff2*20, err_msg*40
        REAL*8    DXFF, DXOF, DYFF, DYOF
        REAL      XFF, XOF, YFF, YOF, DMIN, DMAX, DZMAX
        LOGICAL   TM_FPEQ_SNGL

	logical		valid

C*       *jd* Linux port 12.96 add EXTERNAL calls below
        external scale, range

C	VAX/VMS
C
	DIMENSION IZMRKD(3)
	DATA IZMRKD/12,16,3/

C
C  Set the contour/color levels

        CALL SET_LEVELS_SHADE_FILL (status)
	IF (status .NE. ferr_ok) GOTO 5000


C       DRAW CONTOUR
C
C       from ppl/include/PPL.INC:
C
C       JTYPE: = 2 2-d irregular rectangular grid
C              = 1 1-d set
C              = 0 2-d regular rectangular grid (integer)
C              =-1 2-d second component of a vector regular grid
C              =-2 2-d second component of a vector irregular grid
C
C
C       from ppl/include/ZGRID.INC:
C
C       controls for the plotting of the positions of ungridded x,y,z data
C
C       IZTYP: =0 no points drawn
C              =1 points drawn along the x axis
C              =2 points drawn along the y axis
C              =3 points drawn at each raw input value
C       
C       IZMRK: =0 use the default mark
C              =n use mark n to denote the location
C
C       IZLEN: number of points in the x,y,z triplets

C
C       If it's a 2-d irregular grid plot and points have been drawn
C
	if (abs(jtype).eq.2 .and. iztyp.ne.0) then

	   call markh(hmark(1))

	   if (izmrk.eq.0) then
	      imrk=izmrkd(iztyp)
	   else
	      imrk=izmrk
	   endif

	   if (iztyp.eq.1) then

	      do 200 i=1,nx
		 call trans(0,z(i,ny+1),ylo,xt,y)
		 call plot(xt,y,0,imrk)
		 call mark(imrk)
 200	      continue

	   else if (iztyp.eq.2) then

	      do 210 j=1,ny
		 call trans(0,xlo,z(j,ny+2),x,yt)
		 call plot(x,yt,0,imrk)
		 call mark(imrk)
 210	      continue

	   else

	      do 230 i=1,nx
		 do 220 j=1,ny
		    call trans(0,z(i,ny+1),z(j,ny+2),xt,yt)
		    call plot(xt,yt,0,imrk)
		    call mark(imrk)
 220		 continue
 230	      continue

	   endif

	endif

C
C       If there are some x,y,z triplets and points have been drawn
C
	IF (IZLEN.NE.0.AND.IZTYP.NE.0) THEN

	   CALL MARKH(HMARK(1))

	   IF (IZMRK.EQ.0) THEN
	      IMRK=IZMRKD(IZTYP)
	   ELSE
	      IMRK=IZMRK
	   ENDIF

	   IF (IZTYP.EQ.1) THEN

	      call trans(0,xx(1),ylo,xt,y)
	      CALL PLOT(XT,Y,0,IMRK)
	      CALL MARK(IMRK)
	      DO 300 I=2,IZLEN
		 IF (XT.NE.XX(I)) THEN
		    call trans(0,xx(i),ylo,xt,y)
		    CALL PLOT(xt,Y,0,IMRK)
		    CALL MARK(IMRK)
		 ENDIF
 300	      CONTINUE

	   ELSE IF (IZTYP.EQ.2) THEN

	      call trans(0,xlo,yy(1),x,yt)
	      CALL PLOT(X,YT,0,IMRK)
	      CALL MARK(IMRK)
	      DO 310 I=2,IZLEN
		 IF (YT.NE.YY(I)) THEN
		    call trans(0,xlo,yy(i),x,yt)
		    CALL PLOT(X,yt,0,IMRK)
		    CALL MARK(IMRK)
		 ENDIF
 310	      CONTINUE

	   ELSE

	      DO 320 I=1,IZLEN
		 call trans(0,xx(i),yy(i),xt,yt)
		 CALL PLOT(xt,yt,0,IMRK)
		 CALL MARK(IMRK)
 320	      CONTINUE

	   ENDIF

	ENDIF

	CALL SCALE(1.,1.,XORG,YORG,0.,0.)
	IF (IWIND.NE.0) CALL WINDOW(0.0,0.0,XLEN,YLEN)
	CALL COLOR(IPEN(1))


C       Calculate the following quantities:
C       ~FF - multiplication factors to go from axis to page coords?
C       ~OF - page offset to the beginning of an axis?

	call trans(0,xmin,ymin,xtm,ytm)
	call trans(0,xmax,ymax,xtx,ytx)
	DXFF = (XHPLOT - XLPLOT)/(xtx-xtm)
	IF (TM_FPEQ_SNGL(xtx, xtm)) DXFF = 1.
	DXOF = (XLPLOT) - DXFF*xtm
	DYFF = (YHPLOT - YLPLOT)/(ytx-ytm)
	IF (TM_FPEQ_SNGL(xtx, xtm)) DXFF = 1.
	DYOF = (YLPLOT) - DYFF*ytm

	XFF = DXFF
	XOF = DXOF
	YFF = DYFF
	YOF = DYOF


C       If this is a 2-D plot on an irregular grid, use TRANS() to 
C       scale the points appropriately.  Values are returned in 
C       the xx() and yy() arrays.
C
	IF (abs(jtype).eq.2) THEN
       
	   do 400 i=1,nx
	      call trans(0,z(i,ny+1),ymin,xx(izlen+i),yt)
 400	   continue
	   do 410 j=1,ny
	      call trans(0,xmin,z(j,ny+2),xt,yy(izlen+j))
 410	   continue


C       For all other plot types fill in XX() and YY() by
C       multiplying the index value by the DX or DY delta values.

	ELSE

	   DX = (xtx - xtm)/(NX - 1)
	   DY = (ytx - ytm)/(NY - 1)
	   IF (NX .EQ. 1) DX = 1.
	   IF (NY .EQ. 1) DY = 1.

	   DO 500 I=1,NX
	      XX(IZLEN+I)=DX*(I-1)+xtm
 500	   CONTINUE
	   DO 510 J=1,NY
	      YY(IZLEN+J)=DY*(J-1)+ytm
 510	   CONTINUE

! TEST - fix XX if this is a subspan-modulo axis.
           IF ( .NOT. curvilinear ) THEN
              CALL box_centers ('X',xx(IZLEN+1),nx,xx(NX+IZLEN+1),valid)
	      DO i = 1, nx
	         xx(izlen+i) = xx(nx+izlen+i)
	      ENDDO

              CALL box_centers ('Y',yy(IZLEN+1),ny,yy(Ny+IZLEN+1),valid)
	      DO j = 1, ny
	         yy(izlen+j) = yy(ny+izlen+j)
	      ENDDO
	   ENDIF

	ENDIF

* Now that the levels are set, create the LEVELS symbols

        CALL setlab_syms (ZLEV, MAX(NLEV2,1) )

	 if (makep.eq.'CONTOUR') then
c *kob* 8/97 had to move the continuation marker to col 5 - it was in col 8
c       this bombed aix compiler, though it seems to work on others
	    CALL CONSEG(Z,NX,NY,XX(IZLEN+1),YY(IZLEN+1),NX,NY,
     1	 XFF,XOF,YFF,YOF,ZLEV,LDIG,LWGT,LCLR,NLEV2,HGT,
     2	 NARC,CANGLE,status)
             IF (status .NE. ferr_ok) GOTO 5002

* Ticket 2375: A color fill plot needs IPEN(0), so that if there is a
* color key it is labeled and outlined in black even on an overlay.
	 else if (makep.eq.'FILL') then
	    
	    CALL COLOR(IPEN(0))
            nlev1 = nlev
            nlev = nlev2
	    call arfill(z,xx(izlen+1),yy(izlen+1),nx,ny)
            nlev = nlev1

	 else
*******     SQRFILL NOT A TMAP PPL+ COMMAND *jd* 2.19.99
*******	    call sqrfill(z,xx(izlen+1),yy(izlen+1),nx,ny,
*******     1	 zlev,nlev2)

	 endif

C
C	END VAX/VMS
C
	CALL COLOR(IPEN(0))
	CALL SCALE(XF,YF,XORG,YORG,XLO,YLO)

	RETURN

C  Error exit when too many levels specified.
C  Arrays LWGT, LDIG, and ZLEV are length ICNLEV=500

 5000   ii = ICNLEV
        buff1 = TM_FMT_SNGL (REAL(ICNLEV), 20, 20, slen1)
        buff2 = TM_FMT_SNGL (REAL(NLEV2), 20, 20, slen2)
        err_msg = '# of contour levels > '// buff1(1:slen1) //
     .          '  (' // buff2(1:slen2) // ')'
        CALL errmsg (ferr_out_of_range, status, err_msg, *5002)

 5002   return

	END

	SUBROUTINE SET_WINDOW_SIZE (wsid,xmin,xmax,ymin,ymax)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Routine to handle resizing windows -- uses GSWKVP for DEC GKS and 
*	GUESC -5304 in ATC GKS.  ATC doesn't resize the window with GSWKVP.
*	J Davison 3.24.92
*	Mod 8.27.93 to handle XGKS resizing
*       Mod 3.15.94 *jd* to call X event processing 
*	*sh* 3.5.97 Mod to support metafile-only (no X) output through a
*		cuckoo's egg implantation of meta_wsid in place of wsid
*      *acm* 8/27/04 New returns from resize_xgks_window; pixx,pixy which are
*                    the size of the window in pixels.  Save these in common 
*                    gkscm2.cmn, so that in gif and batch modes we can return 
*                    them in symbols PPL$XPIXEL and PPL$YPIXEL.
* V6.8 *acm* 7/9/2012 For batch graphics on RHEL6, change ITS_BATCH_GRAPHICS
*                     from logical to integer, then batch = ITS_BATCH_GRAPHICS().NE.0
*

#   ifndef atc_gks
        include         'gkspar.inc'
#   endif
        include         'ws_types.cmn'
	include         'gkscm2.cmn'


	integer		wsid,ierr,conid,wstype
	real		xmin,xmax,ymin,ymax,xsize,ysize,xfactor,yfactor

        integer 	ia(3),lidr,lodr 
        real 		ra(1)

        character*80 	datarec(1), odr(1), str(1)

	INTEGER		ITS_BATCH_GRAPHICS
	LOGICAL		batch

*******************************************************************************
* initialize batch mode
	batch = ITS_BATCH_GRAPHICS() .NE. 0
        pixx = -1
        pixy = -1

#ifdef atc_gks
	
*	Use the escape -5304 from ATC to resize Xwindowse.  Units are in meters
*       -- to be converted to pixels (raster units).

	call gqwkc (wsid,ierr,conid,wstype)

	if (wstype/100 .eq. ws_xwindow/100) then 
*	   FIND CONVERSION FACTOR FROM PIXELS TO MM FOR THIS MONITOR
           call guesc307 (wstype,ierr,xfactor,yfactor)
	   if (ierr .ne. 0) goto 1000

  	   xsize = xmax - xmin
	   ysize = ymax - ymin

	   ia(1) = wsid
	   ia(2) = xsize * 1000.0 / xfactor
	   ia(3) = ysize * 1000.0 / yfactor

           call gprec (3, ia, 0, ra, 0, 0, str, 80, ierr, lidr, datarec)
           call guesc (-5304, lidr, datarec, 80, lodr, odr)
	else 
	   call gswkvp (wsid,xmin,xmax,ymin,ymax)
	endif
#elif xgks
	call resize_xgks_window (wsid,xmax-xmin,ymax-ymin,pixx,pixy)
c       Also need to resize the metafile window, if it is open *js* 8.97
	if (meta_actv .and. .not. meta_clsplt) then
	   call resize_xgks_window (meta_wsid, xmax-xmin,ymax-ymin,
     .             pixx,pixy)
	end if
#else
	call gswkvp (wsid,xmin,xmax,ymin,ymax)
#endif

1000	return
	end

      SUBROUTINE TABMV
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)tabmv.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
	INTEGER*4 ITA,ITB
C
C     CALL TABMV
C
C     THIS SUBROUTINE DRIVES THE TEKTRONIX GRAPHICS TERMINAL.  THE
C     COORDINATES OF THE NEW POSITION ARE RECEIVED IN VARIABLES A
C     AND B.
C
C
#ifdef unix
	INTEGER*2 DUMMY(4)
#else
	byte dummy(4)
#endif
C
#ifdef unix
	include 'PLTCOM.DAT'
#else
	include 'pplinc:PLTCOM.DAT'
#endif
	DATA DUMMY/32,96,32,64/
C
C     CONVERT THE POSITION TO A TEKTERMINAL ADDRESS.
C
      ITA = IFIX(A * PLTOTA)
      ITB = IFIX(B * PLTOTB)
C
C     CHECK THE GRAPHICS FLAG.
C
        IF(GRAPHF)THEN
C
C     CHECK THE PEN POSITION.
C
          IF(.NOT. PEN)CALL CHOUT(GS,1)
        ELSE
C
C     CHECK THE TEKTERMINAL TYPE.
C
          IF(TTYPE .EQ. -4662 .OR. TTYPE .EQ. -4663)THEN
C
C     TRANSMIT THE 'PLOTTER ON' COMMAND TO THE TEKTRONIX PLOTTER.
C
            CALL CHOUT(TEKON,3)
            OLDHTA = 0
            OLDHTB = 0
          ENDIF
C
C     SELECT VECTORS MODE.
C
          CALL CHOUT(GS,1)
          LHIA = 0
          LHIB = 0
          LLOBA = 0
C
C     SET THE GRAPHICS FLAG.
C
          GRAPHF = .TRUE.
C
C     CHECK THE PEN POSITION.
C
          IF(PEN)THEN
C
C     PLOT A DARK LINE SEGMENT SO THAT THE NEXT LINE SEGMENT
C     PLOTTED WILL BE BRIGHT.
C
            CALL CHOUT(DUMMY,4)
          ENDIF
        ENDIF
C
C     CHECK THE TEKTERMINAL TYPE.
C
      IF(TTYPE .GT. 0 .AND. TTYPE .LT. 4014)THEN
C
C     CALCULATE THE HIGH-ORDER B-BYTE.  10 BIT CODES FOR TEK401X
C
#ifdef unix
#ifdef sun
	ihib=or(and(rshift(itb,5),31),32)
#else
# ifdef NEED_IAND
	IHIB=IOR(IAND(ISHFT(ITB,-5),31),32)
# else
	IHIB=OR(AND(LSHIFT(ITB,-5),31),32)
# endif
#endif
#else
	IHIB=IOR(IAND(ISHFT(ITB,-5),31),32)
#endif
C
C     IF NO CHANGE, DO NOT TRANSMIT IT.
C
        IF(IHIB .NE. LHIB)THEN
          CALL CHOUT(IHIB,1)
          LHIB = IHIB
        ENDIF
C
C     TRANSMIT THE LOW-ORDER B-BYTE.
C
#ifdef unix
# ifdef NEED_IAND
	CALL CHOUT(IOR(IAND(ITB,31),96),1)
# else
	CALL CHOUT(OR(AND(ITB,31),96),1)
# endif
#else
	CALL CHOUT(IOR(IAND(ITB,31),96),1)
#endif
C
C     CALCULATE THE HIGH-ORDER A-BYTE.
C
#ifdef unix
#ifdef sun
	IHIA=OR(AND(rSHIFT(ITA,5),31),32)
#else
# ifdef NEED_IAND
	IHIA=IOR(IAND(ISHFT(ITA,-5),31),32)
# else
	IHIA=OR(AND(LSHIFT(ITA,-5),31),32)
# endif
#endif
#else
	IHIA=IOR(IAND(ISHFT(ITA,-5),31),32)
#endif
C
C     IF NO CHANGE, DO NOT TRANSMIT IT.
C
        IF(IHIA .NE. LHIA)THEN
          CALL CHOUT(IHIA,1)
          LHIA = IHIA
        ENDIF
C
C     TRANSMIT THE LOW-ORDER A-BYTE.
C
#ifdef unix
# ifdef NEED_IAND
	CALL CHOUT(IOR(IAND(ITA,31),64),1)
# else
	CALL CHOUT(OR(AND(ITA,31),64),1)
# endif
#else
	CALL CHOUT(IOR(IAND(ITA,31),64),1)
#endif
      ELSE
        ICH = 3
C
C     CALCULATE THE HIGH-ORDER B-BYTE.    12 BIT CODES FOR TEK41XX
C
#ifdef unix
#ifdef sun
        IHIB = OR(AND(rSHIFT(ITB,7), 31), 32)
#else
# ifdef NEED_IAND
        IHIB = IOR(IAND(ISHFT(ITB,-7), 31), 32)
# else
        IHIB = OR(AND(LSHIFT(ITB,-7), 31), 32)
# endif
#endif
#else
        IHIB = IOR(IAND(ISHFT(ITB,-7), 31), 32)
#endif
C
C     IF NO CHANGE, DO NOT TRANSMIT IT.
C
        IF(IHIB .NE. LHIB)THEN
          CALL CHOUT(IHIB,1)
          LHIB = IHIB
          ICH = ICH + 1
        ENDIF
C
C     CALCULATE THE EXTRA BYTE.
C
#ifdef unix
# ifdef NEED_IAND
        ILOBA=IOR(IOR(ISHFT(IAND(ITB,3),2),IAND(ITA,3)),96)
# else
        ILOBA=OR(OR(LSHIFT(AND(ITB,3),2),AND(ITA,3)),96)
# endif
#else
        ILOBA=IOR(IOR(ISHFT(IAND(ITB,3),2),IAND(ITA,3)),96)
#endif
C
C     IF NO CHANGE, DO NOT TRANSMIT IT.
C
        IF(ILOBA .NE. LLOBA)THEN
          CALL CHOUT(ILOBA,1)
          LLOBA = ILOBA
          ICH = ICH + 1
        ENDIF
C
C     TRANSMIT THE LOW-ORDER B-BYTE.
C
#ifdef unix
#ifdef sun
        CALL CHOUT(OR(AND(rSHIFT(ITB,2), 31), 96),1)
#else
# ifdef NEED_IAND
        CALL CHOUT(IOR(IAND(ISHFT(ITB,-2), 31), 96),1)
# else
        CALL CHOUT(OR(AND(LSHIFT(ITB,-2), 31), 96),1)
# endif
#endif
#else
        CALL CHOUT(IOR(IAND(ISHFT(ITB,-2), 31), 96),1)
#endif
C
C     CALCULATE THE HIGH-ORDER A-BYTE.
C
#ifdef unix
#ifdef sun
        IHIA = OR(AND(rSHIFT(ITA,7), 31), 32)
#else
# ifdef NEED_IAND
        IHIA = IOR(IAND(ISHFT(ITA,-7), 31), 32)
# else
        IHIA = OR(AND(LSHIFT(ITA,-7), 31), 32)
# endif
#endif
#else
        IHIA = IOR(IAND(ISHFT(ITA,-7), 31), 32)
#endif
C
C     IF NO CHANGE, DO NOT TRANSMIT IT.
C
        IF(IHIA .NE. LHIA)THEN
          CALL CHOUT(IHIA,1)
          LHIA = IHIA
          ICH = ICH + 1
        ENDIF
C
C     TRANSMIT THE LOW-ORDER A-BYTE.
C
#ifdef unix
#ifdef sun
        CALL CHOUT(OR(AND(rSHIFT(ITA,2), 31), 64),1)
#else
# ifdef NEED_IAND
        CALL CHOUT(IOR(IAND(ISHFT(ITA,-2), 31), 64),1)
# else
        CALL CHOUT(OR(AND(LSHIFT(ITA,-2), 31), 64),1)
# endif
#endif
#else
        CALL CHOUT(IOR(IAND(ISHFT(ITA,-2), 31), 64),1)
#endif
C
C     CHECK THE TEKTERMINAL TYPE.
C
        IF(TTYPE .EQ. -4662 .OR. TTYPE .EQ. -4663)THEN
C
C     TRANSMIT SYNC CHARACTERS WHILE THE PLOTTER DRAWS THE VECTOR.
C
          DA = TWIDTH * FLOAT(ITA - OLDHTA) / TSCLA
          DB = THIGHT * FLOAT(ITB - OLDHTB) / TSCLB
          OLDHTA = ITA
          OLDHTB = ITB
C
C     NOMINAL VECTOR DRAWING TIMES FOR THE TEKTRONIX PLOTTER CAN
C     BE DETERMINED AS FOLLOWS:
C        T (IN MSEC) = 61.44 * L (IN INCHES) + 84.93
C
          NDELAY = IFIX((0.006144 * SQRT(DA * DA + DB * DB) +
     *     0.0050958) * FLOAT(BAUDR))
          IF(NDELAY .GE. ICH)THEN
            DO 10 J=ICH,NDELAY
   10       CALL CHOUT(SYN,1)
          ENDIF
        ENDIF
      ENDIF
      RETURN
C
      END

	SUBROUTINE DSFLAB
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)dsflab.F	1.1    3/10/88
C** v552 *acm* 3/03 Longer strings: changes for multi-line labels.
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C	DSFLAB fills the PLOT5 labels with information from the
C	BIBO header of a DSF file.
C
	INCLUDE 'PARAMPL5.DAT'
	INCLUDE 'CMRD.INC'
	INCLUDE 'LABELS.INC'
	INCLUDE 'BIBO.COM'
	INCLUDE 'TBLE.INC'
C
	REAL STR(11)
	CHARACTER MORINT*16,LAT*11,LON*11,NS*1,EW*1,DEP*10
	INTEGER MORLEN,LATLEN,LONLEN,DEPLEN
C	INCLUDE 'BIBO.DAT'
C
C	fill the XLAB 
C
	XLAB = 'Time (BIBO)'
C
C	fill the YLAB
C
	CALL FILL(DTTAB,NDTTAB,P(DTYPE),STR,IER)
	WRITE(YLAB,'(6A4,1X,4A4)')(STR(I),I=1,10)
	CALL LJUST(YLAB,2048,J)
	WRITE(MORINT,'(4A4)')P(MOOR),P(MOOR+1),P(INST),P(INST+1)
	CALL SQUISH(MORINT,1,16)
	MORLEN=LNBLK(MORINT,16)
	ILAT=P(SLAT)/100.0
	IF(P(SLAT).GE.0)THEN
	    NS='N'
	ELSE
	    NS='S'
	ENDIF
	RLAT=ABS(P(SLAT)-ILAT*100.0)
	IF(RLAT.EQ.0.)THEN
	    WRITE(LAT,999)IABS(ILAT),NS
999	    FORMAT(I4,'#',A1)
	ELSE
	    WRITE(LAT,998)IABS(ILAT),RLAT,NS
998	    FORMAT(I4,1X,F4.1,'#',A1)
	ENDIF
	CALL LJUST(LAT,11,LATLEN)
	ILON=P(SLON)/100.0
	IF(P(SLON).GE.0)THEN
	    EW='E'
	ELSE
	    EW='W'
	ENDIF
	RLON=ABS(P(SLON)-ILON*100.0)
	IF(RLON.EQ.0.)THEN
	    WRITE(LON,999)IABS(ILON),EW
	ELSE
	    WRITE(LON,998)IABS(ILON),RLON,EW
	ENDIF
	CALL LJUST(LON,11,LONLEN)
	WRITE(DEP,'(F10.1)')P(INDEP)
	CALL LJUST(DEP,10,DEPLEN)
C
C	create main label
C
	LAB1=MORINT(1:MORLEN)//'  '//LAT(1:LATLEN)//', '//
     *	    LON(1:LONLEN)//'  ('//DEP(1:DEPLEN)//' M)'
	RETURN
	END
	SUBROUTINE LJUST(STR,INLEN,OUTLEN)
C
C	LJUST left justifies a string and returns its length
C
	INTEGER INLEN,OUTLEN

#ifdef FORTRAN_90
	character str*(*)
#else
	CHARACTER STR*2048
#endif

	IF(STR.EQ.' ')THEN
	    OUTLEN=1
	    RETURN
	ENDIF
100	IF(STR(1:1).NE.' ')GOTO 200
	STR(1:INLEN)=STR(2:INLEN)
	GOTO 100
200	OUTLEN=LNBLK(STR,INLEN)
	RETURN
	END

        SUBROUTINE SHADE_KEY (isetting)
        
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*       Sets the options for SHADE key -- size,location,etc
*       J Davison JISAO/PMEL/TMAP 8.24.88
* v541 *acm*  5/02 add option to control outline on the shade key boxes
*                  also remove VMS INCLUDES

* 552 *acm* 4/03 Shade key improvements: Do not have to set all four corners 
*           when changing the size and location of the shade key -- can 
*           reset any of the four, and others will be filled in by making 
*           the key the default size in that direction.  See key.F
* v581 *acm* 3/05 put flag cont_key into common CONT.INC
* V6.92 *acm* 6/14 New color /key options: any of /key=horizontal,centerlabel

        include         'shade_vars.cmn'
	include		'cmrd_inc.decl'
	include		'CMRD.INC'
        include         'axis_inc.decl'
        include         'AXIS.INC'
        include         'plt_inc.decl'
        include         'PLT.INC'
	include 	'parampl5_dat.decl'
	include 	'PARAMPL5.DAT'
	include		'cont_inc.decl'
	include		'CONT.INC'

        INTEGER i

*******************************************************************************


! From setup_defaults -- which is called only the first time from pplcmd_f

*      key defaults

c	do_key	     	= .true.   ! Still initialize this in setup_defaults.F
        vertical_key 	= .true.
        do 100 i = 1, 4
           kuser_loc(i) = .false.
  100   continue

	IF (isetting .EQ. 0) THEN
	   center_key_labels = .FALSE.
	   vertical_key = .TRUE.
	ENDIF

* Option centered_labels on key (e.g. on discrete color settings, by-levels.)

	IF (isetting .EQ. 2) center_key_labels = .TRUE.

	klab_size = 0.0
	klab_dig  = 3
	klab_len  = 9
	klab_incr = 0
!c Make annotate_key setting persist: Once it has been
!c set, reset it to 0 only if explicitly turned off, see m.EQ.11 below
!c	annotate_key = 0  

	if (m .ge. 1 .and. iflg(1) .ne. 0 .and. p(1).eq.0.0) 
     .	do_key = .false.
	if (m .ge. 1 .and. iflg(1) .ne. 0 .and. p(1).eq.1.0) 
     .	do_key = .TRUE.

	if (m .ge. 2 .and. iflg(2) .ne. 0 .and. p(2).eq.0.0) 
     .	vertical_key = .false.
	if (m .ge. 2 .and. iflg(2) .ne. 0 .and. p(2).eq.1.0) 
     .	vertical_key = .TRUE.
        IF (isetting .EQ. 3) vertical_key = .FALSE.

	if (m .ge. 3 .and. iflg(3) .ne. 0) klab_size = p(3)
	if (m .ge. 4 .and. iflg(4) .ne. 0) klab_incr = ifix (p(4))
	if (m .ge. 5 .and. iflg(5) .ne. 0) klab_dig  = ifix (p(5))
	if (m .ge. 6 .and. iflg(6) .ne. 0) klab_len  = ifix (p(6))

* Set the user-indicated corners of the shade key. If a location is
* not marked, it will be set in key.F

        DO 1000 i = 1, 4
           kuser_loc(i) = (iflg(i+6) .NE. 0)           
 1000   CONTINUE

	IF (m .GE. 7) THEN

          IF (iflg(7) .NE. 0 .AND. iflg(8) .NE. 0 
     .	     .AND. iflg(9) .NE. 0 .AND. iflg(10) .NE. 0) THEN
	      kx_lo = p(7) * 1000.
	      kx_hi = p(8) * 1000.
	      ky_lo = p(9) * 1000.
	      ky_hi = p(10)* 1000.
           ELSE 

              IF (iflg(7).NE.0 .AND. iflg(8).EQ.0) kx_lo = p(7) * 1000.
              IF (iflg(7).EQ.0 .AND. iflg(8).NE.0) kx_hi = p(8) * 1000.
              IF (iflg(7).NE.0 .AND. iflg(8).NE.0) THEN
	         kx_lo = p(7) * 1000.
	         kx_hi = p(8) * 1000.
              ENDIF
  
              IF (iflg(9).NE.0 .AND. iflg(10).EQ.0) ky_lo = p(9) * 1000.
              IF (iflg(9).EQ.0 .AND. iflg(10).NE.0) ky_hi = p(10) * 1000.
              IF (iflg(9).NE.0 .AND. iflg(10).NE.0) THEN
	         ky_lo = p(9) * 1000.
	         ky_hi = p(10) * 1000.
              ENDIF
           ENDIF
        ENDIF

        IF (m .GE. 11) THEN
           annotate_key = 0
	   IF (p(11) .EQ. 1) annotate_key = 1
	ENDIF

        DO 3000 i = 1, 4
           iflg(i+6) = 0  ! Reset for subsequent plots
 3000   CONTINUE

	return
	end

	BLOCK DATA WS_TYPES_INIT

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Initialize wstype constants for either DEC or ATC GKS
*	J Davison 2.13.92
*	Mod to support XGKS *jd* 8.10.93

#ifdef unix
#   ifndef atc_gks
#      ifndef xgks
	include		'/usr/include/GKS3D/GKS3Dforbnd.f'
#      else
	include		'gkspar.inc'
#      endif
#   endif
	include		'ws_types.cmn'
        include         'gkscm2.cmn'
#else
	include		'sys$library:gksdefs.bnd'
	include		'tmap_pplv11inc:ws_types.inc'
        INCLUDE         'tmap_pplv11inc:tmap_gkscm2.inc'
#endif

*******************************************************************************

#ifdef atc_gks
*	ATC GKS values for workstation types

        data         	ws_xwindow/5350/,
     .			ws_uis/-1/,
     .                  ws_meta_in/1001/,
     .                  ws_meta_out/1002/,
     .                  ws_ps_mono/1901/,
     .                  ws_ps_color/1901/,
     .                  ws_tek4014/2500/,
     .                  ws_tek4107/3100/
#elif xgks
*	 XGKS values for workstation types

      data              ws_xwindow/4/,
     .			ws_uis/-1/,
     .                  ws_meta_in/-1/,
     .                  ws_meta_out/-1/,
     .                  ws_ps_mono/-1/,
     .                  ws_ps_color/-1/,
     .                  ws_tek4107/-1/
#else
*	DEC GKS values for workstation types

      data              ws_xwindow/0/,
     .			ws_uis/gvsii/,
     .                  ws_meta_in/gminpt/,
     .                  ws_meta_out/gmoutp/,
     .                  ws_ps_mono/gptsc/,
     .                  ws_ps_color/gcptsc/,
     .                  ws_tek4014/gteko/,
     .                  ws_tek4107/gt41o/
#endif

*	INITIALIZE METAFILE NAME

	data		meta_file/'metafile.plt'/


	end

	INTEGER FUNCTION DO_DIST_LOC(	idim, arg,
     .					com, com_mr, com_cx,
     .					res, res_mr, res_cx,
     .					buff	)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* locate the indicated argument value along the indicated axis and leave
* behind an "interpolating kernel": linear interpolating weights on the
* points immediately before and after the located value

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V230:  1/22/92 - new routine based on DO_FILL_AVE and DO_LOCATE
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include	'xprog_state.cmn'

* calling argument declarations:
	INTEGER	idim, com_mr, com_cx, res_mr, res_cx
	REAL	arg, buff(*),
     .          com( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          res( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif )

* internal variable declarations:
        LOGICAL first_pt, first_lt, crossing_found
	INTEGER i, j, k, l, m, n, ss1,
     .          lo_sub(nferdims), hi_sub(nferdims)
	REAL	bad_res, com1, com2, del

* internal (convenience) equivalences
	INTEGER	lo_s1, lo_s2, lo_s3, lo_s4, lo_s5, lo_s6,
     .          hi_s1, hi_s2, hi_s3, hi_s4, hi_s5, hi_s6
	EQUIVALENCE (lo_s1, lo_sub(1)) , (lo_s2, lo_sub(2)),
     .		    (lo_s3, lo_sub(3)) , (lo_s4, lo_sub(4)),
     .		    (lo_s5, lo_sub(5)) , (lo_s6, lo_sub(6)),
     .		    (hi_s1, hi_sub(1)) , (hi_s2, hi_sub(2)),
     .		    (hi_s3, hi_sub(3)) , (hi_s4, hi_sub(4)),
     .		    (hi_s5, hi_sub(5)) , (hi_s6, hi_sub(6))

* diagnostic mode output: " doing --> VAR_NAME[x=lo:hi@TRN:n,D=#]"
	IF ( mode_diagnostic ) 	CALL DIAG_OP
     .				( 'doing', isact_class_trans, res_cx, idim )

* initialize
	bad_res = mr_bad_data( com_mr )
        
* calculation limits
	DO 10 i = 1, nferdims
	   lo_sub(i) = cx_lo_ss(res_cx,i)
	   hi_sub(i) = cx_hi_ss(res_cx,i)
 10	CONTINUE

* SEARCH ALONG X AXIS
	IF ( idim .EQ. x_dim ) THEN
	   DO 110 n = lo_s6, hi_s6
	   DO 110 m = lo_s5, hi_s5
	   DO 110 l = lo_s4, hi_s4
	   DO 110 k = lo_s3, hi_s3
	   DO 110 j = lo_s2, hi_s2
              first_pt = .TRUE.
              crossing_found = .FALSE.
	      DO 100 i = lo_s1, hi_s1
                 res(i,j,k,l,m,n) = bad_res
                 IF ( crossing_found ) GOTO 100
                 IF ( com(i,j,k,l,m,n) .EQ. bad_res ) GOTO 100
                 IF ( com(i,j,k,l,m,n) .EQ. arg ) THEN
* ... exact equality
                    res(i,j,k,l,m,n) = 1.0
                    crossing_found = .TRUE.
                 ELSEIF ( first_pt ) THEN
* ... first non-bad value
                    first_pt = .FALSE.
                    first_lt = com(i,j,k,l,m,n) .LT. arg
                    ss1 = i
                 ELSEIF ( first_lt .EQV.
     .                    (com(i,j,k,l,m,n) .LT. arg) ) THEN
* ... still have not crossed from GT to LT or visa versa
                    ss1 = i
                 ELSE
* ... found a "crossing"
                    com1 = com(ss1,j,k,l,m,n)
                    com2 = com(i  ,j,k,l,m,n)
                    del = com2 - com1
                    res(ss1,j,k,l,m,n) = (com2-arg) / del
                    res(i  ,j,k,l,m,n) = (arg-com1) / del
                    crossing_found = .TRUE.
                 ENDIF
 100          CONTINUE
 110       CONTINUE

* SEARCH ALONG Y AXIS
	ELSEIF ( idim .EQ. y_dim ) THEN
	   DO 210 n = lo_s6, hi_s6
	   DO 210 m = lo_s5, hi_s5
	   DO 210 l = lo_s4, hi_s4
	   DO 210 k = lo_s3, hi_s3
	   DO 210 i = lo_s1, hi_s1
              first_pt = .TRUE.
              crossing_found = .FALSE.
	      DO 200 j = lo_s2, hi_s2
                 res(i,j,k,l,m,n) = bad_res
                 IF ( crossing_found ) GOTO 200
                 IF ( com(i,j,k,l,m,n) .EQ. bad_res ) GOTO 200
                 IF ( com(i,j,k,l,m,n) .EQ. arg ) THEN
* ... exact equality
                    res(i,j,k,l,m,n) = 1.0
                    crossing_found = .TRUE.
                 ELSEIF ( first_pt ) THEN
* ... first non-bad value
                    first_pt = .FALSE.
                    first_lt = com(i,j,k,l,m,n) .LT. arg
                    ss1 = j
                 ELSEIF ( first_lt .EQV.
     .                    (com(i,j,k,l,m,n) .LT. arg) ) THEN
* ... still have not crossed from GT to LT or visa versa
                    ss1 = j
                 ELSE
* ... found a "crossing"
                    com1 = com(i,ss1,k,l,m,n)
                    com2 = com(i,j  ,k,l,m,n)
                    del = com2 - com1
                    res(i,ss1,k,l,m,n) = (com2-arg) / del
                    res(i,j  ,k,l,m,n) = (arg-com1) / del
                    crossing_found = .TRUE.
                ENDIF
 200         CONTINUE
 210      CONTINUE

* SEARCH ALONG Z AXIS
	ELSEIF ( idim .EQ. z_dim ) THEN
	   DO 310 n = lo_s6, hi_s6
	   DO 310 m = lo_s5, hi_s5
	   DO 310 l = lo_s4, hi_s4
	   DO 310 j = lo_s2, hi_s2
	   DO 310 i = lo_s1, hi_s1
              first_pt = .TRUE.
              crossing_found = .FALSE.
	      DO 300 k = lo_s3, hi_s3
                 res(i,j,k,l,m,n) = bad_res
                 IF ( crossing_found ) GOTO 300
                 IF ( com(i,j,k,l,m,n) .EQ. bad_res ) GOTO 300
                 IF ( com(i,j,k,l,m,n) .EQ. arg ) THEN
* ... exact equality
                    res(i,j,k,l,m,n) = 1.0
                    crossing_found = .TRUE.
                 ELSEIF ( first_pt ) THEN
* ... first non-bad value
                    first_pt = .FALSE.
                    first_lt = com(i,j,k,l,m,n) .LT. arg
                    ss1 = k
                 ELSEIF ( first_lt .EQV.
     .                    (com(i,j,k,l,m,n) .LT. arg) ) THEN
* ... still have not crossed from GT to LT or visa versa
                    ss1 = k
                 ELSE
* ... found a "crossing"
                    com1 = com(i,j,ss1,l,m,n)
                    com2 = com(i,j,k  ,l,m,n)
                    del = com2 - com1
                    res(i,j,ss1,l,m,n) = (com2-arg) / del
                    res(i,j,k,  l,m,n) = (arg-com1) / del
                    crossing_found = .TRUE.
                ENDIF
 300         CONTINUE
 310      CONTINUE

* SEARCH ALONG T AXIS
	ELSEIF ( idim .EQ. t_dim ) THEN
	   DO 410 n = lo_s6, hi_s6
	   DO 410 m = lo_s5, hi_s5
	   DO 410 k = lo_s3, hi_s3
	   DO 410 j = lo_s2, hi_s2
	   DO 410 i = lo_s1, hi_s1
              first_pt = .TRUE.
              crossing_found = .FALSE.
	      DO 400 l = lo_s4, hi_s4
                 res(i,j,k,l,m,n) = bad_res
                 IF ( crossing_found ) GOTO 400
                 IF ( com(i,j,k,l,m,n) .EQ. bad_res ) GOTO 400
                 IF ( com(i,j,k,l,m,n) .EQ. arg ) THEN
* ... exact equality
                    res(i,j,k,l,m,n) = 1.0
                    crossing_found = .TRUE.
                 ELSEIF ( first_pt ) THEN
* ... first non-bad value
                    first_pt = .FALSE.
                    first_lt = com(i,j,k,l,m,n) .LT. arg
                    ss1 = l
                 ELSEIF ( first_lt .EQV.
     .                    (com(i,j,k,l,m,n) .LT. arg) ) THEN
* ... still have not crossed from GT to LT or visa versa
                    ss1 = l
                 ELSE
* ... found a "crossing"
                    com1 = com(i,j,k,ss1,m,n)
                    com2 = com(i,j,k,l,  m,n)
                    del = com2 - com1
                    res(i,j,k,ss1,m,n) = (com2-arg) / del
                    res(i,j,k,l,  m,n) = (arg-com1) / del
                    crossing_found = .TRUE.
                ENDIF
 400         CONTINUE
 410      CONTINUE

* SEARCH ALONG E AXIS
	ELSEIF ( idim .EQ. e_dim ) THEN
	   DO 510 n = lo_s6, hi_s6
	   DO 510 l = lo_s4, hi_s4
	   DO 510 k = lo_s3, hi_s3
	   DO 510 j = lo_s2, hi_s2
	   DO 510 i = lo_s1, hi_s1
              first_pt = .TRUE.
              crossing_found = .FALSE.
	      DO 500 m = lo_s5, hi_s5
                 res(i,j,k,l,m,n) = bad_res
                 IF ( crossing_found ) GOTO 500
                 IF ( com(i,j,k,l,m,n) .EQ. bad_res ) GOTO 500
                 IF ( com(i,j,k,l,m,n) .EQ. arg ) THEN
* ... exact equality
                    res(i,j,k,l,m,n) = 1.0
                    crossing_found = .TRUE.
                 ELSEIF ( first_pt ) THEN
* ... first non-bad value
                    first_pt = .FALSE.
                    first_lt = com(i,j,k,l,m,n) .LT. arg
                    ss1 = m
                 ELSEIF ( first_lt .EQV.
     .                    (com(i,j,k,l,m,n) .LT. arg) ) THEN
* ... still have not crossed from GT to LT or visa versa
                    ss1 = m
                 ELSE
* ... found a "crossing"
                    com1 = com(i,j,k,l,ss1,n)
                    com2 = com(i,j,k,l,  m,n)
                    del = com2 - com1
                    res(i,j,k,l,ss1,n) = (com2-arg) / del
                    res(i,j,k,l,  m,n) = (arg-com1) / del
                    crossing_found = .TRUE.
                ENDIF
 500         CONTINUE
 510      CONTINUE

* SEARCH ALONG F AXIS
	ELSEIF ( idim .EQ. f_dim ) THEN
	   DO 610 m = lo_s5, hi_s5
	   DO 610 l = lo_s4, hi_s4
	   DO 610 k = lo_s3, hi_s3
	   DO 610 j = lo_s2, hi_s2
	   DO 610 i = lo_s1, hi_s1
              first_pt = .TRUE.
              crossing_found = .FALSE.
	      DO 600 n = lo_s6, hi_s6
                 res(i,j,k,l,m,n) = bad_res
                 IF ( crossing_found ) GOTO 600
                 IF ( com(i,j,k,l,m,n) .EQ. bad_res ) GOTO 600
                 IF ( com(i,j,k,l,m,n) .EQ. arg ) THEN
* ... exact equality
                    res(i,j,k,l,m,n) = 1.0
                    crossing_found = .TRUE.
                 ELSEIF ( first_pt ) THEN
* ... first non-bad value
                    first_pt = .FALSE.
                    first_lt = com(i,j,k,l,m,n) .LT. arg
                    ss1 = n
                 ELSEIF ( first_lt .EQV.
     .                    (com(i,j,k,l,m,n) .LT. arg) ) THEN
* ... still have not crossed from GT to LT or visa versa
                    ss1 = n
                 ELSE
* ... found a "crossing"
                    com1 = com(i,j,k,l,m,ss1)
                    com2 = com(i,j,k,l,m,  n)
                    del = com2 - com1
                    res(i,j,k,l,m,ss1) = (com2-arg) / del
                    res(i,j,k,l,m,  n) = (arg-com1) / del
                    crossing_found = .TRUE.
                ENDIF
 600         CONTINUE
 610      CONTINUE

	ENDIF

* always success
	DO_DIST_LOC = ferr_ok
	RETURN

	END

	SUBROUTINE CD_DEFER_COORD_WRITE(cdaxis, grid, idim, lo, hi,
     .				        axis_type)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Set variables to perform writing of netCDF axis coordinates at a later time
* (required for performance since switching between DEFINE and DATA modes
* can be so costly)

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V530 *sh* - 12/00

* argument declarations:
	INTEGER cdaxis, grid, idim, lo, hi, axis_type

* include files
        include 'cdf_tmap.parm'
        include 'xdefer_coords.cmn'
	include 'xio.cmn_text'

* local variable declarations:

	IF ( axis_type .EQ. pcd_defer_init ) THEN
* initialize the list of deferred axes
	  dfr_num = 0

	ELSE
* store info for a deferred axis coord points write
	  dfr_num = dfr_num + 1
	  dfr_cdaxis(dfr_num) = cdaxis
	  dfr_grid(dfr_num) = grid
	  dfr_idim(dfr_num) = idim 
	  dfr_lo(dfr_num) = lo
	  dfr_hi(dfr_num) = hi
	  dfr_axis_type(dfr_num) = axis_type
	ENDIF

	RETURN
	END

c*
c* ef_get_its_dsg.F
c*
c* Ansley Manke
c*  May 2020
c*
c*
c*
c* This returns a flag, its_dsg = true if the datset is
c* a discrete-sampling-geometries (DSG) datset.  If it's DSG
c* return the feature type and number of features.

	SUBROUTINE EF_GET_ITS_DSG(id, iarg, its_dsg )

	IMPLICIT NONE
	INCLUDE 'tmap_dims.parm'
	INCLUDE 'ferret.parm'
	INCLUDE 'xvariables.cmn'
	INCLUDE 'xcontext.cmn'
	include 'xtm_grid.cmn_text'
	include 'xdset_info.cmn_text'
	INCLUDE 'EF_Util.parm'

	INTEGER id, iarg
	LOGICAL its_dsg 
	
	INTEGER TM_DSG_NFEATURES, 
     .		grid, cx_list(EF_MAX_ARGS)
	LOGICAL TM_ITSA_DSG
 
c* The context list was cached by Ferret and must be retrieved
c* to be accessible to the external function. 

	CALL EF_GET_CX_LIST(cx_list)
	
	grid = cx_grid( cx_list(iarg) )
	its_dsg = TM_ITSA_DSG( grid ) 

* can call other functions such as TM_DSG_NFEATURES or TM_DSG_FACTS
* when working to optimize functions for dsg data types

	RETURN 
	END

	SUBROUTINE EW_HADVEC ( tk, mtk, uk, muk, advec, madvec )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute east-west component of heat advection

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/17/86	extracted from SUBROUTINE HDIFFUS
*			with major modifications to convert i-k oriented
*			calculations to i-j oriented calculations
* V200:  7/27/89 - 4D symmetrical version
*	10/11/89 - array declarations using XMEM_SUBSC.CMN (reordered args)

#ifdef unix
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl.parm'		! parameter definitions
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xonedim.cmn'	! geometric constants
	include 'xcontext.cmn'
#else
	INCLUDE 'FERRET_CMN:FERRET.PARM'
	INCLUDE 'FERRET_CMN:GFDL.PARM'		! parameter definitions
	INCLUDE	'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE	'FERRET_CMN:XMEM_SUBSC.CMN'
	INCLUDE 'FERRET_CMN:XONEDIM.CMN'	! geometric constants
	INCLUDE 'FERRET_CMN:XCONTEXT.CMN'
#endif

* calling argument declarations:
	INTEGER	muk, mtk, madvec
* subscript ranges from memory variable table ...
	REAL       tk( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit ),
     .		   uk( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,m2lot:m2hit ),
     .		advec( m3lox:m3hix,m3loy:m3hiy,m3loz:m3hiz,m3lot:m3hit )
	REAL fuw(2:imtp1)

* internal variable declarations:
	INTEGER	i, j, k, l
	REAL	bad_tk, bad_uk, bad_qadvec, fact1, dutdxm, tdudx

* --- end of introductory code ---
* flag for bad/missing data
	bad_tk     = mr_bad_data( mtk )
	bad_uk     = mr_bad_data( muk )
	bad_qadvec = mr_bad_data( madvec )

* south to north loop through east-west lines
	DO 2000 l = mr_lo_s4(madvec), mr_hi_s4(madvec)
	DO 2000 k = mr_lo_s3(madvec), mr_hi_s3(madvec)
	DO 1000 j = mr_lo_s2(madvec), mr_hi_s2(madvec)

	IF ( j .EQ. 1 ) THEN
	   DO 100 i = mr_lo_s1(madvec), mr_hi_s1(madvec)
 100	   advec( i,j,k,l ) = bad_qadvec
	   GOTO 1000
	ENDIF

C   FIND ADVECTIVE COEFFICIENTS FOR WEST AND EAST FACES OF T,S BOXES	! 2967

      FACT1=CSTR(j)*DYTR(j)	    				! 2969 mod
      DO 690 i = MAX(2,mr_lo_s1(madvec)), mr_hi_s1(madvec)+1	! 2972 mod
	IF ( uk( i-1,j  ,k,l ) .EQ. bad_uk
     .  .OR. uk( i-1,j-1,k,l ) .EQ. bad_uk ) THEN
	   fuw(i) = bad_val4
	ELSE
           FUW(I)=( Uk(i-1,j,k,l)  *DYU(j)
     .		 +  Uk(I-1,j-1,k,l)*DYU(j-1) )*FACT1	! 2973 mod
	ENDIF
 690  CONTINUE	    							! 2976

* calculate minus east-west advection component of total advection in flux form
      DO 820 i = mr_lo_s1(madvec), mr_hi_s1(madvec)		! 3066 mod

	IF ( i .EQ. 1  .OR. i .EQ. im ) THEN
	   advec( i,j,k,l ) = bad_qadvec
	   GOTO 820
	ENDIF
	IF ( fuw( i   )    .EQ. bad_val4
     .	.OR. fuw( i+1 )    .EQ. bad_val4
     .	.OR. tk( i  ,j  ,k,l ) .EQ. bad_tk
     .	.OR. tk( i-1,j  ,k,l ) .EQ. bad_tk
     .	.OR. tk( i  ,j-1,k,l ) .EQ. bad_tk
     .	.OR. tk( i-1,j-1,k,l ) .EQ. bad_tk ) THEN
	   advec( i,j,k,l ) = bad_qadvec
	   GOTO 820
	ENDIF

	dutdxm =  (
     *          (-FUW(I+1)*(tk(i+1,j,k,l) + tk(i  ,j,k,l))    	      ! 3067 mod
     *           +FUW(I  )*(tk(i  ,j,k,l) + tk(i-1,j,k,l)))*DXT4R(I) )! 3068 mod

* calculate individual advection component by subtracting the vector t*dU/dX 
	tdudx = tk(i,j,k,l) * (fuw(i+1) - fuw (i))*dxt4r(i)*2.0
	advec(i,j,k,l) = (dutdxm + tdudx ) * cmonthly

 820  CONTINUE	    							! 3072

 1000	CONTINUE
 2000	CONTINUE

	RETURN
	END

	subroutine getlev(z,nxs,nys,nx,ny,dz,zlev,nlev) 
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)getlev.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
c     given the array z(1...nx,1...ny) and the contour interval dz 
c     the array zlev(1...nlev) of contour levels is returned. 
c 
	dimension z(nxs,nys) 
	dimension zlev(2) 
	big=.9e35 
c 
	nfnd=0 
	do 100 i=1,nx 
	do 100 j=1,ny 
	if(z(i,j)-big)70,100,100 
70	nfnd=nfnd+1 
	if(nfnd-1)80,80,90 
80	zmin=z(i,j) 
	zmax=zmin 
90	zmin=amin1(zmin,z(i,j)) 
	zmax=amax1(zmax,z(i,j)) 
100	continue 
c 
	nlmin=zmin/dz+.5+sign(.5,zmin) 
	zlev(1)=dz*nlmin 
	do 200 k=1,51 
	zlevk=zlev(1)+(k-1)*dz 
	if(zlevk-zmax)190,210,210 
190	zlev(k)=zlevk 
200	continue 
210	nlev=k-1 
	return 
	end 

	SUBROUTINE DSFLIM
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)dsflim.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C	Subroutine called by REDSF to keep track of the maximum and
C	minimum times for the data
C
#ifdef unix
	INCLUDE 'BIBO.COM'
	INCLUDE 'AXISL.INC'
	INCLUDE 'TAXIS.INC'
	INCLUDE 'CMRD.INC'
	INCLUDE 'DATA.INC'
#else
        INCLUDE 'pplinc:BIBO.COM'
        INCLUDE 'pplinc:AXISL.INC'
        INCLUDE 'pplinc:TAXIS.INC'
        INCLUDE 'pplinc:CMRD.INC'
        INCLUDE 'pplinc:DATA.INC'
#endif
C
	INTEGER*4 MTMIN,TSTART,TSTOP,TIME
	REAL STOP(3),TEMP(3)
C
	IF(LINEN.EQ.1)THEN
	    CALL MTMDY(P(STIME),IM,ID,IY)
	    WRITE(ITMIN,999)IY,IM,ID,IFIX(P(STIME+2))
999	    FORMAT(3I2.2,I4.4)
	    IF(IAUTOT.EQ.1)ITSTRT=ITMIN
	    TSTOP=MTMIN(P(STIME))+(P(NPTS)-1)*P(SRATE)
	    CALL MINMT(TSTOP,STOP)
	    CALL MTMDY(STOP,IM,ID,IY)
	    WRITE(ITMAX,999)IY,IM,ID,IFIX(STOP(3))
	ELSE
	    TSTART=MTMIN(P(STIME))
	    TSTOP=TSTART+(P(NPTS)-1)*P(SRATE)
	    CALL MINMT(TSTOP,STOP)
C
C	FIND TIME RANGE MINIMUM
C
	    READ(ITMIN,999)IY,IM,ID,IHR
	    CALL MDYMT(TEMP,IM,ID,IY)
	    TEMP(3)=IHR
	    TIME=MTMIN(TEMP)
	    IF(TSTART.LT.TIME)THEN
		CALL MTMDY(P(STIME),IM,ID,IY)
		WRITE(ITMIN,999)IY,IM,ID,IFIX(P(STIME+2))
	    ENDIF
	    READ(ITMAX,999)IY,IM,ID,IHR
	    CALL MDYMT(TEMP,IM,ID,IY)
	    TEMP(3)=IHR
	    TIME=MTMIN(TEMP)
	    IF(TSTOP.GT.TIME)THEN
		CALL MTMDY(STOP,IM,ID,IY)
		WRITE(ITMAX,999)IY,IM,ID,IFIX(STOP(3))
	    ENDIF
	ENDIF
	RETURN
	END

	SUBROUTINE CD_CONVENTIONS_OUT(append, cdfid, string, status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Put a "conventions" attribute into the current netCDF output file

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP

* 7/2007 from CD_STAMP_OUT
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* argument definitions:
*       append  - logical control to create or append
*       cdfid   - returned pointer to open CDF file
*       string  - conventions string to add
*	status	- return status

* argument declarations:
        LOGICAL  append
	INTEGER	 cdfid, status
        CHARACTER*(*) string

* include files
        include 'netcdf.inc'
        include 'tmap_errors.parm'
        include 'cd_lib.parm'

* local variable declarations:

      INTEGER TM_LENSTR1, STR_SAME, TM_LOC_STRING, 
     .        clen, slen, ioc, loc, appnd
      LOGICAL CD_GET_ATTRIB, got_it, do_warn, append_flag
      PARAMETER (do_warn = .TRUE. )
      CHARACTER*132 buff
      CHARACTER*1 nl

* initialize
      slen = MIN( TM_LENSTR1(string), 120 )


* append flag will be set as follows:
c      appnd =  1 ! to append
c      appnd =  0 ! to write the string sent in
c      appnd = -1 ! to write altered history string

      appnd = 0
      append_flag = .TRUE.

* update (or create) conventions record
      got_it = CD_GET_ATTRIB( cdfid, NCGLOBAL, 'Conventions',
     .                     .NOT.do_warn, ' ', buff, clen, 132 )

* is the last conventions attribute the same as this ?
      IF ( clen .GE. slen ) THEN
         IF ( buff(clen-slen+1:clen) .EQ. string(:slen) ) RETURN
      ENDIF
      
* is the last conventions attribute just a "CF-xx?
* If so just replace with the current string  ...
      append_flag = append
      IF ( STR_SAME (buff(1:3), 'CF-') .EQ.0 .AND.
     .     clen .LE. 12 ) THEN
        appnd = 0
        append_flag = .FALSE.

      ELSE

* does the last history end with a CF-xx ?
* If so just replace with the current CF-xx...

         append_flag = append
         ioc = 0
         loc = TM_LOC_STRING(buff,'CF-',ioc)
         IF ( loc .GT. 1 ) THEN
	    buff = buff(:loc-1)//', '//string(:slen)
	    appnd = -1
	    append_flag = .FALSE.
	 ENDIF
      ENDIF

* Insert new CF conventions text
* If there is a conventions att, append current one.
* For conventions, just add it with a comma.

      IF (appnd .EQ. 1) THEN
         CALL CD_WRITE_ATTRIB(cdfid, pcdf_global, 'Conventions', 
     .                     ', '//string(:slen),
     .                     append_flag, status )
      ELSE IF (appnd .EQ. 0) THEN
         CALL CD_WRITE_ATTRIB(cdfid, pcdf_global, 'Conventions', string(:slen),
     .                     append_flag, status )
      ELSE IF (appnd .EQ. -1) THEN
         slen = TM_LENSTR1(buff)
         CALL CD_WRITE_ATTRIB(cdfid, pcdf_global, 'Conventions', buff(:slen),
     .                     append_flag, status )
      ENDIF

      IF ( status .NE. merr_ok ) GOTO 5000

* successful completion
      status = merr_ok
*      RETURN

* error exit
 5000 RETURN
	END

	CHARACTER*(*) FUNCTION TM_SECS_TO_DATE ( num_secs, cal_id )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Will convert secs since 01-JAN-0000 00:00:00 to a date of the form
* yyyy-mm-dd hh:mm:ss
*
* Written 6/16/87 By Mark Verschell for PMEL/TMAP
*
* revision 0.00 - 06/16/87 - Initial Incarnation
* revision 0.10 - 09/19/88 - changed function to CHAR*(*) from CHAR*20 and now
*			     write to temp string to get around 20 character
*			     minimum length needed for date output
* revision 1.00 - 02/09/89 - Completely rewritten eliminating all if-tests,
*			     loops, and goto's.
* revision 2.00 - 02/20/89 - Rewritten - subtract year 0 - claculate from there
*			     year 0 special case - readded logical leap test
*			     Added some error handling (STOP's)

* V510 5/00 *sh* - trap attempt to translate a date before 0000
* V530: *acm* 12/00 add calendar types; cal_id.  This routine is from
*       Jerry's tm_calendars_secs_to_date
*       *acm* 3/01  Treat Julian calendar as a separate case.
*       *ACm* 4/24/01 INT(tot_days/366. + 307./366.)  is 0 under linux,
*                     when the expression is 1.  Use simple IF test on
*		      tot_days instead to see if we're before or after day 59.
* V692 *acm* 10/14 Trap errors in year, month, day etc before making the string 
* V693 *acm* 11/13 back off previous change. Out-of-range time info is handled
*                  elsewhere (Prev. change caused ticket 2116).
* V710  3/16 *acm* Ticket 2158: working with true monthly time axes. Pull the
*                  guts of this routine so TM_SECS_TO_YMDHMS can be called
*                  separately to return the numeric year, month, etc 

* Argument definitions
	REAL*8		num_secs
	INTEGER		cal_id

* Include files
	include 'tmap_errors.parm'
        include 'calendar.decl'
        include 'calendar.cmn'

* Local Definitions

	CHARACTER*20	tempstr
	INTEGER		year, month, day, hour, minute, second, status
	REAL		yeardays

	CALL TM_SECS_TO_YMDHMS (num_secs, cal_id, 
     .     year, month, day, hour, minute, second, status)

* trap invalid input
       IF ( num_secs .LT. 0 ) THEN
          TM_SECS_TO_DATE = '01-JAN-0000:00:00:00'
          RETURN
       ENDIF

	IF (status .NE. merr_ok) GOTO 5000

* Write the date string

C  Get calendar attributes
        CALL TM_GET_CALENDAR_ATTRIBUTES (cal_id, num_months, 
     .                      num_days, yeardays, month_names,
     .                      days_in_month, days_before_month, 
     .                      month_by_day)

	WRITE (tempstr,1000,ERR=5000) day, month_names(month), 
     .      year, hour, minute, second

1000	FORMAT(I2.2,'-',A3,'-',I4.4,' ',2(I2.2,':'),I2.2)
	TM_SECS_TO_DATE = tempstr
	GOTO 9990

* Date syntax error
 5000	CALL TM_ERRMSG (merr_erreq, status, 'TM_SECS_TO_DATE',
     .			no_descfile, no_stepfile,
     .			no_errstring, no_errstring, *9000)

 9000	STOP

* finished
9990	RETURN
	END

*
* str_replace.F
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* 8/2016
*
* Returns string with all instnces of one character replaced by a given single character.
*


      SUBROUTINE str_replace_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CHARACTER*120 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns strings with all instances of a character replaced')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_result_type(id, STRING_RETURN)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'INSTRING')
      CALL ef_set_arg_desc(id, arg, 'String variable to edit')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)
      CALL ef_set_arg_type(id, arg, STRING_ARG)
      

      arg = 2
      CALL ef_set_arg_name(id, arg, 'S1')
      CALL ef_set_arg_desc(id, arg, 'Single character to replace')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)
      CALL ef_set_arg_type(id, arg, STRING_ARG)
      
      arg = 3
      CALL ef_set_arg_name(id, arg, 'S2')
      CALL ef_set_arg_desc(id, arg, 'Single character to insert')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)
      CALL ef_set_arg_type(id, arg, STRING_ARG)


      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE str_replace_compute(id, arg_1, arg_2, arg_3, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif

      INTEGER id

      REAL arg_1(strdf, mem1lox:mem1hix, mem1loy:mem1hiy,
     .                  mem1loz:mem1hiz, mem1lot:mem1hit,
     .                  mem1loe:mem1hie, mem1lof:mem1hif)

      REAL arg_2(strdf, mem2lox:mem2hix, mem2loy:mem2hiy,
     .                  mem2loz:mem1hiz, mem1lot:mem1hit,
     .                  mem1loe:mem1hie, mem1lof:mem1hif)

      REAL arg_3(strdf, mem3lox:mem3hix, mem3loy:mem3hiy,
     .                  mem3loz:mem3hiz, mem3lot:mem3hit,
     .                  mem3loe:mem3hie, mem3lof:mem3hif)

      REAL result(strdf, memreslox:memreshix, memresloy:memreshiy, 
     .                   memresloz:memreshiz, memreslot:memreshit,
     .                   memresloe:memreshie, memreslof:memreshif)

* Ignore the Y/Z/T/E/F dimensions in the work arrays since
* they are not used and Fortran is column major

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      
      CHARACTER*2048 buff
      CHARACTER*1    c_remove, c_replace
      CHARACTER*100  err_msg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER slen, ii
      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      DO ii = X_AXIS, F_AXIS
         IF (arg_hi_ss(ii,2) - arg_lo_ss(ii,2) .GT. 1) THEN
            WRITE (err_msg,*) 'Argument 2 is a single-character string constant'
	    GOTO 999
         ENDIF
         IF (arg_hi_ss(ii,3) - arg_lo_ss(ii,3) .GT. 1) THEN
            WRITE (err_msg,*) 'Argument 3 is a single-character string constant'
	    GOTO 999
         ENDIF
      ENDDO

      CALL EF_GET_STRING_ARG_ELEMENT_6D(id, ARG2, arg_2,
     .  mem2lox, mem2lox, mem2lox, mem2lox, mem2lox, mem2lox, slen, c_remove)
      IF (slen .NE. 1) THEN
         WRITE (err_msg,*) 'Argument 2 is a single-character string constant'
         GOTO 999
      ENDIF

      CALL EF_GET_STRING_ARG_ELEMENT_6D(id, ARG3, arg_3,
     .  mem3lox, mem3lox, mem3lox, mem3lox, mem3lox, mem3lox, slen, c_replace)
      IF (slen .NE. 1) THEN
         WRITE (err_msg,*) 'Argument 3 is a single-character string constant'
         GOTO 999
      ENDIF

      n1 = arg_lo_ss(F_AXIS, ARG1)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

      m1 = arg_lo_ss(E_AXIS, ARG1)
      DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

      l1 = arg_lo_ss(T_AXIS, ARG1)
      DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         k1 = arg_lo_ss(Z_AXIS, ARG1)
         DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

            j1 = arg_lo_ss(Y_AXIS, ARG1)
            DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

               i1 = arg_lo_ss(X_AXIS, ARG1)
               DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

                  CALL EF_GET_STRING_ARG_ELEMENT_6D(id, ARG1, arg_1,
     .                    i1, j1, k1, l1, m1, n1, slen, buff)
                  IF (slen .LE. 0) THEN
                     CALL EF_PUT_STRING(buff, slen, result(1,i,j,k,l,m,n))
                  ELSE
                     CALL REPLACE_LETTER(buff, slen, c_remove, c_replace)
                     CALL EF_PUT_STRING(buff, slen, result(1,i,j,k,l,m,n))
                  ENDIF

                  i1 = i1 + arg_incr(X_AXIS,ARG1)
 100           CONTINUE

               j1 = j1 + arg_incr(Y_AXIS, ARG1)
 200        CONTINUE

            k1 = k1 + arg_incr(Z_AXIS, ARG1)
 300     CONTINUE

         l1 = l1 + arg_incr(T_AXIS, ARG1)
 400  CONTINUE

         m1 = m1 + arg_incr(E_AXIS, ARG1)
 500  CONTINUE

         n1 = n1 + arg_incr(F_AXIS, ARG1)
 600  CONTINUE

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
 999  CALL ef_bail_out (id, err_msg)

      END

      SUBROUTINE REPLACE_LETTER(buff, slen, c_remove, c_replace)

      INTEGER slen
      CHARACTER*1 buff(*), c_remove, c_replace

      INTEGER i

      DO i = 1, slen
         IF (buff(i) .EQ. c_remove) buff(i) = c_replace
      ENDDO

      RETURN
      END

	SUBROUTINE PLOTT7(X,Y,XFACT,YFACT,MPEN,MARK) 
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)plott7.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C 
C v6.3 *acm* Fix bug 1668: The thick tics disappear due to pixel aliasing
C            on some long-time-axis plots. Instead use the thick line type
C            for these tics.  
C 
C     THIS ROUTINE DRAWS A LINE FROM THE PEN'S CURRENT 
C     POSITION AND THEN MAKES A MARK.  SEE PLOT ROUTINE IN 
C     COMPLOT DOCUMENTATION.  THIS SUBROUTINE IS THE SAME 
C     AS PLOT EXCEPT THAT SOME OF THE MARKS HAVE BEEN 
C     IMPROVED AND WE NEED TO SPECIFY XFACT AND YFACT. 
C 
C     THE MARKS, MARK=-3,-4,-5,-6,-7,-8 ARE ENLARGEMENTS OF THE 
C     MARKS, MARK=3,4,5,6,7,8. 
C 
        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'lines_inc.decl'
        include 'LINES.INC'
        INCLUDE 'pen_inc.decl'  ! with num_line_colors
        INCLUDE 'PEN.INC'
        include 'tics_inc.decl'
	include 'TICS.INC'

	integer ithick

	ithick = num_line_colors + 1

	CALL PLOT(X,Y,MPEN,0) 
	CALL VECTRS 
	MMARK=-MARK 
	TY=TLY
	TX=TLX
	GO TO(100,100,100,100,500,600,700,800,900,1100),MMARK 
100	STOP 'MARK' 
C     TO DRAW HORIZONAL TIC OF LENGTH 0.125 AT (X,Y). 
500	TY=TSMY
C     TO DRAW HORIZONAL TIC OF LENGTH 0.25 AT (X,Y). 
600	IF(IY.NE.0)THEN 
	    CALL PLOT(X+IY*TY*.5/XFACT,Y,MPEN,0) 
	ELSE 
	    CALL PLOT(X-TY*.5/XFACT,Y,MPEN,0) 
	    CALL PLOT(X+TY*.5/XFACT,Y,MPEN,0) 
	END IF 
	GOTO 1000
C 
C     TO DRAW VERTICAL TIC OF LENGTH 0.125 AT (X,Y). 
700	TX=TSMX
C     TO DRAW VERTICAL TIC OF LENGTH 0.25 AT (X,Y). 
800	IF(IX.NE.0)THEN 
	    CALL PLOT(X,Y+IX*TX*.5/YFACT,MPEN,0) 
	ELSE 
	    CALL PLOT(X,Y-TX*.5/YFACT,MPEN,0) 
	    CALL PLOT(X,Y+TX*.5/YFACT,MPEN,0) 
	END IF 
	GOTO 1000
C	TO DRAW TRIPLE THICK LARGE X TIC
900	DX=0.005/XFACT
        DX = 0.
	DY=TX*0.5/YFACT
	CALL COLOR(ithick)
	IF(IX.NE.0)THEN
	    CALL PLOT(X,Y+IX*DY,IPEN,0)
	    CALL PLOT(X-DX,Y+IX*DY,IPEN,0)
	    CALL PLOT(X-DX,Y,IPEN,0)
	    CALL PLOT(X+DX,Y,IPEN,0)
	    CALL PLOT(X+DX,Y+IX*DY,IPEN,0)
	    CALL PLOT(X,Y+IX*DY,IPEN,0)
	ELSE
	    CALL PLOT(X,Y-DY,IPEN,0)
	    CALL PLOT(X-DX,Y-DY,IPEN,0)
	    CALL PLOT(X-DX,Y+DY,IPEN,0)
	    CALL PLOT(X+DX,Y+DY,IPEN,0)
	    CALL PLOT(X+DX,Y-DY,IPEN,0)
	    CALL PLOT(X,Y-DY,IPEN,0)
	    CALL PLOT(X,Y+DY,IPEN,0)
	ENDIF
	CALL COLOR(1)
	GOTO 1000
C	TO DRAW TRIPLE THICK LARGE Y TIC
1100	DY=0.005/YFACT
        DY = 0.
	DX=TY*0.5/XFACT
	CALL COLOR(ithick)
	IF(IY.NE.0)THEN
	    CALL PLOT(X+IY*DX,Y,IPEN,0)
	    CALL PLOT(X+IY*DX,Y-DY,IPEN,0)
	    CALL PLOT(X,Y-DY,IPEN,0)
	    CALL PLOT(X,Y+DY,IPEN,0)
	    CALL PLOT(X+IY*DX,Y+DY,IPEN,0)
	    CALL PLOT(X+IY*DX,Y,IPEN,0)
	ELSE
	    CALL PLOT(X-DX,Y,IPEN,0)
	    CALL PLOT(X-DX,Y-DY,IPEN,0)
	    CALL PLOT(X+DX,Y-DY,IPEN,0)
	    CALL PLOT(X+DX,Y+DY,IPEN,0)
	    CALL PLOT(X-DX,Y+DY,IPEN,0)
	    CALL PLOT(X-DX,Y,IPEN,0)
	    CALL PLOT(X+DX,Y,IPEN,0)
	ENDIF
	CALL COLOR(1)
1000	CALL PLOT(X,Y,IPEN,0) 
	RETURN 
	END 

*
* pt_in_poly.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

** Ansley Manke
* January 2008
*
* This function implements the pnpoly code from W. Randolph Franklin found
* in his web pages. The exact code from these web pages is preserved at the end of
* this file; changes to it are the responsibility of Ferret program developers.

* Copyright (c) 1970-2003, Wm. Randolph Franklin
*
* Permission is hereby granted, free of charge, to any person obtaining a 
* copy of this software and associated documentation files (the "Software"), 
* to deal in the Software without restriction, including without limitation 
* the rights to use, copy, modify, merge, publish, distribute, sublicense, 
* and/or sell copies of the Software, and to permit persons to whom the 
* Software is furnished to do so, subject to the following conditions:

*  1. Redistributions of source code must retain the above copyright notice, 
* this list of conditions and the following disclaimers.
*   2. Redistributions in binary form must reproduce the above copyright 
* notice in the documentation and/or other materials provided with the 
* distribution.
*   3. The name of W. Randolph Franklin may not be used to endorse or 
* promote products derived from this Software without specific prior 
* written permission. 
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
* THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS 
* IN THE SOFTWARE. 
*
C W. Randolph Franklin
C http://www.ecse.rpi.edu/Homepages/wrf/pmwiki/
C http://www.ecse.rpi.edu/Homepages/wrf/Research/Short_Notes/pnpoly.html#The%20C%20Code
C http://www.ecse.rpi.edu/Homepages/wrf/Research/Short_Notes/pnpoly.html#Fortran%20Code%20for%20the%20Point%20in%20Polygon%20Test

C  RETURNS:
C           -1 IF THE POINT IS OUTSIDE OF THE POLYGON, 
C            0 IF THE POINT IS ON AN EDGE OR AT A VERTEX, 
C            1 IF THE POINT IS INSIDE OF THE POLYGON. 

***********************************************************************
*  Initialize the function

      SUBROUTINE pt_in_poly_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

      CHARACTER*100 fcn_desc
      WRITE (fcn_desc, 10)
   10 FORMAT 
     . ('Return -1 outside, 0 if on edge, 1 if inside polygon')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)

      CALL ef_set_num_work_arrays(id, 4)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_desc(id, arg, 
     .  'Variable on the XY grid and region to be tested')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'XVERT')
      CALL ef_set_arg_desc(id, arg, 
     .   'X-coordinates of vertices of polygon')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'YVERT')
      CALL ef_set_arg_desc(id, arg, 
     .   'Y-coordinates of vertices of polygon')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      RETURN 
      END

***********************************************************************

* Request an amount of storage to be supplied by Ferret and passed
* as additional arguments.

      SUBROUTINE pt_in_poly_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

*
* Set the work array X/Y/Z/T dimensions

      INTEGER array_num, nx, ny, nv
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

* These are going to be a double precision array, to contain axis 
* coordinates so allocate 2* the size of the axes

      nx = 2*( arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 1 )
      ny = 2*( arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1) + 1 )

      array_num = 1
      CALL ef_set_work_array_dims(id, array_num, 1,1,1,1, nx,1,1,1)
      array_num = 2
      CALL ef_set_work_array_dims(id, array_num, 1,1,1,1, ny,1,1,1)

* Set two arrays the size of the number of vertices.

      nv = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1 
      nv = MAX(nv, arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) + 1 )
      nv = MAX(nv, arg_hi_ss(Z_AXIS,ARG2) - arg_lo_ss(Z_AXIS,ARG2) + 1 )
      nv = MAX(nv, arg_hi_ss(T_AXIS,ARG2) - arg_lo_ss(T_AXIS,ARG2) + 1 )
      array_num = 3
      CALL ef_set_work_array_dims(id, array_num, 1,1,1,1, nv,1,1,1)
      array_num = 4
      CALL ef_set_work_array_dims(id, array_num, 1,1,1,1, nv,1,1,1)

      RETURN 
      END

* **********************************************************************

      SUBROUTINE pt_in_poly_compute (id, arg_1, arg_2, arg_3, result, 
     .   xcoords, ycoords, workx, worky)
C 
C REMARKS 
C   THE VERTICES MAY BE LISTED CLOCKWISE OR ANTICLOCKWISE. 
C   THE FIRST MAY OPTIONALLY BE REPEATED, IF SO N MAY 
C   OPTIONALLY BE INCREASED BY 1. 
C   THE INPUT POLYGON MAY BE A COMPOUND POLYGON CONSISTING 
C   OF SEVERAL SEPARATE SUBPOLYGONS. IF SO, THE FIRST VERTEX 
C   OF EACH SUBPOLYGON MUST BE REPEATED, AND WHEN CALCULATING 
C   N, THESE FIRST VERTICES MUST BE COUNTED TWICE. 
C   INOUT IS THE ONLY PARAMETER WHOSE VALUE IS CHANGED. 
C   THE SIZE OF THE ARRAYS MUST BE INCREASED IF N > MAXDIM 
C   WRITTEN BY RANDOLPH FRANKLIN, UNIVERSITY OF OTTAWA, 7/70. 
C   
C SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED 
C   NONE 
C 
C METHOD 
C   A VERTICAL LINE IS DRAWN THRU THE POINT IN QUESTION. IF IT 
C   CROSSES THE POLYGON AN ODD NUMBER OF TIMES, THEN THE 
C   POINT IS INSIDE OF THE POLYGON. 
C 
C .................................................................. 
C 
      

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, 
     .           mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, 
     .           mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit)
      REAL*8 xcoords(wrk1lox:wrk1hix)
      REAL*8 ycoords(wrk2lox:wrk2hix)
      REAL workx(wrk3lox:wrk3hix)
      REAL worky(wrk4lox:wrk4hix)

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      INTEGER n, i,j,k,l, i1,j1, ii,jj, iarg
      LOGICAL MX,MY,NX,NY 

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* Get the x and y coordinates of the input variable

      iarg = 1
      CALL ef_get_coordinates (id, iarg, X_AXIS, 
     .       arg_lo_ss(X_AXIS, ARG1), arg_hi_ss(X_AXIS, ARG1), xcoords)
      CALL ef_get_coordinates (id, iarg, Y_AXIS, 
     .       arg_lo_ss(Y_AXIS, ARG1), arg_hi_ss(Y_AXIS, ARG1), ycoords)

! Size of the list of polygon vertices

      nv = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1 
      nv = MAX(nv, arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) + 1 )
      nv = MAX(nv, arg_hi_ss(Z_AXIS,ARG2) - arg_lo_ss(Z_AXIS,ARG2) + 1 )
      nv = MAX(nv, arg_hi_ss(T_AXIS,ARG2) - arg_lo_ss(T_AXIS,ARG2) + 1 )

* Get the bounding box around the polygon. Do not check points if they are
* outside this bounding box
 
      xvmin = ABS( bad_flag(ARG3) )
      xvmax = -1*xvmin
      yvmin = ABS( bad_flag(ARG4) )
      yvmax = -1*yvmin

      CALL POLY_BOUND_BOX(arg_2, arg_3, nv, xvmin, xvmax, yvmin, yvmax)

* Loop over all points, checking if they are inside or outside the polygon.

      k = res_lo_ss(Z_AXIS)
      l = res_lo_ss(T_AXIS)

      i1 = arg_lo_ss(X_AXIS,ARG1)
      DO 200 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
         PX = xcoords(i1) 

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 100 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            PY = ycoords(j1)

            IF (px .GE. xvmin .AND. px .LE. xvmax .AND.
     .          py .GE. yvmin .AND. py .LE. yvmax ) THEN
               CALL PNPOLY (px, py, arg_2, arg_3, nv, 
     .                      workx, worky, inout )
               result(i,j,k,l)= FLOAT(inout)
            ELSE
               result(i,j,k,l) = -1
            ENDIF

      j1 = j1 + arg_incr(Y_AXIS,ARG1)
 100  CONTINUE

      i1 = i1 + arg_incr(X_AXIS,ARG1)
 200  CONTINUE

      RETURN 
      END

	SUBROUTINE RECONCILE_COM_DST_CX( com_cx, dst_cx, protected_ax )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* The component context is fully fleshed out (necessarily, since
* the component has already been obtained) whereas the destination (result)
* context may still have some unknown axis limits.  So pass the component
* information over to the destination on all except the critical axis
* on which the transformation/regrid, etc is about to be performed

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V420: 11/95 - code lifted from IS_REGRID **including warnings about untested
*			alternatives**
* V530: *sh* 3/01 - bug fix: preserve cx_has_impl_grid
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'xcontext.cmn'

* calling argument declarations:
	INTEGER	com_cx, dst_cx, protected_ax

* local variable declarations
	LOGICAL has_impl

* Make the destination context like the source data context on all except
* the regrid axis.  That one keeps the user-requested size.
* (Other axes may have been modified by information embedded within a
* user-variable definition.  An alternative (untested 8/89) approach is to
* call PASS_AMBIG_LI** for uvars)

* save the implicit grid status of the destination
	has_impl = cx_has_impl_grid(dst_cx)

	CALL TRANSFER_CONTEXT( com_cx, cx_buff )

	CALL TRANSFER_AXIS( protected_ax, dst_cx, cx_buff )

	CALL TRANSFER_CONTEXT( cx_buff, dst_cx )

* restore the implicit grid status of the destination
	cx_has_impl_grid(dst_cx) = has_impl

	RETURN
	END	

*
* element_index_str_n.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* July 2005
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
*
*  Return index value in LIST for each grids point in V, or a
*  missing value wherever there is no match)
*
*   3/12 *kms* Give index into unraveled arg_2 instead of just I index of arg_2;
*              increased max string length compared from 20 to 128;
*              add check for string lengths .GT. 0;
*              and add E and F dimensions

*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE element_index_str_n_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CHARACTER*100 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT (
     .'Return index value in ARG2 for each string in ARG1 ',
     .'(case sensitive matching)')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 2)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)


      arg = 1
      CALL ef_set_arg_name(id, arg, 'VAR')
      CALL ef_set_arg_desc(id, arg, 'string data to mask')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)
      CALL ef_set_arg_type (id, arg, STRING_ARG)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'STRINGS')
      CALL ef_set_arg_desc(id, arg, 'list of strings to match')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)
      CALL ef_set_arg_type (id, arg, STRING_ARG)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE element_index_str_n_compute(id, arg_1, arg_2, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif

      INTEGER id

      REAL arg_1(strdf,
     .           mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(strdf,
     .           mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result


***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      INTEGER arg, ndx
      INTEGER i, j, k, l, m, n
      INTEGER i2, j2, k2, l2, m2, n2
      INTEGER slen1, slen2
      CHARACTER text1*128, text2*128


      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

C  Check for strings matching arg2
C  Assumes result and arg_1 have same array dimension limits

      DO 300 n=res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
      DO 300 m=res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
      DO 300 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
      DO 300 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
      DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
      DO 300 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         arg = 1
         CALL ef_get_string_arg_element_6d(id, arg, arg_1, 
     .                      i, j, k, l, m, n, slen1, text1)
 
         ndx = 1
         DO 100 n2=arg_lo_ss(F_AXIS,ARG2), arg_hi_ss(F_AXIS,ARG2)
         DO 100 m2=arg_lo_ss(E_AXIS,ARG2), arg_hi_ss(E_AXIS,ARG2)
         DO 100 l2=arg_lo_ss(T_AXIS,ARG2), arg_hi_ss(T_AXIS,ARG2)
         DO 100 k2=arg_lo_ss(Z_AXIS,ARG2), arg_hi_ss(Z_AXIS,ARG2)
         DO 100 j2=arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS,ARG2)
         DO 100 i2=arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS,ARG2)
            arg = 2
            CALL ef_get_string_arg_element_6d(id, arg, arg_2, 
     .                         i2, j2, k2, l2, m2, n2, slen2, text2)
            IF ( slen1 .GT. 0 .AND.
     .           slen2 .GT. 0 .AND.
     .           slen1 .EQ. slen2 ) THEN
              IF ( text1(:slen1) .EQ. text2(:slen2) ) THEN
                 result(i,j,k,l,m,n) = ndx
                 GOTO 200
              ENDIF
            ENDIF
            ndx = ndx + 1
 100     CONTINUE

C        If we got here it was not found
         result(i,j,k,l,m,n) = bad_flag_result

 200     CONTINUE

 300  CONTINUE
 
      RETURN
      END
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

        PROGRAM DRWFNT
        CHARACTER FONT(21)*2,NUM*6,STR*4,NAME(21)*30,NME*30
        CHARACTER NA*7,CCHR*1
        BYTE BCHR
        EQUIVALENCE (BCHR,CCHR)
        DATA FONT/'SR','DR','TR','CR','AS','AC','CS','TI','GE',
     *  'IR','SS','CI','II','SG','CG','IG','GG','GI',
     *  'CC','AR','AG'/
        DATA NAME/'Simplex Roman','Duplex Roman','Triplex Roman',
     *  'Complex Roman','ASCII Simplex Roman','ASCII Complex Roman',
     *	'Complex Script','Triplex Italic',
     *  'Gothic English','Indexical Complex Roman',
     *  'Simplex Script','Complex Italic',
     *  'Indexical Complex Italic','Simplex Greek','Complex Greek',
     *  'Indexical Complex Greek','Gothic German','Gothic Italian',
     *  'Complex Cyrillic','Cartographic Roman',
     *  'Cartographic Greek'/
        DATA NA/'@SRn.a.'/
        OPEN(5,FILE='TI:',STATUS='UNKNOWN')
        CALL PLTYPE(0)
        CALL SIZE(10.5,8.2)
        SZE=0.21
        DO 100 IFNT=21,1,-1
        CALL ERASE
C
C       DRAW BOX
C
        X=5.5
        Y1=8.25
        Y2=0.25
        DO 110 I=1,7
        CALL PLOT(Y1,X,0,0)
        CALL PLOT(Y2,X,1,0)
        X=X-0.75
        IF(Y1.EQ.0.25)THEN
                Y2=Y1
                Y1=8.25
        ELSE
                Y2=Y1
                Y1=0.25
        ENDIF
110     CONTINUE
        Y=8.25
        X1=5.5
        X2=1.0
        DO 120 I=1,17
        CALL PLOT(Y,X1,0,0)
        CALL PLOT(Y,X2,1,0)
        Y=Y-0.5
        IF(X1.EQ.1.0)THEN
                X2=X1
                X1=5.5
        ELSE
                X2=X1
                X1=1.0
        ENDIF
120     CONTINUE
C
C       DRAW CHARACTERS
C
        WRITE(STR,999)FONT(IFNT)
999     FORMAT('@',A2)
        WRITE(NME,997)NAME(IFNT)
997     FORMAT('@SR',A25)
        CALL SYMBEL(8.35,5.5,-90.0,.14,28,NME)
        DO 130 I=1,6
        DO 130 J=1,16
        ICH=(I-1)*16+J+31
        X=5.5-(I-1)*0.75
        Y=8.25-J*0.5
        IF((IFNT.NE.5.AND.IFNT.NE.6).AND.
     *	    (ICH.EQ.92.OR.ICH.EQ.94.OR.ICH.EQ.95.OR.ICH.EQ.64))THEN
                S=X-0.375+SYMWID(.10,7,NA)*0.5
                CALL SYMBEL(Y+0.2,S,-90.,.10,7,NA)
        ELSE
                STR(4:4)=CHAR(ICH)
                WRITE(NUM,998)ICH
998             FORMAT('@SR',I3)
                CALL SQUISH(NUM,1,6)
                CALL SYMBEL(Y+0.4,X-0.02,-90.,0.07,6,NUM)
                S=X-0.37+SYMWID(SZE,4,STR)*0.5
                CALL SYMBEL(Y+0.15,S,-90.,SZE,4,STR)
        ENDIF
130     CONTINUE
        CALL PLTEND
100     CONTINUE
        CALL EXIT
        END

	INTEGER FUNCTION GRID_FROM_NAME_XML(lc_name, dflt_cx, cx_expr, 
     .       status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* given a name which may be the name of a grid or the name of a variable
* with possible data set and grid name modifiers return a grid number

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 7/29/88
* V200:  4/27/90 - bug fix: status not set on successful return
* Unix/RISC port - 11/1/91: bug fix: status not checked returning from
*                           PARSE_NAM_DSET_GRD.  "SHOW GRID T" blew up.
* V300: 2/93 - return unspecified if error exit (caught by f77 3.2)
* V500 7/98 *sh* - allow case-sensitive variable names in single quotes 
*      3/99 *sh* - disallow implicit grids (e.g. "Z[gz=zax]")
* V532 5/01 *sh* - use EVAL_CONTEXT to get grid of expression
* 1/03 *kob* g77 port requires risc buff for arbitrary string concats
* v552: 4/03 *acm*  Increase length of variable names to 128 characters
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include 'xrisc_buff.cmn'

* calling argument declarations:
	INTEGER		dflt_cx, cx_expr, status
	CHARACTER*(*)	lc_name

* local variable declarations:
	INTEGER		STR_UPCASE, TM_GET_GRIDNUM,
     .			vax_code, grid
	CHARACTER	name*128

* change it to upper case
	vax_code = STR_UPCASE( name, lc_name )

* try to identify it first as a grid name
	grid = TM_GET_GRIDNUM( name )
	IF ( grid .NE. unspecified_int4 ) GOTO 1000
	
* prepare a clean context to work from
	CALL INIT_EMPTY_CONTEXT(cx_buff)
	cx_data_set( cx_buff ) = cx_data_set( cx_last )

* get the grid for a variable or expression
	CALL EVAL_CONTEXT ( cx_buff, lc_name, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	grid = cx_grid(is_cx(1))
        cx_expr = is_cx(1)

* success
 1000	GRID_FROM_NAME_XML = grid
	status = ferr_ok
	RETURN

* error exit(s)
 5000	GRID_FROM_NAME_XML = unspecified_int4     ! added 2/93
  	RETURN
 5100	risc_buff = lc_name
	CALL ERRMSG(ferr_invalid_command, status,
     .			'disallowed usage of '//risc_buff, *5000)

	END

	SUBROUTINE TEK4107_LINE_BUNDLE (zwsid)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Routine to set up the line bundles for tek4107's
*	J Davison JISAO/PMEL/TMAP 3.23.89
*	*jd* mod to support atc gks                                                                         
#ifdef unix
	include		'gkscm2.cmn'
#else
	INCLUDE		'tmap_pplv11inc:tmap_gkscm2.inc'
#endif

#ifdef atc_gks
#   ifdef unix
	include        'gkspar.inc'
#   else
	INCLUDE        'atc_gksdir:gkspar.inc'
#   endif
#else
#   ifdef unix
  	include        'gkspar.inc'
#   else
  	INCLUDE        'sys$library:gksdefs.bnd'
#   endif
#endif

	integer		zwsid,ndx,fktr
	integer		index(6)
	data		index /1,3,6,9,11,13/

C	data statement above added 12.96 *jd* for linux port

*******************************************************************************

*	TEK4107 HAS LIMITED COLOR INDICES -- USE AVAILABLE COLORS
	do 20 ndx = 1,6
	   do 10 fktr = 1,3
	      call gsplr (zwsid,(fktr-1)*6+ndx,1,real(fktr),index)
10	   continue
20	continue

	return
	end

	INTEGER FUNCTION GET_VAR_GRID
     .		      ( full_var_name, 
     .			default_cx,
     .			var_cx,
     .			status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* given a full variable specification of the form:
*			(eg.) TEMP[X=170E:170W:2]
* return the grid, only, of the result

* this routine extracted (by quick hack) from GET_VAR_CONTEXT so that GC
* variables can determine their grids in advance of determining inheritance
* for their arguments

* V510: 1/00 *sh**
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'

* calling argument declarations:
	INTEGER		default_cx, var_cx, status
	CHARACTER*(*)	full_var_name

* internal variable declarations:
	INTEGER		mods_cx

* initialize
	CALL TRANSFER_CONTEXT ( default_cx, var_cx )

* find a context slot for the modifications that may be attached to the var name
	CALL STACK_PTR_UP ( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	mods_cx = cx_stack_ptr
	CALL INIT_CONTEXT_MODS ( mods_cx )

* get variable and attached modifications
	CALL PARSE_VAR_NAME ( full_var_name, var_cx, mods_cx, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* 8/99 If G=unknown_user_var was given then exit now.
* It is recognizable because the text position is encoded in the grid number.
* This should happen ONLY when this is called from IS_UVAR_GRID
	IF ( cx_unstand_grid(var_cx)
     . .AND. cx_grid(var_cx) .LT. unspecified_int4 ) GOTO 5100

* determine the defining grid
	CALL GET_CONTEXT_GRID ( var_cx, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* can't do more if the grid isn't known
	IF ( cx_grid(var_cx) .EQ. unspecified_int4 ) THEN
	   GOTO 5100
	ELSE
	   GET_VAR_GRID = cx_grid(var_cx)
	ENDIF

* relinquish the stack space used for the modifications
 100	CALL STACK_PTR_DN ( cx_stack_ptr, cx_stack_ptr_base, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	RETURN

* error exit
 5000	RETURN
 5100	CALL ERRMSG( ferr_unknown_grid, status, full_var_name, *5000 )
	END

	SUBROUTINE INIT_T_AGGREGATE_DSET(mem_filename_list,
     .			nagfiles, have_expr,
     .			dset_name, dset_path, dset_title,
     .			t_regular, use_strict, dset_num, status)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* assemble the needed arguments and call DEFINE_T_AGG_MC_DSET
* a close cousin of this routine is DEFINE_T_AGGREGATION, which similarly
* assembles the arguments, but is intended to for calling from Python
* Whereas Python has the option to supply the time axis metadata of each
* file to be aggregated, herein we will always need to glean that information
* by opening each file

* the incoming command syntax may be
*    DEFINE DATA/AGGREGATE/<dim>  agname = file1, file2, file3, ...
*  or
*    DEFINE DATA/AGGREGATE/<dim>  agname = <string_expression>


* admittedly, the hierarchy of calling names is not self-evident.  They are:
* top level: INIT_T_AGGRETATE_DSET  and DEFINE_T_AGGREGATION (for Python)
*   ==> DEFINE_T_AGG_MC_DSET
*       ==> BUILD_T_AGG_AXIS
*       ==> INIT_T_AGG_MC_DSET

* V695+ *sh* 11/15 new routine 
* V698 *sh* 1/16  pass explicit path name (for "USE file.agg" compatibility)
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.

* arguments:
*	mem_filename_list - if have_expr, the variable of names (input)
*	nagfiles	- number of files in the aggregation (input)
*       have_expr	- flag if filenames were listed or in an expr (input)
*	dset_name	- dataset name to assign to the aggregation (input)
*	dset_path	- path name to assign to the aggregation (input)
*	dset_title	- dataset title (input)
*  t_regular (not implemented)	- flag to promise regular timesteps (input)
*	use_strict	- flag to allow micro-adjustments of T axis (input)
*	dset_num	- number assigned to this data set (output)
*	status		- return status (output)
*

* these are the arrays that need to be created
*	memb_filename	 - array of member filenames (input)
*	memb_tstep_start - array of first timestep in each file (input)
*	memb_tstep_end   - array of last  timestep in each file (input)
*	memb_nstep	 - array of N timesteps in each file (input)


        include 'tmap_dims.parm'
	include 'ferret.parm'
        include 'errmsg.parm'
	include 'xprog_state.cmn'
	include 'xvariables.cmn'   ! for is_mr

* Argument definitions
	LOGICAL		have_expr, t_regular, use_strict
	INTEGER		nagfiles, dset_num, status
	CHARACTER*(*)	dset_name, dset_path, dset_title
	REAL		mem_filename_list(*)

* Internal declarations
	INTEGER	iset, slen, max_str_len
	INTEGER	memb_nstep(nagfiles)
	REAL*8	memb_tstep_start(nagfiles), memb_tstep_end(nagfiles)
	CHARACTER*512 GET_STRING_ELEMENT_1D_X, memb_filename(nagfiles)

* initialize
	status = ferr_ok
	max_str_len = 512

* set up array of filenames
	IF (have_expr) THEN
*  ... filenames passed through a string variable
	  DO iset = 1, nagfiles
	    memb_filename(iset) = GET_STRING_ELEMENT_1D_X(
     .			nagfiles,
     .                  mem_filename_list,iset,
     .			max_str_len,slen )
	  ENDDO
	ELSE
*  ... filenames given by user on command line
	  DO iset = 1, nagfiles
	    memb_filename(iset) = cmnd_buff(item_start(iset):item_end(iset))
	  ENDDO
	ENDIF

* set up dummy (empty) timestep metadata arrays
	DO iset = 1, nagfiles
	   memb_nstep      (iset) = unspecified_int4
	   memb_tstep_start(iset) = unspecified_val8
	   memb_tstep_end  (iset) = unspecified_val8
	ENDDO

* now call the "real" routine
	CALL DEFINE_T_AGG_MC_DSET
     .		(dset_name, dset_path, dset_title, nagfiles,
     .		 memb_filename,
     .		 memb_tstep_start, memb_tstep_end, memb_nstep,
     .		 t_regular, use_strict, dset_num, status)


* done
	RETURN
	END

	LOGICAL FUNCTION TM_SAME_LINE_DEF ( line1, line2 )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Check to see if two lines share an identical definition
*
* by M. Verschell PMEL/TMAP
*
* revision 0.00 - 2/92 *sh* - extracted from TM_FIND_LIKE_LINE by *mv*
* netCDF support *sh* 6/92 - weakened precision of line_mem comparison
* *sh* 12/92 (for netCDF) - use TM_FPEQ to weaken start/delta check, too
*              (should probably use it in the irregular coords check, too??)
* IBM port 14apr94 *kob* : Logical expressions need to be compared
*			   using NEQV and EQV
*			 : syntax error with "val**-5", it must be
*			   "val**(-5)"
* *sh* 2/24/95 - instead of comparing the units string compare the units code
* *sh* 10/95 - slightly different check if a dynamic line
* V510 4/00 *sh* - netCDF data sets using dynamic axes and grids
* V530 10/00 *sh* - bug fix: since netCDF axes are now dynamic, the decision
*		    to bypass coordinate checking on irregular axes must be
*		    based on these be child axes, rather than being dynamic
*		  - also switched to using TM_WORLD rather than direct refs
*		    to line_mem
*      3/01 *sh* - bug fix to 10/00 bug fix ... Still need to make sure
*	            it is the *same* child of an irreg axis by checking
*	            the lo/hi/delta
* V541 2/02 *sh* - added support for line_modulo_len

* V570 5/04 *acm* - Use TM_DFPEQ to weaken  irregular coords check
* V581 *acm* 6/05 - For fix to bug 1271, add flag line_shift_origin
* V614 *acm* 10/08 - Fix bug 1595, comparisons of xx1 and -1*xx2 did
*                   not take into account that the values may be zero.

* Include files
	include 'tmap_dims.parm'
	include 'implicit.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'xtm_grid.cmn_text'
	external xgt_grid_data

* Argument definitions
	INTEGER*4	line1, line2

* Local definitions
        LOGICAL         TM_FPEQ, TM_FPEQ_SNGL, TM_DFPEQ, dynamic
	INTEGER*4	j
	REAL*8		TM_WORLD_AX, xx1, xx2
	REAL*4  asingle, bsingle

* local parameter declaration
* ... all these are somewhat arbitrary
	REAL*8	    haf_dp_eps, max_sp_compare
	PARAMETER ( max_sp_compare = 2.**24,
     .              haf_dp_eps = 10.D0**(-14) ) ! somewhat arbitrary
	REAL	    haf_sp_eps
	PARAMETER ( haf_sp_eps = 10.0**(-7) )	! somewhat arbitrary

* Same regularity/irregularity?
	  IF (line_regular(line1) .NEQV. line_regular(line2)) GOTO 1000

* Same modulo?
	  IF (line_modulo(line1) .NEQV. line_modulo(line2)) GOTO 1000

* Same modulo length?
	  IF (line_modulo(line1)) THEN
	     IF (line_modulo_len(line1) .NE. line_modulo_len(line2))
     .								GOTO 1000
	  ENDIF

* Check length
	  IF (line_dim(line1) .NE. line_dim(line2)) GOTO 1000

* Check units (2/95 - either a recognized unit code or identical strings)
	  IF (line_unit_code(line1) .NE. line_unit_code(line2)) GOTO 1000
	  IF (line_unit_code(line1) .EQ. 0 ) THEN
	     IF (line_units(line1) .NE. line_units(line2)) GOTO 1000
	  ENDIF
* Check orientation
	  IF (line_direction(line1) .NE. line_direction(line2)) GOTO 1000

* Check special values for time axis
	  IF (line_direction(line2) .EQ. 'TI') THEN
	    IF (line_t0(line2) .NE. line_t0(line1)) GOTO 1000
	    IF (line_shift_origin(line2) .NEQV. line_shift_origin(line1))
     .           GOTO 1000
	    IF (line_tunit(line2) .NE. line_tunit(line1)) GOTO 1000
	    IF (line_cal_name(line1) .NE. line_cal_name(line2)) GOTO 1000
	  ENDIF

* dynamic line info
	  dynamic = line1.GT.max_lines .OR. line2.GT.max_lines
	  IF ( line_class (line1) .NE. line_class (line2) ) GOTO 1000
	  IF ( line_parent(line1) .NE. line_parent(line2) ) GOTO 1000

* check coordinate and box locations
	  IF ( line_regular(line2)
     .	.OR.   (line_class (line1) .EQ. pline_class_stride)
     .	.OR.   (line_class (line1) .EQ. pline_class_midpt)   ) THEN
	    asingle = SNGL(line_start(line1))
	    bsingle = SNGL(line_start(line2))
            IF ( .NOT. TM_FPEQ_SNGL( asingle, bsingle ) ) GOTO 1000
	    asingle = SNGL(line_delta(line1))
	    bsingle = SNGL(line_delta(line2))
            IF ( .NOT. TM_FPEQ_SNGL( asingle, bsingle ) ) GOTO 1000
	  ELSE
* irregular lines
	    DO 100 j = 1,line_dim(line1)
* first check the grid points
	      xx1 = TM_WORLD_AX(j, line1, box_middle)
	      xx2 = TM_WORLD_AX(j, line2, box_middle)
	      IF (.NOT. TM_DFPEQ(ABS(xx1), 0.D0) ) THEN
	         IF ( TM_DFPEQ(ABS(xx1), -1*ABS(xx2)) ) GOTO 1000
              ENDIF
              IF ( ABS(xx2) .LT. max_sp_compare ) THEN
* ... single precision comparison
	         IF ( SNGL(xx2) .EQ. SNGL(xx1) ) GOTO 100
* ... they're not equal but they may be within acceptable limits
	         IF ( ABS((xx2-xx1)/(xx2+xx1)) .GT. haf_sp_eps )
     .							    GOTO 1000
              ELSE
* ... full precision comparison (needed for very large time words)
	         IF ( xx1 .EQ. xx2 ) GOTO 100
* ... they're not equal but they may be within machine accuracy
	         IF ( ABS((xx2-xx1)/(xx2+xx1)) .GT. haf_dp_eps )
     .							    GOTO 1000
              ENDIF

* now the grid cell bounds
	      xx1 = TM_WORLD_AX(j, line1, box_lo_lim)
	      xx2 = TM_WORLD_AX(j, line2, box_lo_lim)
	      IF (.NOT. TM_DFPEQ(ABS(xx1), 0.D0) )  THEN
	         IF ( TM_DFPEQ(ABS(xx1), -1*ABS(xx2)) ) GOTO 1000
              ENDIF
              IF ( ABS(xx2) .LT. max_sp_compare ) THEN
* ... single precision comparison
	         IF ( SNGL(xx2) .EQ. SNGL(xx1) ) GOTO 100
* ... they re not equal but they may be within acceptable limits
	         IF ( ABS((xx2-xx1)/(xx2+xx1)) .GT. haf_sp_eps )
     .							    GOTO 1000
              ELSE
* ... full precision comparison (needed for very large time words)
	         IF ( xx1 .EQ. xx2 ) GOTO 100
* ... they're not equal but they may be within machine accuracy
	         IF ( ABS((xx2-xx1)/(xx2+xx1)) .GT. haf_dp_eps )
     .							    GOTO 1000
              ENDIF
  100	    CONTINUE

* finally the upper limit of the top cell
	    xx1 = TM_WORLD_AX(j, line1, box_hi_lim)
	    xx2 = TM_WORLD_AX(j, line2, box_hi_lim)
	      IF (.NOT. TM_DFPEQ(ABS(xx1), 0.D0) )  THEN
	         IF ( TM_DFPEQ(ABS(xx1), -1*ABS(xx2)) ) GOTO 1000
              ENDIF
            IF ( ABS(xx2) .LT. max_sp_compare ) THEN
* ... single precision comparison
	       IF ( SNGL(xx2) .EQ. SNGL(xx1) ) GOTO 500
* ... they're not equal but they may be within acceptable limits
	       IF ( ABS((xx2-xx1)/(xx2+xx1)) .GT. haf_sp_eps )
     .							    GOTO 1000
              ELSE
* ... full precision comparison (needed for very large time words)
	       IF ( xx1 .EQ. xx2 ) GOTO 500
* ... they're not equal but they may be within machine accuracy
	       IF ( ABS((xx2-xx1)/(xx2+xx1)) .GT. haf_dp_eps )
     .							    GOTO 1000
            ENDIF

	  ENDIF

* the lines are identical
 500	  TM_SAME_LINE_DEF = .TRUE.
        RETURN

* the lines differ
 1000   TM_SAME_LINE_DEF = .FALSE.
        RETURN
	END

	SUBROUTINE SET_DEFAULT_COLORS (zwsid,zwstype,ndx_lo,range)
	
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Sets the color map between ndx_lo and ndx_hi to ws default
*	J Davison JISAO/PMEL/TMAP 8.1.89

#ifdef unix
        include         'shade_vars.cmn'
#else
        INCLUDE         'tmap_pplv11inc:tmap_shade_vars.inc'
#endif

	integer		zwsid,ndx_lo,range,ndx_hi,zwstype,err,ndx
	real		r_val,g_val,b_val

********************************************************************************

	ndx_hi	= ndx_lo + range - 1

*	SET ALL COLORS TO THE DEFAULT
	do 50 ndx = ndx_lo,ndx_hi

*	   WHAT IS THE DEFAULT COLOR FOR EACH NDX?
	   call gqpcr (zwstype,ndx,err,r_val,g_val,b_val)
	   if (err .eq. 0) then

*	   SET THE COLOR OF THIS NDX
   	      call gscr (zwsid,ndx,r_val,g_val,b_val)
	   endif
50	end do

	return
	end

	SUBROUTINE TM_CHECK_MONTHLY_AXIS (coords, npts, cal_id, t0_string, units, 
     .                                unit_string, start, delta, tunit, true_month)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* V7031 1/17 *acm* ticket 2497, Back off the auto-detection of monthly axes.


* Check time axis; if it is a monthly axis, with cells the length of the months
* in the given calendar, then we will  define it as a "true_month" calendar.

* coords	coordinate data as read from dataset
* npts		length of coordinate array
* cal_id	calendar ID
* t0_string	time origin
* units		on input, the units of the calendar, 
*                changed on output for true-month axis
* unit_string	on input, the units string for the axis, 
*                changed on output for true-month axis
* start		on input, the first coordinate value, 
*                changed on output for true-month axis
* delta		on input, not set. On output, set for a true-month axis
* tunit		time unit, e.g. 1/12 of seconds in the calendar year
* true_month	flag for true-month calendars
* line_characteristics arrays will also be adjusted


        include 'tmap_errors.parm'
        include 'tmap_dims.parm'
        external xio_data
        include 'xtm_grid.cmn_text'
        external xgt_grid_data
        include 'xunits.cmn_text'
        external xunits_data
        include 'calendar.decl'
        include 'calendar.cmn'

* Argument declarations
	LOGICAL true_month
	INTEGER npts, cal_id, units
	REAL	coords(*), start, delta, tunit
	CHARACTER*(*) t0_string, unit_string

	LOGICAL	TM_DFPEQ_TOL
	INTEGER TM_LENSTR1, STR_SAME, TM_UNIT_ID, TM_UNITS_CAL, 
     .		i, i1, istep, ndx,
     .		slen, year, month, day, zero, status
	REAL	SECS_FROM_BC, TM_SECS_FROM_BC, 
     .		secpday, secs_t0, secs_start, secs_end, secs_box,
     .		secs_box_lo, days_box, days_in_mo, epsilon
	CHARACTER TM_SECS_TO_DATE*20, TM_GET_CALENDAR_NAME*32,
     .		datestring*20, moyr*3
	
  50	FORMAT (7x, I4)

c Backing out of auto-detecting monthly calendar axes. When restoring this,
c get rid of the following statements

	true_month = .FALSE.
	RETURN


* Initialize
	
	secpday = 24*3600
	epsilon = 2.0**(-42)

	IF (npts .LE. 1) THEN
	   true_month = .FALSE.
	   RETURN
	ENDIF

	true_month = .TRUE.
	
* Seconds from 0000 to t0

	secs_t0 = SECS_FROM_BC( t0_string, cal_id, status )

	DO istep = 1, npts-1

* box low and high, in seconds using box bounds
	   ndx = istep + npts

  	   secs_start = coords(ndx)* un_convert(units)
	   secs_end = coords(ndx+1)* un_convert(units)
	   secs_box = secs_end - secs_start
	   days_box = secs_box/ secpday

* seconds from 0000 to box low 
	   secs_box_lo = secs_t0 + secs_start
	   datestring = TM_SECS_TO_DATE ( secs_box_lo, cal_id )
	
	   moyr = datestring(4:6)
	   month = 0
	   DO i = 1, cals_num_months(cal_id)
	      IF ( STR_SAME(cals_month_names(i, cal_id), moyr) .EQ. 0) THEN
	         month = i
	         EXIT  ! month found, exit from loop
	      ENDIF
	   ENDDO
	   read (datestring, 50) year

	   IF (datestring(1:2) .NE. '01') THEN
	      true_month = .FALSE.
	      GOTO 5000
	   ENDIF

	   day = 1
	   zero = 0
	   
	   secs_start = TM_SECS_FROM_BC ( cal_id,
     .          year, month, day, zero, zero, zero, status)

	   IF (month .LT. 12) THEN
	      month = month + 1
	   ELSE
	      year = year + 1
	      month = 1
	   ENDIF
	   secs_end = TM_SECS_FROM_BC ( cal_id,
     .          year, month, day, zero, zero, zero, status)

           secs_box = secs_end - secs_start
	   days_in_mo = (secs_end - secs_start)/ secpday

	   IF  (.NOT. TM_DFPEQ_TOL ( days_in_mo, days_box, epsilon ) ) THEN
	      true_month = .FALSE.
	      GOTO 5000
	   ENDIF
	ENDDO

* convert first coordinate 
	secs_start = coords(1)* un_convert(units)  ! incoming units
	
* new, monthly units
        units = TM_UNIT_ID ( 'month' )
	units = TM_UNITS_CAL ( units, cal_id, true_month )

	start = (secs_start / un_convert(units) )
	delta = 1.

	datestring = TM_GET_CALENDAR_NAME(cal_id)
	slen = TM_LENSTR1 ( datestring )
	unit_string = 'TRUMONTH ('//datestring(:slen)//')'
	tunit = un_convert( units )

 5000	CONTINUE
	RETURN
	END

      SUBROUTINE QUERY_DISPLAY_SIZE (wstype,ierr,imeter,x,y,ix,iy)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*     With use if ATC GKS modification to display size query GQDSP
*     is needed. This routine handles both ATC and DEC GKS queries.
*     J Davison 3.24.92
*     Mod 8.27.93 *jd* to deal w xgks
*     Ferret V69+ *sh* 1/21/15 - disambiguate datatype of x and y

#ifdef unix
#   ifndef atc_gks
        include         'gkspar.inc'
#   endif
        include         'ws_types.cmn'
#else
        include         'sys$library:gksdefs.bnd'
        include         'tmap_pplv11inc:ws_types.inc'
#endif

      integer     wstype,ierr,imeter,ix,iy
      real        dx_in,dy_in,xfactor,yfactor
      REAL*8      x, y

******************************************************************************

#ifdef atc_gks
*     Mod 1 will assume 13x10 inch Xmonitors.  ATC does not restrict windows
*     to fit inside display.  Also GKS query returns size of window, not
*     the display.  

      dx_in = 13.0
      dy_in = 10.0

      if (wstype/100 .eq. ws_xwindow/100) then
*        RETURN VALUES IN METERS AND PIXELS
         x = dx_in * 0.0254
         y = dy_in * 0.0254

*        HOW MANY MM/PIXEL
         call guesc307 (wstype,ierr,xfactor,yfactor)

         ix = dx_in * 25.4 / xfactor
         iy = dy_in * 25.4 / yfactor

         imeter = 0
         ierr = 0
      else
*        TAKE WHAT WE GET FOR TEKS ETC
         call gqdsp (wstype,ierr,imeter,x,y,ix,iy)
      endif
#elif xgks
	 ierr = 0
	 imeter = 0
	 x = 0.36
	 y = 0.25
	 ix = 1280
	 iy = 1024
#else
*     USING DEC GKS USE NORMAL QUERY
      call gqdsp (wstype,ierr,imeter,x,y,ix,iy)
#endif
      
      return
      end

	subroutine epictrd (ndata, di, ti, df, tf, dt, leof, prhead)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)epictrd.F	1.1    3/10/88
C**
C**
C***********************************************************************        C**
C**                 EPIC
C**
C***********************************************************************        C**
C**
c
c  Reads name of a time series data file from unit lun11 (an EPIC file or other
c  pointer file opened by subroutine epicopn).  If end-of-file encountered on
c  unit lun11,leof is set .true.. Opens data file on unit lun1 and reads header.
c  Prints header on output file if prhead is true, not if false.  Reads
c  number of variables and variable codes.  Returns nvars and varcd(i) in
c  common/comvar/.
c
c  Programmed by N Soreide, Jun 85.
c  Modified for other pointer file and variable info, NNS, Oct 85.
c  Modified from epicrd for time series data, NNS, Mar 86.
c
	logical leof,prhead
c
c Subroutine READHD
	character*80 theader(8)
	common /comthdr/ theader
c
c  Subroutine EPICRD 
	character*4 varcd(20)
	common/comvar/ nvars,varcd
	common/comefil/datafile
	common/comedat/dat
	character line*132, dat*3, datafile*132
	common /comerd/ line
c
c  Subroutine EPICOPN EPIC file indicator
	logical lepic
	common /comepl/ lepic
c
	common /epiclun/ lun1,lun11,lun21
c
	data nline /132/
c
c  Read data file name, open data file and read CTD header.
c
	if (lun1 .eq. 0) lun1=1
	if (lun11 .eq. 0) lun11=11
c
	leof=.false.
c
	if (lepic) then
		call efile (datafile, dat, leof)
		if (leof) return
	else
		read (lun11, 102, end=300) datafile
102		format (a)
	endif
c
#ifdef unix
	open (unit=lun1, form='unformatted', status='old', 
     *	file=datafile)
#else
	open (unit=lun1, form='unformatted', status='old', 
     *	readonly,file=datafile)
#endif
c
c  Check that this is time series data
c
	rewind lun1
	read (lun1) theader(1)
	read (lun1) theader(2)
	if (theader(2)(78:78) .ne. 'T') then
		write (6,104) theader(2)(78:78)
104		format (//' This is not time series data.',
     *                    ' Header type is ', a, ' - STOP')
		stop
	endif
	rewind lun1
c
c  Read header, get number of variables and variable codes.
c
	if (prhead) write (6,103) datafile(1:lenstr(datafile))
103	format (/ ' Data file name is ', a /)
c
	call readthd (lun1, 0, ndata, di, ti, df, tf, dt, prhead,
     *	.false., .false.)
	read (theader(3)(79:80), 602) nvars
602	format (i2)
	read (theader(5), 603) (varcd(i),i=1,nvars)
603	format (20a4)
	return
c
c  End-of-file encountered on list of data file names (EPIC file)
c
300	leof=.true.
	return
	end

	SUBROUTINE XEQ_CONTOUR( memory )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute the CONTOUR command

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 1/5/87 copied from rev. 0.0 of XEQ_PLOT (6/3/86) with changes
*		 to allow multiple mrs in a single expression
*		 and with separate subroutines for graphics set-up
* revision 0.1 - 2/25/87 - changes for INTERPRETATION STACK
* revision 0.2 - 6/24/87 - incorporated 90 degree in-plane transpose
*			   and DISP_INIT separated from DISP_SET_UP
* revision 0.3 - 7/8/87  - DISP_LABELS separated from DISP_SET_UP
* revision 0.4 - 7/28/87 - added CALL DISP_PREP
* revision 0.5 - ????    - plots not automatically transposed in XT plane
* revision 0.6 - 3/2/88  - check for valid data range before PLOT+ auto-scaling
* revision 0.7 - 4/14/88 - added /NOLABELS option and range check-->DISP_SET_UP
* revision 0.8 - 4/28/88 - set up PPLUS LEV command if no data range
* revision 0.9 - 8/2/88  - added MODE WAIT
* revision 1.0 - 9/21/88 - do_labels --> no_labels: /NOLABEL processing chged
* revision 1.1 - 1/25/89 - PPLUS interruptibility - chg for multiple plots
* revision 1.2 - 5/1/89  - PPL LEVELS not cleared for no_range if /LEVELS_SAME
* V200:  5/19/89 - 4D symmetrical
*		 - obtain oversized data region to fill contours to edges
*	  1/4/89 - using keys for labelling
*	 3/13/90 - check status from DISP_PREP
* V230:   6/8/92 - added CONTOUR/FILL/KEY/LINE/NOKEY
*       10/22/92 - removed dependence on shade_vars.cmn using PPLCMND(SHAKEY)
*        11/9/92 - protect colors before doing a color overlay
*                - default for KEY is off on overlays
* V300:  3/11/93 - added /SPECTRUM=
* V301:	  1/7/94 - bug fix: (see DISP_DATA_SET_UP) must unprotect plot data
*	 2/10/94 - added /PEN=
* V312: 5/94 - array "memory" as a calling argument
* V320:   1/20/94 - changes to SAVE_FRAME call reflecting C-based procedures
* 12/96 *kob* - Linux Port - had to move variable assignments off of
*               declaration line.
* V450:  5/29/97 - added /NOAXES qualifier (useful in curvilinear plots)
* V491:  12.98   - added /PATTERN qualifier *jd*
* V510 12/99 *sh* - allow plots of all-missing data
*		  - added /SIZE=/SPACING=/SIGDIG= controls over contour labels
*      5/00 *sh* - restored the /PEN qualifier (with "denigrated" remark
* V530 *sh* 1/01 - change "denigrated" to "deprecated"
*      *acm*6/01 - add arguments is_logh, is_logv to DISP_SET_UP call.
*                  (only used for PLOT command)
*      *acm* 7/01 - Add /AXES=TOP,BOT,LEFT,RIGHT
*		    & call ax_on_off to implement /NOAXES.
*      *acm* 10/01  remove VMS includes
* V540 *acm*  2/02  restore persistence of PPL AXSET settings
* V541 *acm*  3/02  Make PPL AXSET settings persist, but not settings
*                   done with qualifiers /AXES= or /NOAXES
*      *acm*  4/02  do not set is_logh, is_logv.  They arent used by CONTOUR.
*      *acm*  4/02  If this is an overlay, and there is no valid data, 
*                   do not put "No Valid Data" across the middle of the plot.
*                   Instead (in disp_set_up) add this information to the
*                   variable name in the key below the plot.
* v541 *acm*  5/02 add option to control outline on the shade key boxes 
*                   /KEY=continuous
* V550: *acm*11/02 add argument is_shade to DISP_SET_UP call (not used by contour)
* V552: *acm* 5/03 add argument use_cell to DISP_SET_UP call (not used by contour)
* v554: *acm* 2/04 add /HGRAT /VGRAT to draw optional graticule lines at tic marks
* v580 *acm* 6/15/04 In the workaround which does a PPL LEV command for data with
*                    a single value, need to give the PPL command the value with  
*                    more precision. (single value data isnt contoured or filled,
*                    but put this fix in as a parallel to what is done in shade
*                    and polygon.)
* V581 *acm* 5/05  fix bug 1249: /KEY=CONT. Need to use EQUAL_STR to get the
*                  argument to /KEY, then compare to see if it equals uppercase 'CON'
* V602 *acm* 11/06 Fix bug 1472: Where single-level color plot is requested, use levels (1) 
*                  setting rather than sending the data value; avoids precision problems.
* V603 *acm*  5/07 as in xeq_shade, for fix of bug 904: if FILL/LINE, then set iautoc and 
*                  NLEV2 to re-use the contour levels from the shade plot. The bug does not
*                  seem to occur on fill plots, but might as well not recompute levels.
* V6.11 4/08 *acm* Fixes for bug 1571; call to PPL_AXES_RESTORE moved to DISP_INIT
* V614  *acm* 10/08 - add new MODE NODATA_LAB to control the NO VALID DATA label.
*                  Put it on plots only when this mode is set.
* V6.2  *acm* 11/08Fix bug 1609: If the plot is an overlay then do not process /AXES=
*                  or /NOAXES. Axes are never drawn for overlays anyway.
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
*                  A time axis may be a T axis or F axis
* V6.85 *acm* 3/13 Fix ticket 2049; check we can open palette file

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'slash.parm'
	include 'xplot_state.cmn'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
	include 'plot_setup.parm'
	include 'xplot_setup.cmn'
        include 'parampl5_dat.decl'     ! with inclen
        include 'PARAMPL5.DAT'  ! with inclen
        include 'cont_inc.decl' ! with iautoc and nlev
        include 'CONT.INC'
	
* calling argument declarations:
	REAL	memory( mem_blk_size, max_mem_blks )

* internal variable declarations:
	LOGICAL	  no_range, overlay, transpz, no_labels, fill, usa_line,
     .            do_key, spectrum, set_up, noaxes, axes, pattern, 
     .		  no_data, is_logh, is_logv, inc_grid
	INTEGER	  TM_LENSTR1, status, slen, sp, ipen,
     .		  ax1_blks, ax1_start, loc, sigdig,
     .		  ax2_blks, ax2_start, patt, i, nparm, num_it, 
     .		  s1, s2, it_start(4), it_end(4), iax(4), density,
     .            loch, locv
        INTEGER   STR_UPCASE, i1
	REAL	  vbuf, only_val, aspect, lab_size, lab_spacing
	PARAMETER (aspect = 0.0)			!kob 12/96
	CHARACTER TM_FMT*12, TM_INQ_PATH*2048, 
     .                  fname*128, buff*25, sfile*2048

* internal parameter declarations:
	LOGICAL		norm_dims_only, not_vector, continuous_key, 
     .                  is_shade, use_cell
	PARAMETER     ( norm_dims_only  = .FALSE.,
     .			not_vector	= .FALSE. )

* set up the graphics environment

	CALL START_PPLUS

* get the data (possibly ?? on a slightly oversized region)
!	cx_ovsiz(cx_last) = ovsiz_plane	! ... causes too many headaches !
	CALL DISP_DATA_SET_UP( memory,
     .		ax1_start, ax1_blks, ax2_start, ax2_blks, status )
	IF ( status .NE. ferr_ok ) GOTO 5100

* initialize
	overlay   = qual_given( slash_cont_over_plot ).GT.0 .AND. twodee_on
	no_labels = qual_given( slash_cont_nolabels  ).GT.0
	transpz   = qual_given( slash_cont_transpz   ).GT.0
	set_up    = qual_given( slash_cont_set_up    ).GT.0
	fill      = qual_given( slash_cont_fill      ).GT.0
	noaxes    = qual_given( slash_noaxes         ).GT.0
	axes      = qual_given( slash_cont_axes      ).GT.0
        IF (overlay) THEN
	   noaxes = .FALSE.
	   axes = .FALSE.
	ENDIF
        sp        = qual_given( slash_cont_spectrum  )
        spectrum  = sp .GT. 0 .AND. fill
        is_shade  = .FALSE.
        use_cell  = .FALSE.

        patt     = qual_given( slash_cont_pattern  )
        pattern  = patt .GT. 0 .AND. fill

	usa_line  = .NOT.fill
     .          .OR. qual_given( slash_cont_line      ).GT.0
	IF ( .NOT.overlay ) CALL DISP_INIT(no_labels,is_cx,
     .                                       num_uvars_in_cmnd)
* ... default orientation for YT and ZT contours has time on horizontal
	IF ( (plot_axis(2).EQ.t_dim .OR. plot_axis(2).EQ.f_dim) .AND. 
     .		plot_axis(1).NE.x_dim ) transpz = .NOT.transpz

* ... CONTOUR/SIZE=float
	loc = qual_given( slash_cont_size )
	IF ( loc .GT. 0  ) THEN
	   CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      vbuf, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   IF ( vbuf .NE. unspecified_val4 ) THEN
	      IF ( vbuf.LE. 0.0 ) GOTO 5210
	      lab_size = vbuf	
	   ENDIF
	ELSE
	   lab_size = 0.08
	ENDIF
* ... CONTOUR/SPACING=float
	loc = qual_given( slash_cont_spacing )
	IF ( loc .GT. 0  ) THEN
	   CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      vbuf, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   IF ( vbuf .NE. unspecified_val4 ) THEN
	      IF ( vbuf .LE. 0.0 ) GOTO 5210
	      lab_spacing = vbuf	
	   ENDIF
	ELSE
	   lab_spacing = 5.0
	ENDIF
* ... CONTOUR/SIGDIG=integer
	loc = qual_given( slash_cont_sigdig )
	IF ( loc .GT. 0  ) THEN
	   CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      vbuf, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   IF ( vbuf .NE. unspecified_val4 ) THEN
	      IF ( vbuf.LE.0.5 ) GOTO 5210
	      sigdig = NINT(vbuf)
	   ENDIF
	ELSE
	   sigdig = 2
	ENDIF
* ... CONTOUR/COLOR=color name or pen number
	loc = MAX( qual_given(slash_pen), qual_given(slash_color))
	IF ( loc .GT. 0 ) THEN
	   IF (.NOT.denig_pen_msg_done .AND. qual_given(slash_pen).GT.0)
     .									THEN
	      CALL WARN( '/PEN is deprecated. Use /COLOR.')
	      denig_pen_msg_done = .TRUE.
	   ENDIF
           CALL EQUAL_COLOR( cmnd_buff(qual_start(loc):qual_end(loc)),
     .                           ipen, status )
           IF ( status .NE. ferr_ok ) GOTO 5000
	ELSE
	   ipen = -1	! auto-select in DISP_SET_UP
	ENDIF

* ... CONTOUR/hgrat[=dash or line] default is dash
*     hgrat line type: 0=tics only, 1=dash, 2=line

	loch = qual_given(slash_cont_hgrat)

* ... CONTOUR/vgrat[=dash or line] default is dash
*     vgrat line type: 0=tics only, 1=dash, 2=line

	locv = qual_given(slash_cont_vgrat)

        IF (loch .EQ. 0  .AND. locv .EQ. 0) THEN
           loch = qual_given(slash_cont_grat)
           locv = qual_given(slash_cont_grat)
        ENDIF

        CALL set_graticules(loch, locv, status)

* set contour label details (3/00)
* fix bug 
	WRITE ( ppl_buff, 3100 ) lab_size, sigdig, lab_spacing
	CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
 3100	FORMAT('CONSET ',F8.3,',',I4,', , , , , ,',F7.2)

	CALL DISP_PREP( status )
	IF ( status .NE. ferr_ok ) GOTO 5000

        density = 0	! not used; vec/flow needs it in set up

* set up the axes and title and load the data into PPLUS
	inc_grid = set_up
	CALL DISP_SET_UP   ( 	memory,
     . 			 	not_vector,
     .				is_shade,
     .				use_cell,
     .				aspect,
     .				overlay,
     .				transpz,
     .				no_labels,
     .				no_range,
     .				only_val,
     .                          density,
     .				is_logh, 
     .				is_logv,
     .				is_mr,		! pass list
     .				num_uvars_in_cmnd,
     .				is_cx,		! pass list
     .				is_uvar,	
     .				memory( 1, ax1_start ),
     .				memory( 1, ax2_start ),
     .				ipen,
     .				inc_grid,
     .				status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* increment counter of line-style contours on screen
	IF ( usa_line ) ncont_on = ncont_on + 1

* is the no valid input data?
        no_data =  no_range .AND. only_val.EQ.bad_val4


* PPLUS blows up setting auto contour levels if all data have same value
* But, do not let this be rounded off, or we cannot find the color when matching 
* this value in get_ndx, called by fillpol.  ( although, if there is just
* one level, the fill is not done.)

* The initial fix below had precision problems when the value in only_val was
* of high precision, sometimes causing polygons to go unfilled (bug 1472).  
* Instead, make a ppl lev 1 setting, as is done in disp_prep.F

c     IF ( no_range .AND. qual_given( slash_shad_lev_same ) .EQ. 0 )
c    .          CALL PPLCMD ( from, line, 0, 
c    .          'LEV () ('//TM_FMT(only_val, 8, 20, slen)//')' , 1, 1 )

      IF ( no_range .AND. qual_given( slash_shad_lev_same ) .EQ. 0 ) THEN
           iautoc = 1  
c           nlev = 1
      ENDIF

* default key
	   do_key =  (qual_given(slash_cont_key)  .GT. 0)
     .		.OR. (.NOT.usa_line .AND. .NOT.overlay)
	   IF ( no_data ) do_key = .FALSE.
	   IF (qual_given(slash_cont_nokey) .GT. 0) do_key = .FALSE.
           IF ( do_key ) THEN
              CALL PPLCMD ( from, line, 0, 'SHAKEY 1,1', 1, 1 )

* ... /KEY=continouus ?
              loc = qual_given( slash_cont_key )
              IF ( loc .GT. 0) THEN
	         CALL EQUAL_STRING( cmnd_buff(qual_start(loc):qual_end(loc)),
     .                        buff, status )
                 IF ( status .NE. ferr_ok ) GOTO 5000
	         IF ( buff(1:3) .EQ. 'CON' ) THEN
                    continuous_key = .TRUE.
                    CALL PPLCMD (from, line, 0, 'S_KEY 1', 1, 1 )
                 ENDIF
              ENDIF

           ELSE
              CALL PPLCMD ( from, line, 0, 'SHAKEY 0,1', 1, 1 )

c when it's an overlay, 'No Valid Data' is part of the plot key,
c done in disp_set_up. If mode_nodata_lab is false then leave this off.

        IF (.NOT. overlay .AND. no_data .AND. mode_nodata_lab) 
     .                  CALL PUT_LABEL( ppl_movlab, 0.5, 0.5,
     .                  ppl_centered, letsize_title,
     .                  'No Valid Data',
     .                  lab_loc_axlen_times, lab_loc_axlen_times )
           ENDIF

* protect colors already on-screen before a color overlay
           IF ( overlay .AND. fill ) CALL PPL_SHASET( 'PROTECT' )

* save old and reset to new color spectrum if requested
           IF ( spectrum ) THEN
              CALL EQUAL_STR_LC( cmnd_buff(qual_start(sp):qual_end(sp)),
     .             fname, status )
              IF ( status .NE. ferr_ok ) RETURN
              IF ( fname .EQ. ' ' ) fname = 'default'
	      
	      slen = TM_LENSTR1(fname)
              sfile = TM_INQ_PATH (fname(:slen),'FER_PALETTE','.spk',
     .        	 .false.,status)
              IF (status .NE. ferr_ok) go to 5300 

              CALL PPL_SHASET( 'SAVE' )
              CALL PPL_SHASET( 'SPECTRUM='//fname(1:TM_LENSTR1(fname)) )
           ENDIF

* save old and set to new pattern if requested (a la spectrum)
           IF ( pattern ) THEN
              CALL EQUAL_STR_LC( 
     .             cmnd_buff(qual_start(patt):qual_end(patt)),
     .             fname, status )
              IF ( status .NE. ferr_ok ) RETURN
              IF ( fname .EQ. ' ' ) fname = 'default'
	      
	      slen = TM_LENSTR1(fname)
              sfile = TM_INQ_PATH (fname(:slen),'FER_PALETTE','.pat',
     .        	 .false.,status)
              IF (status .NE. ferr_ok) go to 5300 

              CALL PPL_PATSET( 'SAVE' )
              CALL PPL_PATSET( 'PATTERN='//fname(1:TM_LENSTR1(fname)) )
           ENDIF


* turn off axes? 
	IF ( noaxes ) THEN 
           DO 300 i = 1, 4
              iax(i) = 0
 300       ENDDO
        ENDIF

* turn on (one or more) axes? (7/11/01)

* ... PLOT/AXES=(TOP,BOTTOM,LEFT,RIGHT)
	IF ( axes ) THEN
           loc = qual_given( slash_cont_axes )
	   CALL EQUAL_STR_LC( cmnd_buff(qual_start(loc):qual_end(loc)),
     .                        buff, status )
           IF ( status .NE. ferr_ok ) GOTO 5000

	   IF ( buff .NE. ' ' ) THEN

* Get arguments, if any.  Otherwise turn on all axes
              slen = TM_LENSTR1(buff)
              s1 = 1
              s2 = slen
              IF (buff(1:1) .EQ. '(' )THEN
                  s1 = 2
                  s2 = slen-1
                  IF ( buff(slen:slen) .NE. ')' ) GOTO 5440
              ENDIF

              nparm = 4
              CALL parse_comma_list ( buff, s1, s2, nparm, 
     .             num_it, it_start, it_end, status)

              IF (status .EQ. ferr_ok .AND. it_start(1) .GT. it_end(1)) THEN	! /AXES=()
                 DO 400 i = 1, 4
                    iax(i) = 0
 400             ENDDO
              ELSE IF (status .NE. ferr_ok .OR. num_it .LT. nparm) THEN
                 GOTO 5440
              ELSE
                 DO 500 i = 1, nparm
                    READ (buff(it_start(i):it_end(i)), *) iax(i)
                    IF (iax(i) .LT. 0  .OR.  iax(i) .GT. 1) GOTO 5450
 500             CONTINUE
              ENDIF
           ELSE		! turn on all axes
	      DO 600 i = 1, 4
		 iax(i) = 1
 600	      CONTINUE
           ENDIF
              
	ENDIF	

*  Turn off or on axes, including time axes.
        IF (axes .OR. noaxes) CALL ax_on_off (iax)

* /set_up only requested ?
	IF ( set_up ) GOTO 1000

* contour it 
        IF ( fill ) THEN
* ... filled contours
	   IF ( overlay ) THEN
	      IF ( usa_line ) THEN
		 CALL PPLCMD ( ' ', ' ', 0,
     .			'FILL/OVER/' //ppl_wait//' ' , 1, 1 )
	         IF ( ppl_interrupted ) GOTO 1000
	         iautoc = 0 ! reuse levels from last plot
	         nlev = nlev2
		 CALL PPLCMD ( ' ', ' ', 0,
     .			'CONTOUR/OVER/' //ppl_wait//' ' , 1, 1 )
	      ELSE
	         CALL PPLCMD ( ' ', ' ', 0,
     .			'FILL/OVER/' //ppl_wait//' ' , 1, 1 )
	      ENDIF
	   ELSE
	      IF ( usa_line ) THEN
	      
		 CALL PPLCMD ( ' ', ' ', 0,
     .			'FILL/LATCH/'//ppl_wait//' ', 1, 1 )
	         IF ( ppl_interrupted ) GOTO 1000
	         iautoc = 0 ! reuse levels from last plot
	         nlev = nlev2
		 CALL PPLCMD ( ' ', ' ', 0,
     .			'CONTOUR/OVER/' //ppl_wait//' ' , 1, 1 )
	      ELSE
		 CALL PPLCMD ( ' ', ' ', 0,
     .			'FILL/LATCH/'//ppl_wait//' ', 1, 1 )
	      ENDIF
	   ENDIF
        ELSE
* ... line-style contour

	   IF (contour_fewer .EQ. 1) THEN
	      iautoc = 1
	      nlev = 10
	   ENDIF
	   IF ( overlay ) THEN
	      CALL PPLCMD ( ' ', ' ', 0,
     .			'CONTOUR/OVER/' //ppl_wait//' ' , 1, 1 )
	   ELSE
	      CALL PPLCMD ( ' ', ' ', 0,
     .			'CONTOUR/LATCH/'//ppl_wait//' ', 1, 1 )
	   ENDIF
        ENDIF

* protect the new colors and restore the original color spectrum
           IF ( spectrum ) THEN
              CALL PPL_SHASET( 'PROTECT' )
              CALL PPL_SHASET( 'SPECTRUM' )
           ENDIF

* restore the original pattern
           IF ( pattern ) THEN
              CALL PPL_PATSET( 'PATTERN' )
           ENDIF

* Mark the levels as set; if we used histogram levels it is 0

          IF (need_histo) iautoc = 1

* restore axes? (5/29/97  revised 3/2002 

c        IF ( axes .or. noaxes ) CALL PPL_AXES_RESTORE

* restore default (non-continuous) key style?
        IF (continuous_key ) CALL PPLCMD (from, line, 0, 'S_KEY 0', 1, 1 )

* interrupt occurred during plot ?
	IF ( ppl_interrupted ) GOTO 1000

* capture the bit map ? (discontinued with v6.6)
	IF ( qual_given( slash_cont_frame ) .GT. 0 ) THEN
	   CALL SAVE_FRAME( frame_file, "HDF", status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	ENDIF

* release the memory used for axis buffers
 1000 	CALL FREE_MEMORY( ax2_start, ax2_blks )
 	CALL FREE_MEMORY( ax1_start, ax2_blks )
	CALL UNPROTECT_CMND_DATA			! 1/94
 5100	RETURN

* error exits
 5000	GOTO 1000
! 5200   CALL ERRMSG( ferr_out_of_range, status,
!     .          cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
!     .          'Legal range is 1 to '//LEFINT(limit,slen), *1000 )
 5210	CALL ERRMSG( ferr_out_of_range, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .		'Value must be positive', *1000 )
 5300   CALL ERRMSG (ferr_file_not_found, status, 
     .          'unable to open "' //
     .	fname(:slen)//'.spk" to set plot colors or pattern.', *1000)
 5440	CALL ERRMSG( ferr_syntax, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .	'AXES[=(TOP,BOTTOM,LEFT,RIGHT)] takes 4 arguments or no argument', *1000 )
 5450	CALL ERRMSG( ferr_out_of_range, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .		'AXES arguments must be 0 or 1', *1000 )

	END

*
* pickz.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* March 1999
*  Redo  July 2000
*
*  Apply a mask to data.  Returns a result with an ABSTRACT Z axis.
*  Take only those points where mask had valid (non-missing) points.
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE pickz_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      CHARACTER*100 fcn_desc
      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns data masked; result on abstract Z axis ',
     .        'where mask has valid points')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 2)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS,
     .        IMPLIED_BY_ARGS, ABSTRACT, IMPLIED_BY_ARGS)

      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'VAR')
      CALL ef_set_arg_desc(id, arg, 'data to mask')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'MASK')
      CALL ef_set_arg_desc(id, arg, 
     .   '1-D mask, same length as z-axis of VAR')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE pickz_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      INTEGER my_lo_l, my_hi_l

      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

*
*     Use utility functions to get context information about the arguments.
*     Set the abstract Z axis.
*

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nx = arg_hi_ss(X_AXIS, ARG2) - arg_lo_ss(X_AXIS, ARG2) + 1
      ny = arg_hi_ss(Y_AXIS, ARG2) - arg_lo_ss(Y_AXIS, ARG2) + 1
      nz = arg_hi_ss(Z_AXIS, ARG2) - arg_lo_ss(Z_AXIS, ARG2) + 1
      nt = arg_hi_ss(T_AXIS, ARG2) - arg_lo_ss(T_AXIS, ARG2) + 1

      my_lo_l = 1
      my_hi_l = ny
      IF (arg_hi_ss(Z_AXIS, ARG2) - arg_lo_ss(Z_AXIS, ARG2) .EQ. 0)
     .    my_hi_l = max(nx,ny,nz,nt)

      CALL ef_set_axis_limits(id, Z_AXIS, my_lo_l, my_hi_l)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE pickz_compute(id, arg_1, arg_2, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .     mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .     mem2lot:mem2hit)
     .     
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .      memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      INTEGER id, i, j, k, l
      INTEGER i1, j1, k1, l1
      INTEGER i2, j2, k2, l2
      INTEGER nlen1, nlen2, ndims
      CHARACTER*100 errtxt

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*  Check that ARG2 is 1-D.  

      ndims = 0
      nlen2 = 0
      DO 88 m = X_AXIS, T_AXIS
         IF (arg_incr(m,ARG2) .GT. 0) THEN
           nlen2 = arg_hi_ss(m,ARG2) - arg_lo_ss(m,ARG2)
           ndims = ndims + 1
         ENDIF
  88  CONTINUE

      IF (ndims .LE. 0  .OR.  ndims .GT. 1) THEN
         WRITE (errtxt, *) 'ARG2 (mask) must be 1-dimensional'
         GOTO 999
      ENDIF

C  Check that the dimension of the mask matches the  x axis of the variable.

      IF (arg_incr(Z_AXIS,ARG1) .GT. 0) nlen1 = arg_hi_ss(Z_AXIS,ARG1) 
     .    - arg_lo_ss(Z_AXIS,ARG1)

      IF (nlen2 .NE. nlen1) THEN
         WRITE (errtxt, *) 
     .    'ARG2 (mask) must be the same length as the z-axis of ARG1'
         GOTO 999
      ENDIF

C  Apply the mask.

      i1 = arg_lo_ss(X_AXIS,ARG1)
      i2 = arg_lo_ss(X_AXIS,ARG2)
      DO 400 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS) 

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         j2 = arg_lo_ss(Y_AXIS,ARG2)
         DO 300 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            l1 = arg_lo_ss(T_AXIS,ARG1)
            l2 = arg_lo_ss(T_AXIS,ARG2)
            DO 200 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

                k = res_lo_ss(Z_AXIS)
                k2 = arg_lo_ss(Z_AXIS,ARG2)
                k1 = arg_lo_ss(Z_AXIS,ARG1)

                DO 100 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

*  Check that this value of ARG_2 is not missing; set the result

                   If (arg_2(i2,j2,k2,l2) .ne. bad_flag(ARG2)) THEN
                        result(i,j,k,l) = arg_1(i1,j1,k1,l1)
                  ELSE
                        result(i,j,k,l) = bad_flag_result
                  END IF

                  k1 = k1 + arg_incr(Z_AXIS,ARG1) 
                  k2 = k2 + arg_incr(Z_AXIS,ARG2) 

 100           CONTINUE

               l1 = l1 + arg_incr(T_AXIS,ARG1)
               l2 = l2 + arg_incr(T_AXIS,ARG2)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
            j2 = j2 + arg_incr(Y_AXIS,ARG2)
 300     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
         i2 = i2 + arg_incr(X_AXIS,ARG2)
 400  CONTINUE

      RETURN 

999   CONTINUE

      CALL EF_BAIL_OUT(id, errtxt)


      END
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

	SUBROUTINE SET_FILL_NDX (fill_ndx)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*	Sets fill index appropriately.  DEC uses bundled indices,
*	at this date ATC has too few to use them, so must use individual
*	attributes.

*	J Davison 10.12.92
*       *jd* 7.31.97 mode to change call to gqlwk to query_xgks_wkstn
*       *jd* 10.98 handle "atomic" colors
* 3/99 *kob* 	move var init off of decl list  - cleaning up after jerry.

        include         'shade_vars.cmn'
	include		'gkscm1_inc.decl'
	include		'GKSCM1.INC'
        include		'gkspar.inc'

	integer		fill_ndx,style,pattern_ndx,solid
	DATA            solid/21/
        integer         max_pline,max_pmark,max_text,max_fill_area
        integer         max_pattern,max_color,error,color_ndx
	real		incr,spc,min_spc,delta_spc
  
	parameter	(min_spc=0.05,delta_spc=0.01)

*******************************************************************************

	if (area_bundles) then
*	   USE SET FILL AREA INDEX
	   call gsfai (fill_ndx+lo_color_ndx(wsid))
	else
*	   HOW MANY COLORS HAVE WE?
           call query_xgks_wkstn (wstype,error,max_pline,max_pmark,
     .              max_text,max_fill_area,max_pattern,max_color)

	   if (max_color .gt. 2) then 
*	      CAN STILL USE COLOR INDICES -- BUT INDIVIDUAL
	      
*             USE ATOMIC COLORS?
	      if (rgb_mapping .ne. by_level) then
*                SMOOTH OUT COLORS TO FULL RANGE
	         call gsfaci (fill_ndx+lo_color_ndx(wsid)-2)
	      else
*                USE ATOMIC COLORS -- REUSE AS NECESSARY
		 color_ndx = mod((fill_ndx - 2),ncl) + 2
		 call gsfaci (color_ndx+lo_color_ndx(wsid)-2)
	      end if
	   else
#ifdef atc_gks
*	      OTHERWISE USE HATCHING SCHEME
	      incr = real (fill_ndx/2) - 1.0

*	      SEQUENTIAL INDICES ARE HATCHING ROTATED 90 DEGREES
	      if (mod(fill_ndx,2) .eq. 0) then
	            style = -1005
		    spc = min_spc + incr*delta_spc
	      else
		    style = -1004
		    spc = (min_spc + incr*delta_spc) * 0.707
	      endif

	      call gsfasi (style)
	      call guesc061 (wsid,1,spc)
#endif
	   endif
	endif

#ifdef xgks
	pattern_ndx = mod((fill_ndx - 2),npat) + 1

	if (patterns(pattern_ndx) .eq. solid) then
	   call gsfais (GSOLID)
	else
	   call gsfais (GHATCH)
	   call gsfasi (-1 * patterns(pattern_ndx))
	end if
#endif

	return
	end

	SUBROUTINE DELETE_OLD_EXPR

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* delete from memory all "expression" variables - internally defined user-vars
* that were created by expressions given with the commmand line

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 10/31/86
* revision 0.1 - 1/30/87 - modified for mr_protected declared as INTEGER
* revision 1.0 - 2/23/87 - changes for conversion to INTERPRETATION STACK using
*			   the idea that all expressions are special cases of
*			   user-defined variables
* revision 1.1 - 5/6/87  - corrected bug in UVAR_NUMBER (status) call
* V200:   7/7/89 - expression may have been deleted outside this routine
* 	 2/19/90 - major rewrite: loop through ALL user vars deleting "EX#"
* V540:  11/01 - initialize last_cmnd_buff
*	         (formerly local array in get_prot_cmnd_data)
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V698  2/16 *acm* For ticket 2352: variables defined with LET/D are
*                  added to that dataset in the attribute structure. Extra
*                  argument to DELETE_USER_VAR

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'

* internal variable declarations:
	INTEGER	uvar, j, num_indices, result_array(max_uvar), dset

* eliminate all user variables created by the last expression given
*	DO 100 uvar = 1, max_uvar
*	   IF ( uvar_num_items( uvar ) .EQ. uvar_deleted ) GOTO 100
        CALL deleted_list_get_undel(uvar_num_items_head,
     .                              result_array(1),
     .                              max_uvar, num_indices )
        dset = pdset_uvars
        DO 100 j = 1, num_indices
           uvar = result_array(j)        
	   IF ( uvar_name_code(uvar)(:3) .EQ. 'EX#' )
     .					CALL DELETE_USER_VAR( uvar, dset )
 100	CONTINUE

* remove memory of previous expressions
	last_cmnd_buff = ' '
	len_last_cmnd = 1

	RETURN
	END

	SUBROUTINE FILLPOL(X,NXS,XF,YF)
C** 
C**    @(#)fillpol.F	1.0    11/30/97
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C  ARRAY X HOLDS X AND Y'S FOR ALL LINES.  DIMENSIONED FOR NXS+npoly
C  ORDER AS FOLLOWS:  ALL X'S FOR LINE1, ALL X'S FOR LINE2,...
C                     STARTING AT X(NXS/2+1), ALL Y'S FOR LINE1,
C                     ALL Y'S FOR LINE2...
C  XF AND YF ARE FACTORS TO CONVERT TO INCHES FROM USER UNITS
C
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	*sh* 11/97 based on SHADESUB and PLOTXY
*
* *kob* 3/28/99 - declare subroutine range as external, otherwise F90 tries to
*                 use it as an intrinsic function - more cleanup work
* V510 *sh* 3/00 - changes to accomodate NPOLYGON > NLINES
*		 - involved eliminating CALL TRANS, which means that there
*			isn't a need to copy the X,y coords to x/ypolybase
* V510 4/00 *sh - corrected faulty logic for centered levels (delta wrong)
* V552 3/03 *acm* allow clipping to be set on or off via IWIND (ppl window off)
* V552 3/03 *acm* Check for too many levels, as is done for FILL and CONTOUR plots.
* V553 *acm*  6/03  For polygons, store the # of points in each polygon in the PPLUS
*                   memory buffer, rather than in lleng.  This way the number of
*                   polygons that may be plotted is unlimited. 
* v554 *acm*  2/04  After levels are set, call setlab_syms to set the LEVELS symbols

* v570  4/04*acm* Fix for the section marked correction for rounding errors. 
*                 Use TM_FPEQ_SNGL to see if values are equal or close.  Also fixes 
*                 this adjustment when the range has negative values; was incorrect.
* v580  8/04*acm* Fix bug 957 poly/lev=1 of a constant field needs zlev(1) to be set.
* v581 *acm* 3/05 open levels (-INF) (INF)
* V600 *acm* 8/06 Fix bugs 843, 844: poly/line and reversed axes. Apply xinv and
*                 yinv to coordinates when drawing the lines.
* V62  *acm* 5/09 Fixing bug 1661: if the plot is TRANSPOSED, then apply 
*                 xinv, yinv to the opposite axis.
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus

        include         'xinterrupt.cmn' ! 1/89 *sh*
        include         'ppl_in_ferret.cmn'

        INTEGER NXS
	REAL X(*), XF, YF

        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'axis_inc.decl'
        include 'AXIS.INC'
        include 'switch_inc.decl'
        include 'SWITCH.INC'
        include 'lines_inc.decl'
        include 'LINES.INC'
        include 'pen_inc.decl'
        include 'PEN.INC'
        include 'pltl_inc.decl'
        include 'PLTL.INC'
        include 'miss_inc.decl'
        include 'MISS.INC'
        include 'hd_inc.decl'
        include 'HD.INC'
        include 'taxis_inc.decl'
        include 'TAXIS.INC'
        include 'axisl_inc.decl'
        include 'AXISL.INC'
        include 'cmrd_inc.decl'
        include 'CMRD.INC'
        include 'cmrdl_inc.decl'
        include 'CMRDL.INC'
        include 'gkscm1_inc.decl'	! sh 11/97
        include 'GKSCM1.INC'		! sh 11/97
!        include 'gkscm2.cmn' ! jd 3.22.89
        include 'gkspar.inc'	! sh 11/97
        include 'shade_vars.cmn'	! sh 11/97
	include		'cont_inc.decl'
	include		'CONT.INC'
        include         'errmsg.parm'
	include 'PPLDAT.INC'		! with ibase
	include 'vector_inc.decl' ! with TRANSPZ
        include 'VECTOR.INC'


* 3/99 *kob*
	EXTERNAL RANGE

	INTEGER xpolybase, ypolybase, zpolybase, polysizemax, nl,
     .		nvertex, fill_ndx, xvertexbase			! 11/97

	INTEGER GET_NDX

* GKS initialization vars
* v491 *kob* removed unnecessary variable declarations
	integer		error,trans_no,cflag
        integer         my_trans
        data            my_trans/20/
	real	 	w(4),v(4),ndc(4),uc(4)
	real		xinv,yinv, tmp

*jd*
	real            zzmin, zzmax
	integer         status, nlm1
	real		dz,znp,zmp
	integer		i,j,uprdn, llen, ptsbase
	logical         line_it, fill_it
        integer         slen1, slen2
        CHARACTER       TM_FMT_SNGL*20, buff1*20, buff2*20, err_msg*40

        parameter       (epsilon = 1e-6)

*************************************

C       Check switches
	line_it = sline
	
	if (sline .and. sfill) then
	   fill_it = .true.
	else if (sline .and. .not. sfill) then
	   fill_it = .false.
	else
	   fill_it = .true.
	end if

* INITIALIZE
	nl = lnum - 1	! # lines over which to loop: last line is color info

* determine temp memory buffer location for points translated to plot coords
* ... layout is xline1, xline2, ..., xlinenl, xcolor , bufferspace ...
*               yline1, yline2, ..., ylinenl, ycolor , bufferspace ...
*     "zpolybase" is the offset to the ycolor array
	xpolybase = 1
        ptsbase = ibase - lnum 
	DO 2010  I=1,nl
        llen = x(ptsbase+i-1)
 2010	xpolybase = xpolybase+llen

        llen = x(ibase-1)      ! Length of color array

	zpolybase = ptsbase - llen - 1 + nxs/2
	xpolybase = xpolybase + llen	! skip past color array
	ypolybase = xpolybase + nxs/2

        xvertexbase = xpolybase + lnum	! skip past list of lengths

	polysizemax = nxs - ypolybase	! unused buffer space
	fill_ndx = 0

* set up GKS environment (code copied from SHADE_SUB)

*	GET PROPER SCALING, NDC COORDINATES, ETC FOR FILL
	call gqcntn (error,trans_no)
	if (error .ne. 0) goto 1100

	call gqnt (trans_no,error,w,v)
	if (error .ne. 0) goto 1100

	call get_user_coords (w,v,ndc,uc,xinv,yinv)
	
* Fixing bug 1661: if the plot is TRANSPOSED, then apply this
* fix to the opposite axis.

	IF (trnspz) THEN
	   tmp = xinv
	   xinv = yinv
	   yinv = tmp
	ENDIF

*	NOW SET THE CLIPPING RECTANGLE AROUND THEM AND PATTERN SIZE
* v4.91 *kob* had to add <cr> after first line below

	call gswn (my_trans,uc(1)*xinv,uc(2)*xinv,uc(3)*yinv,uc(4)*yinv)
        call gsvp (my_trans,ndc(1),ndc(2),ndc(3),ndc(4))
	if (fill_it) call gselnt (my_trans)

	call gqclip (error,cflag,ndc)
	call gqclip (error,cflag,ndc)
	if (error .ne. 0) goto 1000
	if (cflag .NE. iwind) call gsclip (iwind)

*************************************

* original PLOT+ code 
	IBASE=0
	IY=NXS/2
	ZT=YF/XF
	ICNT=1
	IF(M.GE.2.AND.IFLG(2).NE.0)ICNT=P(2)

C *jd* 
* FIND LIMITS
	zmin = 1e33
	zmax = -1e33
	zzmin = 1e33
	zzmax = -1e33
	nlm1  = nl - 1

cc	do 100 i = 0, nlm1 	      
cc	   if (ZEQ.AND.x(zpolybase+i).EQ.CMZEQ) GOTO 100
cc	   if (x(zpolybase+i) .gt. zzmax) zzmax = x(zpolybase+i)
cc	   if (x(zpolybase+i) .lt. zzmin) zzmin = x(zpolybase+i)
cc 100	end do

	do 100 i = 0, nlm1 	      
	   if (ZEQ.AND.x(zpolybase+1+i).EQ.CMZEQ) GOTO 101
	   if (x(zpolybase+1+i) .gt. zzmax) zzmax = x(zpolybase+1+i)
	   if (x(zpolybase+1+i) .lt. zzmin) zzmin = x(zpolybase+1+i)
 101       continue
 100	end do

        IF (zzmin .NE. 1e33) zmin = zzmin  ! Needed for annotating open-ended levels
        IF (zzmax .NE. -1e33) zmax = zzmax

C  Set the contour/color levels
C  ... here we need to call SET_LEVELS_SHADE_FILL if IAUTOC EQ 0 -- levs have been
C      set already.

        IF (IAUTOC .EQ. 0 .OR. 
     .      ((zzmin .NE. 1e33) .AND. (zzmax .NE. -1e33)) ) THEN
           CALL SET_LEVELS_SHADE_FILL (status)
           IF (status .NE. ferr_ok) GOTO 5000
	ELSE
	   IF (sover) THEN
	      IF (zzmin .EQ. 1e33) zmin = 1e36
	      IF (zzmax .EQ. -1e33) zma x= CMZLE - 10
	      CALL SET_LEVELS_SHADE_FILL (status)  !?
	   ENDIF 
	ENDIF

*	DETERMINE PATTERNS OR COLORS TO SET BUNDLED FILL AREA REPRESENTATIONS

*       Allow shading single level fields 
        if (nlev2 .lt. 1) goto 1000
        shd_levels = max (nlev2 - 1,1)

	call set_fill_area_rep (wsid,wstype)

	CALL MARKH(HMARK(1))
	CALL COLOR(IPEN(1))

******** LOOP OVER LINES STORED

	DO 200 I=1,nl
          llen = x(ptsbase+i-1)
* will this polygon fit in the buffer?
	  IF (llen .GT. polysizemax) THEN
	     WRITE (6,*) 'Too much polygon data to plot at once'
	     GOTO 200
	  ENDIF 

* assemble the vertices into arrays in units of plot coordinates
* note: all points in the polygon are guaranteed to be "valid"
	   nvertex = 0

	   DO 150 J=IBASE+1,IBASE+llen
!	      CALL TRANS(I,X(J),X(IY+J),XT,YT)
!	      nvertex = nvertex + 1
!	      x(xvertexbase+nvertex-1) = xt
!	      x(ypolybase+nvertex-1) = yt
	      nvertex = nvertex + 1
	      x(xvertexbase+nvertex-1) = x(j)
	      x(ypolybase+nvertex-1) = x(iy+j)
 150	   CONTINUE

	   if (fill_it) then
*             Determine the color index for the fill
	      if (ZEQ.AND.x(zpolybase+i).EQ.CMZEQ) GOTO 157

	      fill_ndx = GET_NDX (x(zpolybase+i),fill_ndx)
	      if (fill_ndx .eq. -999) goto 157

*             Draw the filled polygon
	      CALL SET_FILL_NDX (fill_ndx)

	      IF ( XEQ ) THEN 
	         do 155 j = xvertexbase, xvertexbase+nvertex-1
		    IF (X(J).EQ.CMXEQ) GOTO 157
 155	         continue
	      ENDIF

	      IF ( YEQ ) THEN 
	         do 156 j = ypolybase, ypolybase+nvertex-1
		    IF (X(J).EQ.CMYEQ) GOTO 157
 156	         continue
	      ENDIF

	      if (nvertex .gt. 2) then
		 if (line_it) call gselnt (my_trans)
		 CALL GFA(nvertex, x(xvertexbase), x(ypolybase)) 
	      end if
	   end if

 157	   if (line_it) then
*             Outline the polygon

	      nvertex = 0
	      DO 158 J=IBASE+1,IBASE+llen
		 nvertex = nvertex + 1
		 IF (XEQ.AND.X(xvertexbase+nvertex-1).EQ.CMXEQ) GOTO 199
		 IF (YEQ.AND.X(ypolybase+nvertex-1).EQ.CMYEQ) GOTO 199
 158	      CONTINUE

	      if (fill_it) call gselnt (trans_no)
	      nvertex = 0

	      DO 160 J=IBASE+1,IBASE+llen
		 nvertex = nvertex + 1
		 if (nvertex .eq. 1) then
		    uprdn = 0
		 else
		    uprdn = 1
		 end if
		 call plot (xinv*x(xvertexbase+nvertex-1),
     .	                    yinv*x(ypolybase+nvertex-1),uprdn,0)
 160	      continue
	      call plot (xinv*x(xvertexbase), yinv*x(ypolybase),1,0)
	   end if

	   if (interrupted) go to 1000 !*jd* 8.3.92
 199    IBASE=IBASE+llen	! prepare for next line
 200	CONTINUE

******** END OF LOOP OVER LINES STORED


* ... restore GKS transforms following FILLPOL 
 1000	call gsclip (cflag)
	call gselnt (trans_no)

* ... and DO THE KEY
	if (fill_it .and. do_key .AND. .NOT.interrupted) then
	   call color(ipen(0))
	   call key
	end if

 1100	CALL COLOR(IPEN(0))

* We use lnum as a counter, but we do not use the lleng array
* or other contstructs that used to treat each polygon as a plot line.
 
        lnum = 1

	RETURN

C  Error exit when too many levels specified.
C  Arrays LWGT, LDIG, and ZLEV are length ICNLEV=500

 5000   ii = ICNLEV
        buff1 = TM_FMT_SNGL (REAL(ICNLEV), 20, 20, slen1)
        buff2 = TM_FMT_SNGL (REAL(NLEV2), 20, 20, slen2)
        err_msg = '# of levels > '// buff1(1:slen1) //
     .          '  (' // buff2(1:slen2) // ')'
        CALL errmsg (ferr_out_of_range, status, err_msg, *5002)
 5002   return

	END

	SUBROUTINE SHOW_DATA_FILES( lun, dset )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* show the files and time step ranges for the requested data set

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 8/15/88
* V230: 6/92 - elaborated on kludge to locate time axis for data set
*            - use the first variable that HAS a time axis
*              (not clear why ds_time_axis cannot be used ??)
* V301: 4/94 - show file for T-independent data set, too
*	       but not for a netCDF data set
* V320:12/94 - increased the output field size for /COLUMNS=xxxx
*Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
*           *acm* 3/12 cleanup ifdefs and unnecessary include files
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V685 *acm*  3/13 For Ensemble aggregations, call the ds_type 'ENS'
* V695 *acm*  2/15 For Forecast aggregations, call the ds_type 'FCT'
* V695 *sh*  12/15 For FMRCs and Ensembles show aggregation members
* V698 *sh*   2/16 insert blank line at conclusion of list
* V702 *sh*  11/16 number the member files with the syntax (e.g.) "12.3"
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.
* V73  4/17 *acm* Change the text when showing members of a union aggregation,
*                 implement dataset.member notation for unions, (e.g.) "12.3"

	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xstep_files.cmn_text'
	external xstep_files_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xprog_state.cmn'

* calling argument declarations:
	INTEGER	lun, dset
	
* local variable declarations:
	LOGICAL		true_month
	INTEGER		KNOWN_GRID, TM_LENSTR1,
     .			ivar, grid, istep, ndec, status, lskip, slen,
     .			alen, nmemb, memb_set, nfig
	CHARACTER	LEFINT*8, lo_date*20, hi_date*20, buff*8, abuff*8
	REAL		timefac

* special processing of EZ data sets
	IF ( ds_type(dset) .EQ. pds_type_ez ) THEN
	   CALL SPLIT_LIST(pttmode_explct, lun,
     .		' /FORMAT = '//ds_parm_text(1,dset), 0)
           DO 10 istep = 1,maxstepfiles
 10	   IF (sf_setnum(istep) .EQ. dset) GOTO 20
	   CALL ERRMSG( ferr_internal, status, 'EZ_ err', *5000 )
 20	   CALL SPLIT_LIST(pttmode_explct, lun,
     .		' /SKIP = '//LEFINT( sf_skip(istep), lskip ), 0)
	   CALL SPLIT_LIST(pttmode_explct, lun,
     .		' /COLUMNS = '//LEFINT( ds_ntuple(dset), lskip ), 0)
 5000	   RETURN

* show aggregation members
        ELSEIF (ds_type(dset) .EQ. 'ENS'
     .    .OR.  ds_type(dset) .EQ. 'FCT'
     .    .OR.  ds_type(dset) .EQ. 'UNI') THEN

* ... get parent aggregation dataset number in string form
	   abuff = LEFINT(dset, alen )

* ... get number of aggregation members
	   CALL CD_GET_AGG_DSET_INFO (dset, nmemb, status)
	   IF (status .NE. ferr_ok) RETURN   ! should never happen
	   CALL SPLIT_LIST(pttmode_explct, lun,
     .		'          Member datasets:', 0 )

* ... loop through the aggregation members.
	   nfig = LOG10(REAL(nmemb)) + 1
	   DO istep = 1, nmemb
	      CALL CD_GET_AGG_DSET_MEMBER (dset, istep, memb_set, status)
	      IF (status .NE. ferr_ok) RETURN   ! should never happen
	      buff = LEFINT(istep, slen )
	      CALL SPLIT_LIST(pttmode_explct, lun,
     .		'      '//abuff(:alen)//'.'//buff(:nfig)//': '
     .			       //ds_des_name(memb_set), 0 )
	   ENDDO
	   RETURN

* nothing to show for netCDF files (4/94)
        ELSEIF (ds_type(dset) .EQ. 'CDF'
     .    .OR.  ds_type(dset) .EQ. 'ECDF') THEN
	   RETURN
	ENDIF

* !kludge - get the time axis from a variable in this data set
	DO 100 ivar = 1, maxvars
	   IF ( ds_var_setnum(ivar) .EQ. dset ) THEN
	      grid = KNOWN_GRID( dset, cat_file_var, ivar )
              IF ( grid_line(t_dim,grid) .NE. mnormal ) GOTO 200
	   ENDIF
 100	CONTINUE

******* 4/94 addition ******
* a time-independent data set
* list files belonging to this data set (should be one, only) 
	DO 110 istep = 1, maxstepfiles
	    IF ( sf_setnum(istep) .EQ. dset ) CALL SPLIT_LIST
     .		(pttmode_explct, lun, ' time-independent data file: '
     .		//sf_name(istep), 0 )
 110	CONTINUE
******* end of 4/94 addition ******
	RETURN

* a time-dependent data set:
* write heading line for step file list
 200	CALL SPLIT_LIST(pttmode_explct, lun,
     .		'          time-dependent data files:', 36)

* output string precision (from SET MODE CALENDAR)
           ndec = ax_dec_pt( t_dim )

	   CALL TM_MONTH_TIME_FACTOR (grid, true_month, timefac)

* see which step files belong with this data set 
	DO 300 istep = 1, maxstepfiles
	    IF ( sf_setnum(istep) .EQ. dset ) THEN
	      CALL TRANSLATE_TO_WORLD(	timefac* sf_1step(istep), t_dim, grid,
     .					ndec, lo_date )
	      CALL TRANSLATE_TO_WORLD(	timefac* sf_lastep(istep), t_dim, grid,
     .					ndec, hi_date )
	      slen = TM_LENSTR1(hi_date)
	      CALL SPLIT_LIST(pttmode_explct, lun,
     .		lo_date(:slen)//' -> '//hi_date(:slen)//'    '
     .		//sf_name(istep), 0 )
	   ENDIF
 300	CONTINUE

* insert blank line for nicer formatting
	CALL SPLIT_LIST(pttmode_explct, lun, ' ', 1)

	RETURN
	END

      SUBROUTINE COMRD5(ICOM,X,M,ILB,N,IFLAG) 
C** 
C**    @(#)comrd5.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*     *jd 11.94 - modified for AIX port
*       Modification uses TM_NUMBER to determine if "value" is a number rather
*       than the ERR= branch of a READ which fails on AIX/xlf
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 

      CHARACTER ICOM*(*),ILB*(*),IN*80,LT*1,JX*20,IF*8,IA*1 
      CHARACTER NAME*81,INTEMP*80,PRMPT*40
      DIMENSION X(*),IFLAG(*)
#ifndef unix
	byte iab
	equivalence (iab,ia)
#endif 
      COMMON/CEFTN5/ IN,IA,LT,NAME,INTEMP
      COMMON/CDFTN5/LN 
      COMMON/CPFTN5/PRMPT


#ifdef unix
CC   If unix, initialize IN in block data stmt in cmrdst.F.  The block data
CC   is declared external in subroutine CMRDST in that file.
      DATA J,KM/0,80/
#else
      DATA J,KM,IN/0,80,' '/ 
#endif

C 
      LOGICAL TM_NUMBER                ! ** TMAP mod 11/94 **
C
C     THIS ROUTINE WAS WRITTEN BY DON DENBO IN MAY, 1980 
C     IT IS LIKE COMRD BUT WRITTEN IN FORTRAN 77 
C     SEE MILELIB DOC FOR DETAILS. 
C     MODIFIED FOR PDP 11 IN AUGUST 1983 BY D. DENBO
C 
      ICOM=' ' 
      ILB=' ' 
      M=0 
      N=0 
      IFLAG(1)=0 
      IF(J.NE.0)GOTO 21 
#ifdef unix
	IF(NAME(1:3).EQ.'/dev/tty')WRITE(LN,PRMPT)
#else
	IF(NAME(1:3).EQ.'TT:')WRITE(LN,PRMPT)
#endif
      READ(LN,'(A80)',END=901)IN 
      DO 20 KM=80,1,-1 
      IF(IN(KM:KM).NE.' ')GOTO 21 
20    CONTINUE 
21	K=INDEX(IN(J+1:),LT)+J
	IF(K.EQ.J)K=81
	INTEMP=IN(J+1:K-1)
 	CALL NEFTN5(J,KM,IS)
	GOTO (200,31,22,23,900),IS
22    M=1 
      GOTO 31 
23    J0=J 
#ifndef unix
	jb=iab
	iab=iand(jb,95)
#endif
      ICOM=IA 
      DO 30 I=2,10 
	CALL NEFTN5(J,KM,IS)
#ifdef unix
	GOTO (30,33,33,30,33),IS
#else
	goto (29,33,33,29,33),is
29	jb=iab
	iab=iand(j,95)
#endif
30	ICOM(I:I)=IA
      J=J0 
      ICOM=' ' 
      GOTO 32 
33    IF(IA.EQ.LT.OR.J.GT.KM)GOTO 900 
31	CALL NEFTN5(J,KM,IS)
	GOTO (200,31,32,300,900),IS
32    M=M+1 
      IFLAG(M)=0 
      GOTO 31 
300   ILB=IA 
      N=1 
      DO 60 J=J+1,KM 
      IA=IN(J:J) 
      IF(IA.EQ.LT)GOTO 900 
      N=N+1 
	ILB(N:N)=IA
60    CONTINUE 
      GOTO 900 
200   M=M+1 
      JX=IA 
      K=1 
90	CALL NEFTN5(J,KM,IS)
	GOTO (80,81,81,80,81),IS
 80    K=K+1 
	JX(K:K)=IA
      GOTO 90 
81	WRITE(IF,'(''(E'',I2,''.0)'')')K
      IFLAG(M)=1 

#ifdef AIX_XLF
      IF ( .NOT.TM_NUMBER(JX) ) GOTO 40  ! ** TMAP mod 11/94 **
#endif
      READ(JX,IF,ERR=40)X(M) 
40    IF(IA.EQ.LT.OR.J.GT.KM)GOTO 900 
      IF(IA.EQ.',')GOTO 31 
100	CALL NEFTN5(J,KM,IS)
	GOTO (200,100,31,300,900),IS
900   IF(IA.EQ.LT)RETURN 
      J=0 
      RETURN 
c
c	eof read
c
901   continue
c	CLOSE(LN) 
c	OPEN(LN,FILE=NAME,STATUS='UNKNOWN') 
      RETURN 
      END 

	SUBROUTINE TM_AXIS_ORDER( lines_n, user_perm, order, ndim, vname )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* based on 1 to lines_n axes pointed to by lines_n try to determine how to place
* this object in lines_n dimensional space
* e.g. if the axes are X,Y and T then slot 3 should probably be NORMAL
* suppose further that axis 2 has no units or clues to its orientation
* then our problem is to map  3 dimensions "XNT" to an ordering of 1240

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* revision 0.0 3/92 for TMAP library
* Linux port -kob - 3/97 - Modify include for tmap_dset.parm to be a
*			   preprocessor include for F90 - needed because
*			   tmap_dset.parm contains an ifdef
* V500 *sh*  6/99 - added user_perm (permutation) input argument allowing the
*		user to coach this routine on the ordering of the axes
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing

        include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
        include 'xtm_grid.cmn_text'
        include 'xio.cmn_text'
        include 'xrisc_buff.cmn'

        INTEGER tt  ! nice short name
        EQUIVALENCE (tt,lunit_errors)

* calling argument declarations:
      INTEGER lines_n(nferdims), user_perm(nferdims), order(nferdims), ndim
      CHARACTER*(*) vname

* internal variable declarations:
!      LOGICAL TM_FIRM_AXIS_ORIENT, present
      LOGICAL var_perm
      INTEGER TM_AXIS_DIRECTION, idim, lasdim, vlen, mdim, nuser,
     .	      ax1, firm_dim, orient, i, ii, perm(nferdims), 
     .	      new1, reorder(nferdims), imin, imax

* initialize
      DO 10 idim = 1, nferdims
 10   order(idim) = unspecified_int4
      mdim =  MIN(nferdims, ndim)

* number of user-specified axes?
	nuser = 0
	DO 20 idim = 1, nferdims
	   IF (user_perm(idim) .NE.unspecified_int4) THEN
	      nuser = nuser + 1
	   ELSE
	      GOTO 30
	   ENDIF
 20	CONTINUE


* nothing happens here!
* arguably, one should permute the negatives so that they refer to
* the axis in the file, rather than the axis in memory. But it was too
* big a hassle (*sh*)
 30	DO 36 idim = 1, nferdims
 36	perm(idim) = user_perm(idim)


	IF (nuser .EQ. 0) THEN
	   ax1 = 0+1    ! user specified no axis orientations (typical)
	ELSE

****** user-specified axis order ******

	   IF (nuser .EQ. mdim) THEN
* ... all axes were specified by the user e.g. /ORDER=YXT for a 3D grid
	      DO 50 idim = 1, mdim
 50	      order(idim) = perm(idim)
	      ax1 = mdim + 1
	   ELSEIF (nuser .LT. mdim) THEN
* ... user gave list shorter than mdim -- apply list to initial axes
*     e.g. /ORDER=YX on an XYT grid will first process X and Y
	      DO 60 idim = 1, nuser
 60	      order(idim) = perm(idim)
* ... now map the remaining axes
* ... first map self-oriented axes if they match an unused orientation
	      DO 62 idim = nuser+1, mdim
	         orient = TM_AXIS_DIRECTION(lines_n(idim))
	         IF (orient .NE. 0) THEN
	            DO 61 i = 1, mdim
 61		    IF (ABS(order(i)).EQ.orient) GOTO 62
	            nuser = nuser + 1
	            order(nuser) = orient
	         ENDIF
 62	      CONTINUE
* ... then map any remaining axes to any unused orientations
	      DO 66 idim = nuser+1, mdim
* ... find unused orientation
	         DO 64 orient = 1, nferdims
	            DO 63 i = 1, idim
 63		    IF (ABS(order(i)) .EQ. orient) GOTO 64 ! in use
		    GOTO 65   ! found a free one
 64		 CONTINUE
	         CONTINUE   ! should never get here !!!
* ... assign axis
 65		 order(idim) = orient
 66	      CONTINUE
	      ax1 = mdim + 1
	   ELSE
* ... user gave list longer than mdim ... how to use this info? (messy)     
*     e.g. /ORDER=YXT on a 2D grid of "?T" orientation should map to XT
* ==> just use as much of the users mapping as applies
	      DO 70 idim = 1, mdim
 70	      order(idim) = perm(idim)
	      ax1 = mdim + 1

!* this block of logic abandoned as making Ferret "too intellligent"
!* because it has imperfection. For example /ORDER=TXYZ given for a
!* firmly XYT grid maps to "XYZ" because Ferret identifies the "X" axis
!* as "firm" first off
!
!*     Step 1: find the first axis of the grid whose orientation is
!*     known with high certainty. Try to map this to a user-given axis
!	      DO 76 firm_dim = 1, mdim
!	         IF (TM_FIRM_AXIS_ORIENT(lines_n(firm_dim), orient)) THEN
!*     ... check that this orientation is in the users list
!	            DO 72 idim = 1, nuser 
!	               IF (orient .EQ. ABS(perm(idim))) THEN
!*     ... check that this orientation is possible to work with
!*         e.g.  /ORDER=YXT with lines_n(1) of 2D grid matching "T" is bad
!*	                or with lines_n(2) of 2D grid matching "Y" is bad
!	                  IF ( (nuser-idim).GE.(mdim-firm_dim)
!     .			 .AND.  idim .GE. firm_dim ) GOTO 80
!	               ENDIF
! 72		    CONTINUE
!	         ENDIF
! 76	      CONTINUE
!*     ... nothing firmly known. Just start from first axis
!	      firm_dim = 1
!	      idim = 1
!*     Step 2: map the orientations to the left and right of firm_dim
! 80	      order(firm_dim) = perm(idim)
!	      DO 84 i = firm_dim-1,1,-1
! 84	      order(i) = perm(idim-(firm_dim-i))
!	      DO 86 i = firm_dim+1,mdim
! 86	      order(i) = perm(idim-(firm_dim-i))
!	      ax1 = mdim + 1

	   ENDIF
	ENDIF

****** automatic determination of axis order ******

* ... pass 1:  e.g. map to 1 0 4 -111
      imax = 0
      imin = nferdims
      DO 100 idim = ax1, mdim
         order(idim) = TM_AXIS_DIRECTION(lines_n(idim))
	 imax = MAX(imax, order(idim))
	 IF (order(idim).GT.0) imin = MIN(imin, order(idim))
 100  CONTINUE
* ..  pass 2: e.g. map "N" to "Y" to give 1 2 4 0

* ..  Is there a dimension before the x dimension?
*     If so create a permutation.

      IF ( imax.GT.0 .AND. imin.EQ.1 .AND. order(1).EQ.0 ) THEN
         var_perm = imax.GT.0 .AND. imin.EQ.1
         IF (mdim .EQ. 2) THEN  ! simple case, put the dimension in slot 1.
	    order(1) = MOD(imax,nferdims) + 1
	    GOTO 160
	 ENDIF

         lasdim = 0  ! more than 2 dims, keep the order, put dimension afterwards.
         DO 110 idim = 2, nferdims
	    IF (order(idim) .EQ. unspecified_int4) THEN 
	       order(idim) = MOD(imax,nferdims) + 1
	       new1 = idim-1
	       GOTO 120
	    ENDIF
 110     CONTINUE
 120     CONTINUE
         
         DO 130 idim = ax1, mdim
	    reorder(idim) = order(new1)
	    new1 = new1 + 1
	    IF (order(new1) .EQ. unspecified_int4 .OR. 
     .          new1 .EQ. nferdims) new1 = 1
	    IF (order(new1) .EQ. 0) new1 = new1 + 1
 130     CONTINUE
         DO 140 idim = mdim+1, nferdims
	    reorder(idim) = unspecified_int4
 140     CONTINUE
         DO 150 idim = 1, nferdims
	    order(idim) = reorder(idim)
 150     CONTINUE

      ENDIF

 160  CONTINUE

      lasdim = 0
      DO 200 idim = 1, nferdims
         IF ( order(idim).EQ.0 ) THEN
*     need to use MOD to prevent more than nferdims dimensions...*kob* 5/02
            lasdim = MOD(lasdim,nferdims) + 1
            IF (var_perm) lasdim = MOD(imax,nferdims) + 1
            order(idim) = lasdim
         ELSEIF (order(idim).NE.unspecified_int4 ) THEN
            lasdim = ABS(order(idim))
         ELSE
            order(idim) = 0
         ENDIF
 200  CONTINUE

* ... pass 3: if out of order (e.g. YXT given) a problem
*             ==> remap to most basic
* 6/99 - only REPEATED axes are a problem -- permutations OK
      lasdim = 0
      DO 310 idim = 1, nferdims
	 DO 300 i = 1, idim-1
            IF ( order(i) .NE. 0
     .     .AND. ABS(order(i)) .EQ. ABS(order(idim)) ) GOTO 500
 300	 CONTINUE
 310  CONTINUE


* remap the lines_n array to match TMAP nferdims-dimensional ordering instead of
* netCDF file ordering. For example, change an XYT grid from current
* line1, line2, line4, unspecified to line1, line2, unspecified, line4
!	i = mdim
!	DO 410 idim = nferdims, 1, -1
!* ... is this axis present in the grid
!	   present = .FALSE.
!	   DO 400 ii = 1, nferdims
!	      IF (ABS(order(ii)) .EQ. idim) present = .TRUE.
! 400	   CONTINUE
!	   IF (present) THEN
!	      lines_n(idim) = lines_n(i)
!	      i = i - 1
!	   ELSE
!	      lines_n(idim) = unspecified_int4
!	   ENDIF
! 410	CONTINUE

* success
      RETURN

* failure - select most basic order
 500  DO 600 idim = 1, nferdims
         IF ( idim .LE. mdim ) THEN
            order(idim) = idim
         ELSE
            order(idim) = 0
         ENDIF
 600  CONTINUE

* sound a warning horn
      risc_buff = vname
      vlen = LEN(vname)
      CALL TM_NOTE( 'Unspecified or unsupported ordering of axes in variable '
     .               //risc_buff(:vlen), tt )
      CALL TM_NOTE( 'The default ordering will be used', tt )

      RETURN
      END

      SUBROUTINE MTDAT(IT,STR)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)mttime.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
	REAL IT(3)
      CHARACTER STR*(*),MONTH(12)*3
      DATA MONTH/'JAN','FEB','MAR','APR','MAY','JUN',
     *           'JUL','AUG','SEP','OCT','NOV','DEC'/
      CALL MTMDY(IT,IM,ID,IY)
      IH=IT(3)
      WRITE(STR,999)MONTH(IM),ID,1900+IY,IH
999   FORMAT(A3,I3,',',I4,I6.4)
      RETURN
      END
      SUBROUTINE MTMDY(IT,IM,ID,IY)
	REAL IT(3)
      DIMENSION IMN(12)
      DATA IMN/1,32,60,91,121,152,182,213,244,274,305,335/
      IY=IT(1)
      IJ=IT(2)
      ITST=1
      IF(IY-(IY/4)*4.EQ.0)ITST=0
      IF(IJ.LT.61-ITST)THEN
      IM=IJ/32+1
      ID=IJ-IMN(IM)+1
      ELSE
      IM=INT((IJ+ITST)/30.6001+.02)+1
      ID=IJ-IMN(IM)+ITST
      END IF
      RETURN
      ENTRY MDYMT(IT,IM,ID,IY)
      IT(1)=IY
      IF(IY-(IY/4)*4.EQ.0)THEN
      IF(IM.LT.3)THEN
      IT(2)=IMN(IM)+ID-1
      ELSE
      IT(2)=IMN(IM)+ID
      END IF
      ELSE
      IT(2)=IMN(IM)+ID-1
      END IF
      RETURN
      END
      INTEGER*4 FUNCTION MTMIN(MTIME)
C     REVISED VERSION THAT WILL WORK FOR LEAP YEARS
C     MINUTES SINCE 1-1-1970
	REAL MTIME(3)
	INTEGER*4 JDN
      CALL MTMDY(MTIME,IM,ID,IY)
      JH=MTIME(3)/100
      JM=AMOD(MTIME(3),100.)
      IF(IM.GT.2)THEN
      IM=IM+1
      ELSE
      IY=IY-1
      IM=IM+13
      END IF
#ifdef unix
      JDN=INT(365.25*IY)+INT(30.6001*IM)+ID-25631
#else
      JDN=JINT(365.25*IY)+JINT(30.6001*IM)+ID-25631
#endif
      MTMIN=JDN*1440+JH*60+JM
      RETURN
      END
      SUBROUTINE MINMT(NMS70,IT)
C     REVISED VERSION THAT DOES LEAP YEAR CORRECTLY
	REAL IT(3)
	INTEGER*4 NMS70,JDN
      JDN=(NMS70/1440)+25631
      IY=INT((JDN-122.1)/365.25)
#ifdef unix
      IM=INT((JDN-INT(365.25*IY))/30.6001)
      ID=JDN-INT(365.25*IY)-INT(30.6001*IM)
#else
      IM=INT((JDN-JINT(365.25*IY))/30.6001)
      ID=JDN-JINT(365.25*IY)-JINT(30.6001*IM)
#endif
      IF(IM.LT.14)THEN
      IM=IM-1
      ELSE
      IM=IM-13
      IY=IY+1
      END IF
      CALL MDYMT(IT,IM,ID,IY)
      LEFT=NMS70-(NMS70/1440)*1440
      IH=(LEFT/60)
      IM=LEFT-60*IH
      IT(3)=IH*100+IM
      RETURN
      END

	SUBROUTINE ALINE (x,nxs)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Processes ALINE command buffer and manages aline database
*	J Davison 10.16.89
*	11.9.93 Mod to put immediate mode output in segments
* v552 *acm* 3/03 Longer strings: changes for multi-line labels.

	include 	'parampl5_dat.decl'            
	include 	'PARAMPL5.DAT'            
	include 	'cmrd_inc.decl'            
	include 	'CMRD.INC'            
	include 	'cmrdl_inc.decl'            
	include 	'CMRDL.INC'            
	include 	'lines_inc.decl'            
	include 	'LINES.INC'            
	include 	'aline.cmn'            
	include 	'switch_inc.decl'            
	include 	'SWITCH.INC'            

* special COMMON to let this routine know if FERRET is in control
        include 'ppl_in_ferret.cmn'
  
	integer		nxs,end,a_line,i
	real		x(nxs),minx,miny,maxx,maxy
	character*2048	str

********************************************************************************

	call upnsquish (label,str,end)
                                
*	IF NO LABEL, EXECUTE ALINE COMMAND IMMEDIATELY
	if (end .eq. 0) then

*	   CANCEL ALL SET LINES IF COMMAND IS SIMPLY 'ALINE'
	   if (m .eq. 0) then
	      do 10 i = 1,nlines
		 aline_on(i) = .false.
10	      continue
	   end if 

*	   OTHERWISE REQUIRE ALL ARGUMENTS   
	   if (m .ne. 5) return
	   
	   if (p(1) .gt. 0 .and. p(1) .le. nlines) then
	      a_line = p(1)
	   else                   
	      a_line = 1               
	   end if 

*	   HANDLE /USER & /NOUSER COORDINATES PROPERLY
	   if (suser) then
	      minx = p(2)
	      miny = p(3)
	      maxx = p(4)
	      maxy = p(5)
	   else
	      call point_convert (p(2),p(3),minx,miny)
	      call point_convert (p(4),p(5),maxx,maxy)
	   end if

!          Mod 11.9.93 to insert aline immediate output into segments
*          TMAP check that output window is active
           IF ( PPL_in_FERRET ) CALL CK_GKS_ACTIVE( *9999 )
*          TMAP addition to turn on segment
           IF ( PPL_in_FERRET ) CALL SEG_ON( )

	   call aline_sub (x,nxs,a_line,minx,miny,maxx,maxy)
           IF ( PPL_in_FERRET ) CALL SEG_OFF
9999	   return
	end if

*	IF LABEL = 'ON' THEN SET ALINE FOR THIS LINE#                          
	if (str(1:2) .eq. 'ON') then
	   if (m .eq. 5 .and. p(1) .gt. 0 .and. p(1) .le. nlines) then
	      a_line			= p(1)
	      aline_on(a_line)		= .true.
	      aline_user(a_line)	= suser
	      aline_minx(a_line)	= p(2)
	      aline_miny(a_line)	= p(3)
	      aline_maxx(a_line)	= p(4)
	      aline_maxy(a_line)	= p(5)
	   end if
	   return
	end if

*	IF LABEL = 'OFF' THEN CANCEL ALINE FOR THIS LINE#
	if (str(1:3) .eq. 'OFF') then
	   a_line 			= p(1)
	   aline_on(a_line)		= .false.
	end if

	return

	end

      SUBROUTINE WINDOW(XALOW,YALOW,XAHIGH,YAHIGH)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)window.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     CALL WINDOW(XLOW,YLOW,XHIGH,YHIGH)
C
C     THIS SUBROUTINE DEFINES A PLOTTING AREA THAT HAS DIFFERENT
C     BOUNDARIES THAN THE COMPLETE DISPLAY DEFINED BY SIZE.  AF-
C     TER A CALL TO THIS SUBROUTINE, ALL SUBSEQUENT PLOTTING MUST
C     LIE WITHIN BOTH SETS OF BOUNDARIES IN ORDER TO BE VISIBLE.
C
C     THE VARIOUS PARAMETERS AND THEIR DEFINITIONS ARE LISTED
C     BELOW:
C        XLOW   - MINIMUM X-VALUE TO BE PLOTTED IN USER'S UNITS.
C        YLOW   - MINIMUM Y-VALUE TO BE PLOTTED IN USER'S UNITS.
C        XHIGH  - MAXIMUM X-VALUE TO BE PLOTTED IN USER'S UNITS.
C        YHIGH  - MAXIMUM Y-VALUE TO BE PLOTTED IN USER'S UNITS.
C
C
#ifdef unix
	include 'PLTCOM.DAT'
#else
	include 'pplinc:PLTCOM.DAT'
#endif
C
C     TRANSFER THE PARAMETERS TO NEW VARIABLES.
C
      XLOW = XALOW
      XHIGH = XAHIGH
      YLOW = YALOW
      YHIGH = YAHIGH
      IF(XHIGH .NE. XLOW .AND. YHIGH .NE. YLOW)THEN
C
C     SET THE WINDOW FLAG.
C
        WINDOF = .TRUE.
C
C     SET THE MINIMUM AND MAXIMUM ALLOWABLE VALUES OF X AND Y.
C
        XMIN = XLOW * XSCALE
        YMIN = YLOW * YSCALE
        XMAX = XHIGH * XSCALE
        YMAX = YHIGH * YSCALE
C
C     CHECK THE PARAMETERS TO MAKE SURE THAT THEY ARE VALID.
C
        IF(XMIN .GT. XMAX)THEN
          TEMP = XMIN
          XMIN = XMAX
          XMAX = TEMP
        ENDIF
        IF(YMIN .GT. YMAX)THEN
          TEMP = YMIN
          YMIN = YMAX
          YMAX = TEMP
        ENDIF
C
C     CALCULATE THE OFF-WINDOW FLAG.
C
        LOWFLG = 0
        IF(XOLD .GT. XMAX)LOWFLG = 1
        IF(XOLD .LT. XMIN)LOWFLG = 2
        IF(YOLD .GT. YMAX)LOWFLG = LOWFLG + 4
        IF(YOLD .LT. YMIN)LOWFLG = LOWFLG + 8
      ELSE
C
C     RESET THE WINDOW FLAG.
C
        WINDOF = .FALSE.
        OWFLG = 0
      ENDIF
      RETURN
C
      END

	CHARACTER*14 FUNCTION MERGED_WHOI_DATE( cx_list, idim, ncx, dayflag )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* create a string of the form YYMMDDHHMMSSCC (internal ordering) based
* on the earlies time to be plotted from the given contexts

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V420: 11/27/95 - 4-digit YEARS!!
* V530:  1/01 *acm* cal_id for alternative calendar axis types
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
*                  A time axis may be a T axis or F axis
* V695  *acm* 9/15 Changes for HH:MM labeling when plotting short time range.
*                  For these axes reset the start time by only a day.

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'ferret.parm'
	include 'xcontext.cmn'

* calling argument declarations
	INTEGER	ncx, cx_list(ncx), idim
	LOGICAL dayflag

* internal variable declarations
	INTEGER 	yr100, yr, mon, day, hr, mn, sec,
     .			status, i, grid, cx, axis
        INTEGER		TM_GET_CALENDAR_ID, cal_id
	CHARACTER*20	TM_SECS_TO_DATE, date
	REAL*8		TSTEP_TO_SECS, bcsecs

* internal parameter declarations
	REAL*8		yrofsecs
	PARAMETER     ( yrofsecs = 60.*60.*24.*365. )
	REAL*8		dayofsecs
	PARAMETER     ( dayofsecs = 60.*60.*24. )

* determne the earliest date to be plotted
	DO 100 i = 1, ncx
	   cx = cx_list(i)
	   grid = cx_grid(cx)
	   IF ( i .EQ. 1 ) THEN
	      bcsecs = TSTEP_TO_SECS( grid, idim, cx_lo_ww(idim,cx) )
	   ELSE
	      bcsecs = MIN( bcsecs,
     .		       TSTEP_TO_SECS( grid, idim, cx_lo_ww(idim,cx) ) )
	   ENDIF

* Convert to date
          axis = grid_line ( idim, grid)
          cal_id = TM_GET_CALENDAR_ID(line_cal_name(axis) )

* arbitrarily subtract a year -- needed cuz PLOT* rounds down the "tmin" value
* OR, subtract a day when plotting short time ranges. This gives us
* more precision to work with in time data (origin, scaling on the page).

	  IF (dayflag) THEN
	     bcsecs = MAX( 0.0D0, bcsecs - dayofsecs )
	  ELSE
	     bcsecs = MAX( 0.0D0, bcsecs - yrofsecs )
	  ENDIF
	  date = TM_SECS_TO_DATE(bcsecs, cal_id)

 100	CONTINUE

* break the date string into component integer values
	CALL TM_BREAK_DATE( date, cal_id, 
     .                      yr, mon, day, hr, mn, sec, status )
	yr100 = yr/100		! 1980 --> 19
	yr = yr - (yr100*100)	! 1982 --> 82

* assemble the pieces in WHOI format
	WRITE (MERGED_WHOI_DATE,3000) yr,mon,day,hr,mn,sec,yr100
 3000	FORMAT (7I2.2)

	RETURN
	END

      SUBROUTINE XAXIS1(XLO,XHI,XTIC,NSMTCX,LINTX,XUNIT,LABEL,
     *    IFORMT,XFACT,Y,YFACT,CSIZE,yacross,xdms,xdspac,vgrat,vcolor,
     *    vline, xvaloff,color0)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* revised for TMAP
* from PPLUS :
*	Directory PMEL:[PLOT5.PPLV11.PLOTLIB]XAXIS1.FOR

* search for "TMAP" to find all revisions
* *sh*  - 1/23/89 added interrupt detection
*		  ... no explicit declarations (too much trouble !) so it must
*		      be compiled with /WARNINGS=NODECLARATIONS
*	*jd* 5.6.96 Fix axis labelling bug where roundoff at zero results 
*			in small non-zero values
* v554: *acm* 2/04 add /HGRAT /VGRAT to draw optional graticule lines at tic marks
C *acm* 11/05  new argument to scinot deg/min/sec labels
C        1/06  xvaloff,yvaloff add this amount to each x or y axis label. 
C              (axis data was read as double precision and converted to single 
C              after applying an offset.)
* V7    *acm* 6/16 Ticket 2434: command qualifiers /DEGMINSEC= /HALFSPAC
*                  DEGMINSEC=1 for Deg-Min axis labels, =2 for Deg-Min-Sec. Default = 1
*                  /HALFSPAC adds a half space between the degree sign and E/W or N/S
* *acm* - 8/16   ticket 1787: restore pen 0 correctly after graticule
* *acm* - 11/16  ticket 2477: incomplete axis on some plots


C**
C**    @(#)xaxis1.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C**

        INTEGER xdms, xdspac
	CHARACTER*1 LETTER
	REAL SYMWID, spacwid
	LOGICAL do_shift

* Parameters for drawing tics across plot

        REAL yacross, dash1, dash2,dash3,dash4, xvaloff
        REAL vgrat(4,2)        ! line type: 0=tics only, <0=line, >0=dash lengths 
        INTEGER vcolor(*)      ! pen number for graticule lines
	INTEGER color0	       ! pen number to restore 
        LOGICAL vline          ! If true, do the lines across.
        LOGICAL solid          ! solid lines across at tics
        LOGICAL dashed         ! dashed lines across at tics
	CHARACTER IFORMT*(*),XLAB*20
	COMMON/TICS/TSMX,TLX,TSMY,TLY,IX,IY
	COMMON/AXLWID/XWID,YWID

	parameter (epsilon = 1.e-6)


* TMAP interrupt flag
	include 'xinterrupt.cmn'
        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'lines_inc.decl'
        include 'LINES.INC'
        INCLUDE 'pen_inc.decl'  ! with IPEN(1)
        INCLUDE 'PEN.INC'

C     THIS ROUTINE DRAWS AN X AXIS.  IT LABELS THE AXIS BELOW
C     IF LABEL=-1, ABOVE IF LABEL=1, AND NOT AT ALL
C     IF LABEL=0.  IF LABEL.NE.0 IFORMT TELLS US WHAT FORMAT TO WRITE
C     THE LABEL IN.  SEE NCHAR PARAMETER IN COMPLOT DOCUMENTATION
C     FOR THE SUBROUTINE NUMBER FOR AN EXPLANATION OF THIS.
C     MODIFICATION OF JULY 29,1979.
C     WE HAVE CHANGED THE MEANING OF IFORMT.
C     USE -10<=IFORMT<=+10 AS BEFORE OR BETTER YET:
C     USE IFORMT = 10H(I7*BALL*)
C                 = 7H(F10.2)  FOR EXAMPLE
C     IN THIS OPTION OUR SUBROUTINE RECONIZES AN I FORMAT BY USING
C     THE FACT THAT THE FIRST TWO CHARACTERS OF IFORMT ARE "(I".
C     IN FACT IF YOU DIMENSION IFORMT IN THE CALLING PROGRAM YOU
C     CAN EVEN USE FORMAT STATEMENTS THAT ARE LONGER THAN 10 CHARACTERS.
C     HOWEVER, THE PRINTED LABEL MUST BE <=20 CHARACTERS.
C
CCC
CCC     THE FOLLOWING SECTION OF CODE MAKES THIS ROUTINE UPWARD COMPATIABLE.
        ABSSZ=ABS(CSIZE)
        SIGSZ=SIGN(1.,CSIZE)
C
C	DRAW AXIS
C
	DIR=SIGN(1.,XTIC)
	XT=INT(XLO/XTIC+SIGN(0.000001,DIR*XLO))*XTIC
	IF(DIR*XT.LT.DIR*XLO)XT=XT+XTIC
	ISTOP=IFIX((XHI-XT)/XTIC+0.000001)
	CALL PLOT(XT,Y,0,0)
	CALL SMX1(XT,XLO,-XTIC,NSMTCX,XFACT,YFACT,Y,
     *    yacross,vgrat,vcolor,vline)
	CALL PLOTT7(XT,Y,XFACT,YFACT,1,-8)
	X=XT
        
        solid = (vgrat(1,1).LT.0 .AND. vgrat(2,1).LT.0 .AND.  
     .            vgrat(3,1).LT.0 .AND.  vgrat(4,1).LT.0 )
        dashed = (vgrat(1,1).GT.0 .OR. vgrat(2,1).GT.0 .OR.  
     .            vgrat(3,1).GT.0 .OR.  vgrat(4,1).GT.0 )
        IF (dashed) THEN
           dash1 = vgrat(1,1)
           dash2 = vgrat(2,1)
           dash3 = vgrat(3,1)
           dash4 = vgrat(4,1)
        ENDIF

	DO 100 I=1,ISTOP
	IF ( interrupted ) RETURN		! TMAP interrupt
	CALL SMX1(X,XHI,XTIC,NSMTCX,XFACT,YFACT,Y,
     *    yacross,vgrat,vcolor,vline)
        IF ((solid.OR.dashed) .AND. vline) THEN ! make line across
           CALL COLOR(vcolor(1))
           IF (dashed) THEN
              CALL DASHSZ(dash1,dash2,dash3,dash4)
              CALL DASHES
           ENDIF
           CALL PLOT(X,Y,0,0) 
           CALL PLOT(X,yacross,1,0)
           CALL PLOT(X,Y,0,0) 
           CALL COLOR(color0)
           CALL VECTRS
        ENDIF

	X=X+XTIC
	CALL PLOTT7(X,Y,XFACT,YFACT,1,-8)
100	CONTINUE
	CALL SMX1(X,XHI,XTIC,NSMTCX,XFACT,YFACT,Y,
     *    yacross,vgrat,vcolor,vline)
        
        IF ((solid.OR.dashed) .AND. vline) THEN ! make line across
           CALL COLOR(vcolor(1))
           IF (dashed) THEN
              CALL DASHSZ(dash1,dash2,dash3,dash4)
              CALL DASHES
           ENDIF
           CALL PLOT(X,Y,0,0) 
           CALL PLOT(X,yacross,1,0)
           CALL PLOT(X,Y,0,0) 
           CALL COLOR(color0)
           CALL VECTRS
        ENDIF

	CALL PLOT(XLO,Y,1,0)
	CALL PLOT(XHI,Y,1,0)
           
C
C	DRAW LABELS
C
	IF(LABEL.EQ.0)RETURN
	IF(LABEL+IX.EQ.0)THEN
		YTEMP=0.0
	ELSE
		YTEMP=TLX*0.5
	ENDIF
	XWID=1.9*ABSSZ+YTEMP
	YTEMP=Y+LABEL*(1.40*ABSSZ+YTEMP)/YFACT
	IF(DIR*XLO.LE.0.AND.DIR*XHI.GE.0)THEN
		X=INT(XLO/(XTIC*LINTX)-0.000001)*XTIC*LINTX
	ELSE
		X=XT
	ENDIF
	ISTOP=INT((XHI-X)/(XTIC*LINTX)+0.000001)
	LETTER = ' '

	TEMP=SIGSZ*X/XUNIT
	CALL NUMCDE(TEMP,XLAB,LETTER,NC,IFORMT,xdms)

	spacwid = 0.
	do_shift = ( INDEX(XLAB, '#') .GT. 0 )  ! longitude or latitude labels
	IF (do_shift) spacwid = SYMWID(ABSSZ,1,'E')

	x0 = x
	DO 200 I=0,ISTOP
	IF ( interrupted ) RETURN		! TMAP interrupt
        TEMP=SIGSZ*X/XUNIT
        IF (xvaloff .EQ. 0) THEN
          CALL NUMCDE(TEMP,XLAB,LETTER,NC,IFORMT,xdms)
        ELSE
          CALL NUMCDE_OFF (TEMP,XLAB,LETTER,NC,IFORMT,xdms,xvaloff)
        ENDIF

* Drawing the label without E/W or N/S, which is done separately.
* Adjust X location to allow for that.

	IF (do_shift) spacwid = SYMWID(ABSSZ,1,LETTER)

	IF (xdspac .GT. 0) THEN
	   XTEMP = X - (0.5*spacwid + 0.5*xdspac*spacwid)/XFACT 
	ELSE
	   XTEMP = X - 0.5*spacwid/XFACT 
	ENDIF

	CALL SCINOT(XTEMP,YTEMP,0.,ABSSZ,NC,XLAB,0,WID,XFACT,YFACT)
        IF (LETTER .NE. ' ') THEN
	   NL = 1
	   XL = XTEMP + 0.5*(WID + 0.5*xdspac*spacwid)/XFACT  ! 0.5* for horiz. centering
	   YL = YTEMP - 0.5*ABSSZ/YFACT                       ! SCINOT centers vertically
	   CALL SYMBEL(XL,YL,0.,ABSSZ,NL,LETTER)
	ENDIF

CC	Original code
CC	X=X+XTIC*LINTX

	X=x0+XTIC*LINTX*(i+1)
	if (abs(x) .lt. epsilon*abs(x0)) x = 0.0

200	CONTINUE
	RETURN
	END

	SUBROUTINE LINE_PLOT_LABELS (var1, nmv, ndv, cx_list, 
     .		this_no_range, overlay, versus, nokey, time_axis, 
     .		tstyle, cal_id_1, ribbon_var, indep_lab, dep_lab, 
     .		ind_min, dep_len, hlen, nfeatures, dset, ivar)

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Put titles on line plots. For multi-line or ribbon plots, add labels
* for multi-lines as a key, or a "colored by var2" label for the ribbon color variable
*
* Pulled out of plot_set_up.F 
* 8/12 ACM 
* V6.83 *acm* 11/30/2012 Need AXIS.INC for the axis lengths, xlen, ylen
* V71  *acm* 2/17  More on ticket 2231. Label set of line plots with their units
*                  if units are different. If PLOT/KEY=title given, use the variable
*                  title in the legend labels for both PLOT and PLOT/VS plots.
* v7.2 *acm* 4/2017 ticket 2446 Drawing formatted time axes on a PLOT/VS, label
*                  at the top with the year if needed.
* V74+ *acm*  4/18 additions for plotting trajectories from a dsg dataset
* V74+ 4/18 *acm*  Automatically do a colored trajectory plot for the command "PLOT var" 
*                  if it's a DSG trajectory set.
* V74+ 7/18 *acm*  Get the title right if its a dsg data in an /overlay.
* V74+ 7/18 *acm*  DSG-enabled Ferret: colorkey labels may be strings from the IDs
* V74+ 8/18 *acm*  DSG-enabled Ferret: label the independent axis with the variable title 
*                  as well as the units, 2-line label on a short axis e.g. in a viewport
* V74+ 3/19 *acm*  If we are plotting lines from a DSG dataset that have been regridded
*                  to an ordinary time axis, then the labels are just the line labels, not
*                  feature-id labels
* V75+ 5/19 *acm*  DSG-enabled Ferret: If there is only one feature (e.g. masked) then 
*                  multi-var plots are labeled as for non-DSG data, titles of each different 
*                  variable
* V751 6/19 *acm*  When multiple datasets are open need to take care to get the right feature-id var
* V751 7/19 *acm*  DSG-enabled Ferret: PLOT/KEY for DSG data will make a line legend consistent
*                  with multi-feature plots, even if there's just one feature.
* V751 7/19 *acm*  DSG-enabled Ferret: labels when plotting user-defined variables
* V751 8/19 *acm*  DSG-enabled Ferret: labels for modifications such as regridding operation
* V76  *acm* 11/19 Issue 1960: Place keys for overlay lines in multiple columns 
*                  below plot before resorting to putting them inside the plot box.
*                  If still too many legend lines, skip them rather than put up dialog box
* V760 *acm* 3/20 Customizations for case when constraints result in no features

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'plot_setup.parm'
	include 'errmsg.parm'
	include 'slash.parm'
	include 'xplot_setup.cmn'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'
	include 'axis_inc.decl'    ! with axis lengths 
	include 'AXIS.INC'         ! with axis lengths   
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xdset_info.cmn_text'
	include 'xdsg_context.cmn'
        include 'netcdf.inc'

* calling argument declarations:
	LOGICAL this_no_range(*), overlay, versus, nokey, time_axis
	INTEGER var1, nmv, ndv, cx_list(*), cal_id_1, ribbon_var, 
     .		indep_lab, dep_lab, nfeatures, dset, ivar
	REAL	dep_len, hlen
	REAL*8  ind_min
	CHARACTER*(*) tstyle

* internal variable declarations:
	LOGICAL TM_ITSA_DSG, user_title, units_same, do_units, its_dsg,
     .          reset_dsg, process_feature(nfeatures), yes_key
	INTEGER	TM_LENSTR1, TM_LENSTR, TM_UNIT_ID, STR_SAME, 
     .		TM_DSG_DSET_FROM_GRID,
     .		ipl, nline_in_mem, slen, slen1, status, ptitl, style, 
     .		justify, iunits, istart, i, nfeatr(nfeatures), dtype, 
     .		fvar_varid, dset_dsg, nlab
	
	CHARACTER*2040	FULL_VAR_TITLE, VAR_TITLE_ONLY, KEY_STRING, 
     .			plot_title, plot_title_1
	CHARACTER	VAR_UNITS*64, SECS_TO_DATE*20, TM_FMT*48,
     .			SANITARY_VAR_CODE*128, VAR_TITLE_MOD*240, 
     .			PAREN_SURROUND*240,CD_DSG_FEATURENAME*16,
     .			year*4, buff1*16, ustring*64, dummy*1024, buff2*40
	REAL		xkeypos, ykeypos, xkeysize, ykeysize, 
     .			lab_ht, labsize, value
	REAL*4		SYMWID, rht

	ptitl = qual_given( slash_title )
	user_title = ptitl .GT. 0

	its_dsg = .FALSE.
	reset_dsg = .FALSE.
	
	IF (cxdsg_empty_set) THEN
	   buff1 = CD_DSG_FEATURENAME ( cxdsg_orient )
	   buff2 = 'No '//buff1(:TM_LENSTR1(buff1))//
     .		       ' Data in Selection'
	ENDIF

* * * * * * *    - - - TITLES - - -   * * * * * * * * *
* if we are starting from a blank screen titling information is centered
* below the X axis - either a title for a single variable or keys for multiple
* if we are overlaying on an existing plot put the new variable name on as a
* key at the lower left

	IF (nfeatures.GT.0) THEN
	   its_dsg = .TRUE.

* create a mask showing which features to plot and a list of feature-numbers to label
* This may be a user-defined variable or expression on a DSG grid. Get the DSG dataset number.

	   dset_dsg = TM_DSG_DSET_FROM_GRID( cx_grid(is_cx(var1)) )
	   CALL MAKE_DSG_FEATURE_MASK(dset_dsg, cx_list(var1), process_feature, nfeatures)
	   ipl = 0
	   DO i = 1, nfeatures
	      IF (process_feature(i)) THEN
	         ipl = ipl + 1
		 nfeatr(ipl) = i
	      ENDIF
	   ENDDO

* The varid of the feature-id variable
 
	   dummy = SANITARY_VAR_CODE(cat_file_var, dsg_feature_var(dset_dsg) )
	   CALL CD_GET_VAR_ID  (dset_dsg, dummy, fvar_varid, status)

	ENDIF

* One feature but multi-vars. Label with variable names.  Add the feature-id
* to the dataset title above the plot.

	IF (its_dsg .AND. (ipl.EQ.1 .AND. (nmv-var1)+1.GT.1) ) THEN
	   reset_dsg = .TRUE.
	   its_dsg = .FALSE.  ! multi-var, one feature
	   
	   CALL CD_READ_ONE ( dset_dsg, fvar_varid, nfeatr(ipl), dtype, value, 
     .                        plot_title_1, slen, status )
	   CALL GET_DSET_TITLE (dset_dsg, dummy, slen)
	   slen = TM_LENSTR(dummy)
	   IF (slen .GT. 0) THEN
	      CALL SET_DSET_TITLE (dset_dsg, dummy(:TM_LENSTR1(dummy))//': ID='//plot_title_1)
	   ELSE
	      CALL SET_DSET_TITLE (dset_dsg, 'ID: '//plot_title_1)
	   ENDIF
	ENDIF


	IF (ribbon_plot) GOTO 1000


* * * * * * *    - - - TITLES - - -   * * * * * * * * *
* if we are starting from a blank screen titling information is centered
* below the X axis - either a title for a single variable or keys for multiple
* if we are overlaying on an existing plot put the new variable name on as a
* key at the lower left
	nline_in_mem = 0
	
	IF ( overlay ) THEN
	   DO 500 ipl = var1, nmv
	      nline_in_mem = nline_in_mem + 1
	      CALL OV_GRP_CX_DOC( cx_list(ipl), 1, cx_xtra_doc )
	      IF ( user_title ) THEN
	         CALL EQUAL_STR_LC(
     .			cmnd_buff(qual_start(ptitl):qual_end(ptitl)),
     .                  plot_title, status )
                 IF ( status .NE. ferr_ok ) GOTO 5000
	         slen = TM_LENSTR1( plot_title )
	      ELSE
	         plot_title = KEY_STRING( cx_list(ipl), cx_xtra_doc, slen )
	         IF (.NOT.use_keys) plot_title = VAR_TITLE_ONLY( cx_list(ipl), slen )
	      ENDIF
              IF (this_no_range(ipl) .AND. mode_nodata_lab) THEN
                 plot_title(slen+1:slen+14) = ' No Valid Data'
                 slen = slen + 14
              ENDIF
              IF (.NOT. nokey) THEN
	         CALL KEY_LOC( overlay, xkeypos, ykeypos, xkeysize, ykeysize,
     .			    lab_ht, style, justify, plot_title(:slen))
* key_loc returns xkeypos=-999 if it has run out of space.  Skip this key entry.
* Could notify the user ...
		 IF (INT(xkeypos) .EQ. unspecified_int4) THEN
c		    CALL WARN ('Too many lines for legend. Not labeling "'//
c     .			plot_title(:slen)//'")
		 ELSE
		    CALL PUT_KEY( nline_in_mem, plot_title(:slen),
     .			    xkeypos, ykeypos, xkeysize, ykeysize,
     .			    lab_ht, style, lab_loc_absolute, lab_loc_absolute )
		 ENDIF
              ENDIF
 500	   CONTINUE
	ELSE
* *kob* 1/00 check the variable time_axis before looking at
*            any time-relevant variables.
* ... basic position and data set labels 
*    ... does the year need special documentation? 
           year = unspecified_name4    ! assume no label needed by default 
           IF ( time_axis ) THEN 
*    ... document the year where the axis, itself, doesn't 
              IF ( tstyle.EQ.'MON' .OR. tstyle.EQ.'DAY' ) THEN 
                 ppl_buff = SECS_TO_DATE( ind_min, cal_id_1 ) 
                 year = ppl_buff(8:11) 
              ENDIF 
           ELSE
              IF ( tstyle.EQ.'MON' .OR. tstyle.EQ.'DAY' ) THEN  ! plot/vs with time variable
	         i = ind_min
                 WRITE (year, '(I4)') i
              ENDIF 
	   ENDIF

* *ACM* if time axis, then cal_id_1 is set to the calendar.  Label the
*       plot with the calendar name if there is non-standard calendar

	   CALL DISP_LABELS( cx_plot, year, cal_id_1 )

* If there are multiple variables with different units, do not label 
* the vertical axis with the units 

	   units_same = .FALSE.
	   ustring = VAR_UNITS(cx_list(var1))
	   IF (nmv .GT. var1) units_same = .TRUE.
	   DO 300 ipl = var1+1, nmv
	      IF (STR_SAME(ustring, VAR_UNITS(cx_list(ipl)) ) .NE. 0) 
     .	          units_same = .FALSE.
 300	   CONTINUE
	   IF (nmv.EQ.var1 .AND. .NOT.versus) units_same = .TRUE.

* ... label dependent axis with units if all variables have the same units
*     (over-written below if /vs)

	   plot_title = VAR_UNITS( cx_list(var1) )
	   slen = TM_LENSTR1( plot_title )
	   IF (units_same) CALL BOX_LABEL( dep_lab,
     .			   plot_title(:slen),
     .			   0.0, 0.0, 0.6*dep_len, letsize_label,
     .			   letsize_label, ppl_centered,
     .			   lab_loc_absolute, lab_loc_absolute )

* ... keys for the dependent vars, or if one, only the title or axis label
*     To do a line-legend key even for one line, issue PLOT command with PLOT/KEY

	   DO 600 ipl = var1, nmv
	      nline_in_mem = nline_in_mem + 1

	      yes_key = use_keys .AND. (.NOT. nokey) .AND.nmv.GT.var1
	      IF (its_dsg .AND. nmv.EQ.1) yes_key = qual_given(slash_plot_key) .GT. 0

	      IF ( yes_key) THEN

	         IF ( its_dsg ) THEN 

* Read the feature-level value. If it's numeric turn it into a string

                    CALL CD_READ_ONE ( dset_dsg, fvar_varid, nfeatr(ipl), dtype, value, 
     .                                 plot_title, slen, status )
		    IF (dtype .NE. NF_CHAR) plot_title = TM_FMT(value, 15, 20, slen)

	         ELSE 
	            plot_title = KEY_STRING( cx_list(ipl), key_doc, slen )
	         ENDIF 

	      ELSE
	         IF (units_same .AND. .NOT.use_keys) THEN 
	            plot_title = VAR_TITLE_ONLY( cx_list(ipl), slen )
	         ELSE
		    do_units = .TRUE.
		    IF (nmv.EQ.var1 .AND. .NOT.versus) do_units = .FALSE.
		    plot_title = FULL_VAR_TITLE( cx_list(ipl), do_units, slen )
		 ENDIF
	      ENDIF
              IF (this_no_range(ipl) .AND. mode_nodata_lab) THEN
                 plot_title(slen+1:slen+14) = ' No Valid Data'
                 slen = slen + 14
              ENDIF

	      IF ( .NOT.yes_key .AND. (ndv .EQ. 1 .OR. user_title) ) THEN
	         IF ( versus ) THEN     ! ("xlen" changed to "dep_len" 11/92)
	            CALL BOX_LABEL( dep_lab,
     .			   plot_title(:slen),
     .			   0.0, 0.0, 0.6*dep_len, letsize_label,
     .			   letsize_label, ppl_centered,
     .			   lab_loc_absolute, lab_loc_absolute )
	         ENDIF
	         IF ( .NOT.versus .OR. user_title ) THEN 
	            IF ( user_title ) THEN     ! user over-ride of title
	               CALL EQUAL_STR_LC
     .			( cmnd_buff(qual_start(ptitl):qual_end(ptitl)),
     .                    plot_title, status )
                       IF ( status .NE. ferr_ok ) GOTO 5000
	               slen = TM_LENSTR1( plot_title )
	            ENDIF
	            CALL BOX_LABEL( ppl_title,
     .			   plot_title(:slen),
     .			   0.0, 0.0, 0.75*hlen, letsize_title,
     .			   letsize_title, ppl_centered,
     .			   lab_loc_absolute, lab_loc_absolute )
	         ENDIF
	      ELSE
                 IF (.NOT. nokey) THEN
	            CALL KEY_LOC( overlay, xkeypos, ykeypos, xkeysize, ykeysize,
     .			       lab_ht, style, justify, plot_title(:slen) )
	            CALL PUT_KEY( nline_in_mem, plot_title(:slen),
     .			       xkeypos, ykeypos, xkeysize, ykeysize,
     .			       lab_ht, style,
     .			       lab_loc_absolute, lab_loc_absolute )
	         ENDIF
	      ENDIF

 600	   CONTINUE

           IF (versus) THEN
	      do_units = .TRUE.
	      plot_title = FULL_VAR_TITLE( cx_list(1), do_units, slen )
              slen = TM_LENSTR1( plot_title )
              CALL BOX_LABEL( indep_lab,
     .                     plot_title(:slen),
     .                     0.0, 0.0, 0.6*hlen, letsize_label,
     .                     letsize_label, ppl_centered,
     .                     lab_loc_absolute, lab_loc_absolute )
           ELSE
	      IF (its_dsg) THEN

* Key was labeled with the feature-ids. Need the variable title, so put it on indep axis
	         IF (yes_key) THEN
		    plot_title = VAR_TITLE_ONLY( cx_list(var1), slen )

		    IF ( user_title ) CALL EQUAL_STR_LC(
     .			cmnd_buff(qual_start(ptitl):qual_end(ptitl)),
     .                  plot_title, status )

		    slen = TM_LENSTR1( plot_title )
		    plot_title_1 = plot_title(:slen)//
     .                     ' ('//ustring(:TM_LENSTR1(ustring))//')'

		    slen = TM_LENSTR1( plot_title_1 )
		    rht = letsize_label
		    IF (ylen .LT. SYMWID(rht, slen, plot_title_1) ) THEN
		       plot_title_1 = plot_title(:TM_LENSTR1(plot_title))//
     .                     '<NL>('//ustring(:TM_LENSTR1(ustring))//')'
		    ENDIF

		    slen = TM_LENSTR1( plot_title_1 )

		    plot_title = VAR_TITLE_MOD(cx_list(var1))
		    plot_title_1(slen+2:) = PAREN_SURROUND(plot_title,slen1)
		    slen = TM_LENSTR1( plot_title_1 )

		    CALL BOX_LABEL( dep_lab,
     .			   plot_title_1(:slen),
     .			   0.0, 0.0, 0.8*dep_len, letsize_label,
     .			   letsize_label, ppl_centered,
     .			   lab_loc_absolute, lab_loc_absolute )
	         ELSE  ! no keys, label w/ var title below the plot
		    plot_title = FULL_VAR_TITLE( cx_list(var1), do_units, slen )
		    IF ( user_title ) CALL EQUAL_STR_LC(
     .			cmnd_buff(qual_start(ptitl):qual_end(ptitl)),
     .                  plot_title, status )
		    slen = TM_LENSTR1( plot_title )
	            CALL BOX_LABEL( ppl_title,
     .			   plot_title(:slen),
     .			   0.0, 0.0, 0.75*hlen, letsize_title,
     .			   letsize_title, ppl_centered,
     .			   lab_loc_absolute, lab_loc_absolute )
		 ENDIF
	      ENDIF
	     
           ENDIF
	ENDIF  ! overlay

	IF (cxdsg_empty_set) THEN
	   CALL DSG_LABEL_NOFEATURE ( buff2, letsize_title, status)
	   IF (status .NE. ferr_ok) GOTO 5000 
	ENDIF

	GOTO 5000  ! done


* Labels for ribbon plots.
 1000	CONTINUE

	nline_in_mem = 0
	IF ( overlay ) THEN
	   DO 1500 ipl = var1, nmv
	      nline_in_mem = nline_in_mem + 1
	      CALL OV_GRP_CX_DOC( cx_list(ipl), 1, cx_xtra_doc )
	      IF ( user_title ) THEN
	         CALL EQUAL_STR_LC(
     .			cmnd_buff(qual_start(ptitl):qual_end(ptitl)),
     .                  plot_title, status )
                 IF ( status .NE. ferr_ok ) GOTO 5000
	         slen = TM_LENSTR1( plot_title )
	      ELSE

	         IF ( .NOT. its_dsg ) plot_title = KEY_STRING( cx_list(ipl), cx_xtra_doc, slen )

		 IF (.NOT.use_keys .OR. its_dsg) plot_title = VAR_TITLE_ONLY( cx_list(ipl), slen )
	      ENDIF
              IF (this_no_range(ipl) .AND. mode_nodata_lab) THEN
                 plot_title(slen+1:slen+14) = ' No Valid Data'
                 slen = slen + 14
              ENDIF

              IF (ipl.EQ.ribbon_var .AND. .NOT.its_dsg) THEN
		 slen1 = TM_LENSTR1( plot_title_1 )
                 plot_title = plot_title_1(1:slen1)//
     .			', Colored by '//plot_title(1:slen)
	         slen = TM_LENSTR1( plot_title)
              ENDIF

              plot_title_1 = plot_title ! ribbon plot: combine with color-by label
 1500	   CONTINUE
           IF (.NOT. nokey) THEN
              CALL KEY_LOC( overlay, xkeypos, ykeypos, xkeysize, ykeysize,
     .			    lab_ht, style, justify, plot_title(:slen))
              CALL PUT_KEY( nline_in_mem, plot_title(:slen),
     .			    xkeypos, ykeypos, xkeysize, ykeysize,
     .			    lab_ht, style, lab_loc_absolute, lab_loc_absolute )
           ENDIF

	ELSE ! Not overlay

* *kob* 1/00 check the variable time_axis before looking at
*            any time-relevant variables.
* ... basic position and data set labels 
*    ... does the year need special documentation? 

	   year = unspecified_name4    ! assume no label needed by default 
	   IF ( time_axis ) THEN 
*    ... document the year where the axis, itself, doesn't 
	      IF ( tstyle.EQ.'MON' .OR. tstyle.EQ.'DAY' ) THEN 
                 ppl_buff = SECS_TO_DATE( ind_min, cal_id_1 ) 
                 year = ppl_buff(8:11) 
	      ENDIF 
           ELSE
              IF ( tstyle.EQ.'MON' .OR. tstyle.EQ.'DAY' ) THEN  ! plot/vs with time variable
	         i = ind_min
                 WRITE (year, '(I4)') i
              ENDIF 
	   ENDIF 

* *ACM* if time axis, then cal_id_1 is set to the calendar.  Label the
*       plot with the calendar name if there is non-standard calendar

	   CALL DISP_LABELS( cx_plot, year, cal_id_1 )

* ... label dependent axis with units (over-written below if /vs)

	   plot_title = VAR_UNITS( cx_list(var1) )

	   slen = TM_LENSTR1( plot_title )
	   buff1 = VAR_UNITS(cx_list(2))  ! ? was cx_y
	   iunits = TM_UNIT_ID(buff1)
	   IF (iunits .NE. 4) THEN
	      CALL BOX_LABEL( dep_lab,
     .			   plot_title(:slen),
     .			   0.0, 0.0, 0.6*dep_len, letsize_label,
     .			   letsize_label, ppl_centered,
     .			   lab_loc_absolute, lab_loc_absolute )
	   ENDIF

	   IF (versus .AND. ribbon_plot) THEN
	      do_units = .TRUE.
	      plot_title = FULL_VAR_TITLE( cx_list(var1), do_units, slen )
	      slen = TM_LENSTR1( plot_title )
	      CALL BOX_LABEL( dep_lab,
     .			   plot_title(:slen),
     .			   0.0, 0.0, 0.6*dep_len, letsize_label,
     .			   letsize_label, ppl_centered,
     .			   lab_loc_absolute, lab_loc_absolute )
     
	      IF (nmv .EQ. 1) THEN
	         plot_title = 'Longitude (degrees_east)'
	         slen = TM_LENSTR1( plot_title )
	         CALL BOX_LABEL( indep_lab,
     .                     plot_title(:slen),
     .                     0.0, 0.0, 0.6*hlen, letsize_label,
     .                     letsize_label, ppl_centered,
     .                     lab_loc_absolute, lab_loc_absolute )

	         plot_title = 'Latitude (degrees_north)'
	         slen = TM_LENSTR1( plot_title )	         
	         CALL BOX_LABEL( dep_lab,
     .			   plot_title(:slen),
     .			   0.0, 0.0, 0.6*dep_len, letsize_label,
     .			   letsize_label, ppl_centered,
     .			   lab_loc_absolute, lab_loc_absolute )
	      ENDIF
	   ENDIF


	   IF (cxdsg_empty_set) THEN
              CALL DSG_LABEL_NOFEATURE ( buff2, letsize_title, status)
	      IF (status .NE. ferr_ok) GOTO 5000 
	   ENDIF

* ... keys for the dependent vars, or if one, only then title or axis label
! ribbon_plot

	   IF (nmv.EQ.1 .AND. (versus.AND.ribbon_plot)) THEN
	      IF (cxdsg_empty_set) do_units = .FALSE.
	      plot_title = FULL_VAR_TITLE( cx_list(nmv), do_units, slen )
              IF (this_no_range(nmv) .AND. mode_nodata_lab) THEN
                 plot_title(slen+1:slen+14) = ' No Valid Data'
                 slen = slen + 14
              ENDIF
	      
              labsize = letsize_title
              IF (.NOT.cxdsg_empty_set) plot_title = 
     .                'Colored by '//plot_title(1:slen)

              IF ( user_title ) THEN     ! user over-ride of title
                 CALL EQUAL_STR_LC
     .             ( cmnd_buff(qual_start(ptitl):qual_end(ptitl)),
     .               plot_title, status )
                 IF ( status .NE. ferr_ok ) GOTO 5000
                 labsize = letsize_title
              ENDIF

              slen = TM_LENSTR1( plot_title )
              CALL BOX_LABEL( ppl_title,
     .			   plot_title(:slen),
     .			   0.0, 0.0, 0.75*hlen, letsize_title,
     .			   labsize, ppl_centered,
     .			   lab_loc_absolute, lab_loc_absolute )
              GOTO 5000
	   ENDIF 

	   istart = var1
	   IF (versus .AND. ribbon_plot) istart = 1

	   DO 1600 ipl = istart, var1+1
	      IF (ipl.EQ.var1 .AND. (versus.AND.ribbon_plot)) GOTO 1600  
	      nline_in_mem = nline_in_mem + 1
	      do_units = .TRUE.
	      plot_title = FULL_VAR_TITLE( cx_list(ipl), do_units, slen )
              IF (this_no_range(ipl) .AND. mode_nodata_lab) THEN
                 plot_title(slen+1:slen+14) = ' No Valid Data'
                 slen = slen + 14
              ENDIF
	         
              labsize = letsize_title
              IF (ipl.EQ.ribbon_var) THEN
	         IF (versus) THEN
	            IF (add_ribbon) plot_title_1 = 'Trajectory'
	            IF (add_ribbon) plot_title = 'Trajectory'
                    slen1 = TM_LENSTR1( plot_title_1 )
		    CALL BOX_LABEL( indep_lab,
     .                     plot_title_1(:slen1),
     .                     0.0, 0.0, 0.75*hlen, letsize_label,
     .                     letsize_label, ppl_centered,
     .                     lab_loc_absolute, lab_loc_absolute )
		    plot_title = 'Colored by '//plot_title(1:slen)
                 ELSE
		    slen1 = TM_LENSTR1( plot_title_1 )
                    plot_title = plot_title_1(1:slen1)//
     .			'<NL>Colored by '//plot_title(1:slen)
                 ENDIF

!		 labsize = 0.8*letsize_title

                 IF ( user_title ) THEN     ! user over-ride of title
                    CALL EQUAL_STR_LC
     .			 ( cmnd_buff(qual_start(ptitl):qual_end(ptitl)),
     .                    plot_title, status )
                    IF ( status .NE. ferr_ok ) GOTO 5000
                    labsize = letsize_title
	         ENDIF
              ENDIF

              slen = TM_LENSTR1( plot_title )
              CALL BOX_LABEL( ppl_title,
     .			   plot_title(:slen),
     .			   0.0, 0.0, 0.75*hlen, letsize_title,
     .			   labsize, ppl_centered,
     .			   lab_loc_absolute, lab_loc_absolute )

              plot_title_1 = plot_title ! ribbon plot: combine with color-by label
 1600	   CONTINUE

	ENDIF ! overlay

5000	CONTINUE

! Restore dataset title
	IF (reset_dsg) CALL SET_DSET_TITLE (dset_dsg, dummy)


	RETURN
	END

	LOGICAL FUNCTION MATCH_NAME ( test_string, len_test, model_string, len_model_chars)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* check to see if test string is same as model string to full length of model
* string
* model string must be all upper case - test string ignores case
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 5/1/86
* revision 0.1 - 12/9/86 - allowed model_string of arbitrary length
* ywei  05/04 changed function prototype to allow speed up
*              before calling this function, make sure
*              len_test = TM_LENSTR(test_string)
*              len_model_chars = TM_LENSTR(model_string)

* calling argument declarations:
	CHARACTER*(*)	model_string
	CHARACTER*(*)	test_string
        INTEGER         len_test
        INTEGER         len_model_chars

* internal variable declarations:
	INTEGER		TM_LENSTR, len_model, i
        LOGICAL         result

	len_model	= LEN( model_string )

* test string cannot be shorter than model or longer than fully terminated model
	IF (   len_test        .LT. len_model_chars
     .	 .OR.( len_model_chars .LT. len_model		! fully terminated ?
     .	 .AND. len_test	       .GT. len_model_chars )	) GOTO 200

        CALL tm_match_captial_name(test_string, model_string, 
     .          len_model_chars, result)

        IF(.NOT.result) GOTO 200
* it matches
	MATCH_NAME = .TRUE.
	RETURN

* it doesn't match
 200	MATCH_NAME = .FALSE.
	RETURN

	END

	SUBROUTINE TEK4014_LINE_BUNDLE (zwsid)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Routine to set up the line bundles for tek4014's
*	J Davison JISAO/PMEL/TMAP 3.23.89
*	*jd* 2.19.92 mod to support atc gks

	integer		zwsid,i,j
#ifdef atc_gks
        integer         ltype(6)
	data		ltype /1,2,3,4,-1001,-1004/
#else
	integer 	ltype(5)
	data		ltype /1,2,3,4,-3/
#endif
	real		thickness

*******************************************************************************

#ifdef atc_gks
*	INCREASE THICKNESS AND REPEAT LINETYPE EACH SIX INDICES
100     do 20 j = 1,3
	   thickness = real (j)*2.0 - 1.0

           do 10 i = 1,6
              call gsplr (zwsid,i+6*(j-1),ltype(i),thickness,1)
10        continue
20     continue
#else
*	INCREASE THICKNESS AND REPEAT LINETYPE EACH FIVE INDICES
	do 20 j = 1,3
	   thickness = real (j)*2.0 - 1.0

	   do 10 i = 1,5
	      call gsplr (zwsid,i+5*(j-1),ltype(i),thickness,1)
10	   continue
20	continue
#endif
	return

	end

*
*  scat2gridlaplace_xt
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE.
*
* Ansley Manke
* July 28 1998
*
* Returns variable interpolated onto an equally-spaced X-T grid.
* Input is scattered triples: (x, t, variable) , may be functions of Y,Z,E,F.
* Output is gridded data in X,Y,Z,T,E,F.  Calls routine "zgrid_laplace".
*
* Nov 13, 2000 1) Allow modulo axes: if modulo take points from other end
*                 to use in gridding each end
*              2) Check that the scattered points are listed on the I,J,or
*                 K axis only, as they may be functions of time.
*  (12/1/2000) 3) If the destination axis is modulo, treat the scattered
*                 points as modulo too.
*
*   12/7/2000  Add error checking on gridding parameters
*    5/2001    Let variable,  be a function of Z and/or T
*
*  11/12/2002  Remove option 2) above: the spatial location of the scattered points
*              is a 1-D list.
*   2/ 9/2005  When we fixed the argument limit machinery this fcn
*              breaks if the output axes are limited by some context.
*              use ef_set_axis_extend to force the regridding to be
*              done on the unrestricted output grid.
*  8/26/2008   The functions call zgrid from the PPLUS code. This function has
*              some hard-wired workspace limited to 50K points. Instead allocate
*              work arrays here and pass them to zgrid_laplace in this directory
*              with no changes other than the work array declarations.
*
*  *kms* 4/2012 Removed extending result grid axes with ef_unspecified_int4: 
*               this appears to destroy the axes of the result grid as demonstrated
*               by the listing in bn_scat2grid_test.jnl.  Now it is up to the
*               the user to give (not truncate) the result grid axes:
*      let sgrid = scat2gridlaplace_xy(xpts, ypts, variable, x[gx=xax5], y[gy=yax5], 5., 5)
*      load sgrid  ! <--- without this, the following uses a 1-element Y axis
*      list/x=4:5/y=1 sgrid

* In this subroutine we provide information about
* the function.  The user configurable information
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
*
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result
*


      SUBROUTINE scat2gridlaplace_xt_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id, 'Use Laplace weighting to grid ' //
     .                     'scattered data to an XT grid.')
      CALL ef_set_num_args(id, 7)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 8)

* XT grid is determined by arguments 4 and 5, the result's x and t axes.

      arg = 1
      CALL ef_set_arg_name(id, arg, 'XPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'X coordinates of scattered XT locations')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'TPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'T coordinates of scattered XT locations')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'F')
      CALL ef_set_arg_desc(id, arg,
     .        'variable at scattered XT locations. ' //
     .        'May also be fcn of Y,Z,E,F')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, YES, YES, NO, YES, YES)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'XAXPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'X axis coordinates of a regular output grid')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, NO, NO, NO, NO, NO)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'TAXPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'T axis coordinates of a regular output grid')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, YES, NO, NO)

      arg = 6
      CALL ef_set_arg_name(id, arg, 'KAY')
      CALL ef_set_arg_desc(id, arg,
     .        'Laplace/spline mixing parameter KAY; ' //
     .        '0.0=pure Laplace; inf=pure spline')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 7
      CALL ef_set_arg_name(id, arg, 'NRNG')
      CALL ef_set_arg_desc(id, arg,
     .        'Effect parameter NRNG; grid vals ' //
     .        'undef if > NRNG grid steps from pts')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE scat2gridlaplace_xt_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER nxout, ntout, nx2, nt2
      INTEGER nxin, nyin, nzin, ntin, nein, nfin, nin

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nxin = 1 + arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1)
      nyin = 1 + arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1)
      nzin = 1 + arg_hi_ss(Z_AXIS,ARG1) - arg_lo_ss(Z_AXIS,ARG1)
      ntin = 1 + arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1)
      nein = 1 + arg_hi_ss(E_AXIS,ARG1) - arg_lo_ss(E_AXIS,ARG1)
      nfin = 1 + arg_hi_ss(F_AXIS,ARG1) - arg_lo_ss(F_AXIS,ARG1)
      nin = MAX(nxin,nyin,nzin,ntin,nein,nfin)
*  If modulo axis, the scatter arrays are extended for values
*  within nrng of the cut-point.  Worst case: everything gets
*  duplicated at both ends; thus three times the points for
*  each modulo axis.
      nin = 9 * nin

      nxout = 1 + arg_hi_ss(X_AXIS,ARG4) - arg_lo_ss(X_AXIS,ARG4)
      ntout = 1 + arg_hi_ss(T_AXIS,ARG5) - arg_lo_ss(T_AXIS,ARG5)

      nx2 = nxout * 2
      nt2 = ntout * 2

* xax  output x axis
      CALL ef_set_work_array_dims_6d(id, 1,
     .                                1, 1, 1, 1, 1, 1,
     .                              nx2, 1, 1, 1, 1, 1)

* tax  output t axis
      CALL ef_set_work_array_dims_6d(id, 2,
     .                                1, 1, 1, 1, 1, 1,
     .                              nt2, 1, 1, 1, 1, 1)

* zgridded  work array - gridded data.
      CALL ef_set_work_array_dims_6d(id, 3,
     .                                1,     1, 1, 1, 1, 1,
     .                            nxout, ntout, 1, 1, 1, 1)

* xscat - scattered points with gaps removed and extended for modulo
      CALL ef_set_work_array_dims_6d(id, 4,
     .                                1, 1, 1, 1, 1, 1,
     .                              nin, 1, 1, 1, 1, 1)

* tscat - scattered points with gaps removed and extended for modulo
      CALL ef_set_work_array_dims_6d(id, 5,
     .                                1, 1, 1, 1, 1, 1,
     .                              nin, 1, 1, 1, 1, 1)

* fscat - scattered points with gaps removed and extended for modulo
      CALL ef_set_work_array_dims_6d(id, 6,
     .                                1, 1, 1, 1, 1, 1,
     .                              nin, 1, 1, 1, 1, 1)

* zgrid_laplace work array zpij
      CALL ef_set_work_array_dims_6d(id, 7,
     .                                1, 1, 1, 1, 1, 1,
     .                              nin, 1, 1, 1, 1, 1)

* zgrid_laplace work array knxt
      CALL ef_set_work_array_dims_6d(id, 8,
     .                                1, 1, 1, 1, 1, 1,
     .                              nin, 1, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE scat2gridlaplace_xt_compute(id, arg_1, arg_2, arg_3,
     .                            arg_4, arg_5, arg_6, arg_7, result,
     .                            xax, tax, zgridded, xscat, tscat,
     .                            fscat, zpij, knxt)

*  arg_1  xpts \
*  arg_2  tpts  > scattered x,t,variable,  triples to be gridded. F can be fcn of y,z,e,f
*  arg_3  variable, /
*  arg_4  xaxis of new grid
*  arg_5  taxis of new grid
*  arg_6  interpolation parameter   kay
*  arg_7  interpolation parameter   nrng

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz,
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz,
     .           mem4lot:mem4hit, mem4loe:mem4hie, mem4lof:mem4hif)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz,
     .           mem5lot:mem5hit, mem5loe:mem5hie, mem5lof:mem5hif)
      REAL arg_6(mem6lox:mem6hix, mem6loy:mem6hiy, mem6loz:mem6hiz,
     .           mem6lot:mem6hit, mem6loe:mem6hie, mem6lof:mem6hif)
      REAL arg_7(mem7lox:mem7hix, mem7loy:mem7hiy, mem7loz:mem7hiz,
     .           mem7lot:mem7hit, mem7loe:mem7hie, mem7lof:mem7hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* Ignore the unused final dimensions in the work arrays since
* Fortran is column major
      REAL*8 xax(wrk1lox:wrk1hix/2)
      REAL*8 tax(wrk2lox:wrk2hix/2)
      REAL zgridded(wrk3lox:wrk3hix, wrk3loy:wrk3hiy)
      REAL xscat(wrk4lox:wrk4hix)
      REAL tscat(wrk5lox:wrk5hix)
      REAL fscat(wrk6lox:wrk6hix)
      REAL zpij(wrk7lox:wrk7hix)
      REAL knxt(wrk8lox:wrk8hix)

* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable''s axes.

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      REAL zgridbad
      PARAMETER (zgridbad = 1.e+35)  ! missing-data flag used by zgrid_laplace

      INTEGER i, j, k, l, m, n
      INTEGER idx, lo_ss, hi_ss
      INTEGER nxpts, ntpts, npts, nscat
      INTEGER nx, nt
      INTEGER i3, j3, k3, l3, m3, n3
      INTEGER xlo, xhi, tlo, thi
      INTEGER nrng
      REAL x1, t1, dx, dt
      REAL kay
      CHARACTER*250 errtxt

C  variables for checking axis characteristics (modulo, regular)
      CHARACTER ax_name(6)*16, ax_units(6)*16
      LOGICAL backward(6), mdulo(6), regular(6)
      LOGICAL modulox, modulot
      REAL*8 modxlen, modtlen

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*  Check to see if output axes are regular, and get modulo characteristics
      CALL ef_get_axis_info_6d(id, ARG4, ax_name, ax_units,
     .                         backward, mdulo, regular)
      IF ( .NOT. regular(X_AXIS) ) THEN
         errtxt = 'Output axes must be REGULARLY spaced'
         GOTO 999
      ENDIF
      modulox = mdulo(X_AXIS)
      IF ( modulox ) THEN
         CALL ef_get_axis_modulo_len(id, ARG4, X_AXIS, modxlen)
      ENDIF

      CALL ef_get_axis_info_6d(id, ARG5, ax_name, ax_units,
     .                         backward, mdulo, regular)
      IF ( .NOT. regular(T_AXIS) ) THEN
         errtxt = 'Output axes must be REGULARLY spaced'
         GOTO 999
      ENDIF
      modulot = mdulo(T_AXIS)
      IF ( modulot ) THEN
         CALL ef_get_axis_modulo_len(id, ARG5, T_AXIS, modtlen)
      ENDIF

*  Find number of points in scattered input points.  1-D arrays defining the
*  scattered data points may lie on the X, Y, Z, T, E, or F axis of the input
*  arguments.
*  Using as flattened arrays, so consider all axes.

      nxpts = 0
      DO 10 idx = X_AXIS, F_AXIS
         lo_ss = arg_lo_ss(idx,ARG1)
         hi_ss = arg_hi_ss(idx,ARG1)
         IF ( lo_ss .NE. ef_unspecified_int4 ) THEN
            IF ( nxpts .NE. 0 ) THEN
               nxpts = nxpts * (hi_ss - lo_ss + 1)
            ELSE
               nxpts = hi_ss - lo_ss + 1
            ENDIF
         ENDIF
  10  CONTINUE

      ntpts = 0
      DO 40 idx = X_AXIS, F_AXIS
         lo_ss = arg_lo_ss(idx,ARG2)
         hi_ss = arg_hi_ss(idx,ARG2)
         IF ( lo_ss .NE. ef_unspecified_int4 ) THEN
            IF ( ntpts .NE. 0 ) THEN
               ntpts = ntpts * (hi_ss - lo_ss + 1)
            ELSE
               ntpts = hi_ss - lo_ss + 1
            ENDIF
         ENDIF
  40  CONTINUE

      IF ( nxpts .NE. ntpts ) THEN
         WRITE (errtxt,90) ' XPTS,', ' TPTS ', nxpts, ntpts
         GOTO 999
      ENDIF

* Verify the number of values given in ARG3 makes sense
      xlo = arg_lo_ss(X_AXIS,ARG3)
      xhi = arg_hi_ss(X_AXIS,ARG3)
      tlo = arg_lo_ss(T_AXIS,ARG3)
      thi = arg_hi_ss(T_AXIS,ARG3)

      IF ( (xhi .GT. xlo) .AND. (thi .GT. tlo) ) THEN
         errtxt = 'F() data values defined on both X and T axis'
         GOTO 999
      ELSE IF ( xhi .GT. xlo ) THEN
         npts = xhi - xlo + 1
         IF ( nxpts .NE. npts ) THEN
            WRITE (errtxt,90) ' XPTS,', ' F(X) ', nxpts, npts
            GOTO 999
         ENDIF
      ELSE IF ( thi .GT. tlo ) THEN
         npts = thi - tlo + 1
         IF ( nxpts .NE. npts ) THEN
            WRITE (errtxt,90) ' XPTS,', ' F(T) ', nxpts, npts
            GOTO 999
         ENDIF
      ELSE IF ( (xlo .NE. ef_unspecified_int4) .OR.
     .          (tlo .NE. ef_unspecified_int4) ) THEN
         npts = 1
         IF ( nxpts .NE. npts ) THEN
            WRITE (errtxt,90) ' XPTS,', ' F()  ', nxpts, npts
            GOTO 999
         ENDIF
      ELSE
         errtxt = 'No data in scattered x, t points.  ' //
     .            'F() data values must be defined on X or T axis.'
         GOTO 999
      ENDIF
  90  FORMAT('Input scattered', 2A6, 'have different # of points', 2I8)

*  Compute number of points in output axes.

      lo_ss = arg_lo_ss(X_AXIS,ARG4)
      hi_ss = arg_hi_ss(X_AXIS,ARG4)
*  Check that xax is an X axis
      IF ( lo_ss .EQ. ef_unspecified_int4 ) THEN
         errtxt = 'Fourth argument must be an X axis'
         GO TO 999
      ENDIF
      nx = hi_ss - lo_ss + 1

      lo_ss = arg_lo_ss(T_AXIS,ARG5)
      hi_ss = arg_hi_ss(T_AXIS,ARG5)
*  Check that tax a T axis
      IF ( lo_ss .EQ. ef_unspecified_int4 ) THEN
         errtxt = 'Fifth argument must be a T axis'
         GO TO 999
      ENDIF
      nt = hi_ss - lo_ss + 1

C  Get coordinates of output axes.

      CALL ef_get_coordinates(id, ARG4, X_AXIS, arg_lo_ss(X_AXIS, ARG4),
     .                        arg_hi_ss(X_AXIS, ARG4), xax)

      CALL ef_get_coordinates(id, ARG5, T_AXIS, arg_lo_ss(T_AXIS, ARG5),
     .                        arg_hi_ss(T_AXIS, ARG5), tax)

*  Set start and delta for output axes.

      x1 = xax(1)
      t1 = tax(1)

      IF ( nx .GT. 1 ) THEN
         dx = xax(2) - xax(1)
      ELSE
         errtxt = 'More than one output X coordinate required'
         GOTO 999
      ENDIF
      IF ( nt .GT. 1 ) THEN
         dt = tax(2) - tax(1)
      ELSE
         errtxt = 'More than one output T coordinate required'
         GOTO 999
      ENDIF

*  Get interpolation parameters.

      kay = arg_6(arg_lo_ss(X_AXIS,ARG6), arg_lo_ss(Y_AXIS,ARG6),
     .            arg_lo_ss(Z_AXIS,ARG6), arg_lo_ss(T_AXIS,ARG6),
     .            arg_lo_ss(E_AXIS,ARG6), arg_lo_ss(F_AXIS,ARG6))
      IF ( kay .LT. 0. ) THEN
         errtxt = 'Gridding parameter KAY must be nonnegative'
         GOTO 999
      ENDIF

      nrng = arg_7(arg_lo_ss(X_AXIS,ARG7), arg_lo_ss(Y_AXIS,ARG7),
     .             arg_lo_ss(Z_AXIS,ARG7), arg_lo_ss(T_AXIS,ARG7),
     .             arg_lo_ss(E_AXIS,ARG7), arg_lo_ss(F_AXIS,ARG7))
      IF ( nrng .LE. 0 ) THEN
         errtxt = 'Gridding parameter NRNG must be a positive integer'
         GOTO 999
      ENDIF

*  Compute result at each Y, Z, E, F

      n3 = arg_lo_ss(F_AXIS,ARG3)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

      m3 = arg_lo_ss(E_AXIS,ARG3)
      DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

      k3 = arg_lo_ss(Z_AXIS,ARG3)
      DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

      j3 = arg_lo_ss(Y_AXIS,ARG3)
      DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

*  If there is a missing value routine zgrid does not grid the data in
*  a zone around that point, even if there are other nearby good data
*  points.  Remove missing/bad data from the input (x,t,f) points.
*  Assigns xscat, tscat, fscat, and nscat.

         CALL nobadxt(arg_1, arg_2, arg_3,
     .                bad_flag(ARG1), bad_flag(ARG2), bad_flag(ARG3),
     .                npts, xlo, xhi, j3, k3, tlo, thi, m3, n3,
     .                xscat, tscat, fscat, nscat)

*  If an output axis is modulo, apply modulo adjustment to that coordinate
*  of the scattered points.
         IF ( modulox ) THEN
            CALL modscat(xax(1), xax(nx), modxlen, nscat, xscat)
         ENDIF
         IF ( modulot ) THEN
            CALL modscat(tax(1), tax(nt), modtlen, nscat, tscat)
         ENDIF

*  If an output axis is modulo, mirror the scattered points within NRNG
*  of each end to the other end of the region.  Extends xscat, tscat,
*  fscat, and updates nscat to the new count.
         IF ( modulox ) THEN
            CALL copyscat(xax, nx, nrng, nscat, xscat, tscat, fscat)
         ENDIF
         IF ( modulot ) THEN
            CALL copyscat(tax, nt, nrng, nscat, tscat, xscat, fscat)
         ENDIF

*  Initialize zgridded to all zeros

         DO l3 = 1, nt
            DO i3 = 1, nx
               zgridded(i3,l3) = 0.0
            ENDDO
         ENDDO

*  Grid the data.

         CALL zgrid_laplace(zgridded, nx, nt, nx, nt, x1, t1,
     .      dx, dt, xscat, tscat, fscat, zpij, knxt, nscat, kay, nrng)

*  Put zgridded into result variable.  Use "bad_flag_result" rather than
*  "zgridbad" to mark bad data.

         l3 = 1
         DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

            i3 = 1
            DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

               IF ( zgridded(i3,l3) .EQ. zgridbad ) THEN
                  result(i,j,k,l,m,n) = bad_flag_result
               ELSE
                  result(i,j,k,l,m,n) = zgridded(i3,l3)
               ENDIF

               i3 = i3 + 1
  100       CONTINUE

            l3 = l3 + 1
  400    CONTINUE

         j3 = j3 + arg_incr(Y_AXIS,ARG3)
  200 CONTINUE

         k3 = k3 + arg_incr(Z_AXIS,ARG3)
  300 CONTINUE

         m3 = m3 + arg_incr(E_AXIS,ARG3)
  500 CONTINUE

         n3 = n3 + arg_incr(F_AXIS,ARG3)
  600 CONTINUE

      RETURN

  999 CALL EF_BAIL_OUT(id, errtxt)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN
      END


      SUBROUTINE nobadxt(xin, tin, fin, badx, badt, badf,
     .                   npts, xlo, xhi, j3, k3, tlo, thi, m3, n3,
     .                   xscat, tscat, fscat, nscat)

* ACM 11/00 change so not exact comparison: wasnt catching all bad values.
* ACM  5/01 properly deal with f-scattered points which may be fcns of y and z

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      LOGICAL TM_FPEQ

*  Input arguments
      REAL xin(*), tin(*)
      REAL fin(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz,
     .         mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)
      REAL badx, badt, badf
      INTEGER npts, xlo, xhi, j3, k3, tlo, thi, m3, n3

*  Output arguments
      REAL xscat(*), tscat(*), fscat(*)
      INTEGER nscat

*  Local variables
      INTEGER idx, i3, l3

      nscat = 0

      IF ( xhi .GT. xlo ) THEN

         DO 100 idx = 1, npts
            IF ( TM_FPEQ(xin(idx), badx) ) GOTO 100
            IF ( TM_FPEQ(tin(idx), badt) ) GOTO 100
            i3 = xlo + idx - 1
            l3 = tlo
            IF ( TM_FPEQ(fin(i3,j3,k3,l3,m3,n3), badf) ) GOTO 100
            nscat = nscat + 1
            xscat(nscat) = xin(idx)
            tscat(nscat) = tin(idx)
            fscat(nscat) = fin(i3,j3,k3,l3,m3,n3)
  100    CONTINUE

      ELSE

         DO 200 idx = 1, nscat
            IF ( TM_FPEQ(xin(idx), badx) ) GOTO 200
            IF ( TM_FPEQ(tin(idx), badt) ) GOTO 200
            i3 = xlo
            l3 = tlo + idx - 1
            IF ( TM_FPEQ(fin(i3,j3,k3,l3,m3,n3), badf) ) GOTO 200
            nscat = nscat + 1
            xscat(nscat) = xin(idx)
            tscat(nscat) = tin(idx)
            fscat(nscat) = fin(i3,j3,k3,l3,m3,n3)
  200    CONTINUE

      ENDIF

      RETURN
      END


C**
C**  Comments from routine ZGRID used in the PLOT+ graphics package; 
C**  the code is part of Ferret which calls PLOT+
C**
C**	subroutine zgrid(z,nxsize,nysize,nx,ny,x1,y1,dx,dy, 
C**     1	xp,yp,zp,n,cay,nrng) 
C** 
C**    @(#)zgrid	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
c     sets up square grid for contouring , given arbitrarily placed 
c     data points. laplace interpolation is used. 
c     the method used here was lifted directly from notes left by 
c     mr ian crain formerly with the comp.science div. 
c     info on relaxation soln of laplace eqn supplied by dr t murty. 
c     fortran ii   oceanography/emr   dec/68   jdt 
c 
c     z = 2-d array of hgts to be set up. points outside region to be 
c     contoured should be initialized to 10**35 . the rest should be 0.0 
c     nx,ny = max subscripts of z in x and y directions . 
c     x1,y1 = coordinates of z(1,1) 
c     dx,dy = x and y increments . 
c     xp,yp,zp = arrays giving position and hgt of each data point. 
c     n = size of arrays xp,yp and zp . 
c 
c     modification feb/69   to get smoother results a portion of the 
c     beam eqn  was added to the laplace eqn giving 
c     delta2x(z)+delta2y(z) - k(delta4x(z)+delta4y(z)) = 0 . 
c     k=0 gives pure laplace solution.  k=inf. gives pure spline solution. 
c     cayin = k = amount of spline eqn (between 0 and inf.) 
c     nrng...grid points more than nrng grid spaces from the nearest 
c            data point are set to undefined. 
c 
c     modification dec23/69   data pts no longer moved to grid pts. 
c 
c     modification may 5 79  common blocks work1 and work2 must 
c     be dimension at least n points long by the user.  common 
c     block work3 must be dimensioned at least ny points long. 
c 
c	modification june 17,1985 - handles data values of 1e35. if at
c	least one data value near a grid point is equal to 1e35, the z
c	array is initialized to 1e35 at that grid point
c	- by g.r. halliwell
c

	SUBROUTINE PPL_TIME( lo_val, hi_val, cal_id )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* send the PLOT+ TIME command with WHOI-formatted dates to PLOT+

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V300:  10/93 - *sh* extracted logic from AXIS_FORMAT
* V420: 11/27/95 - 4-digit PLOT+ YEARS!!
* V450: 11/14/97 - the arbitrary tstart, 1 year before start of interval,
*	causes the /XLIMITS=lo_date:hi_date to mis-represent the data
*	(see err450_time_xlimits.jnl). Eliminated tstart.
* V530  *acm* cal_id for alternative calendar axis types
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'plot_setup.parm'
	include 'xplot_setup.cmn'
* special equivalence needed only with DEC risc compiler: bug fix
        include 'xrisc.cmn'     ! for f77 bug
        CHARACTER rbuff(4)*14
        EQUIVALENCE ( rbuff, risc_buff )


* calling argument declarations:
	REAL*8	  lo_val, hi_val
	INTEGER	  cal_id

* internal variable declarations:
!	REAL*8	  tstart
	CHARACTER ABS_WHOI_DATE*14

* internal parameter declarations
	REAL*8		yrofsecs
	PARAMETER     ( yrofsecs = 60.*60.*24.*365. )

!* set tstart 1 year before the beginning
!	tstart = MAX( 0.0D0, lo_val - yrofsecs )

* TIME command (time axis limits)

              rbuff(1) = ABS_WHOI_DATE( lo_val, cal_id )      ! f77 bug
              rbuff(2) = ABS_WHOI_DATE( hi_val, cal_id )
!              rbuff(3) = ABS_WHOI_DATE( tstart, cal_id )
              WRITE ( ppl_buff, 3020 )  'W'//rbuff(1),
     .                                  'W'//rbuff(2)
!     .                                  'W'//rbuff(3)

! 3020	      FORMAT ('TIME ',A15,',',A15,',',A15)
 3020	      FORMAT ('TIME ',A15,',',A15)
	      CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
	RETURN
      END

      SUBROUTINE LPPLOT(XARRAY,YARRAY,NPTS,XFACT,YFACT,XLOW,YLOW,
     1    XORG,YORG,XTIC,YTIC,CHAR,LUN,NLINES)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)lpplot5.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C         LPPLOT GENERATES A LINE PRINTER PLOT 101 COLUMNS WIDE BY
C         NLINES LINES HIGH. IT DOES NOT DO A PAGE EJECT BEFORE HAND NOR
C         DOES IT DO AXES LABELLING.  IT WILL LABEL TICK MARKS HOWEVER.
C
C         THE CALLING PARAMETERS ARE SIMILAR TO COMPLOT:
C                 XARRAY:HOLDS THE X VALUE OF THE POINTS.
C                 YARRAY:HOLDS THE Y VALUE OF THE POINTS.
C                 NPTS:  THE NUMBER OF POINTS TO BE PLOTTED.
C                 XFACT: NUMBER OF COLUMNS PER USER UNIT.
C                 YFACT: NUMBER OF LINES PER USER UNIT.
C                 XLOW:  LOWEST VALUE OF THE X AXIS.
C                 YLOW:  LOWEST VALUE OF THE Y AXIS.
C                 XORG:  THE X-COORDINATE WHERE THE AXES CROSS.
C                 YORG:  THE Y-COORDINATE WHERE THE AXES CROSS.
C                 XTIC:  THE DISTANCE BETWEEN X TICK MARKS IN
C                        USER UNITS.
C                 YTIC:  THE DISTANCE BETWEEN Y TICK MARKS IN
C                        USER UNITS.
C                 CHAR:  THE CHARACTER TO BE USED TO MARK A POINT.
C                 LUN:   THE LOGICAL UNIT NUMBER ON WHICH TO PUT THE PLOT.
C                 NLINES:HEIGHT OF THE PLOT IN LINES.
C
      DIMENSION XARRAY(1),YARRAY(1)

#ifdef STAR_1_SUPPORTED
      integer*1 DATBUF(101),PRBUFF(121),BLANK,STAR,EYE,CHAR
#else
      BYTE DATBUF(101),PRBUFF(121),BLANK,STAR,EYE,CHAR
#endif

      DIMENSION XLAB(20),LABLOC(20)
      EQUIVALENCE(PRBUFF(11),DATBUF(1))
      DATA BLANK/1H /,STAR/1H*/,EYE/1HI/

      YINCD2=0.5/YFACT
      LINORG=FLOAT(NLINES)+0.5-(YORG-YLOW)*YFACT
      NXTICS=100.0/(XFACT*XTIC)+1

      DO 700 LINE=1,NLINES

      DO 50 JCOL=1,121
   50 PRBUFF(JCOL)=BLANK
      CALL XFILL(XORG,DATBUF,XFACT,XLOW,STAR)

      IF(LINE.NE.LINORG)GO TO 200
      DO 80 JCOL=1,101
   80 DATBUF(JCOL)=STAR
      DO 100 JTIC=1,NXTICS
      XT=(JTIC-1)*XTIC+XLOW
      JXT=(XT-XLOW)*XFACT+1.5
      IF(JXT.GT.101)GO TO 200
      DATBUF(JXT)=EYE
      XLAB(JTIC)=XT
      LABLOC(JTIC)=JXT+5
  100 CONTINUE

  200 IF(LINE.NE.LINORG+1)GO TO 250
      DO 230 JTIC=1,NXTICS
      L=LABLOC(JTIC)
      IF(L.LT.1 .OR. L.GT.111)GO TO 230
      CALL CODEA1(XLAB(JTIC),PRBUFF(L))
  230 CONTINUE

  250 YCENT=(NLINES-LINE)/YFACT+YLOW
      DO 400 JVAL=1,NPTS
      IF(ABS(YCENT-YARRAY(JVAL)).GT.YINCD2)GO TO 400
      CALL XFILL(XARRAY(JVAL),DATBUF,XFACT,XLOW,CHAR)
  400 CONTINUE

      IF(AMOD(YCENT-YLOW,YTIC).LE.YINCD2)GO TO 500
      WRITE(LUN,2000)PRBUFF
 2000 FORMAT(11X,121A1)
      GO TO 700

  500 WRITE(LUN,3000)YCENT,PRBUFF
 3000 FORMAT(1X,F10.2,121A1)

  700 CONTINUE

      RETURN
C**  THIS PROGRAM VALID ON FTN4 AND FTN5 **
      END
C*F45V1P0*

      SUBROUTINE XFILL(X,DATBUF,XFACT,XLOW,CHAR)

#ifdef STAR_1_SUPPORTED
      integer*1 DATBUF(101),CHAR
#else
      BYTE DATBUF(101),CHAR
#endif

      JCOL=(X-XLOW)*XFACT+1.5
      IF(JCOL.LT.1 .OR. JCOL.GT.101)RETURN
      DATBUF(JCOL)=CHAR
      RETURN
C**  THIS PROGRAM VALID ON FTN4 AND FTN5 **
      END
C*F45V1P0*

      SUBROUTINE CODEA1(X,COBUFF)

#ifdef STAR_1_SUPPORTED
      integer*1 COBUFF(1)
#else
      BYTE COBUFF(1)
#endif

      CHARACTER STR*8
      WRITE(STR,'(F8.1)')X
      READ(STR,999)(COBUFF(I),I=1,8)
999	FORMAT(8A1)
      RETURN
C**  THIS PROGRAM VALID ON FTN4 AND FTN5 **
      END

	subroutine zgrid(z,nxsize,nysize,nx,ny,x1,y1,dx,dy, 
     1	xp,yp,zp,n,cay,nrng) 
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)zgrid.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
c     sets up square grid for contouring , given arbitrarily placed 
c     data points. laplace interpolation is used. 
c     the method used here was lifted directly from notes left by 
c     mr ian crain formerly with the comp.science div. 
c     info on relaxation soln of laplace eqn supplied by dr t murty. 
c     fortran ii   oceanography/emr   dec/68   jdt 
c 
c     z = 2-d array of hgts to be set up. points outside region to be 
c     contoured should be initialized to 10**35 . the rest should be 0.0 
c     nx,ny = max subscripts of z in x and y directions . 
c     x1,y1 = coordinates of z(1,1) 
c     dx,dy = x and y increments . 
c     xp,yp,zp = arrays giving position and hgt of each data point. 
c     n = size of arrays xp,yp and zp . 
c 
c     modification feb/69   to get smoother results a portion of the 
c     beam eqn  was added to the laplace eqn giving 
c     delta2x(z)+delta2y(z) - k(delta4x(z)+delta4y(z)) = 0 . 
c     k=0 gives pure laplace solution.  k=inf. gives pure spline solution. 
c     cayin = k = amount of spline eqn (between 0 and inf.) 
c     nrng...grid points more than nrng grid spaces from the nearest 
c            data point are set to undefined. 
c 
c     modification dec23/69   data pts no longer moved to grid pts. 
c 
c     modification may 5 79  common blocks work1 and work2 must 
c     be dimension at least n points long by the user.  common 
c     block work3 must be dimensioned at least ny points long. 
c 
c	modification june 17,1985 - handles data values of 1e35. if at
c	least one data value near a grid point is equal to 1e35, the z
c	array is initialized to 1e35 at that grid point
c	- by g.r. halliwell
c
c*******************************************************************************
c 
c	vax/vms
c
	dimension z(nxsize,nysize),xp(n),yp(n),zp(n),
     .	zpij(50000),knxt(50000)
c
c	end vax/vms
c
c	rsx-11m
c
c	virtual z(nxsize,nysize),xp(n),yp(n),zp(n),zpij(10000),knxt(10000)
c
c	end rsx-11m
c
	dimension imnew(1000),kksav(500)
 
	itmax=100 
	eps=.002 
	big=.9e35 
c 
c     get zbase which will make all zp values positive by 20*(zmax-zmin) 
c*******************************************************************************
c 
c**   grh modification
	zmin=big
	zmax=-big
	do 20 k=1,n 
	if(zp(k).ge.1e35)goto 20
c**
	if(zp(k)-zmax)14,14,12 
12	zmax=zp(k) 
14	if(zp(k)-zmin)16,20,20 
16	zmin=zp(k) 
20	continue 
	zrange=zmax-zmin 
	zbase=zrange*20.-zmin 
	hrange=amin1(dx*(nx-1) , dy*(ny-1)) 
	derzm=2.*zrange/hrange 
c 
c     set pointer array knxt 
c*******************************************************************************
c 
	do 60 kk=1,n 
	k=1+n-kk 
	knxt(k)=0 
	i= (xp(k)-x1)/dx + 1.5 
	if(i*(nx+1-i))60,60,35 
35	j= (yp(k)-y1)/dy + 1.5 
	if(j*(ny+1-j))60,60,40 
40	if(z(i,j)-big)45,60,60 
45	knxt(k)=n+1 
	if(z(i,j))55,55,50 
50	knxt(k)= z(i,j)+.5 
55	z(i,j)=k 
60	continue 
c 
c     affix each data point zp to its nearby grid point.  take avg zp if 
c     more than one zp nearby the grid point. add zbase and complement. 
	do 80 k=1,n 
	if(knxt(k))80,80,65 
65	npt=0 
c**   grh modification
	imask=0
c**
	zsum=0. 
	i= (xp(k)-x1)/dx + 1.5 
	j =(yp(k)-y1)/dy + 1.5 
	kk=k 
70	npt=npt+1 
c**   grh modification
	kksav(npt)=kk
	if(zp(kk).gt.big)imask=1
c**
	zsum=zsum+ zp(kk) 
	knxt(kk)=-knxt(kk) 
	kk = -knxt(kk) 
	if(kk-n)70,70,75 
c**	grh modification
75	if(imask.eq.0)then
	z(i,j) = -zsum/npt-zbase 
	else
	z(i,j) = 1.e35
	do 76 i=1,npt
76	knxt(kksav(i))=0
	endif
c**
80	continue 
c 
c     initially set each unset grid point to value of nearest known pt. 
c*******************************************************************************
c 
	do 110 i=1,nx 
	do 110 j=1,ny 
	if(z(i,j))110,100,110 
100	z(i,j) = -1.e35 
110	continue 
	do 199 iter=1,nrng 
	nnew=0 
	do 197 i=1,nx 
	do 197 j=1,ny 
	if(z(i,j)+big)152,192,192 
152	if(j-1)162,162,153 
153	if(jmnew)154,154,162 
154	zijn=abs(z(i,j-1)) 
	if(zijn-big)195,162,162 
162	if(i-1)172,172,163 
163	if(imnew(j))164,164,172 
164	zijn=abs(z(i-1,j)) 
	if(zijn-big)195,172,172 
172	if(j-ny)173,182,182 
173	zijn=abs(z(i,j+1)) 
	if(zijn-big)195,182,182 
182	if(i-nx)183,192,192 
183	zijn=abs(z(i+1,j)) 
	if(zijn-big)195,192,192 
192	imnew(j)=0 
	jmnew=0 
	go to 197 
195	imnew(j)=1 
	jmnew=1 
	z(i,j)=zijn 
	nnew=nnew+1 
197	continue 
	if(nnew)200,200,199 
199	continue 
200	continue 
	do 202 i=1,nx 
	do 202 j=1,ny 
	abz=abs(z(i,j)) 
	if(abz-big)202,201,201 
201	z(i,j)=abz 
202	continue 
c 
c     improve the non-data points by applying point over-relaxation 
c     using the laplace-spline equation  (carres method is used) 
c*******************************************************************************
c 
	dzrmsp=zrange 
	relax=1.0 
	do 4000 iter=1,itmax 
	dzrms=0. 
	dzmax=0. 
	npg =0 
	do 2000 i=1,nx 
	do 2000 j=1,ny 
	z00=z(i,j) 
	if(z00-big)205,2000,2000 
205	if(z00)2000,208,208 
208	wgt=0. 
	zsum=0. 
c 
	im=0 
	if(i-1)570,570,510 
510	zim=abs(z(i-1,j)) 
	if(zim-big)530,570,570 
530	im=1 
	wgt=wgt+1. 
	zsum=zsum+zim 
	if(i-2)570,570,540 
540	zimm=abs(z(i-2,j)) 
	if(zimm-big)560,570,570 
560	wgt=wgt+cay 
	zsum=zsum-cay*(zimm-2.*zim) 
570	if(nx-i)700,700,580 
580	zip=abs(z(i+1,j)) 
	if(zip-big)600,700,700 
600	wgt=wgt+1. 
	zsum=zsum+zip 
	if(im)620,620,610 
610	wgt=wgt+4.*cay 
	zsum=zsum+2.*cay*(zim+zip) 
620	if(nx-1-i)700,700,630 
630	zipp=abs(z(i+2,j)) 
	if(zipp-big)650,700,700 
650	wgt=wgt+cay 
	zsum=zsum-cay*(zipp-2.*zip) 
700	continue 
c 
	jm=0 
	if(j-1)1570,1570,1510 
1510	zjm=abs(z(i,j-1)) 
	if(zjm-big)1530,1570,1570 
1530	jm=1 
	wgt=wgt+1. 
	zsum=zsum+zjm 
	if(j-2)1570,1570,1540 
1540	zjmm=abs(z(i,j-2)) 
	if(zjmm-big)1560,1570,1570 
1560	wgt=wgt+cay 
	zsum=zsum-cay*(zjmm-2.*zjm) 
1570	if(ny-j)1700,1700,1580 
1580	zjp=abs(z(i,j+1)) 
	if(zjp-big)1600,1700,1700 
1600	wgt=wgt+1. 
	zsum=zsum+zjp 
	if(jm)1620,1620,1610 
1610	wgt=wgt+4.*cay 
	zsum=zsum+2.*cay*(zjm+zjp) 
1620	if(ny-1-j)1700,1700,1630 
1630	zjpp=abs(z(i,j+2)) 
	if(zjpp-big)1650,1700,1700 
1650	wgt=wgt+cay 
	zsum=zsum-cay*(zjpp-2.*zjp) 
1700	continue 
c 
	dz=zsum/wgt-z00 
	npg=npg+1 
	dzrms=dzrms+dz*dz 
	dzmax=amax1(abs(dz),dzmax) 
	z(i,j)=z00+dz*relax 
2000	continue 
c 
c 
c     shift data points zp progressively back to their proper places as 
c     the shape of surface z becomes evident. 
c*******************************************************************************
c 
	if(iter-(iter/10)*10) 3600,3020,3600 
3020	do 3400 k=1,n 
	knxt(k) =iabs(knxt(k)) 
	if(knxt(k))3400,3400,3030 
3030	x=(xp(k)-x1)/dx 
	i=x+1.5 
	x= x+1.-i 
	y=(yp(k)-y1)/dy 
	j=y+1.5 
	y=y+1.-j 
	zpxy = zp(k)+zbase 
	z00 = abs(z(i,j)) 
c 
	zw=1.e35 
	if(i-1)3120,3120,3110 
3110	zw = abs(z(i-1,j)) 
3120	ze=1.e35 
	if(i-nx)3130,3140,3140 
3130	ze = abs(z(i+1,j)) 
3140	if(ze-big)3160,3150,3150 
3150	if(zw-big)3180,3170,3170 
3160	if(zw-big)3200,3190,3190 
3170	ze=z00 
	zw=z00 
	go to 3200 
3180	ze=2.*z00-zw 
	go to 3200 
3190	zw = 2.*z00-ze 
c 
3200	zs=1.e35 
	if(j-1)3220,3220,3210 
3210	zs = abs(z(i,j-1)) 
3220  	zn= 1.e35 
	if(j-ny)3230,3240,3240 
3230	zn = abs(z(i,j+1)) 
3240	if(zn-big)3260,3250,3250 
3250	if(zs-big)3280,3270,3270 
3260	if(zs-big)3300,3290,3290 
3270	zn= z00 
	zs= z00 
	go to 3300 
3280	zn = 2.*z00-zs 
	go to 3300 
3290	zs = 2.*z00-zn 
c 
3300	a=(ze-zw)*.5 
	b=(zn-zs)*.5 
	c=(ze+zw)*.5-z00 
	d=(zn+zs)*.5-z00 
	zxy=z00+a*x+b*y+c*x*x+d*y*y 
	delz=z00-zxy 
	delzm=derzm*(abs(x)*dx+abs(y)*dy)*.80 
	if(delz-delzm)3355,3355,3350 
3350	delz=delzm 
3355	if(delz+delzm)3360,3365,3365 
3360	delz=-delzm 
3365	zpij(k)=zpxy+delz 
3400	continue 
c 
	do 3500 k=1,n 
	if(knxt(k))3500,3500,3410 
3410	npt=0 
	zsum = 0. 
	i= (xp(k)-x1)/dx + 1.5 
	j= (yp(k)-y1)/dy + 1.5 
	kk = k 
3420	npt = npt+1 
	zsum = zsum + zpij(kk) 
	knxt(kk)= -knxt(kk) 
	kk = -knxt(kk) 
	if(kk-n)3420,3420,3430 
3430	z(i,j) =  -zsum/npt 
3500	continue 
3600	continue 
c 
c     test for convergence 
c*******************************************************************************
c 
	if(npg.eq.0)goto 4010
	dzrms=sqrt(dzrms/npg) 
	root =dzrms/dzrmsp 
	dzrmsp=dzrms 
	dzmaxf=dzmax/zrange 
	if(iter-(iter/10)*10-2)3715,3710,3715 
3710	dzrms8 = dzrms 
3715	if(iter-(iter/10)*10)4000,3720,4000 
3720	root = sqrt(sqrt(sqrt(dzrms/dzrms8))) 
	if(root-.9999)3730,4000,4000 
3730	if(dzmaxf/(1.-root)-eps)4010,4010,3740 
c 
c     improve the relaxation factor. 
c*******************************************************************************
c 
3740	if((iter-20)*(iter-40)*(iter-60))4000,3750,4000 
3750	if(relax-1.-root)3760,4000,4000 
3760	tpy =(root+relax-1.)/relax 
	rootgs = tpy*tpy/root 
	relaxn= 2./(1.+sqrt(1.-rootgs)) 
	if(iter-60)3780,3785,3780 
3780	relaxn= relaxn-.25*(2.-relaxn) 
3785	relax = amax1(relax,relaxn) 
4000	continue 
4010	continue 
c 
c     remove zbase from array z and return. 
c 
	do 4500 i=1,nx 
	do 4500 j=1,ny 
	if(z(i,j)-big)4400,4500,4500 
4400	z(i,j)=abs(z(i,j))-zbase 
4500	continue 
	return 
	end 

	SUBROUTINE GETSYM(STR,LABEL,NC,IER)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)getsym.F	1.3    5/31/88
C**
C**
C***********************************************************************
C**
C**		    PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C**	Subprogram called:
C**		CALL GETSYM(STR,LABEL,NC,IER)
C**
C**	Parameters:
C**		STR -- 120 CHARACTER SYMBOL  (char*120)
C**		LABEL -- Value of symbol (char*2048)
C**		NC -- length of LABEL
C**		IER -- error code
C**			0 = success
C**			1 = symbol not found
C**
C**	Description:
C**		Gets value for symbol.
C**
C**	History:
C**	    Written:  
C**		15-DEC-1985	by Donald W. Denbo
C**	    Modified:
C**
C**
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
C* v552 *acm* 3/03 Longer strings: changes for multi-line labels
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long

	INCLUDE 'SYSTEM.INC'
	INCLUDE 'SYMKEY.INC'
	CHARACTER STR*(*),LABEL*(*),DTE*24

	CHARACTER adate*8, atime*10, zone*5
	CHARACTER*3 month_names(12)
	INTEGER ival(8)
        DATA month_names/
     .  'JAN', 'FEB', 'MAR', 'APR', 'MAY', 'JUN',
     .    'JUL', 'AUG', 'SEP', 'OCT', 'NOV', 'DEC'/

	LOGICAL SYS
	CALL SYMCNV(STR,SYS)

	IER=0
	LABEL=' '
C
C	Check for special symbols
C
	IF(STR.EQ.'TIME')THEN

#ifdef gfortran
	   CALL  DATE_AND_TIME(adate, atime, zone, ival)
	   WRITE (label, 101) ival(5), ival(6), ival(7)
  101	   FORMAT (I2.2, ':', I2.2 ':', I2.2)
           NC = 8
#else

#ifdef unix
#ifdef F90_DATE_TIME
            CALL FTIME(dte)
            label=dte(1:8)
            NC=8
#else
            CALL fdate(dte)
            label=dte(12:19)
            NC=9
#endif
#else
            call time(label)
            NC=8
#endif
#endif

	ELSE IF(STR.EQ.'DATE')THEN

#ifdef gfortran
	   CALL  DATE_AND_TIME(adate, atime, zone, ival)
* reformat the output
	   WRITE (label, 102) ival(3), month_names(ival(2)), ival(1)
  102	   FORMAT (I2.2, '-', A3, '-', I4.4)
           NC = 11
#else

#ifdef unix
            CALL FDATE(dte)
#ifdef F90_DATE_TIME
            label=dte(4:6)//' '//dte(1:2)//' '//dte(8:9)
            NC=9
#else
            label=dte(5:11)//dte(21:24)
            NC=11
#endif
#else
            call date(label)
            nc=9
#endif
#endif

	ELSE
C
C	Otherwise get symbol value from file
C
	    CALL GTSYM2(STR,LABEL,NC,SYS,IER)
	ENDIF
	RETURN
	END
	SUBROUTINE GTSYM2(STR,LABEL,NC,SYS,IER)

	INCLUDE 'SYSTEM.INC'
	INCLUDE 'SYMKEY.INC'

C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 

	CHARACTER STR*(*),LABEL*(*),dummy*120
	LOGICAL SYS
	ilen=lnblk(str,120)
	IF(SYS)GOTO 100
	IF(SMKEY2)THEN
	    call dbmfetch(keyln2,str,ilen,label,nc,ier)
	    if(ier.ne.0)goto 100
	    RETURN
	ENDIF
100	call dbmfetch(keyln1,str,ilen,label,nc,ier)
	RETURN
	END

*           rr_grad_pbc_v.F
*
*           Rick Romea
*           Jan. 24, 2000
*
*     Baroclinic pressure gradient term in v momentum equation
*     Units :     cm/s/s
*     MOM2 Grid:  U   
*
************************************************************************


	! NOTE: still need to fix up if first z grid point is not 1


      SUBROUTINE RR_grad_pbc_v_init(id)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

      CALL ef_set_desc             (id,
     .'Barclininc -dp/dy term (cm/s^2) on the MOM2 U Grid')
      CALL ef_set_num_args         (id, 3)
      CALL ef_set_has_vari_args    (id, NO)
      CALL ef_set_axis_inheritance (id, IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok     (id, YES, YES, YES, YES)

      CALL ef_set_arg_name         (id, ARG1, 'U')
      CALL ef_set_arg_desc         (id, ARG1,
     . 'Zonal velocity,required to access MOM2 U Grid. ')
      CALL ef_set_arg_unit         (id, ARG1, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG1, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG1, YES, YES, YES, YES)
      CALL ef_set_axis_extend      (id, ARG1, X_AXIS,0,+1)
      
      CALL ef_set_arg_name         (id, ARG2, 'TEMP')
      CALL ef_set_arg_desc         (id, ARG2,
     . 'Potential Temperature, on the MOM2 T Grid. ')
      CALL ef_set_arg_unit         (id, ARG2, 'oC')
      CALL ef_set_arg_type         (id, ARG2, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2, NO, NO,YES,YES)
      CALL ef_set_axis_extend      (id, ARG2, X_AXIS,0,+1)
      CALL ef_set_axis_extend      (id, ARG2, Y_AXIS,0,+1)

      
      CALL ef_set_arg_name         (id, ARG3, 'SALT')
      CALL ef_set_arg_desc         (id, ARG3,
     .  'Salinity on the MOM2 T Grid. ')
      CALL ef_set_arg_unit         (id, ARG3, 'ppm-0.035')
      CALL ef_set_arg_type         (id, ARG3, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG3, NO, NO,YES,YES)
      CALL ef_set_axis_extend      (id, ARG3, X_AXIS,0,+1)
      CALL ef_set_axis_extend      (id, ARG3, Y_AXIS,0,+1)

      END

c*******************************************************************

      SUBROUTINE RR_grad_pbc_v_compute(id, arg_1, arg_2, arg_3, result)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS)
      REAL bad_flag_result
      REAL arg_1  (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .             mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2  (mem2lox:mem2hix, mem2loy:mem2hiy, 
     .             mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3  (mem3lox:mem2hix, mem3loy:mem2hiy, 
     .             mem3loz:mem2hiz, mem3lot:mem2hit)
      REAL result (memreslox:memreshix, memresloy:memreshiy, 
     .             memresloz:memreshiz, memreslot:memreshit)

      INTEGER  res_lo_ss (4)
      INTEGER  res_hi_ss (4)
      INTEGER  res_incr  (4)

      INTEGER  arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER  arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER  arg_incr  (4,EF_MAX_ARGS)

      INTEGER i,  j,  k,  l, m
      INTEGER i2, j2, k2, l2, m1
      INTEGER i3, j3, k3, l3

      REAL*8         xU(1024)
      REAL*8         yU(1024)
      REAL*8         zU(1024)

      INTEGER        ilat
      INTEGER        ilon
      INTEGER        iZ

      CHARACTER*16  ax_name(4)
      CHARACTER*16  ax_units(4)
      LOGICAL        backward(4)
      LOGICAL        modulo(4)
      LOGICAL        regular(4)

      REAL       dyt  
      REAL*8     Rho  ! functions for density
      REAL       ss,tt

      INCLUDE 'rr_parameters.h'

      ! Statement Functions

      ss(i,j,k,l) =  arg_3(i,j,k,l)*1000. + 35. ! True salinity (ppt)
      tt(i,j,k,l) =  arg_2(i,j,k,l)

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags      (id, bad_flag,  bad_flag_result)

	! Check that upper z grid point is the surface z grid point
	
      IF (arg_lo_ss(Z_AXIS,ARG1) .NE. 1) THEN
        CALL ef_bail_out(id,'U:Upper grid point must be surface')
	ENDIF
      IF (arg_lo_ss(Z_AXIS,ARG2) .NE. 1) THEN
        CALL ef_bail_out(id,'TEMP:Upper grid point must be surface')
      ENDIF
      IF (arg_lo_ss(Z_AXIS,ARG3) .NE. 1) THEN
        CALL ef_bail_out(id,'SALT:Upper grid point must be surface')
	ENDIF

      ! Get U grid coordinates

      CALL ef_get_coordinates    (id, ARG1, X_AXIS, 
     .                            arg_lo_ss(X_AXIS,ARG1),
     .                            arg_hi_ss(X_AXIS,ARG1), xU)    
      CALL ef_get_coordinates    (id, ARG1, Y_AXIS, 
     .                            arg_lo_ss(Y_AXIS,ARG1),
     .                            arg_hi_ss(Y_AXIS,ARG1), yU)
      CALL ef_get_coordinates    (id, ARG1, Z_AXIS, 
     .                            arg_lo_ss(Z_AXIS,ARG1),
     .                            arg_hi_ss(Z_AXIS,ARG1), zU)

      ! check axis units

      CALL ef_get_axis_info  (id, ARG2, ax_name, ax_units, 
     .                                backward, modulo, regular) 
      IF     ( ax_units(1) .NE. 'deg'       .AND.
     .         ax_units(1) .NE. 'lon'       .AND.
     .         ax_units(1) .NE. 'degrees_E' .AND.
     .         ax_units(1) .NE. 'longitude' .AND.
     .         ax_units(1) .NE. 'Longitude' .AND. 
     .         ax_units(1) .NE. 'LONGITUDE' ) THEN
        WRITE (6,*)'Longitude axis units =', ax_units(1) 
        ! CALL ef_bail_out(id,'Longitude axis must be in degrees')
      ENDIF

      IF     ( ax_units(2) .NE. 'deg'       .AND.
     .         ax_units(2) .NE. 'lat'       .AND.
     .         ax_units(2) .NE. 'degrees_N' .AND.
     .         ax_units(2) .NE. 'latitude'  .AND.
     .         ax_units(2) .NE. 'Latitude'  .AND. 
     .         ax_units(2) .NE. 'LATITUDE' ) THEN
        WRITE (6,*)'Latitude axis units =', ax_units(2) 
        ! CALL ef_bail_out(id,'Latitude axis must be in degrees')
      ENDIF

      ! start the loop

      iLat = 1
      j2 = arg_lo_ss(Y_AXIS,ARG2) 
      j3 = arg_lo_ss(Y_AXIS,ARG3) 
      DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

         dyt = SNGL (yU(iLat+1)-yU(iLat)) * Latitude_to_cm
         iLon = 1
         i2 = arg_lo_ss(X_AXIS,ARG2) 
         i3 = arg_lo_ss(X_AXIS,ARG3) 
         DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

            l2 = arg_lo_ss(T_AXIS,ARG2)
            l3 = arg_lo_ss(T_AXIS,ARG3)
            DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

	       iZ = 1
               k2 = arg_lo_ss(Z_AXIS,ARG2)
               k3 = arg_lo_ss(Z_AXIS,ARG3)
               DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

                  IF (
     .              arg_2(i2,  j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .              arg_2(i2,  j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .              arg_2(i2,  j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .              arg_2(i2+1,j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .              arg_2(i2+1,j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .              arg_2(i2+1,j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .              arg_2(i2-1,j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .              arg_2(i2-1,j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .              arg_2(i2-1,j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .              arg_3(i3,  j3,  k3,l3) .EQ. bad_flag(ARG3) .OR.
     .              arg_3(i3,  j3+1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .              arg_3(i3,  j3-1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .              arg_3(i3+1,j3,  k3,l3) .EQ. bad_flag(ARG3) .OR.
     .              arg_3(i3+1,j3+1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .              arg_3(i3+1,j3-1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .              arg_3(i3-1,j3,  k3,l3) .EQ. bad_flag(ARG3) .OR.
     .              arg_3(i3-1,j3+1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .              arg_3(i3-1,j3-1,k3,l3) .EQ. bad_flag(ARG3) 
     .                      ) THEN
                     result(i,j,k,l) = bad_flag_result
                  ELSE

                    IF (iZ .EQ. 1) THEN  ! Top z-grid point.
                      
                      result(i,j,k,l) = SNGL(zU(iZ)) * SNGL( 
     .  Rho(DBLE(tt(i2+1,j2+1,k2,l2)),DBLE(ss(i3+1,j3+1,k3,l3)),zU(iZ)) 
     . +Rho(DBLE(tt(i2  ,j2+1,k2,l2)),DBLE(ss(i3  ,j3+1,k3,l3)),zU(iZ)) 
     . -Rho(DBLE(tt(i2+1,j2  ,k2,l2)),DBLE(ss(i3+1,j3  ,k3,l3)),zU(iZ)) 
     . -Rho(DBLE(tt(i2  ,j2  ,k2,l2)),DBLE(ss(i3  ,j3  ,k3,l3)),zU(iZ))
     .                         )
                     ELSE
                       result(i,j,k,l) = 0.
					  
		       m1=arg_lo_ss(Z_AXIS,ARG2)+1
                       DO m=2,iZ
                          result(i,j,k,l) = result(i,j,k,l) + 
     .                             SNGL (zU(m+1) - zU(m)) * SNGL ( 
     .            Rho(DBLE(tt(i2+1,j2+1,m1  ,l2)),
     .                DBLE(ss(i3+1,j3+1,m1  ,l3)),zU(m  ))
     .           +Rho(DBLE(tt(i2+1,j2+1,m1-1,l2)),
     .                DBLE(ss(i3+1,j3+1,m1-1,l3)),zU(m-1))
     .           +Rho(DBLE(tt(i2  ,j2+1,m1  ,l2)),
     .                DBLE(ss(i3  ,j3+1,m1  ,l3)),zU(m  ))
     .           +Rho(DBLE(tt(i2  ,j2+1,m1-1,l2)),
     .                DBLE(ss(i3  ,j3+1,m1-1,l3)),zU(m-1))
     .           -Rho(DBLE(tt(i2+1,j2  ,m1  ,l2)),
     .                DBLE(ss(i3+1,j3  ,m1  ,l3)),zU(m  ))
     .           -Rho(DBLE(tt(i2+1,j2  ,m1-1,l2)),
     .                DBLE(ss(i3+1,j3  ,m1-1,l3)),zU(m-1))
     .           -Rho(DBLE(tt(i2  ,j2  ,m1  ,l2)),
     .                DBLE(ss(i3  ,j3  ,m1  ,l3)),zU(m  ))
     .           -Rho(DBLE(tt(i2  ,j2  ,m1-1,l2)),
     .                DBLE(ss(i3  ,j3  ,m1-1,l3)),zU(m-1))
     .               )
	               m1 = m1 + arg_incr(Z_AXIS,ARG2)
                       ENDDO
                       result(i,j,k,l) = result(i,j,k,l)/2.
                     ENDIF
                     result(i,j,k,l) = result(i,j,k,l)*RR_temp1/dyt
     .                                   * sec_per_month

                  ENDIF

                 iZ = iZ + 1
                 k2 = k2 + arg_incr(Z_AXIS,ARG2)
                 k3 = k3 + arg_incr(Z_AXIS,ARG3)
                 ENDDO

               l2 = l2 + arg_incr(T_AXIS,ARG2)
               l3 = l3 + arg_incr(T_AXIS,ARG3)
            ENDDO

            iLon = iLon + 1
            i2 = i2 + arg_incr(X_AXIS,ARG2)
            i3 = i3 + arg_incr(X_AXIS,ARG3)
         ENDDO

         iLat = iLat + 1
         j2 = j2 + arg_incr(Y_AXIS,ARG2)
         j3 = j3 + arg_incr(Y_AXIS,ARG3)
      ENDDO
      END


      ! Stolen KNUDSEN code to compute density

      ! D = depth (m)
      ! T = temperature (oC)
      ! S = salinity (ppt)

      REAL*8 FUNCTION Rho(T,S,D)
      IMPLICIT NONE
      REAL*8 T,S,D
      REAL*8 T2,T3,S2,S3,F1,F2,F3,FS,SIGMA,A,B1,B2,B,CO,ALPHA
      T2=T*T
      T3=T2*T
      S2=S*S
      S3=S2*S
      F1=-(T-3.98d0)**2*(T+283.d0)/(503.57d0*(T+67.26d0))
      F2=T3*1.0843d-6-T2*9.8185d-5+T*4.786d-3
      F3=T3*1.667d-8-T2*8.164d-7+T*1.803d-5
      FS=S3*6.76786136d-6-S2*4.8249614d-4+S*8.14876577d-1
      SIGMA=F1+(FS+3.895414d-2)*(1.d0-F2+F3*(FS-.22584586d0))
      A=D*1.d-4*(105.5d0+T*9.5d0-T2*.158d0-D*T*1.5d-4)-
     .(227.d0+T*28.33d0-T2*.551d0+T3*.004d0)
      B1=(FS-28.1324d0)/10.d0
      B2=B1*B1
      B=-B1*(147.3d0-T*2.72d0+T2*.04d0-D*1.d-
     .4*(32.4d0-.87d0*T+.02d0*T2))
      B=B+B2*(4.5d0-.1d0*T-D*1.d-4*(1.8d0-.06d0*T))
      CO=4886.d0/(1.d0+1.83d-5*D)
      ALPHA=D*1.d-6*(CO+A+B)
      Rho=(SIGMA+ALPHA)/(1.d0-1.d-3*ALPHA)
      END

	SUBROUTINE CHOUT(CHR,ICNT)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)chout.F	1.3    5/25/88
C * v552 *acm* 3/03 Longer strings: changes for multi-line labels.
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
#ifdef unix
	include 'PLTCOM.DAT'
#else
	include 'pplinc:PLTCOM.DAT'
#endif
#ifdef unix
	integer chr(icnt)
	character*2048 buf
#else
	byte iosb(4),buf(80),chr(icnt)
	include '($IODEF)'

#endif
C
C	WRITES A SINGLE CHARACTER TO THE TERMINAL
C	D. DENBO JUNE 1983  UPDATED MARCH 1984
C
	DATA IPT/1/
	J=1
#ifdef unix
40	BUF(IPT:IPT)=CHAR(CHR(j))
#else
40	buf(ipt)=chr(j)
#endif
	IPT=IPT+1
	J=J+1
	IF(IPT.GT.80)THEN
C
#ifdef unix
	IF(FILET(1:8).EQ.'/dev/tty')THEN
	    do 50 i=1,80
		istat=putch(buf(i:i))
50	    continue
#else
        IF(FILET(1:3).EQ.'TT:')THEN
            CALL SYS$ASSIGN('TT',CHAN,,)
            CALL SYS$QIOW(,%VAL(CHAN),
     *	    %VAL(IO$_WRITELBLK .OR. IO$M_NOFORMAT)
     *      ,,,,BUF,%VAL(80),,,,)
            CALL SYS$DASSGN(%VAL(CHAN))
#endif
	ELSE
	    IF(.NOT.TEKOPN)THEN
#ifdef unix
		OPEN(LUTK,FILE=FILET,STATUS='NEW')
#else
                OPEN(LUTK,FILE=FILET,STATUS='NEW',
     *		CARRIAGECONTROL='NONE')
#endif
		TEKOPN=.TRUE.
	    ENDIF
#if defined unix && ! defined F90_NO_FPUTC
	    do 51 i=1,80
		call fputc(LUTK,buf(i:i))
51	    continue
#else
	    WRITE(LUTK,999)BUF
999	    format(80a1)
#endif
	ENDIF
	IPT=1
	ENDIF
	IF(J.LE.ICNT)GOTO 40
	RETURN
	ENTRY CHDMP
#ifdef unix
	IF(FILET(1:8).EQ.'/dev/tty')THEN
	    do 60 i=1,ipt-1
		istat=putch(buf(i:i))
60	    continue
	ELSE
	    IF(.NOT.TEKOPN)THEN
		OPEN(LUTK,FILE=FILET,STATUS='NEW')
		TEKOPN=.TRUE.
	    ENDIF
	    do 61 i=1,ipt-1
#ifndef F90_NO_FPUTC
		call fputc(LUTK,buf(i:i))
#else
		WRITE(LUTK,'(a1)')(BUF(I:I))
#endif
61	    continue
	ENDIF
#else
        IF(FILET(1:3).EQ.'TT:')THEN
            CALL SYS$ASSIGN('TT',CHAN,,)
            CALL SYS$QIOW(,%VAL(CHAN),
     *		%VAL(IO$_WRITELBLK .OR. IO$M_NOFORMAT)
     *      ,,,,BUF,%VAL(IPT-1),,,,)
            CALL SYS$DASSGN(%VAL(CHAN))
        ELSE
            IF(.NOT.TEKOPN)THEN
                OPEN(LUTK,FILE=FILET,STATUS='NEW',
     *		CARRIAGECONTROL='NONE')
                TEKOPN=.TRUE.
            ENDIF
            WRITE(LUTK,999)(BUF(I),I=1,IPT-1)
        ENDIF
#endif
	IPT=1
	RETURN
	END

	BLOCK DATA XVARIABLES_DATA

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* initialization of COMMON / XVARIABLES /
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/31/86
* .
* .
* .
* revision 2.0 - 7/21/88 - initialize mblk_size/flink, mr_priority/protected
* V200:  5/17/89 - eliminated _dim% --> 4D symmetry for memory resident data
*		 - all cvar-related stuff to XCALC_VARS
* 		 - deleted variables flagged in mr_protected and mr_del_ links
*		 - eliminated nvar's, modified uvar's
*		 - initialize isp
* Ultrix/RISC port - 2/2/91 - Ultrix compiler doesnt permit variable to be
*               defined multiple times by DATA statements
*               Unix version requires implicit DO loops to be spelled out to
*               avoid duplicate initialization
* V230:  1/30/92 - Sun port: made initialization limits on mr_protected explicit
* V312: 5/94 - array "memory" no longer a COMMON variable
* Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
*       2/12 *kms* Add E and F dimensions (set to nferdims in tmap_dims.parm)
* V685+: 3/14 *sh* - initialize max_usable_intrp
* V695+: 5/15 *sh* - initialize uvar_c_cache_ptr
* V702:  2/17 *sh* - remove old block memory management variables
* V745  4/19 *acm* ticket 1916, special handling getting context for RETURN= outputs
*                  new dynamic-memory line storage for keeping a list of uvars

        IMPLICIT NONE
#include "tmap_dset.parm"
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'	! .cmn_text has an external
!	external xgt_grid_data	! xtm_grid --> xgt  (DEC f77 3.2 not allowed)
	include 'ferret.parm'
	include 'xvariables.cmn'

	INTEGER	    max_mrm1
	PARAMETER ( max_mrm1 = max_mrs - 1 )

	INTEGER	i

* dummy stored memory variable
	DATA mr_protected	( dummy_mr ) / mr_perm_protected /
	DATA mr_size		( dummy_mr ) / 0		/
	DATA mr_data_set	( dummy_mr ) / unspecified_int4	/
	DATA mr_category	( dummy_mr ) / cat_dummy_var	/
	DATA mr_variable	( dummy_mr ) / unspecified_int4	/
	DATA mr_grid		( dummy_mr ) / unspecified_int4	/
	DATA mr_bad_data	( dummy_mr ) / bad_val4		/
	DATA (mr_lo_ww(i,dummy_mr),i=1,nferdims)/ nferdims*unspecified_val8 /
	DATA (mr_hi_ww(i,dummy_mr),i=1,nferdims)/ nferdims*unspecified_val8 /
	DATA (mr_trans(i,dummy_mr),i=1,nferdims)/ nferdims*trans_no_transform /
	DATA (mr_lo_ss(dummy_mr,i),i=1,nferdims)/ nferdims*1 / ! usable dimension
	DATA (mr_hi_ss(dummy_mr,i),i=1,nferdims)/ nferdims*1 / ! usable dimension

* interp stack pointer at stack base
	DATA isp / 1 /

* interp stack pointer movable top
	DATA max_usable_intrp / max_intrp /

* memory variable table and delete priority chain initialization
* (1/92 - made initialization limits explicit for Sun port)
	DATA (mr_protected(i),i=1,max_mrm1)
     .	      / max_mrm1*mr_deleted /	! top one is mr_dummy

	DATA mr_del_flink(0)/ 0 /,
     .	     mr_del_blink(0)/ 0 /,
     .	     (mr_del_flink(i),i=1,max_mrs)/ max_mrs*unspecified_int4 /,
     .	     (mr_del_blink(i),i=1,max_mrs)/ max_mrs*unspecified_int4 /

* user-defined variables
        DATA uvar_name_code_head / 0 /
        DATA uvar_name_code_padding / 0 /
        DATA uvar_name_code      /max_uvar*' '/
        DATA uvar_num_items_head / 0 /
        DATA uvar_num_items_padding / 0 /
	DATA uvar_num_items	/ max_uvar*uvar_deleted /
	DATA uvar_c_cache_ptr	/ max_uvar*0.0 /
	DATA num_uvars_in_cmnd	/ cmnd_uvars_not_given	/

	
* Remote user-defined variables: LET/REMOTE
	DATA uvar_remote	 /max_uvar*.FALSE./
	DATA rvar_on_server	 /max_rvar*.FALSE./
	DATA rvar_uvar		 /max_rvar*0/
	DATA rvar_dset		 /max_rvar*0/
	DATA rvar_varid		 /max_rvar*0/

	END

	LOGICAL FUNCTION TM_DIGIT( string )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* test to see if the first character of "string" is the first character
* of a number

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.00 - 06/24/88
* 11/6/94 *sh* Kludge for AIX port (fixes to PLOT+ to avoid problems with
*	FORTRAN READ ERR= branches):  check for "/" following "." since
*	path names often begin with "./name"
* 1/03 *kob* - g77 port - g77 won't allow intrinsic functions in PARAMETER
*                         statements.  use an character constant instead
* V685+ 12/13    - *acm*  bounds checking: dont refer to parts of the string outside its bounds.

#include "gt_lib.parm"

* calling argument declarations:
	CHARACTER*(*)	string

* internal variable declarations:
	INTEGER		i, slen
	CHARACTER*1	c
	
* local parameter declarations:
        CHARACTER*1     tab
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
#else
	PARAMETER     ( tab = CHAR(9))
#endif

	slen = LEN(string)
	IF (slen .EQ. 0) THEN
	   TM_DIGIT = .FALSE.
	   RETURN
	ENDIF

* skip leading blanks
	DO 100 i = 1, slen
	   c = string(i:i)
	   IF ( c .NE. ' ' .AND. c .NE. tab ) GOTO 200
 100	CONTINUE

* string is blank
	TM_DIGIT = .FALSE.
        RETURN
	
* check first character
 200	TM_DIGIT =   c .EQ. '+'
     .		.OR. c .EQ. '-'
     .		.OR. c .EQ. '.'
     .		.OR. c .GE. '0' .AND. c .LE. '9'

* kludge check for "./name" (11/94 for AIX port)
	IF (slen.GE.2 ) THEN
	   IF (c.EQ.'.') TM_DIGIT = string(2:2) .NE. PathSeparator

* Check for .. starting a string, dataset global attributes

           IF (i .LT. slen) THEN
              IF(c .EQ. '.' .AND. string(i+1:i+1) .EQ. '.') TM_DIGIT = .FALSE.
	   ENDIF
	
	ENDIF

	RETURN

      END

	SUBROUTINE DO_4D_TRANS( action,
     .				com, com_mr, com_cx,
     .				res, res_mr, res_cx,
     .				boxes,
     .			        weights, s_var )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* perform a multi-axis transformation

* multi-axis transformations are those special cases where sequential
* application of single-axis transforms may yield improper results. For
* example, averaging within a circular region would give inappropriate
* results if carried out sequentially: the first axis of averaging would
* be correct but the second axis would weight each averaged row from the
* first axis equally, despite the fact that they represented different
* numbers of data points.

* for a discussion of the 1-pass variance and standard deviation calculations
* see DO_VAR_SUB

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V430: 7/1/96 - based on DO_XY_AVE_INT
* ... comments from DO_XY_AVE_INT:
* V200:  6/5/89
*       10/11/89 - modified array declarations using XMEM_SUBSC.CMN
* V230: 8/10/92  - results were wrong for integration within a single box
* V430: 7/30/96 - IBM port - change yes/no_[xyzt]ax declaration from
*	          INTEGER to LOGICAL *kob*
* V440: 8/23/96 - added cos_factor, was not applying COS(lat) to XZ calcs
* V450: 5/97 -  only apply COS(y) if X integration is involved and Y axis
*		limits are valid (abstract expressions like Z[G=temp] can
*		have a geog Y axis that is not actually used
* 3/06 - apply Andrew*s suggested correction for XY integ., bug1348
* 6/06 - Fix to Andrew*s correction for XY integ., bug1348
* 4/10 - Fix #1735; For averages other than in Y direction the above fix 
*        failed to set ybox sizes and cos correction. Still need to set these.
* 8/10 - One further fix to #1735
* 2/11 - One further fix to #1348: @DIN over 1 grid cell in Y
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V685 *acm* 7/13  Fix ticket 2083: single-y and multi-D transform
* V685+*acm* 12/13 Bug in y boxes; only when y axis in the transf.
* V695 *acm* 10/15 Fix #2319: @STD as a multi-D transform
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.
* V702 *sh* 11/16 mods for trac #2428 - calculation in gathered fragments
* V72  *acm* 6/17 Ticket 2539: Do not set res to bad-value for ave, din.
*                 Weights of zero or non-zero mark whether data is found.

	IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xunits.cmn_text'
	external xunits_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data

* internal variable declarations:
	LOGICAL GEOG_COS_FACTOR, ITSA_TRUEMONTH_AXIS,
     .		point, yes_ax(nferdims), no_ax(nferdims),
     .		at_ave, at_var, at_din, at_nbd, at_ngd, at_sum, at_std, 
     .		short_comp,need_cos, one_y, its_var_or_std, its_ave_or_din
	INTEGER idim, i, j, ir, jr, kr, lr, mr, nr, ic, jc, kc, lc, mc, nc,
     .		grid, nbd, ngd, com_lo(nferdims), com_hi(nferdims),
     .		box_offset(nferdims), offset, ind_lo, ind_hi, cos_offset
	REAL	BOX_SIZE, unit, bad_com, bad_res, box, mean, 
     .		diff,xbox, ybox, zbox, tbox, ebox, fbox,
     .		yc, yh, yh_2, bb, ybxlo, ybxhi, lo_box_lo, hi_box_hi
	REAL*8	TM_WORLD, dsum, bsum, ok,
     .		w, v, wsum_chunk, mean_chunk, mean_old, s_chunk

* calling argument declarations:
	INTEGER	action, com_mr, com_cx, res_mr, res_cx
	REAL    com     ( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .                    m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          res     ( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .                    m2lot:m2hit,m2loe:m2hie,m2lof:m2hif ),
     .          weights ( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .                    m2lot:m2hit,m2loe:m2hie,m2lof:m2hif ),
     .          s_var   ( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .                    m2lot:m2hit,m2loe:m2hie,m2lof:m2hif ),
     .		boxes(*)

* equivalences
	LOGICAL yes_xax, yes_yax, yes_zax,
     .          yes_tax, yes_eax, yes_fax,
     .          no_xax,  no_yax,  no_zax,
     .          no_tax,  no_eax,  no_fax

     	INTEGER	ioffset, joffset, koffset, loffset, moffset, noffset,
     .		i_lo, j_lo, k_lo, l_lo, m_lo, n_lo,
     .		i_hi, j_hi, k_hi, l_hi, m_hi, n_hi

	EQUIVALENCE ( yes_ax(1), yes_xax ),
     .		    ( yes_ax(2), yes_yax ),
     .		    ( yes_ax(3), yes_zax ),
     .		    ( yes_ax(4), yes_tax ),
     .		    ( yes_ax(5), yes_eax ),
     .		    ( yes_ax(6), yes_fax ),
     .		    (  no_ax(1),  no_xax ),
     .		    (  no_ax(2),  no_yax ),
     .		    (  no_ax(3),  no_zax ),
     .		    (  no_ax(4),  no_tax ),
     .		    (  no_ax(5),  no_eax ),
     .		    (  no_ax(6),  no_fax ),
     .		    ( box_offset(1), ioffset ),
     .		    ( box_offset(2), joffset ),
     .		    ( box_offset(3), koffset ),
     .		    ( box_offset(4), loffset ),
     .		    ( box_offset(5), moffset ),
     .		    ( box_offset(6), noffset ),
     .		    (  com_lo(1),  i_lo ),
     .		    (  com_lo(2),  j_lo ),
     .		    (  com_lo(3),  k_lo ),
     .		    (  com_lo(4),  l_lo ),
     .		    (  com_lo(5),  m_lo ),
     .		    (  com_lo(6),  n_lo ),
     .		    (  com_hi(1),  i_hi ),
     .		    (  com_hi(2),  j_hi ),
     .		    (  com_hi(3),  k_hi ),
     .		    (  com_hi(4),  l_hi ),
     .		    (  com_hi(5),  m_hi ),
     .		    (  com_hi(6),  n_hi )

* --- end of introductory code ---

* initialize
	grid = mr_grid( com_mr )
	bad_com = mr_bad_data( com_mr )
	bad_res = mr_bad_data( res_mr )
        point = .FALSE.
	one_y = .FALSE.

* determine the type of transform requested
	at_ave = action .EQ. trans_4d_ave
	at_var = action .EQ. trans_4d_var
	at_din = action .EQ. trans_4d_int_def
	at_nbd = action .EQ. trans_4d_bad_pt
	at_ngd = action .EQ. trans_4d_good_pt
	at_sum = action .EQ. trans_4d_sum
	at_std = action .EQ. trans_4d_std
	short_comp = at_ngd .OR. at_nbd	.OR. at_sum	! for speed, only
	its_ave_or_din = at_ave .OR. at_din
	its_var_or_std = at_var .OR. at_std

* determine the axes to be transformed
	DO 10 idim = 1, nferdims
	  yes_ax(idim) = cx_trans(idim,res_cx) .EQ. action
	  no_ax (idim) = .NOT.yes_ax(idim)
 10	CONTINUE

* get and save grid box sizes (weights) just once for efficiency
* ... save all 4 axes in one long array with offsets to find the starts
* Note that "cx_lo_ss(com_cx,idim)" is subtracted so offsets pre-compensate
*    for the axes starting above index = 1

      IF (.NOT. short_comp) THEN  ! boxes are not needed for ngd, nbd, sum.
	offset = 0
	DO 90 idim = 1, nferdims
	  IF (yes_ax(idim)) THEN
	    box_offset(idim) = offset - cx_lo_ss(com_cx,idim) + 1 ! pre-comp'ed
	    offset = offset + 
     .	             cx_hi_ss(com_cx,idim)-cx_lo_ss(com_cx,idim)+1
	  ELSE
	    box_offset(idim) = -9999
	  ENDIF
 90	CONTINUE
! COS(latitudes) also stored in the box array (8/96)
	cos_offset = offset - cx_lo_s2(com_cx) + 1

* ... save the box sizes
	DO 100 idim = 1, nferdims
	  ind_lo = cx_lo_ss(com_cx,idim)
	  ind_hi = cx_hi_ss(com_cx,idim)
	  offset = box_offset(idim)
	  IF (yes_ax(idim)) THEN
* ... complete boxes mid-axis (incl. default full boxes at endpoints)
	   DO i = ind_lo, ind_hi
	      boxes(i+offset)  = BOX_SIZE( i, grid, idim )
	   ENDDO
* 11/16 re-engineered the 8/92 fix - that axis region may lie in a single box
	   lo_box_lo = cx_lo_ww(idim,com_cx)
	   hi_box_hi = cx_hi_ww(idim,com_cx)
! ... the preceding is a more efficient way to obtain
!	   lo_box_lo = TM_WORLD(ind_lo, grid, idim, box_lo_lim)
!	   hi_box_hi = TM_WORLD(ind_hi, grid, idim, box_hi_lim)
* ... trim if partial box at lower end
	   IF ( lo_box_lo .LT. cx_lo_ww(idim,res_cx) ) boxes(ind_lo+offset) =
     .         boxes(ind_lo+offset) - 
     .			( cx_lo_ww(idim,res_cx) - lo_box_lo )
* ... trim if partial box at upper end
	   IF ( hi_box_hi .GT. cx_hi_ww(idim,res_cx) ) boxes(ind_hi+offset) = 
     .            boxes(ind_hi+offset) - 
     .			( hi_box_hi - cx_hi_ww(idim,res_cx) )
	   point = point .OR. boxes(ind_lo+offset).EQ.0.0
* ... perform integrations on standard units if possible
            unit = 1.
	    IF ( at_din ) THEN
	      unit = un_convert( line_unit_code(grid_line(idim,grid)) )
	      IF (ITSA_TRUEMONTH_AXIS(grid_line(idim,grid))) 
     .		  unit = un_convert(pun_day)
	      DO 50 i = ind_lo, ind_hi
 	      boxes(i+offset) = boxes(i+offset) * unit
 50           continue
	    ENDIF
	  ENDIF
 100	CONTINUE

* impose cosine factors if latitude and longitude are involved
* 5/97 - only use COS(y) if X integration is involved and Y axis lims are VALID
* 3/06 - apply Andrew*s suggested correction for XY integ., bug1348
* 6/06   fix the correction; boxes(i+offset) is in meters, so convert back to 
*        degrees, then radians. Compute the factor, and then convert to meters.
C See this thread:
C http://www.pmel.noaa.gov/maillists/tmap/ferret_users/fu_2009/msg00506.html
C And also ticket 1348. The surface area of sphere depends only on h
C http://mathworld.wolfram.com/Zone.html. Fix for @DIN too.

	need_cos = GEOG_COS_FACTOR( y_dim,grid )
     .		.AND. yes_xax
     .	 	.AND. cx_lo_s2(com_cx) .NE. unspecified_int4
        IF ( at_sum ) need_cos = .FALSE.
        one_y = (cx_lo_ww(y_dim,res_cx) .EQ. cx_hi_ww(y_dim,res_cx))

	IF ( need_cos ) THEN
	   DO 120 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)

C Compute the y boxes if there is a y axis; the computation may be 
C avgs in other directions but we need the ybox size at a given y
C The top and bottom boxes extend only to the coordinate locations,
C (Unless there is just one grid cell in the y direction.)

#ifdef double_p
	      ybxlo = deg2rad* 
     .                TM_WORLD(j, grid, y_dim, box_lo_lim)
	      ybxhi = deg2rad* 
     .                TM_WORLD(j, grid, y_dim, box_hi_lim)
#else
	      ybxlo = deg2rad* 
     .                SNGL( TM_WORLD(j, grid, y_dim, box_lo_lim) )
	      ybxhi = deg2rad* 
     .                SNGL( TM_WORLD(j, grid, y_dim, box_hi_lim) )
#endif
	      IF (j .EQ. cx_lo_s2(com_cx) .AND. .NOT.one_y)
     .                ybxlo = deg2rad* cx_lo_ww(y_dim,res_cx)

	      IF (j .EQ. cx_hi_s2(com_cx) .AND. .NOT.one_y)
     .                ybxhi = deg2rad* cx_hi_ww(y_dim,res_cx)

	      boxes(j+cos_offset) = ABS( SIN(ybxhi) - SIN(ybxlo) )

	      ! surface area of sphere depends only on h not on ybox
	      IF (.NOT.at_din .AND. yes_ax(y_dim)) boxes(j+box_offset(y_dim)) = 1.  

	      ! for integral need area is radius*radius* delx * h
	      ! delx already has units that include radius of earth.
	      IF ( at_din .AND. yes_ax(y_dim) ) then
 		       boxes(j+box_offset(y_dim)) =  m_radius 
	      ENDIF
	      ! Single-point Y axis or Y not part of the integral

#ifdef double_p
	      IF ( at_din .AND. no_ax(y_dim))
     .           boxes(j+cos_offset) = COS( deg2rad * 
     .             TM_WORLD(j,grid,y_dim,box_middle) )
#else
	      IF ( at_din .AND. no_ax(y_dim))
     .           boxes(j+cos_offset) = COS( deg2rad * 
     .           SNGL( TM_WORLD(j,grid,y_dim,box_middle) ) )
#endif
 120       CONTINUE
	ELSE
	      DO 121 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
 121	      boxes(j+cos_offset)  = 1.0
	ENDIF

      ENDIF  ! skipped computing boxes for short_comp

* do the transformation: average, integration, variance, ngood, nbad, ...

* Note: the looping structure allows all possible mixes of axis transforms
*	to be performed in a single framework
* ... set up default limits (com_lo, com_hi) in preparation for the inner loop
* "r" refers to result, "c" refers to component

* Set the range of loop indices for the component data on the transformed axes
	DO 150 idim = 1, nferdims
	  IF (yes_ax(idim)) THEN
	    com_lo(idim) = cx_lo_ss(com_cx,idim)
	    com_hi(idim) = cx_hi_ss(com_cx,idim)
	  ENDIF
 150	CONTINUE

* Set default box size for untransformed axes
* (multiplying  by 1.0 to have nil effect)
	xbox = 1.0
	ybox = 1.0
	zbox = 1.0
	tbox = 1.0
	ebox = 1.0
	fbox = 1.0

* LOOP OVER THE FULL RANGE OF THE RESULT
* ... also set up loop indices for non-transformed axes
*     (component loop to include only the single result point on "no" axes)
	DO 300 nr = cx_lo_s6(res_cx), cx_hi_s6(res_cx)
	IF (no_fax) THEN
	   n_lo = nr
	   n_hi = nr
	ENDIF
	DO 300 mr = cx_lo_s5(res_cx), cx_hi_s5(res_cx)
	IF (no_eax) THEN
	   m_lo = mr
	   m_hi = mr
	ENDIF
	DO 300 lr = cx_lo_s4(res_cx), cx_hi_s4(res_cx)
	IF (no_tax) THEN
	   l_lo = lr
	   l_hi = lr
	ENDIF
	DO 300 kr = cx_lo_s3(res_cx), cx_hi_s3(res_cx)
	IF (no_zax) THEN
	  k_lo = kr
	  k_hi = kr
	ENDIF
	DO 300 jr = cx_lo_s2(res_cx), cx_hi_s2(res_cx)
	IF (no_yax) THEN
	  j_lo = jr
	  j_hi = jr
	ENDIF
	DO 300 ir = cx_lo_s1(res_cx), cx_hi_s1(res_cx)
	IF (no_xax) THEN
	  i_lo = ir
	  i_hi = ir
	ENDIF

* pathological case: world coordinate range of zero along an xform axis

          IF ( point ) THEN    ! 8/92
            nc = n_lo
            mc = m_lo
            lc = l_lo
            kc = k_lo
            jc = j_lo
            ic = i_lo

	    IF (at_din .AND. com(ic,jc,kc,lc,mc,nc) .NE. bad_com) 
     .        res(ir,jr,kr,lr,mr,nr) = 0.0
            GOTO 300
          ENDIF

* initialize the inner loop accumulators
	  IF (its_var_or_std) THEN
* ... initializations were done from IS_TRANS
* ... start from the last accumulated value to support split/gather
	    wsum_chunk = weights(ir,jr,kr,lr,mr,nr)
	    mean_chunk = res    (ir,jr,kr,lr,mr,nr)
	    s_chunk    = s_var  (ir,jr,kr,lr,mr,nr)
	  ELSE
	    dsum = 0.0D0	! data
	    bsum = 0.0D0	! boxes
	    ok	 = 0.0D0	! count valid
	    ngd  = 0
	    nbd  = 0
	  ENDIF

* now loop over the component data accumulating results along relevant axes
* ... two separate loops for efficiency, only -- keep @ngd and @nbd fast


	  IF (short_comp) THEN

	    DO 210 nc = n_lo, n_hi
	    DO 210 mc = m_lo, m_hi
	    DO 210 lc = l_lo, l_hi
	    DO 210 kc = k_lo, k_hi
	    DO 210 jc = j_lo, j_hi
	    DO 210 ic = i_lo, i_hi

	      IF ( com(ic,jc,kc,lc,mc,nc) .EQ. bad_com ) THEN
	        nbd = nbd + 1
	      ELSE
	        ngd = ngd + 1
	        IF (at_sum) THEN
	           dsum = dsum + com(ic,jc,kc,lc,mc,nc)
	           ok = ok + 1
	        ENDIF
	      ENDIF

 210	    CONTINUE

	  ELSE

	    DO 220 nc = n_lo, n_hi
	    IF (yes_fax) fbox = boxes(nc+noffset)
	    DO 220 mc = m_lo, m_hi
	    IF (yes_eax) ebox = boxes(mc+moffset)
	    DO 220 lc = l_lo, l_hi
	    IF (yes_tax) tbox = boxes(lc+loffset)
	    DO 220 kc = k_lo, k_hi
	    IF (yes_zax) zbox = boxes(kc+koffset)
	    DO 220 jc = j_lo, j_hi
	    IF (yes_yax) ybox = boxes(jc+joffset)
	    DO 220 ic = i_lo, i_hi
	    IF (yes_xax) xbox = boxes(ic+ioffset)

	      IF ( com(ic,jc,kc,lc,mc,nc) .NE. bad_com ) THEN
	        box = xbox * ybox * zbox * tbox * ebox * fbox
	        IF (need_cos) box = box * boxes(jc+cos_offset)
	      	IF (its_var_or_std) THEN
	          v = com(ic,jc,kc,lc,mc,nc)
	          w = box
	          wsum_chunk = wsum_chunk + w
	          mean_old = mean_chunk
	          mean_chunk = mean_old + (w/wsum_chunk)*(v-mean_old)
	          s_chunk = s_chunk + w * (v-mean_old)*(v-mean_chunk)
	        ELSE
	          bsum = bsum + box
	          dsum = dsum + box*com(ic,jc,kc,lc,mc,nc)
	        ENDIF
	      ENDIF

 220	    CONTINUE

	  ENDIF

* *sh* 11/16 -- accumulate values, only in this routine.  Finalize elsewhere
* acm notes: 
*   o at_ngd and at_nbd, add the current result to res(ir,jr,... )?  
*   o If bsum EQ 0, do not set the accumulating result to bad_res as
*     we did in the non-scatter and finalize code.  The weights take 
*     care of knowing if any good data was found.

	  IF (at_ngd) THEN
	     res(ir,jr,kr,lr,mr,nr) = ngd  
	  ELSEIF (at_nbd) THEN
	     res(ir,jr,kr,lr,mr,nr) = nbd  
	  ELSEIF (at_sum .AND. ngd.GT.0) THEN
	     res(ir,jr,kr,lr,mr,nr) = dsum
	     weights(ir,jr,kr,lr,mr,nr) = weights(ir,jr,kr,lr,mr,nr) + ok ! weights are #valid
	  ELSEIF (its_ave_or_din) THEN
	      res    (ir,jr,kr,lr,mr,nr) = res    (ir,jr,kr,lr,mr,nr) + dsum
	      weights(ir,jr,kr,lr,mr,nr) = weights(ir,jr,kr,lr,mr,nr) + bsum
	  ELSEIF (its_var_or_std) THEN
	    res    (ir,jr,kr,lr,mr,nr) = mean_chunk
	    weights(ir,jr,kr,lr,mr,nr) = wsum_chunk
	    s_var  (ir,jr,kr,lr,mr,nr) = s_chunk
	  
	     CONTINUE
	  ENDIF

 300	CONTINUE

	RETURN

	END

	LOGICAL FUNCTION OK_AS_AGG_VAR( var1, cat1, dset1, memb_list,
     .		             nsets, agg_dim, quiet, ref_fvar, status )
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* determine if a candidate variable from the fist datset of an aggregation
* is found and has a suitable grid in all other members of the aggregation
* make sure the grid of all member variables is known -- even LET/D vars
* at least one member must have a file variable of this name -- the ref_fvar

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - TMAP 
*
* V698 12/15 *sh* extracted from init_ef_aggregate_dset.F
* V698  4/16 *sh* already used agg axis ok as long as scalar span (typ "@ave")
* V710 *acm* 10/16 Ticket 2422: variables uvar_grid, uvar_data_type, uvar_aux_cat, 
*                  uvar_aux_var to be replaced with calls to LIST routines in NCF_Util.c 

* arguments:
* inputs:
*	var1	  - variable number of the candidate var from dset 1
*	cat1	  - category (uvar or file) of the candidate var from dset 1
*	dset1	  - the dataset number of the 1st member
*	memb_list - list of member datasets
*	nsets	  - number of datasets in the aggregation
*	agg_dim	  - axis of aggregation
*	quiet	  - flag whether to announce unacceptable variables
* outputs
*	ref_fvar  - the first member file variable with an acceptable grid
*	status	  - return status

      IMPLICIT NONE
	include 'netcdf.inc'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xdset_info.cmn_text'
	include 'xdset_info.cd_equiv'
	include 'xunits.cmn_text'
	include 'xtm_grid.cmn_text'  
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xfr_grid.cmn'
	include 'xtext_info.cmn'

* calling argument declarations:
	LOGICAL quiet
	INTEGER	var1, cat1, dset1, nsets, memb_list(nsets), agg_dim,
     .		ref_fvar,status

* local variable declarations:
	LOGICAL SCALAR_GRID_LINE, found_name
	INTEGER iset, member, j, iv, var, cat, grid, ref_grid, idim, 
     .		vlen, nuvars
	CHARACTER vname*128
	INTEGER	STR_SAME, TM_LENSTR1, KNOWN_GRID

* initialize
	status = ferr_ok
	ref_fvar = unspecified_int4

* the name of the candidate variable
	IF (cat1 .EQ. cat_file_var) THEN
	   vname = ds_var_code(var1)
	ELSE
	   vname = uvar_name_code(var1)
	ENDIF 
	vlen = TM_LENSTR1(vname)

* is the candidate variable suitable as the reference fvar?
	IF (cat1 .EQ. cat_file_var) THEN
	   grid = ds_grid_number(var1)
	   IF (.NOT.SCALAR_GRID_LINE(agg_dim,grid,cat1,var1)) GOTO 5400
	   IF ( (agg_dim.EQ.f_dim .AND. grid_line(t_dim,grid).NE.mnormal) 
     .	  .OR.  (agg_dim.EQ.e_dim) )          THEN
	      ref_fvar = var1
	      ref_grid = ds_grid_number(ref_fvar)
	   ENDIF
	ELSE
* ... no but make sure we know its grid
	   CALL GET_UVAR_GRID( var1, dset1, status )
           IF ( status .NE. ferr_ok ) GOTO 5500
           grid = KNOWN_GRID(dset1,cat_user_var,var1)
	ENDIF 

* *** loop over the member datasets ***
	DO iset = 2, nsets
	   member = memb_list(iset)
	   IF (member .EQ. pdset_dummy) CYCLE ! ignore dummy (missing) dataset
	   found_name = .FALSE.

	   CALL FIND_VAR_NAME (member,vname(:vlen), cat, var )
	   IF (var .EQ. munknown_var_name) GOTO 5100
	   IF (cat .EQ. cat_user_var) THEN
	      IF (uvar_dset(var).EQ. unspecified_int4) THEN
	         GOTO 5600
	      ELSEIF (uvar_dset(var).NE. member) THEN
	         GOTO 5100
	      ENDIF
* make sure the grid of this member LET/D variable is known
	      CALL GET_UVAR_GRID( var, member, status )
              IF ( status .NE. ferr_ok ) GOTO 5500
              grid = KNOWN_GRID(member,cat_user_var,var)
	   ENDIF


* "reference fvar" -- the first file var encountered with an acceptable grid
	   IF ( ref_fvar.EQ.unspecified_int4
     .	  .AND. cat .EQ. cat_file_var          ) THEN
	      grid = ds_grid_number(var)
	      IF (.NOT.SCALAR_GRID_LINE(agg_dim,grid,cat,var) ) GOTO 5400
	      IF ( (agg_dim.EQ.f_dim.AND.grid_line(t_dim,grid).NE.mnormal) 
     .	     .OR.  (agg_dim.EQ.e_dim) ) THEN
	         ref_fvar = var
	         ref_grid = ds_grid_number(ref_fvar)
	      ENDIF
	   ENDIF

* now check grid compatibility
	   IF (ref_fvar .EQ. unspecified_int4) THEN
	      GOTO 5000
	   ELSE
	      IF (cat .EQ. cat_user_var) THEN
	         CALL GET_SAVED_UVAR_GRID(var, member, grid)
	      ELSE			! cat_file, cat_agg_e, or cat_agg_f
	         grid = ds_grid_number(var)
	      ENDIF
* ... check that the grid of this variable conforms with the reference grid
! 4/16	      IF (grid_line(agg_dim, grid) .NE. mnormal) GOTO 5400
	      IF (.NOT.SCALAR_GRID_LINE(agg_dim,grid,cat,var)) GOTO 5400
	      DO idim = 1, nferdims
	         IF (idim .EQ.agg_dim) CYCLE  ! already checked
	         IF (agg_dim.EQ.f_dim .AND. idim.EQ.t_dim) CYCLE
* ... conformable for axes with more than 1 pt means same axis in both grids
*     but all single point axes, including normal axes are conformable
	         IF (SCALAR_GRID_LINE(idim,ref_grid,cat_file_var,ref_fvar))
     .									THEN
	            IF (.NOT.SCALAR_GRID_LINE(idim,grid,cat,var)) GOTO 5200
	         ELSE
		    IF ( grid_line(idim, ref_grid) .NE.  
     .                   grid_line(idim, grid)         ) GOTO 5200
	         ENDIF
	      ENDDO
	   ENDIF
	ENDDO

* success
	OK_AS_AGG_VAR = .TRUE.
	RETURN

* failure conditions
 5000	OK_AS_AGG_VAR = .FALSE.
	RETURN
 5100	IF ( .NOT.quiet ) 
     .	         CALL WARN('Variable "'//vname(:vlen)//
     .		 '" excluded from aggregate: '//
     .	         'Not found in all member datasets')
	GOTO 5000

 5200	IF ( .NOT.quiet ) 
     .	         CALL WARN('Variable "'//vname(:vlen)//
     .		 '" excluded from aggregate: '//
     .	         ww_dim_name(idim)//' axis differs among members')
	GOTO 5000

 5400	IF ( .NOT.quiet ) 
     .	         CALL WARN('Variable "'//vname(:vlen)//
     .		 '" excluded from aggregate: '//
     .		'Already has '//ww_dim_name(agg_dim)//' axis')
	GOTO 5000

 5500   CALL ERRMSG( ferr_aggregate_error, status,
     .          'Could not get grid for user-defined variables '// 
     .		vname(:vlen), *5000 )

 5600   CALL ERRMSG( ferr_aggregate_error, status,
     .          'Conflicting global LET definition for '// 
     .		vname(:vlen), *5000 )


	END

        CHARACTER*8 FUNCTION EXPR_NAME( n )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE.
*
*
* create a unique name for a user-defined variable
* "expr#1","expr#2",..."expr#9","expr#:","expr#,",etc. from ASCII table

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 2/23/87
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *kms* 7/18 revise method for generating the name to just use numbers;
*                  original method gives lowercase characters ('a' at n=49)
*                  that match earlier uppercase characters ('A' at n=17),
*                  and would blow up if n exceeds 207.

        IMPLICIT NONE
        INTEGER n, k
        CHARACTER*8 namecode

! original method:
!        EXPR_NAME = 'EX#'//CHAR(48+n)

        IF ( n .LT. 0 ) THEN
            STOP 'EXPR_NAME: unsupported request ' //
     .           'for name code with n < 0'
        ELSEIF ( n .LT. 10 ) THEN
  10        FORMAT('EX#',I1)
            WRITE(namecode, 10) n
        ELSEIF ( n .LT. 100 ) THEN
  20        FORMAT('EX#',I2)
            WRITE(namecode, 20) n
        ELSEIF ( n .LT. 1000 ) THEN
  30        FORMAT('EX#',I3)
            WRITE(namecode, 30) n
        ELSEIF ( n .LT. 10000 ) THEN
  40        FORMAT('EX#',I4)
            WRITE(namecode, 40) n
        ELSEIF ( n .LT. 100000 ) THEN
  50        FORMAT('EX#',I5)
            WRITE(namecode, 50) n
        ELSE
            STOP 'EXPR_NAME: unsupported request ' //
     .           'for name code with n > 99999'
        ENDIF

        EXPR_NAME = namecode

        RETURN
        END

	SUBROUTINE PSEUDO_VAR_CONTEXT
     .		      ( full_pvar_name, 
     .			dflt_cx,
     .			pvar_cx,
     .			pvdim,
     .			status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* given a pseudo-variable
* return in pvar_cx context information describing the exact instance
* including grid and region

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/2/87
* revision 0.1 - 5/5/88  - FINISH_CONTEXT_MODS --> FLESH_OUT_CONTEXT
*			   added CONFINE_CONTEXT
* V200: 6/26/89
* V420: 9/27/95 - allow implicit grids underlying pseudo-var
*	10/95	- allow implicit axes like i[i=1:10:2]
*	11/95   - code to deal with T[T=date:date:delta]
* 
* kob  8/25/97 - use newly created cx_calender to check whether time is a date or time_step
* V500: 2/22/99 *sh* - if ABSTRACT grid or normal axis then use XABSTRACT (or
*			YABSTRACT, ZABSTRACT, TABSTRACT)
*		       see Note at "the_real-ABSTRACT"
* V510: 8/99 *sh* - for g=user_var the returned grid is LT unspecified_int4
*		... having the text position of uvar encoded in it
*		... exit out earliy in this case
*	12/99 *sh* - for formatted lat or lon (e.g. Y[y=0:20n:2]), set units
*	 4/00 *sh* - all grids and axes now maintain use counts
* V530:  8/00 *sh* - assert float data type for pseudo-variable
* 1/03 - *kob* g77 port - Need to use risc_buff for arbitrary concatenations
* V581*acm*  6/05 - For fix to bug 1271, add flag line_shift_origin
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
*       *acm* 4/12 Add new MODE FOURDEE to allow E,F,M,N,etc as user-vars
* V695  *acm* 2/15 cx_calendar stores info about calendar formatting of T and F axes
* V720  *acm* 2/17 ticket 2511 Dynamic grids on user-defined variables

	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include 'tmap_dims.parm'
	include	'xcontext.cmn'
	include	'xalgebra.cmn'
	include	'xfr_grid.cmn'
	include	'xprog_state.cmn'
	include 'xrisc.cmn'
	include 'tmap_errors.parm'
	include 'xunits.cmn_text'
	include 'implicit.parm'
	include 'xtm_grid.cmn_text'

* calling argument declarations:
	INTEGER		dflt_cx, pvar_cx, pvdim, status
	CHARACTER*(*)	full_pvar_name

* internal variable declarations:
	LOGICAL		its_dyn, has_impl_axis, calendar, alloed_tmp
	INTEGER		CGRID_AXIS, mods_cx, idim, pvax, base_grid,
     .			impl_grid, like, tmp, the_real_ABSTRACT

* internal parameter declarations
	REAL*8		daysinsecs
	PARAMETER     ( daysinsecs = 60.*60.*24.)

* initialize fixed length string for RISC
        risc_buff = full_pvar_name
        len_rbuff = MIN( size_rbuff, LEN(full_pvar_name) )
* ... Note: the variable mgrid_abstract gets changed by SET GRID, so here
*     we use an ugly hack to capture the grid that is actually named "ABSTRACT"
	the_real_ABSTRACT = mgrid_xabstract - 2

* use default context as a starting point
	CALL TRANSFER_CONTEXT ( dflt_cx, pvar_cx )

* find a context slot for the modifications that may be attached to the var name
	CALL STACK_PTR_UP ( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	mods_cx = cx_stack_ptr
	CALL INIT_CONTEXT_MODS ( mods_cx )

* get variable and attached modifications
	CALL PARSE_VAR_NAME ( full_pvar_name, pvar_cx, mods_cx, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	cx_type( pvar_cx ) = ptype_float 

* axis of pseudo_var

	pvdim = MOD( cx_variable(pvar_cx)-1, 6 ) + 1

* temporary bug check: may not transform pseudo-variable
	IF ( cx_trans(pvdim,pvar_cx) .NE. trans_no_transform ) CALL ERRMSG
     .		( ferr_syntax, status,
     .		'cannot transform pseudo-variables: '//
     .		 risc_buff(:len_rbuff)//pCR//
     .		'use DEFINE VARIABLE (e.g. DEF VAR ii=i) and transform that', 
     .								*5000 )

* pseudo var may not depend on any data set
	IF ( .NOT.(cx_dset_gvn(mods_cx) .OR. cx_grid_needs_dset) ) THEN
	   cx_data_set(pvar_cx) = pdset_irrelevant
	ENDIF

* bug check
	IF ( cx_category(pvar_cx) .NE. cat_pseudo_var ) CALL ERRMSG
     .			( ferr_internal, status, 'pseud_v', *5000 )

* implicit axis of the form I[I=1:10:2] used?
	has_impl_axis = cx_delta(pvdim,pvar_cx) .NE. unspecified_val8
	IF ( has_impl_axis ) THEN

* ... make sure the specified delta makes sense
	   IF ( cx_delta(pvdim,pvar_cx) .LE. 0.0D0 ) GOTO 5200

* ... need a temporary grid to hold the axes so make it if we don't have one
	   IF ( .NOT.cx_has_impl_grid(pvar_cx) ) THEN
	      CALL ALLO_GRID_TO_CX( pvar_cx, impl_grid, status )
	      IF (status .NE. ferr_ok) GOTO 5000
	   ENDIF
	ENDIF

* process implicit (dynamic) grids (9/95)
* complete the implicit grid definition from the pieces provided
* There is no reason that we **have to** retain any axes other than the
* needed one but it reduces the proliferation of distinct grids if we do
	IF ( cx_has_impl_grid(pvar_cx) ) THEN
* ... build the grid
*     Note: there is an (imperfect) subtlety in the selection of "base_grid"
*	In an expression like "temp+x" the pseudo-variable inherits its axis
*	from the variable "temp".  So in an expression like
*	"temp[x=lo:hi:del]+X[x=lo:hi:del]" presumably the same would be true.
*	This would require that base_grid was inherited --> pulled from 
*	cx_grid(pvar_cx).  However, the inheritance only occurs after an
*	initial pass through this routine where cx_grid(pvar_cx) is unknown.
*	This means that the inherited base_grid based could vary from pass
*	to pass -- leading to, say, the delta value 2 in X[x=lo:hi:2] being
*	applied first to ABSTRACT and then to itself -- leading to a delta of
*	4 and probably a crash.  This is side-stepped by using cx_grid(mods_cx)
*	but with the result that the grid is not inherited.  To  work around
*	the user must use "temp[x=lo:hi:del]+X[g=temp,x=lo:hi:del]"

*   ticket 2511: the grid number may be a large negative number due to the hack 
*   in get_context_mods.F which encodes the start/end limits of the uvar name 
*   into the grid. When that is the case we do not want to use that as base_grid.

	   IF ( cx_grid(mods_cx) .GT. unspecified_int4 ) THEN
	      base_grid = cx_grid(mods_cx)
	   ELSE
! 2/22/99 addition
	      IF (mgrid_abstract .EQ. the_real_ABSTRACT) THEN
	         base_grid = mgrid_xabstract + pvdim - 1
	      ELSE
		 base_grid = mgrid_abstract
	      ENDIF
	   ENDIF
	   impl_grid = cx_impl_grid(pvar_cx)
	   DO 50 idim = 1, nferdims
	      IF ( grid_line(idim,impl_grid).EQ.unspecified_int4 )
     .		   grid_line(idim,impl_grid) = grid_line(idim,base_grid)
 50	   CONTINUE
	ENDIF

* if a dynamic axis was requested create it with the named grid or axis
* as a template and insert it into the dynamic grid 
	IF ( has_impl_axis ) THEN
* ... make the implicit axis and save it in the implicit grid
	   like = grid_line(pvdim,impl_grid)
	   IF ( cx_by_ss(pvdim,pvar_cx) ) THEN
	      CALL TM_GET_LIKE_DYN_LINE( pvdim,
     .					 DBLE(cx_lo_ss(pvar_cx,pvdim)),
     .					 DBLE(cx_hi_ss(pvar_cx,pvdim)),
     .					 cx_delta(pvdim,pvar_cx),
     .					 like,
     .					 pline_class_stride,
     .					 grid_line(pvdim,impl_grid),
     .					 status)
	      cx_lo_ss(pvar_cx,pvdim) = 1
	      cx_hi_ss(pvar_cx,pvdim) = line_dim(grid_line(pvdim,impl_grid))
	   ELSE
* ... special processing for calendar pseudo-variables and lat/long formatting
* *kob* 8/97 check cx_calendar rather then cx_lo_ww
	      calendar = (pvdim.EQ.t_dim .OR. pvdim.EQ.f_dim) .AND. 
     .		 cx_calendar(pvdim,pvar_cx)
	      alloed_tmp = .FALSE.	! assume no dyn axis allocated
	      IF ( calendar ) THEN
* ... note: a minor misbehavior:  for the pseudo-variable
* 	"T[g=temp,t=[t=1-jan-1982:1-jan-1983:24]" it would be nice to inherit
*	line_t0, etc. from g=temp.  The current method does not. (11/95)
	         cx_lo_ww(pvdim,pvar_cx) = cx_lo_ww(pvdim,pvar_cx)
     .					/(-1 * daysinsecs)	! days since BC
	         cx_hi_ww(pvdim,pvar_cx) = cx_hi_ww(pvdim,pvar_cx)
     .					/(-1 * daysinsecs)	! days since BC
* *kob* 9/997 - reset cx_calendar after conversion
		 cx_calendar(pvdim,pvar_cx) = .FALSE.
	         cx_delta(pvdim,pvar_cx) = cx_delta(pvdim,pvar_cx)/24.
	         CALL TM_ALLO_DYN_LINE( tmp, status )
	         IF ( status .NE. ferr_ok ) GOTO 5000
	         alloed_tmp = .TRUE.
	         CALL TM_COPY_LINE( like, tmp )
	         line_t0(tmp) = '1-JAN-0000'
	         line_shift_origin(tmp) = .FALSE.
	         line_units(tmp) = 'DAYS'
	         line_unit_code(tmp) = -4			! days
	         line_tunit(tmp) = daysinsecs
	         line_direction(tmp) = 'TI'
	         like = tmp
	      ELSEIF ( cx_formatted(pvdim) 
     .		.AND. (pvdim.EQ.x_dim .OR. pvdim.EQ.y_dim) ) THEN
	         CALL TM_ALLO_DYN_LINE( tmp, status )
	         IF ( status .NE. ferr_ok ) GOTO 5000
	         alloed_tmp = .TRUE.
	         CALL TM_COPY_LINE( like, tmp )
	         line_unit_code(tmp) = pun_degrees
	         IF ( pvdim .EQ. x_dim ) THEN
		    line_units(tmp) = 'DEGREES_EAST'
	            line_direction(tmp) = 'WE'
	         ELSEIF ( pvdim .EQ. y_dim) THEN
		    line_units(tmp) = 'DEGREES_NORTH'
	            line_direction(tmp) = 'SN'
	         ENDIF
	         like = tmp
	      ENDIF
	      CALL TM_GET_LIKE_DYN_LINE( pvdim,
     .					 cx_lo_ww(pvdim,pvar_cx),
     .					 cx_hi_ww(pvdim,pvar_cx),
     .					 cx_delta(pvdim,pvar_cx),
     .					 like,
     .					 pline_class_basic,
     .					 grid_line(pvdim,impl_grid),
     .					 status)
	      IF ( alloed_tmp ) THEN
	         CALL TM_DEALLO_DYN_LINE( tmp )
	      ENDIF
	   ENDIF
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   cx_delta(pvdim,pvar_cx) =  unspecified_val8
	ENDIF

	IF ( cx_has_impl_grid(pvar_cx) ) THEN
* increment the use count of dynamic axes that are in-use by the temporary grid
	   DO 25 idim = 1, nferdims
 25	   CALL TM_USE_LINE(grid_line(idim,impl_grid))

* catalog the temporary grid as a dynamic grid checking for existing like grid
* ... catalog it or reuse a previously cataloged version
	   CALL TM_GET_LIKE_DYN_GRID(impl_grid,its_dyn,
     .				cx_grid(pvar_cx),grd_stk_ptr,status)
	   IF (status .NE. merr_ok) GOTO 5000
	   IF ( its_dyn ) THEN
	      IF ( mode_diagnostic )  CALL DIAG_OP
     .	     ('allocate', isact_class_impl_grid, cx_grid(pvar_cx), 0)
	   ELSE
	      cx_has_impl_grid(pvar_cx) = .FALSE.
	   ENDIF

* ... deallocate the (now unnecessary) implicit stack-based grid
#ifdef debug_dyn_grids
	   IF ( mode_diagnostic )  CALL DIAG_OP
     .	  ('dealloc ', isact_class_impl_grid, impl_grid, 0)
#endif
	   CALL DEALLO_GRID(status)

* the dynamic (managed) grid has now replaced the temporary (stack) grid
	   impl_grid = cx_grid(pvar_cx)

	ENDIF

* unknown grid for pseudo-variable is OK when program is determining grid
* for an algebraic expression but not OK when it's time to evaluate the expr.
	IF ( cx_grid(pvar_cx) .LE. unspecified_int4 ) GOTO 500	! 8/99

* if the grid is ABSTRACT change it to X/Y/Z/TABSTRACT so other axes than
* pvdim are not effected (2/22/99)
	IF ( cx_grid(pvar_cx) .EQ. the_real_ABSTRACT )
     .		 cx_grid(pvar_cx) = mgrid_xabstract + pvdim - 1

* does the grid have a suitable axis for the pseudo-variable ?
	pvax = CGRID_AXIS( pvdim, pvar_cx )
	IF ( pvax.EQ.mnormal ) THEN
	   cx_grid(pvar_cx) = mgrid_xabstract + pvdim - 1  ! 2/22/99
	ELSEIF (pvax.EQ. munknown ) THEN
	   GOTO 5100
	ENDIF

* insert bad data flag for variable
	CALL GET_CONTEXT_BAD_FLAG( pvar_cx )

* flesh out context removing all axes except those explicitly given
	DO 100 idim = 1, nferdims
	   IF ( idim .NE. pvdim ) THEN
	      CALL DEL_CX_DIM( idim, pvar_cx )
	   ELSE
	      CALL CONFINE_AXIS  ( idim, pvar_cx, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
	      CALL FLESH_OUT_AXIS( idim, pvar_cx, status ) 	! ignore status
	   ENDIF
 100	CONTINUE

* relinquish the stack space used for the modifications
 500	CALL STACK_PTR_DN ( cx_stack_ptr, cx_stack_ptr_base, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	RETURN

* error exit
 5000	RETURN
 5100	IF (cx_has_impl_grid(pvar_cx)) CALL TM_DEALLO_DYN_GRID(impl_grid)
	CALL ERRMSG( ferr_inconsist_grid, status, full_pvar_name, *5000 )
* 1/03 *kob* g77 port requires risc buff for arbitrary string concats
 5200	risc_buff = full_pvar_name
	CALL ERRMSG( ferr_invalid_command, status, 
     .	'non-positive delta value: '//risc_buff, *5000 )
	END

	INTEGER FUNCTION ENSEMBLE_MEMBER_DSET ( agg_dset, imemb )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* return the dset number of ensemble member imemb
* note:  as currently implemented an aggregated dataset knows who its member
*        variable are, and each member variable knows who its member datasets
*        are.  So the only way to learn the dataset number of a member is to
*        access it through a member variable.  This routine follows that path.

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*

* calling arguments
*  agg_dset -- dataset number of the aggregation
*  imemb    -- member number 1, 2, 3, ...


* V690 *sh*

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xcontext.cmn'
	include 'xtext_info.cmn'
	include 'xdset_info.cmn_text'
	include 'xtm_grid.cmn_text'

* calling argument declarations
	INTEGER agg_dset, imemb	

* local variable declarations:
	INTEGER TM_LENSTR1
	INTEGER ivar, grid, vlen, memb_dset
	INTEGER orig_cat, orig_grid, iline, orig_var, status


* find a variable that belongs to this dataset and has an E axis
! very inefficient loop:  needs to be fixed
	DO ivar = 1, maxvars
	   IF (ds_var_setnum(ivar).EQ.agg_dset) THEN
	      grid = ds_grid_number(ivar)
	      IF (grid_line(e_dim,grid) .NE. mnormal) GOTO 100
	   ENDIF
	ENDDO
* ... no variable found (should never happen)
	ENSEMBLE_MEMBER_DSET = pdset_irrelevant ! may avoid a crash sometime?
	RETURN 

* get the dataset number associated with this variable
 100	vlen = TM_LENSTR1( ds_var_code(ivar) )
	CALL CD_GET_AGG_VAR_INFO (agg_dset, ds_var_code(ivar)(:vlen), imemb, 
     .        orig_cat, memb_dset, orig_grid, iline, orig_var, status)
	ENSEMBLE_MEMBER_DSET = memb_dset
	RETURN
	END

	SUBROUTINE PPL_AXES_OFF(set_up)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* turn off the PLOT+ axes with the AXSET command but save the current
* state so the axes can be restored

* V450:  
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

        IMPLICIT NONE
	include 'plot_setup.parm'
	include 'xcontrol.cmn'
	include 'axis_inc.decl'
	include 'AXIS.INC'		! variable iaxon

* calling argument declarations
	LOGICAL set_up

* local variable declarations:
	INTEGER i
	CHARACTER buff*16

* static storage in COMMON
	INTEGER save_iaxon(4)
	COMMON /XAXIS_STATE/ save_iaxon

* save current axis state
	DO 10 i = 1, 4
 10	save_iaxon(i) = iaxon(i)

* turn all 4 axes off
	CALL PPLCMD ( from, line, 0, 'AXSET 0,0,0,0', 1, 1 )

* turn axis labels off
	CALL PPLCMD ( from, line, 0, 'XLAB', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'YLAB', 1, 1 )

* if in /set_up mode this state will not be restored properly
* issue warning only if user typed in command (csp.eq.0)
	IF ( set_up .AND. csp.EQ.0 ) THEN
	   buff = ' '
	   WRITE (buff, '(4I3)' ) (save_iaxon(i), i=1, 4)
	   CALL WARN(
     .		'To restore axes after /SET_UP/NOAXES use PPL AXSET'
     .		//buff(:12) )
	ENDIF

	RETURN
	END

	SUBROUTINE GCF_GET_ARG_PARMS
     .			(gcfcn, iarg, lo_off,  hi_off, implied_lims)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Return parameters about the grid changing function, gcfcn, on how the
* limits of the argument, iarg, should be determined relative to the
* default limits of the grid changing variable

* For example, in
*	LET a = GCFCN( b )
*	LIST a[i=1:5]
* we need to know if the limits i=1:5 should be passed along to b and if they
* should be increased or decreased by offsets supplied by the function.

* V450: 1/97
*       97.07.16 *jc* adding code to query external functions
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)


        IMPLICIT NONE
	include 'tmap_dims.parm'
        include 'xtm_grid.cmn_text'
	include 'ferret.parm'
	include 'xgrid_chg_fcns.cmn'

* calling argument declarations
	LOGICAL	implied_lims(nferdims)
	INTEGER	gcfcn, iarg, lo_off(nferdims),  hi_off(nferdims)

* internal variable declarations
	INTEGER	idim, iptr, ip

* check the internal grid changing functions first
        IF (gcfcn .LT. 0 ) THEN

           STOP 'gcf_get_arg_parms'

        ELSEIF (gcfcn .LE. gfcn_num_internal) THEN

* is this a valid argument number?
	   IF (iarg .LT. 1
     .    .OR. iarg .GT. gfcn_num_reqd_args(gcfcn) )
     .					STOP 'gcf_cx_merge_arg_1'

* determine location of information in argument arrays
	   iptr = gfcn_arg_ptr(gcfcn) + iarg - 1

* return information about argument iarg

	   DO 100 idim = 1, nferdims

	      lo_off(idim) = gfcn_arg_extend_lo(idim, iptr)
	      hi_off(idim) = gfcn_arg_extend_hi(idim, iptr)
	      implied_lims(idim) = gfcn_axis_implied_from(idim, iptr)
 100	   CONTINUE

	ELSE

	   call efcn_get_axis_extend_lo(gcfcn, iarg, lo_off)
	   call efcn_get_axis_extend_hi(gcfcn, iarg, hi_off)
	   call efcn_get_axis_implied_from(gcfcn, iarg, implied_lims)

	ENDIF

	RETURN
	END

	SUBROUTINE RESTRICT_FILE_LIMITS ( cx, modified, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* restrict the context limits of a file variable to the range that is
* indicated by ds_grid_start/end in COMMON

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V500: 3/99 - *sh*
*       5/99 *sh* - when strides are used on a netCDF variable, we may be
*		looking at an implicit grid. In this case VAR_SS_LIMS returns
*		unspecified_int4.
*		NOTE: possible bug introduced with strides since the region
*			checks here are bypassed altogether
* V530: 11/00 *sh* - return "modified" flag
* V552 *acm* 4/03- up VAR_CODE decl from 64 to 128 chars
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'

	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include	'xtext_info.cmn'

* calling argument declarations:
	LOGICAL	modified
	INTEGER	cx, status

* internal variable declarations:
	INTEGER 	TM_LENSTR1, 
     .			idim, variable, category,
     .			slen, slen2, hilim, lolim
	CHARACTER*128	VAR_CODE, variable_code
	CHARACTER	LEFINT*5, CX_DIM_STR*48, buff1*48, buff2*5

* local parameter declarations
	LOGICAL     full_precision
	PARAMETER ( full_precision = .TRUE. )

* --- end of introductory code ---

* initialize
	modified = .FALSE.
	category = cx_category( cx )
	variable = cx_variable( cx )

	DO 10 idim = 1, nferdims
	   IF ( cx_lo_ss(cx,idim) .EQ. unspecified_int4 ) GOTO 10
	   CALL VAR_SS_LIMS( idim, cx, lolim, hilim )
	   IF ( lolim .EQ. unspecified_int4 ) GOTO 10
	   IF ( cx_lo_ss(cx,idim) .GT. hilim .OR.
     .          cx_hi_ss(cx,idim) .LT. lolim )
     .		GOTO 5100
	   IF ( (cx_lo_ss(cx,idim) .LT. lolim)
     .     .OR. (cx_hi_ss(cx,idim) .GT. hilim) ) THEN
	      IF (cx_lo_ss(cx,idim).LT.lolim) cx_lo_ss(cx,idim) = lolim
	      IF (cx_hi_ss(cx,idim).GT.hilim) cx_hi_ss(cx,idim) = hilim
	      cx_by_ss(idim, cx) = .TRUE.
	      CALL FLESH_OUT_AXIS( idim, cx, status )
	      IF ( status.NE.ferr_ok ) GOTO 5900
	      modified = .TRUE.
	   ENDIF
 10	CONTINUE

* successful completion
	status = ferr_ok
	RETURN

* error exit
 5100	buff1 = CX_DIM_STR(idim, cx, ':',full_precision,slen)
	WRITE(buff2,'(I5)') lolim
	variable_code = VAR_CODE( category, variable )
	CALL ERRMSG( ferr_limits, status,
     .		variable_code(:TM_LENSTR1(variable_code))//
     .		' does not contain '//buff1(:slen)//
     .          pCR//'Data are available in '//ss_dim_name(idim)//
     .		' ='//buff2//':'//LEFINT(hilim, slen2)
     .		,*5900 )   ! 3/99
 5900	RETURN
	END	

	SUBROUTINE EZ_READ ( dset, nread, ncol, columns, buff, status,
     .	                      d0, d1, d2, d3, d4,
     .	                      d5, d6, d7, d8, d9,
     .	                      d10,d11,d12,d13,d14,
     .	                      d15,d16,d17,d18,d19  )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* 
* Subroutine uses the COMMON info for the initalized EZ data set (ASCII and
* unformatted non_TMAP data files) to read in the entire data file and transfer 
* it to the variable arrays d0 .. d19.
*
* revision 0.00 - 08/04/89
* revision 1.00 - 08/15/89 - Will initialize XDSET/XSTEP common variables as
*			     necessary (first time, and if dset_mod is set)
* revision 1.10 - 10/24/89 - *sh* eliminated EZ_UPDATE_COMMON call
*			     added multi-column reads of same variable
* revision 1.20 - 02/27/90 - Improved read error message by including record #
* RISC/Unix port *sh* 1/91 - syntax changes to accomodate DEC RISC compiler
*                     5/91 - corrected bug sf_valid(dset) --> sf_valid(sfcnt)
* 3/12/93 *sh* : made "buff" into an argument in the call
* IBM/AIX Port ---
*       4/13/94 *kob* : Put definitions of cr and lf into Parameter statments
*                     : Added "#ifdef READONLY_ALLOWED" because AIX compiler
*                       didn't allow readonly in open statements
* 5/94: *sh* major change to permit /ORDER= control over input
*       converted internal logic to 1D (ncol*nread) instead of 2D (ncol,nread) 
*	added /FORMAT=STREAM, as well, where the file is opened for direct
*	access in longwords, /SKIP signifies the number of words to skip,
*	and /COLUMNS signifies the number of words separating multiple
*	variables in the file
* 2/95:  increased from 10 arguments to 20
* 9/95: *sh* & *kob* - changed error branch for STREAM reads
* 9/95	kob*	- added ifdef for sgi to prevent setting reclen in words 
*		  instead of bytes
* 11/96 *kob* - Linux Port - had to move variable assignments off of
*               declaration line.
* V500 3/99 *kob* - Initialize buff at 610 to prevent use of previous values
* v540 *acm* 10/01 increase length of ds_name
* v540 *acm* 10/01  remove VMS include statements
*
* 2/03 *kob* - g77 port - g77 won't allow intrinsic functions in PARAMETER
*                         statements.  use character constant instead
* v604 *acm* 7/07 increase length of ds_name, ds_des_name
* V68  *acm* 1/12 The variables should be declared REAL (conversion to double prec.)
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
* V694 11/14 *acm* Ticket 2217: permuted ASCII reading in 6D
* V701  7/16 *kms* Compare ds_name to char_init2048 instead of char_init1024

* Arguments:
*	dset	- data set number
*	nread	- (input/output) number of data records to read/actually read
*	ncol    - number of values PER VARIABLE per record ("ngroups" in PLOT+)
*	columns - number of VALUES per record
*       buff    - buffer big enough to hold one record
*	status	- (output)
*	d0...d19- (output) variable arrays
*
	INTEGER*4	dset, nread, ncol, columns, status, nmax
	REAL		d0(ncol*nread), d1(ncol*nread), d2(ncol*nread),
     .			d3(ncol*nread), d4(ncol*nread), d5(ncol*nread), 
     .			d6(ncol*nread), d7(ncol*nread), d8(ncol*nread), 
     .			d9(ncol*nread),
     .			d10(ncol*nread),d11(ncol*nread),d12(ncol*nread),
     .                  d13(ncol*nread),d14(ncol*nread),d15(ncol*nread),
     .                  d16(ncol*nread),d17(ncol*nread),d18(ncol*nread),
     .                  d19(ncol*nread)
        REAL buff(columns)

*
* Include files
	include 'ez_lib.parm'
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
	include 'tmap_errors.parm'
	include 'xez_info.cmn_text'
	external xez_info_data
	include 'xez_order.cmn_text'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xstep_files.cmn_text'
	external xstep_files_data
*
*internal parameter declarations *kob* 4apr94
        CHARACTER*1     cr,lf
#ifdef NO_INTRINSIC_IN_PARAMETER
        PARAMETER       ( cr = o'015',
     .                    lf = o'012')
#else
        PARAMETER       ( cr = CHAR(13),
     .                    lf = CHAR(10))
#endif

* Local definitions
	CHARACTER*11	file_format
	CHARACTER*13	TM_STRING
	CHARACTER*80	errbuff
	CHARACTER*99	in_format
	INTEGER		EZ_PERMUTED_INDEX
	INTEGER*4	tpos, vpos, vcnt, sfcnt, lunit, scnt, rcnt, vfirst
	INTEGER*4	skip_in, read_in, transloc, icol, nout, ncolmn
	INTEGER*4	itemp, i, initloc, irec, ierr
	INTEGER*4	trans(0:maxezvars-1)
	DATA 		(trans(i),i=0,maxezvars-1) /maxezvars*-1/
	LOGICAL		unformatted, file_exists, file_open,
     .			permuted, stream
	REAL		bad(0:maxezvars-1)



* Does data set exist?
	IF (ds_name(dset) .EQ. char_init2048) GOTO 9300
*
* Locate Step file entry
	DO 10 sfcnt = 1,maxstepfiles
	  IF (sf_setnum(sfcnt) .EQ. dset) GOTO 20
  10	CONTINUE
	GOTO 9400

* Initialize
 20	nmax = ncol*nread
*   get file format
	stream = ds_parm_text(1,dset)(:3) .EQ. 'STR'
	unformatted = ds_parm_text(1,dset)(:3) .EQ. 'UNF'
	IF ( unformatted ) THEN
	  file_format = 'UNFORMATTED'
	ELSE
	  file_format = 'FORMATTED'
	  in_format = ds_parm_text(1,dset)		! Run time format info
	ENDIF
*   load transfer array. vpos will end up with number of variables to read in
*   from file, tpos will be number of useful variables to transfer to variable
*   arrays. '-' in ds_var_code indicates unused variable
*   4/94 - also capture the var # of the first var in the data set, vfirst
	tpos = 0
	vpos = 0
	DO 100 vcnt = 1,maxvars
	  IF (ds_var_setnum(vcnt) .EQ. dset) THEN
	    IF ( vpos .EQ. 0 ) vfirst = vcnt
	    vpos = vpos + 1
	    IF (Index(ds_var_code(vcnt),'-') .EQ. 0) THEN
	      trans(tpos) = vpos
	      tpos = tpos + 1
	      bad(tpos) = ds_bad_flag(vcnt)    ! 4/94
	    ENDIF
	  ENDIF
  100	CONTINUE

* is the input permuted?
	permuted = .FALSE.
	DO 110 i = 1, nferdims
	   IF ( ds_ordering(i,vfirst) .NE. i ) permuted = .TRUE.
 110	CONTINUE
!	permuted = .TRUE.   ! debug statement
	IF ( permuted ) CALL EZ_INIT_PERMUTE( vfirst )

*   set up ASSIGN statements (for GOTO variable statements)
	IF ( unformatted ) THEN
	  ASSIGN 400 TO skip_in			! Goes to UNFORMATTED read
	  ASSIGN 500 TO read_in			! Goes to UNFORMATTED read
	ELSEIF ( in_format(:4) .EQ. 'FREE' ) THEN
	  ASSIGN 450 TO skip_in			! Goes to FORMATTED read
	  ASSIGN 610 TO read_in			! Goes to FORMATTED read
	ELSEIF ( stream ) THEN			! "STREAM" direct access binary
	  ASSIGN 499 TO skip_in
	  ASSIGN 620 TO read_in
	  irec = sf_skip(sfcnt) + 1     ! /SKIP=words
	ELSE
	  ASSIGN 450 TO skip_in			! Goes to FORMATTED read
	  ASSIGN 600 TO read_in			! Goes to FORMATTED read
	ENDIF
	GOTO (150 ,151 ,152 ,153 ,154 ,155 ,156 ,157 ,158 ,159,
     .	      1510,1511,1512,1513,1514,1515,1516,1517,1518,1519) tpos
	ASSIGN 799 TO transloc			! transfers 0 variables
	ASSIGN 390 TO initloc
	GOTO 160
  150	ASSIGN 790 TO transloc			! transfers 1 variable
	ASSIGN 380 TO initloc
	GOTO 160
  151	ASSIGN 780 TO transloc			! transfers 2 variables
	ASSIGN 381 TO initloc
	GOTO 160
  152	ASSIGN 770 TO transloc			! transfers 3 variables
	ASSIGN 382 TO initloc
	GOTO 160
  153	ASSIGN 760 TO transloc			! transfers 4 variables
	ASSIGN 383 TO initloc
	GOTO 160
  154	ASSIGN 750 TO transloc			! transfers 5 variables
	ASSIGN 384 TO initloc
	GOTO 160
  155	ASSIGN 740 TO transloc			! transfers 6 variables
	ASSIGN 385 TO initloc
	GOTO 160
  156	ASSIGN 730 TO transloc			! transfers 7 variables
	ASSIGN 386 TO initloc
	GOTO 160
  157	ASSIGN 720 TO transloc			! transfers 8 variables
	ASSIGN 387 TO initloc
	GOTO 160
  158	ASSIGN 710 TO transloc			! transfers 9 variables
	ASSIGN 388 TO initloc
	GOTO 160
  159	ASSIGN 700 TO transloc			! transfers 10 variables
	ASSIGN 389 TO initloc
	GOTO 160
 1510	ASSIGN 7910 TO transloc			! transfers 11 variable
	ASSIGN 3810 TO initloc
	GOTO 160
 1511	ASSIGN 7810 TO transloc			! transfers 12 variables
	ASSIGN 3811 TO initloc
	GOTO 160
 1512	ASSIGN 7710 TO transloc			! transfers 13 variables
	ASSIGN 3812 TO initloc
	GOTO 160
 1513	ASSIGN 7610 TO transloc			! transfers 14 variables
	ASSIGN 3813 TO initloc
	GOTO 160
 1514	ASSIGN 7510 TO transloc			! transfers 15 variables
	ASSIGN 3814 TO initloc
	GOTO 160
 1515	ASSIGN 7410 TO transloc			! transfers 16 variables
	ASSIGN 3815 TO initloc
	GOTO 160
 1516	ASSIGN 7310 TO transloc			! transfers 17 variables
	ASSIGN 3816 TO initloc
	GOTO 160
 1517	ASSIGN 7210 TO transloc			! transfers 18 variables
	ASSIGN 3817 TO initloc
	GOTO 160
 1518	ASSIGN 7110 TO transloc			! transfers 19 variables
	ASSIGN 3818 TO initloc
	GOTO 160
 1519	ASSIGN 7010 TO transloc			! transfers 20 variables
	ASSIGN 3819 TO initloc
*
* Check file validity if necessary
  160	IF (.NOT. sf_valid(sfcnt)) THEN
!	  INQUIRE (	FILE = sf_name(sfcnt),	! sf_name is too short 10/89
	  INQUIRE (	FILE = ds_des_name(dset),
     .			RECL = itemp,	! temporary var needed by DEC/RISC
     .			EXIST = file_exists,
     .			OPENED = file_open,
     .			ERR = 9000)
	  IF (.NOT. file_exists) GOTO 9100
	  sf_reclen(sfcnt) = itemp
* calculate RECL in longwords for unformatted (if not open)             
          IF (.NOT. file_open .AND. unformatted )
     .	                         sf_reclen(sfcnt) = sf_reclen(sfcnt)/4
	  sf_valid(sfcnt) = .TRUE.      ! *sh* dset -> sfcnt 5/91
        ENDIF
*
* get free VMS logical unit #   
	CALL LIB_GET_LUN (lunit)
*
* open the file
#ifdef sun 
#  ifndef sgi
#    define reclen_in_bytes
#  endif
#endif
	IF ( stream ) THEN       ! 5/94
	   OPEN	(UNIT = lunit,
     .		 FILE = ds_des_name(dset),
     .		 FORM = 'UNFORMATTED',
     .		 ACCESS = 'DIRECT',
#ifdef reclen_in_bytes
     .		 RECL = 4,
#else
     .		 RECL = 1,
#endif
     .		 STATUS = 'OLD',
     .		 ERR = 9000)
	ELSE
* added ifdef for READONLY_ALLOWED for IBM port *kob* 4apr94
	   OPEN	(UNIT = lunit,
     .		 FILE = ds_des_name(dset),
     .		 FORM = file_format,
     .		 ACCESS = 'SEQUENTIAL',
     .		 STATUS = 'OLD',
#ifdef READONLY_ALLOWED
     .		 READONLY,
#endif
     .		 ERR = 9000)
	ENDIF
	sf_lunit(sfcnt) = lunit    ! *sh* dset -> sfcnt 5/91
*
* if input is to be permuted then it is essential to pre-fill the arrays
* that will receive the data - this because a fragmentary read (less data in
* the file then the grid dimensions would imply ) will end
* at a point in the middle of the output arrays.
	IF ( permuted ) THEN
	   DO 390 nout = 1, nmax
	      GOTO initloc
 3819	      d19(nout) = bad(trans(19))	      
 3818	      d18(nout) = bad(trans(18))	      
 3817	      d17(nout) = bad(trans(17))	      
 3816	      d16(nout) = bad(trans(16))	      
 3815	      d15(nout) = bad(trans(15))	      
 3814	      d14(nout) = bad(trans(14))	      
 3813	      d13(nout) = bad(trans(13))	      
 3812	      d12(nout) = bad(trans(12))	      
 3811	      d11(nout) = bad(trans(11))	      
 3810	      d10(nout) = bad(trans(10))	      
 389	      d9(nout) = bad(trans(9))	      
 388	      d8(nout) = bad(trans(8))	      
 387	      d7(nout) = bad(trans(7))	      
 386	      d6(nout) = bad(trans(6))	      
 385	      d5(nout) = bad(trans(5))	      
 384	      d4(nout) = bad(trans(4))	      
 383	      d3(nout) = bad(trans(3))	      
 382	      d2(nout) = bad(trans(2))	      
 381	      d1(nout) = bad(trans(1))	      
 380	      d0(nout) = bad(trans(0))	      
 390	   CONTINUE
	ENDIF

*
* read "SKIP" records and initialize records read counter
	GOTO skip_in
  400	DO 425 scnt = 1,sf_skip(sfcnt)
  425	READ (lunit,END=9200,ERR=9000)
	GOTO 499
  450	DO 475 scnt = 1,sf_skip(sfcnt)
  475	READ (lunit,'(1X)',END=9200,ERR=9000)
  499	nout = 0		! is number of values (per var) read so far
	ncolmn = columns
	IF ( stream ) ncolmn = vpos
*
* Read depending on format, nrec counts number of records read
	GOTO read_in
* ... binary data
* Note: neither IOSTAT= nor ERR= branch is effective on binary read of ASCII
*	file ???? (tested on OSF only)
  500	READ (lunit,END=800,ERR=9500) (buff(rcnt),rcnt=1,ncolmn)
* if statement commented out 3/22/95 *kob*
*	IF ( ierr .NE. 0 ) GOTO 9500
	GOTO 690
* ... fixed format data
  600	READ (lunit,in_format,END=800,ERR=9500) (buff(rcnt),rcnt=1,ncolmn)
	GOTO 690
* ... free format data
* 3/99 *kob* - Initialize buff before reading to prevent use of previous values
  610   do 611 rcnt = 1,ncolmn
	   buff(rcnt) = -1.E34
  611	continue
	READ (lunit,*,END=800,ERR=9500) (buff(rcnt),rcnt=1,ncolmn)
	GOTO 690
* ... STREAM format data
*       Normally there will be only a single variable read so vpos=1 but
*       we are allowing multiple variables spaced apart in the file by
*       /COLUMNS= words (stored in ds_ntuple(dset)) 
* Note: neither IOSTAT= nor ERR= branch is effective on read past EOF ????
*	(tested on OSF only) (ok after all? - branch to 9500 no good *sh* 9/95)
  620	DO 622 vcnt = 1, vpos
  622	READ (lunit,rec=irec+(vcnt-1)*ds_ntuple(dset),ERR=9600) buff(vcnt)
	irec = irec + 1
!	GOTO 690

* Repeat the transfer operation if number of columns is a multiple of # vars
 690	DO 795 icol = 0, ncolmn-vpos, vpos
	   IF ( permuted ) THEN
	      nout = EZ_PERMUTED_INDEX()    ! increment permuted fashion
	   ELSE
	      nout = nout + 1
	   ENDIF
	   GOTO transloc
*
* Transfer to variable arrays depending on how many variables
 7010     d19(nout) = buff(trans(19)+icol)
 7110     d18(nout) = buff(trans(18)+icol)
 7210     d17(nout) = buff(trans(17)+icol)
 7310     d16(nout) = buff(trans(16)+icol)
 7410     d15(nout) = buff(trans(15)+icol)
 7510     d14(nout) = buff(trans(14)+icol)
 7610     d13(nout) = buff(trans(13)+icol)
 7710     d12(nout) = buff(trans(12)+icol)
 7810     d11(nout) = buff(trans(11)+icol)
 7910     d10(nout) = buff(trans(10)+icol)
  700      d9(nout) = buff(trans(9)+icol)
  710      d8(nout) = buff(trans(8)+icol)
  720      d7(nout) = buff(trans(7)+icol)
  730      d6(nout) = buff(trans(6)+icol)
  740      d5(nout) = buff(trans(5)+icol)
  750      d4(nout) = buff(trans(4)+icol)
  760      d3(nout) = buff(trans(3)+icol)
  770      d2(nout) = buff(trans(2)+icol)
  780      d1(nout) = buff(trans(1)+icol)
  790      d0(nout) = buff(trans(0)+icol)

 795	CONTINUE

  799   IF (nout .GE. nmax) GOTO 800
	GOTO read_in
*
* Finished, store records read and then exit
  800	nread = nout / ncol
	status = merr_ok
	GOTO 9950
*
* Error message
 9000	CALL TM_ERRMSG( merr_erreq, status, 'EZ_READ',
     .			dset, sfcnt, 'during SKIP reads',
     .			no_errstring, *9999                 )

 9100	CALL TM_ERRMSG( merr_notmounted, status, 'EZ_READ',
     .			dset, sfcnt, 'DATAFILE NOT FOUND',
     .			no_errstring, *9999                 )

 9200	CALL TM_ERRMSG( merr_eof, status, 'EZ_READ',
     .			dset, sfcnt,
     .			'during SKIP reads', no_errstring, *9950   )

 9300	CALL TM_ERRMSG( merr_dsetnf, status, 'EZ_READ',
     .			no_descfile, no_stepfile,
     .			no_errstring, no_errstring, *9999)

 9400	CALL TM_ERRMSG( merr_stepnf, status, 'EZ_READ',
     .			dset, no_stepfile,
     .			no_errstring, no_errstring, *9999)

 9500	BACKSPACE lunit
	READ (lunit,'(A)') errbuff
	CALL TM_ERRMSG( merr_erreq, status, 'EZ_READ',
     .			dset, sfcnt,
     .		'Last or next-to-last record read:'//cr//lf//errbuff,
     .			no_errstring, *9999                 )

 9600	CALL TM_ERRMSG( merr_erreq, status, 'EZ_READ',
     .			dset, no_stepfile,
     .			'error reading STREAM file', no_errstring, *9999)
*
* Close file and free lunit
 9950	CLOSE (lunit, ERR=9990)
 9990	CALL LIB_FREE_LUN (lunit)
        sf_lunit(sfcnt) = file_not_open    ! *sh* added 5/91
 9999	RETURN
	END

*  separate_str.F
* 
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* Ansley Manke June 2013
* Given a data variable and a ROWSIZE indicating trajectory length,
* Insert a bad-value between trajectories.
*
*
*  In this subroutine we provide information about
*  the function.  The user configurable information 
*  consists of the following:
* 
*  descr              Text description of the function
* 
*  num_args           Required number of arguments
* 
*  axis_inheritance   Type of axis for the result
*                        ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                        CUSTOM          - user defined axis
*                        IMPLIED_BY_ARGS - same axis as the incoming argument
*                        NORMAL          - the result is normal to this axis
*                        ABSTRACT        - an axis which only has index values
* 
*  piecemeal_ok       For memory optimization:
*                        axes where calculation may be performed piecemeal
*                        ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE separate_str_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     . 'Insert a bad-value between features, string variable' )

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id, ABSTRACT, NORMAL, NORMAL, 
     .                                             NORMAL, NORMAL, NORMAL)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_desc(id, arg, 'variable to sample on I axis')
      CALL ef_set_axis_influence_6d(id, arg, YES, NO, NO, NO, NO, NO)
      CALL ef_set_arg_type (id, arg, STRING_ARG)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'Rowsize')
      CALL ef_set_arg_desc(id, arg,
     .          'array with per-feature row lengths')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'FixLongitudes')
      CALL ef_set_arg_desc(id, arg,
     .          'ignored (included for parity with numeric fcn)')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, NO, NO)

      CALL ef_set_result_type (id, STRING_RETURN)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END




      SUBROUTINE separate_str_result_limits(id)

      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*     Use utility functions  to get context information about the arguments.
*     indices.


      INTEGER arg_lo_ss(6,EF_MAX_ARGS), arg_hi_ss(6,EF_MAX_ARGS),
     .     arg_incr(6,EF_MAX_ARGS)

      INTEGER nx, nr, nee, lo_lim, hi_lim
      CHARACTER*100 errtxt

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      nx = arg_hi_ss(X_AXIS, ARG1) - arg_lo_ss(X_AXIS, ARG1) + 1

* will add a point for each row

      nr = arg_hi_ss(E_AXIS, ARG2) - arg_lo_ss( E_AXIS, ARG2) + 1
      nee = arg_hi_ss(X_AXIS, ARG2) - arg_lo_ss( X_AXIS, ARG2) + 1
      
      IF (nee .GT. nr) THEN
         IF (nr .NE. 1) THEN
	    errtxt = 'Error argument 2 must be 1D and on X or E axis'
	    GOTO 999
	 ENDIF
	 nr = nee
      ENDIF

      lo_lim = 1
      hi_lim = nx + nr - 1
      CALL ef_set_axis_limits(id, X_AXIS, lo_lim, hi_lim)

      RETURN
 999  CALL EF_BAIL_OUT(id, errtxt)

      END



*  In this subroutine we compute the result
* 
      SUBROUTINE separate_str_compute(id, arg_1, arg_2, arg_3, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)

! We just know this is on the X axis and will be passed in and out correct.y.
      REAL result(memreslox:memreshix)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(6), res_hi_ss(6), res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, i1, ir, k, m, slen
      INTEGER nx, msum, rend, nrr, nee, row_axis
      REAL fixlon, tol, nothing
      LOGICAL ifix
      CHARACTER*512 buff

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      k = res_lo_ss(Z_AXIS)  ! index for unused dimensions

      nx = arg_hi_ss(X_AXIS, ARG1) - arg_lo_ss(X_AXIS, ARG1) + 1

      nee = arg_hi_ss(E_AXIS, ARG2) - arg_lo_ss( E_AXIS, ARG2) + 1
      nrr = arg_hi_ss(X_AXIS, ARG2) - arg_lo_ss( X_AXIS, ARG2) + 1

      row_axis = E_AXIS
      IF (nrr .GT. nee) row_axis = X_AXIS

      CALL ef_get_one_val(id, arg3, fixlon)
      ifix =  (fixlon .GT. 0.8)
      tol = 200.

      i1 = 1
      ir = 1
      msum = 0
      DO m = arg_lo_ss(row_axis,ARG2), arg_hi_ss(row_axis, ARG2)
         IF (row_axis .EQ. E_AXIS) THEN
	    rend = arg_2(k,k,k,k,m,k)
	 ELSE
	    rend = arg_2(m,k,k,k,k,k)
	 ENDIF

	 msum = msum + rend
	 IF (msum .GT. nx) msum = nx-1
	 DO i = i1, msum

	    CALL ef_get_string_arg_element_6d(id, ARG1, arg_1,
     .                       i,k,k,k,k,k, slen,buff)
	    CALL ef_put_string (buff, slen, result(ir) )
  
	    ir = ir + 1
	    IF (ir .GT. res_hi_ss(X_AXIS)) GOTO 9000
	 ENDDO
	 i1 = msum+1
	 buff = ' '
	 slen = 1
	 CALL ef_put_string (buff, slen, result(ir) )
	 ir = ir + 1
	 IF (ir .GT. res_hi_ss(X_AXIS)) GOTO 9000
      ENDDO

 9000 RETURN
c 999  CALL EF_BAIL_OUT(id, errtxt)
      RETURN

      END

	SUBROUTINE IS_SAMPLE(  *, *, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* This routine handles the I/O management logic for the SAMPLE* functions
* When the user issues SAMPLEI({1,5,3,3,8},my_var) this routine will
* compute the result in an "optimal" way -- probably by requesting 1:5 in
* one I/O operation and 8:8 in a separate one and the merging the chunks

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V510: 8/99
*	 *sh* 2/00 (??) - correct improper handling of invalid indices
* V533; *sh* 7/01 - add support for sampling of string variables
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include	'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'

* calling argument declarations:
	INTEGER	status
* normal return is for error conditions
* exit #1 is to request another grid ( stack has been pushed )
* exit #2 is to signal completion of the activity at this stack level

*   ... interpretation stack setup at the time this is called ...
*	stack level		stack contents
*	isp+1	<--	level of last activity ( component just computed )
*	 isp	<--	current stack level (for sampling )

* internal variable declarations:
	LOGICAL	all_at_once
	INTEGER DENSE_CONTIG_REGION, MGRID_SIZE_DELTA
	INTEGER chunk_mr, hold_mr, chunk_cx, hold_cx,
     .		axis, n, phase, lo_cx_lim, hi_cx_lim, mr_sorted_indices,
     .		mr_index_map, idim, chunk_isp, hold_isp, cat, var,
     .		nvalid


* --- end of introductory code ---

* initialize
	hold_isp   = isp
	chunk_isp  = isp + 1
	hold_mr    = is_mr( hold_isp )		! to be filled by chunks
	chunk_mr   = is_mr( chunk_isp )		! each invidivual chunk
	hold_cx    = is_cx( hold_isp )
	chunk_cx   = is_cx( chunk_isp )
!	dflt_cx	   = is_big_cx( hold_isp )
	axis       = is_axis( hold_isp )
	phase      = is_phase(hold_isp)
	mr_index_map      = is_sum(hold_isp)/10000
	mr_sorted_indices = is_sum(hold_isp) - 10000*mr_index_map
	nvalid = mr_hi_ss( mr_index_map, t_dim )	! valid indices
	cat = cx_category(chunk_cx)
	var = cx_variable(chunk_cx)

****  A NEW CHUNK OF DATA HAS JUST ARRIVED  ****
*  Copy it into the result "holder"
	IF ( phase .GT. 0 ) THEN

* the context for the holder may be missing its limits on axes other than the
* sampling axis
	   DO 100 idim = 1, nferdims
	      IF ( idim .NE. axis ) THEN
	         CALL TRANSFER_AXIS( idim, chunk_cx, hold_cx )
	      ENDIF
 100	   CONTINUE

* create result space if this is the first chunk
	   IF ( hold_mr .EQ. unspecified_int4 ) THEN
	      CALL CREATE_TEMP_MEM_VAR( hold_cx, hold_mr, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
	      is_mr( hold_isp ) = hold_mr

* pre-fill output with missing flags, in case a missing index was given
	      IF ( mr_type(hold_mr) .EQ. ptype_string ) THEN
	        CALL INIT_C_STRING_ARRAY( MGRID_SIZE_DELTA(hold_mr),
     .                                    memry(hold_mr)%ptr,
     .                                    mr_c_pointer(hold_mr)      )
	        CALL SET_NULL_C_STRING_ARRAY(mr_c_pointer(hold_mr),
     .					     MGRID_SIZE_DELTA(hold_mr) )

	      ELSE
	        CALL FILL_MEMORY ( hold_mr, mr_bad_data(hold_mr) )
	      ENDIF

	   ENDIF

	   IF ( nvalid .GT. 0 ) THEN
* for optimization, make sure we are using all of the source data that we can
* the ADJUST_COPY_LIMITS routine will modify "phase" to use all available data
	     n = phase
	     CALL ADJUST_COPY_LIMITS(axis, chunk_mr,
     .				     memry(mr_sorted_indices)%ptr,
     .				     phase, nvalid )
	     IF (phase .GT. n) THEN
* ... apply the optimization
	        cx_hi_ss(chunk_cx, axis) = mr_hi_ss(chunk_mr,axis)
	        cx_by_ss(axis,chunk_cx) = .TRUE.
	        CALL FLESH_OUT_AXIS( axis, chunk_cx, status)
	        IF (status .NE. ferr_ok) CALL ERRMSG( ferr_internal, status,
     .		    'SAMPLE* optimization', *5000)
	     ENDIF

* copy data just received into the result
	     CALL COPY_INTO_MAPPED(
     .			memry(chunk_mr)%ptr, chunk_mr, chunk_cx,
     .			memry(mr_sorted_indices)%ptr,
     .			memry(mr_index_map)%ptr, phase, axis,
     .			memry(hold_mr)%ptr, hold_mr )

* ... remove the component protection that signaled we needed it here
	   ENDIF
	   CALL MR_NOT_IN_USE( chunk_mr )
	ENDIF

*********  SETUP TO GRAB THE NEXT CHUNK  **********

* do we want to grab the entire input as a single sample?
	IF (cat .EQ. cat_user_var) THEN
* ... if limits are part of the uvar def'n, use 'em
* ...  and if an indefinite integral is involved, do not break up computation
	   all_at_once = uvar_given(axis,var) .LE. uvlim_gvn_xact
     .		    .OR. uvar_given(axis,var) .EQ. uvlim_need_lo
	ELSE
	  all_at_once = cat .EQ. cat_const_var
     .	           .OR. cat .EQ. cat_pseudo_var
     .	           .OR. cat .EQ. cat_constant
	ENDIF
* ... if limits are explicit inside of the fcn call then use 'em
	all_at_once = all_at_once .OR. cx_given(axis,chunk_cx)

* total number of indices
	n = mr_hi_ss( mr_index_map, x_dim )

* determine next chunk to get
	IF ( nvalid .EQ. 0 ) THEN
	   IF (phase .EQ. 0) THEN
	      lo_cx_lim = 1	! get any old point just so we can have
	      hi_cx_lim = 1	! a complete context for the result
	      is_phase(hold_isp) = 1
	   ELSE
	      is_phase(hold_isp) = -1  ! all done with sampling
	   ENDIF   
	ELSEIF ( all_at_once ) THEN
	   IF (phase .EQ. 0) THEN
	      is_phase(hold_isp) = nvalid
	   ELSE
	      is_phase(hold_isp) = -1  ! all done with sampling
	   ENDIF
	   lo_cx_lim = cx_lo_ss(chunk_cx,axis)  ! grab all of it at once
	   hi_cx_lim = cx_hi_ss(chunk_cx,axis)
	ELSE
	   is_phase(hold_isp) = DENSE_CONTIG_REGION(
     .				memry(mr_sorted_indices)%ptr, 
     .				phase+1, nvalid,
     .				mr_bad_data(mr_sorted_indices),
     .				lo_cx_lim, hi_cx_lim )
	ENDIF

* done?  Pop chunk_cx from context stack
	IF ( is_phase(hold_isp) .LE. 0 ) THEN
	   cx_stack_ptr = cx_stack_ptr - 1
	   IF ( hold_cx .NE. cx_stack_ptr ) CALL WARN('SAMP_STK_ERR')
* ... free the work space used for the sampling inddices
	   CALL DELETE_VARIABLE(mr_index_map)
	   CALL DELETE_VARIABLE(mr_sorted_indices)
	   RETURN 2
	ENDIF

* no, more to get.  Set up chunk_cx to get the next slug of indices
	cx_lo_ss(chunk_cx,axis) = lo_cx_lim 
	cx_hi_ss(chunk_cx,axis) = hi_cx_lim
	cx_by_ss(axis,chunk_cx) = .TRUE.
	CALL FLESH_OUT_AXIS( axis, chunk_cx, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* push the interpretation stack and go get it
	isp = chunk_isp
	status = ferr_ok
	RETURN 1

* error exit
 5000	RETURN

	END	

	SUBROUTINE PPLCMD(FROMI,LINEI,ISI,COMBUF,ICMDIM,ICMSZE)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.   
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* V54: *acm* 9/01 changes for dynamic allocation of PPLUS memory.
*                  This routine passes arguments through by a C "envelope" 
*                  routine pplcmd_c, which gets the global pointer to PPLUS 
*                  memory and passes it to pplcmd_f.F  which has the original code.
*                  Put the strings in common to avoid wierdness with strings in C.
* v541 *acm* 5/02  Slightly more graceful stop in case IDMDIM too large
* v552 *acm* 3/03  cleanup in declarations

c	SUBROUTINE PPLCMD(FROMI,LINEI,ISI,COMBUF,ICMDIM,ICMSZE)

      INCLUDE 'pplcmd_strings.cmn'

	CHARACTER FROMI*(*), LINEI*(*), COMBUF(ICMDIM)*(*)
        INTEGER   ICMDIM,ISI,ICMSZE     

c     internal parameter declarations:
      INTEGER      i

      IF (ICMDIM .GT. 5) GO TO 5000

      DO i = 1, ICMDIM
         PPLCOMBUF(i) = COMBUF(i)
      ENDDO

      PPLFROMI = FROMI
      PPLLINEI = LINEI

      CALL pplcmd_c  (ISI, ICMDIM, ICMSZE)

      RETURN
 5000 STOP 'ICMDIM in PPLCMD too small'
      END

	SUBROUTINE LSTSYM(STR,LABEL,NC,ILST,IER)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)lstsym.F	1.2    5/26/88
C**
C**
C***********************************************************************
C**
C**		    PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C**	Subprogram called:
C**		CALL LSTSYM(STR,LABEL,NC,ILST,IER)
C**
C**	Parameters:
C**		STR -- Symbol name (char*120)
C**		LABEL -- Symbol value (char*2048)
C**		NC -- length of LABEL
C**		ILST -- Initially run with ILST = 0
C**			Output is a counter
C**		IER -- error code
C**			0 = success
C**			1 = error or end of file
C**
C**	Description:
C**		Gets the symbol values one by one until all have been
C**		accessed.
C**
C**	History:
C**	    Written:
C**		15-DEC-1985	by Donald W. Denbo
C**	    Modified:
C**
C**
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
C* v552 *acm* 3/03 Longer strings: changes for multi-line labels
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long

	INCLUDE 'SYMKEY.INC'

	CHARACTER STR*(*),LABEL*(*)
	IF(ILST.EQ.0)THEN
	    call dbmfirstkey(keyln1,str,ilen,ier)
	else
	    call dbmnextkey(keyln1,str,ilen,ier)
	endif
	if(ier.ne.0)goto 2000
	call dbmfetch(keyln1,str,ilen,label,nc,ier)
	str(ilen+1:)=' '
	ILST=ILST+1
	IER=0
	RETURN
2000	IER=1
	RETURN
	END

	SUBROUTINE WIND_STRESS ( uwind,  muwind,
     .				 vwind,	 mvwind,
     .				 stress, mstress )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute wind stress magnitude on T-S grid from components on U-V grid
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/17/86	extracted from SUBROUTINE HDIFFUS
*			with major modifications to convert i-k oriented
*			calculations to i-j oriented calculations
* revision 0.1 - 1/27/89 - modified bad_flag error checking at j=2 in case of
*			   improper GFDL model output
*		note: bad flag checks are based on UWND, only for performance
* V200:  7/27/89 - 4D symmetrical version
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN
* Unix/RISC port 8/91 *sh*: added dp_nts30_wind sensitivity
*                         - also fixed bug at j=2 and j=jmtm1 by changing to
*                           ELSEIF logic
* V320: 12/29/94 - use SPLIT_LIST to redirect tty output for GUI

#ifdef unix
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl.parm'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xcontext.cmn'
        include 'xdset_parms.cmn'
#else
	INCLUDE 'FERRET_CMN:FERRET.PARM'
	INCLUDE 'FERRET_CMN:GFDL.PARM'
        INCLUDE 'TMAP_FORMAT:TMAP_DIMS.PARM'
	INCLUDE	'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE	'FERRET_CMN:XMEM_SUBSC.CMN'
	INCLUDE 'FERRET_CMN:XCONTEXT.CMN'
        INCLUDE 'FERRET_CMN:XDSET_PARMS.CMN'
#endif

* calling argument declarations:
	INTEGER	muwind, mvwind, mstress
* subscript ranges from memory variable table ...
	REAL     uwind( m1lox:m1hix,m1loy:m1hiy,            m1lot:m1hit ),
     .		 vwind( m2lox:m2hix,m2loy:m2hiy,            m2lot:m2hit ),
     .		stress( m3lox:m3hix,m3loy:m3hiy,            m3lot:m3hit )

* internal variable declarations:
        LOGICAL need_nts30
	INTEGER	dset, grid, i_lo, i_hi, j_lo, j_hi, i, j, l,
     .          itt, ittmod, slen
	REAL	bad_wind, bad_stress, taux, tauy
        REAL*8  TM_WORLD
	CHARACTER LEFINT*6

* local parameters
        INTEGER nts30
        PARAMETER ( nts30 = 730 )

* --- end of introductory code ---

* limits for calculation
	i_lo = mr_lo_s1(mstress)
	i_hi = mr_hi_s1(mstress)
	j_lo = mr_lo_s2(mstress)
	j_hi = mr_hi_s2(mstress)

* flag(s) for bad or missing values
	bad_wind   = mr_bad_data ( muwind )
	bad_stress = mr_bad_data ( mstress )

* data set needed to determine whether to do NST30 modification
        dset = mr_data_set( muwind )
        grid = mr_grid    ( muwind )

C									! 3003
C     SINCE STRESS & AIRT ARE DEFINED CORRECTLY ONLY FOR THE CURRENT	! 3007
C     JROW DURING THE 2 TIME STEPS WHEN BC ARE BROUGHT IN AT THE	! 3008
C     BEGINNING OF EACH MONTH...APPROXIMATE THEM ON JROW-1 BY USING	! 3009
C     THE JROW VALUES							! 3010
C									! 3011
* note:	Ron Pacanowski agrees that this IF test is incorrect and...
*      IF (MOD(ITT-1,NTS30).EQ.0.OR.MOD(ITT-1,NTS30).EQ.1) THEN		! 3012
*	should be replaced by:
!	if (j.eq.2) then
****** this will slightly alter the results ******
* note 8/91: this incorrect test remained in throughout the life of
* the 205 model and critically effects the balances when attempting
* an exact match using hourly data.
* The descriptor parameter "NTS30 WIND STRESS MOD" was created to turn back on
* this feature
C									! 3013
	DO 2000 l = mr_lo_s4(mstress), mr_hi_s4(mstress)

* special correction at nts30 time steps ?
* NOTE: nts30 logic is only partially tested - month starts, only tested
*       also, there is a bug (8/91) in the heat flux calculation at present
*       when using hourly data:  qflx is entirely calculated at T-1.  In
*       fact sst should be at T-1 but tau should be at T.  If that bug is
*       fixed the MOD logic above will need to be changed
        IF ( dp_nts30_wind( dset ) ) THEN
	   CALL SPLIT_LIST(pttmode_bull, 6,
     .			'WIND_STRESS: Checking itt against nts30',0)
           itt = INT( TM_WORLD( l, grid, t_dim, box_middle ) )
           ittmod = MOD(itt+1,nts30)
           need_nts30 = ittmod.EQ.0 .OR. ittmod.EQ.1
           IF ( need_nts30 ) 	   CALL SPLIT_LIST(pttmode_bull, 6,
     .			'Using NTS30 at '//LEFINT(l,slen)//
     .			LEFINT(itt,slen),0)
        ELSE
           need_nts30 = .FALSE.
        ENDIF

* shift winds from u,v grid to T grid points
* via 4-point interpolation where possible
	DO 1720 j = j_lo, j_hi
	DO 1720 I = i_lo, i_hi					! 3021 mod

	   IF ( j .EQ. 1  .OR.  i .EQ. 1 ) THEN
	      stress(i,j,l) = bad_stress

	   ELSEIF (      uwind(i  ,j,l  ) .EQ. bad_wind
     .		.OR. uwind(i-1,j,l  ) .EQ. bad_wind ) THEN
	      stress(i,j,l) = bad_stress

	   ELSEIF ( j.EQ.2 .OR. j.EQ.jmtm1 .OR. need_nts30 )  THEN ! 2 pt intrp
	      TAUX = .5*( uwind(i,j,l) + uwind(i-1,j,l) )	! 3015 mod
	      TAUY = .5*( vwind(i,j,l) + vwind(i-1,j,l) )	! 3017 mod
	      stress(i,j,l) = SQRT ( taux**2 + tauy**2 )

	   ELSEIF (  uwind(i  ,j-1,l) .EQ. bad_wind
     .		.OR. uwind(i-1,j-1,l) .EQ. bad_wind ) THEN
	      stress(i,j,l) = bad_stress

           ELSE
	      TAUX = .25* ( uwind (i,j  ,l) + uwind (i-1,j  ,l) +    ! 3022 mod
     .			    uwind (i,j-1,l) + uwind (i-1,j-1,l) )    ! 3023 mod
	      TAUY = .25* ( vwind (i,j  ,l) + vwind (i-1,j  ,l) +    ! 3024 mod
     .			    vwind (i,j-1,l) + vwind (i-1,j-1,l) )    ! 3025 mod
	      stress(i,j,l) = SQRT ( taux**2 + tauy**2 )
	   ENDIF

 1720	CONTINUE								! 3026
 2000	CONTINUE								! 3026

	RETURN
	END

	SUBROUTINE ARROW(XL,YL,XL2,YL2,IAT,SHFT,XMN,CS,SN,XF,YF)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)arrow.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
#ifdef unix
	INCLUDE 'LABCOM.INC'
#else
	INCLUDE 'pplinc:LABCOM.INC'
#endif
	IF(IAT.EQ.0)RETURN
	IF(XL+SHFT*CS/XF.GE.XL2)THEN
	    AX=-HLABS*.5
	    AY=HLABS*.5
	ELSE IF(XL+(XMN+SHFT*CS)/XF.LE.XL2)THEN
	    AX=(HLABS*.5+XMN)
	    AY=HLABS*.5
	ELSE IF(YL+SHFT*SN/YF.GT.YL2)THEN
	    AY=-HLABS*.5
	    AX=XMN*.5
	ELSE
	    AY=HLABS*1.5
	    AX=XMN*.5
	ENDIF
	XLT=XL+((SHFT+AX)*CS-AY*SN)/XF
	YLT=YL+((SHFT+AX)*SN+AY*CS)/YF
	IF(IAT.EQ.2)THEN
	    HS=HLABS*0.5
	    DNM=SQRT(((XL2-XLT)*XF)**2+((YL2-YLT)*YF)**2)
	    CCS=(XL2-XLT)*XF/DNM
	    SSN=(YL2-YLT)*YF/DNM
	    XN=XL2+(-CCS-.5*SSN)*HS/XF
	    YN=YL2+(-SSN+.5*CCS)*HS/YF
	    CALL PLOT(XN,YN,0,0)
	    CALL PLOT(XL2,YL2,1,0)
	    XN=XL2+(-CCS+.5*SSN)*HS/XF
	    YN=YL2+(-SSN-.5*CCS)*HS/YF
	    CALL PLOT(XN,YN,1,0)
	ENDIF
	CALL PLOT(XL2,YL2,0,0)
	CALL PLOT(XLT,YLT,1,0)
	RETURN
	END

        SUBROUTINE WRITE_DODS_FMT ( data, 
     .           m1lox,m1hix, m1loy,m1hiy, m1loz,m1hiz, m1lot,m1hit, 
     .           m1loe,m1hie, m1lof,m1hif, 
     .           workspace, filename, clobber, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* write a gridded variable in DODS DAS binary format

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* Ferret v5.54 9/4/06
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

* change this comment, so that the checkin under branch FDSv1
* will occur.

* calling argument declarations:
        LOGICAL clobber
        INTEGER status,
     .          m1lox,m1hix, m1loy,m1hiy, m1loz,m1hiz, m1lot,m1hit, 
     .          m1loe,m1hie, m1lof,m1hif
	REAL data(m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit,m1loe:m1hie,m1lof:m1hif)
        REAL    workspace (*)  
        CHARACTER*(*) filename

* Local variable declarations
        INTEGER TM_LENSTR1, i, j, k, l, m, n, size, swap_flag,
     .          clobber_flag, slen


* #ifdef for endianness info.
#ifdef sun
	include 'xmachine_byte.cmn'
#else
	include 'xmachine_int1.cmn'
#endif


* BYTEORDER - get byteorder of this architecture
 	IF (active_cpu .EQ. cptype_sun) THEN
	   swap_flag = 0
	ELSE
	   swap_flag = 1
	ENDIF

        size = 0

	DO 100 n = m1lof,m1hif
	DO 100 m = m1loe,m1hie
	DO 100 l = m1lot,m1hit
	DO 100 k = m1loz,m1hiz
	DO 100 j = m1loy,m1hiy
	DO 100 i = m1lox,m1hix

           size = size + 1
           workspace(size) = data(i,j,k,l,m,n)
  100   CONTINUE

         slen = TM_LENSTR1(filename)
         clobber_flag = 0
         IF (clobber) clobber_flag = 1
         CALL write_dods (filename, slen, clobber_flag, swap_flag, 
     .                    size,  workspace)

        RETURN

 5010   status = 0
        RETURN
        END

	SUBROUTINE SPECIAL_SYMBOL( isym, name, value, slen )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* this routine is 2-in-1 to handle "special" (internally defined) symbols
* it acts like an encapsulated special symbol "object" (FORTRAN ...)
* if isym=0 on input then this is a request to translate the passed "name"
*	if the given name is the name of a special symbol return its definition
*	in value and its length in slen. Else return slen=0
* if slen is a positive integer then return the name of that symbol
*	or a blank name if the integer is larger than the number of symbols 

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V522 7/00 *sh* - extracted from symbol_command.F
* V530  8/00 *sh* - bug (feature) fix so that SHOW SYM doesn't eveluate
*			PPL$XPIXEL
*      12/00 *sh* - added symbols SESSION_DATE and SESSION_TIME
*      10/01 *kob*- add symbol FERRET_PLATFORM to display the platform
*                   the executable was built on. 
*       8/05 *acm*- Allow more digits in xrevision number
* V62   4/09 *acm*- Add new symbol DELTA_CPU. When it is evaluated,
*                   calls the intrinsic fcn Dtime and sets the value to that new
*                   delta-time since the last call.  Initialized in initizlize.F
* V62   4/09 *acm*- Add new symbol CLOCK_SECS. When it is evaluated, calls the
*                   intrinsic SYSTEM_CLOCK and sets the value to the delta-time 
*                   in seconds since Ferret was initialized.
* V62   4/09 *acm*- Add new symbols CURRENT_DATE, CURRENT_TIME. These get formatted
*                   date and time, unlike SESSION_DATE, SESSION_TIME which remain
*                   fixed at the start time of the Ferret session.
* V62   5/09 *acm*- make FERRET_MEMORY a special symbol.
* V65   1/10 *acm*- New special symbol N_OPEN_DSETS, counts the number of open datasets
* V65   2/10 *acm*- Call CPU_TIME rather than DTIME for clock symbols. Works
*                   with gfortran as well as g77.
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
* V68   1/12 *acm*- Symbol FERRET_PRECISION is single or double.
* V68   3/12 *acm*- Symbol SESSION_PID for the process ID
* V68   2/13 *kms*- Symbol PROGRAM_NAME = Ferret or PyFerret
* V702  3/17 *sh* - Dynamic memory calculation change for FERRET_MEMORY symbol
*                 - added PEAK_MEMORY and SPAWN_STATUS
* v720 7/17 *acm* ticket 2552 Make SPAWN_STATUS return the return status, so 0=succcess
*                 SPAWN_OK -> SPAWN_OK, so 1=succcess, 0=failure
*                 SPAWN_STATUS returns the status value
* V751 6/19 *acm* Ticket 1903, reporting memory in bytes, so new symbol FERRET_BYTES_MEM

        IMPLICIT NONE
* calling argument declarations:
	INTEGER	  isym, slen
	CHARACTER name*(*), value*(*)

* internal parameter declaration
	INTEGER nspecial
	PARAMETER (nspecial = 21)

* internal variable declarations:
	LOGICAL	IS_SECURE
	INTEGER STR_UPCASE, TM_LENSTR, i, i1, ierr, wsid, 
     .          nxpix, nypix, llen, icount, irate, imax, iset
c        REAL DTIME 
        REAL TArray(2), dtime_res, clock_secs, count, cputime_now, rstatus
	CHARACTER special(nspecial)*16, upname*16
	CHARACTER LEFINT*16, TM_FMT*48, TM_FMT_TRIM*48, NF_INQ_LIBVERS*80,
     .		   NF_INQ_LIBVERS_*80,LEFINT8*16, byte_unit*2
        CHARACTER*10 current_date, current_time, zone
	INTEGER itimes(8)

* names of special symbols (must be upper case)
	DATA special(1)/ 'PPL$XPIXEL' /,
     .	     special(2)/ 'PPL$YPIXEL' /,
     .	     special(3)/ 'BYTEORDER' /,
     .	     special(4)/ 'FERRET_VERSION' /,
     .	     special(5)/ 'FERRET_PLATFORM' /,
     .	     special(6)/ 'FERRET_PRECISION' /,
     .	     special(7)/ 'NETCDF_VERSION' /,
     .	     special(8)/ 'FERRET_MEMORY' /,
     .	     special(9)/ 'FERRET_BYTES_MEM' /
     .	     special(10)/ 'SESSION_DATE' /,
     .	     special(11)/ 'SESSION_TIME' /,
     .	     special(12)/ 'SESSION_PID' /,
     .	     special(13)/ 'DELTA_CPU' /,
     .	     special(14)/ 'CLOCK_SECS' /,
     .	     special(15)/ 'CURRENT_DATE' /,
     .	     special(16)/ 'CURRENT_TIME' /,
     .	     special(17)/ 'N_OPEN_DSETS' /,
     .	     special(18)/ 'PROGRAM_NAME' /,
     .	     special(19)/ 'PEAK_MEMORY' /,
     .	     special(20)/ 'SPAWN_OK' /,
     .	     special(21)/ 'SPAWN_STATUS' /

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xplot_state.cmn'	! for PPL$XPIXEL
	include 'xrevision.cmn'
	include 'xtoday.cmn'
	include 'xplatform_type.cmn'
	include 'xvariables.cmn'
#	include "tmap_dset.parm"
	include 'xdset_info.cmn_text'
	include 'xprog_state.cmn'	! for spawn_status

* #ifdef for endianness info.
#ifdef sun
	include 'xmachine_byte.cmn'
#else
	include 'xmachine_int1.cmn'
#endif

* is this a query by integer or by name?
	IF (isym .GE. 1) THEN 
* ***** QUERY BY INTEGER ******
	   IF (isym.GT.nspecial) THEN
	      name = ' '
	      RETURN
	   ENDIF
	   name = special(isym)
	   RETURN
	ENDIF

* ***** QUERY BY NAME *****
* identify the given name
	ierr = STR_UPCASE( upname, name )
	DO 100 i = 1, nspecial
	   IF (upname .EQ. special(i)) GOTO 200
 100	CONTINUE

* not a recognized special symbol
	slen = 0
	RETURN

 200	GOTO (1100, 1200, 1300, 1400, 1500, 1600, 1700, 1800, 
     .        1900, 2000, 2100, 2200, 2300, 2400, 2500, 2600,
     .        2700, 2800, 2900, 3000, 3100 ) i

* PPL$XPIXEL, PPL$YPIXEL
 1100	CONTINUE
* ... determine the current output window (GKS wkstn ID, that is)
 1200	DO 1230 wsid = 1, max_windows
           IF ( wn_active(wsid) ) GOTO 1240
 1230   CONTINUE
* ... no currently active window
	value = '0'
	slen = 1
	RETURN
 1240	CALL GET_WINDOW_PIXELS(wsid, nxpix, nypix)
	IF ( i.EQ.1 ) THEN
	   value = LEFINT(nxpix,slen)
	ELSE
	   value = LEFINT(nypix,slen)
	ENDIF
	RETURN

* BYTEORDER - get byteorder of this architecture
 1300	IF (active_cpu .EQ. cptype_sun) THEN
	   value = 'BIG'
	   slen = 3
	ELSE
	   value = 'LITTLE'
	   slen = 6
	ENDIF
	RETURN

* FERRET_VERSION
 1400	value = ' '
	value = TM_FMT(revision_level, 5, 12, llen)
	slen = llen
	RETURN

* PLATFORM_TYPE  *kob* 10/01
 1500	value = platform_type
	slen = TM_LENSTR(platform_type)
	RETURN

* FERRET_PRECISION
 1600	CONTINUE
#ifdef double_p
        value = 'double'
#else
        value = 'single'
#endif
	slen = TM_LENSTR(value)
	RETURN

* NETCDF_VERSION
 1700	CONTINUE
	value = NF_INQ_LIBVERS()
	slen = TM_LENSTR(value)
	RETURN

* FERRET_MEMORY
 1800	value = TM_FMT_TRIM(max_mem_allowed/1.D6,-2,12,llen)
	slen = llen
	RETURN

* FERRET_BYTES_MEM
 1900  CALL MEM_TO_BYTES (max_mem_allowed, value, llen, byte_unit)
       value = value(:llen)//byte_unit
       slen = llen + 2
       RETURN

* SESSION_DATE
 2000	value = today_date
	slen = 9
	RETURN

* SESSION_TIME
 2100	value = today_time
	slen = 5
	RETURN

* SESSION_PID
 2200	CONTINUE
	i1 = GETPID()
	count = i1
	value =  TM_FMT(count, 0, 10, slen)
	RETURN


* DELTA_CPU
 2300	CONTINUE
c        CALL DTIME(TArray)
	CALL CPU_TIME(cputime_now)
        dtime_res = cputime_now - cpu_last
	cpu_last = cputime_now
	value = ' '
	value = TM_FMT(dtime_res, 6, 8, slen)
	RETURN

* CLOCK_SECS
 2400	CALL SYSTEM_CLOCK(icount, irate, imax)
        clock_secs = FLOAT(icount-clock_start_count)/FLOAT(irate)
	IF (clock_secs .LT. 0) THEN
           CALL WARN('Evaluating CLOCK_SECS, call to '//
     .     'SYSTEM_CLOCK. Count has exceeded its max and reset.')
           CALL WARN( 'This value of CLOCK_SECS is invalid. '//
     .     'Resetting to new initial value.')
           clock_secs = 0.
	   clock_start_count = FLOAT(icount)/FLOAT(irate)
	ENDIF
	value = ' '
	value = TM_FMT_TRIM(clock_secs, -1, 8, slen)
	RETURN

* CURRENT_DATE
 2500	CONTINUE

#ifdef AIX_XLF
	CALL AIX_DATE( current_date )
#elif F90_DATE_TIME
	CALL FDATE(current_date)
#else
	CALL GET_DATE_AND_TIME (current_date, current_time)
#endif
        value = current_date
	slen = 9
	RETURN

* CURRENT_TIME
 2600	CONTINUE

#ifdef AIX_XLF
	CALL AIX_TIME( current_time )
#elif F90_DATE_TIME
	CALL FTIME(current_time)
#else
	CALL GET_DATE_AND_TIME (current_date, current_time)  ! doesnt get seconds

	CALL Date_and_Time(current_date, current_time, Zone, itimes)
        WRITE (current_time,1000) itimes(5), itimes(6), itimes(7)
 1000   FORMAT (2(I2.2,":"), I2.2)

#endif
	value = current_time
	slen = 8
	RETURN

* N_OPEN_DSETS
 2700	CONTINUE
 
	count = 0.
	DO iset = 1, maxdsets
	   IF ( ds_name(iset) .NE. char_init2048) count = count + 1.
	ENDDO

	value =  TM_FMT(count, 0, 10, slen)
	RETURN

* PROGRAM_NAME
 2800   CONTINUE

        value = 'Ferret'
        slen = 6
        RETURN

* PEAK_MEMORY
 2900	value = LEFINT8(peak_mem,slen)
        RETURN

* SPAWN_OK
 3000   IF (IS_SECURE()) THEN
           rstatus = 0.
        ELSEIF (spawn_status .EQ. 0.) THEN
           rstatus = 1.
	ELSE
	   rstatus = 0.
	ENDIF
	value = TM_FMT(rstatus, 0, 10, slen)
        RETURN

* SPAWN_STATUS
 3100   IF (IS_SECURE()) THEN
	   value = 'secure: spawn not allowed'
	   slen = 25
        ELSE
           rstatus = spawn_status
           value = TM_FMT(rstatus, 0, 10, slen)
	ENDIf
        RETURN

	END

	SUBROUTINE LINE_STYLE( symbol, sym_size, skipsym, 
     .			       color, color1, use_line, do_dash, 
     .			       dashstyle, line_number, so_far )

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* In Ferret the concept of the PLOT+ PEN command is generalized to combine
* line type (dashing), color and symbol into this single call
* Line number ipen will always be associated with line style ipen.
* Prior to this call colors and line types have already been combined via GKS
* bundles to define 6 distinct line styles as bundle indices 1-6
* Symbols are now added to extend this number to 6x17=102
* 1/94: number of line bundles is now num_fancy_lines.  All of these are
* used if /LINES is specified without /SYMBOLS

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V200:	  1/2/90
* 	 2/21/90 - changed line style order so all dash patterns are used for
*		   each symbol choice, then the next symbol ...
* 	 5/18/90 - added args symbol and color to force styling of lines
* Unix/RISC port - 10/91 - /symb"/noline" -> successive line w/ new symbol
* V230:  7/23/92 - when /LINE_STYLE is given /SYMBOLS must default to OFF
* V301:  1/27/94 - when /LINE_STYLE is given w/out /SYMBOL use num_fancy_lines
* V510 *sh* 3/00 - added args use_line and sym_size to suport PLOT/COLOR=/SIZE=
* V530 *acm 5/01 - added args do_dash and dashstyle for 
*		   PLOT/DASH[=(dn1,up1,dn2,up2)]
* V580 *acm*11/04  Allow thickness to be set when cycling through colors automatically.
*                  When color = -11  then thin line, color=-21 then thick=2, when 
*                  color=-31 then thick=3
* V590 *acm* 5/06  settable number of line colors, no longer hard-wired to 6 colors.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* v683 *acm* 11/12 Put sym_so_far into common - previously SAVEd here, no longer working.
* V6.85 *acm* 9/13 New PLOT/COLOR w/o argument for all-color line plot
* V698  4/16 *acm* New PLOT/SKIP=

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'slash.parm'
	include	'plot_setup.parm'
	include	'xplot_setup.cmn'
        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'lines_inc.decl'
        include 'LINES.INC'
	include 'xprog_state.cmn'
        include 'ppl_dash_save.cmn'

* calling argument declarations
	LOGICAL use_line
	INTEGER symbol, skipsym, color, color1, line_number, so_far, do_dash
	REAL	sym_size, dashstyle(*)

* internal variable declarations
        LOGICAL unique_symbol, symbol_only1, select_lines
	INTEGER	style, ppl_draw_line, i, ltyp

* internal parameter declarations
	INTEGER	num_line, ncolors, num_linebundles

* internal variable declarations
	INTEGER	ityp, imrk, style0, sym(num_sym)
        LOGICAL setdash
	DATA	sym/1,3,17,19,21,23,25,27,29,31,33,35,39,41,43,47,51/

* initialize

* num_plain colors was in common as 6, now use line_colors from mode setting
* Use num_linebundles in place of hardwired num_fancy_lines

        ncolors = mode_arg(pmode_linecolors,1)
        num_linebundles = 3 * ncolors
        num_line = ncolors*num_sym

        IF ( so_far .EQ. 1 ) sym_so_far = 0      ! first line on screen
* ... each line needs a new symbol for /SYMBOL or /LINE=n/SYMBOL
        unique_symbol = ( symbol.EQ.qual_on
     .             .AND. .NOT.use_line )
        symbol_only1  = symbol.GT.0 .AND. .NOT.use_line
	select_lines = symbol.EQ.qual_off .AND. use_line

* respond to qualifiers that force actions
	IF ( use_line ) THEN
	   ppl_draw_line = 1	! draw the line by default
	ELSE
	   ppl_draw_line = 3	! PPL LINE command: mark points only
	ENDIF
	IF ( symbol .EQ. qual_on ) THEN
* ... bypass plain lines
	   style = so_far + ncolors
	ELSE
	   style = so_far		! default: no qualifiers
	ENDIF

* select line type and symbols
        IF ( unique_symbol .OR. symbol_only1 ) THEN 
           IF (color.GT.0) THEN
	      ityp = color		! turn on symbol color 3/00
	   ELSE
	      ityp = 1
	   ENDIF
           imrk = MOD(sym_so_far,num_sym) + 1
           sym_so_far = sym_so_far + 1
	ELSEIF ( select_lines .AND. style .LE. num_linebundles ) THEN  ! 1/94
	   ityp = style
	   imrk = 0
	ELSEIF ( style .LE. ncolors ) THEN
	   ityp = style
	   imrk = 0
	ELSEIF ( style .LE. num_line ) THEN
	   style0 = (style-ncolors) - 1
	   ityp  = MOD(style0,ncolors) + 1
	   imrk  = MOD(style0/ncolors,num_sym) + 1
           sym_so_far = MAX( sym_so_far, imrk )    ! ... *sh* 10/91
	ELSE
	   ityp = 1
	   imrk = 0
	ENDIF	   
* replace selections with forced values if supplied
	IF ( symbol    .GT. 0 ) THEN
	  imrk = symbol
	ELSEIF ( symbol .EQ. qual_off ) THEN
          imrk = 0                       ! 7/92
	ELSEIF ( imrk .NE. 0 ) THEN
	  imrk = sym(imrk)
	ENDIF
	IF ( color .GT. 0 ) THEN
           ityp = color
           ltyp = color
        ELSE
           IF (color .EQ. -21) THEN
              ltyp = ityp + ncolors
           ELSE IF (color .EQ. -31) THEN
              ltyp = ityp + ncolors*2
           ELSE
              ltyp = ityp
           ENDIF
	   ltyp = ltyp  + color1 - 1

        ENDIF

	WRITE ( ppl_buff, 3000 ) line_number, ltyp
 3000	FORMAT('PEN ',2I4)
	CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )

	IF ( imrk .GT. 0 ) THEN
* ... "LINE 8 3 1" - symbol number 3 on line 8
	   WRITE ( ppl_buff, 3100 ) line_number, imrk, ppl_draw_line
 3100	   FORMAT ('LINE ',3I4)
	ELSE
* ... "LINE 4 1 0" - no symbols on line 4
	   WRITE ( ppl_buff, 3200 ) line_number
 3200	   FORMAT ('LINE ',I4,' 1 0')
	ENDIF
	CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
	IF ( imrk .GT. 0 ) THEN
* ... "MARKH 8 0.08 5" - symbol size 0.08 on line 8, decimate by 5
	   WRITE ( ppl_buff, 3300 ) line_number, sym_size, skipsym
 3300	   FORMAT ('MARKH ',I4,F8.3, i4)
	   CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
	ENDIF

*  User-requested dash overrides automatic selections
        dash_changed(line_number) = .FALSE.
        linenum_save = 0
        IF (do_dash .EQ. 1) THEN
	   ityp = 4

           dash_changed(line_number) = .TRUE.
           dashsave(line_number,1) = dn1(line_number)
           dashsave(line_number,2) = up1(line_number)
           dashsave(line_number,3) = dn2(line_number)
           dashsave(line_number,4) = up2(line_number)
           linenum_save = line_number

* communicate this to PLOT+
           setdash = .FALSE.
           DO 100 i = 1, 4
              IF (dashstyle(i) .NE. 0.) setdash = .TRUE.
  100	   CONTINUE
           IF (setdash) THEN
              WRITE (ppl_buff, 3400) line_number, ityp, (dashstyle(i),i=1,4)
 3400         FORMAT ('LINE ', I4, ' 0 ', I4, ' 0 0 ',4F7.3)
           ELSE 
              WRITE (ppl_buff, 3500) line_number, ityp
 3500         FORMAT ('LINE ', I4, ' 0 ', I4)
           ENDIF

	   CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
        ENDIF


	RETURN
	END

      SUBROUTINE AXISL(XLOW1,XHIGH1,XORG1,YLOW1,YHIGH1,YORG1,XTIC1,
     * YTIC1,SMXTC1,SMYTC1,LINTX,LINTY,XUNIT1,YUNIT1,CSIZE,ICODE)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)axisl.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C   SUBROUTINE AXISL WILL DRAW AND LABEL A SET OF AXES.
C   THE PARAMETERS ARE DEFINED AS FOLLOWS:
C   XLOW1,XLOW   -LOW X VALUE IN USER UNITS.
C   XHIGH1,XHIGH -HIGH X VALUE IN USER UNITS.
C   XORG1,XORG   -ORIGIN OF X AXIS (I.E. THE POINT AT WHICH THE Y
C                 AXIS WILL MEET OR CROSS THE X AXIS).
C   YLOW1,YLOW   -LOW Y VALUE IN USER UNITS.
C   YHIGH1,YHIGH -HIGH Y VALUE IN USER UNITS.
C   YORG1,YORG   -ORIGIN OF Y AXIS (I.E. THE POINT AT WHICH THE X
C                 AXIS WILL MEET OR CROSS THE Y AXIS).
C   XTIC1,XTIC   -THE DISTANCE IN USER UNITS BETWEEN MAJOR TICK MARKS
C                 ON THE X AXIS.
C   YTIC1,YTIC   -THE DISTANCE IN USER UNITS BETWEEN MAJOR TICK MARKS
C                 ON THE Y AXIS.
C   SMXTC1,SMXTIC-NUMBER OF MINOR TICKS BETWEEN MAJOR TICKS ON X AXIS.
C   SMYTC1,SMYTIC-NUMBER OF MINOR TICKS BETWEEN MAJOR TICKS ON Y AXIS.
C   LINTX        -LABELING INTERVAL ON THE X AXIS.
C                 IF LINTX = N, LABEL PLACED EVERY N-TH TICK MARK.
C                 IF LINTX = 0, NO LABELS WILL BE DRAWN.
C                 IF LINTX IS NEGATIVE, ONLY END POINTS WILL BE LABELED.
C   LINTY        -LABELING INTERVAL ON THE Y AXIS.
C   XUNIT1,XUNIT -FACTOR TO BE DIVIDED INTO LABELING VALUE ON X AXIS.
C   YUNIT1,YUNIT -FACTOR TO BE DIVIDED INTO LABELING VALUE ON Y AXIS.
C   CSIZE        -THE SIZE OF THE CHARACTERS FOR THE LABELS.
C   ICODE        -THE TYPE OF AXIS TO BE DRAWN
C                 0 = STANDARD X-Y AXIS.
C                 1 = SEMI LOG Y AXIS (X IS LINEAR).
C                 2 = SEMI LOG X AXIS (Y IS LINEAR).
C                 3 = LOG LOG AXIS.
C
C   OTHER VARIABLES USED IN THE ROUTINE ARE DEFINED AS:
C   AINC  -TEMPORARY VARIABLE USED TO COMPUTE LOG SCALE INCREMENTS.
C   BINC  -TEMPORARY VARIABLE USED TO COMPUTE LOG SCALE INCREMENTS.
C   CFLAG -FLAG INDICATING THAT THE LOG INCREMENTS HAVE BEEN COMPUTED.
C   CXSIZE-THE SIZE OF THE CHARACTERS FOR THE LABELS IN EQUIVALENT USER
C          UNITS ON THE X AXIS.
C   CYSIZE-THE SIZE OF THE CHARACTERS FOR THE LABELS IN EQUIVALENT USER
C          UNITS ON THE Y AXIS.
C   INC   -ARRAY OF 9 USED TO STORE THE LOG SCALE INCREMENTS.
C   INDEX -INDEX VARIABLE USED TO COMPARE TO LINTX (OR LINTY) TO
C          SEE THAT THE CORRECT LABELING INTERVAL IS USED.
C   LOGX  -FLAG INDICATING THAT THE X AXIS IS A LOG SCALE (LOGX=1).
C   LOGY  -FLAG INDICATING THAT THE Y AXIS IS A LOG SCALE (LOGY=1).
C   SXFLAG-FLAG WHICH INDICATES THAT THE X LOG AXIS HAS BEEN STARTED.
C          AFTER THE FIRST PART OF THE LOG AXIS IS DRAWN, ONLY WHOLE
C          CYCLES ARE DRAWN, EXCEPT MAYBE A PARTIAL CYCLE AT THE END.
C   SYFLAG-FLAG WHICH INDICATES THAT THE Y LOG AXIS HAS BEEN STARTED.
C          AFTER THE FIRST PART OF THE LOG AXIS IS DRAWN, ONLY WHOLE
C          CYCLES ARE DRAWN, EXCEPT MAYBE A PARTIAL CYCLE AT THE END.
C   TEMP  -TEMPORARY VARIABLE USED SEVERAL TIMES.
C   XHI   -USED TO DRAW X LOG AXIS.  EQUALS ALOG10 OF XHIGH.
C   XINC  -THE DISTANCE IN USER UNITS BETWEEN MINOR TICK MARKS ON
C          THE X AXIS (XTIC/(SMXTIC+1)).
C   XLAB  -CONTAINS THE BCD REPRESENTATION OF THE X LABEL BEING PASSED
C          TO SYMBOL.
C   XOFF  -THE X OFFSET OF LABELS ON THE Y AXIS.
C   XPOS  -THE CURRENT X POSITION, USUALLY EQUALS XPT MINUS A FRACTION
C          OF AN INCH (USED FOR LABELING).
C   XPT   -THE CURRENT X VALUE, USED FOR MANY THINGS.
C   XPTS  -TEMPORARY VARIABLE USED IN LABELING, EQUALS XPT/XUNIT.
C   YHI   -USED TO DRAW Y LOG AXIS.  EQUALS ALOG10 OF YHIGH.
C   YINC  -THE DISTANCE IN USER UNITS BETWEEN MINOR TICK MARKS ON
C          THE Y AXIS (YTIC/(SMYTIC+1)).
C   YLAB  -CONTAINS THE BCD REPRESENTATION OF THE Y LABEL BEING PASSED
C          TO SYMBOL.
C   YOFF  -THE Y OFFSET OF LABELS ON THE X AXIS.
C   YPOS  -THE CURRENT Y POSITION, USUALLY EQUALS YPT MINUS A FRACTION
C          OF AN INCH (USED FOR LABELING).
C   YPT   -THE CURRENT Y VALUE, USED FOR MANY THINGS.
C   YPTS  -TEMPORARY VARIABLE USED IN LABELING, EQUALS YPT/YUNIT.
C
      REAL INC(9)
      INTEGER SXFLAG,SYFLAG,CFLAG,SMXTIC,SMYTIC,SMXTC1,SMYTC1
C
	CHARACTER IFMT*6,XLAB*8,YLAB*8
#ifdef unix
	include 'PLTCOM.DAT'
#else
	include 'pplinc:PLTCOM.DAT'
#endif
C
C******************************************************************
C   AXISL MAKES SEVERAL CHECKS ON THE PARAMETERS TO MAKE SURE THAT
C   THEY ARE VALID.   THEY ARE ALTERED INTERNALLY IF NECESSARY.
C******************************************************************
C
C   TRANSFER THE PARAMETERS TO NEW VARIABLES.
C
      XLOW=XLOW1
      XHIGH=XHIGH1
      XORG=XORG1
      YLOW=YLOW1
      YHIGH=YHIGH1
      YORG=YORG1
      XTIC=ABS(XTIC1)
      YTIC=ABS(YTIC1)
      SMXTIC=SMXTC1
      SMYTIC=SMYTC1
      XUNIT=XUNIT1
      YUNIT=YUNIT1
C
C   GET THE ADJUSTED CHARACTER SIZES.
C
      CXSIZE=CSIZE*FACTOR/XSCALE
      CYSIZE=CSIZE*FACTOR/YSCALE
C
C   CHECK THE CALLING PARAMETERS.  MAKE SURE THEY ARE LEGAL.
C
      IF(SMXTIC .LT. 0) SMXTIC=0
      IF(SMYTIC .LT. 0) SMYTIC=0
      IF(XUNIT .EQ. 0.) XUNIT=1.
      IF(YUNIT .EQ. 0.) YUNIT=1.
C
C   IF THE LOW IS BIGGER THAN THE HIGH, THEN CHANGE THEM.
C
      IF(XLOW .LE. XHIGH) GO TO 10
      TEMP=XLOW
      XLOW=XHIGH
      XHIGH=TEMP
10    IF(YLOW .LE. YHIGH) GO TO 20
      TEMP=YLOW
      YLOW=YHIGH
      YHIGH=TEMP
C
C   MAKE SURE THE ORIGIN IS BETWEEN THE HIGH AND THE LOW.
C
20    IF(XORG .LT. XLOW) XORG=XLOW
      IF(XORG .GT. XHIGH) XORG=XHIGH
      IF(YORG .LT. YLOW) YORG=YLOW
      IF(YORG .GT. YHIGH) YORG=YHIGH
C
C   SET SOME FLAGS
C
      SXFLAG=0
      SYFLAG=0
      CFLAG=0
C
C   SEE IF THE X OR Y AXES ARE LOG SCALES. IF SO, SET A FLAG.
C
      LOGX=0
      LOGY=0
      IF(ICODE.EQ.2 .OR. ICODE.EQ.3) LOGX=1
      IF(ICODE.EQ.1 .OR. ICODE.EQ.3) LOGY=1
C
C   COMPUTE DISTANCE BETWEEN MINOR TICK MARKS
C
      XINC=XTIC
      YINC=YTIC
      IF(SMXTIC .NE. 0) XINC=XTIC/FLOAT(SMXTIC+1)
      IF(SMYTIC .NE. 0) YINC=YTIC/FLOAT(SMYTIC+1)
C
C   SET VECTRS MODE.
C
      CALL VECTRS
      YOFF=CYSIZE+70.0/YSCALE
      IF(LOGX .EQ. 1) GO TO 200
C
C******************************************************************
C   DRAW AND LABEL LINEAR X AXIS
C******************************************************************
C
      IF(LINTX .EQ. 0) GO TO 30
C
C   IF THE LABEL FITS INTO AN F8.2 FORMAT, USE IT. OTHERWISE USE E8.2
C
      IFMT='(F8.2)'
      IF(XHIGH.GE.99999.995 .OR. XLOW.LE.-9999.995) IFMT='(E8.2)'
      XPT=XTIC*FLOAT(LINTX)
      IF(XPT .LE. 0.) XPT=XHIGH-XLOW
      IF(XPT .LT. 0.00995) IFMT='(E8.2)'
30    YPT=YORG
      IF(LOGY.EQ.1) YPT=ALOG10(YPT)
      YPOS=YORG-YOFF
      IF(LOGY.EQ.1) YPOS=ALOG10(YORG)-YOFF
      XPT=XLOW
      CALL PLOT(XPT,YPT,0,0)
      CALL PLOT(XPT,YPT,1,8)
      IF(LINTX .EQ. 0) GO TO 60
40    XPTS=XPT/XUNIT
	WRITE(XLAB,IFMT)XPTS
      XPOS=XPT-5.*CXSIZE
      CALL SYMBOL(XPOS,YPOS,0.,CSIZE,8,XLAB)
      CALL PLOT(XPT,YPT,0,0)
60    IF(XTIC .EQ. 0.) GO TO 90
      INDEX=0
      CALL PLOT(XPT,YPT,0,0)
C
C   DO THE SMALL TICK MARKS, IF ANY.
C
70    IF(SMXTIC .EQ. 0) GO TO 85
      DO 80 I=1,SMXTIC
      XPT=XPT+XINC
      IF(XPT .GT. XHIGH) GO TO 90
80    CALL PLOT(XPT,YPT,1,7)
C
C   NOW DO THE LARGE TICK MARK.
C
85    XPT=XPT+XINC
      IF(XPT .GT. XHIGH) GO TO 90
      CALL PLOT(XPT,YPT,1,8)
C
C   SEE IF IT IS TIME TO LABEL.
C
      IF(LINTX .LE. 0) GO TO 70
      INDEX=INDEX+1
      IF(INDEX .LT. LINTX) GO TO 70
      GO TO 40
C
C   DRAW AND LABEL THE LAST TICK MARK.
C
90    XPT=XHIGH
      CALL PLOT(XPT,YPT,1,8)
      IF(LINTX .GE. 0) GO TO 300
      XPTS=XPT/XUNIT
      GO TO 270
C
C******************************************************************
C   DRAW AND LABEL LOG X AXIS
C******************************************************************
C
C
C   COMPUTE THE INCREMENTS FOR A LOG AXIS.
C
200   AINC=1.
      BINC=2.
      DO 205 I=1,9
      INC(I)=ALOG10(BINC)-ALOG10(AINC)
      AINC=AINC+1.
205   BINC=BINC+1.
      CFLAG=1
      YPT=YORG
      IF(LOGY.EQ.1) YPT=ALOG10(YPT)
      YPOS=YORG-YOFF
      IF(LOGY.EQ.1) YPOS=ALOG10(YORG)-YOFF
      XHI=ALOG10(XHIGH)
      XPT=ALOG10(XLOW)
      CALL PLOT(XPT,YPT,0,0)
      CALL PLOT(XPT,YPT,1,8)
      IF(LINTX .GE. 0) GO TO 220
210   XPTS=(10.**XPT)/XUNIT
C
C   IF THE LABEL FITS INTO AN F8.2 FORMAT, USE IT. OTHERWISE USE E8.2
C
      IFMT='(F8.2)'
      IF(XPTS.GE.99999.995 .OR. XPTS.LT.0.00995) IFMT='(E8.2)'
	WRITE(XLAB,IFMT)XPTS
      XPOS=XPT-5.*CXSIZE
      CALL SYMBOL(XPOS,YPOS,0.,CSIZE,8,XLAB)
      CALL PLOT(XPT,YPT,0,0)
220   IF(XTIC .EQ. 0.) GO TO 260
      INDEX=0
      CALL PLOT(XPT,YPT,0,0)
C
C   WE START THE LOG AXIS AT XPT WHICH CURRENTLY EQUALS ALOG10(XLOW).
C   DRAW AND PUT TICK MARKS ON UNTIL THE FIRST CYCLE IS REACHED (...,
C   0.01,0.1,1.,10.,100.,...).  LABEL THIS FIRST CYCLE AND SET A
C   FLAG INDICATING THE AXIS HAS BEEN STARTED (SXFLAG=1).  THE REST
C   OF THE AXIS WILL BE DRAWN WITH WHOLE LOG CYCLES, EXCEPT OF COURSE
C   THE END WHICH IS FROM THE LAST WHOLE CYCLE UNTIL ALOG10(XHIGH)
C
      IF(SXFLAG .EQ. 1) GO TO 240
      TEMP=IFIX(XPT)
      IF(TEMP .GT. XPT) TEMP=TEMP-1.
      DO 230 I=1,8
      TEMP=TEMP+INC(I)
      IF(TEMP .LT. XPT) GO TO 230
      IF(TEMP .GE. XHI) GO TO 260
      CALL PLOT(TEMP,YPT,1,7)
230   CONTINUE
      XPT=TEMP
      SXFLAG=1
      GO TO 255
C
C   DO THE MINOR TICK MARKS.
C
240   DO 250 I=1,8
      XPT=XPT+INC(I)
      IF(XPT .GT. XHI) GO TO 260
250   CALL PLOT(XPT,YPT,1,7)
C
C   NOW THE MAJOR TICK MARK.
C
255   XPT=XPT+INC(9)
      IF(XPT .GT. XHI) GO TO 260
      CALL PLOT(XPT,YPT,1,8)
C
C   SEE IF IT IS TIME TO LABEL.
C
      IF(LINTX .LE. 0) GO TO 240
      INDEX=INDEX+1
      IF(INDEX .LT. LINTX) GO TO 240
      GO TO 210
C
C   DRAW AND LABEL THE LAST TICK MARK.
C
260   XPT=XHI
      CALL PLOT(XPT,YPT,1,8)
      IF(LINTX .GE. 0) GO TO 300
      XPTS=(10.**XPT)/XUNIT
C
C   IF THE LABEL FITS INTO AN F8.2 FORMAT, USE IT. OTHERWISE USE E8.2
C
      IFMT='(F8.2)'
      IF(XPTS.GE.99999.995 .OR. XPTS.LT.0.00995) IFMT='(E8.2)'
270	WRITE(XLAB,IFMT)XPTS
      XPOS=XPT-5.*CXSIZE
      CALL SYMBOL(XPOS,YPOS,0.,CSIZE,8,XLAB)
300   XOFF=8.0*CXSIZE+100.0/XSCALE
      IF(LOGY .EQ. 1) GO TO 400
C
C******************************************************************
C   DRAW AND LABEL LINEAR Y AXIS
C******************************************************************
C
      IF(LINTY .EQ. 0) GO TO 305
C
C   IF THE LABEL FITS INTO AN F8.2 FORMAT, USE IT. OTHERWISE USE E8.2
C
      IFMT='(F8.2)'
      IF(YHIGH.GE.99999.995 .OR. YLOW.LE.-9999.995) IFMT='(E8.2)'
      YPT=YTIC*FLOAT(LINTY)
      IF(YPT .LE. 0.) YPT=YHIGH-YLOW
      IF(YPT .LT. 0.00995) IFMT='(E8.2)'
305   XPT=XORG
      IF(LOGX.EQ.1) XPT=ALOG10(XPT)
      XPOS=XORG-XOFF
      IF(LOGX.EQ.1) XPOS=ALOG10(XORG)-XOFF
      YPT=YLOW
      CALL PLOT(XPT,YPT,0,0)
      CALL PLOT(XPT,YPT,1,6)
      IF(LINTY .EQ. 0) GO TO 320
310   YPTS=YPT/YUNIT
	WRITE(YLAB,IFMT)YPTS
      YPOS=YPT-0.5*CYSIZE
      CALL SYMBOL(XPOS,YPOS,0.,CSIZE,8,YLAB)
      CALL PLOT(XPT,YPT,0,0)
320   IF(YTIC .EQ. 0.) GO TO 350
      INDEX=0
      CALL PLOT(XPT,YPT,0,0)
C
C   DO THE SMALL TICK MARKS, IF ANY.
C
330   IF(SMYTIC .EQ. 0) GO TO 345
      DO 340 I=1,SMYTIC
      YPT=YPT+YINC
      IF(YPT .GT. YHIGH) GO TO 350
340   CALL PLOT(XPT,YPT,1,5)
C
C   NOW DO THE LARGE TICK MARK.
C
345   YPT=YPT+YINC
      IF(YPT .GT. YHIGH) GO TO 350
      CALL PLOT(XPT,YPT,1,6)
C
C   SEE IF IT IS TIME TO LABEL.
C
      IF(LINTY .LE. 0) GO TO 330
      INDEX=INDEX+1
      IF(INDEX .LT. LINTY) GO TO 330
      GO TO 310
C
C   DRAW AND LABEL THE LAST TICK MARK.
C
350   YPT=YHIGH
      CALL PLOT(XPT,YPT,1,6)
      IF(LINTY .GE. 0) GO TO 500
      YPTS=YPT/YUNIT
      GO TO 470
C
C******************************************************************
C   DRAW AND LABEL LOG Y AXIS
C******************************************************************
C
C
C   COMPUTE THE INCREMENTS FOR A LOG AXIS, IF NECESSARY.
C
400   IF(CFLAG.EQ.1) GO TO 406
      AINC=1.
      BINC=2.
      DO 405 I=1,9
      INC(I)=ALOG10(BINC)-ALOG10(AINC)
      AINC=AINC+1.
405   BINC=BINC+1.
406   XPT=XORG
      IF(LOGX.EQ.1) XPT=ALOG10(XPT)
      XPOS=XORG-XOFF
      IF(LOGX.EQ.1) XPOS=ALOG10(XORG)-XOFF
      YHI=ALOG10(YHIGH)
      YPT=ALOG10(YLOW)
      CALL PLOT(XPT,YPT,0,0)
      CALL PLOT(XPT,YPT,1,6)
      IF(LINTY .GE. 0) GO TO 420
410   YPTS=(10.**YPT)/YUNIT
C
C   IF THE LABEL FITS INTO AN F8.2 FORMAT, USE IT. OTHERWISE USE E8.2
C
      IFMT='(F8.2)'
      IF(YPTS.GE.99999.995 .OR. YPTS.LT.0.00995) IFMT='(E8.2)'
	WRITE(YLAB,IFMT)YPTS
      YPOS=YPT-0.5*CYSIZE
      CALL SYMBOL(XPOS,YPOS,0.,CSIZE,8,YLAB)
      CALL PLOT(XPT,YPT,0,0)
420   IF(YTIC .EQ. 0.) GO TO 460
      INDEX=0
      CALL PLOT(XPT,YPT,0,0)
C
C   WE START THE LOG AXIS AT YPT WHICH CURRENTLY EQUALS ALOG10(YLOW).
C   DRAW AND PUT TICK MARKS ON UNTIL THE FIRST CYCLE IS REACHED (...,
C   0.01,0.1,1.,10.,100.,...).  LABEL THIS FIRST CYCLE AND SET A
C   FLAG INDICATING THE AXIS HAS BEEN STARTED (SYFLAG=1).  THE REST
C   OF THE AXIS WILL BE DRAWN WITH WHOLE LOG CYCLES, EXCEPT OF COURSE
C   THE END WHICH IS FROM THE LAST WHOLE CYCLE UNTIL ALOG10(YHIGH)
C
      IF(SYFLAG .EQ. 1) GO TO 440
      TEMP=IFIX(YPT)
      IF(TEMP .GT. YPT) TEMP=TEMP-1.
      DO 430 I=1,8
      TEMP=TEMP+INC(I)
      IF(TEMP .LT. YPT) GO TO 430
      IF(TEMP .GE. YHI) GO TO 460
      CALL PLOT(XPT,TEMP,1,5)
430   CONTINUE
      YPT=TEMP
      SYFLAG=1
      GO TO 455
C
C   DO THE MINOR TICK MARKS.
C
440   DO 450 I=1,8
      YPT=YPT+INC(I)
      IF(YPT .GT. YHI) GO TO 460
450   CALL PLOT(XPT,YPT,1,5)
C
C   NOW THE MAJOR TICK MARK.
C
455   YPT=YPT+INC(9)
      IF(YPT .GT. YHI) GO TO 460
      CALL PLOT(XPT,YPT,1,6)
C
C   SEE IF IT IS TIME TO LABEL.
C
      IF(LINTY .LE. 0) GO TO 440
      INDEX=INDEX+1
      IF(INDEX .LT. LINTY) GO TO 440
      GO TO 410
C
C   DRAW AND LABEL THE LAST TICK MARK.
C
460   YPT=YHI
      CALL PLOT(XPT,YPT,1,6)
      IF(LINTY .GE. 0) GO TO 500
      YPTS=(10.**YPT)/YUNIT
C
C   IF THE LABEL FITS INTO AN F8.2 FORMAT, USE IT. OTHERWISE USE E8.2
C
      IFMT='(F8.2)'
      IF(YPTS.GE.99999.995 .OR. YPTS.LT.0.00995) IFMT='(E8.2)'
470	WRITE(YLAB,IFMT)YPTS
      YPOS=YPT-0.5*CYSIZE
      CALL SYMBOL(XPOS,YPOS,0.,CSIZE,8,YLAB)
C
C   MOVE TO THE ORIGIN.
C
500   XPT=XORG
      IF(LOGX.EQ.1) XPT=ALOG10(XORG)
      YPT=YORG
      IF(LOGY.EQ.1) YPT=ALOG10(YORG)
      CALL PLOT(XPT,YPT,0,0)
      RETURN
      END

      SUBROUTINE GRID(XALOW,XAHIGH,XAORG,YALOW,YAHIGH,YAORG,XAGRID,
     * YAGRID,NATICX,NATICY)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)grid.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     CALL GRID(XLOW,XHIGH,XORG,YLOW,YHIGH,YORG,XGRID,YGRID,NSTICX,
C    * NSTICY)
C
C     THIS SUBROUTINE DRAWS A SET OF X AND Y AXES IN THE PLOTTING
C     AREA.  BOTH GRID LINES AND SMALL TICK MARKS MAY BE DRAWN ON
C     THE AXES AT REGULAR INTERVALS.
C
C     THE VARIOUS PARAMETERS AND THEIR DEFINITIONS ARE LISTED
C     BELOW:
C        XLOW   - MINIMUM VALUE OF THE X-AXIS IN USER'S UNITS.
C        XHIGH  - MAXIMUM VALUE OF THE X-AXIS IN USER'S UNITS.
C        XORG   - VALUE OF X AT WHICH THE Y-AXIS CROSSES THE
C                 X-AXIS IN USER'S UNITS.
C        YLOW   - MINIMUM VALUE OF THE Y-AXIS IN USER'S UNITS.
C        YHIGH  - MAXIMUM VALUE OF THE Y-AXIS IN USER'S UNITS.
C        YORG   - VALUE OF Y AT WHICH THE X-AXIS CROSSES THE
C                 Y-AXIS IN USER'S UNITS.
C        XGRID  - DISTANCE BETWEEN GRID LINES ON THE X-AXIS IN
C                 USER'S UNITS.
C        YGRID  - DISTANCE BETWEEN GRID LINES ON THE Y-AXIS IN
C                 USER'S UNITS.
C        NSTICX - NUMBER OF SMALL TICK MARKS BETWEEN EACH OF THE
C                 GRID LINES ON THE X-AXIS.
C        NSTICY - NUMBER OF SMALL TICK MARKS BETWEEN EACH OF THE
C                 GRID LINES ON THE Y-AXIS.
C
C     GRID MAKES SEVERAL CHECKS ON THE PARAMETERS TO MAKE SURE
C     THAT THEY ARE VALID.  THEY ARE ALTERED INTERNALLY IF NECES-
C     SARY.
C
C
C     TRANSFER THE PARAMETERS TO NEW VARIABLES.
C
      XLOW = XALOW
      XHIGH = XAHIGH
      XORG = XAORG
      YLOW = YALOW
      YHIGH = YAHIGH
      YORG = YAORG
      XGRID = ABS(XAGRID)
      YGRID = ABS(YAGRID)
      NSTICX = NATICX
      NSTICY = NATICY
C
C     CHECK THE PARAMETERS TO MAKE SURE THAT THEY ARE VALID.
C
      IF(XLOW .GT. XHIGH)THEN
        TEMP = XLOW
        XLOW = XHIGH
        XHIGH = TEMP
      ENDIF
      IF(YLOW .GT. YHIGH)THEN
        TEMP = YLOW
        YLOW = YHIGH
        YHIGH = YLOW
      ENDIF
      IF(XORG .LT. XLOW)XORG = XLOW
      IF(YORG .LT. YLOW)YORG = YLOW
      IF(XORG .GT. XHIGH)XORG = XHIGH
      IF(YORG .GT. YHIGH)YORG = YHIGH
      IF(NSTICX .LT. 0)NSTICX = 0
      IF(NSTICY .LT. 0)NSTICY = 0
C
C     SET VECTRS MODE.
C
      CALL VECTRS
C
C     START AT THE ORIGIN.
C
      X = XORG
      Y = YORG
      CALL PLOT(X,Y,0,0)
C
C     IF THERE ARE NO GRID LINES ON THE Y-AXIS, DRAW THE ENTIRE
C     AXIS.
C
      IF(YGRID .EQ. 0.0)THEN
        CALL PLOT(X,YLOW,0,0)
        CALL PLOT(X,YHIGH,1,0)
        CALL PLOT(X,Y,0,0)
      ELSE
C
        SMY = YGRID / FLOAT(NSTICY + 1)
C
        IF(YLOW .LT. YORG)THEN
C
C     DRAW THE NEGATIVE Y-AXIS.
C
          IF(NSTICY .EQ. 0)GO TO 30
   10     DO 20 J=1,NSTICY
          Y = Y - SMY
          IF(Y .LT. YLOW)GO TO 30
   20     CALL PLOT(X,Y,1,5)
          Y = Y - SMY
          IF(Y .GT. YLOW)GO TO 10
   30     CALL PLOT(X,YLOW,1,0)
          Y = YORG
C
C     DRAW THE GRID LINES ON THE NEGATIVE Y-AXIS.
C
   40     Y = Y - YGRID
          IF(Y .LT. YLOW)GO TO 50
          CALL PLOT(XLOW,Y,0,0)
          CALL PLOT(XHIGH,Y,1,0)
          Y = Y - YGRID
          IF(Y .LT. YLOW)GO TO 50
          CALL PLOT(XHIGH,Y,0,0)
          CALL PLOT(XLOW,Y,1,0)
          GO TO 40
   50     Y = YORG
          CALL PLOT(X,Y,0,0)
        ENDIF
C
        IF(YHIGH .GT. YORG)THEN
C
C     DRAW THE POSITIVE Y-AXIS.
C
          IF(NSTICY .EQ. 0)GO TO 80
   60     DO 70 J=1,NSTICY
          Y = Y + SMY
          IF(Y .GT. YHIGH)GO TO 80
   70     CALL PLOT(X,Y,1,5)
          Y = Y + SMY
          IF(Y .LT. YHIGH)GO TO 60
   80     CALL PLOT(X,YHIGH,1,0)
          Y = YORG
C
C     DRAW THE GRID LINES ON THE POSITIVE Y-AXIS.
C
   90     Y = Y + YGRID
          IF(Y .GT. YHIGH)GO TO 100
          CALL PLOT(XLOW,Y,0,0)
          CALL PLOT(XHIGH,Y,1,0)
          Y = Y + YGRID
          IF(Y .GT. YHIGH)GO TO 100
          CALL PLOT(XHIGH,Y,0,0)
          CALL PLOT(XLOW,Y,1,0)
          GO TO 90
  100     Y = YORG
          CALL PLOT(X,Y,0,0)
        ENDIF
      ENDIF
C
C     IF THERE ARE NO GRID LINES ON THE X-AXIS, DRAW THE ENTIRE
C     AXIS.
C
      IF(XGRID .EQ. 0.0)THEN
        CALL PLOT(XLOW,Y,0,0)
        CALL PLOT(XHIGH,Y,1,0)
        CALL PLOT(X,Y,0,0)
      ELSE
C
        SMX = XGRID / FLOAT(NSTICX + 1)
C
        IF(XLOW .LT. XORG)THEN
C
C     DRAW THE NEGATIVE X-AXIS.
C
          IF(NSTICX .EQ. 0)GO TO 130
  110     DO 120 J=1,NSTICX
          X = X - SMX
          IF(X .LT. XLOW)GO TO 130
  120     CALL PLOT(X,Y,1,7)
          X = X - SMX
          IF(X .GT. XLOW)GO TO 110
  130     CALL PLOT(XLOW,Y,1,0)
          X = XORG
C
C     DRAW THE GRID LINES ON THE NEGATIVE X-AXIS.
C
  140     X = X - XGRID
          IF(X .LT. XLOW)GO TO 150
          CALL PLOT(X,YLOW,0,0)
          CALL PLOT(X,YHIGH,1,0)
          X = X - XGRID
          IF(X .LT. XLOW)GO TO 150
          CALL PLOT(X,YHIGH,0,0)
          CALL PLOT(X,YLOW,1,0)
          GO TO 140
  150     X = XORG
          CALL PLOT(X,Y,0,0)
        ENDIF
C
        IF(XHIGH .GT. XORG)THEN
C
C     DRAW THE POSITIVE X-AXIS.
C
          IF(NSTICX .EQ. 0)GO TO 180
  160     DO 170 J=1,NSTICX
          X = X + SMX
          IF(X .GT. XHIGH)GO TO 180
  170     CALL PLOT(X,Y,1,7)
          X = X + SMX
          IF(X .LT. XHIGH)GO TO 160
  180     CALL PLOT(XHIGH,Y,1,0)
          X = XORG
C
C     DRAW THE GRID LINES ON THE POSITIVE X-AXIS.
C
  190     X = X + XGRID
          IF(X .GT. XHIGH)GO TO 200
          CALL PLOT(X,YLOW,0,0)
          CALL PLOT(X,YHIGH,1,0)
          X = X + XGRID
          IF(X .GT. XHIGH)GO TO 200
          CALL PLOT(X,YHIGH,0,0)
          CALL PLOT(X,YLOW,1,0)
          GO TO 190
  200     X = XORG
          CALL PLOT(X,Y,0,0)
        ENDIF
      ENDIF
C
C     THE AXES ARE COMPLETE.
C
      RETURN
C
      END

        SUBROUTINE PATTERN_SET
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
        
*       Sets the patterns for SHADE/FILL
*       J Davison JISAO/PMEL/TMAP 10.23.98
*
*       *acm* 9/02 Check that the number of levels in a pattern file isn't
*                  larger than pattern_num (see shade_vars.cmn), the number 
*                  of pattern levels allowed to be specified in a
*                  pattern file.
* v552 *acm* 3/03 Longer strings: changes for multi-line labels.

        include         'shade_vars.cmn'
        include 	'cmrdl_inc.decl'            
        include 	'CMRDL.INC'            
        include 	'gkscm1_inc.decl'            
        include 	'GKSCM1.INC'            
        include 	'gkscm2.cmn'            
	include		'CMRD.INC'

#ifdef atc_gks
#   ifdef unix
	include        'gkspar.inc'
#   else
	INCLUDE        'atc_gksdir:gkspar.inc'
#   endif
#else
#   ifdef unix
  	include        'gkspar.inc'
#   else
  	INCLUDE        'sys$library:gksdefs.bnd'
#   endif
#endif

       	logical		there
        integer         beg,end,beg_eq                        
        character*2048   str                                

******************************************************************************

*	PROCESS LEVELS AS SPECIFIED
      	call upnsquish (label,str,end)
        call squish (label,1,2048)
        
	if (m .eq. 1 .or. (m .eq. 0 .and. end .eq. 0)) then
	   call pattern_levels (str,end)
	   goto 10
	end if

*	IF A PATTERN IS TO BE READ, DO THAT AND SET LEVELS
	beg = index (str,'PATTERN')
        beg_eq = index (str,'=')
	if (beg .ne. 0 .and. 
     .       (beg_eq .gt. beg .or. beg_eq .eq. 0)) then
	   call pattern_read (label,beg,end,there)
	   if (.not.there) return
	   goto 10
	end if

*	IF A PATTERN IS TO BE SAVED, DO THAT
	beg = index (str,'SAVE')
        beg_eq = index (str,'=')
	if (beg .ne. 0 .and. 
     .       (beg_eq .gt. beg .or. beg_eq .eq. 0)) then
           call pattern_save (label,beg,end)
	   goto 10
	end if

*	SET LEVELS FOR DEFAULT PATTERNS
	beg = index (str,'DEFAULT')
	if (beg .ne. 0) then
	   call pattern_default
	   goto 10
	end if

 10     return
	end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	SUBROUTINE PATTERN_LEVELS (str,end)

        include         'shade_vars.cmn'
	include		'cmrd_inc.decl'
	include		'CMRD.INC'

	include 'errmsg.parm'

* 3/99 *kob* 	move var init off of decl list  - cleaning up after jerry.
	integer		i,j,ndx,npatp1,solid
        DATA            solid/21/

        integer         beg,end,andx
        character*2048   str   
        character*100   err_msg                             

        logical    recognized

*******************************************************************************

*	NO PARAMETERS RESETS TO ZERO PATTERNS -- SOLID COLORS
	if (m .eq. 0) then 
           npat = 1
           patterns(1) = solid
           return
	end if

        ndx = int(p(1))

*	FIRST PARAMETER NEGATIVE DELETES THAT LEVEL
 	if (ndx .lt. 0) then
           andx = abs(ndx)
           if (andx .le. npat) then
              npat = npat - 1
              
              do 5 i = andx, npat
                 patterns(i) = patterns(i+1)
 5            end do
              
              if (npat .eq. 0) then
                 write (6,'(/a/a/)') 
     .         ' PPL+ note: You have removed all patterns.'
     .        ,' The pattern list will be reset to SOLID'
                 
                 npat = 1
                 patterns(1) = solid
              end if

              return
           else
              write (6,'(/a,i2,a/)') 
     .             ' PPL+ error: Pattern ',andx,
     .             ' is not available to be removed'
              return
           end if
        end if

*       NEED PROPER SET OF ARGUMENTS OTHERWISE
        if (end .eq. 0) then
           write (6,'(/a/a/)') 
     .          ' PPL+ error: The syntax to set a pattern', 
     .          ' is the sequence ORDER and then the PATTERN name'
           return
        end if

*	REJECT INDEX OUTSIDE CURRENT LIST + 1
        npatp1 = npat + 1
	if (ndx .le. 0 .or. ndx .gt. npatp1) then
           
          write (6,'(/a,i2,a/a,i2/)') 
     .     ' PPL+ error: The pattern position you specified, ', 
     .     ndx,',',' is outside the valid range of 1 to ', npatp1
           return
        end if

*	REJECT PATTERNS WITH UNRECOGNIZED NAME        
        recognized = .false.
        do 10 i = 1, 21
           beg = index (pattern_list(i),str(1:end))
           if (beg .eq. 0) goto 10

           recognized = .true.
           named_ndx = i
           goto 11
 10     end do
        if (.not. recognized) then
           write (6,'(/a/a/)') ' PPL+ error: The pattern name ' 
     .        //str(1:end)//' is not valid.',
     .        ' Use the PPL command LIST APATTERNS for available '
     .        //'pattern names'
           
           return
        end if

*	REPLACE OLDER PATTERN WITH NEW, ADD PATTERN TO TOP, IF SPECIFIED
 11     if (ndx .eq. p(1)) then
           patterns(ndx) = named_ndx
           if (ndx .eq. npat + 1) npat = npat + 1
           IF (npat .GT. pattern_num) GOTO 1000
       else
*	IF NEW, INSERT INTO PROPER LOCATION IN PATTERN LIST
           do 15 j = npat,ndx+1,-1
              patterns(j+1) = patterns(j)
 15        end do

           npat = npat + 1
           IF (npat .GT. pattern_num) GOTO 1000
           patterns(ndx+1) = named_ndx
        end if


 5000	RETURN
        
 1000	WRITE (err_msg, 110)  pattern_num 
  110   FORMAT ('Too many levels in .pat file. Max is',i4)
        CALL ERRMSG( ferr_prog_limit, status, err_msg, *5000 )
	END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

        SUBROUTINE PATTERN_DEFAULT

#ifdef unix
        include         'shade_vars.cmn'
#else
        INCLUDE         'tmap_pplv11inc:tmap_shade_vars.inc'
#endif

        integer  i

******************************************************************************

*	'DEFAULT' RESETS PATTERN SEQUENCE TO DEFAULT PATTERN SEQUENCE
        npat = 20
        do 1 i = 1, npat
           patterns(i) = default_patterns(i)
 1      end do
        
        return
        end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


	SUBROUTINE PATTERN_READ (str,beg,end,there)

#ifdef unix
        include 	'tmap_errors.parm'    
	include		'cmrd_inc.decl'
	include		'CMRD.INC'
        include         'shade_vars.cmn'
#else

        INCLUDE 	'TMAP_FORMAT:TMAP_ERRORS.PARM'
	INCLUDE		'tmap_pplv11inc:tmap_cmrd.inc'
        INCLUDE         'tmap_pplv11inc:tmap_shade_vars.inc'
#endif

	logical		there, recognized
	integer		beg,end,i,j,speclen,lnblk,status,ndx
	character*2048	str,sfile,instr,label,specdir,tm_inq_path

	external 	lnblk

*******************************************************************************

*	IF NO FILE NAME GIVEN, READ IN FROM MEMORY
	if (end .lt. 9) then
	   if (mnpat .eq. 0) goto 100
	   npat = mnpat

	   do 4 i = 1,npat
	      patterns(i) = mpatterns(i)
4	   end do

	   there = .true.
	   return
	endif

	sfile = tm_inq_path (str(beg+8:end),'FER_PALETTE','.pat',
     .	.false.,status)
*	type *, sfile,str(beg+8:end),status,merr_ok
	if (status .ne. merr_ok) go to 100
	there = .true.

*	OPEN THE FILE
#ifdef atc_gks
 5      open (70,file=sfile,status='old',err=100)
#else
#ifdef NO_OPEN_READONLY
 5      open (70,file=sfile,status='old',err=100)
#else
 5      open (70,file=sfile,readonly,status='old',err=100)
#endif
#endif
*	READ IN THE PATTERNS AND SET THEM
        npat = 0
10	read (70,'(a)',end=30,err=90) instr
	do 15 i = 1,80
	   if (instr(i:i) .ne. ' ') then
	      j = i
	      goto 20
	   end if
15	end do
	goto 10

*	PERMIT COMMENTS 
20	if (instr(j:j) .eq. '!') goto 10
	call parsex (instr(j:j+79),80,p,iflg,m,label,n)
      	call upnsquish (label,str,end)

*	REJECT PATTERNS WITH UNRECOGNIZED NAME        
        recognized = .false.
        do 25 i = 1, 21
           beg = index (pattern_list(i),str(1:end))
           if (beg .eq. 0) goto 25

           recognized = .true.
           named_ndx = i
           goto 27
 25     end do
        if (.not. recognized) then
           write (6,'(/a/a/)') ' PPL+ error: The pattern name ' 
     .        //str(1:end)//' is not valid.',
     .        ' Use the PPL command LIST APATTERNS for available '
     .        //'pattern names'
                      
           return
        end if

 27     ndx = int(p(1))
        patterns(ndx) = named_ndx
        npat = npat + 1
	goto 10

30	close (70)
	return

*	ERROR WITH FILE ACCESS
90	close (70)
100	there = .false.
	write (6,'(/a/)') ' PPL+ error: Unable to read "' //
     .	str(beg+8:end)//'.pat" to set shade and fill patterns.'

	return

	end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	SUBROUTINE PATTERN_SAVE (str,beg,end)

#ifdef unix
        include         'shade_vars.cmn'
#else
        INCLUDE         'tmap_pplv11inc:tmap_shade_vars.inc'
#endif

	integer		beg,end,i
	character*2048	str,sfile

*******************************************************************************

*	WRITE TO MEMORY IF NO FILE NAME GIVEN
	if (end .lt. 6) then
	   mnpat = npat

	   do 10 i = 1,npat
	      mpatterns(i) = patterns(i)
10	   end do
	   goto 101
	end if

#ifdef unix
	sfile = str(beg+5:end)//'.pat'

*	OPEN THE FILE

#   ifdef atc_gks
	open (70,file=sfile,status='unknown',form='formatted',
     .	err=100)
#   else
#ifdef NO_OPEN_CARRIAGECONTROL
	open (70,file=sfile,status='unknown',form='formatted',
     .	err=100)
#else
	open (70,file=sfile,status='unknown',form='formatted',
     .	carriagecontrol='list',err=100)
#endif
#   endif
#else
	sfile = 'fer_palette:'//str(beg+5:end)//'.spk'

*	OPEN THE FILE
#ifdef NO_OPEN_CARRIAGECONTROL
	open (70,file=sfile,status='new',form='formatted',
     .	err=100)
#else
	open (70,file=sfile,status='new',form='formatted',
     .	carriagecontrol='list',err=100)
#endif
#endif
*	WRITE OUT THE SPECTRUM
	do i = 1,npat
	   write (70,'(i3,2x,a25)') i, pattern_list(patterns(i))
	end do

	close (70)
	return

100	write (6,'(/a/)') ' PPL+ error: Unable to save pattern list ' //
     .	str(beg+9:end)//'.pat"'
101	return
	end

	SUBROUTINE LIN_REGRID_1_AXIS(	cx_lims, axis, dst_lo, dst_hi,
     .					src, msrc, dst, mdst,
     .					ss12, coef )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* 	Using data values from src organized on grid src_grd, interpolate to
* 	values dst on grid dst_grd.

* 	msrc and mdst point to data structures in COMMON/XVARIABLES/ which
* 	specify the subscript bounds of src and dst within their respective
* 	grids.

* 	Both src and dst are assumed to be 4 dimensional structures
*	with regridding needed along axis "axis"

*	ss12 holds the indices of nearest grid nodes on src_grd for nodes
*	on dst_grd. COEF holds the interpolation coefficients.

*	The interpolation algorithm is taken from Numerical Recipes, Chapter 3,
*	Section "Interpolation in Two or More Dimensions"

* 	programmer - Jerry Davison
* 	NOAA/PMEL,Seattle,WA - Tropical Modeling and Analysis Program
* 	written for VAX computer under VMS operating system
* 	revision 1.0 - 5.2.88
* V205:   8/3/89 - major re-write (regrid along 1 axis only of 4D structure)
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN
* v570 *acm* 5/04 Range of subscripts might be negative, and contain 
*                 -111 among them. Allow regridding, using the flag 
*                 ok_neg111 to distinguish this case from the flag 
*                 unspecified_int4.
* v580 *acm* 11/04 Fix the definition of ok_neg111; if -111 is at
*                  either end of the interval we cannot distinguish
*                  it as a valid index from its use as the bad flag.
* V68  *acm* 1/12  changes for double-precision ferret.
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xcontext.cmn'

* CALLING ARGUMENT DECLARATIONS:
	INTEGER	  cx_lims, axis, dst_lo, dst_hi, msrc, mdst
	INTEGER   ss12(	dst_lo:dst_hi )
	REAL    src( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          dst( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif ),
     .		coef( dst_lo:dst_hi )

* INTERNAL VARIABLE DECLARATIONS:
        LOGICAL TM_FPEQ, OK_neg111
	INTEGER i, j, k, l, m, n,
     .		ss, src_lo, src_hi, src_grd, dst_grd
	REAL	bad_src, bad_dst, z1, z2, c1, c2

********************************************************************************

* LIMITS FOR CALCULATION
        src_lo = mr_lo_ss(msrc,axis)
        src_hi = mr_hi_ss(msrc,axis)

* FLAG FOR BAD/MISSING DATA
        bad_src = mr_bad_data(msrc)
        bad_dst = mr_bad_data(mdst)

* source and destination grids
	src_grd = mr_grid( msrc )
	dst_grd = mr_grid( mdst )

* DETERMINE (LOWER) src_grd INDEX OF NEAREST NEIGHBORS ON src_grd AXES
* FOR NODES ON dst_grd AXES, AND COMPUTE FRACTIONAL POSITIONS OF dst_grd
* NODES WITH RESPECT TO src_grd.
	CALL GET_LINEAR_COEF(	src_lo, src_hi, src_grd,
     .				dst_lo, dst_hi, dst_grd,
     .				axis, ss12, coef )

* For a modulo longitude axis, the range of subscripts might be negative, 
* and contain -111 among them. ok_neg111 distinguishes between this and 
* the flag unspecified_int4.

        ok_neg111 = (ss12(dst_lo) .LT. unspecified_int4 .AND.
     .               ss12(dst_hi) .GT. unspecified_int4) .OR.
     .              (ss12(dst_lo) .GT. unspecified_int4 .AND.
     .               ss12(dst_hi) .LT. unspecified_int4) 

* CONVERT THE DATA TO dst_grd
	IF ( axis .EQ. x_dim ) THEN
	   DO 110 i = dst_lo, dst_hi

* interpolation coefficients
	      ss = ss12(i)
	      c2 = coef(i)
	      c1 = 1.0 - c2

* special case: exact overlap of source and dest points
	      IF ( TM_FPEQ(c1, 1.0) ) THEN
	         DO 100 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	         DO 100 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	         DO 100 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	         DO 100 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	         DO 100 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
 100	         dst(i,j,k,l,m,n) = src(ss,j,k,l,m,n)
	         GOTO 110
	      ELSEIF ( ss .EQ. unspecified_int4 .AND. 
     .                 .NOT. ok_neg111 ) THEN
* ... this should never happen in FERRET 2.00+
	         DO 102 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	         DO 102 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	         DO 102 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	         DO 102 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	         DO 102 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
 102		 dst(i,j,k,l,m,n) = bad_dst
	         GOTO 110
	      ENDIF

* regular interpolation
	      DO 105 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	      DO 105 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	      DO 105 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	      DO 105 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	      DO 105 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)

* surrounding source data points
	         z1 = src(ss  ,j,k,l,m,n)
	         z2 = src(ss+1,j,k,l,m,n)

* interpolate
	         IF (z1 .EQ. bad_src .OR. z2 .EQ. bad_src ) THEN
		    dst(i,j,k,l,m,n) = bad_dst
	         ELSE
	            dst(i,j,k,l,m,n) = c1*z1 + c2*z2
	         ENDIF

 105	      CONTINUE
 110	   CONTINUE

	ELSEIF ( axis .EQ. y_dim ) THEN
	   DO 210 j = dst_lo, dst_hi

* interpolation coefficients
	      ss = ss12(j)
	      c2 = coef(j)
	      c1 = 1.0 - c2

* special case: exact overlap of source and dest points
	      IF ( TM_FPEQ(c1, 1.0) ) THEN
	         DO 200 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	         DO 200 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	         DO 200 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	         DO 200 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	         DO 200 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
 200	         dst(i,j,k,l,m,n) = src(i,ss,k,l,m,n)
	         GOTO 210
	      ELSEIF ( ss .EQ. unspecified_int4 .AND. 
     .                 .NOT. ok_neg111 ) THEN
* ... this should never happen in FERRET 2.00+
	         DO 202 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	         DO 202 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	         DO 202 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	         DO 202 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	         DO 202 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
 202		 dst(i,j,k,l,m,n) = bad_dst
	         GOTO 210
	      ENDIF

* regular interpolation
	      DO 205 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	      DO 205 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	      DO 205 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	      DO 205 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	      DO 205 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* surrounding source data points
	         z1 = src(i,ss  ,k,l,m,n)
	         z2 = src(i,ss+1,k,l,m,n)

* interpolate
	         IF (z1 .EQ. bad_src .OR. z2 .EQ. bad_src ) THEN
		    dst(i,j,k,l,m,n) = bad_dst
	         ELSE
	            dst(i,j,k,l,m,n) = c1*z1 + c2*z2
	         ENDIF

 205	      CONTINUE
 210	   CONTINUE

	ELSEIF ( axis .EQ. z_dim ) THEN
	   DO 310 k = dst_lo, dst_hi

* interpolation coefficients
	      ss = ss12(k)
	      c2 = coef(k)
	      c1 = 1.0 - c2

* special case: exact overlap of source and dest points
	      IF ( TM_FPEQ(c1, 1.0) ) THEN
	         DO 300 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	         DO 300 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	         DO 300 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	         DO 300 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
	         DO 300 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
 300	         dst(i,j,k,l,m,n) = src(i,j,ss,l,m,n)
	         GOTO 310
	      ELSEIF ( ss .EQ. unspecified_int4 .AND. 
     .                 .NOT. ok_neg111 ) THEN
* ... this should never happen in FERRET 2.00+
	         DO 302 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	         DO 302 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	         DO 302 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	         DO 302 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
	         DO 302 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
 302		 dst(i,j,k,l,m,n) = bad_dst
	         GOTO 310
	      ENDIF

* regular interpolation
	      DO 305 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	      DO 305 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	      DO 305 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	      DO 305 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
	      DO 305 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* surrounding source data points
	         z1 = src(i,j,ss  ,l,m,n)
	         z2 = src(i,j,ss+1,l,m,n)

* interpolate
	         IF (z1 .EQ. bad_src .OR. z2 .EQ. bad_src ) THEN
		    dst(i,j,k,l,m,n) = bad_dst
	         ELSE
	            dst(i,j,k,l,m,n) = c1*z1 + c2*z2
	         ENDIF

 305	      CONTINUE
 310	   CONTINUE

	ELSEIF ( axis .EQ. t_dim ) THEN
	   DO 410 l = dst_lo, dst_hi

* interpolation coefficients
	      ss = ss12(l)
	      c2 = coef(l)
	      c1 = 1.0 - c2

* special case: exact overlap of source and dest points
	      IF ( TM_FPEQ(c1, 1.0) ) THEN
	         DO 400 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	         DO 400 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	         DO 400 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	         DO 400 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
	         DO 400 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
 400	         dst(i,j,k,l,m,n) = src(i,j,k,ss,m,n)
	         GOTO 410
	      ELSEIF ( ss .EQ. unspecified_int4 .AND. 
     .                 .NOT. ok_neg111 ) THEN
* ... this should never happen in FERRET 2.00+
	         DO 402 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	         DO 402 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	         DO 402 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	         DO 402 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
	         DO 402 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
 402		 dst(i,j,k,l,m,n) = bad_dst
	         GOTO 410
	      ENDIF

* regular interpolation
	      DO 405 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	      DO 405 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	      DO 405 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	      DO 405 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
	      DO 405 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* surrounding source data points
	         z1 = src(i,j,k,ss,  m,n)
	         z2 = src(i,j,k,ss+1,m,n)

* interpolate
	         IF (z1 .EQ. bad_src .OR. z2 .EQ. bad_src ) THEN
		    dst(i,j,k,l,m,n) = bad_dst
	         ELSE
	            dst(i,j,k,l,m,n) = c1*z1 + c2*z2
	         ENDIF

 405	      CONTINUE
 410	   CONTINUE

	ELSEIF ( axis .EQ. e_dim ) THEN
	   DO 510 m = dst_lo, dst_hi

* interpolation coefficients
	      ss = ss12(m)
	      c2 = coef(m)
	      c1 = 1.0 - c2

* special case: exact overlap of source and dest points
	      IF ( TM_FPEQ(c1, 1.0) ) THEN
	         DO 500 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	         DO 500 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	         DO 500 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	         DO 500 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
	         DO 500 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
 500	         dst(i,j,k,l,m,n) = src(i,j,k,l,ss,n)
	         GOTO 510
	      ELSEIF ( ss .EQ. unspecified_int4 .AND. 
     .                 .NOT. ok_neg111 ) THEN
* ... this should never happen in FERRET 2.00+
	         DO 502 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	         DO 502 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	         DO 502 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	         DO 502 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
	         DO 502 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
 502		 dst(i,j,k,l,m,n) = bad_dst
	         GOTO 510
	      ENDIF

* regular interpolation
	      DO 505 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	      DO 505 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	      DO 505 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	      DO 505 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
	      DO 505 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* surrounding source data points
	         z1 = src(i,j,k,l,ss  ,n)
	         z2 = src(i,j,k,l,ss+1,n)

* interpolate
	         IF (z1 .EQ. bad_src .OR. z2 .EQ. bad_src ) THEN
		    dst(i,j,k,l,m,n) = bad_dst
	         ELSE
	            dst(i,j,k,l,m,n) = c1*z1 + c2*z2
	         ENDIF

 505	      CONTINUE
 510	   CONTINUE

	ELSEIF ( axis .EQ. f_dim ) THEN
	   DO 610 n = dst_lo, dst_hi

* interpolation coefficients
	      ss = ss12(n)
	      c2 = coef(n)
	      c1 = 1.0 - c2

* special case: exact overlap of source and dest points
	      IF ( TM_FPEQ(c1, 1.0) ) THEN
	         DO 600 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	         DO 600 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	         DO 600 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	         DO 600 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
	         DO 600 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
 600	         dst(i,j,k,l,m,n) = src(i,j,k,l,m,ss)
	         GOTO 610
	      ELSEIF ( ss .EQ. unspecified_int4 .AND. 
     .                 .NOT. ok_neg111 ) THEN
* ... this should never happen in FERRET 2.00+
	         DO 602 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	         DO 602 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	         DO 602 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	         DO 602 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
	         DO 602 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
 602		 dst(i,j,k,l,m,n) = bad_dst
	         GOTO 610
	      ENDIF

* regular interpolation
	      DO 605 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	      DO 605 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	      DO 605 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	      DO 605 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
	      DO 605 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* surrounding source data points
	         z1 = src(i,j,k,l,m,ss  )
	         z2 = src(i,j,k,l,m,ss+1)

* interpolate
	         IF (z1 .EQ. bad_src .OR. z2 .EQ. bad_src ) THEN
		    dst(i,j,k,l,m,n) = bad_dst
	         ELSE
	            dst(i,j,k,l,m,n) = c1*z1 + c2*z2
	         ENDIF

 605	      CONTINUE
 610	   CONTINUE

	ENDIF

	RETURN
	END

	SUBROUTINE TM_WW_AX_1_N (axis, lo, hi)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Return the coordinates of the first and Nth coordinate points of an axis
* Modulo is ignored in this calculation

* V541 *sh* 2/02
* V71  3/16 *acm* Ticket 2158: working with true monthly time axes.

	include 'tmap_dims.parm'
#include "gt_lib.parm"
	include	'xtm_grid.cmn_text'

* calling argument declarations
	INTEGER axis
	REAL*8 lo, hi

* internal variable declarations
	LOGICAL ITSA_TRUEMONTH_AXIS
	INTEGER	isub1, llen, iiaxis
	REAL	TM_WORLD

	IF ( axis .LT. 0 .OR. axis .GT. line_ceiling ) THEN
	  lo = unspecified_val8
	  hi = unspecified_val8
	ELSEIF ( ITSA_TRUEMONTH_AXIS(axis) ) THEN
	  lo = TM_WORLD (1, axis, box_lo_lim )
	  hi = TM_WORLD (line_dim(axis), axis, box_hi_lim )
	ELSEIF ( line_regular(axis) ) THEN
	  lo = line_start(axis)
	  hi = line_start(axis) + (line_dim(axis)-1)*line_delta(axis)
	ELSE
	  iiaxis = axis
	  IF (line_parent(axis) .NE. 0) iiaxis = line_parent(axis)
	  isub1 = line_subsc1(iiaxis)
	  llen = line_dim(iiaxis)
	  lo = line_mem(isub1)
	  hi = line_mem(isub1 + llen - 1)
	ENDIF

	RETURN
	END

	INTEGER FUNCTION CD_ISIT_RECDIM( cdfid, dset, grid, idim,
     .     mode_upcase_output, keepax_flag, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Is the indicated is the indicated axis of the grid the netCDF record axis?
* Or can it never become the record axis ?
* Or are both it and the record axis as-yet undefined?

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 6/92
* V500 *kob* 3/99 - up lengths of CD_AXIS_NAME and name to correspond w/ 
*                   longer line_name
* V600 *acm* 6/05 - Attribute control. Get information from linked-list structure.
* V602 *acm*12/06 - Bug 1478: Correct the treatment of uppercasing names.
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files
* V687 3/14 *acm* Fix ticket 1750. Write Ferret-internal axis names to cdf files, unless
*                 the user has said /KEEP_AXISNAMES
* V697 12/15 *acm* Fix ticket 2336: consistent application of CAN MODE UPCASE

* argument definitions:
*       dset    - dset (if netcdf file, for getting name and attribute 
*                 info from linked-list structure  
*       cdfid   - returned pointer to open CDF file
*       grid    - TMAP grid number
*       idim    - axis number (1-4)
*	status	- return status

* argument declarations:

	LOGICAL	mode_upcase_output
	INTEGER cdfid, dset, grid, idim, keepax_flag, status

* include files
        include 'netcdf.inc'
        include 'tmap_errors.parm'
        include 'cd_lib.parm'

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

* local variable declarations:
      LOGICAL this_ax_exists, recax_exists, coordvar
      INTEGER ndims, nvars, ngatts, recdim, cdfstat, nlen, dimid,
     .        varid, vartype, nvdims, vdims(8), nvatts, all_outflag
      CHARACTER CD_AXIS_OUTNAME*128, CD_AXIS_NAME*128, name*128, name_in*128

* get the axis name
         name = CD_AXIS_NAME( dset, grid, idim, nlen )
         IF (keepax_flag.EQ.1 .OR. .NOT.(mode_upcase_output)) 
     .       name = CD_AXIS_OUTNAME( dset, grid, idim, nlen )

* If mode upcase_output is set, then the axis name
* has been written to the file upcased.

         IF (mode_upcase_output) THEN
            name_in = name
            CALL STR_UPCASE( name, name_in)
         ENDIF

* is there a dimension by this name?
#ifdef usingDODSf2cUnderscore
        cdfstat = NF_INQ_DIMID_( cdfid, name(:nlen), dimid )
#else
        cdfstat = NF_INQ_DIMID ( cdfid, name(:nlen), dimid )
#endif

        this_ax_exists = cdfstat .EQ. NF_NOERR

* get vital statistics of file
#ifdef usingDODSf2cUnderscore
        cdfstat = NF_INQ_( cdfid, ndims, nvars, ngatts, recdim )
#else
        cdfstat = NF_INQ ( cdfid, ndims, nvars, ngatts, recdim )
#endif
!        IF ( cdfstat .NE. NF_NOERR ) GOTO 5100
        recax_exists = recdim .NE. -1

* so what's the answer?
        IF ( .NOT.(this_ax_exists .OR. recax_exists) ) THEN
           CD_ISIT_RECDIM = pcdf_undefined    ! both undefined as yet
        ELSEIF ( this_ax_exists
     .     .AND. recax_exists
     .     .AND. (dimid .EQ. recdim) ) THEN
           CD_ISIT_RECDIM = pcdf_yes          ! both defined and equal
        ELSE
           CD_ISIT_RECDIM = pcdf_no           ! at least one exists unequal
        ENDIF

* successful completion
 1000   status = merr_ok
        RETURN

* error exit
!5100   CALL TM_ERRMSG
!    .     ( cdfstat+pcdferr, status, 'CD_USE_RECDIM', cdfid,
!    .        no_varid, no_errstring, no_errstring, *5900 )
!5900   RETURN
	END

	SUBROUTINE TM_BREAK_FMT_DATE (form, date, cal_id, 
     .                                year, month, day, hour, minute, 
     .                                second, do_err, status)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Will take date strings of various formats and break them into their
* various components.

* *sh* 2/13/95
* V500 *sh* 7/99 - if numslashnum reading fails, try dd-mmm-yyyy (VAX)
*		to support LDEA files with "months since 01-jan"
* V530 *acm* 12/00 - add cal_id for alternative calendar axes
* 
* 1/03 - *kob* g77 port - Need to use risc_buff for arbitrary concatenations
* V551 *acm*  2/03 - fix bug where seconds were wiped out. See cc comments
* V600 *acm* 2/06 - Fix for bug 1394, do err msg only if do_err flag true
* V67  *acm* 3/11 - If there is a T between the date and time in the unitsi 
*                   string "months since yyyy-mm-ddThh:mm:ss (as in GRIB files) 
*                   allow that. Replace T with a space. Ticket 1806.
* V72 *acm*  3/17   If there is a Z at the end, lop that off.
* v745 *acm* 12/18 Issue 1909, option to write dates in ISO8601 format
* v7441*acm* 12/18 Issue 1910: Allow dates in commands to be in ISO 8601 form, yyyy-mm-dd

* ARGUMENT DEFINITIONS
*  form  - code for the date string format
*  date  - date to process
*  cal_id  integer code for which calendar to use
*  day, month, year, hour, minute, second - obvious. Second may be a real number sec.fraction
*  status - returned status

	CHARACTER*(*)	date
	INTEGER	form, day, month, year, hour, minute, status,cal_id
	REAL	second
*
* INCLUDE FILES

	include 'tmap_errors.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'xrisc_buff.cmn'


* internal variable declarations:
        LOGICAL do_err
	INTEGER slen, isecond
	REAL	frac
	PARAMETER ( slen = 32)
	INTEGER TM_LENSTR1, TM_BREAK_FMT_DATE_C, dlen
#ifdef sun
	BYTE       dhol(slen)     !c-type Hollerith string buffers
#else
	INTEGER*1  dhol(slen)     !c-type Hollerith string buffers
#endif

	dlen = TM_LENSTR1( date)

	IF ( form .EQ. pdate_vax ) THEN
	    CALL TM_BREAK_DATE( date, cal_id, year, month, day,
     .			hour, minute, isecond, status)
	    second = FLOAT(isecond)
	    IF (TM_LENSTR1(date) .GT. 20) THEN
	       READ (date(22:slen), *, err=5100)  frac
	       second = second + frac/100.
	    ENDIF

	    RETURN

	ELSEIF ( form .EQ. pdate_numslashnum ) THEN

* ... note:  this is a quick and dirty kludge parser.  Use the udunits package
*	     for a more robust approach
* ... the format looks like (e.g.) 1992-10-18 15:15:42.5 

*     If there is a T or a : between the date and time (as in GRIB files) replace with a space.
           IF (dlen .GT. 10) THEN
              IF (date(11:11).EQ.'T') date(11:11) = ' '
              IF (date(11:11).EQ.':') date(11:11) = ' '
           ENDIF

* If there is a Z at the end, lop that off.

           IF (date(dlen:dlen) .EQ. 'Z') date(dlen:dlen) = ' '

	   CALL TM_FTOC_STRNG( date(:dlen), dhol, slen)
	   status = TM_BREAK_FMT_DATE_C(dhol, year, month,
     .				        day, hour, minute, second)

	   IF ( status .NE. 0 ) THEN
* ... last attempt -- try VAX format
	      CALL TM_BREAK_DATE( date, cal_id, year, month, day,
     .			hour, minute, isecond, status)
	      IF ( status .NE. merr_ok ) GOTO 5200
	      
	      second = FLOAT(isecond)
	      IF (TM_LENSTR1(date) .GT. 20) THEN
	          READ (date(22:slen), *, err=5100)  frac
	          second = second + frac/100.
	       ENDIF

	   ENDIF

	ELSE
	   STOP 'Unknown date format code'
	ENDIF

* successful translation
	status = merr_ok
	RETURN

* error exits
 5000	RETURN
 5100	risc_buff = date(:dlen)
        IF (do_err) THEN
          CALL TM_ERRMSG (merr_badtimedef, status, 'TM_BREAK_FMT_DATE',
     .			unspecified_int4, no_stepfile,
     .			'syntax error in "'//risc_buff,
     .			no_errstring, *5000)
        ELSE
           dlen = TM_LENSTR1(risc_buff)
           CALL WARN (
     .       'cannot parse "units since date", date= "'//
     .        risc_buff(:dlen)//'"'//'; leaving units string')
           status = merr_badtimedef
        ENDIF
	GOTO 5000
          
 5200	risc_buff = date(:dlen)
        IF (do_err) THEN
        CALL TM_ERRMSG (merr_badtimedef, status, 'TM_BREAK_FMT_DATE',
     .			unspecified_int4, no_stepfile,
     .			date(:dlen)//' is not valid in this calendar ',
     .			no_errstring, *5000)
        ELSE
           dlen = TM_LENSTR1(risc_buff)
           CALL WARN (
     .       'cannot parse "units since date", date= "'//
     .        risc_buff(:dlen)//'"'//'; leaving units string')
           status = merr_badtimedef
        ENDIF
	GOTO 5000
	END

	INTEGER FUNCTION DO_FILL_NEAR_DSG ( 
     .				idim, dset, nfeatures, maxobs,
     .				com, com_mr, com_cx,
     .				res, res_mr, res_cx)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* fill along axis idim by duplicating the closest available valid pt

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V???:  3/23/99 - based on DO_FILL_AVE
*         7/2/99 - changed logic so if 2 equi-distant points use the mean
*                - corrected subscriptong bug in L axis search
* V550 *sh* 8/02 - support for modulo lengths. ensure that filling 
*		   does not operate acros the subspan modulo void point
*	   11/02 - change no_point to a very negative nalue (was -1)
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V76   1/20 *acm* Orientation of Point-type data set to e_dim

* Note:  this routine could be made simpler and faster by arranging single
*        inner loops that looped "loop=1,edge" looking at index-loop and
*        index+loop to find the first valid point(s)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include	'xprog_state.cmn'
	include 'xdyn_linemem.cmn_text'
	include 'xdset_info.cmn_text'
	include 'xdsg_context.cmn'


* calling argument declarations:
	INTEGER	idim, dset, nfeatures, maxobs, 
     .         com_mr, com_cx, res_mr, res_cx
	REAL	com   (*),
     .          res   (*)

* internal variable declarations:

	LOGICAL	fmask(nfeatures), omask(maxobs), new_hi
	INTEGER	i, ii, ii_com, lo_pos, hi_pos, 
     .		ifeature, iobs, flen, base, orientation, 
     .		row_size_lm, dsg_fmt_grid, dsg_coord_lm
	REAL	bad_res, bad_com, lo_val, hi_val, val


* local parameter declarations
	INTEGER     no_point
	PARAMETER ( no_point = -99999 )


* initialize
	orientation = dsg_orientation(dset)

	IF (dsg_row_size_var(dset) .GT. 0) row_size_lm = dsg_loaded_lm(dsg_row_size_var(dset))
	bad_res = mr_bad_data( res_mr )
	bad_com = mr_bad_data( com_mr )

* get feature mask and dsg grid and coordinate information
        CALL MAKE_DSG_FEATURE_MASK(dset, res_cx, fmask, nfeatures)

	row_size_lm  = dsg_loaded_lm(dsg_row_size_var(dset))
	dsg_fmt_grid = dsg_xlate_grid(dset)
	orientation  = dsg_orientation(dset)
	dsg_coord_lm = cxdsg_coord_lm(orientation)

* ****** PERFORM THE COMPUTATION *****
	IF (idim.EQ.orientation .AND. orientation.LE.t_dim) THEN 

* *** true ragged array processing:

	   base = 0    ! obs index at end of preceding feature

* ... loop over the features
	   ftrloop: DO ifeature = 1, nfeatures 

	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
              iobs = base

* ... have the user's WW constraints removed this feature?
	      IF (.NOT.fmask(ifeature)) THEN
	         DO i = 1, flen
	            iobs = iobs + 1   ! index in the contig ragged array
	            res(iobs) = bad_res
		 ENDDO
                 base = base + flen
                 CYCLE  ftrloop
              ENDIF

* ... get observation-level mask for this feature
	      CALL MAKE_DSG_OBS_MASK(dset, com_cx, ifeature, base,
     .				     omask, flen)

                 lo_pos = no_point
                 hi_pos = no_point

* ... loop over the observations within each feature
	      oloop: DO i = 1, flen
	         iobs = iobs + 1   ! index in the contig ragged array
	         res(iobs) = bad_res
	         IF (.NOT.omask(i)) CYCLE oloop

* ... the input data value

                 val = com(iobs)
		 IF (val .NE. bad_com) THEN

		    lo_val = val
		    lo_pos = iobs  !! or i+base i
		    
		    res(iobs) = val

		 ELSE

* ... look forward for next valid point

		    new_hi = .FALSE.
		    lookup: DO ii = i+1, flen
		       val = com(ii+base)
		       IF ( val .NE. bad_com ) THEN
                          hi_val = val
	                  hi_pos = ii+base
	                  new_hi = .TRUE.
			  EXIT  lookup
                       ENDIF
                    ENDDO lookup
		    IF (.NOT. new_hi) hi_pos = no_point
	      
		    IF ( lo_pos.EQ.no_point ) THEN
		       IF ( hi_pos.EQ.no_point ) THEN
		          res(iobs) = bad_res
		       ELSE
		          res(iobs) = hi_val
		       ENDIF
		    ELSE
                       IF ( hi_pos.EQ.no_point ) THEN
                          res(iobs) = lo_val
                       ELSEIF ( iobs-lo_pos .EQ. hi_pos-iobs ) THEN
                          res(iobs) = ( lo_val + hi_val ) /2.
                       ELSEIF ( iobs-lo_pos .LT. hi_pos-iobs ) THEN
                          res(iobs) = lo_val
                       ELSE
                          res(iobs) = hi_val
		       ENDIF
		    ENDIF

		 ENDIF
	      ENDDO oloop

              base = base + flen

	   ENDDO  ftrloop


	ELSE

* *** a simple list of instances:

	   DO ifeature = 1, nfeatures 

* ... have the user's WW constraints removed this feature?
	      
	      IF (.NOT.fmask(ifeature)) THEN
	         res(ifeature) = bad_res
		 CYCLE
	      ENDIF

* ... the input data in the nfeature direction
              val = com(ifeature)

	      IF ( val .NE. bad_com ) THEN
	      
		 lo_val = val
		 lo_pos = i

	         res(ifeature) = val

	      ELSE  ! filling
	      

* ... look forward for next valid point

	         DO ii = i+1, flen
                    IF ( com(ii+base).NE.bad_com .AND. 
     .			 com(ii+base).NE.dsg_masked_out_flag) THEN
                       hi_pos = val
                       hi_pos = ii
                       EXIT  
                    ENDIF
	         ENDDO 
		 hi_pos = no_point
	      
		 IF ( lo_pos.EQ.no_point ) THEN
		    IF ( hi_pos.EQ.no_point ) THEN
		       res(ifeature) = bad_res
		    ELSE
		       res(ifeature) = hi_val
		    ENDIF
		 ELSE
                    IF ( hi_pos.EQ.no_point ) THEN
                       res(ifeature) = lo_val
                    ELSEIF ( i-lo_pos .EQ. hi_pos-i ) THEN
                       res(ifeature) = ( lo_val + hi_val ) /2.
                    ELSEIF ( i-lo_pos .LT. hi_pos-i ) THEN
                       res(ifeature) = lo_val
                    ELSE
                       res(ifeature) = hi_val
		    ENDIF

		 ENDIF

              ENDIF  ! filling

           ENDDO  ! ifeature

	ENDIF     ! simple list of instances



* always success
	DO_FILL_NEAR_DSG = ferr_ok
	RETURN

	END

	SUBROUTINE LINE_KEY (x,nxs,a_line,axmin,aymin,axmax,aymax)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Modified PPLMOD_PLTIT and PPLMOD_PLOTXY to execute the ALINE command 
*	where a line is drawn of a particular type as specified.
*	J Davison 10.4.89

*  v5.5 *acm* 12/02 For dot plots -- plot a symbol in the middle as well.
*                   Taken from aline_sub, but put a third symbol in
*                   the middle of the line the key of a line-plot  

*****************************************************
* local variable declarations for PLTIT (for TMAP)
	REAL  	x
	INTEGER nxs
* TMAP include files with explicit type declarations:
	include 'parampl5_dat.decl'
	include 'PARAMPL5.DAT'

CCCCC	VIRTUAL X(NXS)		(*jd* 12.96 for linux port) 
	dimension X(NXS)     

	real 		cs,sn,xt,yt,oldx(4)
	real		axmin,aymin,axmax,aymax
	integer  	icnt,im,j,ibase,iy,a_line, npt
	logical		old_swait


C	KTYPE = 1 -XY  0 -Z  2-VECTOR
	include 'lines_inc.decl'
	include 'LINES.INC'
	include 'pen_inc.decl'
	include 'PEN.INC'
	include 'axis_inc.decl'
	include 'AXIS.INC'
	include 'hd_inc.decl'
	include 'HD.INC'
	include 'taxis_inc.decl'
	include 'TAXIS.INC'
	include 'axisl_inc.decl'
	include 'AXISL.INC'
	include 'plt_inc.decl'
	include 'PLT.INC'
	include 'pltl_inc.decl'
	include 'PLTL.INC'
	include 'mplot_inc.decl'
	include 'MPLOT.INC'
	include 'cmrd_inc.decl'
	include 'CMRD.INC'
	include 'prmcom_inc.decl'
	include 'PRMCOM.INC'
	include 'miss_inc.decl'
	include 'MISS.INC'
	include 'switch_inc.decl'
	include 'SWITCH.INC'
	include 'system_inc.decl'
	include 'SYSTEM.INC'
	include 'cont_inc.decl'  !added to get ivcomp v1.1
	include 'CONT.INC'  !added to get ivcomp v1.1
        include 'gkscm2.cmn' ! jd 3.22.89
        INCLUDE 'makedot.cmn'    ! 10/01 *acm*

	CALL COLOR(IPEN(0))

	oldx(1) 	= x(1)
	x(1) 		= axmin
	oldx(2) 	= x(2)
	x(2) 		= axmax

	oldx(3)		= x(nxs/2+1)
	x(nxs/2+1) 	= aymin
	oldx(4)		= x(nxs/2+2)
        x(nxs/2+2) 	= aymax

	IBASE=0
	IY=NXS/2
	CS=COS(VANG*.01745329252)
	SN=SIN(VANG*.01745329252)
!	ZT=YF/XF
	ICNT=1

	old_swait = swait
	swait = .false.
	CALL COLOR(IPEN(a_line))
	CALL MARKH(HMARK(a_line))

	IF(ITYPE(a_line).GE.4) THEN ! OLD PPL (PRE JD 89 GKS)
	   CALL DASHSZ(DN1(a_line),UP1(a_line),DN2(a_line),UP2(a_line))
	   CALL DASHES
	ELSE
	   CALL VECTRS
	END IF

	IF(ITYPE(a_line).EQ.3)CALL POINTS

	CALL TRANS(1,X(IBASE+1),X(IY+IBASE+1),XT,YT)                
	CALL PLOT(XT,YT,0,0)
	IF (ITYPE(a_line).NE.0.AND.ITYPE(a_line).NE.4) 
     .	CALL MARK(IMARK(a_line))
	IM=0
	IF (ITYPE(a_line).EQ.1.OR.ITYPE(a_line).EQ.3)IM=IMARK(a_line)

* ACM changes for dot plots -- plot a symbol in the middle as well.
        NPT = 2
        IF ( ITYPE(a_line).EQ.1 .OR. ITYPE(a_line).EQ.3) THEN
           NPT = 3
           X(3) = X(2)
           X(IY+3) = X(IY+2)
           X(2) = 0.5*(X(1) + X(3))
           X(IY+2) = 0.5*(X(IY+1) + X(IY+3))
        ENDIF

	DO 60 J=1,NPT
	   CALL TRANS(1,X(J),X(IY+J),XT,YT)
	   CALL PLOT(XT,YT,1,0)
60      CALL MARK(IM)
	IF (ITYPE(a_line).EQ.2.OR.ITYPE(a_line).EQ.5) 
     .	CALL MARK(IMARK(a_line))

	x(1) 		= oldx(1)
	x(2) 		= oldx(2)

	x(nxs/2+1) 	= oldx(3)
        x(nxs/2+2) 	= oldx(4)

	swait = old_swait

!	CALL SCALE(XF,YF,XORG,YORG,XLO,YLO)
C
	CALL WINDOW(0.,0.,0.,0.)
C
!	IF(ITFLG.EQ.1)THEN
!	    XHI=XTI
!	    XLO=XTL
!	ELSE IF(ITFLG.EQ.-1)THEN
!	    YHI=XTI
!	    YLO=XTL
!	ENDIF

        IF (imark(a_line) .eq. 99) THEN
           CALL doit_makedot(IPT,XDOT,YDOT)
           IPT = 0
        ENDIF

 	CALL COLOR(IPEN(0))
	RETURN
	END

	SUBROUTINE GCF_GET_AXIS_SRCS(ifcn, iarg, axis_source)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* return instructions to Ferret on how this particular argument will
* get merged into the joint context of a grid-changing function

* V450: 1/97
*	7/97 - slight reorg for external functions
*   8/97 - type mismatch on axis_implied_from caught by 
*              linux/aix compilers *kob*
* V63  *acm* 10/09 Changes for gfortran build
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)


	include 'tmap_dims.parm'
        include 'xtm_grid.cmn_text'
	include 'ferret.parm'
	include 'xgrid_chg_fcns.cmn'
	include 'xfr_grid.cmn'	! w/ mgrid_abstract

* calling argument declarations
	INTEGER	ifcn, iarg, axis_source(nferdims)

* internal variable declarations
	INTEGER	idim, iptr1,
     .		axis_will_be(nferdims)
	INTEGER efcn_get_num_reqd_args
	LOGICAL axis_implied_from(nferdims)

* initialize
        IF (ifcn .LT. 0 .OR. iarg .LT. 1) THEN

           STOP 'gcf_get_axis_srcs'

        ELSEIF (ifcn .LE. gfcn_num_internal) THEN

* check the internal grid changing functions first
* is this a valid argument number?
	   IF (iarg .GT. gfcn_num_reqd_args(ifcn) )
     .	       STOP 'gcf_get_axis_srcs'

* store info in local arrays to blur distinction between internal and external
* ... determine pointer to argument information
	   iptr1 = gfcn_arg_ptr(ifcn)
	   DO 10 idim = 1, nferdims
	      axis_will_be(idim) = gfcn_axis_will_be(idim,ifcn)
	      axis_implied_from(idim) =
     .			gfcn_axis_implied_from(idim,iptr1+iarg-1)
 10	   CONTINUE

	ELSE

	   IF (iarg .GT. efcn_get_num_reqd_args(ifcn) )
     .	       STOP 'gcf_get_axis_srcs'

	   call efcn_get_axis_will_be(ifcn, axis_will_be)
	   call efcn_get_axis_implied_from(ifcn, iarg, axis_implied_from)

	ENDIF

* return information about argument iarg
*    axis_source may be returned as
*	pgc_impose_axis
*	pgc_merge_axis
*    or	pgc_ignore_axis

	DO 100 idim = 1, nferdims

	   IF (axis_will_be(idim) .EQ. pgc_axis_is_abstract)	THEN
	      axis_source(idim) = pgc_impose_axis

	   ELSEIF (axis_will_be(idim) .EQ. pgc_axis_is_normal) THEN
	      axis_source(idim) = pgc_impose_axis

	   ELSEIF (axis_will_be(idim) .EQ. pgc_axis_supplied_herein) THEN
	      axis_source(idim) = pgc_impose_axis

	   ELSEIF (axis_will_be(idim) .EQ. pgc_axis_implied_by_args) THEN

	      IF (axis_implied_from(idim)) THEN
	         axis_source(idim) = pgc_merge_axis
	      ELSE
	         axis_source(idim) = pgc_ignore_axis
	      ENDIF

	   ELSE
	      STOP 'Invalid axis merging information in GC func'

	   ENDIF

 100	CONTINUE

	RETURN
	END

	SUBROUTINE PARSE_NAM_DSET_GRD( full_var_name, default_cx,
     .				       dset, grid, cat, var, 
     .				       made_impl_grid, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* given a full variable specification of the form:
*			(eg.) TEMP[D=n,G=gname] (with optional region info)
* return context information describing variable, data set and  grid
* ... if necessary determine the grid in the process

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 7/27/88 - based on GET_VAR_CONTEXT and PARSE_VAR_NAME
* revision 0.1 - 3/14/89 - check to see if default data set is known
* V200:   8/9/89 - eliminated unknown data set error
* V402: 7/95 - Allow nested [] of the form vname1[G=vname2[D=dset]]
*	     - Guts of routine extracted to PARSE_NAM_DSET
* V500 *sh* 3/99 - added argument made_impl_grid so calling program can
*		   manage implicit grids (from GET_CONTEXT_MODS by "Z[gz=ax]")
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'

* calling argument declarations:
	LOGICAL		made_impl_grid
	INTEGER		default_cx, dset, grid, cat, var, status
	CHARACTER*(*)	full_var_name

* internal variable declarations:
	INTEGER		IGRID, mods_cx

* most of the work extracted to this routine (7/95)
	dset = unspecified_int4		! no prejudices ??? (7/95)
	CALL PARSE_NAM_DSET( full_var_name, default_cx,
     .			     dset, cat, var, mods_cx, status )

* did we just create an implicit grid?
	made_impl_grid = cx_has_impl_grid(mods_cx)

* determine the defining grid
* (although mods_cx has been deallocated nothing has over-written it yet)
	IF ( var .NE. munknown_var_name ) THEN
	   IF ( cx_unstand_grid( mods_cx ) ) THEN
	      grid = cx_grid( mods_cx )
	   ELSE
	      grid = IGRID( dset, cat, var, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
	   ENDIF
	ENDIF

* error exit
 5000	RETURN
	END

      SUBROUTINE FRSTHD(ITAPEI,NCAST,NDATA)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)frsthd.f	1.1    3/10/88
C**
C**
C***********************************************************************        C**
C**                 EPIC
C**
C***********************************************************************        C**
C**
C  THIS SUBROUTINE WILL READ 1  HEADER FROM A  CAST THAT IS LOCATED ON
C  TAPE ITAPEI. IT WILL RETURN THE VALUES FOR CAST NUMBER AND NUMBER OF 
C  DATA POINTS IN NCAST AND NDATA.  HEADER INFORMATION WIL BE RETURNED 
C  IN HEADER.
C
C  PROGRAMMED 10/84 BY M. VERSCHELL
C
      CHARACTER*80 HEADER(8)
      COMMON /COMHDR/ HEADER
C
C  READ IN HEADER FROM TAPE ITAPEI
C
      READ (ITAPEI) HEADER(1)
      GOTO 100
   99 READ (ITAPEI,END=9000) HEADER(1)
  100 DO 150 J=2,8
      READ (ITAPEI,END=9000) HEADER(J)
  150 CONTINUE 
C
C  IF HEADER READ IN CORRECTLY, ISOLATE AND CONVERT NCAST AND NDATA
C
      READ(HEADER(1)(17:19),200) NCAST
  200 FORMAT(I3)
      READ(HEADER(3)(55:60),300) NDATA
  300 FORMAT(I6)
      RETURN
C
C  HERE BEGINS THE ERROR HANDLING CODE
C
 9000 WRITE (6,9100) NERROR
 9100 FORMAT(1X,'FORTRAN RUN TIME ERROR #',I2)
      IF (NERROR .EQ. -1) WRITE (6,9200)
 9200 FORMAT(1X,'END OF FILE READ BEFORE ALL OF HEADER READ')
      IF (NERROR .EQ. 29) WRITE (6,9300)
 9300 FORMAT(1X,'TAPE 1 NOT ASSIGNED (FOR001.DAT NOT FOUND)')
      IF (NERROR .EQ. 61) WRITE (6,9400)
 9400 FORMAT(1X,'ERROR IN CONVERSION OF NCAST OR NDATA')
      STOP
      END

      SUBROUTINE CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Read the linked list structure for netcdf variable information: 
* given dset, variable id, and attribute name return attribute id
* Test the attribute name in a case-insensitve manner.

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP

* V600 6/05 *acm* Attribute control.
*      6/06 *acm* missing declarations of ncf functions
* V602  2/07 *acm* Fix bug 1492, changing attributes of coordinate variables 
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files
* v698 5/16  *acm* ticket 2413: New attribute keywords ncoordvars, coordnames
*                  return info about coordinate-variables in datasets

* include files
#include "gt_lib.parm"
      INCLUDE "tmap_errors.parm"

* Argument declarations

      CHARACTER*(*) attname
      INTEGER dset, varid, attid, status

* Internal declarations

      INCLUDE 'netcdf.inc'

      CHARACTER*512 abuff
      LOGICAL coordvar
      INTEGER TM_LENSTR1, NCF_GET_VAR_ID, NCF_GET_VAR_ATTR_ID, 
     .        NCF_GET_VAR_ATTR_ID_CASE, STR_SAME, 
     .        slen, flen, dset_num
      PARAMETER (flen=512)      ! size of variable name string

#ifdef sun
      BYTE      fhol(flen)      ! c-type Hollerith string buffer
#else
      INTEGER*1 fhol(flen)      ! c-type Hollerith string buffer
#endif 

      attid = 0
      status = atom_not_found

      dset_num = dset
      IF (dset_num .LT. -2) dset_num = -2

      abuff = ""
      abuff = attname

      slen = TM_LENSTR1( abuff )

* If the name is a pseudo-name for describing attributes then return attid=0.
* If a file contains one of these names as an attribute, it can be accessed
* by putting it in quotes.
* coordnames are coordinate variables (dimensions that are also coordinate variables).

      IF (STR_SAME(abuff(:slen), 'varnames') .EQ. 0 ) THEN
         RETURN
      ELSE IF (STR_SAME(abuff(:slen), 'nvars') .EQ. 0 ) THEN
         RETURN
      ELSE IF (STR_SAME(abuff(:slen), 'ncoordvars') .EQ. 0 ) THEN
         RETURN
      ELSE IF (STR_SAME(abuff(:slen), 'attnames') .EQ. 0 ) THEN 
         RETURN
      ELSE IF (STR_SAME(abuff(:slen), 'nattrs') .EQ. 0 ) THEN
         RETURN
      ELSE IF (STR_SAME(abuff(:slen), 'dimnames') .EQ. 0 ) THEN
         RETURN
      ELSE IF (STR_SAME(abuff(:slen), 'coordnames') .EQ. 0 ) THEN
         RETURN
      ELSE IF (STR_SAME(abuff(:slen), 'ndims') .EQ. 0 ) THEN
         RETURN
      ELSE IF (STR_SAME(abuff(:slen), 'nctype') .EQ. 0 ) THEN
         RETURN
      ENDIF

* If the name is in quotes, remove them and do a case-sensive search
* for the name.

      slen = TM_LENSTR1( abuff )
      IF (abuff(1:1) .EQ. "'" .AND. abuff(slen:slen) .EQ. "'" ) THEN
         abuff = abuff(2:slen-1)
         abuff(slen-1:slen) = ""
         slen = slen - 2
         CALL TM_FTOC_STRNG( abuff(1:slen), fhol, flen )
         status = NCF_GET_VAR_ATTR_ID_CASE(dset_num, varid, fhol, attid)
      ELSE 
         CALL TM_FTOC_STRNG( abuff(1:slen), fhol, flen )
         status = NCF_GET_VAR_ATTR_ID(dset_num, varid, fhol, attid)
      ENDIF
      
      dset = dset_num  ! if changed above, then dset=-1 (which is
                       ! pdset_uvars in ferret.parm) is correct

 5000 RETURN
      END

	SUBROUTINE TM_GET_LINEMATCH_SUB (gvn, tst, dup_name, dup_guts)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Searches the list of pre-defined line_name's and returns the number
* associated with a "match" on lname. A match means that the the characters
* of lname are all found plus, optionally, digits. If no match is found
* the value unspecified_int4 is returned.

* dup_name - returned TRUE if there is an identical name match
* dup_guts - returned TRUE if there is a pattern name match AND the guts
*	     are identica


* V510 *sh* 4/00
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files
* V698  3/16 *acm* Removed Philander-Seigel code including diagnostic variables, 
* pre-defined axes and grids.

* Include files
#include "tmap_dset.parm"	
	include 'tmap_dims.parm'	! 
#include "gt_lib.parm"
	include 'xtm_grid.cmn_text'	! pre-defined grid common
	external xgt_grid_data

* argument variables
	LOGICAL		dup_name, dup_guts
	INTEGER		gvn, tst

* local variable declarations
	LOGICAL		TM_SAME_LINE_DEF
	INTEGER*4	TM_LENSTR1, STR_CASE_BLIND_COMPARE
	INTEGER*4	gvn_len, tst_len, istat, ic
	CHARACTER	lname*128, c*1

* initiaslize
	gvn_len  = TM_LENSTR1(lname)  ! ? why is this here? length of prev. value...
	dup_name = .FALSE.
	dup_guts = .FALSE.
	lname    = line_name(gvn)
	gvn_len  = TM_LENSTR1(lname)

* screen out obvious rejection criteria
	IF ( tst .EQ. gvn ) GOTO 1000	! don't compare to self
	IF ( line_name(tst)  .EQ. char_init16 ) GOTO 1000
	tst_len = TM_LENSTR1( line_name(tst) )
	IF ( tst_len .LT. gvn_len ) GOTO 1000

* test for base name match
	istat = STR_CASE_BLIND_COMPARE
     .			(line_name(tst)(:gvn_len),lname(:gvn_len))
	IF (istat .NE. str_match) GOTO 1000
	IF (tst_len .EQ. gvn_len) dup_name = .TRUE.

* test that only extra digits were added
	DO 90 ic = gvn_len+1, tst_len
	  c = line_name(tst)(ic:ic)
	  IF (  c .LT. '0' .OR. c .GT. '9' ) GOTO 1000
 90	CONTINUE

* found a name pattern match.  Now check if the guts match, too
	dup_guts = TM_SAME_LINE_DEF( gvn, tst )

* not a duplicate definition
 1000	RETURN

	END

	SUBROUTINE DO_AUX_VAR_REGRID(  axis_list, naxis, aux_has_cell_pts,
     .				      src,  msrc,  src_cx,
     .				      dst,  mdst,  dst_cx,
     .				      aux1, maux1, aux1_cx,
     .				      aux2, maux2, aux2_cx,
     .				      aux3, maux3, aux3_cx,
     .				      status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* perform a dispatch of regridding to the rountine appropriate
! for the dimensionailty

* v685 4/13-4/14 *sh*
* v689+ 3/15 *sh* added support for T axis T-F orthoganalization
*       5/15 *sh* allow non-monotonic aux points 

        IMPLICIT NONE
        include 'tmap_dims.parm'
        include 'errmsg.parm'
	include	'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'

* calling argument declarations:
	LOGICAL	aux_has_cell_pts
	INTEGER	naxis, axis_list(naxis), status,
     .		msrc, mdst, maux1, maux2, maux3,
     .		src_cx, dst_cx, aux1_cx, aux2_cx, aux3_cx
        REAL    src(*), dst(*), aux1(*), aux2(*), aux3(*)

* internal variable declarations
	INTEGER	axis, indmin_dst, indmax_dst, slen
	CHARACTER  LEFINT*8, cn*8

	IF ( naxis .EQ. 1) THEN

* initialize
	   axis = axis_list(1)

	   IF ( axis .EQ. t_dim
     .    .AND. cx_regrid_trans(axis,dst_cx) .EQ. pauxrgrd_fmrc) THEN
* do the 1D T axis T-F orthoganalization
	      CALL DO_AUX_VAR_REGRID_1D_T(
     .			axis,
     .			src,  msrc,  src_cx,
     .			dst,  mdst,  dst_cx,
     .			aux1, maux1, aux1_cx,
     .			cx_lo_ss(dst_cx,t_dim),cx_hi_ss(dst_cx,t_dim) )

	   ELSE
* if this is a "1pt false regridding", in which there is no new target axis
* such as results from Z=0 or Z=100:200@ave, then the cx_ss values are
* -999:-999.  To avoid accidental "bad value" interpretations we replace those
	      IF (cx_aux_stat(axis,dst_cx)
     .	     .EQ. paux_stat_false_1pt_regrid) THEN
	         indmin_dst = 1   ! replacing -999
	         indmax_dst = 1   ! replacing -999
	      ELSE
	         indmin_dst = cx_lo_ss(dst_cx,axis)
	         indmax_dst = cx_hi_ss(dst_cx,axis)
	      ENDIF

* do the 1D regridding
	      CALL DO_AUX_VAR_REGRID_1D(
     .			axis, aux_has_cell_pts,
     .			src,  msrc,  src_cx,
     .			dst,  mdst,  dst_cx,
     .			aux1, maux1, aux1_cx,
     .			cx_lo_ss(aux1_cx,axis),cx_hi_ss(aux1_cx,axis),
     .			cx_lo_ss(src_cx, axis),cx_hi_ss(src_cx, axis),
     .			indmin_dst,           indmax_dst             )
	
	   ENDIF

	ELSEIF (naxis .EQ. 2) THEN
	   IF (axis_list(1).EQ.t_dim .AND. axis_list(2).EQ.f_dim) THEN

* do the 1D T axis T-F orthoganalization
	      CALL DO_AUX_VAR_REGRID_2D_TF(
     .			src,  msrc,  src_cx,
     .			dst,  mdst,  dst_cx,
     .			aux1, maux1, aux1_cx,
     .			cx_lo_ss(dst_cx,t_dim),cx_hi_ss(dst_cx,t_dim) )
	   ELSE
	       STOP 'mystery 2D regrid should not be happening'
	   ENDIF
	ELSE
	       STOP 'mystery N-D regrid should not be happening'
	ENDIF

* success always -- all possible error conditions were anticipated
	RETURN
	END

	SUBROUTINE SETUP_LINE_BUNDLES (zwsid,zwstype)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Routine to set polyline indices bundled and set up the bundles
*	for WS zwsid of type zwstype.
*	J Davison JISAO/PMEL/TMAP 3.23.89
*	*jd* 2.19.92 mod to support atc gks

*       *acm* 8/2001  add polymarker call for PLOT/SYMBOL=DOT  
 
* gsplr: wkid, line index, line type, linewidth scale factor, color index
* gspmr: wkid, marker index, marker type(dot=1), size scale factor (const for dot), color

#ifdef unix
	include		'ws_types.cmn'
#else
	include		'tmap_pplv11inc:ws_types.inc'
#endif

	integer		zwsid,zwstype

******************************************************************************

*	SET UP LINE BUNDLE FOR 'PEN N,0' CALLS -- USE INDEX 19 JD 2.19.92
        call gsplr (zwsid,19,1,1.0,0)

#ifdef atc_gks
	if (zwstype/100 .eq. ws_xwindow/100 .or. zwstype .eq. ws_uis) then
#else
	if (zwstype .eq. ws_xwindow .or. zwstype .eq. ws_uis) then
#endif
*	   XWINDOW (OR UIS) WORKSTATION 
	   call ws_line_bundle (zwsid,zwstype)

	else if (zwstype .eq. ws_ps_mono) then
*	   MONOCHROME POSTSCRIPT ATTRIBUTES
	   call ps_line_bundle (zwsid)

	else if (zwstype .eq. ws_tek4014) then
*	   TEK 4014
	   call tek4014_line_bundle (zwsid)

	else if (zwstype .eq. ws_tek4107) then
*	   TEK 4107
	   call tek4107_line_bundle (zwsid)

	else
*	   SETUP DEFAULT LINE BUNDLES
	   call ws_line_bundle (zwsid,zwstype)
	end if



	return

	end

	LOGICAL FUNCTION IS_AGG_MEMBER( dset, kth, parent, more )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* is the indicated dataset part of kth or more aggregated datasets
!**** NOTE:  THIS ROUTINE (and many others) SHOULD USE THE dset
!****      LIST STRUCTURE RATHER THAN BRUTE-FORCE LOOPS THROUGH ALL DATASETS

* calling arguments
*   dset    - the dataset to be checked to see if it is used in an agg (input)
*   kth     - if more than one parent this specifies whichone to return (input)
*   parent  - the kth agg that owns it (or unspecified_int4 if none) (output)
*   more    - logical to indicate if there are other parents beyond kth 

* programmer - steve hankin
* V695 *sh* 1/16
* V698  3/16 *acm* Remove unneeded xdset_parms.cmn
* V7   *acm*  6/12 Add Union aggregations: DEFINE DATA/AGG/U, ds_type 'UNI'

	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'tmap_errors.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xrisc.cmn'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data

* calling argument declarations:
	LOGICAL more
	INTEGER	dset, kth, parent

* local variable declarations:
	INTEGER	nmemb, imemb, membset, iset, kparent, status


* initialize -- default is "no parent found"
	kparent = 0
	IS_AGG_MEMBER = .FALSE.
	parent = unspecified_int4
	more = .FALSE.

* check all of the aggregations currently open
! note: extremely inefficient loop.  Should use List of aggs
	DO iset = 1, maxdsets
	   IF ( ds_name(iset) .EQ. char_init1024) CYCLE
	   IF (iset .EQ. dset) CYCLE
	   IF ( ds_type(iset).NE.'ENS' .AND. ds_type(iset).NE.'FCT' 
     .		.AND. ds_type(iset).NE.'UNI') CYCLE 

* Get number of agg members in this one
	   CALL CD_GET_AGG_DSET_INFO (iset, nmemb, status)
	   IF (status .NE. ferr_ok) CALL WARN('crptn: isit_agg_member')

* Look through the agg members to see if we are one of them
	   members: DO imemb = 1, nmemb
	      CALL CD_GET_AGG_DSET_MEMBER (iset, imemb, membset, status)
	      IF (status .NE. ferr_ok)  CALL WARN('crptn: isit_agg_member')
	      IF (membset .EQ. dset) THEN
	         kparent = kparent + 1
	         IF (kparent .EQ. kth) THEN
	            parent = iset ! return the kth one found
	            IS_AGG_MEMBER = .TRUE.
	         ELSEIF (kparent .GT. kth) THEN
	            more = .TRUE.
	            RETURN    ! nothing more worth learning
	         ENDIF
	         EXIT members
	      ENDIF
	   ENDDO members

	ENDDO

	RETURN
	END

      SUBROUTINE TAXIS4(TLO,ITIME1,ITIME2,DT,NSMTIC,LABEL,IHDB,IDDB,
     .    TFACT,Y,YFACT,CSIZE,yacross,vgrat,vcolor,vline,color0,
     .    is_hours_axis)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* 
* From taxis0: separate routijne for hour:min labeling on time axes
C V7.1 *acm* 8/2016 Ticket 2466: Graticule lines too dense
* *acm* - 8/16   ticket 1787: restore pen 0 correctly after graticule
* *acm* - 9/16   ticket 2466: graticule lines on major tics by default
* *acm* - 1/17   Fix too-many labels on tic marks. Add year to Month-Day labels
C
C**
C**    @(#)taxis4.f	1.1   12/09/15
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C     THIS ROUTINE PLOTS A TIME AXIS AND LABELS IT WITH THE HOUR, MINUTE.
C     VARIBLES:
C         TLO=X VALUE CORRESPONDING TO THE START TIME.
C         ITIME1 = START TIME (IE.  7708190100)
C                  WE RESTRICT THE PERMISSIBLE START TIMES TO BE
C                  EVEN HOURS.  (THAT IS THE LAST 4 DIGITS OF ITIME1
C                  MUST BE 0)
C         ITIME2 = END TIME (IE   7709072300)
C                  THIS IS THE FIRST HOUR NOT TO BE PLOTTED, AND IT
C                  MUST BE AN EVEN HOUR.
C         DT = SAMPLING RATE IN MINUTES.
C         NSMTIC = NUMBER OF SMALL TICS TO MAKE EACH HOUR.
C         LABEL > 0 IF LABELS ARE TO BE DRAWN ABOVE THE AXIS.
C               = 0 IF NO LABELS ARE TO BE DRAWN.
C               < 0 IF LABEL ARE TO BE DRAWN BELOW THE AXIS.
C         IABS(LABEL) = 1 FOR LABELS OF THE STYLE
C                  1..........1..........1..........1..........1
C                       3           4          5        6
C                                    JUN 7
C         IHDB = PRINT LABELS OF HOURS DIVIBLE BY THIS NUMBER ONLY.
C                IF(IHDB = 0) PRINT NO DAY LABELS.
C         IDDB = PRINT LABELS OF DAYS DIVISIBLE BY THIS NUMBER ONLY.
C                IF(IDDB = 0) PRINT NO MONTH LABELS.
C                THIS VARIBLE ONLY APPLYS WHEN IABS(LABEL) = 1
C         TFACT = (LENGTH OF T AXIS IN INCHES)/(LENGTH OF T AXIS IN USER
C         Y = Y COORDINATE OF TIME AXIS. 
C         YFACT = (LENGTH OF Y AXIS IN INCHES)/(LENGTH OF Y AXIS IN USER 
C         CSIZE = SIZE TO DRAW HOUR LABELS.
C                 DAY LABELS WILL BE 1.5 TIMES AS LARGE.
C
C
C     The original routine was first written by David Mandel in July 1980.
C
	CHARACTER ITIME3*14,DATE*6,BUFF*14,YEAR*4
	CHARACTER ITIME*14,ITIME1*14,ITIME2*14,SYM*21
	COMMON/TICS/TSMX,TLX,TSMY,TLY,IX,IY
	COMMON/AXLWID/XWID,YWID


	REAL*8  DIFF, difft
	REAL*8  td, ytemp1, tfact_d, yfact_d
	REAL    delt, rem, angl
	INTEGER is_hours_axis, labint, ticint, hrint
	LOGICAL hvytic

* Parameters for drawing tics across plot

        REAL yacross
        REAL dash1_1, dash1_2, dash1_3, dash1_4
        REAL dash2_1, dash2_2, dash2_3, dash2_4
        REAL vgrat(4,2)        ! line type: 0=tics only, <0=line, >0=dash lengths 
        INTEGER vcolor(*)      ! pen number for graticule lines
	INTEGER color0	       ! pen number to restore
        LOGICAL vline          ! If true, do the lines across.
        LOGICAL solid1, solid2   ! solid lines across at tics
        LOGICAL dashed1, dashed2 ! dashed lines across at tics
        INTEGER ltic, color1, color2
	LOGICAL heavy_at_labels  ! When lots of tic marks, make heavy 
				 !tic/graticule at the location of labels.

* TMAP interrupt flag
	include 'xinterrupt.cmn'
        include 'century.cmn'  ! with MONYRLAB flag
	
  80	FORMAT(I2.2)
  82	FORMAT(I2.2,':00')
  84	FORMAT(I2.2,':',I2.2)

	difft = DIFF(ITIME1,ITIME2)
	angl = 0.

C     CHECK THE PARAMETERS PASSED TO THE SUBROUTINE.

        IF(ITIME1(13:14)//ITIME1(1:12).GE.
     .	   ITIME2(13:14)//ITIME2(1:12)) STOP',3'

C     SET PARAMETERS.
        TIC = 60./DT  
        TICd = 60./DT  
        NTIC = NSMTIC + 1
        delt = 60.
        labint = 120
	ticint = labint
	hrint = 1
      
! On short-time interval axes, tic and label interval
! for hours axis (is_hours_axis eq 1) if difft > 60,
! then labint, ticint should be on the hour or half hour, so
! multiples of 30.
! for more than 8 hours, label on a multiple of even hours, 
! for more than 12 hours, label on a multiple of 4 hours, 
! up to a max of 36 hours labeled hh:mm (set in taxis_style)

	IF (is_hours_axis.EQ.1) THEN
           labint = 30
           delt = 1.
	   ticint = 5
           IF (difft .GE.  300) labint = 60
           IF (difft .GE.  600) labint = 120
	   IF (difft .GE.  300) ticint = 30
           IF (difft .GE.  800) hrint = 2
           IF (difft .GE. 1200) hrint = 4
        ENDIF
        IF (is_hours_axis.EQ.2) THEN
           labint = 10
           delt = 1
	   ticint = 1
           IF (difft .LE. 30) labint = 5
           IF (difft .LE. 20) labint = 4
           IF (difft .LE. 10) labint = 1
           IF (difft .GE. 60) ticint = 2
           IF (difft .GE. 120) ticint = 4
           IF (difft .GE. 240) ticint = 4
        ENDIF

        tic = delt/dt
        ticd = delt/dt

C set up for plotting graticules across at tic marks
        
        solid1 = (vgrat(1,1).LT.0 .AND. vgrat(2,1).LT.0 .AND.  
     .            vgrat(3,1).LT.0 .AND.  vgrat(4,1).LT.0 )
        solid2 = (vgrat(1,2).LT.0 .AND. vgrat(2,2).LT.0 .AND.  
     .            vgrat(3,2).LT.0 .AND.  vgrat(4,2).LT.0 )
        dashed1 = (vgrat(1,1).GT.0 .OR. vgrat(2,1).GT.0 .OR.  
     .            vgrat(3,1).GT.0 .OR.  vgrat(4,1).GT.0 )
        dashed2 = (vgrat(1,2).GT.0 .OR. vgrat(2,2).GT.0 .OR.  
     .            vgrat(3,2).GT.0 .OR.  vgrat(4,2).GT.0 )

        color1 = vcolor(1)
        color2 = vcolor(2)

        IF (dashed1) THEN
           dash1_1 = vgrat(1,1)
           dash1_2 = vgrat(2,1)
           dash1_3 = vgrat(3,1)
           dash1_4 = vgrat(4,1)
        ENDIF
        IF (dashed2) THEN
           dash2_1 = vgrat(1,2)
           dash2_2 = vgrat(2,2)
           dash2_3 = vgrat(3,2)
           dash2_4 = vgrat(4,2)
        ENDIF
C

	IF(NSMTIC.LT.0)THEN
		IHVY=-8
		INML=-7
	ELSE
		IHVY=-9
		INML=-8
		TDIST = TIC/NTIC
	ENDIF
	IF(LABEL+IX.EQ.0)THEN
		YTEMP=0.0
	ELSE
		YTEMP=TLX*0.5
	ENDIF
	IF(IHDB.NE.0)THEN
	FIHDB=0.0
	ELSE
	FIHDB=-1.4
	ENDIF
	YTEMP1=Y+DBLE(LABEL*(0.9*CSIZE+YTEMP)/YFACT)
      IF(LABEL.LT.0) THEN
      YTEMP2=Y-((4.0+FIHDB)*CSIZE+YTEMP)/YFACT
      ELSE
      YTEMP2=Y+((2.5+FIHDB)*CSIZE+YTEMP)/YFACT
      ENDIF
	IF(LABEL.NE.0)XWID=(4.0+FIHDB)*CSIZE+YTEMP
      T=TLO  ! Time in hours, plot units
      td = tlo
      ITIME=ITIME1
      CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
      TDAY=T

      tfact_d = tfact
      yfact_d = yfact
	
      CALL PLOT(TLO,Y,0,0)
      IF (MOD(imin,labint) .EQ. 0) THEN
         CALL PLOTT7(TLO,Y,TFACT,YFACT,1,IHVY)
      ELSE
	 CALL PLOTT7(TLO,Y,TFACT,YFACT,1,INML)
      ENDIF
	
      CALL TIME1(1,ITIME,2,' ',I3,ITIME3,delt)  ! next time stepping from 1 (arg 1) to 2 (arg 2) -- return ITIME3
      ITIME = ITIME3

c Check whether to make an hour label at the start of the axis
c ihdb is hour-label frequency
      IF (IABS(LABEL).EQ.1 .AND. ihdb.EQ.1) THEN
         IF (IMIN .EQ. 0) THEN
            WRITE(SYM,82) IHR
	    CALL scinot_d(Td,YTEMP1,angl,CSIZE,5,SYM,0,wid,tfact_d, yfact_d)
         ENDIF
      ENDIF

c ----  count number of large tics. If no large tics will be drawn
c ----  then will want to draw graticule lines at the small ones.

c Set itime1, itime3 as above

      ITIME=ITIME1
      CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
      CALL TIME1(1,ITIME,2,' ',I3,ITIME3,delt) 
      ITIME = ITIME3

C      LOOP:
       ltic = 0
  110  CONTINUE

	CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
  	CALL TIME1(1,ITIME,2,' ',I3,ITIME3,delt)
	ITIME=ITIME3


	IF(ITIME(13:14)//ITIME(1:12) .LE.
     .       ITIME2(13:14)//ITIME2(1:12)) THEN
	   IF (difft.LE.12 .AND. sec.EQ.0.) THEN 
	      ltic = ltic+1
           ELSE
	      IF (imin.EQ.0. .AND. ihr.NE.0) ltic = ltic+1
	   ENDIF
           GO TO 110
        ENDIF
     
! IF no large tics, and if graticules at just the large tics were
! requested, then plot graticules at the small tics

	IF (ltic .EQ. 0) THEN   
           IF ( (.NOT.solid2) .AND. (solid1) ) THEN
              solid2 = solid1
              color2 = color1
           ENDIF
           IF ( (.NOT.dashed2) .AND. (dashed1) ) THEN 
              dashed2 = dashed1
              dash2_1 = dash1_1
              dash2_2 = dash1_2
              dash2_3 = dash1_3
              dash2_4 = dash1_4
              color2 = color1
           ENDIF

        ENDIF
     
! IF many large tics, make fewer - at the locations of labels
        heavy_at_labels = ltic .GT. 20

! Restore the state of ITIME, ITIME3
      ITIME=ITIME1
      CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)

      CALL TIME1(1,ITIME,2,' ',I3,ITIME3,delt)
      ITIME = ITIME3

c ----

C     LOOP:
   10 CALL PLOT(T,Y,0,0)
      IF ( interrupted ) RETURN		! TMAP interrupt
      DO 20 I=1,NSMTIC
         CALL PLOTT7(T+FLOAT(I)*TDIST,Y,TFACT,YFACT,1,-7)

         IF ((solid2.OR.dashed2) .AND. vline) THEN ! make line across
            CALL COLOR(color2)
            IF (dashed2) THEN
               CALL DASHSZ(dash2_1,dash2_2,dash2_3,dash2_4)
               CALL DASHES
            ENDIF
            CALL PLOT(T+FLOAT(I)*TDIST,y,0,0) 
            CALL PLOT(T+FLOAT(I)*TDIST,yacross,1,0)
            CALL PLOT(T+FLOAT(I)*TDIST,Y,0,0) 
            CALL COLOR(color0)
            CALL VECTRS
         ENDIF

   20 CONTINUE
      CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
	  
      hvytic = (MOD(imin,labint) .EQ. 0)
      IF (heavy_at_labels) THEN
         hvytic = ( (imin .EQ. 0 .AND. MOD(ihr,hrint).EQ.0) .OR. 
     .              (MOD(imin,labint) .EQ. 0 .AND. hrint.LE.1) )
      ENDIF

      IF(hvytic)THEN
         CALL PLOTT7(T+TIC,Y,TFACT,YFACT,1,IHVY)
	
         IF ((solid1.OR.dashed1) .AND. vline) THEN ! make line across
            CALL COLOR(color1)
            IF (dashed1) THEN
               CALL DASHSZ(dash1_1,dash1_2,dash1_3,dash1_4)
               CALL DASHES
            ENDIF
            CALL PLOT(t+tic,y,0,0) 
            CALL PLOT(t+tic,yacross,1,0)
            CALL PLOT(t+tic,Y,0,0) 
            CALL COLOR(color0)
            CALL VECTRS
         ENDIF
      
      ELSE
         IF (MOD(imin,ticint).EQ.0) THEN
            CALL PLOTT7(T+TIC,Y,TFACT,YFACT,1,INML)
		    
c           graticule line at tic
            IF ((solid2.OR.dashed2) .AND. vline) THEN ! make line across
               CALL COLOR(color2)
               IF (dashed2) THEN
                  CALL DASHSZ(dash2_1,dash2_1,dash2_3,dash2_4)
                  CALL DASHES
               ENDIF
               CALL PLOT(t+tic,y,0,0) 
               CALL PLOT(t+tic,yacross,1,0)
               CALL PLOT(t+tic,Y,0,0) 
               CALL COLOR(color0)
               CALL VECTRS
            ENDIF

         ELSE 
            CALL PLOT(T+TIC,Y,1,0)
         ENDIF

      ENDIF

C THE LABELS

      IF (IABS(LABEL).EQ.1) THEN
         IF (imin .EQ. 0 .AND. MOD(ihr,hrint).EQ.0) THEN
	    WRITE(SYM,82) IHR
	    CALL scinot_d(Td+TICd,YTEMP1,angl,CSIZE,5,SYM,0,wid,tfact_d, yfact_d)
         ELSE
	    IF (MOD(imin,labint) .EQ. 0 .AND. hrint.LE.1) THEN
	       WRITE(SYM,84) ihr, imin
	       CALL scinot_d(Td+TICd,YTEMP1,angl,CSIZE,5,SYM,0,wid,tfact_d, yfact_d)
	    ENDIF
         ENDIF
      ENDIF

      CALL TIME1(1,ITIME,2,' ',I3,ITIME3,delt)
      IF(IDDB.EQ.0.OR.IABS(LABEL).NE.1) GO TO 70
      CALL TIME3(ITIME3,IYR3,IMON3,IDAY3,IHR3,IMIN3,ISEC3,ICEN3)
      IF(IDAY.EQ.IDAY3) GO TO 70
      IF(IDAY.NE.IDDB*(IDAY/IDDB))GO TO 60
C             ELSE:
      IF(T-TDAY.GT.180./DT)THEN
         CALL TIME2(ITIME,SYM)
	 READ(SYM,55) DATE, YEAR
55	 FORMAT(6X,A6,1X,A4)
65       FORMAT(A6,1X,A4)
         WRITE (BUFF, 65) DATE, YEAR
         TSYM=TDAY+(T+TIC-TDAY-SYMWID(CSIZE,14,BUFF)/TFACT)*.5
         CALL SYMBEL(TSYM,YTEMP2,angl,CSIZE,14,BUFF)
      ENDIF
   60 TDAY=T+TIC
   70 CONTINUE
      ITIME=ITIME3
      T=T+TIC
      td = td + ticd
      t=td

      IF(ITIME(13:14)//ITIME(1:12) .LE.
     .   ITIME2(13:14)//ITIME2(1:12)) GO TO 10

      IF(IDDB.EQ.0) RETURN

      IF(IABS(LABEL).EQ.1.AND.IDAY.EQ.IDDB*(IDAY/IDDB) ) THEN
         IF (IHR3 .GE. 4) THEN
           CALL TIME2(ITIME,SYM)
	   READ(SYM,55) DATE, YEAR
	   WRITE (BUFF, 65) DATE, YEAR
           TSYM=TDAY+(T-TDAY-SYMWID(CSIZE,14,BUFF)/TFACT)*.5
           CALL SYMBEL(TSYM,YTEMP2,angl,CSIZE,14,BUFF)
         ENDIF
      ENDIF

c Finish out the line
      CALL PLOT (tlo,y,0,0)
      t = TLO + DIFF(ITIME1, ITIME2)/dt
      CALL PLOT (t,y,1,0)
      CALL COLOR(color0)

      RETURN
      END

	CHARACTER*(*) FUNCTION GCF_NAME( ifcn )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* return the name of a grid changing function from its ID number

* V450: 1/97
*       97.07.16 *jc* adding code to allow call to efcn_get_name()
* V500: 3/99 *jc* convert external function names to upper case
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

* calling argument declarations
	INTEGER ifcn

* internal variable declarations
        INTEGER STR_UPCASE, status
	CHARACTER text*40

* internal parameter declarations:
        INTEGER      slen
        PARAMETER  ( slen = 40 )
 
#ifdef sun
        BYTE      fhol(slen)    ! c-type Hollerith string buffer
#else
        INTEGER*1 fhol(slen)    ! c-type Hollerith string buffer
#endif
 
	include	'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xgrid_chg_fcns.cmn'

* check the internal grid changing functions first
	IF (ifcn .LT. 0 ) THEN

	   CALL ERRMSG( ferr_internal, status, 'gcf_name', *5000)

	ELSEIF (ifcn .LE. gfcn_num_internal) THEN

	   GCF_NAME = gfcn_name(ifcn)

	ELSE

	   CALL EFCN_GET_NAME(ifcn, fhol)
	   CALL TM_CTOF_STRNG( fhol, text, slen)
           status =  STR_UPCASE(gcf_name,text)

	ENDIF	   
	
* success
	RETURN

* error exit
 5000	GCF_NAME = 'ILLEGAL NAME'
	RETURN

	END

	INTEGER FUNCTION TM_AXIS_DIRECTION( iaxis )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* decode the "line_direction" to a simple axis

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* revision 0.0 3/92 for TMAP library
* 10/96 *kob* - Linux port - had to move variable assignments off of
*		declaration line.
* v553 6/03 *acm*  cd_read_1_axis may assign 'XX' or 'YY' to line_direction
*                  based on value of AXIS attribute. Or DEFINE_AXIS may 
*                  use these for non-lat/lon axes. Assign the axis the 
*                  corresponding direction.
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing
* V710 9/16 *acm* Use ww_dim_name from xtext_info.cmn
* V710 1/17 *acm* Recognize generic FF axis direction (FI is forecast-time specific)

        include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
        include 'xtm_grid.cmn_text'
	include 'xtext_info.cmn'  ! with ww_dim_name

* calling argument declarations:
      INTEGER  iaxis

* internal variable declarations:
* *kob* explicit definitions not allowed on decl line in linux...
*       moved it to parameter line 10/96
      INTEGER STR_UPCASE, idim, istat
      CHARACTER*1 c1
      CHARACTER*2 orient

* initialize
      orient = line_direction(iaxis)

* check the obvious
      DO 100 idim = 1, nferdims
         IF ( orient .EQ. axis_orients(idim) ) THEN
            TM_AXIS_DIRECTION = idim
            RETURN
         ENDIF
 100  CONTINUE

* other previously determined orientations
      IF ( orient .EQ. 'UD' ) THEN
         TM_AXIS_DIRECTION = z_dim
      ELSEIF (orient .EQ. 'EW' ) THEN
         TM_AXIS_DIRECTION = x_dim
      ELSEIF (orient .EQ. 'XX' ) THEN
         TM_AXIS_DIRECTION = x_dim
      ELSEIF (orient .EQ. 'YY' ) THEN
         TM_AXIS_DIRECTION = y_dim
      ELSEIF (orient .EQ. 'TT' ) THEN
         TM_AXIS_DIRECTION = t_dim
      ELSEIF (orient .EQ. 'FF' ) THEN
         TM_AXIS_DIRECTION = f_dim
      ELSE
         TM_AXIS_DIRECTION = 0
      ENDIF

* last ditch attempt based on axis name and units
* ACM V6.8: Dont do this! Sets ETA to an E axis for instance.
* See ticket 1955.

c      IF ( TM_AXIS_DIRECTION .EQ. 0 ) THEN
c         istat = STR_UPCASE( c1, line_name(iaxis)(1:1) )
c         DO 200 idim = 1, nferdims
c 200     IF ( c1 .EQ. ww_dim_name(idim) ) TM_AXIS_DIRECTION = idim
c      ENDIF

      RETURN
      END

	SUBROUTINE DD2STEP ( idim, arg, com_lo, com_hi,
     .			     com, com_mr,
     .			     res, res_mr, res_cx,
     .			     box	)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute centered derivative of component along axis idim

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:	10/11/89 - modified array declarations using XMEM_SUBSC.CMN
* V230: 5/6/92 - COS correction checks that J location is defined         
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
*       2/12 *kms* Include E and F dimensions (use nferdims in tmap_dims.parm)
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include	'xprog_state.cmn'
	include 'xunits.cmn_text'
	external xunits_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data

* calling argument declarations:
	INTEGER	idim, com_lo, com_hi, com_mr, com_cx, res_mr, res_cx
	REAL	arg,
     .		box( com_lo:com_hi ),
     .          com( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          res( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif )

* internal variable declarations:
	LOGICAL	GEOG_COS_FACTOR, ITSA_TRUEMONTH_AXIS, need_cos
	INTEGER i, j, k, l, m, n, ii, grid,
     .          lo_sub(nferdims), hi_sub(nferdims), axis
	REAL	bad_com, bad_res, lo_com, hi_com, unit, cos_factor,
     .          ybxlo, ybxhi, bx
	REAL*8	TM_WORLD, lo_ww, hi_ww

* internal (convenience) equivalences
	INTEGER	lo_s1, lo_s2, lo_s3, lo_s4, lo_s5, lo_s6,
     .          hi_s1, hi_s2, hi_s3, hi_s4, hi_s5, hi_s6
	EQUIVALENCE (lo_s1, lo_sub(1)) , (lo_s2, lo_sub(2)),
     .		    (lo_s3, lo_sub(3)) , (lo_s4, lo_sub(4)),
     .		    (lo_s5, lo_sub(5)) , (lo_s6, lo_sub(6)),
     .		    (hi_s1, hi_sub(1)) , (hi_s2, hi_sub(2)),
     .		    (hi_s3, hi_sub(3)) , (hi_s4, hi_sub(4)),
     .		    (hi_s5, hi_sub(5)) , (hi_s6, hi_sub(6))

* diagnostic mode output: " doing --> VAR_NAME[x=lo:hi@TRN:n,D=#]"
	IF ( mode_diagnostic ) 	CALL DIAG_OP
     .				( 'doing', isact_class_trans, res_cx, idim )

* initialize
	grid    = mr_grid( res_mr )
	axis    = grid_line( idim, grid )
	bad_com = mr_bad_data( res_mr )
	bad_res = mr_bad_data( com_mr )

* compute limits within which calculation is possible
	DO 10 ii = 1, nferdims
	   lo_sub(ii) = cx_lo_ss(res_cx,ii)
	   hi_sub(ii) = cx_hi_ss(res_cx,ii)
 10	CONTINUE
	lo_sub(idim) = com_lo + 1 
	hi_sub(idim) = com_hi - 1

* create an array of delta H increments
	DO 20 ii = lo_sub(idim), hi_sub(idim)
	   lo_ww = TM_WORLD( ii-1, grid, idim, box_middle )
	   hi_ww = TM_WORLD( ii+1, grid, idim, box_middle )
	   box(ii) = hi_ww - lo_ww
 20	CONTINUE	   

* perform differentiation in standard units if possible
	unit = un_convert( line_unit_code(axis) )
	IF (ITSA_TRUEMONTH_AXIS(axis)) unit = un_convert(pun_day)
	DO 30 ii = lo_sub(idim), hi_sub(idim)
 30	box(ii) = box(ii) * unit

* DERIVATIVE ALONG X AXIS
	IF ( idim .EQ. x_dim ) THEN
	   need_cos = GEOG_COS_FACTOR( idim, grid )
     .                .AND. lo_s2.NE.unspecified_int4
	   DO 110 j = lo_s2, hi_s2
	   IF ( need_cos ) THEN
#ifdef double_p
	      cos_factor = COS( deg2rad *       
     .            TM_WORLD(j, grid, y_dim, box_middle) ) 
              ybxlo = deg2rad* 
     .            TM_WORLD(j,grid,y_dim,box_lo_lim)
              ybxhi = deg2rad* 
     .            TM_WORLD(j,grid,y_dim,box_hi_lim)
#else
	      cos_factor = COS( deg2rad *       
     .            SNGL( TM_WORLD(j, grid, y_dim, box_middle) ) ) 
              ybxlo = deg2rad* 
     .            SNGL( TM_WORLD(j,grid,y_dim,box_lo_lim) )
              ybxhi = deg2rad* 
     .            SNGL( TM_WORLD(j,grid,y_dim,box_hi_lim) )
#endif
              bx = ABS(ybxhi - ybxlo)
	      cos_factor = ABS( SIN(ybxhi) - SIN(ybxlo) )/ bx
	   ENDIF
	   DO 110 n = lo_s6, hi_s6
	   DO 110 m = lo_s5, hi_s5
	   DO 110 l = lo_s4, hi_s4
	   DO 110 k = lo_s3, hi_s3
	      DO 100 i = lo_s1, hi_s1
	         lo_com = com(i-1,j,k,l,m,n)
	         hi_com = com(i+1,j,k,l,m,n)
	         IF ( lo_com.EQ.bad_res .OR. hi_com.EQ.bad_res ) THEN
	            res(i,j,k,l,m,n) = bad_res
	         ELSE
	            res(i,j,k,l,m,n) = (hi_com-lo_com) / box(i)
	            IF ( need_cos )
     .                 res(i,j,k,l,m,n) = res(i,j,k,l,m,n)/cos_factor
	         ENDIF
 100	      CONTINUE
 110	   CONTINUE

* DERIVATIVE ALONG Y AXIS
	ELSEIF ( idim .EQ. y_dim ) THEN
	   DO 210 n = lo_s6, hi_s6
	   DO 210 m = lo_s5, hi_s5
	   DO 210 l = lo_s4, hi_s4
	   DO 210 k = lo_s3, hi_s3
	   DO 210 i = lo_s1, hi_s1
	      DO 200 j = lo_s2, hi_s2
	         lo_com = com(i,j-1,k,l,m,n)
	         hi_com = com(i,j+1,k,l,m,n)
	         IF ( lo_com.EQ.bad_res .OR. hi_com.EQ.bad_res ) THEN
	            res(i,j,k,l,m,n) = bad_res
	         ELSE
	            res(i,j,k,l,m,n) = (hi_com-lo_com) / box(j)
	         ENDIF
 200	      CONTINUE
 210	   CONTINUE

* DERIVATIVE ALONG Z AXIS
	ELSEIF ( idim .EQ. z_dim ) THEN
	   DO 310 n = lo_s6, hi_s6
	   DO 310 m = lo_s5, hi_s5
	   DO 310 l = lo_s4, hi_s4
	   DO 310 j = lo_s2, hi_s2
	   DO 310 i = lo_s1, hi_s1
	      DO 300 k = lo_s3, hi_s3
	         lo_com = com(i,j,k-1,l,m,n)
	         hi_com = com(i,j,k+1,l,m,n)
	         IF ( lo_com.EQ.bad_res .OR. hi_com.EQ.bad_res ) THEN
	            res(i,j,k,l,m,n) = bad_res
	         ELSE
	            res(i,j,k,l,m,n) = (hi_com-lo_com) / box(k)
	         ENDIF
 300	      CONTINUE
 310	   CONTINUE

* DERIVATIVE ALONG T AXIS
	ELSEIF ( idim .EQ. t_dim ) THEN
	   DO 410 n = lo_s6, hi_s6
	   DO 410 m = lo_s5, hi_s5
	   DO 410 k = lo_s3, hi_s3
	   DO 410 j = lo_s2, hi_s2
	   DO 410 i = lo_s1, hi_s1
	      DO 400 l = lo_s4, hi_s4
	         lo_com = com(i,j,k,l-1,m,n)
	         hi_com = com(i,j,k,l+1,m,n)
	         IF ( lo_com.EQ.bad_res .OR. hi_com.EQ.bad_res ) THEN
	            res(i,j,k,l,m,n) = bad_res
	         ELSE
	            res(i,j,k,l,m,n) = (hi_com-lo_com) / box(l)
	         ENDIF
 400	      CONTINUE
 410	   CONTINUE

* DERIVATIVE ALONG E AXIS
	ELSEIF ( idim .EQ. e_dim ) THEN
	   DO 510 n = lo_s6, hi_s6
	   DO 510 l = lo_s4, hi_s4
	   DO 510 k = lo_s3, hi_s3
	   DO 510 j = lo_s2, hi_s2
	   DO 510 i = lo_s1, hi_s1
	      DO 500 m = lo_s5, hi_s5
	         lo_com = com(i,j,k,l,m-1,n)
	         hi_com = com(i,j,k,l,m+1,n)
	         IF ( lo_com.EQ.bad_res .OR. hi_com.EQ.bad_res ) THEN
	            res(i,j,k,l,m,n) = bad_res
	         ELSE
	            res(i,j,k,l,m,n) = (hi_com-lo_com) / box(m)
	         ENDIF
 500	      CONTINUE
 510	   CONTINUE

* DERIVATIVE ALONG F AXIS
	ELSEIF ( idim .EQ. f_dim ) THEN
	   DO 610 m = lo_s5, hi_s5
	   DO 610 l = lo_s4, hi_s4
	   DO 610 k = lo_s3, hi_s3
	   DO 610 j = lo_s2, hi_s2
	   DO 610 i = lo_s1, hi_s1
	      DO 600 n = lo_s6, hi_s6
	         lo_com = com(i,j,k,l,m,n-1)
	         hi_com = com(i,j,k,l,m,n+1)
	         IF ( lo_com.EQ.bad_res .OR. hi_com.EQ.bad_res ) THEN
	            res(i,j,k,l,m,n) = bad_res
	         ELSE
	            res(i,j,k,l,m,n) = (hi_com-lo_com) / box(n)
	         ENDIF
 600	      CONTINUE
 610	   CONTINUE

	ENDIF

	RETURN
	END

	SUBROUTINE CD_RD_YMD_ARR(cdfid,t1id,t0,tunit,n,darr,status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* read an array of time values from a "yymmddhhmmss" time axis
* if T0 is not yet known determine an appropriate value
* return time values as a double precision time relative to t0

* NOTE:  This routine could be grestly optimized for performance.
*     This version calls CD_RD_ARR_1 for each point.
*     Instead it could break apart T0 only once and use array reads to read
*     The double integers directly into the returned double precision array
*     The integers could then be re-arranged into pairs and converted to 
*     TMAP times in place.

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 2/95

* argument definitions:
*	cdfid	 - netCDF id number for already opened CDF file
*       t1id     - netCDF variable id of "time"
*       t0       - T0 string for the time axis
*       tunit    - number of seconds per axis time unit
*       n        - number of time values to return
*       darr     - double precision array returned
*       status   - TMAP library return status

* argument declarations
      INTEGER cdfid, t1id, n, status
      REAL tunit
      REAL*8  darr(n)
      CHARACTER*(*) t0

#ifdef unix
      include 'tmap_errors.parm'
#else
      INCLUDE 'TMAP_FORMAT:TMAP_ERRORS.PARM'
#endif

* internal variable declarations:
      INTEGER i

      DO 100 i = 1, n
 100  CALL CD_RD_YMD_1(cdfid,t1id,t0,tunit,i,darr(i),status)

      RETURN

      END

	SUBROUTINE LEVPRS(PRSE,VAL,INTIF,IER,IPOS)
C** 
C**    @(#)levprs.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	*jd* MOD 3.29.93 READ fails on SGI with comma in string.  Eliminate.
*	*jd* MOD 11.1.94 READ fails on IBM AIX without it.  Put back in.
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
* v552 *acm* 3/03 Longer strings: changes for multi-line labels.
* v580 *acm* 8/04 Change use of 256 to buflen+1, 
*                 where buflen is defined in cmndlen.inc
* v581 *acm* 3/05 open levels (-INF) (INF)

        INCLUDE 'cmndlen.inc'
	INCLUDE 'parampl5_dat.decl'
        INCLUDE 'PARAMPL5.DAT'
	INCLUDE 'cont_inc.decl'
	INCLUDE 'CONT.INC'

	LOGICAL BLNK
	CHARACTER PRSE*(*)

*       variable IF renamed to INTIF for MAC *jd* 7.92

	DIMENSION VAL(4),INTIF(4)
	IER=0
	IPOS=1
	I=1
30	ICM=INDEX(PRSE,',')
	IF(ICM.EQ.0)ICM=buflen+1
	IBL=INDEX(PRSE,' ')
	IF(IBL.EQ.0)IBL=buflen+1
	ISTPP=MIN0(ICM,IBL,buflen)
	BLNK=PRSE(ISTPP:ISTPP).EQ.' '
	IF(ISTPP.NE.1)THEN
		INTIF(I)=1
                val(i) = 0
                IF (prse(:istpp-1) .EQ. 'INF') THEN
                   posinf = .TRUE.
                   RETURN
                ENDIF
                IF (prse(:istpp-1) .EQ. '-INF') THEN
                   neginf = .TRUE.
                   RETURN
                ENDIF
		PRSE(ISTPP:ISTPP)=','

#ifdef AIX_XLF
		READ(PRSE(:ISTPP),996,ERR=1000)VAL(I)
#else
		READ(PRSE(:ISTPP-1),996,ERR=1000)VAL(I)
#endif
996		FORMAT(E20.0)
	ENDIF
20	ISTPP=ISTPP+1
	IF(ISTPP.GT.buflen)GOTO 40
	IF(PRSE(ISTPP:ISTPP).EQ.' '.OR.
     *	(BLNK.AND.PRSE(ISTPP:ISTPP).EQ.','))GOTO 20
	PRSE=PRSE(ISTPP:)
	IPOS=IPOS+ISTPP-1
	I=I+1
	IF(I.LE.4)GOTO 30
40	RETURN
1000	IER=9
	RETURN
	END

	subroutine conseg(z,nxs,nys,px,py,nx,ny,xf,xoff,yf,yoff,
     *	zlev,ndecl,lwgtl,lclr,nlev,hgt,narc,ang,status) 
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)conseg.F	1.2    7/30/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
c
C 
C       lots of places ---> PPLMOD_PPLCMD ---> PPLMOD_PLTIT 
C       ---> PPLMOD_PLOTZ ---> PPLMOD_CONSEG
C       
C       This subroutine plots contours of grid z(i,j) in square segments
C       of length lseg grid units per side.
C       
C       z      - actual 2-D array of data values to be contoured
C       nxs    - number of X grid points
C       nys    - number of Y grid points
C       px     - array of grid points along the X axis
C       py     - array of grid points along the Y axis
C       nx     - number of X grid points
C       ny     - number of Y grid points
C       xf     - factor to go from X axis to page coordinates?
C       xoff   - X axis offset in page coordinates?
C       yf     - factor to go from Y axis to page coordinates?
C       yoff   - Y axis offset in page coordinates?
C       zlev   - array of contour level values (lo val --> hi val)
C       ndecl  - number of decimal places in the contour labels
C       lwgtl  - weight of the contour line
C       lclr   - 
C       nlev   - number of levels to use
C       hgt    - height of characters of labels in inches
C       narc   - number of arc subsegments to use in contouring
C       ang    - angle to rotate the contour plot
C       
C       
C	oceanography emr  dec/1969 
C       *jc* 5.97 Major clean up and commenting
C       *jc* 5.97 Added code for curvilinear coordinates
C      *acm* v581 5/2005 Add CONTOUR/MOD capability for modulo
C                 replications on curvilinear data
C V602 *acm* 2/07 check status coming out of CURV_COORD_RANGE; part of fix to bug 1485
C V617 *acm* 1/09 Initialize the status flag (fixes bug 1622)
* V687 *acm* 3/14 tickets 2151 and 2147: allow missing coordinate data in 3-arg 
*                 and 4-arg plot commands. 

	include 'miss_inc.decl'
	include 'MISS.INC'
        include 'xcurvilinear.cmn'
        include 'errmsg.parm'

	dimension z(nxs,nys),px(nx),py(ny)
	dimension zlev(2),ndecl(2),lwgtl(2),lclr(2)

        real xadd, lmin, lmax, big
	integer error,trans_no, ilo, ihi, jlo, jhi, status
	real xinv,yinv,w(4),v(4),ndc(4),uc(4)

	status = ferr_ok

C       Calculate center point about which to rotate plot
C       Plot will be rotated by 'ang' degrees.

	xc = (px(1)+px(nx))*0.5
	yc = (py(1)+py(ny))*0.5

* Get range of indices for the curvi X,Y coordinates actually needed for the 
* hlimits, vlimits that were requested.

*	GET PROPER SCALING, NDC COORDINATES, ETC FOR FILL
        IF (curvilinear) THEN 
	   CALL gqcntn (error,trans_no)
	   IF (error .NE. 0) GOTO 1000

	   CALL gqnt (trans_no,error,w,v)
	   IF (error .NE. 0) GOTO 1000

	   CALL get_user_coords (w,v,ndc,uc,xinv,yinv)

           CALL CURV_COORD_RANGE (uc, ilo, ihi, jlo, jhi, status )
           IF (status .NE. ferr_ok) goto 1000
        ENDIF
      
        big = ABS(CMXGE)
        lmin = big
        lmax = -1*big
        xadd = 0.

        CALL CONSEG_SECTION(xc, yc, nx, ny, nxs, nys, px, py, z, 
     .    xf, xoff, yf, yoff, zlev, ndecl, lwgtl, lclr, nlev, hgt, 
     .    narc, ang, ilo, ihi, jlo, jhi, xadd, lmin, lmax)

        IF (xmodulo .AND. curvilinear) THEN
           nleft = 0
           nright = 0
           IF (lmin .GT. uc(1) ) nleft =  1 + INT(lmin - uc(1) )/ 360
           IF (lmax .LT. uc(2) ) nright = 1 + INT(uc(2) - lmax )/ 360

           IF (nleft .GT. 0) THEN
              xadd = 0.
              DO 100 i = 1, nleft
                 xadd = xadd - 360.
                 CALL CONSEG_SECTION(xc, yc, nx, ny, nxs, nys, px, py,z,
     .          xf, xoff, yf, yoff, zlev, ndecl, lwgtl, lclr, nlev, hgt, 
     .          narc, ang, ilo, ihi, jlo, jhi, xadd, lmin, lmax)

 100          CONTINUE
           ENDIF

           IF (nright .GT. 0) THEN
              xadd = 0.
              DO 110 i = 1, nright
                 xadd = xadd + 360.
                 CALL CONSEG_SECTION(xc, yc, nx, ny, nxs, nys, px, py,z,
     .          xf, xoff, yf, yoff, zlev, ndecl, lwgtl, lclr, nlev, hgt, 
     .          narc, ang, ilo, ihi, jlo, jhi, xadd, lmin, lmax)
 110          CONTINUE
           ENDIF


        ENDIF   ! xmodulo



1000    return 
	end 

	SUBROUTINE DELETE_USER_VAR_SUB ( uvar, dset )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* delete a user-defined variable (7/97) ON THE ASSUMPTION THAT IT HAS
* NO CHILDREN (children are handled by DELETE_USER_VAR)
* this involves not only eliminating the variable from the list of user var
* definitions but also eliminating in memory any stored grids that depend on
* this variable AND eliminating from memory any stored grids of other user vars
* whose definitions depend on this variable
*  eg DEFINE VARIABLE TEST1 = SALT / 1000
*     DEFINE VARIABLE TEST2 = TEST1^2
*     DEFINE VARIABLE TEST3 = TEST2^2
* if DELETE_USER_VAR is called to delete TEST1 it must also eliminate all stored
* grids of TEST2 and TEST3

* ==> ***NOTE** The process of locating dependencies is a crude, inefficient
* hunt based upon scanning the text of uvar definitions to locate dependent
* variables.  Leveraging on the uvarGrid LIST structures that each ncvar has
* (see NCF_Util.h), a "descendent" list could be managed for each variable
* -- e.g. in IS_UVAR_GRID -- as the grid of a variable is being determined, it
* can add itself to a list maintained by each of children (because the child's
* grid must already exist fore the current (parent) grid to be determined


* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* revision 0.0 - 2/23/87
* Ultrix/RISC port - 2/91 - eliminated dependency on VAX STR$ routine
*     10/22/92 - increased uvar name length

* V420 9/95 - When user variable is deleted release any claim on dynamic grids
* V450 7/97 - renamed to DELETE_USER_VAR_SUB from DELETE_USER_VAR
* V510 2/00 *sh* - with the advent of "child variables" created by grid
*	changing variables deleting a user variable must also remove the name
*	of the (child) variable
* V600  4/06 *acm* - remove deleted variable defs from the linked-list structure
*                    that does attribute handling
* V600  4/06 *acm* - additional declarations found by Solaris compiler
* V602 12/06 *acm* - When removeing var from the user-variables dataset in
*                    linked-list structure, no need to check for  EX# expressions
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V695+ 5/15 *sh* - free cached c array, if any
* V695  7/15 *acm - reinitialize value of uvar_aux_stat to zero
* V698  2/16 *acm* For ticket 2352: variables defined with LET/D are
*                  added to that dataset in the attribute structure.
* V699 6/16 *sh* treat EX# variables just like other variables

        IMPLICIT NONE
        include 'tmap_dims.parm'
        include 'xtm_grid.cmn_text'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'interp_stack.parm'
	include 'xprog_state.cmn'
	include 'xvariables.cmn'
	include 'xrisc.cmn'

* calling argument declarations:
	INTEGER	uvar, dset

* internal variable declarations:
	INTEGER		STR_UPCASE, TM_LENSTR, TM_LENSTR1,du_list(max_uvar), 
     .			ndu, kdu, uv, vax_code,ind, i, j, num_indices, iset, 
     .			varid, slen, flen, status
	CHARACTER*24	check_name

      PARAMETER (flen=128)      ! size of variable name string

#ifdef sun
      BYTE      fhol(flen)      ! c-type Hollerith string buffer
#else
      INTEGER*1 fhol(flen)      ! c-type Hollerith string buffer
#endif 


* procedure:
*	generate a list of all user variables depending on the named uvar
*	then eliminate all refs. to all vars in the list

* variables:
*	du_list	- list of user variables that must be cleared from memory
*	ndu	- number of variables in list
*	kdu	- variable in du_list for which dependencies are being checked

* initialize list of variables to be cleared from memory
	du_list( 1 ) = uvar
	ndu = 1
	kdu = 1

* look through the stored uvar definitions for dependencies
* note: this search depends on uvar_name_code being upper case
*	use risc_buff as temporary storage for an upvase version
*	(unnecessary as of 2/91 but possibly lower case in future)
 100	check_name = uvar_name_code( du_list( kdu ) )	! upper case

*	DO 200 uv = 1, max_uvar
*	   IF ( uvar_num_items( uv ) .EQ. uvar_deleted ) GOTO 200
        CALL deleted_list_get_undel(uvar_num_items_head,
     .                              deleted_list_result(1),
     .                              max_uvar, num_indices )
        DO 200 j = 1, num_indices
           uv = deleted_list_result(j)
	   vax_code = STR_UPCASE( risc_buff, uvar_text( uv ) )
	   ind = INDEX( check_name, risc_buff )
	   IF ( ind .EQ. 0 ) GOTO 200

* make sure this user variable is not already in the list
	   DO 110 i = 1, ndu
	      IF ( du_list( i ) .EQ. uv ) GOTO 200
 110	   CONTINUE

* add another dependent variable to the list
	   ndu = ndu + 1
	   du_list( ndu ) = uv

 200	CONTINUE

* done checking for dependencies on this.  More to check ?
	kdu = kdu + 1
	IF ( kdu .LE. ndu ) GOTO 100

* eliminate all memory grids for variables in the list
	DO 300 i = 1, ndu
 300	CALL PURGE_USER_VAR( du_list( i ) )

* if this user variable is associated with any dynamic grids release them
	CALL DEALLO_UVAR_GRIDS(uvar)

* if there is a c cache of the full range variable, free it
* note: this addition remained untested at the time it was entered
	IF (uvar_c_cache_ptr(uvar) .NE. 0.0) CALL FREE_CACHED_FULL_ARRAY
     .						(uvar_c_cache_ptr(uvar))

* eliminate the named variable from the list of uvars
*	uvar_num_items( uvar ) = uvar_deleted
        CALL deleted_list_modify(uvar_num_items_head,uvar,uvar_deleted)

* Remove from linked-list structure, the user-variables dataset
!        slen = TM_LENSTR( uvar_name_code(uvar)  )
!        IF (slen .GT. 0 .AND. uvar_name_code(uvar)(1:3) .NE. 'EX#') THEN
* 6/16 -- treat 'EX#' just like other variables
	   iset = dset
	   CALL CD_GET_VAR_ID (iset, uvar_name_code(uvar), varid, status)
	   IF (status .NE. ferr_ok) THEN
	      iset = uvar_dset(uvar)
	      CALL CD_GET_VAR_ID (iset, uvar_name_code(uvar), varid, status)
	   ENDIF
! ?? *sh* what is the state of things here if status .NE. ferr_ok ??
	   IF (status .EQ. ferr_ok) THEN
              slen = TM_LENSTR1( uvar_name_code(uvar)  )
              CALL TM_FTOC_STRNG( uvar_name_code(uvar)(1:slen), fhol, flen )
              CALL NCF_DELETE_VAR (iset, fhol )
           ENDIF
!	ENDIF

*	uvar_name_code( uvar ) = " "
        CALL string_array_modify(uvar_name_code_head, uvar, " ", 1 )

	uvar_text     ( uvar ) = " "

	IF (uvar_remote (uvar)) THEN
	   rvar_dset (uvar) = 0
	   rvar_varid (uvar) = 0
	   rvar_on_server (uvar) = .FALSE.
	   rvar_uvar (uvar) = 0
	   uvar_remote (uvar) = .FALSE.
	ENDIF
	
* Reinitialize any aux_uvar settings 
        DO 400 i = 1, nferdims
 400        uvar_aux_stat(uvar,i) = paux_stat_init

      
	RETURN
	END

	INTEGER FUNCTION TM_GET_GRID_OF_LINE (line)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Searches the list of predefined and user-defined grid_names and returns the
* number associated with the first grid using the given axis.
* If no match is found the value unspecified_int4 is returned.

* V510 *sh* 5/00 - based on TM_GET_GRIDNUM
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing

# include "tmap_dset.parm"	
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'	! pre-defined grid common
#include "gt_lib.parm"

* input arguments
	INTEGER		line

* local argument declarations
	INTEGER		igrd, idim

* check the static grids
	DO 100 igrd=1,max_grids
	  IF (grid_name(igrd) .EQ. char_init16) GOTO 100
	  DO 90 idim = 1, nferdims
	    IF ( grid_line(idim, igrd) .EQ. line ) THEN
	      TM_GET_GRID_OF_LINE = igrd
	      GOTO 900 
	    ENDIF
 90	  CONTINUE
100	CONTINUE

* check the dynamic grids
	igrd = 0
 200	CALL TM_NEXT_DYN_GRID( igrd, *299)
	  DO 190 idim = 1, nferdims
	    IF ( grid_line(idim, igrd) .EQ. line ) THEN
	      TM_GET_GRID_OF_LINE = igrd
	      GOTO 900 
	    ENDIF
 190	  CONTINUE
	GOTO 200

* not found
 299	TM_GET_GRID_OF_LINE = unspecified_int4

* found
 900	RETURN
	END

      SUBROUTINE key_hi_inf_vert (px, py, ndx, v_inc,
     .          annotate_key, lab_digits, height)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Make the top box (triangle) for the color key when the upper level is 
* value-to-infinity
*
*  v581 *acm* 3/05 open levels (-INF) (INF)
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus
* V685 *acm* 5/13  changes for ribbon plots

      INCLUDE 	'parampl5_dat.decl'
      INCLUDE 	'PARAMPL5.DAT'
      INCLUDE   'cont_inc.decl'
      INCLUDE	'CONT.INC'           ! with cont_key
      INCLUDE	'axis_inc.decl'
      INCLUDE	'AXIS.INC'
      INCLUDE	'PLTL.INC'
      INCLUDE	'hd_inc.decl'
      INCLUDE	'HD.INC'             ! with zmin, zmax


* Calling arguments
      REAL px(*),py(*), h_inc, height
      INTEGER ndx, annotate_key, lab_digits

* Internal declerations
      INTEGER maxlen, slen, ldigits
      REAL x1, x2, x3, x4, y1, y2, y3, y4
      REAL delx, xx, yy, xxx, yyy
      CHARACTER*20 TM_FMT_SNGL_DIGITS, text

* save px and py values

      y1 = py(1)
      y2 = py(2)
      y3 = py(3)
      y4 = py(4)

      x1 = px(1)
      x2 = px(2)
      x3 = px(3)
      x4 = px(4)

      delx = x3 - x1

      px(3) = x1 + delx/2.
      py(3) = py(1) + v_inc

*	   CALL FILL AREA FOR THIS COLOR/GRAY VALUE
       call set_fill_ndx (ndx)
       call gfa (3,px,py)


* Outline
       px(4) = px(1)
       py(4) = py(1)
       IF (.NOT. cont_key) call gpl (4,px,py)

      IF (annotate_key .GT. 0) THEN
         maxlen = 20
         ldigits = lab_digits+1
         text = TM_FMT_SNGL_DIGITS (zmax,ldigits,maxlen,slen)
	 xx = px(3)/1000.0 - xorg - (slen/2)* height
         yy = py(3)/1000.0 - yorg + 1.1* height
	 
* FILL AND SHADE USE DIFFERENT COORD SYSTEMS -- *jd* 6.4.93
         if (makep .eq. 'SHADE' .or. makep .eq. 'FILLPOL' .OR.
     .         makep .EQ. 'POLYGON' .or. makep .eq. 'RIBPLOT') then
	    call point_convert (xx,yy,xxx,yyy)
         else if (makep .eq. 'FILL') then
	    xxx = xx
	    yyy = yy
         endif

         call symbel (xxx, yyy,0.,height,slen,text(1:slen))
      ENDIF

* Restore px, py

      py(1) = y1
      py(2) = y2
      py(3) = y3
      py(4) = y4

      px(1) = x1
      px(2) = x2
      px(3) = x3
      px(4) = x4

      RETURN
      END

C .................................................................. 

      SUBROUTINE POLY_BOUND_BOX (xv, yv, nv, xvmin, xvmax, yvmin, yvmax)

* Get the bounding box around the polygon. min and max variables
* have been initialized.

      REAL xv(*), yv(*), xvmin, xvmax, yvmin, yvmax
      INTEGER nv
      INTEGER i

      DO 50 i = 1, nv
         xvmin = MIN(xvmin, xv(i))
         xvmax = MAX(xvmax, xv(i))
         yvmin = MIN(yvmin, yv(i))
         yvmax = MAX(yvmax, yv(i))
  50  CONTINUE

      RETURN
      END


C .................................................................. 
	LOGICAL FUNCTION PP_FPEQ ( a, b )
*
*************
* This is a copy of the Ferret function TM_FPEQ. It is included here
* so that the function is a stand-alone function. When and if this
* External Function is statically linked into the Ferret executable,
* We can rename calls to PP_FPEQ back to TM_FPEQ and remove this subroutine.
*************
*
* test to see if REAL*4 floating point numbers are equal to within
* "reasonable" accuracy
* REAL*4 (F_floating) machine error on the VAX is "approximately one part in
* 2**23" or 1.2E-7.  Allow 4.E-7 as machine error after many typical roundoffs.
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.00 - 11/21/85
* revision 0.10 - 10/23/87 - all variables explicitly declared
*
* calling arguments:
	REAL	a, b

* local parameters
	REAL	   VAX_epsilon
	PARAMETER (VAX_epsilon = 4.E-7)

* treat relative error case (non-zero) separate fron zero case

	IF  (a.NE.0.0   .AND.  b.NE.0.0 )  THEN

	   PP_FPEQ =  ABS(a-b) .LE. ABS(b)*VAX_epsilon		! relative error

	ELSE

	   PP_FPEQ =	ABS(a) .LT. VAX_epsilon
     .		.AND.   ABS(b) .LT. VAX_epsilon			! absolute error

	ENDIF
	RETURN
	END

C .................................................................. 
C 
C SUBROUTINE PNPOLY 
C 
C PURPOSE 
C   TO DETERMINE WHETHER A POINT IS INSIDE A POLYGON 
C 
C USAGE 
C   CALL PNPOLY (PX, PY, XX, YY, N, workx, worky, INOUT ) 
C 
C DESCRIPTION OF THE PARAMETERS 
C   PX    - X-COORDINATE OF POINT IN QUESTION. 
C   PY    - Y-COORDINATE OF POINT IN QUESTION. 
C   XX    - N LONG VECTOR CONTAINING X-COORDINATES OF 
C           VERTICES OF POLYGON. 
C   YY    - N LONG VECTOR CONTAING Y-COORDINATES OF 
C           VERTICES OF POLYGON. 
C   N     - NUMBER OF VERTICES IN THE POLYGON. 
C   workx - work array
C   worky - work array
C   INOUT - THE SIGNAL RETURNED: 
C           -1 IF THE POINT IS OUTSIDE OF THE POLYGON, 
C            0 IF THE POINT IS ON AN EDGE OR AT A VERTEX, 
C            1 IF THE POINT IS INSIDE OF THE POLYGON. 
C 
C REMARKS 
C   THE VERTICES MAY BE LISTED CLOCKWISE OR ANTICLOCKWISE. 
C   THE FIRST MAY OPTIONALLY BE REPEATED, IF SO N MAY 
C   OPTIONALLY BE INCREASED BY 1. 
C   THE INPUT POLYGON MAY BE A COMPOUND POLYGON CONSISTING 
C   OF SEVERAL SEPARATE SUBPOLYGONS. IF SO, THE FIRST VERTEX 
C   OF EACH SUBPOLYGON MUST BE REPEATED, AND WHEN CALCULATING 
C   N, THESE FIRST VERTICES MUST BE COUNTED TWICE. 
C   INOUT IS THE ONLY PARAMETER WHOSE VALUE IS CHANGED. 
C   THE SIZE OF THE ARRAYS MUST BE INCREASED IF N > MAXDIM 
C   WRITTEN BY RANDOLPH FRANKLIN, UNIVERSITY OF OTTAWA, 7/70. 
C   
C SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED 
C   NONE 
C 
C METHOD 
C   A VERTICAL LINE IS DRAWN THRU THE POINT IN QUESTION. IF IT 
C   CROSSES THE POLYGON AN ODD NUMBER OF TIMES, THEN THE 
C   POINT IS INSIDE OF THE POLYGON. 
C 
C .................................................................. 
C 
      SUBROUTINE PNPOLY(PX,PY,XX,YY,N,X,Y,INOUT) 
      REAL PX,X(*),Y(*),XX(*),YY(*) 
      INTEGER N, INOUT

      LOGICAL PP_FPEQ, MX,MY,NX,NY, b
      INTEGER I, J, INOUT1, INOUT2
      INOUT1 = 0
      INOUT2 = 0

* Change the original to see if X(J)=Y(J)=0. This loop finds matches 
* for points on the left-hand edges 

    6 DO 1 I=1,N 
      X(I)=XX(I)-PX 
    1 Y(I)=YY(I)-PY 
      INOUT1=-1 
      DO 2 I=1,N 
      J=1+MOD(I,N) 
      MX=X(I).GE.0.0 
      NX=X(J).GE.0.0 
      MY=Y(I).GE.0.0 
      NY=Y(J).GE.0.0 

      IF (PP_FPEQ(X(J),0.) .AND. PP_FPEQ(Y(J),0.)) GOTO 4

      IF(.NOT.((MY.OR.NY).AND.(MX.OR.NX)).OR.(MX.AND.NX)) GO TO 2 
      IF(.NOT.(MY.AND.NY.AND.(MX.OR.NX).AND..NOT.(MX.AND.NX))) GO TO 3 
      INOUT1=-INOUT1 
      GO TO 2
    3 CONTINUE
      IF ( PP_FPEQ(X(J),Y(J)) ) THEN
         IF(PP_FPEQ((Y(I)*X(J)-X(I)*Y(J)),0.)) THEN  
            INOUT1 = 0
            INOUT2 = 0
            GOTO 50
         ENDIF
      ENDIF
      IF( PP_FPEQ((Y(I)*X(J)-X(I)*Y(J))/(X(J)-X(I)), 0.) ) GOTO 4
      IF((Y(I)*X(J)-X(I)*Y(J))/(X(J)-X(I))) 2,4,5 
    4 INOUT1 = 0
      INOUT2 = 0
      GOTO 50
    5 INOUT1=-INOUT1 
    2 CONTINUE 

* Now do the same with the order of subtraction reversed when 
* computing arrays X(I) and Y(I). This finds matches for points 
* on the right-hand edges.

      DO 11 I=1,N 
      X(I)=PX-XX(I)
   11 Y(I)=PY-YY(I) 
      INOUT2=-1 
      DO 12 I=1,N 
      J=1+MOD(I,N) 
      MX=X(I).GE.0.0 
      NX=X(J).GE.0.0 
      MY=Y(I).GE.0.0 
      NY=Y(J).GE.0.0 

      IF (PP_FPEQ(X(J),0.) .AND. PP_FPEQ(Y(J),0.)) GOTO 14

      IF(.NOT.((MY.OR.NY).AND.(MX.OR.NX)).OR.(MX.AND.NX)) GO TO 12 
      IF(.NOT.(MY.AND.NY.AND.(MX.OR.NX).AND..NOT.(MX.AND.NX))) GO TO 13 
      INOUT2=-INOUT2 
      GO TO 12
   13 CONTINUE
      IF ( PP_FPEQ(X(J),Y(J)) ) THEN
         IF(PP_FPEQ(Y(I)*X(J)-X(I)*Y(J), 0.)) THEN  
            INOUT1 = 0
            INOUT2 = 0
            GOTO 50
         ENDIF
      ENDIF
      IF( PP_FPEQ((Y(I)*X(J)-X(I)*Y(J))/(X(J)-X(I)), 0.) ) GOTO 14
      IF((Y(I)*X(J)-X(I)*Y(J))/(X(J)-X(I))) 12,14,15 
   14 INOUT1 = 0
      INOUT2 = 0
      GOTO 50
   15 INOUT2=-INOUT2 
   12 CONTINUE 

* Combine the results: -1 outside the polygon, 0 
* on the edges or vertices, 1 inside the polygon.

   50 CONTINUE
      INOUT = (INOUT2 + INOUT1)/2
      RETURN

      END 

*** ORIG  C >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
*** ORIG  C Here is the exact code from W. Randolph Franklin pages.
*** ORIG  C Fortran Code for the Point in Polygon Test
*** ORIG  
*** ORIG  C>>>PNP1 
*** ORIG  C 
*** ORIG  C .................................................................. 
*** ORIG  C 
*** ORIG  C SUBROUTINE PNPOLY 
*** ORIG  C 
*** ORIG  C PURPOSE 
*** ORIG  C   TO DETERMINE WHETHER A POINT IS INSIDE A POLYGON 
*** ORIG  C 
*** ORIG  C USAGE 
*** ORIG  C   CALL PNPOLY (PX, PY, XX, YY, N, INOUT ) 
*** ORIG  C 
*** ORIG  C DESCRIPTION OF THE PARAMETERS 
*** ORIG  C   PX    - X-COORDINATE OF POINT IN QUESTION. 
*** ORIG  C   PY    - Y-COORDINATE OF POINT IN QUESTION. 
*** ORIG  C   XX    - N LONG VECTOR CONTAINING X-COORDINATES OF 
*** ORIG  C           VERTICES OF POLYGON. 
*** ORIG  C   YY    - N LONG VECTOR CONTAING Y-COORDINATES OF 
*** ORIG  C           VERTICES OF POLYGON. 
*** ORIG  C   N     -  NUMBER OF VERTICES IN THE POLYGON. 
*** ORIG  C   INOUT - THE SIGNAL RETURNED: 
*** ORIG  C           -1 IF THE POINT IS OUTSIDE OF THE POLYGON, 
*** ORIG  C            0 IF THE POINT IS ON AN EDGE OR AT A VERTEX, 
*** ORIG  C            1 IF THE POINT IS INSIDE OF THE POLYGON. 
*** ORIG  C 
*** ORIG  C REMARKS 
*** ORIG  C   THE VERTICES MAY BE LISTED CLOCKWISE OR ANTICLOCKWISE. 
*** ORIG  C   THE FIRST MAY OPTIONALLY BE REPEATED, IF SO N MAY 
*** ORIG  C   OPTIONALLY BE INCREASED BY 1. 
*** ORIG  C   THE INPUT POLYGON MAY BE A COMPOUND POLYGON CONSISTING 
*** ORIG  C   OF SEVERAL SEPARATE SUBPOLYGONS. IF SO, THE FIRST VERTEX 
*** ORIG  C   OF EACH SUBPOLYGON MUST BE REPEATED, AND WHEN CALCULATING 
*** ORIG  C   N, THESE FIRST VERTICES MUST BE COUNTED TWICE. 
*** ORIG  C   INOUT IS THE ONLY PARAMETER WHOSE VALUE IS CHANGED. 
*** ORIG  C   THE SIZE OF THE ARRAYS MUST BE INCREASED IF N > MAXDIM 
*** ORIG  C   WRITTEN BY RANDOLPH FRANKLIN, UNIVERSITY OF OTTAWA, 7/70. 
*** ORIG  C   
*** ORIG  C SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED 
*** ORIG  C   NONE 
*** ORIG  C 
*** ORIG  C METHOD 
*** ORIG  C   A VERTICAL LINE IS DRAWN THRU THE POINT IN QUESTION. IF IT 
*** ORIG  C   CROSSES THE POLYGON AN ODD NUMBER OF TIMES, THEN THE 
*** ORIG  C   POINT IS INSIDE OF THE POLYGON. 
*** ORIG  C 
*** ORIG  C .................................................................. 
*** ORIG  C 
*** ORIG        SUBROUTINE PNPOLY(PX,PY,XX,YY,N,INOUT) 
*** ORIG        REAL X(200),Y(200),XX(N),YY(N) 
*** ORIG        LOGICAL MX,MY,NX,NY 
*** ORIG        INTEGER O 
*** ORIG  
*** ORIG  C OUTPUT UNIT FOR PRINTED MESSAGES 
*** ORIG        DATA O/6/ 
*** ORIG        MAXDIM=200 
*** ORIG        IF(N.LE.MAXDIM)GO TO 6 
*** ORIG        WRITE(O,7)  
*** ORIG      7 FORMAT('0WARNING:',I5,' TOO GREAT FOR THIS VERSION OF pt_in_poly. 
*** ORIG       1 RESULTS INVALID')
*** ORIG        RETURN
*** ORIG      6 DO 1 I=1,N 
*** ORIG        X(I)=XX(I)-PX 
*** ORIG      1 Y(I)=YY(I)-PY 
*** ORIG        INOUT=-1 
*** ORIG        DO 2 I=1,N 
*** ORIG        J=1+MOD(I,N) 
*** ORIG        MX=X(I).GE.0.0 
*** ORIG        NX=X(J).GE.0.0 
*** ORIG        MY=Y(I).GE.0.0 
*** ORIG        NY=Y(J).GE.0.0 
*** ORIG        IF(.NOT.((MY.OR.NY).AND.(MX.OR.NX)).OR.(MX.AND.NX)) GO TO 2 
*** ORIG        IF(.NOT.(MY.AND.NY.AND.(MX.OR.NX).AND..NOT.(MX.AND.NX))) GO TO 3 
*** ORIG        INOUT=-INOUT 
*** ORIG        GO TO 2
*** ORIG      3 IF((Y(I)*X(J)-X(I)*Y(J))/(X(J)-X(I))) 2,4,5 
*** ORIG      4 INOUT=0   
*** ORIG        RETURN 
*** ORIG      5 INOUT=-INOUT 
*** ORIG      2 CONTINUE 
*** ORIG        RETURN 
*** ORIG        END 

	SUBROUTINE DSG_FEATURE_LIMS(dset, nfeatures, lolims, hilims)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Compute the lo/hi coordinate limits of each feature of the given dsg dataset
* For its "obs" coordinate axes.  (e.g. for a time series collection time
* is an obs axis, whereas lon and lat are instance axes

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V720 4/17 *sh*   
* V741 6/18 *acm* Go ahead and get single-value coordinates from feature-level vars
* V751 6/19 *acm* Set limits correctly when data in the entire feature is missing

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xtm_grid.cmn_text'
	include 'xdset_info.cmn_text'
	include 'xdyn_linemem.cmn_text'
	include 'xcontext.cmn'
	include 'xdsg_context.cmn'
	include 'xvariables.cmn'

* calling argument declarations:
	INTEGER dset, nfeatures
	REAL lolims(4,nfeatures), hilims(4,nfeatures)

* internal variable declarations:
        INTEGER i, j, lm, idim, var, rslm, obs_dimlen, flen, iobs0
	REAL cmin, cmax, coord, bad

* initialize
	obs_dimlen = dsg_obs_dimlen(dset)
	rslm = dsg_loaded_lm(dsg_row_size_var(dset))

! DSGTBD: It is inefficient to re-compute the extremes time after time
! A good solution to this would be
!  1. check for attributes '_feature_mins_lm' and '_feature_maxs_lm' on var
!  2a. if they do not exist, then
!    i. compute min and max as below
!    ii. allocate dsg_linemem sufficient to store them -- getting the lm indices
!    iii. create the attributes (hidden atts if possible), attaching the lms
!  2a. if they do exist, then
!    i. get the lm values from the attributes
!    ii. copy the stored extremes back from lm memory
!  3.  Remember to free this memory when closing the DSG dataset

* get the DSG coordinate extremes

	lolims = unspecified_val8
	hilims = unspecified_val8

	DO idim = 1, 4
	   bad = cxdsg_bad_val(idim)
	   IF (cxdsg_has_coord(idim)) THEN
	      lm = cxdsg_coord_lm(idim)
	      IF (cxdsg_is_obs_coord(idim)) THEN
	         iobs0 = 0
	         DO i = 1, nfeatures
	            flen = dsg_linemem(rslm)%ptr(i)   ! feature length
	            cmin = arbitrary_large_val8
	            cmax = arbitrary_small_val8
	            DO j = iobs0+1, iobs0+flen
	               coord = dsg_linemem(lm)%ptr(j)
		       IF (coord .EQ. bad) CYCLE
	               IF (coord .LT. cmin) cmin = coord
	               IF (coord .GT. cmax) cmax = coord
	            ENDDO
	            IF (cmin .LT. arbitrary_large_val8) lolims(idim,i) = cmin
	            IF (cmax .GT. arbitrary_small_val8) hilims(idim,i) = cmax
	            iobs0 = iobs0 + flen
	         ENDDO
* The single coordinate for this feature
	      ELSE
	         DO i = 1, nfeatures
	            coord = dsg_linemem(lm)%ptr(i)
		    IF (coord .EQ. bad) CYCLE
	            lolims(idim,i) = coord
	            hilims(idim,i) = coord
	         ENDDO
	      ENDIF
	   ELSE
	      DO i = 1, nfeatures
	         lolims(idim,i) = unspecified_val8
	         hilims(idim,i) = unspecified_val8
	      ENDDO
	   ENDIF
	ENDDO

	RETURN
	END

        SUBROUTINE SORT_TSERIES_DSETS(nmembers, memb_order, memb_sort)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* NOAA/PMEL, Seattle, WA - TMAP 

* sort the time steps that have been pulled from the time series members
*
* V698 *sh* 1/16 

* calling arguments
*   nmembers	- number of members in aggregation (input)
*   memb_order	- ordering index of member files (output)
*   memb_sort   - starting time steps as currently ordered, to be sorted (in/out)

        IMPLICIT NONE
        include 'tmap_errors.parm'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
        include 'xprog_state.cmn'
	include 'xtm_grid.cmn_text'  
	include 'errmsg.parm'
	include 'netcdf.inc'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xfr_grid.cmn'
	include 'xdiag_ctrl.cmn_text'

* calling argument declarations:
	INTEGER nmembers, memb_order(nmembers)
	REAL    memb_sort(nmembers)

* local variable declarations:
	INTEGER i
	REAL    rorder(nmembers)

* ... pre-sorted indices in a REAL array
	DO i = 1, nmembers
	   rorder(i) = i
	ENDDO

* sort the datasets by start date
	CALL HEAP2(memb_sort, rorder, unspecified_val8, nmembers)

* Return the sort order and the total number of steps

	DO i = 1, nmembers
	   memb_order(i) = NINT(rorder(i))
	ENDDO

	RETURN
	END

	SUBROUTINE ax_on_off (iax, overlay)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* August 2001
* call AXSET to turn axes off or on according to argument iax (0=off, 1=on):
*  iax(1) TOP	 
*  iax(2) BOTTOM
*  iax(3) LEFT
*  iax(4) RIGTH

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* v540 *acm*  2/02 save the state of the axes; so can restore PPL AXSEST settings
*             3/25  Put the common block in a separate include file.
* v552  *acm* 3/03 new param IAXSET to restore axes after PLOT/AXES/set plot.
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction.
* v744 *acm* 11/18 Issue 1786: graticule lines & axes drawn if PLOT/OVER/AXES given


        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'plot_setup.parm'
        include 'xplot_setup.cmn'
        include 'axis_inc.decl'
        include 'AXIS.INC'
        include 'ppl_ax_save.cmn'

	INTEGER		iax(*)
	LOGICAL		overlay

	INTEGER		i, indep_dim, dep_dim, labx, laby, sum
	CHARACTER*25	buff

* save previous axis state (top,bottom,left,right)

	DO 10 i = 1, 4
 10	save_iaxon(i) = iaxon(i)
        save_labx = labelx
        save_laby = labely

	WRITE (buff,90) (iax(i), i=1,4)
  90	FORMAT ('AXSET ', 3(i2,','), I2 )
	CALL PPLCMD (from, line, 0, buff, 1, 1 )


*  turn axis labels off or on

	IF (iax(1) .EQ. 0  .AND. iax(2) .EQ. 0) CALL PPLCMD 
     .         ( from, line, 0, 'XLAB', 1, 1 )

	IF (iax(3) .EQ. 0  .AND. iax(4) .EQ. 0) CALL PPLCMD 
     .         ( from, line, 0, 'YLAB', 1, 1 )

*  When only top or right axis plotted, labels wouldnt appear. 
*  Turn them on.

        labx = labelx
        laby = labely
        change_axlab = .FALSE.
        IF (iax(1) .EQ. 1  .AND. iax(2) .EQ. 0) THEN
           labx = 1
           change_axlab = .TRUE.
	ENDIF
        IF (iax(3) .EQ. 0  .AND. iax(4) .EQ. 1) THEN
           laby = 1
           change_axlab = .TRUE.
        ENDIF
        IF (change_axlab) THEN
           WRITE (buff,92) labx, laby
  92	   FORMAT ('AXLABP ', i2, ',', I2 )
	   CALL PPLCMD (from, line, 0, buff, 1, 1)
        ENDIF

*  What if one is a time axis?  

	indep_dim = plot_axis(1)
	dep_dim = plot_axis(2)
	time_axis = ( (indep_dim.EQ.t_dim .OR. indep_dim.EQ.f_dim)
     .    .OR. (dep_dim.EQ.t_dim .OR. dep_dim.EQ.t_dim) )

	IF ( time_axis .AND. change_axlab) THEN
	   WRITE (buff,94) labx, laby
  94	   FORMAT ('TXLABP ', i2, ',', I2 )
	   CALL PPLCMD (from, line, 0, buff, 1, 1)
	ENDIF

        iaxset = 1

* Is this an overlay plot where they requested axes be drawn?
* Store a flag (AXIS.INC).

	IF (overlay) THEN
	   axes_on_overlay = .FALSE.
	   sum = 0
	   DO i = 1, 4
	     sum = sum + iax(i)
	   ENDDO
	   IF (sum .GT. 0) axes_on_overlay = .TRUE.
	ENDIF
	
	RETURN
	END

*
* ef_get_wrk_mem_subscripts_6d.F (was ef_get_wrk_mem_subscripts.F)
*   
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY
*  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Return the work array memory limits in the common blocks
* for those times when they cannot be retrieved directly.
*
      SUBROUTINE EF_GET_WRK_MEM_SUBSCRIPTS_6D(id, wrk_memlo, wrk_memhi)

      IMPLICIT NONE
      INCLUDE 'tmap_dims.parm'
      INCLUDE 'EF_Util.parm'
      INCLUDE 'EF_mem_subsc.cmn'

* argument declarations
      INTEGER id, wrk_memlo(nferdims,EF_MAX_WORK_ARRAYS),
     .            wrk_memhi(nferdims,EF_MAX_WORK_ARRAYS)

* this assumed EF_MAX_WORK_ARRAYS .EQ. 9
      wrk_memlo(1,1) = wrk1lox
      wrk_memlo(1,2) = wrk2lox
      wrk_memlo(1,3) = wrk3lox
      wrk_memlo(1,4) = wrk4lox
      wrk_memlo(1,5) = wrk5lox
      wrk_memlo(1,6) = wrk6lox
      wrk_memlo(1,7) = wrk7lox
      wrk_memlo(1,8) = wrk8lox
      wrk_memlo(1,9) = wrk9lox

      wrk_memlo(2,1) = wrk1loy
      wrk_memlo(2,2) = wrk2loy
      wrk_memlo(2,3) = wrk3loy
      wrk_memlo(2,4) = wrk4loy
      wrk_memlo(2,5) = wrk5loy
      wrk_memlo(2,6) = wrk6loy
      wrk_memlo(2,7) = wrk7loy
      wrk_memlo(2,8) = wrk8loy
      wrk_memlo(2,9) = wrk9loy

      wrk_memlo(3,1) = wrk1loz
      wrk_memlo(3,2) = wrk2loz
      wrk_memlo(3,3) = wrk3loz
      wrk_memlo(3,4) = wrk4loz
      wrk_memlo(3,5) = wrk5loz
      wrk_memlo(3,6) = wrk6loz
      wrk_memlo(3,7) = wrk7loz
      wrk_memlo(3,8) = wrk8loz
      wrk_memlo(3,9) = wrk9loz

      wrk_memlo(4,1) = wrk1lot
      wrk_memlo(4,2) = wrk2lot
      wrk_memlo(4,3) = wrk3lot
      wrk_memlo(4,4) = wrk4lot
      wrk_memlo(4,5) = wrk5lot
      wrk_memlo(4,6) = wrk6lot
      wrk_memlo(4,7) = wrk7lot
      wrk_memlo(4,8) = wrk8lot
      wrk_memlo(4,9) = wrk9lot

      wrk_memlo(5,1) = wrk1loe
      wrk_memlo(5,2) = wrk2loe
      wrk_memlo(5,3) = wrk3loe
      wrk_memlo(5,4) = wrk4loe
      wrk_memlo(5,5) = wrk5loe
      wrk_memlo(5,6) = wrk6loe
      wrk_memlo(5,7) = wrk7loe
      wrk_memlo(5,8) = wrk8loe
      wrk_memlo(5,9) = wrk9loe

      wrk_memlo(6,1) = wrk1lof
      wrk_memlo(6,2) = wrk2lof
      wrk_memlo(6,3) = wrk3lof
      wrk_memlo(6,4) = wrk4lof
      wrk_memlo(6,5) = wrk5lof
      wrk_memlo(6,6) = wrk6lof
      wrk_memlo(6,7) = wrk7lof
      wrk_memlo(6,8) = wrk8lof
      wrk_memlo(6,9) = wrk9lof

      wrk_memhi(1,1) = wrk1hix
      wrk_memhi(1,2) = wrk2hix
      wrk_memhi(1,3) = wrk3hix
      wrk_memhi(1,4) = wrk4hix
      wrk_memhi(1,5) = wrk5hix
      wrk_memhi(1,6) = wrk6hix
      wrk_memhi(1,7) = wrk7hix
      wrk_memhi(1,8) = wrk8hix
      wrk_memhi(1,9) = wrk9hix

      wrk_memhi(2,1) = wrk1hiy
      wrk_memhi(2,2) = wrk2hiy
      wrk_memhi(2,3) = wrk3hiy
      wrk_memhi(2,4) = wrk4hiy
      wrk_memhi(2,5) = wrk5hiy
      wrk_memhi(2,6) = wrk6hiy
      wrk_memhi(2,7) = wrk7hiy
      wrk_memhi(2,8) = wrk8hiy
      wrk_memhi(2,9) = wrk9hiy

      wrk_memhi(3,1) = wrk1hiz
      wrk_memhi(3,2) = wrk2hiz
      wrk_memhi(3,3) = wrk3hiz
      wrk_memhi(3,4) = wrk4hiz
      wrk_memhi(3,5) = wrk5hiz
      wrk_memhi(3,6) = wrk6hiz
      wrk_memhi(3,7) = wrk7hiz
      wrk_memhi(3,8) = wrk8hiz
      wrk_memhi(3,9) = wrk9hiz

      wrk_memhi(4,1) = wrk1hit
      wrk_memhi(4,2) = wrk2hit
      wrk_memhi(4,3) = wrk3hit
      wrk_memhi(4,4) = wrk4hit
      wrk_memhi(4,5) = wrk5hit
      wrk_memhi(4,6) = wrk6hit
      wrk_memhi(4,7) = wrk7hit
      wrk_memhi(4,8) = wrk8hit
      wrk_memhi(4,9) = wrk9hit

      wrk_memhi(5,1) = wrk1hie
      wrk_memhi(5,2) = wrk2hie
      wrk_memhi(5,3) = wrk3hie
      wrk_memhi(5,4) = wrk4hie
      wrk_memhi(5,5) = wrk5hie
      wrk_memhi(5,6) = wrk6hie
      wrk_memhi(5,7) = wrk7hie
      wrk_memhi(5,8) = wrk8hie
      wrk_memhi(5,9) = wrk9hie

      wrk_memhi(6,1) = wrk1hif
      wrk_memhi(6,2) = wrk2hif
      wrk_memhi(6,3) = wrk3hif
      wrk_memhi(6,4) = wrk4hif
      wrk_memhi(6,5) = wrk5hif
      wrk_memhi(6,6) = wrk6hif
      wrk_memhi(6,7) = wrk7hif
      wrk_memhi(6,8) = wrk8hif
      wrk_memhi(6,9) = wrk9hif

      RETURN
      END

	subroutine ldgrid(xmin,xmax,nx,ymin,ymax,ny,itype,ang,gty,info)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)loadppl.f	1.3    5/31/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
c
c	load and read grid information into ppl header
c
	character info*(*),gty*(*),str*32
#ifdef unix
	include 'PPL.INC'
#else
	include 'pplinc:PPL.INC'
#endif
c
	pxmin=xmin
	pxmax=xmax
	pnx=nx
	pymin=ymin
	pymax=ymax
	pny=ny
	ptype=itype
	gxornt=ang
	write(str,'(f5.1)')ang
	read(str,999)gornt
999	format(2a4)
	read(gty,999)gtype
	read(info,998)grid
998	format(8a4)
	return
	entry gtgrid(xmin,xmax,nx,ymin,ymax,ny,itype,ang,gty,info)
c
	xmin=pxmin
	xmax=pxmax
	nx=pnx
	ymin=pymin
	ymax=pymax
	ny=pny
	itype=ptype
	ang=gxornt
	write(gty,999)gtype
	write(info,998)grid
	return
	end
c
	subroutine ldcmnt(cma,cmb,cmc,cmd,cme)
c
c	load the 120 character comments for the ppl header
c
	character cma*(*),cmb*(*),cmc*(*),cmd*(*),cme*(*)
#ifdef unix
	include 'PPL.INC'
#else
	include 'pplinc:PPL.INC'
#endif
c
	read(cma,999)cmnta
999	format(30a4)
	read(cmb,999)cmntb
	read(cmc,999)cmntc
	read(cmd,999)cmntd
	read(cme,999)cmnte
	return
	entry gtcmnt(cma,cmb,cmc,cmd,cme)
	write(cma,999)cmnta
	write(cmb,999)cmntb
	write(cmc,999)cmntc
	write(cmd,999)cmntd
	write(cme,999)cmnte
	return
	end
c
	subroutine lduser(usa,usb,usc,usd)
c
c	load the 32 character user strings into the ppl header
c
	character usa*(*),usb*(*),usc*(*),usd*(*)
#ifdef unix
	include 'PPL.INC'
#else
	include 'pplinc:PPL.INC'
#endif
c
	read(usa,999)usera
999	format(8a4)
	read(usb,999)userb
	read(usc,999)userc
	read(usd,999)userd
	return
	entry gtuser(usa,usb,usc,usd)
	write(usa,999)usera
	write(usb,999)userb
	write(usc,999)userc
	write(usd,999)userd
	return
	end
c
	subroutine ldplid(ident,source,dte,tme)
c
c	load the plot identification information for the ppl header
c
	character ident*(*),source*(*),dte*(*),tme*(*)
#ifdef unix
	include 'PPL.INC'
#else
	include 'pplinc:PPL.INC'
#endif
c
	read(ident,999)pident
999	format(8a4)
	read(source,999)psrc
	read(dte,998)pdate
998	format(4a4)
	read(tme,998)ptime
	return
	entry gtplid(ident,source,dte,tme)
	write(ident,999)pident
	write(source,999)psrc
	write(dte,998)pdate
	write(tme,998)ptime
	return
	end
c
	subroutine ldvar(name,dte,tme,ident,
     *		mean,var,std,rms,min,max,jdate,lat,long)
c
c	load the variable information into the ppl header
c
	character name*(*),dte*(*),tme*(*),ident*(*),str*16
	real mean,var,std,rms,min,max,jdate,lat,long
#ifdef unix
	include 'PPL.INC'
#else
	include 'pplinc:PPL.INC'
#endif
c
	vxmean=mean
	vxvar=var
	vxmin=min
	vxmax=max
	vxjdat=jdate
	vxlat=lat
	vxlong=long
	read(name,999)varnme
999	format(8a4)
	read(dte,998)vdate
998	format(4a4)
	read(tme,998)vtime
	read(ident,999)vident
c
c	format the variables
c
	write(str,1000)mean
1000	format(1pg12.5)
	read(str,998)vmean
	write(str,1000)var
	read(str,998)vvar
	write(str,1000)std
	read(str,998)vstd
	write(str,1000)rms
	read(str,998)vrms
	write(str,1000)min
	read(str,998)vmin
	write(str,1000)max
	read(str,998)vmax
	write(str,1001)jdate
1001	format(f8.2)
	read(str,998)vjdate
	ideg=abs(int(lat))
	imin=(abs(lat)-ideg)*60
	write(str,1002)ideg,imin
1002	format(i3,'#',i3,' ')
	k=8
	if(imin.eq.0)k=4
	if(lat.gt.0)then
	    str=str(:k)//'N'
	else
	    str=str(:k)//'S'
	endif
	read(str,998)vlat
	ideg=abs(int(long))
	imin=(abs(long)-ideg)*60
	write(str,1002)ideg,imin
	k=8
	if(imin.eq.0)k=4
	if(long.gt.0)then
	    str=str(:k)//'E'
	else
	    str=str(:k)//'W'
	endif
	read(str,998)vlong
	return
	entry gtvar(name,dte,tme,ident,
     *		mean,var,std,rms,min,max,jdate,lat,long)
c
c	not all the formatted strings are returned here!
c
	mean=vxmean
	var=vxvar
	min=vxmin
	max=vxmax
	jdate=vxjdat
	lat=vxlat
	long=vxlong
	write(name,999)varnme
	write(dte,998)vdate
	write(tme,998)vtime
	write(ident,999)vident
	return
	end
c
	subroutine ldaxlb(xlab,ylab,mlab)
c
c	load the axis labels into the ppl header
c
	character xlab*(*),ylab*(*),mlab*(*)
#ifdef unix
	include 'PPL.INC'
#else
	include 'pplinc:PPL.INC'
#endif
c
	read(xlab,999)pxlab
999	format(20a4)
	read(ylab,999)pylab
	read(mlab,998)pmlab
998	format(30a4)
	return
	entry gtaxlb(xlab,ylab,mlab)
	write(xlab,999)pxlab
	write(ylab,999)pylab
	write(mlab,998)pmlab
	return
	end

	SUBROUTINE WINDOW_REGRID_1_AXIS( cx_lims, axis, trans,
     .				 dst_lox, dst_hix, dst_loy, dst_hiy,
     .				 src, msrc, dst, mdst, sslo, sshi,
     .				 wksize )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* 	Using data values from src organized on grid src_grid, regrid to
* 	grid dst_grid within boxes along one axis

*	The algorithm used for regridding is determined by "trans", the
*	regridding transformation -- e.g. min, max, ...
*	This routine handles only algorithms that compute using discrete
*	(unweighted) points.  Transforms such as average and variance are
*	handled in ave_regrid_1_axis

* 	msrc and mdst point to data structures in COMMON/XVARIABLES/ which
* 	specify the subscript bounds of src and dst within their 
* 	respective grids.

*	ss21 holds the indices of source grid boxes (on src_grid) for box
*	limits on dst_grid.

* 	programmer - Steve Hankin
* 	NOAA/PMEL,Seattle,WA - Tropical Modeling and Analysis Program

* V420: 1/96 - removed SUM and NGD from here to ave_regrid_1_axis (weighted)
* V500: 4/99 *kob* bug fix:  fixed loops for y,z,t axis to loop
*                            only to srcss_hi-1
* V510: 1/00 *sh* bug fix to behavior at edges of region
* v570 *acm* 5/04 Note: we do not need to use the ok_neg111 fix for 
*                 when the range of subscripts might be negative, and 
*                 contain -111 among them. Tests for unspecified_int4
*                 are not used in this routine.
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V685+ 12/13 *acm* Typo in the F-axis code.

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'
	include	'xmem_subsc.cmn'
	include 'xvariables.cmn'


* calling argument declarations:
	INTEGER	cx_lims, axis, msrc, trans, mdst,
     .          dst_lox, dst_hix, dst_loy, dst_hiy , wksize
	INTEGER	sslo(wksize), sshi(wksize)

	REAL    src( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          dst( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif )

* local variable declarations:
	INTEGER	npts, dstss, srcss, src_grid, dst_grid,
     .          i, j, k, l, m, n
	INTEGER	srcss_lo,srcss_hi, dstss_lo,dstss_hi,
     .		src_lo, src_hi

	REAL	accum, bad_src, bad_dst

******************************************************************************

* initialize
	src_grid = mr_grid( msrc )
	dst_grid = mr_grid( mdst )

* limits for calculation
        srcss_lo = mr_lo_ss(msrc,axis)
        srcss_hi = mr_hi_ss(msrc,axis)

        dstss_lo = cx_lo_ss(cx_lims,axis)
        dstss_hi = cx_hi_ss(cx_lims,axis)

* flag for bad/missing data
        bad_src = mr_bad_data(msrc)
        bad_dst = mr_bad_data(mdst)

* determine the source grid boxes containing the destination boxes
	CALL GET_WINDOW_LIMS ( srcss_lo, srcss_hi, src_grid,
     .			   dstss_lo, dstss_hi, dst_grid,
     .			   axis, sslo, sshi )


* along X axis
        IF ( axis .EQ. x_dim ) THEN
           DO 190 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
           DO 190 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
           DO 190 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
           DO 190 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
           DO 190 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)

* loop through the each destination grid box
	   DO 160 dstss = dstss_lo,dstss_hi

	      src_lo = sslo(dstss-dstss_lo+1)
	      src_hi = sshi(dstss-dstss_lo+1)

	      IF     ( trans .EQ. prgrd_min ) THEN
	         accum = arbitrary_large_val4
	      ELSEIF ( trans .EQ. prgrd_max ) THEN
	         accum = arbitrary_small_val4
	      ENDIF
	      npts = 0
	      DO 110 srcss = src_lo, src_hi

* ... ignore missing source data
	         IF ( src(srcss,j,k,l,m,n) .EQ. bad_src ) GOTO 110

* ... contribution from this source box
	         IF     ( trans .EQ. prgrd_min ) THEN
	            accum = MIN( accum, src(srcss,j,k,l,m,n) )
	         ELSEIF ( trans .EQ. prgrd_max ) THEN
	            accum = MAX( accum, src(srcss,j,k,l,m,n) )
	         ENDIF
	         npts = npts + 1
 110	      CONTINUE

              IF ( npts .GT. 0 ) THEN
                 dst(dstss,j,k,l,m,n) = accum
              ELSE
                 dst(dstss,j,k,l,m,n) = bad_dst
              ENDIF

 160	   CONTINUE
 190	   CONTINUE

* along Y axis
        ELSEIF ( axis .EQ. Y_dim ) THEN

           DO 290 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
           DO 290 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
           DO 290 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
           DO 290 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
           DO 290 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* loop through the each destination grid box
	   DO 260 dstss = dstss_lo,dstss_hi

	      src_lo = sslo(dstss-dstss_lo+1)
	      src_hi = sshi(dstss-dstss_lo+1)

	      IF     ( trans .EQ. prgrd_min ) THEN
	         accum = arbitrary_large_val4
	      ELSEIF ( trans .EQ. prgrd_max ) THEN
	         accum = arbitrary_small_val4
	      ENDIF
	      npts = 0

	      DO 210 srcss = src_lo, src_hi

* ... ignore missing source data
	         IF ( src(i,srcss,k,l,m,n) .EQ. bad_src ) GOTO 210

* ... contribution from this source box
	         IF     ( trans .EQ. prgrd_min ) THEN
	            accum = MIN( accum, src(i,srcss,k,l,m,n) )
	         ELSEIF ( trans .EQ. prgrd_max ) THEN
	            accum = MAX( accum, src(i,srcss,k,l,m,n) )
	         ENDIF
	         npts = npts + 1
 210	      CONTINUE

              IF ( npts .GT. 0 ) THEN
                 dst(i,dstss,k,l,m,n) = accum
              ELSE
                 dst(i,dstss,k,l,m,n) = bad_dst
              ENDIF

 260	   CONTINUE
 290	   CONTINUE

* along Z axis
        ELSEIF ( axis .EQ. z_dim ) THEN

           DO 390 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
           DO 390 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
           DO 390 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
           DO 390 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
           DO 390 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* loop through the each destination grid box
	   DO 360 dstss = dstss_lo,dstss_hi

	      src_lo = sslo(dstss-dstss_lo+1)
	      src_hi = sshi(dstss-dstss_lo+1)

	      IF     ( trans .EQ. prgrd_min ) THEN
	         accum = arbitrary_large_val4
	      ELSEIF ( trans .EQ. prgrd_max ) THEN
	         accum = arbitrary_small_val4
	      ENDIF
	      npts = 0

	      DO 310 srcss = src_lo, src_hi

* ... ignore missing source data
	         IF ( src(i,j,srcss,l,m,n) .EQ. bad_src ) GOTO 310

* ... contribution from this source box
	         IF     ( trans .EQ. prgrd_min ) THEN
	            accum = MIN( accum, src(i,j,srcss,l,m,n) )
	         ELSEIF ( trans .EQ. prgrd_max ) THEN
	            accum = MAX( accum, src(i,j,srcss,l,m,n) )
	         ENDIF
	         npts = npts + 1
 310	      CONTINUE

              IF ( npts .GT. 0 ) THEN
                 dst(i,j,dstss,l,m,n) = accum
              ELSE
                 dst(i,j,dstss,l,m,n) = bad_dst
              ENDIF

 360	   CONTINUE
 390	   CONTINUE

* along T axis
        ELSEIF ( axis .EQ. T_dim ) THEN

           DO 490 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
           DO 490 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
           DO 490 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
           DO 490 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
           DO 490 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* loop through the each destination grid box
	   DO 460 dstss = dstss_lo,dstss_hi

	      src_lo = sslo(dstss-dstss_lo+1)
	      src_hi = sshi(dstss-dstss_lo+1)

	      IF     ( trans .EQ. prgrd_min ) THEN
	         accum = arbitrary_large_val4
	      ELSEIF ( trans .EQ. prgrd_max ) THEN
	         accum = arbitrary_small_val4
	      ENDIF
	      npts = 0

	      DO 410 srcss = src_lo, src_hi

* ... ignore missing source data
	         IF ( src(i,j,k,srcss,m,n) .EQ. bad_src ) GOTO 410

* ... contribution from this source box
	         IF     ( trans .EQ. prgrd_min ) THEN
	            accum = MIN( accum, src(i,j,k,srcss,m,n) )
	         ELSEIF ( trans .EQ. prgrd_max ) THEN
	            accum = MAX( accum, src(i,j,k,srcss,m,n) )
	         ENDIF
	         npts = npts + 1
 410	      CONTINUE

              IF ( npts .GT. 0 ) THEN
                 dst(i,j,k,dstss,m,n) = accum
              ELSE
                 dst(i,j,k,dstss,m,n) = bad_dst
              ENDIF

 460	   CONTINUE
 490	   CONTINUE

* along E axis
        ELSEIF ( axis .EQ. E_dim ) THEN

           DO 590 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
           DO 590 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
           DO 590 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
           DO 590 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
           DO 590 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* loop through the each destination grid box
	   DO 560 dstss = dstss_lo,dstss_hi

	      src_lo = sslo(dstss-dstss_lo+1)
	      src_hi = sshi(dstss-dstss_lo+1)

	      IF     ( trans .EQ. prgrd_min ) THEN
	         accum = arbitrary_large_val4
	      ELSEIF ( trans .EQ. prgrd_max ) THEN
	         accum = arbitrary_small_val4
	      ENDIF
	      npts = 0

	      DO 510 srcss = src_lo, src_hi

* ... ignore missing source data
	         IF ( src(i,j,k,l,srcss,n) .EQ. bad_src ) GOTO 510

* ... contribution from this source box
	         IF     ( trans .EQ. prgrd_min ) THEN
	            accum = MIN( accum, src(i,j,k,l,srcss,n) )
	         ELSEIF ( trans .EQ. prgrd_max ) THEN
	            accum = MAX( accum, src(i,j,k,l,srcss,n) )
	         ENDIF
	         npts = npts + 1
 510	      CONTINUE

              IF ( npts .GT. 0 ) THEN
                 dst(i,j,k,l,dstss,n) = accum
              ELSE
                 dst(i,j,k,l,dstss,n) = bad_dst
              ENDIF

 560	   CONTINUE
 590	   CONTINUE


* along F axis
        ELSEIF ( axis .EQ. F_dim ) THEN

           DO 690 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
           DO 690 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
           DO 690 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
           DO 690 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
           DO 690 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* loop through the each destination grid box
	   DO 660 dstss = dstss_lo,dstss_hi

	      src_lo = sslo(dstss-dstss_lo+1)
	      src_hi = sshi(dstss-dstss_lo+1)

	      IF     ( trans .EQ. prgrd_min ) THEN
	         accum = arbitrary_large_val4
	      ELSEIF ( trans .EQ. prgrd_max ) THEN
	         accum = arbitrary_small_val4
	      ENDIF
	      npts = 0

	      DO 610 srcss = src_lo, src_hi

* ... ignore missing source data
	         IF ( src(i,j,k,l,m,srcss) .EQ. bad_src ) GOTO 610

* ... contribution from this source box
	         IF     ( trans .EQ. prgrd_min ) THEN
	            accum = MIN( accum, src(i,j,k,l,m,srcss) )
	         ELSEIF ( trans .EQ. prgrd_max ) THEN
	            accum = MAX( accum, src(i,j,k,l,m,srcss) )
	         ENDIF
	         npts = npts + 1
 610	      CONTINUE

              IF ( npts .GT. 0 ) THEN
                 dst(i,j,k,l,m,dstss) = accum
              ELSE
                 dst(i,j,k,l,m,dstss) = bad_dst
              ENDIF

 660	   CONTINUE
 690	   CONTINUE

        ENDIF

	RETURN
	END

! curv_to_rect_map.F  
! From Matt Harrison hinterp.F
! to call only the spherical interpolation modules, and
! recast in F77-compileable format.
! ACM 3/2004
!  10/8/2004  add fourth argument radius  (max_dist) so this can be
!             set to a smaller value for fine grids or small regions.
!
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*

! acm 12/2004 Compute the sum of weights in routine apply_mapping; 
!             sum of weights used when there is good data contributing 
!             to the destination point.
!             Remove use of mask_dst variable; never used.



! In this SUBROUTINE we provide information about
! the function.  The user configurable information 
! consists of the following:
!
! descr              Text description of the function
!
! num_args           Required number of arguments
!
! axis_inheritance   Type of axis for the result
!                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
!                       CUSTOM          - user defined axis
!                       IMPLIED_BY_ARGS - same axis as the incoming argument
!                       NORMAL          - the result is normal to this axis
!                       ABSTRACT        - an axis which only has index values
!
! piecemeal_ok       For memory optimization:
!                       axes where calculation may be performed piecemeal
!                       ( YES, NO )
! 
!
! For each argument we provide the following information:
!
! name               Text name for an argument
!
! unit               Text units for an argument
!
! desc               Text description of an argument
!
! axis_influence     Are this argument's axes the same as the result grid?
!                       ( YES, NO )
!
! axis_extend       How much does Ferret need to extend arg limits relative to result 
!


      SUBROUTINE curv_to_rect_map_init(id)
        
      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER   id, arg
      CHARACTER*100  descr

!**********************************************************************
!                                           USER CONFIGURABLE PORTION |
!                                                                     |
!                                                                     V

      WRITE (descr, 10)
   10 FORMAT
     . ('Compute mapping for regridding: curvilinear to ',
     .  'rectangular grid.')
      CALL ef_set_desc(id, descr)

      CALL ef_set_num_args(id, 4)
      CALL ef_set_num_work_arrays(id, 8)

      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS,  
     .     IMPLIED_BY_ARGS, ABSTRACT, ABSTRACT)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'lon_in')
      CALL ef_set_arg_unit(id, arg, 'degrees')
      CALL ef_set_arg_desc(id, arg, 
     .   'Source grid longitudes (2-D)')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'lat_in')
      CALL ef_set_arg_unit(id, arg, 'degrees')
      CALL ef_set_arg_desc(id, arg, 
     .  'Source grid latitudes (2-D)')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'grid_out')
      CALL ef_set_arg_unit(id, arg, 'degrees')
      WRITE (descr, 20)
   20 FORMAT ('Any variable on destination Longitude-Latitude ',
     .        'grid, Lon and Lat')
      CALL ef_set_arg_desc(id, arg, descr)
     .  
      CALL ef_set_axis_influence(id, arg, YES, YES, NO, NO)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'radius')
      CALL ef_set_arg_unit(id, arg, 'degrees')
      WRITE (descr, 30)
   30 FORMAT ('Source points falling ',
     .   'within radius are included in mapping to destination point')
      CALL ef_set_arg_desc(id, arg, descr)
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

!                                                                     ^
!                                                                     |
!                                           USER CONFIGURABLE PORTION |
!***********************************************************************

      RETURN 
      END  ! SUBROUTINE curv_to_rect_map_init

* Set the limits of the abstract axes for the result.

      SUBROUTINE curv_to_rect_map_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_axis_limits(id, Z_AXIS, 1, 4)
      CALL ef_set_axis_limits(id, T_AXIS, 1, 3)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END  ! SUBROUTINE curv_to_rect_map_result_limits



*
* In this SUBROUTINE we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE curv_to_rect_map_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work array X/Y/Z/T dimensions
*
* ef_set_work_array_lens(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER array_num
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)
      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)

      INTEGER num_nbrs, nx, ny

      num_nbrs = 4

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)


* Define together as one work array:
* i_lon_j_lat(nlon_dst, nlat_dst, num_nbrs, 2)
*  integer i_lon(nlon_dst, nlat_dst, num_nbrs) 
*  integer j_lat(nlon_dst, nlat_dst, num_nbrs) 
*  indices for spherical interpolation - define together as one work array

      array_num = 1
      num_nbrs = 4
      CALL ef_set_work_array_dims(id, array_num,
     .     arg_lo_ss(X_AXIS,ARG3), arg_lo_ss(Y_AXIS,ARG3), 
     .     1, 1, 
     .     arg_hi_ss(X_AXIS,ARG3), arg_hi_ss(Y_AXIS,ARG3), 
     .     num_nbrs, 2)

*  Define together as one work array:
*  real src_dist(nlon_dst, nlat_dst, num_nbrs)
*  real map_src_dist(nlon_dst, nlat_dst, num_nbrs)

      array_num = 2
      CALL ef_set_work_array_dims(id, array_num,
     .     arg_lo_ss(X_AXIS,ARG3), arg_lo_ss(Y_AXIS,ARG3), 
     .     1, 1, 
     .     arg_hi_ss(X_AXIS,ARG3), arg_hi_ss(Y_AXIS,ARG3), 
     .     num_nbrs, 2)

* Define together as one work array:
* logical found_neighbors(nlon_dst, nlat_dst)
* logical map_found_neighbors(nlon_dst, nlat_dst)

      array_num = 3
      CALL ef_set_work_array_dims(id, array_num,
     .     arg_lo_ss(X_AXIS,ARG3), arg_lo_ss(Y_AXIS,ARG3), 
     .     1, 1, 
     .     arg_hi_ss(X_AXIS,ARG3), arg_hi_ss(Y_AXIS,ARG3), 
     .     2, 1)

* integer map_src_add(nlon_dst, nlat_dst, num_nbrs)

      array_num = 4
      CALL ef_set_work_array_dims(id, array_num,
     .     arg_lo_ss(X_AXIS,ARG3), arg_lo_ss(Y_AXIS,ARG3), 
     .     1, 1, 
     .     arg_hi_ss(X_AXIS,ARG3), arg_hi_ss(Y_AXIS,ARG3), 
     .     num_nbrs, 1)

* real wt(nlon_dst, nlat_dst, num_nbrs) 

      array_num = 5
      CALL ef_set_work_array_dims(id, array_num,
     .     arg_lo_ss(X_AXIS,ARG3), arg_lo_ss(Y_AXIS,ARG3), 
     .     1, 1, 
     .     arg_hi_ss(X_AXIS,ARG3), arg_hi_ss(Y_AXIS,ARG3), 
     .     num_nbrs, 1)

* Define together as one work array:
* real src_grid_radians(nx_src, ny_src, 2, 1)
* source grid longitudes (arg_1), translated to radians
* source grid latitudes  (arg_2), translated to radians

      array_num = 6
      CALL ef_set_work_array_dims(id, array_num,
     .     arg_lo_ss(X_AXIS,ARG1), arg_lo_ss(Y_AXIS,ARG2), 1, 1, 
     .     arg_hi_ss(X_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG2), 2, 1)

* real*8 dst_grid(MAX(nx_dst, ny_dst), 2, 1, 1)
* destination rectangular grid, translated to radians
* allocate 2* needed number of values, since this will be real*8

      array_num = 7
      nx =  arg_hi_ss(X_AXIS,ARG3) - arg_lo_ss(X_AXIS,ARG3) + 1
      ny =  arg_hi_ss(Y_AXIS,ARG3) - arg_lo_ss(Y_AXIS,ARG3) + 1
      nx = MAX(nx,ny)
      CALL ef_set_work_array_dims(id, array_num,
     .        1,   1, 1, 1, 
     .     2*nx, 2*2, 1, 1)

* real dst_grid_radians(nx_dst, ny_dst, 2, 1)
* destination rectangular grid, translated to radians

      array_num = 8
      nx =  arg_hi_ss(X_AXIS,ARG3) - arg_lo_ss(X_AXIS,ARG3) + 1
      ny =  arg_hi_ss(Y_AXIS,ARG3) - arg_lo_ss(Y_AXIS,ARG3) + 1
      CALL ef_set_work_array_dims(id, array_num,
     .      1,  1, 1, 1, 
     .     nx, ny, 2, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

!
! In this SUBROUTINE we compute the result
!
      SUBROUTINE curv_to_rect_map_compute(id, arg_1, arg_2, arg_3,
     .          arg_4, result, i_lon_j_lat, src_dist, 
     .          found_neighbors, map_src_add, wt, 
     .          src_grid_radians, dst_grid, dst_grid_radians)

! Schematic:
!    The following example illustrates a destination grid location (+) with 
!    a (R)adius of influence (in radians) denoted by (=).  Valid source grid 
!    locations (o) which fall within the radius of influence of the destination 
!    point are used in the mapping. In this case, 4 valid source grid points fall
!    within the radius of influence.   
!
! 
!               o  o   o   o   o   o   o
!                      =========
!                     =         = 
!               o  o = o   o   o = o   o
!                   =        R    = 
!                   =      +----->=
!               o  o   o   x   x   x   x
!                     =         =
!                      =========
!               o  o   o   x   x   x   x
!
!
!
      IMPLICIT none
      
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'
      

      INTEGER  id

      REAL  bad_flag(EF_MAX_ARGS), bad_flag_result

      REAL  arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .       mem1lot:mem1hit)
      REAL  arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .       mem2lot:mem2hit)
      REAL  arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz,
     .       mem3lot:mem3hit)
      REAL  arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz,
     .       mem4lot:mem4hit)

      REAL  result(memreslox:memreshix, memresloy:memreshiy, 
     .      memresloz:memreshiz, memreslot:memreshit)
     
* Declare work arrays

      INTEGER i_lon_j_lat(wrk1lox:wrk1hix, wrk1loy:wrk1hiy,
     .              wrk1loz:wrk1hiz, wrk1lot:wrk1hit)
      REAL src_dist(wrk2lox:wrk2hix, wrk2loy:wrk2hiy,
     .              wrk2loz:wrk2hiz, wrk2lot:wrk2hit)
      LOGICAL found_neighbors(wrk3lox:wrk3hix, wrk3loy:wrk3hiy,
     .              wrk3loz:wrk3hiz, wrk3lot:wrk3hit)
      INTEGER map_src_add(wrk4lox:wrk4hix, wrk4loy:wrk4hiy,
     .              wrk4loz:wrk4hiz, wrk4lot:wrk4hit)
      REAL wt(wrk5lox:wrk5hix, wrk5loy:wrk5hiy,
     .              wrk5loz:wrk5hiz, wrk5lot:wrk5hit)
      REAL src_grid_radians(wrk6lox:wrk6hix, wrk6loy:wrk6hiy,
     .              wrk6loz:wrk6hiz, wrk6lot:wrk6hit)
      REAL*8 dst_grid(wrk7lox:wrk7hix/2, wrk7loy:wrk7hiy/2,
     .              wrk7loz:wrk7hiz, wrk7lot:wrk7hit)
      REAL dst_grid_radians(wrk8lox:wrk8hix, wrk8loy:wrk8hiy,
     .              wrk8loz:wrk8hiz, wrk8lot:wrk8hit)

! After initialization, the 'res_' arrays contain indexing information 
! for the result axes.  The 'arg_' arrays will contain the indexing 
! information for each variable's axes. 

      INTEGER  res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER  arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .         arg_incr(4,EF_MAX_ARGS)
      
!**********************************************************************
!                                           USER CONFIGURABLE PORTION |
!                                                                     |
!                                                                     V

      INTEGER  i, j, k, l, arg, idim, interp_method, nx, ny,
     .         nlon_src, nlat_src, nlon_dst, nlat_dst, num_nbrs, 
     .         ilon(4), jlat(4)

! ilon and jlat are size of num_nbrs

      REAL max_dist, pi, pi180
      LOGICAL src_modulo

      pi =  4.*ATAN(1.)
      pi180 = pi/ 180.

      num_nbrs = 4

!  Get max_dist as an argument and convert to radians.
cc      max_dist = 0.17
      arg = 4
      CALL ef_get_one_val(id, arg, max_dist)
      max_dist = pi180*max_dist

      src_modulo = .true.  ! Do we want this? Ferret does not now deal w/ modulo curvi data

!  Loop over x,y,t of the input fields
      
      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      interp_method = 3
!      WRITE(*,*) 'Using spherical regridding !!'

      CALL ef_get_bad_flags(id,bad_flag,bad_flag_result)

      nlon_src = arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 1
      nlat_src = arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1) + 1
      nlon_dst = arg_hi_ss(X_AXIS,ARG3) - arg_lo_ss(X_AXIS,ARG3) + 1
      nlat_dst = arg_hi_ss(Y_AXIS,ARG3) - arg_lo_ss(Y_AXIS,ARG3) + 1

      nx = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1
      ny = arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) + 1

      IF (nlon_src .NE. nx .OR. nlat_src .NE. ny) call ef_bail_out (id, 
     . 'argument 2 must have the same x and y dimensions as argument 1')  

* Tranlate input and output grid coordinates to radians.

* arg_1 is lons_in
* arg_2 is lats_in
* src_grid_radians(nx_src, ny_src, 2, 1)

      pi =  4.*ATAN(1.)
      pi180 = pi/ 180.

      DO j = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)
      DO i = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)
         src_grid_radians(i,j,1,1) = pi180*arg_1(i,j,mem1loz,mem1lot)
      ENDDO
      ENDDO

      DO j = arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS,ARG2)
      DO i = arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS,ARG2)
         src_grid_radians(i,j,2,1) = pi180*arg_2(i,j,mem2loz,mem2lot)
      ENDDO
      ENDDO

      arg = 3
      idim = 1

      CALL EF_GET_COORDINATES (id, arg, idim,
     .     arg_lo_ss(X_AXIS,ARG3), arg_hi_ss(X_AXIS,ARG3), 
     .     dst_grid(1,1,1,1) )

      arg = 3
      idim = 2

      CALL EF_GET_COORDINATES (id, arg, idim,
     .     arg_lo_ss(Y_AXIS,ARG3), arg_hi_ss(Y_AXIS,ARG3), 
     .     dst_grid(1,2,1,1) )

      DO j = 1, nlat_dst
      DO i = 1, nlon_dst
        dst_grid_radians(i, j, 1, 1) = pi180* dst_grid(i,1,1,1)
      ENDDO
      ENDDO

      DO j = 1, nlat_dst
      DO i = 1, nlon_dst
        dst_grid_radians(i, j, 2, 1) = pi180* dst_grid(j,2,1,1)
      ENDDO
      ENDDO

      CALL horiz_interp_init_sphe(id, 
     .        src_grid_radians(wrk6lox,wrk6loy,1,1), 
     .        src_grid_radians(wrk6lox,wrk6loy,2,1), 
     .        dst_grid_radians(wrk8lox,wrk8loy,1,1), 
     .        dst_grid_radians(wrk8lox,wrk8loy,2,1),
     .        i_lon_j_lat(wrk1lox,wrk1loy,wrk1loz,1), 
     .        i_lon_j_lat(wrk1lox,wrk1loy,wrk1loz,2), 
     .        ilon, jlat, 
     .        src_dist(wrk2lox,wrk2loy,wrk2loz,1), 
     .        src_dist(wrk2lox,wrk2loy,wrk2loz,2),
     .        found_neighbors(wrk3lox,wrk3loy,1,wrk3lot), 
     .        map_src_add, 
     .        found_neighbors(wrk3lox,wrk3loy,1,wrk3lot), 
     .        num_nbrs, max_dist, 
     .        src_modulo, nlon_src, nlat_src, nlon_dst, nlat_dst)

      i = res_lo_ss(X_AXIS)
      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      l = res_lo_ss(T_AXIS)

      CALL save_mapping (src_dist, wt, 
     .        found_neighbors(wrk3lox,wrk3loy,wrk3loz,wrk3lot), 
     .        i_lon_j_lat(wrk1lox,wrk1loy,wrk1loz,1), 
     .        i_lon_j_lat(wrk1lox,wrk1loy,wrk1loz,2), 
     .        max_dist, nlon_src, nlat_src, 
     .        nlon_dst, nlat_dst, num_nbrs, bad_flag_result,
     .        result(i,j,k,l) )

!                                                                     ^
!                                                                     |
!                                           USER CONFIGURABLE PORTION |
!**********************************************************************

      RETURN 
      END  ! SUBROUTINE curv_to_rect_map_compute

      
      subroutine horiz_interp_init_sphe(id, lon_in, lat_in, lon_out, 
     .        lat_out, i_lon, j_lat, ilon, jlat, src_dist, map_src_dist,
     .        found_neighbors, map_src_add, map_found_neighbors, 
     .        num_nbrs, max_dist, src_modulo, nlon_src, nlat_src, 
     .        nlon_dst, nlat_dst)
      
      integer id, nlon_src, nlat_src, nlon_dst, nlat_dst,  
     .        num_nbrs, ilon(num_nbrs), jlat(num_nbrs), 
     .        map_src_add(nlon_dst,nlat_dst,num_nbrs),
     .        i_lon(nlon_dst,nlat_dst,num_nbrs),
     .        j_lat(nlon_dst,nlat_dst,num_nbrs)

      real    max_dist, 
     .        lon_in(nlon_src, nlat_src),  lat_in(nlon_src, nlat_src), 
     .        lon_out(nlon_dst, nlat_dst), lat_out(nlon_dst, nlat_dst),
     .        src_dist(nlon_dst,nlat_dst,num_nbrs)

      logical found_neighbors(nlon_dst,nlat_dst), src_modulo
      
!------local variables ---------------------------------------
      
      integer  i, j, n, num_neighbors, map_dst_xsize, map_dst_ysize, 
     .         map_src_xsize, map_src_ysize, map_src_size
      real     max_src_dist,
     .         map_src_dist(nlon_dst,nlat_dst,num_nbrs)
      
      logical map_found_neighbors(nlon_dst, nlat_dst)

!--------------------------------------------------------------
      map_dst_xsize = nlon_dst
      map_dst_ysize = nlat_dst
      map_src_xsize = nlon_src
      map_src_ysize = nlat_src
      map_src_size = map_src_xsize*map_src_ysize
      
      num_neighbors = num_nbrs
      max_src_dist = max_dist
      
!using radial_search to find the nearest points and corresponding distance.

      call radial_search(id, lon_in, lat_in, lon_out, lat_out, 
     .          map_src_add, map_src_dist, map_found_neighbors,
     .          num_nbrs, max_dist, src_modulo, nlon_src, nlat_src,
     .          nlon_dst, nlat_dst, map_src_size )
      
      do j=1,map_dst_ysize
      do i=1,map_dst_xsize
         do n=1,num_neighbors
            if(map_src_add(i,j,n) .EQ. 0) then
               jlat(n) = 0
               ilon(n) = 0
            else
               jlat(n) = map_src_add(i,j,n)/map_src_xsize + 1
               ilon(n) = map_src_add(i,j,n) - (jlat(n)-1)*map_src_xsize
               if(ilon(n) .EQ. 0) then
                  jlat(n) = jlat(n) - 1
                  ilon(n) = map_src_xsize
               endif
            endif
            i_lon(i,j,n) = ilon(n)
            j_lat(i,j,n) = jlat(n)
         enddo
      
      enddo
      enddo
      
      do j=1,map_dst_ysize
      do i=1,map_dst_xsize
         do n=1,num_neighbors
            src_dist(i,j,n) = map_src_dist(i,j,n)
         enddo
         found_neighbors(i,j) = map_found_neighbors(i,j)
      enddo
      enddo
      
      nlon_src = map_src_xsize
      nlat_src = map_src_ysize
      nlon_dst = map_dst_xsize
      nlat_dst = map_dst_ysize
      
      return

      end ! subroutine horiz_interp_init_sphe
!#####################################################################
      
       subroutine radial_search(id, theta_src, phi_src, theta_dst, 
     .      phi_dst, map_src_add, map_src_dist, map_found_neighbors, 
     .      num_nbrs, max_dist, src_modulo, nlon_src, nlat_src,
     .      nlon_dst, nlat_dst, map_src_size)
      
! x_dst,y_dst = destination grid lon,lat
! x_src,y_src = source grid lon,lat


!       theta_src = reshape(x_src,(/map_src_size/))
!       phi_src = reshape(y_src,(/map_src_size/))
!       theta_dst(:,:) = x_dst(:,:)
!       phi_dst(:,:) = y_dst(:,:)      

       integer id, nlon_src, nlat_src, nlon_dst, nlat_dst, num_nbrs, 
     .         map_src_add(nlon_dst,nlat_dst,num_nbrs)

       real    theta_src(map_src_size), phi_src(map_src_size),  
     .         theta_dst(nlon_dst, nlat_dst), 
     .         phi_dst(nlon_dst, nlat_dst),
     .         map_src_dist(nlon_dst,nlat_dst,num_nbrs), max_dist

       logical map_found_neighbors(nlon_dst, nlat_dst), src_modulo
       
!-------local variables-----------------------------------------

       integer i, j, n, bound, bound_start, bound_end, i0, j0, 
     .         i_left, i_right, step, step_size, num_neighbors, 
     .         map_dst_xsize, map_dst_ysize, map_src_xsize, 
     .         map_src_ysize, map_dst_size, map_src_size

       real    spherical_distance, d, nearest,res, max_src_dist, pi, 
     .         tpi, hpi, min_theta_dst, max_theta_dst, min_phi_dst, 
     .         max_phi_dst, min_theta_src, max_theta_src, min_phi_src,
     .         max_phi_src, pi180

       logical update_dest_neighbors, continue_search, found_neighbors,
     .         continue_radial_search, result, src_is_modulo


!---------------------------------------------------------------
      

! parameters
      real epsln, large
cc      parameter (epsln=1.e-10, large=1.e20)
      parameter (epsln=4.e-7, large=1.e20)

       pi = 4.*ATAN(1.)
       tpi = 2.0*PI
       hpi = 0.5*PI
       
        pi180 = pi/ 180.

       map_dst_xsize = nlon_dst
       map_dst_ysize = nlat_dst
       map_src_xsize = nlon_src
       map_src_ysize = nlat_src      
       map_dst_size = map_dst_xsize*map_dst_ysize
       map_src_size = map_src_xsize*map_src_ysize
      
       num_neighbors = num_nbrs
       if (num_neighbors .LE. 0) call ef_bail_out (id, 
     .   'num_neighbors must be > 0') 
      
       max_src_dist = max_dist
       src_is_modulo = src_modulo
      
       do i = 1, nlon_dst
       do j = 1, nlat_dst
       do n = 1, num_nbrs
          map_src_add(i,j,n) = 0
          map_src_dist(i,j,n) = large
       enddo
       enddo
       enddo
      
       min_theta_dst=tpi
       max_theta_dst=0.0
       min_phi_dst=pi
       max_phi_dst=-pi
       min_theta_src=tpi
       max_theta_src=0.0
       min_phi_src=pi
       max_phi_src=-pi
      
            
       do i = 1, nlon_dst
       do j = 1, nlat_dst
          if(theta_dst(i,j) .LT. 0.0) theta_dst(i,j)=theta_dst(i,j)+tpi
          if(theta_dst(i,j) .GT. tpi) theta_dst(i,j)=theta_dst(i,j)-tpi
          if(phi_dst(i,j) .LT. -1.* hpi) phi_dst(i,j) = -1.* hpi
          if(phi_dst(i,j) .GT. hpi)  phi_dst(i,j) =  hpi
       enddo
       enddo
       
       do i = 1, map_src_size
          if(theta_src(i) .LT. 0.0)  theta_src(i) = theta_src(i)+tpi
          if(theta_src(i) .GT. tpi)  theta_src(i) = theta_src(i)-tpi
          if(phi_src(i) .LT. -1.* hpi) phi_src(i) = -1.* hpi
          if(phi_src(i) .GT. hpi)  phi_src(i) =  hpi
       enddo

       do j=1,map_dst_ysize
       do i=1,map_dst_xsize
          min_theta_dst = min(min_theta_dst,theta_dst(i,j))
          max_theta_dst = max(max_theta_dst,theta_dst(i,j))
          min_phi_dst = min(min_phi_dst,phi_dst(i,j))
          max_phi_dst = max(max_phi_dst,phi_dst(i,j))
       enddo
       enddo
      
       do i=1,map_src_size
          min_theta_src = min(min_theta_src,theta_src(i))
          max_theta_src = max(max_theta_src,theta_src(i))
          min_phi_src = min(min_phi_src,phi_src(i))
          max_phi_src = max(max_phi_src,phi_src(i))
       enddo
      
!  Note: do comparisons like these with a TM_FPEQ 

c       if (min_phi_dst .LT. min_phi_src) print *, 
c     .    '=> WARNING:  latitute of dest grid exceeds src: src, dest',
c     .    min_phi_src, min_phi_dst, ' degrees src, dest:', 
c     .    min_phi_src/pi180, min_phi_dst/pi180
c       if (max_phi_dst .GT. max_phi_src) print *, 
c     .    '=> WARNING:  latitute of dest grid exceeds src: src, dest',
c     .    max_phi_src, max_phi_dst, ' degrees src, dest:', 
c     .    max_phi_src/pi180, max_phi_dst/pi180
c       if (min_theta_dst .LT. min_theta_src) print *, 
c     .    '=> WARNING : longitude of dest grid exceeds src: src, dest',
c     .    min_theta_src, min_theta_dst, ' degrees src, dest:', 
c     .    min_theta_src/pi180, min_theta_dst/pi180
c       if (max_theta_dst .GT. max_theta_src) print *, 
c     .    '=> WARNING : longitude of dest grid exceeds src: src, dest',
c     .    max_theta_src, max_theta_dst, ' degrees src, dest:', 
c     .    max_theta_src/pi180, max_theta_dst/pi180
      
       do j=1,map_dst_ysize
       do i=1,map_dst_xsize
          found_neighbors=.false.
          continue_search=.true.
          step = 1
          step_size = 1
          nearest = 1.e3
          do while (continue_search .and. step_size .GT. 0)
             do while (step .LE. map_src_size .and. continue_search)
! count land points as nearest neighbors
                d = spherical_distance (theta_dst(i,j), phi_dst(i,j), 
     .                                 theta_src(step),phi_src(step))
                if (d .LE. max_src_dist) then
                   found_neighbors = update_dest_neighbors(
     .                    i, j, map_src_add, map_src_dist, 
     .                    step, d, max_src_dist, 
     .                    nlon_dst, nlat_dst, num_nbrs)
                   if (found_neighbors) then
                      n = 0
                      i0 = mod(step,map_src_xsize)
                      if (i0 .EQ. 0) i0 = map_src_xsize
                      res = float(step)/float(map_src_xsize)
!                     j0 = ceiling(res)
                      j0 = -1.*INT(-1.*res)
                      continue_radial_search = .true.
                      do while (continue_radial_search)
                         n = n+1 ! radial counter
! left boundary 
                         i_left = i0-n
                         if (i_left .LE. 0) then
                            if (src_is_modulo) then
                               i_left = map_src_xsize + i_left
                            else
                               i_left = 1
                            endif
                         endif
                         bound_start = max(j0-n-1,0)*map_src_xsize 
     .                                  + i_left
                         bound_end = min(j0+n-1,map_src_ysize-1)*
     .                                   map_src_xsize + i_left
                         if (bound_end .GT. map_src_size) 
     .                      call ef_bail_out(id, 'array size error')
                         bound = bound_start
                         continue_radial_search = .false.
                         do while (bound .LE. bound_end)
                            d = spherical_distance (theta_dst(i,j),
     .                            phi_dst(i,j), theta_src(bound), 
     .                            phi_src(bound))
                            result = update_dest_neighbors(
     .                        i, j, map_src_add, map_src_dist, 
     .                        bound, d, max_src_dist,
     .                        nlon_dst, nlat_dst, num_nbrs)
                            bound = bound + map_src_xsize
                            if (result) continue_radial_search = .true.
                            if (result) found_neighbors = .true.
                         enddo
! right boundary 
                         i_right = i0+n
                         if (i_right .GT. map_src_xsize) then
                            if (src_is_modulo) then
                               i_right = i_right - map_src_xsize
                            else
                               i_right = map_src_xsize
                            endif
                         endif
                         bound_start = max(j0-n-1,0)*map_src_xsize 
     .                                + i_right
                         bound_end = min(j0+n-1,map_src_ysize-1)*
     .                                 map_src_xsize + i_right
                         bound = bound_start
                         if (bound_end .GT. map_src_size) 
     .                      call ef_bail_out(id, 'array size error')
                         do while (bound .LE. bound_end)
                            d = spherical_distance (theta_dst(i,j),
     .                          phi_dst(i,j),
     .                          theta_src(bound),phi_src(bound))
                            result = update_dest_neighbors(
     .                          i, j, map_src_add, map_src_dist, 
     .                          bound, d, max_src_dist,
     .                          nlon_dst, nlat_dst, num_nbrs)
                            bound = bound + map_src_xsize
                            if (result) continue_radial_search = .true.
                            if (result) found_neighbors = .true.
                         enddo
! bottom boundary 
                         bound_start = max(j0-n-1,0)*map_src_xsize 
     .                                + i_left 
                         bound_end =  max(j0-n-1,0)*map_src_xsize  
     .                                + i_right 
                         if (bound_start .GT. bound_end) then
                            bound_start = max(j0-n-1,0)*map_src_xsize+1
                            bound_end = max(j0-n,1)*map_src_xsize
                         endif
                         bound = bound_start
                         if (bound_end .GT. map_src_size) 
     .                      call ef_bail_out(id, 'array size error')
                         do while (bound .LE. bound_end)
                            d = spherical_distance (theta_dst(i,j),
     .                          phi_dst(i,j),theta_src(bound),
     .                          phi_src(bound))
                            result = update_dest_neighbors(
     .                          i, j, map_src_add, map_src_dist, 
     .                          bound, d, max_src_dist,
     .                          nlon_dst, nlat_dst, num_nbrs)
                            bound = bound + 1
                            if (result) continue_radial_search = .true.
                            if (result) found_neighbors = .true.
                         enddo
! top boundary 
                         bound_start = min(j0+n-1,map_src_ysize-1)*
     .                          map_src_xsize + i_left
                         bound_end =  min(j0+n-1,map_src_ysize-1)*
     .                          map_src_xsize + i_right
                         if (bound_start .GT. bound_end) then
                            bound_start = min(j0+n-1,map_src_ysize-1)*
     .                          map_src_xsize + 1
                            bound_end = min(j0+n,map_src_ysize-1)*
     .                          map_src_xsize
                         endif
                         bound = bound_start
                         if (bound_end .GT. map_src_size) 
     .                      call ef_bail_out(id, 'array size error')
                         do while (bound .LE. bound_end)
                            d = spherical_distance (theta_dst(i,j),
     .                            phi_dst(i,j), theta_src(bound),
     .                            phi_src(bound))
                            result = update_dest_neighbors(
     .                          i, j, map_src_add, map_src_dist, 
     .                          bound, d, max_src_dist,
     .                          nlon_dst, nlat_dst, num_nbrs)
                            bound = bound + 1
                            if (result) continue_radial_search = .true.
                            if (result) found_neighbors = .true.
                         enddo
                      enddo
                      continue_search = .false. ! stop looking
                   endif
                endif
                step=step+step_size
             enddo ! search loop
             step = 1
             step_size = step_size/2
          enddo
          map_found_neighbors(i,j) = found_neighbors
       enddo 
       enddo
      
     .                                
      return
      
      end !  subroutine radial_search
      
!#####################################################################

      real function spherical_distance(theta1,phi1,theta2,phi2)

* Argument definitions
      real theta1, phi1, theta2, phi2

* local variable definitions
      real r1(3), r2(3), cross(3), s, dot, ang, pi

! parameters
      real epsln
cc      parameter (epsln=1.e-10)
      parameter (epsln=4.e-7)

! this is a simple, enough way to calculate distance on the sphere
! first, construct cartesian vectors r1 and r2
! then calculate the cross-product which is proportional to the area
! between the 2 vectors.  The angular distance is arcsin of the 
! distancealong the sphere
!
! theta is longitude and phi is latitude
!

      pi =  4.*ATAN(1.)

      r1(1) = cos(theta1)*cos(phi1)
      r1(2)=sin(theta1)*cos(phi1)
      r1(3)=sin(phi1)

      r2(1) = cos(theta2)*cos(phi2)
      r2(2)=sin(theta2)*cos(phi2)
      r2(3)=sin(phi2)

      cross(1) = r1(2)*r2(3)-r1(3)*r2(2)
      cross(2) = r1(3)*r2(1)-r1(1)*r2(3)
      cross(3) = r1(1)*r2(2)-r1(2)*r2(1)

      s = sqrt(cross(1)**2.+cross(2)**2.+cross(3)**2.)

      s = min(s,1.0-epsln)

      dot = r1(1)*r2(1) + r1(2)*r2(2) + r1(3)*r2(3)

      if (dot .GT. 0) then
          ang = asin(s)
      else if (dot .LT. 0) then
          ang = pi - asin(s)
      else
          ang = pi/2.
      endif
      
      spherical_distance = abs(ang) ! in radians
      
      return
      
      end ! function spherical_distance

!#####################################################################
      logical function update_dest_neighbors(i, j, map_src_add, 
     .             map_src_dist, src_add, d, max_src_dist, nx, ny, nn)
 
* Argument definitions
       integer i, j, nx, ny, nn, map_src_add(nx, ny, nn), src_add
       real map_src_dist(nx, ny, nn), d, max_src_dist

* local variables
      integer n,m, num_neighbors

      update_dest_neighbors = .false.
      num_neighbors = nn

! if (d .le. max_src_dist) then
!    NLOOP : do n=1,num_neighbors
!       DIST_CHK : if (d .lt. map_src_dist(n)) then
!          if (n > 1 .and. src_add == map_src_add(n-1)) exit NLOOP
!          do m=num_neighbors,n+1,-1
!             map_src_add(m) = map_src_add(m-1)
!             map_src_dist(m) = map_src_dist(m-1)
!          enddo
!          map_src_add(n) = src_add
!          map_src_dist(n) = d
!          update_dest_neighbors = .true.
!          exit NLOOP ! n loop
!       endif DIST_CHK
!   end do NLOOP
! endif

      if (d .le. max_src_dist) then
         do n=1,num_neighbors 
            if (d .lt. map_src_dist(i,j,n)) then 
cc               if (n .GT. 1 .and. src_add .NE. map_src_add(i,j,n-1)) 
ccc               if (n .GT. 1 .and. src_add .EQ. map_src_add(i,j,n-1)) 
ccc     .             GOTO 100
               do m=num_neighbors,n+1,-1
                  map_src_add(i,j,m) = map_src_add(i,j,m-1)
                  map_src_dist(i,j,m) = map_src_dist(i,j,m-1)
               enddo
               map_src_add(i,j,n) = src_add
               map_src_dist(i,j,n) = d
               update_dest_neighbors = .true.
               goto 100
            endif 
         end do 
  100    continue

      endif

      return
      end ! function update_dest_neighbors



!#######################################################################
            
       subroutine save_mapping (src_dist, wt, 
     .      found_neighbors, i_lon, j_lat, max_src_dist,  
     .      nlon_src, nlat_src, nlon_dst, nlat_dst, num_nbrs,
     .      bad_flag_result, result)

! compute wt, i_lon, and j_lat and save in the result.
! result(nlon_dst,nlat_dst,num_nbrs,3)  where num_nbrs = 4 and
! 
!   result(m,n,k,1) = wt(m,n,k)
!   result(m,n,k,2) = i_lon(m,n,k)
!   result(m,n,k,3) = j_lat(m,n,k)

! acm 12/2004 Compute the sum of weights in apply_mapping in function 
!             curv_to_rect; weights only used when there is good data 
!             contributing to the destination grid cell.

       integer nlon_src, nlat_src, nlon_dst, nlat_dst, num_nbrs

       real src_dist(nlon_dst, nlat_dst, num_nbrs)
       real wt(nlon_dst, nlat_dst, num_nbrs)  
       real max_src_dist, bad_flag_result

       integer i_lon(nlon_dst,nlat_dst,num_nbrs)
       integer j_lat(nlon_dst,nlat_dst,num_nbrs) 

!  Result contains wts, neighbors, for applying the regridding
       real result(nlon_dst, nlat_dst, num_nbrs, 3)  

       logical found_neighbors(nlon_dst,nlat_dst)

!--- some local variables ----------------------------------------
       integer nlon_in, nlat_in, nlon_out, nlat_out, num_neighbors,
     .               m, n, k, i1, i2, j1, j2
!-----------------------------------------------------------------
      
      real epsln, large
cc      parameter (epsln=1.e-10, large=1.e20)
      parameter (epsln=4.e-7, large=1.e20)
      
         nlon_in  = nlon_src
         nlat_in  = nlat_src
         nlon_out = nlon_dst
         nlat_out = nlat_dst   
         num_neighbors = num_nbrs

!first calculate destination weight
      
         do m=1,nlon_out
         do n=1,nlat_out

! neighbors are sorted nearest to farthest
! check nearest to see if it is a land point

            i1 = i_lon(m,n,1)
            j1 = j_lat(m,n,1)
      
            if(num_neighbors .gt. 1 ) then
               i2 = i_lon(m,n,2)
               j2 = j_lat(m,n,2)
            endif
      
            do k=1, num_neighbors
              if (src_dist(m,n,k) .LE. epsln) then
                 wt(m,n,k) = large
              else if(src_dist(m,n,k) .LE. max_src_dist ) then
                 wt(m,n,k) = 1.0/src_dist(m,n,k)
              else
                 wt(m,n,k) = 0.0
              endif
           enddo

         enddo
         enddo
      
! Save wt, i_lon, j_lat for this curvi/rect grid pair.

         do m=1,nlon_out
         do n=1,nlat_out
            do k=1, num_neighbors
               result(m,n,k,1) = wt(m,n,k)
               result(m,n,k,2) = i_lon(m,n,k)
               result(m,n,k,3) = j_lat(m,n,k)
            enddo
         enddo
         enddo
      
         return
       end ! subroutine save_mapping

	SUBROUTINE PARSE_VAR_NAME( full_var_name, var_cx, mods_cx, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* parse a full variable specification of the form:
*			(eg.) TEMP[X=170E:170W,K=+1D,T=188979]
* return the context modifications in the modification buffer passed
* and the updated (but not completed) variable context in the var context passed
* (var_cx must contain the full default context at the time of the call)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 6/27/86
* revision 0.1 - 2/25/87 - using PARAMETER munknown_var_name
* revision 0.2 - 3/23/87 - added new TMAP library: time axes, file var. names
*			   APPLY_CONTEXT_MODS now called in this routine
* revision 0.3 - 9/16/87 - unknown_qual_bad moved to FERRET.PARM
* revision 0.4 - 7/27/88 - added var_cx (default) to get_context_mods call
* V200:  4/25/90 - initialize cx_given (bug): it was passed along from default
*		   context if no mods were given.  Thus "list/i=101:105 temp"
*		   would have cx_given(x_dim)=.true. whereas
*		   "list/i=101:105 temp[x=@ave]" would have it .false.
* V402: 7/95 - Allow nested [] of the form vname1[G=vname2[D=dset]]
* V450: 1/97 - use local variables instead of xPROG_STATE vars for item_start
*		etc. to avoid conflict. (But share the max_item_list parameter
*		from the COMMON area.
* V530:  8/00 *sh* - set the variables data type
* V550: 10/02 *acm*- Look for @ in full_var_name when determining name_len
* V554 1/04 *acm* - add category cat_counter_var
* V600: 9/05 *acm* - add category cat_attrib_val
* V611 5/08 *acm* Fix bug 1578; dataset specifiers applied correctly var[d=1].attname
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V685 3/13 *sh* support for auxiliary regridding variables
*		 and SHOW VAR/DEPENDENCIES (unknown variable err not reported)
* V690 12/13 *sh* set auto-curvilinear actions that are needed
* V693+ 11/14 *sh* renaming 'sigma' as 'layerz' throughout
*       12/14 *sh* save bracket character positions for VTREE report
* V698  3/16 *acm* Removed Philander-Seigel code including diagnostic 
*                  variables, pre-defined axes and grids, cat_calc_var.
* V698  3/16 *sh* added logic for cat_ef_time2d (ACTS_LIKE_FVAR)
* v698 5/16  *acm* ticket 2413: New attribute keywords ncoordvars, coordnames
*                  return info about coordinate-variables in datasets
* V710 9/16  *acm* ticket 2465: Parsing expressions including attribute references.

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xprog_state.cmn'
	include	'xcontext.cmn'
	include	'xdependency_tree.cmn'
#include "netcdf.inc"

* calling argument declarations:
	CHARACTER*(*)	full_var_name
	INTEGER		var_cx, mods_cx, status

* internal variable declarations:
	LOGICAL         ACTS_LIKE_FVAR
	INTEGER		STR_SAME, TM_LENSTR1, 
     .                  full_name_len, left_bracket, right_bracket, 
     .			name_len, atsign, idim,  brac_nest, i,
     .                  dset, varid, attype, attlen, attoutflag,
     .                  attid, dot,
     .			curv_vars(nferdims), curv_cats(nferdims)
 	LOGICAL		name_only, do_err, aux_given
* 1/97 addition
	INTEGER	num_it, it_start(max_item_list), it_end(max_item_list)
        CHARACTER varname*512, attname*128, newname*512

        newname = full_var_name

* separate simple name from possible modifiers
	full_name_len = TM_LENSTR1 ( newname )
	left_bracket  = INDEX ( newname, '[' )
	name_only     = left_bracket .EQ. 0
	IF ( name_only ) THEN
	   name_len = full_name_len
	ELSE
	   name_len = left_bracket - 1
* ... hunt for matching right bracket
	   brac_nest = 1
	   right_bracket = 0	! default to catch syntax errors
	   DO 200 i = left_bracket+1,full_name_len
	      IF ( newname(i:i) .EQ. "[" ) THEN
	         brac_nest = brac_nest + 1
	      ELSEIF ( newname(i:i) .EQ. "]" ) THEN
	         brac_nest = brac_nest - 1
	         IF ( brac_nest .EQ. 0 ) THEN
	            right_bracket = i
	            GOTO 210
	         ENDIF
	      ENDIF
 200	   CONTINUE
 210	   IF (   right_bracket .LE. left_bracket + 1
     .	     .OR. name_len      .LE. 0			) GOTO 5000
	ENDIF

        IF (left_bracket .GT. 0) THEN
           dot = INDEX ( newname, '.' )
           IF (dot .GT. right_bracket) THEN  ! this is a var[d=].attribute
              newname = full_var_name(1:left_bracket-1)//
     .         full_var_name(left_bracket:right_bracket)//
     .         full_var_name(right_bracket+1:full_name_len)
              full_name_len = TM_LENSTR1(newname)
              name_len = full_name_len
              name_only = .TRUE.
           ENDIF
        ENDIF

* If full_var_name is b@asn, which can occur if b not yet loaded, return 
* name_len is just up to the @

        atsign = INDEX ( newname, '@' )
        IF (atsign .GT. 0  .AND. name_only) THEN
           name_len = atsign - 1
    	   IF (   name_len      .LE. 0			) GOTO 5000
        ENDIF

* break up the "[...,...,...]" into comma-separated arguments
	IF ( .NOT.name_only ) THEN
	   CALL PARSE_COMMA_LIST (	newname,
     .					left_bracket  + 1,
     .					right_bracket - 1,
     .					max_item_list,
     .					num_it,
     .					it_start,
     .					it_end,
     .					status		)
	   IF ( status .NE. ferr_ok ) GOTO 5900
	ELSE
	   num_it = 0
	ENDIF

*interpret the list of items - unknown items represent errors
	CALL GET_CONTEXT_MODS (	var_cx,
     .				newname,
     .				mods_cx,
     .				max_item_list,
     .				num_it,
     .				it_start,
     .				it_end,
     .				unknown_qual_bad,
     .				status	)
	IF ( status .NE. ferr_ok ) GOTO 5900

! no.  save exact position when error is detected in GET_CONTEXT_MODS
!* save the bracket position for VTREE unknown grid report
!	IF (cx_vtree_unknown_grid) THEN
!	   cx_vtree_var_or_start = left_bracket
!	   cx_vtree_cat_or_end   = right_bracket
!	ENDIF

* apply those context mods that don't need to know the grid
* apply them now, before looking for the variable name, because the data set is
* needed in the name search
	DO 100 idim = 1, nferdims
 100	cx_given(idim,var_cx) = .FALSE.			! *sh* 4/90 bug fix
	CALL APPLY_CONTEXT_MODS ( mods_cx, var_cx, nest_context, status )
	IF ( status .NE. ferr_ok ) GOTO 5900

* identify the simple variable name
        CALL FIND_VAR_NAME( cx_data_set( var_cx ),
     .			    newname(1:name_len),
     .			    cx_category( var_cx ),
     .			    cx_variable( var_cx ) )

* always apply mods that describe the auxiliary regridding variables
	cx_naux(var_cx) = cx_naux(mods_cx)
	DO 102 idim = 1, nferdims
	   cx_aux_arg_start(idim,var_cx) = cx_aux_arg_start(idim,mods_cx)
	   cx_aux_arg_end  (idim,var_cx) = cx_aux_arg_end  (idim,mods_cx)
	   cx_aux_stat     (idim,var_cx) = cx_aux_stat     (idim,mods_cx) 
 102	CONTINUE

	IF ( cx_variable( var_cx ) .EQ. munknown_var_name ) THEN
* bail out if this variable cannot be identified
	   GOTO 5100
	ELSEIF (cx_category(var_cx) .EQ. cat_file_var
     .     .OR. cx_category(var_cx) .EQ. cat_user_var ) THEN
* fill in the default aux vars associated with this variable
	   CALL GET_AUTO_AUX_VARS( cx_variable(var_cx),
     .				   cx_category(var_cx),
     .				   cx_data_set(var_cx),
     .				   curv_vars, curv_cats )
	   DO idim = 1, nferdims
	      IF ( curv_vars(idim) .NE. unspecified_int4
     .	     .AND. cx_aux_stat(idim,var_cx) .EQ. paux_stat_na  ) THEN
	         cx_aux_cat (idim,var_cx) = curv_cats(idim)
	         cx_aux_var (idim,var_cx) = curv_vars(idim)
	         cx_aux_stat(idim,var_cx) = paux_stat_passed
	      ENDIF
	   ENDDO
	ENDIF

* set up automated curvilinear actions:  aux variable loads and regridding
* cases include
*  [z=pt, layerz], [z=lo:hi:delta,layerz], [z=lo:hi@ave,layerz], [gz=zax,layerz]
	cx_implicit_aux(var_cx) = .FALSE.   ! set default
	aux_given = .FALSE.
	DO idim = 1, nferdims
	   aux_given = aux_given .OR. cx_aux_given(idim,mods_cx)
	ENDDO
	IF ( aux_given ) THEN
	   IF ( cx_category(var_cx) .NE. cat_file_var
     .	  .AND. cx_category(var_cx) .NE. cat_user_var ) GOTO 5200
!	   IF (cx_mod_layerz .AND.
!     .	     .NOT. (cx_given(z_dim,mods_cx)) GOTO 5300
!	   IF (cx_mod_curvi .AND.
!     .	     .NOT.(cx_given(x_dim,mods_cx).AND.cx_given(y_dim,mods_cx))
!     .					 ) GOTO 5350
	   CALL APPLY_AUTO_CURV(newname(:full_name_len), var_cx, status)
	   IF (status .NE. ferr_ok) GOTO 5900
	ENDIF

* set the data type of the variable
	IF ( ACTS_LIKE_FVAR(cx_category(var_cx)) ) THEN
	   cx_type(var_cx) = ptype_float   ! TO BE GENERALIZED LATER (8/00)
	ELSEIF (cx_category(var_cx) .EQ. cat_counter_var ) THEN
	   cx_type(var_cx) = ptype_float
        ELSEIF (cx_category(var_cx) .EQ. cat_attrib_val) THEN

           do_err = .TRUE.
           dset = cx_data_set(var_cx)
           IF (dset .EQ. unspecified_int4) dset = pdset_uvars  
           CALL  BREAK_VARATTNAME ( newname(1:name_len),
     .                              dset, varname, 
     .                              attname, varid, do_err, status )

           IF (status .NE. ferr_ok) GOTO 5100
           IF (varid .GE. 0) THEN
              CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid,
     .               status)
              IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, varid, 
     .           attid, attname, attype, attlen, attoutflag, status )

              IF (status .NE. ferr_ok) THEN
* Is it a pseudo-attribute for the variable?

                 IF (STR_SAME(attname, 'attnames') .EQ. 0 .OR. 
     .               STR_SAME(attname, 'dimnames') .EQ. 0 .OR. 
     .               STR_SAME(attname, 'varnames') .EQ. 0 .OR. 
     .               STR_SAME(attname, 'coordnames') .EQ. 0 ) THEN
                    cx_type(var_cx) = ptype_string
                 ELSEIF (STR_SAME(attname, 'ndims') .EQ. 0 .OR. 
     .                   STR_SAME(attname, 'type')  .EQ. 0 .OR. 
     .                   STR_SAME(attname, 'nvars') .EQ. 0 .OR. 
     .                   STR_SAME(attname, 'nattrs') .EQ. 0 .OR. 
     .                   STR_SAME(attname, 'ncoordvars') .EQ. 0) THEN
                    cx_type(var_cx) = ptype_float
                 ELSE
                    GOTO 5100
                 ENDIF
              ELSE

                 cx_type(var_cx) = ptype_float
                 IF (attype .EQ. NCCHAR) cx_type(var_cx) = ptype_string
              ENDIF

           ELSE

* Is it a pseudo-attribute at the dataset level?
              cx_type(var_cx) = ptype_float
              IF (STR_SAME (attname, 'varnames')   .EQ. 0 .OR.
     .            STR_SAME (attname, 'dimnames')   .EQ. 0 .OR.
     .            STR_SAME (attname, 'coordnames') .EQ. 0 .OR.
     .            STR_SAME (attname, 'attnames')   .EQ. 0 .OR.
     .            STR_SAME (attname, 'nvars')      .EQ. 0 .OR.
     .            STR_SAME (attname, 'nattrs')     .EQ. 0 .OR.
     .            STR_SAME (attname, 'ncoordvars') .EQ. 0 .OR. 
     .               STR_SAME(attname, 'coordnames') .EQ. 0 )
     .         cx_type(var_cx) = ptype_string
           ENDIF
	ELSE
	   cx_type(var_cx) = unspecified_int4 ! inherited from definition
	ENDIF

* successful completion:
        status = ferr_ok
	RETURN

* error exits:
 5000	CALL ERRMSG( ferr_syntax, status, full_var_name, *5900 )
 5100	IF ( dependency_tree_mode ) THEN
	   status = ferr_unknown_variable   ! set the status, but don't report
	   GOTO 5900
	ELSE
	   CALL ERRMSG
     .		( ferr_unknown_variable, status, full_var_name, *5900 )
	ENDIF
 5200	CALL ERRMSG( ferr_syntax, status,
     .		'LAYERZ and CURVI can only be used on LET variables'//
     .		' and file variables: '//full_var_name, *5900 )
! 5300	CALL ERRMSG( ferr_syntax, status,
!     .		'LAYERZ must be accompanied by explicit Z limits: '
!     .		//full_var_name, *5900 )
! 5350	CALL ERRMSG( ferr_syntax, status,
!     .		'CURVI must be accompanied by explicit X and Y limits: '
!     .		//full_var_name, *5900 )

 5900	RETURN
	END

	SUBROUTINE DOLLAR_ARG( carg, goline, arg, lenarg, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* locate and return the indicated argument for this GO file

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V300: 4/21/93
* V420:  avoid breaking apart "[]" as at the comma in "var[x=1,y=2]"
* V510: 3/00 *sh* - allow backslash escapes to protect quotations
* V531 *sh* 4/01 - allow 2-digit argument numbers and enclosing parens
* 2/03 *kob* - g77 port - g77 won't allow intrinsic functions in PARAMETER
*                         statements.  use an octal constant instead
* 11/04*acm* - fix bug 485: $0 should return the name of the script -
*              IF (karg.LE.0 .OR. karg.GE.100) should be IF(karg.LT.0 ...
* V693+ *sh 2/15 - added support for _DQ_-enclosedquotations
* V697 *acm 1/16 - Fix ticket 2343: preserve blanks at the end of quoted args

        IMPLICIT NONE
* calling argument declarations:
	INTEGER	  lenarg, status
	CHARACTER carg*2, goline*(*), arg*(*)

* internal variable declarations:
	LOGICAL quote, DQ_quote, found_comma, bslash, its_quote, its_DQ
	INTEGER	TM_LENSTR1,lengo, iarg, goptr, start, iend, karg,
     .		open_paren, open_brkt, i, la
	CHARACTER c1*1

* internal parameter declarations
	CHARACTER*1     tab
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
#else
	PARAMETER     ( tab = CHAR(9))
#endif

	include 'ferret.parm'
	include 'errmsg.parm'

* initialize
	status = ferr_ok
	goptr = 0
	lengo = TM_LENSTR1( goline )
	found_comma = .FALSE.

* which argument has been requested?
	IF ( carg .EQ. ' *' ) THEN
	   karg = 1               ! locate start of arg #1
	ELSEIF ( carg .EQ. ' <' ) THEN
	   GOTO 5100     ! implement later
	ELSE
	   READ ( carg, '(I2)', ERR=5100 ) karg
	   IF (karg.LT.0 .OR. karg.GE.100) GOTO 5100  
	ENDIF

* locate the start and end of argument number karg
	DO 500 iarg = 0, karg

* skip blanks and up to one comma that precede the argument
	   DO 100 start = goptr+1, lengo
	      c1 = goline(start:start)
	      IF ( c1 .EQ. ',' ) THEN
	         IF ( found_comma ) THEN
	            iend = start-1
	            goptr = start    ! (start-1 hangs on double comma)
	            GOTO 500
	         ENDIF
	         found_comma = .TRUE.
	      ELSEIF ( c1.NE.' ' .AND. c1.NE.tab ) THEN
	         GOTO 110
	      ENDIF
 100	   CONTINUE
* no more arguments in go line
	   lenarg = 0
	   arg = ' '
	   RETURN

* locate the end of the argument
* ignore commas inside of parentheses to protect "/LEV=(lo,hi,delta)"
* 10/95 ignore commas inside of sqr brackets to protect "VAR[x=1,y=2]"
 110	   quote    = .FALSE.
	   DQ_quote = .FALSE.
	   bslash   = .FALSE.
	   open_paren = 0
	   open_brkt  = 0
	   DO 200 goptr = start, lengo
	      c1 = goline(goptr:goptr)
	      its_quote = c1 .EQ. '"'
	      IF (c1 .EQ. '_' .AND. goptr+3.LE.lengo) THEN
	         its_DQ = goline(goptr:goptr+3) .EQ. "_DQ_"
	      ELSE
	         its_DQ = .FALSE.
	      ENDIF
	      IF (bslash) THEN
	         GOTO 190	! bypass looking at this character
#ifdef NO_DOUBLE_ESCAPE_SLASH
              ELSEIF (c1 .EQ. '\' ) THEN  ! ' char for emacs
#else
              ELSEIF (c1 .EQ. '\\') THEN
#endif
	         bslash=.TRUE.  ! bypass looking at next character
	         GOTO 200
	      ELSEIF ( its_quote .AND. .NOT.DQ_quote ) THEN
	         quote = .NOT.quote
	      ELSEIF ( its_DQ    .AND. .NOT.quote ) THEN
	         DQ_quote = .NOT.DQ_quote
	      ELSEIF ( quote .OR. DQ_quote ) THEN
	         CONTINUE           ! skip over quoted text
	      ELSEIF ( c1 .EQ. '(' ) THEN
	         open_paren = open_paren + 1
	      ELSEIF ( c1 .EQ. ')' ) THEN
	         IF (open_paren.GT.0) open_paren = open_paren - 1
	      ELSEIF ( c1 .EQ. '[' ) THEN
	         open_brkt  = open_brkt  + 1
	      ELSEIF ( c1 .EQ. ']' ) THEN
	          IF (open_paren.GT.0) open_brkt  = open_brkt  - 1
	      ELSEIF ( c1 .EQ. ',' ) THEN
	         IF ( open_paren.EQ.0 .AND. open_brkt.EQ.0 ) THEN
	            found_comma = .TRUE.
	            iend = goptr - 1
	            GOTO 500	     
	         ENDIF
	      ELSEIF (c1.EQ.' ' .OR. c1.EQ.tab ) THEN
	         iend = goptr - 1
	         GOTO 500
	      ENDIF
 190	      bslash = .FALSE.
 200	   CONTINUE
	   iend = lengo     ! end of buffer is end of arg

 500	CONTINUE

* return the requested argument string
	IF ( carg .EQ. ' *' .AND. iend .NE. lengo ) THEN
	   iend = lengo
	ELSEIF ( goline(start:start) .EQ. '"'
     .     .AND. goline(iend:iend)     .EQ. '"' ) THEN
* ... do not pass enclosing quotation marks
	   start = start + 1
	   iend  = iend  - 1
	ELSEIF ( goline(start:start) .EQ. '_'
     .     .AND. goline(iend :iend ) .EQ. '_'
     .     .AND. iend-start .GE. 7             ) THEN
* ... do not pass enclosing _DQ_ marks
	   IF (goline(start : start+3) .EQ. "_DQ_"
     .   .AND. goline(iend-3: iend   ) .EQ. "_DQ_" ) THEN
	      start = start + 4
	      iend  = iend  - 4
	   ENDIF
	ENDIF
	IF ( start .GT. iend ) THEN   ! beware empty quotes
              arg = ' '
              lenarg = 0
	ELSE
	   arg = goline(start:iend)
!	   lenarg = iend - start + 1
* ... remove one level of backslash escapes from the arg
	   CALL DE_ESCAPE_STRING(arg, lenarg)

* ... if the command had quotes, preserve blanks at the end of the string
	   IF (goline(iend:iend) .EQ. ' ') THEN
	      la = lenarg
	      DO i = iend-start+1, la+1, -1
	         lenarg = lenarg + 1
		 arg = arg//' '
	      ENDDO
	   ENDIF
	ENDIF

* a set of empty quotes is regarded as a place-holder for the default
	IF ( arg .EQ. ' ' ) lenarg = 0

* done
 	RETURN

* error exits
 5000	RETURN
 5100	CALL ERRMSG( ferr_syntax, status,
     .		     'illegal GO command argument: $'//carg, *5000 )
	END

	SUBROUTINE UPNSQUISH (instr,outstr,len_out)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	J Davison 3.15.89 JISAO/PMEL/TMAP
*	Routine to convert variable length string to upper case
*	and left justify, throwing away all blanks, and returning 
*	the length of the resulting string.  

	integer		len_in,len_out,i
	character*(*)	instr,outstr

	integer		mask
	data		mask/Z'DF'/

********************************************************************************

	len_in = len (instr)
	outstr = ' '

	len_out = 0
	do 10 i = 1,len_in
	   if (instr(i:i) .eq. ' ') goto 10

	   len_out = len_out + 1
	   if (instr(i:i) .lt. 'a' .or. instr(i:i) .gt. 'z' ) then     
	      outstr(len_out:len_out) = instr(i:i)
           else                                                         
#ifdef unix

#ifdef NEED_IAND
#ifdef FORTRAN_90
C	*jd* Mod for linux port *jd* 12.96
	outstr(len_out:len_out) = 
     x	char(iand(mask,ichar(instr(i:i))))
#else
	outstr(len_out:len_out) = 
     x	char(iand('DF'x,ichar(instr(i:i))))
#endif
#else
              outstr(len_out:len_out) = 
     .              char(and('DF'x,ichar(instr(i:i))))
#endif
#else
              outstr(len_out:len_out) = 
     .              char(iand('DF'x,ichar(instr(i:i))))
#endif
           end if      
10	continue

	return
	end

	INTEGER FUNCTION DO_SMTH_BOX_P( idim, arg,
     .					com, com_mr, com_cx,
     .					res, res_mr, res_cx,
     .					wt	)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* smooth along axis idim by a running mean filter, summing all data 
* present in the box. This will return a result based on partial data.

* programmer - Ansley Manke
* From do_smth_box

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xprog_state.cmn'

* calling argument declarations:
	INTEGER	idim, com_mr, com_cx, res_mr, res_cx
	REAL	arg, wt(*), com(*), res(*)

* internal variable declarations
	LOGICAL	even
	INTEGER	i, wlen
	REAL	weight

* diagnostic mode output: " doing --> VAR_NAME[x=lo:hi@TRN:n,D=#]"
	IF ( mode_diagnostic ) 	CALL DIAG_OP
     .				( 'doing', isact_class_trans, res_cx, idim )

* initialize
	wlen = arg	! length of smoother

* create weights array to be convolved with data
* (with half weights on ends for even argument given)
	weight = 1. / FLOAT(wlen)
	even = MOD(wlen,2) .EQ. 0
	IF (even) wlen = wlen + 1
	DO 100 i = 1, wlen
 100	wt(i) = weight
	IF ( even) THEN
	   wt(1)    = weight * 0.5
	   wt(wlen) = weight * 0.5
	ENDIF

* now convolve this along the desired axis of the grid
	CALL CONVOLVE_P(idim, wlen/2, wt,
     .			com, com_mr, com_cx,
     .			res, res_mr, res_cx )

* success
	DO_SMTH_BOX_P = ferr_ok
	RETURN
	END

	LOGICAL FUNCTION ITSA_MODULO_CURVI_AXIS( xfield, yfield, mr_xpos, 
     .                                           mr_ypos, idim, 
     .                                           dim1, dim2)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*       determine whether a particular curvilinear context grid axis is a modulo one

*       programmer - jonathan callahan
*       NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

*       V420: 04/97
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V687 *acm* 3/14  Ticket 2151: The coordinate variables may be in other dimensions
*                  than XY, e.g. XZ or YZ for a layerz-coordinate vertical axis.
* V693+ 11/14 *sh* renaming 'sigma' as 'layerz' throughout

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'tmap_errors.parm'
	include 'xtm_grid.cmn_text'
	include 'xcurvilinear.cmn'

*       calling argument declarations:
	LOGICAL ITSA_MODULO_CURVI_AXIS_SUB
	REAL    xfield(*), yfield(*)
	INTEGER	mr_xpos, mr_ypos, idim, dim1, dim2

*	Internal declarations
	INTEGER slox_dim1, shix_dim1, slox_dim2, shix_dim2, 
     .          sloy_dim1, shiy_dim1, sloy_dim2, shiy_dim2

* The typical xlon, ylat case
	IF (dim1 .EQ. 1) THEN
	   slox_dim1 = mr_lo_s1(mr_xpos)
	   shix_dim1 = mr_hi_s1(mr_xpos)
	   sloy_dim1 = mr_lo_s1(mr_ypos)
	   shiy_dim1 = mr_hi_s1(mr_ypos)
	ENDIF

* Coordinate field 1 represents something else
	IF (dim1 .EQ. 2) THEN
	   slox_dim1 = mr_lo_s2(mr_xpos)
	   shix_dim1 = mr_hi_s2(mr_xpos)
	   sloy_dim1 = mr_lo_s2(mr_ypos)
	   shiy_dim1 = mr_hi_s2(mr_ypos)
	ENDIF
	IF (dim1 .EQ. 3) THEN
	   slox_dim1 = mr_lo_s3(mr_xpos)
	   shix_dim1 = mr_hi_s3(mr_xpos)
	   sloy_dim1 = mr_lo_s3(mr_ypos)
	   shiy_dim1 = mr_hi_s3(mr_ypos)
	ENDIF
	IF (dim1 .EQ. 4) THEN
	   slox_dim1 = mr_lo_s4(mr_xpos)
	   shix_dim1 = mr_hi_s4(mr_xpos)
	   sloy_dim1 = mr_lo_s4(mr_ypos)
	   shiy_dim1 = mr_hi_s4(mr_ypos)
	ENDIF
	IF (dim1 .EQ. 5) THEN
	   slox_dim1 = mr_lo_s5(mr_xpos)
	   shix_dim1 = mr_hi_s5(mr_xpos)
	   sloy_dim1 = mr_lo_s5(mr_ypos)
	   shiy_dim1 = mr_hi_s5(mr_ypos)
	ENDIF
	IF (dim1 .EQ. 6) THEN
	   slox_dim1 = mr_lo_s6(mr_xpos)
	   shix_dim1 = mr_hi_s6(mr_xpos)
	   sloy_dim1 = mr_lo_s6(mr_ypos)
	   shiy_dim1 = mr_hi_s6(mr_ypos)
	ENDIF


* The typical xlon, ylat case
	IF (dim2 .EQ. 2) THEN
	   slox_dim2 = mr_lo_s2(mr_xpos)
	   shix_dim2 = mr_hi_s2(mr_xpos)
	   sloy_dim2 = mr_lo_s2(mr_xpos)
	   shiy_dim2 = mr_hi_s2(mr_xpos)
	ENDIF

* Coordinate field 2 represents something else
	IF (dim2 .EQ. 1) THEN
	   slox_dim2 = mr_lo_s1(mr_xpos)
	   shix_dim2 = mr_hi_s1(mr_xpos)
	   sloy_dim2 = mr_lo_s1(mr_xpos)
	   shiy_dim2 = mr_hi_s1(mr_xpos)
	ENDIF
	IF (dim2 .EQ. 3) THEN
	   slox_dim2 = mr_lo_s3(mr_xpos)
	   shix_dim2 = mr_hi_s3(mr_xpos)
	   sloy_dim2 = mr_lo_s3(mr_xpos)
	   shiy_dim2 = mr_hi_s3(mr_xpos)
	ENDIF
	IF (dim2 .EQ. 4) THEN
	   slox_dim2 = mr_lo_s4(mr_xpos)
	   shix_dim2 = mr_hi_s4(mr_xpos)
	   sloy_dim2 = mr_lo_s4(mr_xpos)
	   shiy_dim2 = mr_hi_s4(mr_xpos)
	ENDIF
	IF (dim2 .EQ. 5) THEN
	   slox_dim2 = mr_lo_s5(mr_xpos)
	   shix_dim2 = mr_hi_s5(mr_xpos)
	   sloy_dim2 = mr_lo_s5(mr_xpos)
	   shiy_dim2 = mr_hi_s5(mr_xpos)
	ENDIF
	IF (dim2 .EQ. 6) THEN
	   slox_dim2 = mr_lo_s6(mr_xpos)
	   shix_dim2 = mr_hi_s6(mr_xpos)
	   sloy_dim2 = mr_lo_s6(mr_xpos)
	   shiy_dim2 = mr_hi_s6(mr_xpos)
	ENDIF

	ITSA_MODULO_CURVI_AXIS = ITSA_MODULO_CURVI_AXIS_SUB( xfield, yfield,
     .          slox_dim1, shix_dim1, slox_dim2, shix_dim2, 
     .          sloy_dim1, shiy_dim1, sloy_dim2, shiy_dim2,
     5    idim )

	RETURN
	END
	

	SUBROUTINE NOT_RPN (text,atom_type,atom_id,atom_start,atom_end,
     .			    nexp,exp_start,exp_end,exp_at1,exp_atn,
     .			    status,err_msg)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Scan an expression given in Reverse Polish order for illegal atom types
* and break up the expression if there are commas
* other error checking is done at run time

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200: 11/29/89
* V500: 12/98 *sh* - update this neglected, untested routine to recognize
*	alg_grid_chg_fcn, alg_child_var, and alg_const_var
*        1/99 -- and alg_string
* V554 1/04 *acm* - add counter variables for named REPEAT/RANGE control
* V671 7/11  *acm* Ticket 1868 IFV - masking expressions with ifValid, treating 
*		   zero as valid. 
* V720: 4/17 *acm* add direction-changing functions as a subset of grid-changing ones

        IMPLICIT NONE
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'rpn.parm'
	include 'xalgebra.cmn'

* calling argument declarations:
	INTEGER		atom_type(maxatoms),atom_id(maxatoms),
     .			atom_start(maxatoms),atom_end(maxatoms),
     .			exp_start(max_exp),exp_end(max_exp), nexp,
     .			exp_at1  (max_exp),exp_atn(max_exp),status
	CHARACTER*(*)	text,err_msg

* internal variable declarations:
	INTEGER		atom

* initialize
	atom = 0
	nexp = 1
	exp_start(1) = atom_start(1)
	exp_at1(1)   = 1

 10	atom = atom + 1
	IF ( atom_type(atom) .EQ. alg_finished ) THEN
	   GOTO 500
	ELSEIF ( atom_type(atom) .EQ. alg_log_struct.OR.
     .           atom_type(atom) .EQ. alg_log_vstruct ) THEN
	   GOTO 5100
	ELSEIF ( atom_type(atom) .EQ. alg_punctuation ) THEN
	   IF ( atom_id(atom) .EQ. comma ) THEN
	      GOTO 100
	   ELSE
	      GOTO 5100
	   ENDIF
	ELSEIF ( atom_type(atom) .EQ. alg_constant
     .	   .OR.  atom_type(atom) .EQ. alg_variable
     .	   .OR.  atom_type(atom) .EQ. alg_pseudo_var
     .	   .OR.  atom_type(atom) .EQ. alg_function
     .	   .OR.  atom_type(atom) .EQ. alg_operator
     .	   .OR.  atom_type(atom) .EQ. alg_grid_chg_fcn
     .	   .OR.  atom_type(atom) .EQ. alg_dir_chg_fcn
     .	   .OR.  atom_type(atom) .EQ. alg_child_var
     .	   .OR.  atom_type(atom) .EQ. alg_string
     .	   .OR.  atom_type(atom) .EQ. alg_const_var
     .	   .OR.  atom_type(atom) .EQ. alg_counter_var ) THEN
	   GOTO 10	
	ENDIF
	STOP 'NOT_RPN'

* comma - end of current and beginning of new expression
 100	exp_end(nexp) = atom_end(atom-1)
	exp_atn(nexp) = atom-1
	nexp = nexp + 1
	IF ( nexp .GT. max_exp ) GOTO 5200
	exp_start(nexp) = atom_start(atom+1)	! ... limited error check
	exp_at1  (nexp) = atom+1
	GOTO 10

* done
 500	exp_end(nexp) = atom_end(atom-1)
	exp_atn(nexp) = atom-1

* success
	status = ferr_ok
	RETURN

* error exits
 5000	status = ferr_syntax
	RETURN
 5100	err_msg = 'Illegal Reverse Polish item: '//
     .		   text(atom_start(atom):atom_end(atom))
	GOTO 5000
 5200	err_msg = ' '
	GOTO 5000

	END

      SUBROUTINE SET_WINDOW( status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* create a new output window and de-activate (but don't remove) the last

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* revision 0.0 - 6/28/88
* revision 0.1 - 8/1/88  - set window/size defaults to current window
* revision 0.2 - 8/26/88 - added qualifiers /LOCATION
* revision 0.3 -  9/8/88 - added /ASPECT and /TEXT_PROMINENCE
* revision 0.4 - 9/29/88 - /ASPECT clears screen to avoid future redraws
*			 - separate normalization transform for each window
* V200: 12/15/89 - VAX binding required for Xwindows
*	12/20/89 - allow all windows to have been cancelled, set up bundles
*	 3/22/90 - POP the window to the top with an escape function
*	  4/2/90 - clear screen with CLEAR_WINDOW
* Unix/RISC port - 2/26/91 - commented out unused SYS$LIBRARY include statement
*                - TM_LENSTR1 was declared LOGICAL !
*                - added NEW_GKS_WINDOW for OS independence
*                - fixed /ASPECT default behavior to consistent "edge" (10/91)
* V230: 3/92: Sun port - 
*                - replaced CALL GQDSP with CALL QUERY_DISPLAY_SIZE
*                  and CALL GSWKVP with CALL SET_WINDOW_SIZE for ATC GKS
*      10/92:    - update PPL_viewports_active so metafiles start fresh
*     11/4/92    - change to SET_PLOT_SIZE call for auto viewports
*         note about ABSIZE/BSIZE v.s. HEIGHT/WIDTH:  They differ in value by
*              ASIZE = WIDTH*1000  **and** asize,bsize are updated **after**
*              the next plot is produced whereas width,height are updated
*              immediately when PPL SIZE is given (in SET_PLOT_SIZE)
* V320: 8/94 *kob* IBM port- revealed that "physical" should be defined as
*			     logical but was defined as integer
* V411: 9/6/95 *sh* changes to CLEAR_WINDOW (explicit segment deleting) caused
*	SET WINDOW/CLEAR/SIZE=0.2 to crash Ferret.  Indications are that this
*	is timing-related (plot must be complex, doesn't happen in totalview)
*	Changes here to clear window **before** other actions.
* V420 (IBM/AIX port of V411): 10/5/95 - buffer "READ(var,*"
* 1/97 *kob* - Linux Port - had to move variable assignments off of
*               declaration line.
*	    4/97 *kob* - added ifdef for MANDATORY_FORMAT_WIDTHS on internal
*			 read because linux/nag f90 needed a format width.
* *js* Don't create new window with set win/new if batch graphics active
*      Don't set window to any number but 1 if batch graphics active
* *kob* 1.29.97 changed "can\'t" to cannot for compiler reasons
* V540 *sh* 9/01 - pass axis white space to SET_AX_SIZE (from PLOT_SETUP.cmn)
* V600 *acm* 9/05  add SET WINDOW/TITLE.  If no title has been set, set it to 
*                  the session date:time. Save window_title in xplot_setup.cmn 
*                  for use in subsequent windows. Also define a symbol WIN_TITLE
*  v600 *acm* 5/2006 Flag no_plot_yet: changes so user can change the number of 
*                  line colors.
* V602: *acm* 1/07 Changes for metafile-batch mode
* V68   *acm* 4/11 change how flag meta_batch is computed (different Makefile)
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V6.8 *acm* 7/9/2012 For batch graphics on RHEL6, change ITS_BATCH_GRAPHICS
*                     from logical to integer, then batch = ITS_BATCH_GRAPHICS().NE.0
* V69x *sh* 21/1/15 clarify data type of arguments sent to QUERY_DISPLAY_SIZE

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'
	include 'errmsg.parm'
        include 'ppl_in_ferret.cmn' ! with PPL_viewports_active
	include	'pltcom_dat.decl' 
	include	'PLTCOM.DAT'         	  ! with asize,bsize
        include 'plt_inc.decl'     ! with width/height
        include 'PLT.INC'
	include	'gkscm1_inc.decl'	! with gks common
	include	'GKSCM1.INC'	                ! with gks common
	include 'axis_inc.decl'		! axis lengths
	include 'AXIS.INC'		        ! axis lengths
!	include 'gksdefs.for'		! escape code
        include 'xplot_setup.cmn'       ! for animate boolean
        include 'xtoday.cmn'            ! with today_date and today_time
        
* calling argument declarations:
	INTEGER	status

* internal variable declarations:
	LOGICAL TM_DIGIT, physical_chg, relocate, chg_window,
     .		axis_ref, its_meta, batch, meta_batch
	INTEGER TM_LENSTR1, ITS_BATCH_GRAPHICS, ITS_META_GRAPHICS,
     .          ier, id, itype, imeter, irx, iry, wn, n,
     .          qp, ivp, colon_pos, tlen, i, s1, idone
	REAL*8	dmaxx, dmaxy
#ifdef double_p
	REAL	xln, yln, xmn, xmx, ymn, ymx,
     .		bigness, scale, xstretch, ystretch, aspect,
     .		ref_len
	REAL*4  rzero, rone, fcty, fctx, setpx, setpy,
     .          xwlo, ywlo, xwhi, ywhi
#else
	REAL    fcty, fctx, xln, yln, xmn, xmx, ymn, ymx,
     .          bigness, scale, xstretch, ystretch, aspect,
     .          ref_len, rzero, rone, setpx, setpy,
     .          xwlo, ywlo, xwhi, ywhi
#endif
	
	CHARACTER	UPPER_CASE*1, GKS_X_CONID*16,
     .			arg1*1, buffer*24, xwind_id*80, short_buff*24
* ... for GKS escape call:
	INTEGER esc_data(4), dummy
	DATA esc_data/1,0,0,-9/				!kob 1/97
* local parameter declarations:
	INTEGER		slash_size,
     .			slash_new,
     .			slash_loc,
     .			slash_aspect,
     .			slash_clear,
     .			slash_title
        LOGICAL         physical
	PARAMETER     ( slash_size   = 0+1,
     .			slash_new    = 1+1,
     .			slash_loc    = 2+1,
     .			slash_aspect = 3+1,
     .			slash_clear  = 4+1,
     .			slash_title  = 5+1,
     .                  physical     = .TRUE. )

* statement function - value between 0 and 1
	REAL x
	LOGICAL OUTSIDE_0_1
	OUTSIDE_0_1( x ) = x.LT.0.0 .OR. x.GT.1.0

	rzero = 0.0

* meta_batch flag is true when making metafiles in batch mode.

	its_meta = ITS_META_GRAPHICS().NE.0
	batch = ITS_BATCH_GRAPHICS().NE.0
	meta_batch = .FALSE.
        IF (batch) THEN
           IF (its_meta) meta_batch = .TRUE.
        ENDIF

* /TITLE=text
* This text becomes the name of the workstation. The name gets truncated 
* at the first blank space. Replace any internal spaces with underscore.

	IF ( .NOT.pplus_started ) window_title = ' '

        tlen = 1
	qp = qual_given( slash_title )
	IF (qp .GT. 0 .AND. .NOT. animate) THEN
           CALL EQUAL_STR_LC( cmnd_buff(qual_start(qp):qual_end(qp)),
     .			   window_title, status )
           tlen = TM_LENSTR1(window_title)
           DO 70 i = 1, tlen
             IF (window_title(i:i) .EQ. ' ') window_title(i:i) = '_'
 70        CONTINUE

* By default let the session date and time be incorporated into the name.

        ELSE IF (qp .EQ. 0 .AND. window_title .EQ. ' ') THEN
           s1 = 1
           IF (today_date(1:1) .EQ. ' ') s1 = 2
           tlen = TM_LENSTR1(today_date)
           window_title = today_date(s1:tlen)//':'//today_time

* Or the directory.
!  This works, but with slashes the path name does not get appended. 
!  gks calls shorten FERRET_2_/home/ja8/ansley/FERRET/fer 
!  to just the directory name.  If we do use the directory, change
! the code in open_gks_ws.F to do it the same way.

c           call getenv ('PWD',window_title)
c           tlen = TM_LENSTR1(window_title)
c           DO 75 i=1, tlen
c              IF (window_title(i:i) .EQ. '/') window_title(i:i) = '_'
c 75        CONTINUE

        ENDIF
        tlen = TM_LENSTR1(window_title)
        ier = 0
        CALL SETSYM ("WIN_TITLE "//window_title(:tlen), tlen+10, ier, status)

* main window opened yet ?
	IF ( .NOT.pplus_started ) THEN
	   CALL START_PPLUS
	ENDIF

* are we in a valid GKS window environment ?
	IF ( .NOT. gksopn	) RETURN

* ... Don't create new window if batch graphics active
        if (batch .AND. qual_given(slash_new).gt.0) then
           call warn('Cannot create new windows '//
     $          'when batch mode set')
           qual_given(slash_new) = 0
        endif
* get number
	IF ( num_args .EQ. 0 .AND. qual_given(slash_new) .GT. 0 ) THEN
           
* ... find next free number
* *kob* 1/00 - check to make sure user doesnt open window 9 - reserved
*              for animation purposes
           chg_window = .TRUE.
           DO 50 n = 1, (max_windows-1)
              IF ( .NOT.wn_open( n ) ) GOTO 60
 50        CONTINUE
           CALL ERRMSG(ferr_prog_limit,status,'# windows',*5000)
	ELSEIF ( num_args .GT. 0 ) THEN
* ... use number given
	   buffer = cmnd_buff(arg_start(1):arg_end(1)) 
	   IF ( .NOT.TM_DIGIT( buffer ) ) GOTO 5040
* *kob* 4/97
#ifdef MANDATORY_FORMAT_WIDTHS
	   READ ( buffer, *, ERR=5040 ) n
#else
	   READ ( buffer, '(I)', ERR=5040 ) n
#endif
	   chg_window = n .NE. wsid
	ELSE
	   chg_window = .FALSE.
* ... locate currently active window
	   DO 55 wn = 1, max_windows
	      IF ( wn_active( wn ) ) THEN
	         n = wn
	         GOTO 60
	      ENDIF
 55	   CONTINUE
	   GOTO 5060
	ENDIF	   

* valid number ? 
* *kob* 1/00 - check to make sure user doesnt open window 9 - reserved
*              for animation purposes
 60	IF ( (n.LT.1 .OR. n.GT.(max_windows-1)) .AND. 
     .          .NOT.animate  ) CALL ERRMSG
     .		( ferr_out_of_range, status, 'legal numbers are 1-8', *5000 )
* ... Only one window can be open with batch graphics
        if (batch .and. n.ne.1) then
           call warn('Only one window can be open in batch mode')
           n = 1
        endif

* clear the screen ? (which deletes all segments from window)
* (moved from near end of routine 
	IF ( qual_given( slash_clear ) .GT. 0 .AND. .NOT.animate) THEN
        
           CALL CLEAR_WINDOW( n )
! segments already deleted inside CLEAR_WINDOW 9/95
!	   DO 1010 ivp = mvp_dflt, max_viewport
!	      vp_seg0(ivp) = 0
!	      vp_segn(ivp) = 0
! 1010	   CONTINUE
	   vp_seg0( vp_num ) = curr_seg_name	! no segments left in viewport
	   vp_segn( vp_num ) = curr_seg_name
c           ENDIF

	ENDIF
	   
* /SIZE=q
	qp = qual_given( slash_size )
	physical_chg = ( (qp .GT. 0) .AND. (.NOT.meta_batch) )
* *kob* 1/01 - no changing of size if we are in the middle of animating
	IF ( physical_chg .AND. .NOT.animate ) THEN

	   CALL EQUAL_VAL( cmnd_buff(qual_start(qp):qual_end(qp)),
     .			   scale, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   IF ( scale .LE. 0.0 ) GOTO 5050
	   wn_scale(n) = SQRT( scale )
        ENDIF

* /ASPECT=ratio[:"AXIS" or "EDGE"(default)]
	qp = qual_given( slash_aspect )
* *kob* 1/01 - no changing aspect ratio if we are in the middle of animating
	IF ( qp .GT. 0  .AND. .NOT.animate) THEN
* ... decode the ratio and possible ":SIZE" or ":AXES" qualifier
	   CALL EQUAL_STRING( cmnd_buff(qual_start(qp):qual_end(qp)),
     .			   buffer, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   IF ( buffer .EQ. ' ' ) THEN
	      buffer = 'aspect ratio ?'
	      GOTO 5050
	   ENDIF
	   colon_pos = INDEX( buffer,':' )
	   IF ( colon_pos .GT. 0 ) THEN
	      short_buff = buffer(:colon_pos-1)			! for AIX
	      READ ( short_buff,* ,ERR=5020 ) aspect
	      arg1 = UPPER_CASE( buffer(colon_pos+1:colon_pos+1) )
	      axis_ref = arg1 .EQ. 'A'
	      IF ( .NOT.(axis_ref .OR. arg1 .EQ. 'E') ) GOTO 5040
	   ELSE
	      READ ( buffer, * ,ERR=5020 ) aspect
	      axis_ref = .FALSE.    ! default to "edge"  (10/9/91)
	   ENDIF
	   IF ( aspect.LE.0.0 ) GOTO 5050
* ... set up the plot preserving plot area relative to default 6x8 plot
* ... allowing an additional 2.2 and 2.8 in x and y resp. for labelling
	   ystretch = SQRT( aspect )
	   xstretch = 1.0 / ystretch
	   IF ( axis_ref ) THEN
	      ref_len = SQRT( 8.0 * 6.0 )
	      setpx = xstretch*ref_len + 2.2
	      setpy = ystretch*ref_len + 2.8
	      CALL SET_PLOT_SIZE( setpx, setpy )
	   ELSE
	      ref_len = SQRT( 10.2 * 8.8 )
	      setpx = xstretch*ref_len
	      setpy = ystretch*ref_len
	      CALL SET_PLOT_SIZE( setpx, setpy )
	   ENDIF
* ... clear previous plot and any viewports used within it
	   IF ( .NOT.chg_window ) CALL SET_VIEWPORT( mvp_dflt )
	ENDIF

! note: /TEXT_PROMINENCE will not perform correctly within viewports as it
! reshapes the windows
!* /TEXT_PROMINENCE=factor
!* ... works by blowing up plot size in Denbo inches while holding labels and
!*     label positions relative to plot fixed
!	qp = qual_given( slash_text )
!	IF ( qp .GT. 0 ) THEN
!	   CALL EQUAL_VAL( cmnd_buff(qual_start(qp):qual_end(qp)),
!     .			   text_prom, status )
!	   IF ( status .NE. ferr_ok ) RETURN
!	   IF ( aspect.LE.0.0 ) GOTO 5050
!	   text_prom = SQRT( text_prom )
!	   xstretch = xstretch / text_prom
!	   ystretch = ystretch / text_prom
!	   wn_scale(n) = wn_scale(n) * text_prom
!	ENDIF
!
!* communicate /ASPECT and /TEXT_PROMINENCE to PPLUIS
!	CALL SET_PLOT_SIZE( xstretch, ystretch )

* lower left location specified ?
	qp = qual_given( slash_loc )
	relocate = qp .GT. 0
	IF ( relocate .AND. .NOT.meta_batch) THEN
	   CALL EQUAL_STRING( cmnd_buff(qual_start(qp):qual_end(qp)),
     .			   buffer, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   IF ( .NOT.TM_DIGIT( buffer ) )  GOTO 5030	! need a [0,1] value
	   IF ( INDEX(buffer,',') .EQ. 0 ) GOTO 5030
	   READ ( buffer, *, ERR=5030 ) xmn, ymn	! '*' not removed 10/95
	   IF ( OUTSIDE_0_1(xmn) .OR. OUTSIDE_0_1(ymn) ) GOTO 5030
	   physical_chg = .TRUE.
	ENDIF

* store appropriate segment range with each viewport
	IF ( chg_window ) THEN
* ... change windows --> segments will remain until previous window is cleared
	   vp_num = mvp_dflt
           PPL_viewports_active = .FALSE.    ! communicate to PPLUS (10/92) 
	   DO 80 ivp = mvp_dflt, max_viewport
	      vp_seg0(ivp) = 0
	      vp_segn(ivp) = 0
 80	   CONTINUE
           CALL SET_PLOT_SIZE( width, height )   ! from PPL COMMON PLT.INC
	   rone = 1.0
	   xwlo = xwhitelo 
	   ywlo = ywhitelo
	   xwhi = xwhitehi
	   ywhi = ywhitehi
           CALL SET_AX_SIZES( rone, rone, xwlo, ywlo, xwhi, ywhi )
	ENDIF

* create new window ?
	IF ( .NOT. wn_open(n) ) THEN
	   xwind_id = GKS_X_CONID( n )
	   CALL NEW_GKS_WINDOW( n, xwind_id, window_title(:tlen), status )   ! status always OK
	   physical_chg = .TRUE.
* ... set up GKS bundles for the new "workstation" (window)
	   CALL SETUP_LINE_BUNDLES( n, wstype )
           no_plot_yet = .TRUE.
	ELSE
	   CONTINUE
! ... doesn't work:
! "%GKS-E-ERROR_180, Specified escape function is not supported in routine GESC"
!	   esc_data(4) = %LOC(n)
!	   CALL GKS_ESCAPE( GKS_K_ESC_POP_WORKSTATION, esc_data, 16,
!     .			    dummy, dummy, dummy )
	ENDIF

* deactivate previously active window

        DO 100 wn = 1, max_windows
           IF ( wn_active( wn ) ) THEN
              IF (.NOT.meta_batch) CALL GDAWK( wn )
	      wn_active( wn ) = .FALSE.
	   ENDIF
 100	CONTINUE

* activate window
	IF (.NOT.meta_batch) CALL GACWK(n)

*set up sizing
* (capitalized code from Denbo's SUBROUTINE COLOR )
	IF(ASIZE.GT.BSIZE)THEN
	   FCTY=BSIZE/ASIZE
	   FCTX=1.0
	ELSE
	   FCTX=ASIZE/BSIZE
	   FCTY=1.0
	ENDIF
* ... define normalization transformation n (actually selected down below)
	IF ( chg_window ) THEN
	   CALL GSWN(n, rzero,ASIZE, rzero,BSIZE)
	   CALL GSVP(n, rzero, FCTX, rzero, FCTY )
	ENDIF

	IF ( .NOT.physical_chg ) GOTO 1000
c
c	set up the size of the display window
c
	    CALL GQWKC(n,IER,ID,ITYPE)
	    CALL QUERY_DISPLAY_SIZE(ITYPE,IER,IMETER,
     .                              DMAXX,DMAXY,IRX,IRY)

* special location specified on [0,1] scale ?
	    IF ( relocate ) THEN
	      xlowlef(n) = xmn * dmaxx
	      ylowlef(n) = ymn * dmaxy
	    ENDIF

	    IF(WKSAUT)THEN
		XLN=ASIZE*2.54E-5	! Denbo milli-inches to meters
		YLN=BSIZE*2.54E-5

* re-scale as requested
	        xln = wn_scale(n) * xln
	        yln = wn_scale(n) * yln

* ... too big to fit ?
*	        bigness = MIN( dmaxx/xln, dmaxy/yln )
*	        IF ( bigness .LT. 1.0 ) THEN
*	           xln = xln * bigness
*	           yln = yln * bigness
*	        ENDIF

* ... put lower left of each window at a different place if possible
	        wkxmn = MIN( xlowlef(n), dmaxx-xln )
	        wkymn = MIN( ylowlef(n), dmaxy-yln )
	        	        
		WKXMX=WKXMN+XLN
		WKYMX=WKYMN+YLN
C
C	SET THE NDC WINDOW
C
		CALL GSWKWN(n, rzero,FCTX, rzero,FCTY)
C
C	SET DEVICE (WORKSTATION) VIEWPORT
C
		CALL SET_WINDOW_SIZE(n,WKXMN,WKXMX,WKYMN,WKYMX)
	    ELSE
C
C	IF NOT AUTO WKXMN AND WKXMX ETC ARE FRACTIONS OF DMAXX
C	AND DMAXY
C
		CALL GSWKWN(n, rzero,FCTX, rzero,FCTY)
		XMN=DMAXX*WKXMN
		XMX=DMAXX*WKXMX
		YMN=DMAXY*WKYMN
		YMX=DMAXY*WKYMX
		CALL SET_WINDOW_SIZE(n,XMN,XMX,YMN,YMX)
	    ENDIF

* force immediate creation of the window on the screen
	CALL GUWK( n, 1 )

* turn on normalization transform (same as window number and wsid)
 1000	CALL GSELNT(n)

* successful completion
	wsid = n
	wn_open  ( wsid ) = .TRUE.
	wn_active( wsid ) = .TRUE.
	status = ferr_ok
	RETURN

* error exit(s)
 5000	RETURN
! 5010	CALL ERRMSG( ferr_erreq, status, buffer, *5000 )
 5020	CALL ERRMSG( ferr_syntax,status, buffer, *5000 )
 5030	CALL ERRMSG( ferr_out_of_range,status,
     .		'need x and y location between 0 and 1:"'
     .		//buffer(:TM_LENSTR1(buffer))//'"',*5000)
 5040	CALL ERRMSG( ferr_unknown_arg, status, buffer, *5000 )
 5050	CALL ERRMSG( ferr_out_of_range, status, buffer,*5000)
 5060	CALL ERRMSG( ferr_invalid_command,status,
     .          'no open window',*5000 )
	END

        SUBROUTINE SYMBEL(X,Y,DEGRES,HEIGHT,NCHAR,STRING)
C** 
C A simple forward to SYMBEL_HERSHEY.
C This was done to match PyFerret where the original 
C subroutine here was renamed SYMBEL_HERSHEY.
C**
C V7.22 *acm* 10/17 Fix ticket 2566: if zero or negative character size, exit.

C
C       CALL SYMBEL(X,Y,DEGRES,HEIGHT,NCHAR,STRING)
C
C       THIS SUBROUTINE DRAWS A STRING OF CHARACTERS.
C
C       THE VARIOUS PARAMETERS AND THEIR DEFINITIONS ARE LISTED
C       BELOW:
C        X,Y    - COORDINATES OF THE LOWER LEFT-HAND CORNER OF
C                 THE FIRST CHARACTER IN USERS UNITS.
C        DEGRES - ANGLE AT WHICH THE CHARACTERS ARE TO BE DRAWN
C                 IN DEGREES RELATIVE TO THE X-AXIS.
C        HEIGHT - HEIGHT OF THE CHARACTERS IN INCHES (OR MM).
C        NCHAR  - NUMBER OF CHARACTERS TO BE DRAWN.
C        STRING - ARRAY CONTAINING THE DISPLAY CODES OF THE
C                 CHARACTERS TO BE DRAWN.
C
        IF (height .LE. 0. ) RETURN
	CALL SYMBEL_HERSHEY(X,Y,DEGRES,HEIGHT,NCHAR,STRING)
        RETURN
        END

*
* nco.F
*
* Ansley Manke
* March 1, 2005
*
* This function spawns any NCO call, with the first argument being the
* NCO function name, and the second one long string which is the argument 
* to nco including file names and actions.
*
* 
      SUBROUTINE nco_init(id)

* Define arguments and result

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

      CALL ef_set_desc(id, 'Call an NCO utility' )

      CALL ef_set_num_args(id, 2)
      CALL ef_set_axis_inheritance(id, ABSTRACT, NORMAL, NORMAL, 
     .                             NORMAL)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'operator')
      CALL ef_set_arg_desc(id, arg, 'name of operator')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
      CALL ef_set_arg_type(id, arg, STRING_ARG)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'arguments')
      CALL ef_set_arg_desc(id, arg, 'one string with all arguments')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
      CALL ef_set_arg_type(id, arg, STRING_ARG)

      RETURN 
      END

* Define abstract output axis: 1 value

      SUBROUTINE nco_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id
      INTEGER ivalue

      ivalue = 1
      CALL ef_set_axis_limits(id, X_AXIS, ivalue, ivalue)

      RETURN 
      END

*
* Compute the result
*
      SUBROUTINE nco_compute(id, arg_1, arg_2, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, 
     .           mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)
 
      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)

      INTEGER STRINGLEN, arg, blen, slen

      CHARACTER*2048 argstring, buff

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      blen = 0

      arg = 1
      CALL ef_get_arg_string(id, arg, argstring)

      slen = STRINGLEN(argstring)
      buff = argstring(1:slen)//' -O -h '
      blen = slen + 7

      arg = 2
      CALL ef_get_arg_string(id, arg, argstring)

      slen = STRINGLEN(argstring)
      buff = buff(1:blen)//argstring(1:slen)
      blen = blen + slen 

* Spawn the command 

      result(res_lo_ss(X_AXIS), res_lo_ss(Y_AXIS), res_lo_ss(Z_AXIS), 
     .         res_lo_ss(T_AXIS)) = bad_flag_result

      CALL system( buff(1:blen) )

      result(res_lo_ss(X_AXIS), res_lo_ss(Y_AXIS), res_lo_ss(Z_AXIS), 
     .         res_lo_ss(T_AXIS)) = 1

      RETURN 


      END

        INTEGER FUNCTION STRINGLEN (strin)

* determine the length of a character string as the position of the last 
* non-blank character 

* from tm_lenstr (use tm_lenstr if this is ever converted to an
* internally-linked function)

* calling argument declarations:
	CHARACTER*(*) strin

* internal variable declarations:
	INTEGER	mright, i

* initialize: find highest possible right hand limit of string
	mright = LEN(strin)

        DO 100 i = mright,1,-1	
           IF (strin(i:i) .NE. ' ') GOTO 200	 
  100   CONTINUE

* for all blanks
        STRINGLEN = 0

* Found non-blank
  200   STRINGLEN = i

	RETURN
	END

	SUBROUTINE CDF_SET_OUT_TYPE (dset, varid, itsa_uvar, 
     .                itsa_string, out_type, outtype, status)


        include 'netcdf.inc'
        include 'tmap_dims.parm'
        include 'ferret.parm'
	include 'xprog_state.cmn'
	include 'errmsg.parm'

	LOGICAL itsa_uvar, itsa_string
	INTEGER dset, varid, outtype, status
	CHARACTER*(*) out_type

	INTEGER TM_LENSTR1, vartype, slen, alen, attid
	CHARACTER attname*128, dum*10
	
* For error messages
      CHARACTER*9 typnam(6)
      DATA typnam/'NC_BYTE', 'NC_CHAR', 'NC_SHORT', 'NC_INT', 
     .            'NC_FLOAT', 'NC_DOUBLE'/

* Set the type for writing data to netCDF. 
* Apply a command-line output type if given, e.g. SAVE/OUTTYPE=INT
* Otherwise use an OUTTYPE atribute if it's been set, or use the data type
* from the source dataset.
* v7.6 *acm* 5/20 Issue 1876: can read string-typed data, write as char.
*                 Write a note but only if they've asked for /OUTTYPE=STR

* dset         source dataset
* varid        variable id if source is a netCDF file 
* itsa_uvar
* itsa_string  for expressions can't determine this from the dataset
* out_type     string from SAVE/OUTTYPE=
* outtype      return this netcdf type code
*
* To simply reset an output type according to the setting in OUT_TYPE, send in
* the variable type in "outtype" and set varid = -1 (needed in cdf_list_dsg)

* initialize
	status = ferr_ok

	IF (varid .GT. 0) THEN
	   CALL CD_GET_VAR_TYPE (dset, varid, dum, vartype, status)

	   IF (itsa_uvar) THEN  ! for user vars type not known in attrib structure
	      vartype = nf_double  
	      IF (itsa_string) vartype = nf_char
	   ENDIF
	   outtype = vartype

* If there is an OUTTYPE attribute, that came from a SET VAR/OUTTYPE.
* It will be superceded by a SET LIST/OUTTYPE or a SAVE/OUTTYPE setting,
* applied just below.

	   CALL CD_GET_VAR_OUTTYPE (dset, varid, outtype, status)

* If its just an expression it doesnt have a varid in the attribute structure
* for user-vars. Still set the output type.

	ELSE IF (varid .EQ. 0) THEN
	   vartype = 6  ! netcdf nf_double
	   IF (itsa_string) vartype = 2
	ELSE

* if not from a varid, just converting a type using the specified out_type
	   vartype = outtype  
	ENDIF

	IF (outtype .EQ. 0) outtype = vartype

* Setting made with SAVE/OUTTYPE or SET LIST/OUTTYPE
* SAVE/OUTTYPE takes precedence over a SET LIST/OUTTYPE
* out_type comes in from a SAVE/OUTTYPE  Use it if its not DFLT
* list_outtype is from SET LIST/OUTTYPE  IF out_type is DFLT, use list_outtype

	IF ( out_type(1:3) .EQ. 'DFL') out_type = list_outtype

	IF (out_type(1:3) .EQ. 'DOU') outtype = nf_double
	IF (out_type(1:3) .EQ. 'FLO') outtype = nf_float
	IF (out_type(1:3) .EQ. 'INT') outtype = nf_int
	IF (out_type(1:3) .EQ. 'SHO') outtype = nf_short
	IF (out_type(1:3) .EQ. 'BYT') outtype = nf_byte
	IF (out_type(1:3) .EQ. 'STR') THEN
	   outtype = nf_char
	   CALL WARN ('Writing with type STRING not implemented. Using type CHAR.')
	ENDIF
	IF (outtype .EQ. nf_string) outtype = nf_char

	IF (dset .GT. pdset_irrelevant .AND.
     .      outtype.NE.nf_char .AND. outtype.NE.nf_string .AND.
     .      outtype.GT.nf_double) outtype = nf_double

* When the user requests higher precision output from a lower precision file 
* variable, e.g. converting FLOAT to DOUBLE, write an attribute explaining 
* that it contains data converted in this way.

	IF (dset .GT. pdset_irrelevant .AND. outtype.GT.vartype .AND.
     .      outtype.NE.nf_char .AND. outtype.NE.nf_string) THEN

           attname = 'Ferret_Precision_Note'
           CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)
           IF (status.EQ.ferr_ok) 
     .             CALL CD_DELETE_ATTRIBUTE(dset, varid, attname, status)
           slen = TM_LENSTR1(typnam(vartype))
           alen = TM_LENSTR1(typnam(outtype))
           CALL CD_PUT_NEW_ATTR (dset, varid, 
     .              attname, 2, 61, 1, 
     .         'This variable written using Ferret was converted from '//
     .              typnam(vartype)(4:slen)//' to '//
     .              typnam(outtype)(4:alen), 1., status )

	ENDIF

	RETURN
	END

	CHARACTER*14 FUNCTION BC2WHOI( num_minutes )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* convert minutes since 01-JAN-0000 00:00:00 to a WHOI-formatted of the form
* yymmddhhmm

* Written 9/20/88 By Steve Hankin for PMEL/TMAP

* version 0.0 - based on TM_SECS_TO_DATE by Mark Verschell
* version 0.1 - calls TMAP library routines TM_SECS_TO_DATE and TM_BREAK_DATE
* version 0.2 - 1/19/89: remove century from year for WHOI format
* Mod J Davison 11.22.95 Return century, add seconds, for 4 digit year 
* Mod J Davison 10.15.99 Add multi calendar support. Call new routine.
* 
*  *acm* 12/00 Change calendars to match NetCDF standard

      INCLUDE 'calendar.decl'
      INCLUDE 'calendar.cmn'

* Argument definition
	INTEGER		year, month, day, hour, minute, second, status
	INTEGER		century
	REAL*8		num_minutes

* Local Definition
	CHARACTER*20	TM_SECS_TO_DATE, date

******************************************************************************

* convert to date string of the form dd-mmm-yyyy:hh:mm:ss
	date = TM_SECS_TO_DATE (num_minutes * 60.D0, calendar_id )

* break into individual integer date values
	CALL TM_BREAK_DATE ( date, calendar_id, year, month, day, 
     .                       hour, minute, second, status)

* kludge for WHOI format limitation - year doesn't contain century

	century = year/100
	year = MOD(year,100)

* Put results into WHOI string
	WRITE (BC2WHOI,3000) year, month, day, hour, minute,
     .	second, century
3000	FORMAT(7I2.2)

	RETURN
	END

      FUNCTION NUMDM1(IT) 
C** 
C**    @(#)numdm1.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* 	Mod J Davison 11.22.95 for 4 digit years
* 	Mod J Davison  2.6.96  fix bug re 400 year biz
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 

*       J Davison 10.20.99   Modified to support multiple calendars.
*  *acm* 12/00 Change calendars to match NetCDF standard 
*  V5.70 *acm* 5/2004 Include the century in year iy, to get correct
*              evaluation of whether it is a leap year! (Bug 882)
* V68  *acm* 6/12  changes for double-precision ferret, single-precision pplus

      INCLUDE 'calendar.decl'
      INCLUDE 'calendar.cmn'

C     THIS FUNCTION RETURNS NO. OF DAYS IN CURRENT MONTH

#ifdef double_p
	real*8 yeardays
#else
	real yeardays
#endif
      CHARACTER*(*) it

      call time3(it,iy,im,idd,ih,ix,isec,icen) 
      iy = icen* 100 + iy

      CALL tm_get_calendar_attributes (calendar_id, num_months, 
     .                 num_days, yeardays, month_names, days_in_month, 
     .                 days_before_month, month_by_day)

******************************************************************************
* HANDLE GREGORIAN CALENDAR FIRST
******************************************************************************
       if (calendar_id .eq. gregorian) then
         numdm1 = days_in_month(im) 

         if(im.eq.2.and.iy.eq.4*(iy/4)
     .        .and.mod(iy,100).ne.0)  numdm1=29	! centuries are not leap yrs

         if(im.eq.2.and.iy.eq.400*(iy/400)) 
     .        numdm1=29         ! every 400 years is tho...
      
******************************************************************************
* HANDLE JULIAN CALENDAR 
******************************************************************************
       else if (calendar_id .eq. julian) then
         numdm1 = days_in_month(im) 

         if(im.eq.2.and.iy.eq.4*(iy/4))  numdm1=29
      
******************************************************************************
* ALL OTHER SUPPORTED AND REGULAR CALENDARS
******************************************************************************
       else if (calendar_id .gt. gregorian .and. 
     .		calendar_id .le. max_calendars) then

         numdm1 = days_in_month(im) 
      else
         stop 'Illegal calendar in numdm1()'
      end if

      return 
      end 

	SUBROUTINE PRMTIV(X,NXS)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)prmtiv.F	1.1    3/10/88

* modified 6/99 *sh*
*	added mouse input (CALL IGRNPT) to %LABEL
*	added %WHERE mouse input command
* v552 3/03 *acm* changes for multi-line labels with %label, %xaxis, %yaxis
*                   and remove VMS include statements.
* v554 3/04 *acm* 5th arg of %xaxis, %yaxis should set the # of tics
* v554 3/04 *acm* Need to send parameters used for making graticule lines
*                 to xaxis, yaxis, initialized to values for graticule off.
* v580 10/05 *acm* Fix for bug1003; pen may be changed by @Cnnn as well
*                  as @Pn. In saving info about color/font changes from
*                  one line to the next in multi-line lables, allow for
*                  @Cnnn syntax.  (changes also in getlabfonts)
* v580 11/05 *acm* Send new arg to xaxis1,yaxis1 DMS (arg is 0 here)
C        1/06  xvaloff,yvaloff add this amount to each x or y axis label. 
C              (axis data was read as double precision and converted to single 
C              after applying an offset.)
* V683 12/12 *acm* Fix for applying a font setting in multiple line labels
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long
* V69+  5/14 *acm* Fix for ascii font in multi-line labels, ticket 2176
* v695 9/15 *acm* write values to PPL* symbols using 6 digits not 4
* V7    *acm* 6/16 Ticket 2434: command qualifiers /DEGMINSEC= /HALFSPAC
*                  DEGMINSEC=1 for Deg-Min axis labels, =2 for Deg-Min-Sec. Default = 1
*                  /HALFSPAC adds a half space between the degree sign and E/W or N/S

C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C	This subroutine does plot primitives.  They
C	should be used with care since interactions are
C	a very strong possibility.
C
C	These routines do not work with multplt!!!!
C
c
c	%OPNPLT
c		/overlay	do not erase last plot
c
c	%CLSPLT
c		/wait		immediatly return to get next command
c
c	%RANGE
c		min		minimum value of data to be ranged
c		max		maximum value of data
c		ntic		number of large increments
c	ppl$range_low		new minimum range value
c	ppl$range_high		new maximum range value
c	ppl$range_inc		new increment
c
c	%PLTLIN
c		n		plot line n using current scales
c
c	%LABEL
c		/user		x and y in user or inches
c		x		x position user or inches
c		y		y position user or inches
c		ipos		-1 left, 0 center, +1 right justify
c		ang		angle to draw label degrees
c		chsize		character size inches
c		label		string to draw
c
c	%XAXIS
c		/user		y in user or inches
c		xlow		min value of x user
c		xhigh		max value of x user
c		xtic		large tic increment user
c		y		y position user or inches
c		nmstc		number of small tics
c		lint		label interval (large tics)
c		xunit		divisor for axis label
c		ipos		-1 bottom, 0 none, +1 top of label
c		csize		character size inches
c		frmt		axis format char*20
c
c	%YAXIS
c		/user		x in user or inches
c		ylow		min value of y user
c		yhigh		max value of y user
c		ytic		large tic increment user
c		x		x position user or inches
c		nmstc		number of small tics
c		lint		label interval (large tics)
c		yunit		divisor for axis label
c		ipos		-1 left, 0 none, +1 right of label
c		csize		character size inches
c		frmt		axis format char*20
c
c	%WHERE
c		N/A

	DIMENSION X(NXS)
C
	INCLUDE 'PARAMPL5.DAT'
	INCLUDE 'LINES.INC'
	INCLUDE 'PEN.INC'
	INCLUDE 'PLT.INC'
	INCLUDE 'PLTL.INC'
	INCLUDE 'HAB.INC'
	INCLUDE 'LABCOM.INC'
	INCLUDE 'HD.INC'
	INCLUDE 'MISS.INC'
	INCLUDE 'TAXIS.INC'
	include 'axis_inc.decl'
	INCLUDE 'AXIS.INC'
	INCLUDE 'AXISL.INC'
	INCLUDE 'CMRD.INC'
	INCLUDE 'CMRDL.INC'
	INCLUDE 'PRMCOM.INC'
	INCLUDE 'TICS.INC'
	INCLUDE 'AXLWID.INC'
	INCLUDE 'LABELS.INC'
	INCLUDE 'SWITCH.INC'
	INCLUDE 'SYSTEM.INC'
	INCLUDE 'gkscm1_inc.decl'  ! with wsid for igrnpt
	INCLUDE 'GKSCM1.INC'


C
C
	CHARACTER FRMTX*20,SYM*120
	LOGICAL SVQIET,SVLOG,CLEAR

	LOGICAL mouse_input, need_justify, need_arrow
	INTEGER	IGRNPT, idummy, ichoice, iat
	REAL xp, yp, across
        INTEGER numlines, i, j, dms
        LOGICAL lineflag

	EXTERNAL range, scale, size

c        line_spacing = 1.4

C***	OPNPLT
C
	IF(ICOM.EQ.'%OPNPLT')THEN
	    SVQIET=QUIETF
	    SVLOG=LOGCMF
	    QUIETF=.TRUE.
	    LOGCMF=.FALSE.
	    CLEAR = .NOT.SOVER
	    PLTOPN=.TRUE.
	    IF(.NOT.SOVER)CALL SIZE(WIDTH,HEIGHT)
	    CALL OPNDEV(TERMF,CLEAR)
	    CALL COLOR(IPEN(0))
C
C***	CLSPLT
C
	ELSE IF(ICOM.EQ.'%CLSPLT')THEN
	    QUIETF=SVQIET
	    LOGCMF=SVLOG
	    PLTOPN=.FALSE.
	    IF(SWAIT)THEN
		CALL HABIS(IPLOT,IPAUSE,IHDCPY,INC)
	    ELSE
		CALL HABIS(IPLOT,0,IHDCPY,INC)
	    ENDIF
C
C***	RANGE
C
	ELSE IF(ICOM.EQ.'%RANGE')THEN
	    RMIN=P(1)
	    RMAX=P(2)
	    NTIC=P(3)
	    if(rmin.eq.rmax)then
		rlow=rmin
		rhigh=rmax
	    else
	        CALL RANGE(RMIN,RMAX,NTIC,RLOW,RHIGH,RINC)
	    endif
	    SYM='*PPL$RANGE_LOW'
	    CALL PUTVAL(SYM,RLOW,7,IER)
C
	    SYM='*PPL$RANGE_HIGH'
	    CALL PUTVAL(SYM,RHIGH,7,IER)
C
	    SYM='*PPL$RANGE_INC'
	    CALL PUTVAL(SYM,RINC,7,IER)
C
C***	XAXIS
C
	ELSE IF(ICOM.EQ.'%XAXIS')THEN

            dms = 0
            DO 100 ii = 1, 4
              hgrat(ii,1) = 0.
              hgrat(ii,2) = 0.
              vgrat(ii,1) = 0.
              vgrat(ii,2) = 0.
100         CONTINUE

            hcolor(1) = 1 
            hcolor(2) = 1
            vcolor(1) = 1
            vcolor(2) = 1
            across = 0.
            lineflag = .FALSE.

	    CALL INQSCL(XFF,YFF,XOR,YOR,XLOW,YLOW)
	    IF(M.GE.1.AND.IFLG(1).NE.0)THEN
		XLOW=P(1)
	    ELSE
		XLOW=XLO
	    ENDIF
	    IF(M.GE.2.AND.IFLG(2).NE.0)THEN
		XHIGH=P(2)
	    ELSE
		XHIGH=XHI
	    ENDIF
	    IF(M.GE.3.AND.IFLG(3).NE.0)THEN
		XTICC=P(3)
	    ELSE
		XTICC=XTIC
	    ENDIF
	    IF(M.GE.4.AND.IFLG(4).NE.0)THEN
		IF(SUSER)THEN
		    Y=P(4)
		ELSE
		    Y=YLOW+P(4)/YFF
		ENDIF
	    ELSE
		Y=YLOW
	    ENDIF
	    IF(M.GE.5.AND.IFLG(5).NE.0)THEN
		NSMTCS=P(5)
	    ELSE
		NSMTCS=NMTCX
	    ENDIF
	    IF(M.GE.6.AND.IFLG(6).NE.0)THEN
		LINTT=P(6)
	    ELSE
		LINTT=LINTX
	    ENDIF
	    IF(M.GE.7.AND.IFLG(7).NE.0)THEN
		XUNIT=P(7)
	    ELSE
		XUNIT=1.
	    ENDIF
	    IF(M.GE.8.AND.IFLG(8).NE.0)THEN
		IPOS=P(8)
	    ELSE
		IPOS=LABELX
	    ENDIF
	    IX=IPOS
	    IF(M.GE.9.AND.IFLG(9).NE.0)THEN
		CHSIZE=P(9)
	    ELSE
		CHSIZE=XCSIZE
	    ENDIF
	    IF(N.GT.0)THEN
		FRMTX=LABEL(1:N)
	    ELSE IF(IFRX.NE.' ')THEN
		FRMTX=IFRX
	    ELSE
		CALL FRMT(XLOW,XHIGH,NSIGX,FRMTX)
	    ENDIF
	    XFF=XLEN/(XHIGH-XLOW)
	    CALL SCALE(XFF,YFF,XOR,YOR,XLOW,YLOW)
	    call color(ipen(0))
	    CALL XAXIS1(XLOW,XHIGH,XTICC,NSMTCS,LINTT,XUNIT,
     *		IPOS,FRMTX,XFF,Y,YFF,CHSIZE,across,xdms,xdspac,vgrat,
     *		vcolor,vline,xvaloff,ipen(0))

            CALL tm_break_lines (xlab, lnbeg, lnend, numlines)
            nfont = 0
            npen = 0
            fontprefix = ""
            penprefix = ""
            DO 20 j = 1, numlines
               CALL getlabfonts (xlab, lnbeg, lnend, j, fontprefix, 
     .           npnew, nfnew, newfont, newpen, nchr)

	       IF(IPOS.LT.0)THEN
		  YL=Y-(XWID+2.0*HXLAB)/YFF
	       ELSE
	 	  YL=Y+(XWID+HXLAB)/YFF
	       ENDIF
               YL = YL - line_spacing*(j-1)*HYLAB/yff
	       XL=XLOW+(XLEN-SYMWID(HXLAB, NCHR+npen+nfont,
     .                  penprefix(1:npen)//fontprefix(1:nfont)//
     .                  xlab(lnbeg(j):lnend(j) )) )*.5/XFF

               CALL SYMBEL(XL,YL,0.,HXLAB,NCHR+npen+nfont,
     .                  penprefix(1:npen)//fontprefix(1:nfont)//
     .                  xlab(lnbeg(j):lnend(j)))

C  Set up to use any font settings from this line on subsequent lines.

               IF (npnew.GT.0) THEN
                  penprefix(1:npnew) = newpen(1:npnew)
                  npen = npnew
               ENDIF
               IF (nfnew.GT.0) THEN
                  fontprefix(1:nfnew) = newfont(1:nfnew)
                  nfont = nfnew
               ENDIF

  20        CONTINUE

C
C***	YAXIS
C
	ELSE IF(ICOM.EQ.'%YAXIS')THEN
        
            dms = 0
            DO 200 ii = 1, 4
              hgrat(ii,1) = 0.
              hgrat(ii,2) = 0.
              vgrat(ii,1) = 0.
              vgrat(ii,2) = 0.
200         CONTINUE

            hcolor(1) = 1 
            hcolor(2) = 1
            vcolor(1) = 1
            vcolor(2) = 1
            across = 0.
            lineflag = .FALSE.

	    CALL INQSCL(XFF,YFF,XOR,YOR,XLOW,YLOW)
	    IF(M.GE.1.AND.IFLG(1).NE.0)THEN
		YLOW=P(1)
	    ELSE
		YLOW=YLO
	    ENDIF
	    IF(M.GE.2.AND.IFLG(2).NE.0)THEN
		YHIGH=P(2)
	    ELSE
		YHIGH=YHI
	    ENDIF
	    IF(M.GE.3.AND.IFLG(3).NE.0)THEN
		YTICC=P(3)
	    ELSE
		YTICC=YTIC
	    ENDIF
	    IF(M.GE.4.AND.IFLG(4).NE.0)THEN
		IF(SUSER)THEN
		    XX=P(4)
		ELSE
		    XX=XLOW+P(4)/XFF
		ENDIF
	    ELSE
		XX=XLOW
	    ENDIF
	    IF(M.GE.5.AND.IFLG(5).NE.0)THEN
		NSMTCS=P(5)
	    ELSE
		NSMTCS=NMTCY
	    ENDIF
	    IF(M.GE.6.AND.IFLG(6).NE.0)THEN
		LINTT=P(6)
	    ELSE
		LINTT=LINTY
	    ENDIF
	    IF(M.GE.7.AND.IFLG(7).NE.0)THEN
		YUNIT=P(7)
	    ELSE
		YUNIT=1.
	    ENDIF
	    IF(M.GE.8.AND.IFLG(8).NE.0)THEN
		IPOS=P(8)
	    ELSE
		IPOS=LABELY
	    ENDIF
	    IY=IPOS
	    IF(M.GE.9.AND.IFLG(9).NE.0)THEN
		CHSIZE=P(9)
	    ELSE
		CHSIZE=YCSIZE
	    ENDIF

c	    IF(N.GT.0)THEN
c		FRMTX=LABEL(1:N)
c	    ELSE IF(IFRX.NE.' ')THEN  <-- bug here: check IFRY instead.
c		FRMTX=IFRY
c	    ELSE
c		CALL FRMT(YLOW,YHIGH,NSIGY,FRMTX)
c	    ENDIF


	    IF(N.GT.0)THEN
		FRMTX=LABEL(1:N)
	    ELSE IF(IFRY.NE.' ')THEN
		FRMTX=IFRY
	    ELSE
		CALL FRMT(YLOW,YHIGH,NSIGY,FRMTX)
	    ENDIF

	    YFF=YLEN/(YHIGH-YLOW)
	    CALL SCALE(XFF,YFF,XOR,YOR,XLOW,YLOW)
	    call color(ipen(0))
	    CALL YAXIS1(XX,XFF,YLOW,YHIGH,YTICC,NSMTCS,LINTT,YUNIT,
     *		IPOS,FRMTX,YFF,CHSIZE,across,ydms,ydspac,hgrat,hcolor,hline,
     *          yvaloff,.FALSE.,SHRINKY,ipen(0))

            CALL tm_break_lines (ylab, lnbeg, lnend, numlines)
            nfont = 0
            npen = 0
            fontprefix = ""
            penprefix = ""
            DO 30 j = 1, numlines
               CALL getlabfonts (ylab, lnbeg, lnend, j, fontprefix, 
     .           npnew, nfnew, newfont, newpen, nchr)

	       IF(IPOS.LT.0)THEN
	           XL=XX-(YWID+HYLAB)/XFF
	       ELSE
	           XL=XX+(YWID+2.0*HYLAB)/XFF
	       ENDIF 
               XL = XL + line_spacing*(j-1)*hylab/xff
	       YL=YLOW+(YLEN-SYMWID(HYLAB,NCHR+npen+nfont,
     .                  penprefix(1:npen)//fontprefix(1:nfont)//
     .                  ylab(lnbeg(j):lnend(j) )) )*.5/XFF

               CALL SYMBEL(XL,YL,90.,HYLAB,NCHR+npen+nfont,
     .                  penprefix(1:npen)//fontprefix(1:nfont)//
     .                  ylab(lnbeg(j):lnend(j)))

C  Set up to use any font settings from this line on subsequent lines.

               IF (npnew.GT.0) THEN
                  penprefix(1:npnew) = newpen(1:npnew)
                  npen = npnew
               ENDIF
               IF (nfnew.GT.0) THEN
                  fontprefix(1:nfnew) = newfont(1:nfnew)
                  nfont = nfnew
               ENDIF

  30        CONTINUE

C
C***	PLTLIN
C
	ELSE IF(ICOM.EQ.'%PLTLIN')THEN
	    IF(M.GE.1.AND.IFLG(1).NE.0)THEN
		I=P(1)
	    ELSE
		I=1
	    ENDIF
	    IF(IWIND.GT.0)THEN
	    	CALL INQSCL(XFF,YFF,XOR,YOR,XLOW,YLOW)
		XHIGH=XLOW+XLEN/XFF
		YHIGH=YLOW+YLEN/YFF
		CALL WINDOW(XLOW,YLOW,XHIGH,YHIGH)
	    ENDIF
	IBASE=0
	IY=NXS/2
C
	DO 50 J=1,I-1
50	IBASE=IBASE+LLENG(J)
C
	  CALL MARKH(HMARK(I))
	  CALL COLOR(IPEN(I))
C
C     SET PLOT MODE
	    IF(ITYPE(I).GE.4)THEN
	      CALL DASHSZ(DN1(I),UP1(I),DN2(I),UP2(I))
	      CALL DASHES
	    ELSE
	      CALL VECTRS
	    END IF
	    IF(ITYPE(I).EQ.3)CALL POINTS
	    IF(.NOT.(XLE.OR.XEQ.OR.XGE.OR.YLE.OR.YEQ.OR.YGE))THEN
C     DO NOT CHECK POINTS FOR MISSING DATA
	      CALL TRANS(I,X(IBASE+1),X(IY+IBASE+1),XT,YT)
	      CALL PLOT(XT,YT,0,0)
	      IF(ITYPE(I).NE.0.AND.ITYPE(I).NE.4)CALL MARK(IMARK(I))
	      IM=0
	      IF(ITYPE(I).EQ.1.OR.ITYPE(I).EQ.3)IM=IMARK(I)
	      DO 60 J=IBASE+1,IBASE+LLENG(I)
	        CALL TRANS(I,X(J),X(IY+J),XT,YT)
	        CALL PLOT(XT,YT,1,0)
60            CALL MARK(IM)
	    ELSE
C     CHECK POINTS FOR OUT OF RANGE   (CM)
	      DO 70 J=IBASE+1,IBASE+LLENG(I)
		IF(XLE.AND.X(J).LE.CMXLE)GOTO 70
		IF(XEQ.AND.X(J).EQ.CMXEQ)GOTO 70
		IF(XGE.AND.X(J).GE.CMXGE)GOTO 70
		IF(YLE.AND.X(IY+J).LE.CMYLE)GOTO 70
		IF(YEQ.AND.X(IY+J).EQ.CMYEQ)GOTO 70
		IF(YGE.AND.X(IY+J).GE.CMYGE)GOTO 70
	        CALL TRANS(I,X(J),X(IY+J),XT,YT)
	        CALL PLOT(XT,YT,0,0)
	        IF(ITYPE(I).NE.0.AND.ITYPE(I).NE.4)CALL MARK(IMARK(I))
 	        IM=0
	        IF(ITYPE(I).EQ.1.OR.ITYPE(I).EQ.3)IM=IMARK(I)
	        GOTO 71
70	      CONTINUE
71	      IF=1
	      DO 72 K=J+1,IBASE+LLENG(I)
		IF((XLE.AND.X(K).LE.CMXLE).OR.
     *		   (XEQ.AND.X(K).EQ.CMXEQ).OR.
     *		   (XGE.AND.X(K).GE.CMXGE).OR.
     *		 (YLE.AND.X(IY+K).LE.CMYLE).OR.
     *		 (YEQ.AND.X(IY+K).EQ.CMYEQ).OR.
     *		 (YGE.AND.X(IY+K).GE.CMYGE))THEN
	          IF=0
	        ELSE
	          CALL TRANS(I,X(K),X(IY+K),XT,YT)
	          CALL PLOT(XT,YT,IF,0)
	          CALL MARK(IM)
	          IF(IF.EQ.0)THEN
	            IF=1
	          END IF
	        END IF
72	      CONTINUE
	    END IF
	    IF(ITYPE(I).EQ.2.OR.ITYPE(I).EQ.5)CALL MARK(IMARK(I))
 	CALL COLOR(IPEN(0))
	CALL WINDOW(0.,0.,0.,0.)
C
C***	%LABEL
C
	ELSE IF(ICOM.EQ.'%LABEL')THEN
	    IF(N.EQ.0)RETURN

* get missing inputs interactively -- through mouse input (6/99)
* ... if the user **explicitly** omits the justification (iflg(3)) then
*	put up menu (including arrow options)
	    mouse_input = m.LE.2 .OR. iflg(1).EQ.0 .OR. iflg(2).EQ.0
	    need_arrow = .FALSE.
	    IF ( mouse_input ) THEN
	      need_justify = m.GE.3 .AND. iflg(3).EQ.0
	      ichoice = IGRNPT(wsid, need_justify, xp, yp)	! mouse input
	      need_arrow =   ichoice.EQ.70 .OR. ichoice.EQ.102
     .			.OR. ichoice.EQ.76 .OR. ichoice.EQ.108
	      IF (need_arrow) THEN
* ... user wants a line pointing to the text
	         idummy = IGRNPT(wsid, .FALSE., p(1), p(2))
	         p(3) = -1	! left justify
	         IF( ichoice.EQ.70 .OR. ichoice.EQ.102 )THEN	 ! arow head?
	           iat = 2
	         ELSE
	           iat = 1
	         ENDIF
	      ELSE
* ... user just wants text
	         p(1) = xp
	         p(2) = yp
	         IF (ichoice .EQ. 67 .OR. ichoice.EQ.99) THEN
	           p(3) = 0	! center
	         ELSE  IF (ichoice .EQ. 82 .OR. ichoice.EQ.114) THEN
	           p(3) = 1	! right justify
	         ELSE	
	           p(3) = -1	! left justify
	         ENDIF
	      ENDIF
	      iflg(1) = 1
	      iflg(2) = 1
	      iflg(3) = 1
	      IF (m.LT.3) m = 3
	    ENDIF

C
C	SET SCALE FOR LABEL
C
	    CALL INQSCL(XFF,YFF,XOR,YOR,XLOW,YLOW)
	    IF(M.GE.3.AND.IFLG(3).NE.0)THEN
		IPOS=P(3)
	    ELSE
	    	IPOS=-1
	    ENDIF
	    IF(M.GE.4.AND.IFLG(4).NE.0)THEN
	    	ANG=P(4)
	    ELSE
	        ANG=0.
	    ENDIF
	    IF(M.GE.5.AND.IFLG(5).NE.0)THEN
	    	CHSIZE=P(5)
	    ELSE
	    	CHSIZE=HLAB1
	    ENDIF
	    IF(SUSER .OR. mouse_input)THEN	! mouse is always /USER
	    	XFUSER=1.
		YFUSER=1.
		YLOUSR=0.
		XLOUSR=0.
	    ELSE
	    	XFUSER=XFF
		YFUSER=YFF
		XLOUSR=XLOW
		YLOUSR=YLOW
	    ENDIF
	    CS=COS(ANG*0.0175329252)
	    SN=SIN(ANG*0.0175329252)

            CALL tm_break_lines (label, lnbeg, lnend, numlines)
            nfont = 0
            npen = 0
            fontprefix = ""
            penprefix = ""
            DO 40 j = 1, numlines
               CALL getlabfonts (label, lnbeg, lnend, j, fontprefix, 
     .           npnew, nfnew, newfont, newpen, nchr)
               XMN=SYMWID(CHSIZE,NCHR+npen+nfont, 
     .           penprefix(1:npen)//fontprefix(1:nfont)// 
     .           label(lnbeg(j):lnend(j))) 

	       SHFT=0.0
	       IF(IPOS.GT.0)THEN
	   	   SHFT=-XMN
	       ELSE IF(IPOS.EQ.0)THEN
		   SHFT=-XMN*.5
	       ENDIF

	       XT=P(1)/XFUSER+XLOUSR+CS*SHFT/XFF + 
     .             line_spacing*(j-1)*chsize*SN/xff
	       YT=P(2)/YFUSER+YLOUSR+SN*SHFT/YFF - 
     .             line_spacing*(j-1)*chsize*CS/yff

	       IF (need_arrow .AND. j.EQ.1) CALL ARROW(p(1),p(2),xp,yp,
     .				IAT,SHFT,XMN,CS,SN,XFF,YFF,chsize)

               CALL SYMBEL(XT,YT,ANG,CHSIZE,NCHR+npen+nfont,
     .                 penprefix(1:npen)//fontprefix(1:nfont)//
     .                 label(lnbeg(j):lnend(j)))

C  Set up to use any font settings from this line on subsequent lines.

               IF (npnew.GT.0) THEN
                  penprefix(1:npnew) = newpen(1:npnew)
                  npen = npnew
               ENDIF
               IF (nfnew.GT.0) THEN
                  fontprefix(1:nfnew) = newfont(1:nfnew)
                  nfont = nfnew
               ENDIF

  40        CONTINUE
C
C
C***	%WHERE
C
	ELSE IF(ICOM.EQ.'%WHERE')THEN
	    idummy = IGRNPT(wsid, .FALSE., p(1), p(2))	! mouse input

	ENDIF

	RETURN
	END
c!!!!!!!!!!!!!!!!!!!!!

      SUBROUTINE SHADE(XALOW,YALOW,XAHIGH,YAHIGH,XAINT,YAINT,
     * IASHAD)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)shade.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     CALL SHADE(XLOW,YLOW,XHIGH,YHIGH,XINT,YINT,ISHADE)
C
C     THIS SUBROUTINE SHADES A RECTANGLE WITH ONE OR MORE OF THE
C     FOLLOWING: HORIZONTAL LINES, VERTICAL LINES, UPWARD DIAG-
C     ONAL LINES, AND DOWNWARD DIAGONAL LINES.
C
C     THE VARIOUS PARAMETERS AND THEIR DEFINITIONS ARE LISTED
C     BELOW:
C        XLOW   - X-VALUE OF THE LEFT-HAND SIDE OF THE RECTANGLE
C                 IN USER'S UNITS.
C        YLOW   - Y-VALUE OF THE BOTTOM SIDE OF THE RECTANGLE IN
C                 USER'S UNITS.
C        XHIGH  - X-VALUE OF THE RIGHT-HAND SIDE OF THE RECTAN-
C                 GLE IN USER'S UNITS.
C        YHIGH  - Y-VALUE OF THE TOP SIDE OF THE RECTANGLE IN
C                 USER'S UNITS.
C        XINT   - DISTANCE BETWEEN SUCCESSIVE POINTS OF INTERSEC-
C                 TION OF THE SHADING LINES WITH THE BOTTOM AND
C                 TOP SIDES OF THE RECTANGLE IN USER'S UNITS.
C        YINT   - DISTANCE BETWEEN SUCCESSIVE POINTS OF INTERSEC-
C                 TION OF THE SHADING LINES WITH THE LEFT-HAND
C                 AND RIGHT-HAND SIDES OF THE RECTANGLE IN USER'S
C                 UNITS.
C        ISHADE - CODE INDICATING THE TYPE OF SHADING TO BE
C                 DRAWN.
C
C
      LOGICAL XYF,YXF
C
C     TRANSFER THE PARAMETERS TO NEW VARIABLES.
C
      XLOW = XALOW
      XHIGH = XAHIGH
      YLOW = YALOW
      YHIGH = YAHIGH
      XINT = ABS(XAINT)
      YINT = ABS(YAINT)
      ISHADE = IABS(IASHAD)
C
C     CHECK THE PARAMETERS TO MAKE SURE THAT THEY ARE VALID.
C
      IF(XLOW .LE. XHIGH)GO TO 10
      TEMP = XLOW
      XLOW = XHIGH
      XHIGH = TEMP
   10 IF(YLOW .LE. YHIGH)GO TO 20
      TEMP = YLOW
      YLOW = YHIGH
      YHIGH = TEMP
C
C     SET VECTRS MODE.
C
   20 CALL VECTRS
C
C     DETERMINE WHETHER THE RECTANGLE SHOULD BE SHADED.
C
      IF(XLOW .EQ. XHIGH .OR. YLOW .EQ. YHIGH)GO TO 340
      IF(XINT .EQ. 0.0 .OR. YINT .EQ. 0.0)GO TO 340
C
C     CHECK THE SHADING CODE.
C
# ifdef hp
      IF(IAND(ISHADE,1) .EQ. 0)GO TO 40
# else
      IF(AND(ISHADE,1) .EQ. 0)GO TO 40
# endif
C
C     SHADE THE RECTANGLE WITH HORIZONTAL LINES.
C
      Y1 = YLOW
   30 Y1 = Y1 + YINT
      IF(Y1 .GE. YHIGH)GO TO 40
      CALL PLOT(XLOW,Y1,0,0)
      CALL PLOT(XHIGH,Y1,1,0)
      Y1 = Y1 + YINT
      IF(Y1 .GE. YHIGH)GO TO 40
      CALL PLOT(XHIGH,Y1,0,0)
      CALL PLOT(XLOW,Y1,1,0)
      GO TO 30
C
C     CHECK THE SHADING CODE.
C
# ifdef hp
   40 IF(IAND(ISHADE,2) .EQ. 0)GO TO 60
# else
   40 IF(AND(ISHADE,2) .EQ. 0)GO TO 60
# endif
C
C     SHADE THE RECTANGLE WITH VERTICAL LINES.
C
      X1 = XLOW
   50 X1 = X1 + XINT
      IF(X1 .GE. XHIGH)GO TO 60
      CALL PLOT(X1,YLOW,0,0)
      CALL PLOT(X1,YHIGH,1,0)
      X1 = X1 + XINT
      IF(X1 .GE. XHIGH)GO TO 60
      CALL PLOT(X1,YHIGH,0,0)
      CALL PLOT(X1,YLOW,1,0)
      GO TO 50
C
C     CHECK THE SHADING CODE.
C
# ifdef hp
   60 IF(IAND(ISHADE,4) .EQ. 0)GO TO 200
# else
   60 IF(AND(ISHADE,4) .EQ. 0)GO TO 200
# endif
C
C     SHADE THE RECTANGLE WITH UPWARD DIAGONAL LINES.
C
      X1 = XLOW + XINT * FLOAT(IFIX((XHIGH - XLOW) / XINT))
      IF(X1 .LT. XHIGH)X1 = X1 + XINT
      Y1 = YLOW - YINT * (X1 - XHIGH) / XINT
      XYF = .FALSE.
      YXF = .FALSE.
      GO TO 80
   70 IF(XYF)GO TO 110
C
C     THE LOWER END OF THE LINES INTERSECTS THE BOTTOM SIDE OF
C     THE RECTANGLE.
C
      X1 = X1 - XINT
      IF(X1 .LE. XLOW)GO TO 90
      CALL PLOT(X1,YLOW,1,0)
   80 X1 = X1 - XINT
      IF(X1 .LE. XLOW)GO TO 100
      CALL PLOT(X1,YLOW,0,0)
      GO TO 140
   90 Y2 = YLOW - YINT * (X1 - XLOW) / XINT
      XYF = .TRUE.
      GO TO 120
  100 Y2 = YLOW - YINT * (X1 - XLOW) / XINT
      XYF = .TRUE.
      GO TO 130
C
C     THE LOWER END OF THE LINES INTERSECTS THE LEFT-HAND SIDE
C     OF THE RECTANGLE.
C
  110 Y2 = Y2 + YINT
  120 IF(Y2 .GE. YHIGH)GO TO 200
      CALL PLOT(XLOW,Y2,1,0)
      Y2 = Y2 + YINT
  130 IF(Y2 .GE. YHIGH)GO TO 200
      CALL PLOT(XLOW,Y2,0,0)
  140 IF(YXF)GO TO 170
C
C     THE UPPER END OF THE LINES INTERSECTS THE RIGHT-HAND SIDE
C     OF THE RECTANGLE.
C
      Y1 = Y1 + YINT
      IF(Y1 .GE. YHIGH)GO TO 150
      CALL PLOT(XHIGH,Y1,1,0)
      Y1 = Y1 + YINT
      IF(Y1 .GE. YHIGH)GO TO 160
      CALL PLOT(XHIGH,Y1,0,0)
      GO TO 70
  150 X2 = XHIGH - XINT * (Y1 - YHIGH) / YINT
      YXF = .TRUE.
      GO TO 180
  160 X2 = XHIGH - XINT * (Y1 - YHIGH) / YINT
      YXF = .TRUE.
      GO TO 190
C
C     THE UPPER END OF THE LINES INTERSECTS THE TOP SIDE OF THE
C     RECTANGLE.
C
  170 X2 = X2 - XINT
  180 IF(X2 .LE. XLOW)GO TO 200
      CALL PLOT(X2,YHIGH,1,0)
      X2 = X2 - XINT
  190 IF(X2 .LE. XLOW)GO TO 200
      CALL PLOT(X2,YHIGH,0,0)
      GO TO 70
C
C     CHECK THE SHADING CODE.
C
# ifdef hp
  200 IF(IAND(ISHADE,8) .EQ. 0)GO TO 340
# else
  200 IF(AND(ISHADE,8) .EQ. 0)GO TO 340
# endif
C
C     SHADE THE RECTANGLE WITH DOWNWARD DIAGONAL LINES.
C
      X1 = XLOW
      Y1 = YLOW
      XYF = .FALSE.
      YXF = .FALSE.
      GO TO 220
  210 IF(XYF)GO TO 250
C
C     THE LOWER END OF THE LINES INTERSECTS THE BOTTOM SIDE OF
C     THE RECTANGLE.
C
      X1 = X1 + XINT
      IF(X1 .GE. XHIGH)GO TO 230
      CALL PLOT(X1,YLOW,1,0)
  220 X1 = X1 + XINT
      IF(X1 .GE. XHIGH)GO TO 240
      CALL PLOT(X1,YLOW,0,0)
      GO TO 280
  230 Y2 = YLOW + YINT * (X1 - XHIGH) / XINT
      XYF = .TRUE.
      GO TO 260
  240 Y2 = YLOW + YINT * (X1 - XHIGH) / XINT
      XYF = .TRUE.
      GO TO 270
C
C     THE LOWER END OF THE LINES INTERSECTS THE RIGHT-HAND SIDE
C     OF THE RECTANGLE.
C
  250 Y2 = Y2 + YINT
  260 IF(Y2 .GE. YHIGH)GO TO 340
      CALL PLOT(XHIGH,Y2,1,0)
      Y2 = Y2 + YINT
  270 IF(Y2 .GE. YHIGH)GO TO 340
      CALL PLOT(XHIGH,Y2,0,0)
  280 IF(YXF)GO TO 310
C
C     THE UPPER END OF THE LINES INTERSECTS THE LEFT-HAND SIDE
C     OF THE RECTANGLE.
C
      Y1 = Y1 + YINT
      IF(Y1 .GE. YHIGH)GO TO 290
      CALL PLOT(XLOW,Y1,1,0)
      Y1 = Y1 + YINT
      IF(Y1 .GE. YHIGH)GO TO 300
      CALL PLOT(XLOW,Y1,0,0)
      GO TO 210
  290 X2 = XLOW + XINT * (Y1 - YHIGH) / YINT
      YXF = .TRUE.
      GO TO 320
  300 X2 = XLOW + XINT * (Y1 - YHIGH) / YINT
      YXF = .TRUE.
      GO TO 330
C
C     THE UPPER END OF THE LINES INTERSECTS THE TOP SIDE OF THE
C     RECTANGLE.
C
  310 X2 = X2 + XINT
  320 IF(X2 .GE. XHIGH)GO TO 340
      CALL PLOT(X2,YHIGH,1,0)
      X2 = X2 + XINT
  330 IF(X2 .GE. XHIGH)GO TO 340
      CALL PLOT(X2,YHIGH,0,0)
      GO TO 210
C
C     MOVE TO THE LOWER LEFT-HAND CORNER OF THE RECTANGLE.
C
  340 CALL PLOT(XLOW,YLOW,0,0)
      RETURN
C
      END

	LOGICAL FUNCTION CD_ISIT_EPIC ( dset, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine if this netCDF file is an EPIC file
* the following approach is taken to determine if this is an EPIC file:
* 1) locate one of the axes, "time" or "lat"
* 2) check for the attribute "epic_code"

* the common variable cd_what_isit is modified only if it is EPIC

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 2/93
* V600 *ACM* attribute control. 
*             Replace NCVID with CD_GET_VAR_ID
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* argument definitions:
*	dset	- dataset pointer for already opened CDF file

* argument declarations
      INTEGER dset, status

      include 'netcdf.inc'
      include 'tmap_errors.parm'
      include 'tmap_dims.parm'
      include 'xdset_info.cmn_text'
      external xdset_info_data
      include 'xdset_info.cd_equiv'

* internal variable declarations:
      INTEGER i, axid, attype, attlen, attoutflag, attid
      INTEGER axnamlen(2)
      CHARACTER*4 axname(2)

* internal data statements
      DATA axname(1)/'time'/, axnamlen(1)/4/, 
     .     axname(2)/'lat' /, axnamlen(2)/3/

* initialize
      status = merr_ok

* locate an axis that's in the file
      DO 100 i = 1, 2
         CALL CD_GET_VAR_ID ( dset, axname(i)(1:axnamlen(i)), 
     .         axid, status )
         IF ( axid .GT. 0 ) GOTO 200
 100  CONTINUE

* axis not found - it must not be EPIC
      CD_ISIT_EPIC = .FALSE.
      RETURN

* check for "epic_code" attribute
 200  CALL CD_GET_VAR_ATT_ID (dset, axid, 'epic_code', attid, status)

      CD_ISIT_EPIC =  status .EQ. merr_ok

* successful completion (always)
      RETURN
      END

c -+-+ -+-+ -+-+ -+-+ -+-+ -+-+ -+-+ -+-+ -+-+ -+-+ -+-+ -+-+ -+-+ -+-+ -+-+
      subroutine annualdai (fq, nd, x, r, gap, nf, flag)

c   computes annual variation r by robust least squares fit
c   of nf sine and cosine terms to x and remove r from series x.

c  calls: grossout, qr 

      parameter (mf = 5, mt = 2* mf)
      dimension x(*), r(*), gap(*)

      real*8  g(mt,mt), a(mt), b(mt), cw(mt), sw(mt), cwa(mt), swa(mt), 
     .        cm(mt), sm(mt), pi, freq, c, s, c2, cs, ss, cd, sd, cs2, 
     .        cd2, v1, v2, v3, u1, u2, u3, g1, g2, g3, g4, gi, wi, 
     .        vpy, ar, ai
      real fq, flag
      integer nd, nf

c   number nf of frequencies for annual & higher harmonics

      vpy = 365.25* 24.0* 7200.0* fq
      year = nd/ vpy
      if (year .lt. 3.0) return

      pi = 3.1415926535897932384

c   average over nave terms and decimate series

      nave = vpy/ (2.0* (nf + 1))
      if (nave .lt. 1) nave = 1
      nda  = nd/ nave
      
      if (nave .eq. 1) then
        do i = 1, nd
          r(i) = x(i)
        enddo
      else
        j2 = 0
        do i = 1, nda
          j1 = j2 + 1
          j2 = j2 + nave
          n  = 0
          s  = 0.d0
          do j = j1, j2
            xj = x(j)
            if (xj .ne. flag) then
              n = n + 1
              s = s + xj
            endif
          enddo
          if (n .gt. 0) then
            r(i) = s/ n
          else
            r(i) = flag
          endif
        enddo
      endif

c   outliers

      call grossout (nda, 5.0, r, gap, flag)

      ar = 0.d0
      nr = 0
      do i = 1, nda
        ri = r(i)
        if (ri .ne. flag) then
          gap(i) = 1.0
          nr = nr + 1
          ar = ar + ri
        else
          r(i)   = 0.0
          gap(i) = 0.0
        endif
      enddo

      aa = ar/ nr
      do i = 1, nda
        if (r(i) .ne. flag) r(i) = r(i) - aa
      enddo

      do n = 1, nf
        freq   = 2.d0* pi* n/ vpy
        cw(n)  = cos (freq)
        sw(n)  = sin (freq)
        cwa(n) = cos (nave* freq)
        swa(n) = sin (nave* freq)
      enddo

      do n = 1, nf
        m = n + nf
        c  = cwa(n)
        s  = swa(n)
        c2 = 2.d0* c
        u1 = 0.d0
        u2 = r(nda)
        do i = nda - 1, 2, -1
          u3 = c2* u2 - u1 + r(i)
          u1 = u2
          u2 = u3
        enddo
        a(n) = c* u2 - u1 + r(1)
        a(m) = s* u2
      enddo

c   mean of terms set equal to zero

      do n = 1, nf
        c  = cwa(n)
        s  = swa(n)
        c2 = 2.d0* c
        u1 = 0.d0
        u2 = gap(nda)
        do i = nda - 1, 2, -1
          u3 = c2* u2 - u1 + gap(i)
          u1 = u2
          u2 = u3
        enddo
        cm(n) = c* u2 - u1 + gap(1)
        sm(n) = s* u2
      enddo

      do m = 1, nf
        mm = m + nf
        do n = 1, m
          nn = n + nf
          c  = cwa(m)* cwa(n)
          s  = swa(m)* swa(n)
          cs = c - s
          cd = c + s
          s  = swa(m)* cwa(n)
          c  = cwa(m)* swa(n)
          ss = s + c
          sd = s - c
          cs2 = 2.d0* cs
          cd2 = 2.d0* cd
          gi = gap(nda)
          u1 = 0.d0
          u2 = gi
          v1 = 0.d0
          v2 = gi
          do i = nda - 1, 2, -1
            gi = gap(i)
            u3 = cs2* u2 - u1 + gi
            v3 = cd2* v2 - v1 + gi
            u1 = u2
            u2 = u3
            v1 = v2
            v2 = v3
          enddo

          g1 = gap(1) + 0.5d0* (cs* u2 - u1 + cd* v2 - v1)
          g2 =          0.5d0* (ss* u2 - sd* v2)
          g3 =          0.5d0* (ss* u2 + sd* v2)
          g4 =          0.5d0* (cd* v2 - v1 - cs* u2 + u1)

          g1 = g1 - cm(m)* cm(n)/ nr
          g2 = g2 - cm(m)* sm(n)/ nr
          g3 = g3 - sm(m)* cm(n)/ nr
          g4 = g4 - sm(m)* sm(n)/ nr

          g( m, n) = g1
          g( n, m) = g1
          g( m,nn) = g2
          g(nn, m) = g2
          g(mm, n) = g3
          g( n,mm) = g3
          g(mm,nn) = g4
          g(nn,mm) = g4

        enddo
      enddo

      nt = 2* nf

      call qr (mt, nt, nt, g, a, b, resq)

c   correction for averaging

      if (nave .gt. 1) then
        do n = 1, nf
          m = n + nf
            wi = pi* n/ vpy
            ww = nave* sin (wi)/ sin (nave* wi)
            c  = cos ((nave - 1)* wi)
            s  = sin ((nave - 1)* wi)
            ar = b(n)
            ai = b(m)
            b(n) = ww* (c* ar - s* ai)
            b(m) = ww* (s* ar + c* ai)
        enddo
      endif

c   annual variation r

      do i = 1, nd
        r(i) = 0.0
      enddo

      do n = 1, nf
        c  = cw(n)
        s  = sw(n)
        c2 = 2.d0* c
        u1 = b(n)
        u2 = c* u1 + s* b(n + nf)
        r(1) = r(1) + u1
        r(2) = r(2) + u2
        do i = 3, nd
          u3 = c2* u2 - u1
          r(i) = r(i) + u3
          u1 = u2
          u2 = u3
        enddo
      enddo

c   remove annual variation r from series x

      do i = 1, nd
        if (x(i) .ne. flag) x(i) = x(i) - r(i)
      enddo

      return
      end

      subroutine trendflag2 (nd, x, flag)
      real*8 xi, x0, x1, t0, t1, t2, wi, w1, w2, r1, r2, d 
      dimension x(*)
      real flag
      integer nd

      r1 = 1.d0/ nd
      r2 = 2.d0/ nd
      w1 = r2/ (1.d0 - r1)
      w2 = (1.d0 + r1)/ (1.d0 - r1)

      x0 = 0.d0
      x1 = 0.d0
      t0 = 0.d0
      t1 = 0.d0
      t2 = 0.d0
      do i = 1, nd 
        if (x(i) .ne. flag) then
          xi = x(i)
          wi = w1* i - w2
          x0 = x0 + xi 
          x1 = x1 + xi* wi
          t0 = t0 + 1.d0
          t1 = t1 + wi
          t2 = t2 + wi**2
        endif
      enddo
      x0 = x0/ t0
      x1 = x1/ t0
      t1 = t1/ t0
      t2 = t2/ t0

      d  = t2 - t1**2

      c0 = (t2* x0 - t1* x1)/ d
      c1 = (x1 - t1* x0)/ d 

      do i = 1, nd 
        xi = x(i)
        if (xi .ne. flag) then
          fi = w1* i - w2
          x(i) = xi - c1* fi - c0
        endif
      enddo

      return 
      end
      subroutine piw(sst, sstyear, w, ndim, flag)

      integer ndim, j, n

      integer nj, k, j1, j2

      real sst(*), sstyear(*), sd, sw, sj, wk
      real w(50)

      real flag

          sw = 0.0
          sd = 0.0
          nj = 0

          do n = 1, ndim
c            j1 = n - 6
c            j2 = n + 5
            j1 = n - 12
            j2 = n + 11
            nj = 0
            if (j1 .lt. 1) then
              sw = 0.0
              sd = 0.0
            else
              if (j2 .lt. ndim) then
                if(sst(j1)   .ne. flag .and. 
     .             sst(j2+1) .ne. flag) then
                  sd = 0.5* w(1)* (sst(j1) + sst(j2+1))
                  sw = w(1)
                else
                  if(sst(j1) .ne. flag) then
                    sd = w(1)* sst(j1)
                    sw = w(1)
                  else if(sst(j2+1) .ne. flag) then
                    sd = w(1)* sst(j2+1)
                    sw = w(1)
                  endif
                endif
              else
                if(sst(j1) .ne. flag) then
                  sd = w(1)* sst(j1)
                  sw = w(1)
                endif
              endif
              nj = 1
            endif
            k = 1
            do j = j1 + 1, j2
              k = k + 1
              if(j .ge. 1 .and. j .le. ndim) then
                sj = sst(j)
                if(sj .ne. flag) then
                  wk = w(k)
                  nj = nj + 1
                  sw = sw + wk
                  sd = sd + wk*sj
                endif
              endif
            enddo
c            if(sw .ne. 0.0) then
            if(nj .ge. 12 .and. sw .ne. 0.0) then
              sstyear(n) = sd / sw
            else
              sstyear(n) = flag
            endif
          enddo

          do n = 1, ndim
            sst(n) = sstyear(n)
          enddo

          return
          end

      subroutine prolate (w, nd, isw)

c  calculates prolate spheroidal wavefunction data window for
c  high resolution fourier analysis
c  ref: d.j.thomson, bell syst. tech. j. 56,1769-1815 (1977)
c
c  w is a single precison real array of data window values
c  nd is the number of points in w
c  isw is a switch--isw=4 means use a 4-pi window, isw=1 means use
c      the higher resolution pi window
c
c  scale factors=integral(boxcar)/integral(prolate window) are:
c    4 pi prolate window--1.425658520238489
c    pi prolate window--1.057568010371401
c  these are the numbers to multiply the spectrum by for comparison
c  with other windows
c
      ingeger nd, isw
      real w(*)
      real*8 xi, xn, x, d, u, dd, x1, x2
      x1 = dble(1)
      x2 = dble(2)
      xn = dble(nd)/ x2
      if (isw .eq. 4) then
      	d = sqrt (x2/ 0.508125548147497d0)
       	do i = 1, nd
      	  xi = dble(i) - x1
      	  x = xi/ xn - x1
      	  u = (x1 - x)* (x1 + x)
      	  dd = d*(((((((((((((((((((((
     $        2.6197747176990866d-11*u+2.9812025862125737d-10)*u+
     $        3.0793023552299688d-9)*u+2.8727486379692354d-8)*u+
     $        2.4073904863499725d-7)*u+1.8011359410323110d-6)*u+
     $        1.1948784162527709d-5)*u+6.9746276641509466d-5)*u+
     $        3.5507361197109845d-4)*u+1.5607376779150113d-3)*u+
     $        5.8542015072142441d-3)*u+1.8482388295519675d-2)*u+
     $        4.8315671140720506d-2)*u+1.0252816895203814d-1)*u+
     $        1.7233583271499150d-1)*u+2.2242525852102708d-1)*u+
     $        2.1163435697968192d-1)*u+1.4041394473085307d-1)*u+
     $        5.9923940532892353d-2)*u+1.4476509897632850d-2)*u+
     $        1.5672417352380246d-3)*u+4.2904633140034110d-5)
          w(i) = dd
      	enddo
      	return
      else
      	d = sqrt (x2)
      	do i = 1, nd
      	  xi = dble(i) - x1
      	  x = xi/ xn - x1
      	  u = (x1 - x)* (x1 + x)
      	  dd = d*((((((((((
     $        5.3476939016920851d-11*u+2.2654256220146656d-9)*u+
     $        7.8075102004229667d-8)*u+2.1373409644281953d-6)*u+
     $        4.5094847544714943d-5)*u+7.0498957221483167d-4)*u+
     $        7.7412693304064753d-3)*u+5.5280627452077586d-2)*u+
     $        2.2753754228751827d-1)*u+4.3433904277546202d-1)*u+
     $        2.2902051859068017d-1)
          w(i) = dd
        enddo
        return
      endif
      end
      subroutine grossout (nd, sdmax, x, r)

c   finds outliers in x at the sdmax standard deviation level and sets
c   x = flag for outliers

c   calls: robustsd

      dimension  x(*), r(*)
      integer nd
      real sdmax

      jd = 0
      do i = 1, nd
        xi = x(i)
        if (xi .ne. flag) then
          jd = jd + 1
          r(jd) = xi
        endif
      enddo

      call robustsd (jd, r, sd)
        
      jd = 0
      do i = 1, nd
        if (x(i) .ne. flag) then
          jd = jd + 1
          if (abs (r(jd)) .gt. sdmax) x(i) = flag
        endif
      enddo
 
      return
      end

      subroutine qr(ndim, m, n, a, b, x, resq)

      implicit double precision (a-h, o-z)
      integer ndim, m, n

c$$$$  calls no other routines
c  solves over-determined least-squares problem  ax = b
c  where  a  is an  m by n  matrix,  b  is an m-vector .
c  resq  is the sum of squared residuals of optimal solution.  also used
c  to signal error conditions - if -2 , system is underdetermined,  if
c  -1,  system is singular.
c  method - successive householder rotations.  see lawson+hanson - solv
c  -ing least squares problems.
c  routine will also work when m=n.
c*****   caution -  a and b  are overwritten by this routine.

      dimension a(ndim,*), b(*), x(*)
      double precision sum,dot
      real*4 resq
c
      resq=-2.0
      if (m.lt.n) return
c   loop ending on 1800 rotates  a  into upper triangular form
      do 1800 j=1,n
c  find constants for rotation and diagonal entry
      sq=0.0
      do 1100 i=j,m
 1100 sq=a(i,j)**2 + sq

cc      qv1=-sign(dsqrt(sq),a(j,j))
      signa = 1.
      if (abs(a(j,j)) .ne. a(j,j)) signa = -1.
      qv1=-1.* abs(dsqrt(sq)) * signa

      u1=a(j,j) - qv1
      a(j,j)=qv1
      j1=j + 1
      if (j1.gt.n) go to 1500
c  rotate remaining columns of sub-matrix
      do 1400 jj=j1,n
      dot=u1*a(j,jj)
      do 1200 i=j1,m
 1200 dot=a(i,jj)*a(i,j) + dot
      const=dot/dabs(qv1*u1)
      do 1300 i=j1,m
 1300 a(i,jj)=a(i,jj) - const*a(i,j)
      a(j,jj)=a(j,jj) - const*u1
 1400 continue
c  rotate  b  vector
 1500 dot=u1*b(j)
      if (j1.gt.m) go to 1610
      do 1600 i=j1,m
 1600 dot=b(i)*a(i,j) + dot
 1610 const=dot/dabs(qv1*u1)
      b(j)=b(j) - const*u1
      if (j1.gt.m) go to 1800
      do 1700 i=j1,m
 1700 b(i)=b(i) - const*a(i,j)
 1800 continue
c  solve triangular system by back-substitution.
      resq=-1.0
      do 2200 ii=1,n
      i=n-ii+1
      sum=b(i)
      if (ii.eq.1) go to 2110
      i1=i+1
      do 2100 j=i1,n
 2100 sum=sum - a(i,j)*x(j)
 2110 if (a(i,i).eq. 0.0) return
 2200 x(i)=sum/a(i,i)
c  find residual in overdetermined case.
      resq=0.0
      if (m.eq.n) return
      i1=n+1
      m=m
      n=n
      do 2300 i=i1,m
 2300 resq=b(i)**2 + resq
      return
      end

      subroutine robustsd (nd, r, sd)

c   robustly estimated standard deviation sd for nd values of r based on
c   median of the absolute value of the deviations.

c   calls: sort

      dimension r(*), dum(1005)
      integer nd, nh, nmax

      nh = nd/ 2

      smad = 0.67449

      nmax = 1000
      if (nd .le. nmax) then

        do i = 1, nd
          dum(i) = abs (r(i))
        enddo

        call sort (nd, dum)
 
        if (2* nh .eq. nd) then
          sd = 0.5* (dum(nh) + dum(nh + 1))/ smad
        else
          sd = dum(nh + 1)/ smad
        endif

        if (sd .eq. 0.0) then
          do i = 1, nd
            sd = sd + r(i)**2
          enddo
          sd = sqrt (sd/ nd)
        endif

      else

c   preliminary standard deviation
      
        s = 0.0
        do i = 1, nd
          s  = s + r(i)**2
        enddo
        s = sqrt (s/ nd)

        ds = sqrt (2.0* 3.141592654)* s* exp(0.5*smad**2)

        smed = smad* s

        mid = 0.6 + 0.5* nd

c   median absolute deviation

        nmed = -mid
        do i = 1, nd
          if (abs (r(i)) .le. smed) nmed = nmed + 1
        enddo

        if (nmed. eq. 0) go to 20

        ds = - ds* nmed/ nd

    2   sneg = smed
        nneg = nmed
        smed = smed + ds
        nmed = -mid
        do i = 1, nd
          if (abs (r(i)) .le. smed) nmed = nmed + 1
        enddo
cc        if (nneg* sign(1, nmed) .gt. 0) go to 2

        nsigna = 1
        if (abs(nmed) .ne. nmed) nsigna = -1
        if (nneg* nsigna .gt. 0) go to 2

        if (nmed .eq. 0) go to 20

        it = 0
    4   it = it + 1

        if (sneg .gt. smed) then
          sd   = smed
          smed = sneg
          sneg = sd
          nn   = nmed
          nmed = nneg
          nneg = nn
        endif

cc        if (nneg* sign(1, nmed) .lt. 0 .and. nmed - nneg .le. nmax) then

        nsigna = 1
        if (abs(nmed) .ne. nmed) nsigna = -1
        if (nneg* nsigna .gt. 0) go to 2

        if (nneg* nsigna .lt. 0 .and. nmed - nneg .le. nmax) then

          jd = 0
          do i = 1, nd
            ri = abs (r(i))
            if (ri .gt. sneg .and. ri .lt. smed) then
              jd = jd + 1
              dum(jd) = ri
            endif
          enddo

          call sort (jd, dum)

          if (2* nh .eq. nd) then
            smed = 0.5* (dum( -nneg) + dum( -nneg + 1))
          else
            smed = dum( -nneg + 1)
          endif

          go to 20

        endif

        sd = 0.5* (sneg + smed)
        nn = -mid
        do i = 1, nd
          if (abs (r(i)) .le. sd) nn = nn + 1
        enddo

        if (nn .eq. 0) then
          smed = sd
          go to 20
        endif

cc        if (nn* sign(1, nneg) .gt. 0) then

        nsigna = 1
        if (abs(nneg) .ne. nneg) nsigna = -1

        if (nn* nsigna .gt. 0) then
          sneg = sd
          nneg = nn
        else
          smed = sd
          nmed = nn
        endif

        if (it .lt. 10) go to 4

   20   sd = smed/ smad

      endif

      rd = 1.0/ sd
      do i = 1, nd
        r(i) = rd* r(i)
      enddo

      return
      end
      subroutine sort (nd, x)

c   ranks x base on code from numerical recipes.

      dimension x(*)

      if (nd .le. 1) return
      l = nd/2 + 1
      ir = nd

   10 continue
      
      if (l .gt. 1) then
        l = l - 1
        xi = x(l)
      else
        xi = x(ir)
        x(ir) = x(1)
        ir = ir - 1
        if (ir .eq. 1) then
          x(1) = xi
          return
        endif
      endif

      i = l
      j = l + l
   20 if (j .le. ir) then
        if (j .lt. ir) then
          jj = j + 1
          if (x(j) .lt. x(jj)) j = jj
        endif
        if (xi .lt. x(j)) then
          x(i) = x(j)
          i = j
          j = j + j
        else
          j = ir + 1
        endif
        go to 20
      endif

      x(i) = xi

      go to 10
      
      end

	SUBROUTINE TM_CLOSE_STEP ( f_num, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* close a file of time step data
* if called with a negative file number this subroutine returns without action
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.00 - 11/20/85
* revision 0.10 - 02/04/85 - added freeing of logical unit after close
* revision 0.20 - 02/15/89 - renamed TM_CLOSE_STEP, renamed sf_num to f_num
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* arguments:
*	f_num	- number (in /XSTEP_FILES/) of file to close
*	status	- error status on completion

	include 'tmap_errors.parm'
#include "tmap_dset.parm"
	include 'tmap_dims.parm'
	include 'xstep_files.cmn_text'
	external xstep_files_data

	INTEGER		f_num,status,lunit

* initialize
	status = merr_ok			! innocent until proven guilty

* interpret a negative or zero f_num as a no-op
	IF (f_num .LE. 0) RETURN

* normal situation - close the file as requested and free the logical unit
* number
	lunit = sf_lunit(f_num)
	CLOSE (UNIT = lunit, ERR = 5000)
	CALL LIB_FREE_LUN (lunit)
	sf_lunit(f_num) = file_not_open	! signals "closed"
 2000	RETURN

* report ERR= error
 5000	CALL TM_ERRMSG ( merr_erreq, status, 'TM_CLOSE_STEP',
     .			 sf_setnum(f_num), f_num,
     .			 no_errstring, no_errstring , *2000)
	END

        SUBROUTINE SETUP_DEFAULTS

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*

*       Sets ppl+ defaults & the options for SHADE for initial calls 
*       J Davison JISAO/PMEL/TMAP 8.24.88/7.27.89
*	*jd* 2.11.92 Initialize item_* variables here
*	*jd* 5.28.92 Inititalize sqfill to on for AREA command
*	*jd* Use area bundles for DEC , but not for ATC -- too few available
* 	*jd* Set default values for CENTERED & SET_DELTA in CONT.INC 8.15.95
*       *jd* Set default values for patterns 10.98
*       *jd* Initialize rgb_mapping 10.98
* 3/99 *kob* 	move var init off of decl list  - cleaning up after jerry.
* V552 5/03 *acm* Move shade key setup to routine SHADE_KEY
* V553 6/03 *acm* Keep the initialization of do_key here.
* V65 *acm   2/10 If Open-ended levels were used, symbol LEV_OPNLEVS saves 
* the /LEV command needed to duplicate the levels

        include         'shade_vars.cmn'
        include         'parampl5_dat.decl'
        include         'PARAMPL5.DAT'
        include         'axis_inc.decl'
        include         'AXIS.INC'
        include         'plt_inc.decl'
        include         'PLT.INC'
        include         'gkscm2.cmn'
        include         'ARFILL.INC'
        include         'cont_inc.decl'
        INCLUDE         'CONT.INC'

	real		rem
	external	ws_types_init,pplp_ver_data

        integer         i,solid
        DATA            solid/21/
        integer         set_default_patterns(20)
        DATA            set_default_patterns
     .          /1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20/

        character*25    set_pattern_list(21)
        DATA            set_pattern_list
     . /'TINY_TRIANGLES', 
     .  'TINY_GRID',
     .  'TINY_OPEN_SQUARES',
     .	'TINY_SQUARES',
     .	'LITE_HORIZONTAL',
     .	'LITE_VERTICAL',
     .	'DARK_HORIZONTAL',
     .	'DARK_VERTICAL',
     .	'DARK_UP_LEFT_TO_RIGHT',
     .	'LITE_UP_LEFT_TO_RIGHT',
     .	'DARK_UP_RIGHT_TO_LEFT',
     .	'LITE_UP_RIGHT_TO_LEFT',
     .	'LARGE_GRID',
     .	'ANGLED_GRID',
     .	'DOUBLE_VERTICAL',
     .	'DOUBLE_HORIZONTAL',
     .	'BALL_BEARINGS',
     .	'WEAVE',
     .	'FISH_SCALE',
     .	'BRICK',
     .  'SOLID'/

******************************************************************************

*	INITIALIZE WS/METAFILE THINGS
	ws_lun  = 111
	ws_file = 'ppl_port'

	meta_wsid = 101
*       MOD *JD* 3.25.91 Ultrix doesn't like LUN >= 19 for GOPWK
*	meta_lun  = 112
	meta_lun  = 18
*	meta_file = 'metafile.plt' -- initialize in block data

	tmp_wsid = 102
*	tmp_lun  = 113
	tmp_lun  = 17
	tmp_file = 'meta.tmp'

	meta_open = .false.
	meta_actv = .false.
	meta_clsplt = .false.

	vpt_was_set = .false.
	first_meta  = .true.

	item_gclrwk    = 101
	item_ws_xform  = 102
	item_ndx_range = 103
	item_spectrum  = 104
	item_protect   = 105
	item_fill_ndx  = 106
	item_pplpver   = 107

	bad_val = 1

*	SHADE DEFAULT COLORS
	ncl = 6
	custom_colors = .true.
*#ifdef atc_gks
	area_bundles  = .false.
*#else
*	area_bundles  = .true.
*#endif
	mncl = 0

*       RGB MAPPING PARAMETERS
        percent  = 0
        by_value = 1
        by_level = 2

        rgb_mapping = percent

	slvl(1) = 0.0
	sr(1) = 0.8
	sg(1) = 0.0
	sb(1) = 1.0

	slvl(2) = 10.0
	sr(2) = 0.3
	sg(2) = 0.2
	sb(2) = 1.0

	slvl(3) = 33.0
	sr(3) = 0.0
	sg(3) = 0.6
	sb(3) = 0.3

	slvl(4) = 66.0
	sr(4) = 1.0
	sg(4) = 1.0
	sb(4) = 0.0

	slvl(5) = 90.0
	sr(5) = 1.0
	sg(5) = 0.0
	sb(5) = 0.0

	slvl(6) = 100.0
	sr(6) = 0.6
	sg(6) = 0.0
	sb(6) = 0.0

*       DO THE KEY --- move most of this setup to routine SHADE_KEY; values
*       need to be initialized with each call.

	do_key	     	= .true.

*	when open-ended levels; create the /LEV command needed to 
*	duplicate them.

	lev_str = 'none'

*	INITIALIZE SQFFLG TO TRUE
	sqfflg = .true.

*       INITIALIZE DRAFTSMAN AND SPLINE_TENSION
        draftsman=.false.
        spline_tension=0.

*	INITIALIZE CONT.INC ADD ONS
	centered  = .false.
	set_delta = .false.

*       DEFAULTS FOR PATTERN SUPPORT
        do 10 i = 1, 20
           default_patterns(i) = set_default_patterns(i)
           pattern_list(i) = set_pattern_list(i)
 10     end do

*       DEFAULT PATTERN IS SOLID ("pattern" 21)
        npat = 1
        patterns(1) = solid
        pattern_list(solid) = set_pattern_list(solid)

	return
	end

	SUBROUTINE CMDINI
C** 
C**    @(#)cmdini.F	1.2    5/26/88
C**
C**
C***********************************************************************
C**
C**		    PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C**	Subprogram called:
C**		CALL CMDINI
C**
C**	Parameters:
C**
C**	Description:
C**		Initializes the logical units and files necessary for
C**		both the command file and key file reads.
C**
C**	History:
C**	    Written: 
C**		26-JAN-86	by Donald W. Denbo
C**	    Modified:
C**		30-MAY-1986	by Donald W. Denbo
C**		  Changes made for VAX/VMS version
C**
C**
	INCLUDE 'SYSTEM.INC'
	INCLUDE 'SYMKEY.INC'
	INCLUDE 'CMDCOM.INC'
	INCLUDE 'LUNITS.INC'

	CHARACTER FROM*80,TO*80,TEMP*2048,LINE*2048,CR*1,ESC*1
	INTEGER*4 STATUS,IFLAG

* 1/03 *kob* - g77 port requires that equivalence line comes before 
*              variable declaration
* v552 *acm* 3/03 Longer strings: changes for multi-line labels.

	EQUIVALENCE (BUF(1),LINE),(CR,CRB),(ESC,ESCB)

#ifdef STAR_1_SUPPORTED
	integer*1 BUF(80),CRB,ESCB
#else
	BYTE BUF(80),CRB,ESCB
#endif

	DATA CRB,ESCB/13,27/

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Next two lines' variables init'd in PPLDATA.F *jd* 2.93
*	DATA ECHOF,DEBUGF,SMKEY2/.TRUE.,.FALSE.,.FALSE./
*	DATA KEYLN1,KEYLN2,ECHLUN,CMDLUN/21,22,23,24/

c	DATA FROM,TO/'PL5KEY:SYMBOL.KEY','SY:SYSTEM.KEY'/
C	EQUIVALENCE (BUF(1),LINE),(CR,CRB),(ESC,ESCB)
C
#ifndef unix
	CALL ERRSET(36,.TRUE.,.FALSE.,.TRUE.,.FALSE.)
#endif
C
C	OPEN KEY FILE FOR SYMBOLS
C
C**	CALL COPY(FROM,TO,IER)
C**	IF(IER.NE.0)THEN
C**	    WRITE(LTTOUT,999)IER
C**999	    FORMAT(' Symbol key file copy error ',I3)
C**	    CALL EXIT
C**	ENDIF
#ifdef aix
*	OPEN(KEYLN1,FILE='PPL$KEY.001',STATUS='NEW')
#else
# ifdef NO_OPEN_RECORDTYPE
	OPEN(KEYLN1,FILE='PPL$KEY.001',STATUS='NEW')
# else
	OPEN(KEYLN1,FILE='PPL$KEY.001',STATUS='NEW',
     *  ORGANIZATION='INDEXED',ACCESS='KEYED',
     *  RECORDTYPE='VARIABLE',FORM='FORMATTED')
# endif
#endif
*	Following not allowed in f77 on DEC -- is it a don't care?? *jd* 2.93
*     *  KEY=(1:30:CHARACTER))
C
C	OPEN ECHO FILE
C
#ifdef NO_OPEN_CARRIAGECONTROL
	OPEN(ECHLUN,FILE='ECHO',STATUS='NEW')
#else
	OPEN(ECHLUN,FILE='ECHO',STATUS='NEW',CARRIAGECONTROL='LIST')
#endif

C
C	GET COMMAND LINE
C
c
c	rsx-11m
c
c	CALL GETMCR(BUF)
c	ICR=INDEX(LINE,CR)-1
c	IESC=INDEX(LINE,ESC)-1
c	ISTP=MAX0(ICR,IESC)
c	IS=INDEX(LINE,' ')+1
c	IF(IESC.GT.0)BATCHF=.TRUE.
c	IF(IS.GE.ISTP.OR.IS.EQ.1)THEN
c
c	end rsx-11m
c
c	vax/vms
c
#ifndef unix
	STAT=LIB$GET_FOREIGN(LINE,,ISTP)
#endif
	IS=1
	IF(LINE.EQ.' '.OR.ISTP.EQ.0)THEN
c
c	end vax/vms
c
C
C	NO FILE NAME READ
C
	    FROM='TT:'
	    LINE=' '
	    TERMF=.TRUE.
	ELSE
	    TEMP=LINE(IS:ISTP)
	    ISPC=INDEX(TEMP,' ')
	    IF(ISPC.GT.0)THEN
		FROM=TEMP(:ISPC-1)
		LINE=TEMP(ISPC+1:)
		IS=ISTP-IS+1-ISPC
	    ELSE
		FROM=TEMP
		LINE=' '
		IS=0
	    ENDIF
	    TEMP=FROM
	    itlen=lnblk(temp,2048)
	    CALL WLDFLE('SY:.PPC',TEMP(1:itlen),FROM,STATUS,IFLAG)
	    TERMF=.FALSE.
	ENDIF
C
C	SET COMMAND READ
C
	CMDLEV=0
	CALL ATSTRT(FROM,LINE,IS,IER)
	RETURN
	END

	SUBROUTINE TAYIS(IT,TLO,IT1,IT2,DT,NMTCT,LTT,IFDB,ISDB,
     *	YF,XHI,XF,TCSIZE,xacross,hgrat,hcolor,hline,is_hours_axis)
C** 
C**    @(#)tayis.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* 	Mod 11.27.95 For 4 digit years J Davison
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
C *acm* 03/04  new arguments for plotting graticule lines across plot. 
C V695  *acm*  9/15 Changes for hour:min labeling on time axes
C V697  *acm* 12/15 For short-time plots do the time axis in a separate
C                   routine tayis4

C If graticule lines are to be drawn across the plot at the tics
C then only do them for one horizontal and one vertical axis.  
C The dash lines interfere with each other if drawn from both 
C sides. HLINE and VLINE control this.

	INTEGER is_hours_axis
        REAL xacross           ! to draw tic line across plot
        REAL hgrat(4,2)        ! line type: 0=tics only, <0=line, >0=dash lengths 
        INTEGER hcolor(*)      ! pen number 
        LOGICAL hline          ! If true, do the lines across.

	CHARACTER*(*) IT1,IT2
	GOTO (10,20,20,30)IT+1
10	IF (is_hours_axis .EQ. 0) THEN 
	   CALL TAYIS0(TLO,IT1,IT2,DT,NMTCT,LTT,IFDB,ISDB,YF,XHI,XF,TCSIZE,
     .              xacross,hgrat,hcolor,hline)
	ELSE
	   CALL TAYIS4(TLO,IT1,IT2,DT,NMTCT,LTT,IFDB,ISDB,YF,XHI,XF,TCSIZE,
     .              xacross,hgrat,hcolor,hline,is_hours_axis)
	ENDIF
	RETURN
20	CALL TAYIS1(TLO,IT1,IT2,DT,NMTCT,LTT,IFDB,ISDB,YF,XHI,XF,TCSIZE,
     .              xacross,hgrat,hcolor,hline)
	RETURN
30	CALL TAYIS3(TLO,IT1,IT2,DT,NMTCT,LTT,IFDB,ISDB,YF,XHI,XF,TCSIZE,
     .              xacross,hgrat,hcolor,hline)
	RETURN
	END

      SUBROUTINE YAXIS1(X,XFACT,YLO,YHI,YTIC,NSMTCY,LINTY,YUNIT,LABEL,
     *    IFORMT,YFACT,CSIZE,xacross,ydms,ydspac,hgrat,hcolor,hline,
     *    yvaloff, noylab, SHRINKY, color0)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* revised for TMAP
* from PPLUS :
*	Directory PMEL:[PLOT5.PPLV11.PLOTLIB]YAXIS1.FOR

* search for "TMAP" to find all revisions
* *sh*  - 1/23/89 added interrupt detection
*		  ... no explicit declarations (too much trouble !) so it must
*		      be compiled with /WARNINGS=NODECLARATIONS
*	*jd* 5.6.96 Fix axis labelling bug where roundoff at zero results 
*			in small non-zero values
* v554: *acm* 2/04 add /HGRAT /VGRAT to draw optional graticule lines at tic marks
C *acm* 11/05  new argument to scinot deg/min/sec labels
C        1/06  xvaloff,yvaloff add this amount to each x or y axis label. 
C              (axis data was read as double precision and converted to single 
C              after applying an offset.)

* 11/2011 ACM Fixing ticket 1896: When needed, reset the size of numerical axis
*             labes, so the labels dont run off the edge of the plot.
* V7    *acm* 6/16 Ticket 2434: command qualifiers /DEGMINSEC= /HALFSPAC
*                  DEGMINSEC=1 for Deg-Min axis labels, =2 for Deg-Min-Sec. Default = 1
*                  /HALFSPAC adds a half space between the degree sign and E/W or N/S
* *acm* - 8/16   ticket 1787: restore pen 0 correctly after graticule
* *acm* - 11/16  ticket 2477: incomplete axis on some plots


C**
C**    @(#)yaxis1.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
        INTEGER ydms, ydspac
	CHARACTER*1 letter
	REAL SYMWID, spacwid
	LOGICAL do_shift

* Parameters for drawing tics across plot

        REAL xacross, dash1, dash2, dash3, dash4
        REAL hgrat(4,2)        ! line type: 0=tics only, <0=line, >0=dash lengths 
        INTEGER hcolor(*)      ! pen number for graticule lines
        INTEGER color0         ! pen number to restore
	LOGICAL hline          ! If true, do the lines across.
        LOGICAL solid          ! solid lines across at tics
        LOGICAL dashed         ! dashed lines across at tics
	LOGICAL noylab
	LOGICAL SHRINKY

	CHARACTER IFORMT*(*),YLAB*20
	COMMON/TICS/TSMX,TLX,TSMY,TLY,IX,IY
	COMMON/AXLWID/XWID,YWID 

	parameter (epsilon = 1.e-6)

* TMAP interrupt flag
	include 'xinterrupt.cmn'
        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'lines_inc.decl'
        include 'LINES.INC'
        INCLUDE 'pen_inc.decl'  ! with IPEN(1)
        INCLUDE 'PEN.INC'
C
C
C     THIS ROUTINE DRAWS A Y AXIS.  IT LABELS THE AXIS ON THE LEFT
C     IF LABEL=-1, ON THE RIGHT IF LABEL=1, AND NOT AT ALL
C     IF LABEL=0.  IF LABEL.NE.0 IFORMT TELLS US WHAT FORMAT TO WRITE
C     THE LABEL IN.  SEE NCHAR PARAMETER IN COMPLOT DOCUMENTATION
C     FOR THE SUBROUTINE NUMBER FOR AN EXPLANATION OF THIS.
C     IF CSIZE>0 THE LABELS HAVE THAT SIZE.  IF CSIZE<0 THE LABELS
C     HAVE THE SIZE -CSIZE  AND HAVE THE NEGATIVE OF THEIR TRUE
C     VALUES.
C     MODIFICATION OF JULY 29,1979.
C     WE HAVE CHANGED THE MEANING OF IFORMT.
C     USE -10<=IFORMT<=+10 AS BEFORE OR BETTER YET:
C     USE IFORMT = 10H(I7*BALL*)
C                 = 7H(F10.2)  FOR EXAMPLE
C     IN THIS OPTION OUR SUBROUTINE RECONIZES AN I FORMAT BY USING
C     THE FACT THAT THE FIRST TWO CHARACTERS OF IFORMT ARE "(I".
C     IN FACT IF YOU DIMENSION IFORMT IN THE CALLING PROGRAM YOU
C     CAN EVEN USE FORMAT STATEMENTS THAT ARE LONGER THAN 10 CHARACTERS.
C     HOWEVER, THE PRINTED LABEL MUST BE <=20 CHARACTERS.
C
C     THE FOLLOWING SECTION OF CODE MAKES THIS ROUTINE UPWARD COMPATIABLE.
      ABSSZ=ABS(CSIZE)
      SIGSZ=SIGN(1.,CSIZE)
C
C	DRAW AXIS
C

	DIR=SIGN(1.,YTIC)
	YT=INT(YLO/YTIC+SIGN(0.000001,DIR*YLO))*YTIC
	IF(DIR*YT.LT.DIR*YLO)YT=YT+YTIC
	ISTOP=IFIX((YHI-YT)/YTIC+0.000001)
	CALL PLOT(X,YT,0,0)
	CALL SMY1(X,XFACT,YFACT,YT,YLO,-YTIC,NSMTCY,
     .     xacross,hgrat,hcolor,hline)

	CALL PLOTT7(X,YT,XFACT,YFACT,1,-6)

	Y=YT
        
        solid = (hgrat(1,1).LT.0 .AND. hgrat(2,1).LT.0 .AND.  
     .            hgrat(3,1).LT.0 .AND.  hgrat(4,1).LT.0 )
        dashed = (hgrat(1,1).GT.0 .OR. hgrat(2,1).GT.0 .OR.  
     .            hgrat(3,1).GT.0 .OR.  hgrat(4,1).GT.0 )
        IF (dashed) THEN
           dash1 = hgrat(1,1)
           dash2 = hgrat(2,1)
           dash3 = hgrat(3,1)
           dash4 = hgrat(4,1)
        ENDIF

	DO 100 I=1,ISTOP
	IF ( interrupted ) RETURN		! TMAP interrupt
	CALL SMY1(X,XFACT,YFACT,Y,YHI,YTIC,NSMTCY,
     .     xacross,hgrat,hcolor,hline)
        IF ((solid.OR.dashed) .AND. hline) THEN ! make line across
           CALL COLOR(hcolor(1))
           IF (dashed) THEN
              CALL DASHSZ(dash1,dash2,dash3,dash4)
              CALL DASHES
           ENDIF
           CALL PLOT(X,Y,0,0)
           CALL PLOT(xacross,Y,1,0)
           CALL PLOT(X,Y,0,0) 
           CALL COLOR(color0)
           CALL VECTRS
        ENDIF

	Y=Y+YTIC
	CALL PLOTT7(X,Y,XFACT,YFACT,1,-6)
100	CONTINUE
	CALL SMY1(X,XFACT,YFACT,Y,YHI,YTIC,NSMTCY,
     .     xacross,hgrat,hcolor,hline)
        
        IF ((solid.OR.dashed) .AND. hline) THEN ! make line across
           CALL COLOR(hcolor(1))
           IF (dashed) THEN
              CALL DASHSZ(dash1,dash2,dash3,dash4)
              CALL DASHES
           ENDIF
           CALL PLOT(X,Y,0,0) 
           CALL PLOT(xacross,Y,1,0)
           CALL PLOT(X,Y,0,0) 
           CALL COLOR(color0)
           CALL VECTRS
        ENDIF

	CALL PLOT(X,YLO,1,0)
	CALL PLOT(X,YHI,1,0)
C
C	DRAW LABELS
C
	IF(LABEL.EQ.0)RETURN
	IF(LABEL+IY.EQ.0)THEN
		XTEMP=0.
	ELSE
		XTEMP=TLY*0.5
	ENDIF	
	
	LETTER = ' '
	IF(LABEL.EQ.1)THEN
           IF (yvaloff .EQ. 0.) THEN
	      CALL NUMCDE(SIGSZ*YLO/YUNIT,YLAB,LETTER,NC,IFORMT,ydms)
           ELSE
	      CALL NUMCDE_OFF(SIGSZ*YLO/YUNIT,YLAB,LETTER,NC,IFORMT,ydms,
     .              yvaloff)
           ENDIF
	   CALL SCINOT(0.,0.,0.,ABSSZ,NC,YLAB,3,WID,
     .             XFACT,YFACT)

           IF (yvaloff .EQ. 0.) THEN
	      CALL NUMCDE(SIGSZ*YHI/YUNIT,YLAB,LETTER,NC,IFORMT,ydms)
           ELSE
	      CALL NUMCDE_OFF(SIGSZ*YHI/YUNIT,YLAB,LETTER,NC,IFORMT,ydms,yvaloff)
           ENDIF
	   CALL SCINOT(0.,0.,0.,ABSSZ,NC,YLAB,3,WID1,
     .             XFACT,YFACT)

	   IF(YLO.LT.0..AND.YHI.GT.0.)THEN
              IF (yvaloff .EQ. 0.) THEN
                 CALL NUMCDE(0.,YLAB,LETTER,NC,IFORMT,ydms)
              ELSE
                 CALL NUMCDE_OFF(0.,YLAB,LETTER,NC,IFORMT,ydms,yvaloff)
              ENDIF
	      CALL SCINOT(0.,0.,0.,ABSSZ,NC,YLAB,3,WID2,
     *			XFACT,YFACT)
	   ELSE
	      WID2=0.0
	   ENDIF
	   XTEMP=XTEMP+AMAX1(WID,WID1,WID2)
	ENDIF
	
	YWID=0.75*ABSSZ+XTEMP
	XTEMP=X+LABEL*YWID/XFACT  

	IF(DIR*YLO.LE.0.AND.DIR*YHI.GE.0)THEN
		Y=INT(YLO/(YTIC*LINTY)-0.000001)*YTIC*LINTY
	ELSE
		Y=YT
	ENDIF
	ISTOP=INT((YHI-Y)/(YTIC*LINTY)+0.000001)

	y0 = y
	YWIDT=0.
        YSAVE = Y

	IF (SHRINKY) THEN
C First compute max axis-label width without writing labels 
C (ITYPE=3 arg to SCINOT) 

        DO 199 I=0,ISTOP
	IF ( interrupted ) RETURN		! TMAP interrupt
        TEMP=SIGSZ*Y/YUNIT
        IF (yvaloff .EQ. 0) THEN
           CALL NUMCDE(TEMP,YLAB,LETTER,NC,IFORMT,ydms)
        ELSE
           CALL NUMCDE_OFF(TEMP,YLAB,LETTER,NC,IFORMT,ydms,yvaloff)
        ENDIF
        CALL SCINOT(XTEMP,Y,0.,ABSSZ,NC,YLAB,3,WID,XFACT,YFACT)
	
	Y=y0+YTIC*LINTY*(i+1)
	if (abs(y) .lt. epsilon*abs(y0)) y = 0.0

	IF(WID.GT.YWIDT)YWIDT=WID
199	CONTINUE

* Use origin and label-size info that is in common to possibly
* reset the axis-label size for this axis only, so the labels dont
* run off the edge. (Only do this if the axis is labeled on the left.
* means we are ignoring axes at the right of the page, labeled on the right.)

        IF (label .EQ. -1) CALL RESET_LABSIZ (YWID, YWIDT, ABSSZ, NOYLAB)

	ENDIF !SHRINKY

	YWIDT=0.
	Y = YSAVE
	LETTER = ' '

        TEMP=SIGSZ*Y/YUNIT
	CALL NUMCDE(TEMP,YLAB,LETTER,NC,IFORMT,ydms)
	
	spacwid = 0.
	do_shift = ( INDEX(YLAB, '#') .GT. 0 )  ! longitude or latitude labels
	IF (do_shift) spacwid = SYMWID(ABSSZ,1,'N')

* Now make the labels. 
	DO 200 I=0,ISTOP
	IF ( interrupted ) RETURN		! TMAP interrupt
        TEMP=SIGSZ*Y/YUNIT
        IF (yvaloff .EQ. 0) THEN
           CALL NUMCDE(TEMP,YLAB,LETTER,NC,IFORMT,ydms)
        ELSE
           CALL NUMCDE_OFF(TEMP,YLAB,LETTER,NC,IFORMT,ydms,yvaloff)
        ENDIF

* Letter E/W or N/S is added separatly.  Need a space for that plus
* any extra requested space.

	IF (do_shift) spacwid = SYMWID(ABSSZ,1,LETTER)

	XL = XTEMP
	IF (label .EQ. -1) THEN
	   IF (ydspac .GT. 0) THEN
	      XL = XTEMP - (0.5*spacwid + 0.5*ydspac*spacwid)/XFACT 
	   ELSE
	      XL = XTEMP - spacwid/XFACT 
	   ENDIF
	ENDIF

        CALL SCINOT(XL,Y,0.,ABSSZ,NC,YLAB,1,WID,XFACT,YFACT)
        IF (letter .NE. ' ') THEN
	   NL = 1
	   XL = XL + 0.5*(0.5*ydspac*spacwid)/XFACT  ! SCINOT called with right-justify
	   YL = Y - 0.5*ABSSZ/YFACT             ! SCINOT centers vertically
	   CALL SYMBEL(XL,YL,0.,ABSSZ,NC,LETTER)
	ENDIF

CC	Original code
CC	Y=Y+YTIC*LINTY

	Y=y0+YTIC*LINTY*(i+1)
	if (abs(y) .lt. epsilon*abs(y0)) y = 0.0

	IF(WID.GT.YWIDT) YWIDT=WID 
200	CONTINUE
	IF(LABEL.LT.0)THEN 
           IF (YDMS .GE. 2) ywidt = ywidt - symwid(abssz,1,'''')
           YWID=YWID+YWIDT
        ENDIF
	
	YWID = YWID + spacwid + 0.5*ydspac*spacwid
	RETURN
	END

*
* dot_x.F
*
* compute the dot product of two arguments along a shared axis
*




      SUBROUTINE dot_x_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

      CALL ef_set_desc(id, 'Compute the inner product of two variables along X-axis')
      CALL ef_set_num_args(id, 2)
      CALL ef_set_axis_inheritance_6d(id,
     .                                NORMAL, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'VAR1')
      CALL ef_set_arg_desc(id, arg, 'Variable 1')
      CALL ef_set_axis_influence_6d(id, arg,
     .                                YES, YES, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'VAR2')
      CALL ef_set_arg_desc(id, arg, 'Variable 2')
      CALL ef_set_axis_influence_6d(id, arg,
     .                                YES, YES, YES, YES, YES, YES)

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE dot_x_compute(id, arg_1, arg_2, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1, i2, j2, k2, l2, m2, n2
      CHARACTER*100 errtxt

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* check to make sure both variables share the common axis
      IF ( (arg_lo_ss(X_AXIS, ARG1) .EQ. ef_unspecified_int4) .OR. 
     .     (arg_hi_ss(X_AXIS, ARG1) .EQ. ef_unspecified_int4) .OR. 
     .     (arg_lo_ss(X_AXIS, ARG2) .EQ. ef_unspecified_int4) .OR. 
     .     (arg_hi_ss(X_AXIS, ARG2) .EQ. ef_unspecified_int4) 
     .      ) THEN
         WRITE(errtxt,*) 'X axis of arguments 1 and 2 cannot be a normal axis'
         GOTO 999
      ENDIF
      IF ( arg_hi_ss(X_AXIS, ARG1) - arg_lo_ss(X_AXIS, ARG1) .NE. 
     .     arg_hi_ss(X_AXIS, ARG2) - arg_lo_ss(X_AXIS, ARG2) ) THEN
         WRITE(errtxt,*) 'X axis of Arguments 1 and 2 must be the same length'
         GOTO 999
      ENDIF

* Initialize the result, F90 initialize whole array

      result = bad_flag_result  

* Compute the dot product

      n1 = arg_lo_ss(F_AXIS,ARG1)
      n2 = arg_lo_ss(F_AXIS,ARG2)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

       m1 = arg_lo_ss(E_AXIS,ARG1)
       m2 = arg_lo_ss(E_AXIS,ARG2)
       DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

        l1 = arg_lo_ss(T_AXIS,ARG1)
        l2 = arg_lo_ss(T_AXIS,ARG2)
        DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         k1 = arg_lo_ss(Z_AXIS,ARG1)
         k2 = arg_lo_ss(Z_AXIS,ARG2)
         DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

          j1 = arg_lo_ss(Y_AXIS,ARG1)
          j2 = arg_lo_ss(Y_AXIS,ARG2)
          DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

	    i = res_lo_ss(X_AXIS)
           i2 = arg_lo_ss(X_AXIS,ARG2)
           DO 100 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)

            IF ( arg_1(i1,j1,k1,l1,m1,n1) .NE. bad_flag(ARG1) .AND. 
     .	         arg_2(i2,j2,k2,l2,m2,n2) .NE. bad_flag(ARG2) ) THEN

               IF (result(i,j,k,l,m,n) .EQ. bad_flag_result) THEN
	          result(i,j,k,l,m,n) =  
     .	            arg_1(i1,j1,k1,l1,m1,n1)* arg_2(i2,j2,k2,l2,m2,n2)

               ELSE

	          result(i,j,k,l,m,n) = result(i,j,k,l,m,n) + 
     .	            arg_1(i1,j1,k1,l1,m1,n1)* arg_2(i2,j2,k2,l2,m2,n2)

               ENDIF

            ENDIF

           i2 = i2 + arg_incr(X_AXIS,ARG2)
 100       CONTINUE

           j1 = j1 + arg_incr(Y_AXIS,ARG1)
           j2 = j2 + arg_incr(Y_AXIS,ARG2)
 200      CONTINUE

          k1 = k1 + arg_incr(Z_AXIS,ARG1)
          k2 = k2 + arg_incr(Z_AXIS,ARG2)
 300     CONTINUE

         l1 = l1 + arg_incr(T_AXIS,ARG1)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
 400    CONTINUE

        m1 = m1 + arg_incr(E_AXIS,ARG1)
        m2 = m2 + arg_incr(E_AXIS,ARG2)
 500   CONTINUE

       n1 = n1 + arg_incr(F_AXIS,ARG1)
       n2 = n2 + arg_incr(F_AXIS,ARG2)
 600  CONTINUE

      RETURN

 999  CALL EF_BAIL_OUT(id, errtxt)

      RETURN 
      END

	BLOCK DATA XGKS_DEVICES_DATA

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* initialization for DEC GKS devices

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  12/6/89

        IMPLICIT NONE
	include	'xgks_devices.cmn'

	DATA	gks_dev_name(1) / 'DEFAULT'    	/,
     .		gks_dev_name(2) / 'VSII'    	/,
     .		gks_dev_name(3) / 'PS'    	/,
     .		gks_dev_name(4) / 'LN03P'    	/,
     .		gks_dev_name(5) / 'TEK4107'    	/,
     .		gks_dev_name(6) / 'TEK4014'    	/,
     .		gks_dev_name(7) / '&&&&&&&&'   	/,
     .		gks_dev_name(8) / '&&&&&&&&'   	/,
     .		gks_dev_name(9) / '&&&&&&&&'   	/,
     .		gks_dev_name(10)/ '&&&&&&&&'   	/

	DATA	gks_dev_wstype(1) / -999 /,
     .		gks_dev_wstype(2) / -999 /,
     .		gks_dev_wstype(3) / -999 /,
     .		gks_dev_wstype(4) / -999 /,
     .		gks_dev_wstype(5) / -999 /,
     .		gks_dev_wstype(6) / -999 /,
     .		gks_dev_wstype(7) / -999 /,
     .		gks_dev_wstype(8) / -999 /,
     .		gks_dev_wstype(9) / -999 /,
     .		gks_dev_wstype(10)/ -999 /

	DATA	meta_dev_name(1) / 'VSII'    	/,
     .		meta_dev_name(2) / 'PS'    	/,
     .		meta_dev_name(3) / 'LN03P'    	/,
     .		meta_dev_name(4) / 'TEK4107'    	/,
     .		meta_dev_name(5) / 'TEK4014'    	/,
     .		meta_dev_name(6) / '&&&&&&&&'   	/,
     .		meta_dev_name(7) / '&&&&&&&&'   	/,
     .		meta_dev_name(8) / '&&&&&&&&'   	/,
     .		meta_dev_name(9) / '&&&&&&&&'   	/,
     .		meta_dev_name(10)/ '&&&&&&&&'   	/
	END

	SUBROUTINE reset_secs_from_bc( tstep, new_tstep, 
     .                                 old_cal_id, new_cal_id, 
     .                                 status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* return a REAL*8 number giving the number of seconds since 1-JAN-0000:00:00
* for tstep.  On input tstep is relative to calendar old_cal_id,
* on output tstep is relative to the calendar indicated by new_cal_id

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* revision 0.0 2/28/01
* V5.53 *acm* 9/03 Set status flag to OK for case where calendar doesnt change
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

* Calling argument declarations:
	INTEGER		old_cal_id, new_cal_id, status
	REAL*8		tstep, new_tstep

* Local variable declarations:
	INTEGER		year, month, day, hour, minute, second
	REAL*8		TM_SECS_FROM_BC
	CHARACTER*20	TM_SECS_TO_DATE, date

	include 'ferret.parm'
	include 'errmsg.parm'

	IF (old_cal_id .EQ. new_cal_id ) THEN
           new_tstep = tstep
           status = ferr_ok
        ELSE

* Convert to date string
	   date = TM_SECS_TO_DATE(tstep, old_cal_id)
	   CALL TM_BREAK_DATE ( date, old_cal_id,
     .			  year, month, day, hour, minute, second,
     .			  status )
	   IF (status .NE. ferr_ok) GO TO 9000

* Find the offset from 01-JAN-0000 00:00:00 for this date and calendar

	   new_tstep = TM_SECS_FROM_BC (new_cal_id, year, month, day,
     .				     hour, minute, second, status)
	ENDIF

 9000	RETURN
	END

*
* nco.F
*
* Ansley Manke
* March 1, 2005
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
* V685 *acm* 5/13  If the user has sent -A (append) then don't send 
*                  -O (override) to nco.
*
* This function spawns any NCO call, with the first argument being the
* NCO function name, and the second one long string which is the argument 
* to nco including file names and actions.
*
* 
      SUBROUTINE nco_init(id)

* Define arguments and result

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

      CALL ef_set_desc(id, 'Call an NCO utility' )
      CALL ef_set_num_args(id, 2)
      CALL ef_set_axis_inheritance_6d(id,
     .                                ABSTRACT, NORMAL,
     .                                NORMAL,   NORMAL,
     .                                NORMAL,   NORMAL)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'operator')
      CALL ef_set_arg_desc(id, arg, 'name of operator')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)
      CALL ef_set_arg_type(id, arg, STRING_ARG)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'arguments')
      CALL ef_set_arg_desc(id, arg, 'one string with all arguments')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)
      CALL ef_set_arg_type(id, arg, STRING_ARG)

      RETURN 
      END

* Define abstract output axis: 1 value

      SUBROUTINE nco_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id
      INTEGER ivalue

      ivalue = 1
      CALL ef_set_axis_limits(id, X_AXIS, ivalue, ivalue)

      RETURN 
      END

*
* Compute the result
*
      SUBROUTINE nco_compute(id, arg_1, arg_2, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif

      INTEGER id

      REAL arg_1(strdf,
     .           mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(strdf,
     .           mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

      LOGICAL TM_HAS_STRING
      INTEGER TM_LENSTR

      INTEGER arg, alen, slen
      INTEGER i, j, k, l, m, n
      CHARACTER*2048 argstring, buff

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      arg = 1
      CALL ef_get_arg_string(id, arg, argstring)
      alen = TM_LENSTR(argstring)
      buff = argstring(1:alen)
      slen = alen

      arg = 2
      CALL ef_get_arg_string(id, arg, argstring)
      alen = TM_LENSTR(argstring)

      IF ( TM_HAS_STRING(argstring, '-A') ) THEN 
         buff = buff(1:slen)//' -h '
         slen = slen + 5
      ELSE
         buff = buff(1:slen)//' -O -h '
         slen = slen + 7
      ENDIF

      buff = buff(1:slen)//argstring(1:alen)
      slen = slen + alen 

* Spawn the command 

      i = res_lo_ss(X_AXIS)
      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      l = res_lo_ss(T_AXIS)
      m = res_lo_ss(E_AXIS)
      n = res_lo_ss(F_AXIS)
      result(i,j,k,l,m,n) = bad_flag_result

      CALL system( buff(1:slen) )

      result(i,j,k,l,m,n) = 1

      RETURN 
      END

	SUBROUTINE GET_LINEAR_COEF( src_lo, src_hi, src_grid,
     .				    dst_lo, dst_hi, dst_grid,
     .				    axis, ss, coef )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* for regridding axis axis from source grid to destination grid:
* determine linear interpolation coefficients and nearest lower neighbor point 

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 12/30/88
* revision 0.1 -  1/15/89 - fixed bug in coef for xdst<xsrc
* V200:  8/7/89 - allow exact equality case
* V230:  8/23/92 - bug fix for non-date time axes
* V300:   5/5/93 - coordinate comparisons in single precision
* V312:	  6/7/94 - use TDST_WORLD* for simpler, faster date conversions
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction. 

        IMPLICIT NONE
	include 'ferret.parm'
	include 'errmsg.parm'

* calling argument declarations:
	INTEGER src_lo, src_hi, dst_lo, dst_hi, src_grid, dst_grid, axis
	INTEGER ss(dst_lo:dst_hi)
	REAL	coef (dst_lo:dst_hi)

* internal variable declarations:
	INTEGER	ISUBSCRIPT, isrc, ii, status
	REAL*8	TM_WORLD, TDEST_WORLD, xsrc, xdst, xmin, xmax

* initialize
	IF ( axis .EQ. t_dim .OR. axis .EQ. f_dim ) THEN
*          TDST_WORLD gives dates from the source axis as they would be
*	   encoded on the destination axis 
*      ==> ALL TIME/DATE CALCULATIONS ARE DONE IN THE SOURCE AXIS ENCODING
	   CALL TDEST_WORLD_INIT ( dst_grid, src_grid, axis, status ) ! src<->dst
	   IF ( status .NE. ferr_ok ) RETURN  ! note - status not passed !!
	ENDIF
	xmin = TM_WORLD( src_lo, src_grid, axis, box_middle )
	xmax = TM_WORLD( src_hi, src_grid, axis, box_middle )

* loop through points of destination axis
	DO 100 ii = dst_lo, dst_hi

* get destination grid point in question
* if T axis, then get it encoded as per source time axis
	   xdst = TDEST_WORLD( ii, dst_grid, axis, box_middle )

	   IF ( SNGL(xdst) .LT. SNGL(xmin)
     .     .OR. SNGL(xdst) .GT. SNGL(xmax) ) THEN  	! SNGL 5/93

* ... destination point does not lie within source grid bounds
	      coef( ii ) = bad_val4
	      ss  ( ii ) = unspecified_int4

	   ELSE

	      isrc = ISUBSCRIPT( xdst, src_grid, axis, round_dn )
	      xsrc = TM_WORLD( isrc, src_grid, axis, box_middle )
	      IF ( SNGL(xdst) .EQ. SNGL(xsrc) ) THEN    ! SNGL 5/93
	         ss  ( ii ) = isrc
	         coef( ii ) = 0.0
	      ELSEIF ( xdst .GT. xsrc ) THEN
	         ss  ( ii ) = isrc
	         coef( ii ) =	( xdst - xsrc ) /
     .			( TM_WORLD(isrc+1,src_grid,axis,box_middle) - xsrc )
	      ELSE
	         ss  ( ii ) = isrc - 1
	         coef( ii ) =	1.0 - ( ( xsrc - xdst ) /
     .			( xsrc - TM_WORLD(isrc-1,src_grid,axis,box_middle) ) )
	      ENDIF

	   ENDIF

 100	CONTINUE

	RETURN
	END

      SUBROUTINE TAXIS3(TLO,ITIME1,ITIME2,DT,NDAY,LABEL,IMDB,IYDB,
     1    TFACT,Y,YFACT,CSIZE,yacross,vgrat,vcolor,vline)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* revised for TMAP
* from PPLUS :
*	Directory PMEL:[PLOT5.PPLV11.PLOTLIB]TAXIS3.FOR

* search for "TMAP" to find all revisions
* *sh*  - 1/23/89 added interrupt detection
*		  ... no explicit declarations (too much trouble !) so it must
*		      be compiled with /WARNINGS=NODECLARATIONS


* *jd* 11.21.95	Mod for 4 digit year
* *jd* 11.29.95	Mod century axis
* *jd* 2.8.96 Exclude consideration of seconds when comparing times and
*		deciding whether to continue drawing time axis.  Ferret uses
*		PPLLDX to compute time axis locations rather than the PPL
*		TIME command.  It uses single precision reals which can be
*		rounded.  Rounding can lead to the time axis being drawn too
*		long.
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
* *sh* 9/99 - bug fix to "century axis" -- major tic interval (IYDB) may be
*               equal to zero
C *acm* 03/04  new arguments and code for plotting graticule lines across plot.
C *acm*  3/10  Bug 670 fixed: New flag MULTICENFLAG for multi-decade plots, 
C              do not make small tics by default.


C**
C**    @(#)taxis3.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     THIS ROUTINE PLOTS A TIME AXIS AND LABELS IT WITH THE MONTH OF THE
C     AND THE YEAR.
C     VARIBLES:
C         TLO=X VALUE CORRESPONDING TO THE START TIME.
C         ITIME1 = START TIME (IE.  770819000000)
C                  WE RESTRICT THE PERMISSIBLE START TIMES TO BE
C                  THE START OF A NEW MONTH.  (THAT IS THE LAST 6 DIGITS
C                  MUST BE 0 AND THE 7'TH AND 8'TH DIGITS MUST BE 01)
C         ITIME2 = END TIME (IE   770901000000)
C                  THIS IS THE FIRST MONTH NOT TO BE PLOTTED, AND IT
C                  MUST BE THE BEGINNING OF A NEW MONTH..
C         DT = SAMPLING RATE IN MINUTES.
C         NDAY = NUM OF DAYS BETWEN SMALL TICS.
C                  IF NDAY = 2HWK THE TICS WILL BE OFFSET
C                  TO CORRESPOND WITH THE START OF NEW WEEKS.
C         LABEL > 0 IF LABELS ARE TO BE DRAWN ABOVE THE AXIS.
C               = 0 IF NO LABELS ARE TO BE DRAWN.
C               < 0 IF LABEL ARE TO BE DRAWN BELOW THE AXIS.
C         IABS(LABEL) = 1 FOR LABELS OF THE STYLE
C                  1..........1..........1..........1..........1
C                      MAR         APR        MAY      JUN
C                                      1980
C         IABS(LABEL) = 2 FOR LABELS OF THE STYLE
C                  1..........1..........1..........1..........1
C                     NOV 80     DEC 80      JAN 81    FEB 81
C         IMDB = PRINT LABELS OF MONTHS DIVIBLE BY THIS NUMBER ONLY.
C                IF(IMDB = 0) PRINT NO MONTH LABELS.
C         IYDB = PRINT LABELS OF YEARS DIVISIBLE BY THIS NUMBER ONLY.
C                IF(IYDB = 0) PRINT NO YEAR LABELS.
C                THIS VARIBLE ONLY APPLYS WHEN IABS(LABEL) = 1
C         TFACT = (LENGTH OF T AXIS IN INCHES)/(LENGTH OF T AXIS IN USER
C         Y = Y COORDINATE OF TIME AXIS.
C         YFACT = (LENGTH OF Y AXIS IN INCHES)/(LENGTH OF Y AXIS IN USER
C         CSIZE = SIZE TO DRAW DAY LABELS.
C                 YEAR LABELS WILL BE 1.5 TIMES AS LARGE.
C
C     THIS PROGRAM WAS FIRST WRITTEN BY DAVID MANDEL IN JULY 1980.
C
	CHARACTER ITIME1*(*),ITIME*14,ITIME2*(*),SYM*21,MON*3
	CHARACTER CEN*2,YR*2,ITIME3*14
	COMMON/TICS/TSMX,TLX,TSMY,TLY,IX,IY
	COMMON/AXLWID/XWID,YWID

	LOGICAL*4 not_zero_size
        include 'century.cmn'

* Parameters for drawing tics across plot

        REAL yacross
        REAL dash1_1, dash1_2, dash1_3, dash1_4
        REAL dash2_1, dash2_2, dash2_3, dash2_4
        REAL vgrat(4,2)        ! line type: 0=tics only, <0=line, >0=dash lengths 
        INTEGER vcolor(*)      ! pen number 
        LOGICAL vline          ! If true, do the lines across.
        LOGICAL solid1, solid2   ! solid lines across at tics
        LOGICAL dashed1, dashed2 ! dashed lines across at tics
        INTEGER ltic, color1, color2

* TMAP interrupt flag
	include 'xinterrupt.cmn'

C     CHECK THE PARAMETERS PASSED TO THE SUBROUTINE.

	IF(ITIME1(5:10).NE.'010000')STOP ',1'
	IF(ITIME2(5:10).NE.'010000')STOP ',2'

C set up for plotting graticules across at tic marks
        
        solid1 = (vgrat(1,1).LT.0 .AND. vgrat(2,1).LT.0 .AND.  
     .            vgrat(3,1).LT.0 .AND.  vgrat(4,1).LT.0 )
        solid2 = (vgrat(1,2).LT.0 .AND. vgrat(2,2).LT.0 .AND.  
     .            vgrat(3,2).LT.0 .AND.  vgrat(4,2).LT.0 )
        dashed1 = (vgrat(1,1).GT.0 .OR. vgrat(2,1).GT.0 .OR.  
     .            vgrat(3,1).GT.0 .OR.  vgrat(4,1).GT.0 )
        dashed2 = (vgrat(1,2).GT.0 .OR. vgrat(2,2).GT.0 .OR.  
     .            vgrat(3,2).GT.0 .OR.  vgrat(4,2).GT.0 )

        color1 = vcolor(1)
        color2 = vcolor(2)

        IF (dashed1) THEN
           dash1_1 = vgrat(1,1)
           dash1_2 = vgrat(2,1)
           dash1_3 = vgrat(3,1)
           dash1_4 = vgrat(4,1)
        ENDIF
        IF (dashed2) THEN
           dash2_1 = vgrat(1,2)
           dash2_2 = vgrat(2,2)
           dash2_3 = vgrat(3,2)
           dash2_4 = vgrat(4,2)
        ENDIF
C
C     SET PARAMETERS.

*     *jd Number of arguments of TIME3 calls reduced to 6.  TIME3 uses only
*     the first 6, 'seconds' are not handled.  Done for MAC 7.92


	IF(LABEL+IX.EQ.0)THEN
		YTEMP=0.0
	ELSE
		YTEMP=TLX*0.5
	ENDIF
	IF(IABS(LABEL).EQ.1)THEN
	NC=3
	ELSE IF(IABS(LABEL).EQ.3)THEN
	NC=1
	ELSE
	NC=6
	ENDIF
	IF(NDAY.LT.0)THEN
		IHVY=-8
		INML=-7
	ELSE
		IHVY=-9
		INML=-8
	ENDIF

	NOT_ZERO_SIZE = .NOT.(INML.EQ.-7.AND.TSMX.EQ.0)
	IF (MULTICENFLAG) NOT_ZERO_SIZE = .FALSE.

	IF(IMDB.NE.0)THEN
	FIMDB=0.0
	ELSE
	FIMDB=-1.4
	ENDIF
      IF(LABEL.LT.0) THEN
         YTEMP1=Y-(1.4*CSIZE+YTEMP)/YFACT
         YTEMP2=Y-((4.0+FIMDB)*CSIZE+YTEMP)/YFACT
	 IF (ix.EQ.1 .AND. ytemp.NE.0) ytemp1 = ytemp1 + tlx*0.4/YFACT
	 IF (ix.EQ.1 .AND. ytemp.NE.0) ytemp2 = ytemp2 + tlx*0.4/YFACT
      ELSE
         YTEMP1=Y+(0.4*CSIZE+YTEMP)/YFACT
         YTEMP2=Y+((2.5+FIMDB)*CSIZE+YTEMP)/YFACT
	 IF (ix.EQ.1 .AND. ytemp.NE.0) ytemp1 = ytemp1 - tlx*0.4/YFACT
	 IF (ix.EQ.1 .AND. ytemp.NE.0) ytemp2 = ytemp2 - tlx*0.4/YFACT
      ENDIF

      IF(LABEL.LT.0) THEN
	 XTEMP1=X-(1.4*CSIZE+XTEMP)/XFACT
	 XTEMP2=X-((4.0+FIMDB)*CSIZE+XTEMP)/XFACT
	 IF (iy.EQ.1) xtemp1 = xtemp1 + iy*tly*0.4/xfact
	 IF (iy.EQ.1) xtemp2 = xtemp2 + iy*tly*0.4/xfact
      ELSE
	 XTEMP1=X+(0.4*CSIZE+XTEMP)/XFACT
	 XTEMP2=X+((2.5+FIMDB)*CSIZE+XTEMP)/XFACT
	 IF (iy.EQ.1) xtemp1 = xtemp1 - iy*tly*0.4/xfact
	 IF (iy.EQ.1) xtemp2 = xtemp2 - iy*tly*0.4/xfact
      ENDIF

      IF(LABEL.NE.0)XWID=(4.0+FIMDB)*CSIZE+YTEMP
      T=TLO
      ITIME=ITIME1
      CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
      TYR=T
      CALL PLOT(TLO,Y,0,0)

*       Century axis mod
	IF (cenflag) THEN
	   IF (IMON.NE.1) GOTO 10
	   IF (IYDB .GT. 0) THEN
	      IF (MOD(ICEN*100+IYR,IYDB).EQ.0) THEN
	         CALL PLOTT7(TLO,Y,TFACT,YFACT,1,IHVY)
	      ELSE
	         IF(NOT_ZERO_SIZE) ! Don't plot zero length tic
     .		   CALL PLOTT7(TLO,Y,TFACT,YFACT,1,INML)
	      ENDIF
           ENDIF
	ELSE
	   IF(IMON.EQ.1)THEN
	      CALL PLOTT7(TLO,Y,TFACT,YFACT,1,IHVY)
	   ELSE
	      IF(NOT_ZERO_SIZE) ! Don't plot zero length tic
     .		CALL PLOTT7(TLO,Y,TFACT,YFACT,1,INML)
	   ENDIF
	ENDIF

c ----  count number of large tics. If no large tics will be drawn
c ----  then will want to draw graticule lines at the small ones.

      ITIME=ITIME1
      CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
      SECMON=FLOAT(NUMDM1(ITIME))*1440.

C     LOOP:

       ltic = 0
  110  CONTINUE
       CALL TIME1(1,ITIME,2,' ',I3,ITIME3,SECMON)
       CALL TIME3(ITIME3,IYR3,IMON3,IDAY3,IHR3,IMIN3,ISEC3,ICEN3)

       ITIME=ITIME3
       SECMON=FLOAT(NUMDM1(ITIME))*1440.

       IF( ITIME(13:14)// ITIME(1:10).LT.
     .	     ITIME2(13:14)//ITIME2(1:10)) THEN
           IF(IMON3.EQ.1) ltic = ltic + 1
           GO TO 110
       ENDIF

! IF no large tics, and if graticules at just the large tics were
! requested, then plot graticules at the small tics

	IF (ltic .EQ. 0) THEN   
           IF ( (.NOT.solid2) .AND. (solid1) ) THEN
              solid2 = solid1
              color2 = color1
           ENDIF
           IF ( (.NOT.dashed2) .AND. (dashed1) ) THEN 
              dashed2 = dashed1
              dash2_1 = dash1_1
              dash2_2 = dash1_2
              dash2_3 = dash1_3
              dash2_4 = dash1_4
              color2 = color1
           ENDIF
        ENDIF
        
      ITIME=ITIME1
      CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)

c ----

C     LOOP:
   10     CALL PLOT(T,Y,0,0)
	  IF ( interrupted ) RETURN		! TMAP interrupt
	SECMON=FLOAT(NUMDM1(ITIME))*1440.
	TIC=SECMON/DT
          CALL TIME1(1,ITIME,2,' ',I3,ITIME3,SECMON)
          CALL TIME3(ITIME3,IYR3,IMON3,IDAY3,IHR3,IMIN3,ISEC3,ICEN3)

*       Century axis mod
	IF (cenflag) THEN
	   IF (IMON3.NE.1) GOTO 11
	
	   IF (IYDB .GT. 0) THEN
	      IF (MOD(ICEN3*100+IYR3,IYDB).EQ.0) THEN
	         CALL PLOTT7(T+TIC,Y,TFACT,YFACT,1,IHVY)
                 IF ((solid1.OR.dashed1) .AND. vline) THEN ! make line across
                    CALL COLOR(color1)
                    IF (dashed1) THEN
                       CALL DASHSZ(dash1_1,dash1_2,dash1_3,dash1_4)
                       CALL DASHES
                    ENDIF
                    CALL PLOT(t+tic,y,0,0) 
                    CALL PLOT(t+tic,yacross,1,0)
                    CALL PLOT(t+tic,Y,0,0) 
                    CALL COLOR(1)
                    CALL VECTRS
                 ENDIF

	      ELSE
	         IF(NOT_ZERO_SIZE) THEN
     		   CALL PLOTT7(T+TIC,Y,TFACT,YFACT,1,INML) 
                      IF ((solid2.OR.dashed2) .AND. vline) THEN ! make line across
                         CALL COLOR(color2)
                         IF (dashed2) THEN
                            CALL DASHSZ(dash2_1,dash2_2,dash2_3,dash2_4)
                            CALL DASHES
                         ENDIF
                         CALL PLOT(T+TIC,y,0,0) 
                         CALL PLOT(T+TIC,yacross,1,0)
                         CALL PLOT(T+TIC*TDIST,Y,0,0) 
                         CALL COLOR(1)
                         CALL VECTRS
                      ENDIF
	      
                 ENDIF
              ENDIF
          ENDIF
	ELSE
	   IF(IMON3.EQ.1)THEN
	      CALL PLOTT7(T+TIC,Y,TFACT,YFACT,1,IHVY)
              IF ((solid1.OR.dashed1) .AND. vline) THEN ! make line across
                 CALL COLOR(color1)
                 IF (dashed1) THEN
                    CALL DASHSZ(dash1_1,dash1_2,dash1_3,dash1_4)
                    CALL DASHES 
                 ENDIF
                CALL PLOT(t+tic,y,0,0) 
                 CALL PLOT(t+tic,yacross,1,0)
                 CALL PLOT(t+tic,Y,0,0) 
                 CALL COLOR(1)
                 CALL VECTRS
              ENDIF
	   ELSE
	      IF(NOT_ZERO_SIZE) THEN
                 CALL PLOTT7(T+TIC,Y,TFACT,YFACT,1,INML)
                 IF ((solid2.OR.dashed2) .AND. vline) THEN ! make line across
                    CALL COLOR(color2)
                    IF (dashed2) THEN
                       CALL DASHSZ(dash2_1,dash2_2,dash2_3,dash2_4)
                       CALL DASHES
                    ENDIF
                    CALL PLOT(T+TIC,y,0,0) 
                    CALL PLOT(T+TIC,yacross,1,0)
                    CALL PLOT(T+TIC*TDIST,Y,0,0) 
                    CALL COLOR(1)
                    CALL VECTRS
                 ENDIF

              ENDIF
	   ENDIF
	ENDIF

C         THE LABELS
11        CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
          IF(IMDB.EQ.0.OR.LABEL.EQ.0) GO TO 50
          IF(IMON.NE.IMDB*(IMON/IMDB)) GO TO 50
	  IF (cenflag) GOTO 50 ! No month labels for multiple years
              CALL TIME2(ITIME,SYM)
	READ(SYM,30)MON,CEN,YR
30	FORMAT(6X,A3,4X,A2,A2)
	WRITE(SYM,40)MON,YR
   40         FORMAT(A3,' ',A2)
        TSYM=T+(TIC-SYMWID(CSIZE,NC,SYM)/TFACT)*.5
        CALL SYMBEL(TSYM,YTEMP1,0.,CSIZE,NC,SYM)
   50     CONTINUE
          IF(IYDB.EQ.0.OR.NC.EQ.6) GO TO 70
              IF(IYR.EQ.IYR3) GO TO 70
              IF((ICEN*100+IYR).NE.IYDB*((ICEN*100+IYR)/IYDB)) GO TO 60
C             ELSE:
	IF(T-TYR.GT.83333.33/DT)THEN
                  CALL TIME2(ITIME,SYM)
	READ(SYM,30)MON,CEN,YR
	WRITE(SYM,55)CEN,YR
   55             FORMAT(A2,A2)
        TSYM=TYR+(T+TIC-TYR-SYMWID(1.4*CSIZE,4,SYM)/TFACT)*.5
        CALL SYMBEL(TSYM,YTEMP2,0.,1.4*CSIZE,4,SYM)
	ENDIF
   60         TYR=T+TIC
   70     CONTINUE
          ITIME=ITIME3
          T=T+TIC
*** 2.8.96                       IF( ITIME(13:14)// ITIME(1:12).LT.
*** Don't use seconds    .	     ITIME2(13:14)//ITIME2(1:12)) GO TO 10

          IF( ITIME(13:14)// ITIME(1:10).LT.
     .	     ITIME2(13:14)//ITIME2(1:10)) GO TO 10

*     Draw complete time axis -- mods not to draw minor tics require it
      CALL PLOT(TLO,Y,0,0)
      CALL PLOT(T,Y,1,0)

      IF(IYDB.EQ.0.OR.LABEL.EQ.0) GO TO 80
C     ELSE:
	IF(IABS(LABEL).NE.2.AND.IYR.EQ.IYDB*(IYR/IYDB)
     .	.AND.IMON3.GE.4)THEN
          CALL TIME2(ITIME,SYM)
	READ(SYM,30)MON,CEN,YR
	WRITE(SYM,55)CEN,YR
        TSYM=TYR+(T-TYR-SYMWID(1.4*CSIZE,4,SYM)/TFACT)*.5
        CALL SYMBEL(TSYM,YTEMP2,0.,1.4*CSIZE,4,SYM)
	ENDIF
C
C     THE SECTION OF CODE THAT PUTS ON THE SMALL TIC MARKS.
   80 	IF(NDAY.LE.0)RETURN
	CALL TIME3(ITIME1,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
	CALL TIME3(ITIME2,IYR3,IMON3,IDAY3,IHR3,IMIN3,ISEC3,ICEN3)
	IDELT=12*(IYR3-IYR)+IMON3-IMON
	ITIME=ITIME1
	TIC=NDAY*1440./DT
	T1=TLO
	DO 90 I=1,IDELT
	T=T1
	IDUDE=NUMDM1(ITIME)
	NSTIC=IDUDE/NDAY
	DO 100 J=1,NSTIC
	T=T+TIC
	CALL PLOT(T,Y,0,0)
	CALL PLOTT7(T,Y,TFACT,YFACT,1,-7)
C
100	CONTINUE
	IF(IMON.EQ.12)THEN
	IYR=IYR+1
	IMON=1
	ELSE
	IMON=IMON+1
	ENDIF
	WRITE(ITIME,999)IYR,IMON,IDAY,IMIN,ISEC
999	FORMAT(5I2.2)
	T1=T1+IDUDE*1440./DT
90	CONTINUE
      END

	subroutine plotny(xp,yp,ics,itype) 
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)plotny.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
c     plots a line from present point to point xb,yb (in inches) 
c     ics=3 pen up 
c        =2 pen down 
c     itype=0 or 1 ordinary line 
c          =2 heavy line 
c          =3 dotted line 
c     must be initialized by call to plotny with pen up. 
c     oceanography/emr   december 1969. 
c     dotted line routine improved july/74 
c 
	common/rotcon/xk,yk,snthta,csthta
#ifdef unix
	include 'DASHZZ.INC'
#else
	include 'pplinc:dashzz.inc'
#endif
c	data dashln/.02/ , spacln/.04/ , dslab/5.0/
	totlng=dashln+spacln 
	xb=xp*csthta-yp*snthta+xk
	yb=yp*csthta+xp*snthta+yk
	if(ics-3)5,10,5 
5	if(itype-2)10,20,30 
c 
c     ordinary line   itype=0 or 1. 
c 
10	call plot(xb,yb,3-ics,0) 
	go to 100 
c 
c     heavy line   itype=2 
c 
20	dx=xb-xa 
	dy=yb-ya 
	ds=sqrt(dx*dx+dy*dy)+.001 
	dxd=dx*.01/ds 
	dyd=dy*.01/ds 
	call plot(xb,yb,1,0) 
	call plot(xb+dyd,yb-dxd,1,0) 
	call plot(xa+dyd,ya-dxd,1,0) 
	call plot(xa-dyd,ya+dxd,1,0) 
	call plot(xb-dyd,yb+dxd,1,0) 
	call plot(xb,yb,1,0) 
	go to 100 
c 
c     dotted line   itype=3 
c 
30	sx=xb-xa 
	sy=yb-ya 
	sabsq=sx**2+sy**2 
	if(sabsq.eq.0.) go to 100 
	sab=sqrt(sabsq) 
	cose=sx/sab 
	sine=sy/sab 
	if(stlng.lt.dashln) go to 35 
	x=xa-(stlng-dashln)*cose 
	y=ya-(stlng-dashln)*sine 
	go to 50 
35	x=xa-stlng*cose 
	y=ya-stlng*sine 
40	x=x+dashln*cose 
	y=y+dashln*sine 
	ssq=(x-xa)**2+(y-ya)**2 
	if(ssq.lt.sabsq) go to 45 
	call plot(xb,yb,1,0) 
	stlng=dashln-(sqrt(ssq)-sab) 
	go to 100 
45	call plot(x,y,1,0) 
50	x=x+spacln*cose 
	y=y+spacln*sine 
	ssq=(x-xa)**2+(y-ya)**2 
	if(ssq.lt.sabsq) go to 55 
	call plot(xb,yb,0,0) 
	stlng=totlng-(sqrt(ssq)-sab) 
	go to 100 
55	call plot(x,y,0,0) 
	go to 40 
c 
c     save point a for next time 
c 
100	xa=xb 
	ya=yb 
	if(ics.eq.3) stlng=dashln/2.0 
	return 
	end 

	SUBROUTINE BUILD_T_AGG_AXIS (dset_num, nagfiles,
     .			memb_order, memb_filename,
     .			memb_tstep_start, memb_tstep_end,
     .			memb_nsteps, t_regular, use_strict, status)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*


*  Modify the time axis that was defined by the first file of the T-agg
*  through the inclusion time information from all of the member files in
*  the aggregation.
*  If the file time metadata information was not provided (i.e. in the
*  argument arrays memb_*), then fill in that metadata here, while creating the
*  aggregated time axis
*  If the files as-provided were out of order, then sort them


* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - TMAP 
*
* V695+ 10/15 *sh* -- based upon DEFINE_EF_AGGREGATE_GRID
* V67    5/16 *acm*   Fixes for member sets with single-point time axes having bounds
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.
* V7022 1/17 *acm* ticket 2497, Back off the auto-detection of monthly axes.
* V71   2/17 *acm* ticket 2507, When agg axis matches an existing one, fix swapping 
*                  of axis into grids - the swap axis may be in multiple grids.
* V71   2/17 *acm* ticket 2507, further fix for when several variables have the same grid.

      IMPLICIT NONE
        include 'tmap_errors.parm'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xdset_info.cd_equiv'
        include 'xprog_state.cmn'
	include 'xtm_grid.cmn_text'
	include 'xunits.cmn_text' 
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xfr_grid.cmn'
	include 'interp_stack.parm'
	include 'netcdf.inc'


* arguments:

*	dset_num	- dataset number 1st file -- to become the T agg
*	nagfiles	- number of files in the aggregation (input)
*	memb_order	- ordering index of files (input empty/output filled)
*	memb_filename	- array of filenames (input)
*	memb_tstep_start- array of first timestep in each file (input)
*	memb_tstep_end	- array of last  timestep in each file (input)
*	memb_nsteps	- array of N timesteps in each file (input)
*			  (unspecified_int4 signals no metadata provided)
*	t_regular	- flag to signal promise of regular timesteps (input)
*	use_strict	- flag to allow micro-adjustments of T axis (input)
*	status		- return status (output)
*

* Setting the argument t_regular=.TRUE. signals a promise that every
* individual file will be regularly spaced with the identical delta,
* including the delta between files

* Argument definitions
	LOGICAL		t_regular, use_strict
	INTEGER		nagfiles, dset_num, status
	INTEGER		memb_nsteps(nagfiles), memb_order(nagfiles)
	REAL*8		memb_tstep_start(nagfiles), memb_tstep_end(nagfiles)
	CHARACTER*512	memb_filename(nagfiles)


* local variable declarations:
	LOGICAL TM_DFPEQ_TOL, ITSA_TRUEMONTH_AXIS, need_midpoints, need_T0_adjust,
     .		swap_axes, true_month, memb_true_month
	INTEGER TM_LENSTR1, TM_GET_CALENDAR_ID, TM_FIND_LIKE_DYN_LINE,
     .		taxis, nsteps, max_line_available, dtype, vlen, blen,
     .		i, ifile, istep, ivar, TMAP_status, isubsc1,
     .		cdfid, vid, bounds_id, gg, ilo, ihi, l, imemb,
     .		startpts(2), numpts(2), d1s, d1e, d2s, d2e,
     .		agg_unit_code, file_unit_code, agg_cal_id, pre_exist, 
     .		nsteps_trumon
	REAL	TM_WORLD_AX, T0_ADJUST,
     .		tt, delta, highest_tstep, dfirst_delta, 
     .		depsilon, start, tunit, coord_hi, hdel, coord_new
	CHARACTER LEFINT*20, lname*20, vname*64, bname*12, units_str*128,
     .		  calendar_str*128, agg_t0_str*20, file_t0_str*20

* local parameter declaration
* (this definition should be in a shared declarations file)
	REAL	depsilon_46
	PARAMETER (depsilon_46 = 2.**(-46)) 

* initialize using information from the first file of the aggregation
	taxis          = ds_time_axis(dset_num)
	IF (taxis .EQ. mnormal) GOTO 5050   ! no time axis?
	nsteps         = line_dim(taxis) ! n steps in first file ... will grow
	vname          = line_name_orig(taxis)
	vlen           = TM_LENSTR1(vname)
	max_line_available = maxlinestore
	dtype          = unspecified_int4  ! irrelevant from older netCD
	need_midpoints = .FALSE.           ! assume cell edges are provided
	agg_unit_code  = line_unit_code(taxis)
	agg_T0_str     = line_T0(taxis)
	agg_cal_id     = TM_GET_CALENDAR_ID (line_cal_name(taxis))

* note that this routine is called under a promise that
* dset_num is the *only* dataset that uses the time axis pointed to by
* ds_time_axis.  Thus our procedure here will be to define the aggregated T
* axis in as a new axis and then replace the pointers to the old axis with the
* new. 

* Was the first file found to have a true-monthly time axis?
c	true_month = ITSA_TRUEMONTH_AXIS (taxis)
	true_month = .FALSE.

c	IF (true_month .AND. .NOT.t_regular) THEN
c
c* Loop through the files of the aggregation, checking for more compatible true-month axes.
c* The time axis from member 1 is not in line_mem, so just keep reading into the next slots
c
c	   nsteps_trumon = nsteps
c	   isubsc1 = next_line_mem_pos
c	   
c	   coord_hi = line_start(taxis) + (nsteps-1)* line_delta(taxis)
c
c* Translate fake true-month timestep to actual month-length step.
c
c	   CALL TM_TCOORD_TRUMONTH (taxis, coord_hi,  
c     .		       box_middle, coord_new)
c
c	   memb_order(1) = 1
c	   memb_nsteps(1) = nsteps
c	   memb_tstep_start(1) = line_start(taxis) 
c	   memb_tstep_end  (1) = coord_new
c
c	   TMLOOP: DO ifile = 2, nagfiles
c* ... first read the length of the time axis from the file to be aggregated
c	      CALL CD_QUIK_NCOPEN (dset_num, memb_filename(ifile),
c     .				      vname(:vlen),
c     .				      cdfid, vid, bounds_id,
c     .				      units_str, calendar_str,
c     .				      nsteps, TMAP_status)
c	      IF (TMAP_status .NE. merr_ok) GOTO 5010
c* ... check to see if calendar, units, and T0 are consistent with the agg axis
c	      CALL CD_GET_T0(memb_filename(ifile), units_str, calendar_str,
c     .                  agg_cal_id, file_unit_code, file_t0_str, status)
c
c	      IF (next_line_mem_pos+nsteps .GT. max_line_available) GOTO 5100
c
c* ... read the array of time steps from the file and read or compute bounds
c	      CALL CD_RD_R8_ARR(cdfid, vid,1, nsteps,dtype,vname(:vlen),
c     .				   line_mem(isubsc1), status)
c	      IF ( status .NE. merr_ok ) GOTO 5010
c
c	      IF (bounds_id .NE. unspecified_int4) THEN
c
c	         startpts(1) = 1
c	         startpts(2) = 1
c	         numpts(1) = 1
c	         numpts(2) = nsteps
c
c	         d1s = startpts(1)
c	         d1e = numpts(1)
c	         d2s = startpts(2)
c	         d2e = numpts(2)
c		 bname = 'bounds array'
c		 blen = 12
c
c		 CALL CD_RD_R8_BNDS( cdfid, bounds_id,
c     .			  startpts, numpts, dtype, bname(:blen),
c     .                    line_mem(isubsc1+nsteps),  
c     .                    d1s, d1e, d2s, d2e, status )
c	         IF ( status .NE. merr_ok ) GOTO 5010
c
c	      ELSE
c	         CALL TM_IRREGAX_MID( isubsc1,isubsc1 )
c	      ENDIF
c
c	      CALL TM_CHECK_MONTHLY_AXIS (line_mem(isubsc1), nsteps, agg_cal_id, 
c     .                                   file_T0_str, file_unit_code, units_str,
c     .                                   start, delta, tunit, memb_true_month)
c
c* Also bail on true-month if the units or t0 are different.
c
c	      need_T0_adjust = (file_unit_code .NE. agg_unit_code)
c     .			     .OR. (file_T0_str    .NE. agg_T0_str)
c	      IF (need_T0_adjust) memb_true_month = .FALSE.
c
c! check value of "start" relative to the stored axis -- checking sorting.
c	      IF (start .LT. coord_hi) memb_true_month = .FALSE.
c	      IF (start-coord_hi .GT. 2.*line_delta(taxis))  memb_true_month = .FALSE.
c	      IF (delta .NE. line_delta(taxis)) memb_true_month = .FALSE.
c
c	      IF (.NOT.memb_true_month) EXIT TMLOOP ! from loop
c
c	      nsteps_trumon = nsteps_trumon + nsteps
c	      coord_hi = line_start(taxis) + (nsteps_trumon-1)* line_delta(taxis)
c
c* Translate fake true-month timestep to actual month-length step.
c
c	      CALL TM_TCOORD_TRUMONTH (taxis, coord_hi,  
c     .		       box_middle, coord_new)
c
c	      memb_order(ifile) = ifile
c	      memb_nsteps(ifile) = nsteps
c	      memb_tstep_start(ifile) = start
c	      memb_tstep_end(ifile) = coord_new
c
c	      line_dim(taxis) = nsteps_trumon
c	      t_regular = .TRUE.
c	  
c	   ENDDO TMLOOP
c
c* ... If some month isn't a true-mnth axis, then we will not use a true-month axis.
c*     Get the original coordinates from the first member set and continue.
c
c	   IF (true_month .AND. .NOT.memb_true_month) THEN
c	   
c	      t_regular = .FALSE.
c	      ifile = 1
c	      CALL CD_QUIK_NCOPEN (dset_num, memb_filename(ifile),
c     .				      vname(:vlen),
c     .				      cdfid, vid, bounds_id,
c     .				      units_str, calendar_str,
c     .				      nsteps, TMAP_status)
c	      IF (TMAP_status .NE. merr_ok) GOTO 5010
c* ... check to see if calendar, units, and T0 are consistent with the agg axis
c	      CALL CD_GET_T0(memb_filename(ifile), units_str, calendar_str,
c     .                  agg_cal_id, file_unit_code, file_t0_str, status)
c
c* ... read the array of time steps from the file
c	      CALL CD_RD_R8_ARR(cdfid, vid,1, nsteps,dtype,vname(:vlen),
c     .				   line_mem(isubsc1), status)
c	      line_regular(taxis) = .FALSE.
c	      line_unit_code(taxis) = file_unit_code
c	      agg_unit_code = file_unit_code
c	      line_delta(taxis) = unspecified_val8
c
c	      IF (bounds_id .NE. unspecified_int4) THEN
c
c	         startpts(1) = 1
c	         startpts(2) = 1
c	         numpts(1) = 1
c	         numpts(2) = nsteps
c
c	         d1s = startpts(1)
c	         d1e = numpts(1)
c	         d2s = startpts(2)
c	         d2e = numpts(2)
c		 bname = 'bounds array'
c		 blen = 12
c
c		 CALL CD_RD_R8_BNDS( cdfid, bounds_id,
c     .			  startpts, numpts, dtype, bname(:blen),
c     .                    line_mem(isubsc1+nsteps),  
c     .                    d1s, d1e, d2s, d2e, status )
c	      ELSE
c	         CALL TM_IRREGAX_MID( isubsc1,isubsc1 )
c	      ENDIF
c
c	      true_month = .FALSE.
c	   ENDIF
c
c	ENDIF  ! true_month

* Do some of the member sets need bounds?  If so then get them for all sets.
c	IF (.NOT.t_regular .AND. line_regular(taxis)) THEN
c	   need_midpoints = .TRUE.
c	   DO ifile = 1, nagfiles
c	      CALL CD_QUIK_NCOPEN (dset_num, memb_filename(ifile),
c     .				      vname(:vlen),
c     .				      cdfid, vid, bounds_id,
c     .				      units_str, calendar_str,
c     .				      nsteps, TMAP_status)
c	      IF (bounds_id .NE. unspecified_int4) need_midpoints = .FALSE.
c
c	   ENDDO
c	   IF (.NOT. need_midpoints) THEN  ! fill in coordinats and bounds for first member set
c	      hdel = line_delta(taxis)/2.
c	      DO istep = 0, nsteps-1
c	         line_mem(next_line_mem_pos+istep) = line_start(taxis)
c     .		+ istep*line_delta(taxis)
c	         line_mem(next_line_mem_pos+nsteps+istep) = 
c     .		    line_mem(next_line_mem_pos+istep) - hdel
c	         line_mem(next_line_mem_pos+nsteps+istep+1) = 
c     .		    line_mem(next_line_mem_pos+istep) + hdel
c	      ENDDO
c	   ENDIF
c	ENDIF

* set up for a regular or irregular T-agg axis as requested by t_regular
	IF (t_regular .AND. .NOT.line_regular(taxis)) THEN
	   CALL WARN('/T_REGULAR NOT YET IMPLEMENTED')
! T_REGULAR HAS NEVER BEEN TESTED
!* ... convert the irregular t axis of 1st file into a forced-regular axis
!	   line_start(taxis) = line_mem(line_subsc1(taxis))
!	   line_regular(taxis) = .TRUE.
!* !! TODO: WE SHOULD REALLY GARBAGE COLLECT THE ABANDONED SPACE OCCUPIED BY
!*          THE IRREGULAR COORDINATES OF THE FIRST FILE IN THE T-AGG
!*          SEE PACK_LINE_STORAGE
!* quik garb collect if T-axis happens to be the last one in memory
!	   IF (next_line_mem_pos .EQ. line_subsc1(taxis) + nsteps) THEN
!	      next_line_mem_pos = line_subsc1(taxis) ! ouch! orphan some coords
!	      line_subsc1(taxis) =  unspecified_int4
!	   ENDIF
	ELSEIF (.NOT.t_regular .AND. line_regular(taxis)) THEN
* ... convert the so-far regular 1st file axis into a forced-irregular axis
	   IF (next_line_mem_pos+2*line_dim(taxis)+1
     .					.GT.maxlinestore) GOTO 5100
	   line_regular(taxis) = .FALSE.
	   line_subsc1(taxis) = next_line_mem_pos
	   DO istep = 0, nsteps-1
	      line_mem(next_line_mem_pos+istep) = line_start(taxis)
     .		+ istep*line_delta(taxis)
	   ENDDO
	   line_delta(taxis) = unspecified_val8
	   need_midpoints = .TRUE.
	ELSEIF (.NOT.t_regular .AND. .NOT.line_regular(taxis)) THEN
* ... make sure this axis is the last one currently stored in line_mem
	   IF (next_line_mem_pos .GT. line_subsc1(taxis) + 2*nsteps + 1)
     .								THEN
* !! TODO: WE SHOULD REALLY GARBAGE COLLECT THE ABANDONED SPACE OCCUPIED BY
*          THE ORIGINAL IRREGULAR COORDINATES OF THE FIRST FILE IN THE T-AGG
*          SEE PACK_LINE_STORAGE
* ... copy the time steps and bounds from the first file to the top
	      DO istep = 0, 2*nsteps
	         line_mem(next_line_mem_pos+istep)
     .	                            = line_mem(line_subsc1(taxis)+istep)
	      ENDDO
	      line_subsc1(taxis) = next_line_mem_pos
	   ENDIF
* ... copy the cell boundaries to high memory in reversed order
	   max_line_available = max_line_available - nsteps
	   ilo = line_subsc1(taxis) + nsteps
	   ihi = max_line_available + nsteps
	   DO istep = 0, nsteps
	      line_mem(ihi) = line_mem(ilo)
	      ilo = ilo+1
	      ihi = ihi-1
	   ENDDO

	ENDIF

**************
* Loop through the files of the aggregation, appending time step values.
* Different logic applies if the caller passed in the time axis metadata.
* Because the length of the aggregated T axis is not in general known until
* all of the aggregated files have been consulted, we cannot put the cell
* boundaries in their usual place immediately following the cell positions.
* Instead we temporarily locate the irregular cell boundaries at the *top*
* of the line_mem array working backwards, copying them into their proper
* position after the cell marker coordinates are all in place.

	IF (memb_nsteps(1) .NE. unspecified_int4) THEN

!!!!! THIS LOGIC HAS NOT BEEN TESTED -- INTENDED FOR PYTHON INTERFACE

***
* time metadata has been provided by caller (i.e. python program)
* note that the metadata of the first file is ignored since already read
* directly from the file, itself
	   IF (t_regular) THEN
	      CONTINUE
!	      highest_tstep = line_start(taxis)
!     .			    + line_dim(taxis)*line_delta(taxis)
!	      DO ifile = 2, nagfiles
!	         highest_tstep = memb_tstep_end(ifile)
!	         line_dim(taxis) = line_dim(taxis) + memb_nsteps(ifile)
!	      ENDDO
	   ELSE
	      DO ifile = 2, nagfiles
	         line_dim(taxis) = line_dim(taxis) + memb_nsteps(ifile)
	         IF (next_line_mem_pos+line_dim(taxis)+memb_nsteps(ifile)
     .			.GT.maxlinestore)			GOTO 5100
	         IF (memb_nsteps(ifile) .GT. 1 ) THEN
	            delta = (memb_tstep_end(ifile) - memb_tstep_start(ifile))
     .		       / (memb_nsteps(ifile)-1)
	         ELSE
	            delta = 0.0
	         ENDIF
	         DO istep = 0, memb_nsteps(ifile)-1
	            line_mem(next_line_mem_pos+line_dim(taxis)+istep) 
     .		         = memb_tstep_start(ifile) + delta*istep
	         ENDDO
	         line_dim(taxis) = line_dim(taxis) + memb_nsteps(ifile)
	      ENDDO
	      need_midpoints = .TRUE.
	   ENDIF
	ELSE


***
* time metadata has not been provided - we must read it from the files
* insert the metadata of the first file (so far opened as netCDF dataset)
	   memb_nsteps     (1) = nsteps
	   memb_tstep_start(1) = TM_WORLD_AX(1,     taxis,box_middle) 
	   memb_tstep_end  (1) = TM_WORLD_AX(nsteps,taxis,box_middle) 

	   IF (t_regular) THEN
	      CALL WARN('/T_REGULAR NOT YET IMPLEMENTED')
!	      highest_tstep = line_start(taxis)
!     .			    + line_dim(taxis)*line_delta(taxis)
!	      DO ifile = 2, nagfiles
!* ... read the length of the time axis from the file to be aggregated
!	         CALL CD_QUIK_NCOPEN (dset_num, memb_filename(ifile),
!     .				      vname(:vlen),
!     .				      cdfid, vid, bounds_id,
!     .				      units_str, calendar_str,
!     .				      nsteps, TMAP_status)
!	         IF (TMAP_status .NE. merr_ok) GOTO 5010
!* user gives /T_REGULAR as a promise of file compatibility, so no checking
!* of units and calendar attributes
!	         memb_nsteps(ifile) = nsteps
!* ... read the first and last time step values from the axis
!! it's faster to compute the first and last than to read them
!! reading last, anyway, so that if the promise of regular points is a lie
!! at least the range of the time axis will be correct
!!	         CALL CD_RD_R8_1(cdfid, vid,     1,dtype,vname(:vlen),
!!     .                           memb_tstep_start(ifile), status )
!!	         IF ( status .NE. merr_ok ) GOTO 5010
!	         CALL CD_RD_R8_1(cdfid, vid,nsteps,dtype,vname(:vlen),
!     .                           memb_tstep_end(ifile),   status )
!	         IF ( status .NE. merr_ok ) GOTO 5010	         
!	         line_dim(taxis) = line_dim(taxis) + nsteps
!	         highest_tstep = memb_tstep_end(ifile)
!	         line_delta(taxis) = (highest_tstep - line_start(taxis))
!     .				   /(line_dim(taxis) - 1)
!	         memb_tstep_start(ifile) = highest_tstep
!     .				       - (nsteps-1)*line_delta(taxis)
!	         CALL CD_CLOSE_SET ( cdfid, status)
!	         IF ( status .NE. merr_ok ) GOTO 5010
!	      ENDDO
	   ELSE
	      DO ifile = 2, nagfiles
* ... first read the length of the time axis from the file to be aggregated
	         CALL CD_QUIK_NCOPEN (dset_num, memb_filename(ifile),
     .				      vname(:vlen),
     .				      cdfid, vid, bounds_id,
     .				      units_str, calendar_str,
     .				      nsteps, TMAP_status)
	         IF (TMAP_status .NE. merr_ok) GOTO 5010
* ... check to see if calendar, units, and T0 are consistent with the agg axis
	         CALL CD_GET_T0(memb_filename(ifile), units_str, calendar_str,
     .                  agg_cal_id, file_unit_code, file_t0_str, status)
	         need_T0_adjust = (file_unit_code .NE. agg_unit_code)
     .			     .OR. (file_T0_str    .NE. agg_T0_str)
	         IF (need_t0_adjust) CALL T0_ADJUST_INIT ( agg_cal_id,
     .				          file_unit_code, file_t0_str,
     .					  agg_unit_code,  agg_t0_str, status )
	         memb_nsteps(ifile) = nsteps
	         max_line_available = max_line_available-(nsteps+1) ! n+1 edges
	         IF (next_line_mem_pos+line_dim(taxis)+nsteps
     .			.GT.max_line_available)			GOTO 5100
* ... read the array of time steps from the file
	         isubsc1 = line_subsc1(taxis)+line_dim(taxis)
	         CALL CD_RD_R8_ARR(cdfid, vid,1, nsteps,dtype,vname(:vlen),
     .				   line_mem(isubsc1), status)
	         IF ( status .NE. merr_ok ) GOTO 5010



* ... adjust the time step values to the agg-chosen "<units> since <T0>"
	         IF (need_T0_adjust) THEN
	            DO istep = isubsc1, isubsc1+nsteps-1
	               line_mem(istep) = T0_ADJUST(line_mem(istep))
	            ENDDO
	         ENDIF

	         line_dim(taxis) = line_dim(taxis) + nsteps
	         memb_tstep_start(ifile) = line_mem(isubsc1)
	         memb_tstep_end  (ifile) = line_mem(isubsc1+nsteps-1)

	         IF (bounds_id .EQ. unspecified_int4) THEN
* ... cell boundaries NOT available in this file
*     if not available in any one file, they aare effectively missing
	            need_midpoints = .TRUE.

	         ELSEIF (.NOT. need_midpoints) THEN
* ... cell boundaries ARE available in this file
*     store them in high line memory, backwards ordered
	            bname = 'bounds array'
                    blen = 12
*     in CF the bounds are stored 2D Nx2, whereas in Ferret they are simply N+1
*     so two reads are needed
*       read #1) the lower bound array and 
*       read #2) the topmost upper bound (a single point)
*     the cells are *assumed* to be contiguous -- no checking done

*     #1) read the lower box bound values (nsteps values)
                    startpts(1) = 1
                    startpts(2) = 1
                    numpts(1) = 1
                    numpts(2) = nsteps

                    d1s = startpts(1)
                    d1e = numpts(1)
                    d2s = startpts(2)
                    d2e = numpts(2)

                    CALL CD_RD_R8_BNDS( cdfid, bounds_id,
     .			  startpts, numpts, dtype, bname(:blen),
     .                    line_mem(max_line_available),  
     .                    d1s, d1e, d2s, d2e, status )
                    IF ( status .NE. merr_ok ) GOTO 5010

*     #2) read the highest upper box bound value (a single value)
                    startpts(1) = 2
                    startpts(2) = nsteps
                    numpts(1) = 1
                    numpts(2) = 1

                    d1s = startpts(1)
                    d1e = numpts(1)
                    d2s = startpts(2)
                    d2e = numpts(2)

                    CALL CD_RD_R8_BNDS( cdfid, bounds_id,
     .			  startpts, numpts, dtype,  bname(:blen),
     .                    line_mem(max_line_available+nsteps),  
     .                    d1s, d1e, d2s, d2e, status )
                    IF ( status .NE. merr_ok ) GOTO 5010

* ... reorder the newest nstep+1 bounds values into backwards order,
*     ensuring one pass through the loop for single-step axis
	            DO istep = 0, MAX(0,nsteps/2-1)

	               ilo = max_line_available+istep
	               ihi = max_line_available+nsteps-istep
	               tt = line_mem(ilo)
	               line_mem(ilo) = line_mem(ihi)
	               line_mem(ihi) = tt
	            ENDDO

* ... adjust the bounds values to the agg-wide "<units> since <T0>"
	            IF (need_T0_adjust) THEN
	               DO istep = max_line_available, max_line_available+nsteps
	                  line_mem(istep) = T0_ADJUST(line_mem(istep))
	               ENDDO
	            ENDIF
	         ENDIF
	         CALL CD_CLOSE_SET ( cdfid, status)
	         IF ( status .NE. merr_ok ) GOTO 5010
	      ENDDO    ! end of member file loop
	   ENDIF
	ENDIF
	nsteps = line_dim(taxis)   ! length of aggregated axis

****** START: check over and finalize the aggregation time axis
	IF (.NOT.t_regular) THEN

	   IF (.NOT.need_midpoints) THEN
* explicit cell boundaries have been stored in high line_mem indices
* note that instead of nsteps+1 edges, at this point we have nsteps+nagfiles
* because each member file has contributed both a low and a hgh edge
* we have held onto the extra points because the member order may be re-sorted
*   1. reorder the cell bounds back to forwards order
*   2. move the cell bounds from temporary storage to their normal position

* ... 1. reorder the bounds to forward order
	      ilo = max_line_available
	      ihi = ilo + nsteps + nagfiles - 1
	      DO istep = 0, (nsteps+nagfiles)/2
	         tt = line_mem(ilo)
	         line_mem(ilo) = line_mem(ihi)
	         line_mem(ihi) = tt
	         ilo = ilo + 1
	         ihi = ihi - 1
	         IF (ihi .LT. ilo) EXIT  ! exit loop; 1-point axes casuses this
	      ENDDO

* ... 2. shift the bounds down to sit just after the coordinates
	      ilo = line_subsc1(taxis) + nsteps
	      ihi = max_line_available
	      DO istep = 0, nsteps+nagfiles-1
	         line_mem(ilo) = line_mem(ihi)
	         line_mem(ihi) = bad_val4        ! for good house-keeping
	         ilo = ilo + 1
	         ihi = ihi + 1
	      ENDDO
	   ENDIF

* if the fileas as provided were out of order, then sort them here
* sort the time coordinates and bounds in line_mem to match the sort order
	   CALL SORT_TSERIES_DSETS(nagfiles, nsteps, need_midpoints, 
     .				   memb_nsteps, memb_order,
     .				   line_mem(line_subsc1(taxis)),
     .				   line_mem(line_subsc1(taxis)+nsteps) )

* deal with cell boundaries
	   next_line_mem_pos =  next_line_mem_pos + 2*nsteps + 1

* ... compute time midpoints if not supplied
	   IF (need_midpoints) THEN
	      IF (line_subsc1(taxis)+2*nsteps+1.GT.maxlinestore) GOTO 5100
	      CALL TM_IRREGAX_MID(line_subsc1(taxis), nsteps)

	   ELSE

* remove the duplicated cell edges: top of file k duplicates bottom of file k+1
*    istep counts time steps in the aggregated time axis 
*    ifile counts the member files
*    imemb counts the time step in the member current file

	      ilo = line_subsc1(taxis) + nsteps
	      i = 1
	      ifile = memb_order(i)
	      imemb = memb_nsteps(ifile) ! start at top of first file
	      istep = imemb
	      DO WHILE (istep .LE. nsteps)
	         istep = istep + 1
	         imemb = imemb + 1
	         IF (imemb .GT. memb_nsteps(ifile)) THEN
*     ... start of next member file
*     ... skipping the top cell edge of each file
	            i = i + 1
	            IF (i .LE. nagfiles) ifile = memb_order(i)
	            imemb = 1
	         ENDIF
	         l = ilo + istep
	         line_mem(l) = line_mem(l+i-1)
	      ENDDO
* ... copy (dont skip) the upper edge of the aggregate axis
	      line_mem(l+1) = line_mem(l+i)
	   ENDIF

* if the coordinates have been saved as irregular we must now
*  check to see if the coords may be regular after all

*  ... first sanity check monotonicity and bounds bracketing
	   IF (nsteps.EQ.1) GOTO 100
	   ilo = line_subsc1(taxis)    ! L step on agg taxis
	   ihi = ilo + nsteps - 1
           dfirst_delta = line_mem(ilo+1) - line_mem(ilo)
           depsilon = depsilon_46 * 2.*(ABS(line_mem(ilo))
     .		    / dfirst_delta )
	   DO i = 1, nagfiles
	      ifile = memb_order(i)
	      DO l = 1, memb_nsteps(ifile)  ! timestep within memer files
	         IF (i.EQ.1 .AND. l.EQ.1) THEN 
	            CYCLE       ! 1st point on axis		
	         ELSE
	            ilo = ilo + 1
	            tt  = line_mem(ilo)
	            IF (tt .LE. line_mem(ilo-1))	 GOTO 5300
	            IF (tt .LT. line_mem(ilo+nsteps)) GOTO 5400 ! lo bnd chk
	         ENDIF
	      ENDDO
	   ENDDO
	   ifile = memb_order(nagfiles)  ! for error message
	   IF (tt .GT. line_mem(ilo+nsteps+1))	 GOTO 5400 ! hi bnd chk

*   check regularity of cell positions 
	   ilo = line_subsc1(taxis)
	   DO istep = 1, nsteps-1
	      ilo = ilo + 1
	      delta = line_mem(ilo) - line_mem(ilo-1)
	      IF (.NOT.TM_DFPEQ_TOL(dfirst_delta, delta, depsilon) )
     .								GOTO 200
	   ENDDO

*   check regularity of cell bounds
	   ilo = line_subsc1(taxis) + nsteps   ! lower cell bound of 1st pt
	   DO istep = ilo, ilo+nsteps-1	
	      delta = line_mem(istep+1) - line_mem(istep)
	      IF (.NOT. TM_DFPEQ_TOL(dfirst_delta, delta, depsilon) )
     .								GOTO 200
	   ENDDO

* It's regular after all!  - change from irregular designation
 100	   CONTINUE
	   ilo = line_subsc1(taxis)
	   ihi = ilo + nsteps - 1
	   line_regular(taxis) = .TRUE.
	   line_start  (taxis) = line_mem(ilo)
	   IF (nsteps .GT. 1) THEN   
	      line_delta(taxis) = (line_mem(ihi)-line_mem(ilo))/(nsteps-1)
	   ELSE
	      line_delta(taxis) = 1.0   ! arbitrary
	   ENDIF
	   line_subsc1 (taxis) = unspecified_int4
	   next_line_mem_pos =  next_line_mem_pos - (2*nsteps + 1) ! restore
	ENDIF
****** END: check over and finalize the time axis

* does this new time axis match an existing one?
 200	pre_exist = TM_FIND_LIKE_DYN_LINE( taxis )
	swap_axes = pre_exist .NE. unspecified_int4
	IF (swap_axes) ds_time_axis(dset_num) = pre_exist

* correct all time-dependent variables in this dataset
*  ... the upper L limit was set based upon the first file, alone
*  ... and the time axis might just have been swapped for a pre-existing one
*      (ticket 2507, do not wipe out info needed for further grids once the
*       first grid found has its axis swapped.)

	DO ivar = 1, maxvars
	   IF ( ds_var_setnum(ivar) .EQ. dset_num ) THEN
	      gg  = ds_grid_number(ivar)
	      IF (grid_line(t_dim,gg).EQ.taxis .OR. grid_line(t_dim,gg).EQ.pre_exist) THEN
	         ds_grid_end(t_dim,ivar) = nsteps
	         IF (swap_axes) THEN
* ... was this grid modified in this loop an instant ago?
*     note: Shoud use the dset var LIST!   Super-inefficient nested loop
	            DO i = 1, ivar-1
	               IF ( ds_var_setnum(i) .EQ. dset_num ) THEN
	                  IF (ds_grid_number(i) .EQ. gg) GOTO 500 !already done
	               ENDIF
	            ENDDO
	            grid_line(t_dim,gg) = pre_exist
* ... "use" the pre-existing one; "un-use" the new one
	            CALL TM_USE_LINE(pre_exist)
	            CALL TM_DEALLO_DYN_LINE(taxis)
	            ds_time_axis(dset_num) = pre_exist
	         ENDIF
	      ENDIF
	   ENDIF
 500	   CONTINUE
	ENDDO
	IF (swap_axes) taxis = pre_exist

* Is the axis we have created a monthly axis?  IF so store it as such.

c	IF (.NOT. true_month .AND. .NOT.line_regular(taxis)) THEN
c	   CALL TM_CHECK_MONTHLY_AXIS (line_mem( line_subsc1(taxis)), line_dim(taxis), agg_cal_id, 
c     .                                   agg_T0_str, agg_unit_code, units_str,
c     .                                   start, delta, tunit, true_month)
c           IF (true_month) THEN
c              line_regular(taxis) = .TRUE.
c              line_start  (taxis) = start
c              line_delta  (taxis) = delta
c              line_subsc1 (taxis) = unspecified_int4
c	      line_unit_code (taxis) = agg_unit_code
c	      line_units (taxis) = units_str
c              line_tunit  (taxis) = un_convert(agg_unit_code)
c	   ENDIF
c	ENDIF
c

 5000	RETURN
 5010	CALL ERRMSG( ferr_TMAP_error, status, ' ', *5000 )
 5050	CALL ERRMSG( ferr_grid_definition, status,
     .		'first file of aggregation has no time axis '
     .		//memb_filename(1), *5000 )
 5100	CALL ERRMSG(ferr_insuff_memory,status,
     .	        'unable to define T aggregation axis', *5000)
 5200	CALL ERRMSG(ferr_internal, status, 'define_ef_aggregate_grid!',
     .		 *5000)
 5300	lname = LEFINT(l, blen)
	CALL ERRMSG( ferr_grid_definition, status,
     .		'time axis is not monotonic at L='
     .		//lname(:blen)//' of file '//memb_filename(ifile), *5000 )
 5400	lname = LEFINT(l, blen)
	CALL ERRMSG( ferr_grid_definition, status,
     .   'Time bounds do not enclose time step coordinate at L='
     .		//lname(:blen)//' of file '//memb_filename(ifile), *5000 )

	END

	 SUBROUTINE LOAD_CURVILINEAR( xpos, ypos, dim1, dim2, argx_pos,
     .				     edges_ok, mr_xpos, mr_ypos,
     .				     cx_xpos, cx_ypos, cx_val, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* save the dimensioning information about the X position and Y position
* arrays so these arrays will be accessible from inside of PLOT+ routines.
* A C subroutine will be used to cache the pointers to these 2 arrays.
* COMMON will be used to store the size/shape information.

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V450: 3/97
* V541:  2/02 *sh - allow for subspan modulo axes
* V612: 7/08 *acm*  Fix bug 1589; see if the units of the coordinates are degrees
*                   and set a flag.
* V63   9/09 *acm* Fix bug 1688: curvlinear plots when the curv. coords are NOT
*                  longitude and latitude.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V687 *acm* 3/14  Ticket 2147: Need double-precision bad-values for coordinate variables 

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xtext_info.cmn'
	include 'xcurvilinear.cmn'

* calling argument declarations:
	LOGICAL	edges_ok
	REAL	xpos(*), ypos(*)
	INTEGER	argx_pos, dim1, dim2,
     .		mr_xpos, mr_ypos, cx_xpos, cx_ypos, cx_val, status

* internal variable declarations:
	LOGICAL ITSA_MODULO_AXIS, ITSA_MODULO_CURVI_AXIS, TM_HAS_STRING,
     .		xspan_n_dim1, xspan_n_dim2,
     .		yspan_n_dim1, yspan_n_dim2,
     .		xspan_np1_dim1, xspan_np1_dim2,
     .		yspan_np1_dim1, yspan_np1_dim2

	INTEGER	CAXIS_MODLEN, STR_SAME,
     .		dim, x1span, x2span, y1span, y2span,
     .          span_dim1, span_dim2, i1, i2, i3
	CHARACTER*1	fieldname
	CHARACTER*64	VAR_UNITS, xcoord_units

* missing value flags
	badx = mr_bad_data(mr_xpos)
	bady = mr_bad_data(mr_ypos)
	badxcurv = mr_bad_data(mr_xpos)
	badycurv = mr_bad_data(mr_ypos)

* subscript limits
	minss_dim1 = cx_lo_ss(cx_val,dim1)
	maxss_dim1 = cx_hi_ss(cx_val,dim1)
	minss_dim2 = cx_lo_ss(cx_val,dim2)
	maxss_dim2 = cx_hi_ss(cx_val,dim2)

* subscript ranges to be used for dimensioning the arguments
	xpos_loss_dim1 = mr_lo_ss(mr_xpos,dim1)
	xpos_hiss_dim1 = mr_hi_ss(mr_xpos,dim1)
	xpos_loss_dim2 = mr_lo_ss(mr_xpos,dim2)
	xpos_hiss_dim2 = mr_hi_ss(mr_xpos,dim2)
	ypos_loss_dim1 = mr_lo_ss(mr_ypos,dim1)
	ypos_hiss_dim1 = mr_hi_ss(mr_ypos,dim1)
	ypos_loss_dim2 = mr_lo_ss(mr_ypos,dim2)
	ypos_hiss_dim2 = mr_hi_ss(mr_ypos,dim2)

* offsets for start indices relative to the "values" argument indices
	xpos_off0_dim1 = cx_lo_ss(cx_xpos,dim1) - cx_lo_ss(cx_val,dim1)
	xpos_off0_dim2 = cx_lo_ss(cx_xpos,dim2) - cx_lo_ss(cx_val,dim2)
	ypos_off0_dim1 = cx_lo_ss(cx_ypos,dim1) - cx_lo_ss(cx_val,dim1)
	ypos_off0_dim2 = cx_lo_ss(cx_ypos,dim2) - cx_lo_ss(cx_val,dim2)

* determine which axes are represented as only a single point
* and which have N+1 points
	span_dim1 = cx_hi_ss(cx_val,dim1) - cx_lo_ss(cx_val,dim1) + 1
	span_dim2 = cx_hi_ss(cx_val,dim2) - cx_lo_ss(cx_val,dim2) + 1

	x1span  = cx_hi_ss(cx_xpos,dim1) - cx_lo_ss(cx_xpos,dim1) + 1
	x2span  = cx_hi_ss(cx_xpos,dim2) - cx_lo_ss(cx_xpos,dim2) + 1
	y1span  = cx_hi_ss(cx_ypos,dim1) - cx_lo_ss(cx_ypos,dim1) + 1
	y2span  = cx_hi_ss(cx_ypos,dim2) - cx_lo_ss(cx_ypos,dim2) + 1

	xspan_1_dim1   = x1span .EQ. 1
	xspan_1_dim2   = x2span .EQ. 1
	yspan_1_dim1   = y1span .EQ. 1
	yspan_1_dim2   = y2span .EQ. 1

	xspan_n_dim1 = x1span .EQ. span_dim1
	xspan_n_dim2 = x2span .EQ. span_dim2
	yspan_n_dim1 = y1span .EQ. span_dim1
	yspan_n_dim2 = y2span .EQ. span_dim2

	xspan_np1_dim1 = .NOT.(xspan_1_dim1 .OR. xspan_n_dim1)
	xspan_np1_dim2 = .NOT.(xspan_1_dim2 .OR. xspan_n_dim2)
	yspan_np1_dim1 = .NOT.(yspan_1_dim1 .OR. yspan_n_dim1)
	yspan_np1_dim2 = .NOT.(yspan_1_dim2 .OR. yspan_n_dim2)

* check for mismatched array sizes
* ... only sizes of 1, N, or N+1 are allowed
	IF (xspan_np1_dim1) THEN
	   IF (x1span .NE. span_dim1+1) THEN
	      dim = dim1
	      fieldname = 'X'
	      GOTO 5100
	   ENDIF
	ENDIF
	IF (yspan_np1_dim1) THEN
	   IF (y1span .NE. span_dim1+1) THEN
	      dim = dim1
	      fieldname = 'Y'
	      GOTO 5100
	   ENDIF
	ENDIF
	IF (xspan_np1_dim2) THEN
	   IF (x2span .NE. span_dim2+1) THEN
	      dim = dim2
	      fieldname = 'X'
	      GOTO 5100
	   ENDIF
	ENDIF
	IF (yspan_np1_dim2) THEN
	   IF (y2span .NE. span_dim2+1) THEN
	      dim = dim2
	      fieldname = 'Y'
	      GOTO 5100
	   ENDIF
	ENDIF
* ... cannot mix size of N+1 with size of N 
	IF (xspan_np1_dim1 .AND. yspan_n_dim1
     . .OR. yspan_np1_dim1 .AND. xspan_n_dim1
     . .OR. xspan_np1_dim2 .AND. yspan_n_dim2
     . .OR. yspan_np1_dim2 .AND. xspan_n_dim2) GOTO 5200

* have we been given grid box edges or grid points? 
	dim1_edges = xspan_np1_dim1 .OR. yspan_np1_dim1
	dim2_edges = xspan_np1_dim2 .OR. yspan_np1_dim2
	IF (.NOT.edges_ok) THEN
	   dim = dim1
	   IF (dim1_edges) GOTO 5300
	   dim = dim2
	   IF (dim2_edges) GOTO 5300
	ENDIF


* Have we been given modulo-able fields
* ... Both fields must agree that a dimension is modulo in order to honor it
* ... A dimension of length 1 (delta=0) is automatically modulo
	dim1_modulo = ITSA_MODULO_AXIS(cx_val,dim1)
	IF ( dim1_modulo ) THEN
	   dim1_modulo = (xspan_1_dim1
     .		     .OR. x1span .EQ. CAXIS_MODLEN(dim1,cx_xpos))
     .		.AND.
     .		         (yspan_1_dim1
     .		     .OR. y1span .EQ. CAXIS_MODLEN(dim1,cx_ypos))
     .		.AND.
     .		         ITSA_MODULO_CURVI_AXIS(xpos,ypos,mr_xpos,mr_ypos,1,
     .		             dim1, dim2)
	ENDIF

	dim2_modulo = ITSA_MODULO_AXIS(cx_val,dim2)
	IF ( dim2_modulo ) THEN
	   dim2_modulo = (xspan_1_dim2
     .		     .OR. x2span .EQ. CAXIS_MODLEN(dim2,cx_xpos))
     .		.AND.
     .		         (yspan_1_dim2
     .		     .OR. y2span .EQ. CAXIS_MODLEN(dim2,cx_ypos))
     .		.AND.
     .		         ITSA_MODULO_CURVI_AXIS(xpos,ypos,mr_xpos,mr_ypos,2,
     .		             dim1, dim2)
	ENDIF

* See what the units of the curvi coordinate fields are. Set a flag if the
* x coordinates are degrees.

        units_degrees = .FALSE.
        xcoord_units = VAR_UNITS (cx_xpos)
        IF  (TM_HAS_STRING(xcoord_units,'lon') .OR.
     .       TM_HAS_STRING(xcoord_units,'deg') ) 
     .       units_degrees = .TRUE.

* save the memory pointers to the arrays, themselves
	CALL SAVE_ARG_POINTERS( xpos, ypos )

* successful completion
	status = ferr_ok
	RETURN

* error exit
 5000	RETURN
 5100	CALL ERRMSG( ferr_inconsist_plane, status,
     .		ww_dim_name(dim)//' axis of '//fieldname
     .		//' position array', *5000 )
 5200	CALL ERRMSG( ferr_inconsist_plane, status,
     .		ww_dim_name(dim)//' axis of X and Y'
     .		//' position arrays', *5000 )
 5300	CALL ERRMSG( ferr_inconsist_plane, status,
     .		'box edges (on '//ww_dim_name(dim)//' axis)'//pCR//
     .		 'allowed only with SHADE', *5000 )

	END

      BLOCK DATA BIBO5
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)bibo5.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
CC  DEFINITION OF INDEXES USED FOR BIBO HEADER FORMAT
C
      INTEGER NPTS,MIN,MAX,MEAN,PROJ,MOOR
      INTEGER INST,DTYPE,STIME,SRATE,SLAT,SLON
      INTEGER SDEP,INDEP,IADEP,FILT,CUTLO,CUTHI
      INTEGER WIND,SIG,HEAD,SCODE,PCODE,MODEN 
      INTEGER SPTIME
      COMMON /BIBO/ NPTS,MIN,MAX,MEAN,PROJ,MOOR
      COMMON /BIBO/ INST,DTYPE,STIME,SRATE,SLAT,SLON
      COMMON /BIBO/ SDEP,INDEP,IADEP,FILT,CUTLO,CUTHI
      COMMON /BIBO/ WIND,SIG,HEAD,SCODE,PCODE,MODEN
      COMMON /BIBO/ SPTIME
      DATA NPTS,MIN,MAX,MEAN,PROJ,MOOR /1,2,3,4,5,6/
      DATA INST,DTYPE,STIME,SRATE,SLAT,SLON /8,10,11,14,15,16/
      DATA SDEP,INDEP,IADEP,FILT,CUTLO,CUTHI /17,18,19,20,21,22/
      DATA WIND,SIG,HEAD,SCODE,PCODE,MODEN /23,24,25,131,132,133/
      DATA SPTIME/136/
      END
      BLOCK DATA TBLES

      COMMON /TBLE/PTAB(8,4),DTTAB(8,29),FTTAB(8,9),WTTAB(8,11)
      COMMON /TBLE/STTAB(8,19),PCTAB(8,5),UNIT(4,15)

      COMMON /NTBLE/NPTAB,NDTTAB,NFTTAB,NWTTAB
      COMMON /NTBLE/NSTTAB,NPCTAB,NUNIT

      DATA PTAB
     *   /2.0,0.0,4HCUE-,4HII  ,4H    ,4H    ,4H    ,4H    ,
     1    3.0,0.0,4HSUPE,4HR CO,4HDE  ,4H    ,4H    ,4H    ,
     2    4.0,0.0,4HCODE,4H    ,4H    ,4H    ,4H    ,4H    ,
     3    6.0,0.0,4HSLEE,4HP   ,4H    ,4H    ,4H    ,4H    /
      DATA DTTAB
     1   /20.0,6.0,4H    ,4HATMO,4HSPHE,4HRIC ,4HPRES,4HSURE,
     2    12.0,2.0,4H    ,4H  MA,4HJOR ,4HAXIS,4H CUR,4HRENT,
     3    13.0,2.0,4H    ,4H  MI,4HNOR ,4HAXIS,4H CUR,4HRENT,
     4    14.0,2.0,4H    ,4H  AL,4HONGS,4HHORE,4H CUR,4HRENT,
     5    15.0,2.0,4H    ,4H CRO,4HSS-S,4HHORE,4H CUR,4HRENT,
     6    26.0,8.0,4H    ,4H    ,4H WIN,4HD U ,4HVELO,4HCITY,
     7    27.0,8.0,4H    ,4H    ,4H WIN,4HD V ,4HVELO,4HCITY,
     8    28.0,7.0,4H    ,4H    ,4H    ,4H    ,4H   T,4HAU X,
     9    29.0,7.0,4H    ,4H    ,4H    ,4H    ,4H   T,4HAU Y,
     *    30.0,9.0,4H    ,4H    ,4H    ,4H   S,4HEA L,4HEVEL,
     1    31.0,1.0,4H    ,4HDRY ,4HBULB,4H TEM,4HPERA,4HTURE,
     2    16.0,8.0,4H    ,4H    ,4H MAJ,4HOR A,4HXIS ,4HWIND,
     3    35.0,1.0,4H    ,4H    ,4H    ,4H TEM,4HPERA,4HTURE,
     4    36.0,2.0,4H    ,4H    ,4H    ,4H  U ,4HVELO,4HCITY,
     5    37.0,2.0,4H    ,4H    ,4H    ,4H  V ,4HVELO,4HCITY,
     6    38.0,3.0,4H    ,4H    ,4H    ,4H    ,4HPRES,4HSURE,
     7    17.0,8.0,4H    ,4H    ,4H MIN,4HOR A,4HXIS ,4HWIND,
     8    43.0,10.,4H    ,4H    ,4H    ,4HCOND,4HUCTI,4HVITY,
     9    18.0,7.0,4H  MA,4HJOR ,4HAXIS,4H WIN,4HD ST,4HRESS,
     *    49.0,8.0,4H    ,4H    ,4H ALO,4HNGSH,4HORE ,4HWIND,
     1    50.0,8.0,4H    ,4H    ,4HCROS,4HS-SH,4HORE ,4HWIND,
     2    51.0,7.0,4H  AL,4HONGS,4HHORE,4H WIN,4HD ST,4HRESS,
     3    52.0,7.0,4H CRO,4HSS-S,4HHORE,4H WIN,4HD ST,4HRESS,
     4    53.0,0.0,4H  WI,4HND S,4HTRES,4HS DI,4HVERG,4HENCE,
     5    54.0,0.0,4H    ,4H    ,4HWIND,4H STR,4HESS ,4HCURL,
     6    55.0,9.0,4H    ,4H  AD,4HJUST,4HED S,4HEA L,4HEVEL,
     7    19.0,7.0,4H  MI,4HNOR ,4HAXIS,4H WIN,4HD ST,4HRESS,
     8    58.0,12.,4H    ,4H    ,4H    ,4HHEAT,4H CON,4HTENT,
     9    59.0,13.,4H    ,4H    ,4H  DY,4HNAMI,4HC HE,4HIGHT/
      DATA FTTAB
     1   / 0.0,0.0,4H    ,4H    ,4H    ,4H    ,4H  -N,4HONE-,
     2    10.0,0.0,4H    ,4H    ,4H RUN,4HNING,4H AVE,4HRAGE,
     3    11.0,0.0,4H    ,4H    ,4H    ,4H  LO,4HW CO,4HSINE,
     4    12.0,0.0,4H    ,4H    ,4H    ,4HLOW ,4HGAUS,4HSIAN,
     5    20.0,0.0,4H    ,4H    ,4H    ,4H    ,4HDEME,4HANED,
     6    21.0,0.0,4H    ,4H    ,4H    ,4H HIG,4HH CO,4HSINE,
     7    22.0,0.0,4H    ,4H    ,4H RAW,4H - L,4HOW G,4HAUSS,
     8    23.0,0.0,4H    ,4H    ,4HRAW ,4H- LO,4HW CO,4HSINE,
     9    8*0./
      DATA WTTAB
     1   / 0.0,0.0,4H    ,4H    ,4H    ,4H    ,4H  -N,4HONE-,
     2     2.0,0.0,4H    ,4H    ,4H    ,4H    ,4H  CO,4HSINE,
     3     3.0,0.0,4H    ,4H    ,4H    ,4H COS,4HINE ,4H** 2,
     4     4.0,0.0,4H    ,4H    ,4H    ,4H COS,4HINE ,4H** 3,
     5     5.0,0.0,4H    ,4H    ,4H    ,4H COS,4HINE ,4H** 4,
     6     6.0,0.0,4H    ,4H    ,4H    ,4H EXP,4HONEN,4HTIAL,
     7     7.0,0.0,4H    ,4H    ,4H    ,4H    ,4HGAUS,4HSIAN,
     8     8.0,0.0,4H    ,4H    ,4H    ,4H    ,4H TRI,4HPLET,
     9     9.0,0.0,4H    ,4H    ,4H    ,4H    ,4H HAM,4HMING,
     9    10.0,0.0,4H    ,4H    ,4H    ,4H LAN,4HCOZ ,4H** 2,
     *    8*0./
      DATA STTAB
     1    /0.0,0.0,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,
     2     1.0,0.0,4H    ,4HFOUR,4HIER ,4HCOEF,4HFICI,4HENTS,
     3     2.0,0.0,4H    ,4H    ,4H    ,4HAUTO,4HSPEC,4HTRUM,
     4     3.0,0.0,4H    ,4H    ,4H    ,4H  RE,4HGULA,4HR KE,
     5     4.0,0.0,4H    ,4H    ,4H   N,4HORMA,4HLIZE,4HD KE,
     6     5.0,0.0,4H    ,4H    ,4H    ,4H   C,4HW RO,4HTARY,
     7     6.0,0.0,4H    ,4H    ,4H    ,4H  CC,4HW RO,4HTARY,
     8     7.0,0.0,4H AUT,4HOSPE,4HCTRU,4HM CO,4HNFID,4HENCE,
     9     8.0,0.0,4H    ,4HCROS,4HS-SP,4HECTR,4HAL P,4HHASE,
     *     9.0,0.0,4HCROS,4HS-SP,4HECTR,4HAL C,4HOHER,4HENCE,
     1    10.0,0.0,4H    ,4H    ,4HPHAS,4HE CO,4HNFID,4HENCE,
     2    11.0,0.0,4H    ,4HCOHE,4HRENC,4HE CO,4HNFID,4HENCE,
     3    12.0,0.0,4H    ,4H    ,4H    ,4H  CO,4HSPEC,4HTRUM,
     4    13.0,0.0,4H    ,4H    ,4H    ,4H  QU,4HADRA,4HTURE,
     5    14.0,0.0,4H   C,4HOSPE,4HCTRU,4HM CO,4HNFID,4HENCE,
     6    15.0,0.0,4H   Q,4HUADR,4HATUR,4HE CO,4HNFID,4HENCE,
     7    16.0,0.0,4H    ,4H    ,4H    ,4H   A,4HMPLI,4HTUDE,
     8    17.0,0.0,4H    ,4H    ,4H    ,4H    ,4H   P,4HHASE,
     9    8*0./
      DATA PCTAB
     1   / 0.0,0.0,4H    ,4H    ,4H    ,4H    ,4H    ,4H    ,
     2     1.0,0.0,4H EMP,4HIRIC,4HAL D,4HECOM,4HPOSI,4HTION,
     3    11.0,0.0,4H DYN,4HAMIC,4HAL D,4HECOM,4HPOSI,4HTION,
     4    21.0,0.0,4H    ,4HCOMP,4HLEX ,4HDEMO,4HDULA,4HTION,
     5    8*0.0/
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*      DATA UNIT
*     1  /1H ,1H ,1H ,1H ,
*     2   4H(DEG,4HREES,4H C) ,4H    ,
*     3   4H(CM/,4HSEC),4H    ,4H    ,
*     4   4H(DEC,4HIBAR,4HS)  ,4H    ,
*     5   4H(DEG,4HREES,4H)   ,4H    ,
*     6   4H(CM*,4HDEG ,4HC/SE,4HC)  ,
*     7   4H(MIL,4HLIBA,4HRS) ,4H    ,
*     8   4H(DYN,4HES/C,4HM**2,4H)   ,
*     9   4H(MET,4HERS/,4HSEC),4H    ,
*     *   4H(CEN,4HTIME,4HTERS,4H)   ,
*     1   4H(MMH,4HOS/C,4HM)  ,4H    ,
*     2   4H(0/0,4H0)  ,4H    ,4H    ,
*     3   4H(JOU,4HLES/,4HM**2,4H)   ,
*    4   4H(DYN,4H MET,4HERS),4H    ,
*    5   4*0./

      DATA NPTAB/4/,NDTTAB/29/,NFTTAB/8/,NWTTAB/10/
      DATA NSTTAB/18/,NPCTAB/4/,NUNIT/14/

      END

	SUBROUTINE ZBUFFT(CHR,ICNT)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)zbufft.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
#ifdef unix
	character buff*64,blnk*1,zfile*81
	character chr*(*)
#else
	character buff*64,blnk*1
	byte chr(*)
#endif
C	
C	WRITES CHAR TO CURRENT ZETA BUFFER EVENTUALLY TO BE
C	WRITTEN TO LUN ATTACHED TO THE FILE
C	D. DENBO  JUNE 1983   UPDATED MARCH 1984
C
#ifdef unix
	include 'PLTCOM.DAT'
#else
	include 'pplinc:PLTCOM.DAT'
#endif
	data blnk/' '/
	J=1
	IF (NEWFIL) THEN
#ifdef unix
	len=lnblk(filez,81)
	jcnt=1
100	write(zfile,998)filez(:len),fzcnt
998	format(a,i3.3)
	fzcnt=fzcnt+1
	jcnt=jcnt+1
	if(jcnt.gt.101)stop 'can not open hp file'
	OPEN(UNIT=LUHP,FILE=zfile,STATUS='NEW',err=100)
#else
	OPEN(UNIT=LUHP,FILE=filez,STATUS='NEW')
#endif
	NEWFIL=.FALSE.
	IPT=1
	ENDIF
#ifdef unix
40	BUFF(IPT:IPT)=CHR(J:J)
#else
40	BUFF(IPT:IPT)=char(CHR(J))
#endif
	IPT=IPT+1
	J=J+1
	IF(IPT.GT.64)THEN
	WRITE(LUHP,999)BUFF
	IPT=1
999	FORMAT(A64)
	ENDIF
	IF(J.LE.ICNT)GOTO 40
	RETURN
c	ENTRY ZFLUSH(CHR)
c	DO 10 I=IPT,63
c10	BUFF(I)=CHR(1)
c	BUFF(64)='Z'
30	WRITE(LUHP,999)BUFF
	CLOSE(LUHP)
	NEWFIL=.TRUE.
	IPT=1
	RETURN
	ENTRY HFLUSH
	DO 20 I=IPT,64
20	BUFF(I:I)=BLNK
	GOTO 30
	END

	subroutine epicv (ev,iev)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)epicv.F	1.1    3/10/88
C**
C**
C***********************************************************************        C**
C**                 EPIC
C**
C***********************************************************************        C**
C**
c
c  Translates character variable memonics in the PLOT5 EVAR command into
c  generic variable codes (integer) used in EPIC subroutine VARCK.
c
c  If the input variable memonic is unrecognized, then the character 
c  EVAR argument could contain a numeric column number.  If this is so,
c  then iev is set equal to this column number + 10000, to flag it as
c  a colunn number and not a generic integer variable code.
c
c  If numeric data can not be read from the character EVAR argument,
c  then the output generic code will be -1.
c
c  Programmed by N. Soreide, May 86.
c
#ifdef unix
	include 'TAXIS.INC'
#else
	include 'pplinc:taxis.inc'
#endif
	character *(*) ev
c
	iev=-1
	if (index (ev,'STK') .ne. 0) then
		iev=10
	else if (index (ev,'TIM') .ne. 0) then
		iev=9
		itflg=1
	else if (index (ev,'DYN') .ne. 0) then
		iev=8
	else if (index (ev,'SIG') .ne. 0) then
		iev=3
	else if (index (ev,'SAL') .ne. 0) then
		iev=2
	else if (index (ev,'OX') .ne. 0) then
		iev=4
	else if (index (ev,'CO') .ne. 0) then
		iev=5
	else if (index (ev,'P') .ne. 0) then
		iev=0
	else if (index (ev,'T') .ne. 0) then
		iev=1
	else if (index (ev,'U') .ne. 0) then
		iev=6
	else if (index (ev,'V') .ne. 0) then
		iev=7
c
c  See if character input is of form "Cn" where n is the column number 
c  (add 10000 to flag it as a column number) or of the form "En" where
c  n is the variable code from the EPICKEY file (add 20000 to flag it
c  as an EPICKEY variable code).
c
c       If the read is unsuccessful, then set the code to unknown (-1).
c
        else if (index(ev,'C') .ne. 0) then
            ichev=lenstr(ev)
            read (ev(2:ichev),*,err=100) iev
            iev=iev+10000
        else if (index(ev,'E') .ne. 0) then
            ichev=lenstr(ev)
            read (ev(2:ichev),*,err=100) iev
            iev=iev+20000
	else
c
c       If the character input to EVAR is unrecognized at this point, try
c       to read the column number from the character input.  If this is 
c       is successful, add 10000 to the column number to flag it as
c       a column number and not a generic integer variable code.
c
c       If the read is unsuccessful, then set the code to unknown (-1).
c
	    ichev=lenstr(ev)
	    read (ev(1:ichev),*,err=100) iev
	    iev=iev+10000
	endif
	return
c
100	iev=-1
	return
	end

*
* box_edges function
*
* Ansley Manke
* May 2009
*
* This function returns the edges of the grid boxes for 
* a 1-D variable. 
*

      SUBROUTINE box_edges_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg


      CALL ef_set_desc(id,'Returns the cell edge locations for the axis of a 1-D variable.' )

      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance_6d(id,
     .                                ABSTRACT, NORMAL,
     .                                NORMAL,   NORMAL,
     .                                NORMAL,   NORMAL)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'Variable')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      RETURN 
      END

*
* Set the limits for abstract axis.

      SUBROUTINE box_edges_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER i, np, npmax, numax
      CHARACTER*1 axdir(6)

      DATA axdir/'X', 'Y', 'Z', 'T', 'E', 'F'/

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      npmax = 0
      numax = 0
      DO i = X_AXIS, F_AXIS 
         np = arg_hi_ss(i,ARG1) - arg_lo_ss(i,ARG1) + 1
	 IF (np.GT.1 .AND. npmax.GT.1) GOTO 5100
	 IF (arg_hi_ss(i,ARG1) .EQ. EF_unspecified_int4) np = 0
	 npmax = MAX(np, npmax)
	 IF (arg_hi_ss(i,ARG1) .NE. EF_unspecified_int4) numax = numax + 1
      ENDDO

* No grid - i.e. argument is just a number.
      IF (npmax .EQ. 0) GOTO 5200

* No axes more than 1 long if multiple axes, issue a note

      IF (npmax.EQ.1 .AND. numax.GT.1) THEN
         DO i = X_AXIS, F_AXIS 
	    IF (arg_hi_ss(i,ARG1) .NE. EF_unspecified_int4) THEN
	       CALL WARN 
     .   ('Ambiguous argument, grid has only 1-point axes. Returning edges from '
     .   //axdir(i)//' axis')
	       EXIT ! from loop
	    ENDIF
         ENDDO
      ENDIF

* +1 for box_edges
      npmax = npmax + 1 
      CALL ef_set_axis_limits(id, X_AXIS, 1, npmax)

      RETURN 

5100  CALL EF_BAIL_OUT(id, 'Argument must be 1-dimensional')
5200  CALL EF_BAIL_OUT(id, 'Argument has no axes')

      END

*
* In this subroutine we compute the result
*
      SUBROUTINE box_edges_compute(id, arg_1, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

      INTEGER i, i1, i2,  j, k, l, m, n
      INTEGER idir, np
      REAL    box_hi
      
      LOGICAL its_dsg
      CHARACTER*128 err_msg
   
* Does the variable come from a Discrete Sampling Geometries dataset?  
* IF so we aren't (yet) handling its time coordinates correctly.

      CALL EF_GET_ITS_DSG(id, ARG1, its_dsg )
      IF (its_dsg) THEN
         err_msg = 
     . 'Data is from a Discrete Sampling Geometries (DSG) dataset. Function not yet implemented for DSG data.'
       GOTO 999
      ENDIF

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

! Find the axis of interest. If the result is is 1 cell in all directions
! return the edges for of the first axis found.

      idir = 0
      DO i = X_AXIS, F_AXIS 
         np = arg_hi_ss(i,ARG1) - arg_lo_ss(i,ARG1) + 1
	 IF (np.EQ.res_hi_ss(X_AXIS)-1 .AND. 
     .        arg_hi_ss(i,ARG1).NE.EF_unspecified_int4) THEN
	    idir = i
	    EXIT ! from loop
	 ENDIF
      ENDDO

* Get the low subscripts into the result and the uppermost grid cell limit as the last element

      i1 = arg_lo_ss(idir,ARG1)
      i2 = arg_hi_ss(idir,ARG1)    ! box low limits

      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      l = res_lo_ss(T_AXIS)
      m = res_lo_ss(E_AXIS)
      n = res_lo_ss(F_AXIS)

* Lower limits of requested cells
      CALL ef_get_box_lo_lim(id, ARG1, idir, i1, i2, 
     .           result(res_lo_ss(X_AXIS),j,k,l,m,n) )

* Upper limit of top cell
      CALL ef_get_box_hi_lim(id, ARG1, idir, i2, i2, box_hi)

      result(res_hi_ss(X_AXIS),j,k,l,m,n) = box_hi

      RETURN

 999  CALL ef_bail_out (id, err_msg)
      RETURN

      END

        SUBROUTINE SET_ONE_COLOR
        
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*       Sets the RGB values for a single color index
*       J Davison JISAO/PMEL/TMAP 11.15.91
*       *jd* 3.10.92 Brought over to Sun
*	*jd* 1.14.94 Mod for background setting in xgks
*       *js* 7.31.97 mod to change call to gqlwk to query_xgks_wkstn
* V610  *acm* 3/08 Fixes for metafile batch mode
* V6.8 *acm* 7/9/2012 For batch graphics on RHEL6, change ITS_BATCH_GRAPHICS
*                     from logical to integer, then batch = ITS_BATCH_GRAPHICS().NE.0

#   ifndef atc_gks
        include        'gkspar.inc'
#   endif
	include		'cmrd_inc.decl'
        include         'CMRD.INC'
	include		'gkscm1_inc.decl'
        include         'GKSCM1.INC'
	include		'gkscm2.cmn'
	include         'parampl5_dat.decl'
	include         'PARAMPL5.DAT'
	include         'save_colors.cmn'
        INCLUDE         'pen_inc.decl'  ! with num_line_colors
        INCLUDE         'PEN.INC'

	integer		ndx,red,green,blue,i,err
        integer         max_pline,max_pmark,max_text,max_fill_area
        integer         max_pattern,max_color
	real		val(3)

	parameter	(red = 1,green = 2,blue = 3)	

#ifdef xgks
	integer		black, white
	data		black/0/,white/1/
#endif

	INTEGER ITS_BATCH_GRAPHICS
        LOGICAL batch
	integer		type, error
	REAL		rd, gr, bl


******************************************************************************
*	IF NO ARGS, RESET COLORS
	if (m .eq. 0) then
           call query_xgks_wkstn (wstype,err,max_pline,max_pmark,
     .              max_text,max_fill_area,max_pattern,max_color)
	   if (err .ne. 0) goto 1000

#ifndef xgks
	   do 5 i = 0,num_line_colors
#else
           do 5 i = 1,num_line_colors
#endif
	      call gqpcr (wstype,i,err,val(red),val(green),val(blue))
	      if (err .ne. 0) goto 5
cc	      if (meta_actv) call gscr (wsid,i,val(red),val(green),val(blue))
	      call gscr (wsid,i,val(red),val(green),val(blue))
	      if (meta_actv .and. .not. meta_clsplt) 
     .		call gscr (meta_wsid,i,val(red),val(green),val(blue))
5	   continue
	   goto 1000
	end if



*	ELSE SET COLOR P(1) to RGB: P(2), P(3), P(4)
	if (m .ne. 4) goto 1000
	
	if (p(1) .ge. 0.0 .and. p(1) .le. 255) then
	   ndx = ifix (p(1))
	else
	   goto 1000
	end if

	do 10 i = 1,3
	   if (p(i+1) .ge. 0.0 .and. p(i+1) .le. 100.0) then
	      val(i) = p(i+1)/100.0
	   else
	      goto 1000
	   end if
10	continue

#ifndef xgks
cc	if (meta_actv) call gscr (wsid,ndx,val(red),val(green),val(blue))
	call gscr (wsid,ndx,val(red),val(green),val(blue))
#else
*	FOR X, PERMIT ONLY WHITE OR BLACK BACKGROUNDS FOR NOW
	if (ndx .eq. 0) then
	   if (val(red)   .eq. 0.0 .and.
     .	       val(green) .eq. 0.0 .and. 
     .	       val(blue)  .eq. 0.0) then 
	       call set_background (wsid,black)
	   else
	       call set_background (wsid,white)
	   endif
	else
cc	   if (meta_actv) 
cc     .        call gscr (wsid,ndx,val(red),val(green),val(blue))

	   call gscr (wsid,ndx,val(red),val(green),val(blue))
	endif
#endif

	if (meta_actv .and. .not. meta_clsplt) then
#ifndef xgks
           call gscr (meta_wsid,ndx,val(red),val(green),val(blue))
#else
*	   FOR X, PLACE NO INDEX 0 IN METAFILE, AND INDEX 1 CANNOT BE WHITE
	   if (ndx .eq. 0) goto 1000
	   if (ndx .eq. 1) then
	      if (val(red)   .eq. 1.0 .and.
     .		  val(green) .eq. 1.0 .and. 
     .		  val(blue)  .eq. 1.0) then 
                  call gscr (meta_wsid,ndx,0.0,0.0,0.0)
	      else
                 call gscr (meta_wsid,ndx,val(red),val(green),val(blue))
	      endif
	   else
              call gscr (meta_wsid,ndx,val(red),val(green),val(blue))
	   endif
#endif
	endif
 1000   continue


**** trying to fix batch bug ***
        batch = ITS_BATCH_GRAPHICS() .NE. 0
        if (batch) then
           saved_line_colors = 1
           CALL save_line_color (ndx,val(red),val(green),val(blue))
        endif
**** trying to fix batch bug ***

#ifndef atc_gks
cc       if (meta_actv) call guwk (wsid,gpostp)
        call guwk (wsid,gpostp)
#endif

        return
	end

	SUBROUTINE CD_GET_GENERIC_GRIDS (dset,cdfid,temp_axnams,reversed,
     .					 perm, native_tax, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Loads the common block XGRID with implicitly given grid definitions from a
* netCDF file - i.e. grid definitions for variables that lack a 
* "parent_grid = name" attribute
* also initialize grid limits (lo hi bounds on each axis) for these variables

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 2/92
* 2/95 - added support for reverse-ordered coordinate axes
* 7/96 - increase "name" from 16 to 24 characters for consistence
*	(still dimension names cannot be 24 chars --> line names in COMMON)
* 10/96 *kob* - Linux port - had to move variable assignments off of
*		declaration line.
* V500: 3/99 *sh* - if an axis doesn't exist matching the dimension name, then
*	create a 1,2,3...n axis without error message
*       4/99 *kob* - increase size of temp_axnams, vname and name to 64
* *sh*  6/99 - added "perm" (permutation) argument
* V510: *sh* 1/00 - when a "BASIC" axis is created cuz the file has no
*			coords that axis needs to bump "lastax" to get
*			checked for dup names later
*	     3/00 - convert to dynamic grids and axes
* V533: *sh* 6/01 - support for string variable input
* V552 *acm* 5/03   increase vname to 128 chars 
* V600 *ACM* attribute control. 
*             Change call to CD_GET_ATTRIB to NC_GET_ATTRIB - get attrib 
*             from linked list structure
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing
* V683 10/12*acm* If T and F dimensions, and if both are calendar axes, insist that
*                 the calendars match.
* V685 5/13 *acm* Discrete Sampling Geometries files: if there is a variable with
*                 a cf_role attribute, assign its axis to the E direction. (If the
*                 file has coordinate variables with assigned axes, keep the 
*                 direction assigned in the file.)
* V697 11/15 *sh* return the line number of the native time axis of this dset
* V697 12/15 *am* Fix the logic around checking the calendar attributes when 
*                 grid has both T and F axes
* V710 12/16 *am* If the dimension is not a coordinate variable don't try to 
*                 check its calendar attribute

* argument definitions:
*       dset        - TMAP data set pointer
*	cdfid	    - netCDF id number for already opened CDF file
*       temp_axnams - nferdims axis names per grid: temp until grids are assembled
*       reversed    - logical array to record which axes have reversed coords
*       perm        - user-specified permutation (e.g. "YXZT"=2,1,3,4)
*	native_tax  - (output) line no of time axis of this dataset
*	status	    - return status

* include files

        include 'netcdf.inc'
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
        include 'xbuild_grids.cmn'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xio.cmn_text'
	external xio_data
	include 'xtm_grid.cmn_text'
	        include 'xdset_info.cd_equiv'

* argument declarations
	LOGICAL  reversed(max_lines:line_ceiling)
	INTEGER	 dset, cdfid, perm(nferdims), native_tax, status
	CHARACTER*128 temp_axnams(nferdims,max_temp_grid)

* local parameter definitions:
      INTEGER     str_eq
      PARAMETER ( str_eq = 0 )

* local variable declarations:
* *kob* explicit definitions not allowed on decl line in linux...
*       moved them to parameter line 10/96
      LOGICAL NC_GET_ATTRIB, CD_GET_ATTRIB,
     .        got_it, do_warn, centers, coordvar
      PARAMETER (do_warn = .TRUE. )
      PARAMETER (centers = .TRUE. )
      INTEGER TM_LENSTR1, TM_FIND_GRID_SLOT, STR_CASE_BLIND_COMPARE,
     .        STR_SAME, igrid, iaxis, grid_cnt, istat, idim,
     .        ivar, vartyp, nvdims, vdims(8), nvatts, vlen, idim2,
     .        tmvar, tmpgrid, npts, dim, tmplines(nferdims), ndim,
     .	      grid_dims(nferdims), trans(nferdims), indices(nferdims),
     .        i, maxlen, attlen,attoutflag, all_outflag, axid, iaxis6,
     .        attid, eax, cfrole_dim, blen
      REAL    tmp
      CHARACTER name*128, vname*128, linunits*24, cal_str*24, cal_t*24, cal_f*24

      INTEGER tt  ! nice short name
      EQUIVALENCE (tt,lunit_errors)

* initialize
	native_tax = mpsnorm

* initialize temporary grid name pointer
	num_tmp_grids = 0
	DO 5 i = max_grids, grid_ceiling
 5	   tmp_nam_ptr(i) = 0

* * * * loop through each variable in this TMAP data set * * *
* Check for cf_role attribute. If present, its grid is in the E direction.

	cfrole_dim = 0 
	
        DO 25 tmvar = 1,maxvars
           IF ( ds_var_setnum(tmvar) .NE. dset ) GOTO 25
	   eax = 0
           ivar = cd_varid(tmvar)

* get the vital statistics for this variable
           CALL CD_GET_VAR_INFO(dset, ivar, vname, vartyp, nvdims,
     .                 vdims, nvatts, coordvar, all_outflag, istat)

           IF (istat.NE.merr_ok) CALL TM_ERRMSG
     .     ( istat+pcdferr,status,'CD_GET_GENERIC_GRIDS',cdfid,ivar,
     .       no_errstring, no_errstring, *5900 )
           vlen = TM_LENSTR1(vname)

* if a string variable, the first dimension is the string axis (ignore it)
	   IF (vartyp .EQ. NF_CHAR) THEN
	      nvdims = nvdims - 1
	      DO idim = 1, nvdims
	         vdims(idim) = vdims(idim+1)
	      ENDDO
	   ENDIF

* if it has a cf_role attribute, we'll put its axis in the E direction.
*  trajectory:cf_role = "trajectory_id" (or var w/ "profile_id", or "timeseries_id")
* (IF there is a instance_dimension attribute, it's value is the the instance axis,
* to be put in the E direction. If there is a sample_dimension attribute on some variable, its value is the obs 
* dimension, to be put in the X direction.) 

	   CALL  CD_GET_VAR_ATT_ID (dset, ivar, "cf_role", attid, status)
	   IF (status .EQ. merr_ok) THEN
	      eax = vdims(1)

* find the instance dimension

              DO 15 idim = 1, nvdims
	         IF (idim .EQ. eax) cfrole_dim = idim
 15          CONTINUE
             GOTO 35  ! only one cf_role attribute recognized

	   ENDIF

 25       CONTINUE

 35       CONTINUE

* * * * loop through each variable in this TMAP data set * * *
* if it doesn't have a grid pointer create a suitable one and point to it
        DO 500 tmvar = 1,maxvars
           IF ( ds_var_setnum(tmvar) .NE. dset ) GOTO 500
           ivar = cd_varid(tmvar)

* does it point explicitly to a parent grid ?
          maxlen = 24   !linenamlen
          got_it = NC_GET_ATTRIB( dset, ivar, 'parent_grid',
     .                       .NOT.do_warn, ' ', maxlen, attlen, 
     .                       attoutflag, name, tmp )
          IF ( got_it ) GOTO 500  ! yes - already has a pointer

* get the vital statistics for this variable
           CALL CD_GET_VAR_INFO(dset, ivar, vname, vartyp, nvdims,
     .                 vdims, nvatts, coordvar, all_outflag, istat)

           IF (istat.NE.merr_ok) CALL TM_ERRMSG
     .     ( istat+pcdferr,status,'CD_GET_GENERIC_GRIDS',cdfid,ivar,
     .       no_errstring, no_errstring, *5900 )
           vlen = TM_LENSTR1(vname)

* if a string variable, the first dimension is the string axis (ignore it)
	   IF (vartyp .EQ. NF_CHAR) THEN
	      nvdims = nvdims - 1
	      DO idim = 1, nvdims
	         vdims(idim) = vdims(idim+1)
	      ENDDO
	   ENDIF

* use the next grid building slot to build a grid for this variable
           tmpgrid = num_tmp_grids + 1

* initialize the axis names in case there are fewer than nferdims from CDF variable
           DO 10 idim = 1, nferdims
              tmplines(idim) = unspecified_int4
              temp_axnams(idim,tmpgrid)='NORMAL'
 10        CONTINUE

* find the axis names from the CDF file
	   cal_t = ' '
	   cal_f = ' '
           DO 200 idim = 1, nvdims

* ... get name of dimension
              CALL CD_GET_DS_DIMS( dset, vdims(idim), name, npts, istat )
              IF (istat.NE.merr_ok) CALL TM_ERRMSG
     .     ( istat+pcdferr,status,'CD_GET_GENERIC_GRIDS',cdfid,ivar,
     .       vname(:vlen), 'cant get dimensions', *5900 )
 
* ... locate the axis by that name (processed in CD_GET_AXES)
	      iaxis = 0
 100	      CALL TM_NEXT_TMP_LINE(iaxis, *120)  ! 120 if no more
	         istat = STR_CASE_BLIND_COMPARE(name, line_name(iaxis))
	         IF ( istat .EQ. str_eq ) GOTO 150  ! got a match
	      GOTO 100

* ... axis doesn't exist - perhaps it is a dimension with no variable defn
* *sh* 3/99: or perhaps a 2D variable with name matching the dimension name
*  either way -- not an error condition if we need to synthesize an axis ...
 120	      CALL TM_MAKE_BASIC_AXIS( name, 1.0D0, 1.0D0, npts,
     .                                 iaxis, status )
              IF ( status .NE. merr_ok ) GOTO 5900

* Are there attributes that tell us the direction?  If so apply them.
* for the user's convenience, an invalid T axis is still in the T direction.
* The routine will get and use basic info about the units.

* axis ID
	      CALL CD_GET_VAR_ID (dset, name, axid, status)
	      linunits = char_init24
	      IF (idim .EQ. cfrole_dim) THEN
	         line_direction(iaxis) = 'EE'
		 cfrole_dim = 0  ! reset. Just one axis will have this role.
		 eax = 0
	      ELSE
	         CALL CD_GET_LINE_DIRECTION (dset, axid, iaxis, 
     .                name, linunits, do_warn)
	      ENDIF

* save a pointer to the axis just found
 150          IF (idim.LE.nferdims) tmplines(idim) = iaxis

              CALL CD_GET_VAR_ID (dset, name, axid, status)

* Check the calendar attribute 
	      IF (status .EQ. merr_ok) THEN 
	         blen = 24
                 got_it = CD_GET_ATTRIB( cdfid, axid, 'calendar',
     .                  do_warn, name, cal_str, attlen, blen )
	         IF (got_it .AND. line_direction(iaxis)(1:1).EQ.'T') cal_t = cal_str
	         IF (got_it .AND. line_direction(iaxis)(1:1).EQ.'F') cal_f = cal_str
	      ENDIF

 200       CONTINUE

* reorder the axes into the most likely order if not explicitly given
           IF ( ds_ordering(1,tmvar) .EQ. unspecified_int4 ) THEN
              CALL TM_AXIS_ORDER(tmplines, perm, ds_ordering(1,tmvar),
     .                           nvdims, vname(:vlen))
           ENDIF

* ... make a sorted list of the relevant axes in grid_dims
*     and a list of the index ordering of the axes in indices
	ndim = 0
	DO 210 idim = 1, nferdims
	   trans(idim) =  ABS(ds_ordering(idim,tmvar))
	   grid_dims(idim) = trans(idim)
	   indices(idim) = idim
	   IF (trans(idim) .NE. 0 ) THEN
	      ndim = ndim + 1
	   ENDIF
 210	CONTINUE
	DO 220 idim = 1, ndim
	   DO 215 idim2 = idim+1, ndim
	      IF (grid_dims(idim) .GT. grid_dims(idim2)) THEN
	         dim = grid_dims(idim)
	         grid_dims(idim ) = grid_dims(idim2)
	         grid_dims(idim2) = dim
	      ENDIF
 215	   CONTINUE
 220	CONTINUE
	DO 230 idim = 1, ndim
	   i = 1
	   DO 225 idim2 = 1, ndim
	      IF (trans(idim2) .LT. trans(idim)) i = i + 1
 225	   CONTINUE
	   indices(idim) = i
 230	CONTINUE

* save the axis names in the proper order
           DO 240 idim = 1, nferdims
              ds_grid_start(idim,tmvar) = 1
              ds_grid_end  (idim,tmvar) = 1
 240       CONTINUE
           DO 250 idim = 1, ndim
              dim = trans(idim)
              iaxis = tmplines(indices(idim))
	      idim2 = grid_dims(idim)
              temp_axnams(idim2,tmpgrid) = line_name(iaxis)
              ds_grid_end(idim2,tmvar)   = line_dim(iaxis)
* ... arbitrarily, the native taxis taken from the first grid with a time axis
	      IF (idim2.EQ.t_dim .AND. native_tax.EQ.mpsnorm)
     .						native_tax = iaxis
* ... flag reverse-ordered coordinate axis of variable (2/95)
	      IF ( reversed(iaxis) ) ds_ordering(idim,tmvar)
     .			      = -1 * ds_ordering(idim,tmvar)
 250       CONTINUE

* ... If there is a T and an F axis, check for matching calendars

	   iaxis = 0
	   iaxis6 = 0
           DO 260 idim = 1, ndim
	      IF (trans(idim) .EQ. T_DIM) iaxis  = tmplines(idim)
	      IF (trans(idim) .EQ. F_DIM) iaxis6 = tmplines(idim)
 260       CONTINUE

*     When there is a calendar attrib on the the F or T axis but not both, 
*     use the specified calendar for the both time dimensions

	   IF (iaxis.GT.0 .AND. iaxis6.GT.0) THEN
	      IF ( (STR_SAME(cal_f, ' ') .EQ. 0) )
     .           line_cal_name(iaxis6) = line_cal_name(iaxis)
	      IF ( (STR_SAME(cal_t, ' ') .EQ. 0) )
     .           line_cal_name(iaxis) = line_cal_name(iaxis6)

              IF (STR_SAME(line_cal_name(iaxis), line_cal_name(iaxis6)) .NE. 0) 		
     .		CALL TM_ERRMSG (merr_axis_att, status, 'CD_GET_GENERIC_GRIDS',
     .            no_descfile, 1,
     .		  'Calendar definitions on T and F axes must match',
     .            no_errstring, *5900 )
	   ENDIF

* is the temporary grid we just created unique ?
	   igrid = 0
 300	   CALL TM_NEXT_TMP_GRID( igrid, *320)
	      grid_cnt = tmp_nam_ptr(igrid)
              DO 310 idim = 1, nferdims
                 IF ( temp_axnams(idim,tmpgrid )
     .          .NE.  temp_axnams(idim,grid_cnt) ) GOTO 300
 310          CONTINUE
* ... not unique - exact match with one that already exists
              GOTO 350
 320	   CONTINUE
 

* allocate a new grid
* find next location to store info; if too many grids - give error
	  CALL TM_ALLO_TMP_GRID(igrid, status)
	  IF (status .NE. merr_ok) GOTO 5900

* make up a unique grid name "GXXnn" where XX is hashed from data set name
          grid_name(igrid) = 'G'//cd_dset_code(dset)(:2)
          CALL TM_NEW_GRID_NAME( grid_name(igrid), name )
          grid_name(igrid) = name

* basic defaults
          grid_rotation(igrid) = 0.0
          DO 340 idim = 1, nferdims
 340      grid_out_prod(idim,igrid) = .TRUE.

* save a pointer to this grid for the TMAP variable
 350      ds_grid_number(tmvar) = igrid

 500   CONTINUE

* successful completion
 	status = merr_ok
        RETURN

* error exit
 5900	RETURN

	END

 01SR 0 1133/users/denbo/fonts/font01                     simplex roman
 02DR 0 2470/users/denbo/fonts/font02                     duplex roman
 03TR 0 3964/users/denbo/fonts/font03                     triplex roman
 04CR 0 2204/users/denbo/fonts/font04                     complex roman
 05CS 0 2694/users/denbo/fonts/font05                     complex script
 06TI 0 3829/users/denbo/fonts/font06                     triplex italic
 07GE 0 4457/users/denbo/fonts/font07                     gothic english
 08IR 0 1948/users/denbo/fonts/font08                     indexical complex roman
 09SS 0 1451/users/denbo/fonts/font09                     simplex script
 10CI 0 1630/users/denbo/fonts/font10                     complex italic
 11II 0 1435/users/denbo/fonts/font11                     indexical complex itali
 12SG 0  798/users/denbo/fonts/font12                     simplex greek
 13CG 0 1497/users/denbo/fonts/font13                     complex greek
 14IG 0 1298/users/denbo/fonts/font14                     indexical complex greek
 15GG 0 3541/users/denbo/fonts/font15                     gothic german
 16GI 0 2581/users/denbo/fonts/font16                     gothic italian
 17CC 0 2164/users/denbo/fonts/font17                     comlex cyrillic
 18AR 0  629/users/denbo/fonts/font18                     cartographic roman
 19AG 0  275/users/denbo/fonts/font19                     cartographic greek
 20ZO 1 1011/users/denbo/fonts/font20                     zodiac
 21MU 1 1146/users/denbo/fonts/font21                     music
 22EL 1  376/users/denbo/fonts/font22                     electrical
 23WE 1  327/users/denbo/fonts/font23                     weather
 24MA 1 1901/users/denbo/fonts/font24                     math
 25SM 1  728/users/denbo/fonts/font25                     simplex math
 26MP 1  969/users/denbo/fonts/font26                     map
 27LM 1  351/users/denbo/fonts/font27                     large math
 28IZ 1  400/users/denbo/fonts/font28                     indexical zodiac
 29IM 1 1058/users/denbo/fonts/font29                     indexical math
 30CA 1  258/users/denbo/fonts/font30                     cartographic
 31AS-1 1380/users/denbo/fonts/font31                     ascii simplex roman
 32AC-1 2451/users/denbo/fonts/font32                     ascii complex roman

	SUBROUTINE FIND_MEM_VAR_INCL_C_CACHE( cx, mr, by_value )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* try a traditional Ferret memory cache search.
*  If it fails, as a last ditch, look to see if the full range variable
* is available in c cache (normally used for CF auxiliary variables)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V695+ 5/15 *sh*
* V698  1/16 *sh* -- continue on to check cache whenever mr=0 from FIND_MEM_VAR

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xprog_state.cmn'
	include 'xdset_info.cmn_text'

* calling argument declarations:
	INTEGER cx, mr
	LOGICAL by_value

* internal variable declarations:
	LOGICAL valid_search
	INTEGER CGRID_SIZE, var, cat, npts, status
        REAL*8  c_cache_ptr

* first try a normal cache search
	CALL FIND_MEM_VAR( cx, mr, search_by_value, valid_search )
	IF (mr.NE.mr_nonexist) RETURN   ! 1/16 ignore valid_search

* initialize
	var = cx_variable(cx)
	cat = cx_category(cx)
* ... aggegated vars always map to file var of same cx_variable number
	IF (cat .EQ. cat_agg_f_var) cat = cat_file_var

* last ditch attempt -- is this variable available in c memory cache
* (used to speed recall of CF auxiliary variables)
* NOTE: error conditions are not properly trapped
	IF ( cat .EQ. cat_file_var ) THEN
	   c_cache_ptr = ds_var_c_cache_ptr(var)
	ELSEIF ( cat .EQ. cat_user_var ) THEN
	   c_cache_ptr =  uvar_c_cache_ptr(var) 
	ELSE
	   c_cache_ptr =  0.0
	ENDIF

	IF (c_cache_ptr .NE. 0.0) THEN
	   CALL CREATE_FULL_RANGE_CONTEXT ( cx, cx_buff, status )
	   IF (status .NE. ferr_ok) GOTO 5000
	   CALL CREATE_MEM_VAR( cx_buff, mr, status )
	   IF (status .NE. ferr_ok) GOTO 5000
	   npts = CGRID_SIZE(cx_buff)
	   CALL RECOVER_CACHED_FULL_ARRAY(memry(mr)%ptr,
     .				npts, c_cache_ptr)
	   IF (mode_diagnostic) CALL DIAGNOSTIC_OUT('c-found',mr,point_to_mr)
	   RETURN  ! YAHOO!  Made a last didch cache hit.
	ENDIF
	
* failure exit
 5000	mr = mr_nonexist
	RETURN
	END

      SUBROUTINE SHADE_FILL_IT (data, nxdim, nydim, px, py, xs, ys, 
     .                          xinv, yinv, xadd, lmin, lmax, 
     .                          ilo, ihi, jlo, jhi, maxpt_ov2, status)

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* 2/23/2005 acm
* Do the fill for a shade plot, perhaps with a modulo offset in X
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus
* V687 *acm* 3/14 tickets 2151 and 2147: allow missing coordinate data in 3-arg 
*                 and 4-arg plot commands. 

        include 'miss_inc.decl'
        include 'MISS.INC'
       INCLUDE 'parampl5_dat.decl'
       INCLUDE 'PARAMPL5.DAT'
       INCLUDE 'hd_inc.decl'
       INCLUDE 'HD.INC'
       INCLUDE 'ferret.parm'
       INCLUDE 	'xinterrupt.cmn'	! 1/89 *sh*
       INCLUDE 'errmsg.parm'
       INCLUDE 'xcurvilinear.cmn'

       INTEGER nxdim, nydim, maxpt_ov2, status
       REAL    data(nxdim,nydim), px(*), py(*), xs(*), ys(*), lmin, lmax

* local definitions

      REAL    minrowx, maxrowx, big
      INTEGER GET_NDX, i, j,i1, fill_ndx, npt, pt1, next_ndx,
     .        jtop
      REAL    ddat
      INTEGER nothing
      LOGICAL BAD_XY_COORD, first, xfield_is_modulo
      CHARACTER*128 buff

#ifdef double_p
      real*8 x_curv(200), y_curv(200)
#else
      real x_curv(200), y_curv(200)
#endif

      big = ABS(CMZGE)

      status = ferr_ok
      lmin = -1*big
      lmax = big


*  check for consistency: data range 1:ny, index range jlo:jhi  
*  If inconsistent, use whole Y range given by ny

      IF (curvilinear) THEN
         IF (jlo .LT. 1 .OR. jhi .GT. ny+1) THEN  
            jlo = 1
            jtop = ny
         ELSE
            jtop = jhi 
            IF (jhi .EQ. ny+1) jtop = ny
         ENDIF
      ELSE
         jlo = 1
         jtop = ny
      ENDIF

*  Likewise for X, if this is not an x modulo plot

      IF (curvilinear .AND. (.NOT. xmodulo) ) THEN
c      IF (curvilinear ) THEN
         IF (ilo .LT. 1 .OR. ihi .GT. nx+1) THEN  
            ilo = 1
            itop = nx
         ELSE
            itop = ihi 
            IF (ihi .EQ. nx+1) itop = nx
         ENDIF
      ELSE
         ilo = 1
         itop = nx
      ENDIF

*	LAY FILL DOWN ON SCREEN IN PROPER PLACE

        first = .TRUE.  ! for curvilinear curv_coord_add_sub
	DO 50 j = jlo, jtop

! initialize these so that the check in BAD_XY_COORD doesn't get caught
! in a loop
           py(1) = ys(j)
           py(2) = ys(j+1)
           py(3) = ys(j+1)
           py(4) = ys(j)

* ... initialize for outer DO...WHILE loop
	   i = 0

           minrowx = big
           maxrowx = -1.*big


* ... outer: DO WHILE i LE itop ...
40	   i = i + 1					! To line 50 JD 5.16.90
	   IF (i .EQ. itop+1) GOTO 49

	   IF ( interrupted ) GOTO 3333			! 1/89 - *sh*

* ... initialize for inner DO...WHILE loop
	   IF (.NOT.curvilinear) THEN
* ... note that for curvilinear plots the screening of coordinates is NOT
*	applied. This represents a minor bug/feature since the user might
*	expect the PLOT+ limits command still to apply.
*	(It was just too much trouble for the potential benefit *sh*)
	      IF (BAD_XY_COORD(i,j,xs,py,fill_ndx)) GOTO 40
	   ENDIF
	   ddat = data(i,j)
	   fill_ndx = GET_NDX (data(i,j),fill_ndx)
	   IF (fill_ndx .EQ. -999) GOTO 40
	   pt1 = i
	   npt = 1

* ... inner: DO WHILE fill_ndx remains unchanged ...
* ... find the largest box from this row that is all this color (optimization)
* ... Note: further optimization is possible (especially for very noisy fields)
*	    for curvilinear plots. Since each polygon "tube" shares 2 vertices
*	    with the one that preceded it on the row, we are unnecessarily
*	    computing the curvilinear position of these points TWICE in calls
*	    to CURV_COORD
45	      i = i + 1
	      IF (i .EQ. itop+1) GOTO 48
	      IF ( curvilinear ) THEN
	         npt = i + 1
	         IF ( npt .GE. maxpt_ov2 ) GOTO 48
	      ENDIF

              next_ndx = GET_NDX (data(i,j),next_ndx)
	      IF (.NOT.curvilinear) THEN
	         IF (BAD_XY_COORD(i,j,xs,py,fill_ndx)) GOTO 48
	      ENDIF
              IF (curvilinear) GOTO 48  ! each cell on its own.
	      IF (fill_ndx .EQ. next_ndx) GOTO 45
* ... inner: end loop

* found last cell in chain - now assign the vertices of the polygon
48	   IF ( curvilinear ) THEN
* ... after transformation this will be a curvy "tube" of one color
	      npt = i - pt1 + 1
* ... polygon chain begins along upper edge of row of cells
	      DO 51 i1 = 1, npt
	         x_curv(i1) = xs(pt1+i1-1)
	         y_curv(i1) = ys(j+1)
 51	      CONTINUE
* ... and returns (closes) along lower edge of row of cells
	      DO 52 i1 = npt+1, 2*npt
	         x_curv(i1) = x_curv(2*npt+1-i1)
	         y_curv(i1) = ys(j)
 52	      CONTINUE
	      npt = 2*npt
	      CALL CURV_COORD_ADD (x_curv, y_curv, npt, xinv, yinv, xadd,
     .            first, xfield_is_modulo, status) ! xform the pts
	      IF (curv_missing) THEN
	         i = i - 1
		 GOTO 40
              ENDIF
	      
	      IF ( status .NE. 0 ) RETURN
              minrowx = MIN( minrowx, x_curv(1) )
              minrowx = MIN( minrowx, x_curv(2) )
              maxrowx = MAX( maxrowx, x_curv(1) )
              maxrowx = MAX( maxrowx, x_curv(2) )

	      DO 522 i1 = 1, npt
		 px(i1) = x_curv(i1)
		 py(i1) = y_curv(i1)
 522	      CONTINUE
	   ELSE
* ... always a rectangle -- just save the corners
	      px(1) = xs(pt1)
	      px(2) = xs(pt1)
	      px(3) = xs(i)
	      px(4) = xs(i)
	      py(1) = ys(j)
	      py(2) = ys(j+1)
	      py(3) = ys(j+1)
	      py(4) = ys(j)
	      npt = 4
	   ENDIF
	   pt1 = i	! index of left edge of first cell of next color
	   i = i - 1

	   CALL set_fill_ndx (fill_ndx)
	   CALL gfa (npt,px,py)

*	   TO RETAIN ABILITY FOR COLOR OR HATCHING IN METAFILE, WRITE 
*	   FILL_NDX TO PRIVATE ITEM -- no, forget it *jd* 10.22.92
*	   IF (meta_actv .AND. .NOT. area_bundles) 
*     .				CALL meta_fill_ndx (fill_ndx)

	   GOTO 40

* For each y, what is the max and min x coordinate value covered
* by all the rows and columns?
* We want to save the minimum of the high coords for each row,
* and the maximum of the low coords for each row 

49         IF (minrowx .LT. big) lmin = MAX(lmin, minrowx)
           IF (maxrowx .GT. -1.*big) lmax = MIN(lmax, maxrowx)

50	CONTINUE

        RETURN

3333    status = ferr_interrupt
        RETURN

* error exit
 5000	RETURN
	END 

	INTEGER FUNCTION CD_AXLEN ( cdfid, dimid, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* get the length of an axis (netCDF coordinate variable)
* the axis is presumed to exist and to be a 1D variable

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 2/92
* 4/94 *sh*,*kob* inserted return value for error exit case - avoid
*		  compiler error msg
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* argument definitions:
*	cdfid	- netCDF id number for already opened CDF file
*       dimid   - dimension id of coordinate variable in netCDF file
*       status  - returned status code

* argument declarations
      INTEGER	    cdfid, dimid, status

      include 'netcdf.inc'
      include 'tmap_errors.parm'

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

* internal variable declarations:
* *kob* explicit definitions not allowed on decl line in linux...moved it to parameter line
      LOGICAL CD_GET_ATTVAL, got_it, do_warn
      PARAMETER (do_warn = .TRUE.)
      INTEGER TM_LENSTR1, cdfstat, nval, npts, nlen, axid
      CHARACTER*128 axname
      REAL rlen

* initialize in case of error exit (4/94)
      CD_AXLEN = 0

* get the basic information about this dimension

#ifdef usingDODSf2cUnderscore
      cdfstat = NF_INQ_DIM_( cdfid, dimid, axname, npts )
#else
      cdfstat = NF_INQ_DIM( cdfid, dimid, axname, npts )
#endif
      IF ( cdfstat .NE. NF_NOERR ) GOTO 5100

* get the basics about the axis by the same name
      nlen = TM_LENSTR1( axname )
#ifdef usingDODSf2cUnderscore
      cdfstat = NF_INQ_VARID_( cdfid, axname(:nlen), axid )
#else
      cdfstat = NF_INQ_VARID( cdfid, axname(:nlen), axid )
#endif

* check "true_size" in case this is a condensed axis representation
      got_it = CD_GET_ATTVAL( cdfid, axid, 'true_size',
     .                        do_warn, axname(:nlen), rlen, 1, nval)
      IF (got_it) npts = rlen

* successful completion
      CD_AXLEN = npts
      status = merr_ok
      RETURN

* error exit
 5000 RETURN
 5100 CALL TM_ERRMSG( cdfstat+pcdferr, status, 'CD_AXLEN', cdfid,
     .                no_varid, no_errstring, no_errstring, *5000 )
      END

	SUBROUTINE TM_allo_dyn_line_sub( hook, line, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Allocate a line from the dynamic line area (above max_lines)

* The lines in xtm_grid.cmn fall into two categories (ideally they could
* and should all be category 2, but the development was historical)
* category 1: explicit (static) lines
*	these are located in the low indices of the grid common
*	(e.g. line_name(3)).  They are created by READ_GRIDFILE, CD_*_GRIDS,
*	and by DEFINE AXIS inside Ferret.  These are the lines that are
*	returned by TM_FIND_LINE_SLOT.
* category 2: dynamic lines
*	these are in the upper indices: above max_lines.  They are managed
*	efficiently with linked lists and usage counts.  They are used by
*	Ferret to hold "implicit" lines -- implied by expressions such as
*	SALT[GX=lo:hi:del] where an X axis is implied.
*	They are deleted as necessary to ensure that new line definitions and
*	changes in user variable definitions do not corrupt memory. 
* Note: there is a difference in Ferret between the management of dynamic
* grids and axes.  Namely, **ALL GRIDS** are regarded as a single "grid pool"
* including both dynamic and static: when a static grid exists that matches
* a need it will be used in preference to making a dynamic grid.  This is done
* to ensure consistency -- at all stages of variable evaluation a given
* must be associated with the same grid.  With lines, however, the challenge
* is tracking "who" is using any given line.  Since this is not conveniently
* knowable (too compute intensive to figure out every time it is of interest)
* a greater separation is created between the static and dynamic lines.  This
* is reflected in the differences between TM_GET_LIKE_DYN_LINE and
* TM_GET_LIKE_DYN_GRID.

* Steve Hankin  NOAA/PMEL/TMAP

* 10/3/95 for Ferret version 4.2
* V510 *sh* added "hook" arg so this can be used for tmp lines, too
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* Include files
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'tmap_errors.parm'
	include 'xtm_grid.cmn_text'
	include 'xio.cmn_text'
	external xgt_grid_data

* Argument definitions
	INTEGER hook, line, status

* Local definitions
	INTEGER next_free_line

* take a line from the "free" list and put it on the "used" list
	IF ( line_free_ptr .NE. 0 ) THEN
* ... unhook from free list
	   line			= line_free_ptr
	   next_free_line  	= line_flink(line)
	   line_free_ptr	= next_free_line
* ... hook onto front of used list
	   line_flink(line)	= line_flink(hook)
	   line_blink(line)	= hook
	   line_flink(hook)     = line
	   line_blink(line_flink(line))	= line
	ELSE
	   CALL TM_ERRMSG (merr_linelim, status,
     .                  'TM_ALLO_DYN_LINE', no_descfile, no_stepfile,
     .                  no_errstring, no_errstring, *9999)
	ENDIF

* flag it as in NOT use - its use count gets bumbed when used by a grid or
* a child axis
	line_use_cnt(line) = 0

* successful completion
	status = merr_ok
 9999	RETURN

	END

      SUBROUTINE SMX1(X,XHI,XTIC,NSMTCX,XFACT,YFACT,Y,
     .                yacross,vgrat,vcolor,vline) 
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)smx1.f	1.1    3/10/88
C**
* v554: *acm* 2/04 add /HGRAT /VGRAT to draw optional graticule lines at tic marks:
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C 
C     THIS SUBROUTINE PLOTS THE SMALL XTICS ON THE X AXIS. 
C     IT DIFFERS FROM SMX IN THAT THE TICS ARE BIGGER. 
C 

        REAL yacross, dash1, dash2,dash3,dash4   ! for drawing the tic all the way across the plot
        REAL vgrat(4,2)        ! line type: 0=tics only, <0=line, >0=dash lengths 
        INTEGER vcolor(*)      ! pen number 
        LOGICAL vline          ! If true, do the lines across.
        LOGICAL solid          ! solid lines across at tics
        LOGICAL dashed         ! dashed lines across at tics

        solid = (vgrat(1,2).LT.0 .AND. vgrat(2,2).LT.0 .AND.  
     .            vgrat(3,2).LT.0 .AND.  vgrat(4,2).LT.0 )
        dashed = (vgrat(1,2).GT.0 .OR. vgrat(2,2).GT.0 .OR.  
     .            vgrat(3,2).GT.0 .OR.  vgrat(4,2).GT.0 )
        IF (dashed) THEN
           dash1 = vgrat(1,2)
           dash2 = vgrat(2,2)
           dash3 = vgrat(3,2)
           dash4 = vgrat(4,2)
        ENDIF

      IF(NSMTCX.LT.1) RETURN 
      SMTIC=XTIC/FLOAT(NSMTCX+1) 
      DO 10 I=1,NSMTCX 
          XTEMP=X+FLOAT(I)*SMTIC 
          IF((XHI-XTEMP)/XTIC.GE.0) THEN
             CALL PLOTT7(XTEMP,Y,XFACT,YFACT,1,-7) 

             IF ((solid.OR.dashed) .AND. vline) THEN ! make line across
                CALL COLOR(vcolor(2))
                IF (dashed) THEN
                   CALL DASHSZ(dash1,dash2,dash3,dash4)
                   CALL DASHES
                ENDIF
                CALL PLOT(xtemp,Y,0,0) 
                CALL PLOT(xtemp,yacross,1,0)
                CALL PLOT(xtemp,Y,0,0) 
                CALL COLOR(1)
                CALL VECTRS
             ENDIF
          ENDIF

   10 CONTINUE 
      RETURN 
C**  THIS PROGRAM VALID ON FTN4 AND FTN5 ** 
      END 

	SUBROUTINE CD_REC_SYNCH ( cdfid, lo, hi, tmrecax, grid,
     .                            start, axid, vartyp, reset, 
     .                            old_box_hi, new_box_lo, do_bounds,
     .                            status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Determine where along the record axis to write data in a netCDF
* output file
* Extend the record axis if the coordinates given fit into the
* axis ordering
* Check carefully (and laboriously!) to determina if axis point spacing is
* regular

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 3/92
* note: commented out references to line 1000 are to support disordered axes
* 10/92: bug fix: use TM_FPEQ to check time words
*        performance: write time data outside to avoid multiple ncendf calls
* 12/92: pass back vartyp so data type is correct in cd_write_var axis appends
* 1/97:  issues a one-time warning if an irregular time axis is extended
*	 (since the box bounds will not be saved)
* 6/97:  changed "STATIC" to SAVE for f90 compatibility
*	 also moved var assignments off of declaration line *kob*

* V570  *acm* 5/04 Do not issue the warning about irregular record axis,
*                  Bounds are used rather than edges for defining irregular 
*                  axis cell boundaries.  Check whether there is a gap
*                  between the high box-bound of the existing axis and
*                  the low box-bound of the new axis to be appended.
*      *acm* 6/04  for compiler on rh7, need to pass dimensions of array into cd_rd_r8_bnds 
*                  as scalar integers not array elements.
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing

* argument definitions:
*     cdfid   - netCDF id number for already opened CDF file
*     lo      - lowest index from variable grid on record axis
*     hi      - highest index from variable grid on record axis
*     tmrecax - axis number (1-nferdims) of record axis in grid (for errmsg, only)
*     grid    - defining grid for variable
*     start   - file record number for next write (returned)
*     axid    - CDF var no of coordinate variable for record axis

* include files
        include 'netcdf.inc'
#include "gt_lib.parm"
	include 'tmap_dims.parm'
        include 'cd_lib.parm'
        include 'tmap_errors.parm'
        include 'xio.cmn_text'
        external xio_data

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

* argument declarations
      LOGICAL do_bounds
      INTEGER cdfid, lo, hi, tmrecax, start, axid, grid, vartyp, 
     .        reset, status

* local variable declarations:
      LOGICAL CD_GET_ATTRIB, TM_DFPEQ, got_bnds
      INTEGER TM_LENSTR1, 
     .        alen, look, hi_look, lo_look,
     .        ndims, nvars, cdfstat,
     .        nvdim, vdims(8), nvatts,
     .        ngatts, npts, recdim, blen, bndid,
     .        startpts(2), numpts(2),  d1s, d1e, d2s, d2e
      CHARACTER axnam*128, buff*16, bname*30
      CHARACTER*1     dimnam(nferdims)
      DATA dimnam/'I','J','K','L','M','N'/
      CHARACTER*13 TM_STRING

      REAL*8 TM_WORLD, new_coord, hi_val, lo_val, val,
     .       new_box_lo, old_box_hi, hi_val_1

      INTEGER tt  ! nice short name
      EQUIVALENCE (tt,lunit_errors)

* local parameter declarations
      LOGICAL     append, do_warn
      INTEGER     str_eq
      REAL        unspecified_val4
      PARAMETER ( str_eq = 0,
     .            unspecified_val4 = -2E34,
     .            append = .TRUE., do_warn=.TRUE. )

* get the vital statistics for the CDF file
	cdfstat = NF_INQ (cdfid, ndims, nvars, ngatts, recdim)

* get the name of the record axis
        cdfstat = NF_INQ_DIM ( cdfid, recdim, axnam, npts )

        alen = TM_LENSTR1( axnam )

* is there a coordinate variable by this name ?  If not, error (for now)
        cdfstat = NF_INQ_VARID ( cdfid, axnam(:alen), axid )

        IF ( cdfstat .NE. NF_NOERR ) GOTO 5100

* get the vital statistics of the coordinate variable
        cdfstat = NF_INQ_VAR (cdfid, axid, buff, vartyp, nvdim, vdims,
     .                nvatts)

* locate the new coordinate values at end of coordinate axis ?
* see if the first of the new coordinates exceeds the last already in the file
        new_coord = TM_WORLD( lo, grid, tmrecax, box_middle )
        new_box_lo = 0.D0
        old_box_hi = 0.D0
        reset = 0

        IF ( npts .GT. 0 ) THEN
           CALL CD_RD_R8_1( cdfid, axid, npts, vartyp,
     .                      'axis: '//axnam(:alen), hi_val, cdfstat )
           IF ( cdfstat .NE. merr_ok ) GOTO 5900
           CALL CD_RD_R8_1( cdfid, axid, 1, vartyp,
     .                      'axis: '//axnam(:alen), lo_val, cdfstat )
           IF ( cdfstat.NE.merr_ok ) GOTO 5900
* 4/99 *kob* - call to new routine tm_dfpeq for double precision compares
           IF ( TM_DFPEQ(new_coord,hi_val) ) THEN
              start = npts
              GOTO 4000
           ELSEIF ( new_coord .GT. hi_val ) THEN
              start = npts + 1
              GOTO 1000
           ENDIF
        ELSE
           hi_val = unspecified_val8
           start = 1
           GOTO 4000
        ENDIF

* binary search to locate new coordinate in file
* ... initialize search with coordinate of first point
        IF ( TM_DFPEQ(new_coord, lo_val) ) THEN
           start = 1
           GOTO 4000
        ELSEIF ( new_coord .LT. lo_val ) THEN
           GOTO 5200 
        ENDIF
        lo_look = 0
        hi_look = npts + 1
        look = ( lo_look + hi_look ) / 2

* top of search loop
 100    CALL CD_RD_R8_1( cdfid, axid, look, vartyp,
     .                   'axis: '//axnam(:alen), val, cdfstat )
        IF ( cdfstat.NE.merr_ok ) GOTO 5900
        IF ( TM_DFPEQ(new_coord, val) ) THEN
* ... found it
           start = look
           GOTO 1000
        ELSEIF ( hi_look - lo_look .LE. 1 ) THEN
* ... value not on axis
           GOTO 5200
        ELSEIF ( new_coord .GT. val ) THEN
* ... look higher
           IF ( look .EQ. hi_look ) GOTO 5200
           lo_look = look
           lo_val = val
           look = ( look + hi_look + 1 ) / 2
        ELSE
* ... look lower
           IF ( look .EQ. lo_look ) GOTO 5200
           hi_look = look
           hi_val = val
           look = ( look + lo_look + 1 ) / 2
        ENDIF
        GOTO 100

 1000   CONTINUE

* is there a bounds attribute for this axis? 

       got_bnds = CD_GET_ATTRIB( cdfid, axid, 'bounds',
     .                       do_warn, axnam(:alen), bname, blen, 30 )

       IF (got_bnds) THEN

* Always write bounds when appending to axis which has bounds

          do_bounds = .TRUE.  

* Get upper bound of last box on existing axis

          cdfstat = NF_INQ_VARID ( cdfid, bname(:blen), bndid )

          startpts(1) = 2  ! get uppper bound, 1 point
          numpts(1) = 1

* get upper bound of last point to be used on existing axis
          startpts(2) = start-1  
          numpts(2) = 1

          d1s = startpts(1)
          d1e = numpts(1)
          d2s = startpts(2)
          d2e = numpts(2)
          CALL CD_RD_R8_BNDS( cdfid, bndid, startpts, numpts, vartyp, 
     .                    bname(:blen), old_box_hi, d1s, d1e, d2s, d2e,  
     .                    status )

* Get lower bound of first point to be output

          new_box_lo = TM_WORLD( lo, grid, tmrecax, box_lo_lim )

* Reconcile upper bound of last point on existing axis with lower bound of new axis
* reset = 0  no change to bounds is needed
*       = 1  gap between old_hi and new_lo, so add a void point with these as bounds
*       = 2  need to reset new_lo to match old_hi

          IF (TM_DFPEQ(old_box_hi, new_box_lo) ) THEN 
*  no need to adjust; bounds line up.
              reset = 0

          ELSE IF (old_box_hi .LT. new_box_lo) THEN
*  need to add a void point, with bounds [old_box_hi , new_box_lo]
              reset = 1

          ELSE   !  (old_box_hi .GT. new_box_lo) 
             IF (old_box_hi .LT. new_coord) THEN 
*  old_box_hi is between new_box_lo and new_coord, so use old_box_hi for new_box_lo
                reset = 2
                new_box_lo = old_box_hi

             ELSE IF (old_box_hi .GE. new_coord) THEN
                IF (new_box_lo .GT. hi_val) THEN 
*  Issue an error message: high bound of last point of existing axis greater than
*  the first coordinate of points being appended; cannot reset old_box_hi
                   GO TO 5300
                ELSE   
*  new_box_lo is < hi_val, so use old_box_hi for new_box_lo
                   reset = 2
                   new_box_lo = old_box_hi
                ENDIF
             ENDIF
          ENDIF

       ELSE   ! (not got_bnds)

* Check whether we are outputting the next point on a regularly spaced axis.
* If we are skipping points, issue a warning.

          IF (new_coord .GT. hi_val .AND. npts .GT. 1) THEN  

              CALL CD_RD_R8_1( cdfid, axid, npts-1, vartyp,
     .              'axis: '//axnam(:alen), hi_val_1, cdfstat )
              IF (.NOT. TM_DFPEQ(hi_val-hi_val_1, new_coord-hi_val) ) THEN
                 CALL WARN( 
     . 'Appending to NetCDF record axis which has no bounds attribute.')
                 CALL WARN( 
     . 'This will result in incorrect box sizes on record axis: '
     .             // axnam(:alen))
                 CALL WARN( 
     . 'Write the data initially with the /BOUNDS qualifier')
              ENDIF
           ENDIF

       ENDIF

* successful completion
 4000   status = merr_ok
        RETURN

* error exits
 5100  CALL TM_ERRMSG
     .     ( cdfstat+pcdferr, status, 'CD_REC_SYNCH', cdfid, axid,
     .       'axis: '//axnam(:alen), no_errstring, *5900 )
 5200  CALL TM_ERRMSG
     .      ( merr_badlinedef, status, 'CD_REC_SYNCH', no_descfile,
     .        no_stepfile,
     .       'disordered output coordinate value:'
     .       //TM_STRING(new_coord)//' Axis: '//axnam(:alen),
     .       no_errstring , *5900 )
 5300  CALL TM_ERRMSG     
     .      ( merr_badlinedef, status, 'CD_REC_SYNCH', no_descfile,
     .        no_stepfile,
     . 'output coordinate is inside upper bound of existing axis cell:'
     .       //TM_STRING(new_coord)//' Axis: '//axnam(:alen),
     .       no_errstring , *5900 )
 5900  CONTINUE
       cdfstat = NF_REDEF( cdfid ) ! back into define mode

       RETURN
       END

	SUBROUTINE KNOWN_DATA_TYPE ( cx )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* find the data type for the given variable

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V533:  7/01
* V554 1/04 *acm* - add counter_var 
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V698  3/16 *acm* Removed Philander-Seigel code including diagnostic 
*                  variables, pre-defined axes and grids, cat_calc_var.
* V698 3/16 *sh* added logic for cat_ef_time2d (ACTS_LIKE_FVAR)
* V710 *acm* 10/16 Ticket 2422: variables uvar_grid, uvar_data_type, uvar_aux_cat, 
*                  uvar_aux_var to be replaced with calls to LIST routines in NCF_Util.c 

	include	'tmap_dims.parm'
	include	'xdset_info.cmn_text'
	external xdset_info_data
	include	'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'

* calling argument declarations:
	INTEGER	cx

* internal variable declarations:
	LOGICAL ACTS_LIKE_FVAR
	INTEGER	dset, data_set, category, variable, idim, trans, itype

* initialize
	category = cx_category(cx)
	variable = cx_variable(cx)
	data_set = cx_data_set(cx)

* different procedure for determining grid from each category
	IF     ( ACTS_LIKE_FVAR(category) ) THEN

	   cx_type(cx) =  ds_var_type(variable)

	ELSEIF ( category .EQ. cat_user_var ) THEN

* ... allow "abstract" expressions that don't depend on data set
	   IF ( .NOT.uvar_need_dset(variable)
     .	   .OR. data_set .EQ. unspecified_int4 ) THEN
	      dset = pdset_irrelevant
	   ELSE
	      dset = data_set
	   ENDIF
	   
	   CALL GET_SAVED_UVAR_DTYPE(variable, dset, itype)
	   cx_type(cx) = itype

	ELSEIF ( category .EQ. cat_temp_var ) THEN
!! here, variable may be up to 2000, mr_type is dimension 151
	   cx_type(cx) = mr_type( variable )  

	ELSEIF ( category .EQ. cat_counter_var ) THEN

	   cx_type(cx) = ptype_float

	ELSEIF ( category .EQ. cat_attrib_val ) THEN  !should have been set elsewhere

	   IF (cx_type(cx) .EQ. 0 .OR. 
     .         cx_type(cx) .EQ. unspecified_int4 ) 
     .        STOP 'unknown var.att in KNOWN_DATA_TYPE'

	ELSE

	   STOP 'KNOWN_TYP'

	ENDIF

* For string variables the result data type of @NGD and @NBD is float.  
	IF (cx_type(cx) .EQ. ptype_string) THEN
	   DO 100, idim = 1, nferdims
	      trans = cx_trans(idim, cx) 
	      IF (trans .EQ. trans_good_pt    .OR.
     .            trans .EQ. trans_bad_pt     .OR.
     .            trans .EQ. trans_4d_good_pt .OR.
     .            trans .EQ. trans_4d_bad_pt ) THEN
                  cx_type(cx) = ptype_float
       	       ENDIF
 100	   CONTINUE
        ENDIF

	RETURN
	END

        SUBROUTINE VECFLD(U,V,NXS,NYS,PX,PY,XF,YF)

C**
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	*sh* 04-16-90 	Mod to retain VUSRLN for user defined vector lengths
*       *jd* 8.3.92     Mod to add interrupts
*	*jd* 12.92	Mod to handle fields of 0 length vectors
*	*sh* 12/8/93    corrected bug: vectors blow on divide by zero
*       *acm*7/01	apply scaling to vectors when curv. coords.
*       *acm*		NOTE: If this routine plots vectors directly along
*                       the "edge" of the region for modulo axes, try setting
*                       the region to one grid point less than the whole
*                       globe, e.g. /X=0:357.5   When curv_coord_sub.F applies
*			the modulo correction it "interpolates" between two 
*			x values that are the same.  Also see notes in 
*                       ~ansley/ans_ferret/curvilinear/curv_coord_sub.F
*       *acm* 10/01    Remove VMS includes
*       *acm* 10/24/01 Call mark(99) to plot a point when a vector is too small.
*       *acm*  5/02    Bug fix: alen for curvilinear vectors could be 0.
*       *ACM*  8/02    remove the call to plot a point with mark(99) -- need
*                      to resolve PPLUS issues with polymark first
*       *acm*  9/02    Yet another tweak on the length of curvlinear vectors.
*                      Fix the computation of curv_len, page length of vector as 
*                      it is drawn.
*       *acm* 12/02    Restore call to mark(99) polymarker call when vector is
*                      small.  Call doit_makedot after the loop, to plot points in the buffer.
* v5.81 *acm* lengthen string containing format to 40 characters.
* V6.63 *acm* 7/10 Save a symbol PPL_VECLEN containing the Vector Length value
* V6.65 *acm* 10/10 Draw curvilinear vectors as straight lines.
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus
* V684 *adm* 12/12 Changes for VECTOR/MODULO on curvilinear plots.
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long
* V687 *acm* 3/14 tickets 2151 and 2147: allow missing coordinate data in 3-arg 
*                 and 4-arg plot commands. 
* Patrick's example with vector drawn across branch cut.
* V697 *acm* 2/16 Set the symbol PPL_VECLEN even if the plot is not labeled.  

C	ARRAY X HOLD 2 GRIDS, U(X) IN THE FIRST
C	NX BY NY GRID AND V(Y) IN THE SECOND
C
        real xf,yf
        integer nxs,nys
	REAL U(NXS,NYS),V(NXS,NYS),PX(NXS),PY(NYS)
C
C
        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'lines_inc.decl'
        include 'LINES.INC'
        include 'pen_inc.decl'
        include 'PEN.INC'
        include 'cmrd_inc.decl'
        include 'CMRD.INC'
        include 'miss_inc.decl'
        include 'MISS.INC'
        include 'switch_inc.decl'
        include 'SWITCH.INC'
        include 'hd_inc.decl'
        include 'HD.INC'
        include 'axis_inc.decl'
        include 'AXIS.INC'
        include 'labcom_inc.decl'
        include 'LABCOM.INC'
        include 'vector_inc.decl'
        include 'VECTOR.INC'
        include 'xcurvilinear.cmn'
        include 'makedot.cmn'

	real xfuser,yfuser,xlousr,ylousr,zave,xt,yt
	real xx2,yy2,zz,vfact,xtm,ytm,xtx,ytx,xx1,yy1,vx,vy,vclen
	real thfact,xn,yn,xl,yl,dy,dx, alen, big,lmin,lmax, xadd, tol

	logical done_nleft, done_nright
	integer ic,i,j,lnblk,iln, overedge
	integer TM_LENSTR1, slen, i1, i2

	CHARACTER VECLAB*2048, buff*80, symbuff*120
	
	parameter (tol = 140.)

C
C	VECTOR,X,Y,VFACT,LABEL
C

C     Curvilinear coordinates declarations
        integer status, ii
#ifdef double_p
        real*8 x_curv(12), y_curv(12)
#else
        real x_curv(12), y_curv(12)
#endif
        real curv_len, xxc, yyc, tail_i, tail_j, head_i, head_j, 
     .       head_len, tail_i_orig, tail_j_orig

        include         'xinterrupt.cmn' ! 1/89 *sh*
        include         'ppl_in_ferret.cmn'

*******************************************************************************

         veclab = ' '
	    IF(VUSER)THEN
	    	XFUSER=1.
		YFUSER=1.
		YLOUSR=0.
		XLOUSR=0.
	    ELSE
	    	XFUSER=XF
		YFUSER=YF
		XLOUSR=XLO
		YLOUSR=YLO
	    ENDIF
	XT=VXLOC/XFUSER+XLOUSR
	YT=VYLOC/YFUSER+YLOUSR
	IF(VAUTO)THEN
c
c	use average vector length for scale if auto
c
	    IC=0
	    ZAVE=0.0
	    DO 10 I=1,NX,VSKPX
	    DO 10 J=1,NY,VSKPY
	    XX2=U(I,J)
	    YY2=V(I,J)
C
C	TEST FOR MISSING DATA
C
	    IF((ZLE.AND.XX2.LE.CMZLE).OR.
     *	       (ZEQ.AND.XX2.EQ.CMZEQ).OR.
     *	       (ZGE.AND.XX2.GE.CMZGE).OR.
     *	       (ZLE.AND.YY2.LE.CMZLE).OR.
     *	       (ZEQ.AND.YY2.EQ.CMZEQ).OR.
     *	       (ZGE.AND.YY2.GE.CMZGE))GOTO 10
	    ZZ=SQRT(XX2**2+YY2**2)
	    ZAVE=ZAVE+ZZ
	    IC=IC+1
10	    CONTINUE
	    IF(IC.EQ.0)IC=1
*	    Mod to handle field of length 0 vectors *jd* 12.92
	    IF (zave .eq. 0.0) THEN 
	       zave = 0.5
	    else
	       ZAVE=ZAVE/FLOAT(IC)
	    ENDIF
	    VFACT=VLEN/(2.0*ZAVE)
	    vusrln = (2.0*ZAVE)		!  *sh* 4/90
	ELSE
	    VFACT=VLEN/VUSRLN
	ENDIF

	CALL COLOR(IPEN(1))
	call trans(0,xmin,ymin,xtm,ytm)
	call trans(0,xmax,ymax,xtx,ytx)
!*sh*	DX=(xtx-xtm)/(NX-1)
!*sh*	DY=(ytx-ytm)/(NY-1)
	DX=(xtx-xtm)/MAX(NX-1,1)
	DY=(ytx-ytm)/MAX(NY-1,1)
        IPTMD = 0

	big = ABS(CMZGE)
	lmin = -1*big
	lmax = big

	done_nleft  = .FALSE.
	done_nright = .FALSE.
	xadd = 0.

 90	CONTINUE

	DO 100 I=1,NX,VSKPX
	DO 100 J=1,NY,VSKPY
	IF (i.eq.52 .AND. j.eq.76) THEN
	   slen = 1
	ENDIF

        IF (IPTMD .GT. MAXDOT) THEN
           CALL doit_makedot(IPTMD,XDOTMD,YDOTMD)
           IPTMD = 0
        ENDIF

	XX2=U(I,J)
	YY2=V(I,J)
C
C	TEST FOR MISSING DATA
C
	IF((ZLE.AND.XX2.LE.CMZLE).OR.
     *	   (ZEQ.AND.XX2.EQ.CMZEQ).OR.
     *	   (ZGE.AND.XX2.GE.CMZGE).OR.
     *	   (ZLE.AND.YY2.LE.CMZLE).OR.
     *	   (ZEQ.AND.YY2.EQ.CMZEQ).OR.
     *	   (ZGE.AND.YY2.GE.CMZGE))GOTO 100
C
C	TAIL LOCATION USER UNITS
C
	IF(JTYPE.EQ.-1)THEN
	    XX1 = xtm + DX*(I-1)
	    YY1 = ytm + DY*(J-1)
	ELSE
	    call trans(0,px(i),py(j),xx1,yy1)
	ENDIF

 50    IF (curvilinear) THEN   

C  vclen is approx vector length; without curviness.

           vclen = SQRT( (U(I,J)**2) + (V(I,J)**2))

C Set up to plot the vector in pieces to make a curve.

           tail_i = xx1
           tail_j = yy1
           tail_i_orig = xx1
           tail_j_orig = yy1
           x_curv(1)=xx1
           y_curv(1)=yy1
           CALL CURV_COORD(x_curv, y_curv, 1, 1.0, 1.0, status) ! xform the pts
	   IF (curv_missing) GOTO 100

           xx1=x_curv(1)
           yy1=y_curv(1)
           xxc=x_curv(1)	! initialize, in case of bad data in loop 60 below
           yyc=y_curv(1)
           xx1orig = xx1
           yy1orig = yy1

           curv_len = 0.0
           overedge = 0

C Dont draw as a curve. Move to the tail now and when we have reached the end
C then draw the line to the arrow head.

           CALL PLOT(XX1+xadd,YY1,0,0)
	   IF (xadd .EQ. 0) THEN
	      lmin = MIN(lmin, XX1)
              lmax = MAX(lmax, XX1)
	   ENDIF

           DO 60, ii=1, 500

              head_i = tail_i + U(I,J)*vfact/10
              head_j = tail_j + V(I,J)*vfact/10
              head_i = tail_i + U(I,J)*vfact
              head_j = tail_j + V(I,J)*vfact

              IF (head_i .GT. xtx .AND. (.NOT. dim1_modulo)) THEN
                 head_i = xtx
                 overedge = 1
              ENDIF
              IF (head_j .GT. ytx .AND. (.NOT. dim2_modulo)) THEN
                 head_j = ytx
                 overedge = 1
              ENDIF
              IF (head_i .LT. xtm .AND. (.NOT. dim1_modulo)) THEN
                 head_i = xtm
                 overedge = 1
              ENDIF
              IF (head_j .LT. ytm .AND. (.NOT. dim2_modulo)) THEN
                 head_j = ytm
                 overedge = 1
              ENDIF

              x_curv(1) = head_i
              y_curv(1) = head_j

              CALL CURV_COORD(x_curv, y_curv, 1, 1.0, 1.0, status)
	      IF (curv_missing) GOTO 100

              IF (x_curv(1) .ne. cmzeq) xxc = x_curv(1)
              IF (y_curv(1) .ne. cmzeq) yyc = y_curv(1) 

C  curv_len is sum of vector pieces; actual vector length.  When 
C  it is vclen we are done plotting the vector.

C   Note: len = distance from xx1 to xxc, which in page units is
C   equivalent to xxc = xx1 + (len/xf), or len = (xxc-xx1)* xf

              curv_len = curv_len + 
     .           SQRT( ( (xxc-xx1)*xf )**2  +  ( (yyc-yy1)*yf )**2 )

C  If the line goes over the edge, draw to the edge but don't
C  draw an arrow head.
              IF (overedge .EQ. 1) THEN
	         CALL PLOT(xxc+xadd,yyc,1,0)
		 IF (xadd .EQ. 0) THEN
	            lmin = MIN(lmin, xxc)
	            lmax = MAX(lmax, xxc)
		 ENDIF
		 GO TO 80 
              ENDIF

              IF (curv_len .GE. vclen* vfact) GO TO 70

              tail_i = head_i
              tail_j = head_j
              xx1 = xxc
              yy1 = yyc

 60        CONTINUE

 70        CONTINUE

C Has the vector crossed a branch cut? If so don't draw across the plot...
           IF ( ABS((xxc+xadd)-(xx1+xadd)).GT.tol .AND. units_degrees) THEN
	      CALL PLOT(xxc+xadd,yyc,0,0)
	   ELSE
              CALL PLOT(xxc+xadd,yyc,1,0)
	   ENDIF
           IF (xadd .EQ. 0) THEN
	      lmin = MIN(lmin, xxc)
              lmax = MAX(lmax, xxc)
	   ENDIF

C     DRAW ARROW HEADS

	   IF (xxc .NE. cmzeq  .AND. yyc .NE. cmzeq) THEN
              head_len = 2.*curv_len/(xf+yf)
              head_len = 2.*vclen*vfact/(xf+yf)
              CALL vec_arrows(tail_i_orig, tail_j_orig, 
     .           head_i, head_j, head_len, xadd)
	   ENDIF	! draw arrow if xxc and yyc were ok
   80	   CONTINUE	! vector went over edge

        ELSE	! not curvilinear

           XX2 = XX1 + XX2*VFACT/XF
           YY2 = YY1 + YY2*VFACT/YF
C
C	CALC REAL LENGTH
C
           VX=(XX2-XX1)*XF
           VY=(YY2-YY1)*YF
           VCLEN=SQRT(VX**2+VY**2)
C
C	IF VECTOR IS TOO SMALL PLOT A POINT
C
           IF(VCLEN .LT. VMINLN)THEN
	      CALL PLOT(XX1,YY1,0,0)
	      CALL PLOT(XX1,YY1,1,0)
              CALL MARK(DOTSYMIM)
	      GOTO 100
           ENDIF
C
C	SET UP THE ARROW FACTOR HEAD LENGTH SCALE
C
           IF(VCLEN .GT. ARMAX)THEN
	      THFACT=ARMAX*HFACT/VCLEN
           ELSE IF(VCLEN .LT. ARMIN .AND. VCLEN.GT.0.)THEN
	      THFACT=ARMIN*HFACT/VCLEN
           ELSE
	      THFACT=HFACT
           ENDIF
C
C	DRAW ARROW HEADS
C
           XN=XX2+(-VX-.35*VY)*THFACT/XF
           YN=YY2+(-VY+.35*VX)*THFACT/YF
           CALL PLOT(XN,YN,0,0)
           CALL PLOT(XX2,YY2,1,0)
C
           XN=XX2+(-VX+.35*VY)*THFACT/XF
           YN=YY2+(-VY-.35*VX)*THFACT/YF
           CALL PLOT(XN,YN,1,0)
           CALL PLOT(XX2,YY2,1,0)
C
           CALL PLOT(XX1,YY1,1,0)
        ENDIF

100	CONTINUE
	IF (interrupted) goto 3333 ! *jd* 8.3.92

        CALL doit_makedot(IPTMD,XDOTMD,YDOTMD)


C Go back to do modulo replications if curvilinear and /MODULO

	IF (xmodulo .AND. curvilinear) THEN
           xrange = 360
c           IF (.NOT. units_degrees) xrange = wwxmax - wwxmin
           nleft = 0
           nright = 0
           IF (lmin.GT.xlo .OR. lmax.GT.xhi ) nleft =  1
	   IF (lmin.LT.xlo .OR. lmax.LT.xhi ) nright = 1

           IF (nleft .GT. 0 .AND. .NOT.done_nleft) THEN
              xadd = -1.* xrange
	      done_nleft = .TRUE.
	      GOTO 90
	   ENDIF

           IF (nright .GT. 0 .AND. .NOT.done_nright) THEN
              xadd = xrange
	      done_nright = .TRUE.
	      GOTO 90
	   ENDIF
	ENDIF


        IPTMD = 0

C put the vector-length scale into a PPL symbol
	
C   Save the value in a symbol PPL_VECLEN
	WRITE (VECLAB,VFRMT) VLEN/VFACT
	symbuff = 'PPL_VECLEN'
	CALL GETSYM( symbuff, buff, i2, i1 )
	IF ( i1 .EQ. 0 ) CALL DELSYM(symbuff,i1)
	slen = TM_LENSTR1(veclab)
	CALL PUTSYM( symbuff, veclab, slen, i2)
C
C	DRAW SCALE  MAKE SCALE .5 INCH LONG AT XT,YT
C
	IF(.NOT.VKEY)THEN
	    CALL COLOR(IPEN(0))
	    RETURN
	ENDIF
	CALL WINDOW(0.,0.,0.,0.)

C Note don't need different arrow length for curvilinear case.
C it is a standard half inch.

	XX1=XT
	YY1=YT
	XX2=XT+VLEN/XF
	YY2=YT
        alen = vlen
C
C	DRAW ARROW 
C
	IF(alen.GT.ARMAX)THEN
	    THFACT=ARMAX*HFACT/alen
	ELSE IF(alen.LT.ARMIN .AND. alen .GT. 1.e-6)THEN
	    THFACT=ARMIN*HFACT/alen
	ELSE
	    THFACT=HFACT
	ENDIF
	XN=XX2-THFACT*alen/XF
	YN=YY2+.35*THFACT*alen/YF

	CALL PLOT(XN,YN,0,0)
	CALL PLOT(XX2,YY2,1,0)
C
	XN=XX2-THFACT*alen/XF
	YN=YY2-.35*THFACT*alen/YF
	CALL PLOT(XN,YN,1,0)
	CALL PLOT(XX2,YY2,1,0)
C
	CALL PLOT(XX1,YY1,1,0)
C
C	DRAW LABEL
C
	CALL COLOR(IPEN(0))
	WRITE (VECLAB,VFRMT) VLEN/VFACT
	ILN=LNBLK(VECLAB,20)
	XL = XX2 + .125/XF
	YL = YY2 - HLABS*0.5/YF
	CALL SYMBEL(XL,YL,0.,HLABS,ILN,VECLAB)
3333	IF(IWIND.GT.0)CALL WINDOW(XLO,YLO,XHI,YHI)

	RETURN
	END

	SUBROUTINE RQST_REGRID( dst_cx, src_cx, axis, strides, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 


* given a destination context and an axis to be regridded
* determine the source data limits that should be requested ("rqst")

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V200:  12/1/89 - extracted from REGRID_LIMS
* 	 2/26/90 - repaired minor bug in error message
* 	  3/2/90 - changed inequality conditions to allow endpoints exactly =
* V230:  8/22/92 - allow regridding by association and by single axis averaging
*        11/4/92 - expanded variable name length
* V300:  3/16/93 - if destination region doesn't overlap the source region
*                  then request a single point at the closest edge of the src
*                  This allows bad data to be returned instead of an error.
* V402:	 8/16/95 - bug fix: T axis was **assumed** to be calendar
* V420: 10/25/95 - do not let subscript limits (src_lo/hi_ss) exceed bounds
*	11/95	 - request unspec limits for modulo regrid (entire src region)
*		   (1/96 - set cx_given to FALSE ... omitted earlier)
*	 1/96    - shifted @SUM and @NGD to weighted calcs like @AVE
*	 2/96    - issue warning that G=@NRS is not implemented
* V490:  9/97 *kob* - mods to include negative time axis processing
*     10/6/97 *sh*  - added g=@xact regridding 
* V500:  2/99 *sh* - modified behavior when region is unspecified -- request
*		full  dest axis limits of source rather than unspecified limts
*  *kob* 3/99- up VAR_CODE  to 64 chars 
*        5/99 *sh* for netCDF vars of form var[I=1:10:3] pass along the
*		  delta value in cx_delta to be used as a "stride" in I/O 
* V530   3/01 *acm* alternative calendar axes:  Compare timesteps for source and
*		    destination axes with respect to one of the calendars.
* V530:  3/01 *sh* - added prgrd_nearest
*        6/01 *acm* remove redundant calendar=.FALSE. after line 134
* V552 *acm* 4/03- up VAR_CODE  to 128 chars 
* v580 *acm* 11/04 Store cal_id in cx_cal_id, the calendar ID used when  
*                  computing world coordinates
* V671  6/11 *acm*  New 2D linear xy regridding, fixing ticket 1862
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction. The time 
*                  dimension is now an arg to SECS_TO_TSTEP. Note the input 
*                  argument "axis" in this routine is a dimension, 1, 2, ... 
* V695  *acm* 2/15 cx_calendar stores info about calendar formatting of T and F axes
* V696 *acm* 11/15 Added @BIN and @NBIN regridding transforms
* V720: 6/17 *acm* Ticket 2346: new @IIN regridding transform


	include 'tmap_dims.parm'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include 'xrisc.cmn'
	include	'xalgebra.cmn'
	include	'xtext_info.cmn'

* calling argument declarations:
	LOGICAL strides
	INTEGER	src_cx, dst_cx, status

* internal variable declarations:
	LOGICAL	GEOG_LABEL, ITSA_MODULO_REGRID,
     .		last_axis, src_modulo, calendar
	INTEGER	ISUBSCRIPT, CAXIS_LEN, axis, TM_GET_CALENDAR_ID, TM_LENSTR1,
     .		dst_grid, src_grid, src_lo_ss, src_hi_ss,
     .		src_min_ss, src_max_ss, line, src_line,
     .		dst_lo_ss, dst_hi_ss, where_loest, where_hiest, rgrd_trans,
     .	        dst_taxis, src_taxis, dst_cal_id, src_cal_id, dlen, slen
	REAL*8	TWORLD, SECS_TO_TSTEP,
     .		src_lo_ww, src_hi_ww, dst_lo_ww, dst_hi_ww,
     .          tmp_lo_ww, tmp_hi_ww, d2s_lo_ww, d2s_hi_ww
	CHARACTER	VAR_CODE*128, TM_SECS_TO_DATE*20, pdate*20

* initialize
	dst_grid = cx_grid( dst_cx )
	src_grid = cx_grid( src_cx )

* get regrid transform.  remove its flag from the source request
	rgrd_trans = cx_regrid_trans( axis, dst_cx )
	cx_regrid_trans(axis,src_cx) = prgrd_exact

* ! temp kludge - allow regridding to higher dimensioned objects
	IF ( grid_line(axis,src_grid) .EQ. mnormal ) GOTO 1000

* determine if this is a calendar axis and trap illegal attempts
* to regrid between calendar and non-calendar axes.  
* 3/01 *acm* If calendar axis, get calendar id for dest and source calendars.

	IF ( rgrd_trans.NE.prgrd_associate .AND. 
     .       (axis.EQ.t_dim .OR. axis.EQ.f_dim) ) THEN
	   calendar = GEOG_LABEL(axis,dst_grid)
	   IF (GEOG_LABEL(axis,src_grid).NEQV.calendar) GOTO 5010
	   IF (calendar) THEN
	      src_taxis = grid_line(axis, src_grid)
	      src_cal_id = TM_GET_CALENDAR_ID (line_cal_name(src_taxis) )
	      dst_taxis = grid_line(axis, dst_grid)
	      dst_cal_id = TM_GET_CALENDAR_ID (line_cal_name(dst_taxis) )
	   ENDIF

	ELSE
	   calendar = .FALSE.
	ENDIF

* If this is a regridding between different calendars trap illegal attempts
* to regrid with anything except @lin, @asn, or @near
	IF ( calendar  .AND. 
     .      (axis.EQ.t_dim .OR. axis.EQ.f_dim) ) THEN
	   dst_taxis = grid_line(axis, dst_grid ) 
	   src_taxis = grid_line(axis, src_grid )

	   dst_cal_id = TM_GET_CALENDAR_ID (line_cal_name(dst_taxis))
	   src_cal_id = TM_GET_CALENDAR_ID (line_cal_name(src_taxis))
           IF (dst_cal_id .NE. src_cal_id) THEN
               IF (rgrd_trans .NE. prgrd_linear_interp .AND. 
     .		   rgrd_trans .NE. prgrd_xy_lin        .AND. 
     .		   rgrd_trans .NE. prgrd_associate     .AND. 
     .		   rgrd_trans .NE. prgrd_nearest )  GOTO 5020
           ENDIF
	ENDIF

* modulo regridding always requests the entire source region
	IF ( ITSA_MODULO_REGRID(dst_cx,axis) ) GOTO 1000

* for interpolation we need source points surrounding the destination points
* for averaging     we need source area   surrounding the destination area
* for exact match   we need source points aligning w/ the destination points
	IF ( rgrd_trans .EQ. prgrd_linear_interp
     .	   .OR.  rgrd_trans.EQ.prgrd_xy_lin ) THEN
	   where_loest = box_middle
	   where_hiest = box_middle
	ELSEIF ( rgrd_trans.EQ.prgrd_min
     .	   .OR.  rgrd_trans.EQ.prgrd_max ) THEN
	   where_loest = box_lo_lim			! unweighted
	   where_hiest = box_hi_lim
	ELSEIF ( rgrd_trans .EQ. prgrd_xy_ave 
     .      .OR. rgrd_trans .EQ. prgrd_variance
     .      .OR. rgrd_trans .EQ. prgrd_sum
     .      .OR. rgrd_trans .EQ. prgrd_good_pt
     .      .OR. rgrd_trans .EQ. prgrd_average
     .      .OR. rgrd_trans .EQ. prgrd_bin
     .      .OR. rgrd_trans .EQ. prgrd_nbin
     .      .OR. rgrd_trans .EQ. prgrd_iin ) THEN  ! I think @iin is whole box
	   where_loest = box_lo_lim
	   where_hiest = box_hi_lim
	ELSEIF ( rgrd_trans .EQ. prgrd_associate ) THEN
           CONTINUE
	ELSEIF ( rgrd_trans .EQ. prgrd_xact_pts
     .	    .OR. rgrd_trans .EQ. prgrd_nearest ) THEN
	   where_loest = box_middle
	   where_hiest = box_middle
	ELSE
	   CALL ERRMSG( ferr_internal, status, 'rgrd transf', *5000 )
	ENDIF

* locate the necessary destination region (time in secs since BC)
	IF ( cx_lo_ss(dst_cx,axis) .EQ. unspecified_int4 ) THEN
! 2/99 - commented out earlier versions of logic
!* ... if unknown, hope they will get figured out later <-- current on 2/99
!	   GOTO 1000
!* ... error (for now) if limits are unspecified	<-- old on 2/99
!!	   GOTO 5200
* ... always try to fill the entire destination axis
	   dst_lo_ss = 1
	   dst_hi_ss = CAXIS_LEN(axis, dst_cx)
	ELSE
	   dst_lo_ss = cx_lo_ss(dst_cx,axis)
	   dst_hi_ss = cx_hi_ss(dst_cx,axis)
	ENDIF

	CALL GRID_SUBSCRIPT_EXTREMES(src_min_ss, src_max_ss, src_grid, axis)
        IF ( rgrd_trans .EQ. prgrd_associate ) THEN     ! 8/92
* ... regridding by association bypasses all the hard stuff
	   src_lo_ss = src_min_ss
	   src_hi_ss = src_max_ss
           IF     ( dst_lo_ss .GT. src_hi_ss ) THEN   ! 3/93
              src_lo_ss = src_hi_ss                   ! 3/93 request top point
           ELSEIF ( dst_hi_ss .LT. src_lo_ss ) THEN   ! 3/93
              src_hi_ss = src_lo_ss        ! 3/93 request low point (possible?)
           ELSE
	      IF ( dst_lo_ss .GT. src_lo_ss ) src_lo_ss = dst_lo_ss
	      IF ( dst_hi_ss .LT. src_hi_ss ) src_hi_ss = dst_hi_ss
           ENDIF
           GOTO 500
        ELSE
* NOTE:  times expressed as seconds since BC
           dst_lo_ww = TWORLD( dst_lo_ss,dst_grid,axis,where_loest ) 
	   dst_hi_ww = TWORLD( dst_hi_ss,dst_grid,axis,where_hiest )
        ENDIF

* check to make sure destination region overlaps the source region
* (temporarily use src_**_ww for axis extremes)
* 3/01 *acm* If different calendars, do comparison wrt source calendar...

	src_modulo = line_modulo( grid_line(axis,src_grid) )
	IF ( .NOT. src_modulo ) THEN
	   CALL GRID_SUBSCRIPT_EXTREMES(src_lo_ss, src_hi_ss, src_grid, axis)
	   src_lo_ww = TWORLD( src_lo_ss,src_grid,axis,where_loest )
	   src_hi_ww = TWORLD( src_hi_ss,src_grid,axis,where_hiest )

! (3/2)    IF ( dst_lo_ww.GE.src_hi_ww .OR. dst_hi_ww.LE.src_lo_ww ) GOTO 5100
! (3/93)   IF ( dst_lo_ww.GT.src_hi_ww .OR. dst_hi_ww.LT.src_lo_ww ) GOTO 5100

           IF (calendar .AND. src_cal_id .NE. dst_cal_id) THEN
              CALL reset_secs_from_bc (dst_lo_ww, tmp_lo_ww, 
     .                                 dst_cal_id, src_cal_id, status)
	      IF ( status .NE. ferr_ok ) GOTO 5000
	      CALL reset_secs_from_bc (dst_hi_ww, tmp_hi_ww, 
     .                                 dst_cal_id, src_cal_id, status)
	      IF ( status .NE. ferr_ok ) GOTO 5000
	   ELSE
	      tmp_lo_ww = dst_lo_ww
	      tmp_hi_ww = dst_hi_ww
	   ENDIF

           IF     ( tmp_lo_ww .GT. src_hi_ww ) THEN   ! 3/93
              src_lo_ss = src_hi_ss                   ! 3/93 request top point
              GOTO 500                                ! 3/93
           ELSEIF ( tmp_hi_ww .LT. src_lo_ww ) THEN   ! 3/93
              src_hi_ss = src_lo_ss                   ! 3/93 request low point
              GOTO 500                                ! 3/93
           ENDIF
	ENDIF

* which source grid boxes contain the destination region

* 9/97 *kob* convert time in secs since BC to time position on the 
*             *source* time axis then call ISUBSCRIPT
	IF ( calendar ) THEN

* 3/01 *acm* Get timesteps for dst range wrt source calendar
	   IF (dst_cal_id .NE. src_cal_id) THEN
              CALL reset_secs_from_bc (dst_lo_ww, d2s_lo_ww, 
     .                                 dst_cal_id, src_cal_id, status)
	      IF ( status .NE. ferr_ok ) GOTO 5000
              CALL reset_secs_from_bc (dst_hi_ww, d2s_hi_ww, 
     .                                 dst_cal_id, src_cal_id, status)
	      IF ( status .NE. ferr_ok ) GOTO 5000
	   ELSE
	      d2s_lo_ww = dst_lo_ww
	      d2s_hi_ww = dst_hi_ww
	   ENDIF

	   tmp_lo_ww = SECS_TO_TSTEP( src_grid, axis, d2s_lo_ww)
	   tmp_hi_ww = SECS_TO_TSTEP( src_grid, axis, d2s_hi_ww)

	   src_lo_ss = ISUBSCRIPT( tmp_lo_ww,src_grid,axis,round_dn )
	   src_hi_ss = ISUBSCRIPT( tmp_hi_ww,src_grid,axis,round_up )
	ELSE
	   src_lo_ss = ISUBSCRIPT( dst_lo_ww,src_grid,axis,round_dn )
	   src_hi_ss = ISUBSCRIPT( dst_hi_ww,src_grid,axis,round_up )
	ENDIF
* 9/97 *kob* now convert to ss values


* determine the maximum regriddable region from this source data
	src_lo_ww = TWORLD( src_lo_ss, src_grid, axis, where_loest )
	src_hi_ww = TWORLD( src_hi_ss, src_grid, axis, where_hiest )

* if this isn't sufficient, expand it
* 10/95:  Avoid expanding beyond the axis limits.  This becomes necessary
*  despite the call to CONFINE_AXIS because dynamic grids contexts are immune
*  from CONFINE_CONTEXT as a result of uvar_given = uvlim_gvn_gnl

* 3/01 *acm* If different calendars, do comparison wrt dst calendar...

        IF (calendar .AND. dst_cal_id .NE. src_cal_id) THEN
	   tmp_lo_ww = d2s_lo_ww
	   tmp_hi_ww = d2s_hi_ww
	ELSE
	   tmp_lo_ww = dst_lo_ww
	   tmp_hi_ww = dst_hi_ww
	ENDIF

	IF ( tmp_lo_ww .LT. src_lo_ww
     . .AND. src_lo_ss .GT. src_min_ss ) src_lo_ss = src_lo_ss - 1
	IF ( tmp_hi_ww .GT. src_hi_ww
     . .AND. src_hi_ss .LT. src_max_ss ) src_hi_ss = src_hi_ss + 1

* flesh out the resulting axis
 500    cx_by_ss( axis, src_cx ) = .TRUE.
	cx_lo_ss( src_cx, axis ) = src_lo_ss
	cx_hi_ss( src_cx, axis ) = src_hi_ss
	CALL CONFINE_AXIS( axis, src_cx, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	CALL FLESH_OUT_AXIS( axis, src_cx, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* (5/99) flag the use of netCDF strides by inserting cx_delta value
	IF (strides) THEN
	   line = grid_line(axis,dst_grid)
	   IF (line_regular(line)) THEN
	      src_line  = grid_line(axis,src_grid)
	      cx_delta(axis,src_cx) = line_delta(line)
     .				    / line_delta(src_line)
	   ELSE
	      cx_delta(axis,src_cx) = line_delta(line)
	   ENDIF
	ENDIF

* success
	RETURN

* set axis region as still unknown at this stage
 1000	cx_lo_ss( src_cx, axis )	= unspecified_int4
	cx_hi_ss( src_cx, axis )	= unspecified_int4
	cx_lo_ww( axis, src_cx )	= unspecified_val8
	cx_hi_ww( axis, src_cx )	= unspecified_val8
	cx_given( axis, src_cx )	= .FALSE.
* 9/97 *kob* - cx_calendar needs to also reflect these changes
	IF (axis .eq. t_dim .OR. axis .eq. f_dim) THEN
           cx_calendar(axis,src_cx) = .FALSE.
           cx_cal_id(src_cx) = unspecified_int4
        ENDIF

	RETURN

* error exit
 5000	RETURN
 5010	CALL ERRMSG( ferr_regrid, status,
     .		'only @ASN regridding between calendar and '//pCR
     .		//'non-calendar axes: '//
     .		VAR_CODE(cx_category(dst_cx),cx_variable(dst_cx)), *5000)
 5020	CONTINUE

	slen = TM_LENSTR1 (line_cal_name(src_taxis))
	dlen = TM_LENSTR1 (line_cal_name(dst_taxis))
	WRITE (risc_buff, *) 'only @ASN, @LIN, or @NRST regridding ',
     .		'between calendar types: ',
     .		line_cal_name(src_taxis)(:slen),', ', 
     .		line_cal_name(dst_taxis)(:dlen)
	CALL ERRMSG( ferr_regrid, status, risc_buff, *5000)
! 5100	CALL ERRMSG( ferr_limits, status,
!     .		'regrid region outside source data '//ww_dim_name(axis)//
!     .		' axis range: '//
!     .		VAR_CODE(cx_category(dst_cx),cx_variable(dst_cx)), *5000)
! 5200	CALL ERRMSG( ferr_limits, status,
!     .		'regrid requires limits given on '//ww_dim_name(axis)//
!     .		' axis of '//
!     .		VAR_CODE(cx_category(dst_cx),cx_variable(dst_cx)), *5000)
	END

*
* is_element_of.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* March 2003
*
*  Return logical value (integer 1 or 0); If argument 1 takes on any of 
*  the values of the second argument, return 1, else 0.

*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE is_element_of_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      CHARACTER*100 fcn_desc
      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns 1 if first argument contains any of the ',
     .        'values in argument 2, else 0')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 2)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, ABSTRACT, 
     .     NORMAL, NORMAL, NORMAL)

      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'VAR')
      CALL ef_set_arg_desc(id, arg, 'data to test')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'VALUES')
      CALL ef_set_arg_desc(id, arg, 'values to search for')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE is_element_of_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      INTEGER my_lo_l, my_hi_l

*
*     Use utility functions to get context information about the arguments.
*     Set the abstract X axis.
*

      my_lo_l = 1
      my_hi_l = 1
      CALL ef_set_axis_limits(id, X_AXIS, my_lo_l, my_hi_l)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE is_element_of_compute(id, arg_1, arg_2, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .     mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .     mem2lot:mem2hit)
     .     
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .      memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      INTEGER id
      INTEGER i, j, k, l
      INTEGER i1, j1, k1, l1
      INTEGER i2, j2, k2, l2

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

C  Check for values matching arg2

      i = res_lo_ss(X_AXIS)
      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      l = res_lo_ss(T_AXIS)

      result(i,j,k,l) = 0.

      DO 400 i2=arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS, ARG2)
      DO 300 j2=arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS, ARG2)
      DO 200 k2=arg_lo_ss(Z_AXIS,ARG2), arg_hi_ss(Z_AXIS, ARG2)
      DO 100 l2=arg_lo_ss(T_AXIS,ARG2), arg_hi_ss(T_AXIS, ARG2)

         DO 410 i1=arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS, ARG1)
         DO 310 j1=arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS, ARG1)
         DO 210 k1=arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS, ARG1)
         DO 110 l1=arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS, ARG1)

            IF ( arg_1(i1,j1,k1,l1) .NE. bad_flag(1) .AND.
     .           arg_2(i2,j2,k2,l2) .NE. bad_flag(2)) THEN

               IF (arg_1(i1,j1,k1,l1) .EQ. arg_2(i2,j2,k2,l2) ) THEN
                  result(i,j,k,l) = 1.
                  GO TO 9000
               ENDIF
            ENDIF

 110     CONTINUE
 210     CONTINUE
 310     CONTINUE
 410     CONTINUE

 100  CONTINUE
 200  CONTINUE
 300  CONTINUE
 400  CONTINUE
      
9000  RETURN

      END
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

	SUBROUTINE GET_DSET_PARMS( dset, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* get parameter values for data set - 1st set defaults, then read (if possible)
* from the 205 data base, then over-ride using any parameters given in the
* descriptor

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 2/11/88
* revision 0.1 - 4/28/88 - get parameters from 205 data base
* revision 0.2 - 6/22/88 - allow SIEG and SEIG interchangeably
*			 - warning only for invalid 205 data base entry
* revision 0.3 - 7/1/88  - allow multiple air temp climatologies
*			 - add dp_Am_factor
* revision 1.0 -11/17/88 - new io library and grid common
* revision 1.1 - 4/19/89 - changed AIRT logic so that 3-letter code is read
*			   from 205 data base.  "LEV" is still default.
* Unix/RISC port 5/91 *sh*: changed runs data base file name
*               8/29/91 - added add'l parm "NTS30 WIND STRESS CALC"
* V320: 12/29/94 - use SPLIT_LIST to redirect tty output for GUI
* V420: 9/95 - using TM_ITSA_MODEL_RUN TMAP runs are now recognizable from
* 		their file names, alone.  Parameters are then read from the
*		205 run data base.
*       *acm* 3/12 changes for 6D Ferret

	include 'ferret.parm'
	include 'errmsg.parm'
	include 'tmap_dims.parm'
	include 'tmap_errors.parm'
	include 'xdset_parms.cmn'
	include 'xprog_state.cmn'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xrisc.cmn'          ! 12/94 SPLIT_LIST buffer

* calling argument declarations
	INTEGER	dset, num_prev_gridfiles, status

* local variable declarations
	LOGICAL	TM_HAS_STRING, TM_DIGIT, TM_ITSA_MODEL_RUN
	INTEGER	TM_LENSTR1,
     .		NEXT205, TMAP_status, dummy, i, slen, iclim
	CHARACTER	TM_EXP_CODE*6, col_head*132, table_row*132,
     .			entry*64, entry_nam*64

* parameter definitions
	INTEGER	    max_dset_parms
	PARAMETER ( max_dset_parms = 15 )	! to match *DSET_INFO.CMN

* Philander/Siegel model output ? (Sieg or Seig)
	dp_phil_sieg( dset ) = TM_HAS_STRING( ds_source(dset), 'PHIL' )
     .			 .AND. ( TM_HAS_STRING( ds_source(dset), 'SIEG' )
     .			    .OR. TM_HAS_STRING( ds_source(dset), 'SEIG' ) )

* 9/95 - may conclude it is a TMAP model run based on file name, too
* (the term "Philander/Siegel" has been commandeered for all TMAp runs)
	IF (.NOT.dp_phil_sieg(dset)) dp_phil_sieg(dset) =TM_ITSA_MODEL_RUN
     .					(ds_name(dset),
     .					 ds_source(dset),
     .					 ds_expnum(dset)  )

* Cox model output ?
	dp_cox( dset )	 = TM_HAS_STRING( ds_source(dset), 'COX' )

* something unknown ?
	IF (   ds_source(dset) .NE. ' '
     .	.AND. .NOT.dp_phil_sieg(dset)
     .	.AND. .NOT.dp_cox(dset) ) THEN
	   WRITE ( risc_buff, 3020 )
     .		ds_source(dset)( :TM_LENSTR1( ds_source(dset) ) ),
     .		ds_name(dset)( :TM_LENSTR1( ds_name(dset) ) )
	   CALL WARN ( risc_buff )
	ENDIF

* tropical Pacific (160x100x27) grid ?
	dp_trop_pacific( dset ) = TM_HAS_STRING( ds_subsource(dset), 'TROP' )
     .			    .AND. TM_HAS_STRING( ds_subsource(dset), 'PAC'  )

********* PHILANDER/COX parameters ****************************
* * * * INITIALIZE PARAMETER DEFAULTS * * * * 
	dp_min_wind	( dset ) = 488.
	dp_phil_qflux	( dset ) = .TRUE.
	dp_ramp1_qflux	( dset ) = .FALSE.
	dp_ramp2_qflux	( dset ) = .FALSE.
	dp_clim_air_sst	( dset ) = 1		! LEVITUS
	dp_const_air_sst( dset ) = .TRUE.
	dp_delta_air_sst( dset ) = 1.0
	dp_Am_factor	( dset ) = 2.0
        dp_nts30_wind   ( dset ) = .FALSE.

* * * *  CHECK THE 205 DATA BASE * * * * 
	IF ( dp_phil_sieg(dset).OR.dp_cox(dset) ) THEN
* get the table heading line and row containing this experiment code
	   CALL TM_GET_205_RUN_LINE
     .		( 'model_runs.doc', TM_EXP_CODE(dset), col_head, table_row,
     .			TMAP_status )	
	   IF ( TMAP_status .NE. merr_ok ) THEN
	      CALL WARN ('Model run parameters not available')
	      CALL WARN ('Diagnostic variable results may be incorrect')
	      GOTO 500
	   ENDIF

* ... MINIMUM WIND
	   ASSIGN 110 TO NEXT205
	   entry_nam = 'WND'
	   CALL TM_GET_205_RUN_PARM
     .		( entry_nam, col_head, table_row, entry, slen, TMAP_status )
	   IF ( TMAP_status .NE. merr_ok ) GOTO 5010
	   IF ( .NOT.TM_DIGIT(entry) ) GOTO 5010
	   READ ( entry, *, ERR=5010 ) dp_min_wind(dset)

* ... HEAT FLUX PARAMETERIZATION
 110	   ASSIGN 120 TO NEXT205
	   entry_nam = 'FLUX'
	   CALL TM_GET_205_RUN_PARM
     .		( entry_nam, col_head, table_row, entry, slen, TMAP_status )
	   IF ( TMAP_status .NE. merr_ok ) GOTO 5010
	   dp_phil_qflux  ( dset ) = TM_HAS_STRING( entry, 'PHIL' )
	   dp_ramp1_qflux ( dset ) = TM_HAS_STRING( entry, 'RAMP1' )
	   dp_ramp2_qflux ( dset ) = TM_HAS_STRING( entry, 'RAMP2' )
	   IF ( .NOT.dp_phil_qflux( dset )
     .	  .AND. .NOT.dp_ramp1_qflux( dset )
     .	  .AND. .NOT.dp_ramp2_qflux( dset ) ) GOTO 5010

* ... AIR/SST DELTA TEMP (a value or "CLIM")
 120	   ASSIGN 130 TO NEXT205
	   entry_nam = 'SEAT'
	   CALL TM_GET_205_RUN_PARM
     .		( entry_nam, col_head, table_row, entry, slen, TMAP_status )
	   IF ( TMAP_status .NE. merr_ok ) GOTO 5010
	   IF ( TM_DIGIT( entry ) ) THEN
	      READ ( entry, '(F24.0)', ERR=5010 ) dp_delta_air_sst(dset)
	      dp_delta_air_sst( dset ) = -dp_delta_air_sst(dset) ! neg. stored
	      dp_const_air_sst( dset ) = .TRUE.
	   ELSE
	      IF ( entry(:4) .NE. 'CLIM' ) GOTO 5010
	      dp_const_air_sst( dset ) = .FALSE.
	   ENDIF

* ... CLIMATOLOGICAL AIR TEMP FIELD
 130	   ASSIGN 140 TO NEXT205
	   entry_nam = 'AIR'
	   CALL TM_GET_205_RUN_PARM
     .		( entry_nam, col_head, table_row, entry, slen, TMAP_status )
	   IF ( TMAP_status .NE. merr_ok ) GOTO 5010
	   DO 135 iclim = 1, max_airt_clim
	      IF ( dp_airt_name(iclim) .EQ. unspecified_name4 ) GOTO 137
	      IF ( TM_HAS_STRING(entry,dp_airt_name(iclim)) ) THEN
* ... this 3-letter AIRT code is already known: point data set to it
	         dp_clim_air_sst ( dset ) = iclim
	         GOTO 140
	      ENDIF
 135	   CONTINUE
* ... a new 3-letter code but no room to store it
	   GOTO 5030
* ... a new 3-letter code: save it and point data set to it
 137	   dp_airt_name( iclim )   = entry
	   dp_clim_air_sst( dset ) = iclim

* ... Am FACTOR - HORIZONTAL MOMENTUM DIFFUSION
 140	   ASSIGN 500 TO NEXT205
	   entry_nam = 'Am'
	   CALL TM_GET_205_RUN_PARM
     .		( entry_nam, col_head, table_row, entry, slen, TMAP_status )
	   IF ( TMAP_status .NE. merr_ok ) GOTO 5010
	   IF ( .NOT.TM_DIGIT( entry ) ) GOTO 5010
	   READ ( entry, '(F24.0)', ERR=5010 ) dp_Am_factor(dset)
	ENDIF

* * * * DESCRIPTOR PARAMETERS * * * *
* "name" = "value"
 500	DO 590 i = 1, max_dset_parms

	   entry_nam = ds_parm_name(i,dset)
	   IF ( entry_nam .EQ. ' ' ) THEN
	      GOTO 590
	   ELSE
	      entry = ds_parm_text(i,dset)
	   ENDIF

* ... "HEAT FLUX = PHILANDER/SIEGEL" or "HEAT FLUX = DOUBLE RAMP", etc.
	   IF ( TM_HAS_STRING( entry_nam, 'HEAT FLUX'	) )THEN
	      dp_phil_qflux  ( dset ) = TM_HAS_STRING( entry, 'PHIL' )
	      dp_ramp1_qflux ( dset ) = TM_HAS_STRING( entry, 'SINGLE' )
	      dp_ramp2_qflux ( dset ) = TM_HAS_STRING( entry, 'DOUBLE' )

* ... "AIR-SEA DELTA T = value,"LEV","CAC",... "?
	   ELSEIF ( TM_HAS_STRING( entry_nam, 'AIR-SEA DELTA T'	) ) THEN
	   IF ( TM_DIGIT( entry ) ) THEN
	      READ ( entry, '(F24.0)', ERR=5010 ) dp_delta_air_sst(dset)
	      dp_delta_air_sst( dset ) = -dp_delta_air_sst(dset) ! neg. stored
	      dp_const_air_sst( dset ) = .TRUE.
	      dp_clim_air_sst ( dset ) = unspecified_int4
	   ELSE
	      DO 510 iclim = 1, max_airt_clim
	         IF ( TM_HAS_STRING(entry,dp_airt_name(iclim)) ) THEN
	            dp_const_air_sst( dset ) = .FALSE.
	            dp_clim_air_sst ( dset ) = iclim
	            GOTO 590
	         ENDIF
 510	      CONTINUE
	      GOTO 5020
	   ENDIF

* ... "MINIMUM WIND = 488."
	   ELSEIF ( TM_HAS_STRING( entry_nam, 'MINIMUM WIND' ) ) THEN
	      IF ( entry .EQ. ' ' ) GOTO 5020
	      IF ( TM_DIGIT( entry ) ) THEN
	         READ ( entry, *, ERR=5020 ) dp_min_wind(dset)
	      ELSE
	         GOTO 5020
	      ENDIF

* ... "Am_factor = 2.0"
	   ELSEIF ( TM_HAS_STRING( entry_nam, 'Am_factor' ) ) THEN
	      IF ( entry .EQ. ' ' ) GOTO 5020
	      IF ( TM_DIGIT( entry ) ) THEN
	         READ ( entry, *, ERR=5020 ) dp_Am_factor(dset)
	         IF ( dp_Am_factor(dset) .LT. 0.0 ) GOTO 5020
	      ELSE
	         GOTO 5020
	      ENDIF

* ... "205_AIRT = "LEV","CAC", "ALV", etc.
*     (flag this data set as containing climatological air temp ?)
	   ELSEIF ( TM_HAS_STRING( entry_nam, '205_AIRT' ) ) THEN
	      DO 550 iclim = 1, max_airt_clim
	         IF ( dp_airt_name(iclim) .EQ. unspecified_name4 ) THEN
*	... fill blank AIRT slot with this AIRT 3-letter code
	            dp_airt_name(iclim) = entry(:3)
	            dp_airt_dset(iclim) = dset
	            GOTO 590
	         ELSEIF (TM_HAS_STRING(entry,dp_airt_name(iclim)) ) THEN
*	... point this data set at the already specified 3-letter AIRT code
	            IF ( dp_airt_dset(iclim) .EQ. unspecified_int4 ) THEN
	               dp_airt_dset(iclim) = dset
	               GOTO 590
	            ELSE
	              GOTO 5019
	            ENDIF
	         ENDIF
 550	      CONTINUE
*	... no blank AIRT slots for this AIRT set
	      GOTO 5030

* ... "NTS30 WIND STRESS MODIFICATION"
	   ELSEIF ( TM_HAS_STRING( entry_nam, 'NTS30 WIND' ) ) THEN
              dp_nts30_wind( dset ) = .TRUE.

* ... parameter not recognized
	   ELSEIF ( dp_phil_sieg(dset).OR.dp_cox(dset) ) THEN
	      WRITE ( risc_buff, 3020 )
     .		entry_nam( :TM_LENSTR1( entry_nam ) ),
     .		ds_name(dset)( :TM_LENSTR1( ds_name(dset) ) )
 3020	      FORMAT( ' Warning: unrecognized parameter ', A,
     .					  ' in data set ', A )
	      CALL WARN ( risc_buff )
	   ENDIF

 590	CONTINUE

* successful completion
	status = ferr_ok
	RETURN

* syntax error
 5000	RETURN

 5010	CALL WARN('Invalid entry in model run data base')
	CALL WARN('Data set: '//ds_name(dset)(:TM_LENSTR1(ds_name(dset))))
	CALL WARN('Column:'//entry_nam(:TM_LENSTR1(entry_nam)))
	CALL WARN('Field:'//entry(:slen))
	CALL WARN( 'Continuing with errors ...')
	GOTO NEXT205
 5019	CALL WARN( 'MULTIPLE DSETS CLAIM TO BE SAME AIR TEMPERATURE SET')
 5020	CALL ERRMSG( ferr_descriptor, status,
     .		ds_name(dset)( :TM_LENSTR1( ds_name(dset) ) )//' : "'//
     .		entry_nam(:TM_LENSTR1(entry_nam))//'='//
     .		entry(:TM_LENSTR1(entry))//'"',
     .		*5000 )
 5030	CALL ERRMSG( ferr_prog_limit, status,
     .		ds_name(dset)( :TM_LENSTR1( ds_name(dset) ) )//
     .		' :no room for air temp data set '// entry(:4),
     .		*5000 )

	END

	SUBROUTINE SET_FILL_AREA_REP (zwsid,zwstype)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Setup the fill area indices for patterns or colors depending on
*	workstation characteristics

*	J Davison JISAO/PMEL/TMAP
*	9.2.88
*	JD modified 3.15.89 to support additional workstation types
*	2.18.92 *jd* mod to support ATC GKS

	integer	zwsid,zwstype

#ifdef unix
	include		'ws_types.cmn'
#else
	include		'tmap_pplv11inc:ws_types.inc'
#endif

******************************************************************************
#ifdef atc_gks
	if (zwstype/100 .eq. ws_xwindow/100 .or. zwstype .eq. ws_uis) then
#else
	if (zwstype .eq. ws_xwindow .or. zwstype .eq. ws_uis) then
#endif
*	   XWINDOW (OR UIS) WS
	   call ws_fill_rep (zwsid,zwstype)

	else if (zwstype .eq. ws_ps_mono .or. zwstype .eq. ws_tek4014) then
*	   MONOCHROME HATCHING
	   call hatch_fill_rep (zwsid)

	else if (zwstype .eq. ws_tek4107) then
*	   TEK 4107
	   call tek4107_fill_rep (zwsid)

	else
*	   SETUP DEFAULT FILL AREA BUNDLES
	   call ws_fill_rep (zwsid,zwstype)
	end if

	return

	end

	SUBROUTINE SAY_INTERRUPTED

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* write a text string "**INTERRUPTED**" on the plot

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 1/24/89

#ifdef unix
	include 'axis_inc.decl'
	include 'AXIS.INC'
#else
	INCLUDE 'TMAP_PPLV11INC:AXIS_INC.DECL'
	INCLUDE 'PPLV11INC:AXIS.INC'
#endif

	REAL	x, y, ang, ht, wid, strwid
	CHARACTER string*32
!	REAL	SYMWID		! used once to determine string width

	DATA	ang   / 0.0  /
	DATA	ht    / 0.25 /
	DATA	string/ '@TI** INTERRUPTED **' /
	DATA	strwid/ 3.595 /	! result of "SYMWID( ht, 17, string(4:) )"

	wid = strwid * ((xhi-xlo)/xlen)
	x   = (xlo+xhi-wid)*.5 
	y   = (ylo+yhi)*.5

	CALL SYMBEL( x, y, ang, ht, 20, string )

	RETURN
	END

	SUBROUTINE DD1STEP (	idim, shf, com_lo, com_hi, box,
     .				com, com_mr,
     .				res, res_mr, res_cx )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute a 1 step derivative of the component along axis idim
* note: for a forward  derivative shf=0, and com limits are res_lo:res_hi+1
*       for a backward derivative shf=1, and com limits are res_lo-1:res_hi

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  6/6/89
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN & com_lo/hi
* V230: 5/6/92 - COS correction checks that J location is defined
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
*       2/12 *kms* Include E and F dimensions (use nferdims in tmap_dims.parm)
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xunits.cmn_text'
	external xunits_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data


* calling argument declarations:
	INTEGER	idim, shf, com_mr, com_lo, com_hi, res_mr, res_cx
	REAL	box( com_lo:com_hi ),
     .          com( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          res( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif )

* internal variable declarations:
	LOGICAL	GEOG_COS_FACTOR, ITSA_TRUEMONTH_AXIS, need_cos
	INTEGER i, j, k, l, m, n, ii, grid,
     .          lo_sub(nferdims), hi_sub(nferdims), axis
	REAL	bad_com, bad_res, lo_com, hi_com, unit, cos_factor,
     .          ybxlo, ybxhi, bx
	REAL*8	TM_WORLD, lo_ww, hi_ww

* internal (convenience) equivalences
	INTEGER	lo_s1, lo_s2, lo_s3, lo_s4, lo_s5, lo_s6,
     .          hi_s1, hi_s2, hi_s3, hi_s4, hi_s5, hi_s6
	EQUIVALENCE (lo_s1, lo_sub(1)) , (lo_s2, lo_sub(2)),
     .		    (lo_s3, lo_sub(3)) , (lo_s4, lo_sub(4)),
     .		    (lo_s5, lo_sub(5)) , (lo_s6, lo_sub(6)),
     .		    (hi_s1, hi_sub(1)) , (hi_s2, hi_sub(2)),
     .		    (hi_s3, hi_sub(3)) , (hi_s4, hi_sub(4)),
     .		    (hi_s5, hi_sub(5)) , (hi_s6, hi_sub(6))

* initialize
	grid    = mr_grid( res_mr )
	axis    = grid_line( idim, grid )
	bad_com = mr_bad_data( res_mr )
	bad_res = mr_bad_data( com_mr )

* compute limits within which calculation is possible
	DO 10 ii = 1, nferdims
	   lo_sub(ii) = cx_lo_ss(res_cx,ii)
	   hi_sub(ii) = cx_hi_ss(res_cx,ii)
 10	CONTINUE
	lo_sub(idim) = ( com_lo     ) + shf
	hi_sub(idim) = ( com_hi - 1 ) + shf

* create an array of delta H increments
	lo_ww = TM_WORLD( lo_sub(idim)-shf, grid, idim, box_middle )
	DO 20 ii = lo_sub(idim), hi_sub(idim)
	   hi_ww = TM_WORLD( ii+1-shf, grid, idim, box_middle )
	   box(ii) = hi_ww - lo_ww
	   lo_ww = hi_ww
 20	CONTINUE

* perform differentiation in standard units if possible
	unit = un_convert( line_unit_code(axis) )
	IF (ITSA_TRUEMONTH_AXIS(axis)) unit = un_convert(pun_day)

	DO 30 ii = lo_sub(idim), hi_sub(idim)
 30	box(ii) = box(ii) * unit

* DERIVATIVE ALONG X AXIS
	IF ( idim .EQ. x_dim ) THEN
	   need_cos = GEOG_COS_FACTOR( idim, grid )
     .                .AND. lo_s2.NE.unspecified_int4
	   DO 110 j = lo_s2, hi_s2
	   IF ( need_cos ) THEN
#ifdef double_p
	      cos_factor = COS( deg2rad *       
     .            TM_WORLD(j, grid, y_dim, box_middle) ) 
              ybxlo = deg2rad* 
     .            TM_WORLD(j,grid,y_dim,box_lo_lim)
              ybxhi = deg2rad* 
     .            TM_WORLD(j,grid,y_dim,box_hi_lim)
#else
	      cos_factor = COS( deg2rad *       
     .            SNGL( TM_WORLD(j, grid, y_dim, box_middle) ) ) 
              ybxlo = deg2rad* 
     .            SNGL( TM_WORLD(j,grid,y_dim,box_lo_lim) )
              ybxhi = deg2rad* 
     .            SNGL( TM_WORLD(j,grid,y_dim,box_hi_lim) )
#endif
              bx = ABS(ybxhi - ybxlo)
	      cos_factor = ABS( SIN(ybxhi) - SIN(ybxlo) )/ bx
	   ENDIF

	   DO 110 n = lo_s6, hi_s6
	   DO 110 m = lo_s5, hi_s5
	   DO 110 l = lo_s4, hi_s4
	   DO 110 k = lo_s3, hi_s3
	      lo_com = com(lo_s1-shf,j,k,l,m,n)
	      DO 100 i = lo_s1, hi_s1
	         hi_com = com(i+1-shf,j,k,l,m,n)
	         IF ( lo_com.EQ.bad_res .OR. hi_com.EQ.bad_res ) THEN
	            res(i,j,k,l,m,n) = bad_res
	         ELSE
	            res(i,j,k,l,m,n) = (hi_com-lo_com) / box(i)
	            IF ( need_cos )
     .                 res(i,j,k,l,m,n) = res(i,j,k,l,m,n)/cos_factor
	         ENDIF
	         lo_com = hi_com
 100	      CONTINUE
 110	   CONTINUE

* DERIVATIVE ALONG Y AXIS
	ELSEIF ( idim .EQ. y_dim ) THEN
	   DO 210 n = lo_s6, hi_s6
	   DO 210 m = lo_s5, hi_s5
	   DO 210 l = lo_s4, hi_s4
	   DO 210 k = lo_s3, hi_s3
	   DO 210 i = lo_s1, hi_s1
	      lo_com = com(i,lo_s2-shf,k,l,m,n)
	      DO 200 j = lo_s2, hi_s2
	         hi_com = com(i,j+1-shf,k,l,m,n)
	         IF ( lo_com.EQ.bad_res .OR. hi_com.EQ.bad_res ) THEN
	            res(i,j,k,l,m,n) = bad_res
	         ELSE
	            res(i,j,k,l,m,n) = (hi_com-lo_com) / box(j)
	         ENDIF
	         lo_com = hi_com
 200	      CONTINUE
 210	   CONTINUE

* DERIVATIVE ALONG Z AXIS
	ELSEIF ( idim .EQ. z_dim ) THEN
	   DO 310 n = lo_s6, hi_s6
	   DO 310 m = lo_s5, hi_s5
	   DO 310 l = lo_s4, hi_s4
	   DO 310 j = lo_s2, hi_s2
	   DO 310 i = lo_s1, hi_s1
	      lo_com = com(i,j,lo_s3-shf,l,m,n)
	      DO 300 k = lo_s3, hi_s3
	         hi_com = com(i,j,k+1-shf,l,m,n)
	         IF ( lo_com.EQ.bad_res .OR. hi_com.EQ.bad_res ) THEN
	            res(i,j,k,l,m,n) = bad_res
	         ELSE
	            res(i,j,k,l,m,n) = (hi_com-lo_com) / box(k)
	         ENDIF
	         lo_com = hi_com
 300	      CONTINUE
 310	   CONTINUE

* DERIVATIVE ALONG T AXIS
	ELSEIF ( idim .EQ. t_dim ) THEN
	   DO 410 n = lo_s6, hi_s6
	   DO 410 m = lo_s5, hi_s5
	   DO 410 k = lo_s3, hi_s3
	   DO 410 j = lo_s2, hi_s2
	   DO 410 i = lo_s1, hi_s1
	      lo_com = com(i,j,k,lo_s4-shf,m,n)
	      DO 400 l = lo_s4, hi_s4
	         hi_com = com(i,j,k,l+1-shf,m,n)
	         IF ( lo_com.EQ.bad_res .OR. hi_com.EQ.bad_res ) THEN
	            res(i,j,k,l,m,n) = bad_res
	         ELSE
	            res(i,j,k,l,m,n) = (hi_com-lo_com) / box(l)
	         ENDIF
	         lo_com = hi_com
 400	      CONTINUE
 410	   CONTINUE

* DERIVATIVE ALONG E AXIS
	ELSEIF ( idim .EQ. e_dim ) THEN
	   DO 510 n = lo_s6, hi_s6
	   DO 510 l = lo_s4, hi_s4
	   DO 510 k = lo_s3, hi_s3
	   DO 510 j = lo_s2, hi_s2
	   DO 510 i = lo_s1, hi_s1
	      lo_com = com(i,j,k,l,lo_s5-shf,n)
	      DO 500 m = lo_s5, hi_s5
	         hi_com = com(i,j,k,l,m+1-shf,n)
	         IF ( lo_com.EQ.bad_res .OR. hi_com.EQ.bad_res ) THEN
	            res(i,j,k,l,m,n) = bad_res
	         ELSE
	            res(i,j,k,l,m,n) = (hi_com-lo_com) / box(m)
	         ENDIF
	         lo_com = hi_com
 500	      CONTINUE
 510	   CONTINUE

* DERIVATIVE ALONG F AXIS
	ELSEIF ( idim .EQ. f_dim ) THEN
	   DO 610 m = lo_s5, hi_s5
	   DO 610 l = lo_s4, hi_s4
	   DO 610 k = lo_s3, hi_s3
	   DO 610 j = lo_s2, hi_s2
	   DO 610 i = lo_s1, hi_s1
	      lo_com = com(i,j,k,l,m,lo_s6-shf)
	      DO 600 n = lo_s6, hi_s6
	         hi_com = com(i,j,k,l,m,n+1-shf)
	         IF ( lo_com.EQ.bad_res .OR. hi_com.EQ.bad_res ) THEN
	            res(i,j,k,l,m,n) = bad_res
	         ELSE
	            res(i,j,k,l,m,n) = (hi_com-lo_com) / box(n)
	         ENDIF
	         lo_com = hi_com
 600	      CONTINUE
 610	   CONTINUE

* TODO: derivative along E and F axes?

* DERIVATIVE ALONG UNSUPPORTED AXIS
	ELSE
           STOP '**ERROR: DD1STEP on unsupported axis'
	ENDIF

	RETURN
	END

	SUBROUTINE DEFINE_CLIMAT_ATT (src_cx)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke March 2016
* V698 *acm*  3/16 Ticket 2278: add an attribute with time range when
*                  saving a modulo-regridded variable to netCDF

        IMPLICIT NONE
        include 'tmap_dims.parm'
        include 'ferret.parm'
	include 'xcontext.cmn'
	include 'xtra_compute_attr.cmn'


* calling argument declarations:
	INTEGER src_cx

* internal variable declarations:
	LOGICAL ssame
        INTEGER TM_LENSTR1, STR_SAME, grid, loss, hiss, slen, iprec
	CHARACTER*128 str1, str2
	REAL*8 TM_WORLD, loww, hiww, wwnext

	grid = cx_grid(src_cx)
	loss = cx_lo_ss(src_cx, t_dim)
	hiss = cx_hi_ss(src_cx, t_dim)

* Show month-year using the grid midpoints of the date range

	loww = TM_WORLD (loss, grid, t_dim, box_middle)
	hiww = TM_WORLD (hiss, grid, t_dim, box_middle)

	iprec = 2

	CALL TSTEP_TO_DATE ( grid, t_dim, loww, iprec, str1 )
      
	slen = TM_LENSTR1(str1)
	CALL TSTEP_TO_DATE ( grid, t_dim, hiww, iprec, str2 )

	str1 = str1(:slen)//':'//str2
	

* First check that this isn't already set.  If it is, and if the 
* new value of the string is different, we will not set the attrib.

	IF (natt_computed_var.GT.0) THEN  
	   slen = STR_SAME (attstr_computed_var, str1)
	   IF (STR_SAME (attname_computed_var, 'climatology_time_range') .NE. 0) 
     .                attstr_computed_var = 'do not set. another extra attribute already defined'
	   IF ( STR_SAME (attstr_computed_var, str1) .NE. 0) 
     .                attstr_computed_var = 'Multiple time ranges used'
	ELSE
	   natt_computed_var = 1
	   attname_computed_var = 'climatology_time_range'
	   attstr_computed_var = str1
	ENDIF

	RETURN
	END

C======================================================================

      subroutine buffer_fillpoly (xarg,yarg,npts,index)

#ifdef unix
        include         'xinterrupt.cmn' ! 1/89 *sh*
        include         'ppl_in_ferret.cmn'
        include         'shade_vars.cmn'
#else
        INCLUDE         'TMAP_PPLV11INC:XINTERRUPT.CMN' ! 1/89 *sh*
        INCLUDE         'TMAP_PPLV11INC:PPL_IN_FERRET.CMN'
        INCLUDE         'tmap_pplv11inc:tmap_shade_vars.inc'
#endif

*     J Davison 2.4.99

*     BUFFER_FILLPOLY() called when entire grid cell is a single color; when
*     color changes construct new polygon from individual cells and fill
*     it in FLUSH_BUFFERED_FILLPOLY().

      real xarg(*), yarg(*)
      integer npts, index, i

      buffer_empty = .false.
      num_buffered = num_buffered + 1

      if (npts .eq. 3 .and. num_buffered .eq. 1)
     .     upper_first = upperflg

      do 10 i = 1, npts
         xbuff(i,num_buffered) = xarg(i)         
         ybuff(i,num_buffered) = yarg(i)
 10   end do

      ilast = index + 1

      return
      end

        SUBROUTINE CD_GET_DSG_INSTANCE_VAR(dset, cdfid, ivcd, ivtm, vdims, 
     .                       nvdim, npts, idim, stored_lm, errstr, status)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*.
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Set up a special DSG instance variable from a netCDF dataset

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* v720 4/2017 *sh*
* V74+ 4/18 *acm* Getting DSG grids
* V74+ 4/18 *acm* Allow for the NCEI-style datasets which are one feature
*                 per file but they put the obs variables on 2D grids, 
*                 temp(feature, nobs)
* V74+ 6/18 *acm* Store the min and max row-size lengths in attribute actual_range
* V74+ 6/18 *acm* Apply time units and calendar from the file
* V741 7/18 *acm* Handle missing-flags and details of bad or missing coordinates
* V74+ 7/18 *acm* Working with a rowsize variable that we have synthesized 
*                 when there's not one in the file. 
* V74+ 7/18 *acm* More robust handling of coordinate ranges
* V74+ 7/18 *acm* Attempt to set positive-up or positive-down for Z coordinates
* V74+ 8/18 *acm* For timeseries or trajectory plots, ignore an invalid Z-coordinate
*                 variable as a coordinate
* v751 *acm*  6/19 Allow for longer strings as attribute values - std names -->256
* v751 *acm* 11/19 Don't warn of constant lon/lat e.g. for single-station timeseries or Profiles
* V7.6 *acm* 6/20 Issue 1980: When possible open invalid DSG datasets anyway with NOTES.

* argument definitions:
*       cdfid     - netCDF id number for already opened CDF file
*       dset      - dataset number for already opened CDF file
*       ivcd      - netCDF variable id number
*       ivtm      - XDSET_INFO COMMON variable number
*       vdims     - var may be on a 1-by-npts grid
*       nvdim     - number of dims, 1 or 2
*       npts      - number of values to read into memory
*       idim      - orientation of the coordinate (or "0" for rowSize)
*       stored_lm - dynamic memory line number of the instance variable read from the file 
*       status    - return status

* include files
        include 'netcdf.inc'
        include 'tmap_errors.parm'
        include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
        include 'xbuild_grids.cmn'
        include 'xdset_info.cmn_text'
        external xdset_info_data
        include 'xio.cmn_text'
        external xio_data
        include 'xdyn_linemem.cmn_text'
        include 'xtm_grid.cmn_text'
        include 'xunits.cmn_text'

* argument declarations
        INTEGER  cdfid, dset, ivcd, ivtm, npts, idim, stored_lm, 
     .           vdims(*), nvdim, status
	CHARACTER*(*) errstr

* local variable declarations:
        LOGICAL NC_GET_ATTRIB, TM_HAS_STRING, got_it, ok_cal, has_bad, got_z
        INTEGER TM_LENSTR1, TM_UNIT_ID, STR_SAME, 
     .          TM_GET_CALENDAR_ID, TM_UNITS_CAL, STR_UPCASE,
     .          dtype, attlen, vlen, attoutflag, iaxis,
     .          start(2), numpts(2), i, vtype, since_t0, days_neg4713,
     .		units, cal_id, slen, flen
        REAL    vals(2), delta, coord, coord_min, coord_max, bad
        CHARACTER CD_DSG_FEATURENAME*20, axname*9, buff*256, ftrname*20

* local parameter declaration
	LOGICAL	    do_warn
        INTEGER maxlen
        INTEGER*8 rqst_n
        PARAMETER (maxlen = 256      ,   ! size of std_name
     .		   do_warn = .TRUE. )

* If there was no RowSize variable the line is 1 long, npts = 1
* coord should be the # of obs

* initialize
        vlen = TM_LENSTR1(ds_var_code(ivtm))

	ftrname = CD_DSG_FEATURENAME( dsg_orientation(dset))
	flen = TM_LENSTR1(ftrname)


* allocate memory for the variable
        rqst_n = npts
        CALL TM_GET_LM_DYNMEM(rqst_n, stored_lm, status)
        IF (status .NE. merr_ok) GOTO 5000

* read the 1D variable from the file
        dtype = 0    ! never used

	IF (ivcd .LT. 0) THEN
	   coord = dsg_obs_dimlen(dset)
	   CALL PUT_LINE_COORD ( dsg_linemem(stored_lm)%ptr, 1, coord )   

	ELSE
	   IF (nvdim .EQ. 1) THEN
              CALL CD_RD_R8_ARR( cdfid, ivcd, 1, npts, dtype,
     .                          "reading "//ds_var_code(ivtm)(:vlen)
     .                          //" for DSG",
     .                           dsg_linemem(stored_lm)%ptr, status )
	   ELSE
	      start(1) = 1
	      start(2) = 1
	      numpts(1) = npts
	      numpts(2) = 1
	      CALL CD_RD_R8_BNDS( cdfid, ivcd, start, numpts, dtype,
     .                          "reading "//ds_var_code(ivtm)(:vlen)
     .                          //" for DSG",
     .                           dsg_linemem(stored_lm)%ptr, 
     .                           1, 1, 1, npts, status )
	   ENDIF
	ENDIF

        IF (status .NE. merr_ok) GOTO 5100

        IF (idim .EQ. pdsg_row_size) THEN


* Get the missing and fill-value attributes, use them to set ds_bad_flag.
* Consolidate to one bad-value 

	   CALL CD_GET_BAD_FLAGS (dset, ABS(ivcd), ds_bad_flag(ivtm), 
     .         ds_missing_flag(ivtm), bad_r8, 
     .         dsg_linemem(stored_lm)%ptr, npts)


* *** create the instance (E) axis for the dataset
	   axname = "features"
           iaxis = 0
	   CALL TM_MAKE_BASIC_AXIS( axname, 1.0D0, 1.0D0, npts,
     .				    iaxis, status )
	   IF ( status .NE. merr_ok ) GOTO 5000
	   line_direction(iaxis) = axis_orients(E_dim)
	   line_units(iaxis)    = un_name(pun_instance)
* ... save this axis to be used during grid creation
	   dsg_instance_axis = iaxis

* Does it have an actual_range attribute?  If not compute one and store it.

	   IF (ivcd .LT. 0 ) THEN

	      coord_min = dsg_obs_dimlen(dset)
	      coord_max = dsg_obs_dimlen(dset)
	      got_it = .FALSE.
	      ivcd = ABS(ivcd)

	   ELSE
	      got_it = NC_GET_ATTRIB( dset, ivcd, 'actual_range',
     .                 do_warn, ds_var_code(ivtm)(:vlen),
     .                 maxlen, attlen, attoutflag, 
     .                 buff, vals )

* Check it and also test for missing values. Cannot have missing row-size data
	      
	      bad = ds_bad_flag(ivtm)
	      coord_min = arbitrary_large_val8
	      coord_max = -1*arbitrary_large_val8

	      DO i = 1, lm_size(stored_lm)
	         coord = dsg_linemem(stored_lm)%ptr(i)
	         IF (coord .EQ. bad) GOTO 5300
	         IF (coord .LT. coord_min) coord_min = coord
	         IF (coord .GT. coord_max) coord_max = coord
	      ENDDO

     	   ENDIF ! < 0

* here could compare vals(1), coord_min and vals(2), coord_max
* Store the attribute actual_range

     	   IF (.NOT. got_it) THEN
              CALL CD_GET_VAR_TYPE (dset, ivcd, ds_var_code(ivtm), vtype, status)

              attlen = 2
              attoutflag = 0
              vals(1) = coord_min
              vals(2) = coord_max
              CALL CD_PUT_NEW_ATTR (dset, ivcd, 'actual_range', 
     .              vtype, attlen, attoutflag, buff, vals, status) 
     	   ENDIF


        ELSE  ! pdsg_row_size

* Get the missing and fill-value attributes, use them to set ds_bad_flag.
* Consolidate to one bad-value 

	   CALL CD_GET_BAD_FLAGS (dset, ivcd, ds_bad_flag(ivtm), 
     .         ds_missing_flag(ivtm), bad_r8, dsg_linemem(stored_lm)%ptr, npts)
     
	   bad = ds_bad_flag(ivtm)

* Missing coordinate data is not allowed. For now just in Time
* DSGTBD: tools to fill in missing-coordinates? 

	   IF (idim .EQ. T_dim) THEN
	      DO i = 1, lm_size(stored_lm)
                 coord = dsg_linemem(stored_lm)%ptr(i)
                 IF (coord .EQ. bad) GOTO 5400
	      ENDDO
	   ENDIF

* *** create a coordinate axis corresponding to this variable
*     disallow missing coordinate data.

* ... find the extremes of this coordinate variable
	   CALL CD_GET_DSG_COORD_EXTREMES(dset, ivcd, ivtm,
     .      idim, coord_min, coord_max, status)

	   IF (status.NE.merr_ok .OR. coord_min.EQ.arbitrary_large_val8 ) THEN
	      IF (idim .EQ. z_dim .AND. dsg_orientation(dset).EQ.Z_dim) THEN
	         GOTO 5600
	      ELSE
	         GOTO 5700  
	      ENDIF
	   ENDIF

* ...  Basic checks on data ranges   dsg_orientation(dset).EQ.Z_dim
*      Allow constant time, lon, lat on profile data, 
*      or constant lon,lat on timeseries data or profile data
*      or constant depth on timeseries or trajectory data.  For this case,
*      we just ignore depth as a coordinate

	   IF (coord_min.EQ.coord_max .AND. idim.EQ.t_dim ) THEN 
	      IF (dsg_feature_type(dset) .EQ. pfeatureType_profile
     .           .AND. lm_size(stored_lm) .GT. 1) THEN 
	         CALL WARN ('Constant time step in '//ftrname(:flen)//'  file.')	     
	      ELSE
	         GOTO 5500
	      ENDIF
	   ENDIF
	   
	   IF (coord_min.EQ.coord_max .AND. (idim.EQ.x_dim .OR. idim.EQ.y_dim)  
     .        .AND. lm_size(stored_lm) .GT. 1
     .        .AND. (dsg_feature_type(dset) .EQ. pfeatureType_profile 
     .         .OR.  dsg_feature_type(dset) .EQ. pfeatureType_TimeSeries) ) THEN 
	         CALL WARN ('Constant lon/lat in '//ftrname(:flen)//' file.')	     
	   ENDIF

	   IF (coord_min.EQ.coord_max .AND. idim.EQ.z_dim) THEN 
	      IF (dsg_feature_type(dset) .EQ. pfeatureType_TimeSeries
     .         .OR. dsg_feature_type(dset) .EQ. pfeatureType_Trajectory ) THEN
	         GOTO 5700 
	      ELSE IF (dsg_feature_type(dset).EQ.pfeatureType_profile) THEN
	         GOTO 5600
	      ENDIF
	   ENDIF

* ... create a simple axis
	   axname = "FEATURE_"//axis_dimname(idim) ! e.g. "FEATURE_T"
           IF (npts.EQ.1) THEN
              delta = 1.  ! arbitrary
           ELSE
	      delta = (coord_max-coord_min)/DBLE(npts-1)
           ENDIF
           iaxis = 0
	   CALL TM_MAKE_BASIC_AXIS( axname, coord_min, delta, npts,
     .				    iaxis, status )
	   IF ( status .NE. merr_ok ) GOTO 5100
	   line_direction(iaxis) = axis_orients(idim)

	   line_name_orig(iaxis) = ds_var_code(ivtm)
 
* ... decode and insert units

           got_it = NC_GET_ATTRIB( dset, ivcd, 'units',
     .                 do_warn, ds_var_code(ivtm)(:vlen),
     .                 maxlen, attlen, attoutflag, 
     .                 line_units(iaxis), vals )
           line_unit_code(iaxis) = TM_UNIT_ID(line_units(iaxis))

           IF (idim .EQ. T_dim) THEN

              IF (.NOT. got_it .OR. STR_SAME (buff(1:4), 'none') .EQ. 0) GOTO 5100 ! units = 'none'

* calendar if given
              line_cal_name(iaxis) = 'GREGORIAN'   ! default
              got_it = NC_GET_ATTRIB( dset, ivcd, 'calendar',
     .                 do_warn, ds_var_code(ivtm)(:vlen),
     .                 maxlen, attlen, attoutflag, 
     .                 buff, vals )
              IF (got_it) THEN
                 CALL CD_GET_CALENDAR_NAME( buff, ok_cal)
                 IF (.NOT.ok_cal) GOTO 5100  ! bad calendar attribute
		 line_cal_name(iaxis) = buff
              ENDIF

              cal_id = TM_GET_CALENDAR_ID (line_cal_name(iaxis))
 
* time origin
	      buff = line_units(iaxis)
	      since_T0 = MAX( INDEX(buff,'since'), INDEX(buff,'SINCE') )
              IF ( since_T0 .GT. 2 ) THEN
                 line_units(iaxis) = buff(:since_T0-1)  ! just the "tunits" part 

                 slen = TM_LENSTR1(buff)
                 IF ( slen .GT. since_T0 + 5) THEN
	 
                    CALL CD_GET_TIME_UNITS (buff, cal_id, line_units(iaxis), 
     .			            line_t0(iaxis), days_neg4713, status)
                    IF (status .NE. merr_ok) GOTO 5000

* Named calendar with unit=month or year gets length according to calendar's year length.
                    units = TM_UNIT_ID( line_units(iaxis) )
                    units = TM_UNITS_CAL( units, cal_id, .FALSE. )
		    
                    line_unit_code(iaxis) = units
                    line_tunit(iaxis) = un_convert(line_unit_code(iaxis))
                 ELSE
	            GOTO 5200
		 ENDIF

              ELSE  ! since_t0
	         GOTO 5200
              ENDIF

           ENDIF

* Variable has an axis attribute saying Z but we don't know if it's positve-up or down.
* Check for attributes. Start with an arbitrary assumption of profile datasets.

           IF (idim .EQ. z_dim) THEN
	      got_z = .FALSE.

	      IF (dsg_feature_type(dset) .EQ. pfeatureType_profile) 
     .            line_direction(iaxis) = axis_orients(7) 

* is there a standard name indicating height or altitude/
	      got_it = NC_GET_ATTRIB( dset, ivcd, 'standard_name',
     .                 do_warn, ds_var_code(ivtm), maxlen, attlen, attoutflag, 
     .                 buff, vals )

	      IF (got_it) THEN  
	         IF ( TM_HAS_STRING(buff, 'height') ) line_direction(iaxis) = axis_orients(idim)
	         IF ( TM_HAS_STRING(buff, 'altitude') ) line_direction(iaxis) = axis_orients(idim)
	         IF ( TM_HAS_STRING(buff, 'depth') ) line_direction(iaxis) = axis_orients(7)
	         got_z = .TRUE.
	      ENDIF

* is there an attribute positive= ? Not in the standard, but it would help us here.
	      got_it = NC_GET_ATTRIB( dset, ivcd, 'positive',
     .                 do_warn, ds_var_code(ivtm), maxlen, attlen, attoutflag, 
     .                 buff, vals )

	      IF (.NOT.got_z .AND. got_it) THEN
	         IF ( TM_HAS_STRING(buff, 'UP') ) THEN
		    line_direction(iaxis) = 'DU'
		    got_z = .TRUE.
	         ENDIF

	         IF ( TM_HAS_STRING(buff, 'DOWN') ) THEN
		    line_direction(iaxis) = 'UD'
		    got_z = .TRUE.
	         ENDIF

	      ENDIF

           ENDIF

! DSGTBD: need to think through how to handle longitude ranges -- ERDDAP
! always encodes using 0:360, which breaks Pacific ocean regions

! DSGTBD: users can get to the coordinates of a DSG via pseudo-vars. Need more?
! Maybe insert global dataset attributes here that point to
! the coordinate variable names, e.g. ':dsg_x = "longitude";'
! Note that I created a new routine utl/set_var_att_val.F to make it quicker
! to define new attributes ... though in the end I didn't use it.

* ... assign this axis to the dataset
           ds_basic_axes(idim,dset) = iaxis
        ENDIF

* save other important DSG feature axis information
        IF (idim .EQ. dsg_orientation(dset)) THEN
	   dsg_obs_axis	= iaxis    ! makes life easy during grid creation
	   dsg_obs_dimlen(dset) = npts
! DSGTBD: Are there feature types with no time axis? no lon/lat?
!         for now requiring x, y, t, and depth/height is optional. 7/18

	   IF (idim .EQ. T_dim) ds_time_axis(dset) = iaxis

        ENDIF   ! pdsg_row_size

* flag that this is a DSG axis
	line_dsg_dset(iaxis) = dset

* successful completion
        RETURN

* error exit
 5000   RETURN

* Corrupted coordinate variable or other errors.

 5100   CALL TM_FREE_LM_DYNMEM(stored_lm)
        stored_lm = int4_init
        GOTO 5000
 
 5200   CALL WARN ('Time coordinate must have calendar units: Time units are:'//
     .   line_units(iaxis)(:TM_LENSTR1(line_units)) )
        status = 0   ! soft error
        GOTO 5100
 
 5300	errstr = 'Missing values in the RowSize variable: '//
     .   ds_var_code(ivtm)(:vlen) 
        status = merr_dsg_grid
        GOTO 5100

 5400   CALL WARN ('Missing values in coordinate variable: '//
     .   ds_var_code(ivtm)(:vlen) )
        status = 0   ! soft error
        GOTO 5100

 5500	errstr = 'Corrupted time coordinates in DSG file: '
     .                  //ds_var_code(ivtm)(:vlen)  
        status = merr_dsg_grid
        GOTO 5100

 5600   errstr = 'Corrupted vertical coordinate in DSG profile; no range or all missing: '
     .                  //ds_var_code(ivtm)(:vlen) 
        status = merr_dsg_grid
        GOTO 5100
	
 5700   CONTINUE
* bad coords in depth/altitude for a trajectory or timeseries dataset. 
* Get rid of this as a coord and continue.
        status = 0   ! soft error
        GOTO 5100

        END

* ef_get_string_arg_element_sub.F
*
*  acm 12/03  from ef_get_arg_string
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* This returns an element of the string array which was passed as an argument
* to the function.  
*
* Inside this subroutine arg is an array of pointers (cast as real*8),
* and we can call GET_STRING_ELEMENT to get a string element.
*
*       3/12 *kms* Added E and F dimensions
* V691+*acm* 8/14  Fix ticket 2190: long strings were being cut off.
*

      SUBROUTINE EF_GET_STRING_ARG_ELEMENT_SUB( lox, hix, loy, hiy,
     .                  loz, hiz, lot, hit, loe, hie, lof, hif, arg,
     .                  i, j, k, l, m, n, max_line_len, slen, text )

      INTEGER i, j, k, l, m, n,
     .        lox, hix, loy, hiy, loz, hiz, 
     .        lot, hit, loe, hie, lof, hif,
     .        slen, max_line_len
      CHARACTER*(*) text
      REAL*8 arg(lox:hix, loy:hiy, loz:hiz, lot:hit, loe:hie, lof:hif)

      CHARACTER GET_STRING_ELEMENT*2048

      text = GET_STRING_ELEMENT(lox, hix, loy, hiy, loz, hiz,
     .                          lot, hit, loe, hie, lof, hif, arg,
     .                          i, j, k, l, m, n, max_line_len, slen)

      RETURN
      END

      SUBROUTINE TIME1(I1,ITIME1,I2,ITIME2,I3,ITIME3,DT)               
C start of FERRET mod
C given a time, itime1, in WHOI format (ie, a date) and its corresponding time
C step value, i1 - compute either the date (itime3)  corresponding to another
C time step (i2) or the time step (i3) corresponding to another date (itime2)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* note DAYJ is not included in this module although it is in the TIME1.FOR file
* from PPLUS :
C	Directory PMEL:[PLOT5.LIBRARY.MILELIB]
C	TIME1.FOR;2               5   2-FEB-1985 10:13 
C search for "FERRET" to find all revisions
C *sh* 9/23/88 - rev 1.0 for FERRET 1.10+
C - eliminated JDAY and DAYJ which convert dates to and from minutes since
C	  1970 ("J"="JULIAN") in favor of WHOI2BC and BC2WHOI based on Jan.1, 0
C	  to work around JDAY bug with the year "00"
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
C explicit declarations:
      INTEGER		i1, i2, i3
      INTEGER		iyr, imon, iday, ihr, imin
      REAL		dt
      REAL*8		WHOI2BC, t1, t2
      CHARACTER*14      BC2WHOI
C end of FERRET mods 9-22-88

*	Mod J Davison 11.21.95 For 4 digit year

                                           
C     THIS ROUTINE DOES TIME CALCULATIONS.                             
C         I1 = NUMBER OF A POINT IN OUR SERIES FOR WHICH THE TIME      
C              OF OCCURRENCE OS KNOWN.                                 
C         ITIME1 = THE KNOWN TIME OF OCCURRENCE IN WOODSHOLE FORMAT.   
C         I2,ITIME2 = CONTROL VARIBLES.                                
C             ONE OF THESE MUST BE 0.  THE OTHER MUST BE >= TO THE     
C             THE CORRESPONDING 1 VARIBLE.  IF I2>0 I3=I2 AND          
C             ITIME3= TIME PT I2 OCCURS.  IF ITIME2 .NE.0, I2=0,I3     
C             =POINT TIME ITIME2 OCCURS, AND ITIME3 = EXACT TIME POINT 
C             I3 OCCURS.                                               
C         DT = SAMPLING RATE IN SECONDS.                               
                                                                      
C     THIS PROGRAM WAS MODIFIFIED IN JUNE,1980.  AT THAT TIME WE       
C     TRYED TO IMPROVE THE EFFICIENCY OF THIS PROGRAM.                 
                                                                      
C     SETTING DEFAULTS.                                                
      INTEGER*4 JTIME1,JT,JTIME2,JDAY
      CHARACTER*(*) ITIME1,ITIME2,ITIME3
      CHARACTER*14 ITIME

C	FIND POINT AT WHICH ITIME2 OCCURS

      IF(I2.EQ.0)THEN
      CALL  TIME3(ITIME1,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
      JTIME1=JDAY(IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
      CALL TIME3(ITIME2,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
      JTIME2=JDAY(IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
      I3=FLOAT(JTIME2-JTIME1)/DT+.5
#ifdef unix
      JTIME2=INT(FLOAT(I3)*DT)+JTIME1
#else
      JTIME2=JINT(FLOAT(I3)*DT)+JTIME1
#endif
      I3=I3+I1
      CALL  DAYJ(JTIME2,IYR,IMON,IDAY,IHR,IMIN)
      WRITE(ITIME3,999)IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN
      ELSE
30	I3=I2

C	FIND ITIME3 BY POINT I2.

C FERRET mod 9/23/88 *sh*
C original code:
C	CALL TIME3(ITIME1,IYR,IMON,IDAY,IHR,IMIN)
C	JTIME1=JDAY(IYR,IMON,IDAY,IHR,IMIN)
C	JTIME2=JTIME1+JINT(FLOAT(I3-I1)*DT)
C	CALL DAYJ(JTIME2,IYR,IMON,IDAY,IHR,IMIN)
C	WRITE(ITIME3,999)IYR,IMON,IDAY,IHR,IMIN
C new code:
        T1     = WHOI2BC( itime1 )
        T2     = T1 + DBLE( (I3-I1) * DT )
        ITIME3 = BC2WHOI( T2 )
C end of FERRET mod 9/23/88 *sh*
999	FORMAT(7I2.2)
      ENDIF
      RETURN
      END

*     *jd* 3.11.92 added subroutine DAYJ from plotlib/time1.f
*     To prevent linking warnings 
        SUBROUTINE DAYJ(JDAY,IY,IMN,ID,IH,IM)
        INTEGER*4 JDAY,JDN
        JDN=JDAY/1440
        IY=INT((JDN-122.1)/365.25)
#ifdef unix
        IMN=INT((JDN-INT(365.25*IY))/30.6001)
        ID=JDN-INT(365.25*IY)-INT(30.6001*IMN)
#else
        IMN=INT((JDN-JINT(365.25*IY))/30.6001)
        ID=JDN-JINT(365.25*IY)-JINT(30.6001*IMN)
#endif
        IF(IMN.LT.14)THEN
        IMN=IMN-1
        ELSE
        IMN=IMN-13
        IY=IY+1
        ENDIF
        LEFT=JDAY-(JDAY/1440)*1440
        IH=(LEFT/60)
        IM=LEFT-60*IH
        RETURN
        END

        SUBROUTINE FINALIZE_FERRET

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*  free allocated memory held in global variables/lists
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

        IMPLICIT NONE
        include 'tmap_errors.parm'  ! error codes
        include 'tmap_dims.parm'
#include "tmap_dset.parm"
        include 'xio.cmn_text'
        include 'xdset_info.cmn_text'
        external xio_data
        include 'xtm_grid.cmn_text'
        external xgt_grid_data
        include 'ferret.parm'
        include 'gfdl_vms.parm'
        include 'errmsg.parm'
        include 'gfdl.parm'   ! from phil/sieg
        include 'xonedim.cmn'  ! from phil.sieg
        include 'xfr_grid.cmn'
        include 'xprog_state.cmn'
        include 'xplot_state.cmn'
        include 'xalgebra.cmn'
        include 'xvariables.cmn'
        include 'xtoday.cmn'

        INTEGER ITS_BATCH_GRAPHICS

C       Local variables
        INTEGER j, k, istatus, cmnd_stack_level

C       Silently process commands to clean everything up 
C       (primarily for PyFerret, but also memory leak detection)

C       Close some files that could still be open
        IF ( jrnl_lun .NE. unspecified_int4 ) THEN
            CLOSE(UNIT=jrnl_lun)
            jrnl_lun = unspecified_int4
        ENDIF

C       Reset some MODE values throughout the stack.  These actually 
C       should all be reinitialized at the end of this routine to the 
C       values in xprog_state_data.F 
        DO k = 1, mode_stack_size
            mode_state(pmode_diagnostic,k) = .FALSE.
            mode_state(pmode_verify,k) = .FALSE.
            mode_state(pmode_journal,k) = .FALSE.
        ENDDO

        cmnd_buff = 'CANCEL REDIRECT'
        CALL GET_FER_COMMAND(cmnd_buff, istatus, *100)
        CALL XEQ_CANCEL
  100   CALL CLEANUP_LAST_CMND(cmnd_stack_level)

        cmnd_buff = 'SET GRID ABSTRACT'
        CALL GET_FER_COMMAND(cmnd_buff, istatus, *200)
        CALL XEQ_SET
  200   CALL CLEANUP_LAST_CMND(cmnd_stack_level)

        IF ( pplus_started ) THEN
            IF ( mode_gks .AND. (ITS_BATCH_GRAPHICS() .EQ. 0) ) THEN
                cmnd_buff = 'CANCEL WINDOW /ALL'
                CALL GET_FER_COMMAND(cmnd_buff, istatus, *300)
                CALL XEQ_CANCEL
  300           CALL CLEANUP_LAST_CMND(cmnd_stack_level)
            ENDIF
            CALL CLSPPL
            pplus_started = .FALSE. 
        ENDIF

        cmnd_buff = 'CANCEL VARIABLE /ALL'
        CALL GET_FER_COMMAND(cmnd_buff, istatus, *400)
        CALL XEQ_CANCEL
  400   CALL CLEANUP_LAST_CMND(cmnd_stack_level)

        cmnd_buff = 'CANCEL ALIAS /ALL'
        CALL GET_FER_COMMAND(cmnd_buff, istatus, *500)
        CALL XEQ_CANCEL
  500   CALL CLEANUP_LAST_CMND(cmnd_stack_level)

        cmnd_buff = 'CANCEL LIST /ALL'
        CALL GET_FER_COMMAND(cmnd_buff, istatus, *600)
        CALL XEQ_CANCEL
  600   CALL CLEANUP_LAST_CMND(cmnd_stack_level)

        cmnd_buff = 'CANCEL REGION /ALL'
        CALL GET_FER_COMMAND(cmnd_buff, istatus, *700)
        CALL XEQ_CANCEL
  700   CALL CLEANUP_LAST_CMND(cmnd_stack_level)

        cmnd_buff = 'CANCEL SYMBOL /ALL'
        CALL GET_FER_COMMAND(cmnd_buff, istatus, *800)
        CALL XEQ_CANCEL
  800   CALL CLEANUP_LAST_CMND(cmnd_stack_level)

C       "CANCEL DATA /ALL"
C       Code pulled from xeq_cancel
        DO k = 1, maxdsets
           IF ( ds_name(k) .NE. char_init2048 ) THEN
              CALL CANCEL_ONE_DATA_SET(k, istatus)
           ENDIF
        ENDDO

C       "CANCEL GRID /ALL"
C       Code pulled from xeq_cancel in order to do complete clean up silently
        DO k = 1, grid_ceiling
           IF (grid_name(k) .NE. char_init16) THEN
              grid_use_cnt(k) = 0
              IF ( k .LE. max_grids ) THEN
                 grid_name(k) = char_init16
              ELSE
                 CALL TM_DEALLO_DYN_GRID(k)
              ENDIF
           ENDIF
        ENDDO

C       "CANCEL AXIS /ALL"
C       Code pulled from DEALLO_ALL_AXES in order to do complete clean up silently
        DO k = 1, line_ceiling
           IF (line_name(k) .NE. char_init16) THEN
              line_use_cnt(k) = 0
              line_keep_flag(k) = .FALSE.
              IF ( k .LE. max_lines ) THEN
                 IF ( .NOT. line_regular(k) ) 
     .              CALL FREE_LINE_DYNMEM(k)
                 line_regular(k) = .TRUE.
                 line_name(k) = char_init16
              ELSE
                 CALL TM_DEALLO_DYN_LINE(k)
              ENDIF
           ENDIF
        ENDDO

C       "CANCEL MEMORY /ALL"
C       pulled from xeq_cancel in order to do complete clean up silently
        DO k = 1, max_mr_avail
            IF ( mr_protected(k) .NE. mr_deleted ) THEN
                IF ( mr_protected(k) .EQ. mr_perm_protected ) THEN
                    permanent_mem = permanent_mem - mr_size(k)
                ENDIF
                CALL DELETE_VARIABLE(k)
            ENDIF
        ENDDO
        peak_mem = 0
        peak_essential_mem = 0

        CALL us2i_string_list_free()

        CALL efcn_list_clear()

        CALL string_array_clear(alg_pvar_head)

        CALL string_array_clear(countervar_name_head)

        CALL string_array_clear(uvar_name_code_head)
 
        CALL string_array_clear(ds_var_code_head)

        CALL deleted_list_clear(uvar_num_items_head)

        CALL ncf_datasets_list_clear()

        RETURN

        END

	CHARACTER*(*) FUNCTION VAR_CODE ( category, variable )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* return name code for variable

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 6/4/86
* revision 1.0 - 1/6/87 - cat_expr and cat_temp changed
* revision 1.1 - 3/23/87 - added new TMAP library: time axes, file var. names
* revision 2.0 - 3/10/88 - removed cat_expr_var, added cat_named_var,
*			   changed cat_user_var formatting to use HASH_NAME
* V200:  6/20/89 - eliminated "named" variables
*       11/30/89 - process pseudo-variables, too
*	 12/4/89 - moved hashing of expression to SANITARY_VAR_CODE
* V320:  2/22/95 - added support for reverse-axis variables: cat_file_rev
* V500: 12/98 *sh* - added cat_const_var ... of the form "{1,3,5}"
*	 1/99 *sh8 ... and cat_string
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V694 5/15 *acm* when evaluating attributes, show the code attr
* V698  3/16 *acm* Removed Philander-Seigel code including diagnostic 
*                  variables, pre-defined axes and grids, cat_calc_var.
* V698  3/16 *sh* bug fix #2382 - logic for cat_ef_time2d (ACTS_LIKE_FVAR)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'xdset_info.cmn_text'
	external xdset_info_data
	include	'xvariables.cmn'
	include	'xalgebra.cmn'

* calling argument declarations:
	INTEGER category, variable

* internal variable declarations
	LOGICAL ACTS_LIKE_FVAR
	INTEGER uvar, item, start, end

	IF     ( ACTS_LIKE_FVAR(category) ) THEN

	   VAR_CODE = ds_var_code( variable )

	ELSEIF ( category .EQ. cat_user_var ) THEN

	   VAR_CODE = uvar_name_code(variable)

	ELSEIF ( category .EQ. cat_dummy_var ) THEN

	   VAR_CODE = 'dumm'

	ELSEIF ( category .EQ. cat_temp_var ) THEN

	   VAR_CODE = 'tpry'

	ELSEIF ( category .EQ. cat_pseudo_var ) THEN

	   VAR_CODE = alg_pvar( variable )

	ELSEIF ( category .EQ. cat_const_var ) THEN

	   uvar = variable/1000
           item = variable - 1000*uvar
           start = uvar_item_start( item, uvar )
           end   = uvar_item_end  ( item, uvar )
	   VAR_CODE = uvar_text(uvar)(start:end)

	ELSEIF ( category .EQ. cat_constant ) THEN

	   VAR_CODE = 'cnst'

	ELSEIF ( category .EQ. cat_string ) THEN

	   VAR_CODE = 'str'

	ELSEIF ( category .EQ. cat_attrib_val ) THEN

	   VAR_CODE = 'attr'

	ELSE

	   VAR_CODE = 'bad*'

	ENDIF

 3000	FORMAT(A1,I3.3)
	RETURN
	END

      SUBROUTINE RANGE(UAMIN,UAMAX,NAINTS,UMINR,UMAXR,DINT)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)range.f	1.1    3/10/88
C** V600:  1/06 *acm*  prevent values of LOG10(0.0)
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     CALL RANGE(UMIN,UMAX,NINTS,UMINR,UMAXR,DINT)
C
C     THIS SUBROUTINE FINDS TWO VALUES FOR A VARIABLE SUCH THAT
C     THE RANGE BETWEEN THEM IS EVENLY DIVISIBLE INTO APPROXI-
C     MATELY A SPECIFIED NUMBER OF INTERVALS AND CONTAINS THE
C     MINIMUM AND MAXIMUM VALUES OF THE VARIABLE.
C
C     THE VARIOUS PARAMETERS AND THEIR DEFINITIONS ARE LISTED
C     BELOW:
C        UMIN   - MINIMUM VALUE OF THE VARIABLE.
C        UMAX   - MAXIMUM VALUE OF THE VARIABLE.
C        NINTS  - APPROXIMATE NUMBER OF INTERVALS INTO WHICH THE
C                 RANGE IS TO BE DIVIDED.
C        UMINR  - MINIMUM VALUE OF THE RANGE.
C        UMAXR  - MAXIMUM VALUE OF THE RANGE.
C        DINT   - INTERVAL SIZE.
C
C
C     TRANSFER THE PARAMETERS TO NEW VARIABLES.
C
      UMIN = UAMIN
      UMAX = UAMAX
      NINTS = IABS(NAINTS)
C
C     CHECK THE PARAMETERS TO MAKE SURE THAT THEY ARE VALID.
C
      IF(UMIN .GT. UMAX)THEN
        TEMP = UMIN
        UMIN = UMAX
        UMAX = TEMP
      ENDIF
      IF(NINTS .EQ. 0)NINTS = 1
C
C     FIND THE APPROXIMATE SIZE OF THE INTERVAL.
C
      TEMP = (UMAX - UMIN) / FLOAT(NINTS)
      IF(TEMP .EQ. 0.0)TEMP = UMAX
C
C     SCALE THE INTERVAL SIZE BY POWERS OF TEN TO A VALUE BETWEEN
C     ONE AND TEN.
C
      IF (TEMP .EQ. 0.0) THEN
         NT = 1
      ELSE
         NT = IFIX(ALOG10(TEMP))
      ENDIF
      IF(TEMP .LT. 1.0)NT = NT - 1
      POW = 10.0 ** NT
      TEMP = TEMP / POW
C
C     FIND THE CLOSEST PERMISSIBLE VALUE FOR THE INTERVAL SIZE.
C
      IF(TEMP .LT. SQRT(2.0))THEN
        DINT = POW
      ELSE IF(TEMP .LT. SQRT(10.0))THEN
        DINT = 2.0 * POW
      ELSE IF(TEMP .LT. SQRT(50.0))THEN
        DINT = 5.0 * POW
      ELSE
        DINT = 10.0 * POW
      ENDIF
C
C Note that for some values of these numbers, UMIN, UMAX, and DINT
C the value of FM may be slightly larger or slightly smaller than
C the intended value, and so may behave differently from one compiler/machine
C to another (seen on Solaris vs Linux, in the Y axis of PLOT/i=1:12 1./i

C     CALCULATE THE MINIMUM VALUE OF THE RANGE.
C
      FM = UMIN / DINT
      M = IFIX(FM)
      IF(FM .LT. 0.0)M = M - 1
      UMINR = DINT * FLOAT(M)
C
C     CALCULATE THE MAXIMUM VALUE OF THE RANGE.
C
      FM = UMAX / DINT
      M = IFIX(FM)
      IF(FM .GT. 0.0)M = M + 1
      UMAXR = DINT * FLOAT(M)
      RETURN
C
      END

	SUBROUTINE READ_REMOTE (  baddat, cx, mr, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* read a grid of data from an F-TDS dataset, having been defined with LET/REMOTE

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Thermal Modeling and Analysis Program
*
* revision 0.0 - 2/2012 - based on READ_TM

        IMPLICIT NONE
	include	'tmap_errors.parm'
	include	'tmap_dims.parm'
	include	'xdset_info.cmn_text'
	external xdset_info_data
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'
	include	'xtext_info.cmn'

* calling argument declarations:
	INTEGER	cx, mr, status
	REAL	 baddat

* internal variable declarations:
	LOGICAL	has_a_stride, has_strides(nferdims)
	INTEGER MGRID_SIZE,
     .			idim, uvar, category, dset, grid,
     .			sf_num, tmap_status, idir, ndim,
     .			lo_ss(nferdims), hi_ss(nferdims),
     .			lo_s1, lo_s2, lo_s3, lo_s4, lo_s5, lo_s6, 
     .			hi_s1, hi_s2, hi_s3, hi_s4, hi_s5, hi_s6,
     .			stride(nferdims), lo_ss_ds,hi_ss_ds, line, 
     .			gridlines(nferdims), grid_start(nferdims),
     .			grid_end(nferdims), grid_order(nferdims)
* V500 *kob* 3/99- up VAR_CODE and local var vname to 64 chars
	CHARACTER*128	VAR_CODE, vname

	LOGICAL		reprimand
	DATA       	reprimand/.TRUE./
* *kob* 2/99 - add declaration for new c function

	INTEGER REPLACEABLE_BAD_FLAGS

	EQUIVALENCE	(lo_ss(1),lo_s1), (lo_ss(2),lo_s2),
     .			(lo_ss(3),lo_s3), (lo_ss(4),lo_s4),
     .			(lo_ss(5),lo_s5), (lo_ss(6),lo_s6),
     .			(hi_ss(1),hi_s1), (hi_ss(2),hi_s2),
     .			(hi_ss(3),hi_s3), (hi_ss(4),hi_s4),
     .			(hi_ss(5),hi_s5), (hi_ss(6),hi_s6)

* --- end of introductory code ---

* initialize
	dset = cx_data_set( cx )
	category = cat_user_var
	uvar = cx_variable( cx )
	vname = VAR_CODE( category, uvar )

	grid = cx_grid( cx )

	DO 50 idim = 1, nferdims
	   gridlines(idim) = grid_line(idim, grid)
  50	CONTINUE
	CALL CD_NF_GET_VAR_GRID ( dset, vname, gridlines, status )

	ndim = 0
	DO 70 idim = 1, nferdims
	   line = gridlines(idim)
	   grid_start(idim) = 1
	   grid_end(idim) = 1
	   grid_order(idim) = 0
	   IF (line .NE. mnormal) THEN
	      grid_end(idim) = line_dim(line)

	      DO 60 idir = 1, nferdims+1
                 IF ( line_direction(line) .EQ. axis_orients( idir ) ) THEN
		    ndim = ndim + 1
		    grid_order(ndim) = idir
		    IF (grid_order(ndim) .EQ. 7) grid_order(ndim) = 3
		    GOTO 65
		 ENDIF
 60	      CONTINUE
 65	      CONTINUE
	   ENDIF
 70     CONTINUE

* ensure that all needed limits are known and correct for the remote var

	DO 100 idim = 1, nferdims

	   IF ( gridlines(idim) .EQ. mnormal) THEN
	      cx_lo_ss( cx, idim ) = unspecified_int4
	      cx_hi_ss( cx, idim ) = unspecified_int4
	   ENDIF

	   IF ( cx_lo_ss( cx, idim ) .NE. unspecified_int4 ) GOTO 100
	   IF ( gridlines(idim).EQ.mnormal) GOTO 100

	   IF ( reprimand ) THEN
	      CALL WARN
     .		('FERRET is more efficient if regions are fully specified' )
	      CALL WARN( ww_dim_name(idim)//
     .		' axis limits are unspecified - possibly others, too' )
	      reprimand = .FALSE.		! only remind them once
	   ENDIF
	   CALL FLESH_OUT_AXIS( idim, cx, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000		! should never happen
!	   CALL ERRMSG( ferr_limits, status,
!     .			ww_dim_name(idim)//' axis limits are unknown for '//
!     .			VAR_CODE( cat_file_var, cx_variable(cx) ), *5000 )
 100	CONTINUE


* jli: replace the following cx_delta logic by the line_delta

* strides indicated in cx_delta e.g. SST[I=110:180:10] ?
* If so, transfer this info to the stride array
	has_a_stride = .FALSE.

* reserve and catalog space for the result
	CALL CREATE_MEM_VAR( cx, mr, status )
	IF ( status .NE. ferr_ok ) GOTO 5900
	IF (ds_var_type(uvar) .EQ. ptype_string)
     .		CALL INIT_C_STRING_ARRAY( MGRID_SIZE(mr),
     .			                  memry(mr)%ptr,
     .					  mr_c_pointer(mr)      )

* un-cache it?
* Turns out that uncaching the result here causes all of its descendants to
* become uncached, as well, and lowers the cache hit rate. Instead, we will
* handle invalid mr limits left by strides in IS_REGRID
!	IF ( has_a_stride ) CALL UN_CACHE( mr )   ! since lo:hi are "fake"

* set up array of subscripts
	DO 300 idim = 1, nferdims
*<jli
           line = gridlines(idim)

*          For strides indicated in cx_delta e.g. SST[I=110:180:10]
*          use cx_delta logic

           IF(line_parent(line) .EQ. 0) THEN
              has_strides(idim) =  cx_delta(idim,cx) .NE. unspecified_val8
     .                  .AND.  cx_delta(idim,cx) .NE. 1 
              IF (has_strides(idim)) THEN
                stride(idim) = NINT(cx_delta(idim,cx))
                has_a_stride = .TRUE.
              ELSE
                stride(idim) = 1
              ENDIF
     
              IF ( gridlines(idim) .EQ. mnormal ) THEN
                 lo_ss( idim ) = 1
                 hi_ss( idim ) = 1
              ELSE
                 lo_ss( idim ) = cx_lo_ss( cx, idim )
                 hi_ss( idim ) = cx_hi_ss( cx, idim )
              ENDIF
           
           ELSE

*             For strides specified in SET AXIS/STRIDE
*             Use line_delta logic

              has_strides(idim) = .TRUE.

	      IF ( gridlines(idim) .EQ. mnormal ) THEN
	         lo_ss( idim ) = 1
	         hi_ss( idim ) = 1
                 stride( idim ) = 1

              ELSEIF ( line_regular(line) ) THEN
              
                 IF (has_strides(idim)) THEN
                    stride(idim) = line_delta(line)/line_delta(line_parent(line))+0.5
                    has_a_stride = .TRUE.
                 ELSE
                    stride(idim) =1 
                 ENDIF

!                get size of the native axis
                 CALL VAR_SS_LIMS(idim, cx,lo_ss_ds,hi_ss_ds)

                 lo_ss(idim) = (cx_lo_ss( cx, idim )-1)*stride(idim) + 
     .                         line_offset(line)

                 hi_ss(idim) = (cx_hi_ss( cx, idim )-1)*stride(idim) +
     .                         line_offset(line) 

!                for a reversed axis
                 IF( line_reversed(line)) THEN
!                   must compute hi_ss first and then lo_ss
                    hi_ss(idim) = hi_ss_ds - 
     .                         (line_dim(line)-cx_hi_ss( cx, idim ))*stride(idim) -
     .                         line_offset(line) + 1
  
                    lo_ss(idim) = hi_ss(idim) - 
     .                         (cx_hi_ss(cx,idim)-cx_lo_ss(cx,idim))*stride(idim)
                 ENDIF

!                for nested stride
                 IF( (cx_delta(idim,cx) .NE. unspecified_val8)
     .                  .AND.  (cx_delta(idim,cx) .NE. 1) ) THEN
                    stride(idim) = stride(idim)*cx_delta(idim,cx)
                 ENDIF


              ELSE
*             Irregular line

                 IF (has_strides(idim)) THEN
                    has_a_stride = .TRUE.
                    stride(idim) = line_delta(line)

!                   Nested strided, e.g.,i=1:20:2      
                    IF( (cx_delta(idim,cx) .NE. unspecified_val8)
     .                  .AND.  (cx_delta(idim,cx) .NE. 1) ) THEN
                       stride(idim) = stride(idim)*cx_delta(idim,cx)
                    ENDIF

                    lo_ss(idim)  = line_start(line) +  
     .                             (cx_lo_ss( cx, idim )-1)*stride(idim)
                    hi_ss(idim)  = line_start(line) +  
     .                             (cx_hi_ss( cx, idim )-1)*stride(idim)
                 ELSE
                    lo_ss( idim ) = cx_lo_ss( cx, idim )
                    hi_ss( idim ) = cx_hi_ss( cx, idim )
                    stride(idim) = 1 
                 ENDIF 

	      ENDIF
           
           ENDIF
 300	CONTINUE

* diagnostic output
	IF (mode_diagnostic) THEN
	   IF ( has_a_stride) THEN
	     CALL DIAGNOSTIC_OUT('rdstride',cx,point_to_cx)
	   ELSE
	     CALL DIAGNOSTIC_OUT('reading',mr,point_to_mr)
	   ENDIF
	ENDIF

* read the data

	CALL REMOTE_READ  ( dset,
     .			vname,
     .			rvar_varid(uvar),
     .			lo_s1, lo_s2, lo_s3, lo_s4, lo_s5, lo_s6, 
     .			hi_s1, hi_s2, hi_s3, hi_s4, hi_s5, hi_s6,
     .			lo_ss,
     .			hi_ss,
     .			stride,
     .			gridlines,
     .			grid_start,
     .			grid_end,
     .			grid_order,
     .			memry( mr )%ptr,
     .			baddat, 
     .			sf_num,
     .			tmap_status		)
	IF ( tmap_status .NE. merr_ok ) THEN
	   CALL DELETE_VARIABLE( mr )
	   GOTO 5010
	ENDIF

* baddat attribute is read from the f-tds dataset; if the 
* _FillValue attribute and the bad-value with in the data
* are corrupted by e.g. a conversion from float to double,
* then this way both are corrupted in the same way.

	mr_bad_data(mr) = baddat

* replace multiple bad data flags in some variables
* IF ( ds_bad_flag( variable ) .NE. ds_missing_flag( variable ) )
* *kob* 2/99 - call new routine to check for usage of NaN
	IF (mr_type(mr) .NE. ptype_string
     .  .AND. REPLACEABLE_BAD_FLAGS(ds_bad_flag(uvar), 
     .                              ds_missing_flag(uvar)) .EQ. 1)
     .	   CALL REPLACE_BAD_DATA
     .		(memry(mr)%ptr,mr,cx,ds_missing_flag(uvar))

* successful completion
 	RETURN

* error exit
 5000	cx_category(cx) = category
 	RETURN

* error exit
 5010	CALL ERRMSG( ferr_TMAP_error, status, ' ', *5900 )   ! 7/92
 5900	RETURN
	END	

	SUBROUTINE READ_PERL (  cx, mr, status )
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* read a stream formatted file 
* stolen from read_ez

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* 9/99 *js*  First version hacked from read_binary
* V552 *acm* 4/03- up VAR_CODE  to 128
* v604 *acm* 7/07 increase length of ds_name
* V63  *acm* 10/09 Changes for 1 build
*       *acm* 3/12 cleanup old VMS ifdef
* V702: *sh* 1/17 - bug fix: mr_protected must *end* at mr_not_in_use (=0)
*                   note: this fix was never tested -- applied blindly
*                   by analogy with other ino/read*.F routines
*		  - and for trac #2369 -- dynamic memory management 
*		    (was dynamic memory ever used in this routine?)

	include	'tmap_errors.parm'
	include	'tmap_dims.parm'
	include	'xdset_info.cmn_text'
	external xdset_info_data
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xstep_files.cmn_text'
	external xstep_files_data
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'
	include	'xtext_info.cmn'

* calling argument declarations:
	INTEGER	cx, mr, status, fstatus

* functions
	INTEGER PL_OPEN, PL_READ_VAR

* internal variable declarations:
	INTEGER		nferdimsp1 
	PARAMETER	(nferdimsp1 = nferdims+1)
	INTEGER 	CGRID_SIZE, 
     .			idim, ask_var, category, data_set, grid, ivar,
     .			fvar, nvar20, the_var, nleft, 
     .			cx0, cx1, cx20(20), mr20(20),
     .			mr1, rec1, 
     .			rec_to_read, nrepeat, columns, num_names
	INTEGER         lengths(nferdimsp1)
	LOGICAL         firstTime
	CHARACTER	VAR_CODE*128
	CHARACTER*256   cerrmsg,ferrmsg
	CHARACTER*1024  cname

* --- end of introductory code ---

* nvar20  and the_var - value from 1 to 20      --> variable # within EZ set
* ask_var and fvar    - value from 1 to maxvars --> var # within DSET common

* initialize
	cx0 = cx_stack_ptr
	data_set = cx_data_set( cx )
	category = cx_category( cx )
	ask_var  = cx_variable( cx )
	grid = cx_grid( cx )
	fvar      = 0
	nvar20    = 0
	rec_to_read = 2**30      ! was 99999 - limited file reads
	firstTime = .true.

* how many values of each variable are repeated on each record ?
	columns = ds_ntuple(data_set)
	num_names = ds_basic_axes(1, data_set)
	nrepeat = columns / num_names

* purge from memory any variables from this data set to avoid duplication
* (1 variable may be deleted at any time by memory management but this routine
*  always reads all of 'em)
* note: problem arises if variable is in use
!	CALL PURGE_DSET( data_set )

* create a memory variable for each of up-to-20 variables in the file
	DO ivar = 1, 20

* ... locate the next variable in this data set
	   DO fvar = fvar+1, maxvars
	      IF ( ds_var_setnum( fvar ) .EQ. data_set ) then
* ... is it a dummy '-' placeholder in the variable list ?
 		 IF (INDEX( ds_var_code(fvar),'-') .EQ. 0 ) THEN

* save record of which is the desired var
		    nvar20 = nvar20 + 1
		    IF ( fvar .EQ. ask_var ) the_var = nvar20

* ... create a context describing this variable
		    CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
		    IF ( status .NE. ferr_ok ) RETURN
		    cx20(nvar20) = cx_stack_ptr
		    CALL TRANSFER_CONTEXT( cx, cx_stack_ptr )
		    cx_variable( cx_stack_ptr ) = fvar
		    cx_grid( cx_stack_ptr ) = ds_grid_number( fvar )
		    cx_bad_data( cx_stack_ptr ) = ds_bad_flag( fvar ) ! 12/93 add'n
		    DO idim = 1, nferdims
		       cx_lo_ss( cx_stack_ptr, idim ) = ds_grid_start( idim, fvar )
		       cx_hi_ss( cx_stack_ptr, idim ) = ds_grid_end  ( idim, fvar )
		       cx_by_ss( idim, cx_stack_ptr ) = .TRUE.
* 3/99 *kob* - nag F90 wants to use eqv for logical expressions
		       if (firstTime .eqv. .TRUE.) THEN
			  lengths(idim) = ds_grid_end(idim,fvar) - 
     .		          ds_grid_start(idim,fvar) + 1
		       end if
		       CALL CONFINE_AXIS( idim, cx_stack_ptr, status )
		       IF ( status .NE. ferr_ok ) RETURN
		       CALL FLESH_OUT_AXIS( idim, cx_stack_ptr, status )
		       IF ( status .NE. ferr_ok ) RETURN
		    END DO
		    firstTime = .FALSE.

*       read only what will fit into smallest grid
		    rec1 = CGRID_SIZE(cx_stack_ptr) / nrepeat
		    rec_to_read = MIN( rec_to_read, rec1 )

*       reserve and catalog space for the result
		    CALL CREATE_MEM_VAR( cx_stack_ptr, mr20(nvar20), status )
		    IF ( status .NE. ferr_ok ) GOTO 5000
		 END IF
	      END IF
	   END DO
	END DO

* point to asked-for variable and create dummy entries for the rest
 500	mr = mr20( the_var )
	DO nleft = nvar20+1, 20
	   mr20(nleft) = dummy_mr
	END DO

* initialize the Perl reader
	call toChar(ds_name(data_set), cname)
	if (PL_OPEN(cname) .eq. 0) goto 6000

	fvar = 0
	nvar20 = 0
	DO ivar = 1, 20
	   DO fvar = fvar+1, maxvars
	      IF ( ds_var_setnum( fvar ) .EQ. data_set ) then
 		 IF (INDEX( ds_var_code(fvar),'-') .EQ. 0 ) THEN
		    nvar20 = nvar20 + 1
		    fstatus = PL_READ_VAR( memry(mr20(nvar20))%ptr,
     1		                 lengths )
		 END IF
		 if (fstatus .EQ. 0) goto 6000
	      END IF
	   END DO
	END DO

* flag that all the data is available
	DO ivar = 1, nvar20
	   mr1 = mr20(ivar)
	   CALL MR_AVAILABLE(mr1)
	ENDDO

* the data region obtained may be inadequate for the request
* ("cx" is request, "cx1" is available)
	cx1 = cx20(the_var)
	DO 900 idim = 1, nferdims
	   IF ( cx_hi_ss(cx,idim) .GT. cx_hi_ss(cx1,idim) ) THEN
	      IF ( cx_hi_ss(cx_last,idim) .NE. unspecified_int4
     .	     .OR.  cx_given(idim,cx) ) THEN
* ... error: the user explicitly requested more than there is
	         GOTO 5600
              ELSEIF (cx_lo_ss(cx,idim) .GT. cx_hi_ss(cx1,idim)) THEN
* ... requested data is completely out of range of disk data (2/93 bug fix)
                 GOTO 5600
	      ELSE
* ... no error: the region was filled in by FERRET automatically
	         cx_hi_ss(cx,idim) = cx_hi_ss(cx1,idim)
	         cx_hi_ww(idim,cx) = cx_hi_ww(idim,cx1)
	      ENDIF
	   ENDIF
 900	CONTINUE

* successful completion
	cx_stack_ptr = cx0
	CALL PL_CLOSE()
	RETURN

* error exit
 4900	nvar20 = nvar20 + 1		! delete all
 5000	cx_stack_ptr = cx0
	DO 5010 nleft = 1, nvar20-1	! delete all except last
 5010	CALL DELETE_VARIABLE(mr20(nleft))
	CALL PL_CLOSE()
 5500	RETURN
 5600	CALL ERRMSG( ferr_limits, status,
     .		ww_dim_name(idim)//' axis of '//VAR_CODE(cat_file_var,ask_var),
     .		*5500 )
 6000	CALL PL_GET_ERROR(cerrmsg)
	CALL TM_CTOF_STRNG(cerrmsg, ferrmsg, 255)
	CALL TM_SPLIT_MESSAGE(err_lun, ' **ERROR: '//ferrmsg(1:LEN(ferrmsg)))
        CALL ERRMSG( ferr_TMAP_error, status, ' ', *4900 )
	END	

	subroutine epicvar
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)epicvar.F	1.1    3/10/88
C**
C**
C***********************************************************************        C**
C**                 EPIC
C**
C***********************************************************************        C**
C**
c
c  Interprets PLOT5 EVAR command, which allows user to select EPIC variables
c  for plotting.
c
c  EVAR ?		Lists variable choices for user.
c  EVAR TIM,T		Selects x=time and y=temperature
c  EVAR			Selects x=time and y=first variable after time/date
c  EVAR STK     \_______
c  EVAR TIM STK /       Selects stick plots vs time
c  EVAR TIM,Cn          Selects x=time and y=variable in column n
c  EVAR TIM,En          Selects x=time and y=variable with EPICKEY
c                       variable code n.
c
c  Called in COMND.
c
c  Programmed by N. Soreide, May 86.
c
#ifdef unix
	include 'CMRD.INC'
	include 'CMRDL.INC'
	include 'TAXIS.INC'
	include 'COMEPV.INC'
	include 'COMEPS.INC'
#else
	include 'pplinc:CMRD.INC'
	include 'pplinc:CMRDL.INC'
	include 'pplinc:TAXIS.INC'
	include 'epicinc:COMEPV.INC'
	include 'epicinc:COMEPS.INC'
#endif
	character ev1*5,ev2*5
c
	itflg=0
	ieflg=1
c
	if (index(label(1:n),'?') .ne. 0) then
c
c  Put out parameter list if parameter1 is ?
c
	    write (5,100)
100	    format (' Pressure        P'/
     1	                   ' Temperature     T'/
     2	                   ' Salinity        SAL'/
     3	                   ' Sigma-T         SIG'/
     4	                   ' Oxygen          OX'/
     5	                   ' Conductivity    CO'/
     6	                   ' U               U'/
     7	                   ' V               V'/
     8	                   ' Dynamic Ht      DYN'/
     9	                   ' Time            TIM'/
     1	                   ' Stick Plots     STK'/)
c
c  If EVAR and no parameters, then use x=time, y=first variable after time
c
	else if (n .eq. 0) then
	    iepv1=9
	    iepv2=-1
	    if (lsctd) iepv1=-1
c
c  EVAR with parameters
c
	else
	    isp1=index(label(1:n),' ')
	    ico1=index(label(1:n),',')
	    if (isp1.eq.0 .and. ico1.eq.0) then
		write (5,101)
101		format (' EVAR command must have 2 parameters')
		return
	    else if (isp1 .eq. 0) then
		is=ico1
	    else if (ico1 .eq. 0) then
		is=isp1
	    else
		is=min0(isp1,ico1)
	    endif
	    ev1(1:)=label(1:is-1)
	    ev2(1:)=label(is+1:n)
	    call epicv (ev1,iepv1)
	    call epicv (ev2,iepv2)
	endif
c
c  If x-variable is STK, make x=TIM, and y=STK
c
	if (iepv1 .eq. 10) then
	    iepv1=9
	    iepv2=10
	endif
	return
	end

      SUBROUTINE RE_ORIENT( xlo, xhi, ylo, yhi,
     .			    dim1, dim2, md1, md2, transpz, aspect,
     .			    xgrid, mx, ygrid, my, sout )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* re-orient vectors so that they point in the correct direction on the plot
* preserving the overall magnitude

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* revision 0.0 - 4/1/88
* V200:  5/19/89 - 4D symmetrical
* V230:  1/24/92 - incorporate COS(lat) if appropriate
* V301:  11/93 - replace exact zero check with FPEQ
* V420	 2/96 - calling args changed so /XLIMITS and /YLIMITS can be passed
*	      - also sout, the returned scale factor, was wrong on plots
*		that used the COS factor - was based on "s" instead of "s0"
* V600  4/06 *acm* - make refinement to cos(lat) factor as suggested by A. Wittenberg
* V600  4/06 *acm* - additional declarations found by Solaris compiler
* 6/06 - Fix to Andrew*s correction for XY integ., bug1348
*12/06 - Fix to cos_factor calculation was STILL wrong. Try VEC/ASPECT plots 
*        to see the error.
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

* procedure:	at each point
*	   x --> xprime = A * x
*	   y --> yprime = B * y
*	where
*	   x**2 + y**2 = xprime**2 + yprime**2
*	and  A/B = s, a constant

*	let dx		the range of data on the x axis
*	    dy		the range of data on the y axis
*	    aspect 	the ratio of axis lengths ylen/xlen
*	    xscale	the scale factor (units/inch) on the x axis
*	    s		the ratio of scale factors, yscale/xscale
*	    tan		the ratio of the vector components y/x at any point
*	then
*	    s = (dy/dx)/aspect

*	and, from the constraints on the transformation, above
*	    B = { (1 + tan**2) / (s**2 + tan**2) } **.5
*	    A = s * B

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include	'xvariables.cmn'
	include 'xcontext.cmn'

* calling argument declarations:
	LOGICAL	transpz
	INTEGER	dim1, dim2, md1, md2, mx, my
	REAL	aspect, sout
	REAL	xgrid( md1, md2 ), ygrid( md1, md2 )
	REAL*8	xlo, xhi, ylo, yhi

* internal variable declarations:
        LOGICAL need_cos, GEOG_COS_FACTOR, TM_FPEQ
	INTEGER	grid, i, j, j0
	REAL	AXIS_DISTANCE, s0, s, a, b, tan, tansq, ssq, dx, dy,
     .          bad_x, bad_y, cos_factor, bx, box_size, yh_2, yc, 
     .          ybxlo, ybxhi
	REAL*8	TM_WORLD

* initialize
	grid  = mr_grid( mx )
	bad_x = mr_bad_data( mx )
	bad_y = mr_bad_data( my )
        j0 = mr_lo_ss( mx, y_dim ) - 1  ! may need for latitude cuz j=1,md2

* axis spans in km
	dx = AXIS_DISTANCE( xlo, xhi, dim1, grid )
	dy = AXIS_DISTANCE( ylo, yhi, dim2, grid )
	s0   = (dy/dx) / aspect   ! axis scale ratio before COS(lat) correction

* will we need COS(latitude) corrections ? ( the true dx may be dx*COS(lat) )
        IF ( dim1.EQ.x_dim .AND. dim2.EQ.y_dim ) THEN
           need_cos =     GEOG_COS_FACTOR(x_dim, grid)
     .              .AND. GEOG_COS_FACTOR(y_dim, grid)
        ELSE
           need_cos = .FALSE.
        ENDIF

* re-orient each point
	DO 110 j = 1, md2

* compute COS(lat) correction at this latitude
* 3/06 - apply Andrew*s suggested correction, bug1348

	   IF ( need_cos ) THEN

c Previous calculation
#ifdef double_p
              yc = deg2rad * (TM_WORLD(j+j0,grid,y_dim,box_middle))
#else
              yc = deg2rad * SNGL(TM_WORLD(j+j0,grid,y_dim,box_middle))
#endif
              cos_factor = COS( yc )
  
c Correction
              bx = BOX_SIZE(j+j0, grid, y_dim )
	      yh_2 = 0.5*deg2rad * bx
              cos_factor =  COS( yc ) * ABS( SIN(yh_2) )/yh_2

C The above are all OK if the coordinate point is in the middle of the box.
C If the coordinate is not in the middle of the cell then it should be
C ABS(SIN(yhi)-SIN(ylo))  
C See this thread:
C http://www.pmel.noaa.gov/maillists/tmap/ferret_users/fu_2009/msg00506.html
C And also ticket 1348.

#ifdef double_p
              ybxlo = deg2rad* 
     .          ( TM_WORLD(j+j0,grid,y_dim,box_lo_lim) )
              ybxhi = deg2rad* 
     .          ( TM_WORLD(j+j0,grid,y_dim,box_hi_lim) )
#else
              ybxlo = deg2rad* 
     .          SNGL( TM_WORLD(j+j0,grid,y_dim,box_lo_lim) )
              ybxhi = deg2rad* 
     .          SNGL( TM_WORLD(j+j0,grid,y_dim,box_hi_lim) )
#endif

              cos_factor = ABS( SIN(ybxhi) - SIN(ybxlo) )/(deg2rad * bx)

              IF ( cos_factor .LT. 1.E-6 ) cos_factor = 1.E-6 !arbitrary fix /0
           ELSE
              cos_factor = 1.0
           ENDIF
           s = s0 / cos_factor
           IF ( transpz ) s = 1. / s
           ssq  = s*s

	   DO 100 i = 1, md1

* skip flagged points
	      IF ( xgrid(i,j).EQ.bad_x .OR. ygrid(i,j).EQ.bad_y ) THEN
	         xgrid(i,j) = bad_x
	         ygrid(i,j) = bad_y
	         GOTO 100
	      ENDIF

* no rotation on vertical (or horizontal) vectors (avoid y/0)
	      IF ( TM_FPEQ(xgrid(i,j), 0.0) ) GOTO 100

	      tansq = ( ygrid(i,j)/xgrid(i,j) ) ** 2
	      b     = SQRT( (1.+tansq) / (ssq+tansq) )
	      a     = b * s

	      xgrid(i,j) = a * xgrid(i,j)
	      ygrid(i,j) = b * ygrid(i,j)

 100	   CONTINUE
 110    CONTINUE

* return 1/s to display on plot (generally, s<1)
	sout = 1. / s0			! bug fix 2/96: was 1./s 

	RETURN
	END

	SUBROUTINE TM_WARN_SUBSPAN (iaxis)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*.
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* 5/2016 Ansley Manke
* See ticket 1432.
* Write a NOTE if an axis definition is a subspan modulo axis
* but its length is within a grid cell of the full modulo length.

        include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
        include 'xio.cmn_text'
        external xio_data
        include 'xtm_grid.cmn_text'
        external xgt_grid_data

* argument declarations
	INTEGER iaxis


* local variable declarations:
	LOGICAL	TM_ITS_SUBSPAN_MODULO
	INTEGER TM_LENSTR1, alen, blen, vlen
	REAL	TM_WW_AXLEN, GET_LINE_COORD, axwwlen, delta
	CHARACTER*48 TM_FMT, buff1, buff2

	INTEGER tt  ! nice short name
	EQUIVALENCE (tt,lunit_errors)

	vlen = TM_LENSTR1(line_name(iaxis))
        axwwlen = TM_WW_AXLEN(iaxis)

* get the nominal delta grid cell length for comparison

	IF (line_delta(iaxis) .NE. unspecified_val8) THEN
	   delta = line_delta(iaxis)
	ELSE
	   delta = GET_LINE_COORD(linemem(iaxis)%ptr, 2) - GET_LINE_COORD(linemem(iaxis)%ptr, 1)
	ENDIF

        IF (line_modulo(iaxis) .AND. TM_ITS_SUBSPAN_MODULO(iaxis) .AND.
     .	    (line_modulo_len(iaxis)-axwwlen) .LE. delta )  THEN
           buff1 = TM_FMT( axwwlen,7,22,alen )
           buff2 = TM_FMT( line_modulo_len(iaxis),7,22,blen )
           CALL TM_NOTE('Subspan modulo axis '//line_name(iaxis)(:vlen)//
     .		'. Axis span = '//buff1(:alen)//
     .		', modulo length = ' //buff2(:blen)//
     .		'. Is this intended to be a full-span axis?', tt)
        ENDIF
	
	RETURN
	END

	SUBROUTINE PPL_AXES_RESTORE

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* restore the PLOT+ axes after they have been turned off by PPL_AXES_OFF

* V450:  
* V541: 3/02  *acm* restore of PPL AXLABP settings too
*       3/25  Put the common block in a separate include file.
* v552 *acm* 3/03 new param IAXSET to restore axes after PLOT/AXES/set plot.

	include 'plot_setup.parm'
	include 'axis_inc.decl'
	include 'AXIS.INC'		! variable iaxon
        include 'ppl_ax_save.cmn'

* calling argument declarations

* local variable declarations:
	INTEGER i
	CHARACTER buff*16

* convert 4 axis integers to character as arg to the AXSET command
	buff = ' '
	WRITE (buff, '(4I3)' ) (save_iaxon(i), i=1, 4)

* restore axis state
	CALL PPLCMD ( from, line, 0, 'AXSET '//buff, 1, 1 )

* restore axis labelling

        IF (change_axlab) THEN
           WRITE (buff,92) save_labx, save_laby
  92	   FORMAT ('AXLABP ', i2, ',', I2 )
	   CALL PPLCMD (from, line, 0, buff, 1, 1)
        ENDIF

	IF ( time_axis .AND. change_axlab) THEN
	   WRITE (buff,94) save_labx, save_laby
  94	   FORMAT ('TXLABP ', i2, ',', I2 )
	   CALL PPLCMD (from, line, 0, buff, 1, 1)
	ENDIF

        iaxset = 0

	RETURN
	END

	SUBROUTINE DO_NEAREST(	idim, by_index, find_above,
     .					com, com_mr, com_cx,
     .					res, res_mr, res_cx )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* for each point, locate the valid point along the specified axis
* that is nearest to the point

* This function performs 4 transformations
*       @CDA - closest distance above (world coord distance)
*       @CDB - closest distance below (world coord distance)
*       @CDA - closest index    above
*       @CDA - closest index    below

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V450: 8/97
* v491 - *kob* 3.98 - modify loop @450 to use cx_lo/hi_s3 for k 
*                     rather than s4 *kob*
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'

* calling argument declarations:
	LOGICAL by_index, find_above
	INTEGER	idim, action, com_mr, com_cx, res_mr, res_cx
        REAL    com( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          res( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif )

* internal variable declarations:
	LOGICAL TM_ITSA_DSG
	INTEGER i, j, k, l, m, n, grid, uplim, dnlim, offlim,
     .		delta, las_index
	REAL	bad_com, bad_res
	REAL*8  TM_WORLD
	CHARACTER*150 VAR_TRANS, buff

* --- end of introductory code ---

* initialize
	grid = mr_grid( com_mr )
	bad_com = mr_bad_data( com_mr )
	bad_res = mr_bad_data( res_mr )


* These not customized for DSG data, not sure they really make sense to apply. Write a note.

	IF ( TM_ITSA_DSG(grid) ) THEN 
	   buff = VAR_TRANS(idim, res_cx, j)
	   i = INDEX(buff, '@')

	   CALL WARN ('Transformation '//buff(i:i+4)//
     .     ' not customized for Discrete Sampling Geometries: computed over all features.')
	ENDIF


* determine axis limits along axis of transformation
	IF ( find_above ) THEN		     ! @NRDA and @NRIA
	  offlim = cx_hi_ss(com_cx, idim)    ! source data beyond edge
	  uplim = cx_lo_ss(res_cx, idim)
	  dnlim = cx_hi_ss(res_cx, idim)
	  delta = -1
	ELSE				     ! @NRDB and @NRIB
	  offlim = cx_lo_ss(com_cx, idim)    ! source data beyond edge
	  uplim = cx_hi_ss(res_cx, idim)
	  dnlim = cx_lo_ss(res_cx, idim)
	  delta =  1
	ENDIF

* ALONG X AXIS
	IF ( idim .EQ. x_dim ) THEN
	   DO 150 n = cx_lo_s6(res_cx), cx_hi_s6(res_cx)
	   DO 150 m = cx_lo_s5(res_cx), cx_hi_s5(res_cx)
	   DO 150 l = cx_lo_s4(res_cx), cx_hi_s4(res_cx)
	   DO 150 k = cx_lo_s3(res_cx), cx_hi_s3(res_cx)
	   DO 150 j = cx_lo_s2(res_cx), cx_hi_s2(res_cx)
* ... locate first valid index off edge of requested region
	      las_index = unspecified_int4
	      DO 110 i = offlim, dnlim, delta
	         IF ( com(i,j,k,l,m,n) .NE. bad_com ) las_index = i
 110	      CONTINUE
* ... loop through points finding distance from last valid point
	      DO 120 i = dnlim, uplim, delta
	         IF ( com(i,j,k,l,m,n) .NE. bad_com ) THEN
	            las_index = i
	            res(i,j,k,l,m,n) = 0.0
	         ELSEIF ( las_index.EQ. unspecified_int4 ) THEN
	            res(i,j,k,l,m,n) = bad_res
	         ELSEIF ( by_index ) THEN
* ... distance in index space
	            res(i,j,k,l,m,n) = ABS(i-las_index)
	         ELSE
* ... distance in world coordinates
	            res(i,j,k,l,m,n) = ABS(
     .                    TM_WORLD(i,         grid, idim, box_middle)
     .                  - TM_WORLD(las_index, grid, idim, box_middle) )
	         ENDIF
 120	      CONTINUE
 150	   CONTINUE

* ALONG Y AXIS
	ELSEIF ( idim .EQ. y_dim ) THEN
	   DO 250 n = cx_lo_s6(res_cx), cx_hi_s6(res_cx)
	   DO 250 m = cx_lo_s5(res_cx), cx_hi_s5(res_cx)
	   DO 250 l = cx_lo_s4(res_cx), cx_hi_s4(res_cx)
	   DO 250 k = cx_lo_s3(res_cx), cx_hi_s3(res_cx)
	   DO 250 i = cx_lo_s1(res_cx), cx_hi_s1(res_cx)
* ... locate first valid index off edge of requested region
	      las_index = unspecified_int4
	      DO 210 j = offlim, dnlim, delta
	         IF ( com(i,j,k,l,m,n) .NE. bad_com ) las_index = j
 210	      CONTINUE
* ... loop through points finding distance from last valid point
	      DO 220 j = dnlim, uplim, delta
	         IF ( com(i,j,k,l,m,n) .NE. bad_com ) THEN
	            las_index = j
	            res(i,j,k,l,m,n) = 0.0
	         ELSEIF ( las_index.EQ. unspecified_int4 ) THEN
	            res(i,j,k,l,m,n) = bad_res
	         ELSEIF ( by_index ) THEN
* ... distance in index space
	            res(i,j,k,l,m,n) = ABS(j-las_index)
	         ELSE
* ... distance in world coordinates
	            res(i,j,k,l,m,n) = ABS(
     .                    TM_WORLD(j,         grid, idim, box_middle)
     .                  - TM_WORLD(las_index, grid, idim, box_middle) )
	         ENDIF
 220	      CONTINUE
 250	   CONTINUE

* ALONG Z AXIS
	ELSEIF ( idim .EQ. z_dim ) THEN
	   DO 350 n = cx_lo_s6(res_cx), cx_hi_s6(res_cx)
	   DO 350 m = cx_lo_s5(res_cx), cx_hi_s5(res_cx)
	   DO 350 l = cx_lo_s4(res_cx), cx_hi_s4(res_cx)
	   DO 350 j = cx_lo_s2(res_cx), cx_hi_s2(res_cx)
	   DO 350 i = cx_lo_s1(res_cx), cx_hi_s1(res_cx)
* ... locate first valid index off edge of requested region
	      las_index = unspecified_int4
	      DO 310 k = offlim, dnlim, delta
	         IF ( com(i,j,k,l,m,n) .NE. bad_com ) las_index = k
 310	      CONTINUE
* ... loop through points finding distance from last valid point
	      DO 320 k = dnlim, uplim, delta
	         IF ( com(i,j,k,l,m,n) .NE. bad_com ) THEN
	            las_index = k
	            res(i,j,k,l,m,n) = 0.0
	         ELSEIF ( las_index.EQ. unspecified_int4 ) THEN
	            res(i,j,k,l,m,n) = bad_res
	         ELSEIF ( by_index ) THEN
* ... distance in index space
	            res(i,j,k,l,m,n) = ABS(k-las_index)
	         ELSE
* ... distance in world coordinates
	            res(i,j,k,l,m,n) = ABS(
     .                    TM_WORLD(k,         grid, idim, box_middle)
     .                  - TM_WORLD(las_index, grid, idim, box_middle) )
	         ENDIF
 320	      CONTINUE
 350	   CONTINUE

* ALONG T AXIS
	ELSEIF ( idim .EQ. t_dim ) THEN
	   DO 450 n = cx_lo_s6(res_cx), cx_hi_s6(res_cx)
	   DO 450 m = cx_lo_s5(res_cx), cx_hi_s5(res_cx)
	   DO 450 k = cx_lo_s3(res_cx), cx_hi_s3(res_cx)
	   DO 450 j = cx_lo_s2(res_cx), cx_hi_s2(res_cx)
	   DO 450 i = cx_lo_s1(res_cx), cx_hi_s1(res_cx)
* ... locate first valid index off edge of requested region
	      las_index = unspecified_int4
	      DO 410 l = offlim, dnlim, delta
	         IF ( com(i,j,k,l,m,n) .NE. bad_com ) las_index = l
 410	      CONTINUE
* ... loop through points finding distance from last valid point
	      DO 420 l = dnlim, uplim, delta
	         IF ( com(i,j,k,l,m,n) .NE. bad_com ) THEN
	            las_index = l
	            res(i,j,k,l,m,n) = 0.0
	         ELSEIF ( las_index.EQ. unspecified_int4 ) THEN
	            res(i,j,k,l,m,n) = bad_res
	         ELSEIF ( by_index ) THEN
* ... distance in index space
	            res(i,j,k,l,m,n) = ABS(l-las_index)
	         ELSE
* ... distance in world coordinates
	            res(i,j,k,l,m,n) = ABS(
     .                    TM_WORLD(l,         grid, idim, box_middle)
     .                  - TM_WORLD(las_index, grid, idim, box_middle) )
	         ENDIF
 420	      CONTINUE
 450	   CONTINUE

* ALONG E AXIS
	ELSEIF ( idim .EQ. e_dim ) THEN
	   DO 550 n = cx_lo_s6(res_cx), cx_hi_s6(res_cx)
	   DO 550 l = cx_lo_s4(res_cx), cx_hi_s4(res_cx)
	   DO 550 k = cx_lo_s3(res_cx), cx_hi_s3(res_cx)
	   DO 550 j = cx_lo_s2(res_cx), cx_hi_s2(res_cx)
	   DO 550 i = cx_lo_s1(res_cx), cx_hi_s1(res_cx)
* ... locate first valid index off edge of requested region
	      las_index = unspecified_int4
	      DO 510 m = offlim, dnlim, delta
	         IF ( com(i,j,k,l,m,n) .NE. bad_com ) las_index = m
 510	      CONTINUE
* ... loop through points finding distance from last valid point
	      DO 520 m = dnlim, uplim, delta
	         IF ( com(i,j,k,l,m,n) .NE. bad_com ) THEN
	            las_index = m
	            res(i,j,k,l,m,n) = 0.0
	         ELSEIF ( las_index.EQ. unspecified_int4 ) THEN
	            res(i,j,k,l,m,n) = bad_res
	         ELSEIF ( by_index ) THEN
* ... distance in index space
	            res(i,j,k,l,m,n) = ABS(m-las_index)
	         ELSE
* ... distance in world coordinates
	            res(i,j,k,l,m,n) = ABS(
     .                    TM_WORLD(m,         grid, idim, box_middle)
     .                  - TM_WORLD(las_index, grid, idim, box_middle) )
	         ENDIF
 520	      CONTINUE
 550	   CONTINUE
 
* ALONG F AXIS
	ELSEIF ( idim .EQ. f_dim ) THEN
	   DO 650 m = cx_lo_s5(res_cx), cx_hi_s5(res_cx)
	   DO 650 l = cx_lo_s4(res_cx), cx_hi_s4(res_cx)
	   DO 650 k = cx_lo_s3(res_cx), cx_hi_s3(res_cx)
	   DO 650 j = cx_lo_s2(res_cx), cx_hi_s2(res_cx)
	   DO 650 i = cx_lo_s1(res_cx), cx_hi_s1(res_cx)
* ... locate first valid index off edge of requested region
	      las_index = unspecified_int4
	      DO 610 n = offlim, dnlim, delta
	         IF ( com(i,j,k,l,m,n) .NE. bad_com ) las_index = n
 610	      CONTINUE
* ... loop through points finding distance from last valid point
	      DO 620 n = dnlim, uplim, delta
	         IF ( com(i,j,k,l,m,n) .NE. bad_com ) THEN
	            las_index = n
	            res(i,j,k,l,m,n) = 0.0
	         ELSEIF ( las_index.EQ. unspecified_int4 ) THEN
	            res(i,j,k,l,m,n) = bad_res
	         ELSEIF ( by_index ) THEN
* ... distance in index space
	            res(i,j,k,l,m,n) = ABS(n-las_index)
	         ELSE
* ... distance in world coordinates
	            res(i,j,k,l,m,n) = ABS(
     .                    TM_WORLD(n,         grid, idim, box_middle)
     .                  - TM_WORLD(las_index, grid, idim, box_middle) )
	         ENDIF
 620	      CONTINUE
 650	   CONTINUE

	ENDIF

	RETURN
	END

	LOGICAL FUNCTION TM_Line_match ( line1, line2 )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Check to see if line1 is identical to line2
*
* by M. Verschell PMEL/TMAP
*
* revision 0.00 - 10/19/88
* 5/5/93 - *sh* 2 bug fixes in coordinate compare of irregular axes
*	 - 1) reversed logic; 2) convert args to SNGL
*
* IBM port 14apr94 *kob* : Logical expressions need to be compared
*			   using NEQV and EQV
* 1/96 *sh* "bug" fix: match was based on exactly identical unit strings
*		this meant that "DEGREES" didn't match "LONGITUDE".
* V541 *sh* 2/02 - check line_modulo_len
* V551 *acm*2/03 - check calendar type
* V581 *acm* 6/05 - For fix to bug 1271, add flag line_shift_origin
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.

* Include files
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'xtm_grid.cmn_text'
	external xgt_grid_data


* Argument definitions
	INTEGER*4	line1, line2

* Local definitions
	INTEGER*4	j, lc1, lc2
	LOGICAL		TM_FPEQ

* Same regularity/irregularity?
	IF (line_regular(line1) .NEQV. line_regular(line2)) GOTO 110

* Same modularity?
	IF (line_modulo(line1) .NEQV. line_modulo(line2)) GOTO 110

* Same modulo length?
	IF (line_modulo(line1)) THEN
	  IF (line_modulo_len(line1) .NE. line_modulo_len(line2))
     .							  GOTO 110
	ENDIF

* Check length
	IF (line_dim(line1) .NE. line_dim(line2)) GOTO 110

* Check units
	IF (line_unit_code(line1) .NE. line_unit_code(line2) ) GOTO 110
* ... check actual string for unrecognizable units
	IF ( line_unit_code(line1) .EQ. 0 ) THEN	
	   IF (line_units(line1) .NE. line_units(line2)) GOTO 110
	ENDIF

* Check orientation
	IF (line_direction(line1) .NE. line_direction(line2)) GOTO 110

* Check calendar type
	IF (line_direction(line1) .EQ. 'TI') THEN
           IF (line_cal_name(line1) .NE. line_cal_name(line2)) GOTO 110
        ENDIF

* Check special values for time axis
	IF (line_direction(line1) .EQ. 'TI') THEN
	  IF (line_t0(line1) .NE. line_t0(line2)) GOTO 110
	  IF (line_shift_origin(line1) .NEQV. line_shift_origin(line2)) 
     .        GOTO 110
	  IF (line_tunit(line1) .NE. line_tunit(line2)) GOTO 110
	ENDIF

* check coordinate and box locations
	IF (line_regular(line1)) THEN
	  IF (line_start(line1) .NE. line_start(line2)) GOTO 110
	  IF (line_delta(line1) .NE. line_delta(line2)) GOTO 110
	ELSE
	  lc1 = line_subsc1(line1)
	  lc2 = line_subsc1(line2)
	  DO 100 j = 0,2*line_dim(line1)
! added ".NOT." 5/93 *sh*
#ifdef double_p
	    IF (.NOT.TM_FPEQ( (line_mem(lc1+j)),
     .			      (line_mem(lc2+j)) )) GOTO 110
#else
	    IF (.NOT.TM_FPEQ( SNGL(line_mem(lc1+j)),
     .			      SNGL(line_mem(lc2+j)) )) GOTO 110
#endif
  100	  CONTINUE
	ENDIF

* Yes, lines match
	TM_Line_match = .TRUE.
	GOTO 9999

* No, lines don't match
  110	TM_Line_match = .FALSE.

 9999	RETURN
	END

	SUBROUTINE READ_TM (  cx, mr, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* read a grid of data from a TMAP data set

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 11/28/88 - based on IS_READ_GT v0.3 and READ_GT_XYZ v1.1
* V200:  5/19/89 - reordered lo/hi_ss args
*	 12/8/89 - changed call arguments in TM_READ for new compiler
* V230:  7/30/92 - must CALL ERRMSG to stop command files, etc. following error
*        11/6/92 - increased variable length to 24 characters
* V312: 5/94 - array "memory" as a calling argument
* V500: 2/99 - *kob* add call to new routine REPLACEABLE_BAD_FLAGS to allow
*              and check for NaN as missing values
*	3/99 - *kob* up VAR_CODE and local var variable_code to 64 chars
*	5/99 - *sh* added strides to TMAP read calls
* V533: 6/01 - *sh* initialize string input variable
* v552: 4/03 - *acm* up VAR_CODE and local var variable_code to 128 chars
* V556  4/04 - *acm* stride/modulo fixes: use NINT to convert REAL*8 to integer
* v602  8/06 - *jli* native strides  replace cx_delta logic by the line_delta
*       *acm* 3/12 cleanup old VMS ifdef
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V702 1/17 *sh* as a part of conversion to dynamic memory fixed bug that 
*                REPLACE_BAD_DATA was being called on string variables


        IMPLICIT NONE
	include	'tmap_errors.parm'
	include	'tmap_dims.parm'
	include	'xdset_info.cmn_text'
	external xdset_info_data
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'

* calling argument declarations:
	INTEGER	cx, mr, status

* internal variable declarations:
	LOGICAL	TM_ITSA_DSG_RAGGED,
     .		has_a_stride, has_strides(nferdims), its_dsg
	INTEGER MGRID_SIZE_DELTA,
     .			idim, variable, category, data_set, grid,
     .			sf_num, tmap_status, 
     .			lo_ss(nferdims), hi_ss(nferdims),
     .			lo_s1, lo_s2, lo_s3, lo_s4, lo_s5, lo_s6, 
     .			hi_s1, hi_s2, hi_s3, hi_s4, hi_s5, hi_s6,
     .			stride(nferdims), lo_ss_ds,hi_ss_ds, line
* V500 *kob* 3/99- up VAR_CODE and local var variable_code to 64 chars
	CHARACTER*128	VAR_CODE, variable_code

* *kob* 2/99 - add declaration for new c function
	INTEGER REPLACEABLE_BAD_FLAGS

	EQUIVALENCE	(lo_ss(1),lo_s1), (lo_ss(2),lo_s2),
     .			(lo_ss(3),lo_s3), (lo_ss(4),lo_s4),
     .			(lo_ss(5),lo_s5), (lo_ss(6),lo_s6),
     .			(hi_ss(1),hi_s1), (hi_ss(2),hi_s2),
     .			(hi_ss(3),hi_s3), (hi_ss(4),hi_s4),
     .			(hi_ss(5),hi_s5), (hi_ss(6),hi_s6)

* --- end of introductory code ---

* initialize
	data_set = cx_data_set( cx )
	category = cx_category( cx )
	variable = cx_variable( cx )
	grid = cx_grid( cx )
	variable_code = VAR_CODE( category, variable )
	its_dsg = TM_ITSA_DSG_RAGGED(grid)

* check data type
	IF ( cx_type(cx) .NE. ds_var_type(variable) ) THEN
	   CALL WARN('Internal err: read data type mismatch')
	   cx_type(cx) = ds_var_type(variable)
	ENDIF

* jli: replace the following cx_delta logic by the line_delta

* strides indicated in cx_delta e.g. SST[I=110:180:10] ?
* If so, transfer this info to the stride array
	has_a_stride = .FALSE.

* reserve and catalog space for the result
	CALL CREATE_MEM_VAR( cx, mr, status )
	IF ( status .NE. ferr_ok ) GOTO 5900
	IF (ds_var_type(variable) .EQ. ptype_string)
     .		CALL INIT_C_STRING_ARRAY( MGRID_SIZE_DELTA(mr),
     .			                  memry(mr)%ptr,
     .					  mr_c_pointer(mr)      )

* If this is a DSG ragged array variable, that is a separate path
	IF (its_dsg) GOTO 500

* un-cache it?
* Turns out that uncaching the result here causes all of its descendants to
* become uncached, as well, and lowers the cache hit rate. Instead, we will
* handle invalid mr limits left by strides in IS_REGRID
!	IF ( has_a_stride ) CALL UN_CACHE( mr )   ! since lo:hi are "fake"

* set up array of subscripts
	DO 300 idim = 1, nferdims
*<jli
           line = grid_line(idim, grid)

*          For strides indicated in cx_delta e.g. SST[I=110:180:10]
*          use cx_delta logic

           IF(line_parent(line) .EQ. 0) THEN
              has_strides(idim) =  cx_delta(idim,cx) .NE. unspecified_val8
     .                  .AND.  cx_delta(idim,cx) .NE. 1 
              IF (has_strides(idim)) THEN
                stride(idim) = NINT(cx_delta(idim,cx))
                has_a_stride = .TRUE.
              ELSE
                stride(idim) = 1
              ENDIF
     
              IF ( grid_line( idim, grid ) .EQ. mnormal ) THEN
                 lo_ss( idim ) = 1
                 hi_ss( idim ) = 1
              ELSE
                 lo_ss( idim ) = cx_lo_ss( cx, idim )
                 hi_ss( idim ) = cx_hi_ss( cx, idim )
              ENDIF
           
           ELSE

*             For strides specified in SET AXIS/STRIDE
*             Use line_delta logic

              has_strides(idim) = .TRUE.

	      IF ( grid_line( idim, grid ) .EQ. mnormal ) THEN
	         lo_ss( idim ) = 1
	         hi_ss( idim ) = 1
                 stride( idim ) = 1

              ELSEIF ( line_regular(line) ) THEN
              
                 IF (has_strides(idim)) THEN
                    stride(idim) = line_delta(line)/line_delta(line_parent(line))+0.5
                    has_a_stride = .TRUE.
                 ELSE
                    stride(idim) =1 
                 ENDIF


                 lo_ss(idim) = (cx_lo_ss( cx, idim )-1)*stride(idim) + 
     .                         line_offset(line)

                 hi_ss(idim) = (cx_hi_ss( cx, idim )-1)*stride(idim) +
     .                         line_offset(line) 

!                for a reversed axis
                 IF( line_reversed(line)) THEN

! get size of the native axis 
! w/ fix to issue 1843, var_ss_lims returns strided index values
		 
                    CALL VAR_SS_LIMS(idim, cx,lo_ss_ds,hi_ss_ds)
                    hi_ss_ds = hi_ss_ds* stride(idim)

!                   must compute hi_ss first and then lo_ss
                    hi_ss(idim) = hi_ss_ds - 
     .                         (line_dim(line)-cx_hi_ss( cx, idim ))*stride(idim) -
     .                         line_offset(line) + 1
  
                    lo_ss(idim) = hi_ss(idim) - 
     .                         (cx_hi_ss(cx,idim)-cx_lo_ss(cx,idim))*stride(idim)
                 ENDIF

!                for nested stride
                 IF( (cx_delta(idim,cx) .NE. unspecified_val8)
     .                  .AND.  (cx_delta(idim,cx) .NE. 1) ) THEN
                    stride(idim) = stride(idim)*cx_delta(idim,cx)
                 ENDIF


              ELSE
*             Irregular line

                 IF (has_strides(idim)) THEN
                    has_a_stride = .TRUE.
                    stride(idim) = line_delta(line)

!                   Nested strided, e.g.,i=1:20:2      
                    IF( (cx_delta(idim,cx) .NE. unspecified_val8)
     .                  .AND.  (cx_delta(idim,cx) .NE. 1) ) THEN
                       stride(idim) = stride(idim)*cx_delta(idim,cx)
                    ENDIF

                    lo_ss(idim)  = line_start(line) +  
     .                             (cx_lo_ss( cx, idim )-1)*stride(idim)
                    hi_ss(idim)  = line_start(line) +  
     .                             (cx_hi_ss( cx, idim )-1)*stride(idim)
                 ELSE
                    lo_ss( idim ) = cx_lo_ss( cx, idim )
                    hi_ss( idim ) = cx_hi_ss( cx, idim )
                    stride(idim) = 1 
                 ENDIF 

	      ENDIF
           
           ENDIF
 300	CONTINUE

* diagnostic output
 500	IF (mode_diagnostic) THEN
	   IF ( has_a_stride) THEN
	     CALL DIAGNOSTIC_OUT('rdstride',cx,point_to_cx)
	   ELSE
	     CALL DIAGNOSTIC_OUT('reading',mr,point_to_mr)
	   ENDIF
	ENDIF

* read the data

	IF (its_dsg) THEN
	   CALL CD_DSG_READ(data_set,
     .			    variable,
     .			    memry(mr)%ptr,
     .			    mr_type(mr),
     .			    tmap_status	)
	ELSE
	   CALL TM_READ( data_set,
     .			 variable_code,
     .			 lo_s1, lo_s2, lo_s3, lo_s4, lo_s5, lo_s6, 
     .			 hi_s1, hi_s2, hi_s3, hi_s4, hi_s5, hi_s6,
     .			 lo_ss,
     .			 hi_ss,
     .			 stride,
     .			 memry( mr )%ptr,
     .			 sf_num,
     .			 tmap_status		)
	ENDIF 
	IF ( tmap_status .NE. merr_ok ) THEN
	   CALL DELETE_VARIABLE( mr )
	   GOTO 5010
	ENDIF

* replace multiple bad data flags in some variables
* IF ( ds_bad_flag( variable ) .NE. ds_missing_flag( variable ) )
* *kob* 2/99 - call new routine to check for usage of NaN
! 1/17 *sh* check mr_type is needed here because missing data flags are not
! properly initialized on string variables
	IF ( mr_type(mr) .NE. ptype_string
     . .AND. REPLACEABLE_BAD_FLAGS(ds_bad_flag(variable), 
     .                             ds_missing_flag(variable)) .EQ. 1)
     .	   CALL REPLACE_BAD_DATA
     .		(memry(mr)%ptr,mr,cx,ds_missing_flag(variable))

* successful completion
	RETURN

* error exit
 5010	CALL ERRMSG( ferr_TMAP_error, status, ' ', *5900 )   ! 7/92
 5900	RETURN
	END	

	SUBROUTINE EXPL_CORIOLIS( u   , mu   , v   , mv   ,
     .				  ucoe, mucoe, vcoe, mvcoe    )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute the explicit Coriolis effect based on velocity
* components from the preceeding time step
*			correction based on an implicit scheme

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 -1/27/87 extracted from SUBROUTINE CLINIC
*			with major modifications to convert i-k oriented
*			calculations to i-j oriented calculations
* V200:  7/27/89 - 4D symmetrical version
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN

#ifdef unix
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl.parm'		! parameter definitions
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xonedim.cmn'	! geometric constants
	include 'xcontext.cmn'
#else
	INCLUDE 'FERRET_CMN:FERRET.PARM'
	INCLUDE 'FERRET_CMN:GFDL.PARM'		! parameter definitions
	INCLUDE	'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE	'FERRET_CMN:XMEM_SUBSC.CMN'
	INCLUDE 'FERRET_CMN:XONEDIM.CMN'	! geometric constants
	INCLUDE 'FERRET_CMN:XCONTEXT.CMN'
#endif

* calling argument declarations:
	INTEGER	 mu, mv, mucoe, mvcoe

* subscript ranges from memory variable table ...
	REAL       u( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit ),
     .		   v( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,m2lot:m2hit ),
     .		ucoe( m3lox:m3hix,m3loy:m3hiy,m3loz:m3hiz,m3lot:m3hit ),
     .		vcoe( m4lox:m4hix,m4loy:m4hiy,m4loz:m4hiz,m4lot:m4hit )

* internal variable declarations:
	LOGICAL	HOURLY_DATA
	INTEGER	i_lo, i_hi, j_lo, j_hi, i, j, k, l, dl
	REAL	bad_u, factor

* --- end of introductory code ---

* ***************************************************************
* ORIGINAL GFDL 205 CODE UPON WHICH CALCULATION IS BASED
*
* 388 C   ADD IN CORIOLIS FORCE
* 389 C
* 390       FACTOR=2.0*OMEGA*SINE(J)
* 391       IF(ACOR.EQ.0) GO TO 358
* 392       DO 357 K=1,KM
* 393       DO 357 I=1,IMT
* 394       UA(I,K)=UA(I,K)+FACTOR*VB(I,K)
* 395       VA(I,K)=VA(I,K)-FACTOR*UB(I,K)
* 396  357  CONTINUE
* 397       GO TO 3590
* 398  358  CONTINUE
* 399       DO 359 K=1,KM
* 400       DO 359 I=1,IMT
* 401       UA(I,K)=UA(I,K)+FACTOR*V(I,K)
* 402       VA(I,K)=VA(I,K)-FACTOR*U(I,K)
* 403  359  CONTINUE
* 404  3590 CONTINUE

*************************************************************************
* compute the explicit Coriolis increment implied by the past velocity

* use 1 hour separation for exact results on hourly data
	IF ( HOURLY_DATA(mr_grid(mucoe)) ) THEN
	   dl = 1
	ELSE
	   dl = 0
	ENDIF

* limits for calculation
	i_lo = mr_lo_s1(mucoe)
	i_hi = mr_hi_s1(mucoe)
	j_lo = mr_lo_s2(mucoe)
	j_hi = mr_hi_s2(mucoe)

* flag for bad/missing data
	bad_u = mr_bad_data( mu )

* compute:
	DO 200 j = j_lo, j_hi

	   factor = 2.0*omega*sine(j) * cmonthly
*	   IF ( acor.EQ.0 ) GOTO 358

	   DO 200 l = mr_lo_s4(mucoe), mr_hi_s4(mucoe)
	   DO 200 k = mr_lo_s3(mucoe), mr_hi_s3(mucoe)

* based on velocity at time n-1:
	   DO 100 i = i_lo, i_hi 
	      IF ( u(i,j,k,l) .EQ. bad_u ) THEN
	         ucoe(i,j,k,l) = bad_val4
	         vcoe(i,j,k,l) = bad_val4
	      ELSE
	         ucoe(i,j,k,l) =  factor * v(i,j,k,l)
	         vcoe(i,j,k,l) = -factor * u(i,j,k,l)
	      ENDIF
 100	   CONTINUE
	   GOTO 200

* based on velocity at time n:
! 358 	   CONTINUE
!	   STOP 'Coriolis based on single time step not implemented'
*	   DO 110 i = i_lo, i_hi 
*	      IF ( u(i,j,k,l+dl) .EQ. bad_u ) THEN
*	         ucoe(i,j,k,l) = bad_val4
*	         vcoe(i,j,k,l) = bad_val4
*	      ELSE
*	         ucoe(i,j,k,l) =  factor * v(i,j,k,l+dl)
*	         vcoe(i,j,k,l) = -factor * v(i,j,k,l+dl)
*	      ENDIF
* 110	   CONTINUE

 200	CONTINUE
	RETURN

	END

	SUBROUTINE NUMCDE_OFF(XZ,STR,LETTER,NC,FRMTZ,DMS,OFF)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* revised for TMAP
* from PPLUS :
*	Directory PMEL:[PLOT5.PPLV11.PLOTLIB]NUMCDE.FOR

C**
C**    from numcde.f
C 1/2006 acm Add an offset to the value before formatting it 
C V600: *acm* 5/06 Allow seconds in DMS axis labelling; had removed this.
* V63  *acm* 10/09 Changes for gfortran build
* V7    *acm* 6/16 Ticket 2434: command qualifiers /DEGMINSEC= /HALFSPAC
*                  DEGMINSEC=1 for Deg-Min axis labels, =2 for Deg-Min-Sec. Default = 1
*                  /HALFSPAC adds a half space between the degree sign and E/W or N/S

C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**

c
	CHARACTER*(*) FRMTZ
	CHARACTER*20 FRMT,STR,TEMP,STR_DMS
	CHARACTER*1  LETTER
        INTEGER TM_LENSTR1, dms, imin, isec, dot, deg
        REAL frac, minutes, seconds, off
        REAL*8 val, x
C
	FRMT=FRMTZ
	TEMP=FRMTZ
	CALL UPPER(TEMP,20)
	X=XZ + off

	ILAT = INDEX (TEMP, ',''LAT'')')
	IF (ILAT .NE. 0) THEN
	  FRMT (ILAT+1:) = '''#'')'
	  IF (X .LT. 0) THEN
	    X=-X
	    LETTER = 'S'
	  ELSE IF (X .EQ. 0.) THEN
	    LETTER = ' '
	  ELSE
	    LETTER = 'N'
	  ENDIF
	ELSE
	  ILON = INDEX (TEMP, ',''LON'')') + INDEX (TEMP, ',''LONW'')')
	  ILONE = INDEX (TEMP, ',''LONE'')')
	  IF (ILON .NE. 0) THEN
	    FRMT (ILON+1:) = '''#'')'
	    IF (X .GT. 180.) THEN
	      X=360.-X
	      LETTER = 'E'
	    ELSE IF (X .EQ. 180.) THEN
	      LETTER = ' '
	    ELSE IF (X .LT. 0.) THEN
	      LETTER = 'E'
	      X = -X
	    ELSE
	      LETTER = 'W'
	    ENDIF
	  ELSE IF (ILONE .NE. 0)THEN
* TMAP insert 2/13/89
* Further fixes for X LE -180  1/18/2013
	    X = MOD( X, 360. )
* ... end of TMAP insert
	    FRMT (ILONE+1:) = '''#'')'
	    IF (X .GT.180.) THEN
	      X=360.-X
	      LETTER = 'W'
	    ELSE IF (ABS(X) .EQ. 180.) THEN
	      LETTER = ' '
	      X = ABS(X)
	    ELSE IF (X .LT. -180.) THEN
	      LETTER = 'E'
	      X = 360.+X
	    ELSE IF (X .LT. 0.) THEN
	      LETTER = 'W'
	      X = -X
	    ELSE IF (X .NE. 0.) THEN
	      LETTER = 'E'
            ELSE
	      LETTER = ' '
	    ENDIF
	  ENDIF
	ENDIF
C
	FLAG=0
	IF(FRMT(1:2).EQ.'(I'.OR.FRMT(1:2).EQ.'(i')THEN
            xr = x
	    WRITE(STR,FRMT)IFIX(XR+SIGN(.5,off))
	ELSE
	    WRITE(STR,FRMT)X
	END IF
C     STRIP OFF LEADING ZERO AND SET FLAG
	IF(FRMT(1:4).EQ.'(''0''')THEN
	    TEMP=STR(2:20)
	    STR=TEMP
	    FLAG=1
	END IF
C     LEFT JUSTIFY STRING
	NC=0
100	IF(STR(1:1).EQ.' ')THEN
	    TEMP=STR(2:20)
	    STR=TEMP
	    NC=NC+1
	    IF(NC.LE.20)GOTO 100
	END IF
C     ADD LEADING ZERO
	IF(FLAG.EQ.1.AND.ABS(X).LT.1.1)THEN
	    IF(STR(1:1).EQ.'.')THEN
		TEMP='0'
		TEMP(2:)=STR(1:19)
	    ENDIF
	    IF(STR(1:2).EQ.'+.'.OR.STR(1:2).EQ.'-.')THEN
		TEMP=STR(1:1)
		TEMP(2:2)='0'
		TEMP(3:)=STR(2:18)
	    ENDIF
	    STR=TEMP
	END IF
	NC=LNBLK(STR,20)

* Reformat the value into deg,min,sec if requested.
* This means moving the degree symbol after the degrees
* and putting the direction (N,S,E,W) at the end
* For longitudes larger than 180, format them as is and
* translate to west longitude afterwards.
 
        STR_DMS = ' '
        IF (dms .GE. 1) THEN
            
           dot = INDEX(str,'.')
           deg = INDEX(str,'#')
           IF (dot .EQ. 0) dot = TM_LENSTR1(str) +1
           val = xz + off
           IF (val .LT. 0) val = x

           ideg = INT(val)
           frac = val - FLOAT(ideg)
           minutes = 60.*frac
           imin = INT(minutes+0.1)  ! sun at least, turns 40 into 39 sometimes...
           frac = minutes - FLOAT(imin)
           seconds = 60.* frac
           isec = INT(seconds+0.1)

           IF (ideg .GT. 180.) THEN
              ideg = 360-ideg
              imin = 60-imin
           ENDIF

           IF (dms .EQ. 2) THEN  ! write as deg,min,sec
              IF (ideg .LT. 100) THEN
                 WRITE (STR_DMS, 1100) ideg, imin, isec
              ELSE
                 WRITE (STR_DMS, 1101) ideg, imin, isec
              ENDIF
1100          FORMAT (I2.2, '#', I2.2, '''', I2.2, '''', '''')
1101          FORMAT (I3.3, '#', I2.2, '''', I2.2, '''', '''')

           ELSE IF (dms .EQ. 1) THEN  ! break into deg,min
              IF (ideg .LT. 100) THEN
                 WRITE (STR_DMS, 1200) ideg, imin
              ELSE
                 WRITE (STR_DMS, 1201) ideg, imin
              ENDIF
1200          FORMAT (I2.2, '#', I2.2, '''')
1201          FORMAT (I3.3, '#', I2.2, '''')

           ELSE IF (dms .EQ. 3) THEN  ! write as deg,min.frac

* get number of digits from the format given by the format that came into this routine.
* seeing if it is Fn.m.  If M=0, use minutes only. If M=1, then use one digit for the 
* fractional part of the mintues, otherwise write two digits. Round rather than truncating
* for degrees and fractions.

              dot = INDEX(frmtz,'.')
              READ (frmtz(dot+1:dot+1), *) digits
              IF (digits .EQ. 0) THEN   ! degrees, minutes only
                 imin = INT(minutes+0.5)
                 IF (ideg .LT. 100) THEN
                    WRITE (STR_DMS, 1300) ideg, imin
                 ELSE
                    WRITE (STR_DMS, 1301) ideg, imin
                 ENDIF
1300             FORMAT (I2.2, '#', I2.2, '''')
1301             FORMAT (I3.3, '#', I2.2, '''')
              ELSE IF (digits .EQ. 1) THEN  ! degrees,min.f

                 IF (ideg .LT. 100) THEN
                    WRITE (STR_DMS, 1400) ideg, minutes
                 ELSE
                    WRITE (STR_DMS, 1401) ideg, minutes
                 ENDIF
1400             FORMAT (I2.2, '#', F4.1, '''')
1401             FORMAT (I3.3, '#', F4.1, '''')
              ELSE                          ! degrees,min.ff
                 IF (ideg .LT. 100) THEN
                    WRITE (STR_DMS, 1500) ideg, minutes
                 ELSE
                    WRITE (STR_DMS, 1501) ideg, minutes
                 ENDIF
1500             FORMAT (I2.2, '#', F5.2, '''')
1501             FORMAT (I3.3, '#', F5.2, '''')
              ENDIF

           ELSE 
              STR_DMS = str
           ENDIF
           str = STR_DMS
           NC=LNBLK(STR,20)

        ENDIF

	RETURN
	END

	SUBROUTINE  VEL_ADV_Z (	uk  , muk  ,
     .				wk  , mwk  ,
     .				uadz, muadz )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute vertical advection of velocity components
* note: the identical code applies to both U and V

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 -1/23/87 extracted from SUBROUTINE CLINIC
*			with major modifications to convert i-k oriented
*			calculations to i-j oriented calculations
* revision 0.1 - 4/13/87 - corrected dz(1) --> dz(k)
*			   and corrected flux form to true z advection
* V200:  7/27/89 - 4D symmetrical version
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN
* Linux Port 1/97 *kob* - Added a preprocessor include for xgfdl_masks.cmn
*			  because it needed a preprocessor.
#ifdef unix
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl.parm'		! parameter definitions
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xonedim.cmn'	! geometric constants
#	include "xgfdl_masks.cmn"
	include 'xcontext.cmn'
#else
	INCLUDE 'FERRET_CMN:FERRET.PARM'
	INCLUDE 'FERRET_CMN:GFDL.PARM'		! parameter definitions
	INCLUDE	'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE	'FERRET_CMN:XMEM_SUBSC.CMN'
	INCLUDE 'FERRET_CMN:XONEDIM.CMN'	! geometric constants
	INCLUDE 'FERRET_CMN:XGFDL_MASKS.CMN'
	INCLUDE 'FERRET_CMN:XCONTEXT.CMN'
#endif

* calling argument declarations:
	INTEGER	muk, mwk, muadz

* subscript ranges from memory variable table ...
	REAL      uk( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit ),
     .		  wk( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,m2lot:m2hit ),
     .		uadz( m3lox:m3hix,m3loy:m3hiy,m3loz:m3hiz,m3lot:m3hit )

* internal variable declarations:
	INTEGER	i_lo, i_hi, j_lo, j_hi, i, j, k, l
	REAL	bad_u, bad_w, factor, up, down, dwudz, udwdz

* --- end of introductory code ---

* limits for calculation
	i_lo = mr_lo_s1(muadz)
	i_hi = mr_hi_s1(muadz)
	j_lo = mr_lo_s2(muadz)
	j_hi = mr_hi_s2(muadz)

* flag for bad/missing data
	bad_u = mr_bad_data( muk )
	bad_w = mr_bad_data( mwk )

* ***************************************************************
* ORIGINAL GFDL 205 CODE UPON WHICH CALCULATION IS BASED
*
* 352 C   ADD IN VERTICAL ADVECTION AND VERTICAL DIFFUSION
* 353 C
* 354       DO 340 K=1,KMP1
* 355       DO 340 I=1,IMT
* 356       TEMP2D(I,K)=W(I,K)*(U(I,K-1)+U(I,K))
* 357  340  CONTINUE
* 358       DO 343 K=1,KM
* 359       DO 343 I=1,IMT
* 360       UA(I,K)=UA(I,K)+(TEMP2D(I,K+1)-TEMP2D(I,K))*DZ2R2D(I,K)
* 361  343  CONTINUE

* 371       DO 350 K=1,KMP1
* 372       DO 350 I=1,IMT
* 373       TEMP2D(I,K)=W(I,K)*(V(I,K-1)+V(I,K))
* 374  350  CONTINUE
* 375       DO 353 K=1,KM
* 376       DO 353 I=1,IMT
* 377  353  VA(I,K)=VA(I,K)+(TEMP2D(I,K+1)-TEMP2D(I,K))*DZ2R2D(I,K)
*************************************************************************
	DO 2000 l = mr_lo_s4(muadz), mr_hi_s4(muadz)
	DO 2000 k = mr_lo_s3(muadz), mr_hi_s3(muadz)

* note: k subscripting is offset by one in this code as compared to the 205 code
*	because w(0) = 0. in this code whereas w(1)=0 in the 205 version

	factor = (1. / dz(k)) * cmonthly

	DO 340 j = j_lo, j_hi
	DO 340 i = i_lo, i_hi

	   IF ( uk(i,j,k,l) .EQ. bad_u
     .	    .OR.wk(i,j,k,l) .EQ. bad_w ) THEN

	      uadz(i,j,k,l) = bad_val4
	      GOTO 340
	   ENDIF

* calculate flux form ( as in 205 code ): d/dz(WU)
	   IF ( k .GT. 1 ) THEN
	      up = wk(i,j,k-1,l) * ( uk(i,j,k-1,l) + uk(i,j,k,l) ) / 2
	   ELSE
	      up = 0.0
	   ENDIF

	   IF ( k .LT. kmu(i,j) ) THEN
	      down = wk(i,j,k,l) * ( uk(i,j,k,l) + uk(i,j,k+1,l) ) / 2
	   ELSE
	      down = 0.0
	   ENDIF

	   dwudz = ( up - down ) * factor

* calculate U*d/dz(W)
	   IF ( k .EQ. 1 ) THEN
	      udwdz = uk(i,j,k,l) * (     0.0       - wk(i,j,k,l) ) * factor
	   ELSE
	      udwdz = uk(i,j,k,l) * ( wk(i,j,k-1,l) - wk(i,j,k,l) ) * factor
	   ENDIF

* note: actually we need to calculate the negative: -W*d/dz(U)
* subtract to get -W*d/dz(U) = U*d/dz(W) - d/dz(WU)
	   uadz(i,j,k,l) = udwdz - dwudz

 340	CONTINUE
 2000	CONTINUE
	RETURN
	END

      subroutine pplldx(icode,xt,yt,npts,tstrt,tref,xdt,pplmem)


C**
C**    @(#)pplldx.F	1.2    9/8/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
c
c	icode	0 use both x and y
c		1 use x only
c		2 use y only
c
c                  When saving polygon data, save npts per polygon with 
c                  the data, not in the array lleng(): unlimited # polygons

c               3 use both x and y, for polygons 
c		4 use x only, for polygons
c		5 use y only, for polygons
c
c	xt	x data
c	yt	y data
c	npts	number of xt and yt points
c	tstrt	start time, corresponds to a value of xt=1.0
c 	tref	added 11.95, a reference time (~tstart) ferret will set
c	xdt	sample rate in minutes for x
c	pplmem  data buffer for PPLUS data
c
c	tstrt and xdt are used only for TAXIS,ON.
c
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*............. I changed the logicals on the includes - no impact ...sh
* revised for FERRET
* from PPLUS :

*	Directory PMEL:[PLOT5.LIBRARY.PLOT]

*	PPLLDX.FOR;1              7  25-AUG-1987 15:24

* search for "FERRET" to find all revisions
* *sh* 9/21/88 - rev 1.0 for FERRET 1.10+
*	- extensive changes to code that determines time axis limits
*	  previous version was based on a "minutes since 1970" calculation
*	  that blew up on dates preceeding 1970.  Replaced with a "minutes
*	  since BC" calculation
* *sh* 2/20/89- rev 1.1 for FERRET 1.20
*	- corrected bug in FERRET code: tmin,tstop calculation for linen>1
*	- reference ALL time axes to the same T0='0101010000' date
*	  instead of using T0 from first line (else overlays don't work)
*       - added LIMITS screening - permitting different bad data indicators
*	  in each data set
* Note: calling PPLLDX modifies the XEQ and YEQ limits
*	Mod *jd* 12.23.92 for MAC FERRET to change 8 args to 6 in stmnmx call
* *sh* 10/25/93 - for version 3.01 of FERRET
*	- corrected bug if Y axis was the time axis - data was not put through
*	  the time/date translation pipeline
* *sh*jd* 7.31.95 
*	- Fixes bug where small axis ranges result in round off error 
*	  creation.  Use TRANSLATE to catch.
* *jd* 11.27.95 Mod for 4 digit year
* *jd* 11.28.95 Add additional arg "tref" so reference time can be set
*	        by Ferret, now that 1901 is insufficient
* *jd* 11.30.95 Fix bug (again? see 10/25/93) where Y axis time axis
*		limits are not computed
* V510 *sh* 3/00 - allow loading of up to NPOLYGON lines (instead of NLINES)
*		 - the X or Y inputs no longer both flagged as bad if either is
* V540 *acm*9/01 - changes for dynamic pplus buffer, call PPLLDX via pplldx_envelope.c
*                  which checks pplmem_nsize (new name for NSIZE) and allocates 
*                  more if needed.
*      *acm* 10/01 Remove VMS includes
* V541 *acm*  4/02 Explicitly set itstart to be all 14 character places of tref:
*                  itstrt = tref(1:14) Otherwise we only get the first 10 (why??)
* V553 *acm*  6/03  For polygons, store the # of points in each polygon in the PPLUS
*                   memory buffer, rather than in lleng.  This way the number of
*                   polygons that may be plotted is unlimited. Mark this with the
*                   value of icode (first argument to pplldx_envelope)
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus
*      *kms* 5/12 Always use generic REAL instead of specific SNGL 
*                 (SNGL must have a double-precision or complex argument)
* V695  *acm*  9/15 Changes for hour:min labeling on time axes
* V697  *acm*  1/16 Ticket 2344: if there was a time-plot underlay, use its time scaling

* FERRET 9-21-88: replaced include files to make all declarations explicit
! original:

!	include 'pplinc:parampl5.dat'
!	include 'pplinc:hd.inc'
!	include 'pplinc:lines.inc'
!	include 'pplinc:data.inc'
!	include 'pplinc:axisl.inc'
!	include 'pplinc:taxis.inc'
!	include 'pplinc:cmrdl.inc'
!	include 'pplinc:ppldat.inc'

	include 'parampl5_dat.decl'
	include 'PARAMPL5.DAT'
	include 'hd_inc.decl'
	include 'HD.INC'
	include 'lines_inc.decl'
	include 'LINES.INC'
	include 'taxis_inc.decl'
	include 'TAXIS.INC'
	include 'cmrdl_inc.decl'
	include 'CMRDL.INC'
	include 'data_inc.decl'
	include 'DATA.INC'
	include 'axisl_inc.decl'
	include 'AXISL.INC'
	include 'PPLDAT.INC'

	include 'miss_inc.decl'
	include 'MISS.INC'

* 	Add external stmt for linux port
	external range


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

c
! original:
!	dimension xt(*),yt(*),stop(3),temp(3),start(3)
!	character tstrt*10
!	integer*4 mtmin,tstart,tstop,time,tmin

        REAL pplmem(*)

#ifdef double_p
	REAL*8 xt(*),yt(*), xdt
#else
	REAL xt(*),yt(*), xdt
#endif
	CHARACTER BC2WHOI*14, tstrt*(*), tref*(*)
	REAL*8	WHOI2BC, DIFF, tstart, tstop, time, tmin, off, rate, 
     .		dxmin, dxmax, dymin, dymax, xymin, xymax dtd
	INTEGER	icode, npts, i, ix, iy
	REAL	xs, ys
	LOGICAL  TM_FPEQ_SNGL
	LOGICAL  flip			!  FERRET mod 10/93

	REAL	    bad_flag
	PARAMETER ( bad_flag = -3.E33 )

	logical	translate 

* end of 9-21 FERRET declaration changes

* mod to SAVE certain variables *jd* 6.5.91
        SAVE        tstart,tmin,tstop

c
	dtd = dt

	if(linen.eq.0)call rsmnmx
	linen=linen+1
	jtype=1
	nx=npts
	ny=1
	flip = itflg .EQ. -1		!  FERRET mod 10/93

**	if(ABS(itflg).eq.1)then		!  FERRET mod 10/93  "ABS"

	translate = ABS(itflg).eq.1
	if (translate) then	
c
c	time axis is on.
c ** acm mod 9/01  Compare tref(1:1) rather than just tref. After
c **               passing thru c routine, a blank tref is somehow different??

c    ticket 2344: if there was a time-plot underlay, use its delta-t
	    IF (dt_save .NE. 0) THEN
	       dtd = dt_save
	       dt = dt_save
	    ENDIF

	    if(linen.eq.1)then
		iform='LDX'
		if(iautot.eq.1 .AND. tref(1:1).NE.' ') itstrt=tref(1:14) 
	    endif		
c
c	calculate offset and rate for time data
c
	    off=diff(itstrt,tstrt)/dtd+1.0
	    rate=xdt/dtd
**	else
**	    off=1.0
**	    rate=1.0
	endif
c
c	load data
c

C 8/2015 compute min and max in double precision, then translate

	dxmin=1.0e36
	dxmax=-dxmin
	dymin=dxmin
	dymax=dxmax

	ix=ibase-1
	iy=ix+pplmem_nsize/2
	if(icode.eq.0 .OR. icode.EQ.3) THEN
	    do 100 i=1,npts

	        xs = REAL(xt(i))
	        ys = REAL(yt(i))
	        IF ( flip ) THEN

	          IF ( yeq .AND. TM_FPEQ_SNGL(ys,cmyeq) ) THEN
	             pplmem(iy+i) = bad_flag

		  elseif (translate) then
		     pplmem(iy+i)=(yt(i)-1.0)*rate+off
		  else
		     pplmem(iy+i)=yt(i)
		  endif

	          IF ( xeq .AND. TM_FPEQ_SNGL(xs,cmxeq)) THEN
	             pplmem(ix+i) = bad_flag
	          ELSE
		     pplmem(ix+i)=xt(i)
	          ENDIF

	        ELSE
	          IF ( yeq .AND. TM_FPEQ_SNGL(ys,cmyeq) ) THEN
	             pplmem(iy+i) = bad_flag
	          ELSE
		     pplmem(iy+i)=yt(i)
	          ENDIF

	          IF ( xeq .AND. TM_FPEQ_SNGL(xs,cmxeq) ) THEN
	             pplmem(ix+i) = bad_flag
	          ELSEIF (translate) then
		     pplmem(ix+i)=(xt(i)-1.0)*rate+off
	          ELSE
		     pplmem(ix+i)=xt(i)
		  ENDIF

		ENDIF

		  IF ( .NOT.(xeq .AND. TM_FPEQ_SNGL(xs,cmxeq)) ) THEN
		     dxmin = MIN(dxmin, xt(i))
		     dxmax = MAX(dxmax, xt(i))
		  ENDIF
		  IF ( .NOT.(yeq .AND. TM_FPEQ_SNGL(ys,cmyeq)) ) THEN
		     dymin = MIN(dymin, yt(i))
		     dymax = MAX(dymax, yt(i))
		  ENDIF

100	    continue

            if (flip) THEN
	       IF (translate) then
		   dymin = (dymin-1.0)*rate+off
		   dymax = (dymax-1.0)*rate+off
	       ENDIF
	    ELSE
	       IF (translate) then
		   dxmin = (dxmin-1.0)*rate+off
		   dxmax = (dxmax-1.0)*rate+off
	       ENDIF
	    ENDIF

	else if(icode.eq.1)then
	    do 200 i=1,npts
	        xs = REAL(xt(i))
	        IF ( ( xeq .AND. TM_FPEQ_SNGL(xs,cmxeq) ) ) THEN
	           pplmem(ix+i) = bad_flag
	           pplmem(iy+i) = i     ! 3/00 mod
	           GOTO 200
	        ENDIF
		pplmem(iy+i)=i
	        if (translate) then
		   pplmem(ix+i)=(xt(i)-1.0)*rate+off
	        else
		   pplmem(ix+i)=xt(i)
	        endif
200	    continue
	else
	    do 300 i=1,npts
	        ys = REAL(yt(i))
	        IF ( ( yeq .AND. TM_FPEQ_SNGL(ys,cmyeq) ) ) THEN
	           pplmem(ix+i) = bad_flag
	           pplmem(iy+i) = bad_flag
	           GOTO 300
	        ENDIF
		if (translate) then
		   pplmem(ix+i)=(float(i)-1.0)*rate+off
	        else
		   pplmem(ix+i)=float(i)
	        endif
		pplmem(iy+i)=yt(i)
300	    continue
	endif
* FERRET mod 2/89 - replace bad data LIMITS flags
	cmxeq = bad_flag
	cmyeq = bad_flag
c
c	some variable definitions
c
c	tmin    time for xmin (endpoint of this line in minutes since BC)
c	tstop   time for xmax (endpoint of this line in minutes since BC)
c	itmin   earliest tmin for all lines (in WHOI format)
c	itmax   latest  tstop for all lines (in WHOI format)
c	itstart reference start time (if iautot the first lines tstrt) (???)
c

	if(translate)then  		! 11.30.95 WAS:	if(itflg.eq.1)then
		if(itflg.eq.1) then 	! 11.30.95 for both x and y
		   xymin  = dxmin
		   xymax  = dxmax
	        else 			! gotta be -1
		   xymin  = dymin
		   xymax  = dymax
		endif

	    if(linen.eq.1)then
		tstart = WHOI2BC( itstrt )		! t=1 of time axis

		tmin=tstart+(xymin-1.0)*dtd		! start of plot axis
		itmin = BC2WHOI( tmin )

		tstop=tstart+(xymax-1.0)*dtd		! end of plot axis
		itmax = BC2WHOI( tstop )

	    else

		tmin=tstart+(xymin-1.0)*dtd
		tstop=tstart+(xymax-1.0)*dtd

		time = WHOI2BC( itmin )
		if(tmin.lt.time)  itmin = BC2WHOI( tmin )   ! chg. plot start
c
		time = WHOI2BC( itmax )
		if(tstop.gt.time) itmax = BC2WHOI( tstop )   ! chg. plot end
	    endif
	endif
* end of FERRET 9-21 changes
        
	pbuf=1
c 8/2015 Should stmnmx use double precisison xmin,xmax, ...?  Seems ok as single.
	xmin = dxmin
	xmax = dxmax
	ymin = dymin
	ymax = dymax
	call stmnmx(pplmem,pplmem_nsize,xmin,xmax,ymin,ymax)

	lnum = linen
        IF (icode .LE. 2) THEN
           lleng(linen)=npts
 	   if(linen.ge.NPOLYGON)then
	       linen=NPOLYGON - 1
	   else
	       ibase=ibase+lleng(linen)
	   endif
        ELSE
           ibase = ibase + npts
        ENDIF

	return
	end

c*
c* ef_get_axis_dates.F
c*
c* Ansley Manke
c* Dec 9 1998
c*
c*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
c*
c* This returns the date buffer associated with the 
c* time axis of an argument.
c* datebuf is the date string. slen is the maximum length of the date strings
c*
*  V665 *acm*/11/09 Fix ticket 1766, as in #762, if the axis is modulo
*                   the year 0000 or 0001 returns as blank.  If not modulo
*		    then we want to return the year correctly.
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
* v695 *acm* 2/15  Get axis dates from an F or T axis
* v75  *acm* 3/18  Changes to allow for timesteps in fractional seconds

      SUBROUTINE EF_GET_AXIS_DATES(id, iarg, tax, dim, numtimes, precision, slen, datebuf )

      IMPLICIT NONE
      INCLUDE 'tmap_dims.parm'
      INCLUDE 'ferret.parm'
      INCLUDE 'xcontext.cmn'
      INCLUDE 'EF_Util.parm'
      INCLUDE 'xtm_grid.cmn_text'

      INTEGER id, iarg, dim, numtimes, precision, slen
      REAL*8 tax(*)
      CHARACTER*(*) datebuf(*)

      INTEGER TM_LENSTR1, l, grid, seconds
      REAL*8  tstep_r8, test(5)
      INTEGER cx_list(EF_MAX_ARGS)

c* The context list was cached by Ferret and must be retrieved
c* to be accessible to the external function.

      CALL EF_GET_CX_LIST(cx_list)
      grid = CX_GRID(cx_list(iarg))

      slen = 0
      IF (precision .EQ. 0) precision = 6
      DO 100 L = 1, numtimes
         tstep_r8 = tax(L)
         CALL EF_GET_DATE_TSTEP ( grid, dim, tstep_r8, precision, datebuf(l) )
	 IF ( TM_LENSTR1(datebuf(l)) .GT. slen ) slen = TM_LENSTR1(datebuf(l))
100   CONTINUE


      RETURN 
      END

        SUBROUTINE GET_DATASET_NAME_FROM_BROWSER(status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Get the name of a dataset for a SET DATA /BROWSE command
*
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)


        INTEGER status

	include 'tmap_dims.parm'
        include 'errmsg.parm'
        include 'ferret.parm'
        include 'slash.parm'
        include 'xprog_state.cmn'

	LOGICAL do_jnl
        INTEGER RUN_THREDDS_BROWSER, TM_LENSTR,
     .          len_name, buff_len, loc
        CHARACTER*512 dataset_name
        CHARACTER*2048 err_warn_msg

	do_jnl = mode_journal .AND. jrnl_lun.NE.unspecified_int4 

* Run the browser to get the dataset name
        dataset_name = ' '
        err_warn_msg = ' '
        len_name = RUN_THREDDS_BROWSER(dataset_name, err_warn_msg)

* Check if there was an error running the browser
        IF ( len_name .LT. 0 ) THEN
            IF (do_jnl) CALL SPLIT_LIST(pttmode_ops, jrnl_lun, 
     .                      '!-> **ERROR**', 0)
            CALL SPLIT_LIST(pttmode_ops, ttout_lun, 
     .                      '!-> **ERROR**', 0)
            CALL SPLIT_LIST(pttmode_ops, err_lun, err_warn_msg, 0)
            status = ferr_erreq
            RETURN
        ENDIF

* Check if the user canceled out
        IF ( len_name .EQ. 0 ) THEN
            IF (do_jnl) CALL SPLIT_LIST(pttmode_ops, jrnl_lun, 
     .                      '!-> **CANCEL**', 0)
            CALL SPLIT_LIST(pttmode_ops, ttout_lun, 
     .                      '!-> **CANCEL**', 0)
            status = ferr_erreq
            RETURN
        ENDIF

* Append the dataset name obtained
        buff_len = TM_LENSTR(cmnd_buff)
        cmnd_buff(buff_len+1:) = ' "' // dataset_name(1:len_name) // '"'
        num_items = num_items + 1
        item_start(num_items) = buff_len + 3
        item_end(num_items) = item_start(num_items) + len_name - 1

* Blank out the /BROWSE option to make a nicer message printed to stdout and the journal
        loc = qual_given(slash_set_data_browse)
        IF ( loc .GT. 0 ) THEN
            cmnd_buff(qual_start(loc)-1:qual_end(loc)) = ' '
        ENDIF

* Include the quotes in the filename printed to stdout and the journal
        IF (do_jnl) CALL SPLIT_LIST(pttmode_ops, jrnl_lun, 
     .                  '!-> ' // cmnd_buff, 0)
        CALL SPLIT_LIST(pttmode_ops, ttout_lun, 
     .                  '!-> ' // cmnd_buff, 0)

        status = ferr_ok
        RETURN

        END

	SUBROUTINE TM_CHECK_LINE ( line, npts, reversed, vname, vlen, 
     .      is_double, its_irregular, use_strict, regular, misordered)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Check coordinate data from a netCDF file
*
* Check for misordered or repeated data.
* If repeated values, apply micro-adjusting, or report as a warning if the 
* user requested /STRICT.

* Check if axis is actually regularly spaced (though not flagged as "even")
* Use the precision of the data  in the file.

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - SDIG

* revision 0.0 - 6/17
* V72 6/17 *acm* for trac enhancement #767 -- dynamic coordinate storage 


        include 'tmap_errors.parm'
        include 'xio.cmn_text'
        external xio_data

* argument declarations

	LOGICAL reversed, is_double, has_repeated, its_irregular, 
     .       use_strict, regular, misordered
	REAL line(*)
	INTEGER npts, vlen
	CHARACTER*(*) vname


* local declarations
	LOGICAL TM_DFPEQ_TOL, TM_FPEQ_EPS
	REAL tmp8, micro_adj, epsilon_21, depsilon_42, epsilon, depsilon,
     .       dfirst_delta, ddelta, delta, firs_coord, last_coord, first_delta
	INTEGER i, istat
	CHARACTER*12 TM_LEFINT

	misordered = .FALSE.  ! valid until proven otherwise

* (From Wikipedia on precision:)
* Single precision, called "float" in the C language family, and "real" 
* or "real*4" in Fortran. This is a binary format that occupies 32 bits (4 bytes) 
* and its significand has a precision of 24 bits (about 7 decimal digits).
* Double precision, called "double" in the C language family, and "double precision" 
* or "real*8" in Fortran. This is a binary format that occupies 64 bits (8 bytes) 
* and its significand has a precision of 53 bits (about 16 decimal digits).

      epsilon_21 =  2.**(-21)
      depsilon_42 =  2.**(-42) 

* if the coordinates are decreasing-ordered then reverse them

	IF (npts .GT. 1) THEN
	   first_delta = line(2) - line(1)
	   reversed = first_delta .LT. 0.0
	ENDIF

	IF (reversed) THEN
	   DO i = 1, npts/2
	      tmp8 = line(i)
	      line(i) = line(npts+1-i)
	      line(npts+1-i) = tmp8
	   ENDDO
	ENDIF

* If repeated values, apply micro-adjusting. 
* Or report as a warning if the user requested /STRICT.

         misordered = .FALSE.
         DO i = 2, npts
           IF (line(i) .LT. line(i-1) ) 
     .	      misordered = .TRUE.
	   IF (use_strict .AND. (line(i) .LE. line(i-1)) )
     .	      misordered = .TRUE.

	   IF (misordered) EXIT ! from loop
         ENDDO

* 0726348357

* out of order axis coordinates.
* If reversed above, remove that designation to 
* just hand the user the original data

         IF (misordered) THEN
            CALL TM_NOTE(
     .          'Coordinates out of order or missing on axis '//
     .           vname(:vlen)//' at subscript '//TM_LEFINT(i, istat), 
     .           lunit_errors)
            CALL TM_NOTE(
     .          'A dummy axis of subscripts will be used', lunit_errors)
     
            IF (reversed) THEN
               DO i = 1, npts/2
	         tmp8 = line(i)
	         line(i) = line(npts+1-i)
	         line(npts+1-i) = tmp8
               ENDDO
            ENDIF

            GOTO 1000
         ENDIF

         misordered = .FALSE.
         micro_adj = 1E-7 *
     .		(line(npts) - line(1))

* ... are there repeated values?

	 CALL TM_CHECK_COORDS (line, npts, is_double, use_strict, 
     .                         has_repeated, misordered, micro_adj, 
     .                         epsilon, depsilon)

	 IF (misordered) GOTO 2000
         IF ( has_repeated .AND. .NOT.misordered ) THEN
            CALL TM_NOTE('Axis has repeated values -- micro-adjusting '//
     .           vname(:vlen), lunit_errors)
         ENDIF

* Check if axis is actually regularly spaced (though not flagged as "even")

        IF (its_irregular) GOTO 1000  ! If the file says its irreg, treat it at such

* See if double-precision coordinates are regularly-spaced
	epsilon = 0.
	depsilon = 0.

        IF (is_double) THEN
           dfirst_delta = line(2) - line(1)
           depsilon = depsilon_42 * 2.*(ABS(line(npts)) / first_delta )
           depsilon = depsilon_42 * 2.*(ABS(line(1)) / first_delta )

           DO i = 2, npts
              ddelta = line(i) - line(i-1)
              IF (.NOT. TM_DFPEQ_TOL(dfirst_delta, ddelta, depsilon) ) GOTO 1000
           ENDDO

* See if single-precision (or integer??) coordinates are regularly-spaced
	ELSE
           last_coord = line(npts)
           firs_coord = line(1)
           first_delta = line(2) - line(1)
           epsilon = epsilon_21 * 2.*(ABS(line(npts)) / first_delta )
           epsilon = epsilon_21 * 2.*(ABS(line(1)) / first_delta )

           DO  i = 3, npts
              delta = line(i) - line(i-1)
              IF (.NOT. TM_FPEQ_EPS(epsilon, first_delta, delta) ) GOTO 1000
           ENDDO
	ENDIF
	regular = .TRUE.
	RETURN

 1000	CONTINUE
        regular = .FALSE.

 2000	RETURN
	END

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	PPLADD_METAFILE_WRITES

*	Write private item data records to metafile
*	J Davison JISAO/PMEL/TMAP
*	10.26.89
*	Mod *JD* 4.22.91 Make all entry points into subroutines and
*	add support for new metafile translator
*       Mod *JD* 5.9.91 Work around GKD3D bug wrt private items
*	Above mod taken out when GKS3D bug is fixed late 91.
*	*jd* 2.25.92 Modify for ATC gks -- binary GKSM files require packed rec
*       *jd* 24.7.92 Mod to change back as before for DEC GKS -- doesn't work
*	*jd* 10.5.92 Mod to add info re: protect_used_colors for ATC.
*	*jd* 10.12.92 Mod to add fill area ndx for ATC who stupidly have but
*	    20 area bundles and consequently have a useless area bundle context

	SUBROUTINE META_CLEAR (control_flag)

#ifdef unix
        include         'gkscm2.cmn'
#else
        INCLUDE         'tmap_pplv11inc:tmap_gkscm2.inc'
#endif

#ifdef atc_gks
	integer		control_flag,ix(4)
	real 		x(4)
#else
       integer          control_flag
       character*8      kar_control_flag(1)
#endif 

***************************************************************************

C	Mod for linux *jd* 12.96 change kar_control_flag to array for 
C	consistency with WRITE_ITEM call to gwitm.

#ifdef atc_gks
	ix(1) = control_flag
	call write_item (ix,x,item_gclrwk)
#else
        write (unit=kar_control_flag(1),fmt='(i8)') control_flag
        call gwitm (meta_wsid,item_gclrwk,8,1,kar_control_flag)
#endif
	return
	end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	SUBROUTINE META_WS_XFORM (x_wn,y_wn,big_x_vp,big_y_vp)

#ifdef unix
        include         'gkscm2.cmn'
#else
        INCLUDE         'tmap_pplv11inc:tmap_gkscm2.inc'
#endif

        real            x_wn,y_wn,big_x_vp,big_y_vp,x_vp,y_vp

#ifdef atc_gks
	integer		ix(4)
	real 		x(4)
#else
        character*8     kar_x_wn,kar_y_wn,kar_x_vp,kar_y_vp
        character*32    kar_ws_xform(1)
#endif                                                                    

C	Mod for linux *jd* 12.96 change kar_ws_xform to array for 
C	consistency with WRITE_ITEM call to gwitm.

***************************************************************************

*	CONVERT VIEWPORT SIZE TO INCHES FROM MILLI-INCHES
	x_vp = big_x_vp/1000.0
	y_vp = big_y_vp/1000.0

#ifdef atc_gks
	x(1) = x_wn
	x(2) = y_wn
	x(3) = x_vp
	x(4) = y_vp

	call write_item (ix,x,item_ws_xform)
#else
        x_vp = big_x_vp/1000.0
        y_vp = big_y_vp/1000.0

        write (unit=kar_x_wn,fmt='(f8.4)') x_wn
        write (unit=kar_y_wn,fmt='(f8.4)') y_wn

        write (unit=kar_x_vp,fmt='(f8.4)') x_vp
        write (unit=kar_y_vp,fmt='(f8.4)') y_vp

        kar_ws_xform(1) = kar_x_wn//kar_y_wn//kar_x_vp//kar_y_vp
        call gwitm (meta_wsid,item_ws_xform,32,1,kar_ws_xform)
#endif

	return
	end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	SUBROUTINE META_SHADE_SET

#ifdef unix
        include         'gkscm2.cmn'
	include		'shade_vars.cmn'
        include         'gkscm1_inc.decl'
        include         'GKSCM1.INC'
#else
        INCLUDE         'tmap_pplv11inc:tmap_gkscm1.inc'
        INCLUDE         'tmap_pplv11inc:tmap_gkscm2.inc'
	INCLUDE		'tmap_pplv11inc:tmap_shade_vars.inc'
#endif

#ifdef atc_gks
        integer         i,ix(4)
	real		x(4)
#else
        integer         i
        character*8     kar_shd_levels,kar_ncl,kar_loco
        character*8     kar_ndx,kar_slvl,kar_sr,kar_sg,kar_sb
        character*24    kar_ndx_range(1)
        character*40    kar_spectrum(1)
#endif

C	Mod for linux *jd* 12.96 change kar_ndx_range, kar_spectrum to array 
C	for consistency with WRITE_ITEM call to gwitm.


***************************************************************************

*	WRITE # SHADE LEVELS & # COLOR LEVELS
#ifdef atc_gks
	ix(1) = shd_levels
	ix(2) = ncl
	ix(3) = lo_color_ndx(wsid)

	call write_item (ix,x,item_ndx_range)
#else
        write (unit=kar_shd_levels,fmt='(i8)') shd_levels
        write (unit=kar_ncl,fmt='(i8)') ncl
        write (unit=kar_loco,fmt='(i8)') lo_color_ndx(wsid)

        kar_ndx_range(1) = kar_shd_levels//kar_ncl//kar_loco
        call gwitm (meta_wsid,item_ndx_range,24,1,kar_ndx_range)
#endif

*	WRITE OUT COLOR REPRESENTATIONS
	do 10 i = 1,ncl
#ifdef atc_gks
	   ix(1) = i

	   x(1) = slvl(i)
	   x(2) = sr(i)
	   x(3) = sg(i)
	   x(4) = sb(i)

	   call write_item (ix,x,item_spectrum)
#else
           write (unit=kar_ndx,fmt='(i8)') i
           write (unit=kar_slvl,fmt='(f8.4)') slvl(i)
           write (unit=kar_sr,fmt='(f8.4)') sr(i)
           write (unit=kar_sg,fmt='(f8.4)') sg(i)
           write (unit=kar_sb,fmt='(f8.4)') sb(i)

           kar_spectrum(1) = kar_ndx//kar_slvl//kar_sr//kar_sg//kar_sb
           call gwitm (meta_wsid,item_spectrum,40,1,kar_spectrum)
#endif
10	continue

	return
	end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	SUBROUTINE META_PROTECT

#ifdef unix
        include         'gkscm2.cmn'
	include		'shade_vars.cmn'
#else
        INCLUDE         'tmap_pplv11inc:tmap_gkscm2.inc'
	INCLUDE		'tmap_pplv11inc:tmap_shade_vars.inc'
#endif

#ifdef atc_gks
        integer         ix(4)
	real		x(4)
#else
        integer         i
        character*8     kar_protect(1)
#endif

C	Mod for linux *jd* 12.96 change kar_protect to array for 
C	consistency with WRITE_ITEM call to gwitm.

***************************************************************************

*	WRITE OUT PROTECT_USED_COLORS INFO AS ATC DOESN'T USE FILL AREA
*	BUNDLES AND COLOR INDICES MUST BE PROPERLY RE-CREATED

#ifdef atc_gks
	if (protect_used_colors) then
	   ix(1) = 1
	else
	   ix(1) = 0
	endif

	call write_item (ix,x,item_protect)
#else
	if (protect_used_colors) then
	   i = 1
	else
	   i = 0
	endif

        write (unit=kar_protect(1),fmt='(i8)') i
        call gwitm (meta_wsid,item_protect,8,1,kar_protect)
#endif
	return
	end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	SUBROUTINE META_FILL_NDX (fill_ndx)

	integer		fill_ndx

#ifdef unix
        include         'gkscm2.cmn'
#else
        INCLUDE         'tmap_pplv11inc:tmap_gkscm2.inc'
#endif

#ifdef atc_gks
        integer         ix(4)
	real		x(4)

***************************************************************************

*	WRITE OUT FILL AREA INDEX CURRENTLY IN USE
	ix(1) = fill_ndx

	call write_item (ix,x,item_fill_ndx)
#endif
	return
	end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	SUBROUTINE META_VERSION

#ifdef unix
        include         'gkscm2.cmn'
#else
        INCLUDE         'tmap_pplv11inc:tmap_gkscm2.inc'
#endif

#ifdef unix
        include 	'pplp_ver_date.cmn'
#else
        INCLUDE 	'TMAP_PPLV11INC:PPLP_VER_DATE.CMN'
#endif

#ifdef atc_gks
	integer		ix(4)
	real 		x(4)
#else
       character*13     kar_rev(1)
#endif 

***************************************************************************

#ifdef atc_gks
	read (unit=pplp_ver,fmt='(1x,f4.2)') x(1)
	read (unit=pplp_make_date,fmt='(i2)') ix(1)
	read (unit=pplp_make_date,fmt='(3x,i2)') ix(2)
	read (unit=pplp_make_date,fmt='(6x,i2)') ix(3)

	call write_item (ix,x,item_pplpver)
#else
        kar_rev(1) = pplp_ver // pplp_make_date
        call gwitm (meta_wsid,item_pplpver,13,1,kar_rev)
#endif
	return
	end

C	Mod for linux *jd* 12.96 change kar_rev to array for 
C	consistency with WRITE_ITEM call to gwitm.

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	SUBROUTINE WRITE_ITEM (ix,x,item_type)

*	Converts data to packed record format and writes out item to metafile
*	J Davison 2.25.92

#ifdef unix
        include         'gkscm2.cmn'
#else
        INCLUDE         'tmap_pplv11inc:tmap_gkscm2.inc'
#endif

C	Moved variable initialization into data statement for linux *jd* 12.96

	integer		ix(4),item_type
	real 		x(4)

	integer		lstr(1),ierr,ldr
	character*4	str(1)
	character*80	datrec(10)

	data		lstr/4/,str/'str!'/


*******************************************************************************

	call gprec (4,ix,4,x,1,lstr,str,10,ierr,ldr,datrec)
	call gwitm (meta_wsid,item_type,80,ldr,datrec)

	return
	end

*  sample_fast_i.F
* 
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* Ansley Manke June 2013
* Sample variable using a set of indices.
*
*
*  In this subroutine we provide information about
*  the function.  The user configurable information 
*  consists of the following:
* 
*  descr              Text description of the function
* 
*  num_args           Required number of arguments
* 
*  axis_inheritance   Type of axis for the result
*                        ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                        CUSTOM          - user defined axis
*                        IMPLIED_BY_ARGS - same axis as the incoming argument
*                        NORMAL          - the result is normal to this axis
*                        ABSTRACT        - an axis which only has index values
* 
*  piecemeal_ok       For memory optimization:
*                        axes where calculation may be performed piecemeal
*                        ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE sample_fast_i_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id, 'Fast 1D sample variable using set of indices' )
      
* Tell Ferret to run the following instead, if the arguments are strings.
      CALL ef_set_alt_fcn_name(id, 'SAMPLE_FAST_I_STR')

      CALL ef_set_num_args(id, 2)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id, IMPLIED_BY_ARGS, NORMAL, 
     .                             NORMAL, NORMAL, NORMAL, NORMAL)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'V')
      CALL ef_set_arg_desc(id, arg, '1-D variable in X direction')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'Indices')
      CALL ef_set_arg_desc(id, arg, 'List of indices at which to sample ')
      CALL ef_set_axis_influence_6d(id, arg, YES, NO, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*  In this subroutine we compute the result
* 
      SUBROUTINE sample_fast_i_compute(id, arg_1, arg_2, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

* Function is intended only for variables in the x direction

      REAL arg_1(mem1lox:mem1hix)
      REAL arg_2(mem2lox:mem2hix)
      REAL result(memreslox:memreshix)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER	i, i2, isample

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      i2 = arg_lo_ss(X_AXIS,ARG2)
      DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
      
         result(i) = bad_flag_result
         IF (arg_2(i2) .NE. bad_flag(ARG2)) THEN
            isample = INT(arg_2(i2))
            result(i) = arg_1(isample)
	 ENDIF
	 i2 = i2 + arg_incr(X_AXIS,ARG2)
  100 CONTINUE

      RETURN

      RETURN
      END

	CHARACTER*(*) FUNCTION REGRID_COMMENTS ( cx, mlen )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* return text describing the regridding done

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V420:	 11/1/95 - based on VAR_TITLE_MOD code
* V450: 1/97 - corrected problem of missing blank when no units were defined
* V510: 4/00 *sh* - netCDF grids are now dynamic, so "(" as first character
*		    of name is basis for not using the associated variable
* V533: 6/01 *sh* - @XACT doesn't need a comment if for xact strides
* V552  4/03 *acm*  up gname_from_number to 128 characters (variable names)
* V671  6/11 *acm*  New 2D linear xy regridding, fixing ticket 1862
* V68  *acm* 1/12  changes for double-precision ferret.
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V690 *sh* 1/14 document sigma and curvilinear aux var regridding
* V693+ 11/14 *sh* renaming 'sigma' as 'layerz' throughout
* V698  1/16 *sh*  special formatting of T-F plane FMRC regridding comments
* V741  5/18 *acm* issue 1868: gridding transforms that will grid to same axis
* V741  6/18 *acm* For DSG-file listings, check that cx_regrid_trans was set 
*                  before using it

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include	'implicit.parm'
	include	'xdset_info.cmn_text'
	external xdset_info_data
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xunits.cmn_text'
	include	'ferret.parm'
	include	'xcontext.cmn'
	include	'xalgebra.cmn'
	include	'xtext_info.cmn'

* calling argument declarations
	INTEGER cx

* internal variable declarations
	LOGICAL REGRID_TO_SELF,
     .		add_on, stat_grid, non_atlin, lin_regrid, 
     .		did_regrid(nferdims)
	INTEGER	TM_LENSTR1, KNOWN_GRID,
     .		var, categ, dset, mlen, maxlen, idim, std_grid, n,
     .		axis, slen
	CHARACTER TM_FMT*48, GNAME_FROM_NUMBER*128, VAR_CODE*128,
     .		  ALG_TRANS_TITL*20, units*24, trans*8, mybuff*128,
     .		  sep*1, buff*128

* initialize
	IF ( .NOT. cx_unstand_grid(cx) ) THEN
	   buff = ' '
	   mybuff = ' '
	   RETURN
	ENDIF
	var     = cx_variable( cx )
	categ   = cx_category( cx )
	dset    = cx_data_set( cx )
	non_atlin = .FALSE.		! assume entirely @LIN transforms
	maxlen  = LEN( buff )
	IF ( maxlen .LT. 12 ) GOTO 5000
	stat_grid =  grid_name(cx_grid(cx))(1:1) .NE. '('

* starting blank unavoidable with FORTRAN strings -- removed later
	buff = ' '
	mybuff = ' '
	mlen = 1

* not appending to anything
	add_on = .FALSE.

* static (named) grids are documented by name
	IF ( stat_grid ) THEN
	   buff = GNAME_FROM_NUMBER(dset, cx_grid(cx), mlen)
	   mybuff = GNAME_FROM_NUMBER(dset, cx_grid(cx), mlen)
	   mlen = mlen + 1	! blank at end in case there's more
* ... only go on if there are transforms to report
	   DO 10 idim = 1, nferdims
	     IF (cx_regrid_trans(idim,cx) .NE. prgrd_linear_interp
     .	   .AND. cx_regrid_trans(idim,cx) .NE. prgrd_exact
     .	   .AND. cx_regrid_trans(idim,cx) .NE. prgrd_xy_lin) THEN
	       GOTO 50
	     ENDIF
 10	   CONTINUE
	   GOTO 900
	ENDIF

* count number of axes regridded and unusual transforms
 50	std_grid = KNOWN_GRID( dset, categ, var )
* ... ... trap for internal error -- should never happen
	IF ( std_grid .EQ. unspecified_int4 ) GOTO 5000
	n = 0
	DO 100 idim = 1, nferdims
	   axis = grid_line(idim,cx_grid(cx))
	   did_regrid(idim) = ( axis .NE. grid_line(idim,std_grid) ) .OR. 
     .        REGRID_TO_SELF (cx_regrid_trans(idim, cx) )
	   IF ( did_regrid(idim) ) THEN
	      n = n + 1
	      lin_regrid = ( (cx_regrid_trans(idim,cx).EQ.prgrd_linear_interp) .OR. 
     .             (cx_regrid_trans(idim,cx).EQ.prgrd_xy_lin) )
	      non_atlin = non_atlin
     .	      .OR. ( .NOT. lin_regrid 
     .		.AND. .NOT.( cx_regrid_trans(idim,cx) .EQ. prgrd_xact_pts
     .	               .AND. line_class(axis) .EQ. pline_class_stride ) )
	   ENDIF
 100	CONTINUE

* generate a string like "2 deg on X@AVE" or "Y" or "T@NGD" (for 1 axis)
*  or "Y@AVE X 5 m on Z"  or   "2 deg on X@AVE X 5 deg on Y@AVE"
	DO 120 idim = 1, nferdims
	   axis = grid_line(idim,cx_grid(cx))
 	   IF (axis .NE. grid_line(idim,std_grid) .OR. did_regrid(idim)) THEN
* ... lead-in string
	      IF (add_on) THEN
	         buff = buff(:mlen)//', '
	         mybuff = mybuff(:mlen)//', '
	         mlen = MIN( maxlen, mlen+2 )
	      ELSE
	         add_on = .TRUE.
	      ENDIF

	      IF (cx_regrid_trans(idim,cx) .EQ. pauxrgrd_fmrc ) THEN
* ... comment about T-F axis reorganization for FMRC data sets:
*          "time series view using 2d TIME2D field"
	         IF (idim .EQ. t_dim) THEN
     	            buff = buff(:mlen) //
     .                  'time series view'
	            mlen = mlen + 16
	         ELSEIF (idim.EQ. f_dim) THEN
     	            buff = buff(:mlen) //
     .                  'forecast visualization view'
	            mlen = mlen + 27
	         ENDIF
	      ELSE

	         IF ( line_regular(axis) .AND. .NOT.stat_grid 
     .	    .   AND.  line_dim    (axis) .GT.  1               ) THEN
* ... delta
                    trans = TM_FMT(line_delta(axis),4,8,slen)
	            buff = buff(:mlen)//trans(1:slen)
	            mybuff = mybuff(:mlen)//trans(1:slen)
	            mlen = MIN( maxlen, mlen+slen )
* ... units
	            IF ( line_units(axis) .EQ. ' ' ) THEN
	               units = 'delta'
	            ELSE
	               IF ( line_unit_code(axis) .EQ. 0 ) THEN
	                  units = line_units(axis)
	               ELSE
	                  units = un_name(line_unit_code(axis))
	               ENDIF
	            ENDIF
	            slen = TM_LENSTR1(units)
	            buff = buff(:mlen) //
     .				   ' '// units(:slen)//' '
	            mybuff = mybuff(:mlen) //
     .				   ' '// units(:slen)//' '
	            mlen = MIN( maxlen, mlen+slen+2 )
	         ENDIF
* ... axis
	         buff = buff(:mlen) // 'on '
     .					//ww_dim_name(idim)
	         mybuff = mybuff(:mlen) // 'on '
     .					//ww_dim_name(idim)
	         mlen = MIN( maxlen, mlen+4 )
* ... @transform
	         IF (non_atlin .AND. cx_regrid_trans(idim,cx).NE.unspecified_int4 ) THEN
	            trans = alg_regrid_code(cx_regrid_trans(idim,cx))
	            IF ( trans(:4) .NE. unspecified_name4 ) THEN
	              buff = buff(:mlen)//'@'//trans
	              mybuff = mybuff(:mlen)//'@'//trans
	              mlen = MIN(maxlen,mlen+1+TM_LENSTR1(trans) )
	            ENDIF
	         ENDIF
	      ENDIF
	   ENDIF
 120	CONTINUE

* layerz and curvilinear regridding
* if an auxiliary variable regrid then document "using DEPTH" or whatever
 900	IF (cx_naux(cx) .GT. 0) THEN
	   mybuff = ' using'
	   slen = 6
	   sep = ' '
	   DO idim = 1, nferdims
	      IF (cx_regrid_trans(idim,cx) .EQ. pauxrgrd_fmrc ) THEN
	         IF (idim .EQ. f_dim ) CYCLE
	         mybuff = mybuff(:slen) // ' 2d'
	         slen = slen + 3
	      ENDIF
	      IF (cx_aux_cat(idim,cx) .NE. unspecified_int4) THEN
	         mybuff = mybuff(:slen) // sep //
     .			  VAR_CODE(cx_aux_cat(idim,cx),
     .				   cx_aux_var(idim,cx)  )
	         slen = TM_LENSTR1(mybuff)
	         sep = ','
	      ENDIF
	   ENDDO
	   buff = buff(:mlen)//mybuff
	   mlen = MIN(maxlen,mlen+slen)
	   buff = buff(:mlen)//' field'
	   mlen = MIN(maxlen,mlen+6)
	   IF (cx_naux(cx) .GT. 1) THEN
	      buff = buff(:mlen)//'s'
	      mlen = MIN(maxlen,mlen+1)
	   ENDIF
	ENDIF

* signal if the string has been truncated for being too long
	IF ( mlen .EQ. maxlen ) buff(maxlen:maxlen) = '*'
	IF ( mlen .EQ. maxlen ) mybuff(maxlen:maxlen) = '*'

* remove silly blanks from the start and end
	IF ( buff(mlen:mlen) .EQ. ' ' ) mlen = mlen - 1
	IF ( buff(1:1) .EQ. ' ' ) THEN
           buff = buff(2:)
           mlen = mlen - 1
        ENDIF

* successful completion
	REGRID_COMMENTS = buff
	RETURN

* error exit
 5000	CALL WARN( 'Regrid coruptn!!!' )
	REGRID_COMMENTS = 'regridded ???'
	RETURN

	END

	SUBROUTINE MOUSE_COMMAND

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* get next command line from the GUI input source
* if it is a coded query respond instantly

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V300:  6/16/93
* V301:  1/94 - bug:  incorrect call to DO_QUERY in error return
* V314: 8/19/94 *kob* IBM port - Modified format statements, added 
*				 ifdef MANDATORY_FORMAT_WIDTHS for I format
*			         descriptor 
* 2/03 *kob* - g77 port - g77 won't allow intrinsic functions in PARAMETER
*                         statements.  use an octal constant instead
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

	include 'tmap_dims.parm'
	include 'errmsg.parm'
	include 'ferret.parm'
	include 'command.parm'
	include 'xprog_state.cmn'
	include 'xinterrupt.cmn'
	include 'xgui.cmn'

* calling argument declarations: (none)

* internal variable declarations:
	LOGICAL previous_eof, reverify, looking_for_end
	INTEGER	TM_LENSTR, TM_LENSTR1,
     .		status, iqual, ilist, cmnd_len, query, i

        CHARACTER*1 backslash
#ifdef NO_INTRINSIC_IN_PARAMETER
        PARAMETER ( backslash = o'134' )
#else
        PARAMETER ( backslash = CHAR(92) )
#endif


* read from standard input without prompt
 10	READ ( ttin_lun, '(A)' ) cmnd_buff

* Check for for QUERY commands beginning with "gui_char"
* These commands are handled by this routine without returning to FERRET
	IF ( cmnd_buff(1:1) .EQ. gui_char ) THEN
	   IF ( cmnd_buff(2:2) .EQ. '>' ) THEN
* ">" is a "CONTINUE" signal from GUI  (not used by GUI ??)
	      cmnd_buff = ' '
	      RETURN
	   ELSE
* parse the query: format of command is blank-only separated:
*	"^nn tag arg2 arg3" 
*      (argument numbering to match "QUERY ARG1 arg2 arg3 ...")
* the "tag" field is not a standard part of the QUERY command
* it is a special field which is simply echoed by FERRET to help the 
* GUI keep track of replies
#ifdef MANDATORY_FORMAT_WIDTHS
* no fixed field width works but "*" may cause problems too
* such as "Y" being an unacceptable integer
	      READ ( cmnd_buff(2:3), *, ERR=5000 ) query
#else
	      READ ( cmnd_buff(2:3), '(I)', ERR=5000 ) query
#endif
	      len_cmnd = TM_LENSTR1( cmnd_buff )
	      num_args = 0
	      looking_for_end = .TRUE.
	      DO 100 i = 2, len_cmnd
* find end of this argument (starting with pseudo-argument 0 which is "^nn")
	         IF ( looking_for_end ) THEN
		   IF ( cmnd_buff(i:i) .EQ. " " ) THEN
* ... record end of arg
	              IF ( num_args .GE. 1 ) arg_end(num_args) = i-1
	              looking_for_end = .FALSE.
	           ENDIF
	         ELSE
* find start of arg
	            IF ( cmnd_buff(i:i) .NE. " " ) THEN
* ... record start of next arg
	               num_args = num_args + 1
	               arg_start(num_args) = i
	               looking_for_end = .TRUE.
	            ENDIF
	         ENDIF
 100	      CONTINUE
	      IF ( num_args .GE. 1 ) arg_end(num_args) = len_cmnd

* answer query and request next command from GUI without ever bothering FERRET
	      CALL DO_QUERY( err_lun, gui_fmt1, query,
     .	                     cmnd_buff(arg_start(1):arg_end(1)), status )
	      GOTO 10
	   ENDIF
	ELSE

* normal command - pass it along to FERRET
	   RETURN
	ENDIF

* synax error in GUI query - give a no-content response
 5000	CALL DO_QUERY( err_lun, gui_fmt1, 9999, '*', status )
	GOTO 10
	END

	SUBROUTINE FIND_MEM_VAR( cx, mr, by_value, valid_search )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* look in the list of variables in memory to see if the requested one is there
* search may be done based on subscript or on world coordinate values.

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/31/86
* revision 0.1 - 2/25/87 - bumps priority when variable is found
* revision 1.0 - 3/23/87 - eliminated references to mvar_norm in prep. for 0,1
*			   dimensional structures.  Added contiguousity test.
*			   Syntax changes to enhance performance.
*			   Diagnostic output.
* revision 1.1 - 5/28/87 - added "STUPID" mode
* revision 1.2 - 8/19/87 - added check on cx_trans_arg
* revision 1.3 - 9/10/87 - corrected check on cx_trans_arg
* revision 1.4 - 3/5/88  - added extraction of lower dimensioned objects
* revision 2.0 - 7/21/88 - search only through the hash pile of the context
* revision 2.1 - 10/7/88 - don't use ctxt_norm to determine if exact limits
*			   check is necessary - test to see if the context
*			   truely requires a normal location
* revision 2.1 -10/12/88 - pass bad data flag on extracted variables
* revision 2.2 - 1/4/89  - check regridding transforms
* V200:  5/18/89 - 4D symmetrical - no "extracts", no priority "bumping"
*		 - ignore "given" axes in user defined variables
* V230:  1/27/92 - special checks for transformations RSUM and WEQ
*                  and for uvlim_need_lohi used by @WEQ
*        8/18/92 - @iin matches incorrectly on top limits that aren't full box
*                  e.g. TEMP[Z=0:1000@iin] is found looking for TEMP[Z=0:0@iin]
* V420:  11/95	- speed up by bypassing NORMAL axes
*	 	- for modulo axes uvar_given "given" is not a sufficient test
*				to bypass checks
* V500: 12/98 *sh* - added support for cat_const_var ("{1,3,5}") (uncached)
*        1/99 *sh* - added support for cat_string (uncached)
*	 4/99 *sh* - check mode_arg for mode_stupid
* V510: 12/99 *sh* - modulo axis to not prevent uvlin_gvn_xact hit
* V533: 6/01 *sh* - added @EVNT - check as in trans_run_sum
*	          - check that the data type matches
*		  - check that the delta value matches
* 2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V685 4/13-3/14 *sh* support for auxiliary variables used in regridding
* V692 7/14 *acm* ticket 2183: handle @WGT transform as for integrals
* V695+ 5/15 *sh* added valid_search argument, to support c cache hits
* V701:  7/16 *acm* Ticket 2452. Instances where the cx_*ww and mr*ww values 
*	          should be exactly the same but the cx coordinates are ever 
*	          so slightly too wide to match the request. Use TM_DFPEQ
*	          to test for approx. equal values before rejecting the match  
*	          with what is in memory.
* V720: 4/17 *sh* special behaviors finding DSG variables 
* V74+  5/18 *acm* issue 1868: gridding transforms that will grid to same axis

* (V510) How on cache hits on external functions (EFs) work:
* uvar_given is used to encapsulate information about cache reuse for EF
* results. This ensures that the information is inherited by variables that use
* variables that use EFs. The resultant grid of an EF gets its axes from its
* arguments and from impositions where the EF asserts that the result will have
* a normal, abstract, or custom-imposed axis. These determine the value
* of uvar_given as follows. If the result axis is:
*	set to normal	-> uvlim_irrelevant (no match needed)
*	set to ABSTRACT	-> uvlim_hidden (no match needed)
*	set to custom   -> uvlim_hidden (no match needed)
*	inherited	(exact match required)
*	  with limits given in the arg definitions -> uvlim_gvn_xact
*	  with limits missing from the arg definitions -> uvlim_needed_xact
* Requiring an exact match means that the cached field will be reused only
* when the lo:hi limits of the requested context exactly match the lo:hi
* limits for this axis of the cached field. The reason that an exact match
* is required is because, in general, the function may utilize information
* from any part of the incoming data to effect all of the result. (For example
* a function that multipled one argument by the maximum value along the axis
* of another.) 
* Some of the internal grid-changing functions (e.g. RESHAPE) require
* slightly different rules for setting uvar_given -- see gcf_impose_axes.F
*

        IMPLICIT NONE
        include 'tmap_dims.parm'
#include "tmap_dset.parm"
        include 'implicit.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xdset_info.cmn_text'     ! dsg_loaded_lm
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xprog_state.cmn'

* calling argument declarations:
	INTEGER cx, mr
	LOGICAL by_value, valid_search

* internal variable declarations:
	LOGICAL TM_DFPEQ, TM_ITSA_DSG, REGRID_TO_SELF,
     .          has_trans, itsa_uvar, itsa_dsg,
     .          normal(nferdims), non_modulo(nferdims), 
     .          self(nferdims), transformed
	INTEGER HASH_CX, line, lm, status,
     .		mv, defining_grid, idim, var, cat, dset, mline
        REAL*8  TM_WORLD, ww_hi_bound, c_cache_ptr

* initialize
	valid_search = .TRUE.

* in "STUPID" mode the program cannot find anything in memory
*  (4/99) if mode_arg is 1 we are are using "weak_cache", so do not skip out
	IF (mode_stupid .AND. mode_arg(pmode_stupid,1).NE.1) GOTO 5000

* if the context carries a paux_stat_needed requirement, then a cache hit should
* not be made, because there is an auxiliary variable to be loaded as well
	DO idim = 1, nferdims
	   IF (cx_aux_stat(idim, cx) .EQ. paux_stat_needed) GOTO 5000
	ENDDO

* initialize
	defining_grid = cx_grid( cx )
	var	      = cx_variable(cx)
	cat	      = cx_category(cx)
	dset	      = cx_data_set(cx)

* is there a completed context to look for ?
	IF ( defining_grid   .EQ. unspecified_int4
     .	.OR. dset	     .EQ. unspecified_int4
     .	.OR. var             .EQ. unspecified_int4 ) GOTO 5000

* cat_const_vars are never cached (see IS_CONST_VAR)
* ditto for cat_string (as-of 1/99)
	IF ( cat .EQ. cat_const_var
     .  .OR. cat .EQ. cat_string   ) GOTO 5000

* are we looking for  user defined variable ?
	itsa_uvar = cat .EQ. cat_user_var

* are we hunting for a DSG variable?
	itsa_dsg = TM_ITSA_DSG(defining_grid)

* check for untransformed DSG coordinate variable or rowSize
* they are already cached in line memory
	IF (itsa_dsg .AND. cat.EQ.cat_file_var ) THEN
	   transformed = cx_unstand_grid(cx)
	   IF (.NOT.transformed) THEN
	      DO idim = 1, nferdims
	         IF (cx_trans(idim, cx) .NE. trans_no_transform) THEN
	            transformed = .TRUE.
	            EXIT
	         ENDIF
	      ENDDO
	   ENDIF
	   lm = dsg_loaded_lm(var)
	   IF (.NOT.transformed .AND. lm.NE.int4_init) THEN
* ... create and return an mr table entry pointing to the dsg_linemem
	      CALL CREATE_LM_TABLE_ONLY_MEM_VAR( cx, lm, mr, status )
              IF (status .EQ. ferr_ok) GOTO 1000
* ... in rare chance of error status, the cache hit failed
	   ENDIF
	ENDIF

* do we need special checks for transforms ?
	has_trans = .FALSE.
	DO idim = 1, nferdims
	   has_trans = has_trans
     .        .OR. (cx_trans(idim,cx).NE.trans_no_transform)
	ENDDO

* flag the normal axes so we can bypass checks on them quickly
* DSG grids don't have ordinary modulo-ing, don't handle regions as modulo here

	DO 210 idim = 1, nferdims
	   line = grid_line(idim,defining_grid)
	   IF (line .EQ. mnormal) THEN
	      IF (itsa_dsg .AND. idim.NE.f_dim) THEN
* ... DSG constraints are relevant on some mnormal grid axes
*     e.g. time series features can be subsetted based upon X,Y position
! huh?  how can this compile?
	         normal(idim) = cx_lo_ww(idim,cx) .EQ. unspecified_val8
	      ELSE
	         normal(idim) = .TRUE.
	      ENDIF
	   ELSE 
	      normal(idim) = .FALSE.
	      non_modulo(idim) = .NOT.line_modulo(line)
	   ENDIF
	   IF (itsa_dsg) non_modulo(idim) = .FALSE.
 210	CONTINUE

* determine memory hash pile to search
	mv = HASH_CX( cx )

* locate next table slot in linked list
 100	mv = mv_flink( mv )
	IF ( mv .LE. 0 ) THEN
	   mr = mr_nonexist
	   RETURN     ! not found in normal Ferret cache
	ENDIF

* right variable ?
	IF ( mr_variable ( mv ) .NE. var
     .	.OR. mr_category ( mv ) .NE. cat
     .	.OR. mr_data_set ( mv ) .NE. dset
     .	.OR. mr_grid ( mv ) .NE. defining_grid       ) GOTO 100

* check variable type
	IF ( mr_type(mv) .NE. cx_type(cx) ) GOTO 100

* DSGTBD: the F axis of a DSG can be treated as a gridded axis: superset ok

* flag for transforms that allow regrid-to-same axis

 	DO idim = 1, nferdims
	   line = grid_line(idim,defining_grid)
	   mline = grid_line(idim,mr_grid(mv))
	   self(idim) = line .EQ. mline .AND. 
     .       REGRID_TO_SELF (mr_regrid_trans(idim, mv) )
           IF (self(idim)) GOTO 100
	ENDDO

* right instance (coordinate ranges and transformations) ?

	IF ( itsa_uvar ) THEN

* * * * * LOOK FOR A USER-DEFINED VARIABLE BASED ON COORDINATE VALUES  * * * * 
	   DO 40 idim = 1,nferdims

	      IF ( normal(idim) ) GOTO 40

* transformation correct ?
	      IF ( mr_trans(idim,mv) .NE. cx_trans(idim,cx) ) GOTO 100

* limits specified in uvar expression ? -->  no match necessary
* 11/95 - since modulo is not stripped until after FIND_MEM_VAR is called
*	  we cannot bypass this on modulo axes.
*		e.g. x1 has I=1:10; let xgap=x1[i=3:7]
*		then list xgap[i=1:15] should not "find" the i=3:7 result
* 12/99 - if uvlim_gvn_xact then modulo is never stripped in INTERP_STACK
*	(note: when is it ever stripped for uvlim_gvn_*?. This logic looks
*		out of date. Maybe the non_modulo restriction can be lifted)

	      IF ( (uvar_given(idim,var) .EQ. uvlim_gvn_xact) .OR.
     .		   ( (uvar_given(idim,var) .LT. uvlim_gvn_xact) .AND.
     .		      non_modulo(idim) )  ) GOTO 40

* insist that the  grid stored in memory encompasses the requested data
	      IF (mr_lo_ww(idim, mv) .GT. cx_lo_ww(idim, cx)) THEN
                 IF ( .NOT. TM_DFPEQ(cx_lo_ww(idim,cx),mr_lo_ww(idim,mv)) ) GOTO 100
	      ENDIF
	      IF (mr_hi_ww(idim, mv) .LT. cx_hi_ww(idim, cx)) THEN
                 IF ( .NOT. TM_DFPEQ(cx_hi_ww(idim,cx),mr_hi_ww(idim,mv)) ) GOTO 100
	      ENDIF

* insist that the delta values match
	      IF ( mr_delta(idim,mv) .NE. cx_delta(idim,cx) ) THEN
                 IF ( .NOT. TM_DFPEQ(mr_delta(idim,mv),cx_delta(idim,cx)) )  GOTO 100
	      ENDIF

 40	   CONTINUE

* right instance (coordinate ranges and transformations) ?
	ELSEIF ( by_value ) THEN

* * * * * * LOOK FOR A VARIABLE BASED ON COORDINATE VALUES * * * * * * * * 
	   DO 50 idim = 1,nferdims

	      IF ( normal(idim) ) GOTO 50

* transformation correct ?
	      IF ( mr_trans(idim,mv) .NE. cx_trans(idim,cx) ) GOTO 100

* If it's a DSG grid, then a change to the context in any direction  
* requires redoing the computation -- the context applies to the list
* of features/ obs.

	      IF (itsa_dsg) THEN 
                 IF ( .NOT. TM_DFPEQ(cx_lo_ww(idim,cx),mr_lo_ww(idim,mv)) ) GOTO 100
                 IF ( .NOT. TM_DFPEQ(cx_hi_ww(idim,cx),mr_hi_ww(idim,mv)) ) GOTO 100
	      ENDIF

* insist that the  grid stored in memory encompasses the requested data

	      IF (mr_lo_ww(idim, mv) .GT. cx_lo_ww(idim, cx)) THEN
                 IF ( .NOT. TM_DFPEQ(cx_lo_ww(idim,cx),mr_lo_ww(idim,mv)) ) GOTO 100
	      ENDIF
	      IF (mr_hi_ww(idim, mv) .LT. cx_hi_ww(idim, cx)) THEN
                 IF ( .NOT. TM_DFPEQ(cx_hi_ww(idim,cx),mr_hi_ww(idim,mv)) ) GOTO 100
	      ENDIF

* insist that the delta values match
	      IF ( mr_delta(idim,mv) .NE. cx_delta(idim,cx) ) THEN
                 IF ( .NOT. TM_DFPEQ(mr_delta(idim,mv),cx_delta(idim,cx)) ) GOTO 100
	      ENDIF

 50	   CONTINUE

	ELSE		! by subscript

* * * * * * LOOK FOR A VARIABLE BASED ON SUBSCRIPT VALUES * * * * * * * * *
	   DO 60 idim = 1,nferdims

	      IF ( normal(idim) ) GOTO 60

* transformation correct ?
	      IF ( mr_trans(idim,mv) .NE. trans_no_transform ) GOTO 100
	      IF ( cx_trans(idim,cx) .NE. trans_no_transform ) 
     .		 STOP 'find_by_ss_trans'	! temp diagnostic

* insist that the  grid stored in memory encompasses the requested data
* ... this is an adequate test because the grids looked for by subscript are
* ... always untransformed --> normal axes always have a span on 1 point
	      IF ( mr_lo_ss(mv, idim) .GT. cx_lo_ss(cx, idim)
     .	      .OR. mr_hi_ss(mv, idim) .LT. cx_hi_ss(cx, idim)) GOTO 100

* insist that the delta values match
	      IF ( mr_delta(idim,mv) .NE. cx_delta(idim,cx) ) THEN
	         IF ( .NOT. TM_DFPEQ(mr_delta(idim,mv),cx_delta(idim,cx)) ) GOTO 100
	      ENDIF

 60	   CONTINUE
	ENDIF

* make sure it is completed
	IF ( mr_protected( mv ) .EQ. mr_in_progress ) GOTO 100

* special tests left for last to keep the main loop simple and fast
* ... special limit requirements for indefinite integrals:
*     to satisfy the search an indefinite integral must have exactly the same
*     lower limit and must have upper limit either identical or the grid
*     we are looking for must have upper endpoint on a grid box boundary
*     ( to avoid errors of partial grid boxes )
* fixed logic bug: 8/92 using ww_hi_bound
** was:            IF ( mr_hi_ww(idim,mv).NE.cx_hi_ww(idim,cx)
**     .          .AND. mr_hi_ss(mv,idim).EQ.cx_hi_ss(cx,idim) ) GOTO 100
*
	IF ( has_trans ) THEN
	   DO 70 idim = 1, nferdims
	      IF ( normal(idim) ) GOTO 70
	      IF ( cx_trans( idim, cx ) .EQ. trans_integ_indef .OR. 
     .             cx_trans( idim, cx ) .EQ. trans_avg_wgt .OR. 
     .             cx_trans( idim, cx ) .EQ. trans_4d_avg_wgt) THEN
	         IF ( mr_lo_ww(idim,mv).NE.cx_lo_ww(idim,cx) ) GOTO 100
                 IF ( mr_hi_ww(idim,mv).NE.cx_hi_ww(idim,cx) ) THEN
                    ww_hi_bound = TM_WORLD( cx_hi_ss(cx,idim),
     .                         defining_grid, idim, box_hi_lim ) 
                    IF ( ww_hi_bound .NE. cx_hi_ww(idim,cx)) GOTO 100
                 ENDIF
	      ENDIF
 70	   CONTINUE
	ENDIF

	IF ( has_trans ) THEN
	   DO 80 idim = 1, nferdims
	      IF ( normal(idim) ) GOTO 80
* ... argument of transform must be right
* ... and transforms that compress to a point must have exact limits
	      IF ( cx_trans_arg(idim,cx).NE.mr_trans_arg(idim,mv) ) GOTO 100
	      IF ( cx_trans(idim,cx) .GT. trans_compress_code ) THEN
	         IF ( mr_lo_ww(idim,mv).NE.cx_lo_ww(idim,cx) ) GOTO 100
	         IF ( mr_hi_ww(idim,mv).NE.cx_hi_ww(idim,cx) ) GOTO 100
	      ENDIF
* ... @RSUM must match lower subscript exactly (1/92)
* ... @EVNT ditto (6/01)
	      IF ( cx_trans( idim, cx ) .EQ. trans_run_sum
     .        .OR. cx_trans( idim, cx ) .EQ. trans_event_mask ) THEN
                 IF ( mr_lo_ss(mv,idim).NE.cx_lo_ss(cx,idim) ) GOTO 100
              ENDIF
* ... @WEQ must match both hi and lo subscripts (1/92)
	      IF ( cx_trans( idim, cx ) .EQ. trans_wgted_eq ) THEN
                 IF ( mr_lo_ss(mv,idim).NE.cx_lo_ss(cx,idim)
     .           .OR. mr_hi_ss(mv,idim).NE.cx_hi_ss(cx,idim) ) GOTO 100
              ENDIF

 80	   CONTINUE
	ENDIF

* ... if regridded then regridding transforms must be right
	IF ( cx_unstand_grid( cx ) ) THEN
	   DO idim = 1, nferdims
	      IF ( normal(idim) ) CYCLE
	      IF ( self(idim) ) CYCLE
	      IF ( cx_regrid_trans( idim, cx ) .NE.
     .		   mr_regrid_trans( idim, mv   ) ) GOTO 100
	   ENDDO

* ... check for auxiliary regridding match
	   IF ( mr_naux( mv ) .NE. cx_naux( cx ) ) GOTO 100
	   IF ( cx_naux( cx ) .GT. 0 ) THEN
	      DO 91 idim = 1, nferdims
	         IF ( cx_aux_var(idim,cx) .NE. mr_aux_var(idim, mv)
     .	        .OR.  cx_aux_cat(idim,cx) .NE. mr_aux_cat(idim, mv) )
     .								GOTO 100 
 91	      CONTINUE
	   ENDIF
	ENDIF

* ... if user-defined then watch out for special limit match requirements
	IF ( itsa_uvar ) THEN
	   DO 92 idim = 1, nferdims
	      IF ( normal(idim) ) GOTO 92
	      IF ( uvar_given(idim,var) .EQ. uvlim_need_xact
     .        .OR. uvar_given(idim,var) .EQ. uvlim_need_lohi ) THEN
	         IF ( mr_lo_ww(idim,mv) .NE. cx_lo_ww(idim,cx)
     .           .OR. mr_hi_ww(idim,mv) .NE. cx_hi_ww(idim,cx)) GOTO 100
	      ELSEIF ( uvar_given(idim,var) .EQ. uvlim_need_lo ) THEN
	         IF ( mr_lo_ww(idim,mv) .NE. cx_lo_ww(idim,cx)
     .           .OR. mr_hi_ww(idim,mv) .LT. cx_hi_ww(idim,cx)) GOTO 100
	      ENDIF
 92	   CONTINUE
	ENDIF

* WE FOUND IT !
	mr = mv

* ... diagnostic message ?
 1000	IF (mode_diagnostic) CALL DIAGNOSTIC_OUT('found  ',mr,point_to_mr)

* ... send back pointer
	RETURN

* failure exit
 5000	mr = mr_nonexist
	valid_search = .FALSE.
	RETURN
	END

        PROGRAM DRWSYM
        CHARACTER FONT(20:30)*2,NUM*6,STR*5,NAME(20:30)*30,NME*30
	DIMENSION ILEN(20:30)
	DATA ILEN/26,69,15,12,42,43,78,19,39,32,27/
C	DATA ILEN/27,32,39,19,78,43,42,12,15,69,26/
	DATA FONT/'CA','IM','IZ','LM','MP','SM','MA',
     *	'WE','EL','MU','ZO'/
C        DATA FONT/'ZO','MU','EL','WE','MA','SM','MP',
C     *  'LM','IZ','IM','CA'/
	DATA NAME/'Cartographic','Indexical Math','Indexical Zodiac',
     *	'Large Math','Map','Simplex Math','Math','Weather','Electrical',
     *	'Music','Zodiac'/
c        DATA NAME/'Zodiac','Music','Electrical','Weather',
c     *	'Math','Simplex Math','Map','Large Math','Indexical Zodiac',
c     *	'Indexical Math','Cartographic'/
        OPEN(5,FILE='TI:',STATUS='UNKNOWN')
        CALL PLTYPE(0)
        CALL SIZE(10.5,8.2)
        SZE=0.21
        DO 100 IFNT=20,30
        CALL ERASE
C
C       DRAW BOX
C
        X=6.50
        Y1=9.00
        Y2=0.25
        DO 110 I=1,9
        CALL PLOT(Y1,X,0,0)
        CALL PLOT(Y2,X,1,0)
        X=X-0.875
        IF(Y1.EQ.0.25)THEN
                Y2=Y1
                Y1=9.00
        ELSE
                Y2=Y1
                Y1=0.25
        ENDIF
110     CONTINUE
        Y=9.00
        X1=6.50
        X2=-0.50
        DO 120 I=1,11
        CALL PLOT(Y,X1,0,0)
        CALL PLOT(Y,X2,1,0)
        Y=Y-0.875
        IF(X1.EQ.-0.50)THEN
                X2=X1
                X1=6.50
        ELSE
                X2=X1
                X1=-0.50
        ENDIF
120     CONTINUE
C
C       DRAW CHARACTERS
C
        WRITE(STR,999)FONT(IFNT)
999     FORMAT('@',A2)
        WRITE(NME,997)NAME(IFNT)
997     FORMAT('@SR',A25)
        CALL SYMBEL(9.10,6.50,-90.0,.14,28,NME)
	ICH=1
        DO 130 I=1,8
        DO 130 J=1,10
        X=6.50-(I-1)*0.875
        Y=9.00-J*0.875
        WRITE(NUM,998)ICH
998     FORMAT('@SR',I2.2)
        STR(4:5)=NUM(4:5)
        CALL SYMBEL(Y+0.775,X-0.02,-90.,0.07,6,NUM)
        S=X-0.4375+SYMWID(SZE,5,STR)*0.5
        CALL SYMBEL(Y+0.3325,S,-90.,SZE,5,STR)
	ICH=ICH+1
	IF(ICH.GT.ILEN(IFNT))GOTO 140
130     CONTINUE
140     CALL PLTEND
100     CONTINUE
        CALL EXIT
        END

	SUBROUTINE SHADE (z, cells)


*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Modified of PLOTZ to get data into proper grids for 
*	SHADE command

*	J Davison 8.26.88
*
*	Mod JD 4.18.90 to allow data all of the same value to be shaded. 
*       MOD *JD* To permit use of centered levels and specify the delta Z
*       value as well.  Added variables to CONT.INC common 8.3.95  
*	   *jd 8.28 fix bug in dz specification
*	*jd* 2.96 Change centered option so that data not spanning zero
*			is centered as well.
*	*jd* 5.96 Fix bug where if shade/lev=N option is used with constant 
*	field, no shade results
*       *jd* 1.98 Fix bug: shade misses top level, when top level is lt 0.
* V510 4/00 *sh - corrected faulty logic for centered levels (delta wrong)
* V550 11/02*acm* To use cellarray calls for rectangular shade plots, pass 
*                 cells in as a work array.  Remove VAX includes
* V550 12/02*acm* After levels are set, call setlab_syms to create the LEVELS symbols
* V552  3/03*acm* Check for too many levels, as is done for FILL and CONTOUR plots.
* v552  6/03*acm* Rename the array used for cellarray call.
* v554  3/04*acm* In the section marked correction for rounding errors, under g77 
*                 on linux this incorrectly uses low-order bits to reset NLEV2
* v570  4/04*acm* The fix above went too far.  Use TM_FPEQ to see if
*                 values are equal or close.  Also fixes this adjustment
*                 when the range has negative values; was always incorrect.
* v580  8/04*acm* Fix bug 957 shade/lev=1 of a constant field needs zlev(1) to be set.
* v581  4/05*acm* For cellarray plots JTYPE had erroneously been set to 1 (?!)
* v581 *acm* 3/05 open levels (-INF) (INF)
* v611 *acm* 4/08 Fix bug 1567: Set jj as in PLOTZ so SHADE/LINE gets labels with 
*                 enough precision
* v68  *acm* 4/08 Allow shade, vector plots of degenerate regions - world region 
*              within a grid cell
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus


	include		'parampl5_dat.decl'
	include		'PARAMPL5.DAT'

	include		'axis_inc.decl'
	include		'AXIS.INC'
	include		'plt_inc.decl'
	include		'PLT.INC'
	include		'miss_inc.decl'
	include		'MISS.INC'
	include		'hd_inc.decl'
	include		'HD.INC'
	include		'cont_inc.decl'
	include		'CONT.INC'
	include		'zgrid_inc.decl'
	include		'ZGRID.INC'
	include		'zgridd_inc.decl'
	include		'ZGRIDD.INC'
        include         'errmsg.parm'
        include         'shade_vars.cmn'

	real		dx,dy,dz,z(nx,ny),znp,zmp

	integer		status, i, j, cells(*), slen1, slen2
        CHARACTER       TM_FMT_SNGL*20, buff1*20, buff2*20, err_msg*40
        parameter       (epsilon = 1e-6)

C       Add external stmt for linux port *jd* 12.96 RANGE is intrinsic fcn
        external range

******************************************************************************

C
C  Set the contour/color levels

        CALL SET_LEVELS_SHADE_FILL (status)
	IF (status .NE. ferr_ok) GOTO 5000

C       DRAW
C
C       from ppl/include/PPL.INC:
C
C       JTYPE: = 2 2-d irregular rectangular grid
C              = 1 1-d set
C              = 0 2-d regular rectangular grid (integer)
C              =-1 2-d second component of a vector regular grid
C              =-2 2-d second component of a vector irregular grid
C

C  WHY HAD JTYPE BEEN SET TO 1 HERE??!! 

c        IF (use_cell) JTYPE = 1
        IF (use_cell) JTYPE = 0

C       If it's a 2-d irregular grid, the irregular grid values
C       are also stored in the Z array.  Pass them to shade_sub.
	
	IF (JTYPE.EQ.2 .OR. JTYPE.EQ.-2) THEN

	   CALL SHADE_SUB(Z,Z(1,NY+1),Z(1,NY+2),XX(IZSE-NX-1),
     .        YY(IZSE-NY-1), cells)

C       For all other plot types fill in XX() and YY() by
C       multiplying the index value by the DX or DY delta values.

	ELSE

	   DX = (XMAX - XMIN)/(NX - 1)
	   DY = (YMAX - YMIN)/(NY - 1)
	   IF (NX .EQ. 1) DX = 1.
	   IF (NY .EQ. 1) DY = 1.

	   DO 500 I=1,NX
	      XX(IZLEN+I)=DX*(I-1)+XMIN
 500	   CONTINUE
	   DO 510 J=1,NY
	      YY(IZLEN+J)=DY*(J-1)+YMIN
 510	   CONTINUE

c *kob* 8/97 had to move the continuation marker to col 5 - it was in col 8
c       this bombed aix compiler, though it seems to work on others
	   CALL SHADE_SUB(Z,XX(IZLEN+1),YY(IZLEN+1),XX(IZLEN+NX+1),
     1	       YY(IZLEN+NY+1), cells)

	ENDIF

	RETURN

C  Error exit when too many levels specified.
C  Arrays LWGT, LDIG, and ZLEV are length ICNLEV=500

 5000   ii = ICNLEV
        buff1 = TM_FMT_SNGL (REAL(ICNLEV), 20, 20, slen1)
        buff2 = TM_FMT_SNGL (REAL(NLEV2), 20, 20, slen2)
        err_msg = '# of shade levels > '// buff1(1:slen1) //
     .          '  (' // buff2(1:slen2) // ')'
        CALL errmsg (ferr_out_of_range, status, err_msg, *5002)
 5002   RETURN
	END

	SUBROUTINE COPY_INTO_SUB( cxlo, cxhi,
     .          src, slox, shix, sloy, shiy, sloz, shiz, 
     .          slot, shit, sloe, shie, slof, shif,
     .          dst, dlox, dhix, dloy, dhiy, dloz, dhiz, 
     .          dlot, dhit, dloe, dhie, dlof, dhif   )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* copy data from source grid into dstination grid using limits of source
* context (i.e. dstination grid is ASSUMED) big enough to hold data

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200: 10/16/89 - from COPY_INTO
* V533 *sh* 6/01 - allowing delta values in mrs
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

* calling argument declarations:
	INTEGER cxlo(*), cxhi(*),
     .		slox, shix, sloy, shiy, sloz, shiz, 
     .          slot, shit, sloe, shie, slof, shif, 
     .          dlox, dhix, dloy, dhiy, dloz, dhiz, 
     .          dlot, dhit, dloe, dhie, dlof, dhif

	REAL    src( slox:shix,sloy:shiy,sloz:shiz,slot:shit,sloe:shie,slof:shif ),
     .          dst( dlox:dhix,dloy:dhiy,dloz:dhiz,dlot:dhit,dloe:dhie,dlof:dhif )


* internal variable declarations:
	INTEGER	i, j, k, l, m, n

* --- end of introductory code ---

        DO 100 n = cxlo(6), cxhi(6)
        DO 100 m = cxlo(5), cxhi(5)
	DO 100 l = cxlo(4), cxhi(4)
	DO 100 k = cxlo(3), cxhi(3)
	DO 100 j = cxlo(2), cxhi(2)
	DO 100 i = cxlo(1), cxhi(1)

	   dst(i,j,k,l,m,n) = src(i,j,k,l,m,n)

 100	CONTINUE

	RETURN
	END 

	subroutine fixtim (it1,it2,itnew1,itnew2,itype)
C** 
C**    @(#)fixtim.f	1.1    3/10/88
C**
C**
C***********************************************************************        C**
C**                 EPIC
C**
C***********************************************************************        C**
C**
c
c  Input:
c	it1,it2 = input range of times in PLOT5's WHOI format (yyddmmhhmm)
c	itype   = PLOT5 axis type 0 even hours		ending     00
c                                 1 even days		ending   0000
c                                 3 even months		ending 010000
c                                 4 even minutes
c  Output:
c	itnew1,itnew2 = range of times which suit the input axis type and
c                       include the input range of times (yymmddhhmm)
c
c  Uses subroutines TIME1 (sequence # <--> WHOI times and NUMDM1
c  (# days in month) from PLOT5's MILELIB.
c
c  Programmed by N. Soreide, May 86.

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Mod J Davison 11.21.95 For 4 digit years
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
C 
C *acm* 4/22/02  replace ALL places lower than the desired round-off
C                with 00.  e.g. if 950115013303 is to be expressed
C                in even hours, make it 950115010000 not 950115010003

c
	character*(*) it1,it2,itnew1,itnew2
	character*14 cdum
c
	if (itype .eq. 3) then
cc acm	    itnew1=it1(1:4)//'010000'//it1(11:14)
	    itnew1=it1(1:4)//'01000000'//it1(13:14)

	    if (it2(5:10) .eq. '010000') then
		itnew2=it2
	    else
		dt=1440.
		nm=numdm1(it2)
		read (it2(5:6),*) id
		iseq=nm-id+2
cc		call time1 (1, it2(1:6)//'0000'//it2(11:14), iseq,
cc     1		                cdum, idum, itnew2, dt)
		call time1 (1, it2(1:6)//'000000'//it2(13:14), iseq,
     1		                cdum, idum, itnew2, dt)
	    endif

	else if (itype .eq. 1) then
cc	    itnew1=it1(1:6)//'0000'//it1(11:14)
	    itnew1=it1(1:6)//'000000'//it1(13:14)
	    if (it2(7:10) .eq. '0000') then
		itnew2=it2
	    else
		dt=1440.
		iseq=2
cc		call time1 (1, it2(1:6)//'0000'//it2(11:14), iseq,
cc     1		                cdum, idum, itnew2, dt)
		call time1 (1, it2(1:6)//'000000'//it2(13:14), iseq,
     1		                cdum, idum, itnew2, dt)
	    endif
	else if (itype .eq. 0) then
cc	    itnew1=it1(1:8)//'00'//it1(11:14)
	    itnew1=it1(1:8)//'0000'//it1(13:14)
	    if (it2(9:10) .eq. '00') then
		itnew2=it2
	    else
		dt=60.
		iseq=2
cc		call time1 (1, it2(1:8)//'00'//it2(11:14), iseq,
cc     1		                cdum, idum, itnew2, dt)
		call time1 (1, it2(1:8)//'0000'//it2(13:14), iseq,
     1		                cdum, idum, itnew2, dt)
	    endif

	else if (itype .eq. 4) then
	    itnew1=it1(1:10)//'00'//it1(13:14)
	    if (it2(11:12) .eq. '00') then
		itnew2=it2
	    else
		dt=1.
		iseq=2
		call time1 (1, it2(1:10)//'00'//it2(13:14), iseq,
     1		                cdum, idum, itnew2, dt)
	    endif

	endif
	return
	end

      SUBROUTINE FFTINV (ND, X, a, b, WFT)
      real X(*), WFT(*)
      real a(*), b(*)
      integer nd, nf, i, j

C  From snsr, by Jim Larsen, PMEL 
C  Ansley Manke: 11/2001 Change to undo scaling in FOUR_RE
c   calls NCAR FFT code

c   Calls:  RFFTB

      NF = ND/ 2 

      X(1) = 0.0
      X(2) = a(1)

      DO I = 1, NF-1 
        J = 2* i
        X(J)   = 0.5* a(i) 
        X(J+1) = -0.5* b(i) 
      ENDDO

      X(ND) = a(nf)

      CALL RFFTB (ND, X, WFT) 

      RETURN 
      END

C     SUBROUTINE RFFTB(N,R,WSAVE)                                               
C                                                                               
C     SUBROUTINE RFFTB COMPUTES THE REAL PERODIC SEQUENCE FROM ITS              
C     FOURIER COEFFICIENTS (FOURIER SYNTHESIS). THE TRANSFORM IS DEFINED        
C     BELOW AT OUTPUT PARAMETER R.                                              
C                                                                               
C     INPUT PARAMETERS                                                          
C                                                                               
C     N       THE LENGTH OF THE ARRAY R TO BE TRANSFORMED.  THE METHOD          
C             IS MOST EFFICIENT WHEN N IS A PRODUCT OF SMALL PRIMES.            
C             N MAY CHANGE SO LONG AS DIFFERENT WORK ARRAYS ARE PROVIDED        
C                                                                               
C     R       A REAL ARRAY OF LENGTH N WHICH CONTAINS THE SEQUENCE              
C             TO BE TRANSFORMED                                                 
C                                                                               
C     WSAVE   A WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 2*N+15.           
C             IN THE PROGRAM THAT CALLS RFFTB. THE WSAVE ARRAY MUST BE          
C             INITIALIZED BY CALLING SUBROUTINE RFFTI(N,WSAVE) AND A            
C             DIFFERENT WSAVE ARRAY MUST BE USED FOR EACH DIFFERENT             
C             VALUE OF N. THIS INITIALIZATION DOES NOT HAVE TO BE               
C             REPEATED SO LONG AS N REMAINS UNCHANGED THUS SUBSEQUENT           
C             TRANSFORMS CAN BE OBTAINED FASTER THAN THE FIRST.                 
C             THE SAME WSAVE ARRAY CAN BE USED BY RFFTF AND RFFTB.              
C                                                                               
C                                                                               
C     OUTPUT PARAMETERS                                                         
C                                                                               
C     R       FOR N EVEN AND FOR I = 1,...,N                                    
C                                                                               
C                  R(I) = R(1)+(-1)**(I-1)*R(N)                                 
C                                                                               
C                       PLUS THE SUM FROM K=2 TO K=N/2 OF                       
C                                                                               
C                        2.*R(2*K-2)*COS((K-1)*(I-1)*2*PI/N)                    
C                                                                               
C                       -2.*R(2*K-1)*SIN((K-1)*(I-1)*2*PI/N)                    
C                                                                               
C             FOR N ODD AND FOR I = 1,...,N                                     
C                                                                               
C                  R(I) = R(1) PLUS THE SUM FROM K=2 TO K=(N+1)/2 OF            
C                                                                               
C                       2.*R(2*K-2)*COS((K-1)*(I-1)*2*PI/N)                     
C                                                                               
C                      -2.*R(2*K-1)*SIN((K-1)*(I-1)*2*PI/N)                     
C                                                                               
C      *****  NOTE                                                              
C                  THIS TRANSFORM IS UNNORMALIZED SINCE A CALL OF RFFTF         
C                  FOLLOWED BY A CALL OF RFFTB WILL MULTIPLY THE INPUT          
C                  SEQUENCE BY N.                                               
C                                                                               
C     WSAVE   CONTAINS RESULTS WHICH MUST NOT BE DESTROYED BETWEEN              
C             CALLS OF RFFTB OR RFFTF.                                          
C                                                                               
C                                                                               
      SUBROUTINE RFFTB (N,R,WSAVE)                                              
      INTEGER N
      REAL       R(*)       ,WSAVE(*)     
C                                                                               
      IF (N .EQ. 1) RETURN                                                      
      CALL RFFTB1 (N,R,WSAVE,WSAVE(N+1),WSAVE(2*N+1))                           
      RETURN                                                                    
      END                                                                       
      SUBROUTINE RFFTB1 (N,C,CH,WA,IFAC)                                        
      INTEGER N, NF, NA, L1, IW, K1, IP, L2, IDO, IDL1, I, IX2, IX3, IX4
      REAL       CH(*)      ,C(*)       ,WA(*)      ,IFAC(*)   
      NF = IFAC(2)                                                              
      NA = 0                                                                    
      L1 = 1                                                                    
      IW = 1                                                                    
      DO 116 K1=1,NF                                                            
         IP = IFAC(K1+2)                                                        
         L2 = IP*L1                                                             
         IDO = N/L2                                                             
         IDL1 = IDO*L1                                                          
         IF (IP .NE. 4) GO TO 103                                               
         IX2 = IW+IDO                                                           
         IX3 = IX2+IDO                                                          
         IF (NA .NE. 0) GO TO 101                                               
         CALL RADB4 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3))                        
         GO TO 102                                                              
  101    CALL RADB4 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3))                        
  102    NA = 1-NA                                                              
         GO TO 115                                                              
  103    IF (IP .NE. 2) GO TO 106                                               
         IF (NA .NE. 0) GO TO 104                                               
         CALL RADB2 (IDO,L1,C,CH,WA(IW))                                        
         GO TO 105                                                              
  104    CALL RADB2 (IDO,L1,CH,C,WA(IW))                                        
  105    NA = 1-NA                                                              
         GO TO 115                                                              
  106    IF (IP .NE. 3) GO TO 109                                               
         IX2 = IW+IDO                                                           
         IF (NA .NE. 0) GO TO 107                                               
         CALL RADB3 (IDO,L1,C,CH,WA(IW),WA(IX2))                                
         GO TO 108                                                              
  107    CALL RADB3 (IDO,L1,CH,C,WA(IW),WA(IX2))                                
  108    NA = 1-NA                                                              
         GO TO 115                                                              
  109    IF (IP .NE. 5) GO TO 112                                               
         IX2 = IW+IDO                                                           
         IX3 = IX2+IDO                                                          
         IX4 = IX3+IDO                                                          
         IF (NA .NE. 0) GO TO 110                                               
         CALL RADB5 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3),WA(IX4))                
         GO TO 111                                                              
  110    CALL RADB5 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3),WA(IX4))                
  111    NA = 1-NA                                                              
         GO TO 115                                                              
  112    IF (NA .NE. 0) GO TO 113                                               
         CALL RADBG (IDO,IP,L1,IDL1,C,C,C,CH,CH,WA(IW))                         
         GO TO 114                                                              
  113    CALL RADBG (IDO,IP,L1,IDL1,CH,CH,CH,C,C,WA(IW))                        
  114    IF (IDO .EQ. 1) NA = 1-NA                                              
  115    L1 = L2                                                                
         IW = IW+(IP-1)*IDO                                                     
  116 CONTINUE                                                                  
      IF (NA .EQ. 0) RETURN                                                     
      DO 117 I=1,N                                                              
         C(I) = CH(I)                                                           
  117 CONTINUE                                                                  
      RETURN                                                                    
      END                                                                       
      SUBROUTINE RADB2 (IDO,L1,CC,CH,WA1)                                       
      INTEGER IDO, L1, K, IDP2, I, IC
      REAL       CC(IDO,2,L1)           ,CH(IDO,L1,2)           ,          
     1                WA1(*)          
      REAL TR2, TI2
      DO 101 K=1,L1                                                             
         CH(1,K,1) = CC(1,1,K)+CC(IDO,2,K)                                      
         CH(1,K,2) = CC(1,1,K)-CC(IDO,2,K)                                      
  101 CONTINUE                                                                  
      IF (IDO-2) 107,105,102                                                    
  102 IDP2 = IDO+2                                                              
      DO 104 K=1,L1                                                             
         DO 103 I=3,IDO,2                                                       
            IC = IDP2-I                                                         
            CH(I-1,K,1) = CC(I-1,1,K)+CC(IC-1,2,K)                              
            TR2 = CC(I-1,1,K)-CC(IC-1,2,K)                                      
            CH(I,K,1) = CC(I,1,K)-CC(IC,2,K)                                    
            TI2 = CC(I,1,K)+CC(IC,2,K)                                          
            CH(I-1,K,2) = WA1(I-2)*TR2-WA1(I-1)*TI2                             
            CH(I,K,2) = WA1(I-2)*TI2+WA1(I-1)*TR2                               
  103    CONTINUE                                                               
  104 CONTINUE                                                                  
      IF (MOD(IDO,2) .EQ. 1) RETURN                                             
  105 DO 106 K=1,L1                                                             
         CH(IDO,K,1) = CC(IDO,1,K)+CC(IDO,1,K)                                  
         CH(IDO,K,2) = -(CC(1,2,K)+CC(1,2,K))                                   
  106 CONTINUE                                                                  
  107 RETURN                                                                    
      END                                                                       
      SUBROUTINE RADB3 (IDO,L1,CC,CH,WA1,WA2)                                   
      INTEGER IDO, L1, K, IDP2, I, IC
      REAL       CC(IDO,3,L1)           ,CH(IDO,L1,3)           ,          
     1                WA1(*)     ,WA2(*)  
      REAL TAUI, TAUR
      REAL TR2, TI2, CR2, CI2, CR3, CI3, DR2, DI2, DI3, DR3
      DATA TAUR,TAUI /-.5,.866025403784439/                                     
      DO 101 K=1,L1                                                             
         TR2 = CC(IDO,2,K)+CC(IDO,2,K)                                          
         CR2 = CC(1,1,K)+TAUR*TR2                                               
         CH(1,K,1) = CC(1,1,K)+TR2                                              
         CI3 = TAUI*(CC(1,3,K)+CC(1,3,K))                                       
         CH(1,K,2) = CR2-CI3                                                    
         CH(1,K,3) = CR2+CI3                                                    
  101 CONTINUE                                                                  
      IF (IDO .EQ. 1) RETURN                                                    
      IDP2 = IDO+2                                                              
      DO 103 K=1,L1                                                             
         DO 102 I=3,IDO,2                                                       
            IC = IDP2-I                                                         
            TR2 = CC(I-1,3,K)+CC(IC-1,2,K)                                      
            CR2 = CC(I-1,1,K)+TAUR*TR2                                          
            CH(I-1,K,1) = CC(I-1,1,K)+TR2                                       
            TI2 = CC(I,3,K)-CC(IC,2,K)                                          
            CI2 = CC(I,1,K)+TAUR*TI2                                            
            CH(I,K,1) = CC(I,1,K)+TI2                                           
            CR3 = TAUI*(CC(I-1,3,K)-CC(IC-1,2,K))                               
            CI3 = TAUI*(CC(I,3,K)+CC(IC,2,K))                                   
            DR2 = CR2-CI3                                                       
            DR3 = CR2+CI3                                                       
            DI2 = CI2+CR3                                                       
            DI3 = CI2-CR3                                                       
            CH(I-1,K,2) = WA1(I-2)*DR2-WA1(I-1)*DI2                             
            CH(I,K,2) = WA1(I-2)*DI2+WA1(I-1)*DR2                               
            CH(I-1,K,3) = WA2(I-2)*DR3-WA2(I-1)*DI3                             
            CH(I,K,3) = WA2(I-2)*DI3+WA2(I-1)*DR3                               
  102    CONTINUE                                                               
  103 CONTINUE                                                                  
      RETURN                                                                    
      END    
                                                 
      SUBROUTINE RADBG (IDO,IP,L1,IDL1,CC,C1,C2,CH,CH2,WA)                      
      INTEGER IDO, IP, L1, IDL1, J, IC, L, LC
      INTEGER IDP2, NBD, IPP2, IPPH, K, I, JC, J2, IK, IS, IDIJ
      REAL            CH(IDO,L1,IP)          ,CC(IDO,IP,L1)          ,          
     1                C1(IDO,L1,IP)          ,C2(IDL1,IP),                      
     2                CH2(IDL1,IP)           ,WA(*)    
      REAL PIMACH
      REAL TPI, ARG, DCP, DSP , AR1, AI1, AR2, AR2H, DS2, DC2, DUM
      REAL AR1H, AI2


      TPI = 2.0*PIMACH(DUM)                                                     
      ARG = TPI/FLOAT(IP)                                                       
      DCP = COS(ARG)                                                            
      DSP = SIN(ARG)                                                            
      IDP2 = IDO+2                                                              
      NBD = (IDO-1)/2                                                           
      IPP2 = IP+2                                                               
      IPPH = (IP+1)/2                                                           
      IF (IDO .LT. L1) GO TO 103                                                
      DO 102 K=1,L1                                                             
         DO 101 I=1,IDO                                                         
            CH(I,K,1) = CC(I,1,K)                                               
  101    CONTINUE                                                               
  102 CONTINUE                                                                  
      GO TO 106                                                                 
  103 DO 105 I=1,IDO                                                            
         DO 104 K=1,L1                                                          
            CH(I,K,1) = CC(I,1,K)                                               
  104    CONTINUE                                                               
  105 CONTINUE                                                                  
  106 DO 108 J=2,IPPH                                                           
         JC = IPP2-J                                                            
         J2 = J+J                                                               
         DO 107 K=1,L1                                                          
            CH(1,K,J) = CC(IDO,J2-2,K)+CC(IDO,J2-2,K)                           
            CH(1,K,JC) = CC(1,J2-1,K)+CC(1,J2-1,K)                              
  107    CONTINUE                                                               
  108 CONTINUE                                                                  
      IF (IDO .EQ. 1) GO TO 116                                                 
      IF (NBD .LT. L1) GO TO 112                                                
      DO 111 J=2,IPPH                                                           
         JC = IPP2-J                                                            
         DO 110 K=1,L1                                                          
            DO 109 I=3,IDO,2                                                    
               IC = IDP2-I                                                      
               CH(I-1,K,J) = CC(I-1,2*J-1,K)+CC(IC-1,2*J-2,K)                   
               CH(I-1,K,JC) = CC(I-1,2*J-1,K)-CC(IC-1,2*J-2,K)                  
               CH(I,K,J) = CC(I,2*J-1,K)-CC(IC,2*J-2,K)                         
               CH(I,K,JC) = CC(I,2*J-1,K)+CC(IC,2*J-2,K)                        
  109       CONTINUE                                                            
  110    CONTINUE                                                               
  111 CONTINUE                                                                  
      GO TO 116                                                                 
  112 DO 115 J=2,IPPH                                                           
         JC = IPP2-J                                                            
         DO 114 I=3,IDO,2                                                       
            IC = IDP2-I                                                         
            DO 113 K=1,L1                                                       
               CH(I-1,K,J) = CC(I-1,2*J-1,K)+CC(IC-1,2*J-2,K)                   
               CH(I-1,K,JC) = CC(I-1,2*J-1,K)-CC(IC-1,2*J-2,K)                  
               CH(I,K,J) = CC(I,2*J-1,K)-CC(IC,2*J-2,K)                         
               CH(I,K,JC) = CC(I,2*J-1,K)+CC(IC,2*J-2,K)                        
  113       CONTINUE                                                            
  114    CONTINUE                                                               
  115 CONTINUE                                                                  
  116 AR1 = 1.                                                                  
      AI1 = 0.                                                                  
      DO 120 L=2,IPPH                                                           
         LC = IPP2-L                                                            
         AR1H = DCP*AR1-DSP*AI1                                                 
         AI1 = DCP*AI1+DSP*AR1                                                  
         AR1 = AR1H                                                             
         DO 117 IK=1,IDL1                                                       
            C2(IK,L) = CH2(IK,1)+AR1*CH2(IK,2)                                  
            C2(IK,LC) = AI1*CH2(IK,IP)                                          
  117    CONTINUE                                                               
         DC2 = AR1                                                              
         DS2 = AI1                                                              
         AR2 = AR1                                                              
         AI2 = AI1                                                              
         DO 119 J=3,IPPH                                                        
            JC = IPP2-J                                                         
            AR2H = DC2*AR2-DS2*AI2                                              
            AI2 = DC2*AI2+DS2*AR2                                               
            AR2 = AR2H                                                          
            DO 118 IK=1,IDL1                                                    
               C2(IK,L) = C2(IK,L)+AR2*CH2(IK,J)                                
               C2(IK,LC) = C2(IK,LC)+AI2*CH2(IK,JC)                             
  118       CONTINUE                                                            
  119    CONTINUE                                                               
  120 CONTINUE                                                                  
      DO 122 J=2,IPPH                                                           
         DO 121 IK=1,IDL1                                                       
            CH2(IK,1) = CH2(IK,1)+CH2(IK,J)                                     
  121    CONTINUE                                                               
  122 CONTINUE                                                                  
      DO 124 J=2,IPPH                                                           
         JC = IPP2-J                                                            
         DO 123 K=1,L1                                                          
            CH(1,K,J) = C1(1,K,J)-C1(1,K,JC)                                    
            CH(1,K,JC) = C1(1,K,J)+C1(1,K,JC)                                   
  123    CONTINUE                                                               
  124 CONTINUE                                                                  
      IF (IDO .EQ. 1) GO TO 132                                                 
      IF (NBD .LT. L1) GO TO 128                                                
      DO 127 J=2,IPPH                                                           
         JC = IPP2-J                                                            
         DO 126 K=1,L1                                                          
            DO 125 I=3,IDO,2                                                    
               CH(I-1,K,J) = C1(I-1,K,J)-C1(I,K,JC)                             
               CH(I-1,K,JC) = C1(I-1,K,J)+C1(I,K,JC)                            
               CH(I,K,J) = C1(I,K,J)+C1(I-1,K,JC)                               
               CH(I,K,JC) = C1(I,K,J)-C1(I-1,K,JC)                              
  125       CONTINUE                                                            
  126    CONTINUE                                                               
  127 CONTINUE                                                                  
      GO TO 132                                                                 
  128 DO 131 J=2,IPPH                                                           
         JC = IPP2-J                                                            
         DO 130 I=3,IDO,2                                                       
            DO 129 K=1,L1                                                       
               CH(I-1,K,J) = C1(I-1,K,J)-C1(I,K,JC)                             
               CH(I-1,K,JC) = C1(I-1,K,J)+C1(I,K,JC)                            
               CH(I,K,J) = C1(I,K,J)+C1(I-1,K,JC)                               
               CH(I,K,JC) = C1(I,K,J)-C1(I-1,K,JC)                              
  129       CONTINUE                                                            
  130    CONTINUE                                                               
  131 CONTINUE                                                                  
  132 CONTINUE                                                                  
      IF (IDO .EQ. 1) RETURN                                                    
      DO 133 IK=1,IDL1                                                          
         C2(IK,1) = CH2(IK,1)                                                   
  133 CONTINUE                                                                  
      DO 135 J=2,IP                                                             
         DO 134 K=1,L1                                                          
            C1(1,K,J) = CH(1,K,J)                                               
  134    CONTINUE                                                               
  135 CONTINUE                                                                  
      IF (NBD .GT. L1) GO TO 139                                                
      IS = -IDO                                                                 
      DO 138 J=2,IP                                                             
         IS = IS+IDO                                                            
         IDIJ = IS                                                              
         DO 137 I=3,IDO,2                                                       
            IDIJ = IDIJ+2                                                       
            DO 136 K=1,L1                                                       
               C1(I-1,K,J) = WA(IDIJ-1)*CH(I-1,K,J)-WA(IDIJ)*CH(I,K,J)          
               C1(I,K,J) = WA(IDIJ-1)*CH(I,K,J)+WA(IDIJ)*CH(I-1,K,J)            
  136       CONTINUE                                                            
  137    CONTINUE                                                               
  138 CONTINUE                                                                  
      GO TO 143                                                                 
  139 IS = -IDO                                                                 
      DO 142 J=2,IP                                                             
         IS = IS+IDO                                                            
         DO 141 K=1,L1                                                          
            IDIJ = IS                                                           
            DO 140 I=3,IDO,2                                                    
               IDIJ = IDIJ+2                                                    
               C1(I-1,K,J) = WA(IDIJ-1)*CH(I-1,K,J)-WA(IDIJ)*CH(I,K,J)          
               C1(I,K,J) = WA(IDIJ-1)*CH(I,K,J)+WA(IDIJ)*CH(I-1,K,J)            
  140       CONTINUE                                                            
  141    CONTINUE                                                               
  142 CONTINUE                                                                  
  143 RETURN                                                                    
      END                                                                       

                                                               
      SUBROUTINE RADB4 (IDO,L1,CC,CH,WA1,WA2,WA3)                               
      INTEGER IDO, L1, K, I, IDP2, IC
      REAL       CC(IDO,4,L1)           ,CH(IDO,L1,4)           ,          
     1                WA1(*)     ,WA2(*)     ,WA3(*)      
      REAL SQRT2
      REAL TR1, TR2, TR3, TR4, TI1, TI2, TI3, TI4
      REAL CR2, CR3, CR4, CI2, CI3, CI4
      DATA SQRT2 /1.414213562373095/                                            
      DO 101 K=1,L1                                                             
         TR1 = CC(1,1,K)-CC(IDO,4,K)                                            
         TR2 = CC(1,1,K)+CC(IDO,4,K)                                            
         TR3 = CC(IDO,2,K)+CC(IDO,2,K)                                          
         TR4 = CC(1,3,K)+CC(1,3,K)                                              
         CH(1,K,1) = TR2+TR3                                                    
         CH(1,K,2) = TR1-TR4                                                    
         CH(1,K,3) = TR2-TR3                                                    
         CH(1,K,4) = TR1+TR4                                                    
  101 CONTINUE                                                                  
      IF (IDO-2) 107,105,102                                                    
  102 IDP2 = IDO+2                                                              
      DO 104 K=1,L1                                                             
         DO 103 I=3,IDO,2                                                       
            IC = IDP2-I                                                         
            TI1 = CC(I,1,K)+CC(IC,4,K)                                          
            TI2 = CC(I,1,K)-CC(IC,4,K)                                          
            TI3 = CC(I,3,K)-CC(IC,2,K)                                          
            TR4 = CC(I,3,K)+CC(IC,2,K)                                          
            TR1 = CC(I-1,1,K)-CC(IC-1,4,K)                                      
            TR2 = CC(I-1,1,K)+CC(IC-1,4,K)                                      
            TI4 = CC(I-1,3,K)-CC(IC-1,2,K)                                      
            TR3 = CC(I-1,3,K)+CC(IC-1,2,K)                                      
            CH(I-1,K,1) = TR2+TR3                                               
            CR3 = TR2-TR3                                                       
            CH(I,K,1) = TI2+TI3                                                 
            CI3 = TI2-TI3                                                       
            CR2 = TR1-TR4                                                       
            CR4 = TR1+TR4                                                       
            CI2 = TI1+TI4                                                       
            CI4 = TI1-TI4                                                       
            CH(I-1,K,2) = WA1(I-2)*CR2-WA1(I-1)*CI2                             
            CH(I,K,2) = WA1(I-2)*CI2+WA1(I-1)*CR2                               
            CH(I-1,K,3) = WA2(I-2)*CR3-WA2(I-1)*CI3                             
            CH(I,K,3) = WA2(I-2)*CI3+WA2(I-1)*CR3                               
            CH(I-1,K,4) = WA3(I-2)*CR4-WA3(I-1)*CI4                             
            CH(I,K,4) = WA3(I-2)*CI4+WA3(I-1)*CR4                               
  103    CONTINUE                                                               
  104 CONTINUE                                                                  
      IF (MOD(IDO,2) .EQ. 1) RETURN                                             
  105 CONTINUE                                                                  
      DO 106 K=1,L1                                                             
         TI1 = CC(1,2,K)+CC(1,4,K)                                              
         TI2 = CC(1,4,K)-CC(1,2,K)                                              
         TR1 = CC(IDO,1,K)-CC(IDO,3,K)                                          
         TR2 = CC(IDO,1,K)+CC(IDO,3,K)                                          
         CH(IDO,K,1) = TR2+TR2                                                  
         CH(IDO,K,2) = SQRT2*(TR1-TI1)                                          
         CH(IDO,K,3) = TI2+TI2                                                  
         CH(IDO,K,4) = -SQRT2*(TR1+TI1)                                         
  106 CONTINUE                                                                  
  107 RETURN                                                                    
      END                             
                                                    
      SUBROUTINE RADB5 (IDO,L1,CC,CH,WA1,WA2,WA3,WA4)                           
      INTEGER IDO, L1, K, IDP2, I, IC
      REAL       CC(IDO,5,L1)           ,CH(IDO,L1,5)           ,          
     1                WA1(*)     ,WA2(*)     ,WA3(*)     ,WA4(*)     
      REAL TR2, TR3, TR4, TR5, TI2, TI3, TI4, TI5
      REAL CR2, CR3, CR4, CR5, CI2, CI3, CI4, CI5
      REAL DR2, DR3, DR4, DR5, DI2, DI3, DI4, DI5

      REAL TR11,TI11,TR12,TI12
      DATA TR11,TI11,TR12,TI12 /.309016994374947,.951056516295154,              
     1-.809016994374947,.587785252292473/       
     
      DO 101 K=1,L1                                                             
         TI5 = CC(1,3,K)+CC(1,3,K)                                              
         TI4 = CC(1,5,K)+CC(1,5,K)                                              
         TR2 = CC(IDO,2,K)+CC(IDO,2,K)                                          
         TR3 = CC(IDO,4,K)+CC(IDO,4,K)                                          
         CH(1,K,1) = CC(1,1,K)+TR2+TR3                                          
         CR2 = CC(1,1,K)+TR11*TR2+TR12*TR3                                      
         CR3 = CC(1,1,K)+TR12*TR2+TR11*TR3                                      
         CI5 = TI11*TI5+TI12*TI4                                                
         CI4 = TI12*TI5-TI11*TI4                                                
         CH(1,K,2) = CR2-CI5                                                    
         CH(1,K,3) = CR3-CI4                                                    
         CH(1,K,4) = CR3+CI4                                                    
         CH(1,K,5) = CR2+CI5                                                    
  101 CONTINUE                                                                  
      IF (IDO .EQ. 1) RETURN                                                    
      IDP2 = IDO+2                                                              
      DO 103 K=1,L1                                                             
         DO 102 I=3,IDO,2                                                       
            IC = IDP2-I                                                         
            TI5 = CC(I,3,K)+CC(IC,2,K)                                          
            TI2 = CC(I,3,K)-CC(IC,2,K)                                          
            TI4 = CC(I,5,K)+CC(IC,4,K)                                          
            TI3 = CC(I,5,K)-CC(IC,4,K)                                          
            TR5 = CC(I-1,3,K)-CC(IC-1,2,K)                                      
            TR2 = CC(I-1,3,K)+CC(IC-1,2,K)                                      
            TR4 = CC(I-1,5,K)-CC(IC-1,4,K)                                      
            TR3 = CC(I-1,5,K)+CC(IC-1,4,K)                                      
            CH(I-1,K,1) = CC(I-1,1,K)+TR2+TR3                                   
            CH(I,K,1) = CC(I,1,K)+TI2+TI3                                       
            CR2 = CC(I-1,1,K)+TR11*TR2+TR12*TR3                                 
            CI2 = CC(I,1,K)+TR11*TI2+TR12*TI3                                   
            CR3 = CC(I-1,1,K)+TR12*TR2+TR11*TR3                                 
            CI3 = CC(I,1,K)+TR12*TI2+TR11*TI3                                   
            CR5 = TI11*TR5+TI12*TR4                                             
            CI5 = TI11*TI5+TI12*TI4                                             
            CR4 = TI12*TR5-TI11*TR4                                             
            CI4 = TI12*TI5-TI11*TI4                                             
            DR3 = CR3-CI4                                                       
            DR4 = CR3+CI4                                                       
            DI3 = CI3+CR4                                                       
            DI4 = CI3-CR4                                                       
            DR5 = CR2+CI5                                                       
            DR2 = CR2-CI5                                                       
            DI5 = CI2-CR5                                                       
            DI2 = CI2+CR5                                                       
            CH(I-1,K,2) = WA1(I-2)*DR2-WA1(I-1)*DI2                             
            CH(I,K,2) = WA1(I-2)*DI2+WA1(I-1)*DR2                               
            CH(I-1,K,3) = WA2(I-2)*DR3-WA2(I-1)*DI3                             
            CH(I,K,3) = WA2(I-2)*DI3+WA2(I-1)*DR3                               
            CH(I-1,K,4) = WA3(I-2)*DR4-WA3(I-1)*DI4                             
            CH(I,K,4) = WA3(I-2)*DI4+WA3(I-1)*DR4                               
            CH(I-1,K,5) = WA4(I-2)*DR5-WA4(I-1)*DI5                             
            CH(I,K,5) = WA4(I-2)*DI5+WA4(I-1)*DR5                               
  102    CONTINUE                                                               
  103 CONTINUE                                                                  
      RETURN                                                                    
      END                  

	SUBROUTINE ASCII_LIMITS ( cx, idim, string, slen )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* produce a formatted string representing the space or time limits along the
* specified axes within the specified context

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 7/1/86
* revision 0.1 - 1/9/87  - added trans_integrated
* revision 0.2 - 4/28/87 - automated transformation comment using ALG_TRANS_TITL
* revision 0.3 - 7/13/87 - removed axis_titles - squeezed out unnedded blanks
* revision 0.4 - 9/10/87 - added "using nnn pts" for transformations w/ args
* revision 0.5 - 9/26/87 - using routine LOHI_WORLD
* revision 0.6 - 10/23/87- "using"-->"by" and nnn reduced to minimum digits
* revision 0.7 - 3/25/88 - increased LOHI_WORLD size for date/time strings
* V200:  1/12/90 - "of nnn" text string non-integer transform args
* V430:  7/96 - pass cx to ALG_TRANS_TITL so it can document 4D transformations
* v530  *acm* 3/01 - Show calendar name for alternative calendar types.
* v570  *acm* 5/04 - When showing calendar, need  cal_id .LE. max_calendars, not .LT.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction.
* v687  *acm* 3/14 Fix ticket 2149: TM_GET_CAL gets the calendar label from the T axis.
* v690 *sh* 4/14 show regridding by "false 1 pt" curvilinear regrid 
* V698 *sh* 4/16 document a true E ensemble axis with dataset identifier
* V75+ *acm*5/19 Issue 1930. Do not write member name in header unless we're 
*                looking at just one ensemble member (typo fix).
* V751 *acm*5/19 If DSG dataset, get the calendar of the time var

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'
	include 'xalgebra.cmn'
	include 'calendar.decl'
	include 'calendar.cmn'
	include 'xdset_info.cmn_text'

* calling argument declarations:
	INTEGER		cx, idim, slen
	CHARACTER*(*)	string

* local parameter declarations:
	LOGICAL		full_precision
	PARAMETER     ( full_precision = .TRUE. )

* internal variable declarations:
	LOGICAL		TM_HAS_STRING, its_ensemble
	INTEGER		TM_LENSTR, TM_GET_CALENDAR_ID,
     .			TM_LENSTR1, ENSEMBLE_MEMBER_DSET,
     .			max_len, len_trans, llen, trans, i,
     .			grid, cal_id, len_cal, dset, slen2, memb_dset
	CHARACTER	ALG_TRANS_TITL*20, LOHI_WORLD*44, LEFINT*4, 
     .			TM_FMT*48, TM_GET_CAL*32, TM_GET_F_CAL*32,
     .			VAR_CODE*128,
     .			trans_title*128, cal_name*32
	REAL		trans_arg

* initialize
	max_len	= LEN(string)
	trans     = cx_trans( idim, cx )
	trans_arg = cx_trans_arg( idim, cx )
	dset = cx_data_set(cx)

* is this a label for an ensemble axis?
	its_ensemble = .FALSE.
	its_ensemble = idim .EQ. E_dim
     .		    .AND. dset.GT.pdset_irrelevant
     .	            .AND. dset.LE.max_gfdl_dsets
 	IF (its_ensemble) THEN
	      its_ensemble = TM_HAS_STRING(ds_type(dset), 'ENS')
	ENDIF

* not an applicable dimension ?
	IF ( cx_lo_ww( idim, cx ) .EQ. unspecified_val8 ) THEN
	   string     = ' N/A'
	   slen = 4
	   RETURN
	ENDIF

* put in lower/upper world coordinates
	string = LOHI_WORLD( idim, cx, ' to ', full_precision, slen )
	
* transformation requiring comment ?
	IF ( trans .NE. trans_no_transform ) THEN
	   trans_title = ALG_TRANS_TITL( trans, cx )
	   len_trans   = TM_LENSTR( trans_title )
	   IF ( trans_arg .NE. bad_val4 ) THEN
	      DO 100 i = 1, num_transforms
 100	      IF ( trans .EQ. alg_trans_num(i) ) GOTO 200
	      STOP 'ASCII_LIMITS'
 200	      IF ( alg_trans_its_int(i) ) THEN
* ... add "by nnn pts" squeezing "nnn" to minimum digits
	         trans_title = trans_title(:len_trans)//' by '//
     .			       LEFINT( INT(trans_arg), llen )
	         len_trans = len_trans + 4 + llen
	         trans_title = trans_title(1:len_trans)//' pts'
	         len_trans = len_trans + 4
	      ELSE
* ... add "of nnn " in a nice format
	         trans_title = trans_title(:len_trans)//' of '//
     .			       TM_FMT( trans_arg, 4, 10, llen )
	         len_trans = len_trans + 4 + llen
	      ENDIF
	   ENDIF
	   string = string(1:slen)//' ('//trans_title(:len_trans)//')'	
	   slen = MIN( max_len, slen+len_trans+3 )
	ELSEIF (cx_aux_stat(idim,cx) .EQ. paux_stat_false_1pt_regrid) THEN
* ... add "averaged using DEPTH" or "interpolated using DEPTH"
	   IF     (cx_regrid_trans(idim, cx) .EQ. pauxrgrd_linear ) THEN
	      trans_title = 'interpolated using'
	   ELSEIF (cx_regrid_trans(idim, cx) .EQ. pauxrgrd_pwlave ) THEN
	      trans_title = 'pc wise lin avgd using'
	   ELSE
	      trans_title = '??crptn??'
	   ENDIF	 
	   len_trans = TM_LENSTR( trans_title )
*      append name of auxiliary variable
	   trans_title(len_trans+2:) = VAR_CODE(cx_aux_cat(idim,cx),
     .				                cx_aux_var(idim,cx)  )
	   len_trans = TM_LENSTR( trans_title )
	   string = string(1:slen)//' ('//trans_title(:len_trans)//')'	
	   slen = MIN( max_len, slen+len_trans+3 )
	ENDIF

* calendar name requiring comment ?  If DSG dataset, get the calendar of the time var


	IF ((idim.EQ.t_dim .OR. idim.EQ.f_dim) .AND. 
     .      cx_lo_ww( idim, cx ) .NE. unspecified_val8 ) THEN

	   grid = cx_grid(cx)

	   IF (dset .GT. pdset_irrelevant) THEN
	      IF (dsg_ragged(dset)) grid = dsg_xlate_grid(dset) 
	   ENDIF

	   IF (idim.EQ.t_dim) cal_name = TM_GET_CAL (grid)
	   IF (idim.EQ.f_dim) cal_name = TM_GET_F_CAL (grid)
	   cal_id = TM_GET_CALENDAR_ID (cal_name)
	   IF (cal_id .GT. gregorian .AND. cal_id .LE. max_calendars) THEN
	      len_cal = TM_LENSTR(cal_name)
	      string =  string(1:slen)//' '//cal_name(:len_cal)
	      slen = MIN( max_len, slen+len_cal+1 )
	   ENDIF
	ENDIF

* a single ensemble member name
	IF ( its_ensemble
     .  .AND.cx_lo_ss(cx,idim).NE.unspecified_int4
     .  .AND.cx_lo_ss(cx,idim).EQ.cx_hi_ss(cx,idim) ) THEN

* ... get the special string that indicates the ensemble member
	   memb_dset = ENSEMBLE_MEMBER_DSET(dset, cx_lo_ss(cx,idim))
	   IF (  memb_dset.GT.pdset_irrelevant
     .	    .AND.memb_dset.LE.max_gfdl_dsets) THEN
	      slen2 = TM_LENSTR1( ds_name(memb_dset) )
	      slen2 = MIN(slen2, 12)  ! no more than 12 chars
	      string = string(1:slen)//' ('// 
     .		       ds_name(memb_dset)(1:slen2) // ')'	
	      slen = TM_LENSTR1( string )
	   ENDIF
	ENDIF


	RETURN
	END

	CHARACTER*(*) FUNCTION REPLACE_DEQ ( orig )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* replace the number found in a [D=#]" syntax with the dataset name

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V230:  3/3/92
* V300:  bug fix: check if expanded length is within allowable limits
* V314: 8/22/94 *kob* IBM port - needed to add ifdef MANDATORY_FORMAT_WIDTH for
*				 I format descriptor
* V420: 10/5/95 - bug detected in syntax var2[d=1]- VAR1[d=2,G=[VAR2[D=1]]
*		- actual bug was that i1 is improperly set in branches to 10
* 2/03 *kob* - g77 port - g77 won't allow intrinsic functions in PARAMETER
*                         statements.  use an octal constant instead
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* 11/16 *sh* support for aggregation.member syntax

        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'xvariables.cmn'
        include 'xdset_info.cmn_text'
        external xdset_info_data

* calling argument declarations
	CHARACTER*(*) orig

* internal variable declarations
	INTEGER TM_LENSTR1, FIND_DSET_NUMBER,
     .		i, i0, i1, i2, i3, eqpos, inlen, outlen,
     .          dset, nlen, maxlen

        CHARACTER*1 tab
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
#else
	PARAMETER     ( tab = CHAR(9))
#endif

* initialize
        i0 = 1
!	i1 = 1
        eqpos = 0
	inlen = LEN(orig)
        outlen = 0
	maxlen = LEN( REPLACE_DEQ )    ! 3/93
        REPLACE_DEQ = ' '

* search for next D=
 10     i1 = eqpos + 1			! 10/5: was "i1 = i1 + eqpos"
 11     eqpos = INDEX(orig(i1:), '=')
        IF ( eqpos .EQ. 0 ) GOTO 500
        eqpos = eqpos + i1 - 1
        DO 100 i = eqpos-1, i1, -1
           IF ( orig(i:i) .NE.' '
     .    .AND. orig(i:i) .NE.tab ) GOTO 110
 100    CONTINUE
        GOTO 500   ! blank is final character ??

* is it a "d" ?
 110    IF (orig(i:i).NE.'D' .AND. orig(i:i).NE.'d') GOTO 10

* make sure it's a "D" by itself instead of the end of another word
       IF ( orig(i-1:i-1).NE.' '
     . .AND. orig(i-1:i-1).NE.tab
     . .AND. orig(i-1:i-1).NE.'['
     . .AND. orig(i-1:i-1).NE.','
     . .AND. orig(i-1:i-1).NE.'/' ) GOTO 10

* got a "D=".  Is it followed by a number ?
        DO 200 i2 = eqpos+1, inlen
           IF ( orig(i2:i2) .NE.' '
     .    .AND. orig(i2:i2) .NE.tab ) GOTO 210
 200    CONTINUE
        GOTO 500   ! "=" is final character ??

* if it's "D=name" instead of "D=#" then ignore it
 210    IF ( orig(i2:i2).LT."1" .OR. orig(i2:i2).GT."9" ) GOTO 10

* get the data set number
        DO 300 i3 = i2+1, inlen
           IF ( (orig(i3:i3).LT."0" .OR. orig(i3:i3).GT."9")
     .    .AND. orig(i3:i3).NE."." ) GOTO 310
 300    CONTINUE
        GOTO 500   ! digit is final character ??
 310    i3 = i3 - 1
	dset = FIND_DSET_NUMBER(orig(i2:i3))
        IF (dset.LT.1 .OR. dset.GT.maxdsets) GOTO 10    ! error?

* replace D=# with D=name
        nlen = TM_LENSTR1(ds_name(dset))
        IF ( outlen .EQ. 0 ) THEN
           REPLACE_DEQ = orig(:eqpos)//ds_name(dset)(:nlen)
        ELSE
           REPLACE_DEQ = REPLACE_DEQ(:outlen)
     .               //orig(i0:eqpos)//ds_name(dset)(:nlen)
        ENDIF
        outlen = MIN( maxlen, outlen+eqpos-i0+1+nlen )   ! 3/93
        i1 = i3 + 1  ! skip over the dset # characters
        i0 = i1
        GOTO 11 

* tag on whatever is left over
 500    IF ( outlen .EQ. 0 ) THEN
           REPLACE_DEQ = orig
        ELSE
           REPLACE_DEQ = REPLACE_DEQ(:outlen)//orig(i0:inlen)
        ENDIF

 5000   RETURN
	END

c*
c* ef_get_box_lo_lim.F
c*
c* Ansley Manke
c* Jan 12th 1999
c*Based on ef_get_coordinates.F
c*
   
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
c*
c* This fills in the box_lo_lim of an axis in a grid.  
c*
c* JC_TODO: What about REAL*8 values being passed back to C
c*

      SUBROUTINE EF_GET_BOX_LO_LIM(id, iarg, idim,
     .     ss_lo_lim, ss_hi_lim, values )

      IMPLICIT NONE
      INCLUDE 'tmap_dims.parm'
      INCLUDE 'ferret.parm'
      INCLUDE 'xvariables.cmn'
      INCLUDE 'xcontext.cmn'
      INCLUDE 'EF_Util.parm'

      INTEGER id, iarg, idim
      INTEGER ss_lo_lim, ss_hi_lim
      INTEGER grid, i

      REAL*8  values( ss_lo_lim:ss_hi_lim )
      REAL*8  TM_WORLD

      INTEGER cx_list(EF_MAX_ARGS)

c* The context list was cached by Ferret and must be retrieved
c* to be accessible to the external function.
      CALL EF_GET_CX_LIST(cx_list)

*     defining grid for output data
      grid = cx_grid( cx_list(iarg) )

      DO 100 i = ss_lo_lim, ss_hi_lim
         values( i ) = TM_WORLD( i,grid,idim,box_lo_lim )
 100  continue

      RETURN 
      END

	SUBROUTINE KEY 

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Generates color/gray scale key
* 	J Davison JISAO/PMEL/NOAA
*	7.20.88

*	Modified to PPL_KEY to fit into ppl
*	J Davison 8.17.88
*	Mod introducing xmaxx and ymaxx to limit size of key JD 4.11.90
*	Mod to control font thickness JD 8.3.90
*	Mod to support ATC individual fill area reps *jd* 4.2.92
*       Mod to support single level chosen by user 8.25.92 *jd*
*	Mod to protect colors used already *jd* 10.1.92
*	Mod to use new hatch scheme *jd* 10.12.92 - cancelled 10.22.92
*	Mod to use SYMBEL rather than GTX for key labels *jd* 3.4.93
* 	Mod to provide identical endpoint values for a constant field/jd/5.96
*       Mod for FILLPOL *jd* 3.99
* v541 *acm*  5/02 add option to control outline on the shade key boxes (cont_key)
*                  also remove VMS INCLUDES
* 552 *acm* 4/03 Shade key improvements: 
* 	1) Larger default label size 
*       2) Can change the location of the labels from right to left and
*           top to bottom, by sending a negative value for the label size.
* 	3) The labels are right-justified (may not look it, depending on font) 
*           for vertical shade keys that are labelled on the left
*       4) Do not have to set all four corners when changing the size and
*           location of the shade key -- can reset any of the four, and
*           others will be filled in by making the key the default size
*           in that direction.  See shade_key.F 
* v553 *acm* Fix bug where length of the first numeric key label was not
*           taken into account when determining label size: computing max_len
* V553 *acm* 9/03 Introduce flag check_0. On Linux, there may be a 
*           be a level of -6.E-07 or some such, where it should be 0.
*           Check whether the numbers for the labels are all small,
*           in which case we leave things alone; otherwise use TM_FPEQ_SNGL
*           to see if the value should be exactly 0.  
* V554 *acm* 11/03 Call TM_FMT_SNGL_digits rather than TM_FMT_SNGL: if the shakey
*                  parameter klab_dig is negative, requesting an exact
*                  number of decimal places.  The change is to force the
*                  same number of digits for all labels. -- more consistent 
*                  output, better justification.
* V580 *acm* 7/04  When the user has set the location and size of the colorbar,
*                  the position of the labels was too close to the edge of the
*                  vertical colorbar.
* V580 *acm* 8/04  Allow for PPL POLYGON as well as PPL FILLPOL after a POLY/SET command.
* V580 *acm* 11/04 Make the default key label size 0.1, to match axis labels. Change
*                  setting so the key labels do not go so close to the edge of the plot.
* V580 *acm* 11/04 Fix bug 906: default number of digits did not distinguish different 
*                  levels; got repeated labels 370, 371, 371, 372, 372,...
* v581 *acm* 3/05 open levels (-INF) (INF)
* V600 *acm* 8/05 fix bug 1330; vertical position of key labels, -0.5*karht was missing 
*                 on definition of yy
* V600 *acm* 9/05 fix bug 1339, with (-inf) (inf) levels and the shakey setting klab_dig=0,
*                 we had an infinite loop on DO 30. Start the loop at ndx = lev1+1, not 1.
* V600 *acm* 1/06 Among the changes when we added TM_FMT_SNGL_digits, when checking whether more 
*                 digits are needed, keep track of digits added; need to increase the  
*                 argument klab_len by the same amount in subsequent calls to TM_FMT_SNGL_DIGITS  
*                 when we are writing the numeric labels on the key. 
* V610 *acm* 3/08 For larger default number of levels, make fewer labels when the key is short.
* V630 *acm* 9/09 Fix color key labels that run off the edge of the plot 
* V670 *acm* 2/11 Fix ticket 1798. The fix to 1339 starting label loops at ndx=lev1+1 
*                 was not applied to loop 20 for horizontal keys.
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus
* V685 *acm* 4/13 For horizontal keys check that there is room for the labels and adjust
*                 label size and/or increment
* v686 *acm* 1/14 Fix ticket 2123: labeling color bar when there is just one level.
*                 Remove the special code that labeled the top and bottom of a single-level
*                 color key with the lower boundary of the level. See the 5/96 commend above) 
*                 Instead label with the upper and lower edges of that color level.
* v686 *acm* 1/14 Fixes for labels on horizontal keys: make sure they don't get too small, and
*                 don't let them run over each other. Locate the horizontal colorbar close to
*                 the plot with labels above them. Behavior of args to SHAKEY is unchanged.
* v686 *acm* 2/14 Fix ticket 2124: Do the fix for 2124 only here, not in subr. LEV.
* Get labels on colorbar right if there is just one level.
c	        IF (NL.EQ.1 .AND. J.LE.2) ZLEV(2) = zlev(1)
* V6.92 *acm* 6/14 New color /key options: any of /key=horizontal,centerlabel
*                  For centered labels add a level to corresp to the upper bound of 
*                  the top color on thecolorbar, excluding any upper inf triangle.
* V697 *acm* 12/15 Fix ticket 2326: single level plus (inf) and/or (-inf)
* V71  *acm*  1/17 Fix ticket 2491: labels on colorbar when it's a ribbon/vlog, ribbon/hlog plot
* V71  *acm*  1/17 Fix ticket 2491: Tweak to key labels, code adding .0 to numbers for consistency
* V72  *acm*  7/17 See example, ticket 2550 small exponential labels need more precision in key labels
* V74+  *acm* 3/18 Issue 1607.  /KEY=centerlab
*         For centered labels draw the plot so that the levels are describing 
*         the middle of the colors not the contour lines between colors.
*         Interpolate /LEVELS values to obtain new edge-values for the contours
*         and patch-edges
* V74+  *acm* 8/18 dsg plotting; keys keys labeled with text.
* V74+  *acm* 8/18 dsg plotting; text-based key labels may be drawn at an angle.
* V74+  *acm* 11/18 When drawing in a viewport w/ limited space, key labels include 
*          negative values they run off the edges. Issue 1904
*       *acm* 12/18 For vertical colorbars that are short, like in viewports, adjust
*          the labeling interval so they aren't crowded.
* V7.51 *acm*  7/19 Simplify the center-labeled key logic; put values to use in labels
*                   into the array val_lab.


	include 	'parampl5_dat.decl'
	include 	'PARAMPL5.DAT'
	include		'cont_inc.decl'
	include		'CONT.INC'
        include 	'pltcom_dat.decl'
        include 	'PLTCOM.DAT'
        include 	'pltl_inc.decl'
        include 	'PLTL.INC'

        include         'axis_inc.decl'
        include         'AXIS.INC'
        include         'plt_inc.decl'
        include         'PLT.INC'
        include         'pen_inc.decl'
        include         'PEN.INC'

        include         'shade_vars.cmn'
        include         'gkscm1_inc.decl'
        include         'GKSCM1.INC'
        include         'gkscm2.cmn'

	include        'gkspar.inc'

     	integer TM_LENSTR1, TM_LENSTR, 
     .          ndx,str_len,max_len,incr,lab_digits, nhi, ncount,
     .          lab_add, nlab, i, kount, lev1, levn, nspace, shd_lev_hi,
     .		ITYPEX_save, ITYPEY_save, ic, num_dec, maxstr, i_dec


	real		x_inc,y_inc,px(4),py(4),rem,kpx(5),kpy(5),flaty(5),flatx(5)
	real		xmaxx,ymaxx,vwidth,vheight,karht, ksiz_test
	real		xx,yy,xxx,yyy, xx1, xxn, xxlen, xpos, wid, xp
        real            kx_lo_def, kx_hi_def, ky_lo_def, ky_hi_def,
     .                  val, del, x_inc_inf, y_inc_inf, frac, fixx, inc_min, 
     .                  center_add, keylab_angl, val_lab(ICNLEV)
        character*48    TM_FMT_SNGL
        character*30    txt_out, text, buff
	logical		TM_FPEQ_SNGL, TM_DFPEQ, ITSA_AXIS_VIEW, TM_HAS_STRING,  
     .                  windof_hold, check_0, nofill, cont_key_keep, 
     .                  no_lines, is_viewport, have_neg, string_labs

	external	TM_FMT_SNGL

	equivalence 	(px(1),kpx(1)),(py(1),kpy(1))

	include 	'ppl_in_ferret.cmn'	


*******************************************************************************

*	CANCEL WINDOW ON IF SET
	windof_hold = windof
	windof = .false.

	cont_key_keep = cont_key
	center_add = 0.
	if (center_key_labels) center_add = 0.5
	keylab_angl = 0.

	incr = 0

	DO i = 1, icnlev
	   IF (center_key_labels) THEN
	      val_lab(i) = zlevsave(i)
	   ELSE
	      val_lab(i) = zlev(i)
	   ENDIF
	ENDDO

	string_labs = TM_LENSTR( colorkey_labs(1) ) .GT. 0

	CALL KEY_SET_UP (string_labs, skip_key, max_len, lab_digits, 
     .      check_0, lab_add, num_dec, lev1, levn, incr)

* If the plot has log axes, the location of labels is adjusted in routine
* point_convert.  We do not want that on the color key, so reset the flag
* here, and restore the values at the end

	IF (nofill) GOTO 2000

	itypex_save = itypex
	itypey_save = itypey
	itypex = 1
	itypey = 1


! IF (INF) levels, will force triangles to be at least 5% of length of colorbar

        frac = 0.05
        ncount = 1./frac

* Account for magnitude and formatting of data in the labels as found by TM_FMT_SNGL

	IF (max_len .GT. klab_len) lab_add = lab_add + (max_len-klab_len)

	IF (vertical_key) GOTO 1000

*	MAKE A HORIZONTAL KEY
* Define default x and y lo and hi locations

        if (ppl_in_ferret) then
           call get_view_size (vwidth,vheight,is_viewport)

           IF (ITSA_AXIS_VIEW(1)) vheight = (ylen + yorg )* 1.15

           if (vheight .le. ylen + yorg) goto 2000

           rem = vheight - (ylen + yorg)

           kx_lo_def = 1000.0 *  xorg
           kx_hi_def = 1000.0 * (xorg + xlen)

           ky_lo_def = 1000.0 * (yorg + ylen + 0.05)
           ky_hi_def = 1000.0 * (yorg + ylen + 0.05 + 0.16*rem)

        else
           rem = height - (ylen + yorg)
	   ymaxx = 0.25*ylen
           kx_lo_def = 1000.0 *  xorg 
           kx_hi_def = 1000.0 * (xorg + xlen)
           ky_lo_def = 1000.0 * (yorg + ylen + 0.25*min (rem,ymaxx))
           ky_hi_def = yorg+ylen+ymaxx
           ky_hi_def = height-0.1*rem
           ky_hi_def = 1000.0 * min (yorg+ylen+ymaxx,height-0.1*rem)
        end if

        IF (kuser_loc(1) .OR. kuser_loc(2) .OR. 
     .      kuser_loc(3) .OR. kuser_loc(4)) THEN  

! Some or all of kx_lo,kx_hi,ky_lo,ky_hi  are already set

           IF ((.NOT.kuser_loc(1)) .AND. (.NOT.kuser_loc(2))) THEN
              kx_lo = kx_lo_def
              kx_hi = kx_hi_def
           ELSEIF ((.NOT.kuser_loc(1)) .AND. kuser_loc(2) ) THEN
              kx_lo = kx_hi - (kx_hi_def - kx_lo_def)
           ELSEIF (kuser_loc(1) .AND. (.NOT.kuser_loc(2)) ) THEN
              kx_hi = kx_lo + (kx_hi_def - kx_lo_def)
           ENDIF 

           IF ((.NOT.kuser_loc(3)) .AND. (.NOT.kuser_loc(4)) ) THEN
              ky_lo = ky_lo_def
              ky_hi = ky_hi_def
           ELSEIF ((.NOT.kuser_loc(3)) .AND. kuser_loc(4) ) THEN
              ky_lo = ky_hi - 0.4*(ky_hi_def - ky_lo_def)
           ELSEIF (kuser_loc(3) .AND. (.NOT.kuser_loc(4)) ) THEN
              ky_hi = ky_lo + 0.4*(ky_hi_def - ky_lo_def)
           ENDIF
	   y_inc = 0.1 * (ky_hi - ky_lo)

* When not kuser_loc, we will use the default locations

        ELSE
           kx_lo = kx_lo_def
           kx_hi = kx_hi_def
           ky_lo = ky_lo_def
           ky_hi = ky_hi_def
	   y_inc = 0.25 * (ky_hi - ky_lo)
        ENDIF

	x_inc = (kx_hi - kx_lo)/MAX (1.0, real (shd_levels))
        
        x_inc_inf = x_inc

! IF (INF) levels, force triangles to be at least 5% of length of colorbar

        IF (neginf .AND. posinf) THEN
           IF (shd_levels .GT. ncount) THEN 
              x_inc_inf = frac* (kx_hi - kx_lo)
              x_inc = (1.-2.*frac)*(kx_hi - kx_lo)/ REAL(shd_levels-2)
              kx_lo = kx_lo + (x_inc_inf-x_inc)
           ENDIF
           IF (shd_levels .EQ. 1) THEN
              x_inc = x_inc/2.
              x_inc_inf = x_inc
           ENDIF
        ELSEIF (neginf .OR. posinf) THEN
           IF (shd_levels .GT. ncount) THEN 
              x_inc_inf = frac* (kx_hi - kx_lo)
              x_inc = (1.-frac)*(kx_hi - kx_lo)/ REAL(shd_levels-1)
              IF (neginf) kx_lo = kx_lo + (x_inc_inf-x_inc)
           ENDIF
        ENDIF

* Don't draw lines between color levels when they will be too close together (see ticket 1535)

c	inc_min = 50
c	no_lines = .FALSE.
c	IF ( (x_inc .LT. inc_min) .AND. (INT(0.5 + inc_min/x_inc) .GE. 2) ) no_lines = .TRUE.
c	IF ( (INT(0.5 + inc_min/x_inc) .GE. 2) ) no_lines = .TRUE.
c	IF ( no_lines ) cont_key = .TRUE.

*	SET CHARACTER HEIGHT IN WORLD COORDINATES, AND INCR INDEX

* make sure there is a space between one label and the next
	 max_len = max_len+1  

	if (klab_incr .eq. 0) then
           IF (width/vwidth .GT. 1.5) incr = 2*incr
	end if

	karht = AMIN1 (0.1*1000.0,
     .		1.0*x_inc*real(incr)/real(max_len))/1000.0
        ksize_test = 0.
	if (klab_size .NE. 0) karht = ABS(klab_size)  

* Is there room for the labels at their current size?
* If not adjust the size and/or increment

        IF (incr .GT. 0) THEN

	   xx1 = (kx_lo + x_inc*real(lev1-1))/1000.0 - xorg
	   xxn = (kx_lo + x_inc*real(shd_levels))/1000.0
     .		 + karht*real(max_len) - xorg
	   xxlen = xxn-xx1
	   nlab = INT( 0.5+(shd_levels-lev1)/incr )
	
	   IF (nlab*max_len*karht .GT. xxlen) THEN
	      karht = 0.85*xxlen/FLOAT(nlab*max_len)
	   ENDIF

	   ksiz_test = 0.06
           IF (klab_size .NE. 0) THEN
	      IF (ABS(klab_size) .LT. ksiz_test) ksiz_test = ABS(klab_size)
	   ENDIF

	   IF (karht .LT. ksiz_test) THEN
	      incr = incr*1.5
	      nlab = INT( 0.5+(shd_levels-lev1)/incr )
	      karht = 0.85*xxlen/FLOAT(nlab*max_len)
	   ENDIF

	   ksiz_test = 0.075
           IF (klab_size .NE. 0) ksiz_test = ABS(klab_size)
	   kount = 0
	   DO WHILE (karht .LT. ksiz_test .AND. karht.GT.0. .AND. kount.LT.10)
	      incr = incr+1
	      nlab = INT( 0.5+(shd_levels-lev1)/incr )
	      karht = 0.85*xxlen/FLOAT(nlab*max_len)
	      kount = kount + 1
	   ENDDO
	   IF (karht .GT. ksiz_test) karht = ksiz_test
	ENDIF

* Use angled labels and label each one. 
* (Could use this for numeric labels that run together too...)

	IF (string_labs .AND. incr.GT.1) THEN
	   incr = 1
	   karht = 0.07
	   center_add = 0.
	   keylab_angl = 30.
	ENDIF

*	GENERATE THE KEY FOR EACH COLOR/SHADE
	max_len = 0
	IF (string_labs) THEN
	   text = colorkey_labs(lev1)
	   str_len = TM_LENSTR1(text)
	   istr_max = lev1
	ELSE
	   val = val_lab(lev1)
	   IF (TM_FPEQ_SNGL(val,0.) .AND. check_0) val = 0.
	   text = TM_FMT_SNGL (val,lab_digits,klab_len+lab_add,str_len)  
	ENDIF
        if (max_len .lt. str_len) max_len = str_len
        
        nhi = MAX(2,shd_levels+1)
	do 10 ndx = 2, nhi
	   px(1) = kx_lo + real (ndx - 2) * x_inc
	   px(2) = kx_lo + real (ndx - 2) * x_inc
	   px(3) = kx_lo + real (ndx - 1) * x_inc
	   px(4) = kx_lo + real (ndx - 1) * x_inc

	   py(1) = ky_hi
	   py(2) = ky_hi - 4.0 * y_inc 
	   py(3) = ky_hi - 4.0 * y_inc
	   py(4) = ky_hi

           IF (kuser_loc(3) .OR. kuser_loc(4)) THEN
              py(2) = ky_lo
              py(3) = ky_lo
              py(1) = ky_hi
              py(4) = ky_hi
           ENDIF

           IF ( (ndx.EQ.2) .AND. (annotate_key.EQ.1) .AND. 
     .          (.NOT.neginf) ) CALL key_annotate 
     .          (kpx, kpy, lab_digits, karht, 1, 2)

           IF ( (ndx.EQ.nhi) .AND. (annotate_key.EQ.1) .AND.
     .          (.NOT.posinf) ) CALL key_annotate 
     .          (kpx, kpy, lab_digits, karht, 2, 2)

           IF (neginf .AND. (ndx .EQ. 2) ) THEN
              CALL key_lo_inf_horz (kpx, kpy, ndx, x_inc_inf, 
     .          annotate_key, lab_digits, karht)
              IF (posinf .AND. shd_levels.EQ.1) THEN
                 DO i = 1,4
                 px(i) = px(i) + x_inc
                 ENDDO
                 CALL key_hi_inf_horz (kpx, kpy, ndx, x_inc_inf, 
     .             annotate_key, lab_digits, karht)
              ENDIF

           ELSE IF (posinf .AND. (ndx .EQ. nhi) ) THEN
              CALL key_hi_inf_horz (kpx, kpy, ndx, x_inc_inf, 
     .          annotate_key, lab_digits, karht)

           ELSE

*	   CALL FILL AREA FOR THIS COLOR/GRAY VALUE
	   call set_fill_ndx (ndx)
	   call gfa (4,px,py)

*	   TO RETAIN ABILITY FOR COLOR OR HATCHING IN METAFILE, WRITE 
*	   NDX TO PRIVATE ITEM -- forget it 10.22
*	   if (meta_actv .and. .not. area_bundles) call meta_fill_ndx (ndx)

	   kpx(5) = kpx(1)
	   kpy(5) = kpy(1)

	   IF (.NOT. cont_key) call gpl (5,kpx,kpy)

           ENDIF ! neginf or posinf

           IF (ndx .GE. lev1 .AND. ndx .LE. levn) THEN

              IF (string_labs) THEN
                 text = colorkey_labs(ndx)
                 str_len = TM_LENSTR1(text)
		 IF (max_len .LT. str_len) istr_max = ndx
              ELSE
                 val = val_lab(ndx)
                 IF (TM_FPEQ_SNGL(val,0.) .AND. check_0) val = 0.
	         text = TM_FMT_SNGL (val,lab_digits,klab_len+lab_add,str_len)   
              ENDIF
	      IF (max_len .LT. str_len) max_len = str_len
           ENDIF
10	continue

        IF (incr .GT. 0) THEN

* Incr etc may have changed, so set of labels written could be different.
* Recompute the decimal digits and max_len as formatted for these labels.

	IF (string_labs) THEN
	   buff = colorkey_labs(istr_max)
	   max_len = TM_LENSTR1(text)
	   wid = 0.5* karht
	ELSE

	   num_dec = 0
	   DO ndx = lev1+incr, shd_levels, incr
              val = val_lab(ndx)
              IF (center_key_labels .AND. ndx.GE.shd_levels) EXIT ! from loop
              IF (TM_FPEQ_SNGL(val,0.) .AND. check_0) val = 0.
	      buff = TM_FMT_SNGL (val,lab_digits,klab_len+lab_add,str_len)
              i = INDEX(buff, '.')
              IF (i .GT. 0) num_dec = MAX(num_dec, str_len-i)
	   ENDDO

	   max_len = 0

	   DO ndx = lev1+incr, shd_levels, incr
              val = val_lab(ndx)
	      IF (center_key_labels .AND. ndx.GE.shd_levels) EXIT ! from loop

              IF (TM_FPEQ_SNGL(val,0.) .AND. check_0) val = 0.
	      buff = TM_FMT_SNGL (val,lab_digits,klab_len+lab_add,str_len)
              i = INDEX(buff, '.')
              i_dec = -1
              IF (i .GT. 0) i_dec = str_len-i
              IF (i_dec.LT.num_dec) str_len = str_len + num_dec-i_dec

              IF (max_len .lt. str_len) THEN
	         max_len = str_len
	         txt_out = buff
	      ENDIF
	   ENDDO

	ENDIF


	shd_lev_hi = shd_levels+1
	IF (center_key_labels .AND. posinf) shd_lev_hi = shd_levels

	do 20 ndx = lev1,shd_lev_hi,incr

*	   WRITE OUT CORRESPONDING VALUE

	   IF (string_labs) THEN
              text = colorkey_labs(ndx)
              str_len = TM_LENSTR1(text)
	   ELSE
	      val = val_lab(ndx)
	      IF (center_key_labels .AND. ndx.GE.shd_lev_hi) EXIT ! from loop
	      IF (TM_FPEQ_SNGL(val,0.) .AND. check_0) val = 0.
	      text = TM_FMT_SNGL (val,lab_digits,klab_len+lab_add,str_len)
	   ENDIF
	   IF (ndx .EQ. 1 .AND. neginf) text = " "
	   IF (ndx .EQ. levn+1 .AND. posinf) text = " "
	     
* Add a .0 with the right number of 0's if the other labels have 
* decimal-point .xx but this one does not

	   IF (.NOT. string_labs .AND. num_dec.GT.0 .AND. 
     .         INDEX(text, 'E').EQ.0 .AND. TM_LENSTR(text).GT.0) THEN

	      IF (INDEX(text, '.') .EQ. 0) THEN
	         text = text(:TM_LENSTR1(text))//'.0'
	         IF (num_dec .GT. 1) THEN
	            DO i = 2,num_dec
		       text = text(:TM_LENSTR1(text))//'0'
	            ENDDO
	         ENDIF

	      ELSE IF (str_len.LT.max_len .AND. INDEX(text, 'E').EQ.0) THEN
	         maxstr = max_len
		 IF (have_neg .AND. val .GE. 0.) maxstr = maxstr - 1
		 
		 i = INDEX(text, '.')
		 i_dec = 0
		 IF (i .GT. 0) i_dec = str_len-i

	         DO i = i_dec+1, num_dec
		    text = text(:TM_LENSTR1(text))//'0'
	         ENDDO 
		 
	      ENDIF
   
	   ENDIF
	   str_len = TM_LENSTR(text)

	   IF (keylab_angl .EQ. 0.) THEN
	      xx = (kx_lo + x_inc*(center_add+real(ndx-1)))/1000.0
     .		 - karht*real(str_len)/2.0 - xorg
	   ELSE
	      xx = (kx_lo + x_inc*(real(ndx-1)))/1000.0 + karht - xorg
	   ENDIF
	   yy = (ky_hi - 5.0 * y_inc)/1000.0 - yorg - 1.5*karht
           IF (kuser_loc(3) .OR. kuser_loc(4) ) 
     .            yy = (ky_lo - y_inc)/1000.0-yorg-1.5*karht

* If klab_size negative put the key labels on the top rather than the 
* bottom of the key

           IF (klab_size .LE. 0) THEN
              yy = (ky_hi)/1000.0 - yorg + karht
           ENDIF

*	   FILL AND SHADE USE DIFFERENT COORD SYSTEMS -- *jd* 6.4.93
	   if (makep .eq. 'SHADE' .or. makep .eq. 'FILLPOL' .OR.
     .         makep .EQ. 'POLYGON' .or. makep .eq. 'RIBPLOT') then
	      call point_convert (xx,yy,xxx,yyy)
	   else if (makep .eq. 'FILL') then
	      xxx = xx
	      yyy = yy
	   endif

	   call symbel (xxx,yyy,keylab_angl,karht,str_len,text(1:str_len))

20	continue
        ENDIF

*  Set these to actual locations that were used for PPL LIST SHAKEY
        ky_hi = py(1)
        ky_lo = py(2)

	goto 2000

*	MAKE A VERTICAL KEY 
1000	CONTINUE

* Define default x and y lo and hi locations


        if (ppl_in_ferret) then
           call get_view_size (vwidth,vheight,is_viewport)

           IF (ITSA_AXIS_VIEW(1)) vwidth = (xlen + xorg )* 1.15
           if (vwidth .le. xlen + xorg) goto 2000

	   rem = vwidth - (xlen + xorg)
	   xmaxx = 0.25*xlen
c	   xmaxx = 0.15*xlen

           kx_lo_def = 1000.0 * (xorg + xlen + 0.2*min (rem,xmaxx))
           kx_hi_def = 1000.0 * min (xorg + xlen + xmaxx,vwidth-0.08*rem)
           ky_lo_def = 1000.0 *  yorg
           ky_hi_def = 1000.0 * (yorg + ylen)
        else
	   rem = width - (xlen + xorg)
	   xmaxx = 0.25*xlen
c	   xmaxx = 0.15*xlen
           kx_lo_def = 1000.0 * (xorg + xlen + 0.2*min (rem,xmaxx))
           kx_hi_def = 1000.0 * min (xorg + xlen + xmaxx,width-0.08*rem)
           ky_lo_def = 1000.0 *  yorg
           ky_hi_def = 1000.0 * (yorg + ylen)
        end if

        IF (kuser_loc(1) .OR. kuser_loc(2) .OR. 
     .      kuser_loc(3) .OR. kuser_loc(4)) THEN  

! Some or all of kx_lo,kx_hi,ky_lo,ky_hi  are already set

           IF ((.NOT.kuser_loc(1)) .AND. (.NOT.kuser_loc(2))) THEN
              kx_lo = kx_lo_def
              kx_hi = kx_hi_def
           ELSEIF ((.NOT.kuser_loc(1)) .AND. kuser_loc(2) ) THEN
              kx_lo = kx_hi - 0.4*(kx_hi_def - kx_lo_def)
           ELSEIF (kuser_loc(1) .AND. (.NOT.kuser_loc(2)) ) THEN
              kx_hi = kx_lo + 0.4*(kx_hi_def - kx_lo_def)
           ENDIF 

           IF ((.NOT.kuser_loc(3)) .AND. (.NOT.kuser_loc(4))) THEN
              ky_lo = ky_lo_def
              ky_hi = ky_hi_def
           ELSEIF ((.NOT.kuser_loc(3)) .AND. kuser_loc(4) ) THEN
              ky_lo = ky_hi - (ky_hi_def - ky_lo_def)
           ELSEIF (kuser_loc(3) .AND. (.NOT.kuser_loc(4)) ) THEN
              ky_hi = ky_lo + (ky_hi_def - ky_lo_def)
           ENDIF 

* When not kuser_loc, we will use the default locations

        ELSE
           kx_lo = kx_lo_def
           kx_hi = kx_hi_def
           ky_lo = ky_lo_def
           ky_hi = ky_hi_def
        ENDIF

	x_inc = 0.1 * (kx_hi - kx_lo)
	y_inc = (ky_hi - ky_lo)/MAX (1.0, REAL (shd_levels))

        y_inc_inf = y_inc

! IF (INF) levels, force triangles to be at least 5% of length of colorbar

        IF (neginf .AND. posinf) THEN
           IF (shd_levels .GT. ncount) THEN 
              y_inc_inf = frac* (ky_hi - ky_lo)
              y_inc = (1.-2.*frac)*(ky_hi - ky_lo)/ REAL(shd_levels-2)
              ky_lo = ky_lo + (y_inc_inf-y_inc)
           ENDIF
           IF (shd_levels .EQ. 1) THEN
              y_inc = y_inc/2.
              y_inc_inf = y_inc
           ENDIF
        ELSE IF (neginf .OR. posinf) THEN
           IF (shd_levels .GT. ncount) THEN 
              y_inc_inf = frac* (ky_hi - ky_lo)
              y_inc = (1.-frac)*(ky_hi - ky_lo)/ REAL(shd_levels-1)
              IF (NEGINF) ky_lo = ky_lo + (y_inc_inf-y_inc)
           ENDIF
        ENDIF

* Don't draw lines between color levels when they will be too close together (see ticket 1535)

c	inc_min = 50
c	no_lines = .FALSE.
c	IF ( (y_inc .LT. inc_min) .AND. (INT(0.5 + inc_min/y_inc) .GE. 2) ) no_lines = .TRUE.
c	IF ( (INT(0.5 + inc_min/y_inc) .GE. 2) ) no_lines = .TRUE.
c	IF ( no_lines ) cont_key = .TRUE.

*	SET CHARACTER HEIGHT IN WORLD COORDINATES, AND INCR INDEX
        if (klab_size .eq. 0.0) then
	   karht = AMIN1 (0.10*1000.0,500.0*rem/real(max_len))/1000.0
	else
	   karht = ABS(klab_size)
	end if

	if (klab_incr .eq. 0) then
           IF (height/vheight.GT.1.5 .AND. shd_levels.GT.4) incr = 2*incr   ! short plot, fewer labels
	end if

*	GENERATE THE KEY FOR EACH COLOR/SHADE
	max_len = 0

        IF (string_labs) THEN
           text = colorkey_labs(lev1)
           str_len = TM_LENSTR1(text)
	   IF (max_len .LT. str_len) istr_max = lev1
        ELSE
           val = val_lab(lev1)
           IF (TM_FPEQ_SNGL(val,0.) .AND. check_0) val = 0.
	   text = TM_FMT_SNGL (val,lab_digits,klab_len+lab_add,str_len)
        ENDIF

	if (max_len .lt. str_len) max_len = str_len	

        nhi = MAX(2,shd_levels+1)
	do 1010 ndx = 2, nhi
	   px(1) = kx_lo
	   px(2) = kx_lo + 4.0*x_inc
	   px(3) = kx_lo + 4.0*x_inc
	   px(4) = kx_lo

           IF ( kuser_loc(1) .OR. kuser_loc(2)) THEN
              px(1) = kx_lo
              px(4) = kx_lo
              px(2) = kx_hi
              px(3) = kx_hi
           ENDIF

	   py(1) = ky_lo + real (ndx - 2) * y_inc
	   py(2) = ky_lo + real (ndx - 2) * y_inc
	   py(3) = ky_lo + real (ndx - 1) * y_inc
	   py(4) = ky_lo + real (ndx - 1) * y_inc

           IF ( (ndx.EQ.2) .AND. (annotate_key.EQ.1) .AND.
     .          (.NOT. neginf) ) CALL key_annotate 
     .          (kpx, kpy, lab_digits, karht, 1, 1)

           IF ( (ndx.EQ.nhi) .AND. (annotate_key.EQ.1) .AND.
     .          (.NOT. posinf) ) CALL key_annotate 
     .          (kpx, kpy, lab_digits, karht, 2, 1)

           IF (neginf .AND. (ndx .EQ. 2) ) THEN
              CALL key_lo_inf_vert (kpx, kpy, ndx, y_inc_inf, 
     .          annotate_key, lab_digits, karht)
              IF (posinf .AND. shd_levels.EQ.1) THEN
                 DO i = 1, 4
                 py(i) = py(i) + y_inc
                 ENDDO
                 CALL key_hi_inf_vert (kpx, kpy, ndx, y_inc_inf, 
     .             annotate_key, lab_digits, karht)
              ENDIF
     
           ELSE IF (posinf .AND. (ndx .EQ. nhi) ) THEN
              CALL key_hi_inf_vert (kpx, kpy, ndx, y_inc_inf, 
     .          annotate_key, lab_digits, karht)

           ELSE

*	   CALL FILL AREA FOR THIS COLOR/GRAY VALUE
	      call set_fill_ndx (ndx)
	      call gfa (4,px,py)

*	   TO RETAIN ABILITY FOR COLOR OR HATCHING IN METAFILE, WRITE 
*	   NDX TO PRIVATE ITEM - forget it 10.22
*	   if (meta_actv .and. .not. area_bundles) call meta_fill_ndx (ndx)

              kpx(5) = kpx(1)
              kpy(5) = kpy(1)

              IF (.NOT. cont_key) call gpl (5,kpx,kpy)

           ENDIF ! neginf or posinf

           IF (ndx .GE. lev1 .AND. ndx .LE. levn) THEN
              
	      IF (string_labs) THEN
	         text = colorkey_labs(ndx)
	         str_len = TM_LENSTR1(text)
		 IF (max_len .LT. str_len) istr_max = ndx
	      ELSE
	         val = val_lab(ndx)
	         IF (TM_FPEQ_SNGL(val,0.) .AND. check_0) val = 0.
	         text = TM_FMT_SNGL (val,lab_digits,klab_len+lab_add,str_len)
	      ENDIF
	      if (max_len .lt. str_len) max_len = str_len

           ENDIF
1010	continue

        ystart = 0.
        IF (lev1 .NE. 1) ystart = y_inc

        IF (incr .GT. 0) THEN

* Would the labels be squished vertically?  increase the increment as needed  
* Diff yheight from one label to the next is FLOAT(incr)* y_inc/1000.0)

	IF ( klab_incr .EQ. 0 )  THEN 
	   yy = FLOAT(incr)* y_inc/1000.0
	   DO WHILE ( FLOAT(incr)* y_inc/1000.0 .LT. 2.*karht )
	      incr = 2*incr
	   ENDDO
	ENDIF

	shd_lev_hi = shd_levels+1
	IF (center_key_labels .AND. posinf) shd_lev_hi = shd_levels

* Incr etc may have changed, so set of labels written could be different.
* Recompute the decimal digits and max_len as formatted for these labels.

	IF (string_labs) THEN
	   buff = colorkey_labs(istr_max)
	   max_len = TM_LENSTR1(text)
	   wid = 0.5* karht
	ELSE


	   num_dec = 0
	   DO ndx = lev1+incr, shd_levels, incr
              val = val_lab(ndx)
c              IF (center_key_labels .AND. ndx.GE.shd_levels) EXIT ! from loop	
              IF (TM_FPEQ_SNGL(val,0.) .AND. check_0) val = 0.
	      buff = TM_FMT_SNGL (val,lab_digits,klab_len+lab_add,str_len)
              i = INDEX(buff, '.')
              IF (i .GT. 0) num_dec = MAX(num_dec, str_len-i)
	   ENDDO

	   have_neg = .FALSE.
	   max_len = 0

	   DO ndx = lev1+incr, shd_levels, incr
              val = val_lab(ndx)

              IF (TM_FPEQ_SNGL(val,0.) .AND. check_0) val = 0.
	      buff = TM_FMT_SNGL (val,lab_digits,klab_len+lab_add,str_len)
              i = INDEX(buff, '.')
              i_dec = -1
              IF (i .GT. 0) i_dec = str_len-i
              IF (i_dec.LT.num_dec) str_len = str_len + num_dec-i_dec

              IF (max_len .lt. str_len) THEN
	         max_len = str_len
	         txt_out = buff
	      ENDIF
	      have_neg = have_neg .OR. val.LT.0 
	   ENDDO

! Use SYMWID to right-justify numeric labels

           txt_out = buff(:max_len)//'X'   ! extra space between key and label
           wid = SYMWID(karht,max_len+1,txt_out(:max_len))
	ENDIF

! Set xpos = position of end of string, right-justify from there.

        xpos = kpx(2)/ 1000.0 - xorg

* Keep the labels from running off the edge
        IF (have_neg) THEN
           xpos = xpos - 0.2*karht
           IF (klab_size.EQ.0) karht = 0.9*karht
        ENDIF

        IF ((kuser_loc(1) .OR. kuser_loc(2))) xpos = (kx_hi + x_inc)/ 1000. - xorg

* Set up to right-justify the labels, moving xpos to the rightmost position.

	ndx = max_len

        buff = 'X'
        DO i = 1, ndx
           buff = buff(:i)//'X'   ! extra space between key and label
        ENDDO

        wid = SYMWID(karht,ndx,buff(:ndx))
        xpos = xpos + wid

* If klab_size negative put the key  on the left rather than 
* the right of the keylabels

        IF (klab_size .LT. 0) THEN
           wid = SYMWID(karht,1,'X')
           xpos = kx_lo/1000.0 - xorg - wid
        ENDIF

* If the user set the label size, leave it. If we are drawing in a viewport,
* leave the label sizes as-is.  The user can control whether the labels may
* run into the next viewport or a margin. Otherwise make labels smaller to 
* try to fit them on the page.

        IF (klab_size.EQ.0 .AND. .NOT.is_viewport .AND. xpos+xorg.GT.vwidth) THEN

           ic = 0
           DO WHILE (xpos+xorg .GT. vwidth .AND. ic.LT.5)

              xp = kpx(2)/ 1000.0 - xorg
              IF ((kuser_loc(1) .OR. kuser_loc(2))) xp = (kx_hi + x_inc)/ 1000. - xorg
              karht = 0.9* karht
	      
              wid = SYMWID(karht,max_len,buff(:max_len))
              xp = xp + wid
              ic = ic + 1
              IF (karht .LT. 0.06) THEN 
		    xp = vwidth - xorg - 0.1*karht
		    EXIT ! from loop
              ENDIF
	      xp = kpx(2)/ 1000.0 - xorg

           ENDDO


           xpos = kpx(2)/ 1000.0 - xorg + wid
	ENDIF

c	IF (klab_size.EQ.0 .AND. karht .LT. 0.05) THEN
c	   karht = 0.07
c	   IF (center_key_labels) center_add = 0.8
c	   keylab_angl = -50.
c	ENDIF

        do 1020 ndx = lev1,shd_lev_hi,incr
*	   WRITE OUT CORRESPONDING VALUE
	   	         
	   IF (string_labs) THEN
	      text = colorkey_labs(ndx)
	      str_len = TM_LENSTR1(text)
	   ELSE
	      val = val_lab(ndx)
	      IF (center_key_labels .AND. ndx.GE.shd_lev_hi) EXIT ! from loop
	      IF (TM_FPEQ_SNGL(val,0.) .AND. check_0) val = 0.
	      text = TM_FMT_SNGL (val,lab_digits,klab_len+lab_add,str_len)
	   ENDIF
	   IF (ndx .EQ. 1 .AND. neginf) text = " "
	   IF (ndx .EQ. levn+1 .AND. posinf) text = " "

* Add a .0 with the right number of 0's if the other labels have 
* decimal-point .xx but this one does not. Add trailing 0's for 
* non-scientific-notation numbers so they're all the same length.

	   IF (.NOT.string_labs .AND. num_dec.GT.0 .AND. 
     .         INDEX(text, 'E').EQ.0 .AND. TM_LENSTR(text).GT.0) THEN
	      IF (INDEX(text, '.') .EQ. 0) THEN
	         text = text(:TM_LENSTR1(text))//'.0'
	         IF (num_dec .GT. 1) THEN
	            DO i = 2,num_dec
		       text = text(:TM_LENSTR1(text))//'0'
	            ENDDO
	         ENDIF

	      ELSE IF (str_len.LT.max_len .AND. INDEX(text, 'E').EQ.0) THEN
	         maxstr = max_len
		 IF (have_neg .AND. val .GE. 0.) maxstr = maxstr - 1
		 
		 i = INDEX(text, '.')
		 i_dec = 0
		 IF (i .GT. 0) i_dec = str_len-i

	         DO i = i_dec+1, num_dec
		    text = text(:TM_LENSTR1(text))//'0'
	         ENDDO 
		 
	      ENDIF
   
	   ENDIF
	   str_len = TM_LENSTR(text)

* Right-justify them.

	   txt_out = text
	   wid = SYMWID(karht,str_len,txt_out)
	   IF (string_labs) wid = 0.
	   xx = xpos - WID

	   yy = ( ky_lo + y_inc* (center_add+ real(ndx-1)) )/1000.0 - 
     .        yorg - 0.5*karht

*	   FILL AND SHADE USE DIFFERENT COORD SYSTEMS -- *jd* 6.4.93

	   if (makep .eq. 'SHADE' .or. makep .eq. 'FILLPOL' .OR.
     .         makep .EQ. 'POLYGON' .or. makep .eq. 'RIBPLOT') then
              call point_convert (xx,yy,xxx,yyy)
	   else if (makep .eq. 'FILL') then
	      xxx = xx
	      yyy = yy
	   endif
	   call symbel (xxx,yyy,keylab_angl,karht,str_len,txt_out(1:str_len))

1020	continue
        ENDIF

*  Set these to actual locations that were used for PPL LIST SHAKEY
        kx_lo = px(1)
        kx_hi = px(2)

2000	windof = windof_hold
	cont_key = cont_key_keep

* Restore axis-type settings
	itypex = itypex_save
	itypey = itypey_save

* Undo the shift for centered-key-levels, so overlays are done right

	IF (center_key_labels) CALL SET_LEVELS_CENTERKEY (.FALSE.)

	keylab_angl = 0.

	return
	end

	SUBROUTINE TM_allo_tmp_grid( grid, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* Allocate a temporary grid from the dynamic grid area (above max_grids)

* Steve Hankin  NOAA/PMEL/TMAP

* V510 *sh* 3/00 - guts of routine in  TM_ALLO_DYN_GRID_SUB
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing

* Include files
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
	include 'tmap_errors.parm'
	include 'xtm_grid.cmn_text'
	include 'xbuild_grids.cmn'

* Argument definitions
	INTEGER grid, status

* Local variable definitions
	INTEGER	idim

	CALL TM_ALLO_DYN_GRID_SUB( tmp_grid_hook, grid, status )
	IF ( status .NE. merr_ok) RETURN

* initialize grid to null state
	grid_name(grid) = char_init16
	grid_rotation (grid) = real4_init 
	DO 100 idim = 1, nferdims
	   grid_line(idim,grid) = int4_init
	   grid_out_prod(idim,grid) = .FALSE.
 100	CONTINUE

* save a pointer to temporary name storage needed during grid creation
	num_tmp_grids = num_tmp_grids + 1
	tmp_nam_ptr(grid) =  num_tmp_grids

	RETURN
	END

	subroutine init(nme,key,n)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)init.F	1.1    3/10/88
C** v552 *acm* 3/03 Longer strings: changes for multi-line labels.
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
c
c	vax/vms version of init
c
c	d. denbo   january 85
c
#ifdef unix
	character key(1)*5,nme(1)*81,line*2048,yn*3
	ic=iargc()
	if(ic.gt.0)then
	call getarg(1,line)
	else
	line=' '
	endif
	istp=2048
#else
	character key(1)*5,nme(1)*81,line*2048,cr*1,esc*1,yn*3
	byte buf(2048),crb,escb
	equivalence (line,buf(1)),(cr,crb),(esc,escb)
	integer*4 lib$get_foreign,istat
	data crb/13/,escb/27/
	istat=lib$get_foreign(line,,)
	istp=index(line,cr)
	if(istp.eq.0)istp=index(line,esc)
	if(istp.eq.0)istp=2048
#endif
	line(istp:istp)=' '
	is=1
100	k=index(line,'=')
	if(k.le.0.or.k.ge.istp)goto 200
	line(k:k)=' '
	do 10 i=1,n
	if(key(i).eq.line(is:k-1))goto 11
10	continue
	i=n+1
11	if=0
	do 20 j=k+1,istp
	if(line(j:j).eq.'[')then
	    if=1
	    ibrk=index(line(j:),']')+j-1
	    icma=index(line(j:),',')+j-1
	    if(icma.gt.ibrk)if=0
	endif
	if(line(j:j).eq.','.and.if.eq.1)then
	if=0
	goto 20
	endif

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*       *jd* if stmt below placed entirely within ifdef for MAC 7.92 

#ifdef unix
	if(line(j:j).eq.','.or.line(j:j).eq.' '
     *	.or.line(j:j).eq.':')goto 21
#else
	if(line(j:j).eq.','.or.line(j:j).eq.' '
     *	.or.line(j:j).eq.'/')goto 21
#endif

20	continue
21	if(i.le.n)nme(i)=line(k+1:j-1)
	is=j+1
	goto 100
#ifdef unix
200	k=index(line,':')
#else
200	k=index(line,'/')
#endif
	if(k.le.0.or.k.ge.istp)return
	line(k:k)=' '
	if(line(k+1:k+1).eq.'-')then
	k=k+2
	yn='no'
	else
	k=k+1
	yn='yes'
	endif
	do 30 j=k,istp

*       *jd* as above

#ifdef unix
	if(line(j:j).eq.' '.or.line(j:j).eq.','
     *	.or.line(j:j).eq.':')goto 31
#else
	if(line(j:j).eq.' '.or.line(j:j).eq.','
     *	.or.line(j:j).eq.'/')goto 31
#endif
30	continue
31	do 40 i=1,n
	if(key(i).eq.line(k:j-1))goto 41
40	continue
	goto 200
41	nme(i)=yn
	goto 200
	end

	SUBROUTINE TM_NEXT_VER_NAME ( name, vernam, path )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine the name for the next version of this file
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for DECstation computer under Ultrix and VMS operating systems
*
* rev 0.0 -   5/6/91
* rev 1.0 -   10/17/91  -- <kob>
*                      - modified to pass the specified path to tm_c_ver_name
*                        to allow searching for files in directories other
*                        than just the current one.
*  Sun Port 1/30/92 -kob-  added 'ifdef sun' because SUN uses BYTE where DECstation uses
*                          INTEGER*1
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* calling argument declarations:
        CHARACTER*(*) name, vernam, path

* internal variable declarations:
	INTEGER	nlen
        INTEGER TM_LENSTR1

        include 'tmap_errors.parm'

        INTEGER slen,plen
        PARAMETER  ( slen = 128 )
#ifdef sun
        BYTE      nhol(slen), vhol(slen),phol(slen) ! c-type Hollerith string buffers
#else
        INTEGER*1 nhol(slen), vhol(slen),phol(slen) ! c-type Hollerith string buffers
#endif

* initialize
        nlen = TM_LENSTR1(name)
        plen = TM_LENSTR1(path)

* translate to null-terminated c-type strings
        CALL TM_FTOC_STRNG( name  (:nlen), nhol, slen )
        CALL TM_FTOC_STRNG( path  (:plen), phol, slen)

* call c-written routine to determine next version name from directory
* pass in path so that search is not limited to current directory 10/17/91
        CALL TM_C_VER_NAME( nhol, vhol, phol )

* translate new version name to FORTRAN style
        CALL TM_CTOF_STRNG( vhol, vernam, slen )

	RETURN
	END

	SUBROUTINE SETFONT(fontdir,dirlen,dname,ifont,ii,kif,dnme,
     .               ifn,dnum,itype,dtype,iflen, dlen,ioff,
     .               icnt,ascii,base,rast,iadd,
     .		     sx,sy,id)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Created 1.28.97 *kob*
*
*	Code in this routine taken from old pplmod_symbel.F routine.  This
*	was necessary to reorganize the symbel routine to remove an illegal
*	forward reference into a do loop.  This routine makes the 
*	pplmod_symbel a little cleaner.  This change has 
*	occurred in the middle of releasing v4.45 of 
*	Ferret to the world.  Aix, Sgi, HP, OSF and SunOs
*	have already been released, and this change is
*	not a part of them.
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 

	DIMENSION SX(12000),SY(12000),ASCII(127,4),BASE(4),RAST(4)
	DIMENSION DTYPE(35),DLEN(35),IOFF(4),IFLEN(4),ITYPE(4)
C
	LOGICAL SYMROT,READIR,PLOT,COLRF
c	CHARACTER PLTFIL*80
	CHARACTER ICOM*2,ICHR*1,STRING*120,DNME(35)*(*),DNUM(35)*(*)
	CHARACTER DNAME(35)*(*),KIF(4)*(*),IFN(4)*(*)
	CHARACTER*1 KSUB,KSUPER,KBKSP,KCALL,PENS(16)

* 1/03 *kob* - Add temp character buffer for g77 arbitrary text
*              concatenations
	CHARACTER*2048 temp_charbuff

#ifdef unix
	INTEGER*2 SX,SY

        integer       dirlen
        character*255 fontdir
#else
	byte sx,sy
#endif
	INTEGER*2 ICNT,IBASE,IRAST
*added for linux port
	INTEGER*4 IBASE4,IRAST4 
	INTEGER*2 ASCII
	INTEGER*2 DTYPE,DLEN,IOFF,IFLEN,ITYPE
	INTEGER COLOLD
	LOGICAL ASCFNT
	INTEGER TM_LENSTR1, tlen
C
C
	INCLUDE 'PLTCOM.DAT'


#ifdef unix
 1010	continue
* 1/03 *kob* 
	temp_charbuff = DNAME(id)
	OPEN(LUSY,FILE=fontdir(:dirlen)//'/'//temp_charbuff,STATUS='OLD',
     *	FORM='UNFORMATTED',ERR=5000)
#else
1010	open(lusy,file=dname(id),status='old',readonly,
     *	form='unformatted',err=5000)
#endif
C
C	SETUP FOR NEW FONT
C
	IFONT=II
	KIF(II)=DNME(ID)
	IFN(II)=DNUM(ID)
	ITYPE(II)=DTYPE(ID)
	IFLEN(II)=DLEN(ID)
C
C	SETUP IOFF
C
	IF(II.EQ.4)GOTO 1008
	DO 1007 IJ=II+1,4
	IOFF(IJ)=12000
	KIF(IJ)='@@'
	IFN(IJ)='@@'
1007	IFLEN(IJ)=0
	IOFF(II+1)=IOFF(II)+IFLEN(II)
C
C	READ NEW FONT
C
 1008	READ(LUSY,ERR=5010)ICNT,IBASE,IRAST
	IBASE4 = IBASE
	IRAST4 = IRAST
	READ(LUSY,ERR=5010)(ASCII(IJ,II),IJ=1,127)
	BASE(II)=FLOAT(IBASE4)
	RAST(II)=21./FLOAT(IRAST4)
	IADD=IOFF(II)+1
	READ(LUSY,ERR=5010)(SX(IJ),IJ=IADD,IADD+DLEN(ID)-1)
	READ(LUSY,ERR=5010)(SY(IJ),IJ=IADD,IADD+DLEN(ID)-1)
	CLOSE(LUSY)
	return

 5000	temp_charbuff = DNAME(ID)
	tlen = TM_LENSTR1(temp_charbuff)
	write(6,*) "setfont: Couldn't open font file:"//
     .               fontdir(:dirlen)//'/'//temp_charbuff(:tlen)
	stop
 5010	temp_charbuff = DNAME(ID)
	tlen = TM_LENSTR1(temp_charbuff)
	write(6,*) "setfont: Read error on font file:"//
     .               fontdir(:dirlen)//'/'//temp_charbuff(:tlen)
	stop
	end

	SUBROUTINE Z_HDIFFUS (	tk,   mtk,
     .				vdc,  mvdc,
     .				qflx, mqflx,
     .				qdif, mqdif )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute vertical component of heat diffussion using temperature at
* 3 layers (tkm,tk,tkp) and vertical diffussion coefficient at 2 (vdcM,vdc)
* and using surface boundary fluxes if at the surface

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/7/86	extracted from SUBROUTINE HDIFFUS
*			with major modifications to convert i-k oriented
*			calculations to i-j oriented calculations
* revision 0.1 - 6/25/87 - modified to include surface heat flux when k=1
* V200:  7/25/89 - 4D symmetrical version
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN
*	10/18/89 - fixed bug: lb4-->l on setting qdif to bad_flag while adding
*				      surface BC's
* Linux Port 1/97 *kob* - Added a preprocessor include for xgfdl_masks.cmn
*			  because it needed a preprocessor.
* V450 - 7/22/97 - minor reordering of "#includes" for Solaris compiler bug

#ifdef unix
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl.parm'		! parameter definitions

! land/water masks
#	include "xgfdl_masks.cmn"	

	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xonedim.cmn'	! geometric constants
	include 'xcontext.cmn'
#else
	INCLUDE 'FERRET_CMN:FERRET.PARM'
	INCLUDE 'FERRET_CMN:GFDL.PARM'		! parameter definitions
	INCLUDE	'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE	'FERRET_CMN:XMEM_SUBSC.CMN'
	INCLUDE 'FERRET_CMN:XONEDIM.CMN'	! geometric constants
	INCLUDE 'FERRET_CMN:XCONTEXT.CMN'
	INCLUDE 'FERRET_CMN:XGFDL_MASKS.CMN'	! land/water masks
#endif

* calling argument declarations:
	INTEGER	mtk, mvdc, mqflx, mqdif

* subscript ranges from memory variable table ...
	REAL      tk( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit ),
     .		 vdc( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,m2lot:m2hit ),
     .		qflx( m3lox:m3hix,m3loy:m3hiy,            m3lot:m3hit ),
     .		qdif( m4lox:m4hix,m4loy:m4hiy,m4loz:m4hiz,m4lot:m4hit )

* internal variable declarations:
	LOGICAL HOURLY_DATA, need_qflux
	INTEGER	i, j, k, l, dl, lb4
	REAL	bad_vdc, bad_tk, bad_qdiffus, bad_qflx, up_qdif, dn_qdif

* --- end of introductory code ---
* use 1 hour separation for exact results on hourly data
	IF ( HOURLY_DATA(mr_grid(mqdif)) ) THEN
	   dl = -1
	ELSE
	   dl = 0
	ENDIF

* flag(s) for bad or missing values
	bad_vdc      = mr_bad_data ( mvdc )
	bad_tk       = mr_bad_data ( mtk  )
	bad_qflx     = mr_bad_data ( mqflx )
	bad_qdiffus  = mr_bad_data ( mqdif )

* flag for surface heat flux
	DO 1100 l = mr_lo_s4(mqdif), mr_hi_s4(mqdif)
	DO 1100 k = mr_lo_s3(mqdif), mr_hi_s3(mqdif)

* components from 1 hour before ?
	lb4 = l + dl

	need_qflux = k .EQ. 1

	DO 1000 j = mr_lo_s2(mqdif), mr_hi_s2(mqdif)
	DO 1000 i = mr_lo_s1(mqdif), mr_hi_s1(mqdif)

* diffussion from above:
	IF     ( k .EQ. 1        ) THEN
	   up_qdif = 0.0			! top
	ELSEIF ( k .GT. kmt(i,j) ) THEN
	   up_qdif = 0.0			! bottom or below
	ELSE	

	   IF (vdc( i,j,k-1,lb4 ) .EQ. bad_vdc
     .	   .OR.	tk( i,j,k-1,lb4 ) .EQ. bad_tk
     .	   .OR. tk  ( i,j,k,lb4 ) .EQ. bad_tk ) THEN
	      qdif( i,j,k,l ) = bad_qdiffus
	      GOTO 1000
	   ENDIF

	   up_qdif = cmonthly * (
     *		 vdc(i,j,k-1,lb4)*EEH(K)
     .				*(tk(i,j,k-1,lb4) - tk(i,j,k,lb4)))! 3105 mod
	ENDIF

* diffussion to below:
	IF ( k .GE. kmt(i,j) ) THEN
	   dn_qdif = 0.0			! bottom or below
	ELSE

	   IF (	vdc( i,j,k,  lb4 ) .EQ. bad_vdc
     .	   .OR. tk ( i,j,k+1,lb4 ) .EQ. bad_tk ) THEN
	      qdif( i,j,k,l ) = bad_qdiffus
	      GOTO 1000
	   ENDIF

	   dn_qdif = cmonthly * (
     *		-VDC (i,j,k,lb4)*FFH(K)*(tk(i,j,k,lb4)-tk(i,j,k+1,lb4))) ! 3106 mod
	ENDIF

	qdif(i,j,k,l) = up_qdif + dn_qdif

* add in surface boundary flux if at surface
* (with units converted from cgs to deg/month over upper layer)
	IF ( need_qflux ) THEN
	   IF ( qflx(i,j,lb4) .EQ. bad_qflx ) THEN
	      qdif(i,j,k,l) = bad_qdiffus
	   ELSE
	      qdif(i,j,k,l) = qdif(i,j,k,l)
     .				 + 0.06265833*qflx(i,j,lb4)
	   ENDIF
	ENDIF

 1000	CONTINUE
 1100	CONTINUE

	RETURN
	END

	SUBROUTINE OPNPPL(EFILE,ELUN,DLUN,MLUN,CLUN,LTT,
     *			  KEY1,KEY2,EPLUN1,EPLUN2)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Mod to set SYM='*PPL$PLTNME' to metafile.plt by default *jd* 1.7.94
*	Mod to not reference "getlog" routine for linux port *kob* 3.11.97	
*       Mod to set SYM='*PPL$PLTNME' to value of meta_file *js* 7.25.97
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long
* v691 5/14 *acm* Change name MOD to TEKMOD
* v695 9/15 *acm* write values to PPL* symbols using 6 digits not 4
C**
C**    @(#)opnppl.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
c
c	efile  -- echo file name
c	elun   -- echo lun
c	dlun   -- data lun
c	mlun   -- mult file lun
c	clun   -- command file lun
c	ltt    -- terminal logical unit
c	key1   -- first key file lun
c	key2   -- second key file lun
c	eplun1 -- first EPIC lun
c	eplun2 -- second EPIC lun
c

        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'epiclun_inc.decl'
        include 'EPICLUN.INC'
        include 'axis_inc.decl'
        include 'AXIS.INC'
        include 'data_inc.decl'
        include 'DATA.INC'
        include 'cmrdl_inc.decl'
        include 'CMRDL.INC'
        include 'plt_inc.decl'
        include 'PLT.INC'
        include 'lines_inc.decl'
        include 'LINES.INC'
        include 'conlab_inc.decl'
        include 'CONLAB.INC'
        include 'labcom_inc.decl'
        include 'LABCOM.INC'
        include 'filnam_inc.decl'
        include 'FILNAM.INC'
        include 'lunits_inc.decl'
        include 'LUNITS.INC'
        include 'pen_inc.decl'
        include 'PEN.INC'
        include 'symkey_inc.decl'
        include 'SYMKEY.INC'
        include 'system_inc.decl'
        include 'SYSTEM.INC'
        include 'cmdcom_inc.decl'
        include 'CMDCOM.INC'
	include 'gkscm2.cmn'

C
C	USE OF IP FLAGS
C
C	IP(1)= BOX ON AND OFF  1=ON  0=OFF
C
#ifndef unix
c       Set up structures for exit handler
c
        STRUCTURE /EXIT_DESCRIPTOR/
            INTEGER LINK,
     *      ADDR,
     *      ARGS /1/,
     *      STATUS_ADDR
        END STRUCTURE
        RECORD /EXIT_DESCRIPTOR/ HANDLER
C
        EXTERNAL PPLEXT
        INTEGER*4 EXIT_STATUS
C
        BYTE BUF(80),CRB,ESCB
#endif
	CHARACTER EFILE*(*)
C	CHARACTER EFILE*81
	INTEGER ELUN,DLUN,MLUN,CLUN,LTT,KEY1,KEY2,EPLUN1,EPLUN2
#ifndef unix
	CHARACTER ESC*1,CR*1
        INTEGER*4 LIB$GET_FOREIGN,STAT,LIB$GET_SYMBOL,LEN,IFLAG
        INCLUDE '($JPIDEF)'
#endif
	CHARACTER TEMP*81,TERM*20,SYM*120
C
	CHARACTER TYPE*81
C
#ifdef unix
        DATA CRB,ESCB/13,27/,TEMP/'/dev/tty'/,TERM/'/dev/tty'/
#else
        DATA CRB,ESCB/13,27/,TEMP/'TT:'/,TERM/'TT:'/
        EQUIVALENCE (BUF(1),LABEL),(CR,CRB),(ESC,ESCB)
C
C       SET UP THE EXIT HANDLER
C
        HANDLER.ADDR = %LOC(PPLEXT)
        HANDLER.STATUS_ADDR = %LOC(EXIT_STATUS)
C
C       EXTABLISH THE EXIT HANDLER
C
        CALL SYS$DCLEXH(HANDLER)
#endif
C
C	SET UP THE LOGICAL UNITS
C
	LUNN=DLUN
	LUN1=DLUN
	LUN11=EPLUN1
	LUN21=EPLUN2
	LMULT=MLUN
	LTTOUT=LTT
	KEYLN1=KEY1
	KEYLN2=KEY2
	CMDLUN=CLUN
	ECHLUN=ELUN
C
#ifndef unix
	CALL ERRSET(64,.TRUE.,.FALSE.,.TRUE.,.FALSE.)
	CALL ERRSET(44,.TRUE.,.FALSE.,.TRUE.,.FALSE.)
	CALL ERRSET(36,.TRUE.,.FALSE.,.TRUE.,.FALSE.)
	CALL ERRSET(30,,.FALSE.,,.FALSE.)
#endif
	CALL BAUD(IR)
	CALL PLTYPE(ICODE)
C
#ifdef unix
#ifndef F90_NO_GETLOG
        call getlog(type)
#endif
        BATCHF = TYPE.EQ.' '
C
        call getenv('GRAPHTERM',type)
        len=lnblk(type,81)
#else
        STAT=LIB$GETJPI(JPI$_MODE,,,ISTAT,TYPE,LEN)
        BATCHF = TYPE(:LEN).EQ.'BATCH'
C
        STAT=LIB$GET_SYMBOL('GRAPHTERM',TYPE,LEN)
#endif

	IF(TYPE(1:LEN).EQ.'TEK41XX'.OR.TYPE(1:LEN).EQ.'TEK4105')THEN
		TEKMOD=4107
		CALL TKTYPE(TEKMOD)
	ELSE IF(TYPE(1:LEN).EQ.'TEK4014')THEN
		TEKMOD=4014
		CALL TKTYPE(TEKMOD)
	ENDIF
C
C	OPEN ECHO FILE
C
	IF(EFILE.NE.' ')THEN
#ifdef unix
            OPEN(ECHLUN,FILE=EFILE,STATUS='UNKNOWN')
#else
            OPEN(ECHLUN,FILE=EFILE,STATUS='NEW',CARRIAGECONTROL='LIST')
#endif
	ENDIF
c
c	open key file
c
#ifdef unix
        call dbmopen('PPL$KEY.001',11,keyln1)
c
        IF(BATCHF)TERM='/dev/null'
C
C Don't open below -- problem w/ Ultrix *JD* 3.5.91
C       OPEN(UNIT=LTTOUT,FILE=TERM,STATUS='UNKNOWN')
#else
        OPEN(KEYLN1,FILE='PPL$KEY.001',STATUS='NEW',
     *  ORGANIZATION='INDEXED',ACCESS='KEYED',
     *  RECORDTYPE='VARIABLE',FORM='FORMATTED',
     *  KEY=(1:30:CHARACTER))
c
        IF(BATCHF)TERM='SYS$OUTPUT:'
C
        OPEN(UNIT=LTTOUT,FILE=TERM,STATUS='UNKNOWN',RECL=255)
#endif
C
	CALL STPRMP('ppl+>',5)
C
C	SET DEFAULT SYMBOL DEFINITIONS
C
	SYM='*PPL$FORMAT'
	ISYM=LNBLK(IFORM,80)
	CALL PUTSYM(SYM,IFORM,ISYM,IER)
	SYM='*PPL$PLTNME'
C	TEMP='metafile.plt'
C	CALL PUTSYM(SYM,TEMP,12,IER)
	call putsym(sym, meta_file, LNBLK(meta_file,128), ier)
	SYM='*PPL$TEKNME'
#ifdef unix
        TEMP='/dev/tty'
#else
	TEMP='TT:'
#endif
	CALL PUTSYM(SYM,TEMP,7,IER)
	SYM='*PPL$XLEN'
	CALL PUTVAL(SYM,XLEN,7,IER)
	SYM='*PPL$YLEN'
	CALL PUTVAL(SYM,YLEN,7,IER)
	SYM='*PPL$XORG'
	CALL PUTVAL(SYM,XORG,7,IER)
	SYM='*PPL$YORG'
	CALL PUTVAL(SYM,YORG,7,IER)
	SYM='*PPL$WIDTH'
	CALL PUTVAL(SYM,WIDTH,7,IER)
	SYM='*PPL$HEIGHT'
	CALL PUTVAL(SYM,HEIGHT,7,IER)
	SYM='*PPL$LINE_COUNT'
	TEMP='0'
	CALL PUTSYM(SYM,TEMP,1,IER)
C
C	SET PPL$XFACT, XOFF, YFACT AND YOFF
C
	ISYM=MIN0(1,NLINES)
	DO 20 I=1,ISYM
	WRITE(SYM,999)'XFACT',I
999	FORMAT('*PPL$',A,'(',I3,')')
	CALL PUTVAL(SYM,XFCT(I),7,IER)
	WRITE(SYM,999)'XOFF',I
	CALL PUTVAL(SYM,XOFF(I),7,IER)
	WRITE(SYM,999)'YFACT',I
	CALL PUTVAL(SYM,YFCT(I),7,IER)
	WRITE(SYM,999)'YOFF',I
	CALL PUTVAL(SYM,YOFF(I),7,IER)
20	CONTINUE
C
C	STORE VIEW SYMBOLS
C
	WRITE(SYM,997)'X'
997	FORMAT('*PPL$VIEW_',A)
	TEMP='0.000'
	CALL PUTSYM(SYM,TEMP,5,IER)
	WRITE(SYM,997)'Y'
	CALL PUTSYM(SYM,TEMP,5,IER)
	WRITE(SYM,997)'Z'
	CALL PUTSYM(SYM,TEMP,5,IER)
10	CONTINUE
	RETURN
	END
#ifndef unix
        SUBROUTINE PPLEXT(STATUS)
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C**     Subprogram called:
C**             N/A
C**
C**     Parameters:
C**             STATUS -- Exit status, passed from system
C**
C**     Description:
C**             This routine closes all files and deletes temporary files
C**
C**     History:
C**         Written:
C**             2-AUG-86        by Donald W. Denbo
C**         Modified:
C**
C**
        INTEGER*4 STATUS
#ifdef unix
        include 'filnam_inc.decl'
        include 'FILNAM.INC'
        include 'lunits_inc.decl'
        include 'LUNITS.INC'
        include 'symkey_inc.decl'
        include 'SYMKEY.INC'
        include 'cmdcom_inc.decl'
        include 'CMDCOM.INC'
        include 'pltcom_dat.decl'
        include 'PLTCOM.DAT'
#else
        INCLUDE 'tmap_pplv11inc:tmap_FILNAM.INC'
        INCLUDE 'tmap_pplv11inc:tmap_LUNITS.INC'
        INCLUDE 'TMAP_PPLV11INC:SYMKEY_INC.DECL'
        INCLUDE 'PPLV11INC:SYMKEY.INC'
        INCLUDE 'TMAP_PPLV11INC:CMDCOM_INC.DECL'
        INCLUDE 'PPLV11INC:CMDCOM.INC'
        INCLUDE 'tmap_pplv11inc:tmap_PLTCOM.DAT'
#endif
C
C       CLOSE ALL OPEN COMMAND FILES
C
        CALL ATFLSH
        CLOSE(KEYLN1,DISP='DELETE')
C
C       CLOSE MULT FILE IF OPEN
C
        IF(MULTFL.NE.' ')THEN
           CLOSE(LMULT,DISP='DELETE')
        ENDIF
        IF(PLTFLG)THEN
C
C       BINARY FILE IS OPEN
C
            PEN = .FALSE.
            CALL ZABMV
            CALL BINFSH
        ENDIF
        RETURN
        END
#endif

	SUBROUTINE TM_MAKE_FMT_DATE (form, date, year, month, day,
     .				     hour, minute, second, dlen)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Will take the components of a date and convert it to a string of the
* requested date format

* *sh* 2/13/95
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files
* V7.44  11/18 *acm* Note numslashnum  formatting is ISO 8601 yyyy-mm-dd
* V7.44 12/18 *acm* Allow for fractional seconds 20-DEC-1982 12:52:00.24
* v745 *acm* 12/18 Issue 1909, option to write dates in ISO8601 format
*                  Also more on writing out fractional seconds

* ARGUMENT DEFINITIONS
*  form  - code for the date string format
*  date  - date to process
*  day, month, year, hour, minute, second - obvious
*  status - returned status

	CHARACTER*(*)	date
	INTEGER	form, day, month, year, hour, minute, dlen
	REAL	second
*
* INCLUDE FILES
	include 'tmap_errors.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"

* internal variable declarations:
	INTEGER		isecond, ifrac
	REAL		frac
	CHARACTER*3    cmon(12)

	DATA cmon /'JAN', 'FEB', 'MAR', 'APR', 'MAY', 'JUN',
     .             'JUL', 'AUG', 'SEP', 'OCT', 'NOV', 'DEC'/


	IF ( form .EQ. pdate_vax ) THEN
* model date: 20-DEC-1982 12:52:00
1000       FORMAT(I2.2,'-',A3,'-',I4.4,' ',2(I2.2,':'),I2.2)
1010       FORMAT(I2.2,'-',A3,'-',I4.4,' ',2(I2.2,':'),F4.2)
	   IF (AINT(second) .EQ. second) THEN
	      isecond = AINT(second)
	      WRITE (date,1000) day, cmon(month), year, hour,
     .  			minute, isecond
	      dlen = 20
	   ELSE
	      WRITE (date,1010) day, cmon(month), year, hour,
     .  			minute, second
	      dlen = 23
	   ENDIF
	ELSEIF ( form .EQ. pdate_numslashnum ) THEN
* model date: 1982-12-20 12:52:00
1100       FORMAT(I4.4,'-',I2.2,'-',I2.2,' ',2(I2.2,':'),I2.2)
1110       FORMAT(I4.4,'-',I2.2,'-',I2.2,' ',2(I2.2,':'),I2.2,'.',I2.2)
	   IF (AINT(second) .EQ. second) THEN
	      isecond = AINT(second)
	      WRITE (date,1100) year, month, day, hour,
     .  			minute, isecond
	      dlen = 19
	   ELSE
	      isecond = AINT(second)
	      frac = second - AINT(second)
	      ifrac = 100*frac
	      WRITE (date,1110) year, month, day, hour,
     .  			minute, isecond, ifrac
	      dlen = 22
	   ENDIF
	ELSE
	   STOP 'Unknown date format code'
	ENDIF

	RETURN
	END

      SUBROUTINE NEW_GKS_WINDOW (ws_id,xname,window_title,status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*     Modifies connection id string, opens GKS workstation.  Permits multiple 
*     windows on workstation screen.  Modified from GKS-3D FORTRAN Binding
*     Manual example 19-1.  For VMS simply open the workstation.
*     J Davison 5.13.91
*     *jd* 3.26.92  Modified to accommodate ATC GKS as well as DEC
*     *jd* 12.21.93 Modified to accommodate xgks
*  V600 *acm* 9/05 append window_title to window name

* Calling arguments
      integer         ws_id,status
      character*(*)   xname, window_title

* Internal declarations
      integer         TM_LENSTR1, nlen
      character*2     kwsid

#ifdef xgks
      character*88     window_name

      include         'gkspar.inc' 
      
      write (unit=kwsid,fmt='(i2)') ws_id

      window_name = 'FERRET_'//kwsid(2:2)
      nlen = TM_LENSTR1(window_title)
      IF (nlen .GT. 1 .OR. window_title .NE. '_')
     .    window_name = 'FERRET_'//kwsid(2:2)//'_'//window_title
      nlen = TM_LENSTR1(window_name)
      call gesspn (window_name,nlen)
      call gopwk (ws_id,6,4)

*     SET DEFERRAL STATE TO GENERATE OUTPUT AS SOON AS POSSIBLE
      call gsds (ws_id,gasap,gsuppd)
#else
#ifdef atc_gks
      integer         con_id

      character*80    conid_options 
      character*80    conid_opt/' -nc64 -ox 2 -u 2'/,conid_opt_def
#else
      include         'gkspar.inc' 

      integer         i,fctid,mldr,mlodr,odr
      integer         il,ia,rl,ra,sl,lstr(1),errind,ldr,lidr,lodr

      character*80    idr,str(1)
#endif

      include 'gkscm1_inc.decl'
      include 'GKSCM1.INC'
      include 'ws_types.cmn'

*******************************************************************************

#ifdef atc_gks
      con_id = ws_id
      write (unit=kwsid,fmt='(i2)') ws_id
      conid_opt_def = '-l FERRET'//kwsid//conid_opt
#   ifdef unix
      call getenv ('atcGKSconid',conid_options)
#   else
*     GET LOGICAL WITH TRNLNM
#   endif
      if (conid_options .eq. ' ') conid_options = conid_opt_def

      if (wstype/100 .eq. ws_xwindow/100) then
         call guesc050 (con_id,conid_options)
         call guesc005 (con_id)
      endif
      call gopwk (ws_id,con_id,wstype)
#else
#   ifdef unix
*     Define the conid string by use of pack record (GPREC) and the FORTAN 
*     binding GESC_CONID escape function.

      il = 0
      ia = 0
      rl = 0
      ra = 0
      sl = 1
      mldr = 10
      lstr(1) = len (xname)
      str(1)  = xname
      call gprec (il,ia,rl,ra,sl,lstr,str,mldr,errind,ldr,idr)

      fctid = gecon
      lidr  = 28
      mlodr = 0
      lodr  = 0
      call gesc (fctid,lidr,idr,mlodr,lodr,odr)

      call gopwk (ws_id,0,0)
#   else
      call GKS$OPEN_WS (ws_id,xname,0)
#   endif
#endif

#endif
      status = 3   ! Meaningless but may be used later
      return 
      end
      

	SUBROUTINE MODULO_REGRID( cx_lims, axis, trans,
     .			src, msrc, dst, mdst, ngd, 
     .			mngd, nbd, mnbd, ave, mave)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* 	Using data values from src organized on grid src_grid, regrid to
* 	grid dst_grid by "modulo averaging".  Specifically, average all
*	of the source points that fall within the modulo-replications
*	of each destination point.

* 	msrc and mdst point to data structures in COMMON/XVARIABLES/ which
* 	specify the subscript bounds of src and dst within their 
* 	respective grids.

*	ss21 holds the indices of source grid boxes (on src_grid) for box
*	limits on dst_grid.

* 	programmer - Steve Hankin
* 	NOAA/PMEL,Seattle,WA - Tropical Modeling and Analysis Program

* V420:	 11/95
* V450:	 1/97 - bug fix: error in nfold calculation
* kob*   9/97 - replaced call to ISUBSCRIPT w/ call to ISUBSCR_CX in order
*               to have access to context information - needed for negative
*               time step processing
* V541:	 *sh*  2/02 - support for subspan modulo axes -- dont use line_dim 
* V561: *acm*  4/04 - (old fix got checked in, then an old version got checked in!!)
*                     add checks on source points when computing sum of squared deviations
*                     for MODVAR
* V603 5/07  *acm* - added MODNBD modulo regridding statistic
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction. 

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'		! for line_dim
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xcontext.cmn'
	include	'xmem_subsc.cmn'
	include 'xvariables.cmn'

* calling argument declarations:
	INTEGER	cx_lims, axis, trans, msrc, mdst, mngd, mnbd, mave

	REAL    src( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          dst( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif ),
     .          ngd( m3lox:m3hix,m3loy:m3hiy,m3loz:m3hiz,
     .               m3lot:m3hit,m3loe:m3hie,m3lof:m3hif ),
     .          nbd( m4lox:m4hix,m4loy:m4hiy,m4loz:m4hiz,
     .               m4lot:m4hit,m4loe:m4hie,m4lof:m4hif ),
     .          ave( m5lox:m5hix,m5loy:m5hiy,m5loz:m5hiz,
     .               m5lot:m5hit,m5loe:m5hie,m5lof:m5hif )

* local variable declarations:
	INTEGER	ISUBSCR_CX, TM_MODULO_LINE_DIM,
     .		dstss, srcss, src_grid, dst_grid,
     .		i, j, k, l, m, n, nmod, nfold, dst_start,
     .		srcss_lo, srcss_hi, dstss_lo, dstss_hi, status

	REAL	bad_src, bad_dst, tmp
	REAL*8	TDEST_WORLD, dstww

******************************************************************************
* initialize
	src_grid = mr_grid( msrc )
	dst_grid = mr_grid( mdst )

* limits for calculation
        srcss_lo = mr_lo_ss(msrc,axis)
        srcss_hi = mr_hi_ss(msrc,axis)

        dstss_lo = cx_lo_ss(cx_lims,axis)
        dstss_hi = cx_hi_ss(cx_lims,axis)

* flag for bad/missing data
        bad_src = mr_bad_data(msrc)
        bad_dst = mr_bad_data(mdst)

* initialize outputs to zero (ngd serves as flag for a valid calculation, too)
        DO 10 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
        DO 10 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
        DO 10 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
        DO 10 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
        DO 10 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
        DO 10 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
	   ngd(i,j,k,l,m,n) = 0.0
	   nbd(i,j,k,l,m,n) = 0.0

	   IF ( trans .EQ. prgrd_modulo ) THEN
	      dst(i,j,k,l,m,n) = 0.0
	   ELSEIF ( trans .EQ. prgrd_modsum ) THEN
	      dst(i,j,k,l,m,n) = 0.0
	   ELSEIF ( trans .EQ. prgrd_modvar ) THEN
	      dst(i,j,k,l,m,n) = 0.0
	      ave(i,j,k,l,m,n) = 0.0
	   ELSEIF ( trans .EQ. prgrd_modngd ) THEN
	      dst(i,j,k,l,m,n) = 0.0
	   ELSEIF ( trans .EQ. prgrd_modnbd ) THEN
	      dst(i,j,k,l,m,n) = 0.0
	   ELSEIF ( trans .EQ. prgrd_modmin ) THEN
	      dst(i,j,k,l,m,n) = arbitrary_large_val4
	   ELSEIF ( trans .EQ. prgrd_modmax ) THEN
	      dst(i,j,k,l,m,n) = arbitrary_small_val4
	   ENDIF

 10	CONTINUE

* the modulo index length of the destination axis
! ...	nmod = CAXIS_LEN(axis,cx_dst)	if cx_dst were known ...
	nmod = TM_MODULO_LINE_DIM( grid_line(axis,dst_grid) )

* the number of times the destination axis was folded before the first dstss_lo
!	nfold = INT(dstss_lo/nmod) * nmod
	nfold = INT((dstss_lo-1)/nmod) * nmod		! 1/97

*****************************************

* along X axis
        IF ( axis .EQ. x_dim ) THEN

* loop through the each source grid point
	   DO 190 srcss = srcss_lo,srcss_hi

* what destination grid point owns this source point?
	      dstww = TDEST_WORLD(srcss, src_grid, axis, box_middle)
	      dstss = ISUBSCR_CX(dstww, dst_grid, axis, cx_lims,round_up)

* map that index, modulo-style, to the first target destination point
	      dst_start = MOD(dstss-1,nmod) + 1 + nfold
	      IF (dst_start .LT. dstss_lo) dst_start = dst_start + nmod

* add this contribution to all of the appropriate destination points
	      DO 120 dstss = dst_start, dstss_hi, nmod
                 DO 110 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
                 DO 110 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
                 DO 110 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
                 DO 110 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
                 DO 110 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)

* ... ignore missing source data
	         IF ( src(srcss,j,k,l,m,n) .EQ. bad_src ) THEN
                    nbd(dstss,j,k,l,m,n) = nbd(dstss,j,k,l,m,n) + 1.
                    IF ( trans .EQ. prgrd_modnbd ) 
     .                  dst(dstss,j,k,l,m,n) = nbd(dstss,j,k,l,m,n)
                    GOTO 110
                 ENDIF

* ... count this point
	         ngd(dstss,j,k,l,m,n) = ngd(dstss,j,k,l,m,n) + 1.

	         IF ( trans .EQ. prgrd_modulo ) THEN
	            dst(dstss,j,k,l,m,n) = dst(dstss,j,k,l,m,n) +
     .                                     src(srcss,j,k,l,m,n)
	         ELSEIF ( trans .EQ. prgrd_modsum ) THEN
	            dst(dstss,j,k,l,m,n) = dst(dstss,j,k,l,m,n) +
     .                                     src(srcss,j,k,l,m,n)
	         ELSEIF ( trans .EQ. prgrd_modvar ) THEN
	            ave(dstss,j,k,l,m,n) = ave(dstss,j,k,l,m,n) +
     .                                     src(srcss,j,k,l,m,n)
	         ELSEIF ( trans .EQ. prgrd_modngd ) THEN
	            dst(dstss,j,k,l,m,n) = ngd(dstss,j,k,l,m,n)
	         ELSEIF ( trans .EQ. prgrd_modmin ) THEN
	            IF (src(srcss,j,k,l,m,n) .LT. dst(dstss,j,k,l,m,n))
     .			dst(dstss,j,k,l,m,n) = src(srcss,j,k,l,m,n)
	         ELSEIF ( trans .EQ. prgrd_modmax ) THEN
	            IF (src(srcss,j,k,l,m,n) .GT. dst(dstss,j,k,l,m,n))
     .			dst(dstss,j,k,l,m,n) = src(srcss,j,k,l,m,n)
	         ENDIF

 110	         CONTINUE
 120	      CONTINUE

 190	   CONTINUE

* along Y axis
        ELSEIF ( axis .EQ. Y_dim ) THEN

* loop through the each source grid point
	   DO 290 srcss = srcss_lo,srcss_hi

* what destination grid point owns this source point?
	      dstww = TDEST_WORLD(srcss, src_grid, axis, box_middle)
	      dstss = ISUBSCR_CX(dstww, dst_grid, axis, cx_lims, round_up)

* map that index, modulo-style, to the first target destination point
	      dst_start = MOD(dstss-1,nmod) + 1 + nfold
	      IF (dst_start .LT. dstss_lo) dst_start = dst_start + nmod

* add this contribution to all of the appropriate destination points
	      DO 220 dstss = dst_start, dstss_hi, nmod
                 DO 210 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
                 DO 210 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
                 DO 210 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
                 DO 210 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
                 DO 210 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* ... ignore missing source data
	         IF ( src(i,srcss,k,l,m,n) .EQ. bad_src ) THEN
                    nbd(i,dstss,k,l,m,n) = nbd(i,dstss,k,l,m,n) + 1.
                    IF ( trans .EQ. prgrd_modnbd ) 
     .                 dst(i,dstss,k,l,m,n) = nbd(i,dstss,k,l,m,n)
                    GOTO 210
                 ENDIF

* ... count this point
	         ngd(i,dstss,k,l,m,n) = ngd(i,dstss,k,l,m,n) + 1.

	         IF ( trans .EQ. prgrd_modulo ) THEN
	            dst(i,dstss,k,l,m,n) = dst(i,dstss,k,l,m,n) +
     .                                     src(i,srcss,k,l,m,n)
	         ELSEIF ( trans .EQ. prgrd_modsum ) THEN
	            dst(i,dstss,k,l,m,n) = dst(i,dstss,k,l,m,n) +
     .                                     src(i,srcss,k,l,m,n)
	         ELSEIF ( trans .EQ. prgrd_modvar ) THEN
	            ave(i,dstss,k,l,m,n) = ave(i,dstss,k,l,m,n) +
     .                                     src(i,srcss,k,l,m,n)
	         ELSEIF ( trans .EQ. prgrd_modngd ) THEN
	            dst(i,dstss,k,l,m,n) = ngd(i,dstss,k,l,m,n)
	         ELSEIF ( trans .EQ. prgrd_modmin ) THEN
	            IF (src(i,srcss,k,l,m,n) .LT. dst(i,dstss,k,l,m,n))
     .			dst(i,dstss,k,l,m,n) = src(i,srcss,k,l,m,n)
	         ELSEIF ( trans .EQ. prgrd_modmax ) THEN
	            IF (src(i,srcss,k,l,m,n) .GT. dst(i,dstss,k,l,m,n))
     .			dst(i,dstss,k,l,m,n) = src(i,srcss,k,l,m,n)
	         ENDIF

 210	         CONTINUE
 220	      CONTINUE

 290	   CONTINUE

* along Z axis
        ELSEIF ( axis .EQ. z_dim ) THEN

* loop through the each source grid point
	   DO 390 srcss = srcss_lo,srcss_hi

* what destination grid point owns this source point?
	      dstww = TDEST_WORLD(srcss, src_grid, axis, box_middle)
	      dstss = ISUBSCR_CX(dstww, dst_grid, axis, cx_lims, round_up)

* map that index, modulo-style, to the first target destination point
	      dst_start = MOD(dstss-1,nmod) + 1 + nfold
	      IF (dst_start .LT. dstss_lo) dst_start = dst_start + nmod

* add this contribution to all of the appropriate destination points
	      DO 320 dstss = dst_start, dstss_hi, nmod
                 DO 310 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
                 DO 310 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
                 DO 310 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
                 DO 310 k = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
                 DO 310 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* ... ignore missing source data
	         IF ( src(i,j,srcss,l,m,n) .EQ. bad_src ) THEN
                    nbd(i,j,dstss,l,m,n) = nbd(i,j,dstss,l,m,n) + 1.
                    IF ( trans .EQ. prgrd_modnbd ) 
     .                  dst(i,j,dstss,l,m,n) = nbd(i,j,dstss,l,m,n)
                    GOTO 310
                 ENDIF

* ... count this point
	         ngd(i,j,dstss,l,m,n) = ngd(i,j,dstss,l,m,n) + 1.

	         IF ( trans .EQ. prgrd_modulo ) THEN
	            dst(i,j,dstss,l,m,n) = dst(i,j,dstss,l,m,n) +
     .                                     src(i,j,srcss,l,m,n)
	         ELSEIF ( trans .EQ. prgrd_modsum ) THEN
	            dst(i,j,dstss,l,m,n) = dst(i,j,dstss,l,m,n) +
     .                                     src(i,j,srcss,l,m,n)
	         ELSEIF ( trans .EQ. prgrd_modvar ) THEN
	            ave(i,j,dstss,l,m,n) = ave(i,j,dstss,l,m,n) +
     .                                     src(i,j,srcss,l,m,n)
	         ELSEIF ( trans .EQ. prgrd_modngd ) THEN
	            dst(i,j,dstss,l,m,n) = ngd(i,j,dstss,l,m,n)
	         ELSEIF ( trans .EQ. prgrd_modmin ) THEN
	            IF (src(i,j,srcss,l,m,n) .LT. dst(i,j,dstss,l,m,n))
     .			dst(i,j,dstss,l,m,n) = src(i,j,srcss,l,m,n)
	         ELSEIF ( trans .EQ. prgrd_modmax ) THEN
	            IF (src(i,j,srcss,l,m,n) .GT. dst(i,j,dstss,l,m,n))
     .			dst(i,j,dstss,l,m,n) = src(i,j,srcss,l,m,n)
	         ENDIF

 310	         CONTINUE
 320	      CONTINUE

 390	   CONTINUE

* along T axis
        ELSEIF ( axis .EQ. T_dim ) THEN

*   ==>   ALL TIME/DATE CALCULATIONS ARE DONE IN THE DEST AXIS ENCODING
           CALL TDEST_WORLD_INIT ( src_grid, dst_grid, axis, status ) ! src<->dst
           IF ( status .NE. ferr_ok ) STOP 'bogus TDEST_WORLD_INIT'

* loop through the each source grid point
	   DO 490 srcss = srcss_lo,srcss_hi

* USE DESTINATION GRID TIME/DATE ENCODINGS FOR ALL CALCULATIONS
* what destination grid point owns this source point?
	      dstww = TDEST_WORLD(srcss, src_grid, axis, box_middle)
	      dstss = ISUBSCR_CX(dstww, dst_grid, axis, cx_lims,round_up)

* map that index, modulo-style, to the first target destination point
	      dst_start = MOD(dstss-1,nmod) + 1 + nfold
	      IF (dst_start .LT. dstss_lo) dst_start = dst_start + nmod

* add this contribution to all of the appropriate destination points
	      DO 420 dstss = dst_start, dstss_hi, nmod
                 DO 410 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
                 DO 410 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
                 DO 410 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
                 DO 410 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
                 DO 410 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* ... ignore missing source data
	         IF ( src(i,j,k,srcss,m,n) .EQ. bad_src ) THEN
                    nbd(i,j,k,dstss,m,n) = nbd(i,j,k,dstss,m,n) + 1.
                    IF ( trans .EQ. prgrd_modnbd ) 
     .                  dst(i,j,k,dstss,m,n) = nbd(i,j,k,dstss,m,n)
                    GOTO 410
                 ENDIF

* ... count this point
	         ngd(i,j,k,dstss,m,n) = ngd(i,j,k,dstss,m,n) + 1.

	         IF ( trans .EQ. prgrd_modulo ) THEN
	            dst(i,j,k,dstss,m,n) = dst(i,j,k,dstss,m,n) +
     .                                     src(i,j,k,srcss,m,n)
	         ELSEIF ( trans .EQ. prgrd_modsum ) THEN
	            dst(i,j,k,dstss,m,n) = dst(i,j,k,dstss,m,n) +
     .                                     src(i,j,k,srcss,m,n)
	         ELSEIF ( trans .EQ. prgrd_modvar ) THEN
	            ave(i,j,k,dstss,m,n) = ave(i,j,k,dstss,m,n) +
     .                                     src(i,j,k,srcss,m,n)
	         ELSEIF ( trans .EQ. prgrd_modngd ) THEN
	            dst(i,j,k,dstss,m,n) = ngd(i,j,k,dstss,m,n)
	         ELSEIF ( trans .EQ. prgrd_modmin ) THEN
	            IF (src(i,j,k,srcss,m,n) .LT. dst(i,j,k,dstss,m,n))
     .			dst(i,j,k,dstss,m,n) = src(i,j,k,srcss,m,n)
	         ELSEIF ( trans .EQ. prgrd_modmax ) THEN
	            IF (src(i,j,k,srcss,m,n) .GT. dst(i,j,k,dstss,m,n))
     .			dst(i,j,k,dstss,m,n) = src(i,j,k,srcss,m,n)
	         ENDIF

 410	         CONTINUE
 420	      CONTINUE

 490	   CONTINUE


* along E axis
        ELSEIF ( axis .EQ. e_dim ) THEN

* loop through the each source grid point
	   DO 590 srcss = srcss_lo,srcss_hi

* what destination grid point owns this source point?
	      dstww = TDEST_WORLD(srcss, src_grid, axis, box_middle)
	      dstss = ISUBSCR_CX(dstww, dst_grid, axis, cx_lims,round_up)

* map that index, modulo-style, to the first target destination point
	      dst_start = MOD(dstss-1,nmod) + 1 + nfold
	      IF (dst_start .LT. dstss_lo) dst_start = dst_start + nmod

* add this contribution to all of the appropriate destination points
	      DO 520 dstss = dst_start, dstss_hi, nmod
                 DO 510 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
                 DO 510 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
                 DO 510 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
                 DO 510 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
                 DO 510 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* ... ignore missing source data
	         IF ( src(i,j,k,l,srcss,n) .EQ. bad_src ) THEN
                    nbd(i,j,k,l,dstss,n) = nbd(i,j,k,l,dstss,n) + 1.
                    IF ( trans .EQ. prgrd_modnbd ) 
     .                  dst(i,j,k,l,dstss,n) = nbd(i,j,k,l,dstss,n)
                    GOTO 510
                 ENDIF

* ... count this point
	         ngd(i,j,k,l,dstss,n) = ngd(i,j,k,l,dstss,n) + 1.

	         IF ( trans .EQ. prgrd_modulo ) THEN
	            dst(i,j,k,l,dstss,n) = dst(i,j,k,l,dstss,n) +
     .                                     src(i,j,k,l,srcss,n)
	         ELSEIF ( trans .EQ. prgrd_modsum ) THEN
	            dst(i,j,k,l,dstss,n) = dst(i,j,k,l,dstss,n) +
     .                                     src(i,j,k,l,srcss,n)
	         ELSEIF ( trans .EQ. prgrd_modvar ) THEN
	            ave(i,j,k,l,dstss,n) = ave(i,j,k,l,dstss,n) +
     .                                     src(i,j,k,l,srcss,n)
	         ELSEIF ( trans .EQ. prgrd_modngd ) THEN
	            dst(i,j,k,l,dstss,n) = ngd(i,j,k,l,dstss,n)
	         ELSEIF ( trans .EQ. prgrd_modmin ) THEN
	            IF (src(i,j,k,l,srcss,n) .LT. dst(i,j,k,l,dstss,n))
     .			dst(i,j,k,l,dstss,n) = src(i,j,k,l,srcss,n)
	         ELSEIF ( trans .EQ. prgrd_modmax ) THEN
	            IF (src(i,j,k,l,srcss,n) .GT. dst(i,j,k,l,dstss,n))
     .			dst(i,j,k,l,dstss,n) = src(i,j,k,l,srcss,n)
	         ENDIF

 510	         CONTINUE
 520	      CONTINUE

 590	   CONTINUE

* along F axis
        ELSEIF ( axis .EQ. F_dim ) THEN

*   ==>   ALL TIME/DATE CALCULATIONS ARE DONE IN THE DEST AXIS ENCODING
           CALL TDEST_WORLD_INIT ( src_grid, dst_grid, axis, status ) ! src<->dst
           IF ( status .NE. ferr_ok ) STOP 'bogus TDEST_WORLD_INIT'

* loop through the each source grid point
	   DO 690 srcss = srcss_lo,srcss_hi

* USE DESTINATION GRID TIME/DATE ENCODINGS FOR ALL CALCULATIONS
* what destination grid point owns this source point?
	      dstww = TDEST_WORLD(srcss, src_grid, axis, box_middle)
	      dstss = ISUBSCR_CX(dstww, dst_grid, axis, cx_lims,round_up)

* map that index, modulo-style, to the first target destination point
	      dst_start = MOD(dstss-1,nmod) + 1 + nfold
	      IF (dst_start .LT. dstss_lo) dst_start = dst_start + nmod

* add this contribution to all of the appropriate destination points
	      DO 620 dstss = dst_start, dstss_hi, nmod
                 DO 610 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
                 DO 610 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
                 DO 610 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
                 DO 610 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
                 DO 610 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* ... ignore missing source data
	         IF ( src(i,j,k,l,m,srcss) .EQ. bad_src ) THEN
                    nbd(i,j,k,l,m,dstss) = nbd(i,j,k,l,m,dstss) + 1.
                    IF ( trans .EQ. prgrd_modnbd ) 
     .                  dst(i,j,k,l,m,dstss) = nbd(i,j,k,l,m,dstss)
                    GOTO 610
                 ENDIF

* ... count this point
	         ngd(i,j,k,l,m,dstss) = ngd(i,j,k,l,m,dstss) + 1.

	         IF ( trans .EQ. prgrd_modulo ) THEN
	            dst(i,j,k,l,m,dstss) = dst(i,j,k,l,m,dstss) +
     .                                     src(i,j,k,l,m,srcss)
	         ELSEIF ( trans .EQ. prgrd_modsum ) THEN
	            dst(i,j,k,l,m,dstss) = dst(i,j,k,l,m,dstss) +
     .                                     src(i,j,k,l,m,srcss)
	         ELSEIF ( trans .EQ. prgrd_modvar ) THEN
	            ave(i,j,k,l,m,dstss) = ave(i,j,k,l,m,dstss) +
     .                                     src(i,j,k,l,m,srcss)
	         ELSEIF ( trans .EQ. prgrd_modngd ) THEN
	            dst(i,j,k,l,m,dstss) = ngd(i,j,k,l,m,dstss)
	         ELSEIF ( trans .EQ. prgrd_modmin ) THEN
	            IF (src(i,j,k,l,m,srcss) .LT. dst(i,j,k,l,m,dstss))
     .			dst(i,j,k,l,m,dstss) = src(i,j,k,l,m,srcss)
	         ELSEIF ( trans .EQ. prgrd_modmax ) THEN
	            IF (src(i,j,k,l,m,srcss) .GT. dst(i,j,k,l,m,dstss))
     .			dst(i,j,k,l,m,dstss) = src(i,j,k,l,m,srcss)
	         ENDIF

 610	         CONTINUE
 620	      CONTINUE

 690	   CONTINUE

	ENDIF

	IF ( trans .EQ. prgrd_modngd ) RETURN
	IF ( trans .EQ. prgrd_modnbd ) RETURN

* for all axis orientations
* ... fill in missing values where there were zero source points
        DO 1000 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
        DO 1000 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
        DO 1000 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
        DO 1000 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
        DO 1000 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
        DO 1000 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

	   IF ( ngd(i,j,k,l,m,n) .EQ. 0.0 ) THEN
	      dst(i,j,k,l,m,n) = bad_dst
	   ELSEIF ( trans .EQ. prgrd_modulo ) THEN
	      dst(i,j,k,l,m,n) = dst(i,j,k,l,m,n) / ngd(i,j,k,l,m,n)
	   ELSEIF ( trans .EQ. prgrd_modvar ) THEN
	      ave(i,j,k,l,m,n) = ave(i,j,k,l,m,n) / ngd(i,j,k,l,m,n)
	   ENDIF

 1000	CONTINUE

	IF ( trans .NE. prgrd_modvar ) RETURN

**********************

* PASS #2 (needed only to compute variance - @MODVAR)
* ... at this point ngd contains the number of points
*     and ave contains the averages

* along X axis
        IF ( axis .EQ. x_dim ) THEN

* loop through the each source grid point
	   DO 1190 srcss = srcss_lo,srcss_hi

* what destination grid point owns this source point?
	      dstww = TDEST_WORLD(srcss, src_grid, axis, box_middle)
	      dstss = ISUBSCR_CX(dstww, dst_grid, axis, cx_lims, round_up)

* map that index, modulo-style, to the first target destination point
	      dst_start = MOD(dstss-1,nmod) + 1 + nfold
	      IF (dst_start .LT. dstss_lo) dst_start = dst_start + nmod

* add this contribution to all of the appropriate destination points
	      DO 1120 dstss = dst_start, dstss_hi, nmod
                 DO 1110 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
                 DO 1110 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
                 DO 1110 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
                 DO 1110 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
                 DO 1110 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)

* sum of squared deviations
	         IF ( ngd(dstss,j,k,l,m,n) .GT. 1.0 ) THEN
* ... must be at least 2 source points to get a variance
		    IF (src(srcss,j,k,l,m,n) .NE. bad_src) THEN
	               tmp = src(srcss,j,k,l,m,n)-ave(dstss,j,k,l,m,n)
	               dst(dstss,j,k,l,m,n) = dst(dstss,j,k,l,m,n) +
     .                                        tmp * tmp
                    ENDIF
	         ENDIF

 1110	         CONTINUE
 1120	      CONTINUE

 1190	   CONTINUE


* along Y axis
        ELSEIF ( axis .EQ. Y_dim ) THEN

* loop through the each source grid point
	   DO 1290 srcss = srcss_lo,srcss_hi

* what destination grid point owns this source point?
	      dstww = TDEST_WORLD(srcss, src_grid, axis, box_middle)
	      dstss = ISUBSCR_CX(dstww, dst_grid, axis, cx_lims,round_up)

* map that index, modulo-style, to the first target destination point
	      dst_start = MOD(dstss-1,nmod) + 1 + nfold
	      IF (dst_start .LT. dstss_lo) dst_start = dst_start + nmod

* add this contribution to all of the appropriate destination points
	      DO 1220 dstss = dst_start, dstss_hi, nmod
                 DO 1210 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
                 DO 1210 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
                 DO 1210 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
                 DO 1210 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
                 DO 1210 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* sum of squared deviations
	         IF ( ngd(i,dstss,k,l,m,n) .GT. 1.0 ) THEN
* ... must be at least 2 source points to get a variance
		    IF (src(i,srcss,k,l,m,n) .NE. bad_src) THEN
		        tmp = src(i,srcss,k,l,m,n)-ave(i,dstss,k,l,m,n)
		        dst(i,dstss,k,l,m,n) = dst(i,dstss,k,l,m,n) +
     .                                         tmp * tmp
		    ENDIF
	         ENDIF

 1210	         CONTINUE
 1220	      CONTINUE

 1290	   CONTINUE


* along Z axis
        ELSEIF ( axis .EQ. z_dim ) THEN

* loop through the each source grid point
	   DO 1390 srcss = srcss_lo,srcss_hi

* what destination grid point owns this source point?
	      dstww = TDEST_WORLD(srcss, src_grid, axis, box_middle)
	      dstss = ISUBSCR_CX(dstww, dst_grid, axis, cx_lims, round_up)

* map that index, modulo-style, to the first target destination point
	      dst_start = MOD(dstss-1,nmod) + 1 + nfold
	      IF (dst_start .LT. dstss_lo) dst_start = dst_start + nmod

* add this contribution to all of the appropriate destination points
	      DO 1320 dstss = dst_start, dstss_hi, nmod
                 DO 1310 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
                 DO 1310 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
                 DO 1310 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
                 DO 1310 k = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
                 DO 1310 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* sum of squared deviations
	         IF ( ngd(i,j,dstss,l,m,n) .GT. 1.0 ) THEN
* ... must be at least 2 source points to get a variance
		    IF (src(i,j,srcss,l,m,n) .NE. bad_src) THEN
		       tmp = src(i,j,srcss,l,m,n)-ave(i,j,dstss,l,m,n)
		       dst(i,j,dstss,l,m,n) = dst(i,j,dstss,l,m,n) +
     .                                        tmp * tmp
		    ENDIF
	         ENDIF

 1310	         CONTINUE
 1320	      CONTINUE

 1390	   CONTINUE


* along T axis
        ELSEIF (  axis .EQ. T_dim ) THEN

* loop through the each source grid point
	   DO 1490 srcss = srcss_lo,srcss_hi

* USE DESTINATION GRID TIME/DATE ENCODINGS FOR ALL CALCULATIONS
* what destination grid point owns this source point?
	      dstww = TDEST_WORLD(srcss, src_grid, axis, box_middle)
	      dstss = ISUBSCR_CX(dstww, dst_grid, axis, cx_lims, round_up)

* map that index, modulo-style, to the first target destination point
	      dst_start = MOD(dstss-1,nmod) + 1 + nfold
	      IF (dst_start .LT. dstss_lo) dst_start = dst_start + nmod

* add this contribution to all of the appropriate destination points
	      DO 1420 dstss = dst_start, dstss_hi, nmod
                 DO 1410 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
                 DO 1410 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
                 DO 1410 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
                 DO 1410 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
                 DO 1410 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* sum of squared deviations
	         IF ( ngd(i,j,k,dstss,m,n) .GT. 1.0 ) THEN
* ... must be at least 2 source points to get a variance
		    IF (src(i,j,k,srcss,m,n) .NE. bad_src) THEN
		       tmp = src(i,j,k,srcss,m,n)-ave(i,j,k,dstss,m,n)
		       dst(i,j,k,dstss,m,n) = dst(i,j,k,dstss,m,n) +
     .                                        tmp * tmp
		    ENDIF
	         ENDIF

 1410	         CONTINUE
 1420	      CONTINUE

 1490	   CONTINUE
 

* along E axis
        ELSEIF ( axis .EQ. e_dim ) THEN

* loop through the each source grid point
	   DO 1590 srcss = srcss_lo,srcss_hi

* what destination grid point owns this source point?
	      dstww = TDEST_WORLD(srcss, src_grid, axis, box_middle)
	      dstss = ISUBSCR_CX(dstww, dst_grid, axis, cx_lims, round_up)

* map that index, modulo-style, to the first target destination point
	      dst_start = MOD(dstss-1,nmod) + 1 + nfold
	      IF (dst_start .LT. dstss_lo) dst_start = dst_start + nmod

* add this contribution to all of the appropriate destination points
	      DO 1520 dstss = dst_start, dstss_hi, nmod
                 DO 1510 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
                 DO 1510 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
                 DO 1510 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
                 DO 1510 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
                 DO 1510 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* sum of squared deviations
	         IF ( ngd(i,j,k,l,dstss,n) .GT. 1.0 ) THEN
* ... must be at least 2 source points to get a variance
		    IF (src(i,j,k,l,srcss,n) .NE. bad_src) THEN
	               tmp = src(i,j,k,l,srcss,n)-ave(i,j,k,l,dstss,n)
	               dst(i,j,k,l,dstss,n) = dst(i,j,k,l,dstss,n) +
     .                                        tmp * tmp
                    ENDIF
	         ENDIF

 1510	         CONTINUE
 1520	      CONTINUE

 1590	   CONTINUE

* along F axis
        ELSEIF (  axis .EQ. f_dim ) THEN

* loop through the each source grid point
	   DO 1690 srcss = srcss_lo,srcss_hi

* USE DESTINATION GRID TIME/DATE ENCODINGS FOR ALL CALCULATIONS
* what destination grid point owns this source point?
	      dstww = TDEST_WORLD(srcss, src_grid, axis, box_middle)
	      dstss = ISUBSCR_CX(dstww, dst_grid, axis, cx_lims, round_up)

* map that index, modulo-style, to the first target destination point
	      dst_start = MOD(dstss-1,nmod) + 1 + nfold
	      IF (dst_start .LT. dstss_lo) dst_start = dst_start + nmod

* add this contribution to all of the appropriate destination points
	      DO 1620 dstss = dst_start, dstss_hi, nmod
                 DO 1610 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
                 DO 1610 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
                 DO 1610 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
                 DO 1610 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
                 DO 1610 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* sum of squared deviations
	         IF ( ngd(i,j,k,l,m,dstss) .GT. 1.0 ) THEN
* ... must be at least 2 source points to get a variance
		    IF (src(i,j,k,l,m,srcss) .NE. bad_src) THEN
		       tmp = src(i,j,k,l,m,srcss)-ave(i,j,k,l,m,dstss)
		       dst(i,j,k,l,m,dstss) = dst(i,j,k,l,m,dstss) +
     .                                        tmp * tmp
		    ENDIF
	         ENDIF

 1610	         CONTINUE
 1620	      CONTINUE

 1690	   CONTINUE

	ENDIF

* for all axis orientations: divide sum of squared deviations by N-1
        DO 2000 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
        DO 2000 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
        DO 2000 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
        DO 2000 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
        DO 2000 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
        DO 2000 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

	   IF ( ngd(i,j,k,l,m,n) .LE. 1.0 ) THEN
	      dst(i,j,k,l,m,n) = bad_dst
	   ELSE
	      dst(i,j,k,l,m,n) = dst(i,j,k,l,m,n) /
     .                           (ngd(i,j,k,l,m,n) - 1.0)
	   ENDIF

 2000	CONTINUE

	RETURN
	END

	SUBROUTINE BIN_REGRID_1_AXIS(cx_lims, axis, trans,
     .				 src, msrc, dst, mdst, ss21, src_cx,
     .                           dst_cx, wksize )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* 	Using data values from src organized on grid src_grid, regrid to
* 	grid dst_grid by binning withing boxes along one axis
*       @BIN returns binned data, @NBIN returns number of valid source
*       points in the destination grid cell

* 	msrc and mdst point to data structures in COMMON/XVARIABLES/ which

* 	specify the subscript bounds of src and dst within their 
* 	respective grids.

*	ss21 holds the indices of source grid boxes (on src_grid) for box
*	limits on dst_grid.

* 	programmer - Ansley Manke
* 	NOAA/PMEL,Seattle,WA - TMAP/ SDIG  11/2/2015

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'
	include 'xmem_subsc.cmn'
	include 'xvariables.cmn'

* calling argument declarations:
	INTEGER cx_lims, axis, trans, msrc, mdst, wksize
	INTEGER ss21(wksize)

	REAL    src( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .	             m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .	        dst( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .	             m2lot:m2hit,m2loe:m2hie,m2lof:m2hif )

* local variable declarations:

        LOGICAL         ok_neg111, coord_in_dst
        INTEGER		dstss,srcss,src_grid,dst_grid,i,j,k,l,m,n
	INTEGER	     	srcss_lo,srcss_hi, dstss_lo, dstss_hi,
     .                  src_cx, dst_cx

	REAL		ddist, bad_src, bad_dst
	REAL*8		TM_WORLD, TDEST_WORLD, sum,
     .			xsrc_min, xsrc_max, 
     .			xdst_lo, xdst_hi, xsrc_pt, nsrc_in_dst
******************************************************************************

* initialize
	src_grid = mr_grid( msrc )
	dst_grid = mr_grid( mdst )

* limits for calculation
        srcss_lo = mr_lo_ss(msrc,axis)
        srcss_hi = mr_hi_ss(msrc,axis)

* Range of subscripts might be negative, and contain the value of unspecified_int4 
* among them.  ok_neg111 distinguishes between this and the flag unspecified_int4.

        ok_neg111 = srcss_lo .LT. unspecified_int4 .AND.
     .              srcss_hi .GT. unspecified_int4

        dstss_lo = cx_lo_ss(cx_lims,axis)
        dstss_hi = cx_hi_ss(cx_lims,axis)

* flag for bad/missing data
        bad_src = mr_bad_data(msrc)
        bad_dst = mr_bad_data(mdst)

* determine the source grid boxes containing the destination box edges
	CALL GET_AVE_LIMS( srcss_lo, srcss_hi, src_grid,
     .			   dstss_lo, dstss_hi, dst_grid,
     .			   axis, ss21 )

* along X axis
        IF ( axis .EQ. x_dim ) THEN
           DO 190 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
           DO 190 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
           DO 190 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
           DO 190 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
           DO 190 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)

* loop through the each destination grid box
	   DO 160 dstss = dstss_lo,dstss_hi
	      srcss_lo = ss21(dstss-dstss_lo+1)
	      srcss_hi = ss21(dstss-dstss_lo+2)

*  check if requested region is out of source range
              IF ( (srcss_lo .EQ. unspecified_int4
     .	     .OR.  srcss_hi .EQ. unspecified_int4)
     .       .AND. .NOT.(ok_neg111) ) THEN
	         dst(dstss,j,k,l,m,n) = bad_dst
	         goto 160
	      ENDIF

	      xdst_lo = TM_WORLD(dstss, dst_grid, axis, box_lo_lim )
	      xdst_hi = TM_WORLD(dstss, dst_grid, axis, box_hi_lim )

* add all partial or complete boxes of data from the source grid

* IF source box completely encloses the dest box, then srcss_lo=srcss_hi
* and we can just stick the source point into the destination (for avg or var)
	      sum = 0.0D0
	      nsrc_in_dst = 0.0D0
	      DO 110 srcss = srcss_lo, srcss_hi

* ... ignore missing source data
	         IF ( src(srcss, j, k, l, m, n) .EQ. bad_src ) GOTO 110

	         xsrc_pt = TM_WORLD(srcss,src_grid,axis,box_middle)
	         coord_in_dst = (xsrc_pt.GE.xdst_lo .AND. xsrc_pt.LT.xdst_hi) 

* ... source point in dest box
                 IF (coord_in_dst) THEN
	            nsrc_in_dst = nsrc_in_dst + 1
	            sum   = sum  + src(srcss, j, k, l, m, n)
	         ENDIF 
 
 110	      CONTINUE


* ... divide by npts in bin for @BIN or return # pts for @NBIN

	      IF (trans.EQ.prgrd_bin ) THEN

	         IF ( nsrc_in_dst .EQ. 0.0 ) THEN
	            dst(dstss, j, k, l, m, n) = bad_dst
	        ELSE
	            dst(dstss, j, k, l, m, n) = sum / nsrc_in_dst
	        ENDIF

	      ELSEIF ( trans.EQ.prgrd_nbin ) THEN
	         dst(dstss, j, k, l, m, n) = nsrc_in_dst
	      ENDIF

 160	   CONTINUE
 190	   CONTINUE

* along Y axis
        ELSEIF ( axis .EQ. Y_dim ) THEN

           DO 290 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
           DO 290 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
           DO 290 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
           DO 290 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
           DO 290 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* loop through the each destination grid box
	   DO 260 dstss = dstss_lo,dstss_hi
	      srcss_lo = ss21(dstss-dstss_lo+1)
	      srcss_hi = ss21(dstss-dstss_lo+2)

*  check if requested region is out of source range
              IF ( (srcss_lo .EQ. unspecified_int4
     .	     .OR.  srcss_hi .EQ. unspecified_int4)
     .       .AND. .NOT.(ok_neg111) ) THEN
	         dst(i,dstss,k,l,m,n) = bad_dst
	         goto 260
	      ENDIF

	      xdst_lo  = TM_WORLD(dstss, dst_grid, axis, box_lo_lim )
	      xdst_hi  = TM_WORLD(dstss, dst_grid, axis, box_hi_lim )

* add all partial or complete boxes of data from the source grid

* IF source box completely encloses the dest box, then srcss_lo=srcss_hi
* and we can just stick the source point into the destination (for avg or var)
	      sum = 0.0D0
	      nsrc_in_dst = 0.0D0
	      DO 210 srcss = srcss_lo, srcss_hi

* ... ignore missing source data
	         IF ( src(i, srcss, k, l, m, n) .EQ. bad_src ) GOTO 210

	         xsrc_pt = TM_WORLD(srcss,src_grid,axis,box_middle)
	         coord_in_dst = (xsrc_pt.GE.xdst_lo .AND. xsrc_pt.LT.xdst_hi)

* ... source point in dest box
                 IF (coord_in_dst) THEN
	            nsrc_in_dst = nsrc_in_dst + 1
	            sum   = sum  + src(i, srcss, k, l, m, n)
	         ENDIF 
 
 210	      CONTINUE

* ... divide by npts in bin for @BIN or return # pts for @NBIN

	      IF (trans.EQ.prgrd_bin ) THEN
	         IF ( nsrc_in_dst .EQ. 0.0 ) THEN
	            dst(i, dstss, k, l, m, n) = bad_dst
	         ELSE
	            dst(i, dstss, k, l, m, n) = sum / nsrc_in_dst
	         ENDIF
	      ELSEIF ( trans.EQ.prgrd_nbin ) THEN
	         dst(i, dstss, k, l, m, n) = nsrc_in_dst
	      ENDIF

 260	   CONTINUE
 290	   CONTINUE

* along Z axis
        ELSEIF ( axis .EQ. z_dim ) THEN

           DO 390 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
           DO 390 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
           DO 390 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
           DO 390 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
           DO 390 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* loop through the each destination grid box
	   DO 360 dstss = dstss_lo,dstss_hi
	      srcss_lo = ss21(dstss-dstss_lo+1)
	      srcss_hi = ss21(dstss-dstss_lo+2)

*  check if requested region is out of source range
              IF ( (srcss_lo .EQ. unspecified_int4
     .	     .OR.  srcss_hi .EQ. unspecified_int4)
     .       .AND. .NOT.(ok_neg111) ) THEN
	         dst(i,j,dstss,k,m,n) = bad_dst
	         goto 360
	      ENDIF

	      xdst_lo = TM_WORLD(dstss, dst_grid, axis, box_lo_lim )
	      xdst_hi = TM_WORLD(dstss, dst_grid, axis, box_hi_lim )

* add all partial or complete boxes of data from the source grid

* IF source box completely encloses the dest box, then srcss_lo=srcss_hi
* and we can just stick the source point into the destination (for avg or var)
	      sum = 0.0D0
	      nsrc_in_dst = 0.0D0
	      DO 310 srcss = srcss_lo, srcss_hi

* ... ignore missing source data
	         IF ( src(i, j, srcss, l, m, n) .EQ. bad_src ) GOTO 310

	         xsrc_pt = TM_WORLD(srcss,src_grid,axis,box_middle)

	         coord_in_dst = (xsrc_pt.GE.xdst_lo .AND. xsrc_pt.LT.xdst_hi)

* ... source point in dest box
                 IF (coord_in_dst) THEN
	            nsrc_in_dst = nsrc_in_dst + 1
	            sum   = sum  + src(i, j, srcss, l, m, n)
	         ENDIF 
 
 310	      CONTINUE

* ... divide by npts in bin for @BIN or return # pts for @NBIN

	      IF (trans.EQ.prgrd_bin ) THEN
	         IF ( nsrc_in_dst .EQ. 0.0 ) THEN
	            dst(i, j, dstss, l, m, n) = bad_dst
	         ELSE
	            dst(i, j, dstss, l, m, n) = sum / nsrc_in_dst
	         ENDIF
	      ELSEIF ( trans.EQ.prgrd_nbin ) THEN
	         dst(i, j, dstss, l, m, n) = nsrc_in_dst
	      ENDIF

 360	   CONTINUE
 390	   CONTINUE

* along T axis
        ELSEIF ( axis .EQ. T_dim ) THEN

           DO 490 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
           DO 490 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
           DO 490 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
           DO 490 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
           DO 490 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* loop through the each destination grid box
	   DO 460 dstss = dstss_lo,dstss_hi
	      srcss_lo = ss21(dstss-dstss_lo+1)
	      srcss_hi = ss21(dstss-dstss_lo+2)

*  check if requested region is out of source range
              IF ( (srcss_lo .EQ. unspecified_int4
     .	     .OR.  srcss_hi .EQ. unspecified_int4)
     .       .AND. .NOT.(ok_neg111) ) THEN
	         dst(i,j,k,dstss,m,n) = bad_dst
	         goto 460
	      ENDIF

* USE SOURCE GRID TIME/DATE ENCODINGS FOR ALL CALCULATIONS 6/94
* initialization of TDEST_WORLD is done from GET_AVE_LIMS

	      xdst_lo = TDEST_WORLD(dstss, dst_grid, axis, box_lo_lim)
	      xdst_hi = TDEST_WORLD(dstss, dst_grid, axis, box_hi_lim)

* add all partial or complete boxes of data from the source grid

* IF source box completely encloses the dest box, then srcss_lo=srcss_hi
* and we can just stick the source point into the destination (for avg or var)
	      sum = 0.0D0
	      nsrc_in_dst = 0.0
	      DO 410 srcss = srcss_lo, srcss_hi

* ... ignore missing source data
	         IF ( src(i, j, k, srcss, m, n) .EQ. bad_src ) GOTO 410
	         xsrc_pt = TM_WORLD(srcss,src_grid,axis,box_middle)

	        coord_in_dst = (xsrc_pt.GE.xdst_lo .AND. xsrc_pt.LT.xdst_hi) 

* ... source point in dest box
                 IF (coord_in_dst) THEN
	            nsrc_in_dst = nsrc_in_dst + 1
	            sum   = sum  + src(i, j, k, srcss, m, n)
	         ENDIF 

 410	      CONTINUE

* ... divide by npts in bin for @BIN or return # pts for @NBIN

	      IF (trans.EQ.prgrd_bin ) THEN
	         IF ( nsrc_in_dst .EQ. 0.0 ) THEN
	            dst(i, j, k, dstss, m, n) = bad_dst
	         ELSE
	            dst(i, j, k, dstss, m, n) = sum / nsrc_in_dst
	         ENDIF
	      ELSEIF ( trans.EQ.prgrd_nbin ) THEN
	         dst(i, j, k, dstss, m, n) = nsrc_in_dst
	      ENDIF

 460	   CONTINUE
 490	   CONTINUE

* along E axis
        ELSEIF ( axis .EQ. e_dim ) THEN

           DO 590 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
           DO 590 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
           DO 590 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
           DO 590 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
           DO 590 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* loop through the each destination grid box
	   DO 560 dstss = dstss_lo,dstss_hi
	      srcss_lo = ss21(dstss-dstss_lo+1)
	      srcss_hi = ss21(dstss-dstss_lo+2)

*  check if requested region is out of source range
              IF ( (srcss_lo .EQ. unspecified_int4
     .	     .OR.  srcss_hi .EQ. unspecified_int4)
     .       .AND. .NOT.(ok_neg111) ) THEN
	         dst(i,j,k,l,dstss,n) = bad_dst
	         goto 560
	      ENDIF

* USE SOURCE GRID TIME/DATE ENCODINGS FOR ALL CALCULATIONS 6/94
* initialization of TDEST_WORLD is done from GET_AVE_LIMS

	      xdst_lo = TDEST_WORLD(dstss, dst_grid, axis, box_lo_lim)
	      xdst_hi = TDEST_WORLD(dstss, dst_grid, axis, box_hi_lim)

* add all partial or complete boxes of data from the source grid

* IF source box completely encloses the dest box, then srcss_lo=srcss_hi
* and we can just stick the source point into the destination (for avg or var)
	      sum = 0.0D0
	      nsrc_in_dst = 0.0
	      DO 510 srcss = srcss_lo, srcss_hi

* ... ignore missing source data
	         IF ( src(i, j, k, l, srcss, n) .EQ. bad_src ) GOTO 510

	         xsrc_pt = TM_WORLD(srcss,src_grid,axis,box_middle)
	         coord_in_dst = (xsrc_pt.GE.xdst_lo .AND. xsrc_pt.LT.xdst_hi) 

* ... source point in dest box
                 IF (coord_in_dst) THEN
	            nsrc_in_dst = nsrc_in_dst + 1
	            sum   = sum  + src(i, j, k, l, srcss, n)
	         ENDIF 
 510	      CONTINUE

* ... divide by npts in bin for @BIN or return # pts for @NBIN

	      IF (trans.EQ.prgrd_bin ) THEN
	         IF ( nsrc_in_dst .EQ. 0.0 ) THEN
	            dst(i, j, k, l, dstss, n) = bad_dst
	         ELSE
	            dst(i, j, k, l, dstss, n) = sum / nsrc_in_dst
	         ENDIF
	      ELSEIF ( trans.EQ.prgrd_nbin ) THEN
	         dst(i, j, k, l, dstss, n) = nsrc_in_dst
	      ENDIF

 560	   CONTINUE
 590	   CONTINUE

* along F axis
        ELSEIF ( axis .EQ. f_dim ) THEN

           DO 690 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
           DO 690 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
           DO 690 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
           DO 690 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
           DO 690 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* loop through the each destination grid box
	   DO 660 dstss = dstss_lo,dstss_hi
	      srcss_lo = ss21(dstss-dstss_lo+1)
	      srcss_hi = ss21(dstss-dstss_lo+2)

*  check if requested region is out of source range
              IF ( (srcss_lo .EQ. unspecified_int4
     .	     .OR.  srcss_hi .EQ. unspecified_int4)
     .       .AND. .NOT.(ok_neg111) ) THEN
	         dst(i,j,k,l,m,dstss) = bad_dst
	         goto 660
	      ENDIF

* USE SOURCE GRID TIME/DATE ENCODINGS FOR ALL CALCULATIONS 6/94
* initialization of TDEST_WORLD is done from GET_AVE_LIMS

	      xdst_lo = TDEST_WORLD(dstss, dst_grid, axis, box_lo_lim)
	      xdst_hi = TDEST_WORLD(dstss, dst_grid, axis, box_hi_lim)

* add all partial or complete boxes of data from the source grid

* IF source box completely encloses the dest box, then srcss_lo=srcss_hi
* and we can just stick the source point into the destination (for avg or var)
	      sum = 0.0D0
	      nsrc_in_dst = 0.0
	      DO 610 srcss = srcss_lo, srcss_hi

* ... ignore missing source data
	         IF ( src(i, j, k, l, m, srcss) .EQ. bad_src ) GOTO 610

	         xsrc_pt = TM_WORLD(srcss,src_grid,axis,box_middle)
	         coord_in_dst = (xsrc_pt.GE.xdst_lo .AND. xsrc_pt.LT.xdst_hi) 

* ... source point in dest box
                 IF (coord_in_dst) THEN
	            nsrc_in_dst = nsrc_in_dst + 1
	            sum   = sum  + src(i, j, k, l, m, srcss)
	         ENDIF 
 610	      CONTINUE

* ... divide by npts in bin for @BIN or return # pts for @NBIN

	      IF (trans.EQ.prgrd_bin ) THEN
	         IF ( nsrc_in_dst .EQ. 0.0 ) THEN
	            dst(i, j, k, l, m, dstss) = bad_dst
	         ELSE
	            dst(i, j, k, l, m, dstss) = sum / nsrc_in_dst
	         ENDIF
	      ELSEIF ( trans.EQ.prgrd_nbin ) THEN
	         dst(i, j, k, l, m, dstss) = nsrc_in_dst
	      ENDIF

 660	   CONTINUE
 690	   CONTINUE

        ENDIF

	RETURN
	END

	SUBROUTINE DO_EVENT_DSG( idim, arg, dset, nfeatures, maxobs,
     .				com, com_mr, com_cx,
     .				res, res_mr, res_cx )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* the indicated argument value is regarded as an "event threshhold".
* Any time that the component variable crosses or lands on this value
* an "event" occurs and the output should step up by "1" to indicate it.
* If an exact match occurs, step up ON that value.
* If a crossing occurs, step up on the first value AFTER the crossing.  
*  * for data on Distributed Sampling Geometries grids - operate on each feature


* Ansley Manke
* NOAA/PMEL, Seattle, WA - Science Data Integration Group
*  3/2019
* V76   1/20 *acm* Orientation of Point-type data set to e_dim

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include	'xdset_info.cmn_text'
	include 'xdyn_linemem.cmn_text'

* calling argument declarations:
	INTEGER	idim, wlen, dset, nfeatures, maxobs,
     .		com_mr, com_cx, res_mr, res_cx
	REAL	arg, 
     .          com   ( * ),
     .          res   ( * )

* internal variable declarations:
	LOGICAL fmask(nfeatures), omask(maxobs), first_pt, first_lt 
	INTEGER	i, ifeature, iobs,flen, base, orientation, 
     .          row_size_lm, step_val
	REAL    bad_com, bad_res, comp


* initialize
	bad_com = mr_bad_data( res_mr )
	bad_res = mr_bad_data( com_mr )
	
* DSG-specific initialize
	orientation = dsg_orientation(dset)
	row_size_lm = dsg_loaded_lm(dsg_row_size_var(dset))

* get feature mask
        CALL MAKE_DSG_FEATURE_MASK(dset, res_cx, fmask, nfeatures)


* ****** PERFORM THE COMPUTATION *****

	IF (idim.EQ.orientation .AND. orientation.LE.t_dim) THEN 
* *** true ragged array processing:
* find events along each feature
* skip data masked out by WW masking on the obs axis

*** currently this is the max-smoother: needs event logic

	   base = 0    ! obs index at end of preceding feature
* ... loop over the features
	   DO ifeature = 1, nfeatures 

	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length

* ... have the user's constraints removed this feature?

	      IF (.NOT.fmask(ifeature)) THEN
                 base = base + flen
                 CYCLE
              ENDIF

* ... get observation-level mask for this feature
	      CALL MAKE_DSG_OBS_MASK(dset, com_cx, ifeature, base,
     .				     omask, flen)

* ... loop over the observations within each feature

              first_pt = .TRUE.
	      step_val = 0

              iobs = base
	      DO i = 1, flen
	         iobs = iobs + 1
		 
	         IF (.NOT.omask(i)) CYCLE

	         comp = com(iobs)
                 IF ( comp .EQ. bad_com ) THEN
                    first_pt = .TRUE.
	         ELSEIF (comp .EQ. arg) THEN
	            step_val = step_val + 1
	            first_pt = .TRUE.
		 ELSEIF ( first_pt ) THEN
* ... first non-bad value
                    first_pt = .FALSE.
                    first_lt = comp .LT. arg
                 ELSEIF ( first_lt .NEQV. (comp .LT. arg) ) THEN
* ... found a "crossing"
	            step_val = step_val + 1
	            first_lt = .NOT. first_lt
                 ENDIF

	         res(iobs) = DBLE(step_val)

	      ENDDO
	      base = base + flen
	   ENDDO

	ELSE

* *** a simple list of instances:
* Process all features -- ignoring mask -- for the reasons stated in the intro

	   DO ifeature = 1, nfeatures 

	      comp = com(ifeature)
	      IF ( comp.EQ.bad_com .OR. comp.EQ.dsg_masked_out_flag) THEN
	         first_pt = .TRUE.
	      ELSEIF (comp .EQ. arg) THEN
	         step_val = step_val + 1
	         first_pt = .TRUE.
	      ELSEIF ( first_pt ) THEN
* ... first non-bad value
	         first_pt = .FALSE.
	         first_lt = comp .LT. arg
	      ELSEIF ( first_lt .NEQV. (comp .LT. arg) ) THEN
* ... found a "crossing"
	         step_val = step_val + 1
	         first_lt = .NOT. first_lt
	      ENDIF

	      res(ifeature) = DBLE(step_val)

	   ENDDO

	ENDIF

	RETURN
	END

	SUBROUTINE CLEAR_WINDOW( wid )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* clear full window and close metafile

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:   4/2/90
* V230: 11/19/92 - clear protected colors
* V411:  9/5/95 - explicitly delete each segment before calling GCLRWK
*	to avoid XGKS memory leak in that routine
* V602: *acm* 1/07 Changes for metafile-batch mode
* V76  *acm* 3/20  issue 1970: Check the window is open before trying to CLEAR it

        IMPLICIT NONE
	include 'plot_setup.parm'
	include 'xplot_state.cmn'		! viewport info
	include	'pltcom_dat.decl'	! with gksopn
	include	'PLTCOM.DAT'	! with gksopn

* calling argument declarations:
	INTEGER	wid, ivp, iseg, istate

* internal variable declarations:

	IF ( .NOT. wn_open(wid) ) RETURN

        CALL GQOPS (istate)

! --- start of 9/95 addition
* explicitly delete segments to avoid XGKS memory leak
	DO 200 ivp =  mvp_dflt, max_viewport
	   IF ( vp_segn(ivp) .NE. 0 ) THEN 
	      DO 100 iseg = vp_seg0(ivp)+1 , vp_segn(ivp)
 100	       IF ( gksopn .AND. (istate .GE. 2) ) CALL GDSG( iseg ) 
	   ENDIF
*  and mark segment as deleted
	   vp_seg0(ivp) = 0
	   vp_segn(ivp) = 0
 200	CONTINUE
! --- end of 9/95 addition

* tell GKS to clear the named "workstation" (window)

        CALL GQOPS (istate)
	IF (istate .GE. 2) CALL GCLRWK(wid,0)

* tell PPLUS to close the metafile if it's open
	CALL PPLCMD ( from, line, 0, 'CLSPLT', 1, 1 )

* tell PPLUS to release protected colors (on viewports and overlays)
        CALL PPL_SHASET( 'RESET' )

	RETURN
	END

	SUBROUTINE TM_GARB_COL_LINES ( first, last )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* garbage collect wasted space in newly defined lines (axes)

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 2/92
*
* IBM PORT 14apr94 *kob* : Port to IBM revealed a transfer controll problem at 
*			   around label 200.  A "goto" statment was passing
*			   control to a continue statment.
* V500: 7/99 *sh* - bug fix: need consistent use of char_init16 on line_name
*		    bug fix: invalid branch at 4/94 fix -- was hidden all
*			     this time because line_name check was invalid
*			     so code was never executed
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing

* argument definitions:
*       first   - highest number line to check
*       last    - lowest number line to check
* note: lines are allocated from high to low

* include files

	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'xtm_grid.cmn_text'
	
* argument declarations
	INTEGER	 first, last

* local variable declarations:
      INTEGER iaxis, hiaxis, igrid, i, idim, next_mem, freed_mem

* there is no way that grids can be using unnamed axes
* delete 'em incrementing the grid axis pointers and compacting line memory

* initialize axis loop
!  like: DO 400 iaxis = first, last   but hiaxis keeps shifting down
      iaxis = first
      hiaxis = last
      IF (first .GT. last) RETURN

* is this a hole ?
 10     IF ( line_name(iaxis) .NE. char_init16 ) GOTO 400

* modify axis pointer saved in the grids
           DO 110 igrid = 1, max_grids
              IF ( grid_name(igrid) .EQ. char_init ) GOTO 110
              DO 100 idim = 1, nferdims
                 IF ( grid_line(idim, igrid) .EQ. iaxis )
     .         write (6,*) 'grid defns are garbled!: TM_GRID_GARBAGE' ! diag
                 IF ( grid_line(idim, igrid) .GT. iaxis
     .          .AND. grid_line(idim, igrid) .LE. hiaxis )
     .                grid_line(idim,igrid) = grid_line(idim,igrid) - 1
 100          CONTINUE
 110       CONTINUE

* is there line memory to free ?
* this next goto was 200, but the IBM compiler wouldn't accept a 
* transfer of control to a continue statment.  *kob* 14apr94
* 7/99 *sh* for regular lines skip over line_subsc and line_mem code
           IF ( line_regular(iaxis) ) GOTO 295	! was 205 pre 7/00 (bug)

* look ahead to the next line with uneven point spacing 
           DO 200 i = iaxis+1, hiaxis
              IF ( .NOT.line_regular(i) ) THEN
                 next_mem = line_subsc1(i)
                 GOTO 210
              ENDIF
 200       CONTINUE
 205       next_mem  = next_line_mem_pos
 210       freed_mem = next_mem - line_subsc1(iaxis)

* shift this much line memory to fill the hole
           DO 250 i = next_mem, next_line_mem_pos
 250       line_mem(i-freed_mem) = line_mem(i)

* update line memory pointers
           DO 280 i = iaxis+1, hiaxis
              IF ( .NOT.line_regular(i) ) THEN
                 line_subsc1(i) = line_subsc1(i) - freed_mem
              ENDIF
 280       CONTINUE
           next_line_mem_pos = next_line_mem_pos - freed_mem
           
* shift all the definitions back to fill the hole
 295	   DO 300 i = iaxis+1, hiaxis
 300       CALL TM_COPY_LINE( i, i-1 )

* initialize new hole at end
           line_name(hiaxis) = char_init16
           line_subsc1(hiaxis) = unspecified_int4
           hiaxis = hiaxis - 1
           iaxis = iaxis - 1   ! nullify decrement below

! like: 400    CONTINUE
 400    iaxis = iaxis + 1
        IF ( iaxis .LE. hiaxis ) GOTO 10

* successful completion
        RETURN

	END

	SUBROUTINE ALL_1_ARG

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* treat all the arguments identified by PARSE_COMMAND as a single argument
* example cases that this has to address:
*	message "hello world" 
*	message "hello" "world"
*	message " "hello" "world" "     - unclear what to do ...

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V300: 4/22/93
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
* V694 2/2015 *sh* - handle _DQ_ like double quote
*      *acm*  2/15 Prevent run-time errors in string length for _DQ_ handling

* calling argument declarations:

* internal variable declarations:
	INTEGER i

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xprog_state.cmn'

* reset the command common to look like a single big argument

	IF ( num_args .GT. 1 ) THEN

	   arg_end(1) = arg_end(num_args)

* protect against lost " from start of:  message "hello" "world"
	   i = arg_start(1) - 1
	   IF ( cmnd_buff(i:i) .EQ. '"' ) arg_start(1) = i

* protect against lost " from end of:  message "hello" "world"
	   i = arg_end(1) + 1
	   IF ( i .LE. len_cmnd ) THEN
	      IF ( cmnd_buff(i:i) .EQ. '"' ) arg_end(1) = i
	   ENDIF

* (2/15) kind of pathological cases, but what the heck ...
* protect against lost _DQ_ from start of:  message _DQ_hello_DQ_ _DQ_world_DQ_
	   i = arg_start(1) - 4
	   IF (i .GE. 4) THEN
	      IF ( cmnd_buff(i:i+3) .EQ. '_DQ_' ) arg_start(1) = i
	   ENDIF

* protect against lost _DQ_ from end
	   i = arg_end(1) + 4
	   IF ( i .LE. len_cmnd ) THEN
	      IF ( cmnd_buff(i-3:i) .EQ. '_DQ_' ) arg_end(1) = i
	   ENDIF

	   num_args = 1

	ENDIF

	RETURN
	END

      SUBROUTINE VIEW3(XREF,YREF,ZREF,XDIR,YDIR,ZDIR,DIST)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)view3.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     CALL VIEW3(XREF,YREF,ZREF,XDIR,YDIR,ZDIR,DIST)
C
C     THIS SUBROUTINE ESTABLISHES CONTROL INFORMATION FOR THREE-
C     DIMENSIONAL PROJECTIONS.
C
C     THE VARIOUS PARAMETERS AND THEIR DEFINITIONS ARE LISTED
C     BELOW:
C        XREF   - X-COORDINATE OF THE REFERENCE POINT FOR THE
C                 PROJECTION IN USER'S UNITS.
C        YREF   - Y-COORDINATE OF THE REFERENCE POINT FOR THE
C                 PROJECTION IN USER'S UNITS.
C        ZREF   - Z-COORDINATE OF THE REFERENCE POINT FOR THE
C                 PROJECTION IN USER'S UNITS.
C        XDIR   - X-DIRECTION NUMBER OF THE VIEWING DIRECTION
C                 IN USER'S UNITS.
C        YDIR   - Y-DIRECTION NUMBER OF THE VIEWING DIRECTION
C                 IN USER'S UNITS.
C        ZDIR   - Z-DIRECTION NUMBER OF THE VIEWING DIRECTION
C                 IN USER'S UNITS.
C        DIST   - DISTANCE IN THE VIEWING DIRECTION FROM THE
C                 CENTER OF PROJECTION TO THE REFERENCE POINT
C                 IN INCHES (OR MM).
C
C
#ifdef unix
	include 'PLTCOM.DAT'
#else
	include 'pplinc:PLTCOM.DAT'
#endif
C
      IF(XDIR .NE. 0.0 .OR. YDIR .NE. 0.0 .OR. ZDIR .NE. 0.0)
     * THEN
C
C     SET THE VIEW FLAG.
C
        VIEWF = .TRUE.
C
C     SCALE THE DIRECTION NUMBERS.
C
        XABS = XDIR * XSCALE
        YABS = YDIR * YSCALE
        ZABS = ZDIR * ZSCALE
C
C     COMPUTE THE SINE AND COSINE OF THE ANGLES OF ROTATION.
C
        DISTA = SQRT(XABS * XABS + YABS * YABS + ZABS * ZABS)
        DISTB = SQRT(XABS * XABS + ZABS * ZABS)
        SINA = YABS / DISTA
        COSA = DISTB / DISTA
        IF(DISTB .EQ. 0.0)THEN
          SINB = 0.0
          COSB = 1.0
        ELSE
          SINB = XABS / DISTB
          COSB = ZABS / DISTB
        ENDIF
C
C     COMPUTE THE ELEMENTS OF THE TRANSFORMATION MATRIX.
C
        TAX = COSB
        TAY = 0.0
        TAZ = -SINB
        TBX = -SINA * SINB
        TBY = COSA
        TBZ = -SINA * COSB
        TCX = COSA * SINB
        TCY = SINA
        TCZ = COSA * COSB
C
C     SCALE THE REFERENCE POINT.
C
        XABS = XREF * XSCALE
        YABS = YREF * YSCALE
        ZABS = ZREF * ZSCALE
C
C     TRANSFORM THE REFERENCE POINT.
C
        AREF = XABS * TAX + YABS * TAY + ZABS * TAZ
        BREF = XABS * TBX + YABS * TBY + ZABS * TBZ
        CREF = XABS * TCX + YABS * TCY + ZABS * TCZ
C
C     CONVERT THE VIEW DISTANCE TO INTERNAL INCREMENTS.
C
        VDIST = FACTOR * DIST
      ELSE
C
C     RESET THE VIEW FLAG.
C
        VIEWF = .FALSE.
      ENDIF
      RETURN
C
      END

c..........svdeof-4.f: Do EOFs with either NX > NT or NT > NX

c   User description:
c..........Subroutine finds "traditionally-scaled" EOFs using SVD routine.
c.........."Traditionally-scaled" means that the units of the EOFs are the
c..........  units of the variable, while the TAFs are dimensionless.
c..........Routine is based on Numerical Recipes routine svdcmp.f.
c..........Result of EOF decomposition is that a function f(x,t) of space and  
c..........  time is decomposed into a sum of products: f(x,t) = SUM[v(x)*a(t)].
c..........The v(x) are referred to as the EOFs, or eigenvectors, while the
c..........  a(t) are the "Time Amplitude Functions" (TAFs) (Also called
c..........  "Principal Components") 
c..........The number of terms in the sum (number of non-zero EOFs)  
c..........  is the minimum of (# of locations,# of times). 

c..........Much CPU is saved by choosing to do the EOFs according to which of
c..........NX,NT is larger, since the number of nonzero eigenvalues is min(NX,NT).
c..........The routine can be called with any (NX,NT) (makes the choice automatically)

c---------------------------------------------------------------------------
c.....Use: call the front-end routine DO_SVD_EOF with the following arguments:

c    A(NX,NT)	I/O	data set to be decomposed => returned as TAFs(neof,time)
c    NX			I	# of spatial locations in data set A
c    NT			I	# of time realizations in data set A
c    W(NX)	O	eigenvalues of decomposition
c    V(NX,NX)	O	EOFs in columns (V(space,neof))
c    PCT(NX)	O	% variance represented by each EOF

c   Notes:
c..........In the "standard" form, NT.ge.NX (more times than locations),
c..........there are NX non-zero EOFs and the output arrays are full.
c..........In the reversed form, NT.lt.NX (more locations than times),
c..........there are only NT non-zero EOFs (remaining values are zero).

c...>>>>....Data input matrix A is destroyed on output (overwritten with TAFs).
c...>>>>....Writes error messages to unit 6.
c...>>>>....There are 2 hardwired values in these routines:
c			IWRK=200000, declared in DO_SVD_EOF for use in sub MATRIXTRANS
c				IWRK must be at least (NX+NT)/2 (array MOVE(IWRK)).
c			NMAX=100000, declared in SVDEOF (workspace vectors RV1 and INDX)
c				NMAX is the maximum size of the smaller of (NX,NT)

c...........Included subroutines, called by DO_SVD_EOF (no external routines required)
c			FIX_V (rearranges array V in the case of reversed EOFs) (comments at fix_v)
c			SCALING (does "traditional scaling")
c			DEMEAN (demeans input data)
c			SVDEOF (modified Numerical Recipes routine SVDCMP)
c			INDEXX (NR routine to sort eigenvalues to size order)
c			MATRIXTRANS (matrix transpose routine from U.Kent, UK)
c			SWITCH_A_V (switches (back) the roles of A and V if reversed EOFS)

c   History:
c...........Based on Numerical Recipes subroutine svdcmp.
c...........Aug 1992: svdeof-1.f: svdcmp2 modified to transpose input array A 
c...........  to usual form: A(N,M), where N is space and M is time. M.ge.N.
c...........May 1998: Sorting EOFs by size of eigenvalue (svdeof-2.f).
c...........Jun 1006: svdeof-4.f handles either NX>NT or NT>NX
c...........Everything beyond svdcmp programmed by Billy Kessler (NOAA/PMEL)

c ......... 7/2012 ACM Implement as Ferret external function. Workspace is allocated
c ......... and sent in to the function. A status flag is returned.

c*********************************************************************

c.......Front-end subroutine to choose which way to do the EOFs, based on size of M and N.
c.......DO_SVD_EOF is called from the main program, and calls SVDEOF to do the work.

c..........It is assumed that the input data is A(space,time) (NX,NT).

	SUBROUTINE DO_SVD_EOF (A, NX, NT, w, v, pct, move, work2, work3, ier)
        IMPLICIT REAL(A-H, O-Z), INTEGER(I-N)
c...................................maximum size of (m+n)/2.
cc	PARAMETER (iwrk=200000)		! HARDWIRING
	INTEGER ier

c...........it is ok to use NX for dim(W,V,PCT) because that is really NEOF
c...........which is the minimum of (NX,NT)
	real A(NX,NT),W(NX),V(NX,NX),pct(NX), work2(*), work3(*)

c......................................internal arrays.
	integer move(*)
	INTEGER iwrk
	iwrk = (nx+nt)/2

c-----------------------------------------------------------------------
c........check that enough space is provided in hardwired array (iwrk)
cc	if ((nx+nt)/2.gt.iwrk) then
cc	   	write(6,*) '(nx+nt)/2.gt.',iwrk,' in routine DO_SVD_EOF. Error. Returning.'
cc	   	return
cc	endif
	
c.................demean data array A. (Do first to handle either transpose)
c.................now do by subroutine to allow A to be A(NX*NT).
	call demean (a, nx, nt)
	
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
c........IF-block to work with either usual or reversed EOFs

c........find out whether NX or NT is smaller
	if (nt.ge.nx) then		! more times than locations = usual EOFs

		call svdeof(a, nt, nx, w, v, pct, work2, work3, ier)		! do the work
		IF (ier .NE. 0) RETURN

c...........NEOF=NX nonzero EOFs 
c...........EOFs in V(NX,NEOF)   NX = NEOF
c...........TAFs in A(NEOF,NT)   NT > NEOF

c...........do the "traditional scaling"
		call scaling(a, nx, nt, w, v, pct, nx)
		
	else					! more locations than times. Must reverse order

c..........transpose the input data array A(NX,NT)
c..........after transpose, A is used as A(NT,NX)=(time,space)
c..........(but this can only be done in a sub call where A is just an address)
		call MATRIXTRANS(a,nx,nt,nt*nx,move,iwrk,iok)	

c............now call the SVD calculation with transposed data array A
		call svdeof(a, nx, nt, w, v, pct, work2, work3, ier)
		IF (ier .NE. 0) RETURN
		
c......There are NEOF=NT nonzero EOFs (note NT < NX). 

c......The EOFs are in A(NEOF=NT,NX) which is filled. 
c......It must be transposed to be in the same order as the usual case
c......(but note it is not square as are the usual EOFs stored in V(NX,NX))
		call MATRIXTRANS(a,nt,nx,nt*nx,move,iwrk,iok)

c......The output of SVDEOF makes use of W(NT), PCT(NT) and V(NT,NT).
c......W and PCT are OK as is, since they are 1-d vectors, but the
c......needed elements of V are stored as a sequence of length NT*NT, 
c......(NT TAFs in sequence, followed by zeroes), stored in an actual 
c......array V(NX,NX) (recall NX > NT).
c......Fix V in a subroutine: 
c......Place each TAF running down sequential columns of V(NX,NX).
c......When this is done, the TAFs take up an NT by NT square in the 
c......upper left corner of the larger array V(NX,NX).
		call fix_v(v,nt,nx)
				
c......Transpose V to get the usual order, but note the zeroes. 
c......Must give the complete size of V to the transpose routine.
		call MATRIXTRANS(v,nx,nx,nx*nx,move,iwrk,iok)

c......Note reversal of position of A and V in this call.
		call scaling(v, nx, nt, w, a, pct, nt)
		
c......Switch the EOFs and TAFs to V and A, respectively.
c......Also clean up by zeroing out the unused parts (also W and PCT).
		call switch_a_v(a,v,w,pct,nx,nt)
				
	endif
	
	return
	end
	
c*********************************************************************
c.....subroutine to switch (back) the roles of A and V in the case of reversed EOFS.
c.....The result is that the EOFs are in the columns of V, and the TAFs in the rows of A.
c.....This works because NT < NX. The original array V(NX,NX) only contains the
c.....TAFS in a square (NT,NT) in its upper left corner, so there is at least one
c.....free column at the right side of V, for work space.

c.....Also clean up by zeroing out the unused parts (including W and PCT)

c.....Method:
c	1) move the last (n=NEOF=NT) column of A to the last column (NX) of V
c	2) move the final element of each TAF from V(n,NT) to A(n,NT)
c	3) repeat (1) and (2) with the second-last column and second-last elements
c	   continue the above operations NT times
c	4) shift the rows of V (EOFs) over to the left side of V

	subroutine switch_a_v(a,v,w,pct,nx,nt)
	IMPLICIT REAL(A-H, O-Z), INTEGER(I-N)

	real a(nx,nt), v(nx,nx)
	real w(nx), pct(nx)
	
c......move the elements to the other array
	do 10 n=1,nt	! column number (nt-n+1 or nx-n+1)
	do 11 i=1,nx	! row number
11	v(i,nx-n+1)=a(i,nt-n+1)
	do 12 l=1,nt   ! row number in both (shift to same position in other array)
12	a(nt-l+1,nt-n+1)=v(nt-l+1,nt-n+1)
10	continue

c.....shift the EOFs to the first columns of V
c.....the first one is in column (NX-NT+1)
	do 20 i=1,nx
	do 21 n=1,nt
21	v(i,n)=v(i,n+nx-nt)
20	continue

c.....clean up by zeroing out the bottom of A and right side of V
	do 30 i=1,nx
	do 31 n=nt+1,nx
31	v(i,n)=0.
30	continue

	do 40 n=nt+1,nx
	do 41 l=1,nt
41	a(n,l)=0.
40	continue

c.......while we're here, clean up W and PCT
	do 50 l=nt+1,nx
	w(l)=0.
50	pct(l)=0.

	return
	end
c*********************************************************************
c......output of SVDEOF has W(NT), PCT(NT) and V(NT,NT). 
c......W and PCT are OK as is, since they are 1-d vectors, 
c......but V is really a vector of length NT*NT, (TAFs in sequence, then zeroes),
c......stored in an actual array V(NX,NX) (note NX > NT)
c......Fix V here: Make first NT indices of each of the first NT columns a TAF
c......This might leave some stray leftovers, but it should be ok (?)

	subroutine fix_v(v,nt,nx)
	IMPLICIT REAL(A-H, O-Z), INTEGER(I-N)
	
	real v(nx*nx)		! true size of V
	
	do 10 i=2,nt	! leave the first NT of em alone
	do 11 j=1,nt
	ij=(i-1)*nt+j	! position of TAF(neof i,time j)
	ij2=(i-1)*nx+j	! position where each column is NX long
11	v(ij2)=v(ij)
10	continue

	return
	end
c*********************************************************************
c..........."Traditional scaling"
c...........Section add by BK. 24 Aug 1992.
c...........Scale as my usual EOFs.
c...........Changes made here: 
c            1) Eigenvalues (vector W) output as W**2/M.
c			 2) EOFs (array V) output as V*W/sqrt(J).
c			 3) TAFs (array A) output as A*sqrt(J)
c.................Also find percent variance.

c.........23 Jun 2006: add an argument for the number of EOFs found.
c.........Need this to deal with reversed EOFs (which have only NT < NX EOFs),
c.........But still want to call with the same declared array sizes.
c.........Otherwise have array overflow problems (in V).

	subroutine scaling (a, n, m, w, v, pct, neof)
	IMPLICIT REAL(A-H, O-Z), INTEGER(I-N)
	
c	real A(n,m),W(n),V(n,n),pct(n)
	real A(n,m),W(neof),V(n,neof),pct(neof)

	rim=real(m)
	sqm=sqrt(rim)

	do 100 ix=1,n
	do 100 ieof=1,neof
100	v(ix,ieof)=v(ix,ieof)*w(ieof)/sqm

	totvar=0.
	do 101 ieof=1,neof
	w(ieof)=w(ieof)**2/rim
101	totvar=totvar+w(ieof)

	do 103 ieof=1,neof
103	pct(ieof)=w(ieof)/totvar

	do 102 ieof=1,neof
	do 102 it=1,m
102	a(ieof,it)=a(ieof,it)*sqm

	return
	end

c*********************************************************************
c.......demean A in time. Returned demeaned.

	subroutine demean (a, nx, nt)
	IMPLICIT REAL(A-H, O-Z), INTEGER(I-N)
	
	real a(nx,nt)
	
	do 150 i=1,nx
	av=0.
	do 151 j=1,nt
151	av=av+a(i,j)/real(nt)
	do 152 j=1,nt
152	a(i,j)=a(i,j)-av
150	continue

	return
	end

c*********************************************************************
c........modified Numerical Recipes subroutine SVDCMP
c........subroutine now does no scaling (handles either transposition)
c........=> demeaning must have been done previously

      SUBROUTINE SVDEOF (A, M, N, W, V, pct, RV1, indx, ier)
	IMPLICIT REAL(A-H, O-Z), INTEGER(I-N)

c......................................maximum number of spatial locations.
cc      PARAMETER (NMAX=100000)		! HARDWIRED
c......................................arrays passed from main program.
      real A(N,M),W(N),V(N,N),pct(n)
      dimension RV1(*), indx(*)
      integer ier

	ier = 0  ! success
c-------------------------------------------------------------------------
c...............Section add by BK. 24 Aug 1992.
cc	write(6,*) ' Enter subroutine SVDEOF-3'
c...............check maximum size.
cc	if (n.gt.nmax) then
cc	   write(6,*) 'N.ge.',nmax,' in routine SVDEOF. Error. Returning.'
cc	   return
cc	endif
c...............check that M.ge.N.
cc	if (m.lt.n) then
cc	   write(6,*) 'M=',m,' .lt. N=',n,'. SVDEOF Error. Returning.'
cc	   return
cc	endif
	
c-------------------------------------------------------------------------
      G=0.0
      SCALE=0.0
      ANORM=0.0
      DO 25 I=1,N
        L=I+1
        RV1(I)=SCALE*G
        G=0.0
        S=0.0
        SCALE=0.0
        IF (I.LE.M) THEN
          DO 11 K=I,M
            SCALE=SCALE+ABS(A(i,k))
11        CONTINUE
          IF (SCALE.NE.0.0) THEN
            DO 12 K=I,M
              A(i,k)=A(i,k)/SCALE
              S=S+A(i,k)*A(i,k)
12          CONTINUE
            F=A(I,I)
            G=-SIGN(SQRT(S),F)
            H=F*G-S
            A(I,I)=F-G
            IF (I.NE.N) THEN
              DO 15 J=L,N
                S=0.0
                DO 13 K=I,M
                  S=S+A(i,k)*A(j,k)
13              CONTINUE
                F=S/H
                DO 14 K=I,M
                  A(j,k)=A(j,k)+F*A(i,k)
14              CONTINUE
15            CONTINUE
            ENDIF
            DO 16 K= I,M
              A(i,k)=SCALE*A(i,k)
16          CONTINUE
          ENDIF
        ENDIF
        W(I)=SCALE *G
        G=0.0
        S=0.0
        SCALE=0.0
        IF ((I.LE.M).AND.(I.NE.N)) THEN
          DO 17 K=L,N
            SCALE=SCALE+ABS(A(k,i))
17        CONTINUE
          IF (SCALE.NE.0.0) THEN
            DO 18 K=L,N
              A(k,i)=A(k,i)/SCALE
              S=S+A(k,i)*A(k,i)
18          CONTINUE
            F=A(l,i)
            G=-SIGN(SQRT(S),F)
            H=F*G-S
            A(l,i)=F-G
            DO 19 K=L,N
              RV1(K)=A(k,i)/H
19          CONTINUE
            IF (I.NE.M) THEN
              DO 23 J=L,M
                S=0.0
                DO 21 K=L,N
                  S=S+A(k,j)*A(k,i)
21              CONTINUE
                DO 22 K=L,N
                  A(k,j)=A(k,j)+S*RV1(K)
22              CONTINUE
23            CONTINUE
            ENDIF
            DO 24 K=L,N
              A(k,i)=SCALE*A(k,i)
24          CONTINUE
          ENDIF
        ENDIF
        ANORM=MAX(ANORM,(ABS(W(I))+ABS(RV1(I))))
25    CONTINUE
      DO 32 I=N,1,-1
        IF (I.LT.N) THEN
          IF (G.NE.0.0) THEN
            DO 26 J=L,N
              V(J,I)=(A(j,i)/A(l,i))/G
26          CONTINUE
            DO 29 J=L,N
              S=0.0
              DO 27 K=L,N
                S=S+A(k,i)*V(K,J)
27            CONTINUE
              DO 28 K=L,N
                V(K,J)=V(K,J)+S*V(K,I)
28            CONTINUE
29          CONTINUE
          ENDIF
          DO 31 J=L,N
            V(I,J)=0.0
            V(J,I)=0.0
31        CONTINUE
        ENDIF
        V(I,I)=1.0
        G=RV1(I)
        L=I
32    CONTINUE
      DO 39 I=N,1,-1
        L=I+1
        G=W(I)
        IF (I.LT.N) THEN
          DO 33 J=L,N
            A(j,i)=0.0
33        CONTINUE
        ENDIF
        IF (G.NE.0.0) THEN
          G=1.0/G
          IF (I.NE.N) THEN
            DO 36 J=L,N
              S=0.0
              DO 34 K=L,M
                S=S+A(i,k)*A(j,k)
34            CONTINUE
              F=(S/A(I,I))*G
              DO 35 K=I,M
                A(j,k)=A(j,k)+F*A(i,k)
35            CONTINUE
36          CONTINUE
          ENDIF
          DO 37 J=I,M
            A(i,j)=A(i,j)*G
37        CONTINUE
        ELSE
          DO 38 J= I,M
            A(i,j)=0.0
38        CONTINUE
        ENDIF
        A(I,I)=A(I,I)+1.0
39    CONTINUE
      DO 49 K=N,1,-1
        DO 48 ITS=1,30
          DO 41 L=K,1,-1
            NM=L-1
            IF ((ABS(RV1(L))+ANORM).EQ.ANORM)  GO TO 2
            IF ((ABS(W(NM))+ANORM).EQ.ANORM)  GO TO 1
41        CONTINUE
1         C=0.0
          S=1.0
          DO 43 I=L,K
            F=S*RV1(I)
            IF ((ABS(F)+ANORM).NE.ANORM) THEN
              G=W(I)
              H=SQRT(F*F+G*G)
              W(I)=H
              H=1.0/H
              C= (G*H)
              S=-(F*H)
              DO 42 J=1,M
                Y=A(nm,j)
                Z=A(i,j)
                A(nm,j)=(Y*C)+(Z*S)
                A(i,j)=-(Y*S)+(Z*C)
42            CONTINUE
            ENDIF
43        CONTINUE
2         Z=W(K)
          IF (L.EQ.K) THEN
            IF (Z.LT.0.0) THEN
              W(K)=-Z
              DO 44 J=1,N
                V(J,K)=-V(J,K)
44            CONTINUE
            ENDIF
            GO TO 3
          ENDIF
          IF (ITS.EQ.60) then
	        ier = -1
cc		write(6,*) 'SVDEOF. No convergence in 60 iterations.'
cc		write(6,*) 'Returning with no EOFs found......'
		return
	  endif
          X=W(L)
          NM=K-1
          Y=W(NM)
          G=RV1(NM)
          H=RV1(K)
          F=((Y-Z)*(Y+Z)+(G-H)*(G+H))/(2.0*H*Y)
          G=SQRT(F*F+1.0)
          F=((X-Z)*(X+Z)+H*((Y/(F+SIGN(G,F)))-H))/X
          C=1.0
          S=1.0
          DO 47 J=L,NM
            I=J+1
            G=RV1(I)
            Y=W(I)
            H=S*G
            G=C*G
            Z=SQRT(F*F+H*H)
            RV1(J)=Z
            C=F/Z
            S=H/Z
            F= (X*C)+(G*S)
            G=-(X*S)+(G*C)
            H=Y*S
            Y=Y*C
            DO 45 NM=1,N
              X=V(NM,J)
              Z=V(NM,I)
              V(NM,J)= (X*C)+(Z*S)
              V(NM,I)=-(X*S)+(Z*C)
45          CONTINUE
            Z=SQRT(F*F+H*H)
            W(J)=Z
            IF (Z.NE.0.0) THEN
              Z=1.0/Z
              C=F*Z
              S=H*Z
            ENDIF
            F= (C*G)+(S*Y)
            X=-(S*G)+(C*Y)
            DO 46 NM=1,M
              Y=A(j,nm)
              Z=A(i,nm)
              A(j,nm)= (Y*C)+(Z*S)
              A(i,nm)=-(Y*S)+(Z*C)
46          CONTINUE
47        CONTINUE
          RV1(L)=0.0
          RV1(K)=F
          W(K)=X
48      CONTINUE
3       CONTINUE
49    CONTINUE
c-----------------------------------------------------------------------
c....now do scaling in sub SCALING (allows SVDEOF to handle either transposition)
c-----------------------------------------------------------------------
c...............make sure that eigenvalues are arranged in size order.
c...............if not, rearrange. Check first, may not need it.
	do 200 ieof=2,n
200	if (w(ieof).gt.w(ieof-1)) go to 201
	go to 299

c...............Since both the v's and a's must be rearranged, use
c...............the NR subroutine indexx to make a rank table, then
c...............rearrange in this program by hand.
201     continue
cc201	9(6,*) ' SVDEOF calling sub INDEXX to sort eigenvalues.'
	call indexx (n,w,indx)

c...............Now rearrange using index table INDX. Use RV1 as dummy.
c...............Note that table is in ASCENDING order 
c...............(W(INDX(1)) is smallest, W(INDX(N)) is largest).
	do 220 ieof=1,n
220	rv1(ieof)=w(ieof)
	do 221 ieof=1,n
221	w(ieof)=rv1(indx(n-ieof+1))

	do 222 ieof=1,n
222	rv1(ieof)=pct(ieof)
	do 223 ieof=1,n
223	pct(ieof)=rv1(indx(n-ieof+1))

c.............for V and A (2-D arrays), must rearrange each row/col separately.
	do 230 ix=1,n
	do 231 ieof=1,n
231	rv1(ieof)=v(ix,ieof)
	do 232 ieof=1,n
232	v(ix,ieof)=rv1(indx(n-ieof+1))
230	continue

	do 240 it=1,m
	do 241 ieof=1,n
241	rv1(ieof)=a(ieof,it)
	do 242 ieof=1,n
242	a(ieof,it)=rv1(indx(n-ieof+1))
240	continue
c-----------------------------------------------------------------------
299   continue
cc	write(6,*) ' Finished subroutine SVDEOF'
      RETURN
      END

c***********************************************************************

c...............another NR subroutine.
c...............Makes an index table INDX(N), such that ARRIN(INDX(J))
c					is in ascending order for J=1,2,...,N. 
c...............The inputs N and ARRIN are not changed.
c...............Method is heapsort.

      SUBROUTINE INDEXX(N,ARRIN,INDX)
	IMPLICIT REAL(A-H, O-Z), INTEGER(I-N)

      DIMENSION ARRIN(N),INDX(N)

      DO 11 J=1,N
        INDX(J)=J
11    CONTINUE
      L=N/2+1
      IR=N
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          INDXT=INDX(L)
          Q=ARRIN(INDXT)
        ELSE
          INDXT=INDX(IR)
          Q=ARRIN(INDXT)
          INDX(IR)=INDX(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            INDX(1)=INDXT
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20      IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(ARRIN(INDX(J)).LT.ARRIN(INDX(J+1)))J=J+1
          ENDIF
          IF(Q.LT.ARRIN(INDX(J)))THEN
            INDX(I)=INDX(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
        INDX(I)=INDXT
      GO TO 10
      END

c***********************************************************************

c...............subroutine to transpose matrices
c...............from http://www.netlib.org/toms/513

      SUBROUTINE MATRIXTRANS(A, M, N, MN, MOVE, IWRK, IOK)
	IMPLICIT REAL(A-H, O-Z), INTEGER(I-N)
C *****
C  ALGORITHM 380 - REVISED
C *****
C  A IS A ONE-DIMENSIONAL ARRAY OF LENGTH MN=M*N, WHICH
C  CONTAINS THE MXN MATRIX TO BE TRANSPOSED (STORED
C  COLUMWISE). MOVE IS A ONE-DIMENSIONAL ARRAY OF LENGTH IWRK
C  USED TO STORE INFORMATION TO SPEED UP THE PROCESS.  THE
C  VALUE IWRK=(M+N)/2 IS RECOMMENDED. IOK INDICATES THE
C  SUCCESS OR FAILURE OF THE ROUTINE.
C  NORMAL RETURN  IOK=0
C  ERRORS         IOK=-1 ,MN NOT EQUAL TO M*N
C                 IOK=-2 ,IWRK NEGATIVE OR ZERO
C                 IOK.GT.0, (SHOULD NEVER OCCUR),IN THIS CASE
C  WE SET IOK EQUAL TO THE FINAL VALUE OF I WHEN THE SEARCH
C  IS COMPLETED BUT SOME LOOPS HAVE NOT BEEN MOVED
C  NOTE * MOVE(I) WILL STAY ZERO FOR FIXED POINTS
      DIMENSION A(MN), MOVE(*)
C CHECK ARGUMENTS AND INITIALIZE.
      IF (M.LT.2 .OR. N.LT.2) GO TO 120
      IF (MN.NE.M*N) GO TO 180
      IF (IWRK.LT.1) GO TO 190
      IF (M.EQ.N) GO TO 130
      NCOUNT = 2
      K = MN - 1
      DO 10 I=1,IWRK
        MOVE(I) = 0
   10 CONTINUE
      IF (M.LT.3 .OR. N.LT.3) GO TO 30
C CALCULATE THE NUMBER OF FIXED POINTS, EUCLIDS ALGORITHM
C FOR GCD(M-1,N-1).
      IR2 = M - 1
      IR1 = N - 1
   20 IR0 = MOD(IR2,IR1)
      IR2 = IR1
      IR1 = IR0
      IF (IR0.NE.0) GO TO 20
      NCOUNT = NCOUNT + IR2 - 1
C SET INITIAL VALUES FOR SEARCH
   30 I = 1
      IM = M
C AT LEAST ONE LOOP MUST BE RE-ARRANGED
      GO TO 80
C SEARCH FOR LOOPS TO REARRANGE
   40 MAX = K - I
      I = I + 1
      IF (I.GT.MAX) GO TO 160
      IM = IM + M
      IF (IM.GT.K) IM = IM - K
      I2 = IM
      IF (I.EQ.I2) GO TO 40
      IF (I.GT.IWRK) GO TO 60
      IF (MOVE(I).EQ.0) GO TO 80
      GO TO 40
   50 I2 = M*I1 - K*(I1/N)
   60 IF (I2.LE.I .OR. I2.GE.MAX) GO TO 70
      I1 = I2
      GO TO 50
   70 IF (I2.NE.I) GO TO 40
C REARRANGE THE ELEMENTS OF A LOOP AND ITS COMPANION LOOP
   80 I1 = I
      KMI = K - I
      B = A(I1+1)
      I1C = KMI
      C = A(I1C+1)
   90 I2 = M*I1 - K*(I1/N)
      I2C = K - I2
      IF (I1.LE.IWRK) MOVE(I1) = 2
      IF (I1C.LE.IWRK) MOVE(I1C) = 2
      NCOUNT = NCOUNT + 2
      IF (I2.EQ.I) GO TO 110
      IF (I2.EQ.KMI) GO TO 100
      A(I1+1) = A(I2+1)
      A(I1C+1) = A(I2C+1)
      I1 = I2
      I1C = I2C
      GO TO 90
C FINAL STORE AND TEST FOR FINISHED
  100 D = B
      B = C
      C = D
  110 A(I1+1) = B
      A(I1C+1) = C
      IF (NCOUNT.LT.MN) GO TO 40
C NORMAL RETURN
  120 IOK = 0
      RETURN
C IF MATRIX IS SQUARE,EXCHANGE ELEMENTS A(I,J) AND A(J,I).
  130 N1 = N - 1
      DO 150 I=1,N1
        J1 = I + 1
        DO 140 J=J1,N
          I1 = I + (J-1)*N
          I2 = J + (I-1)*M
          B = A(I1)
          A(I1) = A(I2)
          A(I2) = B
  140   CONTINUE
  150 CONTINUE
      GO TO 120
C ERROR RETURNS.
  160 IOK = I
  170 RETURN
  180 IOK = -1
      GO TO 170
  190 IOK = -2
      GO TO 170
      END

	SUBROUTINE ADD_DSG_VARS (dset, cbuff)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* 2/2019  Ansley Manke
* NOAA/PMEL, Seattle, WA - Science Data Integration Group
* V751 7/19 *acm*  May be working with user-defined variables, so add 
*                  the dset number for the feature-variable


* Add feature-id variable to the command-line buffer, 
* Then it's read and ready for CDF_LIST_DSG to write them out.
* feature-variable is often of type string and is not stored at the
* time of dataset initialization.

        include 'tmap_dims.parm'
        include 'xtm_grid.cmn_text'
	include 'ferret.parm'
	include 'xdset_info.cmn_text'

	INTEGER dset
	CHARACTER*(*) cbuff

	INTEGER TM_LENSTR1, slen
	CHARACTER SANITARY_VAR_CODE*128, vname*128, TM_FMT*48
	
* Probably just need the feature-id variable

	vname = SANITARY_VAR_CODE(cat_file_var, dsg_feature_var(dset) )
	cbuff = cbuff(:TM_LENSTR1(cbuff))//','//vname(:TM_LENSTR1(vname))//
     .         '[d='//TM_FMT( DBLE(dset), 0, 10, slen )//']'

	   
	RETURN
	END

*
* ft_to_orthogonal.F
*
* Ansley Manke 2/2015
* 
*
* Given a variable from a Forecast-Time dataset, and
* the 2D time variable and a time axis representing all
* the times in the set, return the variable in orthogonal
* form: properly put onto the new time axis.
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ft_to_orthogonal )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )


      SUBROUTINE ft_to_orthogonal_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************


      CALL ef_set_desc(id,
     .        'Convert data with 2D Time coordinate to orthogonal FT grid' )
      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 1)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'VAR')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'Variable with 2D Time coordinate')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, NO, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'TIME2D')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'The 2-Dimensional Time coordinate variable')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, YES)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'ALLTIME')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'A variable on the output time axis')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, YES, NO, NO)

      RETURN 
      END

***********************************************************************

* Request an amount of storage to be supplied by Ferret and passed
* as additional arguments.

      SUBROUTINE ft_to_orthogonal_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

*
* Set the work array X/Y/Z/T/E/F dimensions
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)

      INTEGER ntout, nt2
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

* Coordinate data from argument 3

      ntout = 1 + arg_hi_ss(T_AXIS,ARG3) - arg_lo_ss(T_AXIS,ARG3)

* output t coordinates
      CALL ef_set_work_array_dims_6d(id, 1,
     .                                1, 1, 1, 1, 1, 1,
     .                            ntout, 1, 1, 1, 1, 1)

      RETURN
      END

* **********************************************************************

* In this subroutine we compute the result
*
      SUBROUTINE ft_to_orthogonal_compute(id, arg_1, arg_2, arg_3, 
     .                                    result, taxout)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)

      REAL result( memreslox:memreshix, memresloy:memreshiy, 
     .             memresloz:memreshiz, memreslot:memreshit,
     .             memresloe:memreshie, memreslof:memreshif)
     
      REAL taxout(wrk1lox:wrk1hix)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************

      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2
      INTEGER i3, j3, k3, l3, m3, n3
      INTEGER l_off, del_l, del_n
      LOGICAL its_dsg
      CHARACTER*255 err_msg
      REAL time2d_ft, timeout
       
* Does the variable come from a Discrete Sampling Geometries dataset?  

      CALL EF_GET_ITS_DSG(id, ARG1, its_dsg )
      IF (its_dsg) THEN
         err_msg = 
     . 'Data is from a Discrete Sampling Geometries (DSG) dataset. Function does not apply.'
       GOTO 999
      ENDIF

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      CALL ef_get_coordinates(id, ARG3, T_AXIS, arg_lo_ss(T_AXIS, ARG3),
     .                        arg_hi_ss(T_AXIS, ARG3), taxout)

1000  FORMAT ('2D time array mismatch with new time axis: time2d', 
     . f8.2, ' time axis ', i3, f8.2)

* Fill the result with missing-flag

      DO 50 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
      DO 50 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
      DO 50 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
      DO 50 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
      DO 50 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
      DO 50 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
         result(i,j,k,l,m,n) = bad_flag_result
  50  CONTINUE

      i2 = arg_lo_ss(X_AXIS,ARG2)
      j2 = arg_lo_ss(Y_AXIS,ARG2)
      k2 = arg_lo_ss(Z_AXIS,ARG2)
      l2 = arg_lo_ss(T_AXIS,ARG2)
      m2 = arg_lo_ss(E_AXIS,ARG2)
      n2 = arg_lo_ss(F_AXIS,ARG2)

      i3 = arg_lo_ss(X_AXIS,ARG3)
      j3 = arg_lo_ss(Y_AXIS,ARG3)
      k3 = arg_lo_ss(Z_AXIS,ARG3)
      l3 = arg_lo_ss(T_AXIS,ARG3)
      m3 = arg_lo_ss(E_AXIS,ARG3)
      n3 = arg_lo_ss(F_AXIS,ARG3)

      l_off = 0
      del_l = arg_2(i2,j2,k2,l2+1,m2,n2) - arg_2(i2,j2,k2,l2,m2,n2)
      del_n = (arg_2(i2,j2,k2,l2,m2,n2+1) - arg_2(i2,j2,k2,l2,m2,n2))/del_l

      n1 = arg_lo_ss(F_AXIS,ARG1)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

         DO 400 l2 = arg_lo_ss(T_AXIS,ARG2), arg_hi_ss(T_AXIS,ARG2)

	    l = l2 + l_off
            time2d_ft = arg_2(i2,j2,k2,l2,m2,n2)

*  These should match.  (commented out now; something wrong with the
*   declaration of work arrays with this function; Ferret crashes on
*   trying to free the memory...)

	    timeout = taxout(l)
            IF (time2d_ft .NE. timeout) THEN
	       write (err_msg, 1000) time2d_ft, l, timeout
	       GOTO 999  
            ENDIF
	   
            m1 = arg_lo_ss(E_AXIS,ARG1)
            DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

            j1 = arg_lo_ss(Y_AXIS,ARG1)
            DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            i1 = arg_lo_ss(X_AXIS,ARG1)
            DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

	       result(i,j,k,l,m,n) = arg_1(i1,j1,k1,l2,m1,n1)

            i1 = i1 + arg_incr(X_AXIS,ARG1)
 100        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 200        CONTINUE

            k1 = k1 + arg_incr(Z_AXIS,ARG1)
 300        CONTINUE

            m1 = m1 + arg_incr(E_AXIS,ARG1)
 500        CONTINUE

 400     CONTINUE

         n2 = n2 + arg_incr(F_AXIS,ARG2)
         n1 = n1 + arg_incr(F_AXIS,ARG1)
	 l_off = l_off + del_n
 600  CONTINUE

      RETURN

 999  CALL ef_bail_out (id, err_msg)

* **********************************************************************

      END

* 
*  compressm_by.F
* 
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*  
* Ansley Manke
* May 2012
*
* 
*  Compress argument 1 along axis M by the mask given in argument 2
*  Argument 2 may be multidimensional
 
*  In this subroutine we provide information about
*  the function.  The user configurable information 
*  consists of the following:
* 
*  descr              Text description of the function
* 
*  num_args           Required number of arguments
* 
*  axis_inheritance   Type of axis for the result
*                        ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                        CUSTOM          - user defined axis
*                        IMPLIED_BY_ARGS - same axis as the incoming argument
*                        NORMAL          - the result is normal to this axis
*                        ABSTRACT        - an axis which only has index values
* 
*  piecemeal_ok       For memory optimization:
*                        axes where calculation may be performed piecemeal
*                        ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE compressm_by_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .     'Compress arg1 in M by (multi-D) mask in arg 2' )

      CALL ef_set_num_args(id, 2)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                ABSTRACT,        IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'dat')
      CALL ef_set_arg_desc(id, arg, 'variable to compress on M axis')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, NO, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'mask')
      CALL ef_set_arg_desc(id, arg,
     .          'valid/bad points guiding compressmon (multi-D)')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, NO, YES)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END






*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE compressm_by_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER my_hi, lmsk
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

*
*     Use utility functions to get context information about the arguments.
*

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      my_hi = arg_hi_ss(E_AXIS,1) - arg_lo_ss(E_AXIS,1) + 1

      lmsk    = arg_hi_ss(E_AXIS,2) - arg_lo_ss(E_AXIS,2) + 1
      IF ( lmsk .LT. my_hi ) my_hi = lmsk

      CALL ef_set_axis_limits(id, E_AXIS, 1, my_hi)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END



* 
*  In this subroutine we compute the result
* 
      SUBROUTINE compressm_by_compute(id, arg_1, arg_2, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,  j,  k,  l,  m,  n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2
      INTEGER nout, mlo

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      mlo = res_lo_ss(E_AXIS)

* pre-fill the entire output result with missing value flags
*  (since each M-sequence in mask may have different number of valid pts)
      DO 10 n=res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
      DO 10 m=res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
      DO 10 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
      DO 10 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
      DO 10 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
      DO 10 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
 10      result(i,j,k,l,m,n) = bad_flag_result

* fill in the points as specified by the mask
      n1 = arg_lo_ss(F_AXIS,ARG1)
      n2 = arg_lo_ss(F_AXIS,ARG2)
      DO 600 n=res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

            l1 = arg_lo_ss(T_AXIS,ARG1)
            l2 = arg_lo_ss(T_AXIS,ARG2)
            DO 400 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

               j1 = arg_lo_ss(Y_AXIS,ARG1)
               j2 = arg_lo_ss(Y_AXIS,ARG2)
               DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

                  k1 = arg_lo_ss(Z_AXIS,ARG1)
                  k2 = arg_lo_ss(Z_AXIS,ARG2)
                  DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

                     i1 = arg_lo_ss(X_AXIS,ARG1)
                     i2 = arg_lo_ss(X_AXIS,ARG2)
                     DO 100 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

                     nout = 0

                     m1 = arg_lo_ss(E_AXIS,ARG1)
                     m2 = arg_lo_ss(E_AXIS,ARG2)
                     DO 500 m=res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

                        IF ( arg_2(i2,j2,k2,l2,m2,n2)
     .                                   .NE. bad_flag(2) ) THEN
                           IF ( arg_1(i1,j1,k1,l1,m1,n2)
     .                                   .EQ. bad_flag(1) ) THEN
                              result(i,j,k,l,mlo+nout,n) =
     .                                   bad_flag_result
                           ELSE
                              result(i,j,k,l,mlo+nout,n) =
     .                                   arg_1(i1,j1,k1,l1,m1,n1)
                           ENDIF
                           nout = nout + 1
                        ENDIF

                     m1 = m1 + arg_incr(E_AXIS,ARG1)
                     m2 = m2 + arg_incr(E_AXIS,ARG2)
 500                 CONTINUE

                        i1 = i1 + arg_incr(X_AXIS,ARG1)
                        i2 = i2 + arg_incr(X_AXIS,ARG2)
 100                 CONTINUE

                     k1 = k1 + arg_incr(Z_AXIS,ARG1)
                     k2 = k2 + arg_incr(Z_AXIS,ARG2)
 200              CONTINUE

                  j1 = j1 + arg_incr(Y_AXIS,ARG1)
                  j2 = j2 + arg_incr(Y_AXIS,ARG2)
 300           CONTINUE

               l1 = l1 + arg_incr(T_AXIS,ARG1)
               l2 = l2 + arg_incr(T_AXIS,ARG2)
 400        CONTINUE


         n1 = n1 + arg_incr(F_AXIS,ARG1)
         n2 = n2 + arg_incr(F_AXIS,ARG2)
 600  CONTINUE

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* minmax function
*
* Ansley Manke
* May 2009
*
* This function returns the min and max of a variable
* Faster than individually computing the min and max
* or running the STAT command.
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument''s axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE minmax_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     . 'Returns min and max of a var. result[i=1]=min,result[i=2]=max' )

      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance_6d(id,
     .                                ABSTRACT, NORMAL,
     .                                NORMAL,   NORMAL,
     .                                NORMAL,   NORMAL)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'Variable')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* loss               lo subscript for an axis
*
* hiss               hi subscript for an axis
*

      SUBROUTINE minmax_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CALL ef_set_axis_limits(id, X_AXIS, 1, 2)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE minmax_compute(id, arg_1, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1
      REAL amin, amax

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      amin = MAX( ABS(bad_flag(1)), 1.0E34 )
      amax = -1.0 * amin

      DO 100 n1 = arg_lo_ss(F_AXIS,ARG1), arg_hi_ss(F_AXIS,ARG1)
      DO 100 m1 = arg_lo_ss(E_AXIS,ARG1), arg_hi_ss(E_AXIS,ARG1)
      DO 100 l1 = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)
      DO 100 k1 = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)
      DO 100 j1 = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)
      DO 100 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)

         IF ( arg_1(i1,j1,k1,l1,m1,n1) .NE. bad_flag(1) ) THEN
            amin = MIN(amin, arg_1(i1,j1,k1,l1,m1,n1) )
            amax = MAX(amax, arg_1(i1,j1,k1,l1,m1,n1) )
         END IF

 100  CONTINUE

      i = res_lo_ss(X_AXIS)
      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      l = res_lo_ss(T_AXIS)
      m = res_lo_ss(E_AXIS)
      n = res_lo_ss(F_AXIS)
      result(i,j,k,l,m,n) = amin
      result(i+1,j,k,l,m,n) = amax

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	LOGICAL FUNCTION MATCH_TEMPLATE (name, template)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* check to see if the name matches the template
* the template may contain
*	"*" which matches 0 or more of any characters 
*	"?" which match any single character

* Note: this routine IS case sensitive so make sure to UPCASE strings as
*	needed prior to calling this

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V420  4/18/96

        IMPLICIT NONE
* calling argument declarations:
	CHARACTER*(*)	template
	CHARACTER*(*)	name

* internal variable declarations:
	LOGICAL		star_skip, was_star_skip
	INTEGER		TM_LENSTR1, in, it, nlen, tlen, instart
	CHARACTER*1	ch

* initialize
	nlen	= TM_LENSTR1( name )
	tlen	= TM_LENSTR1( template )
	star_skip = .FALSE.
	was_star_skip = .FALSE.

* This lets us search for the template later in the
* name string; fixes bug 1632.

	instart = 0
  600   CONTINUE
        instart = instart + 1
	IF (instart .GT. nlen) GOTO 1000

	in = instart

* LOOP through the characters of the template
* (advance the char ptr for name, "in", as needed)
	DO 500 it = 1, tlen

	  ch = template(it:it)		! next character to match

	  IF ( ch .EQ. '*' ) THEN
	    star_skip = .TRUE.
	    was_star_skip = .TRUE.	! search involves a star
	    GOTO 500

	  ELSEIF ( ch .EQ. '?' ) THEN
	    IF ( star_skip ) THEN
	      GOTO 500			! "*?" matches same as "*"
	    ELSE
	      GOTO 400
	    ENDIF

	  ELSEIF ( star_skip ) THEN
	    DO 100 in = in, nlen
	      IF ( name(in:in) .EQ. ch ) THEN
	        star_skip = .FALSE.
	        GOTO 400
	      ENDIF
 100	    CONTINUE
	    GOTO 1000			! no match for char after "*"

	  ELSEIF ( in .GT. nlen ) THEN
	    GOTO 1000			! no more name chars available

	  ELSEIF ( ch .EQ. name(in:in) ) THEN
	    GOTO 400

	  ELSE
	    IF (was_star_skip) THEN
	       GOTO 600
	    ELSE
	       GOTO 1000
	    ENDIF

	  ENDIF

* advance to next character of name
 400	  IF ( (it.EQ.tlen) ) THEN
	    IF ( (in.NE.nlen) ) GOTO 1000  ! too many chars in name
	  ENDIF
	  in = in + 1

 500	CONTINUE

* success - we've passed through the entire template with no error
	MATCH_TEMPLATE = .TRUE.
	RETURN

* something doesn't match
 1000	MATCH_TEMPLATE = .FALSE.
	RETURN

	END

*
* zaxreplace_rev.F
! version of zaxreplace_avg, with order of arguments 1 and 2 reversed
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* Oct 1998
* 11/2001  clarify function description
*  7/2003  Bug fix; last source point wasnt associated with a dest box
*          when the destination axis continues beyond the source range
*
*
* Replace Z axis, using weighted averaging over bins
*

*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE zaxreplace_rev_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CHARACTER*100 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT('regrid V onto Z axis of ZAX based on Z values in ZVALS ',
     .       'using weighted average')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 7)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'ZVALS')
      CALL ef_set_arg_desc(id, arg,
     .        'Destination Z axis values as a fcn of source Z axis')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'V')
      CALL ef_set_arg_desc(id, arg,
     .        'Variable on native Z axis')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, NO, YES, YES, YES)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'ZAX')
      CALL ef_set_arg_desc(id, arg,
     .        'Variable with desired Z (depth) axis points')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, YES, NO, NO, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE zaxreplace_rev_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER mz1, mz3
      INTEGER iwork

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

*  Allocate double the dimension of the input arguments for work arrays
*  which will be REAL*8
      mz1 = 1 + ABS(arg_hi_ss(Z_AXIS,ARG1) - arg_lo_ss(Z_AXIS,ARG1))
      mz1 = 2 * mz1
      mz3 = 1 + ABS(arg_hi_ss(Z_AXIS,ARG3) - arg_lo_ss(Z_AXIS,ARG3))
      mz3 = 2 * mz3

*  zaxsrc
      iwork = 1
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                              mz1, 1, 1, 1, 1, 1)

*  sbox_lo_lim
      iwork = 2
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                              mz1, 1, 1, 1, 1, 1)

*  sbox_hi_lim
      iwork = 3
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                              mz1, 1, 1, 1, 1, 1)

*  sbox_lo_new
      iwork = 4
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                              mz1, 1, 1, 1, 1, 1)

*  sbox_hi_new
      iwork = 5
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                              mz1, 1, 1, 1, 1, 1)

*  dbox_lo_lim
      iwork = 6
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                              mz3, 1, 1, 1, 1, 1)

*  dbox_hi_lim
      iwork = 7
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                              mz3, 1, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE zaxreplace_rev_compute(id, arg_1, arg_2, arg_3,
     .                                  result, zaxsrc,
     .                                  sbox_lo_lim, sbox_hi_lim,
     .                                  sbox_lo_new, sbox_hi_new,
     .                                  dbox_lo_lim, dbox_hi_lim)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz,
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* Ignore the Y/Z/T/E/F dimensions in the work arrays since
* they are not used and Fortran is column major
      REAL*8 zaxsrc     (wrk1lox:wrk1hix/2)
      REAL*8 sbox_lo_lim(wrk2lox:wrk2hix/2)
      REAL*8 sbox_hi_lim(wrk3lox:wrk3hix/2)
      REAL*8 sbox_lo_new(wrk4lox:wrk4hix/2)
      REAL*8 sbox_hi_new(wrk5lox:wrk5hix/2)
      REAL*8 dbox_lo_lim(wrk6lox:wrk6hix/2)
      REAL*8 dbox_hi_lim(wrk7lox:wrk7hix/2)

* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable''s axes.

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, l1, m1, n1
      INTEGER i2, j2, l2, m2, n2
      INTEGER i3, j3, l3, m3, n3
      INTEGER nbox, nsrc
      INTEGER nsrc_lo, nsrc_hi
      REAL frac, xsrc_min, xsrc_max, xsrc_lo, xsrc_hi, xsrcdiff
      REAL wtd, arg2_val, arg2_val_last, wtd_last
      REAL*8 sum, wtdsum
      REAL dbox_lo, dbox_hi

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      CALL ef_get_coordinates(id, ARG1, Z_AXIS,
     .        arg_lo_ss(Z_AXIS, ARG1), arg_hi_ss(Z_AXIS, ARG1), zaxsrc)

      CALL ef_get_box_limits(id, ARG1, Z_AXIS, arg_lo_ss(Z_AXIS, ARG1),
     .        arg_hi_ss(Z_AXIS, ARG1), sbox_lo_lim, sbox_hi_lim)

      CALL ef_get_box_limits(id, ARG3, Z_AXIS, arg_lo_ss(Z_AXIS, ARG3),
     .        arg_hi_ss(Z_AXIS, ARG3), dbox_lo_lim, dbox_hi_lim)

*
*  Loop over x,y,t,e,f of the input fields
*
      n1 = arg_lo_ss(F_AXIS,ARG1)
      n2 = arg_lo_ss(F_AXIS,ARG2)
      n3 = arg_lo_ss(F_AXIS,ARG3)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

      m1 = arg_lo_ss(E_AXIS,ARG1)
      m2 = arg_lo_ss(E_AXIS,ARG2)
      m3 = arg_lo_ss(E_AXIS,ARG3)
      DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

      l1 = arg_lo_ss(T_AXIS,ARG1)
      l2 = arg_lo_ss(T_AXIS,ARG2)
      l3 = arg_lo_ss(T_AXIS,ARG3)
      DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

      j1 = arg_lo_ss(Y_AXIS,ARG1)
      j2 = arg_lo_ss(Y_AXIS,ARG2)
      j3 = arg_lo_ss(Y_AXIS,ARG3)
      DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

      i1 = arg_lo_ss(X_AXIS,ARG1)
      i2 = arg_lo_ss(X_AXIS,ARG2)
      i3 = arg_lo_ss(X_AXIS,ARG3)
      DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

*
* -ACM- Note: need to think about backwards and forwards z axes: ht vs depth ?
*

*  Translate the source boxes to the new axis units.

         DO 310 k = arg_lo_ss(Z_AXIS,ARG2), arg_hi_ss(Z_AXIS,ARG2)

*  Find the point on the source axis just below the box limit.  Interpolate
*  to get the box limit in new units.
            nbox = 1
            DO WHILE ( zaxsrc(nbox) .LT. sbox_lo_lim(k) )
               nbox = nbox + 1
            ENDDO
            IF ( nbox .EQ. 1 ) THEN
               sbox_lo_new(k) = arg_1(i1,j1,nbox,l1,m1,n1)
            ELSE
               frac = ( sbox_lo_lim(k) - zaxsrc(nbox-1) ) /
     .                ( zaxsrc(nbox)   - zaxsrc(nbox-1) )
               sbox_lo_new(k) = arg_1(i1,j1,nbox-1,l1,m1,n1) +
     .                          frac * ( arg_1(i1,j1,nbox,  l1,m1,n1) -
     .                                   arg_1(i1,j1,nbox-1,l1,m1,n1) )
            ENDIF

            nbox = 1
            DO WHILE ( zaxsrc(nbox) .LT. sbox_hi_lim(k) .AND.
     .                 nbox .LT. arg_hi_ss(Z_AXIS,ARG2) )
               nbox = nbox + 1
            ENDDO
            IF ( nbox .EQ. 1 ) THEN
               sbox_hi_new(k) = arg_1(i1,j1,nbox,l1,m1,n1)
            ELSE
               frac = ( sbox_hi_lim(k) - zaxsrc(nbox-1) ) /
     .                ( zaxsrc(nbox)   - zaxsrc(nbox-1) )
               sbox_hi_new(k) = arg_1(i1,j1,nbox-1,l1,m1,n1) +
     .                          frac * ( arg_1(i1,j1,nbox,  l1,m1,n1) -
     .                                   arg_1(i1,j1,nbox-1,l1,m1,n1) )
            ENDIF

  310    CONTINUE

* For each z line accumulate weighted source points and weights to get
* the average value.   Loop through the each destination grid box.

         sum = 0.
         wtdsum = 0.
         DO 390 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

*  Find the first and last source point in this destination box
            nsrc_lo = 1
            DO WHILE ( sbox_lo_new(nsrc_lo) .LT. dbox_lo_lim(k) )
               nsrc_lo = nsrc_lo + 1
               IF ( nsrc_lo .GT. arg_hi_ss(Z_AXIS, ARG1) ) GO TO 320
            ENDDO
  320       CONTINUE

*  Find any portion of the source box lying in the destination box.
            nsrc_hi = 1
            DO WHILE ( sbox_lo_new(nsrc_hi) .LE. dbox_hi_lim(k) )
               nsrc_hi = nsrc_hi + 1
               IF ( nsrc_hi .GT. arg_hi_ss(Z_AXIS, ARG1) ) GO TO 330
            ENDDO
  330       CONTINUE
            nsrc_hi = nsrc_hi - 1

            IF ( nsrc_hi .LT. nsrc_lo ) THEN
*  No source boxes within this destination box.
               IF ( wtdsum .NE. 0. ) THEN
                  result(i,j,k,l,m,n) = sum / wtdsum
                  sum = 0.
                  wtdsum = 0.
               ELSE
                  result(i,j,k,l,m,n) = bad_flag_result
               ENDIF
*  Done with this Z result; go to the next one
               GOTO 390
            ENDIF

            DO 340 nsrc = nsrc_lo, nsrc_hi

*  Get fraction of this source box lying within the destination box.
               xsrc_min = sbox_lo_new(nsrc)
               xsrc_max = sbox_hi_new(nsrc)

               dbox_hi = dbox_hi_lim(k)
               dbox_lo = dbox_lo_lim(k)

               xsrc_lo = MAX(xsrc_min, dbox_lo)
               xsrc_hi = MIN(xsrc_max, dbox_hi)

               xsrcdiff = xsrc_max - xsrc_min
               wtd = 0.
               IF ( xsrcdiff .NE. 0. )
     .            wtd = (xsrc_hi - xsrc_lo) / xsrcdiff
               arg2_val = arg_2(i2,j2,nsrc,l2,m2,n2)
               IF ( arg2_val .NE. bad_flag(ARG2) ) THEN
                  sum  = sum + wtd * arg2_val
                  wtdsum = wtdsum + wtd
                  arg2_val_last = arg2_val
                  wtd_last = wtd
               ENDIF

  340       CONTINUE

            IF ( wtdsum .NE. 0. ) THEN

* If we had any good data, calculate the average.
               result(i,j,k,l,m,n) = sum / wtdsum

*  Start next average with remaining weighted part of the last box
*  which was not within the destination box.
               sum = (1.- wtd_last) * arg2_val_last
               wtdsum = 1. - wtd_last

            ELSE

               result(i,j,k,l,m,n) = bad_flag_result
               sum = 0.
               wtdsum = 0.

            ENDIF

 390     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
         i2 = i2 + arg_incr(X_AXIS,ARG2)
         i3 = i3 + arg_incr(X_AXIS,ARG3)
 100  CONTINUE

         j1 = j1 + arg_incr(Y_AXIS,ARG1)
         j2 = j2 + arg_incr(Y_AXIS,ARG2)
         j3 = j3 + arg_incr(Y_AXIS,ARG3)
 200  CONTINUE

         l1 = l1 + arg_incr(T_AXIS,ARG1)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
         l3 = l3 + arg_incr(T_AXIS,ARG3)
 400  CONTINUE

         m1 = m1 + arg_incr(E_AXIS,ARG1)
         m2 = m2 + arg_incr(E_AXIS,ARG2)
         m3 = m3 + arg_incr(E_AXIS,ARG3)
 500  CONTINUE

         n1 = n1 + arg_incr(F_AXIS,ARG1)
         n2 = n2 + arg_incr(F_AXIS,ARG2)
         n3 = n3 + arg_incr(F_AXIS,ARG3)
 600  CONTINUE

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN
      END

	SUBROUTINE PLOTXY(X,NXS,XF,YF,IPV)
C** 
C**    @(#)plotxy.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C  ARRAY X HOLDS X AND Y'S FOR ALL LINES.  DIMENSIONED FOR NXS.
C  ORDER AS FOLLOWS:  ALL X'S FOR LINE1, ALL X'S FOR LINE2,...
C                     STARTING AT X(NXS/2+1), ALL Y'S FOR LINE1,
C                     ALL Y'S FOR LINE2...
C  XF AND YF ARE FACTORS TO CONVERT TO INCHES FROM USER UNITS
C
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Modified *jd* J Davison JISAO/PMEL/TMAP 3.22.89
*	To exclude Denbo line dashing in favor of GKS line bundles 
*	Mod *jd* 8.3.92 to add interrupts 
*	Mod *sh* 11/97 to add PLOTPOL command

*  ACM  8-30-2000 Go back to calling the line dash subroutine.   
*  ACM 10/2012    Modulo-ing for PLOT/VS longitudes overlaid on a map.
*  ACM  2/2013    ticket 2141. Fix the modulo operation when the longitude
*                 range is over 360.
* V6.94+ *acm* 3/15 Ticket 2247: singleton points in line plots marked with a dot
* v696 *acm*   6/15 PLOT/VS/GAPLOC to define seperate line segments on	
*                   PLOT/VS plots (LAS ticket 1597 and others)
* v696 *acm*   6/15 Reverting. Implement /GAPLOC only for ribbon plots.	
* V698  4/16 *acm* New PLOT/SKIP=

        include         'xinterrupt.cmn' ! 1/89 *sh*
        include         'ppl_in_ferret.cmn'

	DIMENSION X(NXS)

        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'axis_inc.decl'
        include 'AXIS.INC'
        include 'lines_inc.decl'
        include 'LINES.INC'
        include 'pen_inc.decl'
        include 'PEN.INC'
        include 'pltl_inc.decl'
        include 'PLTL.INC'
        include 'hd_inc.decl'
        include 'HD.INC'
        include 'miss_inc.decl'
        include 'MISS.INC'
        include 'taxis_inc.decl'
        include 'TAXIS.INC'
        include 'axisl_inc.decl'
        include 'AXISL.INC'
        include 'cmrd_inc.decl'
        include 'CMRD.INC'
        include 'gkscm2.cmn' ! jd 3.22.89
        include 'gkspar.inc'	! sh 11/97
        include 'shade_vars.cmn'	! sh 11/97
        INCLUDE 'makedot.cmn'    ! 10/01 *acm*

	REAL MAXVEL

        REAL	xadd, xaddlast, datx, daty

	LOGICAL md
	INTEGER xpolybase, ypolybase, zpolybase, polysizemax, nl,
     .		nvertex, fill_ndx, nskp, idec

	INTEGER klast, mdot
	REAL	xtlast, ytlast

	INTEGER GET_NDX

* GKS initialization vars
	integer		error,trans_no,cflag
        integer         my_trans
        data            my_trans/20/
	real	 	w(4),v(4),ndc(4),uc(4)
	real		xinv,yinv

	logical		valid

*************************************

	nl = lnum

	xadd = 0.
	xadlast = 0.	
	MDOT = 99
C
C  JTYPE IS DATA TYPE (0 FOR 2D, 1 FOR 1D)
C
	IF(IPV.NE.0 .AND.JTYPE.NE.1) RETURN


1000	IBASE=0
	IY=NXS/2
	CS=COS(VANG*.01745329252)
	SN=SIN(VANG*.01745329252)
	ZT=YF/XF
	ICNT=1
	IF(M.GE.2.AND.IFLG(2).NE.0)ICNT=P(2)


	IF(MAKEP.EQ.'PLOTUV')THEN
	  IBASE=IY
	  IBASE1=0
	  IBASE2=LLENG(1)+IY
	  DO 90 I=1,LNUM,2
	    CALL VECTRS
	    CALL COLOR(IPEN(I))
	    DO 95 J=1,LLENG(I),ICNT
	      IF(XLE.AND.X(IBASE+J).LE.CMXLE)GOTO 95
	      IF(XEQ.AND.X(IBASE+J).EQ.CMXEQ)GOTO 95
	      IF(XGE.AND.X(IBASE+J).GE.CMXGE)GOTO 95
	      IF(YLE.AND.X(IBASE2+J).LE.CMYLE)GOTO 95
	      IF(YEQ.AND.X(IBASE2+J).EQ.CMYEQ)GOTO 95
	      IF(YGE.AND.X(IBASE2+J).GE.CMYGE)GOTO 95
	      YT= YFCT(I)*X(IBASE2+J)*CS + XFCT(I)*X(IBASE+J)*SN
	      XT= (XFCT(I)*X(IBASE+J)*CS - YFCT(I)*X(IBASE2+J)*SN)*ZT
	      CALL PLOT(X(IBASE1+J)+XOFF(I),YOFF(I),0,0)
	      CALL PLOT(X(IBASE1+J)+XOFF(I)+XT,YOFF(I)+YT,1,0)
	      if (interrupted) goto 51 ! *jd* 8.3.92
95	    CONTINUE
	    IBASE=IBASE2+LLENG(I+1)
	    IBASE1=IBASE1+LLENG(I+1)+LLENG(I)
90	  IBASE2=IBASE+LLENG(I+2)
	  GOTO 51
	END IF

******** LOOP OVER LINES STORED
	DO 50 I=1,nl
	  CALL MARKH(HMARK(I))
	  CALL COLOR(IPEN(I))

C set decimation for symbols
	  nskp = MAX(1,nskpsym(i))

C     SET PLOT MODE
	  IF(IPV.EQ.1)THEN
C     DRAW VECTORS
	    CALL VECTRS
	    DO 80 J=1,LLENG(I),ICNT
	      IF(XLE.AND.X(IBASE+J).LE.CMXLE)GOTO 80
	      IF(XEQ.AND.X(IBASE+J).EQ.CMXEQ)GOTO 80
	      IF(XGE.AND.X(IBASE+J).GE.CMXGE)GOTO 80
	      IF(YLE.AND.X(IY+IBASE+J).LE.CMYLE)GOTO 80
	      IF(YEQ.AND.X(IY+IBASE+J).EQ.CMYEQ)GOTO 80
	      IF(YGE.AND.X(IY+IBASE+J).GE.CMYGE)GOTO 80
	      YT= YFCT(I)*X(IY+IBASE+J)*CS + XFCT(I)*X(IBASE+J)*SN
	      XT=(XFCT(I)*X(IBASE+J)*CS - YFCT(I)*X(IY+IBASE+J)*SN)*ZT
	      CALL PLOT(FLOAT(J)+XOFF(I),YOFF(I),0,0)
	      CALL PLOT(FLOAT(J)+XOFF(I)+XT,YOFF(I)+YT,1,0)
80          CONTINUE

	  ELSE IF(IPV.EQ.2) THEN
	    IF( m .ge. 1 .and. iflg(1) .ne. 0)then
	       if( p(1) .gt. 0 )then
		   rlenfact = p(1) * abs(xf)
	       else
		   rlenfact = -p(1) * abs(yf)
	       endif
	    else
	       rlenfact = min( abs(xf), abs(yf))
	    endif
	    jcnt = 1
	    if( m .ge. 2 .and. iflg(2) .ne. 0)jcnt = p(2)
	    IF ( i .GT. 1) GOTO 50
	    ibaseu = 0
	    ibasev = iy
	    ibasex = lleng(1)
	    ibasey = iy + lleng(1)
	    CALL COLOR(IPEN(1))
	    maxvel = 0.0
	    DO 100 j = 1,lleng(1),jcnt
	      dist=sqrt(x(ibasev+j)**2+x(ibaseu+j)**2)
	      if(dist.gt.maxvel)maxvel=dist
	      ytail = x(ibasey+j)
	      yhead = ytail + rlenfact*x(ibasev+j)/yf
	      xtail = x(ibasex+j)
	      xhead = xtail + rlenfact*x(ibaseu+j)/xf
	      CALL DRAWVEC(xtail,ytail,xhead,yhead,rlenfact,0,xf,yf)
100	    CONTINUE
	    CALL DRAWVEC(maxvel,ytail,xhead,yhead,rlenfact,1,xf,yf)

* standard line or point plot
	  ELSEIF (ipv .EQ. 0) THEN
!ACM 	    IF(ITYPE(I).GE.4 .and. .not.gks_open)THEN ! JD 3.22.89
	    IF(ITYPE(I).GE.4)THEN ! JD 3.22.89
	      CALL DASHSZ(DN1(I),UP1(I),DN2(I),UP2(I))
	      CALL DASHES
	    ELSE
	      CALL VECTRS
	    END IF
	    IF(ITYPE(I).EQ.3)THEN 
               CALL POINTS
               IF (imark(i) .eq. 99) ipt = 0
            ENDIF
	    IF(.NOT.(XLE.OR.XEQ.OR.XGE.OR.YLE.OR.YEQ.OR.YGE))THEN
C     DO NOT CHECK POINTS FOR MISSING DATA
	      CALL TRANS(I,X(IBASE+1),X(IY+IBASE+1),XT,YT)
	      CALL PLOT(XT,YT,0,0)
	      IF(ITYPE(I).NE.0.AND.ITYPE(I).NE.4)CALL MARK(IMARK(I))
	      IM=0
	      IF(ITYPE(I).EQ.1.OR.ITYPE(I).EQ.3)IM=IMARK(I)
	      DO 60 J=IBASE+1,IBASE+LLENG(I)
	        CALL TRANS(I,X(J),X(IY+J),XT,YT)
	        CALL PLOT(XT,YT,1,0)
60            CALL MARK(IM)
	    ELSE
C     CHECK POINTS FOR OUT OF RANGE   (CM)
	      DO 70 J=IBASE+1,IBASE+LLENG(I)
* ... locate first point
		IF(XLE.AND.X(J).LE.CMXLE)GOTO 70
		IF(XEQ.AND.X(J).EQ.CMXEQ)GOTO 70
		IF(XGE.AND.X(J).GE.CMXGE)GOTO 70
		IF(YLE.AND.X(IY+J).LE.CMYLE)GOTO 70
		IF(YEQ.AND.X(IY+J).EQ.CMYEQ)GOTO 70
		IF(YGE.AND.X(IY+J).GE.CMYGE)GOTO 70

		datx = X(J)
	        daty = X(IY+J)
		IF (MOD_VS_X .AND. datx .LT. xlo) THEN
		   xadd = 360.
		   datx = datx + xadd
		ELSE IF (MOD_VS_X .AND. datx .GT. xhi) THEN
		   xadd = -360.
		   datx = datx + xadd
		ENDIF
		xaddlast = xadd

	        CALL TRANS(I,datx,daty,XT,YT)
	        CALL PLOT(XT,YT,0,0)
	        IF(ITYPE(I).NE.0.AND.ITYPE(I).NE.4) CALL MARK(IMARK(I))
		IM=0
	        IF(ITYPE(I).EQ.1.OR.ITYPE(I).EQ.3) IM=IMARK(I)
	        GOTO 71
70	      CONTINUE
71	      IDN=1
	      idec = 0
* ... plot remaining points
	      DO 72 K=J+1,IBASE+LLENG(I)
		IF((XLE.AND.X(K).LE.CMXLE).OR.
     *		   (XEQ.AND.X(K).EQ.CMXEQ).OR.
     *		   (XGE.AND.X(K).GE.CMXGE).OR.
     *		 (YLE.AND.X(IY+K).LE.CMYLE).OR.
     *		 (YEQ.AND.X(IY+K).EQ.CMYEQ).OR.
     *		 (YGE.AND.X(IY+K).GE.CMYGE))THEN

		  IF (IDN .EQ. 1 .AND. klast.EQ.k-1) THEN ! prev pt was a singleton
                      CALL PLOT(XTLAST,YTLAST,0,0)
                      CALL MARK(MDOT)
		  ENDIF

	          IDN=0
	        ELSE

	          IF (MOD_VS_X) THEN
	          datx = X(K)
	          daty = X(IY+K)

		  IF (MOD_VS_X .AND. datx .LT. xlo) THEN 
		     xadd = 360.
		     datx = datx + xadd

		  ELSE IF (MOD_VS_X .AND. datx .GT. xhi) THEN  
		     xadd = -360.
		     datx = datx + xadd

		  ELSE
		     xadd = 0.

		  ENDIF

* New modulo wrap: Plot to next point on the last wrap, then pick up the pen, go to 
* the new point on new wrap, then go on.
		  IF (xadd .NE. xaddlast) THEN
		     datxlast = datx - xadd + xaddlast
		     CALL TRANS(I,datxlast,daty,XT,YT)
		     CALL PLOT(xt,yt,idn,0)
		     CALL TRANS(I,datx,daty,XT,YT)
		     CALL PLOT(XT,YT,0,0)
		     CALL PLOT(XT,YT,IDN,0)
		  ENDIF

		  CALL TRANS(I,datx,daty,XT,YT)
		  xaddlast = xadd
	
	          ELSE
		     CALL TRANS(I,X(K),X(IY+K),XT,YT)
		  ENDIF  ! mod_vs_x

		  CALL PLOT(XT,YT,IDN,0)

		  if (interrupted) goto 51 ! *jd* 8.3.92
	          idec = idec + 1
	          md = MOD(idec,nskp) .EQ. 0
	          IF (md) CALL MARK(IM)
	          IF(IDN.EQ.0)THEN
		    xtlast = xt
		    ytlast = yt
		    klast = k
	            IDN=1
	          END IF
	        END IF
72	      CONTINUE
	    END IF
	    IF(ITYPE(I).EQ.2.OR.ITYPE(I).EQ.5)CALL MARK(IMARK(I))

	  END IF

          IF (imark(i) .eq. 99) THEN
             CALL doit_makedot(IPT,XDOT,YDOT)
             IPT = 0
          ENDIF
	if (interrupted) go to 51 !*jd* 8.3.92
50	IBASE=IBASE+LLENG(I)

******** END OF LOOP OVER LINES STORED

*** FINALIZE
 51	CONTINUE
        IF (imark(i) .eq. 99) THEN
          CALL doit_makedot(IPT,XDOT,YDOT)
          IPT = 0
        ENDIF

        CALL COLOR(IPEN(0))
	RETURN

	END

*           rr_adv_umetric.F
*
*           Rick Romea
*           Jan. 24, 2000 
*
*     Computes the zonal nonlinear advective metric:  uv tan(theta) / a
*     Units :     cm/s/s
*     MOM2 Grid:  U   
*
*******************************************************************

      SUBROUTINE RR_adv_umetric_init(id)
	IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

      CALL ef_set_desc             (id,
     . 'Zonal momentum nonlinear metric term (cm/s^2);MOM2 U Grid')
      CALL ef_set_num_args         (id, 2)
      CALL ef_set_axis_inheritance (id, IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok     (id, NO, NO, YES, YES)

      ! Define first argument (U)

      CALL ef_set_arg_name         (id, ARG1, 'U')
      CALL ef_set_arg_desc         (id, ARG1,
     . 'Zonal velocity, on the MOM2 U Grid. ')
      CALL ef_set_arg_unit         (id, ARG1, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG1, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG1, YES, YES, YES, YES)

      ! Define second argument (V)

      CALL ef_set_arg_name         (id, ARG2, 'V')
      CALL ef_set_arg_desc         (id, ARG2,
     . 'Meridional velocity, on the MOM2 U Grid. ')
      CALL ef_set_arg_unit         (id, ARG2, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG2, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2,YES,YES,YES,YES)

      END


      SUBROUTINE RR_adv_umetric_compute(id, arg_1, arg_2, result)
	IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER        id

      REAL           bad_flag(EF_MAX_ARGS)
      REAL           bad_flag_result

      REAL           arg_1 (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .                      mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL           arg_2 (mem2lox:mem2hix, mem2loy:mem2hiy, 
     .                      mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL           result (memreslox:memreshix,memresloy:memreshiy,
     .                       memresloz:memreshiz,memreslot:memreshit)

      INTEGER        res_lo_ss (4)
      INTEGER        res_hi_ss (4)
      INTEGER        res_incr  (4)

      INTEGER        arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER        arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER        arg_incr  (4,EF_MAX_ARGS)

      INTEGER        i,  j,  k,  l
      INTEGER        i1, j1, k1, l1
      INTEGER        i2, j2, k2, l2 

      INTEGER        ilat
      CHARACTER *16  ax_name(4)
      CHARACTER *16  ax_units(4)
      LOGICAL        backward(4)
      LOGICAL        modulo(4)
      LOGICAL        regular(4)

      REAL tng

      REAL*8         yU(1024)

	INCLUDE 'rr_parameters.h'

      ! Get axis data

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags      (id, bad_flag,  bad_flag_result)
      CALL ef_get_coordinates    (id, ARG1, Y_AXIS, 
     .                            arg_lo_ss(Y_AXIS,ARG1),
     .                            arg_hi_ss(Y_AXIS,ARG1), yU)

      ! Check axis units:  bail out if not lat and lon.

      CALL ef_get_axis_info  (id, ARG1, ax_name, ax_units, 
     .                                backward, modulo, regular) 
      IF     ( ax_units(1) .NE. 'deg'       .AND.
     .         ax_units(1) .NE. 'lon'       .AND.
     .         ax_units(1) .NE. 'degrees_E' .AND.
     .         ax_units(1) .NE. 'longitude' .AND.
     .         ax_units(1) .NE. 'Longitude' .AND. 
     .         ax_units(1) .NE. 'LONGITUDE' ) THEN
        WRITE (6,*)'Longitude axis units =', ax_units(1) 
        ! CALL ef_bail_out(id,'Longitude axis must be in degrees')
      ENDIF

      IF     ( ax_units(2) .NE. 'deg'       .AND.
     .         ax_units(2) .NE. 'lat'       .AND.
     .         ax_units(2) .NE. 'degrees_N' .AND.
     .         ax_units(2) .NE. 'latitude'  .AND.
     .         ax_units(2) .NE. 'Latitude'  .AND. 
     .         ax_units(2) .NE. 'LATITUDE' ) THEN
        WRITE (6,*)'Latitude axis units =', ax_units(2) 
        !CALL ef_bail_out(id,'Latitude axis must be in degrees')
      ENDIF

      l1 = arg_lo_ss(T_AXIS,ARG1) 
      l2 = arg_lo_ss(T_AXIS,ARG2) 
      DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         
         k1 = arg_lo_ss(Z_AXIS,ARG1)
         k2 = arg_lo_ss(Z_AXIS,ARG2)
         DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

            iLat = 1  
            j1 = arg_lo_ss(Y_AXIS,ARG1)
            j2 = arg_lo_ss(Y_AXIS,ARG2)
            DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
               
               IF ( DABS(yU(iLat)) .EQ. 90.d0 ) THEN
                 tng = 0.   ! handle special case
               ELSE   
                 tng = TAN (SNGL(yU(iLat)) * Degrees_to_radians) 
               ENDIF

               i1 = arg_lo_ss(X_AXIS,ARG1)
               i2 = arg_lo_ss(X_AXIS,ARG2)
               DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

                  IF (arg_1(i1,j1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_2(i2,j2,k2,l2) .EQ. bad_flag(ARG2) )THEN
                     result(i,j,k,l) = bad_flag_result
                  ELSE
                     result(i,j,k,l) = tng / RR_radius
     .                       * ARG_1(i1,j1,k1,l1) 
     .                       * ARG_2(i2,j2,k2,l2)*sec_per_month
                  ENDIF
                  i1 = i1 + arg_incr(X_AXIS,ARG1)
                  i2 = i2 + arg_incr(X_AXIS,ARG2)
               ENDDO

               iLat = iLat + 1
               j1 = j1 + arg_incr(Y_AXIS,ARG1)
               j2 = j2 + arg_incr(Y_AXIS,ARG2)
            ENDDO               

            k1 = k1 + arg_incr(Z_AXIS,ARG1)
            k2 = k2 + arg_incr(Z_AXIS,ARG2)
         ENDDO

         l1 = l1 + arg_incr(T_AXIS,ARG1)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
      ENDDO

      END

	INTEGER FUNCTION TM_FERRET_VARTYPE (ncvtype)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Given a netCDF variable type return the corresponding Ferret parameter

* V533 *sh* 6/01
* V540 *acm* per SH email of 10/19/01  For datasets with datatype "short"
*            Ferret translates the "short" to "float" but the new code 
*            made it think that the variable is, indeed, of type short.
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

	include 'tmap_dtypes.parm'
        include 'netcdf.inc'

* input arguments
	INTEGER	ncvtype

	IF (ncvtype .EQ. NF_FLOAT) THEN
	  TM_FERRET_VARTYPE =  ptype_float
	ELSEIF (ncvtype .EQ. NF_CHAR) THEN
	  TM_FERRET_VARTYPE =  ptype_string
	ELSEIF (ncvtype .EQ. NF_DOUBLE) THEN
	  TM_FERRET_VARTYPE =  ptype_double
	ELSEIF (ncvtype .EQ. NF_INT) THEN
	  TM_FERRET_VARTYPE =  ptype_int4
	ELSEIF (ncvtype .EQ. NF_SHORT) THEN
	  TM_FERRET_VARTYPE =  ptype_int2
	ELSEIF (ncvtype .EQ. NF_BYTE) THEN
	  TM_FERRET_VARTYPE =  ptype_int1
	ELSE
	  CALL WARN('Internal err: unknown data type')
	  TM_FERRET_VARTYPE = ptype_float
	ENDIF

* full data type support not implemented as-of 10/01. 
* cd_read will convert all numeric data to float

       IF ( ncvtype .NE. NF_CHAR) TM_FERRET_VARTYPE =  ptype_float

	RETURN
	END

        LOGICAL FUNCTION CD_DSG_FEATURE_OK (dset, dsg_direction)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*.
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Return TRUE if the direction is the native direction of the ragged-array
* file, or if it can be treated as the requested direction, e.g. a trajectory
* dataset treated as a timeseries dataset.

* Programmer Ansley Manke SDIG 9/2018

* argument definitions:
*       dset      - dataset number for already opened CDF file
*       dsg_direction      - feature-direction flag, 
*	      trajectory marked as x_dim = 1 
*	      profile	 marked as z_dim = 3
*	      time	 marked as t_dim = 4
*	      point	 not yet handled

* include files
        include 'netcdf.inc'
        include 'tmap_errors.parm'
        include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
        include 'xio.cmn_text'
        external xio_data
        include 'xdset_info.cmn_text'
        external xdset_info_data
        include 'xdyn_linemem.cmn_text'
        include 'xtm_grid.cmn_text'

* argument declarations
        INTEGER  dset, dsg_direction

* local variable declarations:
        INTEGER i, lm, obs_dimlen, ivar

* If the set is already open but with no orientation (from a use/feature=none)
* or if the set is already open with the same direction as being requested, we're done.

	IF  (dsg_orientation(dset) .LE. no_dim) THEN
	   CD_DSG_FEATURE_OK = .TRUE.
	   GOTO 5000
	ENDIF

	IF  (dsg_direction .EQ. dsg_orientation(dset)) THEN
	   CD_DSG_FEATURE_OK = .TRUE.
	   GOTO 5000
	ENDIF

        obs_dimlen = dsg_obs_dimlen(dset)

	IF (dsg_direction .EQ. x_dim) THEN

	   ivar = dsg_coord_var(x_dim,dset)
           lm = dsg_loaded_lm(ivar) 
	   IF (lm_size(lm) .NE. obs_dimlen) GOTO 5100

	   ivar = dsg_coord_var(y_dim,dset)
	   IF (ivar .EQ. int4_init) GOTO 5100
           lm = dsg_loaded_lm(ivar) 
	   IF (lm_size(lm) .NE. obs_dimlen) GOTO 5100

	   ivar = dsg_coord_var(t_dim,dset)
           lm = dsg_loaded_lm(ivar) 
	   IF (lm_size(lm) .NE. obs_dimlen) GOTO 5100

        ElSE IF (dsg_direction .EQ. z_dim) THEN

	   ivar = dsg_coord_var(z_dim,dset)
	   IF (ivar .EQ. int4_init) GOTO 5200
           lm = dsg_loaded_lm(ivar) 
	   IF (lm_size(lm) .NE. obs_dimlen) GOTO 5200

	ELSE IF (dsg_direction .EQ. t_dim) THEN

	   ivar = dsg_coord_var(t_dim,dset)
	   IF (ivar .EQ. int4_init) GOTO 5300
           lm = dsg_loaded_lm(ivar) 
	   IF (lm_size(lm) .NE. obs_dimlen) GOTO 5300

	ELSE
	   ! Future: point types, others?
	ENDIF
	
	CD_DSG_FEATURE_OK = .TRUE.


 5000   RETURN
 5500   CD_DSG_FEATURE_OK = .FALSE.
	RETURN

 5100	CONTINUE
        CALL TM_NOTE('Coordinates inconsistent with FeatureType. '//
     .    'Trajectory data must have observations along XYT', lunit_errors )
	GOTO 5500
 5200	CONTINUE
        CALL TM_NOTE('Coordinates inconsistent with FeatureType. '//
     .    ' Profile data must have observations along Z', lunit_errors )
        GOTO 5500

 5300	CONTINUE
        CALL TM_NOTE('Coordinates inconsistent with FeatureType. '//
     .    'Timeseries data must have observations along T', lunit_errors )
	GOTO 5500

	END

	SUBROUTINE CDF_LIST ( fname, append, crecdim, nvars,
     .			      mr_list, cx_list, title, enhead, mode,
     .			      clobber, edges_flag, do_bounds, 
     .			      keepax_flag, out_type, quiet, as_global,
     .			      usr_maxstrlen, do_coords, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* write the indicated list of variables out in netCDF format

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V230:  6/92
*       8/18/92 - added "_FillValue" attribute to pre-fill missing gaps      
*       11/4/92 - expanded user variable name length
* V320: 5/94 - array "memory" as a calling argument
*       8/94 - added qualifiers /ILIMITS=, /JLIMITS, etc.
*	11/94 - output "title" and "long_name_mod" in addition to global
*		and variable "history" attributes ("history" ignored on input)
*	 1/95 - bug introduced 8/94: error branch to 5300 causes crash 
*     1/25/95 - added argument "enhead" for enhanced heading control
* V411: 9/95 - corrected wrong type declaration of ISUBSCRIPT (discovered
*		only on IBM port)
* V450: 11/96 - added argument clobber to allow deletion of file
*		added argument "mode" and code to support NetCDF cache suitable
*		for DODS. Since DODS communications are stateless a cached
*		version of a remote file which contains all of the metadata
*		and coordinates is sufficient to prepare Ferret to read
*		remote DODS data. Only ncopn need be called then on the
*		remote file.
* Linux Port - 6/97 - reorder if def logic when setting cd_data_type to 
*                     BYTE or INTEGER*1
*		    - create equivalences so that all CD_WRITEVAL calls have
*			the same arg daat types
* kob*   9/97 - replaced call to ISUBSCRIPT w/ call to ISUBSCR_CX in order
*               to have access to context information - needed for negative
*               time step processing
* V500 *kob* 3/99- up SANITARY_VAR_CODE and local variable varcode to 64 chars
*             and VAR_UNITS to 64
* V512; *sh* 7/00 - allow SAVE/ILIMITS=n:n (no range) - new arg to EQUAL_RANGE
* V530; *sh* 12/00 - defer writing of axis coordinates and variable data values
*		to a single consolidated point at the end -- to alleviate
*		performance problems due to switching netCDF modes
* V530 *acm* 3/01 pass calendar ID to EQUAL_RANGE
*            4/16/01 properly declare TM_GET_CALENDAR_ID as integer
* V533 *sh* 6/01 - added support for netCDF output string variables
* V600 *acm* 8/05 - Allow more digits in xrevision number
* V552 *acm* 4/03- up SANITARY_VAR_CODE and local variable varcode to 128 chars
* V600 *acm* 6/06  Attribute control; get information for output from  
*                  linked-list structure.
* V600  4/06 *acm* - additional declarations found by Solaris compiler
* V601 10/06 *acm* Fix bug, bug 1454 if the user has set title or units, the users
*                  value is written, previously had always only got these from the
*                  attribute structure, so the new values were not saved.
* V601 10/06 *acm* Fix bug 1460; for value of string attributes, buff is 2048, 
*                  so set buff_size to match. Also, when looping through attributes
*                  (DO 200 loop) only get attribute values from the linked list structure
*                  if they are to be written to the output file.
* V601 10/06 *acm* fix bug 1451, cd_write_var needs the value of mode_upcase_output.
* V602  2/07 *acm* Fix bug 1492, changing attributes of coordinate variables 
* V604  7/07 *acm* Fix bug 1520, if a var has only a _FillValue attribute, and not a 
*                  missing_value one, then neither was written to the output file.
*                  Both should be written.
* V612 8/08  *acm* Fix bug 1587: so that correct bounds are written for axes of a 
*                  user-defined variable, send the dataset number of the underlying 
*                  dataset to cd_write_var
* V62  *acm*  2/09 - Fix bug 1634: allow SAVE/KEEP_AXISNAMES so that child axis names
*                    arent written. They can get too long for OPeNDAP library calls
* V62  *acm*  3/09 - Allow for CANCEL ATT/OUTPUT var.missing_flag and var._FillValue
*                   the special code for these made it impossible to turn off writing
*                   these attributes.
* V641 *acm*  1/10 -Fix bug 1715: packing data on output (bug is in ordering of args
*                   in call to NC_GET_ATTRIB for add_offset, also fix up the output 
*                   missing and FillValue flags which werent correct.)
* V65  *acm*  1/10  Data from some datasets get a mismatch between _FillValue and 
*                   data on output. Fix this.
*       *acm* 3/12  Add E and F dimensions (use nferdims in tmap_dims.parm)
*       *acm* 4/12  The record axis must be the last (slowest varying) axis. If a 
*                   time axis is written, and an E or F axis is written, then write 
*                   in /RIGID mode, with no record axis.
* V680  5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V683  8/12 *acm*  New SET LIST/OUTTYPE and SAVE/OUTTYPE 
* V683 12/12 *acm*  Fix ticket 2004: appending data when writing packed variable
* V685 *acm*  3/13  List the full path or url in the history att for variable.
* V685 6/13 *acm* new qualifier SAVE/NOBOUNDS
* V685 6/13 *acm* Dont add SAVE/NOCOORDS
* v685 6/13 *acm*  bug 2081. For string vars, if the len comes back as 0 the variable contains 
*                  just null strings. Set maxstrlen to 1, else we can't define the variable.
* V686 12/13*acm* For string variables from datasets, keep the string-dimension name and length
*                 from the original dataset on output.
* V686 1/14 *acm* Fix ticket 2136: Appending a string variable to a dataset.
* V687 3/14 *acm* Correct the writing of missing and fill attributes when writing a scaled
*                 user-defined variable.	
* V687 3/14 *acm* Fix ticket 1750. Write Ferret-internal axis names to cdf files, unless
*                 the user has said /KEEP_AXISNAMES
* V694 *acm* 3/15 Ticket 2240. Dont send scale, attribute, and bad-val to CD_WRITE_VAR. That
*                 routine gets those attributes per variable from the dataset being written.
* V695 *acm* 7/15 If they said LIST/QUIET, don't do all the warnings and NOTEs
* V698 *acm* 1/16 Allow for Epic CDF files, ds_type = 'ECDF'
* V698  2/16 *acm* For ticket 2352: variables defined with LET/D are
*                  added to that dataset in the attribute structure
* V7   *acm*  6/12 Add Union aggregations: DEFINE DATA/AGG/U, ds_type 'UNI'
* V702 1/17 *sh* for trac enhancement #2369 -- dynamic memory management 
* v73+ *acm* 12/2017 Issue # 1846, writing user-variables with scale_factor, add_offset
* V74  *acm* 2/18 Issue # 1861, handling missing- and _FillValue with scale and offset
*                 write correct attributes to netCDF output
* V741 *acm* 6/18 V7.40, Issue 1332: write global attributes, and a fix for scalar numeric
*                 attributes 6/6/18.
* V743 *acm* 7/18 Issue 1883: var with only a _FillValue which is NaN got no
*                 _FillValue or missing_value attribute written
* v745 *acm* 12/18  Issue 1909, option to write dates in ISO8601 format
* V751 *acm* 6/19 Remove unused declarations
* V751 *acm* 7/19 Ticket 1946: File with user-variable strings truncates strings appended later.
*		  - Allow for the user to set a length for string-length dimension
* V751 *acm*11/19 new qualifier SAVE/NOCOORDS
* V7.6 *acm* 2/20 When save/asglobal, do not update the conventions or history
* v7.6 *acm* 5/20 Issue 1876: can read string-typed data, write as char.

        IMPLICIT NONE
        include 'netcdf.inc'
#include "netcdf_declareUnderscore.inc"
        include 'tmap_errors.parm'
        include 'cd_lib.parm'
        include 'cdf_tmap.parm'
        include 'tmap_dims.parm'
        include 'xtm_grid.cmn_text'
	include 'xdset_info.cmn_text'	! for DODS caching
	include 'xdset_info.cd_equiv'	! for DODS caching
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
	include 'xrevision.cmn'
	include 'xtoday.cmn'
	include 'xinterrupt.cmn'
        include 'netcdf4_settings.cmn'

* calling argument declarations:
        LOGICAL         append, enhead, clobber, do_coords, quiet
	INTEGER		nvars, mr_list(nvars), cx_list(nvars), mode,
     .			edges_flag, keepax_flag, do_bounds, usr_maxstrlen, 
     .			status
        CHARACTER*(*)   fname, title, out_type
        CHARACTER*1     crecdim

* internal variable declarations:

	INTEGER	   max_len
	PARAMETER (max_len = 2048)

        LOGICAL         TM_LEGAL_NAME, MATCH_NAME, TM_HAS_STRING,
     .			itsa_uvar, need_doc, new, formatted, flushed,
     .			itsa_string, output_units, output_title,
     .                  output_history, get_ds, its_nc, as_global, 
     .                  hist_and_conv
	INTEGER		TM_LENSTR1, ISUBSCR_CX, GET_MAX_C_STRING_LEN,
     .			MGRID_SIZE, STR_SAME, 
     .			cx, mr, dset, grid, cdfid, ivar, nready,
     .                  lbuff, cdfstat, idim, i, loc, errloc,
     .                  recdim, cat, var, cat1, var1, iaxis,
     .			final_status, type, maxstrlen, 
     .			write_lo(nferdims), write_hi(nferdims), 
     .			make_lo(nferdims), make_hi(nferdims),
     .                  dset_last, dset_num, attid, len, ndims_size, wlen

* *kob* 3/99- up SANITARY_VAR_CODE and local variable varcode to 64 chars
*             and VAR_UNITS to 64
* V552 *acm* 4/03- up SANITARY_VAR_CODE and local variable varcode to 128 chars

	CHARACTER	SANITARY_VAR_CODE*128, VAR_TITLE*140,
     .                  VAR_TITLE_MOD*140, VAR_UNITS*64, CX_DIM_STR*48,
     .                  TM_FMT*48, GET_STRING_ELEMENT*(max_len),
     .                  varcode*128, varname*128, buff*2048, revnum*12, 
     .                  c1*1, aname*128, short*128

	REAL*8		user_lo, user_hi, delta, loest_ww, hiest_ww,
     .                  miss_in, fill_in, r_scale, r_off, oneval

* local parameter declarations:
        LOGICAL    already_warned
	DATA    already_warned       / .FALSE. /

* For error messages
      CHARACTER*9 typnam(6)
      DATA typnam/'NC_BYTE', 'NC_CHAR', 'NC_SHORT', 'NC_INT', 
     .            'NC_FLOAT', 'NC_DOUBLE'/

* special equivalence (not in tmap_format/xdset_info.cd_equiv because 
* "BYTE" isnt supported on DECstation)
* reorder loop logic because linux cpp didnt like it *kob* 10/96

#   ifdef sun
      BYTE cd_data_type(maxvars)
#   else
      INTEGER*1 cd_data_type(maxvars)
#   endif

	EQUIVALENCE ( ds_precision, cd_data_type )

* internal equivalence so to match data types for F90
#   ifdef sun
      BYTE ibuff1
#   else
      INTEGER*1 ibuff1
#   endif

	REAL*4		rbuff4
	REAL		vals(100), bad
        REAL*8          dvals(100), avals(0:99), scalefac, addoff
	INTEGER*4	ibuff4
	EQUIVALENCE (rbuff4, ibuff4), (rbuff4, ibuff1)

* local parameter declarations

        INTEGER         TM_GET_CALENDAR_ID, TM_CHECK_NAN, DSG_WHATS_IT, 
     .                  TM_DSG_DSET_FROM_GRID, TM_DSG_NFEATURES,
     .                  buff_size, sslimits0, 
     .			wwlimits0, cal_id, tax, varid, vartype, nvdims, 
     .                  nvatts, vdims(8), iatt, slen, alen, istat, 
     .                  attype, attlen, attoutflag, all_outflag,
     .                  outtype, no_missing_flag, no_fill_flag, 
     .                  varoutflag, nfeatures, longest_feature, nobs
	REAL		little_val, big_val
        LOGICAL         full_precision, DODS_cache, range_not_rqd,
     .                  got_it, got_title, got_history, got_units, its_cdf,
     .                  got_missing, got_fill, do_warn, coordvar, user_var, has_dsg

        PARAMETER     ( buff_size = 2048,
     .			sslimits0 = 1+23-1,
     .			wwlimits0 = 1+29-1,
     .                  full_precision = .TRUE.,
     .			range_not_rqd = .FALSE. )
	CHARACTER	cal_name*32 , attname*128, buff1*128, buff2*128

* initialize
	ivar = 1  ! just house-keeping -- make sure all is init'ed
	cx  = cx_list(1)
	dset = cx_data_set( cx )

	 flushed = .FALSE. ! on error, whether OK variables were written
	 final_status = ferr_ok  ! innocent unless proven guilty
	 DODS_cache = mode .EQ. pcdf_mode_cache
         do_warn = .NOT.quiet
	 got_missing = .FALSE.
	 got_fill = .FALSE.

         CALL CD_DEFER_COORD_WRITE(0,0,0,0,0,pcd_defer_init)

* open/create the file
         CALL CD_OPEN_OUT( fname, append, cdfid, clobber, 
     .                     netcdf4_type, status )
         IF ( status .NE. merr_ok ) GOTO 5400

* History and conventions attributes updated, but not if we're just
* writing a global attribute.

* update history attribute in the file
        revnum = TM_FMT(revision_level, 5, 12, slen)

	hist_and_conv = .TRUE.
	IF (.NOT.clobber .AND. as_global) hist_and_conv = .FALSE.
	IF (hist_and_conv) THEN

           CALL CD_STAMP_OUT( append, cdfid,
     .       program_name(:len_program_name)//' V'//revnum(:slen)//' '//
     .       progname_mod(:len_progname_mod)//' '//today_date, status )
           IF ( status .NE. merr_ok ) GOTO 5800

* update Conventions attribute in the file

           buff1 = 'CF-1.6'

           CALL CD_CONVENTIONS_OUT( append, cdfid, buff1, status )
           IF ( status .NE. merr_ok ) GOTO 5800
	ENDIF

* optional title for data set
	IF ( title .NE. ' ' ) THEN
	   CALL CD_WRITE_ATTRIB(cdfid, pcdf_global, 'title',
     .			title(:TM_LENSTR1(title)), .FALSE., status )
	   IF ( status .NE. merr_ok ) GOTO 5800
	ENDIF

* Did they set a string-length?

* DODS URL saved as a global attribute (11/96)
	IF ( DODS_cache ) THEN
! note that routine CDF_PREP_CACHE is assumore med to have checked the validity
!      of the data set as a DODS data set
           dset = cx_data_set(cx_list(1))
	   CALL CD_WRITE_ATTRIB(cdfid, pcdf_global, 'DODS_URL',
     .			ds_des_name(dset), .FALSE., status )
           IF ( status .NE. merr_ok ) GOTO 5800
	ENDIF

* Other global attributes, if they have been marked for output.
* Mark global attrs for output with SET ATT/OUT=ALL .

        varid = 0      
	cx  = cx_list(1)
        dset = cx_data_set( cx )
	its_cdf = .FALSE.

        IF (dset .GT. pdset_irrelevant) THEN
           its_cdf = (ds_type(dset).EQ.'CDF' .OR. ds_type(dset).EQ.'ECDF' 
     .        .OR. ds_type(dset).EQ.' MC' .OR. ds_type(dset).EQ.'ENS' 
     .        .OR. ds_type(dset).EQ.'FCT' .OR. ds_type(dset).EQ.'UNI') 
           IF (its_cdf) CALL CDF_LIST_GLOBAL_ATTS (dset, cdfid, status)
	ENDIF

* Are variables from a DSG dataset?  Further checking for consistency within
* the CDF_LIST_DSG routine

	has_dsg = .FALSE.
	IF (.NOT.as_global) THEN
	   DO ivar = 1, nvars
              cx = cx_list(ivar)
              grid = cx_grid(cx)
	      IF (DSG_WHATS_IT(grid) .NE. pdsg_not_dsg) THEN 
                 dset = TM_DSG_DSET_FROM_GRID( grid )
                 nfeatures = TM_DSG_NFEATURES( grid )
                 CALL DSG_COORD_LIMS(dset, pdsg_row_size, little_val, big_val)
                 longest_feature = big_val
                 has_dsg = .TRUE.
                 EXIT
	      ENDIF
	   ENDDO
	ENDIF  ! its_cdf

* can append a variable if its grid matches what's in the file using
* non-dsg-code, below (?)

	IF (has_dsg) THEN
	  nobs = dsg_obs_dimlen(dset)
	  CALL CDF_LIST_DSG ( dset, cdfid, fname, append, nvars,
     .			     nfeatures, nobs, longest_feature,
     .			     mr_list, cx_list, title,
     .			     out_type, quiet, do_coords, status )
	   GOTO 5990  ! any error messages have been issued 
	ENDIF

        dset_last = dset
        scalefac = 1.
        addoff = 0.

*  Loop to create all of the variables and their metadata
*  (defer writing of binary data until end) 
*
       DO 100 ivar = 1, nvars
	   cx  = cx_list(ivar)
	   mr  = mr_list(ivar)
	   grid	= cx_grid( cx )
           dset = cx_data_set( cx )
           IF (dset_last .NE. dset) THEN
              IF (dset .GE. 1) THEN
                 its_cdf = (ds_type(dset) .EQ. 'CDF' .OR. 
     .               ds_type(dset) .EQ. ' MC' .OR. 
     .               ds_type(dset) .EQ. 'ENS' .OR. 
     .               ds_type(dset) .EQ. 'FCT' .OR. 
     .               ds_type(dset) .EQ. 'UNI') 
                 IF (its_cdf) CALL CDF_LIST_GLOBAL_ATTS (dset, cdfid, status)
              ENDIF
              dset_last = dset
           ENDIF

           cat = cx_category(cx)
           var = cx_variable(cx)
           varcode = SANITARY_VAR_CODE( cat, var )
           got_title = .FALSE.
           got_history = .FALSE.
           got_units = .FALSE.
           output_title = .FALSE.
           output_title = .TRUE.  ! output the var long_name by default
           output_units = .FALSE.
           output_history = .TRUE.
	   itsa_string = cx_type(cx) .EQ. ptype_string

* is it in the linked-list for dset. If so get attr info, including original 
* upper/lowercase form of the name. If mode upcase_output is set, then upcase 
* the variable name.
* If it is a LET/D= user-var its linked list info is with that datset.
 
* For user-defined variables, with double-precision Ferret, write as double-precision
* unless the user has requested otherwise.

           itsa_uvar = cat .EQ. cat_user_var
	   IF (dset .EQ. pdset_irrelevant) dset = pdset_uvars
	   IF (itsa_uvar .AND. dset .LE. pdset_irrelevant)  dset = pdset_uvars
           CALL CD_GET_VAR_ID (dset, varcode, varid, status)
	   IF (status .NE. ferr_ok) THEN
	      IF (itsa_uvar .AND. dset.GE.pdset_irrelevant) THEN
	         dset = pdset_uvars
		 CALL CD_GET_VAR_ID (dset, varcode, varid, status)
		 IF (status .NE. ferr_ok) dset = dset_last
	      ENDIF
	   ENDIF

           vartype = 0
           outtype = 0

           IF (status .EQ. ferr_ok) 
     .       CALL CD_GET_VAR_INFO (dset, varid, varname, vartype, nvdims, 
     .            vdims, nvatts, coordvar, all_outflag, status)

           CALL CDF_SET_OUT_TYPE (dset, varid, itsa_uvar, 
     .                itsa_string, out_type, outtype, status)
           IF (status .NE. ferr_ok) GOTO 5500

           IF ( cat .EQ. cat_pseudo_var )THEN
	      varcode = varcode(:TM_LENSTR1(varcode))//"_"
	      IF (varcode(1:1) .EQ. "_") varcode = varcode(2:)
	   ENDIF

	   tax = grid_line(t_dim,grid)
           cal_name = line_cal_name(tax)
           cal_id = TM_GET_CALENDAR_ID ( cal_name )

* allowed name?
	   IF (cat .NE. cat_file_var) THEN
              IF ( .NOT.TM_LEGAL_NAME(varcode) ) GOTO 5200
              CALL FIND_VAR_NAME ( pdset_irrelevant, varcode, cat1, var1 )
              IF (  var1 .NE. munknown_var_name
     .      .AND. cat1 .EQ. cat_pseudo_var    ) GOTO 5200
           ENDIF

* if a string variable, then find max len
* If the len comes back as 0 the variable contains just null strings.
* Set maxstrlen to 1, else we cant define the variable.
* Ticket 1946
* For file variables we use the string-length dimension from the input file.
* For user-variables allow the user to set a length. A file created with 
* initial strings of shorter length then truncated strings appended later.

	   IF (itsa_string) THEN
	      maxstrlen = GET_MAX_C_STRING_LEN(
     .				   mr_c_pointer(mr), MGRID_SIZE(mr))
	      IF (maxstrlen .LE. 0) maxstrlen = 1

	      IF (usr_maxstrlen.GT.0 .AND. append .AND. do_warn) THEN 
	         CALL WARN ('SAVE/STRLEN= is ignored when appending to the file')
		 usr_maxstrlen = 0
	      ENDIF

* Here, for user-variables, we COULD arbitrarily set maxstrlen to something larger than 
* the maxstrlen computed for this write, when the user hasn't set a value with /STRLEN, 
* maybe only when the grid has a time axis, e.g. IF(tax.NE.mnormal), so that appends 
* with longer strings would work.  See ticket 1946.

	      IF (itsa_uvar .AND. .NOT.append) THEN
	         IF (usr_maxstrlen.GT.0 .AND. usr_maxstrlen.LT.maxstrlen) GOTO 5600
		 IF (usr_maxstrlen.GT.0) maxstrlen = usr_maxstrlen
	      ENDIF
	   ELSE
	      maxstrlen = 0
	   ENDIF

* get slab limits to use for writing the values of this variable

           ndims_size = 0
	   wlen = 0

           DO 50 idim = 1, nferdims
* ... limits within which to write variable data
              write_lo(idim) = cx_lo_ss(cx,idim)
              write_hi(idim) = cx_hi_ss(cx,idim)

	      IF (write_hi(idim) - write_lo(idim) .GT. 1) THEN
	         ndims_size = ndims_size + 1
	         wlen = write_hi(idim) - write_lo(idim) + 1
	      ENDIF

* get slab limits to use for creating this NetCDF variable
* (elaborate checking if user manually specifies creation limits)
* ... limits within which to create NetCDF variable
              make_lo(idim)  = write_lo(idim)
              make_hi(idim)  = write_hi(idim)
	      IF ( make_lo(idim) .NE. unspecified_int4 ) THEN
	         iaxis = grid_line(idim,grid)
* ... creation limits manually specified by world coordinates?
	         loc = qual_given(wwlimits0+idim)
                 IF ( loc .GT. 0 ) THEN
		    errloc = loc
	            CALL EQUAL_RANGE_T(
     .			cmnd_buff(qual_start(loc):qual_end(loc)), idim,
     .                  grid, user_lo, user_hi, delta, cal_id, status )
                    IF ( status .NE. ferr_OK ) GOTO 5800
	            CALL GRID_WORLD_EXTREMES( loest_ww, hiest_ww,
     .			grid, idim )
	            IF ( .NOT.line_modulo(iaxis) 
     .		   .AND. ( user_lo .LT. loest_ww
     .		      .OR. user_hi .GT. hiest_ww ) ) GOTO 5300
	            make_lo(idim) = ISUBSCR_CX
     .			( user_lo, grid, idim, cx, round_up )
	            make_hi(idim) = ISUBSCR_CX 
     .			( user_hi, grid, idim, cx, round_dn )
	            IF ( .NOT.line_modulo(iaxis)  
     .		   .AND. ( make_hi(idim) .GT. line_dim(iaxis)
     .	              .OR. make_lo(idim) .LT. 1 )	   )	GOTO 5300
	            IF ( make_lo(idim) .GT. write_lo(idim)
     .		    .OR. make_hi(idim) .LT. write_hi(idim) ) 	GOTO 5310
	         ENDIF
* ... creation limits manually specified by subscript?
	         loc = qual_given(sslimits0+idim)
                 IF ( loc .GT. 0 ) THEN
		    errloc = loc
	            CALL EQUAL_RANGE(
     .			cmnd_buff(qual_start(loc):qual_end(loc)),
     .                  idim, user_lo, user_hi, delta, formatted,
     .			range_not_rqd, cal_id, status )
                    IF ( status .NE. ferr_OK ) GOTO 5990
	            make_lo(idim) = user_lo
	            make_hi(idim) = user_hi
	            IF ( .NOT.line_modulo(iaxis) 
     .	           .AND. ( make_hi(idim) .GT. line_dim(iaxis)
     .	              .OR. make_lo(idim) .LT. 1 )	      ) GOTO 5300
	            IF ( make_lo(idim) .GT. write_lo(idim)
     .		    .OR. make_hi(idim) .LT. write_hi(idim) ) 	GOTO 5310
	         ENDIF
	      ENDIF

* ... if a time axis is written, and an E or F axis is written,
*     then write in /RIGID mode, with no record axis.
	      IF (idim .GT. t_dim .AND.
     .	          make_lo(t_dim) .NE. unspecified_int4 .AND.
     .	          make_lo(idim) .NE. unspecified_int4) THEN
                 crecdim = 'N'
		 IF (.NOT.already_warned .AND. do_warn) CALL WARN (
     .	          'Saving E or F axis with time axis uses /RIGID in time')
                 already_warned = .TRUE.
	      ENDIF

 50        CONTINUE
 
* If writing variable as a global variable, only write 1-D variables.
           IF (as_global .AND. ndims_size .GT. 1) GOTO 5320
	   IF (as_global) CYCLE

* determine the netCDF "record dimension" to use
           IF ( write_lo(t_dim) .EQ. unspecified_int4 ) THEN
              recdim = 0
           ELSEIF ( crecdim .EQ. 'T' ) THEN
              recdim = t_dim
           ELSE
              recdim = 0
           ENDIF

* convert the data type into netCDF parameter value
           IF (DODS_cache .AND. cx_type(cx).EQ.unspecified_int4) THEN
	      cx_type(cx) = nf_double
	   ENDIF

	   IF (cx_type(cx) .EQ. ptype_float) THEN
	      type = nf_float
	   ELSEIF  (cx_type(cx) .EQ. ptype_string) THEN
	      type = nf_char
	   ELSEIF  (cx_type(cx) .EQ. ptype_double) THEN
	      type = nf_double
	   ELSEIF  (cx_type(cx) .EQ. ptype_int4) THEN
	      type = nf_int
	   ELSEIF  (cx_type(cx) .EQ. ptype_int2) THEN
	      type = nf_short
	   ELSEIF  (cx_type(cx) .EQ. ptype_int1) THEN
	      type = nf_byte
	   ELSE
	      CALL WARN('Internal err: unknown data type, using FLOAT')
	      type = nf_float
	   ENDIF
           IF (type .NE. 0 .AND. varid .GT. 0) type = outtype
           IF (dset .EQ. pdset_uvars) type = outtype
           IF (itsa_uvar) type = outtype 
           IF (type .EQ. 0) outtype = vartype

* create the variable and its grid (coordinate output gets deferred)

* If this is a user var the axes are based on the defining dset (if any).
           dset_num = dset
           IF (dset.EQ.pdset_uvars .AND. cx_data_set( cx ).GT.0)
     .        dset_num = cx_data_set( cx )  

* When its a netCDF/OPeNDAP file variable use the max string length from the originating dataset.
* If the variable in the dataset is type string, synthesize a name for the string-length dimension.
           buff2 = " "
           IF (type .EQ. NF_CHAR .AND. dset .GE. 1) THEN
	     buff2 = ""
	     its_nc = ( .NOT. TM_HAS_STRING(ds_type(dset),'EZ') )
             IF (dset_num.GE.1 .AND.(.NOT.itsa_uvar) .AND.its_nc) THEN
                CALL CD_GET_DS_DIMS (dset_num, vdims(1), buff2, len, status)
                IF (maxstrlen .LE. len) maxstrlen = len
             ENDIF
	     CALL CD_GET_VAR_TYPE (dset, varid, varname, vartype, status)
	     IF (vartype .EQ. nf_string) THEN
                CALL CD_GET_DS_DIMS (dset_num, vdims(1), buff2, len, status)
	        buff2 = TM_FMT(FLOAT(maxstrlen), 5, 12, slen)
		buff2 = 'STRING1_'//buff2(:slen)
             ENDIF
           ENDIF

	   IF (varid .GT. 0) THEN
              CALL  CD_GET_VAR_VARNAME (dset, varid, varname, status)
              varcode = varname
              IF (mode_upcase_output) CALL STR_UPCASE( varcode, varname)
	   ENDIF

* If they set a larger string-len, use it
           IF (usr_maxstrlen .GT. 0) THEN 
	      IF (usr_maxstrlen .LT. maxstrlen .AND. do_warn) CALL WARN 
     .        ('/STRLEN setting shorter than max string length. Strings will be truncated.'
     .        //pCR//'Variable: '//varcode )
	      maxstrlen = MAX(maxstrlen, usr_maxstrlen)  
           ENDIF

	   CALL CD_MAKE_VAR( cdfid, dset_num, varcode, type, maxstrlen,
     .               grid, make_lo, make_hi, recdim, enhead, new, 
     .               edges_flag, do_bounds, mode_upcase_output, 
     .               keepax_flag, date_fmt_out, 
     .               netcdf4_type, xchunk_size, 
     .               ychunk_size, zchunk_size, tchunk_size, 
     .               deflate_lev, shuffle_flag, endian_code, buff2,
     .               do_coords, status )

           IF ( status .NE. merr_ok ) GOTO 5800
	   
* if its a newly-created variable write attributes
           IF ( new ) THEN

* If the variable is to be written scaled, set the scale and offset
*  values that will be written as attributes and sent to CD_WRITE_VAR. 

	      IF (varid .GT. 0) CALL CDF_SET_SCALE (dset, varid, 
     .        do_warn, scalefac, addoff, ferr_ok, status)
	      
* Write the attributes from a dataset variable as requested by the settings 
* The title, units, and history may be updated later.

	      bad = mr_bad_data(mr)

	      IF (varid.GT.0 .AND. all_outflag.GT.0) THEN
	         CALL CDF_LIST_DSETVAR_ATTS (dset, itsa_uvar, its_cdf, 
     .             varid, varcode, bad, outtype, cdfid, do_warn,  
     .             scalefac, addoff, got_title, output_title, got_history, 
     .             output_history, got_units, output_units, status)

	         IF (status .NE. ferr_ok) GOTO 5400
	      ENDIF
	      
* Write variable title, units, title modifier, history if not already done

              CALL CDF_LIST_DEFAULT_ATTS (dset, varid, varcode, cx, cdfid, 
     .          outtype, all_outflag, itsa_uvar, got_title, output_title, 
     .          got_history, output_history,  got_units, output_units, status )	
	      IF (status .NE. ferr_ok) GOTO 5400   

* NetCDF variable IDs - additional information needed for DODS caching (11/96)
	      IF ( DODS_cache ) THEN
	         ibuff4 = cd_varid(var)		! for F90 data type checks
	         CALL CD_WRITE_ATTVAL(cdfid, varcode,
     .                     'netcdf_var_id',rbuff4, 1, nf_int, status )
                 IF ( status .NE. merr_ok ) GOTO 5800
	         ibuff1 = cd_data_type(var)	! for F90 data type checks
	         CALL CD_WRITE_ATTVAL(cdfid, varcode,
     .                  'netcdf_data_type', rbuff4, 1, nf_byte, status )
                 IF ( status .NE. merr_ok ) GOTO 5800
	      ENDIF

           ENDIF  ! writing attributes of file or user variables

* Write attributes for psuedo-variables
           IF (cat .EQ. cat_pseudo_var) THEN  

              IF (.NOT.got_missing) THEN
 	         CALL CD_WRITE_ATTVAL_DP(cdfid, varcode,
     .          'missing_value', bad, 1, type, status )
                 IF ( status .NE. merr_ok ) GOTO 5800
              ENDIF

              IF (.NOT.got_fill) THEN
                 CALL CD_WRITE_ATTVAL_DP(cdfid, varcode,
     .          '_FillValue', bad, 1, type, status )
                IF ( status .NE. merr_ok ) GOTO 5800
	      ENDIF

              buff = VAR_TITLE( cx )
              lbuff = TM_LENSTR1( buff )
                 CALL CD_WRITE_ATTRIB(cdfid, varcode, 'long_name',
     .                              buff(:lbuff), .FALSE., status )
              IF ( status .NE. merr_ok ) GOTO 5800

* ...other variable modifiers
              c1 = VAR_TITLE_MOD( cx )
              IF ( c1 .NE. ' ' ) THEN
                 IF ( lbuff .GT. 1 ) THEN
                    buff = buff(:lbuff)//', '
                    lbuff = MIN( 140, lbuff+2)
                 ENDIF
                 buff = buff(:lbuff)//VAR_TITLE_MOD( cx )
                 lbuff = TM_LENSTR1( buff )
              ENDIF
* ... write it to the file
              IF ( lbuff .GE. 2 ) THEN
                 CALL CD_WRITE_ATTRIB( cdfid, varcode, 'long_name_mod', 
     .                              buff(2:lbuff), .FALSE., status )
                 IF ( status .NE. merr_ok ) GOTO 5800
              ENDIF
           ENDIF  ! pseudo-variables

 100    CONTINUE  ! loop over nvars

	nready = nvars

*****
* Finally, write all of the coordinates and data values -- in netCDF DATA mode
* Note that this block of code is also executed following an error to
* ensure that all deferred coordinates and "ready" variables are flushed
 400	flushed = .TRUE.	! errors from here to exit may leave corrupted file
*
* write the deferred coordinates
*
	IF (.NOT.as_global .AND. do_coords) CALL CD_WRITE_DEFER_COORD( cdfid, status )
	IF ( status .NE. merr_OK ) GOTO 5800
*
* write the variables
*
        DO 500 ivar = 1, nready
	   cx  = cx_list(ivar)
	   mr  = mr_list(ivar)
	   grid	= cx_grid( cx )
           dset = cx_data_set( cx )
           cat = cx_category(cx)
           var = cx_variable(cx)
           varcode = SANITARY_VAR_CODE( cat, var )

           itsa_uvar = cat .EQ. cat_user_var
           CALL CD_GET_VAR_ID (dset, varcode, varid, status)  ! is it in the linked-list for dset
           IF (status .NE. ferr_ok .AND. itsa_uvar ) THEN
              dset = pdset_uvars    ! is it a user var based on a var in dset
              CALL CD_GET_VAR_ID (dset, varcode, varid, status) 
           ENDIF

* Get varcode into original upper/lowercase form. If mode upcase_output is set, 
* then upcase the variable name.

           IF (status .EQ. ferr_ok) THEN
              CALL CD_GET_VAR_INFO (dset, 
     .                  varid, varname, vartype,  nvdims, vdims,
     .                  nvatts, coordvar, all_outflag, status) 
              varcode = varname
              IF (mode_upcase_output) CALL STR_UPCASE( varcode, varname)
           ENDIF
     
           IF ( cat .EQ. cat_pseudo_var )THEN
	      varcode = varcode(:TM_LENSTR1(varcode))//"_"
	      IF (varcode(1:1) .EQ. "_") varcode = varcode(2:)
	   ENDIF

* check for interrupts - dont check again until entire variable is written
           IF (interrupted) CALL ERRMSG(ferr_interrupt,status,' ',*5800)

	   IF (as_global) THEN
	      CALL CD_GET_VAR_TYPE (dset, varid, varname, vartype, status)

	      IF (outtype .NE. 0) vartype = outtype
	      IF (itsa_uvar .AND. vartype.EQ.0) THEN  ! for user vars type not known in attrib structure
                  vartype = 6      ! netcdf nf_double
                  IF (itsa_string) vartype = 2
               ENDIF

	      IF (vartype .EQ. NF_CHAR) THEN 

	         IF (wlen .GT. 1) GOTO 5325
		 buff = GET_STRING_ELEMENT(
     .				mr_lo_s1(mr), mr_hi_s1(mr),
     .				mr_lo_s2(mr), mr_hi_s2(mr),
     .				mr_lo_s3(mr), mr_hi_s3(mr),
     .				mr_lo_s4(mr), mr_hi_s4(mr),
     .				mr_lo_s5(mr), mr_hi_s5(mr),
     .				mr_lo_s6(mr), mr_hi_s6(mr),
     .				memry(mr)%ptr,
     .				cx_lo_s1(cx), cx_lo_s2(cx),
     .				cx_lo_s3(cx), cx_lo_s4(cx),
     .				cx_lo_s5(cx), cx_lo_s6(cx),
     .				max_len, len)

	         CALL CD_WRITE_ATTRIB(cdfid, pcdf_global, varcode,
     .			buff(:len), .FALSE., status )
                 IF ( status .NE. merr_ok ) GOTO 5800

	      ELSE

	         IF (wlen .GT. 100) GOTO 5320
		 IF (wlen .EQ. 0) wlen = 1
		 avals(:wlen-1) = memry(mr)%ptr
		 CALL CD_WRITE_ATTVAL_DP(
     .                    cdfid, pcdf_global, varcode, avals(0), wlen, 
     .                    vartype, status )
	      ENDIF

	   ELSE  ! not as-global,write regular variable

* get slab limits to use for writing the values of this variable

	      DO 450 idim = 1, nferdims
                 write_lo(idim) = cx_lo_ss(cx,idim)
                 write_hi(idim) = cx_hi_ss(cx,idim)
 450          CONTINUE

* write the data for this variable
              user_var = cat .EQ. cat_user_var
	      CALL CD_WRITE_VAR (cdfid, dset_num, varcode, grid, 
     .                        write_lo, write_hi, memry(mr)%ptr, 
     .                        edges_flag, do_bounds, mode_upcase_output, 
     .                        keepax_flag, user_var, ds_missing_flag(ivar), 
     .                        do_coords, status )

	   ENDIF

           IF ( status .NE. merr_ok ) GOTO 5800
 500	CONTINUE

* close the file
        cdfstat = NF_CLOSE(cdfid)
        IF ( cdfstat .NE. NF_NOERR ) CALL TM_ERRMSG
     .     ( cdfstat+pcdferr, status, 'CDF_LIST', unspecified_int4,
     .     no_varid, 'could not close CDF output file: ',
     .     fname, *5990 )


* final completion -- maybe after an error
	status = final_status
	RETURN

* error exit(s)
 5200    CALL ERRMSG ( ferr_syntax, status,
     .                 'illegal output variable name: '//varcode,
     .                 *5210 )

 5210    CALL TM_NOTE(
     .    'Name must use letters and digits beginning with a letter',
     .                 err_lun )
         CALL TM_NOTE( 'X,Y,Z,Y,I,J,K,L,XBOX,... are reserved names',
     .                 err_lun )
         CALL TM_NOTE( 'Use the LET command to define a legal name',
     .                 err_lun )
         GOTO 5800
 5220    CALL ERRMSG ( ferr_syntax, status,
     .                 'error writing variable: '//varcode,
     .                 *5800 )

 5300    CALL ERRMSG ( ferr_invalid_command, status,
     .                 'Exceeds grid limits: '//
     .			cmnd_buff(qual_start(errloc):qual_end(errloc))
     .			//pCR//'Variable: '//varcode, *5800 )

 5310    CALL ERRMSG ( ferr_invalid_command, status,
     .                 'Does not encompass data to be written: '//
     .			cmnd_buff(qual_start(errloc):qual_end(errloc))
     .			//pCR//'Variable: '//varcode, *5800 )

 5320    CALL ERRMSG ( ferr_invalid_command, status,
     .                'Global attribute must be a 1D variable length < 100'
     .			//pCR//'Variable: '//varcode, *5800 )

 5325    CALL ERRMSG ( ferr_invalid_command, status,
     .                'Multi-valued Global string attributes not implemented'
     .			//pCR//'Variable: '//varcode, *5800 )

 5400    CALL ERRMSG ( ferr_TMAP_error, status, ' ', *5990 )

 5500    CALL ERRMSG ( ferr_TMAP_error, status,
     .                 'unable to set variable type for output: '//varcode,
     .                 *5800 )
     
* User-specified string-length is too short (aname used as dummy string here)

 5600	buff = TM_FMT(FLOAT(maxstrlen), 5, 12, slen)
 	aname = TM_FMT(FLOAT(usr_maxstrlen), 5, 12, alen)
	CALL ERRMSG ( ferr_invalid_command, status,
     .          'Strings are length '//buff(:slen)//
     .		': longer than /STRLEN setting of '//aname(:alen) 
     .		//pCR//'Variable: '//varcode, *5800 )

 5800   CALL ERRMSG ( ferr_TMAP_error, final_status, ' ', *5810 )
 5810	nready = ivar - 1
	IF (.NOT.flushed) GOTO 400 ! yea ... a bit of spagetti code ... 
        cdfstat = NF_CLOSE(cdfid)
 5990   RETURN
	END

	SUBROUTINE compute_histo_bins (z, wrk, badz, nsize, status)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*

* For histogram-based levels, compute the histogram bins. Sort the data and 
* compute the color levels so that each color band contains approximately 
* equal numbers of data points. This form of color management best brings out 
* the fine structure in the data. 
* V630  *acm* 9/09 Introduction of syntax for variance-based and histogram levels
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus
* V691 *acm* 5/14  Define symbols containing histogram levels

        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
	include 'hd_inc.decl'
	include 'HD.INC'
	include 'cont_inc.decl'
	include 'CONT.INC'

* nlev	number of levels to use, from cont.inc
* zmin	in hd.inc, min and max of the data
* zmax

* calling argument declarations:
	INTEGER nsize, status
#ifdef double_p
	REAL*8 z(*), wrk(*), badz
#else
	REAL z(*), wrk(*), badz
#endif

* internal variable declarations:

      INTEGER i, ngood

      CHARACTER ppl_buff*2048, TM_FMT_SNGL*48, buff*10
      INTEGER TM_LENSTR1, ier, ilen, slen 
      LOGICAL TM_FPEQ_SNGL

      ngood = 0
      DO i = 1, nsize
         wrk(i) = z(i)
         IF (wrk(i) .NE. badz) ngood = ngood + 1
      ENDDO

      CALL HEAP2_V (wrk, badz, nsize)

* nlev refers to the edges of the color bins; make the
* user's input refer to the number of bins.

      nlev = nlev + 1  
      nlev2 = nlev
      IF (ngood .LT. nlev) nlev2 = ngood

      n_per_bin = ngood/ (nlev2-1)

      ibin = 1
      DO i = 1, ngood, n_per_bin
         zlev(ibin) = wrk(i)
         ibin = ibin + 1
      ENDDO
      zlev(1) = wrk(1)
      zlev(nlev2) = wrk(ngood)

*      ... could smooth these some.

      IAUTOC = 0  ! levels are already set so dont do it in set_levels.

      USE_HIST = .TRUE.

* Define the LEV_HISTO_LEVELS symbol here. It may be wanted in a PLOT/SET command
* before setlab_syms would be executed.

       IF (USE_HIST) THEN  
          ppl_buff = 'LEV_HISTO_LEVELS '
	  ilen = TM_LENSTR1(ppl_buff)+1
          DO 200 i =1, nlev2
	     buff = TM_FMT_SNGL(zlev(i), -2, 10, slen)
             ppl_buff = ppl_buff(:ilen)//buff(:slen)
	     ilen = TM_LENSTR1(ppl_buff)
	     IF (i.LT.nlev2) ppl_buff = ppl_buff(:ilen)//','
	     ilen = TM_LENSTR1(ppl_buff)
  200     CONTINUE
         ier = 0
         ist = 0
         CALL SETSYM (ppl_buff, ilen, ier, ist)
      ENDIF

      RETURN
      END

	SUBROUTINE TM_BAD_EPIC( array, n, bad )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Make sure bad data matches bad flag for EPIC data.
* The data will come in as single-precision float, the bad-flag
* is stored as double precision, so the vales don't match.

* NOAA/PMEL, Seattle, WA - TMAP

* from tm_scale.F  4/2016


* calling argument declarations:
      INTEGER n
      REAL array(n), bad

* internal variable declarations:	
      LOGICAL TM_FPEQ_SNGL
      INTEGER i
      REAL*4 a, b

      b = SNGL(bad)

      DO  i = 1, n
         a = SNGL(array(i))
	 IF ( TM_FPEQ_SNGL(a, b) ) array(i) = bad
      ENDDO

      RETURN
      END

	SUBROUTINE REVERSE_GRID_AXIS ( axis, cx, mr, dat )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* reverse the ordering of the data along the indicated axis

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V320:  2/16/95
* V541:  2/02 *sh* - added support for delta strides
* V560: 10/03 *acm* - fix bug 537, when use/order=x-y and strides, 
*                     need to reset the indices to apply to the data
*                     as it has been read, after the strides applied, 
*                     e.g. reset 4:360:3 to 1:119:1
* 560: *acm* 4/04 - stride/modulo fixes: use NINT to convert REAL*8 to integer
* 2/12 *acm* Add E and F dimensions (use nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'

* calling argument declarations:
	INTEGER axis, cx, mr
	REAL    dat( * )

* local variable declarations
	INTEGER idim, ilo(nferdims), ihi(nferdims), idel(nferdims)

* get the delta values
	DO idim = 1, nferdims
	  ilo (idim) = cx_lo_ss(cx,idim)
	  ihi (idim) = cx_hi_ss(cx,idim)
	  IF (cx_delta(idim,cx) .EQ. unspecified_val8 ) THEN
	    idel(idim) = 1
	  ELSE
	    idel(idim) = NINT(cx_delta(idim,cx))
     
c	    ihi(idim) = 1 + (ihi(idim) - ilo(idim)) / idel(idim)
c	    ilo(idim) = 1
	    ihi(idim) = ilo(idim) + (ihi(idim) - ilo(idim)) / idel(idim)
            idel(idim) = 1

	  ENDIF
	ENDDO

	CALL REVERSE_GRID_AXIS_SUB( axis, dat,
     .				    ilo(axis), ihi(axis), idel(axis),
     .			            ilo(1), ihi(1),
     .			            ilo(2), ihi(2),
     .			            ilo(3), ihi(3),
     .			            ilo(4), ihi(4),
     .			            ilo(5), ihi(5),
     .			            ilo(6), ihi(6) )

	RETURN
	END 

*
*  scat2grid_bin_xyt
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE.
*
* Ansley Manke
* April 2010
* Ferret V665 10/2010 Change loop structure to make this more efficient.

* In this subroutine we provide information about
* the function.  The user configurable information
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
*
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result
*


      SUBROUTINE  scat2grid_bin_xyt_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .        'Put scattered data into XYT grid by binning')
      CALL ef_set_num_args(id, 7)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                NORMAL,          IMPLIED_BY_ARGS,
     .                                NORMAL,          NORMAL)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 7)

* Output grid is determined by arguments 5, 6, and 7, the result's x, y, and t axes.

      arg = 1
      CALL ef_set_arg_name(id, arg, 'XPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'X coordinates of scattered XYT locations')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'YPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'Y coordinates of scattered XYT locations')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'TPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'T coordinates of scattered XYT locations')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'F')
      CALL ef_set_arg_desc(id, arg,
     .        'variable at scattered XYT locations')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'XAXPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'X axis coordinates of the output grid')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, NO, NO, NO, NO, NO)

      arg = 6
      CALL ef_set_arg_name(id, arg, 'YAXPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'Y axis coordinates of the output grid')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, YES, NO, NO, NO, NO)

      arg = 7
      CALL ef_set_arg_name(id, arg, 'TAXPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'T axis coordinates of the output grid, ' //
     .        'with same units and origin as TPTS')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, YES, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE scat2grid_bin_xyt_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER nxout, nyout, ntout, nx2, ny2, nt2

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nxout = 1 + arg_hi_ss(X_AXIS,ARG5) - arg_lo_ss(X_AXIS,ARG5)
      nyout = 1 + arg_hi_ss(Y_AXIS,ARG6) - arg_lo_ss(Y_AXIS,ARG6)
      ntout = 1 + arg_hi_ss(T_AXIS,ARG7) - arg_lo_ss(T_AXIS,ARG7)

      nx2 = nxout * 2
      ny2 = nyout * 2
      nt2 = ntout * 2

* xaxlo  output x axis
      CALL ef_set_work_array_dims_6d(id, 1,
     .                                1, 1, 1, 1, 1, 1,
     .                              nx2, 1, 1, 1, 1, 1)

* xaxhi  output x axis
      CALL ef_set_work_array_dims_6d(id, 2,
     .                                1, 1, 1, 1, 1, 1,
     .                              nx2, 1, 1, 1, 1, 1)

* yaxlo  output y axis
      CALL ef_set_work_array_dims_6d(id, 3,
     .                                1, 1, 1, 1, 1, 1,
     .                              ny2, 1, 1, 1, 1, 1)

* yaxhi  output y axis
      CALL ef_set_work_array_dims_6d(id, 4,
     .                                1, 1, 1, 1, 1, 1,
     .                              ny2, 1, 1, 1, 1, 1)

* taxlo  output t axis
      CALL ef_set_work_array_dims_6d(id, 5,
     .                                1, 1, 1, 1, 1, 1,
     .                              nt2, 1, 1, 1, 1, 1)

* taxhi  output t axis
      CALL ef_set_work_array_dims_6d(id, 6,
     .                                1, 1, 1, 1, 1, 1,
     .                              nt2, 1, 1, 1, 1, 1)

* counts
      CALL ef_set_work_array_dims_6d(id, 7,
     .                                1,     1,     1, 1, 1, 1,
     .                            nxout, nyout, ntout, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*

      SUBROUTINE scat2grid_bin_xyt_compute(id, arg_1, arg_2, arg_3,
     .                           arg_4, arg_5, arg_6, arg_7, result,
     .                           xaxlo, xaxhi, yaxlo, yaxhi,
     .                           taxlo, taxhi, counts)

*  arg_1  xpts  \
*  arg_2  ypts  / Scattered x,y,t triples to be gridded.
*  arg_3  tpts /
*  arg_4  variable, /
*  arg_5  xaxis of new grid
*  arg_6  yaxis of new grid
*  arg_7  taxis of new grid

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz,
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz,
     .           mem4lot:mem4hit, mem4loe:mem4hie, mem4lof:mem4hif)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz,
     .           mem5lot:mem5hit, mem5loe:mem5hie, mem5lof:mem5hif)
      REAL arg_6(mem6lox:mem6hix, mem6loy:mem6hiy, mem6loz:mem6hiz,
     .           mem6lot:mem6hit, mem6loe:mem6hie, mem6lof:mem6hif)
      REAL arg_7(mem7lox:mem7hix, mem7loy:mem7hiy, mem7loz:mem7hiz,
     .           mem7lot:mem7hit, mem7loe:mem7hie, mem7lof:mem7hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* Ignore the unused final dimensions in the work arrays since
* Fortran is column major
      REAL*8 xaxlo(wrk1lox:wrk1hix/2)
      REAL*8 xaxhi(wrk2lox:wrk2hix/2)
      REAL*8 yaxlo(wrk3lox:wrk3hix/2)
      REAL*8 yaxhi(wrk4lox:wrk4hix/2)
      REAL*8 taxlo(wrk5lox:wrk5hix/2)
      REAL*8 taxhi(wrk6lox:wrk6hix/2)
      REAL counts(wrk7lox:wrk7hix, wrk7loy:wrk7hiy, wrk7loz:wrk7hiz)

* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable''s axes.

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, l1
      INTEGER lo_ss, hi_ss
      INTEGER nxpts, nypts, ntpts, nscat
      INTEGER idx, nx, ny, nt
      REAL xx, yy, tt, ff
      CHARACTER*250 errtxt

*  variables for checking axis characteristics (modulo axes)
      CHARACTER ax_name(6)*16, ax_units(6)*16
      LOGICAL backward(6), mdulo(6), regular(6)
      LOGICAL modulox, moduloy, modulot
      REAL*8 modxlen, modylen, modtlen

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*  Check to see if the output X-axis is modulo (does not need to be regular)
      CALL ef_get_axis_info_6d(id, ARG5, ax_name, ax_units,
     .                         backward, mdulo, regular)
      modulox = mdulo(X_AXIS)
      IF ( modulox ) THEN
         CALL ef_get_axis_modulo_len(id, ARG5, X_AXIS, modxlen)
      ENDIF

*  Check to see if the output Y-axis is modulo (does not need to be regular)
      CALL ef_get_axis_info_6d(id, ARG6, ax_name, ax_units,
     .                         backward, mdulo, regular)
      moduloy = mdulo(Y_AXIS)
      IF ( moduloy ) THEN
         CALL ef_get_axis_modulo_len(id, ARG6, Y_AXIS, modylen)
      ENDIF

*  Check to see if the output T-axis is modulo (does not need to be regular)
      CALL ef_get_axis_info_6d(id, ARG7, ax_name, ax_units,
     .                         backward, mdulo, regular)
      modulot = mdulo(T_AXIS)
      IF ( modulot ) THEN
         CALL ef_get_axis_modulo_len(id, ARG7, T_AXIS, modtlen)
      ENDIF

*  Find number of points in scattered input points.  1-D arrays defining the
*  scattered data points may lie on the X, Y, Z, T, E, or F axis of the input
*  arguments.
*  Using as flattened arrays, so consider all axes.

      nxpts = 0
      DO 10 idx = X_AXIS, F_AXIS
         lo_ss = arg_lo_ss(idx,ARG1)
         hi_ss = arg_hi_ss(idx,ARG1)
         IF ( lo_ss .NE. ef_unspecified_int4 ) THEN
            IF ( nxpts .NE. 0 ) THEN
               nxpts = nxpts * (hi_ss - lo_ss + 1)
            ELSE
               nxpts = hi_ss - lo_ss + 1
            ENDIF
         ENDIF
  10  CONTINUE

      nypts = 0
      DO 20 idx = X_AXIS, F_AXIS
         lo_ss = arg_lo_ss(idx,ARG2)
         hi_ss = arg_hi_ss(idx,ARG2)
         IF ( lo_ss .NE. ef_unspecified_int4 ) THEN
            IF ( nypts .NE. 0 ) THEN
               nypts = nypts * (hi_ss - lo_ss + 1)
            ELSE
               nypts = hi_ss - lo_ss + 1
            ENDIF
         ENDIF
  20  CONTINUE

      ntpts = 0
      DO 40 idx = X_AXIS, F_AXIS
         lo_ss = arg_lo_ss(idx,ARG3)
         hi_ss = arg_hi_ss(idx,ARG3)
         IF ( lo_ss .NE. ef_unspecified_int4 ) THEN
            IF ( ntpts .NE. 0 ) THEN
               ntpts = ntpts * (hi_ss - lo_ss + 1)
            ELSE
               ntpts = hi_ss - lo_ss + 1
            ENDIF
         ENDIF
  40  CONTINUE

      nscat = 0
      DO 80 idx = X_AXIS, F_AXIS
         lo_ss = arg_lo_ss(idx,ARG4)
         hi_ss = arg_hi_ss(idx,ARG4)
         IF ( lo_ss .NE. ef_unspecified_int4 ) THEN
            IF ( nscat .NE. 0 ) THEN
               nscat = nscat * (hi_ss - lo_ss + 1)
            ELSE
               nscat = hi_ss - lo_ss + 1
            ENDIF
         ENDIF
  80  CONTINUE

      IF ( nxpts .NE. nypts ) THEN
         WRITE (errtxt, 90) ' XPTS,', ' YPTS ', nxpts, nypts
         GOTO 999
      ENDIF
      IF ( nxpts .NE. ntpts ) THEN
         WRITE (errtxt, 90) ' XPTS,', ' TPTS ', nxpts, nypts
         GOTO 999
      ENDIF
      IF ( nxpts .NE. nscat ) THEN
         WRITE (errtxt, 90) ' XPTS,', ' F()  ', nxpts, nscat
         GOTO 999
      ENDIF
  90  FORMAT('Input scattered', 2A6, 'have different # of points', 2I8)

      IF ( nscat .LE. 0 ) THEN
         errtxt = 'No data in scattered x, y, t points'
         GOTO 999
      ENDIF

*  Compute number of points in output axes.

      lo_ss = arg_lo_ss(X_AXIS,ARG5)
      hi_ss = arg_hi_ss(X_AXIS,ARG5)
*  Check that xax is an X axis
      IF ( lo_ss .EQ. ef_unspecified_int4 ) THEN
         errtxt = 'Fifth argument must be an X axis'
         GOTO 999
      ENDIF
      nx = hi_ss - lo_ss + 1

      lo_ss = arg_lo_ss(Y_AXIS,ARG6)
      hi_ss = arg_hi_ss(Y_AXIS,ARG6)
*  Check that yax a Y axis
      IF ( lo_ss .EQ. ef_unspecified_int4 ) THEN
         errtxt = 'Sixth argument must be a Y axis'
         GOTO 999
      ENDIF
      ny = hi_ss - lo_ss + 1

      lo_ss = arg_lo_ss(T_AXIS,ARG7)
      hi_ss = arg_hi_ss(T_AXIS,ARG7)
*  Check that tax a T axis
      IF ( lo_ss .EQ. ef_unspecified_int4 ) THEN
         errtxt = 'Seventh argument must be a T axis'
         GOTO 999
      ENDIF
      nt = hi_ss - lo_ss + 1

C  Get coordinates of output axes.

      CALL EF_GET_BOX_LIMITS(id, ARG5, X_AXIS, arg_lo_ss(X_AXIS, ARG5),
     .                       arg_hi_ss(X_AXIS, ARG5), xaxlo, xaxhi)

      CALL EF_GET_BOX_LIMITS(id, ARG6, Y_AXIS, arg_lo_ss(Y_AXIS, ARG6),
     .                       arg_hi_ss(Y_AXIS, ARG6), yaxlo, yaxhi)

      CALL EF_GET_BOX_LIMITS(id, ARG7, T_AXIS, arg_lo_ss(T_AXIS, ARG7),
     .                       arg_hi_ss(T_AXIS, ARG7), taxlo, taxhi)

*  Compute result

      k = res_lo_ss(Z_AXIS)
      m = res_lo_ss(E_AXIS)
      n = res_lo_ss(F_AXIS)

*  Initialize result.

      DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
               result(i,j,k,l,m,n) = 0.0
            ENDDO
         ENDDO
      ENDDO

*  Initialize counts.

      DO l1 = 1, nt
         DO j1 = 1, ny
            DO i1 = 1, nx
               counts(i1,j1,l1) = 0.0
            ENDDO
         ENDDO
      ENDDO

*  Loop over x,y,t, placing the function values in the appropriate slots
*  in the grid. xpts and ypts may be on the X,Y,Z,T,E or F axis of ARG1
*  and ARG2, sending them to a subroutine collapses the extra dimensions
*  so the value can be found.

      DO 700 idx = 1, nscat

         CALL pickout4(arg_1, arg_2, arg_3, arg_4, idx, xx, yy, tt, ff)
         IF ( xx .EQ. bad_flag(ARG1) .OR.
     .        yy .EQ. bad_flag(ARG2) .OR.
     .        tt .EQ. bad_flag(ARG3) .OR. 
     .        ff .EQ. bad_flag(ARG4) ) GOTO 700

*  If output axis is modulo, apply modulo adjustment to that coordinate
*  of the scattered point.
         IF ( modulox ) THEN
            CALL modscat(xaxlo(1), xaxhi(nx), modxlen, 1, xx)
         ENDIF
         IF ( moduloy ) THEN
            CALL modscat(yaxlo(1), yaxhi(ny), modylen, 1, yy)
         ENDIF
         IF ( modulot ) THEN
            CALL modscat(taxlo(1), taxhi(nt), modtlen, 1, tt)
         ENDIF

*  Put fcn into result variable.

         l1 = 1
         DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
            IF ( tt .GE. taxlo(l1) .AND. tt .LT. taxhi(l1) ) THEN

         j1 = 1
         DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            IF ( yy .GE. yaxlo(j1) .AND. yy .LT. yaxhi(j1) ) THEN

         i1 = 1
         DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
            IF ( xx .GE. xaxlo(i1) .AND. xx .LT. xaxhi(i1) ) THEN

               result(i,j,k,l,m,n) = result(i,j,k,l,m,n) + ff
               counts(i1,j1,l1) = counts(i1,j1,l1) + 1.0
*              Location found and point assigned; go to the next scatter point
               GOTO 700

            ENDIF
            i1 = i1 + 1
 100     CONTINUE

            ENDIF
            j1 = j1 + 1
 200     CONTINUE

            ENDIF
            l1 = l1 + 1
 400     CONTINUE

 700  CONTINUE

* Compute result, average in each bin.

      l1 = 1
      DO 410 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

      j1 = 1
      DO 210 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

      i1 = 1
      DO 110 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         IF ( counts(i1,j1,l1) .GT. 0.0 ) THEN
            result(i,j,k,l,m,n) = result(i,j,k,l,m,n) / counts(i1,j1,l1)
         ELSE
            result(i,j,k,l,m,n) = bad_flag_result
         ENDIF

         i1 = i1 + 1
 110  CONTINUE

         j1 = j1 + 1
 210  CONTINUE

         l1 = l1 + 1
 410  CONTINUE

      RETURN

 999  CALL EF_BAIL_OUT(id, errtxt)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN
      END

	LOGICAL FUNCTION TM_LEGAL_UNIX_NAME( name )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* determine whether a particular string is a "legal" Unix path name
*
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* 1/93 - based on tm_legal_name
*
* 2jun94 *kob* - first statement function too long  - caught by ibm compiler
#include "gt_lib.parm"

* calling argument declarations:
	CHARACTER*(*) name

* internal variable declarations:
	INTEGER	TM_LENSTR1, slen, i
	LOGICAL	LETTER, DIGIT, PUNCT
	CHARACTER c*1

* statement functions
	LETTER( c ) = (c.GE.'A' .AND. c.LE.'Z') .OR. 
     .                    (c.GE.'a' .AND. c.LE.'z')
	DIGIT ( c ) = c.GE.'0' .AND. c.LE.'9'
	PUNCT ( c ) = c.EQ.'.' .OR. c.EQ.'_' .OR.  
     .            c.EQ.PathSeparator

* string length
	slen = TM_LENSTR1( name )

* blank name is not allowed
	IF ( name .EQ. ' ' ) GOTO 5000

* all characters must be letters, digits or punctuation
	DO 100 i = 2, slen
	   c = name(i:i)
	   IF ( .NOT.(LETTER(c) .OR. DIGIT(c) .OR. PUNCT(c)) ) GOTO 5000
 100	CONTINUE

* it's ok
	TM_LEGAL_UNIX_NAME = .TRUE.
	RETURN

* it's bad
 5000	TM_LEGAL_UNIX_NAME = .FALSE.
	RETURN

	END

	SUBROUTINE CD_DSG_GET_FEATURETYPE (cdfid, ftype, orientation, dsg_ragged, do_warn)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Find the featureType attribute and return the feature-type information
* for the dataset
* V751 8/18 *acm* don't issue a note if the file has featureType="grid"
* v76  2/20 *acm* add handling of Point feature-type
* V7.6 *acm* 6/20 Issue 1980: When possible open invalid DSG datasets anyway with NOTES.


        include 'netcdf.inc'
        include 'tmap_errors.parm'
c	include 'tmap_dims.parm'
#include "gt_lib.parm"
#include "tmap_dset.parm"
	include 'xio.cmn_text'


	INTEGER cdfid, ftype, orientation
	LOGICAL	dsg_ragged, do_warn

	LOGICAL got_it, CD_GET_ATTRIB
	INTEGER STR_CASE_BLIND_COMPARE, varid, attlen, maxlen
	CHARACTER buff*32

	ftype = pfeatureType_Point
	orientation = no_dim
	dsg_ragged = .FALSE.
	maxlen = 32

	varid = NF_GLOBAL
	got_it = CD_GET_ATTRIB ( cdfid, varid, 'featureType', do_warn, '.',
     .                           buff, attlen, maxlen )
	IF (.NOT. got_it) RETURN

	IF (STR_CASE_BLIND_COMPARE(buff,"timeseries") .EQ. str_match) THEN
	   ftype = pfeatureType_TimeSeries
	   orientation = t_dim		! T axis
	   dsg_ragged = .TRUE.

	ELSEIF (STR_CASE_BLIND_COMPARE(buff,"profile") .EQ. str_match) THEN
	   ftype = pfeatureType_Profile
	   orientation = z_dim		! Z axis
	   dsg_ragged = .TRUE.

	ELSEIF (STR_CASE_BLIND_COMPARE(buff,"trajectory") .EQ. str_match) THEN
	   ftype = pfeatureType_Trajectory
	   orientation = x_dim		! X axis (arbitrarily)
	   dsg_ragged = .TRUE.


	ELSEIF (STR_CASE_BLIND_COMPARE(buff,"point") .EQ. str_match) THEN
	   ftype = pfeatureType_Point
	   orientation = x_dim		! X axis (arbitrarily)
	   dsg_ragged = .TRUE.

	ELSEIF ( (STR_CASE_BLIND_COMPARE(buff,"timeseriesprofile") .EQ. str_match)
     .     .OR.  (STR_CASE_BLIND_COMPARE(buff,"trajectoryprofile") .EQ. str_match) )THEN
	   dsg_ragged = .FALSE.
	   IF (do_warn) CALL TM_NOTE("FEATURE-TYPE NOT YET IMPLEMENTED: "//buff , lunit_errors)

	ELSE
	   dsg_ragged = .FALSE.
	   IF (STR_CASE_BLIND_COMPARE(buff,"grid") .NE. str_match .AND. do_warn)
     .     CALL TM_NOTE("Ignoring non-DSG FeatureType: "//buff , lunit_errors)

	ENDIF

	RETURN
	END

	SUBROUTINE CHECK_MEMORY ( lun )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* diagnostic report on memory usage and integrity check

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 7/20/88
* revision 0.1 - 8/15/88 - max_mrs --> max_mr_avail
* V200:  6/9/89 - deleted variables flagged in mr_protected
*		- deletable variables in mr_del_*
*		- slight reformatting of output
*	 5/3/90 - include temporary vars in del_link chain check
* V313:8/18/94 *kob* IBM Port - format statement 3310 was missing a comma
* V320:8/11/94 - allow bigger output field for (resizable) mem_blk_size
*     12/29/94 - use SPLIT_LIST to redirect tty output for GUI
*		==>  extensive changes!!
* 12/96 *kob* - Linux Port - had to move variable assignments off of
*               declaration line.
* V510: 10/99 *sh* - make checks on 
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
* V702 *sh* Added dynamic memory checks.  Removed old block-oriented stuff

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'ferret.parm'
	include 'xvariables.cmn'

* calling argument declarations:
	INTEGER	lun

* internal variable declarations:
	INTEGER	mv, mvfree, mvused, 
     .		nmvlost, pile, last, size, test_next,
     .		navail, nperm, ntemp, ndel, slen, nn, mrsizelen
        INTEGER*8 mem_in_use
	CHARACTER LEFINT*8, buff*40, b04*4, mrsizebuf*16, byte_unit*2
	PARAMETER (b04 = '    ')


* check Ferret variable memory allocations
        mem_in_use = 0
        DO mv = 1, max_mrs
           mem_in_use = mem_in_use + mr_size(mv)
        ENDDO
* ... no valid ws_size() work memory in use when this routine is called
        IF (mem_in_use .NE. total_mem) THEN
	      CALL WARN('***** corrupted total mem size: '
     .                  //LEFINT(mem_in_use,slen) )
        ENDIF
	CALL SPLIT_LIST( pttmode_explct, lun, 
     .			 b04//'Total table slots: '//
     .			 LEFINT(max_mr_avail,slen), 0 )


* check slots in memory variable table
* ... free table slots
	mvfree = 0
	mv     = mv_flink( 0 )	! base pointer for free slots
 200	IF ( mv .NE. 0 ) THEN

* * * * integrity check * * * * * * * * * * * * * * * * * * * *
	   IF ( mr_protected(mv) .NE. mr_deleted ) CALL WARN
     .			('CORRUPTION! improperly deleted: '
     .						//LEFINT(mv,slen) )
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	   mvfree = mvfree + 1
	   mv = mv_flink( mv )
	   GOTO 200
	ENDIF
	CALL SPLIT_LIST( pttmode_explct, lun,
     .			 b04//'Free table slots: '//
     .			 LEFINT(mvfree,slen), 0 )

* * * * integrity check * * * * * * * * * * * * * * * * * * * *
* check all the variables in all the hash piles
	mvused = 0
	DO 310 pile = 1, pmv_npiles
	   last = -pile
	   mv = mv_flink( last )	! base pointer for slots in this hash #
 300	   IF ( mv .GT. 0 ) THEN
	      IF ( mr_protected(mv) .EQ. mr_deleted
     .	      .OR. mr_protected(mv) .EQ. mr_in_progress
     .	      .OR. mv_blink(mv) .NE. last ) 	CALL WARN
     .			('CORRUPTION! improperly cataloged: '
     .						//LEFINT(mv,slen) )
	      mvused = mvused + 1
	      last   = mv
	      mv     = mv_flink(mv)
	      GOTO 300
	   ENDIF
 310	CONTINUE


* * * * integrity check * * * * * * * * * * * * * * * * * * * *
* check non-cached variables (10/99)
	nn = 0
	last = pmv_nocache_pile
	mv = mv_flink( last )	! base pointer for slots in this hash #
 350	IF ( mv .GT. 0 ) THEN
	   IF ( mr_protected(mv) .EQ. mr_deleted
     .	   .OR. mr_protected(mv) .EQ. mr_in_progress
     .	   .OR. mv_blink(mv) .NE. last ) 	CALL WARN
     .			('CORRUPTION! uncached variable error: '
     .						//LEFINT(mv,slen) )
	   nn = nn + 1
	   mvused = mvused + 1
	   last   = mv
	   mv     = mv_flink(mv)
	   GOTO 350
	ENDIF
	CALL SPLIT_LIST( pttmode_explct, lun,
     .			 b04//'Un-cached variables: '//
     .			 LEFINT(nn,slen), 0 )

* * * * integrity check * * * * * * * * * * * * * * * * * * * *
* check working storage (10/99)
	nn = 0
	last = pmv_work_var_pile
	mv = mv_flink( last )	! base pointer for slots in this hash #
 360	IF ( mv .GT. 0 ) THEN
	   nn = nn + 1
	   mvused = mvused + 1
	   last   = mv
	   mv     = mv_flink(mv)
	   GOTO 360
	ENDIF
	IF ( nn .GT. 0 ) CALL WARN
     .			('CORRUPTION! unfreed work arrays: '
     .						//LEFINT(nn,slen) )


* * * * integrity check * * * * * * * * * * * * * * * * * * * *
* make sure no table slots or memory blocks have been lost
	nmvlost = max_mr_avail - ( mvfree+mvused )
	IF ( nmvlost .NE. 0 ) CALL WARN
     .			('CORRUPTION! lost table slots: '
     .						//LEFINT(nmvlost,slen) )

* * * * integrity check * * * * * * * * * * * * * * * * * * * * *
* variable deletion priority chain
	navail = 0
	mv = mr_del_flink(0)
 400	IF ( mv .NE. 0 ) THEN
	   navail = navail + 1
	   IF ( mr_protected(mv) .NE. mr_not_protected ) CALL WARN
     .			('CORRUPTION! Protected variables deleted')
	   mv = mr_del_flink(mv)
	   GOTO 400
	ENDIF
	ndel   = 0
	nperm  = 0
	ntemp  = 0
        mem_in_use = 0
	DO 410 mv = 1, max_mr_avail
	   IF ( mr_protected(mv) .EQ. mr_perm_protected ) THEN
	      nperm  = nperm  + 1
              mem_in_use = mem_in_use + mr_size(mv)
	   ELSEIF ( mr_protected(mv) .EQ. mr_deleted ) THEN
	      ndel = ndel + 1
	   ELSEIF ( mr_protected(mv) .EQ. mr_temporary ) THEN
	      ntemp = ntemp + 1
	   ENDIF
 410	CONTINUE
	IF ( nperm .GT. 0 ) THEN
	   CALL SPLIT_LIST( pttmode_explct, lun,
     .			 b04//'number of /PERMANENT variables: '//
     .			 LEFINT(nperm,slen), 0 )
	   	   
	   CALL MEM_TO_BYTES (mem_in_use, mrsizebuf, slen, byte_unit)

	   CALL SPLIT_LIST( pttmode_explct, lun,
     .			 b04//'memory used for /PERM: '//
     .			 mrsizebuf(:slen)//byte_unit, 0 )
	ENDIF
	nmvlost = max_mr_avail - (navail+nperm+ndel+ntemp)
	IF ( nmvlost .NE. 0 ) CALL WARN
     .		( 'CORRUPTION! Protected vars unaccountable: '
     .				//LEFINT(nmvlost,slen) )
	nn = ndel - mvfree
	IF ( nn .NE. 0 ) CALL WARN
     .		( 'CORRUPTION! Deleted vars unaccountable: '
     .				//LEFINT(nmvlost,slen) )

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	RETURN
	END

	SUBROUTINE PARSE_NUMBER_LIST( string, array, nmax, n, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* return an array of floating point values from a list of the form
* "{ 1, 3,5,7, 9}"

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V500: *sh* 12/98
*	   2/99 - bug fix - 2 commas together
*       *acm* 3/12 cleanup ifdefs and unnecessary include files. Add disclaimer.
* V69+  *acm* 5/14 ticket 2174: check that the expression is just a constant
*                  before reading from the buffer into the array.

        IMPLICIT NONE
* calling argument declarations
	INTEGER		nmax, n, status
	REAL		array(nmax)
	CHARACTER*(*)	string

* internal variable declarations
	LOGICAL		TM_NUMBER
	INTEGER 	TM_LENSTR1, comma_pos, last_comma_pos, slen
	CHARACTER	buff*64

	include 'ferret.parm'
	include 'errmsg.parm'

* initialize
	n = 0
	slen	  = LEN( string )
	last_comma_pos = 0

* trim around the enclosing "{}" brackets
	IF ( string(slen:slen) .EQ. '}' ) slen = slen - 1
	IF ( string (1:1) .EQ. '{' ) last_comma_pos = 1
	IF (last_comma_pos .GE. slen) GOTO 2000

* loop through the comma list decoding and returning values
 100	CONTINUE
	IF (last_comma_pos .GE. slen) THEN
	   comma_pos = 0	! last item
	ELSE
	   comma_pos = INDEX( string(last_comma_pos+1:slen), ',' )
	ENDIF
	n = n + 1
	If ( n .GT. nmax ) GOTO 5100   ! should never happen
	IF ( comma_pos .EQ. 0 ) THEN
*  ... last item in list
	   IF (last_comma_pos .GE. slen) THEN
	       array(n) = bad_val4			! comma as last item
	   ELSE
	      buff = string(last_comma_pos+1:slen)
	      IF ( buff .EQ. ' ' ) THEN
	         array(n) = bad_val4
	      ELSE
	         IF (TM_NUMBER (buff)) THEN
	            READ ( buff, *, ERR=5000 ) array(n)
	         ELSE
		    GOTO 5200
	         ENDIF
	      ENDIF
	   ENDIF
	   GOTO 1000
	ELSEIF ( comma_pos .EQ. 1 ) THEN
	   array(n) = bad_val4				! 2 commas together
	ELSE
* ... read another value
	   buff = string(last_comma_pos+1:last_comma_pos+comma_pos-1)
	   IF ( buff .EQ. ' ' ) THEN
	      array(n) = bad_val4
	   ELSE
	      IF (TM_NUMBER (buff)) THEN
	         READ ( buff, *, ERR=5000 ) array(n)
	      ELSE
	         GOTO 5200
	      ENDIF
	   ENDIF
	ENDIF
	last_comma_pos = last_comma_pos + comma_pos
	GOTO 100

* success
 1000	status = ferr_ok
	RETURN

* null brackets
 2000	n = 1
	array(1) = bad_val4
	GOTO 1000

* syntax error
 4999	RETURN
 5000	CALL ERRMSG( ferr_syntax, status, string(last_comma_pos+1:),
     .							*4999 )
 5100	CALL ERRMSG( ferr_internal, status, string, *4999 )
 5200   CALL ERRMSG( ferr_syntax, status, 
     .          'must be a constant '//
     .		buff(:TM_LENSTR1(buff)), *4999 )

	END

	INTEGER FUNCTION CGRID_UVAR_SIZE ( cx )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine the number of values in the given cx, recognizing that if it is
* a uvar, then in its pyramid of definitions there may be compressing
* transformations.

* For example in LET Vave = V[x=@ave]
* even though the X limits of the context may X=1:1000, the X size of Vave
* is only 1

* V702: *sh* 3/17

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'

	INTEGER	CGRID_SIZE, CX_DIM_LEN, cx, uvar, idim, isize, dimsize


	IF ( cx_category(cx) .EQ. cat_user_var ) THEN
	   uvar = cx_variable(cx)
	   isize = 1
	   DO idim = 1, nferdims
	      IF (uvar_given(idim, uvar) .EQ. uvlim_need_xact) THEN
	         dimsize = 1
	      ELSE
	         dimsize = CX_DIM_LEN( idim, cx )
	      ENDIF
	      isize = isize * dimsize
	   ENDDO
	   CGRID_UVAR_SIZE = isize
	ELSE
	   CGRID_UVAR_SIZE = CGRID_SIZE(cx)
	ENDIF

	RETURN
	END

	SUBROUTINE GET_MR_DYNMEM( i8_rqst_size, mr, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* allocate the requested amount of dynamic emory (using c or python malloc)
* malloc is done in c (or python), but has to call back into F90 to set pointer
* the hierarchy of calls is as follows
*   get_mr_dynmem.F ==> get_mr_mem.c ==> store_mr_ptr.F

* programmer - steve hankin
* V702 *sh*  1/17 trac enhancement ticket #2369 - dynamic memory
* v74   *acm* 3/18 Introduce parameter abstractax_len replacing 99999999
* v76  *acm* 11/19  Issue 1959: Change SET MEMORY/SIZE= to SET MEMORY/MAX= in messages

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'errmsg.parm'
	include	'ferret.parm'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'

* calling argument declarations:
	INTEGER	mr, status
	INTEGER*8 i8_rqst_size

* internal variable declarations:
	INTEGER	num_slen, mr_del
	INTEGER*8 available_mem
	CHARACTER  LEFINT8*20, TM_FMT*48, num_str*20, mem_unit*2

* Check for unspecified limits on abstract axis
	IF ( i8_rqst_size .EQ. abstractax_len ) GOTO 5100

* if we know there isn't room to accommodate this new object then
* we can error out without compromising the current contents of the cache
	available_mem = max_mem_allowed-(permanent_mem+essential_mem)
	IF ( i8_rqst_size .GT. available_mem) GOTO 5200

* will this new allocation push us over the specified memory size limit?
	IF (total_mem+i8_rqst_size .GT. max_mem_allowed) THEN
* ... delete from tail of deletion priority chain until there's room
 100	  mr_del = mr_del_blink(0)
	    IF ( mr_del .EQ. 0 ) THEN
* ... unable to clear out enough memory for this request
* ... should never get here because of pre-check above
	      CALL WARN("crptn??: get_mr_dynmem")
	      GOTO 5200   ! abort
	    ENDIF
	    CALL DELETE_VARIABLE( mr_del )   ! reduces total_mem
	  IF  (total_mem+i8_rqst_size .GT. max_mem_allowed) GOTO 100 !delete more 
	ENDIF

* allocate the dynamic memory
 200	CALL GET_MR_MEM(mr, i8_rqst_size, status)
        IF (status .NE. ferr_ok) GOTO 5300

* bookkeeping
        mr_size(mr) = i8_rqst_size
        total_mem = total_mem + i8_rqst_size
	IF (total_mem .GT. peak_mem) peak_mem = total_mem
	RETURN


***********************
* error exits
 5000	RETURN
 5100	num_str = LEFINT8(i8_rqst_size,num_slen)
	CALL ERRMSG( ferr_dim_underspec, status,
     .    num_str(:num_slen)//' words were requested. ', *5110)
 5110	CALL SPLIT_LIST(pttmode_explct, show_lun,
     .		'    Check for unspecified limits on an ABSTRACT axis',0 )
	CALL SPLIT_LIST(pttmode_explct, show_lun,
     .		'    Use the SHOW GRID command to see the axes',0 )
	GOTO 5000

 5200	CALL ERRMSG( ferr_insuff_memory,status,' ', *5210)
 5210	CALL MEM_TO_BYTES (max_mem_allowed, num_str, num_slen, mem_unit)
	CALL SPLIT_LIST(pttmode_explct, show_lun,
     .		'    To fulfill this request would exceed the current '//
     .		  'SET MEMORY/MAX= limit of '//num_str(:num_slen)
     .	          //mem_unit,0 )
	CALL SHOW_ABORTED_MEM_STATE(i8_rqst_size)
        GOTO 5000

 5300	CALL ERRMSG( ferr_insuff_memory,status,' ', *5310)
 5310	CALL SPLIT_LIST(pttmode_explct, show_lun,
     .		'    The OS refuses to supply this much memory',0 )
	CALL SHOW_ABORTED_MEM_STATE(i8_rqst_size)
        GOTO 5000

	END

	LOGICAL FUNCTION BAD_XY_COORD (i,j,xs,py,ndx)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Screens 2D plot points where the coordinates of the grid cell are
*	invalid

*	*sh* 4/97 - extracted from "get_ndx" which previously checked both
*	for bad data values and for bad coordinates. With curvilinear coord
*	translations included in the logic these two functions needed to be
*	separated

#ifdef unix
	include		'parampl5_dat.decl'
	include		'PARAMPL5.DAT'
	include		'miss_inc.decl'
	include		'MISS.INC'
        include         'hd_inc.decl'
        include         'HD.INC'
	include		'cont_inc.decl'
	include		'CONT.INC'
	include		'shade_vars.cmn'

#else
	INCLUDE		'tmap_pplv11inc:tmap_parampl5.dat'
	INCLUDE		'tmap_pplv11inc:tmap_miss.inc'
        INCLUDE         'tmap_pplv11inc:tmap_hd.inc'
	INCLUDE		'tmap_pplv11inc:tmap_cont.inc'
	INCLUDE		'tmap_pplv11inc:tmap_shade_vars.inc'
#endif

	integer		i,j,ndx

	real		xs(nx+1),py(4)
	real            get_ndx

********************************************************************************

*	      CHECK AGAINST 'LIMITS' VALUES AND FIND COLOR INDEX
	      if((xle.and.xs(i).le.cmxle) 	.or.
     .		 (xeq.and.xs(i).eq.cmxeq) 	.or.
     .		 (xge.and.xs(i+1).ge.cmxge) 	.or.
     .		 (yle.and.py(1).le.cmyle) 	.or.
     .		 (yeq.and.py(1).eq.cmyeq) 	.or.
     .		 (yge.and.py(2).ge.cmyge) ) THEN

	         get_ndx = bad_val
	         BAD_XY_COORD = .TRUE.

	      ELSE

		 BAD_XY_COORD = .FALSE.

	      end if

	      return
	end

	LOGICAL FUNCTION ITSA_REGRID_FROM_DSG ( cx )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine if this context represents a regrid operation *from* a DSG variable

* V720 *sh* 5/17
* V76  1/20 *acm* working with Point-type dsg data

      include 'tmap_dims.parm'
      include 'implicit.parm'
      include 'ferret.parm'
      include 'xcontext.cmn'
      include 'xtm_grid.cmn_text'
      include 'xdset_info.cmn_text'
      include 'xfr_grid.cmn'

* argument declarations
	INTEGER cx

* internal variable declarations
	INTEGER grid, dset, line, orient

* initialize
	grid = cx_grid(cx)

* is it a regrid at all?
	IF (.NOT.cx_unstand_grid(cx)) THEN
	   ITSA_REGRID_FROM_DSG = .FALSE.
	   RETURN
	ENDIF

* the E axis tells us if the starting point is DSG
	line = grid_line(e_dim,grid)
	IF (line .EQ. mnormal) THEN
	   ITSA_REGRID_FROM_DSG = .FALSE.
	   RETURN
	ENDIF
	dset = line_dsg_dset(line)
	IF ( dset .EQ. pline_not_dsg) THEN
	   ITSA_REGRID_FROM_DSG = .FALSE.
	   RETURN
	ENDIF

* Yes - E tells us that this started as a DSG
* The existence of a feature-oriented axis that is non-DSG indicates a
* regrid from a DSG
* (see comments in dsg_whats_it.F for reasoning behind test for abstract axis)

	orient = dsg_orientation(dset)
	line = grid_line(orient,grid)
	IF (line .EQ. mnormal  .OR. 
     .      line .EQ. grid_line(1,mgrid_xabstract)) THEN
	   ITSA_REGRID_FROM_DSG = .FALSE.
	ELSE
	   ITSA_REGRID_FROM_DSG = line_dsg_dset(line) .EQ. pline_not_dsg
	ENDIF

* We know it's a regrid - the source is a dsg point-type dataset, so the
* grid is fine. (once we implement these regrids!)
	IF (orient .EQ. e_dim) ITSA_REGRID_FROM_DSG = .TRUE.  

        RETURN
        END

*
* samplexy_curv_nrst.F
*
* Ansley Manke
* 4/07

* This function samples 4-d curvlinear data on the x and y axes 
* indicated by args 4 and 5, returning nearest location.
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE samplexy_curv_nrst_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*          USER CONFIGURABLE PORTION |
*   |
*   V
      CHARACTER*120 fcn_desc
      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns data at a set of (X,Y) points, ',
     .   'from nearest loc on XY curvilinear grid')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 5)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, ABSTRACT, 
     .     NORMAL, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)

      CALL ef_set_num_work_arrays(id, 1)

      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'DAT_TO_SAMPLE')
      CALL ef_set_arg_desc(id, arg, 'variable (x,y,z,t) to sample')
      CALL ef_set_axis_influence(id, arg, NO, NO, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'DAT_LON')
      CALL ef_set_arg_desc(id, arg, 'longitudes of input variable')
      CALL ef_set_axis_influence(id, arg, NO, NO, YES, YES)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'DAT_LAT')
      CALL ef_set_arg_desc(id, arg, 'latitudes of input variable')
      CALL ef_set_axis_influence(id, arg, NO, NO, YES, YES)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'XPTS')
      CALL ef_set_arg_desc(id, arg, 'X values of sample points')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'YPTS')
      CALL ef_set_arg_desc(id, arg, 'Y values of sample points')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
*   ^
*   |
*          USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* loss               lo subscript for an axis
*
* hiss               hi subscript for an axis
*

      SUBROUTINE samplexy_curv_nrst_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

* **********************************************************************
*          USER CONFIGURABLE PORTION |
*   |
*   V

      INTEGER my_lo_l, my_hi_l
      INTEGER nx, ny, nz, nt

*     Use utility functions to get context information about the 
*     1st argument, to set the abstract axis lo and hi indices.

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nx = arg_hi_ss(X_AXIS, ARG4) - arg_lo_ss(X_AXIS, ARG4) + 1
      ny = arg_hi_ss(Y_AXIS, ARG4) - arg_lo_ss(Y_AXIS, ARG4) + 1
      nz = arg_hi_ss(Z_AXIS, ARG4) - arg_lo_ss(Z_AXIS, ARG4) + 1
      nt = arg_hi_ss(T_AXIS, ARG4) - arg_lo_ss(T_AXIS, ARG4) + 1

      my_lo_l = 1
      my_hi_l = max(nx,ny,nz,nt)

      CALL ef_set_axis_limits(id, X_AXIS, my_lo_l, my_hi_l)

*   ^
*   |
*          USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE samplexy_curv_nrst_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*           USER CONFIGURABLE PORTION |
*    |
*    V

*
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_lens(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER nx, ny

      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

*  workspace for saving locations of xpt in arg2 array.

      nx = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) 
      ny = arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) 

*  xlocations
      CALL ef_set_work_array_dims (id, 1, 1, 1, 1, 1, nx*ny, 2, 1, 1)

*    ^
*    |
*           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END
*
* In this subroutine we compute the result
*



      SUBROUTINE samplexy_curv_nrst_compute(id, arg_1, arg_2, arg_3, arg_4, 
     .       arg_5, result, xlocations)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .     mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .     mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz,
     .     mem3lot:mem3hit)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz,
     .     mem4lot:mem4hit)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz,
     .     mem5lot:mem5hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .      memresloz:memreshiz, memreslot:memreshit)


* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable's axes.

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

***********************************************************************
*          USER CONFIGURABLE PORTION |
*   |
*   V
      COMMON /STOR/ mxdat, mydat
      INTEGER mxdat, mydat
      INTEGER nx, nxx, nxy, nxz, nxt
      INTEGER ny, nyx, nyy, nyz, nyt
      INTEGER ndimx, ndimy
      INTEGER nx1, nx2, nx3, ny1, ny2, ny3

*  Set up work arrays

      REAL xlocations(wrk1lox:wrk1lox+(wrk1hix-wrk1lox),wrk1loy:wrk1hiy,
     .                wrk1loz:wrk1hiz, wrk1lot:wrk1hit)
      REAL ylocations(2)

      INTEGER i, j, k, l
      INTEGER i1,j1,k1,l1
      INTEGER i2,j2,k2,l2
      INTEGER i3,j3,k3,l3
      INTEGER i4,j4,k4,l4
      INTEGER i5,j5,k5,l5

      LOGICAL need_modulo
      INTEGER ibot, itop, jbot, jtop
      INTEGER nloc, iloc, ptloc, icross
      REAL xpt, ypt, ydiff, yd
      REAL xptmin, xptmax, xcoordmin, xcoordmax
      CHARACTER*255 err_msg

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

C Check that first 3 args are on the same grid.

      nx1 = arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 1
      nx2 = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1
      nx3 = arg_hi_ss(X_AXIS,ARG3) - arg_lo_ss(X_AXIS,ARG3) + 1
      ny1 = arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 1
      ny2 = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1
      ny3 = arg_hi_ss(X_AXIS,ARG3) - arg_lo_ss(X_AXIS,ARG3) + 1

      IF (nx1 .NE. nx2 .OR. nx2 .NE. nx3 .OR. nx1 .NE. nx3) THEN
         err_msg ='Arguments 1, 2, and 3 must have the same XY grid'
         GO TO 999
      ENDIF
      IF (ny1 .NE. ny2 .OR. ny2 .NE. ny3 .OR. ny1 .NE. ny3) THEN
         err_msg ='Arguments 1, 2, and 3 must have the same XY grid'
         GO TO 999
      ENDIF

C Check that sample x and y are simple lists of points - same length

      nxx = arg_hi_ss(X_AXIS,ARG4) - arg_lo_ss(X_AXIS,ARG4) + 1
      nxy = arg_hi_ss(Y_AXIS,ARG4) - arg_lo_ss(Y_AXIS,ARG4) + 1
      nxz = arg_hi_ss(Z_AXIS,ARG4) - arg_lo_ss(Z_AXIS,ARG4) + 1
      nxt = arg_hi_ss(T_AXIS,ARG4) - arg_lo_ss(T_AXIS,ARG4) + 1
      nx = max(nxx, nxy, nxz, nxt)

      nyx = arg_hi_ss(X_AXIS,ARG5) - arg_lo_ss(X_AXIS,ARG5) + 1
      nyy = arg_hi_ss(Y_AXIS,ARG5) - arg_lo_ss(Y_AXIS,ARG5) + 1
      nyz = arg_hi_ss(Z_AXIS,ARG5) - arg_lo_ss(Z_AXIS,ARG5) + 1
      nyt = arg_hi_ss(T_AXIS,ARG5) - arg_lo_ss(T_AXIS,ARG5) + 1
      ny = max(nyx, nyy, nyz, nyt)

      ndimx = 0
      ndimy = 0
      DO 110 i = X_AXIS,T_AXIS
         IF(arg_hi_ss(i,ARG4) - arg_lo_ss(i,ARG4) .GT.0) ndimx=ndimx + 1
         IF(arg_hi_ss(i,ARG5) - arg_lo_ss(i,ARG5) .GT.0) ndimy=ndimy + 1
  110 CONTINUE

      IF (nx .NE. ny   .OR.  ndimx .GT. 1  .OR. ndimy .GT.1) THEN
         err_msg = 
     .  'Arguments 4 and 5 must be 1-dimensional lists of equal length'
         GO TO 999
      ENDIF
      
* Initialize result

      DO 104 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
         DO 103 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            DO 102 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
               DO 101 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

                     result(i,j,k,l) = bad_flag_result

 101           CONTINUE
 102        CONTINUE
 103     CONTINUE
 104  CONTINUE

* Get range of arg_2, longitude coordinates, and arg_4, xpts to sample.
* is modulo-ing needed?

      xcoordmin = ABS(bad_flag(ARG2))
      xcoordmax = -1. * xcoordmin

      k2 = arg_lo_ss(Z_AXIS,ARG2)
      l2 = arg_lo_ss(T_AXIS,ARG2)

      DO 106 j2 = arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS,ARG2)
      DO 105 i2 = arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS,ARG2)
         IF (arg_2(i2,j2,k2,l2) .NE. bad_flag(ARG2)) THEN
            xcoordmin = MIN(arg_2(i2,j2,k2,l2), xcoordmin)
            xcoordmax = MAX(arg_2(i2,j2,k2,l2), xcoordmax)
         ELSE
            err_msg =
     .      'Arg 2, curvilinear X coordinates, contains missing values'
            GOTO 999
         ENDIF
  105 CONTINUE
  106 CONTINUE


      xptmin = ABS(bad_flag(ARG4))
      xptmax = -1.* xptmin
      DO 204 l4 = arg_lo_ss(T_AXIS,ARG4), arg_hi_ss(T_AXIS,ARG4)
      DO 203 k4 = arg_lo_ss(Z_AXIS,ARG4), arg_hi_ss(Z_AXIS,ARG4)
      DO 202 j4 = arg_lo_ss(Y_AXIS,ARG4), arg_hi_ss(Y_AXIS,ARG4)
      DO 201 i4 = arg_lo_ss(X_AXIS,ARG4), arg_hi_ss(X_AXIS,ARG4)

         IF (arg_4(i4,j4,k4,l4) .NE. bad_flag(ARG4)) THEN
            xptmin = MIN(arg_4(i4,j4,k4,l4), xptmin)
            xptmax = MAX(arg_4(i4,j4,k4,l4), xptmax)
         ELSE
            err_msg =
     .      'Arg 2, sample x points, contains missing values'
            GOTO 999
         ENDIF
  201 CONTINUE
  202 CONTINUE
  203 CONTINUE
  204 CONTINUE

      IF (xptmin .LT. xcoordmin) THEN
         need_modulo = .TRUE.
         add_xcoord = -360.
      ENDIF
      IF (xptmax .GT. xcoordmax) THEN
         need_modulo = .TRUE.
         add_xcoord = 360.
      ENDIF
 
*  For each (xpt,ypt) pair, search the data arrays arg2,arg3
*  for the nearest higher (x,y) lat-lon coordinates.  Interpolate 
*  arg_1 in 2 directions for the result.

      i4 = arg_lo_ss(X_AXIS,ARG4)
      j4 = arg_lo_ss(Y_AXIS,ARG4)
      k4 = arg_lo_ss(Z_AXIS,ARG4)
      l4 = arg_lo_ss(T_AXIS,ARG4)

      i5 = arg_lo_ss(X_AXIS,ARG5)
      j5 = arg_lo_ss(Y_AXIS,ARG5)
      k5 = arg_lo_ss(Z_AXIS,ARG5)
      l5 = arg_lo_ss(T_AXIS,ARG5)

      j = res_lo_ss(Y_AXIS)
      DO 600 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

* Find all locations of xpt in arg_2, longitudes of data

         xadd = 0.
	 xpt = arg_4(i4,j4,k4,l4)
         IF (need_modulo .AND. 
     .       ((xpt .LT. xcoordmin) .OR.(xpt .GT. xcoordmax)) )
     .    xadd = add_xcoord

         k2 = arg_lo_ss(Z_AXIS,ARG2)
         l2 = arg_lo_ss(T_AXIS,ARG2)

         nloc = 0

         DO 200 j2 = arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS,ARG2)
            i2 = arg_lo_ss(X_AXIS,ARG2)
            xcoord = arg_2(i2,j2,k2,l2) + xadd
            icross = 1
            IF ((xpt - xcoord) .LT. 0.) icross = -1

            DO 100 i2 = arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS,ARG2)
               xcoord = arg_2(i2,j2,k2,l2) + xadd

               iloc = 1
               IF ((xpt-xcoord) .LT. 0. ) iloc = -1

               IF (icross .NE. iloc)THEN
                  nloc = nloc + 1
                  xlocations(nloc,1,1,1) = MAX(i2-1,1)
                  xlocations(nloc,2,1,1) = j2
                  icross = 1
                  IF ((xpt - xcoord) .LT. 0.) icross = -1
               ENDIF
  100       CONTINUE

  200    CONTINUE

* Which of those locations is nearest ypt in arg_3, latitudes of data?

         ypt = arg_5(i5,j5,k5,l5)
         ydiff = ABS(bad_flag_result)
         ptloc = 1

         k3 = arg_lo_ss(Z_AXIS,ARG3)
         l3 = arg_lo_ss(T_AXIS,ARG3)

         DO 300 iloc = 1, nloc
            i3 = xlocations(iloc,1,1,1)
            j3 = xlocations(iloc,2,1,1)
            IF (arg_3(i3,j3,k3,l3) .EQ. bad_flag(ARG3)) THEN
               err_msg =
     .      'ARG 3, curvilinear Y coordinates, contains missing values'
               GOTO 999
            ENDIF

            yd = ABS(ypt - arg_3(i3,j3,k3,l3))

            IF ( yd .LT. ydiff ) THEN
               ylocations(1) = i3
               ylocations(2) = j3
               ydiff = yd
               ptloc = iloc
            ENDIF
  300   CONTINUE

        ibot = xlocations(ptloc,1,1,1)
        jbot = xlocations(ptloc,2,1,1)
        IF (ibot .GE. arg_hi_ss(X_AXIS,ARG1) ) ibot = ibot - 1
        IF (jbot .GE. arg_hi_ss(Y_AXIS,ARG1) ) jbot = jbot - 1

        itop = ibot + 1
        jtop = jbot + 1

*  Return the function value closest to the xy value

        IF (ibot .GE. arg_lo_ss(X_AXIS,ARG1)  .AND. 
     .              itop .LT. arg_hi_ss(X_AXIS,ARG1) ) THEN

           k1 = arg_lo_ss(Z_AXIS,ARG1)
           k2 = arg_lo_ss(Z_AXIS,ARG2)
           k3 = arg_lo_ss(Z_AXIS,ARG3)
           DO 500 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

              l1 = arg_lo_ss(T_AXIS,ARG1)
              l2 = arg_lo_ss(T_AXIS,ARG2)
              l3 = arg_lo_ss(T_AXIS,ARG3)
              DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

                 xbot = arg_2(ibot,jbot,k2,l2)
                 xtop = arg_2(itop,jbot,k2,l2)

                 ybot = arg_3(ibot,jbot,k3,l3)
                 ytop = arg_3(ibot,jtop,k3,l3)

                 dmin = SQRT((xpt - xbot )**2 + (ypt - ybot)**2 )
                 ii = ibot
                 jj = jbot
                 dd =   SQRT((xpt - xtop )**2 + (ypt - ybot)**2 )
                 IF (dd .LT. dmin) THEN
                      ii = itop
                      jj = jbot
                      dmin = dd
                 ENDIF
                 dd =   SQRT((xpt - xbot )**2 + (ypt - ytop)**2 )
                 IF (dd .LT. dmin) THEN
                      ii = ibot
                      jj = jtop
                      dmin = dd
                 ENDIF
                 dd =   SQRT((xpt - xtop )**2 + (ypt - ytop)**2 )
                 IF (dd .LT. dmin) THEN
                      ii = itop
                      jj = jtop
                      dmin = dd
                 ENDIF
                  
                 result(i,j,k,l) = arg_1(ii,jj,k1,l1) 

                 l1 = l1 + arg_incr(T_AXIS,ARG1)
                 l2 = l2 + arg_incr(T_AXIS,ARG2)
                 l3 = l3 + arg_incr(T_AXIS,ARG3)
 400          CONTINUE
              
               k1 = k1 + arg_incr(Z_AXIS,ARG1)
               k2 = k2 + arg_incr(Z_AXIS,ARG2)
               k3 = k3 + arg_incr(Z_AXIS,ARG3)
 500       CONTINUE

         ENDIF  ! IF (ibot .GE. ...  .AND. itop .LT.  ...

         i4 = i4 + arg_incr(X_AXIS,ARG4)
         j4 = j4 + arg_incr(Y_AXIS,ARG4)
         k4 = k4 + arg_incr(Z_AXIS,ARG4)
         l4 = l4 + arg_incr(T_AXIS,ARG4)

         i5 = i5 + arg_incr(X_AXIS,ARG5)
         j5 = j5 + arg_incr(Y_AXIS,ARG5)
         k5 = k5 + arg_incr(Z_AXIS,ARG5)
         l5 = l5 + arg_incr(T_AXIS,ARG5)
600   CONTINUE

      RETURN
 999  CALL ef_bail_out (id, err_msg)

      END

*------------------------------fft_inverse.F---------------------------

* fft_inverse.F
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* November 2001
*
* v5.50  *acm* 10/02 Simplify the error message for missing data when the 
*                    input is a simple 1-D time series.
*
* This function computes inverse fft transform spectrum for each A,B,
* where these are the real and imaginary part of the FFT coefficients.
*
*  NOTE:
*  IT IS GENERALLY ADVISABLE TO INCLUDE EXPLICIT LIMITS WHEN WORKING WITH
*  FUNCTIONS THAT REPLACE AXES. FOR EXAMPLE, THE CONSIDER THE FUNCTION
*  SORTL(v). THE EXPRESSION
*       LIST/L=6:10 SORTL(v)
*  IS NOT EQUIVALENT TO
*       LIST SORTL(v[L=6:10])
*  THE FORMER WILL LIST THE 6TH THROUGH 10TH SORTED INDICES FROM THE ENTIRE
*  L RANGE OF VARIABLE V. THE LATTER WILL LIST ALL OF THE INDICES THAT
*  RESULT FROM SORTING v[L=6:10].
*  
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE fft_inverse_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id, 'Computes inverse fft time series')
      CALL ef_set_num_args(id, 2)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, ABSTRACT,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 4)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'Real part of FFT coefficients')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, NO, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'B')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 
     .                 'Imaginary part of FFT coefficients')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, NO, YES, YES)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE fft_inverse_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER ntime, nfreq
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

*  Use utility functions to get context information about the argument.

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nfreq = arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1) + 1

C  The FFT code returns frequencies W(k) for k=1 to N/2, with N/2 rounded down

      ntime = nfreq* 2

      CALL ef_set_axis_limits(id, T_AXIS, 1, ntime)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE fft_inverse_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
* 
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER mtdat, mtwork
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      mtdat = 1 + arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1)

      mtwork = 4.* 2.5* mtdat + 15

* a
      CALL ef_set_work_array_dims_6d(id, 1,
     .                                1, 1, 1, 1, 1, 1,
     .                            mtdat, 1, 1, 1, 1, 1)

* b
      CALL ef_set_work_array_dims_6d(id, 2,
     .                                1, 1, 1, 1, 1, 1,
     .                            mtdat, 1, 1, 1, 1, 1)

* wft
      CALL ef_set_work_array_dims_6d(id, 3,
     .                                1, 1, 1, 1, 1, 1,
     .                           mtwork, 1, 1, 1, 1, 1)

* ts
      CALL ef_set_work_array_dims_6d(id, 4,
     .                                1, 1, 1, 1, 1, 1,
     .                           mtwork, 1, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE fft_inverse_compute(id, arg_1, arg_2, result, 
     .                               a, b, wft, ts)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

      REAL a(wrk1lox:wrk1hix, wrk1loy:wrk1hiy, wrk1loz:wrk1hiz,
     .       wrk1lot:wrk1hit, wrk1loe:wrk1hie, wrk1lof:wrk1hif)
      REAL b(wrk2lox:wrk2hix, wrk2loy:wrk2hiy, wrk2loz:wrk2hiz,
     .       wrk2lot:wrk2hit, wrk2loe:wrk2hie, wrk2lof:wrk2hif)
      REAL wft(wrk3lox:wrk3hix, wrk3loy:wrk3hiy, wrk3loz:wrk3hiz,
     .         wrk3lot:wrk3hit, wrk3loe:wrk3hie, wrk3lof:wrk3hif)
      REAL ts(wrk4lox:wrk4hix, wrk4loy:wrk4hiy, wrk4loz:wrk4hiz,
     .        wrk4lot:wrk4hit, wrk4loe:wrk4hie, wrk4lof:wrk4hif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER arg, ntime, nfreq
      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1
      CHARACTER*128 err_msg

   40 FORMAT ('FFT_INVERSE encountered missing data at (i,j,k,l,m,n)',
     .        6I5)
   50 FORMAT ('FFT_INVERSE encountered missing data at L=', I5)

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*  number of freq points.

      arg = 1
      nfreq = (arg_hi_ss(T_AXIS,arg) - arg_lo_ss(T_AXIS,arg) + 1)
      ntime = nfreq* 2

*  Check that arg1 and arg2 have the same axes.

      IF ( arg_lo_ss(X_AXIS,ARG1) .NE. arg_lo_ss(X_AXIS,ARG2) ) THEN
         err_msg = 'X Axes of A and B coefficients must agree'
         GOTO 999
      ENDIF
      IF ( arg_lo_ss(Y_AXIS,ARG1) .NE. arg_lo_ss(Y_AXIS,ARG2)  ) THEN
         err_msg = 'Y Axes of A and B coefficients must agree'
         GOTO 999
      ENDIF
      IF ( arg_lo_ss(Z_AXIS,ARG1) .NE. arg_lo_ss(Z_AXIS,ARG2) ) THEN
         err_msg = 'Z Axes of A and B coefficients must agree'
         GOTO 999
      ENDIF
      IF ( arg_lo_ss(T_AXIS,ARG1) .NE. arg_lo_ss(T_AXIS,ARG2)  ) THEN
         err_msg = 'T Axes of A and B coefficients must agree'
         GOTO 999
      ENDIF
      IF ( arg_lo_ss(E_AXIS,ARG1) .NE. arg_lo_ss(E_AXIS,ARG2)  ) THEN
         err_msg = 'E Axes of A and B coefficients must agree'
         GOTO 999
      ENDIF
      IF ( arg_lo_ss(F_AXIS,ARG1) .NE. arg_lo_ss(F_AXIS,ARG2)  ) THEN
         err_msg = 'F Axes of A and B coefficients must agree'
         GOTO 999
      ENDIF

*  Set WFT for fft; prime factorization of ntime and trig functions.

      CALL rffti (ntime, wft)

      n1 = arg_lo_ss(F_AXIS,ARG1)
      DO 600 n=res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

      m1 = arg_lo_ss(E_AXIS,ARG1)
      DO 500 m=res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

      k1 = arg_lo_ss(Z_AXIS,ARG1)
      DO 300 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 200 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            i1 = arg_lo_ss(X_AXIS,ARG1)
            DO 100 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

* Calculate the inverse FFT for each series which have no missing data.
* Make a simple error message if we have a 1-D input time series.

               l1 =arg_lo_ss(T_AXIS,ARG1)
               DO 400 l = 1, nfreq

                  IF (arg_1(i1,j1,k1,l1,m1,n1) .EQ. bad_flag(ARG1) .OR.
     .                arg_2(i1,j1,k1,l1,m1,n1) .EQ. bad_flag(ARG2)) THEN
                     IF ( i1 .EQ. ef_unspecified_int4 .AND.
     .                    j1 .EQ. ef_unspecified_int4 .AND.
     .                    k1 .EQ. ef_unspecified_int4 .AND.
     .                    m1 .EQ. ef_unspecified_int4 .AND.
     .                    n1 .EQ. ef_unspecified_int4 ) THEN
                        WRITE (err_msg, 50) l
                     ELSE
                        WRITE (err_msg, 40) i1,j1,k1,l,m1,n1
                     ENDIF
                     GO TO 999 
                  ENDIF
                  A(l,1,1,1,1,1) = arg_1(i1,j1,k1,l1,m1,n1)
                  B(l,1,1,1,1,1) = arg_2(i1,j1,k1,l1,m1,n1)

                  l1 = l1 + arg_incr(T_AXIS,ARG1)
 400           CONTINUE

               CALL FFTINV (ntime, ts, a, b, wft)

               DO 410 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS) 
                   result(i,j,k,l,m,n) = ts(l,1,1,1,1,1)
 410           CONTINUE

               i1 = i1 + arg_incr(X_AXIS,ARG1)
 100        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 200     CONTINUE

         k1 = k1 + arg_incr(Z_AXIS,ARG1)
 300  CONTINUE

         m1 = m1 + arg_incr(E_AXIS,ARG1)
 500  CONTINUE

         n1 = n1 + arg_incr(F_AXIS,ARG1)
 600  CONTINUE

      RETURN

 999  CALL ef_bail_out (id, err_msg)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	SUBROUTINE CD_STAMP_OUT(append, cdfid, string, status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Put a "history" stamp into the current netCDF output file

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 3/92
* 10/96 *kob* - Linux port - had to move variable assignments off of
*		declaration line.
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* argument definitions:
*       append  - logical control to create or append
*       cdfid   - returned pointer to open CDF file
*       string  - history string to add
*	status	- return status

* argument declarations:
        LOGICAL  append
	INTEGER	 cdfid, status
        CHARACTER*(*) string

* include files
        include 'netcdf.inc'
        include 'tmap_errors.parm'
        include 'cd_lib.parm'

* local variable declarations:
* *kob* explicit definitions not allowed on decl line in linux...
*       moved it to parameter line 10/96
      INTEGER TM_LENSTR1, STR_SAME, TM_LOC_STRING, 
     .        hlen, slen, ioc, loc, appnd
      LOGICAL CD_GET_ATTRIB, got_it, do_warn, append_flag
      PARAMETER (do_warn = .TRUE. )
      CHARACTER*2048 history
      CHARACTER*1 nl
      PARAMETER( nl = CHAR(10) )

* initialize
      slen = MIN( TM_LENSTR1(string), 120 )

* append flag will be set as follows:
c      appnd =  1 ! to append
c      appnd =  0 ! to write the string sent in
c      appnd = -1 ! to write altered history string

      appnd = 0
      append_flag = .TRUE.

* update (or create) history record
      got_it = CD_GET_ATTRIB( cdfid, NCGLOBAL, 'history',
     .                     .NOT.do_warn, ' ', history, hlen, 2048 )

* is the last history stamp the same as this ?
      IF ( hlen .GE. slen ) THEN
         IF (STR_SAME( history(hlen-slen+1:hlen), string(:slen) ) 
     .      .EQ. 0) RETURN
      ENDIF

* is the last history stamp just a FERRET Vxx  date?
* If so just replace with the current FERRET Vxxx ...

      IF ( STR_SAME (history(1:8), 'FERRET V') .EQ.0 .AND.
     .     hlen .LE. 30 ) THEN 
        appnd = 0
	append_flag = .FALSE.
      ELSE

* does the last history end with a FERRET Vxx  date?
* If so just replace with the current FERRET Vxxx ...

         ioc = 0
         loc = TM_LOC_STRING(history,'FERRET V',ioc)
         IF ( loc .GT. 1 ) THEN
	    history = history(:loc-1)//string(:slen)
	    appnd = -1
	    append_flag = .FALSE.
	 ENDIF
      ENDIF

* Replace or append to signature.

      IF (appnd .EQ. 1) THEN
         CALL CD_WRITE_ATTRIB(cdfid, pcdf_global, 'history',  
     .                     ','//nl(:1)//' '//string(:slen),
     .                     append_flag, status )
      ELSE IF (appnd .EQ. 0) THEN
         CALL CD_WRITE_ATTRIB(cdfid, pcdf_global, 'history', string(:slen),
     .                     append_flag, status )
      ELSE IF (appnd .EQ. -1) THEN
         slen = TM_LENSTR1(history)
         CALL CD_WRITE_ATTRIB(cdfid, pcdf_global, 'history', history(:slen),
     .                     append_flag, status )
      ENDIF
      IF ( status .NE. merr_ok ) GOTO 5000

* successful completion
      status = merr_ok
      RETURN

* error exit
 5000 RETURN
	END

	INTEGER FUNCTION DATE_PREC( grid, idim, dt )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine the precision level needed for a date string to resolve "dt"
* in units appropriate for the given grid time axis

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/18/88
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction. 
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
        include 'xunits.cmn_text'
	include	'ferret.parm'

* calling argument declarations
	INTEGER	grid, idim
	REAL	dt

* internal variable declarations:
	LOGICAL ITSA_TRUEMONTH_AXIS
	INTEGER	i
	REAL	convert(5), delta
	DATA	convert(1)/ 60. /,	! sec --> min
     .		convert(2)/ 60. /,	! min --> hour
     .		convert(3)/ 24. /,	! hr  --> day
     .		convert(4)/ 30. /,	! day --> mon
     .		convert(5)/ 12. /	! mon --> year

* get the dt interval expressed in seconds
	delta = dt * line_tunit( grid_line(idim,grid) )

* A true-month axis has line-units of month, but output units of days
	IF (ITSA_TRUEMONTH_AXIS(grid_line(idim,grid))) delta = dt * un_convert(pun_day)

* see how big it is
	DO 100 i = 1, 5
	   delta = delta / convert(i)
	   IF ( delta .LT. 1.0 ) THEN
	      DATE_PREC = 7-i
	      RETURN
	   ENDIF
 100	CONTINUE

* very big ! use years, only to label
	DATE_PREC = 1
	RETURN
	END

	SUBROUTINE XEQ_SPAWN

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* SPAWN a subprocess to VMS DCL level

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 8/2/88
* v200: Unix/RISC port - 3/12/91 - coach for "^z" on Unix
* V230 6/92 - allow "system" calls for unix
* V320: 12/29/94 - use SPLIT_LIST to redirect tty output for GUI
* 10.28.98 *js* Disable command if secure mode set
* V500:  1/99 - correct the handing of qutes as in SPAWN "date"
*		with call to ALL_1_ARG
* V606  8/07 *acm* Send informational and error messages that are returned from 
*                  commands via SPLIT_LIST to std error rather than std out.
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
*    *acm* 7/17. Test a status flag on the system call (see ticket 2453).
*                 Results seem inconsistent, make it a warning
* V702 3/17 Use the return status to set Ferret symbol ($SPAWN_STATUS)
* v720 7/17 ticket 2552 Make SPAWN_STATUS return the return status, so 0=succcess
*           SPAWN_STATUS returns the status value, used for SPAWN_OK and SPAWN_STATUS

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'

	LOGICAL IS_SECURE
	INTEGER	status, slen

        IF (IS_SECURE()) THEN
           CALL SPLIT_LIST(pttmode_help, err_lun,
     1                     'This command is not allowed.', 0)
           RETURN
        ENDIF

	CALL ALL_1_ARG
	IF ( num_args .GT. 0 ) THEN
*          Flush Fortran stdout and stderr so that any output from
*          the system command will appear in the appropriate place.
           CALL FLUSH(ttout_lun)
           CALL FLUSH(err_lun)
           CALL SYSTEM( cmnd_buff(arg_start(1):arg_end(1)),status )
           spawn_status = status   
	ELSE
* user can get choice of shells with "SPAWN csh", or whatever.
	   CALL SPLIT_LIST(pttmode_help, err_lun,
     .    	' Use "^Z" for shell prompt.  Type "fg" to return.', 0)
	   CALL SPLIT_LIST(pttmode_help, err_lun,
     .    	' Or type "SPAWN csh" (or shell of your choice) '
     .    	//'and "exit" to return', 0)
	ENDIF

5000	CONTINUE
	RETURN



* The return is the return flag from the command, which might be non-zero
* if they look for a file that's non-existent. 
* (Should this really be an ERROR!?  I'm thinking not) 
*   sp rm nothing.dat >> returns 256. 
*   sp ls nofile.dat  >> returns 512
*   sp cat file.dat | grep "this text not in the file"  >> returns 256
*   sp notAcommand >> returns 32512

!5100	CALL ERRMSG(ferr_sys_return, status, 
!     .            'SPAWN '//cmnd_buff(arg_start(1):arg_end(1)), *5000)

	END

      SUBROUTINE DSG_OPERATE (	operation, ncom, ifv, res_cx, com_cx,
     .                          dset,
     .                          nfeatures, fmask,
     .				com1, mr1,
     .				com2, mr2,
     .				com3, mr3,
     .				com4, mr4,
     .				res, mres )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* perform an operation on a contiguous ragged array DSG
* possibly involving a mixture of instance and obs arguments 

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* V7.2 *sh* 5/17 - patterned on OPERATE.F
* V7.5 *acm* 7/19 -fixes to indexing for some operations
* V7.51 *acm* 8/19 - more fixes to indexing for some operations
* V7.5  *acm* 4/20 - more fixes to indexing for some operations, atan2,...

	include 'tmap_dims.parm'
	include	'ferret.parm'
        include 'xdset_info.cmn_text'
        include 'xdyn_linemem.cmn_text'
	include	'xmem_subsc.cmn'
	include 'xvariables.cmn'
	include 'xcontext.cmn'

* calling argument declarations:
	LOGICAL ifv, fmask(nfeatures)
	INTEGER	operation, ncom, res_cx, mr1, mr2, mr3, mr4, mres,
     .          com_cx(ncom), dset, nfeatures
	REAL    com1( m1lox:m1hix ),  ! need lo:hi cuz of -999:-999
     .		com2( m2lox:m2hix ),
     .		com3( m3lox:m3hix ),
     .		com4( m4lox:m4hix ),
     .		 res( * )

!DSGTBD: if it becomes desirable to implement a free (gridded) F axis ...
!	REAL    com1( m1hix, m1lof:m1hif ),
!     .		com2( m2hix, m2lof:m2hif ),
!     .		com3( m3hix, m3lof:m3hif ),
!     .		com4( m4hix, m4lof:m4hif ),
!     .		 res( m5hix, m5lof:m5hif )

* internal variable declarations:
	LOGICAL	first, is_obs_res, is_inst(4), is_obs(4), is_const(4)
	INTEGER CX_DIM_LEN, TM_DSG_DSET_FROM_GRID, TM_DSG_NFEATURES,
     .          row_size_lm, op, inseed, i, ifeature, iobs, base, flen,
     .          nobs
	REAL	RANDU, RANDN, RANDN2, RHO_UNESCO, THETA_FOFF,
     .		DAYS_FROM_DAY0,
     .          bad1, bad2, bad3, bad4, bad_res, dummy,
     .          op_repl, args(4)
	REAL*4  R_IN

* convenience equivalences
        LOGICAL
     .          is_inst_1 , is_inst_2 , is_inst_3 , is_inst_4,
     .          is_obs_1  , is_obs_2  , is_obs_3  , is_obs_4,
     .          is_const_1, is_const_2, is_const_3, is_const_4
        REAL    arg1, arg2, arg3, arg4
        EQUIVALENCE
     .          (is_inst (1), is_inst_1 ), (is_inst (2), is_inst_2 ),
     .          (is_inst (3), is_inst_3 ), (is_inst (4), is_inst_4 ),
     .          (is_obs  (1), is_obs_1  ), (is_obs  (2), is_obs_2  ),
     .          (is_obs  (3), is_obs_3  ), (is_obs  (4), is_obs_4  ),
     .          (is_const(1), is_const_1), (is_const(2), is_const_2),
     .          (is_const(3), is_const_3), (is_const(4), is_const_4),
     .          (args(1), arg1), (args(2), arg2),
     .          (args(3), arg3), (args(4), arg4)

* internal parameter declarations:
	REAL*8          pdays_by_1900
	PARAMETER     ( pdays_by_1900 = 59958230400.0 / (60.*60.*24.) )

* get feature and obs masks
        CALL MAKE_DSG_FEATURE_MASK(dset, res_cx, fmask, nfeatures)

* initialize
	row_size_lm = dsg_loaded_lm(dsg_row_size_var(dset))
        nobs  = dsg_obs_dimlen(dset)

* differentiate obs, instance and constant component vars
        DO i = 1, ncom
           is_inst(i)  = hi_ss(i,1) .EQ. nfeatures
           is_obs(i)   = hi_ss(i,1) .EQ. nobs
           is_const(i) = cx_category(com_cx(i)) .EQ. cat_constant
	   is_const(i) = (hi_ss(i,1) .EQ. unspecified_int4) 
        ENDDO

* set constant values, just once, now
        IF (                is_const_1) THEN
	   IF (hi_ss(1,1) .EQ. unspecified_int4) THEN 
	      arg1 = com1(unspecified_int4)
	   ELSE
	      arg1 = com1(m1lox) 
	   ENDIF
	ENDIF
        IF (ncom.GE.2 .AND. is_const_2)  THEN
	   IF (hi_ss(2,1) .EQ. unspecified_int4) THEN 
	      arg2 = com2(unspecified_int4)
	   ELSE
	      arg2 = com2(m1lox) 
	   ENDIF
	ENDIF
        IF (ncom.GE.3 .AND. is_const_3)   THEN
	   IF (hi_ss(3,1) .EQ. unspecified_int4) THEN 
	      arg3 = com3(unspecified_int4)
	   ELSE
	      arg3 = com3(m1lox) 
	   ENDIF 
	ENDIF
        IF (ncom.GE.4 .AND. is_const_4)   THEN
	   IF (hi_ss(4,1) .EQ. unspecified_int4) THEN 
	      arg4 = com4(unspecified_int4)
	   ELSE
	      arg4 = com4(m1lox) 
	   ENDIF
	ENDIF

* is the result a ragged array or a simple line of instance data?
* note that the result is only an instance when all components are too
        is_obs_res = m5hix .GT. nfeatures

* flag(s) for bad or missing values
	bad1 = mr_bad_data ( mr1 )
	bad2 = mr_bad_data ( mr2 )
	bad3 = mr_bad_data ( mr3 )
	bad4 = mr_bad_data ( mr4 )
	bad_res = mr_bad_data( mres )

* For operations, e.g.  IF var GT a THEN b, create a mask of 1's and 0's.
* but for expressions using IFV, the mask needs to be 1's and bad-values.
* If its an IFV expression then use the corresponding THEN and ELSE.

        op = operation
	op_repl = 0.
	IF (ifv) THEN
	   op_repl = bad_res
	   IF (op .EQ. 45) op = 47
	   IF (op .EQ. 46) op = 48
        ENDIF

* operators, functions, logic structures

	GOTO (   100, 200, 300, 400, 500, 600, 700, 800, 900,1000,
     .		1100,1200,1300,1400,1500,1600,1700,1800,
     .
     .		1900,2000,
     .		2100,2200,2300,2400,2500,2600,2700,2800,2900,3000,
     .		3100,3200,3300,3400,3500,3600,3700,3800,3900,4000,
     .		4100,4200,4300,
     .
     .		4400,4500,4600,4700,4800		   ) op

* ----------------------------------------------------------------------------
* ------- OPERATORS -------------
*
* "+"
 100    CONTINUE
	IF (is_const_1 .AND. is_const_2) THEN  ! 2 constants may have been sent in
	   IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	      res(1) = bad_res
	   ELSE
	      res(1) = arg1 + arg2
	   ENDIF
	   RETURN
	ENDIF
	
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)
           IF (is_inst_2) arg2 = com2(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)
              IF (is_obs_2) arg2 = com2(iobs)

	      IF ( arg1.EQ.bad1 .OR. arg2.EQ.bad2 ) THEN
	        res(iobs) = bad_res
	      ELSE
	        res(iobs) = arg1 + arg2       !   "+"
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN

* "-"
 200	CONTINUE
	IF (is_const_1 .AND. is_const_2) THEN  ! 2 constants may have been sent in
	   IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	      res(1) = bad_res
	   ELSE
	      res(1) = arg1 - arg2
	   ENDIF
	   RETURN
	ENDIF
	
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)
           IF (is_inst_2) arg2 = com2(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)
              IF (is_obs_2) arg2 = com2(iobs)

	      IF ( arg1.EQ.bad1 .OR. arg2.EQ.bad2 ) THEN
	        res(iobs) = bad_res
	      ELSE
	        res(iobs) = arg1 - arg2       !   "-"
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN

* "*"
 300	CONTINUE
	IF (is_const_1 .AND. is_const_2) THEN  ! 2 constants may have been sent in
	   IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	      res(1) = bad_res
	   ELSE
	      res(1) = arg1* arg2
	   ENDIF
	   RETURN
	ENDIF
	
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)
           IF (is_inst_2) arg2 = com2(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)
              IF (is_obs_2) arg2 = com2(iobs)

	      IF ( arg1.EQ.bad1 .OR. arg2.EQ.bad2 ) THEN
	        res(iobs) = bad_res
	      ELSE
	        res(iobs) = arg1 * arg2       !   "*"
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN

* "/"
 400	CONTINUE
	IF (is_const_1 .AND. is_const_2) THEN  ! 2 constants may have been sent in
	   IF (arg2.EQ.0 .OR. arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	      res(1) = bad_res
	   ELSE
	      res(1) = arg1/ arg2
	   ENDIF
	   RETURN
	ENDIF
	
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)
           IF (is_inst_2) arg2 = com2(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)
              IF (is_obs_2) arg2 = com2(iobs)

	      IF (arg2.EQ.0 .OR. arg1.EQ.bad1 .OR. arg2.EQ.bad2 ) THEN
	        res(iobs) = bad_res
	      ELSE
	        res(iobs) = arg1 / arg2       !   "/"
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN

* "^"
 
* "^"
 500	CONTINUE
	IF (is_const_1 .AND. is_const_2) THEN  ! 2 constants may have been sent in
	   IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	      res(1) = bad_res
	   ELSE
	      res(1) = arg1**arg2
	   ENDIF
	   RETURN
	ENDIF
	
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)
           IF (is_inst_2) arg2 = com2(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)
              IF (is_obs_2) arg2 = com2(iobs)

	      IF (arg2.EQ.0 .OR. arg1.EQ.bad1 .OR. arg2.EQ.bad2 ) THEN
	        res(iobs) = bad_res
	      ELSE
	        res(iobs) = arg1 ** arg2       !   "^"
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN

* "AND" - logical AND of 2 masks (any non-zero data regarded as .TRUE.)
 600    CONTINUE

	IF (is_const_1 .AND. is_const_2) THEN  ! 2 constants may have been sent in
	   IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	      res(1) = bad_res
	   ELSE
	      IF ( arg1.NE.0.0 .AND. arg2.NE.0.0 ) THEN
	  	 res(1) = 1.0
	      ELSE
	  	 res(1) = op_repl
	      ENDIF
	   ENDIF
	   RETURN
	ENDIF
	
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)
           IF (is_inst_2) arg2 = com2(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)
              IF (is_obs_2) arg2 = com2(iobs)

              IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	         res(iobs) = bad_res
              ELSE
	         IF ( arg1.NE.0.0 .AND. arg2.NE.0.0 ) THEN
	  	    res(iobs) = 1.0
	         ELSE
	  	    res(iobs) = op_repl
	         ENDIF
              ENDIF

           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN
* "OR" - logical OR of 2 masks (any non-zero data regarded as .TRUE.)
 700	CONTINUE

	IF (is_const_1 .AND. is_const_2) THEN  ! 2 constants may have been sent in
	   IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	      res(1) = bad_res
	   ELSE
	      IF ( arg1.NE.0.0 .OR. arg2.NE.0.0 ) THEN
	  	 res(1) = 1.0
	      ELSE
	  	 res(1) = op_repl
	      ENDIF
	   ENDIF
	   RETURN
	ENDIF
	
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)
           IF (is_inst_2) arg2 = com2(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)
              IF (is_obs_2) arg2 = com2(iobs)

              IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	         res(iobs) = bad_res
              ELSE
	         IF ( arg1.NE.0.0 .OR. arg2.NE.0.0 ) THEN
	  	    res(iobs) = 1.0
	         ELSE
	  	    res(iobs) = op_repl
	         ENDIF
              ENDIF

           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN


* "GT" - mask of 1's where grid 1 exceeds grid 2, 0's elsewhere
* "GT" - mask of 1's where grid 1 exceeds grid 2, bad-val elsewhere
 800 	CONTINUE

	IF (is_const_1 .AND. is_const_2) THEN  ! 2 constants may have been sent in
	   IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	      res(1) = bad_res
	   ELSE
	      IF ( arg1 .GT. arg2 ) THEN
	  	 res(1) = 1.0
	      ELSE
	  	 res(1) = op_repl
	      ENDIF
	   ENDIF
	   RETURN
	ENDIF
	
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)
           IF (is_inst_2) arg2 = com2(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)
              IF (is_obs_2) arg2 = com2(iobs)

              IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	         res(iobs) = bad_res
              ELSE
	         IF ( arg1 .GT. arg2 ) THEN
	  	    res(iobs) = 1.0
	         ELSE
	  	    res(iobs) = op_repl
	         ENDIF
              ENDIF

           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN

* "GE" - mask of 1's where grid 1 exceeds or equals grid 2, bad elsewhere
 900 	CONTINUE

	IF (is_const_1 .AND. is_const_2) THEN  ! 2 constants may have been sent in
	   IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	      res(1) = bad_res
	   ELSE
	      IF ( arg1 .GE. arg2 ) THEN
	  	 res(1) = 1.0
	      ELSE
	  	 res(1) = op_repl
	      ENDIF
	   ENDIF
	   RETURN
	ENDIF
	
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)
           IF (is_inst_2) arg2 = com2(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)
              IF (is_obs_2) arg2 = com2(iobs)

              IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	         res(iobs) = bad_res
              ELSE
	         IF ( arg1 .GE. arg2 ) THEN
	  	    res(iobs) = 1.0
	         ELSE
	  	    res(iobs) = op_repl
	         ENDIF
              ENDIF

           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN


* "LT" - mask of 1's where grid 1 is less than grid 2, bad elsewhere

 1000    CONTINUE
	 IF (is_const_1 .AND. is_const_2) THEN  ! 2 constants may have been sent in
	   IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	      res(1) = bad_res
	   ELSE
	      IF ( arg1 .LT. arg2 ) THEN
	  	 res(1) = 1.0
	      ELSE
	  	 res(1) = op_repl
	      ENDIF
	   ENDIF
	   RETURN
	ENDIF

	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)
           IF (is_inst_2) arg2 = com2(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)
              IF (is_obs_2) arg2 = com2(iobs)

	      IF ( arg1.EQ.bad1 .OR. arg2.EQ.bad2 ) THEN
	        res(iobs) = bad_res
	      ELSE
	         IF ( arg1 .LT. arg2 ) THEN
		    res(iobs) = 1.0
	         ELSE
		    res(iobs) = op_repl
	         ENDIF
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	RETURN

* "LE" - mask of 1's where grid 1 is less than or equal to grid 2, bad elsewher
 1100	CONTINUE

	IF (is_const_1 .AND. is_const_2) THEN  ! 2 constants may have been sent in
	   IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	      res(1) = bad_res
	   ELSE
	      IF ( arg1 .LE. arg2 ) THEN
	  	 res(1) = 1.0
	      ELSE
	  	 res(1) = op_repl
	      ENDIF
	   ENDIF
	   RETURN
	ENDIF
	
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)
           IF (is_inst_2) arg2 = com2(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)
              IF (is_obs_2) arg2 = com2(iobs)

              IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	         res(iobs) = bad_res
              ELSE
	         IF ( arg1 .LE. arg2 ) THEN
	  	    res(iobs) = 1.0
	         ELSE
	  	    res(iobs) = op_repl
	         ENDIF
              ENDIF

           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN


* "EQ" - mask of 1's where grids are equal, 0's elsewhere
* "EQ" - mask of 1's where grids are equal, bad elsewhere
 1200	CONTINUE

	IF (is_const_1 .AND. is_const_2) THEN  ! 2 constants may have been sent in
	   IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	      res(1) = bad_res
	   ELSE
	      IF ( arg1 .EQ. arg2 ) THEN
	  	 res(1) = 1.0
	      ELSE
	  	 res(1) = op_repl
	      ENDIF
	   ENDIF
	   RETURN
	ENDIF
	
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)
           IF (is_inst_2) arg2 = com2(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)
              IF (is_obs_2) arg2 = com2(iobs)

              IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	         res(iobs) = bad_res
              ELSE
	         IF ( arg1 .EQ. arg2 ) THEN
	  	    res(iobs) = 1.0
	         ELSE
	  	    res(iobs) = op_repl
	         ENDIF
              ENDIF

           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN


* "NE" - mask of 1's where grids are not equal, 0's elsewhere
 1300	CONTINUE

	IF (is_const_1 .AND. is_const_2) THEN  ! 2 constants may have been sent in
	   IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	      res(1) = bad_res
	   ELSE
	      IF ( arg1 .NE. arg2 ) THEN
	  	 res(1) = 1.0
	      ELSE
	  	 res(1) = op_repl
	      ENDIF
	   ENDIF
	   RETURN
	ENDIF
	
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)
           IF (is_inst_2) arg2 = com2(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)
              IF (is_obs_2) arg2 = com2(iobs)

              IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	         res(iobs) = bad_res
              ELSE
	         IF ( arg1 .NE. arg2 ) THEN
	  	    res(iobs) = 1.0
	         ELSE
	  	    res(iobs) = op_repl
	         ENDIF
              ENDIF

           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN


 1400	CONTINUE
 1500	CONTINUE
 1600	CONTINUE
 1700	CONTINUE
 1800	CONTINUE
	STOP 'OPERATOR NOT IMPLEMENTED'
* -----------------------------------------------------------------------------
* -------- FUNCTIONS ------------



* "EXP" - exponential function (single argument)
 1900	CONTINUE

	IF (is_const_1) THEN  
	   IF (arg1.EQ.bad1 ) THEN
	      res(1) = bad_res
	   ELSE
	      res(1) = EXP(arg1)
	   ENDIF
	   RETURN
	ENDIF

	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance argument
           IF (is_inst_1) arg1 = com1(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)

	      IF ( arg1 .EQ. bad1 ) THEN
	        res(iobs) = bad_res
	      ELSE
	        res(iobs) =  EXP(arg1)
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN


* "LOG"  (single argument)
 2000	CONTINUE

	IF (is_const_1) THEN  
	   IF (arg1.EQ.bad1 .OR. arg1.LE.0.0 ) THEN
	      res(1) = bad_res
	   ELSE
	      res(1) = LOG10(arg1)
	   ENDIF
	   RETURN
	ENDIF

	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance argument
           IF (is_inst_1) arg1 = com1(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)

	      IF ( arg1.EQ.bad1 .OR. arg1.LE.0.0 ) THEN
	        res(iobs) = bad_res
	      ELSE
	        res(iobs) =  LOG10(arg1)
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN

* "MAX" 2 arguments
 2100	CONTINUE

	IF (is_const_1 .AND. is_const_2) THEN  ! 2 constants may have been sent in
	   IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	      res(1) = bad_res
	   ELSE
	      res(1) = MAX( arg1, arg2 )
	   ENDIF
	   RETURN
	ENDIF
	
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)
           IF (is_inst_2) arg2 = com2(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)
              IF (is_obs_2) arg2 = com2(iobs)

	      IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2 ) THEN
	        res(iobs) = bad_res
	      ELSE
	        res(iobs) = MAX(arg1, arg2)
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN

* "MIN" 2 arguments
 2200	CONTINUE

	IF (is_const_1 .AND. is_const_2) THEN  ! 2 constants may have been sent in
	   IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	      res(1) = bad_res
	   ELSE
	      res(1) = MIN( arg1, arg2 )
	   ENDIF
	   RETURN
	ENDIF
	
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)
           IF (is_inst_2) arg2 = com2(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)
              IF (is_obs_2) arg2 = com2(iobs)

	      IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2 ) THEN
	        res(iobs) = bad_res
	      ELSE
	        res(iobs) = MIN(arg1, arg2)
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN


* "INT"  (single argument)
 2300	CONTINUE

	IF (is_const_1) THEN  
	   IF (arg1 .EQ. bad1 ) THEN
	      res(1) = bad_res
	   ELSE
	      res(1) = INT(arg1)
	   ENDIF
	   RETURN
	ENDIF

	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance argument
           IF (is_inst_1) arg1 = com1(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)

	      IF ( arg1.EQ.bad1 .OR. arg2.EQ.bad2 ) THEN
	        res(iobs) = bad_res
	      ELSE
	        res(iobs) =  INT(arg1)
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN


* "ABS"  (single argument)
 2400	CONTINUE

	IF (is_const_1) THEN  
	   IF (arg1 .EQ. bad1 ) THEN
	      res(1) = bad_res
	   ELSE
	      res(1) = ABS(arg1)
	   ENDIF
	   RETURN
	ENDIF

	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance argument
           IF (is_inst_1) arg1 = com1(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)

	      IF ( arg1.EQ.bad1 .OR. arg2.EQ.bad2 ) THEN
	        res(iobs) = bad_res
	      ELSE
	        res(iobs) =  ABS(arg1)
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN


* "SIN"  (single argument)
 2500	CONTINUE

	IF (is_const_1) THEN  
	   IF (arg1 .EQ. bad1 ) THEN
	      res(1) = bad_res
	   ELSE
	      res(1) = SIN(arg1)
	   ENDIF
	   RETURN
	ENDIF

	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance argument
           IF (is_inst_1) arg1 = com1(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)

	      IF ( arg1.EQ.bad1 .OR. arg2.EQ.bad2 ) THEN
	        res(iobs) = bad_res
	      ELSE
	        res(iobs) =  SIN(arg1)
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN

* "COS"  (single argument)
 2600	CONTINUE

	IF (is_const_1) THEN  
	   IF (arg1 .EQ. bad1 ) THEN
	      res(1) = bad_res
	   ELSE
	      res(1) = COS(arg1)
	   ENDIF
	   RETURN
	ENDIF

	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance argument
           IF (is_inst_1) arg1 = com1(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)

	      IF ( arg1.EQ.bad1 .OR. arg2.EQ.bad2 ) THEN
	        res(iobs) = bad_res
	      ELSE
	        res(iobs) =  COS(arg1)
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN

* "TAN"  (single argument)
 2700	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance argument
           IF (is_inst_1) arg1 = com1(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)

	      IF ( arg1.EQ.bad1 .OR. arg2.EQ.bad2 ) THEN
	        res(iobs) = bad_res
	      ELSE
	        res(iobs) =  TAN(arg1)
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN


* "LN"  (single argument)
 2800	CONTINUE 

	IF (is_const_1) THEN  
	   IF (arg1.EQ.bad1 .OR. arg1.LE.0.0 ) THEN
	      res(1) = bad_res
	   ELSE
	      res(1) = LOG(arg1)
	   ENDIF
	   RETURN
	ENDIF

	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance argument
           IF (is_inst_1) arg1 = com1(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)

	      IF ( arg1.EQ.bad1 .OR. arg2.EQ.bad2 ) THEN
	        res(iobs) = bad_res
	      ELSE
	        res(iobs) =  LOG(arg1)
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN

* "MOD"  2 argument
 2900	CONTINUE

	IF (is_const_1 .AND. is_const_2) THEN  ! 2 constants may have been sent in
	   IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	      res(1) = bad_res
	   ELSE
	      res(1) = MOD( arg1, arg2 )
	   ENDIF
	   RETURN
	ENDIF
	
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)
           IF (is_inst_2) arg2 = com2(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)
              IF (is_obs_2) arg2 = com2(iobs)

	      IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2 ) THEN
	        res(iobs) = bad_res
	      ELSE
	        res(iobs) = MOD(arg1, arg2)
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN

* "MISSING" - replace missing value flag with values in grid 2
 3000	CONTINUE

	IF (is_const_1 .AND. is_const_2) THEN  ! 2 constants may have been sent in
	   IF (arg1 .NE. bad1 ) THEN
	      res(1) = arg1
	   ELSEIF (arg2 .NE. bad2) THEN 
	      res(1) = arg1
	   ELSE
	      res(1) = bad_res
	   ENDIF
	   RETURN
	ENDIF
	
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)
           IF (is_inst_2) arg2 = com2(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)
              IF (is_obs_2) arg2 = com2(iobs)

              IF (arg1 .NE. bad1 ) THEN
	         res(iobs) = arg1
              ELSEIF (arg2 .NE. bad2) THEN 
	         res(iobs) = arg1
              ELSE
	         res(iobs) = bad_res
              ENDIF
           ENDDO

           base = base + flen
        ENDDO
	base = 0
	RETURN

* "IGNORE0" - replace zeros with bad flags  (single argument)
 3100	CONTINUE

	IF (is_const_1) THEN  
	   IF (arg1.EQ.bad1 .OR. arg1.EQ.0.) THEN
	      res(1) = bad_res
	   ELSE
	      res(1) = arg1
	   ENDIF
	   RETURN
	ENDIF

	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance argument
           IF (is_inst_1) arg1 = com1(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)

	      IF (arg1.EQ.bad1 .OR. arg1.EQ.0.) THEN
	         res(iobs) = bad_res
	      ELSE
	         res(iobs) = arg1
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN

* "ATAN"  (single argument)
 3200	CONTINUE

	IF (is_const_1) THEN  
	   IF (arg1.EQ.bad1) THEN
	      res(1) = bad_res
	   ELSE
	      res(1) = ATAN(arg1)
	   ENDIF
	   RETURN
	ENDIF

	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance argument
           IF (is_inst_1) arg1 = com1(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)

	      IF (arg1.EQ.bad1) THEN
	         res(iobs) = bad_res
	      ELSE
	         res(iobs) = ATAN(arg1)
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN


* "ATAN2" - 2 argument arc tangent
 3300	CONTINUE

	IF (is_const_1 .AND. is_const_2) THEN  ! 2 constants may have been sent in
	   IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2 ) THEN
	      res(1) = bad_res
	   ELSEIF (arg1.EQ.0. .AND. arg2.EQ.0. ) THEN 
	      res(1) = bad_res
	   ELSE
	      res(1) = ATAN2 (arg1, arg2)
	   ENDIF
	   RETURN
	ENDIF
	
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)
           IF (is_inst_2) arg2 = com2(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)
              IF (is_obs_2) arg2 = com2(iobs)
	      
	      IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2 ) THEN
	         res(iobs) = bad_res
	      ELSEIF (arg1.EQ.0. .AND. arg2.EQ.0. ) THEN 
	         res(iobs) = bad_res
	      ELSE
	         res(iobs) = ATAN2 (arg1, arg2)
	      ENDIF
	   ENDDO

           base = base + flen
        ENDDO
	base = 0
	RETURN


* "ASIN"  (single argument)
 3400	CONTINUE

	IF (is_const_1) THEN  
	   IF (arg1.EQ.bad1) THEN
	      res(1) = bad_res
	   ELSE
	      res(1) = ASIN(arg1)
	   ENDIF
	   RETURN
	ENDIF

	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance argument
           IF (is_inst_1) arg1 = com1(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)

	      IF (arg1.EQ.bad1) THEN
	         res(iobs) = bad_res
	      ELSE
	         res(iobs) = ASIN(arg1)
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN


* "ACOS"
 3500	CONTINUE

	IF (is_const_1) THEN  
	   IF (arg1.EQ.bad1) THEN
	      res(1) = bad_res
	   ELSE
	      res(1) = ACOS(arg1)
	   ENDIF
	   RETURN
	ENDIF

	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance argument
           IF (is_inst_1) arg1 = com1(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)

	      IF (arg1.EQ.bad1) THEN
	         res(iobs) = bad_res
	      ELSE
	         res(iobs) = ACOS(arg1)
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN

* "RANDU" - random uniform  (single argument)
* use the first value as the seed
 3600	CONTINUE

	first = .TRUE.
	IF (is_const_1) THEN  
	   IF (arg1.EQ.bad1) THEN
	      res(1) = bad_res
	   ELSE
	      R_IN = REAL(arg1)
	      res(1) = RANDU( R_IN )
	   ENDIF
	   RETURN
	ENDIF

	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance argument
           IF (is_inst_1 .AND. first) arg1 = com1(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1 .AND. first) arg1 = com1(iobs)

	      IF (arg1.EQ.bad1) THEN
	         res(iobs) = bad_res
	      ELSEIF ( first ) THEN
	         R_IN = REAL(arg1)
		 res(iobs) = RANDU( R_IN )
		 first = .FALSE.
	      ELSE
	         R_IN = 0.
		 res(iobs) = RANDU( R_IN )
	      ENDIF

           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN

* "RANDN" - random normal  (single argument)
* use the first value as the seed
 3700	CONTINUE

	first = .TRUE.
	IF (is_const_1) THEN  
	   IF (arg1.EQ.bad1) THEN
	      res(1) = bad_res
	   ELSE
	      R_IN = REAL(arg1) 
	      res(1) = RANDN( R_IN )
	   ENDIF
	   RETURN
	ENDIF

	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance argument
           IF (is_inst_1 .AND. first) arg1 = com1(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1 .AND. first) arg1 = com1(iobs)

	      IF (arg1.EQ.bad1) THEN
	         res(iobs) = bad_res
	      ELSEIF ( first ) THEN
	         R_IN = REAL(arg1)
		 res(iobs) = RANDN( R_IN )
		 first = .FALSE.
	      ELSE
	         R_IN = 0.
		 res(iobs) = RANDN( R_IN )
	      ENDIF

           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN

* "RHO" - UNESCO equation of state:
* rho = rho(salinity, temperature, pressure)
* three components - each may be a different XYZT shape
 3800	CONTINUE

	IF (is_const_1 .AND. is_const_2 .AND. is_const_3) THEN  ! all constants may have been sent in
	   IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	      res(1) = bad_res
	   ELSE
	      res(1) = RHO_UNESCO( arg1, arg2, arg3 )
	   ENDIF
	   RETURN
	ENDIF
	
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)
           IF (is_inst_2) arg2 = com2(ifeature)
           IF (is_inst_3) arg3 = com3(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)
              IF (is_obs_2) arg2 = com2(iobs)
              IF (is_obs_3) arg3 = com3(iobs)

	      IF ( arg1.EQ.bad1 .OR. arg2.EQ.bad2  .OR. arg3.EQ.bad3) THEN
	        res(iobs) = bad_res
	      ELSE
	        res(iobs) = RHO_UNESCO( arg1, arg2, arg3 )
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN

* "THETA" - potential temperature from BRYDEN,H.,1973,DEEP-SEA RES
*           and FOFONOFF,N,M,1977,DEEP-SEA RES
* theta = theta(salinity, temperature, pressure,reference_pressure)
* three components - each may be a different XYZT shape
 3900	CONTINUE

	IF (is_const_1 .AND. is_const_2 .AND. is_const_3 .AND. is_const_4) THEN  ! all constants?
	   IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	      res(1) = bad_res
	   ELSE
	      res(1) = THETA_FOFF( arg1, arg2, arg3, arg4)
	   ENDIF
	   RETURN
	ENDIF
	
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)
           IF (is_inst_2) arg2 = com2(ifeature)
           IF (is_inst_3) arg3 = com3(ifeature)
           IF (is_inst_4) arg4 = com4(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)
              IF (is_obs_2) arg2 = com2(iobs)
              IF (is_obs_3) arg3 = com3(iobs)
              IF (is_obs_4) arg4 = com4(iobs)

	      IF ( arg1.EQ.bad1 .OR. arg2.EQ.bad2 .OR.
     .             arg3.EQ.bad3 .OR. arg4.EQ.bad4) THEN
	        res(iobs) = bad_res
	      ELSE
	        res(iobs) = THETA_FOFF( arg1, arg2, arg3, arg4)
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN


* "DAYS1900(year, month, day)" - number of days since 1900
* three components - each may be a different XYZT shape
* *** note: returns days since 1-jan-1900, on the STANDARD CALENDAR

 4000	CONTINUE

	IF (is_const_1 .AND. is_const_2 .AND. is_const_3) THEN  ! all constants?
	   IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2 .OR. arg3.EQ.bad3 .OR.
     .         arg2.LT.1 .OR. arg2.GT.12 .OR. arg3.LT.0) THEN
	      res(1) = bad_res
	   ELSE
	      res(1) = DAYS_FROM_DAY0( pdays_by_1900, arg1, arg2, arg3, dummy)
	   ENDIF
	   RETURN
	ENDIF
	
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)
           IF (is_inst_2) arg2 = com2(ifeature)
           IF (is_inst_3) arg3 = com3(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)
              IF (is_obs_2) arg2 = com2(iobs)
              IF (is_obs_3) arg3 = com3(iobs)


	      IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2 .OR. arg3.EQ.bad3 .OR.
     .            arg2.LT.1 .OR. arg2.GT.12 .OR. arg3.LT.0) THEN
	         res(iobs) = bad_res
	      ELSE
	         res(iobs) = DAYS_FROM_DAY0( pdays_by_1900, arg1,
     .                        arg2, arg3, dummy)
	      ENDIF


           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN

* "RANDU2" - random uniform 
* Call the gfortran RANDOM_SEED and RANDOM_SEED functions.
* See ticket 1886 for discussions of RANDU
*
* iseed = 0   use previous seed - don't reinitialize
* iseed = -1 initialize using system clock
* iseed = integer > 0 initialize using that integer: results will be repeatable

 4100	CONTINUE

	IF (.NOT. is_const_2) THEN
	   RETURN  ! shouldn't get here
	ENDIF

	inseed = INT(arg2)
	IF (inseed.LT.0 .AND. inseed.NE.-1) inseed = -1
	CALL INIT_RANDOM_SEED(inseed)

	IF (is_const_1 .AND. is_const_2) THEN  ! 2 constants may have been sent in
	   IF ( arg1.EQ.bad1 ) THEN
	      res(1) = bad_res
	   ELSE
	      CALL RANDOM_NUMBER( res(1) )
	   ENDIF
	   RETURN
	ENDIF
	
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)

	      IF ( arg1.EQ.bad1 ) THEN
	         res(iobs) = bad_res
	      ELSE
	         CALL RANDOM_NUMBER( res(iobs) )
	      ENDIF
	   
           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN


* "RANDN2" - random normal using gfortran RANDOM_SEED and RANDOM_SEED functions.
* seed set as for RANDU2
 4200	CONTINUE

	IF (.NOT. is_const_2) THEN
	   RETURN  ! shouldn't get here
	ENDIF

	inseed = INT(arg2)
	first = .TRUE.

	IF (is_const_1 .AND. is_const_2) THEN  ! 2 constants may have been sent in
	   IF ( arg1.EQ.bad1 ) THEN
	      res(1) = bad_res
	   ELSE
	      res(1) = RANDN2 (arg1 )
	   ENDIF
	   RETURN
	ENDIF
	
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)

              IF ( arg1 .EQ. bad1 ) THEN
                 res(iobs) = bad_res
              ELSEIF ( first ) THEN
                 res(iobs) = RANDN2( inseed )
                 first = .FALSE.
              ELSE
                 res(iobs) = RANDN2(0)
              ENDIF
           ENDDO

           base = base + flen
        ENDDO
	base = 0
	RETURN


 4300	CONTINUE
	STOP 'FUNCTION NOT IMPLEMENTED'

* ----------------------------------------------------------------------------
* ------- LOGIC STRUCTURES -------------
*
 4400	CONTINUE

* "THEN" - comes from IF (condition) THEN (choice)   ... no "ELSE" given
* component 1 is the condition.  component 2 is the choice
 4500    base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)
           IF (is_inst_2) arg2 = com2(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)
              IF (is_obs_2) arg2 = com2(iobs)

	      IF ( arg1 .NE. bad1
     .       .AND. arg1 .NE. 0.0
     .       .AND. arg2 .NE. bad2 ) THEN
	        res(iobs) = arg2
	      ELSE
	        res(iobs) = bad_res
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	RETURN

* "ELSE" - comes from IF (condition) THEN (choice1) ELSE (choice2)
* component 1 is the condition.  components 2 and 3 are the choices
 4600    base = 0    ! obs index at end of preceding feature
* ... loop over the features
        DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)
           IF (is_inst_2) arg2 = com2(ifeature)
           IF (is_inst_3) arg3 = com3(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)
              IF (is_obs_2) arg2 = com2(iobs)
              IF (is_obs_3) arg3 = com3(iobs)

	      IF ( arg1 .NE. bad1 .AND. arg1 .NE. 0.0 ) THEN
	         IF ( arg2 .NE. bad2 ) THEN
	            res(iobs) = arg2
	         ELSE
	            res(iobs) = bad_res
	         ENDIF
	      ELSE
	         IF ( arg3 .NE. bad3 ) THEN
	            res(iobs) = arg3
	         ELSE
	            res(iobs) = bad_res
	         ENDIF
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	RETURN

* "THEN" - comes from IFV (condition) THEN (choice)   ... no "ELSE" given
* component 1 is the condition.  component 2 is the choice
 4700	CONTINUE

	IF (is_const_1 .AND. is_const_2) THEN  ! all constants?
	   IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	      res(1) = bad_res
	   ELSE
	      res(1) = arg2
	   ENDIF
	   RETURN
	ENDIF
	
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)
           IF (is_inst_2) arg2 = com2(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)
              IF (is_obs_2) arg2 = com2(iobs)

	      IF (arg1.EQ.bad1 .OR. arg2.EQ.bad2) THEN
	         res(iobs) = bad_res
	      ELSE
	         res(iobs) = arg2
	      ENDIF


           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN


* "ELSE" - comes from IFV (condition) THEN (choice1) ELSE (choice2)
* component 1 is the condition.  components 2 and 3 are the choices
 4800	CONTINUE

	IF (is_const_1 .AND. is_const_2 .AND. is_const_3) THEN  ! all constants?
	   IF (arg1 .NE. bad1) THEN
	      IF (arg2 .NE. bad2) THEN
	         res(1) = arg2
	      ELSE
	         res(1) = bad_res
	      ENDIF
	   ELSE
	      IF (arg3 .NE. bad3) THEN
	         res(1) = arg3
	      ELSE
	         res(1) = bad_res
	      ENDIF
	   ENDIF
	   RETURN
	ENDIF
	
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 

           IF (is_obs_res) THEN
	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
           ELSE
              flen = 1  ! inner loop has no meaning for instance result
           ENDIF

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) THEN
              base = base + flen
              CYCLE
           ENDIF

* ... set the instance arguments
           IF (is_inst_1) arg1 = com1(ifeature)
           IF (is_inst_2) arg2 = com2(ifeature)
           IF (is_inst_3) arg3 = com3(ifeature)

           iobs = base

* ... loop over the observations within each feature
	   DO i = 1, flen
	      iobs = iobs + 1   ! index in the contig ragged array

* ... set the obs arguments
              IF (is_obs_1) arg1 = com1(iobs)
              IF (is_obs_2) arg2 = com2(iobs)
              IF (is_obs_3) arg3 = com3(iobs)

              IF (arg1 .NE. bad1) THEN
	         IF (arg2 .NE. bad2) THEN
	            res(iobs) = arg2
	         ELSE
	            res(iobs) = bad_res
	         ENDIF
	      ELSE
	         IF (arg3 .NE. bad3) THEN
	            res(iobs) = arg3
	         ELSE
	            res(iobs) = bad_res
	         ENDIF
	      ENDIF
           ENDDO
           base = base + flen
        ENDDO
	base = 0
	RETURN

* error exits
! 9000	RETURN
	END

      REAL FUNCTION RANDN2(jd)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute a quasi-random number with a standard normal distribution
* based on the routine "GASDEV" on p.203 of Numerical Recipes
* W.H.Press,B.P.Flannery,S.A.Teukolsky,W.T.Vetterling

* uses routine RANDU to supply normal deviates

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V200:  3/29/90
* 9/2011
* Our old RANDU function could return 1. See ticket 1886
* Replace calls to RANDU w/ gfortran RANDOM_SEED and RANDOM_NUMBER


* calling argument declarations:
	INTEGER	jd

* internal variable declarations:
	LOGICAL saved
	REAL	r1, r2, v1, v2, r, fac, rsave

* initialize the uniform and this random generator
	IF ( jd.NE.0 ) THEN
	   CALL INIT_RANDOM_SEED(jd)
	   saved = .FALSE.
	ENDIF

	IF ( saved ) THEN
* ... use the one saved last time
	   RANDN2 = rsave
	   saved = .FALSE.

	ELSE
* ... compute 2 normal from 2 uniforms, return 1, save 1
 10	   CALL RANDOM_NUMBER(r1)
	   CALL RANDOM_NUMBER(r2)
	   v1 = 2. * r1 - 1.
	   v2 = 2. * r2 - 1.
	   r  = v1**2 + v2**2
	   IF ( r .GE. 1 ) GOTO 10	! not inside unit circle ?
	   fac = SQRT(-2.*LOG(r)/r)	   
	   rsave = v1*fac
	   RANDN2 = v2*fac
	   saved = .TRUE.

	ENDIF

	RETURN
	END

*
*  tracks2grid_var_xyt.F
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* October 2010 from tracks2grid_ave_xyt.F
*
* This is the description of the averaging function.
* The input data points are not a simple scatter.  They are cruise tracks 
* strung one after another.  (Each track will be a contiguous block of points 
* in the input data arrays.)  And the subtlety is that each cruise needs to 
* receive the same weight when determining the average for a cell, rather than 
* each individual data point.  Which means effectively that you need to have 
* two averaging processes.  You need to have a buffer (the individual cruise 
* buffer) that is the size and shape of the output grid in which you average 
* each individual cruise.  And then when the final point of each cruise from 
* the input data is encountered, you need to add (average) the points from the 
* individual cruise buffer into the output buffer, re-zeroing the individual 
* cruise buffer as you do so, so it is ready to average the next cruise. 
*
* This function will return the variance for the averages, based on weighted means,
* for small samples, http://wapedia.mobi/en/Weighted_mean#7.
* 
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE  tracks2grid_var_xyt_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CHARACTER*126 buff
      WRITE (buff, 10)
   10 FORMAT ('Weighted variance by cruise, when gridding scattered ',
     .        'data to XYT grid. K=2, average cell span, cruises in cell')
      CALL ef_set_desc(id, buff)

      CALL ef_set_num_args(id, 8)
c      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS,
c     .        IMPLIED_BY_ARGS, ABSTRACT, IMPLIED_BY_ARGS)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS,
     .        IMPLIED_BY_ARGS, NORMAL, IMPLIED_BY_ARGS)

      CALL ef_set_num_work_arrays(id, 9)

* Output grid is determined by arguments 4, 5, 6, the result's x, y, t axes. 

      arg = 1
      CALL ef_set_arg_name(id, arg, 'VAR')
      CALL ef_set_arg_desc(id, arg, 'Variable at scattered input XYT.')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'XPTS')
      CALL ef_set_arg_desc(id, arg, 
     .     'X coordinates of scattered input triples')

      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'YPTS')
      CALL ef_set_arg_desc(id, arg, 
     .     'Y coordinates of scattered input triples')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'TPTS')
      CALL ef_set_arg_desc(id, arg, 
     .     'T coordinates of scattered input triples')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'ICRUISE')
      CALL ef_set_arg_desc(id, arg, 
     .     'Cruise ID at scattered input locations')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 6
      CALL ef_set_arg_name(id, arg, 'XAXPTS')
      CALL ef_set_arg_desc(id, arg, 
     .                   'X axis coordinates of a regular output grid')
      CALL ef_set_axis_influence(id, arg, YES, NO, NO, NO)

      arg = 7
      CALL ef_set_arg_name(id, arg, 'YAXPTS')
      CALL ef_set_arg_desc(id, arg, 
     .                   'Y axis coordinates of a regular output grid')
      CALL ef_set_axis_influence(id, arg, NO, YES, NO, NO)

      arg = 8
      CALL ef_set_arg_name(id, arg, 'TAXPTS')
      WRITE (buff, 20)
   20 FORMAT ('T axis coordinates, of a regular output grid, with same ',
     .       'units and origin as tpts')
      CALL ef_set_arg_desc(id, arg, buff)
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, YES)



*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN 
      END

c*
c* In this subroutine we provide information about the lo and hi
c* limits associated with each abstract or custom axis.   The user 
c* configurable information consists of the following:
c*
c* lo_ss               lo subscript for an axis
c*
c* hi_ss               hi subscript for an axis
c*
c
c      SUBROUTINE tracks2grid_var_xyt_result_limits(id)
c
c      INCLUDE 'ferret_cmn/EF_Util.cmn'
c      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'
c
c      INTEGER id
c
c* **********************************************************************
c*                                           USER CONFIGURABLE PORTION |
c*                                                                     |
c*                                                                     V
c
c
c      CALL ef_set_axis_limits(id, Z_AXIS, 1, 2)
c*                                                                     ^
c*                                                                     |
c*                                           USER CONFIGURABLE PORTION |
c* **********************************************************************
c
c      RETURN 
c      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE tracks2grid_var_xyt_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
* 
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_dims(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER nxout, nyout, ntout, nx2, ny2, nt2
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nxout = 1 + arg_hi_ss(X_AXIS,ARG6) - arg_lo_ss(X_AXIS,ARG6)
      nyout = 1 + arg_hi_ss(Y_AXIS,ARG7) - arg_lo_ss(Y_AXIS,ARG7)
      ntout = 1 + arg_hi_ss(T_AXIS,ARG8) - arg_lo_ss(T_AXIS,ARG8)

      nx2 = nxout* 2
      ny2 = nyout* 2
      nt2 = ntout* 2

* xax  output x axis
      CALL ef_set_work_array_dims (id, 1, 1, 1, 1, 1, nx2, 1, 1, 1)

* yax  output y axis
      CALL ef_set_work_array_dims (id, 2, 1, 1, 1, 1, ny2, 1, 1, 1)

* Tax  output t axis
      CALL ef_set_work_array_dims (id, 3, 1, 1, 1, 1, nt2, 1, 1, 1)

* obs_cruise  work array - sum and counts of observations per cruise
* x,y,t direction: output grid
* z direction: 1..2
      CALL ef_set_work_array_dims (id, 4, 1, 1, 1, 1, 
     .                             nxout, nyout, 2, ntout)

* cell_avg  work array - work array - sum and counts over cruises for cell average
* x,y,t direction: output grid
* z direction: 1..2
      CALL ef_set_work_array_dims (id, 5, 1, 1, 1, 1, 
     .                             nxout, nyout, 2, ntout)

* wi_sums k=1, sum of weights wi = sum of obs in the cells
* x,y,t direction: output grid
* z direction: 1
      CALL ef_set_work_array_dims (id, 6, 1, 1, 1, 1, 
     .                             nxout, nyout, 1, ntout)

* cruisespan getting the min and max lon/lat for computing
* the span of a cruise in each cell. 
      CALL ef_set_work_array_dims (id, 7, 1, 1, 1, 1, 
     .                             nxout, nyout, 4, ntout)

* cruisemean saving individual weighted cruise means. 
* for computing s^2  sum of wi*(xi - weighted_mean)**2
* x,y,t direction: output grid
* z direction: 30 (max cruises per cell?)
      CALL ef_set_work_array_dims (id, 8, 1, 1, 1, 1, 
     .                             nxout, nyout, 30, ntout)

* span
* for arc length for cruises in grid cell.
* x,y,t direction: output grid
* z direction: 30 (max cruises per cell?)
      CALL ef_set_work_array_dims (id, 9, 1, 1, 1, 1, 
     .                             nxout, nyout, 30, ntout)

      RETURN
      END

*
* In this subroutine we compute the result
*

      SUBROUTINE tracks2grid_var_xyt_compute(id, arg_1, arg_2, arg_3, 
     .     arg_4, arg_5, arg_6, arg_7, arg_8, result, xax, yax, tax, 
     .     obs_cruise, cell_avg, wi_sums, cruisespan, cruisemean, span)

*  arg_1  var
*  arg_2  xpts  \
*  arg_3  ypts   | Scattered x,y triples to be gridded.
*  arg_4  tpts  / 
*  arg_5  icruise
*
*  arg_6  xaxis of new grid   
*  arg_7  yaxis of new grid
*  arg_8  taxis of new grid

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .     mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, 
     .     mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, 
     .     mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, 
     .     mem4loz:mem4hiz, mem4lot:mem4hit)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, 
     .     mem5loz:mem5hiz, mem5lot:mem5hit)
      REAL arg_6(mem6lox:mem6hix, mem6loy:mem6hiy, 
     .     mem6loz:mem6hiz, mem6lot:mem6hit)
      REAL arg_7(mem7lox:mem7hix, mem7loy:mem7hiy, 
     .     mem7loz:mem7hiz, mem7lot:mem7hit)
      REAL arg_8(mem8lox:mem8hix, mem8loy:mem8hiy, 
     .     mem8loz:mem8hiz, mem8lot:mem8hit)
      REAL arg_9(mem9lox:mem9hix, mem9loy:mem9hiy, 
     .     mem9loz:mem9hiz, mem9lot:mem9hit)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      INTEGER i, j, k, l, m, n
      INTEGER i6,j7,L8,i6n,j7n,L8n

      INTEGER nxpts, npts
      INTEGER nx, ny, nt
      INTEGER i1, i2, i1n, i2n
      INTEGER obs_only, icruise, ncc, nc_cell, nk

      REAL x1, y1, t1, xf, yf, tf
      REAL xx, yy, tt, vv


      REAL dx, dy, xxbeg, xxend, yybeg, yyend
      REAL spansq, cellspan, cellmean, wt_cruise_mean, unwtd_mean,
     .     wsumsq_ijl, wsumsq, diffsum

      REAL*8 xax1,xaxf, yax1,yaxf, tax1,taxf
      INTEGER indx(4,2)

*  Dimension the work arrays

      REAL*8 xax(wrk1lox:wrk1hix/2, wrk1loy:wrk1hiy,
     .               wrk1loz:wrk1hiz, wrk1lot:wrk1hit)
      REAL*8 yax(wrk2lox:wrk2hix/2, wrk2loy:wrk2hiy,
     .               wrk2loz:wrk2hiz, wrk2lot:wrk2hit)
      REAL*8 tax(wrk3lox:wrk3hix/2, wrk3loy:wrk3hiy,
     .               wrk3loz:wrk3hiz, wrk3lot:wrk3hit)
      REAL obs_cruise(wrk4lox:wrk4hix, wrk4loy:wrk4hiy,
     .               wrk4loz:wrk4hiz, wrk4lot:wrk4hit)
      REAL cell_avg(wrk5lox:wrk5hix, wrk5loy:wrk5hiy,
     .               wrk5loz:wrk5hiz, wrk5lot:wrk5hit)
      REAL wi_sums(wrk6lox:wrk6hix, wrk6loy:wrk6hiy,
     .               wrk6loz:wrk6hiz, wrk6lot:wrk6hit)
      REAL cruisespan(wrk7lox:wrk7hix, wrk7loy:wrk7hiy,
     .               wrk7loz:wrk7hiz, wrk7lot:wrk7hit)
      REAL cruisemean(wrk8lox:wrk8hix, wrk8loy:wrk8hiy,
     .               wrk8loz:wrk8hiz, wrk8lot:wrk8hit)
      REAL span(wrk9lox:wrk9hix, wrk9loy:wrk9hiy,
     .               wrk9loz:wrk9hiz, wrk9lot:wrk9hit)

      CHARACTER*250 errtxt

C  variables for checking axis characteristics (modulo axes)

      CHARACTER ax_name(4)*16, ax_units(4)*16
      LOGICAL backward(4), modulox(4), moduloy(4), modulot(4), regular(4)

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      obs_only = 0	! Compute the variance for average of variable (e.g. fco2)

*  Check to see if output axes are modulo

      CALL ef_get_axis_info (id, 6, ax_name, ax_units, backward, 
     .                       modulox, regular)
      CALL ef_get_axis_info (id, 7, ax_name, ax_units, backward, 
     .                       moduloy, regular)
      CALL ef_get_axis_info (id, 8, ax_name, ax_units, backward, 
     .                       modulot, regular)

*  Find number of points in scattered input points.  1-D arrays defining the 
*  scattered data points may lie on the X, Y, Z, or T axis of the input arguments.

      nxpts = 0

      DO 100 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG2) .GE. 1) THEN
            i1 = arg_lo_ss(m,ARG2)
            i1n = arg_hi_ss(m,ARG2)
            if (i1n-i1 .NE. 0) nxpts = 1 + (i1n - i1)
            IF (nxpts .EQ. 0) GOTO 900
         ENDIF
 100  CONTINUE

      npts = 1
      DO 110 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG1) .GE. 1) THEN
            i2 = arg_lo_ss(m,ARG1)
            i2n = arg_hi_ss(m,ARG1)
            npts = 1 + (i2n - i2)
            IF (npts.NE.nxpts) GOTO 900
         ENDIF
 110  CONTINUE

      DO 120 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG3) .GE. 1) THEN
            i2 = arg_lo_ss(m,ARG3)
            i2n = arg_hi_ss(m,ARG3)
            npts = 1 + (i2n - i2)
            IF (npts .NE. nxpts) GOTO 900
         ENDIF
 120  CONTINUE

      DO 130 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG4) .GE. 1) THEN
            i2 = arg_lo_ss(m,ARG4)
            i2n = arg_hi_ss(m,ARG4)
            npts = 1 + (i2n - i2)
            IF (npts .NE. nxpts) GOTO 900
         ENDIF
 130  CONTINUE

      DO 140 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG5) .GE. 1) THEN
            i2 = arg_lo_ss(m,ARG5)
            i2n = arg_hi_ss(m,ARG5)
            npts = 1 + (i2n - i2)
            IF (npts .NE. nxpts) GOTO 900
         ENDIF
 140  CONTINUE

      nscat = nxpts

*  Compute number of points in output axes.

      i6 = ef_unspecified_int4
      j7 = ef_unspecified_int4
      L8 = ef_unspecified_int4

      i6 = arg_lo_ss(X_AXIS,ARG6)
      i6n = arg_hi_ss(X_AXIS,ARG6)

      j7 = arg_lo_ss(Y_AXIS,ARG7)
      j7n = arg_hi_ss(Y_AXIS,ARG7)

      L8 = arg_lo_ss(T_AXIS,ARG8)
      L8n = arg_hi_ss(T_AXIS,ARG8)

      nx = 1 + (i6n - i6)
      ny = 1 + (j7n - j7)
      nt = 1 + (L8n - L8)

*  Check that xax is a X axis and yax a Y axis

      IF (i6 .EQ. ef_unspecified_int4) THEN
         WRITE (errtxt, *) 'Sixth argument must be a X axis'
         GO TO 999
      ENDIF
      IF (j7 .EQ. ef_unspecified_int4) THEN
         WRITE (errtxt, *) 'Seventh argument must be a Y axis'
         GO TO 999
      ENDIF
      IF (L8 .EQ. ef_unspecified_int4) THEN
         WRITE (errtxt, *) 'Eighth argument must be a T axis'
         GO TO 999
      ENDIF

C  Get coordinates of output axes.

      call ef_get_coordinates(id, ARG6, X_AXIS, 
     .   arg_lo_ss(X_AXIS, ARG6), arg_hi_ss(X_AXIS, ARG6), xax)

      call ef_get_coordinates(id, ARG7, Y_AXIS, 
     .   arg_lo_ss(Y_AXIS, ARG7), arg_hi_ss(Y_AXIS, ARG7), yax)

      call ef_get_coordinates(id, ARG8, T_AXIS, 
     .   arg_lo_ss(T_AXIS, ARG8), arg_hi_ss(T_AXIS, ARG8), tax)

*  Set start, end, and delta for output axes. 

      x1 = xax(1,1,1,1)
      y1 = yax(1,1,1,1)
      t1 = tax(1,1,1,1)

      xf = xax(nx,1,1,1)
      yf = yax(ny,1,1,1)
      tf = tax(nt,1,1,1)

*  Gridbox sizes in data units
      dx = xf - x1
      IF (nx .GT. 1) dx = (xf-x1)/ REAL(nx-1)
      dy = yf - y1
      IF (ny .GT. 1) dy = (yf-y1)/ REAL(ny-1) 
      dt = tf - t1
      IF (nt .GT. 1) dt = (tf-t1)/ REAL(nt-1) 

      IF (nx .EQ. 1) THEN 
         CALL ef_get_box_limits(id, ARG6, X_AXIS, 
     .   arg_lo_ss(X_AXIS, ARG6), arg_hi_ss(X_AXIS, ARG6), xax1,xaxf)
         dx = xaxf - xax1
      ENDIF
      IF (ny .EQ. 1) THEN 
         CALL ef_get_box_limits(id, ARG7, Y_AXIS, 
     .   arg_lo_ss(Y_AXIS, ARG7), arg_hi_ss(Y_AXIS, ARG7), yax1,yaxf)
         dy = yaxf - yax1
      ENDIF
         IF (nt .EQ. 1) THEN 
         CALL ef_get_box_limits(id, ARG8, T_AXIS, 
     .   arg_lo_ss(T_AXIS, ARG8), arg_hi_ss(T_AXIS, ARG8), tax1,taxf)
         tx = taxf - tax1
      ENDIF

*  Compute result

*  Initialize counts.

      DO L = 1, nt
      DO k = 1, 2
      DO j = 1, ny
      DO i = 1, nx
         cell_avg(i,j,k,L) = 0.
      ENDDO
      ENDDO
      ENDDO
      ENDDO

      DO L = 1, nt
      DO k = 1, 2
      DO j = 1, ny
      DO i = 1, nx
         obs_cruise(i,j,k,L) = 0.
      ENDDO
      ENDDO
      ENDDO
      ENDDO

      DO L = 1, nt
      DO k = 1, 1
      DO j = 1, ny
      DO i = 1, nx
         wi_sums(i,j,k,L) = 0.
      ENDDO
      ENDDO
      ENDDO
      ENDDO

      DO L = 1, nt
      DO k = 1, wrk8hiz
      DO j = 1, ny
      DO i = 1, nx
         cruisemean(i,j,k,L) = 0.
      ENDDO
      ENDDO
      ENDDO
      ENDDO

      DO L = 1, nt
      DO k = 1, wrk9hiz
      DO j = 1, ny
      DO i = 1, nx
         span(i,j,k,L) = 0.
      ENDDO
      ENDDO
      ENDDO
      ENDDO

      DO L = 1, nt
      DO j = 1, ny
      DO i = 1, nx
         cruisespan(i,j,1,L) =  1000
         cruisespan(i,j,2,L) = -1000.
         cruisespan(i,j,3,L) =  1000.
         cruisespan(i,j,4,L) = -1000.
      ENDDO
      ENDDO
      ENDDO

*  Loop over x and y, compute the number of observations for the gaussian-weighted 
*  mapping onto the grid.  Lat and longitude may be on the X,Y,Z or T axis of ARG1 
*  and ARG2, sending them to a subroutine collapses the extra dimensions so the
*  value can be found.

      n = 1
      CALL pickoutxytcv (obs_only, arg_1, arg_2, arg_3, arg_4, arg_5,
     .           n, vv, xx, yy, tt, ncc)
      icruise = ncc

* For each cruise keep track of the index range it spans in the result grid
* Then at the end of the cruise need only to process that subset of the grid.
      indx(1,1) = nx
      indx(1,2) = 1
      indx(2,1) = ny
      indx(2,2) = 1
      indx(4,1) = nt
      indx(4,2) = 1

      DO 300 n = 1, nscat

         CALL pickoutxytcv (obs_only, arg_1, arg_2, arg_3, arg_4, arg_5,
     .           n, vv, xx, yy, tt, ncc)
         IF (vv .EQ. bad_flag(ARG1) .OR. xx .EQ. bad_flag(ARG2) .OR. 
     .          yy .EQ. bad_flag(ARG3) .OR. tt .EQ. bad_flag(ARG4) ) GOTO 300

* We have come to the end of a cruise loop over cells represented by the last cruise,
* summing and counting the observations in the cruise, computing weights. 
* weights are span of cruise across cell
* cruisemean is weighted cruise mean in cell
* cell_avg(i,j,1,L) weighted cruise mean averaged over cruises in cell
* cell_avg(i,j,2,L) is count of cruises in cell
* wi_sums(i,j,1,L) sum of weights wi in cell

         IF (ncc .NE. icruise) THEN  
	    icend = n-1

            DO L = indx(4,1), indx(4,2)
            DO j = indx(2,1), indx(2,2)
            DO i = indx(1,1), indx(1,2)


	       IF (obs_cruise(i,j,2,L) .GT. 0.) THEN
                  spansq = (cruisespan(i,j,2,l)-cruisespan(i,j,1,l))**2 +
     .                     (cruisespan(i,j,4,l)-cruisespan(i,j,3,l))**2
                  cellspan = SQRT(spansq)

                  wt_cruise_mean = cellspan*
     .                obs_cruise(i,j,1,L)/obs_cruise(i,j,2,L)
                  unwtd_mean = obs_cruise(i,j,1,L)/obs_cruise(i,j,2,L)

                  cell_avg(i,j,1,L) = cell_avg(i,j,1,L) + wt_cruise_mean
                  cell_avg(i,j,2,L) = cell_avg(i,j,2,L) + 1.  

		  wi_sums(i,j,1,l) = wi_sums(i,j,1,l) + cellspan

		  nc_cell = cell_avg(i,j,2,L)
		  IF (nc_cell .GT. wrk8hiz) THEN
                     print *, 'Num_obs in cell at I,J,L = ', i,j,L, 
     .               ' is', nc_cell
		     CALL ef_bail_out (id,
     .      'too many cruises in cell. increase K size of work arrays 8,9')
		  ENDIF

		  cruisemean(i,j,nc_cell,l) = unwtd_mean
		  span(i,j,nc_cell,l) = cellspan

	       ENDIF


            ENDDO
            ENDDO
            ENDDO

	    icruise = ncc

            DO L = indx(4,1), indx(4,2)
            DO j = indx(2,1), indx(2,2)
            DO i = indx(1,1), indx(1,2)
	       obs_cruise(i,j,1,L) = 0.
	       obs_cruise(i,j,2,L) = 0.
            ENDDO
            ENDDO
            ENDDO

* reset indices
            indx(1,1) = nx
            indx(1,2) = 1
            indx(2,1) = ny
            indx(2,2) = 1
            indx(4,1) = nt
            indx(4,2) = 1

	 ENDIF

*  Count and add up observations in each cell, in this cruise. Span computes the arc
*  length of the current cruise.

         CALL nobsxytv_span (obs_only, xx, yy, tt, vv, nx, ny, nt, 
     .           x1, y1, t1, dx, dy, dt, xf, yf, tf, indx, obs_cruise,
     .           cruisespan)

 300  CONTINUE

* Get data from the last cruise

      icend = n-1

      DO L = indx(4,1), indx(4,2)
      DO j = indx(2,1), indx(2,2)
      DO i = indx(1,1), indx(1,2)

	       IF (obs_cruise(i,j,2,L) .GT. 0.) THEN
                  spansq = (cruisespan(i,j,2,l)-cruisespan(i,j,1,l))**2 +
     .                     (cruisespan(i,j,4,l)-cruisespan(i,j,3,l))**2
                  cellspan = SQRT(spansq)

                  wt_cruise_mean = cellspan*
     .                obs_cruise(i,j,1,L)/obs_cruise(i,j,2,L)
                  unwtd_mean = obs_cruise(i,j,1,L)/obs_cruise(i,j,2,L)

                  cell_avg(i,j,1,L) = cell_avg(i,j,1,L) + wt_cruise_mean
                  cell_avg(i,j,2,L) = cell_avg(i,j,2,L) + 1.  

		  wi_sums(i,j,1,l) = wi_sums(i,j,1,l) + cellspan

		  nc_cell = cell_avg(i,j,2,L)
		  IF (nc_cell .GT. wrk8hiz) THEN
                     print *, 'Num_obs in cell at I,J,L = ', i,j,L, 
     .               ' is', nc_cell
		     CALL ef_bail_out (id,
     .      'too many cruises in cell. increase K size of work arrays 8,9')
		  ENDIF

		  cruisemean(i,j,nc_cell,l) = unwtd_mean
		  span(i,j,nc_cell,l) = cellspan

	       ENDIF

      ENDDO
      ENDDO
      ENDDO
      
*  Put gridded fcn into result variable.
* wi_sums(i,j,1,L) sum of weights wi in cell
* V1 sum of weights
* V2 sum of weights squared
* for s^2  wsumsq sum of wi*(xi - weighted_mean)**2

      k = res_lo_ss(Z_AXIS)
      DO 420 L = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         DO 410 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            DO 400 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

               nc_cell = cell_avg(i,j,2,L)

               IF (nc_cell .EQ. 0) THEN
                   result(i,j,k,l) = bad_flag_result
c                   result(i,j,2,l) = bad_flag_result
               ELSE IF (nc_cell .EQ. 1) THEN
                   result(i,j,k,l) = 0.
c                   result(i,j,2,l) = span(i,j,1,L)

* Compute sum of (cruise-cell-averages - weighted cell mean) squared\

               ELSE IF (nc_cell .GT. 1) THEN

                  cellmean = cell_avg(i,j,1,L)/wi_sums(i,j,1,l)

                  wsumsq_ijl = 0.
                  wsumsq = 0.
		  v1 = 0.
                  DO 500, nk = 1, nc_cell
                      cellspan = span(i,j,nk,L)
		      unwtd_mean = cruisemean(i,j,nk,L)

		      spansq = cellspan*cellspan
		      wsumsq = wsumsq + spansq

* Sum the squares of difference of unweighted cruise means 
* minus weighted cell mean

		      diffsum = unwtd_mean - cellmean
                      wsumsq_ijl = wsumsq_ijl + cellspan*(diffsum)**2

 500              CONTINUE
                  V1 = wi_sums(i,j,1,l)
                  V2 = wsumsq
                  denom = V1*V1 - V2
		  
                  IF (ABS(denom) .GT. 1.e-6) THEN
                     result(i,j,k,l) = wsumsq_ijl* V1/denom
c                     IF (wsumsq .GT. 0.) result(i,j,2,l) = sqrt(wsumsq)
                  ELSE
                     result(i,j,k,l) = bad_flag_result
c                     result(i,j,2,l) = bad_flag_result
                  ENDIF
	       ENDIF

 400        CONTINUE

 410     CONTINUE
 420  CONTINUE

      RETURN

900   CONTINUE

      IF (nxpts .NE. npts) THEN
         WRITE (errtxt,20)
      ELSE IF (nxpts .EQ. 0) THEN
         WRITE (errtxt, 30)
      ENDIF
      GOTO 999 

 999  CALL EF_BAIL_OUT(id, errtxt)
      RETURN

   20 FORMAT 
     . ('Input scattered var,x,y,t,cruiseID have different # of points')

   30 FORMAT ('No data in scattered x,y,t points')


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      END

      SUBROUTINE pickoutxytcv (obs_only, vars, alon, alat, atimes,
     .   cruises, n, vv, xx, yy, tt, ncc)

*  Called from the scatter* family of gridding functions.
*  Pick out nth item from a set of arrays, which are really 
*  4-dimensioned arrays with normal axes on three of the four axes.

      REAL alon(*), alat(*), atimes(*), cruises(*), vars(*)
      REAL xx, yy, tt, vv
      INTEGER obs_only, n, ncc

      vv = 1.
      IF (obs_only .EQ. 0) vv = vars(n)
      xx = alon(n)
      yy = alat(n)
      tt = atimes(n)
      ncc = cruises(n)

      RETURN
      END



c***********************************************************************
c...NOBS.....Based on gausswt, return only the # of obs in (x,y) gridbox
c............method is to call this sub for each data value
c............all calcs done in gridbox units
c............xx/x1/xf all in same units
c............yy/y1/yf all in same units

c  i	xx,yy,tt=x/y/t location of data pt (data units)
c  i	nx,ny,nt=size of grids
c  i	x1,y1,L1=west/south/earliest edge of grid (center of 1st box in data units)
c  o 	obs_cruise(nx,ny,nt) number of obs in each (x,y,t) gridbox
c  o 	cellspan arc length for cruise in current xyt gridbox
c--------------------------------------------------------------------------

	SUBROUTINE nobsxytv_span (obs_only, xx, yy, tt, vv, nx, ny, nt, 
     .             x1, y1, t1, dx, dy, dt, xf, yf, tf, indx, obs_cruise,
     .             cruisespan)


* Argument declarations

        INTEGER nx, ny, nt, obs_only, indx(4,2)
	REAL xx, yy, tt, vv, x1, y1, t1, dx, dy, dt, xf, 
     .       yf, tf, obs_cruise(nx,ny,2,nt), cruisespan(nx,ny,4,nt)

* Local variable declarations

        REAL xxg, yyg, ttg
        INTEGER ig, jg, Lg

	xxg = (xx-x1)/ dx + 1.		  ! grid values of data location
	yyg = (yy-y1)/ dy + 1.
	ttg = (tt-t1)/ dt + 1.

c.................sum the value and count in each (x,y,t) gridbox
	ig = NINT(xxg)
	jg = NINT(yyg)
	Lg = NINT(ttg)
	IF (ig.LT.1 .OR. ig.GT.nx) RETURN
	IF (ig.LT.1 .OR. ig.GT.nx) RETURN
	IF (lg.LT.1 .OR. lg.GT.nt) RETURN


	IF (obs_only .EQ. 0) THEN
           IF (ig.GE.1 .AND. ig.LE.nx .AND. jg.GE.1 .AND. jg.LE.ny .AND.
     .       Lg.GE.1 .AND. Lg.LE.nt   ) THEN
     		obs_cruise(ig,jg,1,Lg) = obs_cruise(ig,jg,1,Lg) + vv
     		obs_cruise(ig,jg,2,Lg) = obs_cruise(ig,jg,2,Lg) + 1.
	   ENDIF
	ELSE
	   IF (ig.GE.1 .AND. ig.LE.nx .AND. jg.GE.1 .AND. jg.LE.ny .AND.
     .      Lg.GE.1 .AND. Lg.LE.nt   ) THEN
     		obs_cruise(ig,jg,1,Lg) = obs_cruise(ig,jg,1,Lg) + 1.
	   ENDIF
	ENDIF

* Keep the min and max lon and lat, to use in computing the span of the
* cruise in this grid cell.
	IF (ig.GE.1 .AND. ig.LE.nx .AND. jg.GE.1 .AND. jg.LE.ny .AND.
     .       Lg.GE.1 .AND. Lg.LE.nt ) THEN
           cruisespan(ig,jg,1,Lg) = MIN(cruisespan(ig,jg,1,Lg), xx)
           cruisespan(ig,jg,2,Lg) = MAX(cruisespan(ig,jg,2,Lg), xx)
           cruisespan(ig,jg,3,Lg) = MIN(cruisespan(ig,jg,3,Lg), yy)
           cruisespan(ig,jg,4,Lg) = MAX(cruisespan(ig,jg,4,Lg), yy)
	ENDIF

* Store the min and max index used in this cruise
	indx(1,1) = MIN(indx(1,1), ig)
	indx(1,2) = MAX(indx(1,2), ig)
	indx(2,1) = MIN(indx(2,1), jg)
	indx(2,2) = MAX(indx(2,2), jg)
	indx(4,1) = MIN(indx(4,1), Lg)
	indx(4,2) = MAX(indx(4,2), Lg)

	RETURN
	END

*
*  eofsvd_tfunc.F
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* July 2012
*
* Compute EOF/s and time amplitude funcions from a 2-d field, or for each level 
* of a 3-D field. Calls Billy Kessler's svdeof code
*
* Return time amplitude functions.
*
*
* In this SUBROUTINE we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE eofsvd_tfunc_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      CALL ef_set_desc(id,
     .   'Return SVD EOF time functions from XYT field.')

      CALL ef_set_num_args(id, 1)

      CALL ef_set_axis_inheritance_6d(id,
     .                                ABSTRACT,        NORMAL,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      CALL ef_set_num_work_arrays(id, 9)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg,
     .                     'Variable in x,y,t; may be fcn of z,e,f')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, YES, YES, YES, YES)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* loss               lo subscript for an axis
*
* hiss               hi subscript for an axis
*

      SUBROUTINE eofsvd_tfunc_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER my_lo_l, my_hi_l

      INTEGER nx, ny

*     Use utility functions to get context information about the 
*     1st argument, to set the abstract axis lo and hi indices.

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nx = arg_hi_ss(X_AXIS, ARG1) - arg_lo_ss(X_AXIS, ARG1) + 1
      ny = arg_hi_ss(Y_AXIS, ARG1) - arg_lo_ss(Y_AXIS, ARG1) + 1

      my_lo_l = 1
      my_hi_l = nx * ny

      CALL ef_set_axis_limits(id, X_AXIS, my_lo_l, my_hi_l)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE eofsvd_tfunc_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*
      COMMON /eof_tfuncSTOR/ mx
      INTEGER mx1, my1, mt1, mx, mxmt, mxmx, mwrk, mwrk2

      INTEGER iwork
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      mx1 = 1 + arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1)
      my1 = 1 + arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1)
      mt1 = 1 + arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1)

      mx = mx1 * my1 + 10
      mxmt = mx * mt1 + 10
      mxmx = mx * mx + 10
      mwrk = mxmt/2
      mwrk2 = MIN(mx, mt1)

*  taf (pack data into this eof by t array, returned as taf)
      iwork = 1
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                             mxmt, 1, 1, 1, 1, 1)

*  ok
      iwork = 2
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1,   1, 1, 1, 1, 1,
     .                              mx1, my1, 1, 1, 1, 1)

* workspace
      iwork = 3
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                               mwrk, 1, 1, 1, 1, 1)

* W(NX) eigenvalues of decomposition
      iwork = 4
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                               mx, 1, 1, 1, 1, 1)

* V(NX,NX) EOFs in columns (V(space,neof))
      iwork = 5
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                               mxmx, 2, 1, 1, 1, 1)

* PCT(NX) % variance represented by each EOF
      iwork = 6
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                               mx, 1, 1, 1, 1, 1)

*                                                            
*  isave_jsave
*  Make this work array 7, so that pack_ef from eofsubs can be used
      iwork = 7
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                               mx, 2, 1, 1, 1, 1)

* work2
      iwork = 8
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                               mwrk2, 1, 1, 1, 1, 1)

* work3
      iwork = 9
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                               mwrk2, 1, 1, 1, 1, 1)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this SUBROUTINE we compute the result
*

      SUBROUTINE  eofsvd_tfunc_compute(id, arg_1, result, 
     .    taf, ok, workspace, w, v, pct, isave_jsave, work2, work3)

*  arg_1  variable, function of (x,y,t)
*  result neof*NT time amplitude functions

*  Work arrays (there are some internal hard-coded arrays, should be 
*  done by external-functions work arrays).
*  taf, ok, isave_jsave, w, v, pct

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      COMMON /eof_tfuncSTOR/ mx
      INTEGER mx

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

*  Dimension the work arrays.


      REAL taf(wrk1lox:wrk1hix, wrk1loy:wrk1hiy,
     .         wrk1loz:wrk1hiz, wrk1lot:wrk1hit,
     .         wrk1loe:wrk1hie, wrk1lof:wrk1hif)
      REAL ok(wrk2lox:wrk2hix, wrk2loy:wrk2hiy,
     .        wrk2loz:wrk2hiz, wrk2lot:wrk2hit,
     .        wrk2loe:wrk2hie, wrk2lof:wrk2hif)
      REAL workspace(wrk3lox:wrk3hix, wrk3loy:wrk3hiy,
     .        wrk3loz:wrk3hiz, wrk3lot:wrk3hit,
     .        wrk3loe:wrk3hie, wrk3lof:wrk3hif)
      REAL w(wrk4lox:wrk4hix, wrk4loy:wrk4hiy,
     .        wrk4loz:wrk4hiz, wrk4lot:wrk4hit,
     .        wrk4loe:wrk4hie, wrk4lof:wrk4hif)
      REAL v(wrk5lox:wrk5hix, wrk5loy:wrk5hiy,
     .        wrk5loz:wrk5hiz, wrk5lot:wrk5hit,
     .        wrk5loe:wrk5hie, wrk5lof:wrk5hif)
      REAL pct(wrk6lox:wrk6hix, wrk6loy:wrk6hiy,
     .        wrk6loz:wrk6hiz, wrk6lot:wrk6hit,
     .        wrk6loe:wrk6hie, wrk6lof:wrk6hif)
      REAL isave_jsave(wrk7lox:wrk7hix, wrk7loy:wrk7hiy,
     .        wrk7loz:wrk7hiz, wrk7lot:wrk7hit,
     .        wrk7loe:wrk7hie, wrk7lof:wrk7hif)
      REAL work2(wrk8lox:wrk8hix, wrk8loy:wrk8hiy,
     .        wrk8loz:wrk8hiz, wrk8lot:wrk8hit,
     .        wrk8loe:wrk8hie, wrk8lof:wrk8hif)
      REAL work3(wrk9lox:wrk9hix, wrk9loy:wrk9hiy,
     .        wrk9loz:wrk9hiz, wrk9lot:wrk9hit,
     .        wrk9loe:wrk9hie, wrk9lof:wrk9hif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER neof, ier
      CHARACTER*255 err_msg, err_out

      INTEGER nx, ny, nt, k, m, n, k1, m1, n1,
     .        iw, jw, kw, lw, mw, nw
      REAL frac_timeser

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*  get array sizes

      nx = 1 + arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1)
      ny = 1 + arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1)
      nt = 1 + arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1)

      frac_timeser = 1.

*  Compute EOF for each depth, ensemble, forecast

      n1 = arg_lo_ss(F_AXIS,ARG1)
      DO 300 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

      m1 = arg_lo_ss(E_AXIS,ARG1)
      DO 200 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

      k1 = arg_lo_ss(Z_AXIS,ARG1)
      DO 100 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

*  Initialize work arrays.

         DO 701 nw = wrk1lof,wrk1hif
         DO 701 mw = wrk1loe,wrk1hie
         DO 701 lw = wrk1lot,wrk1hit
         DO 701 kw = wrk1loz,wrk1hiz 
         DO 701 jw = wrk1loy,wrk1hiy
         DO 701 iw = wrk1lox,wrk1hix
            taf(iw,jw,kw,lw,mw,nw) = 0.
  701    CONTINUE

         DO 702 nw = wrk2lof,wrk2hif
         DO 702 mw = wrk2loe,wrk2hie
         DO 702 lw = wrk2lot,wrk2hit
         DO 702 kw = wrk2loz,wrk2hiz 
         DO 702 jw = wrk2loy,wrk2hiy
         DO 702 iw = wrk2lox,wrk2hix
            ok(iw,jw,kw,lw,mw,nw) = 0.
  702    CONTINUE

         DO 703 nw = wrk3lof,wrk3hif
         DO 703 mw = wrk3loe,wrk3hie
         DO 703 lw = wrk3lot,wrk3hit
         DO 703 kw = wrk3loz,wrk3hiz 
         DO 703 jw = wrk3loy,wrk3hiy
         DO 703 iw = wrk3lox,wrk3hix
            workspace(iw,jw,kw,lw,mw,nw) = 0.
  703    CONTINUE

         DO 704 nw = wrk4lof,wrk4hif
         DO 704 mw = wrk4loe,wrk4hie
         DO 704 lw = wrk4lot,wrk4hit
         DO 704 kw = wrk4loz,wrk4hiz 
         DO 704 jw = wrk4loy,wrk4hiy
         DO 704 iw = wrk4lox,wrk4hix
            w(iw,jw,kw,lw,mw,nw) = 0.
  704    CONTINUE

         DO 705 nw = wrk5lof,wrk5hif
         DO 705 mw = wrk5loe,wrk5hie
         DO 705 lw = wrk5lot,wrk5hit
         DO 705 kw = wrk5loz,wrk5hiz 
         DO 705 jw = wrk5loy,wrk5hiy
         DO 705 iw = wrk5lox,wrk5hix
            v(iw,jw,kw,lw,mw,nw) = 0.
  705    CONTINUE

         DO 706 nw = wrk6lof,wrk6hif
         DO 706 mw = wrk6loe,wrk6hie
         DO 706 lw = wrk6lot,wrk6hit
         DO 706 kw = wrk6loz,wrk6hiz 
         DO 706 jw = wrk6loy,wrk6hiy
         DO 706 iw = wrk6lox,wrk6hix
            pct(iw,jw,kw,lw,mw,nw) = 0.
  706    CONTINUE

         DO 707 nw = wrk7lof,wrk7hif
         DO 707 mw = wrk7loe,wrk7hie
         DO 707 lw = wrk7lot,wrk7hit
         DO 707 kw = wrk7loz,wrk7hiz 
         DO 707 jw = wrk7loy,wrk7hiy
         DO 707 iw = wrk7lox,wrk7hix
            isave_jsave(iw,jw,kw,lw,mw,nw) = 0.
  707    CONTINUE

         DO 708 nw = wrk8lof,wrk8hif
         DO 708 mw = wrk8loe,wrk8hie
         DO 708 lw = wrk8lot,wrk8hit
         DO 708 kw = wrk8loz,wrk8hiz 
         DO 708 jw = wrk8loy,wrk8hiy
         DO 708 iw = wrk8lox,wrk8hix
            work2(iw,jw,kw,lw,mw,nw) = 0.
  708    CONTINUE

         DO 709 nw = wrk9lof,wrk9hif
         DO 709 mw = wrk9loe,wrk9hie
         DO 709 lw = wrk9lot,wrk9hit
         DO 709 kw = wrk9loz,wrk9hiz 
         DO 709 jw = wrk9loy,wrk9hiy
         DO 709 iw = wrk9lox,wrk9hix
            work3(iw,jw,kw,lw,mw,nw) = 0.
  709    CONTINUE

*  Find the number of eofs to solve for. Require that a location has
*  all time points present or it is skipped.
*  neof = number of (x,y) points with all good data.  
*  Set OK to mark where they are. (note this also allows for 
*  working around continental boundaries or other areas where 
*  entire time series are missing)

         CALL count_neof (arg_1, neof, ok, nx, ny, nt, k1, m1, n1,
     .                    arg_lo_ss, arg_hi_ss, arg_incr, mx,
     .                    bad_flag(ARG1), frac_timeser, err_msg, ier)
         IF (ier .NE. 0) then
            GOTO 5010
         ENDIF
	 IF (neof .EQ. 0) THEN
	    err_msg = 'There are no spatial locations having complete time series.'
	    GOTO 5010
	 ENDIF

*  Put the data into the array taf(neof,nt). Input to solver routine,
*  returned as taf.

         CALL pack_ef (arg_1, taf, isave_jsave, neof,  
     .                 ok, frac_timeser, nx, ny, nt, k1, m1, n1,
     .                 arg_lo_ss, arg_hi_ss, arg_incr)

*  Solve for the EOF's: eigenvectors, time functions, percent variance explained.

         CALL solve_eofsvd_tfunc (taf, neof, nt, k, m, n, result, 
     .            isave_jsave, w, v, pct, workspace, work2, work3, 
     .            res_lo_ss, res_hi_ss, res_incr, bad_flag(ARG1),
     .            bad_flag_result, frac_timeser, err_msg, ier)

         IF (ier .NE. 0) GOTO 5020

         k1 = k1 + arg_incr(Z_AXIS,ARG1)
  100 CONTINUE
         m1 = m1 + arg_incr(E_AXIS,ARG1)
  200 CONTINUE
         n1 = n1 + arg_incr(F_AXIS,ARG1)
  300 CONTINUE

      RETURN

 5010 CALL ef_bail_out (id, err_msg)
      RETURN

 5020 IF (ier .EQ. -1) THEN
         err_msg = 'SVDEOF. No convergence in 60 iterations.'
      ENDIF
      WRITE (err_out, 5500) k, m, n, err_msg 
 5500 FORMAT ('k,m,n=', 3I3, A250)
      CALL ef_bail_out (id, err_out)
      RETURN

      END

***********************************************************************

      SUBROUTINE solve_eofsvd_tfunc (taf, neof, nt, k, m, n, result, 
     .            isave_jsave, w, v, pct, workspace, work2, work3,
     .            res_lo_ss, res_hi_ss, res_incr, bad_flag_dat, 
     .            bad_flag_result,frac_timeser, err_msg, ier)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER neof, nt, k, m, n
      REAL w(*)
      REAL v(neof, neof)
      REAL taf(neof, nt)
      REAL pct(*)
      REAL workspace(*), work2(*), work3(*)
      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)
      REAL isave_jsave(wrk3lox:wrk3hix, wrk3loy:wrk3hiy,
     .        wrk3loz:wrk3hiz, wrk3lot:wrk3hit,
     .        wrk3loe:wrk3hie, wrk3lof:wrk3hif)
      INTEGER res_lo_ss(6), res_hi_ss(6), res_incr(6)
      REAL bad_flag_dat, bad_flag_result, frac_timeser
      CHARACTER*(*) err_msg
      INTEGER cnt, ier

* local variables
      INTEGER i, j, l, mm, nn, is, js

      CALL DO_SVD_EOF (taf, neof, nt, w, v, pct, workspace, 
     .                 work2, work3, ier)
      IF (ier .NE. 0) RETURN

*  Result is the time functions. 

      j = res_lo_ss(Y_AXIS)
      DO 120 i = 1, neof
         cnt = 1
         DO 110 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
            result(i,j,k,l,m,n) = taf(i,cnt)
            cnt = cnt + 1
  110    CONTINUE
  120 CONTINUE

      DO 220 i = neof+1, res_hi_ss(X_AXIS)
         DO 210 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
            result(i,j,k,l,m,n) = bad_flag_result
  210    CONTINUE
  220 CONTINUE

      RETURN
      END

	SUBROUTINE DO_AUX_VAR_REGRID_1D_T( axis,
     .				           src,  msrc,  src_cx,
     .				           dst,  mdst,  dst_cx,
     .				           tsrc, mtsrc, tsrc_cx,
     .					   ldst_min, ldst_max ) 

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* perform a 1D t-axis "orthoganalization" regrid guided by an
* auxiliary variable containing a 2D array of time steps
* allow for the usual Ferret promotion of point axes to match span axes
* where either the source data or the position field may have degenerate axes
* (typically the position array will be degenerate in Z and E) 

* This code copied/modified from do_aux_var_regrid_1d_z.F

* V695+ 3/15 *sh*
* V702 1/17 *sh* for trac enhancement #2369 -- dynamic memory management 

        IMPLICIT NONE
        include 'tmap_dims.parm'
        include 'errmsg.parm'
	include	'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	
* calling argument declarations:
	INTEGER	axis,
     .		msrc, mdst, mtsrc, src_cx, dst_cx, tsrc_cx,
     .		ldst_min, ldst_max
        REAL    src ( m4lox:m4hix,m4loy:m4hiy,m4loz:m4hiz,
     .                m4lot:m4hit,m4loe:m4hie,m4lof:m4hif ),
     .          dst ( m5lox:m5hix,m5loy:m5hiy,m5loz:m5hiz,
     .                m5lot:m5hit,m5loe:m5hie,m5lof:m5hif ),
     .          tsrc( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .                m1lot:m1hit,m1loe:m1hie,m1lof:m1hif )


* internal variable declarations:
        INTEGER CX_DIM_LEN,
     .          idim,
     .          i,   j,   k,   l,   m,   n,
     .          is,  js,  ks,  ls,  ms,  ns,
     .          si0, sj0, sk0, sl0, sm0, sn0,
     .          dsi, dsj, dsk, dsl, dsm, dsn,
     .		ip,   jp,  kp,       mp
        INTEGER nmin, nmax, dgrid, status,
     .		lsrc_min, lsrc_max, lsrc_start, lsrc_end, ldst_start, ldst_end
        REAL    tsrc_min, tsrc_max
        REAL*8  TM_WORLD, depsilon
* internally declared work arrays
	REAL*8	tdst(ldst_min:ldst_max)

* equivalence conveniences
* "inc" is the increments for each axis of each component
* "lo"  is the starting subscript (minus 1) for each axis of each component
* "s" is the source data (src)
* "p" (tsrcition) is the time steps of the source data ==> the 2D array
* "d" indicates the delta increment
* "0" indicates the start (lo) index
        INTEGER srcinc(nferdims), srclo(nferdims)
        EQUIVALENCE
     .	    (srcinc(1),dsi), (srcinc(2),dsj), (srcinc(3),dsk),
     .	    (srcinc(4),dsl), (srcinc(5),dsm), (srcinc(6),dsn),
     .	    (srclo(1), si0), (srclo(2), sj0), (srclo(3), sk0),
     .	    (srclo(4), sl0), (srclo(5), sm0), (srclo(6), sn0)

*==========================

* initialize
* nicer names for key index limits
	dgrid   = cx_grid(dst_cx)
	nmin    = cx_lo_ss(dst_cx,f_dim) ! lowest forecast axis index
	nmax    = cx_hi_ss(dst_cx,f_dim) !  hiest forecast axis index
	lsrc_min = cx_lo_ss(src_cx,t_dim) ! l index min in source data
	lsrc_max = cx_hi_ss(src_cx,t_dim) ! l index max in source data

* auxiliary TIME field is 2D on T-F so set up static indices for other axes
	ip = cx_lo_ss(tsrc_cx,x_dim)
	jp = cx_lo_ss(tsrc_cx,y_dim)
	kp = cx_lo_ss(tsrc_cx,z_dim)
	mp = cx_lo_ss(tsrc_cx,e_dim)

* extract the time step values of the destination
	DO l = ldst_min, ldst_max
	   tdst(l) = TM_WORLD(l, dgrid, t_dim, box_middle)
	ENDDO

* compute the delta increment for each axis
* this allows "promotion" of degenerate axes
        DO 10 idim = 1, nferdims
           IF ( CX_DIM_LEN(idim,src_cx) .EQ. 1 ) THEN
              srcinc(idim) = 0
           ELSE
              srcinc(idim) = 1
           ENDIF
 10     CONTINUE

* compute the starting subscript for each axis of each component
* used below through equivalence relationship
* pre-decrement by 1 delta for looping ahead)
        DO idim = 1, nferdims
	   srclo(idim) = cx_lo_ss(src_cx,idim) - srcinc(idim)
	ENDDO

* the relationship between the time steps in the source data (the
* values found in the "position" data -- the 2D aux time field)
* and the same times in the destination field looks something
* like this over 3 forecast cycles

*   **     2d aux times    **	      ** orthoganalized T-F field **
*                       		                 	110
*                       		                 	109
*                       		        1010   1010	108
*                       		        1009   1009	107
*   18     >1008   1012   1016		 1008   1008   1008	106
*   17     >1007   1011   1015		 1007   1007		105
*   16     >1006  >1010   1014		 1006   1006		104
*   15     >1005  >1009   1013		 1005   1005		103
*   14      1004  >1008   1012		 1004   1004		102
*   13      1003  >1007   1011		 			101
*   12      1002  >1006  >1010		 			100
*   11      1001  >1005  >1009		 			 99
*   10      1000   1004  >1008		 			 98
*    |								  |
* l in src_cx						    l in dst_cx 

* ">" above indicate a requested time range of T=1005:1010

* the outer loop is over the frequency axis
	ns = sn0
	DO n = mr_lo_s6(mdst), mr_hi_s6(mdst)
	   ns = ns + dsn

* are there time steps to be copied at this forecast index
	   tsrc_min = tsrc(ip,jp,kp,lsrc_min,mp,n) ! min time at this F
	   tsrc_max = tsrc(ip,jp,kp,lsrc_max,mp,n) ! max time at this F
* tolerance in time matching (would be better if it was consistent for all F)
           depsilon = (2.0**(-42)) *
     .             ABS( (tsrc_max-tsrc_min) / (lsrc_max-lsrc_min+1.0) )
        IF ( ((tdst(ldst_min) - tsrc_max) .GT. depsilon)
     .  .OR. ((tsrc_min - tdst(ldst_max)) .GT. depsilon) ) CYCLE  ! nothing to copy

* locate the index at which the block of times to be copied begins in source and dest
           IF ( (tsrc_min - tdst(ldst_min)) .GT. depsilon ) THEN
	      lsrc_start = lsrc_min
	      DO ldst_start = ldst_min, ldst_max
                  IF ( ABS(tdst(ldst_start) - tsrc_min) .LT. depsilon ) EXIT
	      ENDDO
	   ELSE
	      ldst_start = ldst_min
	      DO lsrc_start = lsrc_min, lsrc_max
                 IF ( ABS(tsrc(ip,jp,kp,lsrc_start,mp,n) -
     .                    tdst(ldst_min)) .LT. depsilon ) EXIT
	      ENDDO
	   ENDIF

* locate the index at which the block of times to be copied ends
	   IF ( (tdst(ldst_max) - tsrc_max) .GT. depsilon ) THEN
	      lsrc_end = lsrc_max
	   ELSE
	      DO lsrc_end = lsrc_max, lsrc_min, -1
                 IF ( ABS(tsrc(ip,jp,kp,lsrc_end,mp,n) -
     .                    tdst(ldst_max)) .LT. depsilon ) EXIT
	      ENDDO
	   ENDIF
	   ldst_end = ldst_start + (lsrc_end-lsrc_start)

* copy the src data to the destination array -- loop over its  X,Y,Z,T,E range
* the 's' variables are source array indices
 100	   is = si0
	   DO 1000 i = mr_lo_s1(mdst), mr_hi_s1(mdst)
	    is = is + dsi

	    js = sj0
	    DO 1000 j = mr_lo_s2(mdst), mr_hi_s2(mdst)
	     js = js + dsj

	     ks = sk0
	     DO 1000 k = mr_lo_s3(mdst), mr_hi_s3(mdst)
	      ks = ks + dsk

* ... special set-up for L axis
	      ls = lsrc_start - 1
	      DO 1000 l = ldst_start, ldst_end
	       ls = ls + 1

	       ms = sm0
	       DO 1000 m = mr_lo_s5(mdst), mr_hi_s5(mdst)
	        ms = ms + dsm

	    dst(i,j,k,l,m,n) = src(is,js,ks,ls,ms,ns)

 1000	   CONTINUE
	ENDDO

* successful completion.  Clean up.
        CALL RELEASE_DYN_WORK_SPACE   ! ?? needed ??
        RETURN

* error exit
 5000	RETURN
	END

*
* transpose_yf.F
* 
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* 3/2017 ACM completing the set of TRANSPOSE functions
* 

      SUBROUTINE transpose_yf_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

      CALL ef_set_desc(id, 'transposes Y and F axes of given variable')
      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, ABSTRACT,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, ABSTRACT        )
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'VAR')
      CALL ef_set_arg_desc(id, arg, 'variable to transpose in Y and F')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, NO, YES, YES, YES, NO)

      RETURN 
      END


      SUBROUTINE transpose_yf_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER lo_f, hi_f, lo_y, hi_y, nf, ny

*     Set the ABSTRACT Y and F axes.

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nf = arg_hi_ss(F_AXIS, ARG1) - arg_lo_ss(F_AXIS, ARG1) + 1
      ny = arg_hi_ss(Y_AXIS, ARG1) - arg_lo_ss(Y_AXIS, ARG1) + 1

*     The below has the effect of translating any sub-matrix so that
*     the indices will always begin at 1 as expected for an abstract axis.

      lo_y = 1
      hi_y = nf
      lo_f = 1
      hi_f = ny

      CALL ef_set_axis_limits(id, Y_AXIS, lo_y, hi_y)
      CALL ef_set_axis_limits(id, F_AXIS, lo_f, hi_f)

      RETURN 

      END


*
* In this subroutine we compute the result
*
      SUBROUTINE transpose_yf_compute(id, arg_1, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1
      CHARACTER*100 errtxt

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* check to make sure both axis have points to transpose
      IF ( (arg_lo_ss(Y_AXIS, ARG1) .EQ. ef_unspecified_int4) .OR. 
     .     (arg_hi_ss(Y_AXIS, ARG1) .EQ. ef_unspecified_int4) ) THEN
         WRITE(errtxt,*) 'Y axis cannot be a normal axis'
         GOTO 999
      ENDIF
      IF ( (arg_lo_ss(F_AXIS, ARG1) .EQ. ef_unspecified_int4) .OR. 
     .     (arg_hi_ss(F_AXIS, ARG1) .EQ. ef_unspecified_int4) ) THEN
         WRITE(errtxt,*) 'F axis cannot be a normal axis'
         GOTO 999
      ENDIF

      n1 = arg_lo_ss(F_AXIS, ARG1)
      DO 600 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

      m1 = arg_lo_ss(E_AXIS, ARG1)
      DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

      l1 = arg_lo_ss(T_AXIS, ARG1)
      DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

      k1 = arg_lo_ss(Z_AXIS, ARG1)
      DO 300  k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

      j1 = arg_lo_ss(Y_AXIS, ARG1)
      DO 200 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

      i1 = arg_lo_ss(X_AXIS, ARG1)
      DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         IF ( arg_1(i1,j1,k1,l1,m1,n1) .NE. bad_flag(ARG1) ) THEN
            result(i,j,k,l,m,n) = arg_1(i1,j1,k1,l1,m1,n1)
         ELSE
            result(i,j,k,l,m,n) = bad_flag_result
         ENDIF

         i1 = i1 + arg_incr(X_AXIS, ARG1)
 100  CONTINUE

         j1 = j1 + arg_incr(Y_AXIS, ARG1)
 200  CONTINUE

         k1 = k1 + arg_incr(Z_AXIS, ARG1)
 300  CONTINUE

         l1 = l1 + arg_incr(T_AXIS, ARG1)
 400  CONTINUE

         m1 = m1 + arg_incr(E_AXIS, ARG1)
 500  CONTINUE

         n1 = n1 + arg_incr(F_AXIS, ARG1)
 600  CONTINUE

      RETURN 

 999  CALL EF_BAIL_OUT(id, errtxt)

      RETURN 
      END

      SUBROUTINE TFORM(X,Y,Z)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)tform.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     CALL TFORM(X,Y,Z)
C
C     THIS SUBROUTINE TRANSFORMS THE COORDINATES OF A POINT
C     FROM THE USER'S COORDINATE SYSTEM TO THE SCREEN COOR-
C     DINATE SYSTEM.  PERSPECTIVE IS APPLIED IF APPROPRIATE.
C
C
#ifdef unix
      include 'PLTCOM.DAT'
#else
      include 'pplinc:PLTCOM.DAT'
#endif
C
C     CHECK THE VIEW FLAG.
C
      IF(VIEWF)THEN
C
C     TRANSFORM THE POINT.
C
        ATEMP = X * TAX + Y * TAY + Z * TAZ - AREF
        BTEMP = X * TBX + Y * TBY + Z * TBZ - BREF
        COLD = X * TCX + Y * TCY + Z * TCZ - CREF
C
C     IF APPROPRIATE, APPLY PERSPECTIVE TO THE POINT.
C
        IF(VDIST .NE. 0.0)THEN
          PERSPC = (VDIST - COLD) / VDIST
          IF(PERSPC .EQ. 0.0)THEN
            ATEMP = 0.0
            BTEMP = 0.0
          ELSE
            ATEMP = ATEMP / PERSPC
            BTEMP = BTEMP / PERSPC
          ENDIF
        ENDIF
C
C     CHECK THE ROTATION FLAG.
C
        IF(ROTAT)THEN
C
C     ROTATE AND TRANSLATE THE POINT.
C
          ANEW = ATEMP * ROTCOS - BTEMP * ROTSIN + AORIGN
          BNEW = ATEMP * ROTSIN + BTEMP * ROTCOS + BORIGN
        ELSE
C
C     TRANSLATE BUT DO NOT ROTATE THE POINT.
C
          ANEW = ATEMP + AORIGN
          BNEW = BTEMP + BORIGN
        ENDIF
      ELSE
C
C     CHECK THE ROTATION FLAG.
C
        IF(ROTAT)THEN
C
C     ROTATE AND TRANSLATE THE POINT.
C
          ANEW = X * ROTCOS - Y * ROTSIN + AORIGN
          BNEW = X * ROTSIN + Y * ROTCOS + BORIGN
        ELSE
C
C     TRANSLATE BUT DO NOT ROTATE THE POINT.
C
          ANEW = X + AORIGN
          BNEW = Y + BORIGN
        ENDIF
      ENDIF
C
C     CHECK THE MIRROR-IMAGE FLAGS.
C
      IF(MIRAF)ANEW = ASIZE - ANEW
      IF(MIRBF)BNEW = BSIZE - BNEW
      RETURN
C
      END

	INTEGER FUNCTION DO_SMTH_PARZN(	idim, arg,
     .					com, com_mr, com_cx,
     .					res, res_mr, res_cx,
     .					wt	)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* smooth along axis idim by a Parzn filter (window)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* for Unix/RISC port 9/91 - based on DO_SMTH_BINML
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xprog_state.cmn'

* calling argument declarations:
	INTEGER	idim, com_mr, com_cx, res_mr, res_cx
	REAL	arg, wt(*), com(*), res(*)

* internal variable declarations
	INTEGER	wlen, status

* diagnostic mode output: " doing --> VAR_NAME[x=lo:hi@TRN:n,D=#]"
	IF ( mode_diagnostic ) 	CALL DIAG_OP
     .				( 'doing', isact_class_trans, res_cx, idim )

* initialize
	wlen = arg	! length of smoother
        IF ( MOD(wlen,2).EQ.0 )  CALL ERRMSG(ferr_out_of_range, status,
     .                  'Parzen smoother length must be odd', *5000 )

* create weights array to be convolved with data
	CALL PARZN_WT( wt, wlen )

* now convolve this along the desired axis of the grid
	CALL CONVOLVE(	idim, wlen/2, wt,
     .			com, com_mr, com_cx,
     .			res, res_mr, res_cx )

* success
	DO_SMTH_PARZN = ferr_ok
	RETURN

* error
 5000	DO_SMTH_PARZN = status
	RETURN
	END

*
* samplexy.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without anx fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and anx derivative works thereof, and
*  its supporting documentation for anx purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in anx publications that result from
*  the use of this software or in anx product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in anx advertising or publicity to endorse or promote anx products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with anx support, consulting,
*  training or assistance of anx kind with regard to the use, operation
*  and performance of this software nor to provide the user with anx
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND Anx EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR Anx SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR Anx DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
*  -------------------------------------------------------------------
*  Replace samplexy_compute subroutine with the one sent by Bernadette Fritzsch 
*  Subject: samplexy.F
*  Date: Thu, 22 Jun 2000 11:07:25 +0200 (MET DST)
*  From: Bernadette Fritzsch <fritzsch@AWI-Bremerhaven.DE>
*  To: hankin@pmel.noaa.gov
*  
*  Hallo Steve,
*  
*  the external function samplexy was first only for the case that all points
*  match the original axes. Now there is a version of samplexy, that interpolate
*  the values between the points, what is more general. But in some cases it
*  fails, when the point matches the axis but one of the neighbour point has bad values.
*  
*  Here are some modification of the code. To avoid to much if-then-else-endif
*  constructs i modify the variable itop and jtop in the case of matching.
*  In this case no interpolation is done but the condition if all numbers are 
*  not bad values is fullfilled.
*  
*  I attach my version of subroutine samplexy_compute. Modifications are marked
*  as coloured.
*  
*  There is another problem where i did not find a solution.
*  What about the case when axis is set modulo?
*  
*  -- Bernadette
*  -------------------------------------------------------------------
*
* This function samples 4-d data on the x and y axes indicated by args 2 and 3
* 9/10/99  Ansley Manke 
*         Result is abstract on the x axis, normal on the y axis,
*         and keeps the z and t axes of the input 4-d data.
*
* 1/13/2000 acm -- fix so that xpts and/or ypts can be on any axis.
* 3/ 1/2000 ACM -- fix bug in the definition of the work arrays
* 6/ 8/2000 ACM -- fix bug in incrementing k2, k3, l2, l3
*
* 7/2000  acm -- merge Bernadettes and increment fix into this version
* 5/2001  acm -- allow modulo axes
* 10/2001 acm -- check that jtop (box top) is within range of ARG1 y axis.
* 10/2001 acm -- check that jtop (box top) is within range of ARG1 y axis.
*  2/2001 acm -- check that modulo axes are also regular, and fix delmodx
*  2/2002 acm -- check xpt and ypt (x and y points to sample) that values arent missing.
* 11/2005 acm -- Allow use of this on any X axis, not just regular ones 
*                (see bug report 1358)
*  1/2014 acm -- Fix ticket 2137: use correct indices when computing dx, dy.
*  7/2016 acm -- Allocate the length of the axes for REAL*8 work arrays. 
*                Use the argument subscript limits, so subsets are handled correctly.

*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE samplexy_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CHARACTER*100 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns data sampled at a set of (X,Y) points, ',
     .        'using linear interpolation')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                ABSTRACT,        NORMAL,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 6)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'DAT_TO_SAMPLE')
      CALL ef_set_arg_desc(id, arg, 'variable (x,y,z,t,e,f) to sample')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'XPTS')
      CALL ef_set_arg_desc(id, arg, 'X values of sample points')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'YPTS')
      CALL ef_set_arg_desc(id, arg, 'Y values of sample points')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* loss               lo subscript for an axis
*
* hiss               hi subscript for an axis
*

      SUBROUTINE samplexy_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER my_lo, my_hi
      INTEGER nx, ny, nz, nt, ne, nf

*     Use utility functions to get context information about the 
*     second argument, to set the abstract axis lo and hi indices.

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nx = arg_hi_ss(X_AXIS, ARG2) - arg_lo_ss(X_AXIS, ARG2) + 1
      ny = arg_hi_ss(Y_AXIS, ARG2) - arg_lo_ss(Y_AXIS, ARG2) + 1
      nz = arg_hi_ss(Z_AXIS, ARG2) - arg_lo_ss(Z_AXIS, ARG2) + 1
      nt = arg_hi_ss(T_AXIS, ARG2) - arg_lo_ss(T_AXIS, ARG2) + 1
      ne = arg_hi_ss(E_AXIS, ARG2) - arg_lo_ss(E_AXIS, ARG2) + 1
      nf = arg_hi_ss(F_AXIS, ARG2) - arg_lo_ss(F_AXIS, ARG2) + 1

      my_lo = 1
      my_hi = max(nx,ny,nz,nt,ne,nf)

      CALL ef_set_axis_limits(id, X_AXIS, my_lo, my_hi)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END
*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE samplexy_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER mxh, myh, mxl, myl
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)


*  Allocate the length of the axes for REAL*8 work arrays. Use the argument
*  subscript limits, so subsets are handled correctly.

*  xaxdat
      CALL ef_set_work_array_dims_6d(id, 1,
     .          arg_lo_ss(X_AXIS,ARG1), 1, 1, 1, 1, 1,
     .          arg_hi_ss(X_AXIS,ARG1)+1, 1, 1, 1, 1, 1)

*  yaxdat
      CALL ef_set_work_array_dims_6d(id, 2,
     .          arg_lo_ss(Y_AXIS,ARG1), 1, 1, 1, 1, 1,
     .          arg_hi_ss(Y_AXIS,ARG1), 1, 1, 1, 1, 1)

*  xboxlo
      CALL ef_set_work_array_dims_6d(id, 3,
     .          arg_lo_ss(X_AXIS,ARG1), 1, 1, 1, 1, 1,
     .          arg_hi_ss(X_AXIS,ARG1), 1, 1, 1, 1, 1)

*  xboxhi
      CALL ef_set_work_array_dims_6d(id, 4,
     .          arg_lo_ss(X_AXIS,ARG1), 1, 1, 1, 1, 1,
     .          arg_hi_ss(X_AXIS,ARG1), 1, 1, 1, 1, 1)

*  
      CALL ef_set_work_array_dims_6d(id, 5,
     .          arg_lo_ss(Y_AXIS,ARG1), 1, 1, 1, 1, 1,
     .          arg_hi_ss(Y_AXIS,ARG1), 1, 1, 1, 1, 1)

*  yboxhi
      CALL ef_set_work_array_dims_6d(id, 6,
     .          arg_lo_ss(Y_AXIS,ARG1), 1, 1, 1, 1, 1,
     .          arg_hi_ss(Y_AXIS,ARG1), 1, 1, 1, 1, 1)


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*

      SUBROUTINE samplexy_compute(id, arg_1, arg_2, arg_3, result,
     .                xaxdat, yaxdat, xboxlo, xboxhi, yboxlo, yboxhi)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

      REAL*8 xaxdat(wrk1lox:wrk1hix)
      REAL*8 yaxdat(wrk2lox:wrk2hix)
      REAL*8 xboxlo(wrk3lox:wrk3hix)
      REAL*8 xboxhi(wrk4lox:wrk4hix)
      REAL*8 yboxlo(wrk5lox:wrk5hix)
      REAL*8 yboxhi(wrk6lox:wrk6hix)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER STR_UPCASE
      LOGICAL TM_FPEQ

      INTEGER nx, nxx, nxy, nxz, nxt, nxe, nxf
      INTEGER ny, nyx, nyy, nyz, nyt, nye, nyf
      INTEGER ndimx, ndimy
      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2
      INTEGER i3, j3, k3, l3, m3, n3
      INTEGER ic, imatch, jmatch
      INTEGER ibot, itop, jbot, jtop, xflag
      INTEGER ilo, ihi, jlo, jhi
      LOGICAL ok, full_span, its_dsg
      REAL fxbot, fxtop, fbb, ftb, fbt, ftt
      REAL xbot, xtop, ybot, ytop
      REAL xfrac, yfrac
      REAL dx, dxlo, dxhi, dy, dylo, dyhi, delmodx, xpt, ypt
      CHARACTER err_msg*255, test_str*16

C  variables for checking axis characteristics (modulo axes)
      CHARACTER ax_name(6)*16, ax_units(6)*16
      LOGICAL backward(6), modulo(6), regular(6)

* Does the variable come from a Discrete Sampling Geometries dataset?  

      CALL EF_GET_ITS_DSG(id, ARG1, its_dsg )
      IF (its_dsg) THEN
         err_msg = 
     . 'Data is from a Discrete Sampling Geometries (DSG) dataset. Function does not apply.'
        GOTO 999
      ENDIF

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      nxx = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1
      nxy = arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) + 1
      nxz = arg_hi_ss(Z_AXIS,ARG2) - arg_lo_ss(Z_AXIS,ARG2) + 1
      nxt = arg_hi_ss(T_AXIS,ARG2) - arg_lo_ss(T_AXIS,ARG2) + 1
      nxe = arg_hi_ss(E_AXIS,ARG2) - arg_lo_ss(E_AXIS,ARG2) + 1
      nxf = arg_hi_ss(F_AXIS,ARG2) - arg_lo_ss(F_AXIS,ARG2) + 1
      nx = max(nxx, nxy, nxz, nxt, nxe, nxf)

      nyx = arg_hi_ss(X_AXIS,ARG3) - arg_lo_ss(X_AXIS,ARG3) + 1
      nyy = arg_hi_ss(Y_AXIS,ARG3) - arg_lo_ss(Y_AXIS,ARG3) + 1
      nyz = arg_hi_ss(Z_AXIS,ARG3) - arg_lo_ss(Z_AXIS,ARG3) + 1
      nyt = arg_hi_ss(T_AXIS,ARG3) - arg_lo_ss(T_AXIS,ARG3) + 1
      nye = arg_hi_ss(E_AXIS,ARG3) - arg_lo_ss(E_AXIS,ARG3) + 1
      nyf = arg_hi_ss(F_AXIS,ARG3) - arg_lo_ss(F_AXIS,ARG3) + 1
      ny = max(nyx, nyy, nyz, nyt, nye, nyf)

      ndimx = 0
      ndimy = 0
      DO 10 i = X_AXIS,F_AXIS
         IF (arg_hi_ss(i,ARG2) - arg_lo_ss(i,ARG2) .GT.0) 
     .       ndimx = ndimx + 1
         IF (arg_hi_ss(i,ARG3) - arg_lo_ss(i,ARG3) .GT.0) 
     .       ndimy = ndimy + 1
   10 CONTINUE

      IF ( (nx .NE. ny) .OR. (ndimx .GT. 1) .OR. (ndimy .GT.1) ) THEN
         err_msg = 
     .  'Arguments 2 and 3 must be 1-dimensional lists of equal length'
         GO TO 999
      ENDIF

*  Get x and y coordinates of the data to be sampled.

      ilo = arg_lo_ss(X_AXIS,ARG1)
      ihi = arg_hi_ss(X_AXIS,ARG1)
      jlo = arg_lo_ss(Y_AXIS,ARG1)
      jhi = arg_hi_ss(Y_AXIS,ARG1)

      CALL ef_get_coordinates(id, ARG1, X_AXIS, ilo, ihi, xaxdat)
      CALL ef_get_coordinates(id, ARG1, Y_AXIS, jlo, jhi, yaxdat)

*  Check to see if input x axis is modulo, and if axes are regular.

      CALL ef_get_axis_info_6d(id, ARG1, ax_name, ax_units,
     .                         backward, modulo, regular)
      IF ( regular(1) ) THEN
         dx = xaxdat(ilo+1) - xaxdat(ilo)
         dxlo = dx/2.
         dxhi = dx/2.
      ELSE
         CALL ef_get_box_limits(id, ARG1, X_AXIS, ilo, ihi,
     .                          xboxlo, xboxhi)
         dxlo = (xboxlo(ilo+1) - xboxlo(ilo) ) / 2.
         dxhi = (xboxhi(ihi) - xboxhi(ihi-1) ) / 2.
      ENDIF

      IF ( regular(2) ) THEN
         dy = yaxdat(jlo+1) - yaxdat(jlo)
         dylo = dy/2.
         dyhi = dy/2.
      ELSE
         CALL ef_get_box_limits(id, ARG1, Y_AXIS, jlo, jhi,
     .                          yboxlo, yboxhi)
         dylo = (yboxlo(jlo+1) - yboxlo(jlo) )/ 2.
         dyhi = (yboxhi(jhi) - yboxlo(jhi-1) )/ 2.
      ENDIF
      
* Check to see if input x,y axis is modulo. If its a longitude 
* axis, check for full-span

      IF ( modulo(1) ) THEN
         ic = STR_UPCASE (test_str, ax_units(1))
         ok = (test_str(1:3) .EQ. 'DEG') 
         dx = xaxdat(ilo+1) - xaxdat(ilo)
         delmodx = (xaxdat(ihi) + dxhi) -
     .             (xaxdat(ilo) - dxlo)
         IF ( .NOT. regular(1) )
     .      delmodx = xboxhi(ihi) - xboxlo(ilo)
         IF ( ok ) THEN 
            full_span = (delmodx .GT. 360.-dx)
            delmodx = 360.
         ELSE
            full_span = .TRUE.
         ENDIF
      ENDIF

      i2 = arg_lo_ss(X_AXIS,ARG2)
      j2 = arg_lo_ss(Y_AXIS,ARG2)
      k2 = arg_lo_ss(Z_AXIS,ARG2)
      l2 = arg_lo_ss(T_AXIS,ARG2)
      m2 = arg_lo_ss(E_AXIS,ARG2)
      n2 = arg_lo_ss(F_AXIS,ARG2)

      i3 = arg_lo_ss(X_AXIS,ARG3)
      j3 = arg_lo_ss(Y_AXIS,ARG3)
      k3 = arg_lo_ss(Z_AXIS,ARG3)
      l3 = arg_lo_ss(T_AXIS,ARG3)
      m3 = arg_lo_ss(E_AXIS,ARG3)
      n3 = arg_lo_ss(F_AXIS,ARG3)

*  For each (xpt,ypt) pair, search the data array 
*   arg_1 for the nearest higher (x,y) grid coordinates.  Interpolate 
*   in 2 directions for the result.

* Y-axis is normal to the result
      j = res_lo_ss(Y_AXIS)

      DO 700 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         xpt = arg_2(i2,j2,k2,l2,m2,n2)
         ypt = arg_3(i3,j3,k3,l3,m3,n3)
         IF (xpt .EQ. bad_flag(ARG2) .OR. ypt .EQ. bad_flag(ARG3)) THEN
            DO 80 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
            DO 80 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
            DO 80 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
            DO 80 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
               result(i,j,k,l,m,n) = bad_flag_result
   80       CONTINUE
*           Go to the next pair of coordinates
            GOTO 690
         ENDIF

* Flag for outside of a modulo axis
         xflag = 0

* Check if xpt is in the x-axis range.
         ibot = ef_unspecified_int4
         itop = ef_unspecified_int4
         imatch = ef_unspecified_int4
*  Locate the X point within the range of modulo X axis 
*  If we have the whole span, then use the point at the other
*  end to handle points within a half-grid cell of the edge.

         IF ( modulo(1) .AND. full_span ) THEN
            IF ( xpt .GE. xaxdat(ihi) .AND.
     .           xpt .LE. xaxdat(ihi) + dxhi ) THEN
               ibot = ihi
               xflag = 1
            ELSE IF ( xpt .GE. xaxdat(ihi) ) THEN
               DO WHILE ( xpt .GE. xaxdat(ihi) ) 
                  xpt = xpt - delmodx
               ENDDO
            ENDIF

            IF ( xpt .LT. xaxdat(ilo) .AND.
     .           xpt .GE. xaxdat(ilo) - dxlo ) THEN
               itop = ilo
               xflag = -1
            ELSE IF ( xpt .LT. xaxdat(ilo) ) THEN
               DO WHILE (xpt .LT. xaxdat(ilo) )
                  xpt = xpt + delmodx
               ENDDO
            ENDIF
	 ENDIF

* Source variable has subspan-modulo axis 

         IF ( modulo(1) .AND. .NOT.full_span ) THEN
            IF (modulo(1) .AND. xpt .GE. xaxdat(ihi) ) THEN
               DO WHILE ( xpt .GE. xaxdat(ihi) ) 
               xpt = xpt - delmodx
               ENDDO
            ENDIF

	    IF (modulo(1) .AND. xpt .LT. xaxdat(ilo) ) THEN
               DO WHILE (xpt .LT. xaxdat(ilo) )
                  xpt = xpt + delmodx
               ENDDO
            ENDIF
         ENDIF

         DO 120 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)
            IF ( TM_FPEQ(xpt, xaxdat(i1)) ) THEN
               imatch = i1
               GOTO 130
            ELSE IF ( i1  .EQ. arg_lo_ss(X_AXIS,ARG1)     .AND.
     .                xpt .LT. xaxdat(i1)       .AND.
     .                xpt .GT. xaxdat(i1)-dxhi  .AND.
     .               .NOT. modulo(1) ) THEN
               ibot = i1
            ELSE IF ( xpt .GE. xaxdat(i1) ) THEN
               ibot = i1
            ENDIF
  120    CONTINUE

         IF ( .NOT. modulo(1) .OR. (modulo(1) .AND..NOT.full_span )) THEN
            IF ( xpt .GT. xaxdat(ihi) .AND.
     .           xpt .LT. xaxdat(ihi) + dxhi ) THEN
               ibot = ihi
            ELSE IF ( xpt .GT. xaxdat(ihi) ) THEN
               ibot = ef_unspecified_int4   ! ARG_2 XPT outside of range 
            ENDIF
         ENDIF

  130    IF ( imatch .NE. ef_unspecified_int4 ) THEN
            ibot = imatch
            itop = imatch
         ELSE IF ( ibot .NE. ef_unspecified_int4 ) THEN
            itop = ibot + 1
            IF ( itop .GT. ihi ) itop = ihi
         ENDIF

* If the data is at the very top or bottom of the modulo x axis, get the
* point from the other end.

         IF ( xflag .EQ. 1 ) THEN
            ibot = ihi
            itop = ilo
         ENDIF
         IF ( xflag .EQ. -1 ) THEN
            itop = ilo
            ibot = ihi
         ENDIF

         IF ( ibot .EQ. ef_unspecified_int4 ) THEN
*           Coordinate outside the grid
            DO 140 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
            DO 140 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
            DO 140 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
            DO 140 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
               result(i,j,k,l,m,n) = bad_flag_result
  140       CONTINUE
*           Go to the next pair of coordinates
            GOTO 690
         ENDIF

cbf      analogously in y direction

* Check if ypt is in the y-axis range.
         jbot = ef_unspecified_int4
         jmatch = ef_unspecified_int4

         DO 220 j1 = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)
            IF ( TM_FPEQ(ypt, yaxdat(j1)) ) THEN
               jmatch = j1
               GOTO 230
            ELSE IF ( j1  .EQ. arg_lo_ss(Y_AXIS,ARG1) .AND.
     .                ypt .LT. yaxdat(j1)   .AND. 
     .                ypt .GT. yaxdat(j1) - dylo ) THEN
               jbot = j1
            ELSE IF ( ypt .GE. yaxdat(j1) ) THEN
               jbot = j1
            ENDIF
  220    CONTINUE

         IF ( ypt .GT. yaxdat(jhi) .AND.
     .        ypt .LT. yaxdat(jhi) + dyhi ) THEN
            jbot = jhi
         ELSE IF ( ypt .GT. yaxdat(jhi) ) THEN
            jbot = ef_unspecified_int4      ! ARG_3 YPT outside of range 
         ENDIF

  230    IF ( jmatch .NE. ef_unspecified_int4 ) THEN
            jbot = jmatch
            jtop = jmatch
         ELSE IF ( jbot .NE. ef_unspecified_int4 ) THEN
            jtop = jbot + 1
            if ( jtop .GT. jhi ) jtop = jhi
         ENDIF

         IF ( jbot .EQ. ef_unspecified_int4 ) THEN
*           Coordinate outside the grid
            DO 240 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
            DO 240 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
            DO 240 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
            DO 240 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
               result(i,j,k,l,m,n) = bad_flag_result
  240       CONTINUE
*           Go to the next pair of coordinates
            GOTO 690
         ENDIF


         xbot = xaxdat(ibot)
         xtop = xaxdat(itop)
         IF ( xtop .LT. xbot ) THEN
            IF ( .NOT. regular(1) )
     .         dx = ( xboxlo(ibot+1) - 
     .                xboxlo(ibot) ) / 2.0
            IF ( xflag .EQ. 1 ) THEN
               xtop = xbot + dx
            ELSE IF ( xflag .EQ. -1 ) THEN
               xbot = xtop - dx
            ENDIF
         ENDIF
         IF ( ibot .NE. itop )
     .      xfrac = (xpt - xbot) / (xtop - xbot)

         ybot = yaxdat(jbot)
         ytop = yaxdat(jtop)
         IF ( jbot .NE. jtop )
     .      yfrac = (ypt - ybot) / (ytop - ybot)

* Loop through the Z/T/E/F axes, assigning results for this coordinate pair
         n1 = arg_lo_ss(F_AXIS,ARG1)
         DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

         m1 = arg_lo_ss(E_AXIS,ARG1)
         DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

         l1 = arg_lo_ss(T_AXIS,ARG1)
         DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

*  First interpolate in x, getting values of the fcn at (x,jbot) and (x,jtop)
               fbb = arg_1(ibot,jbot,k1,l1,m1,n1)
               ftb = arg_1(itop,jbot,k1,l1,m1,n1)
               fbt = arg_1(ibot,jtop,k1,l1,m1,n1)
               ftt = arg_1(itop,jtop,k1,l1,m1,n1)

               IF ( fbb .NE. bad_flag(ARG1)  .AND.
     .              ftb .NE. bad_flag(ARG1)  .AND.
     .              fbt .NE. bad_flag(ARG1)  .AND.
     .              ftt .NE. bad_flag(ARG1) ) THEN

cbf               for matching x-axis no interpolation is need
                  IF ( ibot .EQ. itop ) THEN
                     fxbot = fbb
                     fxtop = fbt
                  ELSE
                     fxbot = fbb + xfrac * (ftb - fbb)
                     fxtop = fbt + xfrac * (ftt - fbt)
                  ENDIF

*  Now interpolate in y, getting value at (x,y)

cbf               for matching y-axis no interpolation is need
                  IF ( jbot .EQ. jtop ) THEN
                     result(i,j,k,l,m,n) = fxbot
                  ELSE
                     result(i,j,k,l,m,n) = fxbot +
     .                                     yfrac * (fxtop - fxbot)
                  ENDIF

               ELSE

*                 one of the components was missing
                  result(i,j,k,l,m,n) = bad_flag_result

               ENDIF

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
 300        CONTINUE

            l1 = l1 + arg_incr(T_AXIS,ARG1)
 400     CONTINUE

            m1 = m1 + arg_incr(E_AXIS,ARG1)
 500     CONTINUE

            n1 = n1 + arg_incr(F_AXIS,ARG1)
 600     CONTINUE

* Only one of the ARG2 and one of the ARG3 actually increments
 690     i2 = i2 + arg_incr(X_AXIS,ARG2)
         j2 = j2 + arg_incr(Y_AXIS,ARG2)
         k2 = k2 + arg_incr(Z_AXIS,ARG2)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
         m2 = m2 + arg_incr(E_AXIS,ARG2)
         n2 = n2 + arg_incr(F_AXIS,ARG2)

         i3 = i3 + arg_incr(X_AXIS,ARG3)
         j3 = j3 + arg_incr(Y_AXIS,ARG3)
         k3 = k3 + arg_incr(Z_AXIS,ARG3)
         l3 = l3 + arg_incr(T_AXIS,ARG3)
         m3 = m3 + arg_incr(E_AXIS,ARG3)
         n3 = n3 + arg_incr(F_AXIS,ARG3)
 700  CONTINUE

      RETURN

 999  CALL ef_bail_out (id, err_msg)

      END

	SUBROUTINE AGG_CLEAN_GRIDS( dset, agg_dim, ens_ax, tlag_ax  )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* check among the temporary grids for duplicates. Remove duplication.
* Ensure that distinct grids have distinct names.

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V698 1/16 *sh* based upon code from CD_CLEAN_GRIDS
*      2/16 *sh* if identical pre-existing agg axes exists, re-use them
* V741 5/18*acm* Changes for promoting global attributes to a variable in ensembles

* argument definitions:
*       dset    - pointer to aggregated data set (input)
*	agg_dim	- axis of aggregation (E_dim or F_dim)  (input)
*	ens_ax	- aggregation axis (input/output)
*	tlag_ax	- time axis (F aggregation, only) (input/output)

        IMPLICIT NONE
* include files
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
        include 'xbuild_grids.cmn'
	include 'xtm_grid.cmn_text'
	include 'xdset_info.cmn_text'
        include 'netcdf.inc'

* argument declarations
	INTEGER	 dset, agg_dim, ens_ax, tlag_ax

* local variable declarations:
	LOGICAL TM_SAME_GRID_DEF, have_prev_ens, have_prev_tlag
	INTEGER TM_FIND_LIKE_DYN_LINE, ivar, gg,
     .		prev_tlag_ax, prev_ens_ax, accepted_grid, test_grid
	CHARACTER buff*8	 

* initialize
	have_prev_tlag = .FALSE.

********************
* avoid creating duplicate axes

* If the ensemble axis or the lag-time axis of an FMRC is an exact duplicate
* of a pre-existing axis use the previous one, instead
	prev_ens_ax = TM_FIND_LIKE_DYN_LINE( ens_ax )
	have_prev_ens = (prev_ens_ax .NE. ens_ax) .AND. 
     .                  (prev_ens_ax  .NE. unspecified_int4)
	IF (agg_dim .EQ. F_dim) THEN
	   prev_tlag_ax = TM_FIND_LIKE_DYN_LINE( tlag_ax )
	   have_prev_tlag = (prev_tlag_ax .NE. tlag_ax) .AND.
     .                      (prev_tlag_ax .NE. unspecified_int4)
	ENDIF
	IF ( have_prev_ens .OR. have_prev_tlag ) THEN
* find the places that the new axes are in use. Replace them with pre_exist 
!     note: We should use the dset var LIST!   Super-inefficient loop here
	   varloop: DO ivar = 1, maxvars
	      IF ( ds_var_setnum(ivar) .NE. dset ) CYCLE varloop
	      gg = ds_grid_number(ivar)
* ... replace the duplicated axes with the previous identical ones
	      IF (have_prev_ens) THEN
	         IF (grid_line(agg_dim,gg) .EQ. ens_ax)
     .				grid_line(agg_dim,gg) = prev_ens_ax
	      ENDIF
	      IF (have_prev_tlag) THEN
	         IF (grid_line(t_dim,gg) .EQ. tlag_ax)
     .				grid_line(t_dim,gg) = prev_tlag_ax
	      ENDIF
	   ENDDO varloop

* delete the redundant axes
* Do the deallo here; depending on tm_garb_col eventually corrupted line lists
	   IF ( have_prev_ens ) THEN 
	      CALL TM_DEALLO_DYN_LINE(ens_ax)
	      ens_ax = prev_ens_ax
	   ENDIF
	   IF ( have_prev_tlag ) THEN
	      CALL TM_DEALLO_DYN_LINE(tlag_ax)
	      tlag_ax = prev_tlag_ax
	   ENDIF
	ENDIF

* ****************
* grids

* check for duplicate grid guts
	accepted_grid = 0		! to get start of linked list
 10	CALL TM_NEXT_TMP_GRID( accepted_grid, *500)
	IF (grid_name(accepted_grid) .EQ. char_init) GOTO 10 ! already removed

	test_grid = accepted_grid
 20	CALL TM_NEXT_TMP_GRID( test_grid, *200)
	IF (grid_name(test_grid) .EQ. char_init) GOTO 100 ! already removed

* is the test grid a duplicate of the accepted grid?
	IF ( TM_SAME_GRID_DEF( accepted_grid, test_grid ) ) THEN
*  ... yes -- point its variables to the accepted grid
	   DO ivar = 1, maxvars
	      IF ( ds_var_setnum(ivar) .NE. dset ) CYCLE
	      IF ( ds_grid_number(ivar) .EQ. test_grid ) 
     .		   ds_grid_number(ivar) = accepted_grid
	   ENDDO
	   grid_name(test_grid) = char_init   ! throw it away
	ELSE
*  ... no -- make sure it has a unique name
	   CALL TM_NEW_GRID_NAME( grid_name(test_grid), buff )
	   grid_name(test_grid) = buff
	ENDIF
* inner loop -- Go back for another test_grid
 100	GOTO 20

* outer loop -- Go back for another accepted_grid
 200	CONTINUE
*  ... no -- make sure accepted_grid has a unique name
	   CALL TM_NEW_GRID_NAME( grid_name(accepted_grid), buff )
	   grid_name(accepted_grid) = buff
	
	GOTO 10

* we've tested the uniqueness of all temporary grids.  We're done.
 500	RETURN
	END

	INTEGER FUNCTION FVAR_NUMBER( dset_num, name_code )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* identify the given name_code by finding it among the given data set variables

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/18/87
* revision 0.1 - 8/29/87 - added vms_str_success
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl_vms.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data

* calling argument declarations:
	INTEGER		dset_num
	CHARACTER*(*)	name_code

* internal variable declarations:
	INTEGER	        fvar, j, num_indices 

* loop through all file variables
*	DO 100 fvar = 1, maxvars
*	   IF ( ds_var_setnum( fvar ) .NE. dset_num ) GOTO 100
*	   vax_code = STR_CASE_BLIND_COMPARE( name_code, ds_var_code(fvar) )

* found the name code ?
*	   IF ( vax_code .EQ. vms_str_success ) THEN
*               FVAR_NUMBER = fvar
*	       RETURN
*	   ENDIF
* 100	CONTINUE

        CALL string_array_find_caseblind(ds_var_code_head,
     .                                   name_code,
     .                                   LEN(name_code),
     .                                   string_array_result1(1),
     .                                   maxvars,
     .                                   num_indices)
        DO 100 j = 1, num_indices
           fvar = string_array_result1(j)
           IF ( ds_var_setnum( fvar ) .NE. dset_num ) GOTO 100
	   FVAR_NUMBER = fvar
	   RETURN
 100	CONTINUE

* not found
	FVAR_NUMBER = var_name_nonexist
	RETURN

	END

	SUBROUTINE EZ_COUNT_DSET ( dset, ezform, nread, status  )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke 7/2014
* 
* Subroutine opens an EZ data set (ASCII and unformatted non_TMAP data files) 
* and returns a count count the records in the datset, minus the number of 
* records skipped. Addressing ticket 2182.
*
* V701  7/16 *kms* Compare ds_name to char_init2048 instead of char_init1024
* 

* Arguments:
*	dset	- data set number
*	ezform	- file format
*	nread	- (output) number of data records in file
*
	INTEGER*4	dset, nread, status
	CHARACTER*(*)	ezform

*
* Include files
	include 'ez_lib.parm'
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
	include 'tmap_errors.parm'
	include 'xez_info.cmn_text'
	external xez_info_data
	include 'xez_order.cmn_text'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xstep_files.cmn_text'
	external xstep_files_data
*
*internal parameter declarations *kob* 4apr94
        CHARACTER*1     cr,lf
#ifdef NO_INTRINSIC_IN_PARAMETER
        PARAMETER       ( cr = o'015',
     .                    lf = o'012')
#else
        PARAMETER       ( cr = CHAR(13),
     .                    lf = CHAR(10))
#endif

* Local definitions
	CHARACTER*11	file_format
	CHARACTER*80	errbuff
	CHARACTER*99	in_format
	INTEGER*4	sfcnt, lunit, scnt, rcnt
	INTEGER*4	skip_in, read_in, nout
	INTEGER*4	itemp, i, irec, ierr
	LOGICAL		unformatted, file_exists, file_open, stream
        REAL		buff

* Does data set exist?
	IF (ds_name(dset) .EQ. char_init2048) GOTO 9300
*
* Locate Step file entry
	DO 10 sfcnt = 1,maxstepfiles
	  IF (sf_setnum(sfcnt) .EQ. dset) GOTO 20
  10	CONTINUE
	GOTO 9400

* Initialize
 20	nread = 0

*   get file format
	stream = ezform(:3) .EQ. 'STR'
	unformatted = ezform(:3) .EQ. 'UNF'
	IF ( unformatted ) THEN
	  file_format = 'UNFORMATTED'
	ELSE
	  file_format = 'FORMATTED'
	  in_format = ezform		! Run time format info
	ENDIF

*   set up ASSIGN statements (for GOTO variable statements)
	IF ( unformatted ) THEN
	  ASSIGN 400 TO skip_in			! Goes to UNFORMATTED read
	  ASSIGN 500 TO read_in			! Goes to UNFORMATTED read
	ELSEIF ( in_format(:4) .EQ. 'FREE' ) THEN
	  ASSIGN 450 TO skip_in			! Goes to FORMATTED read
	  ASSIGN 610 TO read_in			! Goes to FORMATTED read
	ELSEIF ( stream ) THEN			! "STREAM" direct access binary
	  ASSIGN 499 TO skip_in
	  ASSIGN 620 TO read_in
	  irec = sf_skip(sfcnt) + 1     ! /SKIP=words
	ELSE
	  ASSIGN 450 TO skip_in			! Goes to FORMATTED read
	  ASSIGN 600 TO read_in			! Goes to FORMATTED read
	ENDIF

* Check file validity if necessary
  160	IF (.NOT. sf_valid(sfcnt)) THEN
!	  INQUIRE (	FILE = sf_name(sfcnt),	! sf_name is too short 10/89
	  INQUIRE (	FILE = ds_des_name(dset),
     .			RECL = itemp,	! temporary var needed by DEC/RISC
     .			EXIST = file_exists,
     .			OPENED = file_open,
     .			ERR = 9000)
	  IF (.NOT. file_exists) GOTO 9100
* calculate RECL in longwords for unformatted (if not open)             
          IF (.NOT. file_open .AND. unformatted )
     .	                         sf_reclen(sfcnt) = sf_reclen(sfcnt)/4
        ENDIF
*
* get free VMS logical unit #   
	CALL LIB_GET_LUN (lunit)
*
* open the file

	IF ( stream ) THEN       ! 5/94
	   OPEN	(UNIT = lunit,
     .		 FILE = ds_des_name(dset),
     .		 FORM = 'UNFORMATTED',
     .		 ACCESS = 'DIRECT',
#ifdef reclen_in_bytes
     .		 RECL = 4,
#else
     .		 RECL = 1,
#endif
     .		 STATUS = 'OLD',
     .		 ERR = 9000)
	ELSE
* added ifdef for READONLY_ALLOWED for IBM port *kob* 4apr94
	   OPEN	(UNIT = lunit,
     .		 FILE = ds_des_name(dset),
     .		 FORM = file_format,
     .		 ACCESS = 'SEQUENTIAL',
     .		 STATUS = 'OLD',
#ifdef READONLY_ALLOWED
     .		 READONLY,
#endif
     .		 ERR = 9000)
	ENDIF

*
* read "SKIP" records and initialize records read counter
	GOTO skip_in
  400	DO 425 scnt = 1,sf_skip(sfcnt)
  425	READ (lunit,END=9200,ERR=9000)
	GOTO 499
  450	DO 475 scnt = 1,sf_skip(sfcnt)
  475	READ (lunit,'(1X)',END=9200,ERR=9000)
  499	nout = 0		! is number of values (per var) read so far
*
* Read depending on format, nrec counts number of records read
	GOTO read_in
* ... binary data

  500	READ (lunit,END=800,ERR=9500) 

	GOTO 690
* ... fixed format data
  600	READ (lunit,*,END=800,ERR=9500) 
	GOTO 690

* ... free format data
  610   READ (lunit,*,END=800,ERR=9500) 
	GOTO 690

* ... stream
  620   READ (lunit,rec=irec,ERR=9600) buff
	irec = irec + 1

  690	nout = nout + 1
	GOTO read_in
*
* Finished, store records read and then exit
  800	nread = nout 
	status = merr_ok
	GOTO 9950
*
* Error message
 9000	CALL TM_ERRMSG( merr_erreq, status, 'EZ_COUNT',
     .			dset, sfcnt, 'during SKIP reads',
     .			no_errstring, *9999                 )

 9100	CALL TM_ERRMSG( merr_notmounted, status, 'EZ_COUNT',
     .			dset, sfcnt, 'DATAFILE NOT FOUND',
     .			no_errstring, *9999                 )

 9200	CALL TM_ERRMSG( merr_eof, status, 'EZ_COUNT',
     .			dset, sfcnt,
     .			'during SKIP reads', no_errstring, *9950   )

 9300	CALL TM_ERRMSG( merr_dsetnf, status, 'EZ_COUNT',
     .			no_descfile, no_stepfile,
     .			no_errstring, no_errstring, *9999)

 9400	CALL TM_ERRMSG( merr_stepnf, status, 'EZ_COUNT',
     .			dset, no_stepfile,
     .			no_errstring, no_errstring, *9999)

 9500	BACKSPACE lunit
	READ (lunit,'(A)') errbuff
	CALL TM_ERRMSG( merr_erreq, status, 'EZ_COUNT',
     .			dset, sfcnt,
     .		'Last or next-to-last record read:'//cr//lf//errbuff,
     .			no_errstring, *9999                 )

 9600	CALL TM_ERRMSG( merr_erreq, status, 'EZ_COUNT',
     .			dset, no_stepfile,
     .			'error reading STREAM file', no_errstring, *9999)

*
* Close file and free lunit
 9950	CLOSE (lunit, ERR=9990)
 9990	CALL LIB_FREE_LUN (lunit)
        sf_lunit(sfcnt) = file_not_open    ! *sh* added 5/91
 9999	RETURN
	END

	SUBROUTINE NUMBER(X,Y,DEG,CSIZE,NC,V)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)number.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
	CHARACTER LAB*30,IFORM*10
	LOGICAL FLAG
	FLAG=.FALSE.
200	VT=V*1.000001
	IF(V.EQ.0)THEN
	NCC=1
	ELSE
	VX=ALOG10(ABS(VT))
	NCC=IFIX(VX)+SIGN(1.,VX)
	END IF
	IF(NC.GT.0)THEN
	IF(NC.GE.IABS(NCC)+2)THEN
	IF(NCC.GE.0)THEN
	WRITE(IFORM,10)NC,NC-NCC-2
10	FORMAT('(F',I2,'.',I2,')')
	ELSE
	WRITE(IFORM,10)NC,NC-2
	END IF
	ELSE
	IF(NC.LT.7)GOTO 100
	WRITE(IFORM,11)NC,NC-7
11	FORMAT('(1PE',I2,'.',I2,')')
	ENDIF
	WRITE(LAB,IFORM)V
	ELSE
	NC=-NC
	IF(NC.LT.NCC+1)GOTO 100
	WRITE(IFORM,12)NC
12	FORMAT('(I',I2,')')
	WRITE(LAB,IFORM)IFIX(V)
	END IF
	IF(FLAG)THEN
	CALL SYMBL(X,Y,DEG,CSIZE,NC,LAB)
	ELSE
	CALL SYMBOL(X,Y,DEG,CSIZE,NC,LAB)
	END IF
	RETURN
100	LAB='******************************'
	IF(FLAG)THEN
	CALL SYMBL(X,Y,DEG,CSIZE,NC,LAB)
	ELSE
	CALL SYMBOL(X,Y,DEG,CSIZE,NC,LAB)
	ENDIF
	RETURN
	ENTRY NUMBR(X,Y,DEG,CSIZE,NC,V)
	FLAG=.TRUE.
	GOTO 200
	END

	SUBROUTINE INIT_EMPTY_CONTEXT ( cx )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* set up a "null" context suitable to merge other contexts on top of

* V450: 1/97 - part of changes to accomodate grid-changing functions
* 9/97 *kob* - initialize cx_calendar as well
* V530:  8/00 *sh* - initialize data type to unspecified
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V690 *sh* 2/14 init auxiliary var-related context variables
* V695  *acm* 2/15 cx_calendar stores info about calendar formatting of T and F axes

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'

* calling argument declarations:
	INTEGER cx

* internal variable declarations
	INTEGER	idim

* all contexts contain axis region information
	DO 100 idim = 1,nferdims
	   cx_lo_ss ( cx, idim )   = unspecified_int4
	   cx_hi_ss ( cx, idim )   = unspecified_int4
	   cx_lo_ww ( idim, cx )   = unspecified_val8
	   cx_hi_ww ( idim, cx )   = unspecified_val8
	   cx_trans ( idim, cx )   = trans_no_transform
	   cx_by_ss ( idim, cx )   = .TRUE.
	   cx_given ( idim, cx )   = .TRUE.		! <== (*)
	   cx_aux_given( idim, cx ) = .FALSE.
	   cx_aux_stat ( idim, cx ) = paux_stat_na
	   cx_aux_var  ( idim, cx ) = unspecified_int4
	   cx_aux_cat  ( idim, cx ) = unspecified_int4
	   cx_aux_stat ( idim, cx ) = paux_stat_na
	   cx_trans_arg( idim, cx ) = bad_val4
	   cx_delta    ( idim, cx ) = unspecified_val8
	   cx_regrid_trans(idim,cx)=unspecified_int4
 100	CONTINUE

	cx_data_set( cx ) = unspecified_int4
	cx_dset_gvn( cx ) = .TRUE.			! <== (*)
	cx_category( cx ) = unspecified_int4
	cx_variable( cx ) = unspecified_int4
	cx_grid    ( cx ) = unspecified_int4
	cx_type    ( cx ) = unspecified_int4
!	cx_ovsiz   ( cx ) = JC_TODO:  what should this be?
	cx_bad_data( cx ) = bad_val4

	cx_unstand_grid ( cx ) = .FALSE.
	cx_impl_grid    ( cx ) = unspecified_int4

* kob 9/97 - need to initialize cx_calendar as well
		 IF (idim .eq. t_dim .OR. idim .eq. f_dim) 
     .                cx_calendar(idim,cx) = .FALSE.

* (*) initialized to TRUE so that ANDing with another context will yield
*	TRUE only if "given" in that context

	RETURN
	END

	INTEGER FUNCTION CGRID_SIZE_MAX ( cx )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine the number of values used on the grid
* of the specified context

* unlike CGRID_SIZE which uses "1" as the size of unspecified regions this
* one uses CAXIS_LEN - the maximum size.  A kludge in guessing this way.

* another kludge is needed for abstract variables -- since the abstract
* axis is deliberately defined to be "arbitrarily" long.  Use a length of
* 1 in this case

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V420: 11/95 - from CGRID_SIZE
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V685 *acm*  6/13 Increase nominal length of abstract axis
* v74   *acm* 3/18 Introduce parameter abstractax_len replacing 99999999

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'

* calling argument declarations:
	INTEGER	cx

* internal variable declarations:
	INTEGER	CX_DIM_LEN, CAXIS_LEN, CGRID_AXIS, idim, i6d, axlen

* to accomodate the ABSTRACT axis
* (inefficient -- "mline_abstract" should be saved by DEFINE_SPECIAL_GRIDS)

* initialize
	i6d = 1

	DO 100 idim = 1, nferdims
	   IF (cx_lo_ss(cx,idim) .NE. unspecified_int4) THEN
	      i6d = i6d * CX_DIM_LEN(idim,cx)
	   ELSE
	      axlen = CAXIS_LEN(idim,cx)
	      IF ( axlen .EQ. abstractax_len ) THEN
	         axlen = 1	! kludge trap for ABSTRACT axis length
	      ELSEIF ( axlen .GT. 5000 ) THEN
	         axlen = 5000	! kludge 
	      ENDIF
	      i6d = i6d * axlen
	   ENDIF
 100	CONTINUE

	CGRID_SIZE_MAX = i6d

	RETURN
	END

*
* xauto_cor.F
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* July 1999
*  Update to use abstract axis 1-feb-2000
*  acm 11/2001 bug fix: check both arg_1(i1+im...) and arg_1(i1...) for bad flag

* This function computes the autocorrelation for a x series.  
*  Autocorelation formula computed directly for lags of 0, 1, ..., N-1
*  Return on an abstract X axis.

*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*

      SUBROUTINE xauto_cor_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .        'Compute autocorrelation of series, lags of 0, ..., N-1')
      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance_6d(id,
     .                                ABSTRACT,        IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 3)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_desc(id, arg, 'X-series variable')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, YES, YES, YES, YES, YES)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END


*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE xauto_cor_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER lo_ss, hi_ss

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

C  Autocorrelation returns correlations for lags of 0 to N-1.
      lo_ss = 1
      hi_ss = arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 1

      CALL ef_set_axis_limits(id, X_AXIS, lo_ss, hi_ss)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************
      RETURN
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE xauto_cor_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
* 
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER npts, irr

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      npts = 1 + arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1)
  
* partial means  pmean
      irr = 1
      CALL ef_set_work_array_dims_6d(id, irr,
     .                                1, 1, 1, 1, 1, 1,
     .                             npts, 1, 1, 1, 1, 1)

* partial variances  pvar
      irr = 2
      CALL ef_set_work_array_dims_6d(id, irr,
     .                                1, 1, 1, 1, 1, 1,
     .                             npts, 1, 1, 1, 1, 1)

* box sizes BOX
      irr = 3
      CALL ef_set_work_array_dims_6d(id, irr,
     .                                1, 1, 1, 1, 1, 1,
     .                             npts, 1, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE xauto_cor_compute(id, arg_1, result,
     .                             pmean, pvar, box)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* Ignore the Y/Z/T/E/F dimensions in the work arrays since
* they are not used and Fortran is column major
      REAL pmean(wrk1lox:wrk1hix)
      REAL pvar (wrk2lox:wrk2hix)
      REAL box  (wrk3lox:wrk3hix)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      REAL psum, diff, diff2
      REAL dsum, bsize
      INTEGER ir, im, is
      INTEGER nd, arg
      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      arg = 1
      CALL ef_get_box_size(id, arg, X_AXIS, arg_lo_ss(X_AXIS,arg), 
     .                     arg_hi_ss(X_AXIS,arg), box)

      nd = arg_hi_ss(X_AXIS,arg) - arg_lo_ss(X_AXIS,arg) + 1

      n1 = arg_lo_ss(F_AXIS,ARG1)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

      m1 = arg_lo_ss(E_AXIS,ARG1)
      DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

      l1 = arg_lo_ss(T_AXIS,ARG1)
      DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         k1 = arg_lo_ss(Z_AXIS,ARG1)
         DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

            j1 = arg_lo_ss(Y_AXIS,ARG1)
            DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

*
* Calculate the autocorrelation 
*  First step is to compute the partial means [1/(n-i)]* sum[m=1,n-i]dat(m+i)

               DO 120 i = 1, nd
                  psum = 0.
                  dsum = 0.
                  im = i-1
                  i1 = arg_lo_ss(X_AXIS,ARG1)
                  DO 110 is = 1, nd-im 
                     IF ( arg_1(i1+im,j1,k1,l1,m1,n1)
     .                    .NE. bad_flag(ARG1) ) THEN
                        bsize = box(is+im)
                        psum = psum + bsize*arg_1(i1+im,j1,k1,l1,m1,n1)
                        dsum = dsum + bsize
                     ENDIF
                     i1 = i1 + arg_incr(X_AXIS,ARG1)
 110              CONTINUE
                  IF ( dsum .GT. 0. ) pmean(i) = psum / dsum
 120           CONTINUE

*  Compute the partial variances RMS[dat(m+i) - pmean(i)]
*  Don't divide by dsum; the denominators cancel when the autocorrelation
*  is computed below.

               DO 160 i = 1, nd
                  psum = 0.
                  dsum = 0.
                  im = i-1
                  i1 = arg_lo_ss(X_AXIS,ARG1)
                  DO 150 is = 1, nd-im 
                     IF ( arg_1(i1+im,j1,k1,l1,m1,n1)
     .                    .NE. bad_flag(ARG1) ) THEN
                        bsize = box(is+im)
                        diff = arg_1(i1+im,j1,k1,l1,m1,n1) - pmean(i)
                        psum = psum + bsize * diff * diff
                        dsum = dsum + bsize
                     ENDIF
                     i1 = i1 + arg_incr(X_AXIS,ARG1)
 150              CONTINUE
                  IF ( dsum .GT. 0. ) THEN
                     pvar(i) = sqrt(psum)
                  ELSE
                     pvar(i) = 0.
                  ENDIF
 160           CONTINUE

*  Compute the autocorrelation for lag l=0,1,2,...,ND-1

               i1 = arg_lo_ss(X_AXIS,ARG1)
               ir = res_lo_ss(X_AXIS)
               DO 180 i = 1, nd

                  psum = 0.
                  dsum = 0.
                  im = i-1
                  i1 = arg_lo_ss(X_AXIS,ARG1)
                  DO 170 is = 1, nd-im 
                     IF ( arg_1(i1+im,j1,k1,l1,m1,n1)
     .                    .NE. bad_flag(ARG1) .AND.
     .                    arg_1(i1,   j1,k1,l1,m1,n1)    
     .                    .NE. bad_flag(ARG1) ) THEN
                        bsize = (box(is+im) + box(is)) / 2.
                        diff  = arg_1(i1+im,j1,k1,l1,m1,n1) - pmean(i)
                        diff2 = arg_1(i1,   j1,k1,l1,m1,n1) - pmean(1)
                        psum = psum + bsize * diff * diff2
                        dsum = dsum + box(is+im) * box(m)
                     ENDIF
                     i1 = i1 + arg_incr(X_AXIS,ARG1)
 170              CONTINUE

                  IF ( pvar(1) .NE. 0.   .AND.  
     .                 pvar(i) .NE. 0.   .AND. 
     .                 psum    .NE. 0. ) THEN
                     result(ir,j,k,l,m,n) = psum / (pvar(1) * pvar(i))
                  ELSE
                     result(ir,j,k,l,m,n) = bad_flag_result
                  ENDIF

                  i1 = i1 + arg_incr(X_AXIS,ARG1)
                  ir = ir + res_incr(X_AXIS)
 180           CONTINUE

               j1 = j1 + arg_incr(Y_AXIS,ARG1)
 200        CONTINUE

            k1 = k1 + arg_incr(Z_AXIS,ARG1)
 300     CONTINUE

         l1 = l1 + arg_incr(T_AXIS,ARG1)
 400  CONTINUE

         m1 = m1 + arg_incr(E_AXIS,ARG1)
 500  CONTINUE

         n1 = n1 + arg_incr(F_AXIS,ARG1)
 600  CONTINUE

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	SUBROUTINE PUT_ARG5_LINE( src, axis, axmin, axmax, offset,
     .				  i, j, k, l, m, n, line )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* put a single line of data along designateded axis into a memory variable
* Note that whatever the axis orientation, the corresponging index position
* from the i,j,k,l,m,n arguments is irrelevant
* The offset arg is a hack to allow the index limits on thesrc and line to
* be offset from one another by a constant 

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V698+ *sh* 5/15 -- derived from EXTRACT_ARG1_LINE

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include	'xmem_subsc.cmn'

* calling argument declarations:
	INTEGER	axis, axmin, axmax, offset, i, j, k, l, m, n
        REAL    src(m5lox:m5hix,m5loy:m5hiy,m5loz:m5hiz,
     .              m5lot:m5hit,m5loe:m5hie,m5lof:m5hif )
	REAL    line(axmin:axmax)

* internal variable declarations:
	INTEGER	ss

* extract the line
	IF (axis .EQ. x_dim) THEN
	   DO ss = axmin, axmax
	      src(ss-offset, j, k, l, m, n) = line(ss)
	   ENDDO
	ELSEIF (axis .EQ. y_dim) THEN
	   DO ss = axmin, axmax
	      src(i, ss-offset, k, l, m, n) = line(ss)
	   ENDDO
	ELSEIF (axis .EQ. z_dim) THEN
	   DO ss = axmin, axmax
	      src(i, j, ss-offset, l, m, n) = line(ss)
	   ENDDO
	ELSEIF (axis .EQ. t_dim) THEN
	   DO ss = axmin, axmax
	      src(i, j, k, ss-offset, m, n) = line(ss)
	   ENDDO
	ELSEIF (axis .EQ. e_dim) THEN
	   DO ss = axmin, axmax
	      src(i, j, k, l, ss-offset, n) = line(ss)
	   ENDDO
	ELSE    ! f_dim
	   DO ss = axmin, axmax
	      src(i, j, k, l, m, ss-offset) = line(ss)
	   ENDDO
	ENDIF

	RETURN
	END

	SUBROUTINE TAYIS3(TLO,ITIME1,ITIME2,DT,NDAY,LABEL,IMDB,IYDB,
     *	TFACT,X,XFACT,CSIZE,xacross,hgrat,hcolor,hline,color0)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* revised for TMAP
* from PPLUS :
*	Directory PMEL:[PLOT5.PPLV11.PLOTLIB]TAYIS0.FOR

* search for "TMAP" to find all revisions
* *sh*  - 1/23/89 added interrupt detection
*		  ... no explicit declarations (too much trouble !) so it must
*		      be compiled with /WARNINGS=NODECLARATIONS

* *jd* Mod for 4 digit years 11.27.95
* *jd* 11.29.95	Mod century axis
* *jd* 2.8.96 Exclude consideration of seconds when comparing times and
*		deciding whether to continue drawing time axis.  Ferret uses
*		PPLLDX to compute time axis locations rather than the PPL
*		TIME command.  It uses single precision reals which can be
*		rounded.  Rounding can lead to the time axis being drawn too
*		long.
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
C *acm* 03/04  new arguments and code for plotting graticule lines across plot. 
C *acm*  3/10  Bug 670 fixed: New flag MULTICENFLAG for multi-decade plots, 
C              do not make small tics by default.
C v7   *acm*  6/16 Fix ticket 2436: # characters used in time-axis labels 
* *acm* - 8/16   ticket 1787: restore pen 0 correctly after graticule

C**
C**    @(#)tayis3.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     THIS ROUTINE PLOTS A TIME AXIS AND LABELS IT WITH THE MONTH OF THE
C     AND THE YEAR.
C     VARIBLES:
C         TLO=X VALUE CORRESPONDING TO THE START TIME.
C         ITIME1 = START TIME (IE.  770819000000)
C                  WE RESTRICT THE PERMISSIBLE START TIMES TO BE
C                  THE START OF A NEW MONTH.  (THAT IS THE LAST 6 DIGITS
C                  MUST BE 0 AND THE 7'TH AND 8'TH DIGITS MUST BE 01)
C         ITIME2 = END TIME (IE   770901000000)
C                  THIS IS THE FIRST MONTH NOT TO BE PLOTTED, AND IT
C                  MUST BE THE BEGINNING OF A NEW MONTH..
C         DT = SAMPLING RATE IN MINUTES.
C         NDAY = NUM OF DAYS BETWEN SMALL TICS.
C                  IF NDAY = 2HWK THE TICS WILL BE OFFSET
C                  TO CORRESPOND WITH THE START OF NEW WEEKS.
C         LABEL > 0 IF LABELS ARE TO BE DRAWN ABOVE THE AXIS.
C               = 0 IF NO LABELS ARE TO BE DRAWN.
C               < 0 IF LABEL ARE TO BE DRAWN BELOW THE AXIS.
C         IABS(LABEL) = 1 FOR LABELS OF THE STYLE
C                  1..........1..........1..........1..........1
C                      MAR         APR        MAY      JUN
C                                      1980
C         IABS(LABEL) = 2 FOR LABELS OF THE STYLE
C                  1..........1..........1..........1..........1
C                     NOV 80     DEC 80      JAN 81    FEB 81
C         IMDB = PRINT LABELS OF MONTHS DIVIBLE BY THIS NUMBER ONLY.
C                IF(IMDB = 0) PRINT NO MONTH LABELS.
C         IYDB = PRINT LABELS OF YEARS DIVISIBLE BY THIS NUMBER ONLY.
C                IF(IYDB = 0) PRINT NO YEAR LABELS.
C                THIS VARIBLE ONLY APPLYS WHEN IABS(LABEL) = 1
C         TFACT = (LENGTH OF T AXIS IN INCHES)/(LENGTH OF T AXIS IN USER
C         Y = Y COORDINATE OF TIME AXIS.
C         YFACT = (LENGTH OF Y AXIS IN INCHES)/(LENGTH OF Y AXIS IN USER
C         CSIZE = SIZE TO DRAW DAY LABELS.
C                 YEAR LABELS WILL BE 1.5 TIMES AS LARGE.
C
C     THIS PROGRAM WAS FIRST WRITTEN BY DAVID MANDEL IN JULY 1980.
C
	CHARACTER ITIME1*(*),ITIME2*(*)
	CHARACTER ITIME*14,SYM*21,MON*3
	CHARACTER CEN*2,YR*2,ITIME3*14
	COMMON/TICS/TSMX,TLX,TSMY,TLY,IX,IY
	COMMON/AXLWID/XWID,YWID

	LOGICAL*4 not_zero_size
        include 'century.cmn'
        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'lines_inc.decl'
        include 'LINES.INC'
        INCLUDE 'pen_inc.decl'  ! with IPEN(1)
        INCLUDE 'PEN.INC'

* Parameters for drawing tics across plot

        REAL xacross
        REAL dash1_1, dash1_2, dash1_3, dash1_4
        REAL dash2_1, dash2_2, dash2_3, dash2_4
        REAL hgrat(4,2)        ! line type: 0=tics only, <0=line, >0=dash lengths 
        INTEGER hcolor(*)      ! pen number for graticule lines
	INTEGER color0	       ! pen number to restore 
        LOGICAL hline          ! If true, do the lines across.
        LOGICAL solid1, solid2   ! solid lines across at tics
        LOGICAL dashed1, dashed2 ! dashed lines across at tics
        INTEGER ltic, color1, color2

* TMAP interrupt flag
	include 'xinterrupt.cmn'

C     CHECK THE PARAMETERS PASSED TO THE SUBROUTINE.
	IF(ITIME1(5:10).NE.'010000')STOP ',1'
	IF(ITIME2(5:10).NE.'010000')STOP ',2'
        IF(ITIME1(13:14)//ITIME1(1:12).GE.
     .	   ITIME2(13:14)//ITIME2(1:12)) STOP',3'

C set up for plotting graticules across at tic marks

        solid1 = (hgrat(1,1).LT.0 .AND. hgrat(2,1).LT.0 .AND.  
     .            hgrat(3,1).LT.0 .AND.  hgrat(4,1).LT.0 )
        solid2 = (hgrat(1,2).LT.0 .AND. hgrat(2,2).LT.0 .AND.  
     .            hgrat(3,2).LT.0 .AND.  hgrat(4,2).LT.0 )
        dashed1 = (hgrat(1,1).GT.0 .OR. hgrat(2,1).GT.0 .OR.  
     .            hgrat(3,1).GT.0 .OR.  hgrat(4,1).GT.0 )
        dashed2 = (hgrat(1,2).GT.0 .OR. hgrat(2,2).GT.0 .OR.  
     .            hgrat(3,2).GT.0 .OR.  hgrat(4,2).GT.0 )

        color1 = hcolor(1)
        color2 = hcolor(2)

        IF (dashed1) THEN
           dash1_1 = hgrat(1,1)
           dash1_2 = hgrat(2,1)
           dash1_3 = hgrat(3,1)
           dash1_4 = hgrat(4,1)
        ENDIF
        IF (dashed2) THEN
           dash2_1 = hgrat(1,2)
           dash2_2 = hgrat(2,2)
           dash2_3 = hgrat(3,2)
           dash2_4 = hgrat(4,2)
        ENDIF

C     SET PARAMETERS.

*     *jd Number of arguments of TIME3 calls reduced to 6.  TIME3 uses only
*     the first 6, 'seconds' are not handled.  Done for MAC 7.92

	IF(LABEL+IY.EQ.0)THEN
	    XTEMP=0.0
	ELSE
	    XTEMP=TLY*0.5
	ENDIF
	IF(IABS(LABEL).EQ.1)THEN
	    NC=3
	ELSE IF(IABS(LABEL).EQ.3)THEN
	    NC=1
	ELSE
	    NC=6
	ENDIF
	IF(NDAY.LT.0)THEN
	    IHVY=-6
 	    INML=-5
	ELSE
	    IHVY=-10
	    INML=-6
	ENDIF

	NOT_ZERO_SIZE = .NOT.(INML.EQ.-5.AND.TSMY.EQ.0)
	IF (MULTICENFLAG) NOT_ZERO_SIZE = .FALSE.

	IF(IMDB.NE.0)THEN
	    FIMDB=0.0
	ELSE
	    FIMDB=-1.4
	ENDIF
	IF(LABEL.LT.0) THEN
	    XTEMP1=X-(1.1*CSIZE+XTEMP)/XFACT
	    XTEMP2=X-((4.0+FIMDB)*CSIZE+XTEMP)/XFACT
	    IF (iy.eq.1) xtemp1 = xtemp1 + tly*0.4/xfact
	    IF (iy.eq.1) xtemp2 = xtemp2 + tly*0.4/xfact
	ELSE
	    XTEMP1=X+(0.4*CSIZE+XTEMP)/XFACT
	    XTEMP2=X+((2.5+FIMDB)*CSIZE+XTEMP)/XFACT
	    IF (iy.eq.1) xtemp1 = xtemp1 - tly*0.4/xfact
	    IF (iy.eq.1) xtemp2 = xtemp2 - tly*0.4/xfact
	ENDIF
	IF(LABEL.NE.0)YWID=(4.0+FIMDB)*CSIZE+XTEMP
	T=TLO
	ITIME=ITIME1
	CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
	TYR=T
	CALL PLOT(X,TLO,0,0)

*       Century axis mod
	IF (cenflag) THEN
	   IF (IMON.NE.1) GOTO 10
	
	   IF (MOD(ICEN*100+IYR,IYDB).EQ.0) THEN
	      CALL PLOTT7(X,TLO,XFACT,TFACT,1,IHVY)
	   ELSE
	      IF(NOT_ZERO_SIZE) ! Don't plot zero length tic
     .		CALL PLOTT7(X,TLO,XFACT,TFACT,1,INML)
	   ENDIF
	ELSE
	   IF(IMON.EQ.1)THEN
	      CALL PLOTT7(X,TLO,XFACT,TFACT,1,IHVY)
	   ELSE
	      IF(NOT_ZERO_SIZE) ! Don't plot zero length tic
     .		CALL PLOTT7(X,TLO,XFACT,TFACT,1,INML)
	   ENDIF
	ENDIF

c ----  count number of large tics. If no large tics will be drawn
c ----  then will want to draw graticule lines at the small ones.

      ITIME=ITIME1
      CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
      SECMON=FLOAT(NUMDM1(ITIME))*1440.

C     LOOP:

       ltic = 0
  110  CONTINUE
       CALL TIME1(1,ITIME,2,' ',I3,ITIME3,SECMON)
       CALL TIME3(ITIME3,IYR3,IMON3,IDAY3,IHR3,IMIN3,ISEC3,ICEN3)

       ITIME=ITIME3
       SECMON=FLOAT(NUMDM1(ITIME))*1440.

       IF( ITIME(13:14)// ITIME(1:10).LT.
     .	     ITIME2(13:14)//ITIME2(1:10)) THEN
           IF(IMON3.EQ.1) ltic = ltic + 1
           GO TO 110
       ENDIF

! IF no large tics, and if graticules at just the large tics were
! requested, then plot graticules at the small tics

	IF (ltic .EQ. 0) THEN   
           IF ( (.NOT.solid2) .AND. (solid1) ) THEN
              solid2 = solid1
              color2 = color1
           ENDIF
           IF ( (.NOT.dashed2) .AND. (dashed1) ) THEN 
              dashed2 = dashed1
              dash2_1 = dash1_1
              dash2_2 = dash1_2
              dash2_3 = dash1_3
              dash2_4 = dash1_4
              color2 = color1
           ENDIF
        ENDIF
        
      ITIME=ITIME1
      CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)

c ----

C     LOOP:
10	CALL PLOT(X,T,0,0)
	IF ( interrupted ) RETURN		! TMAP interrupt
	SECMON=FLOAT(NUMDM1(ITIME))*1440.
	TIC=SECMON/DT
	CALL TIME1(1,ITIME,2,' ',I3,ITIME3,SECMON)
	CALL TIME3(ITIME3,IYR3,IMON3,IDAY3,IHR3,IMIN3,ISEC3,ICEN3)

*       Century axis mod
	IF (cenflag) THEN
	   IF (IMON3.NE.1) GOTO 11
	
	   IF (MOD(ICEN3*100+IYR3,IYDB).EQ.0) THEN
	      CALL PLOTT7(X,T+TIC,XFACT,TFACT,1,IHVY)

              IF ((solid1.OR.dashed1) .AND. hline) THEN ! make line across
                 CALL COLOR(color1)
                 IF (dashed1) THEN
                    CALL DASHSZ(dash1_1,dash1_2,dash1_3,dash1_4)
                    CALL DASHES
                 ENDIF
                 CALL PLOT(x,t+tic,0,0) 
                 CALL PLOT(xacross,t+tic,1,0)
                 CALL PLOT(x,t+tic,0,0) 
                 CALL COLOR(color0)
                 CALL VECTRS
              ENDIF
	   ELSE
	      IF(NOT_ZERO_SIZE) THEN ! Don't plot zero length tic
      	         CALL PLOTT7(X,T+TIC,XFACT,TFACT,1,INML)

                 IF ((solid2.OR.dashed2) .AND. hline) THEN ! make line across
                    CALL COLOR(color2)
                    IF (dashed2) THEN
                       CALL DASHSZ(dash2_1,dash2_2,dash2_3,dash2_4)
                       CALL DASHES
                    ENDIF
                    CALL PLOT(x,t+tic,0,0) 
                    CALL PLOT(xacross,t+tic,1,0)
                    CALL PLOT(x,t+tic,0,0) 
                    CALL COLOR(color0)
                    CALL VECTRS
                 ENDIF
              ENDIF
	   ENDIF
	ELSE
	   IF(IMON3.EQ.1)THEN
	      CALL PLOTT7(X,T+TIC,XFACT,TFACT,1,IHVY)

              IF ((solid1.OR.dashed1) .AND. hline) THEN ! make line across
                 CALL COLOR(color1)
                 IF (dashed1) THEN
                    CALL DASHSZ(dash1_1,dash1_2,dash1_3,dash1_4)
                    CALL DASHES
                 ENDIF
                 CALL PLOT(x,t+tic,0,0) 
                 CALL PLOT(xacross,t+tic,1,0)
                 CALL PLOT(x,t+tic,0,0) 
                 CALL COLOR(color0)
                 CALL VECTRS
              ENDIF

	   ELSE
	      IF(NOT_ZERO_SIZE) THEN  ! Don't plot zero length tic
     		CALL PLOTT7(X,T+TIC,XFACT,TFACT,1,INML)
     
                 IF ((solid2.OR.dashed2) .AND. hline) THEN ! make line across
                    CALL COLOR(color2)
                    IF (dashed2) THEN
                       CALL DASHSZ(dash2_1,dash2_2,dash2_3,dash2_4)
                       CALL DASHES
                    ENDIF
                    CALL PLOT(x,t+tic,0,0) 
                    CALL PLOT(xacross,t+tic,1,0)
                    CALL PLOT(x,t+tic,0,0) 
                    CALL COLOR(color0)
                    CALL VECTRS
                 ENDIF

              ENDIF

	   ENDIF
	ENDIF

C         THE LABELS
11	CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
	IF(IMDB.EQ.0.OR.LABEL.EQ.0) GO TO 50
	IF(IMON.NE.IMDB*(IMON/IMDB)) GO TO 50
 	IF (cenflag) GOTO 50 ! No month labels for multiple years

	CALL TIME2(ITIME,SYM)
	READ(SYM,30)MON,CEN,YR
30	FORMAT(6X,A3,4X,A2,A2)
	WRITE(SYM,40)MON,YR
40	FORMAT(A3,' ',A2)
        TSYM=T+(TIC-SYMWID(CSIZE,NC,SYM(:NC))/TFACT)*.5
        CALL SYMBEL(XTEMP1,TSYM,90.,CSIZE,NC,SYM(:NC))
50	CONTINUE
	IF(IYDB.EQ.0.OR.NC.EQ.6) GO TO 70
	IF(IYR.EQ.IYR3) GO TO 70
	IF((ICEN*100+IYR).NE.IYDB*((ICEN*100+IYR)/IYDB)) GO TO 60
C             ELSE:
	IF(T-TYR.GT.83333.33/DT)THEN
	    CALL TIME2(ITIME,SYM)
	    READ(SYM,30)MON,CEN,YR
	    WRITE(SYM,55)CEN,YR
55	    FORMAT(A2,A2)
	    TSYM=TYR+(T+TIC-TYR-SYMWID(1.1*CSIZE,4,SYM(:4))/TFACT)*.5
	    CALL SYMBEL(XTEMP2,TSYM,90.,1.1*CSIZE,4,SYM(:4))
	ENDIF
60	TYR=T+TIC
70	CONTINUE
	ITIME=ITIME3
	T=T+TIC

*** 2.8.96                       IF( ITIME(13:14)// ITIME(1:12).LT.
*** Don't use seconds    .	     ITIME2(13:14)//ITIME2(1:12)) GO TO 10

          IF( ITIME(13:14)// ITIME(1:10).LT.
     .	     ITIME2(13:14)//ITIME2(1:10)) GO TO 10

*     Draw complete time axis -- mods not to draw minor tics require it
      CALL PLOT(X,TLO,0,0)
      CALL PLOT(X,T,1,0)

	IF(IYDB.EQ.0.OR.LABEL.EQ.0) GO TO 80
C     ELSE:
	IF(IABS(LABEL).NE.2.AND.IYR.EQ.IYDB*(IYR/IYDB)
     .	.AND.IMON3.GE.4)THEN
	    CALL TIME2(ITIME,SYM)
	    READ(SYM,30)MON,CEN,YR
	    WRITE(SYM,55)CEN,YR
	    TSYM=TYR+(T-TYR-SYMWID(1.1*CSIZE,4,SYM(:4))/TFACT)*.5
	    CALL SYMBEL(XTEMP2,TSYM,90.,1.1*CSIZE,4,SYM(:4))
	ENDIF
C
C     THE SECTION OF CODE THAT PUTS ON THE SMALL TIC MARKS.
80	IF(NDAY.LE.0)RETURN
	CALL TIME3(ITIME1,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
	CALL TIME3(ITIME2,IYR3,IMON3,IDAY3,IHR3,IMIN3,ISEC3,ICEN3)
	IDELT=12*(IYR3-IYR)+IMON3-IMON
	ITIME=ITIME1
	TIC=NDAY*1440./DT
	T1=TLO
	DO 90 I=1,IDELT
	T=T1
	IDUDE=NUMDM1(ITIME)
	NSTIC=IDUDE/NDAY
	DO 100 J=1,NSTIC
	T=T+TIC
	CALL PLOT(X,T,0,0)
	CALL PLOTT7(X,T,XFACT,TFACT,1,-5)
C
100	CONTINUE
	IF(IMON.EQ.12)THEN
	    IYR=IYR+1
	    IMON=1
	ELSE
	    IMON=IMON+1
	ENDIF
	WRITE(ITIME,999)IYR,IMON,IDAY,IMIN,ISEC
999	FORMAT(5I2.2)
	T1=T1+IDUDE*1440./DT
90	CONTINUE
	END

	SUBROUTINE CD_DSG_CHECK_TIMECOORD (nfeatures, obs_len, row_size_lm,
     .					   t_coord_lm, errstr, status)


* check the time data: is it monotonically increasing?  For now this is
* an error; later perhaps we'll sort unsorted data internally? This checks 
* for strict monotonic.  Could perhaps use tm_check_coords-type logic

* Also check that the row-size variable sums to the obs-dimlen

* V7.6 *acm* 6/20 Issue 1980: When possible open invalid DSG datasets anyway with NOTES.

	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
        include 'xdyn_linemem.cmn_text'


	INTEGER nfeatures, obs_len, row_size_lm, t_coord_lm, status
	CHARACTER*(*) errstr

	INTEGER i, irow, base, n_in_row, iobs, nrow, tsiz
	REAL	clast, coord

* Is time in the feature-direction, e.g. for a profile dataset?
* If so no need to check time.
	tsiz = lm_size(t_coord_lm)
	IF (tsiz .EQ. nfeatures) THEN
	   status = merr_ok
	   GOTO 5000
	ENDIF

	base = 0
	DO irow = 1, nfeatures 

	   n_in_row = dsg_linemem(row_size_lm)%ptr(irow)
	   clast = 0.

	   IF ( base+n_in_row .GT. obs_len) GOTO 5200
	   DO i = 1, n_in_row
	      iobs = base + i
	      coord = dsg_linemem(t_coord_lm)%ptr(iobs)
	      IF (i.GT.1) THEN
	         IF (coord-clast .LT. 0.) GOTO 5100  ! not monotonic
	      ENDIF
	      clast = coord

	   ENDDO
	   base = base + n_in_row
	ENDDO

	IF (base .NE. obs_len) GOTO 5200

	status = merr_ok

 5000	RETURN

 5100   errstr = 'Time coordinates are not increasing within each feature. '//
     .     'Data must be sorted by time.'
	 status = merr_dsg_grid
	GOTO 5000
 5200   errstr = 'Row-size data must sum to the length of the observation axis.'
	status = merr_dsg_grid
	GOTO 5000

	END

	SUBROUTINE INIT_AGGREGATE_DSET (dname, dtitle, agg_dset, 
     .     agg_quiet, agg_hide, status )
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP 
*
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V685 4/13 *acm* Ability to define ensemble with /HIDDEN
*                 Get grid of user-vars, allow more combinations with user vars
*                 better error handling.

      IMPLICIT NONE
        include 'tmap_errors.parm'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xdset_info.cd_equiv'
        include 'xprog_state.cmn'
	include 'xtm_grid.cmn_text'  
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xfr_grid.cmn'

* calling argument declarations:
	CHARACTER*(*)	dname, dtitle
	INTEGER		agg_dset, status
	LOGICAL		agg_quiet, agg_hide

* local variable declarations:
	LOGICAL	match, has_uvars
	INTEGER	TM_LENSTR, TM_LENSTR1, STR_SAME, NCF_DELETE_DSET,
     .		NCF_ADD_AGG_MEMBER, NCF_GET_AGG_MEMBER_INFO, 
     .          KNOWN_GRID,
     .		iset, dset, item, ii,
     .		perm(nferdims), nsets, member_sets(maxdsets), 
     .		imatch, nv, grid, igrid, idim, ivar, nvars, iline, 
     .		slen, memb_var, memb_dset, memb_grid, ugrid, 
     .		type, fvar
	CHARACTER vname*128
	CHARACTER TM_STRING*13

* check to see if this name matches an already-open dataset name.
* if so, thats an error

	DO 100 iset = 1, maxdsets
           match = ds_name(iset) .EQ. dname
           IF ( match ) GOTO 5100
  100	CONTINUE

* See if requested datasets are open and if not, try to open them.

	CALL CHECK_MEMBER_SETS (nsets, member_sets, status)
	IF (status .NE. ferr_ok .OR. nsets .EQ. 0) GOTO 9950

* Ok, all the member datasets are open and available

* Assign aggregate data set number, exiting if maximum number 
* of data sets are open

	DO 200 iset = 1,maxdsets
	  IF (ds_name(iset) .EQ. char_init1024) THEN
	    agg_dset = iset
	    GOTO 220
	  ENDIF
  200	CONTINUE

* Too many data sets are open
	CALL TM_ERRMSG ( merr_dsetlim, status, 'INIT_AGGREGATE_DSET',
     .			 no_descfile, no_stepfile,
     .			 'MAX='//TM_STRING(DBLE(maxdsets)),
     .			 no_errstring, *9950)
 220	CONTINUE

* Create datset. Will delete it later if there are no aggregate variables found.

	CALL CREATE_AGG_DSET (agg_dset, dname, dtitle, nsets, 
     .			 e_dim, iline, status)  
	IF (status .NE. ferr_ok) GOTO 5300

* See what variables are shared by all the datsets

	dset = member_sets(1)
	nvars = 0
	
	DO 800 ivar = 1, maxvars
           IF ( ds_var_setnum(ivar) .NE. dset ) GOTO 800
	   vname = ds_var_code(ivar)
	   imatch = 1
	   DO 400 ii = 2, nsets
	      iset = member_sets(ii)
              DO 300 nv = 1, maxvars
	         IF ( (ds_var_setnum(nv) .EQ. iset) .AND.
     .                (STR_SAME(ds_var_code(nv), vname) .EQ. 0) ) THEN
                    imatch = imatch + 1
		 ENDIF
  300	      CONTINUE

* See if a user-defined LET/D variable name matches
              DO 350 nv = 1, maxvars
	         IF ( (uvar_dset(nv) .EQ. iset) .AND.
     .                (STR_SAME(uvar_name_code(nv), vname) .EQ. 0) ) THEN
                    imatch = imatch + 1
	      ENDIF
  350	      CONTINUE

  400	   CONTINUE

           IF (imatch .NE. nsets) THEN
	      IF ( .NOT.agg_quiet ) 
     .	         CALL WARN('Exclude variable from aggregate. '//
     .	         'Does not appear in all member datasets: '//
     .	         vname)
	      GOTO 800 ! Variable not in all datasets
	   ENDIF

           grid = ds_grid_number(ivar)
	   IF (grid_line(e_dim, grid) .NE. 0) GOTO 5400

* Check that grids match for file variables. 
* NOTE if the variables in the member datasets share the same grid, and
*      there is a record axis, then they may have different timesteps but 
*      grid_line and ds_grid_start, ds_grid_end will have the same contents.
*      How to find that case? (check line_mem) Or just allow it?

           imatch = 1
	   has_uvars = .FALSE.
           DO 600 ii = 2, nsets
	      iset = member_sets(ii)
              DO 500 nv = 1, maxvars
	         IF ( (ds_var_setnum(nv) .EQ. iset) .AND. 
     .                (STR_SAME(ds_var_code(nv), vname) .EQ. 0) ) THEN
                    igrid = ds_grid_number(nv)
		    DO 550 idim = 1, nferdims
		       IF ( grid_line(idim, grid) .NE.  
     .                      grid_line(idim, igrid) ) GOTO 500
  550	            CONTINUE
                    imatch = imatch + 1
		 ENDIF
	         IF ( (uvar_dset(nv) .EQ. iset)   .AND. 
     .                (STR_SAME(uvar_name_code(nv), vname) .EQ. 0) ) THEN

	            CALL GET_UVAR_GRID( nv, iset, status )
	            IF ( status .NE. ferr_ok ) GOTO 5600
	            igrid = KNOWN_GRID(iset,cat_user_var,nv)

	            IF (igrid .NE. grid) THEN
		    DO 555 idim = 1, nferdims
		       IF ( grid_line(idim, grid) .NE.  
     .                      grid_line(idim, igrid) ) GOTO 500
  555	            CONTINUE
                    ENDIF
		    imatch = imatch + 1 

		    has_uvars = .TRUE.
	         ENDIF
  500	      CONTINUE
  600	   CONTINUE

*  variable in all datsets but they dont have the same grid.
	   IF (imatch .NE. nsets) THEN
	      IF ( .NOT.agg_quiet ) 
     .	         CALL WARN('Exclude variable from aggregate. '//
     .	         'Grid differs in member datasets: '//
     .	         vname)
	      GOTO 800 
	   ENDIF
	      
* same grid for this variable in all datasets 
	   
           nvars = nvars + 1
c	   IF (has_uvars) grid = unspecified_int4
	   CALL DEFINE_AGGREGATE_GRID (agg_dset, nvars, vname,
     .           ivar, iline, grid, e_dim, member_sets, nsets)
	   IF (status .NE. ferr_ok) GOTO 5000

  800   CONTINUE

* See if user-defined (LET/D=) variables from the first dataset are 
* shared by all the datsets

	dset = member_sets(1)
	DO 1800 ivar = 1, maxvars
           IF ( uvar_dset(ivar) .NE. dset ) GOTO 1800
	   vname = uvar_name_code(ivar)
	   imatch = 1

	   grid = unspecified_int4
	   DO 1400 ii = 2, nsets
	      iset = member_sets(ii)
              DO 1300 nv = 1, maxvars
	         IF ( (ds_var_setnum(nv) .EQ. iset) .AND.
     .                (STR_SAME(ds_var_code(nv), vname) .EQ. 0) ) THEN
                    imatch = imatch + 1
		    grid = ds_grid_number(nv)
		    fvar = nv

		 ENDIF
 1300	      CONTINUE

* See if a user-defined LET/D variable name matches
              DO 1350 nv = 1, maxvars
	         IF ( (uvar_dset(nv) .EQ. iset) .AND.
     .                (STR_SAME(uvar_name_code(nv), vname) .EQ. 0) ) THEN

                    imatch = imatch + 1
		 ENDIF
 1350	      CONTINUE

 1400	   CONTINUE

	   IF (imatch .NE. nsets) THEN
	      
	      IF ( .NOT.agg_quiet ) 
     .	         CALL WARN('Exclude variable from aggregate. '//
     .	         'Does not appear in all member datasets: '//
     .	         vname)
               GOTO 1800 ! Variable not in all datasets
	   ENDIF

* If one dataset contains the variable then we will be able to define the grid.
	   
	   IF (grid .NE. unspecified_int4) THEN

              nvars = nvars + 1

c	      grid = unspecified_int4
	      CALL DEFINE_AGGREGATE_GRID (agg_dset, nvars, vname,
     .           fvar, iline, grid, e_dim, member_sets, nsets)
	      IF (status .NE. ferr_ok) GOTO 5000

* Do not include variables that are entirely user-defined.
	   ELSE
	      IF ( .NOT.agg_quiet ) 
     .	         CALL WARN('Exclude variable from aggregate. '//
     .	         'Must be a file variable in at least one member dataset: '//
     .	         vname)

	   ENDIF

 1800	CONTINUE

* If no variables from the datasets match, delete this dataset. 

	if (nvars .EQ. 0) goto 5500

* Add aggregate members to aggregate dataset

	DO 2000 iset = 1, nsets
	   status = NCF_ADD_AGG_MEMBER (agg_dset, member_sets(iset)) 
 2000	CONTINUE

	IF (dtitle(1:2) .NE. char_init) THEN
	   ds_title(agg_dset) = dtitle
	ELSE
	   ds_title(agg_dset) = 'Ensemble'
	ENDIF
	ds_mod_title(agg_dset) = ' '
	ds_time_axis(agg_dset) = ds_time_axis(member_sets(1))
	ds_format(agg_dset) = ds_format(member_sets(1))
 
* set use counts and clean up temporary grids and axes for agg. dset
	CALL TM_GARB_COL_GRIDS(agg_dset)

* If user requested /HIDE, then mark the member datasets for
* hidden status on SHOW DATA commands
	
	IF (agg_hide) THEN
 	   DO 2100 iset = 1, nsets
	      ds_hide (iset) = .TRUE. 
 2100	   CONTINUE
	ENDIF

 5000   RETURN	

* Errors: too-many datasets open so aggregate dataset can't be opened,
* or error on a member dataset. 
* ?? If some member datasets were opened, close them??)
* Return no-dataset-number.

 9950	agg_dset = unspecified_int4
	status = ferr_TMAP_error
	GOTO 5000
 9960	CALL CANCEL_DATA_SET( agg_dset, .FALSE., status )
	agg_dset = unspecified_int4
	GOTO 5000

 5100   CALL ERRMSG( ferr_syntax,status,'dataset name already in use:'
     .		//dname(:TM_LENSTR1(dname)), *5000 )
     
 5300	CALL ERRMSG( ferr_aggregate_error, status, ' ', *9950 )

 5400	CALL ERRMSG( ferr_TMAP_error, status,
     .		' Variables in member datasets already '
     .		//'have axis in the E direction', *9950 )

 5500	CALL ERRMSG( ferr_aggregate_error, status,
     .		'No valid datasets or datasets share no variables. ', 
     .		*9960 )

 5600	CALL ERRMSG( ferr_aggregate_error, status,
     .		'Could not get grid for user-defined variables '
     .		//uvar_name_code(nv)(:TM_LENSTR1(uvar_name_code(nv))), 
     .		*9960 )
	END

*
* convolvei.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
** Ansley Manke
* Feb 1999
* V6.2 2/2009 Fix bug 1640; treatment of missing data was incorrect.
*     03/2012 *kms* Fix bug 1928 - do not exceed bounds with an even number of weights
*
*
* This external function convolves the component grid, com, with the weight 
* function, wt  along the I axis (see Ferret routine CONVOLVE)
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE convolvei_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CHARACTER*100 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT ('Convolve I component of variable with weight function')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 2)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'COM')
      CALL ef_set_arg_desc(id, arg, 
     .  'Variable in X (and perhaps Y,Z,T,E,F) to convolve')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'WEIGHT')
      CALL ef_set_arg_desc(id, arg, 'Weight function')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE convolvei_compute (id, arg_1, arg_2, result )

*
*
*  From FERRET subroutine CONVOLVE, for the i-axis.
*
* convolve the component grid, com, with the weight function, wt
* along axis idim
* note: the component context may not be of adequate size for the full
*       calculation.  Missing data flags will be inserted where computation is
*       impossible
* also: when bad data points are encountered in the component data all
*       result data depending on it are flagged as bad, too

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      REAL comp, sum, weight
      REAL xlen, ylen, zlen, tlen, elen, flen
      INTEGER i, j, k, l, m, n
      INTEGER hlo, hhi, ii, wlen
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2


      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)
      
* CONVOLVE ALONG X AXIS (arg_1) using weights (arg_2)

* Half the weighting function; weights from -hlen to hlen (now: hlo to hhi)

      xlen = (arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1) 
      ylen = (arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) + 1) 
      zlen = (arg_hi_ss(Z_AXIS,ARG2) - arg_lo_ss(Z_AXIS,ARG2) + 1) 
      tlen = (arg_hi_ss(T_AXIS,ARG2) - arg_lo_ss(T_AXIS,ARG2) + 1) 
      elen = (arg_hi_ss(E_AXIS,ARG2) - arg_lo_ss(E_AXIS,ARG2) + 1) 
      flen = (arg_hi_ss(F_AXIS,ARG2) - arg_lo_ss(F_AXIS,ARG2) + 1) 

      wlen = MAX(xlen, ylen, zlen, tlen, elen, flen)
      hhi = wlen / 2
      hlo = (-1) * hhi
      IF ( MOD(wlen,2) .EQ. 0 ) hlo = hlo + 1

      n1 = arg_lo_ss(F_AXIS,ARG1)
      DO 700 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
       
         m1 = arg_lo_ss(E_AXIS,ARG1)
         DO 600 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
       
            l1 = arg_lo_ss(T_AXIS,ARG1)
            DO 500 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
       
               k1 = arg_lo_ss(Z_AXIS,ARG1)
               DO 400 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

                  j1 = arg_lo_ss(Y_AXIS,ARG1)
                  DO 300 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

                     i1 = arg_lo_ss(X_AXIS,ARG1)
                     DO 200 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS) 

                        sum = 0.0
                        i2 = arg_lo_ss(X_AXIS,ARG2)
                        j2 = arg_lo_ss(Y_AXIS,ARG2)
                        k2 = arg_lo_ss(Z_AXIS,ARG2)
                        l2 = arg_lo_ss(T_AXIS,ARG2)
                        m2 = arg_lo_ss(E_AXIS,ARG2)
                        n2 = arg_lo_ss(F_AXIS,ARG2)

                        DO 100 ii = hlo, hhi

                           IF (i1+ii .LT. arg_lo_ss(X_AXIS,ARG1)  .OR.
     .                         i1+ii .GT. arg_hi_ss(X_AXIS,ARG1) ) THEN
                              result(i,j,k,l,m,n) = bad_flag_result
                              GOTO 190
                           ELSE
                              comp = arg_1(i1+ii,j1,k1,l1,m1,n1)
                              IF ( comp .EQ. bad_flag(ARG1) ) THEN
                                 result(i,j,k,l,m,n) = bad_flag_result
                                 GOTO 190                  
                              ENDIF
                              weight = arg_2(i2,j2,k2,l2,m2,n2)
                              sum = sum + comp * weight
                           ENDIF

                           i2 = i2 + arg_incr(X_AXIS,ARG2)
                           j2 = j2 + arg_incr(Y_AXIS,ARG2)
                           k2 = k2 + arg_incr(Z_AXIS,ARG2)
                           l2 = l2 + arg_incr(T_AXIS,ARG2)
                           m2 = m2 + arg_incr(E_AXIS,ARG2)
                           n2 = n2 + arg_incr(F_AXIS,ARG2)

 100                    CONTINUE
                        result(i,j,k,l,m,n) = sum

 190                    i1 = i1 + arg_incr(X_AXIS,ARG1)
 200                 CONTINUE

                     j1 = j1 + arg_incr(Y_AXIS,ARG1)
 300              CONTINUE

                  k1 = k1 + arg_incr(Z_AXIS,ARG1)
 400           CONTINUE

               l1 = l1 + arg_incr(T_AXIS,ARG1)
 500        CONTINUE

            m1 = m1 + arg_incr(E_AXIS,ARG1)
 600     CONTINUE

         n1 = n1 + arg_incr(F_AXIS,ARG1)
 700  CONTINUE

      RETURN
      END

*
* pick_a_string.F
*
* Ansley Manke
* 15-dec-2003
*
* This function chooses an element element of the first
* argument, which is a 1-D string array, and we choose
* the element given by the (scalar) second argument
* 
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE pick_a_string_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

      CALL ef_version_test(ef_version)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     . 'Demo Function: sets result equal to one element of input' )

      CALL ef_set_num_args(id, 2)
      CALL ef_set_axis_inheritance(id, ABSTRACT, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_result_type(id, STRING_RETURN)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, '1-D string argument')
      CALL ef_set_axis_influence(id, arg, NO, YES, YES, YES)
      CALL ef_set_arg_type (id, arg, STRING_ARG)
      
      arg = 2
      CALL ef_set_arg_name(id, arg, 'N')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id,arg,'Pick Nth element in the X direction')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
      CALL ef_set_arg_type (id, arg, FLOAT_ARG)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


      SUBROUTINE pick_a_string_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*     You could use utility functions at this point to get 
*     context information about the other arguments.  This info 
*     could be used to update the custom or abstract axis lo and hi
*     indices.

      call ef_set_axis_limits(id, X_AXIS, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END




*
* In this subroutine we compute the result
*
      SUBROUTINE pick_a_string_compute(id, arg_1, arg_2, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result


* Single precision Ferret: string arg and result need to be twice the length.
      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif

      REAL arg_1(strdf,mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem1hix, mem2loy:mem1hiy, 
     .           mem2loz:mem1hiz, mem2lot:mem1hit)
      REAL result(strdf,memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1
      INTEGER indx, nx
      REAL value
      CHARACTER*40 err_msg
      
      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      CALL ef_get_one_val(id, 2, value)
      indx = value
      nx = arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 1
      IF (indx .LT. 1 .OR. indx .GT. nx) THEN
         WRITE (err_msg, *) 'Argument 2 too small or large. NX=', nx
         CALL EF_BAIL_OUT (id, err_msg)
      ENDIF

      i1 = indx

      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               l1 = arg_lo_ss(T_AXIS,ARG1)
               DO 100 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

c                  CALL EF_GET_STRING_ARG_ELEMENT (id, ARG1, arg_1, 
c     .                               i1,j1,k1,l1, slen, textstring)
c                  CALL EF_PUT_STRING (textstring, slen, result(1,i,j,k,l))

                   CALL EF_PUT_STRING_PTR(arg_1(1,i1,j1,k1,l1),
     .                            result(1,i,j,k,l) )

                  l1 = l1 + arg_incr(T_AXIS,ARG1)
 100           CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 300     CONTINUE

 400   CONTINUE

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	SUBROUTINE DEALLO_ALL_AXES

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Deallocates all axis (line) slots defined by user 
* Does not deallocate the first group of "protected" axes.
* ACM 6/11/2002
*
* V5.41 7/30/02 ACM Deallocate irregular dynamic axes defined by files too,
*               by calling PACK_LINE_STORAGE.
* V5.42 10/31/02 ACM Check to see if axes are in use, and if so dont remove!
* V5.42 11/06/02 ACM line_keep_flag(islot) is a logical, use .FALSE. not 0.
* V600 10/28/05 ACM Fix bug 1354: cancel data should recover coordinate storage

* Parameters and commons

        IMPLICIT NONE
	include	'tmap_dims.parm'
#	include	"tmap_dset.parm"
	include	'tmap_errors.parm'
        include 'xtm_grid.cmn_text'
        include 'ferret.parm'
	include 'errmsg.parm'

* Local declarations

	INTEGER TM_GET_LINENUM, TM_GET_GRID_OF_LINE,
     .          islot, grid, status, num_protected_axes

* Remove axis names

	num_protected_axes = TM_GET_LINENUM( 'EZ' )  ! top protected axis

        IF (num_protected_axes .EQ. unspecified_int4 .OR.
     .      num_protected_axes .LE. 0) num_protected_axes = 1

        DO 100 islot = num_protected_axes+1, line_ceiling
           IF (line_name(islot) .NE. char_init16) THEN

	      line_keep_flag(islot) = .FALSE.  ! see xeq_cancel.F
              IF (line_use_cnt(islot) .LE. 0) THEN
	         IF ( islot .LE. max_lines ) THEN
                    IF (.NOT. line_regular(islot)) 
     .                  CALL FREE_LINE_DYNMEM(islot)
		    line_regular(islot) = .TRUE.
		    line_name(islot) = char_init16
	         ELSE
	            CALL TM_DEALLO_DYN_LINE(islot)
	         ENDIF
              ELSE

*     ... cannot delete - in use.  Locate the grid that is using it.

	         grid = TM_GET_GRID_OF_LINE( islot )
	         CALL WARN( 'Not deleted: '//line_name(islot))
	         IF ( grid .NE. unspecified_int4 ) THEN
	            CALL WARN( 
     .		      'Axis is in use by grid '//grid_name(grid))
	         ELSE
	            CALL ERRMSG(ferr_internal, status,
     .				'axis use count err', *5000)
	         ENDIF
	      ENDIF

           ENDIF

  100	CONTINUE

	RETURN

* error exits
 5000	RETURN

	END

      SUBROUTINE INHERIT_ATTRS (varname1, varname2, status)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*

* Get all attributes from varname1, a variable in dataset dset1, and assign to the 
* variable in varname2, dataset dset2.  dset2 has been determined in xeq_set.F
* V600  4/06 *acm*   attribute handling
* V600  4/06 *acm* - additional declarations found by Solaris compiler
* V670  2/11 *acm*   Fixes for inheriting attributes.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V698  2/16 *acm* For ticket 2352: variables defined with LET/D are
*                  added to that dataset in the attribute structure.
* v71   7/16 *acm* Fix ticket 2447: special handling of missing-value flags
*                  when inheriting all attributes from one variable to another.
* V720 *acm* 5/17 Implement specific calls in place of CD_GET_VAR_INFO

      INCLUDE 'tmap_dims.parm'
      INCLUDE 'ferret.parm'
      INCLUDE 'errmsg.parm'      
      INCLUDE 'xprog_state.cmn'
      INCLUDE 'xvariables.cmn'
      INCLUDE 'xcontext.cmn'

* Argument declarations
      CHARACTER varname1*(*), varname2*(*)
      INTEGER status

* Local variable declarations
      LOGICAL CD_ISIT_COORDVAR
      INTEGER TM_LENSTR, STR_SAME, slen, tlen, dset1, dset2, 
     .  varid1, varid2, nvatts1, nvatts2,
     .  iatt, first_quote, next_quote, dot, mr, cx, 
     .  cat, iflag, attnum
      CHARACTER*128 attname, buff1, buff2

* Check that neither buffer contains varname.attname (If it is in 
* quotations then the dot is part of the variable name.)

      tlen = TM_LENSTR(varname1) 
      first_quote = INDEX(varname1(1:tlen), "'" )
      next_quote = INDEX(varname1(2:tlen), "'" )

      IF (INDEX(varname1,'.') .NE. 0 ) THEN
         dot = INDEX(varname1,'.')
         IF (dot .GT. first_quote .AND. dot .LT. next_quote) GOTO 5010
      ENDIF

* and now for varname2
      tlen = TM_LENSTR(varname2) 

      first_quote = INDEX(varname2(1:tlen), "'" )
      next_quote = INDEX(varname2(2:tlen), "'" )

      IF (INDEX(varname2,'.') .NE. 0 ) THEN
         dot = INDEX(varname2,'.')
         IF (dot .GT. first_quote .AND. dot .LT. next_quote) GOTO 5010
      ENDIF

* Do the varnames contain dataset specifications?
* evaluate the context without computing the expression to get the dataset

      CALL GET_NEW_CX( cx_last, cx_cmnd, .TRUE., status )
      IF ( status .NE. ferr_ok ) GOTO 5000
 
      CALL EVAL_CONTEXT ( cx_cmnd, varname1, status )
      IF ( status .NE. ferr_ok ) GOTO 5000

      mr = is_mr( 1 )
      cx = is_cx( 1 )

      dset1 = cx_data_set(cx) 
      IF (dset1 .EQ. pdset_irrelevant) dset1 = cx_data_set(cx_last) 

      cat = cx_category(cx)
      IF (cat .EQ. cat_user_var) dset1 = pdset_uvars

      CALL GET_NEW_CX( cx_last, cx_cmnd, .TRUE., status )
      IF ( status .NE. ferr_ok ) GOTO 5000
 
      CALL EVAL_CONTEXT ( cx_cmnd, varname2, status )
      IF ( status .NE. ferr_ok ) GOTO 5000

      mr = is_mr( 1 )
      cx = is_cx( 1 )

      dset2 = cx_data_set(cx) 
      IF (dset2 .EQ. pdset_irrelevant) dset2 = cx_data_set(cx_last) 

      cat = cx_category(cx)

* Get varid for each variable.
      CALL CD_GET_VAR_ID (dset1, varname1, varid1, status)
      IF (status .NE. ferr_ok) GOTO 5050
      CALL CD_GET_VAR_ID (dset2, varname2, varid2, status)
      IF (status .NE. ferr_ok) THEN
         IF (cat .EQ. cat_user_var) dset2 = pdset_uvars 
	 CALL CD_GET_VAR_ID (dset2, varname2, varid2, status)
      ENDIF
      IF (status .NE. ferr_ok) GOTO 5050

* Get number of attributes for variables

      IF (CD_ISIT_COORDVAR(dset1, varid1, varname1, status)) GOTO 5020
      CALL CD_GET_VAR_NATTS (dset1, varid1, varname1, nvatts1, status)

      IF (CD_ISIT_COORDVAR(dset2, varid2, varname2, status)) GOTO 5020
      CALL CD_GET_VAR_NATTS (dset2, varid2, varname2, nvatts2, status)

* Remove attributes from variable 2
* When an attribute is deleted, the following attributes move forward
* so need to keep asking for the first attribute not skipped

      attnum = 1
      DO 100 iatt = 1, nvatts2
         CALL CD_GET_VAR_ATT_NAME (dset2, varid2, attnum, attname, status)
         IF ( STR_SAME(attname, 'missing_value')  .NE. 0 .AND.
     .        STR_SAME(attname, '_FillValue') .NE. 0 ) THEN
            CALL CD_DELETE_ATTRIBUTE (dset2, varid2, attname, status)
            IF (status .NE. ferr_ok) GOTO 5030
         ELSE
            attnum = attnum + 1
         ENDIF
 100  CONTINUE

* Get attribute information from variable 1 and put onto variable 2.
* Do this in the c library so we dont have to define a fixed string for
* string type attributes.

      iflag = 1
      DO 200 iatt = 1, nvatts1
         CALL CD_GET_VAR_ATT_NAME (dset1, varid1, iatt, attname, status)
	 IF (STR_SAME(attname, 'missing_value')  .NE. 0 .AND.
     .       STR_SAME(attname, '_FillValue') .NE. 0) THEN

            CALL CD_TRANSFER_ATTRIBUTE (dset1, varid1, iatt, 
     .        dset2, varid2, status)
            IF (status .NE. ferr_ok) GOTO 5040
	    CALL CD_SET_ATT_FLAG (dset2, varid2, attname, iflag, status)
            IF (status .NE. ferr_ok) GOTO 5040
	 ENDIF
 200  CONTINUE

* Update attribute information used by plotting etc (ds_units, ...)

        CALL UPDATE_ATTRIBUTES (dset2, varname2, varid2, status)
        IF (status .NE. ferr_ok) GOTO 5040

 5000 RETURN

 5010 CALL ERRMSG( ferr_invalid_command, status,
     .  'Use SET ATT/LIKE=var2 var1 without attribute names', *5000 )

 5020 CALL ERRMSG (ferr_invalid_command, status,
     . 'Cannot inherit attributes to/from coordinate variables', *5000)

 5030 buff2 = varname2
      CALL ERRMSG (ferr_internal, status,
     . 'Error removing attributes from '//buff2(:tlen), *5000)

 5040  slen = TM_LENSTR(varname1)
       buff1 = varname1
       CALL ERRMSG (ferr_internal, status,
     . 'Error transferring attributes from '//buff1(:slen)//' to '//
     .  buff2(:tlen), *5000)

 5050  slen = TM_LENSTR(varname1)
       buff1 = varname1
       CALL ERRMSG (ferr_var_not_in_set, status,
     . varname1(:slen),*5000)

 5060  slen = TM_LENSTR(varname1)
       buff1 = varname1
       CALL ERRMSG (ferr_var_not_in_set, status,
     . varname1(:slen),*5000)

      END

*
* nco_attr.F
*
* Ansley Manke
* March 1, 2005
*
* This function spawns a netCDF edit call, ncatted to edit 
* an attribute (e.g. new attribute, edit or delete atttibute,
* or add lines to the global history attribute)
*
* 
*  Notes: 
* 1) our ncatted does not have the i data type.  It returns the messages
* 
* > ncatted -O -h -a missing_value,A,o,i,3 x.nc 
* ncatted: ERROR `i' is not a supported netCDF data type
* ncatted: HINT: Valid data types are `c' = char, `f' = float, `d' = double,`s' = short, `l' = long, `b' = byte

* 2) errors from ncatted do not stop the function from returning normally.

      SUBROUTINE nco_attr_init(id)

* Define arguments and result

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

      CALL ef_set_desc(id, 
     .  'Call ncatted to edit attributes in a netCDF file' )

      CALL ef_set_num_args(id, 6)
      CALL ef_set_axis_inheritance(id, ABSTRACT, NORMAL, NORMAL, 
     .                             NORMAL)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'FileName')
      CALL ef_set_arg_desc(id, arg, 'netCDF file name')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
      CALL ef_set_arg_type(id, arg, STRING_ARG)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'VariableName')
      CALL ef_set_arg_desc(id, arg, 'Variable name (or global)')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
      CALL ef_set_arg_type(id, arg, STRING_ARG)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'AttributeName')
      CALL ef_set_arg_desc(id, arg, 'Attribute to change')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
      CALL ef_set_arg_type(id, arg, STRING_ARG)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'AttType')
      CALL ef_set_arg_desc(id, arg, 'Attribute type')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
      CALL ef_set_arg_type(id, arg, STRING_ARG)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'Mode')
      CALL ef_set_arg_desc(id, arg, 'o=edit, a=append, d=delete')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
      CALL ef_set_arg_type(id, arg, STRING_ARG)

      arg = 6
      CALL ef_set_arg_name(id, arg, 'AttributeValue')
      CALL ef_set_arg_desc(id, arg, 'new value of attribute')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
      CALL ef_set_arg_type(id, arg, STRING_ARG)

      RETURN 
      END

* Define abstract output axis: 1 value

      SUBROUTINE nco_attr_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id
      INTEGER ivalue

      ivalue = 1
      CALL ef_set_axis_limits(id, X_AXIS, ivalue, ivalue)

      RETURN 
      END

*
* Compute the result
*
      SUBROUTINE nco_attr_compute(id, arg_1, arg_2, arg_3, arg_4, 
     .           arg_5, arg_6, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

	  INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz, 
     .           mem4lot:mem4hit)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz, 
     .           mem5lot:mem5hit)
      REAL arg_6(mem6lox:mem6hix, mem6loy:mem6hiy, mem6loz:mem6hiz, 
     .           mem6lot:mem6hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)
 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)

      INTEGER STRINGLEN, arg, blen, slen

      REAL attval, val
      REAL*8 dattval
      INTEGER*2 isattval 
      INTEGER iattval
      CHARACTER*1 battval
      CHARACTER*1 mode, atttype
      CHARACTER*3 atttype_in
      CHARACTER*1024 filename, attributevalue
      CHARACTER*254 variablename, attributename, errmsg
      CHARACTER*2048 buff

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      arg = 1
      CALL ef_get_arg_string(id, arg, filename)
      arg = 2
      CALL ef_get_arg_string(id, arg, variablename)
      arg = 3
      CALL ef_get_arg_string(id, arg, attributename)
      arg = 4
      CALL ef_get_arg_string(id, arg, atttype_in)
      arg = 5
      CALL ef_get_arg_string(id, arg, mode)
      arg = 6
      CALL ef_get_arg_string(id, arg, attributevalue)

      IF (STRINGLEN(atttype_in) .GT. 1) THEN
         CALL EF_BAIL_OUT(id, 
     .       'Attribute type must be f, d, i, l, s, c, or b')
      ELSE
         atttype = atttype_in(1:1)
      ENDIF
      
      IF (atttype .EQ. 'i' .OR. atttype .EQ. 'l' .OR.
     .         atttype .EQ. 'I' .OR. atttype .EQ. 'L') atttype = 'l'

* Check for valid values of mode

      IF (mode .EQ. 'o' .OR. mode .EQ. 'O') THEN
         mode = 'o'
      ELSE IF (mode .EQ. 'a' .OR. mode .EQ. 'A') THEN
         mode = 'a'
      ELSE IF (mode .EQ. 'd' .OR. mode .EQ. 'D') THEN
         mode = 'd'
      ELSE
         CALL EF_BAIL_OUT(id, 'Mode must be o, a, or d')
      ENDIF

* Build the string for the ncatted command
* ncatted -O -h att_nm,var_nm,mode,att_type,att_val filename
* Mode will always be o for overwrite

      buff = 'ncatted -O -h -a '
      blen = 17

      slen = STRINGLEN(attributename)
      buff = buff(1:blen)//attributename(1:slen)//','
      blen = blen + slen + 1

      slen = STRINGLEN(variablename)
      buff = buff(1:blen)//variablename(1:slen)//','//mode(1:1)//','
      blen = blen + slen + 3

      slen = STRINGLEN(atttype)
      buff = buff(1:blen)//atttype(1:slen)//','
      blen = blen + slen + 1

! ncatted -O -h -a cartesian_axis,LAT,o,c,"Z" x.nc

* Read the attribute value based on its type.
* See documentation at the end of this file for attribute types.


      IF (atttype .EQ. 'f' .OR. atttype .EQ. 'F') THEN
         READ (attributevalue,*,err=501) attval
         slen = STRINGLEN(attributevalue)
         buff = buff(1:blen)//attributevalue(1:slen)
         blen = blen + slen

      ELSE IF (atttype .EQ. 'd' .OR. atttype .EQ. 'D') THEN
         READ (attributevalue,*,err=502) dattval
         slen = STRINGLEN(attributevalue)
         buff = buff(1:blen)//attributevalue(1:slen)
         blen = blen + slen

      ELSE IF (atttype .EQ. 'i' .OR. atttype .EQ. 'l' .OR.
     .         atttype .EQ. 'I' .OR. atttype .EQ. 'L') THEN
         READ (attributevalue,*,err=503) iattval
         READ (attributevalue,*,err=503) attval
         val = iattval
         IF (val .NE. attval) GOTO 503
         slen = STRINGLEN(attributevalue)
         buff = buff(1:blen)//attributevalue(1:slen)
         blen = blen + slen

      ELSE IF (atttype .EQ. 's' .OR. atttype .EQ. 'S') THEN
         READ (attributevalue,*,err=504) isattval
         WRITE (attributevalue,*) isattval
         slen = STRINGLEN(attributevalue)
         buff = buff(1:blen)//attributevalue(1:slen)
         blen = blen + slen

      ELSE IF (atttype .EQ. 'c' .OR. atttype .EQ. 'C') THEN
         slen = STRINGLEN(attributevalue)
         buff = buff(1:blen)//'"'//attributevalue(1:slen)//'"'
         blen = blen + slen + 3

      ELSE IF (atttype .EQ. 'b' .OR. atttype .EQ. 'B') THEN
         READ (attributevalue,*,err=505) battval
         slen = STRINGLEN(attributevalue)
         buff = buff(1:blen)//attributevalue(1:slen)
         blen = blen + slen
      ELSE
         CALL EF_BAIL_OUT(id, 
     .       'Attribute type must be f, d, i, s, c, or b')
      ENDIF

* Append the file name

      slen = STRINGLEN(filename)
      buff = buff(1:blen)//' '//filename(1:slen)
      blen = blen + slen + 1

* Spawn the command 

      result(res_lo_ss(X_AXIS), res_lo_ss(Y_AXIS), res_lo_ss(Z_AXIS), 
     .         res_lo_ss(T_AXIS)) = bad_flag_result

      CALL system( buff(1:blen) )

      result(res_lo_ss(X_AXIS), res_lo_ss(Y_AXIS), res_lo_ss(Z_AXIS), 
     .         res_lo_ss(T_AXIS)) = 1

      RETURN 

501   slen = STRINGLEN(attributevalue)
      errmsg = 'Error reading attribute value as floating-point '
     .         //attributevalue(1:slen)
      CALL EF_BAIL_OUT(id, errmsg)

502   slen = STRINGLEN(attributevalue)
      errmsg = 'Error reading attribute value as double-precision '
     .         //attributevalue(1:slen)
      CALL EF_BAIL_OUT(id, errmsg)

503   slen = STRINGLEN(attributevalue)
      errmsg = 'Error reading attribute value as an integer '
     .         //attributevalue(1:slen)
      CALL EF_BAIL_OUT(id, errmsg)

504   slen = STRINGLEN(attributevalue)
      errmsg = 'Error reading attribute value as a short integer '
     .         //attributevalue(1:slen)
      CALL EF_BAIL_OUT(id, errmsg)

505   slen = STRINGLEN(attributevalue)
      errmsg = 'Error reading attribute value as a byte '
     .         //attributevalue(1:slen)
      CALL EF_BAIL_OUT(id, errmsg)

      END


* ncatted documentation: here are the attribute types      
* f    Float. Value(s) specified in att_val will be stored as netCDF intrinsic type NC_FLOAT.
* d    Double. Value(s) specified in att_val will be stored as netCDF intrinsic type NC_DOUBLE.
* i    Integer. Value(s) specified in att_val will be stored as netCDF intrinsic type NC_INT.
* l    Long. Value(s) specified in att_val will be stored as netCDF intrinsic type NC_LONG.
* s    Short. Value(s) specified in att_val will be stored as netCDF intrinsic type NC_SHORT.
* c    Char. Value(s) specified in att_val will be stored as netCDF intrinsic type NC_CHAR.
* b    Byte. Value(s) specified in att_val will be stored as netCDF intrinsic type NC_BYTE. 
* 
* 3.1 netCDF external data types
* 
* The external types supported by the netCDF interface are:
* 
* char    8-bit characters intended for representing text.
* byte    8-bit signed or unsigned integers (see discussion below).
* short  16-bit signed integers.
* int    32-bit signed integers.
* float  real 32-bit IEEE floating-point.
* double 64-bit IEEE floating-point. 


	INTEGER FUNCTION STRINGLEN (strin)

* determine the length of a character string as the position of the last 
* non-blank character 

* from tm_lenstr (use tm_lenstr if this is ever converted to an
* internally-linked function)

* calling argument declarations:
	CHARACTER*(*) strin

* internal variable declarations:
	INTEGER	mright, i

* initialize: find highest possible right hand limit of string
	mright = LEN(strin)

        DO 100 i = mright,1,-1	
           IF (strin(i:i) .NE. ' ') GOTO 200	 
  100   CONTINUE

* for all blanks
        STRINGLEN = 0

* Found non-blank
  200   STRINGLEN = i

	RETURN
	END

*
* transpose_xf.F
* 
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* 3/2017 ACM completing the set of TRANSPOSE functions
* 


      SUBROUTINE transpose_xf_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

      CALL ef_set_desc(id, 'transposes X and F axes of given variable')
      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance_6d(id,
     .                                ABSTRACT,        IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, ABSTRACT)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'VAR')
      CALL ef_set_arg_desc(id, arg, 'variable to transpose in X and F')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, YES, YES, YES, YES, NO)

      RETURN 
      END


      SUBROUTINE transpose_xf_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER lo_x, hi_x, lo_f, hi_f, nx, nf

*     Set the ABSTRACT X and F axes.

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nx = arg_hi_ss(X_AXIS, ARG1) - arg_lo_ss(X_AXIS, ARG1) + 1
      nf = arg_hi_ss(F_AXIS, ARG1) - arg_lo_ss(F_AXIS, ARG1) + 1

*     The below has the effect of translating any sub-matrix so that
*     the indices will always begin at 1 as expected for an abstract axis.

      lo_x = 1
      hi_x = nf
      lo_f = 1
      hi_f = nx

      CALL ef_set_axis_limits(id, X_AXIS, lo_x, hi_x)
      CALL ef_set_axis_limits(id, F_AXIS, lo_f, hi_f)

      RETURN 

      END


*
* In this subroutine we compute the result
*
      SUBROUTINE transpose_xf_compute(id, arg_1, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1
      CHARACTER*100 errtxt

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* check to make sure both axis have points to transpose
      IF ( (arg_lo_ss(F_AXIS, ARG1) .EQ. ef_unspecified_int4) .OR. 
     .     (arg_hi_ss(F_AXIS, ARG1) .EQ. ef_unspecified_int4) ) THEN
         WRITE(errtxt,*) 'F axis cannot be a normal axis'
         GOTO 999
      ENDIF
      IF ( (arg_lo_ss(X_AXIS, ARG1) .EQ. ef_unspecified_int4) .OR. 
     .     (arg_hi_ss(X_AXIS, ARG1) .EQ. ef_unspecified_int4) ) THEN
         WRITE(errtxt,*) 'X axis cannot be a normal axis'
         GOTO 999
      ENDIF

      n1 = arg_lo_ss(F_AXIS, ARG1)
      DO 600 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

      m1 = arg_lo_ss(E_AXIS, ARG1)
      DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

      l1 = arg_lo_ss(T_AXIS, ARG1)
      DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

      k1 = arg_lo_ss(Z_AXIS, ARG1)
      DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

      j1 = arg_lo_ss(Y_AXIS, ARG1)
      DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

      i1 = arg_lo_ss(X_AXIS, ARG1)
      DO 100 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

         IF ( arg_1(i1,j1,k1,l1,m1,n1) .NE. bad_flag(ARG1) ) THEN
            result(i,j,k,l,m,n) = arg_1(i1,j1,k1,l1,m1,n1)
         ELSE
            result(i,j,k,l,m,n) = bad_flag_result
         ENDIF

         i1 = i1 + arg_incr(X_AXIS, ARG1)
 100  CONTINUE

         j1 = j1 + arg_incr(Y_AXIS, ARG1)
 200  CONTINUE

         k1 = k1 + arg_incr(Z_AXIS, ARG1)
 300  CONTINUE

         l1 = l1 + arg_incr(T_AXIS, ARG1)
 400  CONTINUE

         m1 = m1 + arg_incr(E_AXIS, ARG1)
 500  CONTINUE

         n1 = n1 + arg_incr(F_AXIS, ARG1)
 600  CONTINUE

      RETURN 

 999  CALL EF_BAIL_OUT(id, errtxt)

      RETURN 
      END

	SUBROUTINE TM_BREAK_DATE (date, cal_id, year, month, day,
     .				  hour, minute, second, status)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Will take date string composed of DD-MMM-YYYY:HH:MM:SS with optional format:
* DD-MMM:HH:MM:SS and break it up to it's various components.
*
* written 06/17/87 by Mark Verschell for PMEL/TMAP
*
* revision 0.00 - 06/17/87 - Initial Incarnation
* revision 1.00 - 07/07/88 - More conclusive checking of date, bad dates are
*			     trapped and flagged as errors
* revision 1.01 - 01/13/89 - Allows : between day and time parts now
* revision 1.10 - 02/08/89 - Allows year to be left off - defaults to 0000
* revision 1.11 - 02/13/89 - Allows multiple blanks between date and hour
* revision 1.12 - 02/20/89 - Allows dates of form "dd-mmm" - defaults to 0000
* 3/22/95 - check for non-positive DAY value as an error
* V530: *acm* 12/00 alternative calendar types; cal_id
* V63  *acm* 10/09 Changes for gfortran build
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files
* 5/2020 Issue 1906: treat Proleptic-Gregorian identically to Gregorian

* ARGUMENT DEFINITIONS
*  date  - date to process
*  day, month, year, hour, minute, second - obvious
*  status - returned status
	CHARACTER*(*)	date
	INTEGER*4	day, month, year, hour, minute, second, status,
     .                  cal_id
*
* INCLUDE FILES
	include 'tmap_errors.parm'
        include 'calendar.decl'
        include 'calendar.cmn'
#include "gt_lib.parm"
*
* LOCAL DEFINITIONS
	CHARACTER*20	fill_in
	INTEGER*4	out_state(7,22), in_state, pos, istat, leapadj
	INTEGER*4	STR_CASE_BLIND_COMPARE, Class
	REAL		yeardays

* Table gives output state based on input state (right hand column)
*	A = alphabetic	N = numeric	b = blank	- = minus sign
*	: = colon	* = asterik	E = end of date
*		            A   N   b   -   :   *   E
	DATA	out_state / 02, 03, 01, 24, 24, 24, 24,			! 1
     .			    04, 24, 24, 24, 24, 24, 24,			! 2
     .			    24, 09, 24, 10, 24, 24, 24,			! 3
     .			    05, 24, 24, 24, 24, 24, 24,			! 4
     .			    24, 24, 14, 06, 14, 24, 23,			! 5
     .			    24, 07, 24, 24, 24, 24, 24,			! 6
     .			    24, 08, 24, 24, 24, 24, 24,			! 7
     .			    24, 12, 24, 24, 24, 24, 24,			! 8
     .			    24, 12, 24, 11, 24, 24, 24,			! 9
     .			    02, 24, 24, 24, 24, 24, 24,			!10
     .			    02, 24, 24, 24, 24, 24, 24,			!11
     .			    24, 13, 24, 24, 24, 24, 24,			!12
     .			    24, 24, 14, 24, 14, 24, 23,			!13
     .			    24, 15, 14, 24, 24, 24, 24,			!14
     .			    24, 16, 24, 24, 24, 24, 24,			!15
     .			    24, 24, 24, 24, 17, 24, 23,			!16
     .			    24, 18, 24, 24, 24, 24, 24,			!17
     .			    24, 19, 24, 24, 24, 24, 24,			!18
     .			    24, 24, 24, 24, 20, 24, 23,			!19
     .			    24, 21, 24, 24, 24, 24, 24,			!20
     .			    24, 22, 24, 24, 24, 24, 24,			!21
     .			    24, 24, 24, 24, 24, 24, 23/			!22

* initialize
	day = 0
	month = 0
	year = 0
	hour = 0
	minute = 0
	second = 0
	fill_in = '01-'//month_names(1)//'-0000:00:00:00'
	in_state = 1
	pos = 0

* read in next char
  100	pos = pos + 1
* . Calc next state
	in_state = out_state(Class(date,pos),in_state)
* . Process next character unless this is a change of class, THEN output
* STATUS       1   2   3   4   5   6   7   8   9   10  11  12  13  14
	GOTO (100,100,100,100,120,100,100,100,100,130,140,100,150,100,
     .	      100,160,100,100,170,100,100,180,190,9000) in_state
* STATUS       15  16  17  18  19  20  21  22  23  24

* month found
120	fill_in(4:6) = date(pos-2:pos)
	GOTO 100
* 1 digit day found
130	fill_in(2:2) = date(pos-1:pos-1)
	GOTO 100
* 2 digit day found
140	fill_in(1:2) = date(pos-2:pos-1)
	GOTO 100
* year found
150	fill_in(8:11) = date(pos-3:pos)
	GOTO 100
* hour found
160	fill_in(13:14) = date(pos-1:pos)
	GOTO 100
* minute found
170	fill_in(16:17) = date(pos-1:pos)
	GOTO 100
* second found
180	fill_in(19:20) = date(pos-1:pos)
	GOTO 100

* End of string; break into parts
190	READ (fill_in(1:2),'(I2)') day
	READ (fill_in(8:11),'(I4)') year
	READ (fill_in(13:14),'(I2)') hour
	READ (fill_in(16:17),'(I2)') minute
	READ (fill_in(19:20),'(I2)') second

C  Get calendar attributes

      CALL TM_GET_CALENDAR_ATTRIBUTES (cal_id, num_months, 
     .                    num_days, yeardays, month_names, 
     .                    days_in_month, days_before_month,
     .                    month_by_day)
	DO 200 month = 1,12
	  istat = STR_CASE_BLIND_COMPARE( fill_in(4:6), 
     .       month_names(month) )
	  IF (istat .EQ. str_match) GOTO 210
200	CONTINUE
	GOTO 9000

 210	continue

C       ***************************************
C       ******* CHECK VALIDITY OF DATES *******
C       ***************************************


******************************************************************************
* HANDLE GREGORIAN CALENDAR FIRST
******************************************************************************
        IF (cal_id.eq.gregorian .or. cal_id.eq.proleptic) THEN

*          DAYS IN MONTH
	   IF (month .EQ. 2) THEN
	      IF (mod(year,400) .EQ. 0) THEN
		 leapadj = 1
	      ELSE IF (mod(year,4).EQ.0 .AND. mod(year,100).NE.0) THEN
		 leapadj = 1
	      ELSE
		 leapadj = 0
	      ENDIF
	   ELSE
	      leapadj = 0
	   ENDIF
	   IF (day .GT. days_in_month(month)+leapadj
     .         .OR. day .le. 0   ) GOTO 9000

*          HOURS IN DAY, MINUTES IN HOUR, SECONDS IN MINUTE
	   IF (hour .GT. 23 .OR. minute .GT. 59 .OR. second .GT. 59)
     .         GOTO 9000




******************************************************************************
* HANDLE JULIAN CALENDAR 
******************************************************************************
        ELSE IF (cal_id .EQ. julian) THEN

*          DAYS IN MONTH
	   IF (month .EQ. 2) THEN
	      IF (mod(year,4) .EQ. 0) THEN
		 leapadj = 1
	      ELSE
		 leapadj = 0
	      ENDIF
	   ELSE
	      leapadj = 0
	   ENDIF
	   IF (day .GT. days_in_month(month)+leapadj
     .         .OR. day .le. 0   ) GOTO 9000

*          HOURS IN DAY, MINUTES IN HOUR, SECONDS IN MINUTE
	   IF (hour .GT. 23 .OR. minute .GT. 59 .OR. second .GT. 59)
     .         GOTO 9000


******************************************************************************
* ALL OTHER SUPPORTED AND REGULAR CALENDARS
******************************************************************************

	ELSE IF (cal_id .GT. gregorian   .AND.  cal_id .NE. julian .AND.
     .           cal_id .LE. max_calendars) THEN


*          DAYS IN MONTH
	   IF (day .GT. days_in_month(month) 
     .         .OR. day .le. 0) GOTO 9000

*          HOURS IN DAY, MINUTES IN HOUR, SECONDS IN MINUTE
	   IF (hour .GT. 23 .OR. minute .GT. 59 .OR. second .GT. 59)
     .         GOTO 9000
	ELSE
           status = merr_syntax
	   CALL ERRMSG (status, status, 
     .       'Illegal calendar in tm_break_date()', *9999)
        END IF

	GOTO 9990

* Syntax error

 9000	status = merr_syntax
	GOTO 9999

 9990	status = merr_ok

 9999	RETURN
	END

	INTEGER*4 FUNCTION Class ( in_str, pos )
*
* Takes a character {in_str(pos:pos)}, and determines it's class:
*  1 : A to Z
*  2 : 0 to 9
*  3 : blank (tab)
*  4 : -
*  5 : :
*  6 : other
*  7 : end of string
*
* ARGUMENTS
*  in_str - input string
*  pos    - character position in string
	CHARACTER*(*)	in_str
	INTEGER*4	pos
*
* LOCAL DEFINITIONS
	CHARACTER*1	chr, blank, tab, hyphen, colon
	INTEGER*4	slen
	INTEGER*4	TM_LENSTR
	DATA	blank	/ ' ' /
	DATA	hyphen	/ '-' /
	DATA	colon	/ ':' /
		tab	= CHAR(9)

* Determine length of string
	slen = TM_LENSTR( in_str )
* Is pos at end of string?
	IF (pos .GT. slen) THEN
	  class = 7
	  RETURN
	ENDIF

* Get character
	chr = in_str( pos:pos )
* Alphabetic?
	IF ( chr .GE. 'A' .AND. chr .LE. 'Z' .OR.
     .	     chr .GE. 'a' .AND. chr .LE. 'z'      ) THEN
	  class = 1
* Numeric?
	ELSE IF (chr .GE. '0' .AND. chr .LE. '9' ) THEN
	  class = 2
* Blank or tab?
	ELSE IF (chr .EQ. blank .OR. chr .EQ. tab ) THEN
	  class = 3
* Hyphen?
	ELSE IF (chr .EQ. hyphen) THEN
	  class = 4
* Colon?
	ELSE IF (chr .EQ. colon) THEN
	  class = 5
* Everything ELSE
	ELSE
	  class = 6
	ENDIF
	RETURN
	END

	SUBROUTINE TM_MAKE_BASIC_AXIS( name, start,
     .                                 delta, npts, iaxis, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Create a very basic 1 to n axis with no frills

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 2/92
* V510 *sh* 3/00 - convert to dynamic grids and axes for netCDF files
* V550 *sh* 11/02 - initialize line_modulo_len (just for good house keeping)
* V581 *acm* 6/05 - For fix to bug 1271, add flag line_shift_origin
* V63  *acm* 9/09 - Fix bug 1686: set line_name_orig
* v694 1/15 *acm* for ticket 2227: Set the new line_dim_only flag. If a 
*                 dimension from a nc file is not also a 1-D coordinate 
*                 var, don't write the axis Ferret creates.
 

* argument definitions:
*       name      - name for axis
*       start     - starting value
*	delta     - delta value
*       npts      - number of points
*       iaxis     - returned axis pointer in TMAP common
*	status	  - return status

* include files
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data


* argument declarations
	INTEGER	 npts, iaxis, status
        REAL*8   start, delta
        CHARACTER*(*) name

* local variable declarations:
      INTEGER STR_UPCASE,
     .        istat

* allocate a temporary slot for the axis
	CALL TM_ALLO_TMP_LINE(iaxis, status)
	IF (status .NE. merr_ok) GOTO 5900

* build axis
      istat = STR_UPCASE( line_name(iaxis), name )
      line_name_orig(iaxis) = name
      line_dim( iaxis)      = npts
      line_start(iaxis)     = start
      line_delta(iaxis)     = delta
      line_regular(iaxis)   = .TRUE.
      line_units(iaxis)     = ' '
      line_unit_code(iaxis) = 0
      line_modulo(iaxis)    = .FALSE.
      line_modulo_len(iaxis)= 0.0D0
      line_t0(iaxis)        = char_init20
      line_shift_origin(iaxis) = .FALSE.
      line_tunit(iaxis)     = real4_init
      line_direction(iaxis) = 'NA'
      line_dim_only(iaxis)   = .TRUE.

* successful completion
      status = merr_ok

 5900 RETURN

	END

*
* tax_datestring.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Jing Y. Li 
* May 2006
* 18-may-2006 ACM change to compare only the first 3 characters of the precision string.
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
* 27-Feb-2013 ACM  Fix ticket 2043: remove old code for handling single-
*                  precision values coming in from argument 1
* v695  *acm 2/15  Return dates on an F axis or a T axis.
* v75  *acm* 3/18  Issue 1856, changes to allow for timesteps in fractional seconds
* v745 *acm* 12/18  Issue 1909, option to write dates in ISO8601 format
*
* Returns string of dates 
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )


      SUBROUTINE tax_datestring_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .        'Returns date string for time axis coordinate values' )
      CALL ef_set_num_args(id, 3)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_result_type(id, STRING_RETURN)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'time steps to convert')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'B')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'variable with reference time axis')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*     Set data type as string
      arg = 3
      CALL ef_set_arg_type (id, arg, STRING_ARG)
      CALL ef_set_arg_name(id, arg, 'C')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'output precision, e,g. "day" or "minute" ' )
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


* In this subroutine we compute the result
*
      SUBROUTINE tax_datestring_compute(id, arg_1, arg_2, arg_3, 
     .                                  result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(strdf, mem3lox:mem3hix, mem3loy:mem3hiy,
     .                  mem3loz:mem3hiz, mem3lot:mem3hit,
     .                  mem3loe:mem3hie, mem3lof:mem3hif)

      REAL result(strdf, memreslox:memreshix, memresloy:memreshiy, 
     .                   memresloz:memreshiz, memreslot:memreshit,
     .                   memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i3, j3, k3, l3, m3, n3
      INTEGER dir, slen, get_prec, status
      CHARACTER*3 precistring
      CHARACTER*255 err_msg

*  variables for checking axis characteristics (modulo axes)
      CHARACTER ax_name(6)*16, ax_units(6)*16
      LOGICAL backward(6), modulo(6), regular(6), tmodulo

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*  Check to see if time axis of arg 2 is modulo
      CALL ef_get_axis_info_6d(id, ARG2, ax_name, ax_units,
     .                         backward, modulo, regular)
* Get the direction of arg 2
      IF (arg_lo_ss(T_AXIS, ARG2) .NE. ef_unspecified_int4) THEN
         dir = T_AXIS
         tmodulo = modulo(T_AXIS)
      ENDIF
      IF (arg_lo_ss(F_AXIS, ARG2) .NE. ef_unspecified_int4) THEN
         dir = F_AXIS
         tmodulo = modulo(F_AXIS)
      ENDIF

*     Get the precision for output (string)
      i3 = arg_lo_ss(X_AXIS, ARG3)
      j3 = arg_lo_ss(Y_AXIS, ARG3)
      k3 = arg_lo_ss(Z_AXIS, ARG3)
      l3 = arg_lo_ss(T_AXIS, ARG3)
      m3 = arg_lo_ss(E_AXIS, ARG3)
      n3 = arg_lo_ss(F_AXIS, ARG3)
      CALL ef_get_string_arg_element_6d(id, ARG3, arg_3,
     .                       i3, j3, k3, l3, m3, n3, slen, precistring)
      CALL LOWER_CASE(precistring)

      get_prec = 6  ! dates to seconds, output precision will be set by precistring.

      CALL TAX_DATE_STRINGS (arg_1, result, arg_lo_ss, arg_incr, 
     .                res_lo_ss, res_hi_ss, get_prec, dir, precistring, 
     .                tmodulo, bad_flag, status)


! Routine has reset get_prec.  Start over for consistent time-string format.
      IF (status .NE. 0) THEN  
            CALL TAX_DATE_STRINGS (arg_1, result, arg_lo_ss, arg_incr, 
     .                res_lo_ss, res_hi_ss, get_prec, dir, precistring, 
     .                tmodulo, bad_flag, status)
      ENDIF
      

         
      RETURN

 999  CALL ef_bail_out (id, err_msg)

      END

	SUBROUTINE DEALLO_DYN_GRID ( grid )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* deallocate the specified dynamic grid (no check made on grid number)
* and clear any memory references to this grid

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V420 9/8/95 - new
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'interp_stack.parm'
	include 'xvariables.cmn'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xprog_state.cmn'

* calling argument declarations
	INTEGER	grid

* local declarations
	INTEGER mr

* diagnostic message
	IF ( mode_diagnostic )  CALL DIAG_OP
     .	     ('dealloc ',isact_class_impl_grid,grid,0)

* deallocate the grid
	CALL TM_DEALLO_DYN_GRID(grid)

* if the grid was actually destroyed then delete any memory resident 
* variables that were built on this grid
	IF ( grid_use_cnt(grid) .EQ. 0 ) THEN
	   DO 100  mr = 1, max_mrs
	      IF ( mr_protected(mr) .NE. mr_deleted ) THEN
	         IF (mr_grid(mr) .EQ. grid) CALL DELETE_VARIABLE(mr)
	      ENDIF
 100	   CONTINUE
	ENDIF

	RETURN
	END

	SUBROUTINE STRING_CONTEXT
     .		      ( uvar,
     .			item, 
     .			default_cx,
     .			string_cx,
     .			status )

* return in string_cx context information describing the string context
* this is for a "cat_string" - a literal string embedded in a var defn

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V500  1/99 *sh*  based on const_context
* V530  8/00 *sh*  adding support for arrays of strings
	
        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include	'xalgebra.cmn'
	include 'xfr_grid.cmn'

* calling argument declarations:
	INTEGER		default_cx, string_cx, uvar, item, status

* internal variable declarations:
	INTEGER		idim

* initialize
	CALL TRANSFER_CONTEXT ( default_cx, string_cx )
	cx_category( string_cx ) = cat_string
	cx_type    ( string_cx ) = ptype_string
	cx_bad_data( string_cx ) = bad_val4
	cx_data_set( string_cx ) = pdset_irrelevant
	cx_dset_gvn( string_cx ) = .TRUE.
	cx_variable( string_cx ) = 1000*uvar + item     ! packed info
	cx_grid    ( string_cx ) = mgrid_abstract

* flesh out context by removing all axes limits
	DO 200 idim = 1, nferdims
 200	CALL DEL_CX_DIM( idim, string_cx )

	status = ferr_ok
	RETURN

* error exit
	END

*
* floatstr.F
*
* Ansley Manke 11/10
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
* V695 *acm* 9/15  Allow integer formats. Truncate Floating point data, write as integer
* V697 *acm* 11/15 Fix for the zero-filled versions of these formats, so that I0 and F0.0 work
*
* Returns float converted to strings according to format given. 
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, floatstr )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )

      SUBROUTINE floatstr_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .'Returns float converted to strings according to format specified')

      CALL ef_set_num_args(id, 2)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_result_type(id, STRING_RETURN)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg,  
     .     'Floating-point variable to convert')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

*     Set data type as string
      arg = 2
      CALL ef_set_arg_type(id, arg, STRING_ARG)
      CALL ef_set_arg_name(id, arg, 'FMT')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg,  
     . 'Fortran format, in parentheses, e.g. "(F5.1)", "(I4)", or "(I3.3)"')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

* In this subroutine we compute the result
*
      SUBROUTINE floatstr_compute(id, arg_1, arg_2, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(strdf,
     .           mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)

      REAL result(strdf,
     .            memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1, p, p2
      REAL    fval
      INTEGER TM_LENSTR1, STR_UPCASE, slen, ival, isok, dot, status
      CHARACTER*32 fstring, fformat
      CHARACTER*128 err_msg
      CHARACTER*1 nullstr


      LOGICAL do_integer, zero_fill

      nullstr = ''
      isok = 3
      zero_fill = .FALSE.
      do_integer = .FALSE.

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*     Get the Fortran Format (string)
      i = arg_lo_ss (X_AXIS, ARG2)
      j = arg_lo_ss (Y_AXIS, ARG2)
      k = arg_lo_ss (Z_AXIS, ARG2)
      l = arg_lo_ss (T_AXIS, ARG2)
      m = arg_lo_ss (E_AXIS, ARG2)
      n = arg_lo_ss (F_AXIS, ARG2)
      CALL ef_get_string_arg_element_6d(id, ARG2, arg_2,
     .                   i, j, k, l, m, n, slen, fstring)

      i = STR_UPCASE(fformat, fstring)

      do_integer = .FALSE.
      slen = TM_LENSTR1( fformat )
      dot = INDEX(fformat,'.')
      DO 30, p =1, slen-1
	 IF (fformat(p:p+1) .EQ. 'F0' .AND. p+2.LT.dot)  THEN
	    zero_fill = .TRUE.
	    fformat = fformat(1:p)//fformat(p+2:slen)
	    GOTO 40
	 ENDIF
	 IF (fformat(p:p) .EQ. 'F') GOTO 40
	 
	 IF (fformat(p:p+1).EQ.'I0' .AND. fformat(p+2:p+2).NE.')')  THEN
	    zero_fill = .TRUE.
	    do_integer = .TRUE.
	    fformat = fformat(1:p)//fformat(p+2:slen)
	    GOTO 40
	 ENDIF
	 IF (fformat(p:p) .EQ. 'I') THEN
	    do_integer = .TRUE.
            GOTO 40
	 ENDIF
  30  CONTINUE
  40  CONTINUE
      

      n1 = arg_lo_ss(F_AXIS,ARG1)
      DO 600 n=res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

      m1 = arg_lo_ss(E_AXIS,ARG1)
      DO 500 m=res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

      l1 = arg_lo_ss(T_AXIS,ARG1)
      DO 400 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

      k1 = arg_lo_ss(Z_AXIS,ARG1)
      DO 300 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

      j1 = arg_lo_ss(Y_AXIS,ARG1)
      DO 200 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

      i1 = arg_lo_ss(X_AXIS,ARG1)
      DO 100 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         fval = arg_1(i1,j1,k1,l1,m1,n1)
C     Write the string using the format, and put it in the result.
C     If they have sent in an integer format, truncate the data first.

         IF ( fval .NE. bad_flag(ARG1) ) THEN
	    IF (do_integer) THEN 
	       ival = INT(fval)
               WRITE (fstring, fformat) ival
            ELSE
               WRITE (fstring, fformat) fval
	    ENDIF

            slen = TM_LENSTR1(fstring)

C adjust the field width if requested by the user (from repl_exprns.F)
           IF (zero_fill) THEN
	      DO p = 1, slen
	         IF (fstring(p:p) .EQ. ' ') fstring(p:p) = '0'
	      END DO
	   ENDIF

            CALL EF_PUT_STRING(fstring, slen, result(1,i,j,k,l,m,n))

         ELSE

            fstring = nullstr
            slen = 0
            CALL EF_PUT_STRING (fstring, slen, result(1,i,j,k,l,m,n))
         ENDIF

         i1 = i1 + arg_incr(X_AXIS,ARG1)
 100  CONTINUE

         j1 = j1 + arg_incr(Y_AXIS,ARG1)
 200  CONTINUE

         k1 = k1 + arg_incr(Z_AXIS,ARG1)
 300  CONTINUE

         l1 = l1 + arg_incr(T_AXIS,ARG1)
 400  CONTINUE

         m1 = m1 + arg_incr(E_AXIS,ARG1)
 500  CONTINUE

         n1 = n1 + arg_incr(F_AXIS,ARG1)
 600  CONTINUE

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
 5000 err_msg = 'Could not translate W or ZW width value '// fformat
      CALL ef_bail_out (id, err_msg)
      RETURN

      END

	SUBROUTINE TM_allo_dyn_grid_sub( hook, grid, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Allocate a grid from the dynamic grid area (above max_grids)

* The grids in xtm_grid.cmn fall into three categories (ideally they could
* and should all be category 3, but the development was historical)
* category 1: explicit (static) grids
*	these are located in the low indices of the grid common
*	(e.g. grid_name(3)).  They are created by READ_GRIDFILE, CD_*_GRIDS,
*	and by DEFINE GRID inside Ferret.  These are the grids that are
*	returned by TM_FIND_GRID_SLOT.
* category 2: temporary grids
*	these are located beginning at max_grids-1 and descending.  They have
*	only very temporary existence during the GET_UVAR_GRID process -- as
*	holding areas while dynamic grids (category 3) are built.
* category 3: dynamic grids
*	these are in the upper indices: above max_grids.  They are managed
*	efficiently with linked lists and usage counts.  They are used by
*	Ferret to hold "implicit" grids -- implied by expressions such as
*	SALT[GX=U] (the SALT grid with its X axis replaced from the U grid).
*	They are deleted as necessary to ensure that new grid definitions and
*	changes in user variable definitions do not corrupt memory. 

* Steve Hankin  NOAA/PMEL/TMAP

* 9/13/95 for Ferret version 4.2
* V510 *sh* added "hook" arg so this can be used for tmp grids, too
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* Include files
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'tmap_errors.parm'
	include 'xtm_grid.cmn_text'
	include 'xio.cmn_text'
	external xgt_grid_data

* Argument definitions
	INTEGER hook, grid, status

* Local definitions
	INTEGER next_free_grid

* take a grid from the "free" list and put it at the start of the "used" list
	IF ( grid_free_ptr .NE. 0 ) THEN
* ... unhook from free list
	   grid			= grid_free_ptr
	   next_free_grid  	= grid_flink(grid)
	   grid_free_ptr	= next_free_grid
* ... hook onto front of used list
	   grid_flink(grid)	= grid_flink(hook)
	   grid_blink(grid)	= hook
	   grid_flink(hook)= grid
	   grid_blink(grid_flink(grid))	= grid
	ELSE
	   CALL TM_ERRMSG (merr_gridlim, status,
     .                  'TM_ALLO_DYN_GRID', no_descfile, no_stepfile,
     .                  no_errstring, no_errstring, *9999)
	ENDIF

* signal that it is in use by a single claimant
	grid_use_cnt(grid) = 1

* successful completion
	status = merr_ok
 9999	RETURN

	END

	SUBROUTINE T0_ADJUST_INIT ( cal_id,
     .				    tunit_id_src, t0_src,
     .				    tunit_id_dst, t0_dst, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* This routine exists to optimize performance in converting between time axes
* Initialize COMMON in preparation for time coordinate conversion calls to
* T0_ADJUST (see detailed docs in T0_ADJUST.F)

* based upon code from routine TDEST_WORLD_INIT.F
* in this routine, however, no syntax error checking of units and T0 is done

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V695+ *sh* 11/15 

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xunits.cmn_text'
	external xunits_data
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xregrid.cmn'

* calling arguments
*   cal_id       (input) - calendar id for both src and dst axes (must match)
*   tunit_id_src (input) - time unit id on source axis
*   t0_src       (input) - time origin string on source axis
*   tunit_id_dst (input) - time unit id on destination axis
*   t0_dst       (input) - time origin string on destination axis
*   status       (output) - return status

* calling argument declarations:
	INTEGER cal_id, tunit_id_src, tunit_id_dst, status
	CHARACTER*(*)	t0_src, t0_dst

* internal variable declarations:
	LOGICAL TM_DATE_OK
	INTEGER	TM_GET_CALENDAR_ID ,
     .          src_line, dst_line, src_cal_id, dst_cal_id
	REAL	CAL_FACTR
	REAL*8  SECS_FROM_BC, at0src, at0dst, usrc, udst, factor

* initialize
	cnvrt_src_grid = unspecified_int4

* determine the units and absolute T0 for the two axes
	usrc = un_convert( tunit_id_src )
	udst = un_convert( tunit_id_dst )

	at0src = SECS_FROM_BC( t0_src, cal_id, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	at0dst = SECS_FROM_BC( t0_dst, cal_id, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* determine the slope and intercept to be used in TDST_WORLD regridding
	tcnvrt_slope = usrc/udst
	tcnvrt_intercept = (at0src-at0dst) / udst

* success
	tcnvrt_ok = .TRUE.
	RETURN

* error exit
 5000	tcnvrt_ok = .FALSE.
	RETURN
	END

	SUBROUTINE READ_DELIMITED(  cx, mr, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* read an ASCII delimited file
* return only the requested variable in "mr"
* note: always read and store the entire grid limits of data

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V530: 11/00 *sh*
* V533: 6/01 *sh* - check that data type is correct instead of asserting it
* V540: 10/01 *sh* - undo the erroneous change of V533 (why was V533 chg done?)
* V500 *kob* 3/99- up VAR_CODE  to 64 chars
* V552 *acm* 4/03- up VAR_CODE  to 128 chars
*       *acm* 3/12 changes for 6D Ferret
* V685 *acm* 1/13  Ticket 2030: if we run out of  issue a new message
*                  and only clear the variables that had been initialized.
* V701 *acm* 7/16  ticket 2449: report incorrect choice of date/ eurodate as an error
* V702 *acm*11/16  handling read errors in date/time reading
* V702: *sh* 1/17 - bug fix: mr_protected must *end* at mr_not_in_use (=0)
*		  - for trac enhancement #2369 -- dynamic memory management 

	include	'tmap_errors.parm'
	include	'tmap_dims.parm'
	include	'ez_lib.parm'
	include	'xstep_files.cmn_text'
	include	'xdset_info.cmn_text'
	external xdset_info_data
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'
	include	'xtext_info.cmn'

* calling argument declarations:
	INTEGER	cx, mr, status

* internal variable declarations:
	INTEGER 	CGRID_SIZE, CX_DIM_LEN, TM_LENSTR1,
     .			idim, ask_var, category, dset, grid, ivar,
     .			fvar, nvar, the_var, nleft, nsize,
     .			cx0, cx1, nread, istep, nvar20,
     .			cxlist(maxezvars), mrlist(maxezvars),
     .			field_type(maxezvars),
     .			mr1, ndim, las_dim, fst_dim, dims(nferdims),
     .			rec_to_read
	INTEGER*8	i8_size, c_ptr_array
	CHARACTER	VAR_CODE*128, delims*80, errbuff*100


* --- end of introductory code ---

* nvar  and the_var - value from 1 to maxezvars --> variable # within EZ set
* ask_var and fvar    - value from 1 to maxvars --> var # within DSET common

* initialize
	cx0 = cx_stack_ptr
	dset = cx_data_set( cx )
	category = cx_category( cx )
	ask_var  = cx_variable( cx )
	grid = cx_grid( cx )
	fvar      = 0
	nvar20    = 0
	CALL GET_DELIMITED_INFO(nvar, field_type, delims, 
     .				   ds_file_info_ptr(dset) )
* locate the step file belonging to this data set

	DO 10 istep = 1,maxstepfiles
	  IF (sf_setnum(istep) .EQ. dset) GOTO 20
 10	CONTINUE
	CALL ERRMSG( ferr_internal, status, 'delim stepfile?', *5000)

* create a memory variable for each variable in the file
 20	DO 400 ivar = 1, nvar

* ... locate the next variable in this data set
	   DO 100 fvar = fvar+1, maxvars
	      IF ( ds_var_setnum(fvar) .EQ. dset ) GOTO 110
 100	   CONTINUE
* ... no more
	   GOTO 500

* ... is it a dummy '-' placeholder in the variable list ?
 110	   IF (field_type(ivar) .EQ. FTYP_MISSING) THEN
	      cxlist(ivar) = 0
	      mrlist(ivar) = 0
	   ELSE

* save record of which is the desired var
	     nvar20 = nvar20 + 1

* ... create a context describing this variable
	     CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	     IF ( status .NE. ferr_ok ) RETURN
	     cxlist(ivar) = cx_stack_ptr
	     CALL TRANSFER_CONTEXT( cx, cx_stack_ptr )
	     cx_variable( cx_stack_ptr ) = fvar
	     cx_grid    ( cx_stack_ptr ) = ds_grid_number( fvar )
	     cx_bad_data( cx_stack_ptr ) = ds_bad_flag( fvar )	! 12/93 add'n
	     cx_type    ( cx_stack_ptr ) = ds_var_type( fvar )
	     DO 200 idim = 1, nferdims
	        cx_lo_ss(cx_stack_ptr, idim) = ds_grid_start(idim, fvar)
	        cx_hi_ss(cx_stack_ptr, idim) = ds_grid_end  (idim, fvar)
	        cx_by_ss(idim, cx_stack_ptr) = .TRUE.
	        CALL CONFINE_AXIS( idim, cx_stack_ptr, status )
	        IF ( status .NE. ferr_ok ) RETURN
	        CALL FLESH_OUT_AXIS( idim, cx_stack_ptr, status )
	        IF ( status .NE. ferr_ok ) RETURN
 200	     CONTINUE

* reserve and catalog space for the result
	     CALL CREATE_MEM_VAR( cx_stack_ptr, mrlist(ivar), status )
	     IF ( status .NE. ferr_ok ) GOTO 5000
	   ENDIF

* save index of the desired var
	   IF ( fvar .EQ. ask_var ) the_var = ivar

 400	CONTINUE

* point to asked-for variable and create dummy entries for the rest
 500	rec_to_read = CGRID_SIZE(cxlist(the_var))
	mr = mrlist( the_var )
	
* diagnostic output
	IF (mode_diagnostic) CALL DIAGNOSTIC_OUT('reading',mr,point_to_mr)

* allocate a buffer big enough for one input ASCII record
	i8_size = 1024				
        CALL GET_DYN_WORK_SPACE( i8_size, status )    
        IF ( status .NE. merr_ok ) GOTO 5500

* create a null terminated string from the data set name (use record buffer)
	CALL TM_FTOC_STRNG( ds_des_name(dset)
     .		     (:TM_LENSTR1(ds_des_name(dset))),
     .		     workmem(plegacy_work_buffer)%ptr, 4*1024 )

* setup a c pointer array from the mrlist
	CALL DYNMEM_MRLIST_C ( nvar, mrlist, c_ptr_array, status )
        IF ( status .NE. merr_ok ) GOTO 5500

* read the data via TMAP library routine
* Status will report -1* variable number if the date/eurodate specification is wrong.
	status = ferr_ok
	CALL DECODE_FILE_JACKET (
     .		  workmem(plegacy_work_buffer)%ptr,
     .		  workmem(plegacy_work_buffer)%ptr,
     .		  delims, sf_skip(istep), rec_to_read, 4*1024, nvar,
     .		  field_type, nread, mrlist, c_ptr_array,
     .		  mr_bad_data, mr_c_pointer, status)
	CALL DYNMEM_FREE_PTR_ARRAY( c_ptr_array )
	IF (status .NE. ferr_ok) GOTO 5800

* update the variables with info about the number of records actually read
* (for multi-dimensional grid reads just truncate the last axis best we can)
	IF ( nread .LT. rec_to_read ) THEN
	   DO 700 ivar = 1, nvar
	      IF (field_type(ivar) .NE. FTYP_MISSING) THEN
	        cx1 = cxlist(ivar)
	        mr1 = mrlist(ivar)
	        CALL GET_CX_DIMS( cx1, ndim, dims )
	        fst_dim = dims(1)
	        IF ( ndim .GT. 0 ) THEN        ! "IF" added 5/5/93
	           las_dim = dims(ndim)
	        ELSE
	           las_dim = fst_dim
	        ENDIF
	        IF ( ndim .EQ. 1 ) THEN
	           nsize = 1
	        ELSEIF( ndim .EQ. 2 ) THEN
	           nsize = CX_DIM_LEN(fst_dim,cx1)
	        ELSE
	           nsize =  CGRID_SIZE(cx1) / CX_DIM_LEN(las_dim,cx1)
	        ENDIF
* ... last dim (each var) is
*     (total values read)/(prod. of all axis lengths except last)
	        cx_hi_ss( cx1, las_dim ) = MAX( 1, nread/nsize )
	        CALL FLESH_OUT_AXIS( las_dim, cx1, status )
	        IF ( status .NE. ferr_ok ) GOTO 6000
	        mr_hi_ss( mr1, las_dim ) = cx_hi_ss( cx1, las_dim )
	        mr_hi_ww( las_dim, mr1 ) = cx_hi_ww( las_dim, cx1 )
* ... also let the TMAP library know how much is there
	        ds_grid_end(las_dim, mr_variable(mr1)) = cx_hi_ss( cx1, las_dim )
	      ENDIF
 700	   CONTINUE
	ENDIF

* flag that all the data is available
	DO ivar = 1, nvar
	   IF (field_type(ivar) .NE. FTYP_MISSING) THEN
	     mr1 = mrlist(ivar)
	     CALL MR_AVAILABLE(mr1)
	   ENDIF
	ENDDO

* the data region obtained may be inadequate for the request
* ("cx" is request, "cx1" is available)
	cx1 = cxlist(the_var)
	DO 900 idim = 1, nferdims
	   IF ( cx_hi_ss(cx,idim) .GT. cx_hi_ss(cx1,idim) ) THEN
	      IF ( cx_given(idim,cx) ) THEN  ! 3/00 cut mystery cx_last ref.
* ... error: the user explicitly requested more than there is
	         GOTO 5600
              ELSEIF (cx_lo_ss(cx,idim) .GT. cx_hi_ss(cx1,idim)) THEN
* ... requested data is completely out of range of disk data (2/93 bug fix)
                 GOTO 5600
	      ELSE
* ... no error: the region was filled in by FERRET automatically
	         cx_hi_ss(cx,idim) = cx_hi_ss(cx1,idim)
	         cx_hi_ww(idim,cx) = cx_hi_ww(idim,cx1)
	      ENDIF
	   ENDIF
 900	CONTINUE

* set the data type based on the file
	cx_type(cx) = cx_type(cx1)

* successful completion
	cx_stack_ptr = cx0
	RETURN

* error exit
 4900	nvar = nvar + 1		! delete all
 5000	cx_stack_ptr = cx0
	IF (nvar20 .GT. 1) THEN
	   WRITE ( errbuff, 1000 ) nvar20
           CALL WARN (errbuff)
	ENDIF
 1000   FORMAT ('Delimited file reading: Insufficient memory '
     .        //'reading variable ', i4)
 1100	DO 5010 nleft = 1, nvar20-1	! delete all initialized so far
 5010	CALL DELETE_VARIABLE(mrlist(nleft))
        CALL RELEASE_DYN_WORK_SPACE

 5500	RETURN
 5600	CALL ERRMSG( ferr_limits, status,
     .		ww_dim_name(idim)//' axis of '//VAR_CODE(cat_file_var,ask_var),
     .		*5500 )
 5650	CALL ERRMSG( ferr_limits, status,
     .		'/COLUMNS is impossibly large', *5500 )
 5700	CALL ERRMSG( ferr_TMAP_error, status, ' ', *4900 )
 5800	CONTINUE

* String variables not allocated in this error condition, so no need to free them
* in the clean up steps that will follow.
	DO ivar = 1, nvar
	   IF (field_type(ivar) .eq. FTYP_CHARACTER)
     .       mr_protected(mrlist(ivar)) = mr_table_entry_only
	ENDDO 
	CALL ERRMSG( ferr_nomessge, status, 
     .       'Error reading file: Check Date or Time fields.', *1100 )
 6000	CALL ERRMSG( ferr_internal, status, 'READ_EZ ??', *4900 )
	END	

	SUBROUTINE MAKE_CVAR_GRIDS ( dset, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* find or make a full grid, including a time axis, for each cvar variable in 
* the given data set based on information stored in COMMON by INIT_DSET.
* results are stored COMMON/~VARIABLES/ in cvar_grid

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 -11/17/88 - based on MAKE_DS_4D_GRIDS v1.0
*			   new io library does file variables - only cvars here
* Unix/RISC port - 1/91 - cant use "/star" in comments on Unix
*Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
*       *acm* 3/12 changes for 6D Ferret

	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'ferret.parm'
	include 'errmsg.parm'
	include	'xvariables.cmn'
	include	'xcalc_vars.cmn'
	include	'xdset_parms.cmn'

* calling argument declarations
	INTEGER	dset, status

* local variable declarations
	INTEGER	TM_LENSTR1, fvar, cvar, idim, iline, slen
	CHARACTER TM_FMT*4, gname*8

* * * * CALCULATED VARIABLES
	IF ( .NOT.( dp_phil_sieg(dset) .OR. dp_cox(dset) ) ) THEN
* not available: not Philander/Siegel or Cox
	   DO 150 cvar = 1, num_calc_vars
 150	   cvar_grid( cvar, dset ) = unspecified_int4

	ELSE
* create a template for the unchanging grid stuff
	   DO 200 idim = 1, 4
 200	   grid_out_prod( idim, mgrid_buff ) = .TRUE.
	   grid_line( t_dim, mgrid_buff ) = ds_time_axis( dset )

	   DO 320 cvar = 1, num_calc_vars

* fill in the spacial axes for the grid to look for
	      DO 310 idim = 1,3
	         IF ( cvar_axes( idim, cvar ) .EQ. mnormal ) THEN
	            grid_line( idim, mgrid_buff ) = mnormal
	         ELSE
	            grid_line( idim, mgrid_buff ) =
     .			ds_basic_axes( cvar_axes(idim,cvar)-1, dset )
	         ENDIF
 310	      CONTINUE

* make a plausible name for the new grid (e.g. GPCDZ1)
	      gname = 'G' // cvar_name_code(cvar)
     .			  // TM_FMT( REAL(dset), 4, 4, slen )

* make sure name is unique
	      CALL TM_NEW_GRID_NAME( gname, gname )

* save it or use an identical one that already exists
	      CALL TM_GET_LIKE_GRID( mgrid_buff, gname,
     .				     cvar_grid(cvar,dset), status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
 320	   CONTINUE
	ENDIF

* successful completion
	status = ferr_ok
 	RETURN

* error exit
 5000	RETURN
	END

C =========================================================================

      subroutine flush_buffered_fillpoly (xadd, lmin, lmax)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
c:    Extracted from arfill.F
*     v5.81 *acm* 4/05 Changes for FILL/MOD. Draw replications for curvilinear datasets

        include         'xinterrupt.cmn' ! 1/89 *sh*
        include         'ppl_in_ferret.cmn'
        include         'shade_vars.cmn'
	include 	'ARFILL.INC'
        include         'xcurvilinear.cmn'

 
*     J Davison 2.4.99

*     BUFFER_FILLPOLY() called when entire grid cell is a single color; when
*     color changes construct new polygon from individual cells and fill
*     it in FLUSH_BUFFERED_FILLPOLY().

      real xadd, lmin, lmax

      real xarg(2*buffer_max+2), yarg(2*buffer_max+2)
      integer m, ndx, neo, noe
      logical even

      if (sqfflg) then
*        ********************* RECTANGLES ********************
         if (curvilinear) then

*           FIRST POINT IS LOWER LEFT CORNER OF FIRST RECTANGLE
            xarg(1) = xbuff(1,1)
            yarg(1) = ybuff(1,1)
           
*           FOLLOWED BY LOWER RIGHT CORNER OF ALL RECTANGLES
            do 10 m = 1, num_buffered
               xarg(m+1) = xbuff(2,m)
               yarg(m+1) = ybuff(2,m)
 10         end do
            
*           PICK THE UPPER RIGHT CORNER OF THE LAST RECTANGLE
            xarg(num_buffered+2) = xbuff(3,num_buffered)
            yarg(num_buffered+2) = ybuff(3,num_buffered)
 
*           THEN RETURN ALONG UPPER LEFT CORNER OF EACH RECTANGLE
            ndx = 2*num_buffered + 3

            do 20 m = num_buffered, 1, -1
               xarg(ndx-m) = xbuff(4,m)
               yarg(ndx-m) = ybuff(4,m)
 20         end do

            call fillpoly (xarg, yarg, 2*num_buffered+2, ilast-1, 
     .                     xadd, lmin, lmax)
          else
            xarg(1) = xbuff(1,1)
            yarg(1) = ybuff(1,1)

            xarg(2) = xbuff(2,num_buffered)
            yarg(2) = ybuff(2,num_buffered)

            xarg(3) = xbuff(3,num_buffered)
            yarg(3) = ybuff(3,num_buffered)

            xarg(4) = xbuff(4,1)
            yarg(4) = ybuff(4,1)

            call fillpoly (xarg, yarg, 4, ilast-1, xadd, lmin, lmax)
         end if
      else
*        ******************* TRIANGLES *******************
         
         if (num_buffered .eq. 1) then
            
            xarg(1) = xbuff(1,1)
            yarg(1) = ybuff(1,1)

            xarg(2) = xbuff(2,1)
            yarg(2) = ybuff(2,1)

            xarg(3) = xbuff(3,1)
            yarg(3) = ybuff(3,1)

            call fillpoly (xarg, yarg, 3, ilast-1, xadd, lmin, lmax)
            goto 1000
         end if
            
         if (mod(num_buffered,2) .eq. 0) then
            even = .true.
         else
            even = .false.
         end if
         
         if (curvilinear) then

*           INDICES DEPEND ON WHETHER THERE ARE AN EVEN OR ODD # OF PTS
            if (even) then
               neo = num_buffered
               noe = num_buffered - 1
            else
               neo = num_buffered - 1
               noe = num_buffered
            end if

*           FIRST POINT IS LEFT CORNER OF FIRST TRIANGLE
            xarg(1) = xbuff(1,1)
            yarg(1) = ybuff(1,1)
               
*           FOLLOWED BY RIGHT CORNER OF ALL TRIANGLES
            do 110 m = 2, neo, 2
               xarg(m/2+1) = xbuff(3,m)
               yarg(m/2+1) = ybuff(3,m)
 110        end do
               
*           PICK THE RIGHT CORNER OF THE LAST TRIANGLE
            xarg(neo/2+2) = xbuff(2,num_buffered)
            yarg(neo/2+2) = ybuff(2,num_buffered)
               
*           THEN RETURN ALONG LEFT CORNER OF EACH TRIANGLE
            ndx = 2*num_buffered + 5
            
            do 120 m = noe, 1, -2
               xarg((ndx-m)/2) = xbuff(3,m)
               yarg((ndx-m)/2) = ybuff(3,m)
 120        end do

            call fillpoly (xarg, yarg, num_buffered+2, ilast-1,
     .                     xadd, lmin, lmax)
         else
            if (upper_first .and. even) then
               xarg(1) = xbuff(1,1)
               yarg(1) = ybuff(1,1)
               
               xarg(2) = xbuff(3,num_buffered)
               yarg(2) = ybuff(3,num_buffered)
               
               xarg(3) = xbuff(2,num_buffered)
               yarg(3) = ybuff(2,num_buffered)
               
               xarg(4) = xbuff(3,1)
               yarg(4) = ybuff(3,1)

               call fillpoly (xarg, yarg, 4, ilast-1, xadd, lmin, lmax)
            else if (upper_first .and. .not.even) then

               xarg(1) = xbuff(1,1)
               yarg(1) = ybuff(1,1)
               
               xarg(2) = xbuff(1,num_buffered)
               yarg(2) = ybuff(1,num_buffered)
               
               xarg(3) = xbuff(2,num_buffered)
               yarg(3) = ybuff(2,num_buffered)
               
               xarg(4) = xbuff(3,1)
               yarg(4) = ybuff(3,1)

               call fillpoly (xarg, yarg, 4, ilast-1, xadd, lmin, lmax)
            else if (.not.upper_first .and. even) then

               xarg(1) = xbuff(1,1)
               yarg(1) = ybuff(1,1)
               
               xarg(2) = xbuff(1,num_buffered)
               yarg(2) = ybuff(1,num_buffered)
               
               xarg(3) = xbuff(2,num_buffered)
               yarg(3) = ybuff(2,num_buffered)
               
               xarg(4) = xbuff(2,1)
               yarg(4) = ybuff(2,1)

               call fillpoly (xarg, yarg, 4, ilast-1, xadd, lmin, lmax)
            else if (.not.upper_first .and. .not.even) then

               xarg(1) = xbuff(1,1)
               yarg(1) = ybuff(1,1)
               
               xarg(2) = xbuff(3,num_buffered)
               yarg(2) = ybuff(3,num_buffered)
               
               xarg(3) = xbuff(2,num_buffered)
               yarg(3) = ybuff(2,num_buffered)
               
               xarg(4) = xbuff(2,1)
               yarg(4) = ybuff(2,1)

               call fillpoly (xarg, yarg, 4, ilast-1, xadd, lmin, lmax)
            end if
         end if
      end if
      
 1000 buffer_empty = .true.
      num_buffered = 0
      
      return
      end

	SUBROUTINE LOAD_DSG_MASKVAR (dset, fmask_var, reload, status)

c set data/fmask=

* If a feaure-mask was given, store the values of the mask in line storage. 
* Save the memory location dsg_msk_lm(dset), in common. Mask data used in creating 
* feature-masks when computing feature-level masking which also may include 
* context limits in the E direftion. Will deallocate line mem dsg_msk_lm on 
* defining a new mask, closing the dataset, opr CANCEL DATA/FMASK
* 
* On a "LET mask= " find dataset(s) where the mask being defined has 
* the same name as the dataset's current mask. Here also test the 
* length of the new mask. If it's the right length for this dataset, 
* will replace its FMASK, otherwise the FMASK is canceled. 
*
* 4/20/2020 *acm* update to error message
* 6/ 3/2020 *acm* Allowing for LET command redefining an existing feature-mask variable.

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'slash.parm'
	include 'command.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xprog_state.cmn'
#include "tmap_dset.parm"
	include 'xdset_info.cmn_text'
	include 'xtm_grid.cmn_text'
	include 'netcdf.inc'

	LOGICAL reload
	INTEGER dset, status
	CHARACTER*(*) fmask_var
	
	LOGICAL TM_LEGAL_NAME, TM_ITSA_DSG
	INTEGER TM_DSG_DSET_FROM_GRID, TM_DSG_NFEATURES, 
     .		TM_LENSTR1, CX_DIM_LEN,
     .		i, ivar, grid, loc,  ndim, idir, npts, cx, mr1, 
     .		nfeatures, idim, dim(nferdims), attlen, varid, 
     .		attid, attype, attoutflag, slen
	CHARACTER FULL_VAR_TITLE*128, TM_FMT*48,
     .		buff*128, mask_title*128
	REAL	dummy

c Make sure the name is ok
	
	   IF (fmask_var .EQ. ' ') GOTO 5100
	   IF ( .NOT.TM_LEGAL_NAME(fmask_var) ) GOTO 5200


c find a variable in this dataset and test whether it's a dsg dataset
	      
	DO ivar = 1, maxvars
	   IF ( ds_var_setnum(ivar) .EQ. dset ) THEN
              grid = ds_grid_number(ivar)
              EXIT
	   ENDIF
	ENDDO

	IF (.NOT. TM_ITSA_DSG( grid ) ) GOTO 5300

	IF (dset .NE. TM_DSG_DSET_FROM_GRID( grid ) ) GOTO 5300
	nfeatures = TM_DSG_NFEATURES( grid )	


* Set the line-memory to store the mask data

* ... A mask was already defined. Wipe that one out and we'll redefine it.

	IF (dsg_msk_lm(dset) .NE. unspecified_int4)  THEN
	   CALL FREE_LINE_DYNMEM( dsg_msk_lm(dset) )
	   CALL TM_DEALLO_DYN_LINE( dsg_msk_lm(dset) )
	   dsg_msk_lm(dset) = unspecified_int4

* ... wipe memory clear of stored variables - this could change all definitions
	   DO i = 1,max_mr_avail
	      IF ( mr_protected( i ) .NE. mr_deleted ) 
     .               CALL DELETE_VARIABLE( i )
	   ENDDO

	ENDIF

* Load the variable. Reset the arg pointers to get the mask-var
* Use arg_start, arg_end to point to the name of the variable.
* We may be coming from a SET DATA/FMASK command or a LET command
* redefining a variable whose name is already associated with a 
* feature-mask for this dataset.

	loc = qual_given(slash_set_data_fmask)
	IF (loc.GT.0) THEN
	   num_args = 1	 
	   arg_end(1) = qual_end(loc)
	   arg_start(1) = qual_end(loc) - TM_LENSTR1(fmask_var) + 1
	ELSE
	   arg_end(1) = arg_start(1) + TM_LENSTR1(fmask_var) - 1
	ENDIF

	CALL GET_CMND_DATA ( cx_last, ptype_float, status )
	IF (status .NE. ferr_ok .OR. num_uvars_in_cmnd .GT. 1) GOTO 5400

* ... make sure it's a line (not a point,plane,etc.) and that the M extent
*     is the feature-length

	cx = is_cx(isp)
	CALL GET_CX_DIMS( cx, ndim, dim )
	IF ( ndim .GT. 1 ) GOTO 5400
	idim = dim(1)
	IF (nfeatures .NE. CX_DIM_LEN( idim, cx ) ) THEN
*  the mask doesn't match mask on this dset. Issue a note
	   IF (reload) GOTO 5500  
	   GOTO 5400
	ENDIF

* store it here,

	CALL TM_ALLO_TMP_LINE(dsg_msk_lm(dset), status)
	CALL GET_LINE_DYNMEM (nfeatures, dsg_msk_lm(dset), status)
	CALL TM_USE_LINE(dsg_msk_lm(dset))

	CALL TM_NEW_LINE_NAME ('FEATURE_MASK', buff ) 
	line_name(dsg_msk_lm(dset)) = buff
	line_direction( dsg_msk_lm(dset) ) = 'EE'

	mr1 = is_mr( num_uvars_in_cmnd )
	cx = is_cx( num_uvars_in_cmnd )

	CALL EXTRACT_LINE (cx,
     .			memry(mr1)%ptr,
     .			mr1,
     .			linemem(dsg_msk_lm(dset))%ptr,
     .			idir,
     .			ndim,
     .			npts,
     .			status	)

	IF (npts.NE.nfeatures .OR. status.NE.ferr_ok) GOTO 5000

* Put the default bad-flag into the mask data
	CALL TM_SWITCH_BAD ( cx_bad_data (cx), bad_val4, linemem(dsg_msk_lm(dset))%ptr, npts )

* Set a global attribute with the mask title

	buff = '__feature_mask_'
	attlen = TM_LENSTR1(buff)
	mask_title = FULL_VAR_TITLE( cx, .FALSE., attlen )

	varid = 0
	CALL CD_GET_VAR_ATT_ID (dset, varid, buff, attid, status) 
	IF (attid .GT. 0) THEN
	   CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, 
     .                buff, attype, attlen, attoutflag, status )
	   attoutflag = 0
	   CALL CD_REPLACE_ATTR (dset, varid, buff, attype, attlen, 
     .              mask_title, dummy, status)
	ELSE
	   attype = NCCHAR
	   attoutflag = 0
	   CALL CD_PUT_NEW_ATTR (dset, varid, buff, attype, 
     .                 attlen, attoutflag, mask_title, dummy, status )
	ENDIF
	IF (status .NE. ferr_ok) GOTO 5000

* And another with the feature-mask name	

	buff = '__feature_mask_var'
	attlen = TM_LENSTR1(buff)

	varid = 0
	CALL CD_GET_VAR_ATT_ID (dset, varid, buff, attid, status) 
	IF (attid .GT. 0) THEN
	   CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, 
     .                buff, attype, attlen, attoutflag, status )
	   attoutflag = 0
	   CALL CD_REPLACE_ATTR (dset, varid, buff, attype, attlen, 
     .              fmask_var, dummy, status)
	ELSE
	   attype = NCCHAR
	   attoutflag = 0
	   CALL CD_PUT_NEW_ATTR (dset, varid, buff, attype, 
     .                 attlen, attoutflag, fmask_var, dummy, status )
	ENDIF
	IF (status .NE. ferr_ok) GOTO 5000

	status = ferr_ok

 5000	RETURN

 5100	CALL ERRMSG( ferr_unknown_arg, status, 'argument required /FMASK=?', *5000)
 5200	CALL ERRMSG( ferr_invalid_command, status,
     .			'/FMASK=name is not an acceptable name', *5000)
 5300	CALL ERRMSG (ferr_invalid_command, status,
     .'/FMASK is set only for Dicrete Sampling Geometries datasets',
     .               						*5000 )
 5400	buff = TM_FMT(DBLE(nfeatures), 0, 12, i) 
	CALL ERRMSG (ferr_invalid_command, status,
     .'Mask variable must be 1-dimensional, with length num-features = '//
     .   buff(:i),						*5000 )
     
 5500	buff = TM_FMT(DBLE(dset), 0, 12, i)
	slen = TM_LENSTR1(fmask_var)
	CALL WARN ('Feature-mask on dataset '//buff(:i)//
     .   ' canceled. New definition of '//fmask_var(:slen)//
     .   ' does not match nfeatures of set '//buff(:i) )
	GOTO 5000

	END

      Subroutine MRGRNK (XVALT, IRNGT, JWRKT, NVAL)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
* 

!  From http://www.fortran-2000.com/rank/index.html#1.1  
! ACM conversion to f77
! __________________________________________________________
!   MRGRNK = Merge-sort ranking of an array
!   For performance reasons, the first 2 passes are taken
!   out of the standard loop, and use dedicated coding.
! __________________________________________________________
      Real XVALT(*)
      Integer IRNGT(*)
! __________________________________________________________
      Integer  JWRKT(*)	! same size as IRNGT
      Integer  LMTNA, LMTNC, IRNG1, IRNG2
      Integer  NVAL, IIND, IWRKD, IWRK, IWRKF, JINDA, IINDA, IINDB
      Real XVALA, XVALB

      INTEGER ii, indx
!

      IF (NVAL .EQ. 0) THEN
         Return
      ELSE IF (nval .EQ. 1) THEN
         IRNGT (1) = 1
         Return
      ENDIF
!
!  Fill-in the index array, creating ordered couples
!
      Do IIND = 2, NVAL, 2
         If (XVALT(IIND-1) .LE. XVALT(IIND)) Then
            IRNGT (IIND-1) = IIND - 1
            IRNGT (IIND) = IIND
         Else
            IRNGT (IIND-1) = IIND
            IRNGT (IIND) = IIND - 1
         End If
      End Do
      If (Mod(NVAL, 2) .NE. 0) Then
         IRNGT (NVAL) = NVAL
      End If
!
!  We will now have ordered subsets A - B - A - B - ...
!  and merge A and B couples into     C   -   C   - ...
!
      LMTNA = 2
      LMTNC = 4
!
!  First iteration. The length of the ordered subsets goes from 2 to 4
!
      Do WHILE (.TRUE.)
         If (NVAL .LE. 2) GO TO 3000
!
!   Loop on merges of A and B into C
!
         Do IWRKD = 0, NVAL - 1, 4
            If ((IWRKD+4) .GT. NVAL) Then
               If ((IWRKD+2) .GE. NVAL) GO TO 2000
!
!   1 2 3
!
               If (XVALT(IRNGT(IWRKD+2)) .LE. XVALT(IRNGT(IWRKD+3))) 
     .             GO TO 2000
!
!   1 3 2
!
               If (XVALT(IRNGT(IWRKD+1)) .LE. XVALT(IRNGT(IWRKD+3)))Then
                  IRNG2 = IRNGT (IWRKD+2)
                  IRNGT (IWRKD+2) = IRNGT (IWRKD+3)
                  IRNGT (IWRKD+3) = IRNG2
!
!   3 1 2
!
               Else
                  IRNG1 = IRNGT (IWRKD+1)
                  IRNGT (IWRKD+1) = IRNGT (IWRKD+3)
                  IRNGT (IWRKD+3) = IRNGT (IWRKD+2)
                  IRNGT (IWRKD+2) = IRNG1
               End If
               GO TO 2000
            End If
!
!   1 2 3 4
!

            If (XVALT(IRNGT(IWRKD+2)) .LE. XVALT(IRNGT(IWRKD+3))) 
     .            GO TO 1000
!
!   1 3 x x
!
            If (XVALT(IRNGT(IWRKD+1)) .LE. XVALT(IRNGT(IWRKD+3))) Then
               IRNG2 = IRNGT (IWRKD+2)
               IRNGT (IWRKD+2) = IRNGT (IWRKD+3)
               If (XVALT(IRNG2) .LE. XVALT(IRNGT(IWRKD+4))) Then
!   1 3 2 4
                  IRNGT (IWRKD+3) = IRNG2
               Else
!   1 3 4 2
                  IRNGT (IWRKD+3) = IRNGT (IWRKD+4)
                  IRNGT (IWRKD+4) = IRNG2
               End If
!
!   3 x x x
!
            Else
               IRNG1 = IRNGT (IWRKD+1)
               IRNG2 = IRNGT (IWRKD+2)
               IRNGT (IWRKD+1) = IRNGT (IWRKD+3)
               If (XVALT(IRNG1) .LE. XVALT(IRNGT(IWRKD+4))) Then
                  IRNGT (IWRKD+2) = IRNG1
                  If (XVALT(IRNG2) .LE. XVALT(IRNGT(IWRKD+4))) Then
!   3 1 2 4
                     IRNGT (IWRKD+3) = IRNG2
                  Else
!   3 1 4 2
                     IRNGT (IWRKD+3) = IRNGT (IWRKD+4)
                     IRNGT (IWRKD+4) = IRNG2
                  End If
               Else
!   3 4 1 2
                  IRNGT (IWRKD+2) = IRNGT (IWRKD+4)
                  IRNGT (IWRKD+3) = IRNG1
                  IRNGT (IWRKD+4) = IRNG2
               End If
            End If
 1000       CONTINUE
         End Do
 2000    CONTINUE
!
!  The Cs become As and Bs
!
         LMTNA = 4
         GO TO 3000
      End Do
 3000 CONTINUE

!
!  Iteration loop. Each time, the length of the ordered subsets
!  is doubled.
!
      Do WHILE (.TRUE.)
         If (LMTNA .GE. NVAL) GO TO 6000
         IWRKF = 0
         LMTNC = 2 * LMTNC
!
!   Loop on merges of A and B into C
!
         Do WHILE (.TRUE.)
 7000       CONTINUE
            IWRK = IWRKF
            IWRKD = IWRKF + 1
            JINDA = IWRKF + LMTNA
            IWRKF = IWRKF + LMTNC
            If (IWRKF .GE. NVAL) Then
               If (JINDA .GE. NVAL) GO TO 5000
               IWRKF = NVAL
            End If
            IINDA = 1
            IINDB = JINDA + 1
!
!   Shortcut for the case when the max of A is smaller
!   than the min of B. This line may be activated when the
!   initial set is already close to sorted.
!
!          IF (XVALT(IRNGT(JINDA)) .LE. XVALT(IRNGT(IINDB))) GO TO 7000
!
!  One steps in the C subset, that we build in the final rank array
!
!  Make a copy of the rank array for the merge iteration
!
            indx = iwrkd
            DO ii = 1, lmtna
              JWRKT (ii) = IRNGT (indx)
              indx = indx + 1
            ENDDO
!
            XVALA = XVALT (JWRKT(IINDA))
            XVALB = XVALT (IRNGT(IINDB))
!
            Do WHILE (.TRUE.)
               IWRK = IWRK + 1
!
!  We still have unprocessed values in both A and B
!
               If (XVALA .GT. XVALB) Then
                  IRNGT (IWRK) = IRNGT (IINDB)
                  IINDB = IINDB + 1
                  If (IINDB .GT. IWRKF) Then
!  Only A still with unprocessed values
                     indx = iinda
                     DO ii = IWRK+1, IWRKF
                        IRNGT (ii) = JWRKT (indx)
                        indx = indx + 1
                     ENDDO

                     GO TO 4000
                  End If
                  XVALB = XVALT (IRNGT(IINDB))
               Else
                  IRNGT (IWRK) = JWRKT (IINDA)
                  IINDA = IINDA + 1
                  If (IINDA .GT. LMTNA) GO TO 4000 ! Only B still with unprocessed values
                  XVALA = XVALT (JWRKT(IINDA))
               End If
!
            End Do
 4000       CONTINUE
         End Do
 5000    CONTINUE
!
!  The Cs become As and Bs
!
         LMTNA = 2 * LMTNA
      End Do
 6000 CONTINUE
!
      Return
      End	!Subroutine MRGRNK

	SUBROUTINE  VEL_BY_GRAD_P( dpdx, mdpdx,
     .				   ubp, mubp )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute contribution to velocity from GRAD(Pclinic)
* essentially this routine performs only a change of units from sec-1 to month-1
* note1: the same code applies to both X and Y components
* note2: a value of rho=1 is assumed for dimensional correctness

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 -1/26/87 
* V200:  7/27/89 - 4D symmetrical version
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN

#ifdef unix
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl.parm'		! parameter definitions
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xonedim.cmn'	! geometric constants
	include 'xcontext.cmn'
#else
	INCLUDE 'FERRET_CMN:FERRET.PARM'
	INCLUDE 'FERRET_CMN:GFDL.PARM'		! parameter definitions
	INCLUDE	'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE	'FERRET_CMN:XMEM_SUBSC.CMN'
	INCLUDE 'FERRET_CMN:XONEDIM.CMN'	! geometric constants
	INCLUDE 'FERRET_CMN:XCONTEXT.CMN'
#endif

* calling argument declarations:
	INTEGER	mdpdx, mubp

* subscript ranges from memory variable table ...
	REAL    dpdx( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit ),
     .		 ubp( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,m2lot:m2hit )

* internal variable declarations:
	INTEGER	MGRID_SIZE, grid_size
	REAL	factor

* --- end of introductory code ---

* total words in result grid
	grid_size = MGRID_SIZE( mubp )

* ***************************************************************
* ORIGINAL GFDL 205 CODE UPON WHICH CALCULATION IS BASED
*
* 406 C   ADD IN PRESSURE TERM AND ZERO OUT LAND

* 417       DO 360 K=1,KM
* 418       DO 360 I=1,IMT
* 419       UA(I,K)=GM(I,K)*((UA(I,K)-DPDX(I,K)
* 420      * +TEMP(I,K)*U(I,K)-
* 421      *  TEMP2D(I,K)*DXU2R2D(I,K)*(V(I+1,K)-V(I-1,K))))
* 422  360  CONTINUE
* 423       DO 370 K=1,KM
* 424       DO 370 I=1,IMT
* 425       VA(I,K)=GM(I,K)*((VA(I,K)-DPDY(I,K)
* 426      * +TEMP(I,K)*V(I,K)+
* 427      *  TEMP2D(I,K)*DXU2R2D(I,K)*(U(I+1,K)-U(I-1,K))))
* 428  370  CONTINUE
*************************************************************************
* in the 205 code the effectd of DPDX are simple subtracted from UA

* change the sign from how it is used in the 205 code so that all of the
* incremental pieces get added together to form the velocity increment
	factor = -1. * cmonthly

	CALL COPY_GRID( dpdx, mdpdx, ubp, mubp )

	CALL MULT_GRID( grid_size, ubp, factor )

	RETURN

	END

      SUBROUTINE SWAP_ACTIVE_WINDOW()

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* v5.22 *kob* - routine to swap and unswap the active
*               window id's for double buffered windows/animation. 
*               While animating, the inactive window is the one the 
*               animation is being copied to.  The active window is the
*               unmapped window in which the plots/shades are being drawn.
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xprog_state.cmn'
	include 'xinterrupt.cmn'
	include 'plot_setup.parm'
        include 'xplot_setup.cmn'
	include 'xplot_state.cmn'
	include	'pltcom_dat.decl' 
	include	'PLTCOM.DAT'         	  ! with asize,bsize
        include 'plt_inc.decl'     ! with width/height
        include 'PLT.INC'
	include	'gkscm1_inc.decl'	! with gks common
	include	'GKSCM1.INC'	                ! with gks common

        REAL*4  xln, yln, dmaxx, dmaxy
        INTEGER ier, id, itype, imeter, irx, iry,i, idim,
     .          iseg, anim_id, status
        LOGICAL new_window
	REAL*4  rzero, fctx, fcty

	rzero = 0.0

*    calculate size of the window open
*     - taken from set_window.F

        IF (WKXMX .EQ. 0 .AND. WKYMX .EQ. 0) new_window = .TRUE.

        IF(ASIZE.GT.BSIZE)THEN
           FCTY=BSIZE/ASIZE
           FCTX=1.0
        ELSE
           FCTX=ASIZE/BSIZE
           FCTY=1.0
        ENDIF            

        CALL GQWKC(wsid,IER,ID,ITYPE)
        CALL QUERY_DISPLAY_SIZE(ITYPE,IER,IMETER,
     .       DMAXX,DMAXY,IRX,IRY)

        XLN=ASIZE*2.54E-5       ! Denbo milli-inches to meters
        YLN=BSIZE*2.54E-5           
*     re-scale as requested
        xln = wn_scale(wsid) * xln
        yln = wn_scale(wsid) * yln
        wkxmn = MIN( xlowlef(wsid), dmaxx-xln )
        wkymn = MIN( ylowlef(wsid), dmaxy-yln )
        WKXMX=WKXMN+XLN
        WKYMX=WKYMN+YLN

* Check if animation is being turned on, or if we're done
        IF (animate .EQV. .TRUE.) THEN 
* Find the currently active window
           DO wsid = 1,max_windows
              IF (wn_active(wsid) ) GOTO 50
           end do
 50        wn_scale(win_id9) = wn_scale(wsid)

*     swap id's
           active_win_id = wsid
           anim_id = active_win_id
           wsid = win_id9
*     deactivate what will become the animated window
           CALL GDAWK( anim_id)
           wn_active(anim_id) = .FALSE.
*     activate the unmapped window
           CALL GACWK( wsid)
           wn_active(wsid) = .TRUE.

*     if we've already done a plot set window size accordingly
           IF (.NOT. new_window) THEN
*     set its correct size if we've done a plot
              CALL GSWKWN(wsid,rzero,FCTX,rzero,FCTY)
              CALL SET_WINDOW_SIZE (wsid,WKXMN,WKXMX,WKYMN,WKYMX)
              CALL GSWKWN(anim_id,rzero,FCTX,rzero,FCTY)
              CALL SET_WINDOW_SIZE (anim_id,WKXMN,WKXMX,WKYMN,WKYMX)
           ELSE
              CALL GSELNT(wsid)
           ENDIF

           CALL XGKS_X_EVENTS


        ELSE 
* done animating
           CALL CLEAR_WINDOW( wsid )
           IF ( vp_num .EQ. mvp_dflt ) THEN
*     return to full screen - clear away everything
              DO 100 iseg = mvp_dflt, max_viewport
                 IF (iseg .gt. 0 .AND. iseg .LE. max_viewport) THEN
                    vp_seg0(iseg) = 0
                    vp_segn(iseg) = 0
                 ENDIF
 100          CONTINUE
           ELSE
*     delete any segments showing in this viewport
              DO 200 iseg = vp_seg0(vp_num)+1, vp_segn(vp_num)
                 IF (iseg .gt. 0 .AND. iseg .LE. max_viewport) THEN
                    vp_seg0(iseg) = 0
                    vp_segn(iseg) = 0
                 ENDIF
 200          CONTINUE
              CALL GUWK( wsid, 1 )
              CALL PPL_SHASET( 'PROTECT' ) ! protect the colors already on-screen
           ENDIF
           
*     done animating so switch id's back
           wsid = active_win_id
           anim_id = win_id9
*     deactivate what is now the unmapped window
           CALL GDAWK(anim_id)
           wn_active(anim_id) = .FALSE.
*     close unmapped window
           CALL GCLWK(anim_id, batmode)
           wn_open ( anim_id ) = .FALSE.
*     activate the mapped window for continued ferret use
           CALL GACWK(wsid)
           wn_active(wsid) = .TRUE.


              
           ENDIF
           
           RETURN
           END
      

	SUBROUTINE GET_DEPENDENCY_STATUS
     .			(  expr, status_string, slen, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* set up the xdependency_tree COMMON area by running the dependency crawl
* return a line describing the outcome

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V685+  *sh* 11/13 
* V690  *sg* 5/14 - bug fix: changed declaraation type of "memory"
* V702 1/17 *sh* for trac enhancement #2369 -- dynamic memory management

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xdependency_tree.cmn'

* calling argument declarations:
	INTEGER status, slen
	CHARACTER*(*) expr, status_string

* internal variable declarations:
	INTEGER TM_LENSTR1, base_isp, base_cx

        base_isp = 8
        base_cx = 8
        CALL INIT_DEPENDENCIES( cx_last, .TRUE., base_isp, status )
        IF (status.NE. ferr_ok) GOTO 5000

        CALL CRAWL_DEPENDENCIES ( expr, base_cx, status)
        IF (status .NE. ferr_ok) GOTO 5000

	IF (    dependency_status .EQ. df_valid_var) THEN
	   status_string = 'AVAILABLE'
        ELSEIF (dependency_status .EQ. df_unknown_auxvar) THEN
	   status_string = 'UNKNOWN AUXILIARY VARIABLE'
	ELSEIF (dependency_status .EQ. df_unknown_var) THEN
	   status_string = 'UNKNOWN VARIABLE'
	ELSEIF (dependency_status .EQ. df_unknown_grid) THEN
	   status_string = 'UNKNOWN GRID'
	ELSEIF (dependency_status .EQ. df_syntax_error) THEN
	   status_string = 'ERROR IN EXPRESSION'
	ELSEIF (dependency_status .EQ. df_unknown_dataset) THEN
	   status_string = 'UNKNOWN DATASET'
	ELSEIF (dependency_status .EQ. df_recursion_error) THEN
	   status_string = 'ILLEGAL RECURSIVE VARIABLES'
	ELSE
	   STOP 'repl_exprns_depend_tree'
	ENDIF
	slen = TM_LENSTR1(status_string)

* if status incicates a problem, append a substring from the variable definitions
	IF (dependency_status .NE. df_valid_var ) THEN
	   status_string(slen+1:slen+2) = ': '
	   CALL DEPEND_STAT_VAR( workmem(plegacy_work_buffer)%ptr,
     .					status_string(slen+3:) )
	   slen = TM_LENSTR1(status_string)
	ENDIF

 5000	CALL RELEASE_DYN_WORK_SPACE
	RETURN
	END

	SUBROUTINE LEVEL
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)level.F	1.1    3/10/88
C** V600:  1/06 *acm*  prevent values of LOG10(0.0)
* V610 *acm* 3/08 - add new MODE NLEVELS; default number of levels is now 40
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**

	INCLUDE 'PARAMPL5.DAT'
	INCLUDE 'CMRD.INC'
	INCLUDE 'cont_inc.decl'
	INCLUDE 'CONT.INC'

	DO 2601 I=1,M 
	IF(IFLG(I).NE.0)ZLEV(I)=P(I) 
2601	CONTINUE 
	NLEV=M 
	IF(M.LE.1)THEN 
	    NLEV=IFIX(P(1)) 
	    IF(M.EQ.0)NLEV=NLEV_DFLT
	    IAUTOC=1 
	    GOTO 10 
	ELSE 
	    IAUTOC=0 
            IF (ZLEV(1)-ZLEV(NLEV) .EQ. 0) THEN
	       JJ=NSIGC
            ELSE 
	       JJ=NSIGC-IFIX(ALOG10(ABS(ZLEV(1)-ZLEV(NLEV)))+.5) 
	    ENDIF
            IF(JJ.LE.0)JJ=-1 
	    DO 2602 I=1,NLEV 
	    LCLR(I)=0
	    IF(ZLEV(I).EQ.0.)THEN 
	      LDIG(I)=-1 
	    ELSE 
		LDIG(I)=JJ
	    END IF
2602	    CONTINUE
	END IF 
	IFLG(1)=0 
	DO 2603 I=1,NLEV 
	LWGT(I)=2 
	IF(ABS(ZLEV(I)).LT.ABS(ZLEV(1)-ZLEV(2))*1.E-5)GOTO 2603 
	IF(ZLEV(I).GT.0.)THEN 
	    LWGT(I)=1 
	ELSE 
	    LWGT(I)=3 
	END IF 
2603	CONTINUE 
10	RETURN
	END

	SUBROUTINE CALC_CVAR( memory, cx, mrl, mres, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* calculate one or more variables based on the components supplied

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  7/24/89 - based on CALC_XYGRID
*	10/16/89 - adjustable array dimensioning via NON_ARRAY_SUBSC
*	 2/27/90 - added v2.0 CAIR
*		 - and made it able to handle unspecified result region limits
*	 3/13/90 - fixed subsc. err. in QAD (et.al.) with unspec lims
*	 5/15/90 - special unknown subscript checks for AIR components
* V312: 5/94 - array "memory" as a calling argument
* V320: 12/29/94 - use SPLIT_LIST to redirect tty output for GUI
* V685 *acm*  6/13 Increase nominal length of abstract axis

* calling arguments:
* inp	cx	- "context" of the desired result (variable,data set and region)
* inp	mrl	- list of memory variable numbers for the 
*			  component variables of the calculation
* out	mres	- memory variable number of requested result

#ifdef unix
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'instance_table.parm'
	include	'gfdl.parm'
	include	'xvariables.cmn'
	include	'xcalc_vars.cmn'
	include	'xprog_state.cmn'
	include	'xcontext.cmn'
#else
	INCLUDE	'FERRET_CMN:FERRET.PARM'
	INCLUDE	'FERRET_CMN:ERRMSG.PARM'
	INCLUDE	'FERRET_CMN:INSTANCE_TABLE.PARM'
	INCLUDE	'FERRET_CMN:GFDL.PARM'
	INCLUDE	'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE	'FERRET_CMN:XCALC_VARS.CMN'
	INCLUDE	'FERRET_CMN:XPROG_STATE.CMN'
	INCLUDE	'FERRET_CMN:XCONTEXT.CMN'
#endif

	INTEGER		max_components
	PARAMETER     ( max_components = 20 )

* calling argument declarations:
	INTEGER		cx, mrl( max_components ), mres, status
	REAL	memory( mem_blk_size, max_mem_blks )

* internal variable declarations:
	LOGICAL		HOURLY_DATA, chg(4), unk(4), reg, two_results
	INTEGER		CGRID_SIZE, MGRID_SIZE, CGRID_AXIS, MR_DIM_LEN,
     .			nmr, mxtra, cx_xtra, cx_lrg, grid_size, temp_grid_size,
     .			var, ncomp, icomp, iend, k, i, idim, mr, fp, grid,
     .			temp_start_blk, temp_nblks, dlo, dhi,
     .			loest_ss, hiest_ss, res_ss_lo(4), res_ss_hi(4)
	REAL		dt
	REAL*8		TM_WORLD

* for diagnostic output:
	CHARACTER*4	VAR_CODE
	CHARACTER*132	diag_buff
	DATA		diag_buff(1:9) / '-->using:' /

* remove special codes from variable to compute
	var = cx_variable( cx )
	IF ( var .GT. pcv_spec_flg ) var = var - pcv_spec_flg
	cx_variable( cx ) = var

* initialize some stuff
	two_results = cvar_num_results( var ) .GT. 1	! only 2 or 1 allowed
	ncomp  = cvar_frame_length( var )
	grid   = cx_grid( cx )
	DO 1 idim = 1, 4
	res_ss_lo(idim) = 0
	res_ss_hi(idim) = 9999999
	unk( idim ) = .FALSE.
 1	chg( idim ) = .FALSE.

* diagnostic output ?
	IF ( mode_diagnostic ) THEN
	   diag_buff = '--> '//VAR_CODE( cat_calc_var, var )//' from: '
	   iend = 15
	   DO 2 icomp = 1, cvar_frame_length( var )
	      iend = iend + 5
	      mr = mrl( icomp )
	      WRITE ( diag_buff( iend-4:iend ), '(1X,A)' )
     .			VAR_CODE(  mr_category(mr),mr_variable(mr) )
 2	   CONTINUE
	   CALL SPLIT_LIST( pttmode_ops, ttout_lun, diag_buff, iend )
	ENDIF

* shrink requested dimensions to match smallest available component
	fp = cvar_frame_start (var)		! frame pointer
	DO 6 icomp = 1, ncomp
	   fp = fp + 1
	   mr = mrl( icomp )
	   IF ( mr .EQ. dummy_mr ) GOTO 6
	   DO 4 idim = 1, 4
	      IF ( CGRID_AXIS( idim, cx ) .EQ. mnormal ) GOTO 4
	      IF ( mr_lo_ss( mr, idim ) .EQ. unspecified_int4 ) GOTO 4
	      CALL GRID_SUBSCRIPT_EXTREMES ( loest_ss, hiest_ss, grid, idim )
	      dlo = cv_lo_ds(fp,idim)
	      dhi = cv_hi_ds(fp,idim)
	      IF ( idim.EQ.T_dim .AND. dlo.GT.pcv_hourly_flg ) THEN
	         dlo = 0
	         dhi = 0
	         IF ( HOURLY_DATA( grid ) ) dlo = -1
	      ENDIF
* ... 5/90: air temp is special because it sometimes uses regridded CAIR
* ... if it gets here with t_dim unspecified in the SST component
* ... it must be a non-regridded case (note: mr(cair)-->dummy in this case)
	      IF ( var .EQ. pair ) THEN
	         IF ( idim .EQ. t_dim ) THEN
	            IF ( cx_lo_ss(cx,idim) .EQ. unspecified_int4 ) THEN
	               res_ss_lo(idim) = mr_lo_ss(mr,idim)
	               res_ss_hi(idim) = mr_hi_ss(mr,idim)
	               chg( idim ) = .TRUE.
	               unk( idim ) = .TRUE.
	               GOTO 4
	            ENDIF
	         ENDIF
	      ENDIF
* ... fill in unspecified limits (2/90) - fixed QAD error 3/90
	      IF ( cx_lo_ss(cx,idim) .EQ. unspecified_int4 ) THEN
	         res_ss_lo(idim) = MAX( res_ss_lo(idim),
     .					mr_lo_ss(mr,idim) - dlo )
	         res_ss_hi(idim) = MIN( res_ss_hi(idim),
     .					mr_hi_ss(mr,idim) - dhi )
	         chg( idim ) = .TRUE.
	         unk( idim ) = .TRUE.
	         GOTO 4
	      ENDIF
* ... trim limits to available source data
	      IF ( cx_lo_ss(cx,idim) .NE. loest_ss
     .	     .AND. cx_lo_ss(cx,idim)+dlo .LT. mr_lo_ss(mr,idim) ) THEN
	         cx_lo_ss(cx,idim) = mr_lo_ss(mr,idim) - dlo
	         chg( idim ) = .TRUE.
	      ENDIF
	      IF ( cx_hi_ss(cx,idim) .NE. hiest_ss
     .	     .AND. cx_hi_ss(cx,idim)+dhi .GT. mr_hi_ss(mr,idim) ) THEN
	         cx_hi_ss(cx,idim) = mr_hi_ss(mr,idim) - dhi
	         chg( idim ) = .TRUE.
	      ENDIF
 4	   CONTINUE
 6	CONTINUE
	DO 8 idim = 1, 4
	   IF ( unk(idim) ) THEN
* ... fill unspecified result limits with the amount of component available
	      cx_lo_ss(cx,idim) = res_ss_lo(idim)
	      cx_hi_ss(cx,idim) = res_ss_hi(idim)
	   ENDIF
	   IF ( chg(idim) ) THEN
	      cx_by_ss(idim,cx) = .TRUE.
	      CALL CONFINE_AXIS( idim, cx, status )
	      IF ( status .NE. ferr_ok ) RETURN
	      CALL FLESH_OUT_AXIS( idim, cx, status )	
	      IF ( status .NE. ferr_ok ) GOTO 5000
	   ENDIF
 8	CONTINUE

* create another context in case result must be larger that requested size
* (for example baroclinic pressure must always be computed from Z=0 even if
*  it is requested only at depth)
	CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) RETURN
	cx_lrg = cx_stack_ptr
	CALL TRANSFER_CONTEXT( cx, cx_lrg )

* Z range to start at K=1 for components of baroclinic pres. and W
	IF ( var.EQ.pdpdx  .OR. var.EQ.pdpdy
     .	.OR. var.EQ.pw_u   .OR. var.EQ.pw_t  ) THEN
	   DO 9 icomp = 1, ncomp
	      mr = mrl( icomp )
	      IF ( mr_lo_ss( mr, z_dim ) .EQ. unspecified_int4 ) GOTO 9
	      IF ( mr_lo_ss( mr, z_dim ) .NE. 1 ) CALL ERRMSG
     .		( ferr_out_of_range, status,
     .		'baroclinic pressure requires surface data', *5000 )
 9	   CONTINUE
* ... result will go to k=1, also
	   cx_lo_ss( cx_lrg, z_dim ) = 1
	   cx_lo_ww(z_dim, cx_lrg) = TM_WORLD( 1, cx_grid(cx_lrg),
     .					       z_dim, box_lo_lim )
	ENDIF
	grid_size = CGRID_SIZE( cx_lrg )

* reserve memory space for result
	CALL CREATE_MEM_VAR( cx_lrg, mres, status )
	IF ( status .NE. ferr_ok ) RETURN
	nmr = ncomp + 1
	IF ( isp+nmr .GT. max_intrp ) CALL ERRMSG
     .				( ferr_stack_ovfl, status, ' ',*5200 )
	mrl(nmr) = mres	! put it in the list fot NON_ARRAY_SUBSC

* create another context in case 2 results are computed at once
	IF ( two_results ) THEN
	   CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   cx_xtra = cx_stack_ptr
	   CALL TRANSFER_CONTEXT( cx_lrg, cx_xtra )
	   CALL CREATE_MEM_VAR( cx_xtra, mxtra, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   nmr = nmr + 1
	   IF ( isp+nmr .GT. max_intrp ) CALL ERRMSG
     .				( ferr_stack_ovfl, status, ' ',*5100 )
	   mrl(nmr) = mxtra	! put it in the list fot NON_ARRAY_SUBSC
	ENDIF

* extract all the necessary dimensions to unsubscripted variables
	CALL NON_ARRAY_SUBSC( mrl, nmr )

* see BLOCK DATA XVARIABLES_DATA for lists of components in each calculation
	GOTO (	 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     .		110,120,130,140,150,160,170,180,190,200,
     .		210,220,230,240,250,260,270,280,290,300,
     .		310,320,330,340,350,360,370,380,390,400,
     .		410,420,430,440,450,460,470,480,490,500,
     .		510,520,530,540,550,560,570,580,590		 ) var

* QCDZ - vertical heat diffussion coefficient
* ... also computes and stores PCDZ ...
 10	cx_variable( cx_xtra ) = ppcdz
	cx_grid( cx_xtra ) = cvar_grid( ppcdz, cx_data_set(cx) )
	CALL RE_ASSIGN_VARIABLE( mxtra, cx_xtra )
	CALL PROF (
     .		km					, ! k max
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! u
     .		memory( 1, mr_blk1( mrl(2) ) ), mrl(2)	, ! v
     .		memory( 1, mr_blk1( mrl(3) ) ), mrl(3)	, ! rho0
     .		memory( 1, mr_blk1( mxtra  ) ), mxtra	, ! pcdz
     .		memory( 1, mr_blk1( mres   ) ), mres	) ! qcdz
	GOTO 1900

* PCDZ - vertical momentum diffussion coefficient
* ... also computes and stores QCDZ ...
 20	cx_variable( cx_xtra ) = pqcdz
	cx_grid( cx_xtra ) = cvar_grid( pqcdz, cx_data_set(cx) )
	CALL RE_ASSIGN_VARIABLE( mxtra, cx_xtra )
	CALL PROF (
     .		km					, ! k max
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! u
     .		memory( 1, mr_blk1( mrl(2) ) ), mrl(2)	, ! v
     .		memory( 1, mr_blk1( mrl(3) ) ), mrl(3)	, ! rho0
     .		memory( 1, mr_blk1( mres   ) ), mres	, ! pcdz
     .		memory( 1, mr_blk1( mxtra  ) ), mxtra	) ! qcdz
	GOTO 1900

* RHO0 - density referenced to surface ( compression effects neglected )
 30	CALL STATED (
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	,	  ! temp
     .		memory( 1, mr_blk1( mrl(2) ) ), mrl(2)	, 	  ! salt
     .		memory( 1, mr_blk1( mres   ) )	, mres		) ! rho0
	GOTO 2000

* QDFZ - vertical heat diffussion
 40	CALL Z_HDIFFUS (
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! temp
     .		memory( 1, mr_blk1( mrl(2) ) ), mrl(2)	, ! qvdc
     .		memory( 1, mr_blk1( mrl(3) ) ), mrl(3)	, ! qflx
     .		memory( 1, mr_blk1( mres   ) )	, mres	) ! qdfz
	GOTO 2000

* QDFH - horizontal heat diffussion
 50	CALL XY_HDIFFUS (
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! temp
     .		memory( 1, mr_blk1( mres   ) ), mres	) ! qdfh
	GOTO 2000

* QADX - zonal heat advection
 60	CALL EW_HADVEC (
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! temp
     .		memory( 1, mr_blk1( mrl(2) ) ), mrl(2)	, ! u   
     .		memory( 1, mr_blk1( mres   ) ), mres	) ! qadx
	GOTO 2000

* QADY - meridianal heat advection
 70	CALL SN_HADVEC (
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! temp
     .		memory( 1, mr_blk1( mrl(2) ) ), mrl(2)	, ! v   
     .		memory( 1, mr_blk1( mres   ) ), mres	) ! qady
	GOTO 2000

* QADZ - vertical heat advection
 80	CALL Z_HADVEC (
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! temp
     .		memory( 1, mr_blk1( mrl(2) ) ), mrl(2)	, ! w   
     .		memory( 1, mr_blk1( mres   ) ), mres	) ! qadz
	GOTO 2000

* QAD  - total heat advection
 90	CALL COPY_GRID(
     .	  memory( 1, mr_blk1(mrl(1)) ) , mrl(1),		! qadx
     .	  memory( 1, mr_blk1( mres   )), mres	)		! qad
	CALL ADD_2_GRIDS(
     .	  memory( 1, mr_blk1(mrl(2)) ) , mrl(2),		! qady
     .	  memory( 1, mr_blk1( mres   )), mres	 )		! qad
	CALL ADD_2_GRIDS(
     .	  memory( 1, mr_blk1(mrl(3)) ) , mrl(3),		! qadz
     .	  memory( 1, mr_blk1( mres   )), mres 	 )		! qad
	GOTO 2000	

* QDF  - total heat diffussion
 100	CALL COPY_GRID(
     .	  memory( 1, mr_blk1(mrl(1)) ) , mrl(1),		! qdfh
     .	  memory( 1, mr_blk1( mres   )), mres 	 )		! qdf
	CALL ADD_2_GRIDS(
     .	  memory( 1, mr_blk1(mrl(2)) ),  mrl(2),		! qdfz
     .	  memory( 1, mr_blk1( mres   )), mres	 )		! qdf
	GOTO 2000

* QEVA - surface evaporative cooling
* ... also computes and stores QSEN ...
 110	cx_variable( cx_xtra ) = pqsen
	CALL RE_ASSIGN_VARIABLE( mxtra, cx_xtra )
	CALL HFLUX (
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! tau
     .		memory( 1, mr_blk1( mrl(2) ) ), mrl(2)	, ! sst
     .		memory( 1, mr_blk1( mrl(3) ) ), mrl(3)	, ! air
     .		memory( 1, mr_blk1( mxtra  ) ), mxtra	, ! qsen
     .		memory( 1, mr_blk1( mres   ) ), mres	) ! qeva
* ... convert units ...
	CALL MULT_GRID( grid_size, memory(1,mr_blk1( mxtra  )), q2wattm2 )
	CALL MULT_GRID( grid_size, memory(1,mr_blk1( mres   )), q2wattm2 )
	GOTO 1900

* TAU  - wind stress magnitude
 120	CALL WIND_STRESS (
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	,	! taux
     .		memory( 1, mr_blk1( mrl(2) ) ), mrl(2)	,	! tauy
     .		memory( 1, mr_blk1( mres   ) ), mres	)	! tau
	GOTO 2000

* QSEN - surface sensible heat
* ... also computes and stores QEVA ...
 130	cx_variable( cx_xtra ) = pqeva
	CALL RE_ASSIGN_VARIABLE( mxtra, cx_xtra )
	CALL HFLUX (
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! tau
     .		memory( 1, mr_blk1( mrl(2) ) ), mrl(2)	, ! sst
     .		memory( 1, mr_blk1( mrl(3) ) ), mrl(3)	, ! air
     .		memory( 1, mr_blk1( mres   ) ), mres	, ! qsen
     .		memory( 1, mr_blk1( mxtra  ) ), mxtra	) ! qeva
* ... convert units ...
	CALL MULT_GRID( grid_size, memory(1,mr_blk1( mxtra  )), q2wattm2 )
	CALL MULT_GRID( grid_size, memory(1,mr_blk1( mres   )), q2wattm2 )
	GOTO 1900

* QRAD - surface radiative heat
 140	CALL HRADIATION( 
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	,	! sst
     .		memory( 1, mr_blk1( mres   ) ), mres	)	! qrad
*    ... convert units
	CALL MULT_GRID( grid_size, memory(1, mr_blk1( mres   )), q2wattm2 )
	GOTO 2000

* QFLX  - total heat flux
 150	CALL COPY_GRID(
     .	  memory( 1, mr_blk1(mrl(1)) )  , mrl(1) , 			! qeva
     .	  memory( 1, mr_blk1( mres   ) ), mres	  )			! qflx
	CALL ADD_2_GRIDS(
     .	  memory( 1, mr_blk1(mrl(2)) )  , mrl(2) , 			! qsen
     .	  memory( 1, mr_blk1( mres   ) ), mres	  )			! qflx
	CALL ADD_2_GRIDS(
     .	  memory( 1, mr_blk1(mrl(3)) )  , mrl(3) , 			! qrad
     .	  memory( 1, mr_blk1( mres   ) ), mres	  )			! qflx
	GOTO 2000

* RHO - true density
 160	CALL STATE (
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	,		! temp
     .		memory( 1, mr_blk1( mrl(2) ) ), mrl(2)	,		! salt
     .		memory( 1, mr_blk1( mres   ) ), mres		)	! rho
	GOTO 2000

* DPDX - x derivative of baroclinic pressure
* ... also computes and stores DPDY ...
 170	cx_variable( cx_xtra ) = pdpdy
	CALL RE_ASSIGN_VARIABLE( mxtra, cx_xtra )
	CALL GRAD_P_CLINIC (
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! rho 
     .		memory( 1, mr_blk1( mres   ) ), mres	, ! dpdx
     .		memory( 1, mr_blk1( mxtra  ) ), mxtra	) ! dpdy
	GOTO 1900

* DPDY - y derivative of baroclinic pressure
* ... also computes and stores DPDX ...
 180	cx_variable( cx_xtra ) = pdpdx
	CALL RE_ASSIGN_VARIABLE( mxtra, cx_xtra )
	CALL GRAD_P_CLINIC (
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! rho 
     .		memory( 1, mr_blk1( mxtra  ) ), mxtra	, ! dpdx
     .		memory( 1, mr_blk1( mres   ) ), mres	) ! dpdy
	GOTO 1900

* W_U - vertical velocity computed on the uv grid (still on w grid vertically)
 190	CALL W_ON_UV (
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! fuw
     .		memory( 1, mr_blk1( mrl(2) ) ), mrl(2)	, ! fvn
     .		memory( 1, mr_blk1( mres   ) ), mres	) ! w_u
	GOTO 2000

* UAVZ - vertically averaged zonal velocity calculated from PSI
* ... also computes and stores VAVZ ...
 200	cx_variable( cx_xtra ) = pvavz
	CALL RE_ASSIGN_VARIABLE( mxtra, cx_xtra )
	CALL U_FROM_PSI (
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! psi
     .		memory( 1, mr_blk1( mres   ) ), mres	, ! uavz
     .		memory( 1, mr_blk1( mxtra  ) ), mxtra	) ! vavz
	GOTO 1900

* VAVZ - vertically averaged meridional velocity calculated from PSI
* ... also computes and stores UAVZ ...
 210	cx_variable( cx_xtra ) = puavz
	CALL RE_ASSIGN_VARIABLE( mxtra, cx_xtra )
	CALL U_FROM_PSI (
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! psi
     .		memory( 1, mr_blk1( mxtra  ) ), mxtra	, ! uavz
     .		memory( 1, mr_blk1( mres   ) ), mres	) ! vavz
	GOTO 1900

* FUW - zonal advection coefficient ( internal variable for W_U and *ADX )
 220	CALL FUW (
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! psi
     .		memory( 1, mr_blk1( mrl(2) ) ), mrl(2)	, ! uavz
     .		memory( 1, mr_blk1( mrl(3) ) ), mrl(3)	, ! u
     .		memory( 1, mr_blk1( mres   ) ), mres	) ! fuw
	GOTO 2000

* FVN - meridional advection coefficient ( internal variable for W_U and *ADY )
 230	CALL FVN (
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! psi
     .		memory( 1, mr_blk1( mrl(2) ) ), mrl(2)	, ! vavz
     .		memory( 1, mr_blk1( mrl(3) ) ), mrl(3)	, ! v
     .		memory( 1, mr_blk1( mres   ) ), mres	) ! fvn
	GOTO 2000

* UADX - EW advection of U
 240	CALL VEL_ADV_EW (
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! fuw
     .		memory( 1, mr_blk1( mrl(2) ) ), mrl(2)	, ! u
     .		memory( 1, mr_blk1( mres   ) ), mres	) ! uadx
	GOTO 2000

* UADY - NS advection of U
 250	CALL VEL_ADV_NS (
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! fvn
     .		memory( 1, mr_blk1( mrl(2) ) ), mrl(2)	, ! u
     .		memory( 1, mr_blk1( mres   ) ), mres	) ! uady
	GOTO 2000

* UADZ - vertical advection of U
 260	CALL VEL_ADV_Z(
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! u
     .		memory( 1, mr_blk1( mrl(2) ) ), mrl(2)	, ! w
     .		memory( 1, mr_blk1( mres   ) ), mres	) ! uadz
	GOTO 2000

* VADX - EW advection of V
* ... calculation is identical to UADX but with different components
 270	GOTO 240

* VADY - NS advection of V
* ... calculation is identical to UADY but with different components
 280	GOTO 250

* VADZ - vertical advection of V
* ... calculation is identical to UADZ but with different components
 290	GOTO 260

* UDFH - horizontal diffusion of U
 300	CALL VEL_DIF_XY(
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! u
     .		memory( 1, mr_blk1( mrl(2) ) ), mrl(2)	, ! v
     .		memory( 1, mr_blk1( mres   ) ), mres	) ! udfh
	GOTO 2000

* UDFZ - vertical diffusion of U
 310	CALL VEL_DIF_Z(
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! pcdz
     .		memory( 1, mr_blk1( mrl(2) ) ), mrl(2)	, ! u
     .		memory( 1, mr_blk1( mrl(3) ) ), mrl(3)	, ! ubwi
     .		memory( 1, mr_blk1( mres   ) ), mres	) ! udfz
	GOTO 2000

* VDFH - horizontal advection of V
* ... calculation is identical to UDFH but with different components
 320	GOTO 300

* VDFZ - vertical advection of V
* ... calculation is identical to UDFZ but with different components
 330	GOTO 310

* UCOI - implicit calculation of Coriolis effect on U
 340	CALL ERRMSG(ferr_unknown_variable,status,
     .				'UCOI no longer implemented',*5000)
* VCOI - implicit calculation of Coriolis effect on V
 350	CALL ERRMSG(ferr_unknown_variable,status,
     .					'UCOI no longer implemented',*5000)

* UBPI - Grad( Baroclinic pressure ) effect on U
 360	CALL VEL_BY_GRAD_P (
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! dpdx
     .		memory( 1, mr_blk1( mres   ) ), mres	) ! ubpi
	GOTO 2000

* VBPI - Grad( Baroclinic pressure ) effect on V
* ... calculation is identical to UBPI but with different components
 370	GOTO 360

* UBWI - wind stress effect on U
 380	CALL VEL_BY_WIND (
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! taux
     .		memory( 1, mr_blk1( mres   ) ), mres	) ! ubwi
	GOTO 2000

* VBWI - wind stress effect on V
* ... calculation is identical to UBWI but with different components
 390	GOTO 380

* UCOE - explicit calculation of Coriolis effect on U
* ... also computes and stores VCOE ...
 400	cx_variable( cx_xtra ) = pvcoe
	CALL RE_ASSIGN_VARIABLE( mxtra, cx_xtra )
	temp_grid_size = MGRID_SIZE( mrl(1) )	! working space for "AIR"
	CALL GET_MEMORY( temp_grid_size,temp_start_blk,temp_nblks,status )
	IF ( status .NE. ferr_ok ) GOTO 5100
	CALL EXPL_CORIOLIS( 
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! u
     .		memory( 1, mr_blk1( mrl(2) ) ), mrl(2)	, ! v
     .		memory( 1, mr_blk1( mres   ) ), mres	, ! ucoe
     .		memory( 1, mr_blk1( mxtra  ) ), mxtra	) ! vcoe
	CALL FREE_MEMORY( temp_start_blk, temp_nblks )
	GOTO 1900

* VCOE - explicit calculation of Coriolis effect on V
* ... also computes and stores UCOE ...
 410	cx_variable( cx_xtra ) = pucoe
	CALL RE_ASSIGN_VARIABLE( mxtra, cx_xtra )
	temp_grid_size = MGRID_SIZE( mrl(1) )	! working space for "AIR"
	CALL GET_MEMORY( temp_grid_size,temp_start_blk,temp_nblks,status )
	IF ( status .NE. ferr_ok ) GOTO 5100
	CALL EXPL_CORIOLIS( 
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! u
     .		memory( 1, mr_blk1( mrl(2) ) ), mrl(2)	, ! v
     .		memory( 1, mr_blk1( mxtra  ) ), mxtra	, ! ucoe
     .		memory( 1, mr_blk1( mres   ) ), mres	) ! vcoe
	CALL FREE_MEMORY( temp_start_blk, temp_nblks )
	GOTO 1900

* UAD - total advection of zonal velocity
* ... uses identical code to QAD ...
 420	GOTO 90

* VAD - total advection of merional velocity
* ... uses identical code to QAD ...
 430	GOTO 90

* UDF - total diffusion of zonal velocity
* ... uses identical code to QDF ...
 440	GOTO 100

* VDF - total diffusion of merional velocity
* ... uses identical code to QDF ...
 450	GOTO 100

* DUDT - centered time derivative of U
 460	IF ( MR_DIM_LEN(t_dim, mrl(1)).LE.2 ) CALL ERRMSG
     .	( ferr_limits, status, 'insufficient T axis data for '
     .				//VAR_CODE(cat_calc_var,var), *5200 )
	CALL T_DERIV( 
     .	  memory( 1, mr_blk1(mrl(1)) ) , mrl(1),		! u
     .	  memory( 1, mr_blk1( mres   )), mres  ,		! difference
     .    dt, reg )
* ... convert per hour to per month
	CALL MULT_GRID( grid_size, memory(1, mr_blk1(mres)), 730. )
* ... store information about accuracy of calculation
	IF ( reg ) THEN
	   mr_trans_arg( t_dim, mres ) = dt / 2.
	ELSE
	   mr_trans_arg( t_dim, mres ) = bad_val4
	ENDIF
	GOTO 2000	

* DVDT - time derivative of V
* ... uses identical code to DUDT ...
 470	GOTO 460

* DWDT - time derivative of W
* ... uses identical code to DUDT ...
 480	GOTO 460

* DTDT - time derivative of TEMP
* ... uses identical code to DUDT ...
 490	GOTO 460

* UBPS - monthly dU due to surface pressure effects
* ... UBPS = DUDT - ( UDF + UAD + UCOE + UBPI )
* ... we will use a kludge to get around 3D components to a 2D result
 500    mr_lo_ss( mres, z_dim ) = 1	! kludge - make it appear 3D
	mr_hi_ss( mres, z_dim ) = 1	! kludge
	CALL COPY_GRID(
     .	  memory( 1, mr_blk1(mrl(1)) ) , mrl(1) , 		! udf
     .	  memory( 1, mr_blk1( mres   )), mres	  )		! udf
	CALL ADD_2_GRIDS(
     .	  memory( 1, mr_blk1(mrl(2)) ) , mrl(2) , 		! uad
     .	  memory( 1, mr_blk1( mres   )), mres	  )		! udf+uad
	CALL ADD_2_GRIDS(
     .	  memory( 1, mr_blk1(mrl(3)) ) , mrl(3),		! ucoe
     .	  memory( 1, mr_blk1( mres   )), mres 	 )		! udf+uad+ucoe
	CALL ADD_2_GRIDS(
     .	  memory( 1, mr_blk1(mrl(4)) ) , mrl(4),		! ubpi
     .	  memory( 1, mr_blk1( mres   )), mres 	 )		! udf+uad+u...
	CALL SUB_2_GRIDS(
     .	  memory( 1, mr_blk1(mrl(5)) ) , mrl(5),		! dudt 
     .	  memory( 1, mr_blk1( mres   )), mres	,		! udf+uad+u...
     .	  memory( 1, mr_blk1( mres   )), mres	 )		! ubps
	mr_lo_ss( mres, z_dim ) = unspecified_int4	! kludge - back to 2D
	mr_hi_ss( mres, z_dim ) = unspecified_int4	! kludge
* ... store information about accuracy of derivative in calculation
	mr_trans_arg( t_dim, mres ) = 	mr_trans_arg( t_dim, mrl(5) )
	GOTO 2000	

* VBPS - monthly dV due to surface pressure effects
* ... uses identical code to UBPS ...
 510	GOTO 500

* SALI - salinity in parts per thousand
* ... from "SALT" in (PPT-35)/1000
 520	CALL COPY_GRID(
     .	  memory( 1, mr_blk1(mrl(1)) ) , mrl(1),		! salt
     .	  memory( 1, mr_blk1( mres   )), mres  )
	CALL MULT_GRID   ( grid_size, memory(1, mr_blk1( mres )), 1000. )
	CALL ADD_C_2_GRID( grid_size, memory(1, mr_blk1( mres )), 35. )
	GOTO 2000

* DENS - density in gm-cm**3
* ... from "RHO" which is "normalized"
 530	CALL KNUDSEN(
     .	  memory( 1, mr_blk1(mrl(1)) ) , mrl(1),		! temp
     .	  memory( 1, mr_blk1(mrl(2)) ) , mrl(2),		! salt
     .	  memory( 1, mr_blk1( mres   )), mres	 )		! dens

	GOTO 2000

* UBP  - U change caused by baroclinic and barotropic pressure
* ... special routine used to replicate 2D UBPS into 3D result
 540	CALL COPY_2D_TO_3D(
     .	  memory( 1, mr_blk1(mrl(2)) ) , mrl(2),		! ubps
     .	  memory( 1, mr_blk1( mres   )), mres	 )		! ubp
	CALL ADD_2_GRIDS(
     .	  memory( 1, mr_blk1(mrl(1)) ) , mrl(1),		! ubpi
     .	  memory( 1, mr_blk1( mres   )), mres	 )		! ubp
	GOTO 2000

* VBP  - V change caused by baroclinic and barotropic pressure
* ... uses identical code to UBP ...
 550	GOTO 540

* CMSK - convective adjustment mask
 560	CALL CONV_ADJ_MASK (
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! temp
     .		memory( 1, mr_blk1( mrl(2) ) ), mrl(2)	, ! salt
     .		memory( 1, mr_blk1( mres   ) ), mres	) ! w_u
	GOTO 2000

* W_T - vertical velocity computed on the ts grid (still on w grid vertically)
 570	CALL W_ON_TS (
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! u
     .		memory( 1, mr_blk1( mrl(2) ) ), mrl(2)	, ! v
     .		memory( 1, mr_blk1( mres   ) ), mres	) ! w_u
	GOTO 2000

* CAIR - climatological air temperature regridded from monthly data
 580	CALL COPY_GRID(
     .	  memory( 1, mr_blk1(mrl(1)) ) , mrl(1),	! regridded airt
     .	  memory( 1, mr_blk1( mres   )), mres	)	! cair
	GOTO 2000

* AIR - air temperature taylored to data set
 590	CALL AIR_TEMP( 
     .		memory( 1, mr_blk1( mrl(1) ) ), mrl(1)	, ! sst
     .		memory( 1, mr_blk1( mrl(2) ) ), mrl(2)	, ! cair
     .		memory( 1, mr_blk1( mres   ) ), mres	) ! air
	GOTO 2000

* ----------------------------------------------------------------------
* 2 results were computed.  Catalog the extra one
 1900	mr_protected( mxtra ) = mr_not_protected
	CALL MR_NOT_IN_USE( mxtra )
	cx_stack_ptr = cx_stack_ptr - 1

* free cx_lrg and cx_xtra space
 2000	cx_stack_ptr = cx_stack_ptr - 1

* flag that the components are no longer in use
	DO 2010 icomp = 1, ncomp
 2010	CALL MR_NOT_IN_USE( mrl(icomp) )

* success
	RETURN

* error exit
 5000	RETURN 
 5100	CALL DELETE_VARIABLE( mxtra )
 5200	CALL DELETE_VARIABLE( mres )
	RETURN
	END

	SUBROUTINE COPY_GRID ( src, msrc, dst, mdst )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* copy data from one grid to another (using limits of destination grid)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 1/23/87
* V200:  5/19/89 - 4D symmetrical
*	10/11/89 - use COPY_GRID_SUB - avoid adjustable dimensioning with array
* V530:  8/00 *sh* - handle C string arrays, too
* V530:  8/00 *sh* - if input grid uses strides then copy based upon output
*	             grid limits -- the axes MUST BE the same length
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include	'xvariables.cmn'

* calling argument declarations:
	INTEGER msrc, mdst
	REAL    src( * ), dst( * )

* internal variable declarations
	INTEGER	MGRID_SIZE
	INTEGER idim, lo_ss(nferdims), hi_ss(nferdims)

* set-up modified source limits wherever delta is significant
* cuz the FORTRAN dimensioned size can only have delta of 1 
	DO idim = 1, nferdims
	  IF (mr_delta(idim,msrc) .NE. unspecified_val8) THEN
	    lo_ss(idim) = mr_lo_ss(mdst,idim)
	    hi_ss(idim) = mr_hi_ss(mdst,idim)
	  ELSE
	    lo_ss(idim) = mr_lo_ss(msrc,idim)
	    hi_ss(idim) = mr_hi_ss(msrc,idim)
	  ENDIF
	ENDDO

	IF ( mr_type(msrc) .EQ. ptype_string ) THEN

* set up the C pointer variable in the destination variable
	   CALL INIT_C_STRING_ARRAY( MGRID_SIZE(mdst),
     .				     dst,
     .				     mr_c_pointer(mdst)      )

* copy the strings
	   CALL COPY_PTR_GRID_SUB(
     .			  src, lo_ss(1), hi_ss(1),
     .			       lo_ss(2), hi_ss(2),
     .			       lo_ss(3), hi_ss(3),
     .			       lo_ss(4), hi_ss(4),
     .			       lo_ss(5), hi_ss(5),
     .			       lo_ss(6), hi_ss(6),
     .			  dst, mr_lo_s1(mdst), mr_hi_s1(mdst),
     .			       mr_lo_s2(mdst), mr_hi_s2(mdst),
     .			       mr_lo_s3(mdst), mr_hi_s3(mdst),
     .			       mr_lo_s4(mdst), mr_hi_s4(mdst),
     .			       mr_lo_s5(mdst), mr_hi_s5(mdst),
     .			       mr_lo_s6(mdst), mr_hi_s6(mdst) )

	ELSE

	   CALL COPY_GRID_SUB(
     .			  src, lo_ss(1), hi_ss(1),
     .			       lo_ss(2), hi_ss(2),
     .			       lo_ss(3), hi_ss(3),
     .			       lo_ss(4), hi_ss(4),
     .			       lo_ss(5), hi_ss(5),
     .			       lo_ss(6), hi_ss(6),
     .			       mr_bad_data( msrc ),
     .			  dst, mr_lo_s1(mdst), mr_hi_s1(mdst),
     .			       mr_lo_s2(mdst), mr_hi_s2(mdst),
     .			       mr_lo_s3(mdst), mr_hi_s3(mdst),
     .			       mr_lo_s4(mdst), mr_hi_s4(mdst),
     .			       mr_lo_s5(mdst), mr_hi_s5(mdst),
     .			       mr_lo_s6(mdst), mr_hi_s6(mdst),
     .			       mr_bad_data( mdst )			)

	ENDIF

 5000	RETURN
	END 

	SUBROUTINE TM_WW_AXLIMS (axis, lo, hi)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Return the lowest and highest points along the span of an axis
* For a regular axis this will be 1/2 delta below/above the 1st/Nth coordinates
* Modulo is ignored in this calculation

* V541 *sh* 2/02

	include 'tmap_dims.parm'
#include "gt_lib.parm"
	include	'xtm_grid.cmn_text'

* calling argument declarations
	INTEGER axis
	REAL*8 lo, hi

* internal variable declarations
	INTEGER	isub1, llen

	IF ( axis .LT. 0 .OR. axis .GT. line_ceiling ) THEN
	  lo = unspecified_val8
	  hi = unspecified_val8
	ELSEIF ( line_regular(axis) ) THEN
	  lo = line_start(axis) - 0.5D0*line_delta(axis)
	  hi = lo + line_dim(axis)*line_delta(axis)
	ELSE
	  isub1 = line_subsc1(axis)
	  llen = line_dim(axis)
	  hi = line_mem(isub1 + 2*llen)
	  lo = line_mem(isub1 +   llen)
	ENDIF

	RETURN
	END

      SUBROUTINE BOX 
C** 
C**    @(#)box.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*     11.6.92 *jd* Mod to use viewport sizes when in FERRET

#ifdef unix
        include 'parampl5_dat.decl'
	INCLUDE 'PARAMPL5.DAT'
        include 'plt_inc.decl'
	INCLUDE 'PLT.INC'
        include 'pen_inc.decl'
	INCLUDE 'PEN.INC'
#else
        INCLUDE 'TMAP_PPLV11INC:PARAMPL5_DAT.DECL'
	INCLUDE 'PPLV11INC:PARAMPL5.DAT'
        INCLUDE 'TMAP_PPLV11INC:PLT_INC.DECL'
	INCLUDE 'PPLV11INC:PLT.INC'
        INCLUDE 'TMAP_PPLV11INC:PEN_INC.DECL'
	INCLUDE 'PPLV11INC:PEN.INC'
#endif

#ifdef unix
        include 'ppl_in_ferret.cmn'
#else
        INCLUDE 'TMAP_PPLV11INC:PPL_IN_FERRET.CMN'
#endif

	logical  is_viewport
        real     vwidth,vheight,width2,height2

C 	stmt added for linux *jd* 12.96
	external scale

*******************************************************************************

        if (ppl_in_ferret) then
           call get_view_size (vwidth,vheight,is_viewport)
           width2 = vwidth
           height2 = vheight
        else
           width2 = width
           height2 = height
        endif

	CALL SCALE(1.,1.,0.,0.,0.,0.) 
	IF(IP(1).NE.1)RETURN
	CALL PLOT(.01,.01,0,0) 
	CALL PLOT(WIDTH2-.02,.01,1,0) 
	CALL PLOT(WIDTH2-.02,HEIGHT2-.04,1,0) 
	CALL PLOT(.01,HEIGHT2-.04,1,0) 
	CALL PLOT(.01,.01,1,0) 
	RETURN 
	END 

	SUBROUTINE KEY_SET_UP (string_labs, skip_key, max_len, 
     .     lab_digits, check_0, lab_add, num_dec, lev1, levn, incr)


	include 	'parampl5_dat.decl'
	include 	'PARAMPL5.DAT'
	include		'cont_inc.decl'
	include		'CONT.INC'
        include 	'pltcom_dat.decl'
        include 	'PLTCOM.DAT'
        include 	'pltl_inc.decl'
        include 	'PLTL.INC'

        include         'axis_inc.decl'
        include         'AXIS.INC'
        include         'plt_inc.decl'
        include         'PLT.INC'
        include         'pen_inc.decl'
        include         'PEN.INC'

        include         'shade_vars.cmn'
        include         'gkscm1_inc.decl'
        include         'GKSCM1.INC'
        include         'gkscm2.cmn'

	include        'gkspar.inc'

* arguments
	LOGICAL string_labs, skip_key, check_0
	INTEGER max_len, lab_digits, num_dec, lev1, levn, incr

	LOGICAL TM_FPEQ_SNGL, TM_HAS_STRING, 
     .		have_neg, increase_digits
	INTEGER TM_LENSTR1, lev_digits, str_len, have_exp
	REAL	del, val
        REAL*8	val_n, val_last
	CHARACTER*48 TM_FMT_SNGL, buff, text

* Get max length for key labels. 

* initialize
        del = 1
        check_0 = .TRUE.

        lev1 = 1
        levn = nlev2
	incr = 1
        lab_add = 0
        num_dec = 0
        max_len = 0

	skip_key = (levn .EQ. 1 .AND. zlev(1) .GE. 1.e33)
	IF (skip_key) GOTO 5000

* max_len used for horizontal axis computations

	IF (string_labs) THEN
           max_len = 0
	   DO ndx = lev1, shd_levels
	      buff = colorkey_labs(lev1)
	      max_len = MAX (max_len, TM_LENSTR1(buff))   
	   ENDDO
	   
	   GOTO 5000
	ENDIF

* Decide whether to check for small numeric values in the key labels.
* If delta is large, we dont want 0.000005 to be labelled in an exponential
* format (it is zero with a bit of noise). But if all the numbers are 
* small, label them as is. 

	IF (levn.EQ.1) ZLEV(2) = zlev(1)
        IF (neginf) lev1 = 2
        IF (posinf) levn = nlev2 - 1
        IF (neginf.AND.posinf .AND.shd_levels.EQ.1) levn = nlev2

        IF (shd_levels .GT. 1) del = zlev(lev1+1) - zlev(lev1)
        IF (TM_FPEQ_SNGL(del,0.)) check_0 = .FALSE.
        
* See if klab_dig is enough digits to distinguish the levels. 

        lab_digits = klab_dig
        increase_digits = .TRUE.

	if (klab_incr .eq. 0) then
	   incr = (shd_levels/25) + 1
	else
	   incr = klab_incr
	end if

	kount = 0
        DO WHILE (increase_digits .AND. ABS(lab_digits) .LE. klab_len .AND.kount.LT.10)
           buff = ' '
           val = zlev(lev1)
	   IF (center_key_labels) val = zlevsave(lev1)
           IF (TM_FPEQ_SNGL(val,0.) .AND. check_0) val = 0.
 	   text = TM_FMT_SNGL(val,lab_digits,klab_len+5,str_len)

           increase_digits = .FALSE.

 	   have_exp = 0
 	   IF (INDEX(buff, 'E') .GT.0) have_exp = 1
 	   nl = 1

           num_dec = 0
	   have_neg = .FALSE.
           max_len = 0

	   DO 30 ndx = lev1+incr, shd_levels, incr
             val = zlev(ndx)
             IF (center_key_labels) THEN
	        IF (ndx.GE.shd_levels) EXIT ! from loop
		val = zlevsave(ndx)
             ENDIF

	     IF (TM_FPEQ_SNGL(val,0.) .AND. check_0) val = 0.
	     buff = TM_FMT_SNGL (val,lab_digits,klab_len+5,str_len)

	     increase_digits = (buff .EQ. text)   ! Are labels different, one to the next?
             text = buff

             val_last = val_n
             IF (max_len .lt. str_len) max_len = str_len

	     i = INDEX(buff, '.')
             IF (i .GT. 0) num_dec = MAX(num_dec, str_len-i)
	     have_neg = have_neg .OR. val.LT.0 
	     
             nl = nl + 1
             IF (INDEX(buff, 'E') .GT.0) have_exp = have_exp + 1

   30      CONTINUE

           IF (increase_digits) THEN
              IF (lab_digits .GT. 0) lab_digits = lab_digits + 1
              IF (lab_digits .LT. 0) lab_digits = lab_digits - 1
              lab_add = lab_add + 1
           ENDIF

* If some labels are formatted as exponentials and some not, try
* using fewer digits for all exponential.
           IF (have_exp .GT. 0 .AND. .NOT.increase_digits) lab_digits = lab_digits - 1

           kount = kount + 1
        ENDDO

 5000	RETURN
	END

	subroutine opndev(termf,clear)
C**
C**    @(#)opndev.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* revised for TMAP
* from PPLUS :
*       Directory PMEL:[PLOT5.PPLV11.COMPLOT]OPNDEV.F -->.FOR via "PREPRS"
* search for "TMAP" to find all revisions
* *sh* 8/26/88 - rev 1.0 - for FERRET 1.10+
* *sh* 1/20/89 - rev 1.1 - for FERRET 1.10+ from V11 of PPLUS
*       - only delete segments currently in use to permit multiple viewports
* *jd* 3.20.89 Modified for GKS metafiles to write private GCLRWK to metafile
*	as metafile system doesn't write it for some unknown reason.
* *jd* 7.12.90 Mod to not call CHOUT if dimension arg eq 0
* *jd* 10.26.93 Mod to eliminate private GCLRWK for xgks
* *jd* 12.96 Numerous comments including control characters of various
* 	nature (eg ^) eliminated.  They confuse the linux F90 compiler


*****************************************************

C
C	CALL OPNDEV(TERMF,CLEAR)
C
C	THIS SUBROUTINE IS USED TO OPEN A DEVICE FOR THE FIRST TIME
C	AND TO OPEN THE DEVICE FOR ADDITIONAL INPUT.
C
C	TERMF  -- FOR INTERACTIVE / COMMAND SWITCH
C		 IF TRUE THE COMMANDS ARE COMING FROM THE TERMINAL
C	CLEAR -- LOGICAL IF TRUE CLEAR THE DEVICE  (I.E. START NEW)
C
C
* TMAP mod 8/26/88
!	include 'PLTCOM.DAT'
!	include 'GKSCM1.INC'
#ifdef unix
	include 'pltcom_dat.decl'
	include 'PLTCOM.DAT'
	include 'gkscm1_inc.decl'
	include 'GKSCM1.INC'
	include 'gkscm2.cmn' !jd 3.20.89 for private gclrwk
#else
	INCLUDE 'TMAP_PPLV11INC:PLTCOM_DAT.DECL'
	INCLUDE 'PPLV11INC:PLTCOM.DAT'
	INCLUDE 'TMAP_PPLV11INC:GKSCM1_INC.DECL'
	INCLUDE 'PPLV11INC:GKSCM1.INC'
	INCLUDE 'tmap_pplv11inc:tmap_gkscm2.inc' !JD 3.20.89 for private GCLRWK
#endif

	INTEGER	iseg, ivp, lens, itype, i, j, nterm, ndelay ! local declarations
	integer	control_flag ! For private GCLRWK

* special COMMON to let this routine know if FERRET is in control

#ifdef unix
	include 'ppl_in_ferret.cmn'
#else
	INCLUDE 'TMAP_PPLV11INC:PPL_IN_FERRET.CMN'
#endif

* end of TMAP mods 8/26/88 & 1/20/89
C
C	THIS IS A VAX/VMS SUBROUTINE AT THIS TIME
C
	LOGICAL CLEAR,TERMF
	LOGICAL FRST,TRMOPN
#ifndef unix
	integer*4 lib$get_symbol,len,stat
	byte FIRSTB(20,12),SECNDB(20,12),FIRST(20),SECND(20)
	byte ER4010(2),ER41XX(8)
#else
        INTEGER FIRSTB(20,12),SECNDB(20,12),FIRST(20),SECND(20)
        INTEGER ER4010(2),ER41XX(8)
#endif
	CHARACTER TERM(12)*10,TYPE*10
	INTEGER ITERM(12),FIRSTL(12),SECNDL(12)
	LOGICAL SEGMNL(12),SEGMN,FCLOSL(12),FCLOS
C
C
	DATA ER4010/27,12/,ER41XX/27,83,75,33,27,83,69,49/
	DATA TERM/'VT240','GVT+','ZENITH','TEK4010','TEK41XX','MAC',
     *		  'TAB','TEK4105','TEK4014','HIREZ','HP2397','GP220'/
	DATA ITERM/1,2,3,4,5,4,6,7,4,8,9,10/,FRST/.TRUE./,NTERM/12/
C
C
C
	DATA FIRSTB/27,91,63,51,56,104,14*0,
     *		    28,19*0,
     *		    27,91,50,74,16*0,
     *		    20*0,
     *		    27,37,33,48,27,76,86,48,27,83,86,33,49,7*0,
     *		    29,19*0,
     *		    27,37,33,48,27,76,86,48,12*0,
     *		    27,91,50,74,27,49,14*0,
     *		    27,42,100,102,27,42,100,99,27,91,51,56,104,7*0,
     *		    29,19*0,
     *		    20*0,
     *              20*0/
	DATA SECNDB/27,91,63,51,56,108,14*0,
     *		    24,19*0,
     *		    27,58,56,102,16*0,
     *		    20*0,
     *		    27,83,78,27,83,86,33,48,27,76,86,49,27,37,33,49,4*0,
     *		    27,34,48,103,16*0,
     *		    27,76,86,49,27,37,33,49,12*0,
     *		    27,50,18*0,
     *      27,91,51,56,108,27,42,100,100,27,42,100,101,7*0,
     *		    2,19*0,
     *		    20*0,
     *              20*0/
C
C	DEVICE HAS SEGMNMENTS IF TRUE  (I.E. 4115, 4107)
C
	DATA SEGMNL/ .FALSE.,
     *		   .FALSE.,
     *		   .FALSE.,
     *		   .FALSE.,
     *		    .TRUE.,
     *		   .FALSE.,
     *		   .FALSE.,
     *		   .FALSE.,
     *		   .FALSE.,
     *		   .FALSE.,
     *		 2*.FALSE./
C
C	DEVICE MUST BE ERASED TO GO BACK TO COMMAND
C
	DATA FCLOSL/ .TRUE.,
     *		    .FALSE.,
     *		     .TRUE.,
     *		     .TRUE.,
     *		    .FALSE.,
     *		     .TRUE.,
     *		    .FALSE.,
     *		     .TRUE.,
     *		    .FALSE.,
     *		    .FALSE.,
     *		  2*.FALSE./
	DATA FIRSTL/6,1,4,0,13,1,8,6,13,1,2*0/
	DATA SECNDL/6,1,4,0,16,4,8,2,13,1,2*0/
C
C	SET UP FOR SPECIFIC TERMINAL TYPE
C
	IF(FRST)THEN
#ifdef unix
            call getenv('GRAPHTERM',TYPE)
            LENS=lnblk(type,10)
            IF(lens.le.0)then
#else
	    stat=lib$get_symbol('GRAPHTERM',type,len)
	    lens=len
	    if(.not.stat)then
#endif
		ITYPE=1
	    ELSE
		DO 14 I=1,NTERM
		IF(TYPE(1:LENS).EQ.TERM(I))GOTO 11
14		CONTINUE
		I=1
11		ITYPE=ITERM(I)
	    ENDIF
	    DO 12 I=1,20
12	    FIRST(I)=FIRSTB(I,ITYPE)
	    DO 13 I=1,20
13	    SECND(I)=SECNDB(I,ITYPE)
	    FRST=.FALSE.
	    SEGMN=SEGMNL(ITYPE)
	    FCLOS=FCLOSL(ITYPE)
	ENDIF
C
C
	PMODE = ALPHA
	IF(SAVEF)CALL XYZPLT
C
C	CHECK FOR PLOT-TYPE
C
	IF(PTYPE.EQ.1.OR.PTYPE.EQ.2)THEN
C
C	DEVICE IS A TEK TERMINAL COMPATIBLE
C
	    IF(.NOT.TRMOPN)THEN
C
C	OPEN DEVICE FOR GRAPHICS AND ERASE THE SCREEN
C
		if (firstl(itype) .gt. 0) CALL CHOUT(FIRST,FIRSTL(ITYPE))
		TRMOPN=.TRUE.
	    ENDIF
	    IF(CLEAR)THEN
		IF(SEGMN)THEN
		    CALL CHOUT(ER41XX,8)
		ELSE
	            CALL CHOUT(ER4010,2)
C
C	TRANSMIT SYNC CHARACTERS FOR PHOSPHORE COOL DOWN.
C
c		    NDELAY=IFIX(0.7*FLOAT(BAUDR/10))
c		    DO 30 J=1,NDELAY
c30		    CALL CHOUT(SYN,1)
		ENDIF
	    ENDIF
	    CALL CHDMP
	ELSE IF(PTYPE.EQ.3.OR.PTYPE.EQ.4)THEN
C
C	DEVICE IS A GKS DEVICE
C
	    CALL PPLGFLUSH
#ifdef core
            if(.not.gksopn)then
                call crinit
                gksopn=.true.
            endif
c
            if(clear)then
                call delallretainsegs()
                call newframe()
                call createretainseg(1)
            endif
#else
* TMAP mod 8/26/88, PPL_in_FERRET added 1/20/89
	    IF(CLEAR) THEN
	       IF ( PPL_in_FERRET ) THEN
	         CALL CLEAR_VP
	       ELSE
!	         CALL GCLRWK(WSID,0)				! original
		 control_flag = 0				! Mod JD
	         CALL GCLRWK(WSID,control_flag)			! Mod JD
#ifdef xgks
* leave out	 if (meta_actv) CALL GCLRWK(meta_wsid,control_flag) ! Mod JD
#else
		 if (meta_actv) call meta_clear (control_flag)	! Mod JD
#endif
	       ENDIF
	    ENDIF
* end of TMAP mods 8/26/88
#endif
	ENDIF
	IF(PTYPE.EQ.0.OR.PTYPE.EQ.2.OR.PTYPE.EQ.4)THEN
C
C	THE OUTPUT IS A BINARY FILE
C
	    IF(PLTFLG)THEN
C
C	MOVE TO A NEW PLOTTING AREA
C
		PEN = .FALSE.
		CALL ZABMV
		IF(CLEAR)THEN
		    CALL BINFSH
		    PLTFLG = .FALSE.
		ENDIF
	    ENDIF
	ENDIF
	LPEN = .FALSE.
C
C     INITIALIZE THE DATA VARIABLES FOR THE NEXT PLOT.
C
	A = 0.0
	B = 0.0
	AOLD = 0.0
	BOLD = 0.0
	COLD = 0.0
C
	IF(TTYPE.GT.0)THEN
	    IF(ASIZE / TWIDTH .GT. BSIZE / THIGHT)THEN
		PLTOTA = TSCLA /ASIZE
		PLTOTB =TSCLB /ASIZE * TWIDTH /THIGHT
	    ELSE
		PLTOTA = TSCLA / BSIZE * THIGHT / TWIDTH
		PLTOTB = TSCLB / BSIZE
	    ENDIF
	ELSE
	    PLTOTA=TSCLA/(TWIDTH*FACTOR)
	    PLTOTB=TSCLB/(THIGHT*FACTOR)
	ENDIF
C
C     RECOMPUTE THE HP PLOTTER CONVERSION FACTORS.
C
C
C     RESTORE THE DEFAULT MINIMUM AND MAXIMUM ALLOWABLE VALUES OF
C     A AND B.
C
	AMIN = 0.0
	BMIN = 0.0
	AMAX = ASIZE
	BMAX = BSIZE
C
C     CALCULATE THE OFF-SCREEN FLAG.
C
	LOSFLG = 0
	IF(AOLD - 0.001 .GT. AMAX)LOSFLG = 1
	IF(AOLD + 0.001 .LT. AMIN)LOSFLG = 2
	IF(BOLD - 0.001 .GT. BMAX)LOSFLG = LOSFLG + 4
	IF(BOLD + 0.001 .LT. BMIN)LOSFLG = LOSFLG + 8
C
C     TRANSFORM THE ABSOLUTE ORIGIN TO THE USER'S COORDINATE SYS-
C     TEM.
C
	CALL TFORMI(XOLD,YOLD,ZOLD)
	IF(WINDOF)THEN
C
C     CALCULATE THE OFF-WINDOW FLAG.
C
	    LOWFLG = 0
	    IF(XOLD .GT. XMAX)LOWFLG = 1
	    IF(XOLD .LT. XMIN)LOWFLG = 2
	    IF(YOLD .GT. YMAX)LOWFLG = LOWFLG + 4
	    IF(YOLD .LT. YMIN)LOWFLG = LOWFLG + 8
	ENDIF
	RETURN
C
	ENTRY CLSDEV(TERMF,CLEAR)
C
C	THIS ROUTINE CLOSES THE DEVICE DEPENDING ON THE SITUATION
C
	IF(PTYPE.EQ.1.OR.PTYPE.EQ.2)THEN
C
C	DEVICE IS TEK TERMINAL COMPATIBLE
C
	    IF(FCLOS.OR.CLEAR)THEN
C
C	DEVICE REQUIRES THE TERMINAL CLEARED
C
		CALL CHOUT(ER4010,2)
c		NDELAY=IFIX(0.7*FLOAT(BAUDR/10))
c		DO 40 J=1,NDELAY
c40		CALL CHOUT(SYN,1)
	    ENDIF
C
C	GO TO COMMAND SCREEN
C
	    if (secndl (itype) .gt. 0) CALL CHOUT(SECND,SECNDL(ITYPE))
	    TRMOPN=.FALSE.
	    CALL CHDMP
	ELSE IF(PTYPE.EQ.3.OR.PTYPE.EQ.4)THEN
C
C	DEVICE IS GKS
C
	    CALL PPLGFLUSH
	ELSE IF((PTYPE.EQ.0.OR.PTYPE.EQ.2.OR.PTYPE.EQ.4)
     *		.AND.CLEAR)THEN
	    IF(PLTFLG)THEN
		PEN=.FALSE.
		CALL ZABMV
		CALL BINFSH
		PLTFLG=.FALSE.
	    ENDIF
	ENDIF
	RETURN
C
	END

	SUBROUTINE INIT_DEPENDENCIES
     .		( dflt_cx, yes_apply_cx, base_isp, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* this routine is derived from EVAL_EXPR -- but has only the initialization
* part from it, so that other parts of the code may be called multiple times
* for multiple expressions
* see that routine for a discussion of how it is implemented
* instead of evaluating the expression, it determines the dependencies in it

* base_isp, base_cx allow the calling program to set base levels for work on
* the stack, allowing pre-existing stack contents to be protected

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V685+ 9/13 *sh*  
* V702 1/17 *sh* for trac enhancement #2369 -- dynamic memory management 

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xdependency_tree.cmn'

* calling argument declarations
        LOGICAL yes_apply_cx
	INTEGER	dflt_cx, base_isp, status

* local variable declarations
	INTEGER		mr, num_indices, j, uv, total_items
	INTEGER*8	i8_size

* initialize grid stack pointer (pushes down from top)
	dependency_tree_mode = .TRUE.

* delete any memory left-overs from last command
	CALL DELETE_MRS_IN_PROGRESS

* * * * DETERMINE CONTEXT FOR COMMAND * * *
	CALL GET_NEW_CX( dflt_cx, cx_cmnd, yes_apply_cx, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* allocate temporary work space for recording the dependency tree in memory
	total_items = 0
	CALL deleted_list_get_undel(uvar_num_items_head, 
     .                          deleted_list_result(1),
     .                          max_uvar, num_indices )
	DO 100 j = 1, num_indices
	   uv = deleted_list_result(j)
	   total_items = total_items + uvar_num_items( uv )
 100	CONTINUE
* grossly crude heuristic to set an upper bound for the size of the completed
* structure representing the tree -- the number of elements in
* total when adding together all pyramids that can be built from a variable
* colection
* Approx half of elements are operators so divide by 2
* Upper bound size is that each operand depends on all other operands ==> n^2
* Crudely say we'd never in reality get to more than 1/4 of this
* Each record saved contains NFIELDS fields, so multiply by NFIELDS
* so ...   (500 items would will yield 93,750 words)
	dependency_max_recs = total_items/2
	dependency_max_recs = (dependency_max_recs*dependency_max_recs)/4
	dependency_max_recs = MAX(dependency_max_recs, 1000)
	i8_size = dependency_max_recs*dependency_nfields
	CALL GET_DYN_WORK_SPACE( i8_size, status )
	IF (status .NE. ferr_ok) GOTO 5000

* initialize dependency COMMON
	dependency_nrows      = 0
	dependency_root_level = base_isp
!	dependency_block1     = wkblk    ! 1/17 pre-dynamic memory
	dependency_status     = df_valid_var
	IF (cx_data_set(cx_cmnd) .EQ. unspecified_int4) THEN
	   dependency_dflt_dset  = pdset_irrelevant
	ELSE
	   dependency_dflt_dset  = cx_data_set(cx_cmnd)
	ENDIF
	RETURN

* error exit
 5000	CALL EXIT_DEPENDENCY_MODE
     	RETURN
	END

	SUBROUTINE AUX_REGRID_LIMS_1D_T( dst_cx, src_cx, axis_list, naxis,
     .			                 aux1, mr1, cx1, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* This routine handles the special case of forecast model  aggregations
* It determines the range of souce data on the T axis that is needed to
* regrid (reorganize) the 2D time array into a 1D time
* (orthogonal F and T axes) form

* In generic terms, the descript of the routine is this:
* Given a context describing data to be regridded to a destination grid
* create the description of the needed source data in the source context
* Use the auxiliary variables to determine the index range of data needed

* The 2D time field is the auxiliary regrid control variable. It contains
* times that are partially duplicated from one forecat index to the next
* The orthoganalization process removes the duplication by shifting the start
* time index of each successive forcast, so that all forecasts lie on the
* same-single time axis

* When called the source context should be a copy of the destination context 

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

*v695+ 3/15 *sh* patterned after AUX_REGRID_LIMS_1D_Z

	IMPLICIT NONE

	include 'tmap_dims.parm'
	include 'implicit.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xtm_grid.cmn_text'    ! to sanity check T axis


* calling argument declarations:
	INTEGER	src_cx, axis, dst_cx, naxis, axis_list(naxis), status,
     .		mr1, cx1, mr2, cx2, mr3, cx3
        REAL*8  aux1(m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif )

* internal variable declarations:
	INTEGER	KNOWN_GRID, CGRID_AXIS,
     .		idim, src_grid, i, j, k, l, m, n, trans,
     .		ndim, dim(nferdims), t_axis,
     .		ldstmin, ldstmax, llmin, llmax, llo, lhi, ldel,
     .		nlo, nhi, nmin, nmax, looking_for_first
	REAL*8  TM_WORLD, axmax, axmin, bad_aux, t, t1, delta,
     .		tdstrt, tdend, tstepmin, tstepmax

* initialize
	bad_aux = mr_bad_data( mr1 )
!	idim     = axis_list(1)
	llo      = cx_lo_s4(cx1)   ! 2d time array limit - should always be 1
	lhi      = cx_hi_s4(cx1)   ! should always be N
	nlo      = cx_lo_s6(cx1)   ! lowest forecast index - specified by user
	nhi      = cx_hi_s6(cx1)   ! highest forecast index - specified by user
	i        = cx_lo_s1(cx1)   ! fixed index since aux field is 2d
	j        = cx_lo_s2(cx1)
	k        = cx_lo_s3(cx1)
	m        = cx_lo_s5(cx1)
	tstepmin = aux1(i,j,k,llo,m,nlo) ! low-left corner of 2d time array
	tstepmax = aux1(i,j,k,lhi,m,nhi) ! upper right
	tdstrt   = TM_WORLD(cx_lo_s4(dst_cx), cx_grid(dst_cx),
     .			  t_dim, box_middle) ! 'd' for destination start time
	tdend    = TM_WORLD(cx_hi_s4(dst_cx), cx_grid(dst_cx),
     .			  t_dim, box_middle)
	llmin  = llo	! initial default
	llmax  = lhi
	nmin   = nlo
	nmax   = nhi 		

* insert source grid (the defining grid for this variable)
* XXXX TEMPORARY -- ?move this block of code to AUX_VAR_REGRID when 2D curv is added?
	src_grid = KNOWN_GRID( cx_data_set(src_cx),
     .			       cx_category(src_cx),
     .			       cx_variable(src_cx)  )
	cx_grid( src_cx ) = src_grid
	cx_unstand_grid( src_cx ) = .FALSE.
	is_phase( isp )   = prgrd_from_source
	cx_naux( src_cx ) = 0
        DO 100 idim = 1, nferdims
           cx_aux_var  (idim, src_cx) = unspecified_int4
           cx_aux_cat  (idim, src_cx) = unspecified_int4
           cx_aux_stat (idim, src_cx) = paux_stat_na
 100    CONTINUE

* to support monthly times, the target axis may be irregular
!* sanity check the target T axis
!	t_axis = CGRID_AXIS(t_dim,dst_cx)
!	IF (.NOT. line_regular(t_axis)) GOTO 5050
!	IF (lhi .GT. llo) THEN
!	   IF ( line_delta(t_axis)
!     .	   .NE.(aux1(i,j,k,llo+1,m,nlo)-aux1(i,j,k,llo,m,nlo))) GOTO 5060
!	ENDIF

* ideally we should check that the units of the 2D time field are the same as the units of the
* 1D time axis, but since typically Ferret code is creating the 1d time, we'll allow laziness

* this routine only for t_dim -- index-based remapping of time locations
	trans = cx_regrid_trans(t_dim,src_cx)
	IF (trans .NE. pauxrgrd_fmrc) 
     .	  CALL ERRMSG( ferr_internal, status, 'unkwn rgrd trans', *5000)

* make sure that the auxiliary variable is monotonic spaced
*	The 2D time array can never theoretically be non-monotonic
*       but FT aggregations are new and unreliable
	DO n = nlo, nhi
	   looking_for_first = 0
           DO l = llo, lhi
	      t = aux1(i,j,k,l,m,n)
	      IF (t .EQ. bad_aux) THEN
	         GOTO 5150
	      ELSEIF (looking_for_first.EQ.0) THEN
	         t1 = t
	         looking_for_first = 1
	      ELSE
	         IF (looking_for_first.EQ.1) THEN
!	            delta = t-t1
!	            IF (delta .LT. 0.0) GOTO 5100
	            IF (t .LE. t1) GOTO 5100
	            looking_for_first = 2
                 ENDIF
!	         IF (delta .NE. (t-t1)) GOTO 5100
	         t1 = t
	      ENDIF
	   ENDDO
	ENDDO

* the relationship between the time steps in the 2D aux time field (cx1)
* and the same times in the destination field looks something
* like this over 3 forecast cycles

*   **     2d aux times    **	      ** orthoganalized T-F field **
*								115
*                       		               1013	114
*                       		        1012   1012	113
*                       		        1011   1011	112
*                       		       >1010   1010	111
*                       		        1009   1009	110
*   18     1008   1012   1016		 1008   1008   1008	109
*   17     1007   1011   1015		 1007   1007		108
*   16     1006  >1010   1014		 1006   1006		107
*   15     1005   1009   1013		 1005  >1005		106
*   14     1004   1008   1012		 1004   1004		105
*   13     1003   1007   1011		 1003			104
*   12     1002   1006   1010		 1002			103
*   11     1001  >1005   1009		 1001			102
*   10     1000   1004   1008		 1000			101
*    |								  |
* l in src_cx						    l in dst_cx 

* say that the requested time range is T=1005:1010
* The lowest L index of source data needed is the index at which the START time
*    is first encountered as we loop down the forecasts searching lo to hi
* The highest L index of source data needed is the index at which the END  time
*    is first encountered as we loop up   the forecasts searching hi to lo


* This commented out block of code increases efficiency by requesting only
* only the F-range that contains data relevant to the requested T-range.
* However, doing so causes the regrid operation to alter the N range.
* Since this is a 1D T regrid operation, "var[GT(time2d)=t1d]", it is not
* appropriate to alter the F range.  The efficiency loss effects only a minor
* situation in which for whatever reason the user has requested N-indices of
* pure missing data.
!* bail out if the requested min exceeds the available range or similar max
!	IF (tdstrt .GT. tstepmax
!     .  .OR. tdend .LT. tstepmin ) THEN
!* ... no regridding is possible - result will be a field of missing data
!* ... provide a nominal data region that is not trouble to get
!	   llmax = llmin  ! request a single point region only of source data
!	   nmax  = nmin
!	   GOTO 500
!	ENDIF
!
!* determine the minimal forecast index range (i.e. with relevant timesteps)
!	DO n = nlo, nhi
!	   t  = aux1(i,j,k,llo,m,n)
!	   t1 = aux1(i,j,k,lhi,m,n)
!	   IF (t1 .GE. tdstrt
!     .   .AND. t  .LE. tdend  ) THEN
!* ... found first forecast with relevant time steps
!	      nmin = n
!	      EXIT
!	   ENDIF
!	ENDDO
!	DO n = nhi, nlo, -1
!	   t  = aux1(i,j,k,llo,m,n)
!	   t1 = aux1(i,j,k,lhi,m,n)
!	   IF (t1 .GE. tdstrt
!     .   .AND. t  .LE. tdend  ) THEN
!* ... found last forecast with relevant time steps
!	      nmax = n
!	      EXIT
!	   ENDIF
!	ENDDO
!	IF (nmin .GT. nmax) nmax = nmin


***** determine the minimal src time index range needed to do the regrid *****

* find the lowest index of source data that needs to be requested
	IF (tdstrt .LT. tstepmin) THEN
	   CONTINUE	   ! keep llmin
	ELSE
* ... search aux times from low values to high n index for the start time
	   n = nmax + 1
	   DO WHILE (n > nmin)
              n = n - 1           ! loop *down* F indices
	      DO l = llo, lhi     ! loop *up*   T indices
	         t = aux1(i,j,k,l,m,n)
	         IF (t .GT. tdstrt) THEN
	            EXIT    ! continue search at next lower forcast
	         ELSEIF (t .EQ. tdstrt) THEN
	            llmin = l
	            n = nlo  ! signal termination of F loop 
	            EXIT
	         ENDIF
	      ENDDO
	   ENDDO
	ENDIF

* find the highest index of source data that needs to be requested
	IF (tdend .GT. tstepmax) THEN
	   CONTINUE	   ! keep llmax
	ELSE

* ... search aux times from high values to low for the end time
	   n = nmin-1
	   DO WHILE (n < nmax)
	      n = n + 1            ! loop *up*   F indices
	      DO l = lhi, llo, -1  ! loop *down* T indices
	         t = aux1(i,j,k,l,m,n)
	         IF (t .LT. tdend) THEN
	            EXIT    ! continue search at next higher forcast
	         ELSEIF (t .EQ. tdend) THEN
	            llmax = l
	            n = nhi ! signal termination of F loop
	            EXIT 
	         ENDIF
	      ENDDO
	   ENDDO
	ENDIF

* apply the T limits that have been determined
 500	idim = t_dim
	IF (llmin .GT. llmax) llmax = llmin  ! may not be needed?
	cx_lo_ss ( src_cx, idim )  = llmin
        cx_hi_ss ( src_cx, idim )  = llmax
        cx_by_ss ( idim, src_cx )  = .TRUE.

        cx_lo_ww ( idim, src_cx )  = unspecified_val8
        cx_hi_ww ( idim, src_cx )  = unspecified_val8
        cx_delta ( idim, src_cx )  = unspecified_val8
        cx_trans ( idim, src_cx )  = trans_no_transform
        cx_trans_arg(idim,src_cx)  = bad_val4
        cx_given( idim, src_cx )  = .FALSE.
        cx_regrid_trans(idim,src_cx) = unspecified_int4 
        cx_formatted( idim )   = .FALSE.

	CALL FLESH_OUT_AXIS( idim, src_cx, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* apply the F limits that have been determined
	idim = f_dim
	cx_lo_ss ( src_cx, idim )  = nmin
        cx_hi_ss ( src_cx, idim )  = nmax
        cx_by_ss ( idim, src_cx )  = .TRUE.

        cx_lo_ww ( idim, src_cx )  = unspecified_val8
        cx_hi_ww ( idim, src_cx )  = unspecified_val8
        cx_delta ( idim, src_cx )  = unspecified_val8
        cx_trans ( idim, src_cx )  = trans_no_transform
        cx_trans_arg(idim,src_cx)  = bad_val4
        cx_given( idim, src_cx )  = .FALSE.
        cx_regrid_trans(idim,src_cx) = unspecified_int4 
        cx_formatted( idim )   = .FALSE.

	CALL FLESH_OUT_AXIS( idim, src_cx, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* success
        status = ferr_ok
	RETURN

* error exit
 5000	RETURN
! 5050   CALL ERRMSG( ferr_invalid_command, status,
!     .		'target 1D time axis is not regular', *5000)
! 5060   CALL ERRMSG( ferr_invalid_command, status,
!     .		'delta T of target 1D time axis doesnt match the data', *5000)
 5100   CALL ERRMSG( ferr_invalid_command, status,
     .		'2D T-F times are not strictly increasing on T', *5000)
 5150   CALL ERRMSG( ferr_invalid_command, status,
     .		'2D T-F times include missing value', *5000)
	END

	SUBROUTINE RIBBON_PLOTKEY_SETUP (overlay)

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user5/4/2005
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* V7.4+ ACM 7/18  DSG file development
*	Set up the color key for a ribbon or trajectory plot

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'xplot_state.cmn'
	include 'plot_setup.parm'
	include 'xprog_state.cmn'
	include 'xplot_setup.cmn'
	include 'slash.parm'
	include 'parampl5_dat.decl'
	include 'PARAMPL5.DAT'
	include 'cont_inc.decl'	! with nlev
	include 'CONT.INC'

	LOGICAL overlay

	LOGICAL TM_HAS_STRING, do_key
	INTEGER	TM_LENSTR, loc, status
	chARACTER buff*128

* default color key
	do_key =  (qual_given(slash_plot_key)  .GT. 0)
     .		.OR. ( (qual_given(slash_plot_key) .EQ. 0)
     .		        .AND. .NOT.overlay)  ! .AND. .NOT.no_data
	IF (qual_given(slash_plot_nokey) .gt. 0 ) do_key = .FALSE.
	IF ( do_key ) THEN
	   CALL PPLCMD ( from, line, 0, 'SHAKEY 1,1', 1, 1 )

* ... /KEY[=continuous,horizontal,centerlabel] ?
*     /KEY=title is a legal option, but ignored for ribbon plot.

	   loc = qual_given( slash_plot_key )
	   changed_key = .FALSE.

	   IF ( loc .GT. 0) THEN
	      CALL EQUAL_STRING( cmnd_buff(qual_start(loc):qual_end(loc)),
     .		 buff, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
	      IF (TM_LENSTR(buff) .GT. 0) THEN
		 changed_key = .FALSE.
		 IF ( TM_HAS_STRING(buff, 'CON') ) THEN
		   changed_key = .TRUE.
		   CALL PPLCMD (from, line, 0, 'S_KEY 1', 1, 1 )
	         ENDIF
	         IF ( TM_HAS_STRING(buff, 'CEN') ) THEN
		    changed_key = .TRUE.
		    CALL PPLCMD (from, line, 0, 'S_KEY 2', 1, 1 )
	         ENDIF
	         IF ( TM_HAS_STRING(buff, 'HOR') ) THEN
		    changed_key = .TRUE.
		    CALL PPLCMD (from, line, 0, 'S_KEY 3', 1, 1 )
	         ENDIF
	         IF ( TM_HAS_STRING(buff, 'TIT') ) THEN  
		    changed_key = .TRUE.
		    use_keys = .FALSE.
	         ENDIF
	         IF (.NOT. changed_key) GOTO 5600
	      
	      ENDIF ! TM_LENSTR(buff)

	   ENDIF ! loc .GT. 0 for /KEY=

	ELSE  ! do_key
	   CALL PPLCMD ( from, line, 0, 'SHAKEY 0,1', 1, 1 )
	ENDIF ! do_key

 5000	RETURN
 5600	CALL ERRMSG( ferr_syntax, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .		'Unrecognized argument to KEY qualifier', *5000 )
	END

	SUBROUTINE AUX_REGRID_LIMS_1D( dst_cx, src_cx,
     .				       the_axis, axloss, axhiss,
     .			               aux, aux_mr, aux_cx, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Given a context describing data to be regridded to a destination grid
* create the description of the needed source data in the source context
* Use the auxiliary variables to determine the index range of data needed
* For example, if the regrid has requested depth from 0 to 100 and in the 
* auxiliary variable containing depths all of the values LE 100
* are in K=1:6 then we need only request source data over the range K=1:7 

* When called the source context should be a copy of the destination context 

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

*v695+ 3/15 *sh* from AUX_REGRID_LIMS_1D_Z

	IMPLICIT NONE

	include 'tmap_dims.parm'
	include 'implicit.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'

* calling argument declarations:
	INTEGER	src_cx, axis, dst_cx, the_axis, axloss, axhiss, status,
     .		aux_mr, aux_cx
        REAL*8  aux(m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .              m1lot:m1hit,m1loe:m1hie,m1lof:m1hif )
	REAL*8 line(axloss:axhiss)

* internal variable declarations:
	LOGICAL increasing, looking_for_first
	INTEGER	KNOWN_GRID, 
     .		idim, src_grid, i, j, k, l, m, n, trans,
     .		kdstmin, kdstmax, ss, ssmin, ssmax, klo, khi, kdel,
     .		ss_lo(nferdims), ss_hi(nferdims), n_incr, n_decr
	REAL*8  TM_WORLD, axmax, axmin, v, v1, bad_aux

* initialize
	bad_aux = mr_bad_data( aux_mr )
	trans = cx_regrid_trans(the_axis,src_cx)

* capture the data range and modify the target axis to a single point
	DO idim = 1, nferdims
	  ss_lo(idim) = cx_lo_ss(aux_cx, idim)
	  ss_hi(idim) = cx_hi_ss(aux_cx, idim)
	ENDDO
	axloss = ss_lo(the_axis)
	axhiss = ss_hi(the_axis)
* ... a dummy loop on the designated axis
	ss_lo(the_axis) = 1
	ss_hi(the_axis) = 1

* insert source grid (the defining grid for this variable)
* XXXX TEMPORARY -- ?move this block of code to AUX_VAR_REGRID when 2D curv is added?
	src_grid = KNOWN_GRID( cx_data_set(src_cx),
     .			       cx_category(src_cx),
     .			       cx_variable(src_cx)  )
	cx_grid( src_cx ) = src_grid
	cx_unstand_grid( src_cx ) = .FALSE.
	is_phase( isp )   = prgrd_from_source
	cx_naux( src_cx ) = 0
        DO idim = 1, nferdims
           cx_aux_var  (idim, src_cx) = unspecified_int4
           cx_aux_cat  (idim, src_cx) = unspecified_int4
           cx_aux_stat (idim, src_cx) = paux_stat_na
	ENDDO

* Weak test to determine increasing or decreasing by finding the first column
* that has a clear order.   NOTE:  This test can give wrong answers on
* pathological fields with differing order columns
	
	DO 110 n = ss_lo(6),ss_hi(6)
	DO 110 m = ss_lo(5),ss_hi(5)
	DO 110 l = ss_lo(4),ss_hi(4)
	DO 110 k = ss_lo(3),ss_hi(3)
	DO 110 j = ss_lo(2),ss_hi(2)
	DO 110 i = ss_lo(1),ss_hi(1)

* ... get a column of data
	   CALL EXTRACT_ARG1_LINE( aux, the_axis, axloss, axhiss,
     .				   i, j, k, l, m, n, line )

	   n_incr = 0
	   n_decr = 0
	   looking_for_first = .TRUE.
           DO ss = axloss, axhiss
	      v = line(ss)
	      IF (v .EQ. bad_aux) THEN
	         GO TO 110
	      ELSEIF (looking_for_first) THEN
	         v1 = v
	         looking_for_first = .FALSE.
	      ELSE
	         IF (v .GT. v1) THEN
	            n_incr = n_incr + 1
	         ELSE
	            n_decr = n_decr + 1
	         ENDIF
	         v1 = v
	      ENDIF
	   ENDDO

* ... is there a clear ordering to this column of auxilinary coordinates?
	   IF ((n_incr.GE.1 .OR. n_decr.GE.1)
     .   .AND. (n_incr .NE. n_decr          )  ) THEN
	    increasing = n_incr .GE. n_decr  
	    GOTO 130
	   ENDIF

 110	CONTINUE

***** determine the minimal index limits needed to do the regrid *****
* SINGLE AXIS CODE ONLY (GET_CONTEXT_MODS setup to dis-allow multiple args for now)
* ... what are the desired world coordinate limts?
 130	kdstmin = cx_lo_ss ( dst_cx, the_axis )
	kdstmax = cx_hi_ss ( dst_cx, the_axis )
	IF (cx_aux_stat(the_axis,dst_cx) .EQ. paux_stat_false_1pt_regrid) THEN
* ... false 1pt regridding (no target axis ... just a single point value)
	   axmin = cx_lo_ww(the_axis, dst_cx)
	   axmax = cx_hi_ww(the_axis, dst_cx)
	ELSEIF (trans .EQ. pauxrgrd_linear 
     .     .OR. trans .EQ. unspecified_int4  ) THEN
* ... linear interp requires source data below/above target grid point coord
* ... trans.EQ.unspec is for 3-argument plotting
	   axmin   = TM_WORLD(kdstmin, cx_grid(dst_cx), the_axis, box_middle)
	   axmax   = TM_WORLD(kdstmax, cx_grid(dst_cx), the_axis, box_middle)
	ELSEIF (trans .EQ. pauxrgrd_pwlave ) THEN
* ... averaging over cell requires source data over entire cell (larger region)
	   axmin   = TM_WORLD(kdstmin, cx_grid(dst_cx), the_axis, box_lo_lim)
	   axmax   = TM_WORLD(kdstmax, cx_grid(dst_cx), the_axis, box_hi_lim)
	ELSE
	   CALL ERRMSG( ferr_internal, status, 'unkwn rgrd trans', *5000)
	ENDIF
* when searching for the lo/hi index limts of the source data needed
* reverse the direction of traversing the array for decreasing-ordered data
* for a decreasing aux array min>max, lo>hi at this stage
	IF (increasing) THEN
	   klo   = cx_lo_ss(aux_cx,the_axis)
	   khi   = cx_hi_ss(aux_cx,the_axis)
	   kdel  = 1
	ELSE
	   khi  = cx_lo_ss(aux_cx,the_axis)
	   klo  = cx_hi_ss(aux_cx,the_axis)
	   kdel = -1
	ENDIF
	ssmin = khi
	ssmax = klo 

* find the smallest index range in the aux array that contains all of the aux
* values lying within the axmin to axmax value range on the destination axis 
	DO 290 n = ss_lo(6),ss_hi(6)
	DO 290 m = ss_lo(5),ss_hi(5)
	DO 290 l = ss_lo(4),ss_hi(4)
	DO 290 k = ss_lo(3),ss_hi(3)
	DO 290 j = ss_lo(2),ss_hi(2)
	DO 290 i = ss_lo(1),ss_hi(1)

* get a column of data
	   CALL EXTRACT_ARG1_LINE( aux, the_axis, axloss, axhiss,
     .				   i, j, k, l, m, n, line )

* ... search from low values to high for the upper index limit 
           DO ss = klo, khi, kdel
	      v = line(ss)
	      IF ( v .EQ. bad_aux ) THEN
	         CYCLE
	      ELSEIF (v .LT. axmax) THEN
	         IF ( increasing ) THEN
	            IF (ssmax .LT. ss) ssmax = ss
	         ELSE
	            IF (ssmax .GT. ss) ssmax = ss
	         ENDIF
	      ELSE
	         EXIT
	      ENDIF
	   ENDDO

* ... search from high values to low for the lower index limit 
	   DO ss = khi, klo, -1*kdel
	      v = line(ss)
	      IF ( v .EQ. bad_aux ) THEN
	         CYCLE
	      ELSEIF (v .GT. axmin) THEN
	         IF (increasing) THEN
	            IF (ssmin .GT. ss) ssmin = ss
	         ELSE
	            IF (ssmin .LT. ss) ssmin = ss
	         ENDIF
	      ELSE
	         GOTO 290
	      ENDIF
	   ENDDO

 290    CONTINUE

* for decreasing-ordered aux array swap the lo/hi limits just found
	IF (.NOT.increasing) THEN
	   ss    = ssmin
	   ssmin = ssmax
	   ssmax = ss
	ENDIF

* round out, so that regridding interpolations will be possible at the edges
* (the value tests above were based on strict inequality so we always do this) 
	IF (ssmin .GT. cx_lo_ss(aux_cx,the_axis) ) ssmin = ssmin - 1
	IF (ssmax .LT. cx_hi_ss(aux_cx,the_axis) ) ssmax = ssmax + 1

        cx_lo_ss ( src_cx, the_axis )  = ssmin
        cx_hi_ss ( src_cx, the_axis )  = ssmax
        cx_by_ss ( the_axis, src_cx )  = .TRUE.

        cx_lo_ww ( the_axis, src_cx )  = unspecified_val8
        cx_hi_ww ( the_axis, src_cx )  = unspecified_val8
        cx_delta ( the_axis, src_cx )  = unspecified_val8
        cx_trans ( the_axis, src_cx )  = trans_no_transform
        cx_trans_arg(the_axis,src_cx)  = bad_val4
        cx_given( the_axis, src_cx )  = .FALSE.
        cx_regrid_trans(the_axis,src_cx) = unspecified_int4 
        cx_formatted( the_axis )   = .FALSE.

	CALL FLESH_OUT_AXIS( the_axis, src_cx, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* success
        status = ferr_ok
	RETURN

* error exit
 5000	RETURN
! 5100   CALL ERRMSG( ferr_invalid_command, status,
!     .		'auxiliary regridding coordinates are too disordered'
!     .          //pCR//'Need 2:1 ratio ordered:disordered', *5000)
	END

*  rr_taux.F
*
*     Rick Romea
*     Feb. 4, 2000
*
*   Sea Surface Wind Stress  (DYNE/CM**2)  
*  
************************************************************************

      SUBROUTINE RR_taux_init(id)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

      CALL ef_set_desc             (id,' Zonal Wind Stress(dyn/cm^3)')
      CALL ef_set_num_args         (id, 4)
      CALL ef_set_axis_inheritance (id, IMPLIED_BY_ARGS,IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS,IMPLIED_BY_ARGS)
      CALL ef_set_axis_reduction   (id, RETAINED,RETAINED,         
     .                                  RETAINED,RETAINED)          
      CALL ef_set_arg_name         (id, ARG1, 'U')
      CALL ef_set_arg_desc         (id, ARG1, 'Zonal wind speed')
      CALL ef_set_arg_unit         (id, ARG1, 'm/s')
      CALL ef_set_arg_type         (id, ARG1, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG1, YES,YES,YES,YES)

      CALL ef_set_arg_name         (id, ARG2, 'V')
      CALL ef_set_arg_desc         (id, ARG2, 'Meridional wind speed')
      CALL ef_set_arg_unit         (id, ARG2, 'm/s')
      CALL ef_set_arg_type         (id, ARG2, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2, YES,YES,YES,YES)

      CALL ef_set_arg_name         (id, ARG3, 'AIRT')
      CALL ef_set_arg_desc         (id, ARG3, 'AIR TEMPERATURE')
      CALL ef_set_arg_unit         (id, ARG3, 'oC')
      CALL ef_set_arg_type         (id, ARG3, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG3, YES,YES,YES,YES)

      CALL ef_set_arg_name         (id, ARG4, 'SST')
      CALL ef_set_arg_desc         (id, ARG4, 'Sea Surface Temperature')
      CALL ef_set_arg_unit         (id, ARG4, 'oC')
      CALL ef_set_arg_type         (id, ARG4, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2, YES,YES,YES,YES)

      END

c*******************************************************************

      SUBROUTINE RR_taux_compute(id,arg_1,arg_2,arg_3,arg_4,result)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS)
      REAL bad_flag_result
      REAL arg_1  (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .             mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2  (mem2lox:mem2hix, mem2loy:mem2hiy, 
     .             mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3  (mem3lox:mem3hix, mem3loy:mem3hiy, 
     .             mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL arg_4  (mem4lox:mem4hix, mem4loy:mem4hiy, 
     .             mem4loz:mem4hiz, mem4lot:mem4hit)
      REAL result (memreslox:memreshix, memresloy:memreshiy, 
     .             memresloz:memreshiz, memreslot:memreshit)

      INTEGER  res_lo_ss (4)
      INTEGER  res_hi_ss (4)
      INTEGER  res_incr  (4)

      INTEGER  arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER  arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER  arg_incr  (4,EF_MAX_ARGS)

      INTEGER  i,  j,  k,  l
      INTEGER  i1, j1, l1
      INTEGER  i2, j2, l2
      INTEGER  i3, j3, l3
      INTEGER  i4, j4, l4

      REAL AirDensity
      PARAMETER (AirDensity = 0.00125)
      REAL zu
      PARAMETER (zu = 10.)
      REAL zt
      PARAMETER (zt = 10.)
      REAL zq
      PARAMETER (zq = 0.)
      REAL Cd, uz
      REAL QZ,TOL,UW,WT,WQ

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags      (id, bad_flag,  bad_flag_result)

      ! This is a dummy axis, since z is reduced
      DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

        l1 = arg_lo_ss(T_AXIS,ARG1)
        l2 = arg_lo_ss(T_AXIS,ARG2)
        l3 = arg_lo_ss(T_AXIS,ARG3)
        l4 = arg_lo_ss(T_AXIS,ARG4)

        DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

          j1 = arg_lo_ss(Y_AXIS,ARG1) 
          j2 = arg_lo_ss(Y_AXIS,ARG2) 
          j3 = arg_lo_ss(Y_AXIS,ARG2) 
          j4 = arg_lo_ss(Y_AXIS,ARG3) 
        
          DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            i1 = arg_lo_ss(X_AXIS,ARG1) 
            i2 = arg_lo_ss(X_AXIS,ARG2)
            i3 = arg_lo_ss(X_AXIS,ARG3)
            i4 = arg_lo_ss(X_AXIS,ARG4)
 
            DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
              
              IF (arg_1(i1,j1,k,l1) .EQ. bad_flag(ARG1) .OR.
     .            arg_2(i2,j2,k,l2) .EQ. bad_flag(ARG2) .OR.
     .            arg_3(i3,j3,k,l3) .EQ. bad_flag(ARG3) .OR.
     .            arg_4(i4,j4,k,l4) .EQ. bad_flag(ARG4) )THEN
                 result(i,j,k,l) = bad_flag_result
              ELSE

                uz = SQRT(arg_1(i1,j1,k,l1)*arg_1(i1,j1,k,l1)
     .                +  arg_2(i2,j2,k,l2)*arg_2(i2,j2,k,l2))
                IF (uz .LT. 0.1) THEN
                  result(i,j,k,l) = 0.
                ELSE 
                  CALL Bulk(uz,zu,arg_3(i3,j3,k,l3),zt,QZ,zq,
     .                       arg_4(i4,j4,k,l4),TOL,UW,WT,WQ,Cd)
                  result(i,j,k,l) = AirDensity * Cd * uz 
     .                                * arg_1(i1,j1,k,l1)*1.e4
                ENDIF 
              ENDIF

              i1 = i1 + arg_incr(X_AXIS,ARG1)
              i2 = i2 + arg_incr(X_AXIS,ARG2)
              i3 = i3 + arg_incr(X_AXIS,ARG3)
              i4 = i4 + arg_incr(X_AXIS,ARG4)
            ENDDO ! i index

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
            j2 = j2 + arg_incr(Y_AXIS,ARG2)
            j3 = j3 + arg_incr(Y_AXIS,ARG3)
            j4 = j4 + arg_incr(Y_AXIS,ARG4)
          ENDDO ! j index

          l1 = l1 + arg_incr(T_AXIS,ARG1)
          l2 = l2 + arg_incr(T_AXIS,ARG2)
          l3 = l3 + arg_incr(T_AXIS,ARG3)
          l4 = l4 + arg_incr(T_AXIS,ARG4)
        ENDDO ! l index

      ENDDO  ! k index

      END






	SUBROUTINE BULK(UZ,ZU,TZ,ZT,QZ,ZQ,TSFC,TOL,UW,WT,WQ,CD)

*	Minor (I hope) mods made for SSMI stress calc's
*	J Davison 1.24.91
*	No mods made for ECMWF stress calc's
*	J Davison 3.22.93

C	FOLLOWING PROCEDURES AND COEFFICIENTS IN LARGE AND POND (1981 AND
C	1982 BULK; ESTIMATE
C		1) TOL, THE STABILITY PARAMETER Z/L AT Z=10 METERS
C		2)  UW, THE KINEMATIC MOMENTUM FLUX (M/S)**2
C		3)  WT, THE KINEMATIC SENSIBLE HEAT FLUX (DEGREES M/S)
C		4)  WQ, THE KINEMATIC LATENT HEAT FLUX (M/S, G/M**3)
C
C	FROM	1)  UZ, THE MEAN WIND SPEED  [M/S -- JD 1.24.91] AT HEIGHT ZU
C		2)  TZ, THE MEAN AIR TEMPERATURE (CELSIUS)       AT HEIGHT ZT
C		3)  QZ, THE MEAN AIR HUMIDITY (G/M**3)           AT HEIGHT ZQ
C		4) TSFC, THE SEA SURFACE TEMPERATURE (CELSIUS)
C
c      OPTIONS  1) set ZQ=0 to assume a relative humidity of RH=75%
c                DEH changed so RH is set in calling pgm and passed thru common
c                if zq=0.    change made 12/30/85

*		 Not 'passed thru common' but initialized in a data stmt JD 1.91

C		2) SET ZT=0 TO FIND ONLY UW AT NEUTRAL STABILITY
C		3) SET ZU=0 TO RETURN ONLY WITH TOL
C
C     ASSUME	1) A NEUTRAL 10M DRAG COEFFICIENT CDN=0.00115  U10<UCH  11M/S
C				          =0.00049 + 0.000065  U10>UCH  11M/S
C		2) A NEUTRAL 10M STANTON NUMBER   CTN=0.00115  Z/L<0    0
C						     =0.00075  Z/L>0    0
C		3) A NEUTRAL 10M DALTON NUMBER    CEN=0.00115  ALWAYS
C		4) VONK = 0.40 VON KARMAN'S CONSTANT
C		5) THE SMALL WT REGRESSION, WTR BELOW IF BIG=FALSE
C		       WITH A=(.0008,  Z/L>0)   =(.0010,  Z/L<0)
	LOGICAL BIG

*  ARGUMENT DECLARATIONS

      REAL UZ, ZU, TZ, ZT, QZ, ZQ, TSFC, TOL, UW, WT, WQ, CD

*  LOCAL VARIABLE DECLARATIONS

      INTEGER iter
      REAL    a, u, dth, t, cda, cts, ctu, cea, uch, rh, vonk, delth, 
     .        qsat, delq, tkelv, f1, t0, udt, f2, wtr, u3, zuol, ztol, 
     .        zqol, p10, pg10, s10, sg10, phim, phi, psim, phit, psimt, 
     .        psit, phiq, psimq, rk, up, cp, u10, diff, cdn, sqcd, rcd,
     .        ctn, rcdt, ct, rkt, dth10, cen, rcdq, ce, psi, psiq

	WTR(A,U,DTH) = 0.002 + A*U*DTH
C
C		6) THE SATURATION HUMIDITY OF AIR AT T CELSIUS QSAT(T) SAT(T) I
C
	QSAT(T) = 640380000./EXP(5107.4/(273.16 + T))
C
	DATA CDA,CTS,CTU,CEA,UCH/0.00115,0.00075,0.00115,0.00115,10./
	DATA RH,VONK/0.75,0.40/

*	Mod made to incorporate INITAL2 within the BULK subroutine JD 1.24.91
	tol = 0.0
	uw  = 0.0
	wt  = 0.0
	wq  = 0.0
	cd  = 0.0
*	End mod JD 1.24.91

C				ARE THE TEMPERATURES RELIABLE??

	IF(ZT .GT. 0.2) GO TO 1
	TOL = 0.0
	GO TO 3
C
C YES		CALCULATE A BULK STABILITY PARAMETER AT 10 METERS FROM
C		   DELTH, SURFACE-AIR POTENTIAL TEMPERATURE DIFFERENCE
C		   QSFC,  SURFACE  ABSOLUTE  HUMIDITY
C		   T0,    LOCAL MEAN VIRTUAL TEMPERATURE
   1	DELTH = TSFC-TZ-0.01*ZT
	IF(ZQ .LE. 0.0) QZ = RH*QSAT(TZ)
	DELQ = 0.98*QSAT(TSFC)-QZ
	TKELV = 273.16 + TZ
	F1 = 0.00000172
	T0 = TKELV + QZ*F1*TKELV**2
C
C		IS /WT/ LARGE ENOUGH TO USE TRANSFER COEFFICIENTS?
C
	UDT = UZ*DELTH
	IF((UDT .LT. 10.) .AND. (UDT .GT. -15.)) GO TO 2
C YES
	BIG = .TRUE.
	F2 = 1.00
	IF(DELTH .LT. 0.0) F2 = 0.70
	TOL = 0.0 - 1000.*F2/T0/UZ**2*(DELTH + F1/F2*DELQ*T0**2)
	GO TO 3
C
C NO		       DEAL WITH SMALL SENSIBLE HEAT FLUXES
C
   2	BIG = .FALSE.
	A = 0.0010
	IF(DELTH .LT. 0.0) A = 0.0008
	WT = WTR(A,UZ,DELTH)
	WQ = CEA*UZ*DELQ
	U3 = (SQRT(CDA)*UZ)**3
	TOL = 0.0 - 39./U3/T0*(WT + F1*WQ*T0**2)
C
C		RETURN WITH ONLY TOL IF ZU NOT GREATER THAN 0.2
C 
  3	IF(ZU .LE. 0.2) RETURN
	ZUOL = TOL*ZU/10.0
	ZTOL = TOL*ZT/10.0
	ZQOL = TOL*ZQ/10.0
C		EVALUATE THE STABILITY FUNCTIONS IN FZOL
	CALL FZOL(TOL,P10,PG10,S10,SG10)
	CALL FZOL(ZUOL,PHIM,PHI,PSIM,PSI)
	CALL FZOL(ZTOL,PHI,PHIT,PSIMT,PSIT)
	CALL FZOL(ZQOL,PHI,PHIQ,PSIMQ,PSIQ)
C
C	SOLVE FOR U10 AND CDN ITERATIVELY
C
	RK = (ALOG(ZU/10.0) - PSIM + S10)/VONK
	ITER = 1
	UP = UZ/(1.0 + SQRT(CDA)*RK)
  22	CP = CDA
	IF(UP .GT. UCH) CP = (0.49 + 0.065*UP)/1000.
	U10 = UZ/(1.0 + SQRT(CP)*RK)
	DIFF = (UP - U10)/UP
	UP = U10
	IF(DIFF .LE. 0.01) GO TO 4
	ITER = ITER + 1
	IF(ITER .LE. 5) GO TO 22
	WRITE(8,66) ITER,U10,DIFF,CP
  66	FORMAT('-',5X,'TOO BAD, FAILED TO CONVERGE IN 5 ITERATIONS',
     .  I6,3F16.4)
	STOP
C
C		SOLVED FOR U10, NOW FIND CDN AND CD
C		THEN GET UW FROM BULK FORMULA
C
   4	CDN = CDA
	IF(U10 .GT. UCH) CDN = (0.49 + 0.065*U10)/1000.
	SQCD = SQRT(CDN)
	RCD = 1.0 + SQCD/VONK*(ALOG(ZU/10.0) - PSIM)
	CD = CDN/RCD**2
	UW = 0.0 - CD*UZ**2
C
C		SENSIBLE HEAT FLUX IF ZT SET GREATER THAN 0.02
C
	IF(ZT .LE. 0.02) GO TO 5
	CTN = CTU
	IF(DELTH .LT. 0.0) CTN = CTS
	RCDT = 1.0 + SQCD/VONK*(ALOG(ZT/10.0) - PSIMT)
	CT = CTN/RCDT/(1.0 + CTN/VONK/SQCD*(ALOG(ZT/10.) - PSIT))
	WT = CT*UZ*DELTH
	IF(BIG) GO TO 5
C			CALCULATE SMALL SENSIBLE HEAT FLUX
	RKT = (ALOG(ZT/10.0) - PSIT + SG10)/VONK
	DTH10 = DELTH - CT/SQRT(CD)*RKT*(DELTH)
	WT = WTR(A,U10,DTH10)
C
C		LATENT (MOISTURE) FLUX IF ZQ SET GREATER THAN 0.02
C
   5	IF(ZQ .LE. 0.02) RETURN
	CEN = CEA
	RCDQ = 1.0 + SQCD/VONK*(ALOG(ZQ/10.0) - PSIMQ)
	CE = CEN/RCDQ/(1.0 + CEN/VONK/SQCD*(ALOG(ZQ/10.) - PSIQ))
	WQ = CE*UZ*DELQ
	RETURN
	END
C
	SUBROUTINE FZOL(ZOL,PHIM,PHIG,PSIM,PSIG)
C FZOL:		SUBROUTINE TO ESTIMATE THE STABILITY FUNCTIONS
C		USING THE MOST UP TO DATE FLUX-PROFILE RELATIONSHIPS
C

*  ARGUMENT DECLARATIONS

        REAL ZOL,PHIM,PHIG,PSIM,PSIG

*  LOCAL VARIABLE DECLARATIONS

        REAL X

	IF(ZOL .GE. 0.0) GO TO 2
C		UNSTABLE
	X = (1.0 - 16.0*ZOL)**0.25
	PHIM = 1.0/X
	PHIG = PHIM**2
	PSIG = 2.0*ALOG(0.5 + 0.5*X**2)
	PSIM = 0.5*PSIG + 2.0*ALOG(0.5*(1.0 + X)) - 2.0*ATAN(X) + 1.571
	RETURN
C
C		STABLE
C
  2	PHIG = 1.0 + 7.0*ZOL
	PHIM = 1.0 + 7.0*ZOL
	PSIG = -7.0*ZOL
	PSIM = -7.0*ZOL
	RETURN
	END

*
* writev5d.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* June 30 1998
*
* This function takes up to 8 variables from ferret data sets
* and writes them in Vis5D format.  Send in variables to write in the
* first several parameter positions; fill the remaining positions with "0"
* and the name of the file to write in the 9th argument. 
* Requires variables to be on the same x-y grid, grids can vary in depth.
*
*  Use v5dcreate, v5dwrite, v5dclose from the v5d utility functions; these
*  are in binio.c and v5d.c
*
*  ACM  25-Mar-1999  put in filename as an argument.
*
*  ACM 8/May/99 Use REDUCED axes, call ef_set_work_array_lens 
*               function to set gwork
*
*  ACM 8/99 Read either a date and time or a timestep from the "datebuf"
*           that is returned from ef_get_axis_dates
*
*  ACM 8/00 Initialize variable lowlev
* 
*  ACM 11/01 Change testing of Time axis values to allow creating single-time
*            step files (later perhaps appended together)
*          -  single timestep and t>=0 use it
*          -  single timestep and t<0  use date=time=0 (some abstract axes...)
*          -  multiple timesteps and any t<0 bail out. V5d doesn't allow neg times
*
*  ACM 10/03 Pass the ibkwd flag to wrt_v5d_steps. Flip the data in Z only
*            if the Z axis is a depth axis.
*  ACM  6/07 Remove Loop 400 in routine settimes: time axes have already been 
*            tested for whether they are monotonic. This fixes bug 1516. We can go
*            across the 1999-2000 year boundary, but still only works if the year
*            span is within 1950 - 2049.
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE writev5d_init (id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc (id,
     .   'Write up to 8 variables to a Vis5D-formatted file  V5.1' )

      CALL ef_set_num_args(id, 9)
      CALL ef_set_axis_reduction (id, REDUCED, REDUCED, 
     .        REDUCED, REDUCED)

      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, 
     .        IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)

      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      CALL ef_set_num_work_arrays(id, 2)

*  All variables should be on the same grid (except for the vertical 
*  component). There is no result variable sent back to FERRET - a
*  Vis5D file is written.

      arg = 1
      CALL ef_set_arg_name (id, arg, 'V1')
      CALL ef_set_axis_influence (id, arg, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name (id, arg, 'V2')
      CALL ef_set_axis_influence (id, arg, YES, YES, YES, YES)

      arg = 3
      CALL ef_set_arg_name (id, arg, 'V3')
      CALL ef_set_axis_influence (id, arg, YES, YES, YES, YES)

      arg = 4
      CALL ef_set_arg_name (id, arg, 'V4')
      CALL ef_set_axis_influence (id, arg, YES, YES, YES, YES)

      arg = 5
      CALL ef_set_arg_name (id, arg, 'V5')
      CALL ef_set_axis_influence (id, arg, YES, YES, YES, YES)

      arg = 6
      CALL ef_set_arg_name (id, arg, 'V6')
      CALL ef_set_axis_influence (id, arg, YES, YES, YES, YES)

      arg = 7
      CALL ef_set_arg_name (id, arg, 'V7')
      CALL ef_set_axis_influence (id, arg, YES, YES, YES, YES)

      arg = 8
      CALL ef_set_arg_name (id, arg, 'V8')
      CALL ef_set_axis_influence (id, arg, YES, YES, YES, YES)

      arg = 9
      CALL ef_set_arg_type(id, arg, STRING_ARG)
      CALL ef_set_arg_name (id, arg, 'FILENAME')
      CALL ef_set_arg_unit(id, arg, 'none')
      CALL ef_set_arg_desc(id, arg, 'Name of the Vis5D file to write')
      CALL ef_set_axis_influence (id, arg, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN 
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE writev5d_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work array X/Y/Z/T dimensions
*
* ef_set_work_array_lens(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
*  Include file for the Vis5D utility functions thad write the file.
*  We have a separate Ferret version that renames a parameter "MAXVARS.

      INCLUDE 'v5df_fer.h'

      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

      INTEGER max_row, min_col, max_col, min_lev, max_lev
      INTEGER array_num
      INTEGER nwork, nax
      INTEGER min_row, iarg, max_lev_all

*  Set work array size. gwork is a work array whose output dimensions
*  are reset in routine wrt_v5d_steps

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

*  Get max number of rows in all variables
      min_row = MAXROWS
      max_row = 1
      DO 111 iarg = 1, EF_MAX_ARGS
         IF (arg_lo_ss(X_AXIS,iarg) .NE. ef_unspecified_int4) 
     .     min_row = min(min_row, arg_lo_ss(X_AXIS,iarg))

         IF (arg_hi_ss(X_AXIS,iarg) .NE. ef_unspecified_int4) 
     .     max_row = max(max_row, arg_hi_ss(X_AXIS,iarg))

  111 CONTINUE
      IF (min_row .EQ. ef_unspecified_int4 .OR. 
     .    max_row .EQ. ef_unspecified_int4) THEN          
        min_row = 1
        max_row = 1
      ENDIF
      max_row = max_row - min_row + 1

*  Get max number of columns in all variables
      min_col = MAXCOLUMNS
      max_col = 1
      DO 222 iarg = 1, EF_MAX_ARGS
         IF (arg_lo_ss(Y_AXIS,iarg) .NE. ef_unspecified_int4) 
     .     min_col = min(min_col, arg_lo_ss(Y_AXIS,iarg))

         IF (arg_hi_ss(Y_AXIS,iarg) .NE. ef_unspecified_int4) 
     .     max_col = max(max_col, arg_hi_ss(Y_AXIS,iarg))

  222 CONTINUE
      IF (min_col .EQ. ef_unspecified_int4 .OR. 
     .    max_col .EQ. ef_unspecified_int4) THEN          
        min_col = 1
        max_col = 1
      ENDIF
      max_col = max_col - min_col + 1

*  Get total number of levels in all variables together

      min_lev = MAXLEVELS
      max_lev = 1
      max_lev_all = 0
      DO 333 iarg = 1, EF_MAX_ARGS
         IF (arg_lo_ss(Z_AXIS,iarg) .NE. ef_unspecified_int4) 
     .     min_lev = min(min_lev, arg_lo_ss(Z_AXIS,iarg))

         IF (arg_hi_ss(Z_AXIS,iarg) .NE. ef_unspecified_int4) THEN
           max_lev = max(max_lev, arg_hi_ss(Z_AXIS,iarg))
           max_lev_all = max_lev_all + max_lev
         ENDIF

  333 CONTINUE
      IF (min_lev .EQ. ef_unspecified_int4 .OR. 
     .    max_lev .EQ. ef_unspecified_int4) THEN          
        min_lev = 1
        max_lev = 1
        max_lev_all = 1
      ENDIF
      IF (max_lev_all .eq. 0) max_lev_all = 1

*  gwork

      nwork = max_row* max_col* max_lev_all

      array_num = 1
      CALL ef_set_work_array_dims(id, array_num, 1, 1, 1, 1, 
     .     NWORK, 1, 1, 1)

*  ax_vals

      nax = 4* max( max_row, max_col, max_lev_all)
      array_num = 2
      CALL ef_set_work_array_dims(id, array_num, 1, 1, 1, 1, 
     .     nax, 1, 1, 1)


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE writev5d_compute (id, arg_1, arg_2, arg_3,
     .   arg_4, arg_5, arg_6, arg_7, arg_8, arg_9, result, 
     .   gwork, ax_vals)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id, arg
      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .     mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .     mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .     mem3lot:mem3hit)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz, 
     .     mem4lot:mem4hit)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz, 
     .     mem5lot:mem5hit)
      REAL arg_6(mem6lox:mem6hix, mem6loy:mem6hiy, mem6loz:mem6hiz, 
     .     mem6lot:mem6hit)
      REAL arg_7(mem7lox:mem7hix, mem7loy:mem7hiy, mem7loz:mem7hiz, 
     .     mem7lot:mem7hit)
      REAL arg_8(mem8lox:mem8hix, mem8loy:mem8hiy, mem8loz:mem8hiz, 
     .     mem8lot:mem8hit)
      REAL arg_9(mem9lox:mem9hix, mem9loy:mem9hiy, mem9loz:mem9hiz, 
     .     mem9lot:mem9hit)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .     memresloz:memreshiz, memreslot:memreshit)

      REAL gwork(wrk1lox:wrk1hix, wrk1loy:wrk1hiy,
     .               wrk1loz:wrk1hiz, wrk1lot:wrk1hit)

      REAL*8 ax_vals(wrk2lox:wrk2hix/2, wrk2loy:wrk2hiy,
     .               wrk2loz:wrk2hiz, wrk2lot:wrk2hit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)
 

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
*  Include file for the Vis5D utility functions thad write the file.
*  We have a separate Ferret version that renames a parameter "MAXVARS.

      INCLUDE 'v5df_fer.h'

      CHARACTER v5d_filename*160
      CHARACTER arg_name*24, arg_title*128, arg_units*32

      CHARACTER ax_name(4)*16, ax_units(4)*16
      LOGICAL backward(4), modulo(4), regular(4)

      INTEGER i, m, n
      INTEGER numtimes, nlev, numvars, nr, nc, ier

      CHARACTER*255 err_msg

*  Set axis and output arrays.     MAX's are from v5df_fer.h

      REAL*8 xax(MAXCOLUMNS), yax(MAXROWS) 

      INTEGER MAXVARS_OUT
      PARAMETER (MAXVARS_OUT = EF_MAX_ARGS - 1)

      INTEGER timestamp(MAXTIMES), datestamp(MAXTIMES)
      INTEGER ndep(MAXVARS_OUT)

*  Initialize the variables to missing values

      DATA (datestamp(i),i=1,MAXTIMES) / MAXTIMES*IMISSING /
      DATA (timestamp(i),i=1,MAXTIMES) / MAXTIMES*IMISSING /

      INTEGER compress, projection, vertical

      INTEGER idx, idy
      REAL dx, dy, proj_args(4), vert_args(MAXLEVELS)
      INTEGER lowlev(MAX_V5_VARS)

*  Initialize the variable names

      CHARACTER*10 varname(MAXVARS_OUT)
      DATA varname/'var1', 'var2', 'var3', 'var4', 'var5', 'var6', 
     .          'var7', 'var8'/

*  Initialize lowlev
      DATA lowlev/MAX_V5_VARS*0/
 
*  Names of Vis5D utility functions.

c      INTEGER v5dcreate
c      INTEGER v5dsetlowlev
c      INTEGER v5dclose

*  names, units, characteristics of variables to send to Vis5D utility functions.

      CHARACTER*24 zaxis_units(MAXVARS_OUT)
      CHARACTER var_units(MAXVARS_OUT)*32
      LOGICAL ibkwd(MAXVARS_OUT)

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags (id, bad_flag, bad_flag_result)

*  Get coordinate axes.  Note Ferret lists x axis in East longitude and
*  Vis5D assumes West longitude.

      CALL ef_get_coordinates (id, ARG1, X_AXIS, 
     .   arg_lo_ss(X_AXIS, ARG1), arg_hi_ss(X_AXIS, ARG1), xax)
      CALL ef_get_coordinates (id, ARG1, Y_AXIS, 
     .   arg_lo_ss(Y_AXIS, ARG1), arg_hi_ss(Y_AXIS, ARG1), yax)

*  Determine number of variables to write.

      numvars = 0

      DO 100 m = 1, MAXVARS_OUT
         idx = max(arg_incr(X_AXIS,m), 1)
         idy = max(arg_incr(Y_AXIS,m), 1)

         nc = (arg_hi_ss(X_AXIS, m) - arg_lo_ss(X_AXIS, m))/ idx
         nr = (arg_hi_ss(Y_AXIS, m) - arg_lo_ss(Y_AXIS, m))/ idy

         IF (nc .GT. 1  .AND.  nr .GT. 1) numvars = m
  100 CONTINUE

*  Check that the x and y axes for the grids are the same for all variables.
*  Set number of elements in each direction.  Make a NORMAL axis have 
*  one element.

      CALL checkxy (id, numvars, xax, yax, nr, nc, dx, dy, ax_vals, 
     .              err_msg, ier)
      IF (ier .EQ. 0) GO TO 999

C  Set projection arguments for the Vis5D file. 

      proj_args(1) = yax(nr)
      proj_args(3) = dy
      proj_args(2) = 360. - xax(1)
      proj_args(4) = dx

C  Get file name. variable names, and variable units from ferret internal 
C  definitions

      arg = 9
      CALL ef_get_arg_string(id, arg, v5d_filename)

      IF (v5d_filename .EQ. " ") v5d_filename = 'v5d_ferret_file.v5d'		

C  Get  variable names, and variable units from ferret internal definitions

      DO 50 n = 1, numvars

         CALL ef_get_arg_info (id, n, arg_name, arg_title, arg_units)
         CALL ef_get_axis_info (id,n, ax_name, ax_units, backward,
     .     modulo, regular)

         varname(n) = arg_name
         var_units(n) = arg_units
         zaxis_units(n) = ax_units(3)
         ibkwd(n) = backward(3) 

   50 CONTINUE 

C  Set time steps.

      CALL settimes (id, numvars, numtimes, timestamp, datestamp, 
     .               ax_vals, err_msg, ier)

      IF (ier .EQ. 0) GO TO 999

*  Set z steps. 

      CALL setzlevs (id, numvars, vertical, vert_args, zaxis_units,  
     .               ibkwd, ndep, nlev, lowlev, err_msg, ier)

      IF (ier .EQ. 0) THEN
         GO TO 999
      END IF

      compress = 1
      projection = 0

*  Create the Vis5D file
      
      ier = v5dcreate (v5d_filename, numtimes, numvars, nr, nc, 
     .             ndep, varname, timestamp, datestamp, compress, 
     .             projection, proj_args, vertical, vert_args)

      IF (ier .EQ. 0) THEN
        WRITE (err_msg,*) 
     . '(Above are v5dcreate error msgs.) Error during v5d file create.'
        GO TO 999
      END IF

*  Call v5dSetLowLev to specify vertical offset, in grid level index 
*  for each variable.

      ier = v5dsetlowlev (lowlev)

*  v5dsetlowlev returns 0, but the file still works.

c      IF (ier .EQ. 0) THEN
c        write(err_msg,*) ' Error during Vis5D set low levels.'
c        goto 999
c      END IF

*  Call routine to set variable units in Vis5D file.

      DO 300 m = 1, numvars
         CALL v5dsetunits (m, var_units(m))
  300 CONTINUE

*  Fill the data array and write to the Vis5D file for each timestep.

      CALL wrt_v5d_steps (id, nr, nc, ndep, nlev, numvars, ibkwd, arg_1, 
     .      arg_2, arg_3, arg_4, arg_5, arg_6, arg_7, arg_8,  
     .      result, gwork, err_msg, ier)
      IF (ier .EQ. 0) THEN
         GO TO 999
      END IF

*  Close the v5d file and exit

      ier = v5dclose()

      IF (ier .EQ. 0) THEN
         WRITE (err_msg,*) 
     . '(Above are v5dclose error msgs.) Error during v5d file close. '
         GO TO 999
      END IF

      RETURN

 999  CALL ef_bail_out (id, err_msg)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN 
      END


************************************************************************

      SUBROUTINE wrt_v5d_steps (id, nr, nc, ndep, nlev, numvars, ibkwd,
     .     arg_1, arg_2, arg_3, arg_4, arg_5, arg_6, arg_7, arg_8,  
     .     result, g, err_msg, ier)


*  Write an (x,y,z) grid for each timestep to the Vis5D file.
c
c   note that g(1,1,1) is the north west bottom corner
c   and g(nlat,nlon,ndep) is the south east top corner.
c
c  Order of g    3-D array of grid values; 
c    number of values = nlat*nlon*ndep(var)
c                ordered as data[row+nr*(col+nc*lev)] where row incr from
c                North to South, col increases from West to East, and lev
c                increases from bottom to top
c


      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      LOGICAL ibkwd(*)
      INTEGER id
      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .     mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .     mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .     mem3lot:mem3hit)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz, 
     .     mem4lot:mem4hit)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz, 
     .     mem5lot:mem5hit)
      REAL arg_6(mem6lox:mem6hix, mem6loy:mem6hiy, mem6loz:mem6hiz, 
     .     mem6lot:mem6hit)
      REAL arg_7(mem7lox:mem7hix, mem7loy:mem7hiy, mem7loz:mem7hiz, 
     .     mem7lot:mem7hit)
      REAL arg_8(mem8lox:mem8hix, mem8loy:mem8hiy, mem8loz:mem8hiz, 
     .     mem8lot:mem8hit)


      REAL result(memreslox:memreshix, memresloy:memreshiy,  
     .     memresloz:memreshiz,memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


      INTEGER  l, m
      INTEGER i1, j1, k1, l1
      INTEGER i2, j2, k2, l2

      INCLUDE 'v5df_fer.h'

      INTEGER numvars, nr, nc, nl
      INTEGER ndep(*), nlev, index

      REAL baddat, argdat

      CHARACTER*(*) err_msg
      integer ier

*  Set output array.

      REAL*4 g(nr, nc, nlev)

c      INTEGER v5dwrite

*  Get subscript limits.

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags (id, bad_flag, bad_flag_result)
  
*  Fill and write grids in space for each time step and each variable.
*  i1,j1,k1,l1 argument indices; ferret variables being written.
*  i2,j2,k2,l2 Vis5D grid indices 1:nc, 1:nr, 1:nl, 1:ntime

      DO 500 m = 1, numvars

         l2 = 1
         DO 400 l1 = arg_lo_ss(T_AXIS,ARG1),arg_hi_ss(T_AXIS,ARG1)

            i2 = 1
            DO 300 i1 = arg_lo_ss(X_AXIS,ARG1),arg_hi_ss(X_AXIS,ARG1)

               j2 = 1
               DO 200 j1 = arg_lo_ss(Y_AXIS,ARG1),arg_hi_ss(Y_AXIS,ARG1)

                  k1 = arg_lo_ss(Z_AXIS,m)      ! depth may vary w/ m

                  nl = ndep(m)
                  DO 100 k2 = 1, nl
                     index = k2
                     IF (ibkwd(m)) index = nl-k2+1
                     baddat = bad_flag(m)
 
                     IF (m .EQ. 1) argdat = arg_1(i1,j1,k1,l1) 
                     IF (m .EQ. 2) argdat = arg_2(i1,j1,k1,l1) 
                     IF (m .EQ. 3) argdat = arg_3(i1,j1,k1,l1) 
                     IF (m .EQ. 4) argdat = arg_4(i1,j1,k1,l1) 
                     IF (m .EQ. 5) argdat = arg_5(i1,j1,k1,l1) 
                     IF (m .EQ. 6) argdat = arg_6(i1,j1,k1,l1) 
                     IF (m .EQ. 7) argdat = arg_7(i1,j1,k1,l1) 
                     IF (m .EQ. 8) argdat = arg_8(i1,j1,k1,l1) 


                     IF (argdat .EQ. baddat) THEN
                        g(nr-j2+1,i2,index) = MISSING
                     ELSE 
                        g(nr-j2+1,i2,index) = argdat
                     END IF

                     k1 = k1 + arg_incr(Z_AXIS,m)	! depth may vary w/ m
 100              CONTINUE

                  j2 = j2 + 1
 200           CONTINUE

               i2 = i2 + 1
 300        CONTINUE
   
*  Write the time step to the Vis5D file.

            ier = v5dwrite (l2, m, g)		! l=time step, m=variable #

            IF (ier .EQ. 0) THEN
               WRITE (err_msg,*) ' Error during v5d file write. ',
     .                           ' Time step ', l
               GO TO 999
            END IF

            l2 = l2 + 1
 400     CONTINUE

 500  CONTINUE

      RETURN

 999  CONTINUE

      RETURN

      END

*                                                                      ^
*                                                                      |
************************************************************************

      SUBROUTINE checkxy (id, numvars, xax, yax, nr, nc, dx, dy, 
     .         ax_vals, err_msg, ier)

*  Check that there is at least one variable to write to the Vis5D file.
*  Check the x and y axes for the variables: they must agree with xax, yax
*  from arg_1, and not exceed the limits in the include file v5df.h
*  Set nr = # rows and nc = # columns.

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INCLUDE 'v5df_fer.h'

* After initialization, the 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER id
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

      INTEGER ier
      INTEGER i, j, m
      INTEGER numvars, nc, nr, ncm, nrm

      REAL*8 xax(*), yax(*), ax_vals(*)
      REAL   dx, dy

      CHARACTER*(*) err_msg

      CHARACTER ax_name(4)*16, ax_units(4)*16
      LOGICAL backward(4), modulo(4), regular(4)

      IF (numvars .LT. 1) THEN
         ier = 1
      ELSE
         ier = 1
         CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)

         CALL ef_get_axis_info (id, 1, ax_name, ax_units, backward,
     .     modulo, regular)

*  Set number of elements in each direction.  Let a NORMAL axis have 
*  one element.

      IF (arg_hi_ss(X_AXIS,ARG1) .EQ. arg_lo_ss(X_AXIS,ARG1)  .OR.  
     .       arg_incr(X_AXIS,ARG1) .EQ. 0) THEN 
         dx = 1.
         nc = 1
      ELSE
         dx = abs(xax(2) - xax(1))
         nc = arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 1

*  Check that the x axis is equally-spaced.

         IF (.NOT. regular(1)) THEN
            WRITE (err_msg, *) 'Vis5D uses only equally spaced ',
     .            'X-axis.  Regrid the data in x.'
            GO TO 999
         END IF

      END IF

      IF (arg_hi_ss(Y_AXIS,ARG1) .EQ. arg_lo_ss(Y_AXIS,ARG1)  .OR.  
     .       arg_incr(Y_AXIS,ARG1) .EQ. 0) THEN 
         dy = 1.
         nr = 1
      ELSE
         dy = abs(yax(2) - yax(1))
         nr = arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1) + 1

*  Check that the axis is equally-spaced.

         IF (.NOT. regular(2)) THEN
            WRITE (err_msg, *) 'Vis5D uses only equally spaced ',
     .            'Y-axis.  Regrid the data in y.'
            GO TO 999
         END IF

  
      END IF

C  Check number of columns and rows against Vis5D maxima.

         IF (nr .GT. MAXROWS) THEN
            WRITE (err_msg, *) nr, 'Too many rows. Vis5D Max is ', 
     .                  MAXROWS
            ier = 0
            GO TO 999
         ENDIF
         IF (nc .GT. MAXCOLUMNS) THEN
            WRITE (err_msg, *) nr, 'Too many columns. Vis5D Max is ',
     .                  MAXCOLUMNS
            ier = 0
            GO TO 999
         ENDIF

         IF (nr .LE. 1  .OR.  nc .LE. 1)  THEN
            WRITE (err_msg, *) 'The grid for all variables must',
     .         ' have two or more grid points in x and y directions '
             ier = 0
             GO TO 999
         ENDIF

*  Get coordinate axes for variables 2 through numvars.
*  Check with Vis5D max and compare with xax and yax.

         DO 400 m = 2, numvars
            ncm = 
     .        (arg_hi_ss(X_AXIS,m) - arg_lo_ss(X_AXIS,m) + 1)/ 
     .         arg_incr(X_AXIS,m)

            IF (ncm .GT. MAXCOLUMNS) ier = 0
            IF (ncm .NE. nc) ier = 0

            CALL ef_get_coordinates (id, m, X_AXIS, 
     .        arg_lo_ss(X_AXIS, m), arg_hi_ss(X_AXIS, m), ax_vals)
           

            DO 300 i = 1, nc
               IF (xax(i) .NE. ax_vals(i)) ier = 0
 300        CONTINUE

 400     CONTINUE  

         IF (ier .eq. 0) THEN
            WRITE (err_msg, *) 'Vis5D X axes for all variables must ',
     .           ' be the same.'
            go to 999
         ENDIF

         DO 600 m = 2, numvars
            nrm = 
     .        (arg_hi_ss(Y_AXIS,m) - arg_lo_ss(Y_AXIS,m) + 1)/ 
     .         arg_incr(Y_AXIS,m)

            IF (nrm .GT. MAXROWS) ier = 0
            IF (nrm .NE. nr) ier = 0

           CALL ef_get_coordinates (id, m, Y_AXIS, 
     .         arg_lo_ss(Y_AXIS, m), arg_hi_ss(Y_AXIS, m), ax_vals)

            DO 500 j = 1, nr
               IF (yax(j) .NE. ax_vals(j)) ier = 0
 500        CONTINUE

 600     CONTINUE  
         IF (ier .eq. 0) THEN
            WRITE (err_msg, *) 'Vis5D Y axes for all variables must ',
     .           ' be the same.'
            go to 999
         ENDIF

      END IF

      RETURN
  999 ier = 0
      END

*                                                                      ^
*                                                                      |
************************************************************************

      SUBROUTINE settimes (id, numvars, numtimes, timestamp, datestamp, 
     .                     ax_vals, err_msg, ier)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INCLUDE 'v5df_fer.h'

* After initialization, the 'arg_' arrays will contain the indexing 
* information for each variable's axes. 


      INTEGER id, iarg, l
      INTEGER numtimes

      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

      INTEGER ier, m, nlm, icentury
      INTEGER numvars

      REAL*8 tax(MAXTIMES), ax_vals(*)
      INTEGER lasttime, thistime, lastdate, thisdate

      INTEGER iyear, ihour, iminute, isec
      CHARACTER*3 cmon
      INTEGER day_of_mon, day_of_year
      CHARACTER*20 datebuf(MAXTIMES)
      CHARACTER*(*) err_msg

      INTEGER timestamp(*), datestamp(*)

      ier = 1

*  Set time steps; check that there arent too many for Vis5D.

      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)

      IF (arg_hi_ss(T_AXIS,ARG1) .EQ. arg_lo_ss(T_AXIS,ARG1) .or.
     .      arg_incr(T_AXIS,ARG1) .EQ. 0) THEN 
         numtimes = 1
      ELSE
         numtimes = 
     .     (arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1) + 1)/
     .     arg_incr(T_AXIS,ARG1)
         IF (numtimes .GT. MAXTIMES) THEN
            ier = 0
            WRITE (err_msg,*) ' Vis5D has a limit of ', MAXTIMES, 
     .        ' timesteps.', ' DATA region has', numtimes
            GO TO 999
         END IF
      END IF

*  Get time axis coordinates for first variable.

      CALL ef_get_coordinates (id, ARG1, T_AXIS, 
     .   arg_lo_ss(T_AXIS, ARG1), arg_hi_ss(T_AXIS, ARG1), tax)

*  Get time axis for remaining variables.  Check that thay are 
*  the same as for the first variable.  

      DO 200 m = 2, numvars
         IF (arg_hi_ss(T_AXIS,m) .EQ. arg_lo_ss(T_AXIS,m) .or.
     .      arg_incr(T_AXIS,m) .EQ. 0) THEN 
            nlm = 1
         ELSE
            nlm = 
     .        (arg_hi_ss(T_AXIS,m) - arg_lo_ss(T_AXIS,m) + 1)/ 
     .         arg_incr(T_AXIS,m)
         ENDIF

         IF (nlm .NE. numtimes) THEN
            ier = 0
            WRITE (err_msg,*) ' Vis5D: All variables must have same ',
     .                        '# time steps'
            GO TO 999
         END IF

         CALL ef_get_coordinates (id, m, T_AXIS, 
     .       arg_lo_ss(T_AXIS, m), arg_hi_ss(T_AXIS, m), ax_vals)

         IF (numtimes .GT. 1) THEN

            DO 100 l = 1, numtimes
               IF (tax(l) .NE. ax_vals(l)) GO TO 999
 100        CONTINUE
         ELSE
            ax_vals(1) = tax(1)
         ENDIF

 200  CONTINUE  

* If the time axis of grid is not a normal axis, convert to dates and
* write to timestamp and datestamp in the form that Vis5D expects.

      IF (numtimes .EQ. 1  .AND. tax(1) .LT. 0) THEN    ! some normal axes have -t.
         datestamp(1) = 0
         timestamp(1) = 0

      ELSE

*  If there are negative time-axis values, bail out.

         DO 101 l = 1, numtimes
            IF (tax(l) .LT. 0) THEN
               WRITE (err_msg,*) 
     .          ' Vis5D does not allow negative values on time axis.'
               GO TO 999
            ENDIF

101      CONTINUE

         iarg = 1
         CALL ef_get_axis_dates (id, iarg, tax, numtimes, datebuf)

*  Set up the datestamp and timestamp

         DO 300 l = 1, numtimes

*  If datebuf is in form "DD-MON-YYYY HH:MM:SS".  Read date and time; convert
*  to Vis5D time and date stamps.

            IF (datebuf(l)(3:3) .EQ. '-') THEN
               READ (datebuf(l), 110, err=900) day_of_mon, cmon, iyear
               CALL juldate (cmon, day_of_mon, iyear, day_of_year)

               READ (datebuf(l), 120, err=900) ihour, iminute, isec

* note:  Vis5D uses 2-digit years; years YY <=50 are considered to be 20YY,
*        years YY > 50 are considered to be 19YY.

               IF (iyear .GT. 0) THEN
                  icentury = iyear/ 100
                  icentury = icentury * 100
                  iyear = iyear - icentury
                  if (iyear .eq. 100) iyear = 0

               END IF
 
               datestamp(l) = 1000* iyear + day_of_year	
               timestamp(l) = isec + 100 * iminute + 10000* ihour

*  datebuf not in form "DD-MON-YYYY HH:MM:SS".  Try just reading the time as 
*  a number...

            ELSE
               datestamp(l) = 0
               READ (datebuf(l), *, err=900) timestamp(l)

            ENDIF	! IF (datebuf(l)(3:3) .EQ. '-')

  300    CONTINUE

      ENDIF		! IF (numtimes .EQ. 1) 


  110 FORMAT (i2, 1x, a3, 1x, i4)
  120 FORMAT (11x, 3(1x,i2))

      RETURN

*  Error reading the dates/times. 

  900 CONTINUE

      WRITE (err_msg,*) 
     .  'Error assigning dates/times to timestamp for Vis5D',  
     .  datebuf(l)

  999 ier = 0
      RETURN
      END

*                                                                      ^
*                                                                      |
************************************************************************

      SUBROUTINE juldate (cmon, day_of_mon, iyr, day_of_year)

*  Convert character month and day of month to day of year.

      INTEGER i, iyr
      CHARACTER*(*) cmon
      CHARACTER*3 months(12)
      INTEGER day_of_mon, day_of_year, imon, ndaymo(12)

      DATA months/'JAN', 'FEB', 'MAR', 'APR', 'MAY', 'JUN', 'JUL', 
     .            'AUG', 'SEP', 'OCT', 'NOV', 'DEC'/
      DATA ndaymo/31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31/
 

      imon = 0
      DO 100 i = 1, 12
        IF (cmon .EQ. months(i)) imon = i
  100 CONTINUE

      IF (mod(iyr, 4) .EQ. 0) ndaymo(2) = 29

      day_of_year = day_of_mon
      DO 200 i = 1, imon - 1
         day_of_year = day_of_year + ndaymo(i)
  200 CONTINUE

      RETURN
      END
*                                                                      ^
*                                                                      |
************************************************************************
      SUBROUTINE setzlevs (id, numvars, vertical, vert_args, 
     .            zaxis_units, ibkwd, ndep, nlev, lowlev, err_msg, ier)

*  Set z steps.  Must be either the same for all variables or some variables 
*  can be surface data only.

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

      INTEGER numvars, nlev, ndepmax, nltot, lv
      INTEGER m, l, ier


      INCLUDE 'v5df_fer.h'

      INTEGER ndep(*), vertical, vert(MAX_V5_VARS)
      INTEGER lowlev(*)
      REAL vert_args(MAXLEVELS), sort_args(MAXLEVELS*EF_MAX_ARGS)
      REAL*8 zax(MAXLEVELS)
      REAL all_levs(MAXLEVELS, EF_MAX_ARGS)

      LOGICAL seq, ibkwd(*)

      REAL dep_fac(EF_MAX_ARGS)

      CHARACTER*(*) zaxis_units(*), err_msg

*  Get axis subscripts and coordinates.

      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)

      nlev = 1
      ndepmax = 1
      DO 200 m = 1, numvars

         CALL ef_get_coordinates (id, m, Z_AXIS, 
     .   arg_lo_ss(Z_AXIS, m), arg_hi_ss(Z_AXIS, m), zax)

*  Get axis units and determine conversion to KM if possible.  If
*  units are other than cm, m, km, or mb then they will be Vis5D 
*  "generic units"; vertical = 0
* !ACM  ???  Leave cm or m alone and let them be generic units...
* !ACM       But, if some are CM, others in M, want to convert to same units...

         IF (zaxis_units(m) .EQ. 'cm'  .OR. 
     .         zaxis_units(m) .EQ. 'CM') THEN
            dep_fac(m) = 1./1000000.
            vert(m) = 1

         ELSE IF (zaxis_units(m) .EQ. 'm'  .OR.  zaxis_units(m) .EQ. 'M'  
     .            .OR.  zaxis_units(m) .EQ. 'METERS'   .OR.  
     .            zaxis_units(m) .EQ. 'meters') THEN
            dep_fac(m) = 1./1000.
            vert(m) = 1

         ELSE IF (zaxis_units(m) .EQ. 'km'  .OR. 
     .             zaxis_units(m) .EQ. 'KM') THEN
            dep_fac(m) = 1.
            vert(m) = 1

         ELSE IF (zaxis_units(m) .EQ. 'mb'  .OR.  
     .             zaxis_units(m) .EQ. 'MB') THEN
            dep_fac(m) = 1.
            vert(m) = 3

         ELSE 
            dep_fac(m) = 1.
            vert(m) = 0
         END IF

*  !ACM Here we could check and see if all the vertical axes are the same, and
*  set vert_args more simply if so. 

*  vertical = 0 for equally spaced levels in generic units 
*  vertical = 1 for equally spaced levels in km
*  vertical = 2 for unequally spaced levels in km
*  vertical = 3 for unequally spaced levels in mb

*  Get delta-z and determine if the axis is equally spaced.

         IF (arg_hi_ss(Z_AXIS,m) .EQ. arg_lo_ss(Z_AXIS,m)) THEN 
            ndep(m) = 1 
            vert(m) = 0

*  Put DATA for a var w/normal axis at the surface.
            all_levs(1,m) = 0.	
         ELSE

            vertical = 2

            ndep(m) = 
     .        (arg_hi_ss(Z_AXIS,m) - arg_lo_ss(Z_AXIS,m) + 1)/ 
     .         arg_incr(Z_AXIS,m)

            DO 100 l = 1, ndep(m)
               IF (ibkwd(m)) THEN
                  all_levs(ndep(m)-l+1, m) = -1.D0* zax(l)* dep_fac(m) 
               ELSE
                  all_levs(l,m) = zax(l)* dep_fac(m) 
               END IF
  100       CONTINUE


        END IF

         ndepmax = max(ndepmax, ndep(m))
  200 CONTINUE

!  !!!  Vis5D allows us to start some variables at one level and others
!       somewhere else.  doesn't have a structure to allow skipping some
!       levels in any variable. 

!ACM  Because of the result grid being set as inherited from the first 
!     variable, need to have any variables with depth levels come first
!     in the calling sequence to writev5d.F ??  Test for this...

*  Sort the union of all levels into the array vert_args.

      IF (ndepmax .GT. 1) THEN
         nltot = 0
         DO 400 m = 1, numvars
            DO 300 l = 1, ndep(m)
               nltot = nltot + 1
               sort_args(nltot) = all_levs(l, m)
  300       CONTINUE
  400    CONTINUE

         CALL shellsort1 (sort_args, nltot)

*  Remove duplicates.

         nlev = 1
         vert_args(1) = sort_args(1) 
         DO 500 l = 2, nltot 
            IF (sort_args(l) .NE. sort_args(nlev) ) THEN
               nlev = nlev + 1
               sort_args(nlev) = sort_args(l)
               vert_args(nlev) = sort_args(l)
            END IF
  500    CONTINUE

         if (nlev .GT. MAXLEVELS) THEN
            WRITE (err_msg,*) 'Too many levels, all variables ',
     .           'together. Max is ', MAXLEVELS
            ier = 0
            goto 999
         ENDIF

*  Compare the set of levels for each variable with vert_args.  If the 
*  variable's levels are in vert_args with the sequence intact, then set 
*  lowlev appropriately.

         DO 800 m = 1, numvars

*  Find the first element of vert_args that matches the low level of this var.

            seq = .false.
            DO 700 l = 1, nlev
               IF (all_levs(1, m) .EQ. vert_args(l) ) THEN
                  lowlev(m) = l - 1
                  seq = .true.

                  DO 600 lv = 1, ndep(m)
                     IF (all_levs(lv, m)  .NE.  vert_args(l+lv-1) )
     .                   seq = .false.
  600             CONTINUE

               END IF
  700       CONTINUE

            IF (.NOT. seq) THEN
               WRITE (err_msg,*) ' IF levels for different variables ', 
     .             'intersect they must be in sequence with no ', 
     .             'skips.  Levels for argument ', m, 
     .             ' not sequential'
               GO TO 999
            END IF

  800    CONTINUE

      ELSE
         vertical = 0
         vert_args(2) = 1.

      END IF	! ndepmax .GT. 1

      ier = 1

      RETURN

  999 ier = 0

      RETURN
      END

      SUBROUTINE shellsort1 (SDAT, N)


*from http://www.cs.mcgill.ca/~ratzer/progs15_6.html  23-APR-1998
* Changed data to REAL. 
* Removed NCOUNTS, NCOMP, NSWAP.

      REAL     SDAT(*)
      INTEGER  M, N, I, J

      M=N
      DO WHILE (M .GT. 1)
         M=(M+2)/3
         DO I=M+1,N
            DO J=I,M+1,-M
               IF (SDAT(J-M) .GE. SDAT(J)) THEN
                 CALL swapr (SDAT,J,J-M)
               END IF
            END DO 
         END DO 
      END DO
      RETURN
      END !SUBROUTINE SHELL
!

      SUBROUTINE swapr (SDAT,K,L)
      REAL SDAT(*), S
      INTEGER K,L
      S=SDAT(K)
      SDAT(K)=SDAT(L)
      SDAT(L)=S
      RETURN
      END !SUROUTINE SWAP

	SUBROUTINE FLESH_OUT_AXIS( idim, cx, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* given a skeletal context with a known grid transfor the subscript coord
* data to world coordinates and world to subscript on the specified axis
* make sure all time coordinates are in time step values (vs. secs from BC)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  5/26/89 - extracted from FLESH_OUT_CONTEXT
*                - handles axes of uvars where all region info is contained
*		 - detects and set up interpolations
*		 - inserts unspecified limits for file vars
* V230:  7/20/92 - check TM_DATE_OK for valid time axis before doing time xlate
*                - kludge fix to err230_fixed_limits.jnl
*        8/10/92 - point location with transform (e.g. Z=5@DIN) needs
*                  exact location preserved for proper labelling
* V320:	 11/2/94 - checking if interpolation is required needs to be based on
*		   single precision coordinate comparison
* V420:   1/96   - if the context being completed involves modulo
*		   regridding then the interpretation of the limits is altered
* *kob* 11/96   - Linux port.  Linux didn't like tabs between "include"
*                 and what was being included.  removed them
* V450:   1/97   - fix to never-observed bug: the check
*		        "uvar_given(idim,var) .LE. uvlim_gvn_xact"
*		   ignores the possibility of uvlim_irrelevant
*  *KOB* 9/97    - replaced call to ISUBSCRIPT w/ call to ISUBSCR_CX in 
*                  order to use cx_calendar to determine style of taxis
* V500 *kob* 3/99- up VAR_CODE decl from 8 to 64 chars
*      *sh*  5/99 - go ahead and flesh out implicit axes (to improve cache hits
*		    when netCDF strides are invoked)
* V510: *sh* 12/99 - support for uvlim_hiddef (EF caching)
*	*sh* 4/00 - since netCDF dsets now produce dynamic axes we cannot
*		    use line .LT. max_lines as a test of an implicit axes
* v5.3 *acm* 1/01 - line_cal_name is part of the data set information
* V530: *sh* 4/01 - added comment about in_get_grid_mode
* V533: *sh* 6/01 - added logic for strides (cx_delta)
* V552 *acm* 4/03- up VAR_CODE decl from 64 to 128 chars
* V560:*acm* 4/04 - stride/modulo fixes: use NINT to convert REAL*8 to integer
* *acm* v580 11/04- Keep cx_cal_id, the calendar ID used when computing 
*                  world coordinates
* V580 *acm* 11/04- Fix divide by zero; cx_delta(idim,cx) is 0 if user
*                   incorrectly specifies LIST/I=1:100:0 VAR
* V68  *acm* 1/12  explicit single-precision calculations for consistent results in
*		   for double-precision ferret
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction. The time 
*                  dimension is now an arg to SECS_TO_TSTEP.
* V683  *acm*10/12  Fix bug 1972: cx_calendar and cx_cal_id are changed only
*                   if it's the T dimension not the T or F dimension.
* V690  *sh* 4/14 For curvilinear axes keep ww lims as-is (may exceed ax lims)
* V693+ 11/14 *sh* renaming 'sigma' as 'layerz' throughout
* V695  *acm* 2/15 cx_calendar stores info about calendar formatting of T and F axes
* V720  *sh*  4/17 support DSG grids
* V73+ *acm* 12/17 INIT_CXDSG needs nfeatures
* V741  *acm* 6/18 Fix issue 1868: Let the transform remain in the context when 
*                  variable is a constant. So let a = 2; list a[x=@trans] will no 
*                  longer return 2, but will be either computed (for NGD and NBD),
*                  or will be caught as an error instead of returning 2.
* V741  *acm* 7/18 Issue 1868, do not wipe out the trans setting in the case of a constant
* V74+ *acm*10/10 Partial fix to working with E contexts in dsg datasets.
* V744 *acm* 11/18 Issue 965, change behavior when axis is given with strides in the region

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'ferret.parm'
	include 'implicit.parm'
	include 'errmsg.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
	include 'xfr_grid.cmn'
	include 'xtext_info.cmn'
	include 'xdset_info.cmn_text'
	external xdset_info_data

* calling argument declarations:
	INTEGER	idim, cx, status

* internal variable declarations:
	LOGICAL TM_DATE_OK, TM_FPEQ, INHERITED_LIMITS, TM_ITSA_DSG_RAGGED,
     .		ITSA_REGRID_FROM_DSG, 
     .		point, lim_redundant, is_time, fromdsg, abst_nolim, its_dsg
	INTEGER	TM_LENSTR1, ISUBSCR_CX, DSG_WHATS_IT, TM_DSG_DSET_FROM_GRID,
     .		TM_DSG_NFEATURES,
     .		ss, lo_ss, hi_ss, axis, grid, cat, var, ispread,
     .		orientation, obs_dimlen, obs_line, dsgness, taxis,
     .		xlate_grid, dset, e_line, nfeatures, i
	INTEGER TM_GET_CALENDAR_ID, cal_id
	REAL*8	TM_WORLD, SECS_TO_TSTEP, ww_nrst, ww_given, min_ww, max_ww
	CHARACTER	VAR_CODE*128, string*128

* initialize
	var  = cx_variable( cx )
	cat  = cx_category( cx )
	grid = cx_grid    ( cx )
	axis = grid_line( idim, grid )
	status = ferr_ok
	dsgness = DSG_WHATS_IT(grid)
	fromdsg = ITSA_REGRID_FROM_DSG( cx)

* DSG grids (4/17)
* For a DSG contiguous ragged array grid (a DSG observation var) the
* subscript limits are always set to the 1D full limits of the obs axis
* For a DSG instance variable the 1D subscript limits are always set to
* the full span of the E (feature) axis.
* In both observation vars and instance vars if WW limits are provided,
* they are carried along passively to be used at the time of action
* commands (LIST, PLOT, etc.) as a filter on which instances
* of the DSG are to be processed.
* The F axis of a DSG grid, alone, is processed as a typical gridded axis
	IF (dsgness .NE. pdsg_not_dsg .OR. fromdsg) THEN
	   IF (idim .EQ. f_dim) GOTO 1000  ! treat like a gridded axis
* ... initialize DSG info
	   its_dsg = .TRUE.
	   CALL TM_DSG_FACTS(grid, orientation, obs_dimlen, obs_line, its_dsg)
	   dset = TM_DSG_DSET_FROM_GRID(grid)
	   IF (.NOT. its_dsg) dsgness = pdsg_not_dsg
	ENDIF
	IF (dsgness .NE. pdsg_not_dsg ) THEN
* as a friendliness feature make E subscript limits behave as if they
*     were given as WW limits. E=instance=feature axis of a DSG
	   IF ( idim .EQ. e_dim .AND. cx_given(e_dim,cx) ) THEN
	      IF (cx_by_ss(e_dim,cx)) THEN
	         cx_lo_ww(idim,cx) = cx_lo_ss(cx,idim)
	         cx_hi_ww(idim,cx) = cx_hi_ss(cx,idim)
	         cx_by_ss(e_dim,cx) = .FALSE.
	      ENDIF
	   ELSE IF ( idim .EQ. e_dim .AND. cx_lo_ss(cx,idim).NE.unspecified_int4 ) THEN
	      IF (cx_by_ss(e_dim,cx)) THEN
	         cx_lo_ww(idim,cx) = cx_lo_ss(cx,idim)
	         cx_hi_ww(idim,cx) = cx_hi_ss(cx,idim)
	         cx_by_ss(e_dim,cx) = .FALSE.
	      ENDIF
	   ENDIF

* ignore other limits set by subscript (alt: could flag as a user error)
	   cx_lo_ss( cx, idim ) = unspecified_int4 
	   cx_hi_ss( cx, idim ) = unspecified_int4
	   cx_by_ss(idim,cx) = .FALSE.
* if a T axis, convert date-times into grid-specific time step values
* from their representation as negative secs from BC
	   IF ( idim.EQ. t_dim
     .	 .AND. cx_hi_ww(idim,cx) .NE. unspecified_val8
     .	 .AND. cx_calendar(idim,cx)      ) THEN
	     xlate_grid = dsg_xlate_grid(dset)
	     taxis = grid_line(t_dim, xlate_grid)
             cal_id = TM_GET_CALENDAR_ID (line_cal_name(taxis))
             IF ( TM_DATE_OK( line_t0(taxis), cal_id ) ) THEN
	         cx_lo_ww(idim,cx) = SECS_TO_TSTEP
     .                ( xlate_grid, idim, -cx_lo_ww(idim,cx) )
	         cx_hi_ww(idim,cx) = SECS_TO_TSTEP
     .                ( xlate_grid, idim, -cx_hi_ww(idim,cx) )
		 cx_calendar(idim,cx) = .FALSE.
                 cx_cal_id(cx) = cal_id
              ENDIF
	   ENDIF
* constrain the world limits to the coordinate range of the dataset
	   CALL DSG_COORD_LIMS(dset, idim, min_ww, max_ww)
	   IF (min_ww .NE. unspecified_val8 ) THEN
	      IF  (cx_lo_ww(idim,cx) .EQ. unspecified_val8) THEN
	         cx_lo_ww(idim,cx) = min_ww
	         cx_hi_ww(idim,cx) = max_ww
	      ELSE
	         IF (cx_lo_ww(idim,cx) .LT. min_ww) cx_lo_ww(idim,cx) = min_ww 
	         IF (cx_hi_ww(idim,cx) .GT. max_ww) cx_hi_ww(idim,cx) = max_ww 
	      ENDIF
	   ENDIF
* set the subscript limits to capture the full 1D netCDF variable
	   IF (dsgness .EQ. pdsg_instance) THEN
	      IF (idim .EQ. e_dim
     .	    .AND. cx_trans(idim,cx) .LE. trans_compress_code) THEN
	         cx_lo_ss(cx,idim) = 1
	         cx_hi_ss(cx,idim) = line_dim(axis) ! E axis length
	      ENDIF
	   ELSEIF (dsgness .EQ. pdsg_observation) THEN
	      IF (idim .EQ. orientation) THEN
	         cx_lo_ss(cx,idim) = 1
	         cx_hi_ss(cx,idim) = obs_dimlen   ! DSG observation dim length
	      ENDIF
	   ENDIF
* constraining E axis implicitly constrains the XYZT dimensions
* For example E=5 of a trajectory collection has
* only the XYZT extent of that trajectory -- not of the full collection
	   IF ( idim .EQ. e_dim .AND. cx_given(e_dim,cx) ) THEN
	      nfeatures = TM_DSG_NFEATURES( grid )
	      CALL INIT_CXDSG(dset, cx, nfeatures)
	      CALL APPLY_DSG_E_CONSTRAINTS(dset, cx)
	   ENDIF
! DSGTBD: constraining the X axis of a DSG implicitly constrains YZT, too
! because it may remove features that possess the extreme values in YZ or T
! Above we have addressed only explicit constraints on E.
! So as an optimization one might consider recomputing the limits any time
! any of the constraints are altered.
	   GOTO 4000
* When regridding *from* a DSG grid, the ww limits of the DSG become irrelevant
* Since the DSG context will be available at the time of regridding, the
* information contained in these limits will be available
	ELSEIF (fromdsg) THEN
* Regridding *from* a DSG
* Leave the E and orientation axes as-is so that user-specified limts will
* by retained  -- e.g. LIST/L=1:10 vdsg[GT=new_tax]
	   IF (idim.EQ.e_dim .OR. idim.EQ.orientation) THEN
	      CONTINUE
!	      cx_lo_ss(cx,idim) = 1
!	      cx_hi_ss(cx,idim) = line_dim(axis)
	   ELSE
	      cx_by_ss(idim,cx) = .TRUE.
	      cx_lo_ss(cx,idim) = unspecified_int4
	      cx_hi_ss(cx,idim) = unspecified_int4
	      cx_lo_ww(idim,cx) = unspecified_val8  ! unnecessary?
	      cx_hi_ww(idim,cx) = unspecified_val8  ! unnecessary?
	   ENDIF
	ENDIF
! DSGTBD need to test a variety of target grids - suitable and unsuitable
* *** DSG grid end


* For setting the calendar information
 1000	   is_time = idim.EQ.t_dim .OR. idim.EQ.f_dim

* check for special actions needed on user-defined variables
* ( e.g. how to handle U[K=5] - U[K=1:10] )
	IF ( cat .EQ. cat_user_var ) THEN
	   lim_redundant = uvar_given( idim, var ) .LE. uvlim_gvn_xact
     .		     .OR.  uvar_given( idim, var ) .EQ. uvlim_irrelevant
     .		     .OR.  uvar_given( idim, var ) .EQ. uvlim_hidden
	ELSE
	   lim_redundant = .FALSE.
	ENDIF

* for modulo regridding the apparent limits supplied in the definition
* are "swallowed" up by the regridding process. Externally applied limits
* **should** be applied (e.g. A[GT=climatology@MOD,L=1:3] where A=SST[L=lo:hi])
	IF ( .NOT.INHERITED_LIMITS(idim,cx) )  lim_redundant = .FALSE.

	abst_nolim = .FALSE.
	IF ( line_name(axis) .EQ. 'ABSTRACT' .AND. var.LE.max_uvar) THEN
	   abst_nolim = ( cx_trans(idim,cx) .NE. trans_no_transform
     .    .AND. uvar_given(idim,var) .EQ. uvlim_irrelevant ) 
             IF ( cx_trans(idim,cx) .NE.  trans_variance .AND.
     .            cx_trans(idim,cx) .NE.  trans_shift .AND.
     .            cx_trans(idim,cx) .NE.  trans_deriv_cntr .AND.
     .            cx_trans(idim,cx) .NE.  trans_deriv_fwrd .AND.
     .            cx_trans(idim,cx) .NE.  trans_deriv_bkwd .AND.
     .            cx_trans(idim,cx) .NE.  trans_integ_def .AND.
     .            cx_trans(idim,cx) .NE.  trans_integ_indef .AND.
     .            cx_trans(idim,cx) .NE.  trans_locate .AND.
     .            cx_trans(idim,cx) .NE.  trans_wgted_eq .AND.
     .            cx_trans(idim,cx) .NE.  trans_nrst_dist_abv .AND.
     .            cx_trans(idim,cx) .NE.  trans_nrst_dist_blw .AND.
     .            cx_trans(idim,cx) .NE.  trans_nrst_indx_abv .AND.
     .            cx_trans(idim,cx) .NE.  trans_nrst_indx_blw .AND. 
     .            cx_trans(idim,cx) .NE.  trans_event_mask .AND.
     .            cx_trans(idim,cx) .NE.  trans_std_dev .AND.
     .            cx_trans(idim,cx) .NE.  trans_avg_wgt) abst_nolim = .FALSE.

	ENDIF

	IF ( axis .EQ. mnormal ) THEN
* THIS AXIS IS NORMAL TO THE DEFINING GRID
* wipe clean any stray information about it
	   cx_lo_ss( cx, idim ) = unspecified_int4
	   cx_hi_ss( cx, idim ) = unspecified_int4
	   cx_lo_ww( idim, cx ) = unspecified_val8
	   cx_hi_ww( idim, cx ) = unspecified_val8
	   cx_delta( idim, cx ) = unspecified_val8
	   cx_trans( idim, cx ) = trans_no_transform
* kob 9/97 - need to reset cx_calendar as well

	   IF (is_time) cx_calendar(idim,cx) = .FALSE.

* axes with fully "given" regions will have their regions determined via
* MERGE_CONTEXT (when computed) or PASS_AMBIG_LIMS (when found in memory)
* 5/99 - added ".AND. axis .LT. max_lines" -- we will go ahead with
* fleshing out implicit axes (e.g. a[i=10:100:10])
* to improve the cache hit rate when netCDF strides are used. Note the peril
* in this is the behavior of a[i=3:5] where a=b[i=10:100:10]
* 4/00: use line_class instead of max_lines as the test
	ELSEIF ( .NOT.cx_given(idim,cx) .AND. lim_redundant )  THEN
*
* 11/2018 acm: for issue 965, remove this part of the test 
* .		.AND. line_class(axis) .NE. pline_class_stride ) THEN

!pre 4/00     .		.AND. axis .LT. max_lines ) THEN

****
* 7/92 kludge:
* NOTE (4/01): logical variable in_get_grid_mode would be a more reliable soln
* This routine is called by is_uvar_grid (while determining the grid)
* BEFORE uvar_given has been determined.  When called from there lim_redundant
* may be invalid.  Since uvar_given is initialized to uvlim_irrelevant we will
* use this as value a test of whether the call is from is_uvar_grid
* Probably it would be better to make this check while determining
* lim_redundant, above, but that would be a more significant alteration of
* working code - so this is the chicken-out solution
* WAS:	   IF ( cx_trans(idim,cx) .NE. trans_no_transform ) GOTO 5000

* 1/97 - might this kludge have been rendered unnecessary by the 1/97 change to
*        the determination of lim_redundant??
****
          IF ( cx_trans(idim,cx)    .NE. trans_no_transform
     .    .AND. uvar_given(idim,var) .NE. uvlim_irrelevant ) GOTO 5000

****
	   cx_lo_ss( cx, idim ) = unspecified_int4
	   cx_hi_ss( cx, idim ) = unspecified_int4
	   cx_lo_ww( idim, cx ) = unspecified_val8
	   cx_hi_ww( idim, cx ) = unspecified_val8
	   cx_delta( idim, cx ) = unspecified_val8
* kob 9/97 - need to reset cx_calendar as well
	   IF (is_time) THEN
              cx_calendar(idim,cx) = .FALSE.
              cx_cal_id(cx) = unspecified_int4
           ENDIF

	ELSEIF ( cx_by_ss( idim, cx )) THEN!   .AND. .NOT.abst_nolim
* POSITIONS WERE SPECIFIED BY SUBSCRIPT
* is there valid position data for this axis ?
	   IF ( cx_lo_ss( cx, idim ) .EQ. unspecified_int4 ) THEN
* ... no position data but maybe it's a file variable with only 1 point
	      CALL VAR_SS_LIMS( idim, cx, lo_ss, hi_ss )
! old	      IF ( lo_ss.EQ.unspecified_int4 .OR. lo_ss.NE.hi_ss ) RETURN
	      IF ( lo_ss.EQ.unspecified_int4 ) RETURN
	      cx_lo_ss(cx,idim) = lo_ss
	      cx_hi_ss(cx,idim) = hi_ss
	    ENDIF

* if strides in use then set the upper subscript to correct parity
	    IF (cx_delta(idim,cx) .NE. unspecified_val8) THEN
	      IF (cx_delta(idim,cx) .LE. 0.) GOTO 5300
	      ispread = cx_hi_ss(cx,idim) - cx_lo_ss(cx,idim)
	      ispread = (ispread/NINT(cx_delta(idim,cx)))
     .		      * NINT(cx_delta(idim,cx))
	      cx_hi_ss(cx,idim) = cx_lo_ss(cx,idim) + ispread
	    ENDIF

* compute world positions as grid box edges
	   cx_lo_ww(idim, cx) = TM_WORLD( cx_lo_ss( cx,idim),
     .					  grid, idim, box_lo_lim )
	   cx_hi_ww(idim, cx) = TM_WORLD( cx_hi_ss( cx,idim),
     .					  grid, idim, box_hi_lim )

	   IF ( is_time .AND. cx_calendar(idim,cx) ) THEN
             cal_id = TM_GET_CALENDAR_ID (line_cal_name(axis))
             cx_cal_id(cx) = cal_id
           ENDIF


	ELSEIF ( cx_aux_stat( idim, cx ) .EQ. paux_stat_false_1pt_regrid
     .	   .AND. cx_unstand_grid( cx		)	             ) THEN
* 4/14 - WORLD COORDINATES ON A CURVILINEAR OR LAYERZ AXIS
	      cx_lo_ss(cx,idim) = unspecified_int4
	      cx_hi_ss(cx,idim) = unspecified_int4
*  leave ww limits as-is. Values refer to the aux var range, not the native axis 
	        CONTINUE

	ELSE
* WORLD COORDINATE POSITIONS
* is there valid position data for this axis ?
	   IF ( cx_lo_ww( idim, cx ) .EQ. unspecified_val8 ) THEN
* ... no position data but maybe it's a file variable with only 1 point
	      CALL VAR_SS_LIMS( idim, cx, lo_ss, hi_ss )
! old	      IF ( lo_ss.EQ.unspecified_int4 .OR. lo_ss.NE.hi_ss ) RETURN
	      IF ( lo_ss.EQ.unspecified_int4 ) RETURN
	      cx_lo_ss(cx,idim) = lo_ss
	      cx_hi_ss(cx,idim) = hi_ss
* ... compute world positions as grid box edges
	      cx_lo_ww(idim, cx) = TM_WORLD( lo_ss, grid, idim, box_lo_lim )
	      cx_hi_ww(idim, cx) = TM_WORLD( hi_ss, grid, idim, box_hi_lim )
	   ENDIF

	   point = cx_lo_ww(idim,cx) .EQ. cx_hi_ww(idim,cx)

* convert times given as seconds from BC to time step values
* *kob* 8/97 - use cx_calender instead of cx_lo_ww

	   IF ( is_time .AND. cx_calendar(idim,cx) ) THEN
             cal_id = TM_GET_CALENDAR_ID (line_cal_name(axis))
             IF ( TM_DATE_OK( line_t0(axis), cal_id ) ) THEN
	         cx_lo_ww(idim,cx) =
     .                SECS_TO_TSTEP( grid, idim, -cx_lo_ww(idim,cx) )
	         cx_hi_ww(idim,cx) =
     .                SECS_TO_TSTEP( grid, idim, -cx_hi_ww(idim,cx) )
		 cx_calendar(idim,cx) = .FALSE.
                 cx_cal_id(cx) = cal_id
              ENDIF
	   ENDIF
	      
* world coordinate is a single point
	   IF ( point ) THEN
	      ww_given = cx_lo_ww(idim,cx)
	      ss = ISUBSCR_CX(ww_given,grid,idim,cx,round_dn)
	      ww_nrst = TM_WORLD( ss, grid, idim, box_middle )
	      CALL GRID_SUBSCRIPT_EXTREMES( lo_ss, hi_ss, grid, idim )
! ???	      CALL VAR_SS_LIMS( idim, cx, lo_ss, hi_ss )
* ... need to interpolate ? 
* Note: changed to TM_FPEQ(SNGL(xxx),...) 1/94  - testing indicates that
*		double precision time ranges are nexer used at this point
#ifdef double_p
	      IF (  mode_interpolate
     .	     .AND. .NOT.TM_FPEQ((ww_given),(ww_nrst)) ) THEN
#else
	      IF (  mode_interpolate
     .	     .AND. .NOT.TM_FPEQ(SNGL(ww_given),SNGL(ww_nrst)) ) THEN
#endif
* ... set up context to interpolate
	         IF ( cx_trans(idim,cx) .NE. trans_no_transform
     .		.AND. cx_trans(idim,cx) .NE. trans_interpolate ) GOTO 5200
	         cx_trans(idim,cx) = trans_interpolate
	      ELSEIF ( cx_trans(idim,cx) .EQ. trans_no_transform ) THEN
* ... interpolation not desired, needed or possible
	         cx_lo_ww(idim,cx) = ww_nrst
	         cx_hi_ww(idim,cx) = ww_nrst
	         cx_lo_ss(cx,idim) = ss
	         cx_hi_ss(cx,idim) = ss
	      ELSE 
* ... keep original (exact) limits if transformed axis ! 8/92
	         cx_lo_ss(cx,idim) = ss
	         cx_hi_ss(cx,idim) = ss
	      ENDIF
	   ELSE

* world coordinates span a range
* ... compute subscripts ( rounding inward to resolve ambiguities )
	      cx_lo_ss( cx, idim ) = ISUBSCR_CX
     .				(cx_lo_ww(idim, cx), grid, idim, cx,round_up)
	      cx_hi_ss( cx, idim ) = ISUBSCR_CX 
     .				(cx_hi_ww(idim, cx), grid, idim, cx,round_dn)
	   ENDIF
	ENDIF

* TRANSFORMATION REDUCES RANGE TO A POINT ?
	IF ( cx_trans(idim,cx) .GT. trans_compress_code ) THEN
	   cx_lo_ss( cx, idim ) = unspecified_int4
	   cx_hi_ss( cx, idim ) = unspecified_int4
	   cx_by_ss( idim, cx ) = .FALSE.
	ENDIF

 4000   CONTINUE

* successful completion
	RETURN

* error exits
 5000	RETURN

 5200	string = VAR_CODE( cx_category(cx), cx_variable(cx) )
	CALL ERRMSG( ferr_trans_nest, status,
     .		'cannot perform interpolation '//pCR//
     .		ww_dim_name(idim)//' axis of '//string(:TM_LENSTR1(string))//
     .		' is already transformed'//pCR//
     .		'Can you define an intermediate variable ?',
     .		*5000 )
 5300	CALL ERRMSG( ferr_invalid_command, status,
     .		'delta non-positive on '//ww_dim_name(idim)
     .		//' axis of '//VAR_CODE(cx_category(cx),cx_variable(cx)),
     .						*5000)

	END

	SUBROUTINE CONST_VAR_CONTEXT
     .		      ( text,
     .			uvar,
     .			item, 
     .			default_cx,
     .			const_cx,
     .			status )

* return in const_cx context information describing the constant array

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V5.00: 12/18/98 - based on CONSTANT_CONTEXT	
*	 2/99 *sh* - bug fix on cx_given for normal axes
* V530:  8/00 *sh* - allow constant arrays of strings
* V533:  7/01 *sh* - allow single quoted strings
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V693+ *sh* 2/15 - added support for quotation with _DQ_ and _SQ_

	include	'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include	'xalgebra.cmn'
	include 'xfr_grid.cmn'

* calling argument declarations:
	INTEGER		uvar, item, default_cx, const_cx, status
	CHARACTER*(*)	text

* internal variable declarations:
	INTEGER		idim

* initialize
	CALL TRANSFER_CONTEXT ( default_cx, const_cx )
	cx_category( const_cx ) = cat_const_var
	cx_bad_data( const_cx ) = bad_val4
	cx_data_set( const_cx ) = pdset_irrelevant
	cx_dset_gvn( const_cx ) = .TRUE.
	cx_variable( const_cx ) = 1000*uvar + item     ! packed info
	cx_grid    ( const_cx ) = mgrid_xabstract

* identify a constant array of strings by the presence of a quotation mark
	IF ( INDEX(text,'"')    .GT. 0
     .	.OR. INDEX(text,"'")    .GT. 0 
     .	.OR. INDEX(text,"_DQ_") .GT. 0 
     .	.OR. INDEX(text,"_SQ_") .GT. 0 ) THEN
	   cx_type(const_cx) = ptype_string
	ELSE
	   cx_type(const_cx) = ptype_float
	ENDIF

* definition applies only to the axis of the constant list
	cx_given( x_dim, const_cx ) = .TRUE.
	DO 100 idim =  y_dim, nferdims
 100	cx_given( idim, const_cx ) = .FALSE.

* remove all axes limits
	DO 200 idim = y_dim, nferdims
 200	CALL DEL_CX_DIM( idim, const_cx )

* set the X axis limits equal to the length of the array
	cx_lo_ss(const_cx, x_dim) = 1
	CALL COUNT_NUMBER_LIST(text, cx_hi_ss(const_cx,x_dim) )
	cx_by_ss(x_dim,const_cx) = .TRUE.
	CALL FLESH_OUT_AXIS(x_dim, const_cx, status)

	RETURN

!* error exit
! 5000	RETURN
! 5100	CALL ERRMSG( ferr_syntax, status, const_text, *5000 )
	END

	SUBROUTINE NAME_EQUAL_STRING_LC(nambuff, start_pos, status)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* decode "NAME = expression" on a command line
* Leaving the output in the original upper- or lower-case spelling.

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* 
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'

* calling argument declarations:
	INTEGER		start_pos, status
	CHARACTER*(*) nambuff

* local variable declarations:
	INTEGER pos, i1

	CHARACTER*1 tab
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
#else
	PARAMETER     ( tab = CHAR(9))
#endif

* find name to define
* 2 syntaxes are allowed: "DEFINE VAR NAME=TEXT", "DEFINE VAR NAME TEXT"
* in the latter be careful that "TEXT" may contain "="
	pos = INDEX(cmnd_buff(arg_start(1):len_cmnd), '=')
* ... is it a legit = sign or one used within [] further on in expression ?
	IF ( num_args .GT. 1 ) THEN
	   IF ( pos+arg_start(1)-1 .GT. arg_start(2) ) pos = 0
	ENDIF
	IF ( pos .EQ. 0 ) THEN
* ... no "=" separator
	   nambuff = cmnd_buff( arg_start(1):arg_end(1) )
	   IF ( num_args .LT. 2 ) GOTO 400
	   pos = arg_start(2)
	ELSE
* ... yes "=" separator
	   pos = pos + arg_start(1)	! character after "="
*    ... hunt backwards for end of variable name
	   nambuff = '(none)'
	   DO 101 i1 = pos-2, arg_start(1), -1
	      IF ( cmnd_buff(i1:i1).EQ.' '
     .	      .OR. cmnd_buff(i1:i1).EQ.tab ) THEN
	         CONTINUE
	      ELSE
	         GOTO 102
	      ENDIF
 101	   CONTINUE
	   GOTO 5100
 102	   nambuff = cmnd_buff( arg_start(1):i1 )
*    ... find next non-blank, non-tab after "=" -- start of expression
	   DO 105 pos = pos, len_cmnd
	      IF ( cmnd_buff(pos:pos) .NE. ' ' 
     .	     .AND. cmnd_buff(pos:pos) .NE. tab  ) GOTO 106
 105	   CONTINUE
	   GOTO 400	! no text following equal sign
 106	   CONTINUE
	ENDIF
	GOTO 500

* no text follows the name -- this is just a name.
 400	start_pos = 0
	GOTO 1000

* save starting position of the text
 500	start_pos = pos

* success
 1000	status = ferr_ok
	RETURN

* error exit
 5000	RETURN
 5100 	CALL ERRMSG( ferr_syntax, status,
     .			cmnd_buff(:len_cmnd)//' ???', *5000 )


	END

	SUBROUTINE DE_ESCAPE_STRING ( string, slen )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* remove one set of backslash-escapes from a string thereby "exposing" the
* chat=racter that follows each backslash

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 4/4/86
* Unix/RISC port - 2/13/91 - .AND. always produces a logical result

* V510: 3/00 *sh*

        IMPLICIT NONE
* calling argument declarations
	CHARACTER string*(*)

* internal variable declarations
	INTEGER	TM_LENSTR1, slen, iin, iout

! initialize
	slen = TM_LENSTR1(string)
	iin = 1
	iout = iin

! a DO-WHILE loop
 10	IF ( iin .GT. slen ) GOTO 50

!    ... do not copy a slash -- but always copy the character that follows it
#ifdef NO_DOUBLE_ESCAPE_SLASH
        IF (string(iin:iin) .EQ. '\' ) iin = iin + 1
#else
        IF (string(iin:iin) .EQ. '\\') iin = iin + 1
#endif
	
	IF ( iin .LE. slen ) THEN
	   string(iout:iout) = string(iin:iin)
	   iin = iin + 1
	   iout = iout + 1
	   GOTO 10
	ENDIF

!   blank out any remaining characters
 50	DO 100 iin = iout, slen
 100	string(iin:iin) = " " 
	slen = MAX(iout-1, 1)	! new string length
	RETURN

	END

	SUBROUTINE START_PPLUS

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* initialize Denbo's PPLUS program which is imbedded within this program

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 1/29/87 
* revision 0.1 - 6/3/87  - added color definitions
* revision 0.2 - 7/28/87 - added INQUIRE to see if wkstn. has colors
* revision 1.0 - 6/29/88 - removed color definitions to DEFINE_COLORS
*			   removed mode determination to INITIALIZE
* revision 1.1 - 8/11/88 - added GKS deferral state call
* revision 1.2 - 8/16/88 - added GKS_WINDOWS to allow FERRET on BETA
*			   removed GKS deferral state call
* revision 1.3 - 8/26/88 - added PPL SIZE (9,10) to initialize
*			   since the SIZE command is removed from DISP_INIT
* revision 1.4 - 9/8/88  - initialize PPLUS with PPL_in_FERRET
*			 - add EXTERNALS to force loads from FERRET library
*			   instead of PPLUS library
* revision 1.5 - 4/1/89  - transfer MODE WAIT directly to PPLUS variable deflts
* V200:  12/6/89 - GKS state determined by mode_GKS, color setup removed
*	 9/19/90 - warning message when GKS mode is cancelled
* Ultrix/RISC port - commented out GKSFORBND.DEF include: not used
* V300:  3/11/93 - sets a default color spectrum
* V301:	 11/3/93 - calls SET_VIEWPORT to define VP_WIDTH and VP_height symbols
*	 1/24/94 - turn on metafiles in DISP_INIT instead of here
*	           (resolve problem of metafiles created with wrong name)
* V450:  TEMPORARY EXPERIMENTAL change to test metafile-only output
* V450:  3/4/97 - Mod to support metafile-only (no X) output through a
*		cuckoo's egg implantation of meta_wsid in place of wsid
* V610 *acm* 3/08 - add new MODE NLEVELS; Store the setting for the default
*                   number of contour/fill levels.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V6.8 *acm* 7/9/2012 For batch graphics on RHEL6, change ITS_BATCH_GRAPHICS
*                     from logical to integer, then batch = ITS_BATCH_GRAPHICS().NE.0

	include 'tmap_dims.parm'
	include 'plot_setup.parm'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'
	include 'xgks_devices.cmn'
	include	'system_inc.decl'	! with echof
	include	'SYSTEM.INC'	! with echof
	include	'plt_inc.decl'	! with icode
	include	'PLT.INC'	! with icode
	include	'gkscm1_inc.decl'	! with wsid
	include	'GKSCM1.INC'	! with wsid
	include	'switch_inc.decl'	! with deflts
	include	'SWITCH.INC'	! with deflts
	include	'pltcom_dat.decl'	! with gksopn
	include	'PLTCOM.DAT'	! with gksopn
	include	'ppl_in_ferret.cmn'	! with ppl_in_ferret
!	include	'gksdefs.bnd'		! gks parameters
        INCLUDE 'lunits_inc.decl'   ! std err unit number
	INCLUDE 'LUNITS.INC'
	
* internal parameter declarations:
	CHARACTER	dummy_filename*1
	PARAMETER     ( dummy_filename	  = ' ' )

* internal variable declarations
	LOGICAL		batch
	INTEGER		ITS_BATCH_GRAPHICS

* external declarations to force loading of modules used by PPLUS
	EXTERNAL	GET_VP_FROM_FERRET, CLEAR_VP, INTERRUPT,
     .			SEG_ON, SEG_OFF

* still need to cold-start graphics ?
	IF ( pplus_started ) RETURN

* are we in no-X mode?
	batch = ITS_BATCH_GRAPHICS().NE.0

* tell PPLUS that it is under FERRET control without viewports
	PPL_in_FERRET = .TRUE.
	PPL_viewports_active = .FALSE.

* Give PPLUS the unit number for std error, to write error messages

        lerror = err_lun

* set PPLUS /WAIT vs /NOWAIT mode directly from FERRET mode
	deflts(5) = mode_wait	! sets swait default

* tailor output graphics device to environment
	IF ( mode_gks ) THEN
!	   icode = 3		! PLTYPE 3 (GKS)
	   icode = 1		! PLTYPE 3 WS=... is done below
	ELSEIF ( .NOT.interactive ) THEN
	   icode = 0		! PLTYPE 0 (PPLUS metafile)
	ELSE
	   icode = 1		! PLTYPE 1 (Tek terminal)
	   CALL WARN('MODE GKS is disabled.')
	   CALL WARN('Some graphics functionality will not be available.')
	ENDIF

* open PLOT5
	CALL OPNPPL ( dummy_filename,41,42,43,44,ttout_lun,45,46,47,48 )
	echof = .FALSE.
	pplus_started = .TRUE.

* define plot size
	CALL COLOR(1)
	CALL DISP_RESET

* set correct plot device (e.g. "PLTYPE 3 WS=VSII" )
	IF ( batch ) THEN
	   IF ( mode_gks ) CALL SEND_PLTYPE(.TRUE.)
	ELSE
	   IF ( mode_gks ) CALL SEND_PLTYPE(.FALSE.) ! 1/94 was "mode_metafile"
	ENDIF

	IF ( .NOT.gksopn ) RETURN	! flag was set by PPLUS

* start GKS on FERRET side
	wn_open( wsid )   = .TRUE.
	wn_active( wsid ) = .TRUE.
!	wn_open( 1 )   = .TRUE.	! note that wsid only HAPPENS TO BE the
!	wn_active( 1 ) = .TRUE. ! transformation number

!	CALL DEFINE_COLORS( wsid )

* set up the default spectrum
        CALL PPL_SHASET( 'SPECTRUM=default' )

* Set default (initial) number of color levels

        CALL SET_DEFAULT_NLEVELS( mode_arg(pmode_nlevels, 1) )

* set up axis lengths and PLOT+ symbols
	CALL SET_VIEWPORT( mvp_dflt )

* set GKS to regenerate whenever workstation viewport is modified - avoids
*  bug interaction with segments when the first plot is done directly via PPLUS
*  note: subsequent windows will still have their deferral states at default
*	 but no problems are caused by that because FERRET and PPLUS agree on
*	 the window viewport coordinates (see PPLUS SIZE2)
!	CALL GSDS( wsid, gasap, gallow )
! further bug - repeated SET WINDOW/SIZE=x for same x cause segment to go
! invisible
	RETURN
	END

	SUBROUTINE GRID_WORLD_EXTREMES ( lo, hi, grid, idim )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* find the extreme bounds of the indicated grid on the indicated axis
* in WORLD coordinates
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 10/16/86
* revision 1.0 - 3/10/87  - changed to axis data stored in COMMON/~VARIABLES/
*			    and changed time axis dependence
* revision 1.1 - 2/18/88  - incorporated "regular" axes
* revision 1.2 - 20/12/88 - incorporated new TM IO library (no box sizes)
* revision 1.3 - 2/6/89   - added modulo axes of arbitrary length
* Unix/RISC port - 7/91   - eliminated unneeded *variables common
* V4.20 - 10/95 - remove references to line_mem to permit recursive line defs
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
* V72   11/16 *acm* Ticket 2158: working with true monthly time axes.

	include 'tmap_dims.parm'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'

* calling argument declarations
	INTEGER	grid, idim
	REAL*8	lo,hi

* local variable declarations
	LOGICAL ITSA_TRUEMONTH_AXIS
	INTEGER line_num, line_len
	REAL*8	TM_WORLD

	line_num = grid_line( idim, grid )
	line_len = line_dim( line_num )

	IF     ( line_num .EQ. mnormal  ) THEN

	   lo = unspecified_val8
	   hi = unspecified_val8

	ELSEIF ( line_num .EQ. munknown ) THEN

	   lo = arbitrary_small_val8
	   hi = arbitrary_large_val8

	ELSEIF ( line_modulo(line_num) ) THEN

	   lo = arbitrary_small_val8
	   hi = arbitrary_large_val8

	ELSE

	   IF ( line_regular( line_num ) .AND. .NOT.ITSA_TRUEMONTH_AXIS (line_num)) THEN
	      lo = line_start( line_num ) - line_delta( line_num )/2.
	      hi = lo + line_delta( line_num ) * line_dim( line_num )

	   ELSE
* ... lo limit of bottom box; hi limit of top box
	      lo = TM_WORLD(       1, grid, idim, box_lo_lim)
	      hi = TM_WORLD(line_len, grid, idim, box_hi_lim)

	   ENDIF

	ENDIF

	RETURN
	END

	SUBROUTINE COUNT_NUMBER_LIST( string, n )


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* count the number of values in a list of the form "{ 1, 3,5,7, 9}"

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V500: *sh* 12/98
* V510: *sh* 10/99 bug fix: single character {3} gave n=0
* V530:  8/00 *sh* - added support for arrays of strings
* V530:  7/01 *sh* - allow single quoted strings
* V540:  9/01 *sh* - change "SYSTEM:" to "SPAWN:"
*       *acm* 3/12   add disclaimer
* V693+ *sh* 2/15 - add support for _DQ_ and _SQ_ quotations

        IMPLICIT NONE
* calling argument declarations
	INTEGER		n
	CHARACTER*(*)	string

* internal variable declarations
	LOGICAL		in_quote, no_chars_yet,
     .			doub_quote, sing_quote, DQ_quote, SQ_quote,
     .			doub_atom,  sing_atom,  DQ_atom,  SQ_atom
	INTEGER 	TM_LENSTR1, STR_CASE_BLIND_COMPARE,
     .			i, start, slen, vax_code
	CHARACTER*1	c

!* internal parameter declarations
!	CHARACTER*1     tab
!	PARAMETER     ( tab = CHAR(9) )

	include 'ferret.parm'
	include 'errmsg.parm'
	include 'gfdl_vms.parm'

* initialize
	n = 1
	slen = TM_LENSTR1( string )
	start = 1
	no_chars_yet = .TRUE.
	doub_quote = .FALSE.
	sing_quote = .FALSE.
	DQ_quote   = .FALSE.
	SQ_quote   = .FALSE.

* trim around the enclosing "{}" brackets
	IF ( string(slen:slen) .EQ. '}' ) slen = slen - 1
	IF ( string (1:1) .EQ. '{' ) start = start + 1
	IF (start .GT. slen) RETURN 

* loop through the text counting commas
* (poor man's FORTRAN DO-WHILE loop)
	in_quote = .FALSE.
	i = start - 1
 100	i = i + 1
	   c = string(i:i)

* ... identify quotation atoms
	   doub_atom = c.EQ.'"'
	   sing_atom = c.EQ."'"
	   IF (i+3 .LE. slen) THEN
	      DQ_atom = string(i:i+3) .EQ. "_DQ_"
	      SQ_atom = string(i:i+3) .EQ. "_SQ_"
	   ELSE
	      DQ_atom = .FALSE.
	      SQ_atom = .FALSE.
	   ENDIF

	   IF (in_quote) THEN

#ifdef NO_DOUBLE_ESCAPE_SLASH
              IF (c .EQ. '\') THEN  ! ' char for emacs
#else
              IF (c .EQ. '\\') THEN
#endif
	         i = i + 1   ! skip processing of next character 
	      ELSEIF  (     doub_quote .AND. doub_atom
     .	               .OR. sing_quote .AND. sing_atom 
     .	               .OR. DQ_quote   .AND. DQ_atom 
     .	               .OR. SQ_quote   .AND. SQ_atom ) THEN
	         in_quote   = .FALSE.
	         doub_quote = .FALSE.
	         sing_quote = .FALSE.
	         DQ_quote   = .FALSE.
	         SQ_quote   = .FALSE.
	      ELSE
	         CONTINUE   ! skip over anything inside of quotations
	      ENDIF
	   ELSEIF (doub_atom) THEN
	      in_quote   = .TRUE.
	      doub_quote = .TRUE.
	   ELSEIF (sing_atom) THEN
	      in_quote   = .TRUE.
	      sing_quote = .TRUE.
	   ELSEIF (DQ_atom  ) THEN
	      in_quote   = .TRUE.
	      DQ_quote   = .TRUE.
	   ELSEIF (SQ_atom  ) THEN
	      in_quote   = .TRUE.
	      SQ_quote   = .TRUE.
	   ELSEIF (c .EQ. ',') THEN
	      n = n+1
	   ELSEIF (c.EQ.'s' .OR. c.EQ.'S' ) THEN
	      IF ( i+7 .GT. slen ) CONTINUE  ! trap syntax error later
	      vax_code = STR_CASE_BLIND_COMPARE(string(i:i+5), 'SPAWN:')
	      IF( vax_code .NE. vms_str_success ) CONTINUE ! trap syntax later
	      i = i + 5
	      n = n + 2000 - 1   ! allow default memory for 2000 strings 
	   ELSE
	      CONTINUE   ! ignore the text, itself
	   ENDIF
!	   IF (no_chars_yet) THEN
!	      IF (c .NE. ','
!     .	    .AND. c .NE. ' '
!     .	    .AND. c .NE. tab ) no_chars_yet = .FALSE.
!	   ENDIF
	IF ( i .LT. slen ) GOTO 100

!* if there were any digits at all then the count of numbers is the
!* count of commas plus 1
!	IF (.NOT.no_chars_yet) n = n + 1

* success
	RETURN

	END

	SUBROUTINE IS_ATTRIB_VAL(  *, *, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*

* create a string or float abstract array containing attribute values,
* including pseudo-names for global attributes ..nvars, ..ngatts, ..ndims, 
* ..varnames, ..gattnames, and
* varname.natts, varname.natts, varname.attnames

* return in att_cx context information describing the array of attribute values
* (based on is_constant_var.F)
* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP

* V600 8/18/05
* V600  4/06 *acm* - additional declarations found by Solaris compiler
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V694  1/15 *acm* as part of changes for ticket 2227 (handling of dimensions
*                  that are not also 1-D coordinate variables), when returning 
*                  ..dimnames, now list of all dimensions in the dataset.
* V698 *acm* 1/16 Allow for Epic CDF files, ds_type = 'ECDF'
* v698 5/16  *acm* ticket 2413: New attribute keywords ncoordvars, coordnames
*                  return info about coordinate-variables in datasets
* V710 9/16  *acm* ticket 2465: Parsing expressions including attribute references.
* 712 2/17 *sh* fix latent bug when shifting an array of attribute values

        include 'tmap_dims.parm'
#       include "tmap_dset.parm"
        include 'xdset_info.cmn_text'
#include "netcdf.inc"
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xvariables.cmn'
	include	'xcontext.cmn'
	include	'xprog_state.cmn'

* calling argument declarations:
	INTEGER	status

* internal variable declarations:
        CHARACTER*512 varname, name
        CHARACTER*128 attname, dname, aname
        CHARACTER*128 err_string
        LOGICAL coordvar, do_err, got_it
	INTEGER	CGRID_SIZE, STR_SAME, TM_LENSTR1,
     .		mr, cx, size, uvar, n, dset, 
     .          varid, attype, attlen, ndims, nvars, 
     .          ngatts, recdim, ivar, vartype, nvdims,
     .          vdims(8), dsdims(200), iatt, nvatts, idim, nd, vd, na,
     .          attoutflag, all_outflag, xdim, i1, i2, slen,
     .          i, indx, nv, dot, cat, attid, npts, dimid, nddims, 
     .          iitem, start, end, wk_buff

	INTEGER*8 n8

* --- end of introductory code ---
* initialize

	cx = is_cx( isp )
	size = CGRID_SIZE(cx)
	dset = cx_data_set( cx )
        xdim = 1
        i1 = cx_lo_ss(cx,xdim)
        i2 = cx_hi_ss(cx,xdim)
        got_it = .FALSE.

        IF (i2 .LT. i1) GOTO 5100
        
        IF (dset .LT. pdset_uvars .OR. (.NOT.cx_dset_gvn(cx) )) 
     .      dset = cx_data_set( is_cx(isp-1) )

        CALL CD_GET_DS_INFO (dset, nddims, nvars, ngatts, 
     .               recdim, status)
        DO 100 idim = 1, nddims
	   dsdims(idim) = idim
 100	CONTINUE

* reserve and catalog space for the result

	CALL CREATE_TEMP_MEM_VAR( cx, mr, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* diagnostic output
	IF (mode_diagnostic) 
     .      CALL DIAGNOSTIC_OUT ('attrib_val',mr,point_to_mr)

* parse and insert the constant array

	uvar = cx_variable(cx)

! See if this is a user variable and set dataset number accordingly

        dot = INDEX(uvar_text(uvar),'.')
        IF (dot .GT. 0) varname = uvar_text(uvar)(1:dot-1)
        CALL FIND_VAR_NAME(pdset_irrelevant, varname, cat, ivar)
        IF (  ivar .NE. munknown_var_name .AND.
     .         cat .EQ. cat_user_var) dset = pdset_uvars

* do_err: issue error message if attrib does not exist on varname.attname
        do_err = .TRUE. 
	
	iitem = 0
	DO i = 1, uvar_num_items(uvar)
 	   IF (dot .GE. uvar_item_start(i,uvar) .AND. 
     .         dot .LT. uvar_item_end(i,uvar)) iitem = i
	ENDDO
	
	start = 1
	end = TM_LENSTR1(uvar_text(uvar))
	IF (iitem .GT. 0) THEN
	   start = uvar_item_start(iitem,uvar)
	   end = uvar_item_end(iitem,uvar)
	ENDIF
        CALL BREAK_VARATTNAME ( uvar_text(uvar)(start:end), dset, varname, 
     .                          attname, varid, do_err, status )
 
        IF (STR_SAME (varname, '.') .EQ. 0) THEN

           CALL CD_GET_DS_INFO (dset, ndims, nvars, ngatts, 
     .               recdim, status)

           IF (STR_SAME(attname, 'varnames') .EQ. 0 ) THEN

* Get and store the variable names.

              n = i2 - i1 + 1
              CALL INIT_C_STRING_ARRAY( n,
     .				     memry(mr)%ptr,
     .				     mr_c_pointer(mr)    )
              n = 0
              nv = 0
              DO 120 i = 1, nvars
                 name = ' '
                 CALL CD_GET_VAR_INFO (dset, i, name, vartype,
     .                nvdims, vdims, nvatts, coordvar, all_outflag, 
     .                status)
                 IF (.NOT. coordvar) THEN
                    nv = nv + 1
                    IF (nv .GE. i1 .AND. nv .LE. i2) THEN
                       slen = TM_LENSTR1(name)
                       CALL STORE_STRING(name(1:slen), mr, n, status)
                       n = n + 1
                    ENDIF
                 ENDIF
 120          CONTINUE
              got_it = .TRUE.
	      
	     
* dimension names that are also coordinate variables
           ELSE IF (STR_SAME(attname, 'coordnames') .EQ. 0 ) THEN

              n = i2 - i1 + 1
              CALL INIT_C_STRING_ARRAY( n,
     .				     memry(mr)%ptr,
     .				     mr_c_pointer(mr)    )
              n = 0
              nv = 0
              DO 130 i = 1, nvars
                 name = ' '
                 CALL CD_GET_VAR_INFO (dset, i, name, vartype,
     .                nvdims, vdims, nvatts, coordvar, all_outflag, 
     .                status)
                 IF (coordvar) THEN
                    nv = nv + 1
                    IF (nv .GE. i1 .AND. nv .LE. i2) THEN
                       slen = TM_LENSTR1(name)
                       CALL STORE_STRING(name(1:slen), mr, n, status)
                       n = n + 1
                    ENDIF
                 ENDIF
 130          CONTINUE
              got_it = .TRUE.
 
           ELSE IF (STR_SAME(attname, 'dimnames') .EQ. 0 ) THEN
	   

* Get and store the dimension names.

              n = i2 - i1 + 1
	      CALL INIT_C_STRING_ARRAY( n,
     .				     memry(mr)%ptr,
     .				     mr_c_pointer(mr)    )
                IF (ds_type(dset).NE.'CDF' .AND. ds_type(dset).NE.'ECDF') GOTO 5200

* All the dimensions from the dataset

              n = 0
              nv = 0
              nvdims = nddims
	      
              DO 220 idim = 1, nvdims
                 name = ' '
		 CALL CD_GET_DS_DIMS (dset, dsdims(idim), name, npts, status)
		 nv = nv + 1
		 IF (nv .GE. i1 .AND. nv .LE. i2) THEN
                    slen = TM_LENSTR1(name)
                    CALL STORE_STRING(name(1:slen), mr, n, status)
                    n = n + 1
		 ENDIF
 220          CONTINUE
              got_it = .TRUE.
 
           ELSE IF (STR_SAME(attname, 'attnames') .EQ. 0 ) THEN
              IF (ngatts .GT. 0) THEN
                 CALL CD_GET_VAR_ID (dset, '.', varid, status)

	         CALL INIT_C_STRING_ARRAY( ngatts,
     .				     memry(mr)%ptr,
     .				     mr_c_pointer(mr)    )
                 n = 0
                 DO 300 iatt = i1, i2
                 CALL CD_GET_VAR_ATT_NAME (dset, varid, iatt, name, 
     .                    status)
                 slen = TM_LENSTR1(name)
                 CALL STORE_STRING(name(1:slen), mr, n, status)
                 n = n + 1
 300          CONTINUE
              ENDIF
              got_it = .TRUE.

           ELSE IF (STR_SAME(attname, 'ndims') .EQ. 0 ) THEN
              IF (ds_type(dset).NE.'CDF' .AND. ds_type(dset).NE.'ECDF') GOTO 5200

              memry(mr)%ptr(1) = ndims
              got_it = .TRUE.

           ELSE IF (STR_SAME(attname, 'nattrs') .EQ. 0 ) THEN
              memry(mr)%ptr(1) = ngatts
              got_it = .TRUE.

           ELSE IF (STR_SAME(attname, 'nvars') .EQ. 0 .OR.
     .              STR_SAME(attname, 'ncoordvars') .EQ. 0) THEN

* Count number of non-coordinate variables.
              n = 0
              DO 400 ivar = 1, nvars
                 CALL CD_GET_VAR_INFO (dset, ivar, name, vartype,
     .                nvdims, vdims, nvatts, coordvar, all_outflag, 
     .                status)
                 IF (.NOT. coordvar) n = n + 1
 400          CONTINUE
              IF (STR_SAME(attname, 'ncoordvars') .EQ. 0) n = nvars-n
              memry(mr)%ptr(1) = n
              got_it = .TRUE.
           ENDIF

* Is the user asking for the value of a global attribute?

           IF (got_it) GOTO 1000

           CALL CD_GET_VAR_ID (dset, '.', varid, status)

           DO 500 iatt = 1, ngatts
              CALL CD_GET_VAR_ATT_NAME (dset, varid, iatt, name, 
     .                    status)
              IF (STR_SAME(name, attname) .EQ. 0) THEN 

                 CALL CD_GET_VAR_ATT_INFO (dset, varid, iatt, 
     .                 name, attype, attlen, attoutflag, status )

	         IF ( attype .EQ. NCCHAR ) THEN

* ... set up FORTRAN-independent pointer

	            CALL INIT_C_STRING_ARRAY( 1,
     .				     memry(mr)%ptr,
     .				     mr_c_pointer(mr)    )

* ... string
	            CALL ATTRIB_STRING (cx, mr, dset, varid, 
     .			         varname, attname, status)
	         ELSE
* ... array of numbers
	            CALL ATTRIB_VALS (memry(mr)%ptr, 
     .                size, n, dset, varid, varname, attname, status)
	         ENDIF
                 IF ( status .NE. ferr_ok ) GOTO 5000
              ELSE

* If the attribute name is in quotes try to get it anyway, as a numeric or
* string attribute. Perhaps the user is looking for a file attribute named 
* the same as one of our pseudo-attribute names 
* (Logic for case-sensitive searching will go here...)

                 slen = TM_LENSTR1(attname)
                 IF (attname(1:1) .EQ. "'" .AND. 
     .               attname(slen:slen) .EQ. "'" ) THEN

	            CALL ATTRIB_VALS (memry(mr)%ptr, 
     .                 size, n, dset, varid, varname, attname, status)
                    IF (status .NE. ferr_ok ) CALL ATTRIB_STRING (cx, mr, 
     .	                      dset, varid,  varname, attname, status)
                 ENDIF

              ENDIF
 500          CONTINUE

        ELSE  ! variable name is not '.'

           CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid,
     .               status)
           IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, varid, 
     .        attid, aname, attype, attlen, attoutflag, status )

           IF (status .NE. ferr_ok) THEN

* See if it is a pseudo-attribute attnames, ndims, etc.
              CALL CD_GET_VAR_INFO (dset, varid, name, vartype,
     .                nvdims, vdims, nvatts, coordvar, all_outflag, 
     .                status)

              IF (STR_SAME(attname, 'attnames') .EQ. 0 ) THEN
                 IF (nvatts .GT. 0) THEN

	           CALL INIT_C_STRING_ARRAY( nvatts,
     .				     memry(mr)%ptr,
     .				     mr_c_pointer(mr)    )
                   n = 0
                   DO 600 iatt = i1, i2
                      CALL CD_GET_VAR_ATT_NAME (dset, varid, iatt, name, 
     .                    status)
                      slen = TM_LENSTR1(name)
                      CALL STORE_STRING(name(1:slen), mr, n, status)
                      n = n + 1
 600               CONTINUE
                ENDIF
                got_it = .TRUE.

             ELSE IF (STR_SAME(attname, 'dimnames') .EQ. 0 ) THEN

* Get the datset dimension names - not all dimensions are a coordinate variable.

                IF (nvdims .GT. 0) THEN

	           CALL INIT_C_STRING_ARRAY( nvdims,
     .				     memry(mr)%ptr,
     .				     mr_c_pointer(mr)    )
                IF (ds_type(dset).NE.'CDF' .AND. ds_type(dset).NE.'ECDF') GOTO 5200

                   n = 0
                   DO 700 idim = i1, i2
		      CALL CD_GET_DS_DIMS (dset, dsdims(vdims(idim)), 
     .				     dname, npts, status)
                      slen = TM_LENSTR1(dname)
                      CALL STORE_STRING(dname(1:slen), mr, n, status)
                      n = n + 1
 700               CONTINUE
                ENDIF
                got_it = .TRUE.

             ELSE IF (STR_SAME(attname, 'ndims') .EQ. 0 ) THEN
                IF (ds_type(dset).NE.'CDF' .AND. ds_type(dset).NE.'ECDF') GOTO 5200

                memry(mr)%ptr(1) = nvdims
                got_it = .TRUE.

             ELSE IF (STR_SAME(attname, 'nctype') .EQ. 0 ) THEN

                memry(mr)%ptr(1) = vartype
                got_it = .TRUE.

             ELSE IF (STR_SAME(attname, 'nattrs') .EQ. 0 ) THEN
                memry(mr)%ptr(1) = nvatts
                got_it = .TRUE.

             ENDIF
             IF (got_it) GOTO 1000

* If the attribute name is in quotes remove them. Perhaps the user
* is looking for a file attribute named the same as one of our pseudo-
* attribute names 
* (Logic for case-sensitive searching will go here...)

             slen = TM_LENSTR1(attname)
             IF (attname(1:1) .EQ. "'" .AND. attname(slen:slen) .EQ. "'" ) THEN
                attname = attname(2:slen-1)
                attname(slen-1:slen) = ""
             ENDIF

             CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid,
     .               status)
             IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, varid, 
     .          attid, aname, attype, attlen, attoutflag, status )

             IF (status .EQ. ferr_ok) GOTO 1000

           ELSE

* Is it a regular attribute from the file or a definition

 900	      IF ( attype .EQ. NCCHAR ) THEN
* ... set up FORTRAN-independent pointer
	         CALL INIT_C_STRING_ARRAY( 1,
     .				     memry(mr)%ptr,
     .				     mr_c_pointer(mr)    )

* ... string
	         CALL ATTRIB_STRING (cx, mr, dset, varid, varname, attname,
     .			          status)
	      ELSE
* ... array of numbers

* 2/17 - for a case like 
*	define att v.att = {1, 2, 3, 4, 5}
*	load v.att[i=3:5]
* the allocated memory will not be large enough to accommodate the full array
* of attribute values, so we need to allocate a work array
! since other calls are ignoring return status, we will, too ...
	         n8 = attlen
	         CALL CREATE_DYN_WRKSPC( n8, wk_buff, status )
	         CALL ATTRIB_VALS (workmem(wk_buff)%ptr, size, n, dset, 
     .                varid, varname, attname, status)
     
* ... left-shift the results to start a context low limit
                 indx = 0
                 DO 800 i = i1, i2
                    indx = indx + 1
                    memry(mr)%ptr(indx) = workmem(wk_buff)%ptr(i)
800              CONTINUE

	         CALL FREE_WS_DYNMEM( wk_buff )

	      ENDIF
	      IF ( status .NE. ferr_ok ) GOTO 5000
           ENDIF

        ENDIF
* result is ready to return to the stack
1000    CONTINUE
        is_mr( isp ) = mr
        mr_bad_data(mr) = cx_bad_data(cx)

* got the requested component
	RETURN 2

! RETURN 1, which is to request a sub-component, is never used ...

* error exit
 5000	RETURN
 5100   status = ferr_out_of_range
        err_string = "invalid dataset attribute index"
        CALL ERRMSG( status, status, err_string, *5000 )
 5200   status = ferr_invalid_command
        err_string = "implemented only for netCDF/OPeNDAP datasets"
        CALL ERRMSG( status, status, err_string, *5000 )
	END	

      SUBROUTINE CD_REPLACE_ATTR_DP (dset, varid, attname, attype, 
     .                            attlen, string, vals, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Replace an attribute type and/or value in the linked list structure for netcdf 
* Inputs: dset, varid, attribute specification

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP

* V601 11/06 *acm* Attribute control, adding double precision attribute value
* V602  2/07 *acm* Fix bug 1492, changing attributes of coordinate variables 
* V604  6/07 *acm* Declare VALS as double precision! 
* V65  *acm* 1/10  Make sure parameters values are consistent with 
*                              whats in netcdf.inc from netcdf4.
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* Argument declarations

      CHARACTER*(*) attname, string
      INTEGER dset, varid, attype, attlen, status
      REAL*8 vals(*)

* Internal declarations

      include 'netcdf.inc'
      include 'tmap_errors.parm'
      include 'xrisc_buff.cmn'

      LOGICAL cv
      INTEGER TM_LENSTR1, NCF_REPL_VAR_ATT_DP, NCF_REPL_VAR_ATT, 
     .        flen, slen, wlen, vdims(8), vartype, nvdims, nvatts, 
     .        all_outflag, dset_num
      CHARACTER*128 vname

      PARAMETER (flen=size_rbuff)      ! size of attribute string

#ifdef sun
      BYTE      fhol(flen), ghol(flen)      ! c-type Hollerith string buffer
#else
      INTEGER*1 fhol(flen), ghol(flen)      ! c-type Hollerith string buffer
#endif 


      slen = TM_LENSTR1( attname )
      CALL TM_FTOC_STRNG( attname(1:slen), fhol, flen )

      dset_num = dset
      IF (dset_num .LT. -2) dset_num = -2

      IF (attype .EQ. NCDOUBLE) THEN

         slen = 1
         CALL TM_FTOC_STRNG( string(1:slen), ghol, flen )
         
         status = NCF_REPL_VAR_ATT_DP(dset_num, varid, fhol, attype, 
     .           attlen, vals, ghol)
         IF (status .LT. 0) GOTO 5300

      ELSE
         slen = TM_LENSTR1( string)
         CALL TM_FTOC_STRNG( string(1:slen), ghol, flen )
         
         vals(1) = 1.
         status = NCF_REPL_VAR_ATT(dset_num, varid, fhol, attype, 
     .           slen, vals, ghol)
         IF (status .LT. 0) GOTO 5300

      ENDIF

5000  RETURN


! Error
 5300 CALL CD_GET_VAR_INFO (dset_num, varid, vname, vartype, nvdims, 
     .   vdims, nvatts, cv, all_outflag, status)
      slen = TM_LENSTR1( attname )
      wlen = TM_LENSTR1( vname )
      risc_buff(1:slen) = attname
      risc_buff(slen+1:slen+14) = ' for variable '
      risc_buff(slen+15:slen+15+wlen) = vname
      CALL TM_ERRMSG (merr_attalready, status, 'CD_REPLACE_ATTR_DP',
     .           dset_num, no_stepfile, 
     .           risc_buff(1:slen+15+wlen),
     .           no_errstring, *5000)
      END

	SUBROUTINE DSG_COORD_LIMS(dset, idim, lolim, hilim)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Return the lo/hi coordinate limits of the given axis of the dsg dataset

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V720 4/17 *sh*
* V74+ 6/18 *acm* get actual_range for rowsize variable

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xtm_grid.cmn_text'
	include 'xdset_info.cmn_text'
	include 'xdyn_linemem.cmn_text'
	include 'xcontext.cmn'
	include 'xprog_state.cmn'
	include 'xvariables.cmn'
#include "tmap_dset.parm"

* calling argument declarations:
	INTEGER dset, idim
	REAL lolim, hilim

* internal variable declarations:
        INTEGER TM_DSG_E_AXIS, var, nvals, line
	REAL	vals(2)

* local parameter definitions:
        INTEGER     maxlen
	PARAMETER ( maxlen = 2 )

* E axis
	IF (idim .EQ. e_dim) THEN
	   line = TM_DSG_E_AXIS(dset)
	   lolim = 1
	   hilim = line_dim(line)
	   RETURN
	ENDIF

* all other axes
	IF (idim .EQ. pdsg_row_size) THEN
	   var = dsg_row_size_var(dset)	
	ELSE
* ... find the DSG dataset variable associated with this coordinate
	   var = dsg_coord_var(idim,dset)
	ENDIF

	IF (var .NE. int4_init) THEN

* ... get the values stored on attribute 'actual_range'
*     these have reliably been set by CD_GET_DSG_COORD_EXTREMES
	   CALL GET_FVAR_ATT_VAL(dset, var, 'actual_range',
     .				   maxlen, vals, nvals)
	   lolim = vals(1)
	   hilim = vals(2)

	ELSE
* ... no limits exist
	   lolim = unspecified_val8
	   hilim = unspecified_val8
	ENDIF

	RETURN
	END

	SUBROUTINE CSTRING_INSERT( fstring, flen, cstring, clen, insert_pt)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Insert a FORTRAN character string into a "C" string (a character array)
* using a carriage return followed by null as the terminator.
* Return with the insertion point pointing to the null.

* V400:  8/94

* Note that insert_pt is both input and output - it will be returned at the
* correct position for the next insert

* If insert_pt>clen upon return that means the buffer has overflowed

        IMPLICIT NONE
* calling argument declarations:
	INTEGER	flen, clen, insert_pt
	CHARACTER fstring*(*)
#ifdef sun
        BYTE      cstring(clen) ! c-type Hollerith string buffer
#else
        INTEGER*1 cstring(clen) ! c-type Hollerith string buffer
#endif

* internal variable declarations:

* internal parameter declarations:
#ifdef sun
        BYTE      CR, NULL, STAR
#else
        INTEGER*1 CR, NULL, STAR
#endif
	PARAMETER ( CR   = 13,
     .		    NULL =  0,
     .		    STAR = 42 )	

	IF ( insert_pt + flen + 2 .LE. clen ) THEN

* insert the new string
	  CALL TM_FTOC_STRNG( fstring(:flen), cstring(insert_pt), clen )
	  insert_pt = insert_pt + flen

* insert the terminators
	  cstring(insert_pt) = CR
	  insert_pt = insert_pt + 1
	  cstring(insert_pt) = NULL      ! overwritten by next
	
	ELSE

* ERROR: insufficient room to append this text
	  DO 100 insert_pt = insert_pt, clen-1
 100	  cstring(insert_pt) = STAR
	  cstring(clen) = NULL
	  insert_pt = clen + 1

	ENDIF

	RETURN
	END

	SUBROUTINE SETUP_KEYS( nvar )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine parameters needed to layout titles and keys on the plot based on
* how many variables are in the plot

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V200: 12/21/89
* 	  5/6/90 - fixed bug when xlen is very small using MAX
* V420:  4/23/96 - number of columns was computed without respect to nvar
*	  	thus if the plot could fit 3 keys across but only 2 were needed
*	  	they didn't end up centered
* V540: *sh* 9/01 - do not adjust Y axis origin of PLOT command if user
*			specifies not to
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V698 *sh* 3/16 Limit the maximum number of keys.
*                /NOKEY and /TITLE suppresses yadjust

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'slash.parm'
	include	'plot_setup.parm'
	include	'command.parm'
	include	'xplot_setup.cmn'
	include	'xcontext.cmn'
	include	'xprog_state.cmn'
	include 'axis_inc.decl'		! axis lengths
	include 'AXIS.INC'		! axis lengths

* calling argument declarations
	INTEGER	nvar

* local variable declarations:
	LOGICAL	change_yorg, change_ysize, yadjust
	INTEGER	nrow, idim, nkey
	REAL	ysqueeze, yspace_needed, yspace_avail

* limit the number of labels
	nkey = MIN(nvar, max_key_entries)

* how many columns of keys can fit on the plot ?
	key_ncolmn  = MAX( 1, INT((xlen - key_xorigin)/key_xspace0) )
	IF (key_ncolmn .GT. nkey) key_ncolmn = nkey	! 4/96
	key_xspace  = MAX( xlen/5., (xlen - key_xorigin) / key_ncolmn )
	key_xsize   = MAX( xlen/6., key_xspace - key_xwhite_space )

* and how many rows do we need ?
	nrow = ((nkey-1) / key_ncolmn) + 1
	yspace_needed = nrow*key_yspace0

* where was the y origin before we tampered with it ?
	IF ( saved_ppl_yax ) THEN
	   yspace_avail = ppl_saved_yorg
	ELSE
	   yspace_avail = yorg
	ENDIF
	yspace_avail = yspace_avail + key_yorigin

* compute how much we will allow the key labels to shrink
	IF ( nrow .LE. 2 ) THEN
	   ysqueeze = 0.9
	ELSE
	   ysqueeze = MAX( 0.75, 0.92**(nrow-1) )
	ENDIF

* determine if
*  1) the keys will fit using the default y origin and key label size
*  2) the keys will fit but only by shrinking the label size
*  3) the keys will fit only by shifting the y origin (y location of x axis)
	yadjust = cmnd_num .EQ. cmnd_plot
	IF (yadjust) yadjust = qual_given(slash_plot_noyadjust).EQ.0
	IF (yadjust) yadjust = qual_given(slash_plot_nokey).EQ.0
	IF (yadjust) yadjust = qual_given(slash_plot_title).EQ.0
	IF ( .NOT.yadjust ) THEN
	   change_ysize = .FALSE.
	   change_yorg  = .FALSE.
	ELSE
	   change_ysize = yspace_avail .LT. yspace_needed
	   change_yorg  = yspace_avail .LT. yspace_needed*ysqueeze
	ENDIF

	IF ( .NOT. change_yorg ) THEN
* ... restore the default vertical layout if we tampered with it
           IF ( saved_ppl_yax ) THEN
	      ylen = ppl_saved_yaxlen
	      yorg = ppl_saved_yorg
	      saved_ppl_yax = .FALSE.
	   ENDIF
	ENDIF

	IF ( change_yorg ) THEN
* ... shrunken keys AND increased yorigin
* ... save the default vertical layout so we can restore it later
	   IF ( .NOT. saved_ppl_yax ) THEN
	      ppl_saved_yorg   = yorg
	      ppl_saved_yaxlen = ylen
	      saved_ppl_yax = .TRUE.
	   ENDIF 
	   yorg = yspace_needed * ysqueeze - key_yorigin
	   ylen = (ppl_saved_yaxlen + ppl_saved_yorg) - yorg
	   key_yspace = key_yspace0 * ysqueeze
	   key_ysize  = (key_yspace0 - key_ywhite_space) * ysqueeze
	   key_labht  = key_labht0 * ysqueeze
	ELSEIF ( change_ysize ) THEN
* ... shrunken keys but don't tamper with y origin
	   ysqueeze = yspace_avail / yspace_needed
	   key_yspace = key_yspace0 * ysqueeze
	   key_ysize  = (key_yspace0 - key_ywhite_space) * ysqueeze
	   key_labht  = key_labht0 * ysqueeze
	ELSE
* ... full-sized keys, don't tamper with y origin
	   key_yspace = key_yspace0
 	   key_ysize  = key_yspace0 - key_ywhite_space
	   key_labht  = key_labht0
	ENDIF

* how many labels in the upper left corner?
	ul_nlabs = 0
	DO 100 idim = 1, nferdims
	   ul_dolab(idim) = cx_lo_ww(idim,cx_plot).NE.unspecified_val8
     . 		      .AND. cx_lo_ww(idim,cx_plot).NE.unspec_val8_2
	   IF ( ul_dolab(idim) ) ul_nlabs = ul_nlabs + 1	
 100	CONTINUE	

	RETURN
	END

	INTEGER FUNCTION HASH_CX( cx )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* generate a pseudo-random pile number between 1 and pmv_npiles based on
* information in the passed context

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 7/21/88
* V200:  7/12/89 - special treatment for cat_temp_var
* V510: 8/99 *sh* special treatment for cat_work_mr
* v580: 9/04 *acm* Fix Bug 993: constant variables and string variables
*                  use (1000*uvar + item) to pack extra information
*                  into what is stored in cx_variable(cx).  When these
*                  very large values go into computing nsum here,
*                  the expression 2107*nsum overflows and becomes
*                  a negative number, and so HASH_CX computed at the 
*                  end of this routine is 0 or > 0.  This messes up 
*                  the linked lists for variables in memory. Use uvar 
*                  for these types of vars so HASH_CX is always negative.
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xvariables.cmn'	! for pmv_npiles
	include 'xcontext.cmn'

* calling argument declarations:
	INTEGER cx

* internal variable declarations:
	INTEGER idim, nsum, cat, uvar

* initialize
	cat = cx_category( cx )

* special Q&D solution for temporary variables, etc.
	IF ( cat .EQ. cat_constant 
     .  .OR. cat .EQ. cat_temp_var
     .  .OR. cat .EQ. cat_pseudo_var ) THEN
	   HASH_CX = -1
	   RETURN
	ELSEIF ( cat .EQ. cat_work_mr ) THEN
	   HASH_CX = pmv_work_var_pile
	   RETURN
	ENDIF
	
* arbitrary number generated from context information
        uvar = cx_variable( cx )
        IF (cat .EQ. cat_const_var .OR. cat .EQ. cat_string)  
     .       uvar = cx_variable(cx)/1000

	nsum = cx_data_set( cx )
     .	     + uvar * 7
     .	     + cat * 13
	DO 100 idim = 1, nferdims
	   IF ( cx_trans( idim, cx ) .NE. trans_no_transform )
     .	      nsum = nsum + idim*idim
 100	CONTINUE

* randomize the number and return a NEGATIVE pile number

	HASH_CX = -1 * ( MOD( 2107*nsum, pmv_npiles ) + 1 )
        IF (HASH_CX .GE. 0) HASH_CX = -1

	RETURN
	END

	SUBROUTINE REPL_EXPRNS(  cmnd, lencmnd, cmnd_num,
     .				istart, max_check,
     .				ndigits, did_sub, status  )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* parse the command line replacing the first expression that is enclosed
* between grave accents with text strings representing their values
* this routine will be called once for each such expression so that the
* entire command line can be re-parsed between calls.  This makes it possible
* to build the command qualifier information from fixed limits and grave
* accented expressions working from left to right

* USAGE EXAMPLE:
*	CONTOUR/Z=`TEMP[Z=0:1000@LOC:15]` SALINITY*`some_factor`

* NOTE (3/00) THE POTENTIAL FOR WRONG RESULTS WITH OPERATIONS SUCH AS MATRIX
* TRANSPOSE - ALL "IMPOSED" AXES PRESENT THE RISK OF WRONG RESULTS.
* THIS COULD BE FIXED BY FORCING FULL EVALUATION OF EVERY EXPRESSION THAT
* CONTAINS A GC FUNCTION WITH AN IMPOSED AXIS. (For now we leave this
* bug in favor of the performance increase ... important in automated scripts
* that want to test the size of a result before computing it.


* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V400 3/95
* V411: 9/8/95 - serious bug fixed:  use CREATE_TEMP_MEM_VAR and COPY_GRID
*		so that the result scalar is picked correctly from within
*		the body of a larger mvar (instead of assuming that it is
*		always element (1,1,1,1) of the mvar)
* V420: 11/95 - allow grave accents to be "escaped" by '\'
* 	 1/96 - bug fix: special check if grave accents enclose white space
*	 2/96 - allow digits control with `expr,PREC=n`
*		and control of "bad string" with "BAD=xx.xx"
*	 3/96 - added RETURN=shape, isize,istart,iend, etc. for j,k, and l
* Linux Port - 5/97 *kob*
*	     - added ifdef check for double slash because f90/linux didn't
*	       need two of them together for escapes
* V510: 9/99 *sh* - added RETURN=XSTART (X-Y-Z-T, START-END-UNITS))
*	3/00 *sh* - RETURN= options computed without evaluating the expression
*		  - added RETURN=SIZE
* V522: 6/00 *sh* - added RETURN = XAXIS, YAXIS, ZAXIS, TAXIS
* V530: *sh* 9/00 - added support for string variables
*       *sh* 2/01 - added FORMAT = I4.4, etc. (NOT IMPLEMENTED)
*	          - added WIDTH=width and ZWIDTH=width
*	*sh* 3/01 - added RETURN=dset, dsetnum, dsetpath
* V531: *sh* 4/01 - added RETURN=bad
* V532: *sh* 5/01 - mod to EVAL_CONTEXT forced change here  
* *kob* 2/03 - replace call to intrinsic func CHAR with its octal
*              constant equivalent - needed for g77 port
*            - Need to use risc_buff for arbitrary concatenations
* v552: *acm* 4/03 - Issue a complete error message for wrong arguments
*                    to RETURN=
* v552: *acm* 4/03 - Add RETURN=dsettitle
*       *acm* 4/03 - Add RETURN=nc_scale, nc_off[set], user_scale, user_off[set]
* V570  *acm* 6/04 - Add RETURN=CALENDAR
* V580  *acm* 8/04 - Increase the length of string repl from 128 to 2048: If using a
*                    long string, e.g. in a label, this string can be very long. (bug 956)
* V581*acm*  6/05 - For fix to bug 1271, add flag line_shift_origin
*            and restore original t0 on output
* V600 *acm* 3/06  fixing bugs 439&1390, pass apply_cx to get_new_cx to say whether
*                  to apply command context to grave-accent expressions.
* V600 *acm* 6/05 - Attribute control, RETURN= attribute information.
* V600  4/06 *acm* - additional declarations found by Solaris compiler
* V600  6/06 *acm* - additional declarations found by Solaris compiler
* V601 10/06 *acm* - fix bug 1447, where say `var[d=fname.cdf],return=size` failed
*            parsing error, confusing the dot in the filename with `var.att,return=size`
* V602  4/07 *acm* - Add RETURN=xmod,tmod
* V615 11/08 *acm* - fixing bug 1523. If the variable contains a grid-changing 
*                    function, we will do a full evaluation to get its size
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V684 *acm* 12/12 Add data type of DOUBLE for return=dtype
* V685 *sh*  11/13 Add return=status and return=ready
* V69+ *acm*  9/14 Ticket 2197. After return=status and return=ready need to unset the
*                  flag dependency_tree_mode to turn regular error reporting back on.
* V69+ *acm*  9/14 Ticket 981. If the variable is a constant-array, evaluate it to get
*                  the grid size rather than returning the nominal length.
* V695 *acm*  2/15 RETURN=F0 for calendar formatted F axis 
* V695+ *sh* 2/15 add support for _DQ_ style of quotations
* V694 *acm* 5/15 fix bug 2213
* V695 *acm* 6/15 Add return=defined (ticket 2293)
* v695 *acm* 9/15 Ticket 2313: For `return=`, if the return request is for an attribute 
*                 not related to the grid or other characteristics that need evaluation, 
*                 do not evaluate the expression.
* v695 *acm* 5/16 Ticket 2389. When the user gives `var,prec=xx`, return the acutal number
*                 of digits requested. Return exponential formats when that makes the
*                 result shorter. Changes are only for positive values of ,prec=
* v701 *acm* 9/16 Ticket 1269: For RETURN=shape, use the same logic as in SHOW GRID,
*                 for determining when a grid dimension is compressed by a transformation.
* V702 1/17 *sh* for trac enhancement #2369 -- dynamic memory management 
* V720 *acm* 5/17 Implement specific calls in place of CD_GET_VAR_INFO
* V73+ *acm* 12/17 Fix issue #1847 - value overflows integer on RETURN=size
* V74  *acm* 2/18 Issue # 1861, handling missing- and _FillValue with scale and offset
*                 change to `var,RETURN=bad`
* V74+ *acm*10/10 Partial fix to working with E contexts in dsg datasets.
* v745 *acm* 12/18  Issue 1909, option to write dates in ISO8601 format
* v7441*acm* 12/18 Issue 1910: Allow dates in commands to be in ISO 8601 form, yyyy-mm-dd
* v745* acm*  2/19 Issue 400:  If a user var is LET var = filevar[d=1] then return the
*                  correct info for `var,return=dset` and dsetnum and dsetpath.
* V745  4/19 *acm* ticket 1916, special handling getting context for RETURN= outputs
* V751  6/19 *acm* ticket 1929, don't chop off str_len when testing for reformatting at the end

        IMPLICIT NONE
#include "netcdf.inc"
	include 'tmap_dims.parm'
        include 'ferret.parm'
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xrisc.cmn'
	include 'xcontext.cmn'
	include 'xtext_info.cmn'
	include 'xdependency_tree.cmn'
	include 'xtm_grid.cmn_text'
	include 'xdset_info.cmn_text'
	external xdset_info_data
        include 'xdset_info.cd_equiv'

* calling argument declarations:
	LOGICAL	  did_sub, info_query, itsa_subsc, apply_cx
	INTEGER	  cmnd_num, lencmnd, istart, max_check, ndigits, status
	CHARACTER cmnd*(*)

* local parameter declarations 
	INTEGER	   max_len
	PARAMETER (max_len = 2048)

* internal variable declarations:
	LOGICAL   TM_HAS_STRING, TM_DFPEQ, TM_ITSA_DSG, 
     .		  need_formatting, zero_fill, coordvar,
     .            do_err, do_eval, get_ready, was_dep, const_arr_var,
     .		  dqote, DQ, orig_name, uvgrid, compressed, grid_reset, is_dsg
	INTEGER   CGRID_SIZE, CGRID_AXIS, TM_LENSTR1, CX_DIM_LEN,
     .		  FIND_DSET_NUMBER, GET_ABSTRACT_LINE, TM_LENSTR,
     .		  TM_GET_GRIDNUM, GRID_FROM_NAME, TM_SUBSC, TM_GET_CALENDAR_ID,
     .		  str_len, lenbuff, iend, itmp, axis,
     .		  mr, cx, mr_temp, i, i1, i2, use_digits, true_end,
     .		  qual_end, brkt, idim, use_width, dset, varid,
     .            vartype, attype, attlen, inxt, attoutflag, fertype,
     .            attid, ieq, base_isp, base_cx, cat, var, uvar,
     .            i1ss, inss, grid, ucode, dotidx, shorterlen,
     .            hi_cx, item, itype, start, len_name, var_status, 
     .            siz, ifeature
	REAL	  result, val, aval
	REAL*8 TM_WORLD, TM_WW_AXLEN, ww
	CHARACTER TM_FMT*48, LEFINT*16, VAR_TITLE*(max_len),
     .		  VAR_UNITS*(max_len), GET_STRING_ELEMENT*(max_len),
     .		  repl*(max_len), bad_str*(max_len), return_errmsg*256,
     .            buff*128, varname*512, attname*128, aname*128, name*128
        CHARACTER*6 typstring(0:6)

* local parameter declarations
	CHARACTER	tab*1
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
#else
	PARAMETER     ( tab = CHAR(9))
#endif

        DATA typstring/
     .  'Notype', 'BYTE', 'CHAR', 'SHORT', 'INT4', 'FLOAT', 'DOUBLE' /

* initialize
	did_sub = .FALSE.    	! any substitutions done?
	lenbuff = LEN( cmnd )
	use_digits = ndigits
	bad_str = 'bad'
!	fmt = ' '
	use_width = 0
	zero_fill = .FALSE.
	info_query = .FALSE.
        coordvar = .FALSE.
        apply_cx = .FALSE.
	str_len = 0
	is_dsg = .FALSE.
	
	grid = unspecified_int4
	cx_only = .FALSE.   ! do merge_grid in mode for not evaluating full context

* do_err: issue error message if attrib does not exist on varname.attname
        do_err = .TRUE.

* begin the search/replace at the point specified in the call.  (This is done
* to facilitate  grave accents condensed into single accents so they
* can be passed to the command line in SPAWN commands)
* locate the start of the next grave accent pair
 10	IF ( istart .GE. lencmnd ) RETURN
	itmp = INDEX(cmnd(istart:),'`')
        IF ( itmp .EQ. 0 ) RETURN
	istart = istart + itmp
#ifdef NO_DOUBLE_ESCAPE_SLASH
	IF ( istart .GT. 2 ) THEN
	   IF (cmnd(istart-2:istart-2) .EQ. '\') GOTO 10  ! ' for emacs
	ENDIF
#else
	IF ( istart .GT. 2 ) THEN
	   IF (cmnd(istart-2:istart-2) .EQ. '\\') GOTO 10  
	ENDIF
#endif

* locate the end of the next grave accent pair
* Note: no check for backslash-escaped accent here because properly paired
*    accents only need to be checked at start of accent pair
	itmp = INDEX(cmnd(istart:),'`')
	IF ( itmp .EQ. 0 ) GOTO 5100		! unpaired grave accent
	IF ( itmp .EQ. 1 ) THEN
* ... replace  grave accents with single
	   cmnd = cmnd(:istart-1)//cmnd(istart+1:)
	   istart = istart + 1			! first char following accent
	   lencmnd = lencmnd - 1
	   GOTO 1000
	ENDIF
	iend = istart + itmp - 2
	true_end = iend

* do not perform substitutions beyond max_check characters
	IF ( istart .GE. max_check ) RETURN

* ====== 2/96
* Parse ",PRECISION=n" and/or ",BAD=xx.xx" at the end of the expression
*  (may be abbreviated to "P=n" and "B=xx.xx")
* 3/96: added RETURN= (abbreviated R=)
* ... hunt for the first equal sign that is not in square brackets
	brkt = 0
	DO 90 i = istart, iend
	   IF (cmnd(i:i).EQ.'[') THEN
	      brkt = brkt + 1
	   ELSEIF (cmnd(i:i).EQ.']') THEN
	      brkt = brkt - 1
	   ELSEIF (cmnd(i:i).EQ.'=') THEN
	      IF ( brkt .EQ. 0 ) GOTO 98
	   ENDIF
 90	CONTINUE
	GOTO 149	! nope - no equal sign
* ... see if the first part of the expression is a d=dsetnum or d=dsetname
 98	inxt = i
        ieq = i
        IF (cmnd(i-1:i-1).EQ.'d') THEN
           inxt = i+1
           DO 91 i = inxt,iend
              IF ( cmnd(i:i) .EQ. ',' ) GOTO 94
 91        CONTINUE
 94        dset = FIND_DSET_NUMBER(cmnd(inxt:i-1))
       ENDIF

* ... see if the equals sign is just part of some string within the grave accents
*     This fixes bug 1469 (and its duplicate 1690)
* *sh* add support for _DQ_ style of quotations
	dqote = .FALSE. 
	DQ = .FALSE.
	DO i = istart, iend
	   IF (cmnd(i:i).EQ.'"' .AND. .NOT.DQ)  THEN
	      dqote = .NOT.dqote
	   ELSEIF (cmnd(i:i).EQ.'_'
     .       .AND. i+3 .LE. iend ) THEN
	      IF ( cmnd(i:i+3).EQ.'_DQ_' ) DQ = .NOT.DQ
	   ELSEIF (cmnd(i:i).EQ.'=' ) THEN
* ... does the "=" lie between quotation marks?
	      IF (dqote)  THEN
	         IF (INDEX(cmnd(i:iend), '"'   ) .GT. 0) GOTO 149
	      ELSEIF (DQ) THEN
	         IF (INDEX(cmnd(i:iend), '_DQ_') .GT. 0) GOTO 149
	      ENDIF
	   ENDIF
	ENDDO

* ... hunt for the next equal sign 
	DO 93 i = ieq, iend
           IF (cmnd(i:i).EQ.'=') GOTO 99
 93	CONTINUE
	GOTO 149	! nope - no equal sign

* ... locate the comma following the mathematical expression
  99	DO 100 i = i, istart, -1
 100	IF ( cmnd(i:i) .EQ. ',' ) GOTO 101
	GOTO 5500			! no comma ???
 101	iend = i - 1
* ... now decode the name/value pairs following the comma
 110	i = i + 1	   ! advance to character following the comma
* ... locate the end of the name/value pair string
	DO 120 i2 = i, true_end   
	   IF ( cmnd(i2:i2) .EQ. ',' ) THEN
	      qual_end = i2 - 1	
	      GOTO 121
	   ENDIF
 120	CONTINUE
	qual_end = true_end
 121	CONTINUE
* ... locate the keyword start and decode the keyword/value pair
	DO 130 i = i, qual_end   
	   IF (cmnd(i:i).EQ.' ' .OR. cmnd(i:i).EQ.tab) THEN
	      CONTINUE
	   ELSEIF (cmnd(i:i).EQ.'p' .OR. cmnd(i:i).EQ.'P') THEN
* ... decode PRECISION = #_digits
	      CALL EQUAL_VAL(cmnd(i:qual_end), result, status)
	      IF ( status .NE. ferr_ok ) GOTO 5000
	      IF (ABS(result) .GT. 16.) GOTO 5510 	         
	      use_digits = NINT(result)
	      GOTO 131
	   ELSEIF (cmnd(i:i).EQ.'b' .OR. cmnd(i:i).EQ.'B') THEN
* ... decode BAD = string
	      CALL EQUAL_STR_LC(cmnd(i:qual_end), bad_str, status)
	      IF ( status .NE. ferr_ok ) GOTO 5000
	      GOTO 131
	   ELSEIF (cmnd(i:i).EQ.'r' .OR. cmnd(i:i).EQ.'R') THEN
* ... decode RETURN = string
	      CALL EQUAL_STRING(cmnd(i:qual_end), repl, status) !repl is buffer
	      IF ( status .NE. ferr_ok ) GOTO 5000
	      info_query = .TRUE.
	      GOTO 131
	   ELSEIF (cmnd(i:i).EQ.'w' .OR. cmnd(i:i).EQ.'W') THEN
* ... decode width = width (blank-filled width)
	      CALL EQUAL_VAL(cmnd(i:qual_end), val, status)
	      IF ( status .NE. ferr_ok ) GOTO 5000
	      IF (val.GT.0 .AND. val.LT.max_len) use_width = INT(val)
	      GOTO 131
	   ELSEIF (cmnd(i:i).EQ.'z' .OR. cmnd(i:i).EQ.'Z') THEN
* ... decode zwidth = width (zero-filled width)
	      CALL EQUAL_VAL(cmnd(i:qual_end), val, status)
	      IF ( status .NE. ferr_ok ) GOTO 5000
	      IF (val.GT.0 .AND. val.LT.max_len) use_width = INT(val)
	      zero_fill = .TRUE.
	      GOTO 131
! unimplemented code to allow user to control format
!	   ELSEIF (cmnd(i:i).EQ.'f' .OR. cmnd(i:i).EQ.'F') THEN
!* ... decode FORMAT = string
!	      CALL EQUAL_STRING(cmnd(i:qual_end), fmt, status)
!	      IF ( status .NE. ferr_ok ) GOTO 5000
!	      GOTO 131
	   ELSE
	      GOTO 5500
	   ENDIF
 130	CONTINUE
 131	i = qual_end + 1	! comma or beyond end
* ... go back for another keyword?
	IF ( i .LT. true_end ) GOTO 110
* ======

* is the expression just white space?	(1/96 ... quick fix with GOTO's)
 149	DO 150 i = istart, iend
 150	IF ( cmnd(i:i) .NE. ' ' .AND. cmnd(i:i) .NE. tab ) GOTO 160
* ... weird - they gave us pure white space - no numerical result possible
	repl = bad_str
	str_len = 3
	GOTO 500

* is this a single number request or a RETURN= query?
 160	IF ( info_query ) THEN

* 11/2013
* return=ISREADY and return=STATUS are special.  They must function
*   correctly even in the face of unknown variables and unknown datasets.
*   So they must be handled before we attempt even to get the context for the
*   given expression.
	   IF (repl(1:4).EQ. 'STAT' .OR. repl(1:4) .EQ. 'ISRE') THEN
	      get_ready = repl(1:4) .EQ. 'ISRE'
	      CALL GET_DEPENDENCY_STATUS( cmnd(istart:iend),
     .					 repl, str_len, status) 
	      CALL EXIT_DEPENDENCY_MODE
              IF (status.NE. ferr_ok) GOTO 5050
	      IF (get_ready) THEN
*  return=READY gives merely a 1 or 0 
	         IF (    dependency_status .EQ. df_valid_var) THEN
	            repl = '1'
	         ELSE
	            repl = '0'
	         ENDIF
	      ENDIF
	      GOTO 500
	   ENDIF
	   
* 11/2013
* return=DEFINED needs only to check whether the user-variable is defined

* ... RETURN=DEFINED
	   IF ( repl(1:3) .EQ. "DEF" ) THEN
	      str_len = 1
	      repl = '0'	! default, pos=up, or not-depth.
	      CALL FIND_VAR_NAME ( pdset_irrelevant, cmnd(istart:iend), cat, var )
	      IF ( var .NE. munknown_var_name) repl = '1'
	      GOTO 500
	   ENDIF

* ... evaluate the context without computing the expression
*	this is a major performance consideration, but not 100% reliable

	   has_uvar_gc = .FALSE.
	   is_uvar_const = .FALSE.
	   CALL GET_NEW_CX( cx_last, cx_cmnd, apply_cx, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000

	   IF (cmnd(istart:istart) .EQ. '(') THEN
              dset = cx_data_set(cx_cmnd)   ! initial value to try; will return dset
              CALL ISIT_COORD_VAR ( cmnd(istart:iend), dset, 
     .            buff, coordvar, status )
              IF ( status .NE. ferr_ok ) GOTO 5000

           ELSE
* ... context meaningless for d=1,return=varnames
              IF (cmnd(istart:istart+1) .NE. 'd=') THEN

* are we going to need to unset things later? (context-setting for user-vars
* when doing shape and size returns.)

	         grid_reset = ( repl.EQ."SHAPE" .OR. 
     .              (repl.EQ."SIZE"  .AND. INDEX(cmnd(istart:iend),'.').EQ.0) )

	         IF ( repl(2:5).EQ."SIZE" ) THEN
	            DO idim = 1, nferdims
	               IF ( repl(1:1) .EQ. ss_dim_name(idim) ) THEN
		          grid_reset = .TRUE.
			  EXIT
	               ENDIF
		    ENDDO
	         ENDIF

	         IF ( repl(2:6).EQ."START" .OR. repl(2:4).EQ."END" ) THEN
	            DO idim = 1, nferdims
	               IF ( repl(1:1).EQ.ss_dim_name(idim).OR. 
     .                      repl(1:1).EQ.ww_dim_name(idim))  THEN
		          grid_reset = .TRUE.
			  EXIT
	               ENDIF
		    ENDDO
	         ENDIF

*  For results such as shape and size where we need to get the context
*  save a list of the uvars on the stack where the uvar grid gets set and
*  unset it later

		 IF (grid_reset) THEN
		    cx_only = .TRUE.

*  Allocate dynamic line memory for a list of uvars where uvar-grid info gets
*  set in this routine.
		    
		    CALL GET_LINE_DYNMEM(max_uvar, uvar_cx_only_lm, status)
		    uvar_cxo_len = 0

		    CALL DELETE_OLD_UGRIDS

		 ENDIF

		 CALL EVAL_CONTEXT ( cx_cmnd, cmnd(istart:iend), status )
                 IF ( status .NE. ferr_ok ) GOTO 5000

                 cx = is_cx(1)	! always comes back as the first context

		 cat = cx_category(cx)

* ... Returns that can be made without evaluating the expression. If success
*     is not verified, will continue and try again after evaluation.

	      IF (cx.EQ.unspecified_int4 .OR. cx.EQ.0) GOTO 4000 ! context not set

* ... RETURN=UNITS
              IF ( repl(1:4) .EQ. "UNIT" ) THEN	! or "=UNITS"
	         repl = VAR_UNITS( cx )
	         str_len = TM_LENSTR1(repl)
	         GOTO 500

* ... RETURN=TITLE
	      ELSEIF ( repl .EQ. "TITLE" ) THEN
	         repl = VAR_TITLE( cx )
	         str_len = TM_LENSTR1(repl)
	         GOTO 500
		  
* ... RETURN=BAD
	      ELSEIF ( repl .EQ. "BAD" ) THEN
	         result = cx_bad_data ( cx )

* if its a netcdf-type dset with packed data, may have swapped out the bad flag

	         i2 = cx_data_set(cx)
		 CALL GET_DSET_BAD( i2,  cmnd(istart:iend), result )

	         repl = TM_FMT( result, use_digits, 22, str_len )
	         GOTO 500
		 
* ... RETURN=T0
	      ELSEIF ( repl .EQ. "T0" .AND. cat.EQ.cat_file_var) THEN
	         repl = ' '	! default
	         idim = T_DIM
	         axis = CGRID_AXIS ( idim, cx )
	         IF ( axis.NE.mnormal) THEN
	            IF (line_direction(axis) .EQ. 'TI') THEN
    		       repl = line_T0(axis)
                       IF (line_shift_origin(axis)) 
     .                   repl =  '01-JAN-0001 00:00:00'
                    ELSE
		      GOTO 4000
		    ENDIF
	         ENDIF
	         str_len = TM_LENSTR1(repl)
	         CALL CHECK_DATE_REFORMAT (repl, str_len, 
     .              TM_GET_CALENDAR_ID ( line_cal_name(axis)), status)
	         GOTO 500

* ... RETURN=F0
	      ELSEIF ( repl .EQ. "F0" .AND. cat.EQ.cat_file_var) THEN
	         repl = ' '	! default
	         idim = F_DIM
	         axis = CGRID_AXIS ( idim, cx )
	         IF ( axis.NE.mnormal) THEN
	            IF (line_direction(axis) .EQ. 'FI') THEN
    		       repl = line_T0(axis)
                       IF (line_shift_origin(axis)) 
     .                  repl =  '01-JAN-0001 00:00:00'
                    ELSE
		      GOTO 4000
                    ENDIF
	         ENDIF
	         str_len = TM_LENSTR1(repl)
		 CALL CHECK_DATE_REFORMAT (repl, str_len, 
     .                       TM_GET_CALENDAR_ID ( line_cal_name(axis)))
	         GOTO 500
              
* ... RETURN=CALENDAR
	      ELSEIF ( repl(1:3) .EQ. "CAL" .AND. cat.EQ.cat_file_var) THEN
	         repl = ' '	! default
	         axis = CGRID_AXIS ( T_dim, cx )
	         IF ( axis.NE.mnormal) THEN
	               IF (line_direction(axis) .EQ. 'TI' .OR.
     .                  line_direction(axis) .EQ. 'TT')
     .		        repl = line_cal_name(axis)
	         ELSE
		      GOTO 4000
	         ENDIF
	         str_len = TM_LENSTR1(repl)
	         GOTO 500


* ... RETURN=DSET, DSETNUM, DSETPATH, DSETTITLE
	      ELSEIF ( repl(1:4) .EQ. "DSET" .AND. cat.EQ.cat_file_var) THEN
	         i2 = cx_data_set(cx)
	         IF ( i2 .EQ. pdset_irrelevant
     .	        .OR.  i2 .EQ. unspecified_int4 ) THEN
	            GOTO 4000
	         ELSE
                    IF ( repl .EQ. "DSETNUM") THEN
	               repl = LEFINT(i2, str_len)
	            ELSEIF ( repl .EQ. "DSETPATH" ) THEN
	               CALL GET_DSET_NAME(i2, repl, str_len)
                    ELSEIF ( repl .EQ. "DSET" ) THEN
	               CALL GET_SHORT_DSET_NAME(i2, repl, str_len)
                    ELSEIF ( repl .EQ. "DSETTITLE" ) THEN
	               CALL GET_DSET_TITLE(i2, repl, str_len)
                    ELSE 
	               GOTO 4000
                    ENDIF
	         ENDIF
	         str_len = TM_LENSTR1(repl)
	         GOTO 500

* ... RETURN=nc_scale, nc_offset
	         ELSEIF ( repl(1:3) .EQ. "NC_" .AND. cat.EQ.cat_file_var) THEN
	            IF ( repl .EQ. "NC_SCALE" ) THEN
	               CALL GET_NC_SCALE (cx, result)
	            ELSEIF ( repl(1:6) .EQ. "NC_OFF" ) THEN
	               CALL GET_NC_OFFSET (cx, result)
                    ELSE 
	               GOTO 4000
	            ENDIF
	            repl = TM_FMT( result, use_digits, 22, str_len )
	            GOTO 500

* ... RETURN=user_scale, user_offset
	         ELSEIF ( repl(1:5) .EQ. "USER_" ) THEN
	            IF ( repl .EQ. "USER_SCALE" ) THEN
	               CALL GET_USER_SCALE (cx, result)
	            ELSEIF ( repl(1:8) .EQ. "USER_OFF" ) THEN
	               CALL GET_USER_OFFSET (cx, result)
	            ELSE 
	               GOTO 4000
	            ENDIF
	            repl = TM_FMT( result, use_digits, 22, str_len )
	            GOTO 500

* ... RETURN=dtype if it is available in the context at this point. For user-
*     defined variables the type is not yet determined.

	         ELSEIF ( repl .EQ. "DTYPE" .AND. cat.EQ.cat_file_var 
     .              .AND. INDEX(cmnd(istart:iend),'.') .EQ. 0) THEN
	            dset = cx_data_set(cx)
	            IF (dset .EQ. pdset_irrelevant .OR. 
     .               dset .EQ. unspecified_int4) dset = pdset_uvars  ! try user vars

	            varid = 0
	            vartype = 0

	            CALL CD_GET_VAR_ID(dset, cmnd(istart:iend), varid, status)

	            IF (status .EQ. ferr_ok)  
     .                CALL CD_GET_VAR_TYPE (dset, varid, cmnd(istart:iend), 
     .                              vartype, status )

                    IF (vartype.EQ.0 ) GOTO 4000
		    
	            IF (status .EQ. ferr_ok) THEN
                       repl = typstring(vartype)
	            ELSE 
	               GOTO 4000
	            ENDIF
	            str_len = TM_LENSTR1(repl)
	            GOTO 500

* ... varname.atttnum,RETURN=dtype  or varname.attname, RETURN=dtype

	         ELSEIF ( repl .EQ. "DTYPE" .AND. cat.EQ.cat_file_var
     .              .AND. INDEX(cmnd(istart:iend),'.') .GT. 0) THEN
	            attype = 0
	            dset = cx_data_set(cx)
	            IF (cx_data_set(cx) .EQ. pdset_irrelevant) dset = pdset_uvars  ! user vars
	               CALL BREAK_VARATTNAME( cmnd(istart:iend), dset, 
     .                    varname, attname, varid, do_err, status )
	               CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, 
     .                    status)
	               IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, varid, 
     .                    attid, aname, attype, attlen, attoutflag, status )

	            IF (status .EQ. ferr_ok) THEN
                       repl = typstring(attype)
	            ELSE 
	               GOTO 4000
	            ENDIF
	            str_len = TM_LENSTR1(repl)
	            GOTO 500

* ... varname.atttnum,RETURN=size  or varname.attname, RETURN=size

	         ELSEIF ( repl .EQ. "SIZE" .AND. cat.EQ.cat_file_var
     .              .AND. INDEX(cmnd(istart:iend),'.') .GT. 0) THEN
	            IF (.NOT. coordvar) dset = cx_data_set(cx)
	            IF (dset .GE. 1) THEN
	               IF (coordvar) THEN

                          IF (INDEX(buff,'.') .GT. 0)
     .                    CALL BREAK_VARATTNAME( cmnd(istart:iend), dset, varname, 
     .                              attname,  varid, do_err, status )

	               ELSE
                          CALL CD_GET_VAR_ID (dset, cmnd(istart:iend), varid,
     .                        status)
                    
                          IF (status .NE. ferr_ok .AND. 
     .                     INDEX(cmnd(istart:iend),'.') .GT. 0) THEN
                             CALL BREAK_VARATTNAME( cmnd(istart:iend), dset,
     .                         varname, attname, varid, do_err, status )
                          ELSE
                             i2 = CGRID_SIZE ( cx )
                             repl = LEFINT(i2, str_len)
			     str_len = TM_LENSTR1(repl)
                             GOTO 500
                          ENDIF

	               ENDIF
                 
	               CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, 
     .                   status)
	               IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, varid,
     .                  attid, aname,  attype, attlen, attoutflag, status )

	               IF (status .EQ. ferr_ok) THEN
                          IF (attlen .GT. 0) THEN
                             result = attlen
                             repl = TM_FMT( result, use_digits, 22, str_len )
                          ENDIF
	               ELSE 
	                  GOTO 4000
                       ENDIF
                    ENDIF
	            str_len = TM_LENSTR1(repl)
	            GOTO 500

* ... RETURN=XMOD

	         ELSEIF ( repl .EQ. "XMOD" .AND. cat.EQ.cat_file_var) THEN
	            repl = ' '	! default
	            axis = CGRID_AXIS ( X_dim, cx )
	            IF ( axis.NE.mnormal) THEN
	               IF (line_modulo(axis)) THEN
                          result = line_modulo_len(axis)

! If axis has modulo=" ", and units are not degrees, mod len = axis len.
                          IF (result .EQ. 0) result = TM_WW_AXLEN(axis)
                          repl = TM_FMT( result, use_digits, 22, str_len)
		       ENDIF
	            ENDIF
	            str_len = TM_LENSTR1(repl)
	            GOTO 500

* ... RETURN=TMOD

	         ELSEIF ( repl .EQ. "TMOD" .AND. cat.EQ.cat_file_var) THEN
	            repl = ' '	! default
	            axis = CGRID_AXIS ( T_dim, cx )
	            IF ( axis.NE.mnormal) THEN
	               IF (line_modulo(axis)) THEN
                          result = line_modulo_len(axis)

! If axis has modulo=" ", mod len = axis len.
                          IF (result .EQ. 0) result = TM_WW_AXLEN(axis)
                          repl = TM_FMT( result, use_digits, 22, str_len)

                       ENDIF
	           ENDIF
	           str_len = TM_LENSTR1(repl)
	           GOTO 500

* ... RETURN=ISDEPTH

	         ELSEIF ( repl(1:3) .EQ. "ISD" .AND. cat.EQ.cat_file_var) THEN
	            axis = CGRID_AXIS ( Z_dim, cx )
	            IF ( axis.NE.mnormal) THEN
		       repl = '0'
	               IF (line_direction(axis) .EQ. "UD") repl = '1'
	            ELSE 
		       repl = '0'
	            ENDIF
	            str_len = TM_LENSTR1(repl)
	            GOTO 500

	         ENDIF  ! trying to return results based on context only

 4000        	CONTINUE

* ... if the result has any axes with unknown limits then we have to do a
*	full evaluation. This happens (only?) from grid-changing fcns that
*	return ABSTRACT axes, on which limits may depend on data values
* NOTE THE POTENTIAL FOR WRONG RESULTS WITH OPERATIONS SUCH AS MATRIX
* TRANSPOSE - ALL "IMPOSED" AXES PRESENT THE RISK OF WRONG RESULTS
* Just checking for the abstract axis to fix bug 2213. 

                 DO 190 idim = 1, nferdims
		    do_eval = ( cx_hi_ww(idim, cx) .EQ. unspecified_val8
     .	                        .AND. CGRID_AXIS(idim, cx) .NE. mnormal )
		    do_eval = (do_eval .OR. 
     .	                 CGRID_AXIS(idim, cx) .EQ. GET_ABSTRACT_LINE(idim) )
	            IF ( do_eval .OR. has_uvar_gc .OR. is_uvar_const) THEN
		       cx_only = .FALSE.
		       CALL EVAL_EXPR (  cx_last,
     .		                     cmnd(istart:iend), apply_cx, status )
	               IF ( status .NE. ferr_ok ) GOTO 5000
	               cx = is_cx(1)	! always comes back as the first context
		       cx_only = grid_reset
	               GOTO 200
	            ENDIF
 190	         CONTINUE
              ENDIF  ! `d=1,return=varnames`

* If it's a constant-array variable, we'd like to return its actual size, not the
* nominal length of the abstract axis. This should not be a performance problem.

              CALL ISIT_CONST_ARR_VAR ( cx, const_arr_var, status )
              IF (const_arr_var) CALL EVAL_EXPR (  cx_last,
     .		                     cmnd(istart:iend), apply_cx, status )

	   ENDIF
* ... RETURN= information request: "repl" contains the keyword
*     Add to this error string when adding new arguments:

           WRITE (return_errmsg,*)  
     .       'use RETURN= shape,size,grid,title,bad,t0,f0,units,dset, '//pCR//
     .	     '  dsetnum,dsetpath,dsettitle,*size,*start,*end,'//pCR//
     .       '  *units,*axis,nc_scale,nc_offset,user_scale,user_offset,'//pCR//
     .       '  calendar,dtype,xmod,tmod,status,isDepth,isReady,defined'
!     .       '  calendar,dtype,xmod,tmod,status,isDepth,isReady,isLoaded' ! w isLoaded

* ... RETURN=SHAPE

 200	   IF ( repl .EQ. "SHAPE" ) THEN
 
	      repl = ' '
	      str_len = 0

	      DO 210 idim = 1, nferdims
	         IF ( CX_DIM_LEN( idim, cx ) .GT. 1 ) THEN

		    IF (grid .EQ. unspecified_int4) 
     .                  grid = GRID_FROM_NAME ( cmnd(istart:iend), cx, status )
		    
* Getting details about the grid of a user-variable

		    i1 = TM_GET_GRIDNUM( cmnd(istart:iend) )
		    uvgrid = (i1 .EQ. unspecified_int4 )
		    uvar = -1
		    IF (uvgrid) uvar = is_uvar(isp)

		    compressed = .FALSE.
		    IF ( uvar_given(idim,uvar) .EQ. uvlim_gvn_xact)  THEN
		       IF (uvar_lo_ss(uvar, idim) .NE. unspecified_int4) THEN
		          i1ss = uvar_lo_ss(uvar, idim)
		          inss = uvar_hi_ss(uvar, idim)
		       ELSE
		          i1ss = TM_SUBSC ( uvar_lo_ww(idim, uvar), grid, idim, -1 )
		          inss = TM_SUBSC ( uvar_hi_ww(idim, uvar), grid, idim, -1 )
		       ENDIF
	               compressed = (i1ss .NE. inss) 
		    ENDIF

		    IF (.NOT.compressed) THEN
	               str_len = str_len + 1
	               repl(str_len:str_len) = ww_dim_name(idim)
	            ENDIF
	         ENDIF
 210	      CONTINUE
	      IF (str_len .EQ. 0) THEN
	         repl = "POINT"
	         str_len = 5
	      ENDIF

* ... RETURN=T0
	   ELSEIF ( repl .EQ. "T0" ) THEN
	      repl = ' '	! default
	      idim = T_DIM
	      axis = CGRID_AXIS ( idim, cx )
	      IF ( axis.NE.mnormal) THEN
	          IF (line_direction(axis) .EQ. 'TI') THEN
    		      repl = line_T0(axis)
                      IF (line_shift_origin(axis)) 
     .                  repl =  '01-JAN-0001 00:00:00'
                  ENDIF
	      ENDIF
	      str_len = TM_LENSTR1(repl)
	      CALL CHECK_DATE_REFORMAT (repl(:str_len*2), str_len, 
     .                    TM_GET_CALENDAR_ID ( line_cal_name(axis)))

* ... RETURN=F0
	   ELSEIF ( repl .EQ. "F0" ) THEN
	      repl = ' '	! default
	      idim = F_DIM
	      axis = CGRID_AXIS ( idim, cx )
	      IF ( axis.NE.mnormal) THEN
	          IF (line_direction(axis) .EQ. 'FI') THEN
    		      repl = line_T0(axis)
                      IF (line_shift_origin(axis)) 
     .                  repl =  '01-JAN-0001 00:00:00'
                  ENDIF
	      ENDIF
	      str_len = TM_LENSTR1(repl)
	      CALL CHECK_DATE_REFORMAT (repl, str_len, 
     .                    TM_GET_CALENDAR_ID ( line_cal_name(axis)))
              
* ... RETURN=CALENDAR
	   ELSEIF ( repl(1:3) .EQ. "CAL" ) THEN
	      repl = ' '	! default
	      axis = CGRID_AXIS ( T_dim, cx )
	      IF ( axis.NE.mnormal) THEN
	          IF (line_direction(axis) .EQ. 'TI' .OR.
     .                line_direction(axis) .EQ. 'TT')
     .		      repl = line_cal_name(axis)
	      ENDIF

* ... RETURN=UNITS
	   ELSEIF ( repl(1:4) .EQ. "UNIT" ) THEN	! or "=UNITS"
	      repl = VAR_UNITS( cx )

* ... RETURN=TITLE
	   ELSEIF ( repl .EQ. "TITLE" ) THEN
	      repl = VAR_TITLE( cx )

* ... RETURN=GRID
	   ELSEIF ( repl .EQ. "GRID" ) THEN
	      repl = grid_name( cx_grid(cx) )

* ... RETURN=DSET, DSETNUM, DSETPATH, DSETTITLE
	   ELSEIF ( repl(1:4) .EQ. "DSET" ) THEN

******************-----------------
* borrow from is_dependencies to get uvar definition and find its dataset
* (is_dependencies has lifted this old-fashioned style code from elsewhere as well.)
* This makes just one try: see if it's a uservar and uvar_text clearly points 
* to a dataset and return that set.  More-complex expressions don't necessarily 
* have a clear dataset.

	      i2 = cx_data_set(cx)
	      IF (cat .EQ. cat_user_var) THEN
	         
	         uvar = cx_variable(cx)
	         item = 1

	         itype = uvar_item_type ( item, uvar )
	         start = uvar_item_start( item, uvar )
	         iend   = uvar_item_end  ( item, uvar )
	         IF ( itype .EQ. alg_variable    ) THEN

* variable: parse name, get expression context
	            name = uvar_text(uvar)(start:iend)
	            len_name = iend-start+1

	            CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	            IF ( status .NE. ferr_ok ) GOTO 5000
	            hi_cx = cx_stack_ptr
	            CALL GET_VAR_CONTEXT (  name(:len_name),
     .				cx,
     .				hi_cx,
     .				var_status )

		    IF (cx_data_set(hi_cx) .GT. pdset_irrelevant) i2 = cx_data_set(hi_cx)

	         ENDIF
	      ENDIF  ! if cat_user_var
	      
******************-----------------

* i2 contains the dataset number

	      IF ( i2 .EQ. pdset_irrelevant
     .	     .OR.  i2 .EQ. unspecified_int4 ) THEN
	         repl = bad_str
	      ELSE
	         IF ( repl .EQ. "DSETNUM") THEN
	            repl = LEFINT(i2, str_len)
	         ELSEIF ( repl .EQ. "DSETPATH" ) THEN
	            CALL GET_DSET_NAME(i2, repl, str_len)
	         ELSEIF ( repl .EQ. "DSET" ) THEN
	            CALL GET_SHORT_DSET_NAME(i2, repl, str_len)
	         ELSEIF ( repl .EQ. "DSETTITLE" ) THEN
	            CALL GET_DSET_TITLE(i2, repl, str_len)
	         ELSE 
	            GOTO 5520
	         ENDIF
	      ENDIF

* ... RETURN=SIZE
	   ELSEIF ( repl .EQ. "SIZE"  .AND. 
     .              INDEX(cmnd(istart:iend),'.') .EQ. 0) THEN

	      i2 = CGRID_SIZE ( cx )
	      repl = LEFINT(i2, str_len)

* The above overflows integer storage? Compute as a real.
	      IF (i2 .LT. 0) THEN  
	         result = 1.
	         DO idim = 1, nferdims
	            i2 = CX_DIM_LEN(idim, cx)
		    result = result * i2
	         ENDDO
		 repl = TM_FMT( result, use_digits, 22, str_len )

	      ENDIF

* ... RETURN=BAD
	   ELSEIF ( repl .EQ. "BAD" ) THEN
	      result = cx_bad_data ( cx )
	      repl = TM_FMT( result, use_digits, 22, str_len )

* ... RETURN=nc_scale, nc_offset
	   ELSEIF ( repl(1:3) .EQ. "NC_" ) THEN
              IF ( repl .EQ. "NC_SCALE" ) THEN
	         CALL GET_NC_SCALE (cx, result)
	      ELSEIF ( repl(1:6) .EQ. "NC_OFF" ) THEN
	         CALL GET_NC_OFFSET (cx, result)
	      ELSE 
	         GOTO 5520
	      ENDIF
	      repl = TM_FMT( result, use_digits, 22, str_len )

* ... RETURN=user_scale, user_offset
	   ELSEIF ( repl(1:5) .EQ. "USER_" ) THEN
              IF ( repl .EQ. "USER_SCALE" ) THEN
	         CALL GET_USER_SCALE (cx, result)
	      ELSEIF ( repl(1:8) .EQ. "USER_OFF" ) THEN
                 CALL GET_USER_OFFSET (cx, result)
	      ELSE 
	         GOTO 5520
	      ENDIF
	      repl = TM_FMT( result, use_digits, 22, str_len )

* ... varname ,RETURN=dtype
	   ELSEIF ( repl .EQ. "DTYPE" .AND. 
     .              INDEX(cmnd(istart:iend),'.') .EQ. 0) THEN
              dset = cx_data_set(cx)
              IF (dset .EQ. pdset_irrelevant .OR. 
     .            dset .EQ. unspecified_int4) dset = pdset_uvars  ! try user vars

              varid = 0
              vartype = 0

              CALL CD_GET_VAR_ID(dset, cmnd(istart:iend), varid, status)

              IF (status .EQ. ferr_ok)  
     .          CALL CD_GET_VAR_TYPE (dset, varid, cmnd(istart:iend), 
     .                              vartype, status )

              IF (vartype.EQ.0 ) THEN  

*  evaluate expr to get type and translate ferret type to netcdf

	         CALL EVAL_EXPR (  cx_last,
     .		                     cmnd(istart:iend), apply_cx, status )
	         IF ( status .NE. ferr_ok ) GOTO 5000
                 fertype = cx_type(cx)

                 IF (fertype .EQ. ptype_unknown) THEN
                    vartype = 0  ! NAT = 'Not A Type' (c.f. NaN) 
                 ELSE IF (fertype .EQ. ptype_float) THEN
                    vartype = 5    ! NC_FLOAT
                 ELSE IF (fertype .EQ. ptype_int4) THEN
                    vartype = 4     ! NC_INT
                 ELSE IF (fertype .EQ. ptype_int2) THEN
                    vartype = 3     ! NC_SHORT
                 ELSE IF (fertype .EQ. ptype_int1) THEN
                    vartype = 1     ! NC_BYTE
                 ELSE IF (fertype .EQ. ptype_char) THEN
                    vartype = 2     ! NC_CHAR
                 ELSE IF (fertype .EQ. ptype_string) THEN
                    vartype = 2   ! NC_CHAR
                 ELSE IF (fertype .EQ. ptype_double) THEN
                    vartype = 6   ! NC_DOUBLE
                 ELSE
                    vartype = 0
                 ENDIF
              ENDIF
              repl = typstring(vartype)

* ... varname.atttnum,RETURN=dtype  or varname.attname, RETURN=dtype
	   ELSEIF ( repl .EQ. "DTYPE" .AND. 
     .              INDEX(cmnd(istart:iend),'.') .GT. 0) THEN
              attype = 0
              dset = cx_data_set(cx)
              IF (cx_data_set(cx) .EQ. pdset_irrelevant) dset = pdset_uvars  ! user vars
              CALL BREAK_VARATTNAME( cmnd(istart:iend), dset, 
     .                    varname, attname, varid, do_err, status )
              CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, 
     .              status)
              IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, varid, 
     .              attid, aname, attype, attlen, attoutflag, status )

              IF (status .EQ. ferr_ok) THEN
                 repl = typstring(attype)
	      ELSE 
	         GOTO 5520
              ENDIF

* ... varname.atttnum,RETURN=size  or varname.attname, RETURN=size
	   ELSEIF ( repl .EQ. "SIZE" .AND. 
     .              INDEX(cmnd(istart:iend),'.') .GT. 0) THEN
              IF (.NOT. coordvar) dset = cx_data_set(cx)
              IF (dset .GE. 1) THEN
                 IF (coordvar) THEN

                    IF (INDEX(buff,'.') .GT. 0)
     .              CALL BREAK_VARATTNAME( cmnd(istart:iend), dset, varname, 
     .                              attname,  varid, do_err, status )

                 ELSE
                    CALL CD_GET_VAR_ID (dset, cmnd(istart:iend), varid,
     .                  status)
                    
                    IF (status .NE. ferr_ok .AND. 
     .                  INDEX(cmnd(istart:iend),'.') .GT. 0) THEN
                       CALL BREAK_VARATTNAME( cmnd(istart:iend), dset,
     .                         varname, attname, varid, do_err, status )
                    ELSE
                       i2 = CGRID_SIZE ( cx )
                       repl = LEFINT(i2, str_len) 
                       GOTO 500
                    ENDIF

                 ENDIF
                 
                 CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, 
     .               status)
                 IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, varid,
     .               attid, aname,  attype, attlen, attoutflag, status )

                 IF (status .EQ. ferr_ok) THEN
                    IF (attlen .GT. 0) THEN
                       result = attlen
                       repl = TM_FMT( result, use_digits, 22, str_len )
                    ENDIF
	         ELSE 
	            GOTO 5520
                 ENDIF
              ENDIF

* ... RETURN=XMOD
	   ELSEIF ( repl .EQ. "XMOD" ) THEN
	      repl = ' '	! default
	      axis = CGRID_AXIS ( X_dim, cx )
	      IF ( axis.NE.mnormal) THEN
	         IF (line_modulo(axis)) THEN
                    result = line_modulo_len(axis)

! If axis has modulo=" ", and units are not degrees, mod len = axis len.
                    IF (result .EQ. 0) result = TM_WW_AXLEN(axis)
                    repl = TM_FMT( result, use_digits, 22, str_len)
                 ENDIF
	      ENDIF

* ... RETURN=TMOD
	   ELSEIF ( repl .EQ. "TMOD" ) THEN
	      repl = ' '	! default
	      axis = CGRID_AXIS ( T_dim, cx )
	      IF ( axis.NE.mnormal) THEN
	         IF (line_modulo(axis)) THEN
                    result = line_modulo_len(axis)

! If axis has modulo=" ", mod len = axis len.
                    IF (result .EQ. 0) result = TM_WW_AXLEN(axis)
                    repl = TM_FMT( result, use_digits, 22, str_len)
                 ENDIF
	      ENDIF

* ... RETURN=ISDEPTH
	   ELSEIF ( repl(1:3) .EQ. "ISD" ) THEN
	      repl = '0'	! default, pos=up, or not-depth.
	      axis = CGRID_AXIS ( Z_dim, cx )
	      IF ( axis.NE.mnormal) THEN
	         IF (line_direction(axis) .EQ. "UD") repl = '1'
	      ELSE 
	         repl = 'NORMAL'
	      ENDIF

* ... RETURN=ISLOADED
!	   ELSEIF ( repl(1:4) .EQ. "ISLO" ) THEN
!* see is an mr variable matching this cx is already in memory
!	      CALL FIND_MEM_VAR( cx, mr, search_by_value )
!	      IF ( mr.EQ.mr_nonexist ) THEN
!	         repl = '0'
!	      ELSE
!	         repl = '1'
!	      ENDIF
!	   
* ... RETURN=*SIZE, *START, *END, *UNITS, *AXIS
	   ELSE	
* ... axis specific requests - must start with i,j,k,l,m,n or x,y,z,t,e,f
	      DO 220 idim = 1, nferdims
	         IF ( repl(1:1) .EQ. ss_dim_name(idim) ) THEN
	            itsa_subsc = .TRUE.
	            GOTO 221
	         ELSEIF ( repl(1:1) .EQ. ww_dim_name(idim) ) THEN
	            itsa_subsc = .FALSE.
	            GOTO 221
	         ENDIF
 220	      CONTINUE
	      GOTO 5520
 221	      need_formatting = .TRUE.
	      IF ( repl(2:5) .EQ. "SIZE" ) THEN
	         IF (.NOT.itsa_subsc) GOTO 5520
	         i2 = CX_DIM_LEN(idim, cx)
	      ELSEIF ( repl(2:6) .EQ. "START" ) THEN
	         i2 = cx_lo_ss(cx,idim)
	      ELSEIF ( repl(2:4) .EQ. "END" ) THEN
	         i2 = cx_hi_ss(cx,idim)
	      ELSEIF ( repl(2:5) .EQ. "AXIS" ) THEN
	         axis = CGRID_AXIS ( idim, cx )
	         IF (axis.EQ.mnormal .OR. axis.EQ.munknown) THEN
	           repl = 'NORMAL'
	         ELSE
* Get axis name. If mode upcase is canceled, use original spelling if defined
		    orig_name = .FALSE.
		    CALL CHOOSE_LINE_NAME(axis, orig_name, repl)
	         ENDIF
	         need_formatting = .FALSE.
	      ELSEIF ( repl(2:5) .EQ. "UNIT" ) THEN
	         axis = CGRID_AXIS ( idim, cx )
	         IF (axis.EQ.mnormal .OR. axis.EQ.munknown) THEN
	           repl = ' '
	         ELSE
	           repl = line_units( axis )
	         ENDIF
	         need_formatting = .FALSE.

* Get the units attribute from the dataset. 
* User-defined true-month axes are shown in days.
	         IF ( repl(1:8) .EQ. "TRUMONTH") THEN
	            dset = cx_data_set( cx )
		    aname = 'days'
c	            IF (dset .GT. pdset_irrelevant) THEN
c	               CALL GET_ORIGINAL_UNITS (dset, cx_grid(cx), aname, ucode)
c	               IF (ucode .NE. 0) repl = aname
c		    ENDIF
		 ENDIF

	      ELSE
	         GOTO 5520
	      ENDIF
	      IF ( need_formatting ) THEN
	         IF ( itsa_subsc) THEN
	            IF (i2 .EQ. unspecified_int4) i2 = 0
	            repl = LEFINT(i2, str_len)
	         ELSE
	            ww = TM_WORLD(i2, cx_grid(cx), idim, box_middle)
! unimplemented code to allow user to control format
!	            IF ( fmt .NE. ' ' ) THEN
!*    ... use user-specified time format
!	              CALL TRANSLATE_FORMATTED( ww, idim, cx_grid(cx),
!     .					        fmt, bad_str, repl )
!	            ELSE
*   ... default formatting for world coordinates
*       ndec is precision when positive, number of sig digits when negative
	              CALL TRANSLATE_TO_WORLD( ww, idim, cx_grid(cx),
     .				               -use_digits, repl )
!	            ENDIF
	         ENDIF
	      ENDIF
	   ENDIF
	   str_len = TM_LENSTR1(repl)

	ELSE
* single number answer desired
* ... evaluate the expression

	   cx_only = .FALSE.
	   CALL EVAL_EXPR (  cx_last, cmnd(istart:iend), 
     .        .TRUE., status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   cx = is_cx(1)	! always comes back as the first context
	   mr = is_mr(1)

* ... make sure the result is a single, valid value
	   
	   is_dsg = .FALSE.
	   IF ( CGRID_SIZE(cx) .NE. 1 ) THEN

*    For DSG grids the requested region may be just in the WW context in E
	      is_dsg = TM_ITSA_DSG( cx_grid(cx) )
	      IF (CGRID_SIZE(cx).GT.1 .AND. is_dsg ) THEN  
	         siz = 1
		 ifeature = 0
	         DO idim = x_dim, t_dim
	      	      siz = siz * (
     .                 cx_hi_ss(cx,idim)  - cx_lo_ss(cx,idim) + 1 )
	      	      IF (cx_lo_ss(cx, idim) .NE. unspecified_int4) 
     .                 ifeature = cx_lo_ss(cx,idim)
	         ENDDO
	         siz = siz * ( 
     .               cx_hi_ww(e_dim,cx) - cx_lo_ww(e_dim,cx) + 1 )
	         siz = siz * ( 
     .               cx_hi_ss(cx,f_dim) - cx_lo_ss(cx,f_dim) + 1 )
	         IF (siz .NE. 1) GOTO 5200

		 IF (ifeature.EQ.0 .AND. 
     .               cx_hi_ww(e_dim,cx).NE.unspecified_val8) 
     .                 ifeature = cx_hi_ww(e_dim,cx)
		 IF (ifeature.EQ.0 .AND. 
     .               cx_hi_ww(f_dim,cx).NE.unspecified_val8) 
     .                 ifeature = cx_hi_ww(f_dim,cx)
		 IF (ifeature .EQ. 0) ifeature = 1
	      ELSE
	         IF ( CGRID_SIZE(cx) .NE. 1 ) GOTO 5200	! result not a scalar
	      ENDIF

	   ENDIF

* ... extract the result scalar from the (possibly larger) memory variable
	   CALL CREATE_TEMP_MEM_VAR( cx, mr_temp, status )
	   IF ( status .NE. ferr_ok ) RETURN

	   CALL COPY_GRID( memry(mr)%ptr, mr,
     .                     memry(mr_temp)%ptr, mr_temp )

           IF (is_dsg) CALL DSG_ONE_INSTANCE_VAL (mr, mr_type(mr_temp), 
     .                           ifeature, result, repl, max_len, str_len)

	   IF (mr_type(mr_temp) .EQ. ptype_string ) THEN

* ... get one string


	     IF (.NOT. is_dsg) repl =  GET_STRING_ELEMENT(
     .				mr_lo_s1(mr_temp), mr_hi_s1(mr_temp),
     .				mr_lo_s2(mr_temp), mr_hi_s2(mr_temp),
     .				mr_lo_s3(mr_temp), mr_hi_s3(mr_temp),
     .				mr_lo_s4(mr_temp), mr_hi_s4(mr_temp),
     .				mr_lo_s5(mr_temp), mr_hi_s5(mr_temp),
     .				mr_lo_s6(mr_temp), mr_hi_s6(mr_temp),
     .				memry(mr_temp)%ptr,
     .				cx_lo_s1(cx), cx_lo_s2(cx),
     .				cx_lo_s3(cx), cx_lo_s4(cx),
     .				cx_lo_s5(cx), cx_lo_s6(cx),
     .				max_len, str_len)
	   ELSE

	     IF (.NOT. is_dsg) result =  memry(mr_temp)%ptr(1)

	     IF ( result .EQ. mr_bad_data(mr) ) THEN
	        repl = bad_str
	        str_len = TM_LENSTR1(bad_str)
	     ELSE
                repl = TM_FMT(result, use_digits, 48, str_len)
* Did the large allowed string length result in a string like 0.00000001 or 7.499999999999 ?  
* If so see if we can return a nicer string that is essentially the same numeric value.
* First try 24, then 16.
                shorterlen = 24
  400           dotidx = INDEX(repl, '.')
                IF ( (dotidx .GT. 0) .AND. (use_digits .GT. 0) .AND.
     .               ( (INDEX(repl,'000000') .GT. dotidx) .OR.
     .                 (INDEX(repl,'999999') .GT. dotidx) ) ) THEN
                   buff = TM_FMT(result, use_digits, shorterlen, itmp)
                   IF ( buff(1:1) .NE. '*' ) THEN
                      READ (buff,*) aval
                      IF ( TM_DFPEQ(result, aval) ) THEN
                         repl = buff
                         str_len = itmp
                         IF ( shorterlen .GT. 16 ) THEN
                            shorterlen = 16
                            GOTO 400
                         ENDIF
                      ENDIF
                   ENDIF
                ENDIF
	     ENDIF
	   ENDIF
* ... clean up temporary variable
	   CALL DELETE_VARIABLE( mr_temp )
	ENDIF

* adjust the field width if requested by the user
 500	IF (use_width .GT. 0) THEN
	   IF (str_len .LT. use_width) THEN
	      i2 = use_width - str_len
	      DO i = use_width, i2+1, -1   ! shift characters to right
	        repl(i:i) = repl(i-i2:i-i2)
	      END DO
	      DO i = 1, i2
	        IF (zero_fill) THEN
	          repl(i:i) = '0'
	        ELSE
	          repl(i:i) = ' '
	        ENDIF
	      END DO
	   ENDIF
	   str_len = use_width
	ENDIF

* replace the expression text (incl grave accents) with the formatted string
	IF ( (istart-1)+str_len+(lencmnd-true_end-1) .GT. lenbuff ) THEN
           GOTO 5400					! too big to fit
        ELSE
	   IF ( iend+2 .LE. lencmnd ) THEN
	      risc_buff = cmnd(true_end+2:)
	   ELSE
	      risc_buff = ' '
	   ENDIF
           cmnd(istart-1:) = repl(:str_len) // risc_buff
           lencmnd = lencmnd - ((true_end-istart+3) - str_len)
        ENDIF


* successful translation of a grave-accented expression
 1000	did_sub = .TRUE.

* restore the state of uvar grids etc changed here for returns 
* that need the grid, such as *size, shape. The uvar.GT.0 is 
* checking for "packed" uvar-context info as set in const_var_context

        IF (cx_only) THEN
	   CALL RESET_UVAR_GRIDS
	   CALL FREE_LINE_DYNMEM(uvar_cx_only_lm)

	   cx_only = .FALSE.

	ENDIF

	RETURN

* error exits
 5050	CALL RELEASE_DYN_WORK_SPACE
 5000   RETURN
 5100	risc_buff = cmnd(:lencmnd)
	CALL ERRMSG( ferr_syntax, status,
     .       'unpaired grave accents: '//risc_buff, *5000)
 5200	risc_buff = cmnd(istart:iend)
	CALL ERRMSG( ferr_invalid_command, status,
     .       'grave accent doesnt evaluate to scalar'//pCR
     .                                  //risc_buff, *5000)
 5400	risc_buff = cmnd(istart:iend)
	CALL ERRMSG( ferr_invalid_command, status,
     .       'grave accent evaluates to string too long'//pCR
     .					//risc_buff, *5000)
 5500	risc_buff = cmnd(:lencmnd)
	CALL ERRMSG( ferr_syntax, status,
     .       'options: "P=prec","B=bad","W=width","ZW=zero-width" or'
     .	     //' "R=return-item"'//pCR//risc_buff, *5000)
 5510	risc_buff = cmnd(i:qual_end)
	CALL ERRMSG( ferr_invalid_command, status,
     .       'maximum precision is 16 digits: '
     .					//risc_buff, *5000)
 5520   risc_buff = cmnd(i:qual_end)
	CALL ERRMSG( ferr_invalid_command, status,
     .     return_errmsg//pCR//risc_buff, *5000)
	END

	SUBROUTINE IS_REVERSE(  *, *, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* reverse the ordering of the data along the axes indicated in ds_ordering
* and delete the (backwards) component data from memory

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V320: 2/16/95
* V411: 9/11/95 (IBM port) array "reversed" is declared wrong type
* V500: 7/99 *sh* is strides were applied to reversed axes need special
*	handling of the limits
* V541: 2/02 *sh* - bug fix -- 6/01 changes in the handling of delta strides
*			(see read_tm.F) were not propagated to this routine
* V602  8/06 *jli* chages for native strides 
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'

!        include 'tmap_errors.parm'
!        include 'implicit.parm'
        include 'xtm_grid.cmn_text'
        external xgt_grid_data

* calling argument declarations:
	INTEGER	status
* normal return is for error conditions
* exit #1 is to request another grid ( stack has been pushed )
* exit #2 is to signal completion of the activity at this stack level

*   ... interpretation stack setup at the time this is called ...
*	stack level		stack contents
*	isp+1	<--	level of last activity ( component just computed )
*	 isp	<--	current stack level (for moduloing )

* internal variable declarations:
	INTEGER TM_AXES_REVERSED, nrev,
     .		com_mr, res_mr, com_cx, res_cx,	com_isp, res_isp,
     .		axis, i, var, hi_ss, lo_ss, itmp, reversed(nferdims),
     .          grid, line

* --- end of introductory code ---

* Routine IS_STRIP requests the reversed component data under
* the special category cx_category=cat_revfile

* initialize
	res_isp    = isp
	com_isp    = isp + 1
	com_mr     = is_mr( com_isp )
	res_cx     = is_cx( res_isp )
	com_cx     = is_cx( com_isp )
	axis       = is_axis( res_isp )
	var	   = cx_variable(com_cx)

* get the list of reversed axes
	nrev = TM_AXES_REVERSED(var, reversed)

* diagnostic mode output: " doing modulo VAR_NAME[x=lo:hi,D=#]"
	IF ( mode_diagnostic ) 	CALL DIAG_OP
     .				( 'doing',isact_class_reverse, res_cx, axis )

!* strides indicated in cx_delta e.g. SST[I=110:180:10] ?
!* If so, transfer this info to the stride array
!        has_a_stride = .FALSE.
!        DO 100 idim = 1, nferdims
!           has_strides(idim) =  cx_delta(idim,res_cx) .NE. unspecified_val8
!     .                   .AND.  cx_delta(idim,res_cx) .NE. 1 
!           IF (has_strides(idim))  has_a_stride = .TRUE.
! 100    CONTINUE

!* if strides are invloved memory requirement is less ... (cloned from READ_TM)
!* 2/02 -- no longer necessary or appropriate
!        CALL TRANSFER_CONTEXT(res_cx, cx_buff)
!        IF (has_a_stride) THEN
!           DO 200 idim = 1, nferdims
!              IF  (has_strides(idim)) THEN
! 1  	cx_lo_ss( cx_buff, idim ) = 1 
!               cx_hi_ss( cx_buff, idim ) = 
!     .                (cx_hi_ss(res_cx,idim) - cx_lo_ss(res_cx,idim))
!     .              / INT(cx_delta(idim,res_cx))  + 1
!                 cx_delta(idim,res_cx) = unspecified_val8
!              ENDIF
! 200      CONTINUE
!        ENDIF

* create the space for the result in memory
	CALL CREATE_MEM_VAR( res_cx, res_mr, status )
	IF ( status .NE. ferr_ok ) GOTO 5100
	is_mr( res_isp ) = res_mr

* the component data thinks that its subscripts are from "the other end" of
* the axis (from whence the data were read).  In order to prevent subscript
* errors we will disabuse the data of that misconception atthis point
	DO 300 i = 1, nrev
	   axis = reversed(i)
!	   IF (has_strides(axis)) GOTO 300	  ! already handled above


	   CALL VAR_SS_LIMS( axis, res_cx, lo_ss, hi_ss )

!      for a strided axis
           grid = cx_grid(res_cx)
           line = grid_line(axis,grid)
           IF( line_parent(line) .NE. 0 ) THEN
              lo_ss=line_dim(line)
              hi_ss=1
           ENDIF

	   itmp = mr_lo_ss( com_mr, axis )
	   mr_lo_ss(com_mr,axis) = hi_ss + lo_ss - mr_hi_ss(com_mr,axis)
	   mr_hi_ss(com_mr,axis) = hi_ss + lo_ss - itmp
 
	   itmp = cx_lo_ss( com_cx, axis )
	   cx_lo_ss(com_cx,axis) = hi_ss + lo_ss - cx_hi_ss(com_cx,axis)
	   cx_hi_ss(com_cx,axis) = hi_ss + lo_ss - itmp
 
 300	CONTINUE

* copy the source data into the result
	CALL COPY_INTO(
     .    memry(com_mr)%ptr, com_mr, com_cx,
     .    memry(res_mr)%ptr, res_mr   )

* reverse the result along all of the required axes
	DO 400 i = 1, nrev
	   CALL REVERSE_GRID_AXIS
     .		( reversed(i), res_cx, res_mr,memry(res_mr)%ptr )
 400	CONTINUE

* successful completion of modulo operation
 1000	CALL MR_NOT_IN_USE( com_mr )	! remove memory protection on component
	CALL DELETE_VARIABLE( com_mr )  ! delete reversed component data
	cx_stack_ptr = cx_stack_ptr - 1 ! pop com_cx from context stack
	status = ferr_ok
	RETURN 2

* error exits
 5000	RETURN
 5100	CALL MR_NOT_IN_USE( com_mr )
	CALL DELETE_VARIABLE( com_mr )  ! delete reversed component data
	GOTO 5000
	END	

	SUBROUTINE DOLLAR_COMMAND( cmnd,lencmnd,goline,did_sub,status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* parse the command line replacing "dollar" arguments in GO files
* with the appropriate strings

* formats supported:
*	$n 		- argument n (1 through max)
*	$0		- name of Go file
*	$*		- all arguments, 1 through max
*       ($nn)	        - to allow 2-digit argument numbers
* these may be followed by the coached string substitution options
* described in coached_str_sub.F

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V300: 4/21/93
*       5/28/93 - ignore $'s that aren't followed by digits or special chars
* V301: 2/15/94 - allow "*" as a choice that matches all args
* V320 8/94 *kob* - IBM port - had to use risc buff for string concats
*      11/94 *sh* - IBM port - one more application of risc buff at line 500
*     3/2/95 *sh* - allow "*" to appear in the RIGHT hand side of the
*		    substitution string
*     3/24/95  - fix bug introduced 3/2 
* V420	2/29/96	- detach the "coaching" code into a separate routine so it
*		can be used in symbol substitution as well
* V510: 3/00 *sh* bug fix - in the syntax "$1" the final " caused iptr mis-set
* V531: 4/01 *sh* - allow 2-digit argument numbers
*		  - increased argument buffers 255 -> 511
* 2/03 *kob* - g77 port - g77 won't allow intrinsic functions in PARAMETER
*                         statements.  use character constant instead
*            - Need to use risc_buff for arbitrary concatenations
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

        IMPLICIT NONE
* calling argument declarations:
	LOGICAL   did_sub
	INTEGER	  lencmnd, status
	CHARACTER cmnd*(*), goline*(*)

* internal variable declarations:
* d default string
* e error string
* o options string
* r replacement strings

	LOGICAL coaching, in_squote, has_parens
	INTEGER	TM_LENSTR1,
     .		lenbuff, iptr, dollar, lenarg, nexchar, idig
        CHARACTER arg*511, passed_arg*511, c1*1, carg*2

* local parameter declarations
        CHARACTER*1     sing_quote
        CHARACTER*1	tab
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
        PARAMETER     ( sing_quote = o'047' )
#else
	PARAMETER     ( tab = CHAR(9))
        PARAMETER     ( sing_quote = CHAR(39) )
#endif

	include 'ferret.parm'
	include 'errmsg.parm'
	include 'gfdl_vms.parm'
	include 'xrisc.cmn'

* initialize
	nexchar = 1
	did_sub = .FALSE.
	status = ferr_ok
        lenbuff = LEN( cmnd )
	in_squote = .FALSE.

* init for next dollar arg
 10	coaching = .FALSE.
	in_squote = .FALSE.

* locate the next dollar sign  (ignore "$" as last character in command)
	DO 50 dollar = nexchar, lencmnd-1
	   c1 = cmnd(dollar:dollar)
	   IF ( c1 .EQ. sing_quote ) THEN
	      in_squote = .NOT.in_squote
	   ELSEIF ( in_squote ) THEN
	      CONTINUE                     ! to protect PLOT+ 'PPL$WIDTH', etc.
	   ELSEIF ( c1 .EQ. '$' ) THEN     ! 5/93 ignore if wrong carg
	      carg = cmnd(dollar+1:dollar+1)
	      IF ( carg .EQ. '*'
     .        .OR. carg .EQ. '<'
     .	      .OR. (carg.GE.'0' .AND. carg.LE.'9') ) GOTO 60
	   ENDIF
 50	CONTINUE

* done - no more dollar signs (could check in_squote for syntax error ...)
	RETURN

* found a significant "$"
 60	CONTINUE

* note: multiple digit argument number must be enclosed in parentheses.
* this because $15 might legitimately be "$1" prepended to "5"

* is this a paren-surrounded argument number?
* Note: the parsing actually gets done twice ... this is an add-on hack!
* check syntax: ($nn%stuff%)
	has_parens = .FALSE.
	IF (dollar .GT. 1) THEN
	   IF (cmnd(dollar-1:dollar-1) .NE. '(') GOTO 65
	   IF (carg.LT.'0' .OR. carg.GT.'9') GOTO 65
	   iptr = dollar+2
	   IF (iptr .GT. lencmnd) GOTO 65
	   c1 = cmnd(iptr:iptr)
	   IF (c1.GE.'0' .AND. c1.LE.'9') iptr = iptr + 1
	   IF (iptr .GT. lencmnd) GOTO 65
	   c1 = cmnd(iptr:iptr)
           coaching = c1.GE.'!' .AND. c1.LE.'&'
	   IF (coaching) THEN
             DO 62 iptr = iptr+1, lencmnd
                 IF ( cmnd(iptr:iptr) .EQ. c1 ) GOTO 64
 62	      CONTINUE
              GOTO 65       ! unterminated option string - red herring?
 64	      iptr = iptr + 1
	      IF (iptr .GT. lencmnd) GOTO 65
	      c1 = cmnd(iptr:iptr)
	   ENDIF
	   IF (c1 .NE. ')') GOTO 65
	   has_parens = .TRUE.
	ENDIF
 65	CONTINUE

* find a second digit, if any
	nexchar = dollar + 2
	IF (carg.GE.'0' .AND. carg.LE.'9'
     .	.AND. lencmnd .GT. dollar+1 ) THEN
	   DO 70 iptr = dollar+2, lencmnd
	     IF (cmnd(iptr:iptr).LT.'0'.OR.cmnd(iptr:iptr).GT.'9') GOTO 72
 70	   CONTINUE
 72	   carg = ' '
	   idig = iptr-dollar-1
	   IF ( idig.GT.2 ) GOTO 5150
	   carg(dollar-iptr+4:2) = cmnd(dollar+1:iptr-1) ! right justify
	   nexchar = iptr  ! next character after digits (changes later)
	ELSE
	   idig = 1
	   c1 = carg(1:1)
	   carg = ' '
	   carg(2:2) = c1  ! right justify
	ENDIF

	IF (has_parens) THEN
	   dollar = dollar - 1 ! text to replace starts at "("
	ENDIF

* is there a coaching string following  "$x" ?  (e.g. $1"default string")
        coaching = nexchar+1 .LE. lencmnd
        IF ( coaching ) THEN
           c1 = cmnd(nexchar:nexchar)
           coaching = c1.GE.'!' .AND. c1.LE.'&'
        ENDIF

* locate the matching terminator of the coaching string
        IF ( coaching ) THEN
           DO 100 iptr = nexchar+1, lencmnd
              IF ( cmnd(iptr:iptr) .EQ. c1 ) GOTO 200
 100       CONTINUE
           coaching = .FALSE.       ! unterminated option string - red herring?
        ENDIF

* get the argument given on the command line
 200    CALL DOLLAR_ARG( carg, goline, arg, lenarg, status )
        IF ( status .NE. ferr_ok ) RETURN
	passed_arg = arg	! a copy used for fancy editing 3/2

* modify the argument if coaching was provided
	IF ( coaching ) THEN
	   IF (nexchar+1 .GT. iptr-1) GOTO 5400
	   CALL COACHED_STR_SUB('argument $'//carg(3-idig:), passed_arg,
     .		cmnd(nexchar+1:iptr-1), arg, lenarg, status ) 
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   nexchar = iptr+1   ! after termination of coaching
	ELSEIF ( arg .EQ. " " ) THEN
	   GOTO 5500
	ENDIF

* move past closinging paren
	IF (has_parens) THEN
	   DO 210 iptr = nexchar, lencmnd
	      IF ( cmnd(iptr:iptr) .EQ. ')' ) THEN
	        nexchar = iptr + 1
	        GOTO 300
	      ELSEIF ( cmnd(iptr:iptr) .NE. ' '
     .	       .AND.   cmnd(iptr:iptr) .NE. tab ) THEN
	        GOTO 5300   ! should never arrive here
	      ENDIF
 210	   CONTINUE
	   GOTO 5300
	ENDIF

* replace "$n..." with argument text or coached alternative
 300	IF ( (dollar-1)+lenarg+(lencmnd-nexchar-1) .GT. lenbuff ) THEN
           GOTO 5100
        ELSE
	   iptr = lencmnd ! temporary buffer
	   risc_buff = cmnd(nexchar:)
           cmnd(dollar:) = arg(1:lenarg) // risc_buff
           lencmnd = (dollar-1) + lenarg + (lencmnd-nexchar+1)   ! new length
	   nexchar = nexchar + (lencmnd-iptr) ! shift by increase of cmnd len
        ENDIF

* go back for the next argument
        did_sub = .TRUE.
        GOTO 10

* error exits
 5000   RETURN
 5100   CALL ERRMSG( ferr_invalid_command, status,
     .       'command argument strings are too long', *5000)
 5150	risc_buff = cmnd(dollar:iptr)
	CALL ERRMSG( ferr_syntax, status,
     .       'arg number not in 1-99 range: '//risc_buff, *5000 )
 5300   risc_buff = cmnd(dollar:iptr)
	CALL ERRMSG( ferr_syntax, status,
     .       'missing closing paren: '//risc_buff, *5000 )
 5400   risc_buff = cmnd(dollar:iptr)
	CALL ERRMSG( ferr_syntax, status,
     .       'empty argument replacement string: '//risc_buff,
     .		 *5000 )
 5500   risc_buff = goline
	CALL ERRMSG( ferr_invalid_command, status,
     .       'Value needed for argument '//carg(3-idig:)//' in command'//
     .        pCR//'GO '//risc_buff(:TM_LENSTR1(goline)), *5000)

	END

	SUBROUTINE CONFINE_CONTEXT( cx, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* given a skeletal context with a known grid confine the context limits to
* within the grid limits
* if date/time limits were specified convert to time steps here

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 5/5/88  - code lifted from FINISH_1_CONTEXT_MOD
* revision 0.1 - 7/8/88  - avoid wiping out half of xy_ave transform
* revision 0.2 - 7/28/88 - simplified date processing (no mixed dates/tsteps)
* revision 0.3 - 1/12/89 - new error report for munknown axis
* V200:  5/26/89 - removed bulk of routine to CONFINE_AXIS
* V230:  7/20/92 - bug in error trapping fixed
* *kob* 11/96   - Linux port.  Linux didn't like tabs between "include"
*                 and what was being included.  removed them
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xcontext.cmn'
	include 'xtext_info.cmn'

* calling argument declarations:
	INTEGER	cx, status

* internal variable declarations:
	INTEGER	idim

	DO 500 idim = 1, nferdims
    	   CALL CONFINE_AXIS( idim, cx, status )
           IF ( status .NE. ferr_ok ) RETURN      ! 7/92 bug fix
 500    CONTINUE

	RETURN
	END

	SUBROUTINE MERGIFY_CX( dflt_cx, uvar, cx, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* impose a "merged look" on context cx by setting the data set to the default,
* an dsetting the grid to the merged grid

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V510 5/00 *sh* set the bad value flag for the merged context
* V533 7/01 *sh* - set the data type of the result
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xfr_grid.cmn'

* calling argument declarations
	INTEGER	dflt_cx, uvar, cx, status

* local variable declarations
	INTEGER	KNOWN_GRID, idim

* impose default data set or no data set as appropriate
	IF ( uvar_need_dset( uvar ) ) THEN
	   cx_data_set( cx ) = cx_data_set( dflt_cx )
	ELSE
	   cx_data_set( cx ) = pdset_irrelevant
	ENDIF

* point context to this user variable
	cx_variable( cx ) = uvar
	cx_category( cx ) = cat_user_var

* get the missing value flag that corresponds to this variable
	CALL GET_CONTEXT_BAD_FLAG( cx )

* impose merged grid
	cx_grid( cx ) = KNOWN_GRID( cx_data_set(cx), cat_user_var, uvar )
	cx_unstand_grid( cx ) = .FALSE.

* set the result data type (valid 
	CALL KNOWN_DATA_TYPE(cx)

* wipe out any transformations from first component of merged context
	DO 100 idim = 1, nferdims
	   cx_trans    ( idim, cx ) = trans_no_transform
	   cx_trans_arg( idim, cx ) = bad_val4
 100	CONTINUE

	RETURN

* error exit
! 5000	RETURN
	END

      SUBROUTINE maxMINMAX  (Z, L, MM, NN, neigh_x, neigh_y, badz, 
     .                      zmaxlist, nzmax)
C
C  based on NCAR routine MINMAX, return maxima
C  From the NCAR graphics library at http://ngwww.ucar.edu version 4.2
C  Modified by Ansley Manke to regurn only the maxima for subroutine findhi.F
C
C-------------------------------------------------------------
C	$Id: maxminmax.F 12378 2011-06-28 20:07:59Z ksmith $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C This file is free software; you can redistribute it and/or modify
C it under the terms of the GNU General Public License as published
C by the Free Software Foundation; either version 2 of the License, or
C (at your option) any later version.
C
C This software is distributed in the hope that it will be useful, but
C WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
C General Public License for more details.
C
C You should have received a copy of the GNU General Public License
C along with this software; if not, write to the Free Software
C Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
C USA.
C-------------------------------------------------------------

CC THIS ROUTINE FINDS RELATIVE MINIMUMS AND MAXIMUMS.  A RELATIVE MINIMUM
C (OR MAXIMUM) IS DEFINED TO BE THE LOWEST (OR HIGHEST) POINT WITHIN
C A CERTAIN NEIGHBORHOOD OF THE POINT.  THE NEIGHBORHOOD USED HERE
C IS + OR - MN IN THE X DIRECTION AND + OR - NM IN THE Y DIRECTION.
C
C ORIGINATOR       DAVID KENNISON

C  Ansley Manke changes for Ferret 7/01
C	- remove sections that put label on plot
C	- use "bad value" rather than SPECIAL VALUE, SPVAL
C	- remove references to IOFFP, JOFFDT
c	- new code and my comments in lowercase
c	- return maxes.  For n = 1, nzmax:
c	    zmaxlist(1,n) = i index of zmax point
c	    zmaxlist(2,n) = j index of zmax point
c	    zmaxlist(3,n) = z value at zmax point
C
      integer	L, MM, NN, m, n, nm1, mm1, jp, im, mn, ip, is, it, ii,
     .		js, nm, jt, jk, ik, nzmax, neigh_x, neigh_y

      real	Z(L,NN), aa, an, badz, zmaxlist(3,*)
C
      M = MM
      N = NN

c      MN = min(2,MAX(2,IFIX(FLOAT(M)/8.)))
c      NM = min(2,MAX(2,IFIX(FLOAT(N)/8.)))

      MN = neigh_x
      NM = neigh_y

      nzmax = 0
C
      NM1 = N-1
      MM1 = M-1
C
C LINE LOOP FOLLOWS - THE COMPLETE TWO-DIMENSIONAL TEST FOR A MINIMUM OR
C MAXIMUM OF THE FIELD IS ONLY PERFORMED FOR POINTS WHICH ARE MINIMA OR
C MAXIMA ALONG SOME LINE - FINDING THESE CANDIDATES IS MADE EFFICIENT BY
C USING A COUNT OF CONSECUTIVE INCREASES OR DECREASES OF THE FUNCTION
C ALONG THE LINE
C
      DO 127 JP=2,NM1
C
         IM = MN-1
         IP = -1
         GO TO 126
C
C CONTROL RETURNS TO STATEMENT 10 AS LONG AS THE FUNCTION IS INCREASING
C ALONG THE LINE - WE SEEK A POSSIBLE MAXIMUM
C
  101    IP = IP+1
         AA = AN
         IF (IP .EQ. MM1) GO TO 104
         AN = Z(IP+1,JP)
         IF (AN.EQ.badz) GO TO 125
         IF (AA-AN) 102,103,104
  102    IM = IM+1
         GO TO 101
  103    IM = 0
         GO TO 101
C
C FUNCTION DECREASED - TEST FOR MAXIMUM ON LINE
C
  104    IF (IM .GE. MN) GO TO 106
         IS = max(1,IP-MN)
         IT = IP-IM-1
         IF (IS .GT. IT) GO TO 106
         DO 105 II=IS,IT
            IF (AA .LE. Z(II,JP)) GO TO 112
  105    CONTINUE
  106    IS = IP+2
         IT = min(M,IP+MN)
         IF (IS .GT. IT) GO TO 109
         DO 108 II=IS,IT
            IF (Z(II,JP).NE.badz) GO TO 107
            IP = II-1
            GO TO 125
  107       IF (AA .LE. Z(II,JP)) GO TO 112
  108    CONTINUE
C
C WE HAVE MAXIMUM ON LINE - DO TWO-DIMENSIONAL TEST FOR MAXIMUM OF FIELD
C
  109    JS = max(1,JP-NM)
         JT = min(N,JP+NM)
         IS = max(1,IP-MN)
         IT = min(M,IP+MN)
         DO 111 JK=JS,JT
            IF (JK .EQ. JP) GO TO 111
            DO 110 IK=IS,IT
               IF (Z(IK,JK).GE.AA .OR. (Z(IK,JK).EQ.badz)) GO TO 112
  110       CONTINUE
  111    CONTINUE

	 nzmax = nzmax + 1
	 zmaxlist(1,nzmax) = float(ip)
	 zmaxlist(2,nzmax) = float(jp)
	 zmaxlist(3,nzmax) = z(ip,jp)

  112    IM = 1
         IF (IP-MM1) 113,127,127
C
C CONTROL RETURNS TO STATEMENT 20 AS LONG AS THE FUNCTION IS DECREASING
C ALONG THE LINE - WE SEEK A POSSIBLE MINIMUM
C
  113    IP = IP+1
         AA = AN
         IF (IP .EQ. MM1) GO TO 116
         AN = Z(IP+1,JP)
         IF (AN.EQ.badz) GO TO 125
         IF (AA-AN) 116,115,114
  114    IM = IM+1
         GO TO 113
  115    IM = 0
         GO TO 113
C
C FUNCTION INCREASED - TEST FOR MINIMUM ON LINE
C
  116    IF (IM .GE. MN) GO TO 118
         IS = max(1,IP-MN)
         IT = IP-IM-1
         IF (IS .GT. IT) GO TO 118
         DO 117 II=IS,IT
            IF (AA .GE. Z(II,JP)) GO TO 124
  117    CONTINUE
  118    IS = IP+2
         IT = min(M,IP+MN)
         IF (IS .GT. IT) GO TO 121
         DO 120 II=IS,IT
            IF (Z(II,JP).NE.badz) GO TO 119
            IP = II-1
            GO TO 125
  119       IF (AA .GE. Z(II,JP)) GO TO 124
  120    CONTINUE
C
C WE HAVE MINIMUM ON LINE - DO TWO-DIMENSIONAL TEST FOR MINIMUM OF FIELD
C
  121    JS = max(1,JP-NM)
         JT = min(N,JP+NM)
         IS = max(1,IP-MN)
         IT = min(M,IP+MN)
         DO 123 JK=JS,JT
            IF (JK .EQ. JP) GO TO 123
            DO 122 IK=IS,IT
               IF (Z(IK,JK).LE.AA .OR. (Z(IK,JK).EQ.badz)) GO TO 124
  122       CONTINUE
  123    CONTINUE
C
  124    IM = 1
         IF (IP-MM1) 101,127,127
C
C SKIP SPECIAL VALUES ON LINE
C
  125    IM = 0
  126    IP = IP+1
         IF (IP .GE. MM1) GO TO 127
         IF (Z(IP+1,JP).EQ.badz) GO TO 125
         IM = IM+1
         IF (IM .LE. MN) GO TO 126
         IM = 1
         AN = Z(IP+1,JP)
         IF (Z(IP,JP)-AN) 101,103,113
C
  127 CONTINUE
C
      RETURN

      END

      SUBROUTINE CD_GET_VAR_TYPE (dset, varid, vname, vtype, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Read the linked list structure for netcdf variable information: 
* given dset and variable name OR variable ID return variable type.
* If varid is 0 or -999, use vname
*
*
* NOTE
* 5/21/2020 
* Note that data types greater than NF_DOUBLE have been added.
* The numeric ones of these seem to work fine for us, but NF_STRING
* does not. CD_SCAN_VARS and CD_DSG_SCAN_VARS have traps to issue
* an error if datasets have variables with type.

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - 
* 5/2017

* include files
#include "gt_lib.parm"
      INCLUDE "tmap_errors.parm"
      INCLUDE 'netcdf.inc'

* Argument declarations

      CHARACTER*(*) vname
      INTEGER dset, varid, vtype, status
   
* Internal declarations
      INTEGER NCF_GET_VAR_TYPE, TM_LENSTR1
      INTEGER slen, var_id

      status = merr_ok

      var_id = varid
      IF (varid.EQ.0 .OR. varid.EQ.unspecified_int4) THEN
        slen = TM_LENSTR1(vname)
	CALL CD_GET_VAR_ID (dset, vname(:slen), var_id, status)
      ENDIF

      status = NCF_GET_VAR_TYPE(dset, var_id, vtype)
      
      RETURN
      END

      SUBROUTINE POSITN(X,Y)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)positon.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     CALL POSITN(X,Y)
C
C     THIS SUBROUTINE DETERMINES THE CURRENT PLOTTING POSITION AND
C     RETURNS THE COORDINATES TO THE USER'S PROGRAM IN USER'S UNITS.
#ifdef unix
C     IF THE PLOTTING DEVICES INCLUDE THE TEKTERMINAL AND IT IS IN
#else
C     IF THE PLOTTING DEVICES INCLUDE THE TEKTERMINAL AND IT IS IN
#endif
C     ALPHAS MODE, THE POSITION RETURNED IS THAT OF THE ALPHA CUR-
C     SOR.
C
C
	CHARACTER*1 IMODE
      DIMENSION IN(7)
C
#ifdef unix
	include 'PLTCOM.DAT'
#else
	include 'pplinc:PLTCOM.DAT'
#endif

CC      Linux port:
        integer octal37

#ifdef FORTRAN_90
        data    octal37/O'37'/
#else
        data    octal37/'37'O/
#endif

C
C     SET ALPHAS MODE.
C
      IMODE = PMODE
      PMODE = ALPHA
C
C     IF THE LAST POINT WAS NOT PLOTTED BECAUSE THE PEN WAS UP,
C     PLOT THE POINT NOW.
C
      IF(SAVEF)CALL XYZPLT
C
C     RESTORE THE CURRENT PLOTTING MODE.
C
      PMODE = IMODE
C
C     CHECK THE PLOT TYPE.
C
      IF(PTYPE .EQ. 0 .OR. PTYPE .EQ. -1.OR.PTYPE.GT.2)GO TO 20
C
C     CHECK THE TEKTERMINAL TYPE.
C
      IF(TTYPE .EQ. 4006)GO TO 20
C
C     WRITE OUT THE CHARACTER BUFFER.
C
      CALL CHDMP
      LHIA = 0
      LHIB = 0
      LLOBA = 0
      IF(TTYPE .EQ. -4662 .OR. TTYPE .EQ. -4663)GO TO 10
C
C     SELECT ALPHA CURSOR ADDRESS INPUT MODE ON THE TEKTERMINAL
C     AND READ THE FIVE CHARACTERS GENERATED BY THE TEKTERMINAL.
C
      CALL CHOUT(ESC,1)
      CALL CHOUT(5,1)
      CALL CHIN(IN,5,0)
C
C     CHECK THE TEKTERMINAL TYPE.
C
      IF(TTYPE .GT. 0)THEN
C
C     CALCULATE THE COORDINATES OF THE POINT.
C
#ifdef unix
# ifdef NEED_IAND
        AOLD = FLOAT(IOR(ISHFT(IAND(IN(2), octal37),5),IAND(IN(3), octal37)
     *   )) / PLTOTA + AMIN
        BOLD = FLOAT(IOR(ISHFT(IAND(IN(4), octal37),5),IAND(IN(5), octal37)
     *   )) / PLTOTB + BMIN
      ELSE
C
C     CALCULATE THE COORDINATES OF THE POINT.
C
        AOLD = FLOAT(IOR(ISHFT(IAND(IN(2), octal37),7),ISHFT(IAND(IN(3),
     *    octal37),2))) / PLTOTA + AMIN
        BOLD = FLOAT(IOR(ISHFT(IAND(IN(4), octal37),7),ISHFT(IAND(IN(5),
     *    octal37),2))) / PLTOTB + BMIN
# else
        AOLD = FLOAT(OR(LSHIFT(AND(IN(2), 31),5),AND(IN(3), 31)
     *   )) / PLTOTA + AMIN
        BOLD = FLOAT(OR(LSHIFT(AND(IN(4), 31),5),AND(IN(5), 31)
     *   )) / PLTOTB + BMIN
      ELSE
C
C     CALCULATE THE COORDINATES OF THE POINT.
C
        AOLD = FLOAT(OR(LSHIFT(AND(IN(2), 31),7),LSHIFT(AND(IN(3),
     *    31),2))) / PLTOTA + AMIN
        BOLD = FLOAT(OR(LSHIFT(AND(IN(4), 31),7),LSHIFT(AND(IN(5),
     *    31),2))) / PLTOTB + BMIN
# endif
#else
        AOLD = FLOAT(IOR(ISHFT(IAND(IN(2), octal37),5),IAND(IN(3), octal37)
     *   )) / PLTOTA + AMIN
        BOLD = FLOAT(IOR(ISHFT(IAND(IN(4), octal37),5),IAND(IN(5), octal37)
     *   )) / PLTOTB + BMIN
      ELSE
C
C     CALCULATE THE COORDINATES OF THE POINT.
C
        AOLD = FLOAT(IOR(ISHFT(IAND(IN(2), octal37),7),ISHFT(IAND(IN(3),
     *    octal37),2))) / PLTOTA + AMIN
        BOLD = FLOAT(IOR(ISHFT(IAND(IN(4), octal37),7),ISHFT(IAND(IN(5),
     *    octal37),2))) / PLTOTB + BMIN
#endif
      ENDIF
      GO TO 20
C
C     CHECK THE GRAPHICS FLAG.
C
   10 IF(GRAPHF)THEN
C
C     SELECT GRAPHICAL INPUT MODE ON THE TEKTRONIX PLOTTER AND
C     READ THE SEVEN CHARACTERS GENERATED BY THE PLOTTER.
C
        CALL CHOUT(ESC,1)
        CALL CHOUT(IDTK,1)
        CALL CHOUT(77,1)
        CALL CHIN(IN,7,0)
C
C     CALCULATE THE COORDINATES OF THE POINT.
C
#ifdef unix
#ifdef sun
        AOLD = FLOAT(OR(OR(LSHIFT(AND(IN(1), 31),7),LSHIFT(AND(
     *IN(3),31),2)),rSHIFT(AND(IN(5), 31),3)))/PLTOTA+AMIN
        BOLD = FLOAT(OR(OR(LSHIFT(AND(IN(2), 31),7),LSHIFT(AND(
     *IN(4),31),2)),rSHIFT(AND(IN(6), 31),3)))/PLTOTB+BMIN
#else
# ifdef NEED_IAND
        AOLD = FLOAT(IOR(IOR(ISHFT(IAND(IN(1), octal37),7),ISHFT(IAND(
     *IN(3),octal37),2)),ISHFT(IAND(IN(5), octal37),-3)))/PLTOTA+AMIN
        BOLD = FLOAT(IOR(IOR(ISHFT(IAND(IN(2), octal37),7),ISHFT(IAND(
     *IN(4),octal37),2)),ISHFT(IAND(IN(6), octal37),-3)))/PLTOTB+BMIN
# else
        AOLD = FLOAT(OR(OR(LSHIFT(AND(IN(1), 31),7),LSHIFT(AND(
     *IN(3),31),2)),LSHIFT(AND(IN(5), 31),-3)))/PLTOTA+AMIN
        BOLD = FLOAT(OR(OR(LSHIFT(AND(IN(2), 31),7),LSHIFT(AND(
     *IN(4),31),2)),LSHIFT(AND(IN(6), 31),-3)))/PLTOTB+BMIN
# endif
#endif
#else
C
        AOLD = FLOAT(IOR(IOR(ISHFT(IAND(IN(1), octal37),7),ISHFT(IAND(
     *IN(3),octal37),2)),ISHFT(IAND(IN(5), octal37),-3)))/PLTOTA+AMIN
        BOLD = FLOAT(IOR(IOR(ISHFT(IAND(IN(2), octal37),7),ISHFT(IAND(
     *IN(4),octal37),2)),ISHFT(IAND(IN(6), octal37),-3)))/PLTOTB+BMIN
#endif
      ENDIF
C
C     TRANSFORM THE POINT TO THE USER'S COORDINATE SYSTEM.
C
   20 CALL TFORMI(XNEW,YNEW,ZNEW)
      X = XNEW / XSCALE
      Y = YNEW / YSCALE
      RETURN
C
      END

*
* godae_obs.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Steve Hankin
* Dac, 2000

* This function reads a GODAE (FNMOC) ship observations file (name passed
* in) and returns the variables in a multi-dimensional array NoxNv where
* No is the number of obs in the file and Nv is the number of variables
* read (list of variables as per source code)

* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE godae_obs_init (id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc (id,
     .   'Read an FNOC ship obs file - result in Nobs X 15 array' )

      CALL ef_set_num_args(id, 1)

      CALL ef_set_axis_inheritance(id,  ABSTRACT, ABSTRACT, 
     .                                  NORMAL,   NORMAL)

      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      CALL ef_set_num_work_arrays(id, 0)


      arg = 1
      CALL ef_set_arg_type(id, arg, STRING_ARG)
      CALL ef_set_arg_name (id, arg, 'dtg FILENAME')
      CALL ef_set_arg_unit(id, arg, 'none')
      CALL ef_set_arg_desc(id, arg,
     .                  'FNMOC "dtg" file in the form YYYYMMDDHH')
      CALL ef_set_axis_influence (id, arg, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN 
      END



*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE godae_obs_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)
      INTEGER OPEN_OCN_OBS
      CHARACTER*80 errmsg

      INCLUDE 'xgodae_obs.cmn'


      CALL ef_get_arg_string(id, 1, gobs_filename)

      IF (gobs_filename .EQ. " ") CALL ef_bail_out(id,
     .          'No filename specified')

      nobs = OPEN_OCN_OBS(gobs_filename,errmsg)
      IF (nobs .LE. 0) CALL ef_bail_out(id, errmsg)

* the same list of variables is read from every file
      nvars = 15

* indicate the number of variables to be returned on the X axis
      CALL ef_set_axis_limits(id, X_AXIS, 1, nobs)

* indicate the number of observations to be returned on the Y axis
      CALL ef_set_axis_limits(id, Y_AXIS, 1, nvars)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE godae_obs_compute (id, arg_1, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id
      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .     mem1lot:mem1hit)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)
 

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
*  names, units, characteristics of variables to send to Vis5D utility functions.

        CHARACTER errmsg*80

        INCLUDE 'xgodae_obs.cmn'

C  Read data from the input file straight into Ferret
      CALL READ_OCN_OBS(gobs_filename, result, nvars, nobs, errmsg)
      IF ( errmsg.NE.' ' ) CALL ef_bail_out(id,
     .          'No filename specified')

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN 
      END

*  sample_fast_i.F
* 
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* Ansley Manke June 2013
* Sample variable using a set of indices.
*
*
*  In this subroutine we provide information about
*  the function.  The user configurable information 
*  consists of the following:
* 
*  descr              Text description of the function
* 
*  num_args           Required number of arguments
* 
*  axis_inheritance   Type of axis for the result
*                        ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                        CUSTOM          - user defined axis
*                        IMPLIED_BY_ARGS - same axis as the incoming argument
*                        NORMAL          - the result is normal to this axis
*                        ABSTRACT        - an axis which only has index values
* 
*  piecemeal_ok       For memory optimization:
*                        axes where calculation may be performed piecemeal
*                        ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE sample_fast_i_init(id)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id, 'Fast 1D sample variable using set of indices' )

      CALL ef_set_num_args(id, 2)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id, IMPLIED_BY_ARGS, NORMAL, 
     .                             NORMAL, NORMAL, NORMAL, NORMAL)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'V')
      CALL ef_set_arg_desc(id, arg, 'Variable to sample')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'Indices')
      CALL ef_set_arg_desc(id, arg, 'List of indices at which to sample ')
      CALL ef_set_axis_influence_6d(id, arg, YES, NO, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*  In this subroutine we compute the result
* 
      SUBROUTINE sample_fast_i_compute(id, arg_1, arg_2, result)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* Function is intended only for variables in the x direction

      REAL arg_1(mem1lox:mem1hix)
      REAL arg_2(mem2lox:mem2hix)
      REAL result(memreslox:memreshix)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER	i, i2, isample

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      i2 = arg_lo_ss(X_AXIS,ARG2)
      DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
      
         result(i) = bad_flag_result
         IF (arg_2(i2) .NE. bad_flag(ARG2)) THEN
            isample = INT(arg_2(i2))
            result(i) = arg_1(isample)
	 ENDIF
	 i2 = i2 + arg_incr(X_AXIS,ARG2)
  100 CONTINUE

      RETURN

      RETURN
      END

*           rr_diff_tx.F
*
*           Rick Romea
*           Jan. 24, 2000
*
*     Computes the zonal diffusive term: A T_xx
*     Units :     oC/s
*     MOM2 Grid:  T  
*
*******************************************************************

      SUBROUTINE RR_diff_tx_init(id)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

      CALL ef_set_desc             (id,
     .'Ah d^2T/dx^2 diffusive term (oC/s);MOM2 T Grid')
      CALL ef_set_num_args         (id, 2)
      CALL ef_set_axis_inheritance (id, IMPLIED_BY_ARGS, 
     .  IMPLIED_BY_ARGS,IMPLIED_BY_ARGS,IMPLIED_BY_ARGS)

      CALL ef_set_piecemeal_ok     (id, NO,NO,NO,NO)

      CALL ef_set_arg_name         (id, ARG1, 'U')
      CALL ef_set_arg_desc         (id, ARG1,
     . 'Zonal velocity, required to access the MOM2 U Grid. ')
      CALL ef_set_arg_unit         (id, ARG1, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG1, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG1, YES, YES, YES, YES)
      CALL ef_set_axis_extend      (id, ARG1, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG1, Y_AXIS,-1,+1)

      CALL ef_set_arg_name         (id, ARG2, 'TEMP')
      CALL ef_set_arg_desc         (id, ARG2,
     . 'Potential temperature, on the MOM2 T Grid. ')
      CALL ef_set_arg_unit         (id, ARG2, 'deg-C')
      CALL ef_set_arg_type         (id, ARG2, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2, NO, NO,YES,YES)
      CALL ef_set_axis_extend      (id, ARG2, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG2, Y_AXIS,-1,+1)
      END


      SUBROUTINE RR_diff_tx_compute(id, arg_1, arg_2, result)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'
      INTEGER        id
      REAL           bad_flag(EF_MAX_ARGS)
      REAL           bad_flag_result
      REAL           arg_1 (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .                      mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL           arg_2 (mem2lox:mem2hix, mem2loy:mem2hiy, 
     .                      mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL           result (memreslox:memreshix,memresloy:memreshiy,
     .                       memresloz:memreshiz,memreslot:memreshit)
      INTEGER        res_lo_ss (4)
      INTEGER        res_hi_ss (4)
      INTEGER        res_incr  (4)
      INTEGER        arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER        arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER        arg_incr  (4,EF_MAX_ARGS)
      INTEGER        i,  j,  k,  l
      INTEGER        i2, j2, k2, l2
      REAL*8         yU(1024)
      REAL*8         xU(1024)
      REAL*8         yT(1024)
      REAL*8         xT(1024)
      INTEGER        ilat
      INTEGER        ilon
      CHARACTER *16  ax_name(4)
      CHARACTER *16  ax_units(4)
      LOGICAL        backward(4)
      LOGICAL        modulo(4)
      LOGICAL        regular(4)
      REAL dxt, dyt, dxu,xjt
      REAL cst,diff_fe
      INCLUDE 'rr_parameters.h'

C*********************************************************************
C
c  MOM2 Code:
c
c   DIFF_Tx(i,k,j) = (diff_fe(i,k,j) - diff_fe(i-1,k,j)) * cstdxtr(i,j)
c
c     diff_fe(i,k,j) = ah_cstdxur(i,j) * (t(i+1,k,j,n) - t(i,k,j,n))
c     cstdxtr(i,j)   = cstr(j) * dxtr(i)
c
c       ah_cstdxur(i,j) = diff_cet(j) * cstr(j) * dxur(i)
c
c          diff_cet(j)  = ah*xjt(j)
c
c             ah = constant lateral diffusion coeff for tracers
c                   ah = 2.e7(cm**2/sec)
c             xjt(j) = 3.166 * dyt(j) * dytr(50) - 2.166
c      
c     dxt     = longitudinal width of "t" grid box at the equator (cm)
c     dxtr    = reciprocal of "dxt"
c     dyt     = latitudinal height of "t" grid box (in cm)
c     dytr    = reciprocal of "dyt"
c     dxu     = longitudinal width of "u,v" grid box at the equator (cm) 
c     dxur    = reciprocal of "dxu"
c
c     cst     = cosine of "t" grid point latitude
c               cst(j)  = cos(phit(j))
c     cstr    = reciprocal of "cst"
c
c        n = 1 => temperature
c        n = 2 => salinity
c
c*********************************************************************

      dxt(i) = SNGL(xU(i)-xU(i-1))*Longitude_to_cm
      dyt(j) = SNGL(yU(j)-yU(j-1))*Latitude_to_cm
      dxu(i) = SNGL(xT(i+1)-xT(i))*Longitude_to_cm
      cst(i) = cos(SNGL(yT(i))*Degrees_to_radians) 
      xjt(i) = 3.166*dyt(i)/dyt_ref-2.166
      diff_fe(i,j,k,l,iLon,iLat) =ah*xjt(iLat) /cst(iLat)/dxu(iLon)
     .              *(arg_2(i+1,j,k,l)-arg_2(i,j,k,l))


      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags      (id, bad_flag,  bad_flag_result)
      CALL ef_get_coordinates    (id, ARG1, X_AXIS, 
     .                            arg_lo_ss(X_AXIS,ARG1),
     .                            arg_hi_ss(X_AXIS,ARG1), xU)
      CALL ef_get_coordinates    (id, ARG1, Y_AXIS, 
     .                            arg_lo_ss(Y_AXIS,ARG1),
     .                            arg_hi_ss(Y_AXIS,ARG1), yU)
      CALL ef_get_coordinates    (id, ARG2, X_AXIS, 
     .                            arg_lo_ss(X_AXIS,ARG2),
     .                            arg_hi_ss(X_AXIS,ARG2), xT)
      CALL ef_get_coordinates    (id, ARG2, Y_AXIS, 
     .                            arg_lo_ss(Y_AXIS,ARG2),
     .                            arg_hi_ss(Y_AXIS,ARG2), yT)
      CALL ef_get_axis_info      (id, ARG1, ax_name, ax_units, 
     .                                backward, modulo, regular) 
      IF     ( ax_units(1) .NE. 'deg'       .AND.
     .         ax_units(1) .NE. 'degrees_E' .AND.
     .         ax_units(1) .NE. 'longitude' .AND.
     .         ax_units(1) .NE. 'Longitude' .AND. 
     .         ax_units(1) .NE. 'LONGITUDE' ) THEN
        WRITE (6,*)'Longitude axis units =', ax_units(1) 
        !CALL ef_bail_out(id,'Longitude axis must be in degrees')
      ENDIF
      IF     ( ax_units(2) .NE. 'deg'       .AND.
     .         ax_units(2) .NE. 'degrees_N' .AND.
     .         ax_units(2) .NE. 'latitude'  .AND.
     .         ax_units(2) .NE. 'Latitude'  .AND. 
     .         ax_units(2) .NE. 'LATITUDE' ) THEN
        WRITE (6,*)'Latitude axis units =', ax_units(2) 
        !CALL ef_bail_out(id,'Latitude axis must be in degrees')
      ENDIF

      l2 = arg_lo_ss(T_AXIS,ARG2) 
      DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         k2 = arg_lo_ss(Z_AXIS,ARG2)
         DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
            ilat = 2
            j2 = arg_lo_ss(Y_AXIS,ARG2) + 1 
            DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
               iLon = 2
               i2 = arg_lo_ss(X_AXIS,ARG2) + 1
               DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
                  IF (arg_2(i2,  j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2,  j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2,  j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2-1,k2,l2) .EQ. bad_flag(ARG2) )THEN
                     result(i,j,k,l) = bad_flag_result
                  ELSE
                     result(i,j,k,l) =
     .                   (diff_fe(i2  ,j2,k2,l2,iLon,iLat)
     .                  - diff_fe(i2-1,j2,k2,l2,iLon-1,iLat))
     .                      /cst(iLat)/dxt(iLon)*sec_per_month
                  ENDIF
                  iLon = iLon + 1
                  i2 = i2 + arg_incr(X_AXIS,ARG2)
               ENDDO
               iLat = iLat + 1
               j2 = j2 + arg_incr(Y_AXIS,ARG2)
            ENDDO               
            k2 = k2 + arg_incr(Z_AXIS,ARG2)
         ENDDO
         l2 = l2 + arg_incr(T_AXIS,ARG2)
      ENDDO
      END

	SUBROUTINE PLOTZ(Z,XF,YF,XLPLOT,YLPLOT,XHPLOT,YHPLOT)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
C**     
C**     @(#)plotz.F	1.4    9/9/88
C**     
C**     
C***********************************************************************
C**     
C**     PLOT+ Scientific Graphics System
C**     
C***********************************************************************
C**     
C**     
C       lots of places ---> PPLMOD_PPLCMD ---> PPLMOD_PLTIT ---> PPLMOD_PLOTZ
C       
C       This subroutine is called for CONTOUR, SHADE and FILL plots
C       and puts the data on the proper grid and then plots it.
C 
C       Z      - actual 2D data array
C       XF     - X factor ( page? length / X range )
C       YF     - Y factor
C       XLPLOT - lower X page? coordinate
C       YLPLOT - lower Y page? coordinate
C       XHPLOT - upper X page? coordinate
C       YHPLOT - upper Y page? coordinate
C       
*       MOD *JD* to include AREA in TMAP PPL+
*       MOD *JD* moved dimension z(nx,ny) from below subroutine statement to
*       below includes so that CONTOUR will work on the MAC -- Ed Flinchem
*       had to do this to make that work. 3.29.93 DIMENSION --> REAL as well.
*       MOD *JD* To permit use of centered levels and specify the delta Z
*       value as well.  Added variables to CONT.INC common 8.3.95  
*	*jd* 8.28 fix bug in dz specification
*	*jd* 2.96 Change centered option so that data not spanning zero
*       is centered as well.
*       *jc* 4.97 Major clean up and commenting
*       *jc* 5.97 Added code for curvilinear coordinates
* V510 4/00 *sh - corrected faulty logic for centered levels (delta wrong)
* V540 10/01 *acm Set LWGT, LDIG when using previously defined levels; have 
*                 not been set if previous call was SHADE
* V540 10/01 *acm remove VMS include statements
* V540 12/01 *acm* do NOT set LWGT, LDIG here; set them in SHADE
* V541  5/02 *acm* Check that number levels not greater than size of 
*                  LWGT, LDIG, and ZLEV; issue an error message.
* V550 11/02 *acm* For fine grids, XLPLOT, XHPLOT, YLPLOT, YHPLOT computations
*                  need to be done in double precision.
* V550 11/02 *acm* New call to create LEVELS symbols, routine setlab_syms
* V554  9/03 *acm* Fix precision bug double precision, for fine grids in 
*                  curvlinear coordinates. See also pltit.F, setax.F
* v581 *acm* 3/05 open levels (-INF) (INF)
* V581 *acm* 7/05 fix bug 1279: fill/lev=(n) gave exactly N not nlev2=approx N
* V600 *acm* 1/06 prevent values of LOG10(0.0)
* V602 *acm* 2/07 check status coming out of CONSEG; part of fix to bug 1485
* V603 *acm* 5/07 Compute sig figs for labels along contours, and dash characteristics
*                 even when re-using previous levels. Those levels may have come from
*                 a previous SHADE plot as in SHADE/LINE and therefore the levels were
*                 set but not the contour label and line characteristics.
* V603 *acm* 7/07 Fix bug 1335, zero contours not dark. zlev(i) not seen as 0. Fix by 
*                 using TM_FPEQ to compare zlev(i) to 0., within machine accuracy.
* V604 *acm& 7/07 Fix bug 1519. The setting of levels info was incorrectly resetting the
*                 highest and lowest level when doing (-inf) and (inf) levels spec.
* v68  *acm* 4/08 Allow shade, vector plots of degenerate regions - world region 
*              within a grid cell
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus
* V698 *acm* 3/16  Ticket 2375: outline color key in black even on an overlay.

	INCLUDE 'PARAMPL5.DAT'
	INCLUDE 'ZGRIDD.INC'
	INCLUDE 'ZGRID.INC'
	INCLUDE 'AXIS.INC'
	include	'cont_inc.decl'
	INCLUDE 'CONT.INC'
	INCLUDE 'HD.INC'
	INCLUDE 'TAXIS.INC'
	INCLUDE 'AXISL.INC'
	INCLUDE 'PEN.INC'
	INCLUDE 'LINES.INC'
	INCLUDE 'PLTL.INC'
	include 'xcurvilinear.cmn'
        INCLUDE 'errmsg.parm'

* Argument declarations
**	DIMENSION Z(NX,NY)
	REAL	  Z(NX,NY)
        REAL      XF,YF
        REAL*8    XLPLOT,YLPLOT,XHPLOT,YHPLOT

* Local declarations
        INTEGER   status, slen1, slen2, nlev1
        CHARACTER TM_FMT*48, buff1*20, buff2*20, err_msg*40
        REAL*8    DXFF, DXOF, DYFF, DYOF
        REAL      XFF, XOF, YFF, YOF, DMIN, DMAX, DZMAX
        LOGICAL   TM_FPEQ_SNGL

	logical		valid

C*       *jd* Linux port 12.96 add EXTERNAL calls below
        external scale, range

C	VAX/VMS
C
	DIMENSION IZMRKD(3)
	DATA IZMRKD/12,16,3/

C
C  Set the contour/color levels

        CALL SET_LEVELS_SHADE_FILL (status)
	IF (status .NE. ferr_ok) GOTO 5000


C       DRAW CONTOUR
C
C       from ppl/include/PPL.INC:
C
C       JTYPE: = 2 2-d irregular rectangular grid
C              = 1 1-d set
C              = 0 2-d regular rectangular grid (integer)
C              =-1 2-d second component of a vector regular grid
C              =-2 2-d second component of a vector irregular grid
C
C
C       from ppl/include/ZGRID.INC:
C
C       controls for the plotting of the positions of ungridded x,y,z data
C
C       IZTYP: =0 no points drawn
C              =1 points drawn along the x axis
C              =2 points drawn along the y axis
C              =3 points drawn at each raw input value
C       
C       IZMRK: =0 use the default mark
C              =n use mark n to denote the location
C
C       IZLEN: number of points in the x,y,z triplets

C
C       If it's a 2-d irregular grid plot and points have been drawn
C
	if (abs(jtype).eq.2 .and. iztyp.ne.0) then

	   call markh(hmark(1))

	   if (izmrk.eq.0) then
	      imrk=izmrkd(iztyp)
	   else
	      imrk=izmrk
	   endif

	   if (iztyp.eq.1) then

	      do 200 i=1,nx
		 call trans(0,z(i,ny+1),ylo,xt,y)
		 call plot(xt,y,0,imrk)
		 call mark(imrk)
 200	      continue

	   else if (iztyp.eq.2) then

	      do 210 j=1,ny
		 call trans(0,xlo,z(j,ny+2),x,yt)
		 call plot(x,yt,0,imrk)
		 call mark(imrk)
 210	      continue

	   else

	      do 230 i=1,nx
		 do 220 j=1,ny
		    call trans(0,z(i,ny+1),z(j,ny+2),xt,yt)
		    call plot(xt,yt,0,imrk)
		    call mark(imrk)
 220		 continue
 230	      continue

	   endif

	endif

C
C       If there are some x,y,z triplets and points have been drawn
C
	IF (IZLEN.NE.0.AND.IZTYP.NE.0) THEN

	   CALL MARKH(HMARK(1))

	   IF (IZMRK.EQ.0) THEN
	      IMRK=IZMRKD(IZTYP)
	   ELSE
	      IMRK=IZMRK
	   ENDIF

	   IF (IZTYP.EQ.1) THEN

	      call trans(0,xx(1),ylo,xt,y)
	      CALL PLOT(XT,Y,0,IMRK)
	      CALL MARK(IMRK)
	      DO 300 I=2,IZLEN
		 IF (XT.NE.XX(I)) THEN
		    call trans(0,xx(i),ylo,xt,y)
		    CALL PLOT(xt,Y,0,IMRK)
		    CALL MARK(IMRK)
		 ENDIF
 300	      CONTINUE

	   ELSE IF (IZTYP.EQ.2) THEN

	      call trans(0,xlo,yy(1),x,yt)
	      CALL PLOT(X,YT,0,IMRK)
	      CALL MARK(IMRK)
	      DO 310 I=2,IZLEN
		 IF (YT.NE.YY(I)) THEN
		    call trans(0,xlo,yy(i),x,yt)
		    CALL PLOT(X,yt,0,IMRK)
		    CALL MARK(IMRK)
		 ENDIF
 310	      CONTINUE

	   ELSE

	      DO 320 I=1,IZLEN
		 call trans(0,xx(i),yy(i),xt,yt)
		 CALL PLOT(xt,yt,0,IMRK)
		 CALL MARK(IMRK)
 320	      CONTINUE

	   ENDIF

	ENDIF

	CALL SCALE(1.,1.,XORG,YORG,0.,0.)
	IF (IWIND.NE.0) CALL WINDOW(0.0,0.0,XLEN,YLEN)
	CALL COLOR(IPEN(1))


C       Calculate the following quantities:
C       ~FF - multiplication factors to go from axis to page coords?
C       ~OF - page offset to the beginning of an axis?

	call trans(0,xmin,ymin,xtm,ytm)
	call trans(0,xmax,ymax,xtx,ytx)
	DXFF = (XHPLOT - XLPLOT)/(xtx-xtm)
	IF (TM_FPEQ_SNGL(xtx, xtm)) DXFF = 1.
	DXOF = (XLPLOT) - DXFF*xtm
	DYFF = (YHPLOT - YLPLOT)/(ytx-ytm)
	IF (TM_FPEQ_SNGL(xtx, xtm)) DXFF = 1.
	DYOF = (YLPLOT) - DYFF*ytm

	XFF = DXFF
	XOF = DXOF
	YFF = DYFF
	YOF = DYOF


C       If this is a 2-D plot on an irregular grid, use TRANS() to 
C       scale the points appropriately.  Values are returned in 
C       the xx() and yy() arrays.
C
	IF (abs(jtype).eq.2) THEN
       
	   do 400 i=1,nx
	      call trans(0,z(i,ny+1),ymin,xx(izlen+i),yt)
 400	   continue
	   do 410 j=1,ny
	      call trans(0,xmin,z(j,ny+2),xt,yy(izlen+j))
 410	   continue


C       For all other plot types fill in XX() and YY() by
C       multiplying the index value by the DX or DY delta values.

	ELSE

	   DX = (xtx - xtm)/(NX - 1)
	   DY = (ytx - ytm)/(NY - 1)
	   IF (NX .EQ. 1) DX = 1.
	   IF (NY .EQ. 1) DY = 1.

	   DO 500 I=1,NX
	      XX(IZLEN+I)=DX*(I-1)+xtm
 500	   CONTINUE
	   DO 510 J=1,NY
	      YY(IZLEN+J)=DY*(J-1)+ytm
 510	   CONTINUE

! TEST - fix XX if this is a subspan-modulo axis.
           IF ( .NOT. curvilinear ) THEN
              CALL box_centers ('X',xx(IZLEN+1),nx,xx(NX+IZLEN+1),valid)
	      DO i = 1, nx
	         xx(izlen+i) = xx(nx+izlen+i)
	      ENDDO

              CALL box_centers ('Y',yy(IZLEN+1),ny,yy(Ny+IZLEN+1),valid)
	      DO j = 1, ny
	         yy(izlen+j) = yy(ny+izlen+j)
	      ENDDO
	   ENDIF

	ENDIF

* Now that the levels are set, create the LEVELS symbols

        CALL setlab_syms (ZLEV, MAX(NLEV2,1) )

	 if (makep.eq.'CONTOUR') then
c *kob* 8/97 had to move the continuation marker to col 5 - it was in col 8
c       this bombed aix compiler, though it seems to work on others
	    CALL CONSEG(Z,NX,NY,XX(IZLEN+1),YY(IZLEN+1),NX,NY,
     1	 XFF,XOF,YFF,YOF,ZLEV,LDIG,LWGT,LCLR,NLEV2,HGT,
     2	 NARC,CANGLE,status)
             IF (status .NE. ferr_ok) GOTO 5002

* Ticket 2375: A color fill plot needs IPEN(0), so that if there is a
* color key it is labeled and outlined in black even on an overlay.
	 else if (makep.eq.'FILL') then
	    
	    CALL COLOR(IPEN(0))
            nlev1 = nlev
            nlev = nlev2
	    call arfill(z,xx(izlen+1),yy(izlen+1),nx,ny)
            nlev = nlev1

	 else
*******     SQRFILL NOT A TMAP PPL+ COMMAND *jd* 2.19.99
*******	    call sqrfill(z,xx(izlen+1),yy(izlen+1),nx,ny,
*******     1	 zlev,nlev2)

	 endif

C
C	END VAX/VMS
C
	CALL COLOR(IPEN(0))
	CALL SCALE(XF,YF,XORG,YORG,XLO,YLO)

	RETURN

C  Error exit when too many levels specified.
C  Arrays LWGT, LDIG, and ZLEV are length ICNLEV=500

 5000   ii = ICNLEV
        buff1 = TM_FMT(DBLE(ICNLEV), 0, 20, slen1)
        buff2 = TM_FMT(DBLE(NLEV2), 0, 20, slen2)
        err_msg = '# of contour levels > '// buff1(1:slen1) //
     .          '  (' // buff2(1:slen2) // ')'
        CALL errmsg (ferr_out_of_range, status, err_msg, *5002)

 5002   return

	END

*
* treverse.F
*
* Ansley Manke
* Sep 15 2004
*
* This function returns the T values of the input variables,
* reversed and on an abstract T axis. Other axes are unchanged.
*
*
* In this subroutine we provide information about
* the function.  The user configurable information
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
*
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument''s axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result
*


      SUBROUTINE treverse_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .  'Returns values reversed in T direction on an abstract T axis')
      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, ABSTRACT,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'Variable to reverse the T axis')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, NO, YES, YES)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


      SUBROUTINE treverse_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER nt

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nt = arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1) + 1

      CALL ef_set_axis_limits(id, T_AXIS, 1, nt)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE treverse_compute(id, arg_1, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable''s axes.

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      n = res_lo_ss(F_AXIS)
      DO 600 n1 = arg_lo_ss(F_AXIS,ARG1), arg_hi_ss(F_AXIS,ARG1)

      m = res_lo_ss(E_AXIS)
      DO 500 m1 = arg_lo_ss(E_AXIS,ARG1), arg_hi_ss(E_AXIS,ARG1)

      l = res_lo_ss(T_AXIS)
      DO 400 l1 = arg_hi_ss(T_AXIS,ARG1), arg_lo_ss(T_AXIS,ARG1), -1

      k = res_lo_ss(Z_AXIS)
      DO 300 k1 = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)

      j = res_lo_ss(Y_AXIS)
      DO 200 j1 = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)

      i = res_lo_ss(X_AXIS)
      DO 100 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)

         IF ( arg_1(i1,j1,k1,l1,m1,n1) .EQ. bad_flag(ARG1) ) THEN
            result(i,j,k,l,m,n) = bad_flag_result
         ELSE
            result(i,j,k,l,m,n) = arg_1(i1,j1,k1,l1,m1,n1)
         ENDIF

         i = i + res_incr(X_AXIS)
 100  CONTINUE

         j = j + res_incr(Y_AXIS)
 200  CONTINUE

         k = k + res_incr(Z_AXIS)
 300  CONTINUE

         l = l + res_incr(T_AXIS)
 400  CONTINUE

         m = m + res_incr(E_AXIS)
 500  CONTINUE

         n = n + res_incr(F_AXIS)
 600  CONTINUE

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END

	REAL FUNCTION R_CGRID_SIZE_DELTA ( cx )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Real-number version of cgrid_size_delta.
* determine the number of values in a 2D grid that lies within the plane
* of the specified context
* Unlike CGRID_SIZE this routine *IS* sensitive to cx_delta values

* Ansley Manke 9/2014

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'

* calling argument declarations
	INTEGER	cx

* internal variable declarations
	INTEGER	idim
	REAL size, delta

* determine the delta product
	size = 1
	DO 10 idim = 1, nferdims
	  IF (cx_delta(idim,cx) .NE. unspecified_val8) THEN
	    delta = cx_delta(idim,cx)
	  ELSE
	    delta = 1.
	  ENDIF
          IF ( (cx_hi_ss(cx,idim) .GE. cx_lo_ss(cx,idim)) .AND.
     .         (cx_hi_ss(cx,idim) .NE. unspecified_int4)  .AND.
     .         (cx_lo_ss(cx,idim) .NE. unspecified_int4)  ) THEN
              size = size * 
     .          (FLOAT(cx_hi_ss(cx,idim)-cx_lo_ss(cx,idim))/delta + 1.)
          ENDIF
 10 	CONTINUE

* the result
	R_CGRID_SIZE_DELTA = size

	RETURN
	END

	BLOCK DATA XTEXT_INFO_DATA

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* pre-defined text strings

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 1/30/87
* revision 0.1 - 3/18/87 - added fvar_name_code (removed from *VARIABLES)
* revision 0.2 - 7/13/87 - added axis titles from ASCII_LIMITS
* revision 0.3 - 2/24/88 - added AIRT and axis_orients
* revision 0.4 - 3/18/88 - added date_labels and date_str_len
* revision 0.5 - 4/4/88  - added unit_text
* revision 0.6 -11/22/88 - new TM IO library took over axis_orients
* V300:  2/3/93 - added verify_modes
* V301:    1/94 - changed MODE VERIFY "FILES" to MODE VERIFY "DEFAULT" 
* Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
*            2/12 *kms* Add E, F, M, N, ENSEMBLE, and FORECAST;
*                       include tmap_dims.parm for nferdims needed by xtext_info.cmn
* V698  *acm* 5/16 Ticket 2405: MODE CALENDAR:auto

        IMPLICIT NONE
        include 'tmap_dims.parm'
#include "tmap_dset.parm"
	include	'ferret.parm'
	include	'xtext_info.cmn'

	DATA	ww_dim_name( x_dim )	/ 'X' /,
     .		ww_dim_name( y_dim )	/ 'Y' /,
     .		ww_dim_name( z_dim )	/ 'Z' /,
     .		ww_dim_name( t_dim )	/ 'T' /,
     .		ww_dim_name( e_dim )	/ 'E' /,
     .		ww_dim_name( f_dim )	/ 'F' /

	DATA	ss_dim_name( x_dim )	/ 'I' /,
     .		ss_dim_name( y_dim )	/ 'J' /,
     .		ss_dim_name( z_dim )	/ 'K' /,
     .		ss_dim_name( t_dim )	/ 'L' /,
     .		ss_dim_name( e_dim )	/ 'M' /,
     .		ss_dim_name( f_dim )	/ 'N' /

* pre-defined file variables
	DATA	fvar_name_code	( ptemp ) / 'TEMP'	/,
     .		fvar_name_code	( psalt ) / 'SALT'	/,
     .		fvar_name_code	( pu    ) / 'U'		/,
     .		fvar_name_code	( pv    ) / 'V'		/,
     .		fvar_name_code	( pw    ) / 'W'		/,
     .		fvar_name_code	( ptaux ) / 'TAUX'	/,
     .		fvar_name_code	( ptauy ) / 'TAUY'	/,
     .		fvar_name_code	( ppsi  ) / 'PSI '	/,
     .		fvar_name_code	( pairt ) / 'AIRT'	/

* axis names used to document outputs
	DATA	axis_title(x_dim)	/'LONGITUDE'/,
     .		axis_title_len(x_dim)	/9/,
     .		axis_title(y_dim)	/'LATITUDE' /,
     .		axis_title_len(y_dim)	/8/,
     .		axis_title(z_dim)	/'DEPTH'    /,
     .		axis_title_len(z_dim)	/5/,
     .		axis_title(t_dim)	/'TIME'     /,
     .		axis_title_len(t_dim)	/4/,
     .		axis_title(e_dim)	/'ENSEMBLE' /,
     .		axis_title_len(e_dim)	/8/,
     .		axis_title(f_dim)	/'FORECAST' /,
     .		axis_title_len(f_dim)	/8/

* label formatting information
	DATA	date_labels ( 1 )	/ 'years'   /,
     .		date_labels ( 2 )	/ 'months'  /,
     .		date_labels ( 3 )	/ 'days'    /,
     .		date_labels ( 4 )	/ 'hours'   /,
     .		date_labels ( 5 )	/ 'minutes' /,
     .		date_labels ( 6 )	/ 'seconds' /,
     .		date_labels ( 7 )	/ 'auto' /
	DATA	date_str_len( 1 )	/  4 /,		! yyyy
     .		date_str_len( 2 )	/  8 /,		! mmm-yyyy
     .		date_str_len( 3 )	/ 11 /,		! dd-mmm-yyyy
     .		date_str_len( 4 )	/ 14 /,		! dd-mmm-yyyy:hh
     .		date_str_len( 5 )	/ 17 /,		! dd-mmm-yyyy:hh:mm
     .		date_str_len( 6 )	/ 20 /		! dd-mmm-yyyy:hh:mm:ss
     .		date_str_len( 7 )	/ 20 /		! dd-mmm-yyyy:hh:mm:ss

* computed variable units
	DATA	unit_text( punot_app	)/ ' ' /,		! N/A
     .		unit_text( pudiffusion	)/ 'cm**2/sec' /,
     .		unit_text( puheat_flux	)/ 'watt/m**2' /,
     .		unit_text( putemp_dt	)/ 'deg. C/month' /,
     .		unit_text( puvel_dt	)/ 'cm/sec/month' /,
     .		unit_text( pupressure	)/ 'dynes/cm**2' /,
     .		unit_text( pudensity	)/ 'gm/cm**3' /,
     .		unit_text( pupres_dx	)/ 'dynes/cm**3' /,
     .		unit_text( puppt	)/ 'ppt' /,
     .		unit_text( puvelocity	)/ 'cm/sec' /,
     .		unit_text( putemperature)/ 'deg. C' /

* arguments for mode verify
        DATA   verify_modes(1) / 'DEFAULT' /,
     .         verify_modes(2) / 'ALL' /,
     .         verify_modes(3) / 'ALWAYS' /

	END

	SUBROUTINE SHOW_DSG_RANGES ( dset, showing_grid, lun )
	
* For DSGF dataset, SHOW DATA/FULL or SHOW GRID, list the
* coordinate ranges lon, lat, z, time for the observations/

* programmer - Ansley
* NOAA/PMEL, Seattle, WA - Science Data Integration Group
*  3/3/2020
* 4/20/2020  *acm* Use MASKED_DSG_RANGE to get the range in each direction
*            including nice longitudes corrected for modulo lon
*
	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'xtext_info.cmn'

	INTEGER		dset, grid, lun
	LOGICAL		showing_grid

	INTEGER		STR_DNCASE,TM_LENSTR1, 
     .			igrid, ndec, cx, idim, dlen, status
	REAL		TM_WORLD, lo, hi
	CHARACTER	buff*16, line*255
	
	CALL SPLIT_LIST(pttmode_explct, lun, ' ', 1)
	IF (showing_grid) THEN
	   line = 'Dataset coordinates:'
	   CALL SPLIT_LIST(pttmode_explct, lun, line, 20)
	ENDIF

	ndec = 5
	igrid =  dsg_xlate_grid(dset)
	cx = cx_none

	DO idim = 1, t_dim

	   lo = unspecified_val8
	   hi = unspecified_val8
	   CALL MASKED_DSG_RANGE (dset, cx, idim, lo, hi)
	   IF (lo .EQ. unspecified_val8) CYCLE
	
	   CALL TRANSLATE_TO_WORLD( lo, idim, igrid, ndec, line )
	   dlen = TM_LENSTR1(line)
	   line(dlen+1:) = ' to ' 
	   
	   CALL TRANSLATE_TO_WORLD( hi, idim, igrid, ndec, line(dlen+5:) )
	   dlen = TM_LENSTR1(line)

	   status = STR_DNCASE(buff, axis_title(idim))

	   CALL SPLIT_LIST(pttmode_explct, lun,
     .			'  '//buff(:TM_LENSTR1(buff))//' range: '//line(:dlen), 0) 

	ENDDO
	
	CALL SPLIT_LIST(pttmode_explct, lun,'  ', 0) 
	

	RETURN
	END

*
* times_table.F
*
* Jonathan Callahan
* Feb 19th 1998
*
* Returns A with the T axis replaced by a multiplication table of length B.
*


*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* version            Ferret internal EF version number
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )


      SUBROUTINE times_table_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CALL ef_set_desc(id,'creates a times table' )

      CALL ef_set_num_args(id, 2)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, ABSTRACT)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'argument being multiplied')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'N')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'extent of table')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END


*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* loss               lo subscript for an axis
*
* hiss               hi subscript for an axis
*

      SUBROUTINE times_table_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      COMMON / times_table / my_lo_l, my_hi_l
      INTEGER my_lo_l, my_hi_l

      REAL value
      INTEGER arg, ivalue

*     You could use utility functions at this point to get 
*     context information about the other arguments.  This info 
*     could be used to update the custom or abstract axis lo and hi
*     indices.

      arg = 2

      CALL ef_get_one_val(id, arg, value)
      
      ivalue = value

      my_lo_l = 1
      my_hi_l = ivalue

      CALL ef_set_axis_limits(id, T_AXIS, my_lo_l, my_hi_l)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END



*
* In this subroutine we compute the result
*
      SUBROUTINE times_table_compute(id, arg_1, arg_2, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .     mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, 
     .     mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      COMMON / times_table / my_lo_l, my_hi_l
      INTEGER my_lo_l, my_hi_l

      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*     This check to make sure we only have a single point on the T axis

      IF ( arg_lo_ss(T_AXIS,ARG1) .NE. arg_hi_ss(T_AXIS,ARG1) ) THEN
         WRITE (6,*) 'EF ERROR: Improper range on T axis of argument.'
      END IF

      i1 = arg_lo_ss(X_AXIS,ARG1)
      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               l1 = arg_lo_ss(T_AXIS,ARG1)
               DO 100 l=my_lo_l, my_hi_l


                  IF ( arg_1(i1,j1,k1,l1) .EQ. bad_flag(1) ) THEN

                     result(i,j,k,l) = bad_flag_result

                  ELSE

                     result(i,j,k,l) = l * arg_1(i1,j1,k1,l1)

                  END IF

                  l1 = l1 + arg_incr(T_AXIS,ARG1)
 100           CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 300     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
 400  CONTINUE

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
*  scat2grid_t
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without anx fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and anx derivative works thereof, and
*  its supporting documentation for anx purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in anx publications that result from
*  the use of this software or in anx product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in anx advertising or publicity to endorse or promote anx products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with anx support, consulting,
*  training or assistance of anx kind with regard to the use, operation
*  and performance of this software nor to provide the user with anx
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND Anx EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR Anx SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR Anx DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE.
*
* Ansley Manke
* May 2003
* 11-Jul-2003  Clean up section where we get box limits
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.

* Input is a set of T coordinates on an abstract axis, and an output time axis.
* Returns a time series which is the number of points that fall inside of each T cell.
*

*
* In this subroutine we provide information about
* the function.  The user configurable information
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
*
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result
*


      SUBROUTINE  scat2grid_t_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .        'Count number of t points in each cell of output axis')
      CALL ef_set_num_args(id, 2)
      CALL ef_set_axis_inheritance_6d(id,
     .                                NORMAL, NORMAL,
     .                                NORMAL, IMPLIED_BY_ARGS,
     .                                NORMAL, NORMAL)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 2)

* output grid is determined by argument 2.

      arg = 1
      CALL ef_set_arg_name(id, arg, 'TPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'T coordinates of scattered input time coordinates')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'TAXIS')
      CALL ef_set_arg_desc(id, arg,
     .        'Output time axis')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, YES, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE scat2grid_t_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER ntout, nt2

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      ntout = 1 + arg_hi_ss(T_AXIS,ARG2) - arg_lo_ss(T_AXIS,ARG2)

* doubled in case REAL is REAL*4
      nt2 = 2 * ntout

* taxlo  output t axis box lower limits
      CALL ef_set_work_array_dims_6d(id, 1,
     .                                1, 1, 1, 1, 1, 1,
     .                              nt2, 1, 1, 1, 1, 1)

* taxhi  output t axis box upper limits
      CALL ef_set_work_array_dims_6d(id, 2,
     .                                1, 1, 1, 1, 1, 1,
     .                              nt2, 1, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*

      SUBROUTINE scat2grid_t_compute(id, arg_1, arg_2,
     .                               result, taxlo, taxhi)

*  arg_1  tpts  Scattered t values to be gridded.
*  arg_2  taxis T axis to use for output

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* Ignore the unused final dimensions in the work arrays since
* Fortran is column major
      REAL*8 taxlo(wrk1lox:wrk1hix/2)
      REAL*8 taxhi(wrk2lox:wrk2hix/2)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l, m, n
      INTEGER idx, lo_ss, hi_ss, l1
      INTEGER ntpts, ntgrid
      REAL tt
      CHARACTER*250 errtxt

C  variables for checking axis characteristics (modulo axes)
      CHARACTER ax_name(6)*16, ax_units(6)*16
      LOGICAL backward(6), mdulo(6), regular(6)
      LOGICAL modulot
      REAL*8 modtlen

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*  Check to see if output axis is modulo (does not need to be regular)
      CALL ef_get_axis_info_6d(id, ARG2, ax_name, ax_units, 
     .                         backward, mdulo, regular)
      modulot = mdulo(T_AXIS)
      IF ( modulot ) THEN
         CALL ef_get_axis_modulo_len(id, ARG2, T_AXIS, modtlen)
      ENDIF

*  Find number of points in scattered input points.  1-D arrays defining
*  the scattered data points may lie on any axis of the input argument.
*  Using as flattened arrays, so consider all axes.

      ntpts = 0
      DO 40 idx = X_AXIS, F_AXIS
         lo_ss = arg_lo_ss(idx,ARG1)
         hi_ss = arg_hi_ss(idx,ARG1)
         IF ( lo_ss .NE. ef_unspecified_int4 ) THEN
            IF ( ntpts .NE. 0 ) THEN
               ntpts = ntpts * (hi_ss - lo_ss + 1)
            ELSE
               ntpts = hi_ss - lo_ss + 1
            ENDIF
         ENDIF
  40  CONTINUE

      IF ( ntpts .EQ. 0 ) THEN
         errtxt = 'No data in TPTS'
         GOTO 999
      ENDIF

*  Check tax is a T axis

      lo_ss = arg_lo_ss(T_AXIS,ARG2)
      hi_ss = arg_hi_ss(T_AXIS,ARG2)
*  Check that tax a T axis
      IF ( lo_ss .EQ. ef_unspecified_int4 ) THEN
         errtxt = 'Second argument must be a T axis'
         GO TO 999
      ENDIF
      ntgrid = hi_ss - lo_ss + 1

C  Get cell boundaries

      CALL ef_get_box_limits(id, ARG2, T_AXIS, arg_lo_ss(T_AXIS, ARG2),
     .                       arg_hi_ss(T_AXIS, ARG2), taxlo, taxhi)

*  Compute result

      i = res_lo_ss(X_AXIS)
      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      m = res_lo_ss(E_AXIS)
      n = res_lo_ss(F_AXIS)

*  Initialize counts

      DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         result(i,j,k,l,m,n) = 0.
      ENDDO

*  Loop over input tpts

      DO 700 idx = 1, ntpts

         CALL pickout(arg_1, idx, tt)
         IF ( tt .EQ. bad_flag(ARG1) ) GOTO 700

*  If an output axis is modulo, apply modulo adjustment to that coordinate
*  of the scattered point.
         IF ( modulot ) THEN
            CALL modscat(taxlo(1), taxhi(ntgrid), modtlen, 1, tt)
         ENDIF

         l1 = 1
         DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS) 

            IF ( tt .GE. taxlo(l1) .AND. tt .LE. taxhi(l1) ) THEN
               result(i,j,k,l,m,n) = result(i,j,k,l,m,n) + 1.
*              Location found and point assigned; go to the next scatter point
               GOTO 700
            ENDIF

            l1 = l1 + 1
  400    CONTINUE

 700  CONTINUE

      RETURN

 999  CALL EF_BAIL_OUT(id, errtxt)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN
      END

	SUBROUTINE MR_IN_USE ( mr )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* flag that the specified variable is in use as a component of a calculation
* and is therefore not available to be deleted
* (multiple calculations can claim the same component by incrementing the
* protection counter)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  6/12/89
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V702 12/16 *sh* doc change only

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xvariables.cmn'

* calling argument declarations:
	INTEGER mr

* internal variable declarations:
	INTEGER prev, next

* remove it from the deletion chain if it is in there
	IF ( mr_protected(mr) .EQ. mr_not_protected ) THEN
	   prev = mr_del_blink(mr)
	   next = mr_del_flink(mr)
	   mr_del_flink(prev) = next
	   mr_del_blink(next) = prev
	   mr_del_flink(mr)   = unspecified_int4	! important 12/16
	   mr_del_blink(mr)   = unspecified_int4	! important 12/16
* ... changing to "in use" makes it "essential memory"
	   essential_mem = essential_mem + mr_size(mr)
	   IF (essential_mem.GT.peak_essential_mem) 
     .		peak_essential_mem = essential_mem

	ELSEIF ( mr_protected(mr) .EQ. mr_in_progress ) THEN
	   mr_protected(mr) = mr_not_protected  ! to be incremented just below
* ... mr_in_progress vars are already considered "essential memory"
	ENDIF

* bump claims counter
	IF ( mr_protected(mr) .GE. mr_not_protected ) 
     .		mr_protected(mr) = mr_protected(mr) + 1
	   
	RETURN
	END

	SUBROUTINE ASSIGN_VARIABLE( cx, mr, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* assign and fill a slot in the memory variable table to the variable or
* expression indicated in the context cx
* the assigned variable will always be designated as "in-progress"

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.1 - 1/30/87 - modified for mr_protected declared as INTEGER
* revision 0.2 - 3/23/87 - eliminated mr_norm
* revision 0.3 - 4/1/87  - bad_flag changed
* revision 0.4 - 7/21/87 - contexts changed to reflect exact size requested by
*			   the operator so the stored in-plane memory variable
*			   limits must be rounded out to the grid box edges
* revision 0.5 - 8/18/87 - added trans_arg (for @SHF)
* revision 0.6 - 7/21/88 - find mem var slot with FIND_MR_SLOT
* revision 0.7 - 1/4/89  - added regrid transforms
* V200:  5/18/89 - 4D symmetrical; using mr_del_ deletion chain
*		 - context assignment in a separate routine
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V702:  1/17 *sh* - dynamic memory management
*                  - find MR slot outside of this routine 

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'

* calling argument declarations:
	INTEGER		cx, mr, status

* internal variable declarations:
	CHARACTER*4	VAR_CODE

* flag it as "in progress"
	mr_protected( mr ) = mr_in_progress

* since it is in progress it is "essential" (not safe to delete)
	essential_mem = essential_mem + mr_size(mr)
	IF (essential_mem.GT.peak_essential_mem) 
     .		peak_essential_mem = essential_mem

* assign variable context to slot
	CALL ASSIGN_MR_CX( cx, mr )

* success
	status = ferr_ok    ! 1/17 no longer a failure possibility here
 5000	RETURN

* error exit : no space available
! 5010	CALL ERRMSG( ferr_too_many_vars, status,
!     .			VAR_CODE(cx_category(cx),cx_variable(cx)), *5000 )

	END

	SUBROUTINE COPY(FROM,TO,IER)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)copy.f	1.2    5/26/88
C**
C**
C***********************************************************************
C**
C**		    PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C**	Subprogram called:
C**		CALL COPY(FROM,TO,IER)
C**
C**	Parameters:
C**		FROM -- File to be copied (char*80)
C**		TO   -- File to be created (char*80)
C**		IER  -- Error code
C**			0 = success
C**			10 = spawn error
C**			20 = wait error
C**			2 = error - unlikly results to be expected
C**			4 = severe error - possible PIP abort
C**
C**	Description:
C**		COPY executes the MCR PIP command to copy a file.
C**
C**	History:
C**	    Written: 
C**		22-JAN-86	by Donald W. Denbo
C**	    Modified:
C**		30-MAY-86	by Donald W. Denbo
C**		  Changes made for VAX/VMS version
C**
C**
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 

	CHARACTER FROM*(*),TO*(*)
c
c	rsx-11m
c
c	INTEGER*2 WAIT,ERROR,FLAG,STATUS,IER
c	CHARACTER CMD*80
c	WRITE(CMD,999)TO,FROM
c999	FORMAT('PIP ',A30,'=',A30)
c	CALL SQUISH(CMD,5,61)
c	WAIT=0
c	FLAG=0
c	CALL TISPWN(CMD,WAIT,ERROR,FLAG,STATUS)
c	IF(ERROR.EQ.0.AND.STATUS.EQ.1)THEN
c	    IER=0
c	ELSE
c	    IER=10*ERROR+STATUS
c	ENDIF
c
c	end rsx-11m
c
c	vax/vms
c
	CHARACTER CMD*200	
	INTEGER IER
	WRITE(CMD,999)FROM,TO
999	FORMAT('$COPY ',A80,' ',A80)
#ifndef unix
	CALL LIB$SPAWN(CMD)
#endif
	IER=0
	RETURN
	END

	SUBROUTINE VAR_DATA_FMT( nleft, nright, rqst_digits, min_width,
     .				 width, good_fmt, bad_fmt )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* prepare a format suitable to write out gridded data in a minimum width that
* provides the requested precision.  May use E or F format, depending on size
* "min_width" prevents the field from being less than xxx columns

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V200:   7/9/90 - extracted from LIST_CMND_DATA
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

        IMPLICIT NONE
	include 'ferret.parm'

* calling argument declarations:
	INTEGER nleft, nright, rqst_digits, min_width,
     .		width
	CHARACTER*(*) good_fmt, bad_fmt

* local variable declarations:
	INTEGER	F_size, E_size

* use F or E format for good data - whichever is smaller
	F_size = nleft + nright + 3	! _.     and extra spc --> 3
	E_size = rqst_digits + 7		! -.E-xx and extra spc --> 7
	IF ( F_size .LT. E_size ) THEN
	   width = MAX( F_size, min_width )
	   WRITE ( good_fmt, 3000 ) 'F', width, nright
	ELSE
	   width  = MAX( E_size, min_width )
	   WRITE ( good_fmt, 3000 ) '1PE', width, rqst_digits-1
	ENDIF

* string format for bad data
	WRITE ( bad_fmt, 3002 ) width
* . . . to create ...FORMAT (Fxx.yy) and FORMAT (Axx)

 3000	FORMAT ( '(',A,I2,'.',I2,')' )	
 3002	FORMAT ( '(A',I2,')' )	

	RETURN
	END

	SUBROUTINE UNPROTECT_CMND_DATA

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* unprotect (flag as not in use) the data from the most recent command

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V230: 7/27/92 - removed code from GET_CMND_DATA
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V720  4/17 *sh* allow mr_table_entry_only (for DSG vars cached in dsg_linemem)
* V740: 1/18 *acm* for issue 1854, protection status temporarily reset 
*             for curvi-coord plot with /SET

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xvariables.cmn'

* calling argument declarations
* ...

* local variable declarations
	INTEGER		nu, mr

* remove protections from the data grids
	DO 400 nu = 1, num_uvars_in_cmnd
	   mr = is_mr( nu )
	   IF ( mr_protected(mr) .NE. mr_deleted ) 
     .                                CALL MR_NOT_IN_USE( mr )
 400	CONTINUE

! temp diagnostic - last mem var fetched should never be in-use by this stage
 	IF ( mr_protected( mr ) .NE. mr_perm_protected
     . .AND. mr_protected( mr ) .NE. mr_not_protected
     . .AND. mr_protected( mr ) .NE. mr_temporary
     . .AND. mr_protected( mr ) .NE. mr_table_entry_only
     . .AND. mr_protected( mr ) .NE. mr_deleted 
     . .AND. mr_protected( mr ) .GT. mr_keep_flag )
     .			WRITE (6,*) 'get_cmnd_prot_err'

 	RETURN
	END

	SUBROUTINE AXIS_ENDS( plot_ax, dat_ax, grid, first, last, delta,
     .                        is_log, axtp, versus, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* set up PPLUS to know the correct axis endpoints and tic interval

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 7/21/87
* revision 0.1 - 2/29/88 - allowed for non-inverted vertical Z axis
* V300 10/93 - allow delta value to be passed into this routine
* Linux Port *kob* 12/96 - had to add "external RANGE" because RANGE is an
*			   intrinsic function for F90.
* V500 - *jd* 5.3.99 Add axis extrema symbols
*	 *sh* 6/99 - consolidated axis extrema symbols into AXIS_END_SYMS
*             7/99 - use 7 digits of output precision
*        *kob* 9/99 - fixed minor bug in which length of val_buff was one
*                     character too short.  this only showed up under Linux
*        *acm* 6/01 - add logical IS_LOG  for log axis
* V580 *acm* 12/04 Fix bug 1129; send back correct value of delta if computed here
* V68  *acm* 1/12 changes for double-precision ferret, single-precision pplus.
* V695+ *sh* 4/15 format long longitude axes using a delta based upon 15 deg
* V710  *acm* 11/16 Ticket 2483: Fix the axis-end symbols that are defined 
*                   for time axis plots
* V720  *acm*  2/17 Ticket 2246. If the plot is a PLOT/VS plot (or polygon plot?),
*                   then axis-backwards is not relevant. The plot axis is drawn
*                   from the data values not the grid.

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'plot_setup.parm'
	include 'errmsg.parm'
	include 'xtm_grid.cmn_text'
	include 'xplot_setup.cmn'

* kob 12/96
	EXTERNAL RANGE
* calling argument declarations:
	LOGICAL		is_log, versus
	CHARACTER*1	plot_ax		! X (horiz) or Y (vert) axis of plot
	INTEGER		dat_ax, grid	! X,Y,Z,... axis of data
	REAL*8		first, last, delta

* internal variable declarations:
	LOGICAL		BKWD_AXIS, GEOG_LABEL
	CHARACTER	val_buff*45, tstyle*3, xtra_lab*24
	INTEGER		TM_GET_CALENDAR_ID, axtp, taxis, cal_id, status
	REAL*4		x1, x2, uminr, umaxr, dint
	REAL*8		TSTEP_TO_SECS, SECS_TO_TSTEP, firstl, lastl, epsilon, eps2, span
	PARAMETER	(epsilon=1.e-45)

	STATUS = ferr_ok 

	xtra_lab = ' '

* For log axes set up PPLUS for a regular or inverted log axis

	IF (is_log) THEN
 
* Check for negative or too-tiny values of range
	   IF (first .LT. epsilon .OR. last  .LT. epsilon) GO TO 5000

	   IF (.NOT.versus .AND. BKWD_AXIS(dat_ax, grid) ) THEN
	      axtp = 4		! inverse log axis (leave type 3 as is in PPLUS)
           ELSE
	      axtp = 2		! log axis
	   ENDIF

	   firstl = LOG10(first)
	   lastl = LOG10(last)

	   first = INT(LOG10(first))
	   last  = INT(LOG10(last))

!  If needed, round the higher limit up, if not an exact decade already. 
	   eps2 = ABS(MIN(firstl, lastl)/ 100.)

           IF (lastl .GE. firstl ) THEN
	      IF (ABS(lastl - last) .GT. eps2) last = last + 1.
	      IF (ABS(lastl - last) .GT. 1.) last = last - 1.
	   ELSE
             IF (ABS(firstl - first) .GT. eps2) first = first + 1.
	      IF (ABS(firstl - first) .GT. 1.) first = first - 1.
	   ENDIF
       ENDIF
       span = ABS(last-first)

* Convert to single precision and reverse order if a depth plot on Y axis

#ifdef double_p
	IF ( plot_ax .EQ. 'Y'  .AND. .NOT.versus .AND. BKWD_AXIS(dat_ax, grid) ) THEN
	   x2 = (first)
	   x1 = (last)
	ELSE
	   x1 = (first)
	   x2 = (last)
	ENDIF
#else	
	IF ( plot_ax .EQ. 'Y'  .AND. NOT.versus .AND. BKWD_AXIS(dat_ax, grid) ) THEN
	   x2 = SNGL(first)
	   x1 = SNGL(last)
	ELSE
	   x1 = SNGL(first)
	   x2 = SNGL(last)
	ENDIF
#endif

* use Denbo's PPLUS routine to calculate the tic interval, dint
	IF ( delta .EQ. unspecified_val8 ) THEN
	   IF (dat_ax .EQ. x_dim
     .   .AND. GEOG_LABEL(x_dim,grid)
     .	 .AND. span .GT. 75. .AND..NOT.versus ) THEN
* ... use 15-degree delta for long longitude axes
	      IF (span .GT. 180.) THEN
	         delta = 30.
	      ELSE
	         delta = 15.
	      ENDIF
	      dint = delta
	   ELSE
	      CALL RANGE( x1, x2, 10, uminr, umaxr, dint )
              delta = dint
	   ENDIF
	ELSE
	   dint = delta
	ENDIF

* if its a time axis, correct the  the actual axis ends that PPLUS will use.
	IF (.NOT.versus .AND. .NOT.adjust_time .AND. 
     .      (dat_ax .EQ. t_dim .AND. GEOG_LABEL(t_dim,grid)) ) THEN
	   taxis = grid_line(t_dim,grid)
           cal_id = TM_GET_CALENDAR_ID ( line_cal_name(taxis) )

	   first = TSTEP_TO_SECS(grid, t_dim, first)
	   last  = TSTEP_TO_SECS(grid, t_dim, last)

* Set time style: 'MON', 'YR', etc.  CALL TAXIS_STYLE to set the
* parameter ITYPET in common

	   CALL TAXIS_STYLE( plot_ax, first, last, tstyle, xtra_lab ) 

	   CALL TPLOT_AXIS_ENDS  (first, last, cal_id, tstyle)
	   first = SECS_TO_TSTEP( grid, t_dim, first )
	   last  = SECS_TO_TSTEP( grid, t_dim, last )
	ENDIF

* and send the actual limits requested together with this tic interval to PPLUS
	WRITE ( val_buff, '(3(E14.7,1X))' ) x1, x2, dint
	CALL PPLCMD ( from, line, 0, 
     .				plot_ax//'AXIS '//val_buff , 1, 1 )

* Define symbols identifying axis limits
	CALL AXIS_END_SYMS(plot_ax, first, last)

	RETURN
 5000	STATUS = 9999

      END

	SUBROUTINE CHECK_PLOT_TRAJ (versus, nvars, grid, its_traj)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Are we making a plot from a DSG trajectory dataset?
* Is it a trajectory plot? 
* Is it a non-trajectory ribbon plot from a traj dataset?
* Is this just a regular ribon plot with 3 variables (not a lon/lat traj plot)? 
* OR a PLOT/VS var1,var2 from a DSG trajectory dataset for var1,var2 not lon/lat?


* V751 7/19 *acm*  Changes for working with user-defined variables on DSG grid
* V76  1/20 *acm*  Point data are also plotted as ribbon plots, with symbols.

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
        include 'xdset_info.cmn_text'
	include 'xplot_setup.cmn'
#include "tmap_dset.parm"

* calling argument declarations:
	LOGICAL versus, its_traj
	INTEGER nvars, grid

* internal variable declarations:
	INTEGER	TM_DSG_DSET_FROM_GRID, TM_UNIT_ID, dset, iunits1, iunits2, cx
	CHARACTER VAR_UNITS*40, buff1*40


	dset = TM_DSG_DSET_FROM_GRID( grid )
       its_traj = dsg_feature_type(dset).EQ.pfeatureType_Trajectory .OR.  
     .            dsg_feature_type(dset).EQ.pfeatureType_Point

	IF (its_traj .AND. versus .AND. nvars.GT.1) THEN

	   cx = is_cx(1)
	   buff1 = VAR_UNITS(cx)
	   iunits1 = TM_UNIT_ID(buff1)
	       
	   cx = is_cx(2)
	   buff1 = VAR_UNITS(cx)
	   iunits2 = TM_UNIT_ID(buff1)
	       
	   its_traj = (iunits1.EQ.4 .AND. iunits2.EQ.4)  ! still a traj plot
	   IF (.NOT.its_traj .AND. nvars.EQ.2) ribbon_plot = .FALSE.
	ENDIF

	RETURN
	END

	SUBROUTINE LIST_MULTI(  mr_list, cx_list,
     .			       heading, perm, wsize, work, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* control routine to set up working arrays for LIST_MULTI_SUB

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  7/31/90
* V312: 5/94 - array "memory" as a calling argument
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include 'tmap_dims.parm'


* calling argument declarations:
	LOGICAL	heading
	INTEGER	mr_list(*), cx_list(*), perm(nferdims), wsize, status
	REAL	work(0:wsize)
	
* internal variable declarations:
	INTEGER ws

* the work array is partitioned as follows in the called routine:
* These need to be recomputed if nferdims is changed.
*	work(0)	     is xact_range(nvar)
*	work(ws)     is has_size(nferdims,nvar)
*	work(7*ws)   is bad(nvar)
*	work(8*ws)   is pt_blk(nvar)   (not used after 2/12 changes)
*	work(9*ws)   is size(nferdims,nvar)
*	work(15*ws)  is msize(nvar)
*	work(16*ws)  is width(nvar)
*	work(17*ws)  is out(nvar)

	ws = wsize / (2*nferdims+6)
	CALL LIST_MULTI_SUB(mr_list,cx_list,heading,perm, ws,
     .			work(0),     work(ws),   work(7*ws),
     .			work(8*ws),  work(9*ws), work(15*ws),
     .			work(16*ws), work(17*ws),
     .			status)


	RETURN
	END

*
* tax_units.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Jing Y. Li 
* May 4th 2006
* v695  *acm 2/15  Time axis may be an F axis or a T axis.
*
* This function returns the time axis unit value in seconds.
*

*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*
* 2006-05-11 It only works with the unit naming convention in xunits_data.F

      SUBROUTINE tax_units_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .     'Returns units of time axis coordinate values, in seconds')
      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance_6d(id,
     .                                NORMAL, NORMAL,
     .                                NORMAL, NORMAL,
     .                                NORMAL, NORMAL)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'variable with reference time axis')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE tax_units_compute(id, arg_1, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'
      INCLUDE 'xunits.cmn_text'
      EXTERNAL xunits_data

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      INTEGER i, j, k, l, m, n
      INTEGER iun, dir
      CHARACTER*16 axname(6), axunits(6)
      LOGICAL bkw1(6), mod1(6), reg1(6)
      CHARACTER*255 err_msg

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* Get the direction of arg 1
      IF (arg_lo_ss(T_AXIS, ARG1) .NE. ef_unspecified_int4) dir = T_AXIS
      IF (arg_lo_ss(F_AXIS, ARG1) .NE. ef_unspecified_int4) dir = F_AXIS

      i = res_lo_ss(X_AXIS)
      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      l = res_lo_ss(T_AXIS)
      m = res_lo_ss(E_AXIS)
      n = res_lo_ss(F_AXIS)

*     Get axis information
      CALL ef_get_axis_info_6d(id, ARG1, axname, axunits,
     .                         bkw1, mod1, reg1)
      CALL LOWER_CASE(axunits(dir))
      DO 20 iun = pun_1st_time, pun_last_time 
         IF ( (un_name(iun)      .EQ. axunits(dir))      .OR.
     .        (un_name(iun)(1:2) .EQ. axunits(dir)(1:2)) .OR.
     .        ( (un_name(iun)    .EQ. 'yr')   .AND.
     .          (axunits(dir) .EQ. 'year')      )        ) THEN
            result(i,j,k,l,m,n) = un_convert(iun) 
            RETURN
         ENDIF
  20  CONTINUE

      WRITE(err_msg,*) 'Unrecognized time axis unit ', axunits(dir)
      CALL ef_bail_out (id, err_msg)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END

	SUBROUTINE SETAX(X,NXS,XF,YF,XL,YL,XH,YH,NMX,NMY,
     *	XTI,XTL,its_ribbon)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
*	Modified J Davison 11.28.88 for compatibility to v1.1 PPL
*
*       Declarations added 9.6.88 J Davison                           
*	Mod for 4 year digits *jd* 11.21.95
*  
* v5.41 *acm* - 3/02  If autoscaling is done on an axis, after the
*                     scale settings are made, set XAXIS_MIN, XAXIS_MAX
*                     or YAXIS_MIN, YAXIS_MAX
*               Also remove VMS include statements.
* v5.41 *acm*   6/20/02 remove unneeded calls to GETSYM.
* V554  9/03 *acm* Fix precision bug double precision, for fine grids in 
*                  curvlinear coordinates. See also pltit.F, plotz.F
* V694  *acm*  1/15 Changes to allow two time axes on plot (F-T)
* V694  *acm*  5/15 Ticket 2283. Handling axis scaling for ribbon plots. Do auto-scale 
*                   using just the first line. The second is the color-by variable
* V695  *acm*  9/15 Changes for hour:min labeling on time axes
* V697  *acm*  1/16 Ticket 2344: if there was a time-plot underlay, will use the underlay's 
*                   time scaling for time overlay plots.

	REAL*8		DIFF, dtd
        real            x,rxax,rxmon,rxchr,thi,xti,xtl
        real            xmn,xmx,xt,yt
        real*8		dxl, dxh, dxf, dyl, dyh, dyf
	logical		its_ribbon
                                                                      
        integer         nxs,iy,nmx,i,ibasex,ibasey,len,j,nmy    
	
	integer		lnum_lines
                                                                      
        external        diff                                          
*       End declarations 9.6.88
*	
*	Declarations added 11.28.88
	real		xtx,ytx,xtm,ytm
*	End declarations 11.28.88

	external RANGE

C**
C**    @(#)setax.F	1.2    9/8/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
	DIMENSION X(NXS)
C	KTYPE = 0 -XY  1 -Z  2-VECTOR

        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'lines_inc.decl'
        include 'LINES.INC'
        include 'pen_inc.decl'
        include 'PEN.INC'
        include 'pltl_inc.decl'
        include 'PLTL.INC'
        include 'axis_inc.decl'
        include 'AXIS.INC'
        include 'hd_inc.decl'
        include 'HD.INC'
        include 'taxis_inc.decl'
        include 'TAXIS.INC'
        include 'axisl_inc.decl'
        include 'AXISL.INC'
        include 'miss_inc.decl'
        include 'MISS.INC'
        include 'cmrdl_inc.decl'
        include 'CMRDL.INC'

	LOGICAL CONTR,VECTR
	CHARACTER IT1TMP*14,IT2TMP*14

	dtd = dt
	dt_save = dt

C	SETUP AXIS FOR ALL PLOT TYPES.
c	CONTR=MAKEP.EQ.'CONTOUR'.OR.MAKEP.EQ.'VIEW'.or.makep.eq.'SHADE'
c     *	.OR.MAKEP.EQ.'VECTOR'

	CONTR=MAKEP.EQ.'CONTOUR'.OR.MAKEP.EQ.'VIEW'
     *		.OR.MAKEP.EQ.'VECTOR'.or.makep.eq.'SHADE'   
     *          .or.makep.eq.'FLOWLINE'
     *          .or.makep.eq.'FILL'.or.makep.eq.'PIXEL'

	VECTR=MAKEP.EQ.'PLOTV'.OR.MAKEP.EQ.'PLOTUV'
     *	.OR.MAKEP.EQ.'VELVCT'
	IY=NXS/2
	IF(ITFLG.NE.0)THEN
	    IF (IAUTOT .EQ. 1 .AND.
     1	        (IFORM(1:3).EQ.'EPI' .OR. IFORM(1:3).EQ.'BIB' .or.
     2		iform(1:3).eq.'LDX')) THEN
		IF (is_hours_axis .GT. 0) THEN ! Round off to the nearest minute
		   CALL FIXTIM (ITMIN,ITMAX,IT1,IT2,4)
		ELSE
		   CALL FIXTIM (ITMIN,ITMAX,IT1,IT2,ITYPET) ! to the hour
		ENDIF
	    ELSE
		IF (is_hours_axis .GT. 0) THEN ! Round off to the nearest minute
		   CALL FIXTIM (IT1,IT2,IT1TMP,IT2TMP,4)
		ELSE
		   CALL FIXTIM (IT1,IT2,IT1TMP,IT2TMP,ITYPET)
		ENDIF
		IT1=IT1TMP
		IT2=IT2TMP
	    ENDIF
	    TLO = 1. - DIFF(IT1,ITSTRT)/dtd
C
C	    CHANGE FROM 3-CHAR MON TO 1-CHAR MON IF INSUFFICIENT SPACE
C
	    RXAX=DIFF(IT1,IT2)/1440.
	    IF(ITFLG.GT.0)THEN
		RXMON=30.*XLEN/RXAX
	    ELSE
		RXMON=30.*YLEN/RXAX
	    ENDIF
	    RXCHR=TCSIZE*6.
	    IF (RXCHR .GT. RXMON) then
		itxtpe=3
		labelt=itxtpe*itxlbp
	    endif
	    THI=TLO+DIFF(IT1,IT2)/dtd
	ENDIF


	IF(ITFLG.EQ.2)THEN
	    IF (IAUTOT .EQ. 1 .AND.
     1	        (IFORM(1:3).EQ.'EPI' .OR. IFORM(1:3).EQ.'BIB' .or.
     2		iform(1:3).eq.'LDX')) THEN
		CALL FIXTIM (ITMIN,ITMAX,IT1b,IT2b,ITYPETb) 
		TLOb = 1. - DIFF(IT1,ITSTRT)/dtd
	    ELSE
		CALL FIXTIM (IT1b,IT2b,IT1TMP,IT2TMP,ITYPETb)
		IT1b=IT1TMP
		IT2b=IT2TMP
		TLOb = 1. - DIFF(IT1b,ITSTRTb)/dtd
	    ENDIF
C
C	    CHANGE FROM 3-CHAR MON TO 1-CHAR MON IF INSUFFICIENT SPACE
C
	    RXAX=DIFF(IT1b,IT2b)/1440.
	    RXMON=30.*XLEN/RXAX
	    RXCHR=TCSIZE*6.
	    IF (RXCHR .GT. RXMON) then
		itxtpeb=3
		labeltb=itxtpeb*itxlbpb
	    endif
	    THIb=TLOb+DIFF(IT1b,IT2b)/dtd
	ENDIF

	call trans(0,xmin,ymin,xtm,ytm)
	call trans(0,xmax,ymax,xtx,ytx)
	
	IF(ITFLG.EQ.2)THEN
	    XTI=XHI
	    XTL=XLO
	    XHI=THI
	    XLO=TLO
	    DXF=XLEN/(XHI-XLO)
	    IF(CONTR)THEN
		DXL=(xtm-XLO)*DXF
		DXH=XLEN+(xtx-XHI)*DXF
	    ENDIF
	ENDIF
	IF(ITFLG.EQ.1)THEN
	    XTI=XHI
	    XTL=XLO
	    XHI=THI
	    XLO=TLO
	    DXF=XLEN/(XHI-XLO)
	    IF(CONTR)THEN
		DXL=(xtm-XLO)*DXF
		DXH=XLEN+(xtx-XHI)*DXF
	    ENDIF
	ELSE
	    IF(CONTR)THEN
C	CONTOUR PLOT
		IF(IAUTOX.EQ.1)THEN
		    IF(ITYPEX.GT.1)THEN
			CALL RANGEL(xtm,xtx,XLO,XHI)
			XLO=LOG10(ABS(XLO))
			XHI=LOG10(ABS(XHI))
		    ELSE
			CALL RANGE(xtm,xtx,NTICX,XLO,XHI,XTIC)
		    ENDIF
		    IF(xtm.gt.xtx)THEN
			DXF=XLO
			XLO=XHI
			XHI=DXF
			XTIC=-XTIC
		    ENDIF
		ENDIF
		DXF=XLEN/(XHI-XLO)
		DXL=(xtm-XLO)*DXF
		DXL=(xtm-XLO)*DXF
		DXH=XLEN+(xtx-XHI)*DXF
		NMX=NMTCX              
	    ELSE
		IF(IAUTOX.EQ.0)GOTO 100
		IF(VECTR)THEN
		    XMN=1.
		    XMX=LLENG(1)
		    DO 50 I=1,LNUM
			IF(XMX.LT.LLENG(I))XMX=LLENG(I)
50		    CONTINUE
		ELSE
		    XMN=1.E38
		    XMX=-XMN
		    IBASEX=0
		    IBASEY=IY
		    lnum_lines = lnum
		    IF (its_ribbon) lnum_lines = 1  
		    DO 10 I=1,lnum_lines
			LEN=LLENG(I)
			DO 20 J=1,LEN
			    IF((XLE.AND.X(IBASEX+J).LE.CMXLE).OR.
     *			    (XEQ.AND.X(IBASEX+J).EQ.CMXEQ).OR.
     *			    (XGE.AND.X(IBASEX+J).GE.CMXGE).OR.
     *			    (YLE.AND.X(IBASEY+J).LE.CMYLE).OR.
     *			    (YEQ.AND.X(IBASEY+J).EQ.CMYEQ).OR.
     *			    (YGE.AND.X(IBASEY+J).GE.CMYGE))GOTO 20
			    XT=X(IBASEX+J)*XFCT(I)+XOFF(I)
			    IF(XT.LT.XMN)XMN=XT
			    IF(XT.GT.XMX)XMX=XT
20			CONTINUE
			IBASEX=IBASEX+LEN
			IBASEY=IBASEY+LEN
10		    CONTINUE
		ENDIF
		IF(ITYPEX.GT.1)THEN
		    CALL RANGEL(XMN,XMX,XLO,XHI)
		    XLO=LOG10(ABS(XLO))
		    XHI=LOG10(ABS(XHI))
		ELSE
		    CALL RANGE(XMN,XMX,NTICX,XLO,XHI,XTIC)
		ENDIF
	    ENDIF
100	    DXF=XLEN/(XHI-XLO)
	    NMX=NMTCX
	ENDIF
C	YAXIS
	IF(ITFLG.EQ.2)THEN
	    XTI=YHI
	    XTL=YLO
	    YHI=THIb
	    YLO=TLOb
	    DYF=YLEN/(YHI-YLO)
	    IF(CONTR)THEN
		DYL=(ytm-YLO)*DYF
		DYH=YLEN+(ytx-YHI)*DYF
	    ENDIF
        ENDIF

	IF(ITFLG.EQ.-1)THEN
	    XTI=YHI
	    XTL=YLO
	    YHI=THI
	    YLO=TLO
	    DYF=YLEN/(YHI-YLO)
	    IF(CONTR)THEN
		DYL=(ytm-YLO)*DYF
		DYH=YLEN+(ytx-YHI)*DYF
	    ENDIF
	ELSE
	    IF(CONTR)THEN
C CONTOUR DATA
		IF(IAUTOY.EQ.1)THEN
		    IF(ITYPEY.GT.1)THEN
			CALL RANGEL(ytm,ytx,YHI,YLO)
			YHI=LOG10(ABS(YHI))
			YLO=LOG10(ABS(YLO))
		    ELSE
			CALL RANGE(ytm,ytx,NTICY,YLO,YHI,YTIC)
		    ENDIF
		    IF(ytm.gt.ytx)THEN
			DYF=YLO
			YLO=YHI
			YHI=DYF
			YTIC=-YTIC
		    ENDIF
		ENDIF
		DYF=YLEN/(YHI-YLO)
		DYL=(ytm-YLO)*DYF
		DYH=YLEN+(ytx-YHI)*DYF
		NMY=NMTCY
	    ELSE
		IF(IAUTOY.EQ.0)GOTO 200
		XMN=1.E38
		XMX=-XMN
		IBASEY=IY
		IBASEX=0
		lnum_lines = lnum
		IF (its_ribbon) lnum_lines = 1  
		DO 30 I=1,lnum_lines
		    DO 40 J=1,LLENG(I)
			IF((XLE.AND.X(IBASEX+J).LE.CMXLE).OR.
     *			(XEQ.AND.X(IBASEX+J).EQ.CMXEQ).OR.
     *			(XGE.AND.X(IBASEX+J).GE.CMXGE).OR.
     *			(YLE.AND.X(IBASEY+J).LE.CMYLE).OR.
     *			(YEQ.AND.X(IBASEY+J).EQ.CMYEQ).OR.
     *			(YGE.AND.X(IBASEY+J).GE.CMYGE))GOTO 40
			YT=X(IBASEY+J)*YFCT(I)+YOFF(I)
			IF(YT.LT.XMN)XMN=YT
			IF(YT.GT.XMX)XMX=YT
40		    CONTINUE
		    IBASEX=IBASEX+LLENG(I)
30		IBASEY=IBASEY+LLENG(I)
		IF(VECTR)THEN
		    IF(ABS(XMX).GT.ABS(XMN))THEN
			XMN=-ABS(XMX)
		    ELSE
			XMX=ABS(XMN)
		    ENDIF
		ENDIF
		IF(ITYPEY.GT.1)THEN
		    CALL RANGEL(XMN,XMX,YLO,YHI)
		    YLO=LOG10(ABS(YLO))
		    YHI=LOG10(ABS(YHI))
		ELSE
		    CALL RANGE(XMN,XMX,NTICY,YLO,YHI,YTIC)
		ENDIF
200		DYF=YLEN/(YHI-YLO)
		NMY=NMTCY
	    ENDIF
	ENDIF

C	YAXIS and XAXIS are time/forecast axes
	IF(ITFLG.EQ.2)THEN
	    XTI=YHI
	    XTL=YLO
	    YHI=THIb
	    YLO=TLOb
	    DYF=YLEN/(YHI-YLO)
	    IF(CONTR)THEN
		DYL=(ytm-YLO)*DYF
		DYH=YLEN+(ytx-YHI)*DYF
	    ENDIF
	ENDIF
 
        IF (IAUTOX .NE. 0) CALL setax_syms('X', xlo, xhi)
        IF (IAUTOY .NE. 0) CALL setax_syms('Y', ylo, yhi)

	XF = DXF
	YF = DYF
	XL = DXL
	YL = DYL
	XH = DXH
	YH = DYH
	
	RETURN
	END

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Return the array memory limits in the common blocks for those
* times when they cannot be retrieved directly.
*
* 4D subroutine version which calls the 6D subroutine version and
* checks the E and F dimensions are unused
*
      SUBROUTINE EF_GET_ARG_MEM_SUBSCRIPTS(id, arg_memlo, arg_memhi)

      IMPLICIT NONE
      INCLUDE 'tmap_dims.parm'
      INCLUDE 'EF_Util.parm'

* argument declarations - 4D
      INTEGER id, arg_memlo(4, EF_MAX_ARGS),
     .            arg_memhi(4, EF_MAX_ARGS)

* local variables
      INTEGER ndx, adx,
     .        arg_memlo_6d(nferdims, EF_MAX_ARGS),
     .        arg_memhi_6d(nferdims, EF_MAX_ARGS)
      CHARACTER*128 buff

* call the 6D version
      CALL EF_GET_ARG_MEM_SUBSCRIPTS_6D(id, arg_memlo_6d, arg_memhi_6d)

* check E and F are unused
      DO 110 adx = 1, EF_MAX_ARGS
         DO 100 ndx = 5, nferdims
            IF ( arg_memlo_6d(ndx, adx) .NE.
     .           arg_memhi_6d(ndx, adx) ) THEN
               WRITE (buff,50) ndx, adx
 50            FORMAT ('Dimension ', I1, ' of argument ', I2,
     .            ' is used; use EF_GET_ARG_MEM_SUBSCRIPTS_6D instead')
               CALL EF_BAIL_OUT(id, buff)
               STOP 'EF_BAIL_OUT returned in EF_GET_ARG_MEM_SUBSCRIPTS'
            ENDIF
 100     CONTINUE
 110  CONTINUE

* copy to the 4D arrays
      DO 210 adx = 1, EF_MAX_ARGS
         DO 200 ndx = 1, 4
            arg_memlo(ndx, adx) = arg_memlo_6d(ndx, adx)
            arg_memhi(ndx, adx) = arg_memhi_6d(ndx, adx)
 200     CONTINUE
 210  CONTINUE

      RETURN
      END

	SUBROUTINE GETLIN(LINE,ILEN)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)getlin.F	1.2    5/26/88
C**
C**
C***********************************************************************
C**
C**		    PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C**	Subprogram called:
C**		CALL GETLIN(LINE,ILEN)
C**
C**	Parameters:
C**		LINE -- Line from command input device   (char*2048)
C**		ILEN -- Length of LINE
C**
C**	Description:
C**		Gets the next line from the command input device.
C**
C**	History:
C**	    Written: 
C**		21-DEC-85	by Donald W. Denbo
C**	    Modified:
C**
C*** v552 *acm* 3/03 Longer strings: changes for multi-line labels
C**
	INCLUDE 'CMDCOM.INC'
	INCLUDE 'SYSTEM.INC'

C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 

	CHARACTER PMPT*30,LINE*(*),IN*2048
	IP=INP
	PMPT=PRMPT
	K=1
100	IN=' '
#ifdef unix
	IF(CMDFIL(1:8).EQ.'/dev/tty')THEN
#else
	if(cmdfil(1:3).eq.'TT:')then
#endif
	    CALL CHARIN(IN,2048,PMPT,IP)
	ELSE
	    READ(CMDLUN,999,END=901)IN
999	    FORMAT(A)
	    LINCNT=LINCNT+1
	ENDIF
	ILEN=LNBLK(IN,lenlab)
	LINE(K:K+ILEN-1)=IN(1:ILEN)
	IF(IN(ILEN:ILEN).EQ.'-')THEN
	    K=K+ILEN-1
C
C	SINCE LF IS FIRST CHARACTER
C
	    PMPT=PRMPT
	    PMPT(2:2)='_'
	    PMPT(3:)=PRMPT(2:)
	    IP=INP+1
	    GOTO 100
	ENDIF
	ILEN=K+ILEN-1
	RETURN
C
C	EOF READ GO UP ONE LEVEL IN COMMAND FILE STRUCTURE
C
901	CALL ATEND
	IF(DONEF)RETURN
	GOTO 100
	END

	SUBROUTINE SET_LEVELS_CENTERKEY (do_shift)


*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* ACM 3/22/2018
* issue 1607: For centered labels draw the plot so that the levels are
* describing the middle of the colors not the contour lines between colors.
* Interpolate /LEVELS values to obtain new '''edge-values''' for the contours 
* and patch-edges; then SHADE and CONTOUR just as we always have, but using 
* those new computed levels. The color key would labeled at the patch-centers 
* using the original /LEVELS values. 
*
* When plotting is done,  will restore the previous levels, so any plot using /LEVELS
* without an argument will start this process again.
* If do_shift is FALSE, undo this shifting, restoring previous levels an nlev2.

	include		'parampl5_dat.decl'
	include		'PARAMPL5.DAT'
	include		'cont_inc.decl'
	include		'CONT.INC'
        include         'shade_vars.cmn'

	LOGICAL do_shift

	REAL zh, delz, vlo, vhi

	IF (.NOT.center_key_labels) RETURN

	IF (do_shift) THEN

	   nlev2_save = nlev2
	   DO i = 1, nlev2
	      zlevsave(i) = zlev(i) 
	   ENDDO

* When the palette is by_value, the color-spectrum setting needs to
* correspond to the original levels, but with an extra upper-bound
* If there is pos-inf, it lies below that value.

	   IF (rgb_mapping .eq. by_value) THEN
	      IF (posinf) THEN
	         del = zlev(nlev-1) - zlev(nlev-2)
	         nlev = nlev + 1
	         zlev(nlev-1) = zlev(nlev-1) + del
	      ELSE
	         del = zlev(nlev) - zlev(nlev-1)
	         nlev = nlev + 1
	         zlev(nlev) = zlev(nlev-1) + del
	      ENDIF
	      nlev2 = nlev
	      RETURN

	   ENDIF

	   zh = zlev(nlev2)
           IF (neginf) zh = zlev(nlev2-1)
	   i1 = 1
	   in = nlev2
	   IF (neginf) i1 = 2
	   IF (posinf) in = nlev2-1

*    ... initial lower bound 

	   vlo = zlevsave(i1)
	   vhi = zlevsave(i1+1)
	   zlev(i1) = vlo - (vhi-vlo)/2.

*    ... interpolate between middle levels

	   DO i = i1+1, in
	      vlo = zlevsave(i-1)
	      vhi = zlevsave(i)
	      zlev(i) = vlo + (vhi-vlo)/2.
	   ENDDO

*    ... upper-most bound
           zlev(in+1) = vhi + (vhi-vlo)/2.

           IF (neginf) zlev(1) = zlev(2) - 1
           IF (posinf) zlev(in+2) = zlev(in+1) + 1

	   nlev2 = nlev2+1

* Or, restore un-shifted set of levels

	ELSE
	   nlev2 = nlev2_save
	   nlev  = nlev2_save
	   DO i = 1, nlev2
	      zlev(i) = zlevsave(i) 
	   ENDDO
	ENDIF

	RETURN
	END

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
C  Gausswt software From Billy Kessler, PMEL, Seattle WA  25-Aug-1998

C  !ACM Modified to pass nxaxis, NAY dimensions of grid and wate.
C   and to deal with nx, nz, or nm = 1.  Also to send cutoff as a parameter.

C  May 26, 2000  Don't send cutoff, but xsc, ysc as parameters.
C  June 7, 2000  Send xsc, ysc, xcutoff, ycutoff as parameters
C  June 7, 2000  Send xsc, ysc, xcutoff, ycutoff as parameters

c.............subroutines to do gaussian-weighted mapping onto grids.

c.......3sep97: rewritten to give each nested loop a separate loop number.
c		otherwise "if (delx.gt.xcut) go to 100" does not work right!
c************************************************************************
c............sub gausswt forms the weight sums inside loop over all data.
c............--->>> 3-d mapping (x,y,t)
c............--->>> allows wraparound year (flagged by arg iwflag)
c............method is to call this sub for each data value
c............  sub loops on grid locations, maps each irregular data point to
c............  all possible gridpts, weighting by 3-d distance from gridpt.
c............  all calcs done in gridbox units
c............xx/x1/xf/xsc all in same units
c............yy/y1/yf/ysc all in same units
c............tt/t1/tf/tsc all in same units (but nm can be anzthing)
c............   note that, ie, t1 is the center of gridbox 1. So if dates
c............   are in months, Jan 15=1, Dec 15=12, and Jan 1=0.5, Dec 31=12.5.

c  i	xx,yy,tt=x/y/t location of data pt (data units)
c  i	val=data value at this (xx,yy,tt)
c  o	grid(nx,nz,nm)=sum of weighted values
c  o	wate(nx,nz,nm)=sum of weights
c  i	nx,nz,nm=size of grids
c  i	x1,y1,t1=west/south/date edge of grid (center of 1st box in data units)
c  i	xf,yf,tf=east/north/date edge of grid (center of final box)
c  i	xsc,ysc,tsc=mapping scales (data units)
c  i	iwflag=1 for time wrapping; 0 for no wrapping
c--------------------------------------------------------------------------

	subroutine gausswt2_v0 (xx,yy,tt,val,grid,wate,nx,nz,nm,x1,y1,t1,
     .             xf,yf,tf,xsc,ysc,tsc,cutoff,iwflag,nax,nay)

C ACM 6/2000 Version of gausswt with two cutoff parameters.
c acm 8/2005 there is just one cutoff parameter
c V62 *ACM* 2/2009 Keep this original version with the treatment of the
c            cutoff parameter, for backwards compatibility.
 
	integer nx, nz, nm, iwflag, nax, nay, i, j, m
	real grid(nax,nay,*), wate(nax,nay,*)
	real xx, yy, tt, val, x1, y1, t1, xf, yf, tf, xsc, ysc, tsc
	real cutoff
        real dx, dy, dt, xxg, yyg, ttg, xcut, ycut, tcut
	real xgp, delx, ygp, dely, tgp, delt, xgas, ygas, tgas, expn

	dx=1.
	dy=1. 
	dt=1.
	if (nx .gt. 1) dx=(xf-x1)/real(nx-1)  ! gridbox sizes in data units
	if (nz .gt. 1) dy=(yf-y1)/real(nz-1) 
	if (nm .gt. 1) dt=(tf-t1)/real(nm-1)

	xxg=(xx-x1)/dx+1.		  ! grid values of data location
	yyg=(yy-y1)/dy+1.
	ttg=(tt-t1)/dt+1.

c	cutoff=2.			  ! cutoff limits search (min wt=e**-4)
	xcut=cutoff*xsc/dx		  ! cutoffs scaled to grid units
	ycut=cutoff*ysc/dy		  ! look only cutoff* the scale width
	tcut=cutoff*tsc/dt		  !   from the gridbox center

	do 100 i=1,nx			  ! loop on x gridpoints
	xgp=real(i)			  ! center of gridbox
	delx=abs(xgp-xxg)		  ! distance of data pt from grid ctr
	if (delx.gt.xcut) go to 100  	  ! only do nearby points

	do 101 j=1,nz			  ! loop on y gridpoints, same procedure
	ygp=real(j)		
	dely=abs(ygp-yyg)
	if (dely.gt.ycut) go to 101

	do 102 m=1,nm			  ! loop on t gridpoints, same procedure
	tgp=real(m)
	delt=abs(tgp-ttg)
	if (delt.gt.tcut .and. iwflag.eq.1) 
     .		delt=abs(delt-real(nm)) 	! allow flagged time wrapping
	if (delt.gt.tcut) go to 102

	xgas=(delx*dx/xsc)**2		  	! make gaussian exponents
	ygas=(dely*dy/ysc)**2
	tgas=(delt*dt/tsc)**2
	expn=exp(-xgas-ygas-tgas)		! make the gaussian weight
	wate(i,j,m)=wate(i,j,m)+expn		! sum the weights
	grid(i,j,m)=grid(i,j,m)+val*expn	! sum the weighted values

102	continue
101	continue
100	continue

	return
	end

	CHARACTER*(*) FUNCTION SECS_TO_DATE_OUT ( num_secs, cal_id, 
     .            modulo, prec )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Convert secs since 01-JAN-0000 00:00:00 to a date of the form
* yyyy-mm-dd hh:mm:ss
* difference from TM_SECS_TO_DATE: if year=0 or 1 then blank year field 

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - code pulled from TM_SECS_TO_DATE
* revision 1.0 - 2/22/89 - calls TM_SECS_TO_DATE
* V530: *acm* 12/00 add calendar types; cal_id
* V610: *acm*  2/08 Fix bug 762: if the axis is not modulo, always list the
*                   year (previously never listed year 0 or year 1)
* V698  *acm* 5/16 Ticket 2405: MODE CALENDAR:auto
* V7.45 *acm* 12/18 Issue: modulo axes start in year 0 or 1 and are < 1 year long
*                   so if year=2 and modulo then blank year field  

        IMPLICIT NONE
* Calling argument declarations:
	REAL*8		num_secs
	INTEGER		cal_id, prec
        LOGICAL         modulo

* internal variable declarations
	LOGICAL		skp_year
	INTEGER		year, month, day, hour, minute, second, status
	CHARACTER	TM_SECS_TO_DATE*20, temp_str*20
        CHARACTER*3     month_names(12)
        DATA month_names/
     .		'JAN', 'FEB', 'MAR', 'APR', 'MAY', 'JUN',
     .		'JUL', 'AUG', 'SEP', 'OCT', 'NOV', 'DEC'/

* convert to date string always including year
	temp_str = TM_SECS_TO_DATE( num_secs, cal_id )
        CALL TM_BREAK_DATE (temp_str, cal_id, year, month, day,
     .		             hour, minute, second, status)

* Select the requested precision and form the string. 
* Auto-determine prec, unless the user set it explicitly. 
* If the axis is modulo, and the year is 0 thru 2, do not write the year
* If monthly time axis write only month-year-day

	skp_year = (year .LE. 2 .AND. modulo)
	IF ( prec .GE. 6 ) THEN		! full precision

	   IF (.NOT. skp_year) THEN
              WRITE (temp_str,1000,ERR=5000) day, month_names(month), 
     .               year, hour, minute, second
           ELSE
              WRITE (temp_str,1010,ERR=5000) day, month_names(month), 
     .               hour, minute, second
           ENDIF

1000       FORMAT(I2.2,'-',A3,'-',I4.4,' ',2(I2.2,':'),I2.2)
1010	   FORMAT(I2.2,'-',A3,' ',2(I2.2,':'),I2.2)


	ELSEIF ( prec .EQ. 5 ) THEN	! dd-mmm-yyyy hh:mm
	   IF (.NOT. skp_year) THEN
              WRITE (temp_str,1020,ERR=5000) day, month_names(month), 
     .               year, hour, minute
           ELSE
              WRITE (temp_str,1030,ERR=5000) day, month_names(month), 
     .               hour, minute

           ENDIF
1020       FORMAT(I2.2,'-',A3,'-',I4.4,' ',I2.2,':',I2.2)
1030	   FORMAT(I2.2,'-',A3,' ',I2.2,':',I2.2)

	ELSEIF ( prec .EQ. 4 ) THEN	! dd-mmm-yyyy hh
	   IF (.NOT. skp_year) THEN
              WRITE (temp_str,1040,ERR=5000) day, month_names(month), 
     .               year, hour
           ELSE
              WRITE (temp_str,1050,ERR=5000) day, month_names(month), 
     .               hour
           ENDIF
1040       FORMAT(I2.2,'-',A3,'-',I4.4,' ',I2.2)
1050	   FORMAT(I2.2,'-',A3,' ',I2.2)

	ELSEIF ( prec .EQ. 3 ) THEN	! dd-mmm-yyyy
	   IF (.NOT. skp_year) THEN
              WRITE (temp_str,1060,ERR=5000) day, month_names(month), 
     .               year
           ELSE
              WRITE (temp_str,1070,ERR=5000) day, month_names(month)

           ENDIF
1060       FORMAT(I2.2,'-',A3,'-',I4.4)
1070	   FORMAT(I2.2,'-',A3)

	ELSEIF ( prec .EQ. 2 ) THEN	! mmm-yyyy
	   IF (.NOT. skp_year) THEN
              WRITE (temp_str,1080,ERR=5000) month_names(month), year
           ELSE
              WRITE (temp_str,1090,ERR=5000) month_names(month)

           ENDIF
1080       FORMAT(A3,'-',I4.4)
1090	   FORMAT(A3)

	ELSE				! yyyy
	   IF (.NOT. skp_year) THEN
              WRITE (temp_str,1100,ERR=5000) year
           ELSE
              temp_str = ' '

           ENDIF
1100       FORMAT(I4.4)
	ENDIF

* done
        SECS_TO_DATE_OUT = temp_str
	RETURN

* internal error
 5000	STOP 'SECS_TO_DATE'
	END

!
! lanczos.F90
!
! Bill Ivor Gustafson, ivor@ucdavis.edu
! 29-oct-1999
!
! This function bandpass filters the input data in time 
! using a Lanczos filter.  For details see:
!   Duchon, C. E., 1979: Lanczos filtering in one and two dimensions.
!        J. of App. Met., 18, 1016-1022.
!
! lanczos function from Brett McDaniel was in 
! Fortran 90.  Translated to f77 by Ansley Manke, PMEL  6/25/04
!   -change include files
!   -allocate weight array with a lanczos_init function
!   -change cycle and exit statements in loop 100 of 
!    compute function to GOTO's
!
! In this subroutine we provide information about
! the function.  The user configurable information 
! consists of the following:
!
! descr              Text description of the function
!
! num_args           Required number of arguments
!
! axis_inheritance   Type of axis for the result
!                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
!                       CUSTOM          - user defined axis
!                       IMPLIED_BY_ARGS - same axis as the incoming argument
!                       NORMAL          - the result is normal to this axis
!                       ABSTRACT        - an axis which only has index values
!
! piecemeal_ok       For memory optimization:
!                       axes where calculation may be performed piecemeal
!                       ( YES, NO )
! 
!
! For each argument we provide the following information:
!
! name               Text name for an argument
!
! unit               Text units for an argument
!
! desc               Text description of an argument
!
! axis_influence     Are this argument's axes the same as the result grid?
!                       ( YES, NO )
!
! axis_extend       How much does Ferret need to extend arg limits relative to result 
!


      SUBROUTINE lanczos_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

      CALL ef_version_test(ef_version)

! **********************************************************************
!                                            USER CONFIGURABLE PORTION |
!                                                                      |
!                                                                      V

      CALL ef_set_desc(id, 
     .      'Bandpass filters data in time using a Lanczos filter' )

      CALL ef_set_num_args(id, 4)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .      IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      CALL ef_set_num_work_arrays(id, 1)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 
     .      'Data to be filtered in time (may also vary in x,y,z)')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'F1')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg,'Low frequency cutoff')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'F2')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg,'High frequency cutoff')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'N')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg,'Number of weights (must be odd)')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
!                                                                      ^
!                                                                      |
!                                            USER CONFIGURABLE PORTION |
! **********************************************************************

      RETURN 
      END  ! SUBROUTINE lanczos_init

*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE lanczos_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
*
* Set the work array X/Y/Z/T dimensions
*
* ef_set_work_array_lens(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER array_num, arg, nn
      REAL val


      arg = 4
      CALL ef_get_one_val(id, arg, val)  

      nn = val

      array_num = 1

! dimensions for weight array: nn = arg4

      CALL ef_set_work_array_dims(id, array_num,
     .     0, 0, 0, 0, 
     .     nn, 0, 0, 0)


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END ! SUBROUTINE lanczos_work_size



      SUBROUTINE lanczos_compute(id, arg_1, arg_2, arg_3, arg_4, 
     .                           result, weight)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .       mem1loz:mem1hiz, mem1lot:mem1hit),     
     .      arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, 
     .       mem2loz:mem2hiz, mem2lot:mem2hit),     
     .      arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, 
     .       mem3loz:mem3hiz, mem3lot:mem3hit),     
     .      arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, 
     .       mem4loz:mem4hiz, mem4lot:mem4hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .        memresloz:memreshiz, memreslot:memreshit)

      REAL weight(wrk1lox:wrk1hix, wrk1loy:wrk1hiy,
     .               wrk1loz:wrk1hiz, wrk1lot:wrk1hit)
     
! After initialization, the 'res_' arrays contain indexing information 
! for the result axes.  The 'arg_' arrays will contain the indexing 
! information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS), 
     .        arg_incr(4,1:EF_MAX_ARGS)

! **********************************************************************
!                                            USER CONFIGURABLE PORTION |
!                                                                      |
!                                                                      V
      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1
      integer m,nn
      real aa,bb,f1,f2,pi,pik,sigma
      real da

      pi  = acos(-1.)

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

! Get the counter values to cycle through, nw=2*nn+1...
      i = arg_lo_ss(X_AXIS,ARG4)
      j = arg_lo_ss(Y_AXIS,ARG4)
      k = arg_lo_ss(Z_AXIS,ARG4)
      l = arg_lo_ss(T_AXIS,ARG4)
      if( mod(int(arg_4(i,j,k,l)),2) .EQ. 0 ) then
         CALL EF_BAIL_OUT(id,'The number of weights must be odd.')
      else
         nn = ( arg_4(i,j,k,l)-1 )/2
      endif

! Calculate the weights...

      i  = arg_lo_ss(X_AXIS,ARG2)
      j  = arg_lo_ss(Y_AXIS,ARG2)
      k  = arg_lo_ss(Z_AXIS,ARG2)
      l  = arg_lo_ss(T_AXIS,ARG2)
      f1 = arg_2(i,j,k,l)

      i  = arg_lo_ss(X_AXIS,ARG3)
      j  = arg_lo_ss(Y_AXIS,ARG3)
      k  = arg_lo_ss(Z_AXIS,ARG3)
      l  = arg_lo_ss(T_AXIS,ARG3)
      f2 = arg_3(i,j,k,l)

      weight(0,0,0,0)  = 2.*(f2-f1)
      do k = 1,nn
         pik   = pi*k
         aa    = pik/nn
         sigma = sin(aa)/aa
         aa    = 2.*pik*f1
         bb    = 2.*pik*f2
         weight( k,0,0,0) = ( sin(bb)/pik - sin(aa)/pik )*sigma
      end do

c      print*,'Weights for k=0,...,n:'
c      print*,(weight(k,0,0,0), k=0,nn)

! For testing, calculate the response function...
c      da = .0005
c      aa = 0.0
c      do while( aa .LT. .5 )
c         bb = 0.
c         do i = 1,nn
c            bb = bb + weight(i,0,0,0)*cos(2.*pi*aa*float(i))
c         end do
c         bb = weight(0,0,0,0) + 2.*bb
c         write(11,*) aa,bb
c         aa = aa+da
c      end do

      if( res_hi_ss(T_AXIS) - res_lo_ss(T_AXIS) .LT. 2*nn ) then
         CALL EF_BAIL_OUT(id, 
     .     'Too many weights exist for the number of times present.')
      endif

! Apply the weights to the data...
! NOTE:  The array indexes are setup inefficiently, but that's 
!        how the Ferret folks set it up.
      i1 = arg_lo_ss(X_AXIS,ARG1)
      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

             do l=res_lo_ss(T_AXIS),res_lo_ss(T_AXIS)+nn-1
                result(i,j,k,l) = bad_flag_result
             end do
             do l=res_hi_ss(T_AXIS)-nn+1,res_hi_ss(T_AXIS)
                result(i,j,k,l) = bad_flag_result
             end do

             DO 100 l=res_lo_ss(T_AXIS)+nn, res_hi_ss(T_AXIS)-nn
                if( arg_1(i1,j1,k1,l) .EQ. bad_flag(1) ) then
                   result(i,j,k,l) = bad_flag_result
                   GOTO 100
                end if
                result(i,j,k,l) = weight(0,0,0,0)*arg_1(i1,j1,k1,l)

                do m = 1,nn
                   if( arg_1(i1,j1,k1,l-m) .EQ. bad_flag(1) 
     .                   .or. arg_1(i1,j1,k1,l+m) .EQ. bad_flag(1))then
                       result(i,j,k,l) = bad_flag_result
                    GOTO 110
                   end if
                   result(i,j,k,l) = result(i,j,k,l) + weight(m,0,0,0)* 
     .                   ( arg_1(i1,j1,k1,l-m) + arg_1(i1,j1,k1,l+m) )
                end do
110             continue

100          end do

             k1 = k1 + arg_incr(Z_AXIS,ARG1)
200        end do

           j1 = j1 + arg_incr(Y_AXIS,ARG1)
300      end do

         i1 = i1 + arg_incr(X_AXIS,ARG1)
400   end do
     
!                                                                      ^
!                                                                      |
!                                            USER CONFIGURABLE PORTION |
! **********************************************************************

      RETURN 
      END ! SUBROUTINE lanczos_compute

      SUBROUTINE LINE(X,Y,IMARK,NAPTS)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)line.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     CALL LINE(X,Y,IMARK,NPTS)
C
C     THIS SUBROUTINE PLOTS A SERIES OF POINTS USING DATA SUP-
C     PLIED IN ARRAYS.  THE CURRENT PLOTTING MODE IS USED TO
C     DETERMINE THE MANNER IN WHICH THE POINTS ARE CONNECTED.
C
C     THE VARIOUS PARAMETERS AND THEIR DEFINITIONS ARE LISTED
C     BELOW:
C        X,Y    - ARRAYS CONTAINING THE COORDINATES OF THE
C                 POINTS TO BE PLOTTED IN USER'S UNITS.
C        IMARK  - DATA MARK CODE (0-88).
C        NPTS   - NUMBER OF POINTS TO BE PLOTTED.
C
C
      DIMENSION X(1),Y(1)
C
      IF(NAPTS .EQ. 0)RETURN
      NPTS = IABS(NAPTS)
C
C     MOVE TO THE FIRST POINT WITH THE PEN UP.
C
      CALL PLOT(X(1),Y(1),0,0)
      CALL MARK(IMARK)
      IF(NPTS .EQ. 1)RETURN
C
C     MOVE TO THE REST OF THE POINTS WITH THE PEN DOWN.
C
      DO 10 I=2,NPTS
   10 CALL PLOT(X(I),Y(I),1,IMARK)
      RETURN
C
      END

	SUBROUTINE HUNT_R4 (x1,lo_dim,hi_dim,x2,ndx_lo, frac)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Routine to determine nearest neighbor index (lower index)
*	on GRID1 for points on GRID2.

*	Taken from Numerical Recipes, Chapter 3, Section "Search With
*	Correlated Values"

* V450:  7/97 - new, cloned from double prec. version hunt.F
*             - also return "frac" - the interpolation factor for ndx_lo 
* V690 *sh* 11/13 - ensure that if exact match, the frac=1.0 case is always used

	integer		lo_dim,hi_dim,ndx_lo,ndx_mid,ndx_hi,inc

	real		x1(lo_dim:hi_dim),x2, frac

	logical		ascnd

********************************************************************************

*	TRUE IF ASCENDING GRID COORDINATES, FALSE OTHERWISE
	ascnd = x1(hi_dim) .gt. x1(lo_dim)
	
*	IF INITIAL GUESS IS NO GOOD, GO IMMEDIATELY TO BISECTION
	if (ndx_lo .lt. lo_dim .or. ndx_lo .gt. hi_dim) then
	   ndx_lo = lo_dim - 1
	   ndx_hi = hi_dim + 1
	   goto 3
	end if

	inc = 1

*	QUICKLY GET A GOOD ESTIMATE FOR LOCATION IN GRID1
	if (x2 .ge. x1(ndx_lo) .eqv. ascnd) then
*	   HUNT UP FOR PLACEMENT IN GRID
1	   ndx_hi = ndx_lo + inc
	   
	   if (ndx_hi .gt. hi_dim) then 
*	      HUNT OVER -- OFF HIGH END OF GRID
	      ndx_hi = hi_dim + 1
	   else if (x2 .gt. x1(ndx_hi) .eqv. ascnd) then
	      ndx_lo = ndx_hi
	      inc    = inc + inc
	      goto 1
	   end if
	else
*	   HUNT DOWN FOR PLACEMENT
	   ndx_hi = ndx_lo
2	   ndx_lo = ndx_hi - inc

	   if (ndx_lo .lt. lo_dim) then
*	      FALL OFF LOW END OF GRID -- HUNT IS OVER
	      ndx_lo = lo_dim - 1
	   else if (x2 .lt. x1(ndx_lo) .eqv. ascnd) then
	      ndx_hi = ndx_lo
	      inc = inc + inc
	      goto 2
	   end if	
	end if

*	USE BISECTION TO DETERMINE EXACT LOCATION IN GRID
3	IF (ndx_hi - ndx_lo .eq. 1) THEN

* return result -- including interpolation fraction

	   IF (ndx_lo.GE.lo_dim .AND. ndx_lo.LT.hi_dim) THEN
	      IF (x2 .EQ. x1(ndx_lo)) THEN
	         frac = 1.0
	      ELSEIF (x2 .EQ. x1(ndx_hi)) THEN
	         ndx_lo = ndx_hi		! 11/13 addition
	         frac = 1.0
	      ELSE
	         frac = (x1(ndx_hi)-x2) / (x1(ndx_hi)-x1(ndx_lo))
	      ENDIF
	   ELSE    
	      frac = -999.0
	   ENDIF
	   return
	ENDIF

	ndx_mid = (ndx_hi + ndx_lo)/2
	if (x2 .gt. x1(ndx_mid) .eqv. ascnd) then
	   ndx_lo = ndx_mid
	else
	   ndx_hi = ndx_mid
	end if

	goto 3


	end

      SUBROUTINE ABMV_makedot
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)abmv.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C     Mod *JD* 4.5.91 to include PLTDAT.DAT in unix/vms system dependent way
*  
*  8/2001  acm  for PLOT/SYMBOL=DOT
*  Version of ABMV to be called by make_dot.  Call GPM for polymarker
*  rather than GPL (polyline) 

C     CALL ABMV
C
C     ALL PLOTTING EVENTUALLY MUST BE ACCOMPLISHED BY MOVING THE
C     PEN FROM ONE LOCATION TO ANOTHER.  ABMV PERFORMS THIS FUNC-
C     TION BY CALLING THE DRIVER ROUTINES FOR THE VARIOUS PLOTTING
C     DEVICES.  THESE SUBROUTINES ARE LISTED BELOW:
C        TABMV  - TEKTRONIX GRAPHICS TERMINAL
C        PRABMV - PRINTRONIX PRINTER PLOTTER
C        ZABMV  - ZETA PLOTTER
C        BABMV  - BENSON PLOTTER
C	 GKSMV_makedot  - GKS DRIVER calling polymarker
C
C
C *kob* 9/98 - use external statemen to initialize block data rather than an
C              included .DAT file.  the latter was causing mutliple 
C              references 

#ifdef unix
      include 'PLTCOM.DAT'
      external pltdat_block_data
#else
      include 'pplv11inc:PLTCOM.DAT'
      include 'pplv11inc:PLTDAT_VMS.DAT'
#endif
C

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C
C     CHECK THE PLOT TYPE.
C
      GO TO(10,40,30,10,10,20,20),PTYPE + 3
C
C     PLOT ON THE TEKTERMINAL.
C
   10 CALL TABMV
	GOTO 25
20	CALL GKSMV_makedot
C
C     CHECK FOR OTHER PLOTTING DEVICES.
C
25      GOTO(40,50,50,50,30,50,30),PTYPE +3
C
C     PLOT ON THE PRINTRONIX PRINTER PLOTTER.
C
C
C     PLOT ON THE ZETA PLOTTER.
C
   30 CALL ZABMV
	GOTO 50
C
C	PLOT ON THE HP7475 PLOTTER
C
C
40	CALL HPABMV
   50 LPEN = PEN
      RETURN
C
      END

	SUBROUTINE IS_GATHER(  *, *, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* bring together a full data grid from fragmentary pieces by requesting those
* pieces one by one on the interpretation stack

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  6/8/89
* V312: 5/94 - array "memory" as a calling argument
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include	'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'

* calling argument declarations:
	INTEGER	status
* normal return is for error conditions
* exit #1 is to request another grid ( stack has been pushed )
* exit #2 is to signal completion of the activity at this stack level

*   ... interpretation stack setup at the time this is called ...
*	stack level		stack contents
*	isp+1	<--	level of last activity ( component just computed )
*	 isp	<--	current stack level (for gathering )

* internal variable declarations:
	INTEGER com_mr, res_mr, com_cx, res_cx,	dflt_cx, com_isp, res_isp,
     .		frag, idim, top


* --- end of introductory code ---

* initialize
	res_isp    = isp
	com_isp    = isp + 1
	res_mr     = is_mr( res_isp )
	com_mr     = is_mr( com_isp )
	res_cx     = is_cx( res_isp )
	com_cx     = is_cx( com_isp )
	dflt_cx	   = is_big_cx( res_isp )
	idim       = is_axis( res_isp )
	frag	   = is_sum ( res_isp )

* diagnostic mode output: " doing gather VAR_NAME[x=lo:hi@TRN:n,D=#]"
	IF ( mode_diagnostic ) 	CALL DIAG_OP
     .				( 'doing',isact_class_gather, com_cx, idim )

* create context and mem. res. space if this is the first component recieved
	IF ( res_mr .EQ. unspecified_int4 ) THEN
* ... use gathering axis from dflt_cx and everything else from component
* ... (since all else may be altered during evaluation if its a user var)
	   CALL TRANSFER_CONTEXT( com_cx, res_cx )
	   CALL TRANSFER_AXIS( idim, dflt_cx, res_cx )
	   CALL CREATE_MEM_VAR( res_cx, res_mr, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   is_mr( res_isp ) = res_mr
	ENDIF

* copy data just received into the result
	CALL COPY_INTO( memry(com_mr)%ptr, com_mr, com_cx,
     .			memry(res_mr)%ptr, res_mr )

* ... remove the component protection that signaled we needed it here
	CALL MR_NOT_IN_USE( com_mr )

* are we done ?
	IF ( cx_hi_ss(com_cx,idim) .EQ. cx_hi_ss(dflt_cx,idim) ) THEN
* ... yes - pop com_cx and dflt_cx from context stack
	   IF ( dflt_cx .NE. cx_stack_ptr ) STOP 'GATH_STK_ERR'	! temp
	   cx_stack_ptr = cx_stack_ptr - 2
	   RETURN 2
	ENDIF

* no - set up com_cx to get the next component grid
	CALL DEFINE_NEXT_CHUNK_CX(idim, com_cx, dflt_cx, frag, status)
	IF ( status .NE. ferr_ok ) GOTO 5000

* push the interpretation stack and go get it
	isp = com_isp
	status = ferr_ok
	RETURN 1

* error exit
 5000	RETURN
	END	

	SUBROUTINE PERMUTE( src_cx, src, msrc, dst, mdst, perm )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* permute the 4D data from the source grid into the destination grid
* - 24 possible permutations  (!4)  

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  8/31/89
*	10/16/89 - modified array declarations using *_SUB call
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'

* calling argument declarations:
	INTEGER src_cx, msrc, mdst, perm(nferdims)
	REAL    src( * ),dst( * )

* local variable declarations:
	INTEGER  MGRID_SIZE

	IF ( mr_type(msrc) .EQ. ptype_string ) THEN

* ... set up the C pointer variable in the destination variable
           CALL INIT_C_STRING_ARRAY( MGRID_SIZE(mdst),
     .                               dst,
     .                               mr_c_pointer(mdst)      )

	   CALL PERMUTE_PTR_SUB (    src_cx, perm,
     .			    src, mr_lo_s1(msrc), mr_hi_s1(msrc),
     .				 mr_lo_s2(msrc), mr_hi_s2(msrc),
     .				 mr_lo_s3(msrc), mr_hi_s3(msrc),
     .				 mr_lo_s4(msrc), mr_hi_s4(msrc),
     .				 mr_lo_s5(msrc), mr_hi_s5(msrc),
     .				 mr_lo_s6(msrc), mr_hi_s6(msrc),
     .			    dst, mr_lo_s1(mdst), mr_hi_s1(mdst),
     .				 mr_lo_s2(mdst), mr_hi_s2(mdst),
     .				 mr_lo_s3(mdst), mr_hi_s3(mdst),
     .				 mr_lo_s4(mdst), mr_hi_s4(mdst),
     .				 mr_lo_s5(mdst), mr_hi_s5(mdst),
     .				 mr_lo_s6(mdst), mr_hi_s6(mdst) )

	ELSE	
	   CALL PERMUTE_SUB (    src_cx, perm,
     .			    src, mr_lo_s1(msrc), mr_hi_s1(msrc),
     .				 mr_lo_s2(msrc), mr_hi_s2(msrc),
     .				 mr_lo_s3(msrc), mr_hi_s3(msrc),
     .				 mr_lo_s4(msrc), mr_hi_s4(msrc),
     .				 mr_lo_s5(msrc), mr_hi_s5(msrc),
     .				 mr_lo_s6(msrc), mr_hi_s6(msrc),
     .			    dst, mr_lo_s1(mdst), mr_hi_s1(mdst),
     .				 mr_lo_s2(mdst), mr_hi_s2(mdst),
     .				 mr_lo_s3(mdst), mr_hi_s3(mdst),
     .				 mr_lo_s4(mdst), mr_hi_s4(mdst),
     .				 mr_lo_s5(mdst), mr_hi_s5(mdst),
     .				 mr_lo_s6(mdst), mr_hi_s6(mdst)  )
	ENDIF

 5000	RETURN
	END 

	SUBROUTINE SHADE_SUB (data,xc,yc,xs,ys, cells)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
*       lots of places ---> PPLMOD_PPLCMD ---> PPLMOD_PLTIT
*               ---> PPLADD_SHADE ---> PPLADD_SHADE_SUB()
*
*	Uses GKS calls to display an image using fill area, with
*	a range of colors if available on the workstation, or grey scale 
*	(or other available) patterns if not.  FORTRAN binding is used.

*	J Davison JISAO/PMEL/TMAP 6.15.88

*	Modified to fit into PPL as the SHADE command routine
*	J Davison 8.12.88

*	*sh*  1/23/89 - added interrupt detection
*	*jd*  3.15.89 - modified to provide for metafile output and also
*			to support more workstations
*	*jd*  7.17.89 - to fix transform error
*	*jd*  8.28.89 - to certify clipping on for shade
*	*jd* 12.13.89 - to fill edge cells completely -- clipping prevents
*			fill area overflowing plot axes
*	*jd*   1.2.90 -	get box boundaries from Ferret if in Ferret; can have
*			irregular grids there
*	*jd*  5.16.90 - to speed up the shade execution, wait while repeated
*			cells of same color are added to list to fill.  Also
*			extracted part of code into 2 subroutines to clean up.
*       *jd*  4.11.91 - calls to write shd_levels & shade settings to metafile
*                       as private items and NOT set color rep or fill area
*                       rep explicitly in the metafile
*	*jd*  4.2.92  - Includes decision to NOT use area bundles if more
*			than 20 in ATC GKS
*	*jd*  7.31.92 - Mod to allow shading of single level fields
*	*jd*  10.1.92 - Accommodate protection of used colors
*	*jd*  10.12.92- Handle lack of sufficient fill area indices in ATC
*			GKS when using hatching. -- cancel this 10.22.92 
*	*jd*  10.26.930 Eliminate meta_shade_set but don't replace with
*				code to retain function, yet
*	*jd*  01.27.94  Fix bug in assigning shd_levels -- always >= 1
*	*sh*  03.07.97  Allow external transformation to curvilinear coords
*	*sh*  25.11.97  changed calling args of GET_NDX by eliminating "i,j"
*			and by returning -999 for no index found
*       *acm* 11/02     V5.50 For rectangular shade plots with no pattern
*                       calls, use cellarray call for the shade.
*       *acm*  1/03     v5.50 Remove debug line that stopped Ferret for large
*                             cellarray plots (!)
*       *acm* 1/27/03   Bug fix in cellarray plots, which had not taken the
*                       possible /HLIMITS and /VLIMITS into account.
* v5.51*acm*  1/30/03  Comment out the cellarray implementation; xgks doesnt
*                      completely implement it & has a precision bug for 
*                      large plots.  see comment lines: c no_cellarray
* V5.54 *acm* 2/11/04  For cellarray plots, if the data is all missing or
*                      outside the range of the axes that have been plotted,
*                      do not make the cellarray call.
*  V5.54 *acm* 2/11/04 For cellarray plots, make sure the edges of the rectangle 
*                      of data corresponds to the correct part of the box drawn
*                      by the axes. (/hlim or /vlim plots)
* V5.61 *acm* 4/16/04  For cellarray plots, fix treatment of half-cells around
*                      the edges of the plot.  
* V5.81 *acm* 3/05     For curvilinear plots, do a partial solution for the question
*                      of modulo longitude axes: Determine the index range needed
*                      to plot the requested /HLIM/VLIM range. New routine SHADE_FILL_IT
*                      uses only that range, checks to see if a branch point has been 
*                      crossed, and makes the plot call.  For curvilinear plots, do not 
*                      gather up whole groups of cells of the same color but do each 
*                      separately, checking for the branch cut.  Make more calls to 
*                      SHADE_FILL_IT as needed to fill the longitude range.
C V602 *acm* 2/07 check status coming out of CURV_COORD_RANGE; part of fix to bug 1485
* V603 *acm* 5/07 Fix part 1 of bug 1302; if xmodulo is true, then set dim1_modulo true.
* V6.8 *acm* 7/9/2012 For batch graphics on RHEL6, change ITS_BATCH_GRAPHICS
*                     from logical to integer, then batch = ITS_BATCH_GRAPHICS().NE.0
* V701 *acm* 7/17 ticket 2451: cellarray plots with axis direction reversed by /VLIM or /HLIM

	INCLUDE		'parampl5_dat.decl'
	INCLUDE		'PARAMPL5.DAT'
        INCLUDE         'shade_vars.cmn'
	INCLUDE		'axis_inc.decl'
	INCLUDE		'AXIS.INC'
	INCLUDE		'miss_inc.decl'
	INCLUDE		'MISS.INC'
        INCLUDE         'hd_inc.decl'
        INCLUDE         'HD.INC'
	INCLUDE		'cont_inc.decl'
	INCLUDE		'CONT.INC'
	INCLUDE		'gkscm1_inc.decl'
	INCLUDE		'GKSCM1.INC'
	INCLUDE		'gkscm2.cmn'
        INCLUDE         'pen_inc.decl'
        INCLUDE         'PEN.INC'
	INCLUDE         'gkspar.inc'
	INCLUDE 	'xinterrupt.cmn'	! 1/89 *sh*
	INCLUDE 	'ppl_in_ferret.cmn'
        INCLUDE         'switch_inc.decl'
        INCLUDE         'SWITCH.INC'
        INCLUDE         'xcurvilinear.cmn'
        INCLUDE         'errmsg.parm'

	INTEGER		error,i,j,trans_no,cflag

        INTEGER         my_trans,fill_ndx,GET_NDX
        DATA            my_trans/20/

C       data statement of my_trans added for linux port *jd* 12.96

	REAL		data(nx,ny),xc(nx),yc(ny),xs(nx+1),ys(ny+1)
	REAL	 	w(4),v(4),ndc(4),uc(4)
	REAL		xinv,yinv, cx1, cx2, cy1, cy2, half

	logical		valid

        INTEGER		cells(*), pmax
        INTEGER         j1, jn, jd
	INTEGER		ITS_BATCH_GRAPHICS
	LOGICAL		REGULARLY_SPACED,
     .                  batch, irregular, plot_cell, do_cell

* declarations for curvilinear coordinates
	LOGICAL		ITS_CURVILINEAR, ITS_CURV_EDGES
	INTEGER		status
	INTEGER		maxpts, maxpt_ov2, nright, nleft, 
     .                  ilo, ihi, jlo, jhi
	PARAMETER     ( maxpts = 200,
     .			maxpt_ov2 = maxpts / 2 )
	REAL		px(maxpts), py(maxpts), xadd, lmin, lmax

*	PARAMETER	(my_trans = 10)
	EXTERNAL	GET_NDX

*	MY_TRANS is the normalization transformation used in laying down the
*	area fill overlay.

******************************************************************************

*       *sh* (3/97) are we doing a curvilinear plot?
	IF (ppl_in_ferret) THEN
	   curvilinear = ITS_CURVILINEAR()
	ELSE
	   curvilinear = .FALSE.
	ENDIF

*	*jd* mod to allow shading single level fields 
	IF (nlev2 .LT. 1) GOTO 1000
	shd_levels = MAX (nlev2 - 1,1)

* are we in no-X mode?
	batch = ITS_BATCH_GRAPHICS() .NE. 0

*	DETERMINE PATTERNS OR COLORS TO SET BUNDLED FILL AREA REPRESENTATIONS
	CALL set_fill_area_rep (wsid,wstype)

        IF (meta_actv .AND. .NOT. meta_clsplt) 
     .     CALL set_fill_area_rep (meta_wsid,meta_wstype)

*	GET PROPER SCALING, NDC COORDINATES, ETC FOR FILL
	CALL gqcntn (error,trans_no)
	IF (error .NE. 0) GOTO 1000

	CALL gqnt (trans_no,error,w,v)
	IF (error .NE. 0) GOTO 1000

	CALL get_user_coords (w,v,ndc,uc,xinv,yinv)

*	NOW SET THE CLIPPING RECTANGLE AROUND THEM AND PATTERN SIZE

	CALL gswn (my_trans,uc(1)*xinv,uc(2)*xinv,uc(3)*yinv,uc(4)*yinv)
	CALL gsvp (my_trans,ndc(1),ndc(2),ndc(3),ndc(4))
	CALL gselnt (my_trans)

	CALL gqclip (error,cflag,ndc)
	IF (error .NE. 0) GOTO 1000
	IF (cflag .NE. gclip) CALL gsclip (gclip)

*	SET UP COORDINATES FOR CENTER OF EACH GRID BOX

        irregular = .FALSE.

**** X coordinates ***
	IF (ppl_in_ferret) THEN			!	JD 1.2.90	

* "curvilinear" indicates a 3-argument SHADE command: "SHADE vals, xpos, ypos"
	   IF ( curvilinear ) THEN
              irregular = .FALSE.
* ... Indices have been passed to this routine instead of coordinates
*     The coordinates are inside Ferret - gotten through CURV_COORDS below 
	      IF ( ITS_CURV_EDGES(1) ) THEN
* ... User gave Ferret edge points as coords -- set indices to point to them
* 	e.g. 1, 2, 3, ..., N+1
	         DO 11 i = 1, nx
 11	         xs(i) = xc(i)
	         xs(nx+1) = xs(nx) + 1
	      ELSE
* ... User gave Ferret grid points as coords -- set indices to index midpoints
* 	e.g. 0.5, 1.5, ...,N+.5
	         xs(1) = (xc(1) - (xc(2) - xc(1))/2.0)
	         DO 12 i = 1,nx-1
	            xs(i+1) = (xc(i) + (xc(i+1) - xc(i))/2.0)
12	         CONTINUE
	         xs(nx+1) = (xc(nx) + (xc(nx) - xc(nx-1))/2.0)
	      ENDIF

* normal rectangular grid (non-curvilinear)
	   ELSE
	      CALL box_bounds ('X',xc(1),nx,xs,valid)
	      IF (.NOT. valid) THEN
	         interrupted = .true.
	         GOTO 3333
	      ENDIF
	   ENDIF
	   DO 20 i = 1,nx+1
	      xs(i) = xs(i)*xinv
20	   CONTINUE
	ELSE
	   xs(1) = (xc(1) - (xc(2) - xc(1))/2.0)*xinv
	   DO 30 i = 1,nx-1
	      xs(i+1) = (xc(i) + (xc(i+1) - xc(i))/2.0)*xinv
30	   CONTINUE
	   xs(nx+1) = (xc(nx) + (xc(nx) - xc(nx-1))/2.0)*xinv
	ENDIF

        IF (.NOT.curvilinear .AND. .NOT.irregular) 
     .      irregular = .NOT. REGULARLY_SPACED(xc, nx)

**** Y coordinates *** (see doc of logic in X coordinates)
	IF (ppl_in_ferret) THEN			!	JD 1.2.90
	   IF ( curvilinear ) THEN
	      IF ( ITS_CURV_EDGES(2) ) THEN
	         DO 21 i = 1, ny
 21	         ys(i) = yc(i)
	         ys(ny+1) = ys(ny) + 1
	      ELSE
	         ys(1) = (yc(1) - (yc(2) - yc(1))/2.0)
	         DO 22 i = 1,ny-1
	            ys(i+1) = (yc(i) + (yc(i+1) - yc(i))/2.0)
22	         CONTINUE
	         ys(ny+1) = (yc(ny) + (yc(ny) - yc(ny-1))/2.0)
	      ENDIF
	   ELSE
	      CALL box_bounds ('Y',yc(1),ny,ys,valid)
	      IF (.NOT. valid) THEN
	         interrupted = .true.
	         GOTO 3333
	      ENDIF
	      DO 31 j = 1,ny+1
	         ys(j) = ys(j)*yinv
31	      CONTINUE
	   ENDIF
	ELSE
	   ys(1) = (yc(1) - (yc(2) - yc(1))/2.0)*yinv
	   DO 35 j = 1,ny-1
	      ys(j+1) = (yc(j) + (yc(j+1) - yc(j))/2.0)*yinv
35	   CONTINUE
	   ys(ny+1) = (yc(ny) + (yc(ny) - yc(ny-1))/2.0)*yinv
*								END 12.13.89
	ENDIF
        IF (.NOT.curvilinear .AND. .NOT.irregular) 
     .      irregular = .NOT. REGULARLY_SPACED(yc, ny)


*       WRITE OUT SHD_LEVELS & SHADE SETTINGS TO METAFILE (4.91)
#ifndef xgks
        IF (meta_actv) CALL meta_shade_set
#endif
c
c* For cellarray shade plots:
c
c*       For version 5.52 cellarray called only for gif batch mode.
c*       cellarray call is for rectangular, evenly spaced grids,
c*       to be filled with solid colors. Use previously-implemented 
c*       calls tha use fillarea when there is meta or ps output.
c*       use_cell is determined in disp_set_up, called on the Ferret 
c*       side from xeq_shade.

* See ticket 2039:  When the cellarray plot is one of several in viewports,
* the colors in the cellarray image are off by one. Have not found the cause. 
* Work around it by refusing to make a cellarray call except for the first 
* color map, either the first plot on the page, or if a PPL SHASET RESET has 
* been issued.

* For ticket 2451: When the axes are reversed, the cellarray call draws nothing.
* Also refuse to make the call in this case.

      do_cell = use_cell .AND. (lo_color_ndx(wsid).EQ.num_line_colors+1) .AND. 
     .    xinv.EQ.1 .AND. yinv.EQ.1

      IF (do_cell) THEN
      
* Collect color indices in cellarray cells array.
* Set the data rectangle to represent whole grid cells.

        half = (xc(2) - xc(1)) / 2.
        cx1 = (uc(1) - half)* xinv   
        cx2 = (uc(2) + half)* xinv   

        half = (yc(2) - yc(1)) / 2.
        cy1 = (uc(3) - half)* yinv
        cy2 = (uc(4) + half)* yinv

* Get the number of grid cells to be plotted 

        mx = 0
        my = 0

        plot_cell = .TRUE.
        DO 60 i = 1, nx
           IF (xc(i) .GE. cx1 .AND. xc(i) .LE. cx2) mx = mx + 1
  60    CONTINUE
        DO 65 j = 1, ny
           IF (yc(j) .GE. cy1 .AND. yc(j) .LE. cy2) my = my + 1
  65    CONTINUE

* none of the data is in the range of the axes we are plotting; 
* dont make the cellarray call.

        IF ( (mx .EQ. 0) .OR. (my .EQ. 0) ) plot_cell = .FALSE.

* load the color array

        k = 0
        pmax = 0
        j1 = ny
        jn = 1
        jd = -1

        IF (yinv .LT. 0) THEN
           j1 = 1
           jn = ny
           jd = 1
        ENDIF

        DO 80 j = j1,jn,jd
	   DO 70 i = 1,nx

           IF ( interrupted ) GOTO 3333			! 1/89 - *sh*

           IF (xc(i) .GT. cx1 .AND. xc(i) .LE. cx2  .AND.
     .         yc(j) .GT. cy1 .AND. yc(j) .LE. cy2 ) THEN

              fill_ndx  = GET_NDX (data(i,j),fill_ndx)
              k = k + 1
 
              IF (fill_ndx .NE. -999) THEN
                 cells(k) = fill_ndx + lo_color_ndx(wsid)-2
                 pmax = max (cells(k), pmax)

              ELSE
                 cells(k) = 0
              ENDIF

           ENDIF

70         CONTINUE
80      CONTINUE

c If all the data is missing don't make the cellarray call

        IF (pmax .EQ. 0) plot_cell = .FALSE.

*  Render the field using the cellarray primitive call.  

         IF (plot_cell) THEN
            DO 90 i = 0, pmax
               CALL gsfaci (i)
90          CONTINUE

* If the data rectangle doesnt take up the whole plot box, reset
* the world coordinates of the corners to match the data rectangle.

            half = (xc(2) - xc(1)) / 2.
            IF (cx1 .LT. xc(1) - half ) cx1 = xc(1)  - half
            IF (cx2 .GT. xc(nx) + half) cx2 = xc(nx) + half

            half = (yc(2) - yc(1)) / 2.
            IF (cy1 .LT. yc(1) - half ) cy1 = yc(1)  - half
            IF (cy2 .GT. yc(ny) + half) cy2 = yc(ny) + half
            IF (yinv .LT. 0) THEN
               half = -1*cy1  ! temp. storage to switch values
               cy1 = -1*cy2
               cy2 = half
            ENDIF
            CALL gca (cx1, cy1, cx2, cy2, mx,my, 1,1, mx,my, cells)
         ENDIF

      ELSE  ! non-cellarray:

* SHADE plot, when either a pattern is used or 
* we have curvilinear coordinates

*	LAY FILL DOWN ON SCREEN IN PROPER PLACE

* Get range of indices for the curvi X,Y coordinates actually needed for the 
* hlimits, vlimits that were requested.

        IF (curvilinear) THEN
           CALL CURV_COORD_RANGE (uc, ilo, ihi, jlo, jhi, status )
           IF (status .NE. ferr_ok) GOTO 1000
           IF (xmodulo) dim1_modulo = .TRUE.
        ENDIF

        xadd = 0.
        CALL SHADE_FILL_IT (data, nx, ny, px, py, xs, ys, xinv, yinv, 
     .                   xadd, lmin, lmax, ilo, ihi, jlo, jhi, 
     .                   maxpt_ov2, status)
        IF (status .EQ. ferr_interrupt) GOTO 3333

*	MODULO REPLICATIONS TO FILL OUT uc(1) TO uc(2)

        IF (xmodulo .AND. curvilinear) THEN
           xrange = 360
           IF (.NOT. units_degrees) xrange = wwxmax - wwxmin
           nleft = 0
           nright = 0
           IF (lmin .GT. uc(1) ) nleft =  1 + INT(lmin - uc(1) )/ xrange
           IF (lmax .LT. uc(2) ) nright = 1 + INT(uc(2) - lmax )/ xrange

           IF (nleft .GT. 0) THEN
              xadd = 0.
              DO 100 i = 1, nleft
                 xadd = xadd - xrange
                 CALL SHADE_FILL_IT (data, nx, ny, px, py, xs, ys,
     .                         xinv, yinv,  xadd, lmin, lmax, ilo, 
     .                         ihi, jlo, jhi, maxpt_ov2, status)
                 IF (status .EQ. ferr_interrupt) GOTO 3333
 100          CONTINUE
           ENDIF

           IF (nright .GT. 0) THEN
              xadd = 0.
              DO 110 i = 1, nright
                 xadd = xadd + xrange
                 CALL SHADE_FILL_IT (data, nx, ny, px, py, xs, ys,
     .                         xinv, yinv,  xadd, lmin, lmax, ilo, 
     .                         ihi, jlo, jhi, maxpt_ov2, status)
                 IF (status .EQ. ferr_interrupt) GOTO 3333
 110          CONTINUE
           ENDIF


        ENDIF   ! xmodulo

      ENDIF	! use_cell

 3333	CONTINUE					! 1/89 - *sh*
* post-interrupt re-entry				! 1/89 - *sh*

*	BACK TO PREVIOUS CLIPPING
	CALL gsclip (cflag)

*	BACK TO OLD TRANSFORM
	CALL gselnt (trans_no)

*	DO THE KEY
	IF (do_key .AND. .NOT.interrupted) CALL key	! 1/89 - *sh*
        CALL shade_key_cont(0)

	RETURN
*	Fatal error
1000	RETURN
	END

	SUBROUTINE SYS_LS( cmnd_text, sysout_ptr, nlines, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 


* Execute an "ls -1" shell command and return the resulting strings

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V695+:  5/15 *sh*  - based upon store_sys_strings.F

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include	'xrisc.cmn'

* calling argument declarations:
	INTEGER	nlines, status
	REAL*8	 sysout_ptr
	CHARACTER*(*) cmnd_text, ls_out

* internal variable declarations:
	INTEGER	istat

	CALL WARN('Unix ls NEEDS SECURITY CHECKS')

* create the ls command as a null-terminated C string
	CALL TM_FTOC_STRNG ('ls -1 '//cmnd_text,
     .			    risc_buff, size_rbuff )

* execute the shell command
	CALL GET_SYS_CMND(sysout_ptr, nlines, risc_buff, istat)
	IF (istat .NE. 0) THEN
	   CALL ERRMSG(ferr_insuff_memory, status,
     .			'dynamic memory for string', *5000)
	ELSE
	   status = ferr_ok
	ENDIF


* transfer the strings into this mr (and free the pointer)
XXX	CALL XFER_C_PTRS(sysout_ptr,0,0,mr_c_pointer(mr),1,pos-1,nlines)
	

* success
	status = ferr_ok

 5000	RETURN
	END	

	SUBROUTINE GET_DEPENDENCIES( uvar, dset, work, status )
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* this routine is derived from GET_UVAR_GRID
* see that routine for a discussion of how it is implemented
* instead of evaluating the grid of a uvar, this routine traces through the
* same path and reports out the dependencies

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V685+ 9/13 *sh*  
* V692 10/14 *acm* Ticket 2204: initialize the new context before
*                  putting info init

        include 'tmap_errors.parm'
        include 'tmap_dims.parm'
        include 'xtm_grid.cmn_text'
        external xgt_grid_data

	include	'ferret.parm'
	include	'interp_stack.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xdependency_tree.cmn'

* calling argument declarations:
	INTEGER	uvar, dset, status
	INTEGER	work(dependency_max_recs, dependency_nfields)

* internal variable declarations:
	INTEGER	isp_orig, cx_orig, cx, idim

* pre-load the variable info onto the CX stack
	cx_orig = cx_stack_ptr
	CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	cx = cx_stack_ptr
* Make the new context empty 
	CALL INIT_EMPTY_CONTEXT ( cx )
	cx_data_set(cx) = dset
	cx_variable(cx) = uvar
	cx_category(cx) = cat_user_var

* pre-load the variable info onto the IS stack
	isp_orig = isp
	CALL PUSH_INTERP_STACK( isp, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	is_cx   ( isp ) = cx
	is_uvar ( isp ) = uvar
	is_act  ( isp ) = isact_algebra	! temp diagnostic

* initialize the stacks - (repeated for each component)
 100	is_phase( isp ) = 0
	is_sum  ( isp ) = 0   ! flag to change after getting aux vars
	IF ( status .NE. ferr_ok ) GOTO 5000

* evaluate the dependencies through recursive descent
*  ... exit 100 is to evaluate the dependencies for a component uvar
*  ... exit 300 means that a variable in need of reporting has been obtained
*  ... "normal" return indicates an error has occurred
* calling this starts a new dependency tree -- create a forward link from last
 200	CALL IS_DEPENDENCIES( *100, *300, work, status )
	GOTO 5000
 
* a uvar has just been reported.  Are we done ?
 300	IF ( isp .EQ. isp_orig ) THEN
* ... yes - clean up and go home
	   IF (status .NE. ferr_ok) GOTO 5000
	   IF ( cx_stack_ptr .NE. cx_orig ) WRITE (6,*) 'cx_stk_lev_crptn'
	   RETURN
	ELSE
* ... no - go back for more
	   GOTO 200
	ENDIF

* error exit
 5000	IF ( status .EQ. ferr_stack_ovfl )
     .		CALL WARN( 'Check for recursion in variable definitions' )
	RETURN
	END

	SUBROUTINE CD_RD_R8_1(cdfid,varid,index,dtype,errstr,dval,status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* read a single value from a netCDF variable and return it as a double prec.
* The variable must be a simple array (e.g. an axis)

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 2/92
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* argument definitions:
*	cdfid	 - netCDF id number for already opened CDF file
*       varid    - variable id in netCDF file
*       index    - subscript of array to return
*	dtype    - data type of variable
*       errstr   - identifying string to be printed with error messages
*       vname    - name of variable owning attribute (used in error msgs)
*       dval     - double precision value returned
*       status   - TMAP library return status

* argument declarations
      INTEGER cdfid, varid, index, dtype, status
      REAL*8  dval
      CHARACTER*(*) errstr

      include 'netcdf.inc'
      include 'tmap_errors.parm'

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

* internal variable declarations:
      INTEGER cdfstat

* read the value
* NF_ routines convert to desired output data type.

#ifdef usingDODSf2cUnderscore
      cdfstat = NF_GET_VAR1_DOUBLE_(cdfid, varid, index, dval)
#else
      cdfstat = NF_GET_VAR1_DOUBLE(cdfid, varid, index, dval)
#endif

      IF ( cdfstat .NE. NF_NOERR ) CALL TM_ERRMSG
     .     ( cdfstat+pcdferr, status, 'CD_RD_R8_1', cdfid, varid,
     .       errstr, no_errstring, *5000 )

      status = merr_ok

 5000 RETURN

      END

	SUBROUTINE SHOW_DIAG_VARS( name, order )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute the SHOW VARIABLES/DIAGNOSTIC command - display an alphabetized list 
* of the available variables

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 7/8/87  - from SHOW_MEM_VARS and XEQ_SHOW
* revision 0.1 - 3/25/88 - added interruptibility
* revision 0.2 - 4/5/88  - eliminated cvar_second_name
* revision 0.3 - 4/29/88 - added "name" for name matching
* V200:  7/25/89 - show component vars
* V320: 12/29/94 - use SPLIT_LIST to redirect tty output for GUI
* V650  Write to show_lun which may be set to a file unit number rather than std out
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'
	include 'xvariables.cmn'
	include	'xcalc_vars.cmn'
	include	'xtext_info.cmn'
	include 'xinterrupt.cmn'

* calling argument declarations:
	INTEGER		order( max_calc_vars )
	CHARACTER	name*4

* local variable declarations:
	LOGICAL MATCH4, all, full
	INTEGER i, i2, temp, len, icomp, comp0, iend, var, status,
     .          TM_LENSTR, len_test, len_mchars
	CHARACTER	var_code*4, comp_buff*64
	DATA		comp_buff(1:9) / '-->using:' /

* local parameters
	INTEGER	    slash_full
	PARAMETER ( slash_full = 1 + 1 )

* initialize
	all  = name .EQ. unspecified_name4
	full = qual_given(slash_full) .GT. 0

* fill the order buffer with the default order
	DO 100 i = 1, num_calc_vars
 100	order(i) = i

* alphabetize the list
	DO 200 i2 = num_calc_vars, 2, -1
	DO 200 i = 2, i2
	   IF ( cvar_name_code(order(i-1)) .GT. cvar_name_code(order(i)) )
     .									THEN
	      temp = order(i)
	      order(i  ) = order(i-1)
	      order(i-1) = temp
	   ENDIF
 200	CONTINUE

* ... and write it out
	   CALL SPLIT_LIST(pttmode_explct, show_lun,
     .		'Diagnostic variables:',21)
	   CALL SPLIT_LIST(pttmode_explct, show_lun,
     .		'name         title',18)
           len_test = TM_LENSTR(name)
	   DO 300 i2 = 1, num_calc_vars
	      IF ( interrupted ) CALL ERRMSG
     .			( ferr_interrupt, status, ' ', *1000 )
	      i = order( i2 )
              len_mchars = TM_LENSTR(cvar_name_code(i)(:4))
	      IF ( all .OR. MATCH4(name,len_test, 
     .            cvar_name_code(i),len_mchars) ) THEN
	         CALL SPLIT_LIST(pttmode_explct, show_lun,
     .			cvar_name_code(i)//'      '//cvar_primary_name(i), 0)
	         IF ( .NOT.full ) GOTO 300
* ... show the components
	         comp0  = cvar_frame_start( i )
	         iend = 9
	         DO 250 icomp = comp0 + 1, comp0 + cvar_frame_length(i)
	            iend = iend + 5
	            var = cv_variable( icomp )
	            IF (var .GT. pcv_spec_flg) var = var - pcv_spec_flg
	            IF ( cv_category( icomp ) .EQ. cat_calc_var ) THEN
	               var_code = cvar_name_code( var )
	            ELSE
	               var_code = fvar_name_code( var )
	            ENDIF
	            WRITE( comp_buff( iend-4:iend ), '(1X,A)' ) var_code
 250	         CONTINUE
	         CALL SPLIT_LIST(pttmode_explct, show_lun, comp_buff, iend)
	      ENDIF
 300	   CONTINUE

 1000	RETURN
	END

	SUBROUTINE TRANS_FINALIZE( idim, arg,
     .				   res, res_mr, res_cx )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* finalize a transform that contains accumulated values
* e.g. average =  WIGHTED_SUM(values) divided by SUM(weights)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V702 11/16 *sh* for enhancement ticket 2428: split/gather on compressed axes


        IMPLICIT NONE
* calling argument declarations:
	INTEGER	idim, res_mr, res_cx
	REAL	arg, res(*)

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include 'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xprog_state.cmn'

* internal variable declarations:
	INTEGER	trans
	INTEGER CGRID_SIZE, size


* initiailize
	trans = cx_trans( idim, res_cx )
	size = CGRID_SIZE(res_cx)

	IF ( trans .EQ. trans_average
     .  .OR. trans .EQ. trans_4d_ave   
     .  .OR. trans .EQ. trans_integ_def
     .  .OR. trans .EQ. trans_4d_int_def  ) THEN
* ... diagnostic mode output: " final --> VAR_NAME[x=lo:hi@TRN:n,D=#]"
	   IF ( mode_diagnostic ) CALL DIAG_OP
     .			( 'final', isact_class_trans, res_cx, idim )
	   CALL FINALIZE_AVE_INT(trans, size,
     .			         res_mr, res, res(size+1) )

	ELSEIF ( trans .EQ. trans_sum
     .      .OR. trans .EQ. trans_4d_sum
     .      .OR. trans .EQ. trans_max
     .      .OR. trans .EQ. trans_min   ) THEN

	   CALL FINALIZE_SUMS_COUNTS(trans, size,
     .			         res_mr, res, res(size+1) )

	ELSEIF ( trans .EQ. trans_variance
     .      .OR. trans .EQ. trans_4d_var
     .	    .OR. trans .EQ. trans_std_dev
     .      .OR. trans .EQ. trans_4d_std ) THEN

	   IF ( mode_diagnostic ) CALL DIAG_OP
     .			( 'final', isact_class_trans, res_cx, idim )
	   CALL FINALIZE_VARIANCE(trans, size,
     .			          res_mr, res, res(size+1), res(2*size+1) )


	ELSE
 
* trans_good_pt, trans_4d_good_pt, trans_bad_pt, trans_4d_bad_pt are simple 
* counts, and do not need a finalization step.

* all other transformations do not require initialization
*      trans_locate - potentially could, but would need added machinery during
*                     split gather since it is locating a result that lies
*                     *between* two points


	   CONTINUE   ! TBD

	ENDIF

	RETURN

	END

	INTEGER FUNCTION DO_DERIV_BKWD(	idim, arg,
     .					com, com_mr, com_cx,
     .					res, res_mr, res_cx,
     .					box	)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute backwards derivative of component along axis idim

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  6/6/89
*	10/16/89 - changes to adjustable array declarations
* 12/96 *kob* - Linux Port - had to move variable assignments off of
*               declaration line.
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xprog_state.cmn'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xdset_info.cmn_text'

* calling argument declarations:
	INTEGER	idim, com_mr, com_cx, res_mr, res_cx
	REAL	arg, box(*), com(*), res(*)
	
* internal variable declarations:
	LOGICAL	TM_ITSA_DSG
	INTEGER TM_DSG_DSET_FROM_GRID, TM_DSG_NFEATURES, 
     .		dset, grid, nfeatures, maxobs, mr_list(2)
	REAL	little_val, big_val

* forward and backwards derivatives are identical except for a shift 
	INTEGER	ishf		!kob 12/96
	PARAMETER (ishf = 1)	! 1 for backwards, 0 for forwards

* diagnostic mode output: " doing --> VAR_NAME[x=lo:hi@TRN:n,D=#]"
	IF ( mode_diagnostic ) 	CALL DIAG_OP
     .				( 'doing', isact_class_trans, res_cx, idim )


* DSG-specific initialize

	grid = mr_grid( com_mr )
	IF (TM_ITSA_DSG(grid)) THEN 

* DSG ragged array
	   dset = TM_DSG_DSET_FROM_GRID(grid)
	   nfeatures = TM_DSG_NFEATURES(grid)

* ... get the length of the longest feature
	   CALL DSG_COORD_LIMS(dset, pdsg_row_size, little_val, big_val)
	   maxobs = big_val
     
	   mr_list(1) = com_mr
	   mr_list(2) = res_mr
	   CALL NON_ARRAY_SUBSC( mr_list, 2 )
	   CALL DSG_ARRAY_SUBSC( mr_list, 2, dsg_orientation(dset) )

	   CALL DD1STEP_DSG (idim, ishf, dset, nfeatures, maxobs,
     .			com, com_mr, com_cx,
     .			res, res_mr, res_cx,
     .			box	)


	ELSE

	   CALL DD1STEP (  idim, ishf,
     .			cx_lo_ss(com_cx,idim),cx_hi_ss(com_cx,idim), box,
     .			com, com_mr,
     .			res, res_mr, res_cx )

	ENDIF

* always success
	DO_DERIV_BKWD = ferr_ok

	RETURN
	END

	SUBROUTINE TM_COPY_LINE ( source, dest )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Copies line information from source to dest
*
* revision 0.00 - 11/22/88
* 10/95 - check to see if a dynamic line -- some variables don't get copied
*  1/96 - repaired bug (incomplete test) in 10/95 check
*  1/01 - *acm* add line_cal_name parallel with treatment of line_t0
* V581 *acm* 6/05 - For fix to bug 1271, add flag line_shift_origin
* V62  *acm* 3/09 - copy line_name_orig, used to keep original axis names 
*                   for use with attribute structure, e.g. save/keep_axisname
* v694 1/15 *acm* (see ticket 2227) handle the line_dim_only flag

* Arguments
	INTEGER*4	source, dest
*
* Parameters and commons

	include 'tmap_dims.parm'
        include 'tmap_errors.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'xtm_grid.cmn_text'
	external xgt_grid_data

	INTEGER status

*
	line_name(dest)      = line_name(source)
	line_name_orig(dest) = line_name_orig(source)
	line_dim(dest)       = line_dim(source) 
	line_units(dest)     = line_units(source) 
	line_unit_code(dest) = line_unit_code(source) 
	line_direction(dest) = line_direction(source) 
	line_regular(dest)   = line_regular(source) 
	line_modulo(dest)    = line_modulo(source) 
	line_start(dest)     = line_start(source) 
	line_delta(dest)     = line_delta(source) 
	line_t0(dest)        = line_t0(source) 
	line_shift_origin(dest) = line_shift_origin(source) 
	line_tunit(dest)     = line_tunit(source) 
	line_cal_name(dest)  = line_cal_name(source) 
	line_dim_only(dest)  = line_dim_only(source)

	IF ( dest.LE.max_lines .AND. source.LE.max_lines 
     .       .AND. .NOT.line_regular(source) ) THEN
* non-dynamic lines, only
	   CALL GET_LINE_DYNMEM (line_dim(source), dest, status)
           IF (status .NE. merr_ok) GOTO 5000
	   CALL COPY_LINE_COORDS (linemem(source)%ptr, linemem(dest)%ptr, line_dim(source))
	   CALL COPY_LINE_COORDS (lineedg(source)%ptr, lineedg(dest)%ptr, line_dim(source)+1)
	ELSEIF ( dest.GT.max_lines .AND. source.GT.max_lines) THEN! ELSEIF 1/96
* dynamic lines, only
	   line_class (dest)	= line_class (source)
	   line_parent(dest)	= line_parent(source)
	ENDIF

 5000	RETURN
	END

      SUBROUTINE TIME2(ITIME,SYM)
C** 
C**    @(#)time2.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Mod 11.20.95 J Davison to accommodate 4 digit year, and seconds
*       J Davison 10.15.99   Modified to support multiple calendars.
* V530 1/01 *acm* split calendar.cmn into .cmn and .decl

      CHARACTER ITIME*(*),SYM*(*)
C                                                                        

#ifdef unix
        include 'calendar.decl' 
        include 'calendar.cmn'
#else
        INCLUDE 'TMAP_PPLV11INC:CALENDAR.CMN'
#endif


C     THIS ROUTINE TRANSLATES enhanced WOODSHOLE FORMATTED TIME
C     INTO A PLOTABLE TYPE FORMAT.                                       
C         IE.  77081904590118 BECOMES 4:59:01 AUG 19, 1877
C     IN THE GREGORIAN CALENDAR, WHERE MONTH 8 IS 'AUG'. THE VALUES OF
C     MONTH_NAMES IN THE CURRENT CALENDAR DETERMINES THE MONTH NAMES.
C                                                                        

**************************************************************************

      CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)                   

*     WRITE(SYM,40) IHR,IMIN,ISEC,MONTH_NAMES(IMON),IDAY,ICEN,IYR         
*  40 FORMAT(I2,':',I2.2,':',I2.2,' ',A3,' ',I2,',', I2.2, I2.2)
 
      WRITE(SYM,40) IHR,IMIN,MONTH_NAMES(IMON),IDAY,ICEN,IYR         

   40 FORMAT(I2,':',I2.2,' ',A3,' ',I2,',', I2.2, I2.2)
      RETURN                                                             
      END                                                                

*
*  tracks2grid_ave_xyt.F
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* June 2009  from scatgrid_nobs_xyt
*
* The input data points are not a simple scatter.  They are cruise tracks 
* strung one after another .  (Each track will be a contiguous block of points 
* in the input data arrays. )  And the subtlety is that each cruise needs to 
* receive the same weight when determining the average for a cell, rather than 
* each individual data point.  Which means effectively that you need to have 
* two averaging processes .  You need to have a buffer (the individual cruise 
* buffer) that is the size and shape of the output grid in which you average 
* each individual cruise.  And then when the final point of each cruise from 
* the input data is encountered, you need to add (average) the points from the 
* individual cruise buffer into the output buffer, re-zeroing the individual 
* cruise buffer as you do so, so it is ready to average the next cruise. 
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE  tracks2grid_ave_xyt_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CHARACTER*126 buff
      WRITE (buff, 10)
   10 FORMAT ('Average by cruise, when gridding scattered ',
     .        'data to XYT grid.')
      CALL ef_set_desc(id, buff)

      CALL ef_set_num_args(id, 8)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS,
     .        IMPLIED_BY_ARGS, NORMAL, IMPLIED_BY_ARGS)

      CALL ef_set_num_work_arrays(id, 5)

* Output grid is determined by arguments 4, 5, 6, the result's x, y, t axes. 

      arg = 1
      CALL ef_set_arg_name(id, arg, 'VAR')
      CALL ef_set_arg_desc(id, arg, 
     .     'Variable at scattered input XYT. Enter a scalar to just count Obs.')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'XPTS')
      CALL ef_set_arg_desc(id, arg, 
     .     'X coordinates of scattered input triples')

      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'YPTS')
      CALL ef_set_arg_desc(id, arg, 
     .     'Y coordinates of scattered input triples')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'TPTS')
      CALL ef_set_arg_desc(id, arg, 
     .     'T coordinates of scattered input triples')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'ICRUISE')
      CALL ef_set_arg_desc(id, arg, 
     .     'Cruise ID at scattered input locations')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 6
      CALL ef_set_arg_name(id, arg, 'XAXPTS')
      CALL ef_set_arg_desc(id, arg, 
     .                   'X axis coordinates of a regular output grid')
      CALL ef_set_axis_influence(id, arg, YES, NO, NO, NO)

      arg = 7
      CALL ef_set_arg_name(id, arg, 'YAXPTS')
      CALL ef_set_arg_desc(id, arg, 
     .                   'Y axis coordinates of a regular output grid')
      CALL ef_set_axis_influence(id, arg, NO, YES, NO, NO)

      arg = 8
      CALL ef_set_arg_name(id, arg, 'TAXPTS')
      WRITE (buff, 20)
   20 FORMAT ('T axis coordinates, of a regular output grid, with same ',
     .       'units and origin as tpts')
      CALL ef_set_arg_desc(id, arg, buff)
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, YES)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN 
      END
*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE tracks2grid_ave_xyt_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
* 
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_dims(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER nxout, nyout, ntout, nx2, ny2, nt2
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nxout = 1 + arg_hi_ss(X_AXIS,ARG6) - arg_lo_ss(X_AXIS,ARG6)
      nyout = 1 + arg_hi_ss(Y_AXIS,ARG7) - arg_lo_ss(Y_AXIS,ARG7)
      ntout = 1 + arg_hi_ss(T_AXIS,ARG8) - arg_lo_ss(T_AXIS,ARG8)

      nx2 = nxout* 2
      ny2 = nyout* 2
      nt2 = ntout* 2

* xax  output x axis
      CALL ef_set_work_array_dims (id, 1, 1, 1, 1, 1, nx2, 1, 1, 1)

* yax  output y axis
      CALL ef_set_work_array_dims (id, 2, 1, 1, 1, 1, ny2, 1, 1, 1)

* Tax  output t axis
      CALL ef_set_work_array_dims (id, 3, 1, 1, 1, 1, nt2, 1, 1, 1)

* obs_cruise  work array - sum and counts of observations per cruise
* x,y,t direction: output grid
* z direction: 1..2
      CALL ef_set_work_array_dims (id, 4, 1, 1, 1, 1, 
     .                             nxout, nyout, 2, ntout)

* obs  work array - work array - sum and counts of observations
* x,y,t direction: output grid
* z direction: 1..2
      CALL ef_set_work_array_dims (id, 5, 1, 1, 1, 1, 
     .                             nxout, nyout, 2, ntout)

      RETURN
      END


*
* In this subroutine we compute the result
*

      SUBROUTINE tracks2grid_ave_xyt_compute(id, arg_1, arg_2, arg_3, 
     .     arg_4, arg_5, arg_6, arg_7, arg_8, result, 
     .      xax, yax, tax, obs_cruise, obs)

*  arg_1  var
*  arg_2  xpts  \
*  arg_3  ypts   | Scattered x,y triples to be gridded.
*  arg_4  tpts  / 
*  arg_5  icruise
*
*  arg_6  xaxis of new grid   
*  arg_7  yaxis of new grid
*  arg_8  taxis of new grid

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .     mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, 
     .     mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, 
     .     mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, 
     .     mem4loz:mem4hiz, mem4lot:mem4hit)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, 
     .     mem5loz:mem5hiz, mem5lot:mem5hit)
      REAL arg_6(mem6lox:mem6hix, mem6loy:mem6hiy, 
     .     mem6loz:mem6hiz, mem6lot:mem6hit)
      REAL arg_7(mem7lox:mem7hix, mem7loy:mem7hiy, 
     .     mem7loz:mem7hiz, mem7lot:mem7hit)
      REAL arg_8(mem8lox:mem8hix, mem8loy:mem8hiy, 
     .     mem8loz:mem8hiz, mem8lot:mem8hit)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      INTEGER i, j, k, l, m, n
      INTEGER i1, i2, j1, k1, l1, k2
      INTEGER i6,j7,L8,i6n,j7n,L8n

      INTEGER nxpts, npts
      INTEGER nx, ny, nt
      INTEGER i1n, i2n
      INTEGER obs_only

      REAL x1, y1, t1, icruise, ncruise, xf, yf, tf
      REAL xx, yy, tt, vv

*  Dimension the work arrays

      REAL*8 xax(wrk1lox:wrk1hix/2, wrk1loy:wrk1hiy,
     .               wrk1loz:wrk1hiz, wrk1lot:wrk1hit)
      REAL*8 yax(wrk2lox:wrk2hix/2, wrk2loy:wrk2hiy,
     .               wrk2loz:wrk2hiz, wrk2lot:wrk2hit)
      REAL*8 tax(wrk3lox:wrk3hix/2, wrk3loy:wrk3hiy,
     .               wrk3loz:wrk3hiz, wrk3lot:wrk3hit)
      REAL obs_cruise(wrk4lox:wrk4hix, wrk4loy:wrk4hiy,
     .               wrk4loz:wrk4hiz, wrk4lot:wrk4hit)
      REAL obs(wrk5lox:wrk5hix, wrk5loy:wrk5hiy,
     .               wrk5loz:wrk5hiz, wrk5lot:wrk5hit)

      CHARACTER*250 errtxt

C  variables for checking axis characteristics (modulo axes)

      CHARACTER ax_name(4)*16, ax_units(4)*16
      LOGICAL backward(4), modulox(4), moduloy(4), modulot(4), regular(4)

      REAL dx, dy, xxbeg, xxend, yybeg, yyend
      REAL*8 xax1,xaxf, yax1,yaxf, tax1,taxf
      INTEGER indx(4,2)

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      obs_only = 0	! 0 = var 1 is a variable to average.
                        ! 1 = Compute a count of cruises with an obs in the grid cells

*  Check to see if output axes are modulo

      CALL ef_get_axis_info (id, 6, ax_name, ax_units, backward, 
     .                       modulox, regular)
      CALL ef_get_axis_info (id, 7, ax_name, ax_units, backward, 
     .                       moduloy, regular)
      CALL ef_get_axis_info (id, 8, ax_name, ax_units, backward, 
     .                       modulot, regular)

*  Find number of points in scattered input points.  1-D arrays defining the 
*  scattered data points may lie on the X, Y, Z, or T axis of the input arguments.

      nxpts = 0

      DO 100 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG2) .GE. 1) THEN
            i1 = arg_lo_ss(m,ARG2)
            i1n = arg_hi_ss(m,ARG2)
            if (i1n-i1 .NE. 0) nxpts = 1 + (i1n - i1)
            IF (nxpts .EQ. 0) GOTO 900
         ENDIF
 100  CONTINUE

      npts = 1
      DO 110 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG1) .GE. 1) THEN
            i2 = arg_lo_ss(m,ARG1)
            i2n = arg_hi_ss(m,ARG1)
            npts = 1 + (i2n - i2)
            IF ((npts.NE.1) .AND. (npts.NE.nxpts)) GOTO 900
         ENDIF
 110  CONTINUE
      IF (npts .EQ. 1) obs_only = 1  ! just count up the obs

      DO 120 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG3) .GE. 1) THEN
            i2 = arg_lo_ss(m,ARG3)
            i2n = arg_hi_ss(m,ARG3)
            npts = 1 + (i2n - i2)
            IF (npts .NE. nxpts) GOTO 900
         ENDIF
 120  CONTINUE

      DO 130 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG4) .GE. 1) THEN
            i2 = arg_lo_ss(m,ARG4)
            i2n = arg_hi_ss(m,ARG4)
            npts = 1 + (i2n - i2)
            IF (npts .NE. nxpts) GOTO 900
         ENDIF
 130  CONTINUE

      DO 140 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG5) .GE. 1) THEN
            i2 = arg_lo_ss(m,ARG5)
            i2n = arg_hi_ss(m,ARG5)
            npts = 1 + (i2n - i2)
            IF (npts .NE. nxpts) GOTO 900
         ENDIF
 140  CONTINUE

      nscat = nxpts

*  Compute number of points in output axes.

      i6 = ef_unspecified_int4
      j7 = ef_unspecified_int4
      L8 = ef_unspecified_int4

      i6 = arg_lo_ss(X_AXIS,ARG6)
      i6n = arg_hi_ss(X_AXIS,ARG6)

      j7 = arg_lo_ss(Y_AXIS,ARG7)
      j7n = arg_hi_ss(Y_AXIS,ARG7)

      L8 = arg_lo_ss(T_AXIS,ARG8)
      L8n = arg_hi_ss(T_AXIS,ARG8)

      nx = 1 + (i6n - i6)
      ny = 1 + (j7n - j7)
      nt = 1 + (L8n - L8)

*  Check that xax is a X axis and yax a Y axis

      IF (i6 .EQ. ef_unspecified_int4) THEN
         WRITE (errtxt, *) 'Sixth argument must be a X axis'
         GO TO 999
      ENDIF
      IF (j7 .EQ. ef_unspecified_int4) THEN
         WRITE (errtxt, *) 'Seventh argument must be a Y axis'
         GO TO 999
      ENDIF
      IF (L8 .EQ. ef_unspecified_int4) THEN
         WRITE (errtxt, *) 'Eighth argument must be a T axis'
         GO TO 999
      ENDIF

C  Get coordinates of output axes.

      call ef_get_coordinates(id, ARG6, X_AXIS, 
     .   arg_lo_ss(X_AXIS, ARG6), arg_hi_ss(X_AXIS, ARG6), xax)

      call ef_get_coordinates(id, ARG7, Y_AXIS, 
     .   arg_lo_ss(Y_AXIS, ARG7), arg_hi_ss(Y_AXIS, ARG7), yax)

      call ef_get_coordinates(id, ARG8, T_AXIS, 
     .   arg_lo_ss(T_AXIS, ARG8), arg_hi_ss(T_AXIS, ARG8), tax)

*  Set start, end, and delta for output axes. 

      x1 = xax(1,1,1,1)
      y1 = yax(1,1,1,1)
      t1 = tax(1,1,1,1)

      xf = xax(nx,1,1,1)
      yf = yax(ny,1,1,1)
      tf = tax(nt,1,1,1)

*  Gridbox sizes in data units
      dx = xf - x1
      IF (nx .GT. 1) dx = (xf-x1)/ REAL(nx-1)
      dy = yf - y1
      IF (ny .GT. 1) dy = (yf-y1)/ REAL(ny-1) 
      dt = tf - t1
      IF (nt .GT. 1) dt = (tf-t1)/ REAL(nt-1) 

      IF (nx .EQ. 1) THEN 
         CALL ef_get_box_limits(id, ARG6, X_AXIS, 
     .   arg_lo_ss(X_AXIS, ARG6), arg_hi_ss(X_AXIS, ARG6), xax1,xaxf)
         dx = xaxf - xax1
      ENDIF
      IF (ny .EQ. 1) THEN 
         CALL ef_get_box_limits(id, ARG7, Y_AXIS, 
     .   arg_lo_ss(Y_AXIS, ARG7), arg_hi_ss(Y_AXIS, ARG7), yax1,yaxf)
         dy = yaxf - yax1
      ENDIF
         IF (nt .EQ. 1) THEN 
         CALL ef_get_box_limits(id, ARG8, T_AXIS, 
     .   arg_lo_ss(T_AXIS, ARG8), arg_hi_ss(T_AXIS, ARG8), tax1,taxf)
         tx = taxf - tax1
      ENDIF


      CALL ef_get_box_limits(id, ARG6, X_AXIS, 
     .   arg_lo_ss(X_AXIS, ARG6), arg_lo_ss(X_AXIS, ARG6), xax1,xax1)
      CALL ef_get_box_limits(id, ARG6, X_AXIS, 
     .   arg_hi_ss(X_AXIS, ARG6), arg_hi_ss(X_AXIS, ARG6), xaxf,xaxf)

*  Compute result

*  Initialize counts.

      k2 = 2
      IF (obs_only .EQ. 1) k2 = 1

      DO L = 1, nt
      DO k = 1, k2
      DO j = 1, ny
      DO i = 1, nx
         obs(i,j,k,L) = 0.
      ENDDO
      ENDDO
      ENDDO
      ENDDO

      DO L = 1, nt
      DO k = 1, k2
      DO j = 1, ny
      DO i = 1, nx
         obs_cruise(i,j,k,L) = 0.
      ENDDO
      ENDDO
      ENDDO
      ENDDO

*  Loop over x and y, compute the number of observations for the gaussian-weighted 
*  mapping onto the grid.  Lat and longitude may be on the X,Y,Z or T axis of ARG1 
*  and ARG2, sending them to a subroutine collapses the extra dimensions so the
*  value can be found.

      n = 1
      CALL pickoutxytcv (obs_only, arg_1, arg_2, arg_3, arg_4, arg_5,
     .           n, vv, xx, yy, tt, ncc)
      icruise = ncc

* For each cruise keep track of the index range it spans in the result grid
* Then at the end of the cruise need only to process that subset of the grid.
      indx(1,1) = nx
      indx(1,2) = 1
      indx(2,1) = ny
      indx(2,2) = 1
      indx(4,1) = nt
      indx(4,2) = 1

      DO 300 n = 1, nscat

         CALL pickoutxytcv (obs_only, arg_1, arg_2, arg_3, arg_4, arg_5,
     .           n, vv, xx, yy, tt, ncc)
         IF (vv .EQ. bad_flag(ARG1) .OR. xx .EQ. bad_flag(ARG2) .OR. 
     .          yy .EQ. bad_flag(ARG3) .OR. tt .EQ. bad_flag(ARG4) ) GOTO 300

         IF (ncc .NE. icruise) THEN
	    
            DO L = indx(4,1), indx(4,2)
            DO j = indx(2,1), indx(2,2)
            DO i = indx(1,1), indx(1,2)
	       IF (obs_only .EQ. 0) THEN
                  IF (obs_cruise(i,j,2,L) .GT. 0.) THEN
                     obs(i,j,1,L) = obs(i,j,1,L) + 
     .                 obs_cruise(i,j,1,L)/obs_cruise(i,j,2,L)
                     obs(i,j,2,L) = obs(i,j,2,L) + 1.
		  ENDIF
                  obs_cruise(i,j,1,L) = 0.
                  obs_cruise(i,j,2,L) = 0.
               ELSE
                  IF (obs_cruise(i,j,1,L) .GT. 0.) THEN
                     obs(i,j,1,L) = obs(i,j,1,L) + 1.
                  ENDIF
                  obs_cruise(i,j,1,L) = 0.
               ENDIF
            ENDDO
            ENDDO
            ENDDO

	    icruise = ncc

* reset indices
            indx(1,1) = nx
            indx(1,2) = 1
            indx(2,1) = ny
            indx(2,2) = 1
            indx(4,1) = nt
            indx(4,2) = 1
	    
	 ENDIF

*  If an output axis is modulo, apply modulo adjustment to that coordinate
*  of the scattered point.

c         IF  (modulox(1) .AND. xx.NE.bad_flag(ARG1))
c     .         CALL modscatminmax (xax1, xaxf, 1, xx)

         CALL nobsxytv (obs_only, xx, yy, tt, vv, nx, ny, nt, 
     .           x1, y1, t1, dx, dy, dt, xf, yf, tf, indx, obs_cruise)

*  Put points within dx or dy  or dt of the end just beyond the
*  other end, and use in the gridding computation.

c         IF (modulox(1)) THEN
c            IF ((xx-x1 .GE. 0.) .AND. (xx-x1 .LT. dx) ) THEN
c               xxend = xf + (xx-x1)
c               CALL nobsxytv (obs_only, xxend, yy, tt, vv, nx, ny, nt, 
c     .              x1, y1, t1, dx, dy, dt, xf, yf, tf, indx, obs_cruise)
c            ENDIF
                     
c            IF ((xf-xx .GE. 0.)  .AND. (xf-xx .LT. dx) ) THEN
c               xxbeg = x1 - (xf-xx)
c               CALL nobsxytv (obs_only, xxbeg, yy, tt, vv, nx, ny, nt, 
c     .              x1, y1, t1, dx, dy, dt, xf, yf, tf, indx, obs_cruise)
c            ENDIF
c         ENDIF

 300     CONTINUE

* Get data from the last cruise
	    
      DO L = indx(4,1), indx(4,2)
      DO j = indx(2,1), indx(2,2)
      DO i = indx(1,1), indx(1,2)
         IF (obs_only .EQ. 0) THEN
            IF (obs_cruise(i,j,2,L) .GT. 0.) THEN
               obs(i,j,1,L) = obs(i,j,1,L) + 
     .                 obs_cruise(i,j,1,L)/obs_cruise(i,j,2,L)
               obs(i,j,2,L) = obs(i,j,2,L) + 1.
            ENDIF
            obs_cruise(i,j,1,L) = 0.
            obs_cruise(i,j,2,L) = 0.
         ELSE
            IF (obs_cruise(i,j,1,L) .GT. 0.) THEN
               obs(i,j,1,L) = obs(i,j,1,L) + 1.
            ENDIF
               obs_cruise(i,j,1,L) = 0.
         ENDIF
      ENDDO
      ENDDO
      ENDDO

*  Put gridded fcn into result variable.

      IF (obs_only .EQ. 0) THEN
         k = res_lo_ss(Z_AXIS)
         L1 = 1
         DO 420 L = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
            j1 = 1
            DO 410 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
               i1 = 1
               DO 400 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
                  IF (obs(i1,j1,2,L1) .GT. 0.) THEN
                     result(i,j,k,l) = obs(i1,j1,1,L1)/obs(i1,j1,2,L1)
		  ELSE
                     result(i,j,k,l) = bad_flag_result
		  ENDIF

                  i1 = i1 + 1
 400           CONTINUE
               j1 = j1 + 1

 410        CONTINUE
            L1 = L1 + 1
 420     CONTINUE

      ELSE
         k = res_lo_ss(Z_AXIS)
         L1 = 1
         DO 520 L = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
            j1 = 1
            DO 510 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
               i1 = 1
               DO 500 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
                  result(i,j,k,l) = obs(i1,j1,1,L1)
                  i1 = i1 + 1
 500           CONTINUE
               j1 = j1 + 1

 510        CONTINUE
            l1 = l1 + 1
 520     CONTINUE

      ENDIF

      RETURN

900   CONTINUE

      IF (nxpts .NE. npts) THEN
         WRITE (errtxt,20)
      ELSE IF (nxpts .EQ. 0) THEN
         WRITE (errtxt, 30)
      ENDIF
      GOTO 999 

 999  CALL EF_BAIL_OUT(id, errtxt)
      RETURN

   20 FORMAT 
     . ('Input scattered var,x,y,t,cruiseID have different # of points')

   30 FORMAT ('No data in scattered x,y,t points')


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      END




      SUBROUTINE pickoutxytcv (obs_only, vars, alon, alat, atimes,
     .   cruises, n, vv, xx, yy, tt, ncc)

*  Called from the scatter* family of gridding functions.
*  Pick out nth item from a set of arrays, which are really 
*  4-dimensioned arrays with normal axes on three of the four axes.

      REAL alon(*), alat(*), atimes(*), cruises(*), vars(*)
      REAL xx, yy, tt, vv
      INTEGER obs_only, n, ncc

      vv = 1.
      IF (obs_only .EQ. 0) vv = vars(n)
      xx = alon(n)
      yy = alat(n)
      tt = atimes(n)
      ncc = cruises(n)

      RETURN
      END

	SUBROUTINE DEFINE_NEXT_CHUNK_CX(idim, com_cx, dflt_cx, frag, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* increment com_cx so that it becomes the context describing the next chunk
* needed in a gather operation

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V702: *sh* 11/16 - code pulled from IS_GATHER

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'

* calling argument declarations:
	INTEGER idim, com_cx, dflt_cx, frag, status

* calling argument definitions:
*	idim - the axis of the gather operation
*	com_cx - the context to be updated (the next component of the gather)
*	dflt_cx - the target context, with transforms, pre-split/gather
*	frag - the fragment (a.k.a increment) size

* internal variable declarations:
	INTEGER top_ss, lo_ss

* increment the subscript range by fragment size
	top_ss = cx_hi_ss(com_cx,idim)
	CALL TRANSFER_CONTEXT( dflt_cx, com_cx )
	cx_lo_ss(com_cx,idim) = top_ss + 1
	cx_hi_ss(com_cx,idim) = MIN( top_ss+frag, cx_hi_ss(dflt_cx,idim))
	cx_by_ss(idim,com_cx) = .TRUE.
	CALL FLESH_OUT_AXIS( idim, com_cx, status )       ! ignore status

* same exit whether success or failure
	RETURN
	END	

	SUBROUTINE TM_MONTH_TIME_FACTOR (grid, true_month, timefac)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*.
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Return a scale factor to write true-monthly data in original time units. 
* Converting from the secs-per-month in the true-month calendar to units from 
* the original axis.
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.

	include 'ferret.parm'
	include 'tmap_dims.parm'
        include 'xunits.cmn_text'
	include 'calendar.decl'
        include 'xtm_grid.cmn_text'
        external xgt_grid_data

	LOGICAL true_month
	INTEGER grid
	REAL timefac

	LOGICAL ITSA_TRUEMONTH_AXIS
	INTEGER TM_GET_CALENDAR_ID, 
     .		iaxis, cal_id, monax_units_code, status
	REAL	secspmon, secs_p_unit, unit_p_mon

	timefac = 1.
	iaxis = grid_line(t_dim, grid)
!	print *, line_units(iaxis)

* get axis description stored by Ferret

	true_month = ITSA_TRUEMONTH_AXIS(iaxis)
	IF (.NOT. true_month) RETURN

	monax_units_code = line_unit_code(iaxis) 

	cal_id = TM_GET_CALENDAR_ID ( line_cal_name(iaxis) )

* Convert to days

* Translation from line-unit-code (true month) to days

	secspmon = un_convert( monax_units_code )

	secs_p_unit = un_convert( pun_day )
	unit_p_mon = secspmon/ secs_p_unit
	timefac = unit_p_mon

	RETURN
	END

	INTEGER FUNCTION MODULO_PARITY(ss1, modlen, delta)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Determine the "parity" that is associated with the starting subscript ss1
* given a modulo length of lenmod and a stride value of delta
* for example, if the modulo length is 10
*	i=1:10:3  - parity = 1  ... ditto i=4:10:3
*	i=2:10:3  - parity = 2  ... ditto i=5:10:3
*	i=3:10:3  - parity = 3  ... ditto i=6:10:3
* Although i=11 would seem to be parity=2, it is the starting index of the
* next modulo replication so it is parity=1. i=12 is parity=2, etc.

* V533: *sh* 6/01
* V56: *acm* 3/04 Fix bugs that occur when ss1 is negative.

        IMPLICIT NONE
* calling argument declarations
	INTEGER	ss1, modlen, delta

* internal variable declarations
	INTEGER TM_MOD, nmod

	nmod = (ss1-1)/modlen  ! number of modulo replications preceding ss1

* Start at the bottom of the modulo replication preceding ss1
        IF (ss1 .LT. 0 .AND. nmod*modlen .NE. ss1-1) nmod = nmod - 1

	MODULO_PARITY = TM_MOD(ss1-1-(nmod*modlen), delta) + 1

	RETURN
	END

	SUBROUTINE GET_WORK_MR ( i8_size, mr, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* allocate and return a managed block of memory without a corresponding
* context that points to it. 
* The routines delete_variable and delete_uncached_vars are responsible for
* freeing the memory
* This routine may be called to get as many separate chunks of work space
* as are required -- unlike GET_MEM_SPC, which returns always the same
* single hunk of memory. (This routine is superior to GET_WORK_SPC in almost
* every way ... should really replace that routine.)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V510 8/99 *sh*
*      2/00 *sh* bug fix - initialize mr_grid
* V533 7/01 *sh* - set data type
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V69+ *acm*  9/14 Ticket 1758. Memory request uses number of blocks not words

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'

* calling argument declarations:
	INTEGER	mr, status
	INTEGER*8 i8_size

* internal variable declarations
	INTEGER idim

* --- end of introductory code ---

* get a free slot in the memory variable table
	CALL FIND_MR_SLOT( mr, status )
	IF ( status .NE. ferr_ok ) RETURN

* allocate memory
	CALL GET_MR_DYNMEM( i8_size, mr, status )
	IF ( status .NE. ferr_ok ) THEN
	   CALL MR2FREELIST(mr)
	   RETURN
	ENDIF

* always set its data type to float
	mr_type( mr ) = ptype_float

* always set its missing value flag to the default
	mr_bad_data( mr ) = bad_val4

* flag it as "in progress"
	mr_protected( mr )	= mr_in_progress

* book keeping about memory usage
	essential_mem = essential_mem + mr_size(mr)
	IF (essential_mem.GT.peak_essential_mem) 
     .		peak_essential_mem = essential_mem

* work arrays do not use any grids
	mr_grid( mr ) = unspecified_int4

* for good house-keeping, set the mr subscripts
	mr_lo_ss(mr,x_dim) = 1
	mr_hi_ss(mr,x_dim) = i8_size
	DO 100 idim = 2, nferdims
	   mr_lo_ss(mr,idim) = unspecified_int4
	   mr_hi_ss(mr,idim) = unspecified_int4
 100	CONTINUE

* hook it into the cacke search list (just to be consistent with other vars)
	CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) RETURN
	cx_category(cx_stack_ptr) = cat_work_mr
	CALL HOOK_MR_SLOT( cx_stack_ptr, mr )
	cx_stack_ptr = cx_stack_ptr - 1

	RETURN
	END

	BLOCK DATA XGT_GRID_DATA

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* names and sizes of predefined climatological axes

* programmer - mark verschell (from a program by steve hankin)
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.00 - 05/07/87 - by Mark Verschell for PMEL/TMAP
* revision 0.10 - 07/27/88 - Parameter name change, grid/lisne definition order
*			     swapped, line now defined by box coord, midpt coord
* revision 0.11 - 11/21/88 - variable initialization changed to char_initXX
* revision 0.20 - 11/29/88 - removed NORMAL and UNKNOWN line definitions
* revision 0.21 - 12/12/88 - added next_line_mem_pos initialization
* revision 0.30 - 12/15/88 - SH changed box boundry coordinates for PSYT / PSYU
*			     to correctly reflect location in GFDL model 
* revision 0.31 - 02/17/89 - Fixed next_line_mem_pos error (1 less than correct)
* revision 0.40 - 01/07/91 - eliminated multoply define line_mem for RISC
*			     by defining and using pline_mem_next
* revision 0.41 - 04/24/91 *sh* unix/RISC port: increased size of grid_filename
* revision 0.42 - 7/2/92 *kob* commented out initialization of line_mem
*			       to speed compilation and decrease mem needs.
* *kob* 10/96   - Linux port.  Linux didn't like tabs between "include"
*                 and what was being included.  removed them
* V510 *sh* 3/00 - initialize through line/grid_ceiling -- for dynamic netCDF
*			grid and line management
* V530*acm* 1/01 - add line_cal_name for alternative calendar types.
* V550 *sh* 11/02 - add initialize line_modulo_len
* V581 *acm* 6/05 - For fix to bug 1271, add flag line_shift_origin
* V62 *acm*  2/09 - Save original upper/lowercase spelling of axis names 
*                   in line_name_orig for CANCEL MODE UPCASE
*      4/12 *acm* - 6D Ferret, formatted F axis is direction FI
* V685 *acm* 3/13 - add climatological axes to the pre-defined axes.
* v685 *acm* 4/13 - Let Ferret compute the modulo lengths for clim. axes
* v697 *acm* 12/115 -Missed some initializations, 4D-->6D grids
* V698  3/16 *acm* Removed Philander-Seigel code including diagnostic variables, 
* pre-defined axes and grids.
* V698  3/16 *acm* Fix the line_subsc1 values for irregular axes
* V698  3/16 *acm* Define monthly climatology for Julian axis.
* V702 11/16 *sh* Commented out initialization of of grids cuz
*                 was taking unacceptable long time to compile
* V720 4/17 *sh* added line_dsg_dset, axis_dimname
* V72 8/17 *acm*   For trac enhancement #767 -- dynamic coordinate storage

	include 'tmap_dims.parm'
	include 'implicit.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'xunits.cmn_text'
	include 'xtm_grid.cmn_text'

	INTEGER		ngrd_def, nlne_def, grids_left, lines_left,
     .			grid_lines_left, i, j, outtype

	PARAMETER	(ngrd_def	= 0,
     .			 nlne_def	= 8,
     .			 grids_left	= grid_ceiling-ngrd_def,
     .			 lines_left	= line_ceiling-nlne_def,
     .			 grid_lines_left= nferdims*grids_left)

	PARAMETER	(outtype	= 6)  ! netcdf type double, output axis type.

* DEFINE LINES

	DATA
     .		line_name	(clmirr)	/ 'MONTH_IRREG'	/,
     .		line_name_orig	(clmirr)	/ 'MONTH_IRREG'	/,
     .		line_subsc1	(clmirr)	/ 2		/,
     .		line_dim	(clmirr)	/ 12		/,
     .		line_units	(clmirr)	/ 'DAYS'	/,
     .		line_unit_code  (clmirr)	/ -4   /,
     .		line_direction	(clmirr)	/ 'TI'		/,
     .		line_regular	(clmirr)	/ .FALSE.	/,
     .		line_modulo	(clmirr)	/ .TRUE.       /,
     .		line_start	(clmirr)	/ unspecified_val8 /,
     .		line_delta	(clmirr)	/ unspecified_val8 /,
     .		line_tunit	(clmirr)	/ 86400 /,
     .		line_t0		(clmirr)	/'01-JAN-0000 00:00:00'/,
     .		line_cal_name	(clmirr)	/'GREGORIAN'/
     
	DATA
     .		line_name	(clmreg)	/ 'MONTH_REG'	/,
     .		line_name_orig	(clmreg)	/ 'MONTH_REG'	/,
     .		line_subsc1	(clmreg)	/ unspecified_int4 /,
     .		line_dim	(clmreg)	/ 12		/,
     .		line_units	(clmreg)	/ 'hour'	/,
     .		line_unit_code  (clmreg)	/ -3   /,
     .		line_direction	(clmreg)	/ 'TI'		/,
     .		line_regular	(clmreg)	/ .TRUE.	/,
     .		line_modulo	(clmreg)	/ .TRUE.       /,
     .		line_start	(clmreg)	/ 366. /,
     .		line_delta	(clmreg)	/ 730.485 /,
     .		line_tunit	(clmreg)	/ 3600 /,
     .		line_t0		(clmreg)	/'01-JAN-0000 00:00:00'/,
     .		line_cal_name	(clmreg)	/'GREGORIAN'/


	DATA
     .		line_name	(clseas)	/ 'SEASONAL_REG'	/,
     .		line_name_orig	(clseas)	/ 'SEASONAL_REG'	/,
     .		line_subsc1	(clseas)	/ unspecified_int4 /,
     .		line_dim	(clseas)	/ 4		/,
     .		line_units	(clseas)	/ 'HOURS'	/,
     .		line_unit_code  (clseas)	/ -3   /,
     .		line_direction	(clseas)	/ 'TI'		/,
     .		line_regular	(clseas)	/ .TRUE.	/,
     .		line_modulo	(clseas)	/ .TRUE.       /,
     .		line_start	(clseas)	/ 1095.7275 /,
     .		line_delta	(clseas)	/ 2191.455 /,
     .		line_tunit	(clseas)	/ 3600 /,
     .		line_t0		(clseas)	/'01-JAN-0000 00:00:00'/,
     .		line_cal_name	(clseas)	/'GREGORIAN'/

	DATA
     .		line_name	(clmgrg)	/ 'MONTH_GREGORIAN' /,
     .		line_name_orig	(clmgrg)	/ 'MONTH_GREGORIAN' /,
     .		line_subsc1	(clmgrg)	/ 27		/,
     .		line_dim	(clmgrg)	/ 12		/,
     .		line_units	(clmgrg)	/ 'days'	/,
     .		line_unit_code  (clmgrg)	/ -4   /,
     .		line_direction	(clmgrg)	/ 'TI'		/,
     .		line_regular	(clmgrg)	/ .FALSE.	/,
     .		line_modulo	(clmgrg)	/ .TRUE.       /,
     .		line_start	(clmgrg)	/ unspecified_val8 /,
     .		line_delta	(clmgrg)	/ unspecified_val8 /,
     .		line_tunit	(clmgrg)	/ 86400 /,
     .		line_t0		(clmgrg)	/'01-JAN-0000 00:00:00'/,
     .		line_cal_name	(clmgrg)	/'GREGORIAN'/
     
	DATA
     .		line_name	(clmnol)	/ 'MONTH_NOLEAP' /,
     .		line_name_orig	(clmnol)	/ 'MONTH_NOLEAP' /,
     .		line_subsc1	(clmnol)	/ 52		/,
     .		line_dim	(clmnol)	/ 12		/,
     .		line_units	(clmnol)	/ 'days'	/,
     .		line_unit_code  (clmnol)	/ -4   /,
     .		line_direction	(clmnol)	/ 'TI'		/,
     .		line_regular	(clmnol)	/ .FALSE.	/,
     .		line_modulo	(clmnol)	/ .TRUE.       /,
     .		line_start	(clmnol)	/ unspecified_val8 /,
     .		line_delta	(clmnol)	/ unspecified_val8 /,
     .		line_tunit	(clmnol)	/ 86400 /,
     .		line_t0		(clmnol)	/'01-JAN-0000 00:00:00'/,
     .		line_cal_name	(clmnol)	/'NOLEAP'/

	DATA
     .		line_name	(clm360)	/ 'MONTH_360_DAY' /,
     .		line_name_orig	(clm360)	/ 'MONTH_360_DAY' /,
     .		line_subsc1	(clm360)	/ unspecified_int4	/,
     .		line_dim	(clm360)	/ 12		/,
     .		line_units	(clm360)	/ 'days'	/,
     .		line_unit_code  (clm360)	/ -4   /,
     .		line_direction	(clm360)	/ 'TI'		/,
     .		line_regular	(clm360)	/ .TRUE.	/,
     .		line_modulo	(clm360)	/ .TRUE.       /,
     .		line_start	(clm360)	/ 15. /,
     .		line_delta	(clm360)	/ 30. /,
     .		line_tunit	(clm360)	/ 86400 /,
     .		line_t0		(clm360)	/'01-JAN-0000 00:00:00'/,
     .		line_cal_name	(clm360)	/'360_DAY'/

	DATA
     .		line_name	(clmall)	/ 'MONTH_ALL_LEAP' /,
     .		line_name_orig	(clmall)	/ 'MONTH_ALL_LEAP' /,
     .		line_subsc1	(clmall)	/ 77	/,
     .		line_dim	(clmall)	/ 12		/,
     .		line_units	(clmall)	/ 'days'	/,
     .		line_unit_code  (clmall)	/ -4   /,
     .		line_direction	(clmall)	/ 'TI'		/,
     .		line_regular	(clmall)	/ .FALSE.	/,
     .		line_modulo	(clmall)	/ .TRUE.       /,
     .		line_start	(clmall)	/ unspecified_val8 /,
     .		line_delta	(clmall)	/ unspecified_val8 /,
     .		line_tunit	(clmall)	/ 86400 /,
     .		line_t0		(clmall)	/'01-JAN-0000 00:00:00'/,
     .		line_cal_name	(clmall)	/'ALL_LEAP'/

	DATA
     .		line_name	(clmjul)	/ 'MONTH_JULIAN' /,
     .		line_name_orig	(clmjul)	/ 'MONTH_JULIAN' /,
     .		line_subsc1	(clmjul)	/ 102	/,
     .		line_dim	(clmjul)	/ 12		/,
     .		line_units	(clmjul)	/ 'days'	/,
     .		line_unit_code  (clmjul)	/ -4   /,
     .		line_direction	(clmjul)	/ 'TI'		/,
     .		line_regular	(clmjul)	/ .FALSE.	/,
     .		line_modulo	(clmjul)	/ .TRUE.       /,
     .		line_start	(clmjul)	/ unspecified_val8 /,
     .		line_delta	(clmjul)	/ unspecified_val8 /,
     .		line_tunit	(clmjul)	/ 86400 /,
     .		line_t0		(clmjul)	/'01-JAN-0000 00:00:00'/,
     .		line_cal_name	(clmjul)	/'JULIAN'/


* 7/99 *kob* add in initialization for line_name and mpsnorm.  
*            needed for v3.4 of netcdf use
	DATA    line_name       (mpsnorm) /' '/
	DATA    line_name_orig  (mpsnorm) /' '/


* initialize the unused grid common locations
	DATA	grid_filename	/maxgridfiles*char_init128/

	DATA	(line_parent(i),i=1,line_ceiling)
     .			/line_ceiling*0/

	DATA	(line_class(i),i=1,line_ceiling)
     .			/line_ceiling*pline_class_basic/

	DATA	(line_name(i),i=nlne_def+1,line_ceiling)
     .			/lines_left*char_init16/
	DATA	(line_name_orig(i),i=nlne_def+1,line_ceiling)
     .			/lines_left*char_init16/

	DATA	(line_subsc1(i),i=nlne_def+1,line_ceiling)
     .			/lines_left*int4_init/

	DATA	(line_dim(i),i=nlne_def+1,line_ceiling)
     .			/lines_left*int4_init/

	DATA	(line_units(i),i=nlne_def+1,line_ceiling)
     .			/lines_left*char_init16/

	DATA	(line_unit_code(i),i=nlne_def+1,line_ceiling)
     .			/lines_left*int4_init/

	DATA	(line_direction(i),i=nlne_def+1,line_ceiling)
     .			/lines_left*char_init02/

	DATA	(line_start(i),i=nlne_def+1,line_ceiling)
     .			/lines_left*real8_init/

	DATA	(line_delta(i),i=nlne_def+1,line_ceiling)
     .			/lines_left*real8_init/

	DATA	(line_regular(i),i=nlne_def+1,line_ceiling)
     .			/lines_left*.FALSE./
	DATA	(line_dim_only(i),i=nlne_def+1,line_ceiling)
     .			/lines_left*.FALSE./
	DATA	(line_allocated(i),i=nlne_def+1,line_ceiling)
     .			/lines_left*0/

	DATA	(line_t0(i),i=nlne_def+1,line_ceiling)
     .			/lines_left*char_init20/

	DATA	 line_cal_name(0)  /'GREGORIAN'/
	DATA	(line_cal_name(i),i=nlne_def+1,line_ceiling)
     .			/lines_left*'GREGORIAN'/

	DATA	(line_shift_origin(i),i=1,line_ceiling)
     .			/line_ceiling*.FALSE./

	DATA	(line_tunit(i),i=nlne_def+1,line_ceiling)
     .			/lines_left*real4_init/

	DATA	(line_modulo(i),i=nlne_def+1,line_ceiling)
     .			/lines_left*.FALSE./

	DATA	(line_modulo_len(i),i=nlne_def+1,line_ceiling)
     .			/lines_left*0.0D0/
     
	DATA	(line_dattype(i),i=1,line_ceiling)
     .			/line_ceiling*outtype/

	DATA	(line_dsg_dset(i),i=1,line_ceiling)
     .			/line_ceiling*pline_not_dsg/

	DATA	(grid_name(i),i=ngrd_def+1,grid_ceiling)
     .			/grids_left*char_init16/

* 11/16 *sh* commented these out to speed compilation
!	DATA	((grid_line(i,j),i=1,nferdims),j=ngrd_def+1,grid_ceiling)
!     .			/grid_lines_left*int4_init/
!
!	DATA	(grid_rotation(i),i=ngrd_def+1,grid_ceiling)
!     .			/grids_left*real4_init/
!
!	DATA	((grid_out_prod(i,j),i=1,nferdims),j=ngrd_def+1,grid_ceiling)
!     .			/grid_lines_left*.FALSE./

* DEFINE LINE AND BOX COORDS NEXT TO LAST

* MONTH_IRREG

* on startup, allocate these lines dynamically and store the following coordinates

*  COORDS FOR MONTH_IRREG

	DATA	(clim_line_coords( i,clmirr ), i=1,12)
     .	/     15.5, 45.12125, 74.7425, 105.2425, 135.7425, 166.2425, 
     .	     196.7425, 227.7425, 258.2425, 288.7425, 319.2425, 349.7425/

*  BOX BOUNDARIES FOR MONTH_IRREG
	DATA	(clim_line_edges ( i,clmirr ), i=1,13)
     .	/     0.0, 31.0, 59.2425, 90.2425, 120.2425, 151.2425, 
     .	    181.2425, 212.2425, 243.2425, 273.2425, 304.2425, 
     .	    334.2425, 365.2425/

    
* MONTH_GREGORIAN
     
*  COORDS FOR MONTH_GREGORIAN

	DATA	(clim_line_coords( i,clmgrg ), i=1,12)
     .	/     15.5, 45.12125, 74.7425, 105.2425, 135.7425, 166.2425, 
     .	     196.7425, 227.7425, 258.2425, 288.7425, 319.2425, 349.7425/

     
*  BOX BOUNDARIES FOR MONTH_GREGORIAN
	DATA	(clim_line_edges ( i,clmgrg ), i=1,13)
     .	/     0.0, 31.0, 59.2425, 90.2425, 120.2425, 151.2425, 
     .	    181.2425, 212.2425, 243.2425, 273.2425, 304.2425, 
     .	    334.2425, 365.2425/

* MONTH_NOLEAP
     
*  COORDS FOR MONTH_NOLEAP
	DATA	(clim_line_coords( i,clmnol ), i=1,12)
     .	/     15.5,  45.0,  74.5, 105.0, 135.5, 166.0, 196.5, 
     .	     227.5, 258.0, 288.5, 319.0, 349.5/

*  BOX BOUNDARIES FOR MONTH_NOLEAP
	DATA	(clim_line_edges ( i,clmnol ), i=1,13)
     .	/     0.0, 31.0, 59.0, 90.0, 120.0, 151.0, 181.0, 
     .      212.0, 243.0, 273.0, 304.0, 334.0, 365.0/


* MONTH_ALL_LEAP
    
*  COORDS FOR MONTH_ALL_LEAP
	DATA	(clim_line_coords( i,clmall ), i=1,12)
     .	/     15.5, 45.5, 75.5, 106.0, 136.5, 167.0, 197.5, 
     .       228.5, 259.0, 289.5, 320.0, 350.5/

*  BOX BOUNDARIES FOR MONTH_ALL_LEAP
	DATA	(clim_line_edges ( i,clmall ), i=1,13)
     .	/     0.0, 31.0, 60.0, 91.0, 121.0, 152.0, 182.0, 213.0, 
     .      244.0, 274.0, 305.0, 335.0, 366.0/

* MONTH_JULIAN
     
*  COORDS FOR MONTH_JULIAN
	DATA	(clim_line_coords( i,clmjul ), i=1,12)
     .	/         15.50,  45.25,  74.75, 105.25, 135.75, 166.25, 
     .           196.75, 227.75, 258.25, 288.75, 319.25, 349.750/

*  BOX BOUNDARIES FOR MONTH_JULIAN
	DATA	(clim_line_edges ( i,clmjul ), i=1,13)
     .	/     0.0, 31.0, 59.25, 90.25, 120.25, 151.25, 181.25, 
     .      212.25, 243.25, 273.25, 304.25, 334.25, 365.25/

* Miscellaneous (axis orientations)

	DATA 	axis_orients(  1 )	/ 'WE' /,   ! west to east
     .          axis_orients(  2 )	/ 'SN' /,   ! south to north
     .          axis_orients(  3 )	/ 'DU' /,   ! down to up
     .          axis_orients(  4 )	/ 'TI' /,   ! time (always forward)
     .          axis_orients(  5 )	/ 'EE' /,   ! Ensemble
     .          axis_orients(  6 )	/ 'FI' /,   ! Forecast
     .          axis_orients(  7 )	/ 'UD' /,   ! up to down
     .          axis_orients(  8 )	/ 'NA' /,   ! not applicable
     .          axis_orients(  9 )	/ 'NA' /    ! ... unused slot ...   

	DATA	axis_dimname( 1 )	/ 'X'	/,
     .		axis_dimname( 2 )	/ 'Y'	/,
     .		axis_dimname( 3 )	/ 'Z'	/,
     .		axis_dimname( 4 )	/ 'T'	/,
     .		axis_dimname( 5 )	/ 'E'	/,
     .		axis_dimname( 6 )	/ 'F'	/

	END

	SUBROUTINE SETUP_COLOR_TABLE (zwsid,ndx_lo,range)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Sets the color map between ndx_lo and ndx_hi -- GKS FORTRAN binding
*	J Davison JISAO/PMEL/TMAP 4.29.88/6.15.88

*	Completely rewritten J Davison 7.27.89
*	Mod JD 4.18.90 allowing only one shade level
*       Mod JD 10.98 setup by percent, by_value, or by_level
* V63  *acm* 10/09 Changes for gfortran build

        include         'parampl5_dat.decl'
        include         'PARAMPL5.DAT'
        include         'shade_vars.cmn'
        include         'cont_inc.decl'
        include         'CONT.INC'

	integer		zwsid,ndx_lo,range,ndx,t_cl,cl_0
	integer		ndx_hi,ndx_lop1,ndx_him1

 	real		del_lvl,lvl
	real		r_inc,g_inc,b_inc,r_val,g_val,b_val

******************************************************************************
	
	if (rgb_mapping .eq. percent) then
*          SMOOTHLY INTERPOLATE COLORS TO RANGE
	   ndx_hi       = ndx_lo + range - 1
	   ndx_lop1	= ndx_lo + 1
	   ndx_him1	= ndx_hi - 1

	   if (range .eq. 2) goto 100
	   if (range .le. 1) goto 101
	   cl_0	        = 1
	   lvl	        = 0.0
	   del_lvl	= 100.0/real (range - 1)

*	   SET ALL COLORS IN SPECTRUM EXCEPT FIRST AND LAST

	   do 50 ndx = ndx_lop1,ndx_him1
	      lvl = lvl + del_lvl
	   
*	      LOCATE THIS LEVEL IN THE SPECIFIED SPECTRUM LEVELS
	      do 10 t_cl = cl_0,ncl-1
		 if (lvl .lt. slvl(t_cl+1)) then
		    cl_0 = t_cl
		    goto 20
		 end if
 10	      end do

*             FIND THE R,G,B VALUES TO SET THIS LEVEL
 20	      r_inc	= (sr(cl_0+1) - sr(cl_0))/(slvl(cl_0+1) - slvl(cl_0))
	      g_inc	= (sg(cl_0+1) - sg(cl_0))/(slvl(cl_0+1) - slvl(cl_0))
	      b_inc	= (sb(cl_0+1) - sb(cl_0))/(slvl(cl_0+1) - slvl(cl_0))
	      
	      r_val	= sr(cl_0) + r_inc*(lvl - slvl(cl_0))
	      g_val	= sg(cl_0) + g_inc*(lvl - slvl(cl_0))
	      b_val	= sb(cl_0) + b_inc*(lvl - slvl(cl_0))

*             NOW SET THE COLOR OF THIS INDEX/LEVEL
	      call gscr (zwsid,ndx,r_val,g_val,b_val)
 50	   end do

*	   SET R,G,B FOR FIRST AND LAST LEVELS
 100	   call gscr (zwsid,ndx_hi,sr(ncl),sg(ncl),sb(ncl))
 101	   call gscr (zwsid,ndx_lo,sr(1),sg(1),sb(1))

	else if (rgb_mapping .eq. by_value) then
	   if (ncl .eq. 0) then
	      ncl = 2
	      slvl(1) = zlev(1)
	      slvl(2) = zlev(nlev2)
	   end if

*          SMOOTHLY INTERPOLATE COLORS TO RANGE
	   ndx_hi       = ndx_lo + range - 1
	   ndx_lop1	= ndx_lo + 1
	   ndx_him1	= ndx_hi - 1

	   if (range .eq. 2) goto 200
	   if (range .le. 1) goto 201
	   cl_0	        = 1

*	   SET ALL COLORS IN SPECTRUM EXCEPT FIRST AND LAST
	   do 150 ndx = ndx_lo,ndx_hi
	      lvl = zlev(ndx - ndx_lo + 1)
	   
*	      LOCATE THIS LEVEL IN THE SPECIFIED SPECTRUM LEVELS
	      if (lvl .lt. slvl(1)) then
		 call gscr (zwsid,ndx,sr(1),sg(1),sb(1))
	      else if  (lvl .ge. slvl(ncl)) then
		 call gscr (zwsid,ndx,sr(ncl),sg(ncl),sb(ncl))
	      else
		 do 110 t_cl = cl_0,ncl-1
		    if (lvl .lt. slvl(t_cl+1)) then
		       cl_0 = t_cl
		       goto 120
		    end if
 110		 end do

*                FIND THE R,G,B VALUES TO SET THIS LEVEL
 120		 r_inc	= (sr(cl_0+1) - sr(cl_0))
     .  	      /(slvl(cl_0+1) - slvl(cl_0))

		 g_inc	= (sg(cl_0+1) - sg(cl_0))
     .  	      /(slvl(cl_0+1) - slvl(cl_0))

		 b_inc	= (sb(cl_0+1) - sb(cl_0))
     .  	      /(slvl(cl_0+1) - slvl(cl_0))
		 
		 r_val	= sr(cl_0) + r_inc*(lvl - slvl(cl_0))
		 g_val	= sg(cl_0) + g_inc*(lvl - slvl(cl_0))
		 b_val	= sb(cl_0) + b_inc*(lvl - slvl(cl_0))

*                NOW SET THE COLOR OF THIS INDEX/LEVEL
		 call gscr (zwsid,ndx,r_val,g_val,b_val)
	      end if
 150	   end do

	   goto 2000

*	   SET R,G,B FOR FIRST AND LAST LEVELS
 200	   call gscr (zwsid,ndx_hi,sr(ncl),sg(ncl),sb(ncl))
 201	   call gscr (zwsid,ndx_lo,sr(1),sg(1),sb(1))

	else if (rgb_mapping .eq. by_level) then
*	   ATOMIC COLORS -- AS MANY COLORS AS SET IN COLOR PALETTE
	   do 1000 ndx = ndx_lo, ndx_lo + ncl - 1
	      r_val = sr(ndx - ndx_lo + 1)    
	      g_val = sg(ndx - ndx_lo + 1)    
	      b_val = sb(ndx - ndx_lo + 1)    

	      call gscr (zwsid,ndx,r_val,g_val,b_val)
 1000	   end do
	end if

 2000	return
	end

	REAL FUNCTION BOX_SIZE( isubscript, grid, idim )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* given a subscript value on a grid and an axis return the length of the
* grid box

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* revision 0.0 - 12/9/86
* revision 1.0 - 3/10/87 - line data stored in COMMON/~VARIABLES/
* revision 0.2 - 3/23/87 - added new TMAP library: time axes, file var. names
* revision 0.3 - 2/18/88 - incorporated "regular" lines
* revision 1.0 - 1/12/88 - new TM IO library stores box bounds, not sizes
* Unix/RISC port - 1/91 - cant use "/star" in documentation
*                  9/91 - incorporated (missing) modulo axis logic
* V4.20 - 10/95 - remove references to line_mem to permit recursive line defs
*	   1/96 - bug fix: only look at line_parent for dynamic lines
*		           (code would be sweeter if ALL lines had line_parent)
* V510 4/00 *sh* -- all lines now DO have line_parent
*      6/00 *sh* -- bug fix: children of irregular modulo axes 
* V533 6/01 *sh* -- using TM_AXIS_RECURSIVE
* V541  2/02 *sh* -- support for subspan modulo axes
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'ferret.parm'
	include	'xvariables.cmn'

* calling argument declarations:
	INTEGER	isubscript, grid, idim

* internal variable declarations:
	LOGICAL TM_AXIS_RECURSIVE, TM_ITS_SUBSPAN_MODULO, ITSA_TRUEMONTH_AXIS,
     .		recursive, modulo, regular, true_month
	INTEGER	TM_MODULO_LINE_DIM, axis, isub0, llen
	REAL*8	TM_WORLD, lo_point, hi_point

* initialize
	axis = grid_line( idim, grid )
	IF ( axis .EQ. mnormal .OR. axis .EQ. munknown ) THEN
	   BOX_SIZE = bad_val4
	   RETURN
	ENDIF

	true_month = ITSA_TRUEMONTH_AXIS(axis)

* special consideration for sub-span modulo axis outside its core range
	llen = TM_MODULO_LINE_DIM(axis)
	IF (TM_ITS_SUBSPAN_MODULO(axis) ) THEN
	   IF ( isubscript.LT.1 .OR. isubscript.GE.llen ) THEN
	      regular = .FALSE.
	   ELSE
	      regular = line_regular( axis )
	   ENDIF
	ELSE
	   regular = line_regular( axis )
	ENDIF

	IF (true_month) regular = .FALSE.

	IF ( regular ) THEN
* regularly spaced points all have same grid box size
#ifdef double_p
	   BOX_SIZE = ( line_delta( axis ) )
#else
	   BOX_SIZE = SNGL( line_delta( axis ) )
#endif

	ELSE
* irregularly spaced points
* keep subscript within bounds ( between 1 and dimension of axis ) by ...
           IF ( line_modulo( axis ) ) THEN
* ... modulo-ing to the appropriate value
              isub0 = MOD(isubscript-1,llen) + 1
           ELSE
* ... truncating to the appropriate value
	      isub0 = MIN( llen, MAX( 1, isubscript ) )
           ENDIF

* only dynamic lines have the possibility of recursive definitions
* (since FORTRAN doesn't protect "AND" clauses this test in 2 steps)
	   recursive = TM_AXIS_RECURSIVE(axis, true_month)

* use modulo logic if the parent line is modulo (6/00)
	   modulo = line_modulo(axis)
	   IF (recursive) THEN
	      modulo = modulo .OR.
     .		       line_modulo( line_parent(axis) )
	   ENDIF

* use TM_WORLD to compute BOX_SIZE for recursive defs (10/95)

	   IF ( recursive ) THEN
* ... every nth point from an irregular axis --> use midpoints as box bounds
	      IF (isub0.EQ.1 .AND. .NOT.modulo ) THEN
	         lo_point =  TM_WORLD(isub0,   grid, idim, box_lo_lim)
	      ELSE
	         lo_point = (TM_WORLD(isub0,   grid, idim, box_middle) 
     .			  +  TM_WORLD(isub0-1, grid, idim, box_middle)) / 2
	      ENDIF
	      IF ( isub0.EQ.llen .AND. .NOT.modulo ) THEN
	         hi_point =  TM_WORLD(isub0,   grid, idim, box_hi_lim)
	      ELSE
	         hi_point = (TM_WORLD(isub0,   grid, idim, box_middle) 
     .			  +  TM_WORLD(isub0+1, grid, idim, box_middle)) / 2
	      ENDIF
#ifdef double_p
	      BOX_SIZE = (hi_point - lo_point)
#else
	      BOX_SIZE = SNGL(hi_point - lo_point)
#endif
	   ELSE
#ifdef double_p
	      BOX_SIZE = ( TM_WORLD(isub0, grid, idim, box_hi_lim)
     .		             - TM_WORLD(isub0, grid, idim, box_lo_lim) )
#else
	      BOX_SIZE = SNGL( TM_WORLD(isub0, grid, idim, box_hi_lim)
     .		             - TM_WORLD(isub0, grid, idim, box_lo_lim) )
#endif
	   ENDIF

	ENDIF

	RETURN
	END

	SUBROUTINE compute_mnstd(z, badz, need_std, nsize, rbad, status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*

C**
C**
* V630  *acm* 9/09 Introduction of syntax for variance-based and histogram levels
* V664:  8/10 - implement robust method for computing variances (bug 1745)
* V666:  1/11 - fix bug 1778: missing data not treated correctly. Dont use CMZGE,
*               so variance result is the same as other Ferret variance calculations
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus
* V69+ *acm* 7/14 ticket 2186: more-robust mean and std deviation if big outliers
* v695 *acm* 9/15 ticket 2311: variance-based levels for constant variable. Also
*                 improve accuracy of computation using real*4 bad-value sent in from
*                 the Ferret side.
* V698 *acm* 2/16 Re-fix 2186. The fix for 2311 broke the fix for 2186, so the test 
*                 for data outside 3*std correction wasn't made.
* V720 *acm* 2/17 Make sure zmin and zmax have been computed. May not be done yet for 
*                 plot/vs/ribbon plots.
* V751 *acm* 7/19 Call to MINMAX needs final argument, nok

        IMPLICIT NONE
	include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
	include 'hd_inc.decl'
	include 'HD.INC'
	include 'cont_inc.decl'
	include 'CONT.INC'
	include 'miss_inc.decl'
	include 'MISS.INC'

* calling argument declarations:
	LOGICAL need_std
	INTEGER nsize, status
	REAL*8 z(*), badz

* internal variable declarations:
	REAL*8 sum, dev, sumsq_dev, variance, tol_lo, tol_hi, zmean2

	LOGICAL TM_FPEQ_SNGL, TM_FPEQ, zmax_test, zmin_test, ok
	REAL  zero, rbad
	REAL*8 x, xmean, sum2, sumc, variance_c, xdelta, 
     .         z_max_tol, z_min_tol, zlo, zhi
	INTEGER i, n, n2, nok

        IF (.not. need_std .AND. centered) THEN
	   zstd = lev_std
	   zmean = 0.
	   GOTO 5000
	ENDIF

c  Already have zmin, zmax? (not true for ribbon plots...)

	IF (zmin.EQ.0.0 .AND. zmax.EQ.0.0) THEN
	   CALL MINMAX( z, nsize, badz, zlo, zhi, nok )
	   zmin = zlo
	   zmax = zhi
	ENDIF

c if min and max are equal, will use linear levels. No need to issue the warning.

	if (zmin .EQ. zmax) THEN
	   zmean = zmin
	   zstd = 0
	   IF (need_std) status = 0
	   GOTO 5000
	ENDIF

        IF (.not. need_std) GOTO 5000

c Has the user set min or max levels to be used?
c If so take those into account

	zmax_test = .FALSE.
	zmin_test = .FALSE.

	IF (.NOT. TM_FPEQ_SNGL(lev_max, rbad)) THEN
	   zmax_test = .TRUE.
	   z_max_tol = DBLE(lev_max)
	ENDIF
	IF (.NOT. TM_FPEQ_SNGL(lev_min, rbad)) THEN
	   zmin_test = .TRUE.
	   z_min_tol = DBLE(lev_min)
	ENDIF

c Compute data mean.

        sum = 0.0
        n = 0
        DO 100 i = 1, nsize
	   x = z(i)
	   IF ( x .NE. badz) THEN
	      ok = .TRUE.
	      IF (zmax_test .AND. x.GE.z_max_tol) ok = .FALSE.
	      IF (zmin_test .AND. x.LE.z_min_tol) ok = .FALSE.
	      IF (ok) THEN
  	         sum = sum + x
                 n = n + 1
	      ENDIF
	   ENDIF
 100    CONTINUE
        IF (n .EQ. 0) GOTO 5000
#ifdef double_p
        zmean = sum/DBLE(n)
#else
        zmean = sum/FLOAT(n)
#endif

        IF (need_std) THEN

* Compute variance. See http://en.wikipedia.org/wiki/Algorithms_for_calculating_variance

* On-line algorithm with mean subtracted first. Noted as the most robust.
* Since we always compute the mean first anyway, use it.

	   n = 0
	   xmean = 0.D0
	   sum2 = 0.D0
 
	   DO i = 1, nsize
	   x = z(i)
	      IF ( x .NE. badz) THEN
	         ok = .TRUE.
	         IF (zmax_test .AND. x.GE.z_max_tol) ok = .FALSE.
	         IF (zmin_test .AND. x.LE.z_min_tol) ok = .FALSE.
	         IF (ok) THEN
                    n = n + 1
		    x = x - zmean
                    xdelta = x - xmean
                    xmean = xmean + xdelta/FLOAT(n)
                    sum2 = sum2 + xdelta*(x - xmean)  ! This expression uses the new value of mean
 	         ENDIF
 	      ENDIF
	   ENDDO
           variance_c = sum2/FLOAT(n - 1)
	   zstd = SQRT(variance_c)

* Ignore any data outside 3 STD
           
	   tol_lo = zmean - 3.*zstd
	   tol_hi = zmean + 3.*zstd
	   IF (zmin_test) tol_hi = MIN(tol_hi, z_max_tol)
	   IF (zmax_test) tol_lo = MAX(tol_lo, z_min_tol)

c Recompute data mean.
 
	   sum = 0.0
	   n2 = 0
	   DO 200 i = 1, nsize
              x = z(i)
	      IF ( x .NE. badz) THEN
	         ok = .TRUE.
	         IF ( x .GE. tol_hi) ok = .FALSE.
	         IF ( x. LE. tol_lo) ok = .FALSE.
	         IF (ok) THEN
                    sum = sum + x
                    n2 = n2 + 1
                 ENDIF
              ENDIF
  200      CONTINUE

	   IF (n2 .EQ. 0) GOTO 5000
	   IF (n2 .EQ. n) GOTO 4900

#ifdef double_p
	   zmean2 = sum/DBLE(n2)
#else
	   zmean2 = sum/FLOAT(n2)
#endif
	   n2 = 0
	   xmean = 0.D0
	   sum2 = 0.D0
 
	   DO i = 1, nsize
	      x = z(i)
	      IF ( x .NE. badz) THEN
	         ok = .TRUE.
	         IF ( x .GE. tol_hi) ok = .FALSE.
	         IF ( x. LE. tol_lo) ok = .FALSE.
	         IF (ok) THEN
                    n2 = n2 + 1
		    x = x - zmean2
                    xdelta = x - xmean
                    xmean = xmean + xdelta/FLOAT(n2)
                    sum2 = sum2 + xdelta*(x - xmean)  ! This expression uses the new value of mean
 	         ENDIF
	      ENDIF
	   ENDDO

	   IF (FLOAT(n2)/FLOAT(n) .GT. 0.9) THEN
              zmean = zmean2
              variance_c = sum2/FLOAT(n2 - 1)
              zstd = SQRT(variance_c)
           ENDIF

c Once more.
           tol_lo = zmean - 3.*zstd
           tol_hi = zmean + 3.*zstd
	   IF (zmin_test) tol_hi = MIN(tol_hi, z_max_tol)
	   IF (zmax_test) tol_lo = MAX(tol_lo, z_min_tol)
 
           sum = 0.0
           n2 = 0
           DO 300 i = 1, nsize
              x = z(i)
	      IF ( x .NE. badz) THEN
	         ok = .TRUE.
	         IF ( x .GE. tol_hi) ok = .FALSE.
	         IF ( x. LE. tol_lo) ok = .FALSE.
	         IF (ok) THEN
                    sum = sum + x
                    n2 = n2 + 1
                 ENDIF
	      ENDIF
  300      CONTINUE
           IF (n2 .EQ. 0) GOTO 5000
#ifdef double_p
           zmean2 = sum/DBLE(n2)
#else
           zmean2 = sum/FLOAT(n2)
#endif
	   n2 = 0
	   xmean = 0.D0
	   sum2 = 0.D0
 
	   DO i = 1, nsize
	      x = z(i)
	      IF ( x .NE. badz) THEN
	         ok = .TRUE.
	         IF ( x .GE. tol_hi) ok = .FALSE.
	         IF ( x. LE. tol_lo) ok = .FALSE.
	         IF (ok) THEN
		    n2 = n2 + 1
		    x = x - zmean2
                    xdelta = x - xmean
                    xmean = xmean + xdelta/FLOAT(n2)
                    sum2 = sum2 + xdelta*(x - xmean)  ! This expression uses the new value of mean
 	         ENDIF
	      ENDIF
	   ENDDO

	   IF (FLOAT(n2)/FLOAT(n) .GT. 0.9) THEN
              zmean = zmean2
              variance_c = sum2/FLOAT(n2 - 1)
              zstd = SQRT(variance_c)
           ENDIF

        ENDIF  ! need_std

 4900   CONTINUE

* If user is resetting the mean, do that here
	IF (centered) zmean = 0.

* If the std came out as zero, use linear color levels

	zero = 0.

	IF (need_std) THEN
	   IF ( .NOT. TM_FPEQ(zmean, zero) )  THEN
	      IF (TM_FPEQ_SNGL(zstd/zmean, zero))  GOTO 5010
	   ELSE 
	      x = MAX(ABS(zmin), ABS(zmax))
	      IF (TM_FPEQ(zstd/x , zero) )  GOTO 5010
	   ENDIF 
	ENDIF

 5000	RETURN
	
 5010   status = 0
 
	  CALL WARN(
     . 'Could not compute Std Dev. Data too large or or not within 3 std of computed mean.')
	  CALL WARN('Using linear levels instead.')

	RETURN
	END

	SUBROUTINE LOCATOR (x1,lo_dim,hi_dim,x2,ndx_lo)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Routine to determine nearest neighbor index (lower index)
*	on GRID1 for points on GRID2.

*	Taken from Numerical Recipes, Chapter 3, Section "Search With
*	Correlated Values"

*	J Davison JISAO/PMEL/NOAA
*	5.3.88/8.29.88


	integer		lo_dim,hi_dim,ndx_lo,ndx_mid,ndx_hi,inc

	real*4		x1(lo_dim:hi_dim),x2

	logical		ascnd

********************************************************************************

*	TRUE IF ASCENDING GRID COORDINATES, FALSE OTHERWISE
	ascnd = x1(hi_dim) .gt. x1(lo_dim)
	
*	IF INITIAL GUESS IS NO GOOD, GO IMMEDIATELY TO BISECTION
	if (ndx_lo .lt. lo_dim .or. ndx_lo .gt. hi_dim) then
	   ndx_lo = lo_dim - 1
	   ndx_hi = hi_dim + 1
	   goto 3
	end if

	inc = 1

*	QUICKLY GET A GOOD ESTIMATE FOR LOCATION IN GRID1
	if (x2 .ge. x1(ndx_lo) .eqv. ascnd) then
*	   HUNT UP FOR PLACEMENT IN GRID
1	   ndx_hi = ndx_lo + inc
	   
	   if (ndx_hi .gt. hi_dim) then 
*	      HUNT OVER -- OFF HIGH END OF GRID
	      ndx_hi = hi_dim + 1
	   else if (x2 .ge. x1(ndx_hi) .eqv. ascnd) then
	      ndx_lo = ndx_hi
	      inc    = inc + inc
	      goto 1
	   end if
	else
*	   HUNT DOWN FOR PLACEMENT
	   ndx_hi = ndx_lo
2	   ndx_lo = ndx_hi - inc

	   if (ndx_lo .lt. lo_dim) then
*	      FALL OFF LOW END OF GRID -- HUNT IS OVER
	      ndx_lo = lo_dim - 1
	   else if (x2 .lt. x1(ndx_lo) .eqv. ascnd) then
	      ndx_hi = ndx_lo
	      inc = inc + inc
	      goto 2
	   end if	
	end if

*	USE BISECTION TO DETERMINE EXACT LOCATION IN GRID
3	if (ndx_hi - ndx_lo .eq. 1) return

	ndx_mid = (ndx_hi + ndx_lo)/2
!	if (x2 .gt. x1(ndx_mid) .eqv. ascnd) then ** JD 9.13.89 
	if (x2 .ge. x1(ndx_mid) .eqv. ascnd) then
	   ndx_lo = ndx_mid
	else
	   ndx_hi = ndx_mid
	end if

	goto 3


	end

      SUBROUTINE CD_CONSISTENT_AXIS_ORIENT (dset, reversed, perm, status)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Checks that axis orientation is the same for all grids in the dataset
! it looks like the routine does more than this ...

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - Thermal Modeling and Analysis Program

* revision 0.0 - 1/11 
* V67 1/11 *acm*  Ticket 1774. Changes for making sure axes have the same direction
*                 in all  grids of a dataset.
* V672 8/11 *acm* When reordering axes, dont wipe out an existing axis that is not being moved.
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing
* V698 3/16 *sh*  changed an array declaration to match grid_ceiling change

* argument definitions:
*      dset        - TMAP data set pointer
*      reversed    - logical array to record which axes have reversed coords
*      perm        - user-specified permutation (e.g. "YXZT"=2,1,3,4)
*      status       - return status

* include files
      include 'netcdf.inc'
      include 'tmap_errors.parm'
      include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
      include 'xbuild_grids.cmn'
      include 'xdset_info.cmn_text'
      external xdset_info_data
      include 'xio.cmn_text'
      external xio_data
      include 'xtm_grid.cmn_text'
            include 'xunits.cmn_text'
      external xunits_data
      include 'xdset_info.cd_equiv'

* argument declarations
      LOGICAL  reversed(max_lines:line_ceiling),
     .         already_noted(max_lines:line_ceiling)
      INTEGER dset, perm(*), status

* local variable declarations:

      INTEGER TM_LENSTR1, i, j, igrid, igrid_min, igrid_max, idim, iaxis, 
     .        disordered, reordered, n_in_grid,  
     .        grid_save(nferdims), igrid1, ipos1, igrid2, ipos2, kk, 
     .        iaxis_last, iax, iorder, tmvar, ivar, vartyp, nvdims, 
     .        vdims(8), nvatts, vlen, istat, lastdim, tmplines(nferdims), 
     .        i1, i2, iter, ndim, isave_order, ncheck
      LOGICAL shift_ok, need_iterate, coordvar, all_outflag, permuted
      REAL axes_out_of_order(100)
      CHARACTER vname*128

      INTEGER grid_ndims (max_grids:grid_ceiling), 
     .        line_use_dir(0:3000)


! *sh* 3/2016 It looks as if experimental changes were made
!    in this routine that became permanent parts of it:
! 1. it contains explicit integer values 100, 1001, 3000, 500, 501
!    that do not automatically adjust when the corresponding parameter values
!    are adjusted
! 2. it makes a copy of every grid -- the majority of which have nothing to do
!    with this dataset ==> significant scalablity issue

!      INTEGER copy_of_grids (nferdims, 1001)
      INTEGER copy_of_grids (nferdims,grid_ceiling)   !!!! TEMPORARY  !!!! 

      iter = 0
      reordered = 0

! why are we copying grids that are not used by this dataset?
      DO igrid = 501, grid_ceiling
      DO idim = 1, nferdims
         copy_of_grids(idim, igrid-500) = grid_line(idim, igrid)
      ENDDO
      ENDDO

      DO i = max_lines,line_ceiling
         already_noted = .FALSE.
      ENDDO

      DO i = 1, 100
         axes_out_of_order(i) = 0.
      ENDDO

      DO i = 0, line_ceiling
         line_use_dir(i) = 0
      ENDDO
      DO i = max_grids, grid_ceiling
         grid_ndims(i) = 0
      ENDDO

 1000 CONTINUE
      disordered = 0

      need_iterate = .FALSE.  ! is this the right place to set this?

* Loop over the grids created for this dataset

      igrid = 0               ! to get start of linked list
  10  CALL TM_NEXT_TMP_GRID( igrid, *19)

      DO 100 idim = 1, nferdims
         iaxis = grid_line(idim, igrid)

         IF (iaxis  .GT. 0) THEN
            IF (line_use_dir (iaxis) .EQ. 0) THEN
               line_use_dir(iaxis) = idim
            ELSE
               IF ( line_use_dir(iaxis) .NE. idim) THEN
                  disordered = disordered + 1
                  axes_out_of_order(disordered) = FLOAT(iaxis)
               ENDIF
            ENDIF
         ENDIF
  100 CONTINUE

      GOTO 10
  19  CONTINUE
      
      IF (disordered .EQ. 0) GOTO 2000

      CALL HEAP2_V (axes_out_of_order, 0., disordered)

! Count dimensions of the grids.

      igrid = 0 
  20  CALL TM_NEXT_TMP_GRID( igrid, *29)
      grid_ndims(igrid) = 0
      DO 110 idim = 1, nferdims
         IF (grid_line(idim,igrid) .GT. 0) 
     .            grid_ndims(igrid) = grid_ndims(igrid) + 1 
  110 CONTINUE
      GOTO 20
  29  CONTINUE  ! counting dimensions

      iaxis_last = 0
      iorder = 0
      DO 220 i = 1, disordered
         iorder = iorder + 1
         iaxis = INT(axes_out_of_order(iorder))
	 IF (iaxis.EQ.iaxis_last .OR. iaxis.EQ.0) GOTO 220
         iaxis_last = iaxis

C Axis marked with a direction but is in inconsistent position in grids?
         IF (line_direction(iaxis).NE.'NA' .AND. .NOT.already_noted(iaxis)) THEN
	    vlen = TM_LENSTR1(line_name(iaxis)) 
            CALL TM_NOTE( 'Axis '//line_name(iaxis)(1:vlen)//' marked as '//
     .          line_direction(iaxis), lunit_errors )
            CALL TM_NOTE(
     .          'but it has different directions in grids. '//
     .          'Axes in grids may be inconsistent.', lunit_errors)
            already_noted(iaxis) = .TRUE.
         ELSE

c Find the grid which contains this axis and has the most dimensions.
            igrid1 = 0
            ipos1 = 0
            n_in_grid = 0
	    
            igrid = 0 
  40        CALL TM_NEXT_TMP_GRID( igrid, *49)
            DO 130 idim = 1, nferdims
               IF (grid_line(idim, igrid) .EQ. iaxis .AND. 
     .             grid_ndims(igrid) .GT. n_in_grid) THEN
                  igrid1 = igrid
                  ipos1 = idim
                  n_in_grid = grid_ndims(igrid)
               ENDIF
  130        CONTINUE

            GOTO 40
  49        CONTINUE  ! Grid with this axis and most dimensions

* Adjust grids based on position already determined for the grid with most axes.

            igrid = 0               ! Loop over all grids comparing with grid1
  90        CALL TM_NEXT_TMP_GRID( igrid, *99)
            IF (igrid .NE. igrid1) THEN
               ipos2 = 0
               igrid2 = 0
               DO 150 idim = 1, nferdims
                  IF (grid_line(idim, igrid).EQ. iaxis .AND. 
     .                 idim .NE. ipos1)  THEN
                     igrid2 = igrid
                     ipos2 = idim
                  ENDIF
  150          CONTINUE

               IF (igrid2 .NE. 0) THEN
                  i1 = MIN(ipos1, ipos2)
                  i2 = MAX(ipos1, ipos2)
                  shift_ok = .FALSE.
                  DO 160 idim = i1, i2
                         iax = grid_line(idim,igrid2)

                         IF (grid_line(idim,igrid2) .LE. 0 .OR.
     .                       line_direction(iax) .EQ. 'NA') 
     .                       shift_ok = .TRUE.
  160             CONTINUE
                  IF (shift_ok) THEN
                     DO 170 idim = 1, nferdims
                        grid_save(idim) = grid_line(idim,igrid2)
  170                CONTINUE

                     grid_line(ipos1,igrid2) = grid_line(ipos1,igrid1)
                     line_use_dir(grid_line(ipos1,igrid1)) = ipos1
                     grid_line(ipos2,igrid2) = mpsnorm

                     DO 180 idim = ipos2+1, nferdims
                        IF (grid_save(idim-1).NE.mpsnorm) THEN
                           grid_line(idim-1,igrid2) = grid_save(idim)
			   need_iterate = .TRUE.
			ENDIF
  180                CONTINUE

                     reordered = reordered + 1
                  ELSE
                     vlen = TM_LENSTR1(line_name(iaxis)) 

                     CALL TM_NOTE('Could not adjust grid containing axis '// 
     .                       line_name(iaxis)(1:vlen), lunit_errors)

                     CALL TM_NOTE('Axes in grids may be inconsistent.',
     .                         lunit_errors)
                  ENDIF
                  
               ENDIF  ! igrid2 .ne. 0
            ENDIF
             
            GOTO 90
  99        CONTINUE  ! Loop over all grids comparing with grid1

          ENDIF
  220 CONTINUE ! disordered

      iter = iter + 1
      IF (iter .LT. 10) GOTO 1000
* Here loop back if need_iterate is true.

* Reset ds_grid_start and ds_grid_end

 2000 CONTINUE 
      IF (reordered .GT. 0) THEN
* * * * loop through each variable in this TMAP data set * * *
      DO 250 tmvar = 1,maxvars
         IF ( ds_var_setnum(tmvar) .NE. dset ) GOTO 250
         igrid = ds_grid_number(tmvar)

* Check.  Did we wind up with a different number of axes after
* attempt to fix the grids?

         ncheck = 0
         DO 200 idim = 1, nferdims
	       IF (grid_line(idim,igrid) .GT. 0) ncheck = ncheck + 1
  200     CONTINUE 

         IF (ncheck .NE. grid_ndims(igrid)) THEN
* Issue warnings
            ivar = cd_varid(tmvar)
            CALL CD_GET_VAR_INFO(dset, ivar, vname, vartyp, nvdims,
     .                 vdims, nvatts, coordvar, all_outflag, istat)
            vlen = TM_LENSTR1(vname) 
            CALL TM_NOTE(' ', lunit_errors)
            CALL TM_NOTE('Could not adjust grid for variable '// 
     .                 vname(1:vlen), lunit_errors)
            CALL TM_NOTE('Axes in grids may be inconsistent.',
     .                 lunit_errors)
* Restore grids as they were read. At least the data can be viewed
* and perhaps used to fix the file.

            DO 210 idim = 1, nferdims
	       grid_line(idim,igrid) = copy_of_grids(idim,igrid-500)
  210       CONTINUE 
 
         ENDIF

	 ndim = 0
	 DO 230 idim = 1, nferdims
	    iaxis = grid_line(idim, igrid)
	    ds_grid_start(idim,tmvar) = 1
	    ds_grid_end(idim,tmvar) = 1
            IF (iaxis .EQ. 0) THEN
	       ds_ordering(idim,tmvar) = 0
	    ELSE
	       ds_grid_end(idim,tmvar) = line_dim(iaxis)
	       ndim = ndim + 1
	       isave_order = ds_ordering(ndim,tmvar)  ! want to keep the sign
	       ds_ordering(ndim,tmvar) = idim

	       IF ( reversed(iaxis) ) THEN
	          ds_ordering(ndim,tmvar)
     .			      = -1 * ds_ordering(ndim,tmvar)
               ELSE
	          IF ( perm(idim).NE.unspecified_int4 .AND. perm(idim).LT.0) THEN
		  ds_ordering(ndim,tmvar) = -1 * ds_ordering(ndim,tmvar)
                  ELSE   ! if already had a reversed coord indicated, save that.
                     IF ( (ABS(isave_order) .EQ. ABS(ds_ordering(ndim,tmvar)) )
     .	                 .AND.(isave_order .NE. ds_ordering(ndim,tmvar)) )
     .	               ds_ordering(ndim,tmvar) = isave_order
                  ENDIF
               ENDIF
	    ENDIF

  230    CONTINUE 

* Now apply user-supplied ordering and reversals
	 permuted  = .FALSE.

        lastdim = 0
        DO 240 idim = 1, nferdims
           tmplines(idim) = ds_ordering(idim,tmvar)

           IF (perm(idim).EQ.0 .OR. perm(idim).EQ.unspecified_int4) GOTO 240
           IF ( ABS(perm(idim)) .LE. lastdim ) permuted = .TRUE.
           IF ( perm(idim).NE.unspecified_int4 .AND. perm(idim).LT.0 )
     .		   permuted = .TRUE.
           lastdim = ABS(perm(idim))
 240     CONTINUE

* get the variable name
         IF (permuted) THEN
            ivar = cd_varid(tmvar)
            CALL CD_GET_VAR_INFO(dset, ivar, vname, vartyp, nvdims,
     .                 vdims, nvatts, coordvar, all_outflag, istat)

            vlen = TM_LENSTR1(vname)
            CALL TM_AXIS_ORDER(tmplines, perm, ds_ordering(1,tmvar),
     .                           nvdims, vname(:vlen))
         ENDIF

  250 CONTINUE
      ENDIF

      RETURN
      END

c*
c* ef_get_axis_calendar.F
c*
c* Ansley Manke * 
c* 5/2006
c*
c*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*

c*
c* This routine returns the calendar name, days in year, number of 
c* months and days in each month of a time axis
c*

      SUBROUTINE EF_GET_AXIS_CALENDAR(id, iarg, calname, yrdays, 
     .               mnths, d_in_month)

      IMPLICIT NONE
      INCLUDE 'tmap_dims.parm'
      INCLUDE 'ferret.parm'
      INCLUDE 'xcontext.cmn'
      INCLUDE 'EF_Util.parm'
      INCLUDE 'xtm_grid.cmn_text'
      INCLUDE 'calendar.decl'
      INCLUDE 'calendar.cmn'

* argument declarations
      INTEGER id, iarg
      INTEGER grid, axis, idim
      CHARACTER*(*) calname
      REAL yrdays
      INTEGER mnths, d_in_month(*)

* Internal declarations
      INTEGER TM_GET_CALENDAR_ID, cx_list(EF_MAX_ARGS), cal_id, i

* Initialize
      yrdays = 0.
      mnths = 0.
      DO 100 i = 1, 12
         d_in_month(i) = 0
100   CONTINUE

c* The context list was cached by Ferret and must be retrieved
c* to be accessible to the external function.

      CALL EF_GET_CX_LIST(cx_list)

* Get the grid and if it has a time axis get the calendar info

      grid = cx_grid(cx_list(iarg))
      idim = t_dim
      axis = grid_line(idim, grid) 

      IF (axis .EQ. munknown) THEN
         calname = 'none'

      ELSE IF (axis .EQ. mnormal) THEN
         calname = 'none'

      ELSE
         calname  = line_cal_name(axis)
         cal_id = TM_GET_CALENDAR_ID (calname)
         yrdays = cals_yeardays(cal_id)      
         mnths = cals_num_months(cal_id)

         DO 110 i = 1, mnths
           d_in_month(i) = cals_days_in_month(i,cal_id)
110      CONTINUE

      ENDIF

      RETURN 
      END

	SUBROUTINE READ_EZ (  cx, mr, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* read a file of EZ-type (ASCII or unformatted) data
* return only the requested variable in "mr"
* note: always read and store the entire grid limits of data

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  10/89/89
*	  4/24/90 - bug fix: when this routine determines data limits it must
*			    pass cx_hi_ww(idim,cx) as well as cx_hi_ss(cx,idim)
* V230:   7/15/92 - bug fix: was limited to 99999 record read
*         11/6/92 - increased variable length to 24 characters
* V300:   2/17/93 - bug fix: when requested lo limit exceeds received hi
*         3/12/93 - allow unlimited number of columns using FERRET mem mgmt
*	   5/5/93 - minor bug fix when file has no data and grid is only 1 pt
* V301:  12/21/93 - need to set separate bad value flag for each variable
* V312: 5/94 - array "memory" as a calling argument
* V320: 2/95 - increased number of readable vars from 10 to 20
*	3/95 - fixed bug - reserve "buff" of size "column" instead of "nrepeat"
* V500 *kob* 3/99- up VAR_CODE  to 64 chars
* V510: *sh* 3/00 - bug fix: needless (?) reference to cx_last
*		(see err500_2nd_try.jnl)
* V510: 6/00 *sh* - bug fix trap /COLUMNS= >grid size
* V552 *acm* 4/03- up VAR_CODE  to 128 chars
*       *acm* 3/12 cleanup old VMS ifdef
* V685 *acm* 1/13  Ticket 2030: if we run out of  issue a new message
* V702: *sh* 1/17 - bug fix: mr_protected must *end* at mr_not_in_use (=0)
*		  - for trac enhancement #2369 -- dynamic memory management 

	include	'tmap_errors.parm'
	include	'tmap_dims.parm'
	include	'xdset_info.cmn_text'
	external xdset_info_data
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'
	include	'xtext_info.cmn'

* calling argument declarations:
	INTEGER	cx, mr, status

* internal variable declarations:
	INTEGER 	CGRID_SIZE, CX_DIM_LEN,
     .			idim, ask_var, category, data_set, grid, ivar,
     .			fvar, nvar20, the_var, nleft, nsize,
     .			cx0, cx1, cx20(20), mr20(20), nread,
     .			mr1, ndim, las_dim, fst_dim, dims(nferdims), rec1,
     .			rec_to_read, nrepeat, columns, num_names
	INTEGER*8	i8_size
	CHARACTER	VAR_CODE*128, errbuff*100

* --- end of introductory code ---

* nvar20  and the_var - value from 1 to 20      --> variable # within EZ set
* ask_var and fvar    - value from 1 to maxvars --> var # within DSET common

* initialize
	cx0 = cx_stack_ptr
	data_set = cx_data_set( cx )
	category = cx_category( cx )
	ask_var  = cx_variable( cx )
	grid = cx_grid( cx )
	fvar      = 0
	nvar20    = 0
	rec_to_read = 2**30      ! was 99999 - limited file reads

* how many values of each variable are repeated on each record ?
	columns = ds_ntuple(data_set)
	num_names = ds_basic_axes(1, data_set)
	nrepeat = columns / num_names

* purge from memory any variables from this data set to avoid duplication
* (1 variable may be deleted at any time by memory management but this routine
*  always reads all of 'em)
* note: problem arises if variable is in use
!	CALL PURGE_DSET( data_set )

* create a memory variable for each of up-to-20 variables in the file
	DO 400 ivar = 1, 20

* ... locate the next variable in this data set
	   DO 100 fvar = fvar+1, maxvars
	      IF ( ds_var_setnum( fvar ) .EQ. data_set ) GOTO 110
 100	   CONTINUE
* ... no more
	   GOTO 500

* ... is it a dummy '-' placeholder in the variable list ?
 110	   IF (INDEX( ds_var_code(fvar),'-') .NE. 0 ) GOTO 400

* save record of which is the desired var
	   nvar20 = nvar20 + 1
	   IF ( fvar .EQ. ask_var ) the_var = nvar20

* ... create a context describing this variable
	   CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   cx20(nvar20) = cx_stack_ptr
	   CALL TRANSFER_CONTEXT( cx, cx_stack_ptr )
	   cx_variable( cx_stack_ptr ) = fvar
	   cx_grid( cx_stack_ptr ) = ds_grid_number( fvar )
	   cx_bad_data( cx_stack_ptr ) = ds_bad_flag( fvar )	! 12/93 add'n
	   DO 200 idim = 1, nferdims
	      cx_lo_ss( cx_stack_ptr, idim ) = ds_grid_start( idim, fvar )
	      cx_hi_ss( cx_stack_ptr, idim ) = ds_grid_end  ( idim, fvar )
	      cx_by_ss( idim, cx_stack_ptr ) = .TRUE.
	      CALL CONFINE_AXIS( idim, cx_stack_ptr, status )
	      IF ( status .NE. ferr_ok ) RETURN
	      CALL FLESH_OUT_AXIS( idim, cx_stack_ptr, status )
	      IF ( status .NE. ferr_ok ) RETURN
 200	   CONTINUE

* read only what will fit into smallest grid
	   rec1 = CGRID_SIZE(cx_stack_ptr) / nrepeat
	   rec_to_read = MIN( rec_to_read, rec1 )
	   IF (rec_to_read .LE. 0 ) GOTO 5650

* reserve and catalog space for the result
	   CALL CREATE_MEM_VAR( cx_stack_ptr, mr20(nvar20), status )
	   IF ( status .NE. ferr_ok ) GOTO 5000

 400	CONTINUE

* point to asked-for variable and create dummy entries for the rest
 500	mr = mr20( the_var )
	DO 600 nleft = nvar20+1, 20
 600	mr20(nleft) = dummy_mr
	
* allocate a buffer big enough for one record
	i8_size = columns
        CALL GET_DYN_WORK_SPACE( i8_size, status )	! was "nrepeat" B4 3/95
	IF ( status .NE. merr_ok ) GOTO 5500

* diagnostic output
	IF (mode_diagnostic) CALL DIAGNOSTIC_OUT('reading',mr,point_to_mr)

* read the data via TMAP library routine
	nread = rec_to_read

	CALL EZ_READ( data_set, nread, nrepeat, columns,
     .          workmem(plegacy_work_buffer)%ptr, status,
     .		memry(mr20( 1))%ptr,
     .		memry(mr20( 2))%ptr,
     .		memry(mr20( 3))%ptr,
     .		memry(mr20( 4))%ptr,
     .		memry(mr20( 5))%ptr,
     .		memry(mr20( 6))%ptr,
     .		memry(mr20( 7))%ptr,
     .		memry(mr20( 8))%ptr,
     .		memry(mr20( 9))%ptr,
     .		memry(mr20(10))%ptr,
     .		memry(mr20(11))%ptr,
     .		memry(mr20(12))%ptr,
     .		memry(mr20(13))%ptr,
     .		memry(mr20(14))%ptr,
     .		memry(mr20(15))%ptr,
     .		memry(mr20(16))%ptr,
     .		memry(mr20(17))%ptr,
     .		memry(mr20(18))%ptr,
     .		memry(mr20(19))%ptr,
     .		memry(mr20(20))%ptr  )
	IF ( status .NE. merr_ok ) GOTO 5700

* free up the buffer space
        CALL  RELEASE_DYN_WORK_SPACE

* update the variables with info about the number of records actually read
* (for multi-dimensional grid reads just truncate the last axis best we can)
	IF ( nread .LT. rec_to_read ) THEN
	   DO 700 ivar = 1, nvar20
	      cx1 = cx20(ivar)
	      mr1 = mr20(ivar)
	      CALL GET_CX_DIMS( cx1, ndim, dims )
	      fst_dim = dims(1)
	      IF ( ndim .GT. 0 ) THEN        ! "IF" added 5/5/93
	         las_dim = dims(ndim)
	      ELSE
	         las_dim = fst_dim
	      ENDIF
	      IF ( ndim .EQ. 1 ) THEN
	         nsize = 1
	      ELSEIF( ndim .EQ. 2 ) THEN
	         nsize = CX_DIM_LEN(fst_dim,cx1)
	      ELSE
	         nsize =  CGRID_SIZE(cx1) / CX_DIM_LEN(las_dim,cx1)
	      ENDIF
* ... last dim (each var) is
*     (total values read)/(prod. of all axis lengths except last)
	      cx_hi_ss( cx1, las_dim ) = MAX( 1, nrepeat*nread/nsize )
	      CALL FLESH_OUT_AXIS( las_dim, cx1, status )
	      IF ( status .NE. ferr_ok ) GOTO 6000
	      mr_hi_ss( mr1, las_dim ) = cx_hi_ss( cx1, las_dim )
	      mr_hi_ww( las_dim, mr1 ) = cx_hi_ww( las_dim, cx1 )
* ... also let the TMAP library know how much is there
	      ds_grid_end(las_dim, mr_variable(mr1)) = cx_hi_ss( cx1, las_dim )
 700	   CONTINUE
	ENDIF

* flag that all the data is available
	DO ivar = 1, nvar20
	   mr1 = mr20(ivar)
	   CALL MR_AVAILABLE(mr1)
	ENDDO

* the data region obtained may be inadequate for the request
* ("cx" is request, "cx1" is available)
	cx1 = cx20(the_var)
	DO 900 idim = 1, nferdims
	   IF ( cx_hi_ss(cx,idim) .GT. cx_hi_ss(cx1,idim) ) THEN
	      IF ( cx_given(idim,cx) ) THEN  ! 3/00 cut mystery cx_last ref.
* ... error: the user explicitly requested more than there is
	         GOTO 5600
              ELSEIF (cx_lo_ss(cx,idim) .GT. cx_hi_ss(cx1,idim)) THEN
* ... requested data is completely out of range of disk data (2/93 bug fix)
                 GOTO 5600
	      ELSE
* ... no error: the region was filled in by FERRET automatically
	         cx_hi_ss(cx,idim) = cx_hi_ss(cx1,idim)
	         cx_hi_ww(idim,cx) = cx_hi_ww(idim,cx1)
	      ENDIF
	   ENDIF
 900	CONTINUE

* successful completion
	cx_stack_ptr = cx0
	RETURN

* error exit
 4900	nvar20 = nvar20 + 1		! delete all
 5000	cx_stack_ptr = cx0
	IF (nvar20 .GT. 1) THEN
	   WRITE ( errbuff, 1000 ) nvar20
           CALL WARN (errbuff)
	ENDIF
 1000   FORMAT ('ASCII file reading: Insufficient memory reading variable ', i4)
	DO 5010 nleft = 1, nvar20-1	! delete all except last
 5010	CALL DELETE_VARIABLE(mr20(nleft))
        CALL  RELEASE_DYN_WORK_SPACE
 5500	RETURN
 5600	CALL ERRMSG( ferr_limits, status,
     .		ww_dim_name(idim)//' axis of '//VAR_CODE(cat_file_var,ask_var),
     .		*5500 )
 5650	CALL ERRMSG( ferr_limits, status,
     .		'/COLUMNS is impossibly large', *5500 )
 5700	CALL ERRMSG( ferr_TMAP_error, status, ' ', *4900 )
 6000	CALL ERRMSG( ferr_internal, status, 'READ_EZ ??', *4900 )
	END	

        SUBROUTINE SHADE_SET

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*

*       Sets the options for SHADE -- fill_missing, custom_colors
*       J Davison JISAO/PMEL/TMAP 8.24.88
*	Completely rewritten J Davison 7.27.89
*       *JD* 4.22.91 Take out fill area rep setting for metafiles -- 
*				new translator
*	*jd* 3.93 Exchange DEFAULT and SPECTRUM code positions for FERRET
*	*jd* SPECTRA is now FER_PALETTE
*       *jd* eliminate call meta_protect for xgks -- but haven't replaced
*			functionality with other code
*	*jd* 6.94 add option to have comments in .spk files -- !-begun lines
*       *jd* 10.98 Add control for rgb interpolation, atomic colors, or data
*                 based levels in color bar
*       *acm* 9/02 Check that the number of levels in a palette file isn't 
*                  larger than SPEC_SIZE (see shade_vars.cmn), the number 
*                  of spectrum levels allowed to be specified in a palette file.
* v552 *acm* 3/03 Longer strings: changes for multi-line labels.
* V602: *acm* 1/07 Changes for metafile-batch mode
* V608: *acm*11/07 the text for RGB_mapping must be palette, by_value, or by_level; issue
*                  a warning if its not one of these. Fixes bug 1549
* V610  *acm* 3/08 Fixes for metafile batch mode

        include         'shade_vars.cmn'
        include 	'cmrdl_inc.decl'            
        include 	'CMRDL.INC'            
        include 	'gkscm1_inc.decl'            
        include 	'GKSCM1.INC'            
        include 	'gkscm2.cmn'            


#ifdef atc_gks
#   ifdef unix
	include        'gkspar.inc'
#   else
	INCLUDE        'atc_gksdir:gkspar.inc'
#   endif
#else
#   ifdef unix
  	include        'gkspar.inc'
#   else
  	INCLUDE        'sys$library:gksdefs.bnd'
#   endif
#endif

       	logical		there
        integer         beg,end                            
        character*2048   str                                

******************************************************************************

      	call upnsquish (label,str,end)
        call squish (label,1,2048)

*	IF NO LABELS IN THE SHASET COMMAND THEN PROCESS LEVELS AS SPECIFIED
	if (end .eq. 0) then
	   call shade_levels
	   goto 10
	end if

*	IF RGB MAPPING MODIFIED, SET FLAG
	beg = index (str,'RGB_MAPPING')
	if (beg .ne. 0) then
	   call shade_mapping  (str)
	   goto 10
	end if

*	IF A SPECTRUM IS TO BE READ, DO THAT AND SET LEVELS
	beg = index (str,'SPECTRUM')
	if (beg .ne. 0) then
	   call shade_read (label,beg,end,there)
	   if (.not.there) return
	   goto 10
	end if

*	OTHERWISE: IF DEFAULT COLORS REQUESTED, SET THEM
	beg = index (str,'DEFAULT')
	if (beg .ne. 0) then
	   call shade_default
	   goto 10
	end if

*	IF A SPECTRUM IS TO BE SAVED, DO THAT
	beg = index (str,'SAVE')
	if (beg .ne. 0) then
	   call shade_save (label,beg,end)
	   return
	end if

*	IF A SPECTRUM IS TO BE PROTECTED OR UNPROTECTED, DO THAT
	if (str .eq. 'PROTECT' .or. str .eq. 'RESET') then
	   call shade_protect_reset (str)
	   return
	end if

10      CALL GQOPS (istate)  ! In batch mode the graphics may not be active now. 
        IF (istate .GE. 2) THEN

*       SET THE SHADES                                                
#ifdef atc_gks
	   call gsds (wsid,gasti,gallow) !This action necessary?
	   if (.not. protect_used_colors) call set_fill_area_rep (wsid,wstype)
	   call gsds (wsid,gasap,gsuppd)   
                                                          
#else
 	   if (.not. protect_used_colors) 
     .   	call set_fill_area_rep (wsid,wstype)
           if (meta_actv) call guwk (wsid,gpostp)	

#endif
*4.91   if (meta_actv) call set_fill_area_rep (meta_wsid,meta_wstype)

        ENDIF
	return
	end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	SUBROUTINE SHADE_LEVELS 

        include         'parampl5_dat.decl'
        include         'PARAMPL5.DAT'
        include         'cont_inc.decl'
        include         'CONT.INC'
        include         'shade_vars.cmn'
	include		'cmrd_inc.decl'
	include		'CMRD.INC'

	include 'errmsg.parm'

	integer		i,j

        CHARACTER*100   err_msg

*******************************************************************************

	custom_colors = .true.

*	NO PARAMETERS RESETS SPECTRUM TO GRAY SCALE
	if (m .eq. 0) then
           if (rgb_mapping .eq. by_value) then
              ncl = 0
           else
              ncl = 2
              if (rgb_mapping .eq. by_level) then
                 slvl(1) = 1.0
                 slvl(2) = 2.0
              else
                 slvl(1) = 0.0
                 slvl(2) = 100.0
              end if
           end if
           
           sr(1) = 0.0
           sg(1) = 0.0
           sb(1) = 0.0
           
           sr(2) = 1.0
           sg(2) = 1.0
           sb(2) = 1.0
           
           return
        end if
        
*       LISTING ONLY THE FIRST PARAMETER DELETES THAT LEVEL
	if (m .eq. 1) then
           if (rgb_mapping .eq. percent .and. 
     .          (p(1) .eq. 0.0 .or. abs(p(1)) .ge. 100.0)) return

           if (ncl .eq. 1) then
              ncl = 0
           else if (ncl .gt. 1) then
              do 5 i = 1,ncl
                 if (p(1) .eq. slvl(i)) then
                    ncl = ncl - 1
                    do 1 j = i,ncl
                       slvl(j) = slvl(j+1)
                       sr(j) = sr(j+1)       
                       sg(j) = sg(j+1)       
                       sb(j) = sb(j+1)       
 1                  end do
                    return
                 end if
 5            end do
           end if
        end if

*	NEED COMPLETE SET OF ARGUMENTS OTHERWISE
	if (m .ne. 4) return

*	REJECT PERCENT OF SPECTRUM OUTSIDE 0 TO 100	
	if (rgb_mapping .eq. percent .and. 
     .       (p(1) .lt. 0.0 .or. p(1) .gt. 100.0)) return

*	REJECT PERCENT OF R,G,B OUTSIDE 0 TO 100
	if (p(2) .lt. 0.0 .or. p(2) .gt. 100.0) return
	if (p(3) .lt. 0.0 .or. p(3) .gt. 100.0) return
	if (p(4) .lt. 0.0 .or. p(4) .gt. 100.0) return

*	IF FIRST VALUE, ENTER INTO TABLE
        if (ncl .eq. 0) then
           slvl(1) = p(1)
           sr(1) = p(2)/100.0
           sg(1) = p(3)/100.0
           sb(1) = p(4)/100.0
           ncl = 1

           return
        end if
       
*	REPLACE OLDER VALUES WITH NEW IF RESPECIFIED
	do 10 i = 1,ncl
	   if (p(1) .eq. slvl(i)) then
	      sr(i) = p(2)/100.0
	      sg(i) = p(3)/100.0
	      sb(i) = p(4)/100.0

	      return
	   end if
10	end do

*	IF NEW, INSERT INTO PROPER LOCATION IN SPECTRUM
	do 20 i = 1,ncl-1
	   if (p(1) .lt. slvl(i+1)) then  
	      do 15 j = ncl,i+1,-1
		 slvl(j+1) = slvl(j)
		 sr(j+1) = sr(j)
		 sg(j+1) = sg(j)
		 sb(j+1) = sb(j)
15	      end do
	      ncl = ncl + 1
              IF (ncl .GT. spec_size) GOTO 1000

	      slvl(i+1) = p(1)
	      sr(i+1) = p(2)/100.0
	      sg(i+1) = p(3)/100.0
	      sb(i+1) = p(4)/100.0

	      return
	   end if
20	end do
          
        if (p(1) .gt. slvl(ncl)) then 
           ncl = ncl + 1
           IF (ncl .GT. spec_size) GOTO 1000
           
           slvl(ncl) = p(1)
           sr(ncl) = p(2)/100.0
           sg(ncl) = p(3)/100.0
           sb(ncl) = p(4)/100.0
        end if
 
 5000	RETURN
        
 1000	WRITE (err_msg, 110)  spec_size 
  110   FORMAT ('Too many spectrum levels in .spk file. Max is', i4)
        CALL ERRMSG( ferr_prog_limit, status,
     .		err_msg, *5000 )
	END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	SUBROUTINE SHADE_DEFAULT

        include         'shade_vars.cmn'


*******************************************************************************

	custom_colors = .false.
	return
	end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	SUBROUTINE SHADE_MAPPING  (str)

* Set mapping for color bar:
*     PERCENT    -> 0
*     BY_VALUE   -> 1
*     BY_LEVEL   -> 2

#ifdef unix
        include         'shade_vars.cmn'
#else
        INCLUDE         'tmap_pplv11inc:tmap_shade_vars.inc'
#endif

        character*2048   str

*******************************************************************************

	if (index (str, 'PERCENT') .ne. 0) then
           rgb_mapping = percent
           goto 10
	end if

        if (index (str, 'BY_VALUE') .ne. 0) then
           rgb_mapping = by_value
           goto 10
	end if

        if (index (str, 'BY_LEVEL') .ne. 0) then
           rgb_mapping = by_level
           goto 10
	end if

 10     return
	end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	SUBROUTINE SHADE_READ (str,beg,end,there)

*	Mod *jd* 10.92 to allow memory reads
*	Mod *jd* 3.1.93 to use tm_inq_path

        include 	'tmap_errors.parm'    
	include		'cmrd_inc.decl'
	include		'CMRD.INC'
        include         'shade_vars.cmn'

	logical		there
	integer		beg,end,i,j,speclen,lnblk,status
        integer         test_end
	character*2048	str,sfile,instr,label,specdir,tm_inq_path
        character*2048   test_str
	external 	lnblk

        integer         mapping,percentage,value,level 
        INTEGER         TM_LENSTR1, ilen, slen
*******************************************************************************

*       DEFAULT MAPPING IS PERCENT FOR COMPATIBILITY WITH ORIGINAL SYSTEM
        rgb_mapping = percent
        ncl = 0

*	IF NO FILE NAME GIVEN, READ IN FROM MEMORY
	if (end .lt. 10) then
	   if (mncl .eq. 0) goto 100

	   custom_colors = .true.
	   ncl = mncl
           rgb_mapping = mrgb_mapping

	   do 4 i = 1,ncl
	      slvl(i) = mslvl(i)
	      sr(i) = msr(i)/100.0
	      sg(i) = msg(i)/100.0
	      sb(i) = msb(i)/100.0
4	   end do

	   there = .true.
	   return
	endif
************** Modified to use tm_inq_path *jd* 3.1.93 ***************
*#ifdef unix
*        call getenv ('SPECTRA',specdir)
*        speclen = lnblk (specdir,2048)
*	sfile = specdir(:speclen)//'/'//str(beg+9:end)//'.spk'
*	inquire (file=sfile,exist=there)
*	if (there) goto 5

*	sfile = str(beg+9:end)//'.spk'
*	inquire (file=sfile,exist=there)
*	if (.not.there) goto 100
*#else
*	sfile = 'spectra:'//str(beg+9:end)//'.spk'
*	inquire (file=sfile,exist=there)
*	if (.not.there) goto 100
*#endif
***************** end mod 3.1.93 **************************************

	sfile = tm_inq_path (str(beg+9:end),'FER_PALETTE','.spk',
     .	.false.,status)
*	type *, sfile,str(beg+9:end),status,merr_ok
	if (status .ne. merr_ok) go to 100
	there = .true.

*	OPEN THE FILE
#ifdef atc_gks
 5      open (70,file=sfile,status='old',err=100)
#else
#ifdef NO_OPEN_READONLY
 5      open (70,file=sfile,status='old',err=100)
#else
 5      open (70,file=sfile,readonly,status='old',err=100)
#endif
#endif

*	NOW READ IN THE LEVELS AND SET THEM
10	read (70,'(a)',end=30,err=90) instr
	do 15 i = 1,80
	   if (instr(i:i) .ne. ' ') then
	      j = i
	      goto 20
	   end if
15	end do
	goto 10

*	PERMIT COMMENTS 
20	if (instr(j:j) .eq. '!') goto 10

*       DETERMINE MAPPING
        call upnsquish (instr,test_str,test_end)
 
        if (index(test_str, 'RGB_MAPPING') .ne. 0) then
 
           percentage     = index (test_str, 'PERCENT')
           value          = index (test_str, 'BY_VALUE')
           level          = index (test_str, 'BY_LEVEL') 

           if (percentage .ne. 0) then
              rgb_mapping = percent
           else if (value .ne. 0) then
              rgb_mapping = by_value
           else if (level .ne. 0) then
              rgb_mapping = by_level
           else
              ilen = TM_LENSTR1(instr)
              slen = TM_LENSTR1(sfile)
              CALL WARN ('RGB_Mapping type not recognized, given '//
     .         'in palette file '//sfile(1:slen)//' as '//instr(1:ilen))
              CALL WARN ('Must be percent, by_value or by_level. '//
     .         'Defaulting to percent')
           endif
              

*	   RESET SPECTRUM TO GRAY SCALE
           if (rgb_mapping .eq. by_value) then
              ncl = 0
           else
              ncl = 2
              if (rgb_mapping .eq. by_level) then
                 slvl(1) = 1.0
                 slvl(2) = 2.0
              else
                 slvl(1) = 0.0
                 slvl(2) = 100.0
              end if
           end if
           
           sr(1) = 0.0
           sg(1) = 0.0
           sb(1) = 0.0
           
           sr(2) = 1.0
           sg(2) = 1.0
           sb(2) = 1.0
           
           goto 10
        end if
        
        call parsex (instr(j:j+79),80,p,iflg,m,label,n)
	call shade_levels
	goto 10

30	close (70)
	return

*	ERROR WITH FILE ACCESS
90	close (70)
100	there = .false.
	write (6,'(/a/)') ' PPL+ error: Unable to read "' //
     .	str(beg+9:end)//'.spk" to set shade and fill colors.'

	return

	end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	SUBROUTINE SHADE_SAVE (str,beg,end)

        include         'shade_vars.cmn'

	integer		beg,end,i
	character*2048	str,sfile


*******************************************************************************

*	WRITE TO MEMORY IF NO FILE NAME GIVEN
	if (end .lt. 6) then
	   mncl = ncl
           mrgb_mapping = rgb_mapping

	   do 10 i = 1,ncl
	      mslvl(i) = slvl(i)
	      msr(i) = sr(i)*100.0
 	      msg(i) = sg(i)*100.0
	      msb(i) = sb(i)*100.0
10	   end do
	   goto 101
	end if

#ifdef unix
	sfile = str(beg+5:end)//'.spk'

*	OPEN THE FILE

#   ifdef atc_gks
	open (70,file=sfile,status='unknown',form='formatted',
     .	err=100)
#   else
#ifdef NO_OPEN_CARRIAGECONTROL
	open (70,file=sfile,status='unknown',form='formatted',
     .	err=100)
#else
	open (70,file=sfile,status='unknown',form='formatted',
     .	carriagecontrol='list',err=100)
#endif
#   endif
#else
	sfile = 'fer_palette:'//str(beg+5:end)//'.spk'

*	OPEN THE FILE
#ifdef NO_OPEN_CARRIAGECONTROL
	open (70,file=sfile,status='new',form='formatted',
     .	err=100)
#else
	open (70,file=sfile,status='new',form='formatted',
     .	carriagecontrol='list',err=100)
#endif
#endif
*	WRITE OUT THE SPECTRUM
        if (rgb_mapping .eq. percent) then
           write(70,'(a/" "/"! SetPt    Red  Green   Blue")') 
     .          'RGB_Mapping Percent'

        else if (rgb_mapping .eq. by_value) then
           write(70,'(a/" "/"! SetPt    Red  Green   Blue")') 
     .          'RGB_Mapping By_value'

        else if (rgb_mapping .eq. by_level) then
           write(70,'(a/" "/"! Level    Red  Green   Blue")') 
     .          'RGB_Mapping By_level'
        end if

        if (rgb_mapping .ne. by_level) then
           do i = 1,ncl
              write (70,'(4f7.1)') slvl(i),
     .             sr(i)*100.0,sg(i)*100.0,sb(i)*100.0
           end do
        else
           do i = 1,ncl
              write (70,'(i7,3f7.1)') i,
     .             sr(i)*100.0,sg(i)*100.0,sb(i)*100.0
           end do
        end if
        
	close (70)
	return

100	write (6,'(/a/)') ' PPL+ error: Unable to save spectrum ' //
     .	str(beg+9:end)//'.spk"'
101	return
	end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	SUBROUTINE SHADE_PROTECT_RESET (str)

        include         'shade_vars.cmn'
	include		'gkscm1_inc.decl'
	include		'GKSCM1.INC'
        include         'gkscm2.cmn'

	character*2048	str

*******************************************************************************

*	PROTECT PREVIOUSLY USED COLORS
	if (str .eq. 'PROTECT') then
	   protect_used_colors = .true.
	else if (str .eq. 'RESET') then
*	SET THEM TO BE REUSED
	   protect_used_colors = .false.
	   lo_color_ndx(wsid) = 0
	   hi_color_ndx(wsid) = 0
	endif

#ifndef xgks
	if (meta_actv .and. .not. meta_clsplt) call meta_protect
#endif

	return
	end

	SUBROUTINE XEQ_STAT

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute the STAT command

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/25/88
* V200:  5/19/89 - 4D symmetrical
*	10/16/89 - set up adjustable array limits with NON_ARRAY_SUBSC
* V312: 5/94 - array "memory" as a calling argument
*       10/26/94 - changed "STAT" to "VAR_STAT" for IBM/AIX
* V420	 2/7/96  - added STAT/BRIEF
* V530: *sh* 9/00 - added initial data type support in get_cmnd_data 
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V720 *acm*  3/17 Ticket 2512: Add STAT/PRECICISION=

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'slash.parm'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'

* calling argument declarations:

* local variable declarations:
	LOGICAL	full
	INTEGER	mv, cx, istat, lp, stat_digits, status
	REAL	value
	
* decode the qualifiers
	full = qual_given( slash_stat_brief ) .EQ. 0

* determine precision for outputting values
* First, use STAT/PREC= setting.
	stat_digits = 0
	lp = qual_given( slash_stat_precision ) 
	IF ( lp .GT. 0 ) THEN
	   CALL EQUAL_VAL( cmnd_buff(qual_start(lp):qual_end(lp)),
     .                     value, status )
           IF ( status .NE. ferr_ok ) GOTO 5000
	   stat_digits = MAX(1.,MIN(value, 16.))	! 1 to 16	   
	ENDIF

* get the requested data somehow
	CALL GET_CMND_DATA (  cx_last, ptype_native, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* compute and display the results
  	DO 400 istat = 1, num_uvars_in_cmnd
	   mv = is_mr( istat )
	   cx = is_cx( istat )
	   CALL NON_ARRAY_SUBSC( mv, 1 )
	   CALL VAR_STAT( memry(mv)%ptr, mv, cx,
     .			  ttout_lun, full, stat_digits, status )
           IF (status .NE. ferr_ok) GOTO 5000
 400	CONTINUE

	RETURN

* error exit(s)
 5000	RETURN
	END

	SUBROUTINE CD_WRITE_DEFER_COORD( cdfid, status )


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Write (deferred) netCDF axis coordinates based upon infermation stored
* in COMMON
* (required for performance since switching between DEFINE and DATA modes
* can be so costly)

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V530 *sh* - 12/00
*	    -  1/01 bug fix -- upper box bound of last coord wrong
* V570 *acm*   5/04 For irregular axes, write bounds coordinate variable, 
*                   dimensioned 2xN
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V65  *acm* 1/10  Make sure parameters values are consistent with 
*                              whats in netcdf.inc from netcdf4.
* V65  *acm* 2/10- all warnings and notes to std error not std out

* argument declarations:
	INTEGER cdfid, status

* include files
        include 'netcdf.inc'
        include 'cdf_tmap.parm'
#include "gt_lib.parm"
        include 'tmap_errors.parm'
	include 'xio.cmn_text'
        include 'xdefer_coords.cmn'

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

* local variable declarations:
	INTEGER	 iax, i, i1000, hilim, cdfstat, box_loc,
     .           start(2), count(2)
	REAL*8   buff(1000)
	REAL*8   TM_WORLD


* put CDF into data mode so coordinates can be written
        CALL CD_SET_MODE(cdfid, pcd_mode_data, status)
        IF ( status .NE. merr_ok ) RETURN

* loop over all of the deferred axes
	DO 500 iax = 1, dfr_num

*   write the coordinates -- buffer 1000 at a time
	  IF (dfr_axis_type(iax) .EQ. pcd_defer_points) THEN
	    box_loc = box_middle
	  ELSEIF (dfr_axis_type(iax) .EQ. pcd_defer_edges) THEN
	    box_loc = box_lo_lim
	  ELSEIF (dfr_axis_type(iax) .NE. pcd_defer_bounds) THEN
	    CALL TM_NOTE( '***IntrnlERR - CD_DEFER_COORD_WRITE',
     .				lunit_errors)
	  ENDIF


* Write coordinates or edges as N by 1 or N+1 by 1

          IF (dfr_axis_type(iax) .EQ. pcd_defer_points .OR.
     .        dfr_axis_type(iax) .EQ. pcd_defer_edges) THEN
             DO 110 i1000 = dfr_lo(iax), dfr_hi(iax), 1000
               hilim = MIN((i1000-1)+1000, dfr_hi(iax))
               DO 100 i = i1000, hilim
 100           buff(i-i1000+1) = TM_WORLD(i, dfr_grid(iax), 
     .			              dfr_idim(iax), box_loc)
#ifdef usingDODSf2cUnderscore
               cdfstat = NF_PUT_VARA_DOUBLE_(cdfid, dfr_cdaxis(iax), 
     .		       i1000-dfr_lo(iax)+1, hilim-i1000+1, buff)
#else
               cdfstat = NF_PUT_VARA_DOUBLE (cdfid, dfr_cdaxis(iax), 
     .		       i1000-dfr_lo(iax)+1, hilim-i1000+1, buff)
#endif
               IF (cdfstat .NE. NF_NOERR) GOTO 5010
 110         CONTINUE

* ... for edge defn tag on the upper bound of the top grid box
	     IF (dfr_axis_type(iax) .EQ. pcd_defer_edges) THEN
                buff(1) = TM_WORLD(dfr_hi(iax), dfr_grid(iax), 
     .			       dfr_idim(iax), box_hi_lim)
#ifdef usingDODSf2cUnderscore
               cdfstat = NF_PUT_VAR1_DOUBLE_(cdfid, dfr_cdaxis(iax),
     .			dfr_hi(iax)-dfr_lo(iax)+2, buff)
#else
               cdfstat = NF_PUT_VAR1_DOUBLE (cdfid, dfr_cdaxis(iax),
     .			dfr_hi(iax)-dfr_lo(iax)+2, buff)
#endif
               IF (cdfstat .NE. NF_NOERR) GOTO 5010
	     ENDIF

* Write bounds as N by 2, 1000 sets buffered at a time.

          ELSEIF (dfr_axis_type(iax) .EQ. pcd_defer_bounds) THEN
             DO 210 i1000 = dfr_lo(iax), dfr_hi(iax), 500
                hilim = MIN((i1000-1)+500, dfr_hi(iax))
                buff(1) = TM_WORLD(i1000, dfr_grid(iax), 
     .			              dfr_idim(iax), box_lo_lim)
                DO 200 i = i1000, hilim
                   buff(2*(i-i1000+1)-1) = TM_WORLD(i, dfr_grid(iax), 
     .			              dfr_idim(iax), box_lo_lim)
 200               buff(2*(i-i1000+1)) = TM_WORLD(i, dfr_grid(iax), 
     .			              dfr_idim(iax), box_hi_lim)


                start(1) = 1
                count(1) = 2
                start(2) = i1000-dfr_lo(iax)+1
                count(2) =  hilim-i1000+1

#ifdef usingDODSf2cUnderscore
                cdfstat = NF_PUT_VARA_DOUBLE_(cdfid, dfr_cdaxis(iax), start,
     .		          count, buff)
#else
                cdfstat = NF_PUT_VARA_DOUBLE (cdfid, dfr_cdaxis(iax), start,
     .		          count, buff)
#endif
               IF (cdfstat .NE. NF_NOERR) GOTO 5010
 210           CONTINUE
           ENDIF

 500	CONTINUE

	dfr_num = 0   ! just house-keeping to be on the safe side

	RETURN
 5010   status = cdfstat
        RETURN
	END

        SUBROUTINE INIT_F_AGGREGATE_DSET(memb_dsetname_var,
     .     nsets, have_expr, dname, dpath, dtitle, agg_dset,
     .     agg_quiet, agg_hide, tline, tmatch, fline, fmatch, status)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* initialize a new ensemble (E) or forecast (F) aggregated dataset
* Aggregation member variables may be a blend of file variables and LET/D vars
* Since the user may alter LET/D definitions after the aggregation has been
* defined, the following approach is taken to processing:
*  1) during DEFINE DATA/AGG the grids of all member variables are determined
*     This means that IS_UVAR_GRID is called for LET/D vars.
*     These grid numbers are stored in the aggregation LIST structures
*     The grids of the variables in the aggregated (parent) dataset are also
*     determined and stored in ds_grid_number as if they are file variables.
*     These grids are "static" as with file variables -- always valid. 
*  2) (TBD as of this writing!!!)==> the use counts of *all* member grids are
*     bumped, so that they cannot be deleted, even if LET/D definitions change
*  3) (TBD as of this writing!!!)==> at get_grid time all of the components
*     of the aggregation are checked to ensure they have a grid (IS_UVAR_GRID) 
*     -- allowing for last-minute LET/D var changes
*  4) during evaluation (in IS_STRIP and IS_AGGREGATE_GATHER) the variable
*     name and member dataset number are used to make a fresh determination of
*     the variable category and grid.  Error out if grid number has changed

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP 
*
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V685 4/13 *acm* Ability to define ensemble with /HIDDEN
*                 Get grid of user-vars, allow more combinations with user vars
*                 better error handling.
* V695 2/15 *acm* Aggregation in either E or F direction, as defined by agg_dim
* V695+ 5/15 *sh* Call GET_AXIS_SPEEDS (pulled out of CHECK_MEMBER_DSETS)
* V695+ 10/15 *sh* rename this routine to INIT_EF_AGGREGATE_DSET
* V698 12/15 *sh* reorganization of code in order to accommodate:
*		  checks of uvar grids delayed until eval
*	          allow for LET/D def changes after DEFINE/AGG (hopefully)
*		  allow dataset list passed as a Ferret string variable
*                 allow forecast datasets out of order (sort em)
*		  allow gaps in the forecast series (insert dummy datasets)
* V698 1/16  *sh* pass explicit path name (for "USE file.agg" compatibility)
*      2/16  *sh* automatically xfer attributes from member vars to agg vars
*      3/16  *sh* trap simple invalid commands
*                 start TBOXLO[L=1], not TBOX[L=1], of agg_lag_t axis at 0.0 
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.
* V741 *acm* 5/18 Promoting global attributes to a variable in ensembles
*                 Clarify the error message at label 5500.
* v74  10/18 *kms* Split E and F aggregation routines

* arguments:
*       memb_dsetname_var - if have_expr, the variable of names (input)
*       nsets             - number of datasets in the aggregation (input)
*       have_expr         - flag if filenames were listed or in an expr (input)
*       dname             - dataset name to assign to the aggregation (input)
*       dpath             - dataset path name to assign to aggregation (input)
*       dtitle            - dataset title (input)
*       agg_dset          - number assigned to this data set (output)
*       agg_quiet         - flag whether to report certain conditions (input)
*       agg_hide          - flag whether to hide the component datasets (input)
*       tline             - the forecasted-time axis to use (input, can be invalid)
*       tmatch            - method of matching times to tline (input, can be empty);
*                           eg, '@ASN', '@BIN', '@XACT', '@XACT:0.001', '@LAG', '@ASN@LAG', ...
*       fline             - the time-of-forecast axis to use (input, can be invalid)
*       fmatch            - method of matching times to fline (input, can be empty);
*                           eg, '@ASN', '@BIN', '@XACT', '@XACT:0.001', '@LAG', '@ASN@LAG', ...
*       status            - return status (output)

      IMPLICIT NONE
	include 'netcdf.inc'
        include 'tmap_errors.parm'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
        include 'ferret.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xdset_info.cd_equiv'
	include 'xunits.cmn_text'
        include 'xprog_state.cmn'
	include 'xtm_grid.cmn_text'  
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xfr_grid.cmn'

* calling argument declarations:
        CHARACTER*(*) dname, dpath, dtitle, tmatch, fmatch
        INTEGER nsets, agg_dset, tline, fline, status
        LOGICAL have_expr, agg_quiet, agg_hide
        REAL memb_dsetname_var(*)

* parameter definitions
	INTEGER	pmaxgaps, pmaxvarsperset
	PARAMETER (pmaxgaps = 10,
     .		   pmaxvarsperset = 400)

* local variable declarations:
	LOGICAL	OK_AS_AGG_VAR, ITSA_TRUEMONTH_AXIS, match, has_uvars
	INTEGER	TM_LENSTR, TM_LENSTR1, STR_SAME,
     .		NCF_ADD_AGG_MEMBER, KNOWN_GRID,
     .		iset, dset1, item, ii, nT, max_str_len,
     .		perm(nferdims), member_sets(nsets+pmaxgaps),
     .		imatch, nv, grid, igrid, idim, ivar, nvars, nuvars, iline, 
     .		slen, memb_var, memb_dset, memb_grid, ugrid, nsets_wgaps,
     .		type, fvar, ndims, recdim, varid, attoutflag,
     .          agg_lag_t, memb_tax,
     .		ref_grid, ref_fvar, ref_fvars(pmaxvarsperset),
     .		num_indices, j, jj, ignored_status

	CHARACTER buff*64, tcoordname*16
	CHARACTER TM_STRING*13
	CHARACTER*512 GET_STRING_ELEMENT_1D_X, memb_dsetname(nsets)
	CHARACTER*128 vname
	REAL*8  TM_WORLD, avg_lag

* initialize
	agg_lag_t = unspecified_int4  ! lag time axis if FMRC
	max_str_len = 512
	nsets_wgaps = nsets
	DO iset = 1, nsets+pmaxgaps
	   member_sets(iset) = pdset_dummy
	ENDDO

* the /TAXIS and /FAXIS options not yet supported for FMRC
        IF ( fline .NE. unspecified_int4 )
     .     CALL ERRMSG(ferr_syntax, status, '/FAXIS option '//
     .             'not currently supported for F-aggregation', *6000)
        IF ( tline .NE. unspecified_int4 )
     .     CALL ERRMSG(ferr_syntax, status, '/TAXIS option '//
     .             'not currently supported for F-aggregation', *6000)

* must have at least two datasets for an F aggregation
        IF ( nsets .LT. 2 ) GOTO 5050

* check to see if this new dataset name matches an already-open dataset name.
* if so, that is an error
	DO iset = 1, maxdsets
           match = ds_name(iset) .EQ. dname
           IF ( match ) GOTO 5100
	ENDDO

* set up array of dataset identifier strings
* these may be string dataset numers or names, pre-init'ed or not
	IF (have_expr) THEN
*  ... dataset list passed through a string variable
	  DO iset = 1, nsets
	    memb_dsetname(iset) = GET_STRING_ELEMENT_1D_X(
     .			nsets,
     .                  memb_dsetname_var,iset,
     .			max_str_len,slen )
	  ENDDO
	ELSE
*  ... dataset names given by user on command line
	  DO iset = 1, nsets
	    memb_dsetname(iset) = cmnd_buff(item_start(iset):item_end(iset))
	  ENDDO
	ENDIF

* See if requested datasets are open and if not, try to open them.
        CALL CHECK_MEMBER_SETS(f_dim, nsets, memb_dsetname,
     .                         member_sets, status)
	IF (status .NE. ferr_ok) GOTO 9950

* forecast aggregation datasets may need to be sorted and gaps detected
	   CALL SORT_FMRC_DSETS (nsets, member_sets, nsets+pmaxgaps,
     .				 nsets_wgaps, nT, status)
	   IF (status .NE. ferr_ok) GOTO 5000

* Assign aggregate data set number, exiting if maximum number 
* of data sets are open
	DO iset = 1,maxdsets
	  IF (ds_name(iset) .EQ. char_init2048) THEN
	    agg_dset = iset
	    GOTO 220
	  ENDIF
	ENDDO
* ... too many data sets are open
      CALL TM_ERRMSG( merr_dsetlim, status, 'INIT_F_AGGREGATE_DSET',
     .			 no_descfile, no_stepfile,
     .			 'MAX='//TM_STRING(DBLE(maxdsets)),
     .			 no_errstring, *9950)
 220	CONTINUE

* Create datset. Will delete it later if there are no aggregate variables found
* Note: the pattern will the first dataset given.  They may get reordered.
	CALL CREATE_AGG_DSET (agg_dset, dname, dpath, dtitle,
     .       nsets_wgaps, member_sets(1), f_dim, iline, status)  
	IF (status .NE. ferr_ok) GOTO 5300

* perform initializations needed on a new dataset
* determine relative access speeds along each axis
	CALL GET_AXIS_SPEED( agg_dset )

* 1st member dset sets pattern for all to follow
	dset1 = member_sets(1)

* If this is a Forecast aggregation create name for the 2D time array
* Make it unique as necessary by adding trailing "_" chars
	   tcoordname = 'TF_TIMES'
	   slen = 8
 250	   CONTINUE
	   DO ivar = 1, maxvars
	      IF (ds_var_setnum(ivar) .EQ. dset1) THEN
	         IF ( STR_SAME(tcoordname,ds_var_code(ivar)) .EQ. 0 ) THEN
	            tcoordname = tcoordname(:slen)//'_'
	            slen = slen + 1
	            GOTO 250
	         ENDIF
	      ENDIF
	   ENDDO

*****
* find variables that are acceptable for aggregation using dset1 as the basis
* an aggregatable var must have at least member dset that is an fvar - ref_fvar
* note LET/D names that duplicate file variable names take precedence, so
*     check them first
	nuvars = 0
!	DO nv = 1, max_uvar      ! brute-force equivalent loop
	CALL deleted_list_get_undel(uvar_num_items_head,
     .                              deleted_list_result(1),
     .                              max_uvar, num_indices )
	DO j = 1, num_indices
	   nv = deleted_list_result(j)
	   IF (uvar_dset(nv) .EQ. dset1) THEN
	      IF (OK_AS_AGG_VAR(nv, cat_user_var, dset1, member_sets,
     .           nsets_wgaps, f_dim, agg_quiet, ref_fvar, status)) THEN
	         nuvars = nuvars + 1
	         ref_fvars(nuvars) = ref_fvar
	      ELSE
	         IF (status .NE. ferr_ok) GOTO 5000
	      ENDIF
	   ENDIF
	ENDDO
	nvars = nuvars

* now find the file variables
	ref_grid = unspecified_int4
        DO nv = 1, maxvars
	   IF (ds_var_setnum(nv) .EQ. dset1) THEN
* ... skip it if it duplicates a name already found as a LET/D variable
	      DO ii = 1, nuvars
	         IF (STR_SAME(ds_var_code(ref_fvars(ii)),
     .			      ds_var_code(nv)           ) .EQ. 0) GOTO 300
	      ENDDO
	      IF (OK_AS_AGG_VAR(nv, cat_file_var, dset1, member_sets,
     .           nsets_wgaps, f_dim, agg_quiet, ref_fvar, status)) THEN
	         nvars = nvars + 1
	         ref_fvars(nvars) = ref_fvar
	      ELSE
	         IF (status .NE. ferr_ok) GOTO 5000
	      ENDIF
	   ENDIF
 300	   CONTINUE
	ENDDO
*****

* If no variables from the datasets match, delete this dataset. 
	IF (nvars .EQ. 0) GOTO 5500

* For forecast aggregations, the time axis of the aggregation 
* is not taken directly from the ensemble members.  Instead it
* is merely a lag axis -- number of time steps and lag per step
	   ref_grid = ds_grid_number(ref_fvars(1))
	   IF (ref_grid .EQ. unspecified_int4) GOTO 5400
	   memb_tax = grid_line(t_dim, ref_grid)
	   avg_lag = ( TM_WORLD(nT, ref_grid, t_dim, box_middle )
     .	             - TM_WORLD(1,  ref_grid, t_dim, box_middle ) )
     .			/(nT-1)
	   CALL TM_NEW_LINE_NAME ( 'AGG_LAG_T', buff )
! pre 3/16	   CALL TM_MAKE_BASIC_AXIS( buff, 0.0D0, avg_lag, nT,
* note that if the FMRC gets aggregated by the THREDDS Data Server this
* code never gets called.  See CD_SCAN_AUX_COORDS for that case.
* If the member axes are true-month axes, make the time axis of the 
* aggregation a daily axis, not true-month.
	   CALL TM_MAKE_BASIC_AXIS( buff, avg_lag/2., avg_lag, nT,
     .				    agg_lag_t, status )
	   line_unit_code(agg_lag_t) = line_unit_code(memb_tax)
	   IF (ITSA_TRUEMONTH_AXIS(memb_tax)) line_unit_code(agg_lag_t) = pun_day
	   line_units(agg_lag_t) = un_name(line_unit_code(agg_lag_t))
	   line_direction(agg_lag_t) = 'TT'
	   line_dattype  (agg_lag_t) = nf_double
	   line_dim_only (agg_lag_t) = .FALSE.  ! indicates netCDF dim w/out var


* register the list of variables found suitable for this aggregation
	ii = 0
	nv = 0
	DO WHILE (ii .LT. nvars)
	   ii = ii + 1
	   nv = nv + 1! kludgy: incremented just below when TF_TIMES is added
	   ref_fvar = ref_fvars(ii)
	   vname = ds_var_code(ref_fvar)
	   grid = ds_grid_number(ref_fvar)
           CALL DEFINE_F_AGGREGATE_GRID(agg_dset, tcoordname, nv,
     .                   vname, ref_fvar, iline, agg_lag_t, grid,
     .                   member_sets, nsets_wgaps, status)
	   IF (status .NE. ferr_ok) GOTO 5000

* transfer to the aggregated variable whatever special attributes it inherits
	   CALL SET_AGG_VAR_ATTS(agg_dset, vname, nv, nsets_wgaps, 
     .			         ref_fvar, member_sets, status)
	   IF (status .NE. ferr_ok) GOTO 9960
	ENDDO

* Promote global attributes to variables in the aggregated dataset. 

        CALL PROMOTE_AGG_GLOBAL_ATTS(agg_dset, nsets_wgaps,
     .            member_sets, f_dim, iline, nvars, status)
	IF (status .NE. ferr_ok) GOTO 5600

* register member datasets to aggregate dataset
	DO iset = 1, nsets_wgaps
	   status = NCF_ADD_AGG_MEMBER (agg_dset, iset, member_sets(iset)) 
	ENDDO
 
* remove duplicate temp grid definitions amd makegrid names unique
        CALL AGG_CLEAN_GRIDS(agg_dset, f_dim, iline, agg_lag_t)

* set use counts and remove temp status of agg grids and axes
	CALL TM_GARB_COL_GRIDS(agg_dset)

* set the official time axis of the dataset
	CALL CD_GET_TIME_AXIS( agg_dset, t_dim, ignored_status )
* (always successful)

* If user requested /HIDE, then mark the member datasets for hidden status
	IF (agg_hide) THEN
	   DO iset = 1, nsets_wgaps
	      ds_hide (member_sets(iset)) = .TRUE. 
	   ENDDO
	ENDIF

* successful completion
	RETURN

* error bail out
* remove all hidden member datasets of the failed aggregation
* ... this is a little brute force in that it may cancel a previously opened
* ... dataset included using DEFINE DATA/AGG/HIDE (havnt checked carefully)
 5000	DO ii = 1, nsets_wgaps
	   iset = member_sets(ii)
	   IF (iset .EQ. pdset_dummy
     .    .OR. iset .EQ. unspecified_int4) CYCLE
	   IF (ds_name(iset) .EQ. char_init2048) CYCLE ! already deleted
	   IF (ds_hide (iset)) CALL CANCEL_ONE_DATA_SET( iset, ignored_status )
	ENDDO
 6000	RETURN

* Errors: too-many datasets open so aggregate dataset can't be opened,
* or error on a member dataset. 
* ?? If some member datasets were opened, close them??)
* Return no-dataset-number.

 9950	agg_dset = unspecified_int4
	status = ferr_TMAP_error
	GOTO 5000
* wipe out the partially-created aggregated dataset
 9960	CALL TM_PURGE_TMP_GRIDS(ignored_status)
	CALL TM_CLOSE_SET_COND_DEALLO( agg_dset, .FALSE., ignored_status )
	agg_dset = unspecified_int4
	GOTO 5000

 5050	CALL ERRMSG( ferr_invalid_command,status,
     .		'cannot F-aggregate a single member dataset', *6000 )

 5100   CALL ERRMSG( ferr_invalid_command,status,
     .		'dataset name already in use: '
     .		//dname(:TM_LENSTR1(dname)), *5000 )
     
 5300	CALL ERRMSG( ferr_aggregate_error, status, ' ', *9950 )


 5400	CALL ERRMSG( ferr_aggregate_error, status,
     .		'No time axis for aggregation',          *9960 )

 5500	CALL ERRMSG( ferr_aggregate_error, status,
     .		'No valid datasets or datasets share no variables '
     .		//'that can be aggregated. ', 
     .		*9960 )

 5600	CALL ERRMSG( ferr_aggregate_error, status,
     .		'Error setting global attributes. ', 
     .		*9960 )

	END

* 
*  expndi_to_et.F
* 
*  Ansley Manke
*  8/31/2016
* DSGTODO  Make use of dsg-handling upgrade

* 
* Expand argument 1 to a 2D E-T variable, using argument 2, a RowSize variable to
* separate the time series, and placing each time series at the correct
* location on the time series defined by argument 3. 
* Typical use is that arg 1 is a collection of time series in a Timeseries DSG
* file, and a common time series variable has been defined for all of the data.
 
*  In this subroutine we provide information about
*  the function.  The user configurable information 
*  consists of the following:
* 
*  descr              Text description of the function
* 
*  num_args           Required number of arguments
* 
*  axis_inheritance   Type of axis for the result
*                        ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                        CUSTOM          - user defined axis
*                        IMPLIED_BY_ARGS - same axis as the incoming argument
*                        NORMAL          - the result is normal to this axis
*                        ABSTRACT        - an axis which only has index values
* 
*  piecemeal_ok       For memory optimization:
*                        axes where calculation may be performed piecemeal
*                        ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE expndi_to_et_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .  'Expand arg1 into a T-E grid defined by Rowsize and Tseries' )

      CALL ef_set_num_args(id, 4)
      CALL ef_set_axis_inheritance_6d(id,
     .                                NORMAL, NORMAL,
     .                                NORMAL, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, NORMAL)
      CALL ef_set_num_work_arrays(id, 2)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'var data')
      CALL ef_set_arg_desc(id, arg, 'Variable to expand, on I axis')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'time data')
      CALL ef_set_arg_desc(id, arg, 
     .          'Timesteps for variable to expand, on same I axis')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'Rowsize (E direction)')
      CALL ef_set_arg_desc(id, arg,
     .          'Length of each individual time series')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, YES, NO)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'Result T')
      CALL ef_set_arg_desc(id, arg,
     .          'A variable on the desired result T axis')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, YES, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE expndi_to_et_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER mth, mtl

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

     
* 
      mtl = arg_lo_ss(T_AXIS,ARG4)
      mth = mtl + (arg_hi_ss(T_AXIS,ARG4) - arg_lo_ss(T_AXIS,ARG4))

*  taxlo
      CALL ef_set_work_array_dims_6d(id, 1,
     .                              mtl, 1, 1, 1, 1, 1,
     .                              mth, 1, 1, 1, 1, 1)

*  taxhi
      CALL ef_set_work_array_dims_6d(id, 2,
     .                              mtl, 1, 1, 1, 1, 1,
     .                              mth, 1, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


* 
*  In this subroutine we compute the result
* 
      SUBROUTINE expndi_to_et_compute(id, 
     .            arg_1, arg_2, arg_3, arg_4,
     .            result, taxlo, taxhi)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id
      
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz,
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz, 
     .           mem4lot:mem4hit, mem4loe:mem4hie, mem4lof:mem4hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

     
      REAL*8 taxlo(wrk1lox:wrk1hix)
      REAL*8 taxhi(wrk2lox:wrk2hix)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l, m, n, i1, k1
      INTEGER index1, index2, lpos
      REAL    sum, count, t1, t2

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      k1 = arg_lo_ss (Z_AXIS,ARG1)  ! unspecified_int4


* make sure arguments 1 and 2 on same grid
      IF ( (arg_lo_ss(X_AXIS,ARG1) .NE. arg_lo_ss(X_AXIS,ARG2))
     . .OR.(arg_hi_ss(X_AXIS,ARG1) .NE. arg_hi_ss(X_AXIS,ARG2)) ) CALL
     .           EF_BAIL_OUT(id, 'X limits of args 1 and 2 mismatched')

      do i = 2,6
         IF ( arg_hi_ss(i,ARG1) - arg_lo_ss(i,ARG1) + 1  .NE. 1
     .    .OR.arg_hi_ss(i,ARG2) - arg_lo_ss(i,ARG2) + 1  .NE. 1 ) CALL
     .     EF_BAIL_OUT(id, 'arguments 1 and 2 must be on X axis only')
      enddo

* make sure RowSize is valid

      sum = 0.
      DO m = arg_lo_ss(E_AXIS,ARG3), arg_hi_ss(E_AXIS,ARG3)
         sum = sum + arg_3(k1,k1,k1,k1,m,k1)
      enddo

      IF (sum .NE. arg_hi_ss(X_axis,ARG1) - arg_lo_ss(X_axis,ARG1) + 1 ) 
     .  CALL EF_BAIL_OUT(id, 'Values of arg 2 must sum to the length of arg 1')

* Get output-axis time coordinates

      CALL ef_get_box_limits(id, ARG4, T_AXIS,
     .   arg_lo_ss(T_AXIS, ARG4), arg_hi_ss(T_AXIS, ARG4), taxlo, taxhi)

* pre-fill the entire output result with missing value flags
*  (since each t-series in the input has different start and end times)

      DO 10 n=res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
      DO 10 m=res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
      DO 10 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
      DO 10 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
      DO 10 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
      DO 10 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
         result(i,j,k,l,m,n) = bad_flag_result
 10   CONTINUE

      i = res_lo_ss(X_AXIS)
      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      n = res_lo_ss(F_AXIS)

* fill in the points 
      

      index1 = 1
      m = res_lo_ss(E_AXIS)
      DO 100 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
         index2 = index1 + INT(arg_3(k1,k1,k1,k1,m,k1)) - 1
	 t1 = arg_2(index1,k1,k1,k1,k1,k1)
	 t2 = arg_2(index2,k1,k1,k1,k1,k1)
	 DO l = arg_lo_ss(T_AXIS,ARG4), arg_hi_ss(T_AXIS,ARG4)
	    IF (t1 .GE. taxlo(l) .AND. t1 .LT. taxhi(l) ) GOTO 123
	 ENDDO
 123	 CONTINUE
         lpos = l

	 if (index2 .GT. res_hi_ss(T_AXIS)) index2 = res_hi_ss(T_AXIS)
	 sum = 0.0
	 count = 0.
	 DO i1 = index1, index2
	    IF (arg_1(i1,k1,k1,k1,k1,k1) .NE. bad_flag(ARG1) ) THEN
	       count = count + 1.
	       sum = sum + arg_1(i1,k1,k1,k1,k1,k1)
	    ENDIF
	 ENDDO

	 IF (count .GT. 0.) THEN 
	    result(i,j,k,lpos,m,n) = sum/count
	 ELSE
	    result(i,j,k,lpos,m,n) = bad_flag_result
	 ENDIF

	 index1 = index2+1

 100  CONTINUE
         


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	CHARACTER*(*) FUNCTION TM_PATH_LIST( path_list, fname, 
     .                               def_ext, do_errmsg, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* locate the file, filename, with default file extension, def_ext
* (it is acceptable for fname to be blank with the full path given in
*  path_list )

* on unix systems path_list may be a list of directories separated be blanks
* on VMS systems it may be a logical name terminated with a colon

* append default file extension, def_ext, if file has none
* (def_ext is assumed to begin with a ".")

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/9/91
*
* revision 1.0 - 10/17/91 <kob> Relative Version Numbers
*
*  Sun Port 1/30/92 -kob-  added 'ifdef sun' because SUN uses BYTE
*                          where DECstation uses INTEGER*1
*  10/21/92 *sh* changed INQUIRE to OPEN/CLOSE because of incompatibility
*                bug between DEC f772.1 INQUIRE and Multinet VMS/nfs files 
*                (search for "f772.1" to find patches)
* 5/93 *sh* removed the INQUIRE bug fix - now on f77 3.0
* 5/93 *sh* 2 weeks later - restore INQUIRE patch - bug still in f77 ?
*          (PLOT+ fails to find default.spk)
* 4/94 *sh* small change in error message to add " (.des)"
* 11/96 *sh* changed ifdef sun to ifdef inquire_not_nfs_compatible
*	     ... maybe the Muktinet problem has been resolved (??
*	     The use of OPEN instead of INQUIRE fails to allow directories
*	     as valid, existing files. This is a problem for Ferret's
*	     LIST/FORMAT=cache/FILE=directory  (DODS caching)
* 7/97 *kob* Minor modification to error reporting.  Don't want to output
*            a default extension, if an explicit extension is used.
* 12/97 - *kob* - added check for "~/xxx" because it was cashing core dump
*  1/99 - js - on PC's, path separator is ';' rather than ' '
* v5.41 5/02 *acm* - If there are .'s within the filename, the logic for adding
*                    the extension is not adequate (statement 50). When file not
*                    found, go back and see if adding the extension works.
* v5.50 10/02 *acm*- path_buff longer to accomodate longer s_filename 
*                    in descript.def
* v5.42 10/02 *kob* - Increase size of temp_fname to 512
* V6.04  7/07 *acm* - increase size of dataset names to 1024. 
* V701  7/16 *kms*  - increase size of dataset names to 2048


* calling argument declarations:
      LOGICAL       do_errmsg
      INTEGER       status
      CHARACTER*(*) path_list, fname, def_ext

**************************** UNIX **********************************

* local variable declarations
      LOGICAL TM_F7721BUG_INQUIRE   ! temporary bug fix for f772.1
      INTEGER slen
      PARAMETER ( slen = 2048 )
      INTEGER TM_LENSTR1, TM_LENSTR
      INTEGER start, end, plen, flen, len_pbuff, postslash, i
      INTEGER tilde, tilde_len, dot,path_len,lext           
      INTEGER vers_int,vers_len,end_tilde,path_tries
      LOGICAL file_exist,pos_ver,zero_ver
      LOGICAL relative, dot_next_to_tilde, retry_ext
      CHARACTER  ext*8, path_buff*(slen),suffix*16,TM_LEFINT*8
      CHARACTER  tilde_buff*8,vers_no*8,temp_fname*(slen)

	
*
#ifdef sun
      BYTE      nhol(slen), vhol(slen),fhol(slen),phol(slen)
                                !c-type Hollerith string buffers
#else
      INTEGER*1 nhol(slen), vhol(slen),fhol(slen),phol(slen)
                                !c-type Hollerith string buffers
#endif
*
      include 'tmap_errors.parm'
#include "gt_lib.parm"

* initialize
      retry_ext = .false.

  60  CONTINUE
*      end = 0          10/91
      end = -1
      path_tries = 0
      plen = LEN( path_list )
      flen = TM_LENSTR1( fname )
      status = merr_erreq
      pos_ver= .false.
      zero_ver = .false.
      dot_next_to_tilde = .false.

* check for relative version number in file name. eg ferret.jnl.~nnn~
* If nnn > or = 0 then relative is false, else it is true.
*
* scan the whole filename and set dot equal to the last period in
* the filename. e.g. for ferret.jnl.~-1~ dot would be 11
      dot = 0
      do 5 i=1,flen
         if (fname(i:i) .EQ. '.')
     .        dot = i
 5              continue
              
* set the tilde buff to be either ".~nnn~" or blank. Also reset filename
* length so that it doesn't include the ".~nnn~"
*
* kob 12/9/97 - "go ~/xxxx" caused a crash, and the reason is that in that 
*                instance, fname is only length 1, so tilde+1 exceeds the 
*                bounds - 
      tilde = INDEX(fname,'~')
      flen = LEN(fname)
      IF (tilde .EQ. flen) THEN
	 end_tilde = INDEX(fname(tilde:), '~')
      ELSE
	 end_tilde = INDEX(fname(tilde+1:), '~')
      ENDIF
      if (dot .EQ. tilde-1) dot_next_to_tilde = .true.

* if tilde eq flen, then this isn't  a relative version issue *kob* 2/98
      if (tilde .EQ. 0 .OR. tilde .EQ. flen) then
         tilde_buff = ' '
      elseif ((tilde .GT. 0) .AND. (dot_next_to_tilde)) THEN
         flen = tilde - 2
         tilde_buff = fname(tilde-1: )
         path_buff = fname(:flen)
      else
         flen = tilde -1
         tilde_buff = fname(tilde: )
         path_buff = fname(:flen)
      endif

* set the relative flag accordingly
      relative = .false.
* if tilde eq flen, then this isn't  a relative version issue *kob* 2/98
      if (tilde .EQ. 0 .OR. tilde .EQ. flen) then
         goto 50
      elseif (fname(tilde+1:tilde+1) .EQ. '0') then
         zero_ver = .true.
      elseif (fname(tilde+1:tilde+1) .NE. '-') then
         pos_ver = .true.
      else
         relative = .true.
      endif   

* apply default extension if filename doesn't have one
* must check if there is a "dot" but ...
* avoid detecting "../path/name" as a significant "dot"

 50      IF ( INDEX( fname(:flen), '.' ) .GT. 0 .AND. 
     .        .NOT. retry_ext)  THEN

         lext = INDEX( fname(:flen), '.' )      ! just to see what this is...
         ext = ' '
         lext= 0
      ELSE
         ext = def_ext
         lext = TM_LENSTR1(ext)
      ENDIF

* does the filename contain its own path ?

      flen = TM_LENSTR1( fname )

      IF ( path_list .EQ. ' ' ) THEN
         IF ( fname .EQ. ' ' ) GOTO 1000   ! INQUIRE bug: blank name exists
         path_buff = fname(:flen)//ext
         end = plen    ! flag not to continue search after one try
         GOTO 200
      ENDIF

* find start of next path text (non-blank)
 100  IF ( end .ge. plen - 2 ) GOTO 1000   ! possible path list truncation
*      DO 101 start = end+1, plen            10/91
      DO 101 start = end+2, plen
 101  IF ( path_list(start:start) .NE. EnvSeparator ) GOTO 110
* no more paths
      GOTO 1000

* find end of path name (last non-blank) (note: mandatory blank at end)
 110  end = INDEX(path_list(start+1:plen), EnvSeparator) + start - 1
      if (end .lt. start) then
         end = plen-1
      endif

* check path name and file name
* note: FORTRAN/RISC compiler doesn't permit // with character*(*)
*      (yet it is working w/ fname(:flen) ... perhaps it requires explicit len
      IF ( fname .EQ. ' ' ) THEN
* ... filename is contained in the path list environment variable
         path_buff = path_list(start:end)
      ELSEIF ( pos_ver) then
            IF (dot_next_to_tilde) then
                path_buff = path_list(start:end)//PathSeparator
     .           //fname(:flen)//ext(:lext)//tilde_buff
            ELSE
                 path_buff = path_list(start:end)//PathSeparator
     .              //fname(:flen)//ext(:lext)//'.'//tilde_buff
            ENDIF
            IF (end_tilde .EQ. 0) THEN
               len_pbuff = TM_LENSTR1( path_buff )
               path_buff = path_buff(:len_pbuff)//'~'
            ENDIF
      ELSE
         path_buff = path_list(start:end)//PathSeparator
     .              //fname(:flen)//ext
      ENDIF

* for relative versions, we need to convert the tilde_buff, filename
* and path list to c strings and pass them in to tm_make_relative_ver
* which will return the proper version number for the file to open
 200  if ( relative) then
            temp_fname = fname(:flen)//ext
            path_len = TM_LENSTR1(temp_fname)
            tilde_len = TM_LENSTR1( tilde_buff )
            CALL TM_FTOC_STRNG( tilde_buff(:tilde_len), nhol, slen)
            CALL TM_FTOC_STRNG(temp_fname(:path_len) , fhol, slen)
            CALL TM_FTOC_STRNG(path_list(start:end),phol,slen)
            call TM_MAKE_RELATIVE_VER(nhol, fhol,phol,vers_int)
*            call TM_CTOF_STRNG( vhol, vers_no, slen)
            vers_no =  TM_LEFINT(vers_int,vers_len)
            path_len = TM_LENSTR1(path_buff)
            path_buff = path_buff(:path_len)//'.'//'~'
     .                      //vers_no(:vers_len)//'~'
         endif
      len_pbuff = TM_LENSTR1( path_buff )
* INQUIRE bug check was added for f772.1 problem.
* the INQUIRE check was commented out 5/13/93 for f77 3.2
* but was restored May 28 cuz the bug was still there
* on June 9 this comment was removed from the ifdef line
* On 11/96 the ifdef sun was changed to ifdef inquire_not_nfs_compatible
* (and the ifdef logic was reversed)
* 7/2007 When increasing length of dataset names, in particular for long 
* DODS file names. Apparently the first argument to INQUIRE cannot be 
* longer than 256, it causes a bus error, overwriting other vars. This
* is handled in the calling routine tm_inq_path.

#ifdef inquire_not_nfs_compatible
! temporary routine needed because of incompatibility between DEC f772.1 and
! Multinet nfs-mounted files (files sometimes not found)  *sh* 10/21/92
      file_exist = TM_F7721BUG_INQUIRE( path_buff( :len_pbuff ) )
#else
      INQUIRE ( FILE		= path_buff( :len_pbuff ) ,
     .			EXIST		= file_exist,
     .			ERR 		= 5000)
* took out NAME statement because v3.0 of f77 didn't dig it ------kob 10/8/91
*     .		   	NAME		= TM_PATH_LIST,
#endif
      IF ( file_exist ) GOTO 1100

* try next path in list
      path_tries = path_tries + 1
      GOTO 100

* file not found
 1000 CONTINUE

* try forcing addition of the default extension -- if there are internal .'s 
* in the filename, the IF test at Statement# 50 is not adequate.  Go back, 
* reinitialize everything, and try again.

      IF (.NOT. retry_ext) THEN
         ext = def_ext
         lext = TM_LENSTR1(ext)
         retry_ext = .TRUE.
         GO TO 60
      ENDIF

* file still not found

      TM_PATH_LIST = ' '
      status = merr_notmounted
      IF ( do_errmsg ) THEN
         GOTO 5000
      ELSE
         RETURN
      ENDIF

* successful exit
* set TM_PATH_LIST to path_buff because v3.0 of f77 won't let this happen in INQUIRE -10/8/91
 1100 status = merr_ok
      TM_PATH_LIST = path_buff( :len_pbuff)
      RETURN

* error exits
* 7/97 *kob* mods to not include a default extension in error message if
*            an explicit extension is used
 5000 lext = TM_LENSTR(def_ext)      !can now be zero 7/97
      if (path_list(1:1) .EQ. '.' .OR. path_tries .GT. 1) then
         path_buff = fname(:TM_LENSTR1(fname))
	 if ( lext .GT. 0 ) path_buff = path_buff(:TM_LENSTR1(path_buff))
     .				//' ('//def_ext(1:lext)//')' ! *sh* 4/94,11/94
      else 
         path_buff = path_list(:plen-1)//PathSeparator//fname
      endif
      len_pbuff = TM_LENSTR1(path_buff) ! *sh* 4/94
      CALL TM_ERRMSG (status, status, 'TM_PATH_LIST',
     .                unspecified_int4, no_stepfile,
     .                path_buff(:len_pbuff), 
     .                no_errstring, *9900)
 9900 RETURN

      END

	DOUBLE PRECISION FUNCTION SECS_TO_TSTEP( grid, idim, secs )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* convert an absolute time measured in seconds from 1-JAN-0000:00:00:00
* into a time step value relevant on a particular grid, "grid"

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 7/27/88
* V530: *acm* 12/00 add calendar types; cal_id
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction. The time 
*                  dimension is now an arg to SECS_TO_TSTEP.
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.

	include 'tmap_dims.parm'
        include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xunits.cmn_text'
        include 'ferret.parm'

* calling argument declarations:
	INTEGER	grid, idim
	REAL*8	secs

* internal variable declarations:
	LOGICAL		ITSA_TRUEMONTH_AXIS
	INTEGER		TM_GET_CALENDAR_ID, axis, cal_id, status
	CHARACTER*20	date
	REAL*8		SECS_FROM_BC, bc_to_t0, unit_convert

* determine time axis of grid
	axis = grid_line( idim, grid )

* valid time axis ?
	IF ( line_direction( axis ) .EQ. 'TI' .OR. 
     .       line_direction( axis ) .EQ. 'FI' ) THEN

* get calendar type

	   cal_id = TM_GET_CALENDAR_ID ( line_cal_name(axis) )

* seconds from BC to start of time axis
	   bc_to_t0 = SECS_FROM_BC( line_t0(axis), cal_id, status )

* convert to units used on this time axis

	   unit_convert = line_tunit(axis)
	   IF (ITSA_TRUEMONTH_AXIS(axis)) unit_convert =  un_convert(pun_day)
	   SECS_TO_TSTEP = ( secs - bc_to_t0 ) / unit_convert

	ELSE

* not a valid time axis
	   SECS_TO_TSTEP = secs		! no conversion possible

	ENDIF
	RETURN
	END

	LOGICAL FUNCTION TM_CHECK_BNDS (line, line_edges, npts, 
     .                         iaxis, doubletype, vname)

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Checks to make sure bounds are contiguous and the data points are 
* enclosed by its bounds on an axis

* 4/2004 ACM from tm_check_box_loc
* V600 *acm* 3/06  Fix bug 1400: Add more convenient syntax for user-specified bounds:
*                  Bounds can be either 2*N or N+1 values.
* V601 *acm* 9/19  Fix bug 1434; check bounds for regularly-spaced axes 
* V63  *acm* 10/09 Changes for gfortran build
* V65  *acm*  2/10 Test for overlapping bounds
* V66  *kms*  7/10 Initialize return value to .TRUE. (uninitialized bug for
*                  N+1 bounds) and no need to check for gaps for N+1 bounds
* V694  5/15 *acm* Match precision for bounds checks (as is done for coords).
* V696 10/15 *acm* Ticket 2321: Fix logic when detecting coords that match grid bounds
* V72 6/17 *acm*   For trac enhancement #767 -- dynamic coordinate storage. 

        INCLUDE 'xio.cmn_text'
	INCLUDE 'tmap_dims.parm'
        INCLUDE 'tmap_errors.parm'
	INCLUDE 'xtm_grid.cmn_text'
	EXTERNAL xgt_grid_data

* Arguments
	LOGICAL doubletype
	INTEGER iaxis, npts
	REAL	line(*), line_edges(*)
        CHARACTER*(*) vname

* Internal definitions
        LOGICAL TM_FPEQ_EPS, TM_DFPEQ_TOL, equal, equal_ends, overlapping
	INTEGER TM_LENSTR1, ipt1, ibx1, i, ngap, vlen, status
        REAL*8 pt, del, bhi, blo
	
	REAL epsilon_21, epsilon
	REAL*8 depsilon_42, depsilon, first_delta
        REAL blast
        CHARACTER TM_STRING*13, vbuff*128

        epsilon_21 =  2.**(-21) 
        depsilon_42 =  2.**(-42) 

	blast = line_edges(2)  ! First box-hi
        TM_CHECK_BNDS = .TRUE.
        ngap = 0
        overlapping = .FALSE.

        first_delta = line(2) - line(1)
        depsilon = depsilon_42 * 2.*(ABS(line(1)) / first_delta )
        epsilon = epsilon_21 * 2.*(ABS(line(1)) / first_delta )

        DO i = 1, npts
           pt = line(i)
           blo = line_edges(2*(i-1)+1)
           bhi = line_edges(2*(i-1)+2)
           IF ( (pt .LT. blo) .OR.  (pt .GT. bhi) ) THEN

              IF (doubletype) THEN
                 equal = TM_DFPEQ_TOL(pt,blo,depsilon) .OR. TM_DFPEQ_TOL(pt,bhi,depsilon)
              ELSE
                 equal = TM_FPEQ_EPS(epsilon,pt,blo) .OR. TM_FPEQ_EPS(epsilon,pt,bhi)
              ENDIF
              IF (.NOT. equal) THEN
                 TM_CHECK_BNDS = .FALSE.
                 GOTO 5000
              ENDIF

              GOTO 5000
           ENDIF
           IF (i .GT. 1) THEN
              IF (doubletype) THEN
                 equal_ends = TM_DFPEQ_TOL(blast, REAL(blo), depsilon)
              ELSE
                 equal_ends = TM_FPEQ_EPS(epsilon, blast, REAL(blo))
              ENDIF
              IF (.NOT.equal_ends .AND. blo.LT.blast) THEN 
                 overlapping = .TRUE.
                 GOTO 330
              ENDIF
              IF (.NOT. equal_ends ) THEN
                 ngap = ngap + 1
                 line_edges(2*(i-1)+1) = blast
              ENDIF
              blast = REAL(bhi)
	      ENDIF

	ENDDO

	IF (ngap .EQ. 0) THEN
	   TM_CHECK_BNDS = .TRUE.
	   GOTO 5000
	ELSE

	   vbuff = vname   
	   vlen = TM_LENSTR1(vbuff)
	   CALL WARN( 'Axis definition error on axis: ' 
     .               //vbuff(:vlen))
	   CALL WARN(
     .        'Bounds given describe non-contiguous axis cells ')
	   CALL WARN(
     .         'Using the LOWER bound specified for each axis cell')
	   TM_CHECK_BNDS = .TRUE.

	ENDIF

  330	IF (overlapping) THEN
	   vbuff = vname   
	   vlen = TM_LENSTR1(vbuff)
	   CALL WARN( 'Axis definition error on axis: '
     .        //vbuff(:vlen)//'. Bounds describe cells '//
     .        'that overlap one another ')
	   TM_CHECK_BNDS = .FALSE.
	ENDIF

 5000  RETURN

      END

*
* pt_in_poly.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

** Ansley Manke
* January 2008
*
* This function implements the pnpoly code from W. Randolph Franklin found
* in his web pages. The exact code from these web pages is preserved at the end of
* this file; changes to it are the responsibility of Ferret program developers.

* Copyright (c) 1970-2003, Wm. Randolph Franklin
*
* Permission is hereby granted, free of charge, to any person obtaining a 
* copy of this software and associated documentation files (the "Software"), 
* to deal in the Software without restriction, including without limitation 
* the rights to use, copy, modify, merge, publish, distribute, sublicense, 
* and/or sell copies of the Software, and to permit persons to whom the 
* Software is furnished to do so, subject to the following conditions:

*  1. Redistributions of source code must retain the above copyright notice, 
* this list of conditions and the following disclaimers.
*   2. Redistributions in binary form must reproduce the above copyright 
* notice in the documentation and/or other materials provided with the 
* distribution.
*   3. The name of W. Randolph Franklin may not be used to endorse or 
* promote products derived from this Software without specific prior 
* written permission. 
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
* THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS 
* IN THE SOFTWARE. 
*
C W. Randolph Franklin
C http://www.ecse.rpi.edu/Homepages/wrf/pmwiki/
C http://www.ecse.rpi.edu/Homepages/wrf/Research/Short_Notes/pnpoly.html#The%20C%20Code
C http://www.ecse.rpi.edu/Homepages/wrf/Research/Short_Notes/pnpoly.html#Fortran%20Code%20for%20the%20Point%20in%20Polygon%20Test

C  RETURNS:
C           -1 IF THE POINT IS OUTSIDE OF THE POLYGON, 
C            0 IF THE POINT IS ON AN EDGE OR AT A VERTEX, 
C            1 IF THE POINT IS INSIDE OF THE POLYGON. 

***********************************************************************
*  Initialize the function

      SUBROUTINE pt_in_poly_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

      CHARACTER*100 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT 
     . ('Return -1 outside, 0 if on edge, 1 if inside polygon')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                NORMAL,          NORMAL,
     .                                NORMAL,          NORMAL)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 4)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_desc(id, arg, 
     .  'Variable on the XY grid and region to be tested')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'XVERT')
      CALL ef_set_arg_desc(id, arg, 
     .   'X-coordinates of vertices of polygon')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'YVERT')
      CALL ef_set_arg_desc(id, arg, 
     .   'Y-coordinates of vertices of polygon')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      RETURN 
      END

***********************************************************************

* Request an amount of storage to be supplied by Ferret and passed
* as additional arguments.

      SUBROUTINE pt_in_poly_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

*
* Set the work array X/Y/Z/T/E/F dimensions
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)

      INTEGER array_num, nx, ny, nv
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

* Coordinate data from argument 1

      array_num = 1
      CALL ef_set_work_array_dims_6d(id, array_num,
     .                               arg_lo_ss(X_AXIS,ARG1), 1, 1, 1, 1, 1,
     .                               arg_hi_ss(X_AXIS,ARG1), 1, 1, 1, 1, 1)

      array_num = 2
      CALL ef_set_work_array_dims_6d(id, array_num,
     .                               arg_lo_ss(Y_AXIS,ARG1), 1, 1, 1, 1, 1,
     .                               arg_hi_ss(Y_AXIS,ARG1), 1, 1, 1, 1, 1)


* Set two arrays the size of the number of vertices.

      nv = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1 
      nv = MAX(nv, arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) + 1 )
      nv = MAX(nv, arg_hi_ss(Z_AXIS,ARG2) - arg_lo_ss(Z_AXIS,ARG2) + 1 )
      nv = MAX(nv, arg_hi_ss(T_AXIS,ARG2) - arg_lo_ss(T_AXIS,ARG2) + 1 )

      array_num = 3
      CALL ef_set_work_array_dims_6d(id, array_num,
     .                                1, 1, 1, 1, 1, 1,
     .                               nv, 1, 1, 1, 1, 1)

      array_num = 4
      CALL ef_set_work_array_dims_6d(id, array_num,
     .                                1, 1, 1, 1, 1, 1,
     .                               nv, 1, 1, 1, 1, 1)

      RETURN 
      END

* **********************************************************************

      SUBROUTINE pt_in_poly_compute (id, arg_1, arg_2, arg_3, result, 
     .   xcoords, ycoords, workx, worky)
C 
C REMARKS 
C   THE VERTICES MAY BE LISTED CLOCKWISE OR ANTICLOCKWISE. 
C   THE FIRST MAY OPTIONALLY BE REPEATED, IF SO N MAY 
C   OPTIONALLY BE INCREASED BY 1. 
C   THE INPUT POLYGON MAY BE A COMPOUND POLYGON CONSISTING 
C   OF SEVERAL SEPARATE SUBPOLYGONS. IF SO, THE FIRST VERTEX 
C   OF EACH SUBPOLYGON MUST BE REPEATED, AND WHEN CALCULATING 
C   N, THESE FIRST VERTICES MUST BE COUNTED TWICE. 
C   INOUT IS THE ONLY PARAMETER WHOSE VALUE IS CHANGED. 
C   THE SIZE OF THE ARRAYS MUST BE INCREASED IF N > MAXDIM 
C   WRITTEN BY RANDOLPH FRANKLIN, UNIVERSITY OF OTTAWA, 7/70. 
C   
C SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED 
C   NONE 
C 
C METHOD 
C   A VERTICAL LINE IS DRAWN THRU THE POINT IN QUESTION. IF IT 
C   CROSSES THE POLYGON AN ODD NUMBER OF TIMES, THEN THE 
C   POINT IS INSIDE OF THE POLYGON. 
C 
C Originally written as an external function, this version uses
C internal Ferret functions STR_UPCASE and TM_HAS_STRING to upcase
C the axis units string and compare its value to legal longitude
C units strings.
C
C .................................................................. 
C 

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

      REAL*8 xcoords(wrk1lox:wrk1hix)
      REAL*8 ycoords(wrk2lox:wrk2hix)
      REAL workx(wrk3lox:wrk3hix)
      REAL worky(wrk4lox:wrk4hix)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      
      CHARACTER ax_name(6)*16, ax_units(6)*16, dummy*16
      LOGICAL backward(6), mdulo(6), regular(6)

      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, ii, jj, iarg, inout, nv
      REAL xvmin, xvmax, yvmin, yvmax, px, py, xmin, xmax
      INTEGER STR_UPCASE
      LOGICAL TM_HAS_STRING, mod_lo, mod_hi, its_dsg
      
      CHARACTER*128 err_msg
      
* Does the variable come from a Discrete Sampling Geometries dataset?  
* If so the function doesn't apply.

      CALL EF_GET_ITS_DSG(id, ARG1, its_dsg )
      IF (its_dsg) THEN
         err_msg = 
     . 'Data is from a Discrete Sampling Geometries (DSG) dataset. Function requires an XY grid.'
	GOTO 999
      ENDIF

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* Get the x and y coordinates of the input variable

      iarg = 1
      CALL ef_get_coordinates (id, iarg, X_AXIS, 
     .       arg_lo_ss(X_AXIS, ARG1), arg_hi_ss(X_AXIS, ARG1), xcoords)
      CALL ef_get_coordinates (id, iarg, Y_AXIS, 
     .       arg_lo_ss(Y_AXIS, ARG1), arg_hi_ss(Y_AXIS, ARG1), ycoords)

* Size of the list of polygon vertices

      nv = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1 
      nv = MAX(nv, arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) + 1 )
      nv = MAX(nv, arg_hi_ss(Z_AXIS,ARG2) - arg_lo_ss(Z_AXIS,ARG2) + 1 )
      nv = MAX(nv, arg_hi_ss(T_AXIS,ARG2) - arg_lo_ss(T_AXIS,ARG2) + 1 )


* Get the bounding box around the polygon. Do not check points if they are
* outside this bounding box
 
      xvmin = ABS( bad_flag(ARG3) )
      xvmax = -1*xvmin
      yvmin = ABS( bad_flag(ARG4) )
      yvmax = -1*yvmin

      CALL POLY_BOUND_BOX(arg_2, arg_3, nv, xvmin, xvmax, yvmin, yvmax)

* If x axis of arg 1 is longitude, see if the xpts are outside the range of the x axis. Do we need to work 
* in a different modulo branch?
* Get the units of the x axis of arg1

      CALL ef_get_axis_info_6d(id, ARG1, ax_name, ax_units,
     .                         backward, mdulo, regular)
      dummy = ax_units(1) 
      i = STR_UPCASE (dummy, ax_units(1))
      
      mod_lo = .FALSE.
      mod_hi = .FALSE.

      IF ( TM_HAS_STRING(ax_units(1), 'EAST')
     .   .OR. TM_HAS_STRING(ax_units(1), 'WEST')
     .   .OR. TM_HAS_STRING(ax_units(1), 'degreeE')
     .   .OR. TM_HAS_STRING(ax_units(1), 'degreesE')
     .   .OR. TM_HAS_STRING(ax_units(1), 'degree_E')
     .   .OR. TM_HAS_STRING(ax_units(1), 'degrees_E')
     .   .OR. TM_HAS_STRING(ax_units(1), 'degreeW')
     .   .OR. TM_HAS_STRING(ax_units(1), 'degreesW')
     .   .OR. TM_HAS_STRING(ax_units(1), 'degree_W')
     .   .OR. TM_HAS_STRING(ax_units(1), 'degrees_W')
     .   .OR. TM_HAS_STRING(ax_units(1), 'LON') ) THEN


         xmin = 1.e34
         xmax = -1.e34
         do i = wrk1lox,wrk1hix 
            xmin = MIN(xmin, xcoords(i))
            xmax = MAX(xmax, xcoords(i))
         enddo

         mod_lo = (xvmin .LT. xmin)
         mod_hi = (xvmax .GT. xmax)
      ENDIF

* Loop over all points, checking if they are inside or outside the polygon.

      n = res_lo_ss(F_AXIS)
      m = res_lo_ss(E_AXIS)
      l = res_lo_ss(T_AXIS)
      k = res_lo_ss(Z_AXIS)

      j1 = arg_lo_ss(Y_AXIS,ARG1)
      DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
         py = ycoords(j1)

         i1 = arg_lo_ss(X_AXIS,ARG1)
         DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
            px = xcoords(i1) 

            IF (px .GE. xvmin .AND. px .LE. xvmax .AND.
     .          py .GE. yvmin .AND. py .LE. yvmax ) THEN
               CALL PNPOLY (px, py, arg_2, arg_3, nv, 
     .                      workx, worky, inout )
               result(i,j,k,l,m,n)= FLOAT(inout)
            ELSE
               result(i,j,k,l,m,n) = -1
            ENDIF
	    
	    IF (mod_lo) THEN
            IF (px-360 .GE. xvmin .AND. px-360 .LE. xvmax .AND.
     .          py .GE. yvmin .AND. py .LE. yvmax ) THEN
               CALL PNPOLY (px-360, py, arg_2, arg_3, nv, 
     .                      workx, worky, inout )
               result(i,j,k,l,m,n)= FLOAT(inout)
            ELSE
               result(i,j,k,l,m,n) = -1
            ENDIF
	    ENDIF  ! mod_lo

	    IF (mod_hi) THEN
            IF (px+360 .GE. xvmin .AND. px+360 .LE. xvmax .AND.
     .          py .GE. yvmin .AND. py .LE. yvmax ) THEN
               CALL PNPOLY (px+360, py, arg_2, arg_3, nv, 
     .                      workx, worky, inout )
               result(i,j,k,l,m,n)= FLOAT(inout)
            ELSE
               result(i,j,k,l,m,n) = -1
            ENDIF
	    ENDIF  ! mod_hi

            i1 = i1 + arg_incr(X_AXIS,ARG1)
 100     CONTINUE

         j1 = j1 + arg_incr(Y_AXIS,ARG1)
 200  CONTINUE

      RETURN 

 999  CALL ef_bail_out (id, err_msg)

      RETURN 
      END




C .................................................................. 

      SUBROUTINE POLY_BOUND_BOX (xv, yv, nv, xvmin, xvmax, yvmin, yvmax)

* Get the bounding box around the polygon. min and max variables
* have been initialized.

      REAL xv(*), yv(*), xvmin, xvmax, yvmin, yvmax
      INTEGER nv
      INTEGER i

      DO 50 i = 1, nv
         xvmin = MIN(xvmin, xv(i))
         xvmax = MAX(xvmax, xv(i))
         yvmin = MIN(yvmin, yv(i))
         yvmax = MAX(yvmax, yv(i))
  50  CONTINUE

      RETURN
      
      END


C .................................................................. 
C 
C SUBROUTINE PNPOLY 
C 
C PURPOSE 
C   TO DETERMINE WHETHER A POINT IS INSIDE A POLYGON 
C 
C USAGE 
C   CALL PNPOLY (PX, PY, XX, YY, N, workx, worky, INOUT ) 
C 
C DESCRIPTION OF THE PARAMETERS 
C   PX    - X-COORDINATE OF POINT IN QUESTION. 
C   PY    - Y-COORDINATE OF POINT IN QUESTION. 
C   XX    - N LONG VECTOR CONTAINING X-COORDINATES OF 
C           VERTICES OF POLYGON. 
C   YY    - N LONG VECTOR CONTAING Y-COORDINATES OF 
C           VERTICES OF POLYGON. 
C   N     - NUMBER OF VERTICES IN THE POLYGON. 
C   workx - work array
C   worky - work array
C   INOUT - THE SIGNAL RETURNED: 
C           -1 IF THE POINT IS OUTSIDE OF THE POLYGON, 
C            0 IF THE POINT IS ON AN EDGE OR AT A VERTEX, 
C            1 IF THE POINT IS INSIDE OF THE POLYGON. 
C 
C REMARKS 
C   THE VERTICES MAY BE LISTED CLOCKWISE OR ANTICLOCKWISE. 
C   THE FIRST MAY OPTIONALLY BE REPEATED, IF SO N MAY 
C   OPTIONALLY BE INCREASED BY 1. 
C   THE INPUT POLYGON MAY BE A COMPOUND POLYGON CONSISTING 
C   OF SEVERAL SEPARATE SUBPOLYGONS. IF SO, THE FIRST VERTEX 
C   OF EACH SUBPOLYGON MUST BE REPEATED, AND WHEN CALCULATING 
C   N, THESE FIRST VERTICES MUST BE COUNTED TWICE. 
C   INOUT IS THE ONLY PARAMETER WHOSE VALUE IS CHANGED. 
C   THE SIZE OF THE ARRAYS MUST BE INCREASED IF N > MAXDIM 
C   WRITTEN BY RANDOLPH FRANKLIN, UNIVERSITY OF OTTAWA, 7/70. 
C   
C SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED 
C   NONE 
C 
C METHOD 
C   A VERTICAL LINE IS DRAWN THRU THE POINT IN QUESTION. IF IT 
C   CROSSES THE POLYGON AN ODD NUMBER OF TIMES, THEN THE 
C   POINT IS INSIDE OF THE POLYGON. 
C 
C .................................................................. 
C 
      SUBROUTINE PNPOLY(PX,PY,XX,YY,N,X,Y,INOUT) 
      REAL PX,PY,X(*),Y(*),XX(*),YY(*) 
      INTEGER N, INOUT

      LOGICAL TM_FPEQ, MX,MY,NX,NY, b
      INTEGER I, J, INOUT1, INOUT2
      INOUT1 = 0
      INOUT2 = 0

* Change the original to see if X(J)=Y(J)=0. This loop finds matches 
* for points on the left-hand edges 

    6 DO 1 I=1,N 
      X(I)=XX(I)-PX 
    1 Y(I)=YY(I)-PY 
      INOUT1=-1 
      DO 2 I=1,N 
      J=1+MOD(I,N) 
      MX=X(I).GE.0.0 
      NX=X(J).GE.0.0 
      MY=Y(I).GE.0.0 
      NY=Y(J).GE.0.0 

      IF (TM_FPEQ(X(J),0.) .AND. TM_FPEQ(Y(J),0.)) GOTO 4

      IF(.NOT.((MY.OR.NY).AND.(MX.OR.NX)).OR.(MX.AND.NX)) GO TO 2 
      IF(.NOT.(MY.AND.NY.AND.(MX.OR.NX).AND..NOT.(MX.AND.NX))) GO TO 3 
      INOUT1=-INOUT1 
      GO TO 2
    3 CONTINUE
      IF ( TM_FPEQ(X(J),Y(J)) ) THEN
         IF(TM_FPEQ((Y(I)*X(J)-X(I)*Y(J)),0.)) THEN  
            INOUT1 = 0
            INOUT2 = 0
            GOTO 50
         ENDIF
      ENDIF
      IF( TM_FPEQ((Y(I)*X(J)-X(I)*Y(J))/(X(J)-X(I)), 0.) ) GOTO 4
      IF((Y(I)*X(J)-X(I)*Y(J))/(X(J)-X(I))) 2,4,5 
    4 INOUT1 = 0
      INOUT2 = 0
      GOTO 50
    5 INOUT1=-INOUT1 
    2 CONTINUE 

* Now do the same with the order of subtraction reversed when 
* computing arrays X(I) and Y(I). This finds matches for points 
* on the right-hand edges.

      DO 11 I=1,N 
      X(I)=PX-XX(I)
   11 Y(I)=PY-YY(I) 
      INOUT2=-1 
      DO 12 I=1,N 
      J=1+MOD(I,N) 
      MX=X(I).GE.0.0 
      NX=X(J).GE.0.0 
      MY=Y(I).GE.0.0 
      NY=Y(J).GE.0.0 

      IF (TM_FPEQ(X(J),0.) .AND. TM_FPEQ(Y(J),0.)) GOTO 14

      IF(.NOT.((MY.OR.NY).AND.(MX.OR.NX)).OR.(MX.AND.NX)) GO TO 12 
      IF(.NOT.(MY.AND.NY.AND.(MX.OR.NX).AND..NOT.(MX.AND.NX))) GO TO 13 
      INOUT2=-INOUT2 
      GO TO 12
   13 CONTINUE
      IF ( TM_FPEQ(X(J),Y(J)) ) THEN
         IF(TM_FPEQ(Y(I)*X(J)-X(I)*Y(J), 0.)) THEN  
            INOUT1 = 0
            INOUT2 = 0
            GOTO 50
         ENDIF
      ENDIF
      IF( TM_FPEQ((Y(I)*X(J)-X(I)*Y(J))/(X(J)-X(I)), 0.) ) GOTO 14
      IF((Y(I)*X(J)-X(I)*Y(J))/(X(J)-X(I))) 12,14,15 
   14 INOUT1 = 0
      INOUT2 = 0
      GOTO 50
   15 INOUT2=-INOUT2 
   12 CONTINUE 

* Combine the results: -1 outside the polygon, 0 
* on the edges or vertices, 1 inside the polygon.

   50 CONTINUE
      INOUT = (INOUT2 + INOUT1)/2
      RETURN

      END 

*** ORIG  C >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
*** ORIG  C Here is the exact code from W. Randolph Franklin pages.
*** ORIG  C Fortran Code for the Point in Polygon Test
*** ORIG  
*** ORIG  C>>>PNP1 
*** ORIG  C 
*** ORIG  C .................................................................. 
*** ORIG  C 
*** ORIG  C SUBROUTINE PNPOLY 
*** ORIG  C 
*** ORIG  C PURPOSE 
*** ORIG  C   TO DETERMINE WHETHER A POINT IS INSIDE A POLYGON 
*** ORIG  C 
*** ORIG  C USAGE 
*** ORIG  C   CALL PNPOLY (PX, PY, XX, YY, N, INOUT ) 
*** ORIG  C 
*** ORIG  C DESCRIPTION OF THE PARAMETERS 
*** ORIG  C   PX    - X-COORDINATE OF POINT IN QUESTION. 
*** ORIG  C   PY    - Y-COORDINATE OF POINT IN QUESTION. 
*** ORIG  C   XX    - N LONG VECTOR CONTAINING X-COORDINATES OF 
*** ORIG  C           VERTICES OF POLYGON. 
*** ORIG  C   YY    - N LONG VECTOR CONTAING Y-COORDINATES OF 
*** ORIG  C           VERTICES OF POLYGON. 
*** ORIG  C   N     -  NUMBER OF VERTICES IN THE POLYGON. 
*** ORIG  C   INOUT - THE SIGNAL RETURNED: 
*** ORIG  C           -1 IF THE POINT IS OUTSIDE OF THE POLYGON, 
*** ORIG  C            0 IF THE POINT IS ON AN EDGE OR AT A VERTEX, 
*** ORIG  C            1 IF THE POINT IS INSIDE OF THE POLYGON. 
*** ORIG  C 
*** ORIG  C REMARKS 
*** ORIG  C   THE VERTICES MAY BE LISTED CLOCKWISE OR ANTICLOCKWISE. 
*** ORIG  C   THE FIRST MAY OPTIONALLY BE REPEATED, IF SO N MAY 
*** ORIG  C   OPTIONALLY BE INCREASED BY 1. 
*** ORIG  C   THE INPUT POLYGON MAY BE A COMPOUND POLYGON CONSISTING 
*** ORIG  C   OF SEVERAL SEPARATE SUBPOLYGONS. IF SO, THE FIRST VERTEX 
*** ORIG  C   OF EACH SUBPOLYGON MUST BE REPEATED, AND WHEN CALCULATING 
*** ORIG  C   N, THESE FIRST VERTICES MUST BE COUNTED TWICE. 
*** ORIG  C   INOUT IS THE ONLY PARAMETER WHOSE VALUE IS CHANGED. 
*** ORIG  C   THE SIZE OF THE ARRAYS MUST BE INCREASED IF N > MAXDIM 
*** ORIG  C   WRITTEN BY RANDOLPH FRANKLIN, UNIVERSITY OF OTTAWA, 7/70. 
*** ORIG  C   
*** ORIG  C SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED 
*** ORIG  C   NONE 
*** ORIG  C 
*** ORIG  C METHOD 
*** ORIG  C   A VERTICAL LINE IS DRAWN THRU THE POINT IN QUESTION. IF IT 
*** ORIG  C   CROSSES THE POLYGON AN ODD NUMBER OF TIMES, THEN THE 
*** ORIG  C   POINT IS INSIDE OF THE POLYGON. 
*** ORIG  C 
*** ORIG  C .................................................................. 
*** ORIG  C 
*** ORIG        SUBROUTINE PNPOLY(PX,PY,XX,YY,N,INOUT) 
*** ORIG        REAL X(200),Y(200),XX(N),YY(N) 
*** ORIG        LOGICAL MX,MY,NX,NY 
*** ORIG        INTEGER O 
*** ORIG  
*** ORIG  C OUTPUT UNIT FOR PRINTED MESSAGES 
*** ORIG        DATA O/6/ 
*** ORIG        MAXDIM=200 
*** ORIG        IF(N.LE.MAXDIM)GO TO 6 
*** ORIG        WRITE(O,7)  
*** ORIG      7 FORMAT('0WARNING:',I5,' TOO GREAT FOR THIS VERSION OF pt_in_poly. 
*** ORIG       1 RESULTS INVALID')
*** ORIG        RETURN
*** ORIG      6 DO 1 I=1,N 
*** ORIG        X(I)=XX(I)-PX 
*** ORIG      1 Y(I)=YY(I)-PY 
*** ORIG        INOUT=-1 
*** ORIG        DO 2 I=1,N 
*** ORIG        J=1+MOD(I,N) 
*** ORIG        MX=X(I).GE.0.0 
*** ORIG        NX=X(J).GE.0.0 
*** ORIG        MY=Y(I).GE.0.0 
*** ORIG        NY=Y(J).GE.0.0 
*** ORIG        IF(.NOT.((MY.OR.NY).AND.(MX.OR.NX)).OR.(MX.AND.NX)) GO TO 2 
*** ORIG        IF(.NOT.(MY.AND.NY.AND.(MX.OR.NX).AND..NOT.(MX.AND.NX))) GO TO 3 
*** ORIG        INOUT=-INOUT 
*** ORIG        GO TO 2
*** ORIG      3 IF((Y(I)*X(J)-X(I)*Y(J))/(X(J)-X(I))) 2,4,5 
*** ORIG      4 INOUT=0   
*** ORIG        RETURN 
*** ORIG      5 INOUT=-INOUT 
*** ORIG      2 CONTINUE 
*** ORIG        RETURN 
*** ORIG        END 

	SUBROUTINE GACWK
C**
C**    @(#)gksfake.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* additions by *SH* 6/90 for PLOT+ enhancements
* kob/jd 1/97- comment out unneeded itmes for linux/f90 port
	ENTRY GCLKS
	ENTRY GCLWK
	ENTRY GDAWK
	ENTRY GQACWK
	ENTRY GQOPWK
	ENTRY GSCLIP
	ENTRY GQCLIP
	ENTRY GSDS
	ENTRY GUWK
	ENTRY GFA
	ENTRY GQASF
	ENTRY GQCNTN
	ENTRY GQLWK
	ENTRY GQOPS
	ENTRY GQPCR
	ENTRY GQPLR
	ENTRY GQPXAD
	ENTRY GSASF
	ENTRY GSCHH
	ENTRY GSCR
	ENTRY GSFAI
	ENTRY GSFAR
	ENTRY GSPA
	ENTRY GSPLI
	ENTRY GSPLR
	ENTRY GSTXAL
	ENTRY GSTXFP
	ENTRY GTX
	ENTRY GWITM
	ENTRY GERHND
	ENTRY GCLSG
	ENTRY GCRSG
	ENTRY GDSG
*	ENTRY gks$INQ_COLOR_REP
*	ENTRY gks$inq_MAX_WS_STATE_TABLE
*	ENTRY gks$OPEN_WS
*	ENTRY gks$inq_current_xformno
*	ENTRY gks$inq_xform
*	ENTRY gks$inq_pixel_array_dim
*	ENTRY gks$inq_pixel_array
        ENTRY gesc            ! 5/91 (used for multiple windows)
* end of 6/90 additions
* additions by *SH* 10/90 for PMEL cluster link w/out GKSFORBND.OLB
*	ENTRY FB$2CINPUT
*	ENTRY FB$ATTRIBUTES
*	ENTRY FB$CONTROL
*	ENTRY FB$ERRORS
*	ENTRY FB$INITIALIZE
*	ENTRY FB$INQGKS
*	ENTRY FB$INQPIXEL
*	ENTRY FB$INQWDT
*	ENTRY FB$INQWS
*	ENTRY FB$METAFILE
*	ENTRY FB$OUTPUT
*	ENTRY FB$REPRESENTATIONS
*	ENTRY FB$REQUEST
*	ENTRY FB$SEGMENTS
*	ENTRY FB$SETMODE
*	ENTRY FB$SUPPORT
*	ENTRY FB$TRANSFORMATIONS
*	ENTRY FB$UTILITIES
	ENTRY GECLKS
*	ENTRY GKS$$FB_ERROR
	ENTRY GUREC
* end of 10/90 additions

	ENTRY GCLRWK
	ENTRY GOPKS
	ENTRY GOPWK
	ENTRY GPL
	ENTRY GQMDS
	ENTRY GQWKC
	ENTRY GSELNT
	ENTRY GSPLCI
	ENTRY GSVP
	ENTRY GSWKVP
	ENTRY GSWKWN
	ENTRY GSWN
	ENTRY GINCH
	ENTRY GINLC
	ENTRY GPREC
	ENTRY GQCHS
	ENTRY GQLCS
	ENTRY GQNT
	ENTRY GRQCH
	ENTRY GRQLC
	ENTRY GSLCM
	ENTRY GSVPIP
	ENTRY GQDSP
	STOP 'Cannot use GKS on this system.  CANCEL MODE GKS'
	END

	INTEGER FUNCTION DO_MIN( idim, arg,
     .				 com, com_mr, com_cx,
     .				 res, res_mr, res_cx,
     .				 buff	)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* find the minimum value of the component grid along axis idim

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  6/1/89
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include	'xprog_state.cmn'

* calling argument declarations:
	INTEGER	idim, com_mr, com_cx, res_mr, res_cx
	REAL	arg, buff(*),
     .          com( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          res( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif )

* internal variable declarations:
	INTEGER i, j, k, l, m, n, pt
	REAL	bad_res, minmum

* internal parameter declaration
	REAL		too_large
	PARAMETER     ( too_large = 1.E33 )

* diagnostic mode output: " doing --> VAR_NAME[x=lo:hi@TRN:n,D=#]"
	IF ( mode_diagnostic ) 	CALL DIAG_OP
     .				( 'doing', isact_class_trans, res_cx, idim )

* initialize
	pt   = cx_lo_ss( res_cx, idim )
	bad_res = mr_bad_data( res_mr )

* ALONG X AXIS
	IF ( idim .EQ. x_dim ) THEN
	   DO 110 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 110 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 110 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 110 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 110 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	      minmum = too_large
	      DO 100 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_res ) GOTO 100
	         IF ( com(i,j,k,l,m,n) .LT. minmum )
     .              minmum = com(i,j,k,l,m,n)
 100	      CONTINUE
	      IF ( minmum .EQ. too_large ) THEN
	         res(pt,j,k,l,m,n) = bad_res
	      ELSE
	         res(pt,j,k,l,m,n) = minmum
	      ENDIF
 110	   CONTINUE

* ALONG Y AXIS
	ELSEIF ( idim .EQ. y_dim ) THEN
	   DO 210 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 210 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 210 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 210 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 210 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	      minmum = too_large
	      DO 200 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_res ) GOTO 200
	         IF ( com(i,j,k,l,m,n) .LT. minmum )
     .              minmum = com(i,j,k,l,m,n)
 200	      CONTINUE
	      IF ( minmum .EQ. too_large ) THEN
	         res(i,pt,k,l,m,n) = bad_res
	      ELSE
	         res(i,pt,k,l,m,n) = minmum
	      ENDIF
 210	   CONTINUE

* ALONG Z AXIS
	ELSEIF ( idim .EQ. z_dim ) THEN
	   DO 310 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 310 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 310 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 310 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 310 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	      minmum = too_large
	      DO 300 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_res ) GOTO 300
	         IF ( com(i,j,k,l,m,n) .LT. minmum )
     .              minmum = com(i,j,k,l,m,n)
 300	      CONTINUE
	      IF ( minmum .EQ. too_large ) THEN
	         res(i,j,pt,l,m,n) = bad_res
	      ELSE
	         res(i,j,pt,l,m,n) = minmum
	      ENDIF
 310	   CONTINUE

* ALONG T AXIS
	ELSEIF ( idim .EQ. t_dim ) THEN
	   DO 410 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 410 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 410 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 410 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 410 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	      minmum = too_large
	      DO 400 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_res ) GOTO 400
	         IF ( com(i,j,k,l,m,n) .LT. minmum )
     .              minmum = com(i,j,k,l,m,n)
 400	      CONTINUE
	      IF ( minmum .EQ. too_large ) THEN
	         res(i,j,k,pt,m,n) = bad_res
	      ELSE
	         res(i,j,k,pt,m,n) = minmum
	      ENDIF
 410	   CONTINUE

* ALONG E AXIS
	ELSEIF ( idim .EQ. e_dim ) THEN
	   DO 510 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 510 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 510 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 510 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 510 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	      minmum = too_large
	      DO 500 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_res ) GOTO 500
	         IF ( com(i,j,k,l,m,n) .LT. minmum )
     .              minmum = com(i,j,k,l,m,n)
 500	      CONTINUE
	      IF ( minmum .EQ. too_large ) THEN
	         res(i,j,k,l,pt,n) = bad_res
	      ELSE
	         res(i,j,k,l,pt,n) = minmum
	      ENDIF
 510	   CONTINUE

* ALONG F AXIS
	ELSEIF ( idim .EQ. f_dim ) THEN
	   DO 610 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 610 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 610 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 610 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 610 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	      minmum = too_large
	      DO 600 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx) 
	         IF ( com(i,j,k,l,m,n) .EQ. bad_res ) GOTO 600
	         IF ( com(i,j,k,l,m,n) .LT. minmum )
     .              minmum = com(i,j,k,l,m,n)
 600	      CONTINUE
	      IF ( minmum .EQ. too_large ) THEN
	         res(i,j,k,l,m,pt) = bad_res
	      ELSE
	         res(i,j,k,l,m,pt) = minmum
	      ENDIF
 610	   CONTINUE

	ENDIF

	DO_MIN = ferr_ok

	RETURN
	END

       subroutine apply_mapping (data_in, ilo, ihi, jlo, jhi,
     .                           wt, i_lon, j_lat, data_out, 
     .                           nlon_src, nlat_src, nlon_dst, nlat_dst,
     .                           num_nbrs, bad_flag_in, bad_flag_out)

! This is the last set of loops from horiz_interp_sphe, applying wt
! to the data to compute the regridded result.

! acm 7/2004 Add variable COUNT to set data to missing if there is nothing added
! to the sum in a given output grid cell.  This had been done in the original code
! by seeing if the value is a "land" value, but it is not general enough for our
! purposes.

! acm 12/2004 Compute the sum of weights here; weights only used when there
!             is good data contributing to the destination point.

       IMPLICIT NONE
       integer ilo, ihi, jlo, jhi
       real data_in(ilo:ihi, jlo:jhi)     ! input field
       real data_out(nlon_dst, nlat_dst)  ! output
       real wt(nlon_dst, nlat_dst, num_nbrs)  

       real i_lon(nlon_dst,nlat_dst,num_nbrs)
       real j_lat(nlon_dst,nlat_dst,num_nbrs) 

       real bad_flag_in, bad_flag_out

       integer nlon_src, nlat_src, nlon_dst, nlat_dst, 
     .         num_nbrs

!--- some local variables ----------------------------------------
       integer nlon_in, nlat_in, nlon_out, nlat_out, num_neighbors,
     .               m, n, k, i, j
       real sum
       logical okij
!-----------------------------------------------------------------

! parameters
      real epsln, large
cc      parameter (epsln=1.e-10, large=1.e20)
      parameter (epsln=4.e-7, large=1.e20)

         nlon_in  = nlon_src
         nlat_in  = nlat_src
         nlon_out = nlon_dst
         nlat_out = nlat_dst   
         num_neighbors = num_nbrs

         do m=1,nlon_out
         do n=1,nlat_out

            data_out(m,n) = 0.0
            sum=0.0
            do k=1, num_neighbors
               i = i_lon(m,n,k)
               j = j_lat(m,n,k)

               okij = .TRUE.
               IF (i .LT. ilo  .OR. i .GT. ihi) THEN
                  okij = .FALSE.
               ENDIF
               IF (j .LT. jlo  .OR.  j .GT. jhi) THEN
                  okij = .FALSE.
               ENDIF


               if (i.GT.0 .and. j.GT.0 .AND. okij) THEN
                  IF (data_in(i,j) .NE. bad_flag_in ) THEN
                     data_out(m,n) = data_out(m,n)+
     .                                  data_in(i,j)*wt(m,n,k)
                     sum = sum + wt(m,n,k)
                  endif
               else
                  data_out(m,n) = bad_flag_out
                  GO TO 33
               endif
            enddo

            IF (sum .GT. epsln) THEN
               data_out(m,n) = data_out(m,n)/sum
            ELSE
               data_out(m,n) = bad_flag_out
            ENDIF
  33        continue

         enddo
         enddo
      

         return
       end ! subroutine horiz_interp_sphe
      
      

	SUBROUTINE GET_DSET_NAME( dset_num, name, len_text )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* get the name of the given data set if that is meaningful
* else get a string describing the nature of the name 

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V200	  1/4/89 - from GET_1_DSET_NAME: 
*		 - eliminated the possibility of multiple data set variables
* Unix/RISC port 5/91 *sh*: use ds_des_name; right justify long data set paths
* Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'ferret.parm'

* calling argument declarations:
	INTEGER		dset_num, len_text
	CHARACTER*(*)	name

* internal variable declarations:
	INTEGER		TM_LENSTR1, len_name

* initialize
	len_name  = LEN( name )

* consider the options
* 11/02 *kob* Also need to make sure that dset_num isn't undefined
	IF     ( dset_num .EQ. pdset_irrelevant	.OR. 
     .              dset_num .EQ. unspecified_int4)	THEN	! no name
	   name(1:len_name) = 'N/A'
	   len_text = 3

	ELSE
	   len_text = TM_LENSTR1( ds_des_name( dset_num ) )
           IF ( len_text .GT. len_name ) THEN
* ... too long to fit
              name = ds_des_name(dset_num)(len_text-len_name+1:)
              len_text = len_name
           ELSE
              name = ds_des_name( dset_num )
           ENDIF

	ENDIF

	RETURN
	END

	SUBROUTINE EXTRACT_ARG1_LINE( src, axis, axmin, axmax,
     .				      i, j, k, l, m, n, line )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* extract a single line of data along requested axis from a memory variable
* Note that whatever the axis orientation, the corresponging index position
* from the i,j,k,l,m,n arguments is irrelevant

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V698+ *sh* 5/15

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include	'xmem_subsc.cmn'

* calling argument declarations:
	INTEGER	axis, axmin, axmax, i, j, k, l, m, n
        REAL    src(m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .              m1lot:m1hit,m1loe:m1hie,m1lof:m1hif )
	REAL    line(axmin:axmax)

* internal variable declarations:
	INTEGER	ss

* extract the line
	IF (axis .EQ. x_dim) THEN
	   DO ss = axmin, axmax
	      line(ss) = src(ss, j, k, l, m, n)
	   ENDDO
	ELSEIF (axis .EQ. y_dim) THEN
	   DO ss = axmin, axmax
	      line(ss) = src(i, ss, k, l, m, n)
	   ENDDO
	ELSEIF (axis .EQ. z_dim) THEN
	   DO ss = axmin, axmax
	      line(ss) = src(i, j, ss, l, m, n)
	   ENDDO
	ELSEIF (axis .EQ. t_dim) THEN
	   DO ss = axmin, axmax
	      line(ss) = src(i, j, k, ss, m, n)
	   ENDDO
	ELSEIF (axis .EQ. e_dim) THEN
	   DO ss = axmin, axmax
	      line(ss) = src(i, j, k, l, ss, n)
	   ENDDO
	ELSE    ! f_dim
	   DO ss = axmin, axmax
	      line(ss) = src(i, j, k, l, m, ss)
	   ENDDO
	ENDIF

	RETURN
	END

	SUBROUTINE CALENDAR_AXIS (idim, grid, cx, status)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*

* Reset time step if axis is a different calendar than Gregorian.
* V683  *acm*10/12 Improve handling of F axes and info about the calendar of the grid.
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.

	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xunits.cmn_text'
	external xunits_data
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xvariables.cmn'
	include	'xcontext.cmn'

* calling argument declarations:
	INTEGER idim, grid, cx, status

* internal variable declarations:
	LOGICAL ITSA_TRUEMONTH_AXIS, true_month
	REAL*8	SECS_FROM_BC, bc_to_t0, ww, new_lo_ww, new_hi_ww, 
     .		new_lo, new_hi, timefac, tcoord
	INTEGER TM_GET_CALENDAR_ID, axis, cal_id, prev_cal_id, istat, ndec
	CHARACTER datestring*20, day_of_mo*2

* axis for this dimension
	axis = grid_line( idim, grid )
* Is it really a calendar axis? Might be an F axis in a grid with a 
* calendar T axis.

	IF (line_t0(axis) .EQ. char_init20) THEN
	   istat = 2
	   GOTO 5000
	ENDIF

	cal_id = TM_GET_CALENDAR_ID ( line_cal_name(axis) )
	bc_to_t0 = SECS_FROM_BC(line_t0(axis), cal_id, istat)
	IF (istat .NE. ferr_ok) GO TO 4000

	prev_cal_id = cx_cal_id(cx)
	IF (prev_cal_id.NE.cal_id .AND. prev_cal_id.NE.unspecified_int4) THEN
	   CALL reset_secs_from_bc (-cx_lo_ww(idim,cx), 
     .		     new_lo_ww, prev_cal_id, cal_id, istat)

	   IF (istat .ne. ferr_ok) GO TO 5000
	   CALL reset_secs_from_bc (-cx_hi_ww(idim,cx), 
     .		     new_hi_ww, prev_cal_id, cal_id, istat)
	   IF (istat.ne. ferr_ok) GO TO 5000
	   cx_cal_id(cx) = cal_id
	ELSE
	   new_lo_ww = -1*cx_lo_ww(idim,cx)
	   new_hi_ww = -1*cx_hi_ww(idim,cx)
	ENDIF

	cx_lo_ww(idim,cx) = (new_lo_ww-bc_to_t0)/line_tunit(axis)
	cx_hi_ww(idim,cx) = (new_hi_ww-bc_to_t0)/line_tunit(axis)

* For a true-month axis, set the coordinate accurately.

	true_month = ITSA_TRUEMONTH_AXIS(axis)

	IF (true_month) THEN
	
	
	   CALL TM_MONTH_TIME_FACTOR (grid, true_month, timefac)

* Hack: Make the request lie inside the cell, if the upper limit is on 
* the boundary. A request for 01-jan-yyy1 to 01-oct-yyy2 should end with
* the grid cell of sep-yyy2, not in the cell that starts at 1-oct-yyy2
* Shift the upper-limit by one second.

           tcoord = (new_lo_ww-bc_to_t0)/line_tunit(axis)
	   CALL TM_TCOORD_TRUMONTH (axis, tcoord, box_middle, new_lo)

* See if the upper limit corresponds to 01-mmm-yyyy 00:00:00
	   ndec = 6
	   tcoord = cx_hi_ww(idim,cx) * timefac
           CALL TRANSLATE_TO_WORLD( tcoord, idim, 
     .                      dgrid_buff, ndec, datestring )
	   day_of_mo = datestring

	   tcoord = (new_hi_ww-bc_to_t0)/line_tunit(axis)
	   IF (day_of_mo .EQ. '01' .AND. 
     .         INDEX(datestring, '00:00:00') .GT. 0) 
     .          tcoord = (new_hi_ww-bc_to_t0-1)/line_tunit(axis)

	   CALL TM_TCOORD_TRUMONTH (axis, tcoord, box_middle, new_hi)

* Convert to days
	   CALL TM_MONTH_TIME_FACTOR (grid, true_month, timefac)

	   cx_lo_ww(idim,cx) = timefac* new_lo
	   cx_hi_ww(idim,cx) = timefac* new_hi
        ENDIF
 

* also fix the world limits for cx_cmnd, if they were originally set 
* using default calendar
* Fix for bug 1365: if the limits for cx_cmnd were not set, do not set them here

	IF ( (cx_lo_ww(idim,cx_cmnd) .NE. unspecified_val8)  .AND.
     .             (cx_cal_id(cx_cmnd) .NE. unspecified_int4)  .AND.
     .             (cal_id .NE. prev_cal_id) ) THEN   
	   cx_lo_ww(idim,cx_cmnd) = -1*new_lo_ww
	   cx_hi_ww(idim,cx_cmnd) = -1*new_hi_ww
	   cx_cal_id(cx_cmnd) = cal_id
	ENDIF

 4000	status = ferr_ok
	RETURN
 5000   status = istat
	RETURN
	END

	SUBROUTINE IS_STRING(  *, *, status )

* create a string  "variable" in memory

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V500:  1/99 - based on IS_CONST_VAR
* V530:  8/00 *sh* - support for string arrays -- use dynamic memory alloc
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V693+ *sh* 12/14 support for _DQ_ and _SQ_ string delimiters

	include	'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xvariables.cmn'
	include	'xcontext.cmn'
	include	'xprog_state.cmn'

* calling argument declarations:
	INTEGER	status

* internal variable declarations:
	INTEGER	MGRID_SIZE, mr, cx, uvar, item, start, end

* --- end of introductory code ---

* NOTE: it is by historical accident that this routine exists at all.
* To be fully consistent the string variables created by this routine should
* be created by is_constant with a cx_type of ptype_string and a cx_category
* of cat_constant. So it goes ...

* This routine extracts the sring given in a user variable definition and
* inserts it into a Ferret string variable. The string, itself, is stored
* in dynamic storage via C. The pointer to the string is put into the
* Ferret mr storage.

* initialize
	cx = is_cx( isp )

* reserve and catalog space for the pointer(s) to the string
	CALL CREATE_MEM_VAR( cx, mr, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	is_mr( isp ) = mr

* save the pointer array address in cx_c_pointer
	CALL INIT_C_STRING_ARRAY( MGRID_SIZE(mr),
     .				  memry(mr)%ptr,
     .				  mr_c_pointer(mr)      )

* determine the string to be stored
	uvar = cx_variable(cx)/1000
	item = cx_variable(cx) - 1000*uvar
	start = uvar_item_start( item, uvar )
	end   = uvar_item_end  ( item, uvar )

* trim off surrounding quotation marks
	IF (uvar_text(uvar)(start:start) .EQ. '"'
     . .OR. uvar_text(uvar)(start:start) .EQ. "'" ) THEN
! trim off single or double quotes
	  start = start + 1
	  end = end - 1
	ELSEIF (end-start .GT. 7) THEN  ! should always be true if here
! trim off "_DQ_" or "_SQ_"
	  start = start + 4
	  end = end - 4
	ENDIF

* save the string in dynamic memory
	CALL STORE_STRING(uvar_text(uvar)(start:end),
     .			  mr, 0, status)
	IF (status .NE. ferr_ok) GOTO 5000

* diagnostic output
	IF (mode_diagnostic) CALL DIAGNOSTIC_OUT('string',mr,point_to_mr)

* set the bad data flag
	mr_bad_data( mr ) = bad_val4

* got the requested component
	status = ferr_ok
	RETURN 2
! RETURN 1, which is to request a sub-component, is never used ...

* error exit
 5000	RETURN
	END	

*
* lsl_lowpass.F
*
* LSL-low_pass_filter from Ned Cokelet.
*  Ansley Manke
*  Dec 6 1999
*
* Returns the argument filtered with Least Squares Lanzcos filter in time.
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE lsl_lowpass_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CHARACTER*100 label

      WRITE (label, 10) 
   10 FORMAT ( 'Returns Least Squares Lanzcos filter of ',
     .         'equally-spaced time series' )
      CALL ef_set_desc(id,label)

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 3)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_desc(id, arg, 'data to be filtered')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'cutoff_period')
      CALL ef_set_arg_desc(id, arg, 
     .        'period at which filter attains 1/2 amplitude. <=N')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'filter_span')
      CALL ef_set_arg_desc(id, arg, 
     . 'number of input data points used in each filtered output point')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE lsl_lowpass_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER mt
      INTEGER iwork
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      mt = 1 + arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1)

*  x -- input time series
      iwork = 1
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                               mt, 1, 1, 1, 1, 1)

*  y -- output time series
      iwork = 2
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                               mt, 1, 1, 1, 1, 1)

*  h -- work array for subroutine LSL_low_pass_filter

      iwork = 3
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                               mt, 1, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END



*
* In this subroutine we compute the result
*
      SUBROUTINE lsl_lowpass_compute(id, arg_1, arg_2, arg_3, result, 
     .                               x, y, h)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

      REAL x(wrk1lox:wrk1hix, wrk1loy:wrk1hiy,
     .       wrk1loz:wrk1hiz, wrk1lot:wrk1hit,
     .       wrk1loe:wrk1hie, wrk1lof:wrk1hif)
      REAL y(wrk2lox:wrk2hix, wrk2loy:wrk2hiy,
     .       wrk2loz:wrk2hiz, wrk2lot:wrk2hit,
     .       wrk2loe:wrk2hie, wrk2lof:wrk2hif)
      REAL h(wrk3lox:wrk3hix, wrk3loy:wrk3hiy,
     .       wrk3loz:wrk3hiz, wrk3lot:wrk3hit,
     .       wrk3loe:wrk3hie, wrk3lof:wrk3hif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER nn, nt
      INTEGER filter_span
      REAL cutoff_period
      CHARACTER*255 err_msg


*  Get argument and result subscripts and bad-data flags.

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*  Get cutoff parameter.

      i = arg_lo_ss(X_AXIS,ARG2)
      j = arg_lo_ss(Y_AXIS,ARG2)
      k = arg_lo_ss(Z_AXIS,ARG2)
      l = arg_lo_ss(T_AXIS,ARG2)
      m = arg_lo_ss(E_AXIS,ARG2)
      n = arg_lo_ss(F_AXIS,ARG2)
      cutoff_period = arg_2(i,j,k,l,m,n)

*  Get time percent parameter.

      i = arg_lo_ss(X_AXIS,ARG3)
      j = arg_lo_ss(Y_AXIS,ARG3)
      k = arg_lo_ss(Z_AXIS,ARG3)
      l = arg_lo_ss(T_AXIS,ARG3)
      m = arg_lo_ss(E_AXIS,ARG3)
      n = arg_lo_ss(F_AXIS,ARG3)
      filter_span = arg_3(i,j,k,l,m,n)

*  Get N = length of time series.

      nt = 1 + arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1)

      IF (filter_span .GT. nt) THEN
         WRITE (err_msg, 10)
   10    FORMAT('LSL_FILTER: The filter span must be less than or ', 
     .             'equal to the number of points')
         GOTO 999
      ENDIF
 
      n1 = arg_lo_ss(F_AXIS,ARG1)
      DO 600 n=res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

      m1 = arg_lo_ss(E_AXIS,ARG1)
      DO 500 m=res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

      k1 = arg_lo_ss(Z_AXIS,ARG1)
      DO 300 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 200 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            i1 = arg_lo_ss(X_AXIS,ARG1)
            DO 100 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

* Compute the filtered time series.

               nn = 1
               DO 400 l1=arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)
                  x(nn,1,1,1,1,1) = arg_1(i1,j1,k1,l1,m1,n1)
                  nn = nn + 1
 400           CONTINUE

               CALL LSL_low_pass_filter (x, nt, cutoff_period, 
     .                           bad_flag(ARG1), filter_span, h, y)

*  Put the filtred series in result

               nn = 1
               DO 410 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
                  IF ( y(nn,1,1,1,1,1) .NE. bad_flag(ARG1) ) THEN
                     result(i,j,k,l,m,n) = y(nn,1,1,1,1,1)
                  ELSE
                     result(i,j,k,l,m,n) = bad_flag_result
                  ENDIF
                  nn = nn + 1
 410           CONTINUE


               i1 = i1 + arg_incr(X_AXIS,ARG1)
 100        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 200     CONTINUE

         k1 = k1 + arg_incr(Z_AXIS,ARG1)
 300  CONTINUE

         m1 = m1 + arg_incr(E_AXIS,ARG1)
 500  CONTINUE

         n1 = n1 + arg_incr(F_AXIS,ARG1)
 600  CONTINUE

      RETURN

 999  CALL ef_bail_out (id, err_msg)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

      subroutine LSL_low_pass_filter( 
     1  x, N, cutoff_period, missing_value, filter_span, h, y )
c
c Least Squares Lanczos (LSL) low-pass filter:  This subroutine 
c low-pass filters an equally spaced time series using least-squares 
c approximation to the ideal low-pass filter of Bloomfield with Lanczos 
c convergence factors.  It is very similar to subroutine LOPASS in 
c Chapter 6, p. 149, of
c 
c Bloomfield, P., 1976, Fourier Analysis of Time Series: An 
c    Introduction, John Wiley & Sons, New York, 258 pp.
c
c The main difference is that the present routine takes account of
c missing values in the input time series.
c
c Inputs:
c
c x(N) = a real array of equally spaced points to low-pass filter
c N    = the number of points in x
c cutoff_period = the cutoff period (the period at which the filter
c                 attains 1/2 amplitude or 1/4 "energy") measured in
c                 units of delta t.  The cutoff_period must be less than
c                 or equal to N.
c filter_span = the number of input data points used in each filtered
c               output point.  A wide filter gives a narrow frequency
c               response transition band, but leads to ringing near
c               data discontinuities and loss of filtered values at the
c               end points and surrounding missing values.  A narrow
c               filter reduces ringing and output data loss, but gives
c               a wider frequency transition width, i.e. it falls off
c               less rapidly at freqs. higher than the cutoff.
c               The filter transition region lies in the period range
c               between N*cutoff_period/(N + cutoff_period) and 
c               N*cutoff_period/(N - cutoff_period). 
c missing_value = the missing value flag that signals to exclude flagged
c                 values from the computation.
c Outputs:
c
c filter_span = the filter span should be an odd integer.  It is set to 
c               the next lower odd number if the input is even.
c y(N)        = the output array of filtered values.  Values near the
c               ends and near gaps are filled with the missing value
c               flag.
c
c Note on tidal filtering:  For hourly time series containing tidal
c signals, some investigators use this filter with a 35-hour cutoff period
c and a filter span of xxx hours to remove at least 99.5 % of the energy for
c periods less than 25 hours.
c
c Adapted from Bloomfield by E. D. Cokelet, NOAA/PMEL, 3 Dec 1999    
c
c        1         2         3         4         5         6         7
c23456789012345678901234567890123456789012345678901234567890123456789012
c

c acm  explicitly define and type all variables
      integer n, i, j, ib, ie
      real cutoff_period, missing_value
      real*8 pi, omega_c, h0, con, summ, temp, x1, x2, d1, d2

      integer filter_span, half_span
      real x(*), h(*), y(*)

c      d(z) = sin(z)/z      ! define statement function  (doesnt work on osf)

      pi = 4.*atan(1.d0)

c Make sure filter span is odd
c
      half_span = int( (filter_span - 1) / 2 )
      filter_span = 2*half_span + 1
c
c
c Calculate the filter weights and normalize them
c
      omega_c = 2 * pi / cutoff_period
c
      h0 = omega_c / pi
      con = 2.*pi/float(filter_span)
      summ = h0
      do 10 i = 1, half_span
         d1 = sin(float(i)*omega_c)/ (float(i)*omega_c)
         d2 = sin(float(i)*con)/ (float(i)*con)
c         h(i) = h0 * d( float(i)*omega_c ) * d( float(i)*con )
         h(i) = h0 * d1 * d2
         summ = summ + 2. * h(i)
 10   continue
c
      h0 = h0/summ
      do 20 i = 1, half_span
         h(i) = h(i) / summ
 20   continue
c
c
c Put missing_value in the first and last half_span elements to
c account for end effects
c
      do 30 i =1, half_span
         y(i) = missing_value
         j = N - i + 1
         y(j) = missing_value
 30   continue
c
c
c Filter by convolving.  
c To account for gaps in the time series, set to missing any filtered
c values that would require missing values to compute them.
c
      ib = half_span + 1
      ie = N - half_span
c
      do 50 i = ib, ie
         if (x(i) .eq. missing_value) then
            temp = missing_value
            go to 45
         end if
         temp = h0 * x(i)
         do 40 j = 1, half_span
   	    x1 = x(i - j)
   	    x2 = x(i + j)
   	    if ( ( x1 .eq. missing_value ) .or. 
     1          ( x2 .eq. missing_value ) ) then
   		temp = missing_value
   		go to 45
   	    end if
	    temp = temp + h(j) * ( x1 + x2 )
 40      continue
 45      continue
         y(i) = temp

 50   continue
c
      return
      end

c      real*8 function d(z)
c
cc      d(z) = sin(z)/z      ! define statement function  (doesnt work on osf)
c
c      real z
c      d = sin(z)/ z
c
c      return
c      end

	INTEGER FUNCTION NEST_REGION_CLASS( idim, cx, uvar )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine the region-limits class (uvar_given) of a user-defined variable
* used as a component in another user-defined variable

* for example,	DEFINE VARIABLE A = U[K=@AVE]
*		DEFINE VARIABLE B = A[K=1:5] * 5
* references to B have the K limits reduced to a point although it isn't
* evident in the definition of B, alone.  This routine is used to determine
* the uvar_given character of A[K=1:5] used as a component in B.

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  7/18/89
* V230:  1/27/92 - changed uvlim_*_hi (unused) to uvlim_*_lohi to describe
*                  @WEQ - exaxt limits required but a range of data
*                - also added @RSUM (like @IIN)
*           ==>  commandeered "hi" to become "lohi" for @WEQ
*    note: those table entries using "lohi" are less thoroughly tested
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'	
	include 'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'

* calling argument declarations
	INTEGER	idim, cx, uvar

* local variable declarations
	INTEGER	REGION_CLASS, iins, iout, nested(0:3,0:3)

* local parameter declarations
	INTEGER		gnl,   lo,   lohi,   xact
	PARAMETER     ( gnl=0, lo=1, lohi=2, xact=3 )

* * * * NESTING TABLE * * * *
*			    ---  underlying user var definition  ---
* (paradigm)	      U[K=1:5]	     U[K=@IIN]	     U[K=@WEQ]	    U[K=@AVE]
*			gnl		lo		lohi		xact
*		--------------------------------------------------------------
* N C |	gnl	|	gnl		lo		lohi		xact |
* E O |	lo	|	 lo		lo		lohi		xact |
* W M |	lohi	|	lohi		lohi		lohi		xact |
*   P |	xact	|	xact		xact		xact		xact |
*		--------------------------------------------------------------
* across the top of the table we have the class of the underlying definition
* on the left we have the manner in which the new component is referenced
* for example, if "DEFINE VARIABLE A=U[K=@AVE]" defines the underlying var
*	       and "A[K=1:5]" is the new component then the column is "xact"
*	       and the row is "gnl" indicating that the result is "xact".
* (This makes sense as the new component will function like A[K=1:5@AVE]
*	- reducing to a point and requiring an exact match to locate it in mem.)
*  or (ex#2)   if "DEFINE VARIABLE A=U" defines the underlying var
*	       and "A[K=@AVE]" is the new component then the column is "gnl"
*	       and the row is "xact" indicating that the result is "xact".

* gnl  == no match required e.g. "U"		or "U[K=1:5]"
* lo   == match lo limit    e.g. "U[K=@IIN]"	or "U[K=1:5@IIN]"
* lohi == match both limits (range of data)  e.g. "U[K=@WEQ]"
* xact == match both limits (single point)   e.g. "U[K=@AVE]"
* "xact" is special because it refers to transformations that reduce a range
*	of data to a point (like averaging).

	DATA	(nested(iins,0),iins=0,3) / gnl,   lo, lohi, xact /,
     .		(nested(iins,1),iins=0,3) /  lo,   lo, lohi, xact /,
     .		(nested(iins,2),iins=0,3) /lohi, lohi, lohi, xact /,
     .		(nested(iins,3),iins=0,3) /xact, xact, xact, xact /

**************************************************************************

* terminology: in the example reference of A[K=1:5] where DEF VAR A=U[K=@AVE]
* the "A[K=1:5]" is referred to as the "outside reference" and "U[K=@AVE]" is
* the inside reference

* get region-limits class of outside reference
	iout = REGION_CLASS( idim, cx )

* get region-limits class of inside reference
	iins = MOD( uvar_given(idim,uvar), 4 )

* pull nested reference from table
	NEST_REGION_CLASS = nested( iins, iout )
	
	RETURN
	END

	SUBROUTINE init_random_seed(inseed)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Set seeds for calls to RANDOM_NUMBER.
* Both RANDOM_NUMBER and RANDOM_SEED are part of the gfortran library.
*
* This routine based on init_random_seed from the gfortran documentation
* except that the input argument inseed determines seeding as follows:
*  inseed = 0 return. Continue to use the seeding that's currently in effect
*  inseed = -1 use the system clock to initialize the seed
*  inseed = N > 0 use N to initialize the seed, for repeatable results.

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*


	INTEGER :: inseed
	INTEGER :: i, n, clock
	INTEGER, DIMENSION(:), ALLOCATABLE :: seed

	INTEGER iseed

	iseed = inseed
	IF (inseed .EQ. 0) RETURN

	CALL RANDOM_SEED(size = n)
	ALLOCATE(seed(n))

	IF (inseed .EQ. -1) THEN
	   CALL SYSTEM_CLOCK(COUNT=clock)
	   iseed = clock
	ENDIF
	seed = iseed + 37 * (/ (i - 1, i = 1, n) /)
	CALL RANDOM_SEED(PUT = seed)

	DEALLOCATE(seed)
	END SUBROUTINE

*
* zaxreplace_bin.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* Oct 1999
* 11/2001  clarify function description
*  7/2003  fix bug in finding the source points in this destination box

* Replace Z axis, using unweighted averaging over bins.
* Find the source points within each destination box, average them.

* Points that match a destination box edge are arbitrarily put in the
* box whose lower bound they match, e.g. 500 is put in the500-600 box 
* not the 400-500 box. 
*


*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE zaxreplace_bin_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CHARACTER*100 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT('regrid V onto Z axis of ZAX based on Z values in ZVALS ',
     .       'using unweighted average')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 2)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'V')
      CALL ef_set_arg_desc(id, arg,
     .        'Variable on native Z axis')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, NO, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'ZVALS')
      CALL ef_set_arg_desc(id, arg,
     .        'Destination Z axis values as a fcn of source Z axis')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'ZAX')
      CALL ef_set_arg_desc(id, arg,
     .        'Variable with desired Z (depth) axis points')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, YES, NO, NO, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE zaxreplace_bin_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER mz3
      INTEGER iwork

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

*  Allocate double the dimension of the input arguments for work arrays
*  which will be REAL*8
      mz3 = 1 + ABS(arg_hi_ss(Z_AXIS,ARG3) - arg_lo_ss(Z_AXIS,ARG3))
      mz3 = 2 * mz3

*  dbox_lo_lim
      iwork = 1
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                              mz3, 1, 1, 1, 1, 1)

*  dbox_hi_lim
      iwork = 2
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                              mz3, 1, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE zaxreplace_bin_compute(id, arg_1, arg_2, arg_3,
     .                          result, dbox_lo_lim, dbox_hi_lim)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz,
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* Ignore the Y/Z/T/E/F dimensions in the work arrays since
* they are not used and Fortran is column major
      REAL*8 dbox_lo_lim(wrk1lox:wrk1hix/2)
      REAL*8 dbox_hi_lim(wrk2lox:wrk2hix/2)

* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable''s axes.

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, l1, m1, n1
      INTEGER i2, j2, l2, m2, n2
      INTEGER i3, j3, l3, m3, n3
      INTEGER nsrc, nsrc_lo, nsrc_hi
      REAL*8 sum
      REAL count, arg1_val

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      CALL ef_get_box_limits(id, ARG3, Z_AXIS, arg_lo_ss(Z_AXIS, ARG3),
     .        arg_hi_ss(Z_AXIS, ARG3), dbox_lo_lim, dbox_hi_lim)

*
*  Loop over x,y,t,e,f of the input fields
*
      n1 = arg_lo_ss(F_AXIS,ARG1)
      n2 = arg_lo_ss(F_AXIS,ARG2)
      n3 = arg_lo_ss(F_AXIS,ARG3)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

      m1 = arg_lo_ss(E_AXIS,ARG1)
      m2 = arg_lo_ss(E_AXIS,ARG2)
      m3 = arg_lo_ss(E_AXIS,ARG3)
      DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

      l1 = arg_lo_ss(T_AXIS,ARG1)
      l2 = arg_lo_ss(T_AXIS,ARG2)
      l3 = arg_lo_ss(T_AXIS,ARG3)
      DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

      j1 = arg_lo_ss(Y_AXIS,ARG1)
      j2 = arg_lo_ss(Y_AXIS,ARG2)
      j3 = arg_lo_ss(Y_AXIS,ARG3)
      DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

      i1 = arg_lo_ss(X_AXIS,ARG1)
      i2 = arg_lo_ss(X_AXIS,ARG2)
      i3 = arg_lo_ss(X_AXIS,ARG3)
      DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

*
* -ACM- Note: need to think about backwards and forwards z axes: ht vs depth ?
*

* For each z line accumulate unweighted source points to get
* the average value.   Loop through the each destination grid box.

         DO 390 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

*  Find the first and last source point in this destination box
            nsrc_lo = 1
            DO WHILE ( arg_2(i2,j2,nsrc_lo,l2,m2,n2)
     .                 .LT. dbox_lo_lim(k) )
               nsrc_lo = nsrc_lo + 1
               IF ( nsrc_lo .GT. arg_hi_ss(Z_AXIS, ARG2) ) GO TO 310
            ENDDO
  310       CONTINUE

*  Find any portion of the source box lying in the destination box.
            nsrc_hi = 1
            DO WHILE ( arg_2(i2,j2,nsrc_hi,l2,m2,n2)
     .                 .LT. dbox_hi_lim(k) )
               nsrc_hi = nsrc_hi + 1
               IF ( nsrc_hi .GT. arg_hi_ss(Z_AXIS, ARG2) ) GO TO 320
            ENDDO
  320       CONTINUE
            nsrc_hi = nsrc_hi - 1

            IF ( nsrc_hi .LT. nsrc_lo ) THEN
*  No source points within this destination box.
               result(i,j,k,l,m,n) = bad_flag_result
*  Done with this Z result; go to the next one
               GO TO 390
            ENDIF

*  Average function values lying within the destination box.
            sum = 0.
            count = 0.
            DO 330 nsrc = nsrc_lo, nsrc_hi
               arg1_val = arg_1(i1,j1,nsrc,l1,m1,n1)
               IF ( arg1_val .NE. bad_flag(ARG1) ) THEN
                  sum = sum  + arg1_val
                  count = count + 1.
               ENDIF
  330       CONTINUE

* If we had any good data, calculate the average.
            IF ( count .NE. 0. ) THEN
               result(i,j,k,l,m,n) = sum / count
            ELSE
               result(i,j,k,l,m,n) = bad_flag_result
            ENDIF

 390     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
         i2 = i2 + arg_incr(X_AXIS,ARG2)
         i3 = i3 + arg_incr(X_AXIS,ARG3)
 100  CONTINUE

         j1 = j1 + arg_incr(Y_AXIS,ARG1)
         j2 = j2 + arg_incr(Y_AXIS,ARG2)
         j3 = j3 + arg_incr(Y_AXIS,ARG3)
 200  CONTINUE

         l1 = l1 + arg_incr(T_AXIS,ARG1)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
         l3 = l3 + arg_incr(T_AXIS,ARG3)
 400  CONTINUE

         m1 = m1 + arg_incr(E_AXIS,ARG1)
         m2 = m2 + arg_incr(E_AXIS,ARG2)
         m3 = m3 + arg_incr(E_AXIS,ARG3)
 500  CONTINUE

         n1 = n1 + arg_incr(F_AXIS,ARG1)
         n2 = n2 + arg_incr(F_AXIS,ARG2)
         n3 = n3 + arg_incr(F_AXIS,ARG3)
 600  CONTINUE

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN
      END

	BLOCK DATA NETCDF4_LIST_SETTINGS_DATA
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or 'bug fixes'.
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP 'AS IS' AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*       *acm* 2/16 add echunk and fchunk

*
* Initialize the settings for netcdf4 datasets and store them in common.

        IMPLICIT NONE
        include 'netcdf4_settings.cmn'

*
*	netcdf4_type	- netcdf format: 4=netcdf4, 3=netcdf3(=classic), 6=64-bit
*	xchunk_size     - chunk size in X direction
*	ychunk_size     - chunk size in Y direction
*	zchunk_size     - chunk size in Z direction
*	tchunk_size     - chunk size in T direction
*	echunk_size     - chunk size in E direction
*	fchunk_size     - chunk size in F direction
*	deflate_lev	- deflate level (0 for no deflate)
*	shuffle_flag    - shuffle - 0 or 1
*	endian_code     - native=0, little=1, big=0 match nf_endian_* params
*	cache_size_mb   - cache_chunk size in mbytes

	DATA netcdf4_type /3/
	DATA xchunk_size  /0/
	DATA ychunk_size  /0/
	DATA zchunk_size  /0/
	DATA tchunk_size  /0/
	DATA echunk_size  /0/
	DATA fchunk_size  /0/
	DATA deflate_lev  /0/
	DATA shuffle_flag /0/
	DATA endian_code  /0/
	DATA netcdf4_type_set /3/
	DATA xchunk_size_set  /0/
	DATA ychunk_size_set  /0/
	DATA zchunk_size_set  /0/
	DATA tchunk_size_set  /0/
	DATA echunk_size_set  /0/
	DATA fchunk_size_set  /0/
	DATA deflate_lev_set  /0/
	DATA shuffle_flag_set /0/
	DATA endian_code_set  /0/
	DATA default_cache_size  /0/

* cache_size_mb is obtained on initialization by a call to the netcdf library.

	END

*
*  extend.F
*
*  Simple test of axis extension.
*
*  Jonathan Callahan, October 1998
*

*
*  In this subroutine we provide information about the function
*
      SUBROUTINE extend_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,'text function for extending axes' )

      CALL ef_set_num_args(id, 1)
*
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS,        !^ Normaly 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)   !| set by
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)             !V default
*
*

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_desc(id, arg, 'anything')
      CALL ef_set_arg_unit(id, arg, 'un-normalized units')
      CALL ef_set_axis_extend(id, arg, X_AXIS, -1, 1)
      CALL ef_set_axis_extend(id, arg, Y_AXIS, -1, 1)
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

* 
*  In this subroutine we compute the result
* 
      SUBROUTINE extend_compute(id, a, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      REAL a(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .     mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .         arg_incr(4,EF_MAX_ARGS)
      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
*
      INTEGER i1, j1, k1, l1, id
      INTEGER i,  j,  k,  l

*
* get what we need
*
      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*
* =========
* Main Loop
* =========
* remember that the ARG1 axes are extended by -1,+1 in X and Y
*

             i1 = arg_lo_ss(X_AXIS,ARG1)+1
      DO 400 i  = res_lo_ss(X_AXIS),res_hi_ss(X_AXIS)

               j1 = arg_lo_ss(Y_AXIS,ARG1)+1
        DO 300 j  = res_lo_ss(Y_AXIS),res_hi_ss(Y_AXIS)

                k1 = arg_lo_ss(Z_AXIS,ARG1)
         DO 200 k  = res_lo_ss(Z_AXIS),res_hi_ss(Z_AXIS)

                 l1 = arg_lo_ss(T_AXIS,ARG1)
          DO 100 l  = res_lo_ss(T_AXIS),res_hi_ss(T_AXIS)


             IF ( a(i1  ,j1  ,k1,l1) .EQ. bad_flag(1).OR.
     .            a(i1+1,j1  ,k1,l1) .EQ. bad_flag(1)    ) THEN

                result(i,j,k,l) = bad_flag_result

             ELSE

                result(i,j,k,l) = a(i,j,k,l) * 0.5

             END IF


         l1 = l1 + arg_incr(T_AXIS,ARG1)
 100     CONTINUE

        k1 = k1 + arg_incr(Z_AXIS,ARG1)
 200    CONTINUE

       j1 = j1 + arg_incr(Y_AXIS,ARG1)
 300   CONTINUE

      i1 = i1 + arg_incr(X_AXIS,ARG1)
 400  CONTINUE
      
         
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

        subroutine stripit (instring,inlength,cchar,outstring,il)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)stripit.f	1.1    3/10/88
C**
C**
C***********************************************************************        C**
C**                 EPIC
C**
C***********************************************************************        C**
C**
c
c  Removes character cchar from instring(1:inlength).
c
c  Input:
c       instring = input string
c       inlength = length of input string
c       cchar = character to remove from instring
c  Output:
c       outstring = output string, equal to input string with character
c                   cchar removed remaining string compressed.
c       il = length of output string
c
        character*(*) instring,outstring
        character*1 cchar
c
        outstring=instring
        il=inlength
c
c  Get rid of "cchar"
c
200         i=index(outstring(1:il),cchar)
            if (i.eq.0) goto 300
            if (i .eq. 1) then
                outstring(1:il)=outstring(i+1:il)
                il=il-1
            else
                outstring(1:il)=outstring(1:i-1)//outstring(i+1:il)
                il=il-1
            endif
            goto 200
300     return
        end

      SUBROUTINE EF_GET_STRING_ARG_MAX_LEN(id, iarg, str_arg, smax)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*  acm 12/03  
*
* This returns the maximum length of the string elements of a string array
* which was passed as an argument to the external function.
*

      IMPLICIT NONE
      INCLUDE 'tmap_dims.parm'
      INCLUDE 'ferret.parm'
      INCLUDE 'errmsg.parm'
      INCLUDE 'xvariables.cmn'
      INCLUDE 'EF_Util.parm'

      INTEGER id, iarg, smax
      REAL str_arg(*)

      INTEGER max_line_len, mr, slen,
     .        i, j, k, l, m, n, 
     .        lox, hix, loy, hiy, loz, hiz,
     .        lot, hit, loe, hie, lof, hif
      INTEGER mr_list(EF_MAX_ARGS)
      CHARACTER buff*64
      PARAMETER (max_line_len = 512)
      
      INTEGER arg_lo_ss(nferdims,EF_MAX_ARGS),
     .        arg_hi_ss(nferdims,EF_MAX_ARGS),
     .        arg_incr (nferdims,EF_MAX_ARGS)

      CALL EF_GET_ARG_SUBSCRIPTS(id, arg_lo_ss, arg_hi_ss, arg_incr)
 
* The memory resident list was cached by Ferret and must be retrieved
* to be accessible to the external function.

      CALL EF_GET_MR_LIST(mr_list)
      mr = mr_list(iarg)

      IF ( mr .EQ. 0 ) THEN
* Do not call during custom axis creation time
          buff = 
     .     'Use ef_get_string_arg_element_len in the compute phase'
          GOTO 5000

* Check the variable type.

      ELSE IF (mr_type(mr) .NE. ptype_string) THEN
         WRITE (buff,4000) iarg
 4000    FORMAT ('Argument',I3,' is not a string')
         GOTO 5000
      ELSE
         lox = arg_lo_ss(X_AXIS,iarg)
         hix = arg_hi_ss(X_AXIS,iarg)
         loy = arg_lo_ss(Y_AXIS,iarg)
         hiy = arg_hi_ss(Y_AXIS,iarg)
         loz = arg_lo_ss(Z_AXIS,iarg)
         hiz = arg_hi_ss(Z_AXIS,iarg)
         lot = arg_lo_ss(T_AXIS,iarg)
         hit = arg_hi_ss(T_AXIS,iarg)
         loe = arg_lo_ss(E_AXIS,iarg)
         hie = arg_hi_ss(E_AXIS,iarg)
         lof = arg_lo_ss(F_AXIS,iarg)
         hif = arg_hi_ss(F_AXIS,iarg)


* Inside ef_get_string_arg_elem_len_sub, str_arg is an array of pointers (cast as REAL*8),
* and we can call GET_STRING_ELEMENT to get the length of a string element. 

          smax = 0
          DO 100 n = lof, hif
          DO 100 m = loe, hie
          DO 100 l = lot, hit
          DO 100 k = loz, hiz
          DO 100 j = loy, hiy
          DO 100 i = lox, hix
             CALL EF_GET_STRING_ARG_ELEM_LEN_SUB(lox, hix, loy, hiy,
     .                   loz, hiz, lot, hit, loe, hie, lof, hif,
     .                   str_arg, i, j, k, l, m, n, max_line_len, slen)
             smax = MAX(slen, smax)
 100      CONTINUE

      ENDIF

      RETURN

* return an error message     
 5000 CALL EF_BAIL_OUT(id, buff)
      STOP 'EF_BAIL_OUT returned in EF_GET_STRING_ARG_MAX_LEN'

      END

	REAL*8 FUNCTION TM_SECS_FROM_BC ( cal_id,
     .    year, month, day, hour, minute, second, status)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Will convert a date of yyyy-mm-dd hh:mm:ss to seconds since
* 0000-01-01 00:00:00
*
* Written 6/16/87 By Mark Verschell for PMEL/TMAP
*
* revision 0.00 - 06/16/87 - Initial Incarnation
* V530: *acm* 12/00 add calendar types; cal_id for time axes. This
*                   routine is just Jerry's tm_calendars_secs_from_bc
*       J Davison 10.20.99   Copied TM_SECS_FROM_BC() and modified to support
*                            multiple calendars.
*       *acm* 3/01  Treat Julian calendar as a separate case.
*       *acm* 8/02  Fix bug in Julian calendar computations where leap day was
*                   added twice for case where we are at the first year of a
*                   century.
* V63  *acm* 10/09 Changes for gfortran build

* Include files
        include 'calendar.decl'
        include 'calendar.cmn'
	include 'tmap_errors.parm'

* Argument definition

	INTEGER         cal_id,year, month, day, hour, minute, second,
     .			status
*
* Local Definitions
	INTEGER		secstat
	REAL*8		secs_in_minute, secs_in_hour, secs_in_day,
     .      secs_in_year, secs_in_century, total_secs,
     .      leap_yr_days

	PARAMETER	(secs_in_minute	 = 60.0,
     .      secs_in_hour	 = secs_in_minute*60.0,
     .      secs_in_day	 = secs_in_hour*24.0)


*****************************************************************************
*****************************************************************************


*****************************************************************************
* HANDLE GREGORIAN CALENDAR FIRST
*****************************************************************************
	if (cal_id .eq. gregorian) then

*	   INITIALIZE
	   leap_yr_days = cals_num_days(cal_id) + 1.0

	   secs_in_year	 = secs_in_day*cals_num_days(cal_id)
	   secs_in_century = 
     .      secs_in_day*(76*cals_num_days(cal_id) + 24*leap_yr_days)

*          ADD LOTS OF SECONDS FOR EACH CENTURY SINCE 0 DAY
	   total_secs = secs_in_century * INT(year/100)

*          ADD A DAY FOR EVERY 400 YEARS (LEAP YEAR AT CENTENNIAL)
	   total_secs = total_secs + secs_in_day*INT(year/400.+0.9975)

*          ADD A YEAR FOR EACH YEAR SINCE TURN OF CENTURY
	   total_secs = total_secs + secs_in_year*MOD(year,100)

*          ADD A DAY FOR EACH LEAP YEAR SINCE CENTENNIAL(EXCEPT FOR CENTENNIAL)
	   total_secs = 
     .      total_secs + secs_in_day*INT((MOD(year,100)-1)/4)

*          ADD SECONDS FOR NUMBER OF MONTHS
	   total_secs = total_secs +
     .       cals_days_before_month(month,cal_id)*secs_in_day

*          ADD 1 DAY WORTH OF SECONDS IF THIS IS LEAP YEAR AND PAST FEBRUARY
	   if (month .GT. 2) then
	      if (MOD(year,400) .EQ. 0) then
     	         total_secs = total_secs + secs_in_day
	      else
		 if (MOD(year,4) .EQ. 0 .AND. MOD(year,100) .NE. 0)
     .	             total_secs = total_secs + secs_in_day
	      endif
	   endif
*          ADD SECONDS FOR NUMBER OF DAYS
	   total_secs = total_secs + secs_in_day*(day-1)

*          ADD SECONDS FOR NUMBER OF HOURS
	   total_secs = total_secs + secs_in_hour*(hour)

*          ADD SECONDS FOR NUMBER OF MINUTES
	   total_secs = total_secs + secs_in_minute*(minute)

*          ADD SECONDS FOR NUMBER OF SECS FOR TOTAL NUMBER OF SECONDS
	   total_secs = total_secs + second

*****************************************************************************
* HANDLE JULIAN CALENDAR 
*****************************************************************************
	ELSE IF (cal_id .eq. julian) then

*	   INITIALIZE
	   leap_yr_days = cals_num_days(cal_id) + 1.0

	   secs_in_year	 = secs_in_day*cals_num_days(cal_id)
	   secs_in_century = 
     .      secs_in_day*(75*cals_num_days(cal_id) + 25*leap_yr_days)

*          ADD LOTS OF SECONDS FOR EACH CENTURY SINCE 0 DAY
	   total_secs = secs_in_century * INT(year/100+0.9975)

*          ADD A YEAR FOR EACH YEAR SINCE TURN OF CENTURY
	   total_secs = total_secs + secs_in_year*MOD(year,100)

*          ADD A DAY FOR EACH LEAP YEAR SINCE CENTENNIAL, PLUS 1 DAY FOR 
*          CENTENNIAL
*          !! IF THIS IS CENTENNIAL YEAR, THIS YEARS LEAP SECONDS ADDED BELOW

	   total_secs = 
     .      total_secs + secs_in_day*(INT((MOD(year,100)-1)/4))
	   IF (MOD(year,100) .NE. 0) total_secs = 
     .      total_secs + secs_in_day

*          ADD SECONDS FOR NUMBER OF MONTHS
	   total_secs = total_secs +
     .       cals_days_before_month(month,cal_id)*secs_in_day

*          ADD 1 DAY WORTH OF SECONDS IF THIS IS LEAP YEAR AND PAST FEBRUARY

	   if (month .GT. 2  .AND. MOD(year,4) .EQ. 0)
     .             total_secs = total_secs + secs_in_day

*          ADD SECONDS FOR NUMBER OF DAYS
	   total_secs = total_secs + secs_in_day*(day-1)

*          ADD SECONDS FOR NUMBER OF HOURS
	   total_secs = total_secs + secs_in_hour*(hour)

*          ADD SECONDS FOR NUMBER OF MINUTES
	   total_secs = total_secs + secs_in_minute*(minute)

*          ADD SECONDS FOR NUMBER OF SECS FOR TOTAL NUMBER OF SECONDS
	   total_secs = total_secs + second


******************************************************************************

******************************************************************************
* ALL OTHER SUPPORTED AND REGULAR CALENDARS
******************************************************************************
	ELSE IF (cal_id .GT. gregorian   .AND.  cal_id .NE. julian .AND.
     .           cal_id .LE. max_calendars) THEN

*	   INITIALIZE
	   secs_in_year	   = secs_in_day*cals_num_days(cal_id)
	   if (cal_id .eq. julian) secs_in_year	   = secs_in_day*365.25
	   secs_in_century = 100*secs_in_year

*          ADD LOTS OF SECONDS FOR EACH CENTURY SINCE 0 DAY
	   total_secs = secs_in_century * INT(year/100)

*          ADD A YEAR FOR EACH YEAR SINCE TURN OF CENTURY
	   total_secs = total_secs + secs_in_year*MOD(year,100)

*          ADD SECONDS FOR NUMBER OF MONTHS
	   total_secs = total_secs + 
     .            cals_days_before_month(month,cal_id)*secs_in_day

*          ADD SECONDS FOR NUMBER OF DAYS
	   total_secs = total_secs + secs_in_day*(day-1)

*          ADD SECONDS FOR NUMBER OF HOURS
	   total_secs = total_secs + secs_in_hour*(hour)

*          ADD SECONDS FOR NUMBER OF MINUTES
	   total_secs = total_secs + secs_in_minute*(minute)

*          ADD SECONDS FOR NUMBER OF SECS FOR TOTAL NUMBER OF SECONDS
	   total_secs = total_secs + second

	ELSE
           secstat = merr_syntax
	   CALL ERRMSG (secstat, status, 
     .       'Illegal calendar in tm_secs_from_bc()', *5000)
	ENDIF

*       FINISHED
	tm_secs_from_bc = total_secs
5000	return
	end

	SUBROUTINE CDF_LIST_DSETVAR_ATTS (dset, itsa_uvar, its_cdf, varid, 
     .          varcode, bad, outtype, cdfid, do_warn, scalefac, addoff,
     .          got_title, output_title, got_history, output_history, 
     .          got_units, output_units, status )

* 2/2019  Ansley Manke
* NOAA/PMEL, Seattle, WA - Science Data Integration Group

* On writing to netCDF, write out the attributes from the source dataset
* as requested by the user, who may set the variable to write all attributes,
* or only specific ones.

* v751 *acm*  6/19 Allow for longer strings as attribute values


        include 'netcdf.inc'
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'

	LOGICAL itsa_uvar, its_cdf, do_warn, got_title, output_title, 
     .          got_history, output_history, got_units, output_units
	INTEGER dset, varid, outtype, cdfid, status
	CHARACTER*(*) varcode
	REAL	bad


	LOGICAL NC_GET_ATTRIB_DP, NC_GET_ATTRIB, MATCH_NAME,
     .          got_it, got_fill, got_missing, coordvar
	INTEGER TM_LENSTR1, TM_CHECK_NAN, 
     .          attoutflag, no_fill_flag, no_missing_flag, attid, attype, 
     .          attlen, iatt, nvatts, slen, alen, all_outflag, maxlen, 
     .          lbuff, nvdims, vdims(8), vtype
	REAL vals(100), miss_in, fill_in, scalefac, addoff
	CHARACTER attname*128, vbuff*128
	CHARACTER*1024 buff

* For error messages
      CHARACTER*9 typnam(6)
      DATA typnam/'NC_BYTE', 'NC_CHAR', 'NC_SHORT', 'NC_INT', 
     .            'NC_FLOAT', 'NC_DOUBLE'/


* Set up to write all the attributes from a file ivariable

* Initialize

	maxlen = 1024
	vbuff = varcode
	
	status = NF_INQ_VARID(dset, vbuff, varid)
	CALL CD_GET_VAR_ID (dset, vbuff, varid, status)


* Output the bad flag used by Ferret (and _FillValue which has been made  
* the same as missing_flag)

	vals(1) = bad
	attlen = 1
	got_fill = .FALSE.

* Get attype for missing flag

	attoutflag = 0
	no_missing_flag = 1
	no_fill_flag = 0  ! Write _fillValue unless specifically told not to

	attname = 'missing_value'
	CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)
	IF (attid .GT. 0) THEN
	   no_missing_flag = 0
	   CALL CD_GET_VAR_ATT_INFO (dset, varid, 
     .                attid, attname, attype, attlen, attoutflag, status )
	   IF (attoutflag .EQ. 0) no_missing_flag = 1
	   IF (attoutflag .NE. 0) got_it = NC_GET_ATTRIB_DP 
     .                (dset, varid, attname, do_warn, vbuff, attlen, 
     .                attoutflag, miss_in)
	ELSE
	   attname = '_FillValue'
	   CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)
	   IF (attid .GT. 0) THEN
	      no_fill_flag = 0
	      CALL CD_GET_VAR_ATT_INFO (dset, varid, 
     .                attid, attname, attype, attlen, attoutflag, status )
	      IF (attoutflag .EQ. 0) no_fill_flag = 1
	   ENDIF
	ENDIF

	IF (no_missing_flag .EQ. 1) THEN
	  attname = '_FillValue'
	  CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)
	  IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, varid, 
     .                attid, attname, attype, attlen, attoutflag, status )
	   IF (attoutflag .EQ. 0) no_fill_flag = 1
	ENDIF

* If the data is numeric, check the missing flag, getting the original one, 
* and write with the output type

	IF (status .EQ. ferr_ok .AND. outtype .NE. nf_char) THEN

* If un-scaling on output, write the original missing flag.
	   IF (scalefac .NE. 1.D0  .OR. addoff .NE. 0.D0) THEN
	      vals(1) = miss_in
	      vals(1) = vals(1)

* Otherwise convert missing flag to requested output type for the variable
	   ELSE
	      IF (attype .NE. outtype .AND. status .EQ. ferr_ok)  THEN
	         alen = TM_LENSTR1(typnam(attype))
	         slen = TM_LENSTR1(typnam(outtype))
	         IF ((.NOT.itsa_uvar) .AND. (dset .GT. 0 .AND. do_warn)) 
     .	          CALL WARN ('Converting data type of missing_value '//
     .	           typnam(attype)(1:alen)//' to match output type of variable '//
     .	           typnam(outtype)(1:slen) )
	      ENDIF
	   ENDIF
	   attype = outtype
  
	   IF (attoutflag .EQ. 1) THEN
	      IF (no_missing_flag.EQ.0) THEN
	         CALL CD_WRITE_ATTVAL_DP(
     .	                    cdfid, vbuff, 'missing_value', vals, attlen, 
     .	                    attype, status )
	         IF (status .NE. ferr_ok) GOTO 5000
	         got_missing = .TRUE.

	         IF (dset .EQ. pdset_uvars) THEN 
	            CALL CD_WRITE_ATTVAL_DP(
     .	              cdfid, vbuff, '_FillValue', vals, attlen, 
     .	              attype, status )
	            IF (status .NE. ferr_ok) GOTO 5000
	            got_fill = .TRUE.
	         ENDIF
	      ENDIF

* Ferret doesn't keep the values corresponding to two flags in the data that it stores.
* If there was a _FillValue in the input file, and its the bad-flag, write it.
* Issue #1883: If there is a _FillValue and it's NaN, it will be different from the
* bad-flag. We do want to write it.

	      IF (.NOT.got_fill ) THEN 
	         attname = '_FillValue'
	         CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)
	         IF (attid .GT. 0) 
     .	            CALL CD_GET_VAR_ATT_INFO (dset, varid, 
     .	            attid, attname, attype, attlen, attoutflag, status )
	         IF (attoutflag .EQ. 0) no_fill_flag = 1
	         got_it = .FALSE.
	         IF (attoutflag .NE. 0) got_it = NC_GET_ATTRIB_DP
     .	            (dset, varid, attname, do_warn, vbuff, attlen, 
     .	             attoutflag, fill_in)
	         IF ( TM_CHECK_NAN(fill_in) .EQ. 1   ) fill_in = bad
	         IF (got_it .AND. (fill_in.EQ.bad .OR. fill_in.EQ.miss_in) ) THEN
	            vals(1) = fill_in
	            vals(1) = vals(1)
	            attype = outtype
	         ELSE
		    IF (its_cdf .AND. .NOT.itsa_uvar) no_fill_flag = 1
	         ENDIF
	      ENDIF
	      IF (no_fill_flag .EQ. 0) THEN
		 CALL CD_WRITE_ATTVAL_DP(
     .	           cdfid, vbuff, '_FillValue', vals, attlen, 
     .	           at type, status )
		 got_fill = .TRUE.	  
	      ENDIF

	   ENDIF
	ENDIF ! status 


* Get vbuff into original upper/lowercase form. If mode upcase_output is set, 
* then upcase the variable name.

	CALL CD_GET_VAR_INFO (dset, varid, buff, vtype, 
     .	  nvdims, vdims, nvatts, coordvar, all_outflag, status) 
	vbuff = buff
	IF (mode_upcase_output) CALL STR_UPCASE( vbuff, buff)

	DO 200 iatt = 1, nvatts
	   CALL CD_GET_VAR_ATT_NAME( dset, varid, iatt, attname, status)
	   CALL CD_GET_VAR_ATT_INFO (dset, varid, iatt, attname, 
     .	     attype, attlen, attoutflag, status )
	        
	   slen = TM_LENSTR1(attname)
	   IF ( MATCH_NAME (attname,  slen, 'MISSING_VALUE', 13 ) .OR. 
     .	        MATCH_NAME (attname,  slen, '_FILLVALUE', 10 ) ) CYCLE   ! done already

	   IF ( MATCH_NAME (attname,  slen, 'SCALE_FACTOR', 12 ) .OR. 
     .	        MATCH_NAME (attname,  slen, 'ADD_OFFSET', 10 ) ) THEN
	      got_it = NC_GET_ATTRIB_DP (dset, varid, attname,
     .	             do_warn, vbuff, attlen, attoutflag, vals)
	      IF (attoutflag  .EQ. 1) CALL CD_WRITE_ATTVAL_DP (cdfid, vbuff,
     .	         attname, vals, attlen, attype, status )
	         IF (status .NE. ferr_ok) GOTO 5000
              CYCLE
	   ENDIF

	   attype = 0
	   attlen = 0
	   CALL CD_GET_VAR_ATT_INFO (dset, varid, iatt,
     .	         attname, attype, attlen, attoutflag, status )
     
	   IF (attype .NE. nf_char .AND. attlen .GT. 100) THEN
	      attlen = 100
	      alen = TM_LENSTR1(attname)
	      IF (do_warn) CALL WARN 
     .           ('writing only first 100 elements of attribute'//attname(1:alen))
	   ENDIF

	   IF (attype.EQ.nf_char .AND. attoutflag.EQ.1) THEN
	      got_it = NC_GET_ATTRIB ( dset, varid, attname, do_warn, vbuff, 
     .	            maxlen, attlen, attoutflag, buff, vals)
	      lbuff = TM_LENSTR1(buff)
	      CALL CD_WRITE_ATTRIB(cdfid, vbuff, attname, buff(:lbuff), .FALSE., status )

	   ELSE IF (attoutflag.EQ.1) THEN
	      got_it = NC_GET_ATTRIB ( dset, varid, attname, do_warn, vbuff, 
     .	            maxlen, attlen, attoutflag, buff, vals)
	      CALL CD_WRITE_ATTVAL_DP (cdfid, vbuff,attname, vals, attlen, attype, status )
	      IF (status .NE. ferr_ok) GOTO 5000

	   ENDIF

	   IF (MATCH_NAME (attname,  slen, 'LONG_NAME', 9 )) THEN
	      got_title = .TRUE.
	      output_title = (attoutflag .EQ. 1)
	   ENDIF

	   IF (MATCH_NAME (attname,  slen, 'UNITS', 5 )) THEN
	      got_units = .TRUE.
	      output_units = (attoutflag.EQ.1)
	   ENDIF

	   IF (MATCH_NAME (attname,  slen, 'HISTORY',  7 )) THEN
	      got_history = .TRUE.
	      output_history = (attoutflag.EQ.1)
	   ENDIF

 200	CONTINUE

! done getting attributes from linked-list structure

 5000	RETURN
	END

	LOGICAL FUNCTION GEOG_VAR( idim, cx )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine whether a particular axis of a VARIABLE represents geographical
* locations (lat.,long., etc.) requiring special label formatting

* V450: 3/97 - based on GEOG_LABEL
* *acm* 12/00 cleanup: TM_DATE_OK declared but not called
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction.

	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
        include 'tmap_errors.parm'
	external xgt_grid_data
        include 'xunits.cmn_text'
        external xunits_data
	include 'ferret.parm'
	include 'xtext_info.cmn'
	include 'xprog_state.cmn'
	include 'xcontext.cmn'

* calling argument declarations:
	INTEGER		idim, cx

* internal variable declarations:
	INTEGER		TM_UNIT_ID, units
	CHARACTER*80	VAR_UNITS

* initialize
	GEOG_VAR = .FALSE.	! default

* see if labeling modes are disabled, first
	IF ( .NOT.ax_fmt(idim) )  RETURN

* get the "units" that goes with the variable (context)
	units = TM_UNIT_ID( VAR_UNITS(cx) )

* do these units imply a formatt-ible axis
	IF ( (idim.EQ.t_dim .OR. idim.EQ.f_dim) .AND.
     .        (units.LT.pun_1st_time.OR.units.GT.pun_last_time)) THEN
	   GEOG_VAR = .FALSE.
!	   GEOG_VAR = .TRUE.		! where to get T0 ???
	ELSEIF ( (idim.EQ.x_dim.OR.idim.EQ.y_dim) .AND.
     .		units .EQ. pun_degrees ) THEN
	   GEOG_VAR = .TRUE.
	ELSEIF ( (idim.EQ.z_dim) .AND.
     .          ( units .EQ. pun_millibars
     .          .OR. units .EQ. pun_decibars
     .          .OR. units .EQ. pun_meters )  ) THEN
	   GEOG_VAR = .TRUE.
	ENDIF

	RETURN
	END

	SUBROUTINE STORE_STRING( text, mr, offset, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 


* Store a given FORTRAN character string into dynamic memory

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V530:  8/00 *sh*
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xvariables.cmn'

* calling argument declarations:
	INTEGER	mr, offset, status
!	REAL    memory( mem_blk_size, max_mem_blks )
	CHARACTER*(*) text

* internal variable declarations:
	INTEGER	clen, istat

* --- end of introductory code ---

* length of string to be stored
	clen = LEN(text)

* convert to a null-terminated C string
! instead we are using the assumption that FORTRAN character arrays are
! passed with the correct starting address
!	CALL GET_WORK_SPC( 1+clen/4, wrk1, status )
!	IF (status .NE. ferr_ok) RETURN

!	CALL TM_FTOC_STRNG (text,
!     .			    memory(1,wrk1), clen )

* allocate dynamic storage and save the pointer in the Ferret grid
	CALL SAVE_C_STRING(text, clen,
     .			   mr_c_pointer(mr), offset, istat )
	IF (istat .NE. 0) THEN
	   CALL ERRMSG(ferr_insuff_memory, status,
     .			'dynamic memory for string', *5000)
	ELSE
	   status = ferr_ok
	ENDIF

 5000	RETURN
	END	

	SUBROUTINE DEFINE_SPECIAL_GRIDS

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* define "pre_defined" grids not set up by TMAP_FORMAT COMMON

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

*
* V200:  6/22/89
*	10/23/89 - added ez_dflt
* V300: 6/93 - lengthened axis EZ x10 so that accidental truncations were rarer
* V500: 12/98 - added XABSTRACT, YABSTRACT, ZABSTRACT, and TABSTRACT
* V581*acm*  6/05 - For fix to bug 1271, add flag line_shift_origin
* V62 *acm*  2/09 - Save original upper/lowercase spelling of axis names 
*                   in line_name_orig for CANCEL MODE UPCASE
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
* V685 *acm*  6/13 Increase nominal length of abstract axis
* V698 *sh* 12/15 set up dummy (missing placeholder) dataset 

	include	'tmap_dims.parm'
	include	'tmap_errors.parm'
	include 'xunits.cmn_text'
	external xunits_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xdset_info.cmn_text'
	include	'ferret.parm'
	include	'xfr_grid.cmn'

* local variable declarations:
	INTEGER	TM_FIND_LINE_SLOT, TM_FIND_GRID_SLOT,
     .		iline, igrid, idim, iline_abstract, status

* "ABSTRACT" axis
* find a space to catalog it
	status = TM_FIND_LINE_SLOT( iline )
	IF ( status .NE. merr_ok ) GOTO 5000

* save the line in memory - but don't catalog its name
	line_name     ( iline ) = 'ABSTRACT'
	line_name_orig( iline ) = 'ABSTRACT'
	line_start    ( iline ) = 1.0D0
	line_delta    ( iline ) = 1.0D0
	line_dim      ( iline ) = 99999999
	line_regular  ( iline ) = .TRUE.
	line_modulo   ( iline ) = .FALSE.
	line_units    ( iline ) = ' '
	line_unit_code( iline ) = 0	! unknown units
	line_t0       ( iline ) = ' '
	line_shift_origin( iline ) = .FALSE.
	line_subsc1   ( iline ) = unspecified_int4	! since regular
	line_direction( iline ) = 'NA'
	iline_abstract = iline

* "ABSTRACT" grid
* find a space to catalog it
	status = TM_FIND_GRID_SLOT( igrid )
	IF ( status .NE. merr_ok ) GOTO 5000

* make grid with nferdims abstract axes
	DO 100 idim = 1, nferdims
	   grid_line    (idim, igrid) = iline_abstract
           grid_out_prod(idim, igrid) = .TRUE.
 100	CONTINUE	
	grid_rotation( igrid ) = 0.0
	grid_name    ( igrid ) = 'ABSTRACT'

* save pointer to grid
	mgrid_abstract = igrid


* "EZ" axis
* find a space to catalog it
	status = TM_FIND_LINE_SLOT( iline )
	IF ( status .NE. merr_ok ) GOTO 5000

* save the line in memory - but don't catalog its name
	line_name     ( iline ) = 'EZ'
	line_name_orig( iline ) = 'EZ'
	line_start    ( iline ) = 1.0D0
	line_delta    ( iline ) = 1.0D0
	line_dim      ( iline ) = 20480
	line_regular  ( iline ) = .TRUE.
	line_modulo   ( iline ) = .FALSE.
	line_units    ( iline ) = ' '
	line_unit_code( iline ) = 0	! unknown units
	line_t0       ( iline ) = ' '
	line_shift_origin( iline ) = .FALSE.
	line_subsc1   ( iline ) = unspecified_int4	! since regular
	line_direction( iline ) = 'NA'

* "EZ" grid
* find a space to catalog it
	status = TM_FIND_GRID_SLOT( igrid )
	IF ( status .NE. merr_ok ) GOTO 5000

* make grid with 1 axis, only
	DO 200 idim = 1, nferdims
	   grid_line    (idim, igrid) = mnormal
           grid_out_prod(idim, igrid) = .TRUE.
 200	CONTINUE	
	grid_line    (1, igrid) = iline    
	grid_rotation( igrid ) = 0.0
	grid_name    ( igrid ) = 'EZ'

* save pointer to grid
	mgrid_ez_dflt = igrid


* "XABSTRACT" grid
* find a space to catalog it
	status = TM_FIND_GRID_SLOT( igrid )
	IF ( status .NE. merr_ok ) GOTO 5000

* make grid with 1 abstract axis
	DO 300 idim = 1, nferdims
	   grid_line    (idim, igrid) = mnormal
           grid_out_prod(idim, igrid) = .TRUE.
 300	CONTINUE
	grid_line(x_dim, igrid) = iline_abstract
	grid_rotation( igrid ) = 0.0
	grid_name    ( igrid ) = 'XABSTRACT'

* save pointer to grid
	mgrid_xabstract = igrid

* "YABSTRACT" grid
* find a space to catalog it
	status = TM_FIND_GRID_SLOT( igrid )
	IF ( status .NE. merr_ok ) GOTO 5000

* make grid with 1 abstract axis
	DO 400 idim = 1, nferdims
	   grid_line    (idim, igrid) = mnormal
           grid_out_prod(idim, igrid) = .TRUE.
 400	CONTINUE
	grid_line(y_dim, igrid) = iline_abstract
	grid_rotation( igrid ) = 0.0
	grid_name    ( igrid ) = 'YABSTRACT'

* save pointer to grid
	mgrid_yabstract = igrid


* "ZABSTRACT" grid
* find a space to catalog it
	status = TM_FIND_GRID_SLOT( igrid )
	IF ( status .NE. merr_ok ) GOTO 5000

* make grid with 1 abstract axis
	DO 500 idim = 1, nferdims
	   grid_line    (idim, igrid) = mnormal
           grid_out_prod(idim, igrid) = .TRUE.
 500	CONTINUE
	grid_line(z_dim, igrid) = iline_abstract
	grid_rotation( igrid ) = 0.0
	grid_name    ( igrid ) = 'ZABSTRACT'

* save pointer to grid
	mgrid_zabstract = igrid

* "TABSTRACT" grid
* find a space to catalog it
	status = TM_FIND_GRID_SLOT( igrid )
	IF ( status .NE. merr_ok ) GOTO 5000

* make grid with 1 abstract axis
	DO 600 idim = 1, nferdims
	   grid_line    (idim, igrid) = mnormal
           grid_out_prod(idim, igrid) = .TRUE.
 600	CONTINUE
	grid_line(t_dim, igrid) = iline_abstract
	grid_rotation( igrid ) = 0.0
	grid_name    ( igrid ) = 'TABSTRACT'

* save pointer to grid
	mgrid_tabstract = igrid



* "EABSTRACT" grid
* find a space to catalog it
	status = TM_FIND_GRID_SLOT( igrid )
	IF ( status .NE. merr_ok ) GOTO 5000

* make grid with 1 abstract axis
	DO 700 idim = 1, nferdims
	   grid_line    (idim, igrid) = mnormal
           grid_out_prod(idim, igrid) = .TRUE.
 700	CONTINUE
	grid_line(e_dim, igrid) = iline_abstract
	grid_rotation( igrid ) = 0.0
	grid_name    ( igrid ) = 'EABSTRACT'

* save pointer to grid
	mgrid_eabstract = igrid



* "FABSTRACT" grid
* find a space to catalog it
	status = TM_FIND_GRID_SLOT( igrid )
	IF ( status .NE. merr_ok ) GOTO 5000

* make grid with 1 abstract axis
	DO 800 idim = 1, nferdims
	   grid_line    (idim, igrid) = mnormal
           grid_out_prod(idim, igrid) = .TRUE.
 800	CONTINUE
	grid_line(f_dim, igrid) = iline_abstract
	grid_rotation( igrid ) = 0.0
	grid_name    ( igrid ) = 'FABSTRACT'

* save pointer to grid
	mgrid_fabstract = igrid

* dummy dataset
	ds_name(pdset_dummy) = "(dummy)"
	ds_des_name(pdset_dummy) = "(dummy)"

	RETURN

 5000	STOP 'DFN_SPC_GRD'
	END

	SUBROUTINE ECHO(LINE,ILEN)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)echo.F	1.3    5/31/88
C**
C**
C***********************************************************************
C**
C**		    PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C**	Subprogram called:
C**		CALL ECHO(LINE,ILEN)
C**
C**	Parameters:
C**		LINE -- Command string to be echoed.
C**		ILEN -- Length of LINE
C**
C**	Description:
C**		Writes LINE on the current ECHO file.  If LINE is too
C**		long a continuation line is also written.
C**
C**	History:
C**	    Written: 
C**		15-DEC-1985	by Donald W. Denbo
C**	    Modified:
C**
C**
#ifdef unix
	include 'CMDCOM.INC'
#else
	INCLUDE 'cmdinc:CMDCOM.INC'
#endif
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 

	CHARACTER LINE*(*),LEV*5
	LOGICAL LEVF
	LEVF=CMDLEV.GT.1
	IF(LEVF)THEN
	    WRITE(LEV,999)CMDLEV
999	    FORMAT('C ',I1,'- ')
	ENDIF
	K=1
200	KS=MIN0(K+69,ILEN)
	IF(KS.NE.ILEN)THEN
	    IF(LEVF)THEN
		WRITE(ECHLUN,998)LEV,LINE(K:KS)
998		FORMAT(A5,A70,'-')
	    ELSE
		WRITE(ECHLUN,996)LINE(K:KS)
996		FORMAT(A70,'-')
	    ENDIF
	ELSE
	    IF(LEVF)THEN
		WRITE(ECHLUN,997)LEV,LINE(K:ILEN)
997		FORMAT(A5,A)
	    ELSE
		WRITE(ECHLUN,995)LINE(K:ILEN)
995		FORMAT(A)
	    ENDIF
	    RETURN
	ENDIF
	K=KS+1
	GOTO 200
	END

      SUBROUTINE AIR_TEMP ( sst, msst, cair, mcair, air, mair )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute air temperature: either climatological field (unmodified)
*			   or SST-const south of j=91 and climatol. to the north

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 4/12/88
* revision 0.1 - 7/2/88  - allow multiple air temp climatologies
* V200:  7/27/89 - 4D symmetrical version
*	10/11/89 - modified array declarations

#ifdef unix
	include 'ferret.parm'
	include 'tmap_dims.parm'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xdset_parms.cmn'
#else
	INCLUDE 'FERRET_CMN:FERRET.PARM'
	INCLUDE 'TMAP_FORMAT:TMAP_DIMS.PARM'
	INCLUDE	'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE	'FERRET_CMN:XMEM_SUBSC.CMN'
	INCLUDE 'FERRET_CMN:XDSET_PARMS.CMN'
#endif

* calling argument declarations:
	INTEGER	mair, msst, mcair
	REAL     sst( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit ),
     .		cair( m2lox:m2hix,m2loy:m2hiy,            m2lot:m2hit ),
     .		 air( m3lox:m3hix,m3loy:m3hiy,            m3lot:m3hit )

* internal variable declarations:
	INTEGER	i_lo, i_hi, j_lo, j_hi, i, j, l, dset
	REAL	bad_cair, bad_air, bad_sst, dairt

* --- end of introductory code ---
* initialize
	dset    = mr_data_set( mair )

* limits for calculation
	i_lo = mr_lo_s1(mair)
	i_hi = mr_hi_s1(mair)
	j_lo = mr_lo_s2(mair)
	j_hi = mr_hi_s2(mair)

* flag for bad/missing data
	bad_cair  = mr_bad_data( mcair )
	bad_air   = mr_bad_data( mair )
	bad_sst   = mr_bad_data( msst )

* constant air/sst temperature difference
	dairt = dp_delta_air_sst( dset )


	IF ( .NOT.dp_const_air_sst(dset) ) THEN

* climatological air temp
	   DO 100 l = mr_lo_s4(mair), mr_hi_s4(mair)
	   DO 100 j = j_lo, j_hi
	   DO 100 i = i_lo, i_hi

	      IF ( cair(i,j,l) .EQ. bad_cair ) THEN
	         air(i,j,l) = bad_air
	      ELSE
	         air(i,j,l) = cair(i,j,l)
	      ENDIF

 100	   CONTINUE

	ELSE
* constant air-sst difference in south, climatology in north
	   DO 200 l = mr_lo_s4(mair), mr_hi_s4(mair)
	   DO 200 j = j_lo, j_hi
	   DO 200 i = i_lo, i_hi

	      IF ( j .LT. 91 ) THEN
	         IF ( sst(i,j,1,l) .EQ. bad_sst ) THEN
	            air(i,j,l) = bad_air
	         ELSE
	            air(i,j,l) = sst(i,j,1,l) - dairt
	         ENDIF
	      ELSE
	         IF ( cair(i,j,l) .EQ. bad_cair ) THEN
	            air(i,j,l) = bad_air
	         ELSE
	            air(i,j,l) = cair(i,j,l)
	         ENDIF
	      ENDIF

 200	   CONTINUE

	ENDIF
	RETURN
	END

	SUBROUTINE ADDL_CX_DOC( joint_cx, addl_cx, overlay, flags )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* merge an additional variable context with those already merged into the
* joint context for a plot.  See GRP_CX_DOC

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V200:	  2/2/90
* V230:  7/22/92 - added overlay argument for cases where the original plot
*                  was unspecified on an axis but the overlay is not
*                e.g. SHADE T_INDEPENDENT  CONTOUR/OVER T_DEPENDENT
* *kob* 11/96   - Linux port.  Linux didn't like tabs between "include"
*                 and what was being included.  removed them
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V685+ *acm* 12/13 For 6D Ferret, the array coming in as flags is longer for extra dimensions

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'

* calling argument declarations
	INTEGER joint_cx, addl_cx 
	LOGICAL	overlay, flags(0:12) 

* internal variable declarations
	INTEGER	idim, CX_DIM_LEN

* document the grid in the key ??
* ( as of FERRET v2.00 this is governed entirely by cx_unstand_grid )
!	flags(pdoc_regrid) = cx_unstand_grid(addl_cx)
!     .			 .AND. cx_unstand_grid(addl_cx)


* document the data set in the key ??
* (take any "real" data set over pdset_irrelevant)
	IF ( cx_data_set(joint_cx) .EQ. pdset_irrelevant ) THEN
	   cx_data_set(joint_cx) = cx_data_set(addl_cx)
           IF ( overlay ) THEN   ! 7/92
              flags(pdoc_dset) = .TRUE.
              flags(0) = .TRUE.
           ENDIF
	ELSEIF ( cx_data_set(addl_cx) .NE. pdset_irrelevant ) THEN
	   IF ( cx_data_set(addl_cx) .NE. cx_data_set(joint_cx) ) THEN
	      cx_data_set(joint_cx) = unspecified_int4
	      flags(pdoc_dset) = .TRUE.
	      flags(0) = .TRUE.
	   ENDIF
	ENDIF

* check each axis for documentation needs
* note: unspec_val8_2 indicates differing limits between contexts
*	unspecified_val8 indicates irrelevant (normal) limits
	DO 100 idim = 1, nferdims
	   IF ( cx_lo_ww(idim,addl_cx)  .EQ. unspecified_val8 ) GOTO 100
	   IF ( cx_lo_ww(idim,joint_cx) .EQ. unspec_val8_2    ) GOTO 100
	   IF ( cx_lo_ww(idim,joint_cx) .EQ. unspecified_val8 ) THEN
	      CALL TRANSFER_AXIS( idim, addl_cx, joint_cx )
              IF ( overlay ) THEN     ! 7/92
                 flags(idim) =  CX_DIM_LEN( idim, addl_cx ) .EQ. 1
                 IF ( flags(idim) ) flags(0) = .TRUE.
              ENDIF
	   ELSEIF(  cx_lo_ww(idim,joint_cx) .NE. cx_lo_ww(idim,addl_cx)
     .		.OR.cx_hi_ww(idim,joint_cx) .NE. cx_hi_ww(idim,addl_cx) ) THEN
	      cx_lo_ww(idim,joint_cx) = unspec_val8_2
	      cx_hi_ww(idim,joint_cx) = unspec_val8_2
	      flags(idim) = .TRUE.
	      flags(idim+pdoc_offset_xform) = .TRUE.
	      flags(0) = .TRUE.
	   ENDIF
	   IF( cx_trans_arg(idim,joint_cx) .NE. cx_trans_arg(idim,addl_cx)
     .	  .OR. cx_trans(idim,joint_cx) .NE. cx_trans(idim,addl_cx) ) THEN
	      cx_trans    (idim,joint_cx) = trans_no_transform
	      cx_trans_arg(idim,joint_cx) = bad_val4
	      flags(idim+pdoc_offset_xform) = .TRUE.
	      flags(0) = .TRUE.
	   ENDIF

 100	CONTINUE

	RETURN
	END

      SUBROUTINE OBLIQ3(DEGRES)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)obliq3.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     CALL OBLIQ3(DEGRES)
C
C     THIS SUBROUTINE ESTABLISHES CONTROL INFORMATION FOR OBLIQUE
C     THREE-DIMENSIONAL PROJECTIONS WHERE THE PLANE OF PROJECTION
C     IS PARALLEL TO THE XY-PLANE.
C
C
#ifdef unix
	include 'PLTCOM.DAT'
#else
	include 'pplinc:PLTCOM.DAT'
#endif
C
      IF(DEGRES .NE. 0.0)THEN
C
C     SET THE VIEW FLAG.
C
        VIEWF = .TRUE.
C
C     CONVERT THE ANGLE OF PROJECTION TO RADIANS.
C
        TEMP = 0.01745329251994 * DEGRES
C
C     COMPUTE THE ELEMENTS OF THE TRANSFORMATION MATRIX.
C
        TAX = 1.0
        TAY = 0.0
        TAZ = -COS(TEMP)
        TBX = 0.0
        TBY = 1.0
        TBZ = -SIN(TEMP)
        TCX = 0.0
        TCY = 0.0
        TCZ = 0.0
        VDIST = 0.0
      ELSE
C
C     RESET THE VIEW FLAG.
C
        VIEWF = .FALSE.
      ENDIF
      RETURN
C
      END

	BLOCK DATA ENCODE_STRINGS_DATA


*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Thermal Modeling and Analysis Program
* 11/2009


	INCLUDE 'encode_strings.cmn'

* Reserved chars to encode

	DATA reschar(1)  /'!'/
	DATA reschar(2)  / '*'/
	DATA reschar(3)  / '"'/
	DATA reschar(4)  / ''''/
	DATA reschar(5)  / '('/
	DATA reschar(6)  / ')'/
	DATA reschar(7)  / ';'/
	DATA reschar(8)  / ':'/
	DATA reschar(9)  / '@'/
	DATA reschar(10) / '&'/
	DATA reschar(11) / '+'/
	DATA reschar(12) / '$'/
	DATA reschar(13) / ','/
	DATA reschar(14) / ','/
	DATA reschar(15) / '?'/
	DATA reschar(16) / '%'/
	DATA reschar(17) / '#'/
	DATA reschar(18) / '['/
	DATA reschar(19) / ']'/
	DATA reschar(20) / ' '/
	DATA reschar(21) / '{'/
	DATA reschar(22) / '}'/
	DATA reschar(23) / '='/
	DATA reschar(24) / '`'/
	

** examples break when I encode a /
**	DATA reschar(14) / '/'/
**	DATA subencode(14) /'%2F'/

* The corresponding encoding
	DATA subencode(1)  /'%21'/
	DATA subencode(2)  /'%2A'/
	DATA subencode(3)  /'%22'/
	DATA subencode(4)  /'%27'/
	DATA subencode(5)  /'%28'/
	DATA subencode(6)  /'%29'/
	DATA subencode(7)  /'%3B'/
	DATA subencode(8)  /'%3A'/
	DATA subencode(9)  /'%40'/
	DATA subencode(10) /'%26'/
	DATA subencode(11) /'%2B'/
	DATA subencode(12) /'%24'/
	DATA subencode(13) /'%2C'/
	DATA subencode(14) /'%2C'/
	DATA subencode(15) /'%3F'/
	DATA subencode(16) /'%25'/
	DATA subencode(17) /'%23'/
	DATA subencode(18) /'%5B'/
	DATA subencode(19) /'%5D'/
	DATA subencode(20) /'%20'/
	DATA subencode(21) /'%7B'/
	DATA subencode(22) /'%7D'/
	DATA subencode(23) /'%3D'/
	DATA subencode(24) /'%60'/

	DATA nsubencode /nencode*3/

	END

	SUBROUTINE INIT_JOURNAL( status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* open the FERRET journal file

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V300:  5/93 - extracted from initialize.F
* V312:  5/94 - insert "PROCLAIM" output from here instead of from INITIALIZE
* V320: 12/29/94 - use WARN to avoid direct tty output (for GUI)
* V66   *kms* 5/10 LIB_GET_LUN is a subroutine, not a function
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

	include 'tmap_dims.parm'
	include 'tmap_errors.parm'  ! error codes
	include	'ferret.parm'
	include	'errmsg.parm'
	include 'xprog_state.cmn'

* calling argument declarations:
	INTEGER status

* local variable declarations:
	INTEGER TM_LENSTR1, jnl_len

* get logical unit to open the journal file
	CALL LIB_GET_LUN( jrnl_lun )

*  rename last journal file by this name to old version
        CALL TM_PARK_LAST_VERSION( journal_file, status )
        IF ( status .NE. merr_ok ) GOTO 9000
	OPEN (	FILE=journal_file,
     .		UNIT=jrnl_lun,
     .		STATUS='NEW',
     .		ERR = 9000 )

* put introductory remarks into journal file
	CALL PROCLAIM ( jrnl_lun, '! ' )

* successful completion
	status = ferr_ok   ! status not really used
	RETURN

* errors
* note: error not reported to ERRMSG since this is called from INITIALIZE
 9000	jrnl_lun = unspecified_int4	! flag that there is no journal file
	jnl_len = TM_LENSTR1(journal_file)
	CALL WARN('Unable to create journal file '
     .			//journal_file(:jnl_len) )
	status = ferr_invalid_command  

	END

c*
c* ef_get_arg_string.F
c*   
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
c* Jonathan Callahan
c* Mar 17th 1999
* V530  8/00 *sh* - shifted to new way of storing strings
*      10/00      - allow this routine to be called during CUSTOM AXIS time
*                      (before evaluation of variables)
c*
c*v540 1/02 *kob* - fix bug which used character array risc_buff to pass
c*                  a string into tm_ctof_string when tm_ctof_string was
c*                  expecting an integer array.  no longer need xrisc.cmn

c*
c* This returns the (single) string which was passed as an argument
c* to the function.  
c* It may be called during grid creation time (custom axis creation) or
c* during evaluation time.
c* Other routines are available to handle arrays of strings.
c* Note that grabbing an array of string during grid creation time is more
c* difficult (though not impossible). The EVAL_EXPR routine cannot safely be
c* called since the stacks would get re-initialized and the {,,,} would need
c* to be parsed
c*

      SUBROUTINE EF_GET_ARG_STRING(id, iarg, text)

      IMPLICIT NONE
      INCLUDE 'tmap_dims.parm'
      INCLUDE 'ferret.parm'
      INCLUDE 'errmsg.parm'
      INCLUDE 'EF_Util.parm'
      INCLUDE 'xvariables.cmn'
      INCLUDE 'xcontext.cmn'

      INTEGER id, iarg
      CHARACTER*(*) text

      INTEGER   GET_OFFSET_C_STRING_LEN, 
     .          slen, flen, cx, uv, item, start, end,
     .          mr, mr_list(EF_MAX_ARGS)
      INTEGER*2 int_buff(1024)
      CHARACTER buff*64
 
c The memory resident list was cached by Ferret and must be retrieved
c to be accessible to the external function.
      CALL EF_GET_MR_LIST(mr_list)
      mr = mr_list(iarg)
      
      IF ( mr .EQ. 0 ) THEN
* we must have been called during custom axis creation time. We'll need
* to grab the string straight from the function definition
* (e.g. EF("my_string") and also allow A="string"; EF(a)
        CALL EF_GET_CX_LIST(mr_list) ! get contexts
        cx = mr_list(iarg)
        IF (cx_category(cx) .EQ. cat_user_var) THEN
* ... an intermediate variable was defined as a constant string
          uv = cx_variable(cx)
          IF (uvar_num_items(uv)   .NE. 1
     .   .OR. uvar_item_type(1,uv) .NE. alg_string ) GOTO 5000
          item = 1
        ELSEIF (cx_category(cx) .EQ. cat_string) THEN
* ... determine the string position directly within EF call
          uv = cx_variable(cx)/1000
          item = cx_variable(cx) - 1000*uv
        ELSE
          GOTO 5000
        ENDIF
* remove the surrounding quotation marks
        start = uvar_item_start( item, uv ) + 1 ! +1 to bypass quotations
        end   = uvar_item_end  ( item, uv ) - 1
        text = uvar_text(uv)(start:end)

      ELSE

c Here's how you check the variable type.
* (this should never happen as checks against it are made previously) 
        IF (mr_type(mr) .NE. ptype_string) GOTO 5000

* get the string (up to the byte size of int_buff)
        CALL GET_OFFSET_C_STRING(mr_c_pointer(mr), 0, int_buff, 2048)

* and the string length
        slen = GET_OFFSET_C_STRING_LEN(mr_c_pointer(mr), 0)
        IF ( slen .GT. 2048 ) slen = 2048

* copy it into the FORTRAN string
        CALL TM_CTOF_STRNG (int_buff, text, slen)

      ENDIF

      RETURN

* Error - bail out
 5000 WRITE (buff, 3000) iarg
 3000 FORMAT ('Argument',I3,' is not a string')
      CALL EF_BAIL_OUT(id, buff)
      STOP 'EF_BAIL_OUT returned in EF_GET_ARG_STRING'

      END

	SUBROUTINE SHOW_1_UVAR_XML( lun, uvar, vname, first )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* output some lines describing a user variable in xml-style format
* 20-Oct-2004 acm  from show_1_uvar.F
*  7-Feb-2005 acm  (bug 1165) fix string vars so they are output with 
*                  surrounding &quot;
* V602 12/06 *acm* remove extra call to GRID_FROM_NAME_XML
* V606  8/07 *acm* when there are quotes within the var definition, as in
*                  a date specification change these to &quot; for valid xml.
* V616  1/2009 *acm* Fixing LAS ticket 481, new style of xml output
* V631 11/09 *acm* For XML-formatted output check for and replace the strings < > and &
*                  with &lt; etc.
* V650  Write to lun which may be set to a file unit number rather than std out
* V67  *acm* 2/11 XML fixes. New attribute formatting, ![CDATA] escape, upper/lowercase handling.
* V67  *acm* 2/16 Fixes for getting extra attributes that may have been assigned
* V720 *acm* 5/17 Implement specific calls in place of CD_GET_VAR_INFO

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include	'ferret.parm'
	include	'xvariables.cmn'
	include	'xcontext.cmn'
	include	'xrisc.cmn'
	include 'xprog_state.cmn'
        include 'errmsg.parm'
	include 'netcdf.inc'

* calling argument declarations:
	INTEGER	lun, uvar
	CHARACTER*(*) vname	! buffer -- 255 char
        LOGICAL first
	
* local variable declarations:
        LOGICAL NC_GET_ATTRIB, got_it
	INTEGER TM_LENSTR1, GRID_FROM_NAME_XML, STR_SAME,
     .          slen, llen, grid, cx_expr, i, j, status,
     .            varid, nvatts, blen, len_attbuff, attoutflag, attid, 
     .            attlen, attype, iatt, dset, alen, itype
	CHARACTER FULL_UVAR_NAME_XML*150, FULL_UVAR_NAME*150, 
     .            TM_FMT*48,
     .            buff*150, buff2*170, c*1, atype*10, aname*128, 
     .            attname*128, attbuff*2048, outstring*2048
	REAL      vals(100)
        LOGICAL TM_HAS_STRING, save_mode_ignore, save_silent_err, new

 2010  FORMAT ('<var name="', A, '">' )
 2020  FORMAT ('<attribute name="', A, '" type="char">' )
 2030  FORMAT ('<attribute name="', A, '" type="float">' )
 2040  FORMAT ('<attribute name="',  A, '" type="', A,'">' )
 2050  FORMAT ('   <value>', A, '</value>')
 2055  FORMAT ('   <value><![CDATA[', A, ']]></value>')
 2060  FORMAT ('</attribute>')
 2070  FORMAT ('</var>')

* initialize
	IF (uvar_num_items(uvar) .EQ. uvar_deleted  ) RETURN

* See if user variable is relevant to the context
* turn off error reporting

        save_mode_ignore = mode_ignore_err 
        silent_err = save_silent_err
        mode_ignore_err = .TRUE.
        silent_err = .TRUE.

        vname = FULL_UVAR_NAME(uvar,slen)
        grid= GRID_FROM_NAME_XML(vname, cx_last, cx_expr, 
     .       status)

* Restore error reporting

        save_mode_ignore = mode_ignore_err 
        mode_ignore_err = save_mode_ignore
        silent_err = save_silent_err

        IF (status .NE. ferr_ok) RETURN

* Before first variable output the global tag.

        IF (first) THEN
           risc_buff = '<global>'
           CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
           first = .FALSE.
        ENDIF

* variable name and definition

* ... output variable code, units, grid, and type

        vname = FULL_UVAR_NAME_XML(uvar,slen)
        CALL ESCAPE_FOR_XML (vname, outstring, slen)
        WRITE ( risc_buff, 2010 ) outstring(1:slen)
	CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

        WRITE ( risc_buff, 2020 ) 'definition'
	CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
	buff = uvar_text(uvar)
        CALL ESCAPE_FOR_XML (buff, outstring, slen)
	WRITE (risc_buff, 2055) outstring(1:slen)
	CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
	WRITE ( risc_buff, 2060 ) 
	CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

	risc_buff = ' '

* ... title and units 
	IF ( uvar_units(uvar) .NE. ' ' ) THEN
           CALL ESCAPE_FOR_XML (uvar_units(uvar), outstring, slen)
           WRITE ( risc_buff, 2020 ) 'units'
           CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
           WRITE (risc_buff, 2055) outstring(1:slen)
           CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
           WRITE ( risc_buff, 2060 ) 
           CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
        ENDIF

	IF ( uvar_title(uvar) .NE. ' ' ) THEN
           CALL ESCAPE_FOR_XML (uvar_title(uvar), outstring, slen)
           WRITE ( risc_buff, 2020 ) 'long_name'
           CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
           WRITE (risc_buff, 2055) outstring(1:slen)
           CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
           WRITE ( risc_buff, 2060 ) 
           CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
        ENDIF

* ... bad data flag 

        buff = TM_FMT(uvar_bad_data(uvar), 7,16,slen)
        CALL ESCAPE_FOR_XML (buff, outstring, slen)
        WRITE ( risc_buff, 2030 ) 'missing_value'
        CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
        WRITE (risc_buff, 2050) outstring(1:slen)
        CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
        WRITE ( risc_buff, 2060 ) 
        CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

	
* Once the grid is set, the dtype is also known. 

        dset = uvar_dset(uvar)
        IF (dset .LE. pdset_irrelevant) dset = pdset_uvars
        CALL GET_SAVED_UVAR_DTYPE(uvar, dset, itype)

	buff = 'FLOAT'
        IF (itype .EQ. ptype_string ) buff = 'STRING'

        CALL ESCAPE_FOR_XML (buff, outstring, slen)
        WRITE ( risc_buff, 2020 ) 'ferret_datatype'
        CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
        WRITE (risc_buff, 2055) buff(1:slen)
        CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
        WRITE ( risc_buff, 2060 ) 
        CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)      

* All attributes not already listed.
 
        dset = uvar_dset(uvar)
        IF (dset .LE. pdset_irrelevant) dset = pdset_uvars
	CALL CD_GET_VAR_ID (dset, vname, varid, status)
	IF (status .NE. ferr_ok) THEN
	    dset = cx_data_set(cx_last) 
	    CALL CD_GET_VAR_ID (dset, vname, varid, status)
        ENDIF
	IF (status .NE. ferr_ok) GOTO 1000

	CALL CD_GET_VAR_NATTS (dset, varid, vname, nvatts, status)

	IF (status .NE. ferr_ok) GOTO 1000

	DO 200 iatt = 1, nvatts
           CALL CD_GET_VAR_ATT_INFO (dset, varid, iatt, attname, 
     .              attype, attlen, attoutflag, status )

           new = .TRUE.
           new = (STR_SAME(attname, 'units') .NE. 0)         .AND. 
     .              (STR_SAME(attname, 'long_name') .NE. 0)     .AND. 
     .              (STR_SAME(attname, 'history') .NE. 0)       .AND. 
     .              (STR_SAME(attname, 'missing_value') .NE. 0) .AND. 
     .              (STR_SAME(attname, '_FillValue') .NE. 0)

           IF (new) THEN
              blen = 2048  ! len of attbuff
              got_it = NC_GET_ATTRIB (dset, varid, attname, 
     .                                .TRUE., vname, blen, attlen, 
     .                                attoutflag, attbuff, vals)

              CALL ESCAPE_FOR_XML (attname, aname, slen)

              IF (attype .EQ. NCCHAR)   atype = 'char'
              IF (attype .EQ. NCBYTE)   atype = 'byte'
              IF (attype .EQ. NCSHORT)  atype = 'int'
              IF (attype .EQ. NCLONG)   atype = 'int'
              IF (attype .EQ. NCFLOAT)  atype = 'float'
              IF (attype .EQ. NCDOUBLE) atype = 'double'
              alen = TM_LENSTR1(atype)

              WRITE (risc_buff, 2040) aname(1:slen), atype(1:alen)
              CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

              IF (attype .NE. NCCHAR) THEN
                 slen = 1
                 attbuff = ' '
                 DO 150 i = 1, attlen
                    buff = TM_FMT(vals(i), 7, 14, llen)
                    CALL ESCAPE_FOR_XML (buff, outstring, llen)
                    WRITE ( risc_buff, 2050 ) outstring(1:llen)
                    CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
 150             CONTINUE
              ELSE 
                 CALL ESCAPE_FOR_XML (buff, outstring, llen)
                 WRITE ( risc_buff, 2050 ) outstring(1:llen)
                 CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
              ENDIF

              WRITE ( risc_buff, 2060 )
              CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

           ENDIF

 200    CONTINUE
1000    CONTINUE

* ... grid

        IF (grid .NE. unspecified_int4) 
     .          CALL SHOW_GRID_XML (lun, grid, cx_expr)

        WRITE ( risc_buff, 2070 )
	CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

	RETURN
	END

* 
*  expndi_by_z.F
* 
*  Steve Hankin
*  2/22/2001
* 
*  Expand argument 1 by createing a 2D XZ structure from it with the 
* separation between Z columns given by the location of non-missing values in
* argument 2. Thus the Z columns created are "ragged"
* Typical use is that arg 1 is a collection of vertical casts appended end-
* to-end and that arg 2 flags the start of each cast

*  Args 3 and 4 are constants -- the size of the X and Z axes, respectively
 
*  In this subroutine we provide information about
*  the function.  The user configurable information 
*  consists of the following:
* 
*  descr              Text description of the function
* 
*  num_args           Required number of arguments
* 
*  axis_inheritance   Type of axis for the result
*                        ( CUSTOM, IMPLIED_BY_Z_ARGS, NORMAL, ABSTRACT )
*                        CUSTOM          - user defined axis
*                        IMPLIED_BY_Z_ARGS - same axis as the incoming argument
*                        NORMAL          - the result is normal to this axis
*                        ABSTRACT        - an axis which only has index values
* 
*  piecemeal_ok       For memory optimization:
*                        axes where calculation may be performed piecemeal
*                        ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE expndi_by_z_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .  'Expand arg1 on I into an XZ grid. (Typ. to split Z-profiles)' )

      CALL ef_set_num_args(id, 4)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, ABSTRACT, 
     .     IMPLIED_BY_ARGS, ABSTRACT, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'dat')
      CALL ef_set_arg_desc(id, arg, 'variable to expand on I axis')
      CALL ef_set_axis_influence(id, arg, NO, YES, NO, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'mask')
      CALL ef_set_arg_desc(id, arg,
     .          'each valid point starts a new Z column')
      CALL ef_set_axis_influence(id, arg, NO, YES, NO, YES)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'n_profiles')
      CALL ef_set_arg_desc(id, arg,
     .          'I size of result (constant)')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'max_profile_len')
      CALL ef_set_arg_desc(id, arg,
     .          'K size of result (constant)')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END






*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE expndi_by_z_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      REAL size

*
*     Use utility functions to get context information about the arguments.
*

* output X axis size
      CALL ef_get_one_val(id, ARG3, size)
      CALL ef_set_axis_limits(id, X_AXIS, 1, INT(ABS(size)))

* output Z axis size
      CALL ef_get_one_val(id, ARG4, size)
      CALL ef_set_axis_limits(id, Z_AXIS, 1, INT(ABS(size)))
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END



* 
*  In this subroutine we compute the result
* 
      SUBROUTINE expndi_by_z_compute(id, arg_1, arg_2, arg_3, arg_4,
     .                               result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy,
     .	   mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy,
     .     mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy,
     .     mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy,
     .     mem4loz:mem4hiz, mem4lot:mem4hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER j1, k1, l1
      INTEGER j2, k2, l2
      INTEGER imax,kmax, iout, kout

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* make sure inputs are conformable
      IF ( (arg_lo_ss(X_AXIS,ARG1) .NE. arg_lo_ss(X_AXIS,ARG2))
     . .OR.(arg_hi_ss(X_AXIS,ARG1) .NE. arg_hi_ss(X_AXIS,ARG2)) ) CALL
     .           EF_BAIL_OUT(id, 'X limits of args 1 and 2 mismatched')
      IF ( (arg_lo_ss(Z_AXIS,ARG1) .NE. arg_hi_ss(Z_AXIS,ARG1))
     . .OR.(arg_lo_ss(Z_AXIS,ARG2) .NE. arg_hi_ss(Z_AXIS,ARG2)) ) CALL
     .           EF_BAIL_OUT(id, 'Z size of args 1 and 2 must be 1')

* limits on output arrays
        imax = res_hi_ss(X_AXIS)
        kmax = res_hi_ss(Z_AXIS)

* pre-fill the entire output result with missing value flags
*  (since each I-sequence in mask may have different number of valid pts)
      DO 40 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         DO 30 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            DO 20 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
               DO 10 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
 10            result(i,j,k,l) = bad_flag_result
 20         CONTINUE
 30      CONTINUE
 40   CONTINUE

* fill in the points as specified by the mask
      k1 = arg_lo_ss(Z_AXIS,ARG1)
      k2 = arg_lo_ss(Z_AXIS,ARG2)

      l1 = arg_lo_ss(T_AXIS,ARG1)
      l2 = arg_lo_ss(T_AXIS,ARG2)
      DO 400 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         j2 = arg_lo_ss(Y_AXIS,ARG2)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            iout = res_lo_ss(X_AXIS)
            kout = res_lo_ss(Z_AXIS)
            IF ( arg_2(arg_lo_ss(X_AXIS,ARG2),j2,k2,l2)
     .     .NE. bad_flag(2) ) THEN
              iout = iout - 1  ! will immediately increment
            ELSE
              kout = kout - 1  ! will immediately increment
            ENDIF
            DO 200 i=arg_lo_ss(X_AXIS,ARG1),arg_hi_ss(X_AXIS,ARG1)

               IF ( arg_2(i,j2,k2,l2) .EQ. bad_flag(2) ) THEN
*    ... add another element to this Z column
                  IF (kout .GE. kmax) CALL EF_BAIL_OUT(id,
     .               'Arg 4 size too small')
                  kout = kout + 1
               ELSE
*    ... start a new Z column
                  IF (iout .GE. imax) CALL EF_BAIL_OUT(id,
     .               'Arg 3 size too small')
                  iout = iout + 1
                  kout = res_lo_ss(Z_AXIS)
               ENDIF
               result(iout,j,kout,l) = arg_1(i,j1,k1,l1)

 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
            j2 = j2 + arg_incr(Y_AXIS,ARG2)
 300     CONTINUE

         l1 = l1 + arg_incr(T_AXIS,ARG1)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
 400  CONTINUE
      
         
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	SUBROUTINE DELETE_VARIABLE ( mr )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* delete a memory resident variable releaseing its space in the memory
* variable table and bulk memory

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* revision 0.0 - 4/1/86
* revision 0.1 - 1/29/87 - change to leave illegal limits in mr if deleted
*			   in diagnostic mode and to accomodate mr_protected
*			   as declared INTEGER instead of LOGICAL
*		     and   to eliminate references to tvar_grid
* revision 0.2 - 9/30/87 - added mr_perm_prot
* revision 0.3 - 3/10/88 - added cat_named_var
* revision 1.0 - 7/21/88 - deletion involves removing the variable from its
*			   hash pile in the memory variable table and returning
*			   it to the free list
* revision 1.1 -10/12/88 - for named variables possibly call DELETE_NVAR
* V200:  5/25/89 - reordered lo/hi_ss arguments
* 		 - deleted variables flagged in mr_protected and mr_del_ links
*		 - nvar variables eliminated
*		 - temporary variables represented via mr_protected
* V320: 12/29/94 - use SPLIT_LIST to redirect tty output for GUI
* V510: 2/00 *sh* - free up the mr_grid pointer when variable is deleted
* V530: 8/00 *sh* - if the variable was a string array then free the C memory
* V533: 6/01 *sh* - allow for string variables with strides
* V601 11/06 *acm*- fix bug 1466: memory for string vars is NOT allocated via malloc,
*                   so do not FREE it here. 
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V702 1/16 *sh*: dynamic memory management
*                 (commented out) sanity checking of memory when debugging
* V740: 1/18 *acm* for issue 1854, protection status temporarily reset 
*             for curvi-coord plot with /SET


        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'

* calling argument declarations:
	INTEGER mr

* internal variable declarations:
	INTEGER MGRID_SIZE_DELTA, size, idim, prev, next

* Special case of curvilinear plot command with /SET where curvi-coord 
* data may have been temporarily protected.

	IF ( mr_protected( mr ) .LT. mr_keep_flag ) GOTO 5000

* diagnostic "delete" message
	IF (mode_diagnostic) THEN
	   IF ( mr_protected(mr) .NE. mr_table_entry_only )
     .			CALL DIAGNOSTIC_OUT( '-DELETE', mr, point_to_mr )
	   IF ( mr_protected( mr ) .EQ. mr_perm_protected	) THEN
	      CALL SPLIT_LIST(pttmode_ops, ttout_lun,'PERMANENT', 9)
	   ENDIF
	ENDIF

* book keeping
	   IF ( mr_protected( mr ) .EQ. mr_temporary	
     .	  .OR.  mr_protected( mr ) .EQ. mr_in_progress
     .	  .OR.  mr_protected( mr ) .GT. mr_not_protected    ) THEN
	      essential_mem = essential_mem - mr_size(mr)
	   ENDIF

* if this is a string array variable then free the "C" memory allocated
* if mr_table_entry_only, no memory was given to the variable
	IF ( mr_type(mr)      .EQ. ptype_string  .AND.
     .       mr_protected(mr) .NE. mr_table_entry_only ) THEN
	   size = MGRID_SIZE_DELTA(mr)
	   CALL FREE_C_STRING_ARRAY(mr_c_pointer(mr), size)
	ENDIF

* remove variable slot from hash pile doubly linked list
        prev = mv_blink( mr )
        next = mv_flink( mr )
        mv_flink( prev ) = next
        mv_blink( next ) = prev

* return the slot to the memory variable free list
* this code is equivalent to MR2FREELIST. kept in-line here for speed
        mv_flink( mr ) = mv_flink( 0 )
        mv_blink( mr ) = unspecified_int4               ! house keeping
        mv_flink( 0 ) = mr

* remove the variable from the deletion chain if it is there
	IF ( mr_protected(mr) .EQ. mr_not_protected ) THEN
	   prev = mr_del_blink(mr)
	   next = mr_del_flink(mr)
	   mr_del_flink(prev) = next
	   mr_del_blink(next) = prev
	   mr_del_flink(mr)   = unspecified_int4	! important 12/16
	   mr_del_blink(mr)   = unspecified_int4	! important 12/16
	ENDIF

* release bulk memory that the variable used
	IF ( mr_protected( mr ) .NE. mr_table_entry_only ) THEN
	   CALL FREE_MR_DYNMEM( mr )
	ELSE
* ... remove the table_entry_only pointer for good housekeeping
	   CALL NULLIFY_MR(mr)
	   mr_size(mr) = 0  
	ENDIF
* eliminate any stray indications that this variable points to a grid
	mr_grid( mr ) = unspecified_int4

* set protection to indicate deleted
	mr_protected( mr ) = mr_deleted

* sanity check memory integrity after deletion
! note that this call can give false indications of corruption.
! When DELETE_VARIABLE is called due to the mr table being full during
! CREATE_MEM_VAR.  In that case GET_MEMORY reserves the memory, and then
! ASSIGN_VARIABLE (which calls FIND_MR_SLOT) deletes a variable to free up
! a slot while the newly reserved memory has not yet been assigned to an mr.
! NOTE: this may no longer be true since code change to CREATE_MEM_VAR:
!       FIND_MR_SLOT is now called before GET_MEMORY and ASSIGN_VARIABLE
!#ifndef NDEBUG
!        IF ( mode_diagnostic ) CALL SANITY_CHECK_MEMORY("DELETE_VARIABLE")
!#endif


 5000	RETURN
	END

	SUBROUTINE TM_GET_205_RUN_PARM ( column, col_head, table_row,
     .					 entry, entry_len, status )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* This routine will use "column" as a search string in "col_head" to
* locate "entry" in "table_row". "Col_head" and "Table_row" are read
* from a file storing information about the model runs (and maybe other
* data sets).
*
* Arguments:
*	column    - string to search for in col_head
*	col_head  - a string containing column information (Bottom line)
*	table_row - a string containing experiment information
*       entry     - value in table_row pointed to by location of column
*		    in col_head
*	entry_len - length of entry
*	status    - return status
*
* Written 04/26/88 by M. Verschell for PMEL/TMAP
*
* revision 0.00 - 04/27/88
* revision 1.00 - 12/02/88 - major changes (unable to document)
* revision 1.01 -  1/91 *sh* syntax changes to accomodate DEC RISC compiler
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* Include files

	include 'tmap_errors.parm'

* Argument definitions
	CHARACTER*(*)	column, col_head, table_row, entry
	INTEGER*4	entry_len, status

* Local Definitions
	CHARACTER*132	up_col,up_head
	INTEGER*4	col_strt, col_end, collen, headlen, i, istat
	INTEGER*4	TM_LENSTR1, STR_UPCASE
	LOGICAL		TM_HAS_STRING

* Initialize
	collen = TM_LENSTR1(column)
	headlen = TM_LENSTR1(col_head)
	status = STR_UPCASE(up_col,column(1:collen))
	status = STR_UPCASE(up_head,col_head(1:headlen))

* Locate "column" in "col_head"
	IF ( .NOT. TM_HAS_STRING(up_head(1:headlen),column(1:collen)) )
     .		 GOTO 9000

* Found it, let's get the column start and end locations
	DO i=INDEX(up_head(1:headlen),up_col(1:collen)),1,-1
	  IF (up_head(i:i) .EQ. ' ') THEN
	    col_strt = i+1
	    GOTO 100
	  ENDIF
	ENDDO
	col_strt = 1
  100	col_end  = INDEX(up_head(col_strt:),' ') + col_strt-2

* Pull out the entry now
	IF (col_end .GT. col_strt) entry = table_row(col_strt:col_end)

* Left justify, and determine length of entry
	DO i=1,LEN(entry)
	  IF (entry(i:i) .NE. ' ' .AND. entry(i:i) .NE. '	') THEN
	    entry = entry(i:)
	    entry_len = TM_LENSTR1(entry)
	    GOTO 9900
	  ENDIF
	ENDDO
	entry_len = 1
	GOTO 9900

* ERROR - searching for "column" in column headings
 9000	up_col = Column		! RISC bug: cannot use CHAR*(*) in concat
	CALL TM_ERRMSG ( merr_keynf, status, 'TM_GET_205_RUN_PARM',
     .			 no_descfile, no_stepfile, 'Column='//up_col(:collen),
     .			 no_errstring, *9999 )

* Status set
 9900	status = merr_ok

* Bye bye
 9999	RETURN
	END

	SUBROUTINE PUT_ANNOTATION (user, nouser, norm, xloc, yloc,
     .          halign, angle, size, nlab, labtxt, status)
	
	
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Make calls to PPLUS to set up the size angle and label for the DEFINE ANNOTATION 
* command. If the user has not set a label number, increment the count that is in 
* place for other moveable labels added by Ferret.

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'plot_setup.parm'
	include 'xplot_setup.cmn'

	LOGICAL user, norm, nouser
	INTEGER	nlab, status
	REAL	xloc, yloc, halign, angle, size
	CHARACTER*(*) labtxt

* local variable declarations:
	INTEGER TM_LENSTR1, rlen, nchar
	CHARACTER TM_FMT*48, buff*20
	
* Count of (PLOT+ movable labels) or use the nlab given by the user
	IF (nlab .EQ. 0) THEN
 	   nlabs_on = nlabs_on + 1
	   nlab = nlabs_on
	ENDIF

* Send label size to pplus
	WRITE ( ppl_buff, 3000 ) nlab, size
	CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )

* Send rotation angle to pplus
	IF (angle .NE. 0.) THEN
	   WRITE ( ppl_buff, 3100 ) nlab, angle
	   CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
	ENDIF

* Send LABS command with qualifier, position, justify setting, and label

	WRITE ( ppl_buff, 3200 ) nlab
	IF (user) WRITE ( ppl_buff, 3300 ) nlab
	rlen = TM_LENSTR1(ppl_buff)

	ppl_buff = ppl_buff(:rlen)//','//TM_FMT(xloc, 14, 16, nchar)
	rlen = TM_LENSTR1(ppl_buff)

	ppl_buff = ppl_buff(:rlen)//','//TM_FMT(yloc, 14, 16, nchar)
	rlen = TM_LENSTR1(ppl_buff)

	ppl_buff = ppl_buff(:rlen)//','//TM_FMT(halign, 14, 16, nchar)
	rlen = TM_LENSTR1(ppl_buff)

	ppl_buff = ppl_buff(:rlen)//', '//labtxt
	rlen = TM_LENSTR1(ppl_buff)

	CALL PPLCMD ( from, line, 0, ppl_buff(:rlen), 1, 1 )

	RETURN
	
 3000	FORMAT('HLABS ',I3,1X,F6.3 )
 3100	FORMAT ('RLABS ',I4, ',', F8.3)
 3200	FORMAT('LABS/NOUSER ', I3)
 3300	FORMAT('LABS/USER ', I3)

	END

	SUBROUTINE DO_STRING_GOODBAD (	idim, trans,
     .					com, com_mr, com_cx,
     .					res, res_mr, res_cx )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Count the number of "FERRET Ver. 6.14" and "bad" values in the string array data,
* where FERRET Ver. 6.14 means length > 0


* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xprog_state.cmn'

* calling argument declarations:
	INTEGER	idim, trans, com_mr, com_cx, res_mr, res_cx
	REAL*8  com( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif )
	REAL    res( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif )

* internal variable declarations:
	LOGICAL	good_un
	INTEGER GET_C_STRING_LEN, 
     .          ii, i, j, k, l, m, n, pt, ngd, nbd, slen
	REAL	bad_res

* diagnostic mode output: " doing --> VAR_NAME[x=lo:hi@TRN:n,D=#]"
	IF ( mode_diagnostic ) 	CALL DIAG_OP
     .				( 'doing', isact_class_trans, res_cx, idim )

* initialize
        pt   = cx_lo_ss( res_cx, idim )
        bad_res = mr_bad_data( res_mr )
	good_un  = trans .EQ. trans_good_pt

* Write a note about missing values of strings 

        IF (good_un) THEN
	   CALL WARN
     .    ('@NGD of string variable, counting null strings as missing')
        ELSE
	   CALL WARN
     .    ('@NBD of string variable, counting null strings as missing')
        ENDIF

* ALONG X AXIS
	IF ( idim .EQ. x_dim ) THEN
	   DO 110 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 110 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 110 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 110 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 110 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
              ngd = 0
              nbd = 0
	      DO 100 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	         slen = GET_C_STRING_LEN(com(i,j,k,l,m,n))
		 IF ( slen .GT. 0 ) THEN
                    ngd = ngd + 1
                 ELSE
                    nbd = nbd + 1
                 ENDIF
 100	      CONTINUE
              IF ( good_un ) THEN
                 res(pt,j,k,l,m,n) = ngd
              ELSE
                 res(pt,j,k,l,m,n) = nbd
              ENDIF
 110	   CONTINUE

* ALONG Y AXIS
	ELSEIF ( idim .EQ. y_dim ) THEN
	   DO 210 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 210 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 210 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 210 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 210 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
              ngd = 0
              nbd = 0
	      DO 200 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	         slen = GET_C_STRING_LEN(com(i,j,k,l,m,n))
		 IF ( slen .GT. 0 ) THEN
                    ngd = ngd + 1
                 ELSE
                    nbd = nbd + 1
                 ENDIF
 200	      CONTINUE
              IF ( good_un ) THEN
                 res(i,pt,k,l,m,n) = ngd
              ELSE
                 res(i,pt,k,l,m,n) = nbd
              ENDIF
 210	   CONTINUE

* ALONG Z AXIS
	ELSEIF ( idim .EQ. z_dim ) THEN
	   DO 310 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 310 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 310 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 310 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 310 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
              ngd = 0
              nbd = 0
	      DO 300 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	         slen = GET_C_STRING_LEN(com(i,j,k,l,m,n))
		 IF ( slen .GT. 0 ) THEN
                    ngd = ngd + 1
                 ELSE
                    nbd = nbd + 1
                 ENDIF
 300	      CONTINUE
              IF ( good_un ) THEN
                 res(i,j,pt,l,m,n) = ngd
              ELSE
                 res(i,j,pt,l,m,n) = nbd
              ENDIF
 310	   CONTINUE

* ALONG T AXIS
	ELSEIF ( idim .EQ. t_dim ) THEN
	   DO 410 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 410 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 410 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 410 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 410 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
              ngd = 0
              nbd = 0
	      DO 400 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	         slen = GET_C_STRING_LEN(com(i,j,k,l,m,n))
		 IF ( slen .GT. 0 ) THEN
                    ngd = ngd + 1
                 ELSE
                    nbd = nbd + 1
                 ENDIF
 400	      CONTINUE
              IF ( good_un ) THEN
                 res(i,j,k,pt,m,n) = ngd
              ELSE
                 res(i,j,k,pt,m,n) = nbd
              ENDIF
 410	   CONTINUE

* ALONG E AXIS
	ELSEIF ( idim .EQ. e_dim ) THEN
	   DO 510 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 510 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 510 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 510 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 510 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
              ngd = 0
              nbd = 0
	      DO 500 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	         slen = GET_C_STRING_LEN(com(i,j,k,l,m,n))
		 IF ( slen .GT. 0 ) THEN
                    ngd = ngd + 1
                 ELSE
                    nbd = nbd + 1
                 ENDIF
 500	      CONTINUE
              IF ( good_un ) THEN
                 res(i,j,k,l,pt,n) = ngd
              ELSE
                 res(i,j,k,l,pt,n) = nbd
              ENDIF
 510	   CONTINUE

* ALONG F AXIS
	ELSEIF ( idim .EQ. f_dim ) THEN
	   DO 610 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 610 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 610 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 610 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 610 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
              ngd = 0
              nbd = 0
	      DO 600 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	         slen = GET_C_STRING_LEN(com(i,j,k,l,m,n))
		 IF ( slen .GT. 0 ) THEN
                    ngd = ngd + 1
                 ELSE
                    nbd = nbd + 1
                 ENDIF
 600	      CONTINUE
              IF ( good_un ) THEN
                 res(i,j,k,l,m,pt) = ngd
              ELSE
                 res(i,j,k,l,m,pt) = nbd
              ENDIF
 610	   CONTINUE

	ENDIF

* success
	RETURN
	END

*
* strings_as_args.F
*
* Ansley Manke
* 17-dec-2003
*
* This function takes two string arguments and one numeric argument.
* It returns a string result.  The result is the first N letters of the 
* first argument prepended to the string in the second argument, where N
* is the number of characters to take from the strings of arg1.
* 
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE strings_as_args_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

      CALL ef_version_test(ef_version)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .  'Demo Function: Prepend first NCHAR characters of string 1 onto string2')

      CALL ef_set_num_args(id, 3)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     . IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_result_type(id, STRING_RETURN)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'S1')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'string argument')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)
      CALL ef_set_arg_type (id, arg, STRING_ARG)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'S2')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'string argument')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)
      CALL ef_set_arg_type (id, arg, STRING_ARG)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'NCHAR')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, '# characters to take from S1')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
      CALL ef_set_arg_type (id, arg, FLOAT_ARG)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE strings_as_args_compute(id, arg_1, arg_2, 
     .                                   arg_3, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result

*  ! string arg and result need to be twice the length.

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, 
     .           mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, 
     .           mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1
      INTEGER i2, j2, k2, l2
      INTEGER iarg, slen, slen1, slen2, nchar
      REAL value
      CHARACTER text1*10, text2*10, textout*20

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      CALL ef_get_one_val (id, 3, value)
      nchar = value

      i1 = arg_lo_ss(X_AXIS,ARG1)
      i2 = arg_lo_ss(X_AXIS,ARG2)
      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         j2 = arg_lo_ss(Y_AXIS,ARG2)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            k2 = arg_lo_ss(Z_AXIS,ARG2)
            DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               l1 = arg_lo_ss(T_AXIS,ARG1)
               l2 = arg_lo_ss(T_AXIS,ARG2)
               DO 100 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
                  iarg = 1
 	          CALL EF_GET_STRING_ARG_ELEMENT (id, ARG1, arg_1, 
     .                                      i1,j1,k1,l1, slen1, text1)
                  CALL EF_GET_STRING_ARG_ELEMENT_LEN (id, iarg, arg_1, 
     .                                           i1,j1,k1,l1, slen1)
                  iarg = 2
 	          CALL EF_GET_STRING_ARG_ELEMENT (id, iarg, arg_2, 
     .                                      i2,j2,k2,l2, slen2, text2)
                  CALL EF_GET_STRING_ARG_ELEMENT_LEN (id, iarg, arg_2, 
     .                                           i1,j1,k1,l1, slen2)

                  iarg = 1
                  IF (slen1 .GE. nchar) THEN
                     textout = text1(1:nchar)//text2
                     slen = nchar + slen2
                  ELSE
                     textout = text1(1:slen1)//text2
                     slen = slen1 + slen2
                  ENDIF

                  CALL EF_PUT_STRING (textout, slen, result(i,j,k,l))

                  l1 = l1 + arg_incr(T_AXIS,ARG1)
                  l2 = l2 + arg_incr(T_AXIS,ARG2)
 100           CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
               k2 = k2 + arg_incr(Z_AXIS,ARG2)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
            j2 = j2 + arg_incr(Y_AXIS,ARG2)
 300     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
         i2 = i2 + arg_incr(X_AXIS,ARG2)
 400  CONTINUE
 

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	SUBROUTINE SHOW_GRID_STRING_XML (lun, grid, cx_expr,
     .                  stringdimname, strdim)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
*  list the axes for a grid in xml-style format

* programmer - Ansley Manke, based on show_grid.F
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* 6-Aug-2003
* V580 *acm* 11/4/04 add <axes> tags
* v6.5 *acm* 3/10 Cleanup - remove commented-out includes
* V67  *acm* 2/11 XML fixes. New attribute formatting, ![CDATA] escape, upper/lowercase handling.
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V698 2/16 *acm*  For ticket 1786: if mode_upcase is canceled write axis name
*                  using original upper/lowercase spelling

        IMPLICIT NONE
	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'xvariables.cmn'
	include	'xtext_info.cmn'
	include	'xprog_state.cmn'
	include	'xrisc.cmn'
	include	'xcontext.cmn'


* calling argument declarations
	INTEGER lun, grid, cx_expr, strdim
	CHARACTER*(*) stringdimname

* local variable declarations:
	LOGICAL original 
	INTEGER TM_LENSTR1, TM_LENSTR, STR_DNCASE, idim, slen, line, status
        CHARACTER*1 axdir
	CHARACTER*2048 outstring
	CHARACTER axname*64

 2020   FORMAT ('<grid name="',A,'">' )
 2030   FORMAT ('<axes>' )
 2040   FORMAT( '<', A1, 'axis>' ,A , '</', A1, 'axis>' )
 2050   FORMAT ('</axes>')
 2060   FORMAT ('</grid>') 
 2070   FORMAT ('<dimension>', A, '</dimension>')


* list the axes of the grid

        CALL ESCAPE_FOR_XML (grid_name(grid), outstring, slen)
	WRITE ( risc_buff, 2020 ) outstring(1:slen)
	CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
	WRITE ( risc_buff, 2030 ) 
	CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

* First the string-length dimension

	slen = TM_LENSTR(stringdimname)

	CALL ESCAPE_FOR_XML (stringdimname, outstring, slen)
	WRITE (risc_buff, 2070 ) outstring(1:slen) 
	CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

	original = .TRUE.
	DO 110 idim = 1, nferdims
           line = grid_line(idim, grid)
           IF (line .GT. 0) THEN
	      slen = TM_LENSTR(line_name(line))
	      status = STR_DNCASE(axdir, ww_dim_name(idim))
	   ENDIF

           IF (line .GT. 0  .AND.  slen .GT. 0 .AND.
     .         cx_expr .EQ. unspecified_int4) THEN
	      CALL CHOOSE_LINE_NAME(line, original, axname)
	      slen = TM_LENSTR(axname)

              CALL ESCAPE_FOR_XML (axname, outstring, slen)
              WRITE (risc_buff, 2040 ) axdir, outstring(1:slen), axdir
	      CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
           ENDIF

           IF (line .GT. 0  .AND.  slen .GT. 0 .AND.
     .         cx_expr .NE. unspecified_int4) THEN

              IF ( cx_hi_ss(cx_expr,idim).NE.unspecified_int4 .AND. 
     .	           cx_lo_ss(cx_expr,idim).NE.unspecified_int4 ) THEN
                 slen = TM_LENSTR1(axname)
                 WRITE (risc_buff, 2040 ) axdir,
     .              axname(1:slen), axdir
	         CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
              ENDIF
           ENDIF

 110	CONTINUE

        WRITE ( risc_buff, 2050 )
        CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
        WRITE ( risc_buff, 2060 )
        CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

        RETURN
	END

	SUBROUTINE EXTRACT_LINE( cx, src, msrc, line, idim, ndim, nout, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* extract a single line of data from a memory variable grid.  Determine
* which line to extract from the given context

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 7/8/87
* V200:  5/19/89 - 4D symmetrical
*	10/16/89 - modified array declarations using call to *_SUB
*	  5/9/90 - allow a multi-dimensional region as a line for PLOT/VS
*	         - return number of dims
* v580 *acm* 11/04 Fix bug 1009. Distinguish between axes which really have one 
*                  point, and those for which the hi and lo subscripts on the axes 
*                  are undefined. When undefined return zero from CX_DIM_LEN_ZERO in
*                  GET_CX_DIMS_ZERO. These axes are listed last in the heirarchy in 
*                  array plot_axis().  This means we can plot a variable with just 
*                  one point in their range (if /HLIMITS or /VLIMITS are used to give 
*                  PPLUS a range to draw).
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'

* calling argument declarations:
	INTEGER	cx, msrc, idim, ndim, n, nout, status
	REAL    src(*), line(*)

* internal variable declarations:
	INTEGER	CGRID_SIZE, dim(nferdims)

* determine 6D shape of context
	CALL GET_CX_DIMS_ZERO( cx, ndim, dim )

* have we been given a reasonable context ?
! eliminated 5/90
!	IF ( ndim .NE. 1 ) CALL ERRMSG
!     .		( ferr_dim_underspec, status, 'can only PLOT lines', *5000 )

* determine the axis orientation and length
	idim = dim(1)
	nout = CGRID_SIZE( cx )

* extract the line
	CALL EXTRACT_LINE_SUB(	cx, line, src,
     .				mr_lo_s1(msrc), mr_hi_s1(msrc),
     .				mr_lo_s2(msrc), mr_hi_s2(msrc),
     .				mr_lo_s3(msrc), mr_hi_s3(msrc),
     .				mr_lo_s4(msrc), mr_hi_s4(msrc),
     .				mr_lo_s5(msrc), mr_hi_s5(msrc),
     .				mr_lo_s6(msrc), mr_hi_s6(msrc)  )

* successful completion
	status = ferr_ok
	RETURN

! 5000	RETURN
	END

	SUBROUTINE EVAL_EXPR (  dflt_cx, expression, apply_cx, 
     .              status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* "evaluate expression"
* calculate grid of data based on the expression given
* Saves (temporarily) expression in user-variable (uvar) structure.
* when done - return with the variable un-"protected" (flagged as deletable)

* a sample command may look like:
*	CONTOUR/Z=`TEMP[Z=0:1000@LOC:10]` TEMP[X=160E:160W]

* contexts are transferred, modified and used in the following manner:
*   i)	skeletal context ( without grid-related info.) is specified in the call
*	Usually it is based on SET REGION,DTA_SET,etc. ( cx_last )
*  ii)	this context is modified by the command qualifiers given to produce a 
*	new skeletal context to be used for the evaluation of the current 
*	command ( cx_cmnd )
*	the command context may, itself, contain grave-accented expressions
*	... those parts of the region are ignored until they are known
*  iii)	as the expression is evaluated each variable, as it is encountered,
*	begins with cx_cmnd and modifies it by the variable
*	qualifiers to produce the context at which the variable is to be
*	evaluated.

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V400: 3/95 - based on GET_PROT_CMND_DATA
* V600:  3/07 *acm* - fixing bug 439&1390. Add logical variable its_action_command 
*                     to decide when the qualifiers /X=/Y=/Z=/T= apply to the evaluation
*                     of immed. mode expressions in the command.
* V600 *acm* 3/06  fixing bugs 439&1390, pass apply_cx to get_new_cx to say whether
*                  to apply command context to grave-accent expressions.
* V702 *sh*  3/17 Dynamic memory

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
	include 'xfr_grid.cmn'


* calling argument declarations
        LOGICAL apply_cx
	INTEGER	dflt_cx, status
	CHARACTER*(*) expression

* local variable declarations
	INTEGER		cx_expr, mr
	CHARACTER	EXPR_NAME*8
	INTEGER		tlen

* initialize grid stack pointer (pushes down from top)
	tlen = LEN(expression)
	grd_stk_ptr = max_grids

* initialize memory usage diagnostic
	completed_args_mem = 0
	current_cmnd_uvar = 1
	deferred_committed_mem = 0
	nsplits = 0

* delete any memory left-overs from last command
	CALL DELETE_MRS_IN_PROGRESS

* * * * DETERMINE CONTEXT FOR COMMAND * * *
* ==> this needs to be replaced with a version that can evaluate incomplete
*	regions that have grave-accented region information
	CALL GET_NEW_CX( dflt_cx, cx_cmnd, apply_cx, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* store expression in the uvar list names as "EX#1"
	CALL DELETE_OLD_EXPR
	CALL BREAK_UP_EXPR( expression, num_uvars_in_cmnd, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	IF ( num_uvars_in_cmnd .NE. 1 ) CALL ERRMSG
     .			(ferr_invalid_command,status,expression,*5000)

* reserve a context slot to hold a fresh command context
	cx_stack_ptr = cx_stack_ptr + 1
	cx_expr = cx_stack_ptr

* evaluate the expression
	CALL TRANSFER_CONTEXT( cx_cmnd, cx_expr )
	CALL INTERP_STACK(  1, cx_expr, EXPR_NAME(1), status )
	IF ( status .NE. ferr_ok ) GOTO 5000

! temp diagnostic
	   IF ( cx_stack_ptr .NE. cx_cmnd+1 ) WRITE (6,*) 'get_cmnd_???'

* flag this result as temporary/delete-able
        CALL UNPROTECT_CMND_DATA
	RETURN

* error exit
 5000	RETURN
	END

	SUBROUTINE EZ_Mod_Vars( dset, vpos, varid,
     .			name, title, units, grid, bad, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* A routine to fill in the "missing" gaps in the XDSET_INFO entry for an EZ_
* data set. All parameters (except dset and var) are optional, however, any
* unused parameters must be filled with char_init, int4_init, or real4_init
* depending on type.
*
* revision 0.00 - 08/14/89
* revision 0.10 - 10/25/89 - *sh* immediate COMMON update via EZ_UPDATE_VAR
* revision 0.11 - 04/25/91 *sh* Unix/RISC port: longer des name
* V530: change to xez_info.cmn requires ez_lib.parm first
* V532 5/01 *sh* - when the grid is modified must handle dynamic allocation
* V533 6/01 *sh* - added argument "name"
* V540 10/01 *sh* - when title is modified, reset titl_mod to blank
*      *acm* 10/01 increase length of ds_name
*      *acm* 10/01  remove VMS include statements
* v604 *acm* 7/07 increase length of ds_name, ds_des_name
* V616  1/09 *acm* - Fix ticket 1615, If doing SET VAR/UNITS, /TITLE, /BAD on a
*                    var from an EZ dataset, set the appropriate attributes.
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V68  *acm* 1/12 The variables should be declared REAL (conversion to double prec.)
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
* V701  7/16 *kms* Compare ds_name to char_init2048 instead of char_init1024

* Arguments:
*	dset	- data set number
*	vpos	- variable number within COMMON/XDSET_INFO
*	name	- variable name
*	title	- variable title
*	units	- variable units
*	grid	- grid data is on for this variable
*	bad	- bad data flag
*	status	- (output)
*
	CHARACTER*(*)	name, title, units
	INTEGER*4	dset, vpos, grid, status
	REAL		bad

	INTEGER		TM_LENSTR1, 
     .                  outtype_flag, varid, attid, attype, attlen, 
     .			attoutflag
	REAL		dummy
	CHARACTER	varattname*512, varname*128, attname*128, buf*2
*
* Include files
	include 'tmap_dims.parm'  
	include 'ez_lib.parm'  
#include "tmap_dset.parm"  
#include "gt_lib.parm"
	include 'xez_info.cmn_text'  
	external xez_info_data
	include 'tmap_errors.parm'
	include 'xdset_info.cmn_text'  
	external xdset_info_data
	include 'xstep_files.cmn_text'
	external xstep_files_data
        include 'netcdf.inc'

*
* Local definitions
*
* Does data set exist?
	IF (ds_name(dset) .EQ. char_init2048) GOTO 9100
*
* Defining variable title?
	IF ( title .NE. char_init80 ) THEN
           ds_var_title( vpos ) = title

           attlen = TM_LENSTR1(title)
           attname = 'long_name'
           CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)
           IF (attid .GT. 0) THEN
              CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, 
     .          attname, attype, attlen, attoutflag, status )
              CALL CD_REPLACE_ATTR (dset, varid, attname, attype, attlen, 
     .        title, dummy, status)
           ENDIF
	ENDIF
*
* Defining variable units?

	IF ( units .NE. char_init16 ) THEN
           ds_var_units( vpos ) = units

           attlen = TM_LENSTR1(units)
           attname = 'units'
           CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)
           IF (attid .GT. 0) THEN
              CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, 
     .             attname, attype, attlen, attoutflag, status )
              CALL CD_REPLACE_ATTR (dset, varid, attname, attype, 
     .           attlen, units, dummy, status)
           ELSE
                 attype = NF_CHAR
                 attoutflag = 1
                 CALL CD_PUT_NEW_ATTR (dset, varid, attname, attype, 
     .              attlen, attoutflag, units, dummy, status )
           ENDIF
	ENDIF
*
* Defining variable name?
*	IF (name .NE. char_init16) ds_var_code(vpos) = name
	IF (name .NE. char_init16) 
     .      CALL string_array_modify(ds_var_code_head,
     .                               vpos, name, LEN(name))
*
* Defining grid number?
	IF (grid .NE. int4_init) THEN
	  CALL TM_USE_DYN_GRID(grid)	! allocate new as used by variable
	  CALL TM_DEALLO_DYN_GRID( ds_grid_number(vpos) ) ! deallo old
	  ds_grid_number(vpos) = grid
	  CALL EZ_UPDATE_VAR(vpos)
	ENDIF
*
* Defining bad data flag?

	IF ( bad  .NE. real4_init  ) THEN
	   CALL PURGE_FILE_VAR( vpos ) ! remove memory-resident variables
	   CALL PURGE_ALL_UVARS	 ! delete (possibly dependent) uvars
	   ds_missing_flag(vpos) = ds_bad_flag(vpos)	      
	   ds_bad_flag    (vpos) = bad

	   attlen = 1
	   attname = 'missing_value'
	   CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)
	   IF (attid .GT. 0) THEN
              CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, 
     .             attname, attype, attlen, attoutflag, status )
              CALL CD_REPLACE_ATTR (dset, varid, attname, attype, attlen, 
     .           buf, bad, status)
	   ENDIF
	   attname = '_FillValue'
	   CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)
	   IF (attid .GT. 0) THEN
              CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, 
     .             attname, attype, attlen, attoutflag, status )
              CALL CD_REPLACE_ATTR (dset, varid, attname, attype, attlen, 
     .           buf, bad, status)
	   ENDIF

	status = merr_ok
	ENDIF

	GOTO 9990
*
* Error messages
 9100	CALL TM_ERRMSG( merr_dsetnf, status, 'EZ_MOD_DSET',
     .			no_descfile, no_stepfile,
     .			no_errstring, no_errstring, *9990)
*
* finished
 9990	RETURN
	END

	SUBROUTINE DD1STEP_DSG (idim, shf, dset, nfeatures, maxobs,
     .			com, com_mr, com_cx,
     .			res, res_mr, res_cx,
     .			box	)

*
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute a 1 step derivative of the component along axis idim
* for data on Distributed Sampling Geometries grids
* note: for a forward  derivative shf=0
*       for a backward derivative shf=1
*
* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Science Data Integration Group
* 2/2019
* V76   1/20 *acm* Orientation of Point-type data set to e_dim

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xunits.cmn_text'
	external xunits_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xdyn_linemem.cmn_text'
	include 'xdset_info.cmn_text'
	include 'xdsg_context.cmn'


* calling argument declarations:
	INTEGER	idim, shf, dset, nfeatures, maxobs, com_mr, com_cx, res_mr, res_cx
	REAL	box( * )
	REAL	com   (*),
     .          res   (*)

* internal variable declarations:
	LOGICAL	fmask(nfeatures), omask(maxobs)
	INTEGER i, ii, ifeature, iobs, flen, base, orientation, row_size_lm, 
     .          dsg_fmt_grid, dsg_coord_lm, iaxis
	REAL	bad_com, bad_res, lo_com, hi_com, unit, 
     .          dummy, boxdel, boxmean, boxstd


* initialize
	bad_com = mr_bad_data( com_mr )
	bad_res = mr_bad_data( res_mr )

* get feature mask and dsg grid and coordinate information
        CALL MAKE_DSG_FEATURE_MASK(dset, res_cx, fmask, nfeatures)

	row_size_lm  = dsg_loaded_lm(dsg_row_size_var(dset))
	dsg_fmt_grid = dsg_xlate_grid(dset)
	orientation  = dsg_orientation(dset)
	dsg_coord_lm = cxdsg_coord_lm(orientation)

* perform integrations on standard units if possible
	iaxis = grid_line(orientation, dsg_fmt_grid)
	unit = un_convert( line_unit_code(iaxis) )
	unit = 1. ! just testing

* ****** PERFORM THE COMPUTATION *****
	IF (idim.EQ.orientation .AND. orientation.LE.t_dim) THEN 

* *** true ragged array processing:

	   base = 0    ! obs index at end of preceding feature

* ... loop over the features
	   ftrloop: DO ifeature = 1, nfeatures 

	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
              iobs = base

* ... have the user's WW constraints removed this feature?
	      IF (.NOT.fmask(ifeature)) THEN
                 base = base + flen
                 CYCLE  ftrloop
              ENDIF

* ... get observation-level mask for this feature
	      CALL MAKE_DSG_OBS_MASK(dset, com_cx, ifeature, base,
     .				     omask, flen)

* ... loop over the observations within each feature

	      res(iobs+flen) = bad_res
	      

* Get and save box sizes for all feature coordinates. Feature-mask applied later.
* Weighted computation:
*   For trajectories the box size is the  great-circle-distance along the line between 
*   lon-lat points, For integrals, convert to meters; routine returns distance in Km.
*   In Z and T use distance between, construct boxes based on coordinate data.

              IF (orientation .EQ. x_dim) THEN
	         CALL BOXES_DSG (orientation, flen, unit, 
     .		   dsg_linemem(dsg_coord_lm)%ptr(base+1), 
     .		   dsg_linemem(cxdsg_coord_lm(y_dim))%ptr(base+1), box)

              ELSE
	         CALL BOXES_DSG (orientation, flen, unit, 
     .		   dsg_linemem(dsg_coord_lm)%ptr(base+1), 
     .		   dummy, box)

              ENDIF

              IF (unit .NE. 1.) THEN
	        DO i = 1, flen
		    box(i) = unit*box(i)
                 ENDDO
              ENDIF

* note: for a forward  derivative shf=0
*       for a backward derivative shf=1

	      oloop: DO i = 1, flen
	         iobs = iobs + 1   ! index in the contig ragged array
	         res(iobs) = bad_res
		 IF (i-shf .LT. 1) CYCLE oloop
		 IF (i+1-shf .GT. flen) cycle oloop

	         IF (.NOT.omask(i-shf)) CYCLE oloop
	         IF (.NOT.omask(i+1-shf)) CYCLE oloop

	         ii = iobs-shf
		 lo_com = com(iobs-shf)
	         ii = iobs+1-shf
	         hi_com = com(iobs+1-shf)

*    box size. For trajectory datasets, look for extra-large boxes
*    and instead use nearby delta 

		 boxdel = box(i)
		 
		 IF ( orientation.EQ.x_dim .AND. boxstd .GT. 0.) THEN
		    IF ( boxdel .GT. 2.* boxstd) THEN
		       IF (i.GT.1) THEN
		          boxdel = MIN( boxstd, box(i-1) )
		       ELSEIF (i.LT.flen) THEN
		          boxdel = MIN( boxstd, box(i+1) )
		       ELSE
		          boxdel = boxmean
		       ENDIF
		    ENDIF
	         ENDIF

	         IF ( lo_com.EQ.bad_res .OR. hi_com.EQ.bad_res .OR. boxdel.EQ.0.) THEN
	            res(iobs) = bad_res
	         ELSE
	            res(iobs) = (hi_com-lo_com) / boxdel
	         ENDIF

              ENDDO  oloop

              base = base + flen

	   ENDDO  ftrloop

	ELSE

* *** a simple list of instances:


	   DO ifeature = 1, nfeatures
	      box(ifeature) = ifeature
	   ENDDO

	   res(1) = bad_res
	   res(ifeature) = bad_res
	   DO ifeature = 1+shf, nfeatures-shf

* ... have the user's WW constraints removed this feature?
	      IF (.NOT.fmask(ifeature-shf)) CYCLE
	      IF (.NOT.fmask(ifeature+1-shf)  ) CYCLE

* ... the input data values
	      lo_com = com(ifeature-shf)
	      hi_com = com(ifeature+1-shf)

	      IF ( lo_com.EQ.bad_com .OR. hi_com.EQ.bad_com ) THEN
	         res(ifeature) = bad_res
	      ELSE
	         res(ifeature) = (hi_com-lo_com) / box(i)
	      ENDIF

	   ENDDO

	ENDIF


	RETURN
	END

	SUBROUTINE IS_COUNTER_VAR( var,  *, status )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* create a counter array  "variable" in memory

* programmer - Ansley Manke, from is_const_var
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* Ferret v5.54 1/04
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction.
* V683  *acm*10/12 Improve handling of F axes and info about the calendar of the grid.
* V69+  *acm*10/14 Bug 2200: assign mr subscripts correctly
* V695  *acm* 2/15 cx_calendar stores info about calendar formatting of T and F axes

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xvariables.cmn'
	include	'xcontext.cmn'
	include	'xprog_state.cmn'
        include 'xcontrol.cmn'
        include 'xalgebra.cmn'

* calling argument declarations:
	INTEGER	var, status

* internal variable declarations:
	INTEGER	mr, cx, csp1, idim
	REAL    counter_const

* initialize
	cx = is_cx( isp )
	IF ( status .NE. ferr_ok ) GOTO 5000

* diagnostic output
	IF (mode_diagnostic) CALL DIAGNOSTIC_OUT('counter_v',mr,point_to_mr)

* parse and insert the counter variable

* cs_command has set cs_phase to point to the next value of the loop controller
        
        csp1 = csp_cvar(var)
	counter_const = cs_phase( csp1 ) - cs_delta( csp1 )

* reserve and catalog space for the result
	CALL CREATE_TEMP_MEM_VAR( cx, mr, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	is_mr( isp ) = mr
        
        idim = 1

	cx_lo_ss    ( cx, idim ) = unspecified_int4
	cx_hi_ss    ( cx, idim ) = unspecified_int4
        cx_by_ss    ( idim, cx ) = .TRUE.

	mr_lo_ss    ( mr, idim ) = unspecified_int4
	mr_hi_ss    ( mr, idim ) = unspecified_int4

	cx_trans    ( idim, cx ) = trans_no_transform
	cx_trans_arg( idim, cx ) = bad_val4
	if (idim .EQ. t_dim .OR. idim .EQ. f_dim) 
     .      cx_calendar(idim,cx) = .FALSE.


* diagnostic output
	IF (mode_diagnostic) CALL DIAGNOSTIC_OUT('constan',mr,point_to_mr)

* insert the constant
	memry(mr)%ptr(1) = counter_const

* set context data
	cx_bad_data( cx ) = bad_val4
	cx_data_set( cx ) = pdset_irrelevant
	cx_dset_gvn( cx ) = .FALSE.

* set the bad data flag to an unusual number
	mr_bad_data( mr ) = -2.1E34

* got the requested value
	RETURN 1

* error exit
 5000	RETURN
	END	

      SUBROUTINE ERASE
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)erase.F	1.2    3/18/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     CALL ERASE
C
C     THIS SUBROUTINE IS USED TO INDICATE THAT A DISPLAY HAS
C     BEEN COMPLETED AND A NEW DISPLAY IS ABOUT TO BEGIN.  ON
C     THE TEKTERMINAL, THE SCREEN IS ERASED AND THE ALPHA CUR-
C     SOR IS MOVED TO THE UPPER LEFT-HAND CORNER OF THE SCREEN.
C     ON THE PRINTRONIX PRINTER PLOTTER, THE RASTER BUFFER IS
C     RE-INITIALIZED.  ON THE ZETA AND BENSON
C     PLOTTERS, IF PLOTTING HAS BEEN DONE SINCE THE LAST CALL
C     TO PLOTEND OR ERASE, THE PEN IS LIFTED AND MOVED TO THE
C     LEFT MARGIN THREE INCHES ABOVE THE TOP OF THE LAST PLOT.
C     IN ALL CASES, THE MODE IS SET TO ALPHAS.
C
C
C
#ifdef unix
	include 'PLTCOM.DAT'
	include 'GKSCM1.INC'
#else
	include 'pplinc:PLTCOM.DAT'
	include 'pplinc:GKSCM1.INC'
#endif
C
	CHARACTER TERM(12)*10,TYPE*10
#ifndef unix
	integer*4 lib$get_symbol,len,stat
	byte FIRSTB(15,12),SECNDB(15,12),FIRST(15),SECND(15)
#else
	INTEGER FIRSTB(15,12),SECNDB(15,12),FIRST(15),SECND(15)
#endif
	INTEGER ITERM(12),FIRSTL(12),SECNDL(12)
	LOGICAL FRST
	DATA TERM/'VT240','GVT+','ZENITH','TEK4010','TEK41XX','MAC',
     *		  'TAB','TEK4105','TEK4014','HIREZ','HP2397','GP220'/
	DATA ITERM/1,2,3,4,5,4,6,7,4,8,9,10/,FRST/.TRUE./,NTERM/12/
C
	DATA FIRSTB/27,91,63,51,56,104,9*0,
     *		    28,27,12,12*0,
     *		    27,91,50,74,11*0,
     *		    27,12,13*0,
     *		    27,37,33,48,27,76,86,48,27,83,69,49,3*0,
     *		    29,27,12,12*0,
     *		    27,37,33,48,27,76,86,48,27,12,5*0,
     *		    27,91,50,74,27,49,9*0,
     *		    27,42,100,102,27,42,100,99,27,91,51,56,104,27,12,
     *		    15*0,
     *		    15*0,
     *              15*0/
	DATA SECNDB/27,91,63,51,56,108,9*0,
     *		    24,14*0,
     *		    27,12,27,58,56,102,9*0,
     *		    27,12,13*0,
     *		    27,83,75,33,27,76,86,49,27,37,33,49,3*0,
     *		    27,12,27,34,48,103,9*0,
     *		    27,12,27,76,86,49,27,37,33,49,5*0,
     *		    27,12,27,50,11*0,
     *		    27,91,51,56,108,27,42,100,100,27,42,100,101,2*0,
     *		    15*0,
     *		    15*0,
     *              15*0/
	DATA FIRSTL/6,3,4,2,12,3,10,6,15,3*0/
	DATA SECNDL/6,1,6,2,12,6,10,4,13,3*0/
C
C
C     SET THE PLOTTING MODE.
C
      PMODE = ALPHA
C
C     IF THE LAST POINT WAS NOT PLOTTED BECAUSE THE PEN WAS UP,
C     PLOT THE POINT NOW.
C
      IF(SAVEF)CALL XYZPLT
C
C     CHECK THE PLOT TYPE.
C
      GO TO(10,50,70,10,10,20,20),PTYPE + 3
C
C     CHECK THE TEKTERMINAL TYPE.
C
   10 IF(TTYPE .EQ. -4662 .OR. TTYPE .EQ. -4663)GO TO 40
C
C     MOVE TO HOME POSITION AND ERASE THE SCREEN ON OTHER TEK-
C     TRONICS GRAPHICS TERMINALS.
C
	IF(FRST)THEN
#ifdef unix
	call getenv('GRAPHTERM',TYPE)
	LENS=lnblk(type,10)
	IF(lens.le.0)then
#else
        STAT=LIB$GET_SYMBOL('GRAPHTERM',TYPE,LEN)
        LENS=LEN
        IF(.NOT.STAT)THEN
#endif
	ITYPE=1
	ELSE
	DO 14 I=1,NTERM
	IF(TYPE(1:LENS).EQ.TERM(I))GOTO 11
14	CONTINUE
	I=1
11	ITYPE=ITERM(I)
	ENDIF
	DO 12 I=1,15
12	FIRST(I)=FIRSTB(I,ITYPE)
	DO 13 I=1,15
13	SECND(I)=SECNDB(I,ITYPE)
	FRST=.FALSE.
	ENDIF
C
	IF(HPSCLA.GT.700.)THEN
	CALL CHOUT(FIRST,FIRSTL(ITYPE))
	HPSCLA=100.
	ELSE
	CALL CHOUT(SECND,SECNDL(ITYPE))
	HPSCLA=779.
	ENDIF
C
C     TRANSMIT SYNC CHARACTERS WHILE THE PHOSPHORS IN THE SCREEN
C     COOL DOWN.
C
        NDELAY = IFIX(0.7 * FLOAT(BAUDR / 10))
        DO 30 J=1,NDELAY
   30   CALL CHOUT(SYN,1)
      CALL CHDMP
      GO TO 60
C
C     CHECK THE GRAPHICS FLAG.
C
   40 IF(.NOT. GRAPHF)THEN
C
C     TRANSMIT THE 'PLOTTER ON' COMMAND TO THE TEKTRONIX PLOTTER.
C
        CALL CHOUT(TEKON,3)
      ENDIF
C
C     MOVE TO HOME POSITION ON THE TEKTRONIX PLOTTER.
C
      CALL CHOUT(HOME,5)
C
C     SELECT ALPHANUMERIC MODE ON THE TEKTRONIX PLOTTER.
C
      CALL CHOUT(US,1)
C
C     TRANSMIT THE 'PLOTTER OFF' COMMAND TO THE TEKTRONIX PLOTTER.
C
      CALL CHOUT(TEKOFF,5)
      CALL CHDMP
C
C     RESET THE GRAPHICS FLAG.
C
60    GRAPHF = .FALSE.
C
C     CHECK FOR OTHER PLOTTING DEVICES.
C
	GOTO 25
C
C	GKS ERASE
C
20	CALL PPLGFLUSH
	IF(HPSCLA.GT.700.)THEN
	    HPSCLA=100.
#ifdef core
	    if(.not.gksopn)then
		call crinit
		gksopn=.true.
	    endif
	    call delallretainsegs()
	    call newframe()
	    call createretainseg(1)
#else
	    CALL GCLRWK(WSID,0)
#endif
	ELSE
	    HPSCLA=779.
	ENDIF
25      GOTO(50,90,90,90,70,90,70),PTYPE + 3
C
C     CHECK THE PLOTTING FLAG.
C
   70 IF(PLTFLG)THEN
C
C     MOVE TO A NEW PLOTTING AREA AND RESET THE ZETA PLOTTER.
C
        PEN = .FALSE.
        CALL ZABMV
C
C     WRITE OUT THE PLOTTING BUFFER.
C
        CALL BINFSH
        PLTFLG = .FALSE.
      ENDIF
	GOTO 90
50	IF(PLTFLG)THEN
C
C	RESET THE HP PLOTTER
C
	A=0.
	B=0.
	PEN=.FALSE.
	CALL HPABMV
	CALL ZBUFFT('SP0;',4)
	OLDHTA=0
	CALL HFLUSH
	PLTFLG=.FALSE.
	ENDIF
C
C     CHECK THE PLOTTING FLAG.
C
   90 LPEN = .FALSE.
C
C     INITIALIZE THE DATA VARIABLES FOR THE NEXT PLOT.
C
      A = 0.0
      B = 0.0
      AOLD = 0.0
      BOLD = 0.0
      COLD = 0.0
C
	IF(TTYPE.GT.0)THEN
	IF(ASIZE / TWIDTH .GT. BSIZE / THIGHT)THEN
	PLTOTA = TSCLA /ASIZE
	PLTOTB =TSCLB /ASIZE * TWIDTH /THIGHT
      ELSE
        PLTOTA = TSCLA / BSIZE * THIGHT / TWIDTH
        PLTOTB = TSCLB / BSIZE
      ENDIF
	ELSE
	PLTOTA=TSCLA/(TWIDTH*FACTOR)
	PLTOTB=TSCLB/(THIGHT*FACTOR)
	ENDIF
C
C     RECOMPUTE THE HP PLOTTER CONVERSION FACTORS.
C
C
C     RESTORE THE DEFAULT MINIMUM AND MAXIMUM ALLOWABLE VALUES OF
C     A AND B.
C
      AMIN = 0.0
      BMIN = 0.0
      AMAX = ASIZE
      BMAX = BSIZE
C
C     CALCULATE THE OFF-SCREEN FLAG.
C
      LOSFLG = 0
      IF(AOLD - 0.001 .GT. AMAX)LOSFLG = 1
      IF(AOLD + 0.001 .LT. AMIN)LOSFLG = 2
      IF(BOLD - 0.001 .GT. BMAX)LOSFLG = LOSFLG + 4
      IF(BOLD + 0.001 .LT. BMIN)LOSFLG = LOSFLG + 8
C
C     TRANSFORM THE ABSOLUTE ORIGIN TO THE USER'S COORDINATE SYS-
C     TEM.
C
      CALL TFORMI(XOLD,YOLD,ZOLD)
      IF(WINDOF)THEN
C
C     CALCULATE THE OFF-WINDOW FLAG.
C
        LOWFLG = 0
        IF(XOLD .GT. XMAX)LOWFLG = 1
        IF(XOLD .LT. XMIN)LOWFLG = 2
        IF(YOLD .GT. YMAX)LOWFLG = LOWFLG + 4
        IF(YOLD .LT. YMIN)LOWFLG = LOWFLG + 8
      ENDIF
      RETURN
C
      END

	SUBROUTINE CD_1D_LINE_FROM_2D (dset, cdfid, varid, vname,
     .			axcalt, axlagf, axlagt, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*.
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*

* this routine gets the 2D FMRC time array into memory and calls
* CD_MAKE_FMRC_AXES to synthesize the T calendar time and F lead time
* axes that are needed to support FMRC visualization and analysis
* it also modifies the time axis (native_tax) of the dataset -- which TDS
* provides only as a undocumented dimension, making a lag time axis (axlagt)

* V695+ *acm* and *sh*
* V698  *sh* 3/16 -- modify the native taxis (axlagt) to become a lag time
*                 -- look for and read time_bounds 2d array if it exists
* V72 6/17 *acm* For trac enhancement #767 -- dynamic coordinate storage 
* v751 *acm*  6/19 Allow for longer strings as attribute values (line_name is length 64)

* include files
        include 'netcdf.inc'
	include 'tmap_errors.parm'
#include "gt_lib.parm"
	include 'tmap_dims.parm'
#include "tmap_dset.parm"

	include 'xio.cmn_text'
	include 'xtm_grid.cmn_text'
	include 'xunits.cmn_text'
	external xgt_grid_data


* calling argument declarations
	INTEGER dset, cdfid, varid, axcalt, axlagf, axlagt, status
	CHARACTER*(*) vname

* internal variable declarations
	LOGICAL NC_GET_ATTRIB_STRING, coordvar, has_edges, do_warn, got_it
	INTEGER TM_LENSTR1, cdfstat, i, outflag, nvatts, vartype,
     .		start(nferdims),count(nferdims), zero(nferdims),
     .		npts, nT, nF, npts_cdf, vdims(8), nvdim,
     .		vlen, blen, bndid, attid, attype, attlen, attoutflag
	REAL*8  TM_WORLD_AX, avg_lag, uppermost
	CHARACTER  TM_STRING*13, buff*256
	CHARACTER bname*64, attname*64

	INTEGER max_slen
	PARAMETER (max_slen = 64)

* initialize
	do_warn = .FALSE.
	vlen = TM_LENSTR1(vname)


* start out by getting an overview of the 2D time variable
	CALL CD_GET_VAR_INFO (dset, varid, vname, vartype, 
     .            nvdim, vdims, nvatts, coordvar, outflag, status)

* Read the 2d time coordinate array from the netCDF dataset
* Save it at the start of available line storage memory

	npts = 1
	DO i = 1, nvdim
	   CALL CD_GET_DS_DIMS (dset, vdims(i), buff, npts_cdf, status)
	   start(i) = 1
	   count(i) = npts_cdf
	   zero(i) = 0
	   npts = npts* npts_cdf
	ENDDO
	nT = count(1)   ! number of time steps per forecast
	nF = count(2)   ! number of forecasts in collection

* grab a temporary dynamic axis slot for it. Store it in the axis axcalt 
* as that axis will be set up with the coordinates

	CALL TM_ALLO_TMP_LINE(axcalt, status)
	IF (status .NE. merr_ok) GOTO 5000

	CALL GET_LINE_DYNMEM (npts+1, axcalt, status)
	IF (status .NE. merr_ok) GOTO 5000 
	CALL CD_READ_SUB(cdfid, varid, nvdim, start, count, zero, zero, 
     .			 linemem(axcalt)%ptr, 0, 0, cdfstat)
	IF ( cdfstat .NE. NF_NOERR ) GOTO 5000

************* start bounds reading
	has_edges = .FALSE.   ! assume failure
* if a 2d time_bounds array exists, read the bounds from it
* ... first look for a "bounds" attribute on the 2d time array
	CALL CD_GET_VAR_ATT_ID (dset, varid, 'bounds', attid, status)
	IF (status.EQ.atom_not_found) GOTO 1000

* ... get the name of the variable pointed to by the bounds array
        CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, 
     .                attname, attype, attlen, attoutflag, status )
	IF (status.EQ.atom_not_found) GOTO 999
	IF (attype .NE. NCCHAR) GOTO 999
	got_it = NC_GET_ATTRIB_STRING (dset, varid, attname, 
     .                                do_warn, vname(:vlen), max_slen, 
     .                                attlen, attoutflag, bname)
	IF (.NOT.got_it) GOTO 999

        CALL TM_CHECK_FMRC_BNDS_ATTRIB (dset, nT, nF, vname, vlen, 
     .                                  bname, bndid, status)
        IF (status .NE. merr_ok) GOTO 999
	blen = TM_LENSTR1(bname)

* ... set up limits for reading the lower bounds
	nvdim = 3
	start(1) = 1  ! lower bounds
	count(1) = 1
	zero (1) = 0
	start(2) = 1
	count(2) = nT
	zero (2) = 0
	start(3) = 1
	count(3) = nF
	zero (3) = 0

* ... read the lower bounds into line memory above the 2d time coordinates
	CALL CD_READ_SUB(cdfid, bndid, nvdim, start, count, zero, zero, 
     .			 lineedg(axcalt)%ptr, 0, 0, cdfstat)
	IF ( cdfstat .NE. NF_NOERR ) GOTO 999

* ... alter limits for reading the single upper bound of the top point
	start(1) = 2  ! upper bound
	count(1) = 1
	zero (1) = 0
	start(2) = nT
	count(2) = 1
	zero (2) = 0
	start(3) = nF
	count(3) = 1
	zero (3) = 0

* ... read the upper-upper bound into line memory above the 2d lower bounds
	CALL CD_READ_SUB(cdfid, bndid, nvdim, start, count, zero, zero, 
     .			 uppermost, 0, 0, cdfstat)
	IF ( cdfstat .NE. NF_NOERR ) GOTO 999
	CALL PUT_LINE_COORD ( lineedg(axcalt)%ptr, 2*npts+1, uppermost )

* ... success!
	has_edges = .TRUE.
	GOTO 1000

* ... report corruption in bounds linkage
 999	CALL TM_NOTE('2D bounds attribute corruption', lunit_errors)
************* end bounds reading

* make the axes needed by the FMRC dataset
 1000	CALL CD_MAKE_FMRC_AXES (dset, has_edges, varid, vname, vartype,
     .			    npts, nT, nF, axcalt, axlagf, status)
	IF (status .NE. merr_ok) GOTO 5000

* 3/16 - correct the lag-time axis of the FMRC (created by Unidata TDS)
*    from a simplistic 1, ..Nt axis to a true delta (lag) time
	line_unit_code(axlagt) = line_unit_code(axcalt)
	line_units(axlagt) = un_name(line_unit_code(axlagt))
	line_direction(axlagt) = 'TT'
	line_dattype  (axlagt) = nf_double
	line_dim_only (axlagt) = .FALSE.  ! no longer netCDF dim w/o coord var

	avg_lag = ( TM_WORLD_AX(nT, axcalt, box_middle )
     .	          - TM_WORLD_AX(1,  axcalt, box_middle ) ) / (nT-1)
	line_start(axlagt)     = avg_lag/2.  ! box 1 starts at 0.0
	line_delta(axlagt)     = avg_lag

* successful completion
        status = merr_ok
	RETURN

* error exit
 5000	RETURN

	END

*           rr_diff_sy.F
*
*           Rick Romea
*           Jan. 24, 2000
*
*     Meridional diffusive term: A S_yy
*     Units :    (SALINITY(ppm) - 0.035)/s
*     MOM2 Grid:  T  
*
*******************************************************************

      SUBROUTINE RR_diff_sy_init(id)
	IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

      CALL ef_set_desc             (id,
     .'Ah d^2S/dy^2 diffusive term (SALT/s);MOM2 T Grid')
      CALL ef_set_num_args         (id, 2)
      CALL ef_set_axis_inheritance (id, IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok     (id, NO, NO, NO, NO)

      CALL ef_set_arg_name         (id, ARG1, 'U')
      CALL ef_set_arg_desc         (id, ARG1,
     . 'Zonal velocity, required to access the MOM2 U Grid. ')
      CALL ef_set_arg_unit         (id, ARG1, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG1, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG1, YES, YES, YES, YES)
      CALL ef_set_axis_extend      (id, ARG1, Y_AXIS,-1,+1)

      CALL ef_set_arg_name         (id, ARG2, 'SALT')
      CALL ef_set_arg_desc         (id, ARG2,
     . 'Potential temperature, on the MOM2 T Grid. ')
      CALL ef_set_arg_unit         (id, ARG2,
     .  'deg-C')
      CALL ef_set_arg_type         (id, ARG2, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2, NO, NO,YES,YES)
      CALL ef_set_axis_extend      (id, ARG2, Y_AXIS,-1,+1)

      END


      SUBROUTINE RR_diff_sy_compute(id, arg_1, arg_2, result)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER        id

      REAL           bad_flag(EF_MAX_ARGS)
      REAL           bad_flag_result

      REAL           arg_1 (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .                      mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL           arg_2 (mem2lox:mem2hix, mem2loy:mem2hiy, 
     .                      mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL           result (memreslox:memreshix,memresloy:memreshiy,
     .                       memresloz:memreshiz,memreslot:memreshit)

      INTEGER        res_lo_ss (4)
      INTEGER        res_hi_ss (4)
      INTEGER        res_incr  (4)

      INTEGER        arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER        arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER        arg_incr  (4,EF_MAX_ARGS)

      INTEGER        i,  j,  k,  l
      INTEGER        i2, j2, k2, l2

      REAL*8         yU(1024)
      REAL*8         yT(1024)
      INTEGER        ilat
      CHARACTER *16  ax_name(4)
      CHARACTER *16  ax_units(4)
      LOGICAL        backward(4)
      LOGICAL        modulo(4)
      LOGICAL        regular(4)

      REAL dyt,dyu,xjt
      REAL cst,csu,diff_cnt,ahc_south,ahc_north
     .               
	INCLUDE 'rr_parameters.h'

C*********************************************************************
c  MOM2 Code:
c      DIFF_Ty(i,k,j) = ahc_north(j)*(t(i,k,j+1,n) - t(i,k,j,  n))
c     &               - ahc_south(j)*(t(i,k,j  ,n) - t(i,k,j-1,n))
c          ahc_north(j) = diff_cnt(j)*csu(j)*dyur(j)
c     &                            *cstr(j)*dytr(j)
c          ahc_south(j) = diff_cnt(j)*csu(j-1)*dyur(j-1)
c     &                            *cstr(j)*dytr(j)
c          diff_cnt(j)  = ah*xjt(j)
c          xjt(j) = 3.166*dyt(j)*dytr(50)-2.166
c     dyt     = latitudinal height of "t" grid box (in cm)
c     dytr   = reciprocal of "dyt"
c     dyu     = latitudinal height of "u,v" grid box (cm)
c     dyur    = reciprocal of "dyu"
c
c     ah     = constant lateral diffusion coeff for tracers(cm**2/sec) 
c               ah = 2.e7
c     csu     = cosine of "u,v" grid point latitude
c               csu(j)  = cos(phiu(j))
c     cst     = cosine of "t" grid point latitude
c               cst(j)  = cos(phit(j))
c     cstr    = reciprocal of "cst"
c     n = 1 => temperature
c     n = 2 => salinity
c*********************************************************************

      !  Statement functions

      dyt(iLat) = SNGL(yU(iLat)-yU(iLat-1))*Latitude_to_cm
      dyu(iLat) = SNGL(yT(iLat+1)-yT(iLat))*Latitude_to_cm
      xjt(iLat) = 3.166*dyt(iLat)/dyt_ref-2.166
      diff_cnt(iLat) = ah*xjt(iLat)
      cst(iLat) = cos(SNGL(yT(iLat))*Degrees_to_radians) 
      csu(iLat) = cos(SNGL(yU(iLat))*Degrees_to_radians) 
      ahc_south(iLat) = diff_cnt(iLat)*csu(iLat-1)
     .                         /cst(iLat)/dyu(iLat)/dyt(iLat)
      ahc_north(iLat) = diff_cnt(iLat)*csu(iLat)
     .                         /cst(iLat)/dyu(iLat)/dyt(iLat)
      ! Get axis data

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags      (id, bad_flag,  bad_flag_result)
      CALL ef_get_coordinates    (id, ARG1, Y_AXIS, 
     .                            arg_lo_ss(Y_AXIS,ARG1),
     .                            arg_hi_ss(Y_AXIS,ARG1), yU)
      CALL ef_get_coordinates    (id, ARG2, Y_AXIS, 
     .                            arg_lo_ss(Y_AXIS,ARG2),
     .                            arg_hi_ss(Y_AXIS,ARG2), yT)

      ! Check axis units:  bail out if not lat and lon.

      CALL ef_get_axis_info      (id, ARG1, ax_name, ax_units, 
     .                                backward, modulo, regular) 
      IF     ( ax_units(1) .NE. 'deg'       .AND.
     .         ax_units(1) .NE. 'degrees_E'       .AND.
     .         ax_units(1) .NE. 'longitude' .AND.
     .         ax_units(1) .NE. 'Longitude' .AND. 
     .         ax_units(1) .NE. 'LONGITUDE' ) THEN
        WRITE (6,*)'Longitude axis units =', ax_units(1) 
        !CALL ef_bail_out(id,'Longitude axis must be in degrees')
      ENDIF

      IF     ( ax_units(2) .NE. 'deg'       .AND.
     .         ax_units(2) .NE. 'degrees_N'       .AND.
     .         ax_units(2) .NE. 'latitude'  .AND.
     .         ax_units(2) .NE. 'Latitude'  .AND. 
     .         ax_units(2) .NE. 'LATITUDE' ) THEN
        WRITE (6,*)'Latitude axis units =', ax_units(2) 
        !CALL ef_bail_out(id,'Latitude axis must be in degrees')
      ENDIF

      l2 = arg_lo_ss(T_AXIS,ARG2) 
      DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         
         k2 = arg_lo_ss(Z_AXIS,ARG2)
         DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

            ilat = 2
            j2 = arg_lo_ss(Y_AXIS,ARG2) 
            DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

               i2 = arg_lo_ss(X_AXIS,ARG2) + 1
               DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

                  IF (arg_2(i2,  j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2,  j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2,  j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2-1,k2,l2) .EQ. bad_flag(ARG2) )THEN
                     result(i,j,k,l) = bad_flag_result
                  ELSE
                     result(i,j,k,l) = (
     .                  ahc_north(iLat)*
     .                    (  arg_2(i2,j2+1,k2,l2)
     .                     - arg_2(i2,j2  ,k2,l2))
     .                - ahc_south(iLat)*
     .                    (  arg_2(i2,j2  ,k2,l2) 
     .                     - arg_2(i2,j2-1,k2,l2))
     .                             )*sec_per_month
                  ENDIF

                  i2 = i2 + arg_incr(X_AXIS,ARG2)
               ENDDO

               iLat = iLat + 1
               j2 = j2 + arg_incr(Y_AXIS,ARG2)
            ENDDO               

            k2 = k2 + arg_incr(Z_AXIS,ARG2)
         ENDDO

         l2 = l2 + arg_incr(T_AXIS,ARG2)
      ENDDO

      END

	SUBROUTINE DO_4D_STRING_GOODBAD( trans,
     .				com, com_mr, com_cx,
     .				res, res_mr, res_cx, arg )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* perform a multi-axis transformation

* multi-axis transformations are those special cases where sequential
* application of single-axis transforms may yield improper results. For
* example, averaging within a circular region would give inappropriate
* results if carried out sequentially: the first axis of averaging would
* be correct but the second axis would weight each averaged row from the
* first axis equally, despite the fact that they represented different
* numbers of data points.

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* Compute NGD NBD for string variables.
*
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'

* internal variable declarations:
	LOGICAL point, yes_ax(nferdims), no_ax(nferdims),
     .	        at_ave, at_var, at_din, at_nbd, at_ngd
	INTEGER idim, i, j, ir, jr, kr, lr, mr, nr,
     .	        ic, jc, kc, lc, mc, nc, nbd, ngd,
     .	        com_lo(nferdims), com_hi(nferdims),
     .	        ind_lo, ind_hi
	REAL    bad_com, bad_res

* calling argument declarations:
	INTEGER trans, com_mr, com_cx, res_mr, res_cx
	REAL*8  com( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif )
	REAL    arg,
     .          res( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif )

* equivalences
	LOGICAL yes_xax, yes_yax, yes_zax,
     .          yes_tax, yes_eax, yes_fax,
     .          no_xax,  no_yax,  no_zax,
     .          no_tax,  no_eax,  no_fax

	INTEGER GET_C_STRING_LEN, slen, 
     .		i_lo, j_lo, k_lo, l_lo, m_lo, n_lo,
     .		i_hi, j_hi, k_hi, l_hi, m_hi, n_hi

	EQUIVALENCE ( yes_ax(1), yes_xax ),
     .		    ( yes_ax(2), yes_yax ),
     .		    ( yes_ax(3), yes_zax ),
     .		    ( yes_ax(4), yes_tax ),
     .		    ( yes_ax(5), yes_eax ),
     .		    ( yes_ax(6), yes_fax ),
     .		    (  no_ax(1),  no_xax ),
     .		    (  no_ax(2),  no_yax ),
     .		    (  no_ax(3),  no_zax ),
     .		    (  no_ax(4),  no_tax ),
     .		    (  no_ax(5),  no_eax ),
     .		    (  no_ax(6),  no_fax ),
     .		    (  com_lo(1),  i_lo ),
     .		    (  com_lo(2),  j_lo ),
     .		    (  com_lo(3),  k_lo ),
     .		    (  com_lo(4),  l_lo ),
     .		    (  com_lo(5),  m_lo ),
     .		    (  com_lo(6),  n_lo ),
     .		    (  com_hi(1),  i_hi ),
     .		    (  com_hi(2),  j_hi ),
     .		    (  com_hi(3),  k_hi ),
     .		    (  com_hi(4),  l_hi ),
     .		    (  com_hi(5),  m_hi ),
     .		    (  com_hi(6),  n_hi )

* --- end of introductory code ---

* initialize
	bad_com = mr_bad_data( com_mr )
	bad_res = mr_bad_data( res_mr )

	at_nbd = trans .EQ. trans_4d_bad_pt
	at_ngd = trans .EQ. trans_4d_good_pt

* determine the axes to be transforomed
	DO 10 idim = 1, nferdims
	  yes_ax(idim) = cx_trans(idim,res_cx) .EQ. trans
	  no_ax (idim) = .NOT. yes_ax(idim)
 10	CONTINUE

* do the transformation:  ngood, nbad only
* Write a note about missing values of strings 

	IF (at_ngd) THEN
	   CALL WARN
     .    ('@NGD of string variable, counting null strings as missing')
	ELSEIF (at_nbd) THEN
	   CALL WARN
     .    ('@NBD of string variable, counting null strings as missing')
	ENDIF

* Note: the looping structure allows a possible mix of axis transforms
*	to be performed in a single framework
* ... set up default limits (com_lo, com_hi) in preparation for the inner loop
* "r" refers to result, "c" refers to component

* Set the range of loop indices for the component data on the transformed axes
	DO 150 idim = 1, nferdims
	  IF (yes_ax(idim)) THEN
	    com_lo(idim) = cx_lo_ss(com_cx,idim)
	    com_hi(idim) = cx_hi_ss(com_cx,idim)
	  ENDIF
 150	CONTINUE


* LOOP OVER THE FULL RANGE OF THE RESULT
* ... also set up loop indices for non-transformed axes
*     (component loop to include only the single result point on "no" axes)
	DO 300 nr = cx_lo_s6(res_cx), cx_hi_s6(res_cx)
	IF (no_fax) THEN
	   n_lo = nr
	   n_hi = nr
	ENDIF
	DO 300 mr = cx_lo_s5(res_cx), cx_hi_s5(res_cx)
	IF (no_eax) THEN
	   m_lo = mr
	   m_hi = mr
	ENDIF
	DO 300 lr = cx_lo_s4(res_cx), cx_hi_s4(res_cx)
	IF (no_tax) THEN
	   l_lo = lr
	   l_hi = lr
	ENDIF
	DO 300 kr = cx_lo_s3(res_cx), cx_hi_s3(res_cx)
	IF (no_zax) THEN
	  k_lo = kr
	  k_hi = kr
	ENDIF
	DO 300 jr = cx_lo_s2(res_cx), cx_hi_s2(res_cx)
	IF (no_yax) THEN
	  j_lo = jr
	  j_hi = jr
	ENDIF
	DO 300 ir = cx_lo_s1(res_cx), cx_hi_s1(res_cx)
	IF (no_xax) THEN
	  i_lo = ir
	  i_hi = ir
	ENDIF

* initialize the inner loop accumulators

	  ngd  = 0
	  nbd  = 0

* now loop over the component data accumulating results along relevant axes

	  DO 210 nc = n_lo, n_hi
	  DO 210 mc = m_lo, m_hi
	  DO 210 lc = l_lo, l_hi
	  DO 210 kc = k_lo, k_hi
	  DO 210 jc = j_lo, j_hi
	  DO 210 ic = i_lo, i_hi
             slen = GET_C_STRING_LEN(com(ic,jc,kc,lc,mc,nc))
             IF ( slen .GT. 0 ) THEN
                ngd = ngd + 1
             ELSE
                nbd = nbd + 1
             ENDIF
 210	  CONTINUE

* compute result from accumulators
	  IF (at_ngd) THEN
	     res(ir,jr,kr,lr,mr,nr) = ngd
	  ELSEIF (at_nbd) THEN
	     res(ir,jr,kr,lr,mr,nr) = nbd
	  ENDIF

 300	CONTINUE

	RETURN
 
	END

	SUBROUTINE DO_REGRID_TO_DSG( src_cx, dst_cx, dset, nfeatures, nobs,
     .				     src, dst)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* sample the gridded source data at the ragged points of the destination DSG

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V720:  *sh* 5/17
* V751: *acm* 8/19 tweaks for grid-to-trajectory 
* V751: *acm* 8/19 apply obs-level masking 
* V751: *acm* 8/19 Handle regrids to timeseries or trajectory
*                  where the grid doesn't have z but the DSG data does
*                  and vice versa (untested). 
* V76  1/20 *acm* working with Point-type dsg data 

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xtm_grid.cmn_text'
	include 'xdset_info.cmn_text'
	include 'xdyn_linemem.cmn_text'
	include 'xcontext.cmn'
	include 'xdsg_context.cmn'
	include 'xprog_state.cmn'
	include 'xvariables.cmn'
	include 'xmem_subsc.cmn'

* calling argument declarations:
	INTEGER	src_cx, dst_cx, dset, nfeatures, nobs
        REAL    src( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          dst(nobs)

* local variable declarations:
	LOGICAL ITSA_DSG_TRAJ, fmask(nfeatures), 
     .		process_obs(nobs), sampled_ax(4), skipz

* ... sample_ax is not the same as cxdsg_has_coord cuz the source data may
*     have fixed coordinates on some of the DSG coordinates
	INTEGER ISUBSCRIPT, TM_DSG_DSET_FROM_GRID, TM_LENSTR1,
     .		src_grid, dst_grid, row_size_lm,
     .		idim, ifeature, iobs, ptr, base, ivar, obs_in_feature,
     .		ss(nferdims), orient, status
	REAL	TDEST_CONVERT, ww_lo(4), ww_hi(4), coord
	CHARACTER*20  CD_DSG_FEATURENAME, buff

! DSGTBD need to offer linear interpolation option
!      as well as current point-in-box
! DSGTBD need to check T input grids.  X modulo does work

* initialize
	src_grid = cx_grid(src_cx)
	dst_grid = cx_grid(dst_cx)
	dset = TM_DSG_DSET_FROM_GRID(dst_grid)
	dst_grid = dsg_xlate_grid(dset)

!	bad_src = cx_bad_data( src_cx )   ! not needed here but
!	bad_dst = cx_bad_data( dst_cx )   ! would be needed for interpolation

! set up conversions between DSG times and the time axis of the source grid
	CALL TDEST_WORLD_INIT(dst_grid, src_grid, t_dim, status)
	IF (status .NE. ferr_ok) RETURN

* DSG-specific initialize
	row_size_lm = dsg_loaded_lm(dsg_row_size_var(dset))


* if the orientation is trajectory, timeseries, or point, and if only one of the source 
* and destination grids has z coordinates then ignore it in the other. 

	skipz = .FALSE.
	orient = dsg_orientation(dset)

	IF (orient.NE.z_dim) THEN 
	   IF ( (grid_line(z_dim,src_grid).NE.mnormal .AND. grid_line(z_dim,dst_grid).EQ.mnormal) .OR.
     .          (grid_line(z_dim,src_grid).EQ.mnormal .AND. grid_line(z_dim,dst_grid).NE.mnormal) ) THEN
	      skipz = .TRUE.
	      buff = CD_DSG_FEATURENAME(orient)

	      IF (grid_line(z_dim,dst_grid).EQ.mnormal) CALL WARN ('Gridded data has a Z axis, but '//
     .         buff(:TM_LENSTR1(buff))//' data does not. Use surface data from gridded dataset')
	   ENDIF 
	ENDIF

* determine relevant axes, coordinate limits, and unsampled subscripts
	DO idim = 1, 4
	   IF (idim.EQ.z_dim .AND. skipz) CYCLE
	   sampled_ax(idim) = cx_regrid_trans(idim,dst_cx)
     .			  .NE. unspecified_int4
	   IF ( sampled_ax(idim) ) THEN
* ... the axis of regridding
	      ww_lo(idim) = cx_lo_ww(idim,src_cx)
	      ww_hi(idim) = cx_hi_ww(idim,src_cx)
	   ELSE
* ... all other spatial axes
	      IF (cx_lo_ss(src_cx,idim).NE.cx_hi_ss(src_cx,idim)) GOTO 5100
	      ss(idim) = cx_lo_ss(src_cx,idim)
	   ENDIF
	ENDDO
	ss(e_dim) = cx_lo_ss(src_cx,e_dim)
	ss(f_dim) = cx_lo_ss(src_cx,f_dim) ! DSGTBD F axis support TBD
! F axis will become an outer DO LOOP around all the logic

* get feature mask
        CALL MAKE_DSG_FEATURE_MASK(dset, dst_cx, fmask, nfeatures)

* ****** PERFORM THE SAMPLING *****
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 
	   obs_in_feature = dsg_linemem(row_size_lm)%ptr(ifeature)
	   IF (orient .EQ. e_dim) obs_in_feature = 1

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) GOTO 500

* ... get the instance-level subscripts in the source data
*     screen out of range instance coordinates in the process
	   DO idim = 1, 4
	      IF (idim.EQ.z_dim .AND. skipz) CYCLE
	      IF ( sampled_ax(idim) ) THEN
	         IF (.NOT.cxdsg_is_obs_coord(idim)) THEN
	            coord = dsg_linemem(cxdsg_coord_lm(idim))%ptr(ifeature)
	            IF (idim .EQ. t_dim) coord = TDEST_CONVERT(coord)
	            IF (coord.LE.ww_lo(idim) .OR. coord.GT.ww_hi(idim)) THEN
	               GOTO 500
	            ELSE
	               ss(idim) = ISUBSCRIPT(coord, src_grid, idim, round_dn)
	            ENDIF
	         ENDIF
	      ENDIF
	   ENDDO
	   IF (skipz) ss(3) = m1loz

* ... get observation-level mask for this feature
	   IF (orient .EQ. e_dim) THEN
	      process_obs(1) = .TRUE.
	   ELSE
	      CALL MAKE_DSG_OBS_MASK(dset, dst_cx, ifeature, base,
     .				  process_obs, obs_in_feature)
	   ENDIF

! DSGTBD Performance optimization possible using a variation on ISUBSCRIPT
! ISUBSCRIPT is where the compute-intensive parts of this procedure occur. 
! A version that pre-checks whether the next subscript is unchanged or
! neighbor to the previously found one on this axis could save time

* ... loop over the observations within each feature
	   DO iobs = 1, obs_in_feature
	      ptr = base + iobs  ! pointer (index) into the ragged contig array

* ... have the user's constraints removed this observation?
	      IF (.NOT.process_obs(iobs)) CYCLE

* ... get the obs-level subscripts in the source data
	      DO idim = 1, 4
	         IF (idim.EQ.z_dim .AND. skipz) CYCLE
	         IF ( sampled_ax(idim) ) THEN
	            IF (cxdsg_is_obs_coord(idim)) THEN
	               coord = dsg_linemem(cxdsg_coord_lm(idim))%ptr(ptr)
	               IF (idim .EQ. t_dim) coord = TDEST_CONVERT(coord)
	               IF (coord.LE.ww_lo(idim) .OR. coord.GT.ww_hi(idim)) THEN
	                  GOTO 400
	               ELSE
	                  ss(idim) = ISUBSCRIPT(coord,src_grid,idim,round_dn)
	               ENDIF
	            ENDIF
	         ENDIF
	      ENDDO

* ... pluck out the gridded source value and insert into the DSG output
	      dst(ptr) = src(ss(1),ss(2),ss(3),ss(4),ss(5),ss(6))  

! DSGTBD: creating equivalences to ss() will slightly shorten code
!         I didn't do this because equivs are invisible in Totalview

 400	      CONTINUE
	   ENDDO ! obs loop
 500	   base = base + obs_in_feature
	ENDDO    ! feature loop

	RETURN

* untrapped error -- SHOULD NEVER HAPPEN -- but if it did anyway, this is nicer
* to the user than a STOP
 5000	RETURN
 5100	CALL ERRMSG( ferr_internal, status, 'DO_REGRID_TO_DSG', *5000)
	END

	SUBROUTINE LIST_DSG_COMMA_TAB (dset, cx_list, mr_list, nvar,
     .				      heading, nfeatures, nobs )


*
*  This software was developed by the Science Data Integration Group (SDIG) 
*  of the National Oceanographic and AtmosphericAdministration's (NOAA) 
*  Pacific Marine Environmental Lab(PMEL) as part of Ferret/PyFerret
*  5/1/2019
*
* List data from a single DSG feature collection as a tab- or comma-delimited file
* with a header
* 
*  6/2019 *acm* Write strings in id's, dates without quotes (as ERDDAP does)
*  7/2019 *acm* Future: assign precision per variable, but for now use default or user-set prec.
* V751 7/18 *acm* Call single routine for DSG feature-type names
* V76  1/20 *acm* working with Point-type dsg data 

        include 'netcdf.inc'
	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xtm_grid.cmn_text'
	include 'xdset_info.cmn_text'
	include 'xdyn_linemem.cmn_text'
	include 'xcontext.cmn'
	include 'xprog_state.cmn'
	include 'xvariables.cmn'
	include 'slash.parm'
	include 'xrisc.cmn'          ! SPLIT_LIST buffer


* calling argument declarations:
	LOGICAL heading
	INTEGER dset, nvar, nfeatures, cx_list(nvar), mr_list(nvar)

* internal parameter declarations:
	INTEGER maxlen
	PARAMETER (maxlen = 20)   ! length of buffer str

* internal variable declarations:
	LOGICAL process_feature(nfeatures), process_obs(nobs), its_dsg, 
     .		has_mask, norow
	LOGICAL instance_coord(4), relevant_coord(4),
     .		instance_var(nvar), point_var(nvar), 
     .		instance_vars_only, point_vars_only, 
     .		ftr_label, do_comma_del, do_tab_del
	INTEGER CGRID_SIZE, TM_LENSTR1, DSG_WHATS_IT, GET_OFFSET_C_STRING_LEN,
     .		i, j, ifeature, ivar, iobs, nobs, idim, cx, grid, slen,
     .		orientation, obsdimlen, coord_lm(4), fvar_varid, base, ptr,
     .		bufflen, line, mr,  gxlate, row_size_lm, clen, nblank,
     .		feature_line, prec_digits(nvar), iwd, 
     .		alen, slen1, slen2, vname_len, list_dsg_digits, dtype, 
     .		idlen, ilen, direc(nvar), vstrlen, paren, coord_ord(4), 
     .		icol, ipad, sdim, blen, status
	REAL	value
	CHARACTER VAR_CODE*128, TM_FMT*48, VAR_UNITS*64,
     .		FMT*20, AX_TITLE*32, AX_TITLE_UNITS*64, SANITARY_VAR_CODE*128, 
     .		CD_DSG_FEATURENAME*20,
     .		strbuff*128, line_buff*10000, vcode(nvar)*128,  bad_buff*32,
     .		col_head_format*64, pstr*15, feature_idname*32, id_buff*128,
     .		tab_or_comma*1, cn*8

	CHARACTER*255	VAR_TITLE, VAR_TITLE_MOD, PAREN_SURROUND, vname_buff

	PARAMETER (vstrlen=40)  ! length of vstr
	CHARACTER vstr*40

	
*internal variable declarations:
        INTEGER flen
        PARAMETER  ( flen = 255 )
	INTEGER*1 fhol(flen)	! c-type Hollerith string buffer


	DATA coord_ord /4,1,2,3/
	

* initialize

        norow = qual_given(slash_list_norow) .GT. 0

* ... column headings for tab and comma-delimited output (9/95)
		
        do_tab_del   = list_fmt_type .EQ. plist_tab_del
        do_comma_del = list_fmt_type .EQ. plist_comma_del

	IF ( do_comma_del ) THEN
	   tab_or_comma = ','
	ELSEIF( do_tab_del ) THEN
	   tab_or_comma = CHAR(9)
	ENDIF

	gxlate = dsg_xlate_grid(dset)
	cx = cx_list(1)
	grid = cx_grid(cx)
	its_dsg = .TRUE.
	CALL TM_DSG_FACTS( grid,
     .			   orientation, obsdimlen, feature_line, its_dsg )
	IF (.NOT. its_dsg) GOTO 5200
	row_size_lm = dsg_loaded_lm(dsg_row_size_var(dset))

	feature_idname = 'feature-id'
	IF (orientation.GE.pfeatureType_Trajectory .AND. orientation.LE.pfeatureType_Point) THEN
	   strbuff = CD_DSG_FEATURENAME(orientation)
	   feature_idname = strbuff(:tm_lenstr1(strbuff)) // '-id'
	ENDIF

	pstr = '               '

* determine precision for outputting values

	list_dsg_digits = MAX(16,list_digits + 2)

	i = qual_given( slash_list_precision ) 
	IF ( i .GT. 0 ) THEN
	   CALL EQUAL_VAL( cmnd_buff(qual_start(i):qual_end(i)),
     .                     value, status )
           IF ( status .NE. ferr_ok ) GOTO 5100
	   list_dsg_digits = MAX(1.,MIN(value, 16.))	! 1 to 16
	ENDIF

* are there any observation vars?  Or is this all instance vars?
	point_vars_only    = .TRUE.   ! a hack to list E=@AVE result
	instance_vars_only = .TRUE.   ! a hack to list instance vars only
	ftr_label = .TRUE.

	DO ivar = 1, nvar
	   cx = cx_list(ivar)
	   grid = cx_grid(cx)
	   instance_var(ivar) = DSG_WHATS_IT(grid) .EQ. pdsg_instance
	   point_var(ivar) = CGRID_SIZE(cx) .EQ. 1
	   IF (.NOT.point_var(ivar)   ) point_vars_only    = .FALSE.
	   IF (.NOT.instance_var(ivar)) instance_vars_only = .FALSE.
	ENDDO

********** as in list_multi ***

* get direction of each variable in the dsg file

	DO ivar = 1, nvar
	   
	   cx = cx_list(ivar)
	   mr = mr_list(ivar)
	   direc(ivar) = no_dim

	   DO idim = 1, nferdims
	      IF ( cx_hi_ss(cx,idim) .GT. cx_lo_ss(cx,idim) ) 
     .	          direc(ivar) = idim
	   ENDDO
	
	ENDDO

* The varid of the feature-id variable
 
	line_buff = SANITARY_VAR_CODE(cat_file_var, dsg_feature_var(dset) )
	CALL CD_GET_VAR_ID  (dset, line_buff, fvar_varid, status)

* which dimensions are relevant to show
	DO idim = 1, 4
	   line = grid_line(idim, gxlate)
	   relevant_coord(idim) =  line.NE.mnormal .AND. .NOT.point_vars_only
	   IF (relevant_coord(idim)) THEN
	      ivar = dsg_coord_var(idim,dset)
	      coord_lm(idim) = dsg_loaded_lm(ivar)  ! line memory table indices
	      instance_coord(idim) = line_dim(line) .EQ. nfeatures

	      IF (instance_vars_only .AND. .NOT.instance_coord(idim))
     .		   relevant_coord(idim) = .FALSE.
	   ENDIF
	ENDDO


* create a mask showing which features to list
	IF (point_vars_only) THEN
	   process_feature(1) = .TRUE.    ! E axis reduced to 1 point
	   ftr_label = (nfeatures .EQ. 1) ! if compressed along ftr dir, don't list feature lab
	ELSE
	   CALL MAKE_DSG_FEATURE_MASK(dset, cx, process_feature, nfeatures)
	ENDIF
	IF (norow) ftr_label = .FALSE.

* Header

	IF (heading) THEN

* data set name and title
	   CALL GET_DSET_NAME( dset, line_buff, alen )
	   CALL SPLIT_LIST(pttmode_explct, list_lun,
     .		'             DATA SET: '//line_buff(:alen), alen+23)

* ... title of data set
	   CALL GET_DSET_TITLE( dset, line_buff, alen )
	   IF ( alen .GT. 1 ) CALL SPLIT_LIST(pttmode_explct, list_lun,
     .		'             '//line_buff(:alen), alen+13)


* ... then variable titles and any special limits or data set for a variable

	   strbuff = VAR_CODE( cat_file_var, dsg_feature_var(dset))
	   alen = TM_LENSTR1( strbuff )
	   strbuff = feature_idname

	   vname_len = 0
	   DO ivar = 1, nvar
	      cx = cx_list(ivar)
	      strbuff = VAR_CODE( cx_category(cx),cx_variable(cx))
	      vname_len = MAX(TM_LENSTR1(strbuff), vname_len)
	   ENDDO

	   vname_buff = VAR_CODE( cat_file_var, dsg_feature_var(dset))
*          Appending space just to get rid of a nonsense compiler warning
	   strbuff = feature_idname(:TM_LENSTR1(feature_idname))//' '
	   clen = TM_LENSTR1( strbuff )
	   risc_buff = ' '



* ID-var
	   icol = 1
	
	   cn = TM_FMT(FLOAT(icol), 5,8,slen)
	   ipad = MIN(2,3-slen)
	   risc_buff = " Column"//pstr(:ipad)//cn(:slen)//": "
	   slen = TM_LENSTR1(risc_buff)

* if /NOROW then not writing the ID variable and coordinates

	   IF (norow) THEN

	      icol = 0		! Will start lines labeling columns with variable names
	   
	   ELSE
     
	      risc_buff(slen+2:) = vname_buff(:alen)//' is '//strbuff(:clen)
	      CALL SPLIT_LIST(pttmode_explct, list_lun, risc_buff, 0)

* names of coordinate-variables

	      DO idim = 1, 4
	         sdim = coord_ord(idim)
	         IF ( relevant_coord(sdim) ) THEN
	            icol = icol + 1
	            cn = TM_FMT(FLOAT(icol), 5,8,slen)
	            ipad = MIN(2,3-slen)

	           IF (sdim .EQ. t_dim) THEN
	               col_head_format = AX_TITLE( sdim, gxlate, alen )
	            ELSE
	               col_head_format = AX_TITLE_UNITS( sdim, gxlate, alen )
                    ENDIF

	            risc_buff = " Column"//pstr(:ipad)//cn(:slen)//': '//col_head_format(:alen)

	            CALL SPLIT_LIST(pttmode_explct, list_lun, risc_buff, 0)
	         ENDIF
	      ENDDO

	   ENDIF ! norow

* Variables with units and bad-flag

2020	   format ("(A", I0, ",' is ', A)")
	   WRITE(FMT,2020) vname_len

	   DO ivar = 1, nvar
	   
	      icol = icol + 1

	      cx = cx_list(ivar)
	      mr = mr_list(ivar)
	      vname_buff = VAR_CODE( cx_category(cx),cx_variable(cx))

	      strbuff   = VAR_TITLE( cx )
	      clen   = TM_LENSTR1( strbuff )
	      strbuff(clen+1:)  = ' '//PAREN_SURROUND(VAR_UNITS(cx), slen1)
	      clen = clen+1+slen1
	      strbuff(clen+1:) = PAREN_SURROUND(VAR_TITLE_MOD(cx),slen2)
	      clen = clen+slen2
	      risc_buff = ' '

	      cn = TM_FMT(FLOAT(icol), 5,8,slen)
	      ipad = MIN(2,3-slen)
	      risc_buff = " Column"//pstr(:ipad)//cn(:slen)//": "
	      IF (norow .AND. nvar.EQ.1) risc_buff = "Variable: "
	      slen = TM_LENSTR1(risc_buff)

	      WRITE ( risc_buff(slen+2:), FMT ) 
     .           vname_buff(:vname_len), strbuff(:clen)
     	      blen = TM_LENSTR1(risc_buff)

* Show the bad-flag, but not for string variables.

              blen = 0
	      IF ( (mr_type(mr_list(ivar)) .NE. ptype_string)) THEN
                bad_buff = '   BAD FLAG : '// 
     .                  TM_FMT(mr_bad_data(mr),list_dsg_digits,8,blen)
              ENDIF

	      IF (blen .GT. 0) THEN
	         slen = TM_LENSTR1(risc_buff)
	         risc_buff(slen+2:) = bad_buff(:blen+14)
	      ENDIF

	      CALL SPLIT_LIST(pttmode_explct, list_lun, risc_buff, 0)

	   ENDDO  ! nvar
 
	ENDIF  ! heading

* header line for columns  

	slen = 0
	IF (.NOT.norow) THEN
	   line_buff = VAR_CODE( cat_file_var, dsg_feature_var(dset))
	   slen = TM_LENSTR1(line_buff)

	   DO idim = 1, 4
	      sdim = coord_ord(idim)
	      IF ( relevant_coord(sdim) ) THEN	      
	         strbuff = AX_TITLE( sdim, gxlate, alen )
	         line_buff(slen+1:) = tab_or_comma// strbuff(:TM_LENSTR1(strbuff))
	         slen = TM_LENSTR1(line_buff)
	      ENDIF
	   ENDDO
	ENDIF  ! .not. norow


	DO ivar = 1, nvar
	   cx = cx_list(ivar)
	   strbuff = VAR_CODE( cx_category(cx),cx_variable(cx))
	   line_buff(slen+1:) = tab_or_comma//strbuff(:TM_LENSTR1(strbuff))
	   IF (ivar.EQ.1 .AND. norow) line_buff(slen+1:) = strbuff(:TM_LENSTR1(strbuff))
	   slen = TM_LENSTR1(line_buff)
	ENDDO
	IF ( (norow .AND. nvar.GT.1) .OR. (.NOT.norow) ) 
     .	     CALL SPLIT_LIST(pttmode_explct, list_lun, line_buff, 0)


*  ***** LIST THE DATA ******
	base = 0    ! obs index at end of preceding feature
* ... loop over the features
	DO ifeature = 1, nfeatures 
	   nobs = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length

* ... have the user's constraints removed this feature?
	   IF (.NOT.process_feature(ifeature)) GOTO 500

* ... each line starts with the Feature ID
	   id_buff = pstr

	   ilen = 0

* Read the feature-id value. If it's numeric turn it into a string.
cc* If it's a string enclose in quotes for consistency with string variables (?)

	   IF (ftr_label) THEN
	      CALL CD_READ_ONE ( dset, fvar_varid, ifeature, dtype, value, 
     .                                 strbuff, bufflen, status )
	      IF (dtype .NE. NF_CHAR) THEN
	         strbuff = TM_FMT(value, 8, 12, bufflen)
cc	      ELSE
cc	         strbuff = '"'//strbuff(:bufflen)//'"'
cc		 bufflen = bufflen+2
	      ENDIF	 

	      id_buff = strbuff(:bufflen)//tab_or_comma
	      ilen = bufflen + 1

* if compressed along the e dimension don't include the feature-id value.

	   ELSE
	      strbuff = '  '
	      bufflen = 1
	      ilen = bufflen
	   ENDIF

* ... get observation-level mask for this feature
	   CALL MAKE_DSG_OBS_MASK(dset, cx, ifeature, base,
     .				  process_obs, nobs)

* ... loop over the observations within each feature
	   DO iobs = 1, nobs
	      ptr = base + iobs  ! pointer (index) into the ragged contig array

* ... have the user's constraints removed this observation?
	      IF (.NOT.process_obs(iobs)) CYCLE

*             Appending space just to get rid of a nonsense compiler warning
	      line_buff = id_buff(:ilen)//' '
	      slen = ilen

* ... insert the relevant formatted coordinates, time first.
cc*     Put the time string in quotes for consistency

	      IF (.NOT. norow) THEN
	         DO idim = 1, 4
	            sdim = coord_ord(idim)
		    IF ( relevant_coord(sdim) ) THEN
	              IF (instance_coord(sdim)) THEN
* ... feature coordinate
	                  value = dsg_linemem(coord_lm(sdim))%ptr(ifeature)
	               ELSE
* ... obs coordinate
	                  value = dsg_linemem(coord_lm(sdim))%ptr(ptr)
	               ENDIF
		       IF (ABS(value) .GE. ABS(bad_val4)) THEN
		          strbuff = '*'
		       ELSE
	                 CALL TRANSLATE_TO_WORLD( value, sdim, gxlate, 
     .					     ax_dec_pt(sdim), strbuff)
	               ENDIF
		       clen = TM_LENSTR1(strbuff)
		       paren = INDEX((strbuff), "(")
		       IF (paren .GT. 0) clen = MIN(clen,paren-1)
cc		       IF (sdim .EQ. t_dim) THEN
cc		          strbuff = '"'//strbuff(:clen)//'"'
cc		          clen = clen + 2
cc	               ENDIF
		       line_buff(slen+1:) = strbuff(:clen)//tab_or_comma
	               slen = slen + clen + 1
	            ENDIF
	         ENDDO

	      ENDIF ! .not. norow

* ... insert the formatted data

	      bufflen = slen
	      DO ivar = 1, nvar
	         mr = mr_list(ivar)
		 
	         IF ( mr_type(mr) .EQ. ptype_string ) THEN
                    vstr = '                '
                    vstr(1:1) = '"'

	            IF (point_var(ivar)) THEN
* ... compressed feature result
	               iwd = 0
	           ELSEIF (instance_var(ivar)) THEN
* ... feature value
	               iwd = ifeature - 1
	            ELSE
* ... obs value
	               iwd = ptr - 1
	            ENDIF

	            slen = GET_OFFSET_C_STRING_LEN(mr_c_pointer(mr), iwd )
	            slen = MIN(slen, vstrlen-2)  ! fixed length of vstr...
		    CALL GET_OFFSET_C_STRING(mr_c_pointer(mr),
     .				   iwd,
     .				   vstr(2:),
     .				   slen    )
                    vstr(slen+2:slen+2) = '"'    


	         ELSE

	           IF (point_var(ivar)) THEN
* ... compressed feature result
	               value = memry(mr)%ptr(1)
	            ELSEIF (instance_var(ivar)) THEN
* ... feature value
	               value = memry(mr)%ptr(ifeature)
	            ELSE
* ... obs value
	               value = memry(mr)%ptr(ptr)
	            ENDIF
		    
		    IF (value .EQ. mr_bad_data(mr)) THEN
		       vstr = TM_FMT(mr_bad_data(mr),list_dsg_digits,8,blen)
		    ELSE
		       vstr = TM_FMT(value,list_dsg_digits,list_dsg_digits,slen)
		    ENDIF
		 ENDIF

* remove leading blanks   (better way to handle this?)
		 DO i = 1, vstrlen
                    IF ( vstr( i:i ) .NE. ' ' ) ExIT
		 ENDDO
		 CALL TM_PACK_STRING(vstr, vstr, 1, i, clen)
	         clen = TM_LENSTR1(vstr)

	         line_buff(bufflen+1:) = vstr
	         bufflen = bufflen + clen
		 IF (ivar .LT. nvar) THEN
		    line_buff(bufflen+1:) = tab_or_comma
		    bufflen = bufflen+1
		 ENDIF
	      ENDDO

* ... write out the line
	      CALL SPLIT_LIST(pttmode_explct, list_lun, line_buff, 0)

* ... write only a single line from each feature if there are no ragged arrays
	      IF (instance_vars_only) EXIT	! list just one "obs" line
	   ENDDO

 500	   base = base + nobs
	   IF (point_vars_only) EXIT		! list just one "feature" line
	ENDDO   ! loop over features

 5000	RETURN
 5100	CALL ERRMSG( ferr_invalid_command, status,
     .		'Error getting value from LIST/PRECISION= ',
     .		*5000 )
 5200	CALL ERRMSG( ferr_grid_definition, status,
     .		'Data grid is not a DSG grid ',
     .		*5000 )
	END

	SUBROUTINE XEQ_CANCEL

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute the CANCEL command

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 4/3/86
* revision 0.1 - 12/15/86
* revision 0.2 - 3/20/87 - changes for new TMAP library
* revision 0.3 - 5/1/87  - added CANCEL MOVIE, CANCEL LIST/OUT, CANCEL REGION
*			   and CANCEL EXPRESSION
* revision 0.4 - 8/29/87 - updated CANCEL LIST for unformatted option
* revision 0.5 - 9/11/87 - updated CANCEL LIST for BIBO option
* revision 0.6 - 9/16/87 - added CANCEL GRID (not imp)
* revision 0.7 - 9/23/87 - modified CANCEL REGION for predefined regions
*			   and added CANCEL LIST/HEAD
* revision 0.8 - 10/5/87 - modified CANCEL LIST to toggle SET LIST
*			   and added CANCEL LIST/APPEND
* revision 0.9 - 3/7/88  - added list_tmap
* revision 1.0 - 6/29/88 - added CANCEL MEMORY
*			 - CANCEL LIST returns filename to 'AUTO'
*			 - added CANCEL WINDOW
* revision 1.1 - 7/2/88  - CANCEL DATA now wipes out all memory variables that
*			   depend on a climatological air temp. field
* revision 1.2 - 8/2/88  - added mode wait
* revision 1.3 - 9/1/88  - added CANCEL VIEWPORT name
* revision 1.4 - 12/2/88 - bug fix: cancel mem only to max_mr_avail
* revision 1.5 - 1/10/89 - added CANCEL MODE REJECT, corrected last_mode
* revision 1.6 - 2/16/89 - ds_open --> ds_name.EQ.char_init30 to test open-ness
* revision 1.7 - 2/17/89 - GT_CLOSE_SET --> TM_CLOSE_SET   
* revision 1.8 - 4/1/89  - MODE WAIT directly sets PPLUS variable deflts
* V200:  5/24/89 - layout changes, only
* 		 - deleted variables are flagged in mr_protected
*		 - added CANCEL VARIABLE
*		 - CANCEL DATA purges all user defined variables
*		 - added laser movie output
*	10/20/89 - CANCEL DATA removed to CANCEL_DATA_SET, if only one set left
*		 - then cancel data points to it
*	  1/5/90 - added CANCEL MODE metafile
*	 3/13/90 - call CANCEL_WINDOW even if in batch mode
* Unix/RISC port - 4/25/91 *sh*: increased ds_name size
*                              : bug fix in CANCEL MODE: mode_GKS --> pmode_GKS
* V230:5/14/92 - REMOTE_X mode was replaced by the REFRESH mode
*       6/8/92 - added CANCEL ALIAS
*       6/9/92 - CANCEL LIST uses list_fmt_type
*              - added tmap_diag_on to mode diagnostic
*      8/25/92 - added CANCEL AXIS/MODULO
*      11/4/92 - CANCEL VARIABLE to handle long names
*     1/14/93  - gutted CANCEL MOVIE
* V300:2/10/93 - CANCEL MODE META will also issue PPL CLSPLT 
*      5/12/93 - added MODE PPLLIST and MODE JOURNAL filename
*      5/24/93 - added CANCEL DATA/NOERROR
*      6/16/93 - added CANCEL MODE GUI
*      2/24/94 - incorporate a stack of past mode states
* V312: 5/94 - array "memory" as a calling argument
* V314:9/1/94 *kob* IBM port - Need to make logical comparisons with NEQ 
*			       or NEQV
* V320: 12/29/94 - use SPLIT_LIST to redirect tty output for GUI
*	 1/18/94 - check CANCEL MODE VERIFY for "ALWAYS" state
*	 2/28/95 - update TMAP COMMON alt_messages when mode_gui is CANCELLED
* V400:  6/22/95 - added CANCEL SYMBOL
* V411:   9/1/95 - Added support for  CAN VAR/D=dset var
*	  10/95  - buffer READ(*) for AIX port
* V420:    4/96  - use arg_to_item to make comma-separated line blank sep
*		 - templates in CANCEL VAR, SYMBOL, ALIAS, VIEW
*Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
* V450:    7/97  - update CANCEL VAR/ALL so it handles child vars and dynamic
*                  grids/axes
* V510: 5/00 *sh* - added CANCEL AXIS and CANCEL GRID
* v540 *acm* 10/01 increase length of ds_name
* v540 *acm* 10/01 remove VMS include statements
* v541 *acm*  6/02 Add CANCEL AXIS/ALL
*             6/02 For irregular axes, on CANCEL AXIS axname, recover line_mem
*                  space with call to PACK_LINE_STORAGE
* v541 *acm*  7/02 Capitalize routine names in CALL PACK_LINE_STORAGE, DEALLO_ALL_AXES.
* v551 *acm*  1/03 Bug fix: datasets starting with digit not correctly cancelled.
* V570: *acm* 5/04 - add MODE GRATICULE[:argument] 
*       *acm* 6/04 - CANCEL AXIS/DEPTH as inverse to SET AXIS/DEPTH
* V600: *acm* 2/06 - fix bug 1392: cancel dataset whose name starts with digit.
* V600 *acm* 10/05 CANCEL ATTRIBUTE[/ALL][/OUTPUT] varname.attname
* V600 *acm* 5/06 MODE LINECOLORS User can change the number of line colors.
* V600 *acm* 6/06 additional declarations found by Solaris compiler
* V602 *jli* 7/06 added CANCEL AXIS/STRIDE
* V601 *acm*11/06 Fix bug 1470: on a CANCEL AXIS/MODULO or CANCEL AXIS/DEPTH, change
*                 values in the attribute structure for the axis.
* V602: *acm* 1/07 Changes for metafile-batch mode: When in gif mode or batch mode, 
*                  ignore CANCEL MODE META
* V602  2/07 *acm* Fix bug 1492, changing attributes of coordinate variables 
* v604 *acm* 7/07 increase length of
* V606  8/07 *acm* Send informational and error messages that are returned from 
*                  commands via SPLIT_LIST to std error rather than std out.
* V610  *acm* 3/08 Fixes for metafile batch mode
* V63   *acm* 9/09 Fix bug 1691: deallocate use of dynamic axis when it is found in a grid.
*                  If more than one grid uses the dyn axis, deallocate use of axis for each.
* V66   *kms* 5/10 add CANCEL REDIRECT for stdout/stderr redirection
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
*       *acm* 3/12 removing old calls to LASER_STATUS routine for movies
*       *acm* 4/12 Add new MODE FOURDEE to allow E,F,M,N,etc as user-vars
*       *acm* 4/12 Remove MODE FOURDEE, using _E, _F, _M, _N instead, throughout.
* V6.8 *acm* 7/9/2012 For batch graphics on RHEL6, change ITS_BATCH_GRAPHICS
*                     from logical to integer, then batch = ITS_BATCH_GRAPHICS().NE.0
* V683 *acm*  8/12 add new CANCEL LIST/OUTTYPE=  
* V685 *acm*  4/13 Changes for ensemble datasets, correctly handle flag for hiding 
*                  ensemble members 
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long
* V690 *sh* 1/14 add CAN VAR/LAYERZ
* V693+ 11/14 *sh* renaming 'sigma' as 'layerz' throughout
* V695 *acm*  9/15 Fix #2317: length of name sent to FIND_DSET_NUMBER
* V698 *sh*  1/16 aggregation logic moved inside of CANCEL_DATA_SET
* V698 *acm* 1/16 change remaining dset=-1 to the parameter dset=pdset_uvars
* V698  2/16 *acm* For ticket 2352: variables defined with LET/D are
*                  added to that dataset in the attribute structure.
* V698  4/16 *acm* For ticket 2399: Apply MODE CALENDAR settings to F axes too
* V7    acm  6/16 Ticket 2437: Deprecating mode_6d_lab. 
*		  Adjust output to 6-D or 4-D grids
* V720 *acm* 5/17 Implement specific calls in place of CD_GET_VAR_INFO


	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'tmap_errors.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
        include 'xdiag_ctrl.cmn_text'
        include 'xtm_grid.cmn_text'
        external xgt_grid_data
	include 'xalt_messages.cmn_text'
	include	'ferret.parm'
	include	'slash.parm'
	include 'errmsg.parm'
	include 'movies.parm'
	include 'plot_setup.parm'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xfr_grid.cmn'
	include 'xvideo.cmn'
	include 'xcommand.cmn'
	include	'xcontrol.cmn'
	include	'pltcom_dat.decl'	! with gksopn
	include	'PLTCOM.DAT'	! with gksopn
	include	'switch_inc.decl'	! with deflts
	include	'SWITCH.INC'	! with deflts
        include 'LUNITS.INC'          ! with lttout
        include 'lunits_inc.decl'

* calling argument declarations:

* local variable declarations:
	INTEGER		REGION_NUMBER, FIND_DSET_NUMBER,
     .                  TM_GET_LINENUM, TM_GET_GRIDNUM, 
     .			TM_GET_GRID_OF_LINE, TM_LENSTR1, STR_UPCASE,
     .                  STR_SAME, ITS_GIF_GRAPHICS, ITS_BATCH_GRAPHICS,
     .			ivp, i, blen, ier, i1, num_protected_axes,
     .			status, variable, category,
     .			idim, iqual, iset, item, ivar, nth, mr,
     .			mode, cx, axis, grid, mod_cx,
     .                  TM_LENSTR, len_test, len_mchars, varid,
     .                  dset, cat, var, mods_cx, iflag, loc, nvatts, 
     .                  slen, iatt, igrd, iline, new_att_modulo_len,
     .			cache_size, cache_nelems, cache_preemption
	LOGICAL		MATCH4, TM_DIGIT_TEST, IS_TEMPLATE, MATCH_TEMPLATE,
     .			report_error, slash_all, del_perm, del_temp,
     .                  perm_var, all_dims, coordvar, do_err, 
     .                  canout, new_att_modulo, its_gif, batch, 
     .                  redir_cancel_stdout, redir_cancel_stderr

	CHARACTER	arg*4, buff*512, argsym*120, varname*512,
     .                  attname*128, show_str*512, buff2*3, DUMMY*512

* local parameter declarations:
	INTEGER		slash_del_temp, slash_del_perm
	PARAMETER     ( slash_del_temp = 1+1,
     .			slash_del_perm = 2+1 )

* command given with /ALL ?
	slash_all = .FALSE.
	DO 10 iqual = 1, num_qualifiers
	IF ( qualifier_list( iqual ) .EQ. 1 ) slash_all = .TRUE.
 10	CONTINUE

* if the user entered a blank-separated list insteas of comma-separated
* then make it behave like a comma-separated list (4/96)
	CALL ARG_TO_ITEM

* select subcommand
	GOTO ( 100, 200, 300, 400, 500, 600, 700, 800, 900, 1000,
     .        1100,1200,1300,1400,1500,1600,1700, 1800 ) subcmnd_num

* CANCEL '    '
* arrival at this point usually means an illegal subcommand was given
* and was assumed to be an argument by the command parser
 100	IF ( num_args .GE. 1 ) THEN
	   CALL ERRMSG( ferr_invalid_subcmnd,status,
     .				cmnd_buff( arg_start(1):arg_end(1) ), *5000 )
	ELSE
	   GOTO 5010
	ENDIF
	RETURN

* CANCEL WINDOW
 200	CALL CANCEL_WINDOW( status )
	RETURN

* CANCEL REGION[/ALL/X/Y/Z/T/E/F/I/J/K/L/M/N] [region_name]
 300	IF ( slash_all .AND.
     .	     (num_args.GT.0 .OR. num_qualifiers.GT.1) ) GOTO 5310
	all_dims = num_qualifiers .EQ. 0
	IF ( slash_all ) THEN
* ... CANCEL REGION/ALL
	   DO 302 idim = 1, nferdims
 302	   CALL DEL_CX_DIM( idim, cx_last )
	   DO 304 cx = 0, min_context, -1
 304	   cx_name( cx ) = unspecified_name4
	ELSEIF ( num_args .EQ. 0 ) THEN
* ... CANCEL REGION[/I/J/K/L/M/N]
	   DO 310 idim = 1, nferdims
	      IF ( all_dims
     .	      .OR. qual_given(idim+1) .GT. 0		! /I/J/K/L/M or /N
     .	      .OR. qual_given(idim+nferdims+1) .GT. 0 ) THEN	! /X/Y/Z/T/E or /F
	         CALL DEL_CX_DIM( idim, cx_last )
	      ENDIF
 310	   CONTINUE
	ELSE
* ... CANCEL REGION[/I/J/K/L/M/N] name
	   DO 340 item = 1, num_items
	      arg = cmnd_buff( item_start(item):item_end(item) )
	      cx = REGION_NUMBER( arg )
	      IF ( cx .EQ. unspecified_int4 ) CALL ERRMSG
     .			( ferr_unknown_arg, status, arg, *5000 )
	      IF ( all_dims ) THEN
	         cx_name( cx ) = unspecified_name4
	      ELSE
	         DO 320 idim = 1, nferdims
	            IF ( qual_given(idim+1) .GT. 0		! /I/J/K/L/M or /N
     .	            .OR. qual_given(idim+nferdims+1) .GT. 0 ) THEN ! /X/Y/Z/T/E or /F
	               CALL DEL_CX_DIM( idim, cx )
	               cx_given( idim, cx ) = .FALSE.
	            ENDIF
 320	         CONTINUE
	      ENDIF	         
 340	   CONTINUE
	ENDIF
	RETURN

* CANCEL MEMORY /ALL /TEMP[default] or /PERM
 400	del_perm = slash_all .OR. qual_given( slash_del_perm ) .GT. 0
	del_temp = slash_all .OR. qual_given( slash_del_temp ) .GT. 0
     .			     .OR. .NOT.del_perm
	   DO 410 mr = 1,max_mr_avail
	      IF ( mr_protected( mr ) .EQ. mr_deleted ) GOTO 410
	      perm_var = mr_protected(mr) .EQ. mr_perm_protected
	      IF ( del_perm .AND. perm_var ) THEN
* ... permanent_mem could more efficiently be set after all deletions are
*     done, but this way we are performing a sanity check as well
	         permanent_mem = permanent_mem - mr_size(mr)
	         CALL DELETE_VARIABLE( mr )
	      ELSEIF ( del_temp .AND. .NOT.perm_var ) THEN  ! same as "ELSE"?
	         CALL DELETE_VARIABLE( mr )
	      ENDIF
 410       CONTINUE
* ... /ALL resets to peaks indicators
	IF (slash_all) THEN
           peak_mem = 0
           peak_essential_mem = 0
	ENDIF
	IF ( del_perm ) CALL SPLIT_LIST(pttmode_ops, err_lun, 
     .			' PERMANENT data cleared from memory', 0)
	IF ( del_temp ) CALL SPLIT_LIST(pttmode_ops, err_lun, 
     .			' TEMPORARY data cleared from memory', 0) 
	RETURN

* CANCEL EXPRESSION
 500	CALL DELETE_OLD_EXPR
	num_uvars_in_cmnd = cmnd_uvars_not_given
	RETURN

* CANCEL LIST
 600	IF ( slash_all .OR. qual_given( slash_canc_list_prec   ) .GT. 0 )
     .	   list_digits = default_output_precision
	IF ( slash_all .OR. qual_given( slash_canc_list_out ) .GT. 0 ) THEN
	   list_file       = 'AUTO'
	ENDIF
	IF ( slash_all .OR. qual_given( slash_canc_list_append ) .GT. 0 )
     .	   list_append = .FALSE.
	IF ( slash_all .OR. qual_given( slash_canc_list_form ) .GT. 0 ) THEN
	   list_format_given = .FALSE.
	   list_fmt_type     = plist_default
	ENDIF
	IF ( slash_all .OR. qual_given( slash_canc_list_outtyp ) .GT. 0 ) THEN
	   list_outtype = 'DFLT'
	   list_fmt_type     = plist_default
	ENDIF
	IF ( qual_given( slash_canc_list_heading ) .GT. 0 ) THEN
	   list_heading = .FALSE.
	ELSEIF ( slash_all ) THEN
	   list_heading = .TRUE.		! /ALL restores default state
	ENDIF

	IF (slash_all) CALL NETCDF4_CANCEL_SETTINGS
	RETURN

* CANCEL DATA_SET data_set_number1,number2,...
 700	report_error = qual_given(slash_canc_data_noerr) .LE. 0      ! 5/93
 	IF ( num_items .GT. 0 ) THEN
	   DO 710 item = 1, num_items
	      buff = cmnd_buff(item_start(item):item_end(item))
	      blen = item_end(item)-item_start(item)+1
* interpret and check the data set specified
	      IF ( TM_DIGIT_TEST(buff) ) THEN
	         argsym = buff(:blen)			! 10/95 for AIX

*  (1/03 *acm*) See xeq_set
#ifdef MANDATORY_FORMAT_WIDTHS
	         READ ( argsym,*,ERR=610 ) iset
#else
	         READ ( argsym,'(I)',ERR=610 ) iset
#endif

* ... check for valid number given
	         IF ( iset .LT. 1 .OR. iset .GT. maxdsets ) GOTO 5030
	         IF (  ds_name( iset ) .EQ. char_init1024) THEN
	            IF ( report_error ) THEN
	               GOTO 5030
	            ELSE
	               GOTO 710
	            ENDIF
	         ENDIF
	         GOTO 705

*     argument starts with a number but is not a number.
*     Check for a valid dataset name

 610	         iset = FIND_DSET_NUMBER( buff(:blen) )
	         IF (  iset .EQ. unspecified_int4 )then
	            IF ( report_error ) THEN
	               GOTO 5030
   	            ELSE
	               GOTO 710
	            ENDIF
	         ENDIF

	      ELSE
  	         iset = FIND_DSET_NUMBER( buff(:blen) )
	         IF (  iset .EQ. unspecified_int4 )then
	            IF ( report_error ) THEN
	               GOTO 5030
	            ELSE
	               GOTO 710
	            ENDIF
	         ENDIF
	      ENDIF

*  ... this may also cancel parent aggregations that use this dataset
*      and if an aggregation, hidden agg members 
 705	      CALL CANCEL_DATA_SET( iset, status )  

 710	   CONTINUE
* ... if only one set remains then point to it
	   iset = unspecified_int4
	   DO 715 i = 1, maxdsets
	     IF ( ds_name(i) .EQ. char_init1024) GOTO 715
	     IF ( iset .EQ. unspecified_int4 ) THEN
	         iset = i
	     ELSE
	         GOTO 790
	     ENDIF
 715	   CONTINUE
	   cx_data_set( cx_last ) = iset

	ELSEIF ( slash_all ) THEN
* all user variables are invalidated by closing the datasets
	   CALL PURGE_ALL_UVARS
! an earlier version of this code prioritized the canceling of aggregations
! before other datasets.  Might be learning the hard way why this was so ...
	   DO iset = 1, maxdsets
	      IF ( ds_name(iset) .EQ. char_init1024) CYCLE
	      CALL CANCEL_ONE_DATA_SET( iset, status )
	   ENDDO

	ELSE
	   GOTO 5010
	ENDIF
 790	RETURN

* CANCEL MODE mode_name
* loop through the list of mode names given
 800	IF ( num_items .EQ. 0 ) GOTO 5010
	DO 820 item = 1, num_items
* identify the specified mode to CANCEL
           len_test = TM_LENSTR(cmnd_buff( item_start(item):item_end(item) ))
	   DO 810 mode = 1, max_modes
              len_mchars = TM_LENSTR(mode_name( mode)(:4))
	      IF ( MATCH4( cmnd_buff( item_start(item):item_end(item) ),
     .			  len_test, mode_name( mode),len_mchars )) THEN
	         IF ( mode.EQ.pmode_GKS .AND. gksopn ) GOTO 5820
* ... ignore MODE VERIFY from a GO file if MODE VERIFY:ALWAYS is set
	         IF ( mode.EQ.pmode_verify
     .	        .AND. mode_arg(mode,1).EQ.3
     .	        .AND. csp .GT. 0 ) GOTO 820
* ... push the mode stack adding on a FALSE (because it's CANCEL)
	         DO 806 i = mode_stack_size, 2, -1
	            mode_state(mode,i) = mode_state(mode,i-1) 
		    mode_arg  (mode,i) = mode_arg  (mode,i-1)
		    IF (mode .EQ. pmode_time_lab) 
     .		      mode_state(pmode_f_lab,i-1) = mode_state(pmode_time_lab,i)
 806	         CONTINUE
		 mode_state( mode,1 ) = .FALSE.
* ... WAIT requires a string to communicate with PPLUS
	         IF ( mode .EQ. pmode_wait ) THEN
	            ppl_wait = 'NOWAIT'
	            deflts(5) = .FALSE.
* ... when REJECT is changed transformed and regridded variables may be wrong
	         ELSEIF ( mode .EQ. pmode_reject
     .		.AND. (mode_state(mode,1) .NEQV. mode_state(mode,2))) THEN
	            CALL DELETE_TRANSFORMED_VARS( status )
	            IF ( status .NE. ferr_ok ) RETURN
* ... mode metafile may require immediate communication with PPLUS
	         ELSEIF ( mode .EQ. pmode_metafile ) THEN
                 
*     When in gif mode or batch mode, ignore CANCEL MODE META
	            its_gif = ITS_GIF_GRAPHICS() .NE. 0
	            batch = ITS_BATCH_GRAPHICS() .NE. 0
                    IF ( its_gif ) THEN
                       mode_metafile = .FALSE.
                    ELSE IF ( batch ) THEN
                       mode_metafile = .FALSE.
 	               IF ( gksopn ) THEN
                          CALL SEND_PLTYPE( mode_metafile )
                          CALL PPLCMD ( from, line, 0, 'CLSPLT', 1, 1 )  ! 2/93
                       ENDIF
                    ELSE
 	               IF ( gksopn ) THEN
                          CALL SEND_PLTYPE( mode_metafile )
                          CALL PPLCMD ( from, line, 0, 'CLSPLT', 1, 1 )  ! 2/93
                       ENDIF
                    ENDIF

* ... mode REFRESH sends message to gnu READLINE routine to turn off refresh
	         ELSEIF ( mode .EQ. pmode_Xwindows ) THEN
	            CALL TM_SET_FREE_EVENT(0)
* ... mode diagnostic sends message to TMAP library
                 ELSEIF ( mode .EQ. pmode_diagnostic ) THEN
                    tmap_diag_on = .FALSE.
* ... mode journal - turn off journaling
                 ELSEIF ( mode .EQ. pmode_journal ) THEN
	            IF ( jrnl_lun .NE. unspecified_int4 )
     .                  CLOSE( UNIT=jrnl_lun, ERR = 5830 )
		    jrnl_lun = unspecified_int4
* ... mode ppllist - restore PPLUS listings to screen
                 ELSEIF ( mode .EQ. pmode_ppllist ) THEN
	            IF ( jrnl_lun .NE. 6 )
     .                  CLOSE( UNIT=lttout, ERR = 5830 )
		    lttout = 6
* ... mode graticule - turn off automatic graticules
                 ELSEIF ( mode .EQ. pmode_grat ) THEN
	            grat_on = .FALSE.
                    mode_grat_buff = ' '
* ... mode linecolors - resets number of line colors to 6
*                       the mode itself is always .TRUE.
                 ELSEIF ( mode .EQ. pmode_linecolors ) THEN
                    num_linecolors  = 6
		    mode_arg( mode,1 ) = num_linecolors
		    mode_state( mode,1 ) = .TRUE.

                    WRITE (show_str, 2000) mode_arg(pmode_linecolors, 1)
 2000               FORMAT (I3)
                    IF (no_plot_yet) THEN
                       CALL START_PPLUS
                       CALL PPLCMD (from, line, 0, 
     .                   'LINECOLORS '//show_str(1:3)//' 1', 1, 1)
                       CALL DISP_RESET
                    ELSE
                       CALL PPLCMD (from, line, 0, 
     .                   'LINECOLORS '//show_str(1:3)//' 0', 1, 1)
                       CALL WARN ('New number of line colors will take '//
     .                  'effect on next new window: SET WIN/NEW or '//
     .                  'SET WIN/CLEAR')
                    ENDIF

* ... mode shrink_ylab allows the y-axis label to automatically shrink
*     so it doesn't run off the page.
                 ELSEIF ( mode .EQ. pmode_shrink_ylab ) THEN
	            CALL PPLCMD ( from, line, 0, 'SHRINKY 0', 1, 1 )

* ... Changes to mode calendar apply to F-direction as well as T.
                 ELSEIF ( mode .EQ. pmode_time_lab ) THEN
	           ax_dec_pt(f_dim) = ax_dec_pt(t_dim) 
	           ax_fmt(f_dim) = ax_fmt(t_dim) 

* ... mode pplgui - close reply pipe
                 ELSEIF ( mode .EQ. pmode_gui ) THEN
	            alt_messages = .FALSE.
		    CONTINUE
!	            CALL GUI_PIPE_CLOSE( status )
!		    IF ( status .NE. ferr_ok ) GOTO 5000

                 ELSEIF ( mode .EQ. pmode_6d_lab ) THEN
	            CALL WARN( 'MODE 6D_lab is deprecated. '//
     .                'Leave the mode set; output '//
     .                'automatically adjusts to 4D or 6D grids') 

                 ELSEIF ( mode .EQ. pmode_desperate ) THEN
	            CALL WARN("MODE DESPERATE is deprecated. Use MODE FRUGAL")

	         ENDIF
		 GOTO 820
	      ENDIF
 810	   CONTINUE
* unidentifiable mode name
	   GOTO 5020
 820	CONTINUE
	RETURN

* CANCEL MOVIE
 900	frame_on = .FALSE.
	RETURN

* CANCEL VIEWPORT
 1000	IF ( num_items .EQ. 0 ) THEN
* return to default(full) viewport
           batch = ITS_BATCH_GRAPHICS() .NE. 0
           IF (batch) THEN
              IF ( gksopn ) THEN
                 CALL SEND_PLTYPE( mode_metafile )
                 CALL PPLCMD ( from, line, 0, 'CLSPLT', 1, 1 )  ! 2/93
              ENDIF
           ENDIF
	   CALL SET_VIEWPORT( mvp_dflt )	   
	ELSE
* cancel a viewport definition
	   DO 1050 item = 1, num_items
	      i1 = STR_UPCASE(buff,
     .			cmnd_buff(item_start(item):item_end(item)))
	      DO 1040 ivp = 1, max_viewport
	         IF ( vp_name(ivp).EQ.unspecified_name4 ) GOTO 1040
	         IF ( MATCH_TEMPLATE(vp_name(ivp),buff) ) THEN
	            IF (ivp.EQ.mvp_dflt) GOTO 5040
	            vp_name( ivp ) = unspecified_name4
	            IF ( vp_num .EQ. ivp ) vp_num = mvp_dflt
	         ENDIF
 1040	      CONTINUE
 1050	   CONTINUE
	ENDIF
	RETURN

* CANCEL VARIABLE
* ... data set specified?
* /D=xxx: has the user requested CANCEL VAR/D= ?
 1100	iqual = qual_given( slash_canc_var_data )
	IF ( iqual .GT. 0 ) THEN
	   CALL EQUAL_STRING( cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .			      buff, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   IF ( buff .EQ. ' ' ) THEN
	      iset = pdset_irrelevant	! "/D", alone for default-to-dset
	      buff = 'No current data set'	! ... for error reporting
	      IF ( iset .EQ. unspecified_int4) GOTO 5130
	   ELSE
	      iset = FIND_DSET_NUMBER( buff )
	      IF ( iset .EQ. unspecified_int4) GOTO 5130
	   ENDIF
	ELSE
	   iset = unspecified_int4
	ENDIF

* /LAYERZ
	IF (qual_given(slash_canc_var_layerz) .GT. 0) THEN 
	   IF (slash_all) CALL TM_NOTE('/ALL ignored when /LAYERZ is specified.',
     .				        err_lun)
	   IF (num_args .EQ. 0) GOTO 5010
	   DO item = 1, num_args
	      i1 = STR_UPCASE(buff,
     .			cmnd_buff(item_start(item):item_end(item)))
	      dset = unspecified_int4    ! to be determined during parse
	      CALL PARSE_NAM_DSET( buff, cx_last, dset,
     .			        category, variable, mod_cx, status )
	      IF ( status .NE. ferr_ok ) RETURN
	      IF ( variable .EQ. munknown_var_name ) GOTO 5110
* ... not sure ... how are LET/D vars found?
	      IF (category .EQ. cat_user_var) dset = pdset_uvars
	      CALL CD_GET_VAR_ID (dset, buff, varid, status)
              CALL CD_DELETE_ATTRIBUTE (dset, varid, patnam_layerz, status )
	      CALL PURGE_ALL_UVARS
	   ENDDO
	   RETURN
	ENDIF

* /NOERROR
	report_error = qual_given(slash_canc_var_noerr) .LE. 0

* /ALL
	IF ( slash_all
     .	.OR. (num_items.EQ.0 .AND. iset.NE.unspecified_int4) ) THEN
	   CALL PURGE_ALL_UVARS
	   DO 1110 ivar = 1, max_uvar
	   IF (iset.EQ.unspecified_int4 .OR. iset.EQ.uvar_dset(ivar))
     .				CALL DELETE_USER_VAR(ivar, iset)     ! 7/97
 1110	   CONTINUE
	   num_uvars_in_cmnd = cmnd_uvars_not_given  ! renders EX#n deleted 
	ELSE
	   IF (num_items .EQ. 0) GOTO 5010	   
	   DO 1120 item = 1, num_items
	      i1 = STR_UPCASE(buff,
     .			cmnd_buff(item_start(item):item_end(item)))
* ... decode specified variable name of form VNAME[D=iset] (9/95)
* ... Note: an "odd" behavior for the user will occur if the variable "A"
*	    is defined BOTH as a LET (global) and LET/D (global).  In this
*	    case CAN VAR A will delete only the LET definition.  CAN VAR A
*	    given twice will cancel both.  I regard this as acceptable -- the
*	    case described here is pretty pathological, anyway.
	      IF ( IS_TEMPLATE(buff) ) THEN
	         DO 1115 ivar = 1, max_uvar
	            IF ( uvar_name_code(ivar)(1:3) .NE. 'EX#'
     .	   .AND. (iset.EQ.unspecified_int4.OR.iset.EQ.uvar_dset(ivar)))
     .								THEN
		       IF (MATCH_TEMPLATE(uvar_name_code(ivar),buff)) THEN
* ... note: calling PURGE_ALL_UVARS for each individual deleted uvar is
*		inefficient ... but cautious. (minimum labor implementation)
	                  CALL PURGE_ALL_UVARS
			  CALL DELETE_USER_VAR(ivar, iset)         ! 7/97
	               ENDIF
	            ENDIF
1115	         CONTINUE
	      ELSE
* If /D was not given, look first in the global user-vars, then at LET/D vars
* in the default datset.
	         IF (iset .EQ. unspecified_int4) THEN  
		    iset = pdset_uvars
		    CALL PARSE_NAM_DSET( buff, cx_last, iset,
     .			     category, variable, mod_cx, status )
		    IF ( status.NE.ferr_ok .OR. variable.EQ.munknown_var_name) 
     .			     iset = unspecified_int4
		 ENDIF

	         CALL PARSE_NAM_DSET( buff, cx_last, iset,
     .			     category, variable, mod_cx, status )
	         IF ( status .NE. ferr_ok ) RETURN
		 IF (report_error) THEN
	            IF ( variable .EQ. munknown_var_name ) GOTO 5110
	            IF ( category .NE. cat_user_var ) GOTO 5120
		 ELSE
	            IF ( variable .EQ. munknown_var_name .OR. 
     .			 category .NE. cat_user_var ) GOTO 1120
		 ENDIF
	         CALL PURGE_ALL_UVARS
		 CALL DELETE_USER_VAR(variable, iset)         ! 7/97
	      ENDIF
 1120	   CONTINUE
	ENDIF
	RETURN

* CANCEL AXIS/MODULO
 1200	IF ( qual_given(slash_canc_axis_modulo) .GT. 0 ) THEN

           new_att_modulo = .FALSE.
           new_att_modulo_len = 0.

	   DO 1220 item = 1, num_items
              axis = TM_GET_LINENUM(
     .				cmnd_buff(item_start(item):item_end(item)) )
              IF ( axis .EQ. unspecified_int4 ) GOTO 6210
              IF ( line_modulo(axis) ) THEN
                 line_modulo( axis ) = .FALSE.
* ... wipe memory clear of stored variables - this could change all definitions
*      ( could be more selective for efficiency by checking to see where this
*      axis gets used )
                 DO 1210 i = 1,max_mr_avail
 1210            IF ( mr_protected( i ) .NE. mr_deleted ) 
     .                                CALL DELETE_VARIABLE( i )
              ENDIF
 1220	   CONTINUE

* CANCEL AXIS/ALL

        ELSE IF ( qual_given(slash_canc_axis_all) .GT. 0 ) THEN 	
	   CALL DEALLO_ALL_AXES

* CANCEL AXIS/DEPTH

        ELSE IF ( qual_given(slash_canc_axis_depth) .GT. 0 ) THEN 
        
	   DO 1222 item = 1, num_items
              axis = TM_GET_LINENUM(
     .				cmnd_buff(item_start(item):item_end(item)) )
              IF ( axis .EQ. unspecified_int4 ) GOTO 6210
              IF ( line_direction(axis) .EQ. 'UD' ) THEN
                 line_direction(axis) = 'DU'
              ENDIF

 1222	   CONTINUE

* CANCEL AXIS/STRIDE
        ELSE IF ( qual_given(slash_canc_axis_stride) .GT. 0 ) THEN
           
* ...   Elimate all cached memory
           CALL PURGE_ALL_MEMORY

* ...   Eliminate all memory-resident user-defined vars and their
*       uvar_grid 's 
           CALL PURGE_ALL_UVARS
* ...   
           DO 1223 item = 1, num_items 
              axis = TM_GET_LINENUM(
     .                          cmnd_buff(item_start(item):item_end(item)) )

* ...   Check it is legal to issue CANCEL AXIS/STRIDE
              IF ( axis .EQ. unspecified_int4 ) GOTO 6210
 
*       not legal if axis no longer exists
              IF( line_name(axis) .EQ. char_init16) GOTO 6310

*       not legal if this is not a strided axis
              IF( line_parent(axis) .EQ. 0) GOTO 6320

              igrd = 0
              iline= 0

* ...   Loop through all dynamic grids and find which uses this axis

 6001         CALL TM_NEXT_DYN_GRID( igrd, *6199)

                 DO 6002 idim = 1, nferdims
                    iline = grid_line(idim,igrd)

                    IF ( iline .EQ. axis ) THEN

* ...   Reinsert the native axis (the parent of this axis)
                       grid_line(idim,igrd) = line_parent(axis)

* ...   Deallocate this axis
                       line_keep_flag(axis) = .FALSE. 
                       CALL TM_DEALLO_DYN_LINE(axis)

                    ENDIF
 6002            CONTINUE


              GOTO 6001
 6199         CONTINUE 


 1223      CONTINUE 

        ELSE

* ... CANCEL AXIS
	   num_protected_axes = TM_GET_LINENUM( 'EZ' )  ! top protected axis
	   DO 1230 item = 1, num_items
              axis = TM_GET_LINENUM(
     .				cmnd_buff(item_start(item):item_end(item)) )
              IF ( axis .EQ. unspecified_int4 ) GOTO 6210
	      IF ( axis .LE. num_protected_axes ) GOTO 6212
	      line_keep_flag(axis) = .FALSE.  ! see tm_garb_col_grids.F
	      IF (line_use_cnt(axis) .LE. 0) THEN
	         IF ( axis .LE. max_lines ) THEN
                    IF (.NOT. line_regular(axis))
     .                  CALL PACK_LINE_STORAGE(axis)
		    line_name(axis) = char_init16
	         ELSE
	            CALL TM_DEALLO_DYN_LINE(axis)
	         ENDIF
	      ELSE
*     ... cannot delete - in use.  Locate the grid that is using it.
	         grid = TM_GET_GRID_OF_LINE( axis )
	         CALL WARN( 'Not deleted: '//line_name(axis))
	         IF ( grid .NE. unspecified_int4 ) THEN
	            CALL WARN( 
     .		      'Axis is in use by grid '//grid_name(grid))
	         ELSE
	            CALL ERRMSG(ferr_internal, status,
     .				'axis use count err', *5000)
	         ENDIF
	      ENDIF
 1230	   CONTINUE
        ENDIF

* ... Check the attribute structure for this axis name and change 
*     attribute values as needed.

        buff2 = ' '
        IF (line_name(axis) .NE. char_init16) THEN
           CALL RESET_AX_ATT (line_name(axis), buff2, 
     .           buff2, buff2, new_att_modulo,
     .           new_att_modulo_len, line_direction(axis), 
     .           line_regular(axis) )
        ENDIF

	RETURN

* CANCEL GRID
 1300   CONTINUE
	DO 1330 item = 1, num_items
           grid = TM_GET_GRIDNUM(
     .			cmnd_buff(item_start(item):item_end(item)) )
           IF (grid .EQ. unspecified_int4) GOTO 6215
* ... clear out any user variable dependencies and warn if used by a dataset
	   IF (grid_use_cnt(grid) .GE. 1 .OR. grid .LE. mgrid_fabstract) THEN
	      CALL PURGE_MR_GRID(grid, status)
	      IF ( status .NE. ferr_ok ) THEN
	          CALL WARN( 'Not deleted: '//grid_name(grid))
	          RETURN
	      ENDIF
* ... grids created by data sets without associated vars may get deleted by
*     PURGE_MR_GRID (e.g. handled as climatological_axes.cdf handles axes)
	      IF (grid_name(grid) .EQ. char_init16) RETURN
	   ENDIF
* ... remove the grid if possible
	   IF (grid_use_cnt(grid) .LE. 0) THEN
	      IF ( grid .LE. max_grids ) THEN
	         grid_name(grid) = char_init16
	         DO 1310 idim = 1, nferdims
 1310		 CALL TM_DEALLO_DYN_LINE( grid_line(idim,grid))
	      ELSE
	         CALL TM_DEALLO_DYN_GRID(grid)
	      ENDIF
	   ELSE
*     ... cannot delete - in use.
	      CALL WARN( 'Not deleted: '//grid_name(grid))
	   ENDIF
 1330	CONTINUE
	RETURN


* CANCEL ATTRIBUTE  /OUTPUT[=all]
 1400	 IF ( num_args .LT. 1 ) GOTO 5010

!
* ... get dset number if present:  CANCEL ATT/D=dset ...
	iqual = qual_given( slash_canc_attr_data ) 
        IF ( iqual .GT. 0 ) THEN
	   CALL EQUAL_STRING( cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .			      show_str, status )  ! show_str is just a buffer
	   IF ( status .NE. ferr_ok ) RETURN
	   IF ( show_str .NE. ' ' ) THEN
	      dset = FIND_DSET_NUMBER( show_str )
	      IF ( dset .EQ. unspecified_int4) THEN
	         CALL WARN('Unknown data set: '
     .		 //show_str(:TM_LENSTR1(show_str)))
	         RETURN
	      ENDIF
	   ENDIF

        ELSE  ! get dataset from context or from [d=]
           buff = cmnd_buff(item_start(1):item_end(1))

           CALL GET_NEW_CX( cx_last, cx_cmnd, .TRUE., status )
           IF ( status .NE. ferr_ok ) GOTO 5000
 
           IF (buff(1:1) .EQ. '(') THEN
              dset = cx_data_set(cx_cmnd)   ! initial value to try; will return dset
              CALL ISIT_COORD_VAR ( buff, dset, 
     .              varname, coordvar, status )
              IF ( status .NE. ferr_ok ) THEN 
                 dset = -2  ! a user-defined axis (coordinate variable)
                 CALL ISIT_COORD_VAR ( buff, dset, 
     .              varname, coordvar, status )
                 IF ( status .NE. ferr_ok ) THEN
                    dset = cx_data_set(cx_cmnd)
                    GOTO 5920
                 ENDIF
              ENDIF

           ELSE

* Get the dataset if given as [d=]

	      IF ( INDEX(buff,'[') .GT. 0 ) THEN
                 dset = pdset_irrelevant	! default (not used ...)
                 CALL PARSE_NAM_DSET(buff, cx_last, dset, cat, var,
     .                 mods_cx, status)
              ELSE
                 cx = is_cx( 1 )
                 IF (cx .EQ. 0 .OR. cx .EQ. unspecified_int4)
     .                cx = cx_cmnd
                dset = cx_data_set(cx)
             ENDIF
	   ENDIF
        ENDIF

!---------

* /OUTPUT

* ... CANCEL ATT/OUTPUT varname.attname

        loc = qual_given( slash_canc_attr_output ) 
        canout = ( loc .GT. 0 )

       IF ( canout ) 
     .   CALL EQUAL_STRING( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			    buff2, status )

* Get varname.attname and see if a dataset is specified

        buff = cmnd_buff(item_start(1):item_end(1))

!! get dataset from varname.attname
* ... evaluate the context without computing the expression to get the dataset

	CALL GET_NEW_CX( cx_last, cx_cmnd, .TRUE., status )
        IF ( status .NE. ferr_ok ) GOTO 5000
 
        IF (buff(1:1) .EQ. '(') THEN
           dset = cx_data_set(cx_cmnd)   ! initial value to try; will return dset
           CALL ISIT_COORD_VAR ( buff, dset, 
     .            varname, coordvar, status )
           IF ( status .NE. ferr_ok ) THEN 
              dset = -2  ! a user-defined axis (coordinate variable)
              CALL ISIT_COORD_VAR ( buff, dset, 
     .              varname, coordvar, status )
              IF ( status .NE. ferr_ok ) THEN
                 dset = cx_data_set(cx_cmnd)
                 GOTO 5920
              ENDIF
           ENDIF
        ENDIF
c
c        ELSE
c
c* Get the dataset if given as [d=]
c
c	   IF ( INDEX(buff,'[') .GT. 0 ) THEN
c               dset = pdset_irrelevant	! default (not used ...)
c               CALL PARSE_NAM_DSET(buff, cx_last, dset,
c     .				     cat, var, mods_cx, status)
c           ELSE
c              cx = is_cx( 1 )
c              IF (cx .EQ. 0 .OR. cx .EQ. unspecified_int4)
c     .             cx = cx_cmnd
c             dset = cx_data_set(cx)
c          ENDIF
c	ENDIF

        IF (dset .EQ. pdset_irrelevant .OR. dset .EQ. unspecified_int4)
     .        dset = cx_data_set(cx_cmnd) 
        IF (dset .EQ. unspecified_int4) dset = pdset_uvars

* Check that the variable exists in the dataset

        IF (INDEX(buff, '.') .EQ. 0) THEN
           varname = buff
           CALL CD_GET_VAR_ID (dset, varname, varid, status)
        ELSE
           CALL BREAK_VARNAME( buff, dset, varname, attname, 
     .                         varid,  status )
        ENDIF
        IF (status .NE. ferr_ok) GOTO 6220

* If cancel/output varname.attname, set the attribute output flag to 0

        IF (canout) THEN
           iflag = 0

* Is the command CAN ATT/OUTPUT=all varname?
           slen = TM_LENSTR(buff2)
           IF (slen .GT. 0  .AND.  buff2(1:3) .EQ. 'ALL') THEN

* It must be just a varname, not varname.attname.
              CALL BREAK_VARATTNAME (buff, dset, varname, 
     .           attname, i, .FALSE., status)
              IF (attname .NE. '') GOTO 6240

              CALL CD_GET_VAR_NATTS (dset, varid, varname, nvatts, status)

* Set all attribute output flags to 0

              DO 1410 iatt = 1, nvatts
                 CALL CD_GET_VAR_ATT_NAME (dset, varid, iatt, attname, 
     .                                     status)
                 CALL CD_SET_ATT_FLAG(dset, varid, attname, iflag, status)
 1410         CONTINUE

           ELSE
* Not /OUT=ALL. For single attribute, see if it exists and if so change the 
* flag. The user may be wanting to turn off writing of an attribute that 
* Ferret creates, like the AXIS attribute, or bounds...
           
              CALL BREAK_VARATTNAME (buff, dset, varname, 
     .           attname, i, .FALSE., status)

              IF (attname .EQ. '') GOTO 6230

              IF (status .NE. ferr_ok) THEN
                 CALL CD_PUT_NEW_ATTR (dset, varid, attname, 5, 1, iflag,
     .              buff, 1., status)
              ELSE

* Reset an existing attribute output flag to 0
                 CALL CD_SET_ATT_FLAG(dset, varid, attname, iflag, status)
              ENDIF
           ENDIF

* canout is false. The command was CANCEL ATT varname.attname. Delete the attribute
        ELSE

* See if the attribute  exists for the variable
           do_err = .TRUE.
           dummy = varname  ! Save name for changing axis modulo or depth setting

           CALL BREAK_VARATTNAME ( buff, dset, varname, 
     .                 attname, varid, do_err, status )

           IF (attname .EQ. '') GOTO 6230

           IF (status .NE. ferr_ok) GOTO 6220 
           CALL CD_DELETE_ATTRIBUTE (dset, varid, attname, status )

* If this is an axis and we are changing modulo or depth setting, make the 
* setting in the Ferret definition of the axis.

           IF (coordvar) THEN
              IF ( STR_SAME(attname, 'modulo') .EQ. 0) THEN
                 new_att_modulo = .FALSE.
                 new_att_modulo_len = 0.

                 axis = TM_GET_LINENUM(dummy )
                 IF ( axis .EQ. unspecified_int4 ) GOTO 6210
                 IF ( line_modulo(axis) ) THEN
                    line_modulo( axis ) = .FALSE.
* ... wipe memory clear of stored variables - this could change all definitions
*      ( could be more selective for efficiency by checking to see where this
*      axis gets used )
                    DO 1420 i = 1,max_mr_avail
 1420               IF ( mr_protected( i ) .NE. mr_deleted ) 
     .                                CALL DELETE_VARIABLE( i )
                 ENDIF

              ENDIF
              IF ( STR_SAME(attname, 'depth') .EQ. 0) THEN

	         axis = TM_GET_LINENUM(dummy )
                 IF ( axis .EQ. unspecified_int4 ) GOTO 6210
                 IF ( line_direction(axis) .EQ. 'UD' ) THEN
                    line_direction(axis) = 'DU'
                 ENDIF
              ENDIF
           ENDIF   ! coordvar

        ENDIF

	RETURN
        
* CANCEL REDIRECT
 1500   redir_cancel_stdout = .FALSE.
        redir_cancel_stderr = .FALSE.
        IF ( num_args .GT. 0 ) THEN
*          Get all the redirect sources to cancel
           DO 1510 i = 1,num_args
              IF ( MATCH4( cmnd_buff(arg_start(i):arg_end(i) ), 
     .              arg_end(i) - arg_start(i) + 1, 'STDOUT', 6) ) THEN
                 redir_cancel_stdout = .TRUE.
              ELSE IF ( MATCH4( cmnd_buff(arg_start(i):arg_end(i) ), 
     .              arg_end(i) - arg_start(i) + 1, 'STDERR', 6) ) THEN
                 redir_cancel_stderr = .TRUE.
              ELSE
*                Unknown redirect source
                 CALL WARN('Ignored cancel redirect of unknown source: '
     .                   // cmnd_buff(arg_start(i):arg_end(i)) )
              ENDIF
 1510      CONTINUE
           IF ( redir_cancel_stdout .AND. 
     .          (redirect_stdout_flags .EQ. redirect_none) ) THEN
              CALL WARN('stdout is not redirected')
              redir_cancel_stdout = .FALSE.
           ENDIF
           IF ( redir_cancel_stderr .AND. 
     .          (redirect_stderr_flags .EQ. redirect_none) ) THEN
              CALL WARN('stderr is not redirected')
              redir_cancel_stderr = .FALSE.
           ENDIF
        ELSE
*          Default: cancel all active redirects
           IF ( redirect_stdout_flags .NE. redirect_none ) THEN
              redir_cancel_stdout = .TRUE.
           ENDIF
           IF ( redirect_stderr_flags .NE. redirect_none ) THEN
              redir_cancel_stderr = .TRUE.
           ENDIF
           IF ( (.NOT. redir_cancel_stdout) .AND. 
     .          (.NOT. redir_cancel_stderr) ) THEN
              CALL WARN('No active redirects to cancel')
           ENDIF
        ENDIF
*
        IF ( redir_cancel_stdout ) THEN
           IF ( (redirect_stdout_flags .EQ. redirect_file) .OR.
     .          (redirect_stdout_flags .EQ. redirect_file_tee) ) THEN
*             Check if stdout and stderr are sent to the same LUN
              IF ( (redirect_stderr_lun .NE. redirect_stdout_lun) .OR.
     .             ((redirect_stderr_flags .NE. redirect_file) .AND.
     .           (redirect_stderr_flags .NE. redirect_file_tee)) ) THEN
                 CLOSE(UNIT=redirect_stdout_lun)
              ENDIF
              redirect_stdout_lun = -1
           ENDIF
           redirect_stdout_flags = redirect_none
        ENDIF
*
        IF ( redir_cancel_stderr ) THEN
           IF ( (redirect_stderr_flags .EQ. redirect_file) .OR.
     .          (redirect_stderr_flags .EQ. redirect_file_tee) ) THEN
*             Check if stdout and stderr are sent to the same LUN
              IF ( (redirect_stdout_lun .NE. redirect_stderr_lun) .OR.
     .             ((redirect_stdout_flags .NE. redirect_file) .AND.
     .           (redirect_stdout_flags .NE. redirect_file_tee)) ) THEN
                 CLOSE(UNIT=redirect_stderr_lun)
              ENDIF
              redirect_stderr_lun = -1
           ENDIF
           redirect_stderr_flags = redirect_none
        ENDIF
*
        RETURN

* CANCEL ALIAS
 1600	IF ( slash_all ) THEN
           DO 1610 i = num_predefined_alias+1, total_num_alias
 1610      alias_name(i) = unspecified_name4
        ELSE
	   IF ( num_items .EQ. 0 ) GOTO 5010
	   DO 1630 item = 1, num_items
	      i1 = STR_UPCASE(buff,
     .			cmnd_buff(item_start(item):item_end(item)))
              DO 1620 i = 1, total_num_alias
                 IF ( alias(i) .EQ. unspecified_name4 ) GOTO 1620
                 IF ( MATCH_TEMPLATE(alias_name(i), buff) ) THEN
                    alias_name(i) = unspecified_name4
                 ENDIF
 1620         CONTINUE
 1630      CONTINUE
        ENDIF
	RETURN

* CANCEL SYMBOL
 1700	IF ( slash_all ) THEN
* cancel all symbols
* (this lovely piece of code is borrowed from the PLOT+ routine getcmd.F)
	   i=0
 1705      CALL LSTSYM(argsym,buff,blen,i,ier)	! get next symbol name (argsym)
           IF(ier.EQ.0)THEN
	      CALL DELSYM(argsym,ier)
	      GOTO 1705
	   ENDIF
	   RETURN
	ENDIF
* cancel the template-specified symbol(s)
	IF ( num_items .EQ. 0 ) GOTO 5010
* (this lovely piece of code is borrowed from the PLOT+ routine getcmd.F)
	i=0
 1710   CALL LSTSYM(argsym,buff,blen,i,ier)	! get next symbol name (argsym)
        IF(ier.EQ.0)THEN
* ... check the given templates 
	   DO 1720 i1 = 1, num_items
	      nth = STR_UPCASE(buff,
     .			cmnd_buff(item_start(i1):item_end(i1)))
	      IF ( MATCH_TEMPLATE(argsym,buff) ) CALL DELSYM(argsym,ier)
 1720	   CONTINUE
           GOTO 1710
	ENDIF
	RETURN


* CANCEL NCCACHE. Set all arguments of -1 to restore the default settings.

 1800	cache_size = -1
	cache_nelems = -1
	cache_preemption = -1
	CALL CD_SET_CHUNK_CACHE (cache_size, cache_nelems, 
     .     cache_preemption, status)
	CALL SPLIT_LIST(pttmode_ops, err_lun,
     .   ' Restoring default chunk cache settings', 0)

	RETURN


* error exits
 5000	RETURN
 5010	CALL ERRMSG( ferr_invalid_command, status,
     .			'CANCEL what?', *5000 )
 5020	CALL ERRMSG( ferr_invalid_command, status,
     .			'unknown mode:'//
     .			cmnd_buff( item_start(item):item_end(item) ), *5000 )
 5030	CALL ERRMSG( ferr_unknown_data_set, status, buff(:blen), *5000 )
 5040	CALL ERRMSG( ferr_invalid_command, status,
     .			'cannot cancel viewport:'//
     .			cmnd_buff( item_start(item):item_end(item) ), *5000 )
 5090	CALL ERRMSG( ferr_ODR_error, status, buff, *5000 )
 5110	CALL ERRMSG( ferr_unknown_variable, status, buff(:8), *5000 )
 5120	CALL ERRMSG( ferr_invalid_command, status,
     .		'can only CANCEL variables you DEFINE '//buff, *5000 )
 5130	CALL ERRMSG( ferr_unknown_data_set, status,
     .			buff(:TM_LENSTR1(buff)), *5000 )
 5310	CALL ERRMSG( ferr_invalid_command, status,
     .		'/ALL with named region or axis qualifier', *5000 )
 5400	CALL ERRMSG( ferr_invalid_command, status,
     .		'Unknown alias: '//
     .           cmnd_buff(item_start(item):item_end(item)), *5000 )
 5820	CALL ERRMSG( ferr_invalid_command, status,
     .		     'MODE GKS cannot be modified after the first GKS plot',
     .			*5000 )
 5830	CALL ERRMSG( ferr_erreq, status, 'Cannot close file', *5000 )
 5920   slen = TM_LENSTR(buff)
        CALL ERRMSG( ferr_invalid_command, status,
     .   'variable, axis, or attribute does not exist: '//
     .    buff(:slen), *5000 )
 6210	CALL ERRMSG( ferr_invalid_command, status, 'unknown axis: '//
     .		     cmnd_buff(item_start(item):item_end(item)), *5000 )
 6212	CALL ERRMSG( ferr_invalid_command, status, 'protected axis: '//
     .		     cmnd_buff(item_start(item):item_end(item)), *5000 )
 6215	CALL ERRMSG( ferr_unknown_grid, status,
     .		     cmnd_buff(item_start(item):item_end(item)), *5000 )
 6220 CALL ERRMSG( ferr_unknown_variable, status, 
     .               'unknown variable or attribute: '//
     .		     cmnd_buff(item_start(1):item_end(1)), *5000 )
 6230	CALL ERRMSG( ferr_invalid_command, status,
     .	    'CANCEL ATTRIBUTE given with no attribute: '//
     .	    'Use CAN ATT/OUT=ALL varname, or CAN ATT[/OUT] varname.attname '
     .			, *5000 )
 6240	CALL ERRMSG( ferr_invalid_command, status,
     .	    'CANCEL ATTRIBUTE/ALL varname.attname: '//
     .	    'cannot specify attribute name '
     .			, *5000 )
 6310   CALL ERRMSG( ferr_invalid_command, status, 'axis no longer exists: '//
     .               cmnd_buff(item_start(item):item_end(item)), *5000 )

 6320   CALL ERRMSG( ferr_invalid_command, status, 'not a strided axis: '//
     .               cmnd_buff(item_start(item):item_end(item)), *5000 )
 
	END

	SUBROUTINE KNUDSEN( temp, mtemp, salt, msalt, dens, mdens )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* lifted from COX routine KNUDSEN to compute the density of sea water via
* the Knudsen formula 

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 12/15/87
* V200:  7/27/89 - 4D symmetrical version
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN

#ifdef unix
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl.parm'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xonedim.cmn'
#else
	INCLUDE 'FERRET_CMN:FERRET.PARM'
	INCLUDE 'FERRET_CMN:GFDL.PARM'
	INCLUDE	'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE	'FERRET_CMN:XMEM_SUBSC.CMN'
	INCLUDE 'FERRET_CMN:XONEDIM.CMN'
#endif

* calling argument declarations:
	INTEGER	   mtemp, msalt, mdens
	REAL    temp( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit ),
     .		salt( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,m2lot:m2hit ),
     .		dens( m3lox:m3hix,m3loy:m3hiy,m3loz:m3hiz,m3lot:m3hit )

* internal variable declarations:
	REAL T3,S2,T2,S3,F1,F2,F3,FS,SIGMA,A,B1,B2,B,CO,ALPHA,ALPSTD
	REAL S,T,DN,D
	REAL POTEM
	INTEGER	i_lo, i_hi, j_lo, j_hi, i, j, k, l
	REAL	bad_temp, bad_salt, bad_dens

* --- end of introductory code ---

* limits for calculation
	i_lo = mr_lo_s1(mdens)
	i_hi = mr_hi_s1(mdens)
	j_lo = mr_lo_s2(mdens)
	j_hi = mr_hi_s2(mdens)

* flag for bad/missing data
	bad_temp = mr_bad_data( mtemp )
	bad_salt = mr_bad_data( msalt )
	bad_dens = mr_bad_data( mdens )

	DO 2000 l = mr_lo_s4(mdens), mr_hi_s4(mdens)
	DO 2000 k = mr_lo_s3(mdens), mr_hi_s3(mdens)

* depth in meters
	D = zdzz(k) / 100.

* main loop - compute one horizontal grid
	DO 100 j = j_lo, j_hi
	DO 100 i = i_lo, i_hi

	   IF ( temp(i,j,k,l).EQ.bad_temp .OR. salt(i,j,k,l).EQ.bad_salt ) THEN
	      dens(i,j,k,l) = bad_dens
	      GOTO 100
	   ENDIF

* true salinity(ppt) and potential temperature
	   s = (salt(i,j,k,l)*1000.D0) + 35.
	   t = POTEM( temp(i,j,k,l), s, d )

* stolen KNUDSEN code
      T2 = T*T
      T3= T2* T
      S2 = S*S
      S3 = S2 * S
      F1 = -(T-3.98)**2 * (T+283.)/(503.57*(T+67.26))
      F2 = T3*1.0843E-6 - T2*9.8185E-5 + T*4.786E-3
      F3 = T3*1.667E-8 - T2*8.164E-7 + T*1.803E-5
      FS= S3*6.76786136D-6 - S2*4.8249614D-4 + S*8.14876577D-1
      SIGMA= F1 + (FS+3.895414D-2)*(1.-F2+F3*(FS-.22584586D0))
      A= D*1.0E-4*(105.5+ T*9.50 - T2*0.158 - D*T*1.5E-4)  -
     1(227. + T*28.33 - T2*0.551 + T3* 0.004)
      B1 = (FS-28.1324)/10.0
      B2 = B1 * B1
      B= -B1* (147.3-T*2.72 + T2*0.04 - D*1.0E-4*(32.4- 0.87*T+.02*T2))
      B= B+ B2*(4.5-0.1*T - D*1.0E-4*(1.8-0.06*T))
      CO = 4886./(1. + 1.83E-5*D)
      ALPHA=     D*1.0E-6* (CO+A+B)
      DN=(SIGMA+ALPHA)/(1.-1.E-3*ALPHA)

	dens(i,j,k,l) = DN
 100	CONTINUE
 2000	CONTINUE

      RETURN
      END
********************************************************************
      REAL FUNCTION POTEM(T,S,P)
C     POTENTIAL TEMPERATURE FUNCTION
C     BASED ON FOFONOFF AND FROESE (1958) AS SHOWN IN "THE SEA" VOL. 1,
C     PAGE 17, TABLE IV
C     INPUT IS TEMPERATURE, SALINITY, PRESSURE (OR DEPTH)
C     UNITS ARE DEG.C., PPT, DBARS (OR METERS)
	REAL t, s, p
	REAL s2, p2, t2, t3, b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11
      B1=-1.60E-5*P
      B2=1.014E-5*P*T
      T2=T*T
      T3=T2*T
      B3=-1.27E-7*P*T2
      B4=2.7E-9*P*T3
      B5=1.322E-6*P*S
      B6=-2.62E-8*P*S*T
      S2=S*S
      P2=P*P
      B7=4.1E-9*P*S2
      B8=9.14E-9*P2
      B9=-2.77E-10*P2*T
      B10=9.5E-13*P2*T2
      B11=-1.557E-13*P2*P
      POTEM=B1+B2+B3+B4+B5+B6+B7+B8+B9+B10+B11
      POTEM=T-POTEM
      RETURN
      END

      SUBROUTINE ZOOM(X1,Y1,X2,Y2)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)zoom.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     CALL ZOOM(X1,Y1,X2,Y2)
C
C     THIS SUBROUTINE SELECTS THE BOUNDARIES OF THE AREA TO BE
C     DISPLAYED ON THE SCREEN OF THE TEKTERMINAL OR THE HP PLOT-
C     TER.  THIS AREA MUST BE SMALLER THAN, AND COMPLETELY CON-
C     TAINED WITHIN, THE OVERALL PLOTTING AREA DEFINED BY SUB-
C     ROUTINE SIZE.  SINCE THE AREA SELECTED FOR DISPLAY IS
C     SCALED TO FILL THE ENTIRE SCREEN, GREATER DETAIL IS VIS-
C     IBLE THAN WHEN THE ENTIRE PLOTTING AREA IS DISPLAYED.
C
C     THE VARIOUS PARAMETERS AND THEIR DEFINITIONS ARE LISTED
C     BELOW:
C        X1     - X-COORDINATE OF THE FIRST CORNER OF THE SCREEN
C                 IN USER'S UNITS.
C        Y1     - Y-COORDINATE OF THE FIRST CORNER OF THE SCREEN
C                 IN USER'S UNITS.
C        X2     - X-COORDINATE OF THE OPPOSITE CORNER OF THE
C                 SCREEN IN USER'S UNITS.
C        Y2     - Y-COORDINATE OF THE OPPOSITE CORNER OF THE
C                 SCREEN IN USER'S UNITS.
C
C
#ifdef unix
	include 'PLTCOM.DAT'
#else
	include 'pplinc:PLTCOM.DAT'
#endif
C
C     SCALE AND TRANSFORM THE COORDINATES OF THE FIRST CORNER OF
C     THE SCREEN.
C
      CALL TFORM(X1 * XSCALE,Y1 * YSCALE,ZTEMP)
      AMN = ANEW
      BMN = BNEW
C
C     SCALE AND TRANSFORM THE COORDINATES OF THE OPPOSITE CORNER
C     OF THE SCREEN.
C
      CALL TFORM(X2 * XSCALE,Y2 * YSCALE,ZTEMP)
      AMX = ANEW
      BMX = BNEW
C
C     FIND THE MINIMUM AND MAXIMUM VALUE OF EACH TRANSFORMED
C     COORDINATE.
C
      IF(AMN .GT. AMX)THEN
        TEMP = AMN
        AMN = AMX
        AMX = TEMP
      ENDIF
      IF(BMN .GT. BMX)THEN
        TEMP = BMN
        BMN = BMX
        BMX = TEMP
      ENDIF
C
C     RESTORE THE DEFAULT MINIMUM AND MAXIMUM ALLOWABLE VALUES
C     OF A AND B.
C
      AMIN = 0.0
      BMIN = 0.0
      AMAX = ASIZE
      BMAX = BSIZE
C
C     IF THE COORDINATES ARE IN THE PLOTTING AREA, SET THEM AS
C     THE MINIMUM AND MAXIMUM ALLOWABLE VALUES OF A AND B.
C
      IF(AMN .NE. AMX .AND. BMN .NE. BMX)THEN
        IF(AMN .GT. AMIN)AMIN = AMN
        IF(BMN .GT. BMIN)BMIN = BMN
        IF(AMX .LT. AMAX)AMAX = AMX
        IF(BMX .LT. BMAX)BMAX = BMX
      ENDIF
      ADIF = AMAX - AMIN
      BDIF = BMAX - BMIN
C
C     RECOMPUTE THE TEKTERMINAL CONVERSION FACTORS.
C
      IF(ADIF / TWIDTH .GT. BDIF / THIGHT)THEN
        PLTOTA = TSCLA / ADIF
        PLTOTB = TSCLB / ADIF * TWIDTH / THIGHT
      ELSE
        PLTOTA = TSCLA / BDIF * THIGHT / TWIDTH
        PLTOTB = TSCLB / BDIF
      ENDIF
C
C     RECOMPUTE THE HP PLOTTER CONVERSION FACTORS.
C
      PLTOHA = HPSCLA / ADIF
      PLTOHB = HPSCLB / BDIF
C
C     CALCULATE THE OFF-SCREEN FLAG.
C
      LOSFLG = 0
      IF(AOLD - 0.001 .GT. AMAX)LOSFLG = 1
      IF(AOLD + 0.001 .LT. AMIN)LOSFLG = 2
      IF(BOLD - 0.001 .GT. BMAX)LOSFLG = LOSFLG + 4
      IF(BOLD + 0.001 .LT. BMIN)LOSFLG = LOSFLG + 8
      RETURN
C
      END

      SUBROUTINE LSTBBO(IUNIT,HEADR)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)lstb5.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
CC  DEFINITION OF INDEXES USED FOR BIBO FORMAT:
C
#ifdef unix
	INCLUDE 'BIBO.COM'
#else
        INCLUDE 'pplinc:BIBO.COM'
#endif
C
      COMMON /TBLE/PTAB(8,4),DTTAB(8,29),FTTAB(8,9),WTTAB(8,11)
      COMMON /TBLE/STTAB(8,19),PCTAB(8,5),UNIT(4,15)
      COMMON /NTBLE/NPTAB,NDTTAB,NFTTAB,NWTTAB
      COMMON /NTBLE/NSTTAB,NPCTAB,NUNIT

	REAL LINE1,LINE2,BLNK
        DIMENSION HEADR(145),LINE1(11),LINE2(15)
#ifdef unix
	CHARACTER FDTE*24
* 1/03 *kob* need to equiv blnk to iblnk for g77 as well
#if defined FORTRAN_90 || defined G77
	integer iblnk
	equivalence (blnk,iblnk)
	data iblnk/Z'20202020'/
#else
	data blnk/'    '/
#endif
	CALL FDATE(FDTE)
#else
	character dte*10,tme*10
	data blnk/'    '/
	call date(dte)
	call time(tme)
#endif

      CALL FILL(PTAB,NPTAB,HEADR(PROJ),LINE1,IER)
#ifdef unix
      WRITE(IUNIT,1000)(LINE1(I),I=1,6),FDTE
 1000 FORMAT(/1X,'PROJECT: ',6A4,T57,A24)
#else
      WRITE(IUNIT,1000)(LINE1(I),I=1,6),dte,tme
 1000 FORMAT(/1X,'PROJECT: ',6A4,T57,a10,3x,a10)
#endif
C        FIND THE END OF THE COMMENT FIELD:
      DO 200 I=1,5
      J1=(5-I)*20+HEAD
      J2=J1+19
      DO 100 J=J1,J2
      IF((HEADR(J).NE.BLNK).AND.(HEADR(J).NE.0.))GO TO 300
  100 CONTINUE
  200 CONTINUE
      GO TO 320

  300 WRITE(IUNIT,2000)(HEADR(K),K=HEAD,J2)
 2000 FORMAT(10(/1X,20A4))

  320 WRITE(IUNIT,3000)
 3000 FORMAT(1X,'GEOGRAPHIC INFORMATION:',T35,
     1   'DESCRIPTIVE INFORMATION:'/)

      JLEFT=1
      JRITE=1

  400 CALL COL1(HEADR,JLEFT,LINE1)
      CALL COL2(HEADR,JRITE,LINE2)
      WRITE(IUNIT,5000)(LINE1(I),I=1,9),(LINE2(I),I=1,12)
 5000 FORMAT(1X,8A4,A1,11A4,A3)
      JLEFT=JLEFT+1
      JRITE=JRITE+1
      IF(JRITE.LE.16)GO TO 400

      WRITE(IUNIT,6000)
 6000 FORMAT(1X)
      RETURN
      END
C*F45V1P0*

      SUBROUTINE COL1(HEADR,JLEFT,LINE1)

      DIMENSION HEADR(145),LINE1(11)

      CHARACTER TE*50,NS(2)*1,EW(2)*1
	REAL LINE1,BLNK
C
CC  DEFINITION OF INDEXES USED FOR BIBO FORMAT:
C
#ifdef unix
	INCLUDE 'BIBO.COM'
#else
        INCLUDE 'pplinc:BIBO.COM'
#endif

* 1/03 *kob* need to equiv blnk to iblnk for g77 as well
#if defined FORTRAN_90 || defined G77
	integer iblnk
	equivalence (blnk,iblnk)
	data iblnk/Z'20202020'/
#else
	data blnk/'    '/
#endif

      DATA NS/'N','S'/,EW/'E','W'/
      IF(JLEFT.LE.7)GO TO 100
      DO 50 I=1,11
   50 LINE1(I)=BLNK
      RETURN

  100 GO TO (1,2,3,4,5,6,7),JLEFT

1     WRITE(TE,1000)HEADR(MOOR),HEADR(MOOR+1)
 1000 FORMAT('STATION ID:',T13,2A4)
      GOTO 200

2     WRITE(TE,2000)HEADR(INST),HEADR(INST+1)
 2000 FORMAT('INSTRUMENT:',T13,2A4)
      GOTO 200

    3 ILAT=HEADR(SLAT)/100.0
	IF(HEADR(SLAT).GE.0.)THEN
	INS=1
	ELSE
	INS=2
	ENDIF
      RLAT=ABS(HEADR(SLAT)-ILAT*100.0)
      WRITE(TE,3000)IABS(ILAT),RLAT,NS(INS)
 3000 FORMAT('LATITUDE:',2X,I4,1X,F4.1,1X,A1)
      GOTO 200

    4 ILONG=HEADR(SLON)/100.0
	IF(HEADR(SLON).GE.0.)THEN
	IEW=1
	ELSE
	IEW=2
	ENDIF
      RLONG=ABS(HEADR(SLON)-ILONG*100.0)
      WRITE(TE,4000)IABS(ILONG),RLONG,EW(IEW)
 4000 FORMAT('LONGITUDE:',1X,I4,1X,F4.1,1X,A1)
      GOTO 200

5     WRITE(TE,5000)HEADR(SDEP)
 5000 FORMAT('STA DEPTH:',T13,F8.2,' (METERS)')
      GOTO 200

6     WRITE(TE,6000)HEADR(INDEP)
 6000 FORMAT('NOM DEPTH:',T13,F8.2,' (METERS)')
      GOTO 200

7     WRITE(TE,7000)HEADR(IADEP)
 7000 FORMAT('ACT DEPTH:',T13,F8.2,' (METERS)')
200   READ(TE,8000)LINE1
8000	FORMAT(11A4)
      RETURN
      END
C*F45V1P0*
      SUBROUTINE COL2(HEADR,JRITE,LINE2)
      DIMENSION HEADR(145),LINE2(15),LSTRNG(11)
      CHARACTER TE*60,STR*20
	REAL LINE2,LSTRNG
C
CC  DEFINITION OF INDEXES USED FOR BIBO FORMAT:
C
#ifdef unix
	INCLUDE 'BIBO.COM'
#else
        INCLUDE 'pplinc:BIBO.COM'
#endif
      COMMON /TBLE/PTAB(8,4),DTTAB(8,29),FTTAB(8,9),WTTAB(8,11)
      COMMON /TBLE/STTAB(8,19),PCTAB(8,5),UNIT(4,15)
      COMMON /NTBLE/NPTAB,NDTTAB,NFTTAB,NWTTAB
      COMMON /NTBLE/NSTTAB,NPCTAB,NUNIT


      GO TO (1,2,3,4,5,6,61,7,8,9,10,11,12,13,14,15),JRITE

    1 CALL FILL(DTTAB,NDTTAB,HEADR(DTYPE),LSTRNG,IER)
      WRITE(TE,1000)(LSTRNG(I),I=1,10)
 1000 FORMAT('DATA:',T7,6A4,1X,4A4)
      GOTO 200

    2 IF(HEADR(SCODE).GT.0.0)GO TO 23
      JRITE=JRITE+1
      GO TO 3
   23 CALL FILL(STTAB,NSTTAB,HEADR(SCODE),LSTRNG,IER)
	WRITE(TE,3000)(LSTRNG(I),I=1,10)
	GOTO 200

    3 IF(HEADR(PCODE).GT.0.0)GO TO 33
      JRITE=JRITE+1
      GO TO 4
   33 CALL FILL(PCTAB,NPCTAB,HEADR(PCODE),LSTRNG,IER)
      WRITE(TE,3000)(LSTRNG(I),I=1,10)
 3000 FORMAT(T7,6A4,1X,4A4)
      GOTO 200

    4 IF(HEADR(MODEN).GT.0.0)GO TO 43
      JRITE=JRITE+1
      GO TO 5
43    WRITE(TE,4000)IFIX(HEADR(MODEN))
 4000 FORMAT('MODE NUMBER:',T21,I10)
      GOTO 200

    5 WRITE(TE,4500)IFIX(HEADR(NPTS))
 4500 FORMAT('NUMBER OF POINTS:',T21,I10)
      GOTO 200

    6 CALL MTDAT(HEADR(STIME),STR)
	WRITE(TE,4800)STR
 4800 FORMAT('DATA START TIME:',T20,A18,'(GMT)')
      GOTO 200

61	IF(HEADR(SPTIME).EQ.0.0)THEN
	JRITE=JRITE+1
	GOTO 7
	ELSE
	CALL MTDAT(HEADR(SPTIME),STR)
	WRITE(TE,4900)STR
4900	FORMAT('DATA STOP TIME:',T20,A18,'(GMT)')
	ENDIF
	GOTO 200

    7 WRITE(TE,5000)HEADR(SRATE)
 5000 FORMAT('SAMPLING RATE:',T21,F10.2,' (MINUTES)')
      GOTO 200

    8 CALL FILL(FTTAB,NFTTAB,HEADR(FILT),LSTRNG,IER)
      WRITE(TE,5500)(LSTRNG(I),I=1,6)
 5500 FORMAT('FILTER:',T7,6A4)
      IF(HEADR(FILT).LE.0.0)JRITE=JRITE+2
      GOTO 200

    9 WRITE(TE,5800)HEADR(CUTLO)
 5800 FORMAT('LOW CUTOFF:',T21,1PE10.2,' (CPH)')
      GOTO 200

   10 WRITE(TE,5900)HEADR(CUTHI)
 5900 FORMAT('HIGH CUTOFF:',T21,1PE10.2,' (CPH)')
      GOTO 200

   11 IF(HEADR(WIND).GT.0.0)GO TO 113
      JRITE=JRITE+2
      GO TO 13
  113 CALL FILL(WTTAB,NWTTAB,HEADR(WIND),LSTRNG,IER)
      WRITE(TE,6000)(LSTRNG(I),I=1,6)
 6000 FORMAT('WINDOW:',T7,6A4)
      GOTO 200

   12 WRITE(TE,6300)HEADR(SIG)
 6300 FORMAT('WINDOW FALLOFF:',T21,1PE10.2,' (CPH)')
      GOTO 200

   13 WRITE(TE,6500)HEADR(MIN)
 6500 FORMAT('MINIMUM:',T21,1PE10.2)
      GOTO 200

   14 WRITE(TE,6800)HEADR(MAX)
 6800 FORMAT('MAXIMUM:',T21,1PE10.2)
      GOTO 200

   15 WRITE(TE,7000)HEADR(MEAN)
 7000 FORMAT('MEAN:',T21,1PE10.2)

200   READ(TE,8000)LINE2
8000  FORMAT(15A4)
      RETURN
      END
C*F45V1P0*
      SUBROUTINE FILL(TABLE,N,VALUE,STRING,IER)

      COMMON /TBLE/PTAB(8,4),DTTAB(8,29),FTTAB(8,9),WTTAB(8,11)
      COMMON /TBLE/STTAB(8,19),PCTAB(8,5),UNIT(4,15)
      COMMON /NTBLE/NPTAB,NDTTAB,NFTTAB,NWTTAB
      COMMON /NTBLE/NSTTAB,NPCTAB,NUNIT

      DIMENSION TABLE(8,N),STRING(11)
	character str*44
	real blnk
#if defined FORTRAN_90 || defined G77
	integer iblnk
	equivalence (blnk,iblnk)
	data iblnk/Z'20202020'/
#else
	data blnk/'    '/
#endif

      IER=0
      DO 100 I=1,N
      IF(ABS(TABLE(1,I)-VALUE).LT. 0.01)GO TO 200
  100 CONTINUE

      WRITE(STR,1000)IFIX(VALUE)
 1000 FORMAT(14X,I10)
	read(str,1223)STRING
1223	format(11a4)
      IER=1
      K=1
      GO TO 400

  200 DO 300 J=1,6
  300 STRING(J)=TABLE(J+2,I)
      K=TABLE(2,I)+1

  400 DO 500 J=7,10
  500 STRING(J)=UNIT(J-6,K)
      STRING(11)=BLNK
      RETURN
C**  THIS PROGRAM VALID ON FTN4 AND FTN5 **
      END

	SUBROUTINE DISP_RESET

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* initialize or reset the underlying plot package (PPLUS) to FERRET defaults
* (this routine is called only at start-up or by the command PPLUS/RESET)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 9/8/88 - extracted from DISP_INIT
* V200:   1/3/89 - added ALINE, AXLSZE
* V230:  11/4/92 - call SET_VIEWPORT(dflt_vp)
*        11/9/92 - unprotect all colors
* V540:  *sh* 9/01 - grab the PLOT+ origin from COMMON
* V600 *acm* 5/2006 LINECOLORS User can change the number of line colors.
* V62  *acm* 4/09 - Restore default settings for AXTYPE, AXLABP, AXLINT,
*                   TXLABP, TXLSZE, TICS, CONPRE, CONPST, DFLTFNT, palette,
*                   Default number of colors. (Should reset the line colors??)
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* v696  *acm* 6/15 PLOT/VS/GAPLOC to define seperate line segments on
*                  PLOT/VS plots (LAS ticket 1597 and others)
* V697  *acm*  1/16 Ticket 2344: if there was a time-plot underlay, use the underlay's 
*                   time scaling for time overlay plots. TAXUND restores the default.

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'plot_setup.parm'
	include 'xplot_setup.cmn'
	include 'xplot_state.cmn'
        include 'xprog_state.cmn'
	include 'xrevision.cmn'

* local variable declarations
	CHARACTER buff*24
	REAL*4 xsize, ysize

* local parameters
        LOGICAL     physical
        PARAMETER ( physical = .TRUE. )

* PLOT5 re-initialization (to forget previous states)
!	CALL PPLCMD ( from, line, 0, 'GET FERRET_PPLINIT', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'XFOR', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'YFOR', 1, 1 )
 	CALL PPLCMD ( from, line, 0, 'XLAB', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'YLAB', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'XAXIS', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'YAXIS', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'XVALOFF 0', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'YVALOFF 0', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'AXSET 1,1,1,1', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'PEN 0,1', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'PEN 1,1', 1, 1 )

        WRITE (buff, 100) mode_arg(pmode_linecolors, 1)
  100   FORMAT (I3)
        CALL PPLCMD (from, line, 0, 'LINECOLORS '//buff(1:3)//' 1', 1, 1)

	buff = ' '
	WRITE ( buff, 3000 ) xwhitelo, ywhitelo
 3000	FORMAT(F9.3,F9.3)
	CALL PPLCMD ( from, line, 0, 'ORIGIN '//buff, 1, 1 )
	CALL PPLCMD ( from, line, 0, 'AXATIC 10,10', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'LABS', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'ALINE', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'TAXIS OFF', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'AXNMTC 0,0', 1, 1 )
c	CALL PPLCMD ( from, line, 0, 'TXNMTC 0', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'TXNMTC -1', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'TAXUND 0', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'TITLE', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'LABSET,0.16,0.12,0.12,0.12', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'WINDOW ON', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'BOX OFF', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'CROSS 0', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'AXLSZE .1,.1', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'AXTYPE 1,1', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'AXLABP -1,-1', 1, 1)
	CALL PPLCMD ( from, line, 0, 'TXLABP -1', 1, 1)
	CALL PPLCMD ( from, line, 0, 'TXLSZE .1', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'TICS,.125,.25,.125,.25,-1,-1', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'AXLINT 2,2', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'CONPRE ', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'CONPST ', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'SIZE 10.2  8.8 ', 1, 1 )
        CALL SET_VIEWPORT( mvp_dflt )   ! remove viewports, restore axis sizes
	CALL PPLCMD ( from, line, 0, 'GAPLOC 0', 1, 1 )

c        CALL COLOR (1)  ! ppl is not always in the right state to call this...

* set up the default spectrum
        CALL PPL_SHASET( 'RESET' )
        CALL PPL_SHASET( 'SPECTRUM=default' )

* Set default (initial) number of color levels

        CALL SET_DEFAULT_NLEVELS( mode_arg(pmode_nlevels, 1) )

	RETURN
	END

	CHARACTER*(*) FUNCTION LEFT_REAL( val, fmt, len )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* create a left-justified real string from val with format fmt
* typical usage:
* i) declare length of function in calling routine 
*	eg. CHARACTER*8 LEFT_REAL
* ii) use as a character variable
*	eg. WRITE( 20,'(1X,A)') LEFT_REAL( x, 2, len )

* note: if value cannot fit within field '****' will be inserted

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written in transportable FORTRAN 77

* revision 0.0 - 7/13/87 modeled after LEFINT rev. 0.0

        IMPLICIT NONE
* calling argument declarations:
	REAL	val
	CHARACTER*(*) fmt
	INTEGER	len

* internal variable declarations:
	CHARACTER*16 buff16
	INTEGER	     first

* create right-justified string of up to 16 digits
	WRITE ( buff16, fmt ) val

* find left-most non-blank
	DO 100 first = 1, 15
	   IF ( buff16(first:first) .NE. ' ' ) GOTO 200
 100	CONTINUE
	first = 16

* insert left-justified string
 200	LEFT_REAL = buff16(first:16)

* measure its length
	DO 300 len = 0, 15
	   IF ( LEFT_REAL( len+1:len+1 ) .EQ. ' ' ) RETURN
 300	CONTINUE

* error - didn't fit
	LEFT_REAL = '****'
	len = 4
	RETURN

	END

	SUBROUTINE DO_AUX_REGRID_LINE_AVE ( axis,
     .					 src_line, pos_line,
     .					 kmin_src, kmax_src,
     .					 ndx_dst, coef_dst,
     .					 kmin_dst, kmax_dst,
     .					 kdlo_ok,  kdhi_ok,
     .					 bad_src,  bad_dst, bad_pos,
     .					 ascending,
     .					 dst_line    )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* regrid a single line along the regrided axis.  For each destination point
* regrid using the weighted average of values lying entirely or partly
* in the cell

* the algorithm will weight the input values based upon viewing the
* coordinates found in the auxiliary coordinate variable as a piecewise-linear
* function.  For each destination grid cell the algorithm will compute the
* integral, and divide by its length.

* Thus that calculation is one of adding up the areas of a
* series of trapezoids from the source data over a coordinate length defined
* by the limits of each target grid cell.

* For any given cell the trapezopids at the edges of the cell may be truncated,
* as the destination cell boundaries may not lie directly on the coordinate
* values given in the auxiliary variable.

* sample expression:  temp[gz(depth)=zax]
* variable naming convention:
*     pos_line - position (coordinate) values (e.g. depth)
*     src_line - values on their original grid (e.g. temp)
*     dst_line - values regridded to target grid

*  The incoming index pointers tell us the source data indices that lie
*  at or immediatly below each target grid cell boundary.
*  If there are N destination grid points there will be N+1
*  cell boundaries and N+1 incoming indices, positions and coefficients. The
*  coefficient values are non-unity, when the target cell boundary coordinate
*  lies in between the coordinate values from the auxiliary coordinate array
*  The sense of the coefficient is that the value at this destination location
*  should be computed as 
*                  interp_val = coef*src(k) + (1-coef)*src(k+1)
* 
* v690 11/13 *sh* - based upon DO_AUX_VAR_REGRID_LIN
* v698+ 5/15 *sh* - support non-monotonic and missing aux vars (e.g. density)

        IMPLICIT NONE
        include 'tmap_dims.parm'
        include 'errmsg.parm'
	include	'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'

* calling argument declarations:
	LOGICAL	ascending
	INTEGER	axis, kmin_src,kmax_src, kmin_dst, kmax_dst, kdlo_ok, kdhi_ok,
     .		ndx_dst (kmin_dst:kmax_dst+1)
        REAL    src_line(kmin_src:kmax_src),
     .		pos_line(kmin_src:kmax_src),
     .		coef_dst(kmin_dst:kmax_dst+1),
     .		dst_line(kmin_dst:kmax_dst),
     .		bad_src, bad_dst, bad_pos

* internal variable declarations:
	LOGICAL	trunc, bad_ave, bad_next_ave
        INTEGER ndx_lo, ksrc, kdst, kend, kstart, kinc1
        REAL    area, span, width, frac, pos_lo, pos_hi, src_lo, src_hi
* ... 5/15 bad_ave and bad_next_ave look after non-monotonic and missing values

* initialize
	IF (ascending) THEN 
	   kinc1 = 1
	ELSE
	   kinc1 = -1
	ENDIF

* set up the lower bound of the first trapezoid (possibly truncated)
	frac   = coef_dst(kdlo_ok)
	ksrc   = ndx_dst (kdlo_ok)
	pos_hi = pos_line(ksrc)
	src_hi = src_line(ksrc)
	bad_ave = frac   .EQ. bad_val4
     .       .OR. pos_hi .EQ. bad_pos
     .       .OR. src_hi .EQ. bad_src
	trunc  = frac.NE.1.0
	IF (trunc .AND. .NOT.bad_ave) THEN
* make the initial truncated trapezoid behave like a full trapezoid by  
* replacing its lower limit with the proper linear interpolation
	   src_hi = frac*src_hi + (1-frac)*src_line(ksrc+kinc1)
	   pos_hi = frac*pos_hi + (1-frac)*pos_line(ksrc+kinc1)
	   trunc  = .FALSE.
	ENDIF
	kstart = ksrc + kinc1   ! ksrc always points to the upper index

* loop over destination cells
* each dst cell is represented by two points in the dst arrays
*    the k   point is the index below or at the start of the cell
*    the k+1 point is the index below or at the end   of the cell
	DO 1000 kdst = kdlo_ok, kdhi_ok

	   area = 0.0
	   span = 0.0

* set up low lim of next dest cell from high lim of preceding
	   pos_lo = pos_hi
	   src_lo = src_hi

* loop over the full src trapezoids that contribute to current dst cell
	   kend = ndx_dst(kdst+1)
	   DO 500 ksrc = kstart, kend, kinc1

* upper end of trapezoid in the src line
	      pos_hi  = pos_line(ksrc)
	      src_hi  = src_line(ksrc)

	      width = pos_hi - pos_lo

* bail on this output cell if there is non-monotonic or missing data
	      bad_ave = bad_ave
     .	           .OR. pos_hi .EQ. bad_pos
     .             .OR. src_hi .EQ. bad_src
     .             .OR. width  .LE. 0.0
	      IF (bad_ave) EXIT

* add a full trapezoid 
	      span  = span + width
	      area  = area + width * 0.5*(src_hi+src_lo)

* prepare for next trapezoid in the src line
	      pos_lo = pos_hi
	      src_lo = src_hi	    
 500	   CONTINUE

* handle partial trapezoid at upper bound of destination cell
	   frac = coef_dst(kdst+1)
	   bad_next_ave = frac .EQ. bad_val4
	   trunc = frac .NE. 1.0 .AND. .NOT.bad_next_ave
	   IF (trunc) THEN
	      bad_next_ave = pos_line(kend) .EQ. bad_pos
     .                  .OR. src_line(kend) .EQ. bad_src
     .                  .OR. pos_line(kend+kinc1) .EQ. bad_pos
     .                  .OR. src_line(kend+kinc1) .EQ. bad_src
	      IF (.NOT. bad_next_ave) THEN
* add the lower part of the truncated trapezoid.
* the upper part is handled as part of the next destination cell
	         pos_hi = frac*pos_line(kend) + (1-frac)*pos_line(kend+kinc1)
	         src_hi = frac*src_line(kend) + (1-frac)*src_line(kend+kinc1)
	         width = pos_hi - pos_lo
	         span  = span + width
	         area  = area + width * 0.5*(src_hi+src_lo)
	      ENDIF
	   ENDIF

* store the weighted average of trapezoids contributing to dst cell
	   IF (bad_ave .OR. bad_next_ave) THEN
	      dst_line(kdst) = bad_dst
	   ELSE
	      dst_line(kdst) = area/span
	   ENDIF

* prepare for next dst
	   kstart = kend + kinc1
	   bad_ave = bad_next_ave   ! happens when bad partial trap at end

 1000	CONTINUE

	RETURN
	END

      SUBROUTINE CD_ISIT_ANOTHER_DSET (expression, dset, varname,status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Look for [d=n] within an expression, and reset dset to match the dataset number
* or name. varname is returned without the [d=] expression.

* V600 6/05 *acm* Attribute control.

	INCLUDE	'ferret.parm'
	INCLUDE 'errmsg.parm'

* calling argument declarations

      INTEGER dset, status
      CHARACTER*(*) expression, varname

* local variable declarations
      INTEGER TM_LENSTR1, slen, elen, llen, ivar, mods_cx, category

      llen = TM_LENSTR1(expression)
      varname = expression

      IF ( INDEX(expression,'[') .GT. 0 ) THEN

         CALL PARSE_NAM_DSET(expression, cx_last, dset, category, 
     .                       ivar, mods_cx, status)
         IF (status .NE. ferr_ok) THEN
            dset = pdset_irrelevant	! default (not used ...)
            CALL PARSE_NAM_DSET(expression, cx_last, dset, category, 
     .                       ivar, mods_cx, status)
         ENDIF
         IF (status .NE. ferr_ok) GOTO 5010
         slen = INDEX(expression,'[') 
         elen = INDEX(expression,']')
         varname = expression(1:slen-1)
         IF (llen .GT. elen) 
     .      varname = expression(1:slen-1)//expression(elen+1:llen)
 
      ENDIF

5000  RETURN

5010  IF (dset .EQ. pdset_irrelevant .OR. 
     .       dset .EQ. unspecified_int4) status = ferr_syntax

      RETURN
      END

	SUBROUTINE FIND_VAR_NAME ( dset_num, test_name, category, variable )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* identify the given name by finding it in one of the known categories

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 4/4/86
* revision 0.1 - 1/20/87 - changed nvari_prenamed to num_fils_vars for PSI
* revision 0.2 - 3/6/87  - introduced user var search and munknown_var_name
* revision 0.3 - 3/23/87 - added new TMAP library: time axes, file var. names
* revision 0.4 - 3/10/88 - added cat_named_var and unspecified data set
* V200:  6/20/89 - eliminated "named" variables
*	 1/25/90 - padded cvar_name_code with 4 blanks avoid QADXT=QADX match
* V402:  7/95 - Added support for  LET/D=dset var = ...
* V495: 7/7/98 - *sh* allow case-sensitive variable names in quotes from dsets
*       user variable names are allowed in quotations just for
*       consistency. Pseudo-variable names in quotes are not allowed -- so they
*       don't get confused
* V510 5/00 *sh* - don't match on a cvar unless the data set indicates
*	Philander-Seigel
* V554 1/04 *acm* Add category cat_counter_var
*  ywei 05/04 change MATCH_NAME and MATCH_QUOTED_NAME function calls to speed up
* V600 *acm* 6/05 attribute control.  If the variable contains a dot (e.g. varname.attname
*                 or varname.attnum) then find and use just the varname.
* V600 9/05 *acm* Fix bug 1336: 
*                 Restore the order of searching through the different lists
*                 of variable names (the chunk of code now at DO 250).  Yonghua had
*                 moved this for efficiency but it wound up finding the wrong
*                 variable def for user variables defined with LET/D.
* v600 6/06 *acm* initialize category to 0 (needed for solaris)
* V63  *acm* 10/09 Changes for gfortran build
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V685 *acm*  3/13 For Ensemble aggregations, call the ds_type 'ENS'
* V685+ *acm* 3/13 For Ensemble ds_type, check datset number before testing its type
* v694 *acm* 12/14 Fix ticket 2050: case of variables in quotes
*      *sh*  12/14 Allow _SQ_ as an acceptable equivalent to single quotes
*      *acm*  2/15 Prevent run-time errors in string length for _SQ_ handling
* V695 *acm*  2/15 For Forecast aggregations, call the ds_type 'FCT'
* V698  3/16 *acm* Removed Philander-Seigel code including diagnostic 
*                  variables, pre-defined axes and grids, cat_calc_var.
* V7   *acm*  6/12 Add Union aggregations: DEFINE DATA/AGG/U, ds_type 'UNI'

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
        include 'errmsg.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include	'xalgebra.cmn'
        include 'xcontrol.cmn'

* calling argument declarations:
	INTEGER		dset_num, category, variable
	CHARACTER*(*)	test_name

* internal variable declarations:
	INTEGER		TM_LENSTR, ivar, uvdset, len_test, len_mchars,
     .                  j, num_indices, varid, dset, status
	LOGICAL		MATCH_QUOTED_NAME, single_dset, do_err
        CHARACTER       varname*512, attname*128
        CHARACTER*258   buff

* initialize
        buff = test_name
	single_dset = dset_num .NE. unspecified_int4
        len_test = TM_LENSTR(test_name)
        category = 0
        dset = dset_num

        IF (INDEX(test_name, '.') .GT. 0) THEN
           do_err = .TRUE.
           CALL BREAK_VARATTNAME ( test_name, dset, varname, 
     .                             attname, varid, do_err, status )
           IF (status .EQ. ferr_ok) THEN
              category = cat_attrib_val
              RETURN

* String marked as not being a varname.attname, perhaps a string in
* quotes that may contain a dot.

           ELSE IF (status .EQ. ferr_not_attribute) THEN
              GOTO 500 

           ELSE 
              variable = munknown_var_name
              RETURN
           ENDIF
        ENDIF
*

*                  CALL tm_log( test_name, len_test) 

* start by checking counter variable names
*	DO 10 ivar = 1, num_counter_vars
*           len_mchars = TM_LENSTR(countervar_name(ivar))
*	   IF ( MATCH_NAME( test_name, len_test,
*        1	   countervar_name(ivar),len_mchars ) ) THEN
*	      category = cat_counter_var
*	      variable = ivar
*	      RETURN
*	   ENDIF
* 10	CONTINUE

 500 	CALL string_array_find(countervar_name_head,
     .                         test_name,
     .                         len_test,
     .                         string_array_result(1),
     .                         max_uvar,
     .                         num_indices)
        IF(num_indices.GT.0) THEN
              ivar = string_array_result(1)
	      category = cat_counter_var
	      variable = ivar
              test_name = buff
	      RETURN
        ENDIF

* check pseudo-variables names
*	DO 20 ivar = 1, num_pseudo_vars
*           len_mchars = TM_LENSTR(alg_pvar(ivar))
*	   IF ( MATCH_NAME( test_name, len_test, alg_pvar(ivar),len_mchars)) 
*        1	   THEN
*	      category = cat_pseudo_var
*	      variable = ivar
*	      RETURN
*	   ENDIF
* 20	CONTINUE

	CALL string_array_find(alg_pvar_head,
     .                         test_name,
     .                         len_test,
     .                         string_array_result(1),
     .                         max_uvar,
     .                         num_indices)
        IF(num_indices.GT.0) THEN
              ivar = string_array_result(1)
	      IF (ivar .GT. 30) ivar = ivar - 30 ! allow _I,_J,_K,_L,_X,_Y,_Z,_T 
	      category = cat_pseudo_var
	      variable = ivar
              test_name = buff
	      RETURN
        ENDIF

* check data user-defined variables
*       CALL tm_log(my_cbuff, 255)
        CALL string_array_find_quoted(uvar_name_code_head,
     .                                test_name,
     .                                len_test,
     .                                string_array_result(1),
     .                                max_uvar,
     .                                num_indices)
*         cat_test = -1
*         var_test = -1
* ... first check for an explicitly named data set
*	   DO 40 ivar = 1, max_uvar
*	      IF ( uvar_num_items( ivar ) .EQ. uvar_deleted ) GOTO 40
*	      IF ( uvar_dset( ivar ) .NE. dset ) GOTO 40
*              len_mchars = TM_LENSTR(uvar_name_code(ivar))
*	      IF ( MATCH_QUOTED_NAME(test_name,len_test, uvar_name_code(ivar), len_mchars))
*     .        	   THEN
*	         category = cat_user_var
*	         variable = ivar
*	         RETURN
*	      ENDIF
* 40	   CONTINUE
	IF ( single_dset ) THEN
           DO 40 j = 1, num_indices
              ivar = string_array_result(j)
	      IF ( uvar_dset( ivar ) .NE. dset ) GOTO 40
              IF ( uvar_num_items( ivar ) .EQ. uvar_deleted ) GOTO 40
              category = cat_user_var
	      variable = ivar
              test_name = buff
	      RETURN
 40	      CONTINUE


	ELSE
* ... check for an implicitly named data set - the "current" data set
	   uvdset = cx_data_set(cx_last)
	   IF ( uvdset .NE. unspecified_int4 ) THEN
*	      DO 60 ivar = 1, max_uvar
*	         IF ( uvar_num_items( ivar ) .EQ. uvar_deleted ) GOTO 60
*	         IF ( uvar_dset( ivar ) .NE. uvdset ) GOTO 60
*                 len_mchars = TM_LENSTR(uvar_name_code(ivar))
*	         IF ( MATCH_QUOTED_NAME( test_name,len_test, uvar_name_code(ivar),len_mchars))
*     .        	      THEN
*	            category = cat_user_var
*	            variable = ivar
*	            RETURN
*	         ENDIF
* 60	      CONTINUE
           DO 60 j = 1, num_indices
              ivar = string_array_result(j)
	      IF ( uvar_dset( ivar ) .NE. uvdset ) GOTO 60
              IF ( uvar_num_items( ivar ) .EQ. uvar_deleted ) GOTO 60
              category = cat_user_var
	      variable = ivar
              test_name = buff
	      RETURN
 60	      CONTINUE
	   ENDIF
	ENDIF

* ... check the global user variable definitions defined without /D
*	DO 100 ivar = 1, max_uvar
*	   IF ( uvar_num_items( ivar ) .EQ. uvar_deleted ) GOTO 100
*	   IF ( uvar_dset( ivar ) .NE. unspecified_int4 ) GOTO 100
*           len_mchars = TM_LENSTR(uvar_name_code(ivar))
*	   IF ( MATCH_QUOTED_NAME( test_name,len_test,uvar_name_code(ivar),len_mchars) )
*     .        	THEN
*	      category = cat_user_var
*	      variable = ivar
*	      RETURN
*	   ENDIF
* 100	CONTINUE
           DO 100 j = 1, num_indices
              ivar = string_array_result(j)
	      IF ( uvar_dset( ivar ) .NE. unspecified_int4 ) GOTO 100
              IF ( uvar_num_items( ivar ) .EQ. uvar_deleted ) GOTO 100
              category = cat_user_var
	      variable = ivar
              test_name = buff
	      RETURN
 100	      CONTINUE

* check file variables from this data set
* Quoted variable may have been saved in the data structure uppercased:
* Look first with the spelling given, then if not found use case-blind search.
*
*	DO 200 ivar = 1, maxvars
*	   IF ( single_dset .AND. ds_var_setnum( ivar ) .NE. dset ) GOTO 200
*           len_mchars = TM_LENSTR(ds_var_code(ivar))
*	   IF ( MATCH_QUOTED_NAME( test_name,len_test, ds_var_code( ivar ),len_mchars)) 
*        1    THEN
*	      category = cat_file_var
*	      variable = ivar
*	      RETURN
*	   ENDIF
* 200	CONTINUE

        CALL string_array_find_quoted(ds_var_code_head,
     .                                test_name,
     .                                len_test,
     .                                string_array_result(1),
     .                                max_uvar,
     .                                num_indices)
* NOTE: (*sh* 12/2014):  The routine string_array_find_quoted includes a case-blind
*     array scan if the test_name string has no enclosing qquotation marks.
*     So are these next lines of code redundant/unnecessary?
	IF (len_test.GT.0) THEN
* ... case-blind search for name enclosed in "'"
	   IF (num_indices.EQ.0 .AND. test_name(1:1).EQ."'") THEN
!	      len_test = TM_LENSTR(test_name)    ! 12/14 *sh* is this needed?
	      varname = test_name(2:len_test-1)
	      CALL string_array_find_caseblind(ds_var_code_head,
     .                                   varname,
     .                                   len_test-2,
     .                                   string_array_result(1),
     .                                   max_uvar,
     .                                   num_indices)
* ... case-blind search for name enclosed in _SQ_
	   ELSEIF (len_test.GT.8) THEN
	      IF (num_indices.EQ.0 .AND. test_name(1:4).EQ.p_SQ_quote) THEN
	         varname = test_name(5:len_test-4)
	         CALL string_array_find_caseblind(ds_var_code_head,
     .                                   varname,
     .                                   len_test-8,
     .                                   string_array_result(1),
     .                                   max_uvar,
     .                                   num_indices)
	      ENDIF
	   ENDIF
	ENDIF

        DO 200 j = 1, num_indices
           ivar = string_array_result(j)
	   IF ( single_dset .AND. ds_var_setnum( ivar ) .NE. dset ) GOTO 200
 	   category = cat_file_var
 	   IF (dset.NE.unspecified_int4) THEN
	      IF (ds_type(dset).EQ.'ENS') category = cat_agg_e_var
	      IF (ds_type(dset).EQ.'FCT') category = cat_agg_f_var
	      IF (ds_type(dset).EQ.'UNI') category = cat_agg_u_var
 	   ENDIF
	   variable = ivar
           test_name = buff
           RETURN
 200	CONTINUE


* ... check the global user variable definitions defined with /D
*       CALL tm_log(my_cbuff, 255)
        CALL string_array_find_quoted(uvar_name_code_head,
     .                                test_name,
     .                                len_test,
     .                                string_array_result(1),
     .                                max_uvar,
     .                                num_indices)
*	DO 250 ivar = 1, max_uvar
*	   IF ( uvar_num_items( ivar ) .EQ. uvar_deleted ) GOTO 250
*	   IF ( uvar_dset( ivar ) .NE. pdset_irrelevant ) GOTO 250
*           len_mchars = TM_LENSTR(uvar_name_code(ivar))
*	   IF ( MATCH_QUOTED_NAME( test_name,len_test,uvar_name_code(ivar),len_mchars))
*     .        	THEN
*	      category = cat_user_var
*	      variable = ivar
*	      RETURN
*	   ENDIF
* 250	CONTINUE
           DO 250 j = 1, num_indices
              ivar = string_array_result(j)
	      IF ( uvar_dset( ivar ) .NE. pdset_irrelevant ) GOTO 250
              IF ( uvar_num_items( ivar ) .EQ. uvar_deleted ) GOTO 250
              category = cat_user_var
	      variable = ivar
              test_name = buff
	      RETURN
 250	      CONTINUE

* not found
	variable = munknown_var_name
        test_name = buff

	RETURN

	END

	SUBROUTINE TM_COPY_GRID ( source, dest )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Copies grid information from source to dest
*
* revision 0.00 - 11/22/88
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing
*
* Arguments
	INTEGER*4	source, dest
*
* Parameters and commons
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'xtm_grid.cmn_text'
*
* Local declarations
	INTEGER*4	icnt
*
	grid_name(dest) = grid_name(source)
	DO 100 icnt = 1,nferdims
	  grid_line(icnt,dest) = grid_line(icnt,source)
	  grid_out_prod(icnt,dest) = grid_out_prod(icnt,source)
  100	CONTINUE
	grid_rotation(dest) = grid_rotation(source)
	RETURN
	END

	SUBROUTINE GET_UVARS_LIST_BY_ATTNAME_AND_VAL
     .			(attname, attstring, maxlist,
     .			 id_list, dset_list, nfound  )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* return a list of all user variables that have a particular given value for
* a given string attribute
* intended usage:  find variables that have _SIGMA_REF_'="DEPTH"
* Note: if the incoming string is unspecified_name4, then all attrib vals match

* V690: 2/14 *sh* 
* V693+ 11/14 *sh* renaming 'sigma' as 'layerz' throughout

        IMPLICIT NONE
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl_vms.parm'
	include 'xvariables.cmn'
	include 'xrisc.cmn'

* calling argument declaration:
	CHARACTER*(*) attname, attstring
	INTEGER	maxlist, id_list(maxlist), dset_list(maxlist), nfound

* internal parameter declarations
	INTEGER	maxlen
	PARAMETER (maxlen = 50)

* internal variable declarations:
	LOGICAL NC_GET_ATTRIB,
     .		found_one, no_match_needed
	INTEGER	STR_CASE_BLIND_COMPARE,
     .		ivar, dset, status, varid, attid, attlen, attoutflag,
     .		num_indices, vax_code, dsetm1
	REAL	attvals(maxlen)
	CHARACTER retstring*(maxlen)

* initialize
	no_match_needed = attstring .EQ. unspecified_name4
	nfound = 0
	dsetm1 = -1
        CALL deleted_list_get_undel(uvar_num_items_head, 
     .                          deleted_list_result(1),
     .                          max_uvar, num_indices )

* loop through the user variables
	DO ivar = 1, num_indices

	   CALL CD_GET_VAR_ID (dsetm1, uvar_name_code(ivar), varid, status)
           found_one = NC_GET_ATTRIB ( dsetm1, varid, patnam_layerz,
     .                            .FALSE., uvar_name_code(ivar), maxlen,
     .                            attlen, attoutflag, retstring,
     .                            attvals )
* ... attrib name matches.
*     if necessary now also check if the contents match
           IF (found_one) THEN
	      found_one = no_match_needed
	      IF (.NOT.no_match_needed) THEN
	         vax_code = STR_CASE_BLIND_COMPARE(attstring,retstring)
	         found_one = vax_code .EQ. vms_str_success
	      ENDIF
	      IF (found_one) THEN
	         nfound = nfound + 1
	         id_list  (nfound) = varid
	         dset_list(nfound) = pdset_uvars  ! needs to be uvar_dset(ivar) for LET/D
	         IF (nfound .EQ. maxlist) RETURN  ! hacky but good enuf
	      ENDIF
	   ENDIF
	ENDDO

	RETURN
	END

	SUBROUTINE BOX_BOUNDS( x_or_y, val1, n, bounds, valid )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* PLOT+ routine for use inside FERRET:
* Supply to PLOT+ the bounds of n grid boxes from X or Y axis of the contour
* data currently in PLOT+.  Pointers to the appropriate FERRET axes are in
* COMMON.

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* for FERRET V2.00: 12/21/89
* V3.00 changed REAL FUNCTION to SUBROUTINE (noticed by f77 3.2)
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.

	include 'ferret.parm'
	include 'xbox_bounds.cmn'

* calling argument declarations:
	LOGICAL		valid
	INTEGER		n
	REAL*4		val1, bounds(n+1)
	REAL		wval
	CHARACTER	x_or_y*1

* internal variable declarations:
	INTEGER	ISUBSCRIPT, i, idim, isub1, isub0
	DOUBLE PRECISION TM_WORLD

* initialize
	IF ( x_or_y .EQ. 'X' ) THEN
	   idim = bb_xaxis
	ELSEIF ( x_or_y .EQ. 'Y' ) THEN
	   idim = bb_yaxis
	ENDIF

* determine starting subscript
	isub1 = ISUBSCRIPT ( DBLE(val1), bb_grid, idim, round_dn )
	isub0 = isub1 - 1

* pass back box edges
	DO 100 i = 1, n
	   wval =  TM_WORLD (isub0+i,bb_grid,idim,box_lo_lim)
	   bounds(i) = wval
 100	CONTINUE
	wval = TM_WORLD (isub0+n,bb_grid,idim,box_hi_lim)
	bounds(n+1)  = wval

* always (the appearance of) success
	valid = .TRUE.
	RETURN
	END

	INTEGER FUNCTION TM_DEALLO_DYN_LINE_SUB( line )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Deallocate a line from the dynamic line area (above max_lines)
* Called quasi-recursively by tm_deallo_dyn_line

* Steve Hankin  NOAA/PMEL/TMAP

* 10/3/95 for Ferret version 4.2
* V510 *sh( 4/00 - allow deallocation of non-dynamic lines
* V600 *acm* 10/05 Call PACK_LINE_STORAGE for irregular axes to reset coord storage.

* Include files

	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'tmap_errors.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xio.cmn_text'

* Argument definitions
	INTEGER line

* Local definitions
	INTEGER next_used_line

* initialize
	TM_DEALLO_DYN_LINE_SUB = 0

* screen out garbage (may come from temporary grids)
	IF ( line .LT. 1 .OR. line .GT. max_dyn_lines ) RETURN

* decrement the used count for this line
	line_use_cnt(line) = line_use_cnt(line) - 1
	IF ( line_use_cnt(line) .LT. 0 ) line_use_cnt(line) = 0

* if not a dynamic line or it is a "keeper" then we are done
	IF ( line.LE.max_lines .OR. line_keep_flag(line) ) THEN
	   RETURN
	ENDIF

* does anyone still have a claim on this line?
	IF ( line_use_cnt(line) .GT. 0 ) THEN
	   RETURN

* a use count of -1 results from a line which was allocated and then promptly
* deallocated without being used
	ELSEIF ( line_use_cnt(line) .EQ. 0 ) THEN

	   line_name(line) = char_init16

* take this line from the "used" list and put it on the "free" list
* ... hook onto free list
	   next_used_line   = line_flink(line)
	   line_flink(line) = line_free_ptr  
	   line_free_ptr    = line
	   
* ... unhook from used list
	   line_flink(line_blink(line)) = next_used_line
	   line_blink(next_used_line)   = line_blink(line)

	ELSE
* internal error -- the use count is negative!!
	   CALL TM_NOTE('Intern err: TM_DEALLO_DYN_LINE:2 !!!', lunit_errors)
	ENDIF

* Recover the coordinate storage used for an irregularly-spaced line.
        IF ( .NOT. line_regular(line) ) CALL PACK_LINE_STORAGE (line)

* return flag to indicate if the quasi-recursive descent ends here
* ... zero or index of parent axis to deallocate
	TM_DEALLO_DYN_LINE_SUB = line_parent(line)

* successful completion
	RETURN

	END

	SUBROUTINE GET_WINDOW_LIMS( src_lo, src_hi, src_grid,
     .				 dst_lo, dst_hi, dst_grid,
     .				 idim, sslo, sshi )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* for regridding axis idim from source grid to destination grid:
* determine source grid points contained within the destination boxes

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V510 - *sh* 1/00 -- drawn from GET_AVE_LIMS
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction.

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'

* calling argument declarations:
	INTEGER src_lo, src_hi, dst_lo, dst_hi, src_grid, dst_grid, idim
	INTEGER sslo(dst_lo:dst_hi+1),sshi(dst_lo:dst_hi+1)

* internal variable declarations:
	INTEGER	ISUBSCRIPT, ii, dst_ss, status
	REAL*8	TDEST_WORLD, src_ww

* initialize
        IF ( idim .EQ. t_dim .OR. idim .EQ. f_dim ) THEN
*         TDST_WORLD gives dates from the destination axis as they would be
*         encoded on the source axis 
*   ==>   ALL TIME/DATE CALCULATIONS ARE DONE IN THE DESTINATION AXIS ENCODING
           CALL TDEST_WORLD_INIT ( src_grid, dst_grid, idim, status ) ! src<->dst
           IF ( status .NE. ferr_ok ) RETURN   ! note - status not passed!!!
        ENDIF

* pre-set the output to reflect no source points in any destination cell
	DO 10 ii = dst_lo, dst_hi
	   sslo(ii) = src_hi+1
	   sshi(ii) = src_lo-1
 10	CONTINUE

* loop through the source points identifying which cell each belongs in
	DO 100 ii = src_lo, src_hi

* ... find the destination cell containing the source point
	   src_ww = TDEST_WORLD( ii, src_grid, idim, box_middle )
	   dst_ss = ISUBSCRIPT( src_ww, dst_grid, idim, round_up)

	   IF ( dst_lo.LE.dst_ss .AND. dst_ss.LE.dst_hi ) THEN
	      sslo(dst_ss) = MIN(sslo(dst_ss), ii)
	      sshi(dst_ss) = ii   ! MAX() not needed -> ii strictly increasing
	   ENDIF

 100	CONTINUE

	RETURN
	END	

	SUBROUTINE DEFINE_T_AGGREGATION
     .		(dset_name, dset_title, nagfiles,
     .		 memb_filename,
     .		 gvn_memb_tstep_start, gvn_memb_tstep_end, gvn_memb_nstep,
     .		 t_regular, use_strict, dset_num, status)

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* this routine functions as a wrapper around the routine DEFINE_T_AGG_MC_DSET
* it is intended to make that routine friendlier to call from Python
* Through this routine we permit the Python user to pass scalars to
* indicate the time step metadata is not available

* V695+ *sh* 10/15 new routine 

* arguments:
*   NOTE: the 3 args that begin with "gvn" are the "given" metadata for the
*   files to be aggregated.  If the gvn_memb_nstep array length is 1, then the
*   calling program has elected NOT to provide this information 

*	dset_name	- dataset name to assign to the aggregation (input)
*	dset_title	- dataset title (input)
*	nagfiles	- number of files in the aggregation (input)
*	memb_filename	- array of filenames (input)
*	gvn_memb_tstep_start - array of first timestep in each file (input)
*	gvn_memb_tstep_end   - array of last  timestep in each file (input)
*	gvn_memb_nstep	- array of N timesteps in each file (input)
*	t_regular	- flag to signal promise of regular timesteps (input)
*	use_strict	- flag to allow micro-adjustments of T axis (input)
*	dset_num	- number assigned to this data set (output)
*	status		- return status (output)
*

        include 'ferret.parm'
        include 'errmsg.parm'

* Argument definitions
	INTEGER		gvn_memb_nstep(*)
	REAL*8		gvn_memb_tstep_start(*), gvn_memb_tstep_end(*)
	LOGICAL		t_regular, use_strict
	INTEGER		nagfiles, dset_num, status
	CHARACTER*(*)	dset_name, dset_title
	CHARACTER*128	memb_filename(nagfiles)

* Internal declarations
	INTEGER	iset
	INTEGER	memb_nstep(nagfiles)
	REAL*8	memb_tstep_start(nagfiles), memb_tstep_end(nagfiles)

* ***!!! TEMPORARY  !!!*** -- need to expand error message list
	INTEGER ferr_invalid_pyFerret_call
	ferr_invalid_pyFerret_call = ferr_invalid_command

* initialize
	status = ferr_ok

* HOW TO GET THE SIZE OF AN ARRAY!!!!  Intrinsic SIZE function??


* has the caller of this routine provided the time step metadata?
	IF ( SIZE(gvn_memb_nstep).NE.SIZE(gvn_memb_tstep_start)
     .  .OR. SIZE(gvn_memb_nstep).NE.SIZE(gvn_memb_tstep_end)  ) GOTO 5100

	IF (SIZE(gvn_memb_nstep) .EQ. nagfiles) THEN
* yes -- copy the given metadata into working arrays
	   DO iset = 1, nagfiles
	      memb_nstep      (iset) = gvn_memb_nstep      (iset)
	      memb_tstep_start(iset) = gvn_memb_tstep_start(iset)
	      memb_tstep_end  (iset) = gvn_memb_tstep_end  (iset)
	   ENDDO
	ELSEIF (SIZE(gvn_memb_nstep) .EQ. 1) THEN
* no -- set up empty arrays
	   DO iset = 1, nagfiles
	      memb_nstep      (iset) = unspecified_int4
	      memb_tstep_start(iset) = unspecified_val8
	      memb_tstep_end  (iset) = unspecified_val8
	   ENDDO
	ELSE
* oops -- lengths of arrays are not conformable
	   GOTO 5100
	ENDIF

* now call the "real" routine
	CALL DEFINE_T_AGG_MC_DSET
     .		(dset_name, dset_title, nagfiles,
     .		 memb_filename,
     .		 memb_tstep_start, memb_tstep_end, memb_nstep,
     .		 use_strict, dset_num, status)


* success
	RETURN

* error exits
 5000	RETURN
 5100	CALL ERRMSG( ferr_invalid_command, status,
     .		'aggregation timestep metadata  arrays must' //
     .		'contain metadata for the files or be all of length 1'
     .           *5000 )
	END

	INTEGER FUNCTION GET_ONED_STRING_LEN_SUB (grid_data, lo,hi, indx )
	
* Flattening out grid_data to treat it as a 1-D grid ignoring zero-length dimensions
* and return the length of the string at location indx

	INTEGER  indx, lo, hi
	REAL*8 grid_data( lo:hi )
	
	INTEGER GET_C_STRING_LEN

	GET_ONED_STRING_LEN_SUB = GET_C_STRING_LEN( grid_data(indx) )

	RETURN
	END

      SUBROUTINE CD_SET_CHUNK_CACHE (cache_size, cache_nelems, 
     .     cache_preemption, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Set a new chunk cache size, nelems and/or preemption. User specifies 
* cache size in bytes, counts.  If any was unspecified it will come in with a negative
* value and should remain unchanged.
* If all arguments are -1, restore the default from the netcdf library.
* If any individual argument comes in as -1, use the current value;
* e.g. the user will probably set the cache size but leave other values 
* unchanged.

* From the netcdf-4 docs:
* sizep
*    The total size of the raw data chunk cache. 
* nelemsp
*    The number of chunk slots in the raw data chunk cache hash table 
* preemptionp
*    The preemtion value is between 0 and 1 inclusive and indicates 
*    how much chunks that have been fully read are favored for preemption. 
*    A value of zero means fully read chunks are treated no differently 
*    than other chunks (the preemption is strictly LRU) while a value of 
*    one means fully read chunks are always preempted before other chunks. 

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP

* revision 0.0 - 1/2010

* argument definitions:
*       cache_mbytes  - Cache size to set
*	status         - return status

      INCLUDE 'netcdf.inc'
      INCLUDE 'netcdf4_settings.cmn'
      INCLUDE 'tmap_errors.parm'

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

* argument declarations:
      REAL cache_mbytes
      INTEGER cache_size, cache_nelems, 
     .     cache_preemption, status

* local variable declarations:
      INTEGER cdfstat, c_size_in, c_nelems_in, c_preemp_in
      INTEGER default_preemp_size, default_nelems_size

C Set the cache size for the files created/opened in this session.

C Get current settings ( get cache_nelems, cache_preemption which 
C are not currently settable by the user.)

#ifdef usingDODSf2cUnderscore
      cdfstat = NF_GET_CHUNK_CACHE_(c_size_in, c_nelems_in, c_preemp_in)
#else
      cdfstat = NF_GET_CHUNK_CACHE(c_size_in, c_nelems_in, c_preemp_in)
#endif

      IF (cdfstat .NE. NF_NOERR) GOTO 5100 

C If it hasnt been done yet, save the default values
      IF (default_cache_size .EQ. 0) default_cache_size = c_size_in
      IF (default_nelems_size .EQ. 0) default_nelems_size = c_nelems_in
      IF (default_preemp_size .EQ. 0) default_preemp_size = c_preemp_in

C If this routine called with all the args set to -1, (cancel NCCACHE)
C then set to the library default sizes.

      IF (cache_size.LT.0 .AND. cache_nelems.LT.0 .AND. 
     .                          cache_preemption.LT.0) THEN
         cache_size = default_cache_size
         cache_nelems = default_nelems_size
         cache_preemption = default_preemp_size
      ENDIF

C If any individual argument comes in as -1, use the current value.

      IF (cache_size .LT. 0) cache_size = c_size_in
      IF (cache_nelems .LT. 0) cache_nelems = c_nelems_in
      IF (cache_preemption .LT. 0) cache_preemption = c_preemp_in

C Make the setting.

#ifdef usingDODSf2cUnderscore
      cdfstat = NF_SET_CHUNK_CACHE_(cache_size, cache_nelems, 
     .     cache_preemption)
#else 
      cdfstat = NF_SET_CHUNK_CACHE(cache_size, cache_nelems, 
     .     cache_preemption)
#endif

      IF (cdfstat .NE. NF_NOERR) GOTO 5100 

      status = merr_ok
 5000 RETURN
 5100 CALL TM_ERRMSG (cdfstat+pcdferr, status, 'CD_SET_CHUNK_CACHE',
     .     no_descfile, no_stepfile, 
     .    'Setting chunk cache size',
     .     no_errstring, *5000 )
      END

	SUBROUTINE SHOW_LINE_COORDS( grid, cx, idim )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* describe the axes of a grid and then give coordinate data about those
* axes as indicated in cx

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V50 - *sh* 4/99 code extracted from SHOW_GRID
* V530 - *sh* 1/01 - show lower limit value of grid box
* 560 *acm* 4/04 - stride/modulo fixes: use NINT to convert REAL*8 to integer
* v580 *acm* 11/04 Store cal_id in cx_cal_id, the calendar ID used when  
*                  computing world coordinates
* V581 *acm*  6/05 Fix bug in show axis/t with non-standard calendars; RESET_SECS_FROM_BC
* V581 *acm*  6/05 Fix call to TM_GET_CALENDAR_ID (did this ever work with the
*                  argument grid rather than calendar name?!)
* V601 *acm*  3/08 Allow more figs when writing values with negative exponents.
* V650  Write to show_lun which may be set to a file unit number rather than std out
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
*       *acm* 3/12 6D Ferret, changed a comment only
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction. The time 
*                  dimension is now an arg to SECS_TO_TSTEP.
* V683  *acm*10/12 Improve handling of F axes and info about the calendar of the grid.
* V695  *acm* 2/15 cx_calendar stores info about calendar formatting of T and F axes
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes. Return integer
*                  monthly values in these listings

        IMPLICIT NONE
	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'slash.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'
	include 'xtext_info.cmn'
	include 'xcontext.cmn'
	include 'xinterrupt.cmn'
	include 'xrisc.cmn'

* calling argument declarations
	INTEGER grid, cx, idim

* local variable declarations:
	LOGICAL	GEOG_LABEL, ITSA_TRUEMONTH_AXIS, calendar, true_month
	INTEGER ISUBSCR_CX, TM_LENSTR, TM_LENSTR1,
     .          TM_GET_CALENDAR_ID,
     .		lo, hi, i, line, loest, hiest, dlen,
     .		ndec, status, delta, exlen, cal_id,
     .          prev_cal_id, less_figs
	CHARACTER TM_FMT*48, buff*14, pt_str*28, lo_str*28, extra*24
	REAL	BOX_SIZE
	REAL*8	TM_WORLD, SECS_TO_TSTEP,
     .          pt_val8, lo_val8, start, end, new_ww, new_lo, new_hi, timefac


* local parameter declarations:
	INTEGER		sig_figs
	PARAMETER     ( sig_figs = 7 )   ! was 5 1/95

* initialize
	line = grid_line( idim, grid )
	CALL TM_MONTH_TIME_FACTOR (grid, true_month, timefac)

* ignore bogus lines (should never occur ...)
	IF ( line .EQ. munknown
     .  .OR. line .EQ. mnormal ) RETURN

	calendar = (idim.EQ.t_dim .OR. idim.EQ.f_dim) .AND. GEOG_LABEL( idim, grid )	
	IF ( calendar ) THEN
	   exlen = INDEX(line_units(line), '(') - 1
	   IF (exlen .LE. 0) exlen = TM_LENSTR(line_units(line))
	   extra = 'TSTEP ('//line_units(line)(:exlen)
	   extra = extra(:TM_LENSTR(extra))//')'
	ELSE
	   extra = ' '
	ENDIF
	exlen = TM_LENSTR1(extra)
	risc_buff = ' '
	WRITE ( risc_buff, 3030 ) ss_dim_name(idim),
     .				  ww_dim_name(idim),
     .				  ww_dim_name(idim),
     .				  ww_dim_name(idim), extra
	CALL SPLIT_LIST(pttmode_explct, show_lun, ' ', 1)
	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
* ... determine range of data to display
	IF ( cx_lo_ss( cx, idim ) .EQ. unspecified_int4
     . .AND. cx_lo_ww( idim, cx ) .EQ. unspecified_val8 )
     .									THEN
	   lo    = 1
	   hi    = line_dim( line )
	ELSEIF ( cx_by_ss( idim, cx ) ) THEN
	   CALL GRID_SUBSCRIPT_EXTREMES( loest, hiest, grid, idim )
	   lo = MAX( loest, cx_lo_ss( cx, idim ) )
	   hi = MIN( hiest, cx_hi_ss( cx, idim ) )
	ELSE
* kob - 1/98 -  cx_lo/hi_ww need to be translated to tsteps, before calling
*         ISUBSCR_CX, for the t dimension when cx_calendar is true.
*         similar to what goes on in flesh_out_axis. 
*
* cx_lo_ww was set without knowledge of the axis, so if this is a non-std calendar
* need to reset according to the actual calendar type

	   IF ( (idim.EQ.t_dim .OR. idim.EQ.f_dim) .AND. cx_calendar(idim,cx) ) THEN


	      IF (line_t0(line) .EQ. char_init20) GOTO 110  ! Not a calendar ax (e.g. f axis)
              cal_id = TM_GET_CALENDAR_ID(line_cal_name(line))
              cx_cal_id(cx) = cal_id

	      start = cx_lo_ww(idim,cx)
	      end   = cx_hi_ww(idim,cx)
              prev_cal_id = 1

	      IF ( (idim.EQ.t_dim .OR. idim.EQ.f_dim)  .AND.  cal_id .NE. prev_cal_id .AND.
     .             start .LT. 0. .AND. start .NE. unspecified_val8.AND.
     .             end   .LT. 0. .AND. end   .NE. unspecified_val8) THEN
	         CALL RESET_SECS_FROM_BC (-start, new_ww, prev_cal_id, 
     .                                    cal_id, status)
	         cx_lo_ww(idim,cx) = new_ww   ! not negative as we now know the axis.

	         CALL RESET_SECS_FROM_BC (-end, new_ww, prev_cal_id, 
     .                                    cal_id, status)
	         IF ( status .NE. ferr_ok ) RETURN
	         cx_hi_ww(idim,cx) = new_ww

              ELSE IF ( (idim.EQ.t_dim .OR. idim.EQ.f_dim)  .AND. 
     .              cal_id .EQ. prev_cal_id .AND.
     .             start .LT. 0. .AND. start .NE. unspecified_val8.AND.
     .             end   .LT. 0. .AND. end   .NE. unspecified_val8) THEN
	         cx_lo_ww(idim,cx) = -1*cx_lo_ww(idim,cx)
	         cx_hi_ww(idim,cx) = -1*cx_hi_ww(idim,cx)
              ENDIF

              cx_lo_ww(idim,cx) =
     .            SECS_TO_TSTEP( grid, idim, cx_lo_ww(idim,cx) )
              cx_hi_ww(idim,cx) =
     .		   SECS_TO_TSTEP( grid, idim, cx_hi_ww(idim,cx) )
 
* Convert to months

	          cx_lo_ww(idim,cx) = cx_lo_ww(idim,cx)/ timefac
	          cx_hi_ww(idim,cx) = cx_hi_ww(idim,cx)/ timefac

              IF (true_month) THEN
c          cx_lo_ww(idim,cx) = INT(cx_lo_ww(idim,cx))
c	          cx_hi_ww(idim,cx) = INT(cx_lo_ww(idim,cx)+1) 
	          CALL TM_TCOORD_TRUMONTH (line, cx_lo_ww(idim,cx),  
     .		    box_middle, new_lo)
	          CALL TM_TCOORD_TRUMONTH (line, cx_hi_ww(idim,cx),  
     .		    box_middle, new_hi)
     
* Convert to days
	          cx_lo_ww(idim,cx) = new_lo* timefac
	          cx_hi_ww(idim,cx) = new_hi* timefac

              ENDIF

* reset cx_calendar now that cx_lo/hi_ww have been converted
              cx_calendar(idim,cx) = .FALSE.
	   ENDIF
 110	   CONTINUE
	   lo = ISUBSCR_CX( cx_lo_ww(idim,cx),
     .			grid, idim, cx, round_dn )
	   hi = ISUBSCR_CX( cx_hi_ww(idim,cx),
     .			grid, idim, cx, round_up )
	ENDIF

* determine delta increment for listing
	IF ( cx_delta( idim, cx ) .NE. unspecified_val8 ) THEN
	   delta = NINT(cx_delta( idim, cx ))
	ELSE
	   delta = 1
	ENDIF

* write lines of coord and box size data
	IF ( calendar ) THEN
	   ndec = 6	! was 5 1/95
	ELSE
	   ndec = ABS(sig_figs)
	ENDIF
	IF (true_month) ndec = 2

	DO 120 i = lo, hi, delta
	   IF ( interrupted ) CALL ERRMSG
     .		( ferr_interrupt, status, ' ', *1000 )
	   lo_val8 = TM_WORLD( i, grid, idim, box_lo_lim )
	   pt_val8 = TM_WORLD( i, grid, idim, box_middle )
	   CALL TRANSLATE_TO_WORLD( pt_val8,idim,grid,ndec,pt_str )
	   
	   IF (true_month) THEN  ! show in months
	      CALL TRANSLATE_TO_WORLD( lo_val8,idim,grid,ndec+1,lo_str )
	      pt_val8 = INT((pt_val8+1)/timefac)
	      
	   ELSE
	      CALL TRANSLATE_TO_WORLD( lo_val8,idim,grid,ndec,lo_str )
	   ENDIF

#ifdef double_p
	   IF ( calendar ) extra = 
     .	         	TM_FMT( (pt_val8), sig_figs, 14, dlen )
#else
	   IF ( calendar ) extra = 
     .	         	TM_FMT( SNGL(pt_val8), sig_figs, 14, dlen )
#endif
           buff = TM_FMT(
     .                       BOX_SIZE(i,grid,idim), sig_figs, 9, dlen )
           IF (dlen .GT. 9) THEN
              less_figs = sig_figs - 3
              buff = TM_FMT(
     .            BOX_SIZE(i,grid,idim), less_figs, 9, dlen )
           ENDIF
	   risc_buff = ' '
	   WRITE ( risc_buff, 3040 ) ! 3040
     .			i, pt_str,
     .			buff, lo_str,
     .			extra(:exlen)

	   CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
 120	CONTINUE

 3030	FORMAT ( T8,A1,T14,A1,T38,A1,'BOX  ',T52,A1,'BOXLO',T70,A28 )
 3040   FORMAT ( T3,I6,'> ',T12,A28,T38,A10,T49,A28,T75,A14 )

* successful completion
 1000	RETURN
	END

	PROGRAM TEST_STREAM

* For gfortran under linux 2/2012, with double-precision Ferret,
* gfortran -o make_stream_file -Dreclen_in_bytes -Ddouble_p -fdefault-real-8 -fdefault-double-8 make_stream_file.F

	INTEGER i,j

	REAL myvar(10,5)

* generates a test file of REAL direct access values
!	  1  2  3  4  5  6  7  8  9 10
!	 11 12 13 14 15 16 17 18 19 20
!	 21 22 23 24 25 26 27 28 29 30
!	 31 32 33 34 35 36 37 38 39 40
!	 41 42 43 44 45 46 47 48 49 50

* fill with dummy data
	DO 5 j = 1,5
	DO 5 i = 1,10
 5	myvar(i,j) = (j-1)*10+i


* messages to user
	WRITE (6,*)
     .		'Creating machine-specific binary file stream10by5.unf'
	WRITE (6,*)
     .		'Remember to mv stream10by5.unf to stream10by5_{$machine}.unf'

#ifdef double_p
* create output file
	OPEN(UNIT=20,
     .	     STATUS='unknown',
     .	     FILE='stream10by5.unf',
     .	     ACCESS='DIRECT',
#ifdef reclen_in_bytes
     .	     RECL=80)
#else
     .	     RECL=20)
#endif

#else
	OPEN(UNIT=20,
     .	     STATUS='unknown',
     .	     FILE='stream10by5.unf',
     .	     ACCESS='DIRECT',
#ifdef reclen_in_bytes
     .	     RECL=40)
#else
     .	     RECL=10)
#endif
#endif

	DO 100 j = 1, 5
 100	WRITE (20,REC=j) (myvar(i,j),i=1,10)

	STOP
	END

	SUBROUTINE STORE_SYS_STRINGS( cmnd_text, cx, mr,
     .				      pos, nlines, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 


* Execute a shell command and save the resulting strings in the variable mr

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V530:  9/00 *sh*
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V74  3/18 *acm For issue #1199 disallow SPAWN in secure mode

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xvariables.cmn'
	include	'xcontext.cmn'
	include	'xrisc.cmn'

* calling argument declarations:
	INTEGER	cx, mr, pos, nlines, status
	CHARACTER*(*) cmnd_text

* internal variable declarations:
	LOGICAL IS_SECURE
	INTEGER	TM_LENSTR1,clen, old_len, istat, new_mr
	REAL*8	 sysout_ptr

* --- end of introductory code ---

*spawn operations are disallowed in secure mode.
        IF (IS_SECURE()) GOTO 5200

* length of string to be stored
	clen = TM_LENSTR1(cmnd_text)

* convert command to a null-terminated C string
	CALL TM_FTOC_STRNG (cmnd_text,
     .			    risc_buff, size_rbuff )

* execute the shell command
	CALL GET_SYS_CMND(sysout_ptr, nlines, risc_buff, istat)
	IF (istat .NE. 0) THEN
	   CALL ERRMSG(ferr_insuff_memory, status,
     .			'dynamic memory for string', *5000)
	ELSE
	   status = ferr_ok
	ENDIF


* enlarge the context to accomodate the new strings
* ... It is OK to modify cx in this blase way since the Ferret syntax doesnt
*     support "{stuff}[cx mods]". cx mods can be applied to a system output
*     string list only via "LET var={stuff}" and then using "var[cx mods]"
	old_len = cx_hi_ss(cx, x_dim)
! note: the "2000" in this line matches the same in COUNT_NUMBER_LIST.F
	cx_hi_ss(cx, x_dim) = cx_hi_ss(cx, x_dim) + nlines - 2000
	cx_hi_ww(x_dim, cx) = cx_hi_ss(cx, x_dim)

* do we need to allocate a larger block of memory?
	IF ( cx_hi_ss(cx, x_dim) .GT. mr_size(mr) ) THEN
* ... this is effectively a "reallocate" of a larger memory block
	   CALL CREATE_TEMP_MEM_VAR( cx, new_mr, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   CALL GET_C_POINTER(memry(new_mr)%ptr, mr_c_pointer(new_mr))
! 2/2017 - there are no string pointers in the too-short mr yet, so why are
!          we attempting to transfer the string pointers?
!          Looks like this is a left-over from some earlier logic. 
!	   CALL XFER_C_PTRS( mr_c_pointer(mr),     1, 0,
!     .			     mr_c_pointer(new_mr), 1, 0, old_len )
* 2/2017 -- because a pointer to the original mr was passed as an argument
* the routine that called this, freeing that memory from here would corrupt
* runtime stack and crash the program.  So in lieu of deleting the variable
* here, we set it to be deleted later and make it non-cache retrievable
	   mr_type(mr) = ptype_float ! a trick so that C strings are not freed
!	   CALL DELETE_VARIABLE(mr)  ! when DELETE_VARIABLE is called
	   CALL MR_AVAILABLE(mr)     ! put it onto the deletable chain
	   CALL UN_CACHE(mr)         ! set to non-retreivable
	   mr = new_mr
	ELSE
	   mr_hi_ss(mr, x_dim) = cx_hi_ss(cx, x_dim)
	   mr_hi_ww(x_dim, mr) = cx_hi_ss(cx, x_dim)
 	ENDIF

* transfer the strings into this mr (and free the pointer)
	CALL XFER_C_PTRS(sysout_ptr,0,0,mr_c_pointer(mr),1,pos-1,nlines)
	CALL FREE_C_POINTER( sysout_ptr )

* success
	status = ferr_ok

 5000	RETURN

 5200	CALL ERRMSG(ferr_invalid_command, status,
     .   'SPAWN not allowed in secure mode', *5000 )
	END	

	SUBROUTINE PERMUTE_SUB( src_cx, perm,
     .		src, slox, shix, sloy, shiy, sloz, shiz, 
     .		slot, shit, sloe, shie, slof, shif,
     .		dst, dlox, dhix, dloy, dhiy, dloz, dhiz, 
     .		dlot, dhit, dloe, dhie, dlof, dhif )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* permute the 4D data from the source grid into the destination grid
* - 24 possible permutations  (!4)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200: 10/16/89 - extracted from PERMUTE
*	 3/16/90 - fixed bug: "src(i,j,l,k)" --> "src(i,j,k,l)"
*
* v541: 3/02 - *kob* need to replace ifdef 0 because IRIX preprocessor
*                    didn't like it
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
*	           restore code that was ifdef'd out due to a DEC compiler error

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'

* calling argument declarations:
	INTEGER src_cx, perm(nferdims),
     .		slox, shix, sloy, shiy, sloz, shiz,
     .		slot, shit, sloe, shie, slof, shif,
     .		dlox, dhix, dloy, dhiy, dloz, dhiz, 
     .		dlot, dhit, dloe, dhie, dlof, dhif

	REAL    src( slox:shix,sloy:shiy,sloz:shiz,slot:shit,sloe:shie,slof:shif ),
     .		dst( dlox:dhix,dloy:dhiy,dloz:dhiz,dlot:dhit,dloe:dhie,dlof:dhif )

* internal variable declarations:
	INTEGER	loi, loj, lok, lol, lom, lon, hii, hij, 
     .		hik, hil, him, hin, i, j, k, l, m, n, idim
	INTEGER	lo(nferdims), hi(nferdims), ii(nferdims)
	EQUIVALENCE
     .		(lo(1), loi), (hi(1), hii),
     .		(lo(2), loj), (hi(2), hij),
     .		(lo(3), lok), (hi(3), hik),
     .		(lo(4), lol), (hi(4), hil),
     .		(lo(5), lom), (hi(5), him),
     .		(lo(6), lon), (hi(6), hin)

* local parameter declarations
	INTEGER	i_ax, j_ax, k_ax, l_ax, m_ax, n_ax
	PARAMETER  (i_ax=1, j_ax=2, k_ax=3, l_ax=4, m_ax=5, n_ax=6)

* 1/00 *kob* -  the below code was used to upgrade permute_sub.F for
*		v5.30.  However, a bug in the DEC optimizer caused the
*		loop to be unrolled incorrectly, leading to improper
*		results.  It's in included here so as not to lose it, 
*		but stuck in an ifdef which shouldn't be accessed.
* 3/12 * resurrect this code. Much simpler than the replacement code.

	EQUIVALENCE
     .		(ii(1), i),
     .		(ii(2), j),
     .		(ii(3), k),
     .		(ii(4), l),
     .		(ii(5), m),
     .		(ii(6), n)

* initialize - save loop limits as unsubscripted variables
	DO 100 idim = 1, nferdims
	   lo(idim) = cx_lo_ss(src_cx,idim)
	   hi(idim) = cx_hi_ss(src_cx,idim)
 100	CONTINUE

	DO 200  n = lon, hin
	DO 200  m = lom, him
	DO 200  l = lol, hil
	DO 200  k = lok, hik
	DO 200  j = loj, hij
	DO 200  i = loi, hii
	   dst(ii(perm(1)),ii(perm(2)),ii(perm(3)),ii(perm(4)),
     .	       ii(perm(5)),ii(perm(6))) =
     .		src(i,j,k,l,m,n)
 200	CONTINUE

	RETURN
	END 

	SUBROUTINE TM_MAKE_DYN_LINE(idim, lo, hi, del,
     .					units, modulo, mod_len,
     .					outline, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Create a dynamic (always) line base on the input description
* To create a dynamic line that is based on another line use
* TM_GET_LIKE_DYN_LINE, instead
* Will create a line description based on the input arguments and
* compare it to other line definitions in common. Unlike
* tm_get_like_line (and unlike TM_GET_LIKE_DYN_GRID) this will check
* dynamic lines (only).
* If there is a match then "outline" returns with the number of the match.
* If there is no match, then a new dynamic line is created.
* "outline" returns with the number of the new dynamic line.

* created 1/98 *sh* - based on tm_get_like_dyn_line
* V532 5/01 *sh* - eliminate (annoying) warning message about unknown units
* V541 2/01 *sh* - added support for line_modulo_len
* 1/03 - *kob* g77 port - Need to use risc_buff for arbitrary concatenations
* V580 9/04 *acm* - if units not given, assign general X or Y direction rather 
*                   than WE or SN
* V600 *acm* 2/06 - Fix for bug 1394, send do_err flag to TM_DATE_REFORMAT
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing
* v694 1/15 *acm* (see ticket 2227) handle the line_dim_only flag

* Arguments
	LOGICAL		modulo
	INTEGER		idim, outline, status
	REAL*8		lo, hi, del, mod_len
	CHARACTER*(*)	units

* argument description:
* in	idim	  - axis orientation: 1-nferdims
* in	units	  - units string for axis (max 16 characters)
*		    used when labeling the axis
*		    if creating a time axis format should be
*		    "units since dd-mmm-yyyy:hh:mm:ss" with 
*		    max of 16 characters for the unit string
* in	modulo	  - if creating a modulo axis this is TRUE (untested on 1/98)
* in	lo,hi,del - description of line (note REAL*8)
* out	outline	  - returned line

* INCLUDE FILES
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'implicit.parm'
	include 'tmap_errors.parm'
	include 'xtm_grid.cmn_text'
	include 'xunits.cmn_text'
		include 'xrisc_buff.cmn'

*
* Local definitions
	INTEGER		TM_FIND_LIKE_DYN_LINE,
     .			TM_LENSTR1, TM_UNIT_ID,
     .			inline, iunit, since_T0

	REAL*8 		dp_epsilon
	PARAMETER 	( dp_epsilon = 1.D-10)

* allocate a scratch line 
	CALL TM_ALLO_DYN_LINE( inline, status )
	IF ( status .NE. merr_ok ) RETURN

* initialize
	line_t0(inline)        = char_init20
	line_tunit(inline)     = 0

* basic defaults on the line to be created
	line_parent(inline)    = 0
	line_regular(inline)   = .TRUE.
	line_class(inline)     =  pline_class_basic
	line_direction(inline) = axis_orients(idim)
	line_dim_only(inline)    = .FALSE.

* set user-specified (boolean) modulo flag
	line_modulo(inline)    = modulo		! "TRUE" untested 1/98 !!!
	line_modulo_len(inline) = mod_len

* set user-specified units -- attempting to interpret them (a pain!)
	line_units(inline)     = units
	IF ( idim .EQ. t_dim ) THEN
* ... sloppy check for "since dd-mmm-yyyy" -- misses mixed case "Since"
	   since_T0 = MAX( INDEX(units,'since'), INDEX(units,'SINCE') )
	   IF ( since_T0 .GT. 2 ) THEN
	     line_units(inline) = units(:since_T0-1) ! just the "units" part 
	     IF ( TM_LENSTR1(units) .GT. since_T0 + 5 ) THEN
	       CALL TM_DATE_REFORMAT(units(since_T0+6:),
     .				     pdate_numslashnum, line_t0(inline),
     .                               pdate_vax, .TRUE., status )
	       IF ( status .NE. merr_ok ) GOTO 9000
	     ENDIF
	   ENDIF
	ENDIF

* decode the units - check the validity
	line_unit_code(inline) = 0
	IF ( units .NE. ' ' ) THEN
           line_unit_code(inline) = TM_UNIT_ID( line_units(inline) )
	   iunit = line_unit_code(inline)	
           IF ( iunit .EQ. 0 ) THEN
!	     CALL WARN('unknown axis units: '//units)

             IF (line_direction(inline) .EQ. 'WE'  )
     .           line_direction(inline) = 'XX'
             IF (line_direction(inline) .EQ. 'SN' )
     .           line_direction(inline) = 'YY'
 
	     CONTINUE
	   ELSEIF (iunit .EQ. -5) THEN    ! "-5" is "MONTHS"
	       risc_buff = units
               CALL WARN(risc_buff(:TM_LENSTR1(risc_buff))//
     .			' is ambiguous ... using 1/12 of 365 days.') 
           ELSEIF ( iunit .NE. 0 ) THEN
* ... Issue warning for inappropriate units like HOURS on X ax
*     and render the units unconvertible
             IF (  ( idim.EQ.t_dim .AND.
     .             ( iunit.LT.pun_1st_time.OR.iunit.GT.pun_last_time ) )
     .        .OR. ( idim.NE.t_dim .AND.
     .             ( iunit.LT.pun_1st_len .OR.iunit.GT.pun_last_len  ) )
     .        .OR. ( idim.EQ.z_dim .AND.
     .               iunit.EQ.pun_degrees )  ) THEN     ! 7/96
		risc_buff = units
		CALL WARN
     .               (risc_buff(:TM_LENSTR1(risc_buff))
     .                  //' appear to conflict with orientation:'
     .                  //' no conversions possible')
               line_unit_code(inline) = 0
             ENDIF           
           ENDIF
	ENDIF

* set start, delta, and N
	line_start(inline)     = lo
	line_delta(inline)     = del 
	line_dim(inline)       = INT((hi-lo)/del +dp_epsilon) + 1

* search for this line among the existing, dynamic lines
	outline =  TM_FIND_LIKE_DYN_LINE( inline )

	IF (outline .EQ. unspecified_int4) THEN
* ... doesn't exist yet - make a new dynamic line  "(AXnnn)"
	   CALL TM_ALLO_DYN_LINE( outline, status )
	   IF (status .NE. merr_ok) GOTO 9000
	   CALL TM_COPY_LINE( inline, outline )

* ... name it "(AXnnn)"
	   WRITE ( line_name(outline), 3000 ) outline - max_lines
 3000	   FORMAT('(AX',I3.3,')')		! restricted to 3 digits
	ENDIF

* successful completion
	status = merr_ok

* error and normal exits
 9000	CALL TM_DEALLO_DYN_LINE(inline)
	RETURN
	END

* chdir.F
*
* Change current working directory.
* Contributed by Andrew Wittenberg, Princeton University
* 10/17/01
* Changes by PMEL, to substitute the Ferret routine TM_LENSTR for
* the trim function.

      SUBROUTINE chdir_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      CALL ef_set_desc(id,'Change current working directory.' )
      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_type(id, arg, STRING_ARG)
      CALL ef_set_arg_name(id, arg, 'TO_DIRECTORY')
      CALL ef_set_arg_desc(id, arg, 'desired working directory')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES) 

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE chdir_compute(id, arg_1, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      INTEGER itest, ilen
      CHARACTER arg1_text*160
      INTEGER CHDIR, TM_LENSTR1

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      CALL ef_get_arg_string(id, 1, arg1_text)
      ilen = TM_LENSTR1(arg1_text)

      WRITE(*,*) 'Changing directory to: ',arg1_text(1:ilen)
      itest = CHDIR(arg1_text(1:ilen))


cc original code:
cc      WRITE(*,*) 'Changing directory to: ',trim(arg1_text)
cc      itest = CHDIR(trim(arg1_text))


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

      INTEGER FUNCTION TM_LENSTR1 (line)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine the length of a character string as the position of the last 
* non-blank character
* unlike TM_LENSTR this routine will return a length of 1 (vs. 0) if the string
* is all blanks

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.00 - 05/05/87 - based on TM_LENSTR rev. 0.00
*
* calling argument declarations:
	CHARACTER*(*) line

* internal variable declarations:
	INTEGER	i, mright

* initialize: find highest possible right hand limit of string
	mright = LEN(line)

	DO 100 i = mright,1,-1
	IF (line(i:i) .NE. ' ') GOTO 200
 100	CONTINUE

* for all blanks
	TM_LENSTR1 = 1
	RETURN

* found non-blank
 200	TM_LENSTR1 = i
	RETURN
	END

	CHARACTER*(*) FUNCTION VAR_TITLE_MOD ( cx )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* return title modifications ( including in-plane transformations) for variable

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 4/28/87
* revision 0.1 - 6/25/87 - special remarks added to some derivatives
* revision 0.2 - 8/29/87 - special remarks added only if DT is known
*			   eliminated enclosing parens / "-" between remarks
* revision 0.3 - 9/10/87 - added "using nnn pts" for transforms
*			   and ds_var_modification --> ds_var_titl_mod
* revision 0.31- 10/23/87- "using" --> "by"
* revision 0.4 - 4/4/88  - added remarks about data-set-dependent calculations
* revision 0.4 - 5/5/88  - modified remarks to include QDF and QDFZ
* revision 0.5 - 7/2/88  - remarks about Am and multiple clim. airt fields for
*			   QFLX
* revision 0.6 - 7/25/88 - added regriding
* revision 0.7 - 1/4/89  - added regridding transformations
* V200:  6/2/89 - interchanged order of lo/hi_ss arguments
*		- check in-plane-ness for transforms to display
*	 1/3/89 - mr --> cx
* V230:  1/27/92 - added special string for @WEQ
*        8/18/92 - eliminated string(1:) notation for MAC compatibility
*        8/23/92 - changes to accomodate regridding transforms
* V420:	 9/25/95 - use REGRID_COMMENTS
* V430:  7/96 - pass cx to ALG_TRANS_TITL so it can document 4D transformations
* V455:  9/97 - modify labeling of xforms @CIA,CIB,CDA,CDB to avoid "by n pts"
* V491:  3/98 - crash due to boolean operator precedence error
* V530:  8/00 *sh* - added support for cat_string
* V533:  6/01 *sh* - added transformation @EVNT
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction. 
* V690 *sh* suppress comment about regridding for 1pt 'false regridding'
*       used on  curvilinear variables.  It will be documented in ASCII_LIMITS.
* V698  3/16 *acm* Removed Philander-Seigel code including diagnostic 
*                  variables, pre-defined axes and grids, cat_calc_var.
* V751  8/19 *acm* Special label if it was a regrid-to-DSG

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include	'xdset_info.cmn_text'
	external xdset_info_data
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'instance_table.parm'
	include	'xcontext.cmn'
	include	'xalgebra.cmn'
	include	'xtext_info.cmn'

* calling argument declarations
	INTEGER cx

* internal variable declarations
	LOGICAL	TM_ITSA_DSG, add_on, all_q, vcalc, false_regrid, its_dsg
	INTEGER	TM_LENSTR, TM_LENSTR1, CX_DIM_LEN, TM_DSG_DSET_FROM_GRID,
     .		var, categ, dset, cairt, cairt_dset,
     .		mlen, t_len, maxlen, idim, trans, slen, k_lo
	CHARACTER ALG_TRANS_TITL*20, TM_FMT*48,
     .		REGRID_COMMENTS*64, CD_DSG_FEATURENAME*20,
     .          trans_title*40, buffer*24, dummy*256

* initialize
	var     = cx_variable( cx )
	categ   = cx_category( cx )
	dset    = cx_data_set( cx )
	maxlen  = LEN( VAR_TITLE_MOD )

* begin with stored title modification string
	IF     ( categ .EQ. cat_file_var ) THEN
	   var_title_mod = ds_var_titl_mod( var )
	ELSE
	   var_title_mod = ' '
	ENDIF
	IF ( categ .EQ. cat_string ) RETURN

* length so far
	mlen = TM_LENSTR( var_title_mod )
	add_on = mlen .GT. 0
	mlen = MAX( 1, mlen )		! avoid zero len string errors

* add axis name to pseudo variables
	IF ( categ .EQ. cat_pseudo_var ) THEN
	   idim = MOD( var-1, 6 ) + 1
	   var_title_mod = 'axis '//line_name(grid_line(idim, cx_grid(cx)))
	ENDIF

* add remarks about in-plane transformations
	DO 100 idim = 1, nferdims
	   trans = cx_trans( idim, cx )
	   IF ( trans .NE. trans_no_transform
     .	  .AND. trans .LT. trans_compress_code 
     .	  .AND. CX_DIM_LEN(idim,cx) .GT. 1 ) THEN
	      IF ( add_on ) THEN
	         var_title_mod = var_title_mod(:mlen) //' - '
	         mlen = MIN( maxlen, mlen + 3 )
	      ELSE
	         add_on = .TRUE.
	      ENDIF
	      trans_title = ALG_TRANS_TITL( trans, cx )
	      t_len = TM_LENSTR1( trans_title )
	      IF ( cx_trans( idim, cx ) .EQ. trans_wgted_eq ) THEN
                 trans_title = trans_title(:t_len)//' of '//
     .                TM_FMT( cx_trans_arg(idim,cx), 4, 12, slen )
                 t_len = t_len + 4 + slen
	      ELSEIF ( cx_trans( idim, cx ) .EQ. trans_event_mask ) THEN
                 trans_title = trans_title(:t_len)//' at '//
     .                TM_FMT( cx_trans_arg(idim,cx), 4, 12, slen )
                 t_len = t_len + 4 + slen
	      ELSEIF ( cx_trans_arg( idim, cx ) .NE. bad_val4 ) THEN
	         IF ( trans .GE. trans_nrst_dist_abv
     .        .AND.   trans .LE. trans_nrst_indx_blw ) GOTO 95	!9/97 @CIA trap
* ... add "by nnn pts"
	         trans_title = trans_title(:t_len)//' by '//
     .			TM_FMT( cx_trans_arg(idim,cx), 4, 8, slen )
	         t_len = t_len + 4 + slen
	         trans_title = trans_title(:t_len)//' pts'
	         t_len = t_len + 4
	      ENDIF
 95	      var_title_mod = var_title_mod(:mlen) // trans_title(:t_len) //
     .		' on ' // ww_dim_name( idim )
	      mlen = MIN( maxlen, mlen+t_len+5 )
	   ENDIF
 100	CONTINUE

* re-gridded ?
*    ... check for 'false 1pt regrid'
	false_regrid = .FALSE.
	DO idim = 1, nferdims
	   IF (cx_aux_stat(idim,cx) .EQ. paux_stat_false_1pt_regrid)
     .		false_regrid = .TRUE.
	ENDDO
	IF (   cx_unstand_grid(cx)
     .	 .AND. .NOT.false_regrid ) THEN
	   IF ( add_on ) THEN
	      var_title_mod = var_title_mod(:mlen) //' - '
	      mlen = MIN( maxlen, mlen + 3 )
	   ELSE
	      add_on = .TRUE.
	   ENDIF

*    ... special label if it was a regrid-to-DSG
	   IF ( TM_ITSA_DSG(cx_grid(cx))  ) THEN
	      dset = TM_DSG_DSET_FROM_GRID(cx_grid(cx))
	      buffer = CD_DSG_FEATURENAME(dsg_orientation(dset))
	      slen = TM_LENSTR1( buffer )
	      
	      dummy = 'regrid: to '//buffer(:slen)//' DSG grid'
	      var_title_mod =  var_title_mod(:mlen)//'regrid: to '//buffer(:slen)//' DSG grid'
	      slen = slen + 13

  	  ELSE
	      dummy = REGRID_COMMENTS(cx, slen)

*    ... This catches more cases of regrid-to-dsg, but doesn't relabel regrid from dsg
*    ... to fixed time or z axis

              IF (TM_DSG_DSET_FROM_GRID(cx_grid(cx)) .GT. pdset_irrelevant .AND. .NOT.its_dsg) THEN
	         IF (INDEX(dummy, ' on E') .GT. 0) THEN 
	            dset = TM_DSG_DSET_FROM_GRID(cx_grid(cx))
	            buffer = CD_DSG_FEATURENAME(dsg_orientation(dset))
	            slen = TM_LENSTR1( buffer )
	            dummy = 'regrid: to '//buffer(:slen)//' DSG grid'
	            var_title_mod =  var_title_mod(:mlen)//'regrid: to '//buffer(:slen)//' DSG grid'
	            slen = slen + 13
	         ELSE
	            var_title_mod =  var_title_mod(:mlen)//'regrid: '//dummy
		 ENDIF
	      ELSE
	         var_title_mod =  var_title_mod(:mlen)//'regrid: '//dummy
	      ENDIF


	  ENDIF
	   mlen = MIN( maxlen, mlen + 8 + slen )
	ENDIF

* signal if the string has been truncated for being too long
	IF ( mlen .EQ. maxlen ) VAR_TITLE_MOD(maxlen:maxlen) = '*'

* clean up
	IF ( VAR_TITLE_MOD .EQ. ' ' ) THEN
	   RETURN

* ... complication from avoiding zero length strings above
	ELSEIF ( VAR_TITLE_MOD(1:1) .EQ. ' ' ) THEN
	   VAR_TITLE_MOD = VAR_TITLE_MOD(2:maxlen)
	   mlen = mlen - 1
	ENDIF

	RETURN
	END

	SUBROUTINE PARSE_COMMAND (  cmnd_buff,
     .				   max_words, max_quals,
     .				   cmnd_len, cmnd_num, subcmnd_num,
     .				   num_quals, qualifier_list,
     .				   qual_start, qual_end,
     .				   num_args, arg_start, arg_end,
     .				   err_lun, reverify, arg1_quoted, status )


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* decode a command line into command, subcommand, qualifiers and arguments

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/24/86
* revision 0.1 - 3/4/87  - changed /star to /@
* revision 0.2 - 5/13/87 - errors processed via ERRMSG
* revision 0.3 - 3/23/88 - bug in quotation mark processing (/T="17-AUG-1982")
* revision 0.4 - 7/28/88 - treat "[" similar to '"' -  allowing commmas as in
*			   TEMP[D=1,G=U] 
* V200:  12/8/89 - correctly handle tabs and spaces preceding ! comment
* 	  2/8/90 - fill in command alias, if any
* Unix/RISC port - 1/91 - cant use "/star" in documentation
*                 10/91 - added TM_LEGAL_NAME for improved syntax checks
*!! removed - doesn't work !! - checked for buffer overflow
* V230:  6/26/92 - commands, subcommands, and qualifiers 4-->8 characters
*         8/4/92 - bug fix:  message "yy" ,xx --> error: unpaired quotation ...
*                          - formalized handling of quotations (see comments)
* V300: 2/3/93 - check for semicolons and parens in command groups
*      4/20/93 - "go back" and start again after alias substitution
*	          allowing command groups or other aliases in an alias
*      4/21/93 - replace "$n" arguments in GO command lines
*	       - ignore semicolons inside of quotation marks
*       5/6/93 - lots of little stuff for dollar argument subst incl "reverify"
* V301:2/25/94 - bug fix: num_args wrong if "/"'s follow args inside other args
* V314:8/18/94 *kob* IBM port - MATCH4 should be defined as logical
* V400: 3/20/95 - call REPL_EXPRNS to evaluated any grave accent-enclosed
*		  expressions as a part of command parsing.
*		  Added argument "memory".
*	 6/2/95  - substitute (PLOT+) symbols prior to any other parsing
* V420:10/26/95 - Avoid paren removal when line begins with "($name)"
*		- do not allow ":" to end a word (e.g. "/xlimits=12: 16")
*		- make sure "()" is retained as a single word
*       11/3/95 - allow \ to escap !,`,/ and ;	! removed quotes *kob* 12/96
*		- improve parsing to accomodate nested [] and ()
*	4/25/96 - for IF and ELIF commands only evaluate grave accents in the
*		  up to the first command argument (others will be evaluated
*		  when the sub-clause of the IF is evaluated.
* V430: 6/11/96 - Ignore "yes?" at start of command
* Linux Port - 12/96 *kob
*	     - had to close open quotes in above comment line - linux f77
*	       was freaking out because of it...
*	     - added ifdef check for double slash because f90/linux didn't
*	       need two of them together for escapes
* v4.91 12/97 *kob* - added parameter decl. for local_max_arg_list to use as
*                     number of elements for itsa_qualifer logical array
* V500 *sh* 4/99 - Increased nsubst_passes to 100 for detecting recursion
*		- so large numbers of grave accents can be in a single line
* V530 *sh* 10/00 - modify so that symbols inside of REPEAT loops get
*	translated inside of the loop (keep copy of input in risc_buff)
*	*sh* 3/01 - added arg1_quoted to indicate if the first arg in the list
*		has enclosing quotes - and avoid calling PARSE_COMMA_LIST
* V531 *sh* 4/01 - added continuation lines
* V533 *sh* 7/01 - allow both single and double quotes
* v541 *acm* 3/02 -bug fix; nested repeat loops, parsing parentheses in the command.
*                  Make another copy of cmnd_buff AFTER removal of enclosing parens
* 2/03 *kob* - g77 port - g77 won't allow intrinsic functions in PARAMETER
*                         statements.  use an octal constant instead
* V552 *acm* 6/03  The v541 fix noted above introduced bug in symbol substitution
*                  within REPEATS: yes? def sym a 0; rep/i=1:3 (def sym a `i`; say ($a))
*                  Fix in saving cmnd_copy.  Bugs 376 and 558 fixed.
* V600 *acm* 3/06  fixing bugs 439&1390, pass cmnd_num to repl_exprns so we can decide
*                  if the command is an action command, and so whether to apply command
*                  context to grave-accent expressions.
* v603 *acm* 5/07  fix bug 919; null symbol entered as the command produced an error;
*                  the fix is to return at statement 500 if word_num = 0
* v612 *acm* 7/08  Fix bug 1583: precision of grave-accent expressions upped from 5 to 7.
* v62  *acm*11/08  Fix bug 1608: semicolon inside double quotes.
* V68  *acm* 3/12  For double-precision Ferret, let the precision of grave-accent 
*                  expressions increase to 14.
* V68  *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V68  *acm* 7/12 return 16 digits by default for grave-accent expressions
* V685+ *acm* 12/13  bounds checking: dont refer to parts of the string outside its bounds.
* V693 *sh* 12/14 moved arg_start/end inits into PARSE_COMMAND (housekeeping)
*	          Changes in GET_FERRET_CMND simplify this routine:
*                   1) comments are never passed into this routine
*                   2) nor "yes? " or "...? "
*                   3) continuation lines are assembled before getting here
*                 Also added support for _DQ_ style of quotation marks
*      *acm*  2/15 Prevent run-time errors in string length for _DQ_ handling
* V695 *acm*  3/15 Ticket 2245: if no arguments on a REPEAT command, exit gracefully.
* V698 *sh*  12/15 avoid the need to surround filenames with slashes in quotes
*	           Applies to SET DATA, GO, SAY, DEFINE SYM and DEFINE DATA/AGG
*		   The first non-qualifier following a qualifier terminates
*                  parsing of qualifiers, supporting
*		       DEFINE DATA/AGG name = /path/filename, 
*                  Specific hacks for SET DATA (& DEFINE SYM) and GO
* V697 12/15 *acm* Ticket 2337 Increase length of cmnd buffer to 20480.
*                  change to echo back only the first part of the command on error.
* V697  1/16 *acm* ticket 2356: Allow multiple slashes in command-line between qualifiers.
* V697  2/16 *acm* DO NOT Increase length of cmnd buffer to 20480
*                  but keep the other changes at that time, echo back only the 
*                  start of command on an error
* V697  3/16 Ticket 2376: parsing backslash escapes within repeat loops.
* V697  3/16  *acm* ticket 2356 scale back change for multiple slash at end of command
* V73   7/17  *acm* ticket 2551 Report an error for unmatched parentheses in a REPEAT loop.
* V75   4/19  *acm* Issue   660 Evaluate a grave-accent expression that appears right after
*                               a slash in the position of a qualifier
* V76  11/19  *acm* Issue  1963  Check for too-short abbreviations of qualifiers, e.g.
*                  /T= for /TITLE is interpreted as a possible time qual in 
*                  evaluating grave-accent expressions.
*                  /TITLE= is the only known case of this potential conflict, could expand
*                  the too-shortness from 1 to MIN(
* V76  12/19 *acm* ticket 1963, Replace one-letter qualifiers with what is
*                  being used (so /T for /TITLE isn't misinterpreted elsewhere).
* V76   4/20 *acm* ticket 756. If the whole command is a symbol, evaluate it and
*                  start the parsing over.

* command, subcommand and qualifiers will be identified by number in
*	 COMMON/XCOMMAND.  Arguments will be returned as positions in
*	 the command buffer
* command syntax:
*	COMMAND_NAME [/QUALx/QUALy...] [SUBCOMMAND] [ARGUMENTa ARGUMENTb ...]
*
*	qualifiers may be anywhere preceeding the first argument
*	arguments are separated by spaces or tabs unless = or comma is present
*	SUBCOMMAND is optional
*	quotes may surround any group of characters that is to be regarded as a
*	single argument
 
* note: arrays arg_start and arg_end must be large enough to accomodate the
*	sum of command, subcommand, qualifiers and args since they are used
*	for working storage

* note: quotations (8/92): quotation mark pairs will be interpreted either
*       as surrounding quotes or as embedded quotes depending on whether the
*       quote marks are both the starting and ending characters of the "word".
*       For surrounding quotes the word start/end will exclude the quotes.

        IMPLICIT NONE
* declare calling arguments of SUBROUTINE
	LOGICAL		reverify, arg1_quoted
	CHARACTER*(*)	cmnd_buff
	INTEGER		max_words,max_quals,cmnd_len,cmnd_num,subcmnd_num,
     .			num_quals,qualifier_list(max_quals),
     .			qual_start(max_quals), qual_end(max_quals),
     .			num_args,arg_start(max_words),arg_end(max_words),
     .			err_lun,status

	include	'tmap_dims.parm'
	include	'errmsg.parm'
	include	'ferret.parm'
	include	'command.parm'
	include 'xcommand.cmn'
	include 'xcontrol.cmn'
	include 'xvariables.cmn'	! for num_uvars_in_cmnd
        include 'xrisc.cmn'

* local variable declarations:
*
**kob*12/97!!! NOTE:local_max_arg_list must match max_arg_list in xprog_state
        INTEGER local_max_arg_list
        PARAMETER (local_max_arg_list = 128)

* modified def of MATCH4 from INTEGER to LOGICAL *kob* IBM port 8/94
	LOGICAL	TM_LEGAL_NAME, known_qualifier, atsin_qualifier,
     .          doub_quote, DQ_quote, a_qual_found, look_for_quals,
     .		surround_quote, surround_DQ_, end_DQ_, subst, first_paren,
     .          itsa_qualifier(local_max_arg_list), 
     .          MATCH4, escape, apply_cx, ptrslash, i3_ok,
     .		its_set_data, its_define_sym, its_go, its_say,
     .		has_lead_white_space, found_white_space, expnd_qual, restart
	INTEGER TM_LENSTR, STR_UPCASE
	INTEGER	buff_len, bang_position, ptr, quote_end,
     .		word_num, look_ahead, look_back, isub_word, csgo,
     .		isubcmnd_ptr, iword, last_qual, iqual_word, iterm,
     .		iqual, iqual_ptr, iarg, i, ii, nparen, nsubst_passes,
     .		grave_start, grave_end, in, out, nest,
     .		paren_level,len_test,len_mchars, current_words,
     .		last_recognized_word, white_aftr_cmnd, white_aftr_subcmnd,
     .		ngone, ir, ic
	CHARACTER c1*1
	CHARACTER url_buff*2048

* local parameter declarations:
	INTEGER		grave_digits
	CHARACTER*1	tab
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
#else
	PARAMETER     ( tab = CHAR(9) )
#endif
        PARAMETER ( grave_digits = 16 )

* intialize
	grave_start	= 1
	nsubst_passes   = 0
	reverify	= .FALSE.
	arg1_quoted	= .FALSE.
	status 		= ferr_ok
	buff_len	= LEN ( cmnd_buff )
 5	ptr		= 1		! current position in cmnd_buff
	word_num	= 0		! current "word" in cmnd_buff
	num_quals	= 0
	num_args	= 0
	cmnd_num 	= 0		! in case of comment line
	cmnd_buff (buff_len:buff_len) = ' '	! always end with blank
	a_qual_found	= .FALSE.
	look_for_quals	= .TRUE. 
	white_aftr_cmnd = buff_len
	white_aftr_subcmnd = buff_len

* inits moved into this code from get_ferret_command (housekeeping)
        DO i = 1, local_max_arg_list
           arg_start(i) = 0
           arg_end(i) = 0
	ENDDO

* full length of text
	cmnd_len = TM_LENSTR (cmnd_buff)

* ignore trailing slashes in parsing (further fix for ticket 2356)

	IF (cmnd_len .GE. 2) THEN
	DO WHILE (cmnd_buff(cmnd_len-1:cmnd_len) .EQ. '//' .AND. cmnd_len.GT.2)
	   cmnd_len = cmnd_len-2
	   IF (cmnd_len .LE. 1) GOTO 6
	ENDDO
	ENDIF
 6	CONTINUE

* save a copy of the command with untranslated symbols for use by REPEAT
* and for building the complete command when continuation lines are used.

	cmnd_copy = cmnd_buff
	len_cmnd_copy = cmnd_len

* * * * * * * * *
* remove parens enclosing entire command or command group
* modified 10/95 to protect "($name) at line start
 20     IF (cmnd_len .GT. 1) THEN
 	IF (cmnd_len .GT. cmnd_copy_len) GOTO 5005

	   IF( cmnd_buff(1:1) .EQ. '(' 
     .	 .AND. cmnd_buff(2:2) .NE. '$'
     .   .AND. cmnd_buff(cmnd_len:cmnd_len) .EQ. ')' ) THEN
              cmnd_buff(1:1) = ' '
              cmnd_buff(cmnd_len:cmnd_len) = ' '
              CALL LEFT_JUST( cmnd_buff(1:cmnd_len),
     .                        cmnd_buff(1:cmnd_len), cmnd_len )
           ENDIF
           DO WHILE (cmnd_buff(cmnd_len:cmnd_len) .EQ. '/' .AND. cmnd_len.GT.1)
	      cmnd_len = cmnd_len-1
	   ENDDO
        ENDIF

* Again save a copy of the command with untranslated symbols for use by REPEAT
* this time without enclosing parens.

        IF (len_cmnd_copy .GT. 1) THEN
	   IF( cmnd_copy(1:1) .EQ. '(' 
     .	 .AND. cmnd_copy(2:2) .NE. '$'
     .   .AND. cmnd_copy(len_cmnd_copy:len_cmnd_copy) .EQ. ')' ) THEN
              cmnd_copy(1:1) = ' '
              cmnd_copy(len_cmnd_copy:len_cmnd_copy) = ' '
              CALL LEFT_JUST( cmnd_copy(1:len_cmnd_copy),
     .                        cmnd_copy(1:len_cmnd_copy), len_cmnd_copy)
           ENDIF
           DO WHILE (cmnd_copy(len_cmnd_copy:len_cmnd_copy) .EQ. '/' 
     .               .AND. len_cmnd_copy.GT.1)
	      len_cmnd_copy = len_cmnd_copy-1
	   ENDDO
        ENDIF


* * * * * * * * *
* process semicolon-separated command group  (2/93)
* "REPEAT/L=lo:hi (command1;command2)"  is a single command (at this stage) but
* "command1;command2" and "(command1;command2)" are command groups
        IF ( INDEX(cmnd_buff(1:cmnd_len),';') .GT. 0 ) THEN
* ... it is a command group if there is a ";" NOT enclosed in parens
           nparen = 0
           surround_quote = .FALSE.
	   surround_DQ_   = .FALSE.
           DO 60 i = 1, cmnd_len
	      i3_ok = i+3 .LT. cmnd_len
	      c1 = cmnd_buff(i:i)
              IF ( c1 .EQ. '(' ) THEN
                 nparen = nparen + 1
              ELSEIF ( c1 .EQ. ')' ) THEN
                 nparen = nparen - 1
              ELSEIF ( c1 .EQ. '"' ) THEN
                 IF (.NOT.surround_DQ_)
     .			surround_quote = .NOT.surround_quote
              ELSEIF ( i3_ok
     .          .AND. cmnd_buff(i:i+3) .EQ. p_DQ_quote ) THEN
                 IF (.NOT.surround_quote)
     .			surround_DQ_   = .NOT.surround_DQ_
              ELSEIF ( c1 .EQ. ';' ) THEN
	         escape = i.GT.1
#ifdef NO_DOUBLE_ESCAPE_SLASH
	         IF (escape) escape = cmnd_buff(i-1:i) .EQ. '\;'
#else
	         IF (escape) escape = cmnd_buff(i-1:i) .EQ. '\\;'
#endif
                 IF ( nparen.EQ.0
     .		.AND. .NOT.escape
     .		.AND. .NOT.surround_DQ_
     .		.AND. .NOT.surround_quote ) THEN
                    cmnd_num = cmnd_semicolon
                    GOTO 1000   ! successful exit
                 ENDIF
              ENDIF
 60        CONTINUE
        ENDIF

* * * * * * * * *
* substitute GO command arguments, if any
* and return to re-process command if substitution occurs (4/93)
* Note: could have been done as a command stack operation ... maybe cleaner 
	nsubst_passes = nsubst_passes + 1 ! guard against recursion (4/93)
	IF ( nsubst_passes .GT. 100 ) GOTO 5060
	IF ( cs_in_control ) THEN
	   IF ( INDEX(cmnd_buff(:cmnd_len),'$') .GT. 0 ) THEN
* ... search backwards for a GO command in charge of the command stack
	      DO 92 csgo = csp, 1, -1
	         IF ( cs_cmnd_num(csgo) .EQ. cmnd_go ) THEN
	            CALL DOLLAR_COMMAND( cmnd_buff, cmnd_len,
     .			  	         cs_text(csgo), subst, status )
	            IF ( status .NE. ferr_ok ) GOTO 5000	
		    IF ( subst ) THEN
			reverify = .TRUE.      ! informational echo needed
			GOTO 20   ! back for recursive substitutions
		   ENDIF
	         ENDIF
 92	      CONTINUE
	   ENDIF
	ENDIF

* * * * * * * * *
* substitute symbols (PLOT+ symbols expressed as "($symname)" ), if any (6/95)
* and return to re-process command if substitution occurs
        
* If the whole command was a symbol, evaluate that and then start all over.
	restart = cmnd_buff(1:1) .EQ. '(' 
     .	    .AND. cmnd_buff(2:2) .EQ. '$'
     .	    .AND. cmnd_buff(cmnd_len:cmnd_len) .EQ. ')'

	CALL SYMBOL_COMMAND( cmnd_buff, cmnd_len, subst, status )
	IF (cmnd_len .GT. cmnd_copy_len) GOTO 5005
	IF ( status .NE. ferr_ok ) GOTO 5000
	IF ( subst ) THEN
	   reverify = .TRUE.       ! informational echo needed
	   IF (restart .AND. cmnd_len.GT.1) GOTO 5 
	   GOTO 20   ! back for more substitutions
	ENDIF

* * * * * * * * *
* substitute command alias, if any
* and return to re-process command if substitution occurs (4/93)
* Note: could have been done as a command stack operation ... maybe cleaner 
         CALL ALIAS_COMMAND( cmnd_buff, cmnd_len, *20 )

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
* parser: break up command into "words" storing start and end locations
* "words" are separated by blank, tab, "/" or " but not by comma or =
* 10/95 - words are also not separated by ":"
 100	CONTINUE

* skip blanks preceeding word
	has_lead_white_space = .FALSE.
	DO 110 ptr = ptr, cmnd_len
	   IF (      cmnd_buff(ptr:ptr) .NE. ' '
     .	       .AND. cmnd_buff(ptr:ptr) .NE. tab ) GOTO 200
	   has_lead_white_space = .TRUE.
 110	CONTINUE
	GOTO 500		! end of command buffer - no more words

* we have another word in the buffer.  Is this word a qualifier ?
* 12/15 - cease hunt for qualifiers when a non-qual follows qualifiers
 200	IF ( word_num .EQ. max_words ) GOTO 500
	word_num 	= word_num + 1
	IF  ( has_lead_white_space ) THEN
	   IF (ptr .LT. white_aftr_cmnd 
     .   .AND. word_num .GT. 1  ) white_aftr_cmnd = ptr-1 ! GO hack
	   IF (ptr .LT. white_aftr_subcmnd 
     .   .AND. word_num .GT. 2  ) white_aftr_subcmnd = ptr-1 ! SET DATA hack
	ENDIF
	IF ( look_for_quals .AND. cmnd_buff(ptr:ptr).EQ.'/' ) THEN
	   itsa_qualifier(word_num) = .TRUE.
	   a_qual_found = .TRUE.
	   ptr = ptr + 1		! jump over "/"

* Skip over multiple / in a row. (ticket 2356)
* (Not allowing for all possible combinations of spaces and slashes)

	   DO WHILE (cmnd_buff(ptr:ptr) .EQ. '/' .AND. ptr.LT.cmnd_len)
	      ptr = ptr+1
	   ENDDO

*	skip blanks between "/" and text of word
	   DO 210 ptr = ptr, cmnd_len
		IF (      cmnd_buff(ptr:ptr) .EQ. '/' ) GOTO 5050
		IF (      cmnd_buff(ptr:ptr) .NE. ' '
     .		    .AND. cmnd_buff(ptr:ptr) .NE. tab ) GOTO 300
 210	   CONTINUE
	   word_num = word_num - 1
	   GOTO 500			! ignore "/" at end of buffer
	ELSE
	   itsa_qualifier(word_num) = .FALSE.
	   IF (a_qual_found) look_for_quals = .FALSE.
	ENDIF

* we have found the start of a word - initialize variables
 300    arg_start (word_num) = ptr
        surround_quote = .FALSE.
	surround_DQ_   = .FALSE.

* start searching for the end of the word: blank or tab
* include as a block (i.e. skip over) quoted text 
 400	CONTINUE  ! ============= TOP OF LOOP

* Define a logical to stay away from cmnd_buff(ptr-1:ptr-1) when ptr = 1
           ptrslash = .FALSE.
	   IF (ptr .GT. 1) THEN
#ifdef NO_DOUBLE_ESCAPE_SLASH
	      IF ( cmnd_buff(ptr-1:ptr-1) .EQ. '\' ) ptrslash = .TRUE.
*                            '  closing single quote to make emacs happy
#else
	      IF ( cmnd_buff(ptr-1:ptr-1) .EQ. '\\' ) ptrslash = .TRUE.
#endif
           ENDIF
	   IF (ptrslash) THEN
	      GOTO 410
           ELSEIF ( cmnd_buff(ptr:ptr) .EQ. '"'  ) THEN
* ... double quote - skip past entire quotated string
              surround_quote = ptr .EQ. arg_start(word_num)
              DO i = ptr+1, cmnd_len
#ifdef NO_DOUBLE_ESCAPE_SLASH
                IF ( cmnd_buff(i-1:i-1) .EQ. '\'  ) CYCLE  ! ' for emacs
#else
                IF ( cmnd_buff(i-1:i-1) .EQ. '\\' ) CYCLE
#endif
                IF (cmnd_buff(i:i).EQ.'"' ) THEN
	          ptr = i
                  quote_end = ptr
                  GOTO 410
                ENDIF
	      ENDDO
              GOTO 5010
           ELSEIF ( cmnd_buff(ptr:ptr) .EQ. "'"  ) THEN
* ... single quote - skip past entire quotated string
              DO ptr = ptr+1, cmnd_len
#ifdef NO_DOUBLE_ESCAPE_SLASH
                IF ( cmnd_buff(ptr-1:ptr-1) .EQ. '\'  ) CYCLE  ! ' for emacs
#else
                IF ( cmnd_buff(ptr-1:ptr-1) .EQ. '\\' ) CYCLE
#endif
                IF (cmnd_buff(ptr:ptr).EQ."'" ) GOTO 410
	      ENDDO
              GOTO 5010
           ELSEIF ( cmnd_buff(ptr:ptr) .EQ. '_'  
     .	      .AND. ptr+3 .LE. cmnd_len           ) THEN
	      IF (cmnd_buff(ptr:ptr+3) .EQ. p_DQ_quote) THEN
* ... _DQ_ quote - skip past entire quotated string
                 surround_DQ_ = ptr .EQ. arg_start(word_num)
                 DO i = ptr+4, cmnd_len
                    IF (cmnd_buff(ptr:ptr).EQ.'_' 
     .            .AND. i+3 .LE. cmnd_len           ) THEN
	               IF (cmnd_buff(i:i+3) .EQ. p_DQ_quote) THEN
	                  ptr = i + 3
                          quote_end = ptr
                          GOTO 410
	               ENDIF
                    ENDIF
	         ENDDO
                 GOTO 5010
	      ELSEIF (cmnd_buff(ptr:ptr+3) .EQ. p_SQ_quote) THEN
* ... _SQ_ quote - skip past entire quotated string
                 DO i = ptr+4, cmnd_len
                    IF (cmnd_buff(ptr:ptr).EQ.'_' 
     .            .AND. i+3 .LE. cmnd_len           ) THEN
	               IF (cmnd_buff(i:i+3) .EQ. p_SQ_quote) THEN
	                  ptr = i + 3
                          GOTO 410
	               ENDIF
                    ENDIF
	         ENDDO
                 GOTO 5010
	      ENDIF
	      GOTO 410   ! this underscore was not part of _DQ_ or _SQ_
	   ELSEIF ( cmnd_buff(ptr:ptr) .EQ. '`' ) THEN
* ... grave accent - skip past entire immediate mode expression
	      DO 402 ptr = ptr+1, cmnd_len
#ifdef NO_DOUBLE_ESCAPE_SLASH
	         IF ( cmnd_buff(ptr-1:ptr-1) .EQ. '\'  ) GOTO 402
*                            '  closing single quote to make emacs happy
#else
	         IF ( cmnd_buff(ptr-1:ptr-1) .EQ. '\\' ) GOTO 402
#endif
	         IF ( cmnd_buff(ptr:ptr) .EQ. '`' ) GOTO 410
 402	      CONTINUE
	      GOTO 5010
	   ELSEIF ( cmnd_buff(ptr:ptr) .EQ. '[' ) THEN
* ... embedded bracket - find matching right bracket
	      nest = 1
	      DO 403 ptr = ptr+1, cmnd_len
#ifdef NO_DOUBLE_ESCAPE_SLASH
	         IF ( cmnd_buff(ptr-1:ptr-1) .EQ. '\'  ) GOTO 403
*                            '  closing single quote to make emacs happy
#else
	         IF ( cmnd_buff(ptr-1:ptr-1) .EQ. '\\' ) GOTO 403
#endif
	         IF ( cmnd_buff(ptr:ptr) .EQ. '[' ) THEN
	            nest = nest + 1
	         ELSEIF ( cmnd_buff(ptr:ptr) .EQ. ']' ) THEN
	            nest = nest - 1
	            IF ( nest .EQ. 0 ) GOTO 410
	         ENDIF
 403	      CONTINUE
	      GOTO 5010
	   ELSEIF ( cmnd_buff(ptr:ptr) .EQ. '(' ) THEN
* ... embedded paren - find matching right paren (10/95)
	      nest = 1
	      DO 404 ptr = ptr+1, cmnd_len
#ifdef NO_DOUBLE_ESCAPE_SLASH
	         IF ( cmnd_buff(ptr-1:ptr-1) .EQ. '\'  ) GOTO 404
*                            '  closing single quote to make emacs happy
#else
	         IF ( cmnd_buff(ptr-1:ptr-1) .EQ. '\\' ) GOTO 404
#endif
	         IF ( cmnd_buff(ptr:ptr) .EQ. '(' ) THEN
	            nest = nest + 1
	         ELSEIF ( cmnd_buff(ptr:ptr) .EQ. ')' ) THEN
	            nest = nest - 1
	            IF ( nest .EQ. 0 ) GOTO 410
	         ENDIF
 404	      CONTINUE
	      GOTO 5010
	   ELSE
		IF (	  cmnd_buff(ptr:ptr) .NE. ' '
     .		    .AND. cmnd_buff(ptr:ptr) .NE. '/'
     .		    .AND. cmnd_buff(ptr:ptr) .NE. tab ) THEN
                   surround_quote = .FALSE.  ! text outside of quotation
                   GOTO 410
                ENDIF
	   ENDIF

* "/" can be escaped using "\/"
	   IF (ptr .GT. 1) THEN
#ifdef NO_DOUBLE_ESCAPE_SLASH
	      IF (cmnd_buff(ptr-1:ptr) .EQ. '\/') GOTO 410
#else
	      IF (cmnd_buff(ptr-1:ptr) .EQ. '\\/') GOTO 410
#endif
	   ENDIF

* "/" is not a terminator if we are not looking for more qualifiers
	   IF (.NOT.look_for_quals
     .    .AND. cmnd_buff(ptr:ptr) .EQ. '/' ) THEN
	      surround_quote = .FALSE.  ! text outside of quotation
	      GOTO 410
	   ENDIF
	
* probable terminator found - make sure it's not hiding a comma or =
* first check ahead that the next non-blank/tab is not comma or =
* ... also check for ":"
	   DO 405 look_ahead = ptr+1, cmnd_len
	      IF (   cmnd_buff( look_ahead:look_ahead ) .EQ. ' '
     .		.OR. cmnd_buff( look_ahead:look_ahead ) .EQ. tab ) GOTO 405
	      IF (   cmnd_buff( look_ahead:look_ahead ) .EQ. ','
     .		.OR. cmnd_buff( look_ahead:look_ahead ) .EQ. ':'
     .		.OR. cmnd_buff( look_ahead:look_ahead ) .EQ. '=' ) THEN
		   GOTO 410	! no. "," ":" or "=" connects a single "word"
	      ELSE
		   GOTO 406	! all clear ahead - no = or comma
	      ENDIF
 405	   CONTINUE

* now look back to make sure this isn'a a gap following an = or comma
 406	   CONTINUE
           IF (ptr .GT. 1) THEN
           DO 408 look_back = ptr-1, 1, -1
	      IF (   cmnd_buff( look_back:look_back ) .EQ. ' '
     .	      .OR. cmnd_buff( look_back:look_back ) .EQ. tab ) GOTO 408
	      IF (   cmnd_buff( look_back:look_back ) .EQ. ','
     .	      .OR. cmnd_buff( look_back:look_back ) .EQ. ':'
     .	      .OR. cmnd_buff( look_back:look_back ) .EQ. '=' ) THEN
		 GOTO 410	! no  - , or = connects a single "word"
	      ELSE
		 GOTO 420	! yes - we found a terminator
	      ENDIF
 408	   CONTINUE
           ENDIF
		 GOTO 420	! yes - we found a terminator

* manual DO-loop to permit embedded quotation marks
 410	IF ( ptr .LT. cmnd_len ) THEN
	   ptr = ptr + 1
	   GOTO 400
	ENDIF

* end of buffer has been reached with no word terminator - assume the word ends
 415	ptr = cmnd_len + 1

* we have found the end of the word.  
 420    IF ( surround_quote ) THEN
	   arg_start(word_num) = arg_start(word_num) + 1
           arg_end  (word_num) = quote_end - 1
cc  Allow zero-length null string in quotes
           IF ( arg_start(word_num) .GT. arg_end(word_num)+1 ) GOTO 5015
	ELSEIF ( surround_DQ_ ) THEN
	   arg_start(word_num) = arg_start(word_num) + 4
           arg_end  (word_num) = quote_end - 4
cc  Allow zero-length null string in quotes
           IF ( arg_start(word_num) .GT. arg_end(word_num)+1 ) GOTO 5015
	ELSE
	   arg_end (word_num) = ptr - 1
	ENDIF
        IF ( ptr .LT. cmnd_len ) THEN
           GOTO 100                              ! go back for next word
        ELSE
	   GOTO 500				 ! done parsing
        ENDIF

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
* identify the words in the command line	

* +++++++ COMMAND +++++++
* first word must be command name
* legal syntax of command ?  (avoid, e.g., "LISTX=160W")

 500    CONTINUE
        IF ( word_num .EQ. 0 ) RETURN
        IF ( .NOT.TM_LEGAL_NAME(cmnd_buff(arg_start(1):arg_end(1))) )
     .                                                        THEN
           word_num = 1
           GOTO 5025
        ENDIF
* search the list of options
        len_test = TM_LENSTR(cmnd_buff(arg_start(1):arg_end(1)))
	DO 510 cmnd_num = 1, total_num_commands
           len_mchars = TM_LENSTR(commands(cmnd_num)(:4))
	   IF ( MATCH4( cmnd_buff(arg_start(1):arg_end(1)),len_test,
     .			commands(cmnd_num), len_mchars ) )  GOTO 600
 510	CONTINUE
* no matches against known 4 character command names --> error
	GOTO 5020					! error exit

* +++++++ SUBCOMMAND +++++++
* now identify the subcommand (if any) as next non-qualifier word
 600    DO 610 isub_word = 2,word_num
	   IF ( .NOT.itsa_qualifier(isub_word) ) GOTO 620
 610	CONTINUE
* no other words - therefore no subcommand was given
	GOTO 650
* look for a match in the list of subcommands for this command
 620	len_test = 
     .     TM_LENSTR(cmnd_buff(arg_start(isub_word):arg_end(isub_word)))
        DO 630 subcmnd_num = 2, num_subcommands(cmnd_num)
	   isubcmnd_ptr = subcmnd_num + subcommand_pointer(cmnd_num) - 1
           len_mchars = TM_LENSTR(subcommands( isubcmnd_ptr)(:4))
	   IF ( MATCH4( cmnd_buff(arg_start(isub_word):arg_end(isub_word)),
     .                  len_test,
     .			subcommands( isubcmnd_ptr),  
     .                  len_mchars)  ) THEN
* ... legal syntax of subcommand ?  (avoid, e.g., "SET REGION@T")

*     If we passed over part of the command inside the grave accents above,
*     then pass over that part again here.  This allows
*        LET rname = "/x=1:5"; SET REGION`rname` 

              grave_start = INDEX(
     .           cmnd_buff(arg_start(isub_word):arg_end(isub_word)),'`')
              IF (grave_start .EQ. 0) grave_start = arg_end(isub_word)+1
              IF ( .NOT.TM_LEGAL_NAME
     .        (cmnd_buff(arg_start(isub_word):(grave_start-1))) )
     .                                                        THEN
                 word_num = isub_word
                 GOTO 5025
              ELSE
                 GOTO 700
              ENDIF
           ENDIF
 630	CONTINUE
* no matches against known 4 character subcommands --> no subcommand given
 650	isub_word	 = 0		! no subcommand word in cmnd_buff
	subcmnd_num	 = 1		! use "    " as  subcommand
	isubcmnd_ptr = subcommand_pointer(cmnd_num)

* special hacks to allow "SET DATA path/dset" and "GO path/script"
* without quotes surrounding the argument
 700	its_set_data = cmnd_num    .EQ. cmnd_set
     .           .AND. subcmnd_num .EQ. 7
	its_define_sym = cmnd_num    .EQ. cmnd_define
     .           .AND. subcmnd_num .EQ. 8
	its_go  = cmnd_num    .EQ. cmnd_go
	its_say = cmnd_num    .EQ. cmnd_message
	IF (its_go .OR. its_say) THEN
	   last_recognized_word = 1    ! GO and MESSAGE have no subcommand
	ELSE
	   last_recognized_word = 2    ! used by SET DATA and DEF SYM
	ENDIF

* +++++++ QUALIFIERS +++++++
* since "/" may be used for syntax purposes other that qualifiers determine the
* last "/" that is intended as a qualifier.  For example "GO path/script.jnl"
* 12/2015 note: this hack is required because the code above does not identify
* the command and subcommand at the very start and use the word count at that
* point to guide the identification of qualifier slashes.
* locate the final qualifier
	last_qual = word_num
	DO iword = MAX( isub_word+1, 2 ), word_num
	   IF ( .NOT.itsa_qualifier(iword) ) THEN
	      last_qual = iword - 1
	      EXIT
	   ENDIF
	ENDDO
* any so-called qualifiers beyond last_qual are red herrings
* they should own their slash chars, and may not be separate words at all
* note that if there is white space between a slash and the start of text
* it may not get fixed correctly ... lazy cuz that shouldn't ever happen
	DO iword = last_qual+1, word_num
	   IF (itsa_qualifier(iword)) THEN
	      arg_start(iword) = arg_start(iword) - 1  ! own the  "/"
	   ENDIF
	ENDDO
* group contiguous blocks of slash-connected chars into single args
*     e.g. set data /home/users/tmap/ferret/linux/dsets/coads.nc
* ... work from right to left, consolidate qualifier groups
	ngone = 0
	DO iword = word_num, last_qual+1, -1
	   IF (itsa_qualifier(iword) )THEN
	      itsa_qualifier(iword) = .FALSE.
	      IF (arg_start(iword).EQ.(arg_end(iword-1)+1)) THEN
	         arg_end(iword-1) = arg_end(iword)
	         arg_start(iword) = 0
	         arg_end(iword)   = 0
	         ngone = ngone + 1
	      ENDIF
	   ENDIF
	ENDDO
* ... remove the voids left behind
	iword = last_qual+1
	current_words = word_num
	DO WHILE (iword .LT. current_words)
	   IF (arg_start(iword) .EQ. 0) THEN
	      DO ii = iword+1, current_words
	         arg_start(ii-1) = arg_start(ii)
	         arg_end  (ii-1) = arg_end  (ii)
	      ENDDO
	      arg_start(current_words) = 0
	      arg_end  (current_words) = 0
	      current_words = current_words - 1
	   ENDIF
	   IF (arg_start(iword).NE.0) iword = iword + 1
	ENDDO
	word_num = word_num - ngone
*	last_qual = word_num

* finally ... loop through qualifiers to identify them
* Check for too-short abbreviations, /T= for /TITLE see ticket 1963.
 704	CONTINUE

        expnd_qual = .FALSE.
        ic = 1
        ir = 1
        DO 740 iqual_word = 2, last_qual
	   IF ( .NOT.itsa_qualifier(iqual_word) )	  GOTO 740
	   IF ( num_qualifs(isubcmnd_ptr) .EQ. 0 )        GOTO 5030	! error
	   IF ( num_quals .EQ. max_quals )		  GOTO 5040	! error

* find qualifier terminator ( eg. /K=1:5  is terminated by "=" )
	   DO 710 iterm = arg_start(iqual_word), arg_end(iqual_word)
	      IF (   cmnd_buff(iterm:iterm) .EQ. ' '
     .		.OR. cmnd_buff(iterm:iterm) .EQ. '	'
     .		.OR. cmnd_buff(iterm:iterm) .EQ. '=' ) GOTO 720
 710	   CONTINUE
	   iterm = arg_end(iqual_word) + 1	! no funny terminator

* identify against list of qualifiers for this subcommand 
* unless there's a grave-accent to evaluate (issue 660)
 720	   len_test = TM_LENSTR(cmnd_buff(arg_start(iqual_word):iterm-1))
	   IF (INDEX(cmnd_buff(arg_start(iqual_word):iterm-1),'`') .GT. 0) GOTO 740

           DO 730 iqual = 1,num_qualifs(isubcmnd_ptr)
	   iqual_ptr = iqual + qualifier_pointer(isubcmnd_ptr) - 1
           len_mchars = TM_LENSTR(qualifiers(iqual_ptr)(:4))
	   known_qualifier = 
     .		MATCH4( cmnd_buff(arg_start(iqual_word):iterm - 1 ),
     .                  len_test,
     .			qualifiers(iqual_ptr),len_mchars )
     
* Did they abbreviate to one letter when we may need more?  Fill out the qualifier.
* Could expand the too-shortness from (len_test.EQ.1) to (len_test.LT.len_mchars)

           IF (known_qualifier .AND. len_test.EQ.1 .AND. len_mchars.GT.1) THEN
c           IF (known_qualifier .AND. len_test.LT.len_mchars .AND. len_mchars.GT.1) THEN
              expnd_qual = .TRUE.
              risc_buff(ir:) = cmnd_buff(ic:arg_start(iqual_word))
	      ir = TM_LENSTR(risc_buff)   ! ir + arg_start(iqual_word)-1
              risc_buff(ir:) = qualifiers(iqual_ptr)(:len_mchars)
              ir = ir + len_mchars 
              ic = arg_start(iqual_word) + len_test 

           ENDIF 

* "@/anything" will be permitted to pass
* (8/92 - this should be lifted outside of this loop for speed!!! *sh*)
	   atsin_qualifier  = 
     .		cmnd_buff(arg_start(iqual_word):arg_start(iqual_word)) .EQ. '@'
	   IF ( known_qualifier .OR. atsin_qualifier ) THEN
	        last_recognized_word = iqual_word
		num_quals = num_quals + 1
		qual_start(num_quals) = arg_start(iqual_word)
		qual_end  (num_quals) = arg_end  (iqual_word)
		IF ( known_qualifier ) THEN
		   qualifier_list(num_quals) = iqual
		ELSE
		   qualifier_list(num_quals) = 0
		ENDIF
		GOTO 740
	   ENDIF
 730	   CONTINUE

* checked all possible qualifiers and did't find a match

	   IF (its_set_data .OR. its_define_sym) THEN
* *sh* 2015 *HACK* for SET DATA path/filename and GO path/filename
*      since filenames may contain slashes that are mistaken as qualifiers
*      we treat the first unrecognized qualifier as potentially part of the
*      filename. 
*      It is *not* part of the filename if
*      - no white space gap has been seen to the left
*      For SET DATA it is also not part of the filename if
*      - there is a white space gap without a comma found to the right
	      IF (white_aftr_subcmnd .GT. arg_start(iqual_word)) GOTO 5030 
* ... look to right for white space with no comma
	      found_white_space = .FALSE.
	      DO iterm = arg_end(iqual_word), cmnd_len
	         IF (   cmnd_buff(iterm:iterm) .EQ. ' '
     .		   .OR. cmnd_buff(iterm:iterm) .EQ. '	' ) THEN
	            found_white_space = .TRUE.
		 ELSEIF (found_white_space) THEN
	            IF (cmnd_buff(iterm:iterm) .NE. ',') THEN
	               GOTO 5030
	            ELSE
	               EXIT
	            ENDIF
	         ENDIF
	      ENDDO
	      word_num = last_recognized_word + 1
	      arg_end(word_num) = cmnd_len
	      IF (itsa_qualifier(word_num)) arg_start(word_num)
     .			= arg_start(word_num)-1	    ! keep "/" in /home/file
	      itsa_qualifier(word_num) = .FALSE.
	      last_qual = iqual_word - 1     ! added 12/2015 -- approx true
	      EXIT
	   ELSEIF (its_go .OR. its_say) THEN
* *HACK* for GO to allow unquoted "GO path/script" and "GO /hom/path/script"
	      IF (white_aftr_cmnd .GT. arg_start(iqual_word)) GOTO 5030 
* ... its an absolute path -- count the slashes
	      ngone = 0
	      i = iqual_word+1
	      DO WHILE (i.LE. word_num .AND. itsa_qualifier(i))
	         ngone = ngone + 1
	         i  =i+1
	      ENDDO
* turn this entire absolute path into a single argument
	      word_num = word_num - ngone
	      arg_start(iqual_word) = arg_start(iqual_word)-1 ! keep start "/"
	      arg_end(iqual_word)   = arg_end(iqual_word+ngone)
	      itsa_qualifier(iqual_word) = .FALSE.
	      last_qual = iqual_word - 1     ! added 12/2015 -- approx true
	      DO i = iqual_word+1, word_num
                 arg_start(i) = arg_start(i+ngone)
                 arg_end  (i) = arg_end  (i+ngone)
	         IF (itsa_qualifier(i) ) arg_start(i) = arg_start(i) - 1
	         itsa_qualifier(i) = .FALSE.
	      ENDDO
	      EXIT
	   ELSE
	      GOTO 5030		! all other commands: unknown qual error
	   ENDIF

 740	CONTINUE

* If we replaced abbreviated qualifiers with longer versions, go back and
* and re-parse the whole thing as all the pointers now need to be revised.

        IF (expnd_qual) THEN
	   risc_buff(ir:) = cmnd_buff(ic:TM_LENSTR(cmnd_buff))
	   cmnd_buff = risc_buff
           expnd_qual = .FALSE.   
           GOTO 5  
        ENDIF

* +++++++ ARGUMENTS +++++++
* return buffer locations for all words not yet identified
* (last_qual check as bug fix 2/94 *sh*)
	DO 810 iarg = 2,word_num
	   IF ( iarg .LE. last_qual
     .      .AND. (itsa_qualifier(iarg) .OR. isub_word.EQ.iarg) ) THEN
		GOTO 810     ! command, subcommand, or qualifier
	   ELSE
		num_args		= num_args + 1
		arg_start( num_args )	= arg_start( iarg )
		arg_end  ( num_args ) 	= arg_end  ( iarg )
	   ENDIF
 810	CONTINUE

* is the first argument enclosed in quotation marks?
* the nature of arg_start,end allows safe (??) decrement/increment
	IF (num_args .GE. 1) THEN
	   arg1_quoted =
     .	        (cmnd_buff(arg_start(1)-1:arg_start(1)-1) .EQ. '"'
     .     .AND. cmnd_buff(arg_end  (1)+1:arg_end  (1)+1) .EQ. '"' )
     .   .OR.
     .	        (cmnd_buff(arg_start(1)-1:arg_start(1)-1) .EQ. "'"
     .     .AND. cmnd_buff(arg_end  (1)+1:arg_end  (1)+1) .EQ. "'" )

	   IF (.NOT.arg1_quoted
     .    .AND. (cmnd_buff(arg_start(1)-1:arg_start(1)-1) .EQ. "_")
     .    .AND. (cmnd_buff(arg_end  (1)+1:arg_end  (1)+1) .EQ. "_")
     .    .AND. (arg_start(1)-4.GE.1)
     .    .AND. (arg_end  (1)+4.LE.cmnd_len)                     )THEN
	      arg1_quoted = 
     .          (cmnd_buff(arg_start(1)-4:arg_start(1)-1) .EQ. "_DQ_"
     .      .AND.cmnd_buff(arg_end  (1)+1:arg_end  (1)+4) .EQ. "_DQ_" )
     .    .OR.
     .          (cmnd_buff(arg_start(1)-4:arg_start(1)-1) .EQ. "_SQ_"
     .      .AND.cmnd_buff(arg_end  (1)+1:arg_end  (1)+4) .EQ. "_SQ_" )
	   ENDIF
	ENDIF

* REPEAT loops postpone symbol substitutions in arguments -- all 1 arg for now
	IF ( cmnd_num .EQ. cmnd_repeat ) THEN
	   IF (num_args .EQ. 0) GOTO 5070
	   IF ( cmnd_buff(arg_end(num_args):arg_end(num_args)) .EQ. ')' 
     .    .AND. cmnd_buff(arg_start(1):arg_start(1)) .EQ. '(' ) THEN
*   ... search backwards for left paren
	    first_paren = .TRUE.
	    paren_level = 1
	    DO 850 i = len_cmnd_copy-1, 1, -1
	      IF (cmnd_copy(i:i) .EQ. ')') THEN
	        paren_level = paren_level + 1
	        first_paren = .FALSE.
	      ELSEIF (cmnd_copy(i:i) .EQ. '(') THEN
	        paren_level = paren_level - 1
	        IF (first_paren) THEN
*   ... dont confuse symbol at end "($sym)" with paren-enclosed command group 
	          IF (cmnd_copy(i+1:i+1) .EQ. '$') GOTO 890
	          first_paren = .FALSE.
	        ENDIF
	        IF ( paren_level .EQ. 0 ) THEN
*   ... found the block of REPEAT argument - replace the text with original
	          cmnd_buff(arg_start(1):) = cmnd_copy(i:len_cmnd_copy)
	          cmnd_len = arg_start(1) + (len_cmnd_copy-i)
	          num_args = 1
	          arg_end(1) = cmnd_len
	          GOTO 890
	        ENDIF
	      ENDIF
 850	    CONTINUE
*   ... no matching left paren ever found (probably a syntax error ...)
*       It would be better to let the parsing of each command catch and report
*       errors, but ticket 2551 shows a failure in that. Make it an error here.
          GOTO 5080
	  ENDIF
	ENDIF
 890	CONTINUE


* For SET DATA commands if there is an F-TDS expression, then encode that now.

	IF  (cmnd_num .EQ. cmnd_set .AND. 
     .       subcmnd_num .EQ. subcmnd_set_data+1 ) THEN
	
	   IF (num_args .GT. 0) url_buff = cmnd_buff( arg_start(1):arg_end(num_args) )
	   len_test = TM_LENSTR(url_buff)
           i = INDEX( url_buff(1:len_test), '_expr_{}' ) 
	   IF (i .GT. 0) THEN
	      num_args = 1
              CALL CD_ENCODE_URL (url_buff)
	      len_test = TM_LENSTR(url_buff)
	      i = INDEX(cmnd_buff, "http://")
	      cmnd_buff(i:i+len_test) = url_buff
	      arg_end(1) = i+len_test - 1
	   ENDIF
	ENDIF

* +++++++++ grave-accented immediate-mode expressions +++++++++++  3/95
* evaluate and substitute the first grave accent-surrounded expression, if any
* beginning at character grave_start
* and return to re-process command if substitution occurs (4/93)
* This part of the command parsing is postponed until the end so that
* the command qualifiers (which may contain region information) will have
* been identified and can be used while evaluating the grave expressions
	nsubst_passes = nsubst_passes + 1 ! guard against recursion (4/93)
	IF ( nsubst_passes .GT. 100 ) GOTO 5060
* For REPEAT commands the grave accented expressions INSIDE the REPEAT loop
* must be deferred until later
	IF ( INDEX(cmnd_buff(:cmnd_len),'`') .GT. 0 ) THEN
	   IF  ( cmnd_num .EQ. cmnd_repeat ) THEN
	      grave_end = qual_end(num_quals)

	   ELSEIF  ( cmnd_num .EQ. cmnd_if
     .	     .OR.    cmnd_num .EQ. cmnd_elif ) THEN
	      IF ( num_args .GE. 1 ) THEN
	         grave_end = arg_end(1)
	      ELSE
	         grave_end = grave_start      ! invalid IF comand syntax
	      ENDIF
	   ELSE
	      grave_end = cmnd_len
	   ENDIF
           apply_cx = its_action_command(cmnd_num)
	   CALL REPL_EXPRNS(  cmnd_buff, cmnd_len,
     .			     apply_cx, grave_start, grave_end,
     .                       grave_digits, subst, status  )
	   IF ( status .NE. ferr_ok ) GOTO 5000	
	   IF ( subst ) THEN
* ... num_uvars_in_cmnd flags expression results from previous cmnds as invalid
	      num_uvars_in_cmnd = cmnd_uvars_not_given
	      reverify = .TRUE.      ! informational echo needed
	      GOTO 5   ! back to parse again with the expresns replaced
	   ENDIF
	ENDIF

* replace backslashes that were escapes
* Ticket 2376: If the command is a REPEAT, this needs to wait until
* the command is parsed within the execution of the loop.

#ifdef NO_DOUBLE_ESCAPE_SLASH
	IF (  ( cmnd_num .NE. cmnd_repeat ) .AND. 
     .		INDEX(cmnd_buff(:cmnd_len),'\') .GT. 0 ) THEN
	   in  = 1
	   out = 1
 900	   IF (cmnd_buff(in:in+1) .EQ. '\!') THEN
	      cmnd_buff(out:out) = '!'
	      in = in + 2
	   ELSEIF (cmnd_buff(in:in+1) .EQ. '\;') THEN
	      cmnd_buff(out:out) = ';'
	      in = in + 2
	   ELSEIF (cmnd_buff(in:in+1) .EQ. '\`') THEN
	      cmnd_buff(out:out) = '`'
	      in = in + 2
	   ELSEIF (cmnd_buff(in:in+1) .EQ. '\/') THEN
	      cmnd_buff(out:out) = '/'
	      in = in + 2
#else
	IF ( ( cmnd_num .NE. cmnd_repeat ) .AND. 
     .		INDEX(cmnd_buff(:cmnd_len),'\\') .GT. 0 ) THEN
	   in  = 1
	   out = 1
 900	   IF (cmnd_buff(in:in+1) .EQ. '\\!') THEN
	      cmnd_buff(out:out) = '!'
	      in = in + 2
	   ELSEIF (cmnd_buff(in:in+1) .EQ. '\\;') THEN
	      cmnd_buff(out:out) = ';'
	      in = in + 2
	   ELSEIF (cmnd_buff(in:in+1) .EQ. '\\`') THEN
	      cmnd_buff(out:out) = '`'
	      in = in + 2
	   ELSEIF (cmnd_buff(in:in+1) .EQ. '\\/') THEN
	      cmnd_buff(out:out) = '/'
	      in = in + 2
#endif	
	   ELSE
	      cmnd_buff(out:out) = cmnd_buff(in:in)
	      in = in + 1
	   ENDIF
	   out = out + 1
	   IF (in.LT.cmnd_len) GOTO 900	
	   cmnd_buff(out:out) = cmnd_buff(in:in)
	   cmnd_len = out
* ... cover over characters exposed at line end
	   DO 910 out = out+1,in+1
 910	   cmnd_buff(out:out) = ' '
	ENDIF

* successful completion
 1000   status = ferr_ok
	RETURN

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* error exits
 5000	RETURN
* error exits
 5005	CALL ERRMSG( ferr_syntax, status,
     .			'command line too long -- exceeds 2048', *5000 )

 5010	CALL ERRMSG( ferr_syntax, status,
     .			'unpaired quotation marks, grave accent or brackets',
     .			*5000 )

 5015	CALL ERRMSG( ferr_syntax, status,
     .				'zero length quotation forbidden', *5000 )

 5020	CALL ERRMSG( ferr_unknown_command, status,
     .		cmnd_buff( arg_start(1):arg_end(1) ), *5000 )

 5025	IF ( arg_end(word_num) - arg_start(word_num) .GT. 200) THEN 
	   CALL ERRMSG( ferr_syntax, status,
     .		cmnd_buff( arg_start(word_num):arg_start(word_num)+200 )//'...', *5000 )
        ELSE
	   CALL ERRMSG( ferr_syntax, status,
     .		cmnd_buff( arg_start(word_num):arg_end(word_num) ), *5000 )
        ENDIF

 5030	CALL ERRMSG( ferr_unknown_qualifier, status,
     .		cmnd_buff( arg_start(iqual_word):arg_end(iqual_word) ), *5000 )

 5040	CALL ERRMSG
     .		( ferr_cmnd_too_complex, status, 'too many qualifiers', *5000 )

 5050	CALL ERRMSG( ferr_syntax, status, '"/"', *5000 )

 5060	CALL ERRMSG( ferr_syntax, status,
     .		'Recursive aliases or GO argument definitions', *5000 )

 5070	CALL ERRMSG
     .			( ferr_invalid_command, status, 'REPEAT what ?', *5000 )
 5080	CALL ERRMSG
     .			( ferr_invalid_command, status, 
     .		'Mismatched parentheses within REPEAT loop ', *5000 )
	END

	SUBROUTINE POLYGON_SET_UP
     .			      ( 
     .				overlay, transpz, coord_ax, no_labels,
     .				no_range, only_val,
     .				symbol, line_type, use_line,
     .				is_logx, is_logy, 
     .				mr_list, cx_list, nmv,
     .				is_modx,
     .				do_mod_minus, 
     .				do_mod_plus,
     .				add_lon,
     .				x_dat, y_dat, status )


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* Set up for single or multiple polygons to be  ploted by loading data
* and labels and defining axis formats

* The POLYGON command accepts single and multi-dimensional arguments
* "1D FORM"
*	   yes? POLYGON xpoly1D, ypoly1D, values
*   where if xpoly1D or ypoly1D contain missing values, those represent
*   the end of one polygon and the start of the next. The length of the values
*   array must equal the number of polygons
* in which case the X coordinate might ve visualized as
*    x1,x1,x1,x1,BAD,x2,x2,x2,BAD,x3,x3,x3,x3,x3,x3,x3,x3,BAD,...
* where the "1","2","3" refer to the successive polygons

* "2D FORM"
*	   yes?  POLYGON xpoly2D, ypoly2D, values
*   where values must be 1-dimensional and its axis must match in size and
*   orientation one of the axes from the 2D arrays. The other axis of the
*   2D coordinates is the axis of the coordinates within each polygon
* in which case the X coordinate might ve visualized as
*    x1,x1,x1,x1,BAD,BAD,...
*    x2,x2,x2,BAD,BAD,...
*    x3,x3,x3,x3,x3,x3,x3,x3,BAD,BAD,...

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V500: 2/99 - based on plot_set_up.F
*       3/99 - *jd* mods to complete the command
* V500: 3/99 *kob* - upped VAR_UNITS from 32 to 64 chars
*       5/99 *kob* - minor mod to remove improper comment line linux compiler
*                    didn't like
*       6/99 - *jd* fix bug in 2 var form where x_dat(1) is reassigned
* V510: *sh* 3/00 - trap if number of polygons is too large 
*		  - new arg use_line for change in arguments to LINE_STYLE
*	5/00 - added /HLIMITS and /VLIMITS (denigrating /xlimits/ylimits)
* V510: *sh* 7/00 - added arg to EQUAL_RANGE 
* V530 *sh* 1/01 - change "denigrated" to "deprecated"
*	    1/01 - remove makep setting so segments are not pre-activated
* V530 *ACM* 1/03  cal_id for alternative calendar axes.
* V530 *ACM* 5/09  add arguments (unused here) to line_style call. 
* V533 *acm* 6/01 - for LOG plots add logicals is_logx, is_logy.  set to plot
*                   log of depth as inverse axis
* V533 *acm* 9/01 - changes for dynamic pplus buffer.  Rename NSIZE to pplmem_nsize.
*                   call PPLLDX via pplldx_envelope.c which checks pplmem_nsize 
*                   and allocates more memory if needed.  
*      *acm* 10/01  remove VMS includes
* v540 *acm* 12/01  IF (missing_polygon) THEN don't call PPLLDX_envelope; calling
*                   with missing data for time-axis data results in trying to 
*                   compute a time axis (elsewhere) with out-of-range values.
* v541 *acm*  3/02  The above fix is too broad.  Apply it only to time-axis 
*                   overlays.
* v541 *acm*  3/02  Compute and allocate the ammount of PPLUS memory that'll
*                   be needed for this plot, before the loop that loads polygons.
* v541 *acm*  3/02  set twodee_on to .TRUE. (as in disp_init) so we can overlay on 
*                   polygon plots
* v541 *acm*  4/02  If we have a depth axis, multiply the corresponding 
*                   vertices by -1.  Else the polygons arent plotted.
* v541 *acm*  8/02  For "No Valid Data" the test is: 
*                   IF (no_range .AND. (only_val.EQ.mr_bad_data(mr_color))
* V550 *acm* 11/02  When its a 1-d form the ppl memory allocation was wrong.
*                   (Input is 1D arrays of p1,p1,p1,p1,BAD,p2,p2,p2,p2,BAD,..)
* V552 *acm*  3/03  Send the key string to key_loc since it may be multi-line
*                   Also, set strings longer
* V553 *acm*  6/03  For polygons, store the # of points in each polygon in the PPLUS
*                   memory buffer, rather than in lleng.  This way the number of
*                   polygons that may be plotted is unlimited. Mark this with the
*                   value of icode (first argument to pplldx_envelope)
* v554 *acm* 12/03  Bug fix: for 1-D form of polygon command, save values of context 
*                   so they can be properly restored. (ss_x_save, ss_y_save)
* V580 *acm* 11/04  Check calendar id only for 2-D polygon form; 1-D polygon data are
*                   just lists on abstract axis.  Fix for bug 1066
* V580 *acm* 12/04  Correct the syntax sending XFOR LONE to pplus when we 
*                   turn on lon/lat formatting.
* V600 *acm*  11/05 Fix for bug 1130, 1349: axis labels need lat/lon labels,
*                   fixes to the precision
* V62  *acm* 5/09   Fixing bug 1661: if the plot is TRANSPOSED, then multiply 
*                   vertices of the opposite axis by -1 
* V630  *acm* 9/09 Introduction of syntax for variance-based and histogram levels
* V650 *acm*  3/10  Check calendar id only if polygon data is not a list on an
*                   abstract time axis.  Fix for bug 1722.
* V671 *acm*  5/11  For the 1D form of polygon plots, the check for adequate 
*                   PLOT+ memory was not adequate - we need x,y, and variable 
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction.
* V6.85 *acm* 9/13 Change to CALL LINE_STYLE, implementing new PLOT/COLOR w/o 
*                  argument for all-color line plot
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long
* V691  *acm*  5/14 Clean up temp memory used for computing histogram levels
* V695  *acm*  9/15 send REAL*4 rbad to compare with lev_max, lev_min inside compute_mnstd
* V698  *acm*  3/16 #2396: On a POLYGON/OVERLAY with no /TITLE given, if there is 
*                   no 3rd argument (colors), make nominal title
* V698  4/16 *acm* New PLOT/SKIP= means change in call sequence for LINE_STYLE
* V701  *acm* 8/16 Fix ticket 2463: single-valued data with a /LEVELS setting
* V702  *acm* 10/16 Test the results of MINMAX routine before use; if all data is 
*                   all-missing it returns arbitrary_large_val4.
* V71  *acm* 2/17  More on ticket 2231. New argument to FULL_VAR_TITLE to control units labels
* V72  *acm* 3/17  For ticket 2517, changes to arguments in calls to AXIS_ENDS

	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'ferret.parm'
	include 'plot_setup.parm'
	include 'errmsg.parm'
	include 'slash.parm'
!	include 'gfdl_vms.parm'
	include 'xplot_setup.cmn'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'
	include 'xtext_info.cmn'
	include 'axis_inc.decl'       ! with axis lengths
	include 'AXIS.INC'       ! with axis lengths	
        include 'PPLDAT.INC'
	include 'parampl5_dat.decl'
	include 'PARAMPL5.DAT'	! with NPOLYGONS
        include 'switch_inc.decl'
        include 'SWITCH.INC'
        include 'pltl_inc.decl'
        include 'PLTL.INC'
	include 'vector_inc.decl' ! with TRANSPZ
        include 'VECTOR.INC'


* calling argument declarations:
	LOGICAL		overlay, transpz, no_labels, no_range, use_line,
     .			is_logx, is_logy, is_modx, do_mod_minus, do_mod_plus, 
     .			do_units
	INTEGER		symbol, line_type, coord_ax, iunits, do_dash,
     .			nmv, mr_list( nmv ), cx_list( nmv ), status
	REAL		x_dat(*), y_dat(*)     ! dynamic space allocation 
	REAL            only_val, dashstyle(4), add_lon

* internal variable declarations:
	LOGICAL         missing_polygon, first_polygon, use_nice
	LOGICAL		NO_LINE_RANGE, ambiguous_coord_axis,
     .			formatted, user_title, oneD_form, stack_up,
     .			x_is_log, y_is_log, vflag
	CHARACTER*2048	KEY_STRING, FULL_VAR_TITLE, plot_title
* 3/99 *kob* - upped VAR_UNITS from 32 to 64 chars
	CHARACTER	VAR_UNITS*64, LEFINT*6, TM_GET_CALENDAR_NAME*32, 
     .			x_ax*1, y_ax*1,buff*8, buff2*4, t1_date*14,
     .                  cal_name*32, cal_name_saved*32, buff3*16,
     .			buff4*16, LEFT_REAL*16, fmt*4, buffer*40, buffsym*30
	INTEGER         TM_UNIT_ID
	INTEGER		TM_LENSTR1, CX_DIM_LEN,	TM_GET_CALENDAR_ID, 
     .			STR_SAME,
     .			mr_x, cx_x, mr_y, cx_y, cx_color, mr_color,
     .			slen, slen2, x_lab, y_lab, nline_in_mem, i,
     .			npoly, ncolor, ipoly, xrow, yrow, start, end,
     .			npts, idim, color_dim, coord_dim,
     .			style, justify, ndim, dims(nferdims), nfdim,
     .			fdims(nferdims), plot_mem_used, pxlim, pylim, ptitl,
     .			cx_buff_x, cx_buff_y,
     .			phlim, pvlim, pxdenig, pydenig,
     .                  cal_id, tax, x_axtyp, y_axtyp, n,
     .			ss_x_save, ss_y_save, mvh_temp, ier, nc, skipsym,
     .			nsiz, ngood

	REAL		x_len, y_len, lo, hi, lox, hix, loy, hiy,
     .			xkeypos, ykeypos, xkeysize, ykeysize, lab_ht,
     .			dt_min, epsilon, small, scale,
     .			xptsmin, xptsmax, xptsmean, xdif, xmeanlog,
     .			yptsmin, yptsmax, yptsmean, ydif, ymeanlog,
     .                  first, last

	REAL*8		vmin, vmax, delta, ind_min, ind_max, dep_min,
     .			dep_max
	REAL*4 rbad

* local parameter declarations:
	LOGICAL		range_rqd
	PARAMETER     ( range_rqd = .TRUE. )
	PARAMETER     ( epsilon = 1.E-45 )

	do_units = .TRUE.
	vflag = .FALSE.  ! argument to axis_ends

* signal that plot set-up has begun
	IF ( mode_diagnostic ) CALL SPLIT_LIST(pttmode_ops, ttout_lun,
     .				'setting up polygons', 19)

* Permit 2 arguments, ginn up dummy 3rd in that case
        IF (nmv .EQ. 3) THEN
	   cx_color = cx_list(3)
	   mr_color = mr_list(3)
        ELSEIF (nmv .EQ. 2) THEN
	   CALL INIT_EMPTY_CONTEXT(cx_buff)
*       ignore status ... always OK
	   CALL CONSTANT_CONTEXT("0", cx_buff, cx_buff, status)
	   cx_color = cx_buff
	   mr_color = dummy_mr
        ELSE
	   GOTO 5200 
        ENDIF

* initialize
	nline_in_mem = 0
	pxlim = qual_given( slash_xlimits ) ! deprecated
	pylim = qual_given( slash_ylimits ) ! deprecated
	phlim = qual_given( slash_hlimits )
	pvlim = qual_given( slash_vlimits )
	ptitl = qual_given( slash_title )
	user_title = ptitl .GT. 0
	cx_x = cx_list(1)
	cx_y = cx_list(2)
	mr_x = mr_list(1)
	mr_y = mr_list(2)
	plot_mem_used = 0
	lox = arbitrary_large_val4
	hix = arbitrary_small_val4
	loy = arbitrary_large_val4
	hiy = arbitrary_small_val4
c	ind_dim = plot_axis(1)
	stack_up = .FALSE.
	cal_id = 0
	x_axtyp = 1
	y_axtyp = 1

* *acm* 3/02  set flag indicating a 2D plot is on the screen
*             (so we can overlay other plots on a polygon plot)
	twodee_on = .TRUE.

* perform sanity checks on the arguments
* ... check the X coordinate variable for shape
	CALL GET_CX_DIMS( cx_x, ndim, dims)
	IF (ndim .EQ. 0) GOTO 5210		! npoints = 1 !!! yuk!
	IF (ndim .GT. 2) GOTO 5210		! could someday be relaxed ...
* ... check the Y coordinate variable for conformability
	CALL GET_CX_DIMS( cx_y, nfdim, fdims)
	IF (ndim .NE. nfdim) GOTO 5210
	DO 100, idim = 1, ndim
	   IF (dims(idim) .NE. fdims(idim)) GOTO 5210
	   IF ( CX_DIM_LEN(dims(idim),cx_x)
     .    .NE.  CX_DIM_LEN(dims(idim),cx_y) ) GOTO 5210
 100	CONTINUE
* ... check the color value array for consistent structure
	oneD_form = ndim .EQ. 1
	CALL GET_CX_DIMS( cx_color, nfdim, fdims)
	IF (nfdim .GT. 1) GOTO 5210

* determine coordinate axes for polygon coords and fill color values
	IF (oneD_form) THEN
* 1-dimensional form of command
	   coord_dim = dims(1)	! axis of points in the polygon(s)
	   color_dim = coord_dim
	ELSE
* 2-dimensional form of command
* ... does the color value axis match one of the coordinate array axes?
	   IF (nfdim .EQ. 0) THEN
	      ambiguous_coord_axis = .TRUE.
	   ELSE
	      DO 105 idim = 1, ndim
	         IF (dims(idim) .EQ. fdims(1)) THEN
	            ambiguous_coord_axis = .FALSE.
	            GOTO 106
	         ENDIF
 105          CONTINUE
	      ambiguous_coord_axis = .TRUE.
	   ENDIF
 106	   IF (ambiguous_coord_axis) THEN
* ... abmiguous 2D form since since color_array is a scalar
	      IF (coord_ax .GT. 0 ) THEN
* ... the user has specified the coordinate axis (e.g. "/COORD_AX=J")
	         CALL EQUAL_STRING( cmnd_buff(qual_start(coord_ax):
     .					      qual_end  (coord_ax)),
     .				    buff, status )
                 IF ( status .NE. ferr_ok ) RETURN
                 DO 120 coord_dim = 1,4
	            IF (ww_dim_name(coord_dim) .EQ. buff(1:1)
     .		   .OR. ss_dim_name(coord_dim) .EQ. buff(1:1) ) THEN
*      ... is the specified axis an axis of the arrays?
	               DO 110 idim = 1, 2
 110		       IF (coord_dim .EQ. dims(idim)) GOTO 150
	               GOTO 5300	! invalid coordinate dim given
	            ENDIF
 120	         CONTINUE
	         GOTO 5300	! coord dim wasn't "X","Y","Z", or "T"
	      ELSE
* ... the user has NOT specified the coordinate axis
	         coord_dim = dims(2)
	         CALL WARN("Ambiguous axes in 2D coordinate arrays")
	         CALL WARN("Continuing as /COORD_AX="//
     .				ww_dim_name(coord_dim))
	      ENDIF
 150	      IF (dims(1) .EQ. coord_dim) THEN
	         color_dim = dims(2)
	      ELSE
	         color_dim = dims(1)
	      ENDIF
	   ELSE
* color fill value array is 1D and matches an axis of the coordinate arrays
	      color_dim = fdims(1)
	      IF (dims(1) .EQ. color_dim) THEN
	         coord_dim = dims(2)
	      ELSE
	         coord_dim = dims(1)
	      ENDIF
	   ENDIF
	ENDIF

* set flag indicating a 1D plot is on the screen
	IF (.NOT.overlay) onedee_on = .TRUE.

        IF (.NOT. overlay) has_time_axis = .FALSE.  ! ??

* prepare for possible transpose of X and Y axes
	IF ( transpz ) THEN
	   y_ax  = 'X'
	   x_ax  = 'Y'
	   y_lab = ppl_xlab
	   x_lab = ppl_ylab
	   y_len   = xlen
	   x_len   = ylen
	   x_is_log = is_logy
           y_is_log = is_logx

	   IF (pxlim .GT. 0) THEN
	      pxdenig = pxlim
	   ELSE
	      pxdenig = pvlim
	   ENDIF
	   IF (pylim .GT. 0) THEN
	      pydenig = pylim
	   ELSE
	      pydenig = phlim
	   ENDIF
	ELSE
	   y_ax  = 'Y'
	   x_ax  = 'X'
	   y_lab = ppl_ylab
	   x_lab = ppl_xlab
	   x_len   = xlen
	   y_len   = ylen
	   x_is_log = is_logx
           y_is_log = is_logy

	   IF (pxlim .GT. 0) THEN
	      pxdenig = pxlim
	   ELSE
	      pxdenig = phlim
	   ENDIF
	   IF (pylim .GT. 0) THEN
	      pydenig = pylim
	   ELSE
	      pydenig = pvlim
	   ENDIF
	ENDIF

* * * * * * *    - - - LOAD DATA - - -    * * * * * * * * *
* allocate modifiable context buffers for data extraction
	CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) RETURN
	cx_buff_x = cx_stack_ptr
	CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) RETURN
	cx_buff_y = cx_stack_ptr
	CALL TRANSFER_CONTEXT( cx_x, cx_buff_x )
	CALL TRANSFER_CONTEXT( cx_y, cx_buff_y )
	stack_up = .TRUE.

* set start indices for extraction
	IF (oneD_form) THEN
	   end  = 0
	ELSE
	   xrow = cx_lo_ss(cx_x,color_dim) - 1
	   yrow = cx_lo_ss(cx_y,color_dim) - 1
	ENDIF

* tell PLOT+ the bad data flags used
	WRITE ( ppl_buff, 3005 ) mr_bad_data( mr_x ), x_ax
	CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
	WRITE ( ppl_buff, 3005 ) mr_bad_data( mr_y ), y_ax
	CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
 	WRITE ( ppl_buff, 3005 ) mr_bad_data( mr_color ), 'Z'
	CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
 3005	FORMAT ( 'LIMITS ',G15.8,1X,A1,'EQ' )


* need number of polygons and points in each. On the first polyon we will
* check that we have enough PPLUS memory and allocate more if needed.

        first_polygon = .TRUE.
	ngood = 0

* ...  point to the first polygon 
       IF ( oneD_form ) THEN
*    ... coords are 1D arrays of p1,p1,p1,p1,BAD,p2,p2,p2,p2,BAD,...
*    ... we will find npoly as we go through the list
          npoly = 0
	ELSE
*    ... coords are 2D arrays of color_dim X coord_dim
           npoly = cx_hi_ss(cx_x,color_dim) - cx_lo_ss(cx_x,color_dim) + 1
	ENDIF

* loop through all the polygons variables loading them into PPLUS
* construct a funky FORTRAN 77 DO-WHILE loop
* ---- 
        IF (oneD_form) THEN
           ss_x_save = cx_lo_ss(cx_buff_x,coord_dim)
           ss_y_save = cx_lo_ss(cx_buff_y,coord_dim)
        ENDIF

200	CONTINUE

* ... prepare the context buffer to point to the next polygon 
	   IF ( oneD_form ) THEN
*    ... coords are 1D arrays of p1,p1,p1,p1,BAD,p2,p2,p2,p2,BAD,...
	      cx_lo_ss(cx_buff_x,coord_dim) =
     .	       cx_lo_ss(cx_buff_x,coord_dim) + end   ! advance past end of last
	      cx_lo_ss(cx_buff_y,coord_dim) =
     .	       cx_lo_ss(cx_buff_y,coord_dim) + end
	      IF (cx_lo_ss(cx_buff_x,coord_dim)
     .	     .GE. cx_hi_ss(cx_buff_x,coord_dim)) THEN
                
 	         cx_lo_ss(cx_buff_x,coord_dim) = ss_x_save   ! restore what it was
	         cx_lo_ss(cx_buff_y,coord_dim) = ss_y_save   ! so we can count npts
                                                             ! in the 700 loop below
                 GOTO 290 ! exit DO_WHILE loop
              ENDIF

	   ELSE
*    ... coords are 2D arrays of color_dim X coord_dim
	      xrow = xrow + 1  ! advance to next polygon in the 2D array
	      yrow = yrow + 1  ! advance to next polygon in the 2D array
	      IF (xrow .GT. cx_hi_ss(cx_x,color_dim)) GOTO 290	! exit the DO_WHILE loop
	      cx_lo_ss(cx_buff_x,color_dim) = xrow
	      cx_hi_ss(cx_buff_x,color_dim) = xrow
	      cx_lo_ss(cx_buff_y,color_dim) = yrow
	      cx_hi_ss(cx_buff_y,color_dim) = yrow
	   ENDIF

* ... extract 1-dimensional arrays -- possibly with embedded missing values
* ... x coordinates
	   CALL EXTRACT_LINE (	cx_buff_x,
     .				memry(mr_x)%ptr,
     .				mr_x,
     .				x_dat,
     .				coord_dim,
     .				ndim,
     .				npts,
     .				status	)
	   IF ( status .NE. ferr_ok ) GOTO 5000
* ... y coordinates
	   CALL EXTRACT_LINE (	cx_buff_y,
     .				memry(mr_y)%ptr,
     .				mr_y,
     .				y_dat,
     .				coord_dim,
     .				ndim,
     .				npts,
     .				status	)
	   IF ( status .NE. ferr_ok ) GOTO 5000

*  For 2d form, npts in each polygon; check PPLUS memory and if needed, 
*  allocate more.  Multiply by 2 because we have X and Y vertices of 
*  polygons, and by 2 again because the call below to 
*       PPLLDX_envelope(5,x_dat,x_dat,ncolor...  
*  loads polygon data after all the previous data.

	   IF (first_polygon .AND. .NOT.oneD_form) THEN
              plot_mem_used = 4* npts* npoly
              CALL REALLO_ENVELOPE(plot_mem_used)

              first_polygon = .FALSE.
              plot_mem_used = 0
              npoly = 0
           ENDIF

* If one of the axes is a depth axis, multiply the corresponding 
* vertices by -1.  Else they don't show up on the plot.
* xlo, xhi, ylo, yhi are from AXIS.INC

           IF (transpz) THEN
              IF ( xlo .GT. xhi )  THEN
                 DO 201 i = 1, npts
                    IF ( y_dat(i) .NE. mr_bad_data(mr_y) )
     .                y_dat(i) = -1.* y_dat(i)
  201            CONTINUE
              ENDIF
   
              IF ( ylo .GT. yhi )  THEN
                 DO 202 i = 1, npts
                    IF ( x_dat(i) .NE. mr_bad_data(mr_x) )
     .                x_dat(i) = -1.* x_dat(i)
  202            CONTINUE
              ENDIF

   	   ELSE

      	      IF ( xlo .GT. xhi )  THEN
                 DO 203 i = 1, npts
                    IF ( x_dat(i) .NE. mr_bad_data(mr_x) )
     .                x_dat(i) = -1.* x_dat(i)
  203            CONTINUE
              ENDIF
   
              IF ( ylo .GT. yhi )  THEN
                 DO 204 i = 1, npts
                    IF ( y_dat(i) .NE. mr_bad_data(mr_y) )
     .                y_dat(i) = -1.* y_dat(i)
  204            CONTINUE
              ENDIF
	   ENDIF  

	   IF (add_lon .NE. 0.) THEN
	      DO 205 i = 1, npts
	         IF ( x_dat(i) .NE. mr_bad_data(mr_x) ) 
     .              x_dat(i) = add_lon + x_dat(i)
  205	      CONTINUE
           ENDIF

* When using log axis transform to log(x).  Scale the points of the
* polygon within the log axis range xlo, xhi to keep something like
* the original shape of the polygon.

	   IF (x_is_log) THEN

*  Find min and max x points in the polygon shape (linear units)

	      xptsmin = ABS(mr_bad_data(mr_x))
	      xptsmax = -1.* xptsmin

	      DO 400 i = 1, npts
		 IF (x_dat(i) .NE. mr_bad_data(mr_x)) THEN 
		    xptsmin = MIN(xptsmin, x_dat(i))
		    xptsmax = MAX(xptsmax, x_dat(i))
		 ENDIF
  400         CONTINUE

	      xptsmean = (xptsmin+xptsmax)/2.

*  Convert the x midpoint to log units, and put the other x points
*  on the page scaled by the axis ends xlo and xhi

	      IF (xptsmean .GT. epsilon) THEN
		 xmeanlog = LOG10(xptsmean)
		 scale = 0.1* (xhi-xlo)	! log axis units

		 DO 410 i = 1, npts
		    xdif = scale*(x_dat(i) - xptsmean)
		    x_dat(i) = xmeanlog + xdif
  410		 CONTINUE
	      ELSE
		 small = xptsmean
		 GO TO 5600
	      ENDIF
	   ENDIF

* When using log axis transform to log(y).  Scale the points of the
* polygon within the log axis range ylo, yhi to keep something like
* the original shape of the polygon.

	   IF (y_is_log) THEN

*  Find min and max y points in the polygon shape (linear units)

	      yptsmin = ABS(mr_bad_data(mr_y))
	      yptsmax = -1.* yptsmin

	      DO 500 i = 1, npts
		 IF (y_dat(i) .NE. mr_bad_data(mr_y)) THEN 
		    yptsmin = MIN(yptsmin, y_dat(i))
		    yptsmax = MAX(yptsmax, y_dat(i))
		 ENDIF
  500         CONTINUE

	      yptsmean = (yptsmin+yptsmax)/2.

*  Convert the y midpoint to log units, and put the other Y points
*  on the page scaled by the axis ends ylo and yhi

	      IF (yptsmean .GT. epsilon) THEN
		 ymeanlog = LOG10(yptsmean)
		 scale = 0.1* (yhi-ylo)	! log axis units

		 DO 510 i = 1, npts
		    ydif = scale*(y_dat(i) - yptsmean)
		    y_dat(i) = ymeanlog + ydif
  510		 CONTINUE
	      ELSE
		 small = yptsmean
		 GO TO 5600
	      ENDIF
	   ENDIF

* ... locate the (next) contiguous segment in the arrays
*    ...search for start of segment
	   missing_polygon = .false.

	   start = npts
	   end   = npts
	   DO 210 i = 1, npts
	      IF ( x_dat(i) .NE. mr_bad_data(mr_x) 
     .       .AND. y_dat(i) .NE. mr_bad_data(mr_y) ) THEN
	         start = i
	         GOTO 220
	      ENDIF
 210	   CONTINUE
	   GOTO 240   ! This polygon is all missing in X - omit		
*    ... find the end of the segment
 220	   DO 230 i = start, npts
	      IF ( x_dat(i) .EQ. mr_bad_data(mr_x) 
     .       .OR.  y_dat(i) .EQ. mr_bad_data(mr_y) ) THEN
	         end = i - 1
	         GOTO 250
	      ENDIF
 230	   CONTINUE

 240	   IF (start .GE. end ) missing_polygon = .true.
	   nsiz = npts


* ... check for adequate PLOT+ memory
 250	   npts = end-start+1

           IF (oneD_form) THEN
              plot_mem_used = plot_mem_used + 3*npts
              CALL reallo_envelope(plot_mem_used)
           ENDIF

c	   IF ( npoly         .GE. NPOLYGON   ) GOTO 5160

* ... maintain check on x data range for PLOT+ auto-scaling
	   CALL MINMAX( x_dat(start), npts, mr_bad_data(mr_x), lo, hi)
	   IF (lo .NE. arbitrary_large_val4) THEN ! if it is arb-large, then all missing
	      IF (lo .LT. lox) lox = lo
	      IF (hi .GT. hix) hix = hi
	   ENDIF
	   CALL MINMAX( y_dat(start), npts, mr_bad_data(mr_y), lo, hi)
	   IF (lo .NE. arbitrary_large_val4) THEN ! if it is arb-large, then all missing
	      IF (lo .LT. loy) loy = lo
	      IF (hi .GT. hiy) hiy = hi
	   ENDIF

* ... pass the data to PLOT+

	   if (overlay) SOVER = .true.

* ... let PPL data loader know what's going on (kludge)
	   makep = 'FILLPOL'

* ... setup for possible overlay on a time axis plot  ? calendar_id here?
	   IF (overlay .AND. has_time_axis  ) THEN
	      dt_min  = saved_dt_min
	      t1_date = saved_t1_date
              IF ( .NOT. oneD_form) THEN
              
*  Check for calendar mismatch for time- overlay plots
*  (but only for 2-D polygon form; 1-D polygon data are
*  just lists on abstract axis.)
*  If the axis is 7 (abstract) then dont do the check either.
                 tax = grid_line(f_dim,cx_grid(cx_x ))
                 IF (tax.EQ.mnormal) tax = grid_line(t_dim,cx_grid(cx_x ))
		 IF (STR_SAME(line_name(tax),'ABSTRACT') .NE. 0) THEN 
                    cal_name = line_cal_name(tax)
                    cal_id = TM_GET_CALENDAR_ID ( cal_name )
                    IF (cal_id .NE. saved_calendar_id) GO TO 5360
                 ENDIF
              ENDIF
	   ELSE
              dt_min  = 1.0
              t1_date = ' '
	   ENDIF

	   IF (missing_polygon) THEN
! for time series overlays, dont load the data

              IF (.NOT. (has_time_axis .AND. overlay)) 
     .    	  CALL PPLLDX_envelope(3,mr_bad_data(mr_x),
     .            mr_bad_data(mr_y),1,t1_date,' ',dt_min,plot_mem_used)
	   ELSE IF ( transpz ) THEN
	      CALL PPLLDX_envelope(3,y_dat(start),x_dat(start),npts,
     .		           t1_date, ' ', dt_min, plot_mem_used)
	   ELSE
	      CALL PPLLDX_envelope(3,x_dat(start),y_dat(start),npts,
     .			   t1_date, ' ', dt_min, plot_mem_used)
	   ENDIF

* ... increment number of lines on plot
	   nline_in_mem = nline_in_mem + 1
	   npoly = npoly + 1
	   ngood = ngood + 1
	   x_dat(nsiz+npoly) = 1.  ! flag for use with color array: poly skipped?

	   IF (missing_polygon .AND. has_time_axis .AND. overlay) THEN
	      nline_in_mem = nline_in_mem - 1
	      ngood = ngood - 1
	      x_dat(nsiz+npoly) = -99  ! flag for use with color array: poly skipped
	   ENDIF

	GOTO 200	! end of DO-WHILE loop
 290	IF (npoly .EQ. 0 ) GOTO 5230


* ... restore normal PPLOT+ operations (else segments get prematurely created)
	   makep = ' '

* NOW set the line style (skipsym used only on line plots, dummy value here)
        do_dash = 0
	skipsym = 1
	CALL LINE_STYLE( symbol, 0.08, skipsym, line_type, line_type, use_line, 
     .                   do_dash, dashstyle, 1, 1 )
     
* release context stack buffers
	cx_stack_ptr = cx_stack_ptr - 2
	stack_up = .FALSE.

* pass the color value array to PLOT+ (use x_dat as a buffer)

	if (nmv .eq. 2) then
	   ncolor = 1
	   x_dat(1) = 0.0
	else
	   CALL EXTRACT_LINE (	cx_color,
     .				memry(mr_color)%ptr,
     .				mr_color,
     .				x_dat,
     .				color_dim,
     .				ndim,
     .				ncolor,
     .				status	)
	   IF ( status .NE. ferr_ok ) GOTO 5000
	endif
	IF (ncolor .EQ. 1) THEN
	   DO 300 ipoly = 1, npoly
 300	   x_dat(ipoly) = x_dat(1)	! single color applied to all pol'gs
	   ncolor = npoly

* for time-axis overlays, mising-polygons are not loaded. Account for that in the color array.
	ELSEIF (ncolor.GT.ngood .AND. has_time_axis .AND. overlay) THEN
	   nc = 0
	   DO ipoly = 1, ncolor
	      IF (x_dat(nsiz+ipoly) .NE. -99.) THEN
	         nc = nc + 1
		 x_dat(nc) = x_dat(ipoly)
	      ENDIF
	   ENDDO
	   ncolor = nc
	ELSE
	   IF (ncolor .NE. npoly) GOTO 5220	! color array length wrong
	ENDIF

* pass back a summary about the range of colors
	no_range = NO_LINE_RANGE(x_dat,
     .				 ncolor, mr_bad_data(mr_color), only_val )

	if (overlay) SOVER = .true.
	makep = 'FILLPOL'   ! that PLOT+ kludge again
	CALL PPLLDX_envelope(5,x_dat,x_dat,ncolor, t1_date, ' ', 
     .                       dt_min,plot_mem_used)


* If needed for the levels setting, compute data mean and std, store
* in common.  If the user set a std to use, store that.
* send 	REAL*4 rbad to compare with lev_max, lev_min inside compute_mnstd
* If the user set some /LEVELS then compute_mnstd just returns 

       rbad = bad_val4
       CALL compute_mnstd (x_dat, mr_bad_data(mr_color), need_std, 
     .    ncolor, rbad, status)
       IF (need_std .AND. status.NE.ferr_ok) THEN
* ... set up for automatic levels
          CALL PPLCMD ( from, line, 0, 'LEV,()', 1, 1 )
          CALL USE_LINEAR_LEVELS
          status = ferr_ok
       ENDIF

* If histogram-based levels are requested, compute the 
* histogram bins.

       IF (need_histo) THEN
* create temporary buffer to contain workspace

	  CALL CREATE_TEMP_MEM_VAR( cx_x, mvh_temp, status )
	  IF ( status .NE. ferr_ok ) RETURN
          plot_mem_used = plot_mem_used + ncolor

	  CALL COMPUTE_HISTO_BINS (x_dat, memry(mvh_temp)%ptr, 
     .       mr_bad_data(mr_color), ncolor, status) 

* ... clean up temporary variable
	  CALL DELETE_VARIABLE( mvh_temp )
       ENDIF

* ... check for adequate PLOT+ memory to store the npts for each poly. 
* ... Save in ppl mem rather than array lleng to remove restriction on
* ... total number of polys that can be plotted.

           plot_mem_used = plot_mem_used + npoly + 1
           CALL reallo_envelope(plot_mem_used)

* reset start indices for extraction
	IF (oneD_form) THEN
	   end  = 0
	ELSE
	   xrow = cx_lo_ss(cx_x,color_dim) - 1
	   yrow = cx_lo_ss(cx_y,color_dim) - 1
	ENDIF

* loop through all the polygons getting their npts;
* loading the counts into PPLUS memory
* ---- 
         DO 700 n = 1, npoly

* ... prepare the context buffer to point to the next polygon 
	   IF ( oneD_form ) THEN
*    ... coords are 1D arrays of p1,p1,p1,p1,BAD,p2,p2,p2,p2,BAD,...
	      cx_lo_ss(cx_buff_x,coord_dim) =
     .	       cx_lo_ss(cx_buff_x,coord_dim) + end   ! advance past end of last
	      cx_lo_ss(cx_buff_y,coord_dim) =
     .	       cx_lo_ss(cx_buff_y,coord_dim) + end
	      IF (cx_lo_ss(cx_buff_x,coord_dim)
     .	     .GE. cx_hi_ss(cx_buff_x,coord_dim)) GOTO 690 ! exit DO_WHILE loop
	   ELSE
*    ... coords are 2D arrays of color_dim X coord_dim
	      xrow = xrow + 1  ! advance to next polygon in the 2D array
	      yrow = yrow + 1  ! advance to next polygon in the 2D array
	      IF (xrow .GT. cx_hi_ss(cx_x,color_dim)) GOTO 690	! exit the DO_WHILE loop
	      cx_lo_ss(cx_buff_x,color_dim) = xrow
	      cx_hi_ss(cx_buff_x,color_dim) = xrow
	      cx_lo_ss(cx_buff_y,color_dim) = yrow
	      cx_hi_ss(cx_buff_y,color_dim) = yrow
	   ENDIF

* ... extract 1-dimensional arrays -- possibly with embedded missing values
* ... x coordinates
	   CALL EXTRACT_LINE (	cx_buff_x,
     .				memry(mr_x)%ptr,
     .				mr_x,
     .				x_dat,
     .				coord_dim,
     .				ndim,
     .				npts,
     .				status	)
	   IF ( status .NE. ferr_ok ) GOTO 5000
* ... y coordinates
	   CALL EXTRACT_LINE (	cx_buff_y,
     .				memry(mr_y)%ptr,
     .				mr_y,
     .				y_dat,
     .				coord_dim,
     .				ndim,
     .				npts,
     .				status	)
	   IF ( status .NE. ferr_ok ) GOTO 5000

* ... check for missing polygon

	   missing_polygon = .false.
	   start = npts
	   end   = npts
	   DO 610 i = 1, npts
	      IF ( x_dat(i) .NE. mr_bad_data(mr_x) 
     .       .AND. y_dat(i) .NE. mr_bad_data(mr_y) ) THEN
	         start = i
	         GOTO 620
	      ENDIF
 610	   CONTINUE
	   GOTO 640   ! This polygon is all missing in X - omit		
*    ... find the end of the segment
 620	   DO 630 i = start, npts
	      IF ( x_dat(i) .EQ. mr_bad_data(mr_x) 
     .       .OR.  y_dat(i) .EQ. mr_bad_data(mr_y) ) THEN
	         end = i - 1
	         GOTO 650
	      ENDIF
 630	   CONTINUE

 640	   IF (start .GE. end ) missing_polygon = .true.

* ... check for adequate PLOT+ memory
 650	   npts = end-start+1

	   IF (missing_polygon) THEN
! for time series overlays, dont load the data
              IF (.NOT. (has_time_axis .AND. overlay)) 
     .    	 CALL pplld_pts_envelope (1, plot_mem_used)
	   ELSE
	      CALL pplld_pts_envelope (npts, plot_mem_used)
	   ENDIF

 700    CONTINUE
 690    CONTINUE
        CALL pplld_pts_envelope (ncolor, plot_mem_used)

	makep = ' '   ! that PLOT+ kludge again

	IF ( .NOT.overlay ) THEN
           CALL PPLCMD ( from, line, 0, 'XFOR 0', 1, 1 )
           CALL PPLCMD ( from, line, 0, 'YFOR 0', 1, 1 )
        ENDIF

* turn on lon/lat axis formatting, if lon/lat units, otherwise off

	IF (.NOT.overlay) THEN
	   iunits = TM_UNIT_ID(VAR_UNITS(cx_x))
	   IF (iunits .EQ. 4) THEN
	      CALL PPLCMD ( from, line, 0, 'XFOR (I7,''''LONE'''')', 1, 1 )
	   else
	      CALL PPLCMD ( from, line, 0, 'XFOR 0', 1, 1 )
	   endif
	   
	   iunits = TM_UNIT_ID(VAR_UNITS(cx_y))
	   IF (iunits .EQ. 4) THEN
	      CALL PPLCMD ( from, line, 0, 'YFOR (I7,''''LAT'''')', 1, 1 )
	   else
	      CALL PPLCMD ( from, line, 0, 'YFOR 0', 1, 1 )
	   endif
	ENDIF


* If xmodulo, check for modulo operation
* Get axis limits - if this is an overlay or the user specified /HLIM

	IF (is_modx .AND. add_lon.EQ.0) THEN
	   IF (overlay) THEN ! Get existing xaxis limits

              buffsym = 'XAXIS_MIN'
              CALL GETSYM( buffsym, buffer, nc, ier )
              READ (buffer, *) vmin
              buffsym = 'XAXIS_MAX'
              CALL GETSYM( buffsym, buffer, nc, ier )
              READ (buffer, *) vmax
	   ELSE IF ( pxdenig .GT. 0 ) THEN 
              tax = grid_line(f_dim,cx_grid(cx_x ))
              IF (tax.EQ.mnormal) tax = grid_line(t_dim,cx_grid(cx_x ))
              cal_name = line_cal_name(tax)
              cal_id = TM_GET_CALENDAR_ID ( cal_name )
	      CALL EQUAL_RANGE( 
     .			cmnd_buff(qual_start(pxdenig):qual_end(pxdenig)),
     .			x_dim, vmin, vmax, delta,
     .			formatted, range_rqd, cal_id, status )
	      IF ( status .NE. ferr_OK ) GOTO 5000
	   ENDIF

	   IF (lox.LT.vmin .OR. hix.LT.vmax) THEN
	      do_mod_plus = .TRUE.
	   ENDIF
	   IF (hix .GT. vmax .OR. lox.GT.vmin) THEN
	      do_mod_minus = .TRUE.
	   ENDIF
	   IF ((do_mod_minus.OR.do_mod_plus) .AND. x_is_log) THEN
	      CALL WARN( '/MODULO ignored on polygon command with log x axis')
	      do_mod_minus = .FALSE.
	      do_mod_plus = .FALSE.
	   ENDIF
        ENDIF

* axis scaling -- only applies if it is a fresh plot (not an overlay)
* most of the work is avoiding an error if there is no data range with
* which to make a scale ...


	IF ( .NOT.overlay ) THEN
	   delta = unspecified_val8
* ... X axis
	   IF ( pxdenig .GT. 0 ) THEN   ! explicit /XLIMITS 10/93
	      IF (pxlim.GT.0 .AND. .NOT.denig_xylim_msg_done) THEN
	         CALL WARN( '/XLIMITS and /YLIMITS are deprecated.')
	         CALL WARN( 'Use /HLIMITS and /VLIMITS instead.')
	         denig_xylim_msg_done = .TRUE.
	      ENDIF
              tax = grid_line(f_dim,cx_grid(cx_x ))
              IF (tax.EQ.mnormal) tax = grid_line(t_dim,cx_grid(cx_x ))
              cal_name = line_cal_name(tax)
              cal_id = TM_GET_CALENDAR_ID ( cal_name )

*  Check for valid log axis before proceeding if log and limits are given
	      IF (is_logx) THEN
	          CALL AXIS_ENDS(x_ax, coord_dim, cx_grid(cx_x), vmin, 
     .			     vmax, delta, x_is_log, x_axtyp, vflag, status )
	         IF ( status .NE. ferr_ok ) THEN
                    first = vmin
                    last  = vmax
                    GOTO 5400
                 ENDIF
              ENDIF

	      CALL EQUAL_RANGE( 
     .			cmnd_buff(qual_start(pxdenig):qual_end(pxdenig)),
     .			x_dim, vmin, vmax, delta,
     .			formatted, range_rqd, cal_id, status )
	      IF ( status .NE. ferr_OK ) GOTO 5000

              CALL AXIS_ENDS(x_ax, coord_dim, cx_grid(cx_x), vmin, 
     .			     vmax, delta, x_is_log, x_axtyp, vflag, status )
		 IF ( status .NE. ferr_ok ) THEN
		 first = vmin
		 last = vmax
		 GOTO 5400
	      ENDIF

	   ELSEIF (lox .GE. hix) THEN
	      IF (lox .EQ. arbitrary_large_val4) lox = 1.0
* ... no data range -- provide artifical axis limits
              CALL AXIS_ENDS(x_ax, coord_dim, cx_grid(cx_x),
     .			DBLE(lox-1.0), DBLE(lox+1.0), 0.5D0, x_is_log, 
     .			x_axtyp, vflag, status )
	      IF ( status .NE. ferr_ok ) THEN
		 first = lox-1.0
		 last = lox+1.0
		 GOTO 5400
	      ENDIF
	   ELSE
              CALL AXIS_ENDS(x_ax,coord_dim,cx_grid(cx_x),
     .	       DBLE(lox),DBLE(hix), delta, x_is_log, x_axtyp, vflag, status )
	      IF ( status .NE. ferr_ok ) THEN
		 first = lox
		 last = hix
		 GOTO 5400
	      ENDIF

	   ENDIF

* turn on lon/lat axis formatting, if lon/lat units, otherwise off

	   iunits = TM_UNIT_ID(VAR_UNITS(cx_x))
	   IF (iunits .EQ. 4) THEN
	      CALL GET_AXIS_FORMAT( DBLE(lox), DBLE(hix), delta, 
     .           fmt, use_nice )
              IF (use_nice) THEN
                  ppl_buff = 'XFOR,('//fmt(:TM_LENSTR1(fmt))//
     .              ',''''LONE'''')' 
                 CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
              ENDIF
           ELSE
	      CALL PPLCMD ( from, line, 0, 'XFOR 0', 1, 1 )
	   ENDIF

* ... Y axis
	   delta = unspecified_val8

	   IF ( pydenig .GT. 0 ) THEN   ! explicit /XLIMITS 10/93
	      IF (pxlim.GT.0 .AND. .NOT.denig_xylim_msg_done) THEN
	         CALL WARN( '/XLIMITS and /YLIMITS are deprecated.')
	         CALL WARN( 'Use /HLIMITS and /VLIMITS instead.')
	         denig_xylim_msg_done = .TRUE.
	      ENDIF
              tax = grid_line(f_dim,cx_grid(cx_x ))
              IF (tax.EQ.mnormal) tax = grid_line(t_dim,cx_grid(cx_x ))
              cal_name = line_cal_name(tax)
              cal_id = TM_GET_CALENDAR_ID ( cal_name )

*  Check for valid log axis before proceeding if log and limits are given
	      IF (y_is_log) THEN 
                 CALL AXIS_ENDS(y_ax,coord_dim,cx_grid(cx_y),
     .			     vmin,vmax,delta, y_is_log, y_axtyp, vflag, status )
	         IF ( status .NE. ferr_ok ) THEN
		    first = vmin
		    last = vmax
		    GOTO 5400
	         ENDIF
	      ENDIF

	      CALL EQUAL_RANGE( 
     .			cmnd_buff(qual_start(pydenig):qual_end(pydenig)),
     .			y_dim, vmin, vmax, delta,
     .			formatted, range_rqd, cal_id, status )
	      IF ( status .NE. ferr_OK ) GOTO 5000
              CALL AXIS_ENDS(y_ax,coord_dim,cx_grid(cx_y),
     .			     vmin,vmax,delta, y_is_log, y_axtyp, vflag, status )
	      IF ( status .NE. ferr_ok ) THEN
		 first = vmin
		 last = vmax
		 GOTO 5400
	      ENDIF
	   ELSEIF (loy .GE. hiy) THEN
	      IF (loy .EQ. arbitrary_large_val4) loy = 1.0
* ... no data range -- provide artifical axis limits
              CALL AXIS_ENDS(y_ax,coord_dim,cx_grid(cx_y),
     .			DBLE(loy-1.0),DBLE(loy+1.0), 0.5D0, y_is_log, 
     .			y_axtyp, vflag, status )
	      IF ( status .NE. ferr_ok ) THEN
		 first = loy-1.0
		 last = loy+1.0
		 GOTO 5400
	      ENDIF
	   ELSE
              CALL AXIS_ENDS(y_ax,coord_dim,cx_grid(cx_y),
     .		DBLE(loy),DBLE(hiy), delta, y_is_log, y_axtyp, vflag, status )
	      IF ( status .NE. ferr_ok ) THEN
		 first = loy
		 last = hiy
		 GOTO 5400
	      ENDIF

	   ENDIF

	   iunits = TM_UNIT_ID(VAR_UNITS(cx_y))
	   IF (iunits .EQ. 4) THEN
	       CALL GET_AXIS_FORMAT( DBLE(loy), DBLE(hiy), delta, 
     .            fmt, use_nice )
               IF (use_nice) THEN
                   ppl_buff = 'YFOR,('//fmt(:TM_LENSTR1(fmt))//
     .               ',''''LAT'''')' 
                  CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
               ENDIF
           ELSE
	      CALL PPLCMD ( from, line, 0, 'YFOR 0', 1, 1 )
	   ENDIF

*   When not an overlay, set the axis type to log or reverse log
	   IF (is_logx .OR. is_logy) THEN
	      WRITE (buff3, 3006) x_axtyp, y_axtyp

 3006         FORMAT ('axtype,', I2, ',', I2)
	      CALL PPLCMD ( from, line, 0, buff3, 1, 1)
	   ENDIF

	ELSE
	ENDIF

	IF ( no_labels ) RETURN

* * * * * * *    - - - LABELS - - -   * * * * * * * * *
* if we are starting from a blank screen each axis is labelled with the units
* of its coordinate variable
* The plot title is derived from the color value variable (unless over-ridden
* by the /TITLE qualifier) and it is placed in a key for overlays or as a
* title for a fresh plot.  If no 3rd argument, label with the word cnst as
* we are using a nominal constant as the 3rd argument.

	IF ( overlay ) THEN
	   IF ( user_title ) THEN
	      CALL EQUAL_STR_LC(
     .			cmnd_buff(qual_start(ptitl):qual_end(ptitl)),
     .                  plot_title, status )
              IF ( status .NE. ferr_ok ) GOTO 5000
	      slen = TM_LENSTR1( plot_title )
	   ELSE
	      IF (nmv .EQ. 3) THEN
	         CALL OV_GRP_CX_DOC( cx_color, 1, cx_xtra_doc )
	         plot_title = KEY_STRING( cx_color, cx_xtra_doc, slen )
	      ENDIF
	      IF (nmv .EQ. 2) THEN
	         plot_title = 'cnst'
	         slen = 4
	      ENDIF
	   ENDIF
           IF (no_range .AND. (only_val.EQ.mr_bad_data(mr_color)) ) THEN
              plot_title(slen+1:slen+14) = ' No Valid Data'
              slen = slen + 14
           ENDIF
	   CALL KEY_LOC( overlay, xkeypos, ykeypos, xkeysize, ykeysize,
     .			 lab_ht, style, justify, plot_title(:slen) )
*          Key uses line 1
	   CALL PUT_KEY( 1, plot_title(:slen),
     .			 xkeypos, ykeypos, xkeysize, ykeysize,
     .			 lab_ht, style, lab_loc_absolute, lab_loc_absolute )
	ELSE
* ... basic position and data set labels
	   CALL DISP_LABELS( cx_plot, unspecified_name4, cal_id)
* ... title
	   IF ( user_title ) THEN     ! user over-ride of title
	      CALL EQUAL_STR_LC
     .		( cmnd_buff(qual_start(ptitl):qual_end(ptitl)),
     .            plot_title, status )
              IF ( status .NE. ferr_ok ) GOTO 5000
	      slen = TM_LENSTR1( plot_title )
	   ELSE
	      plot_title = FULL_VAR_TITLE( cx_color, do_units, slen )
	   ENDIF
	   CALL BOX_LABEL( ppl_title,
     .			 plot_title(:slen),
     .			 0.0, 0.0, 0.75*xlen, letsize_title,
     .			 letsize_title, ppl_centered,
     .			 lab_loc_absolute, lab_loc_absolute )
* ... label axis labels:  units from the polygon coordinates

	   plot_title = FULL_VAR_TITLE( cx_x, do_units, slen )

C	   plot_title = VAR_UNITS( cx_x )
C	   slen = TM_LENSTR1( plot_title )
	   CALL BOX_LABEL( x_lab,
     .			 plot_title(:slen),
     .			 0.0, 0.0, 0.6*x_len, letsize_label,
     .			 letsize_label, ppl_centered,
     .			 lab_loc_absolute, lab_loc_absolute )

	   plot_title = FULL_VAR_TITLE( cx_y, do_units, slen )

C	   plot_title = VAR_UNITS( cx_y )
C	   slen = TM_LENSTR1( plot_title )
	   CALL BOX_LABEL( y_lab,
     .			 plot_title(:slen),
     .			 0.0, 0.0, 0.6*y_len, letsize_label,
     .			 letsize_label, ppl_centered,
     .			 lab_loc_absolute, lab_loc_absolute )
	 ENDIF

* successful completion
 1000	status = ferr_ok
	RETURN

* error exit
 5000	CALL PPLCMD ( from, line, 0, 'NLINES', 1, 1 )	! wipe buffers clean
	IF (stack_up) cx_stack_ptr = cx_stack_ptr - 2
	RETURN
! 5150	buff = LEFINT( INT(0.99*pplmem_nsize), slen )
!	CALL ERRMSG( ferr_prog_limit, status,
!     .		'Plot buffer size is: '//buff(:slen), *5000 )
 5160	buff = LEFINT( NPOLYGON, slen )
	CALL ERRMSG( ferr_prog_limit, status,
     .		'Maximum polygons is: '//buff(:slen), *5000 )
 5200	CALL ERRMSG( ferr_invalid_command, status,
     .		'POLYGON may use 2 args (xpts,ypts) with /LINE only,' //
     .          ' or 3 args (xpts,ypts,color_value)',
     .		*5000)
 5210	CALL ERRMSG( ferr_invalid_command, status,
     .		'illegal dimensions for polygon coordinate(s) or values',
     .		*5000)
 5220	buff2 = LEFINT(npoly, slen2)
	buff  = LEFINT(ncolor, slen) 
	CALL ERRMSG( ferr_invalid_command, status,
     .		'no. of values ('//buff(:slen)//') '//
     .		'doesnt match no. of polygons ('//buff2(:slen2)//')', 
     .		*5000)
 5230	CALL ERRMSG( ferr_invalid_command, status,
     .		'zero polygons specified',
     .		*5000)
 5300	CALL ERRMSG( ferr_invalid_command, status,
     .		'invalid argument to /COORD_AX=',
     .		*5000)

 5360	cal_name = TM_GET_CALENDAR_NAME(cal_id)
        cal_name_saved = TM_GET_CALENDAR_NAME(saved_calendar_id)
        slen = TM_LENSTR1 (cal_name_saved)
        slen2 = TM_LENSTR1(cal_name)
	CALL ERRMSG( ferr_inconsist_grid, status,
     .          'Differing calendar axes: '//pCR//
     .		'first variable is on '//cal_name_saved(:slen)//
     .		' axis'//pCR//
     .		'overlaid variable is on '//cal_name(:slen2)//
     .		' axis', *5000 )

 5400	buff3 = LEFT_REAL (first, '(G15.3)', slen)
	buff4 = LEFT_REAL (last,  '(G15.3)', slen2)
	CALL ERRMSG( ferr_out_of_range, status,
     . 'Limits for log axis negative or too small: '//
     .  buff3(:slen)// ' : '//  buff4(:slen2), *5000 )

 5600	buff3 = LEFT_REAL (small, '(G15.3)', slen)
	CALL ERRMSG( ferr_out_of_range, status,
     . 'X coordinates on log axis negative or too small : '//
     .  buff3(:slen), *5000 )
	END

*
* time_reformat.F
*
* Jan 2015
*
* Given a time string, translate it to a Ferret-formatted string
*   dd-Mon-YYYY hh:mm:ss
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, time_reformat )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )


      SUBROUTINE time_reformat_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     . 'Returns date string(s) reformatted to Ferret time-string format' )

      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance_6d(id, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_result_type(id, STRING_RETURN)

      arg = 1
      CALL ef_set_arg_type (id, arg, STRING_ARG)

      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 
     . 'Time string(s) to convert, e.g. 1992-04-23 12:30:01')
      CALL ef_set_axis_influence_6d(id, arg, YES, YES, YES, YES, YES, YES)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

* In this subroutine we compute the result
*
      SUBROUTINE time_reformat_compute(id, arg_1, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)



* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1

      INTEGER rtype, slen, status
      CHARACTER*20 indate, outdate
      CHARACTER*128 err_msg
      INTEGER cal_id

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_result_type(id, rtype)

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      i1 = arg_lo_ss(X_AXIS,ARG1)
      DO 600 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 500 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            DO 400 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               l1 = arg_lo_ss(T_AXIS,ARG1)
               DO 300 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

               m1 = arg_lo_ss(E_AXIS,ARG1)
               DO 200 m=res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

               n1 = arg_lo_ss(F_AXIS,ARG1)
               DO 100 n=res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

C   Reformat the date string and put into the result.

                  CALL ef_get_string_arg_element_6d(id, ARG1, arg_1,
     .                i1,j1,k1,l1,m1,n1,slen,indate)

                 CALL TAX_REFORMAT_DATE (indate, outdate, status)
		 IF (outdate(1:3) .EQ. 'xxx') GOTO 5000

                 slen = 20
                 CALL EF_PUT_STRING (outdate, slen,
     .                    result(i,j,k,l,m,n))

                  n1 = n1 + arg_incr(F_AXIS,ARG1)
 100           CONTINUE
                 
                  m1 = m1 + arg_incr(E_AXIS,ARG1)
 200           CONTINUE
                 
                  l1 = l1 + arg_incr(T_AXIS,ARG1)
 300           CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
 400        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 500     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
 600  CONTINUE
     
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
 5000 err_msg = 'Could not translate string to Ferret date format '// indate
      CALL ef_bail_out (id, err_msg)

      END

      INTEGER FUNCTION I1MACH(I)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* modified by steve hankin to contain explicit declarations
	INTEGER	I

C***BEGIN PROLOGUE  I1MACH
C***DATE WRITTEN   750101   (YYMMDD)
C***REVISION DATE  840405   (YYMMDD)
C***CATEGORY NO.  R1
C***KEYWORDS  MACHINE CONSTANTS
C***AUTHOR  FOX, P. A., (BELL LABS)
C           HALL, A. D., (BELL LABS)
C           SCHRYER, N. L., (BELL LABS)
C***PURPOSE  RETURNS INTEGER MACHINE DEPENDENT CONSTANTS
C***DESCRIPTION
C
C * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C   THESE MACHINE CONSTANT ROUTINES MUST BE ACTIVATED FOR
C   A PARTICULAR ENVIRONMENT.
C * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C
C     I1MACH CAN BE USED TO OBTAIN MACHINE-DEPENDENT PARAMETERS
C     FOR THE LOCAL MACHINE ENVIRONMENT.  IT IS A FUNCTION
C     SUBROUTINE WITH ONE (INPUT) ARGUMENT, AND CAN BE CALLED
C     AS FOLLOWS, FOR EXAMPLE
C
C          K = I1MACH(I)
C
C     WHERE I=1,...,16.  THE (OUTPUT) VALUE OF K ABOVE IS
C     DETERMINED BY THE (INPUT) VALUE OF I.  THE RESULTS FOR
C     VARIOUS VALUES OF I ARE DISCUSSED BELOW.
C
C  I/O UNIT NUMBERS.
C    I1MACH( 1) = THE STANDARD INPUT UNIT.
C    I1MACH( 2) = THE STANDARD OUTPUT UNIT.
C    I1MACH( 3) = THE STANDARD PUNCH UNIT.
C    I1MACH( 4) = THE STANDARD ERROR MESSAGE UNIT.
C
C  WORDS.
C    I1MACH( 5) = THE NUMBER OF BITS PER INTEGER STORAGE UNIT.
C    I1MACH( 6) = THE NUMBER OF CHARACTERS PER INTEGER STORAGE UNIT.
C
C  INTEGERS.
C    ASSUME INTEGERS ARE REPRESENTED IN THE S-DIGIT, BASE-A FORM
C
C               SIGN ( X(S-1)*A**(S-1) + ... + X(1)*A + X(0) )
C
C               WHERE 0 .LE. X(I) .LT. A FOR I=0,...,S-1.
C    I1MACH( 7) = A, THE BASE.
C    I1MACH( 8) = S, THE NUMBER OF BASE-A DIGITS.
C    I1MACH( 9) = A**S - 1, THE LARGEST MAGNITUDE.
C
C  FLOATING-POINT NUMBERS.
C    ASSUME FLOATING-POINT NUMBERS ARE REPRESENTED IN THE T-DIGIT,
C    BASE-B FORM
C               SIGN (B**E)*( (X(1)/B) + ... + (X(T)/B**T) )
C
C               WHERE 0 .LE. X(I) .LT. B FOR I=1,...,T,
C               0 .LT. X(1), AND EMIN .LE. E .LE. EMAX.
C    I1MACH(10) = B, THE BASE.
C
C  SINGLE-PRECISION
C    I1MACH(11) = T, THE NUMBER OF BASE-B DIGITS.
C    I1MACH(12) = EMIN, THE SMALLEST EXPONENT E.
C    I1MACH(13) = EMAX, THE LARGEST EXPONENT E.
C
C  DOUBLE-PRECISION
C    I1MACH(14) = T, THE NUMBER OF BASE-B DIGITS.
C    I1MACH(15) = EMIN, THE SMALLEST EXPONENT E.
C    I1MACH(16) = EMAX, THE LARGEST EXPONENT E.
C
C  TO ALTER THIS FUNCTION FOR A PARTICULAR ENVIRONMENT,
C  THE DESIRED SET OF DATA STATEMENTS SHOULD BE ACTIVATED BY
C  REMOVING THE C FROM COLUMN 1.  ALSO, THE VALUES OF
C  I1MACH(1) - I1MACH(4) SHOULD BE CHECKED FOR CONSISTENCY
C  WITH THE LOCAL OPERATING SYSTEM.
C***REFERENCES  FOX P.A., HALL A.D., SCHRYER N.L.,*FRAMEWORK FOR A
C                 PORTABLE LIBRARY*, ACM TRANSACTIONS ON MATHEMATICAL
C                 SOFTWARE, VOL. 4, NO. 2, JUNE 1978, PP. 177-188.
C***ROUTINES CALLED  (NONE)
C***END PROLOGUE  I1MACH
C
      INTEGER IMACH(16),OUTPUT
      EQUIVALENCE (IMACH(4),OUTPUT)
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 1700 SYSTEM.
C
C     DATA IMACH( 1) /    7 /
C     DATA IMACH( 2) /    2 /
C     DATA IMACH( 3) /    2 /
C     DATA IMACH( 4) /    2 /
C     DATA IMACH( 5) /   36 /
C     DATA IMACH( 6) /    4 /
C     DATA IMACH( 7) /    2 /
C     DATA IMACH( 8) /   33 /
C     DATA IMACH( 9) / Z1FFFFFFFF /
C     DATA IMACH(10) /    2 /
C     DATA IMACH(11) /   24 /
C     DATA IMACH(12) / -256 /
C     DATA IMACH(13) /  255 /
C     DATA IMACH(14) /   60 /
C     DATA IMACH(15) / -256 /
C     DATA IMACH(16) /  255 /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 5700 SYSTEM.
C
C     DATA IMACH( 1) /   5 /
C     DATA IMACH( 2) /   6 /
C     DATA IMACH( 3) /   7 /
C     DATA IMACH( 4) /   6 /
C     DATA IMACH( 5) /  48 /
C     DATA IMACH( 6) /   6 /
C     DATA IMACH( 7) /   2 /
C     DATA IMACH( 8) /  39 /
C     DATA IMACH( 9) / O0007777777777777 /
C     DATA IMACH(10) /   8 /
C     DATA IMACH(11) /  13 /
C     DATA IMACH(12) / -50 /
C     DATA IMACH(13) /  76 /
C     DATA IMACH(14) /  26 /
C     DATA IMACH(15) / -50 /
C     DATA IMACH(16) /  76 /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 6700/7700 SYSTEMS.
C
C     DATA IMACH( 1) /   5 /
C     DATA IMACH( 2) /   6 /
C     DATA IMACH( 3) /   7 /
C     DATA IMACH( 4) /   6 /
C     DATA IMACH( 5) /  48 /
C     DATA IMACH( 6) /   6 /
C     DATA IMACH( 7) /   2 /
C     DATA IMACH( 8) /  39 /
C     DATA IMACH( 9) / O0007777777777777 /
C     DATA IMACH(10) /   8 /
C     DATA IMACH(11) /  13 /
C     DATA IMACH(12) / -50 /
C     DATA IMACH(13) /  76 /
C     DATA IMACH(14) /  26 /
C     DATA IMACH(15) / -32754 /
C     DATA IMACH(16) /  32780 /
C
C
C     MACHINE CONSTANTS FOR THE CDC CYBER 170 SERIES (FTN5).
C
C     DATA IMACH( 1) /    5 /
C     DATA IMACH( 2) /    6 /
C     DATA IMACH( 3) /    7 /
C     DATA IMACH( 4) /    6 /
C     DATA IMACH( 5) /   60 /
C     DATA IMACH( 6) /   10 /
C     DATA IMACH( 7) /    2 /
C     DATA IMACH( 8) /   48 /
C     DATA IMACH( 9) / O"00007777777777777777" /
C     DATA IMACH(10) /    2 /
C     DATA IMACH(11) /   48 /
C     DATA IMACH(12) / -974 /
C     DATA IMACH(13) / 1070 /
C     DATA IMACH(14) /   96 /
C     DATA IMACH(15) / -927 /
C     DATA IMACH(16) / 1070 /
C
C     MACHINE CONSTANTS FOR THE CDC CYBER 200 SERIES
C
C     DATA IMACH( 1) /      5 /
C     DATA IMACH( 2) /      6 /
C     DATA IMACH( 3) /      7 /
C     DATA IMACH( 4) /      6 /
C     DATA IMACH( 5) /     64 /
C     DATA IMACH( 6) /      8 /
C     DATA IMACH( 7) /      2 /
C     DATA IMACH( 8) /     47 /
C     DATA IMACH( 9) / X'00007FFFFFFFFFFF' /
C     DATA IMACH(10) /      2 /
C     DATA IMACH(11) /     47 /
C     DATA IMACH(12) / -28625 /
C     DATA IMACH(13) /  28718 /
C     DATA IMACH(14) /     94 /
C     DATA IMACH(15) / -28625 /
C     DATA IMACH(16) /  28718 /
C
C
C     MACHINE CONSTANTS FOR THE CDC 6000/7000 SERIES.
C
C     DATA IMACH( 1) /    5 /
C     DATA IMACH( 2) /    6 /
C     DATA IMACH( 3) /    7 /
C     DATA IMACH( 4) /6LOUTPUT/
C     DATA IMACH( 5) /   60 /
C     DATA IMACH( 6) /   10 /
C     DATA IMACH( 7) /    2 /
C     DATA IMACH( 8) /   48 /
C     DATA IMACH( 9) / 00007777777777777777B /
C     DATA IMACH(10) /    2 /
C     DATA IMACH(11) /   47 /
C     DATA IMACH(12) / -929 /
C     DATA IMACH(13) / 1070 /
C     DATA IMACH(14) /   94 /
C     DATA IMACH(15) / -929 /
C     DATA IMACH(16) / 1069 /
C
C     MACHINE CONSTANTS FOR THE CRAY 1
C
C     DATA IMACH( 1) /   100 /
C     DATA IMACH( 2) /   101 /
C     DATA IMACH( 3) /   102 /
C     DATA IMACH( 4) /   101 /
C     DATA IMACH( 5) /    64 /
C     DATA IMACH( 6) /     8 /
C     DATA IMACH( 7) /     2 /
C     DATA IMACH( 8) /    63 /
C     DATA IMACH( 9) /  777777777777777777777B /
C     DATA IMACH(10) /     2 /
C     DATA IMACH(11) /    47 /
C     DATA IMACH(12) / -8189 /
C     DATA IMACH(13) /  8190 /
C     DATA IMACH(14) /    94 /
C     DATA IMACH(15) / -8099 /
C     DATA IMACH(16) /  8190 /
C
C     MACHINE CONSTANTS FOR THE DATA GENERAL ECLIPSE S/200
C
C     DATA IMACH( 1) /   11 /
C     DATA IMACH( 2) /   12 /
C     DATA IMACH( 3) /    8 /
C     DATA IMACH( 4) /   10 /
C     DATA IMACH( 5) /   16 /
C     DATA IMACH( 6) /    2 /
C     DATA IMACH( 7) /    2 /
C     DATA IMACH( 8) /   15 /
C     DATA IMACH( 9) /32767 /
C     DATA IMACH(10) /   16 /
C     DATA IMACH(11) /    6 /
C     DATA IMACH(12) /  -64 /
C     DATA IMACH(13) /   63 /
C     DATA IMACH(14) /   14 /
C     DATA IMACH(15) /  -64 /
C     DATA IMACH(16) /   63 /
C
C     MACHINE CONSTANTS FOR THE HARRIS 220
C
C     DATA IMACH( 1) /       5 /
C     DATA IMACH( 2) /       6 /
C     DATA IMACH( 3) /       0 /
C     DATA IMACH( 4) /       6 /
C     DATA IMACH( 5) /      24 /
C     DATA IMACH( 6) /       3 /
C     DATA IMACH( 7) /       2 /
C     DATA IMACH( 8) /      23 /
C     DATA IMACH( 9) / 8388607 /
C     DATA IMACH(10) /       2 /
C     DATA IMACH(11) /      23 /
C     DATA IMACH(12) /    -127 /
C     DATA IMACH(13) /     127 /
C     DATA IMACH(14) /      38 /
C     DATA IMACH(15) /    -127 /
C     DATA IMACH(16) /     127 /
C
C     MACHINE CONSTANTS FOR THE HONEYWELL 600/6000 SERIES.
C
C     DATA IMACH( 1) /    5 /
C     DATA IMACH( 2) /    6 /
C     DATA IMACH( 3) /   43 /
C     DATA IMACH( 4) /    6 /
C     DATA IMACH( 5) /   36 /
C     DATA IMACH( 6) /    6 /
C     DATA IMACH( 7) /    2 /
C     DATA IMACH( 8) /   35 /
C     DATA IMACH( 9) / O377777777777 /
C     DATA IMACH(10) /    2 /
C     DATA IMACH(11) /   27 /
C     DATA IMACH(12) / -127 /
C     DATA IMACH(13) /  127 /
C     DATA IMACH(14) /   63 /
C     DATA IMACH(15) / -127 /
C     DATA IMACH(16) /  127 /
C
C     MACHINE CONSTANTS FOR THE HP 2100
C     3 WORD DOUBLE PRECISION OPTION WITH FTN4
C
C     DATA IMACH(1) /      5/
C     DATA IMACH(2) /      6 /
C     DATA IMACH(3) /      4 /
C     DATA IMACH(4) /      1 /
C     DATA IMACH(5) /     16 /
C     DATA IMACH(6) /      2 /
C     DATA IMACH(7) /      2 /
C     DATA IMACH(8) /     15 /
C     DATA IMACH(9) /  32767 /
C     DATA IMACH(10)/      2 /
C     DATA IMACH(11)/     23 /
C     DATA IMACH(12)/   -128 /
C     DATA IMACH(13)/    127 /
C     DATA IMACH(14)/     39 /
C     DATA IMACH(15)/   -128 /
C     DATA IMACH(16)/    127 /
C
C     MACHINE CONSTANTS FOR THE HP 2100
C     4 WORD DOUBLE PRECISION OPTION WITH FTN4
C
C     DATA IMACH(1) /      5 /
C     DATA IMACH(2) /      6 /
C     DATA IMACH(3) /      4 /
C     DATA IMACH(4) /      1 /
C     DATA IMACH(5) /     16 /
C     DATA IMACH(6) /      2 /
C     DATA IMACH(7) /      2 /
C     DATA IMACH(8) /     15 /
C     DATA IMACH(9) /  32767 /
C     DATA IMACH(10)/      2 /
C     DATA IMACH(11)/     23 /
C     DATA IMACH(12)/   -128 /
C     DATA IMACH(13)/    127 /
C     DATA IMACH(14)/     55 /
C     DATA IMACH(15)/   -128 /
C     DATA IMACH(16)/    127 /
C
C     MACHINE CONSTANTS FOR THE IBM 360/370 SERIES,
C     THE XEROX SIGMA 5/7/9, THE SEL SYSTEMS 85/86, AND
C     THE PERKIN ELMER (INTERDATA) 7/32.
C
C     DATA IMACH( 1) /   5 /
C     DATA IMACH( 2) /   6 /
C     DATA IMACH( 3) /   7 /
C     DATA IMACH( 4) /   6 /
C     DATA IMACH( 5) /  32 /
C     DATA IMACH( 6) /   4 /
C     DATA IMACH( 7) /  16 /
C     DATA IMACH( 8) /  31 /
C     DATA IMACH( 9) / Z7FFFFFFF /
C     DATA IMACH(10) /  16 /
C     DATA IMACH(11) /   6 /
C     DATA IMACH(12) / -64 /
C     DATA IMACH(13) /  63 /
C     DATA IMACH(14) /  14 /
C     DATA IMACH(15) / -64 /
C     DATA IMACH(16) /  63 /
C
C     MACHINE CONSTANTS FOR THE PDP-10 (KA PROCESSOR).
C
C     DATA IMACH( 1) /    5 /
C     DATA IMACH( 2) /    6 /
C     DATA IMACH( 3) /    5 /
C     DATA IMACH( 4) /    6 /
C     DATA IMACH( 5) /   36 /
C     DATA IMACH( 6) /    5 /
C     DATA IMACH( 7) /    2 /
C     DATA IMACH( 8) /   35 /
C     DATA IMACH( 9) / "377777777777 /
C     DATA IMACH(10) /    2 /
C     DATA IMACH(11) /   27 /
C     DATA IMACH(12) / -128 /
C     DATA IMACH(13) /  127 /
C     DATA IMACH(14) /   54 /
C     DATA IMACH(15) / -101 /
C     DATA IMACH(16) /  127 /
C
C     MACHINE CONSTANTS FOR THE PDP-10 (KI PROCESSOR).
C
C     DATA IMACH( 1) /    5 /
C     DATA IMACH( 2) /    6 /
C     DATA IMACH( 3) /    5 /
C     DATA IMACH( 4) /    6 /
C     DATA IMACH( 5) /   36 /
C     DATA IMACH( 6) /    5 /
C     DATA IMACH( 7) /    2 /
C     DATA IMACH( 8) /   35 /
C     DATA IMACH( 9) / "377777777777 /
C     DATA IMACH(10) /    2 /
C     DATA IMACH(11) /   27 /
C     DATA IMACH(12) / -128 /
C     DATA IMACH(13) /  127 /
C     DATA IMACH(14) /   62 /
C     DATA IMACH(15) / -128 /
C     DATA IMACH(16) /  127 /
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRAN SUPPORTING
C     32-BIT INTEGER ARITHMETIC.
C
C     DATA IMACH( 1) /    5 /
C     DATA IMACH( 2) /    6 /
C     DATA IMACH( 3) /    5 /
C     DATA IMACH( 4) /    6 /
C     DATA IMACH( 5) /   32 /
C     DATA IMACH( 6) /    4 /
C     DATA IMACH( 7) /    2 /
C     DATA IMACH( 8) /   31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /    2 /
C     DATA IMACH(11) /   24 /
C     DATA IMACH(12) / -127 /
C     DATA IMACH(13) /  127 /
C     DATA IMACH(14) /   56 /
C     DATA IMACH(15) / -127 /
C     DATA IMACH(16) /  127 /
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRAN SUPPORTING
C     16-BIT INTEGER ARITHMETIC.
C
C     DATA IMACH( 1) /    5 /
C     DATA IMACH( 2) /    6 /
C     DATA IMACH( 3) /    5 /
C     DATA IMACH( 4) /    6 /
C     DATA IMACH( 5) /   16 /
C     DATA IMACH( 6) /    2 /
C     DATA IMACH( 7) /    2 /
C     DATA IMACH( 8) /   15 /
C     DATA IMACH( 9) / 32767 /
C     DATA IMACH(10) /    2 /
C     DATA IMACH(11) /   24 /
C     DATA IMACH(12) / -127 /
C     DATA IMACH(13) /  127 /
C     DATA IMACH(14) /   56 /
C     DATA IMACH(15) / -127 /
C     DATA IMACH(16) /  127 /
C
C     MACHINE CONSTANTS FOR THE UNIVAC 1100 SERIES. FTN COMPILER
C
C
C     DATA IMACH( 1) /    5 /
C     DATA IMACH( 2) /    6 /
C     DATA IMACH( 3) /    1 /
C     DATA IMACH( 4) /    6 /
C     DATA IMACH( 5) /   36 /
C     DATA IMACH( 6) /    4 /
C     DATA IMACH( 7) /    2 /
C     DATA IMACH( 8) /   35 /
C     DATA IMACH( 9) / O377777777777 /
C     DATA IMACH(10) /    2 /
C     DATA IMACH(11) /   27 /
C     DATA IMACH(12) / -128 /
C     DATA IMACH(13) /  127 /
C     DATA IMACH(14) /   60 /
C     DATA IMACH(15) /-1024 /
C     DATA IMACH(16) / 1023 /
C
C
C     MACHINE CONSTANTS FOR THE VAX 11/780
C
      DATA IMACH(1) /    5 /
      DATA IMACH(2) /    6 /
      DATA IMACH(3) /    5 /
      DATA IMACH(4) /    6 /
      DATA IMACH(5) /   32 /
      DATA IMACH(6) /    4 /
      DATA IMACH(7) /    2 /
      DATA IMACH(8) /   31 /
      DATA IMACH(9) /2147483647 /
      DATA IMACH(10)/    2 /
      DATA IMACH(11)/   24 /
      DATA IMACH(12)/ -127 /
      DATA IMACH(13)/  127 /
      DATA IMACH(14)/   56 /
      DATA IMACH(15)/ -127 /
      DATA IMACH(16)/  127 /
C
C     MACHINE CONSTANTS FOR THE Z80 MICROPROCESSOR
C
C     DATA IMACH( 1) /     1/
C     DATA IMACH( 2) /     1/
C     DATA IMACH( 3) /     0/
C     DATA IMACH( 4) /     1/
C     DATA IMACH( 5) /    16/
C     DATA IMACH( 6) /     2/
C     DATA IMACH( 7) /     2/
C     DATA IMACH( 8) /    15/
C     DATA IMACH( 9) / 32767/
C     DATA IMACH(10) /     2/
C     DATA IMACH(11) /    24/
C     DATA IMACH(12) /  -127/
C     DATA IMACH(13) /   127/
C     DATA IMACH(14) /    56/
C     DATA IMACH(15) /  -127/
C     DATA IMACH(16) /   127/
C
C                               
C***FIRST EXECUTABLE STATEMENT  I1MACH
      IF (I .LT. 1  .OR.  I .GT. 16) GO TO 10
C
      I1MACH=IMACH(I)
      RETURN
C
   10 CONTINUE
      WRITE(OUTPUT,9000)
9000  FORMAT('1ERROR    1 IN I1MACH - I OUT OF BOUNDS ')
C
C     CALL FDUMP
C
C
      STOP
      END

	SUBROUTINE LEVSET(IST,VAL,INTIF,LWGH,NL)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)levset.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**

* V510 *sh* 3/00 - bug fix - "DEL" ignored because of misspelling of lwgh
* V62+ *acm 6/09 - bug fix #1672 too few levels computed depending on the values
* V62+ *acm 6/09 - rename variable IF to INTIF
* V630  *acm* 9/09 Introduction of syntax for variance-based and histogram levels
* V631 *acm* 10/09 For the fix to bug 1672(present only in 32-bit linux), the
*                  comparison must be done with TM_FPEQ. This was the cause of bug 1707.
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus

	INCLUDE 'CMRDL.INC'

	DIMENSION VAL(4),INTIF(4)
	LOGICAL TM_FPEQ_SNGL
	REAL top

	LWGH=0
	IF(INDEX(LABEL(:IST),'DEL').NE.0)LWGH=5
	IF(INDEX(LABEL(:IST),'PEN').NE.0)LWGH=4
	IF(INDEX(LABEL(:IST),'DASH').NE.0)LWGH=3
	IF(INDEX(LABEL(:IST),'DARK').NE.0)LWGH=2
	IF(INDEX(LABEL(:IST),'LINE').NE.0)LWGH=1
	IF(INTIF(2).EQ.0)THEN
	   NL=1
	ELSE
	   IF(INTIF(3).EQ.0)THEN
	      VAL(3)=VAL(2)-VAL(1)
	      NL=2
	   ELSE

	      IF(VAL(3).NE.0.)THEN
		 NL = INT((VAL(2)-VAL(1))/VAL(3))+1
		 top = VAL(1)+(NL-1)*VAL(3)
		 IF ( (top .LT. VAL(2)) .AND. 
     .                (.NOT.TM_FPEQ_SNGL(val(2),top)) ) NL = NL + 1 
	      ELSE
		 NL=2
	      ENDIF

	   ENDIF
	ENDIF
	RETURN
	END

	SUBROUTINE SHORT_MOD_COPY(  res_lo, res_hi, idim,
     .				   tcom_cx, tcom_mr, res_cx, res_mr)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* copy into the result over the range lo:hi from the component data
* the range lo:hi is assumed to be not more than Nmod points

* copying takes place in 2 stages ... with possible voids before,between,
* and after.

* the "t" in tcom_cx and tcom_mr refer to the fact that these are temporary
* information -- they may be modified

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V420: 11/95 - to accomodate modulo stripped on the main INTERP_STACK
*	12/95 - fixed bug for negative subscripts
* V533: *sh* 6/01 - added logic to cope with strides
* V541: *sh*  2/02 - support for subspan modulo axes
*	See NOTE in code below
* 560: *acm* 4/04 - stride/modulo fixes: use NINT to convert REAL*8 to integer
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'
	include	'xtext_info.cmn'

* calling argument declarations:
	INTEGER	res_lo, res_hi, idim, tcom_cx, tcom_mr, res_cx, res_mr

* internal variable declarations:
	INTEGER CAXIS_MODLEN, MODULO_PARITY,
     .		npts, com_lo, com_hi, com_nshf, res_nshf,
     .		nshift, xlate, uplim, idel,
     .		cx_lo_sav, cx_hi_sav, mr_lo_sav, mr_hi_sav


* --- end of introductory code ---

* The diagram below illustrates the component and result regions relative
* to the modulo axis replications

* |++++++++|--------|--------|--------|--------|   <-- replicated modulo axis
*                |--------|			   <-- component received
*                                 |-----|	   <-- result requested

* The copy takes place in two steps.

* Step 1: The component is shifted so that the start of the result
*	  region lies within the component span (if possible)
*	  As much data as is possible contiguously is then copied
* |++++++++|--------|--------|--------|--------|   <-- replicated modulo axis
*                         |--------|		   <-- shifted component
*                                 |-----|	   <-- result requested

* Step 2: The component is shifted so that the start of the component
*	  region lies within the result span (if possible)
*	  As much data as is possible contiguously is then copied
* |++++++++|--------|--------|--------|--------|   <-- replicated modulo axis
*                                  |--------|	   <-- shifted component
*                                 |-----|	   <-- result requested

* save to restore at end
	cx_lo_sav = cx_lo_ss(tcom_cx, idim)
	cx_hi_sav = cx_hi_ss(tcom_cx, idim)
	mr_lo_sav = mr_lo_ss(tcom_mr, idim)
	mr_hi_sav = mr_hi_ss(tcom_mr, idim)

* initialize
	npts = CAXIS_MODLEN( idim, tcom_cx )	! length of modulo axis
	com_lo = cx_lo_ss(tcom_cx, idim)
	com_hi = MIN( cx_hi_ss(tcom_cx,idim), com_lo+npts-1 )	
	IF (cx_delta(idim,res_cx) .EQ. unspecified_val8) THEN
	   idel = 1
	ELSE
	   idel = NINT(cx_delta(idim,res_cx))
	ENDIF

* initialize the modulo shifting
	IF ( com_lo .GT. 0 ) THEN
	   com_nshf = (com_lo - 1) / npts
	ELSE
	   com_nshf = (com_lo / npts ) - 1
	ENDIF
	IF ( res_lo .GT. 0 ) THEN
	   res_nshf = (res_lo - 1) / npts
	ELSE
	   res_nshf = (res_lo / npts) - 1
	ENDIF
	nshift = res_nshf - com_nshf

* STEP 1
* shift component so the start of the result lies within the component range
	xlate = npts * nshift
	IF ( res_lo.GT.com_hi+xlate ) xlate = xlate - npts
	IF ( res_lo.LT.com_lo+xlate ) xlate = xlate + npts
	IF ( res_lo.GE.com_lo+xlate .AND. res_lo.LE.com_hi+xlate ) THEN
* ... copy the region (if the parity matches)
	   uplim = MIN( res_hi, com_hi+xlate )
	   cx_lo_ss(tcom_cx, idim) = res_lo
	   cx_hi_ss(tcom_cx, idim) = uplim
	   mr_lo_ss(tcom_mr, idim) = mr_lo_sav + xlate
	   mr_hi_ss(tcom_mr, idim) = mr_hi_sav + xlate
	   IF ( MODULO_PARITY(cx_lo_sav,             npts,idel)
     .	   .EQ. MODULO_PARITY(cx_lo_ss(tcom_cx,idim),npts,idel) ) THEN
	      CALL COPY_INTO( memry(tcom_mr)%ptr, tcom_mr,
     .			      tcom_cx,
     .			      memry(res_mr)%ptr, res_mr )
	   ENDIF
* NOTE:  it is KNOWN that sometimes this routine needlessle copies the same
*	 region of component into the same region of result at both STEP 1
*	 and STEP 2.  This has not been debugged because the consequences
*	 are negligible (*sh* 11/02)
	   IF (uplim .EQ. res_hi) GOTO 1000	! STEP 2 not needed
	ENDIF

* STEP 2
* shift component so the start of the component lies within the result range
	xlate = npts * nshift
	IF ( com_lo+xlate.GT.res_hi ) xlate = xlate - npts
	IF ( com_lo+xlate.LT.res_lo ) xlate = xlate + npts
	IF ( com_lo+xlate.GE.res_lo .AND. com_lo+xlate.LE.res_hi ) THEN
* ... copy the region
	   uplim = MIN( res_hi, com_hi+xlate )
	   cx_lo_ss(tcom_cx, idim) = com_lo + xlate
	   cx_hi_ss(tcom_cx, idim) = uplim
	   mr_lo_ss(tcom_mr, idim) = mr_lo_sav + xlate
	   mr_hi_ss(tcom_mr, idim) = mr_hi_sav + xlate
	   IF ( MODULO_PARITY(cx_lo_sav,             npts,idel)
     .	   .EQ. MODULO_PARITY(cx_lo_ss(tcom_cx,idim),npts,idel) ) THEN
	      CALL COPY_INTO( memry(tcom_mr)%ptr, tcom_mr,
     .			   tcom_cx,
     .			   memry(res_mr)%ptr, res_mr )
	   ENDIF
	ENDIF

* clean up - restore as before this call
 1000	cx_lo_ss(tcom_cx, idim) = cx_lo_sav
	cx_hi_ss(tcom_cx, idim) = cx_hi_sav
	mr_lo_ss(tcom_mr, idim) = mr_lo_sav
	mr_hi_ss(tcom_mr, idim) = mr_hi_sav

	RETURN	
	END	

	INTEGER FUNCTION TM_UNIT_ID( string )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* identify the string as a known unit or return 0

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.00 - 04/15/88
* revision 1.00 - 05/26/88 - to work with TMAP routines
* revision 1.01 - 11/21/88 - variable used check changed to specific char_initXX
* 7/96 *sh*: check that "deg" is not hiding "degrees C" or "deg K" ...
* V5.1 *sh* 12/99 - changed logic for matching un_name to insist on exact
*	match with possible final "s". It was matching "Kelvin" to "in"
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files
* V6.85 6/13 *acm* fix bug#2080: the check for degrees_C etc.

* Include files
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'xunits.cmn_text'
	external xunits_data

* calling argument declarations:
	CHARACTER*(*)	string

* internal parameter declarations:
	INTEGER		ndeg_temp
	PARAMETER     ( ndeg_temp = 6 )

* internal variable declarations:
	INTEGER		iun, ideg
	INTEGER         STR_CASE_BLIND_COMPARE, TM_LENSTR1, istat, slen
	LOGICAL		TM_HAS_STRING, match
	CHARACTER	deg_temp(ndeg_temp)*1

* initialize characters that signal "degrees" is really temperature
	DATA deg_temp / 'C', 'K', 'F', 'c', 'k', 'f' /	

* check through alternate (long) names first to avoid ambiguity
* eg. "m" is the un_name for "meters" but also exits in many other unit names
	DO 110 iun = 1, pun_num_alt

	   IF ( un_alt_name(iun) .EQ. char_init12 ) GOTO 200

	   IF ( TM_HAS_STRING( string, un_alt_name(iun) ) ) THEN
* ... check that "deg" is not hiding "degrees C" or "deg K" ...
	      IF ( un_alt_subsc( iun ) .EQ. pun_degrees ) THEN
	         DO 105 ideg = 1, ndeg_temp
	            IF (TM_HAS_STRING(string,deg_temp(ideg))) GOTO 110
 105	         CONTINUE
	      ENDIF
	      TM_UNIT_ID = un_alt_subsc( iun )
	      RETURN
	   ENDIF

 110	CONTINUE

* now it's safe to search the list of short abbreviations
 200	slen = TM_LENSTR1(string)
	DO 210 iun = pun_1st_unit, pun_last_unit

	   IF ( un_name(iun) .EQ. char_init12 .OR.
     .	        un_name(iun) .EQ. ' '             ) GOTO 210

* ... check for string match or possibly plural
	   istat = STR_CASE_BLIND_COMPARE(string, un_name(iun))
	   match = istat .EQ. str_match
	   IF (.NOT.match .AND. slen.GT.1) THEN
	      istat = STR_CASE_BLIND_COMPARE(string(:slen-1), un_name(iun))
	      match = istat .EQ. str_match
	      IF ( match ) match = string(slen:slen).EQ.'s'
     .			      .OR. string(slen:slen).EQ.'S'
	   ENDIF

	   IF ( match ) THEN
* ... check that "deg" is not hiding "degrees C" or "deg K" ...
	      IF ( iun .EQ. pun_degrees ) THEN
	         DO 205 ideg = 1, ndeg_temp
	            IF (TM_HAS_STRING(string,deg_temp(ideg))) GOTO 210
 205	         CONTINUE
	      ENDIF
	      TM_UNIT_ID = iun
	      RETURN
	   ENDIF

 210	CONTINUE

* not found
	TM_UNIT_ID = 0
	RETURN

	END

      subroutine drawpoly(x, y, z, zlev, nlev, nsides, xadd, lmin, lmax)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
c:    Extracted from arfill.F
c:    Output polygon (rectangle or triangle) for contour display.
c:
*     v5.81 *acm* 4/05 Changes for FILL/MOD. Draw replications for curvilinear datasets
*     v6.4  *acm*11/09 For curvi plots, dont buffer polygons of a single color. This 
*                      resulted in drawing rectangles across what should be curvi portions
*                      of the grid (bug 1505).

      real x(*), y(*), z(*)
      integer i,j,npoly,nlev,nsides 
      real xadd, lmin, lmax
      real zlev(nlev)
      real xpoly(20), ypoly(20),zmin,zmax,f
c
        include         'miss_inc.decl'
        include         'MISS.INC'
        include         'shade_vars.cmn'
        include         'xcurvilinear.cmn'

      zmin=  1e30
      zmax= -1e30

      do 10 i = 1,nsides
         if ((zle .and. z(i) .le. cmzle)  .or.
     .        (zeq .and. z(i) .eq. cmzeq)  .or.
     .        (zge .and. z(i) .ge. cmzge)) then
            
            if (.not. buffer_empty) call flush_buffered_fillpoly (xadd,
     .                    lmin, lmax)
            return
         end if
         
         zmin=amin1(zmin,z(i))
         zmax=amax1(zmax,z(i))
 10   continue
      
      do 100 i = 1, nlev-1

*        ENTIRE CELL IS OUTSIDE PRESET LEVELS
         if ((zmin.gt.zlev(i+1)) .or. (zmax.lt.zlev(i))) goto 100

*        ENTIRE CELL IS A SINGLE COLOR
         if ((zmin.ge.zlev(i)) .and. (zmax.le.zlev(i+1))) then

            if ((i .ne. ilast .and. .not. buffer_empty) 
     .           .or. num_buffered .ge. buffer_max
     .           .or. curvilinear) then

               call flush_buffered_fillpoly (xadd, lmin, lmax)
            end if

            call buffer_fillpoly (x, y, nsides, i-1)
            return
         endif

*        CELL IS MORE THAN ONE COLOR. FLUSH BUFFER AND FILL IN THIS CELL.
         if (.not. buffer_empty) call flush_buffered_fillpoly (xadd,
     .                     lmin, lmax)

         x(nsides+1)=x(1)
         y(nsides+1)=y(1)
         z(nsides+1)=z(1)
         npoly=0
c
         do 80 j=1,nsides

            if (z(j).lt.zlev(i)) then
c
c z(j) is below
c
               if (z(j+1).gt.zlev(i+1)) then
c
c z(j+1) is above
c
                  npoly=npoly+1
                  f=(z(j)-zlev(i))/(z(j)-z(j+1))
                  xpoly(npoly)=x(j) - f*(x(j)-x(j+1))
                  ypoly(npoly)=y(j) - f*(y(j)-y(j+1))
c
                  npoly=npoly+1
                  f=(z(j)-zlev(i+1))/(z(j)-z(j+1))
                  xpoly(npoly)=x(j) - f*(x(j)-x(j+1))
                  ypoly(npoly)=y(j) - f*(y(j)-y(j+1))

               else if ((z(j+1).ge.zlev(i)) .and. 
     *                 (z(j+1).le.zlev(i+1))) then
c
c z(j+1) is inside
c
                  npoly=npoly+1
                  f=(z(j)-zlev(i))/(z(j)-z(j+1))
                  xpoly(npoly)=x(j) - f*(x(j)-x(j+1))
                  ypoly(npoly)=y(j) - f*(y(j)-y(j+1))
c
                  npoly=npoly+1
                  xpoly(npoly)=x(j+1)
                  ypoly(npoly)=y(j+1)

               endif

            else if (z(j).gt.zlev(i+1)) then
c
c z(j) is above
c
               if (z(j+1).lt.zlev(i)) then
c
c z(j+1) is below
c
                  npoly=npoly+1
                  f=(z(j)-zlev(i+1))/(z(j)-z(j+1))
                  xpoly(npoly)=x(j) - f*(x(j)-x(j+1))
                  ypoly(npoly)=y(j) - f*(y(j)-y(j+1))
c
                  npoly=npoly+1
                  f=(z(j)-zlev(i))/(z(j)-z(j+1))
                  xpoly(npoly)=x(j) - f*(x(j)-x(j+1))
                  ypoly(npoly)=y(j) - f*(y(j)-y(j+1))

               else if ((z(j+1).ge.zlev(i)) .and. 
     *                 (z(j+1).le.zlev(i+1))) then
c
c z(j+1) is inside
c
                  npoly=npoly+1
                  f=(z(j)-zlev(i+1))/(z(j)-z(j+1))
                  xpoly(npoly)=x(j) - f*(x(j)-x(j+1))
                  ypoly(npoly)=y(j) - f*(y(j)-y(j+1))
c
                  npoly=npoly+1
                  xpoly(npoly)=x(j+1)
                  ypoly(npoly)=y(j+1)

               endif

            else
c
c z(j) is inside
c
               if (z(j+1).gt.zlev(i+1)) then
c
c z(j+1) is above
c
                  npoly=npoly+1
                  f=(z(j)-zlev(i+1))/(z(j)-z(j+1))
                  xpoly(npoly)=x(j) - f*(x(j)-x(j+1))
                  ypoly(npoly)=y(j) - f*(y(j)-y(j+1))

               else if(z(j+1).lt.zlev(i))then
c
c z(j+1) is below
c
                  npoly=npoly+1
                  f=(z(j)-zlev(i))/(z(j)-z(j+1))
                  xpoly(npoly)=x(j) - f*(x(j)-x(j+1))
                  ypoly(npoly)=y(j) - f*(y(j)-y(j+1))

               else
c
c z(j+1) is inside
c
                  npoly=npoly+1
                  xpoly(npoly)=x(j+1)
                  ypoly(npoly)=y(j+1)

               endif

            endif

 80      continue

         call fillpoly(xpoly, ypoly, npoly, i-1, xadd, lmin, lmax)

 100   continue

      return 
      end

*
* sortn_str.F
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* May 2012
*
* This function sorts data on T axis in increasing order.  
* Returns index of sorted values.  The indices of any missing
* data are listed first.
*
*  NOTE:
*  IT IS GENERALLY ADVISABLE TO INCLUDE EXPLICIT LIMITS WHEN WORKING WITH
*  FUNCTIONS THAT REPLACE AXES. FOR EXAMPLE, THE CONSIDER THE FUNCTION
*  sortn_str(v). THE EXPRESSION
*  	LIST/L=6:10 sortn_str(v)
*  IS NOT EQUIVALENT TO
*  	LIST sortn_str(v[L=6:10])
*  THE FORMER WILL LIST THE 6TH THROUGH 10TH SORTED INDICES FROM THE ENTIRE
*  L RANGE OF VARIABLE V. THE LATTER WILL LIST ALL OF THE INDICES THAT
*  RESULT FROM SORTING v[L=6:10].
*  
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE sortn_str_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CHARACTER*120 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns indices of string data, sorted on the N axis ',
     .        'in increasing order, null strings at the end')
      CALL ef_set_desc(id, fcn_desc)  

      CALL ef_set_num_args(id, 1)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, ABSTRACT)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 2)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'STR')
      CALL ef_set_arg_desc(id, arg, 'String variable to sort in N')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, NO)
      CALL ef_set_arg_type(id, arg, STRING_ARG)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END


*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE sortn_str_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER my_lo, my_hi

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      my_lo = 1
      my_hi = arg_hi_ss(F_AXIS,ARG1) - arg_lo_ss(F_AXIS,ARG1) + 1

      CALL ef_set_axis_limits(id, F_AXIS, my_lo, my_hi)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE sortn_str_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
* 
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER mdat

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      mdat = 1 + arg_hi_ss(F_AXIS,ARG1) - arg_lo_ss(F_AXIS,ARG1)

* sort_dat (256 * 4 bytes = 1024 byte string, but only use first 512 for safety sake)
      CALL ef_set_work_array_dims_6d(id,   1,
     .                                1,   1, 1, 1, 1, 1,
     .                            mdat, 256, 1, 1, 1, 1)

* sort_indx
      CALL ef_set_work_array_dims_6d(id, 2,
     .                                1, 1, 1, 1, 1, 1,
     .                             mdat, 1, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE sortn_str_compute(id, arg_1, result,
     .                             sort_dat, sort_indx)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif

      INTEGER id

      REAL arg_1(strdf, mem1lox:mem1hix, mem1loy:mem1hiy, 
     .                  mem1loz:mem1hiz, mem1lot:mem1hit, 
     .                  mem1loe:mem1hie, mem1lof:mem1hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* Ignore the Y/Z/T/E/F dimensions in the work arrays since
* they are not used and Fortran is column major
      CHARACTER*512 sort_dat(wrk1lox:wrk1hix)
      REAL sort_indx(wrk2lox:wrk2hix)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER nsrt, slen, nn
      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)
 

      m1 = arg_lo_ss(E_AXIS, ARG1)
      DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

      l1 = arg_lo_ss(T_AXIS, ARG1)
      DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS) 

      k1 = arg_lo_ss(Z_AXIS, ARG1)
      DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

         j1 = arg_lo_ss(Y_AXIS, ARG1)
         DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            i1 = arg_lo_ss(X_AXIS, ARG1)
            DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS) 

               nsrt = 0

               n1 = arg_lo_ss(F_AXIS, ARG1)
               DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

                  nsrt = nsrt + 1
                  CALL EF_GET_STRING_ARG_ELEMENT_6D(id, ARG1, arg_1,
     .                    i1, j1, k1, l1, m1, n1, slen, sort_dat(nsrt))
                  IF (slen .LE. 0) THEN
                     nsrt = nsrt - 1
                  ELSE
                     sort_indx(nsrt) = n1
                  ENDIF

                  n1 = n1 + arg_incr(F_AXIS, ARG1)
 600           CONTINUE
*
* Sort based on sort_dat.  sort_indx goes along for the ride,
* elements moved when elements of sort_dat moved.
*
               IF (nsrt .GT. 1) CALL HEAP2_STR (sort_dat, 
     .                                   sort_indx, nsrt)

* Put sorted indices in the array first, then bad flags.

               n = res_lo_ss(F_AXIS)
               DO 620 nn = 1, nsrt
                  result(i,j,k,l,m,n) = sort_indx(nn)
                  n = n + 1
 620           CONTINUE

               DO 640 n = res_lo_ss(F_AXIS)+nsrt, res_hi_ss(F_AXIS)
                  result(i,j,k,l,m,n) = bad_flag_result
 640           CONTINUE

               i1 = i1 + arg_incr(X_AXIS, ARG1)
 100        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS, ARG1)
 200     CONTINUE

         k1 = k1 + arg_incr(Z_AXIS, ARG1)
 300  CONTINUE

         l1 = l1 + arg_incr(T_AXIS,ARG1)
 400  CONTINUE

         m1 = m1 + arg_incr(E_AXIS, ARG1)
 500  CONTINUE


*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

	FUNCTION VARCK (HEADER, CHOICE, YCOLUMN)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)varck.f	1.1.1.1    7/30/88
C**
C**
C***********************************************************************        C**
C**                 EPIC
C**
C***********************************************************************        C**
C**
C
C  READS EPIC HEADER TO FIND THE COLUMN NUMBER (YCOLUMN) OF THE
C  GENERIC VARIABLE CHOICE.  IF CHOICE IS NEGATIVE, NO MESSAGE
C  IS PRINTED ON OUTPUT (UNIT6) WHEN THE SELECTED VARIABLE IS NOT
C  FOUND ON THE DATA FILE.
C
C  EXTRACTED FROM M. VERSCHELL'S PLOTSETUP BY N SOREIDE, JUN 85.
C
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
	CHARACTER*(*) HEADER(8)
	LOGICAL VARCK
	INTEGER*4 CHOICE,YCOLUMN,ICNT,CODEVAL(0:8),VARCODE
c
C  CODEVAL setup
c    This identifies the variable code range a variable type can be
c    found in. The range is the number:number+9. If the number is 999
c    then the variable is a special case, and must be dealt with 
c    specially.
c
c  Generic variable codes are given here.  Routine will return column
c  number of the variable:
c
c                    Generic   
c                      Code    Description
c		     ------   -----------
c			0     Pressure
c			1     Temperature
c			2     Salinity
c			3     Sigma-T
c			4     Oxygen
c			5     Conductivity
c			6     U
c			7     V
c			8     Dynamic Height
c			9     Other
c
      DATA CODEVAL /0,20,40,999,60,50,999,999,10/
c
C
	ICABS=IABS(CHOICE)
	READ (HEADER(3)(79:80),101) NVARS
101	FORMAT (I2)
      DO 300 ICNT=1,NVARS
        READ(HEADER(5)(ICNT*4-3:ICNT*4),1030) VARCODE
 1030   FORMAT(I4)
        IF (ICABS .EQ. 3) THEN
          IF (VARCODE .EQ. 70) GOTO 400
        ELSE IF (ICABS .EQ. 6) THEN
          IF((VARCODE.EQ.320).OR.(VARCODE.EQ.322).OR.(VARCODE.EQ.324)
     >       .OR.(VARCODE.EQ.326).OR.(VARCODE.EQ.330)
     >       .OR.(VARCODE.EQ.332).OR.(VARCODE.EQ.334)
     >       .OR.(VARCODE.EQ.336).OR.(VARCODE.EQ.420)
     >       .OR.(VARCODE.EQ.340)
     >       .OR.(VARCODE.EQ.422)) GOTO 400
        ELSE IF (ICABS .EQ. 7) THEN
          IF((VARCODE.EQ.321).OR.(VARCODE.EQ.323).OR.(VARCODE.EQ.325)
     >       .OR.(VARCODE.EQ.327).OR.(VARCODE.EQ.331)
     >       .OR.(VARCODE.EQ.333).OR.(VARCODE.EQ.335)
     >       .OR.(VARCODE.EQ.337).OR.(VARCODE.EQ.421)
     >       .OR.(VARCODE.EQ.341)
     >       .OR.(VARCODE.EQ.423)) GOTO 400
        ELSE IF (ICABS .EQ. 9) THEN
          IF ((YCOLUMN .EQ. ICNT).AND.(VARCODE .NE. 0)) GOTO 400
        ELSE 
          IF((VARCODE.GE.CODEVAL(ICABS)).AND.
     >       (VARCODE.LE.(CODEVAL(ICABS)+9))) GOTO 400
        ENDIF
  300 CONTINUE
  310    IF (CHOICE .GT. 0) WRITE(6,1040) 
 1040 FORMAT(/' There is no match for this variable. Cast OMITTED.'/)
	VARCK = .FALSE.
	RETURN
c
  400 YCOLUMN = ICNT
	VARCK = .TRUE.
	RETURN
	END

	SUBROUTINE TM_PARK_LAST_VERSION ( fname, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* rename any existing file of name fname to the current highest version of
* that filename plus one

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for DECstation computer under Ultrix operating system
*
* rev 0.0 -   5/6/91
* rev 1.0 -   10/17/91  -- <kob>
*                        - extract path out of filename if it exists as part of
*                           the filename. pass both filename and path to 
*                           tm_next_ver_name.
*SUN port - 2/92- kob-  ***Temporarily***
*                         don't call tm_next_ver_name or tm_rename if running
*                         on  a sun.  Merely append '.old' the the file
*                         if it exists.  
* 		comment out ifdef because posix version should work 3/92 kob
* bug fix 1/94 *sh* - if path is included with file name then pass only the
*			name as the first argument to TM_NEXT_VER_NAME
*			Re-append path to the version name.
*
* IBM port 6/2/94 *kob* - Inherited length string concatenation error on IBM
*			  aix compiler forces uses of risc_buff
*
* 1/03 - *kob* g77 port - Need to use risc_buff for arbitrary concatenations

* calling argument declarations:
      INTEGER       status
      CHARACTER*(*) fname

#ifdef unix
      include 'tmap_errors.parm'
#include "gt_lib.parm"
      include 'xrisc_buff.cmn'

* internal variable declarations:
      LOGICAL there
      CHARACTER*128  buff
      INTEGER flen, TM_LENSTR1, i
      INTEGER postslash
* Initialize
      status = merr_ok

* does the file already exist ?
      INQUIRE ( FILE=fname, EXIST=there )

      IF ( .NOT.there ) RETURN

* it already exists - rename it to the highest version
* first extracting possible path out of filename  -- 10/91
      IF ( INDEX( fname, PathSeparator) .GT. 0) THEN
         flen = TM_LENSTR1(fname)
         do 10 i = flen-1,1,-1
            IF ( fname(i:i) .EQ. PathSeparator ) THEN
               postslash = MIN(i+1,flen)     ! MIN if slash at end->dont crash
               GOTO 11
            ENDIF
 10      continue
* ... next version with path name
 11      CALL TM_NEXT_VER_NAME( fname(postslash:), buff,
     .			        fname(:postslash-1))
  	 risc_buff = fname(:postslash-1)
         CALL TM_RENAME( fname, risc_buff(:TM_LENSTR1(risc_buff))//buff, 
     .                   status )
      ELSE
* ... next version in this directory
         CALL TM_NEXT_VER_NAME(fname,buff,' ')
         CALL TM_RENAME( fname, buff, status )
      ENDIF

      RETURN
#else
      STOP 'TM_PARK_LAST_VERSION is for Unix systems, only'
#endif
      END

      SUBROUTINE EF_GET_STRING_ARG_ELEM_LEN_SUB( lox, hix, loy, hiy,
     .                  loz, hiz, lot, hit, loe, hie, lof, hif, arg, 
     .                  i, j, k, l, m, n, max_line_len, slen )
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* This returns an the length of an element of the string array 
* which was passed as an argument to the function.  
*
* Called by ef_get_string_arg_element_len.
*
* Inside this subroutine arg is an array of pointers (cast as real*8),
* and we can call GET_STRING_ELEMENT to get the length of a string element.
*
*  acm 12/03  from ef_get_arg_string
*
*       3/12 *kms* Added E and F dimensions

      INTEGER i, j, k, l, m, n, 
     .        lox, hix, loy, hiy, loz, hiz,
     .        lot, hit, loe, hie, lof, hif,
     .        slen, max_line_len
      REAL*8 arg(lox:hix, loy:hiy, loz:hiz, lot:hit, loe:hie, lof:hif)

      CHARACTER*512 text

      CHARACTER GET_STRING_ELEMENT*512
    
      text = GET_STRING_ELEMENT(lox, hix, loy, hiy, loz, hiz,
     .                          lot, hit, loe, hie, lof, hif, arg,
     .                          i, j, k, l, m, n, max_line_len, slen)

      RETURN
      END

*
* samplexz.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without anx fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and anx derivative works thereof, and
*  its supporting documentation for anx purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in anx publications that result from
*  the use of this software or in anx product that INCLUDE 'ferret_cmn/s this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in anx advertising or publicity to endorse or promote anx products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with anx support, consulting,
*  training or assistance of anx kind with regard to the use, operation
*  and performance of this software nor to provide the user with anx
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND Anx EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR Anx SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR Anx DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke  from samplexy  5/15/01
* 11-Jan-06 *acm* declare xlo, xhi, zlo, zhi  as integer not real
*
* This function samples 4-d data on the x and z axes indicated by args 2 and 3
*         Result is abstract on the x axis, normal on the y axis,
*         and keeps the z and t axes of the input 4-d data.
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE samplexz_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      CHARACTER*100 fcn_desc
      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns data sampled at a set of (X,Z) points, ',
     .   'using linear interpolation')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, ABSTRACT, IMPLIED_BY_ARGS, 
     .     NORMAL, IMPLIED_BY_ARGS)

      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      CALL ef_set_num_work_arrays(id, 2)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'DAT_TO_SAMPLE')
      CALL ef_set_arg_desc(id, arg, 'variable (x,y,z,t) to sample')
      CALL ef_set_axis_influence(id, arg, NO, YES, NO, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'XPTS')
      CALL ef_set_arg_desc(id, arg, 'X values of sample points')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'ZPTS')
      CALL ef_set_arg_desc(id, arg, 'Z values of sample points')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* loss               lo subscript for an axis
*
* hiss               hi subscript for an axis
*

      SUBROUTINE samplexz_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER my_lo_l, my_hi_l
      INTEGER nx, ny, nz, nt

*     Use utility functions to get context information about the 
*     1st argument, to set the abstract axis lo and hi indices.

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nx = arg_hi_ss(X_AXIS, ARG2) - arg_lo_ss(X_AXIS, ARG2) + 1
      ny = arg_hi_ss(Y_AXIS, ARG2) - arg_lo_ss(Y_AXIS, ARG2) + 1
      nz = arg_hi_ss(Z_AXIS, ARG2) - arg_lo_ss(Z_AXIS, ARG2) + 1
      nt = arg_hi_ss(T_AXIS, ARG2) - arg_lo_ss(T_AXIS, ARG2) + 1

      my_lo_l = 1
      my_hi_l = max(nx,ny)
      my_hi_l = max(my_hi_l,nz)
      my_hi_l = max(my_hi_l,nt)

      CALL ef_set_axis_limits(id, X_AXIS, my_lo_l, my_hi_l)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END
*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE samplexz_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_lens(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER mxh, mzh, mxl, mzl

      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

*  Allocate double the length of the axes for REAL*8 work arrays.

      mxl = arg_lo_ss(X_AXIS,ARG1)
      mzl = arg_lo_ss(Z_AXIS,ARG1)

      mxh = mxl + 
     .     2* (arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 1)
      mzh = mzl + 
     .     2* (arg_hi_ss(Z_AXIS,ARG1)  - arg_lo_ss(Z_AXIS,ARG1) + 1)

*  xaxdat
      CALL ef_set_work_array_dims (id, 1, mxl, 1, 1, 1, mxh, 1, 1, 1)

*  zaxdat
      CALL ef_set_work_array_dims (id, 2, mzl, 1, 1, 1, mzh, 1, 1, 1)


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*

      SUBROUTINE samplexz_compute(id, arg_1, arg_2, arg_3, result,
     .       xaxdat, zaxdat)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .     mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .     mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz,
     .     mem3lot:mem3hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .      memresloz:memreshiz, memreslot:memreshit)


* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable's axes.

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      COMMON /STOR/ mxdat, mydat
      INTEGER mxdat, mydat
      INTEGER nx, nxx, nxy, nxz, nxt
      INTEGER nz, nzx, nzy, nzz, nzt
      INTEGER ndimx, ndimz

*  Set up work arrays

      REAL*8 xaxdat(wrk1lox:wrk1lox+(wrk1hix-wrk1lox)/2,wrk1loy:wrk1hiy,
     .               wrk1loz:wrk1hiz, wrk1lot:wrk1hit)
      REAL*8 zaxdat(wrk2lox:wrk2lox+(wrk2hix-wrk2lox)/2,wrk2loy:wrk2hiy,
     .               wrk2loz:wrk2hiz, wrk2lot:wrk2hit)

      INTEGER i, j, k, l
      INTEGER i1,j1,k1,l1
      INTEGER i2,j2,k2,l2
      INTEGER i3,j3,k3,l3

      INTEGER imatch, kmatch
      INTEGER ibot, itop, kbot, ktop
      REAL fxbot, fxtop, fbb, ftb, fbt, ftt
      REAL xbot, xtop, zbot, ztop
      REAL frac
      CHARACTER*255 err_msg

C  variables for checking axis characteristics (modulo axes)

      CHARACTER ax_name(4)*16, ax_units(4)*16
      LOGICAL backward(4), modulo(4), regular(4)
      REAL delmodx, delmodz, xpt, zpt
      INTEGER xlo, xhi, zlo, zhi

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      nxx = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1
      nxy = arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) + 1
      nxz = arg_hi_ss(Z_AXIS,ARG2) - arg_lo_ss(Z_AXIS,ARG2) + 1
      nxt = arg_hi_ss(T_AXIS,ARG2) - arg_lo_ss(T_AXIS,ARG2) + 1
      nx = max(nxx, nxy, nxz, nxt)

      nzx = arg_hi_ss(X_AXIS,ARG3) - arg_lo_ss(X_AXIS,ARG3) + 1
      nzy = arg_hi_ss(Y_AXIS,ARG3) - arg_lo_ss(Y_AXIS,ARG3) + 1
      nzz = arg_hi_ss(Z_AXIS,ARG3) - arg_lo_ss(Z_AXIS,ARG3) + 1
      nzt = arg_hi_ss(T_AXIS,ARG3) - arg_lo_ss(T_AXIS,ARG3) + 1
      nz = max(nzx, nzy, nzz, nzt)

      ndimx = 0
      ndimz = 0
      DO 110 i = X_AXIS,T_AXIS
         IF (arg_hi_ss(i,ARG2) - arg_lo_ss(i,ARG2) .GT.0) 
     .       ndimx = ndimx + 1
         IF (arg_hi_ss(i,ARG3) - arg_lo_ss(i,ARG3) .GT.0) 
     .       ndimz= ndimz + 1
  110 CONTINUE

      IF (nx .NE. nz   .OR.  ndimx .GT. 1  .OR. ndimz .GT.1) THEN
         WRITE (err_msg, 10)
         GO TO 999
      ENDIF

   10 FORMAT(
     . 'Arguments 2 and 3 must be 1-dimensional lists of equal length')

*  Get  and z coordinates of the data to be sampled.

      CALL ef_get_coordinates(id, ARG1, X_AXIS,
     .   arg_lo_ss(X_AXIS, ARG1), arg_hi_ss(X_AXIS, ARG1), xaxdat)
      CALL ef_get_coordinates(id, ARG1, Z_AXIS,
     .   arg_lo_ss(Z_AXIS, ARG1), arg_hi_ss(Z_AXIS, ARG1), zaxdat)

      i2 = arg_lo_ss(X_AXIS,ARG2)
      j2 = arg_lo_ss(Y_AXIS,ARG2)
      k2 = arg_lo_ss(Z_AXIS,ARG2)
      l2 = arg_lo_ss(T_AXIS,ARG2)

      i3 = arg_lo_ss(X_AXIS,ARG3)
      j3 = arg_lo_ss(Y_AXIS,ARG3)
      k3 = arg_lo_ss(Z_AXIS,ARG3)
      l3 = arg_lo_ss(T_AXIS,ARG3)

*  Check to see if input x,z  axis is modulo

      CALL ef_get_axis_info (id, ARG1, ax_name, ax_units, backward, 
     .                       modulo, regular)

      xlo = arg_lo_ss(X_AXIS,ARG1)
      xhi = arg_hi_ss(X_AXIS,ARG1)
      zlo = arg_lo_ss(Z_AXIS,ARG1)
      zhi = arg_hi_ss(Z_AXIS,ARG1)

      IF ( modulo(1) ) delmodx = xaxdat(xhi,1,1,1) - xaxdat(xlo,1,1,1)
      IF ( modulo(3) ) delmodz = zaxdat(zhi,1,1,1) - zaxdat(zlo,1,1,1)

*  For each (xpt,zpt) pair, search the data array 
*   arg_1 for the nearest higher (x,z) grid coordinates.  Interpolate 
*   in 2 directions for the result.

      i2 = arg_lo_ss(X_AXIS,ARG2)
      j2 = arg_lo_ss(Y_AXIS,ARG2)
      k2 = arg_lo_ss(Z_AXIS,ARG2)
      l2 = arg_lo_ss(T_AXIS,ARG2)

      i3 = arg_lo_ss(X_AXIS,ARG3)
      j3 = arg_lo_ss(Y_AXIS,ARG3)
      k3 = arg_lo_ss(Z_AXIS,ARG3)
      l3 = arg_lo_ss(T_AXIS,ARG3)

      k = res_lo_ss(Z_AXIS)
      DO 500 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         ibot = ef_unspecified_int4	! Check if xpt points in xax range.
         imatch = 0

	 xpt = arg_2(i2,j2,k2,l2)
         DO 100 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)
            IF (xpt .GE. xaxdat(i1,1,1,1)) ibot = i1
            if (xpt .EQ. xaxdat(i1,1,1,1)) imatch = i1

cbf      may be some derivation from the exact value can be allowed:
cbf      if (xpt - xaxdat(i1,1,1,1)).le.eps)   imatch = i1

*  Locate the X point within the range of modulo X axis 

	    IF (modulo(1)) THEN
	       DO WHILE (xpt .GE. xaxdat(xhi,1,1,1) ) 
                  xpt = xpt - delmodx
	       ENDDO
	       DO WHILE (xpt .LT. xaxdat(xlo,1,1,1) )
		  xpt = xpt + delmodx
	       ENDDO
	    ENDIF

  100    CONTINUE
         i1 = arg_hi_ss(X_AXIS,ARG1)
         IF (xpt .GT. xaxdat(i1,1,1,1)) THEN
             ibot = ef_unspecified_int4		! ARG_2 XPT outside of range 
						! (non modulo)
         ENDIF

cbf       for matching the next neighbour is not of interest
         IF (imatch .NE. 0) then
            itop = ibot
         ELSE
            itop = ibot + 1
         ENDIF
         IF (ibot .EQ. ef_unspecified_int4) itop = ibot

cbf        analogously in z direction
         kbot = ef_unspecified_int4	! Check if ypt points in zax range.
         kmatch = 0

	 zpt = arg_3(i3,j3,k3,l3)
         DO 200 k1 = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)
            IF (zpt .GE. zaxdat(k1,1,1,1) ) kbot = k1
            IF (zpt .EQ. zaxdat(k1,1,1,1) ) kmatch = k1
cbf         IF zpt - zaxdat(k1,1,1,1) ) .LE. eps) kmatch = k1

*  Locate the Z point within the range of modulo Z axis 

	    IF (modulo(3)) THEN
	       DO WHILE (zpt .GE. zaxdat(zhi,1,1,1) ) 
                  zpt = zpt - delmodz
	       ENDDO
	       DO WHILE (zpt .LT. zaxdat(zlo,1,1,1) )
		  zpt = zpt + delmodz
	       ENDDO
	    ENDIF

  200    CONTINUE
         k1 = arg_hi_ss(Z_AXIS,ARG1)
         IF (arg_3(i3,j3,k3,l3) .GE. zaxdat(k1,1,1,1) ) THEN
            kbot = ef_unspecified_int4		! ARG_3 ZPT outside of range 
						! (non modulo)

         ENDIF

         IF (kmatch .NE. 0) then
            ktop = kbot
         ELSE
            ktop = kbot + 1
         ENDIF
         IF (kbot .EQ. ef_unspecified_int4) ktop = kbot

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 400 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            l1 = arg_lo_ss(T_AXIS,ARG1)
            l2 = arg_lo_ss(T_AXIS,ARG2)
            l3 = arg_lo_ss(T_AXIS,ARG3)
            DO 300 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

*  First interpolate in x, getting values of the fcn at (x,kbot) and (x,ktop)

	       IF (ibot .EQ. ef_unspecified_int4  .OR.  
     .		   kbot .EQ. ef_unspecified_int4) THEN
                 result(i,j,k,l) = bad_flag_result
	       ELSE 
                  IF (ibot .GE. arg_lo_ss(X_AXIS,ARG1)  .AND.
     .                itop .LE. arg_hi_ss(X_AXIS,ARG1) ) THEN

                     xbot = xaxdat(ibot,1,1,1)
                     xtop = xaxdat(itop,1,1,1)

                     fbb = arg_1(ibot,j1,kbot,l1)
                     ftb = arg_1(itop,j1,kbot,l1)
                     fbt = arg_1(ibot,j1,ktop,l1)
                     ftt = arg_1(itop,j1,ktop,l1)

                     IF (fbb .NE. bad_flag(ARG1)  .AND.
     .                   ftb .NE. bad_flag(ARG1)  .AND.
     .                   fbt .NE. bad_flag(ARG1)  .AND.
     .                   ftt .NE. bad_flag(ARG1) ) THEN

cbf                 for matching x-axis no interpolation is need
                          if (imatch.ne.0) then
                             fxbot = fbb
                             fxtop = fbt
                          else
                             frac = (xpt - xbot )/ (xtop - xbot)
                             fxbot = fbb + frac* (ftb - fbb)
                             fxtop = fbt + frac* (ftt - fbt)
                          endif

*  Now interpolate in y, getting value at (x,y)

                       IF (kbot .GE. arg_lo_ss(Z_AXIS,ARG1)  .AND.
     .                     ktop .LE. arg_hi_ss(Z_AXIS,ARG1) ) THEN
                          zbot = zaxdat(kbot,1,1,1)
                          ztop = zaxdat(ktop,1,1,1)

                          IF (kmatch .NE. 0) THEN
                             result(i,j,k,l) = fxbot
                          ELSE
                            frac = (zpt - zbot)/ (ztop-zbot)

                            result(i,j,k,l) = fxbot + frac* 
     .                                         (fxtop - fxbot)
                          ENDIF
                       ELSE
                           result(i,j,k,l) = bad_flag_result
                       ENDIF

                    ELSE
                        result(i,j,k,l) = bad_flag_result
                    ENDIF  ! bad_flag(ARG1) test
                  ENDIF	   ! fbb,ftp, etc not bad flags

	       ENDIF  ! itop, jtop not ef_unspecified_int4

               l1 = l1 + arg_incr(T_AXIS,ARG1)

 300        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 400     CONTINUE

         i2 = i2 + arg_incr(X_AXIS,ARG2)
         j2 = j2 + arg_incr(Y_AXIS,ARG2)
         k2 = k2 + arg_incr(Z_AXIS,ARG2)
         l2 = l2 + arg_incr(T_AXIS,ARG2)

         i3 = i3 + arg_incr(X_AXIS,ARG3)
         j3 = j3 + arg_incr(Y_AXIS,ARG3)
         k3 = k3 + arg_incr(Z_AXIS,ARG3)
         l3 = l3 + arg_incr(T_AXIS,ARG3)
         k = k + res_incr(Z_AXIS)
500   CONTINUE


      RETURN
 999  CALL ef_bail_out (id, err_msg)

      END

	SUBROUTINE  VEL_BY_WIND(  tau, mtau,
     .				 ubwi, mubwi )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute contribution to velocity in surface layer due to wind stress
* note1: the same code applies to both X and Y components
* note2: a value of rho=1 is assumed for dimensional correctness

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 -1/23/87 extracted from SUBROUTINE CLINIC
*			with major modifications to bypass th fudging of wind
*			stress effects into the diffusion terms
* V200:  7/27/89 - 4D symmetrical version
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN

#ifdef unix
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl.parm'		! parameter definitions
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xonedim.cmn'	! geometric constants
	include 'xcontext.cmn'
#else
	INCLUDE 'FERRET_CMN:FERRET.PARM'
	INCLUDE 'FERRET_CMN:GFDL.PARM'		! parameter definitions
	INCLUDE	'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE	'FERRET_CMN:XMEM_SUBSC.CMN'
	INCLUDE 'FERRET_CMN:XONEDIM.CMN'	! geometric constants
	INCLUDE 'FERRET_CMN:XCONTEXT.CMN'
#endif

* calling argument declarations:
	INTEGER	mtau, mubwi

* subscript ranges from memory variable table ...
	REAL     tau( m1lox:m1hix,m1loy:m1hiy,            m1lot:m1hit ),
     .		ubwi( m2lox:m2hix,m2loy:m2hiy,            m2lot:m2hit )

* internal variable declarations:
	INTEGER	MGRID_SIZE, grid_size
	REAL	factor

* --- end of introductory code ---

* total words in result grid
	grid_size = MGRID_SIZE( mubwi )

* ***************************************************************
* ORIGINAL GFDL 205 CODE UPON WHICH CALCULATION IS BASED
*
*259  C   SET VERTICAL VISCOUS BOUNDARY CONDITIONS
*260  C
*261        DO 280 K=1,KM
*262        DO 280 I=1,IMT
*263        UDIF(I,K)=UB(I,K)
*264        VDIF(I,K)=VB(I,K)
*265   280  CONTINUE
*266        TAPER=1.
*267        IF(ITT*DTUV.LE.TAPLEN*86400.) TAPER=0.5*(1.-COS(PI*
*268       1(ITT*DTUV/(TAPLEN*86400.))))
*269        TFAC1=(MOD(ITT-1,NTS30)+1.)/FLOAT(NTS30)
*270        TFAC2=1.-TFAC1
*271        DO 290 I=1,IMT
*272        FACTOR=(DZZ(1)/BVVC(I))*TAPER
*273        UOVER(I)=UB(I,1)+(WSX(I)*TFAC2+TX(I)*TFAC1)*FACTOR
*274        VOVER(I)=VB(I,1)+(WSY(I)*TFAC2+TY(I)*TFAC1)*FACTOR
*275   290  CONTINUE

*362        DO 345 K=1,KMP1
*363        DO 345 I=1,IMT
*364        TEMP2D(I,K)=UDIF(I,K-1)-UDIF(I,K)
*365   345  CONTINUE
*366        DO 348 K=1,KM
*367        DO 348 I=1,IMT
*368        UA(I,K)=UA(I,K)+EEM2D(I,K)*VVC(I,K-1)*TEMP2D(I,K)-
*369       * FFM2D(I,K)*VVC(I,K)*TEMP2D(I,K+1)
*370   348  CONTINUE
	
*378        DO 355 K=1,KMP1
*379        DO 355 I=1,IMT
*380        TEMP2D(I,K)=VDIF(I,K-1)-VDIF(I,K)
*381   355  CONTINUE
*382        DO 356 K=1,KM
*383        DO 356 I=1,IMT
*384        VA(I,K)=VA(I,K)+EEM2D(I,K)*VVC(I,K-1)*TEMP2D(I,K)-
*385       * FFM2D(I,K)*VVC(I,K)*TEMP2D(I,K+1)
*386   356  CONTINUE
*************************************************************************

* when all the fudging is done the entire contribution of wind stress reduces
* to TAUi / dz(1)
* factor also converts to units of cm/sec per month (730 hours )

	factor = ( 1. / dz(1) ) * cmonthly

	CALL COPY_GRID( tau, mtau, ubwi, mubwi )

	CALL MULT_GRID( grid_size, ubwi, factor )

	RETURN

	END

      SUBROUTINE VP_AXLIM2LIM( scale, xloax, yloax, xhiax, yhiax,
     .                                xlovp, ylovp, xhivp, yhivp,
     .                                xoei,  yoei,  xcei,  ycei )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Determine the viewport limits that are implied from viewport limits
* specified ax axis endpoint positions

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V540: 9/01 *sh*
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'
	include 'xplot_setup.cmn'
        include 'plt_inc.decl'     ! with width/height
        include 'PLT.INC'
	
* calling argument declarations:
	REAL*4	scale, xlovp, ylovp, xhivp, yhivp,
     .		xcei, ycei, xoei, yoei,
     .		xloax, yloax, xhiax, yhiax

* internal variable declarations:
	REAL*4	xcv, xov, ycv, yov, xwpi, ywpi

* *** VIEWPORTS SPECIFIED BY AXIS ENDPOINTS ***
* Previous to V5.4 all viewports were specified as the corners of the PLOT+
* output window.  This made quick and dirty layouts very simple, but it
* meant an arduous process for someone to carefully lay out a multi-frame
* plot.
* In V5.4 we introduce DEFINE VIEW/AXES, in which the viewport position
* refers to the bounds of the active plotting area. The process of computing
* the corresponding PLOT+ output window is complex because the layout is a
* combination of normalized coordinates and PLOT+ "Denbo inches".
*
* The algorithm for determining the PLOT+ rectangle goes as follows.  It
* applies identically for X and Y.
*
*     |-------------------------|
*     |                         |
*     |    |---------------|CV  |
*     |    |               |    |
*     |    |   +++++++++CA |    |
*     |    |   +       +   |    |
*     |    |-OE-       -CE-|    |
*     |    |   +       +   |    |
*     |    |   +       +   |    |
*     |    | OA+++++++++   |    |
*     |    |      WA       |    |
*     |  OV|---------------|    |
*     |           WV            |
*     |-------------------------|
*                 WP
*
* We begin with notation
* "O" indicates an "origin" (lower left of a rectangle)
* "C" indicates "clip" (upper right of a rectangle)
* "W" indicates a width
*
* "V" indicates relative to the viewport
* "A" indicates relative to the axes of the viewport
* "E" indicates an "edge" distance -- the gap between the viewport and axes
* "P" indicates relative to the "page" (the current output window or metafile)
*
* "i" indicates the value is in units of "Denbo inches"
*     if "i" is absent it is normalized
*
* The known quantities are
* WPi = scale*width  - width of the output page (with scale factor)
* CA, OA - the limits of the axes given by the user in the DEF VIEW/AXES command
* OEi, CEi - the PLOT+ origin (1.2,1.4) and white space above the axes (1.0,1.4)
*
* We shift to normalized units using
*   OE = OEi/WPi
*   CE = CEi/WPi
*
* Giving
*   OV = OA - OE
*      = OA - OEi/WPi
* and similarly
*   CV = CA + CEi/WPi
*
* Determining the desired PLOT+ output window is further complicated by the
* ability of DEF VIEW/AXES to specify a viewport that implies a contradictory
* layout with respect to the "white space" surrounding the active plot
* rectangle.  For example, specifying an origin for the axes at 0,0 on the
* output window leaves no room for white space.  Thus in this code we adjust
* the PLOT+ origin as necessary to avoid this contradictory layout.

* ... V5.22 default behaviors (viewport not specified by axis)

        xWPi = scale*width
        yWPi = scale*height
        xoei = xwhitelo  ! ppl xorigin
        yoei = ywhitelo  ! ppl yorigin
        xcei = xwhitehi  ! white space to right of X axis
        ycei = ywhitehi  ! white space for docmtn at top of plot

        xov = xloax
        xcv = xhiax
        yov = yloax
        ycv = yhiax

        xwpi = scale * width
        ywpi = scale * height

        xcv = xcv + xcei/xwpi
        ycv = ycv + ycei/ywpi
        xov = xov - xoei/xwpi
        yov = yov - yoei/ywpi

* ... make adjustments if the normalized limits exceed allowable
        IF (xcv .GT. 1.0001) THEN
          xcei = xcei + (1.0-xcv)*xwpi
          xcv = 1.0
        ENDIF
        IF (ycv .GT. 1.0001) THEN
          ycei = ycei + (1.0-ycv)*ywpi
          ycv = 1.0
        ENDIF
        IF (xov .LT. -0.0001) THEN
          xoei = xoei + xov*xwpi
          xov = 0.0
        ENDIF
        IF (yov .LT. -0.0001) THEN
          yoei = yoei + yov*ywpi
          yov = 0.0
        ENDIF

* results
        xlovp = xov
        ylovp = yov
        xhivp = xcv
        yhivp = ycv

* success
	RETURN
	END

	SUBROUTINE TM_GET_LM_DYNMEM( rqst_size, lm, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* allocate the requested amount of dynamic emory (using c or python malloc)
* malloc is done in c (or python), but has to call back into F90 to set pointer
* the hierarchy of calls is as follows
*   tm_get_lm_dynmem.F ==> tm_get_lm_mem.c ==> tm_store_lm_ptr.F

* programmer - steve hankin
* V702 *sh*  4/17 code copies/modified from fer/mem "mr" dynamic memory

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'tmap_errors.parm'
	include 'xdyn_linemem.cmn_text'

* calling argument declarations:
	INTEGER	lm, status
	INTEGER*8 rqst_size

* internal variable declarations:
	INTEGER	next, last
	CHARACTER*13    TM_STRING

* find a free table slot -- the first on the free list
	lm = free_dyn_line(plm_free_base)
	IF (lm .EQ. 0) GOTO 5100

* allocate the dynamic memory
	CALL TM_GET_LM_MEM(lm, rqst_size, status)
        IF (status .NE. merr_ok) GOTO 5000

* bookkeeping
        lm_size(lm) = rqst_size
        total_line_mem = total_line_mem + rqst_size
* ... remove this line from the free list
	free_dyn_line(plm_free_base) = free_dyn_line(lm)

	RETURN


***********************
* error exits
 5000	RETURN
 5100	CALL TM_ERRMSG (merr_linstorlim, status, 'TM_GET_LM_DYNMEM',
     .                  no_descfile, no_stepfile,
     .                  'MAX='//TM_STRING(DBLE(max_lm)),
     .                  no_errstring, *5000)

	END

	SUBROUTINE IS_AUXVAR_REGRID(  *, *, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* this routine controls the fetching of auxiliary variables if more than
* one; the determination of the curvilinier index region and fetching of
* the target; and (optionally) performing the regridding.  The regridding
* step is skipped when this routine is called under isact_aux_plot_vars
*
* regridding:  regrid the data from the source grid to the destination grid
* using auxiliary variables to guide the numerics of the regrid
* architype is a conversion from density to depth "TEMP[gz(depth)=zax]"
* where "depth" is a field of depths defined on the same density axis
* as the variable TEMP

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 9/2013 based upon IS_REGRID
* for Ferret v685+
* v695+ *sh* 3/15 - support for TF (FMRC) regridding added
* V698 *sh* 1/16 - bug fix: cx_regrid_trans were getting clobbered in dst_cx

	IMPLICIT NONE

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xtext_info.cmn'
	include	'xprog_state.cmn'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xalgebra.cmn'   ! with alg_regrid_code

* calling argument declarations:
	INTEGER	status
* normal exit is for error conditions
* exit #1 is to signal completion of the activity at this stack level

* internal variable declarations:
	LOGICAL	ITS_UN_CACHED, not_reusable, first, aux_has_cell_pts
	INTEGER TM_LENSTR1, CAXIS_LEN, AUX_AXIS_FROM_ARG,
     .		i, j, icom, idim, mr, lo_cx, hi_cx, lo_isp, hi_isp, naxis,
     .		aux_mr_list(nferdims), mr1, mr2, mr3,
     .		aux_cx_list(nferdims), cx1, cx2, cx3,
     .		isp_ptr, axis_list(nferdims),
     .		dst_cx, src_cx, com_cx, dst_mr, src_mr, frame_bottom, 
     .		impl_grid, slen, s1, sn, naux, ptr
	CHARACTER*128 VAR_CODE, src_name, com_name

!* temporary cuz totalview doesn't see equiv vars
!	INTEGER im1, im2, im3, ic1, ic2, ic3 

        EQUIVALENCE
     .          ( aux_mr_list(1), mr1 ),
     .          ( aux_mr_list(2), mr2 ),
     .          ( aux_cx_list(1), cx1 ),
     .          ( aux_mr_list(2), mr2 ),
     .          ( aux_cx_list(2), cx2 ),
     .          ( aux_mr_list(3), mr3 ),
     .          ( aux_cx_list(3), cx3 )


* this routine guides the regridding process through three phases:
*  1) isphase_get_aux_var  - gets the needed auxiliary vars onto the cx stack
*  2) isphase_get_source_var - gets the pre-regridded data field
*  3) isphase_do_aux_regrid  - performs the regridding

* RETURN 1 is to get another component
* RETURN 2 is when the regridding is completed
* normal RETURN is for errors

* auxiliary regridding always requires at least 2 component variables:
*	1 or more auxiliary variables  (e.g. xcoords, and ycoords for curvilinear regrid)
* and   the source data to be regridded

* for each components obtained, is_obj(isp) will retain a pointer to the
* parent level -- the level at which regridding was requested (a.k.a. "lo_isp")

* in all 3 phases the interp stack setup will look like this
*	stack level		stack contents
*       -----------		--------------
*	isp+1	<--	level  of component just obtained
*	...     <--     levels of components previously obtained
*	lo_isp	<--	level at which regrid was requested
* --- end of introductory code ---

* initialize
	IF ( is_phase(isp).EQ. isphase_get_aux_var
     . .AND. is_sum(isp) .EQ. 1                     )  THEN
* ... first time called.  Set up is_obj pointer
	   lo_isp = isp
	   is_obj(isp+1) = lo_isp ! so auxvar just obtained points to regrid op
	ELSE
	   lo_isp   = is_obj(isp)    ! the isp level of the regrid operation
	ENDIF
	lo_cx    = is_cx(lo_isp)
	naux    = cx_naux( lo_cx )
	IF (cx_type(lo_cx) .EQ. ptype_string) GOTO 5010

* set pointers to the auxiliary variables
* (if we are have more aux variables to get some of these pointers will be wrong)
* ... first pre-fill with known values
	DO 5 i = 1, 3
	   aux_mr_list(i) = dummy_mr
	   aux_cx_list(i) = unspecified_int4 
 5	CONTINUE
!**************
!* remove these lines
!	im1 = mr1
!	im2 = mr2
!	im3 = mr3
!	ic1 = cx1
!	ic2 = cx2
!	ic3 = cx3
!**************
        i = 0
        DO idim = 1, nferdims
           IF (cx_aux_var(idim,lo_cx) .NE. unspecified_int4) THEN
              i = i + 1
              isp_ptr = lo_isp + i 
              axis_list(i) = idim
	      IF (idim .EQ. f_dim
     .	    .AND. cx_aux_var(t_dim,lo_cx) .NE. unspecified_int4) THEN
* ... note that with TF regridding there are 2 dimensions with cx_aux_var but
*     only one auxiliary variable, TIME2D, so both axes point to same aux var
                 aux_mr_list(i) = aux_mr_list(1)
                 aux_cx_list(i) = aux_cx_list(1)	         
	      ELSE
                 aux_mr_list(i) = is_mr(isp_ptr)  ! see equivs
                 aux_cx_list(i) = is_cx(isp_ptr)  ! see equivs
	      ENDIF
          ENDIF
	ENDDO
!**************
!* remove these lines
!	im1 = mr1
!	im2 = mr2
!	im3 = mr3
!	ic1 = cx1
!	ic2 = cx2
!	ic3 = cx3
!**************
* ... TF-regridding (FMRC) introduces the idea that the number of axes being
*     regridded (T&F) may differ from the number of aux variables (time2d)
	naxis = i

* sanity checks
!        IF ( naux.GT.1 )
!     .		CALL ERRMSG(ferr_prog_limit, status,
!     .		'for now TF is the only 2 aux var regrid supported', *5000)

	IF ( is_phase(lo_isp) .EQ. isphase_get_aux_var ) THEN 

* we're in the initial phase getting the components needed
	   CALL CREATE_NEW_CONTEXT( lo_cx, hi_cx, status )	! pushes stack

* put isp up one so that the component just received stays on the stack
	   isp = isp + 1

	   IF (is_sum(lo_isp) .LT. naux ) THEN
*  *** SET UP TO GET THE NEXT AUXILIARY VARIABLE ***
	      is_sum(lo_isp) = is_sum(lo_isp) + 1  ! the next auxvar
	      CALL GET_AUX_VAR_CONTEXT( lo_cx, hi_cx, is_sum(lo_isp),
     .					status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
	      is_axis(lo_isp) = AUX_AXIS_FROM_ARG(lo_cx, is_sum(lo_isp) )

	   ELSE
* *** SET UP TO GET THE SOURCE DATA ***
	      is_phase(lo_isp) = isphase_get_source_var

* set up 4D array limits as unsubscripted variables in COMMON
              CALL NON_ARRAY_SUBSC( aux_mr_list, naux )

!**************
!* remove these lines
!	im1 = mr1
!	im2 = mr2
!	im3 = mr3
!	ic1 = cx1
!	ic2 = cx2
!	ic3 = cx3
!**************

* create the context for the source data needed to perform the regrid
              CALL AUX_REGRID_LIMS( lo_cx, hi_cx, axis_list, naxis,
     .                memry(mr1)%ptr, mr1, cx1,
     .                memry(mr2)%ptr, mr2, cx2,
     .                memry(mr3)%ptr, mr3, cx3,
     .                status )
              IF (status .NE. ferr_ok) GOTO 5000
	   ENDIF

* go get the next component (the one just set up) via RETURN 1
   	   CALL PUSH_INTERP_STACK( isp, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   is_cx ( isp ) = hi_cx
	   is_obj( isp ) = lo_isp  ! points back to the regridded variable
	   IF ( cx_category(hi_cx) .EQ. cat_user_var ) THEN
* ... setup to evaluate auxiliary var that is user-defined (uvar)
	      is_uvar( isp ) = cx_variable( hi_cx )
	   ENDIF
	   RETURN 1

	ELSEIF (  is_phase(lo_isp) .EQ. isphase_get_source_var ) THEN 
 
* ***  TIME TO REGRID OR RETURN "3 ARGUMENTS" (2 for Z)  FOR PLOTTING****
* ... we have all of the needed components.
	   is_phase(lo_isp) = isphase_do_aux_regrid  ! (never used)

* if the scenario is
*       yes? LET TEMPZ = TEMP[gz(DEPTH)=zax]
*       yes? LOAD TEMPZ
*    then the interp stack setup at the time this is called is
*
*   stack level            stack contents
*   ----- -----      -----------------------------------
* hi_isp:isp+naux   variable on native grid (TEMP)
*        isp        auxiliary variable (DEPTH)
* lo_isp:isp-1      requested regrid result (TEMP[dz(DEPTH)=zax])
*        isp-2      evaluating TEMPZ
*        isp-3      evaluating EXP#


  	   hi_isp = isp + cx_naux(lo_cx)   ! the source data (just obtained)
	   src_cx = is_cx(hi_isp)
	   dst_cx = lo_cx
	   src_mr = is_mr(hi_isp)

*******************************
* RETURN AUX VARS FOR "3 ARGUMENT" PLOTS
* No regridding to do.
* Transfer the isp stack contents of the component variable (hi_isp)
* to the destination level (lo_isp) and reset the stack pointer
* Park the auxiliary variables in the special parking area at the stack top
* XXX TEMPORARY: tbd - also park a copy of their cx at the top of the cx stack?
	   IF (is_act(lo_isp) .EQ. isact_aux_plot_vars) THEN
* park the auxiliary variable(s) at the top of the isp stack
	      i = 0
	      DO idim = 1, nferdims
	         IF (cx_aux_var(idim,lo_cx) .NE. unspecified_int4) THEN
* XXX TEMPORARY - warn of same auxvar parked twice.  Better would be to ERROR
*	when saved context regions and mr don't match btwn now and earlier
	            ptr = is_aux_ptr(lo_isp) + idim
	            IF (is_mr(ptr) .NE. unspecified_int4)
     .			CALL WARN("is_auxvar_regrid dup auxvar parked")
	            CALL TRANSFER_ISP(isp+i, ptr)		! save it
	            is_axis(ptr) = idim			        ! bookkeeping
* ... also park a copy of the aux var context at the top of the cx stack
	            is_cx(ptr) = max_context+idim
	            CALL TRANSFER_CONTEXT(is_cx(isp+i),is_cx(ptr))
* ... set the aux axis limits to the limits required getting the target var
	            CALL TRANSFER_AXIS(idim, src_cx, is_cx(ptr))
	            i = i + 1
	         ENDIF
	      ENDDO
	      IF (i .NE. cx_naux(lo_cx)) CALL WARN("is_auxvar_regrid crptn")
* the component just obtained is *the* result (no regridding to do)
	      CALL TRANSFER_CONTEXT( src_cx, dst_cx )
	      is_mr(lo_isp) = src_mr
	      CALL MR_IN_USE( src_mr )  ! hack cuz we will "un-use" it below
	      GOTO 400     ! clean up the stack
	   ENDIF
*******************************

* Make the destination context like the source data context on all except
* the regrid axis.  That one keeps the user-requested size.
* (other axes may have been modified by information embedded within a
* user-variable definition.) 

* (*sh* untested, simpler(?) alternative is to create the mr from dst_cx just
* as it is, pre-fill with missing, and create cx_valid based on available
* limits of the source data and the auxiliary variable)

* insist that on the axes being regridded the size of the auxiliary fields is
* either the same as the source data or +1 larger.  +1 indicates cell boundary
* coordinates in the auxiliary variable(s).  Determine whether point locations
* or bounds were provided.
	   first = .TRUE.
	   DO i = 1, naxis
	      idim = axis_list(i)
* ... check all relevant aux vars
	      DO  j = 1, naxis 
	         com_cx = aux_cx_list(j)
	         IF (CAXIS_LEN(idim,com_cx) .NE. CAXIS_LEN(idim,src_cx)+1
     .	       .AND. CAXIS_LEN(idim,com_cx) .NE. CAXIS_LEN(idim,src_cx) )
     .									GOTO 5500
	         IF ( first ) THEN
	            aux_has_cell_pts = CAXIS_LEN(idim,com_cx)
     .			          .EQ. CAXIS_LEN(idim,src_cx)
	            first = .FALSE.
	         ELSE
	            IF (aux_has_cell_pts .NEQV. 
     .			CAXIS_LEN(idim,com_cx).EQ.CAXIS_LEN(idim,src_cx) )
     .									GOTO 5500
	         ENDIF
	      ENDDO
	   ENDDO

	   CALL TRANSFER_CONTEXT( src_cx, cx_buff )
	   cx_unstand_grid( cx_buff ) = cx_unstand_grid( dst_cx )
	   cx_grid        ( cx_buff ) = cx_grid        ( dst_cx )
	   cx_impl_grid   ( cx_buff ) = cx_impl_grid   ( dst_cx )
	   cx_naux        ( cx_buff ) = cx_naux        ( dst_cx )
           DO idim = 1, nferdims
              cx_aux_var (idim, cx_buff) = cx_aux_var (idim, dst_cx)
              cx_aux_cat (idim, cx_buff) = cx_aux_cat (idim, dst_cx)
              cx_aux_stat(idim, cx_buff) = cx_aux_stat(idim, dst_cx)
	      cx_regrid_trans(idim,cx_buff ) = cx_regrid_trans(idim, dst_cx)
	      cx_delta(idim,cx_buff) = unspecified_val8
	   ENDDO
	   DO i = 1, naxis 
	      idim = axis_list(i)
	      CALL TRANSFER_AXIS( idim, dst_cx, cx_buff )
	      cx_regrid_trans(idim, cx_buff) = cx_regrid_trans(idim, dst_cx)
	      cx_delta(idim,cx_buff) = unspecified_val8
	   ENDDO
	   CALL TRANSFER_CONTEXT( cx_buff, dst_cx )  ! (nervous. is it ok to clobber this?)

* create a space for the new result possibly with the edges flagged as bad
	   CALL CREATE_MEM_VAR( dst_cx, dst_mr, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   is_mr( lo_isp ) = dst_mr

* auxiliary regridding often creates ragged edges, so pre-fill with missing values
           CALL FILL_MEMORY ( dst_mr, mr_bad_data(dst_mr) )

* diagnostic message ?
	   IF (mode_diagnostic) THEN
	      CALL DIAGNOSTIC_OUT('auxgrd ',dst_mr,  point_to_mr)
	   ENDIF 

* ... set up 4D array limits as unsubscripted variables in COMMON
	   aux_mr_list(4) = src_mr
	   aux_mr_list(5) = dst_mr
           CALL NON_ARRAY_SUBSC( aux_mr_list, 5 )    ! 5 arguments to pass

	   CALL DO_AUX_VAR_REGRID(  axis_list, naxis, aux_has_cell_pts,
     .	   		memry(src_mr )%ptr, src_mr,  src_cx,
     .			memry(dst_mr )%ptr, dst_mr,  dst_cx,
     .			memry(mr1)%ptr, mr1, cx1,
     .			memry(mr2)%ptr, mr2, cx2,
     .			memry(mr3)%ptr, mr3, cx3,
     .			status )

	   IF (status .NE. ferr_ok) GOTO 5000

* clean up 
 400	   CONTINUE
* (the following code was adapted from IS_DO_OP)

* the "frame_bottom" is the isp level that will be left when the components of
* the current calculation (1 to 3) are reduced to a single value.
* on exit isp will point to the frame bottom and the result will be left there
	   frame_bottom = lo_isp

* ... if any components were un_cached we must uncache the result
	   not_reusable = .FALSE.
	   DO 410 icom = isp, frame_bottom, -1
 410	   IF ( ITS_UN_CACHED(is_mr(icom)) ) not_reusable = .TRUE.
	   IF ( not_reusable ) CALL UN_CACHE( dst_mr )

* ...release component cx stack space
	   DO 420 isp = hi_isp, frame_bottom, -1
	      IF ( is_cx(isp) .NE. cx_stack_ptr ) WRITE (6,*) 'OP_STK??'	! temp
	      cx_stack_ptr = cx_stack_ptr - 1
	      mr  = is_mr( isp )
	      IF ( mr_protected(mr) .EQ. mr_temporary
     .	      .OR. mr_category (mr) .EQ. cat_temp_var ) THEN
	         CALL DELETE_VARIABLE( mr )
	      ELSE
	         CALL MR_NOT_IN_USE( mr )
	      ENDIF

* ...deallocate dynamic grids from components
	      com_cx = is_cx(isp)
	      IF ( cx_has_impl_grid(com_cx) ) THEN
	         impl_grid = cx_grid(com_cx)
	         CALL DEALLO_DYN_GRID(impl_grid)
	         cx_has_impl_grid(com_cx) = .FALSE.
	      ENDIF
 420	   CONTINUE

* collapse the interp stack frame
	   isp = frame_bottom

* save the result context at the cx level previously used by the 1st component (why?)
	   cx_stack_ptr = cx_stack_ptr + 1
	   CALL TRANSFER_CONTEXT( dst_cx, cx_stack_ptr )
	   is_cx( isp ) = cx_stack_ptr

	   RETURN 2
	ENDIF

* error exits
 5000	RETURN
 5010	CALL ERRMSG( ferr_invalid_command, status,
     .		'cant do auxiliary variable regridding on string variables',
     .		 *5000)
 5500	com_name = VAR_CODE(cx_category(com_cx),
     .                      cx_variable(com_cx) )
        src_name = VAR_CODE(cx_category(src_cx),
     .                      cx_variable(src_cx) )
        i = TM_LENSTR1(com_name)
        j = TM_LENSTR1(src_name)
        CALL ERRMSG( ferr_invalid_command, status,
     .          'auxiliary variable '//com_name(:i)//
     .          ' has non-conformable length on '//ww_dim_name(idim)//
     .          ' axis for regridding '//src_name(:j), *5000 )
	END	

      SUBROUTINE ISIT_COORD_VAR ( expression, dset, varname, 
     .                            coordvar, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
      
* See if the expression is a coordinate variable name from the linked-list structure, 
* inside parentheses.  Return the dset and logical flag coordvar.  If the expression
* is not in parentheses, it is not treated as a variable name.

* V600 6/05 *acm* Attribute control.
* V600  4/06 *acm* - additional declarations found by Solaris compiler

        INCLUDE	'ferret.parm'
	INCLUDE 'errmsg.parm'
        INCLUDE 'xrisc.cmn'


* calling argument declarations
      LOGICAL coordvar
      INTEGER dset, status
      CHARACTER*(*) expression, varname

* local variable declarations

      INTEGER TM_LENSTR1, NCF_GET_VAR_AXFLAG, slen, varid, ivar, 
     .        mods_cx, category, itmp, dir, ic
      CHARACTER*128 buff
      CHARACTER*1   c
   
      coordvar = .FALSE.

      slen = TM_LENSTR1(expression)
      buff = expression

      IF (expression(1:1) .EQ. '(' .AND.
     .    INDEX(expression(1:slen), ')' ) .GT. 1 ) THEN

         varname = expression(2:slen)

* locate the end of the parentheses

         itmp = INDEX(varname,')')
         IF ( itmp .GT. slen .OR. itmp .LE. 0) GOTO 5200   ! unpaired parentheses
         varname(itmp:itmp) = ' '
         itmp = itmp - 1
         slen = itmp

         IF ( INDEX(varname,'[') .GT. 0 ) THEN

            dset = pdset_irrelevant	! default (not used ...)
            CALL PARSE_NAM_DSET(varname, cx_last, dset,
     .        category, ivar, mods_cx, status)
            IF (status .NE. ferr_ok) GOTO 5000
            slen = INDEX(varname,'[') 
            varname(slen:) = ' ' 
         ENDIF
         IF (dset .EQ. pdset_irrelevant .OR. 
     .       dset .EQ. unspecified_int4) GO TO 5100

         CALL CD_GET_VAR_ID (dset, varname(:slen), varid, status)
     
         IF (status .NE. ferr_ok) THEN

* The name may be axis name with digit(s) added for a unique name. 
* test that only extra digits were added

            DO 80 ic = slen, 1, -1
	       c = varname(ic:ic)
	       IF (  c .LT. '0' .OR. c .GT. '9' ) GOTO 90

* axis names must be enclosed in parentheses to get a varid returned from cd_get_var_id
c               buff = '('//varname(1:ic-1)//')'
               buff = varname(1:ic-1)
               CALL CD_GET_VAR_ID (dset, buff, varid, status)

               IF (varid .GT. 0) THEN
* Remove the digit 
                  buff(ic:slen) = ' '
                  GOTO 90

               ENDIF

 80	    CONTINUE
         ENDIF

 90      CONTINUE      

         IF (status .NE. ferr_ok) GOTO 5100

         status = NCF_GET_VAR_AXFLAG (dset, varid, coordvar, dir)

      ELSE
 
         varname = expression

         IF ( INDEX(varname,'[') .GT. 0 ) THEN

            dset = pdset_irrelevant	! default (not used ...)
            CALL PARSE_NAM_DSET(varname, cx_last, dset,
     .        category, ivar, mods_cx, status)
            IF (status .NE. ferr_ok) GOTO 5000
            slen = INDEX(varname,'[') 
            varname(slen:) = ' ' 
            slen = slen - 1
         ENDIF
         IF (dset .EQ. pdset_irrelevant .OR. 
     .       dset .EQ. unspecified_int4) GO TO 5100

         CALL CD_GET_VAR_ID (dset, varname(:slen), varid, status)
      
         IF (status .NE. ferr_ok) GOTO 5100

         status = NCF_GET_VAR_AXFLAG (dset, varid, coordvar, dir)  

      ENDIF

* error exits
 5000 RETURN
 5100 status = ferr_invalid_command
      RETURN
 5200 status = ferr_syntax
      CALL ERRMSG( status, status, 'no closing parentheses'//
     .			buff(:slen), *5000 )
      END

	SUBROUTINE CD_GET_AGG_VAR_INFO (agg_dset, vname, imemb,
     .      vtype, mdset, igrid, iline, nv, status)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP 
*
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V698 *sh* 1/16 -- added status check/warning, since not checked by callers
*
* Given aggregate datset, variable name in the set, aggregate sequence number,
* return the Ferret datset id, grid number and variable type for the variable 
* in that member set.
*
* for var in aggregate member-dataset:
* for members of the aggregate, imemb (id= sequence number 1,2,3,...
*   igrid    Ferret grid number
*   iline    Ferret line number of aggregate dimension
*   vtype    1=file-var, 3=user-var
*   mdset    Ferret dataset number
*   nv       sequence number in ds_var_code or uvar_name_code

      INCLUDE 'tmap_errors.parm'


* Argument declarations

	CHARACTER*(*) vname
	INTEGER agg_dset, imemb, vtype, mdset, igrid, iline, nv, status

* Local variable declarations
	INTEGER NCF_GET_AGG_VAR_INFO, varid

	CALL CD_GET_VAR_ID (agg_dset, vname, varid, status)
	status = NCF_GET_AGG_VAR_INFO( agg_dset, varid, imemb, vtype, 
     .		mdset, igrid, iline, nv)

	IF (status .NE. pcd_ferr_ok) CALL WARN('ERROR in CD_GET_AGG_VAR_INFO')
	RETURN
	END

	SUBROUTINE CD_GET_TIME_UNITS (buff, cal_id, units_str, 
     .			              t0_str, days_neg4713, status)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*.
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* 2/2017 acm
* Get the time units from a string 'since date', set units_str
* and t0_str if the string is valid.
* 
* The return days_neg4713 is returned non-zero if the axis is from 
* a Matlab-generatedfile with "Julian astronomical date".
*
* Code taken fron cd_get_1_axis.F, new routine for ticket 2246;
* Drawing formatted time axes on a PLOT/VS plot.

        include 'tmap_dims.parm'
        include 'xtm_grid.cmn_text'
        external xgt_grid_data
        include 'xunits.cmn_text'
        external xunits_data
#include "gt_lib.parm"
        include 'calendar.decl'
        include 'calendar.cmn'

	CHARACTER*(*) buff, units_str, t0_str
	INTEGER cal_id, status
	REAL*8	days_neg4713

	CHARACTER*3 dbuf
	INTEGER	TM_LENSTR1, STR_UPCASE, since_T0, slen, istat
	REAL*8	TM_SECS_FROM_BC, secs_to_1901, secs_to_1968, 
     .		days_1901_may68 
	
* parameter declarations
        REAL*8          psecs_per_day
        PARAMETER     ( psecs_per_day = 60.*60.*24. )

	since_T0 = MAX( INDEX(buff,'since'), INDEX(buff,'SINCE') )
	units_str = buff(:since_T0-1)  ! just the "tunits" part 

	istat = STR_UPCASE( dbuf, buff(1:3) )

	slen = TM_LENSTR1(buff)

	IF (buff(since_T0+6:since_T0+10) .EQ. '-4713' .AND.
     .      dbuf .EQ. 'DAY')  THEN

c  Matlab Julian date encoding
c  This is the simple conversion; but we will reset the origin to 1901.
c       buff = 'DAYS since 1968-05-23 00:00:00'
c       days_neg4713 = 2440000.D0

	   buff = 'DAYS since 1901-01-15 00:00:00'
           secs_to_1901 = TM_SECS_FROM_BC 
     .                        (GREGORIAN, 1901,1,15,0,0,0,status)
           secs_to_1968 = TM_SECS_FROM_BC 
     .                        (GREGORIAN, 1968,5,23,0,0,0,status)
           days_1901_may68 = (secs_to_1968 - secs_to_1901)/
     .                             psecs_per_day
           days_neg4713 = 2440000.D0 - days_1901_may68

	ENDIF

	CALL TM_DATE_REFORMAT(buff(since_T0+6:),pdate_numslashnum,
     .                            cal_id, t0_str, 
     .                            pdate_vax, .FALSE., status )

	RETURN
	END

	SUBROUTINE TM_EXIT ( )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*

* exit the TMAP library, closing all open files as we do so
* V510 - *sh* 12/99 -- needed for netCDF caching to work right
* v540 *acm* 10/01 increase length of ds_name
* v540 *acm* 10/01  remove VMS include statements
* v604 *acm* 7/07 increase length of ds_name, ds_des_name
* V701  7/16 *kms* Compare ds_name to char_init2048 instead of char_init1024

	include 'tmap_errors.parm'	! error code parameter defs
#include "tmap_dset.parm"
	include 'tmap_dims.parm'
	include 'xstep_files.cmn_text'
	external xstep_files_data
	include 'xdset_info.cmn_text'
	external xdset_info_data

* internal variable declarations
        LOGICAL   its_cdf
	INTEGER   ds_num,status,f_num

* loop over all data sets
	DO 500 ds_num = 1, maxdsets
	   IF (ds_name(ds_num) .EQ. char_init2048) GOTO 500

* save the data format
           its_cdf = ds_type(ds_num) .EQ. 'CDF'
     .        .OR.   ds_type(ds_num) .EQ. 'ECDF' 

* Now loop through stepfiles closing files
	   DO 100 f_num = 1, maxstepfiles
	     IF (sf_setnum(f_num) .NE. ds_num) GOTO 100

* close step file or CDF file ?
	    IF ( sf_lunit (f_num) .NE. file_not_open) THEN	! open ?
               IF ( its_cdf ) THEN
                  CALL CD_CLOSE_SET( sf_lunit(f_num), status )
               ELSE
	          CALL TM_CLOSE_STEP (f_num, status)
               ENDIF
	     ENDIF
  100	   CONTINUE

 500	CONTINUE

	RETURN
	END

	SUBROUTINE GFDL_TERMS

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute geometrical and other constants as defined in GFDL code

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/7/86	extracted from SUBROUTINE HDIFFUS
* revision 0.1 - 1/16/87 - added terms needed for momentum eqn
* revision 0.2 - 7/18/88 - Am entered from data sets - not computed here

#ifdef unix
	include 'gfdl.parm'
	include 'xonedim.cmn'
#else
	INCLUDE 'FERRET_CMN:GFDL.PARM'
	INCLUDE 'FERRET_CMN:XONEDIM.CMN'
#endif

* internal variable declarations:
	INTEGER	i,j,k
	REAL	ph1deg, radius, radian, sumdy, dym

* begin executable code:
* initialize - compute basic grid coordinates ( dxt and dyt in degrees )
	CALL MESH( dxt, dyt )

* for COMMON/XEDDY
!	am = 2.E7
	ah = 2.E7
	fkpm = .0134
	fkph = .00134
	dtuv = 3600.	! 1 hour
        c2dtuv=2.0*dtuv	! 2028
	nts30 = 365.25*86400. / (12.*dtuv) + .1
	dtts = 3600.
	C2DTTS = 2.0*DTTS	! seconds to 2 hour timestep leapfrogs	! 2027
	cmonthly = c2dtts * (730./2.)	! convert seconds to months

C									!  937
       PH1DEG=-30.0+dyt(1)					! 1019 mod
C									! 1022
C   DEFINE PHYSICAL CONSTANTS						! 1023
C									! 1024
       OMEGA=3.1415927/43082.						! 1025
       RADIUS=6370.E5							! 1026
       RADIAN=57.29578							! 1027
       GRAV=980.6							! 1028

      BAH=FKPH								! 1045
      BAM=FKPM								! 1046

*   --- Z axis definitions ---
      DO 100 K=1,KM							! 1059
      C2DZ(K)=2.0*DZ(K)							! 1060
      DZ2R(K)=1.0/C2DZ(K)						! 1061
 100  CONTINUE								! 1062
      DZZ(1)=0.5*DZ(1)							! 1063
      ZDZ(1)=DZ(1)							! 1064
      DO 110 K=2,km							! 1065
      DZZ(K)=0.5*(DZ(K-1)+DZ(K))					! 1066
      ZDZ(K)=ZDZ(K-1)+DZ(K)						! 1067
 110  CONTINUE								! 1068
      DZZ(KM+1)=0.5*DZ(KM)						! 1069
!      DZZ2R(KMP1)=.5/DZZ(KMP1)						! 1070
      ZDZZ(1)=DZZ(1)							! 1071
      DO 120 K=1,km							! 1072
!      DZZ2R(K)=.5/DZZ(K)						! 1073
      ZDZZ(K+1)=ZDZZ(K)+DZZ(K+1)					! 1074
      EEH(K)=1./(DZ(K)*DZZ(K))						! 1075
      FFH(K)=1./(DZ(K)*DZZ(K+1))					! 1076
      EEM(K)=1./(DZ(K)*DZZ(K))						! 1077
      FFM(K)=1./(DZ(K)*DZZ(K+1))					! 1078
!      KAR(K)=K								! 1079
 120  CONTINUE								! 1080

* convert dxt,dyt from degrees to cm
!      DXT=DXT*RADIUS/RADIAN						! 1090
!      DYT=DYT*RADIUS/RADIAN						! 1091
	DO 124 i = 1,imt
 124	DXT(i) = dxt(i) * radius/radian
	DO 125 j = 1,jmt
 125	DYT(j) = dyt(j) * radius/radian

*   --- Y axis definitions ---
       PHI(1)=PH1DEG/RADIAN						! 1092
      PHIT(1)=PHI(1)-.5*DYT(1)/RADIUS					! 1093
      SUMDY=PHI(1)							! 1094
      DYU(JMT)=DYT(JMT)							! 1095
      DO 130 J=1,JMT							! 1096
      IF(J.NE.JMT) DYU(J)=.5*(DYT(J)+DYT(J+1))				! 1097
      DYTR(J)=1./DYT(J)							! 1098
!      DYT2R(J)=.5/DYT(J)						! 1099
!      DYT4R(J)=.25/DYT(J)						! 1100
      DYUR(J)=1./DYU(J)							! 1101
      DYU2R(J)=.5/DYU(J)						! 1102
      DYU4R(J)=.25/DYU(J)						! 1103
      IF(J.NE.JMT) SUMDY=SUMDY+DYT(J+1)/RADIUS				! 1104
      IF(J.NE.JMT) PHI(J+1)=SUMDY					! 1105
      IF(J.NE.1) PHIT(J)=.5*(PHI(J-1)+PHI(J))				! 1106
      CST(J)=COS(PHIT(J))						! 1107
      CS (J)=COS(PHI (J))						! 1108
      SINE(J)=SIN(PHI(J))						! 1109
      CSTR(J)=1.0/CST(J)						! 1110
      CSR(J)=1.0/CS(J)							! 1111
      TNG(J)=SINE(J)/CS(J)						! 1112
 130  CONTINUE								! 1113

*   --- X axis definitions ---
      DXU(IMT)=DXT(IMT)					! 1114 mod
!      IF(LCYC.EQ.1) DXU(IMT)=.5*(DXT(2)+DXT(3))		! 1115 mod
      DXU(IMT)=.5*(DXT(2)+DXT(3))		! 1115 mod 2/93
      DO 140  I=1,IMT							! 1116
      IF(I.NE.IMT) DXU(I)=.5*(DXT(I)+DXT(I+1))		! 1117 mod
      DXTR(I)=1./DXT(I)					! 1118 mod
!      DXT2R(I)=.5/DXT(I)					! 1119 mod
      DXT4R(I)=.25/DXT(I)					! 1120 mod
      DXUR(I)=1./DXU(I)							! 1121
      DXU2R(I)=.5/DXU(I)						! 1122
!      DXU4R(I)=.25/DXU(I)						! 1123
  140 CONTINUE								! 1124

* compute actual coordinate positions for x and y in degrees
* **** NOTE: the yv coordinates computed here DO NOT agree with the NMC
* (and other) wind point coordinates, although the errors are small.  According
* to the COX documentation the t,s grid points should lie at the midpoints of
* the u,v points.  This was reversed in the SUBROUTINE GRIDS (by Ron Pacanowski)
* which generated the NMC wind coordinates.  It has been corrected here.
	xv(1) = 131.0				! from NMCWIN.DAT file
	xt(1) = 130.5
	DO 150 i = 2, imt
	   xv(i) = xv( i-1 ) + 0.5 * ( dxu(i-1) + dxu(i) ) * radian/radius
	   xt(i) = xt( i-1 ) + 0.5 * ( dxt(i-1) + dxt(i) ) * radian/radius
 150	CONTINUE
	DO 160 j = 1, jmt
	   yv(j) = phi (j) * radian
	   yt(j) = phit(j) * radian
 160	CONTINUE

C									! 1137
C   PRINT SOME THINGS							! 1138
C									! 1139
!      PRINT 9701							! 1140
! 9701 FORMAT(50H0 GRID BOX THICKNESS  'DZ'                        )	! 1141
!      PRINT 970, DZ							! 1142
!      PRINT 9702							! 1143
! 9702 FORMAT(50H0 GRID POINT SEPARATION  'DZZ'                    )	! 1144
!      PRINT 970, DZZ							! 1145
!      PRINT 9703							! 1146
! 9703 FORMAT(50H0 DEPTH OF BOX BOTTOM  'ZDZ'                      )	! 1147
!      PRINT 970, ZDZ							! 1148
!      PRINT 9704							! 1149
! 9704 FORMAT(50H0 DEPTH OF GRID POINT  'ZDZZ'                     )	! 1150
!      PRINT 970, ZDZZ							! 1151
!      PRINT 9705							! 1152
! 9705 FORMAT(50H0 LATITUDE OF T,S POINTS (RADIANS)  'PHIT'        )	! 1153
!      PRINT 970, PHIT							! 1154
!      PRINT 9706							! 1155
! 9706 FORMAT(50H0 LATITUDE OF U,V POINTS (RADIANS)  'PHI'         )	! 1156
!      PRINT 970, PHI							! 1157
!      PRINT 9707							! 1158
! 9707 FORMAT(50H0 COSINE OF T,S LATITUDE  'CST'                   )	! 1159
!      PRINT 970, CST							! 1160
!      PRINT 9708							! 1161
! 9708 FORMAT(50H0 COSINE OF U,V LATITUDE  'CS'                    )	! 1162
!      PRINT 970, CS							! 1163
!      PRINT 9709							! 1164
! 9709 FORMAT(50H0 SINE OF U,V LATITUDE  'SINE'                    )	! 1165
!      PRINT 970, SINE							! 1166
 970  FORMAT(1X,10E13.5)						! 1167
!C									! 1168
!C  NEWTONIAN DAMPING COEFFICIENTS POLEWARD OF 30 DEGREES NORTH &	! 1169
!C  20 DEGREES SOUTH.							! 1170
!C									! 1171
!      RGAMMA=1./(GAMMA*86400.)						! 1172
!      DO 1200 J=1,NPS							! 1173
! 1200 RGS(J)=RGAMMA*.5*(1.+COS(3.14159*(J-2.)/(NPS-1.)))		! 1174
!      DO 1201 J=1,NPN							! 1175
! 1201 RGN(J)=RGAMMA*.5*(1.+COS(3.14159*(J-2.)/(NPN-1.)))		! 1176
!C									! 1177
!C     VARIABLE HORIZONTAL DIFFUSION FACTORS...ALLOW UP TO 25.*AM	! 1178
!C     AND 25.*AH FOR THE COARSE REGIONS				! 1179
!C									! 1180
!      XIV(*)=1.							! 1181
!      XIT(*)=1.							! 1182
	DO 1205 i = 1,imt
	xiv(i) = 1.0
 1205	xit(i) = 1.0
      DYM=1./DYT(50)							! 1183
      DO 1210 J=1,JMT							! 1184
1210  XJT(J)=3.166*DYT(J)*DYM-2.166					! 1185
      XJV(JMT)=XJT(JMT)							! 1186
      DO 1211 J=1,JMTM1							! 1187
1211  XJV(J)=.5*(XJT(J)+XJT(J+1))					! 1188

	RETURN
	END

	SUBROUTINE CD_GET_TIME_AXIS(dset, recdim, status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Determine the designated "time axis" for this data set
* and save its lo/hi limits in stepfile common
* This is needed for compatibility with GT and TS formats

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 3/92
*
* 7/95 *kob* - added check for MC dataset to prevent clobbering of
*	       stepfile time data already stored
* 4/03 *acm* - Use STR_SAME to compare strings

* argument definitions:
*       dset        - TMAP data set pointer
*       recdim      - orientation of "time axis" (usually t_dim)
*	status	    - return status

* include files
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
        include 'xdset_info.cd_equiv'
	include 'xstep_files.cmn_text'
	external xstep_files_data


* argument declarations
	INTEGER	 dset, recdim, status

* local variable declarations:
      REAL*8  TM_WORLD
      INTEGER STR_SAME, tmvar, istep, grid, taxis

* locate the step file that belongs to this data set
      DO 100 istep = 1,maxstepfiles
         IF (sf_setnum(istep) .EQ. dset) GOTO 190
 100  CONTINUE
* No step file allocated
      RETURN    ! can never happen
      
* locate the first variable with a valid time axis.  This will be 
* regarded as THE time axis for the data set
 190  DO 200 tmvar = 1,maxvars
        IF ( ds_var_setnum(tmvar) .NE. dset ) GOTO 200
        grid = ds_grid_number( tmvar )
        taxis = grid_line(t_dim, grid)
        IF ( taxis .NE. mpsnorm ) GOTO 300
 200  CONTINUE

* no variables with time axes in the data set
* *kob* 12/00 no need to do the below for MC datasets

      IF ( STR_SAME(ds_type(dset), '  MC') .NE. 0 ) THEN
	 ds_time_axis(dset) = mpsnorm 
	 sf_1step(istep)    = unspecified_val8
	 sf_lastep(istep)   = unspecified_val8
      ENDIF
      GOTO 1000

* save the time axis and its limits
* add check for MC datasets....their sf_1step and sf_lastep are already
* set...dont want to clobber them
 300  IF ( STR_SAME(ds_type(dset), '  MC') .NE. 0) then
         ds_time_axis(dset) = taxis
         sf_1step(istep)    = TM_WORLD( ds_grid_start(t_dim,tmvar),
     .                               grid, recdim, box_lo_lim )
         sf_lastep(istep)   = TM_WORLD( ds_grid_end(t_dim,tmvar),
     .                               grid, recdim, box_hi_lim )
      ENDIF

* successful completion
 1000   status = merr_ok
        RETURN

* error(s)
* 5000   RETURN
* 5100   CALL TM_ERRMSG ( merr_varform, status, 'CD_GET_TIME_AXIS',
*     .       unspecified_int4, unspecified_int4,
*     .       'no variables in netCDF file', no_errstring, *5000 )
	END

	SUBROUTINE MEM_TO_BYTES (mem, mem_str, slen, mem_unit)


* Convert memory in Words to bytes, making it Kb, Mb or Gb depending on size.
* Returns two strings with the size and the units. slen is the length of mem_str

* NOAA/PMEL, Seattle, WA - Science Data Integration Group


* V751  6/1  *acm*

	INTEGER*8 mem
	INTEGER   slen
	CHARACTER*(*) mem_str, mem_unit

	CHARACTER TM_FMT_TRIM*48

	IF (mem .GT. 100000000) THEN
           mem_str = TM_FMT_TRIM( FLOAT(mem*8)/1.E9, -2, 12, slen)
           mem_unit = 'Gb'
        ELSE IF (mem .GT. 100000) THEN 
           mem_str = TM_FMT_TRIM( FLOAT(mem*8)/1.E6, -2, 12, slen)
           mem_unit = 'Mb'
        ELSE 
           mem_str = TM_FMT_TRIM( FLOAT(mem*8)/1.E3, -2, 12, slen)
           mem_unit = 'Kb'
        ENDIF

	RETURN
	END

*
* string_cat3.F
*
* Ansley Manke
* May 2006
*
*
* Returns concatenation of 3 strings
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, string_cat3 )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )


      SUBROUTINE string_cat3_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V


      CALL ef_set_desc(id,
     .  'Demo Function: Returns concatenation of 3 strings' )

      CALL ef_set_num_args(id, 3)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_result_type(id, STRING_RETURN)

      arg = 1
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_desc(id, arg, 'string1')
      CALL ef_set_arg_type (id, arg, STRING_ARG)

      arg = 2
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)
      CALL ef_set_arg_name(id, arg, 'B')
      CALL ef_set_arg_desc(id, arg, 'string2')
      CALL ef_set_arg_type (id, arg, STRING_ARG)

      arg = 3
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)
      CALL ef_set_arg_name(id, arg, 'C')
      CALL ef_set_arg_desc(id, arg, 'string3')
      CALL ef_set_arg_type (id, arg, STRING_ARG)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


* In this subroutine we compute the result
*
      SUBROUTINE string_cat3_compute(id, arg_1, arg_2, arg_3, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(strdf,mem1lox:mem1hix, mem1loy:mem1hiy, 
     .     mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(strdf,mem2lox:mem2hix, mem2loy:mem2hiy, 
     .     mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3(strdf,mem3lox:mem3hix, mem3loy:mem3hiy, 
     .     mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL result(strdf,memreslox:memreshix, memresloy:memreshiy, 
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l
      INTEGER i1, j1, k1, l1, i2, j2, k2, l2, i3, j3, k3, l3
      INTEGER atype, iarg, slen, slen1, slen2, slen3
      CHARACTER*100 errmsg, str1*255, str2*255, str3*255

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      CALL ef_get_arg_type (id, ARG1, atype)
      IF (atype .NE. STRING_ARG) THEN
        errmsg = 'must call with string arguments'
        GO TO 5000
      ENDIF

      CALL ef_get_arg_type (id, ARG2, atype)
      IF (atype .NE. STRING_ARG) THEN
        errmsg = 'must call with string arguments'
        GO TO 5000
      ENDIF

      CALL ef_get_arg_type (id, ARG3, atype)
      IF (atype .NE. STRING_ARG) THEN
        errmsg = 'must call with string arguments'
        GO TO 5000
      ENDIF

      i1 = arg_lo_ss(X_AXIS,ARG1)
      i2 = arg_lo_ss(X_AXIS,ARG2)
      i3 = arg_lo_ss(X_AXIS,ARG3)
      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         j2 = arg_lo_ss(Y_AXIS,ARG2)
         j3 = arg_lo_ss(Y_AXIS,ARG3)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            k2 = arg_lo_ss(Z_AXIS,ARG2)
            k3 = arg_lo_ss(Z_AXIS,ARG3)
            DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               l1 = arg_lo_ss(T_AXIS,ARG1)
               l2 = arg_lo_ss(T_AXIS,ARG2)
               l3 = arg_lo_ss(T_AXIS,ARG3)
               DO 100 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
                     
                  CALL EF_GET_STRING_ARG_ELEMENT (id, ARG1, arg_1, 
     .                                      i1,j1,k1,l1, slen1, str1)
                  CALL EF_GET_STRING_ARG_ELEMENT (id, ARG2, arg_2, 
     .                                      i2,j2,k2,l2, slen2, str2)
                  CALL EF_GET_STRING_ARG_ELEMENT (id, ARG3, arg_3, 
     .                                      i3,j3,k3,l3, slen3, str3)
                  
                     slen = slen1 + slen2 + slen3
                     CALL EF_PUT_STRING (
     .                  str1(:slen1)//str2(:slen2)//str3(:slen3), 
     .                  slen, result(1,i,j,k,l))

                  l1 = l1 + arg_incr(T_AXIS,ARG1)
                  l2 = l2 + arg_incr(T_AXIS,ARG2)
                  l3 = l3 + arg_incr(T_AXIS,ARG3)
 100           CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
               k2 = k2 + arg_incr(Z_AXIS,ARG2)
               k3 = k3 + arg_incr(Z_AXIS,ARG3)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
            j3 = j3 + arg_incr(Y_AXIS,ARG3)
            j3 = j3 + arg_incr(Y_AXIS,ARG3)
 300     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
         i2 = i2 + arg_incr(X_AXIS,ARG2)
         i3 = i3 + arg_incr(X_AXIS,ARG3)
 400  CONTINUE
      
      RETURN 
 5000 CALL EF_BAIL_OUT(id,errmsg)

      RETURN

      END

	INTEGER FUNCTION GCF_ARG_TYPE( gcfcn, iarg )

* return the argument type required for this argument

* V500:  1/99
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

        IMPLICIT NONE
* calling argument declarations
	INTEGER		gcfcn, iarg

* internal variable declarations
	INTEGER		iptr
	INTEGER efcn_get_arg_type

	include	'tmap_dims.parm'
	include 'ferret.parm'
	include 'grid_chg_fcns.parm'   ! for place-holder behavior
	include 'xgrid_chg_fcns.cmn'


	IF ( gcfcn .GT. gfcn_num_internal ) THEN
* ... external function
	   GCF_ARG_TYPE = efcn_get_arg_type(gcfcn, iarg)

	ELSE
* ... internal grid-changing function
	   iptr = gfcn_arg_ptr(gcfcn)
	   GCF_ARG_TYPE = gfcn_arg_type(iptr+iarg-1)

	ENDIF

	RETURN
	END

	LOGICAL FUNCTION TM_FPEQ_SNGL ( a, b )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* test to see if REAL*4 floating point numbers are equal to within
* "reasonable" accuracy
* REAL*4 (F_floating) machine error on the VAX is "approximately one part in
* 2**23" or 1.2E-7.  Allow 4.E-7 as machine error after many typical roundoffs.
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* programmer - Ansley Manke, from tm_fpeq.F
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* 1/13/2012
* Single-precision version of TM_FPEQ, to be called from PPLUS.
*      *kms*  3/12 modified to actually use the maximum absolute error
*

* calling arguments:
	REAL*4 a, b

* local parameters
	REAL*4	   VAX_epsilon, eps
	PARAMETER (VAX_epsilon = 4.E-7)

* determine the maximum relative error
        eps = ABS(b) * VAX_epsilon
* if close to zero, set the maximum absolute error
        IF ( eps .LT. VAX_epsilon ) eps = VAX_epsilon

* make the comparison
        TM_FPEQ_SNGL = ( ABS(a-b) .LE. eps )

	RETURN
	END

	subroutine   arc(x,y,nask,eps,xx,yy,nret,
     ,      ks,kmax,xl,yl,splxp,splyp,spls,spline_tension)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* revised for TMAP
*
* *sh*  - 1/26/93 modified routine to call spline under tension fit
*                 if spline_tension is not zero.  otherwise, it will
*		  use the fit that this algorithm calculates (cubic).
*******************************************************************
C** 
C**    @(#)arc.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
c	given four successive points x(k),y(k),k=1,4 defining 3 segments, 
c	the points xx(k),yy(k),k=1,nret are generated describing a curve 
c	between points 2 and 3 trying to match slope with similar curves 
c	from 1 to 2 and from 3 to 4. if the segment (2,3) is less than eps 
c	in length,nret is set to 2 and points 2 and 3 only are returned in 
c	arrays xx,yy.  otherwise nret = the input parameter nask. 
c	the curve xx,yy is a cubic over segment (2,3). 
c	if segment (1,2) is less than eps the second derivative at 
c	point 2 is set to zero.   if segment (3,4) is less than eps 
c	the second derivative at point 3 is set to zero.  these two 
c	features may be used for starting and ending an open curve. 
c	oceanography emr  december 1969 
c 
	dimension x(*),y(*)
	dimension  xx(11),yy(11),slope(3),ds(3) 
! TMAP mod, spline fit:
	dimension xl(*),yl(*),splxp(*),splyp(*),spls(*)
c 
	if(nask-2) 10,10,20 
10	nret=2 
	xx(1)=x(2) 
	yy(1)=y(2) 
	xx(2)=x(3) 
	yy(2)=y(3) 
	return 
c 
20	continue
c
! TMAP mod, spline fit:
	if (spline_tension.ne.0.) then
	nret=nask
	do 141, k=1,nret
	  splt=(spls(ks)+float(k)/float(nret)*
     *         (spls(ks+1)-spls(ks)))/spls(kmax)
	  call kurv2(splt,xx(k),yy(k),kmax,xl,yl,
     *         splxp,splyp,spls,spline_tension)
141	continue
	else
c
	pi=3.1415926 
	hafpi =pi*.50 
	angmax =pi*.25 
	xcent = (x(2)+x(3))*.5 
	ycent = (y(2)+y(3))*.5 
	dx2= x(3)-x(2) 
	dy2= y(3)-y(2) 
	ds2 =  sqrt(dx2*dx2+dy2*dy2) 
	if(ds2-eps)10,30,30 
30	ang2=atan2(dy2,dx2) 
	cos2 = cos(ang2) 
	sin2 = sin(ang2) 
c 
	do 130 k=1,3,2 
	dx = x(k+1)-x(k) 
	dy = y(k+1)-y(k) 
	ds(k)=sqrt(dx*dx + dy*dy) 
	slope(k)=0. 
	if(ds(k)-eps) 130,40,40 
40	ang =(atan2(dy,dx) - ang2)*.5 
	if(ang-hafpi) 60,60,50 
50	ang = ang-pi 
60	if(ang+hafpi) 70,80,80 
70	ang = ang+pi 
80	if(ang-angmax)100,100,90 
90	ang=angmax 
100	if(ang+angmax)110,120,120 
110	ang=-angmax 
120	slope(k)=sin(ang)/cos(ang) 
130	continue 
	if(ds(3)-eps)132,134,134 
132	slope(3)=-slope(1)*.5 
134	if(ds(1)-eps)136,138,138 
136	slope(1)=-slope(3)*.5 
138	continue 
	c= .25*(slope(3)-slope(1)) 
	d= .25*(slope(3)+slope(1)) 
c 
	nret=nask 
	dx=2./(nret-1) 
	xt=-1.-dx 
	do 140 k=1,nret 
	  xt=xt+dx
	  yt=(c+d*xt)*(xt*xt-1.) 
	  xx(k)=(xt*cos2-yt*sin2)*ds2*.5+xcent 
	  yy(k)=(xt*sin2+yt*cos2)*ds2*.5+ycent 
140	continue
c
! TMAP mod, spline fit:
	endif
c
	return 
	end 

      SUBROUTINE DAXIS(XF,YF,NMX,NMY,DRAW)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* revised for TMAP
* from PPLUS :
*	Directory PMEL:[PLOT5.PPLV11.PLOT]DAXIS.FOR

* search for "TMAP" to find all revisions
* *sh*  - 1/23/89 added interrupt detection from interrupts in lower routines
*	  	  no explicit declarations - use FORT/WARN=NODECLARATIONS
* v5.41 *acm* - 3/02  bug fix: xaxis2 call for log plots caused the tics for log 
*               axes to be wrong.
*               Also remove VMS include statements.
* v554: *acm* 2/04 add /HGRAT /VGRAT to draw optional graticule lines at tic marks:
*                  Pass new arguments to all axis routines, and set hline, vline
*                  when done.
C *acm* 11/05  new argument to xaxis1 and yaxis1 for deg/min/sec labels
C        1/06  xvaloff,yvaloff add this amount to each x or y axis label. 
C              (axis data was read as double precision and converted to single 
C              after applying an offset.)
C *acm* 5/09   Extra argument lets us skip the plot label (when redrawing
C              axes after a POLY/OVERLAY)
C *acm* 10/09  Fix bug 1708: YAXIS2 call for log plots caused the tics for the 
*              right hand side log axes to be wrong when we have a depth axis.
C *acm*  5/12  Only draw the axis labels the first time the axes are made.
C              Axes are repeated so axis lines and graticule lines are on top
C              of other plot elements but the labels dont need to be.
C *acm* 10/14  bug 2205. Polygon plots have extra calls because polygons can get 
C              drawn on topof axes. This(?) causes the main label to not get 
C              finished. For polygon plots only, draw the main label twice.
* V694  *acm*  1/15 Changes to allow two time axes on plot (F-T)
* V695  *acm*  9/15 Changes for hour:min labeling on time axes
* V695 *acm*   5/15 Ticket 2279: Draw axis lines, tics and labels only once
*	       as for pyFerret
* V7    *acm* 6/16 Ticket 2434: command qualifiers /DEGMINSEC= /HALFSPAC
*                  DEGMINSEC=1 for Deg-Min axis labels, =2 for Deg-Min-Sec. Default = 1
*                  /HALFSPAC adds a half space between the degree sign and E/W or N/S
* *acm* - 8/16   ticket 1787: restore pen 0 correctly after graticule

C**
C**    @(#)daxis.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
	include 'parampl5_dat.decl'
	include 'PARAMPL5.DAT'
	include 'axis_inc.decl'
	include 'AXIS.INC'
	include 'labels_inc.decl'
	include 'LABELS.INC'
	include 'labcom_inc.decl'
	include 'LABCOM.INC'
	include 'hab_inc.decl'
	include 'HAB.INC'
	include 'lines_inc.decl'
	include 'LINES.INC'
	include 'pen_inc.decl'
	include 'PEN.INC'
	include 'pltl_inc.decl'
	include 'PLTL.INC'
	include 'mplot_inc.decl'
	include 'MPLOT.INC'
	include 'taxis_inc.decl'
	include 'TAXIS.INC'
	include 'tics_inc.decl'
	include 'TICS.INC'
	include 'tics2_inc.decl'
	include 'TICS2.INC'
	include 'axisl_inc.decl'
	include 'AXISL.INC'

	CHARACTER IFX*20,IFY*20
        integer ii
	LOGICAL noylab, DRAW

* TMAP interrupt flag
	include 'xinterrupt.cmn'

C If graticule lines are to be drawn across the plot at the tics
C then only do them for one horizontal and one vertical axis.  
C The dash lines interfere with each other if drawn from both 
C sides. HLINE and VLINE control this. Draw the axis after the 
C graticule lines, so the axes themselves are always solid, black.

        HLINE = .TRUE.
        VLINE = .TRUE.

C	SETUP AXIS
	CALL SETLAB(XF,YF,LTT,LTB,LYL,LYR,LXT,LXB,IFX,IFY,LTBb)
C ---------- Skip this section if not drawing the axes ----------
	IF (DRAW) THEN

	noylab =  (ylab .EQ. ' ') 
C
C     DRAW AXIS, LEFT, RIGHT Y AXIS THEN TOP, BOTTOM XAXIS
C
	IF(MAKEP.EQ.'VIEW')GOTO 1000
      IF(MYLEF.EQ.0.AND.IAXON(3).EQ.1)THEN
	  IY=ITY
C	  YAXIS1 = LINEAR ,  YAXIS2 = LOG
C
          IF(ITFLG.EQ.-1 .OR. ITFLG.EQ.2)THEN
              IF(ITFLG.EQ.-1) CALL TAYIS(ITYPET,TLO,IT1,IT2,DT,NMTCT,LTB,IFDB,ISDB,
     *        YF,XLO,XF,TCSIZE,XHI,HGRAT, HCOLOR, HLINE, IPEN(0), is_hours_axis)
              IF(ITFLG.EQ.2) CALL TAYIS(ITYPETb,TLOb,IT1b,IT2b,DT,NMTCTb,LTBb,IFDBb,ISDBb,
     *        YF,XLO,XF,TCSIZEb,XHI,HGRAT, HCOLOR, HLINE, IPEN(0), is_hours_axis)
            hline = .FALSE.
	  ELSE IF(ITYPEY.EQ.1)THEN
	   CALL YAXIS1(XLO,XF,YLO,YHI,YTIC,NMY,LINTY,1.,LYL,IFY,YF,
     *	    YCSIZE,XHI,YDMS,YDSPAC,HGRAT, HCOLOR, HLINE, YVALOFF, NOYLAB, 
     *	    SHRINKY, IPEN(0))
            hline = .FALSE.
	  ELSE
            CALL YAXIS2(XLO,XF,YLO,YHI,0.,LYL,IFY,1,YF,YCSIZE,
     .                    XHI,HGRAT, HCOLOR, HLINE, IPEN(0))
            hline = .FALSE.
          END IF
      END IF
	IF ( interrupted ) GOTO 3333		! TMAP interrupt
      IF(IAXON(4).EQ.1)THEN
	IY=-ITY
        IF(ITFLG.EQ.-1 .OR. ITFLG.EQ.2)THEN
            IF(ITFLG.EQ.-1) CALL TAYIS(ITYPET,TLO,IT1,IT2,DT,NMTCT,LTT,IFDB,ISDB,
     *      YF,XHI,XF,TCSIZE,XLO,HGRAT, HCOLOR, HLINE, IPEN(0), is_hours_axis)
            IF(ITFLG.EQ.2) CALL TAYIS(ITYPETb,TLOb,IT1b,IT2b,DT,NMTCTb,LTTb,IFDBb,ISDBb,
     *      YF,XHI,XF,TCSIZEb,XLO,HGRAT, HCOLOR, HLINE, IPEN(0), is_hours_axis)
           hline = .FALSE.
	ELSE IF(ITYPEY.EQ.1)THEN
	    CALL YAXIS1(XHI,XF,YLO,YHI,YTIC,NMY,LINTY,1.,LYR,IFY,YF,
     *     YCSIZE,XLO,YDMS,YDSPAC,HGRAT, HCOLOR, HLINE, YVALOFF, NOYLAB,
     *	    SHRINKY, IPEN(0))
           hline = .FALSE.
	ELSE
	   CALL YAXIS2(XHI,XF,YLO,YHI,0.,LYR,IFY,1,YF,YCSIZE,
     .                    XLO,HGRAT, HCOLOR, HLINE, IPEN(0))
           hline = .FALSE.
	ENDIF
      ENDIF
	IF ( interrupted ) GOTO 3333		! TMAP interrupt
      IF(IAXON(1).EQ.1)THEN
          IX=-ITX
C
C	  XAXIS1 = LINEAR, XAXIS2 = LOG, TAXIS CALLS EITHER TAXIS0,
C					 TAXIS1 OR TAXIS3
C
          IF(ITFLG.EQ.1 .OR. ITFLG.EQ.2)THEN
              CALL TAXIS(ITYPET,TLO,IT1,IT2,DT,NMTCT,LTT,IFDB,ISDB,
     *        XF,YHI,YF,TCSIZE,YLO,VGRAT, VCOLOR, VLINE, IPEN(0), is_hours_axis)
              vline = .FALSE.
          ELSE IF (ITYPEX.EQ.1)THEN
	      CALL XAXIS1(XLO,XHI,XTIC,NMX,LINTX,1.,LXT,IFX,XF,YHI,YF,
     *	       XCSIZE,YLO,XDMS,XDSPAC,VGRAT, VCOLOR, VLINE, XVALOFF, IPEN(0))
              vline = .FALSE.
          ELSE
	      CALL XAXIS2(XLO,XHI,0.,LXT,IFX,1,XF,YHI,YF,XCSIZE,
     *                    YLO,VGRAT, VCOLOR, VLINE, IPEN(0))
              vline = .FALSE.
          END IF
      END IF
	IF ( interrupted ) GOTO 3333		! TMAP interrupt
      IF(MXBOT.EQ.0.AND.IAXON(2).EQ.1)THEN
          IX=ITX
          IF(ITFLG.EQ.1 .OR. ITFLG.EQ.2)THEN
              CALL TAXIS(ITYPET,TLO,IT1,IT2,DT,NMTCT,LTB,IFDB,ISDB,
     *        XF,YLO,YF,TCSIZE,YHI,VGRAT, VCOLOR, VLINE, IPEN(0), is_hours_axis)
              vline = .FALSE.
          ELSE IF (ITYPEX.EQ.1) THEN
	      CALL XAXIS1(XLO,XHI,XTIC,NMX,LINTX,1.,LXB,IFX,XF,YLO,YF,
     *	      XCSIZE,YHI,XDMS,XDSPAC,VGRAT, VCOLOR, VLINE, XVALOFF, IPEN(0))
              vline = .FALSE.
          ELSE
	      CALL XAXIS2(XLO,XHI,0.,LXB,IFX,1,XF,YLO,YF,XCSIZE,
     *                    YHI,VGRAT, VCOLOR, VLINE, IPEN(0))
              vline = .FALSE.
          END IF
      END IF

C ---------- End of skip section if not drawing the axes ----------
      ENDIF  ! draw

* TMAP interrupt re-entry
 3333	CONTINUE

	IF(IWIND.GT.0)CALL WINDOW(XLO,YLO,XHI,YHI)
	CALL CROSS
	CALL WINDOW(0.,0.,0.,0.)
C
C	DRAW AXIS LABELS
C
1000	CONTINUE
        IF (DRAW) CALL LABDRW(XF,YF,IFX,IFY)
	CALL PPLGFLUSH
	RETURN
	END

*
* transpose_yz.F
*
* 
* 
*
* This function sets the second argument to be equal
* to the first one with the Y and Z axes switched.
*


*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument''s axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE transpose_yz_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id, 'transposes Y and Z axes of given variable')
      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, ABSTRACT,
     .                                ABSTRACT,        IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'VAR')
      CALL ef_set_arg_desc(id, arg, 'variable transposed in Y and Z')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, NO, NO, YES, YES, YES)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


      SUBROUTINE transpose_yz_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER my_lo_z, my_hi_z, my_lo_y, my_hi_y, nz, ny

*     Set the abstract Z and Y axes.

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nz = arg_hi_ss(Z_AXIS, ARG1) - arg_lo_ss(Z_AXIS, ARG1) + 1
      ny = arg_hi_ss(Y_AXIS, ARG1) - arg_lo_ss(Y_AXIS, ARG1) + 1

*     The below has the effect of translating any sub-matrix so that
*     the indices will always begin at 1 as expected for an abstract axis.

      my_lo_z = 1
      my_hi_z = ny
      my_lo_y = 1
      my_hi_y = nz

      CALL ef_set_axis_limits(id, Z_AXIS, my_lo_z, my_hi_z)
      CALL ef_set_axis_limits(id, Y_AXIS, my_lo_y, my_hi_y)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 

      END


*
* In this subroutine we compute the result
*
      SUBROUTINE transpose_yz_compute(id, arg_1, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1
      CHARACTER*100 errtxt

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* check to make sure both axis have points to transpose
      IF ( (arg_lo_ss(Y_AXIS, ARG1) .EQ. ef_unspecified_int4) .OR. 
     .     (arg_hi_ss(Y_AXIS, ARG1) .EQ. ef_unspecified_int4) ) THEN
         WRITE(errtxt,*) 'Y axis cannot be a normal axis'
         GOTO 999
      ENDIF
      IF ( (arg_lo_ss(Z_AXIS, ARG1) .EQ. ef_unspecified_int4) .OR. 
     .     (arg_hi_ss(Z_AXIS, ARG1) .EQ. ef_unspecified_int4) ) THEN
         WRITE(errtxt,*) 'Z axis cannot be a normal axis'
         GOTO 999
      ENDIF

      n1 = arg_lo_ss(F_AXIS, ARG1)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

      m1 = arg_lo_ss(E_AXIS, ARG1)
      DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

      l1 = arg_lo_ss(T_AXIS, ARG1)
      DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

      k1 = arg_lo_ss(Z_AXIS, ARG1)
      DO 300 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS) 

      j1 = arg_lo_ss(Y_AXIS, ARG1)
      DO 200 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS) 

      i1 = arg_lo_ss(X_AXIS, ARG1)
      DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         IF ( arg_1(i1,j1,k1,l1,m1,n1) .NE. bad_flag(ARG1) ) THEN
            result(i,j,k,l,m,n) = arg_1(i1,j1,k1,l1,m1,n1)
         ELSE
            result(i,j,k,l,m,n) = bad_flag_result
         ENDIF

         i1 = i1 + arg_incr(X_AXIS, ARG1)
 100  CONTINUE

         j1 = j1 + arg_incr(Y_AXIS, ARG1)
 200  CONTINUE

         k1 = k1 + arg_incr(Z_AXIS, ARG1)
 300  CONTINUE

         l1 = l1 + arg_incr(T_AXIS, ARG1)
 400  CONTINUE

         m1 = m1 + arg_incr(E_AXIS, ARG1)
 500  CONTINUE

         n1 = n1 + arg_incr(F_AXIS, ARG1)
 600  CONTINUE

      RETURN 

 999  CALL EF_BAIL_OUT(id, errtxt)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	LOGICAL FUNCTION NC_GET_ATTRIB_FLOAT ( dset, varid, attrib,
     .                                   do_warn, vname, attlen, 
     .                                   attoutflag, vals )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* get a float values from attribute in a netCDF data structure if the attribute exists
* 
* Based on CD_GET_ATTRIB
* V600 -  5/05 *acm*  Attribute handling upgrade. Rework to read information 
*                     from data strucure rather than the netCDF file.
*                     Replace NCAINQ with CD_GET_VAR_ATT_INFO
*                     Replace NCAGTC with CD_GET_VAR_ATTR
*                     This routine now returns both character and real results,
*                     so it replaces CD_GET_ATTVAL.
*         6/06 *acm*  replace istat with status
*         8/06 *acm*  test for too_long should be .GT. IF (attlen .GT. maxlen) THEN
* V602  2/07 *acm* Fix bug 1492, changing attributes of coordinate variables 
* V602 *acm* make sure lena=length of attr name is defined before writing warning
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Make sure parameters values are consistent with 
*                              whats in netcdf.inc from netcdf4.
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files
* v6.85+ 12/13 *acm* take more care with string length,needed when bounds checking

* argument definitions:
*	dset	 - dataset number
*       varid    - variable id 
*       attrib   - attribute to search for
*	do_warn	 - logical flag to issue warning if invalid attribute
*                - warnings are never issued if attribute doesn't exit
*       vname    - name of variable owning attribute (used in error msgs)
*       maxlen   - maximum allowable return string
*       attlen   - length of output (string length or number of values)
*       attoutflag- 1 if attribute to be written to output files, 0 if not
*       string   - array in which to return result if string type
*       vals     - array in which to return result if numerical type

* argument declarations
      LOGICAL       do_warn
      INTEGER	    dset, varid, attlen, attoutflag
      CHARACTER*(*) attrib, vname
      REAL          vals(*)
      real*8        dval(100)

#include "gt_lib.parm"
      include 'netcdf.inc'
      include 'xio.cmn_text'
      include 'tmap_errors.parm'
      include 'xrisc_buff.cmn'

* internal variable declarations:
      LOGICAL too_long
      INTEGER TM_LENSTR1, NCF_GET_VAR_ATTR,
     .        maxlen, lena, lenb, attype, status, i, dset_num, attid
      CHARACTER*128 aname, string, buff

      INTEGER tt  ! nice short name
      EQUIVALENCE (tt,lunit_errors)

      INTEGER slen, flen
      PARAMETER (flen=size_rbuff)        ! size of attribute string
#ifdef sun
      BYTE      fhol(flen), ghol(flen)      ! c-type Hollerith string buffer
#else
      INTEGER*1 fhol(flen), ghol(flen)     ! c-type Hollerith string buffer
#endif 

       NC_GET_ATTRIB_FLOAT = .FALSE.
       IF (dset .EQ. unspecified_int4) RETURN
       IF (varid .LT. 0) RETURN

* initialize
       maxlen = LEN(string)
       string(:maxlen) = ' '
       too_long = .FALSE.

* inquire about the attribute by name, using its id number

      CALL CD_GET_VAR_ATT_ID (dset, varid, attrib, attid, status)
      IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, varid, attid,
     .                   aname, attype, attlen, attoutflag, status )

      IF ( status .NE. merr_ok ) THEN
         NC_GET_ATTRIB_FLOAT = .FALSE.
         RETURN  ! doesn't exist
      ENDIF

      lena = TM_LENSTR1( aname )
      CALL TM_FTOC_STRNG (aname(:lena), ghol, flen)

* Get attribute length and value

      dset_num = dset
      IF (dset_num .LT. -2) dset_num = -2
      status = NCF_GET_VAR_ATTR(dset_num, varid, ghol, fhol, attlen, dval)

      IF ( status .NE. merr_ok ) THEN
         NC_GET_ATTRIB_FLOAT = .FALSE.
         attlen = 0
         attoutflag = 0
         RETURN  
      ENDIF

      IF ( attype.EQ.NF_CHAR ) THEN

         lena = attlen
         IF (attlen .GT. maxlen) THEN
            fhol(maxlen) = 0
            lena = maxlen
            too_long = .TRUE.
         ENDIF

         CALL TM_CTOF_STRNG ( fhol, string, lena )
         READ (string, *, err=5000) vals(1)

         NC_GET_ATTRIB_FLOAT = .TRUE.
         GOTO 5010

      ELSE

         NC_GET_ATTRIB_FLOAT = .TRUE.
         DO 80 i = 1, attlen
  80        vals(i) = dval(i)

      ENDIF

      RETURN

* Error exit

 5000 lena = TM_LENSTR1( attrib )
      buff = 'Unexpected attribute type: attribute "'//attrib(:lena)//
     .       '" string instead of float, in netCDF variable: '//vname
      lenb = TM_LENSTR1( buff )
      CALL TM_NOTE( buff(:lenb), tt )

      buff = 'Unable to convert attribute value to float "'
     .       //string(:lenb)//'"'
      lenb = TM_LENSTR1( buff )
      CALL TM_NOTE( buff(:lenb), tt )

      CALL TM_ERRMSG
     .     ( status+pcdferr, status, 'NC_GET_ATTRIB_FLOAT', dset,
     .        no_varid, no_errstring, no_errstring, *5900 )

 5900 RETURN

* warning exit - converted string to float
 5010 lenb = TM_LENSTR1( string )
 
      lena = TM_LENSTR1( attrib )
      buff = 'Unexpected attribute type: attribute "'//attrib(:lena)//
     .       '" string instead of float, in netCDF variable: '//vname
      lenb = TM_LENSTR1( buff )
      IF ( do_warn ) CALL TM_NOTE( buff(:lenb), tt )
      RETURN

      END

! curv_to_rect_fsu.F
! From Matt Harrison hinterp.F
! to call only the spherical interpolation modules, and
! recast in F77-compileable format.
!
! This is a special version of curv_to_rect, but with num_nbrs = 1 not 4.
! the mapping function computed at FSU uses just one neighbor.
!   
!   -- Check use of and document issue of cell bounds 
!      vs cell centers.
!
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*


* acm 12/2004 Compute the sum of weights in routine apply_mapping; 
*             sum of weights used when there is good data contributing 
*             to the destination point.
*             Remove use of mask_dst variable; never used.
* acm  3/2005 The curvilinear data may be a subset.  If it was saved
*             with SAVE/HEADING=ENHANCED, then the lo and hi subscripts
*             in the dataset correspond to the subset, and we can use
*             a map pre-computed using the entire dataset for this regridding.
*             Pass the subscripts of the input curvilinear data to the 
*             apply_mapping routine (if not a subset these are 1:max_ss).
* ACM  1/2009 Correct bug with the indices passed into apply_mapping; Treating
*             indices as if they start at 1 inside that routine lets us compute 
*             and apply mapping functions based on subsets of the grid


! In this SUBROUTINE we provide information about
! the function.  The user configurable information 
! consists of the following:
!
! descr              Text description of the function
!
! num_args           Required number of arguments
!
! axis_inheritance   Type of axis for the result
!                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
!                       CUSTOM          - user defined axis
!                       IMPLIED_BY_ARGS - same axis as the incoming argument
!                       NORMAL          - the result is normal to this axis
!                       ABSTRACT        - an axis which only has index values
!
! piecemeal_ok       For memory optimization:
!                       axes where calculation may be performed piecemeal
!                       ( YES, NO )
! 
!
! For each argument we provide the following information:
!
! name               Text name for an argument
!
! unit               Text units for an argument
!
! desc               Text description of an argument
!
! axis_influence     Are this argument's axes the same as the result grid?
!                       ( YES, NO )
!
! axis_extend       How much does Ferret need to extend arg limits relative to result 
!


      SUBROUTINE curv_to_rect_fsu_init(id)
        
      INCLUDE 'EF_Util.cmn'

      INTEGER   id, arg
      CHARACTER*100  descr

!**********************************************************************
!                                           USER CONFIGURABLE PORTION |
!                                                                     |
!                                                                     V

      WRITE (descr, 10)
   10 FORMAT
     .('Alt func to Apply mapping to regrid from curvilinear to rectangular grid')
      CALL ef_set_desc(id, descr)

      CALL ef_set_num_args(id, 2)

      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS,  
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'V')
      CALL ef_set_arg_desc(id, arg, 
     .  'Variable to regrid, on curvilinear grid V(x,y,z,t)')
      CALL ef_set_axis_influence(id, arg, NO, NO, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'mapping')
      WRITE (descr, 30)
   30 FORMAT ('mapping computed by curv_to_rect_MAP')
      CALL ef_set_arg_desc(id, arg, descr)
      CALL ef_set_axis_influence(id, arg, YES, YES, NO, NO)

!                                                                     ^
!                                                                     |
!                                           USER CONFIGURABLE PORTION |
!***********************************************************************

      RETURN 
      END  ! SUBROUTINE curv_to_rect_fsu_init


!
! In this SUBROUTINE we compute the result
!
      SUBROUTINE curv_to_rect_fsu_compute(id, arg_1, arg_2, result)

      IMPLICIT none
      
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'
      
      INTEGER  id

      REAL  bad_flag(EF_MAX_ARGS), bad_flag_result

      REAL  arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .       mem1lot:mem1hit)
      REAL  arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .       mem2lot:mem2hit)

      REAL  result(memreslox:memreshix, memresloy:memreshiy, 
     .      memresloz:memreshiz, memreslot:memreshit)

! After initialization, the 'res_' arrays contain indexing information 
! for the result axes.  The 'arg_' arrays will contain the indexing 
! information for each variable's axes. 

      INTEGER  res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER  arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .         arg_incr(4,EF_MAX_ARGS)
      
!**********************************************************************
!                                           USER CONFIGURABLE PORTION |
!                                                                     |
!                                                                     V

      INTEGER  i, j, k, l, i1, j1, k1, l1, i2, j2, k2, l2, ih, jh,
     .         num_nbrs, nlon_src, nlat_src, nlon_dst, nlat_dst

      num_nbrs = 4
      num_nbrs = 1
      
      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id,bad_flag,bad_flag_result)

      nlon_src = arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 1
      nlat_src = arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1) + 1

      nlon_dst = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1
      nlat_dst = arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) + 1

      i1 = arg_lo_ss(X_AXIS,ARG1)
      j1 = arg_lo_ss(Y_AXIS,ARG1)
      ih = arg_hi_ss(X_AXIS,ARG1)
      jh = arg_hi_ss(Y_AXIS,ARG1)

      i2 = arg_lo_ss(X_AXIS,ARG2)
      j2 = arg_lo_ss(Y_AXIS,ARG2)
      k2 = arg_lo_ss(Z_AXIS,ARG2)
      l2 = arg_lo_ss(T_AXIS,ARG2)

      i = res_lo_ss(X_AXIS)
      j = res_lo_ss(Y_AXIS)

      l1 = arg_lo_ss(T_AXIS,ARG1)
      DO l = res_lo_ss(T_AXIS),res_hi_ss(T_AXIS)

         k1 = arg_lo_ss(Z_AXIS,ARG1)
         DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

c     .        i1, ih, j1, jh,  ! line 2 of this call WAS... 
c     .        1,nlon_src, 1,nlat_src,  ! Or try  
            CALL apply_mapping ( arg_1(i1,j1,k1,l1), 
     .        i1, ih, j1, jh,
     .        arg_2(i2,j2,k2,l2), arg_2(i2,j2,k2,l2+1),
     .        arg_2(i2,j2,k2,l2+2), result(i,j,k,l), nlon_src,
     .        nlat_src, nlon_dst, nlat_dst, num_nbrs, 
     .        bad_flag(ARG1), bad_flag_result )

            k1 = k1 + arg_incr(Z_AXIS,ARG1)
         ENDDO

         l1 = l1 + arg_incr(T_AXIS,ARG1)
      ENDDO


!                                                                     ^
!                                                                     |
!                                           USER CONFIGURABLE PORTION |
!**********************************************************************

      RETURN 
      END  ! SUBROUTINE curv_to_rect_fsu_compute

*  piecewise3.F
* 
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* Ansley Manke June 2013
* implements stl2, Piecewise linear approximations of fewest line segments
* described in http://www.computer.org/csdl/proceedings/afips/1972/5079/00/50790187.pdf
* and a somewhat later version of the code, found at
* http://www.netlib.org/toms/510
*
*
*  In this subroutine we provide information about
*  the function.  The user configurable information 
*  consists of the following:
* 
*  descr              Text description of the function
* 
*  num_args           Required number of arguments
* 
*  axis_inheritance   Type of axis for the result
*                        ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                        CUSTOM          - user defined axis
*                        IMPLIED_BY_ARGS - same axis as the incoming argument
*                        NORMAL          - the result is normal to this axis
*                        ABSTRACT        - an axis which only has index values
* 
*  piecemeal_ok       For memory optimization:
*                        axes where calculation may be performed piecemeal
*                        ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE piecewise3_init(id)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     . 'Return indices to sample from piecewise linear interpolation' )

      CALL ef_set_num_args(id, 7) 
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, ABSTRACT, NORMAL, 
     .                                              NORMAL,   NORMAL)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 6)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'V1')
      CALL ef_set_arg_desc(id, arg, '1st variable to sample')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'V2')
      CALL ef_set_arg_desc(id, arg, '2nd variable to sample')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'V3')
      CALL ef_set_arg_desc(id, arg, '3rd variable to sample')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'Control parameter')
      CALL ef_set_arg_desc(id, arg,
     .          'Control parameter (e.g. 6 for ntol=rest=cont=1)')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'Tol1')
      CALL ef_set_arg_desc(id, arg, 'Tolerance for V1')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 6
      CALL ef_set_arg_name(id, arg, 'Tol2')
      CALL ef_set_arg_desc(id, arg, 'Tolerance for V2')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 7
      CALL ef_set_arg_name(id, arg, 'Tol3')
      CALL ef_set_arg_desc(id, arg, 'Tolerance for V3')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)



*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE piecewise3_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER my_hi_i
      INTEGER arg_lo_ss(4,EF_MAX_ARGS),
     .        arg_hi_ss(4,EF_MAX_ARGS),
     .        arg_incr (4,EF_MAX_ARGS)

*
*     Use utility functions to get context information about the arguments.
*

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      my_hi_i = arg_hi_ss(X_AXIS,1) - arg_lo_ss(X_AXIS,1) + 1

      CALL ef_set_axis_limits(id, X_AXIS, 1, my_hi_i)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

      
*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE piecewise3_work_size(id)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
* 
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims(id, array #,
*                           xlo, ylo, zlo, tlo, 
*                           xhi, yhi, zhi, thi)
*

      INTEGER arg_lo_ss(4,EF_MAX_ARGS),
     .        arg_hi_ss(4,EF_MAX_ARGS),
     .        arg_incr (4,EF_MAX_ARGS)
      INTEGER npts, iwork

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      npts = 1 + arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1)
  
* input x-axis coordinates
      iwork = 1
      CALL ef_set_work_array_dims(id, iwork,
     .                                1, 1, 1, 1,
     .                             npts, 1, 1, 1)

* internal computation, u1 for y1
      iwork = 2
      CALL ef_set_work_array_dims(id, iwork,
     .                                1, 1, 1, 1,
     .                             npts, 1, 1, 1)

* internal computation, u2 for y2
      iwork = 3
      CALL ef_set_work_array_dims(id, iwork,
     .                                1, 1, 1, 1,
     .                             npts, 1, 1, 1)

* internal computation, u3 for y3
      iwork = 4
      CALL ef_set_work_array_dims(id, iwork,
     .                                1, 1, 1, 1,
     .                             npts, 1, 1, 1)

* internal computation, v
      iwork = 5
      CALL ef_set_work_array_dims(id, iwork,
     .                                1, 1, 1, 1,
     .                           2*npts, 1, 1, 1)

* internal computation, w
      iwork = 6
      CALL ef_set_work_array_dims(id, iwork,
     .                                1, 1, 1, 1,
     .                           2*npts, 1, 1, 1)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*  In this subroutine we compute the result
* 
      SUBROUTINE piecewise3_compute(id, arg_1, arg_2, arg_3, arg_4, 
     .        arg_5, arg_6, arg_7, result, xpts, u1, u2, u3, v, w)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz, 
     .           mem4lot:mem4hit)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz, 
     .           mem5lot:mem5hit)
      REAL arg_6(mem6lox:mem6hix, mem6loy:mem6hiy, mem6loz:mem6hiz, 
     .           mem6lot:mem6hit)
      REAL arg_7(mem7lox:mem7hix, mem7loy:mem7hiy, mem7loz:mem7hiz, 
     .           mem7lot:mem7hit)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit)

* Ignore the Y/Z/T/E/F dimensions in the work array since
* they are not used and Fortran is column major

      REAL xpts(wrk1lox:wrk1hix)

      REAL u1(wrk2lox:wrk2hix)
      REAL u2(wrk3lox:wrk3hix)
      REAL u3(wrk4lox:wrk4hix)
      REAL  v(wrk5lox:wrk5hix)
      REAL  w(wrk6lox:wrk6hix)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4),
     .        res_hi_ss(4),
     .        res_incr (4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS),
     .        arg_hi_ss(4,EF_MAX_ARGS),
     .        arg_incr (4,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,  k
      INTEGER nx, nout1, nout2, nout3, nmerge1, nmerge2, ip
      REAL val, tol(3), bad_y
      CHARACTER*100 errtxt

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* Control parameter IP

      CALL ef_get_one_val(id, ARG4, val)
      IP = INT(val)

* Tolerances

      CALL ef_get_one_val(id, ARG5, tol(1))

      CALL ef_get_one_val(id, ARG6, tol(2))

      CALL ef_get_one_val(id, ARG7, tol(3))

*  Set x coordinate - abstract axis.

      nx = arg_hi_ss(X_AXIS, ARG1) - arg_lo_ss(X_AXIS, ARG1) + 1
      DO 50 i = 1, nx
         xpts(i) = i
  50  CONTINUE

      k = res_lo_ss(Z_AXIS)  ! index for unused dimensions

* STL2 modified to truncate result to next lowest integer

      bad_y = bad_flag(ARG1)
      CALL STL2(xpts, arg_1, tol(1), nx, bad_y, bad_flag_result, 
     .   u1, v, w, nout1, IP)
      IF (nout1 .GT. res_hi_ss(X_AXIS)) THEN
        write (errtxt,*) 'first call to STL2 returns too many data', nout1
	 GOTO 999
      ENDIF

      bad_y = bad_flag(ARG2)
      CALL STL2(xpts, arg_2, tol(2), nx, bad_y, bad_flag_result, 
     .   u2, v, w, nout2, IP)
      IF (nout1 .GT. res_hi_ss(X_AXIS)) THEN
        write (errtxt,*) 'second call to STL2 returns too many data', nout2
	 GOTO 999
      ENDIF

      bad_y = bad_flag(ARG3)
      CALL STL2(xpts, arg_3, tol(3), nx, bad_y, bad_flag_result, 
     .   u3, v, w, nout3, IP)
      IF (nout1 .GT. res_hi_ss(X_AXIS)) THEN
        write (errtxt,*) 'third call to STL2 returns too many data', nout3
	 GOTO 999
      ENDIF

* Truncate result(j=1) to next lowest integer - its going to be
* the set of coordinate values to sample at.

      DO 100 i = 1, nout1+nout2
	 w(i) = 0.
 100  CONTINUE

      CALL merge (u1,nout1,u2,nout2,w,nmerge1)
      IF (nout1 .GT. res_hi_ss(X_AXIS)) THEN
        write (errtxt,*) 'nmerge1 too large', nmerge1
	 GOTO 999
      ENDIF

      DO 200 i = 1, nout1+nout2
	 v(i) = 0.
 200  CONTINUE

      CALL merge (w,nmerge1,u3,nout3,v,nmerge2)
	      IF (nout1 .GT. res_hi_ss(X_AXIS)) THEN
        write (errtxt,*) 'nmerge2 too large', nmerge2
	 GOTO 999
      ENDIF

      DO 300 i = 1, nmerge2
        result(i,k,k,k) = v(i)
 300  CONTINUE

      DO 400 i = nmerge2+1, res_hi_ss(X_AXIS)
        result(i,k,k,k) = bad_flag_result
 400  CONTINUE

      RETURN
 999  CALL EF_BAIL_OUT(id, errtxt)
      RETURN

      END

      SUBROUTINE STL2(X, Y, E, M, bad_y, bad_out, U, V, W, K, IP)

C PIECEWISE LINEAR APPROXIMATIONS OF FEWEST
C LINE SEGMENTS WITHIN GIVEN TOLERANCES.

C X,Y,E AND M CONTAIN INPUT DATA.
C U,V,K AND POSSIBLY W CONTAIN OUTPUT.

C IP IS A PARAMETER DETERMINING THE OPERATION
C  OF THE PROGRAM.

C X AND Y ARE INPUT DATA ARRAYS OF M ELEMENTS
C  X(I),Y(I) CONTAINS THE ITH DATA POINT.

C E MAY BE A SINGLE TOLERANCE OR A TABLE OF
C  TOLERANCES DEPENDING ON THE VALUE OF IP.
C IF E IS AN ARRAY, THEN E(I) IS THE TOLERANCE
C  ASSOCIATED WITH X(I),Y(I) AND E MUST CONTAIN
C  M NONNEGATIVE ELEMENTS.

C U AND V ARE OUTPUT ARRAYS OF K+1 ELEMENTS.
C  U IS A PARTITION OF THE INTERVAL (X(1),X(N))
C  WITH U(1)=X(1) AND U(K+1)=X(N).
C  V(I) IS AN ORDINATE TO BE ASSOCIATED WITH
C  U(I) IN THE APPROXIMATION.  (IF A CONTINUOUS
C  APPROXIMATION IS REQUESTED, THEN V(I) IS
C  'THE' ORDINATE TO BE ASSOCIATED WITH U(I).)

C IF A CONTINUOUS APPROXIMATION IS REQUESTED,
C  THEN W IS NOT USED.  IN THIS CASE THE ITH
C  APPROXIMATING SEGMENT IS THE STRAIGHT LINE
C  FROM U(I),V(I) TO U(I+1),V(I+1).

C IF A CONTINUOUS APPROXIMATION IS NOT
C  REQUESTED, THEN W IS A K-ELEMENT OUTPUT
C  ARRAY.  IN THIS CASE THE ITH APPROXIMATING
C  SEGMENT IS THE STRAIGHT LINE FROM
C  U(I),W(I) TO U(I+1),V(I+1), AND V(1) IS
C  SET EQUAL TO W(1).

C K IS THE NUMBER OF SEGMENTS IN THE PIECE-
C  WISE LINEAR APPROXIMATION GENERATED.  IN
C  CASE OF AN ERROR RETURN, K WILL BE SET TO
C  ZERO.

C THE CONTROL PARAMETER IP IS THE PRODUCT
C  OF THREE INDICATORS I1,I2 AND I3.
C  I1 INDICATES WHETHER OR NOT E IS AN
C     ARRAY OF TOLERANCES.
C     I1 = -1 INDICATES E IS AN ARRAY
C     I1 = +1 INDICATES E IS A SINGLE NUMBER.
C  I2 INDICATES WHETHER OR NOT THE
C     APPROXIMATION IS TO BE RESTRICTED TO
C     THE 'TOLERANCE BAND' ABOUT THE DATA.
C     I2 = 1 INDICATES NO BAND RESTRICTION
C     I2 = 2 INDICATES APPLY THIS RESTRICTION
C     (THE 'TOLERANCE BAND' IS A PIECEWISE
C     LINEAR BAND CENTERED AT THE DATA WHOSE
C     WIDTH IS DETERMINED BY THE TOLERANCES
C     AT THE DATA POINTS.)
C  I3 INDICATES WHETHER OR NOT THE
C     APPROXIMATION MUST BE CONTINUOUS.
C     I3 = 1 INDICATES CONTINUITY NOT REQUIRED
C     I3 = 3 INDICATES CONTINUITY IS REQUIRED

C CALL STL2 (X,Y,E,M,X,Y,E,M,IP) WILL NOT
C  CAUSE PROBLEMS PROVIDED THAT
C  EITHER A CONTINUOUS APPROXIMATION IS
C  REQUESTED, OR E IS A SUFFICIENTLY LARGE
C  ARRAY.

C THE PROGRAM PERFORMS THE FOLLOWING DATA
C  CHECKS.  ARE THE X-VALUES IN INCREASING
C  ORDER.  ARE THE TOLERANCE(S) NONNEGATIVE.
C  IS THE NUMBER OF DATA POINTS GREATER THAN
C  ONE.  IF ANY CHECK FAILS, THE PROGRAM
C  RETURNS WITH K SET EQUAL TO 0.  IN THIS
C  CASE NO FURTHER PROCESSING IS ATTEMPTED.

      IMPLICIT NONE
* Calling arguments
      REAL X(*), Y(*), E(*), U(*), V(*), W(*), bad_y, bad_out
      INTEGER M, K, IP

* Local declarations
      LOGICAL skipbad
      INTEGER N, ITCH, I, J, L, KEEP, INIT, INDC, IGRAZE,
     .        IDIOT, IT, IPIV, KP
      REAL EPSLN, SGN, XEYE, YEYE, TEMP1, SMIN, DX, 
     .     SVX, SVY, SVMN, TEMP2, XINIT, YINIT, SLOPE, SMAX, 
     .     SVMX, TEST

      N = M
      ITCH = IP
      J = 1
C ERROR CHECKS
      IF (N.LE.1) GO TO 400
      IF (E(1).LT.0.0) GO TO 400
      DO 10 L=2,N
        IF (X(L-1).GE.X(L)) GO TO 400
        IF (ITCH.GE.0) GO TO 10
        IF (E(L).LT.0.0) GO TO 400
   10 CONTINUE
C INITIALIZATION FOR ENTIRE PROGRAM
      EPSLN = E(1)
      SGN = 1.0
      KEEP = 1
      I = 1

      CALL PIECEWISE3_CHECKGAP (Y, bad_y, x, u, i, j, n, skipbad)
      IF (skipbad) GOTO 30

      U(i) = X(i)
      J = 2
      INIT = 1
      INDC = 0
      GO TO 30
C INITIALIZATION FOR EACH SEGMENT
   20 CONTINUE
      J = J + 1
      INIT = I
      INDC = 0
      IF (IABS(ITCH).LT.3) KEEP = I
      IF (IABS(IABS(ITCH)-4).NE.2) GO TO 30
C RESTRICTED TO TOLERANCE BAND
      XEYE = U(J-1)
      YEYE = V(J-1)
      TEMP1 = EPSLN
      IF (ITCH.LT.0) TEMP1 = TEMP1 + (SGN*E(I-1)-EPSLN)*(X(I)-U(J-1)
     * )/(X(I)-X(I-1))
      YINIT = YEYE - TEMP1 - TEMP1
      GO TO 40
   30 CONTINUE
C NOT RESTRICTED TO TOLERANCE BAND
      XEYE = X(I)
      YEYE = Y(I) + EPSLN
      YINIT = Y(I) - EPSLN
      IF (IABS(ITCH).EQ.1 .OR. I.EQ.1) GO TO 40
      TEMP1 = EPSLN
      IF (ITCH.LT.0) TEMP1 = SGN*E(I+1)
      SMIN = (Y(I+1)-YEYE-TEMP1)/(X(I+1)-XEYE)
      IF (ITCH.LT.0) TEMP1 = SGN*E(I-1)
      SMAX = (YEYE-Y(I-1)+TEMP1)/(XEYE-X(I-1))

      IF (KEEP.EQ.I-1) GO TO 50
      IT = I - 2
      XINIT = XEYE
      IPIV = I
      IGRAZE = I
      I = I + 1

      CALL PIECEWISE3_CHECKGAP (Y, bad_y, x, u, i, j, n, skipbad)
      IF (skipbad) GOTO 30

      GO TO 150
   40 CONTINUE
      IF (XEYE.GE.X(I)) I = I + 1
      IF (ITCH.LT.0) EPSLN = SGN*E(I)
      DX = X(I) - XEYE
      SMAX = (Y(I)+EPSLN-YEYE)/DX
      SMIN = (Y(I)-EPSLN-YEYE)/DX
   50 CONTINUE
      XINIT = XEYE
      IPIV = I
      IGRAZE = I
C DETERMINATION OF INDIVIDUAL SEGMENT
   60 CONTINUE
      IF (I.EQ.N) GO TO 260
      I = I + 1
      
C New i, so does it point to a bad-val?

      CALL PIECEWISE3_CHECKGAP (Y, bad_y, x, u, i, j, n, skipbad)
      IF (skipbad) GOTO 30

   70 CONTINUE
 
C TEST FOR NEW *MAX* SLOPE
      DX = X(I) - XEYE
      IF (ITCH.LT.0) EPSLN = SGN*E(I)
      TEMP1 = (Y(I)+EPSLN-YEYE)/DX
      TEST = TEMP1 - SMAX
      IF (SGN.LE.0.0) TEST = -TEST
      IF (TEST) 80, 90, 100
   80 CONTINUE
C TEST FOR END OF CANDIDATE SEGMENT
      TEST = TEMP1 - SMIN
      IF (SGN.LE.0.0) TEST = -TEST
      IF (TEST.LT.0.0) GO TO 210
      SMAX = TEMP1
   90 CONTINUE
C TEST FOR NEW *MIN* SLOPE
      IPIV = I
  100 CONTINUE
      TEMP2 = (Y(I)-EPSLN-YEYE)/DX
      TEST = TEMP2 - SMAX
      IF (SGN.LE.0.0) TEST = -TEST
      IF (TEST) 110, 120, 140
  110 CONTINUE
      TEST = SMIN - TEMP2
      IF (SGN.LE.0.0) TEST = -TEST
      IF (TEST) 120, 130, 60
  120 CONTINUE
      SMIN = TEMP2
  130 CONTINUE
      IGRAZE = I
      GO TO 60
C CHECK FOR PIVOT AT NEW EYE POINT
  140 CONTINUE
      IF (XEYE.EQ.X(IPIV)) GO TO 220
      IF (ITCH.LT.0) EPSLN = SGN*E(IPIV)
      INDC = 1
      SVX = XEYE
      SVY = YEYE
      SVMN = SMIN
      SVMX = SMAX
      XEYE = X(IPIV)
      YEYE = Y(IPIV) + EPSLN
      SMIN = SMAX
      SMAX = (YINIT-YEYE)/(XINIT-XEYE)
      IF (KEEP.GE.IPIV) GO TO 170
      IT = IPIV - 1
  150 CONTINUE
      TEMP2 = YEYE + EPSLN
      DO 160 L=KEEP,IT
        IF (ITCH.LT.0) TEMP2 = YEYE + SGN*E(L)
        TEMP1 = (Y(L)-TEMP2)/(X(L)-XEYE)
        TEST = TEMP1 - SMAX
        IF (SGN.LE.0.0) TEST = -TEST
        IF (TEST.LT.0.0) SMAX = TEMP1
  160 CONTINUE
  170 CONTINUE
      IF (IPIV.GE.I-1) GO TO 70
      IT = I - 2
      TEMP2 = YEYE - EPSLN
      IDIOT = IPIV
      DO 200 L=IDIOT,IT
        DX = X(L+1) - XEYE
        IF (ITCH.LT.0) TEMP2 = YEYE - SGN*E(L+1)
        TEMP1 = (Y(L+1)-TEMP2)/DX
        TEST = TEMP1 - SMAX
        IF (SGN.LE.0.0) TEST = -TEST
        IF (TEST) 180, 190, 200
  180   CONTINUE
        SMAX = TEMP1
  190   CONTINUE
        IPIV = L + 1
  200 CONTINUE
      GO TO 70
C END OF CURRENT SEGMENT
  210 CONTINUE
      TEMP2 = SMIN
      IF (I.EQ.N) GO TO 240
      KEEP = IGRAZE
      GO TO 250
  220 CONTINUE
      TEMP2 = SMAX
      IF (I.EQ.N) GO TO 230
      SGN = -SGN
      EPSLN = -EPSLN
      KEEP = IPIV
      GO TO 250
  230 CONTINUE
      IF (INDC.EQ.0 .OR. XEYE.NE.X(N-1)) GO TO 240
      XEYE = SVX
      YEYE = SVY
      SMIN = SVMN
      SMAX = SVMX
  240 CONTINUE
      U(J) = X(N-1)
      YINIT = Y(N-1)
      GO TO 270
  250 CONTINUE
      IF (IABS(IABS(ITCH)-4).NE.2) GO TO 300
C DETERMINE KNOT ON EDGE OF TOLERANCE BAND
      TEMP1 = 0.0
      IF (ITCH.LT.0) TEMP1 = EPSLN - SGN*E(I-1)
      TEMP1 = (Y(I)-Y(I-1)+TEMP1)/(X(I)-X(I-1))
      
      U(J) = (Y(I)+EPSLN-YEYE-TEMP1*X(I)+TEMP2*XEYE)/(TEMP2-TEMP1)

      GO TO 310
  260 CONTINUE
      U(J) = X(N)
      YINIT = Y(N)
  270 CONTINUE
C CONTINUITY CHECK FOR LAST SEGMENT
      IF (IABS(ITCH).GE.3 .OR. INIT.EQ.1) GO TO 290
      IT = INIT - 1
      SVMX = SMAX + SGN
      TEMP2 = YEYE + EPSLN
      DO 280 L=KP,IT
        IF (ITCH.LT.0) TEMP2 = YEYE + SGN*E(L)
        TEMP1 = (Y(L)-TEMP2)/(X(L)-XEYE)
        TEST = TEMP1 - SVMX
        IF (SGN.LE.0.0) TEST = -TEST
        IF (TEST.LT.0.0) SVMX = TEMP1
  280 CONTINUE
      IF (ABS(SVMX-SMAX+SVMX-SMIN).LE.ABS(SMAX-SMIN)) SMAX = SVMX
  290 CONTINUE
C NEARNESS CHECK FOR LAST SEGMENT
      TEMP2 = SMAX
      TEMP1 = YEYE + SMAX*(U(J)-XEYE)
      TEST = YINIT - TEMP1
      IF (SGN.LT.0.0) TEST = -TEST
      IF (TEST.GT.0.0) GO TO 310
      TEMP2 = SMIN
      TEMP1 = YEYE + SMIN*(U(J)-XEYE)
      TEST = YINIT - TEMP1
      IF (SGN.LT.0.0) TEST = -TEST
      IF (TEST.LT.0.0) GO TO 310
      TEMP2 = (YINIT-YEYE)/(U(J)-XEYE)
      V(J) = YINIT
      GO TO 320
  300 CONTINUE
      IF (IABS(ITCH).GE.3) GO TO 330
      U(J) = 0.5*(X(I)+X(I-1))
  310 CONTINUE
      V(J) = YEYE + TEMP2*(U(J)-XEYE)
  320 CONTINUE
      IF (XEYE.NE.XINIT) GO TO 330
      IF (IABS(ITCH).EQ.2) GO TO 360
      IF (IABS(ITCH).NE.6) GO TO 330
      IF (J.LE.2) GO TO 380
      GO TO 390
  330 CONTINUE
C RECOMPUTATION OF KNOT FOR CONTINUITY
      IF (J.LE.2) GO TO 370
      IF (SLOPE.EQ.TEMP2) GO TO 360
      YINIT = V(J-2)
      IF (IABS(ITCH).LT.3) YINIT = W(J-2)
      TEMP1 = (XEYE*TEMP2-U(J-2)*SLOPE+YINIT-YEYE)/(TEMP2-SLOPE)
      IF (IABS(ITCH).GE.3) GO TO 350
      IF (TEMP1.GT.XINIT) GO TO 360
      TEST = ABS(EPSLN)
      IDIOT = INIT - KP
      DO 340 L=1,IDIOT
        IT = INIT - L
        IF (TEMP1.GE.X(IT)) GO TO 350
        DX = Y(IT) - YEYE - TEMP2*(X(IT)-XEYE)
        IF (ITCH.LT.0) TEST = E(IT)
        IF (ABS(DX).GT.TEST) GO TO 360
  340 CONTINUE
  350 CONTINUE
      U(J-1) = TEMP1
      V(J-1) = YEYE + TEMP2*(U(J-1)-XEYE)
      IF (IABS(ITCH).LT.3) W(J-1) = V(J-1)
      GO TO 390
  360 CONTINUE
      W(J-1) = YEYE + TEMP2*(U(J-1)-XEYE)
      GO TO 390
  370 CONTINUE
      IF (IABS(ITCH).LT.3) GO TO 360
  380 CONTINUE
      V(1) = YEYE + TEMP2*(U(1)-XEYE)
  390 CONTINUE
      SLOPE = TEMP2
      KP = KEEP
      IF (I.LT.N) GO TO 20
      IF (X(N).EQ.U(J)) GO TO 400
      IF (IABS(ITCH).LT.3) W(J) = V(J)
      J = J + 1
      U(J) = X(N)
      V(J) = Y(N)
  400 CONTINUE
      IF (J.GE.2 .AND. IABS(ITCH).LT.3) V(1) = W(1)
      K = J

* Truncate to integer values: indices at which to sample

      DO 500 I = 1, K
         u(i) = INT(u(i))
  500 CONTINUE

      RETURN
      END

      SUBROUTINE PIECEWISE3_CHECKGAP (Y, bad_y, x, u, i, j, 
     .   n, skipbad)
      REAL Y(*), bad_y, x(*), u(*)
      INTEGER i, j, n
      LOGICAL skipbad

      skipbad = .FALSE.
	 
      IF ( Y(i).EQ.bad_y ) THEN
	 IF (i.GT.2) THEN
	    u(j) = x(i-1)
	       
	    IF ( j .gt. 1 .and. INT(u(j)) .LT. INT(u(j-1)) ) then
	       j = j - 1
	       DO WHILE (INT(u(j)) .LE. INT(u(j-1)) )
		     j = j - 1
	       ENDDO	  
	       u(j) = x(i-1)
	    ENDIF
            IF ( j .gt. 1 .and. INT(u(j)) .EQ. INT(u(j-1)) ) j = j - 1

            j = j + 1
	 ENDIF
         DO WHILE ( Y(i).EQ.bad_y .AND. i.LT.n)
            i = i + 1
         ENDDO
         
         IF (i.GT.1) u(j) = x(i-1)
         IF (i.GE.n) THEN
	    i = n
	    u(j) = x(n)
	 ENDIF
         IF ( j .gt. 1 .and. INT(u(j)) .EQ. INT(u(j-1)) ) j = j - 1

         j = j + 1
         u(j) = x(i)
         IF ( j .gt. 1 .and. INT(u(j)) .EQ. INT(u(j-1)) ) j = j - 1

         j = j + 1
         skipbad = .TRUE.
      ENDIF

      RETURN
      END


      subroutine merge(a,na,b,nb,c,nout)
c http://en.wikibooks.org/wiki/Algorithm_Implementation/Sorting/Merge_sort#Fortran
! Normal usage: NA+NB = NC
! B overlays C(NA+1:NC)

! modified to return nout instead of assuming treating NC, length of C as known.

      integer  NA,NB,NC         
      REAL  A(*), B(*), C(*)
 
      integer I,J,K
 
      I = 1
      J = 1
      K = 1
      do while(I .LE. NA .and. J .LE. NB)
         if (A(I) .LE. B(J)) then
            C(K) = A(I)
            I = I+1
         else
            C(K) = B(J)
            J = J+1
         endif
         K = K + 1
      enddo
      do while (I .LE. NA)
         C(K) = A(I)
         I = I + 1
          K = K + 1
      enddo
      do while (J .LE. NB)
         C(K) = B(J)
         J = J+1
         K = K + 1
      enddo

* remove duplicates

      j = 1
      do i = 2, k
         IF (c(i) .GT. c(i-1)) then
	    j = j + 1
	    c(j) = c(i)
	 endif
      enddo
      nout = j

      return
 
      end ! subroutine merge

	SUBROUTINE EXTRACT_Z_LINE( block, bad_flag, i, j, l, m, n,
     .		cxloz, cxhiz,
     .		slox, shix, sloy, shiy, sloz, shiz, 
     .		slot, shit, sloe, shie, slof, shif,
     .		zline, klo, khi )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Extract a single Z line of data from a memory variable grid.
* Identify contiguously valid data region and report in klo, khi
* Return values in buffer that always starts with the first valid value

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V450:  11/12/97
* V491:  16/4/98 - added cx_lo/hiz to limit extraction by context limits
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

* calling argument declarations:
	INTEGER slox, shix, sloy, shiy, sloz, shiz, slot, shit,
     .		sloe, shie, slof, shif, i, j, l, m, n, 
     .		klo, khi, cxloz, cxhiz
	REAL    bad_flag,
     .		block( slox:shix,sloy:shiy,sloz:shiz,slot:shit,sloe:shie,slof:shif ),
     .		zline(shiz-sloz+1)

* internal variable declarations:
	LOGICAL	searching_for_valid
	INTEGER k

* initialize
	searching_for_valid = .TRUE.

* initialize
	klo = 0		! if unchanged at end signals no valid data found
	khi = 0

* extract the line
	DO 100 k = cxloz, cxhiz

* ... skip invalid values at start of line
	   IF ( searching_for_valid ) THEN
	      searching_for_valid = block(i,j,k,l,m,n) .EQ. bad_flag
	      IF (searching_for_valid) GOTO 100
	      klo = k
* ... terminate if invalid point encountered after valid points
	   ELSEIF ( block(i,j,k,l,m,n) .EQ. bad_flag ) THEN
	      khi = k-1
	      GOTO 300
	   ENDIF

* ... transfer point to output
	   zline(k-klo+1) = block(i,j,k,l,m,n)

 100	CONTINUE
	khi = cxhiz

* successful completion
* reference returned limits to 1, so that klo=0 reliably signals no data
 300	klo = klo - cxloz + 1
	khi = khi - cxloz + 1
	RETURN
	END

      SUBROUTINE nobad (xin, yin, zin, badz, nscat, xscat, yscat, zscat)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*  Ansley Manke 5/99
*  Called by scat2gridlaplace* gridding functions.
*  If there is a missing value routine zgrid does not grid the data in 
*  a zone around that point, even if there are other nearby good data 
*  points.  Remove missing/bad data from the input (x,y,zscat) points.
*
* ACM 11/00 change so not exact comparison: wasnt catching all bad values.
*

      REAL xin(*), yin(*), zin(*), badz
      REAL xscat(*), yscat(*), zscat(*)
      INTEGER nscat, ngood, i
      REAL*8 badcompare
      REAL*8 eps
      PARAMETER ( eps = 4.0D-7 )

      ngood = 0
      badcompare = eps * abs(badz)
      IF ( badcompare < eps ) badcompare = eps

      DO 100 i = 1, nscat
         IF ( abs(zin(i) - badz) .GT. badcompare ) THEN
            ngood = ngood + 1
            xscat(ngood) = xin(i)
            yscat(ngood) = yin(i)
            zscat(ngood) = zin(i)
         ENDIF
  100 CONTINUE

      nscat = ngood

      RETURN
      END

	SUBROUTINE SAVE_FRAME( filename, format, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* make a movie or GIF frame of the current output graphics

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  11/14/89 - based on XEQ_FRAME
* V320: 5/94 - array "memory" as a calling argument
*	8/94 - filename added as calling argument
*	1/95 - major revamp using entirely X code instead of GKS (much faster)
*		and incorporating GIF output
*       9/97 - now supports batch mode
* V500: 4/99 *sh* increased filename string length from 128 to 255
* 1/03 *kob* g77 port - requires use of risc_buff for concats
*
* V6.2  *jli* 5/08 pass background color and transparent to put_frame_batch()
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V6.8 *acm* 7/9/2012 For batch graphics on RHEL6, change ITS_BATCH_GRAPHICS
*                     from logical to integer, then batch = ITS_BATCH_GRAPHICS().NE.0

        IMPLICIT NONE
* calling argument declarations:
	INTEGER		status
	CHARACTER*(*)	filename, format

* internal variable declarations:
	INTEGER		TM_LENSTR1, ITS_BATCH_GRAPHICS, 
     .			i, elen, flen, wsid, clen
        REAL            red, green, blue
	CHARACTER	errstr*128

	include 'errmsg.parm'
	include 'movies.parm'
	include 'tmap_dims.parm'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'
	include 'xrisc_buff.cmn'

        INTEGER slen
        PARAMETER  ( slen = 255 )

* declarations for C-calling machinery
#ifdef sun
        BYTE      fnmhol(slen), errhol(slen), fmthol(5),colorhol(slen) ! c Hollerith strings
#else
        INTEGER*1 fnmhol(slen), errhol(slen), fmthol(5),colorhol(slen) ! cHollerith strings
#endif

* translate to null-terminated c-type strings
        flen = TM_LENSTR1(filename)
        CALL TM_FTOC_STRNG( filename(:flen), fnmhol, slen )
        clen = TM_LENSTR1(transparent_color)
        CALL TM_FTOC_STRNG( transparent_color(:clen), colorhol, slen )
        CALL TM_FTOC_STRNG( format, fmthol, 5 )

* determine the current output window (GKS wkstn ID, that is)
	DO wsid = 1, max_windows
	   IF ( wn_active(wsid) ) GOTO 110
	end do

* blank out the error message return buffer (a C string)
 110	DO i = 1, slen
	   errhol(i) = 0	   
	end do

* if running in batch mode, take care of metafiles rather than
* dumping window
	if (ITS_BATCH_GRAPHICS().NE.0) then
           CALL GET_BACKGROUND_COLOR (red, green, blue)
           call put_frame_batch(wsid, fnmhol, fmthol, transparent, 
     .        red, green, blue, errhol, status)
	else
* capture the bitmap (C routine)
	   CALL PUT_FRAME( wsid, fnmhol, errhol, fmthol, status )
	end if

* illegal filename errors in status, bitmap capture errors in errstr
	IF ( status .LT. 0 ) THEN
	   GOTO 5200
	ELSEIF ( errhol(1) .NE. 0 ) THEN
	   CALL TM_CTOF_STRNG( errhol, errstr, slen )
	   elen = TM_LENSTR1(errstr)
	   GOTO 5300
	ENDIF

* successful completion
	status = ferr_ok
	RETURN

* error exit
 5000	RETURN
 5200	risc_buff = filename(:flen)
	CALL ERRMSG( ferr_erreq, status, 'Unable to open GIF file: '
     .		     //risc_buff, *5000 )
 5300	CALL ERRMSG( ferr_invalid_command, status,
     .               errstr(:elen), *5000 )

	END

	SUBROUTINE SPLIT_LIST( mode, out_lun, next_line, line_len )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* depending on the state of mode_gui either write this string to the
* out_lun unit number or send it to the GUI

* Note that line_len=0 means this routine will determine the line length

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V320:  11/9/94
*	 12/29/94 - added "mode" argument
* V400:	  6/20/95 - bug fix: LIST/FILE output sent to "default_list_lun"
*			should go to disk file, not to screen
* V6.6  *kms* 5/10 - monitor redirect_*_flags for stdout/stderr redirection.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include 'ferret.parm'
        include 'gui.parm'
	include 'xprog_state.cmn'
        include 'xgui.cmn'

* calling arguments
	INTEGER	      mode, out_lun, line_len
	CHARACTER*(*) next_line

*internal variable declarations:
        INTEGER slen
        PARAMETER  ( slen = 255 )
#ifdef sun
        BYTE      fhol(slen)	! c-type Hollerith string buffer
#else
        INTEGER*1 fhol(slen)	! c-type Hollerith string buffer
#endif
	INTEGER	TM_LENSTR1, llen

* determine line length if not supplied
	IF ( line_len .LE. 0 ) THEN
	   llen = TM_LENSTR1(next_line)
	ELSE
	   llen = line_len
	ENDIF

* output to the desired device
!	IF ( mode_gui ) THEN    ! 6/20 - kludge
	IF ( mode_gui .AND. out_lun.NE.default_list_lun ) THEN
	   CALL TM_FTOC_STRNG( next_line(:llen), fhol, slen )
	   CALL FERRET_LIST_IN_WINDOW( fhol, ftxout_append )
        ELSE IF ( (out_lun .EQ. ttout_lun) .AND.
     .            (redirect_stdout_flags .NE. redirect_none) ) THEN
           IF ( (redirect_stdout_flags .EQ. redirect_journal_tee) .OR.
     .          (redirect_stdout_flags .EQ. redirect_journal) ) THEN
              IF (mode_journal .AND. jrnl_lun.NE.unspecified_int4) THEN
                 WRITE ( jrnl_lun, '(A,A)' ) '!', next_line(:llen)
              ENDIF
           ENDIF
           IF ( (redirect_stdout_flags .EQ. redirect_file_tee) .OR.
     .          (redirect_stdout_flags .EQ. redirect_file) ) THEN
              WRITE ( redirect_stdout_lun, '(A)' ) next_line(:llen)
           ENDIF
           IF ( (redirect_stdout_flags .EQ. redirect_journal_tee) .OR.
     .          (redirect_stdout_flags .EQ. redirect_file_tee) ) THEN
              WRITE ( out_lun, '(A)' ) next_line(:llen)
           ENDIF
        ELSE IF ( (out_lun .EQ. err_lun) .AND.
     .            (redirect_stderr_flags .NE. redirect_none) ) THEN
           IF ( (redirect_stderr_flags .EQ. redirect_journal_tee) .OR.
     .          (redirect_stderr_flags .EQ. redirect_journal) ) THEN
              IF (mode_journal .AND. jrnl_lun.NE.unspecified_int4) THEN
                 WRITE ( jrnl_lun, '(A,A)' ) '!', next_line(:llen)
              ENDIF
           ENDIF
           IF ( (redirect_stderr_flags .EQ. redirect_file_tee) .OR.
     .          (redirect_stderr_flags .EQ. redirect_file) ) THEN
              WRITE ( redirect_stderr_lun, '(A)' ) next_line(:llen)
           ENDIF
           IF ( (redirect_stderr_flags .EQ. redirect_journal_tee) .OR.
     .          (redirect_stderr_flags .EQ. redirect_file_tee) ) THEN
              WRITE ( out_lun, '(A)' ) next_line(:llen)
           ENDIF
	ELSE
	   WRITE ( out_lun, '(A)' ) next_line(:llen)
	ENDIF

	RETURN
	END

      SUBROUTINE ADD_RDC_XFORM ( cx, status )

* add a hidden @RDC transform if appropriate

* programmer - jonathan callahan
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* version 5.0 - 10/20/98
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *kms* 4/13 change RETURN's in middle of idim loop to GOTO 100's

* The @RDC ("reduced") transform is an attempt to use Ferret's
* transform capabilities to create a result context which is 
* of different dimensionality than the argument contexts while
* passing result context information upstream to the arguments.
*
* Specifically, we are working with external functions where
* we would like to have the result be a flag indicating success.
* A simple example is the writev5d.F external function which
* writes a vis5D file for some arguments over a set region.
* Our result should be a one dimensional flag.  However, we 
* would still like to be able to use SET REGION to specify the 
* a region which should be applied to the arguments.  Normally,
* SET REGION only applies to the result context so that we
* currently, before this fix, have this behavior:
*
*	SET REGION/x180:160w/y=20s:20n/l=1
*
*	let a = writev5d(sst, airt)
*	list a                          ! Lists 180 X 90 X 12 values
* 
* The workaround is the ugly:
*
*   let a = writev5d(sst[x=180:160w,y=20s:20n,l=1], airt[...])
*
*
* The @RDC transform is applied internally in the grid 
* determination phase and is hidden from the user.  The 
* program structure is:
*
* interp_stack.F
*        |
*      grid
*  determination -- get_uvar_grid.F -- is_uvar_grid.F -- get_var_context.F
*      phase
*        |
*        |
*
*
* This subroutine needs to apply the @RDC transform whenever
* the result axis inherits from an argument axis but the
* result axis is reduced.
* This is really a sneaky way of saying that the argument context
* depends on the result context (ie SET REGION information).
*
* Places where changes where made to accomodate @RDC:
*
* ferret.parm         -- pgc_span_*, trans_reduced
* xgrid_chg_fcns.parm -- gfcn_reduction(4,pmax_grid_chg_fcns)
* interp_stack.parm   -- isact_reduce
* EF_Util.h           -- axis.reduction
* EF_InternalUtil.c   -- efcn_get_axis_reduction_(), EF_New()
* get_var_context.F   -- CALL ADD_RDC_XFORM()
* gcf_impose_axes.F
* interp_stack.F
*

      IMPLICIT NONE
      include 'tmap_dims.parm'
      include 'xdset_info.cmn_text'
      external xdset_info_data
      include 'ferret.parm'
      include 'xcontext.cmn'
      include 'xgrid_chg_fcns.cmn'
      include 'errmsg.parm'
      
      LOGICAL ITSA_GCVAR
      INTEGER WHICH_GCFCN

      LOGICAL valid_limits
      INTEGER cx, status, uvar, gcfcn, idim
      INTEGER axis_reduction(nferdims)
      
      valid_limits = .TRUE.

      IF ( cx_category(cx) .EQ. cat_user_var ) THEN

         uvar = cx_variable(cx)
         IF ( ITSA_GCVAR(uvar) ) THEN

            gcfcn = WHICH_GCFCN(uvar)

            IF ( gcfcn .GT. gfcn_num_internal ) THEN

               CALL EFCN_GET_AXIS_REDUCTION(gcfcn, axis_reduction)
               DO 100 idim = 1, nferdims

* Check that we have valid limits
                  IF ( cx_by_ss(idim,cx) ) THEN
                     IF ( cx_lo_ss(cx,idim) .EQ. unspecified_int4 
     .                 .OR. cx_hi_ss(cx,idim) .EQ. unspecified_int4 )
     .                 THEN
                          GOTO 100
                     ENDIF
                  ELSE
                     IF ( cx_lo_ww(idim,cx) .EQ. unspecified_val8 
     .                 .OR. cx_hi_ww(idim,cx) .EQ. unspecified_val8 )
     .                 THEN
                          GOTO 100
                     ENDIF
                  ENDIF

* Check that we have a valid grid or else FLESH_OUT_AXIS will fail
                  IF ( cx_grid(cx) .EQ. unspecified_int4 ) THEN
                     GOTO 100
                  ENDIF

                  IF ( axis_reduction(idim) 
     .                 .EQ. pgc_span_reduced ) THEN
                     cx_trans    ( idim, cx ) = trans_reduced
                     cx_trans_arg( idim, cx ) = bad_val4
                     CALL FLESH_OUT_AXIS(idim, cx, status)
                  ENDIF 

 100           CONTINUE

            ENDIF

*     Nothing to do YET for internal gc functions

         ENDIF

*     Nothing to do for non-gc functions
         
      ENDIF

*     Nothing to do for non-user variables
         
*     No way to return non-ok status yet.

      status = ferr_ok

      RETURN

* error exit

* 5100   CALL ERRMSG( ferr_syntax,status,'illegal name: '//buff3,*5000 )

      END
      

	SUBROUTINE TRANSFER_CONTEXT ( source, dest )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* transfer space/time/data_set/variable context from one context buffer to
* another

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 6/27/86
* revision 0.1 - 8/18/87 - added cx_trans_arg
* revision 1.0 - 9/23/87 - special logic for pre-defined contexts (dest<1)
* revision 1.1 - 3/4/88  - corrected .LT. --> .LE. on cx value
* revision 1.2 - 1/4/89  - added regridding transforms
* V200:  5/31/89 - 4D symmetrical (using TRANSFER_AXIS)
*		 - added cx_ovsiz, eliminated %%_relative
* V420: 9/95	- Support for implicit grids (cx_has_impl_grid)
* V530:  8/00 *sh* - transfer data type, too
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V685 3/13 *sh* support for aux var regridding: var[gz(depth)=zax]

	IMPLICIT NONE

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'

	INTEGER	source, dest, idim, i

* all contexts contain axis region information
	DO 100 idim = 1, nferdims
 100	CALL TRANSFER_AXIS( idim, source, dest )

* that's all that pre-defined contexts have
	IF ( source .LE. 0 .OR. dest .LE. 0 ) RETURN

	DO 200 idim = 1, nferdims
	   cx_delta   ( idim, dest ) = cx_delta   ( idim, source )
	   cx_regrid_trans(idim,dest)=cx_regrid_trans(idim,source)
 200	CONTINUE	

	cx_data_set( dest ) = cx_data_set( source )
	cx_dset_gvn( dest ) = cx_dset_gvn( source )
	cx_category( dest ) = cx_category( source )
	cx_variable( dest ) = cx_variable( source )
	cx_grid    ( dest ) = cx_grid    ( source )
	cx_type    ( dest ) = cx_type    ( source )
	cx_ovsiz   ( dest ) = cx_ovsiz   ( source )
	cx_bad_data( dest ) = cx_bad_data( source )

	cx_unstand_grid ( dest ) = cx_unstand_grid ( source )
	cx_impl_grid    ( dest ) = cx_impl_grid    ( source )

* do not inherit cx_has_impl_grid.  It is a flag to say which cx
* actually  **allocated** the grid
*	cx_has_impl_grid( dest ) = .FALSE.

* transfer aux var info
	cx_naux( dest ) = cx_naux( source )
	DO 300 i = 1, nferdims
	   cx_aux_arg_start(i, dest) = cx_aux_arg_start(i, source)
	   cx_aux_arg_end  (i, dest) = cx_aux_arg_end  (i, source)
	   cx_aux_stat     (i, dest) = cx_aux_stat     (i, source)
 300	CONTINUE


	RETURN
	END

	SUBROUTINE REGRID_LIMS( dst_cx, src_cx, axis, status, * )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* given a context describing data to be regridded to a destination grid
* - select one of the axes needing regridding
* - create, if necessary, an intermediate grid that differs from the
*	destination grid by only this single axis
* - compute the region on the source grid (possibly the newly created
*	intermediate grid) that will supply the re-griddable data
* When called the source context should be a copy of the destination context 

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 -  7/25/88
* revision 0.1 -   9/1/89 - corrected bug in destination world limits
*			  - added xy averaging
* revision 0.2 -   6/2/89 - modified grid limits calc. for modulo axes
* V200:  7/31/89 - 4D symmetrical version
*		 - fixed bug following GRID_SUBSCRIPT_EXTREMES for modulo axes
*	 11/3/89 - if destination limits are unknown flag error
*	 12/1/89 - handles XY averaging - (uses RQST_REGRID)
* V420: 10/95	 - Support for implicit axes: intermed. grids inherit
*		   responsibilities (use counts) for implicit axes
*	11/95	   check that destination axis is modulo for modulo regrid
*		   and take abnormal return if it dest region is
*		   modulo-wrapped
* V440: 9/96	 - Bug: failed to call TM_USE_LINE for dynamic line in
*		   intermediate grid (err430_deallo_dyn_line)
*		   Also corrected undetected bug: in intermediate grid for
*		   XY averaging need to deallo the y_dim not the "axis"
* V500 *kob* 3/99- up VAR_CODE  to 64 chars 
*      *sh*  5/99 - incorporate logic for netCDF strides. Allow for multi-axes
*		    use same framework to handle XY averaging
*	*sh* 4/00 - all grids and axes now maintain use counts and have
*			line_class available
* V533 *sh* 6/01 - allow strides and modulo to be combined
* V550 *sh*  2/02 - support for subspan modulo axes
* V552 *acm* 4/03- up VAR_CODE  to 128 chars 
* v554 *acm* 3/04 - When a strides request is made, and a grid had been defined
*                   for use in comparisons (define grid/like=var), the request 
*                   got turned into a regrid instead of a stride. Change the test
*                   for may_have_strides.
* V671  6/11 *acm*  New 2D linear xy regridding, fixing ticket 1862
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include 'implicit.parm'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'
	include	'xtext_info.cmn'

* calling argument declarations:
	INTEGER	src_cx, axis, dst_cx, status

* internal variable declarations:
	LOGICAL	ITSA_MODULO_REGRID, ITSA_MODULO_AXIS,  TM_ITS_CDF,
     .		xy_regrid, last_axis, may_have_strides, has_strides,
     .		unacceptable_modulo
	INTEGER	KNOWN_GRID, CAXIS_MODLEN, TM_AXIS_STRIDE, CX_DIM_LEN,
     .		idim, axis_list(nferdims), naxis, var_grid, src_grid, dst_grid,
     .		next_axis, dst_axis, var_axis, i, axlen, i1
	REAL	fraction
	CHARACTER VAR_CODE*128, dtype*4

* initialize
* this is a bit of a hack for implementing netCDF strides
* Under circumstances listed near bottom we may abort the intention to use
* strides In that case, we come back and do this routine over again.
* We save a copy of the src_cx in case of this eventuality
	CALL TRANSFER_CONTEXT(src_cx, cx_buff)

* insert source grid ( defining grid for this variable )
	dst_grid = cx_grid( dst_cx )
	var_grid = KNOWN_GRID( cx_data_set(src_cx),
     .			  cx_category(src_cx),
     .			  cx_variable(src_cx)	)

* initially select a single axis for regridding
	DO 10 axis = 1, nferdims
 10	IF (grid_line(axis,dst_grid).NE.grid_line(axis,var_grid)) GOTO 20
* ... signal calling routine that there's nothing to regrid
	cx_unstand_grid( dst_cx ) = .FALSE.
	status = ferr_ok
	RETURN

* special requirement for modulo regrid
 20	IF ( ITSA_MODULO_REGRID(dst_cx,axis) ) THEN
	   IF ( .NOT.ITSA_MODULO_AXIS(dst_cx,axis) ) GOTO 5100
* ... strip off the destination modulo wraps if any with abnormal return
* (so we compute just the base limits, 1-N, of the modulo axis)
	   IF ( cx_lo_ss(dst_cx,axis) .NE. unspecified_int4 ) THEN
	      IF (cx_hi_ss(dst_cx,axis ) .GT. CAXIS_MODLEN(axis,dst_cx)
     .       .OR. cx_lo_ss(dst_cx,axis ) .LT. 1 ) RETURN 1
	   ENDIF
	ENDIF

* (5/99) should more than one axis be regridded at once?
* yes if XY average regridding
* yes if multiple axis strides in a netCDF file
* for stride axes, we cannot have modulo and cannot have other
* types of regridding needed also

* If the regrid is of the form netCDFvar[i=lo:hi:del] then it is
* currently represented as a regrid to a dynamic axis. Since the netCDF
* library can do strides, we will allow it to as long as a variety
* of conditions are met. The "flag" that will trigger strides in the netCDF
* IO is the presence of a cx_delta value (see rqst_regrid.F and read_tm.F)
* Note that modulo regrids cannot be handled with strides: suppose X axis
* is 1:360 degrees by one degree, then V[I=1:720:7] will select different
* points in the 1:360 range than in the 361:720 range.
	may_have_strides =  cx_category(dst_cx) .EQ. cat_file_var

	IF (may_have_strides) THEN
!	   may_have_strides = TM_ITS_CDF(cx_data_set(dst_cx), dtype )
!     .                  .AND. cx_has_impl_grid(dst_cx) 

	   may_have_strides = TM_ITS_CDF(cx_data_set(dst_cx), dtype )

	ENDIF
 50	naxis = 1
	axis_list(1) = axis	
	has_strides = .FALSE.
	xy_regrid = (cx_regrid_trans(axis,src_cx) .EQ. prgrd_xy_ave).OR. 
     .           (cx_regrid_trans(axis,src_cx) .EQ. prgrd_xy_lin)
	IF ( xy_regrid)   THEN
	   naxis = 2
	   axis_list(2) = y_dim
	ELSEIF ( may_have_strides ) THEN
	  DO 100 idim = axis, nferdims
	    dst_axis = grid_line(idim,dst_grid)
	    var_axis = grid_line(idim,var_grid)
	    IF (dst_axis.EQ.var_axis) GOTO 100
	    IF (cx_regrid_trans(idim,dst_cx).EQ.prgrd_xact_pts
     .     .OR. cx_regrid_trans(idim,dst_cx).EQ.prgrd_exact) THEN
	      IF ( line_class(dst_axis) .EQ. pline_class_stride ) THEN
	        IF (idim .NE. axis) naxis = naxis + 1
	        axis_list(naxis) = idim
	      ELSE
	        GOTO 110	! abort
	      ENDIF
	    ELSE
	      GOTO 110		! abort
	    ENDIF
 100	  CONTINUE
	  has_strides = .TRUE.  ! all axes meet the conditions
 110	  IF (.NOT.has_strides) naxis = 1
	ENDIF

* will there be more axes to regrid after this/these?
	next_axis = axis_list(naxis) + 1
	last_axis = .TRUE.
	DO 200 idim = next_axis, nferdims
 200	IF ( grid_line(idim,dst_grid) .NE. grid_line(idim,var_grid) )
     .							last_axis = .FALSE.
	IF (.NOT.last_axis) has_strides = .FALSE.  ! (can never happen)

* if its the last axis then the source data will be on its defining grid
	IF ( last_axis ) THEN
	   src_grid = var_grid
	   cx_unstand_grid( src_cx ) = .FALSE.
	   is_phase( isp )   = prgrd_from_source
	ELSE		
* we need an intermediate grid
	   cx_unstand_grid( src_cx ) = .TRUE.
	   CALL ALLO_GRID( src_grid,status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   CALL TM_COPY_GRID_W_LINE_USE( dst_grid, src_grid ) 
	   grid_name( src_grid ) = ww_dim_name(axis)//'NTERMED'	! for diag out
	   CALL TM_DEALLO_DYN_LINE(grid_line(axis,src_grid))
	   grid_line( axis, src_grid ) = grid_line( axis, var_grid )
	   CALL TM_USE_LINE(grid_line(axis,var_grid)) ! 9/96
	   IF (xy_regrid) THEN
! 9/96: changed DEALLO grid_line(axis,src_grid) to grid_line(y_dim,src_grid)
	      CALL TM_DEALLO_DYN_LINE(grid_line(y_dim,src_grid))
	      grid_line(y_dim,src_grid) = grid_line(y_dim,var_grid)
	      CALL TM_USE_LINE(grid_line(y_dim,var_grid)) !9/96
	   ENDIF
	   is_phase( isp ) = prgrd_from_ntrmed
	ENDIF
	cx_grid( src_cx ) = src_grid

* get limits to request
	DO 300 idim = 1, naxis
	   CALL RQST_REGRID( dst_cx, src_cx, axis_list(idim),
     .			     has_strides, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
 300	CONTINUE

* if doing strides then we may decide to abort
* 1) if it turns out to be a modulo stride operation (e.g. I=1:720:11 on
*    a 360 point modulo longitude axis. Note that we could have checked for
*    this above, but since RQST_REGRID does all the work, we waited
* 2) if the complete source data is already in cache don't reread w/ strides
	IF (has_strides) THEN
	   unacceptable_modulo = .FALSE.
	   DO 400 i = 1, naxis
	      idim = axis_list(i)
	      axlen = CAXIS_MODLEN(idim, src_cx)
	      IF (CX_DIM_LEN(idim,src_cx) .GT. axlen) THEN
*     ...  for multi-cycle modulo stride must be an integer factor of ax length
	         fraction = FLOAT(axlen) /
     .			    TM_AXIS_STRIDE(grid_line(idim,dst_grid), i1)
	         unacceptable_modulo = unacceptable_modulo
     .				 .OR.  fraction .NE. INT(fraction)
	      ENDIF
 400	   CONTINUE
! THE COMMENTED OUT CODE BELOW CAN BE USED TO TURN ON LOGIC THAT WILL REUSE
! CACHED (NON_STRIDES) DATA RATHER THAN REREADING USING STRIDES. IT IS
! COMMENTED OUT AS NOT ENTIRELY DESIRABLE: 1) IT CREATES MULTIPLE CODE PATHS
! FOR THE SAME OPERATION; 2) IT CAN CAUSE UNACCEPTABLE MEMORY USAGE AS THE
! NON-STRIDED BASE REGION GETS MODULO-REPLICATED BEFORE SUBSAMPLING
* ... if full source region is already in memory without strides then
*     do striding from it in memory -- no new IO needed (optimization)
!	   CALL FIND_MEM_VAR( src_cx, mr, search_by_value )
!           IF ( unacceptable_modulo .OR. mr.GT.mr_nonexist ) THEN
           IF ( unacceptable_modulo ) THEN
	      may_have_strides = .FALSE.
	      CALL TRANSFER_CONTEXT( cx_buff, src_cx)
	       IF (mode_diagnostic) THEN
	        CALL WARN('Not using NetCDF strides for multi-cycle modulo')
	        CALL WARN('Stride value not a factor of axis length')  
	       ENDIF
	      GOTO 50			! re-do w/out strides
	   ENDIF
	ENDIF

* success
        status = ferr_ok
	RETURN

* error exit
 5000	RETURN
 5100	CALL ERRMSG( ferr_regrid, status,
     .          '@MOD regridding to a non-modulo axis: '
     .          //VAR_CODE(cx_category(dst_cx),cx_variable(dst_cx)),
     .		*5000)

	END

	SUBROUTINE CONSTANT_CONTEXT
     .		      ( const_text, 
     .			default_cx,
     .			const_cx,
     .			status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* return in const_cx context information describing the constant

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/28/87
* revision 0.1 - 5/5/88  - FINISH_CONTEXT_MODS --> FLESH_OUT_CONTEXT
* V200:  6/20/89 - re-worked user defined variable logic 
* V300: ifdef to work around "*" bug in READ (buff,*) in DEC f77 3.2.2
* V420 (IBM/AIX port of V411): 10/5/95 - buffer "READ(var,*"
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V751  *acm* 6/19 read directly from const_text instead of putting that
*                  text into a smaller buffer. See issue 1929 allowing
*                  e.g for `00000000000000000012345678901234567890`

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include	'xalgebra.cmn'

* calling argument declarations:
	INTEGER		default_cx, const_cx, status
	CHARACTER*(*)	const_text

* internal variable declarations:
	INTEGER		idim
	REAL		const_buff

* equivalences
	REAL		cx_value( max_cx )
	EQUIVALENCE   ( cx_variable, cx_value )

* initialize
	CALL TRANSFER_CONTEXT ( default_cx, const_cx )
	cx_category( const_cx ) = cat_constant
	cx_bad_data( const_cx ) = bad_val4
	cx_data_set( const_cx ) = pdset_irrelevant
	cx_dset_gvn( const_cx ) = .TRUE.
	cx_type    ( const_cx ) = ptype_float

* get the value of the constant
* bug is that if a "*" follows the numeric text the error branch is taken
	READ ( const_text, *, ERR=5100 ) const_buff
	cx_value( const_cx ) = const_buff

* flesh out context by removing all axes limits
	DO 200 idim = 1, nferdims
 200	CALL DEL_CX_DIM( idim, const_cx )

	RETURN

* error exit
 5000	RETURN
 5100	CALL ERRMSG( ferr_syntax, status, const_text, *5000 )
	END

	SUBROUTINE EQUAL_PERMUTE(string,fill,v_ok,neg_ok,perm,status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* from a string of the form "perm=XYZTEF", return array perm with the ordering
* expressed as integers

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:   9/1/89
* V230: 4/92 (SUN port) - bug fix on loop: "fill in any missing dimensions"
*
* 7/15/98 *js* Added support for "XYZTV" permutations. 
*    5/99 *sh* Added booleans "fill" argument to control if permutation array
*	       is filled, var_ok arg to determine if "V" is allowable, and
*	       neg_ok for acceptable minus signs
* 2/03 *kob* - g77 port - g77 won't allow intrinsic functions in PARAMETER
*                         statements.  use an octal constant instead
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V693+ *sh* 2/15 - added support for _DQ_ quotations

      IMPLICIT NONE

* includes
      include 'tmap_dims.parm'

* calling argument declarations
	LOGICAL		fill, v_ok, neg_ok
	INTEGER		perm(*), status
	CHARACTER*(*)	string

* internal variable declarations
	INTEGER	TM_LENSTR1, STR_UPCASE, equal_pos, slen, pos, vax_code,
     .		idim, ndim, i, j, rev, pmax
	CHARACTER*1	ax

* internal parameter declarations:
	CHARACTER*1	tab



	PARAMETER     ( tab = CHAR(9))


	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xtext_info.cmn'

* initialize
	slen	  = TM_LENSTR1( string )
	equal_pos = INDEX( string, '=' )
	IF ( equal_pos .EQ. 0 .OR. equal_pos .EQ. slen ) GOTO 5100
	IF (v_ok) THEN
	   pmax = nferdims+1
	ELSE
	   pmax = nferdims
	ENDIF

* skip blanks and tabs
	DO  pos = equal_pos+1, slen
	   IF ( string(pos:pos) .NE. ' '
     .	  .AND. string(pos:pos) .NE. tab ) GOTO 100
	END DO
	GOTO 5100

* remove quotation marks
 100	   IF ( string(pos :pos  ) .EQ. '"'
     .	  .AND. string(slen:slen ) .EQ. '"' ) THEN
	      pos  = pos  + 1
	      slen = slen - 1
	   ELSEIF (string(pos :pos ) .EQ. '_'
     .	     .AND. string(slen:slen) .EQ. '_' 
     .	     .AND. slen-pos.GE.8            ) THEN
	      IF (string(pos:pos+3)   .EQ. '_DQ_'
     .	    .AND. string(slen-3:slen) .EQ. '_DQ_' ) THEN
	         pos  = pos  + 4
	         slen = slen - 4
	      ENDIF
	   ENDIF

* decode permutation string
	ndim = 0
	rev = 1	 ! reversed axis ?
	DO 250 pos = pos, slen
	   vax_code = STR_UPCASE( ax, string(pos:pos) )
	   IF ( v_ok .AND. ax .EQ. 'V') THEN   ! Variable name permutation
	      ndim = ndim + 1
	      perm(ndim) = nferdims+1
	   ELSEIF ( neg_ok .AND. ax .EQ. '-' ) THEN
	      rev = -1
	   ELSE
	      DO 220 idim = 1, nferdims
	         IF ( ax .EQ. ss_dim_name(idim)
     .	         .OR. ax .EQ. ww_dim_name(idim) ) THEN
	            IF (ndim .EQ. pmax) GOTO 5100
*   ... check for duplicates
	            DO 210 i = 1, ndim
 210		    IF ( idim .EQ. ABS(perm(i)) ) GOTO 5100
*  ... save the axis
	            ndim = ndim + 1
	            perm(ndim) = idim * rev
	            rev = 1
	            GOTO 250
	         ENDIF
 220	      CONTINUE
	      GOTO 5100
	   ENDIF
 250	CONTINUE

* fill in any missing dimensions (e.g. "perm=YX" is interpreted as YXZT)
	IF (fill) THEN
	  DO 350 j = ndim+1, nferdims+1
	     DO 320 idim = 1, nferdims+1
	        DO 310 i = 1, j-1   ! slots already set (4/92 bug fix)
 310	        IF ( idim .EQ. ABS(perm(i)) ) GOTO 320
	        perm(j) = idim
	        GOTO 350
 320	     CONTINUE
 350	  CONTINUE
	ENDIF

* success
	status = ferr_ok
	RETURN

* syntax error
 5000	RETURN
 5100	CALL ERRMSG( ferr_syntax, status, string, *5000 )
	END

	INTEGER FUNCTION FIELD_WIDTH( val, grid, idim, ndec, numbers )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine the width of field needed to write out value "val" in a formatting
* style appropriate to axis "idim" of grid "grid" with ndec decimal points
* also return the number of characters needed exclusive of the extra formatting
* ("numbers")

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 3/18/88
* 10/2/95 - bug fix:  date string was using ndec instead of ABS(dec) for
*			determining field width
* V600  1/06 *acm*  prevent values of LOG10(0.0) 
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction. 

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xprog_state.cmn'
	include 'xtext_info.cmn'

* calling argument declarations
	INTEGER	grid, idim, ndec, numbers
	REAL*8	val

* internal variable declarations:
	LOGICAL	GEOG_LABEL, fancy
	INTEGER	decim, left
	REAL	fval

* initialize
	fancy = GEOG_LABEL( idim, grid )	! special axis formatting
	decim = ABS( ndec )
	IF ( decim .GT. 0 ) decim = decim + 1	! allow room for decimal pt.
	fval = val

* get actual numerical value to format if different from given
	IF ( fancy ) THEN
	   IF (idim.EQ.t_dim .OR. idim.EQ.f_dim) THEN
	      FIELD_WIDTH = date_str_len( MAX( 1, MIN(6,ABS(ndec)) ) )	! 10/95
	      RETURN
	   ELSEIF ( idim .EQ. x_dim .AND. fval .GT. 180.0 ) THEN
	      fval = 360. - val
	   ELSEIF ( idim .EQ. y_dim .AND. fval .LT. 0.0   ) THEN	
	      fval = -fval
	   ENDIF
	ENDIF

* digits to left of decimal
	IF ( ABS(fval) .LT. 10.0 ) THEN
	   left = 1
	ELSE
	   left = LOG10( ABS(fval) ) + 1
           IF (fval .EQ. 0) left = 1
	ENDIF
	IF ( fval .LT. 0.0 ) left = left + 1	! minus sign

* numeric field width
	numbers = left + decim

* total field width
	IF ( fancy ) THEN
	   IF ( idim .EQ. x_dim .AND. fval .EQ. 180.0
     .	       .OR. idim .EQ. y_dim .AND. fval .EQ. 0.0	  ) THEN
	      FIELD_WIDTH = numbers
	   ELSE
	      FIELD_WIDTH = numbers + 1	! "E","N", etc. 
	   ENDIF

	ELSE
	   FIELD_WIDTH = numbers

	ENDIF

	RETURN
	END

	SUBROUTINE TM_GET_LIKE_DYN_GRID ( ingrid, its_dyn, outgrid,
     .					  static_lim,  status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Will compare "ingrid" to other grid definitions in common. Unlike
* tm_get_like_grid this will check both static and dynamic grids.
* If there is a match then "outgrid" returns with the number of the match.
* The variable its_dyn tells if it is dynamic
* If there is no match, then a new dynamic grid is created.
* "outgrid" returns with the number of the new dynamic grid and its_dyn
* is .TRUE..

* created 9/95 *sh*
* 	 11/95 added argument static_lim - kludge because the TMAP library
*	       routines do not know that the upper portion of the grid
*	       COMMON is used as scratch space by Ferret when determining
*	       grids for variables.  This argument prevents accidental
*	       matches against those scratch grids

* V511: 5/00 *sh* even static grids get "used" now
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* Arguments
	LOGICAL		its_dyn
	INTEGER		ingrid, outgrid, static_lim, status
*
* INCLUDE FILES
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'tmap_errors.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
*
* Local definitions
	INTEGER		TM_FIND_LIKE_GRID, TM_FIND_LIKE_DYN_GRID

* initialize
	its_dyn = .TRUE.

* does it exist already among the existing, static grids?
	outgrid = TM_FIND_LIKE_GRID(ingrid)
	IF (outgrid .NE. unspecified_int4
     ..AND. outgrid .LT. static_lim       ) THEN
* ... yes - it matches an explicit grid
	   its_dyn = .FALSE.
	   CALL TM_USE_DYN_GRID( outgrid )	! added 5/00
	ELSE

* does it exist already among the existing, dynamic grids?
	   outgrid =  TM_FIND_LIKE_DYN_GRID( ingrid )
	   IF (outgrid .NE. unspecified_int4) THEN
* ... yes - it matches an existing dynamic grid - inc its use count
	      CALL TM_USE_DYN_GRID( outgrid )
	   ELSE

* it shall be a new dynamic grid  "(Gnnn)"
	      CALL TM_ALLO_DYN_GRID( outgrid, status )
	      IF (status .NE. merr_ok) GOTO 9000
	      CALL TM_COPY_GRID_W_LINE_USE( ingrid, outgrid )

* name it "(Gnnn)"
	      WRITE ( grid_name(outgrid), 3000 ) outgrid - max_grids
 3000	      FORMAT('(G',I3.3,')')		! restricted to 3 digits

	   ENDIF
	ENDIF

* successful completion
	status = merr_ok
 9000	RETURN
	END

      SUBROUTINE REDEFINE_AX_ATT (name, new_units, new_t0,  
     .       new_cal_name, new_modulo, new_modulo_len, 
     .       direction, regular_flag )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*  Change attributes for a redefined axis

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP
* 11/2006 
* V602  3/07 *acm* Also look for the axis in dataset -2, the pseudo-dataset 
*                  containing information on user-defined axes
* V602  3/07 *acm* Treat t0 as units; if new t0 is not defined, remove the attribute.
* v604 *acm* 7/07 increase length of ds_name
* v616 *acm* 1/09 Fix ticket 1614: Needed to set the attname to modulo for the block,
*                 if new_modulo is false then remove attribute from axis
* V64  *acm*11/09 The ENDIF for name-is-an-axis-of-dset was in the wrong place:
*                 check for changes in all the attribs.
* V698  3/16 *acm* Remove unneeded xdset_parms.cmn
* V720 *acm* 5/17 Implement specific calls in place of CD_GET_VAR_INFO

        IMPLICIT NONE
	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'tmap_errors.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'ferret.parm'
	include 'errmsg.parm'
        include 'xcontext.cmn'
	include 'xprog_state.cmn'
	include 'xvariables.cmn'
	include 'xrisc.cmn'
        include 'netcdf.inc'

* calling argument declarations:

      CHARACTER*(*) name, direction, new_units, new_t0, 
     .              new_cal_name
      REAL*8 new_modulo_len
      LOGICAL regular_flag, new_modulo

* local variable declarations: 
      
      INTEGER TM_LENSTR1, STR_SAME, 
     .        dset, varid, attlen, attype, attoutflag, 
     .        attid, len, maxlen, status
      REAL dummy
      CHARACTER buff*128, varname*128, attbuff*10, attname*128, dir*4
      LOGICAL	CD_ISIT_COORDVAR, do_warn, got_it

      dummy = 0.
      do_warn = .FALSE.
      maxlen = 128

c... loop over datasets
c    Dataset pdset_coordvars (value -2) is the pseudo-dataset containing 
c    user-defined axes. See if name exists as an axis name.

      DO 100 dset = pdset_coordvars, maxdsets
         IF (dset .EQ. pdset_uvars) GOTO 100
         IF (dset .EQ. pdset_irrelevant) GOTO 100

         IF (dset .GT. 0) THEN
            IF ( ds_name(dset) .EQ. char_init2048) GOTO 100
         ENDIF

         CALL CD_GET_VAR_ID (dset, name, varid, status)

         IF (status .EQ. ferr_ok) THEN  ! name is an axis name in the dataset

! name is a variable; is it a coordinate variable of the dataset?
 
            IF (.NOT. CD_ISIT_COORDVAR (dset, varid, name, status)) goto 100

c ... If units attribute already exists, change it; otherwise add new
c     If new units not defined, remove units attribute.

         attname = 'units'
         IF (new_units .NE. " ") THEN
            len = TM_LENSTR1(new_units)
            CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)

            IF (status .NE. ferr_ok) THEN
               attoutflag = 1
               CALL CD_PUT_NEW_ATTR (dset, varid, attname, NCCHAR, len,
     .         attoutflag, new_units, dummy, status)
            ELSE
               CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, attname, attype,
     .           attlen, attoutflag, status)
               CALL CD_REPLACE_ATTR (dset, varid, 
     .           attname, NCCHAR, len, new_units, dummy, status)
            ENDIF

        ELSE
           
            CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)
            IF (status .EQ. ferr_ok) CALL CD_DELETE_ATTRIBUTE (dset, varid, 
     .          attname, status)

        ENDIF

c ... If t0 attribute already exists, change it; otherwise add new
c     If new t0 not defined, remove the time_origin attribute.

         attname = 'time_origin'
         IF (new_t0 .NE. " ") THEN

            len = TM_LENSTR1(new_t0)
            CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)

            IF (status .NE. ferr_ok) THEN
               attoutflag = 1
               CALL CD_PUT_NEW_ATTR (dset, varid, attname, NCCHAR, len,
     .           attoutflag, new_t0, dummy, status)
            ELSE
               CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, attname, attype,
     .           attlen, attoutflag, status)
               CALL CD_REPLACE_ATTR (dset, varid, 
     .           attname, attype, len, new_t0, dummy, status)
            ENDIF

        ELSE
           
            CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)
            IF (status .EQ. ferr_ok) CALL CD_DELETE_ATTRIBUTE (dset, varid, 
     .          attname, status)

        ENDIF

c ... direction; Change positive=up or down on Z axes; replace cartesian_axis 
c     or axis attribute only if already an attribute

         attname = 'positive'

         CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)

         IF (status .EQ. ferr_ok) THEN
            CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, attname,
     .        attype, attlen, attoutflag, status)

            IF (direction .EQ. 'DU') THEN
               dir = 'up'
               len = 2
            ELSE
               dir = 'down'
               len = 4
            ENDIF
            CALL CD_REPLACE_ATTR (dset, varid, attname, attype, 
     .        len, dir, dummy, status)
         ENDIF

         attname = 'cartesian_axis'
         len = 1

         dir = ' '
         IF (direction(1:1) .EQ. 'T') dir = 'T' 
         IF (direction .EQ. 'WE' .OR. 
     .    direction(1:1) .EQ. 'X') dir = 'X'
         IF (direction .EQ. 'SN' .OR. 
     .    direction(1:1) .EQ. 'Y') dir = 'Y'
         IF (direction .EQ. 'UD' .OR. 
     .    direction .EQ. 'DU' .OR.  
     .    direction(1:1) .EQ. 'Z') dir = 'Z'
         
         IF (dir .NE. ' ') THEN
            CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)

            IF (status .EQ. ferr_ok) THEN
               CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, attname,
     .            attype, attlen, attoutflag, status)
               CALL CD_REPLACE_ATTR (dset, varid, 
     .            attname, attype, len, dir, dummy, status)
            ENDIF

            attname = 'axis'

            CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)

            IF (status .EQ. ferr_ok) THEN
               CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, attname, attype,
     .           attlen, attoutflag, status)
               CALL CD_REPLACE_ATTR (dset, varid, 
     .           attname, attype, len, dir, dummy, status)
            ENDIF
         ENDIF

c ... If calendar attribute already existed, change it; otherwise add new
c     If new calendar not defined, remove calendar attribute.

         attname = 'calendar'
         IF (new_cal_name .NE. " ") THEN
            attoutflag = 1
            IF ( (STR_SAME(new_cal_name(1:3), 'GRE') .EQ. 0) .OR.
     .           (STR_SAME(new_cal_name(1:3), 'STA') .EQ. 0) ) attoutflag = 0

            len = TM_LENSTR1(new_cal_name)
            CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)

            IF (status .NE. ferr_ok) THEN
               CALL CD_PUT_NEW_ATTR (dset, varid, attname, NCCHAR, len,
     .           attoutflag, new_cal_name, dummy, status)
            ELSE
               CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, attname, attype,
     .           attlen, attoutflag, status)
               CALL CD_REPLACE_ATTR (dset, varid, 
     .           attname, attype, len, new_cal_name, dummy, status)
            ENDIF

        ELSE
           
            CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)
            IF (status .EQ. ferr_ok) CALL CD_DELETE_ATTRIBUTE (dset, varid, 
     .          attname, status)

         ENDIF

c ... point_spacing; change only if it was already an attribute

         attname = 'point_spacing'
         attbuff = 'uneven'
         IF (regular_flag) attbuff = 'even'
         len = TM_LENSTR1(attbuff)

         CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)

         IF (status .EQ. ferr_ok) THEN
            CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, attname, attype,
     .        attlen, attoutflag, status)
            CALL CD_REPLACE_ATTR (dset, varid, 
     .        attname, attype, len, attbuff, dummy, status)
         ENDIF

c ... modulo; either write modulo = ' ' for modulo=true,
c     or write modulo length.

         IF (new_modulo) THEN
            attname = 'modulo'

            IF (new_modulo .OR. (new_modulo_len .GT. 0.D0)) THEN
               attbuff = ' '
               len = 1
               CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)

               IF (new_modulo_len .GT. 0) THEN  ! write the value of new_modulo_len
                  IF (status .NE. ferr_ok) THEN
                     attoutflag = 1
                     CALL CD_PUT_NEW_ATTR_DP (dset, varid, attname, NCDOUBLE, len,
     .               attoutflag, attbuff, new_modulo_len, status)
                  ELSE
                     CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, attname, attype,
     .               attlen, attoutflag, status)
                     CALL CD_REPLACE_ATTR_DP (dset, varid, 
     .               attname, attype, len, attbuff, new_modulo_len, status)
                  ENDIF

               ELSE  ! write string attribute modulo=' '
                  IF (status .NE. ferr_ok) THEN
                     attoutflag = 1
                     CALL CD_PUT_NEW_ATTR_DP (dset, varid, attname, NCCHAR, len,
     .               attoutflag, attbuff, new_modulo_len, status)
                  ELSE
                     CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, attname, attype,
     .               attlen, attoutflag, status)
                     CALL CD_REPLACE_ATTR (dset, varid, 
     .               attname, NCCHAR, len, attbuff, dummy, status)
                  ENDIF
               ENDIF

            ENDIF
         ELSE  ! if new_modulo is false then remove attribute from axis
            
	    attname = "modulo"
            CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)

            IF (status .EQ. ferr_ok) THEN
               CALL CD_DELETE_ATTRIBUTE (dset, varid, attname, status)
            ENDIF
         ENDIF

        ENDIF  ! name is an axis name in the dataset

  100 CONTINUE   
      
      status = ferr_ok

      RETURN
      END

	SUBROUTINE DEPEND_STAT_VAR( work, string )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* get a string describing the variable that was the source of the dependency tree
* status flag

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V685+  *sh* 9/13 

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xdependency_tree.cmn'

* calling argument declarations:
	INTEGER	work(dependency_max_recs, dependency_nfields)
	CHARACTER(*) string

	CALL DEPEND_STAT_VAR_SUB( string,
     .			work(1,1), work(1,2), work(1,3), work(1,4), 
     .			work(1,5), work(1,6), work(1,7), work(1,8) )


	RETURN
	END

	SUBROUTINE DELETE_USER_VAR ( uvar, iset )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* delete a user-defined variable 
* First locate each of its children and delete them

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V450 7/97 - guts of routine moved to DELETE_USER_VAR_SUB
* V510 *sh* 1/00 - bug fixes to support nested GC variables
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V698  2/16 *acm* For ticket 2352: variables defined with LET/D are
*                  added to that dataset in the attribute structure. Extra
*                  argument to DELETE_USER_VAR
* V699 6/16 *sh* quick exit if already deleted

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xvariables.cmn'

* calling argument declarations:
	INTEGER	uvar, iset

* internal variable declarations:
	INTEGER	i, uv, uvar_ancestor, num_indices, 
     .          result_array(max_uvar), dset

* fall-back check to forgive sloppy bookkeeping elsewhere
* as of 6/16 uvar grids are stored in LIST structures and a double deletion
* can corrupt them
	IF (uvar_num_items(uvar) .EQ. uvar_deleted) RETURN

* delete child vars
*	DO 200 uv = 1, max_uvar
*	   IF ( uvar_num_items( uv ) .EQ. uvar_deleted ) GOTO 200
        CALL deleted_list_get_undel(uvar_num_items_head, 
     .                          result_array(1),
     .                          max_uvar, num_indices )
         DO 200 i =1, num_indices
           uv = result_array(i)
* ... delete if this variable is a child of uvar 
*	uvar_name_code for child vars is "(Cnnn,Vmmm)" -- the "mmm" is the ancestor
	   IF (uvar_name_code(uv)(1:2) .NE. '(C' ) GOTO 200
	   READ (uvar_name_code(uv)(8:10),'(I3)',ERR=200) uvar_ancestor
	   dset = pdset_uvars
	   IF (uvar_ancestor.EQ.uvar) CALL DELETE_USER_VAR_SUB(uv, dset)
 200	CONTINUE

* now delete the variable itself
	dset = iset
	IF (dset.EQ.unspecified_int4 .OR. 
     .      dset.EQ.pdset_irrelevant) dset = pdset_uvars
        CALL DELETE_USER_VAR_SUB(uvar, dset)
	      
	RETURN
	END

	SUBROUTINE TM_allo_tmp_line( line, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* Allocate a temporary line from the dynamic line area (above max_lines)

* Steve Hankin  NOAA/PMEL/TMAP

* V510 *sh* 3/00 - guts of routine in  TM_ALLO_DYN_LINE_SUB
* V581*acm*  6/05 For fix to bug 1271, add flag line_shift_origin
* v694 1/15 *acm* (see ticket 2227) handle the line_dim_only flag

* Include files
	include 'tmap_dims.parm'
	include 'implicit.parm'
	include 'tmap_errors.parm'
#include "tmap_dset.parm"
	include 'xtm_grid.cmn_text'

* Argument definitions
	INTEGER line, status

	CALL TM_ALLO_DYN_LINE_SUB( tmp_line_hook, line, status )
	IF ( status .NE. merr_ok) RETURN

* initialize the line to a null content
	line_name(line)	     = char_init16
        line_t0(line)        = char_init20
        line_shift_origin(line) = .FALSE.
        line_tunit(line)     = real4_init
        line_parent(line)    = 0
        line_regular(line)   = .TRUE.
        line_class(line)     =  pline_class_basic
        line_direction(line) = 'NA'
        line_modulo(line)    = .FALSE.
        line_units(line)     = char_init16
	line_unit_code(line) = int4_init
        line_start(line)     = real8_init
        line_delta(line)     = real8_init
        line_dim(line)       = int4_init

	line_subsc1(line)    = int4_init
	line_dim_only(line)  = .FALSE.

	RETURN
	END

*
* efstrings.F
*
*
* Returns A testing additional string capabilities
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, efstrings )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )


      SUBROUTINE efstrings_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,'Demo Function: tests string utilities' )

      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_result_type(id, STRING_RETURN)

      CALL ef_set_num_work_arrays(id, 1)

      arg = 1
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)
      CALL ef_set_arg_type (id, arg, STRING_ARG)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE efstrings_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work array X/Y/Z/T dimensions
*
* ef_set_work_array_dims(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER iarg, ns
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      iarg = 1
      ns = arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1) + 1

      CALL ef_set_work_array_dims(id, iarg, 1,1,1,1, 1,1,1,2*ns)

      iarg = 2
      CALL ef_set_work_array_dims(id, iarg, 1,1,1,1, 1,1,1,20*ns)


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END



* In this subroutine we compute the result
*
      SUBROUTINE efstrings_compute(id, arg_1, result, tax)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* Single precision Ferret: string arg and result need to be twice the length.
      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(strdf,mem1lox:mem1hix, mem1loy:mem1hiy, 
     .     mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL result(strdf,memreslox:memreshix, memresloy:memreshiy, 
     .     memresloz:memreshiz, memreslot:memreshit)
      REAL*8 tax(wrk1lox:wrk1hix, wrk1loy:wrk1hiy,
     .               wrk1loz:wrk1hiz, wrk1lot:wrk1hit/2)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l
      INTEGER i1, j1, k1, l1
      INTEGER rtype, iarg, slen, prec
      CHARACTER*32 textstring, datestring
      CHARACTER*3 short

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_result_type(id, rtype)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      CALL ef_get_coordinates (id, ARG1, T_AXIS, 
     .       arg_lo_ss(T_AXIS, ARG1), arg_hi_ss(T_AXIS, ARG1), tax)

*     'dd-mon-yyyy hh:mm:ss' date format
      prec = 6

      i1 = arg_lo_ss(X_AXIS,ARG1)
      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)


         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               l1 = arg_lo_ss(T_AXIS,ARG1)
               DO 100 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

C get the string and its length
                  CALL EF_GET_STRING_ARG_ELEMENT (id, ARG1, arg_1, 
     .                                      i1,j1,k1,l1, slen, textstring)

C get just the length
                  CALL EF_GET_STRING_ARG_ELEMENT_LEN(id, ARG1, arg_1, 
     .                                      i1,j1,k1,l1,  slen)

C What if the string buffer were declared too short?
                  CALL EF_GET_STRING_ARG_ELEMENT (id, ARG1, arg_1, 
     .                                      i1,j1,k1,l1, slen, short)

C just copy the pointer to the result
                  IF (l .EQ. res_lo_ss(T_AXIS)) THEN
                     CALL EF_PUT_STRING_PTR
     .                 (arg_1(1,i1,j1,k1,l1),result(1,i,j,k,l))

C Copy a new string to the result
                  ELSE IF (l .EQ. res_lo_ss(T_AXIS)+1) THEN
                     textstring = 'new'
                     slen = 3
                     CALL EF_PUT_STRING (textstring, slen, result(1,i,j,k,l))
                  ELSE

C Compute other string values and put them in the result.
                     CALL EF_GET_AXIS_DATES (id, ARG1, tax(1,1,1,L1), 1, prec, slen, datestring)
                     CALL EF_PUT_STRING (datestring, slen, result(1,i,j,k,l))
                  ENDIF

                  l1 = l1 + arg_incr(T_AXIS,ARG1)
 100           CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 300     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
 400  CONTINUE
     
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	SUBROUTINE TM_CLOSE_SET_COND_DEALLO ( ds_num, deallo, status )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*

* 2/2016 *sh* identical to legacy TM_CLOSE_SET except deallocation of
* the grids owned by the variables of the dataset is conditional
* That allows this routine to be called during error conditions in defining
* aggregate datasets.  At that time the line_use_cnt values have not yet 
* been bumped by TM_GARB_COL to reflect the usage by these grids.  

*
* Reclaim a data set by re-initializing all associated common variables.
* Initialize all the variables with the set up values, except for:
*	ds_var_setnum		= set_not_open
*	ds_alert_on_open	= .FALSE.
*	ds_alert_on_output	= .FALSE.
*	ds_regsteps		= .TRUE.
*	sf_setnum		= set_not_open
*	sf_valid		= .FALSE.
*	sf_lunit		= file_not_open	
*	sf_regvars		= .TRUE.
*	sf_regtimes		= .TRUE.
*
* programmer - mark verschell
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.00 - 09/11/86 - based on TM_ONLY1_STEP
* revision 1.00 - 03/19/87 - based on TM_CLOSE_SET by S. HANKIN
* revision 1.10 - 05/07/87 - added clean up of grid, and integration_tstep
* revision 1.11 - 07/07/87 - removed ds_revision
* revision 1.12 - 10/30/87 - removed ds_make_dscrip_rev
* revision 1.13 - 07/09/88 - aux_parm becomes parm_name and parm_text, and
*			     aux_modnum, aux_parm(s) now initialized in do loop
* revision 1.14 - 10/31/88 - added ds_var_modline
* revision 1.15 - 11/21/88 - changed re-initialization to specific char_initXX
* revision 1.16 - 02/08/89 - removed ds_var_modline
* revision 1.20 - 02/15/89 - Renamed TM_CLOSE_SET - added var_file variables -
*			     changed GT_CLOSE_STEP to TM_CLOSE_STEP, removed
*			     ds_open
* revision 1.21 - 04/24/91 - increased size of sf_name, ds_name and ds_des_name
* netCDF support *sh* 6/92
* EPIC netCDF *sh* 3/93
* v500 - *kob* 3/99 -  initialize ds_var_code, ds_var_units, ds_var_title
*                      and ds_var_titl_mod w/ char_inits of proper new value
* v500 - *kob* 4/99 - increase size of sf_name and ds_des_name for lengthly
*	              DODS filenames
* V510 *sh* 4/00 - deallocate grids and axes used by variables in this data set
* v540 *acm* 10/01 increase length of ds_name
* v540 *acm* 10/01 remove VMS include statements
* v552 *acm*  3/03 bug fix: If maxstepfiles > maxvarfiles, got error on closing dataset.
* V552 *acm*  5/03 increase size of ds_var_code from 64 to 128 chars
* V581 *acm*/3/05 - increase length of strings for dataset title to 1024 
* V600 *acm* 6/05 - Attribute control.
* V600 *acm* 2/06 - restore default values of ds_var_scale, ds_var_off, ds_var_scaleit
* v604 *acm* 7/07 increase length of ds_name, ds_des_name
* V608 *acm* 10/07 Fixes for memory leak; call NCF_DELETE_DSET as a function
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing
* V698 1/16 *sh* treat F aggregations ('FCT') like E-aggs
*      2/16 *sh* create this routine from TM_CLOSE_SET
* V701  7/16 *kms* Compare ds_name to char_init2048 instead of char_init1024
*                  Initialize ds_name and ds_des_name to char_init2048
*                  sf_name initialized to char_init2048
* V720 4/17 *sh*  Initialize DSG variables
* V76  1/20 *acm* remove commented-out lines

* arguments:
*	ds_num	- (input) data set number (see COMMON /XSTEP_FILES/)
*	deallo	- (input) flag whether to deallocate the grids

	include 'tmap_errors.parm'	! error code parameter defs
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'tmap_dims.parm'
	include 'xstep_files.cmn_text'
	external xstep_files_data
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xtm_grid.cmn_text'

* argument declarations
	LOGICAL deallo
	INTEGER ds_num, status

* internal variable declarations
        LOGICAL   its_cdf
	INTEGER   NCF_DELETE_DSET, STR_SAME,
     .            f_num, ivar, iparm, iaux, idim,
     .            grid, line, lm, var

* initialize: do we have an open set?
	IF (ds_name(ds_num) .EQ. char_init2048) GOTO 9000

* save the data format
	its_cdf = ds_type(ds_num) .EQ. 'ENS'
     .     .OR.   ds_type(ds_num) .EQ. 'FCT'
     .     .OR.   ds_type(ds_num) .EQ. 'CDF'
     .     .OR.   ds_type(ds_num) .EQ. 'ECDF' 

* special steps to close a DSG dataset
	IF (dsg_ragged(ds_num)) THEN
           CALL CD_RELEASE_DSG_INSTANCE_VARS(ds_num)
* ... remove the special axes and grids used for coordinate formatting
	   grid = dsg_xlate_grid(ds_num)
	   CALL TM_DEALLO_DYN_GRID(grid)
* re-init the special DSG variables
	   dsg_ragged(ds_num) = .FALSE.
	ENDIF

* Clear variables associated only with data set number

* free the coordinate memory for the time axis of an aggregation
	IF (ds_type(ds_num) .EQ. 'FCT' .OR. STR_SAME(ds_type(ds_num), ' MC') .EQ. 0) THEN
	   IF (ds_time_axis(ds_num).NE.int4_init .AND. ds_time_axis(ds_num).NE.unspecified_int4)
     .         CALL FREE_LINE_DYNMEM (ds_time_axis(ds_num))
        ENDIF

* special steps to close a DSG dataset
	IF (dsg_ragged(ds_num)) THEN
           CALL CD_RELEASE_DSG_INSTANCE_VARS(ds_num)
* ... remove the special axes and grids used for coordinate formatting
	   grid = dsg_xlate_grid(ds_num)
	   CALL TM_DEALLO_DYN_GRID(grid)
* re-init the special DSG variables
	   dsg_ragged(ds_num) = .FALSE.
	ENDIF

* Clear variables associated only with data set number

* free the coordinate memory for the time axis of an aggregation
	IF (ds_type(ds_num) .EQ. 'FCT' .OR. STR_SAME(ds_type(ds_num), ' MC') .EQ. 0) THEN
	   IF (ds_time_axis(ds_num).NE.int4_init .AND. ds_time_axis(ds_num).NE.unspecified_int4)
     .         CALL FREE_LINE_DYNMEM (ds_time_axis(ds_num))
        ENDIF

* First clear variables associated only with data set number
	ds_type(ds_num)			=	char_init04
	ds_format(ds_num)		=	char_init04
	ds_source_class(ds_num)		=	char_init16
	ds_source(ds_num)		=	char_init16
	ds_subsource(ds_num)		=	char_init16
	ds_prog_rev(ds_num)		=	char_init04
********************************************************************************
	ds_expnum(ds_num)		=	char_init04
	ds_modnum(ds_num)		=	char_init04
	ds_title(ds_num)		=	char_init1024
	ds_mod_title(ds_num)		=	char_init1024
	ds_forcing_set(ds_num)		=	char_init16
	ds_t0time(ds_num)		=	char_init20
	ds_time_unit(ds_num)		=	real4_init
	ds_ntegrate_tstep(ds_num)	=	real4_init
	ds_ntuple(ds_num)		=	int4_init
	ds_time_run(ds_num)		=	char_init20
	DO 100 iaux = 1,num_aux
	  ds_aux_modnum(iaux,ds_num)	=	char_init04
  100	CONTINUE
	DO 110 iparm = 1,num_parm
	  ds_parm_name(iparm,ds_num)	=	char_init20
	  ds_parm_text(iparm,ds_num)	=	char_init80
  110	CONTINUE
********************************************************************************
	ds_alert_on_open(ds_num)	= 	.FALSE.
	ds_alert_on_output(ds_num)	= 	.FALSE.
	ds_message(ds_num)		=	char_init80
********************************************************************************
* Note that ds_basic_axes relate to the TMAP model output

	ds_des_name(ds_num)		=	char_init2048
	ds_name(ds_num)			=	char_init2048
	ds_1step(ds_num)		=	real8_init
	ds_lastep(ds_num)		=	real8_init
	ds_delstep(ds_num)		=	real8_init
	ds_regsteps(ds_num)		=	.TRUE.
	ds_basic_axes(1,ds_num)		=	int4_init
	ds_basic_axes(2,ds_num)		=	int4_init
	ds_basic_axes(3,ds_num)		=	int4_init
	ds_basic_axes(4,ds_num)		=	int4_init
	ds_basic_axes(5,ds_num)		=	int4_init
	ds_basic_axes(6,ds_num)		=	int4_init
	ds_time_axis(ds_num)		=	int4_init
	ds_accepts_remote(ds_num)	= 	.FALSE.
	ds_hide(ds_num)			=	.FALSE.

* Delete any delimited file info given and reset to NULL
        CALL delete_delimited_info(ds_file_info_ptr(ds_num))

* Next clear variables associated with variable in that data set.
	DO 130 ivar = 1,maxvars
	  IF (ds_var_setnum(ivar) .NE. ds_num) GOTO 130

* ... deallocate grids and axes used by the dat aset
	  IF (deallo) CALL TM_DEALLO_DYN_GRID( ds_grid_number(ivar))

*	  ds_var_code(ivar)		=	char_init128
          CALL string_array_modify(ds_var_code_head, ivar,
     .                             char_init128,
     .                             LEN(char_init128))
	  ds_var_title(ivar)		=	char_init1024
	  ds_var_titl_mod(ivar)		=	char_init1024
	  ds_var_units(ivar)		=	char_init64
	  ds_grid_number(ivar)		=	int4_init
	  ds_missing_flag(ivar)		=	real4_init
	  ds_bad_flag(ivar)		=	real4_init
	  DO 120 idim = 1, nferdims
	     ds_ordering(idim,ivar)	=	int4_init
	     ds_grid_start(idim,ivar)	=	int4_init
	     ds_grid_end(idim,ivar)	=	int4_init
  120	  CONTINUE
	  ds_precision(ivar)		=	char_init01
	  ds_aux_set_num(ivar)		=	int4_init
********************************************************************************
	  ds_ndataperrec(ivar)		=	int4_init
	  ds_nrecpervar(ivar)		=	int4_init
	  ds_nrecb4var(ivar)		=	int4_init
	  ds_var_setnum(ivar) 		=	set_not_open
	  ds_var_scaleit(ivar) 		=	.FALSE.
	  ds_var_scale(ivar) 		=	1.0
	  ds_var_off(ivar) 		=	0.0

  130	CONTINUE

* Now loop through stepfiles and initialize associated entries, closing files
* if necessary

	DO 140 f_num = 1, maxstepfiles
	  IF (sf_setnum(f_num) .NE. ds_num) GOTO 140

* close step file or CDF file ?
	  IF ( sf_lunit (f_num) .NE. file_not_open) THEN	! open ?
            IF ( its_cdf ) THEN
               CALL CD_CLOSE_SET( sf_lunit(f_num), status )
            ELSE
	       CALL TM_CLOSE_STEP (f_num, status)
            ENDIF
	    IF (status .NE. merr_ok) GOTO 9900
	  ENDIF

* delete step file from tables
	  sf_name(f_num)		=	char_init2048
	  sf_setnum(f_num)		=	set_not_open
	  sf_aux_set_num(f_num)		=	int4_init
	  sf_nrecperstep(f_num)		=	int4_init
	  sf_skip(f_num)		=	int4_init
	  sf_1step(f_num)		=	real8_init
	  sf_lastep(f_num)		=	real8_init
	  sf_delta(f_num)		=	real8_init
	  sf_reclen(f_num)		=	int4_init
	  sf_valid(f_num)		=	.FALSE.
	  sf_lunit(f_num)		=	file_not_open	
	  sf_index(f_num)		=	char_init23
	  sf_regvars(f_num)		=	.TRUE.
	  sf_regtimes(f_num)		=	.TRUE.
  140	CONTINUE

        DO 150 f_num = 1, maxvarfiles
	  vf_firstvar(f_num)		=	int4_init
	  vf_lastvar(f_num)		=	int4_init
  150   CONTINUE

	status = NCF_DELETE_DSET(ds_num)
        GOTO 9900

 9000	status = merr_ok

 9900	RETURN
	END

    	SUBROUTINE SET_AGG_VAR_ATTS(agg_dset, vname, aggv_slot, nsets,
     .                              ref_fvar, memb_set, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* assign attributes to an aggregated variable if the same, identical attributes
* are found on all member variables
* (units, title, and bad_flag are taken care of elsewhere)


* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V698 *sh* 2/16 
* V698 *acm* 2/16 LET/D variables are now stored with their associated datset
*                 in the List structure so can get their attribute info
* V720 *acm* 5/17 Implement specific calls in place of CD_GET_VAR_INFO

        INCLUDE 'tmap_dims.parm'
        INCLUDE 'ferret.parm'
        INCLUDE 'errmsg.parm'      
        INCLUDE 'xprog_state.cmn'
        INCLUDE 'xvariables.cmn'
        INCLUDE 'xcontext.cmn'
        INCLUDE 'xdset_info.cmn_text'
        INCLUDE 'netcdf.inc'

* calling arguments
*  agg_dset     - dset no of the aggregation (input)
*  vname        - name of the aggregated variable (input)
*  aggv_slot    - index of agg var in ds_ common (input)
*  nsets        - number of member datasets in aggregation (input)
*  ref_fvar     - reference file variable serving as the pattern (input)
*  memb_set     - list of member dataset numbers (input)
*  status       - return status (output)

* calling argument declarations
    	INTEGER agg_dset, aggv_slot, nsets, 
     .          ref_fvar, memb_set(*), status
        CHARACTER*128 vname

* Local variable declarations
        INTEGER maxlen
        PARAMETER (maxlen = 2048)

        LOGICAL NC_GET_ATTRIB, got_it
        INTEGER TM_LENSTR1, vlen, ref_dset, ref_id, var_id,
     .          nvatts, att, imemb, attype, attlen, attoutflag,
     .          m_attid, m_attype, m_attlen, m_attoutflag,
     .          m_dset, m_cat, m_grid, m_var, m_ens_ax,
     .          all_outflag, memb_id(nsets), i, iatt
        REAL    attvals(50), m_attvals(50)
        CHARACTER attname*128
        CHARACTER*(maxlen) attstr, m_attstr


* initialize
        vlen = TM_LENSTR1(vname)
        ref_dset = ds_var_setnum(ref_fvar)

* Get var id for reference variable
        CALL CD_GET_VAR_ID (ref_dset, vname(:vlen), ref_id, status)
        IF (status .NE. ferr_ok) GOTO 5200

* Get var id for aggregated variable
        CALL CD_GET_VAR_ID (agg_dset, vname(:vlen), var_id, status)
        IF (status .NE. ferr_ok) GOTO 5200

* Get var ids for member variables
        imemb = 1
        DO imemb = 1, nsets

* skip dummy datasets
           IF (memb_set(imemb) .EQ. pdset_dummy) THEN
              memb_id(imemb) = unspecified_int4
              CYCLE
           ENDIF

* LET/D vars are represented in the List structure of their assigned
* dataset. Treat as for any file variable
	   CALL CD_GET_AGG_VAR_INFO (agg_dset, vname(:vlen), imemb, 
     .         m_cat, m_dset, m_grid, m_ens_ax, m_var, status)
           IF (status .NE. ferr_ok) GOTO 5200
           CALL CD_GET_VAR_ID (memb_set(imemb), vname(:vlen),
     .                         memb_id(imemb), status)
           IF (status .NE. ferr_ok) GOTO 5200

        ENDDO

* Get number of attributes from the reference variable
        CALL CD_GET_VAR_NATTS (ref_dset, ref_id, vname(:vlen),
     .                         nvatts, status)

**** loop through the attribute list from the reference variable
        attloop: DO iatt = 1, nvatts
           CALL CD_GET_VAR_ATT_NAME (ref_dset, ref_id, iatt, attname, status)

* Ignore basic attributes. These are already defined.
*?? Check the attribute values from each member?
           IF (attname .EQ. 'units'
     .    .OR. attname .EQ. 'long_name'
     .    .OR. attname .EQ. '_FillValue'
     .    .OR. attname .EQ. 'missing_value') CYCLE

* get the reference attribute info
           CALL CD_GET_VAR_ATT_INFO (ref_dset, ref_id, iatt, attname, 
     .               attype, attlen, attoutflag, status )
           IF (status .NE. ferr_ok) GOTO 5200

* get the reference attribute value and info
           got_it = NC_GET_ATTRIB ( ref_dset, ref_id, attname,
     .                              .TRUE., vname(:vlen), maxlen,
     .                              attlen, attoutflag,
     .                              attstr, attvals )
           IF (.NOT.got_it) GOTO 5200
	   
* ensure that the attribute is identical in all member variables

           DO imemb = 1, nsets

* ... skip over dummy members
              IF (memb_set(imemb) .EQ. pdset_dummy) CYCLE

! ... skip over user variables
              IF (memb_id(imemb)  .EQ. unspecified_int4) CYCLE

* ... get the attribute id in the member
              CALL CD_GET_VAR_ATT_ID (memb_set(imemb), memb_id(imemb),
     .                                attname, m_attid, status)
              IF (status.EQ.atom_not_found) CYCLE attloop

* ... get the attribute info for the member
              CALL CD_GET_VAR_ATT_INFO (memb_set(imemb), memb_id(imemb),
     .                                  m_attid, attname, m_attype, 
     .                                  m_attlen, m_attoutflag, status )
              IF (status .NE. ferr_ok) GOTO 5200
              IF (m_attype .NE. attype
     .       .OR. m_attlen .NE. attlen ) CYCLE attloop

* get the attribute value for the member
              got_it = NC_GET_ATTRIB (memb_set(imemb), memb_id(imemb),
     .                              attname,
     .                              .TRUE., vname(:vlen), maxlen,
     .                              m_attlen, m_attoutflag,
     .                              m_attstr, m_attvals )
              IF (.NOT.got_it) GOTO 5200

* check that the value matches the reference
              IF (attype .EQ. NCCHAR) THEN
* ... check that string values are identical
                 IF (m_attstr .NE. attstr)  CYCLE attloop
              ELSE
* ... check that numeric values are identical
                 DO i = 1, attlen
                    IF (attvals(i) .NE. m_attvals(i)) CYCLE attloop
                 ENDDO
              ENDIF

           ENDDO   ! done cmparing with member attributes

* transfer this attribute from the reference variable to the aggregate variable
	   CALL CD_PUT_NEW_ATTR (agg_dset, var_id, attname, attype, 
     .                  attlen, attoutflag, attstr, attvals, status )

        ENDDO attloop

* Do not call UPDATE_ATTRIBUTES. The title, units, missing etc were
* already set in defining the variable in the aggregation.
cc        CALL UPDATE_ATTRIBUTES (agg_dset, vname, aggv_slot, status)
cc        IF (status .NE. ferr_ok) GOTO 5200

* success
* (status may have been set to atom_not_found on a missing attribute.
*  Set to ferr_ok.)

	status = ferr_ok
        RETURN

* error exits
 5000   RETURN

! 5100   CALL ERRMSG (ferr_var_not_in_set, status, vname(:vlen),*5000)
!
 5200   CALL ERRMSG (ferr_internal, status,
     .               'attListCrptn: '//vname(:vlen),*5000)
	END

	SUBROUTINE TRANSFER_GRID ( source_grid, dest_grid )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* transfer a complete description of a grid from one slot in COMMON to another

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 10/14/86
* revision 0.1 -  3/23/87 - eliminated grid_origin as not useful
* 2/12 *acm* Add E and F dimensions (use nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'ferret.parm'

	INTEGER	source_grid, dest_grid, idim

	grid_name     ( dest_grid )	= 'unknown'
	grid_rotation ( dest_grid )	= grid_rotation( source_grid )

	DO 100 idim = 1, nferdims
	   grid_line    (idim, dest_grid) = grid_line    (idim, source_grid)
	   grid_out_prod(idim, dest_grid) = grid_out_prod(idim, source_grid)
 100	CONTINUE

	RETURN
	END

	SUBROUTINE PS_LINE_BUNDLE (zwsid)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Routine to set up the line bundles for monochrome PS ws's
*	J Davison JISAO/PMEL/TMAP 3.23.89
*	*jd* 2.19.92 mod to support atc gks
* 
*       *acm* 8/2001  add polymarker call for PLOT/SYMBOL=DOT  
* gsplr: wkid, line index, line type, linewidth scale factor, color index
* gspmr: wkid, marker index, marker type(dot=1), 
*        size scale factor (const for dot), color index

*        NOTE: as of 10/3/01  this is not working consistently. With 
*        marktype=1, the documentation says the symbol will be a "point"
*        and that the mark size is ignored.  In fact the mark size is not 
*        ignored, and if I use the argument as in the /THICKNESS qualifier 
*        for lines, we get three different sizes for the marks. The marks 
*        are not round dots however.  Also, when saving the plot to a metafile, 
*        the postscript image has the dots looking much smaller than they 
*        do on the Ferret window or in a gif image.  They are so small they 
*        are invisible in ghostview except for the largest size. They do print 
*        as tiny dots.

	integer		zwsid,i,j
#ifdef atc_gks
	integer 	ltype(6)
	data   	        ltype/1,2,3,4,-2,-3/
#else
        integer         ltype(6)
        data            ltype/1,-5,3,4,-3,-1/
#endif
	real		thickness, dotsize
        integer		marktype

C	For linux *jd* 12.96 put initialization in data statements
	
*******************************************************************************

        marktype = 1    ! polymarker type 1=dot, (4=circle)
	do 20 j = 1,3
	   thickness = real (j)*2.0 - 1.0
           dotsize = thickness/ 2.

	   do 10 i = 1,6
	      call gsplr (zwsid,i+6*(j-1),ltype(i),thickness,1)
	      call gspmr (zwsid,i+6*(j-1),marktype,dotsize,1) 

10	   continue
20	continue

	return

	end

      SUBROUTINE STL2(X, Y, E, M, bad_y, bad_out, U, V, W, K, IP)

C PIECEWISE LINEAR APPROXIMATIONS OF FEWEST
C LINE SEGMENTS WITHIN GIVEN TOLERANCES.

C X,Y,E AND M CONTAIN INPUT DATA.
C U,V,K AND POSSIBLY W CONTAIN OUTPUT.

C IP IS A PARAMETER DETERMINING THE OPERATION
C  OF THE PROGRAM.

C X AND Y ARE INPUT DATA ARRAYS OF M ELEMENTS
C  X(I),Y(I) CONTAINS THE ITH DATA POINT.

C E MAY BE A SINGLE TOLERANCE OR A TABLE OF
C  TOLERANCES DEPENDING ON THE VALUE OF IP.
C IF E IS AN ARRAY, THEN E(I) IS THE TOLERANCE
C  ASSOCIATED WITH X(I),Y(I) AND E MUST CONTAIN
C  M NONNEGATIVE ELEMENTS.

C U AND V ARE OUTPUT ARRAYS OF K+1 ELEMENTS.
C  U IS A PARTITION OF THE INTERVAL (X(1),X(N))
C  WITH U(1)=X(1) AND U(K+1)=X(N).
C  V(I) IS AN ORDINATE TO BE ASSOCIATED WITH
C  U(I) IN THE APPROXIMATION.  (IF A CONTINUOUS
C  APPROXIMATION IS REQUESTED, THEN V(I) IS
C  'THE' ORDINATE TO BE ASSOCIATED WITH U(I).)

C IF A CONTINUOUS APPROXIMATION IS REQUESTED,
C  THEN W IS NOT USED.  IN THIS CASE THE ITH
C  APPROXIMATING SEGMENT IS THE STRAIGHT LINE
C  FROM U(I),V(I) TO U(I+1),V(I+1).

C IF A CONTINUOUS APPROXIMATION IS NOT
C  REQUESTED, THEN W IS A K-ELEMENT OUTPUT
C  ARRAY.  IN THIS CASE THE ITH APPROXIMATING
C  SEGMENT IS THE STRAIGHT LINE FROM
C  U(I),W(I) TO U(I+1),V(I+1), AND V(1) IS
C  SET EQUAL TO W(1).

C K IS THE NUMBER OF SEGMENTS IN THE PIECE-
C  WISE LINEAR APPROXIMATION GENERATED.  IN
C  CASE OF AN ERROR RETURN, K WILL BE SET TO
C  ZERO.

C THE CONTROL PARAMETER IP IS THE PRODUCT
C  OF THREE INDICATORS I1,I2 AND I3.
C  I1 INDICATES WHETHER OR NOT E IS AN
C     ARRAY OF TOLERANCES.
C     I1 = -1 INDICATES E IS AN ARRAY
C     I1 = +1 INDICATES E IS A SINGLE NUMBER.
C  I2 INDICATES WHETHER OR NOT THE
C     APPROXIMATION IS TO BE RESTRICTED TO
C     THE 'TOLERANCE BAND' ABOUT THE DATA.
C     I2 = 1 INDICATES NO BAND RESTRICTION
C     I2 = 2 INDICATES APPLY THIS RESTRICTION
C     (THE 'TOLERANCE BAND' IS A PIECEWISE
C     LINEAR BAND CENTERED AT THE DATA WHOSE
C     WIDTH IS DETERMINED BY THE TOLERANCES
C     AT THE DATA POINTS.)
C  I3 INDICATES WHETHER OR NOT THE
C     APPROXIMATION MUST BE CONTINUOUS.
C     I3 = 1 INDICATES CONTINUITY NOT REQUIRED
C     I3 = 3 INDICATES CONTINUITY IS REQUIRED

C CALL STL2 (X,Y,E,M,X,Y,E,M,IP) WILL NOT
C  CAUSE PROBLEMS PROVIDED THAT
C  EITHER A CONTINUOUS APPROXIMATION IS
C  REQUESTED, OR E IS A SUFFICIENTLY LARGE
C  ARRAY.

C THE PROGRAM PERFORMS THE FOLLOWING DATA
C  CHECKS.  ARE THE X-VALUES IN INCREASING
C  ORDER.  ARE THE TOLERANCE(S) NONNEGATIVE.
C  IS THE NUMBER OF DATA POINTS GREATER THAN
C  ONE.  IF ANY CHECK FAILS, THE PROGRAM
C  RETURNS WITH K SET EQUAL TO 0.  IN THIS
C  CASE NO FURTHER PROCESSING IS ATTEMPTED.

      IMPLICIT NONE
* Calling arguments
      REAL X(*), Y(*), E(*), U(*), V(*), W(*), bad_y, bad_out
      INTEGER M, K, IP

* Local declarations
      LOGICAL skipbad
      INTEGER N, ITCH, I, J, L, KEEP, INIT, INDC, IGRAZE,
     .        IDIOT, IT, IPIV, KP, ilo, ihi, icount
      REAL EPSLN, SGN, XEYE, YEYE, TEMP1, SMIN, DX, 
     .     SVX, SVY, SVMN, TEMP2, XINIT, YINIT, SLOPE, SMAX, 
     .     SVMX, TEST

* If there is a trivial amount of data in the input array then we are done
      ilo = 0
      ihi = 0
      icount = 0
      DO i = 1, m
         IF (y(i) .NE. bad_y) THEN
	    icount = icount + 1
	    IF (ilo .EQ. 0) ilo = i
	    ihi = i
	 ENDIF
      ENDDO

      IF (icount .LE. 2) THEN
         k = icount
	 IF (ilo .GT. 0) u(1) = ilo
	 IF (ihi .GT. 0) u(icount) = ihi
	 GOTO 600
      ENDIF

      N = M
      ITCH = IP
      J = 1
C ERROR CHECKS
      IF (N.LE.1) GO TO 400
      IF (E(1).LT.0.0) GO TO 400
      DO 10 L=2,N
        IF (X(L-1).GE.X(L)) GO TO 400
        IF (ITCH.GE.0) GO TO 10
        IF (E(L).LT.0.0) GO TO 400
   10 CONTINUE
C INITIALIZATION FOR ENTIRE PROGRAM
      EPSLN = E(1)
      SGN = 1.0
      KEEP = 1
      I = 1

      CALL PIECEWISE3_CHECKGAP (Y, bad_y, x, u, i, j, n, skipbad)
      IF (I.EQ.N) GOTO 260
      IF (skipbad) GOTO 30

      U(i) = X(i)
      J = 2
      INIT = 1
      INDC = 0
      GO TO 30
C INITIALIZATION FOR EACH SEGMENT
   20 CONTINUE
      J = J + 1
      INIT = I
      INDC = 0
      IF (IABS(ITCH).LT.3) KEEP = I
      IF (IABS(IABS(ITCH)-4).NE.2) GO TO 30
C RESTRICTED TO TOLERANCE BAND
      XEYE = U(J-1)
      YEYE = V(J-1)
      TEMP1 = EPSLN
      IF (ITCH.LT.0) TEMP1 = TEMP1 + (SGN*E(I-1)-EPSLN)*(X(I)-U(J-1)
     * )/(X(I)-X(I-1))
      YINIT = YEYE - TEMP1 - TEMP1
      GO TO 40
   30 CONTINUE
C NOT RESTRICTED TO TOLERANCE BAND
      XEYE = X(I)
      YEYE = Y(I) + EPSLN
      YINIT = Y(I) - EPSLN
      IF (IABS(ITCH).EQ.1 .OR. I.EQ.1) GO TO 40
      TEMP1 = EPSLN
      IF (ITCH.LT.0) TEMP1 = SGN*E(I+1)
      SMIN = (Y(I+1)-YEYE-TEMP1)/(X(I+1)-XEYE)
      IF (ITCH.LT.0) TEMP1 = SGN*E(I-1)
      SMAX = (YEYE-Y(I-1)+TEMP1)/(XEYE-X(I-1))

      IF (KEEP.EQ.I-1) GO TO 50
      IT = I - 2
      XINIT = XEYE
      IPIV = I
      IGRAZE = I
      I = I + 1

      CALL PIECEWISE3_CHECKGAP (Y, bad_y, x, u, i, j, n, skipbad)
      IF (skipbad) THEN
         IF (I.EQ.N) GOTO 260
	 GOTO 30
      ENDIF

      GO TO 150
   40 CONTINUE
      IF (XEYE.GE.X(I)) I = I + 1
      IF (ITCH.LT.0) EPSLN = SGN*E(I)
      DX = X(I) - XEYE
      SMAX = (Y(I)+EPSLN-YEYE)/DX
      SMIN = (Y(I)-EPSLN-YEYE)/DX
   50 CONTINUE
      XINIT = XEYE
      IPIV = I
      IGRAZE = I
C DETERMINATION OF INDIVIDUAL SEGMENT
   60 CONTINUE
      IF (I.EQ.N) GO TO 260
      I = I + 1
      
C New i, so does it point to a bad-val?

      CALL PIECEWISE3_CHECKGAP (Y, bad_y, x, u, i, j, n, skipbad)
      IF (skipbad) THEN
         IF (I.EQ.N) GOTO 260
	 GOTO 30
      ENDIF

   70 CONTINUE
 
C TEST FOR NEW *MAX* SLOPE
      DX = X(I) - XEYE
      IF (ITCH.LT.0) EPSLN = SGN*E(I)
      TEMP1 = (Y(I)+EPSLN-YEYE)/DX
      TEST = TEMP1 - SMAX
      IF (SGN.LE.0.0) TEST = -TEST
      IF (TEST) 80, 90, 100
   80 CONTINUE
C TEST FOR END OF CANDIDATE SEGMENT
      TEST = TEMP1 - SMIN
      IF (SGN.LE.0.0) TEST = -TEST
      IF (TEST.LT.0.0) GO TO 210
      SMAX = TEMP1
   90 CONTINUE
C TEST FOR NEW *MIN* SLOPE
      IPIV = I
  100 CONTINUE
      TEMP2 = (Y(I)-EPSLN-YEYE)/DX
      TEST = TEMP2 - SMAX
      IF (SGN.LE.0.0) TEST = -TEST
      IF (TEST) 110, 120, 140
  110 CONTINUE
      TEST = SMIN - TEMP2
      IF (SGN.LE.0.0) TEST = -TEST
      IF (TEST) 120, 130, 60
  120 CONTINUE
      SMIN = TEMP2
  130 CONTINUE
      IGRAZE = I
      GO TO 60
C CHECK FOR PIVOT AT NEW EYE POINT
  140 CONTINUE
      IF (XEYE.EQ.X(IPIV)) GO TO 220
      IF (ITCH.LT.0) EPSLN = SGN*E(IPIV)
      INDC = 1
      SVX = XEYE
      SVY = YEYE
      SVMN = SMIN
      SVMX = SMAX
      XEYE = X(IPIV)
      YEYE = Y(IPIV) + EPSLN
      SMIN = SMAX
      SMAX = (YINIT-YEYE)/(XINIT-XEYE)
      IF (KEEP.GE.IPIV) GO TO 170
      IT = IPIV - 1
  150 CONTINUE
      TEMP2 = YEYE + EPSLN
      DO 160 L=KEEP,IT
        IF (ITCH.LT.0) TEMP2 = YEYE + SGN*E(L)
        TEMP1 = (Y(L)-TEMP2)/(X(L)-XEYE)
        TEST = TEMP1 - SMAX
        IF (SGN.LE.0.0) TEST = -TEST
        IF (TEST.LT.0.0) SMAX = TEMP1
  160 CONTINUE
  170 CONTINUE
      IF (IPIV.GE.I-1) GO TO 70
      IT = I - 2
      TEMP2 = YEYE - EPSLN
      IDIOT = IPIV
      DO 200 L=IDIOT,IT
        DX = X(L+1) - XEYE
        IF (ITCH.LT.0) TEMP2 = YEYE - SGN*E(L+1)
        TEMP1 = (Y(L+1)-TEMP2)/DX
        TEST = TEMP1 - SMAX
        IF (SGN.LE.0.0) TEST = -TEST
        IF (TEST) 180, 190, 200
  180   CONTINUE
        SMAX = TEMP1
  190   CONTINUE
        IPIV = L + 1
  200 CONTINUE
      GO TO 70
C END OF CURRENT SEGMENT
  210 CONTINUE
      TEMP2 = SMIN
      IF (I.EQ.N) GO TO 240
      KEEP = IGRAZE
      GO TO 250
  220 CONTINUE
      TEMP2 = SMAX
      IF (I.EQ.N) GO TO 230
      SGN = -SGN
      EPSLN = -EPSLN
      KEEP = IPIV
      GO TO 250
  230 CONTINUE
      IF (INDC.EQ.0 .OR. XEYE.NE.X(N-1)) GO TO 240
      XEYE = SVX
      YEYE = SVY
      SMIN = SVMN
      SMAX = SVMX
  240 CONTINUE
      U(J) = X(N-1)
      YINIT = Y(N-1)
      GO TO 270
  250 CONTINUE
      IF (IABS(IABS(ITCH)-4).NE.2) GO TO 300
C DETERMINE KNOT ON EDGE OF TOLERANCE BAND
      TEMP1 = 0.0
      IF (ITCH.LT.0) TEMP1 = EPSLN - SGN*E(I-1)
      TEMP1 = (Y(I)-Y(I-1)+TEMP1)/(X(I)-X(I-1))
      
      U(J) = (Y(I)+EPSLN-YEYE-TEMP1*X(I)+TEMP2*XEYE)/(TEMP2-TEMP1)

      GO TO 310
  260 CONTINUE
      U(J) = X(N)
      YINIT = Y(N)
  270 CONTINUE
C CONTINUITY CHECK FOR LAST SEGMENT
      IF (IABS(ITCH).GE.3 .OR. INIT.EQ.1) GO TO 290
      IT = INIT - 1
      SVMX = SMAX + SGN
      TEMP2 = YEYE + EPSLN
      DO 280 L=KP,IT
        IF (ITCH.LT.0) TEMP2 = YEYE + SGN*E(L)
        TEMP1 = (Y(L)-TEMP2)/(X(L)-XEYE)
        TEST = TEMP1 - SVMX
        IF (SGN.LE.0.0) TEST = -TEST
        IF (TEST.LT.0.0) SVMX = TEMP1
  280 CONTINUE
      IF (ABS(SVMX-SMAX+SVMX-SMIN).LE.ABS(SMAX-SMIN)) SMAX = SVMX
  290 CONTINUE
C NEARNESS CHECK FOR LAST SEGMENT
      TEMP2 = SMAX
      TEMP1 = YEYE + SMAX*(U(J)-XEYE)
      TEST = YINIT - TEMP1
      IF (SGN.LT.0.0) TEST = -TEST
      IF (TEST.GT.0.0) GO TO 310
      TEMP2 = SMIN
      TEMP1 = YEYE + SMIN*(U(J)-XEYE)
      TEST = YINIT - TEMP1
      IF (SGN.LT.0.0) TEST = -TEST
      IF (TEST.LT.0.0) GO TO 310
      TEMP2 = (YINIT-YEYE)/(U(J)-XEYE)
      V(J) = YINIT
      GO TO 320
  300 CONTINUE
      IF (IABS(ITCH).GE.3) GO TO 330
      U(J) = 0.5*(X(I)+X(I-1))
  310 CONTINUE
      V(J) = YEYE + TEMP2*(U(J)-XEYE)
  320 CONTINUE
      IF (XEYE.NE.XINIT) GO TO 330
      IF (IABS(ITCH).EQ.2) GO TO 360
      IF (IABS(ITCH).NE.6) GO TO 330
      IF (J.LE.2) GO TO 380
      GO TO 390
  330 CONTINUE
C RECOMPUTATION OF KNOT FOR CONTINUITY
      IF (J.LE.2) GO TO 370
      IF (SLOPE.EQ.TEMP2) GO TO 360
      YINIT = V(J-2)
      IF (IABS(ITCH).LT.3) YINIT = W(J-2)
      TEMP1 = (XEYE*TEMP2-U(J-2)*SLOPE+YINIT-YEYE)/(TEMP2-SLOPE)
      IF (IABS(ITCH).GE.3) GO TO 350
      IF (TEMP1.GT.XINIT) GO TO 360
      TEST = ABS(EPSLN)
      IDIOT = INIT - KP
      DO 340 L=1,IDIOT
        IT = INIT - L
        IF (TEMP1.GE.X(IT)) GO TO 350
        DX = Y(IT) - YEYE - TEMP2*(X(IT)-XEYE)
        IF (ITCH.LT.0) TEST = E(IT)
        IF (ABS(DX).GT.TEST) GO TO 360
  340 CONTINUE
  350 CONTINUE
      U(J-1) = TEMP1
      V(J-1) = YEYE + TEMP2*(U(J-1)-XEYE)
      IF (IABS(ITCH).LT.3) W(J-1) = V(J-1)
      GO TO 390
  360 CONTINUE
      W(J-1) = YEYE + TEMP2*(U(J-1)-XEYE)
      GO TO 390
  370 CONTINUE
      IF (IABS(ITCH).LT.3) GO TO 360
  380 CONTINUE
      V(1) = YEYE + TEMP2*(U(1)-XEYE)
  390 CONTINUE
      SLOPE = TEMP2
      KP = KEEP
      IF (I.LT.N) GO TO 20
      IF (X(N).EQ.U(J)) GO TO 400
      IF (IABS(ITCH).LT.3) W(J) = V(J)
      J = J + 1
      U(J) = X(N)
      V(J) = Y(N)
  400 CONTINUE
      IF (J.GE.2 .AND. IABS(ITCH).LT.3) V(1) = W(1)
      K = J

* Truncate to integer values: indices at which to sample

      DO 500 I = 1, K
         u(i) = INT(u(i))
  500 CONTINUE

  600 CONTINUE
      RETURN
      END

      SUBROUTINE PIECEWISE3_CHECKGAP (Y, bad_y, x, u, i, j, 
     .   n, skipbad)
      REAL Y(*), bad_y, x(*), u(*)
      INTEGER i, j, n
      LOGICAL skipbad

      skipbad = .FALSE.
	 
      IF ( Y(i).EQ.bad_y ) THEN
	 IF (i.GT.2) THEN
	    u(j) = x(i-1)
	       
	    IF ( j .gt. 1 .and. INT(u(j)) .LT. INT(u(j-1)) ) then
	       j = j - 1
	       DO WHILE (INT(u(j)) .LE. INT(u(j-1)) )
		     j = j - 1
	       ENDDO	  
	       u(j) = x(i-1)
	    ENDIF
            IF ( j .gt. 1 .and. INT(u(j)) .EQ. INT(u(j-1)) ) j = j - 1

            j = j + 1
	 ENDIF
         DO WHILE ( Y(i).EQ.bad_y .AND. i.LT.n)
            i = i + 1
         ENDDO
         
         IF (i.GT.1) u(j) = x(i-1)
         IF (i.GE.n) THEN
	    i = n
	    u(j) = x(n)
	 ENDIF
         IF ( j .gt. 1 .and. INT(u(j)) .EQ. INT(u(j-1)) ) j = j - 1

         j = j + 1
         u(j) = x(i)
         IF ( j .gt. 1 .and. INT(u(j)) .EQ. INT(u(j-1)) ) j = j - 1

         j = j + 1
         skipbad = .TRUE.
      ENDIF

      RETURN
      END


      subroutine merge(a,na,b,nb,c,nout,nmax)
c http://en.wikibooks.org/wiki/Algorithm_Implementation/Sorting/Merge_sort#Fortran
! Normal usage: NA+NB = NC
! B overlays C(NA+1:NC)

! modified to return nout instead of assuming treating NC, length of C as known.

      integer  NA,NB,NC         
      REAL  A(*), B(*), C(*)
 
      integer I,J,K
 
      I = 1
      J = 1
      K = 1
      do while(I .LE. NA .and. J .LE. NB)
         if (A(I) .LE. B(J)) then
            C(K) = A(I)
            I = I+1
	    IF (I.GT.nmax) GOTO 100
         else
            C(K) = B(J)
            J = J+1
         endif
         K = K + 1
	 IF (K.GT.nmax) GOTO 100
      enddo
      do while (I .LE. NA)
         C(K) = A(I)
         I = I + 1
         K = K + 1
	 IF (K.GT.nmax) GOTO 100
      enddo
      do while (J .LE. NB)
         C(K) = B(J)
         J = J+1
         K = K + 1
	 IF (K.GT.nmax) GOTO 100
      enddo

* remove duplicates

 100  CONTINUE
      j = 1
      do i = 2, k
         IF (c(i) .GT. c(i-1)) then
	    j = j + 1
	    IF (j.GT.nmax) THEN
	       j = nmax
	       GOTO 200
	    ENDIF
	    c(j) = c(i)
	 endif
      enddo
 200  nout = j

      return
 
      end ! subroutine merge

	SUBROUTINE TRIM_AXIS_ENDS( uvar, exp_cx, imp_cx, idim, ww_lo, ww_hi )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Trim axis edges as for contour (and filled contour) plots
* from choose_cx_ww, implementing SHADE/TRIM

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V609:  2/20/22008
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction. The time 
*                  dimension is now an arg to SECS_TO_TSTEP.
* V695  *acm* 2/15 cx_calendar stores info about calendar formatting of T and F axes

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'command.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'

* calling argument declarations:
	INTEGER uvar, exp_cx, imp_cx, idim
	REAL*8	ww_lo, ww_hi

* internal variable declarations:
	INTEGER	imp_ndim, exp_ndim, imp_dim(4), exp_dim(4), grid,
     .		lo_edge, hi_edge
	REAL*8	TM_WORLD, SECS_TO_TSTEP, ww_low, ww_hiw

* initialize
* always use the grid carried with the data itself for ww/ss translations
	grid = cx_grid( imp_cx )

* default is to use the limits associated with the data itself
	ww_lo = cx_lo_ww(idim,imp_cx)
	ww_hi = cx_hi_ww(idim,imp_cx)
	lo_edge =  box_lo_lim
	hi_edge =  box_hi_lim

* trim as for contour (and filled contour) plots 

	ww_lo = MAX( ww_lo,
     .               TM_WORLD(cx_lo_ss(imp_cx,idim),grid,idim,
     .                        box_middle)                    )
	ww_hi = MIN( ww_hi,
     .               TM_WORLD(cx_hi_ss(imp_cx,idim),grid,idim,
     .                        box_middle)                    )

* contour expression has its own limits imbedded ?
	IF ( uvar_given(idim,uvar) .LT. uvlim_needed ) RETURN

* contour expression depends on command limits - use 'em
* (test for unspecified in case limits came from file information)
	IF ( cx_by_ss(idim,exp_cx) ) THEN
	   IF ( cx_lo_ss(exp_cx,idim).EQ.unspecified_int4 ) THEN
	      RETURN
	   ELSE
	      ww_lo = MAX(TM_WORLD(cx_lo_ss(exp_cx,idim),grid,idim,
     .                    lo_edge),
     .			  cx_lo_ww(idim,imp_cx) )
	      ww_hi = MIN(TM_WORLD(cx_hi_ss(exp_cx,idim),grid,idim,
     .                    hi_edge),
     .			  cx_hi_ww(idim,imp_cx) )
	   ENDIF
	ELSE
	   IF ( cx_lo_ww(idim,exp_cx).EQ.unspecified_val8 ) THEN
	      RETURN
	   ELSE
* ... explicit limits can further restrict, but not expand
* 8/97 *kob* - check cx_calender for a date time rather than ww_low
	      ww_low = cx_lo_ww( idim, exp_cx )
	      ww_hiw = cx_hi_ww( idim, exp_cx )
	      IF ( (idim.EQ.t_dim .OR. idim.EQ.f_dim) .AND. 
     .              cx_calendar(idim,exp_cx) ) THEN
	         ww_low = SECS_TO_TSTEP( grid, idim, -ww_low )  
	         ww_hiw = SECS_TO_TSTEP( grid, idim, -ww_hiw )  
	      ENDIF                                     
	      ww_lo = MAX( ww_low, ww_lo )
	      ww_hi = MIN( ww_hiw, ww_hi )
	   ENDIF
	ENDIF

	RETURN
	END

	SUBROUTINE REGRID_FROM_DSG_LIMS( dst_cx, src_cx, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* given a context describing data to be regridded FROM a destination DSG grid
* to a uniform axis along the feature orientation, set up the DSG source
* data context
* When called the source context should be a copy of the destination context 

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V720 *sh* 5/17
* V76  1/20 *acm* working with Point-type dsg data 

	include 'tmap_dims.parm'
	include 'implicit.parm'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'
	include	'xtext_info.cmn'
	include 'xdset_info.cmn_text'

* calling argument declarations:
	INTEGER	src_cx, dst_cx, status

* internal variable declarations:
	INTEGER	KNOWN_GRID,
     .		idim, src_grid

* initialize

* install the native grid for the source data
	src_grid = KNOWN_GRID( cx_data_set(src_cx),
     .			       cx_category(src_cx),
     .			       cx_variable(src_cx))
	cx_grid(src_cx) = src_grid
	cx_unstand_grid( src_cx ) = .FALSE.

* set it up as an ordinary DSG context -- preserve E and F from user settings
	DO idim = 1, 4
	   cx_lo_ww(idim,src_cx) = unspecified_val8
	   cx_hi_ww(idim,src_cx) = unspecified_val8
	ENDDO
	DO idim = 1, nferdims
	   CALL FLESH_OUT_AXIS( idim, src_cx, status )
	   IF (status .NE. ferr_ok) GOTO 5000
	ENDDO

* success
	RETURN

* error exit
 5000	RETURN

	END

	SUBROUTINE OFFSET_SS( idim, cx, lo_off, hi_off, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine offsets to subscripts of the specified axis needed to request
* a region of component data adequate to compute the result region

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  5/31/89 - based on CHG_PLANE_LIMS
* for Unix/RISC port 9/91 - added SHN,SPZ,SWL
* V230:  1/22/92 - added @WEQ and @RSUM
*        3/23/92 - added @FLN, @FNR
*         7/2/92 - changed @FLN, @FNR to off-edge (vs. window width)  
* V455:  9/97 - trap illegal offset arguments, return status
*	      - added transforms @CDA,CDB,CIA,CIB
* V533:  *sh* 6/01 - added @EVNT
* v552  4/03 *acm* up VAR_TRANS to 150 characters (variables are up to 128, plus
*                  space for the transformation specifier)
* V581: 3/05 *acm* Fix bug 1207: CDB, CIB, CDA, CIA are one-sided: return
*                  offset only in one direction.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V692 7/14 *acm* ticket 2183: handle @WGT transform as for integrals

        IMPLICIT NONE
* calling argument declarations:
	INTEGER idim, cx, lo_off, hi_off, status

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'

* internal variable declarations:
	LOGICAL	offset_supplied( 2:max_plane_transform )
	INTEGER	ioff, trans, lout,
     .		offset_lo   ( 2:max_plane_transform ),
     .		offset_hi   ( 2:max_plane_transform )
	REAL	arg
	CHARACTER*150 VAR_TRANS, buff

* pre-stored offsets needed for transformations
	DATA offset_lo  	( trans_integ_indef )	/  0  /,
     .	     offset_hi  	( trans_integ_indef )	/  0  /,
     .	     offset_supplied	( trans_integ_indef )	/ .FALSE. /,
     .
     .	     offset_lo   	( trans_smth_box )	/ -1  /,
     .	     offset_hi   	( trans_smth_box )	/ +1  /,
     .	     offset_supplied	( trans_smth_box )	/ .TRUE. /,
     .
     .	     offset_lo   	( trans_smth_max )	/ -1  /,
     .	     offset_hi   	( trans_smth_max )	/ +1  /,
     .	     offset_supplied	( trans_smth_max )	/ .TRUE. /,
     .
     .	     offset_lo   	( trans_smth_median )	/ -1  /,
     .	     offset_hi   	( trans_smth_median )	/ +1  /,
     .	     offset_supplied	( trans_smth_median )	/ .TRUE. /,
     .
     .	     offset_lo   	( trans_smth_min )	/ -1  /,
     .	     offset_hi   	( trans_smth_min )	/ +1  /,
     .	     offset_supplied	( trans_smth_min )	/ .TRUE. /,
     .
     .	     offset_lo   	( trans_deriv_cntr )	/ -1  /,
     .	     offset_hi   	( trans_deriv_cntr )	/ +1  /,
     .	     offset_supplied	( trans_deriv_cntr )	/ .FALSE. /,
     .
     .	     offset_lo   	( trans_deriv_fwrd )	/  0  /,
     .	     offset_hi   	( trans_deriv_fwrd )	/ +1  /,
     .	     offset_supplied	( trans_deriv_fwrd )	/ .FALSE. /,
     .
     .	     offset_lo   	( trans_deriv_bkwd )	/ -1  /,
     .	     offset_hi   	( trans_deriv_bkwd )	/  0  /,
     .	     offset_supplied	( trans_deriv_bkwd )	/ .FALSE. /,
     .
     .	     offset_lo   	( trans_subset )	/  0  /,
     .	     offset_hi   	( trans_subset )	/  0  /,
     .	     offset_supplied	( trans_subset )	/ .FALSE. /,
     .
     .	     offset_lo   	( trans_shift )		/ 1 /,
     .	     offset_hi   	( trans_shift )		/ 1 /,
     .	     offset_supplied	( trans_shift )		/ .TRUE. /,
     .
     .	     offset_lo   	( trans_fill_ave )	/ -1  /,
     .	     offset_hi   	( trans_fill_ave )	/ +1  /,
     .	     offset_supplied	( trans_fill_ave )	/ .TRUE. /,
     .
     .	     offset_lo   	( trans_smth_binml )	/ -1  /,
     .	     offset_hi   	( trans_smth_binml )	/ +1  /,
     .	     offset_supplied	( trans_smth_binml )	/ .TRUE. /,
     .
     .	     offset_lo   	( trans_smth_hanng )	/ -1  /,
     .	     offset_hi   	( trans_smth_hanng )	/ +1  /,
     .	     offset_supplied	( trans_smth_hanng )	/ .TRUE. /,
     .
     .	     offset_lo   	( trans_smth_parzn )	/ -1  /,
     .	     offset_hi   	( trans_smth_parzn )	/ +1  /,
     .	     offset_supplied	( trans_smth_parzn )	/ .TRUE. /,
     .
     .	     offset_lo   	( trans_smth_welch )	/ -1  /,
     .	     offset_hi   	( trans_smth_welch )	/ +1  /,
     .	     offset_supplied	( trans_smth_welch )	/ .TRUE. /,
     .
     .       offset_lo  	( trans_run_sum )	/  0  /,
     .	     offset_hi  	( trans_run_sum )	/  0  /,
     .	     offset_supplied	( trans_run_sum )	/ .FALSE. /,
     .
     .       offset_lo  	( trans_wgted_eq )	/  0  /,
     .	     offset_hi  	( trans_wgted_eq )	/  0  /,
     .	     offset_supplied	( trans_wgted_eq )	/ .FALSE. /,
     .
     .	     offset_lo   	( trans_fill_interp )	/ -1  /,
     .	     offset_hi   	( trans_fill_interp )	/ +1  /,
     .	     offset_supplied	( trans_fill_interp )	/ .TRUE. /,
     .
     .	     offset_lo   	( trans_fill_near )	/ -1  /,
     .	     offset_hi   	( trans_fill_near )	/ +1  /,
     .	     offset_supplied	( trans_fill_near )	/ .TRUE. /

	DATA offset_lo  	( trans_nrst_dist_abv )	/  -1 /,
     .	     offset_hi  	( trans_nrst_dist_abv )	/  +1 /,
     .	     offset_supplied	( trans_nrst_dist_abv )	/ .TRUE. /,
     .
     .	     offset_lo  	( trans_nrst_dist_blw )	/  -1 /,
     .	     offset_hi  	( trans_nrst_dist_blw )	/  +1 /,
     .	     offset_supplied	( trans_nrst_dist_blw )	/ .TRUE. /,
     .
     .	     offset_lo  	( trans_nrst_indx_abv )	/  -1 /,
     .	     offset_hi  	( trans_nrst_indx_abv )	/  +1 /,
     .	     offset_supplied	( trans_nrst_indx_abv )	/ .TRUE. /,
     .
     .	     offset_lo  	( trans_nrst_indx_blw )	/  -1 /,
     .	     offset_hi  	( trans_nrst_indx_blw )	/  +1 /,
     .	     offset_supplied	( trans_nrst_indx_blw )	/ .TRUE. /,
     .
     .	     offset_lo  	( trans_event_mask )	/  0 /,
     .	     offset_hi  	( trans_event_mask )	/  0 /,
     .	     offset_supplied	( trans_event_mask )	/ .FALSE. /,
     .
     .       offset_lo  	( trans_avg_wgt )	/  0  /,
     .	     offset_hi  	( trans_avg_wgt )	/  0  /,
     .	     offset_supplied	( trans_avg_wgt )	/ .FALSE. /,
     .
     .       offset_lo  	( trans_4d_avg_wgt )	/  0  /,
     .	     offset_hi  	( trans_4d_avg_wgt )	/  0  /,
     .	     offset_supplied	( trans_4d_avg_wgt )	/ .FALSE. /,
     .
     .	     offset_lo   	( trans_smth_box_p )	/ -1  /,
     .	     offset_hi   	( trans_smth_box_p )	/ +1  /,
     .	     offset_supplied	( trans_smth_box_p )	/ .TRUE. /

* --- end of introductory code ---
* initiailize
	trans = cx_trans    ( idim, cx )
	arg   = cx_trans_arg( idim, cx )
	status = ferr_ok

	IF ( offset_supplied(trans) .AND. arg.NE. bad_val4 ) THEN
* offset given explicitly by user (eg @SHF:-1)
	   ioff = INT( arg )
	   IF ( trans .EQ. trans_smth_box
     .	  . OR. trans .EQ. trans_smth_box_p
     .	  . OR. trans .EQ. trans_smth_binml
     .	  . OR. trans .EQ. trans_smth_hanng
     .	  . OR. trans .EQ. trans_smth_max
     .	  . OR. trans .EQ. trans_smth_median
     .	  . OR. trans .EQ. trans_smth_min
     .	  . OR. trans .EQ. trans_smth_parzn
     .	  . OR. trans .EQ. trans_smth_welch
     .	  . OR. trans .EQ. trans_fill_ave ) THEN
	      IF (ioff .LE. 0) GOTO 5100
	      hi_off = ioff / 2
	      lo_off = -hi_off
	   ELSEIF ( trans .EQ. trans_fill_interp
     .         .OR. trans .EQ. trans_fill_near     ) THEN  ! number of points 
	      IF (ioff .LE. 0) GOTO 5100
              hi_off = ioff                                ! past edge
              lo_off = -hi_off
	   ELSEIF ( trans .EQ. trans_shift ) THEN
	      hi_off = ioff
	      lo_off = ioff
	   ELSEIF ( trans .EQ. trans_nrst_dist_abv
     .	     .OR.   trans .EQ. trans_nrst_indx_abv ) THEN
	      IF (ioff .LE. 0) GOTO 5100
              hi_off = ioff 
              lo_off = 0
	   ELSEIF ( trans .EQ. trans_nrst_dist_blw
     .	      .OR.  trans .EQ. trans_nrst_indx_blw ) THEN
	      IF (ioff .LE. 0) GOTO 5100
              hi_off = 0
              lo_off = -1*ioff
	   ELSE
! temp - for debugging
	      WRITE (6,*) 'illegal plane transform', trans
	   ENDIF

	ELSE
* use default or standard offsets
	   lo_off = offset_lo( trans )
	   hi_off = offset_hi( trans )
	ENDIF

	RETURN

* error exits
 5000	RETURN
 5100	buff = VAR_TRANS(idim, cx, lout )
	CALL ERRMSG( ferr_invalid_command, status,
     .               'illegal transform argument: '//buff(:lout),
     .               *5000 )
 
	END

      SUBROUTINE ABPLT
                
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
****************************************************************
* revised for FERRET
* from PPLUS :
*	Directory PMEL:[PLOT5.LIBRARY.COMPLOT]
*	ABPLT.FOR;2               9   5-FEB-1985 11:33 
* search for "FERRET" to find all revisions
* *sh* 9/13/88 - rev 1.0 for FERRET 1.10+
*	- if GKS (ptype>2) then bypass clipping at screen limits
* 
* *kob* 3/02 - need to add sgi to ifdef statement 
****************************************************************
*     CALL ABPLT

*     THIS SUBROUTINE PERFORMS SCREEN CLIPPING AND THEN MOVES THE
*     PEN FROM THE CURRENT POSITION TO A NEW POINT.


******************************************************************
* FERRET mod - for explicit declarations - 9-13-88
C     DIMENSION AMXMN(2),BMXMN(2)
      REAL AMXMN(2),BMXMN(2), binter, ainter
      EQUIVALENCE (AMXMN(1),AMAX),(BMXMN(1),BMAX)

#ifdef unix
      include 'pltcom_dat.decl'
      include 'PLTCOM.DAT'
#else
      INCLUDE 'tmap_pplv11inc:tmap_PLTCOM.DAT'
      INCLUDE 'pplv11inc:pltcom.dat'
#endif
C end of FERRET mod
******************************************************************

C     CALCULATE THE NEW OFF-SCREEN FLAG.

******************************************************************
C FERRET mod - bypass GKS clipping - 9-13-88
      IF ( ptype .LT. 3 ) THEN
          OSFLG = 0
          IF(ANEW - 0.001 .GT. AMAX)OSFLG = 1
          IF(ANEW + 0.001 .LT. AMIN)OSFLG = 2
          IF(BNEW - 0.001 .GT. BMAX)OSFLG = OSFLG + 4
          IF(BNEW + 0.001 .LT. BMIN)OSFLG = OSFLG + 8
       ELSE
          OSFLG = 0
          losflg = 0            ! reset by many PPLUS routines
       ENDIF
* end of FERRET mod
******************************************************************

C     CHECK THE PEN POSITION.

       IF(.NOT. PENF)GO TO 90

C     CHECK THE PLOTTING MODE.

      IF(PMODE .EQ. POINT)GO TO 80

C     CHECK THE OLD AND NEW POINTS TO SEE IF THEY ARE BOTH OUT-
C     SIDE THE BOUNDARY OF THE SCREEN IN THE SAME DIRECTION.  IF
C     SO, NO INTERCEPT EXISTS.

#ifdef unix
# ifdef NEED_IAND
      IF(IAND(LOSFLG,OSFLG) .NE. 0)GO TO 100
# else
      IF(AND(LOSFLG,OSFLG) .NE. 0)GO TO 100
# endif
#else
      IF(IAND(LOSFLG,OSFLG) .NE. 0)GO TO 100
#endif
C     CHECK THE OLD POINT TO SEE IF IT IS WITHIN THE BOUNDARY OF
C     THE SCREEN.  IF NOT, COMPUTE THE INTERCEPT.

      IF(LOSFLG .EQ. 0)GO TO 30

C     CHECK THE HORIZONTAL LIMITS OF THE SCREEN.

#ifdef unix
# ifdef NEED_IAND
        if(ishft(losflg,-2) .eq. 0)goto 10
# else
        if(rshift(losflg,2) .eq. 0)goto 10
# endif
#else
        if(ishft(losflg,-2) .eq. 0)goto 10
#endif

C    THE POINT IS OUTSIDE THE HORIZONTAL LIMITS OF THE SCREEN.
C    CALCULATE THE INTERCEPT.
       
#ifdef unix
# ifdef NEED_IAND
        binter = bmxmn(ishft(losflg,-2))
# else
        binter = bmxmn(rshift(losflg,2))
# endif
#else
        binter = bmxmn(ishft(losflg,-2))
#endif
      AINTER = (ANEW - AOLD) * (BINTER - BOLD) / (BNEW - BOLD) +
     * AOLD
    
C     CHECK THE INTERCEPT TO INSURE THAT IT IS ON THE BOUNDARY
C     OF THE SCREEN.

      IF(AINTER + 0.001 .GE. AMIN .AND. AINTER - 0.001 .LE. AMAX)
     * GO TO 20

C     THE POINT IS OUTSIDE THE VERTICAL LIMITS OF THE SCREEN.
C     CALCULATE THE INTERCEPT.

#ifdef unix
# ifdef NEED_IAND
 10         ainter = amxmn(iand(losflg,3))
# else
 10         AINTER = AMXMN(AND(LOSFLG,3))
# endif
#else
 10         ainter = amxmn(iand(losflg,3))
#endif
      BINTER = (BNEW - BOLD) * (AINTER - AOLD) / (ANEW - AOLD) +
     * BOLD

C     CHECK THE INTERCEPT TO INSURE THAT IT IS ON THE BOUNDARY
C     OF THE SCREEN.

      IF(BINTER + 0.001 .LT. BMIN .OR. BINTER - 0.001 .GT. BMAX)
     * GO TO 100

C     PLOT TO THE INTERCEPT WITH THE PEN UP.

  20  A = AINTER - AMIN
      B = BINTER - BMIN
      PEN = .FALSE.
      CALL ABMV
      GO TO 40

C     CHECK THE OLD POINT TO SEE IF IT IS WITHIN THE BOUNDARY OF
C     THE WINDOW.  IF NOT, PLOT TO THE INTERCEPT WITH THE PEN UP.

  30  IF(LOWFLG .EQ. 0)GO TO 40
      A = AOLD - AMIN
      B = BOLD - BMIN
      PEN = .FALSE.
      CALL ABMV

C      CHECK THE NEW POINT TO SEE IF IT IS WITHIN THE BOUNDARY OF
C      THE SCREEN.  IF NOT, COMPUTE THE INTERCEPT.

  40  IF(OSFLG .EQ. 0)GO TO 70

C     CHECK THE HORIZONTAL LIMITS OF THE SCREEN.
#ifdef unix
#if defined sun || defined sgi
        if(rshift(osflg,2) .eq. 0)goto 50
#else
# ifdef NEED_IAND
        IF(ISHFT(OSFLG,-2) .EQ. 0)GO TO 50
# else
        IF(LSHIFT(OSFLG,-2) .EQ. 0)GO TO 50
# endif
#endif
#else
        IF(ISHFT(OSFLG,-2) .EQ. 0)GO TO 50
#endif

C     THE POINT IS OUTSIDE THE HORIZONTAL LIMITS OF THE SCREEN.
C     CALCULATE THE INTERCEPT.
#ifdef unix
#if defined sun || defined sgi
        binter = bmxmn(rshift(osflg,2))
#else
# ifdef NEED_IAND
        BINTER = BMXMN(ISHFT(OSFLG,-2))
# else
        BINTER = BMXMN(LSHIFT(OSFLG,-2))
# endif
#endif
#else
        BINTER = BMXMN(ISHFT(OSFLG,-2))
#endif
      AINTER = (ANEW - AOLD) * (BINTER - BOLD) / (BNEW - BOLD) +
     * AOLD

C     CHECK THE INTERCEPT TO INSURE THAT IT IS ON THE BOUNDARY
C     OF THE SCREEN.

      IF(AINTER + 0.001 .GE. AMIN .AND. AINTER - 0.001 .LE. AMAX)
     * GO TO 60

C     THE POINT IS OUTSIDE THE VERTICAL LIMITS OF THE SCREEN.
C     CALCULATE THE INTERCEPT.
#ifdef unix
# ifdef NEED_IAND
 50    AINTER = AMXMN(IAND(OSFLG,3))
# else
 50    AINTER = AMXMN(AND(OSFLG,3))
# endif
#else
 50    AINTER = AMXMN(IAND(OSFLG,3))
#endif
      BINTER = (BNEW - BOLD) * (AINTER - AOLD) / (ANEW - AOLD) +
     * BOLD

C     PLOT TO THE INTERCEPT WITH THE PEN DOWN.

  60  A = AINTER - AMIN
      B = BINTER - BMIN
      PEN = .TRUE.
      CALL ABMV
      GO TO 100

C     PLOT TO THE POINT WITH THE PEN DOWN.

  70  A = ANEW - AMIN
      B = BNEW - BMIN
      PEN = .TRUE.
      CALL ABMV
      GO TO 100

C     CHECK THE NEW POINT TO SEE IF IT IS WITHIN THE BOUNDARY OF
C     THE SCREEN.  IF NOT, DO NOT PLOT IT.

  80  IF(OSFLG .NE. 0)GO TO 100

C     PLOT TO THE POINT WITH THE PEN UP AND THEN DRAW A DOT.

      A = ANEW - AMIN
      B = BNEW - BMIN
      PEN = .FALSE.
      CALL ABMV
      PEN = .TRUE.
      CALL ABMV
      GO TO 100

C     CHECK THE NEW POINT TO SEE IF IT IS WITHIN THE BOUNDARY OF
C     THE SCREEN.  IF NOT, DO NOT PLOT IT.

  90  IF(OSFLG .NE. 0)GO TO 100

C     PLOT TO THE POINT WITH THE PEN UP.

      A = ANEW - AMIN
      B = BNEW - BMIN
      PEN = .FALSE.
      CALL ABMV

C     MOVE THE COORDINATES OF THE NEW POINT TO THE OLD POINT.

 100  AOLD = ANEW
      BOLD = BNEW
      AOSOLD = A
      BOSOLD = B
      LOSFLG = OSFLG
      RETURN

      END

	SUBROUTINE PACK_LINE_STORAGE (axis)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* For a line (axis) that has been deallocated, pack the coordinate memory array.

* ACM 6/11/2002
* V5.41 7/30/02 ACM Fix def of npoints. Also, move the pointer into 
*                   line_mem array when the coordinates in line_mem have
*                   been changed. 
* V600 10/28/05 ACM Fix bug 1354: We were moving way more coord data than needed
* V600 10/31/05 ACM Renamed from REMOVE_AXIS.F
*                   

* Parameters and commons

	include	'tmap_dims.parm'
#	include	"tmap_dset.parm"
	include 'xtm_grid.cmn_text'
        include 'ferret.parm'

* Argument declaration

        INTEGER axis

* Local declarations
	INTEGER  TM_GET_LINENUM, iaxis, imem, first_pt, last_pt, 
     .           npoints, n_to_move, num_protected_axes

	num_protected_axes = TM_GET_LINENUM( 'EZ' )  ! top protected axis

        IF (num_protected_axes .EQ. unspecified_int4 .OR.
     .      num_protected_axes .LE. 0) num_protected_axes = 1

* First index in this line, number of points in line

        first_pt = line_subsc1 ( axis )

*  Recover space in line_mem array that defines point locations, box sizes.
*  If this line is the last in the coordinate storage, move the pointer only.

        IF (first_pt .NE. unspecified_int4  .AND. 
     .      first_pt .NE. int4_init) THEN

           npoints = 2*line_dim(axis) + 1
           last_pt = first_pt + npoints

           n_to_move = next_line_mem_pos - last_pt

           IF (last_pt  .LT. next_line_mem_pos) THEN
              DO 200 imem = 1, n_to_move 
                 line_mem(first_pt+imem-1) = line_mem(last_pt+imem-1)
  200         CONTINUE
           ENDIF

*  For all axes whose line_mem entries were moved, also move the pointer 
*  into line_mem

           DO 300 iaxis = num_protected_axes+1, line_ceiling 
              IF ( (.NOT. line_regular(iaxis) ) .AND. 
     .              (line_subsc1(iaxis) .NE. unspecified_int4) ) THEN

                 IF (line_subsc1(iaxis) .GT. first_pt) 
     .            line_subsc1(iaxis) = line_subsc1(iaxis) - npoints

              ENDIF
  300      CONTINUE
  
           line_subsc1(axis) = unspecified_int4

           next_line_mem_pos = first_pt + n_to_move 

        ENDIF

	RETURN
	END

	SUBROUTINE CS_COMMAND( cmnd_line, * )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* this routine is called to get the next command when the program is under
* "internal" control (one command executing another)
* its function is to return the next command to execute or to flag that the
* internal level controlling the program has completed

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* revision 0.0 - 4/29/87
* revision 0.1 - 4/12/88 - allowed negative delta for time axis
* v300: 1/2/93 - incorporated cmnd_semicolon
* V320: 12/29/94 - use SPLIT_LIST to redirect tty output for GUI
* V420:  4/25/96 - added IF command
*
* 1/98 sh&kob
* "KNOWN BUG: The proper formatting of the REPEAT limit requires a 
*              knowledge of the grid of the result(see lohi_string.F). 
*              Since the grid is not determined until the first repeat 
*              loop is executed the formatting of the first loop may be
*              incorrect. Fixing this would require that a new set of 
*              world coordinate formatting routines be developed that 
*              do not depend on the grid. This seemed too much trouble 
*              given the small consequeunces."

* V510 *sh* 3/00 - interrupts need to be processed in here!!
*		   [IN FACT THIS TURNS OUT TO BE IRRELEVANT ... ]
* v522 *kob* 12/00 - add xplot_setup common file to check to see if we
*                    are animating
* v540 *kob* 1/02 - fix bug in which last animation plot wasn't being
*                   flushed to the screen
* v541 *kob* 8/02 - for animating, check for Xserver backingstore and
*                   don't animate if it's not set
* V554 1/04 *acm* - add cs_repeatname for named /RANGE loop control
* V600 5/06 *acm* - the call to new_gks_window needs window_title.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

        IMPLICIT NONE
* calling argument declarations:
	CHARACTER*(*)	cmnd_line
* RETURN 1 - used when no command can be supplied

* internal variable declarations:
	INTEGER	prev, status, limit, i, nparen
        CHARACTER CX_DIM_STR*40,anim_win_id*16,GKS_X_CONID*16
	INTEGER  TM_LENSTR1, slen, anim_id, bs, ws_id, tlen
        CHARACTER*48 TM_FMT, out_buff
        REAL    val
        LOGICAL range

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'command.parm'
	include 'xprog_state.cmn'
	include 'xcontext.cmn'
	include 'xcontrol.cmn'
        include 'xrisc.cmn'
	include 'xinterrupt.cmn'
	include 'xplot_setup.cmn'
	include 'xplot_state.cmn'
	include	'gkscm1_inc.decl'	! with gks common
	include	'GKSCM1.INC'	                ! with gks common
	include 'xtoday.cmn'		! with window_title

	IF ( interrupted ) THEN
* *kob* if we are animating, stop and reset active window
	   IF (animate .EQV. .TRUE.) THEN
	      animate = .FALSE.
	      CALL SWAP_ACTIVE_WINDOW
	   ENDIF
	   CALL ERRMSG( ferr_interrupt,status,' ', *1000 )

	ELSEIF ( cs_cmnd_num( csp ) .EQ. cmnd_repeat ) THEN

***** REPEAT loop *******
* done yet ?
           range = .FALSE.
	   IF ( (cs_limit(csp)-cs_phase(csp))*cs_delta(csp)
     .          .LT. 0.0 ) THEN
* ... yes
* *kob* check to see if we need to keep looping through animation
	      IF ( cs_loop(csp) .GT.1 ) THEN 
		 cs_phase( csp ) = cs_start( csp ) 
		 cs_loop( csp ) = cs_loop( csp) - 1 
		 cmnd_line = cs_text( csp ) 
		 CALL CS_SET_CONTEXT 
		 RETURN 1
	      ELSE
* *kob* repeat loop done so we are done animating.  reset active window
* 1/02 v5.4 - and also flush last plot to screen
		 IF (animate .EQV. .TRUE.) THEN
		    animate = .FALSE.
* flush last plot to screen
		    wsid = win_id9
		    anim_id = active_win_id
		    CALL COPY_BUFFERED_WINDOW(wsid, anim_id)
		    CALL CLEAR_WINDOW(wsid)
* reset active window
		    CALL SWAP_ACTIVE_WINDOW
		 ENDIF
		 CALL POP_CS
		 RETURN 1
	      ENDIF
	   ELSE
*       kob 12/00 - before we grab the next command, if we are animating lets
*             take the snapshot here
	      IF (animate .EQV. .TRUE.) THEN
		 IF (.NOT. first_frame) THEN
*       kob 8/02 - need to check and see if the X server has
*                  backing store turned on.  If not, give an
*                  error and stop animating.
		    DO ws_id = 1,max_windows
		       IF (wn_open(ws_id) ) GOTO 50
		    end do
		    CALL ERRMSG( ferr_invalid_command, status, 
     .                              'No graphics window open', *1000 )
 50		    CALL BACKING_STORE_ENABLED(ws_id, bs)
		    IF (bs .EQ. 1) THEN
		       IF (.NOT. wn_open(win_id9)) THEN 
*       * open an unmapped window
			  CALL UNMAP_ANIMATE_WINDOW
			  anim_win_id = GKS_X_CONID( win_id9 ) 
                          tlen = TM_LENSTR1(window_title)
			  CALL NEW_GKS_WINDOW( win_id9, anim_win_id, 
     .                       window_title(:tlen), status ) 
			  if (status .EQ. ferr_ok) wn_open(win_id9) = .TRUE.
			  CALL SETUP_LINE_BUNDLES( win_id9, wstype )
*       swap active windows so the unampped window becomes the active
*       window, and the newly created window is the animating window
			  CALL SWAP_ACTIVE_WINDOW
		       ELSE 
			  wsid = win_id9
			  anim_id = active_win_id
			  CALL COPY_BUFFERED_WINDOW(wsid, anim_id)
*       need to clear the double buffered unmapped window before next plot *kob*
			  CALL CLEAR_WINDOW(wsid)
		       ENDIF
		    ELSE
*       kob 8/02 - X server backing store not turned on so we
*                  can't animate
		       animate = .FALSE.
		       CALL ERRMSG( ferr_not_implemented, status, 
     .                  'Animations require X-server backingstore', *1000 )

		    ENDIF   
		 ELSE
		    first_frame = .false.
		 ENDIF   
	      ENDIF
*       ... no - get the next command
	      cmnd_line = cs_text( csp )
* ... set up the default context to evaluate the command
              range = (cs_repeatname( csp ) .NE. unspecified_name4)
	      IF (.NOT. range) CALL CS_SET_CONTEXT
              IF (range) THEN
                 val = cs_phase( csp )
                 out_buff = TM_FMT(val,10,10,len_rbuff)
              ENDIF

* ... prepare for next time around	   
	      cs_phase( csp ) = cs_phase( csp ) + cs_delta( csp )
	   ENDIF

* ... echo the progress so the operator can monitor
           IF ( mode_verify ) THEN
              IF (.NOT. range) THEN
                 risc_buff = CX_DIM_STR( cs_axis(csp), cx_last, ':',
     .             .TRUE., len_rbuff )
              
              ELSE
                 slen = TM_LENSTR1(cs_repeatname(csp))
                 risc_buff = cs_repeatname(csp)(1:slen)//':'//out_buff(1:len_rbuff)
                 len_rbuff = TM_LENSTR1(risc_buff)
               ENDIF

	      CALL SPLIT_LIST(pttmode_ops, ttout_lun, '!-> REPEAT: '
     .                           //risc_buff(1:len_rbuff), 12+len_rbuff)
           ENDIF

	ELSEIF ( cs_cmnd_num(csp) .EQ. cmnd_semicolon ) THEN

***** semicolon-separated command group
* initialize the extracting of a single command
           prev  = cs_phase(csp)
           limit = cs_limit(csp)

* done yet?
           IF ( prev .GE. limit ) THEN
* ... yes
	      CALL POP_CS
	      RETURN 1

	   ELSE
* ... no - get the next command (find semicolon NOT enclosed in parens)
              nparen = 0
              DO 100 i = prev+1, limit
                 IF ( cs_text(csp)(i:i) .EQ. '(' ) THEN
                    nparen = nparen + 1
                 ELSEIF ( cs_text(csp)(i:i) .EQ. ')' ) THEN
                    nparen = nparen - 1
                 ELSEIF ( cs_text(csp)(i:i) .EQ. ';' ) THEN
* ... found another semicolon-terminated command in group
                    IF ( nparen .EQ. 0 ) THEN
                       cmnd_line = cs_text(csp)(prev+1:i-1)
                       cs_phase(csp) = i
                       GOTO 1000
                    ENDIF
                 ENDIF
 100          CONTINUE
* ... last command in buffer
              cmnd_line = cs_text(csp)(prev+1:limit)
              cs_phase(csp) = limit
                   
	   ENDIF

* ****** conditional "IF" command

	ELSEIF ( cs_cmnd_num(csp) .EQ. cmnd_if ) THEN

* already done?
	   IF (cs_phase(csp) .GT. 0 ) THEN

* ... yes get outta here
	      CALL POP_CS
	      RETURN 1
	   ELSE

* ... no - get the next command
	      cmnd_line = cs_text( csp )
	      cs_phase(csp) = 1		! signal to POP after this command

	   ENDIF

* ***** unrecognized command in control of stack

        ELSE
           CALL ERRMSG( ferr_internal, status, 'command stack', *1000 )
        ENDIF

 1000   RETURN
	END

	SUBROUTINE CHARIN(STR,IN,PRMT,INPL)
C** 
C**    @(#)charin.F	1.2    5/26/88
C**
C**
C***********************************************************************
C**
C**		    PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C**	Subprogram called:
C**		CALL CHARIN(STR,IN,PRMP,INP)
C**
C**	Parameters:
C**		STR -- Output string (char*IN or byte(IN))
C**		IN -- Maximum input string length
C**		PRMP -- Prompt for terminal input
C**		INP -- Prompt lenght in characters
C**
C**	Description:
C**		CHARIN prompts the user for input from the terminal.
C**
C**	History:
C**	    Written: 
C**		15-DEC-1985	by Donald W. Denbo
C**	    Modified:
C**		30-MAY-1986	by Donald W. Denbo
C**		  Changes made for VAX/VMS version
C**
C**
C     Mod *JD* 3.5.91 problems with buffered terminal output in unix
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*     Mod *jd* 8.30.93 to handle FORTRAN read error you get w XGKS if the 
*	window is clicked with the mouse.
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
* v552 *acm* 3/03 Longer strings: changes for multi-line labels

#ifdef unix
	include 'CMDCOM.INC'
	include 'LUNITS.INC'
#else
	include 'pplv11inc:CMDCOM.INC'
	include 'pplv11inc:lunits.inc'
#endif
	character str*(*),prmt*(*)
#ifdef unix
	write(LTTOUT,999)prmt(:inpl)
C     Mod format *JD* 3.5.91 get problem with output held in buffer
# ifdef FORTRAN_90
999	format(a)
# else
999	format(1x,a,$) !original
# endif
C OK in Sun?? 999	format(a)
	call flush(LTTOUT)
C Leave this out JD 3.5.91	call flush(LTTOUT)
100	read(CMDLUN,998,err=100,end=100)str(:in)
998	format(a)
#else
        INTEGER*2 IOSB(4)
        BYTE INB(2048),PRMTB(30)
        INCLUDE '($IODEF)'
        STR=' '
        READ(PRMT,'(30A1)')PRMTB
        CALL SYS$ASSIGN('TT',CHAN,,)
        CALL SYS$QIOW(,%VAL(CHAN),%VAL(IO$_READPROMPT),IOSB,,,
     *  INB,%VAL(IN),,,PRMTB,%VAL(INP))
        CALL SYS$DASSGN(%VAL(CHAN))
        WRITE(STR,'(2048A1)')(INB(I),I=1,IOSB(2))
#endif
	RETURN
	END

        SUBROUTINE CD_GET_1_AXIS(dset, cdfid, ivar, iaxis, its_epic,
     .                           reversed, tregular, use_strict, 
     .                           bad_bndsid, has_gdef, status)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*.
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any puFrpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Load the common block XGRID with a single axis definition from a
* netCDF file

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 2/92
*   8/19/92: search for "LAT" in axis units was setup wrong
*  10/20/92: a more systematic approach to identifying the axis orientation
*  11/30/92:  changed Z axis orientation "UP" to "DU"
* 12/92: use TM_FPEQ_EPS to test regularity of axes
*  1/93: special error message for npts=0 (for UNLIMITED time axis in CDL)
*  2/93: allow zero length axis and out of order axes by substituting dummies
*  3/93: added EPIC support
*  4/93: bug fix: set default units if time_origin is read
* 10/93: EPIC longitudes now use "degree_east".  Allow west-encoded longitudes
*        for any data set using units like "degree west" or "positive=west".
*  8/94: for out of order coordinates 1) issue a max # of messages and 2)
*        allow strictly DECREASING coordinates by multiplying by -1
* 12/94: millibar and decibar (and all pressure) units should be UD 
*        allow "height" as a DU axis name
*  2/95: interpret time units like "hours since 1982-12-01 12:52:00"
*  2/95: note reverse-ordered coordinate axes in array "reversed"
*        and reverse the coordinates as saved
*        Also allow CDC-style yyyymmdd time format
* 10/95: if a longitude axis has 360 degrees then default to MODULO
* 11/95: recognize units "degrees_north" as a latitude
*  4/96: bug: millibar and decibar units identified by wrong constants
*  8/97: bug: X axis with "y" in axis name is mis-identified 
* 5/98 *kob* : mod so that CDC datafiles w/ two day offsets are compatible
*              w/ ferret.  
* V500 3/99 *sh*: instead of erroring out, simply return iaxis=0 for an
*       invalid coordinate axis -- to be handled by calling program
* V500 4/99 *kob*:  increase vname and vupcase from 24 to 64 chars 
* V510 *sh* 3/00 - added tregular argument
*                - convert to dynamic grids and axes
* V530 *sh* 1/01 - automatically flag as modulo any time axis that ends before
*                  year 0002
* V530 *acm* 12/00 attribute for different calendar types
*      *acm*  7/12/2001  correct for conflicts between prev two versions,
*                        somehow checked into CVS w/o proper merging
* V533 *acm*  8/30/01  change calendar name 360 to 360_day
*      *acm* 10/01  remove VMS includes
* V550 *sh*  2/02 - added support for line_modulo_len
*      *sh* 11/02 - automatically detect subspan modulo longitude and time axes
* V550 *acm*12/02 - AXIS and CARTESIAN_AXIS attributes, and modifications to
*                   order of precedence for axis orientation.
* V550 *acm* 1/03 - Account for differences in behavior of CD_GET_ATTVALC
*                   under OSF and PC.
* V552 *acm* 1/03 - error checking on value of calendar attribute.
* V552 *acm* 5/03 - increase vname and vupcase to 128 chars 
* V552 *acm* 6/03 - If AXIS attribute is set, put XX or YY in line_direction
*                   at first, then determine if the axis is longitude/latitude
* V552 *acm* 6/03 - calculate secsperyear using double precision arithmetic.
* V553 *acm* 7/03 - New code to read files with time axis encodings of:
*                      units: "days since -4713-01-01 00:00:00"
*                   The code detects the -4713 and replaces the time origin
*                   with 1-jan-1901.  Then subtract the correct number of days
*                   from the time coordinates: 2415386.  This is a file made
*                   by Matlab, which uses this "Julian" astromical date
*                   convention (different from our Julian calendar).  The 
*                   simple conversion is that May 23,1968 equals
*                   2440000 days.
* V554  *acm 12/03 Restore the last-ditch determination of line_direction
*                        using the starting letter of the axis.
* V570 *acm* 4/04  Add the calendar "all_leap", 366 days every year.
*                  also the name "365_DAY" as an equivalent to "NOLEAP" 
* V570 *acm* 5/04  Allow "bounds" attribute for defining an irregular axis.  Store
*                  all irregular axis intervals as Nx2 bounds rather than Nx1 edges.
*      *acm* 6/04  for compiler on rh7, need to pass dimensions of array into cd_rd_r8_bnds 
*                  as scalar integers not array elements.
*            6/18/04 Change order of operations so axes with edges are read the same as 
*                  in previous versions.  Also treat 1-point axes having bounds correctly
* V580 *acm* 10/04 Add a comment only, describing the hack to deal with CDC files starting 
*                  in 1-1-1 00:00:00
* V580 *acm* 11/04 Fix bug 1042 If bounds attribute has a problem found by TM_CHECK_BNDS_ATTRIB,
*                  just skip applying the bounds. The edges have been defined by putting them
*                  midway between coordinates; use this definition. If there is only one point 
*                  on the axis, then set it to be a regular axis.  
* V580 *acm* 11/04 further fixes for when there is just one point on an axis having bounds
*                  first_delta is meaningless and should not be used.
* V581 *acm*  1/05 Fixes for irreg axes with bounds: tm_check_bnds_centered now checks
*                  whether the coordinates are centered in the bound boxes, and whether
*                  the boxes are equal sized. Also fix def of d2e for reading axis bounds.
* V581 *acm*  2/05 Fix bug 1179: axis_dir .EQ. 'z' needs to be done as a case-insensitve
*                  comparison, in section testing positive=down.
* V581 *acm*  5/05 Fix bug 1231: check 'TT and 'TI' when applying tregular
* V581 *acm*  5/05 Fix bug 1232: if tregular, then dont try to use bounds
* V581*acm*  6/05  Fix for bug 1271, add flag line_shift_origin marking hack to shift axes 
*                   starting on 1-1-0001 (CDC files)
* V600 *acm* 10/05 TM_CHECK_BNDS_ATTRIB and TM_CHEC_EDGES_ATTRIB should not have 
*                  npts as an argument; npts from axis length was being reset
*                  as npts bounds or edges, which is npts+1
* V600 *acm* 11/05 Fix bug 1363: As is already done for years, named calendar with unit=month 
*                  gets assigned the length of month in that calendar.
* V600 *acm*  2/06 Fix bug 1394: if the time units contain a "since" but the remainder of
*                  the string is not a date, keep the whole units string.
* V600 *acm* 3/06  Fix bug 1400: Change in the call to TM_CHECK_BNDS
* V600 *acm* 8/05  attribute control. 
*                  Replace NCVID with CD_GET_VAR_ID
*                  Replace NCVINQ for variables, with CD_GET_VAR_INFO
*                  Change call to CD_GET_ATTRIB to NC_GET_ATTRIB - get attrib from 
*                  linked list structure
*                  CD_GET_ATTVAL replaced by NC_GET_ATTRIB, which now returns  
*                  strings or real values according to attrib type
* V600 *acm* 6/06  use TM_FPEQ_EPS to compare coordinates.
* V601 *acm* 9/19  Fix bug 1443; MAXLEN of bounds name should be NF_MAX_NAME from netcdf.inc
* V601 *acm* 9/19  Fix bug 1434; check bounds for regularly-spaced axes 
* V602 *acm* 1/07  Fix bug 1483; checking for irregularly spaced axis failed if the delta-coordinates
*                  on the axis varied by orders of magnitude.
* V602  2/07 *acm* Check upper and lowercase versions of axis (coordinate_axis) attribute
* V604  6/07 *acm* Further fixes for finely-spaced axes (see bug 1483); compute only one epsilion23
*                  for checking regularity of axes. For checking axis length of 360, use TM_FPEQ
*                  to allow for numerical accuracy of bounds for axes of exactly length360.
* V61   1/08 *acm* Fix bug 1559: Sanity-checking the modulo length can run into precision
*                  problems, in particular if the axis coordinates in the file are single-precision.
* V612  8/08 *acm* If the file has a point-spacing=uneven attribute, mark the axis as irreg
*                  and do not do all the testing for regular axis.
* V62  10/08 *acm* Add PROLEPTIC_GREGORIAN to the calendars recognized; same as GREGORIAN
* V62   2/09 *acm* Save the original upper/lowercase spelling of axis names in line_name_orig,
*                  for use on output of user-defined variables when MODE UPCASE_OUTPUT is cancelled.
* V63   7/09 *acm* Fix bug 1676 Reversed axis with EDGES 
* V65  *acm* 1/10  Make sure parameters values are consistent with 
*                              whats in netcdf.inc from netcdf4.
*      *kms* 5/10  Fix scaling/offset bug: using iaxis instead of i inside loops 334 and 336
*
* V67 *acm* 1/11   WE, SN, not XX, YY in line_direction
* V68 *acm* 1/12   Implement micro-adjusting of repeated coordinates (ticket 1910).
*                  To keep the previous behavior the user may specify USE/STRICT.
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files
* V6.83 12/12 *acm* ticket 1996: NOTE if reversing an axis
* V685 *acm* 1/13  Fix ticket 2026: dont automatically treat a 1-point longitude
*                  axis as modulo.
* V685 *acm* 8/13  Fix ticket 2088: Report the correct index location in axis when
*                  unrepairable repeated axis coords on axis
* V685 *acm* 8/13  Fix ticket 2090: If there is enough coord storage to read just the coords
*                  but not bounds, still read and check coordiantes for regular spacing.
* V685 *acm* 9/13  Move the NOTE about reversing a decreasing-ordered axis, so that
*                  it shows up for regularly spaced ones.
* V685 *acm* 11/13 REALLY make the check for axis length in single precision when the
*                  coordinate variable came in as a single-precision variable.
* V6.87 4/14 *acm* ticket 2146: if invalid bounds, make the bounds a dependent variale.
* V691  4/15 *acm* Ticket 2170: bub with invalid bounds when point-spacing=true attribute.
* Ticket 2172: If the axis is actually too long, reset the modulo flags
* so it is treated as not modulo.
* V694  5/15 *acm* Match precision for bounds checks (as is done for coords).
* V695+  5/15 *sh* allow "units='none'" as ignorable units string (for Andrew)
* V695+ 10/15 *sh* pass axis length instead of iaxis to TM_CHECK_BNDS_ATTRIB
* V698   4/16 *sh* recognize special E and F non-convertible axis units
* V698  5/16 *acm* for ticket 1432, could write a note when encountering a 
*                  supbspan modolo axis with length almost the modulo length.
*                  (commented out for now.)
* v7+   7/16 *acm* Ticket 2445, regular-spacing attribute and repeated or missing values
*                  in the first 2 coordinates
* V710  4/16 *acm* new TM_UNITS_CAL to account for calendar in units id
* V710  4/16 *acm* Remove the 2-day shift correction. CDC does not seem to 
*                  consistenly applythis logic to current files
* V71 12/16 *acm* Ticket 2158: working with true monthly time axes.
* V7022 1/17 *acm* ticket 2497, Back off the auto-detection of monthly axes.
* 1/13/2017 *acm* Do the repeated-coordinates checking in the new routine
*                 TM_CHECK_COORDS, also called by xeq_define, to consistently
*                 handle almost-equal coordinates, differing by machine precision.
* 1/24/2017 *acm* Ticket 2504: If Ferret is computuing axis bounds, set them such 
*                 that the axis lies within the given modulo length.
* 1/26/2017 *acm* Ticket 1480. change the message if the modulo length is 
*                 less than the axis length. The rest of that ticket is 
*                 addressed in cd_write_axis.
* v720 2/2017 *acm* Ticket 2513. Check that bounds or edges data is in the file when 
*                 attribute is found, before trying to use it.
* v720 3/2017 *acm* Ticket 2246. Call CD_GET_TIME_UNITS routine to get t0 date and time units 
* V72 6/17 *acm* For trac enhancement #767 -- dynamic coordinate storage 
* V73+ 12/17 *acm* Issue #1848: apply set_regular flag once the coordinates have been set up
* V74  ACM  2/2018 As in the DSG branch, pass line_direction(iaxis) to 
*                 cd_get_line_direction as an argument
* v743 9/2018 *acm* Issue 1894. Both point_spacing="even" and bounds are given. The axis
*                  coordinates/bounds are detected as uneven. Neither the coordinates
*                  nor line_start/ line_delta were set. In this case, treat it as irregular.
* v744 11/2011 *acm* Issue 1906: If PROLEPTIC_GREGORIAN is given then 
*                  override mixed-gregorian calendar handling. 
* v7441*acm* 12/18 Issue 1909,1919: ISO 8601 formatted dates and detecting
*                  mixed gregorian/julain calendar axes
* v7445*acm*  4/19 Issue 334: If there was a point_spacing = "even" attr, do more checking.
*                  But, if they've said USE/REGULART then go ahead and treat it as regular.
* v7445*acm*  4/19 Fix the calls to TM_SCALE 
* V7.51 *acm* 5/2019: Issue 1934: error with Epic file where east lons were treated as west
*
* argument definitions:
*       cdfid    - netCDF id number for already opened CDF file  (to go away with new attr. hanling)
*       dset     - dataset number for already opened CDF file
*       ivar     - netCDF variable id number
*       iaxis    - returned pointer to the axis created
*       its_epic - flags an EPIC netCDF data set
*       reversed    - logical array to record which axes have reversed coords
*       status   - return status

* include files
        include 'netcdf.inc'
        include 'tmap_errors.parm'
        include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
        include 'xbuild_grids.cmn'
        include 'xdset_info.cmn_text'
        external xdset_info_data
        include 'xio.cmn_text'
        external xio_data
        include 'xtm_grid.cmn_text'
        external xgt_grid_data
        include 'xunits.cmn_text'
        external xunits_data
        include 'calendar.decl'
        include 'calendar.cmn'
        include 'errmsg.parm'

* argument declarations
        LOGICAL  its_epic, reversed(max_lines:line_ceiling), tregular, 
     .           use_strict, has_gdef
        INTEGER  cdfid, dset, ivar, iaxis, bad_bndsid, status

* local parameter definitions:
      INTEGER     str_eq
      PARAMETER ( str_eq = 0 )

* local variable declarations:
      LOGICAL NC_GET_ATTRIB, CD_GET_ATTVAL,
     .        TM_HAS_STRING, TM_FPEQ_EPS, TM_DFPEQ, CD_GET_ATTVALC, 
     .        CD_GET_ATTVAL_L, TM_CHECK_BNDS, TM_CHECK_BNDS_CENTERED, 
     .        TM_FPEQ, TM_DFPEQ_TOL, NC_GET_ATTRIB_DP,
     .        got_it, got_torg, do_warn,
     .        epic_time, west_lon, yyyymmdd_time, 
     .        got_mod, mod_tf, setmodfalse, ok_cal, ok,
     .        got_edges, got_bnds, coordvar, its_irregular, 
     .        do_scale, do_offset, scale_is_dp, reg,
     .        has_repeated, misordered, has_missing, is_double, 
     .        true_month, okmod, edge_reg, set_regular, attr_regular

      INTEGER TM_UNIT_ID, TM_UNITS_CAL, TM_LENSTR1, TM_GET_CALENDAR_ID,      
     .        STR_CASE_BLIND_COMPARE, STR_UPCASE, STR_SAME,
     .        soft_err, 
     .        vartype, vback, npts, vlen, cdfstat, istat,
     .        nvdims, vdims(8), nvatts, i, units, npts_cdf, elen, 
     .        edgid, spacing_atlen, epic_t2var, since_T0,
     .        cal_id, year, month, day, hour, minute, second, slen,
     .        blen, bndid, startpts(2), numpts(2),
     .        d1s, d1e, d2s, d2e, attoutflag, maxlen,
     .        all_outflag, dir, attlen, itop, irev, attype, iatt, ibx1,
     .        i1, i2, i3, i0, npts2

      REAL    rbuff, delta, first_delta, val, val2, lm_len, 
     .        scale, offset, start
      REAL*4  r4delta
      REAL*8  TM_LONW2LONE, TM_WW_AXLEN, GET_LINE_COORD,
     .        tmp8, axwwlen, dscale, doffset,  micro_adj, madj
      CHARACTER*12 TM_LEFINT
      CHARACTER vname*128, ename*128, vupcase*128, words(8)*24,
     .        spacing_attr*14, bname*128
      CHARACTER*13 TM_STRING
      CHARACTER*1 axis_dir
      CHARACTER*2 dcode

      INTEGER tt  ! nice short name
      EQUIVALENCE (tt,lunit_errors)

      INTEGER bufflen
      PARAMETER (bufflen = 256)
      CHARACTER*256 buff
      REAL*8   TM_SECS_FROM_BC, first, secs2firststep, secs1590,
     .         t0_secs, last_coord, firs_coord, secsperyear, secs2start, 
     .         days_neg4713

* initialize for EPIC
      do_warn = .NOT.its_epic     ! EPIC files can get away with anything
      west_lon = .FALSE.          ! assume longitudes are positive east
      iaxis = 0

* gen; initialization
 
      got_torg = .FALSE.
      days_neg4713 = 0.D0
      bad_bndsid = 0
      cal_id = 1
      misordered = .FALSE.
      has_missing = .FALSE.



* get the vital statistics of the axis 

      CALL CD_GET_VAR_INFO (dset, ivar, vname, vartype, 
     .            nvdims, vdims, nvatts, coordvar, all_outflag, status)

      IF (status .NE. merr_ok) GOTO 5100
      vlen = TM_LENSTR1(vname)
      istat = STR_UPCASE( vupcase, vname )
!      IF ( nvdims .NE. 1 ) CALL TM_ERRMSG
!     .     ( cdfstat+pcdferrmax, status, 'CD_GET_1_AXIS', cdfid, ivar,
!     .     vname(:vlen), 'not a 1D variable', *5900 )

* get axis length:

      CALL CD_GET_DS_DIMS (dset, vdims(1), buff, npts_cdf, status)
      IF (status .NE. ferr_ok) GOTO 5100

! removed 3/93          IF ( npts_cdf .EQ. 0 ) GOTO 5150
      npts = npts_cdf      ! differ only if "true_size" is used

* grab a temporary dynamic axis slot for it
      CALL TM_ALLO_TMP_LINE(iaxis, status)
      IF (status .NE. merr_ok) GOTO 5900

* Store the data type of the axis

      line_dattype(iaxis) = vartype

* Are there scale_factor and/or add_offset attributes?  If so need to unpack
* the coordinate values

      scale = 1.
      dscale = 1.D0
      offset = 0.
      doffset = 0.D0
      maxlen = bufflen
      do_scale = NC_GET_ATTRIB(dset, ivar, 'scale_factor',
     .                       do_warn, vname(:vlen), maxlen, attlen, 
     .                       attoutflag, buff, scale)
     
      scale_is_dp = .FALSE.

      IF ( do_scale ) THEN
         CALL CD_GET_VAR_ATT_ID (dset, ivar, 'scale_factor', iatt, 
     .              status)
         IF (iatt .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, ivar, 
     .              iatt, buff, attype, attlen, attoutflag, istat )

         IF (attype .EQ. nf_double) THEN
             got_it = NC_GET_ATTRIB_DP(dset, ivar, 'scale_factor',
     .                       do_warn, vname(:vlen), attlen, 
     .                       attoutflag, dscale)
             scale_is_dp = .TRUE.
	 ENDIF
      ENDIF

      maxlen = bufflen
      do_offset = NC_GET_ATTRIB(dset, ivar, 'add_offset',
     .                       do_warn, vname(:vlen), maxlen, attlen, 
     .                       attoutflag, buff, offset)

      IF ( do_offset ) THEN
         CALL CD_GET_VAR_ATT_ID (dset, ivar, 'add_offset', iatt, 
     .              status)
         IF (iatt .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, ivar, 
     .              iatt, buff, attype, attlen, attoutflag, istat )

         IF (attype .EQ. nf_double) THEN
            got_it = NC_GET_ATTRIB_DP(dset, ivar, 'add_offset',
     .                       do_warn, vname(:vlen), attlen, 
     .                       attoutflag, doffset)
            IF (do_scale .AND. (.NOT. scale_is_dp))  GOTO 5400
     	 ELSE
	    IF (do_scale .AND. scale_is_dp)  GOTO 5400
     	 ENDIF

      ENDIF
      do_scale = do_scale .OR. do_offset
 
* optional point spacing parameter: even, uneven, disordered
      IF ( its_epic ) THEN
         spacing_attr = 'type'          ! type = "EVEN" or ="E"
         spacing_atlen = 4
      ELSE
         spacing_attr = 'point_spacing' ! point_spacing = "even"
         spacing_atlen = 13
      ENDIF

      maxlen = bufflen
      got_it = NC_GET_ATTRIB(dset, ivar, spacing_attr(1:spacing_atlen),
     .                       do_warn, vname(:vlen), maxlen, attlen, 
     .                       attoutflag, buff, val)

      line_regular(iaxis) = .FALSE.
      its_irregular = .FALSE.
      set_regular = .FALSE.
      attr_regular = .FALSE.

      IF ( got_it ) THEN
         line_regular(iaxis) = buff(1:1).EQ.'e' .OR. buff(1:1).EQ.'E'
         its_irregular = .NOT.line_regular(iaxis)
	 attr_regular = line_regular(iaxis)
      ELSE
         line_regular(iaxis) = .FALSE. ! default
      ENDIF

* Bounds or edges attribute?

      maxlen = 128
      got_bnds = NC_GET_ATTRIB( dset, ivar, 'bounds',
     .                       do_warn, vname(:vlen), maxlen, 
     .                       attlen, attoutflag, bname, val)
     
      got_edges = NC_GET_ATTRIB( dset, ivar, 'edges',
     .                       do_warn, vname(:vlen), maxlen,
     .                       attlen, attoutflag, ename, val)

* Cannot have both "edges" and "bounds" attributes
* Ticket 2513
* Check that the file has the bounds or edges listed in the attribute.
* Use bounds if they are in the file, else edges.

      IF ( got_bnds .AND. got_edges ) THEN
         bndid = 0
	 edgid = 0
	 CALL CD_GET_VAR_ID (dset, bname, bndid, status)
	 CALL CD_GET_VAR_ID (dset, ename, edgid, status)

* If bounds or edges are in the file, use bounds preferentially, else edges

	 IF (bndid + edgid .GT. 0) THEN
	    IF (bndid .GT. 0) THEN
               CALL TM_NOTE(
     .          'Axis has both edges and bounds attributes: '//
     .           vname(:vlen)//' - edges definition ignored', tt )
               got_bnds = .FALSE.
	    ENDIF
	    IF (edgid .GT. 0 .AND. bndid.EQ.0) THEN
               CALL TM_NOTE(
     .          'Axis has both edges and bounds attributes: '//
     .           vname(:vlen)//'. Bounds not in file. Ignore bounds definition', tt )
               got_bnds = .FALSE.
	    ENDIF
	 ENDIF ! at least one of bounds and edges is in the file
	 
* If attributes but not data for bounds/edges, issue a note	    
	 IF (bndid + edgid .EQ. 0) THEN
            CALL TM_NOTE(
     .           'Axis has both edges and bounds attributes: '//
     .           vname(:vlen)//'. Bounds and edges not in file, '//
     .           'ignore bounds and edges attributes', tt )
            got_bnds = .FALSE.
            got_edges = .FALSE.
	 ENDIF

      ENDIF

* We will be checking bounds or edges. Read the coords too
* in case we are going to mark the axis as irregular.

      IF (got_edges .OR. got_bnds) line_regular(iaxis) = .FALSE.

* optional "true_size" parameter for 2 point representations of even axes
      IF ( line_regular(iaxis) ) THEN

         got_it = NC_GET_ATTRIB( dset, ivar, 'true_size', 
     .                          do_warn, vname(:vlen), maxlen, 
     .                          attlen, attoutflag, buff, val)
         IF ( got_it ) THEN
            IF ( npts_cdf .NE. 2 ) THEN
               soft_err = 1
               GOTO 5000
            ENDIF
            npts = val
         ENDIF
      ENDIF
      line_dim( iaxis ) = npts

      IF (npts .LT. 2) line_regular(iaxis) = .TRUE.

* *ACM get the calendar name.

      line_cal_name(iaxis) = 'GREGORIAN'   ! default
      maxlen = bufflen
      got_it = NC_GET_ATTRIB( dset, ivar, 'calendar', do_warn,
     .                        vname(:vlen), maxlen, attlen, attoutflag, 
     .                        buff, val)
      IF (got_it) then
         CALL CD_GET_CALENDAR_NAME(buff, ok_cal)

         IF (ok_cal) THEN
	    line_cal_name(iaxis) = buff
	 ELSE
            slen = TM_LENSTR1(buff)
            CALL TM_NOTE('calendar attribute on axis "'//vupcase(:vlen)//
     .                '" is not recognized: '//buff(1:slen), tt)
            CALL TM_NOTE(
     .             'A dummy axis of subscripts will be used', tt)
            GOTO 1000
         ENDIF
      ENDIF
      cal_id = TM_GET_CALENDAR_ID (line_cal_name(iaxis))

* optional units for axis (may contain "tunits since T0_date" 2/95)
      line_units(iaxis) = ' '   ! default
      maxlen = bufflen
      got_it = NC_GET_ATTRIB( dset, ivar, 'units', do_warn,
     .                        vname(:vlen), maxlen, attlen, attoutflag, 
     .                        buff, val)
      IF (STR_SAME (buff(1:4), 'none') .EQ. 0) buff = ' ' ! units = 'none'
      since_T0 = MAX( INDEX(buff,'since'), INDEX(buff,'SINCE') )
      yyyymmdd_time = buff(1:15) .EQ. 'yyyymmddhhmmss'

      IF ( since_T0 .GT. 2 ) THEN
         line_units(iaxis) = buff(:since_T0-1)  ! just the "tunits" part 

         slen = TM_LENSTR1(buff)
         IF ( slen .GT. since_T0 + 5) THEN
	 
	    got_torg = .TRUE.
	    CALL CD_GET_TIME_UNITS (buff, cal_id, line_units(iaxis), 
     .			            line_t0(iaxis), days_neg4713, status)

c fix for bug 1394
c If the part after since is not a date/time, just keep the whole
c string as the units.  i.e., "days_since_event".

c           IF ( status .NE. merr_ok ) GOTO 1000        ! 3/99 soft error 

            IF ( status .NE. merr_ok ) THEN   
               line_units(iaxis) = buff(1:slen)
               got_torg = .FALSE.
               since_t0 = 0
               status = merr_ok
            ENDIF
         ELSE
            since_t0 = 0        ! flag that no T0 was present
         ENDIF
      ELSEIF ( yyyymmdd_time ) THEN
         line_units(iaxis) = 'days'
         line_t0(iaxis) = ' ' ! to be determined when coords are read
         got_torg = .TRUE.
      ELSE
         IF (got_it) line_units(iaxis) = buff
         got_torg = .FALSE.
      ENDIF

* EPIC time axes are encoded as 2 integers in variables TIME and TIME2
      IF ( its_epic .AND.  vupcase .EQ. 'TIME' ) THEN
         CALL CD_GET_VAR_ID ( dset, 'time2', epic_t2var, status)
         epic_time  = epic_t2var .NE. atom_not_found
      ELSE
         epic_time  = .FALSE.
      ENDIF
      IF ( epic_time ) line_units(iaxis) = 'Days'     ! arbitrary

* ... decode the units

      units = TM_UNIT_ID( line_units(iaxis) )

* Named calendar with unit=month or year gets length according to calendar's year length.

      units = TM_UNITS_CAL( units, cal_id, .FALSE. )

      line_unit_code(iaxis) = units
      IF  (   units.EQ.0
     .  .AND. line_units(iaxis) .NE. ' '
     .  .AND. line_units(iaxis) .NE. plag_ax_units_e
     .  .AND. line_units(iaxis) .NE. plag_ax_units_f ) THEN
         CALL TM_NOTE('Units on axis "'//vname(:vlen)//
     .                '" are not recognized: '//line_units(iaxis), tt)
         CALL TM_NOTE('They will not be convertible:', tt)
      ENDIF
      IF ( units .GE. 0 ) THEN
         line_tunit(iaxis) = real4_init
      ELSE
         line_tunit(iaxis) = un_convert(line_unit_code(iaxis))
      ENDIF

* optional "modulo" flag (and optionally the associated length)
      
      rbuff = 0.

*  **ACM** Note that under OSF (and PC? ) CD_GET_ATTVALC returns TRUE 
*      when the value of the attribute is, say, "F".  Under Solaris and 
*      Linux, returns FALSE  Reads a value from a character buffer if 
*      the value of the modulo attribute is type character. For solaris, 
*      linux, if the value of the attribue is non-numeric string, returns 
*      false, and rbuff=0. For OSF, returns true and rbuff = 0 or -1.

      line_modulo(iaxis) = CD_GET_ATTVALC( dset, ivar, 'modulo',
     .                             do_warn, vname(:vlen), rbuff, 0.0 )
      line_modulo_len(iaxis) = rbuff
      IF (line_modulo_len(iaxis) .LT. 0.) line_modulo_len(iaxis) = 0.

* See if there is a logical modulo attrib, with yes, true, false, etc.

      got_mod = .FALSE.
      mod_tf = .TRUE.

      IF (.NOT. line_modulo(iaxis) .OR. 
     .     line_modulo_len(iaxis) .LE. 0.) THEN
         got_mod = CD_GET_ATTVAL_L( dset, ivar, 'modulo',
     .                             do_warn, vname(:vlen),mod_tf)
         IF (got_mod) line_modulo(iaxis) = mod_tf

      ENDIF
      setmodfalse = (.NOT.mod_tf  .AND. got_mod)

* optional time_origin and time_unit values for time axis
* (time origin could have been set by the units "... since time_origin")
      maxlen = 20
      IF (.NOT.got_torg) got_torg = NC_GET_ATTRIB( dset, ivar,
     .          'time_origin', do_warn, vname(:vlen), maxlen, attlen, 
     .          attoutflag, line_t0(iaxis), val)
      IF ( .NOT.got_torg ) THEN
         IF ( epic_time ) THEN
            line_t0(iaxis) = '15-JAN-1901' ! arbitrary
         ELSEIF (since_t0 .LT. 2) THEN
            line_t0(iaxis) = char_init20
         ENDIF
      ENDIF

* a user can impose non-standard time units by setting the time_unit attribute
* (not fully tested, I suspect - *sh* 4/93)
      maxlen = bufflen
      got_it = NC_GET_ATTRIB( dset,ivar,'time_unit',
     .           do_warn, vname(:vlen), maxlen, attlen, attoutflag, 
     .           buff, line_tunit(iaxis))

*!      got_it = NC_GET_ATTRIB( dset,ivar,'month_lengths',do_warn,

* if a time_origin was given then some units are required (4/93)
* default to "seconds" if no units were specified
      IF ( got_torg .AND. line_tunit(iaxis).EQ.real4_init ) THEN
           line_units(iaxis) = 'seconds'
           line_unit_code(iaxis) = TM_UNIT_ID( line_units(iaxis) )
           line_tunit(iaxis) = un_convert(line_unit_code(iaxis))
      ENDIF

* Use attributes to try to determine the orientation and 
* direction of the axis

      CALL CD_GET_LINE_DIRECTION (dset, ivar, vname, line_units(iaxis),  
     .   do_warn, .TRUE., line_direction(iaxis))

* longitude axes may be encoded "west" (discontinuous at 180, East negative,
* West positive) or "east" (standard - 0->360 east from Greenwhich)

      got_it = NC_GET_ATTRIB( dset, ivar, 'positive', do_warn, 
     .                        vname(:vlen), maxlen, attlen, attoutflag, 
     .                        buff, val)
      IF ( got_it .AND. STR_CASE_BLIND_COMPARE('west',buff(:4))
     .                  .EQ.str_eq) THEN
            line_direction(iaxis) = 'WE'
            west_lon = .TRUE.                        ! convert encodings below
      ENDIF

* If there is a 'positive' attribute, see if it indicates west.


      IF (got_it) THEN
       west_lon = west_lon 
     .  .OR.    ( line_direction(iaxis) .EQ. 'WE'
     .      .AND. TM_HAS_STRING(buff,'west') )
     .  .OR.    ( its_epic
     .      .AND. (INDEX(vupcase, 'LON') .GT. 0)
     .      .AND. .NOT.TM_HAS_STRING(buff,'east') )
      ENDIF

* was a regular time axis forced on us by the user?
      IF (tregular) THEN 
        IF (line_direction(iaxis).EQ."TI" .OR.
     .      line_direction(iaxis).EQ."TT" ) line_regular(iaxis) = .TRUE.
        got_bnds = .FALSE.
	got_edges = .FALSE.
	its_irregular = .FALSE.
	set_regular = .TRUE.
      ENDIF

* get the axis coordinates - none, regular, or irregular

* Allocate line coordinate storage, put the pointer in array linemem(iaxis)
* and lineedg(iaxis) storage.

      CALL GET_LINE_DYNMEM (npts_cdf, iaxis, status) 
      IF (status .NE. merr_ok) GOTO 5900

      CALL PUT_LINE_COORD ( linemem(iaxis)%ptr, 1, 0.0 )

* If there was a point_spacing = "even" attr, do just a bit more checking.
* But, if they've said USE/REGULART then go ahead and treat it as regular.
* (ticket 334)

      IF (npts.GT.1 .AND. line_regular(iaxis) .AND. 
     .    attr_regular.AND.(.NOT.set_regular) ) THEN   

         IF ( epic_time ) THEN
               CALL CD_RD_EP_1( cdfid, ivar, epic_t2var, line_t0(iaxis),
     .                       line_tunit(iaxis), 1, val, status )
               IF ( status .NE. merr_ok ) GOTO 1000
               CALL CD_RD_EP_1( cdfid, ivar, epic_t2var, line_t0(iaxis),
     .                       line_tunit(iaxis), 2, val2, status )
         ELSEIF ( yyyymmdd_time ) THEN
               CALL CD_RD_YMD_1( cdfid, ivar, line_t0(iaxis),
     .                       line_tunit(iaxis), 1, val, status )
               IF ( status .NE. merr_ok ) GOTO 1000
               CALL CD_RD_YMD_1( cdfid, ivar,  line_t0(iaxis),
     .                       line_tunit(iaxis), 2, val2, status )
         ELSE
               CALL CD_RD_R8_1( cdfid, ivar, 1, vartype, vname(:vlen),
     .                       val, status )
               IF ( status .NE. merr_ok ) GOTO 1000
              CALL CD_RD_R8_1( cdfid, ivar, 2, vartype, vname(:vlen),
     .                       val2, status )
         ENDIF

         first_delta = ABS(val2-val)

         IF ( epic_time ) THEN
            CALL CD_RD_EP_1( cdfid, ivar, epic_t2var, line_t0(iaxis),
     .                       line_tunit(iaxis), npts_cdf, val2, status )
         ELSEIF ( yyyymmdd_time ) THEN
            CALL CD_RD_YMD_1( cdfid, ivar,  line_t0(iaxis),
     .                       line_tunit(iaxis), npts_cdf, val2, status )
         ELSE
            CALL CD_RD_R8_1( cdfid,ivar, npts_cdf, vartype, vname(:vlen),
     .                       val2, status )
         ENDIF

*  Do the first-delta and computed delta-coordinates agree?

         IF (is_double) THEN
            ok = TM_DFPEQ(first_delta, ABS(val2-val)/DBLE(npts-1) ) 
         ELSE
            ok = TM_FPEQ(first_delta, ABS(val2-val)/DBLE(npts-1) ) 
         ENDIF
         
	 IF (.NOT. ok ) THEN
            CALL TM_NOTE('Axis "'//vname(:vlen)//'" is irregular. Ignoring'//
     .        ' erroneous point_spacing=even attribute. ', tt)
	    line_regular(iaxis) = .FALSE.
	    attr_regular = .FALSE.

	 ENDIF
      ENDIF

      IF ( npts .EQ. 0 ) THEN
* create a dummy one point axis
         CALL TM_NOTE('Axis "'//vname(:vlen)//
     .                '" has no coordinates', tt)
         CALL TM_NOTE('A dummy value of 1 will be used', tt)
         line_start  (iaxis) = 1.0D0
         line_delta  (iaxis) = 1.0D0
         line_subsc1 (iaxis) = unspecified_int4
         line_regular(iaxis) = .TRUE.
         line_dim    (iaxis) = 11
         last_coord          = 1.0D0
         firs_coord          = 1.0D0

* start/n/delta representation for "regular axes"
* (no check is made on validity of the regularity claim)
* read the start and end - compute delta     
      ELSEIF ( line_regular(iaxis) ) THEN

         IF ( epic_time ) THEN
            CALL CD_RD_EP_1( cdfid, ivar,  epic_t2var, line_t0(iaxis),
     .                       line_tunit(iaxis), 1, 
     .                       line_start(iaxis), status )
            IF ( status .NE. merr_ok ) GOTO 1000        ! 3/99 soft error
            CALL CD_RD_EP_1( cdfid, ivar,  epic_t2var, line_t0(iaxis),
     .                       line_tunit(iaxis), npts_cdf, 
     .                       line_delta(iaxis), status )
         ELSEIF ( yyyymmdd_time ) THEN
            CALL CD_RD_YMD_1( cdfid, ivar, line_t0(iaxis),
     .                       line_tunit(iaxis), 1, 
     .                       line_start(iaxis), status )
            IF ( status .NE. merr_ok ) GOTO 1000        ! 3/99 soft error
            CALL CD_RD_YMD_1( cdfid, ivar,  line_t0(iaxis),
     .                       line_tunit(iaxis), npts_cdf, 
     .                       line_delta(iaxis), status )
         ELSE
            CALL CD_RD_R8_1( cdfid, ivar,   1, vartype, vname(:vlen),
     .                       line_start(iaxis), status )
            IF ( status .NE. merr_ok ) GOTO 1000        ! 3/99 soft error
            CALL CD_RD_R8_1( cdfid,ivar,npts_cdf,vartype,vname(:vlen),
     .                       line_delta(iaxis), status )
         ENDIF

         IF ( status .NE. merr_ok ) GOTO 1000   ! 3/99 soft error

* Invalid points. Cannot compute line_delta
         IF (ABS(line_start(iaxis)) .GE. ABS(bad_r8)   .OR. 
     .       ABS(line_delta(iaxis)) .GE. ABS(bad_r8) ) THEN 
	    misordered = .TRUE.
	    has_missing = .TRUE.
	    words(1) = '2'
	    GOTO 540
	 ENDIF

	 IF (do_scale) THEN
	    IF (scale_is_dp) THEN
	       line_start(iaxis) = line_start(iaxis)*dscale + doffset
	       line_delta(iaxis) = line_delta(iaxis)*dscale + doffset
	    ELSE
	       line_start(iaxis) = line_start(iaxis)*scale + offset
	       line_delta(iaxis) = line_delta(iaxis)*scale + offset
	    ENDIF
	 ENDIF

         IF ( west_lon ) THEN
            line_start(iaxis) = TM_LONW2LONE( line_start(iaxis) ) 
            line_delta(iaxis) = TM_LONW2LONE( line_delta(iaxis) ) 
         ENDIF
         IF ( npts .GT. 1 ) THEN
* ... allow for reverse ordering of axis coordinates on regular-spaced axes
*     (the variable line_delta actually contains line_end at this moment)
            reversed(iaxis) = line_delta(iaxis) .LT. line_start(iaxis)
            IF ( reversed(iaxis) ) THEN
               tmp8 = line_delta(iaxis)
               line_delta(iaxis) =
     .           (line_start(iaxis)-line_delta(iaxis))/DBLE(npts-1)
               line_start(iaxis) = tmp8
            ELSE
               line_delta(iaxis) =
     .           (line_delta(iaxis)-line_start(iaxis))/DBLE(npts-1)
            ENDIF
         ELSE
            reversed(iaxis) = .FALSE.
            line_delta(iaxis) = 1
         ENDIF

* Ticket 2445: repeated coordinates on axis marked as regular is an invalid axis
      
	 IF (line_delta(iaxis) .EQ. 0.) THEN
	    misordered = .TRUE.
	    words(1) = '2'
	    GOTO 540
	 ENDIF

         line_subsc1(iaxis) = unspecified_int4
         last_coord = line_start(iaxis) + DBLE(npts-1)*line_delta(iaxis)
         firs_coord = line_start(iaxis)


* ============= START OF IRREGULAR AXIS PROCESSING ========================
      ELSE 


* Read the coords and test for regular spacing. If regular then we're good. 
* If not, then compute the grid cell bounds.

         line_start(iaxis) = unspecified_val8
         line_delta(iaxis) = unspecified_val8


* read the CDF coordinate values into double precision axis storage
* Applying any scaling using TM_SCALE.  Coordinate data does not have missing-flags,
* send the default missing flag which should not match any valid coordinate data.

         IF ( epic_time ) THEN
            CALL CD_RD_EP_ARR( cdfid, ivar, epic_t2var,
     .                         line_t0(iaxis), line_tunit(iaxis),
     .                         npts_cdf, linemem(iaxis)%ptr, status )
         ELSEIF ( yyyymmdd_time ) THEN
            CALL CD_RD_YMD_ARR( cdfid, ivar,
     .                         line_t0(iaxis), line_tunit(iaxis),
     .                         npts_cdf, linemem(iaxis)%ptr, status )
         ELSE
            CALL CD_RD_R8_ARR( cdfid, ivar, 1, npts_cdf, vartype,
     .                         vname(:vlen), linemem(iaxis)%ptr, status )
            IF (days_neg4713 .NE. 0.) THEN
               offset = -1* days_neg4713
               CALL TM_SCALE (1.D0, -1* days_neg4713, bad_r8, 
     .                        linemem(iaxis)%ptr,  npts)
            ENDIF
         ENDIF
         IF ( status .NE. merr_ok ) GOTO 1000   ! 3/99 soft error
	 
	 IF (do_scale) THEN
	    IF (scale_is_dp) THEN
	       CALL TM_SCALE (dscale, doffset, bad_r8, 
     .                         linemem(iaxis)%ptr, npts)
	    ELSE
	       CALL TM_SCALE (scale, offset, bad_r8, 
     .                         linemem(iaxis)%ptr, npts)
	    ENDIF
	 ENDIF

         IF ( west_lon ) THEN
            CALL TM_LONW2E_LINE (linemem(iaxis)%ptr, npts)
         ENDIF
	 
         is_double = vartype .EQ. ncdouble


* Check for misordered or repeated data
* If repeated values, apply micro-adjusting, or report as a warning if the 
* user requested /STRICT.

* Check if axis is actually regularly spaced (though not flagged as "even")
* Use the precision of the data  in the file.

	CALL TM_CHECK_LINE ( linemem(iaxis)%ptr, npts, 
     .      reversed(iaxis), vname, vlen, is_double, its_irregular, 
     .      use_strict, line_regular(iaxis), misordered)
	IF (misordered) GOTO 1000

	IF (line_regular(iaxis)) THEN 
* yes, it's actually regular - save it as such
           line_start  (iaxis) = GET_LINE_COORD (linemem(iaxis)%ptr, 1)
           line_delta  (iaxis) = 
     .              ( GET_LINE_COORD (linemem(iaxis)%ptr, npts) - 
     .                line_start(iaxis) )/DBLE(npts-1)
           last_coord = line_start(iaxis) + DBLE(npts-1)*line_delta(iaxis)
           firs_coord = line_start(iaxis)

           GOTO 390
	ENDIF

* Compute the default locations of boundaries between grid boxes (midpoints)
* Note: this may be modified by a subsequent "EDGES" or "BOUNDS" definition
 
        CALL TM_IRREGAX_MID( linemem(iaxis)%ptr, lineedg(iaxis)%ptr, npts )
      ENDIF

* ============= END OF IRREGULAR AXIS PROCESSING ========================


 390  CONTINUE

* Notify user of reversal
* Dont issue the note if west_lon. 

      IF ( reversed(iaxis) .AND. (.NOT.west_lon)) THEN
         CALL TM_NOTE('Axis coordinates are decreasing-ordered. '//
     .         'Reversing ordering for axis '//vname(:vlen), tt)
      ENDIF

* 4/2016 remove this correction. CDC does not seem to consistenly apply
* this logic to current files

* hack to cope with Gregorian/Julian calendar ambiguities (used by NOAA/CDC)
* Comments from Roland Schweitzer about CDC files:
* These CDCfiles have units of the form: days since 1-1-1 00:00:00 or
* hours since 1-1-1 00:00:00.  Any of these files that encode dates
* after 1590 will look to Ferret as if they are offset by 2 days.  The 
* CDC axes shift around the time axis at various historical breaks as the
* UDUNITS package does. Ferret uses a proleptic Gregorian calendar - same
* for all time without these shifts. (Ferret uses udunits for units 
* definitions only.) Also note there are CDC files which decode to 
* fall entirely within year 0001.  These files represent a climatology,
* and Ferret deals with them correctly.
* 11/2018: If the calendar type is PROLEPTIC_GREGORIAN, then do not apply
*          the shift, even if it the origin is at 01-JAN-0001

      IF (since_T0.GT.2) CALL TM_BREAK_DATE(line_t0(iaxis), cal_id, 
     .       year, month, day, hour, minute, second, istat)
      IF ( (since_T0.GT.2) 
     .  .AND. (istat.EQ.merr_ok) 
     .  .AND. (year.EQ.1) .AND. (month.EQ.1) .AND. (day.EQ.1)
     .  .AND. (hour.EQ.0) .AND. (minute.EQ.0) .AND. (second.EQ.0) 
     .  .AND.(cal_id .EQ. GREGORIAN) ) THEN

* ... get time step of L=1
           IF ( line_regular(iaxis) ) THEN
              first = line_start(iaxis)   
           ELSE
              first = GET_LINE_COORD (lineedg(iaxis)%ptr, 1)
           ENDIF

* ... compute seconds from 1-jan-0001
           secs2firststep = un_convert(line_unit_code(iaxis)) * first
* compute seconds from 1590
           secs1590 = TM_SECS_FROM_BC (GREGORIAN, 1590,1,1,0,0,0,status)
            IF ( status .NE. merr_ok ) GOTO 5900

* ... correct axis if crosses 1590 threshold
           IF (secs2firststep .GT. secs1590) THEN
              line_t0(iaxis) = '30-DEC-0000 00:00:00'
              line_shift_origin(iaxis) = .TRUE.
           ENDIF
        ENDIF

*  See if there are box edges or bounds in the file.

****************************************************************************
*                              BOX EDGES                                   *
****************************************************************************

* the attribute "edges=name" may point to a list of box boundaries
      IF ( .NOT.got_edges ) GOTO 500

      CALL TM_CHECK_EDGES_ATTRIB (cdfid, iaxis, vname, vlen, ename, 
     .        edgid, status)

      IF (status .EQ. pcdferr) GO TO 5100

* Invalid edges, issue a note and use coordinate midpoints.
 
       IF (status .NE. merr_ok) THEN
         CALL TM_IRREGAX_MID( linemem(iaxis)%ptr, lineedg(iaxis)%ptr, npts )
         GO TO 600
      ENDIF

* read the (npts+1) box edge values into double precision storage

      CALL CD_RD_R8_ARR( cdfid, edgid, 1, npts+1, vartype,
     .                     vname(:vlen), lineedg(iaxis)%ptr, status )
      IF ( status .NE. merr_ok ) GOTO 1000    ! 3/99 soft error

* Check to see that each data point is contained inside its box.
* See if they're centered after all.

      CALL TM_CHECK_LINE_EDGES ( linemem(iaxis)%ptr, 
     .                   lineedg(iaxis)%ptr, npts, iaxis, reversed(iaxis), 
     .                   vname, vlen, is_double, edge_reg, ok)

      IF (.NOT. ok) THEN
           CALL TM_NOTE(
     .            'Error in Edges or edges do not enclose point on axis '//
     .             vname(:vlen), tt)
           CALL TM_NOTE('Substituting coordinate midpoints', tt)
           CALL TM_IRREGAX_MID( linemem(iaxis)%ptr, lineedg(iaxis)%ptr, npts  )
           bad_bndsid = edgid     
       ENDIF

* The axis had a point_spacing = "even" attribute and also edges.  We have found 
* the axis coordinate and/or edges themselves to be in fact irregular. So don't 
* later on apply the set_regular, which came from the point-spacing attribute.
* If the user said USE/REGULART then go ahead and still treat it as regular

      IF (ok .AND. attr_regular .AND. .NOT.edge_reg ) set_regular = .FALSE.

* It's actually regular - save it as such
      IF (edge_reg .AND. .NOT. line_regular(iaxis)) THEN
         line_regular(iaxis) = .TRUE.
         line_start  (iaxis) = GET_LINE_COORD (lineedg(iaxis)%ptr, 1)
         IF (npts .GT. 1) THEN
	      line_delta  (iaxis) = 
     .        (GET_LINE_COORD (lineedg(iaxis)%ptr, npts) - 
     .         GET_LINE_COORD (lineedg(iaxis)%ptr, 1) )/DBLE(npts-1)
         ELSE
	      line_delta  (iaxis) = 
     .        (GET_LINE_COORD (lineedg(iaxis)%ptr, npts+1) - 
     .         GET_LINE_COORD (lineedg(iaxis)%ptr, 1) )
         ENDIF
         last_coord = line_start(iaxis) + 
     .                DBLE(npts-1)*line_delta(iaxis)
         firs_coord = line_start(iaxis)
      ELSE
	 line_regular(iaxis) = .FALSE.
      ENDIF


****************************************************************************
*                              BOX BOUNDS                                  *
****************************************************************************

* the attribute "bounds=name" may point to a list of box boundaries

500   maxlen = 128
      IF ( .NOT.got_bnds ) GOTO 600

* Check the bounds variable, issue any warnings.
      CALL TM_CHECK_BNDS_ATTRIB (dset, line_dim(iaxis), vname, vlen,
     .                             bname, bndid, status)
      IF (status .EQ. pcdferr) GO TO 5100
      IF (status .NE. merr_ok) THEN
         IF (npts .EQ. 1) THEN  ! save as a regular axis, no bounds.
              line_regular(iaxis) = .TRUE.
              line_delta(iaxis) = 1
              line_subsc1 (iaxis) = unspecified_int4
              last_coord = line_start(iaxis) 
              firs_coord = line_start(iaxis)
         ENDIF
         ! If npts not 1 then we have already set the boundaries
         ! with CALL TM_IRREGAX_MID
         GO TO 600
      ENDIF

* read the (npts*2) box edge values into double precision storage 

      startpts(1) = 1
      startpts(2) = 1
      numpts(1) = 2
      numpts(2) = npts

      d1s = startpts(1)
      d1e = numpts(1)
      d2s = startpts(2)
      d2e = numpts(2)

* read the 2*npts box edge values into double precision storage
* Allocate line-edges coordinate storage, put the pointer in scratch 
* space lineedg(line_0). This will be redone into n+1 edges, so this
* allocation is temporary.

      npts2 = 2*npts
      CALL GET_LINE_DYNMEM (npts2, line_0, status)  
      IF (status .NE. merr_ok) GOTO 5900

      blen = TM_LENSTR1(bname)
      CALL CD_RD_R8_BNDS( cdfid, bndid, startpts, numpts, vartype, 
     .                    bname(:blen), lineedg(line_0)%ptr,  
     .                    d1s, d1e, d2s, d2e, status )
      IF ( status .NE. merr_ok ) GOTO 1000    ! 3/99 soft error

      IF (npts .EQ. 1) CALL PUT_LINE_COORD ( linemem(iaxis)%ptr, 1, line_start(iaxis) )
      CALL TM_CHECK_LINE_BOUNDS (linemem(iaxis)%ptr, 
     .                  lineedg(line_0)%ptr, npts, 
     .                  iaxis, reversed(iaxis), vname, vlen, 
     .                  is_double, line_regular(iaxis), ok)

      IF (.NOT.ok ) THEN
         CALL TM_NOTE('Error in bounds "'//bname(:blen)//
     .         '" or bounds do not enclose point on axis '//
     .         vname(:vlen), tt)
         CALL TM_NOTE('Substituting coordinate midpoints', tt)

         CALL TM_IRREGAX_MID( linemem(iaxis)%ptr, lineedg(iaxis)%ptr, npts )

	 bad_bndsid = bndid
      ENDIF

* The axis had a point_spacing = "even" attribute and also bounds.  We have found 
* the axis coordinate and/or bounds themselves to be in fact irregular. So don't 
* later on apply the set_regular, which came from the point-spacing attribute.

      IF (ok .AND. set_regular .AND. .NOT.line_regular(iaxis) ) set_regular = .FALSE.

      IF (ok .AND. .NOT.line_regular(iaxis)) THEN
	   
* Change from N*2 storage of bounds to N+1 edges.

         CALL TM_CONVERT_BOUNDS_EDGES (
     .                  lineedg(line_0)%ptr, 
     .                  lineedg(iaxis)%ptr, npts)

      ENDIF

* Use bounds to set the line_delta for regular axis.

      IF (ok .AND. line_regular(iaxis)) line_delta(iaxis) = 
     .   GET_LINE_COORD(lineedg(line_0)%ptr, 2) - GET_LINE_COORD(lineedg(line_0)%ptr, 1)

*  deallocate the temporary edge storage used to check bounds.
      CALL FREE_LINE_DYNMEM(line_0)

 600  CONTINUE

* All the checks for regular have been made. If regular, make sure we have set 
* line-start and line_delta, and deallocate the line storage....

      IF (set_regular) THEN
         IF (.NOT.line_regular(iaxis) .AND. npts.GT.1) THEN
	    line_start(iaxis) = GET_LINE_COORD(linemem(iaxis)%ptr, 1)
	    line_delta(iaxis) = GET_LINE_COORD(linemem(iaxis)%ptr, 2) - 
     .                          GET_LINE_COORD(linemem(iaxis)%ptr, 1)
	 ENDIF
	 line_regular(iaxis)= .TRUE.
      ENDIF

      IF (line_regular(iaxis)) CALL FREE_LINE_DYNMEM(iaxis)
 
* Check if axis is a monthly axis for this calendar.  If so store as a 'true-month' 
* axis, stored internally as if regular, but coordinates returned on true axis.
* Do not call this if the file has enhanced header, with parent and child grids. 
* (at least for now.)
* 1/13/2017 ticket 2497, Back off this auto-detection of monthly axes for now.


	true_month = .FALSE.
c	IF (line_direction(iaxis) .EQ. 'TI' .AND. 
c     .      .NOT.line_regular(iaxis) .AND.
c     .      .NOT.has_gdef ) 
c     .       CALL TM_CHECK_MONTHLY_AXIS (linemem(iaxis)%ptr, line_dim(iaxis), cal_id, 
c     .                                   line_t0(iaxis), units, line_units(iaxis),
c     .                                   start, delta, line_tunit(iaxis), true_month)
c
c        IF (true_month) THEN
c           line_regular(iaxis) = .TRUE.
c           line_start  (iaxis) = start !* line_tunit(iaxis)/ un_convert(pun_day)
c           line_delta  (iaxis) = delta
c           line_subsc1 (iaxis) = unspecified_int4
c           last_coord = line_start(iaxis) + DBLE(npts-1)*line_delta(iaxis)
c           firs_coord = start
c           line_unit_code (iaxis) = units
c           line_tunit  (iaxis) = un_convert(units)
c           got_edges = .FALSE.
c           got_bnds  = .FALSE.
c	ENDIF

* Save the axis name (upper case) and original axis name.   

        line_name(iaxis) = vupcase
        line_name_orig(iaxis) = vname

* if it is a longitude axis of 360 degrees or less let it default to MODULO
* unless user has set it explicitly to false.
        
 400    axwwlen = 0.
        axwwlen = TM_WW_AXLEN(iaxis)

        IF ( line_direction(iaxis).EQ.'WE'
     .       .AND. units.EQ.4
     .       .AND. (.NOT.setmodfalse)
     .       .AND. npts.GT.1 ) THEN

           r4delta = axwwlen ! single precision
           delta = r4delta
           IF (TM_FPEQ(delta, 360.0) .OR. delta .LT. 360.0) THEN
              line_modulo(iaxis) = .TRUE.
              IF (line_modulo_len(iaxis).EQ.0.0D0)
     .                    line_modulo_len(iaxis) = 360.D0
           ELSE

* Ticket 2504: Are the coordinates within a 360 deg but the bounds not?

              IF (.NOT.line_regular(iaxis)) THEN
	         IF (.NOT.got_bnds .AND. .NOT.got_edges .AND. 
     .               GET_LINE_COORD (lineedg(iaxis)%ptr, npts) - 
     .               GET_LINE_COORD (lineedg(iaxis)%ptr,1) .LE. 360.D0 ) THEN
	            CALL TM_ADJUST_BOUNDS(iaxis, npts, 360.0, axwwlen, okmod)
	            IF (okmod) THEN
		       line_modulo(iaxis) = .TRUE.
		       line_modulo_len(iaxis) = 360.D0
		    ENDIF
	         ENDIF
	      ENDIF
           ENDIF
        ENDIF

* if it is a calendar time axis and the first point is in year 0000 or 0001
* then it is implicitly MODULO

        IF (got_torg) THEN
           IF (line_direction(iaxis)(1:1).EQ.'T') line_direction(iaxis) = 'TI'
           IF (line_direction(iaxis)(1:1).EQ.'F') line_direction(iaxis) = 'FI'
c           secsperyear = cals_yeardays(cal_id)* 24*60*60
           tmp8 = cals_yeardays(cal_id)
           secsperyear = tmp8 * (24.D0*60.D0*60.D0)

           CALL TM_BREAK_DATE(line_t0(iaxis), cal_id, year, month, day,
     .                       hour, minute, second, istat)
           t0_secs = TM_SECS_FROM_BC (cal_id, year, month, day,
     .                               hour, minute, second, status)
           CALL TM_WW_AX_1_N(iaxis, first, tmp8)
 	   secs2start = t0_secs + first*line_tunit(iaxis)
           IF ( (secs2start .LE.  2*secsperyear)
     .	    .AND. (axwwlen*line_tunit(iaxis) .LE. secsperyear) ) THEN
              line_modulo(iaxis) = .TRUE.
              IF (line_modulo_len(iaxis).EQ.0.0D0)
     .          line_modulo_len(iaxis) = secsperyear/line_tunit(iaxis)

* Ticket 2504: Are the coordinates within a year but the bounds not?
           ELSEIF (.NOT.line_regular(iaxis) .AND. .NOT.got_bnds .AND. .NOT.got_edges) THEN  
	      delta = tmp8 - first
              IF ( (secs2start .LE.  2*secsperyear)
     .	           .AND. (delta*line_tunit(iaxis) .LE. secsperyear) ) THEN
	         CALL TM_ADJUST_BOUNDS(iaxis, npts, 
     .                 secsperyear/line_tunit(iaxis), axwwlen, okmod)

	         IF (okmod) THEN
		    line_modulo(iaxis) = .TRUE.
		    line_modulo_len(iaxis) = axwwlen
	         ENDIF
              ENDIF
           ENDIF
        ENDIF

* sanity check the modulo length

* Ticket 2504: If the coordinates lie within the modulo length but the auto-
* generated midpoint bounds make the axis too long, reset them so the axis 
* is the prescribed length. (may have been done for special cases above)

	IF (.NOT.line_regular(iaxis) .AND. line_modulo(iaxis) .AND. .NOT.got_bnds .AND. .NOT.got_edges) THEN
	   CALL TM_ADJUST_BOUNDS(iaxis, npts,  
     .                 line_modulo_len(iaxis), axwwlen, okmod)
	   IF (.NOT.okmod ) THEN
	      line_modulo(iaxis) = .FALSE.
	      line_modulo_len(iaxis) = 0.
	   ENDIF
	ENDIF

* a whisker too small is assumed a precision error
* a whisker larger is assumed to be deliberate
* ACM 1/08 
* If a whisker too large, this may be a precision error 
* In particular this happens converting single float coordinates to
* double coordinate storage. If coords are single precision do the 
* check in single precision.

* Ticket 2172: If the axis is actually too long, reset the modulo flags
* so it is treated as not modulo.
* Ticket 1480, change the message; the modulo length is invalid if 
* it's shorter than the axis.

        IF (line_modulo(iaxis).AND.line_modulo_len(iaxis).NE.0.D0) THEN
           IF (line_modulo_len(iaxis) .LT. axwwlen) THEN
             IF (is_double) THEN
                ok = TM_DFPEQ(axwwlen, line_modulo_len(iaxis)) 
             ELSE
	        lm_len = line_modulo_len(iaxis)
                delta = axwwlen ! single precision
		IF (vartype.NE.ncdouble) delta = r4delta
                ok = TM_FPEQ(delta, lm_len)
             ENDIF
             IF (.NOT.  ok) THEN
	        line_modulo_len(iaxis) = 0
		line_modulo(iaxis) = .FALSE.
                CALL TM_NOTE(
     .          'Ignored modulo length less than axis length: '
     .          //vname(:vlen), tt )
             ENDIF
           ENDIF
        ENDIF

* Write a note when subspan modulo axis length within a grid cell of modulo length
c	CALL TM_WARN_SUBSPAN (iaxis)

* Save the line direction in the linked-list structure for the coordinate variable

         dir = 0
         dcode = line_direction(iaxis)
         IF (dcode .EQ. 'XX' .OR. dcode .EQ. 'WE') dir = 1
         IF (dcode .EQ. 'YY' .OR. dcode .EQ. 'SN') dir = 2
         IF (dcode .EQ. 'ZZ' .OR. dcode .EQ. 'UD' .OR. dcode .EQ. 'DU') dir = 3
         IF (dcode .EQ. 'TT' .OR. dcode .EQ. 'TI') dir = 4
         IF (dcode .EQ. 'EE') dir = 5
         IF (dcode .EQ. 'FF' .OR. dcode .EQ. 'FI') dir = 6
         CALL CD_SET_ATT_AXDIR (dset, ivar, dir, status)

* successful completion
        status = merr_ok
        RETURN

 540	IF (misordered) THEN
	    IF (has_missing) THEN
	       CALL TM_NOTE(
     .           'Coordinates missing on axis '//
     .           vname(:vlen)//' at subscript '//words(1), tt)
	    ELSE
	       CALL TM_NOTE(
     .           'unrepairable repeated axis coords on axis '//
     .           vname(:vlen)//' at subscript '//words(1), tt)
	    ENDIF
	    CALL TM_NOTE(
     .           'A dummy axis of subscripts will be used', tt)

	 ENDIF

* 3/99-style "soft" error - invalid axis but CDF file need not be rejected
 1000   CONTINUE

	CALL TM_DEALLO_DYN_LINE(iaxis)
	CALL FREE_LINE_DYNMEM (iaxis)

        iaxis = 0
        status = merr_ok
        RETURN

* error messages
 5000   CALL TM_NOTE( 'netCDF parent axis definition error', tt )
        IF ( soft_err .EQ. 1 ) THEN
           CALL TM_NOTE(
     .    '"true_size" attribute must have only max/min axis coords: '
     .       //vname(:vlen), tt )
        ELSEIF ( soft_err .EQ. 11 ) THEN
           CALL TM_NOTE('Edges definition "'//ename(:elen)//
     .                   '" points to no existing axis', tt )
        ELSEIF ( soft_err .EQ. 12 ) THEN
           CALL TM_NOTE('Edges definition "'//ename(:elen)//
     .                   '" is not 1D', tt )
        ELSEIF ( soft_err .EQ. 13 ) THEN
           CALL TM_NOTE('Edges "'//ename(:elen)//
     .          '" must be 1 pt longer than '//vname(:vlen), tt )
        ENDIF
        IF ( soft_err .LE. 10 ) THEN
           CALL TM_NOTE( 'Axis definition ignored', tt )
        ELSE
           CALL TM_NOTE( 'Edge definitions ignored', tt )
        ENDIF
        GOTO 400

 5100   CALL TM_ERRMSG
     .     ( cdfstat+pcdferr, status, 'CD_GET_1_AXIS', cdfid, ivar,
     .       no_errstring, no_errstring, *5900 )

 5400   CALL TM_ERRMSG
     .     ( cdfstat+pcdferr, status, 'CD_GET_1_AXIS', cdfid, ivar,
     .       'Scale and offset attributes not of the same type', 
     .       no_errstring, *5900 )

* error exit
 5900   RETURN
        END

	subroutine smooth(z,nxs,nys,nx,ny,nsm) 
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)smooth.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
c     given array z(i,j),i=1,nx , j=1,ny   and nsm=0,1,2,3 ... 
c     laplacian smoothing is applied to z nsm times by means of the 
c     operation z=z + .25*(av(zn,zs,ze,zw)-z) . 
c     the sweep is alternately sw to ne and ne to sw. 
c     zxx and zyy are assumed to be zero at edges 
c     unused points in z should be .ge. 10**35 . 
c     oceanography emr   oct/69   version no. 2  improved edging 
c 
	dimension z(nxs,nys)
	if(nsm)400,400,20 
20	big=.9e35 
	r=.25/4. 
	do 330 it=1,nsm 
	itodd=it-(it/2)*2 
	do 300 ii=1,nx 
	i=itodd*ii+(1-itodd)*(nx+1-ii) 
	iintp=(i-1)*(nx-i) 
	do 300 jj=1,ny 
	j=itodd*jj+(1-itodd)*(ny+1-jj) 
	zij=z(i,j) 
	if(zij-big)210,210,300 
210	del2=0. 
	if(iintp)230,230,215 
215	del2x=z(i-1,j)+z(i+1,j)-zij-zij 
	if(del2x-big)220,230,230 
220	del2=del2x 
230	if((j-1)*(ny-j))250,250,235 
235	del2y=z(i,j-1)+z(i,j+1)-zij-zij 
	if(del2y-big)240,250,250 
240	del2=del2+del2y 
250	z(i,j)=zij+del2*r 
300	continue 
330	continue 
400	return 
	end 

	SUBROUTINE BAD_EDGES_SUB( cx,
     .		src, slox, shix, sloy, shiy, sloz, shiz, 
     .		slot, shit, sloe, shie, slof, shif, bad_src )


*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* context cx contains the limits of the valid data within array X
* fill the edges of array X with bad-data flags

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200: 10/16/89 - from BAD_EDGES
* V300:  3/16/93 - allow for possibility of entire region invalid
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'

* calling argument declarations:
	INTEGER cx, slox, shix, sloy, shiy, sloz, shiz, 
     .		slot, shit, sloe, shie, slof, shif
	REAL    src( slox:shix,sloy:shiy,sloz:shiz,slot:shit,sloe:shie,slof:shif )
	REAL	bad_src

* internal variable declarations:
	INTEGER	i, j, k, l, m, n, i_lo, j_lo, k_lo, l_lo, 
     .		m_lo, n_lo, i_hi, j_hi, k_hi, l_hi, m_hi, n_hi

* --- end of introductory code ---

* valid limits
	i_lo = cx_lo_s1(cx)
	j_lo = cx_lo_s2(cx)
	k_lo = cx_lo_s3(cx)
	l_lo = cx_lo_s4(cx)
	m_lo = cx_lo_s5(cx)
	n_lo = cx_lo_s6(cx)
	i_hi = cx_hi_s1(cx)
	j_hi = cx_hi_s2(cx)
	k_hi = cx_hi_s3(cx)
	l_hi = cx_hi_s4(cx)
	m_hi = cx_hi_s5(cx)
	n_hi = cx_hi_s6(cx)

* 3/93
* if a low valid limit exceeds a high limit then there must be no valid region
        IF ( i_lo .GT. i_hi
     .  .OR. j_lo .GT. j_hi
     .  .OR. k_lo .GT. k_hi
     .  .OR. l_lo .GT. l_hi
     .  .OR. m_lo .GT. m_hi
     .  .OR. n_lo .GT. n_hi ) THEN
* fill entire result with bad flags
	   DO 10 i = slox, shix
	   DO 10 j = sloy, shiy
	   DO 10 k = sloz, shiz
	   DO 10 l = slot, shit
	   DO 10 m = sloe, shie
	   DO 10 n = slof, shif
 10	   src(i,j,k,l,m,n) = bad_src
           RETURN
        ENDIF

* fill in along X axis
	DO 100 i = slox, i_lo-1
	DO 100 j = j_lo, j_hi
	DO 100 k = k_lo, k_hi
	DO 100 l = l_lo, l_hi
	DO 100 m = m_lo, m_hi
	DO 100 n = n_lo, n_hi
 100	src(i,j,k,l,m,n) = bad_src
	DO 110 i = i_hi+1, shix
	DO 110 j = j_lo, j_hi
	DO 110 k = k_lo, k_hi
	DO 110 l = l_lo, l_hi
	DO 110 m = m_lo, m_hi
	DO 110 n = n_lo, n_hi
 110	src(i,j,k,l,m,n) = bad_src

* fill in along Y axis
	DO 200 j = sloy, j_lo-1
	DO 200 i = i_lo, i_hi
	DO 200 k = k_lo, k_hi
	DO 200 l = l_lo, l_hi
	DO 200 m = m_lo, m_hi
	DO 200 n = n_lo, n_hi
 200	src(i,j,k,l,m,n) = bad_src
	DO 210 j = j_hi+1, shiy
	DO 210 i = i_lo, i_hi
	DO 210 k = k_lo, k_hi
	DO 210 l = l_lo, l_hi
	DO 210 m = m_lo, m_hi
	DO 210 n = n_lo, n_hi
 210	src(i,j,k,l,m,n) = bad_src

* fill in along Z axis
	DO 300 k = sloz, k_lo-1
	DO 300 i = i_lo, i_hi
	DO 300 j = j_lo, j_hi
	DO 300 l = l_lo, l_hi
	DO 300 m = m_lo, m_hi
	DO 300 n = n_lo, n_hi
 300	src(i,j,k,l,m,n) = bad_src
	DO 310 k = k_hi+1, shiz
	DO 310 i = i_lo, i_hi
	DO 310 j = j_lo, j_hi
	DO 310 l = l_lo, l_hi
	DO 310 m = m_lo, m_hi
	DO 310 n = n_lo, n_hi
 310	src(i,j,k,l,m,n) = bad_src

* fill in along T axis
	DO 400 l = slot, l_lo-1
	DO 400 i = i_lo, i_hi
	DO 400 j = j_lo, j_hi
	DO 400 k = k_lo, k_hi
	DO 400 m = m_lo, m_hi
	DO 400 n = n_lo, n_hi
 400	src(i,j,k,l,m,n) = bad_src
	DO 410 l = l_hi+1, shit
	DO 410 i = i_lo, i_hi
	DO 410 j = j_lo, j_hi
	DO 410 k = k_lo, k_hi
	DO 410 m = m_lo, m_hi
	DO 410 n = n_lo, n_hi
 410	src(i,j,k,l,m,n) = bad_src

* fill in along E axis
	DO 500 m = sloe, m_lo-1
	DO 500 i = i_lo, i_hi
	DO 500 j = j_lo, j_hi
	DO 500 l = l_lo, l_hi
	DO 500 k = k_lo, k_hi
	DO 500 n = n_lo, n_hi
 500	src(i,j,k,l,m,n) = bad_src
	DO 510 m = m_hi+1, shie
	DO 510 i = i_lo, i_hi
	DO 510 j = j_lo, j_hi
	DO 510 k = k_lo, k_hi
	DO 510 l = l_lo, l_hi
	DO 510 n = n_lo, n_hi
 510	src(i,j,k,l,m,n) = bad_src

* fill in along F axis
	DO 600 n = slof, n_lo-1
	DO 600 i = i_lo, i_hi
	DO 600 j = j_lo, j_hi
	DO 600 k = k_lo, k_hi
	DO 600 l = l_lo, l_hi
	DO 600 m = m_lo, m_hi
 600	src(i,j,k,l,m,n) = bad_src
	DO 610 n = n_hi+1, shif
	DO 610 i = i_lo, i_hi
	DO 610 j = j_lo, j_hi
	DO 610 k = k_lo, k_hi
	DO 610 l = l_lo, l_hi
	DO 610 m = m_lo, m_hi
 610	src(i,j,k,l,m,n) = bad_src

	RETURN
	END 

	SUBROUTINE SHOW_1_MR( mr, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* display a description of variable MR

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  6/12/89 - extracted from SHOW_MEM_VARS
*	 2/27/90 - changed VAR_CODE to *8
*	 3/30/90 - allow 6 digit subscripts
* Risc/UNIX port 4/91 *sh* cannot use functions in WRITE list
* V230:  11/4/92 - expanded variable name length
* V420: 11/95 - indicate un-cached variables
* V500 *kob* 3/99- up VAR_CODE and vname decl's to 64 chars
* V552 *acm* 4/03- up VAR_CODE and vname decl's from 64 to 128 chars
* V63  *acm* 10/09 Changes for gfortran build
* V650  Write to show_lun which may be set to a file unit number rather than std out
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V6.8  acm  6/12 Implement mode_6d_lab, set by default. If canceled, the 
*                 various SHOW commnands will not list info for E,F dimensions.
* V698  1/16 *sh* bug fix: the initial 6D trap was removing all possibility of
*		  showing 5D or 6D variables
* V7    acm  6/16 Ticket 2437: Deprecating mode_6d_lab. 
*		  Adjust output to 6-D or 4-D grids
* V702 *sh* 2/17  Reveal dynamic memory instead of block memory
*		  Increase field widths for long axes
* V720 *sh* 4/17  customize output to show a DSG mr
* V751 *acm* 6/19 Issue 1903: memory set and reported in terms of bytes

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'xdset_info.cmn_text'
	external xdset_info_data
	include	'ferret.parm'
	include 'xprog_state.cmn'
	include 'xvariables.cmn'
	include 'xtext_info.cmn'
	include 'xalgebra.cmn'
	include 'xrisc.cmn'          ! 12/94 SPLIT_LIST buffer
	include 'errmsg.parm'

* calling argument declarations:
	INTEGER	mr, status

* V500 *kob* 3/99- up VAR_CODE and vname decl's to 64 chars
* V552 *acm* 4/03- up VAR_CODE and vname decl's from 64 to 128 chars
* local variable declarations:
	LOGICAL	ITS_UN_CACHED, FOUR_D_GRID, TM_ITSA_DSG
	INTEGER TM_LENSTR1, MR_DIM_LEN, TM_DSG_DSET_FROM_GRID,
     .		idim, ndim, mrlen, mrsizelen, dset, listdims, grid
	INTEGER*8 mem
	CHARACTER VAR_CODE*128, ALG_TRANS_CODE*3, ARG_STRING*12, TM_FMT*48,
     .		  protection*4, shape*4, dname*14, gname*12, vname*128,
     .		  ww_lo(nferdims)*20, ww_hi(nferdims)*20, 
     .		  ss_lo(nferdims)*9, ss_hi(nferdims)*9,
     .		  mrbuf*4, mrsizebuf*16,
     .		  cache_stat*8, byte_unit*2

! DSGTBD Use dsg_xlate_grid wherever TRANSLATE_TO_WORLD is called in Ferret
* Get the grid to be use for formatting output
	grid = mr_grid(mr)
	IF (TM_ITSA_DSG(grid)) THEN
	   dset = TM_DSG_DSET_FROM_GRID(grid)
	   grid = dsg_xlate_grid(dset)
	ENDIF

* If mode 6d_lab has been canceled, we will list only the first 4 dimensions.
	listdims = nferdims
	IF ( .NOT. mode_6d_lab) listdims = 4
	status = ferr_ok
	IF ( FOUR_D_GRID(mr_grid(mr)) ) listdims = 4

* get shape
	shape = ' '
	ndim = 0

* If mode 6d_lab has been canceled, but the variable has dimension 5 or 6,
* that is an error
	DO 150 idim = listdims+1, nferdims
	   IF ( MR_DIM_LEN( idim, mr ) .GT. 1 ) GOTO 5100
 150	CONTINUE

	DO 170 idim = 1, listdims
	   IF ( MR_DIM_LEN( idim, mr ) .GT. 1 ) THEN
	      ndim = ndim + 1
	      shape(ndim:ndim) = ww_dim_name(idim)
	   ENDIF
 170	CONTINUE

* get formatted world positions
	DO 180 idim = 1, listdims
	   IF ( mr_lo_ww(idim,mr) .EQ. unspecified_val8 ) THEN
	      ww_lo(idim) = ' ...'
	      ww_hi(idim) = ' ...'
	   ELSE
	      CALL TRANSLATE_TO_WORLD
     .	           ( mr_lo_ww(idim,mr),idim,grid,
     .		     ax_dec_pt(idim), ww_lo(idim) )
	      CALL TRANSLATE_TO_WORLD
     .	           ( mr_hi_ww(idim,mr),idim,grid,
     .		     ax_dec_pt(idim), ww_hi(idim) )
	   ENDIF
	   IF ( mr_lo_ss(mr,idim) .EQ. unspecified_int4 ) THEN
	      ss_lo(idim) = '     ...'
	      ss_hi(idim) = '     ...'
	   ELSEIF ( mr_hi_ss(mr,idim) .GT. 9999 ) THEN
! not needed any longer ...
	      WRITE ( ss_lo(idim), '(I9)' ) mr_lo_ss(mr,idim)
	      WRITE ( ss_hi(idim), '(I9)' ) mr_hi_ss(mr,idim)
	   ELSE
	      WRITE ( ss_lo(idim), '(I9)' ) mr_lo_ss(mr,idim)
	      WRITE ( ss_hi(idim), '(I9)' ) mr_hi_ss(mr,idim)
	   ENDIF
 180	CONTINUE

* write a line summary of this memory variable
	IF ( mr_protected(mr) .EQ. mr_not_protected ) THEN
	   protection = ' '
	ELSEIF ( mr_protected(mr) .EQ. mr_perm_protected ) THEN
	   protection = 'PERM'
	ELSE
	   protection = '*ERR'
	ENDIF
	IF ( ITS_UN_CACHED(mr) ) THEN
	   cache_stat = 'UNCACHED'
	ELSE
	   cache_stat = ' '
	ENDIF
	vname = VAR_CODE( mr_category(mr),mr_variable(mr) )
	dset = mr_data_set(mr)
	IF ( dset .EQ. pdset_irrelevant ) THEN
	   dname = ' '
	ELSE
	   dname = 'D='//ds_name(dset)
	ENDIF
	IF ( mr_unstand_grid(mr) ) THEN
	   gname = grid_name(mr_grid(mr))
	   gname = ',G='//gname(:TM_LENSTR1(gname))//']'
	ELSE
	   gname = ']'
	ENDIF
	mrbuf      = TM_FMT( FLOAT(mr), 0, 4, mrlen )
	mrsizebuf  = TM_FMT( FLOAT(mr_size(mr)), 0, 8, mrsizelen )

	mem = mr_size(mr)

	CALL MEM_TO_BYTES (mem, mrsizebuf, mrsizelen, byte_unit)
	IF (mem .EQ. 0) byte_unit = ' '

	risc_buff  = ' '
	WRITE ( risc_buff, 3010 )	vname(:TM_LENSTR1(vname)),
     .					dname(:TM_LENSTR1(dname)),
     .					gname(:TM_LENSTR1(gname)),
     .					shape,
     .					mrbuf(:mrlen),
     .					mrsizebuf(:mrsizelen),
     .					byte_unit,
     .					protection,
     .					cache_stat

	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	risc_buff = ' '
	WRITE ( risc_buff, 3020 )
     .	  ( ss_lo(idim), ww_lo(idim), idim=1,listdims )
	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	risc_buff = ' '
	WRITE ( risc_buff, 3020 )
     .	  ( ss_hi(idim), ww_hi(idim), idim=1,listdims )
	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	risc_buff = ' '

* RISC compiler bug: cannot use character functions in WRITE statement
* ... use ww_lo and ss_lo as temporary buffers
        DO 200 idim = 1, listdims
           ss_lo(idim) = ALG_TRANS_CODE( mr_trans(idim,mr) )
           ww_lo(idim) = ARG_STRING( mr_trans_arg(idim,mr) )
 200    CONTINUE
	WRITE ( risc_buff, 3030 ) (ss_lo(idim), ww_lo(idim), idim = 1,listdims)

	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)

 3010	FORMAT(T2,A,'[',2A,T36,A4,'  mr:',A, ' size:', A, 1X,A2,1X,A4,1x,A8)
 3020	FORMAT(T2,5(A9,'/',A12),A9,'/',A12)
 3030	FORMAT(T2,6(4X,A3,A12))

 5000	RETURN
 5100	CALL ERRMSG( ferr_invalid_command, status,
     .		     'variable has more than 4 dimensions. Set mode 6D_LAB'
     .		     //pCR//'Output will automatically adjust to 4D or 6D grid'
     .		     //pCR//cmnd_buff(:len_cmnd),
     .			*5000 )
	END

*
* expnd_by_len_str.F
*
* Ansley Manke 08/2013
*
* This function takes a string variable and a set of lengths
* and returns the variable with element 1 repeated len1 times,
* then element 2 repeated len2 times, etc.
*

*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE expnd_by_len_str_init(id)

      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

      CALL ef_version_test(ef_version)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id, 
     . 'Returns a variable expanded by the lengths given in arg 2' )
      CALL ef_set_num_args(id, 3)
      CALL ef_set_axis_inheritance_6d(id, ABSTRACT, NORMAL, 
     .     NORMAL, NORMAL, NORMAL, NORMAL)
      CALL ef_set_result_type(id, STRING_RETURN)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'var')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg,'1D variable to expand')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, NO, NO)
      CALL ef_set_arg_type (id, arg, STRING_ARG)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'len')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 
     .     'lengths to expand each element of argument 1')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'nx')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 
     .      'length of result (sum of lengths in arg 2)')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

      SUBROUTINE expnd_by_len_str_result_limits(id)

      INCLUDE 'EF_Util.cmn'

      INTEGER id


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

* Get the size of the output axis from arg 3

      INTEGER nx, iarg
      REAL val

      iarg = 3
      CALL ef_get_one_val(id, iarg, val)
      nx = INT(val)

      call ef_set_axis_limits(id, X_AXIS, 1, nx)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE expnd_by_len_str_compute(id, arg_1, arg_2, arg_3, result)

      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif


      INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(strdf,
     .           mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit, 
     .           mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, 
     .           mem2loz:mem2hiz, mem2lot:mem2hit, 
     .           mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, 
     .           mem3loz:mem3hiz, mem3lot:mem3hit, 
     .           mem3loe:mem3hie, mem3lof:mem3hif)
      REAL result(strdf, 
     .            memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshiz, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(6), res_hi_ss(6), res_incr(6)
      INTEGER arg_lo_ss(6,1:EF_MAX_ARGS), arg_hi_ss(6,1:EF_MAX_ARGS),
     .     arg_incr(6,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l,m,n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2
      INTEGER count, indx, slen
      CHARACTER*100 errtxt
      CHARACTER*2048 buff
      REAL expnd_by_len_str

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* check that the lists are 1D

      errtxt = 'Argument 1 must be a 1D list'
      n = arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 1
      DO i = Y_AXIS, F_AXIS
         m = arg_hi_ss(i,ARG1) - arg_lo_ss(i,ARG1) + 1 
         IF (n.GT.1 .AND. m.GT.1) GOTO 9000
         n = MAX(n,m)
      ENDDO

      errtxt = 'Argument 2 must be a 1D list'
      n = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1
      DO i = Y_AXIS, F_AXIS
         m = arg_hi_ss(i,ARG2) - arg_lo_ss(i,ARG2) + 1
         IF (n.GT.1 .AND. m.GT.1) GOTO 9000
         n = MAX(n,m)
      ENDDO
      
* Put the requested features into the result

      i2=arg_lo_ss(X_AXIS,ARG2)
      j2=arg_lo_ss(Y_AXIS,ARG2)
      k2=arg_lo_ss(Z_AXIS,ARG2)
      l2=arg_lo_ss(T_AXIS,ARG2)
      m2=arg_lo_ss(E_AXIS,ARG2)
      n2=arg_lo_ss(F_AXIS,ARG2)

      i = res_lo_ss(X_AXIS)
      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      l = res_lo_ss(T_AXIS)
      m = res_lo_ss(E_AXIS)
      n = res_lo_ss(F_AXIS)

      DO 200 n1 = arg_lo_ss(F_AXIS,ARG1), arg_hi_ss(F_AXIS,ARG1)
      DO 200 m1 = arg_lo_ss(E_AXIS,ARG1), arg_hi_ss(E_AXIS,ARG1)
      DO 200 l1 = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)
      DO 200 k1 = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)
      DO 200 j1 = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)
      DO 200 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)
         IF ( arg_2(i2,j2,k2,l2,m2,n2) .NE. bad_flag(2) ) THEN
	    
            CALL ef_get_string_arg_element_6d(id, ARG1, arg_1, 
     .                      i1,j1,k1,l1,m1,n1, slen, buff)

            count = INT(arg_2(i2,j2,k2,l2,m2,n2))    ! number to replicate

            DO 100 indx = 1, count
               CALL EF_PUT_STRING(buff, slen, result(1,i,j,k,l,m,n))
               i = i + 1
 100        CONTINUE

         ENDIF  ! arg_2 bad

      i2 = i2 + arg_incr(X_AXIS,ARG2)
      j2 = j2 + arg_incr(Y_AXIS,ARG2)
      k2 = k2 + arg_incr(Z_AXIS,ARG2)
      l2 = l2 + arg_incr(T_AXIS,ARG2)
      m2 = m2 + arg_incr(E_AXIS,ARG2)
      n2 = n2 + arg_incr(F_AXIS,ARG2)
 200  CONTINUE

 300  CONTINUE
      
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
 9000 CALL EF_BAIL_OUT(id, errtxt)
      END

	SUBROUTINE COPY_INTO_MAPPED ( src, msrc, cxs,
     .				      sorted_indices, index_map, hilim,
     .				      axis, dst, mdst )

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* copy data from source grid into dstination grid using sorted_indices
* and index_map to guide the copy subscripts along axis "axis"
* The dstination grid is assumed big enough to hold the data

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V510: 8/99 *sh* - based on COPY_INTO
* V533: 7/01 *sh* - added string support
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'

* calling argument declarations:
	INTEGER msrc, cxs, mdst, axis, hilim
	REAL    sorted_indices( * ), index_map( * ), src( * ), dst( * )

* A typical scenario for the use of this routine might be as follows:
*   requested list of subscripts at which to sample: {17, 13, 15, 13}
*   sorted indices (derived from above):	      13, 13, 15, 17
*   index map -- from sorted to original:	      2, 4, 3, 1  

* The source data might contain VAR[I=13:15]  ("axis" = I)
* with "hilim" equal to 3 -- pointing to the upper limit in the sorted indices
*		and index map of the source data
 
* The job of this routine would be to copy I=15 of source into I=3 of result 
*	then throw away I=14
*	then copy I=13 of source into both I=4 and I=2 or result

	IF (mr_type(msrc) .EQ. ptype_string ) THEN
	  CALL COPY_PTR_INTO_MAPPED_SUB( cxs, axis, hilim,
     .			    sorted_indices, index_map,
     .			    src, mr_lo_s1(msrc), mr_hi_s1(msrc),
     .				 mr_lo_s2(msrc), mr_hi_s2(msrc),
     .				 mr_lo_s3(msrc), mr_hi_s3(msrc),
     .				 mr_lo_s4(msrc), mr_hi_s4(msrc),
     .				 mr_lo_s5(msrc), mr_hi_s5(msrc),
     .				 mr_lo_s6(msrc), mr_hi_s6(msrc),
     .			    dst, mr_lo_s1(mdst), mr_hi_s1(mdst),
     .				 mr_lo_s2(mdst), mr_hi_s2(mdst),
     .				 mr_lo_s3(mdst), mr_hi_s3(mdst),
     .				 mr_lo_s4(mdst), mr_hi_s4(mdst),
     .				 mr_lo_s5(mdst), mr_hi_s5(mdst),
     .				 mr_lo_s6(mdst), mr_hi_s6(mdst) )
	ELSE
	  CALL COPY_INTO_MAPPED_SUB( cxs, axis, hilim,
     .			    sorted_indices, index_map,
     .			    src, mr_lo_s1(msrc), mr_hi_s1(msrc),
     .				 mr_lo_s2(msrc), mr_hi_s2(msrc),
     .				 mr_lo_s3(msrc), mr_hi_s3(msrc),
     .				 mr_lo_s4(msrc), mr_hi_s4(msrc),
     .				 mr_lo_s5(msrc), mr_hi_s5(msrc),
     .				 mr_lo_s6(msrc), mr_hi_s6(msrc),
     .			    dst, mr_lo_s1(mdst), mr_hi_s1(mdst),
     .				 mr_lo_s2(mdst), mr_hi_s2(mdst),
     .				 mr_lo_s3(mdst), mr_hi_s3(mdst),
     .				 mr_lo_s4(mdst), mr_hi_s4(mdst),
     .				 mr_lo_s5(mdst), mr_hi_s5(mdst),
     .				 mr_lo_s6(mdst), mr_hi_s6(mdst) )
	ENDIF

	RETURN
	END 

	SUBROUTINE ERASE_DSET ( dset )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* delete all memory variables with data from a particular data set
* eliminate all context references to it, too

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 4/3/86
* V200:   6/9/89 - deleted variables flagged in mr_protected
*	10/25/89 - moved memory-resident purging to PURGE_DSET
* V411:  7/95 - Delete variables created with  LET/D=this_dset
* V601  11/06 - Also need to delete LET/D= variables from the linked-
*               list attribute structure.
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V695+ *sh* 5/15 - free any c-cached arrays owned by the dataset
* V698  2/16 *acm* For ticket 2352: variables defined with LET/D are
*                  added to that dataset in the attribute structure. Extra
*                  argument to DELETE_USER_VAR

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xdset_info.cmn_text'

* calling argument declarations:
	INTEGER dset

* local variable declarations:
	INTEGER TM_LENSTR, mr, ii, slen, flen, dset_uvars

      PARAMETER (flen=128)      ! size of variable name string
#ifdef sun
      BYTE      fhol(flen)      ! c-type Hollerith string buffer
#else
      INTEGER*1 fhol(flen)      ! c-type Hollerith string buffer
#endif 

* eliminate memory resident data
	CALL PURGE_DSET( dset )

* free any c-cached variables owned by this dataset
	DO ii = 1, maxvars
	   IF (ds_var_setnum(ii) .EQ. dset) THEN
	      IF (ds_var_c_cache_ptr(ii).NE.0.0) CALL FREE_CACHED_FULL_ARRAY
     .						(ds_var_c_cache_ptr(ii))
	   ENDIF
	ENDDO

* delete LET-defined variables that belong to this data set
	DO 100 ii = 1, max_uvar
*	   IF (uvar_dset(ii) .EQ. dset) uvar_num_items(ii) =
*     .					uvar_deleted
	   IF (uvar_dset(ii) .EQ. dset) THEN
	      CALL DELETE_USER_VAR(ii, dset)
              CALL deleted_list_modify(uvar_num_items_head, ii,
     .	            uvar_deleted)

* 6/16: This logic is now handled inside of DELETE_USER_VAR
!* Remove variable from linked-list structure, the user-variables dataset
!
!              slen = TM_LENSTR( uvar_name_code(ii)  )
!              IF (slen .GT. 0 .AND. uvar_name_code(ii)(1:3) .NE. 'EX#') THEN
!                 CALL TM_FTOC_STRNG( uvar_name_code(ii)(1:slen), fhol, flen )
!
!                 dset_uvars = pdset_uvars
!                 CALL NCF_DELETE_VAR (dset_uvars, fhol )
!              ENDIF

           ENDIF

 100	CONTINUE


* eliminate context information depending on this data set
	DO 200 ii = 1, max_context
	   IF ( cx_data_set( ii ) .EQ. dset ) THEN
	      cx_data_set( ii ) = unspecified_int4
	      cx_grid( ii ) = unspecified_int4
	   ENDIF
 200	CONTINUE

	RETURN
	END

	SUBROUTINE APPLY_CONTEXT_MODS
     .				( mods_cx, dest_cx, nest_new_cx, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* modify the indicated destination context based on mods in mods_cx
* apply only those modifications that can be done without for-certain knowledge
* of the underlying grid.  For example, translating subscript values into
* WORLD coordinates will be done in FINISH_CONTEXT_MODS instead of here

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 10/15/86
* revision 0.1 -   4/8/87 - mods not applied to normal axes
* revision 0.2 -  4/29/87 - fully incorporated relative (implied) coordinates
*			  - and added check on transformation nesting
* revision 0.3 - 5/12/87  - corrected bug of check being made to see if an axis
*			    was normal as a test for applying a mod.  This is
*			    invalid since the grid is not presumed to be known.
* revision 0.4 - 8/18/87  - added transfer of trans_arg (for @SHF)
* revision 0.5 - 9/11/87  - transfer delta only if command or if explicitly
*			    given in variable modifier
* revision 0.6 -  4/1/89  - apply regrididng transformations, too
* V200:  5/19/89 - no nested transformations possible
* 		 - eliminated "d" notation and "relative" logic
*		 - changed logic of cx_given and cx_dset_given
* V420: 9/95	 - Support for implicit grids
*	10/95	 - xfer delta specifications whenever mods to axis are explicit
*		 - also xfer cx_regrid_trans since dynamic axes may use
* *kob* 9/97 - support for negative time steps - make sure cx_calendar
*              gets transfered
* *acm* v580 11/04 Transfer cx_cal_id, the calendar ID used when computing 
*                  world coordinates
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V685 3/13 *sh* support for aux var regridding: var[gz(depth)=zax]
* V695  *acm* 2/15 cx_calendar stores info about calendar formatting of T and F axes

	IMPLICIT NONE

	include 'tmap_dims.parm'
	include 'errmsg.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
	include 'xtext_info.cmn'

* calling argument declarations:
	INTEGER	mods_cx, dest_cx, status
	LOGICAL	nest_new_cx

* internal variable declarations:
!	LOGICAL		itsa_uvar
	INTEGER		idim, var, trans, i
!	CHARACTER	ALG_TRANS_CODE*3

* first see if data_set or variable is being modified
	cx_dset_gvn( dest_cx ) = cx_dset_gvn( mods_cx )
	IF (cx_dset_gvn(mods_cx)) cx_data_set(dest_cx) = cx_data_set(mods_cx)
	IF ( cx_variable( mods_cx ) .NE. unspecified_int4 ) THEN
	   cx_variable( dest_cx ) = cx_variable( mods_cx )
	   cx_category( dest_cx ) = cx_category( mods_cx )
	ENDIF

* modify the grid if the user said to explicitly
	cx_unstand_grid ( dest_cx ) = cx_unstand_grid ( mods_cx )
	cx_has_impl_grid( dest_cx ) = cx_has_impl_grid( mods_cx )
	cx_has_impl_grid( mods_cx ) = .FALSE.	! house-keeping: only 1 cx SET
	cx_impl_grid    ( dest_cx ) = cx_impl_grid    ( mods_cx )
	IF ( cx_unstand_grid( mods_cx ) ) THEN
	   cx_grid( dest_cx ) = cx_grid( mods_cx )
	ENDIF
* ... apply regrid transform to each axis (some may be "unspecified")
	DO 50 idim = 1, nferdims
 50	cx_regrid_trans(idim,dest_cx) = cx_regrid_trans(idim,mods_cx)

* apply modifications for each axis ( except normal axes, of course )
	DO 100 idim = 1, nferdims
	   IF ( .NOT.cx_given( idim, mods_cx )	   )	GOTO 100

* ... "given" flag on dest context to represent limits (not transform) given
	   cx_given( idim, dest_cx ) = 
     .		cx_lo_ss( mods_cx, idim ) .NE. unspecified_int4
     .	   .OR. cx_lo_ww( idim, mods_cx ) .NE. unspecified_val8

* ... transfer coordinates if they were given (e.g. L=@SBX has no coords)
	   IF ( cx_given( idim, dest_cx ) ) THEN
	      cx_by_ss( idim, dest_cx ) = cx_by_ss( idim, mods_cx ) 
	      IF ( cx_by_ss( idim, mods_cx ) ) THEN
	         cx_lo_ss( dest_cx ,idim) = cx_lo_ss( mods_cx,idim)
	         cx_hi_ss( dest_cx ,idim) = cx_hi_ss( mods_cx,idim)
	         cx_lo_ww( idim,dest_cx ) = unspecified_val8
	         cx_hi_ww( idim,dest_cx ) = unspecified_val8
* kob 9/97 - need to reset cx_calendar as well
		 IF (idim.EQ.t_dim .OR. idim.EQ.f_dim) THEN
                    cx_calendar(idim,dest_cx) = .FALSE.
                    cx_cal_id(dest_cx) = unspecified_int4
                 ENDIF
	      ELSE
	         cx_lo_ww( idim,dest_cx ) = cx_lo_ww( idim,mods_cx)
	         cx_hi_ww( idim,dest_cx ) = cx_hi_ww( idim,mods_cx)
	         cx_lo_ss( dest_cx ,idim) = unspecified_int4
	         cx_hi_ss( dest_cx ,idim) = unspecified_int4
* kob 9/97 - need to transfer cx_calendar as well
		 IF (idim.EQ.t_dim .OR. idim.EQ.f_dim) THEN
                    cx_calendar(idim,dest_cx) = cx_calendar(idim,mods_cx)
                    cx_cal_id(dest_cx) = cx_cal_id(mods_cx)
                 ENDIF

	      ENDIF
	      cx_delta( idim, dest_cx )   = cx_delta( idim, mods_cx ) ! 10/95
	   ENDIF

*  ... transfer transformation ( imposes @nul if nothing was given )
	   trans = cx_trans(idim,mods_cx)
!	   IF ( itsa_uvar ) THEN
!* ... check for illegal nesting of transforms
!* (note: in V2.0 omitting this doesn't generate errors - just inappropriate
!*  behavior like @SBX on an @AVE axis generates a field of bad data)
!* ... cannot use because @SBX is valid on U-U[K=@AVE] although it is need_xact
!	     IF ( ( uvar_given( idim, var ) .EQ. uvlim_gvn_xact
!     .	       .OR. uvar_given( idim, var ) .EQ. uvlim_need_xact )
!     .	     .AND.( trans .NE. trans_no_transform ) ) GOTO 5100
!	   ENDIF
	   cx_trans   ( idim, dest_cx ) = trans
	   cx_trans_arg(idim, dest_cx ) = cx_trans_arg(idim, mods_cx )

*   ... transfer delta always for command mod or if explicit for variable mod
	   IF ( .NOT.nest_new_cx )
     .	   cx_delta( idim, dest_cx ) = cx_delta( idim, mods_cx ) 

 100	CONTINUE

* transfer aux var info
	cx_naux( dest_cx ) = cx_naux( mods_cx )
	IF ( cx_naux(dest_cx) .GE. 1 ) THEN
	   DO 200 i = 1, cx_naux( dest_cx )
	      cx_aux_arg_start(i, dest_cx) = cx_aux_arg_start(i, mods_cx)
	      cx_aux_arg_end  (i, dest_cx) = cx_aux_arg_end  (i, mods_cx)
 200	   CONTINUE
	ENDIF

	status = ferr_ok
 5000	RETURN
! 5100	CALL ERRMSG( ferr_trans_nest, status,
!     .		'invalid nesting of @'//ALG_TRANS_CODE(trans)//
!     .		' on '//ww_dim_name(idim)//' axis', *5000 )
	END

	SUBROUTINE RCVD_REGRID( src_cx, dst_cx, axis, work, 
     .				ok_min, ok_max, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* given the reveived ("rcvd") source context (of actually available data) and
* the requested output region determine the limits of the result that can be
* calculated

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V200:  12/1/89 - extracted from IS_REGRID
* 	 2/27/90 - if destination is unspecified set it from the source
* V230:  8/22/92 - special bypass for regridding by association
* V300:   5/5/93 - special check for source grid with only one point
*	         - and use single precision check comparing world coords
*	NOTE: sing. prec. check is risky - consistent w/ regridding algorithms?
* V402:	 8/16/95 - bug fix: T axis was **assumed** to be calendar
* V420:	   10/95 - determine regriddable limits for "window" transforms
*			such as min, max, ...
*	   11/95 - modulo regridding - source region independent of result
*	 1/96    - shifted @SUM and @NGD to weighted calcs like @AVE
* V490:9/97 *kob* - mods to include negative time axis processing
*   10/6/97  *sh* - added g=@xact regridding 
* V491:4/98  *sh* - bug fix: @ASN could lead to hi<lo limits
* V500: 2/99 *sh* - modified behavior when dest region is unspecified -- 
*		provide full dest axis limits rather than source-data driven
* V510: 1/00 *sh* - bug fix: destination subscript limits chosen incorrectly
*		for min, max, ave, etc.
*		  - bigger work array for DO_WINDOW_REGRID
* V530   3/01 *acm* alternative calendar axes:  Compare timesteps for source and
*		    destination axes with respect to one of the calendars.
* V530: 3/01 *sh* - added rgrd_nearest -- (unrestricted by source lims)
* V550: 2/02 *sh* - did NOT change CAXIS_LEN to CAXIS_MODLEN
*		    since subspan modulo default length is N not N+1
* v580 *acm* 11/04 Store cal_id in cx_cal_id, the calendar ID used when  
*                  computing world coordinates
* V671  6/11 *acm*  New 2D linear xy regridding, fixing ticket 1862
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction. The time 
*                  dimension is now an arg to SECS_TO_TSTEP. Note the input 
*                  argument "axis" in this routine is a dimension, 1, 2, ... 
* V696 *acm* 11/15 Added @BIN and @NBIN regridding transforms
* V720: 6/17 *acm* Ticket 2346: new @IIN regridding transform

        IMPLICIT NONE
* calling argument declarations:
	INTEGER	src_cx, dst_cx, axis, work, ok_min, ok_max, status

* internal variable declarations:
	LOGICAL GEOG_LABEL, ITSA_MODULO_REGRID, calendar, modulo,
     .		need_margin_check
	INTEGER ISUBSCRIPT, CAXIS_LEN, TM_GET_CALENDAR_ID,
     .		dst_where_loest, dst_where_hiest, rgrd_trans,
     .		src_where_loest, src_where_hiest,
     .		dst_ss_min, dst_ss_max,
     .		dst_grid, src_grid,
     .		dst_lo_ss, dst_hi_ss,
     .          src_taxis, dst_taxis, src_cal_id, dst_cal_id
	REAL*8	TWORLD, TM_WORLD, SECS_TO_TSTEP,
     .		src_lo_ww, src_hi_ww, dst_lo_ww, dst_hi_ww,
     .          tmp_lo_ww, tmp_hi_ww, s2d_lo_ww, s2d_hi_ww

	include 'tmap_dims.parm'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'

* initialize
	status = ferr_ok
	src_grid = cx_grid( src_cx )
	dst_grid = cx_grid( dst_cx )
* ... regrid calendar time axes? (src_grid was checked in rqst_regrid)
	calendar = (axis.EQ.t_dim .OR. axis.EQ.f_dim) .AND. GEOG_LABEL(axis,dst_grid)
	modulo = ITSA_MODULO_REGRID(dst_cx,axis)

* what is the regridding transformation for this axis ?
	rgrd_trans = cx_regrid_trans( axis, dst_cx )

* easy bypass for regridding by association
        IF ( rgrd_trans .EQ. prgrd_associate ) THEN
           CALL GRID_SUBSCRIPT_EXTREMES(dst_ss_min, dst_ss_max,
     .                                  dst_grid, axis)
           dst_lo_ss = MAX( cx_lo_ss(src_cx,axis), dst_ss_min )
           dst_hi_ss = MIN( cx_hi_ss(src_cx,axis), dst_ss_max )
	   IF (dst_lo_ss .GT. dst_hi_ss) dst_hi_ss = dst_lo_ss	! 4/98
           GOTO 500

* ... and easy bypass for regridding by modulo
* ... set default limits at 1 to n regardless
* ... (cant use GRID_SS_EXTR because of line_modulo)
        ELSEIF ( modulo ) THEN
           dst_lo_ss = 1
           dst_hi_ss = CAXIS_LEN(axis, dst_cx)
           GOTO 500
        ENDIF

* for interpolation we need source points surrounding the destination points
* for averaging     we need source area   surrounding the destination area
* for "window"ing   we need source area   containing  the destination area
* for exact match   we need source points aligning w/ the destination points
* for nrst match    do as for averaging
* for binning       do as for averaging
	IF ( rgrd_trans .EQ. prgrd_linear_interp
     .      .OR. rgrd_trans .EQ. prgrd_xy_lin ) THEN
	   dst_where_loest = box_middle
	   dst_where_hiest = box_middle
	   src_where_loest = box_middle
	   src_where_hiest = box_middle
	   need_margin_check = .TRUE.
	ELSEIF ( rgrd_trans .EQ. prgrd_min
     .	    .OR. rgrd_trans .EQ. prgrd_max ) THEN
	   dst_where_loest = box_lo_lim
	   dst_where_hiest = box_hi_lim
	   src_where_loest = box_middle
	   src_where_hiest = box_middle
	   need_margin_check = .FALSE.
	ELSEIF ( rgrd_trans .EQ. prgrd_xy_ave
     .      .OR. rgrd_trans .EQ. prgrd_variance
     .      .OR. rgrd_trans .EQ. prgrd_sum
     .      .OR. rgrd_trans .EQ. prgrd_good_pt
     .	    .OR. rgrd_trans .EQ. prgrd_average
     .	    .OR. rgrd_trans .EQ. prgrd_nearest
     .	    .OR. rgrd_trans .EQ. prgrd_bin
     .	    .OR. rgrd_trans .EQ. prgrd_nbin
     .	    .OR. rgrd_trans .EQ. prgrd_iin ) THEN   ! I think @iin is whole box
	   dst_where_loest = box_lo_lim
	   dst_where_hiest = box_hi_lim
	   src_where_loest = box_lo_lim
	   src_where_hiest = box_hi_lim
	   need_margin_check = .FALSE.
	ELSEIF ( rgrd_trans .EQ. prgrd_xact_pts
     .	    .OR. rgrd_trans .EQ. prgrd_nearest ) THEN
	   dst_where_loest = box_middle
	   dst_where_hiest = box_middle
	   src_where_loest = box_middle
	   src_where_hiest = box_middle
	   need_margin_check = .TRUE.
	ENDIF

* find the available source region for regridding
* NOTE:  times expressed as seconds since BC
	src_lo_ww = TWORLD(cx_lo_ss(src_cx,axis),src_grid,axis,
     .			   src_where_loest)
	src_hi_ww = TWORLD(cx_hi_ss(src_cx,axis),src_grid,axis,
     .			   src_where_hiest)

* find the corresponding subscripts on the destination grid
* 9/97 *kob* convert time in secs since BC to time position on the 
*             *source* time axis then call ISUBSCRIPT
	IF ( calendar ) THEN	! fixed 8/95

* 3/01 *acm* get timestep for source range relative to destination calendar.

	   src_taxis = grid_line(axis, src_grid)
	   src_cal_id = TM_GET_CALENDAR_ID (line_cal_name(src_taxis) )

	   dst_taxis = grid_line(axis, dst_grid)
	   dst_cal_id = TM_GET_CALENDAR_ID (line_cal_name(dst_taxis) )

	   IF (src_cal_id .NE. dst_cal_id) THEN
	      CALL reset_secs_from_bc (src_lo_ww, s2d_lo_ww, 
     .                                 src_cal_id, dst_cal_id, status)
	      IF ( status .NE. ferr_ok ) GOTO 5000
	      CALL reset_secs_from_bc (src_hi_ww, s2d_hi_ww, 
     .                                 src_cal_id, dst_cal_id, status)
	      IF ( status .NE. ferr_ok ) GOTO 5000
	   ELSE
              s2d_lo_ww = src_lo_ww
              s2d_hi_ww = src_hi_ww
	   ENDIF

	   tmp_lo_ww = SECS_TO_TSTEP(dst_grid, axis, s2d_lo_ww)
	   tmp_hi_ww = SECS_TO_TSTEP(dst_grid, axis, s2d_hi_ww)

	   dst_lo_ss = ISUBSCRIPT( tmp_lo_ww,dst_grid,axis,round_up )
	   dst_hi_ss = ISUBSCRIPT( tmp_hi_ww,dst_grid,axis,round_dn )
	ELSE
	   dst_lo_ss = ISUBSCRIPT( src_lo_ww,dst_grid,axis,round_up )
	   dst_hi_ss = ISUBSCRIPT( src_hi_ww,dst_grid,axis,round_dn )
	ENDIF


* determine whether destination edges can actually be regridded
* changed to sing. prec 5/93
	dst_lo_ww = TWORLD(dst_lo_ss,dst_grid,axis,dst_where_loest)
	dst_hi_ww = TWORLD(dst_hi_ss,dst_grid,axis,dst_where_hiest)
! 1/00 removed this check for G=@MIN, MAX, ...
!      IS IT NEEDED AT ALL???
	IF ( need_margin_check ) THEN

* 3/01 *acm* If different calendars, do comparison wrt dst calendar...

           IF (calendar .AND. src_cal_id .NE. dst_cal_id) THEN
	      CALL reset_secs_from_bc (src_lo_ww, tmp_lo_ww, 
     .                                 src_cal_id, dst_cal_id, status)
	      IF ( status .NE. ferr_ok ) GOTO 5000
	      CALL reset_secs_from_bc (src_hi_ww, tmp_hi_ww, 
     .                                 src_cal_id, dst_cal_id, status)
	      IF ( status .NE. ferr_ok ) GOTO 5000

	   ELSE
	      tmp_lo_ww = src_lo_ww
	      tmp_hi_ww = src_hi_ww
	   ENDIF
#ifdef double_p
	   IF ( (dst_lo_ww) .LT. (tmp_lo_ww) )
     .	                                dst_lo_ss = dst_lo_ss + 1
	   IF ( (dst_hi_ww) .GT. (tmp_hi_ww) )
     .                                  dst_hi_ss = dst_hi_ss - 1
#else
	   IF ( SNGL(dst_lo_ww) .LT. SNGL(tmp_lo_ww) )
     .	                                dst_lo_ss = dst_lo_ss + 1
	   IF ( SNGL(dst_hi_ww) .GT. SNGL(tmp_hi_ww) )
     .                                  dst_hi_ss = dst_hi_ss - 1
#endif
	ENDIF
	IF ( dst_lo_ss .GT. dst_hi_ss ) dst_hi_ss = dst_lo_ss  !bug chk 5/93

* if destination limits were unspecified set them to the full axis span
 500    IF ( cx_hi_ss(dst_cx,axis) .EQ. unspecified_int4 ) THEN
! pre 2/99 logic for unspecified limits
!	   cx_lo_ss(dst_cx,axis) = dst_lo_ss
!	   cx_hi_ss(dst_cx,axis) = dst_hi_ss
	   cx_lo_ss(dst_cx,axis) = 1
	   cx_hi_ss(dst_cx,axis) = CAXIS_LEN(axis, dst_cx)
	   cx_lo_ww(axis,dst_cx) = TM_WORLD( dst_lo_ss,
     .					     dst_grid, axis, box_lo_lim )
	   cx_hi_ww(axis,dst_cx) = TM_WORLD( dst_hi_ss,
     .					     dst_grid, axis, box_hi_lim )
           cx_cal_id(dst_cx) = dst_cal_id
	ENDIF

* even with sufficient source data we shouldn't exceed the requested region
        dst_ss_min = cx_lo_ss(dst_cx,axis)
	dst_ss_max = cx_hi_ss(dst_cx,axis)

* determine the limits that can actually be regridded
	IF ( modulo ) THEN
           ok_min = dst_ss_min		! can always regrid to full request
	   ok_max = dst_ss_max
	ELSE
           ok_min = MAX( dst_lo_ss, dst_ss_min )
	   ok_max = MIN( dst_hi_ss, dst_ss_max )
	ENDIF

* size of working arrays needed for later regridding
* 1/00 times two to accomodate @MIN, @MAX needs
	work = ( dst_hi_ss - dst_lo_ss + 2 ) * 2
	RETURN
* error exit
 5000	RETURN
	END	

	SUBROUTINE PPLCMD_F(ISI,ICMDIM,ICMSZE,pplmem)

c	SUBROUTINE PPLCMD_F(FROMI,LINEI,ISI,COMBUF,ICMDIM,ICMSZE,pplmem)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.   
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*

C**

C**    @(#)pplcmd.F   1.4    11/8/88 !Mod added 12.6.88 JD
C**    @(#)pplcmd.F   1.3     9/8/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
*       Modified 8.12.88 J Davison TMAP/JISAO/PMEL   
*       to include SHADE command.                    
*	J Davison 11.28.88 Modified for compatibility to v1.1 PPL
*	J Davison 05.04.89 Added pixmap call to capture color bitmap
*	J Davison 10.04.89 Added aline call to plot a line
*	J Davison 01.25.90 Modified CLSPLT to handle metafiles
*	J Davison 04.10.90 Mod to support 'PEN N,0' command => color index 0
*       J Davison 08.02.91 Mods to generate brain dead version of ppl
*       J Davison 11.15.91 Mod to support 'COLOR' command
*       J Davison 01.14.92 Mod to include AREA, SQFILL
*	*jd* 10.16.92 Mod to add save & restore function for pen command
*	*tc* 01.26.93 Mod to handle draftsman and spline_tension with
*	     CONSET command.  use variables 9 (spl_ten) and 10 (drman).
*	     by the way, the array size of p and iflg is 20 in cmrd.inc so
*	     a command can handle up to 20 inputs.
*	J Davison 11.09.93 Mod to add segments to advanced commands
*	J Davison 01.06.94 Mod to use PLTNME to set metafile name
*	J Davison 01.25.94 Mod to call PPLGFLUSH to flush output at each call
*	J Davison 11.19.95 Mod for 4 digit year capability
*	J Davison 11.29.95 Mod for century axis
*	J Davison 10.15.98 Mod for pattern support: PATSET
*       *jd* VVV  02.16.99 Mod to bring two versions of PPLCMD in line VVV
*	S Hankin  11.25.97 Mod to add commands PLOTPOL and FILLPOL
*       kob 9.98 - add external statement to force linker to find
*                  block data statments
*       J Davison 10.14.99 Mod to add CALENDAR command for multiple calendars
* V510: *sh* 3/0 - bug fix: TXLABP 0 was interpreted as TXLABP 1 cuz
*		of SIGN() call near top of this routine
*       ACM 10/2000  Add VECTOR/FLOWLINE, alias FLOWLINE 
* V530: *acm* 1/01 calendar info in calendar.cmn and calendar.decl
* V54:  *acm* 9/01 changes for dynamic allocation of PPLUS memory.
*                  This routine called by a C "envelope" routine PPLCMD
*                  with the same arguments as the original PPLCMD.F, which
*                  gets the global pointer to PPLUS memory and passes it to
*                  this routine.   The only change here is that array pplmem
*                  (old name was X)  is passed in rather than in PPLDAT.INC
*      *acm* 10/01  remove VMS includes
* v541 *acm*  5/02 add option to control outline on the shade key boxes (S_KEY)
* v552 *acm*  3/03 Add poly
* v552 *acm*  3/03 Longer strings: changes for multi-line labels
* v552 *acm*  5/03 Add option to control whether cellarray calls are made for
*                  shade plots (S_CELL)  Only used internally.
* v580 *acm* 8/04 Change use of 256 to buflen+1, 
*                 where buflen is defined in cmndlen.inc
* v580 *acm* 8/04 allow PPL POLYGON as well as PPL FILLPOL after POLY/SET
* V581 *acm* 4/05 fix bug 1214; clsplt needs to set meta_actv to false.
* V581 *acm* 5/05 Add simple error checking to the text with XFOR, YFOR, and VECKEY
*                 to see if they are a valid fortran format strings(bug1215). Note
*                 this is just a first-pass checking: if mode ignore_error is on,
*                 or if a plot command is issued without correcting the PPL call,
*                 the bad format string is passed on to routines like numcde or
*                 vecfld, where it will cause a crash.
C *acm* 11/05     new options for XFOR, YFOR, 'DM' deg/min deg/min
* V600: *acm* 11/05 add xdms,ydms for deg/min labels
C        1/06  xvaloff,yvaloff add this amount to each x or y axis label. 
C              (axis data was read as double precision and converted to single 
C              after applying an offset.)
C V600: *acm* 4/06 Change how RANGE_DM is applied when using DM or DMS axis labelling.
C V600: *acm* 5/06 Allow seconds in DMS axis labelling; had removed this.
C V600 *acm* 5/2006 LINECOLORS User can change the number of line colors.
C V602  1/07 *acm* true batch mode for metafiles; flag meta_batch
C                 distinguises this case from other batch modes.
C V610 *acm* 11/2007 For build using PGI Fortran compilers at ECMWF 
C                 The code testing the Format for axis labels balks at
C                 writing a 0 using an F format. See changes at lines 
C                 WRITE(err_msg,label,ERR=1999) 0.  Need to check for an I
C                 format and write 0, else write 0.0.
C V63  *acm* 10/09 Changes for gfortran build
C V65  *acm*  1/10 New time-axis style for DAY and MONTH, DMY: adds the
C                  year to DAY,MONTH or to MONTH.
* V65   *acm* 2/10 Fix bug 1724: in metafile batch mode only, if some command
*                  has opened the metafile but nothing plotted yet, and if
*                  a SET MODE META:newname.plt is issued, just rename the metafile
*                  that was opened. New RENAMPL command.
C *acm*  3/10  Bug 670 fixed: New flag MULTICENFLAG for multi-decade plots, 
C              do not make small tics by default.
* V68   *acm* 4/11 change how flag meta_batch is computed (different Makefile)
* V6.8 *acm* 7/9/2012 For batch graphics on RHEL6, change ITS_BATCH_GRAPHICS
*                     from logical to integer, then batch = ITS_BATCH_GRAPHICS().NE.0
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long
* v691 5/14 *acm* Change name MOD to TEKMOD
* V6.92 *acm* 6/14 New color /key options: any of /key=horizontal,centerlabel
* V694  *acm*  1/15 Changes to allow two time axes on plot (F-T)
* V694  *acm*  5/15 Ticket 2283. Change to call for subroutine setax. 
* v696 *acm*	gap_var to define seperate line segments on PLOT/VS plots
*                  (LAS ticket 1597 and others)
* V695  *acm*  9/15 Changes for hour:min labeling on time axes
* v695 9/15 *acm* write values to PPL* symbols using 6 digits not 4
* V697  *acm*  1/16 Ticket 2344: if there was a time-plot underlay, use its
*                   delta-t for time overlay plots. TAXUND restores the default.
* V698  4/16 *acm* New PLOT/NTH=
* V7    *acm* 6/16 Ticket 2434: command qualifiers /DEGMINSEC= /HALFSPAC
*                  DEGMINSEC=1 for Deg-Min axis labels, =2 for Deg-Min-Sec. Default = 1
*                  /HALFSPAC adds a half space between the degree sign and E/W or N/S
* V741 *acm*  5/18 issue 1874: consistently apply /CONSET number of digits setting

c	fromi	command file or device (/dev/tty or TT: for terminal)
c	linei	input line for parameters
c	isi	length of line in characters
c	combuf() command buffer for executing commands from memory
c	icmdim	dimensioned length of combuf
c	icmsze	number of lines in combuf
c
        include 'comepl_inc.decl'  ! added 9.6.88 j davison 
        include 'COMEPL.INC'  ! added 9.6.88 j davison 
	include 'comeps_inc.decl'
	include 'COMEPS.INC'
	include 'comepv_inc.decl'
	include 'COMEPV.INC'
	include 'parampl5_dat.decl'
	include 'PARAMPL5.DAT'
	include 'PPLDAT.INC'
	include 'axis_inc.decl'
	include 'AXIS.INC'
	include 'lines_inc.decl'
	include 'LINES.INC'
	include 'pen_inc.decl'
	include 'PEN.INC'
	include 'labels_inc.decl'
	include 'LABELS.INC'
	include 'labcom_inc.decl'
	include 'LABCOM.INC'
	include 'cont_inc.decl'
	include 'CONT.INC'
	include 'dashzz_inc.decl'
	include 'DASHZZ.INC'
	include 'conlab_inc.decl'
	include 'CONLAB.INC'
	include 'plt_inc.decl'
	include 'PLT.INC'
	include 'pltl_inc.decl'
	include 'PLTL.INC'
	include 'hab_inc.decl'
	include 'HAB.INC'
	include 'data_inc.decl'
	include 'DATA.INC'
	include 'cmrd_inc.decl'
	include 'CMRD.INC'
	include 'cmrdl_inc.decl'
	include 'CMRDL.INC'
	include 'hd_inc.decl'
	include 'HD.INC'
	include 'mplot_inc.decl'
	include 'MPLOT.INC'
	include 'miss_inc.decl'
	include 'MISS.INC'
	include 'taxis_inc.decl'
	include 'TAXIS.INC'
	include 'tics_inc.decl'
	include 'TICS.INC'
	include 'tics2_inc.decl'
	include 'TICS2.INC'
	include 'axisl_inc.decl'
	include 'AXISL.INC'
	include 'xylabp_inc.decl'
	include 'XYLABP.INC'
	include 'view_inc.decl'
	include 'VIEW.INC'
	include 'zgrid_inc.decl'
	include 'ZGRID.INC'
	include 'filnam_inc.decl'
	include 'FILNAM.INC'
	include 'lunits_inc.decl'
	include 'LUNITS.INC'
	include 'vector_inc.decl'
	include 'VECTOR.INC'
	include 'system_inc.decl'
	include 'SYSTEM.INC'
	include 'cmdcom_inc.decl'
	include 'CMDCOM.INC'
	include 'symkey_inc.decl'
	include 'SYMKEY.INC'
	include 'switch_inc.decl'
	include 'SWITCH.INC'
	include 'prmcom_inc.decl'
	include 'PRMCOM.INC'
	include 'gkscm2.cmn'
        include 'ARFILL.INC'
	include 'calendar.decl'
	include 'calendar.cmn'
        INCLUDE 'pplcmd_strings.cmn'
        INCLUDE 'cmndlen.inc'
        INCLUDE 'errmsg.parm'

* special COMMON to let this routine know if FERRET is in control
        include 'ppl_in_ferret.cmn'
                                     
        real            pplmem(*)
        logical         tmapdebug
CCCCCCC Assign value below rather than initialize here.  F90 complains (linux)
CCCCCCC data	        tmapdebug/.false./

        common/tmdebug/ tmapdebug

*       Declarations added J Davison 9.2.88                    
        integer         icmdim,is,isi,icmsze,i,ier,isym        
        integer         j,k,ic,ierr,lun1,lun11                 
        integer         idum1,iy1,ix1,ix3                   
        integer         lnblk,ws_state

	REAL*8		DIFF
        real            xm,ym,xt,xdum1,xdum2,xdum3,xdum4       
        real            xdum5,zmn,zmx,p1,x1,y1,y2,x3,x4     
        real            symwid,xmx,xmn,ymx,ymn,dd
                                                               
        external        lnblk,diff,symwid                      
                                                               
        logical         first_time_thru               
        data            first_time_thru/.true./                

*       End declarations 9.2.88
                                
*	Declarations added J Davison 11.30.88
	real		xft,yft,xlt,ylt,xht,yht,xtit,xtlt
	integer		nmxt,nmyt,ilen
*	End declarations 11.30.88

	integer	  ipen_save(0:nlines), cal_status
	data	  ipen_save/1,nlines*1/
        INTEGER   TM_LENSTR, TM_LENSTR1, slen

	character strr*2048

* *acm*  For batch metafile 
	INTEGER ITS_BATCH_GRAPHICS, ITS_META_GRAPHICS
	LOGICAL its_meta, batch, meta_batch, its_open

        LOGICAL TM_HAS_STRING
	CHARACTER DTE*10,TEMP*2048,TEMP2*2048,FILE*81,FROM*80,LINE*2048
	CHARACTER SYM*120,ICOM7*7
	CHARACTER FROMI*10,LINEI*10
	CHARACTER COMBUF(ICMDIM)*2048
	CHARACTER YES*3,NO*2,err_msg*40
	LOGICAL LEOF
	LOGICAL IFLG1,IFLG2,LABON,VALOFF,TBOTH
	DIMENSION X1(5),Y1(5),Y2(4),X3(2),IX3(5)
	DIMENSION X4(4)
	INTEGER	  num_comm
	PARAMETER(num_comm = 126)
	CHARACTER COMM(num_comm)*7
	EQUIVALENCE (DT,X3(1)),(ITYPET,IX3(1)),(TSMX,X4(1))
	EQUIVALENCE (XLO,X1(1)),(YLO,Y1(1)),
     *		(HLAB1,Y2(1))
	INTEGER	ISTAT,IFLAG !Added back in -- deleted for some reason in v1.1
	DATA YES,NO/'YES','NO'/
	DATA FILE/' '/
	DATA COMM/'AUTO','BAUD','EXIT','PLTYPE','RWDSEQ','SIZE',
     *  'SMOOTH',
     *  'TKTYPE','XLAB','YLAB','FORMAT','CONTOUR','PLOT','READSEQ',
     *  'VARS','XAXIS','YAXIS','NLINES','LINE','LABS','LABSET',
     *  'LEVELS','CLINE','CONSET','LIST','SKPSEQ','VIEW','ENTER',
     *  'CROSS','PARAM',
     *  'SAVE','GET','XFOR','YFOR','ORIGIN','WINDOW','RWD','RD','SKP',
     *  'MULTPLT','METRIC','ENGLISH','LIMITS','PLOTV','TAXIS','RDCOM',
     *  'PLOTUV','TICS','TMIN','TMAX','TSTART','PEN','AXLEN','AXLABP',
     *  'AXLINT','AXTYPE','AXLSZE','AXNSIG','AXNMTC','AXATIC','ROTATE',
     *  'C','BOX','RLABS','AXSET',' ','LLABS','LEV','DATPT','PLTNME',
     *  'HLABS','CONPRE','CONPST','TRANSXY','MARKH','LINFIT','DFLTFNT',
     *  'GRID','TEKNME','ECHO','VELVCT','TIME','TXTYPE','TXLSZE',
     *  'TXLINT','TXNMTC','TXLABP','TAXUND','AUTOLAB','EVAR','DEBUG','RESET',
     *  'TITLE','VPOINT','CLSPLT','VECTOR','VECSET','VECKEY','USR',
     *  'SHADE','SHAKEY','SHASET','PIXMAP','ALINE','TMDEBUG','COLOR',
     *  'SQFILL','FILL', 'PLOTPOL', 'FILLPOL', 'PATSET','CALENDA',
     *  'FLOWLIN', 'S_KEY', 'S_CELL', 'POLYGON', 'XVALOFF', 'YVALOFF',
     *  'LINECOL','RENAMPL','SHRINKY','RIBBON','RIBFAST','RIBMISS',
     *  'GAPLOC','CLRKLAB'/

!  *  'SQFILL','AREA'/ NAME CHANGE *jd*
 
	CHARACTER*15  TMPCHR
	character*2048 set_name

*	*jd* linux external stmt below inserted	
	external scale

* *kob* add external statment 9/98
	EXTERNAL 
     .          BIBO5,
     .          TBLES,
     .          DSFCOM_INIT,
     .          PPLDAT,
     .          WS_TYPES_INIT

        include 'tmap_errors.parm'
        include 'century.cmn'

*****************************************************************************

*  get strings out of common.
      DO i = 1, ICMDIM
        COMBUF(i) = PPLCOMBUF(i) 
      ENDDO

      FROMI = PPLFROMI
      LINEI = PPLLINEI

*       SETUP SHADE ROUTINE DEFAULTS             
        if (first_time_thru) then                
	   tmapdebug = .false.
           first_time_thru = .false.             
           call setup_defaults                   
        end if                                   

C
C	SET UP LABELT STUFF
C
	IF ( LABELT .EQ. 0 ) THEN
	   ITXLBP= 0		! 3/00 bug fix for "TXLABP 0"
	ELSE
	   ITXTPE=ABS(LABELT)
	   ITXLBP=SIGN(1,LABELT)
	ENDIF
C
C	INITIALIZE COMMAND BUFFER
C
	FROM=FROMI
	LINE=LINEI
	IS=ISI
	MEMBUF=ICMSZE.GE.1
	BUFSZE=ICMSZE
	IF(MEMBUF)THEN
!	    M=BUFDIM No longer defined in v1.1 -- see cmdcom.inc
	    M=IBFDIM
	    M=MIN0(M,BUFSZE)
	    DO 30 I=1,M
30	    CMDBUF(I)=COMBUF(I)
	    FROM='$$MEMBUF$$'
	    LINE=' '
	    IS=0
	ENDIF
#ifdef unix
        TERMF=FROM.EQ.'/dev/tty'
#else
        TERMF=FROM.EQ.'TT:'
#endif
	CMDLEV=0
	CALL ATSTRT(FROM,LINE,IS,IER)
C
C	    ERROR OCCURRED WHILE OPENING 'FROM' AS INPUT FOR COMMANDS
C
	IF(IER.NE.0)RETURN
C
C	READ COMMAND FROM INPUT AND PARSE
C
	MBUFF=1
10	call gqops (ws_state)
!	If GKS WS is active, flush output buffer before leaving if just plotted
	if (ws_state .ge. 3) then
	  if (makep .eq. 'CONTOUR'
     .	  .or.makep .eq. 'PLOT'
     .	  .or.makep .eq. 'VIEW'
     .	  .or.makep .eq. 'PLOTV'
     .	  .or.makep .eq. 'PLOTUV'
     .	  .or.makep .eq. 'VELVCT'
     .	  .or.makep .eq. 'VECTOR'
     .	  .or.makep .eq. 'FLOW'
     .	  .or.makep .eq. 'SHADE'
     .	  .or.makep .eq. 'FILL'
     .	  .or.makep .eq. 'PLOTPOL'
     .	  .or.makep .eq. 'FILLPOL'
     .	  .or.makep .eq. 'POLYGON'
     .	  .or. icom(1:1) .eq. '%') then
             IF ( PPL_in_FERRET ) CALL SEG_ON( )
             call pplgflush
             IF ( PPL_in_FERRET ) CALL SEG_OFF
	   endif
	endif
	makep = ' '
        IF (makep .EQ. 'POLYGON') makep = 'FILLPOL'

	CALL GETCMD(STRING,ISLEN,ICOM,P,IFLG,M,LABEL,N,LBSTRT)
	IF (DONEF) RETURN

C       Changed ICOM to CHAR*7 comparison for CALENDAR command. *jd* 10.99
	ICOM7(1:7)=ICOM(1:7)
	DO 20 I=1,num_comm
	    IF(ICOM7.EQ.COMM(I))GOTO 21
20	CONTINUE
	IF(ICOM(1:1).EQ.'%')THEN
! 	   Mod 11.9.93 to insert advanced command output into segments
*          TMAP check that output window is active
           IF ( PPL_in_FERRET ) CALL CK_GKS_ACTIVE( *9999 ) 
*          TMAP addition to turn on segment
           IF ( PPL_in_FERRET ) CALL SEG_ON( )

	   CALL PRMTIV(pplmem,pplmem_nsize)
           IF ( PPL_in_FERRET ) CALL SEG_OFF
	ELSE
	    CALL SPWN
	ENDIF
	GOTO 10
21	IFLG1=(M.GE.1.AND.IFLG(1).NE.0)
	IFLG2=(M.GE.2.AND.IFLG(2).NE.0)
	LABON=(LABEL.EQ.'ON'.OR.LABEL.EQ.'on')
	TBOTH=(LABEL.EQ.'BO'.OR.LABEL.EQ.'bo')
	IF (TBOTH) LABON = .TRUE.
	VALOFF=(INDEX(LABEL,'OFF')+INDEX(LABEL,'off')).NE.0
C       Mod below for brain dead version *JD* 8.2.91
        if (tmapdebug) then
	GOTO (100,200,300,500,600,700,900,1000,1100,1200,1300,
     *	1400,1500,1600,1800,1900,2000,2100,2200,2300,2500,2600,
     *	2700,2800,2900,3300,3400,3500,3600,4000,4200,4300,
     *	4400,4500,4600,4700, 600,1600,3300,4900,5000,5100,5200,
     *	5300,5400,5500,5700,5800,5900,6000,6100,6200,6300,6400,
     *	6500,6600,6700,6800,6900,7000,7100,7200,7300,7400,7500,
     *	7600,7700,7800,7900,8000,8100,8200,8300,8400,8500,8600,
     *	8700,8800,8900,9000,9100,9200,9300,9400,9500,9600,9700,9750,
     *	9800,9900,9910,9920,9930,9940,9950,9110,9120,9130,9140,
     *	9150,9160,9170,9180,9190,98,9191,9380,9171,9172,9173,
     *  9174,9175,9390,9165,9166,9183,4401,4501,9192,9960,9970,
     *  1550,9980,9982,9984,9985),I
        else
	GOTO (100,200,300,500,99,700,900,1000,1100,1200,1300,
     *	1400,1500,99,1800,1900,2000,2100,2200,2300,2500,2600,
     *	2700,2800,2900,99,3400,3500,3600,4000,4200,4300,
     *	4400,4500,4600,4700,99,99,99,4900,5000,5100,5200,
     *	5300,5400,5500,5700,5800,5900,6000,6100,6200,6300,6400,
     *	6500,6600,6700,6800,6900,7000,7100,7200,7300,7400,7500,
     *	7600,7700,7800,7900,8000,8100,8200,8300,8400,8500,8600,
     *	8700,8800,8900,9000,9100,9200,9300,9400,9500,9600,9700,9750,
     *	9800,9900,9910,9920,9930,9940,9950,9110,9120,9130,9140,
     *	9150,9160,9170,9180,9190,98,9191,9380,9171,9172,9173,
     *  9174,9175,9390,9165,9166,9183,4401,4501,9192,9960,9970,
     *  1550,9980,9982,9984,9985),I
        end if
        goto 10

C     TMDEBUG
 98   call upper (label,2048)
      if (label .eq. 'ON')  tmapdebug = .true.
      if (label .eq. 'OFF') tmapdebug = .false.
      goto 10
C
C     Brain dead response for RDing
C
 99   IF(.NOT.QUIETF)WRITE(LTTOUT,
     . '(1X,''COMMAND NOT SUPPORTED IN THIS VERSION OF PPLUS: '',A7)') 
     . ICOM(:7)
      GOTO 10
C     AUTO
100	IF(LABON)THEN
	    IPAUSE=0
	    IHDCPY=1
	ELSE
	    IPAUSE=1
	    IHDCPY=0
	END IF
	GOTO 10
C     BAUD
200	IR=IFIX(P(1))
	CALL BAUD(IR)
	GOTO 10
C     EXIT
300	CALL ATFLSH
	RETURN
C     PLTYPE
500	ICODE=IFIX(P(1))
C       More brain dead mods:
        IF (ICODE .NE. 3 .AND. .not. tmapdebug) THEN
           IF(.NOT.QUIETF)WRITE(LTTOUT,'(1X,A)')
     .          'PLTYPE 3 ONLY IS SUPPORTED IN THIS VERSION OF PPLUS'
           GOTO 10
        ENDIF
	CALL PLTYPE(ICODE)
	CALL TKTYPE(TEKMOD)
	GOTO 10
C     SIZE
700	WIDTH=P(1)
	HEIGHT=P(2)
	SYM='*PPL$WIDTH'
	CALL PUTVAL(SYM,WIDTH,6,IER)
	SYM='*PPL$HEIGHT'
	CALL PUTVAL(SYM,HEIGHT,6,IER)
	GOTO 10
C     SMOOTH
900	IF(M.EQ.0)GOTO 10
	CALL SMOOTH(pplmem,NX,NY,NX,NY,IFIX(P(1)))
	GOTO 10
C     TKTYPE
1000	TEKMOD=IFIX(P(1))
	CALL TKTYPE(TEKMOD)
	GOTO 10
C     XLAB
1100	XLAB=LABEL
	GOTO 10
C     YLAB
1200	YLAB=LABEL
	GOTO 10
C     FORMAT
1300	IFORM=LABEL
	CALL UPPER(IFORM,80)
	SYM='*PPL$FORMAT'
	ISYM=LNBLK(IFORM,80)
	CALL PUTSYM(SYM,IFORM,ISYM,IER)
	LSCTD=SCTD
	GOTO 10
C     VARS
1800	IEFLG=0
	LSOFFS=SOFFS
	LSTIME=STIME
	LSNEXT=SNEXT
	IF(IFLG(1).NE.0)NGRP=IFIX(P(1))
	JX=0
	JY=0
	JZ=0
	DO 1801 I=2,M
	    IF(IFLG(I).EQ.0)GOTO 1801
	    IF(P(I).EQ.1.)JX=I-1
	    IF(P(I).EQ.2.)JY=I-1
	    IF(P(I).EQ.3.)JZ=I-1
1801	CONTINUE
	NVAR=M-1
	GOTO 10
C     XAXIS
1900	DO 1901 I=1,M
	    IF(I.GE.4)GOTO 1902
	    IF(IFLG(I).NE.0)X1(I)=P(I)
1901	CONTINUE
1902	IF(M.GT.0)THEN
	    IAUTOX=0
	    X1(3)=SIGN(ABS(X1(3)),X1(2)-X1(1))
	ELSE
	    IAUTOX=1
	ENDIF
	GOTO 10
C     YAXIS
2000	DO 2001 I=1,M
	    IF(M.GE.4)GOTO 2002
	    IF(IFLG(I).NE.0)Y1(I)=P(I)
2001	CONTINUE
2002	IF(M.GT.0)THEN
	    IAUTOY=0
	    Y1(3)=SIGN(ABS(Y1(3)),Y1(2)-Y1(1))
	ELSE
	    IAUTOY=1
	ENDIF
	GOTO 10
C     NLINES
2100	CALL RSMNMX
	LINEN=0
	IBASE=1
	PBUF=0
	LNUM=1
	GOTO 10
2200	I=IFIX(P(1))
	IF(IFLG2)IMARK(I)=IFIX(P(2))
	IF(M.GE.3.AND.IFLG(3).NE.0)ITYPE(I)=IFIX(P(3))
        if(m.ge.4.and.iflg(4).ne.0)xoff(i)=p(4)     
        if(m.ge.5.and.iflg(5).ne.0)yoff(i)=p(5)     
        if(m.ge.6.and.iflg(6).ne.0)dn1(i)=p(6)      
        if(m.ge.7.and.iflg(7).ne.0)up1(i)=p(7)      
        if(m.ge.8.and.iflg(8).ne.0)dn2(i)=p(8)      
        if(m.ge.9.and.iflg(9).ne.0)up2(i)=p(9)      
	IF(M.GE.10.AND.IFLG(10).NE.0)IPEN(I)=IFIX(P(10))
	GOTO 10

!	All references to X2 deleted for 1.4 version of PPLCMD
!	N=M
!	IF(M.GE.10)N=9
!	DO 2201 J=4,N
!	    IF(J.LT.6)THEN
!		K=J-3
!	    ELSE
!		K=J-1
!	    ENDIF
!	    IF(IFLG(J).NE.0)X2(I,K)=P(J)
!2201	CONTINUE

C     LABS
2300	IF(P(1).EQ.0..OR.M.EQ.0)THEN
	    DO 2301 I=1,NLABS
		LLTYPE(I)=0
2301	    RHLABS(I)=-1.0
	    NLAB=0
	ELSE
	    I=IFIX(P(1))
	    IF(N.NE.0)LABS(I)=LABEL
	    USRLBS(I)=SUSER
	    IF(IFLG2)THEN
		XLABS(I)=P(2)
		YLABS(I)=P(3)
		IF(M.GE.4.AND.IFLG(4).NE.0)LTYPE(I)=P(4)
	    ELSE
		XLABS(I)=1.E35
	    ENDIF
	    IF(NLAB.LT.I)NLAB=I
	END IF
	GOTO 10
C     LABSET
2500	DO 2501 I=1,M
	    IF(IFLG(I).NE.0)Y2(I)=P(I)
2501	CONTINUE
	GOTO 10
C     LEVELS
2600	CALL LEVEL
	GOTO 10
C     CLINE
2700	DO 2701 I=1,M
	    IF(IFLG(I).NE.0)LWGT(I)=IFIX(P(I))
2701	CONTINUE
	DO 2702 I=M+1,NLEV
2702	LWGT(I)=1
	GOTO 10
C     CONSET
2800	IF(IFLG1)HGT=P(1)
	NEWSIG = 0  ! set this flag if a PPL CONSET is specificially setting the nsig value
	IF(IFLG2)THEN
	   IF (IFIX(P(2)) .GT. 0) NEWSIG = 1
	   NSIGC=IFIX(P(2))
	ENDIF
	IF(M.GE.3.AND.IFLG(3).NE.0)NARC=IFIX(P(3))
	IF(M.GE.4.AND.IFLG(4).NE.0)DASHLN=P(4)
	IF(M.GE.5.AND.IFLG(5).NE.0)SPACLN=P(5)
	IF(M.GE.6.AND.IFLG(6).NE.0)CAY=P(6)
	IF(M.GE.7.AND.IFLG(7).NE.0)NRNG=IFIX(P(7))
	IF(M.GE.8.AND.IFLG(8).NE.0)DSLAB=P(8)
! TMAP mod, spline fit:
	if(m.ge.9.and.iflg(9).ne.0)spline_tension=p(9)
! TMAP mod, horz contour labels:
	if(m.ge.10.and.iflg(10).ne.0.and.p(10).ne.0.)draftsman=.true.	
	if(m.ge.10.and.iflg(10).ne.0.and.p(10).eq.0.)draftsman=.false.	
	GOTO 10
C     CROSS
3600	ICROSS=0
	IF(LABON)ICROSS=1
	IF(IFLG(1).EQ.1)ICROSS=ICROSS+INT(P(1))
	GOTO 10
C     PARAM
4000	GOTO 10
C	DO 4001 I=1,M
C4001	IF(IFLG(I).EQ.1)A(I)=P(I)
C	GOTO 10
C     SAVE
4200	IF(N.EQ.0)GOTO 10
#ifdef unix
        temp=label
#else
	CALL WLDFLE('SY:.PPL_SAVE',LABEL,TEMP,ISTAT,IFLAG)
#endif
	OPEN(UNIT=LMULT,FILE=TEMP,STATUS='NEW',
     *	FORM='UNFORMATTED')
C
C	SAVE THE FOLLOWING COMMON BLOCKS:
C
C	HD
C	MPLOT   (IMULT)
C	PPLDAT  (IBASE AND PBUF)
C	SWITCH  (DEFLTS AND FLAG)
C	SYSTEM
C	XYLABP
C
	WRITE(LMULT)IPTS,IMULT,IBASE,PBUF,DEFLTS,FLAG,ECHOF,DEBUGF,
     *	BATCHF,ERRORF,DONEF,MEMBUF,LOGITF,QUIETF,LOGCMF,XLABS,YLABS,
     *	RLABS,LTYPE,XLLABS,YLLABS,LLTYPE,RHLABS,USRLBS
C
	CALL SAVE(LMULT)
	CLOSE(LMULT)
	GOTO 10
C	GET
4300	IF(N.EQ.0)GOTO 10
#ifdef unix
        temp=label
#else
        CALL WLDFLE('SY:.PPL_SAVE',LABEL,TEMP,ISTAT,IFLAG)
#endif
	CALL WLDFLE('SY:.PPL_SAVE',LABEL,TEMP,ISTAT,IFLAG)
	OPEN(UNIT=LMULT,FILE=TEMP,STATUS='OLD',
     *	FORM='UNFORMATTED',ERR=4301)
	IF(IMULT.EQ.1)THEN
	    XM=HEIGHT
	    YM=WIDTH
	ENDIF
C
C	GET THE FOLLOWING COMMON BLOCKS:
C
C	HD
C	MPLOT   (IMULT)
C	PPLDAT  (IBASE AND PBUF)
C	SWITCH  (DEFLTS AND FLAG)
C	SYSTEM
C	XYLABP
C
	READ(LMULT)IPTS,IMULT,IBASE,PBUF,DEFLTS,FLAG,ECHOF,DEBUGF,
     *	BATCHF,ERRORF,DONEF,MEMBUF,LOGITF,QUIETF,LOGCMF,XLABS,YLABS,
     *	RLABS,LTYPE,XLLABS,YLLABS,LLTYPE,RHLABS,USRLBS
C
	CALL GET(LMULT)
	CLOSE(LMULT)
	IF(IMULT.EQ.1)THEN
	    HEIGHT=XM
	    WIDTH=YM
	ENDIF
	CALL BAUD(IR)
	CALL PLTYPE(ICODE)
	CALL TKTYPE(TEKMOD)
	GOTO 10
4301	IF(.NOT.QUIETF)WRITE(LTTOUT,'(1X,A30,'' NOT FOUND'')')LABEL
	GOTO 10


c For XFOR and YFOR, check if LABEL is a valid format: 
c do a test write to the string err_msg, using label as a format
c If format is (DM) then axis will be labelled with 
c deg/min, or deg/min.ff decimal fraction of minutes.
c****If it is XFOR(DM,ddd) then we will rotate the labes by ddd degrees.****

C   RANGE_DM recomputes axis range and delta, so that it has
C   good intervals when expressed as deg-min-sec (A previous 
C   call to RANGE sets intervals based on degrees and decimal 
C   fractions of degrees.) Reset only the delta, as the user may
C   have explicitly set the lo and hi limit

C     XFOR
4400  i = STR_UPCASE (TMPCHR, LABEL(1:5))
      i = TM_LENSTR1(LABEL) - 1
      IF (TMPCHR(2:2) .EQ. 'D') THEN  ! degrees/mintues/seconds ?
           IF (TMPCHR(2:3) .EQ. 'DM') THEN
              xdms = 0
              IF (TMPCHR(2:3) .EQ. 'DM') xdms = 1 
              IF (TMPCHR(2:4) .EQ. 'DMS') xdms = 2 
              IF (xdms .GT. 0) THEN
	         CALL RANGE_DM(XLO,XHI,XTIC,xmn,xmx,dd)
                 xtic = dd
	      ENDIF
           ELSE ! 'DD' resets to decimal degrees
              xdms = 0
           ENDIF
           GOTO 10
        ENDIF

        IF (TMPCHR(2:4) .EQ. 'SPC') THEN  ! Space between degree-sign and EW or NS
           xdspac = 0
           IF (TMPCHR(5:5) .NE. ')') READ (TMPCHR(5:5), *) xdspac
           GOTO 10
        ENDIF

        IFRX=LABEL
        slen = TM_LENSTR(LABEL)
        IF (slen .GT. 1) THEN
           IF (TM_HAS_STRING( label, '(I')) THEN
              WRITE(err_msg,label,ERR=1999) 0
           ELSE
              WRITE(err_msg,label,ERR=1999) 0.0
           ENDIF
        ELSE
	   xdspac = 0
	   xdms = 0
        ENDIF
	GOTO 10
C     YFOR

4500  i = STR_UPCASE (TMPCHR, LABEL(1:15))
      i = TM_LENSTR1(LABEL) - 1
      IF (TMPCHR(2:2) .EQ. 'D') THEN  ! degrees/mintues/seconds ?
           IF (TMPCHR(2:3) .EQ. 'DM') THEN
              ydms = 0
              IF (TMPCHR(2:3) .EQ. 'DM') ydms = 1 
              IF (TMPCHR(2:4) .EQ. 'DMS') ydms = 2 
              IF (ydms .GT. 0) THEN
	         CALL RANGE_DM(YLO,YHI,YTIC,ymn,ymx,dd)
                 ytic = dd
	      ENDIF

           ELSE ! 'DD' resets to decimal degrees
              ydms = 0
           ENDIF
           GOTO 10
        ENDIF

        IF (TMPCHR(2:4) .EQ. 'SPC') THEN  ! Space between degree-sign and EW or NS
           ydspac = 0
           IF (TMPCHR(5:5) .NE. ')') READ (TMPCHR(5:5), *) ydspac
           GOTO 10
        ENDIF

        IFRY=LABEL
        slen = TM_LENSTR(LABEL)
        IF (slen .GT. 1) THEN
           IF (TM_HAS_STRING( label, '(I')) THEN
              WRITE(err_msg,label,ERR=1999) 0
           ELSE
              WRITE(err_msg,label,ERR=1999) 0.0
           ENDIF
        ELSE
	   ydspac = 0
	   ydms = 0
        ENDIF
	GOTO 10
        
C     XVALOFF
4401  XVALOFF=P(1)
      i = XVALOFF
      IF (FLOAT(i) .NE. XVALOFF) THEN
         err_msg = 'Offset must be an integer'
         CALL ERRMSG (ferr_out_of_range, status, err_msg, *9999)
      ENDIF
      GOTO 10

C     YVALOFF
4501  YVALOFF=P(1)
      i = YVALOFF
      IF (FLOAT(i) .NE. YVALOFF) THEN
         err_msg = 'Offset must be an integer'
         CALL ERRMSG (ferr_out_of_range, status, err_msg, *9999)
      ENDIF
      GOTO 10

C     ORIGIN
4600	IF(IFLG1)XORG=P(1)
	IF(IFLG2)YORG=P(2)
	SYM='*PPL$XORG'
	CALL PUTVAL(SYM,XORG,6,IER)
	SYM='*PPL$YORG'
	CALL PUTVAL(SYM,YORG,6,IER)
	if(pltopn)then
	    call setax(pplmem,pplmem_nsize,xft,yft,xlt,ylt,xht,yht,
     .                 nmxt,nmyt,xtit,xtlt,.FALSE.)
     	    call scale(xft,yft,xorg,yorg,xlo,ylo)
	endif
	GOTO 10
C     WINDOW
4700	IWIND=0
	IF(LABON) IWIND=1
	GOTO 10
C     METRIC
5000	CALL METRIC
	GOTO 10
C     ENGLISH
5100	CALL ENGLSH
	GOTO 10
C     LIMITS
5200	CALL UPPER(LABEL,2048)
	IF(INDEX(LABEL,'XLE').NE.0)THEN
	    XLE=.NOT.VALOFF
	    IF(IFLG1)CMXLE=P(1)
	ELSE IF(INDEX(LABEL,'XEQ').NE.0)THEN
	    XEQ=.NOT.VALOFF
	    IF(IFLG1)CMXEQ=P(1)
	ELSE IF(INDEX(LABEL,'XGE').NE.0)THEN
	    XGE=.NOT.VALOFF
	    IF(IFLG1)CMXGE=P(1)
	ELSE IF(INDEX(LABEL,'YLE').NE.0)THEN
	    YLE=.NOT.VALOFF
	    IF(IFLG1)CMYLE=P(1)
	ELSE IF(INDEX(LABEL,'YEQ').NE.0)THEN
	    YEQ=.NOT.VALOFF
	    IF(IFLG1)CMYEQ=P(1)
	ELSE IF(INDEX(LABEL,'YGE').NE.0)THEN
	    YGE=.NOT.VALOFF
	    IF(IFLG1)CMYGE=P(1)
	ELSE IF(INDEX(LABEL,'ZLE').NE.0)THEN
	    ZLE=.NOT.VALOFF
	    IF(IFLG1)CMZLE=P(1)
	ELSE IF(INDEX(LABEL,'ZEQ').NE.0)THEN
	    ZEQ=.NOT.VALOFF
	    IF(IFLG1)CMZEQ=P(1)
	ELSE IF(INDEX(LABEL,'ZGE').NE.0)THEN
	    ZGE=.NOT.VALOFF
	    IF(IFLG1)CMZGE=P(1)
	ENDIF
	GOTO 10
C     TAXIS
5400	ITFLG=0
	IF(LABON)THEN
	    IF(SYAXIS)THEN
		ITFLG=-1
	ELSE
		ITFLG=1
	    ENDIF
	ENDIF
	IF (TBOTH) ITFLG=2
	DO 5401 I=1,M
	    IF(I.GE.3)GOTO 5402
	    IF(IFLG(I).NE.0)X3(I)=P(I)
5401	CONTINUE
	GOTO 10
5402	DO 5403 J=I,M
	    IF(IFLG(J).NE.0)IX3(J-2)=IFIX(P(J))
5403	CONTINUE
	GOTO 10
C     RDCOM
5500	goto 10
C     TICS
5800	DO 5801 I=1,M
	    IF(I.GT.4)GOTO 5802
	    IF(IFLG(I).NE.0)X4(I)=P(I)
5801	CONTINUE
5802	IF(M.GE.5.AND.IFLG(5).EQ.1)ITX=P(5)
	IF(M.GE.6.AND.IFLG(6).EQ.1)ITY=P(6)
* The following lets the user plot small tics with PPL TICS
	MULTICENFLAG = .FALSE.
	GOTO 10
C	TMIN
5900	IF(N.NE.0)THEN
	    IT1=LABEL(2:11)
	    IF(ITSTRT.EQ.' ')ITSTRT=IT1
	ENDIF

C	Linux port. *jd* 12.96 F90 compiler has problem with the statement
C	below "Invalid forward reference to 6102 detected at DT (end of stmt)"
C	This is into an IF THEN ELSE clause.  As there is but one command 
C	before another GOTO I have copied the code from line 6102 and 
C	GOTO 10 right here.

CCC	GOTO 6102
	TLO=1.-DIFF(IT1,ITSTRT)/DT ! Needs to be == line 6102
	GOTO 10
C	TMAX
6000	IF(N.NE.0)THEN
	    IT2=LABEL(2:11)
	ENDIF
	GOTO 10
C	TSTART
6100	IF (IFORM(1:3).EQ.'EPI' .OR. IFORM(1:3).EQ.'BIB') THEN
	    GOTO 10
	ELSE
	    IF(N.EQ.0)LABEL(2:)=IT1
	    ITSTRT=LABEL(2:11)
6102	    TLO=1.-DIFF(IT1,ITSTRT)/DT
	    GOTO 10
	ENDIF
C	PEN
6200	I=IFIX(P(1))
	if (label .ne. ' ') then 
	   call upnsquish (label,strr,end)
	   if (strr .eq. 'SAVE') then
	      ipen_save(i) = ipen(i)
	      goto 6201
	   elseif (strr .eq. 'RESTORE') then
	      ipen(i) = ipen_save(i)
	      goto 6201
	   endif
	endif
	IF(M.LT.2.OR.IFLG(2).EQ.0)GOTO 10
	IF(I.LT.1)I=0
	IPEN(I)=IFIX(P(2))
	if (ipen(i) .eq. 0) ipen(i) = 19  !JD 10.16.92 [post atc] for 'PEN N,0'
6201	GOTO 10
C	AXLEN
6300	IF(IFLG1)XLEN=P(1)
	IF(IFLG2)YLEN=P(2)
	SYM='*PPL$XLEN'
	CALL PUTVAL(SYM,XLEN,6,IER)
	SYM='*PPL$YLEN'
	CALL PUTVAL(SYM,YLEN,6,IER)
	if(pltopn)then
	    call setax(pplmem,pplmem_nsize,xft,yft,xlt,ylt,xht,yht,nmxt,
     *	    nmyt,xtit,xtlt,.FALSE.)
	    call scale(xft,yft,xorg,yorg,xlo,ylo)
	endif
	GOTO 10
C	AXLABP
6400	IF(IFLG1)LABELX=IFIX(P(1))
	IF(IFLG2)LABELY=IFIX(P(2))
	GOTO 10
C	AXLINT
6500	IF(IFLG1)LINTX=IFIX(P(1))
	IF(IFLG2)LINTY=IFIX(P(2))
	GOTO 10
C	AXTYPE
6600	IF(IFLG1)ITYPEX=IFIX(P(1))
	IF(IFLG2)ITYPEY=IFIX(P(2))
	GOTO 10
C	AXLSZE
6700	IF(IFLG1)XCSIZE=P(1)
	IF(IFLG2)YCSIZE=P(2)
	GOTO 10
C	AXNSIG
6800	IF(IFLG1)NSIGX=IFIX(P(1))
	IF(IFLG2)NSIGY=IFIX(P(2))
	GOTO 10
C	AXNMTC
6900	IF(IFLG1)NMTCX=IFIX(P(1))
	IF(IFLG2)NMTCY=IFIX(P(2))
	GOTO 10
C	AXATIC
7000	IF(IFLG1)NTICX=IFIX(P(1))
	IF(IFLG2)NTICY=IFIX(P(2))
	GOTO 10
C	ROTATE
7100	IF(LABON)THEN
	    CALL ROTATE(90.)
	ELSE
	    CALL ROTATE(0.)
	ENDIF
	GOTO 10
C	COMMENT COMMAND 'C'
7200	GOTO 10
C	BOX
7300	IP(1)=0
	IF(LABON)IP(1)=1
	GOTO 10
C	RLABS
7400	I=IFIX(P(1))
	IF(IFLG2)THEN
	    RLABS(I)=P(2)
	ELSE
	    RLABS(I)=0.
	ENDIF
	GO TO 10
C	AXSET
7500	DO 7501 I=1,M
7501	    IF(IFLG(I).NE.0) IAXON(I)=P(I)
	    GOTO 10
C	'BLANK COMMAND'
7600	    CONTINUE
	    GOTO 10
C	LLABS
7700	    IF(.NOT.IFLG1)GOTO 10
	    I=P(1)
	    IF(IFLG2)THEN
		XLLABS(I)=P(2)
		YLLABS(I)=P(3)
	    ELSE
		LLTYPE(I)=0
	    ENDIF
	    IF(M.GE.4.AND.IFLG(4).NE.0)LLTYPE(I)=P(4)
	    GOTO 10
C	LEV
7800	    CALL LEV
	    GOTO 10
C	DATPT
7900	    IF(IFLG1)IZTYP=P(1)
	    IF(IFLG2)IZMRK=P(2)
	    GOTO 10
C	PLTNME
*8000	    IF(N.EQ.0)THEN
*		TEMP='ppl.meta'
*	    ELSE
*		TEMP=LABEL
*	    ENDIF
*	    CALL PLTNME(TEMP)
*	    SYM='*PPL$PLTNME'
*	    ISYM=LNBLK(TEMP,2048)
*	    CALL PUTSYM(SYM,TEMP,ISYM,IER)
8000	    IF(N.EQ.0)THEN
		meta_file='metafile.plt'
		TEMP='metafile.plt'
	    ELSE
		meta_file=LABEL
		TEMP=LABEL
	    ENDIF
	    SYM='*PPL$PLTNME'
	    ISYM=LNBLK(TEMP,2048)
	    CALL PUTSYM(SYM,TEMP,ISYM,IER)
	    GOTO 10
C	HLABS
8100	    IF(.NOT.IFLG1)GOTO 10
	    I=P(1)
	    IF(IFLG2)THEN
		RHLABS(I)=P(2)
	    ELSE
		RHLABS(I)=-1.0
	    ENDIF
	    GOTO 10
C	CONPRE
8200	    IF(N.EQ.0)THEN
		CONPRE=' '
	    ELSE
		CONPRE=LABEL
	    ENDIF
	    GOTO 10
C	CONPST
8300	    IF(N.EQ.0)THEN
		CONPST=' '
	    ELSE
		CONPST=LABEL
	    ENDIF
	    GOTO 10
C	TRANSXY
8400	    I=IFIX(P(1))
	    IF(IFLG2)XFCT(I)=P(2)
	    IF(M.GE.3.AND.IFLG(3).NE.0)XOFF(I)=P(3)
	    IF(M.GE.4.AND.IFLG(4).NE.0)YFCT(I)=P(4)
	    IF(M.GE.5.AND.IFLG(5).NE.0)YOFF(I)=P(5)
	    IF(M.EQ.1)THEN
		XFCT(I)=1.0
		XOFF(I)=0.0
		YFCT(I)=1.0
		YOFF(I)=0.0
	    ENDIF
	    WRITE(SYM,997)'XFACT',I
997	    FORMAT('*PPL$',A,'(',I3,')')
	    CALL PUTVAL(SYM,XFCT(I),6,IER)
	    WRITE(SYM,997)'XOFF',I
	    CALL PUTVAL(SYM,XOFF(I),6,IER)
	    WRITE(SYM,997)'YFACT',I
	    CALL PUTVAL(SYM,YFCT(I),6,IER)
	    WRITE(SYM,997)'YOFF',I
	    CALL PUTVAL(SYM,YOFF(I),6,IER)
	    GOTO 10
C	MARKH
8500	    I=IFIX(P(1))
	    IF(IFLG2)HMARK(I)=P(2)
	    IF(M.EQ.1)HMARK(I)=0.08
	    IF(M.GE.3)nskpsym(I) = p(3)
	    GOTO 10
C	LINFIT
8600	    I=IFIX(P(1))
	    IF(I.GT.LINEN.OR.LLENG(I).LE.2.OR.LINEN.GE.NLINES)THEN
		IF(.NOT.QUIETF)WRITE(LTTOUT,
     *            '('' LINFIT ERROR -- NO ROOM OR LINE'',I3,
     *            '' DOES NOT EXIST'')')
		GOTO 10
	    ENDIF
	    CALL LINFIT(I,pplmem,pplmem_nsize,IBASE,PBUF)
	    GOTO 10
C	DFLTFNT
8700	    IF(N.EQ.0)GOTO 10
	    I=INDEX(LABEL,'@')
	    DTE='@CL@'
	    IF(I.EQ.0)THEN
		DTE(5:)=LABEL
	    ELSE
		DTE(4:)=LABEL
	    ENDIF
	    XT=SYMWID(HLAB1,6,DTE)
	    CONPRE=DTE(4:)
	    GOTO 10
C	GRID
8800	    IF(N.EQ.0)CAY=ABS(CAY)
	    CALL UPPER(LABEL,2048)
	    IF(LABEL(1:1).EQ.'L')CAY=-ABS(CAY)
	    GOTO 10
C	TEKNME
8900	    IF(N.EQ.0)THEN
#ifdef unix
                TEMP='/dev/tty'
#else
		TEMP='TT:'
#endif
	    ELSE
		TEMP=LABEL
	    ENDIF
	    CALL TEKNME(TEMP)
	    SYM='*PPL$TEKNME'
	    ISYM=LNBLK(TEMP,2048)
	    CALL PUTSYM(SYM,TEMP,ISYM,IER)
	    GOTO 10
C	ECHO
9000	    ECHOF=LABON
	    GOTO 10
C	TIME
9200	    IF(N.EQ.0)THEN
		IAUTOT=1
		GOTO 10
	    ENDIF
	    IAUTOT=0

	    IF (itflg .EQ. 2) GOTO 9230

C	GET TMIN,TMAX,TSTART FROM LABEL
C
C	IF NO FIRST PARAMETER SKIP TMIN PROCESSING
C
	    IF(M.GE.1.AND.IFLG(1).EQ.0)GOTO 9201
	    IC=INDEX(LABEL,',')
	    IF(IC.EQ.0)IC=buflen+1
	    IS=INDEX(LABEL,' ')
	    IS=MIN0(IS,IC)

!*JD*	    IT1=LABEL(2:IS-1)
	    TMPCHR = LABEL(1:IS-1)

	    IF ( TMPCHR(12:12) .EQ. ' ' ) THEN
		IT1=TMPCHR(2:11)         ! old format
	 	IT1(11:14) = '0019'
	    ELSE
		IT1(1:12)=TMPCHR(4:15)   ! enhanced format
		IF (tmpchr(11:12) .EQ. ' ') IT1(11:12)='00' 
		IT1(13:14) = TMPCHR(2:3) ! century
	    ENDIF

	    IF(ITSTRT.EQ.' ')ITSTRT=IT1
	    IF(IC.NE.0)IS=IS+1
9210	    IF(LABEL(IS:IS).EQ.' ')THEN
		IS=IS+1
		IF(IS.GT.2048)GOTO 9203
		GOTO 9210
	    ELSE IF(LABEL(IS:IS).EQ.',')THEN
		LABEL=LABEL(IS+1:)
		GOTO 9202
	    ELSE
		LABEL=LABEL(IS:)
	    ENDIF
C
C	IF NO SECOND PARAMETER SKIP TMAX PROCESSING
C
9201	    IF(M.GE.2.AND.IFLG(2).EQ.0)GOTO 9202
	    IC=INDEX(LABEL,',')
	    IF(IC.EQ.0)IC=buflen+1
	    IS=INDEX(LABEL,' ')
	    IS=MIN0(IS,IC)

!*JD*	    IT2=LABEL(2:IS-1)
	    TMPCHR = LABEL(1:IS-1)

	    IF ( TMPCHR(12:12) .EQ. ' ' ) THEN
		IT2=TMPCHR(2:11)         ! old format
		IT2(11:14) = '0019'
	    ELSE
		IT2(1:12)=TMPCHR(4:15)   ! enhanced format
		IF (TMPCHR(11:12) .EQ. ' ') IT2(11:12)='00' 
		IT2(13:14) = TMPCHR(2:3) ! century
	    ENDIF

	    IF(IC.NE.0)IS=IS+1
9220	    IF(LABEL(IS:IS).EQ.' ')THEN
		IS=IS+1
		IF(IS.GT.2048)GOTO 9203
		GOTO 9220
	    ELSE
		LABEL=LABEL(IS:)
	    ENDIF

!*JD* 9202  ITSTRT=LABEL(2:11)
9202	    TMPCHR = LABEL(1:15)

	    IF ( TMPCHR(12:12) .EQ. ' ' ) THEN
		ITSTRT=TMPCHR(2:11)         ! old format
		ITSTRT(11:14) = '0019'
	    ELSE
		ITSTRT(1:12)=TMPCHR(4:15)   ! enhanced format
		IF (TMPCHR(11:12) .EQ. ' ') ITSTRT(11:12)='00' 
		ITSTRT(13:14) = TMPCHR(2:3) ! century
	    ENDIF

9203	    TLO=1.-DIFF(IT1,ITSTRT)/DT
	    GOTO 10
c------------------------------------------------------------------------------------

C Time definition for second time axis (forecast/time plot)
9230    CONTINUE

C	GET TMIN,TMAX,TSTART FROM LABEL
C
C	IF NO FIRST PARAMETER SKIP TMIN PROCESSING
C
	    IF(M.GE.1.AND.IFLG(1).EQ.0)GOTO 9231
	    IC=INDEX(LABEL,',')
	    IF(IC.EQ.0)IC=buflen+1
	    IS=INDEX(LABEL,' ')
	    IS=MIN0(IS,IC)

	    TMPCHR = LABEL(1:IS-1)

	    IF ( TMPCHR(12:12) .EQ. ' ' ) THEN
		IT1b=TMPCHR(2:11)         ! old format
	 	IT1b(11:14) = '0019'
	    ELSE
		IT1b(1:12)=TMPCHR(4:15)   ! enhanced format
		IF (tmpchr(11:12) .EQ. ' ') IT1b(11:12)='00' 
		IT1b(13:14) = TMPCHR(2:3) ! century
	    ENDIF

	    IF(ITSTRTb.EQ.' ')ITSTRTb=IT1b
	    IF(IC.NE.0)IS=IS+1
9240	    IF(LABEL(IS:IS).EQ.' ')THEN
		IS=IS+1
		IF(IS.GT.2048)GOTO 9233
		GOTO 9240
	    ELSE IF(LABEL(IS:IS).EQ.',')THEN
		LABEL=LABEL(IS+1:)
		GOTO 9232
	    ELSE
		LABEL=LABEL(IS:)
	    ENDIF
C
C	IF NO SECOND PARAMETER SKIP TMAX PROCESSING
C
9231	    IF(M.GE.2.AND.IFLG(2).EQ.0)GOTO 9232
	    IC=INDEX(LABEL,',')
	    IF(IC.EQ.0)IC=buflen+1
	    IS=INDEX(LABEL,' ')
	    IS=MIN0(IS,IC)

	    TMPCHR = LABEL(1:IS-1)

	    IF ( TMPCHR(12:12) .EQ. ' ' ) THEN
		IT2b=TMPCHR(2:11)         ! old format
		IT2b(11:14) = '0019'
	    ELSE
		IT2b(1:12)=TMPCHR(4:15)   ! enhanced format
		IF (TMPCHR(11:12) .EQ. ' ') IT2b(11:12)='00' 
		IT2b(13:14) = TMPCHR(2:3) ! century
	    ENDIF

	    IF(IC.NE.0)IS=IS+1
9250	    IF(LABEL(IS:IS).EQ.' ')THEN
		IS=IS+1
		IF(IS.GT.2048)GOTO 9233
		GOTO 9250
	    ELSE
		LABEL=LABEL(IS:)
	    ENDIF

9232	    TMPCHR = LABEL(1:15)

	    IF ( TMPCHR(12:12) .EQ. ' ' ) THEN
		ITSTRTb=TMPCHR(2:11)         ! old format
		ITSTRTb(11:14) = '0019'
	    ELSE
		ITSTRTb(1:12)=TMPCHR(4:15)   ! enhanced format
		IF (TMPCHR(11:12) .EQ. ' ') ITSTRTb(11:12)='00' 
		ITSTRTb(13:14) = TMPCHR(2:3) ! century
	    ENDIF
	    


9233	    TLOb=1.-DIFF(IT1b,ITSTRTb)/DT
	    GOTO 10

c------------------------------------------------------------------------------------


C	TXTYPE
9300	    CALL UPPER(LABEL,2048)
	IF (itflg .EQ. 2) GOTO 9330

	
C
C	IF NO FIRST PARAMETER SKIP PROCESSING
C
	    IF(M.GE.1.AND.IFLG(1).EQ.0)GOTO 9301
	    is_hours_axis = 0
	    IF(LABEL.EQ.'MIN')THEN
		ITYPET=0
		is_hours_axis = 2
	    ELSE IF(LABEL(1:1).EQ.'H')THEN
		ITYPET=0
		is_hours_axis = 1
	    ELSE IF(LABEL(1:1).EQ.'D')THEN
		ITYPET=0
		is_hours_axis = 0
	    ELSE IF(LABEL(1:1).EQ.'M')THEN
		ITYPET=1
	    ELSE
		ITYPET=3
	    ENDIF
C
C	PROCESS TIME AXIS STYLE
C
9301	    IF(ITYPET.EQ.0)THEN
		IF(INDEX(LABEL,'HRD').NE.0)THEN
		    ITXTPE=2
		ELSE
		    ITXTPE=1
		ENDIF
	    ELSE IF(ITYPET.EQ.1)THEN
		IF(INDEX(LABEL,'DAYM').NE.0)THEN
		    ITXTPE=2
		ELSE
		    ITXTPE=1
		ENDIF
		MONYRLAB = .FALSE.
		IF (INDEX(LABEL,'DMY').NE.0) MONYRLAB = .TRUE.
	    ELSE
		IF(INDEX(LABEL,'MON1').NE.0)THEN
		    ITXTPE=3
		ELSE IF(INDEX(LABEL,'MONY').NE.0)THEN
		    ITXTPE=2
		ELSE
		    ITXTPE=1
		ENDIF

*               Century axis mod
	        CENFLAG = .FALSE.
	        IF(INDEX(LABEL,'MULTIY').NE.0) CENFLAG = .TRUE.

*               multi-decade axis mod
	        MULTICENFLAG = .FALSE. 
	        IF(INDEX(LABEL,'MULTID').NE.0) THEN
		   CENFLAG = .TRUE. 
		   MULTICENFLAG = .TRUE. 
	        ENDIF
	    ENDIF
	    MONYRLAB = .FALSE.  ! Option for MON and DAY types. 
	    IF (INDEX(LABEL,'DMY').NE.0) MONYRLAB = .TRUE.

c Do not automatically turn on Day-Month-Year lables for shorter time axes
c            IF (LABEL.EQ.'HR' .OR. LABEL.EQ.'DAY') MONYRLAB = .TRUE.
	    LABELT=ITXTPE*ITXLBP
	    GOTO 10

	
c------------------------------------------------------------------------------------
9330	    CONTINUE
C
C	IF NO FIRST PARAMETER SKIP PROCESSING
C
	    IF(M.GE.1.AND.IFLG(1).EQ.0)GOTO 9331
	    is_hours_axis = 0
	    IF(LABEL.EQ.'PDAY')THEN
		ITYPETb=0
		is_hours_axis = 2
	    ELSE IF(LABEL(1:1).EQ.'H')THEN
		ITYPETb=0
		is_hours_axis = 1
	    ELSE IF(LABEL(1:1).EQ.'D')THEN
		ITYPETb=0
		is_hours_axis = 0
	    ELSE IF(LABEL(1:1).EQ.'M')THEN
		ITYPETb=1
	    ELSE
		ITYPETb=3
	    ENDIF
C
C	PROCESS TIME AXIS STYLE
C
9331	    IF(ITYPETb.EQ.0)THEN
		IF(INDEX(LABEL,'HRD').NE.0)THEN
		    ITXTPEb=2
		ELSE
		    ITXTPEb=1
		ENDIF
	    ELSE IF(ITYPETb.EQ.1)THEN
		IF(INDEX(LABEL,'DAYM').NE.0)THEN
		    ITXTPEb=2
		ELSE
		    ITXTPEb=1
		ENDIF
		MONYRLAB = .FALSE.
		IF (INDEX(LABEL,'DMY').NE.0) MONYRLAB = .TRUE.
	    ELSE
		IF(INDEX(LABEL,'MON1').NE.0)THEN
		    ITXTPEb=3
		ELSE IF(INDEX(LABEL,'MONY').NE.0)THEN
		    ITXTPEb=2
		ELSE
		    ITXTPEb=1
		ENDIF

*               Century axis mod
	        CENFLAG = .FALSE.
	        IF(INDEX(LABEL,'MULTIY').NE.0) CENFLAG = .TRUE.

*               multi-decade axis mod
	        MULTICENFLAG = .FALSE. 
	        IF(INDEX(LABEL,'MULTID').NE.0) THEN
		   CENFLAGb = .TRUE. 
		   MULTICENFLAGb = .TRUE. 
	        ENDIF
	    ENDIF
	    MONYRLABb = .FALSE.  ! Option for MON and DAY types. 
	    IF (INDEX(LABEL,'DMY').NE.0) MONYRLABb = .TRUE.
	    IF (LABEL.EQ.'HR' .OR. LABEL.EQ.'PDAY') MONYRLABb = .TRUE.

	    LABELTb=ITXTPEb*ITXLBPb
	    
	    GOTO 10
c------------------------------------------------------------------------------------

C	TXLSZE
9400	    CONTINUE
	    IF (itflg .EQ. 2) THEN
	       IF(IFLG1)TCSIZEb=P(1)
	    ELSE
	       IF(IFLG1)TCSIZE=P(1)
	       IF (itflg.EQ.0.AND.IFLG1) TCSIZEb=P(1) 
	    ENDIF
	    
	    GOTO 10
C	TXLINT
9500	    CONTINUE
	    IF (itflg .EQ. 2) THEN
	       IF(IFLG1)IFDBb=P(1)
	       IF(IFLG2)ISDBb=P(2)
	    ELSE
	       IF(IFLG1)IFDB=P(1)
	       IF(IFLG2)ISDB=P(2)
	       IF (itflg.EQ.0) THEN
	          IF(IFLG1)IFDBb=P(1)
	          IF(IFLG2)ISDBb=P(2)
	       ENDIF

	    ENDIF
	    GOTO 10
C	TXNMTC
9600	    CONTINUE
	    IF (itflg .EQ. 2) THEN
	       IF(IFLG1)NMTCTb=P(1)
	    ELSE
	       IF(IFLG1)NMTCT=P(1)
	       IF (itflg.EQ.0 .AND.IFLG1)NMTCTb=P(1) 
	    ENDIF
	    GOTO 10
C	TXLABP
9700	    CONTINUE
	    IF (itflg .EQ. 2) THEN
	       IF(IFLG1)THEN
		  ITXLBPb=P(1)
		  LABELTb=ITXTPE*ITXLBP
	       ENDIF
	    ELSE
	       IF(IFLG1)THEN
		  ITXLBP=P(1)
		  LABELT=ITXTPE*ITXLBP
		  IF (itflg.EQ.0) THEN
 		     ITXLBPb=P(1)
		     LABELTb=ITXTPE*ITXLBP
		  ENDIF
	       ENDIF
	    ENDIF
	    GOTO 10
C restore delta-T for underlay plots
C	TAXUND
9750	    CONTINUE
	    DT_SAVE = P(1)
	    GOTO 10
C	AUTOLAB
9800	    IGTLAB=0
	    IF(LABON)IGTLAB=1
	    GOTO 10
C	EVAR
9900	    CALL UPPER(LABEL,2048)
	    LSOFFS=SOFFS
	    LSTIME=STIME
	    LSNEXT=SNEXT
	    CALL EPICVAR
	    GOTO 10
C	DEBUG
9910	    DEBUGF=LABON
	    GOTO 10
C	RESET
9920	    LABEL='PPL$RESET'
	    N=9
	    GOTO 4300
C	TITLE
9930	    IF(N.EQ.0)THEN
		LAB1=' '
	    ELSE
		LAB1=LABEL
	    ENDIF
	    IF(IFLG1)HLAB1=P(1)
	    GOTO 10
C	VPOINT
9940	    IF(IFLG1)VIEWX=P(1)
	    IF(IFLG2)VIEWY=P(2)
	    IF(M.GE.3.AND.IFLG(3).NE.0)VIEWZ=P(3)
	    WRITE(SYM,999)'X'
999	    FORMAT('*PPL$VIEW_',A1)
	    CALL PUTVAL(SYM,VIEWX,6,IER)
	    WRITE(SYM,999)'Y'
	    CALL PUTVAL(SYM,VIEWY,6,IER)
	    WRITE(SYM,999)'Z'
	    CALL PUTVAL(SYM,VIEWZ,6,IER)
	    GOTO 10
C	CLSPLT
9950	    CALL PLTYPE(ICODE)
*	    MOD *JD* 1.25.90 to accomodate use of clsplt and metafiles
*           *ACM* 4/5/05 After a set/win/clear need meta_actv false
*                        so VIEW/AXES can reset sizing info 

	    its_meta = ITS_META_GRAPHICS() .NE. 0
	    batch = ITS_BATCH_GRAPHICS() .NE. 0
	    meta_batch = .FALSE.
	    IF (batch) THEN
	       IF (its_meta) meta_batch = .TRUE.
	    ENDIF
            its_open = meta_open
            if (meta_batch .and. ws_state.GT.0) its_open = .true.

	    if (its_open .and. .not. meta_clsplt .and. .not. first_meta) then
	       if (meta_actv .OR. meta_batch) call gdawk (meta_wsid)
	       call gclwk (meta_wsid, batmode)
	       close (meta_lun)
	       meta_clsplt = .true.
               meta_actv = .false.     ! mode state is still saved in mode_metafile
	       vpt_was_set = .false.
	    elseif (meta_batch .and. vpt_was_set ) then
	       call gdawk (meta_wsid)
	       call gclwk (meta_wsid, batmode)
	       close (meta_lun)
	       meta_clsplt = .true.
               meta_actv = .false.
	       vpt_was_set = .false.
	    end if        

	    GOTO 10

C	RENAMPL
9960	    CONTINUE
*	Close and rename the metafile; reopen.
            strr = LABEL
	    IF (its_open .AND. first_meta) THEN
	       CLOSE (meta_lun, STATUS='KEEP')
	       CALL RENAME(strr, meta_file)
	       OPEN (UNIT=meta_lun,file=meta_file)
	    END IF        

	    GOTO 10

C	SHRINKY
9970	    CONTINUE
*	Whether to shrink ylabels automatically so they will fit in margin.
*       see YAXIS1
            SHRINKY = .FALSE.      
            IF (P(1) .EQ. 1) SHRINKY = .TRUE.      
	    GOTO 10

C	RIBFAST (RIBBON/FAST)  
9980	    CONTINUE
*	Plot style for ribbon plots: 
*	 FAST for one color per point, default is interpolate
*	 colors between points
            RIBBON_FAST = .FALSE.      
            IF (P(1) .EQ. 1) RIBBON_FAST = .TRUE.      
	    GOTO 10

C	RIBMISS (RIBBON/MISS=)  
9982	    CONTINUE
* Plot style for missing-data in ribbon plots: 
* Default: thin black line. Can request /missing=dash, /missing=blank, 
* /missing= color-palette (e.g. gray_light). The color palette 
* will typically be a one-color plot, or if a multicolor palette 
* is given its first color will be used.

            CALL RIBBON_MISSING      
	    GOTO 10


C	GAPLOC (PLOT/VS/GAPLOC)  
9984	    CONTINUE
* Extra variable sent on PLOT/VS plots, with 1 or zero to indicate
* end of segments
	    gap_var = 0
            gap_var = P(1) 
	    GOTO 10


C     CLRKLAB COLOR-KEY LABELS
9985	    CALL CLRKLAB (LABEL)
	    GOTO 10

C     RWDSEQ & RWD
600	    CALL OPENF(FILE,IERR)
	    IF(IERR.NE.0)GOTO 10
	    SYM='*PPL$EOF'
	    CALL PUTSYM(SYM,NO,2,IER)
	    IF(IFORM(1:3).EQ.'DSF'.OR.IFORM(1:4).EQ.'BIBO'
     *	    .OR.IFORM(1:3).EQ.'PPL')THEN
	    CALL RWDDSF(FILE)
	    GOTO 10
	ELSE IF(IFORM(1:3).EQ.'EPI')THEN
	    rewind (LUN11)
	    GOTO 10
	ENDIF
	REWIND LUNN
	GOTO 10
C     CONTOUR
1400	MAKEP='CONTOUR'
	if(iflg1)then
	    ivcomp=p(1)
	else
	    ivcomp=1
	endif
	if(iflg2)cangle=p(2)
1401	continue
#ifndef unix
	IF(LOGITF)CALL LOGGER('PPLCONT')
#endif
	GOTO 6001
C     PLOT
1500	MAKEP='PLOT'
	GOTO 6002
C     Ribbon PLOT
1550	MAKEP='RIBPLOT'
	GOTO 6002
C     READSEQ & RD
1600	CALL OPENF(FILE,IERR)
	IF(IERR.NE.0)GOTO 10
	CALL RDSEQ(pplmem,pplmem_nsize,PBUF,IBASE,FILE)
	GOTO 10
C     LIST
2900	CALL LIST(LTTOUT,pplmem,pplmem_nsize,LABEL)
	GOTO 10
C     SKPSEQ & SKP
3300	CALL OPENF(FILE,IERR)
	IF(IERR.NE.0)GOTO 10
	SYM='*PPL$EOF'
	CALL PUTSYM(SYM,NO,2,IER)
	J=IFIX(P(1))
	IF(M.EQ.0.OR.IFLG(1).EQ.0)J=1
	IF(IFORM(1:3).EQ.'DSF'.OR.IFORM(1:4).EQ.'BIBO'
     *	.OR.IFORM(1:3).EQ.'PPL')THEN
	DO 3304 I=1,J
	    CALL OPNDSF(FILE,'RD',LUNN)
	    CALL RDHDSF(LUNN,1,XPTS,K)
	    CALL CLSDSF(LUNN)
	    IF(K.EQ.0)GOTO 3302
3304	CONTINUE
	ELSE IF(IFORM(1:3).EQ.'EPI')THEN
	    CLOSE(LUNN)
	    DO 3305 I=1,J
		IF (LSCTD) THEN
		    CALL EPICRD(IDUM1,IDUM1,LEOF,.FALSE.)
		ELSE
		    CALL EPICTRD(IDUM1,XDUM1,XDUM2,XDUM3,XDUM4,XDUM5,
     *		    LEOF,.FALSE.)
		ENDIF
		IF(LEOF)GOTO 3302
3305	    CONTINUE
	ELSE IF(IFORM(1:3).NE.'UNF')THEN
	    DO 3301 I=1,J
3301	    READ(LUNN,*,END=3302)
	ELSE
	    DO 3303 I=1,J
3303	    READ(LUNN,END=3302)
	ENDIF
	GOTO 10
3302	IF(.NOT.QUIETF)WRITE(LTTOUT,'('' EOF'')')
	SYM='*PPL$EOF'
	CALL PUTSYM(SYM,YES,3,IER)
	GOTO 10
C	VIEW
3400	MAKEP='VIEW'
	IF(IFLG2)THEN
	    XYSCLE=1
	ELSE
	    XYSCLE=P(2)
	ENDIF
	IF(IFLG1)THEN
	    ZSCLE=P(1)
	ELSE
	    ZSCLE=0.
	ENDIF
	IF(M.GE.4.AND.(IFLG(3).NE.0.AND.IFLG(4).NE.0))THEN
	    VEWZMN=P(3)
	    VEWZMX=P(4)
	    IF(ZMN.GT.ZMX)THEN
		P1=VEWZMN
		VEWZMN=VEWZMX
		VEWZMX=P1
	    ENDIF
	ELSE
	    VEWZMN=ZMIN
	    VEWZMX=ZMAX
	ENDIF
	if(m.ge.5.and.iflg(5).ne.0)then
	    ivcomp=p(5)
	else
	    ivcomp=1
	endif
	GOTO 1401
C	ENTER
3500	IF(.NOT.QUIETF)WRITE(LTTOUT,'('' ENTER X,Y OR "END"'')')
	JTYPE=1
	YMIN=1.E38
	XMIN=YMIN
	XMAX=-XMIN
	YMAX=XMAX
	LINEN=LINEN+1
	CALL STPRMP('enter>',6)
	DO 3501 I=0,pplmem_nsize-1
3503	    CALL GETCMD(STRING,ISLEN,ICOM,P,IFLG,M,LABEL,N,LBSTRT)
	    IF(ICOM.EQ.'END')GOTO 3502
	    pplmem(IBASE+I)=P(1)
	    pplmem(pplmem_nsize/2+IBASE+I)=P(2)
	    IF(P(1).GT.XMAX)XMAX=P(1)
	    IF(P(1).LT.XMIN)XMIN=P(1)
	    IF(P(2).GT.YMAX)YMAX=P(2)
	    IF(P(2).LT.YMIN)YMIN=P(2)
3501	CONTINUE
3502	LLENG(LINEN)=I
	NX=I
	NY=1
	CALL RDSEQ2(pplmem,pplmem_nsize,PBUF,IBASE,FILE)
	CALL STPRMP('ppl+>',5)
	GOTO 10
C     MULTPLT
4900	CALL MULT
	GOTO 10
C     PLOTV
5300	MAKEP='PLOTV'
5301	IF(IFLG(1).EQ.1)VANG=P(1)
	GOTO 6002
C	PLOTUV
5700	MAKEP='PLOTUV'
	GOTO 5301
6002	CONTINUE
#ifndef unix
	IF(LOGITF)CALL LOGGER('PPLPLOT')
#endif
	IF(PBUF.EQ.0)THEN
	    IF(.NOT.QUIETF)WRITE(LTTOUT,'('' BUFF EMPTY'')')
	    GOTO 10
	ELSE
	    LINEN=0
	    IBASE=1
	ENDIF
6001	IF(N.NE.0)LAB1=LABEL
	ICOUNT=ICOUNT+1
	IF(IMULT.NE.1)THEN
	    CALL PLTIT(pplmem,pplmem_nsize)
	ELSE
	    CALL MPLOT(pplmem,pplmem_nsize)
	    IF(IMCNT.LT.MNX*MNY)GOTO 10
#ifdef unix
            rewind(lmult)
#else
	    OPEN(LMULT,FILE=MULTFL,STATUS='OLD',
     *	    FORM='UNFORMATTED')
#endif
	    DO 6003 IMCNT=1,MNX*MNY
		READ(LMULT,END=6004)IPTS,MXBOT,MYLEF
		READ(LMULT,END=6004)XLABS,YLABS,RLABS,LTYPE,XLLABS,
     *		YLLABS,LLTYPE,RHLABS,USRLBS
		CALL GET(LMULT)
		IF(JTYPE.EQ.1)THEN
		    CALL GETXY(LMULT,pplmem,pplmem_nsize)
		ELSE
		    CALL GETZ(LMULT,pplmem,NX,NY)
		ENDIF
		IF(IZTYP.NE.0)CALL GETZG(LMULT)
		CALL PLTIT(pplmem,pplmem_nsize)
6003	    CONTINUE
cc#ifdef unix
 6004         CLOSE(LMULT)
cc#else
cc6004	    CLOSE(LMULT,DISP='DELETE')
cc#endif
c
c	show mult file is closed by clearing the file name
c
	    MULTFL=' '
	    CALL MPLOT2(pplmem,pplmem_nsize)
	ENDIF
	GOTO 10
C	VELVCT
9100	MAKEP='VELVCT'
	GOTO 5301
C	VECTOR
9110	MAKEP='VECTOR'
	IF(IFLG1)VSKPX=P(1)
	IF(IFLG2)VSKPY=P(2)
	GOTO 6001
C       FLOWLINE (VECTOR/FLOWLINE)
9390	MAKEP='FLOW'
	IF(IFLG1)DENSITY=P(1)
	GOTO 6001
C	VECSET
9120	IF(IFLG1)VLEN=P(1)
	IF(IFLG2)VUSRLN=P(2)
	VAUTO=M.LT.2
	GOTO 10
C	VECKEY
9130	IF(IFLG1)VXLOC=P(1)
	IF(IFLG2)VYLOC=P(2)
	IF(M.GE.3.AND.IFLG(3).NE.0)VPOS=P(3)
	IF(N.GT.0)THEN
           VFRMT=LABEL
c Check if LABEL is a valid format: 
c do a test write to the string err_msg, using label as a format
           slen = TM_LENSTR(LABEL)
           IF (slen .GT. 1) THEN 
              IF (TM_HAS_STRING( label, '(I')) THEN
                 WRITE(err_msg,label,ERR=1999) 0
              ELSE
                 WRITE(err_msg,label,ERR=1999) 0.0
              ENDIF
           ENDIF
        ENDIF
	VUSER=SUSER
	VKEY=M.GE.2
	GOTO 10
c	usr
9140	temp2=' '
	call pplusr(label,ier,temp2)
	IF(ier.ne.0)then
	    ilen=lnblk(temp2,80)
	    temp='USR: '//temp2(:ilen)
	    if(.not.quietf)WRITE(LTTOUT,'(a)')temp(:ilen+5)
	    temp2='C '//temp(:ilen+5)
	    call echo(temp2,ilen+7)
	endif
	goto 10
C	SHADE
9150    MAKEP = 'SHADE'                                                       
        IF(N.NE.0)LAB1=LABEL                                                  
        ICOUNT=ICOUNT+1                                                       
        IF(IMULT.NE.1)THEN                                                    
            CALL PLTIT(pplmem,pplmem_nsize)                                               
        ELSE                                                                  
            CALL MPLOT(pplmem,pplmem_nsize)                                               
            IF(IMCNT.LT.MNX*MNY)GOTO 10                                       
            OPEN(LMULT,FILE=MULTFL,STATUS='OLD',                              
     *      FORM='UNFORMATTED')                                               
            DO 9151 IMCNT=1,MNX*MNY                                           
            READ(LMULT,END=9152)IPTS,MXBOT,MYLEF                              
	    READ(LMULT,END=9152)XLABS,YLABS,RLABS,LTYPE,XLLABS,YLLABS,LLTYPE, 
     *	    RHLABS,USRLBS                                                     
            CALL GET(LMULT)                                                   
            IF(JTYPE.EQ.1)THEN                                                
                CALL GETXY(LMULT,pplmem,pplmem_nsize)                                     
            ELSE                                                              
                CALL GETZ(LMULT,pplmem,NX,NY)                                      
            ENDIF                                                             
            IF(IZTYP.NE.0)CALL GETZG(LMULT)                                   
            CALL PLTIT(pplmem,pplmem_nsize)                                               
9151        CONTINUE    
9152        CLOSE(LMULT)
 
cc#ifdef FORTRAN_90                                           
cc9152        CLOSE(LMULT,STATUS='DELETE')                             c
cc#else
cc9152        CLOSE(LMULT,DISP='DELETE')                             
cc#endif
c                                                                  
c       show mult file is closed by clearing the file name         
c                                                                  
            MULTFL=' '                                             
            CALL MPLOT2(pplmem,pplmem_nsize)                                   
        ENDIF                                                      
        GOTO 10                                                    
C       SHAKEY                                                     
9160    call shade_key (-1)
        goto 10                                                    
C       SHASET                                                     
9170    call shade_set                                             
        goto 10
                                                 
C       S_KEY   (continuous color key, center labels, horizontal)                                                   
9165    ICODE=IFIX(P(1))
        IF (ICODE .LE. 1) call shade_key_cont (ICODE)
        call shade_key (ICODE)
        goto 10       
                                
C       SHADE_CELL   (use cellarray call for shade)                                                   
9166    ICODE=IFIX(P(1))
        call shade_cell (ICODE)
        goto 10       

c       area
*!9171 makep='AREA' NAME CHANGE *jd*
9171   makep='FILL'
        if(iflg1)then
            ivcomp=p(1)
        else
            ivcomp=1
        endif
        if(iflg2)cangle=p(2)
        GOTO 6001

 9172	makep='PLOTPOL'
        if(iflg1)then
            ivcomp=p(1)
        else
            ivcomp=1
        endif
        if(iflg2)cangle=p(2)
        GOTO 6001

 9173	makep='FILLPOL'
        if(iflg1)then
            ivcomp=p(1)
        else
            ivcomp=1
        endif
        if(iflg2)cangle=p(2)
        GOTO 6001

 9183	makep='FILLPOL'   ! makep='POLYGON'
        if(iflg1)then
            ivcomp=p(1)
        else
            ivcomp=1
        endif
        if(iflg2)cangle=p(2)
        GOTO 6001

 9174	call pattern_set
	goto 10

C  calendar
 9175	if(n.eq.0)then
	   set_name='GREGORIAN'
	else
	   set_name=label
	endif

	call tm_set_current_calendar (set_name, cal_status)
	if (cal_status .ne. merr_ok) GOTO 2999
	goto 10

#ifdef unix
9180    continue
#else
9180    call pixmap                                             
#endif
        goto 10                                                    
9190	call aline (pplmem,pplmem_nsize)
	goto 10
c COLOR
9191    call set_one_color
        goto 10
c LINECOLORS
9192    call set_num_linecolors
        goto 10
c sqfill
 9380   if(labon)sqfflg=.true.
        if(VALOFF .or. n.eq.0)sqfflg=.false.
        goto 10
9999	RETURN

c Format errors
1999    slen = TM_LENSTR1(LABEL)
        err_msg = 'Invalid format specification: '//LABEL(1:slen)
        CALL errmsg (ferr_out_of_range, status, err_msg, *9999)

c Calendar errors
2999    slen = lnblk (set_name,16)
	WRITE (err_msg, 9176) set_name(1:slen)
 9176	FORMAT('Calendar "',a, '" is invalid.')
        CALL errmsg (ferr_unknown_arg, status, err_msg, *9999)


	END
	SUBROUTINE OPENF(FILE,IER)
c  If format is EPIC:
c  Opens EPIC file on unit=11 if label is not blank.
c  Returns logical variable lepic in COMMON/COMEPL/ as true or false
c  to indicate whether this is an EPIC file or simply a pointer file.
c
c  Programmed by N Soreide, Jun 85.
c  Modified for pointer file, Oct 85.
c  Patched up Feb 88
c
	character line*132

*       Declarations added 9.6.88 J Davison          
        integer ier,isym,lnblk,i,ix                  
                                                     
        external lnblk                               
*       End declarations 9.6.88                      

c
c
c  Get EPIC (RIM) file with data file names
c
	include 'comepl_inc.decl'
	include 'COMEPL.INC'
	include 'epiclun_inc.decl'
	include 'EPICLUN.INC'
	include 'data_inc.decl'
	include 'DATA.INC'
	include 'cmrd_inc.decl'
	include 'CMRD.INC'
	include 'cmrdl_inc.decl'
	include 'CMRDL.INC'
	include 'lunits_inc.decl'
	include 'LUNITS.INC'
	include 'system_inc.decl'
	include 'SYSTEM.INC'

	CHARACTER FILE*(*),SYM*120
	IER=0
	IF(N.EQ.0)THEN
	    IF(FILE.EQ.' ')THEN
		IF(.NOT.QUIETF)WRITE(LTTOUT,999)
999		FORMAT(' NO FILE')
		IER=1
	    ELSE IF(IFORM(1:3).EQ.'EPI')THEN
		CLOSE(LUN1)
	    ENDIF
	ELSE
	    SYM='*PPL$INPUT_FILE'
	    ISYM=LNBLK(LABEL,2048)
	    CALL PUTSYM(SYM,LABEL,ISYM,IER)
	    CLOSE(LUNN)
#ifdef unix
            FILE=LABEL
#else
	    I=INDEX(LABEL,':')
	    IF(I.LE.0)THEN
		FILE='SY:'
		FILE(4:)=LABEL
	    ELSE
		FILE=LABEL
	    ENDIF
#endif
	    IF(IFORM(1:3).EQ.'DSF'.OR.IFORM(1:3).EQ.'BIB'
     *	    .OR.IFORM(1:3).EQ.'PPL')THEN
	        RETURN
	    ELSE IF(IFORM(1:3).EQ.'EPI')THEN
C
c  		Open EPIC file to read data file names
c
	    CLOSE(LUN1)
	    CLOSE(LUN11)
#ifdef unix
            open (unit=LUN11, form='formatted', status='old',
     1      file=FILE,err=100 )
#else
open (unit=LUN11, form='formatted', status='old',
     1	    readonly,file=FILE,err=100 )
#endif
c
c  Check whether this is EPIC file or other pointer file.
c
	    read (LUN11, 102) line
102	    format (a)
	    ix = index (line(1:132), 'EPIC')
	    if (ix .ne. 0 .or. line(1:1).eq. ' ')then
		lepic = .true.
	    else
		lepic = .false.
	    endif
	    rewind (LUN11)
	ELSE IF(IFORM(1:3).NE.'UNF')THEN
#ifdef unix
            OPEN(UNIT=LUNN,FILE=FILE,STATUS='OLD',ERR=100)
        ELSE
            OPEN(UNIT=LUNN,FILE=FILE,STATUS='OLD',ERR=100,
     *      FORM='UNFORMATTED')
#else
	    OPEN(UNIT=LUNN,FILE=FILE,STATUS='OLD',ERR=100,READONLY)
	ELSE
     	    OPEN(UNIT=LUNN,FILE=FILE,STATUS='OLD',ERR=100,READONLY,
     *	    FORM='UNFORMATTED')
#endif
	ENDIF
	ENDIF
	RETURN
100	IER=2
	IF(.NOT.QUIETF)WRITE(LTTOUT,998)FILE
998	FORMAT(1X,A30,' NOT FOUND')
	RETURN
	END

      SUBROUTINE RR_vuy_Qiao_init(id)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

      CALL ef_set_desc             (id,'v du/dy from Qiao (1997)')
      CALL ef_set_num_args         (id, 3)
      CALL ef_set_axis_inheritance (id, IMPLIED_BY_ARGS, 
     . IMPLIED_BY_ARGS,IMPLIED_BY_ARGS,IMPLIED_BY_ARGS)

      CALL ef_set_arg_name         (id, ARG1, 'v4') 
      CALL ef_set_arg_desc         (id, ARG1, 'v4')
      CALL ef_set_arg_unit         (id, ARG1, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG1, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG1, YES, YES, YES, YES)

      CALL ef_set_arg_name         (id, ARG2, 'u2')
      CALL ef_set_arg_desc         (id, ARG2, 'u2')
      CALL ef_set_arg_unit         (id, ARG2, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG2, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2, YES,  NO, YES, YES)

      CALL ef_set_arg_name         (id, ARG3, 'u5')
      CALL ef_set_arg_desc         (id, ARG3, 'u5')
      CALL ef_set_arg_unit         (id, ARG3, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG3, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG3, YES,  NO, YES, YES)

      END


      SUBROUTINE RR_vuy_Qiao_compute(id,arg_1,arg_2,arg_3,result)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER        id
      REAL           arg_1 (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .                      mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL           arg_2 (mem2lox:mem2hix, mem2loy:mem2hiy, 
     .                      mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL           arg_3 (mem3lox:mem3hix, mem3loy:mem3hiy, 
     .                      mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL           result (memreslox:memreshix,memresloy:memreshiy,
     .                       memresloz:memreshiz,memreslot:memreshit)
      INTEGER        res_lo_ss (4)
      INTEGER        res_hi_ss (4)
      INTEGER        res_incr  (4)
      INTEGER        arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER        arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER        arg_incr  (4,EF_MAX_ARGS)

      INTEGER        i,  j,  k,  l
      INTEGER        i1, j1, k1, l1
      INTEGER        i3, j3, k3, l3
      INTEGER        i2, j2, k2, l2

      REAL           dy

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)

      dy = 212.7e5  ! 2 degrees of latitude in cm

      i  = res_lo_ss(X_AXIS)
      i1 = arg_lo_ss(X_AXIS,ARG1) 
      i2 = arg_lo_ss(X_AXIS,ARG2) 
      i3 = arg_lo_ss(X_AXIS,ARG3) 

      j  = res_lo_ss(Y_AXIS)
      j1 = arg_lo_ss(Y_AXIS,ARG1) 
      j2 = arg_lo_ss(Y_AXIS,ARG2) 
      j3 = arg_lo_ss(Y_AXIS,ARG3) 

      l1 = arg_lo_ss(T_AXIS,ARG1) 
      l2 = arg_lo_ss(T_AXIS,ARG2) 
      l3 = arg_lo_ss(T_AXIS,ARG3) 
      DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         k1 = arg_lo_ss(Z_AXIS,ARG1)
         k2 = arg_lo_ss(Z_AXIS,ARG2)
         k3 = arg_lo_ss(Z_AXIS,ARG3)

         DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

           !  ARG_1 = v4 
           !  ARG_2 = u2
           !  ARG_3 = u5

           result(i,j,k,l) = ARG_1(i1,j1,k1,l1) *
     .        (ARG_3(i3,j3,k3,l3)-ARG_2(i2,j2,k2,l2))/dy

           k1 = k1 + arg_incr(Z_AXIS,ARG1)
           k2 = k2 + arg_incr(Z_AXIS,ARG2)
           k3 = k3 + arg_incr(Z_AXIS,ARG3)
         ENDDO 

         l1 = l1 + arg_incr(T_AXIS,ARG1)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
         l3 = l3 + arg_incr(T_AXIS,ARG3)
      ENDDO               
      END				

    	SUBROUTINE XEQ_QUERY

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute the QUERY command

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* for FERRET V300: 6/16/93
* V301:	11/05/93 - changed QUERY/PIPE to QUERY/IGNORE (a NO-OP)
*Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
* V66   *kms* 5/10 LIB_GET_LUN is a subroutine, not a function
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

        include 'tmap_dims.parm'
#       include "tmap_dset.parm"
        include 'xdset_info.cmn_text'
        external xdset_info_data
        include 'xtm_grid.cmn_text'
        external xgt_grid_data
	include	'ferret.parm'
	include	'slash.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'
	include 'xcommand.cmn'
	include 'xgui.cmn'

* local parameter declarations:
	INTEGER	    slash_all, slash_file, slash_ignore
	PARAMETER ( slash_all  = 1 + 0,
     .		    slash_file = 1 + 1,
     .		    slash_ignore = 1 + 2 )
	CHARACTER*1 NO_TAG
	PARAMETER ( NO_TAG = " " )

* local variable declarations:
	LOGICAL	do_all, fileout, its_ppl
	INTEGER	TM_LENSTR1, STR_UPCASE, vax_code,
     .		chout, flen, qfile, status, i, query, n
	CHARACTER fname*132, qry4*4


* initialize
	fileout = .FALSE.
	status = ferr_ok
        qfile = qual_given( slash_file )

* is this a QUERY/IGNORE NO-OP ?
	IF ( qual_given( slash_ignore ) .GT. 0 ) RETURN

* query given ?
	IF ( num_args .EQ. 0 ) GOTO 5300

* command given with /ALL ?
	do_all = qual_given( slash_all ) .GT. 0

* identify the query - if it starts with 'P' it is a PLOT+ query
	qry4 = cmnd_buff(arg_start(1):arg_end(1))
	vax_code = STR_UPCASE( qry4,
     .		   cmnd_buff(arg_start(1):arg_end(1)) )
	its_ppl = qry4(1:1) .EQ. 'P'
	IF ( .NOT. its_ppl ) THEN
	   DO 10 query = 1, max_queries
	      IF ( queries(query) .EQ. unspecified_name4 ) GOTO 10
	      IF ( qry4 .EQ. queries(query)(:4) )          GOTO 20
 10	   CONTINUE
	   GOTO 5100
	ENDIF

* command given with /FILE  - open output channel
 20        IF ( qfile .GT. 0 ) THEN
	   CALL EQUAL_STR_LC(
     .                  cmnd_buff(qual_start(qfile):qual_end(qfile)),
     .                  fname, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   flen = TM_LENSTR1(fname)
	   IF ( fname.NE.' ' ) THEN
	      CALL LIB_GET_LUN( chout ) 
	      OPEN ( UNIT = chout,
     .		     FILE = fname,
     .		     STATUS = 'UNKNOWN',
     .		     ERR = 5200 ) 
	      fileout = .TRUE.
	   ENDIF

	ELSE
	   chout = ttout_lun
	ENDIF

* do it
	IF ( its_ppl ) THEN
!	   QRY_PPL( chout, gui_fmt1, qry4, status ) 	   
	ELSE
	   CALL DO_QUERY( chout, gui_fmt1, query, NO_TAG, status )
	ENDIF
	IF ( status .NE. ferr_ok ) GOTO 5000
	
* exit
 1000	IF ( fileout ) THEN
	   WRITE ( chout, '(40A1)' ) ('=',i=1,40) 
	   CLOSE ( UNIT = chout, ERR = 5000 )
	ENDIF
	RETURN
 3000	FORMAT (I4, 2X, A4)

* error exits
 5000	RETURN
 5100	CALL ERRMSG( ferr_invalid_command, status,
     .		     'unknown QUERY: '//cmnd_buff(arg_start(1):arg_end(1)),
     .		     *1000 )
 5200	CALL ERRMSG( ferr_erreq, status, fname(1:flen), *1000 )
 5300	CALL ERRMSG( ferr_invalid_command, status, 'QUERY what?', *5000 )
	END

c gridding_subs.F
c Utility functions called by gridding functions


c nobsxytv 
c
c***********************************************************************
c...NOBS.....Based on gausswt, return only the # of obs in (x,y) gridbox
c............method is to call this sub for each data value
c............all calcs done in gridbox units
c............xx/x1/xf all in same units
c............yy/y1/yf all in same units

c  i	xx,yy,tt=x/y/t location of data pt (data units)
c  i	nx,ny,nt=size of grids
c  i	xaxlo,xaxyi, etc bounds of destination grid cells
c  o 	obs(nx,ny,nt) number of obs in each (x,y,t) gridbox
c--------------------------------------------------------------------------

	SUBROUTINE nobsxytv (obs_only, xx, yy, tt, vv, nx, ny, nt, 
     .             xaxlo,xaxhi, yaxlo,yaxhi, taxlo,taxhi, indx, obs)

      IMPLICIT NONE

* Argument declarations

        INTEGER nx, ny, nt, obs_only, indx(4,2)
	REAL xx, yy, tt, vv, xaxlo(*), xaxhi(*), 
     .       yaxlo(*), yaxhi(*), taxlo(*), taxhi(*), obs(nx,ny,2,nt)

* Local variable declarations

        INTEGER i, j, l, ig, jg, Lg

	lg = 1
	DO l = 1, nt
	   IF (tt.GE.taxlo(lg) .AND.
     .         tt.LT.taxhi(lg)) THEN
              jg = 1
	      DO j = 1, ny
		 IF (yy.GE.yaxlo(jg) .AND.
     .	             yy.LT.yaxhi(jg)) THEN
                    ig = 1
		    DO i = 1, nx
		       IF ( xx.GE.xaxlo(ig) .AND.
     .                      xx.LT.xaxhi(ig)) THEN

		          IF (obs_only .EQ. 0) THEN
		             obs(ig,jg,1,Lg) = obs(ig,jg,1,Lg) + vv
		             obs(ig,jg,2,Lg) = obs(ig,jg,2,Lg) + 1.
		          ELSE
		             obs(ig,jg,1,Lg) = obs(ig,jg,1,Lg) + 1.
		             ENDIF

* Store the min and max index used in this cruise
		             indx(1,1) = MIN(indx(1,1), ig)
		             indx(1,2) = MAX(indx(1,2), ig)
		             indx(2,1) = MIN(indx(2,1), jg)
		             indx(2,2) = MAX(indx(2,2), jg)
		             indx(4,1) = MIN(indx(4,1), Lg)
		             indx(4,2) = MAX(indx(4,2), Lg)
		       ENDIF !xx in grid box
		       ig = ig + 1
		    ENDDO  ! nx

		 ENDIF !yy in grid box
		 jg = jg + 1
	      ENDDO  ! ny

	   ENDIF !tt in grid box
	   lg = lg + 1
	ENDDO  ! nt

	RETURN
	END


c nobsxytv_var
c
c***********************************************************************
c...NOBS.....Based on gausswt, return only the # of obs in (x,y) gridbox
c............method is to call this sub for each data value
c............all calcs done in gridbox units
c............xx/x1/xf all in same units
c............yy/y1/yf all in same units

c this version returns the cell mean in obs(ig,jg,1,Lg)
c this version returns the cell variance in obs(ig,jg,3,Lg)

c  i	xx,yy,tt=x/y/t location of data pt (data units)
c  i	nx,ny,nt=size of grids
c  i	xaxlo,xaxyi, etc bounds of destination grid cells
c  o 	obs(nx,ny,nt) number of obs in each (x,y,t) gridbox
c--------------------------------------------------------------------------

	SUBROUTINE nobsxytv_var (obs_only, xx, yy, tt, vv, nx, ny, nt, 
     .             xaxlo,xaxhi, yaxlo,yaxhi, taxlo,taxhi, indx, obs)

      IMPLICIT NONE

* Argument declarations

        INTEGER nx, ny, nt, obs_only, indx(4,2)
	REAL xx, yy, tt, vv,xaxlo(*), xaxhi(*), yaxlo(*), yaxhi(*), 
     .       taxlo(*), taxhi(*), obs(nx,ny,3,nt)

* Local variable declarations

        REAL xxg, yyg, ttg, delta
        INTEGER i, j, l, ig, jg, Lg 

	lg = 1
	DO l = 1, nt
	   IF (tt.GE.taxlo(lg) .AND.
     .         tt.LT.taxhi(lg)) THEN
              jg = 1
	      DO j = 1, ny
		 IF (yy.GE.yaxlo(jg) .AND.
     .	             yy.LT.yaxhi(jg)) THEN
                    ig = 1
		    DO i = 1, nx
		       IF ( xx.GE.xaxlo(ig) .AND.
     .                      xx.LT.xaxhi(ig)) THEN

		          IF (obs_only .EQ. 0) THEN
		             obs(ig,jg,2,Lg) = obs(ig,jg,2,Lg) + 1.	! count
		             delta = vv - obs(ig,jg,1,Lg)
		             obs(ig,jg,1,Lg) = obs(ig,jg,1,Lg) + 
     .                          delta/obs(ig,jg,2,Lg) ! current est of mean
		             obs(ig,jg,3,Lg) = obs(ig,jg,3,Lg) - 
     .                          delta*(vv - obs(ig,jg,1,Lg)) !M2
		          ELSE
		             obs(ig,jg,1,Lg) = obs(ig,jg,1,Lg) + 1.
		          ENDIF

* Store the min and max index used in this cruise
		             indx(1,1) = MIN(indx(1,1), ig)
		             indx(1,2) = MAX(indx(1,2), ig)
		             indx(2,1) = MIN(indx(2,1), jg)
		             indx(2,2) = MAX(indx(2,2), jg)
		             indx(4,1) = MIN(indx(4,1), Lg)
		             indx(4,2) = MAX(indx(4,2), Lg)
		       ENDIF !xx in grid box
		       ig = ig + 1
		    ENDDO  ! nx

		 ENDIF !yy in grid box
		 jg = jg + 1
	      ENDDO  ! ny

	   ENDIF !tt in grid box
	   lg = lg + 1
	ENDDO  ! nt


	RETURN
	END

c ----------------
c http://en.wikipedia.org/wiki/Algorithms_for_calculating_variance#On-line_algorithm
c def online_variance(data):
c     n = 0
c     mean = 0
c     M2 = 0
c 
c     for x in data:
c         n = n + 1
c         delta = x - mean
c         mean = mean + delta/n
c         M2 = M2 + delta*(x - mean)  # This expression uses the new value of mean
c 
c     variance_n = M2/n
c     variance = M2/(n - 1)
c     return variance
c ------------------

c pickoutxytcv
c
c***********************************************************************
      SUBROUTINE pickoutxytcv (obs_only, vars, alon, alat, atimes,
     .   cruises, n, vv, xx, yy, tt, ncc)

*  Called from the scatter* family of gridding functions.
*  Pick out nth item from a set of arrays, which are really 
*  4-dimensioned arrays with normal axes on three of the four axes.

      IMPLICIT NONE
      REAL alon(*), alat(*), atimes(*), cruises(*), vars(*)
      REAL xx, yy, tt, vv
      INTEGER obs_only, n, ncc

      vv = 1.
      IF (obs_only .EQ. 0) vv = vars(n)
      xx = alon(n)
      yy = alat(n)
      tt = atimes(n)
      ncc = cruises(n)

      RETURN
      END

c
c modscatminmax
c
c***********************************************************************

      SUBROUTINE modscatminmax (axlo, axhi, nscat, scatm)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
* 
* ACM 11/00
*  Called by scat2gridlaplace* gridding functions.
*  If there is a modulo axis, apply modulo-ness to the coordinates in that 
*  direction of the scattered points.

*  ax           axlo, axhi outer box range of the modulo axis
*  nscat        input: number of scattered points, output: updated number.
*  scatm        scattered points coordinate array in the direction of the 
*               modulo axis

      IMPLICIT NONE
      REAL scatm(*)
      REAL*8 axlo, axhi
      INTEGER nscat, i
      REAL ax1, axf, scatpt, diff, range

      ax1 = axlo
      axf = axhi
      range = axf - ax1
      IF (range .EQ. 0.) RETURN  ! else the WHILE loops are infinite !

      DO 100 i = 1, nscat
         scatpt = scatm(i)
         diff = scatpt - axf
         DO WHILE (diff .GE. 0)
            scatpt = scatpt - range
            diff = scatpt - axf
         ENDDO

         diff = scatpt - ax1 
         DO WHILE (diff .LT. 0.)
            scatpt = scatpt + range
            diff = scatpt - ax1
         ENDDO

         scatm(i) = scatpt
  100 CONTINUE

      RETURN
      END

	SUBROUTINE ZABMV
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)zabmv.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C

C	CALL ZABMV
C
C	This routine creates a binary file that can be used to
c	construct device dependent plotting code
c
c	the file format is:
c
c	dimension x(63),y(63)
c	write(luhp)x,y
c
c	where:
c			x>0, y>0	is the coordinate to be
c					moved to, pen down
c
c			x<0, y>0	is a pen up move to -x,y
c
c			x>0, y<0	select pen x
c
c			x<0, y<0	plot end
c
c	D. Denbo  February 1985
c
#ifdef unix
	include 'PLTCOM.DAT'
#else
	include 'pplinc:PLTCOM.DAT'
#endif
	IF(.NOT.PLTFLG)THEN
	CALL BINBUF(ASIZE,BSIZE)
C
C	SELECT PEN 1
C
	CALL BINBUF(1.,-1.)
	PLTFLG=.TRUE.
	LPEN=.NOT.PEN
	ENDIF
	IF(PEN)THEN
	CALL BINBUF(A,B)
	ELSE
	CALL BINBUF(-A-.001,B)
	ENDIF
	RETURN
	END
	SUBROUTINE BINBUF(XN,YN)
C
C	fills the file buffer with a flush function
C
	DIMENSION XB(63),YB(63)
#ifdef unix
	include 'PLTCOM.DAT'
#else
	include 'pplinc:PLTCOM.DAT'
#endif
#ifdef unix
	CHARACTER ZFILE*81
#endif
	IF(NEWFIL)THEN
#ifdef unix
	len=lnblk(filez,81)
	icnt=1
100	write(zfile,999)filez(:len),fzcnt
999	format(a,i3.3)
	fzcnt=fzcnt+1
	icnt=icnt+1
	if(icnt.gt.100)stop 'can not open meta file'
	OPEN(UNIT=LUHP,FILE=ZFILE,FORM='UNFORMATTED',
     *	STATUS='NEW',ERR=100)
#else
	OPEN(UNIT=LUHP,FILE=FILEz,FORM='UNFORMATTED',
     *	STATUS='NEW')
#endif
	NEWFIL=.FALSE.
	IPT=1
	ENDIF
	XB(IPT)=XN
	YB(IPT)=YN
	IPT=IPT+1
	IF(IPT.GT.63)THEN
	WRITE(LUHP)XB,YB
	IPT=1
	ENDIF
	RETURN
	ENTRY BINFSH
	XB(IPT)=-1.
	YB(IPT)=-1.
	WRITE(LUHP)XB,YB
	CLOSE(LUHP)
	NEWFIL=.TRUE.
	IPT=1
	RETURN
	END

	SUBROUTINE CD_WRITE_DSG_DATA ( cdfid, vname, grid, lo, hi, dat, 
     .                           mode_upcase_output, fer_bad, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Write a hyperslab of data into the current output netCDF file
* pared down simplified version of CD_WRITE_VAR for writing a dsg 1-d variable

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - Science Data Integration Group
*  2/5/2019

* argument definitions:
*     cdfid   - netCDF id number for already opened CDF file
*     vname   - name of variable
*     grid    - defining grid for variable
*     lo      - low indices of variable hyperslab
*     hi      - high indices of variable hyperslab
*     dat     - data values to write
*     mode_upcase_output
*     fer_bad - bad flag, for handling packed  data
*     status  - return status

* include files
        include 'netcdf.inc'
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
        include 'cdf_tmap.parm'
        include 'ferret.parm'
        include 'xvariables.cmn'
	include 'xdset_info.cmn_text'
	external xdset_info_data
        include 'xunits.cmn_text'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data

* argument declarations
      LOGICAL mode_upcase_output
      INTEGER cdfid, grid, lo(*), hi(*), status
      CHARACTER*(*) vname
      REAL dat(*), fer_bad

* local variable declarations:

      INTEGER TM_LENSTR1, STR_SAME,
     .        start(nferdims), count(nferdims), idim, iaxis, cdfstat, vlen,
     .        slab_min(nferdims), slab_max(nferdims), tmrecax,
     .	      dims, varid, wrkspc, i, j, k, l, m, n,
     .	      vartyp, nvdim, vdims(8), nvatts, npts

      LOGICAL CD_GET_BOUNDS, TM_DFPEQ, CD_GET_ATTVAL, 
     .        got_it, scaled, do_warn, user_var
      CHARACTER*128 vbuff     
      REAL   bad, r_scale, r_offset
      REAL*8 scalefac, addoff
      REAL*8 r100_8(200)
      REAL*8 TM_WORLD
    
      INTEGER elen, numvals, nv 
      CHARACTER name*128

      REAL*4 r100_4(200)

* For error message
      CHARACTER*9 typnam(6)
      DATA typnam/'NC_BYTE', 'NC_CHAR', 'NC_SHORT', 'NC_INT', 
     .            'NC_FLOAT', 'NC_DOUBLE'/

* initialize
      name = vname
      vlen = TM_LENSTR1( name )

* get the variable id

      cdfstat = NF_INQ_VARID(cdfid, vname(:vlen), varid)
      IF ( cdfstat .NE. NF_NOERR ) GOTO 5100

* get the vital statistics for this variable

      cdfstat = NF_INQ_VAR (cdfid, varid, vbuff, vartyp, nvdim,
     .             vdims, nvatts)

* Get values for scalefac, addoff and bad-flag set in cdf_list for this variable

      scalefac = 1.
      addoff = 0.
      numvals = 1
      do_warn = .FALSE.
      got_it = CD_GET_ATTVAL ( cdfid, varid, "scale_factor",
     .                        do_warn, vname,
     .                        scalefac, numvals, nv )
      got_it = CD_GET_ATTVAL ( cdfid, varid, "add_offset",
     .                        do_warn, vname,
     .                        addoff, numvals, nv )
      got_it = CD_GET_ATTVAL ( cdfid, varid, "missing_value",
     .                        do_warn, vname,
     .                        bad, numvals, nv )
      IF (.NOT.got_it) got_it = 
     .         CD_GET_ATTVAL ( cdfid, varid, "_FillValue",
     .                        do_warn, vname,
     .                        bad, numvals, nv )

* enter data mode so data can be read and written
* (CD_GET_GENERIC_BOUNDS needs to read coordinate values)
      CALL CD_SET_MODE(cdfid, pcd_mode_data, status)
      IF ( status .NE. merr_ok ) RETURN

* get the hyperslab limits of this variable as stored in the file
      got_it = CD_GET_BOUNDS( cdfid, varid, slab_min, slab_max,
     .                        tmrecax, status )
      IF ( status .NE. merr_ok ) GOTO 5900
    
      IF (.NOT.got_it) CALL CD_GET_GENERIC_BOUNDS
     . ( cdfid, varid, grid, lo, slab_min, slab_max, tmrecax, status )

      IF ( status .NE. merr_ok ) GOTO 5900

* determine the start and count as netCDF will want them

      dims = 0
      DO idim = 1, nferdims
         IF ( lo(idim).NE.unspecified_int4) THEN
            dims = dims + 1
            start(dims) = lo(idim) - slab_min(idim) + 1
            count(dims) = hi(idim) - lo(idim) + 1
         ENDIF
      ENDDO

*xxxx   Never scale the missing flag: instead we read data, insert the default missing-flag
*xxxx   for internal use in computing etc, and then on output restore the
*xxxx   packing, and the incoming missing-data flag.

      scaled = .FALSE.
      r_offset = 0.
      r_scale = 1.

      IF ( .NOT. TM_DFPEQ(scalefac, 1.D0) .OR. 
     .     .NOT. TM_DFPEQ(addoff, 0.D0) ) THEN

         IF (.NOT. TM_DFPEQ(scalefac, 0.D0) ) THEN
	    r_scale = 1. /scalefac
            r_offset = -1.D0* addoff* r_scale
         ENDIF

         npts = 1
         DO 250  idim = 1, nferdims
            IF ( count(idim) .GT. 0 ) npts = npts* count(idim)
 250     CONTINUE

	 IF (user_var) THEN
	    CALL TM_SCALE_NOBAD( r_scale, r_offset, dat, npts, bad, vartyp )
	 ELSE

c file var: rescale, skipping missing and restoring the _FillValue from the input file.
            CALL TM_SCALE_SWITCH_BAD ( r_scale, r_offset, fer_bad, bad, dat, npts )
	 ENDIF

         scaled = .TRUE.
      ENDIF

* write the slab

      CALL CD_WRITE_VAR_SUB( cdfid, varid, vartyp, dims, start, count, 
     .	vdims(1), dat, cdfstat )

* If rescaled above, restore it to previous values so it can be reused 

      IF ( scaled ) THEN
         r_scale = scalefac
         r_offset = addoff
	 
	 IF (user_var) THEN
	    CALL TM_SCALE_NOBAD( r_scale, r_offset, dat, npts, bad, vartyp )
	 ELSE

c unpack again, skipping missing and going back to Ferret internal bad-flag.
            CALL TM_SCALE_SWITCH_BAD ( r_scale, r_offset, bad, fer_bad, dat, npts )

	 ENDIF
      ENDIF

      IF ( cdfstat .EQ. -60) GOTO 5260
      IF ( cdfstat .NE. NF_NOERR ) GOTO 5300

* successful completion
 1000 status = merr_ok
      RETURN

* error messages
 5100 CALL TM_ERRMSG
     . ( merr_unkvar, status, 'CD_WRITE_DSG_DATA', unspecified_int4,
     .   unspecified_int4,
     .   'variable was never created in CDF file',
     .   vname(:vlen), *5900 )

 5260 vbuff = vname 
      CALL TM_ERRMSG (cdfstat+pcdferr, status, 'CD_WRITE_DSG_DATA',
     .     no_descfile, no_stepfile, 
     .    'data in variable '//vbuff(:vlen)//
     .    ' not representable in output type '//typnam(vartyp),
     .     no_errstring, *5900 )

 5300 CALL TM_ERRMSG
     . ( cdfstat+pcdferr, status, 'CD_WRITE_DSG_DATA', unspecified_int4,
     . no_varid, 'failure writing to CDF output file',
     . no_errstring, *5900 )

* error exit
 5900   RETURN
	END

       SUBROUTINE INIT_T_AGG_MC_DSET(dset_num, nagfiles, memb_filename,
     .            memb_tstep_start, memb_tstep_end, memb_nstep_start, 
     .            memb_nsteps, memb_order, status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Initialize a multifile netCDF ("MC") T-aggregated dataset
*    - information equivalent to reading stepfile information from descriptor
*      file is passed in through the argument list
*    - call cd_init_dset on first file of data set to set up all 
*      common information for the dataset, such as variables, etc
*    - assemble the T-aggregate dataset and associate this
*      time axis with the parent grids
*
* V695+ *sh* 10/15 - new, hack-built from MC_INIT_DSET
* V698 *sh*   2/16 - member files may be disordered

* arguments:
*	dset_num	 - number assigned to this data set (input)
*	nagfiles	 - number of files in the aggregation (input)
*	memb_filename	 - array of filenames (input)
*	memb_tstep_start - array of first timestep in each file (input)
*	memb_tstep_end	 - array of last  timestep in each file (input)
*       memb_nstep_start - array of time axis indices of the first step (input)
*	memb_nsteps	 - array of N timesteps in each file (input)
*	memb_order	 - sequence ordering of member (input)
*	status		 - return status (output)

        IMPLICIT NONE
* Argument definitions
        INTEGER dset_num, nagfiles, memb_order(nagfiles), 
     .     memb_nstep_start(nagfiles), memb_nsteps(nagfiles), status
        REAL*8 memb_tstep_start(nagfiles), memb_tstep_end(nagfiles)
        CHARACTER*512	memb_filename(nagfiles)

* Parameter and common files

	include 'tmap_errors.parm'		! error codes
#include "tmap_dset.parm"	
	include 'tmap_dims.parm'		! data set dimensions
!#include "gt_lib.parm"
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xio.cmn_text'
        external xio_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xdset_info.cmn_text'		! data set common
	external xdset_info_data
	include 'xstep_files.cmn_text'		! step file common
	external xstep_files_data
	include 'xdset_info.cd_equiv'		! has mc_init_stepfile

* Define variables from Set File namelist records

	include 'descript.def'


* Internal declarations

	CHARACTER*13	TM_STRING
	INTEGER		ivar, stp_pos,
     .			istep, i, nrecperstep, epos, first_file,
     .			stp_cnt, min_pos, max_pos,istat,
     .			lline, file_reclen
	REAL*8		file_trange

* simulate reading of step records - one per file to be aggregated
	istep = 0

* Initialize some STEPFILE variables
	s_aux_set_num = 0       ! irrelevant?
	s_regvarflag  = ' '     ! irrelevant
	s_index       = ' '	! irrelevant
	file_reclen = unspecified_int4  ! irrelevant?
	s_delta	      = 0	! used to determine if regular time steps

* * * * * * top of stepfile loop * * * * *
	DO i = 1, nagfiles
	  istep = memb_order(i)

* calculate time range per file and check for even number per file
	  file_trange = memb_tstep_end(istep)-memb_tstep_start(istep)
	  s_delta = file_trange / DBLE(memb_nsteps(istep))

* Find the next storage position for stepfiles in common
	  IF (i .EQ. 1) THEN
* ... stepfile of first file in member list was assigned during netCDF init
	     DO stp_cnt = 1,maxstepfiles
	       IF (sf_setnum(stp_cnt) .EQ. dset_num) GOTO 100
	     ENDDO
	     GOTO 5100     ! should never happen
	  ELSE  
	     DO stp_cnt = stp_pos,maxstepfiles
	       IF (sf_setnum(stp_cnt) .EQ. set_not_open) GOTO 100
	     ENDDO
* No room left for new stepfiles
	     CALL TM_ERRMSG ( merr_filim, status, 'MC_AGG_INIT',
     .			   dset_num, no_stepfile,
     .			   'MAX='//TM_STRING(DBLE(maxstepfiles)),
     .			   no_errstring, *9900)
	   ENDIF

* store values in common
 100	  sf_setnum(stp_cnt) = dset_num
	  sf_name  (stp_cnt) = memb_filename(istep)
	  sf_1step (stp_cnt) = memb_tstep_start(istep)
	  sf_lastep(stp_cnt) = memb_tstep_end(istep)
* sf_ndxs and sf_ndxe contain the L limits for each file on the agg T axis
	  sf_ndxs  (stp_cnt) = memb_nstep_start(istep)
	  sf_ndxe  (stp_cnt) = sf_ndxs(stp_cnt) + memb_nsteps(istep) - 1
	  sf_delta(stp_cnt) = s_delta
!	  sf_aux_set_num(stp_cnt) = s_aux_set_num
	  sf_lunit(stp_cnt) = file_not_open
	  sf_index(stp_cnt) = s_index
	  sf_reclen(stp_cnt) = file_reclen !???uninited var in MC_INIT_DSET
	  IF (s_regvarflag .EQ. ' ') sf_regvars(stp_cnt) = .TRUE.
!	  IF (last_delta .EQ. -999.) last_delta = s_delta  ! relevant?
	  IF (s_delta .NE. 0) THEN
	    sf_regtimes(stp_cnt) = .TRUE.		   ! relevant?
	  ELSE
	    sf_regtimes(stp_cnt) = .FALSE.
	  ENDIF

* time-independent fields are read from the first file in the member list
	  IF (i .EQ. 1) mc_init_stepfile(dset_num) = stp_cnt

* prepare for next file
	  stp_pos = stp_cnt+1

	ENDDO  
* * * * end of stepfile loop * * * * *


* summarize certain stepfile info at the dataset level
	ds_1step(dset_num)  = memb_tstep_start(memb_order(1))
	ds_lastep(dset_num) = memb_tstep_end(memb_order(nagfiles))
	IF (ds_regsteps(dset_num)) THEN
	  ds_delstep(dset_num)  = line_delta(ds_time_axis(dset_num))
	ELSE
	  ds_delstep(dset_num) = 0.
	ENDIF
	status = merr_ok

	RETURN


* errors
 9900	status = ferr_TMAP_error
 5000	RETURN
 5100	CALL ERRMSG( ferr_internal, status, 'init_t_agg_mc_dset', *5000)
	END

	REAL FUNCTION CAL_FACTR (cal_id)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Find factor to adjust time units for different calendar axes.

* programmer - Ansley Manke
*
* revision 0.00 - 03-Mar-2001

* V570 *acm* 5/04  Add the calendar ALL_LEAP = 366_DAY.

* calling argument declarations:
	INTEGER cal_id

* local variable declarations
	INTEGER cal_id_greg
	REAL sec_per_year(6)

	include 'tmap_dims.parm'
	include 'xunits.cmn_text'

	sec_per_year(1) = 31556952.
        sec_per_year(2) = 31536000.
        sec_per_year(3) = 31557600.
        sec_per_year(4) = 31104000.
        sec_per_year(5) = 31622400.

	cal_id_greg = 1		! Default gregorian calendar
	CAL_FACTR = sec_per_year(cal_id_greg) / sec_per_year(cal_id)

c CAL_ID
c
c     1	'GREGORIAN',
c     2  'NOLEAP',
c     3  'JULIAN',
c     4  '360_DAY',
c     5  'ALL_LEAP'

c from xunits_data.F:
c
c	DATA	...
c
c     .		un_convert( -8)	/ 31622400.	/, ! sec per 366 day year
c     .		un_convert( -9)	/ 31104000.	/, ! sec per 360 day year
c     .		un_convert(-10)	/ 31556952.	/, ! sec per 365.2425 year
c     .		un_convert(-11)	/ 31536000.	/, ! sec per 365.0 day year
c     .		un_convert(-12)	/ 31557600.	/, ! sec per 365.25 day year

	RETURN
	END

	SUBROUTINE ASSIGN_MR_CX( cx, mr )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* fill a slot in the memory variable table with context information

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V200:  6/26/89 - extracted from ASSIGN_VARIABLE
* V530:  8/00 *sh* save data type, too
* V530:  6/01 *sh* save the delta value, too
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V685+ 10/13 *sh* added auxiliary regridding "aux" variables
* V692 7/14 *acm* ticket 2183: handle @WGT transform as for integrals

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'

* calling argument declarations:
	INTEGER		cx, mr

* internal variable declarations:
	INTEGER		idim, trans, grid
	REAL*8		TM_WORLD

* initialize
	grid = cx_grid( cx ) 

* background info
	mr_data_set ( mr )	= cx_data_set( cx )
	mr_category ( mr )	= cx_category( cx )
	mr_variable ( mr )	= cx_variable( cx )
	mr_type     ( mr )	= cx_type    ( cx )
	mr_grid     ( mr )	= grid
	mr_bad_data ( mr )	= cx_bad_data( cx )
	mr_unstand_grid( mr )   = cx_unstand_grid( cx )
	mr_naux     ( mr )      = cx_naux     ( cx )

* region, transformations and regridding transforms
	DO 100 idim = 1,nferdims
	   trans = cx_trans( idim, cx )
	   mr_trans  ( idim, mr )   = trans
	   mr_lo_ss  ( mr, idim )   = cx_lo_ss  ( cx, idim )
	   mr_hi_ss  ( mr, idim )   = cx_hi_ss  ( cx, idim )
	   mr_delta  ( idim, mr )   = cx_delta  ( idim, cx )
	   mr_aux_var( idim, mr )   = cx_aux_var( idim, cx )
	   mr_aux_cat( idim, mr )   = cx_aux_cat( idim, cx )
	   mr_trans_arg(idim, mr)   = cx_trans_arg(idim, cx)
	   mr_regrid_trans( idim, mr ) = cx_regrid_trans( idim, cx )

* round out to world coordinate box edges except in some special cases:
*   i) indefinite integrals (since they depend on exact integration limits)
*  ii) transforms (except MIN and MAX) that reduce to a point
* iii) user-defined variables that are based on transformed quantities
*      (e.g. DEFINE UAVE = U[K=1:3@AVE])

	   IF ( (trans .EQ. trans_integ_indef) .OR.
     .          (trans .EQ. trans_avg_wgt) .OR.
     .          (trans .EQ. trans_4d_avg_wgt) .OR.
     .          ( (trans .GT. trans_compress_code) .AND.
     .            (trans .NE. trans_max) .AND.
     .            (trans .NE. trans_min) ) .OR.
     .          (cx_lo_ss(cx,idim) .EQ. unspecified_int4) ) THEN
* ... catalog with exact world coordinate limits
	      mr_lo_ww( idim, mr ) = cx_lo_ww( idim, cx )
	      mr_hi_ww( idim, mr ) = cx_hi_ww( idim, cx )
	   ELSE
* ... round out limits out to indicate full span of end grid boxes
	      mr_lo_ww(idim, mr) = TM_WORLD( cx_lo_ss(cx,idim),
     .					     grid,
     .					     idim, box_lo_lim	)
	      mr_hi_ww(idim, mr) = TM_WORLD( cx_hi_ss(cx,idim),
     .					     grid,
     .					     idim, box_hi_lim	)
	   ENDIF
 100	CONTINUE

	RETURN
	END

	SUBROUTINE CHECK_MEMBER_SETS (agg_dim, nsets, memb_dsetnames,
     .				      member_sets, status)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP 
*
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V685 *acm*  3/13 For Ensemble aggregations, call the ds_type 'ENS'
* V695 *acm*  2/15 For Forecast aggregations, call the ds_type 'FCT'
* V695+ *sh*  5/15 removed block of code from here to INIT_AGGREGATE_DSET
*                  notably, the call to GET_AXIS_SPEED
* V698+ *sh* 11/15 add ok_re_use_existing to TM_INIT_DSET call
*            12/15 pass dataset names and nsets *into* this routine
*	           if dataset not already open, then open it hidden
*	      2/16 allow "-" as an indicator of a dummy dataset
*	      3/16 check for illegal Unix filenames
*	      4/16 defer checking aggs build of aggs to OK_AS_AGG_VAR

* calling arguments
*   agg_dim             - axis of the aggregation being created
*   nsets		- number of datasets to be aggregated (input)
*   memb_dsetnames	- array of names of the datasets (input)
*   member_sets		- array of open dataset numbers (output)
*   status		- return status

        include 'tmap_errors.parm'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
        include 'xprog_state.cmn'
	include 'xtm_grid.cmn_text'  
	include 'errmsg.parm'
	include 'netcdf.inc'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xfr_grid.cmn'
	include 'xdiag_ctrl.cmn_text'

* calling argument declarations:
	INTEGER agg_dim, nsets, member_sets(nsets), status
	CHARACTER*(*), memb_dsetnames(nsets)

* local variable declarations:
	LOGICAL TM_DIGIT, tregular, use_strict
	INTEGER TM_LENSTR, i, ich, buff_len, dset, iset, perm(nferdims)
	CHARACTER buff1*512

* local parameter definitions
	LOGICAL ok_re_use_existing
	PARAMETER ( ok_re_use_existing = .TRUE.)

	DO 100 iset = 1, nsets
	   member_sets(iset) = unspecified_int4
  100	CONTINUE

	DO 110 i = 1, nferdims
	   perm(i) = unspecified_int4
  110	CONTINUE

* Check on the aggregate-member datasets. (code taken from xeq_set)
* Open them if they're not already open.

	tregular = .FALSE.
	use_strict = .FALSE.

	DO iset = 1, nsets

	   buff1 = memb_dsetnames(iset)
	   buff_len = TM_LENSTR(buff1)

* check for legal Unix filename
* could use tm_legal_unix_name.F, but it is old and overly strict
* the netCDF library will refuse an illegal name, but it will not give a nice
* message
* can easily add more to this test as needed
	   IF (INDEX(buff1(:buff_len)," ") .GT. 0) GOTO 5050

	   IF (buff1 .EQ. "-") THEN
* dummy dataset indicator
	      IF (iset .EQ. 1) GOTO 5100
	      member_sets(iset) = pdset_dummy
	      CYCLE
	   ENDIF

* check to see if data set was referred to by number
* 9/95 - replaced "*" with "(I)" read from separate buffer
	   IF ( TM_DIGIT(buff1) ) THEN

* avoid crash due to single character "+" or "."
	      IF (buff_len.EQ.1
     .      .AND.(buff1(1:1).LT.'0' .OR. buff1(1:1).GT.'9')) GOTO 740

              DO ich = 1, buff_len
		IF ( .NOT. TM_DIGIT(buff1(ich:ich))) GOTO 740
	      ENDDO
	      READ (buff1,*) dset
#ifdef MANDATORY_FORMAT_WIDTHS
	      READ (buff1,*,ERR=740) dset
#else
	      READ (buff1,'(I)',ERR=740) dset
#endif
* ... check for valid number given
	      IF   ( dset .LT. 1
     .	      .OR.   dset .GT. maxdsets )	  GOTO 5200
	      IF (ds_name(dset).EQ.char_init1024) GOTO 5200
	      GOTO 750
	   ENDIF

* no! it wasn't given by number so open the data set
 740       ds_dset_type = 'CDF'   ! used and cleared in tm_init_dset

* initialize a TMAP-supported data set
 	   CALL TM_INIT_DSET( buff1, ok_re_use_existing,
     .			      perm, dset, tregular, use_strict, status )
	   
           IF ( status .NE. merr_no_action ) THEN  ! merr_no_action = already init'ed
	      IF ( status .NE. ferr_ok ) GOTO 5300 ! error in file or url
	      ds_hide(dset) = .TRUE.   ! hide unless previously opened
	   ENDIF

 750	   member_sets(iset) = dset

	ENDDO

	status = ferr_ok

 5000   RETURN	

* Error exits: 
 5050	CALL ERRMSG( ferr_invalid_command, status,
     .		'corrupted filename: '//buff1(:buff_len), *5000 )
 5100	CALL ERRMSG( ferr_invalid_command, status,
     .		'1st aggregate member may not be missing', *5000)
 5200	CALL ERRMSG( ferr_unknown_data_set, status,
     .		'dset '//buff1(:buff_len),         *5000 )
 5300	CALL ERRMSG( ferr_TMAP_error, status, ' ', *5000 )

	END

	SUBROUTINE FLOW_SET_UP (mr_list, cx_list, transpz)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* set up for flowline plots, determining if we need the cosine correction

* programmer - Ansley Manke -- from disp_set_up
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* 5/31/01
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

C replace includes with those from plot_set_up, 
C plus those starting w/ xbox_bounds:

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'ferret.parm'
	include 'xplot_setup.cmn'
	include 'xvariables.cmn'

	include 'vector_inc.decl'	! with need_cos
	include 'VECTOR.INC'		! with need_cos

*kob 1/97
	include 'xwindow_state.cmn'

* calling argument declarations:
	INTEGER		mr_list(*), cx_list(*)

* internal variable declarations:

	INTEGER	dim1, dim2, mvx, ctx, grid
        LOGICAL	GEOG_COS_FACTOR, transpz

* initialize
	mvx  = mr_list( 1 )
	ctx  = cx_list  ( 1 )
	grid = mr_grid( mvx )

* get dimensions of data region 
	dim1 = plot_axis(1)
	dim2 = plot_axis(2)

* will we need COS(latitude) corrections ? ( the true dx may be dx*COS(lat) )
        IF ( dim1.EQ.x_dim .AND. dim2.EQ.y_dim ) THEN
           need_cos =     GEOG_COS_FACTOR(x_dim, grid)
     .              .AND. GEOG_COS_FACTOR(y_dim, grid)
        ELSE
           need_cos = .FALSE.
        ENDIF

        trnspz = transpz

	RETURN
	END

      SUBROUTINE makedot

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C  Ansley Manke 8/2001
C  Plot a single point making polymark calls rather than polyline
C  based on XYZPLT
C  10/2001 simplifications that go with buffering the GPM calls
C  
C     THIS SUBROUTINE PERFORMS WINDOW CLIPPING IAND THEN MOVES THE
C     PEN FROM THE CURRENT POSITION TO A NEW POINT.

******************************************************************
C FERRET mod - for explicit declarations - 9-19-88
C      DIMENSION XMXMN(2),YMXMN(2)
      REAL XMXMN(2),YMXMN(2)
      EQUIVALENCE (XMXMN(1),XMAX),(YMXMN(1),YMAX)
      REAL xinter, yinter, zinter, dx, dy, dz, cosx, cosy, cosz, dist

#ifdef unix
      include 'pltcom_dat.decl'
      include 'PLTCOM.DAT'
#else
      INCLUDE 'tmap_pplv11inc:tmap_PLTCOM.DAT'
#endif
C end of FERRET mod
******************************************************************
C     Check the plotting mode.

      IF(PMODE .EQ. ALPHA)GO TO 30


      XNEW = XTEMP
      YNEW = YTEMP
      ZNEW = ZTEMP

  30  IF(.NOT. WINDOF)GO TO 40

C     Calculate the new off-window flag.

      OWFLG = 0
      IF(XNEW .GT. XMAX)OWFLG = 1
      IF(XNEW .LT. XMIN)OWFLG = 2
      IF(YNEW .GT. YMAX)OWFLG = OWFLG + 4
      IF(YNEW .LT. YMIN)OWFLG = OWFLG + 8

C     CHECK THE NEW POINT TO SEE IF IT IS WITHIN THE BOUNDARY OF
C     THE WINDOW.  IF NOT, DO NOT PLOT IT.

      IF(OWFLG .NE. 0)GO TO 50

C     Transform the point to the screen coordinate system.

  40  CALL TFORM(XNEW,YNEW,ZNEW)

C     Plot the point.

      CALL ABPLT_makedot

C     Move the coordinates of the new point to the old point.

  50  XOLD = XNEW
      YOLD = YNEW
      ZOLD = ZNEW
      LOWFLG = OWFLG
      SAVEF = .FALSE.

C     CALCULATE THE OLD OFF-SCREEN FLAG.

      LOSFLG = 0
******************************************************************
C FERRET mod - bypass GKS clipping - 9-19-88
      IF ( ptype .LT. 3 ) THEN
          IF(AOLD - 0.001 .GT. AMAX)LOSFLG = 1
          IF(AOLD + 0.001 .LT. AMIN)LOSFLG = 2
          IF(BOLD - 0.001 .GT. BMAX)LOSFLG = LOSFLG + 4
          IF(BOLD + 0.001 .LT. BMIN)LOSFLG = LOSFLG + 8
       ENDIF
C end of FERRET mod
******************************************************************


  60  RETURN
      END

      SUBROUTINE ABMV
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)abmv.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C     Mod *JD* 4.5.91 to include PLTDAT.DAT in unix/vms system dependent way

C     CALL ABMV
C
C     ALL PLOTTING EVENTUALLY MUST BE ACCOMPLISHED BY MOVING THE
C     PEN FROM ONE LOCATION TO ANOTHER.  ABMV PERFORMS THIS FUNC-
C     TION BY CALLING THE DRIVER ROUTINES FOR THE VARIOUS PLOTTING
C     DEVICES.  THESE SUBROUTINES ARE LISTED BELOW:
C        TABMV  - TEKTRONIX GRAPHICS TERMINAL
C        PRABMV - PRINTRONIX PRINTER PLOTTER
C        ZABMV  - ZETA PLOTTER
C        BABMV  - BENSON PLOTTER
C	 GKSMV  - GKS DRIVER
C
C
C *kob* 9/98 - use external statemen to initialize block data rather than an
C              included .DAT file.  the latter was causing mutliple 
C              references 

#ifdef unix
      include 'PLTCOM.DAT'
      external pltdat_block_data
#else
      include 'pplv11inc:PLTCOM.DAT'
      include 'pplv11inc:PLTDAT_VMS.DAT'
#endif
C

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C
C     CHECK THE PLOT TYPE.
C
      GO TO(10,40,30,10,10,20,20),PTYPE + 3
C
C     PLOT ON THE TEKTERMINAL.
C
   10 CALL TABMV
	GOTO 25
20	CALL GKSMV
C
C     CHECK FOR OTHER PLOTTING DEVICES.
C
25      GOTO(40,50,50,50,30,50,30),PTYPE +3
C
C     PLOT ON THE PRINTRONIX PRINTER PLOTTER.
C
C
C     PLOT ON THE ZETA PLOTTER.
C
   30 CALL ZABMV
	GOTO 50
C
C	PLOT ON THE HP7475 PLOTTER
C
C
40	CALL HPABMV
   50 LPEN = PEN
      RETURN
C
      END

*
* samplei_multi.F
*
* Ansley Manke
* Dec 1998
*
* This function samples data along the I axis using a set of indices
* which may be different for the j,k,L dimensions.
* 4/5/99  Ansley Manke 
*         Indices may be oriented along any axis; 
*         Result is abstract on the sampled axis.
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE samplei_multi_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      CHARACTER*100 fcn_desc
      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns data sampled according to I indices which ',
     . 'may vary in JKL')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 2)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, ABSTRACT, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)

      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'I_INDICES')
      CALL ef_set_arg_desc(id, arg, 'indices upon which to sample')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'DAT_TO_SAMPLE')
      CALL ef_set_arg_desc(id, arg, 'data to sample using I indices')
      CALL ef_set_axis_influence(id, arg, NO, YES, YES, YES)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* loss               lo subscript for an axis
*
* hiss               hi subscript for an axis
*

      SUBROUTINE samplei_multi_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER my_lo_l, my_hi_l
      INTEGER nx, ny, nz, nt

*     Use utility functions to get context information about the 
*     1st argument, to set the abstract axis lo and hi indices.

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nx = arg_hi_ss(X_AXIS, ARG1) - arg_lo_ss(X_AXIS, ARG1) + 1
      ny = arg_hi_ss(Y_AXIS, ARG1) - arg_lo_ss(Y_AXIS, ARG1) + 1
      nz = arg_hi_ss(Z_AXIS, ARG1) - arg_lo_ss(Z_AXIS, ARG1) + 1
      nt = arg_hi_ss(T_AXIS, ARG1) - arg_lo_ss(T_AXIS, ARG1) + 1

      my_lo_l = 1
      my_hi_l = nx
      IF (arg_hi_ss(X_AXIS, ARG1) - arg_lo_ss(X_AXIS, ARG1) .EQ. 0)
     .    my_hi_l = max(nx,ny,nz,nt)

      CALL ef_set_axis_limits(id, X_AXIS, my_lo_l, my_hi_l)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END
*
* In this subroutine we compute the result
*
      SUBROUTINE samplei_multi_compute(id, arg_1, arg_2, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .     mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .     mem2lot:mem2hit)
     .     
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .      memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      INTEGER id, i, j, k, l
      INTEGER i1, j1, k1, l1
      INTEGER j2, k2, l2
      INTEGER iorder
      REAL aorder

      INTEGER nlen(3), unspecified_int4
      CHARACTER*8 lefint, aindex(3) 
      CHARACTER*100 errtxt

      unspecified_int4 = -111

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      j1 = arg_lo_ss(Y_AXIS,ARG1)
      j2 = arg_lo_ss(Y_AXIS,ARG2)
      DO 400 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS) 

         k1 = arg_lo_ss(Z_AXIS,ARG1)
         k2 = arg_lo_ss(Z_AXIS,ARG2)
         DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

            l1 = arg_lo_ss(T_AXIS,ARG1)
            l2 = arg_lo_ss(T_AXIS,ARG2)
            DO 200 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

                i1 = arg_lo_ss(X_AXIS,ARG1)
                DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

*  Get the index to sample, whichever axis of arg_1 it is on.

                   aorder = arg_1(i1,j1,k1,l1)
                   IF (i1 .EQ. unspecified_int4) 
     .                  CALL pickindex(arg_1, i, aorder)
                   iorder = aorder

*  Check that we do have an index of ARG_2; set the result

                  IF (aorder .EQ. bad_flag(ARG1)) THEN
                     result(i,j,k,l) = bad_flag_result
                  ELSE

                     IF (iorder .LT. arg_lo_ss(X_AXIS,ARG2)  .OR.
     .                   iorder .GT. arg_hi_ss(X_AXIS,ARG2) ) THEN
                        GO TO 999
                     ELSE

                        IF (arg_2(iorder,j2,k2,l2) .EQ. bad_flag(ARG2))
     .                   THEN
                           result(i,j,k,l) = bad_flag_result
                        ELSE
                           result(i,j,k,l) = arg_2(iorder,j2,k2,l2)
 
                        END IF
                     END IF
                  END IF

                  i1 = i1 + arg_incr(X_AXIS,ARG1)
 100           CONTINUE

               l1 = l1 + arg_incr(T_AXIS,ARG1)
               l2 = l2 + arg_incr(T_AXIS,ARG2)
 200        CONTINUE

            k1 = k1 + arg_incr(Z_AXIS,ARG1)
            k2 = k2 + arg_incr(Z_AXIS,ARG2)
 300     CONTINUE

         j1 = j1 + arg_incr(Y_AXIS,ARG1)
         j2 = j2 + arg_incr(Y_AXIS,ARG2)
 400  CONTINUE

      RETURN 

999   CONTINUE

      aindex(1) = LEFINT(iorder,nlen(1))
      aindex(2) = LEFINT(arg_lo_ss(X_AXIS,ARG2),nlen(2))
      aindex(3) = LEFINT(arg_hi_ss(X_AXIS,ARG2),nlen(3))

      WRITE (errtxt,*) 'Sampling index ', aindex(1)(1:nlen(1)), 
     . ' in ARG1 is outside the range of I indices for ARG2 (', 
     .  aindex(2)(1:nlen(2)), ':', aindex(3)(1:nlen(3)), ')'

      CALL ef_bail_out(id, errtxt)

      RETURN
      END
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************
      SUBROUTINE pickindex(arr, iindex, aorder)

*  Get the index to sample, whichever axis of arg_1 it is on.  Collapse
*  array arr to one dimension and return the i'th point.

      real arr(*), aorder
      integer iindex

      aorder = arr(iindex)

      return
      end

    	SUBROUTINE SHOW_DYN_GRIDS(mods_cx)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* summarize the dynamic grids and axes currently in existence
* also do sanity checks that use counts are appropriate

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V420:  11/95
*Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
* V510 *sh* 4/00 - grids may also be allocated by data set variables
*                  Use /DYNAMIC/ALL to see them.
* V532 5/01 *sh* - bug fix: ignore deleted static grids when chking axis usage
* V650  Write to show_lun which may be set to a file unit number rather than std out
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V697  12/15 *acm* Changes to add details on SHOW GRID uvar to indicate 
*                   compressed or subsetted axes
* V710 *acm* 10/16 Ticket 2422: variables uvar_grid, uvar_data_type, uvar_aux_cat, 
*                  uvar_aux_var to be replaced with calls to LIST routines in NCF_Util.c 

* FERRET DOCUMENATION:  dynamic grids and axes
* (entered 1/2016 *sh*)
* There are three types of grids in Ferret:  legacy, dynamic, and temporary
* 1. Legacy grids occupy grid storage belowup to index max_grids
*    They are brute-force allocated using TM_GET_GRIDNUM.
* 2. Dynamic grids occupy grid storage above max_grids.
*    They are managed using routines with "_dyn_" in their names.
*    They appear as a simple table, like the legacy grids, but they are
*    managed through a doubly-linked list into lists of "free" and "used" grids
*    A use count (grid_use_cnt) keeps track of when they are no longer needed.
*    When a use count falls to zer (through de-allocation) a grid is
*    automatically returned to the free list.
*    Each variable in a dataset that depends upon a grid constitutes a "use"
*    as does each memory-resident user variable instance defined on that grid.
*    This routine checks that these counts have not been corrupted.
* 3. Temporary grids are a linked lists of grids that have been temporarily
*    removed from the free and used lists.  They are managed by routines that
*    have "_tmp_" in their names.
*    Grids are put onto the temporary list during the process of initializing
*    a dataset, so that if an error condition occurs during initialization
*    it is simple to clean up the partially created grids.  At successful
*    completion of initializing a dataset all temporary grid should be moved
*    back to the free or used lists. Some go back to the free list because
*    duplicate grid definitions occur temporarily during dataset initialization
* 
* Dynamic management of axes ("lines") is very similar.  Each grid that uses a
*    line bumps the use count for that line.  

        IMPLICIT NONE
	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'xdset_info.cmn_text'
	include 'xtm_grid.cmn_text'
	include	'ferret.parm'
	include	'slash.parm'
	include 'xprog_state.cmn'
	include 'xvariables.cmn'
	include 'xrisc.cmn'          ! 12/94 SPLIT_LIST buffer
        include 'xfr_grid.cmn'   ! w/ mgrid_abstract
	include 'errmsg.parm'

* calling argument declarations:
	INTEGER mods_cx

* local variable declarations:
        LOGICAL show_all, shown, uvgrid
	INTEGER grid, line, dset, var, count, i, slash_all, status
	INTEGER ngrids, saved_uvgrid
	CHARACTER sanity_msg*24

* local parameter declarations
        PARAMETER ( slash_all  = 1 + 0 )

* initialize
        show_all   = qual_given( slash_all ) .GT. 0
	uvgrid = .FALSE.

* first show the dynamic grids
        shown = .FALSE.
	grid = grid_flink(max_grids)
 	IF ( grid .EQ. max_grids ) THEN
	   CALL SPLIT_LIST(pttmode_explct, show_lun,
     .						'No dynamic grids',16)
	ELSE
	   CALL SPLIT_LIST(pttmode_explct, show_lun,
     .						'Dynamic grids:',14)
	ENDIF
* ... --- "while" loop
 100	IF ( grid .NE. max_grids ) THEN
* ... is this an exlicit (netCDF) grid that shouldn't be shown 
           IF (grid_name(grid)(1:1).NE.'(' .AND. .NOT.show_all) THEN
               grid = grid_flink(grid)
               GOTO 100
           ENDIF
* ... sanity check the use count -- must be in use by user vars or dset vars

	   count = 0
           IF (grid .EQ. mgrid_abstract) count = 1  ! is it SET GRID?
	   
	   DO 125 var = 1, max_uvar

              CALL GET_SAVED_UVAR_GRID_LIST_LEN(var, ngrids)
	      IF (ngrids .GT. 0) THEN

		 dset = uvar_dset(var)             ! the dset that owns this LET/D
		 IF (dset .LE. pdset_irrelevant) dset = pdset_uvars  ! global uvars
		 DO i = 1, ngrids
		    CALL NCF_NEXT_UVAR_GRID_IN_LIST ( dset, var, i, saved_uvgrid )
		    IF ( saved_uvgrid .EQ. grid ) count = count + 1
		 ENDDO

	      ENDIF
		    
 125	   CONTINUE

	   DO 135 var = 1, maxvars
	      IF ( ds_grid_number(var) .EQ. grid ) count = count + 1
 135	   CONTINUE
	   IF ( count .EQ. grid_use_cnt(grid) ) THEN
	      sanity_msg = ' '
	   ELSEIF ( count .GT. grid_use_cnt(grid) ) THEN
	      sanity_msg = 'err: grid under-allocated'
	   ELSE
	      sanity_msg = 'err: grid over-allocated'
	   ENDIF
* ... end of sanity check
* 4/99 *kob* modify write and format statement - mostly for stylistic reasons
	   WRITE (risc_buff,3000) 'GRID', 
     .           grid_name(grid),
     .            grid_use_cnt(grid),
     .					sanity_msg
* *kob* 4/99 shorten dynamic grid name on output statment
 3000	   FORMAT ( 4X,A,1X,A16,16X, 'use count:',I4,5x,A)
	   CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	   CALL SHOW_GRID(grid, mods_cx, uvgrid, status)
	   IF (status .NE. ferr_ok) GOTO 5000
           shown = .TRUE.
	   grid = grid_flink(grid)
	ENDIF
	IF (grid .NE.max_grids) GOTO 100
        IF (.NOT.shown)  CALL SPLIT_LIST(pttmode_explct, show_lun,
     .					'    no implicit grids',21)

* now the dynamic axes
        shown = .FALSE.
	line = line_flink(max_lines)
 	IF ( line .EQ. max_lines ) THEN
	   CALL SPLIT_LIST(pttmode_explct, show_lun,
     .						'No dynamic axes',15)
	ELSE
	   CALL SPLIT_LIST(pttmode_explct, show_lun,
     .						'Dynamic axes:',13)
	ENDIF
* ... --- "while" loop
 200	IF ( line .NE. max_lines ) THEN
* ... is this an exlicit (netCDF) grid that shouldn't be shown 
           IF (line_name(line)(1:1).NE.'(' .AND. .NOT.show_all) THEN
               line = line_flink(line)
               GOTO 200
           ENDIF
* ... sanity check the use count -- must be in use by user vars
	   count = 0
* ... in use by static grids
	   DO 225 grid = 1, max_grids-1
              IF ( grid_name(grid) .NE. char_init16 ) THEN
	        DO 220 i = 1, nferdims
	           IF ( grid_line(i,grid) .EQ. line ) count = count + 1
 220	        CONTINUE
              ENDIF
 225	   CONTINUE
* ... in use by dynamic grids
	   grid = grid_flink(max_grids)
 230	   IF ( grid .NE. max_grids ) THEN
	      DO 232 i = 1, nferdims
	         IF ( grid_line(i,grid) .EQ. line ) count = count + 1
 232	      CONTINUE
	      grid = grid_flink(grid)
	   ENDIF
	   IF (grid .NE.max_grids) GOTO 230
* ... in use by other axes
	   DO 235 i = max_lines, max_dyn_lines
	         IF ( line_parent(i) .EQ. line ) count = count + 1
 235	   CONTINUE
	   IF ( count .EQ. line_use_cnt(line) ) THEN
	      sanity_msg = ' '
	   ELSEIF ( count .GT. line_use_cnt(line) ) THEN
	      sanity_msg = 'err: axis under-allocated'
	   ELSE
	      sanity_msg = 'err: axis over-allocated'
	   ENDIF
* ... end of sanity check
* *kob* 4/99 - reference format statement at 3000 - for stylistic reasons
	   WRITE (risc_buff,3000) 'AXIS',line_name(line), line_use_cnt(line),
     .					sanity_msg
	   CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
           shown = .TRUE.
	   line = line_flink(line)
	ENDIF
	IF (line .NE.max_lines) GOTO 200
        IF (.NOT.shown)  CALL SPLIT_LIST(pttmode_explct, show_lun,
     .					'    no implicit axes',20)

 5000	RETURN
	END

	BLOCK DATA XERRMSG_TEXT_DATA

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* error message strings
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.00 -  3/31/86
* revision 0.1 --> 3/18/87+ - added several gerrs
* revision 1.0  -  5/14/87 - added last error and error codes
* revision 1.1  -  9/25/87 - changed relative coords error message
* revision 1.2  -  2/15/88 - data_set_not_set --> grid_definition 
* revision 1.3  -  3/2/88  - contour_line --> no_range
* revision 1.4  -  3/10/88 - k_depth --> perm_var
* revision 1.5  -  4/6/88  - cos_innac --> descriptor
* revision 1.6 -   8/4/88  - changed insuff memory text
* revision 1.7 -   1/3/89  - too_many_dsets --> regrid
* revision 1.8 -  1/12/89  - changed error texts to be compatible with
*			     ERRMSG prefixing "ERROR:"
* V200: 10/16/89 - added ferr_ODR_error for Panasonic laser disk
*	  2/7/90 - changed text of unknown_arg
*        23/9/91 - unused ferr_gks --> ferr_not_implemented
* V230:   8/5/92 - "ignored" removed from text of ferr_too_many_args
*        11/9/92 - text of unknown variable mentions not in data set
* V530: *sh* 9/00 - added ferr_data_type
* V580 *acm* 11/04 - New code ferr_nomessge for use when user-given error  
*                    msg in coached string substitution
* V6.2 *acm*  2/09 - Change the text of insufficent memory error to 
*                    request exceeds memory setting
* V6.7 *acm*  1/11 - Fix ticket 1768: undefined messages for no-such-attribute
*                    and error in attribute caused nulls to be written to std out.
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V684 9/12 *acm*  - Add error code for file not found
*                    (error message for font files not found)
* V658+ *sh* 10/13 - added ferr_unknown_auxvar
* V72  *acm*  6/17 - add ferr_ppl_error to call errmsg routine for syntax
*                    errors calling PPLUS, see ticket 2543
* V76:  1/2020 -     Remove obsolete ferr_ODR_error 

        IMPLICIT NONE
	include 'errmsg.parm'	! parameter definitions
	include 'xerrmsg_text.cmn'	! common declaration


* last error reported
	DATA last_error / ferr_ok /

* codes for "special" errors
	DATA special_err_code( ferr_ok        - gspecial ) / 'ok'	/,
     .	     special_err_code( ferr_erreq     - gspecial ) / 'erreq'	/,
     .	     special_err_code( ferr_interrupt - gspecial ) / 'interrupt'/

* codes for errors that are not reported explicitly by GFDL
	DATA noreport_err_code( ferr_TMAP_error - gnoreport ) / 'TMAP_error'/

* codes and text for normal error messages
	DATA err_text( ferr_insuff_memory - greport )
     .		/ 'request exceeds memory setting'/
	DATA report_err_code( ferr_insuff_memory - greport )
     .		/ 'insuff_memory'/

	DATA err_text( ferr_too_many_vars - greport )
     .		/ 'too many variables to store in memory'	/
	DATA report_err_code( ferr_too_many_vars - greport )
     .		/ 'too_many_vars'/

	DATA err_text( ferr_perm_var	  - greport )		! unused
     .		/ 'data flagged as permanent'		/
	DATA report_err_code( ferr_perm_var	  - greport )
     .		/ 'perm_var' /

	DATA err_text( ferr_syntax	  - greport )
     .		/ 'command syntax'			/
	DATA report_err_code( ferr_syntax	  - greport )
     .		/ 'syntax' /

	DATA err_text( ferr_unknown_qualifier - greport )
     .		/ 'unknown command qualifier'			/
	DATA report_err_code( ferr_unknown_qualifier- greport )
     .		/ 'unknown_qualifier' /

	DATA err_text( ferr_unknown_variable - greport )
     .		/ 'variable unknown or not in data set'		/

	DATA report_err_code( ferr_unknown_variable - greport )
     .		/ 'unknown_variable' /

	DATA err_text( ferr_invalid_command  - greport )
     .		/ 'invalid command'			/
	DATA report_err_code( ferr_invalid_command  - greport )
     .		/ 'invalid_command' /

	DATA err_text( ferr_regrid - greport )
     .		/ 'regridding'				/
	DATA report_err_code( ferr_regrid - greport )
     .		/ 'regridding' /

	DATA err_text( ferr_cmnd_too_complex - greport )
     .		/ 'command too complex'				/
	DATA report_err_code( ferr_cmnd_too_complex - greport )
     .		/ 'cmnd_too_complex' /

	DATA err_text( ferr_unknown_data_set - greport )
     .		/ 'unknown data set'				/
	DATA report_err_code( ferr_unknown_data_set - greport )
     .		/ 'unknown_data_set' /

	DATA err_text( ferr_too_many_args - greport )
     .		/ 'too many arguments'/
	DATA report_err_code( ferr_too_many_args - greport )
     .		/ 'too_many_args' /

	DATA err_text( ferr_not_implemented	- greport )
     .		/ 'feature not implemented'			/
	DATA report_err_code( ferr_not_implemented - greport )
     .		/ 'not_implemented' /

	DATA err_text( ferr_invalid_subcmnd - greport )
     .		/ 'invalid subcommand'				/
	DATA report_err_code( ferr_invalid_subcmnd - greport )
     .		/ 'invalid_subcmnd' /

	DATA err_text( ferr_relative_coord - greport )
     .		/ 'invalid use delta region'			/
	DATA report_err_code( ferr_relative_coord - greport )
     .		/ 'relative_coord' /

	DATA err_text( ferr_unknown_arg - greport )
     .		/ 'unknown or invalid argument'				/
	DATA report_err_code( ferr_unknown_arg - greport )
     .		/ 'unknown_arg' /

	DATA err_text( ferr_dim_underspec - greport )
     .		/ 'dimensions improperly specified'		/
	DATA report_err_code( ferr_dim_underspec - greport )
     .		/ 'dim_underspec' /

	DATA err_text( ferr_grid_definition - greport )
     .		/ 'improper grid or axis definition'		/
	DATA report_err_code( ferr_grid_definition- greport )
     .		/ 'grid_definition' /

	DATA err_text( ferr_internal - greport )
     .		/ 'internal program problem'			/
	DATA report_err_code( ferr_internal - greport )
     .		/ 'internal' /

	DATA err_text( ferr_line_too_long - greport )
     .		/ 'line too long'				/
	DATA report_err_code( ferr_line_too_long - greport )
     .		/ 'line_too_long' /

	DATA err_text( ferr_inconsist_plane - greport )
     .		/ 'inconsistent sizes of data regions'		/
	DATA report_err_code( ferr_inconsist_plane - greport )
     .		/ 'inconsist_plane' /

	DATA err_text( ferr_inconsist_grid - greport )
     .		/ 'inconsistent data grids'			/
	DATA report_err_code( ferr_inconsist_grid - greport )
     .		/ 'inconsist_grid' /

	DATA err_text( ferr_expr_too_complex - greport )
     .		/ 'expression too complex'			/
	DATA report_err_code( ferr_expr_too_complex - greport )
     .		/ 'expr_too_complex' /

	DATA err_text( ferr_stack_ovfl - greport )
     .		/ 'stack overflow'				/
	DATA report_err_code( ferr_stack_ovfl - greport )
     .		/ 'stack_ovfl' /

	DATA err_text( ferr_stack_undfl - greport )
     .		/ 'stack underflow'				/
	DATA report_err_code( ferr_stack_undfl - greport )
     .		/ 'stack_undfl' /

	DATA err_text( ferr_out_of_range - greport )
     .		/ 'value out of legal range'			/
	DATA report_err_code( ferr_out_of_range - greport )
     .		/ 'out_of_range' /

	DATA err_text( ferr_prog_limit - greport )
     .		/ 'a program limit has been reached'		/
	DATA report_err_code( ferr_prog_limit - greport )
     .		/ 'prog_limit' /

	DATA err_text( ferr_unknown_grid - greport )
     .		/ 'unknown defining grid'			/
	DATA report_err_code( ferr_unknown_grid - greport )
     .		/ 'unknown_grid' /

	DATA err_text( ferr_no_range - greport )
     .		/ 'all data have same value'			/
	DATA report_err_code( ferr_no_range - greport )
     .		/ 'no_range' /

	DATA err_text( ferr_var_not_in_set - greport )
     .		/ 'required variable not in data set'		/
	DATA report_err_code( ferr_var_not_in_set - greport )
     .		/ 'var_not_in_set' /

	DATA err_text( ferr_unknown_file_type - greport )
     .		/ 'class of data set is unknown'		/
	DATA report_err_code( ferr_unknown_file_type - greport )
     .		/ 'unknown_file_type' /

	DATA err_text( ferr_limits - greport )
     .		/ 'illegal limits'				/
	DATA report_err_code( ferr_limits - greport )
     .		/ 'limits' /

	DATA err_text( ferr_descriptor - greport )
     .		/ 'in descriptor file'	/
	DATA report_err_code( ferr_descriptor - greport )
     .		/ 'descriptor' /

	DATA err_text( ferr_bad_delta - greport )
     .		/ 'invalid delta increment'			/
	DATA report_err_code( ferr_bad_delta - greport )
     .		/ 'bad_delta' /

	DATA err_text( ferr_trans_nest - greport )
     .		/ 'illegal use of transformation'		/
	DATA report_err_code( ferr_trans_nest - greport )
     .		/ 'trans_nest' /

	DATA err_text( ferr_state_not_set - greport )
     .		/ 'required program command has not been given'	/
	DATA report_err_code( ferr_state_not_set - greport )
     .		/ 'state_not_set' /

	DATA err_text( ferr_unknown_command - greport )
     .		/ 'unknown command'				/
	DATA report_err_code( ferr_unknown_command - greport )
     .		/ 'unknown_command' /

        
	DATA err_text( ferr_ef_error - greport )
     .		/ ' '	/

	DATA err_text( ferr_data_type - greport )
     .		/ 'illegal data type (float,string,...) for operation'/
	DATA report_err_code( ferr_data_type - greport )
     .		/ 'data_type' /

	DATA err_text( ferr_unknown_attribute - greport )
     .		/ 'attribute undefined or invalid attribute name'/
	DATA report_err_code( ferr_unknown_attribute - greport )
     .		/ 'unknown_attribute' /

	DATA err_text( ferr_not_attribute - greport )
     .		/ 'error specifying attribute'/
	DATA report_err_code( ferr_not_attribute - greport )
     .		/ 'not_attribute' /

	DATA err_text( ferr_aggregate_error - greport )
     .		/ 'error defining aggregate dataset'/
	DATA report_err_code( ferr_not_attribute - greport )
     .		/ 'aggregate_error' /

	DATA err_text( ferr_file_not_found - greport )
     .		/ 'file undefined or not found'/
	DATA report_err_code( ferr_aggregate_error - greport )
     .		/ 'filefound_error' /

	DATA err_text( ferr_unknown_auxvar - greport )
     .		/ 'auxiliary variable unknown or not in data set' /
	DATA report_err_code( ferr_aggregate_error - greport )
     .		/ 'auxvar_error' /

	DATA err_text( ferr_ppl_error - greport )
     .		/ 'PPLUS command syntax error' /
	DATA report_err_code( ferr_ppl_error - greport )
     .		/ 'ppl_cmd_error' /

	DATA err_text( ferr_sys_return - greport )
     .		/ 'Shell command returned failure flag' /

	DATA err_text( ferr_nomessge - greport )
     .		/ ' '/

	DATA report_err_code( ferr_nomessge - greport )
     .		/ 'no_message' /

	END

      SUBROUTINE HEAP2_V (RA, BAD, N)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
C  Ansley Manke
C  From Numerical Recipes, Heapsort subroutine SORT2
C  with change noted below for the case where N=1
* V6.74 3/12 *acm* cleanup, add disclaimer

C Return only the data not the indices.

      INTEGER N
      REAL RA(*), BAD

      INTEGER L, IR, J, I, NGD
      REAL RRA

* From SHELLR
* since the input array may be large but sparse, begin by sorting
* the missing value flags to the end of the list

      ngd = 0
      DO j = 1, n
         IF (RA(j) .NE. bad) THEN
            ngd = ngd + 1
            RA(ngd) = RA(j)
          ENDIF 
      END DO

      DO j = ngd+1, n
         RA(j) = bad
      END DO

      L = NGD/2 + 1
      IR = NGD

      IF (NGD .LT. 1) RETURN

   10 CONTINUE
         IF (L .GT. 1) THEN
            L = L - 1
            RRA = RA(L)
         ELSE
            RRA = RA(IR)
            RA(IR) = RA(1)
            IR = IR - 1
            IF (IR .LE. 1) THEN	! *acm* Num Recipes has .EQ. here,
				!       but this fails in the case where	
				!       the loop starts with L=1
               RA(1) = RRA
               RETURN
            ENDIF
          ENDIF

          I = L
          J = L + L
   20     IF (J .LE. IR) THEN
             IF (J .LT. IR) THEN
                IF (RA(J) .LT. RA(J+1)) J = J + 1
             ENDIF
             IF (RRA .LT. RA(J)) THEN
                RA(I) = RA(J)
                I = J
                J = J + J
             ELSE
                J = IR + 1
             ENDIF
             GO TO 20
          ENDIF

          RA(I) = RRA
      GO TO 10

      END

	INTEGER FUNCTION MGRID_SIZE_DELTA ( mr )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine the number of values in a grid *with strides*

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V533 *sh* like MGRID_SIZE but sensitive to _delta
* V560 *acm* 4/04 - stride/modulo fixes: use NINT to convert REAL*8 to integer
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xvariables.cmn'

* calling argument declarations
	INTEGER mr

* internal variable declkarations
	INTEGER	idim, size, delta

* determine the delta product
	size = 1
	DO idim = 1, nferdims
	  IF (mr_delta(idim,mr) .NE. unspecified_val8) THEN
	    delta = NINT(mr_delta(idim,mr))
	  ELSE
	    delta = 1
	  ENDIF
	  size = size * 
     .		((mr_hi_ss(mr,idim)-mr_lo_ss(mr,idim))/delta + 1)
	ENDDO

* the result
	MGRID_SIZE_DELTA = size

	RETURN
	END

	LOGICAL FUNCTION TM_FIRM_AXIS_ORIENT(axis, orientation)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Determine if "axis" has a rock-firm orientation

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V500 *sh* 6/99 - new -- to help with SET DATA/ORDER=
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* argument definitions:
*	axis	    - input:  axis in TMAP COMMON
*	orientation - output: a value 1-nferdims if orientation is firm

* include files
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xunits.cmn_text'
	external xunits_data

* argument declarations
	INTEGER	 axis, orientation

* local variable declarations:
	LOGICAL TM_HAS_STRING
	INTEGER units

* initialize
	units = line_unit_code(axis)

* try to determine the orientation of the axis

	IF ( units .LT. 0 ) THEN
	  orientation = t_dim
	ELSEIF ( units .EQ. 4 ) THEN     ! degrees
	  IF  ( TM_HAS_STRING(line_units(axis), 'NORTH')
     .     .OR. TM_HAS_STRING(line_units(axis), 'SOUTH')
     .     .OR. TM_HAS_STRING(line_name(axis), 'LAT') ) THEN 
	    orientation = y_dim
	  ELSEIF ( TM_HAS_STRING(line_units(axis), 'EAST')
     .	   .OR. TM_HAS_STRING(line_units(axis), 'WEST')
     .     .OR. TM_HAS_STRING(line_name(axis), 'LON') ) THEN 
            orientation = x_dim
	  ENDIF
	ELSEIF ( units .EQ. pun_millibars
     .	 .OR.  units .EQ. pun_decibars
     .   .OR.  units .EQ. 14
     .   .OR.  units .EQ. 15                  ! layer or level
     .   .OR. TM_HAS_STRING(line_name(axis), 'HEIGHT') 
     .   .OR. TM_HAS_STRING(line_name(axis), 'ELEV') ) THEN 
          orientation = z_dim
	ELSE
	  orientation = 0
	ENDIF

* set return value
	TM_FIRM_AXIS_ORIENT = orientation .NE. 0
  
	RETURN
	END

	SUBROUTINE TAYIS0(TLO,ITIME1,ITIME2,DT,NSMTIC,LABEL,IHDB,IDDB,
     *	TFACT,X,XFACT,CSIZE,xacross,hgrat,hcolor,hline,color0)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* From taxis0: separate routijne for hour:min labeling on time axes

C**
C**    @(#)tayis0.f	1.1    3/10/88
* *acm* - 8/16   ticket 1787: restore pen 0 correctly after graticule
* *acm* - 9/16   ticket 2466: graticule lines on major tics by default
* V745 *acm* 3/19 Draw tic marks on top of any graticule lines so 
*                 dashes or color are covered up by the tic mark
C
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C     THIS ROUTINE PLOTS A TIME AXIS AND LABELS IT WITH THE DAY OF THE M
C     AND THE MONTH.
C     VARIBLES:
C         TLO=X VALUE CORRESPONDING TO THE START TIME.
C         ITIME1 = START TIME (IE.  7708190100)
C                  WE RESTRICT THE PERMISSIBLE START TIMES TO BE
C                  EVEN HOURS.  (THAT IS THE LAST 4 DIGITS OF ITIME1
C                  MUST BE 0)
C         ITIME2 = END TIME (IE   7709072300)
C                  THIS IS THE FIRST HOUR NOT TO BE PLOTTED, AND IT
C                  MUST BE AN EVEN HOUR.
C         DT = SAMPLING RATE IN MINUTES.
C         NSMTIC = NUMBER OF SMALL TICS TO MAKE EACH HOUR.
C         LABEL > 0 IF LABELS ARE TO BE DRAWN ABOVE THE AXIS.
C               = 0 IF NO LABELS ARE TO BE DRAWN.
C               < 0 IF LABEL ARE TO BE DRAWN BELOW THE AXIS.
C         IABS(LABEL) = 1 FOR LABELS OF THE STYLE
C                  1..........1..........1..........1..........1
C                       3           4          5        6
C                                    JUN 7
C         IHDB = PRINT LABELS OF HOURS DIVIBLE BY THIS NUMBER ONLY.
C                IF(IHDB = 0) PRINT NO DAY LABELS.
C         IDDB = PRINT LABELS OF DAYS DIVISIBLE BY THIS NUMBER ONLY.
C                IF(IDDB = 0) PRINT NO MONTH LABELS.
C                THIS VARIBLE ONLY APPLYS WHEN IABS(LABEL) = 1
C         TFACT = (LENGTH OF T AXIS IN INCHES)/(LENGTH OF T AXIS IN USER
C         Y = Y COORDINATE OF TIME AXIS.
C         YFACT = (LENGTH OF Y AXIS IN INCHES)/(LENGTH OF Y AXIS IN USER
C         CSIZE = SIZE TO DRAW HOUR LABELS.
C                 DAY LABELS WILL BE 1.5 TIMES AS LARGE.
C
C
C     THIS ROUTINE WAS FIRST WRITTEN BY DAVID MANDEL IN JULY 1980.
C
	CHARACTER ITIME3*14,DATE*6,BUFF*14,YEAR*4
	CHARACTER ITIME*14,ITIME1*(*),ITIME2*(*),SYM*21
	COMMON/TICS/TSMX,TLX,TSMY,TLY,IX,IY
	COMMON/AXLWID/XWID,YWID

* Parameters for drawing tics across plot

        REAL xacross
        REAL dash1_1, dash1_2, dash1_3, dash1_4
        REAL dash2_1, dash2_2, dash2_3, dash2_4
        REAL hgrat(4,2)        ! line type: 0=tics only, <0=line, >0=dash lengths 
        INTEGER hcolor(*)      ! pen number for graticule lines
	INTEGER color0	       ! pen number to restore 
        LOGICAL hline, do_line ! If true, do the lines across.
        LOGICAL solid1, solid2   ! solid lines across at tics
        LOGICAL dashed1, dashed2 ! dashed lines across at tics
        INTEGER ltic, color1, color2

* TMAP interrupt flag

	include 'xinterrupt.cmn'
        include 'century.cmn'  ! with MONYRLAB flag
        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'lines_inc.decl'
        include 'LINES.INC'
        INCLUDE 'pen_inc.decl'  ! with IPEN(1)
        INCLUDE 'PEN.INC'

C     CHECK THE PARAMETERS PASSED TO THE SUBROUTINE.
	IF(ITIME1(9:10).NE.'00')STOP ',1'
	IF(ITIME2(9:10).NE.'00')STOP ',2'
        IF(ITIME1(13:14)//ITIME1(1:12).GE.
     .	   ITIME2(13:14)//ITIME2(1:12)) STOP',3'
        
        solid1 = (hgrat(1,1).LT.0 .AND. hgrat(2,1).LT.0 .AND.  
     .            hgrat(3,1).LT.0 .AND.  hgrat(4,1).LT.0 )
        solid2 = (hgrat(1,2).LT.0 .AND. hgrat(2,2).LT.0 .AND.  
     .            hgrat(3,2).LT.0 .AND.  hgrat(4,2).LT.0 )
        dashed1 = (hgrat(1,1).GT.0 .OR. hgrat(2,1).GT.0 .OR.  
     .            hgrat(3,1).GT.0 .OR.  hgrat(4,1).GT.0 )
        dashed2 = (hgrat(1,2).GT.0 .OR. hgrat(2,2).GT.0 .OR.  
     .            hgrat(3,2).GT.0 .OR.  hgrat(4,2).GT.0 )
     
     	do_line = hline

        color1 = hcolor(1)
        color2 = hcolor(2)

        IF (dashed1) THEN
           dash1_1 = hgrat(1,1)
           dash1_2 = hgrat(2,1)
           dash1_3 = hgrat(3,1)
           dash1_4 = hgrat(4,1)
        ENDIF
        IF (dashed2) THEN
           dash2_1 = hgrat(1,2)
           dash2_2 = hgrat(2,2)
           dash2_3 = hgrat(3,2)
           dash2_4 = hgrat(4,2)
        ENDIF
C
C     SET PARAMETERS.
	TIC = 60./DT
	NTIC = NSMTIC + 1
	IF(NSMTIC.LT.0)THEN
	    IHVY=-6
	    INML=-5
	ELSE
	    IHVY=-10
	    INML=-6
	    TDIST = TIC/NTIC
	ENDIF
	IF(LABEL+IY.EQ.0)THEN
	    XTEMP=0.0
	ELSE
	    XTEMP=TLY*0.5
	ENDIF
	IF(IHDB.NE.0)THEN
	    FIHDB=0.0
	ELSE
	    FIHDB=-1.4
	ENDIF
	XTEMP1=X+LABEL*(0.9*CSIZE+XTEMP)/XFACT
	IF(LABEL.LT.0) THEN
	    XTEMP2=X-((4.0+FIHDB)*CSIZE+XTEMP)/XFACT
	ELSE
	    XTEMP2=X+((2.5+FIHDB)*CSIZE+XTEMP)/XFACT
	ENDIF
	IF(LABEL.NE.0)YWID=(4.0+FIHDB)*CSIZE+XTEMP
	T=TLO
	ITIME=ITIME1
	CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
	TDAY=T
	CALL PLOT(X,TLO,0,0)
	IF(IHR.EQ.0)THEN
	    CALL PLOTT7(X,TLO,XFACT,TFACT,1,IHVY)
	ELSE
	    CALL PLOTT7(X,TLO,XFACT,TFACT,1,INML)
	ENDIF
	CALL TIME1(1,ITIME,2,' ',I3,ITIME3,60.)
	ITIME = ITIME3
	IF(IABS(LABEL).NE.1.OR.IHR.NE.IHDB*(IHR/IHDB)) GO TO 11
C      ELSE:
	WRITE(SYM,80) IHR
80	FORMAT(I2.2)
	CALL SCINOT(XTEMP1,T,90.,CSIZE,2,SYM,0,WID,XFACT,TFACT)    
 11     CONTINUE

c ----  count number of large tics. If no large tics will be drawn
c ----  then will want to draw graticule lines at the small ones.

c Set itime1, itime3 as above

      ITIME=ITIME1
      CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
      CALL TIME1(1,ITIME,2,' ',I3,ITIME3,60.)
      ITIME = ITIME3

C      LOOP:
       ltic = 0
  110  CONTINUE

	CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
	CALL TIME1(1,ITIME,2,' ',I3,ITIME3,60.)
	ITIME=ITIME3
	
*    do not draw a graticule line along the upper axis
	do_line = ( ITIME3(13:14)// ITIME3(1:10).LT.
     .	              ITIME2(13:14)//ITIME2(1:10))

	IF(ITIME(13:14)//ITIME(1:12) .LE.
     .       ITIME2(13:14)//ITIME2(1:12)) THEN
           IF(IHR.EQ.0) ltic = ltic + 1
           GO TO 110
        ENDIF
     
! IF no large tics, and if graticules at just the large tics were
! requested, then plot graticules at the small tics

	IF (ltic .EQ. 0) THEN  
           IF ( (.NOT.solid2) .AND. (solid1) ) THEN
              solid2 = solid1
              color2 = color1
           ENDIF
           IF ( (.NOT.dashed2) .AND. (dashed1) ) THEN 
              dashed2 = dashed1
              dash2_1 = dash1_1
              dash2_2 = dash1_2
              dash2_3 = dash1_3
              dash2_4 = dash1_4
              color2 = color1
           ENDIF
        ENDIF

! Restore the state of ITIME, ITIME3
      ITIME=ITIME1
      CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)

      CALL TIME1(1,ITIME,2,' ',I3,ITIME3,60.)
      ITIME = ITIME3
c ----


C      LOOP:
10	CALL PLOT(X,T,0,0)
	IF ( interrupted ) RETURN		! TMAP interrupt
	DO 20 I=1,NSMTIC
        
                 IF ((solid2.OR.dashed2) .AND. do_line) THEN ! make line across
                    CALL COLOR(color2)
                    IF (dashed2) THEN
                       CALL DASHSZ(dash2_1,dash2_2,dash2_3,dash2_4)
                       CALL DASHES
                    ENDIF
                    CALL PLOT(x,T+FLOAT(I)*TDIST,0,0) 
                    CALL PLOT(xacross,T+FLOAT(I)*TDIST,1,0)
                    CALL PLOT(x,T+FLOAT(I)*TDIST,0,0) 
                    CALL COLOR(color0)
                    CALL VECTRS
                 ENDIF
	CALL PLOTT7(X,T+FLOAT(I)*TDIST,XFACT,TFACT,1,-5)

20	CONTINUE
	CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
	IF(IHR.EQ.0)THEN
            
              IF ((solid1.OR.dashed1) .AND. do_line) THEN ! make line across
                 CALL COLOR(color1)
                 IF (dashed1) THEN
                    CALL DASHSZ(dash1_1,dash1_2,dash1_3,dash1_4)
                    CALL DASHES
                 ENDIF
                 CALL PLOT(x,t+tic,0,0) 
                 CALL PLOT(xacross,t+tic,1,0)
                 CALL PLOT(x,t+tic,0,0) 
                 CALL COLOR(color0)
                 CALL VECTRS
              ENDIF
	    CALL PLOTT7(X,T+TIC,XFACT,TFACT,1,IHVY)

	ELSE
            
                 IF ((solid2.OR.dashed2) .AND. do_line) THEN ! make line across
                    CALL COLOR(color1)
                    IF (dashed1) THEN
                       CALL DASHSZ(dash1_1,dash2_1,dash1_3,dash1_4)
                       CALL DASHES
                    ENDIF
                    CALL PLOT(x,t+tic,0,0) 
                    CALL PLOT(xacross,t+tic,1,0)
                    CALL PLOT(x,t+tic,0,0) 
                    CALL COLOR(color0)
                    CALL VECTRS
                 ENDIF
	    CALL PLOTT7(X,T+TIC,XFACT,TFACT,1,INML)

	ENDIF
C         THE LABELS
	IF(IHDB.EQ.0.OR.IABS(LABEL).NE.1) GO TO 50
	IF(IHR.NE.IHDB*(IHR/IHDB)) GO TO 50
	WRITE(SYM,80) IHR
	CALL SCINOT(XTEMP1,T+TIC,90.,CSIZE,2,SYM,0,WID,XFACT,TFACT)
50	CONTINUE
	CALL TIME1(1,ITIME,2,' ',I3,ITIME3,60.)
	IF(IDDB.EQ.0.OR.IABS(LABEL).NE.1) GO TO 70
	CALL TIME3(ITIME3,IYR3,IMON3,IDAY3,IHR3,IMIN3,ISEC3,ICEN3)
	IF(IDAY.EQ.IDAY3) GO TO 70
	IF(IDAY.NE.IDDB*(IDAY/IDDB))GO TO 60
C             ELSE:
	IF(T-TDAY.GT.180./DT)THEN
	    CALL TIME2(ITIME,SYM)

	   READ(SYM,55) DATE, YEAR
55	   FORMAT(6X,A6,1X,A4)
65         FORMAT(A6,1X,A4)
           IF (MONYRLAB) THEN
	      WRITE (BUFF, 65) DATE, YEAR
              TSYM=TDAY+(T+TIC-TDAY-SYMWID(CSIZE,14,BUFF)/TFACT)*.5
	      CALL SYMBEL(XTEMP2,TSYM,90.,CSIZE,14,BUFF)
	   ELSE
	      TSYM=TDAY+(T+TIC-TDAY-SYMWID(1.5*CSIZE,6,DATE)/TFACT)*.5
	      CALL SYMBEL(XTEMP2,TSYM,90.,1.5*CSIZE,6,DATE)
	   ENDIF

	ENDIF
60	TDAY=T+TIC
70	CONTINUE
	ITIME=ITIME3
	T=T+TIC
c	IF(ITIME.LE.ITIME2) GO TO 10
        IF(ITIME(13:14)//ITIME(1:12) .LE.
     .       ITIME2(13:14)//ITIME2(1:12)) GO TO 10
	IF(IDDB.EQ.0) RETURN
	IF(IABS(LABEL).EQ.1.AND.IDAY.EQ.IDDB*(IDAY/IDDB)
     .	.AND.IHR3.GE.4)THEN
	    CALL TIME2(ITIME,SYM)
	    READ(SYM,55) DATE, YEAR
* TMAP mod 8/11/89 *sh*                                 
! original:  ("mon" --> "date")                           
!	    TSYM=TDAY+(T-TDAY-SYMWID(1.5*CSIZE,6,MON)/TFACT)*.5
!	    CALL SYMBEL(XTEMP2,TSYM,90.,1.5*CSIZE,6,MON)

           IF (MONYRLAB) THEN
	      WRITE (BUFF, 65) DATE, YEAR
              TSYM=TDAY+(T-TDAY-SYMWID(CSIZE,14,BUFF)/TFACT)*.5
	      CALL SYMBEL(XTEMP2,TSYM,90.,CSIZE,14,BUFF)
	   ELSE
	      TSYM=TDAY+(T-TDAY-SYMWID(1.5*CSIZE,6,DATE)/TFACT)*.5
	      CALL SYMBEL(XTEMP2,TSYM,90.,1.5*CSIZE,6,DATE)
	   ENDIF
	ENDIF
	RETURN
	END

	SUBROUTINE SHOW_MEM_VARS

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute the SHOW VARIABLES/MEMORY command - display a priority-sorted list 
* of the data in memory

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 5/29/87 - (from XEQ_EXAMINE)
* revision 0.1 - 7/8/87  - made mr_list and mr_sort into dummy args
* revision 0.2 - 9/17/87 - made permanent vars,only the default
*			   and added trans_arg output
* revision 0.3 - 3/25/88 - added /NAMED qualifier, reformatted "PERM" output
*			   and added interrupts
* revision 0.4 - 6/27/88 - added /PERM and /TEMP qualifiers
* revision 0.5 - 10/5/88 - loop 2,max_mrs --> 1,max_mr_avail
* revision 0.6 - 1/10/89 - added grid info
* V200:  5/19/89 - 4D symmetrical; major reformatting of output
* 		 - deleted variables flagged in mr_protected
*		 - sorting not needed because of deletion priority chain
*		 - most code moved to SHOW_1_MR
* V320: 12/29/94 - use SPLIT_LIST to redirect tty output for GUI
* 12/96 *kob* - Linux Port - had to move variable assignments off of
*               declaration line.
* V650  Write to show_lun which may be set to a file unit number rather than std out*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'
	include 'xvariables.cmn'
	include 'xinterrupt.cmn'

* calling argument declarations:

* local variable declarations:
	LOGICAL	show_all, show_perm, show_named, show_temp
	INTEGER status, iqual, mr
	CHARACTER datmsg*16
	PARAMETER ( datmsg = 'data loaded with' )	!kob 12/96
* local parameter declarations:
	INTEGER	    slash_all, slash_named, slash_temp, slash_perm
	PARAMETER ( slash_all = 1,
     .		    slash_named = 2,
     .		    slash_temp  = 3,
     .		    slash_perm  = 4 )

* interpret qualifiers
	show_all   = qual_given( slash_all ) .GT. 0
	show_named = show_all .OR. qual_given( slash_named ) .GT. 0
	show_perm  = show_all .OR. qual_given( slash_perm ) .GT. 0
	show_temp  = show_all .OR. qual_given( slash_temp ) .GT. 0
	show_all   = show_temp .AND. show_perm
* ... /PERM is default
	show_perm  = show_perm .OR.
     .		     .NOT.(show_all .OR. show_named .OR. show_temp)

* write introductory line
	IF ( show_all ) THEN
	   CALL SPLIT_LIST(pttmode_explct, show_lun,
     .				'all data in memory:',19 )
	ELSE
	   IF ( show_named ) CALL SPLIT_LIST(pttmode_explct, show_lun,
     .				datmsg//' /NAME=:',24 )
	   IF ( show_perm  ) CALL SPLIT_LIST(pttmode_explct, show_lun,
     .				datmsg//' /PERMANENT:',28 )
	   IF ( show_temp  ) CALL SPLIT_LIST(pttmode_explct, show_lun,
     .				datmsg//'out /PERMANENT:',31 )
	ENDIF

* display permanent variables
	IF ( show_perm ) THEN
	   DO 100 mr = 1, max_mr_avail
	      IF ( interrupted ) CALL ERRMSG( ferr_interrupt,status,' ',*5000 )
 100	   IF (mr_protected(mr).EQ.mr_perm_protected) CALL SHOW_1_MR(mr,status)
	ENDIF

* display deletable variables
	IF ( show_temp ) THEN
	   mr = mr_del_flink(0)
 200	   IF ( mr .NE. 0 ) THEN
	      IF ( interrupted ) CALL ERRMSG( ferr_interrupt,status,' ',*5000 )
	      CALL SHOW_1_MR( mr, status )
	      IF (status .NE. ferr_ok) GOTO 5000
	      mr = mr_del_flink(mr)
	      GOTO 200
	   ENDIF
	ENDIF

 5000	RETURN
	END

	SUBROUTINE IS_AGGREGATE_GATHER(  *, *, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* bring the components of an aggregate defined with DEFINE DATA/AGGREGATE 
* together by requesting the members one by one on the interpretation stack

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Thermal Modeling and Analysis Program
*
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V69+ 5/14 *acm* Fixes for ticket 2177: datasets with _FillValue, no missing_value
* V695 2/15 *acm* 6D add aggregation in forecast direction
* V698 1/16 *sh* fix to bug #2347 (res var no instead of com var on stack)
*		altered logic as described in header of INIT_EF_AGGREGATE_DSET
*      3/16 *acm*always mark aggregation components unused after using them,
*      3/16 *sh* delete agg component after using if nothig else has a claim
*      4/16 *sh* Allow that SET VAR/NAME= has altered the agg varname
* V741 *acm* 5/18 Fixes so string-variables are returned in aggregations

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'
	include 'xtm_grid.cmn_text'   ! for grid_line

* calling argument declarations:
	INTEGER	status
* normal return is for error conditions
* exit #1 is to request another member ( stack has been pushed )
* exit #2 is to signal completion of the activity at this stack level

*   ... interpretation stack setup at the time this is called ...
*	stack level		stack contents
*	isp+1	<--	level of last activity ( component just computed )
*	 isp	<--	current stack level (for gathering )

* internal variable declarations:
	LOGICAL	NC_GET_ATTRIB, NC_GET_ATTRIB_STRING, TM_SAME_GRID_DEF,
     .		SCALAR_GRID_LINE,
     .		attoutflag, got_it, itsa_dummy
	INTEGER NCF_GET_ATTR_FROM_ID, TM_LENSTR1, STR_SAME, KNOWN_GRID,
     .		MGRID_SIZE_DELTA,
     .		com_mr, res_mr, com_cx, res_cx, com_isp, res_isp,
     .		res_grid, res_cat, res_var,
     .		agg_dim, top, imemb, memb_dset, iline, idim,
     .		varid, attlen, maxlen, agg_dset, slen, agg_vlen, memb_vlen,
     .		orig_cat, orig_var, orig_grid,
     .		 com_cat,  com_var,  com_grid

	CHARACTER*128 VAR_CODE, agg_vname, memb_vname, buff
	CHARACTER LEFINT*6

* --- end of introductory code ---

* initialize
	res_isp    = isp
	com_isp    = isp + 1
	res_mr     = is_mr( res_isp )
	com_mr     = is_mr( com_isp )
	res_cx     = is_cx( res_isp )
	com_cx     = is_cx( com_isp )
	agg_dim    = is_axis( res_isp )
        agg_dset   = cx_data_set(res_cx)
	res_grid   = cx_grid(res_cx)
	res_cat    = cx_category(res_cx)
	res_var    = cx_variable(res_cx)

* diagnostic mode output: " doing aggregate gather VAR_NAME[x=lo:hi@TRN:n,D=#]"
* Put in the agg- index value just for this output

	IF ( mode_diagnostic ) THEN
	   cx_lo_ss( com_cx,agg_dim ) = is_phase(isp)  ! hack to make
	   cx_hi_ss( com_cx,agg_dim ) = is_phase(isp)  ! diagnostic informative
	   CALL DIAG_OP
     .	    ( 'doing',isact_class_aggregate_gather, com_cx, agg_dim )
	   cx_lo_ss( com_cx,agg_dim ) = unspecified_int4
	   cx_hi_ss( com_cx,agg_dim ) = unspecified_int4
	ENDIF

* create mem. result from result cx if this is the first component received
	IF ( res_mr .EQ. unspecified_int4 ) THEN
	   CALL CREATE_MEM_VAR( res_cx, res_mr, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000


	   IF ( mr_type(res_mr) .EQ. ptype_string ) THEN
	      CALL INIT_C_STRING_ARRAY( MGRID_SIZE_DELTA(res_mr),
     .                               memry(res_mr)%ptr,
     .                               mr_c_pointer(res_mr)      )
	      CALL SET_NULL_C_STRING_ARRAY(mr_c_pointer(res_mr),
     .                                     MGRID_SIZE_DELTA(res_mr) )
	   ENDIF

	   is_mr( res_isp ) = res_mr
	ENDIF

* copy data just received into the result
* bad data flag differences are resolved during this COPY operation
	CALL COPY_AGG_INTO( memry(com_mr)%ptr, com_mr, com_cx, agg_dim,
     .			memry(res_mr)%ptr, res_mr, is_phase(isp) )

* ... remove the component protection that signaled we needed it here
	IF (cx_data_set(com_cx) .NE. pdset_dummy) THEN
	   CALL MR_NOT_IN_USE( com_mr )
* ... delete it altogether (avoid memory clogging) unless its in use elsewhere
	   IF (mr_protected(com_mr) .EQ. mr_not_protected) 
     .					CALL DELETE_VARIABLE( com_mr )
	ELSE
	   CALL DELETE_VARIABLE( com_mr )   ! delete dummy (missing vals) 
	ENDIF

* are we done ?
	IF ( is_phase(isp) .EQ. is_sum(isp) ) THEN
* ... yes - pop com_cx from context stack
	   cx_stack_ptr = cx_stack_ptr - 1
	   RETURN 2
	ENDIF

**************************************
* NOT DONE -- set up com_cx to get the next aggregate member
	is_phase(res_isp) = is_phase(res_isp) + 1

! *sh* as seen in earlier version ...
! these parts of the component context were already set in IS_STRIP
!	CALL TRANSFER_CONTEXT( big_cx, com_cx )

	imemb = is_phase(res_isp)

	agg_vname = VAR_CODE (res_cat, res_var)   ! *sh* 1/16
	agg_vlen = TM_LENSTR1(agg_vname)
	CALL CD_GET_AGG_VAR_INFO (agg_dset, agg_vname, imemb, 
     .      orig_cat, memb_dset, orig_grid, iline, orig_var, status)

* for special case (hack) of an E-aggregation of FMRCs, the 2dtime array comes
* from one particular member.  We have just completed that, so we're done
	IF (orig_cat .EQ. cat_ef_time2d) THEN
* ... pop com_cx from context stack
	   cx_stack_ptr = cx_stack_ptr - 1
	   RETURN 2
	ENDIF

* Is it the 2D Time variable for a Forecast-aggregation?  If so then
* there has been a cache hit failure (FIND_MEM_VAR_INCL_C_CACHE)
* ... should never happen
	IF (memb_dset .EQ. pagg_promotion_indicator_dset)
     .		CALL ERRMSG(ferr_internal, status,
     .		'aggregation failure in is_aggregate_gather', *5000)

	itsa_dummy = memb_dset .EQ. pdset_dummy
	IF (itsa_dummy) THEN
* ... for a dummy (missing-filled) dset, borrow context info of the 1st member
	   CALL CD_GET_AGG_VAR_INFO (agg_dset, agg_vname, 1, 
     .         orig_cat, memb_dset, orig_grid, iline, orig_var, status)
	ENDIF

* a couple of 'delayed mode' use cases to beware -- actions the user may have
* taken **SINCE** the aggregation was defined:
*  1) user may have issued a SET VAR/NAME= (rename) of the aggregated variable
*  2) user may have issued a LET/D on a member variable
* If 1, then agg_vname will differ from memb_vname 
* If 2, then cat# and var# associated with member name may have changed
* Do a fresh "find" for the original member variable name
	IF (orig_cat .NE. cat_agg_gpromote) THEN
	   memb_vname = VAR_CODE(orig_cat, orig_var)
	   memb_vlen = TM_LENSTR1(memb_vname)
	   CALL FIND_VAR_NAME (memb_dset,memb_vname, com_cat, com_var )
	   IF (com_var .EQ. munknown_var_name) CALL ERRMSG(
     .		ferr_aggregate_error, status, 'variable '//
     .		memb_vname(:MEMB_vlen)//' no longer found in agg member '//
     .		LEFINT(imemb,slen), *5000)
	ELSE
	   com_cat = orig_cat
	   com_var = orig_var
	ENDIF

* grid must not have changed since DEFINE DATA/AGG
	com_grid = KNOWN_GRID(memb_dset, com_cat, com_var)
	IF (com_grid .EQ. unspecified_int4) THEN   ! can only be a uvar
* ... GET_UVAR_GRID uses the interp_stack, so bump isp
	   isp = com_isp
	   CALL GET_UVAR_GRID( com_var, memb_dset, status )
	   isp = res_isp  ! restore to value at start of routine
           IF ( status .NE. ferr_ok ) GOTO 5000
	   com_grid = KNOWN_GRID(memb_dset, com_cat, com_var)
	ENDIF

* check that component grid is conformable with aggregation
* (grid may have changed due to new LET/D definition)
	CALL CONFORMABLE_AGG_GRID(agg_dim, memb_vname, imemb,
     .                            res_grid, res_cat, res_var,
     .                            com_grid, com_cat, com_var,
     .                            orig_grid, status )
	IF (status .NE. ferr_ok) GOTO 5000

* scalar axes of components need not match the agg result
	DO idim = 1, nferdims
! 4/16	   IF ( idim.NE.agg_dim  .AND.    ! would not allow E-agg of E-aggs
	   IF (SCALAR_GRID_LINE(idim, com_grid, com_cat, com_var) ) THEN
	      CALL DEL_CX_DIM(idim, com_cx) 
	   ENDIF
	ENDDO

* the T axis of an F-aggregation has a single set of indices but the time
* values differ for each axis.  So re-interpret the time range from the indices
* (Indices are retained throughout from result cx)
	IF (agg_dim .EQ. f_dim) THEN
	   cx_by_ss(t_dim, com_cx) = .TRUE.
	   CALL FLESH_OUT_AXIS(t_dim, com_cx, status )
	   IF (status .NE. ferr_ok) GOTO 5000
	ENDIF

* set up the member variable
	cx_data_set(com_cx) = memb_dset
	cx_category(com_cx) = com_cat
	cx_variable(com_cx) = com_var
	cx_grid    (com_cx) = com_grid
	CALL GET_CONTEXT_BAD_FLAG(com_cx)
	
	IF (itsa_dummy) THEN
* dummy dataset triggers a missing data fill operation in INTERP_STACK
	   cx_data_set(com_cx) = pdset_dummy
	ENDIF

	is_uvar(com_isp) = com_var ! relevant if component 1 is LET/D

* push the interpretation stack and go get it
	isp = com_isp
	status = ferr_ok
	RETURN 1

* error exit
 5000	RETURN
	END	

	SUBROUTINE DIRRD(SELSTR,LUN,FILEC,END)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)dirrd.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C	SUBROUTINE THAT WILL GET MULTIPLE COPIES OF A FILE BASED
C	ON A SELECTION STRING
C
C	D.W. DENBO  MAR 1985
C
C	SELSTR -- 80 CHARACTER STRING CONTAINING WILD CARD FILE NAME
C	LUN  -- INTEGER  (NOT USED)
C	FILEC  -- 80 CHARACTER STRING CONTAINGING FILE NAME
C	END    -- LOGICAL   FALSE NOT DONE  (FILEC CONTAINS NAME)
C			    TRUE IF END OF LIST
C
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
	LOGICAL FIRST,END
	CHARACTER SELSTR*(*),FILEC*(*),FILE*80
	INTEGER*4 STATUS,CONTEXT
	DATA FIRST/.TRUE./
	IF(FIRST)THEN
	  J=INDEX(SELSTR,']')
	  JLN=LNBLK(SELSTR,80)
	  IF(SELSTR(J+1:).EQ.' ')THEN
	    FILE=SELSTR(:J)//'*.*;*'
	  ELSE IF(INDEX(SELSTR,'.').EQ.0)THEN
	    FILE=SELSTR(:JLN)//'.*'
	  ELSE
	    FILE=SELSTR
	  ENDIF
	  CONTEXT=0
	  FIRST=.FALSE.
	ENDIF
	END=.FALSE.

C 	What is this?  Coitenly not unix... *jd* for Linux port
#ifdef unix
	status = 0
#else
	STATUS = LIB$FIND_FILE(FILE,FILEC,CONTEXT)
#endif
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
***	IF(.NOT.STATUS)THEN
	IF(STATUS .EQ. 0)THEN
	  FIRST=.TRUE.
	  END=.TRUE.
	ENDIF
	RETURN
	END

      SUBROUTINE RANGE_DM(uamin,uamax,udel,uminr,umaxr,dint)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)range.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     CALL RANGE_DM(umin,umax,udel,uminr,umaxr,dint)
C
C     This subroutine finds two values for a variable such that
C     the range between them is evenly divisible into approxi-
C     mately a specified number of intervals and contains the
C     minimum and maximum values of the variable.
C     Based on RANGE, but computed for output as degrees and minutes.
C
C     The various parameters and their definitions are listed
C     below:
C        UMIN   - previously computed minimum value of the range.
C        UMAX   - previously computed minimum value of the range.
C        UDEL  -  previous delta value.
C        UMINR  - new minimum value of the range.
C        UMAXR  - new maximum value of the range.
C        DINT   - new interval size.
C
C  Calling argument declarations
      REAL uamin, uamax, udel, uminr, umaxr, dint

C Local variable declarations

      REAL umin, umax, temp, fm
      INTEGER m
C
C     Transfer the parameters to new variables.
C
      umin = uamin
      umax = uamax
C
C     Check the parameters to make sure that they are valid.
C
      IF (umin .GT. umax) THEN
        temp = umin
        umin = umax
        umax = temp
      ENDIF
C
C
C     Change to intervals appropriate for deg/minute formatting
C     If the previously computed interval is less than 1 minute,
C     make it 1 minute; change other intervals to correspond to
C     2, 5, 10, 30 minutes, or whole degrees.
C
      IF (udel .LE. 0.01) THEN
         dint = 1./120.   ! half minute 0.0083 deg
      ELSE IF (udel .LE. 0.02) THEN
         dint = 1./60.   ! one minute 0.01667 deg
      ELSE IF (udel .LE. 0.05) THEN
         dint = 2./60.   ! two minutes 0.0333 deg
      ELSE IF (udel .LE. 0.1) THEN 
         dint = 5./60.   ! five minutes 0.0833 deg
      ELSE IF (udel .LE. 0.2) THEN
         dint = 10./60.   ! ten minutes 0.1667 deg
      ELSE IF (udel .LE. 0.5) THEN
         dint = 15./60.   ! 15 minutes 0.25 deg
      ELSE
         dint = udel
      ENDIF
C
C     recalculate the minimum value of the range.
C
      fm = umin / dint
      m = IFIX(fm)
      IF (fm .LT. 0.0) m = m - 1
      uminr = dint * FLOAT(m)
C
C     recalculate the maximum value of the range.
C
      fm = umax / dint
      m = IFIX (fm)
      IF (fm .GT. 0.0) m = m + 1
      umaxr = dint * FLOAT(m)
C
      RETURN
      END

	SUBROUTINE TM_MAKE_4D_GRIDS ( dnum, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Will check a dataset to make sure it has no mpsunkn axis. If it has an
* unknown time axis, it will create an axis using %%_GET_TIME_AXIS, then
* construct a 4D grid from that. If it has other axis with mpsunkn, it will
* issue an error.
*
* written 07/88 by M. Verschell for PMEL/TMAP
*
* revision 0.00 - 07/06/88
* revision 0.10 - 07/28/88 - If GT data set calls GT_GET_TIME_AXIS, if TS data
*			     set it calls TS_GET_TIME_AXIS.
* revision 0.11 - 11/21/88 - is var used check changed to specific char_initXX
* revision 0.12 - 11/29/88 - munknown changed to mpsunkn in grid_line check
* revision 0.13 - 02/08/89 - added ds_time_modulo sets line_modulo on time axis
* revision 0.20 -  9/12/90 - *sh* make auto time axis only if needed
* Unix/RISC port - 3/12/91 *sh* - fixed bug: variable "new" not initialized
* 6/91 - kob - Time independent data handling capability added.
*            -  proc's STR_UPCASE and INDEX used to see if the
*               word INDEPENDENT exists in t0_time, if so the
*               the data is considered time independent
* 12/92 - *sh* - set grid_out_prod when inserting time axis
* 1/93  - *sh* - check for "-1:-1" limits given for an explicit T axis
*
* 7/95  - *kob*- added logic to add a time axis to a multi-file netcdf data
*		 set based on the information in a descriptor

* V510 5/00 *sh* - adapt to dynamic grids and axes for netCDF files
*      6/00 *sh* bug fix: T axis ds_grid_start/end set only on first var using
*		each grid
* V530 1/00 *kob* - mods for aggregating time_independent files in an MC
*                   context
* V541 2/02 *sh* - minor change to support line_modulo_len
* 4/03 *acm* - Use STR_SAME to compare strings
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
*       *acm* 3/12 removing use of old GT and TS data formats (routine 
*	           GT_GET_TIME_AXIS is still used for MC datasets).

* CALLING ARGUMENTS
*	dnum - the data set fow which a time axis is desired
*	status  - the returning status
	INTEGER*4	dnum, status
*
* INCLUDE FILES
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'tmap_errors.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xtm_grid.cmn_text'
		include 'xstep_files.cmn_text'
	external xstep_files_data

*
* LOCAL DEFINITIONS
* upstat, temp_t0time,STR_UPCASE added for implementation of time-independent
* data ------------------> kob 6/91
        CHARACTER*11    temp_t0time               ! kob-
        INTEGER*4       upstat                    ! 6/91
	LOGICAL		use_ext_tax
	CHARACTER*13    TM_STRING
	INTEGER*4	ivar, iv, ngrd, ilne, ngrid, ext_tax, sf
	INTEGER*4	GT_GET_TIME_AXIS, 
     .			TM_FIND_LIKE_GRID, STR_UPCASE
* local parameter declarations:
        INTEGER*4 STR_SAME, new
        PARAMETER ( new = 0 )
	LOGICAL all_normal

* initialize
	use_ext_tax = .TRUE.	! assume auto axis isn't needed

* *kob* 12/00 - loop through all variables and check them all 
*               for time indepedence.   
	all_normal = .TRUE.
	DO 50 ivar = 1,maxvars
	   ngrd = ds_grid_number(ivar)
	   IF (ds_var_setnum(ivar) .EQ. dnum) THEN
	      IF ( grid_line(4,ngrd) .NE. mpsnorm) THEN
		 all_normal = .FALSE.
		 GOTO 70
	      ENDIF
	   ENDIF
 50	CONTINUE

*       Loop through all variables
 70	DO 150 ivar = 1,maxvars
	  IF (ds_var_setnum(ivar) .EQ. dnum) THEN

* . Are any non-time axes defined as mpsunkn ?
	    ngrd = ds_grid_number(ivar)
	    DO 100 ilne = 1,3
	      IF ( grid_line(ilne,ngrd) .EQ. mpsunkn ) GOTO 9100
  100	    CONTINUE

* .. If time axis unknown create an auto time axis (once, only)
*	and build a new nferdims-D grid in position 0 with time info
* *kob* 12/00 also do this if all the variables are time independent
	    IF ( grid_line(4,ngrd) .EQ. mpsunkn .OR. 
     .             ( (STR_SAME(ds_type(dnum), '  MC') .EQ. 0) .AND. 
     .              grid_line(4,ngrd) .NE. mpsnorm) .OR.
     .	            (STR_SAME(ds_type(dnum), '  MC') .eq. 0) .AND.
     .		    all_normal ) THEN
* ... create a time axis from the descriptor information (*sh* 9/90)
* ... IF statement added to check for time-independent data ----> kob 6/91
* ...   and to make sure time_axis is set to normal for time independent data
	      IF ( use_ext_tax ) THEN
	         use_ext_tax = .FALSE.
                 upstat = STR_UPCASE(temp_t0time,ds_t0time(dnum))
                 IF (INDEX(temp_t0time,'INDEPENDENT') .GT. 0) THEN   ! kob -
                    ds_time_axis(dnum) = mpsnorm                     ! 6/91
	         ELSEIF ((STR_SAME(ds_type(dnum), '  GT') .EQ. 0) .OR. 
     .                   (STR_SAME(ds_type(dnum), '  MC') .EQ. 0) ) THEN
	           ds_time_axis(dnum) = GT_GET_TIME_AXIS(dnum,status)
	         ELSE
	           GOTO 9200
	         ENDIF
	         IF (status .NE. merr_ok) GOTO 9999
* Do not set line modulo if data is time-independent ----------> kob 6/91
	         IF (ds_time_modulo(dnum) .AND. (INDEX(temp_t0time,
     .                'INDEPENDENT') .EQ. 0))
     .			     line_modulo(ds_time_axis(dnum)) = .TRUE.
	         line_modulo_len(ds_time_axis(dnum)) = 0.0D0
	      ENDIF

* ... Transfer things to position 0 ("new") from old 3D grid
	      CALL TM_COPY_GRID(ngrd,new)
	      grid_line(4,new) = ds_time_axis(dnum)
              grid_out_prod(4,new) = .TRUE.
* ... Does this match an already existing grid?
	      ngrid = TM_FIND_LIKE_GRID ( new )
	      IF (ngrid .EQ. unspecified_int4) THEN
*	... This is a new grid definition -- make sure name is unique
	         grid_name(new) = grid_name(ngrd)
	         grid_name(ngrd) = '%noexist%'
	         CALL TM_NEW_GRID_NAME(grid_name(new), grid_name(new))
	         grid_name(ngrd) = grid_name(new)
*	... Keep the new grid with the time axis and "use" the time axis
*	    Other vars defined on this grid will then bypass this code
	         CALL TM_COPY_GRID( new, ngrd )
	         CALL TM_USE_LINE( ds_time_axis(dnum) )
	      ELSE
*	... This duplicates a pre-existing grid definition -- reuse the older
	         DO 110 iv =  1,maxvars
	           IF (ds_var_setnum(ivar) .EQ. dnum) THEN
	             IF (ds_grid_number(iv).EQ.ngrd)
     .			 ds_grid_number(iv) = ngrid
	           ENDIF
 110		 CONTINUE
	         ngrd = ngrid
	      ENDIF
* ... Set the (previously unspecified) subscript limits for the variable
* ... Check to see if data is time-independent, if it is, both
* ...... grid start and end are set to 1 -----------> kob 6/91
	      DO 120 iv =  1,maxvars
	        IF (ds_var_setnum(ivar).EQ.dnum
     .	     .AND.  ds_grid_number(iv) .EQ.ngrd  ) THEN
	          ds_grid_start(4,iv) = 1
                  IF (INDEX(temp_t0time,'INDEPENDENT') .GT. 0) THEN
                    ds_grid_end(4,iv) = 1
                  ELSE
                    ds_grid_end  (4,iv) = line_dim( ds_time_axis(dnum) )
                  ENDIF
	        ENDIF
 120	      CONTINUE
	    ELSE
	      ext_tax = grid_line(4,ngrd)	! save external time ax #
	    ENDIF

	  ENDIF

  150	CONTINUE

* a few clean-up details for externally defined time axis (*sh* 9/90)
* (uses time axis from last data set variable as data set default)
	IF ( use_ext_tax ) THEN
	   ds_time_axis  ( dnum ) = ext_tax
	   ds_time_modulo( dnum ) = line_modulo( ext_tax )
	   DO 160 sf = 1, maxstepfiles
 160	   IF ( sf_setnum(sf) .EQ. dnum ) sf_regtimes(sf) = .FALSE.
* *sh* 1/93: check for "-1:-1" limits with an explicit time axis
	   DO 170 ivar = 1,maxvars
	      IF (ds_var_setnum(ivar) .EQ. dnum) THEN
                 IF ( ds_grid_start(4,ivar) .LE. 0 )
     .                 ds_grid_start(4,ivar) = 1
                 IF ( ds_grid_end(4,ivar) .LE. 0 )
     .                 ds_grid_end(4,ivar) =  line_dim( ext_tax )
              ENDIF
 170       CONTINUE
	ENDIF

	GOTO 9990

* error messages
 9000	CALL TM_ERRMSG (merr_gridlim, status, 'TM_MAKE_4D_GRIDS',
     .			no_descfile, no_stepfile,
     .			'MAX='//TM_STRING(DBLE(max_grids)), no_errstring,
     .			*9999)
 9100	CALL TM_ERRMSG (merr_undefline, status, 'TM_MAKE_4D_GRIDS',
     .			dnum, no_stepfile,
     .			'VARIABLE = '//ds_var_code(ivar), no_errstring,
     .			*9999)
 9200	CALL TM_ERRMSG (merr_unktype, status, 'TM_MAKE_4D_GRIDS',
     .			dnum, no_stepfile,
     .			'Type declared '//ds_type(dnum),
     .			no_errstring, *9999)
 9990	status = merr_ok

 9999	RETURN
	END

	SUBROUTINE COPY_INTO ( src, msrc, cxs, dst, mdst )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* copy data from source grid into dstination grid using limits of source
* context (i.e. dstination grid is ASSUMED) big enough to hold data

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V200:  6/8/89
*	10/16/89 - use *_SUB - avoid adjustable dimensioning with array
* V533:  *sh* 6/01 - allow for the possibility that there is a delta value
*		   - support for string arrays
* 560: *acm* 4/04 - stride/modulo fixes: use NINT to convert REAL*8 to integer
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'

* calling argument declarations:
	INTEGER msrc, cxs, mdst
	REAL    src( * ), dst( * )

* internal variable declarations
	INTEGER idim, soffset, doffset, mdel,
     .		smlo(nferdims), smhi(nferdims),
     .		dmlo(nferdims), dmhi(nferdims),
     .		cxlo(nferdims), cxhi(nferdims)

* set-up modified limits wherever delta is significant
* cuz the FORTRAN dimensioned size can only have delta of 1 

	DO idim = 1,nferdims
	  IF (mr_delta(idim,msrc) .NE. unspecified_val8) THEN
            mdel = NINT(mr_delta(idim,msrc))

	    IF (mr_delta(idim,msrc).NE.mr_delta(idim,mdst)
     .	   .OR. mr_delta(idim,msrc).NE.cx_delta(idim,cxs) ) CALL WARN
     .		('Internl_delta_err')
	    soffset = (mr_lo_ss(msrc,idim)-cx_lo_ss(cxs,idim))/
     .			mdel  + 1
	    doffset = (mr_lo_ss(mdst,idim)-cx_lo_ss(cxs,idim))/
     .			mdel  + 1
	    cxlo(idim) = 1

	    cxhi(idim) = 1 + (cx_hi_ss(cxs,idim)-cx_lo_ss(cxs,idim))/
     .			     mdel
	    dmlo(idim) = doffset
	    dmhi(idim) = doffset +
     .			     (mr_hi_ss(mdst,idim)-mr_lo_ss(mdst,idim))/
     .			     mdel
	    smlo(idim) = soffset
	    smhi(idim) = soffset + 
     .			     (mr_hi_ss(msrc,idim)-mr_lo_ss(msrc,idim))/
     .			     mdel
	  ELSE
	    cxlo(idim) = cx_lo_ss(cxs, idim)
	    cxhi(idim) = cx_hi_ss(cxs, idim)
	    dmlo(idim) = mr_lo_ss(mdst,idim)
	    dmhi(idim) = mr_hi_ss(mdst,idim)
	    smlo(idim) = mr_lo_ss(msrc,idim)
	    smhi(idim) = mr_hi_ss(msrc,idim)
	  ENDIF
	ENDDO

	IF (mr_type(msrc) .EQ. ptype_string ) THEN
	   CALL COPY_PTR_INTO_SUB( cxlo, cxhi,
     .			    src, smlo(1), smhi(1),
     .				 smlo(2), smhi(2),
     .				 smlo(3), smhi(3),
     .				 smlo(4), smhi(4),
     .				 smlo(5), smhi(5),
     .				 smlo(6), smhi(6),
     .			    dst, dmlo(1), dmhi(1),
     .				 dmlo(2), dmhi(2),
     .				 dmlo(3), dmhi(3),
     .				 dmlo(4), dmhi(4),
     .				 dmlo(5), dmhi(5),
     .				 dmlo(6), dmhi(6) )
	ELSE
	   CALL COPY_INTO_SUB( cxlo, cxhi,
     .			    src, smlo(1), smhi(1),
     .				 smlo(2), smhi(2),
     .				 smlo(3), smhi(3),
     .				 smlo(4), smhi(4),
     .				 smlo(5), smhi(5),
     .				 smlo(6), smhi(6),
     .			    dst, dmlo(1), dmhi(1),
     .				 dmlo(2), dmhi(2),
     .				 dmlo(3), dmhi(3),
     .				 dmlo(4), dmhi(4),
     .				 dmlo(5), dmhi(5),
     .				 dmlo(6), dmhi(6) )
	ENDIF

	RETURN
	END 

	SUBROUTINE PUT_KEY( line_num, string, xpos, ypos, xsize, ysize,
     .			      lab_ht, style, xaxrel, yaxrel )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* create a key for a plot using a PLOT+ movable label and an ALINE
* (xsize,ysize) is the size of the "key box" (including the line specimen
* (xpos,ypos) is the lower left corner of the box
* as of V2.00 of FERRET the "style" is always line specimen to left of text

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V200:	  2/2/90
* V301:  11/5/93 - define PLOT+ symbol "LABKEY" with the key string
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'plot_setup.parm'
	include	'xplot_setup.cmn'
	include 'axis_inc.decl'	! axis lengths
	include 'AXIS.INC'	! axis lengths
#ifdef NO_PASSED_CONCAT
	include 'xrisc.cmn'
#endif

* calling argument declarations
	INTEGER line_num, style, xaxrel, yaxrel
	REAL	xpos, ypos, xsize, ysize, lab_ht
	CHARACTER string*(*)

* internal variable declarations
	REAL	xmid, ymid, xll, yll, dxlen, dylen

	dxlen = xlen
	dylen = ylen
* adjust positions relative to axis lengths if requested
	xll = xpos
	yll = ypos
	IF ( xaxrel .EQ. lab_loc_axlen_plus ) THEN
	   xll = xll + dxlen
	ELSEIF ( xaxrel .EQ. lab_loc_axlen_times ) THEN
	   xll = xll * dxlen
	ENDIF
	IF ( yaxrel .EQ. lab_loc_axlen_plus ) THEN
	   yll = yll + dylen
	ELSEIF ( yaxrel .EQ. lab_loc_axlen_times ) THEN
	   yll = yll * dylen
	ENDIF

* x,y coords. of line specimen right end
	xmid = xll + xsize*key_line_frac
	ymid = yll + ysize*0.5

* instruct PLOT+ to draw line specimen: "ALINE/NOUSER 3 2.5 -1.5 3.0 -1.5 ON"
	WRITE ( ppl_buff, 3000) line_num, xll, ymid, xmid, ymid
 3000	FORMAT( 'ALINE/NOUSER ',I3,4F9.3,' ON')
	CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )

* instruct PLOT+ to write the key text
* ... x coord of text left end
	xmid = xmid + xsize*0.05
	CALL BOX_LABEL( ppl_movlab,
     .			string, xmid, yll, xsize*(.95-key_line_frac), ysize,
     .			lab_ht, ppl_left_just, xaxrel, yaxrel )

* define a PLOT+ symbol LABKEY
#ifdef NO_PASSED_CONCAT
	risc_buff = string
	CALL PPLCMD ( from, line, 0, 'SET LABKEY '//risc_buff, 1, 1 )
#else
	CALL PPLCMD ( from, line, 0, 'SET LABKEY '//string, 1, 1 )
#endif

	RETURN
	END

	SUBROUTINE IS_CONST_VAR(  *, *, status )

* create a constant valued array  "variable" in memory

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V500: 12/98 - based on IS_CONSTANT
* V530:  8/00 *sh* - allow lists of strings
* V533:  7/01 *sh* - allow single quoted strings
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V693+ *sh* 2/15 - support for _DQ_ and _SQ_ as quotation indicators
 
        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xvariables.cmn'
	include	'xcontext.cmn'
	include	'xprog_state.cmn'

* calling argument declarations:
	INTEGER	status

* internal variable declarations:
	INTEGER	CGRID_SIZE,
     .		mr, cx, size, uvar, item, start, end, n

* --- end of introductory code ---
* initialize
	cx = is_cx( isp )
	size = CGRID_SIZE(cx)

* reserve and catalog space for the result
* ... note: could create a lasting variable, but would need to make sure
*     that when DELETE_VARIABLE is called it also purges all cat_const_var
*     component variables. This approached seemed to add more complexity
*     than value ...
	CALL CREATE_TEMP_MEM_VAR( cx, mr, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* diagnostic output
	IF (mode_diagnostic) CALL DIAGNOSTIC_OUT('const_v',mr,point_to_mr)

* parse and insert the constant array
* ... note that the uvar number and item number of "{1,3,5}" are
*     packed together in the cx_variable value
	uvar = cx_variable(cx)/1000
	item = cx_variable(cx) - 1000*uvar
	start = uvar_item_start( item, uvar )
	end   = uvar_item_end  ( item, uvar )

	IF ( INDEX(uvar_text(uvar)(start:end), '"')    .GT. 0
     .	.OR. INDEX(uvar_text(uvar)(start:end), "'")    .GT. 0
     .	.OR. INDEX(uvar_text(uvar)(start:end), "_DQ_") .GT. 0
     .	.OR. INDEX(uvar_text(uvar)(start:end), "_SQ_") .GT. 0 ) THEN
* ... set up FORTRAN-independent pointer
	   CALL INIT_C_STRING_ARRAY( size,
     .				     memry(mr)%ptr,
     .				     mr_c_pointer(mr)      )

* ... array of strings
* NOTE: this routine will alter the context size and replace the mr
* (allocating a larger block of memory) if the SYSTEM: syntax is used
	   CALL PARSE_STRING_LIST(cx,
     .				  uvar_text(uvar)(start:end),
     .			          mr,
     .			          status)
	ELSE
* ... array of numbers
! ... as-of 12/98 limited to one block max array lentgh
	   CALL PARSE_NUMBER_LIST(uvar_text(uvar)(start:end),
     .			          memry(mr)%ptr,
     .			          size,
     .			          n,
     .			          status)
	ENDIF
	IF ( status .NE. ferr_ok ) GOTO 5000

* set the bad data flag
	mr_bad_data( mr ) = bad_val4

* result is ready to return to the stack
	is_mr( isp ) = mr

* got the requested component
	RETURN 2
! RETURN 1, which is to request a sub-component, is never used ...

* error exit
 5000	RETURN
	END	

	CHARACTER*(*) FUNCTION CD_AXIS_NAME ( dset, grid, idim, nlen )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine the netCDF name to use for the indicated axis of this grid

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 6/92
* V4.20  11/95 - remove parentheses surrounding dynamic axis names
* V600  *acm* 6/05 Attribute control. Get information from linked-list structure.
* V602 11/06*acm* Instead of looking to see if the Ferret axis name and the
*                 axis name in the attribute structure differ because Ferret
*                 needed to rename an axis on file initialization for uniqueness;
*                 we use the Ferret name throughout, restoring it only on output.
* V697 12/15 *acm* Fix ticket 2336: consistent application of CAN MODE UPCASE
* V710 9/16 *acm* Use ww_dim_name from xtext_info.cmn

* argument definitions:
*     dset    - dset (if netcdf file, for getting name and attribute 
*               info from linked-list structure  
*     grid    - TMAP grid id
*     idim    - axis orientation (1-nferdims)
*     nlen    - length of name

* include files
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xtext_info.cmn'  ! with ww_dim_name

* argument declarations
      INTEGER dset, grid, idim, nlen

* local variable declarations:
      LOGICAL TM_ABSTRACT_AXIS, coordvar
      INTEGER TM_LENSTR1, iaxis, varid, vartype, nvdims, vdims(8), 
     .        nvatts, status, llen, ic, all_outflag

      CHARACTER*1 c
      CHARACTER*130 buff

* initialize
      iaxis = grid_line(idim, grid)

* basic name straight from the grid
      buff = line_name(iaxis)
      nlen = TM_LENSTR1( buff )

* Get information, if it exists, from linked-list structure, including
* original upper/lowercase form of axis name. Also restore the original
* name if the axis name was changed on inupt. (If name matched an existing 
* line name, then Ferret appends a digit to the name.)

      CALL CD_GET_VAR_ID (dset, buff, varid, status)  ! is it in the linked-list for dset

      IF (status .NE. merr_ok) THEN
         nlen = TM_LENSTR1( buff )

      ELSE

* Get axis name into original upper/lowercase form.

         CALL CD_GET_VAR_INFO (dset, varid, buff, vartype, 
     .       nvdims, vdims, nvatts, coordvar, all_outflag,status) 

      ENDIF

100   CONTINUE

* if it's an abstract axis make a special name
      IF ( TM_ABSTRACT_AXIS( iaxis ) ) THEN
         buff = ww_dim_name(idim)//'AX'
         nlen = 3

* if it's a dynamic axis remove the parentheses
      ELSEIF ( line_name(iaxis)(1:1) .EQ. '(' ) THEN
	 IF ( nlen .LE. 2) nlen = 3			! should never happen
         buff = line_name(iaxis)(2:nlen-1)
	 nlen = nlen - 2
      ENDIF

      nlen = TM_LENSTR1( buff )
      CD_AXIS_NAME = buff(:nlen)

      RETURN
      END

	SUBROUTINE CD_OPEN_DSET ( dset, cdfid, remote_dods_id, status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Open a netCDF file and stores preliminaries in TMAP XDSET_INFO common

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 2/92
* 2/93 - ds_aux_modnum replaced by cd_what_isit (equivalenced (but unused))
* 3/93 - initialize ds_type for PMEL EPIC CDF file
* 11/94 - ignore the global "history" attribute.  Use "title_mod" instead.
* *sh* 3/2/95 - informative messages issued through TM_NOTE (for GUI)
*
* *kob* 7/95 - added logic for multi-file netcdf datasets
* *kob* 3/21/96 - add in changes originally made 7/21/95 by -sh- to 
*		 initialize ds_basic_axes as per TMAP model output
* *kob* 6/4/96	- prevent title from being overwritten for mc datasets
* *kob* 6/18/96 - bug fix in mc loop - loop w/ maxstepfiles rather than
*		  maxdsets.  Also reorganize loop for efficiency
*		- clarify error message at 5300
* 10/96 *kob* - Linux port 
*		- had to move variable assignments off of
*		  declaration line.
*		- hsd to declare hex constants as implicit
*		  integers in DATA statements.  Added a 
*		  FORTRAN_90 ifdef to accomplish this.
* *sh* 11/12/96 - changes to accomodate caching of DODS data 
* *kob* 4/99 - increase size of TM_INQ_PATH, cdf_file and raw_file 
*              to accomodate lenghty DODS dataset names
* 4/03 *acm* - Use STR_SAME to compare strings
* 9/04 *acm* - Fix bug 982 If same variable name in multiple descriptor files, 
*              mc_init_stepfile needs to know which file its from.
* V581: *acm*/3/05 - increase length of strings for dataset title to 1024 
* V600 *acm* 6/05 - Attribute control. just open the dataset here; getting info
*                   is done in cd_load_dset_attrs. See sequence of calls in 
*                   cd_init_dset.
* V600 *acm* 7/06 - To return correct netCDF error messages, call NF_OPEN and
*                   NF_STRERROR instead of NCOPN. Requires DODS library v3.5.2 or
*                   higher.
* V604 *acm* 6/07 Allow longer strings for OPeNDAP file-open errors.
* v604 *acm* 7/07 increase length of ds_des_name
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V65  *acm* 1/10  Call CD_TRANSLATE_ERROR rather than individual calls to NF_STRERROR
* V65  *acm* 1/10  Dont add the note **OPeNDAP/netCDF Error code** - that is now
*                  done only in CD_TRANSLATE_ERROR 
* V65  *acm* 2/10- all warnings and notes to std error not std out
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* argument definitions:
*       dset    - pointer to TMAP data set
*       cdfid   - returned pointer to open CDF file (or cache)
*       remote_dods_id   - returned pointer to open remote URL (or zero)
*	status	- return status

* argument declarations:
	INTEGER	      dset, cdfid, remote_dods_id, status

* include files
        include 'netcdf.inc'
        include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "gt_lib.parm"
#include "tmap_dset.parm"
	include 'xstep_files.cmn_text'
        external xstep_files_data
	include 'xdset_info.cmn_text'
	external xdset_info_data
        include 'xio.cmn_text'
        external xio_data
        include 'xdset_info.cd_equiv'
! kob 7/95
	include 'xsys_names.cmn_text'	            

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

* local variable declarations:
* *kob* explicit definitions not allowed on decl line in linux...
*       moved it to parameter line 10/96

      LOGICAL TM_HAS_STRING, got_it,
     .        do_warn, file_exists
      PARAMETER (do_warn = .TRUE. )
      REAL val
      INTEGER TM_LENSTR1, STR_SAME, STR_UPCASE,
     .        ndims, nvars, ngatts, recdim, cdfstat, i, istep, 
     .        err_status, i1, i2
      INTEGER len, iin, iout, ilast, dlen
      CHARACTER ch*1
* *kob* 4/99
* *kob* 11/00 - increase size of below to accomidate DODS files in mc sets
      CHARACTER*2048 TM_INQ_PATH, cdf_file, raw_file
      CHARACTER*1024 buff, upstr  ! for nf_ error message
      CHARACTER*30 buff30

#ifdef FORTRAN_90
	INTEGER HEX40
	DATA HEX40/Z'40'/
#endif

        buff = ' '
        upstr = ' '
        err_status = merr_nc_open

****** DODS *********
* If this is a DODS remote file - see if it is cached (11/96)
	remote_dods_id = -1	! the default: "NO"
	IF ( ds_des_name(dset)(1:7) .EQ. 'http://') THEN

	   err_status = merr_remote_open

* ... have they specifically indicated "(no cache)"
	   IF ( TM_HAS_STRING(ds_des_name(dset),'(no cach') ) THEN
* ... do not use cache!
* ... crude parse: remove everything beyond last "("
	      dlen = TM_LENSTR1(ds_des_name(dset))
	      DO 5 iin = dlen, 1, -1
	         IF (ds_des_name(dset)(iin:iin) .NE. '(' ) THEN
	            ds_des_name(dset)(iin:iin) = ' '
	         ELSE
	            ds_des_name(dset)(iin:iin) = ' '
	            GOTO 50
	         ENDIF
 5	      CONTINUE
	   ENDIF

* ... create the full file name path for the cache file
	   dlen = TM_LENSTR1(ds_des_name(dset))
	   raw_file = ' '
	   iout = 1				
	   DO 10 iin = 8, dlen			! just past the "http://"
	      ch = ds_des_name(dset)(iin:iin)	
	      IF ( ch .EQ. PathSeparator ) THEN
	         raw_file(iout:iout) = '_'
	      ELSE
	         raw_file(iout:iout) = ch
	      ENDIF
	      iout = iout + 1
 10	   CONTINUE

* ... does it exist?
	   cdf_file = TM_INQ_PATH( raw_file, 'FER_DODS_CACHE_DIR',
     .		' ', .FALSE., status )
	   IF ( status .EQ. merr_notmounted ) GOTO 50
	   IF ( status .NE. merr_ok ) GOTO 5900		! syntax err

* ... open the remote URL in order to initialize the DODS client libraries
* This time penalty is unavoidable (though HTTP caching may eliminate it)
* Using the cache file will remove the need to read remote coordinates
	   CALL TM_NOTE( 'Using cache '//cdf_file, lunit_errors)
	   
* ---
* Define a symbol CACHE_FILE
* if this symbol already exists then delete it
        buff30 = 'CACHE_FILE'	
	CALL GETSYM( 'CACHE_FILE', buff, i2, i1 )
	IF ( i1 .EQ. 0 ) CALL DELSYM(buff30,i1)

* define the symbol
	dlen = TM_LENSTR1(cdf_file)
	CALL PUTSYM( buff30, cdf_file, dlen, i2)
* ---


           cdfstat = NF_OPEN(ds_des_name(dset), NF_NOWRITE, remote_dods_id) 
	   IF ( cdfstat .NE. NF_NOERR ) THEN
              GOTO 5150
           ENDIF
           
           ds_des_name(dset) = cdf_file	! replace remote with cache!
	ENDIF
****** END DODS *********

* open the netCDF file and get its vital statistics. 
* NCPOPT  Call not used in Netcdf3, 4 
 50     CONTINUE
* check for mutli-file netcdf datasets then loop through the list
* of stepfiles to find the first one that is on line    *kob* 7/95
* * kob*  bug fix in loop logic 9/18/96
        IF (STR_SAME(ds_type(dset), '  MC') .EQ. 0) THEN
 		DO 100 i=1,maxstepfiles
                     err_status = merr_nc_open

		     IF (sf_setnum(i) .NE. dset) GOTO 100
		     cdf_file = TM_INQ_PATH(sf_name(i),tmap_tsteps,
     .                                      ' ',.FALSE., status)
		     IF (status .EQ. merr_ok)  THEN
			 cdfstat = NF_OPEN(cdf_file, NF_NOWRITE, cdfid) 
                         IF ( cdf_file(1:7) .EQ. 'http://')
     .                        err_status = merr_remote_open

			 mc_init_stepfile(dset) = i
			 IF ( cdfstat .EQ. NF_NOERR) GOTO 110
		     ENDIF
 100	        CONTINUE

* error exit now.....no file on line found after looping through
* all stepfiles
		GOTO 5300
                
	ELSE
               
           cdfstat = NF_OPEN(ds_des_name(dset), NF_NOWRITE, cdfid) 

	ENDIF
	        IF ( cdfstat .NE. NF_NOERR ) GOTO 5100
 110   CONTINUE

       status = merr_ok

       RETURN

* error messages
 5100   CONTINUE
        CALL CD_TRANSLATE_ERROR (cdfstat, buff)

        i = STR_UPCASE(upstr,buff)
        IF (STR_SAME(upstr(1:13), 'UNKNOWN ERROR') .EQ. 0) THEN
           buff = 'Unable to access remote URL: Data server '//
     .    'unavailable or file cannot be opened'
        ENDIF

        dlen = TM_LENSTR1(buff)

        CALL TM_ERRMSG
     .     ( err_status, status, 'CD_OPEN_DSET', dset,
     .        no_stepfile, buff, no_errstring, *5900 )

 5150   CALL TM_ERRMSG
     .     ( err_status, status, 'CD_OPEN_DSET', dset,
     .        no_varid, 'Unable to access remote URL', no_errstring,
     .		*5900 )
*kob* 9/18
 5300   CONTINUE
        CALL CD_TRANSLATE_ERROR (cdfstat, buff)

        dlen = TM_LENSTR1(buff)

        CALL TM_ERRMSG (merr_notmounted,status, 'CD_OPEN_DSET',dset,
     .    no_stepfile,
     .    'No files on-line from data set. '//buff(1:dlen),
     .    no_errstring,
     .    *5900)
* erase any record of tampering with this data set
 5900   CALL TM_CLOSE_SET( dset, i )

* error exit
	RETURN
	END

	LOGICAL FUNCTION ITSA_PURE_SUM_VAR( uvar )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* is the indicated variable of the form a + b + c ?
* Variables of this type may return a string result if all of the summands
* are strings.


* V533 *sh* 7/01
* v554: 1/04 *acm* Counter variables for REPEAT/RANGE=/NAME=
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V720: 4/17 *acm* Add direction-changing functions as a subset of grid-changing ones

        IMPLICIT NONE
* calling argument declarations
	INTEGER	uvar

* internal variable declarations
	INTEGER i, i1, ii, itype

	include	'tmap_dims.parm'
	include 'ferret.parm'
	include 'xvariables.cmn'

* This routine should never be called for GC vars -- it is to handle "legacy"
* variables in Ferret.
* Expressions like
*      LET a = STRING_FUNCTION(c+d) + "b" + {"a","b","c"}
* are acceptable because INIT_UVAR will have decomposed them and removed GC
* function calls such as  STRING_FUNCTION(c+d).  The only function calls that
* could remain would be numeric functions (e.g. SIN(x)). A uvar containing
* a numeric function call is NOT "pure_sum"

* Further "subleties" (aka hacks) added to support IF cond THEN "a" ELSE "b"
* In this case the "cond" logic does not bear on the data type of the result
* so we do not consider it in our search

* initialize - start testinging after the "alg_then_marker" (if exists)
* (probably will be buggy for nested IFs)
	DO i1 =  1, uvar_num_items(uvar)
	  itype = uvar_item_type(i1,uvar)
	  IF ( itype .EQ. alg_then_marker ) GOTO 10
	ENDDO
	i1 = 1

* test the "purity" of the expression
 10	DO 100 i = i1, uvar_num_items(uvar)

	  itype = uvar_item_type(i,uvar)

* constants and pseudo-variables are known to be numeric
	  IF   ( itype .EQ. alg_constant   
     .	  .OR.   itype .EQ. alg_pseudo_var 
     .	  .OR.   itype .EQ. alg_counter_var ) THEN
	     GOTO 1000

	  ELSEIF (
     .		 itype .EQ. alg_child_var   
     .	  .OR.   itype .EQ. alg_variable   
     .	  .OR.   itype .EQ. alg_grid_chg_fcn  
     .	  .OR.   itype .EQ. alg_dir_chg_fcn 
     .	  .OR.   itype .EQ. alg_const_var
     .	  .OR.   itype .EQ. alg_string    
     .	  .OR.   itype .EQ. alg_attrib_val  ) THEN
	     GOTO 100

	  ELSEIF ( itype .EQ. alg_if_marker
     .    .OR.     itype .EQ. alg_then_marker
     .	      .OR. itype .EQ. alg_log_struct
     .	      .OR. itype .EQ. alg_log_vstruct) THEN
	     GOTO 100

	  ELSEIF ( itype .EQ. alg_function  ) THEN
	     GOTO 1000

	  ELSEIF ( itype .EQ. alg_operator  ) THEN
	     ii = uvar_item_start( i, uvar )
	     IF ( uvar_text(uvar)(ii:ii).EQ.'+' ) THEN
	       GOTO 100
	     ELSE
	       GOTO 1000
	     ENDIF

	  ELSE
	     STOP 'unknown_alg_cat'
	  ENDIF
 100	CONTINUE

* yes
	ITSA_PURE_SUM_VAR = .TRUE.
	RETURN

* no
 10000	ITSA_PURE_SUM_VAR = .FALSE.
	RETURN

	END

	SUBROUTINE IS_CONSTANT(  *, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* create a constant value "variable" in memory

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 7/28/87
* revision 0.1 - 6/23/88 - set bad data flag to -2.1E34 so -1.E34 is valid
* V200:  6/26/89 - just a single value
*	11/30/89 - added diagnostic output
* V312: 5/94 - array "memory" as a calling argument
* V554  1/04 - *acm* remove VAX common statements.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
 
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xvariables.cmn'
	include	'xcontext.cmn'
	include	'xprog_state.cmn'

* calling argument declarations:
	INTEGER	status

* internal variable declarations:
	INTEGER	mr, cx

* equivalences
	REAL	cx_value( max_cx )
	EQUIVALENCE ( cx_variable, cx_value )

* --- end of introductory code ---
* initialize
	cx = is_cx( isp )

* reserve and catalog space for the result
	CALL CREATE_TEMP_MEM_VAR( cx, mr, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	is_mr( isp ) = mr

* diagnostic output
	IF (mode_diagnostic) CALL DIAGNOSTIC_OUT('constan',mr,point_to_mr)

* insert the constant
	memry(mr)%ptr(1) = cx_value(cx)

* set the bad data flag to an unusual number
	mr_bad_data( mr ) = -2.1E34

	RETURN 1

* error exit
 5000	RETURN
	END	

	SUBROUTINE POS_LAB( ss, cx, idim, ndec, string, slen )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* create a string of the form (e.g.) "I:22  X:130.5E"
* if grid is unknown then "I:22", alone
* if subscript is unknown then "I:*"

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:   ???? 
*	 7/10/90 - added checks for invalid grid and ss
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include	'xcontext.cmn'
	include	'xtext_info.cmn'

* calling argument declarations:
	INTEGER		ss, cx, idim, ndec, slen
	CHARACTER*(*)	string
	
* local variable declarations:
	INTEGER		TM_LENSTR1, grid
	CHARACTER*48	TM_FMT
	REAL*8		TM_WORLD

* initialize string with subscript (e.g.) "I:22 " or "I:*"
	IF ( ss .NE. unspecified_int4 ) THEN
	   string = ss_dim_name(idim) // ':' // TM_FMT( DBLE(ss),0,4,slen )
	   slen = slen + 2
	ELSE
	   string = ss_dim_name(idim) // ':*'
	   slen = 3
	   RETURN
	ENDIF

* done with pathological cases
	IF ( cx .GT. 0 ) THEN
	   grid = cx_grid( cx )
	ELSE
	   RETURN
	ENDIF

* add on world coord axis name (e.g.) "I:22  X:"
	string = string(:slen+1) // ww_dim_name(idim) // ':'

* add formatted world coordinate position
	CALL TRANSLATE_TO_WORLD
     .	   ( TM_WORLD( ss, grid, idim, box_middle ),
     .	     idim, grid, ndec, string(slen+7: ) )

* compute string length
	slen = TM_LENSTR1( string )

	RETURN
	END

! rect_to_curv.F
! 
! renamed from hinterp_bilinear.F  
! From Matt Harrison hinterp.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
! to CALL only the bilinear interpolation modules, and
! recast in F77-compileable code.
! ACM 3/2004
!
! mjh@gfdl.gov
! 2/20/2003
!
! In this subroutine we provide information about
! the function.  The user configurable information 
! consists of the following:
!
! descr              Text description of the function
!
! num_args           Required number of arguments
!
! axis_inheritance   Type of axis for the result
!                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
!                       CUSTOM          - user defined axis
!                       IMPLIED_BY_ARGS - same axis as the incoming argument
!                       NORMAL          - the result is normal to this axis
!                       ABSTRACT        - an axis which only has index values
!
! piecemeal_ok       For memory optimization:
!                       axes where calculation may be performed piecemeal
!                       ( YES, NO )
! 
!
! For each argument we provide the following information:
!
! name               Text name for an argument
!
! unit               Text units for an argument
!
! desc               Text description of an argument
!
! axis_influence     Are this argument's axes the same as the result grid?
!                       ( YES, NO )
!
! axis_extend       How much does Ferret need to extend arg limits relative to result 
!


      SUBROUTINE rect_to_curv_init(id)
        
      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER   id, arg
      CHARACTER*100  descr

!**********************************************************************
!                                           USER CONFIGURABLE PORTION |
!                                                                     |
!                                                                     V

      WRITE (descr, 10)
   10 FORMAT ('Regrid from rectangular to curvilinear grid')
      CALL ef_set_desc(id, descr)

      CALL ef_set_num_args(id, 4)
      CALL ef_set_num_work_arrays(id, 8)

      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS,  
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'V')
      CALL ef_set_arg_desc(id, arg,
     ,  'variable V(x,y,z,t) on rectilinear grid')
      CALL ef_set_axis_influence(id, arg, NO, NO, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'lon_bounds_out')
      CALL ef_set_arg_unit(id, arg, 'degrees')
      CALL ef_set_arg_desc(id, arg, 
     .  'Destination curvilinear grid longitude bounds(2-D)')
      CALL ef_set_axis_influence(id, arg, YES, YES, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'lat_bounds_out')
      CALL ef_set_arg_unit(id, arg, 'degrees')
      CALL ef_set_arg_desc(id, arg, 
     .  'Destination curvilinear grid latitude bounds(2-D)')
      CALL ef_set_axis_influence(id, arg, YES, YES, NO, NO)   
      
      arg = 4
      CALL ef_set_arg_name(id, arg, 'missing_allowed')
      WRITE (descr, 20)
   20 FORMAT ('number of missing values allowed in four ',
     .   'surrounding source cells: 0 to 3')
      CALL ef_set_arg_desc(id, arg, descr)
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)      

!                                                                     ^
!                                                                     |
!                                           USER CONFIGURABLE PORTION |
!***********************************************************************

      RETURN 
      END  ! subroutine rect_to_curv_init

*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE rect_to_curv_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work array X/Y/Z/T dimensions
*
* ef_set_work_array_lens(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER array_num, nx, ny
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)
      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)

*   real wti(nlon_dst,nlat_dst,2)      
*   weights for bilinear interpolation 

      array_num = 1
      CALL ef_set_work_array_dims(id, array_num,
     .     arg_lo_ss(X_AXIS,ARG3), arg_lo_ss(Y_AXIS,ARG3), 
     .     1, 0, 
     .     arg_hi_ss(X_AXIS,ARG3), arg_hi_ss(Y_AXIS,ARG3), 
     .     2, 0)
     
*  real wtj(nlon_dst,nlat_dst,2)      
*  weights for bilinear interpolation 

      array_num = 2
      CALL ef_set_work_array_dims(id, array_num,
     .     arg_lo_ss(X_AXIS,ARG3), arg_lo_ss(Y_AXIS,ARG3), 
     .     1, 0, 
     .     arg_hi_ss(X_AXIS,ARG3), arg_hi_ss(Y_AXIS,ARG3), 
     .     2, 0)

*  real*8 in_lon_lat(max(nlat_src+1, nlon_src+1), 2) 
*  edges of x,y input axes, will be declared real*8
      array_num = 3
      nx = arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 2
      ny = arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1) + 2
      nx = MAX(nx,ny)
      CALL ef_set_work_array_dims(id, array_num,
     .        1,  1, 1, 1,
     .     2*nx, 4, 1, 1)

*  real rad_lon_lat(max(nlat_src+1, nlon_src+1), 2) 
*  edges of input axes, will be declared real, converted to radians

      array_num = 4
      CALL ef_set_work_array_dims(id, array_num,
     .     1,  1, 1, 1,
     .     nx, 2, 1, 1)

*  real out_lon(nlon_dst, nlat_dst)  
*  edges of output longitude grid, will be converted to radians

      array_num = 5
      nx = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1
      ny = arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) + 1
      CALL ef_set_work_array_dims(id, array_num,
     .     1,   1, 1, 1,
     .     nx, ny, 1, 1)

*  real out_lat(nlon_dst, nlat_dst)      
*  edges of output latitude grid, will be converted to radians

      array_num = 6
      nx = arg_hi_ss(X_AXIS,ARG3) - arg_lo_ss(X_AXIS,ARG3) + 1
      ny = arg_hi_ss(Y_AXIS,ARG3) - arg_lo_ss(Y_AXIS,ARG3) + 1
      CALL ef_set_work_array_dims(id, array_num,
     .     1,   1, 1, 1,
     .     nx, ny, 1, 1)

*  integer i_lon(nlon_dst,nlat_dst,2) 
* indices for bilinear interpolation 
* These will be declared integer inside the compute routine

      array_num = 7
      CALL ef_set_work_array_dims(id, array_num,
     .     arg_lo_ss(X_AXIS,ARG3), arg_lo_ss(Y_AXIS,ARG3), 
     .     1, 1, 
     .     arg_hi_ss(X_AXIS,ARG3), arg_hi_ss(Y_AXIS,ARG3), 
     .     2, 1)

*  integer j_lat(nlon_dst,nlat_dst,2) 
*  indices for bilinear interpolation 
*  These will be declared integer inside the compute routine

      array_num = 8
      CALL ef_set_work_array_dims(id, array_num,
     .     arg_lo_ss(X_AXIS,ARG3), arg_lo_ss(Y_AXIS,ARG3), 
     .     1, 1, 
     .     arg_hi_ss(X_AXIS,ARG3), arg_hi_ss(Y_AXIS,ARG3), 
     .     2, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


!
! In this subroutine we compute the result
!
      SUBROUTINE rect_to_curv_compute(id, arg_1, arg_2, arg_3, 
     .          arg_4, result, wti, wtj, in_lon_lat,
     .          rad_lon_lat, out_lon, out_lat, i_lon, j_lat)

      implicit none
      
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'
      

      INTEGER  id

      REAL  bad_flag(EF_MAX_ARGS), bad_flag_result

      REAL  arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .       mem1lot:mem1hit)
      REAL  arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .       mem2lot:mem2hit)
      REAL  arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz,
     .       mem3lot:mem3hit)      
      REAL  arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz,
     .       mem4lot:mem4hit)       

      REAL  result(memreslox:memreshix, memresloy:memreshiy, 
     .      memresloz:memreshiz, memreslot:memreshit)
     
      REAL wti(wrk1lox:wrk1hix, wrk1loy:wrk1hiy,
     .               wrk1loz:wrk1hiz, wrk1lot:wrk1hit)
      REAL wtj(wrk2lox:wrk2hix, wrk2loy:wrk2hiy,
     .               wrk2loz:wrk2hiz, wrk2lot:wrk2hit)
      REAL*8 in_lon_lat(wrk3lox:wrk3hix/2, wrk3loy:wrk3hiy,
     .               wrk3loz:wrk3hiz, wrk3lot:wrk3hit)
      REAL rad_lon_lat(wrk4lox:wrk4hix, wrk4loy:wrk4hiy,
     .               wrk4loz:wrk4hiz, wrk4lot:wrk4hit)
      REAL out_lon(wrk5lox:wrk5hix, wrk5loy:wrk5hiy,
     .               wrk5loz:wrk5hiz, wrk5lot:wrk5hit)
      REAL out_lat(wrk6lox:wrk6hix, wrk6loy:wrk6hiy,
     .               wrk6loz:wrk6hiz, wrk6lot:wrk6hit)
      INTEGER i_lon(wrk7lox:wrk7hix, wrk7loy:wrk7hiy,
     .               wrk7loz:wrk7hiz, wrk7lot:wrk7hit)
      INTEGER j_lat(wrk8lox:wrk8hix, wrk8loy:wrk8hiy,
     .               wrk8loz:wrk8hiz, wrk8lot:wrk8hit)

! After initialization, the 'res_' arrays contain indexing information 
! for the result axes.  The 'arg_' arrays will contain the indexing 
! information for each variable's axes. 

      INTEGER  res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER  arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .         arg_incr(4,EF_MAX_ARGS)
      
!**********************************************************************
!                                           USER CONFIGURABLE PORTION |
!                                                                     |
!                                                                     V

      INTEGER  arg, idim, i, j, k, l, interp_method
      INTEGER  i1, j1, k1, l1, k2, k3, l2, l3, verbose,
     .         nlon_src, nlat_src, nlon_dst, nlat_dst, nx, ny

      REAL missing_permit, pi, pi180
      CHARACTER*16 axname(4), ax_units(4) 
      LOGICAL back(4), modulo(4), reg(4)

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

! Get edges of coordinate boxes on input axes.  Convert to radians.

      pi =  4.*ATAN(1.)
      pi180 = pi/ 180.

      arg = 1
     
      CALL ef_get_box_limits(id, ARG1, X_AXIS, arg_lo_ss(X_AXIS, ARG1), 
     .   arg_hi_ss(X_AXIS, ARG1), 
     .   in_lon_lat(1,1,1,1), in_lon_lat(1,3,1,1))

! last box upper limit
      nx = arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 1
      in_lon_lat(nx+1,1,1,1) = in_lon_lat(nx,3,1,1)

c      idim = 1
c      CALL EF_GET_COORDINATES (id, arg, idim,
c     .     arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)+1, 
c     .     in_lon_lat(1,1,1,1) )

! Transform degrees to radians

      nx = arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 2
      DO i = 1, nx
        rad_lon_lat(i, 1, 1, 1) = pi180* in_lon_lat(i,1,1,1)
      ENDDO

      CALL ef_get_box_limits(id, ARG1, Y_AXIS, arg_lo_ss(Y_AXIS, ARG1), 
     .   arg_hi_ss(Y_AXIS, ARG1), 
     .   in_lon_lat(1,2,1,1), in_lon_lat(1,4,1,1))

! last box upper limit
      ny = arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1) + 1
      in_lon_lat(ny+1,2,1,1) = in_lon_lat(ny,4,1,1)

c      idim = 2
c      CALL EF_GET_COORDINATES (id, arg, idim,
c     .     arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)+1, 
c     .     in_lon_lat(1,2,1,1) )

! Transform degrees to radians

      ny = arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1) + 2
      DO i = 1, ny
        rad_lon_lat(i, 2, 1, 1) = pi180* in_lon_lat(i,2,1,1)
      ENDDO

      k2 = arg_lo_ss(Z_AXIS,ARG2)
      l2 = arg_lo_ss(T_AXIS,ARG2)
      DO j = arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS,ARG2)
         DO i = arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS,ARG2)
            out_lon(i, j, 1, 1) = pi180* arg_2(i,j,k2,l2)
         ENDDO
      ENDDO

      k3 = arg_lo_ss(Z_AXIS,ARG3)
      l3 = arg_lo_ss(T_AXIS,ARG3)
      DO j = arg_lo_ss(Y_AXIS,ARG3), arg_hi_ss(Y_AXIS,ARG3)
         DO i = arg_lo_ss(X_AXIS,ARG3), arg_hi_ss(X_AXIS,ARG3)
            out_lat(i, j, 1, 1) = pi180* arg_3(i,j,k3,l3)
         ENDDO
      ENDDO

      CALL ef_get_axis_info(id,ARG1,axname,ax_units,back,modulo,reg)

      interp_method = 2
!      WRITE(*,*) 'Using bilinear regridding !!'

! Number of missing cells to allow (0 to 3)

      CALL ef_get_one_val (id, 4, missing_permit)
      IF (missing_permit .LT. 0 .OR. missing_permit .GT. 3) 
     .    CALL ef_bail_out (id, 'argument 6 must be between 0 and 3')

      CALL ef_get_bad_flags(id,bad_flag,bad_flag_result)

! nlon_src and nlat_src without the extra element for upper grid box (why?)

      nlon_src = nx-1
      nlat_src = ny-1
      nlon_dst = arg_hi_ss(X_AXIS,ARG3) - arg_lo_ss(X_AXIS,ARG3) + 1
      nlat_dst = arg_hi_ss(Y_AXIS,ARG3) - arg_lo_ss(Y_AXIS,ARG3) + 1

      verbose = 0
      CALL horiz_interp_init_bili (id, wti, wtj, i_lon, j_lat,  
     .   nlon_src, nlat_src, nlon_dst, nlat_dst, interp_method, 
     .   rad_lon_lat(1,1,1,1), rad_lon_lat(1,2,1,1), out_lon, out_lat, 
     .   verbose, modulo(1) )

      i1 = arg_lo_ss(X_AXIS,ARG1)
      j1 = arg_lo_ss(Y_AXIS,ARG1)

      i = res_lo_ss(X_AXIS)
      j = res_lo_ss(Y_AXIS)

      l1 = arg_lo_ss(T_AXIS,ARG1)
      DO l = res_lo_ss(T_AXIS),res_hi_ss(T_AXIS)
         k1 = arg_lo_ss(Z_AXIS,ARG1)
         DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

            CALL horiz_interp_bili ( wti, wtj, i_lon, j_lat,  
     .                    nlon_src, nlat_src, nlon_dst, 
     .                    nlat_dst, interp_method, 
     .                    arg_1(i1,j1,k1,l1), result(i,j,k,l),
     .                    verbose, bad_flag(ARG1), bad_flag_result,
     .                    missing_permit)

            k1 = k1 + arg_incr(Z_AXIS,ARG1)
         ENDDO
         l1 = l1 + arg_incr(T_AXIS,ARG1)
      ENDDO


!                                                                     ^
!                                                                     |
!                                           USER CONFIGURABLE PORTION |
!**********************************************************************

      RETURN 
      END  ! subroutine rect_to_curv_compute
* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*    horiz_interp_init_bili

! From module hinterp_subs_mod


! <CONTACT EMAIL='bw@gfdl.noaa.gov'>
!   Bruce Wyman
! </CONTACT>

! <HISTORY SRC='http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/'/>

! <OVERVIEW>
!   Performs spatial interpolation between grids.
! </OVERVIEW>

! <DESCRIPTION>
!     This module can interpolate data from rectangular/tripolar grid
!     to rectangular/tripolar grid. Three interpolation schems are used here.
!     when the source grid is tripolar grid, inverse of square distance weighted
!     scheme (spherical regrid) is used. When the source grid is rectangular 
!     longitude/latitude grid, any one of following three schemes can be applied: 
!     conservation scheme that conserves the area-weighed integral of the input field, 
!     bilinear interpolation that use the surround four source grid to interpolate onto
!     the destination grid, spherical regrid that use thes inverse of square distance
!     as weight. User can choose the interpolation method in the horiz_interp_init.
!     when the source grid is rectangular grid (1D), the default method is conserve
!     scheme. When the source grid is tripolar grid (2D), spherical regrid is the 
!     default algorithm and no other scheme can be applied. 

!     There is an optional mask field for missing input data.
!     An optional output mask field may be used in conjunction with
!     the input mask to show where output data exists.
! </DESCRIPTION>

!-----------------------------------------------------------------------
!
!        Performs spatial interpolation between grids.
!
!-----------------------------------------------------------------------

      


!---- interfaces ----



! <INTERFACE NAME='horiz_interp_init'>
!   <OVERVIEW>
!      Allocates space and initializes a derived-type variable
!      that contains pre-computed interpolation indices and weights.
!   </OVERVIEW>
!   <DESCRIPTION>
!      Allocates space and initializes a derived-type variable
!      that contains pre-computed interpolation indices and weights
!      for improved performance of multiple interpolations between
!      the same grids. This routine does not need to be called if you
!      are doing a single grid-to-grid interpolation.
!   </DESCRIPTION>
!   <IN NAME='lon_in' TYPE='real' DIM='dimension(:), dimension(:,:)' UNITS='radians'>
!      Longitude (in radians) for source data grid. when lon_in is 1D, it is the longitude
!      edges and its value are for adjacent grid boxes and must increase 
!      in value. When lon_in is 2D, there are two cases: one is the longitude edges stored as
!      pairs for each grid box (when interp_method is 1(conservative)), the other is the longitude
!      of the center of each grid box. 
!   </IN>
!   <IN NAME='lat_in' TYPE='real' DIM='dimension(:), dimension(:,:)' UNITS='radians'>
!      Latitude (in radians) for source data grid. when lat_in is 1D, it is the latitude
!      edges and its value are for adjacent grid boxes and must increase 
!      in value. When lat_in is 2D, it is the longitude of the center of each grid box.
!      When interp_method is 1(conservative) or 2(bilinear), lon_in should be 1D.
!   </IN>
!   <IN NAME='lon_out' TYPE='real' DIM='dimension(:), dimension(:,:)' UNITS='radians' >
!      Longitude (in radians) for source data grid. when lon_in is 1D, it is the longitude
!      edges and its value are for adjacent grid boxes and must increase 
!      in value. When lon_in is 2D, there are two cases: one is the longitude edges stored as
!      pairs for each grid box (when interp_method is 1), the other is the longitude
!      of the center of each grid box (when interp_method is 2). 
!   </IN>
!   <IN NAME='lat_out' TYPE='real' DIM='dimension(:), dimension(:,:)' UNITS='radians' >
!      Latitude (in radians) for source data grid. when lat_in is 1D, it is the latitude
!      edges and its value are for adjacent grid boxes and must increase 
!      in value. When lat_in is 2D, there are two cases: one is the latitude edges stored as
!      pairs for each grid box (when interp_method is 1), the other is the latitude
!      of the center of each grid box (when interp_method is 2).
!   </IN>
!   <IN NAME='verbose' TYPE='integer'>
!      Integer flag that controls the amount of printed output.
!      verbose = 0, no output; = 1, min,max,means; = 2, still more
!   </IN>
!   <IN NAME='interp_method' TYPE='integer'> 
!      interpolation method, = 1, using conservation scheme,
!      = 2, using bilinear interpolation, = SPHERICA(3),using spherical regrid.
!      when source grid is 1d, default value is CONSERVE; when source grid is 2d,
!      default value is 'SPHERICA'.
!   </IN>
!   <IN NAME = 'src_modulo' >
!      Indicate the source data grid is cyclic or not.
!   </IN>
!   <OUT NAME='Interp' >
!      A derived-type variable containing indices and weights used for subsequent 
!      interpolations. To reinitialize this variable for a different grid-to-grid 
!      interpolation you must first use the 'horiz_interp_end' interface.
!   </OUT>


! </INTERFACE>


C      real wti(nlon_dst,nlon_dst,2)      !weights for bilinear interpolation 
C      real wtj(nlat_dst,nlat_dst,2)
C      integer i_lon(nlon_dst,nlon_dst,2) !indices for bilinear interpolation 
C      integer j_lat(nlat_dst,nlat_dst,2)
C      integer nlon_src, nlat_src         !size of source grid
C      integer nlon_dst, nlat_dst         !size of destination grid
C      integer interp_method              !interpolation method.
                                         !  =1, conservative scheme
                                         !  =2, bilinear interpolation
                                         !  =3, spherical regrid


C Interp list:
C wti, wtj, i_lon, j_lat, nlon_src, nlat_src, nlon_dst, nlat_dst, interp_method 

C Interp allocation from subroutine horiz_interp_init_bili 

      subroutine horiz_interp_init_bili (id, wti, wtj, i_lon, j_lat,  
     .   nlon_src, nlat_src, nlon_dst,nlat_dst, interp_method, 
     .   lon_in, lat_in, lon_out, lat_out, verbose, src_modulo )

!-----------------------------------------------------------------------
C inputs
C  From type horiz_interp_type, variable Interp


      real wti(nlon_dst,nlat_dst,2)      !weights for bilinear interpolation 
      real wtj(nlon_dst,nlat_dst,2)
      integer i_lon(nlon_dst,nlat_dst,2) !indices for bilinear interpolation 
      integer j_lat(nlon_dst,nlat_dst,2)
      integer nlon_src, nlat_src         !size of source grid
      integer nlon_dst, nlat_dst         !size of destination grid
      integer interp_method              !interpolation method.

C Other inputs

      real lon_in(*) , lat_in(*)
      real lon_out(nlon_dst,nlat_dst), lat_out(nlon_dst,nlat_dst)
      integer id, verbose
      logical src_modulo
!-----------------------------------------------------------------------
C  Other declarations

      integer INDP, nlon_in, nlat_in, nlon_out, nlat_out, n, m,
     .   i, j, ie, is, je, js, istart, jstart, iend, jend, 
     .   ln_err, lt_err, na, warns
      real wtw, wte, wts, wtn, lon, lat, pi, tpi, hpi,      
     .   glt_min, glt_max, gln_min, gln_max, min_lon, max_lon

! parameters
      real epsln, large
      integer stdout 
      parameter (epsln=1.e-10, large=1.e20, stdout = 6)

      pi  =  3.14159265358979323846 
      hpi = 0.5*pi
      tpi = 4.0*hpi
      glt_min = hpi
      glt_max = -hpi
      gln_min = tpi
      gln_max = -tpi
      min_lon = 0.0
      max_lon = tpi
      ln_err = 0
      lt_err = 0

      warns = verbose

      nlon_in = nlon_src  
      nlat_in = nlat_src
      nlon_out = nlon_dst
      nlat_out = nlat_dst

      if(lon_in(nlon_in) - lon_in(1) .gt. tpi + epsln) 
     . call ef_bail_out (id, 
     . 'The range of source grid longitude may be no larger than tpi')

      if(lon_in(1) .lt. 0.0) then
        min_lon = lon_in(1)
        max_lon = lon_in(nlon_in)
      endif

!     find longitude points of data within interval [-360., 360.]
      istart = 1
      do i=2,nlon_in
        if (lon_in(i-1) .lt. -tpi .and. lon_in(i) .ge. -tpi) istart = i
      enddo 
      iend = nlon_in
      do i=2,nlon_in
        if (lon_in(i-1) .lt. tpi  .and. lon_in(i) .ge. tpi) iend = i
      enddo

!     find latitude points of data within interval [-90., 90.]
      jstart = 1
      do j=2,nlat_in
        if (lat_in(j-1) .lt. -1.0 * hpi .and. 
     .      lat_in(j  ) .ge. -1.0 * hpi) jstart = j
      enddo 
      jend = nlat_in
      do j=2,nlat_in
        if (lat_in(j-1) .lt. hpi .and. lat_in(j) .ge.hpi ) jend = j
      enddo

      do n = 1, nlat_out
      do m = 1, nlon_out
        lon = lon_out(m,n)
        lat = lat_out(m,n)

        if(lon .lt. min_lon) then
         lon = lon + tpi
        else if(lon .gt. max_lon) then
         lon = lon - tpi
        endif
! when the input grid is in not cyclic, the output grid should located inside
! the input grid
      if(.not. src_modulo) then
        if((lon .lt. lon_in(1)) .or. (lon .gt. lon_in(nlon_in))) 
     .   call ef_bail_out(id, 
     .'input grid not modulo, output grid must be inside input grid')


      endif

      glt_min = min(lat,glt_min)
      glt_max = max(lat,glt_max)
      gln_min = min(lon,gln_min)
      gln_max = max(lon,gln_max)

      na = iend - istart + 1
      is = INDP(lon, lon_in(istart), na ) + istart - 1
      if( lon_in(is) .gt. lon ) is = max(is - 1,istart)
      if( lon_in(is) .eq. lon .and. is .eq. nlon_in) 
     .      is = max(is - 1,istart)
      ie = min(is+1,iend)
      if(lon_in(is) .ne. lon_in(ie) .and. lon_in(is) .le. lon) then
        wtw = ( lon_in(ie) - lon) / (lon_in(ie) - lon_in(is) )
      else
! east or west of the last data value. this could be because a
! cyclic condition is needed or the dataset is too small. 
        ln_err = 1
        ie = istart
        is = iend
        if (lon_in(ie) .ge. lon ) then
           wtw = (lon_in(ie) -lon)/(lon_in(ie)-lon_in(is)+tpi+epsln)
        else
          wtw = (lon_in(ie) -lon+tpi+epsln)/
     .          (lon_in(ie)-lon_in(is)+tpi+epsln)
        endif   
      endif
      wte = 1. - wtw

      na = jend - jstart + 1
      js = INDP(lat, lat_in(jstart), na ) + jstart - 1

      if( lat_in(js) .gt. lat ) js = max(js - 1, jstart)
      if( lat_in(js) .eq. lat .and. js .eq. jend) 
     .     js = max(js - 1, jstart)
      je = min(js + 1, jend)

      if ( lat_in(js) .ne. lat_in(je) .and. lat_in(js) .le. lat) then
        wts = ( lat_in(je) - lat )/(lat_in(je)-lat_in(js))
      else
!     north or south of the last data value. this could be because a
!     pole is not included in the data set or the dataset is too small.
!     in either case extrapolate north or south
         lt_err = 1
         wts = 1.
      endif

      wtn = 1. - wts
      
            i_lon (m,n,1) = is
            i_lon (m,n,2) = ie
            j_lat (m,n,1) = js
            j_lat (m,n,2) = je
            wti   (m,n,1) = wtw
            wti   (m,n,2) = wte
            wtj   (m,n,1) = wts
            wtj   (m,n,2) = wtn
      
      enddo
      enddo
      if (ln_err .eq. 1 .and. warns .GT. 0) then
        write (stdout,'(/,(1x,a))') 
     . '==> Warning: the geographic data set does not extend far   ', 
     . '             enough east or west - a cyclic boundary       ', 
     . '             condition was applied. check if appropriate   '
         write (stdout,'(/,(1x,a,2f8.4))') 
     . '    data required between longitudes:', gln_min, gln_max,     
     . '    data set is between longitudes:', 
     .   lon_in(istart), lon_in(iend)
         warns = warns - 1
       endif
!
       if (lt_err .eq. 1 .and. warns .GT. 0) then
         write (stdout,'(/,(1x,a))')
     . '==> Warning: the geographic data set does not extend far   ',
     . '             enough north or south - extrapolation from    ',
     . '             the nearest data was applied. this may create ',
     . '             artificial gradients near a geographic pole   ' 
         write (stdout,'(/,(1x,a,2f8.4))')
     . '    data required between latitudes:', glt_min, glt_max,
     . '      data set is between latitudes:', 
     .   lat_in(jstart), lat_in(jend)
         warns = warns - 1
       endif

       return

      end ! subroutine horiz_interp_init_bili

* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      subroutine horiz_interp_bili ( wti, wtj, i_lon, j_lat,  
     .                    nlon_src, nlat_src, nlon_dst, 
     .                    nlat_dst, interp_method, 

     .                    data_in, data_out, verbose, 
     .                    missing_value,  missing_result, 
     .                    missing_permit)
!-----------------------------------------------------------------------


!-----------------------------------------------------------------------
C  From type horiz_interp_type, variable Interp

      real wti(nlon_dst,nlat_dst,2)      !weights for bilinear interpolation 
      real wtj(nlon_dst,nlat_dst,2)
      integer i_lon(nlon_dst,nlat_dst,2) !indices for bilinear interpolation 
      integer j_lat(nlon_dst,nlat_dst,2)
      integer nlon_src, nlat_src         !size of source grid
      integer nlon_dst, nlat_dst         !size of destination grid
      integer interp_method              !interpolation method.

      real data_in(nlon_src, nlat_src)   ! input
      real data_out(nlon_dst, nlat_dst)  ! output
      integer verbose
      real missing_value                 ! missing flag of input
      real missing_result                ! missing flag for result
      real missing_permit                ! Number of missing cells to allow
!-----------------------------------------------------------------------
      integer nlon_in, nlat_in, nlon_out, nlat_out, n, m,
     .            is, ie, js, je, iverbose, num_missing, 
     .            miss_in, miss_out
      real  dwtsum, wtsum, min_in, max_in, avg_in, 
     .            min_out, max_out, avg_out, wtw, wte, wts, wtn
      real data(4)

! parameters
      real epsln, large
      parameter (epsln=1.e-10, large=1.e20)

      nlon_in  = nlon_src
      nlat_in  = nlat_src
      nlon_out = nlon_dst
      nlat_out = nlat_dst

      iverbose = verbose

      do n = 1, nlat_out
      do m = 1, nlon_out
      data_out(m,n) = 0.0

      is = i_lon (m,n,1) 
      ie = i_lon (m,n,2)
      js = j_lat (m,n,1)
      je = j_lat (m,n,2)
      wtw = wti(m,n,1)
      wte = wti(m,n,2)
      wts = wtj(m,n,1)
      wtn = wtj(m,n,2)
      data(1) = data_in(is,js)
      data(2) = data_in(ie,js)
      data(3) = data_in(ie,je)
      data(4) = data_in(is,je)

      call data_sum_bilinear ( data, wtw,wte, wts,wtn, dwtsum, wtsum, 
     .   num_missing, missing_value)

      if (num_missing .gt. missing_permit .or. wtsum .lt. epsln) then
        data_out(m,n) = missing_result
      else
        data_out(m,n) = dwtsum/wtsum
      endif
      enddo
      enddo

!***********************************************************************
! compute statistics: minimum, maximum, and mean
!-----------------------------------------------------------------------

!!      if (iverbose .GT. 0) then
!!
!!! compute statistics of input data
!!
!!       call stats_type2 (data_in, min_in, max_in, avg_in, 
!!   .           miss_in, missing_value)
!!
!!! compute statistics of output data
!!       call stats_type2 (data_out, min_out, max_out, avg_out, 
!!   .          miss_out, missing_value)
!!
!!!---- output statistics ----
!!! root_pe have the information of global mean, min and max
!!
!!       write (*,900)
!!       write (*,901)  min_in ,max_in, avg_in
!!         write (*,903)  miss_in
!!         write (*,902)  min_out,max_out,avg_out
!!         write (*,903)  miss_out
!! 900     format (/,1x,10('-'),' output from horiz_interp ',10('-'))
!! 901     format ('  input:  min=',f16.9,'  max=',f16.9,'  avg=',f22.15)
!! 902     format (' output:  min=',f16.9,'  max=',f16.9,'  avg=',f22.15)
!! 903     format ('          number of missing points = ',i6)
!!
!!      endif


      return

      end ! subroutine horiz_interp_bili

* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

       integer function INDP (value, array, ia)
       real array(*)
       real value
       integer ia
!
!=======================================================================
!
!     INDP = index of nearest data point within "array" corresponding to
!            "value".

!     inputs:
!     value  = arbitrary data...same units as elements in "array"
!     array  = array of data points  (must be monotonically increasing)

!     output:
!     INDP =  index of nearest data point to "value"
!             if "value" is outside the domain of "array" then INDP = 1
!             or "ia" depending on whether array(1) or array(ia) is
!             closest to "value"
!=======================================================================
!
       integer i
       logical keep_going
!
       do i=2,ia
         if (array(i) .lt. array(i-1)) then
         write (6,*) 
     .   ' => Error: array must be monotonically increasing in "INDP"', 
     .   '          when searching for nearest element to value=',value
         write (6,*) '           array(i) < array(i-1) for i=',i 
         write (6,*) '           array(i) for i=1..ia follows:'
         stop
        endif
      enddo
      if (value .lt. array(1) .or. value .gt. array(ia)) then
        if (value .lt. array(1))  INDP = 1
        if (value .gt. array(ia)) INDP = ia
      else
        i=1
        keep_going = .true.
        do while (i .le. ia .and. keep_going)
          i = i+1
          if (value .le. array(i)) then
            INDP = i
            if (array(i)-value .gt. value-array(i-1)) INDP = i-1
            keep_going = .false.
          endif
        enddo
      endif
      return
      end ! function INDP

* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      subroutine data_sum_bilinear ( data, wtw, wte, wts, wtn, 
     .                               dwtsum, wtsum, num_missing,
     .                               missing_value  )

!  sums up the data and weights for a single output grid box
!-----------------------------------------------------------------------
      real data(*)
      real wtw, wte, wts, wtn
      real dwtsum, wtsum
      integer num_missing
      real missing_value

!  dwtsum = sum(data*wt*mask)
!  wtsum  = sum(wt*mask)

      integer i
      real wt1, wt2
!-----------------------------------------------------------------------


      num_missing = 0
      dwtsum = 0.0
      wtsum  = 0.0

      do i = 1,4
      if(data(i) .eq. missing_value) then
         num_missing = num_missing + 1
      else
         if (i .eq. 1) then
            wt1= wtw
            wt2 = wts
         else if (i .eq. 2) then
            wt1= wte
            wt2 = wts
         else if (i .eq. 3) then
            wt1= wte
            wt2 = wtn
         else if (i  .eq. 4) then
            wt1= wtw 
            wt2 = wtn
         endif

         dwtsum = dwtsum + data(i) * wt1 * wt2
         wtsum  = wtsum + wt1 * wt2
      endif
      enddo

      return
      end ! subroutine data_sum_bilinear

* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!---This statistics is for bilinear interpolation and spherical regrid.

!!      subroutine stats_type2 ( dat, low, high, avg, miss, missing_value,
!!     .  nlon, nlat)
!!
!!      real dat(nlon,nlat)
!!      real low, high, avg  ! output
!!      integer miss         ! output
!!      real  missing_value  ! input
!!      integer nlon, nlat   ! input
!!
!!
!!      real dsum, npts
!!      integer n, m
!!
!!      dsum = 0.0
!!      miss = 0
!!      npts = 0
!!
!!      do n = 1, nlat
!!      do m = 1, nlon
!!      IF (dat(m,n) .NE. missing_value) THEN
!!         npts = npts + 1
!!         low = MIN( low, dat(m,n) )
!!         high = MAX (high, dat(m,n) )
!!         dsum = dsum + dat(m,n)
!!      ELSE
!!         miss = miss + 1
!!      ENDIF
!!      ENDDO
!!      ENDDO
!!
!!      if(npts .EQ. 0) then
!!         avg = missing_value
!!      else
!!         avg = dsum/real(npts)
!!      endif
!!   
!!      return
!!
!!      end  ! subroutine stats_type2


* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

	SUBROUTINE EZ_INIT_PERMUTE(varnum )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* work routine for EZ_READ when /ORDER is not the default X-Y-Z-T
* Initialize the variables used to translate the permuted subscripts
* into the 1D array index

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Thermal Modeling and Analysis Program

* revision 0.00 -  5/94 *sh*
* Linux port -kob - 3/97 - Modify include for tmap_dset.parm to be a
*			   preprocessor include for F90 - needed because
*			   tmap_dset.parm contains an ifdef
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing

* calling arguments:
* varnum - the variable number in COMMON
	INTEGER varnum

        include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
        include 'xtm_grid.cmn_text'
        include 'xdset_info.cmn_text'
        include 'xez_order.cmn_text'

* local variable definitions:
	INTEGER idim, gridnum, line

* initialize
	gridnum = ds_grid_number(varnum)

* ezii    - the "current" subscript, zero referenced
* ezorder - the permuted ordering
* eznn    - the length of each axis
	DO 100 idim = 1, nferdims
	   ezii(idim) = 0
	   ezorder(idim) = ds_ordering(idim, varnum)
	   line = grid_line(idim, gridnum)
	   IF ( line .EQ. mpsnorm) THEN
	      eznn(idim) = 1
	   ELSE
	      eznn(idim) = line_dim(line)
	   ENDIF
 100	CONTINUE

* decrement by 1 since EZ_READ pre-increments
	ezii(ezorder(1)) = ezii(ezorder(1)) - 1
	RETURN
        END

	subroutine epicvc
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)epicvc.F	1.1    3/10/88
C**
C**
C***********************************************************************        C**
C**                 EPIC
C**
C***********************************************************************        C**
C**
c
c  Gets column numbers for variables specified by the PLOT5 EVAR command.
c  Called in RDSEQ for each EPIC data file read.  For EVAR/NOCTD, the
c  default x is time and threis no default for y.  For 	EVAR/CTD, the
c  default for y is the variable in column 1 (usually pressure)
c  and the default for x is the variable in column 2.
c  The file is omitted  if selected data is not on the data file.
c
c  Programmed by N. Soreide, May 86.
c  Modified for CTD data 1/87, NNS.
c
#ifdef unix
	include 'DATA.INC'
	include 'COMTHDR.INC'
	include 'COMEPV.INC'
	include 'COMEPS.INC'
#else
	include 'pplinc:data.inc'
	include 'epicinc:comthdr.inc'
	include 'epicinc:comepv.inc'
	include 'epicinc:comeps.inc'
#endif
	logical varok,varck
c
c  Set jz=0 since EVAR is not used for contour data.
c
        jz=0
c
c  If iepv1 is .ge. 20000, then EPICKEY variable code = iepv1-20000.
c  If iepv1 is .ge. 10000, then column number = iepv1-10000.
c
c  Get x variable column number.  If not in data file, set jx=0
c  to get time as x-axis variable (in RDSEQ).  If iepv1=9, set
c  jx=0 for time as x-axis variable.
c
	if (iepv1.eq.-1 .or. iepv1.eq.15 .or. iepv1.eq.9) then
		jx=0
        else if (iepv1 .ge. 20000) then
                call varkey (theader,iepv1-20000,jx)
	else if (iepv1 .ge. 10000) then
		jx=iepv1-10000
	else
		varok=varck(theader,-iepv1,jx)
		if (.not. varok) jx=0
	endif
c
c  If iepv2 is .ge. 10000, then column number = iepv1-10000.
c
c  Get y variable column number.  If not in data file or iepv2=9, set 
c  jy=0 get time as y-variable.  If iepv2 is -1, use first
c  variable after date/time for y-variable.
c
	if (iepv2 .eq. -1) then
		jy=3
	else if (iepv2 .eq. 9) then
		jy=0
        else if (iepv2 .ge. 20000) then
                call varkey (theader,iepv2-20000,jy)
	else if (iepv2 .ge. 10000) then
		jy=iepv2-10000
	else
		varok=varck(theader,-iepv2,jy)
		if (.not. varok) jy=0
	endif
	nvar=max0 (jx,jy)
	if (lsctd) then
	    if (iepv1 .eq. -1) jx=2
	    if (iepv2 .eq. -1) jy=1
	endif
	ngrp=1
	return
	end

	SUBROUTINE REVERSE_GRID_AXIS_SUB( axis, dat, ddlo, ddhi, ddel,
     .		dlox, dhix, dloy, dhiy, dloz, dhiz, 
     .		dlot, dhit, dloe, dhie, dlof, dhif )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* reverse the grid indexing along the indicated axis
* the passed indices are correct for the *result* of the reversal

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V320: 2/16/89
* V541:  2/02 *sh* - added support for delta strides
* 2/12 *acm* Add E and F dimensions (use nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include 'ferret.parm'

* calling argument declarations:
	INTEGER axis, ddlo, ddhi, ddel,
     .		dlox, dhix, dloy, dhiy, dloz, dhiz, 
     .		dlot, dhit, dloe, dhie, dlof, dhif
	REAL    dat( dlox:dhix,dloy:dhiy,dloz:dhiz,dlot:dhit,dloe:dhie,dlof:dhif )

* internal variable declarations:
	INTEGER	i, j, k, l, m, n, turn_pt, hiplo
	REAL tmp

* --- end of introductory code ---

* initialize
	turn_pt = ddlo + (ddhi-ddlo-1)/2
	hiplo = ddlo + ddhi

* reverse the data along the appropriate axis

	IF ( axis .EQ. x_dim ) THEN
	   DO 100 n = dlof, dhif
	   DO 100 m = dloe, dhie
	   DO 100 l = dlot, dhit
	   DO 100 k = dloz, dhiz
	   DO 100 j = dloy, dhiy
	   DO 100 i = dlox, turn_pt

	      tmp = dat(i,j,k,l,m,n)
	      dat(      i,j,k,l,m,n) = dat(hiplo-i,j,k,l,m,n)
	      dat(hiplo-i,j,k,l,m,n) = tmp

 100	   CONTINUE

	ELSEIF ( axis .EQ. y_dim ) THEN
	   DO 200 n = dlof, dhif
	   DO 200 m = dloe, dhie
	   DO 200 l = dlot, dhit
	   DO 200 k = dloz, dhiz
	   DO 200 j = dloy, turn_pt
	   DO 200 i = dlox, dhix

	      tmp = dat(i,j,k,l,m,n)
	      dat(i,      j,k,l,m,n) = dat(i,hiplo-j,k,l,m,n)
	      dat(i,hiplo-j,k,l,m,n) = tmp

 200	   CONTINUE

	ELSEIF ( axis .EQ. z_dim ) THEN
	   DO 300 n = dlof, dhif
	   DO 300 m = dloe, dhie
	   DO 300 l = dlot, dhit
	   DO 300 k = dloz, turn_pt
	   DO 300 j = dloy, dhiy
	   DO 300 i = dlox, dhix

	      tmp = dat(i,j,k,l,m,n)
	      dat(i,j,      k,l,m,n) = dat(i,j,hiplo-k,l,m,n)
	      dat(i,j,hiplo-k,l,m,n) = tmp

 300	   CONTINUE

	ELSEIF ( axis .EQ. t_dim ) THEN
	   DO 400 n = dlof, dhif
	   DO 400 m = dloe, dhie
	   DO 400 l = dlot, turn_pt
	   DO 400 k = dloz, dhiz
	   DO 400 j = dloy, dhiy
	   DO 400 i = dlox, dhix

	      tmp = dat(i,j,k,l,m,n)
	      dat(i,j,k,      l,m,n) = dat(i,j,k,hiplo-l,m,n)
	      dat(i,j,k,hiplo-l,m,n) = tmp

 400	   CONTINUE
* TODO: REVERSE_GRID_AXIS_SUB along E and F axes?

* ALONG UNSUPPORTED AXIS
        ELSE
           STOP '**ERROR: REVERSE_GRID_AXIS_SUB on an unsupported axis'
        ENDIF

	RETURN
	END 

*
* lsl_lowpass.F
*
* LSL-low_pass_filter from Ned Cokelet.
*  Ansley Manke
*  Dec 6 1999
*
* Returns the argument filtered with Least Squares Lanzcos filter in time.
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE lsl_lowpass_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      CHARACTER*100 label

      WRITE (label, 10) 
   10 FORMAT ( 'Returns Least Squares Lanzcos filter of ',
     .          'equally-spaced time series' )
      CALL ef_set_desc(id,label)

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)

      CALL ef_set_num_work_arrays(id, 3)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_desc(id, arg, 'data to be filtered')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'cutoff_period')
      CALL ef_set_arg_desc(id, arg, 
     .   'period at which filter attains 1/2 amplitude. <=N')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'filter_span')
      CALL ef_set_arg_desc(id, arg, 
     . 'number of input data points used in each filtered output point')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE lsl_lowpass_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_dims(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER mt

      INTEGER iwork
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      mt = 1 + arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1)

*  x -- input time series
      iwork = 1
      CALL ef_set_work_array_dims (id, iwork, 1, 1, 1, 1, 
     .   mt, 1, 1, 1)

*  y -- output time series
      iwork = 2
      CALL ef_set_work_array_dims (id, iwork, 1, 1, 1, 1, 
     .   mt, 1, 1, 1)

*  h -- work array for subroutine LSL_low_pass_filter

      iwork = 3
      CALL ef_set_work_array_dims (id, iwork, 1, 1, 1, 1, 
     .   mt, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END



*
* In this subroutine we compute the result
*
      SUBROUTINE lsl_lowpass_compute(id, arg_1, arg_2, arg_3, result, 
     .                              x, y, h)

      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'
      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .     mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, 
     .     mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, 
     .     mem3loz:mem3hiz, mem3lot:mem3hit)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER i, j, k, l, n
      INTEGER i1, j1, k1, l1
      INTEGER nt
      INTEGER filter_span
      REAL cutoff_period
      CHARACTER*255 err_msg

*  Dimension the work arrays.

      REAL x(wrk1lox:wrk1hix, wrk1loy:wrk1hiy,
     .               wrk1loz:wrk1hiz, wrk1lot:wrk1hit)
      REAL y(wrk2lox:wrk2hix, wrk2loy:wrk2hiy,
     .               wrk2loz:wrk2hiz, wrk2lot:wrk2hit)
      REAL h(wrk3lox:wrk3hix, wrk3loy:wrk3hiy,
     .               wrk3loz:wrk3hiz, wrk3lot:wrk3hit)

*  Get argument and result subscripts and bad-data flags.

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*  Get cutoff parameter.

      cutoff_period = arg_2(arg_lo_ss(X_AXIS,ARG2), 
     .            arg_lo_ss(Y_AXIS,ARG2), arg_lo_ss(Z_AXIS,ARG2), 
     .            arg_lo_ss(T_AXIS,ARG2))

*  Get time percent parameter.

      filter_span = arg_3(arg_lo_ss(X_AXIS,ARG3), 
     .            arg_lo_ss(Y_AXIS,ARG3), arg_lo_ss(Z_AXIS,ARG3), 
     .            arg_lo_ss(T_AXIS,ARG3))

*  Get N = length of time series.

      nt  =  1 + arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1)

      IF (filter_span .GT. nt) THEN
         WRITE (err_msg, 10)
   10    FORMAT('LSL_FILTER: The filter span must be less than or ', 
     .             'equal to the number of points')
         GOTO 999
      ENDIF
 
      i1 = arg_lo_ss(X_AXIS,ARG1)
      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

* Compute the filtered time series.

               n = 1
               DO 100 l1=arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)
                  x(n,1,1,1) = arg_1(i1,j1,k1,l1)
                  n = n + 1
 100           CONTINUE

               CALL LSL_low_pass_filter (x, nt, cutoff_period, 
     .            bad_flag(ARG1), filter_span, h, y)

*  Put the filtred series in result

               n = 1
               DO 110 l= res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
                  IF (y(n,1,1,1) .NE. bad_flag(ARG1)) THEN
                     result(i,j,k,l) = y(n,1,1,1)
                  ELSE
                     result(i,j,k,l) = bad_flag_result
                  ENDIF
                  n = n + 1
 110           CONTINUE


               k1 = k1 + arg_incr(Z_AXIS,ARG1)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 300     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
 400  CONTINUE
      
      RETURN

 999  CALL ef_bail_out (id, err_msg)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

      subroutine LSL_low_pass_filter( 
     1  x, N, cutoff_period, missing_value, filter_span, h, y )
c
c Least Squares Lanczos (LSL) low-pass filter:  This subroutine 
c low-pass filters an equally spaced time series using least-squares 
c approximation to the ideal low-pass filter of Bloomfield with Lanczos 
c convergence factors.  It is very similar to subroutine LOPASS in 
c Chapter 6, p. 149, of
c 
c Bloomfield, P., 1976, Fourier Analysis of Time Series: An 
c    Introduction, John Wiley & Sons, New York, 258 pp.
c
c The main difference is that the present routine takes account of
c missing values in the input time series.
c
c Inputs:
c
c x(N) = a real array of equally spaced points to low-pass filter
c N    = the number of points in x
c cutoff_period = the cutoff period (the period at which the filter
c                 attains 1/2 amplitude or 1/4 "energy") measured in
c                 units of delta t.  The cutoff_period must be less than
c                 or equal to N.
c filter_span = the number of input data points used in each filtered
c               output point.  A wide filter gives a narrow frequency
c               response transition band, but leads to ringing near
c               data discontinuities and loss of filtered values at the
c               end points and surrounding missing values.  A narrow
c               filter reduces ringing and output data loss, but gives
c               a wider frequency transition width, i.e. it falls off
c               less rapidly at freqs. higher than the cutoff.
c               The filter transition region lies in the period range
c               between N*cutoff_period/(N + cutoff_period) and 
c               N*cutoff_period/(N - cutoff_period). 
c missing_value = the missing value flag that signals to exclude flagged
c                 values from the computation.
c Outputs:
c
c filter_span = the filter span should be an odd integer.  It is set to 
c               the next lower odd number if the input is even.
c y(N)        = the output array of filtered values.  Values near the
c               ends and near gaps are filled with the missing value
c               flag.
c
c Note on tidal filtering:  For hourly time series containing tidal
c signals, some investigators use this filter with a 35-hour cutoff period
c and a filter span of xxx hours to remove at least 99.5 % of the energy for
c periods less than 25 hours.
c
c Adapted from Bloomfield by E. D. Cokelet, NOAA/PMEL, 3 Dec 1999    
c
c        1         2         3         4         5         6         7
c23456789012345678901234567890123456789012345678901234567890123456789012
c

c acm  explicitly define and type all variables
      integer n, i, j, ib, ie
      real*4 cutoff_period, missing_value
      real*8 pi, omega_c, h0, con, summ, temp, x1, x2, d1, d2

      integer filter_span, half_span
      real*4 x(*), h(*), y(*)

c      d(z) = sin(z)/z      ! define statement function  (doesnt work on osf)

      pi = 4.*atan(1.d0)

c Make sure filter span is odd
c
      half_span = int( (filter_span - 1) / 2 )
      filter_span = 2*half_span + 1
c
c
c Calculate the filter weights and normalize them
c
      omega_c = 2 * pi / cutoff_period
c
      h0 = omega_c / pi
      con = 2.*pi/float(filter_span)
      summ = h0
      do 10 i = 1, half_span
         d1 = sin(float(i)*omega_c)/ (float(i)*omega_c)
         d2 = sin(float(i)*con)/ (float(i)*con)
c         h(i) = h0 * d( float(i)*omega_c ) * d( float(i)*con )
         h(i) = h0 * d1 * d2
         summ = summ + 2. * h(i)
 10   continue
c
      h0 = h0/summ
      do 20 i = 1, half_span
         h(i) = h(i) / summ
 20   continue
c
c
c Put missing_value in the first and last half_span elements to
c account for end effects
c
      do 30 i =1, half_span
         y(i) = missing_value
         j = N - i + 1
         y(j) = missing_value
 30   continue
c
c
c Filter by convolving.  
c To account for gaps in the time series, set to missing any filtered
c values that would require missing values to compute them.
c
      ib = half_span + 1
      ie = N - half_span
c
      do 50 i = ib, ie
         if (x(i) .eq. missing_value) then
            temp = missing_value
            go to 45
         end if
         temp = h0 * x(i)
         do 40 j = 1, half_span
   	    x1 = x(i - j)
   	    x2 = x(i + j)
   	    if ( ( x1 .eq. missing_value ) .or. 
     1          ( x2 .eq. missing_value ) ) then
   		temp = missing_value
   		go to 45
   	    end if
	    temp = temp + h(j) * ( x1 + x2 )
 40      continue
 45      continue
         y(i) = temp

 50   continue
c
      return
      end

c      real*8 function d(z)
c
cc      d(z) = sin(z)/z      ! define statement function  (doesnt work on osf)
c
c      real z
c      d = sin(z)/ z
c
c      return
c      end

      CHARACTER*(*) FUNCTION GKS_X_CONID( wsid )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine the correct name for the CONID to open the next GKS output window
* the value of wsid is assumed to be 1 for the first window, 2,3,... for
* subsequent windows
* the name stored in xwind_node is assumed to end with ":0" or "::0"

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V200: 12/20/89
* RISC/Ultrix port *sh* 5/91:  allow tcp/ip addresses, too 
* V230:  5/14/92 - REMOTE_X mode was replaced by the REFRESH mode
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xprog_state.cmn'
	
* calling argument declarations:
	INTEGER		wsid

* internal variable declarations:
	CHARACTER	letter*1

* generate letter "A", "B", ...
	letter = CHAR(64+wsid)

* format of conid is DECnet_node::0.letter
*                 or tcp.ip.node:0.letter
* the stored name (xwind_node) lacks only the "dot-letter" ending
* eliminated mode_Xwindows 5/92 
!	IF ( mode_Xwindows ) THEN
!           GKS_X_CONID = xwind_node(:xwind_node_len)//'.'//letter
!	ELSE
* ... local DECnet connect name
	  GKS_X_CONID = '0::0.'//letter
!	ENDIF

	RETURN
	END

	SUBROUTINE TM_ERRMSG ( 	status_in, status_out, routine,
     .				 dset_num, sf_num, 
     .				 expected, found, * )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* display explanatory message of error and calling routine, transfers error
* code to output variable, and always take alternate return to serve as error
* branch in calling program
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.00 - 11/19/85
* revision 1.00 - 04/01/87 - changes to calling statement to allow more
*			     complete but concise messages. (MAV)
* revision 1.10 - 06/01/87 - added "calling routine" parameter to call
* revision 1.11 - 09/24/88 - printing of dset, sf based on flags only. Flags
*			     now set to unspecified_int4 to facilitate this
* Unix/RISC port - 3/12/91 - Unix system error messages via UNIX CALL GERROR
*                          - TMAP_diag_on variable controls subroutine name out
*                          - changed error message format to "**TMAP ERR"
* added netCDF errors - 2/92 *sh*
* all output to be directed through TM_SPLIT_MESSAGE for optional GUI
* Linux Port - *kob* 5/97 - added call for linux_perror, which is a c 
*			    routine, because the appropriate routine 
*			    didn't exist in nag F90
*			  - f90 doesnt accept "D" in col 1 as a debug thing
*			    so ifdef around it
* V500 - *kob* 7/99 - update error codes to handle netCDF V3.4 differences
*
* *acm* 11/05 V600  -- New symbol FER_LAST_ERROR contains all the text normally
*                       written to std out. 
* V600 *acm* 7/06 Using NetCDF-3 calls in cd_open_dset, if an error is found,
*                 the correct error message is passed in here. Process these under
*                 merr_nc_open, separately from other netcdf errors. Report the
*                 netCDF / OPeNDAP error code.
* V604 *acm* 6/07 Allow longer strings for OPeNDAP file-open errors. Call these
*                 **Internet Data error 
* V63  *acm* 10/09 Changes for gfortran build
* V68  *acm*  4/11 Error codes for NetCDF-4 (HDF) errors are in the range -101 to -116


* arguments:
*	status_in	- error code from calling program
*	status_out	- error code (echoed) back to calling program
*	routine		- calling routine or program
*	dset_num	- data set number
*	sf_num		- step_file number
*	expected	- expected value, except in case where a limit is
*			  exceeded, in which case this is the limit. Or if
*			  special error, this might have another value.
*	found		- the value found when "expected" value was expected

	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "gt_lib.parm"
	include 'xio.cmn_text'
	external xio_data
	include 'xerror_text.cmn_text'
	external xerror_text_data
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xstep_files.cmn_text'
	external xstep_files_data
	include 'xdiag_ctrl.cmn_text'
	external xdiag_ctrl_data
!	include 'xalt_messages.cmn_text'	! w/ alt_messages
	external xalt_messages_data

* argument definitions
	CHARACTER*(*)	routine, expected, found
	INTEGER		status_in, status_out, dset_num, sf_num

* local definitions
	CHARACTER*2048	TM_CMPRSS, expbuff, fndbuff
	CHARACTER*2048	errbuf	! introduced for GUI-SPLIT messages
        CHARACTER*2048  symbuf  ! for symbol FER_LAST_ERROR
	INTEGER		sf_len, des_len, TM_LENSTR1, msg_len, exp_len,
     .			fnd_len, rtn_len, len_symbuf, ier, ist, cdferr

* initialize
	status_out = status_in	! transfer error code to output
	errbuf = ' '
        expbuff = ' '
        fndbuff = ' '

* initialize string for symbol FER_LAST_ERROR

         symbuf = ' '
         len_symbuf = 1

* print calling routine line to identify where error occured
* (diagnostic, only - *sh* 3/15/91)
* add ifdef check for f90 - no D on col 1 *kob*
c#if defined unix  && ! defined FORTRAN_90   
cD        TMAP_diag_on = .TRUE.     ! compile if "-d_lines"-----Emacs: 
c#endif
        IF ( TMAP_diag_on ) THEN
	   rtn_len = TM_LENSTR1(routine)
	   write (lunit_errors, *) ' ***** ERROR IN ',routine(:rtn_len),
     .				   ' *****'
        ENDIF

* Handle special messages first:

* error message from ERR= branch ?
* fetch the system error codes for most recent error

	IF ( status_in .EQ. merr_erreq ) THEN
#ifdef unix
#ifdef F90_SYSTEM_ERROR_CALLS
	  call linux_perror(expbuff)
#else
          CALL GERROR(expbuff)       ! get system error message
#endif
	  msg_len = TM_LENSTR1(expbuff)
	  WRITE (errbuf,1000) expbuff(:msg_len)
	  CALL TM_SPLIT_MESSAGE(lunit_errors, errbuf)
          msg_len = TM_LENSTR1(errbuf)
          symbuf(len_symbuf:) = errbuf(:msg_len)
          len_symbuf = len_symbuf + msg_len + 1
#else
* VMS code by Mark Renton
	  CALL ERRSNS ( fnum, rmssts, rmsstv, iunit, condval )
	  IF ( ( rmssts .EQ. 0 ) .AND. ( rmsstv .EQ. 0 ) ) THEN
	    msgvec ( 1 ) = 1
	    msgvec ( 2 ) = condval
	    msgvec ( 3 ) = 0
	  ELSE
	    msgvec ( 1 ) = 1
	    msgvec ( 2 ) = rmssts
	    IF ( rmsstv .ne. 0 ) THEN
	      msgvec ( 1 ) = 2
	      msgvec ( 3 ) = rmsstv
	    ENDIF
	  ENDIF
* output the message but, SYS_PUTMSG needs a <cr> sent afterword
	  CALL SYS_PUTMSG ( msgvec, , , )
	  WRITE (errbuf,1000) expbuff(:msg_len)
	  CALL TM_SPLIT_MESSAGE(lunit_errors, errbuf)
          msg_len = TM_LENSTR1(errbuf)
          symbuf(len_symbuf:) = errbuf(:msg_len)
          len_symbuf = len_symbuf + msg_len + 1

#endif

* Output the message for a regular error; errors from cd_open_dset
* are treated here.
	ELSE IF ( (status_in .GT. pregular) .AND.
     .		  (status_in .LE. pregular + num_regular + 1) ) THEN

          IF (status_in .EQ. merr_nc_open) THEN
	     msg_len = TM_LENSTR1(expected)
	     WRITE (errbuf,1001) 
	     CALL TM_SPLIT_MESSAGE(lunit_errors, errbuf)
             msg_len = TM_LENSTR1(errbuf)
             symbuf(len_symbuf:) = errbuf(:msg_len)
             len_symbuf = len_symbuf + msg_len + 1
1001	     FORMAT(' **netCDF error')

          ELSE IF (status_in .EQ. merr_remote_open) THEN
	     msg_len = TM_LENSTR1(expected)
	     WRITE (errbuf,1002) 
	     CALL TM_SPLIT_MESSAGE(lunit_errors, errbuf)
             msg_len = TM_LENSTR1(errbuf)
             symbuf(len_symbuf:) = errbuf(:msg_len)
             len_symbuf = len_symbuf + msg_len + 1
1002	     FORMAT(' **Internet Data error')

          ELSE

             msg_len = TM_LENSTR1(msg_regular(status_in - pregular))
             WRITE (errbuf,1000)
     .		 msg_regular(status_in - pregular)(:msg_len)
             CALL TM_SPLIT_MESSAGE(lunit_errors, errbuf)
             msg_len = TM_LENSTR1(errbuf)
             symbuf(len_symbuf:) = errbuf(:msg_len)
             len_symbuf = len_symbuf + msg_len + 1

1000	     FORMAT(' **TMAP ERR: ',A)
          ENDIF


* output a netCDF error (note: CDF uses error code -1)
* *kob* 7/99 - Update for netCDF v3.4
* acm 1/10 - CD_TRANSLATE_ERROR calls error translation routine.

	ELSEIF ( (status_in .GE. pcdferr-120) .AND.
     .		 (status_in .LE. pcdferr + pcdferrmax) ) THEN
* xxxxx can we get filename from netCDF call ???           
* xxxxx cdfid and varid are available as dset_num, sf_num
           cdferr = status_in - pcdferr
           CALL CD_TRANSLATE_ERROR (cdferr, errbuf)
	   CALL TM_SPLIT_MESSAGE(lunit_errors, errbuf)

           msg_len = TM_LENSTR1(errbuf)
           symbuf(len_symbuf:) = errbuf(:msg_len)
           len_symbuf = len_symbuf + msg_len + 1

           IF (expected .NE. no_errstring) THEN
	     errbuf = ' '
	     WRITE (errbuf,*) expected
	     CALL TM_SPLIT_MESSAGE(lunit_errors, errbuf)
             msg_len = TM_LENSTR1(errbuf)
             symbuf(len_symbuf:) = errbuf(:msg_len)
             len_symbuf = len_symbuf + msg_len + 1
	   ENDIF
           IF (found .NE. no_errstring) THEN
	     errbuf = ' '
	     WRITE (errbuf,*) found
	     CALL TM_SPLIT_MESSAGE(lunit_errors, errbuf)   
             msg_len = TM_LENSTR1(errbuf)
             symbuf(len_symbuf:) = errbuf(:msg_len)
             len_symbuf = len_symbuf + msg_len + 1
	   ENDIF

           GOTO 4000   ! bypass normal error processing
* unrecognized error code ?
	ELSE
	  WRITE (errbuf,1100) status_in
	  CALL TM_SPLIT_MESSAGE(lunit_errors, errbuf)
1100	  FORMAT(' *** Unknown error code:',I10,' *** ')
          msg_len = TM_LENSTR1(errbuf)
          symbuf(len_symbuf:) = errbuf(:msg_len)
          len_symbuf = len_symbuf + msg_len + 1

	END IF

* Output any info in expected and found strings (if any present)
	errbuf = ' '
	IF (expected .NE. no_errstring) THEN
cc	  expbuff = TM_CMPRSS(expected)
	  exp_len = TM_LENSTR1(expected)
          expbuff = expected(1:exp_len)

	  exp_len = TM_LENSTR1(expbuff)
	  IF (found .NE. no_errstring) THEN
cc	    fndbuff = TM_CMPRSS(found)
	    fnd_len = TM_LENSTR1(found)
	    fndbuff = found(1:fnd_len)
	    WRITE (errbuf,1200) expbuff(1:exp_len),
     .				      fndbuff(1:fnd_len)
	    CALL TM_SPLIT_MESSAGE(lunit_errors, errbuf)
1200	    FORMAT(13X,'Expected: ',A,' Found: ',A)
            msg_len = TM_LENSTR1(errbuf)
            symbuf(len_symbuf:) = errbuf(:msg_len)
            len_symbuf = len_symbuf + msg_len + 1
	  ELSE
	    WRITE (errbuf,1300) expbuff(1:exp_len)
	    CALL TM_SPLIT_MESSAGE(lunit_errors, errbuf)
 1300       FORMAT(13X,A)
            symbuf(len_symbuf:) = expbuff(:exp_len)
            len_symbuf = len_symbuf + exp_len + 1
	  ENDIF
	ENDIF

* output step file and descriptor file if asked for
	IF ( dset_num .GT. 0 ) THEN
	  errbuf = ' '
	  des_len = TM_LENSTR1(ds_des_name(dset_num))
	  WRITE (errbuf,1300)
     .		 'Data set: '//ds_des_name(dset_num)(:des_len)
	  CALL TM_SPLIT_MESSAGE(lunit_errors, errbuf)             
          msg_len = TM_LENSTR1(errbuf)
          symbuf(len_symbuf:) = errbuf(:msg_len)
          len_symbuf = len_symbuf + msg_len + 1
	ENDIF

	IF ( sf_num .GT. 0 ) THEN
	  errbuf = ' '
	  sf_len = TM_LENSTR1(sf_name(sf_num))
	  WRITE (errbuf,1300)
     .           'Data file: '//sf_name(sf_num)(:sf_len)
	  CALL TM_SPLIT_MESSAGE(lunit_errors, errbuf)
          msg_len = TM_LENSTR1(errbuf)
          symbuf(len_symbuf:) = errbuf(:msg_len)
          len_symbuf = len_symbuf + msg_len + 1
	ENDIF

* print blank line to set off error messages
! 4000   IF ( .NOT.alt_messages) WRITE (lunit_errors, *)
 4000	CONTINUE

* Generate symbol containing the whole error message

         ier = 0
         ist = 0
         CALL SETSYM ('FER_LAST_ERROR '//symbuf, 14+len_symbuf, 
     .                 ier, ist)

* take alternate RETURN always
	RETURN 1

	END

	SUBROUTINE DEALLO_UNFORMED_GRID( status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* deallocate a scratch space from the grid COMMON stack
* The axes of this grid were never allocated, so it is an "unformed" grid

* V520 *sh* 6/00 - new based on DEALLO_GRID
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xfr_grid.cmn'

* calling argument declarations
	INTEGER	status

* internal declarations:
	INTEGER	idim

* clean out the grid deallocating any dynamic lines that this used
	DO 100 idim = 1, nferdims
	   grid_line(idim,grd_stk_ptr) = unspecified_int4
 100	CONTINUE
	grid_name(grd_stk_ptr) = char_init16

* remove the stack slot
	grd_stk_ptr = grd_stk_ptr + 1

	IF ( grd_stk_ptr .GT. max_grids ) CALL ERRMSG
     .		( ferr_stack_ovfl, status, 'deallo_unformed_grid',
     .						*5000 )

	status = ferr_ok

 5000	RETURN
	END

*
* samplexz.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without anx fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and anx derivative works thereof, and
*  its supporting documentation for anx purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in anx publications that result from
*  the use of this software or in anx product that INCLUDE 's this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in anx advertising or publicity to endorse or promote anx products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with anx support, consulting,
*  training or assistance of anx kind with regard to the use, operation
*  and performance of this software nor to provide the user with anx
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND Anx EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR Anx SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR Anx DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke  from samplexy  5/15/01
* 11-Jan-06 *acm* declare xlo, xhi, zlo, zhi  as integer not real
*
* This function samples 4-d data on the x and z axes indicated by args 2 and 3
*         Result is abstract on the x axis, normal on the y axis,
*         and keeps the z and t axes of the input 4-d data.
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE samplexz_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CHARACTER*100 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns data sampled at a set of (X,Z) points, ',
     .        'using linear interpolation')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                ABSTRACT,        IMPLIED_BY_ARGS,
     .                                NORMAL,          IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 2)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'DAT_TO_SAMPLE')
      CALL ef_set_arg_desc(id, arg, 'variable (x,y,z,t,e,f) to sample')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, YES, NO, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'XPTS')
      CALL ef_set_arg_desc(id, arg, 'X values of sample points')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'ZPTS')
      CALL ef_set_arg_desc(id, arg, 'Z values of sample points')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* loss               lo subscript for an axis
*
* hiss               hi subscript for an axis
*

      SUBROUTINE samplexz_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER nx, ny, nz, nt, ne, nf
      INTEGER my_lo, my_hi

*     Use utility functions to get context information about the 
*     second argument, to set the abstract axis lo and hi indices.

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nx = arg_hi_ss(X_AXIS, ARG2) - arg_lo_ss(X_AXIS, ARG2) + 1
      ny = arg_hi_ss(Y_AXIS, ARG2) - arg_lo_ss(Y_AXIS, ARG2) + 1
      nz = arg_hi_ss(Z_AXIS, ARG2) - arg_lo_ss(Z_AXIS, ARG2) + 1
      nt = arg_hi_ss(T_AXIS, ARG2) - arg_lo_ss(T_AXIS, ARG2) + 1
      ne = arg_hi_ss(E_AXIS, ARG2) - arg_lo_ss(E_AXIS, ARG2) + 1
      nf = arg_hi_ss(F_AXIS, ARG2) - arg_lo_ss(F_AXIS, ARG2) + 1

      my_lo = 1
      my_hi = MAX(nx,ny,nz,nt,ne,nf)

      CALL ef_set_axis_limits(id, X_AXIS, my_lo, my_hi)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END
*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE samplexz_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER mxh, mzh, mxl, mzl

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

*  Allocate double the length of the axes for REAL*8 work arrays.

      mxl = arg_lo_ss(X_AXIS,ARG1)
      mzl = arg_lo_ss(Z_AXIS,ARG1)

      mxh = mxl + 
     .     2* (arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 1)
      mzh = mzl + 
     .     2* (arg_hi_ss(Z_AXIS,ARG1) - arg_lo_ss(Z_AXIS,ARG1) + 1)

*  xaxdat
      CALL ef_set_work_array_dims_6d(id, 1,
     .                              mxl, 1, 1, 1, 1, 1,
     .                              mxh, 1, 1, 1, 1, 1)

*  zaxdat
      CALL ef_set_work_array_dims_6d(id, 2,
     .                              mzl, 1, 1, 1, 1, 1,
     .                              mzh, 1, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE samplexz_compute(id, arg_1, arg_2, arg_3, result,
     .                            xaxdat, zaxdat)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* Ignore the Y/Z/T/E/F dimensions in the work arrays since
* they are not used and Fortran is column major
      REAL*8 xaxdat(wrk1lox:wrk1lox+(wrk1hix-wrk1lox)/2)
      REAL*8 zaxdat(wrk2lox:wrk2lox+(wrk2hix-wrk2lox)/2)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      LOGICAL TM_FPEQ

      INTEGER nx, nxx, nxy, nxz, nxt, nxe, nxf
      INTEGER nz, nzx, nzy, nzz, nzt, nze, nzf
      INTEGER ndimx, ndimz
      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2
      INTEGER i3, j3, k3, l3, m3, n3
      INTEGER imatch, kmatch
      INTEGER ibot, itop, kbot, ktop
      INTEGER xlo, xhi, zlo, zhi
      REAL fxbot, fxtop, fbb, ftb, fbt, ftt
      REAL xbot, xtop, zbot, ztop
      REAL xfrac, zfrac
      REAL delmodx, delmodz, xpt, zpt
      CHARACTER*255 err_msg

C  variables for checking axis characteristics (modulo axes)
      CHARACTER ax_name(6)*16, ax_units(6)*16
      LOGICAL backward(6), modulo(6), regular(6)

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

C Validate argument dimensions
      nxx = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1
      nxy = arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) + 1
      nxz = arg_hi_ss(Z_AXIS,ARG2) - arg_lo_ss(Z_AXIS,ARG2) + 1
      nxt = arg_hi_ss(T_AXIS,ARG2) - arg_lo_ss(T_AXIS,ARG2) + 1
      nxe = arg_hi_ss(E_AXIS,ARG2) - arg_lo_ss(E_AXIS,ARG2) + 1
      nxf = arg_hi_ss(F_AXIS,ARG2) - arg_lo_ss(F_AXIS,ARG2) + 1
      nx = MAX(nxx, nxy, nxz, nxt, nxe, nxf)

      nzx = arg_hi_ss(X_AXIS,ARG3) - arg_lo_ss(X_AXIS,ARG3) + 1
      nzy = arg_hi_ss(Y_AXIS,ARG3) - arg_lo_ss(Y_AXIS,ARG3) + 1
      nzz = arg_hi_ss(Z_AXIS,ARG3) - arg_lo_ss(Z_AXIS,ARG3) + 1
      nzt = arg_hi_ss(T_AXIS,ARG3) - arg_lo_ss(T_AXIS,ARG3) + 1
      nze = arg_hi_ss(E_AXIS,ARG3) - arg_lo_ss(E_AXIS,ARG3) + 1
      nzf = arg_hi_ss(F_AXIS,ARG3) - arg_lo_ss(F_AXIS,ARG3) + 1
      nz = MAX(nzx, nzy, nzz, nzt, nze, nzf)

      ndimx = 0
      ndimz = 0
      DO 10 i = X_AXIS,F_AXIS
         IF ( arg_hi_ss(i,ARG2) .GT. arg_lo_ss(i,ARG2) ) 
     .      ndimx = ndimx + 1
         IF ( arg_hi_ss(i,ARG3) .GT. arg_lo_ss(i,ARG3) ) 
     .      ndimz= ndimz + 1
   10 CONTINUE

      IF ( (nx .NE. nz) .OR. (ndimx .GT. 1) .OR. (ndimz .GT.1) ) THEN
         err_msg = 
     .  'Arguments 2 and 3 must be 1-dimensional lists of equal length'
         GO TO 999
      ENDIF

*  Get x and z coordinates of the data to be sampled.

      CALL ef_get_coordinates(id, ARG1, X_AXIS,
     .   arg_lo_ss(X_AXIS, ARG1), arg_hi_ss(X_AXIS, ARG1), xaxdat)
      CALL ef_get_coordinates(id, ARG1, Z_AXIS,
     .   arg_lo_ss(Z_AXIS, ARG1), arg_hi_ss(Z_AXIS, ARG1), zaxdat)

*  Check to see if input x or z axis is modulo

      CALL ef_get_axis_info_6d(id, ARG1, ax_name, ax_units,
     .                         backward, modulo, regular)

      xlo = arg_lo_ss(X_AXIS,ARG1)
      xhi = arg_hi_ss(X_AXIS,ARG1)
      zlo = arg_lo_ss(Z_AXIS,ARG1)
      zhi = arg_hi_ss(Z_AXIS,ARG1)

* Is this enough? (see samplexy and samplexyt)
      IF ( modulo(X_AXIS) ) THEN
         delmodx = xaxdat(xhi) - xaxdat(xlo)
      ENDIF
      IF ( modulo(Z_AXIS) ) THEN
         delmodz = zaxdat(zhi) - zaxdat(zlo)
      ENDIF

*  For each (xpt,zpt) pair, search the data array 
*   arg_1 for the nearest higher (x,z) grid coordinates.  Interpolate 
*   in 2 directions for the result.

      i2 = arg_lo_ss(X_AXIS,ARG2)
      j2 = arg_lo_ss(Y_AXIS,ARG2)
      k2 = arg_lo_ss(Z_AXIS,ARG2)
      l2 = arg_lo_ss(T_AXIS,ARG2)
      m2 = arg_lo_ss(E_AXIS,ARG2)
      n2 = arg_lo_ss(F_AXIS,ARG2)

      i3 = arg_lo_ss(X_AXIS,ARG3)
      j3 = arg_lo_ss(Y_AXIS,ARG3)
      k3 = arg_lo_ss(Z_AXIS,ARG3)
      l3 = arg_lo_ss(T_AXIS,ARG3)
      m3 = arg_lo_ss(E_AXIS,ARG3)
      n3 = arg_lo_ss(F_AXIS,ARG3)

* Z-axis is normal to the results
      k = res_lo_ss(Z_AXIS)

      DO 700 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         xpt = arg_2(i2,j2,k2,l2,m2,n2)
         zpt = arg_3(i3,j3,k3,l3,m3,n3)

         IF ( xpt .EQ. bad_flag(ARG2) .OR.
     .        zpt .EQ. bad_flag(ARG3) ) THEN
            DO 30 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
            DO 30 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
            DO 30 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
            DO 30 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
               result(i,j,k,l,m,n) = bad_flag_result
   30       CONTINUE
*           Go to the next pair of coordinates
            GOTO 690
         ENDIF

* Try to get xpt in range if the X-axis is modulo
         IF ( modulo(X_AXIS) ) THEN
            DO WHILE ( xpt .GE. xaxdat(xhi) ) 
               xpt = xpt - delmodx
            ENDDO
            DO WHILE ( xpt .LT. xaxdat(xlo) )
               xpt = xpt + delmodx
            ENDDO
         ENDIF

* Check if xpt is in the X-axis range.
         ibot = ef_unspecified_int4
         imatch = ef_unspecified_int4

         DO 110 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)
            IF ( TM_FPEQ(xpt, xaxdat(i1)) ) THEN
               imatch = i1
               GOTO 120
            ELSE IF ( xpt .GT. xaxdat(i1) ) THEN
               ibot = i1
            ENDIF
  110    CONTINUE

* Check that xpt is not beyond the upper end of the X-axis range.
         IF ( xpt .GT. xaxdat(xhi) ) THEN
            ibot = ef_unspecified_int4
         ENDIF

  120    IF ( imatch .NE. ef_unspecified_int4 ) THEN
            ibot = imatch
            itop = imatch
         ELSE IF ( ibot .NE. ef_unspecified_int4 ) THEN
            itop = ibot + 1
         ELSE
*           xpt outside the grid
            DO 130 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
            DO 130 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
            DO 130 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
            DO 130 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
               result(i,j,k,l,m,n) = bad_flag_result
  130       CONTINUE
*           Go to the next pair of coordinates
            GOTO 690
         ENDIF

         xbot = xaxdat(ibot)
         xtop = xaxdat(itop)
         IF ( xtop .EQ. xbot ) THEN 
            xfrac = 0.
         ELSE
            xfrac = (xpt - xbot) / (xtop - xbot)
         ENDIF

* Try to get zpt in range if the Z-axis is modulo
         IF ( modulo(Z_AXIS) ) THEN
            DO WHILE ( zpt .GE. zaxdat(zhi) ) 
               zpt = zpt - delmodz
            ENDDO
            DO WHILE ( zpt .LT. zaxdat(zlo) )
               zpt = zpt + delmodz
            ENDDO
         ENDIF

* Check if zpt is in the Z-axis range.
         kbot = ef_unspecified_int4
         kmatch = ef_unspecified_int4

         DO 310 k1 = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)
            IF ( TM_FPEQ(zpt, zaxdat(k1)) ) THEN
               kmatch = k1
               GOTO 320
            ELSE IF ( zpt .GT. zaxdat(k1) ) THEN
               kbot = k1
            ENDIF
  310    CONTINUE

* Check that zpt is not beyond the upper end of the Z-axis range.
         IF ( zpt .GT. zaxdat(zhi) ) THEN
            kbot = ef_unspecified_int4
         ENDIF

  320    IF ( kmatch .NE. ef_unspecified_int4 ) THEN
            kbot = kmatch
            ktop = kmatch
         ELSE IF ( kbot .NE. ef_unspecified_int4 ) THEN
            ktop = kbot + 1
         ELSE
*           zpt outside the grid
            DO 330 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
            DO 330 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
            DO 330 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
            DO 330 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
               result(i,j,k,l,m,n) = bad_flag_result
  330       CONTINUE
*           Go to the next pair of coordinates
            GOTO 690
         ENDIF

         zbot = zaxdat(kbot)
         ztop = zaxdat(ktop)
         IF ( ztop .EQ. zbot ) THEN 
            zfrac = 0.
         ELSE
            zfrac = (zpt - zbot) / (ztop - zbot)
         ENDIF

         n1 = arg_lo_ss(F_AXIS,ARG1)
         DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

         m1 = arg_lo_ss(E_AXIS,ARG1)
         DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

         l1 = arg_lo_ss(T_AXIS,ARG1)
         DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

            j1 = arg_lo_ss(Y_AXIS,ARG1)
            DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

*  First interpolate in x, getting values of the fcn at (x,kbot) and (x,ktop)
               fbb = arg_1(ibot,j1,kbot,l1,m1,n1)
               ftb = arg_1(itop,j1,kbot,l1,m1,n1)
               fbt = arg_1(ibot,j1,ktop,l1,m1,n1)
               ftt = arg_1(itop,j1,ktop,l1,m1,n1)

               IF ( fbb .NE. bad_flag(ARG1)  .AND.
     .              ftb .NE. bad_flag(ARG1)  .AND.
     .              fbt .NE. bad_flag(ARG1)  .AND.
     .              ftt .NE. bad_flag(ARG1) ) THEN

                  fxbot = fbb + xfrac * (ftb - fbb)
                  fxtop = fbt + xfrac * (ftt - fbt)

*  Now interpolate in z, getting value at (x,z)
                  result(i,j,k,l,m,n) = fxbot + zfrac * (fxtop - fxbot)

               ELSE

*                 Some component was undefined
                  result(i,j,k,l,m,n) = bad_flag_result

               ENDIF

               j1 = j1 + arg_incr(Y_AXIS,ARG1)
 200        CONTINUE

            l1 = l1 + arg_incr(T_AXIS,ARG1)
 400     CONTINUE

            m1 = m1 + arg_incr(E_AXIS,ARG1)
 500     CONTINUE

            n1 = n1 + arg_incr(F_AXIS,ARG1)
 600     CONTINUE

* Only one of the ARG2 and one of ARG3 actually increments
 690     i2 = i2 + arg_incr(X_AXIS,ARG2)
         j2 = j2 + arg_incr(Y_AXIS,ARG2)
         k2 = k2 + arg_incr(Z_AXIS,ARG2)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
         m2 = m2 + arg_incr(E_AXIS,ARG2)
         n2 = n2 + arg_incr(F_AXIS,ARG2)

         i3 = i3 + arg_incr(X_AXIS,ARG3)
         j3 = j3 + arg_incr(Y_AXIS,ARG3)
         k3 = k3 + arg_incr(Z_AXIS,ARG3)
         l3 = l3 + arg_incr(T_AXIS,ARG3)
         m3 = m3 + arg_incr(E_AXIS,ARG3)
         n3 = n3 + arg_incr(F_AXIS,ARG3)

 700  CONTINUE

      RETURN

 999  CALL ef_bail_out (id, err_msg)

      END

	BLOCK DATA XGRID_CHG_FCNS_DATA

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* function names and descriptive information for internally-defined grid-
* changing functions

* V450 - 7/79 - minor change to text on ZAXREPLACE
* V491 - 1/98 - changed function TEST2 so that it replaces T axis
* V500: 1/99 added gfcn_arg_type in support of string arguments
*       2/99 changed UNRAVEL to XSEQUENCE, YSEQUENCE, ZSEQUENCE, TSEQUENCE
*       3/99 *kob* fixed bugs in above additions - parameter references
*	incorrect
*	3/99 *sh* added a numerical argument to ECHO to debug stack problem
* V510: added SAMPLE* functions as *internal* GC functions
* V533: *sh* 6/01 - allow some functions to take parg_type_multi
*            7/01 - added function SPAWN  
* V540: *sh* 10/01 - use improved data typing parameters parg_type_*
*       *acm*11/01 - clarify the function description for ZAXREPLACE
*	     12/01 - bug fix in arg type of SPAWN function
* V541: *kob* 6/02 - Add STRLEN, UPCASE,DNCASE,STRINDEX, STRRINDEX
*                        SUBSTRING, STRCAT, STRFLOAT 
*                    internal string handling functions   
* V550: *acm*10/02 - Correct the function description for SUBSTRING
*        2/12 *kms* Add E and F dimensions (set to nferdims in tmap_dims.parm)
* V720: 4/17 *acm* Add DOT (inner product) and TRANSPOSE as direction-changing functions
*                  which call specific funcions depenging on direction arguments
* v720: 5/17 *acm* Rename innerproduct functions to dot
*                  Also fix gfcn_axis_implied_from definition for arg 3 of DOT function

* the addition (or major modification) of an internal grid-changing function
* requires changes to these routines:
*	grid_chg_fcns.parm	- parameters to number the functions
*	XGRID_CHG_FCNS_DATA	- description of the function and args
*	DO_INTERNAL_GC_FCN	- code to execute the function
* (opt)	GCF_GET_IMPOSED_AXES	- return the "imposed" axes, if any
* (opt)	GCF_IMPOSE_RESULT_LIMS	- fill in limits of "imposed" axes, if any

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'grid_chg_fcns.parm'
	include 'xgrid_chg_fcns.cmn'

* internal variable declarations
	INTEGER		i


* XSEQUENCE(arg) - same values as input grid but unravelled into an X line
	INTEGER		p_xunravel_arg_start, p_xunravel_num_args 
	PARAMETER     ( p_xunravel_arg_start = 1,
     .			p_xunravel_num_args  = 1 )

	DATA gfcn_name         (p_xunravel) /'XSEQUENCE'/
	DATA gfcn_version      (p_xunravel) / 1.0 /
	DATA gfcn_descr        (p_xunravel) / 'unravel grid to a line in X' /
	DATA gfcn_rtn_type     (p_xunravel) /pfcn_rtn_arg1_type /
	DATA gfcn_num_reqd_args(p_xunravel) /p_xunravel_num_args/
	DATA (gfcn_dir_args(i,p_xunravel),i=1,nferdims) /nferdims*0/
	DATA gfcn_has_vari_args(p_xunravel) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_xunravel),i=1,nferdims)/
     .						pgc_axis_is_abstract,
     .						pgc_axis_is_normal,
     .						pgc_axis_is_normal,
     .						pgc_axis_is_normal,
     .						pgc_axis_is_normal,
     .						pgc_axis_is_normal /
	DATA (gfcn_piecemeal_ok(i,p_xunravel),i=1,nferdims)
     .      / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
	DATA gfcn_arg_ptr(p_xunravel) /p_xunravel_arg_start/

* ... description of arguments
	DATA gfcn_arg_name(p_xunravel_arg_start+0)/'VAR'/
	DATA gfcn_arg_type(p_xunravel_arg_start+0)/parg_type_float_or_string/
	DATA gfcn_arg_units(p_xunravel_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_xunravel_arg_start+0)/' '/
	DATA (gfcn_arg_extend_lo (i,p_xunravel_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_xunravel_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_xunravel_arg_start+0),i=1,nferdims)
     .    / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /


* TIMES2(arg) a.k.a. "ECHO" -- display string  --> debugging function
* 1/98 - changed TIMES2 to test custom axis replacement of T axis
	INTEGER		p_times2_arg_start, p_times2_num_args 
	PARAMETER     ( p_times2_arg_start = p_xunravel_arg_start +
     .					     p_xunravel_num_args,
     .			p_times2_num_args  = 2 )


	DATA gfcn_name         (p_times2) /'ECHO'/
	DATA gfcn_version      (p_times2) / 1.0 /
	DATA gfcn_descr        (p_times2)
     .			/ 'echo passed string (test routine)' /
	DATA gfcn_rtn_type     (p_times2) / pfcn_rtn_float /
	DATA gfcn_num_reqd_args(p_times2) /p_times2_num_args/
	DATA (gfcn_dir_args(i,p_times2),i=1,nferdims) /nferdims*0/
	DATA gfcn_has_vari_args(p_times2) /.FALSE./

	DATA (gfcn_axis_will_be(i,p_times2),i=1,nferdims)/
     .						pgc_axis_implied_by_args,
     .						pgc_axis_implied_by_args,
     .						pgc_axis_implied_by_args,
     .						pgc_axis_implied_by_args,
     .						pgc_axis_implied_by_args,
     .						pgc_axis_implied_by_args/
	DATA (gfcn_piecemeal_ok(i,p_times2),i=1,nferdims)
     .      / .TRUE., .TRUE., .TRUE., .TRUE., .TRUE., .TRUE. /
	DATA gfcn_arg_ptr(p_times2) /p_times2_arg_start/

* ... description of arguments
	DATA gfcn_arg_name(p_times2_arg_start+0)/'STR'/
	DATA gfcn_arg_type(p_times2_arg_start+0)/parg_type_string/
	DATA gfcn_arg_units(p_times2_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_times2_arg_start+0)/'input text'/
	DATA (gfcn_arg_extend_lo (i,p_times2_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_times2_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_times2_arg_start+0),i=1,nferdims)
     .    / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
* ... argument 2
	DATA gfcn_arg_name(p_times2_arg_start+1)/'NUM'/
	DATA gfcn_arg_type(p_times2_arg_start+1)/parg_type_float/
	DATA gfcn_arg_units(p_times2_arg_start+1)/'anything'/
	DATA gfcn_arg_descr(p_times2_arg_start+1)/'numerical variable'/
	DATA (gfcn_arg_extend_lo (i,p_times2_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_times2_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 2 ?
	DATA (gfcn_axis_implied_from(i, p_times2_arg_start+1),i=1,nferdims)
     .    / .TRUE., .TRUE., .TRUE., .TRUE., .TRUE., .TRUE. /


* RESHAPE(data,grid_and_start) - same values as input grid but reshaped
*   into the grid of the 2nd arg ... starting at start point (1,1,1,1,1,1)
	INTEGER		p_reshape_arg_start, p_reshape_num_args 
	PARAMETER     ( p_reshape_arg_start = p_times2_arg_start +
     .					      p_times2_num_args,
     .			p_reshape_num_args  = 2 )

	DATA gfcn_name         (p_reshape) /'RESHAPE'/
	DATA gfcn_version      (p_reshape) / 1.0 /
	DATA gfcn_descr        (p_reshape) / 'reshape A to grid of B' /
	DATA gfcn_rtn_type     (p_reshape) /pfcn_rtn_arg1_type /
	DATA gfcn_num_reqd_args(p_reshape) /p_reshape_num_args/
	DATA (gfcn_dir_args(i,p_reshape),i=1,nferdims) /nferdims*0/
	DATA gfcn_has_vari_args(p_reshape) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_reshape),i=1,nferdims)/
     .						pgc_axis_supplied_herein,
     .						pgc_axis_supplied_herein,
     .						pgc_axis_supplied_herein,
     .						pgc_axis_supplied_herein,
     .						pgc_axis_supplied_herein,
     .						pgc_axis_supplied_herein /
	DATA (gfcn_piecemeal_ok(i,p_reshape),i=1,nferdims)
     .      / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
	DATA gfcn_arg_ptr(p_reshape) /p_reshape_arg_start/

* ... description of arguments
	DATA gfcn_arg_name(p_reshape_arg_start+0)/'A'/
	DATA gfcn_arg_type(p_reshape_arg_start+0)/parg_type_float_or_string/
	DATA gfcn_arg_units(p_reshape_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_reshape_arg_start+0)/'data to be reshaped'/
	DATA gfcn_arg_name(p_reshape_arg_start+1)/'B'/
	DATA gfcn_arg_type(p_reshape_arg_start+1)/parg_type_float/
	DATA gfcn_arg_units(p_reshape_arg_start+1)/' '/
	DATA gfcn_arg_descr(p_reshape_arg_start+1)/'destination grid'/
	DATA (gfcn_arg_extend_lo (i,p_reshape_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_reshape_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
*  Note: set to TRUE despite the fact that all of the
*     resultant axes are "pgc_axis_supplied_herein". This is to cover the
*     special case in which an axis of the result (imposed) **happens to**
*     match the axis of the argument. In this case TRUE means that context
*     limits do get passed upstream.
	DATA (gfcn_axis_implied_from(i, p_reshape_arg_start+0),i=1,nferdims)
     .    / .TRUE., .TRUE., .TRUE., .TRUE., .TRUE., .TRUE. /
* ... merge the axes implied by argument 2 ?
	DATA (gfcn_axis_implied_from(i, p_reshape_arg_start+1),i=1,nferdims)
     .    / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /

* ZAXREPLACE(var, depthoflayer, zaxis)
*   interpolate the sigma layer onto the Z (depth) axis provided guided by
*   the depthoflayer field provided
	INTEGER		p_zlayer_arg_start, p_zlayer_num_args 
	PARAMETER     ( p_zlayer_arg_start = p_reshape_arg_start +
     .					     p_reshape_num_args,
     .			p_zlayer_num_args  = 3 )

	DATA gfcn_name         (p_zlayer) /'ZAXREPLACE'/
	DATA gfcn_version      (p_zlayer) / 1.0 /
	DATA gfcn_descr        (p_zlayer)(1:51) /
     .	         'regrid V onto Z axis of ZAX based upon Z values in '/
	DATA gfcn_descr        (p_zlayer)(52:124) /
     .           'ZVALS using linear interpolation'/

	DATA gfcn_rtn_type     (p_zlayer) / pfcn_rtn_float /
	DATA gfcn_num_reqd_args(p_zlayer) /p_zlayer_num_args/
	DATA (gfcn_dir_args(i,p_zlayer),i=1,nferdims) /nferdims*0/
	DATA gfcn_has_vari_args(p_zlayer) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_zlayer),i=1,nferdims)/
     .						pgc_axis_implied_by_args,
     .						pgc_axis_implied_by_args,
     .						pgc_axis_implied_by_args,
     .						pgc_axis_implied_by_args,
     .						pgc_axis_implied_by_args,
     .						pgc_axis_implied_by_args/
	DATA (gfcn_piecemeal_ok(i,p_zlayer),i=1,nferdims)
     .      /  .FALSE., .FALSE., .FALSE., .TRUE., .TRUE., .TRUE./
	DATA gfcn_arg_ptr(p_zlayer) /p_zlayer_arg_start/

* ... description of arguments
	DATA gfcn_arg_name(p_zlayer_arg_start+0)/'V'/
	DATA gfcn_arg_type(p_zlayer_arg_start+0)/parg_type_float/
	DATA gfcn_arg_units(p_zlayer_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_zlayer_arg_start+0)/
     .		'variable on native Z axis'/
	DATA gfcn_arg_name(p_zlayer_arg_start+1)/'ZVALS'/
	DATA gfcn_arg_type(p_zlayer_arg_start+1)/parg_type_float/
	DATA gfcn_arg_units(p_zlayer_arg_start+1)/' '/
	DATA gfcn_arg_descr(p_zlayer_arg_start+1)/
     .	'Z-value field corresponding to data points of V'/
	DATA gfcn_arg_name(p_zlayer_arg_start+2)/'ZAX'/
	DATA gfcn_arg_type(p_zlayer_arg_start+2)/parg_type_float/
	DATA gfcn_arg_units(p_zlayer_arg_start+2)/' '/
	DATA gfcn_arg_descr(p_zlayer_arg_start+2)/
     .		'variable with desired Z (depth) axis points'/
	DATA (gfcn_arg_extend_lo (i,p_zlayer_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_zlayer_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_zlayer_arg_start+0),i=1,nferdims)
     .    / .TRUE., .TRUE., .FALSE., .TRUE., .TRUE., .TRUE. /
* ... argument 2 
	DATA (gfcn_axis_implied_from(i, p_zlayer_arg_start+1),i=1,nferdims)
     .    / .TRUE., .TRUE., .FALSE., .TRUE., .TRUE., .TRUE. /
* ... argument 3
	DATA (gfcn_axis_implied_from(i, p_zlayer_arg_start+2),i=1,nferdims)
     .    / .FALSE., .FALSE., .TRUE., .FALSE., .FALSE., .FALSE. /


* YSEQUENCE(arg) - same values as input grid but unravelled into a Y line
	INTEGER		p_yunravel_arg_start, p_yunravel_num_args
	PARAMETER     ( p_yunravel_arg_start = p_zlayer_arg_start +
     .					       p_zlayer_num_args,
     .			p_yunravel_num_args  = 1 )
	DATA gfcn_name         (p_yunravel) /'YSEQUENCE'/
	DATA gfcn_version      (p_yunravel) / 1.0 /
	DATA gfcn_descr        (p_yunravel) / 'unravel grid to a line in Y' /
	DATA gfcn_rtn_type     (p_yunravel) /pfcn_rtn_arg1_type /
	DATA gfcn_num_reqd_args(p_yunravel) /p_yunravel_num_args/
	DATA (gfcn_dir_args(i,p_yunravel),i=1,nferdims) /nferdims*0/
	DATA gfcn_has_vari_args(p_yunravel) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_yunravel),i=1,nferdims)/
     .						pgc_axis_is_normal,
     .						pgc_axis_is_abstract,
     .						pgc_axis_is_normal,
     .						pgc_axis_is_normal,
     .						pgc_axis_is_normal,
     .						pgc_axis_is_normal /
	DATA (gfcn_piecemeal_ok(i,p_yunravel),i=1,nferdims)
     .      / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
	DATA gfcn_arg_ptr(p_yunravel) /p_yunravel_arg_start/

* ... description of arguments
	DATA gfcn_arg_name(p_yunravel_arg_start+0)/'VAR'/
	DATA gfcn_arg_type(p_yunravel_arg_start+0)/parg_type_float_or_string/
	DATA gfcn_arg_units(p_yunravel_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_yunravel_arg_start+0)/' '/
	DATA (gfcn_arg_extend_lo (i,p_yunravel_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_yunravel_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_yunravel_arg_start+0),i=1,nferdims)
     .    / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /


* ZSEQUENCE(arg) - same values as input grid but unravelled into a Z line
	INTEGER		p_zunravel_arg_start, p_zunravel_num_args
	PARAMETER     ( p_zunravel_arg_start = p_yunravel_arg_start +
     .					       p_yunravel_num_args,
     .			p_zunravel_num_args  = 1 )
	DATA gfcn_name         (p_zunravel) /'ZSEQUENCE'/
	DATA gfcn_version      (p_zunravel) / 1.0 /
	DATA gfcn_descr        (p_zunravel) / 'unravel grid to a line in Z' /
	DATA gfcn_rtn_type     (p_zunravel) /pfcn_rtn_arg1_type /
	DATA gfcn_num_reqd_args(p_zunravel) /p_zunravel_num_args/
	DATA (gfcn_dir_args(i,p_zunravel),i=1,nferdims) /nferdims*0/
	DATA gfcn_has_vari_args(p_zunravel) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_zunravel),i=1,nferdims)/
     .						pgc_axis_is_normal,
     .						pgc_axis_is_normal,
     .						pgc_axis_is_abstract,
     .						pgc_axis_is_normal,
     .						pgc_axis_is_normal,
     .						pgc_axis_is_normal /
	DATA (gfcn_piecemeal_ok(i,p_zunravel),i=1,nferdims)
     .      / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
	DATA gfcn_arg_ptr(p_zunravel) /p_zunravel_arg_start/

* ... description of arguments
	DATA gfcn_arg_name(p_zunravel_arg_start+0)/'VAR'/
	DATA gfcn_arg_type(p_zunravel_arg_start+0)/parg_type_float_or_string/
	DATA gfcn_arg_units(p_zunravel_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_zunravel_arg_start+0)/' '/
	DATA (gfcn_arg_extend_lo (i,p_zunravel_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_zunravel_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_zunravel_arg_start+0),i=1,nferdims)
     .    / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /


* TSEQUENCE(arg) - same values as input grid but unravelled into a T line
	INTEGER		p_tunravel_arg_start, p_tunravel_num_args
	PARAMETER     ( p_tunravel_arg_start = p_zunravel_arg_start +
     .					       p_zunravel_num_args,
     .			p_tunravel_num_args  = 1 )
	DATA gfcn_name         (p_tunravel) /'TSEQUENCE'/
	DATA gfcn_version      (p_tunravel) / 1.0 /
	DATA gfcn_descr        (p_tunravel) / 'unravel grid to a line in T' /
	DATA gfcn_rtn_type     (p_tunravel) /pfcn_rtn_arg1_type /
	DATA gfcn_num_reqd_args(p_tunravel) /p_tunravel_num_args/
	DATA (gfcn_dir_args(i,p_tunravel),i=1,nferdims) /nferdims*0/
	DATA gfcn_has_vari_args(p_tunravel) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_tunravel),i=1,nferdims)/
     .						pgc_axis_is_normal,
     .						pgc_axis_is_normal,
     .						pgc_axis_is_normal,
     .						pgc_axis_is_abstract,
     .						pgc_axis_is_normal,
     .						pgc_axis_is_normal/
	DATA (gfcn_piecemeal_ok(i,p_tunravel),i=1,nferdims)
     .      / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
	DATA gfcn_arg_ptr(p_tunravel) /p_tunravel_arg_start/

* ... description of arguments
	DATA gfcn_arg_name(p_tunravel_arg_start+0)/'VAR'/
	DATA gfcn_arg_type(p_tunravel_arg_start+0)/parg_type_float_or_string/
	DATA gfcn_arg_units(p_tunravel_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_tunravel_arg_start+0)/' '/
	DATA (gfcn_arg_extend_lo (i,p_tunravel_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_tunravel_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_tunravel_arg_start+0),i=1,nferdims)
     .    / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /

* ESEQUENCE(arg) - same values as input grid but unravelled into a E line
	INTEGER		p_eunravel_arg_start, p_eunravel_num_args
	PARAMETER     ( p_eunravel_arg_start = p_tunravel_arg_start +
     .					       p_tunravel_num_args,
     .			p_eunravel_num_args  = 1 )
	DATA gfcn_name         (p_eunravel) /'ESEQUENCE'/
	DATA gfcn_version      (p_eunravel) / 1.0 /
	DATA gfcn_descr        (p_eunravel) / 'unravel grid to a line in E' /
	DATA gfcn_rtn_type     (p_eunravel) /pfcn_rtn_arg1_type /
	DATA gfcn_num_reqd_args(p_eunravel) /p_eunravel_num_args/
	DATA (gfcn_dir_args(i,p_eunravel),i=1,nferdims) /nferdims*0/
	DATA gfcn_has_vari_args(p_eunravel) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_eunravel),i=1,nferdims)/
     .						pgc_axis_is_normal,
     .						pgc_axis_is_normal,
     .						pgc_axis_is_normal,
     .						pgc_axis_is_normal,
     .						pgc_axis_is_abstract,
     .						pgc_axis_is_normal/
	DATA (gfcn_piecemeal_ok(i,p_eunravel),i=1,nferdims)
     .      / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
	DATA gfcn_arg_ptr(p_eunravel) /p_eunravel_arg_start/

* ... description of arguments
	DATA gfcn_arg_name(p_eunravel_arg_start+0)/'VAR'/
	DATA gfcn_arg_type(p_eunravel_arg_start+0)/parg_type_float_or_string/
	DATA gfcn_arg_units(p_eunravel_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_eunravel_arg_start+0)/' '/
	DATA (gfcn_arg_extend_lo (i,p_eunravel_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_eunravel_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_eunravel_arg_start+0),i=1,nferdims)
     .    / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /


* FSEQUENCE(arg) - same values as input grid but unravelled into a F line
	INTEGER		p_funravel_arg_start, p_funravel_num_args
	PARAMETER     ( p_funravel_arg_start = p_eunravel_arg_start +
     .					       p_eunravel_num_args,
     .			p_funravel_num_args  = 1 )
	DATA gfcn_name         (p_funravel) /'FSEQUENCE'/
	DATA gfcn_version      (p_funravel) / 1.0 /
	DATA gfcn_descr        (p_funravel) / 'unravel grid to a line in F' /
	DATA gfcn_rtn_type     (p_funravel) /pfcn_rtn_arg1_type /
	DATA gfcn_num_reqd_args(p_funravel) /p_funravel_num_args/
	DATA (gfcn_dir_args(i,p_funravel),i=1,nferdims) /nferdims*0/
	DATA gfcn_has_vari_args(p_funravel) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_funravel),i=1,nferdims)/
     .						pgc_axis_is_normal,
     .						pgc_axis_is_normal,
     .						pgc_axis_is_normal,
     .						pgc_axis_is_normal,
     .						pgc_axis_is_normal,
     .						pgc_axis_is_abstract/
	DATA (gfcn_piecemeal_ok(i,p_funravel),i=1,nferdims)
     .      / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
	DATA gfcn_arg_ptr(p_funravel) /p_funravel_arg_start/

* ... description of arguments
	DATA gfcn_arg_name(p_funravel_arg_start+0)/'VAR'/
	DATA gfcn_arg_type(p_funravel_arg_start+0)/parg_type_float_or_string/
	DATA gfcn_arg_units(p_funravel_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_funravel_arg_start+0)/' '/
	DATA (gfcn_arg_extend_lo (i,p_funravel_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_funravel_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_funravel_arg_start+0),i=1,nferdims)
     .    / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /

* SAMPLEI - sample argument 1 at the X indices indicated in arg 2
	INTEGER		p_samplei_arg_start, p_samplei_num_args 
	PARAMETER     ( p_samplei_arg_start = p_funravel_arg_start +
     .					      p_funravel_num_args,
     .			p_samplei_num_args  = 2 )

	DATA gfcn_name         (p_samplei) /'SAMPLEI'/
	DATA gfcn_version      (p_samplei) / 1.0 /
	DATA gfcn_descr        (p_samplei)
     .		/ 'sample a field at a list of X indices' /
	DATA gfcn_rtn_type     (p_samplei) /pfcn_rtn_arg1_type /
	DATA gfcn_num_reqd_args(p_samplei) /p_samplei_num_args/
	DATA (gfcn_dir_args(i,p_samplei),i=1,nferdims) /nferdims*0/
	DATA gfcn_has_vari_args(p_samplei) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_samplei),i=1,nferdims)/
     .					pgc_axis_is_abstract,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args /
	DATA (gfcn_piecemeal_ok(i,p_samplei),i=1,nferdims)
     .      / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
	DATA gfcn_arg_ptr(p_samplei) /p_samplei_arg_start/

* ... description of arguments
	DATA gfcn_arg_name(p_samplei_arg_start+0)/'TO_BE_SAMPLED'/
	DATA gfcn_arg_type(p_samplei_arg_start+0)/parg_type_float_or_string/
	DATA gfcn_arg_units(p_samplei_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_samplei_arg_start+0)
     .			/'data to sample at list of X indices supplied '/
	DATA (gfcn_arg_extend_lo (i,p_samplei_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_samplei_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA gfcn_arg_name(p_samplei_arg_start+1)/'X_INDICES'/
	DATA gfcn_arg_type(p_samplei_arg_start+1)/parg_type_float/
	DATA gfcn_arg_units(p_samplei_arg_start+1)/' '/
	DATA gfcn_arg_descr(p_samplei_arg_start+1)
     .			/'list of X indices at which to sample'/
	DATA (gfcn_arg_extend_lo (i,p_samplei_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_samplei_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_samplei_arg_start+0),i=1,nferdims)
     .    / .FALSE., .TRUE., .TRUE., .TRUE., .TRUE., .TRUE. /
* ... by argument 2?
	DATA (gfcn_axis_implied_from(i, p_samplei_arg_start+1),i=1,nferdims)
     .    / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /


* SAMPLEJ - sample argument 1 at the Y indices indicated in arg 2
	INTEGER		p_samplej_arg_start, p_samplej_num_args 
	PARAMETER     ( p_samplej_arg_start = p_samplei_arg_start +
     .					      p_samplei_num_args,
     .			p_samplej_num_args  = 2 )

	DATA gfcn_name         (p_samplej) /'SAMPLEJ'/
	DATA gfcn_version      (p_samplej) / 1.0 /
	DATA gfcn_descr        (p_samplej)
     .		/ 'sample a field at a list of Y indices' /
	DATA gfcn_rtn_type     (p_samplej) /pfcn_rtn_arg1_type /
	DATA gfcn_num_reqd_args(p_samplej) /p_samplej_num_args/
	DATA (gfcn_dir_args(i,p_samplej),i=1,nferdims) /nferdims*0/
	DATA gfcn_has_vari_args(p_samplej) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_samplej),i=1,nferdims)/
     .					pgc_axis_implied_by_args,
     .					pgc_axis_is_abstract,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args /
	DATA (gfcn_piecemeal_ok(i,p_samplej),i=1,nferdims)
     .      / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
	DATA gfcn_arg_ptr(p_samplej) /p_samplej_arg_start/

* ... description of arguments
	DATA gfcn_arg_name(p_samplej_arg_start+0)/'TO_BE_SAMPLED'/
	DATA gfcn_arg_type(p_samplej_arg_start+0)/parg_type_float_or_string/
	DATA gfcn_arg_units(p_samplej_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_samplej_arg_start+0)
     .			/'data to sample at list of Y indices supplied '/
	DATA (gfcn_arg_extend_lo (i,p_samplej_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_samplej_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA gfcn_arg_name(p_samplej_arg_start+1)/'Y_INDICES'/
	DATA gfcn_arg_type(p_samplej_arg_start+1)/parg_type_float/
	DATA gfcn_arg_units(p_samplej_arg_start+1)/' '/
	DATA gfcn_arg_descr(p_samplej_arg_start+1)
     .			/'list of Y indices at which to sample'/
	DATA (gfcn_arg_extend_lo (i,p_samplej_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_samplej_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_samplej_arg_start+0),i=1,nferdims)
     .    / .TRUE., .FALSE., .TRUE., .TRUE., .TRUE., .TRUE. /
* ... by argument 2?
	DATA (gfcn_axis_implied_from(i, p_samplej_arg_start+1),i=1,nferdims)
     .    / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /


* SAMPLEK - sample argument 1 at the Z indices indicated in arg 2
	INTEGER		p_samplek_arg_start, p_samplek_num_args 
	PARAMETER     ( p_samplek_arg_start = p_samplej_arg_start +
     .					      p_samplej_num_args,
     .			p_samplek_num_args  = 2 )

	DATA gfcn_name         (p_samplek) /'SAMPLEK'/
	DATA gfcn_version      (p_samplek) / 1.0 /
	DATA gfcn_descr        (p_samplek)
     .		/ 'sample a field at a list of Z indices' /
	DATA gfcn_rtn_type     (p_samplek) /pfcn_rtn_arg1_type /
	DATA gfcn_num_reqd_args(p_samplek) /p_samplek_num_args/
	DATA (gfcn_dir_args(i,p_samplek),i=1,nferdims) /nferdims*0/
	DATA gfcn_has_vari_args(p_samplek) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_samplek),i=1,nferdims)/
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_is_abstract,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args /
	DATA (gfcn_piecemeal_ok(i,p_samplek),i=1,nferdims)
     .      / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
	DATA gfcn_arg_ptr(p_samplek) /p_samplek_arg_start/

* ... description of arguments
	DATA gfcn_arg_name(p_samplek_arg_start+0)/'TO_BE_SAMPLED'/
	DATA gfcn_arg_type(p_samplek_arg_start+0)/parg_type_float_or_string/
	DATA gfcn_arg_units(p_samplek_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_samplek_arg_start+0)
     .			/'data to sample at list of Z indices supplied '/
	DATA (gfcn_arg_extend_lo (i,p_samplek_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_samplek_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA gfcn_arg_name(p_samplek_arg_start+1)/'Z_INDICES'/
	DATA gfcn_arg_type(p_samplek_arg_start+1)/parg_type_float/
	DATA gfcn_arg_units(p_samplek_arg_start+1)/' '/
	DATA gfcn_arg_descr(p_samplek_arg_start+1)
     .			/'list of Z indices at which to sample'/
	DATA (gfcn_arg_extend_lo (i,p_samplek_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_samplek_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_samplek_arg_start+0),i=1,nferdims)
     .    / .TRUE., .TRUE., .FALSE., .TRUE., .TRUE., .TRUE. /
* ... by argument 2?
	DATA (gfcn_axis_implied_from(i, p_samplek_arg_start+1),i=1,nferdims)
     .    / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /


* SAMPLEL - sample argument 1 at the T indices indicated in arg 2
	INTEGER		p_samplel_arg_start, p_samplel_num_args 
	PARAMETER     ( p_samplel_arg_start = p_samplek_arg_start +
     .					      p_samplek_num_args, 
     .			p_samplel_num_args  = 2 )

	DATA gfcn_name         (p_samplel) /'SAMPLEL'/
	DATA gfcn_version      (p_samplel) / 1.0 /
	DATA gfcn_descr        (p_samplel)
     .		/ 'sample a field at a list of T indices' /
	DATA gfcn_rtn_type     (p_samplel) /pfcn_rtn_arg1_type /
	DATA gfcn_num_reqd_args(p_samplel) /p_samplel_num_args/
	DATA (gfcn_dir_args(i,p_samplel),i=1,nferdims) /nferdims*0/
	DATA gfcn_has_vari_args(p_samplel) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_samplel),i=1,nferdims)/
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_is_abstract,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args/
	DATA (gfcn_piecemeal_ok(i,p_samplel),i=1,nferdims)
     .      / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
	DATA gfcn_arg_ptr(p_samplel) /p_samplel_arg_start/

* ... description of arguments
	DATA gfcn_arg_name(p_samplel_arg_start+0)/'TO_BE_SAMPLED'/
	DATA gfcn_arg_type(p_samplel_arg_start+0)/parg_type_float_or_string/
	DATA gfcn_arg_units(p_samplel_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_samplel_arg_start+0)
     .			/'data to sample at list of T indices supplied '/
	DATA (gfcn_arg_extend_lo (i,p_samplel_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_samplel_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA gfcn_arg_name(p_samplel_arg_start+1)/'T_INDICES'/
	DATA gfcn_arg_type(p_samplel_arg_start+1)/parg_type_float/
	DATA gfcn_arg_units(p_samplel_arg_start+1)/' '/
	DATA gfcn_arg_descr(p_samplel_arg_start+1)
     .			/'list of T indices at which to sample'/
	DATA (gfcn_arg_extend_lo (i,p_samplel_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_samplel_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_samplel_arg_start+0),i=1,nferdims)
     .    / .TRUE., .TRUE., .TRUE., .FALSE., .TRUE., .TRUE. /
* ... by argument 2?
	DATA (gfcn_axis_implied_from(i, p_samplel_arg_start+1),i=1,nferdims)
     .    / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /


* SAMPLEM - sample argument 1 at the E indices indicated in arg 2
	INTEGER		p_samplem_arg_start, p_samplem_num_args 
	PARAMETER     ( p_samplem_arg_start = p_samplel_arg_start +
     .					      p_samplel_num_args, 
     .			p_samplem_num_args  = 2 )

	DATA gfcn_name         (p_samplem) /'SAMPLEM'/
	DATA gfcn_version      (p_samplem) / 1.0 /
	DATA gfcn_descr        (p_samplem)
     .		/ 'sample a field at a list of E indices' /
	DATA gfcn_rtn_type     (p_samplem) /pfcn_rtn_arg1_type /
	DATA gfcn_num_reqd_args(p_samplem) /p_samplem_num_args/
	DATA (gfcn_dir_args(i,p_samplem),i=1,nferdims) /nferdims*0/
	DATA gfcn_has_vari_args(p_samplem) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_samplem),i=1,nferdims)/
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_is_abstract,
     .					pgc_axis_implied_by_args/
	DATA (gfcn_piecemeal_ok(i,p_samplem),i=1,nferdims)
     .      / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
	DATA gfcn_arg_ptr(p_samplem) /p_samplem_arg_start/

* ... description of arguments
	DATA gfcn_arg_name(p_samplem_arg_start+0)/'TO_BE_SAMPLED'/
	DATA gfcn_arg_type(p_samplem_arg_start+0)/parg_type_float_or_string/
	DATA gfcn_arg_units(p_samplem_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_samplem_arg_start+0)
     .			/'data to sample at list of E indices supplied '/
	DATA (gfcn_arg_extend_lo (i,p_samplem_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_samplem_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA gfcn_arg_name(p_samplem_arg_start+1)/'E_INDICES'/
	DATA gfcn_arg_type(p_samplem_arg_start+1)/parg_type_float/
	DATA gfcn_arg_units(p_samplem_arg_start+1)/' '/
	DATA gfcn_arg_descr(p_samplem_arg_start+1)
     .			/'list of E indices at which to sample'/
	DATA (gfcn_arg_extend_lo (i,p_samplem_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_samplem_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_samplem_arg_start+0),i=1,nferdims)
     .    / .TRUE., .TRUE., .TRUE., .TRUE., .FALSE., .TRUE. /
* ... by argument 2?
	DATA (gfcn_axis_implied_from(i, p_samplem_arg_start+1),i=1,nferdims)
     .    / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /


* SAMPLEN - sample argument 1 at the F indices indicated in arg 2
	INTEGER		p_samplen_arg_start, p_samplen_num_args 
	PARAMETER     ( p_samplen_arg_start = p_samplem_arg_start +
     .					      p_samplem_num_args, 
     .			p_samplen_num_args  = 2 )

	DATA gfcn_name         (p_samplen) /'SAMPLEN'/
	DATA gfcn_version      (p_samplen) / 1.0 /
	DATA gfcn_descr        (p_samplen)
     .		/ 'sample a field at a list of F indices' /
	DATA gfcn_rtn_type     (p_samplen) /pfcn_rtn_arg1_type /
	DATA gfcn_num_reqd_args(p_samplen) /p_samplen_num_args/
	DATA (gfcn_dir_args(i,p_samplen),i=1,nferdims) /nferdims*0/
	DATA gfcn_has_vari_args(p_samplen) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_samplen),i=1,nferdims)/
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_is_abstract/
	DATA (gfcn_piecemeal_ok(i,p_samplen),i=1,nferdims)
     .      / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
	DATA gfcn_arg_ptr(p_samplen) /p_samplen_arg_start/

* ... description of arguments
	DATA gfcn_arg_name(p_samplen_arg_start+0)/'TO_BE_SAMPLED'/
	DATA gfcn_arg_type(p_samplen_arg_start+0)/parg_type_float_or_string/
	DATA gfcn_arg_units(p_samplen_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_samplen_arg_start+0)
     .			/'data to sample at list of F indices supplied '/
	DATA (gfcn_arg_extend_lo (i,p_samplen_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_samplen_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA gfcn_arg_name(p_samplen_arg_start+1)/'F_INDICES'/
	DATA gfcn_arg_type(p_samplen_arg_start+1)/parg_type_float/
	DATA gfcn_arg_units(p_samplen_arg_start+1)/' '/
	DATA gfcn_arg_descr(p_samplen_arg_start+1)
     .			/'list of F indices at which to sample'/
	DATA (gfcn_arg_extend_lo (i,p_samplen_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_samplen_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_samplen_arg_start+0),i=1,nferdims)
     .    / .TRUE., .TRUE., .TRUE., .TRUE., .TRUE., .FALSE. /
* ... by argument 2?
	DATA (gfcn_axis_implied_from(i, p_samplen_arg_start+1),i=1,nferdims)
     .    / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /



* SPAWN("unix cmnd") - execute a Unix system command and return strings
	INTEGER		p_spawn_arg_start, p_spawn_num_args
	PARAMETER     ( p_spawn_arg_start = p_samplen_arg_start +
     .					    p_samplen_num_args,
     .			p_spawn_num_args  = 1 )
	DATA gfcn_name         (p_spawn) /'SPAWN'/
	DATA gfcn_version      (p_spawn) / 1.0 /
	DATA gfcn_descr        (p_spawn) / 'execute a system command' /
	DATA gfcn_rtn_type     (p_spawn) /pfcn_rtn_string /
	DATA gfcn_num_reqd_args(p_spawn) /p_spawn_num_args/
	DATA (gfcn_dir_args(i,p_spawn),i=1,nferdims) /nferdims*0/
	DATA gfcn_has_vari_args(p_spawn) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_spawn),i=1,nferdims)/
     .						pgc_axis_is_abstract,
     .						pgc_axis_is_normal,
     .						pgc_axis_is_normal,
     .						pgc_axis_is_normal,
     .						pgc_axis_is_normal,
     .						pgc_axis_is_normal/
	DATA (gfcn_piecemeal_ok(i,p_spawn),i=1,nferdims)
     .      / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
	DATA gfcn_arg_ptr(p_spawn) /p_spawn_arg_start/

* ... description of arguments
	DATA gfcn_arg_name(p_spawn_arg_start+0)/'STR'/
	DATA gfcn_arg_type(p_spawn_arg_start+0)/parg_type_string/
	DATA gfcn_arg_units(p_spawn_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_spawn_arg_start+0)/'Unix command string'/
	DATA (gfcn_arg_extend_lo (i,p_spawn_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_spawn_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_spawn_arg_start+0),i=1,nferdims)
     .    / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /

* STRCMP(string1, string2) - compare 2 string *arrays* as in C function
	INTEGER		p_strcmp_arg_start, p_strcmp_num_args
	PARAMETER     ( p_strcmp_arg_start = p_spawn_arg_start +
     .					    p_spawn_num_args,
     .			p_strcmp_num_args  = 2 )
	DATA gfcn_name         (p_strcmp) /'STRCMP'/
	DATA gfcn_version      (p_strcmp) / 1.0 /
	DATA gfcn_descr        (p_strcmp) /
     .	'compare strings: +, 0, or - for str1 >, =, or < str2 rspctvly' /
	DATA gfcn_rtn_type     (p_strcmp) /pfcn_rtn_float /
	DATA gfcn_num_reqd_args(p_strcmp) /p_strcmp_num_args/
	DATA (gfcn_dir_args(i,p_strcmp),i=1,nferdims) /nferdims*0/
	DATA gfcn_has_vari_args(p_strcmp) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_strcmp),i=1,nferdims)/
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args/
	DATA (gfcn_piecemeal_ok(i,p_strcmp),i=1,nferdims)
     .      / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
	DATA gfcn_arg_ptr(p_strcmp) /p_strcmp_arg_start/

* ... description of argument 1
	DATA gfcn_arg_name(p_strcmp_arg_start+0)/'STR1'/
	DATA gfcn_arg_type(p_strcmp_arg_start+0)/parg_type_string/
	DATA gfcn_arg_units(p_strcmp_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_strcmp_arg_start+0)/'string array 1'/
	DATA (gfcn_arg_extend_lo (i,p_strcmp_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_strcmp_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_strcmp_arg_start+0),i=1,nferdims)
     .    / .TRUE., .TRUE., .TRUE., .TRUE., .TRUE., .TRUE. /

* ... description of argument 2
	DATA gfcn_arg_name(p_strcmp_arg_start+1)/'STR2'/
	DATA gfcn_arg_type(p_strcmp_arg_start+1)/parg_type_string/
	DATA gfcn_arg_units(p_strcmp_arg_start+1)/' '/
	DATA gfcn_arg_descr(p_strcmp_arg_start+1)/'string array 2'/
	DATA (gfcn_arg_extend_lo (i,p_strcmp_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_strcmp_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 2 ?
	DATA (gfcn_axis_implied_from(i, p_strcmp_arg_start+1),i=1,nferdims)
     .    / .TRUE., .TRUE., .TRUE., .TRUE., .TRUE., .TRUE. /


* STRLEN(string1) - return the length of the string
	INTEGER		p_strlen_arg_start, p_strlen_num_args
	PARAMETER     ( p_strlen_arg_start = p_strcmp_arg_start +
     .					    p_strcmp_num_args,
     .			p_strlen_num_args  = 1 )
	DATA gfcn_name         (p_strlen) /'STRLEN'/
	DATA gfcn_version      (p_strlen) / 1.0 /
	DATA gfcn_descr        (p_strlen) /
     .	'determine string length' /
	DATA gfcn_rtn_type     (p_strlen) /pfcn_rtn_float /
	DATA gfcn_num_reqd_args(p_strlen) /p_strlen_num_args/
	DATA (gfcn_dir_args(i,p_strlen),i=1,nferdims) /nferdims*0/
	DATA gfcn_has_vari_args(p_strlen) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_strlen),i=1,nferdims)/
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args/
	DATA (gfcn_piecemeal_ok(i,p_strlen),i=1,nferdims)
     .      / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
	DATA gfcn_arg_ptr(p_strlen) /p_strlen_arg_start/

* ... description of argument 1
	DATA gfcn_arg_name(p_strlen_arg_start+0)/'STR'/
	DATA gfcn_arg_type(p_strlen_arg_start+0)/parg_type_string/
	DATA gfcn_arg_units(p_strlen_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_strlen_arg_start+0)/'string array 1'/
	DATA (gfcn_arg_extend_lo (i,p_strlen_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_strlen_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_strlen_arg_start+0),i=1,nferdims)
     .    / .TRUE., .TRUE., .TRUE., .TRUE., .TRUE., .TRUE. /


* UPCASE(string1) - return string in all upper case
	INTEGER		p_upcase_arg_start, p_upcase_num_args
	PARAMETER     ( p_upcase_arg_start = p_strlen_arg_start +
     .					    p_strlen_num_args,
     .			p_upcase_num_args  = 1 )
	DATA gfcn_name         (p_upcase) /'UPCASE'/
	DATA gfcn_version      (p_upcase) / 1.0 /
	DATA gfcn_descr        (p_upcase) /
     .	'upper case entire string' /
	DATA gfcn_rtn_type     (p_upcase) /pfcn_rtn_string /
	DATA gfcn_num_reqd_args(p_upcase) /p_upcase_num_args/
	DATA (gfcn_dir_args(i,p_upcase),i=1,nferdims) /nferdims*0/
	DATA gfcn_has_vari_args(p_upcase) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_upcase),i=1,nferdims)/
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args/
	DATA (gfcn_piecemeal_ok(i,p_upcase),i=1,nferdims)
     .      / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
	DATA gfcn_arg_ptr(p_upcase) /p_upcase_arg_start/

* ... description of argument 1
	DATA gfcn_arg_name(p_upcase_arg_start+0)/'STR'/
	DATA gfcn_arg_type(p_upcase_arg_start+0)/parg_type_string/
	DATA gfcn_arg_units(p_upcase_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_upcase_arg_start+0)/'string array 1'/
	DATA (gfcn_arg_extend_lo (i,p_upcase_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_upcase_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_upcase_arg_start+0),i=1,nferdims)
     .    / .TRUE., .TRUE., .TRUE., .TRUE., .TRUE., .TRUE. /



* STRINDEX(string1, substring) - find start char position of substring
	INTEGER		p_strindex_arg_start, p_strindex_num_args
	PARAMETER     ( p_strindex_arg_start = p_upcase_arg_start +
     .					    p_upcase_num_args,
     .			p_strindex_num_args  = 2 )
	DATA gfcn_name         (p_strindex) /'STRINDEX'/
	DATA gfcn_version      (p_strindex) / 1.0 /
	DATA gfcn_descr        (p_strindex) /
     .	'Return start character position of substring in string' /
	DATA gfcn_rtn_type     (p_strindex) /pfcn_rtn_float /
	DATA gfcn_num_reqd_args(p_strindex) /p_strindex_num_args/
	DATA (gfcn_dir_args(i,p_strindex),i=1,nferdims) /nferdims*0/
	DATA gfcn_has_vari_args(p_strindex) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_strindex),i=1,nferdims)/
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args/
	DATA (gfcn_piecemeal_ok(i,p_strindex),i=1,nferdims)
     .      / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
	DATA gfcn_arg_ptr(p_strindex) /p_strindex_arg_start/

* ... description of argument 1
	DATA gfcn_arg_name(p_strindex_arg_start+0)/'STR1'/
	DATA gfcn_arg_type(p_strindex_arg_start+0)/parg_type_string/
	DATA gfcn_arg_units(p_strindex_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_strindex_arg_start+0)/'string array 1'/
	DATA (gfcn_arg_extend_lo (i,p_strindex_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_strindex_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_strindex_arg_start+0),i=1,nferdims)
     .    / .TRUE., .TRUE., .TRUE., .TRUE., .TRUE., .TRUE. /

* ... description of argument 2
	DATA gfcn_arg_name(p_strindex_arg_start+1)/'SUBSTR'/
	DATA gfcn_arg_type(p_strindex_arg_start+1)/parg_type_string/
	DATA gfcn_arg_units(p_strindex_arg_start+1)/' '/
	DATA gfcn_arg_descr(p_strindex_arg_start+1)/'string array 2'/
	DATA (gfcn_arg_extend_lo (i,p_strindex_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_strindex_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 2 ?
	DATA (gfcn_axis_implied_from(i, p_strindex_arg_start+1),i=1,nferdims)
     .    / .TRUE., .TRUE., .TRUE., .TRUE., .TRUE., .TRUE. /



* STRRINDEX(string1, substring) - find last char position of substring
	INTEGER		p_strrindex_arg_start, p_strrindex_num_args
	PARAMETER     ( p_strrindex_arg_start = p_strindex_arg_start +
     .					    p_strindex_num_args,
     .			p_strrindex_num_args  = 2 )
	DATA gfcn_name         (p_strrindex) /'STRRINDEX'/
	DATA gfcn_version      (p_strrindex) / 1.0 /
	DATA gfcn_descr        (p_strrindex) /
     .	'Return last character position of substring in string' /
	DATA gfcn_rtn_type     (p_strrindex) /pfcn_rtn_float /
	DATA gfcn_num_reqd_args(p_strrindex) /p_strrindex_num_args/
	DATA (gfcn_dir_args(i,p_strrindex),i=1,nferdims) /nferdims*0/
	DATA gfcn_has_vari_args(p_strrindex) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_strrindex),i=1,nferdims)/
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args/
	DATA (gfcn_piecemeal_ok(i,p_strrindex),i=1,nferdims)
     .      / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
	DATA gfcn_arg_ptr(p_strrindex) /p_strrindex_arg_start/

* ... description of argument 1
	DATA gfcn_arg_name(p_strrindex_arg_start+0)/'STR1'/
	DATA gfcn_arg_type(p_strrindex_arg_start+0)/parg_type_string/
	DATA gfcn_arg_units(p_strrindex_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_strrindex_arg_start+0)/'string array 1'/
	DATA (gfcn_arg_extend_lo (i,p_strrindex_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_strrindex_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_strrindex_arg_start+0),i=1,nferdims)
     .    / .TRUE., .TRUE., .TRUE., .TRUE., .TRUE., .TRUE. /

* ... description of argument 2
	DATA gfcn_arg_name(p_strrindex_arg_start+1)/'SUBSTR'/
	DATA gfcn_arg_type(p_strrindex_arg_start+1)/parg_type_string/
	DATA gfcn_arg_units(p_strrindex_arg_start+1)/' '/
	DATA gfcn_arg_descr(p_strrindex_arg_start+1)/'string array 2'/
	DATA (gfcn_arg_extend_lo (i,p_strrindex_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_strrindex_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 2 ?
	DATA (gfcn_axis_implied_from(i, p_strrindex_arg_start+1),i=1,nferdims)
     .    / .TRUE., .TRUE., .TRUE., .TRUE., .TRUE., .TRUE. /



* DNCASE(string1) - return string in all lower case
	INTEGER		p_dncase_arg_start, p_dncase_num_args
	PARAMETER     ( p_dncase_arg_start = p_strrindex_arg_start +
     .					    p_strrindex_num_args,
     .			p_dncase_num_args  = 1 )
	DATA gfcn_name         (p_dncase) /'DNCASE'/
	DATA gfcn_version      (p_dncase) / 1.0 /
	DATA gfcn_descr        (p_dncase) /
     .	'make entire string lower case' /
	DATA gfcn_rtn_type     (p_dncase) /pfcn_rtn_string /
	DATA gfcn_num_reqd_args(p_dncase) /p_dncase_num_args/
	DATA (gfcn_dir_args(i,p_dncase),i=1,nferdims) /nferdims*0/
	DATA gfcn_has_vari_args(p_dncase) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_dncase),i=1,nferdims)/
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args/
	DATA (gfcn_piecemeal_ok(i,p_dncase),i=1,nferdims)
     .      / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
	DATA gfcn_arg_ptr(p_dncase) /p_dncase_arg_start/

* ... description of argument 1
	DATA gfcn_arg_name(p_dncase_arg_start+0)/'STR'/
	DATA gfcn_arg_type(p_dncase_arg_start+0)/parg_type_string/
	DATA gfcn_arg_units(p_dncase_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_dncase_arg_start+0)/'string array 1'/
	DATA (gfcn_arg_extend_lo (i,p_dncase_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_dncase_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_dncase_arg_start+0),i=1,nferdims)
     .    / .TRUE., .TRUE., .TRUE., .TRUE., .TRUE., .TRUE. /


* STRCAT(string1, string2) - concatenate 2 string *arrays* as in C function
	INTEGER		p_strcat_arg_start, p_strcat_num_args
	PARAMETER     ( p_strcat_arg_start = p_dncase_arg_start +
     .					    p_dncase_num_args,
     .			p_strcat_num_args  = 2 )
	DATA gfcn_name         (p_strcat) /'STRCAT'/
	DATA gfcn_version      (p_strcat) / 1.0 /
	DATA gfcn_descr        (p_strcat) /
     .	'concatenate two strings' /
	DATA gfcn_rtn_type     (p_strcat) /pfcn_rtn_string /
	DATA gfcn_num_reqd_args(p_strcat) /p_strcat_num_args/
	DATA (gfcn_dir_args(i,p_strcat),i=1,nferdims) /nferdims*0/
	DATA gfcn_has_vari_args(p_strcat) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_strcat),i=1,nferdims)/
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args/
	DATA (gfcn_piecemeal_ok(i,p_strcat),i=1,nferdims)
     .      / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
	DATA gfcn_arg_ptr(p_strcat) /p_strcat_arg_start/

* ... description of argument 1
	DATA gfcn_arg_name(p_strcat_arg_start+0)/'STR1'/
	DATA gfcn_arg_type(p_strcat_arg_start+0)/parg_type_string/
	DATA gfcn_arg_units(p_strcat_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_strcat_arg_start+0)/'string array 1'/
	DATA (gfcn_arg_extend_lo (i,p_strcat_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_strcat_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_strcat_arg_start+0),i=1,nferdims)
     .    / .TRUE., .TRUE., .TRUE., .TRUE., .TRUE., .TRUE. /

* ... description of argument 2
	DATA gfcn_arg_name(p_strcat_arg_start+1)/'STR2'/
	DATA gfcn_arg_type(p_strcat_arg_start+1)/parg_type_string/
	DATA gfcn_arg_units(p_strcat_arg_start+1)/' '/
	DATA gfcn_arg_descr(p_strcat_arg_start+1)/'string array 2'/
	DATA (gfcn_arg_extend_lo (i,p_strcat_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_strcat_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 2 ?
	DATA (gfcn_axis_implied_from(i, p_strcat_arg_start+1),i=1,nferdims)
     .    / .TRUE., .TRUE., .TRUE., .TRUE., .TRUE., .TRUE. /



* SUBSTR(string1, offset, length) - clips a substring from a string
	INTEGER		p_substring_arg_start, p_substring_num_args
	PARAMETER     ( p_substring_arg_start = p_strcat_arg_start +
     .					    p_strcat_num_args,
     .			p_substring_num_args  = 3 )
	DATA gfcn_name         (p_substring) /'SUBSTRING'/
	DATA gfcn_version      (p_substring) / 1.0 /
	DATA gfcn_descr        (p_substring) /
     .	         'Return a substring ' /
	DATA gfcn_rtn_type     (p_substring) /pfcn_rtn_string /
	DATA gfcn_num_reqd_args(p_substring) /p_substring_num_args/
	DATA (gfcn_dir_args(i,p_substring),i=1,nferdims) /nferdims*0/
	DATA gfcn_has_vari_args(p_substring) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_substring),i=1,nferdims)/
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args/
	DATA (gfcn_piecemeal_ok(i,p_substring),i=1,nferdims)
     .      / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
	DATA gfcn_arg_ptr(p_substring) /p_substring_arg_start/

* ... description of argument 1
	DATA gfcn_arg_name(p_substring_arg_start+0)/'STR'/
	DATA gfcn_arg_type(p_substring_arg_start+0)/parg_type_string/
	DATA gfcn_arg_units(p_substring_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_substring_arg_start+0)/'string array'/
	DATA (gfcn_arg_extend_lo (i,p_substring_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_substring_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_substring_arg_start+0),i=1,nferdims)
     .    / .TRUE., .TRUE., .TRUE., .TRUE., .TRUE., .TRUE. /

* ... description of argument 2
	DATA gfcn_arg_name(p_substring_arg_start+1)/'OFFSET'/
	DATA gfcn_arg_type(p_substring_arg_start+1)/parg_type_float/
	DATA gfcn_arg_units(p_substring_arg_start+1)/' '/
	DATA gfcn_arg_descr(p_substring_arg_start+1)/'start position'/
	DATA (gfcn_arg_extend_lo (i,p_substring_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_substring_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 2 ?
	DATA (gfcn_axis_implied_from(i, p_substring_arg_start+1),i=1,nferdims)
     .    / .TRUE., .TRUE., .TRUE., .TRUE., .TRUE., .TRUE. /


* ... description of argument 3
	DATA gfcn_arg_name(p_substring_arg_start+2)/'LENGTH'/
	DATA gfcn_arg_type(p_substring_arg_start+2)/parg_type_float/
	DATA gfcn_arg_units(p_substring_arg_start+2)/' '/
	DATA gfcn_arg_descr(p_substring_arg_start+2)/'number of chars'/
	DATA (gfcn_arg_extend_lo (i,p_substring_arg_start+2),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_substring_arg_start+2),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 3 ?
	DATA (gfcn_axis_implied_from(i, p_substring_arg_start+2),i=1,nferdims)
     .    / .TRUE., .TRUE., .TRUE., .TRUE., .TRUE., .TRUE. /


* STRFLOAT(string1) - return float value of given string
	INTEGER		p_strfloat_arg_start, p_strfloat_num_args
	PARAMETER     ( p_strfloat_arg_start = p_substring_arg_start +
     .					    p_substring_num_args,
     .			p_strfloat_num_args  = 1 )
	DATA gfcn_name         (p_strfloat) /'STRFLOAT'/
	DATA gfcn_version      (p_strfloat) / 1.0 /
	DATA gfcn_descr        (p_strfloat) /
     .	'Return float value from character string' /
	DATA gfcn_rtn_type     (p_strfloat) /pfcn_rtn_float /
	DATA gfcn_num_reqd_args(p_strfloat) /p_strfloat_num_args/
	DATA (gfcn_dir_args(i,p_strfloat),i=1,nferdims) /nferdims*0/
	DATA gfcn_has_vari_args(p_strfloat) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_strfloat),i=1,nferdims)/
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args/
	DATA (gfcn_piecemeal_ok(i,p_strfloat),i=1,nferdims)
     .      / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
	DATA gfcn_arg_ptr(p_strfloat) /p_strfloat_arg_start/

* ... description of argument 1
	DATA gfcn_arg_name(p_strfloat_arg_start+0)/'STR'/
	DATA gfcn_arg_type(p_strfloat_arg_start+0)/parg_type_string/
	DATA gfcn_arg_units(p_strfloat_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_strfloat_arg_start+0)/'string array 1'/
	DATA (gfcn_arg_extend_lo (i,p_strfloat_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_strfloat_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_strfloat_arg_start+0),i=1,nferdims)
     .    / .TRUE., .TRUE., .TRUE., .TRUE., .TRUE., .TRUE. /


* dot(var1,var2,idim) - return inner-product of two variables 
*                                computed along a given common dimension
	INTEGER		p_dot_arg_start, p_dot_num_args
	PARAMETER     ( p_dot_arg_start = p_strfloat_arg_start +
     .					    p_strfloat_num_args,
     .			p_dot_num_args  = 3 )
	DATA gfcn_name         (p_dot) /'DOT'/
	DATA gfcn_alt_name_base (p_dot) /'DOT_%'/
	DATA gfcn_version      (p_dot) / 1.0 /
	DATA gfcn_descr        (p_dot) /
     .	'Compute the inner product of two variables along given dimension' /
	DATA gfcn_rtn_type     (p_dot) /pfcn_rtn_float /
	DATA gfcn_num_reqd_args(p_dot) /p_dot_num_args/
	DATA (gfcn_dir_args(i,p_dot),i=1,nferdims)/3,0,0,0,0,0/
	DATA gfcn_has_vari_args(p_dot) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_dot),i=1,nferdims)/
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args/
	DATA (gfcn_piecemeal_ok(i,p_dot),i=1,nferdims)
     .      / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
	DATA gfcn_arg_ptr(p_dot) /p_dot_arg_start/

* ... description of argument 1
	DATA gfcn_arg_name(p_dot_arg_start+0)/'VAR1'/
	DATA gfcn_arg_type(p_dot_arg_start+0)/parg_type_float/
	DATA gfcn_arg_units(p_dot_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_dot_arg_start+0)/'Variable 1'/
	DATA (gfcn_arg_extend_lo (i,p_dot_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_dot_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_dot_arg_start+0),i=1,nferdims)
     .    / .TRUE., .TRUE., .TRUE., .TRUE., .TRUE., .TRUE. /

     
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_substring_arg_start+0),i=1,nferdims)
     .    / .TRUE., .TRUE., .TRUE., .TRUE., .TRUE., .TRUE. /

* ... description of argument 2
	DATA gfcn_arg_name(p_dot_arg_start+1)/'VAR2'/
	DATA gfcn_arg_type(p_dot_arg_start+1)/parg_type_float/
	DATA gfcn_arg_units(p_dot_arg_start+1)/' '/
	DATA gfcn_arg_descr(p_dot_arg_start+1)/'Variable 2'/
	DATA (gfcn_arg_extend_lo (i,p_dot_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_dot_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 2 ?
	DATA (gfcn_axis_implied_from(i, p_dot_arg_start+1),i=1,nferdims)
     .    / .TRUE., .TRUE., .TRUE., .TRUE., .TRUE., .TRUE. /

* ... description of argument 3
	DATA gfcn_arg_name(p_dot_arg_start+2)/'IDIM'/
	DATA gfcn_arg_type(p_dot_arg_start+2)/parg_type_float/
	DATA gfcn_arg_units(p_dot_arg_start+2)/' '/
	DATA gfcn_arg_descr(p_dot_arg_start+2)/'Dimension (e.g.1,2,...)'/
	DATA (gfcn_arg_extend_lo (i,p_dot_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_dot_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 3 ?
	DATA (gfcn_axis_implied_from(i, p_dot_arg_start+2),i=1,nferdims)
     .    / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /

c-------------

* TRANSPOSE(var,dim1,dim2) - return transpose of variable in the two given directions
	INTEGER		p_transpose_arg_start, p_transpose_num_args
	PARAMETER     ( p_transpose_arg_start = p_dot_arg_start +
     .					    p_dot_num_args,
     .			p_transpose_num_args  = 3 )
	DATA gfcn_name         (p_transpose) /'TRANSPOSE'/
	DATA gfcn_alt_name_base (p_transpose) /'TRANSPOSE_%%'/
	DATA gfcn_version      (p_transpose) / 1.0 /
	DATA gfcn_descr        (p_transpose) /
     .	'Compute the transpose along two given dimensions' /
	DATA gfcn_rtn_type     (p_transpose) /pfcn_rtn_float /
	DATA gfcn_num_reqd_args(p_transpose) /p_transpose_num_args/
	DATA (gfcn_dir_args(i,p_transpose),i=1,nferdims)/2,3,0,0,0,0/
	DATA gfcn_has_vari_args(p_transpose) /.FALSE./
	DATA (gfcn_axis_will_be(i,p_transpose),i=1,nferdims)/
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args,
     .					pgc_axis_implied_by_args/
	DATA (gfcn_piecemeal_ok(i,p_transpose),i=1,nferdims)
     .      / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /
	DATA gfcn_arg_ptr(p_transpose) /p_transpose_arg_start/

* ... description of argument 1
	DATA gfcn_arg_name(p_transpose_arg_start+0)/'VAR'/
	DATA gfcn_arg_type(p_transpose_arg_start+0)/parg_type_float/
	DATA gfcn_arg_units(p_transpose_arg_start+0)/' '/
	DATA gfcn_arg_descr(p_transpose_arg_start+0)/'Variable to transpose'/
	DATA (gfcn_arg_extend_lo (i,p_transpose_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_transpose_arg_start+0),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 1 ?
	DATA (gfcn_axis_implied_from(i, p_transpose_arg_start+0),i=1,nferdims)
     .    / .TRUE., .TRUE., .TRUE., .TRUE., .TRUE., .TRUE. /

* ... description of argument 2
	DATA gfcn_arg_name(p_transpose_arg_start+1)/'DIM1'/
	DATA gfcn_arg_type(p_transpose_arg_start+1)/parg_type_float/
	DATA gfcn_arg_units(p_transpose_arg_start+1)/' '/
	DATA gfcn_arg_descr(p_transpose_arg_start+1)/'Dimension 1 for transpose (1,2,...)'/
	DATA (gfcn_arg_extend_lo (i,p_transpose_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_transpose_arg_start+1),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 2 ?
	DATA (gfcn_axis_implied_from(i, p_transpose_arg_start+1),i=1,nferdims)
     .    / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /

* ... description of argument 3
	DATA gfcn_arg_name(p_transpose_arg_start+2)/'DIM2'/
	DATA gfcn_arg_type(p_transpose_arg_start+2)/parg_type_float/
	DATA gfcn_arg_units(p_transpose_arg_start+2)/' '/
	DATA gfcn_arg_descr(p_transpose_arg_start+2)/'Dimension 2 for transpose (1,2,...)'/
	DATA (gfcn_arg_extend_lo (i,p_transpose_arg_start+2),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
	DATA (gfcn_arg_extend_hi (i,p_transpose_arg_start+2),i=1,nferdims)
     .    / 0, 0, 0, 0, 0, 0 /
* ... merge the axes implied by argument 3 ?
	DATA (gfcn_axis_implied_from(i, p_transpose_arg_start+2),i=1,nferdims)
     .    / .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /


* internal parameters helpful for initialization
	DATA gfcn_num_internal/p_transpose/

c-------------


* template for next function ...
	INTEGER		p_next, p_next_arg_start, p_next_num_args 
	PARAMETER     ( p_next = p_transpose + 1,
     .			p_next_arg_start = p_transpose_arg_start +
     .					   p_transpose_num_args,
     .			p_next_num_args  = 1 )

	END

	SUBROUTINE FILLPOL(X,NXS,XF,YF,fp_xfac,fp_yfac)
C** 
C**    @(#)fillpol.F	1.0    11/30/97
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C  ARRAY X HOLDS X AND Y'S FOR ALL LINES.  DIMENSIONED FOR NXS+npoly
C  ORDER AS FOLLOWS:  ALL X'S FOR LINE1, ALL X'S FOR LINE2,...
C                     STARTING AT X(NXS/2+1), ALL Y'S FOR LINE1,
C                     ALL Y'S FOR LINE2...
C  XF AND YF ARE FACTORS TO CONVERT TO INCHES FROM USER UNITS
C
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	*sh* 11/97 based on SHADESUB and PLOTXY
*
* *kob* 3/28/99 - declare subroutine range as external, otherwise F90 tries to
*                 use it as an intrinsic function - more cleanup work
* V510 *sh* 3/00 - changes to accomodate NPOLYGON > NLINES
*		 - involved eliminating CALL TRANS, which means that there
*			isn't a need to copy the X,y coords to x/ypolybase
* V510 4/00 *sh - corrected faulty logic for centered levels (delta wrong)
* V552 3/03 *acm* allow clipping to be set on or off via IWIND (ppl window off)
* V552 3/03 *acm* Check for too many levels, as is done for FILL and CONTOUR plots.
* V553 *acm*  6/03  For polygons, store the # of points in each polygon in the PPLUS
*                   memory buffer, rather than in lleng.  This way the number of
*                   polygons that may be plotted is unlimited. 
* v554 *acm*  2/04  After levels are set, call setlab_syms to set the LEVELS symbols

* v570  4/04*acm* Fix for the section marked correction for rounding errors. 
*                 Use TM_FPEQ_SNGL to see if values are equal or close.  Also fixes 
*                 this adjustment when the range has negative values; was incorrect.
* v580  8/04*acm* Fix bug 957 poly/lev=1 of a constant field needs zlev(1) to be set.
* v581 *acm* 3/05 open levels (-INF) (INF)
* V600 *acm* 8/06 Fix bugs 843, 844: poly/line and reversed axes. Apply xinv and
*                 yinv to coordinates when drawing the lines.
* V62  *acm* 5/09 Fixing bug 1661: if the plot is TRANSPOSED, then apply 
*                 xinv, yinv to the opposite axis.
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus
* V72  *acm* 6/17  PyFerret ticket 2542, check for zero-extent on polygons before
*                  calling graphics routines
* V74  *acm* 1/18  Fixing issue 1009: scaling of polygons overlaid on time plot
*                  when rescaling time for precision.
* V745 *acm* 3/19  The fix for 2542 (issue 1814) needs to be applied only for
*                  filled polygons in PyFerret.


        include         'xinterrupt.cmn' ! 1/89 *sh*
        include         'ppl_in_ferret.cmn'

        INTEGER NXS
	REAL X(*), XF, YF, fp_xfac, fp_yfac

        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'axis_inc.decl'
        include 'AXIS.INC'
        include 'switch_inc.decl'
        include 'SWITCH.INC'
        include 'lines_inc.decl'
        include 'LINES.INC'
        include 'pen_inc.decl'
        include 'PEN.INC'
        include 'pltl_inc.decl'
        include 'PLTL.INC'
        include 'miss_inc.decl'
        include 'MISS.INC'
        include 'hd_inc.decl'
        include 'HD.INC'
        include 'taxis_inc.decl'
        include 'TAXIS.INC'
        include 'axisl_inc.decl'
        include 'AXISL.INC'
        include 'cmrd_inc.decl'
        include 'CMRD.INC'
        include 'cmrdl_inc.decl'
        include 'CMRDL.INC'
        include 'gkscm1_inc.decl'	! sh 11/97
        include 'GKSCM1.INC'		! sh 11/97
!        include 'gkscm2.cmn' ! jd 3.22.89
        include 'gkspar.inc'	! sh 11/97
        include 'shade_vars.cmn'	! sh 11/97
	include		'cont_inc.decl'
	include		'CONT.INC'
        include         'errmsg.parm'
	include 'PPLDAT.INC'		! with ibase
	include 'vector_inc.decl' ! with TRANSPZ
        include 'VECTOR.INC'


* 3/99 *kob*
	EXTERNAL RANGE

	INTEGER xpolybase, ypolybase, zpolybase, polysizemax, nl,
     .		nvertex, fill_ndx, xvertexbase			! 11/97

	INTEGER GET_NDX

* GKS initialization vars
* v491 *kob* removed unnecessary variable declarations
	integer		error,trans_no,cflag
        integer         my_trans
        data            my_trans/20/
	real	 	w(4),v(4),ndc(4),uc(4)
	real		xinv,yinv, tmp

*jd*
	real            zzmin, zzmax
	integer         status, nlm1
	real		dz,znp,zmp, x1val, y1val, xdel, ydel, vlo, vhi
	integer		i,j,uprdn, llen, ptsbase
	logical         line_it, fill_it
        integer         slen1, slen2
        CHARACTER       TM_FMT*48, buff1*20, buff2*20, err_msg*40

        parameter       (epsilon = 1e-6)

*************************************

C       Check switches
	line_it = sline
	
	if (sline .and. sfill) then
	   fill_it = .true.
	else if (sline .and. .not. sfill) then
	   fill_it = .false.
	else
	   fill_it = .true.
	end if

* INITIALIZE
	nl = lnum - 1	! # lines over which to loop: last line is color info

* determine temp memory buffer location for points translated to plot coords
* ... layout is xline1, xline2, ..., xlinenl, xcolor , bufferspace ...
*               yline1, yline2, ..., ylinenl, ycolor , bufferspace ...
*     "zpolybase" is the offset to the ycolor array
	xpolybase = 1
        ptsbase = ibase - lnum 
	DO 2010  I=1,nl
        llen = x(ptsbase+i-1)
 2010	xpolybase = xpolybase+llen

        llen = x(ibase-1)      ! Length of color array

	zpolybase = ptsbase - llen - 1 + nxs/2
	xpolybase = xpolybase + llen	! skip past color array
	ypolybase = xpolybase + nxs/2

        xvertexbase = xpolybase + lnum	! skip past list of lengths

	polysizemax = nxs - ypolybase	! unused buffer space
	fill_ndx = 0

* set up GKS environment (code copied from SHADE_SUB)

*	GET PROPER SCALING, NDC COORDINATES, ETC FOR FILL
	call gqcntn (error,trans_no)
	if (error .ne. 0) goto 1100

	call gqnt (trans_no,error,w,v)
	if (error .ne. 0) goto 1100

	call get_user_coords (w,v,ndc,uc,xinv,yinv)
	
* Fixing bug 1661: if the plot is TRANSPOSED, then apply this
* fix to the opposite axis.

	IF (trnspz) THEN
	   tmp = xinv
	   xinv = yinv
	   yinv = tmp
	ENDIF

*	NOW SET THE CLIPPING RECTANGLE AROUND THEM AND PATTERN SIZE
* v4.91 *kob* had to add <cr> after first line below

	call gswn (my_trans,uc(1)*xinv,uc(2)*xinv,uc(3)*yinv,uc(4)*yinv)
        call gsvp (my_trans,ndc(1),ndc(2),ndc(3),ndc(4))
	if (fill_it) call gselnt (my_trans)

	call gqclip (error,cflag,ndc)
	call gqclip (error,cflag,ndc)
	if (error .ne. 0) goto 1000
	if (cflag .NE. iwind) call gsclip (iwind)

*************************************

* original PLOT+ code 
	IBASE=0
	IY=NXS/2
	ZT=YF/XF
	ICNT=1
	IF(M.GE.2.AND.IFLG(2).NE.0)ICNT=P(2)

C *jd* 
* FIND LIMITS
	zmin = 1e33
	zmax = -1e33
	zzmin = 1e33
	zzmax = -1e33
	nlm1  = nl - 1

cc	do 100 i = 0, nlm1 	      
cc	   if (ZEQ.AND.x(zpolybase+i).EQ.CMZEQ) GOTO 100
cc	   if (x(zpolybase+i) .gt. zzmax) zzmax = x(zpolybase+i)
cc	   if (x(zpolybase+i) .lt. zzmin) zzmin = x(zpolybase+i)
cc 100	end do

	do 100 i = 0, nlm1 	      
	   if (ZEQ.AND.x(zpolybase+1+i).EQ.CMZEQ) GOTO 101
	   if (x(zpolybase+1+i) .gt. zzmax) zzmax = x(zpolybase+1+i)
	   if (x(zpolybase+1+i) .lt. zzmin) zzmin = x(zpolybase+1+i)
 101       continue
 100	end do

        IF (zzmin .NE. 1e33) zmin = zzmin  ! Needed for annotating open-ended levels
        IF (zzmax .NE. -1e33) zmax = zzmax

C  Set the contour/color levels
C  ... here we need to call SET_LEVELS_SHADE_FILL if IAUTOC EQ 0 -- levs have been
C      set already.

        IF (IAUTOC .EQ. 0 .OR. 
     .      ((zzmin .NE. 1e33) .AND. (zzmax .NE. -1e33)) ) THEN
           CALL SET_LEVELS_SHADE_FILL (status)
           IF (status .NE. ferr_ok) GOTO 5000
	ELSE
	   IF (sover) THEN
	      IF (zzmin .EQ. 1e33) zmin = 1e36
	      IF (zzmax .EQ. -1e33) zma x= CMZLE - 10
	      CALL SET_LEVELS_SHADE_FILL (status)  !?
	   ENDIF 
	ENDIF

*	DETERMINE PATTERNS OR COLORS TO SET BUNDLED FILL AREA REPRESENTATIONS

*       Allow shading single level fields 
        if (nlev2 .lt. 1) goto 1000
        shd_levels = max (nlev2 - 1,1)

	call set_fill_area_rep (wsid,wstype)

	CALL MARKH(HMARK(1))
	CALL COLOR(IPEN(1))

******** LOOP OVER LINES STORED

	DO 200 I=1,nl
          llen = x(ptsbase+i-1)
* will this polygon fit in the buffer?
	  IF (llen .GT. polysizemax) THEN
	     WRITE (6,*) 'Too much polygon data to plot at once'
	     GOTO 200
	  ENDIF 

* assemble the vertices into arrays in units of plot coordinates
* note: all points in the polygon are guaranteed to be "valid"
	   nvertex = 0
 
* Check that the polygon has a nonzero size in both directions
* PyFerret fails e.g. on a zero-height rectangle. This is not a 
* perfect test but will catch most cases.
* The check is needed only for FILLED polygons.  If using POLY to 
* draw an outline then a zero height or width is ok.

           x1val = x(IBASE+1)
           y1val = x(iy+IBASE+1)
          xdel = 0.
          ydel = 0.

	   DO 150 J=IBASE+1,IBASE+llen
	      nvertex = nvertex + 1
	      x(xvertexbase+nvertex-1) = x(j)
	      x(ypolybase+nvertex-1) = x(iy+j)
              IF (j .GT. ibase+1) THEN
                xdel = MAX( xdel, ABS(x1val-x(j)) )
                ydel = MAX( ydel, ABS(y1val-x(iy+j)) )
              ENDIF

 150	   CONTINUE

	   if (fill_it) then

	      IF (xdel.LT.epsilon .OR. ydel.LT.epsilon) GOTO 157

*             Determine the color index for the fill
	      if (ZEQ.AND.x(zpolybase+i).EQ.CMZEQ) GOTO 157

	      fill_ndx = GET_NDX (x(zpolybase+i),fill_ndx)
	      if (fill_ndx .eq. -999) goto 157

*             Draw the filled polygon
	      CALL SET_FILL_NDX (fill_ndx)

* Rescale the polygons if time-data has been scaled for precision.
* the scaling accounts for the range of the polygon data, needs
* to be widened if overlaying on a longer time axis.

	      IF ( XEQ ) THEN 
	         do 155 j = xvertexbase, xvertexbase+nvertex-1
	            IF (X(J).EQ.CMXEQ) GOTO 157
 155	         continue
	         IF (fp_xfac .NE. 1.) THEN 
	            CALL MINMAX_SNGL( X(xvertexbase), nvertex, CMXEQ, vlo, vhi)
	            do j = xvertexbase, xvertexbase+nvertex-1
	               x(j) = x(j) + (x(j)-vlo)*fp_xfac
	            enddo
	         ENDIF
	      ENDIF

	      IF ( YEQ ) THEN 
	         do 156 j = ypolybase, ypolybase+nvertex-1
	            IF (X(J).EQ.CMYEQ) GOTO 157
 156	         continue
	         IF (fp_yfac .NE. 1.) THEN 
	            CALL MINMAX_SNGL( X(ypolybase), nvertex, CMYEQ, vlo, vhi)
	            do j = xvertexbase, xvertexbase+nvertex-1
	               x(j) = x(j) + (x(j)-vlo)*fp_yfac
	            enddo
	         ENDIF
	      ENDIF

	      if (nvertex .gt. 2) then
		 if (line_it) call gselnt (my_trans)
		 CALL GFA(nvertex, x(xvertexbase), x(ypolybase)) 
	      end if
	   end if

 157	   if (line_it) then
*             Outline the polygon

	      nvertex = 0
	      DO 158 J=IBASE+1,IBASE+llen
		 nvertex = nvertex + 1
		 IF (XEQ.AND.X(xvertexbase+nvertex-1).EQ.CMXEQ) GOTO 199
		 IF (YEQ.AND.X(ypolybase+nvertex-1).EQ.CMYEQ) GOTO 199
 158	      CONTINUE

	      if (fill_it) call gselnt (trans_no)
	      nvertex = 0

	      DO 160 J=IBASE+1,IBASE+llen
		 nvertex = nvertex + 1
		 if (nvertex .eq. 1) then
		    uprdn = 0
		 else
		    uprdn = 1
		 end if
		 call plot (xinv*x(xvertexbase+nvertex-1),
     .	                    yinv*x(ypolybase+nvertex-1),uprdn,0)
 160	      continue
	      call plot (xinv*x(xvertexbase), yinv*x(ypolybase),1,0)
	   end if

	   if (interrupted) go to 1000 !*jd* 8.3.92
 199    IBASE=IBASE+llen	! prepare for next line
 200	CONTINUE

******** END OF LOOP OVER LINES STORED


* ... restore GKS transforms following FILLPOL 
 1000	call gsclip (cflag)
	call gselnt (trans_no)

* ... and DO THE KEY
	if (fill_it .and. do_key .AND. .NOT.interrupted) then
	   call color(ipen(0))
	   call key
	end if

 1100	CALL COLOR(IPEN(0))

* We use lnum as a counter, but we do not use the lleng array
* or other contstructs that used to treat each polygon as a plot line.
 
        lnum = 1

	RETURN

C  Error exit when too many levels specified.
C  Arrays LWGT, LDIG, and ZLEV are length ICNLEV=500

 5000   ii = ICNLEV
        buff1 = TM_FMT(DBLE(ICNLEV), 0, 20, slen1)
        buff2 = TM_FMT(DBLE(NLEV2), 0, 20, slen2)
        err_msg = '# of levels > '// buff1(1:slen1) //
     .          '  (' // buff2(1:slen2) // ')'
        CALL errmsg (ferr_out_of_range, status, err_msg, *5002)
 5002   return

	END

*
* days1900toymdhms.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Steve Hankin
* Jan, 2001
*
* 12/12/02 *acm* bug fix: define the REAL*8 parameter  psecsto1900 using a 
*                double precision constant .D0; the constant lost precision
*                under linux.

* This function converts a Julian day from 1-jan-1900 to a trio of 3 values
* on the Z axis: year, month, day

* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE days1900toymdhms_init (id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc (id,
     .   'Convert Julian day to values y,m,d,h,m,s on k=1,...,6' )

      CALL ef_set_num_args(id, 1)

      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, 
     .                                 ABSTRACT,        IMPLIED_BY_ARGS)

      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      CALL ef_set_num_work_arrays(id, 0)


      arg = 1
      CALL ef_set_arg_name (id, arg, 'day1900')
      CALL ef_set_arg_unit(id, arg, 'none')
      CALL ef_set_arg_desc(id, arg,
     .         'Julian day counted from 1-jan-1900')
      CALL ef_set_axis_influence (id, arg, YES, YES, NO, YES)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN 
      END


*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE days1900toymdhms_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

* 3 output values: year, month, day 
        CALL EF_SET_AXIS_LIMITS(id, Z_AXIS, 1, 6)
        
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END



*
* In this subroutine we compute the result
*
      SUBROUTINE days1900toymdhms_compute (id, arg_1, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id
      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .     mem1lot:mem1hit)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)
 

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

        INTEGER i, j, k, l, k1, yr, mon, day, hr, min
        REAL sec
        REAL*8 num_secs

        REAL*8  psecsto1900  ! seconds from 1-jan-0000 to 1-jan-1900
        PARAMETER ( psecsto1900 = 59958230400.D0 )

* get the subscripting limits and flags
        CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
        CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
        CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* check to make sure that we were not passes a span along the Z axis
        IF (arg_lo_ss(Z_AXIS,1) .NE.  arg_hi_ss(Z_AXIS,1)) CALL
     .          EF_BAIL_OUT(id, 'Cannot handle a Z range on argument') 

* loop over all of the input values
        k1 = arg_lo_ss(Z_AXIS,1)
        DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
          DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
              DO 100 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)


                 IF ( arg_1(i,j,k1,l) .EQ. bad_flag(1) ) THEN

                    DO 90 k = 1, 6
 90                 result(i,j,k,l) = bad_flag_result

                 ELSE

                    num_secs = 24.D0*60.D0*60.D0 * arg_1(i,j,k1,l)
     .                       + psecsto1900
                    CALL SECS_TO_YMDHMS( num_secs,
     .                                   yr, mon, day, hr, min, sec )
                    result(i,j,1,l) = FLOAT(yr)
                    result(i,j,2,l) = FLOAT(mon)
                    result(i,j,3,l) = FLOAT(day)
                    result(i,j,4,l) = FLOAT(hr)
                    result(i,j,5,l) = FLOAT(min)
                    result(i,j,6,l) = sec

                 END IF


 100        CONTINUE
 300      CONTINUE
 400    CONTINUE


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN 
      END

	DOUBLE PRECISION FUNCTION TDEST_CONVERT( tstep )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* convert a time step value to a new time encoding using slope and offset
* that were set up by TDEST_WORLD_INIT
* This routine exists to optimize performance in converting between time axes

* The conversion process is simply based on the fact that each time axis is
* a slope (units) and an intercept (T0)
* Let
*	A - absolute time (seconds since BC)
*	U - units (slope)
*	T - axis-relative time
* so that
*	AT0src - is the absolute time of T0 on the source axis
*	AT0dst - equivalently on the destination axis
* Then
*	Tsrc = (A-AT0src) / Usrc
*	Tdst = (A-AT0dst) / Udst
* from which
*	Tdst = Tsrc*(Usrc/Udst) + (AT0src-AT0dst)/Udst 
* or in terms of the COMMON variables
*	Tdst = Tscr*tcnvrt_slope + tcnvrt_intercept

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V720: *sh* 5/17 - the code here lifted untouched from TDEST_WORLD

	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xregrid.cmn'

* calling argument declarations:
	REAL*8 tstep

* internal variable declarations:
        INTEGER status

* special treatment of calendar time axis
        IF ( tcnvrt_ok  ) THEN
	   TDEST_CONVERT = tstep * tcnvrt_slope + tcnvrt_intercept
	ELSE
	   CALL WARN('Time axis conversion not properly initialized')
	   TDEST_CONVERT = unspecified_val8  ! untested - likely to cause crash
	ENDIF

 5000	RETURN
	END

      SUBROUTINE MARK(IMARK)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

*  8/2001  acm  for PLOT/SYMBOL=DOT, call makedot
*      *acm* 10/01  remove VMS includes

*
C**    @(#)mark.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
      CHARACTER IMODE*1
      LOGICAL LARGE
C
C     THE NEXT LINE IS MACHINE DEPENDENT AND MAY BE REPLACED BY
C     INTEGER MRKTAB(2,44),TABT(200)
      INTEGER*2 MRKTAB(2,44),TABT(200)
C
	include 'PLTCOM.DAT'

      DATA MRKTAB/    5,   9,  11,  15,  14,  15,  11,  12,
     *               26,  31,  32,  37,  38,  43,  44,  49,
     *                1,   5,  64,  67,   5,  15,  50,  54,
     *                1,   9,  55,  63,  15,  19,  21,  25,
     *               50,  53,  51,  54,  72,  77,  84,  98,
     *               18,  22,  11,  19,  64,  66,  68,  71,
     *               68,  70,  78,  83, 102, 106, 113, 118,
     *              119, 124, 125, 130, 131, 136, 105, 110,
     *              107, 112, 137, 139,  99, 106, 103, 108,
     *              140, 144, 140, 147, 156, 163, 148, 155,
     *              170, 183, 184, 189, 188, 193, 164, 169/
C
	DATA TABT/9,41,45,13,9,45,0,13,41,0,
     *25,29,0,11,43,29,11,25,43,11,25,29,11,43,29,18,27,34,0,27,
     *24,20,27,36,0,27,30,20,27,18,0,3,27,36,27,34,0,27,51,41,
     *13,45,9,41,4,2,16,32,50,52,38,22,4,9,29,41,9,13,25,45,
     *13,13,27,31,0,27,45,9,27,29,0,27,41,13,20,18,9,0,18,34,
     *0,20,36,0,45,36,34,41,19,35,0,21,17,33,37,21,19,35,33,17,
     *21,37,20,29,25,0,17,33,21,37,35,19,17,33,21,37,19,35,33,17,
     *21,19,43,0,37,33,21,37,25,12,44,0,42,10,0,17,37,26,30,0,
     *12,44,0,8,40,13,45,0,43,11,0,9,41,4,41,30,9,52,4,12,
     *20,21,13,12,0,9,45,0,33,41,42,34,33,14,44,10,0,9,41,0,
     *42,12,46,0,0,0,0,0,0,0/
C
C     CHECK THE DATA MARK CODE.  For PLOT/DOT, call makedot to call POLYMARK
C
      IF (IMARK .EQ. 99) CALL makedot

      IF(IMARK .LT. 1 .OR. IMARK .GT. 88)RETURN
C
C     DETERMINE THE SIZE OF THE DATA MARK AND ITS CODE.
C
      JMARK = (IMARK + 1) / 2
      LARGE = .FALSE.
      IF(2 * JMARK .EQ. IMARK)LARGE = .TRUE.
C
C     GET CONTROL INFORMATION FROM THE POINTER TABLE.
C
      IPOINT = MRKTAB(1,JMARK)
      ILAST = MRKTAB(2,JMARK)
C
C     SAVE THE CURRENT PLOTTING POSITION AS THE REFERENCE POINT.
C
      XREF = XTEMP
      YREF = YTEMP
C
C     SET VECTORS MODE.
C
      IMODE = PMODE
      PMODE = VECTOR
C
C     LIFT THE PEN BEFORE DRAWING THE FIRST LINE SEGMENT.
C
      PENF = .FALSE.
C
C     DRAW THE DATA MARK.
C
      DO 10 IPT=IPOINT,ILAST
      IB = TABT(IPT)
C
C     CHECK FOR NO DISPLACEMENT.  THIS INDICATES THAT THE PEN IS
C     TO BE LIFTED BEFORE DRAWING THE NEXT LINE SEGMENT.
C
      IF(IB .EQ. 0)THEN
        PENF = .FALSE.
      ELSE
C
C     CALCULATE THE DISPLACEMENT FROM THE REFERENCE POINT.
C     FOR SPEED WE HAVE CODED THE NEXT TWO LINES USING THE NON STANDARD
C     AND AND RS FUNCTIONS.  HOWEVER THESE LINES COULD BE REPLACED BY
C
#ifdef unix
# ifdef NEED_IAND
	movex = ishft(ib,-3) -3
	movey = iand(ib,7) -3
# else
	movex = rshift(ib,3) - 3
        MOVEY = AND(IB,7) - 3
# endif
#else
	movex = ishft(ib,-3) -3
	movey = iand(ib,7) -3
#endif
C
C     IF THE DATA MARK IS LARGE, DOUBLE THE DISPLACEMENT.
C
        IF(LARGE)THEN
          MOVEX = 2 * MOVEX
          MOVEY = 2 * MOVEY
        ENDIF
C
C     CALCULATE THE NEW POINT.
C
        XTEMP = HMARK * FLOAT(MOVEX) + XREF
        YTEMP = HMARK * FLOAT(MOVEY) + YREF
C
C     PLOT TO THE POINT.
C
        CALL XYZPLT
        PENF = .TRUE.
      ENDIF
   10 CONTINUE
C
C     RESTORE THE CURRENT PLOTTING POSITION.
C
      XTEMP = XREF
      YTEMP = YREF
      PENF = .FALSE.
      CALL XYZPLT
C
C     RESTORE THE CURRENT PLOTTING MODE.
C
      PMODE = IMODE
      RETURN
C
      END

*
*  ave_scat2grid_t.F
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without anx fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and anx derivative works thereof, and
*  its supporting documentation for anx purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in anx publications that result from
*  the use of this software or in anx product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in anx advertising or publicity to endorse or promote anx products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with anx support, consulting,
*  training or assistance of anx kind with regard to the use, operation
*  and performance of this software nor to provide the user with anx
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND Anx EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR Anx SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR Anx DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* Sep 2004

* Inputs are a set of T coordinates and a variable on an abstract axis, and an 
* output time axis. Returns a time series which is the average of the variable, 
* based on the number of points that fall inside of each T cell. 
* From scat2grid_t.F

*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE  ave_scat2grid_t_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     . 'Compute average of a variable in each cell of output time axis')
      CALL ef_set_num_args(id, 3)
      CALL ef_set_axis_inheritance_6d(id,
     .                                NORMAL, NORMAL,
     .                                NORMAL, IMPLIED_BY_ARGS,
     .                                NORMAL, NORMAL)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 3)

* output grid is determined by argument 3. 

      arg = 1
      CALL ef_set_arg_name(id, arg, 'TPTS')
      CALL ef_set_arg_desc(id, arg, 
     .        'T coordinates of scattered input time coordinates')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'VPTS')
      CALL ef_set_arg_desc(id, arg, 
     .        'Variable at times in TPTS')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'TAXIS')
      CALL ef_set_arg_desc(id, arg, 
     .        'Output time axis')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, YES, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN 
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE ave_scat2grid_t_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER ntout, nt2

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      ntout = 1 + arg_hi_ss(T_AXIS,ARG3) - arg_lo_ss(T_AXIS,ARG3)

* doubled in case REAL is REAL*4
      nt2 = 2 * ntout

* taxlo  output t axis box lower limits
      CALL ef_set_work_array_dims_6d(id, 1,
     .                                1, 1, 1, 1, 1, 1,
     .                              nt2, 1, 1, 1, 1, 1)

* taxhi  output t axis box upper limits
      CALL ef_set_work_array_dims_6d(id, 2,
     .                                1, 1, 1, 1, 1, 1,
     .                              nt2, 1, 1, 1, 1, 1)

* counts 
      CALL ef_set_work_array_dims_6d(id, 3, 
     .                                1, 1, 1, 1, 1, 1,
     .                            ntout, 1, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*

      SUBROUTINE ave_scat2grid_t_compute(id, arg_1, arg_2, arg_3,
     .                               result, taxlo, taxhi, counts)

*  arg_1  tpts  Scattered t values to be gridded.
*  arg_2  vpts  Scattered fcn values to be gridded.
*  arg_3  taxis to use for output

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* Ignore the unused final dimensions in the work arrays since
* Fortran is column major
      REAL*8 taxlo(wrk1lox:wrk1hix/2)
      REAL*8 taxhi(wrk2lox:wrk2hix/2)
      REAL counts(wrk3lox:wrk3hix)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l, m, n
      INTEGER idx, lo_ss, hi_ss, l1
      INTEGER ntpts, nvpts, ntgrid
      REAL tt, vv
      CHARACTER*250 errtxt

*  variables for checking axis characteristics (modulo axes)
      CHARACTER ax_name(6)*16, ax_units(6)*16
      LOGICAL backward(6), mdulo(6), regular(6)
      LOGICAL modulot
      REAL*8 modtlen

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*  Check to see if output axis is modulo (does not need to be regular)
      CALL ef_get_axis_info_6d(id, ARG3, ax_name, ax_units,
     .                         backward, mdulo, regular)
      modulot = mdulo(T_AXIS)
      IF ( modulot ) THEN
         CALL ef_get_axis_modulo_len(id, ARG3, T_AXIS, modtlen)
      ENDIF

*  Find number of points in scattered input points.  1-D arrays defining
*  the scattered data points may lie on any axis of the input argument.
*  Using as flattened arrays, so consider all axes.

      ntpts = 0
      DO 40 idx = X_AXIS, F_AXIS
         lo_ss = arg_lo_ss(idx,ARG1)
         hi_ss = arg_hi_ss(idx,ARG1)
         IF ( lo_ss .NE. ef_unspecified_int4 ) THEN
            IF ( ntpts .NE. 0 ) THEN
               ntpts = ntpts * (hi_ss - lo_ss + 1)
            ELSE
               ntpts = hi_ss - lo_ss + 1
            ENDIF
         ENDIF
  40  CONTINUE

* Check that arguments 1 and 2 have the same number of values

      nvpts = 0
      DO 80 idx = X_AXIS, F_AXIS
         lo_ss = arg_lo_ss(idx,ARG2)
         hi_ss = arg_hi_ss(idx,ARG2)
         IF ( lo_ss .NE. ef_unspecified_int4 ) THEN
            IF ( nvpts .NE. 0 ) THEN
               nvpts = nvpts * (hi_ss - lo_ss + 1)
            ELSE
               nvpts = hi_ss - lo_ss + 1
            ENDIF
         ENDIF
  80  CONTINUE

      IF ( nvpts .NE. ntpts ) THEN
         errtxt = 'TPTS and VPTS have different number of values'
         GOTO 999
      ENDIF
      IF ( nvpts .EQ. 0 ) THEN
         errtxt = 'No data in TPTS and VPTS'
         GOTO 999
      ENDIF

*  Check tax is a T axis

      lo_ss = arg_lo_ss(T_AXIS,ARG3)
      hi_ss = arg_hi_ss(T_AXIS,ARG3)
*  Check that tax a T axis
      IF ( lo_ss .EQ. ef_unspecified_int4 ) THEN
         errtxt = 'Third argument must be a T axis'
         GO TO 999
      ENDIF
      ntgrid = hi_ss - lo_ss + 1

*  Get cell boundaries

      CALL ef_get_box_limits(id, ARG3, T_AXIS, arg_lo_ss(T_AXIS, ARG3),
     .                       arg_hi_ss(T_AXIS, ARG3), taxlo, taxhi)

*  Compute result

      i = res_lo_ss(X_AXIS)
      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      m = res_lo_ss(E_AXIS)
      n = res_lo_ss(F_AXIS)

*  Initialize result

      DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         result(i,j,k,l,m,n) = 0.
      ENDDO

*  Initialize counts

      DO l1 = 1, ntgrid
         counts(l1) = 0.
      ENDDO

*  Loop over input tpts

      DO 700 idx = 1, ntpts

         CALL pickout2(arg_1, arg_2, idx, tt, vv)
         IF ( tt .EQ. bad_flag(ARG1) .OR. vv .EQ. bad_flag(ARG2) ) THEN
            GOTO 700
         ENDIF

*  If an output axis is modulo, apply modulo adjustment to that coordinate
*  of the scattered point.
         IF ( modulot ) THEN
            CALL modscat(taxlo(1), taxhi(ntgrid), modtlen, 1, tt)
         ENDIF

         l1 = 1
         DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

            IF ( tt .GE. taxlo(l1) .AND. tt .LE. taxhi(l1) ) THEN
               result(i,j,k,l,m,n) = result(i,j,k,l,m,n) + vv
               counts(l1) = counts(l1) + 1.0
*              Location found and point assigned; go to the next scatter point
               GOTO 700
            ENDIF

            l1 = l1 + 1
 400     CONTINUE

 700  CONTINUE

* Compute average

      l1 = 1
      DO 410 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         IF ( counts(l1) .GT. 0.0 ) THEN
           result(i,j,k,l,m,n) = result(i,j,k,l,m,n) / counts(l1)
         ELSE
           result(i,j,k,l,m,n) = bad_flag_result
         ENDIF

         l1 = l1 + 1
 410  CONTINUE

      RETURN

 999  CALL EF_BAIL_OUT(id, errtxt)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN
      END

	SUBROUTINE PPLLDC(K,Z,MX,MY,IMN,IMX,JMN,JMX,
     *		PI,PJ,NX1,NY1,XMIN1,YMIN1,DX1,DY1,pplmem)
#ifdef double_p
	REAL*8 PI(*),PJ(*),Z(MX,MY),DX1,DY1
#else
	REAL PI(*),PJ(*),Z(MX,MY)
#endif
	REAL pplmem(*)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)pplldc.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C              Mod *sh* 4.1.91 Bug fix in PPLLDV fixed, see below
C              Mod *sh* 5.15.91 dx,dy put into common block
C              Mod *sh* 3.7.97 *sh* replace limits if curvilinear plot
* V54 *acm*9/01 - changes for dynamic pplus buffer, call PPLLDC via pplldc_envelope.c
*                  which checks pplmem_nsize (new name for NSIZE) and allocates 
*                  more if needed.
*      *acm* 10/01  remove VMS includes* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus
c
c	k	=0 already on an equally spaced rectangular grid
c		=1 on a unequally spaced, but rectangular grid
c	z	input array
c	mx	dimensioned x size of z(mx,my)
c	my	dimensioned y size of z
c	imn	initial x index value
c	imx	final x index value
c	jmn	initial y index value
c	jmx	final y index value
c	pi	x positions pi(mx)
c	pj	y positions pj(my)
c	nx1	number of x grid points in output buffer
c	ny1	number of y grid points in output buffer
c	xmin1	position of 1,1 in output grid
c	ymin1	position of 1,1 in output grid
c	dx	spacing of x grid points in output buffer
c	dy	spacing of y grid points in output buffer
C
C
C
	INCLUDE 'PARAMPL5.DAT'
	INCLUDE 'ZGRID.INC'
	INCLUDE 'ZGRIDD.INC'
	INCLUDE 'MISS.INC'
	INCLUDE 'LINES.INC'
	INCLUDE 'PPLDAT.INC'
	INCLUDE 'HD.INC'
	INCLUDE 'DATA.INC'
	INCLUDE 'cont_inc.decl'
	INCLUDE 'CONT.INC'

	LOGICAL		ITS_CURVILINEAR
	REAL		xmn, xmx, ymn, ymx

	COMMON/LDDXDY/ DX,DY
C
	call rsmnmx
	JTYPE=0
	NX=NX1
	NY=NY1
	DX=DX1
	DY=DY1
	XMIN=XMIN1
	YMIN=YMIN1
	IF(K.EQ.1)THEN
	    JTYPE=2
	    XMIN=PI(1)
	    XMAX=PI(MX)
	    YMIN=PJ(1)
	    YMAX=PJ(MY)
	    NX=MX
	    NY=MY
	    DO 100 I=IMN,IMX
	    DO 100 J=JMN,JMX
100		pplmem(NX*(J-1)+I)=Z(I,J)
	    IV=NX*NY
	    DO 101 I=1,NX
101		pplmem(IV+I)=PI(I)
	    IV=IV+NX
	    DO 102 J=1,NY
102		pplmem(IV+J)=PJ(J)
C
	ELSE
C
C	DATA ALREADY GRIDDED
C
	    NX=IMX-IMN+1
	    NY=JMX-JMN+1
	    XMAX=XMIN+DX*(NX-1)
	    YMAX=YMIN+DY*(NY-1)
	    I=0
	    DO 400 II=IMN,IMX
	    I=I+1
	    J=0
	    DO 400 JJ=JMN,JMX
	    J=J+1
	    pplmem(NX*(J-1)+I)=Z(II,JJ)
400	    CONTINUE
	ENDIF
	linen=0
*
* for a curvilinear plot the apparent min/max, which are in fact the min/max
* index values, are wrong -- set symbols based on the true axis ranges
	IF ( ITS_CURVILINEAR() ) THEN
	   CALL GET_CURVILINEAR_LIMITS( xmn, xmx, ymn, ymx )
	   call stmnmx(pplmem,pplmem_nsize,xmn,xmx,ymn,ymx)
	ELSE
	   call stmnmx(pplmem,pplmem_nsize,xmin,xmax,ymin,ymax)
	ENDIF

	RETURN
        end

	SUBROUTINE PPLLDV(K,Z,MX,MY,IMN,IMX,JMN,JMX,pplmem)
!	ENTRY PPLLDV(K,Z,MX,MY,IMN,IMX,JMN,JMX)
! ... start of copied from pplldc

	INCLUDE 'PARAMPL5.DAT'
	INCLUDE 'ZGRID.INC'
	INCLUDE 'ZGRIDD.INC'
	INCLUDE 'MISS.INC'
	INCLUDE 'LINES.INC'
	INCLUDE 'PPLDAT.INC'
	INCLUDE 'HD.INC'
	INCLUDE 'DATA.INC'

        REAL pplmem(*)

#ifdef double_p
	REAL*8 Z(MX,MY)
#else
	REAL Z(MX,MY)
#endif

	COMMON/LDDXDY/ DX,DY
! ... end of copied from pplldc

C
C	LOAD THE SECOND SET OF GRID INFORMATION FOR VECTOR PLOTS
C	OR FIRST SET OF COORDINATES FOR CURVILINEAR PLOTS
C
	IF(.NOT.(JTYPE.EQ.0.OR.JTYPE.EQ.2))RETURN
	call rsmnmx
	JTYPE=-1
	IVLEN=NX*NY
	IF(K.EQ.1)THEN
	    JTYPE=-2
	    IVLEN=NX*NY+NX+NY
	    DO 500 I=IMN,IMX
	    DO 500 J=JMN,JMX
500	    pplmem(IVLEN+NX*(J-1)+I)=Z(I,J)
	    IV=IVLEN+NX*NY
	    DO 501 I=1,NX
!501	    pplmem(IV+I)=PI(I)           ! illegal use of PI (not passed)
501	    pplmem(IV+I)=pplmem(NX*NY+i) ! reuse coords from PPLLDC
	    IV=IV+NX
	    DO 502 J=1,NY
!502	    pplmem(IV+J)=PJ(J)              ! illegal use of PJ (not passed)
502	    pplmem(IV+J)=pplmem(NX*NY+nx+j) ! reuse coords from PPLLDC
	ELSE
C
C	DATA ALREADY GRIDDED
C
	    NX=IMX-IMN+1
	    NY=JMX-JMN+1
	    XMAX=XMIN+DX*(NX-1)
	    YMAX=YMIN+DY*(NY-1)
	    I=0
	    DO 700 II=IMN,IMX
	    I=I+1
	    J=0
	    DO 700 JJ=JMN,JMX
	    J=J+1
	    pplmem(IVLEN+NX*(J-1)+I)=Z(II,JJ)
700	    CONTINUE
	ENDIF
	linen=0
	call stmnmx(pplmem,pplmem_nsize,xmin,xmax,ymin,ymax)
	RETURN
	END

	SUBROUTINE RIBBON_PLOT_SET_UP (versus, nvars, addgaps, thick, 
     .		overlay, spectrum, status)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - SDIG program
* 4/24/2018

* Set up for making ribbon-style plots, colored by a variable. Extracted from  
* xeq_plot, and with additions for plotting trajectoriesas ribbon plots.

* V74+ 4/18 *acm*  Automatically do a colored trajectory plot for the command 
*                  "PLOT var" if it's a DSG trajectory set. 
* V74+ 4/18 *acm*  Call RIBBON_PLOTKEY_SETUP to handle setting up the color key 
* V7.5+ *acm*  4/18 PLOT/VS plots from DSG data that are not native-trajectory plots
* V751 7/19 *acm*  DSG-enabled Ferret: change to call of CHECK_PLOT_TRAJ

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'plot_setup.parm'
	include 'slash.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'
	include 'xplot_setup.cmn'
	include 'parampl5_dat.decl'
	include 'PARAMPL5.DAT'
	include 'cont_inc.decl'
	include 'CONT.INC'

* calling argument declarations:
	LOGICAL versus, overlay, addgaps, spectrum
	INTEGER nvars, thick, status

* internal variable declarations:
	LOGICAL TM_HAS_STRING,  do_key, its_traj
	INTEGER	MR_DIM_LEN, CX_DIM_LEN, CGRID_SIZE, TM_DSG_NFEATURES,
     .		TM_LENSTR1, TM_LENSTR, STR_SAME,
     .          nvs, loc, cx, grid, slen, nfeatures
	REAL	val
	CHARACTER buff*128, TM_INQ_PATH*2048, sfile*2048

* if ribbon_plot then:
	
	cx = is_cx(1)
	grid = cx_grid(cx)

	IF (grid_is_dsg .AND. versus) THEN
	   CALL CHECK_PLOT_TRAJ (versus, nvars, grid, its_traj)
	   IF (.NOT. ribbon_plot) RETURN
	ENDIF

	IF (versus) THEN
	   nvs = 3
	   IF (addgaps) nvs = 4

* If it's a DSG trajectory dataset, can make the trajectories colored by var
* with just a "PLOT var".

	   IF (grid_is_dsg .AND. versus) THEN
	      IF (ribbon_plot) nvs = 1

	      cx = is_cx(1)
	      grid = cx_grid(cx)
	      nfeatures = TM_DSG_NFEATURES( grid )

	   ENDIF
	  
	   IF (nvars .LT. nvs) GOTO 5100
	   IF (nvars .GT. nvs .AND. .NOT.grid_is_dsg) THEN
	      buff = 'PLOT/RIBBON/VS uses just 3 variables. Ignoring extra variables.'
	      IF (addgaps) buff = 'PLOT/RIBBON/VS/GAPLOC uses 4 variables. Ignoring extra variables.'
	      CALL WARN (buff)
	   ENDIF
	ELSE
	   IF (nvars .LT. 2) GOTO 5100
	   IF (nvars .GT. 2) CALL WARN (
     .	  'PLOT/RIBBON uses just 2 variables. Did you mean PLOT/RIBBON/VS?')
	ENDIF

* If a color was given, that's not valid for Ribbon plots.
	loc = qual_given( slash_plot_color )
	IF ( loc .GT. 0  ) GOTO 5200

* If a thickness is given, set pen number to the thickness, pen=1,2,or 3

	loc = qual_given( slash_plot_thick )
	IF ( loc .GT. 0  ) THEN

	  CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			  val, status )

	  IF ( val .NE. unspecified_val4 ) THEN
	     thick = NINT( val )	! user-specified line style
	  ELSE
	     thick = 2  ! default if no value is specified
	  ENDIF
	ENDIF

* A "gaps" variable specifies the end of line segments to draw for PLOT/VS/RIBBON.
* If it's DSG we handle all that from the grid defs; interferes with /MASKFEATURE

	IF (addgaps .AND. grid_is_dsg ) GOTO 5600
	IF (addgaps .AND. .NOT.versus ) GOTO 5400

* Style: fast for one-color per point, default is to interpolate
* colors between points

	loc = qual_given( slash_plot_fast  )
	IF ( loc.GT.0 ) THEN
	  CALL PPLCMD ( from, line, 0, 'RIBFAST 1', 1, 1 )
	ELSE
	  CALL PPLCMD ( from, line, 0, 'RIBFAST 0', 1, 1 )
	ENDIF

* Missing: how to represent missing color-values. Default is
* thin black line. Can request /missing=dash, /missing=blank, 
* /missing= color-palette (e.g. gray_light). The color palette 
* will typically be a one-color plot, or if a multicolor palette 
* is given its first color will be used.

* (call this BEFORE setting the main color palette for ribbon plot; so that
* the setting for palette type: percent, by_level, or by_value is set for the
* specified palette.)

	loc = qual_given( slash_plot_missing  )
	IF ( loc.GT.0 ) THEN
	   CALL EQUAL_STR_LC( cmnd_buff(qual_start(loc):qual_end(loc)),
     .	     buff, status )
	   IF ( status .NE. ferr_ok ) RETURN

	    IF (STR_SAME (buff(1:4), 'blan') .EQ. 0) THEN
	     CALL PPLCMD ( from, line, 0, 'RIBMISS BLANK', 1, 1 )
	   ELSEIF ( buff .EQ. ' ' ) THEN
	      CALL PPLCMD ( from, line, 0, 'RIBMISS DEFAULT', 1, 1 )
	   ELSE
	      CALL PPLCMD ( from, line, 0, 'RIBMISS SPECTRUM='//buff, 1, 1 )
	   ENDIF
	ELSE
	   CALL PPLCMD ( from, line, 0, 'RIBMISS DEFAULT', 1, 1 )
	ENDIF

* ... PLOT/PALETTE=  for multi-colored "ribbon" line 

* save old and reset to new color spectrum if requested

	loc = qual_given( slash_plot_spectrum  )
	IF ( loc.GT.0 ) THEN
	   CALL EQUAL_STR_LC( cmnd_buff(qual_start(loc):qual_end(loc)),
     .	     buff, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   IF ( buff .EQ. ' ' ) buff = 'default'
	ENDIF

	IF (loc.GT.0 ) THEN
	   slen = TM_LENSTR1(buff)
	   sfile = TM_INQ_PATH (buff(:slen),'FER_PALETTE','.spk',
     .        	.false.,status)
	   IF (status .NE. ferr_ok) GOTO 5500 

	   CALL PPL_SHASET( 'SAVE' )
	   CALL PPL_SHASET( 'SPECTRUM='//buff(1:TM_LENSTR1(buff)) )
	   spectrum = .TRUE.

	ENDIF
	      
* default color key
	CALL RIBBON_PLOTKEY_SETUP (overlay, status)
	IF (status .NE. ferr_ok) GOTO 5000

* successful completion
	status = ferr_ok
	RETURN

* error exits
 5000	RETURN
     
 5100	IF (versus .AND. addgaps .AND. ribbon_plot) THEN
           CALL ERRMSG( ferr_syntax, status, 
     .	   'PLOT/VS/RIBBON/GAPLOC plot needs 4 arguments', *5000 )
        ELSEIF (versus .AND. addgaps) THEN
           CALL ERRMSG( ferr_syntax, status,
     .     'PLOT/VS/GAPLOC implemented only for RIBBON plots', *5000)
        ELSEIF (versus) THEN
           CALL ERRMSG(ferr_syntax, status,
     .     'PLOT/VS/RIBBON plot needs 3 arguments', *5000 )
	ELSE
           CALL ERRMSG( ferr_syntax, status, 
     .	   'RIBBON plot needs 2 arguments', *5000 )
	ENDIF
 5200	CALL ERRMSG( ferr_syntax, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .	  '/COLOR not valid for PLOT/LEVELS ribbon plot', *5000 )
 5400	CALL ERRMSG( ferr_syntax, status, 
     .	'PLOT/GAPLOC applies only to PLOT/VS/RIBBON', *5000 )
 5500   CALL ERRMSG (ferr_file_not_found, status, 
     .          'unable to open "' //
     .	buff(:slen)//'.spk" to set ribbon-plot colors.', *5000)

 5600	CALL ERRMSG( ferr_syntax, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .	  '/GAPLOC invalid for Discrete Sampling Geometries Trajectory dataset', *5000 )
	   CALL WARN ('/GAPLOC invalid for Discrete Sampling Geometries Trajectory file')


	END

*
* unique_str2int.F
*
* Ansley Manke
* July 2009
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
*
* This function returns an ID number for each unique
* string in the input array of strings.
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE unique_str2int_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CHARACTER*100 descrip

      WRITE (descrip, 100)
  100 FORMAT ('Returns an ID number for each unique string ',
     .        'in the input array of strings (case sensitive)')
      CALL ef_set_desc(id, descrip)

      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_type (id, arg, STRING_ARG)
      CALL ef_set_arg_desc(id, arg, 'Array of Strings')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


* In this subroutine we compute the result
*
      SUBROUTINE unique_str2int_compute(id, arg_1, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif

      INTEGER id

      REAL arg_1(strdf, mem1lox:mem1hix, mem1loy:mem1hiy,
     .                  mem1loz:mem1hiz, mem1lot:mem1hit, 
     .                  mem1loe:mem1hie, mem1lof:mem1hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

* Routine US2I_COMPARE_STRING_LIST creates and maintains a 
* list of unique names and their sequence numbers.
*
* Future calls to this function will return the same indices for strings
* given in this call because the above functions maintains a static list
* of strings which is initialized once and never released.

      INTEGER flen
      PARAMETER (flen=512)

      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER b1len, status, isame, icmp, ifirst, istr
      CHARACTER*512 buff1
      REAL result_last
      INTEGER*1 fhol(flen), hol_last(flen)      ! c-type Hollerith string buffer

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      ifirst = 1

* These loops are intentionally left in un-optimal order since
* contiguous identical strings are most likely at a location
* through all time/ensemble/forecast periods.

      i = res_lo_ss(X_AXIS)
      DO 100 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)

      j = res_lo_ss(Y_AXIS)
      DO 200 j1 = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)

      k = res_lo_ss(Z_AXIS)
      DO 300 k1 = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)

      l = res_lo_ss(T_AXIS)
      DO 400 l1 = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)

      m = res_lo_ss(E_AXIS)
      DO 500 m1 = arg_lo_ss(E_AXIS,ARG1), arg_hi_ss(E_AXIS,ARG1)

      n = res_lo_ss(F_AXIS)
      DO 600 n1 = arg_lo_ss(F_AXIS,ARG1), arg_hi_ss(F_AXIS,ARG1)

         CALL EF_GET_STRING_ARG_ELEMENT_6D(id, ARG1, arg_1,
     .                          i1, j1, k1, l1, m1, n1, b1len, buff1)

         CALL TM_FTOC_STRNG(buff1(1:b1len), fhol, flen)
         isame = 0
         IF ( ifirst .EQ. 0 ) THEN
*           hol_last is assigned from the last search, so first
*           check the common case of contiguous identical strings
            CALL US2I_STR_CMP(fhol, hol_last, icmp)
            IF ( icmp .EQ. 0 ) THEN
               result(i,j,k,l,m,n) = result_last
               isame = 1
            ENDIF
         ENDIF
         IF ( isame .EQ. 0 ) THEN
*           Search for the string in the whole list
*           (initializing the list if needed)
            CALL US2I_COMPARE_STRING_LIST(fhol, istr)
            IF ( istr .EQ. 0 ) THEN
               buff1 = 'Problems initializing the list of strings'
               GOTO 999
            ENDIF
            result(i,j,k,l,m,n) = FLOAT(istr)
*           Copy the string and the result for the next compare
            DO istr = 1, b1len
               hol_last(istr) = fhol(istr)
            ENDDO
            result_last = result(i,j,k,l,m,n)
            ifirst = 0
         ENDIF

         n = n + res_incr(F_AXIS)
 600  CONTINUE

         m = m + res_incr(E_AXIS)
 500  CONTINUE

         l = l + res_incr(T_AXIS)
 400  CONTINUE

         k = k + res_incr(Z_AXIS)
 300  CONTINUE

         j = j + res_incr(Y_AXIS)
 200  CONTINUE

         i = i + res_incr(X_AXIS)
 100  CONTINUE

      RETURN

 999  CALL EF_BAIL_OUT(id, buff1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

        SUBROUTINE GET_WINDOW_PIXELS (ws_id,x_pixel_dim,y_pixel_dim)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Capture size in pixels of GKS ws with id ws_id
*       J Davison 12.23.92
*	Mod 3.11.93 for Ferret to capture entire screen when in viewport

*	Mod 10/9/95 *sh* to make this a PLOT+ routine rather than a Ferret
*	routine.  Renamed "GET_WINDOW_PIXELS" from "GET_FRAME_SIZE"

*	Note:  because this routine uses floating point calculations there
*	is reason for concern that there may be single pixel errors in the
*	size returned.  An alternative approach (in C) would use
*	XGKS gescinqxattr to get the X display, window, and graphic context
*	and (presumably) XGetWindowAttributes (see Ferret's grab_image_xwd.c)
*	to get the pixel size.
* 1/97 *kob* - Linux Port - had to move variable assignments off of
*               declaration line.
* 8/04 *acm* - Get x and y pixel sizes that were saved in common by set_window_size.
*              When in gif or batch mode, these will be values of symbols PPL$XPIXEL 
*              and PPL$YPIXEL.  If not in gif  or batch mode, we get the window size 
*              from a GKS call.
* V602: *acm* 1/07 Changes for metafile-batch mode
* V68   *acm* 4/11 change how flag meta_batch is computed (different Makefile)
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus.
* V6.8 *acm* 7/9/2012 For batch graphics on RHEL6, change ITS_BATCH_GRAPHICS
*                     from logical to integer, then batch = ITS_BATCH_GRAPHICS().NE.0

        IMPLICIT NONE
        include 'pltcom_dat.decl'
        include 'PLTCOM.DAT'


        logical         batch, its_meta, its_gif, meta_batch
	integer		ITS_BATCH_GRAPHICS, ITS_META_GRAPHICS, 
     .                  ITS_GIF_GRAPHICS, error_status,transno,ws_id
	integer		x_pixel_dim,y_pixel_dim
	integer		new_trans
	PARAMETER	( new_trans = 10 )

	real*4		rzero,fctx,fcty
	real*4		world(4),ndc(4),x_minw,x_maxw,y_minw,y_maxw

******************************************************************************

* meta_batch flag is true when making metafiles in batch mode.

	its_meta = ITS_META_GRAPHICS() .NE. 0
	batch = ITS_BATCH_GRAPHICS() .NE. 0
	its_gif = ITS_GIF_GRAPHICS() .NE. 0
	meta_batch = .FALSE.
        IF (batch) THEN
           IF (its_meta) meta_batch = .TRUE.
        ENDIF

* initialize in case of error (not an adequate response, really)
	x_pixel_dim = 1
	y_pixel_dim = 1
	rzero = 0.0

*	GET WORLD COORDINATES AND PIXEL DIMENSIONS OF FRAME
	call  gqcntn (error_status,transno)
	if (error_status .ne. 0) RETURN

        IF(ASIZE.GT.BSIZE)THEN
           FCTY=BSIZE/ASIZE
           FCTX=1.0
        ELSE
           FCTX=ASIZE/BSIZE
           FCTY=1.0
        ENDIF
	CALL GSWN(new_trans, rzero, asize, rzero, bsize )
	CALL GSVP(new_trans, rzero, fctx,  rzero, fcty )
	call gselnt (new_trans)

	call gqnt (new_trans,error_status,world,ndc)
	if (error_status .ne. 0) GOTO 1000

        x_minw = world(1)
        x_maxw = world(2)
        y_minw = world(3)
        y_maxw = world(4)

! get pixx and pixy that were saved by set_window_size

        CALL get_pix(ws_id,x_pixel_dim, y_pixel_dim)

! If not a gif or metafile batch window get pixel workstation from gks

        IF ((.NOT.meta_batch) .AND. (.NOT.its_gif)) 
     .	CALL gqpxad(ws_id,x_minw,y_maxw,
     .	x_maxw,y_minw,error_status,x_pixel_dim,y_pixel_dim)

 1000	call gselnt (transno)
        return

	end

	BLOCK DATA XERROR_TEXT_DATA

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* error message strings
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.00 - 11/20/85
* revision 0.10 - 05/07/87 - added error for Too may Grid files, and changed
*			     end of file to include "BAD DESCRIPTOR"
* revision 0.20 - 08/10/88 - Reworded error messages, and added some new ones
* revision 0.21 - 12/15/88 - Added time line definition error
* revision 0.22 - 01/06/89 - Removed merr_unkline, changed merr_lineundef,
*                            removed references to "COMMON" in error messages
* Unix/RISC port *sh* 3/15/91: changed text "not mounted" -> "not on line"
* 3/12/92 *sh* : added netCDF support - changed text of merr_badsubscr
*                                     - and merr_gridpredef
* 3/12/93 *sh* : allow unlimited columns in EZ data set
* 11/99 *sh* - change "grid lines" to "axes" in error message
* V600 6/05 *acm* new error merr_attalready; attribute already defined
* V604 6/07 *acm* New merr_remote_open for errors opening remote datasets
* V697 12/15*acm* New merr_axis_att reporting errors in axis attributes, 
*                 e.g. calendars (For ticket 2332)
* v741 6/18 *acm* New merr_dsg_grid and merr_invalid, reporting DSG grid errors
* v741 7/18 *acm* New merr_dsg_struc, reporting DSG attribute errors

	include 'tmap_errors.parm'		! parameter definitions
	include 'xerror_text.cmn_text'	! common declaration

* special error messages
	DATA
     .	msg_special(merr_interrupt - pspecial)
     .		/'interrupted                                       '/

* regular error messages
	DATA
     .	msg_regular(merr_notsupport - pregular)
     .		/'Attempt to access unsupported feature             '/
     .	msg_regular(merr_filpos - pregular)
     .		/'record in incorrect position                      '/,
     .	msg_regular(merr_tstep - pregular)
     .		/'STEP record indicates incorrect time step         '/,
     .	msg_regular(merr_expnum - pregular)
     .		/'STEP record indicates incorrect run number        '/,
     .	msg_regular(merr_modnum - pregular)
     .		/'STEP record indicates incorrect mod number        '/,
     .	msg_regular(merr_notmounted - pregular)
     .		/'non-existent or not on line                       '/,
     .  msg_regular(merr_stepform - pregular)
     .		/'STEP record not found                             '/,
     .  msg_regular(merr_eof - pregular)
     .		/'End Of File encountered                           '/,
     .  msg_regular(merr_nmlerr - pregular)
     .		/'Error in namelist record                          '/,
     .  msg_regular(merr_unkvar - pregular)
     .		/'Unknown variable code                             '/,
     .  msg_regular(merr_unkgrid - pregular)
     .		/'Unknown grid specification                        '/,
     .  msg_regular(merr_stpmtch - pregular)
     .		/'1st timestep in datafile different from descriptor'/,
     .	msg_regular(merr_filim - pregular)
     .		/'file limit reached                                '/,
     .	msg_regular(merr_nostep - pregular)
     .		/'time step not found in data set                   '/,
     .	msg_regular(merr_dsetlim - pregular)
     .		/'limit on number of data sets has been reached     '/,
     .	msg_regular(merr_varlim - pregular)
     .		/'limit on number of variables has been reached     '/,
     .	msg_regular(merr_outofgrid - pregular)
     .		/'Requested data range is outside of data set limits'/,
     .	msg_regular(merr_badsubscr - pregular)
     .		/'Subscript limits dont make sense'/,
     .	msg_regular(merr_auxlim - pregular)
     .		/'limit on number of auxiliary sets has been reached'/,
     .	msg_regular(merr_grfillim - pregular)
     .		/'limit on number of grid files has been reached    '/,
     .	msg_regular(merr_gridlim - pregular)
     .		/'limit on number of grids has been reached         '/,
     .	msg_regular(merr_linelim - pregular)
     .		/'limit on number of axes has been reached          '/,
     .	msg_regular(merr_keynf - pregular)
     .		/'requested key not found in search list            '/,
     .	msg_regular(merr_gridpredef - pregular)
     .		/'attempt to redefine grid or attribute             '/
* regular error messages - continued
	DATA
     .	msg_regular(merr_lineundef - pregular)
     .		/'unknown line specification in grid file           '/,
     .	msg_regular(merr_linepredef - pregular)
     .		/'attempt to redefine line                          '/,
     .	msg_regular(merr_badgriddef - pregular)
     .		/'error in grid definition                          '/,
     .	msg_regular(merr_badlinedef - pregular)
     .		/'error in line definition                          '/,
     .	msg_regular(merr_badtimedef - pregular)
     .		/'error in time line definition                     '/,
     .	msg_regular(merr_linstorlim - pregular)
     .		/'limit on storage for coordinates has been reached '/,
     .	msg_regular(merr_nocoordlin - pregular)
     .		/'grid file defines line without giving coordinates '/,
     .	msg_regular(merr_unktype - pregular)
     .		/'unrecognized data type in FORMAT_RECORD           '/,
     .	msg_regular(merr_syntax - pregular)
     .		/'syntax error in string                            '/,
     .	msg_regular(merr_undefline - pregular)
     .		/'grid has unknown axis                             '/,
     .	msg_regular(merr_notimeinfo - pregular)
     .		/'Time axis info missing or incomplete for dataset  '/,
     .  msg_regular(merr_varform - pregular)
     .		/'VAR record not found                              '/,
     .  msg_regular(merr_varmtch - pregular)
     .		/'1st variable in datafile different from descriptor'/,
     .	msg_regular(merr_dsetnf - pregular)
     .		/'Data set requested is not initialized             '/,
     .	msg_regular(merr_stepnf - pregular)
     .		/'No stepfiles found for requested data set         '/,
     .	msg_regular(merr_badcolmn - pregular)
     .		/'# of columns not a multiple of # of vars          '/,
     .	msg_regular(merr_attalready - pregular)
     .		/'attribute already defined                         '/,
     .	msg_regular(merr_badfileatt - pregular)
     .		/'attribute reading error                           '/,
     .	msg_regular(merr_nc_open - pregular)
     .		/'error opening netCDF file                         '/,
     .	msg_regular(merr_remote_open - pregular)
     .		/'error opening remote data file                    '/,
     .	msg_regular(merr_chunk_spec - pregular)
     .		/'error specifying chunk sizes                      '/
     .	msg_regular(merr_time_string - pregular)
     .		/'error creating time string                        '/
     .	msg_regular(merr_axis_att - pregular)
     .		/'error in axis attributes                          '/
     .	msg_regular(merr_dsg_grid - pregular )
     .		/'Coordinates inconsistent with FeatureType         '/
     .	msg_regular(merr_dsg_struc - pregular )
     .		/'Corrupted CF-DSG structure or attributes          '/
     .	msg_regular(merr_invalid - pregular )
     .		/'Invalid command                        '/
	END

	SUBROUTINE TRANSLATE_LIMIT
     .		(string, idim, subscript, answer, formatted, cal_id, 
     .		status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* convert an ascii representation of a coordinate value into a floating point 
* representation using special format rules

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 4/11/86
* revision 0.1 - 3/27/87 - corrected bug that let ","," " or tab slip through
* revision 0.2 - 4/28/87 - allowed relative ("d") notation
* revision 0.3 - 3/25/88 - added date/time formatted input
* revision 0.4 -12/14/88 - corrected error detection
* revision 0.5 - 3/14/89 - return "formatted" flag
* V200:  6/15/89 - eliminated "d" notation and "relative" logic
*	11/30/89 - error check for comma in string
*	 2/16/90 - error check for slash in string
* Unix/RISC port - 3/12/91 - TM_DATE to replace READ(ERR=) testing date string
* V230:  6/19/92 - bug in error reporting using "risc_buff" fixed
* V300:  9/93 - allow "m" as in Z=15m to be acceptable
* V310: 4/94 - ignore blanks before or after the text
* V320: 1/95 - allow blanks in dates ("1-jan-1985 12:00")  TM_BREAK_DATE has
*		a thorough parser
* V420 (IBM/AIX port of V411): 10/5/95 - buff for "READ(var,*"
* V500 *sh* - 6/99 check for quotations around text (e.g. date strings)
* V53 *acm* - 3/01 calendar axes:  pass in calendar ID
* 2/03 *kob* - g77 port - g77 won't allow intrinsic functions in PARAMETER
*                         statements.  use an octal constant instead 
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction.
* V693+ *sh* 2/15 - added support for _DQ_ quotations
* V72   *acm* 11/16 - improve error message for invalid date strings
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.

* possible formats:
* for subscript values ( subscript .EQ. .TRUE. ) :
*	#	- simple number
* for world coordinate values:
*   x coord:  #  or #E  or  #W     for East, West
*   y coord:  #  or #S  or  #N     for South, North
*   z coord:  #  
*   t coord:  #  or dd-mmm-$_@hh:mm:ss  eg 14-JAN-1986@11:15

	include 'tmap_dims.parm'
	include 'errmsg.parm'
	include 'ferret.parm'
	include 'xrisc.cmn'
	include 'calendar.decl'
	include 'calendar.cmn'

* calling argument declarations:
	CHARACTER*(*)	string
	LOGICAL		subscript, formatted
	INTEGER		status, idim
	REAL*8		answer

* internal variable declarations:
	LOGICAL		TM_DIGIT, TM_DATE
	INTEGER		TM_LENSTR1, end_pos, start_pos, pbad, i, 
     .                  slen, j, cal_id
	REAL*8		SECS_FROM_BC, given_answer
	CHARACTER	buff*60				! for AIX port 10/95

* internal parameter declarations:
	CHARACTER*1	tab
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
#else
	PARAMETER     ( tab = CHAR(9))
#endif

* initialize fixed length string for RISC
        risc_buff = string
	len_rbuff = MIN( size_rbuff, LEN(string) )

* imbedded comma, blank, slash or tab will go undetected as a READ syntax error
	pbad = INDEX( string, ',' )
	IF ( pbad .GT. 0 ) GOTO 5100
	pbad = INDEX( string, tab )
	IF ( pbad .GT. 0 ) GOTO 5100
	pbad = INDEX( string, '/' )
	IF ( pbad .GT. 0 ) GOTO 5100

* initialize
	end_pos = TM_LENSTR1( string )
	formatted = .FALSE.	! may be reset later

* (6/99) check for enclosing quotes
	DO 4 i = 1, end_pos
	   IF (string(i:i) .EQ. '"') THEN
	      start_pos = i + 1
	      GOTO 6
	   ELSEIF ( string(i:i) .EQ. '_'
     .	      .AND. i+3 .LT. len_rbuff ) THEN
	      IF (string(i:i+3) .EQ. "_DQ_") THEN
	         start_pos = i + 4
	         GOTO 6
	      ENDIF
	   ENDIF
 4	CONTINUE
	start_pos = 1
 6	IF (start_pos .GT. 1) THEN
	   DO 8 i = end_pos, start_pos, -1
	      IF (string(i:i) .EQ. '"') THEN
	         end_pos = i - 1
	         GOTO 9
	      ELSEIF ( string(i:i) .EQ. '_'
     .	      .AND. i+3 .LE. len_rbuff ) THEN
	         IF (string(i:i+3) .EQ. "_DQ_") THEN
	            end_pos = i - 1
	            GOTO 9
	         ENDIF
	      ENDIF
 8	   CONTINUE
	ENDIF
 9	IF (start_pos .GT. end_pos) GOTO 5000

* special check for embedded blanks ignoring leading and following blanks 4/94
	DO 10 i = start_pos, end_pos
	   IF ( string(i:i) .NE. ' ' ) GOTO 11
 10	CONTINUE
	pbad = 1
	GOTO 5100    ! all blank string
 11	pbad = INDEX( string(i:end_pos), ' ' )
	IF ( pbad.GT.0 .AND. idim.NE.t_dim ) GOTO 5100   ! t_dim fallthru 1/95

* flag "D" ending as error as of version 2.00 of FERRET
	IF ( string(end_pos:end_pos) .EQ. 'd'
     .  .OR. string(end_pos:end_pos) .EQ. 'D' ) GOTO 5000

	buff = string(i:end_pos)		! AIX port 10/95
	slen = end_pos - i + 1
	IF ( subscript ) THEN

* /I /J /K or /L
	   IF ( .NOT.TM_DIGIT(string(i:end_pos)) ) GOTO 5000
	   READ ( buff,* , ERR=5000 ) given_answer
* make sure the value given is integer
	   answer = INT(given_answer)
	   IF ( ABS( answer-given_answer ) .GT. 0.0001 ) GOTO 5000

	ELSEIF ( idim .EQ. z_dim ) THEN    ! 9/93 addition to allow "m" at end
* /Z
	   formatted = string(end_pos:end_pos) .EQ.'m'
     .	          .OR. string(end_pos:end_pos) .EQ.'M'
	   IF ( formatted ) end_pos = end_pos - 1
	   READ ( buff,* , ERR=5000 ) answer

	ELSEIF ( idim .EQ. x_dim .OR. idim .EQ. y_dim .OR. idim .EQ. e_dim) THEN

* /X and /Y and /E
	   CALL TRANSLATE_LAT_LONG ( buff(:slen), idim,
     .				     answer, formatted,status )
	   IF ( status .NE. ferr_ok ) GOTO 5900

	ELSE
* /T or /F
* date/time string ?
           IF ( TM_DATE( buff(:slen) ) ) THEN
* ... time step cannot be evaluated until we know what axis this is on
* ... save number of seconds from B.C. as a negative to flag later translation

	      answer = -1.D0 * SECS_FROM_BC( buff(:slen), cal_id, 
     .                                       status )
	      formatted = .TRUE.
	      IF ( status .NE. ferr_ok ) THEN 
	         buff = buff(:slen)//' is not valid in this calendar'
		 GOTO 5200
	      ENDIF
           ELSE
* ... read it as a time step value
	      READ ( buff,* , ERR=5000 ) answer
           ENDIF
        ENDIF

* successful completion
 1000	status = ferr_ok
	RETURN

* error exit
 5000	CALL ERRMSG( ferr_syntax, status, string, *5900 )
 5100	CALL ERRMSG( ferr_syntax, status,
     .		'"'//risc_buff(pbad:pbad)//'" is illegal in '//
     .		risc_buff(:len_rbuff), *5900 )
 5200	CALL ERRMSG( ferr_syntax, status, buff, *5900)
 5900	RETURN

	END

    	SUBROUTINE SHOW_TRANSFORMS

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* show a nicely formatted list of the available transforms

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V420:  11/95 - lifted from XEQ_SHOW
*	       - and SHOW LIST (tab and comma delimited formats)
*	 12/95 - show explicit ITP as well (start at index 3 instead of 4)
* V430:   7/96 - incorporate 4D transformations: AVE, VAR, DIN, NDG, NBD
* V446:   9/97 - bug showed up with addition of new xforms
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'xprog_state.cmn'
	include	'xalgebra.cmn'
	include 'xrisc.cmn'          ! 12/94 SPLIT_LIST buffer

* calling argument declarations:
*...

* local variable declarations:
	INTEGER n, i, i1, i2, i4d

* count number of transforms
	n=0
	DO 110 i = 1, num_transforms
	   IF ( alg_trans_num( i ) .EQ. unspecified_int4  ) GOTO 110
	   IF ( alg_trans_num( i ) .EQ. trans_no_transform) GOTO 110
       IF ( alg_trans_num( i ) .EQ. trans_reduced     ) GOTO 110
* ... skip hidden transforms (e.g. 4D internal implementations)
	   DO 109 i4d = 1, num_4d_trans
	      IF (alg_trans_num( i ) .EQ. alg_4d_trans(i4d)) GOTO 110
 109	   CONTINUE
	   n = n+1
 110	CONTINUE
* locate half-way point in the list
	i = 0
	DO 112 i2 = 1, num_transforms
	   IF ( alg_trans_num( i2 ) .EQ. unspecified_int4  ) GOTO 112
	   IF ( alg_trans_num( i2 ) .EQ. trans_no_transform) GOTO 112
       IF ( alg_trans_num( i2 ) .EQ. trans_reduced     ) GOTO 112
* ... skip hidden transforms (e.g. 4D internal implementations)
	   DO 111 i4d = 1, num_4d_trans
	      IF (alg_trans_num( i2 ) .EQ. alg_4d_trans(i4d)) GOTO 112
 111	   CONTINUE
           i = i+1
	   IF ( i .GT. (n+1)/2 ) GOTO 115
 112	CONTINUE
* heading lines
 115	WRITE (risc_buff, 3050) ('code','description',i=1,2)
	CALL SPLIT_LIST(pttmode_explct, ttout_lun, risc_buff, 0)
	risc_buff = ' '
        WRITE (risc_buff, 3050) ('----','-----------',i=1,2)
	CALL SPLIT_LIST(pttmode_explct, ttout_lun, risc_buff, 0)
	risc_buff = ' '
 3050   FORMAT (T4,A,T16,A,T45,A,T57,A)
* list the transforms 2 per line - use 2 separate pointers
	i1 = 3 - 1
	i2 = i2 - 1
	DO 150 i = 1, (n+1)/2
* ... locate first pointer
           DO 120 i1 = i1+1, num_transforms
              IF ( alg_trans_num( i1 ) .EQ. unspecified_int4  ) GOTO 120
	      IF ( alg_trans_num( i1 ) .EQ. trans_no_transform) GOTO 120
          IF ( alg_trans_num( i1 ) .EQ. trans_reduced     ) GOTO 120
* ... skip hidden transforms (e.g. 4D internal implementations)
	      DO 119 i4d = 1, num_4d_trans
	         IF (alg_trans_num( i1 ) .EQ. alg_4d_trans(i4d)) GOTO 120
 119	      CONTINUE
	      GOTO 121
 120	   CONTINUE
* ... locate second pointer
 121	   DO 130 i2 = i2+1, num_transforms
              IF ( alg_trans_num( i2 ) .EQ. unspecified_int4  ) GOTO 130
	      IF ( alg_trans_num( i2 ) .EQ. trans_no_transform) GOTO 130
          IF ( alg_trans_num( i2 ) .EQ. trans_reduced     ) GOTO 130
* ... skip hidden transforms (e.g. 4D internal implementations)
	      DO 129 i4d = 1, num_4d_trans
	         IF (alg_trans_num( i2 ) .EQ. alg_4d_trans(i4d)) GOTO 130 !9/97
 129	      CONTINUE
	      GOTO 131
 130	   CONTINUE
 131	   IF ( i .LE. n/2 ) THEN
* ... write two transforms per line
              WRITE (risc_buff, 3054)
     .                 alg_trans_text(i1), alg_trans_title(i1),
     .                 alg_trans_text(i2), alg_trans_title(i2)
	   ELSE
* ... write the last transformation on a line alone
              WRITE (risc_buff, 3055)
     .                 alg_trans_text(i1), alg_trans_title(i1)
	   ENDIF
	   CALL SPLIT_LIST(pttmode_explct, ttout_lun, risc_buff, 0)
	   risc_buff = ' '
 150   CONTINUE
 3054   FORMAT (T4,'@',A3,T16,A20,T45,'@',A3,T57,A20)
 3055   FORMAT (T4,'@',A3,T16,A20)
	RETURN

	END

*     rr_diff_vz.F
*
*           Rick Romea
*           Jan. 24, 2000
*
*     Meridional momentum diffusive term :  [Az v_z]_z
*     Units :     cm/s/s
*     MOM2 Grid :  U   
*
*******************************************************************

      SUBROUTINE RR_diff_vz_init(id)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

      CALL ef_set_desc             (id,
     .'d(Az dv/dz)/dz momentum diffusive term (cm/s^2);MOM2 U Grid')
      CALL ef_set_num_args         (id, 5)
      CALL ef_set_axis_inheritance (id, IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok     (id, NO, NO, NO, NO)

      ! Define first argument (U)

      CALL ef_set_arg_name         (id, ARG1, 'U')
      CALL ef_set_arg_desc         (id, ARG1,
     . 'Zonal velocity, on the MOM2 U Grid. ')
      CALL ef_set_arg_unit         (id, ARG1, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG1, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG1, YES, YES, YES, YES)
      CALL ef_set_axis_extend      (id, ARG1, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG1, Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG1, Z_AXIS,0,+1)

      ! Define second argument (V)

      CALL ef_set_arg_name         (id, ARG2, 'V')
      CALL ef_set_arg_desc         (id, ARG2,
     . 'Meridional velocity, on the MOM2 U Grid. ')
      CALL ef_set_arg_unit         (id, ARG2, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG2, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2,YES,YES,YES,YES)
      CALL ef_set_axis_extend      (id, ARG2, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG2, Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG2, Z_AXIS,0,+1)

      ! Define third argument (TEMP)

      CALL ef_set_arg_name         (id, ARG3, 'TEMP')
      CALL ef_set_arg_desc         (id, ARG3,
     . 'Potential temperature, on MOM2 T Grid. ')
      CALL ef_set_arg_unit         (id, ARG3, 'deg-C')
      CALL ef_set_arg_type         (id, ARG3, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG3, NO, NO,YES,YES)
      CALL ef_set_axis_extend      (id, ARG3, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG3, Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG3, Z_AXIS,0,+1)

      ! Define forth argument (SALT)

      CALL ef_set_arg_name         (id, ARG4, 'SALT')
      CALL ef_set_arg_desc         (id, ARG4,
     . 'Salinity, on MOM2 T Grid. ')
      CALL ef_set_arg_unit         (id, ARG4, '(ppt-35)/1000')
      CALL ef_set_arg_type         (id, ARG4, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG4, NO, NO,YES,YES)
      CALL ef_set_axis_extend      (id, ARG4, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG4, Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG4, Z_AXIS,0,+1)

      ! Define fifth argument (TAUY)

      CALL ef_set_arg_name         (id, ARG5, 'TAUY')
      CALL ef_set_arg_desc         (id, ARG5,
     . 'Zonal wind stress.')
      CALL ef_set_arg_unit         (id, ARG5, 'dynes/cm^2')
      CALL ef_set_arg_type         (id, ARG5, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG5, NO, NO, NO,YES)
      CALL ef_set_axis_extend      (id, ARG5, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG5, Y_AXIS,-1,+1)

      ! Define a work array

      CALL ef_set_num_work_arrays  (id, 1)

      END 

C*************************************************************************

      SUBROUTINE RR_diff_vz_work_size(id)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'
      INTEGER id
      INTEGER res_lo_ss (4)
      INTEGER res_hi_ss (4)
      INTEGER res_incr  (4)
      CALL ef_get_res_subscripts  (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_set_work_array_dims (id, 1,  
     .    res_lo_ss(1),  res_lo_ss(2), res_lo_ss(3),  res_lo_ss(4),
     .    res_hi_ss(1),  res_hi_ss(2), res_hi_ss(3),  res_hi_ss(4) )
      END

C*************************************************************************

      SUBROUTINE RR_diff_vz_compute(id, 
     .             arg_1,arg_2,arg_3,arg_4,arg_5,result,wrk_1)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'
      
      INTEGER        id

      REAL           bad_flag(EF_MAX_ARGS)
      REAL           bad_flag_result

      REAL           arg_1  (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .                       mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL           arg_2  (mem2lox:mem2hix, mem2loy:mem2hiy, 
     .                       mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL           arg_3  (mem3lox:mem3hix, mem3loy:mem3hiy, 
     .                       mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL           arg_4  (mem4lox:mem4hix, mem4loy:mem4hiy, 
     .                       mem4loz:mem4hiz, mem4lot:mem4hit)
      REAL           arg_5  (mem5lox:mem5hix, mem5loy:mem5hiy, 
     .                       mem5loz:mem5hiz, mem5lot:mem5hit)
      REAL           result (memreslox:memreshix,memresloy:memreshiy,
     .                       memresloz:memreshiz,memreslot:memreshit)
      REAL           wrk_1  (memreslox:memreshix,memresloy:memreshiy,
     .                       memresloz:memreshiz,memreslot:memreshit)

      INTEGER        res_lo_ss (4)
      INTEGER        res_hi_ss (4)
      INTEGER        res_incr  (4)

      INTEGER        arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER        arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER        arg_incr  (4,EF_MAX_ARGS)

      INTEGER        i,  j,  k,  l
      INTEGER        i1, j1, k1, l1
      INTEGER        i2, j2, k2, l2
      INTEGER        i3, j3, k3, l3
      INTEGER        i4, j4, k4, l4
      INTEGER        i5, j5, k5, l5

      REAL*8         zT(1024)
      REAL*8         zU(1024)
  
      INTEGER        iZ

      REAL get_dzw,dzw,dzt,diff_fb,rhom1z,Ri,Potential_density

      INCLUDE 'rr_parameters.h'

c*********************************************************************
c     THIS IS THE MOM2 CODE:
c
c     dzt     = thickness of "t" grid cells (cm)
c     dztr(k) = reciprocal of "dzt"
c     dzw(k)  = vertical resolution of "w" grid cells (in cm)
c     dzwr(k) = reciprocal of "dzw"
c     visc_cbu       = viscosity coefficient at bottom of "u" cells (cm**2/s)
c     visc_cbu_back  = background viscosity (cm**2/s)  =  1.
c     fricmx         = maximum viscosity    (cm**2/s)  = 50.
c     visc_cbu_limit = largest viscosity (cm**2/sec) = fricmx
c     wndmix         = min value for mixing at surface to 
c                     simulate high freq wind mixing. (cm**2/sec)  = 10.
c     smf     = surface momentum flux (dynes/cm**2)
c                smf(1) = taux     smf(2) = tauy
c     grav    = gravity (cm/sec**2)
c     epsln   = small value: 1.e-25
c
c      DIFF_Uz(i,k,j) = (diff_fb(i,k-1,j)-diff_fb(i,k,j))*dztr(k)
c      diff_fb(i,k,j) = visc_cbu(i,k,j)*dzwr(k)*(u(i,k,j,n)-u(i,k+1,j,n))
c      diff_fb(i,0,j) = smf(i,j,n) ! taux (dynes/cm^3)
c      t1                = 1./(1. + 5.*riu(i,k,j))
c      visc_cbu(i,k,j)   = fricmx*t1**2 + visc_cbu_back
c      if(riu(i,k,j).lt.0.)visc_cbu(i,k,j)=visc_cbu_limit ! unstable
c      if(visc_cbu(i,1,j).lt.wndmix)visc_cbu(i,1,j)=wndmix ! surface
c
c      riu(i,k,j) = -grav/4.*dzw(k)*(rhom1z(i,k,j+1) + rhom1z(i+1,k,j+1) +
c     &                            rhom1z(i,k,j)   + rhom1z(i+1,k,j)) /
c     &  ((u(i,k,j,1)-u(i,k+1,j,1))**2+(u(i,k,j,2)-u(i,k+1,j,2))**2 +  epsln) 
c      rhom1z(i,k,j) = ro(i,k,j) - ro(i,k+1,j)
c
c      do ks=1,2
c        call statec (t(1,1,1,1,tlev), t(1,1,1,2,tlev), ro(1,1,jsmw)
c     &,              max(js,jsmw), je, istrt-1, iend+1, ks)
c*********************************************************************

      !  Statement functions

      dzw(iZ) =  get_dzw(iZ,zT) * Meters_to_cm
      dzt(iZ) = (dzw(iZ-1) + dzw(iZ)) / 2.
      diff_fb(i,j,k,l,iZ) = wrk_1(i,j,k,l)/dzw(iZ)  ! wrk_1=visc_cbu
     .                 *(arg_2(i,j,k,l)-arg_2(i,j,k+1,l))
      rhom1z(i3,j3,k3,l3,i4,j4,k4,l4) =
     .        Potential_density(arg_3(i3,j3,k3  ,l3),
     .                          arg_4(i4,j4,k4  ,l4))
     .      - Potential_density(arg_3(i3,j3,k3+1,l3),
     .                          arg_4(i4,j4,k4+1,l4)) 

      ! Get axis data

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags      (id, bad_flag,  bad_flag_result)
      CALL ef_get_coordinates    (id, ARG1, Z_AXIS, 
     .                            arg_lo_ss(Z_AXIS,ARG1),
     .                            arg_hi_ss(Z_AXIS,ARG1), zU)
      CALL ef_get_coordinates    (id, ARG3, Z_AXIS, 
     .                            arg_lo_ss(Z_AXIS,ARG3),
     .                            arg_hi_ss(Z_AXIS,ARG3), zT)

       ! Compute the viscosity coefficients

      l1 = arg_lo_ss(T_AXIS,ARG1) 
      l2 = arg_lo_ss(T_AXIS,ARG2) 
      l3 = arg_lo_ss(T_AXIS,ARG3) 
      l4 = arg_lo_ss(T_AXIS,ARG4) 
      DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1) + 1
         j2 = arg_lo_ss(Y_AXIS,ARG2) + 1
         j3 = arg_lo_ss(Y_AXIS,ARG3) + 1
         j4 = arg_lo_ss(Y_AXIS,ARG4) + 1
         DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            i1 = arg_lo_ss(X_AXIS,ARG1) + 1
            i2 = arg_lo_ss(X_AXIS,ARG2) + 1
            i3 = arg_lo_ss(X_AXIS,ARG3) + 1
            i4 = arg_lo_ss(X_AXIS,ARG4) + 1
            DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

               iZ = 1
               k1 = arg_lo_ss(Z_AXIS,ARG1)
               k2 = arg_lo_ss(Z_AXIS,ARG2)
               k3 = arg_lo_ss(Z_AXIS,ARG3)
               k4 = arg_lo_ss(Z_AXIS,ARG4)
               DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
                  IF (
     .                arg_1(i1,  j1,  k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1+1,j1,  k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1-1,j1,  k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1,  j1+1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1+1,j1+1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1-1,j1+1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1,  j1-1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1+1,j1-1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1-1,j1-1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_2(i2,  j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2,  j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2,  j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_3(i3,  j3,  k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3+1,j3,  k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3-1,j3,  k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3,  j3+1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3+1,j3+1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3-1,j3+1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3,  j3-1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3+1,j3-1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3-1,j3-1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_4(i4,  j4,  k4,l4) .EQ. bad_flag(ARG4) .OR.
     .                arg_4(i4+1,j4,  k4,l4) .EQ. bad_flag(ARG4) .OR.
     .                arg_4(i4-1,j4,  k4,l4) .EQ. bad_flag(ARG4) .OR.
     .                arg_4(i4,  j4+1,k4,l4) .EQ. bad_flag(ARG4) .OR.
     .                arg_4(i4+1,j4+1,k4,l4) .EQ. bad_flag(ARG4) .OR.
     .                arg_4(i4-1,j4+1,k4,l4) .EQ. bad_flag(ARG4) .OR.
     .                arg_4(i4,  j4-1,k4,l4) .EQ. bad_flag(ARG4) .OR.
     .                arg_4(i4+1,j4-1,k4,l4) .EQ. bad_flag(ARG4) .OR.
     .                arg_4(i4-1,j4-1,k4,l4) .EQ. bad_flag(ARG4)
     .                  )THEN
                     wrk_1(i,j,k,l) = bad_flag_result
                  ELSE
                     Ri = - gravity/4. * dzw(iZ) * (
     .                  rhom1z(i3  ,j3+1,k3,l3,i4  ,j4+1,k4,l4) + 
     .                  rhom1z(i3+1,j3+1,k3,l3,i4+1,j4+1,k4,l4) +
     .                  rhom1z(i3  ,j3  ,k3,l3,i4  ,j4  ,k4,l4) + 
     .                  rhom1z(i3+1,j3  ,k3,l3,i4+1,j4  ,k4,l4) ) /
     .               ( (arg_1(i1,j1,k1,l1)-arg_1(i1,j1,k1+1,l1))**2 +
     .                 (arg_2(i2,j2,k2,l2)-arg_2(i2,j2,k2+1,l2))**2 
     .                        + epsln )

                     ! Viscosity coefficient

                     IF(Ri.lt.0.)THEN
                        wrk_1(i,j,k,l) = visc_cbu_limit  ! unstable
                     ELSE
                        wrk_1(i,j,k,l) = fricmx/(1.+5.*Ri)**2
     .                                      + visc_cbu_back
                     ENDIF
                     IF(k1.EQ.1.AND.wrk_1(i,j,k,l).lt.wndmix)THEN
                        wrk_1(i,j,k,l)=wndmix ! surface
                     ENDIF
                  ENDIF

                  iZ = iZ + 1 
                  k1 = k1 + arg_incr(Z_AXIS,ARG1)
                  k2 = k2 + arg_incr(Z_AXIS,ARG2)
                  k3 = k3 + arg_incr(Z_AXIS,ARG3)
                  k4 = k4 + arg_incr(Z_AXIS,ARG4)
               ENDDO

               i1 = i1 + arg_incr(X_AXIS,ARG1)
               i2 = i2 + arg_incr(X_AXIS,ARG2)
               i3 = i3 + arg_incr(X_AXIS,ARG3)
               i4 = i4 + arg_incr(X_AXIS,ARG4)
            ENDDO

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
            j2 = j2 + arg_incr(Y_AXIS,ARG2)
            j3 = j3 + arg_incr(Y_AXIS,ARG3)
            j4 = j4 + arg_incr(Y_AXIS,ARG4)
         ENDDO               

         l1 = l1 + arg_incr(T_AXIS,ARG1)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
         l3 = l3 + arg_incr(T_AXIS,ARG3)
         l4 = l4 + arg_incr(T_AXIS,ARG4)
      ENDDO

      ! Now compute the term
      

      l2 = arg_lo_ss(T_AXIS,ARG2) 
      l5 = arg_lo_ss(T_AXIS,ARG5)
      DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         j2 = arg_lo_ss(Y_AXIS,ARG2) + 1
         j5 = arg_lo_ss(Y_AXIS,ARG5) + 1
         DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            i2 = arg_lo_ss(X_AXIS,ARG2) + 1
            i5 = arg_lo_ss(X_AXIS,ARG5) + 1
            DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

               iZ = 1
               k2 = arg_lo_ss(Z_AXIS,ARG2)
               k5 = arg_lo_ss(Z_AXIS,ARG5)
               DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

                  IF(wrk_1(i,j,k,l).EQ. bad_flag_result)THEN
                     result(i,j,k,l) = bad_flag_result
                  ELSEIF (arg_2(i2,j2,k2  ,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2,j2,k2+1,l2) .EQ. bad_flag(ARG2) )THEN
                     result(i,j,k,l) = bad_flag_result
                  ELSE

                    IF (k5.EQ.1) THEN  ! Top term is wind stress term
                       IF (arg_5(i5,j5,k5,l5) .EQ. bad_flag(ARG5))THEN
                          PRINT*,'BAD FLAG RESULT' 
                          result(i,j,k,l) = bad_flag_result
                       ELSE
                          result(i,j,k,l) = (   arg_5(i5,j5,k5,l5)
     .                                  -  diff_fb(i2,j2,k2,l2,iZ)  )
     .                                     /dzt(iZ) * sec_per_month 
                       ENDIF
                    ELSE
                       result(i,j,k,l) = ( diff_fb(i2,j2,k2-1,l2,iZ-1)
     .                                  -  diff_fb(i2,j2,k2,l2,iZ) )
     .                                     /dzt(iZ) * sec_per_month 
                    ENDIF

                  ENDIF

                  iZ = iZ + 1 
                  k2 = k2 + arg_incr(Z_AXIS,ARG2)
                  k5 = k5 + arg_incr(Z_AXIS,ARG5)
               ENDDO

               i2 = i2 + arg_incr(X_AXIS,ARG2)
               i5 = i5 + arg_incr(X_AXIS,ARG5)
            ENDDO

            j2 = j2 + arg_incr(Y_AXIS,ARG2)
            j5 = j5 + arg_incr(Y_AXIS,ARG5)
         ENDDO               

         l2 = l2 + arg_incr(T_AXIS,ARG2)
         l5 = l5 + arg_incr(T_AXIS,ARG5)
      ENDDO

      END


      ! Density at one Bar 

      REAL FUNCTION Potential_density(T,S)
      IMPLICIT NONE
      REAL T ! Potential Temperature  
      REAL S ! ( SALINITY(ppt) - 35) / 1000 
      REAL Pressure / 1.0 / ! Bar
      REAL Sppt ! Salinity (ppt)     
      Sppt = 1.e3*S+35.  ! Convert S: -->  ppt
      CALL RR_unesco(T,Sppt,Pressure,Potential_density)
      Potential_density = Potential_density*1.e-3  ! Convert:kg/m^3-->g/cm^3
      END				  

	REAL FUNCTION get_dzw(iZ,zT) 
      IMPLICIT NONE
	INTEGER iZ
      REAL*8 zT(iZ+1) 
      IF(iZ.EQ.0)THEN
	    get_dzw=SNGL(zT(1))
      ELSE
        get_dzw=SNGL(zT(iZ+1)-zT(iZ))
      ENDIF
	END

	SUBROUTINE HUNT_INDICES (src, ksmin, ksmax,
     .				 bad_src, targ,
     .				 indices, coefs, kdmin, kdmax,
     .				 kdlo_ok, kdhi_ok, ascnd )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Routine to determine nearest neighbor index (lower index)
*	on GRID1 for points on GRID2.

*	Taken from Numerical Recipes, Chapter 3, Section "Search With
*	Correlated Values"

*       Note that the SRC array may be either ascending or descending order
*       but the TARG array is always ascending

* variable naming:
*	's' refers to the source array -- the incoming list of values
*	'd' refers to the destination arrays -- the outgoing indices and coefs
*	min/max refer to the dimensioned limits of arrays
*	_ok refers to to limits within which the arrays contain valid values

* V690 *sh* 12/13 - derived from Ferret source routine HUNT_R4
*             compute an entire array of indices and coefficient (frac)
*             in a single call.  If exact match, insist on frac=1.0 case.
*             IF reversed (.not.ascnd) return the index and coef for the
*	      lower *coordinate value* point, not the lower index as before

	include 'ferret.parm'

	integer		ksmin, ksmax, kdmin, kdmax, indices(kdmin:kdmax),
     .			kslo_ok,kshi_ok,ndx_lo,ndx_mid,ndx_hi,inc, k,
     .			kdlo_ok, kdhi_ok

	real		src(ksmin:ksmax),
     .			targ(kdmin:kdmax), coefs(kdmin:kdmax),
     .			bad_src, frac

	logical		find_1st_ok, ascnd

*******************************************************************************
* initialize
	kdlo_ok = kdmin
	kdhi_ok = kdmax

*       FIND A CONTIGUOUS BLOCK OF VALID VALUES IN THE src ARRAY
	find_1st_ok = .TRUE.  ! here refers to the input values src
	DO 50 k = ksmin, ksmax
* ... skip invalid values at start of line
	   IF ( find_1st_ok ) THEN
	      IF (src(k) .EQ. bad_src) GOTO 50
	      find_1st_ok = .FALSE.
	      kslo_ok = k
* ... terminate if invalid point encountered after valid points
	   ELSEIF ( src(k) .EQ. bad_src ) THEN
	      kshi_ok = k-1
	      GOTO 60
	   ENDIF
 50	CONTINUE
	IF (find_1st_ok) THEN
	   kdlo_ok = unspecified_int4    !  no input values to hunt among
	   kdhi_ok = unspecified_int4
	   RETURN
	ELSE
	   kshi_ok = ksmax
	ENDIF

*       DEGENERATE CASE? (ONLY A SINGLE POINT TO 'hunt' AMONG)
 60	IF (kshi_ok .EQ. kslo_ok) THEN
	   DO 100 k = kdmin, kdmax
	      indices(k) = kslo_ok
	      IF (targ(k) .eq. src(kslo_ok)) THEN
	         coefs  (k) = 1.0
	         kdlo_ok = k
	         kdhi_ok = k
	      ELSE
	         coefs  (k) = bad_val4
	      ENDIF
 100	   CONTINUE
	   RETURN
	ENDIF

*	TRUE IF ASCENDING GRID COORDINATES, FALSE OTHERWISE
	ascnd = src(kshi_ok) .gt. src(kslo_ok)

* set initial guess for index from array src
	ndx_lo = kslo_ok
	find_1st_ok = .TRUE.  ! now refers to the output coefs

	DO 1000 k = kdmin, kdmax

! this should never happen, givin the initialization value
!*	IF INITIAL GUESS IS NO GOOD, GO IMMEDIATELY TO BISECTION
!	    if (ndx_lo .lt. kslo_ok .or. ndx_lo .gt. kshi_ok) then
!	       ndx_lo = kslo_ok - 1
!	       ndx_hi = kshi_ok + 1
!	       goto 3
!	    end if
 
 	    inc = 1

*	QUICKLY GET A GOOD ESTIMATE FOR LOCATION IN GRID1
	   if (targ(k) .ge. src(ndx_lo) .eqv. ascnd) then
*	   HUNT UP FOR PLACEMENT IN GRID
1	      ndx_hi = ndx_lo + inc
	      
	      if (ndx_hi .gt. kshi_ok) then 
*	      HUNT OVER -- OFF HIGH END OF GRID
	         ndx_hi = kshi_ok + 1
	      else if (targ(k) .gt. src(ndx_hi) .eqv. ascnd) then
	         ndx_lo = ndx_hi
	         inc    = inc + inc
	         goto 1
	      end if
	   else
*	   HUNT DOWN FOR PLACEMENT
	      ndx_hi = ndx_lo
2	      ndx_lo = ndx_hi - inc

	      if (ndx_lo .lt. kslo_ok) then
*	      FALL OFF LOW END OF GRID -- HUNT IS OVER
	         ndx_lo = kslo_ok - 1
	      else if (targ(k) .lt. src(ndx_lo) .eqv. ascnd) then
	         ndx_hi = ndx_lo
	         inc = inc + inc
	         goto 2
	      end if	
	   end if

*	USE BISECTION TO DETERMINE EXACT LOCATION IN GRID
3	   IF (ndx_hi - ndx_lo .eq. 1) THEN

* return result -- including interpolation fraction

	      IF (ndx_lo.GE.kslo_ok .AND. ndx_lo.LT.kshi_ok) THEN
	         IF (targ(k) .EQ. src(ndx_lo)) THEN
	            frac = 1.0
	         ELSEIF (targ(k) .EQ. src(ndx_hi)) THEN
	            ndx_lo = ndx_hi		! 11/13 addition
	            frac = 1.0
	         ELSEIF (.NOT.ascnd) THEN	! 12/13 adtn - reverse-ordered
	            frac = (src(ndx_lo)-targ(k)) / (src(ndx_lo)-src(ndx_hi))
	            ndx_lo = ndx_hi		! hi index is lo position
	         ELSE
	            frac = (src(ndx_hi)-targ(k)) / (src(ndx_hi)-src(ndx_lo))
	         ENDIF
	         find_1st_ok = .FALSE.
	      ELSE    
	         frac = bad_val4
* ... the "ok" limits can include only valid coefficient values
	         IF (find_1st_ok) THEN
	            kdlo_ok = k + 1
	         ELSE
	            IF (k .LE. kdhi_ok) kdhi_ok = k - 1
	         ENDIF
	      ENDIF

* store the result just found
	      indices(k) = ndx_lo
	      coefs(k) = frac

	      GOTO 900
	   ENDIF

	   ndx_mid = (ndx_hi + ndx_lo)/2
	   if (targ(k) .gt. src(ndx_mid) .eqv. ascnd) then
	      ndx_lo = ndx_mid
	   else
	      ndx_hi = ndx_mid
	   end if
   
   	   goto 3

* prepare for next hunt
 900	   IF     (ndx_lo .LT. kslo_ok) THEN
	      ndx_lo = kslo_ok
	   ELSEIF (ndx_lo .GT. kshi_ok) THEN
	      ndx_lo = kshi_ok
	   ENDIF

 1000	CONTINUE

	RETURN
	end

      SUBROUTINE EDIT_ATTRIBUTE( grid_data, mr, varattname, dset, 
     .         attype_spec, att_quiet, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*  Change an attribute for a variable: can change value(s), and/or type

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP
* 9/2005
* 3/2006 Allow commands equivalent to SET AXIS/modulo/depth/units etc.
* V600  4/06 *acm* - additional declarations found by Solaris compiler
* V64  10/09 *acm* longer string length for grid_name
* V720 *acm* 5/17 Implement specific calls in place of CD_GET_VAR_INFO

	include 'tmap_dims.parm'
*TMAP_DSET.PARM
*
* parameters used in "TMAP-formatted" data sets
*
* revision 0.00 - 05/07/87 - by Mark Verschell for PMEL/TMAP
* revision 0.01 - 11/21/88 - Changed variable initialization to char_initXX
* revision 0.02 - 3/99 - *kob* added char_init64
* revision 0.03 - 4/99 - *kob* added char_init256
* V500 - 7/99 *sh* ==> changed char_init to "%%" so that all of the
*			char_init*N are effectively the same definition
* V581 - 3/05 *acm* add char_init_1024
* V68    1/12 *acm* Real variables should be declared REAL (conversion to double prec.)
*        3/12 *acm* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V680   5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V685 *acm*  3/13 For Ensemble aggregations, call the ds_type 'ENS'
* v686 *acm*  1/14 Fix ticket 2127: dont check file type if the variable not a file variable.
* v687 *acm*  3/14 Fix ticket 2161: editing long_name or units of var in ascii files
* V695 *acm*  2/15 For Forecast aggregations, call the ds_type 'FCT'
* V7   *acm*  6/12 Add Union aggregations: DEFINE DATA/AGG/U, ds_type 'UNI'
* V702 *sh*   1/17 For dynamic memory -- use PURGE_ALL_UVARS_EXCEPT_EX

* codes for data sets
	INTEGER		set_not_open,set_open,file_not_open
	PARAMETER      (set_not_open = -9)	! shows available set storage
	PARAMETER      (set_open = -19)		! shows available set storage
	PARAMETER      (file_not_open = -7)	! shows data file not open

* codes for end of namelist blocks
	CHARACTER*4	end_of_aux
	CHARACTER*8	end_of_variables
	CHARACTER*40	end_of_stepfiles, end_of_varfiles
	CHARACTER*60	end_of_grids
	PARAMETER	(end_of_variables = '**END OF VARS**')
	PARAMETER	(end_of_aux = '**END OF AUX**')
	PARAMETER	(end_of_stepfiles = '**END OF STEPFILES**')
	PARAMETER	(end_of_varfiles = '**END OF VARFILES**')
	PARAMETER	(end_of_grids = '**END OF GRIDS**')

* codes for common block initialization
	CHARACTER*80	char_init
	CHARACTER*20	sevens
	CHARACTER	char_init01*01, char_init02*02, char_init04*04,
     .			char_init08*08,	char_init12*12, char_init16*16,
     .			char_init20*20,	char_init23*23, char_init24*24,
     .			char_init30*30, char_init40*40, char_init60*60,
     .			char_init64*64, char_init80*80, char_init128*128,
     .                  char_init256*256, char_init512*512, 
     .                  char_init1024*1024
	INTEGER*2	int2_init
	INTEGER*4	int4_init
	REAL		real4_init
	REAL*8		real8_init
	PARAMETER	(sevens = '77777777777777777777')
! changed this definition because use of char_init and char_initN was
! inconsistent in the code. This way makes all the definitions the same
! (except char_init01)
!	PARAMETER	(char_init = sevens//sevens//sevens//sevens)
	PARAMETER	(char_init = '%%')
	PARAMETER	(char_init01 = char_init)
	PARAMETER	(char_init02 = char_init)
	PARAMETER	(char_init04 = char_init)
	PARAMETER	(char_init08 = char_init)
	PARAMETER	(char_init12 = char_init)
	PARAMETER	(char_init16 = char_init)
	PARAMETER	(char_init20 = char_init)
	PARAMETER	(char_init23 = char_init)
	PARAMETER	(char_init24 = char_init)
	PARAMETER	(char_init30 = char_init)
	PARAMETER	(char_init40 = char_init)
	PARAMETER	(char_init60 = char_init)
	PARAMETER	(char_init64 = char_init)
	PARAMETER	(char_init80 = char_init)
	PARAMETER	(char_init128= char_init)
	PARAMETER	(char_init256= char_init)
	PARAMETER	(char_init512= char_init)
	PARAMETER	(char_init1024= char_init)
	PARAMETER	(int2_init = -7777)
	PARAMETER	(int4_init = -7777)
	PARAMETER	(real4_init = -7.77E-07)
	PARAMETER	(real8_init = -7.77E-07)
	
* record length parameters
	INTEGER		default_reclen,max_reclen,max_tapereclen
	PARAMETER      (default_reclen = 162,	! for GFDL Phil/Seig output
     .			max_reclen = 4095,	! VMS restriction
     .			max_tapereclen = 2499)	! VMS restriction

* bad/missing data indicators
	REAL		bad_r4
	REAL*8		bad_r8
	PARAMETER	(bad_r4 = -1.E34 , bad_r8 = -1.E34)

* zero representations
	INTEGER*1		i1zero
	INTEGER		i4zero
	PARAMETER	(i1zero = 0, i4zero = 0)

* file format codes
	INTEGER		GFDL_3D,pacific_grids,model_output
	CHARACTER*2	grids_at_times,time_series
	CHARACTER*4	pds_type_gt,pds_type_ts,pds_type_ez
	INTEGER*1		regular,irregular
	PARAMETER	(grids_at_times = 'GT',
     .			 time_series = 'TS',
     .			 model_output = 1,
     .			 GFDL_3D = 1,
     .			 pacific_grids = 1,
     .			 regular = 1,
     .			 irregular = 2,
     .			 pds_type_gt = '  GT',
     .			 pds_type_ts = '  TS',
     .			 pds_type_ez = '  EZ' )

* codes for heading records
	INTEGER		plogo,ptitl,pform,pback,pmess,psumm,pvari,
     .			pgrid,pcomm,pindx,pxtra,nbefore_vari
	PARAMETER      (plogo = 1,
     .			ptitl = 2,
     .			pform = 3,
     .			pback = 4,
     .			pmess = 5,
     .			psumm = 6,
     .			pvari = 7,
     .			pcomm = 8,
     .			pgrid = 9,
     .			pindx = 10,
     .			pxtra = 11)
	PARAMETER	(nbefore_vari = 6)	! records preceeding VARI recs

* codes for variables
	INTEGER		ptemp,psalt,pu,pv,pw,ptaux,ptauy,ppsi,pairt,
     .			ptstar_s, ptstar_n, psstar_s, psstar_n
	PARAMETER      (ptemp = 1,
     .			psalt = 2,
     .			pu    = 3,
     .			pv    = 4,
     .			pw    = 5,
     .			ptaux = 6,
     .			ptauy = 7,
     .			ppsi  = 8,
     .			pairt = 9,
     .			ptstar_s = 10,
     .			ptstar_n = 11,
     .			psstar_s = 12,
     .			psstar_n = 13 )

* codes for standard grids and "No defining grid error"
	INTEGER		pps1dxt,pps1dyt,pps1dzb,pps3dtemp,pps3duv,
     .			pps3dw,	pps1dxv,pps1dyv,pps1dz, pps2dtemp,
     .			pps2duv
	INTEGER		no_grid_err
	PARAMETER      (pps1dxt   = 1,
     .			pps1dyt   = 2,
     .			pps1dzb   = 3,
     .			pps1dxv   = 4,
     .			pps1dyv   = 5,
     .			pps1dz    = 6,
     .			pps3dtemp = 7,
     .			pps3duv   = 8,
     .			pps3dw    = 9,
     .			pps2dtemp = 10,
     .			pps2duv   = 11)
	PARAMETER      (no_grid_err = -1)

* codes used at time steps
	CHARACTER*4	step_code
	INTEGER		nintro_recs
	PARAMETER	(nintro_recs = 1 , step_code = 'STEP')

* codes used for time<->date conversion
	INTEGER		to_year, to_month, to_day, to_hour, to_minute,
     .			to_second, full_prec
	PARAMETER	(to_year	= 6,
     .			 to_month	= 5,
     .			 to_day		= 4,
     .			 to_hour	= 3,
     .			 to_minute	= 2,
     .			 to_second	= 1,
     .			 full_prec	= 2)

* codes for auxiliary data sets
	INTEGER		main_set
	PARAMETER	(main_set	= 0)
	include 'tmap_errors.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'ferret.parm'
	include 'errmsg.parm'
        include 'xcontext.cmn'
	include 'xprog_state.cmn'
	include 'xvariables.cmn'
	include 'xrisc.cmn'
      INCLUDE 'netcdf.inc'

* local parameter declarations:
      INTEGER  max_line_len
      PARAMETER ( max_line_len = 2048 )


* calling argument declarations:

      LOGICAL CD_ISIT_COORDVAR, coordvar, att_quiet
      INTEGER mr, attype_spec, dset, status
      REAL grid_data(mr_lo_ss(mr,1):mr_hi_ss(mr,1),
     .               mr_lo_ss(mr,2):mr_hi_ss(mr,2),
     .               mr_lo_ss(mr,3):mr_hi_ss(mr,3),
     .               mr_lo_ss(mr,4):mr_hi_ss(mr,4),
     .               mr_lo_ss(mr,5):mr_hi_ss(mr,5),
     .               mr_lo_ss(mr,6):mr_hi_ss(mr,6))
      CHARACTER*(*) varattname

* local variable declarations: 
      
      LOGICAL TM_HAS_STRING, 
     .        valid, do_err, have_mods, ez, ncfile
      INTEGER MR_DIM_LEN, TM_LENSTR1, STR_SAME, varid, idim, ndims,
     .        attlen, attype, span, lo(nferdims), hi(nferdims), del(nferdims), slen, vlen, 
     .        attlen_old, attype_old, attoutflag, cat, var, tmap_status,
     .        grid, mod_cx, attid
      REAL dummy, bad, scalefac, offset
      CHARACTER GET_STRING_ELEMENT*2048, TM_FMT*2048, attbuff*2048, 
     .          errbuff*256, varname*512, attname*128, aname*128

      CHARACTER	grid_name*64, title*128, units*64, newname*128

! Check that the expresssion is 1-D and if it is a string, just 1 value.

      ndims = 0
      attlen = 0
      DO 30 idim = 1, nferdims
         span = MR_DIM_LEN(idim, mr )
         valid = mr_lo_ss( mr,idim ) .NE. unspecified_int4
         IF (span .GT. 0 .AND. valid ) ndims = ndims + 1
         attlen = MAX(attlen, span)
 30   CONTINUE

* * * * * DETERMINE INDEX LIMITS * * *
      DO 40 idim = 1, nferdims
         lo(idim) = mr_lo_ss( mr, idim )
         hi(idim) = mr_hi_ss( mr, idim )
         del(idim)= 1
 40   CONTINUE

      IF (ndims .LT. 0 .OR. ndims .GT. 1) GOTO 5100

* Reconcile data types for the attribute. If requested a float attribute
* but the expression is a string, it is an error.  If a string was requested,
* we can convert a numeric value to string below.

      IF (attype_spec .EQ. ptype_float  .AND. 
     .    mr_type(mr) .NE. ptype_float) GOTO 5300

      attype = NCFLOAT
      IF (mr_type(mr) .EQ. ptype_string .OR.
     .    attype_spec .EQ. ptype_string ) attype = NCCHAR

* See if the attribute already exists for the variable.

      do_err = .TRUE.
      CALL BREAK_VARATTNAME ( varattname, dset, varname, 
     .              attname, varid, do_err, status )
      IF (status .NE. ferr_ok) GOTO 5400

      coordvar = CD_ISIT_COORDVAR (dset, varid, varname, status)
      IF (coordvar) THEN

* Do not allow user to change the direction of an axis.

        IF (STR_SAME(attname, 'AXIS')           .EQ. 0  .OR.
     .      STR_SAME(attname, 'CARTESIAN_AXIS') .EQ. 0) THEN
     
            vlen = TM_LENSTR1(varname)
            slen = TM_LENSTR1(attname)
            GOTO 5600
        ENDIF

      ENDIF

!  If attribute already exists, change it.

      CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)
      IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, 
     .             aname, attype_old, attlen_old, attoutflag, status )

      errbuff = varattname
      IF (attype .EQ. NCCHAR ) THEN

         IF (mr_type(mr) .NE. ptype_string) THEN
            attbuff = TM_FMT(
     .                grid_data(lo(1),lo(2),lo(3),lo(4),lo(5),lo(6)),
     .                8, 40, slen)
            IF (attlen .GT. 1) THEN 
               CALL WARN ('Requested string attribute using a '//
     .                    'numeric expression. Using first value and '//
     .                    'converting to string')
               attlen = 1
            ENDIF

         ELSE
            IF (attlen .GT. 1) GOTO 5200
            attbuff = GET_STRING_ELEMENT(
     .              lo(1), hi(1), lo(2), hi(2),
     .	            lo(3), hi(3), lo(4), hi(4), 
     .	            lo(5), hi(5), lo(6), hi(6), 
     .              grid_data, lo(1), lo(2), lo(3),
     .              lo(4), lo(5), lo(6), 
     .              max_line_len, slen)

            dummy = 1.
            attlen = TM_LENSTR1(attbuff)    
         ENDIF

         vlen = TM_LENSTR1(errbuff)
         IF (attype .NE. attype_old .AND. (.NOT.att_quiet)) 
     .         CALL WARN ('Changing the type of attribute '//
     .         errbuff(:vlen))
         IF (.NOT.att_quiet) CALL WARN ('Changing the value of attribute '//
     .         errbuff(:vlen))

         CALL CD_REPLACE_ATTR (dset, varid, attname, attype, attlen, 
     .         attbuff, dummy, status)

      ELSE 
         attype = NCFLOAT
         vlen = TM_LENSTR1(errbuff)
         IF (attype .NE. attype_old .AND. (.NOT.att_quiet)) 
     .         CALL WARN ('Changing the type of attribute '//
     .         errbuff(:vlen))
         IF (.NOT.att_quiet) CALL WARN ('Changing the value of attribute '//
     .         errbuff(:vlen))

         IF (attlen .NE. attlen_old .AND. attype .EQ. attype_old .AND. (.NOT.att_quiet)) 
     .         CALL WARN ('Changing the length  of attribute '//
     .         errbuff(:vlen))

         CALL CD_REPLACE_ATTR (dset, varid, attname, attype, attlen, 
     .         attbuff, grid_data(lo(1),lo(2),lo(3),lo(4),lo(5),lo(6)), 
     .	       status)  

      ENDIF

* For coordinate variables, change attributes as in SET AXIS command.

      IF (coordvar) THEN
         IF (STR_SAME(attname, 'modulo')      .EQ. 0  .OR.
     .       STR_SAME(attname, 'depth')       .EQ. 0  .OR.
     .       STR_SAME(attname, 'positive')    .EQ. 0  .OR.
     .       STR_SAME(attname, 'calendar')    .EQ. 0  .OR.
     .       STR_SAME(attname, 'time_origin') .EQ. 0  .OR.
     .       STR_SAME(attname, 'units')       .EQ. 0) THEN

! input varname may differ from name in linked-list structure by a digit (see isit_coord_var)
           CALL GET_INPUT_VARNAME (varattname, varname)  
           CALL RESET_AXIS (dset, varid, varname, attname, attbuff,
     .         grid_data(lo(1),lo(2),lo(3),lo(4),lo(5),lo(6)), status)  
        ENDIF
      ENDIF

* Replace information in Ferret variables as in SET VAR

	grid = int4_init
	bad = real4_init
	scalefac = real4_init
	offset = real4_init
        have_mods = .FALSE.
        ncfile = .FALSE.
        ez = .FALSE.
	newname = char_init128
	title = char_init128
	units = char_init64
	grid_name = char_init16

     	IF ( STR_SAME(attname, 'scale_factor') .EQ. 0 ) THEN
           have_mods = .TRUE.
           scalefac = grid_data(lo(1),lo(2),lo(3),lo(4),lo(5),lo(6))
        ENDIF

     	IF ( STR_SAME(attname, 'add_offset') .EQ. 0 ) THEN
           have_mods = .TRUE.
           offset = grid_data(lo(1),lo(2),lo(3),lo(4),lo(5),lo(6))
        ENDIF

     	IF ( STR_SAME(attname, 'long_name') .EQ. 0 ) THEN
           have_mods = .TRUE.
           title = attbuff
        ENDIF

     	IF ( STR_SAME(attname, 'units') .EQ. 0 ) THEN
           have_mods = .TRUE.
           units = attbuff
        ENDIF

     	IF ( STR_SAME(attname, 'missing_value') .EQ. 0 ) THEN
           have_mods = .TRUE.
           bad = grid_data(lo(1),lo(2),lo(3),lo(4),lo(5),lo(6))
        ENDIF
     
     	IF ( STR_SAME(attname, '_FillValue') .EQ. 0 ) THEN
           have_mods = .TRUE.
           bad = grid_data(lo(1),lo(2),lo(3),lo(4),lo(5),lo(6))
        ENDIF

* Get var and cat
	CALL PARSE_NAM_DSET( varname, cx_last, dset,
     .			     cat, var, mod_cx, status )

        IF (var .EQ. munknown_var_name)  GOTO 5000

	IF ( cat .EQ. cat_file_var ) ez = ds_type(dset) .EQ. pds_type_ez

	IF (dset .GT. 0) ncfile = (TM_HAS_STRING(ds_type(dset), 'CDF') .OR.
     .               TM_HAS_STRING(ds_type(dset), 'MC') .OR.
     .               TM_HAS_STRING(ds_type(dset), 'ENS') .OR.
     .               TM_HAS_STRING(ds_type(dset), 'FCT') .OR.
     .               TM_HAS_STRING(ds_type(dset), 'UNI') .OR.
     .               TM_HAS_STRING(ds_type(dset), 'GT')  )

* note on EZ vars:
* modifying the variable info invalidates data in memory
*        the purging of memory variables below is unnecessarily strict in both
*	 the uvar and fvar cases.  FVAR's can be modified in memory to change
*	 mr_grid, units, etc.  They need to be deleted only if they were on 
* 	 non-standard grids or units.  The UVAR's need to be purged only if
*	 they depend on the FVAR being changed)

* 1/17 use PURGE_ALL_UVARS_EXCEPT_EX instead of PURGE_ALL_UVARS because EX#n
*      was passed to this routine.  With dynamic memory we must not free
*      a memory pointer that was passed in as an argument
	IF ( ez ) THEN
	   IF ( have_mods ) THEN
	      CALL PURGE_FILE_VAR( var ) ! remove memory-resident variables
	      CALL PURGE_ALL_UVARS_EXCEPT_EX !delete (possibly dependent) uvars
	      CALL EZ_MOD_VARS( dset,var,varid,
     .			        newname,title,units,grid,bad,tmap_status )
	      IF ( tmap_status .NE. merr_ok ) THEN
	         status = ferr_TMAP_error
	         RETURN
	      ENDIF
	   ENDIF
	ELSEIF ( cat .EQ. cat_file_var ) THEN
* ... other file variables (10/95)

	   IF ( bad  .NE. real4_init  ) THEN
	      CALL PURGE_FILE_VAR( var ) ! remove memory-resident variables
	      CALL PURGE_ALL_UVARS_EXCEPT_EX !delete (possibly dependent) uvars
	      ds_missing_flag(var) = ds_bad_flag(var)
	      ds_bad_flag    (var) = bad
	   ENDIF

	   IF ( units .NE. char_init16 ) ds_var_units( var ) = units
	   IF ( title .NE. char_init80 ) ds_var_title( var ) = title

           IF ((scalefac .NE. real4_init) .AND. ncfile) THEN
	      CALL PURGE_FILE_VAR( var ) ! remove memory-resident variables
	      CALL PURGE_ALL_UVARS_EXCEPT_EX
              ds_var_scale(var) = scalefac
              ds_var_scaleit(var)       = .TRUE.
           ENDIF
           IF ((offset .NE. real4_init) .AND. ncfile) THEN
	      CALL PURGE_FILE_VAR( var ) ! remove memory-resident variables
	      CALL PURGE_ALL_UVARS_EXCEPT_EX
              ds_var_off(var)   = offset
              ds_var_scaleit(var)       = .TRUE.
           ENDIF
	ELSE
* ... user-defined var

	   IF ( units .NE. char_init16 ) uvar_units( var )  = units
	   IF ( title .NE. char_init80 ) uvar_title( var )  = title
	   IF ( bad  .NE. real4_init  ) THEN
	      CALL PURGE_ALL_UVARS_EXCEPT_EX	 ! delete invalidated uvars
	      uvar_bad_data(var) = bad
	   ENDIF

	ENDIF

* successful completion
	status = ferr_ok




 5000 RETURN
 5100 CALL ERRMSG( ferr_invalid_command, status,
     . 'attribute values must be 1 dimensional: '//
     . errbuff(:vlen),*5000 )

 5200 CALL ERRMSG( ferr_invalid_command, status,
     .  'String attribute may contain just one string: '//
     .  errbuff(:vlen),*5000 )

 5300 CALL ERRMSG( ferr_invalid_command, status,
     .  'Attribute type does not match expression: '//
     .  errbuff(:vlen),*5000 )

 5400 errbuff = varattname
      CALL ERRMSG( ferr_invalid_command, status,
     .  'Attribute does not exist: '//errbuff(:vlen),*5000)

 5500 CALL ERRMSG( ferr_invalid_command, status,
     .  'To change "'// attname(:slen)//
     .  '" for coordinate variable, use SET AXIS instead',*5000)

 5600 CALL ERRMSG( ferr_invalid_command, status,
     .  'Cannot change attribute for direction of axis.',*5000)

      END

	SUBROUTINE T_DERIV( com, mcom, res, mres, dt, reg )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute centered derivative of component along axis t_dim

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  8/1/89 - based on DO_DERIV_CNTR
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN
* 2/12 *acm* Add E and F dimensions (use nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include	'xprog_state.cmn'
	include 'xunits.cmn_text'
	external xunits_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data

* calling argument declarations:
	LOGICAL reg
	INTEGER	mcom, mres
	REAL	   dt,
     .   com( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .   res( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,m2lot:m2hit,m2loe:m2hie,m2lof:m2hif )

* internal variable declarations:
	INTEGER i, j, k, l, m, n, grid, lo_l, hi_l, lm1, lp1
	REAL	bad_com, bad_res, lo_com, hi_com, box, box1
	REAL*8	TM_WORLD

* initialize
	grid    = mr_grid( mres )
	bad_com = mr_bad_data( mres )
	bad_res = mr_bad_data( mcom )

* fill in edges if not computable
	lo_l = mr_lo_s4(mres)
	IF ( mr_lo_s4(mcom) .EQ. mr_lo_s4(mres) ) THEN
	   DO 100 n = mr_lo_s6(mres), mr_hi_s6(mres)
	   DO 100 m = mr_lo_s5(mres), mr_hi_s5(mres)
	   DO 100 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   DO 100 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   DO 100 j = mr_lo_s2(mres), mr_hi_s2(mres)
	   DO 100 i = mr_lo_s1(mres), mr_hi_s1(mres)
 100	   res(i,j,k,lo_l,m,n) = bad_res
	   lo_l = lo_l + 1
	ENDIF
	hi_l = mr_hi_s4(mres)
	IF ( mr_hi_s4(mcom) .EQ. mr_hi_s4(mres) ) THEN
	   DO 200 n = mr_lo_s6(mres), mr_hi_s6(mres)
	   DO 200 m = mr_lo_s5(mres), mr_hi_s5(mres)
	   DO 200 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   DO 200 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   DO 200 j = mr_lo_s2(mres), mr_hi_s2(mres)
	   DO 200 i = mr_lo_s1(mres), mr_hi_s1(mres)
 200	   res(i,j,k,hi_l,m,n) = bad_res
	   hi_l = hi_l - 1
	ENDIF
	   
* loop through all computable points
	DO 1000 l = lo_l, hi_l

	lm1 = l-1
	lp1 = l+1

* time box size
	   box = TM_WORLD( lp1, grid, t_dim, box_middle )
     .	       - TM_WORLD( lm1, grid, t_dim, box_middle )

* all T spacings the same ?
	   IF ( l .EQ. lo_l ) THEN
	      box1 = box
	      reg  = .TRUE.
	   ELSE
	      IF ( box .NE. box1 ) reg = .FALSE.
	   ENDIF

	   DO 500 n = mr_lo_s6(mres), mr_hi_s6(mres)
	   DO 500 m = mr_lo_s5(mres), mr_hi_s5(mres)
	   DO 500 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   DO 500 j = mr_lo_s2(mres), mr_hi_s2(mres)
	   DO 500 i = mr_lo_s1(mres), mr_hi_s1(mres)

	      lo_com = com(i,j,k,lm1,m,n)
	      hi_com = com(i,j,k,lp1,m,n)
	      IF ( lo_com.EQ.bad_res .OR. hi_com.EQ.bad_res ) THEN
	         res(i,j,k,l,m,n) = bad_res
	      ELSE
	         res(i,j,k,l,m,n) = (hi_com-lo_com) / box
	      ENDIF

 500	   CONTINUE
 1000	CONTINUE

* compute delta t
	IF ( reg ) THEN
	   dt = box
	ELSE
	   box = TM_WORLD( hi_l+1, grid, t_dim, box_middle )
     .	       - TM_WORLD( lo_l-1, grid, t_dim, box_middle )
	   dt = box / (hi_l-lo_l+1)
	ENDIF

	RETURN
	END	

      SUBROUTINE HEAP2_STR (RA, IB, N)

C  Ansley Manke
C  From Numerical Recipes, Heapsort subroutine SORT2

      IMPLICIT NONE
      INTEGER N
      CHARACTER*512 RA(*), RRA, RRB

      INTEGER L, IR, J, I, NGD
      REAL IB(*), IIB

* From SHELLR

      L = N/2 + 1
      IR = N

   10 CONTINUE
         IF (L .GT. 1) THEN
            L = L - 1
            RRA = RA(L)
            IIB = IB(L)
         ELSE
            RRA = RA(IR)
            IIB = IB(IR) 
            RA(IR) = RA(1)
            IB(IR) = IB(1)
            IR = IR - 1
            IF (IR .LE. 1) THEN	! *acm* Num Recipes has .EQ. here,
				!       but this fails in the case where	
				!       the loop starts with L=1
               RA(1) = RRA
               IB(1) = IIB
               RETURN
            ENDIF
          ENDIF

          I = L
          J = L + L
   20     IF (J .LE. IR) THEN
             IF (J .LT. IR) THEN
                IF (RA(J) .LT. RA(J+1)) J = J + 1
             ENDIF
             IF (RRA .LT. RA(J)) THEN
                RA(I) = RA(J)
                IB(I) = IB(J)
                I = J
                J = J + J
             ELSE
                J = IR + 1
             ENDIF
             GO TO 20
          ENDIF

          RA(I) = RRA
          IB(I) = IIB
      GO TO 10

      END

 	CHARACTER*(*) FUNCTION AX_TITLE( idim, grid, len )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* produce a title string with units suitable for an axis

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* revision 0.0 - 8/25/88
* V320: 12/19/94 - recognize millibars and decibars as special axes
*		(kludge: use "m" for meters instead of exact unit string.
*			This because of "METERS" in the old grid files around.)
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
* V695+ *sh* 3/15 - generate axis titles for TIME LAG axes in FMRC variables
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.

	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xunits.cmn_text'
	include 'ferret.parm'
	include 'xtext_info.cmn'

* calling argument declarations:
	INTEGER	idim, grid, len
	LOGICAL	GEOG_LABEL

* internal variable declarations:
        LOGICAL ITS_FMRC, ITSA_TRUEMONTH_AXIS
	INTEGER	TM_LENSTR1, i, line, ulen
	CHARACTER*16 unit_name

* check for program bug	! temp
	IF ( grid .EQ. unspecified_int4 ) STOP 'no_grd_orient'

	line = grid_line( idim, grid )

	IF ( GEOG_LABEL( idim, grid ) ) THEN
	   AX_TITLE = axis_title( idim )
	   len = axis_title_len( idim )
* special formatting for vertical axes - 12/19/94
	   IF ( idim .EQ. z_dim ) THEN
	      IF ( line_unit_code(line) .EQ. pun_millibars 
     .        .OR. line_direction( line ) .EQ. 'DU'     ) THEN
	         AX_TITLE = "HEIGHT"
	         len = 6
	      ENDIF
	      IF ( line_unit_code(line) .EQ. pun_meters ) THEN
	         unit_name = 'm'		! kludge for "METERS"
	      ELSE
	         unit_name = line_units(line)
	      ENDIF
	      ulen = TM_LENSTR1( unit_name )
	      AX_TITLE = AX_TITLE(1:len)//' ('//unit_name(:ulen)//')'
	      len = len + 3 + ulen
	   ENDIF	      

        ELSEIF ( ITS_FMRC(grid)
     .   .AND. (idim.EQ.t_dim .OR. idim.EQ.f_dim)) THEN 
* HACK: special formatting for FMRC T-F plane data 3/15
           IF (idim .EQ. t_dim ) THEN
              AX_TITLE = 'MODEL ELAPSED TIME'
              len = 18
           ELSE
              AX_TITLE = 'FORECAST LEAD TIME'
              len = 18
           ENDIF
           unit_name = line_units(line)

* If its a true-month axis then make the output unit name be day
           IF ( ITSA_TRUEMONTH_AXIS(line) ) unit_name = 'day'
           ulen = TM_LENSTR1( unit_name )
           AX_TITLE = AX_TITLE(:len)//' ('//unit_name(:ulen)//')'
           len = len + 3 + ulen

	ELSE
	   AX_TITLE = ww_dim_name( idim )
	   len = 1
	   IF ( line .NE. mnormal .AND. line .NE. munknown ) THEN
	      IF ( line_units(line) .NE. ' ' ) THEN
	         ulen = TM_LENSTR1( line_units(line) )
	         AX_TITLE = AX_TITLE(1:1)//' ('//line_units(line)(:ulen)//')'
	         len = 4 + ulen
	      ENDIF
	   ENDIF
	ENDIF

	RETURN
	END

* 
*  earth_distance.F
* 
*  Ansley manke
*  9/2017
* 
*  Compute the the incremental distance along a path
*  using the law of cosines as in Billy's earth_distance.jnl script

      SUBROUTINE earth_distance_init(id)

      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

      CALL ef_set_desc(id, 'Return the point-to-point-distance in Km along the path' )

      CALL ef_set_num_args(id, 2)
      CALL EF_SET_HAS_VARI_ARGS(id, NO)
      CALL EF_SET_AXIS_INHERITANCE_6D(id, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL EF_SET_PIECEMEAL_OK(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'longitude')
      CALL EF_SET_ARG_DESC(id, arg,
     .          'List of longitudes in degrees East along the path')
      CALL EF_SET_AXIS_INFLUENCE_6D(id, arg, YES, YES, YES, YES, YES, YES)

      arg = 2
      CALL EF_SET_ARG_NAME(id, arg, 'latitude')
      CALL EF_SET_ARG_DESC(id, arg,
     .          'List of latitudes in degrees North along the path')
      CALL EF_SET_AXIS_INFLUENCE_6D(id, arg, YES, YES, YES, YES, YES, YES)


      RETURN 
      END

* 
*  Compute the result
* 
      SUBROUTINE earth_distance_compute(id, lons, lats, result)

      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL lons(mem1lox:mem1hix, mem1loy:mem1hiy,
     .	   mem1loz:mem1hiz, mem1lot:mem1hit,
     .	   mem1loe:mem1hie, mem1lof:mem1hif)
      REAL lats(mem2lox:mem2hix, mem2loy:mem2hiy,
     .     mem2loz:mem2hiz, mem2lot:mem2hit,
     .     mem2loe:mem2hie, mem2lof:mem2hif)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .     memresloz:memreshiz, memreslot:memreshit,
     .     memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(6), res_hi_ss(6), res_incr(6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS), arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr(6,EF_MAX_ARGS)


      INTEGER i, num, nm
      REAL dlo, dhi, ed_pd, ed_rearth, ed_lat1, ed_lat2, ed_lon1, ed_lon2, 
     .	   ed_x1, ed_x2, ed_y1, ed_y2, ed_z1, ed_z2, ed_d1, ed_angle
      CHARACTER*80 errtxt


      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* check that the lists are 1D

      errtxt = 'Argument 1 must be a 1D list'
      num = arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 1
      DO i = Y_AXIS, F_AXIS
         nm = arg_hi_ss(i,ARG1) - arg_lo_ss(i,ARG1) + 1 
         IF (num.GT.1 .AND. nm.GT.1) GOTO 9000
         num = MAX(num,nm)
      ENDDO

      errtxt = 'Argument 2 must be a 1D list'
      num = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1
      DO i = Y_AXIS, F_AXIS
         nm = arg_hi_ss(i,ARG2) - arg_lo_ss(i,ARG2) + 1
         IF (num.GT.1 .AND. nm.GT.1) GOTO 9000
         num = MAX(num,nm)
      ENDDO

* Call generalized routine to compute each delta-earth-distance along the path

      errtxt = ' '
      CALL EARTH_DEL (lons, lats, num, bad_flag(1), bad_flag(2), result, errtxt )
      IF (errtxt .NE. ' ') GOTO 9000

      RETURN 
 9000 CALL EF_BAIL_OUT(id, errtxt)

      END

c SUBROUTINE EARTH_DEL is in the source directory fer/utl/

	PROGRAM BINARY
	INTEGER*2 ASCII(128),ICNT,IBASE,IRAST,ILEN
	BYTE X(5000),Y(5000)
	CHARACTER NAME*30
100	WRITE(5,'('' FILE: '',$)')
	READ(5,'(A30)')NAME
	IF(NAME.EQ.'STOP')STOP
	OPEN(1,FILE=NAME,STATUS='OLD')
	OPEN(2,FILE=NAME,STATUS='NEW',FORM='UNFORMATTED')
	READ(1,987)ICNT,IBASE,IRAST
987	FORMAT(1X,I2,2I4)
	IF(ICNT.EQ.99)THEN
	READ(1,985)(ASCII(IJ),IJ=1,128)
	ILEN=ASCII(128)
	ELSE
	READ(1,985)(ASCII(IJ),IJ=1,ICNT+1)
	ILEN=ASCII(ICNT+1)
	DO 1010 IJ=ICNT+1,128
1010	ASCII(IJ)=1
	ENDIF
985	FORMAT(1X,20I4)
	READ(1,984)(X(IJ),IJ=1,ILEN)
	READ(1,984)(Y(IJ),IJ=1,ILEN)
984	FORMAT(1X,40I2)
	CLOSE(1)
	WRITE(2)ICNT,IBASE,IRAST,ILEN
	WRITE(2)(ASCII(I),I=1,127)
	WRITE(2)(X(I),I=1,ILEN)
	WRITE(2)(Y(I),I=1,ILEN)
	CLOSE(2)
	GOTO 100
	END

      SUBROUTINE XYZPLT

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
****************************************************************
C revised for FERRET
C from PPLUS :
C	Directory PMEL:[PLOT5.LIBRARY.COMPLOT]
C	ABPLT.FOR;2               9   5-FEB-1985 11:33 
C search for "FERRET" to find all revisions
C *sh* 9/19/88 - rev 1.0 for FERRET 1.10+
C	- if GKS (ptype>2) then bypass clipping at screen limits
C !!! ALSO :  Routine overflows subscripts at label 70
C	      70 XINTER = XMXMN(IAND(LOWFLG,3))
C	      logic to deal with a pair of points whose connecting segment
C		crosses the corner of the window is wrong
C	      ...bounds checking is OFF to match Denbo's compile stmt
C *acm* 10/11 Fix ticket 1545. Further fix for the case where the connecting 
C             segment does not cross the corner, but e.g. one point is to the 
C             left of the plot and the other above. See examples in ticket 
C             1545. In this case at label 70, XINTER is set to zero, and that 
C             value is used in computing YINTR and ZINTR. Once XYINTR is
C             set to the xmin or xmax, then need to call TRANS again and
C             define values before ABPLT is called.
****************************************************************
C     CALL XYZPLT

C     THIS SUBROUTINE PERFORMS WINDOW CLIPPING IAND THEN MOVES THE
C     PEN FROM THE CURRENT POSITION TO A NEW POINT.



******************************************************************
C FERRET mod - for explicit declarations - 9-19-88
C      DIMENSION XMXMN(2),YMXMN(2)
      REAL XMXMN(2),YMXMN(2)
      EQUIVALENCE (XMXMN(1),XMAX),(YMXMN(1),YMAX)
      REAL xinter, yinter, zinter, dx, dy, dz, cosx, cosy, cosz, dist

      include 'pltcom_dat.decl'
      include 'PLTCOM.DAT'

C end of FERRET mod
******************************************************************
C     CHECK THE PLOTTING MODE.

      IF(PMODE .EQ. ALPHA)GO TO 30

C     CHECK THE PEN POSITION.

      IF(PENF)GO TO 10

C     TEMPORARILY STORE THE NEW POSITION.

      XNEW = XTEMP
      YNEW = YTEMP
      ZNEW = ZTEMP
      SAVEF = .TRUE.
      RETURN

C     CHECK THE PLOTTING MODE.

  10  IF(PMODE .NE. POINT)GO TO 20
      XNEW = XTEMP
      YNEW = YTEMP
      ZNEW = ZTEMP
      GO TO 30

C     IF THE LAST POINT WAS NOT PLOTTED BECAUSE THE PEN WAS UP,
C     PLOT THE POINT NOW.

  20  IF(.NOT. SAVEF)GO TO 60
      PENF = .FALSE.
  30  IF(.NOT. WINDOF)GO TO 40

C     CALCULATE THE NEW OFF-WINDOW FLAG.

      OWFLG = 0
      IF(XNEW .GT. XMAX)OWFLG = 1
      IF(XNEW .LT. XMIN)OWFLG = 2
      IF(YNEW .GT. YMAX)OWFLG = OWFLG + 4
      IF(YNEW .LT. YMIN)OWFLG = OWFLG + 8

C     CHECK THE NEW POINT TO SEE IF IT IS WITHIN THE BOUNDARY OF
C     THE WINDOW.  IF NOT, DO NOT PLOT IT.

      IF(OWFLG .NE. 0)GO TO 50

C     TRANSFORM THE POINT TO THE SCREEN COORDINATE SYSTEM.

  40  CALL TFORM(XNEW,YNEW,ZNEW)

C     PLOT TO THE POINT.

      CALL ABPLT

C     MOVE THE COORDINATES OF THE NEW POINT TO THE OLD POINT.

  50  XOLD = XNEW
      YOLD = YNEW
      ZOLD = ZNEW
      LOWFLG = OWFLG
      SAVEF = .FALSE.

C     CHECK THE PLOTTING MODE.

      IF(PMODE .EQ. POINT .OR. PMODE .EQ. ALPHA)RETURN
      PENF = .TRUE.
      IF(PMODE .NE. DASH)GO TO 60

C     REINITIALIZE THE SEGMENT COUNTER.

      IDSEG = 1
      SEG = DSEG(1)
  60  XNEW = XTEMP
      YNEW = YTEMP
      ZNEW = ZTEMP
      IF(.NOT. WINDOF)GO TO 120

C     CALCULATE THE NEW OFF-WINDOW FLAG.

      OWFLG = 0
      IF(XNEW .GT. XMAX)OWFLG = 1
      IF(XNEW .LT. XMIN)OWFLG = 2
      IF(YNEW .GT. YMAX)OWFLG = OWFLG + 4
      IF(YNEW .LT. YMIN)OWFLG = OWFLG + 8

C     CHECK THE OLD AND NEW POINTS TO SEE IF THEY ARE BOTH OUT-
C     SIDE THE BOUNDARY OF THE WINDOW IN THE SAME DIRECTION.  IF
C     SO, NO INTERCEPT EXISTS.

# ifdef NEED_IAND
       IF(IAND(LOWFLG,OWFLG) .NE. 0)GOTO 190
# else
       IF(AND(LOWFLG,OWFLG) .NE. 0)GOTO 190
# endif

C     CHECK THE OLD POINT TO SEE IF IT IS WITHIN THE BOUNDARY OF
C     THE WINDOW.  IF NOT, COMPUTE THE INTERCEPT.

      IF(LOWFLG .EQ. 0)GO TO 90

C     CHECK THE HORIZONTAL LIMITS OF THE WINDOW.

# ifdef NEED_IAND
      IF(ISHFT(LOWFLG,-2) .EQ. 0)GO TO 70
# else
      IF(rSHIFT(LOWFLG,2) .EQ. 0)GO TO 70
# endif

C     THE POINT IS OUTSIDE THE HORIZONTAL LIMITS OF THE WINDOW.
C     CALCULATE THE INTERCEPT.

# ifdef NEED_IAND
      YINTER = YMXMN(ISHFT(LOWFLG,-2))
# else
      YINTER = YMXMN(rSHIFT(LOWFLG,2))
# endif

      ZINTER = (ZNEW - ZOLD) * (YINTER - YOLD) / (YNEW - YOLD) +
     * ZOLD
      XINTER = (XNEW - XOLD) * (YINTER - YOLD) / (YNEW - YOLD) +
     * XOLD

C     CHECK THE INTERCEPT TO INSURE THAT IT IS ON THE BOUNDARY
C     OF THE WINDOW

      IF(XINTER + 0.001 .GE. XMIN .AND. XINTER - 0.001 .LE. XMAX)
     * GOTO 80

C     THE POINT IS OUTSIDE THE VERTICAL LIMITS OF THE WINDOW.
C     CALCULATE THE INTERCEPT.

      irecompute = 0
# ifdef NEED_IAND
 70   XINTER = XMXMN(IAND(LOWFLG,3))
      IF (IAND(LOWFLG,3) .LT.1 .OR. IAND(LOWFLG,3).GT.2) irecompute = 1
# else
 70   XINTER = XMXMN(AND(LOWFLG,3))
      IF (AND(LOWFLG,3) .LT.1 .OR. AND(LOWFLG,3).GT.2) irecompute = 1
# endif

      YINTER = (YNEW - YOLD) * (XINTER - XOLD) / (XNEW - XOLD) +
     * YOLD
      ZINTER = (ZNEW - ZOLD) * (XINTER - XOLD) / (XNEW - XOLD) +
     * ZOLD

C     CHECK THE INTERCEPT TO INSURE THAT IT IS ON THE BOUNDARY
C     OF THE WINDOW.

      IF(YINTER + 0.001 .LT. YMIN .OR. YINTER - 0.001 .GT. YMAX)
     * GO TO 190

C     TRANSFORM THE INTERCEPT TO THE SCREEN COORDINATE SYSTEM.

  80  CALL TFORM(XINTER,YINTER,ZINTER)
      XOLD = XINTER
      YOLD = YINTER
      ZOLD = ZINTER
      AOLD = ANEW
      BOLD = BNEW 

C     CALCULATE THE OLD OFF-SCREEN FLAG.

C     LOSFLG = 0
******************************************************************
C FERRET mod - bypass GKS clipping - 9-19-88
      IF ( ptype .LT. 3 ) THEN
          IF(AOLD - 0.001 .GT. AMAX)LOSFLG = 1
          IF(AOLD + 0.001 .LT. AMIN)LOSFLG = 2
          IF(BOLD - 0.001 .GT. BMAX)LOSFLG = LOSFLG + 4
          IF(BOLD + 0.001 .LT. BMIN)LOSFLG = LOSFLG + 8
       ENDIF
C end of FERRET mod
******************************************************************

C     CHECK THE NEW POINT TO SEE IF IT IS WITHIN THE BOUNDARY OF
C     THE WINDOW.  IF NOT, COMPUTE THE INTERCEPT.

 90   IF(OWFLG .EQ. 0)GO TO 120

C     CHECK THE HORIZONTAL LIMITS OF THE WINDOW.

# ifdef NEED_IAND
      IF(ISHFT(OWFLG,-2) .EQ. 0)GO TO 100
# else
      IF(rSHIFT(OWFLG,2) .EQ. 0)GO TO 100
# endif

C     THE POINT IS OUTSIDE THE HORIZONTAL LIMITS OF THE WINDOW.
C     CALCULATE THE INTERCEPT.

# ifdef NEED_IAND
      YINTER = YMXMN(ISHFT(OWFLG,-2))
# else
      YINTER = YMXMN(rSHIFT(OWFLG,2))
# endif

      ZINTER = (ZNEW - ZOLD) * (YINTER - YOLD) / (YNEW - YOLD) +
     * ZOLD
      XINTER = (XNEW - XOLD) * (YINTER - YOLD) / (YNEW - YOLD) +
     * XOLD

C     CHECK THE INTERCEPT TO INSURE THAT IT IS ON THE BOUNDARY
C     OF THE WINDOW.

      IF(XINTER + 0.001 .GE. XMIN .AND. XINTER - 0.001 .LE. XMAX)
     * GO TO 110

C     THE POINT IS OUTSIDE THE VERTICAL LIMITS OF THE WINDOW.
C     CALCULATE THE INTERCEPT.

# ifdef NEED_IAND
 100  XINTER = XMXMN(IAND(OWFLG,3))
# else
 100  XINTER = XMXMN(AND(OWFLG,3))
# endif

      YINTER = (YNEW - YOLD) * (XINTER - XOLD) / (XNEW - XOLD) +
     * YOLD
      ZINTER = (ZNEW - ZOLD) * (XINTER - XOLD) / (XNEW - XOLD) +
     * ZOLD

C recompute these now that we have a correct xinter and corrected yintr, zintr
C and before calling abplt.

      IF (irecompute .EQ. 1) THEN
         CALL TFORM(XINTER,YINTER,ZINTER)
         XOLD = XINTER
         YOLD = YINTER
         ZOLD = ZINTER
         AOLD = ANEW
         BOLD = BNEW 
      ENDIF

C     CHECK THE PLOTTING MODE.

 110  IF(PMODE .EQ. VECTOR)GO TO 160
      DX = XINTER - XOLD
      DY = YINTER - YOLD
      DZ = ZINTER - ZOLD
      GO TO 130

C     CHECK THE PLOTTING MODE.

 120  IF(PMODE .EQ. VECTOR)GO TO 170
      DX = XNEW - XOLD
      DY = YNEW - YOLD
      DZ = ZNEW - ZOLD

C     INITIALIZE VARIABLES IN PREPARATION FOR DRAWING A DASHED
C     LINE.

 130  DIST = SQRT(DX * DX + DY * DY + DZ * DZ)
      IF(DIST .EQ. 0.0)GO TO 150
      COSX = DX / DIST
      COSY = DY / DIST
      COSZ = DZ / DIST

C     DRAW A DASHED LINE ONE SEGMENT AT A TIME.

# ifdef NEED_IAND
 140  PENF = IAND(IDSEG,1) .NE. 0
# else 
 140  PENF = AND(IDSEG,1) .NE. 0
# endif

      IF(SEG .GE. DIST)GO TO 150
      XOLD = XOLD + SEG * COSX
      YOLD = YOLD + SEG * COSY
      ZOLD = ZOLD + SEG * COSZ

C     TRANSFORM THE END OF THE SEGMENT TO THE SCREEN COORDINATE
C     SYSTEM.

      CALL TFORM(XOLD,YOLD,ZOLD)

C     PLOT TO THE END OF THE SEGMENT.

      CALL ABPLT
      DIST = DIST - SEG

# ifdef NEED_IAND
      IDSEG = IAND(IDSEG,3) + 1
# else
      IDSEG = AND(IDSEG,3) + 1
# endif

      SEG = DSEG(IDSEG)
      GO TO 140
 150  SEG = SEG - DIST

C     CHECK THE NEW POINT TO SEE IF IT IS WITHIN THE BOUNDARY OF
C     THE WINDOW.  IF NOT, PLOT TO THE INTERCEPT.

      IF(OWFLG .EQ. 0)GO TO 170

C     TRANSFORM THE INTERCEPT TO THE SCREEN COORDINATE SYSTEM.

 160  CALL TFORM(XINTER,YINTER,ZINTER)
      GO TO 180

C     TRANSFORM THE POINT TO THE SCREEN COORDINATE SYSTEM.

 170  CALL TFORM(XNEW,YNEW,ZNEW)

C     PLOT TO THE POINT.

 180  CALL ABPLT

C     MOVE THE COORDINATES OF THE NEW POINT TO THE OLD POINT.

 190  XOLD = XNEW
      YOLD = YNEW
      ZOLD = ZNEW
      LOWFLG = OWFLG
      RETURN 

      END

	SUBROUTINE  CONV_ADJ_mask( t    , mt,
     .				   s    , ms,
     .				   cmask, mcmask )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute a mask with bad data flags indicating regions of convective adjustment
* and 1's indicating regions without it
* note: at K=1 this algorithm fails to detect a pass #1 convective adjustment
*	that gets wiped out by pass #2 - ie k=1 is mixed with  k=2 on pass one,
*	then k=2 is mixed with k=3 on pass #2 --> K=1 and K=2 are unequal at the
*	end
*	At K=km it will succeed or fail depending on whether km is odd or even

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 -7/22/87
*			with major modifications to convert i-k oriented
*			calculations to i-j oriented calculations
* V200:  7/27/89 - 4D symmetrical version
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl.parm'		! parameter definitions
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'

* calling argument declarations:
	INTEGER	mt, ms, mcmask

* subscript ranges from memory variable table ...
	REAL        t( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit ),
     .		    s( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,m2lot:m2hit ),
     .		cmask( m3lox:m3hix,m3loy:m3hiy,m3loz:m3hiz,m3lot:m3hit )

* internal variable declarations:
	INTEGER	i_lo, i_hi, j_lo, j_hi, i, j, k, l
	REAL	bad_t, bad_cmask

****************   205 model code   ******************************************
******************************************************************************
* 3199 C   FIND DENSITY FOR STABILITY DETERMINATION
* 3200 C
* 3201       DO 965 KS=1,2
* 3202       CALL STATEC(TA,TA(1,1,2),RHON,TDIF,TDIF(1,1,2),KS)
* 3203 C
* 3204 C   CONVECTIVELY ADJUST ADJACENT PAIRS OF BOXES IF GRAVITATIONALLY UNSTA
* 3205 C
* 3206       DO 960 M=1,NT1
* 3207       TEMP(1,1;IMT*KM)=0.5*C2DZ2D(1,1;IMT*KM)*TA(1,1,M;IMT*KM)
* 3208       LN=(2*((KMM1-KS)/2)+1)*IMT
* 3209       WHERE (KALTBV(1,KS,KS;LN).AND.RHON(1,KS;LN).GT.RHON(1,KS+1;LN))
* 3210         TA(1,KS,M;LN)=(TEMP(1,KS;LN)+TEMP(1,KS+1;LN))
* 3211      *                 *DZZ2R2D(1,KS+1;LN)
* 3212         TA(1,KS+1,M;LN)=TA(1,KS,M;LN)
* 3213       ENDWHERE
* 3214  960  CONTINUE
* 3215  965  CONTINUE
*****************************************************************************
* --- end of introductory code ---

* limits for calculation
	i_lo = mr_lo_s1(mcmask)
	i_hi = mr_hi_s1(mcmask)
	j_lo = mr_lo_s2(mcmask)
	j_hi = mr_hi_s2(mcmask)

* flag for bad/missing data
	bad_t    = mr_bad_data( mt )
	bad_cmask = bad_val4

	DO 2000 l = mr_lo_s4(mcmask), mr_hi_s4(mcmask)
	DO 2000 k = mr_lo_s3(mcmask), mr_hi_s3(mcmask)

* preset entire mask to a value of 1.0
	DO 10 j = j_lo, j_hi
	DO 10 i = i_lo, i_hi
 10	cmask(i,j,k,l) = 1.0

* since convective adjustment is computed in 2 passes we presume a point has
* been convectively adjusted in this time step if its density is identical to
* the density immediately above or below

	IF ( k .GT. 1 ) THEN
* ... check against plane above
	   DO 200 j = j_lo, j_hi
	      DO 100 i = i_lo, i_hi

* ... only check temp for bad data - assume salt is bad at the same points
	         IF ( t(i,j,k-1,l) .EQ. bad_t
     .	         .OR. t(i,j,k  ,l) .EQ. bad_t ) THEN
	            cmask(i,j,k,l) = bad_cmask

	         ELSEIF (t(i,j,k,l) .EQ. t(i,j,k-1,l)
     .	          .AND.  s(i,j,k,l) .EQ. s(i,j,k-1,l) ) THEN
	            cmask(i,j,k,l) = bad_cmask

	         ENDIF
 100	      CONTINUE
 200	   CONTINUE	
	ENDIF

	IF ( k .LT. km ) THEN
* ... check against plane below
	   DO 400 j = j_lo, j_hi
	      DO 300 i = i_lo, i_hi

* ... only check temp for bad data - assume salt is bad at the same points
	         IF ( t(i,j,k+1,l) .EQ. bad_t
     .	         .OR. t(i,j,k  ,l) .EQ. bad_t ) THEN
	            cmask(i,j,k,l) = bad_cmask

	         ELSEIF (t(i,j,k,l) .EQ. t(i,j,k+1,l)
     .	          .AND.  s(i,j,k,l) .EQ. s(i,j,k+1,l) ) THEN
	            cmask(i,j,k,l) = bad_cmask

	         ENDIF
 300	      CONTINUE
 400	   CONTINUE	
	ENDIF

 2000	CONTINUE
	RETURN
	END

*
* write_webrow_gwt.F
*
* Ansley Manke
* April 2009
*
* This function writes a special webrowset file for LAS
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE write_webrow_gwt_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg
      CHARACTER*100 descrip


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      WRITE (descrip, 100)
      CALL ef_set_desc(id, descrip)
  100 FORMAT (
     . 'Write a webrowset file with cruise numbers and IDs (used by LAS)')

      CALL ef_set_num_args(id, 4)
      CALL ef_set_axis_inheritance(id,  ABSTRACT,
     .     NORMAL, NORMAL, NORMAL)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'id')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_type (id, arg, STRING_ARG)
      CALL ef_set_arg_desc(id, arg, 'Cruise IDs (string)')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'name')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_type (id, arg, STRING_ARG)
      CALL ef_set_arg_desc(id, arg, 'Cruise name (string)')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'Cruise_Mask')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'Mask =1 at start of each cruise')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
      
      arg = 4
      CALL ef_set_arg_name(id, arg, 'filename')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_type (id, arg, STRING_ARG)
      CALL ef_set_arg_desc(id, arg, 'Filename to write')
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END



      SUBROUTINE write_webrow_gwt_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER nx

      nx = 1
      call ef_set_axis_limits(id, X_AXIS, 1, nx)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE write_webrow_gwt_compute(id, arg_1, arg_2, arg_3, arg_4, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id, arg

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(2,mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(2,mem2lox:mem2hix, mem2loy:mem2hiy, 
     .           mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, 
     .           mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, 
     .           mem4loz:mem4hiz, mem4lot:mem4hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER slen, blen, iunit, icruise, nd
      INTEGER i1,j1,k1,l1, i2,j2,k2,l2
      CHARACTER*512 fname
      CHARACTER*100 errtxt
      CHARACTER*512 buff, buff_cname

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

C  Get file name

      arg = 4
      CALL ef_get_arg_string(id, arg, fname)

      iunit = 19

       OPEN( UNIT        = iunit,
     .       FILE        = fname,
     .       FORM        = 'FORMATTED',
     .       ACCESS      = 'SEQUENTIAL',
     .       STATUS      = 'REPLACE',
     .       ERR         = 5010 )

* Write webrowset header.

      buff = "<?xml version='1.0'?>"
      slen = 21
      WRITE (iunit, 1000) buff(1:slen)
 1000 FORMAT(A)
      buff = "<webRowSet>"
      slen = 99
      WRITE (iunit, 1000) buff(1:slen)

      WRITE (iunit, *) '<data>'

* Write cruise ids and numbers to the webrowset file...

      j1 = arg_lo_ss(Y_AXIS,ARG1)
      k1 = arg_lo_ss(Z_AXIS,ARG1)
      l1 = arg_lo_ss(T_AXIS,ARG1)
      i = res_lo_ss(X_AXIS)

* If the cruise_name is different from the cruise_id,
* write the cruise_name in parentheses after the ID.

      icruise = 0
      DO 100 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)
         IF (arg_3(i1,j1,k1,l1) .NE. bad_flag(ARG3)) THEN
            icruise = icruise + 1 
	    IF (icruise .LT. 10) 
     .	       WRITE (iunit, 1010) icruise
	    IF (icruise .GE. 10 .AND. icruise .LT. 100) 
     .	       WRITE (iunit, 1012) icruise
	    IF (icruise .GE. 100) 
     .	        WRITE (iunit, 1014) icruise
	    IF (icruise .GE. 1000) 
     .	        WRITE (iunit, 1015) icruise

            CALL EF_GET_STRING_ARG_ELEMENT(id, ARG1, arg_1,
     .                          i1,j1,k1,l1, slen, buff)
            CALL EF_GET_STRING_ARG_ELEMENT(id, ARG2, arg_2,
     .                          i1,j1,k1,l1, blen, buff_cname)
            IF (slen .EQ. blen) THEN
	       IF (buff(:slen) .EQ. buff_cname(:slen)) blen = 0
	    ENDIF
            IF (blen .GT. 0) THEN
	       buff(slen+1:slen+2) = ' ('
	       slen = slen + 2
	       buff(slen+1:slen+blen) = buff_cname(:blen)
	       slen = slen + blen
	       buff(slen+1:slen+1) = ')'
	       slen = slen + 1
	    ENDIF

            WRITE (iunit, 1020) buff(1:slen)
	 ENDIF
 100  CONTINUE

1010  FORMAT('<currentRow>'/'<columnValue>'/I1/'</columnValue>')
1012  FORMAT('<currentRow>'/'<columnValue>'/I2/'</columnValue>')
1014  FORMAT('<currentRow>'/'<columnValue>'/I3/'</columnValue>')
1015  FORMAT('<currentRow>'/'<columnValue>'/I4/'</columnValue>')
1020  FORMAT('<columnValue>'/A/'</columnValue>'/'</currentRow>')

* Write closing tag.
      WRITE (iunit, 1030) 
1030  FORMAT ('</data>'/'</webRowSet>')

      CLOSE (iunit, ERR = 5020 )
      i = res_lo_ss(X_AXIS)
      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Y_AXIS)
      l = res_lo_ss(Y_AXIS)
      result(i,j,k,l) = 1.

      RETURN 

5010  CONTINUE
      WRITE(errtxt,*) 'Error opening file ', fname
      CALL EF_BAIL_OUT(id, errtxt)
      RETURN
5020  CONTINUE
      WRITE(errtxt,*) 'Error closing file ', fname
      CALL EF_BAIL_OUT(id, errtxt)
      RETURN

      END

	INTEGER FUNCTION DO_FILL_NEAR(  idim, arg,
     .					com, com_mr, com_cx,
     .					res, res_mr, res_cx,
     .					buff	)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* fill along axis idim by duplicating the closest available valid pt

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V???:  3/23/99 - based on DO_FILL_AVE
*         7/2/99 - changed logic so if 2 equi-distant points use the mean
*                - corrected subscriptong bug in L axis search
* V550 *sh* 8/02 - support for modulo lengths. ensure that filling 
*		   does not operate acros the subspan modulo void point
*	   11/02 - change no_point to a very negative nalue (was -1)
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)

* Note:  this routine could be made simpler and faster by arranging single
*        inner loops that looped "loop=1,edge" looking at index-loop and
*        index+loop to find the first valid point(s)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include	'xprog_state.cmn'

* calling argument declarations:
	INTEGER	idim, com_mr, com_cx, res_mr, res_cx
	REAL	arg, buff(*),
     .          com( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          res( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif )

* internal variable declarations:
	LOGICAL	TM_ITS_SUBSPAN_MODULO, has_mod_void
	INTEGER TM_MODULO_LINE_DIM, CGRID_AXIS,
     .		i, j, k, l, m, n, ii, jj, kk, ll, mm, nn, 
     .          lo_sub(nferdims), hi_sub(nferdims),
     .		lo_edge, hi_edge, lo_pos, hi_pos, edge,
     .		npts, line
	REAL	bad_res, lo_val, hi_val

* internal (convenience) equivalences
	INTEGER	lo_s1, lo_s2, lo_s3, lo_s4, lo_s5, lo_s6,
     .          hi_s1, hi_s2, hi_s3, hi_s4, hi_s5, hi_s6
	EQUIVALENCE (lo_s1, lo_sub(1)) , (lo_s2, lo_sub(2)),
     .		    (lo_s3, lo_sub(3)) , (lo_s4, lo_sub(4)),
     .		    (lo_s5, lo_sub(5)) , (lo_s6, lo_sub(6)),
     .		    (hi_s1, hi_sub(1)) , (hi_s2, hi_sub(2)),
     .		    (hi_s3, hi_sub(3)) , (hi_s4, hi_sub(4)),
     .		    (hi_s5, hi_sub(5)) , (hi_s6, hi_sub(6))

* local parameter declarations
	INTEGER     no_point
	PARAMETER ( no_point = -99999 )

* diagnostic mode output: " doing --> VAR_NAME[x=lo:hi@TRN:n,D=#]"
	IF ( mode_diagnostic ) 	CALL DIAG_OP
     .				( 'doing', isact_class_trans, res_cx, idim )

* initialize
	bad_res = mr_bad_data( com_mr )
	edge = arg
	line = CGRID_AXIS(idim, com_cx)
	has_mod_void = TM_ITS_SUBSPAN_MODULO(line)
	npts = TM_MODULO_LINE_DIM(line)

* compute limits within which calculation is straightforward
	DO 10 ii = 1, nferdims
	   lo_sub(ii) = cx_lo_ss(res_cx,ii)
	   hi_sub(ii) = cx_hi_ss(res_cx,ii)
 10	CONTINUE
	lo_edge = MAX( lo_sub(idim)-edge, cx_lo_ss(com_cx, idim) )
	hi_edge = MIN( hi_sub(idim)+edge, cx_hi_ss(com_cx, idim) )

* FILL ALONG X AXIS
	IF ( idim .EQ. x_dim ) THEN
	   DO 110 n = lo_s6, hi_s6
	   DO 110 m = lo_s5, hi_s5
	   DO 110 l = lo_s4, hi_s4
	   DO 110 k = lo_s3, hi_s3
	   DO 110 j = lo_s2, hi_s2
           lo_pos = no_point
           hi_pos = no_point
           DO 101 i = lo_edge, lo_s1
              IF ( com(i,j,k,l,m,n) .NE. bad_res ) THEN
                 lo_val = com(i,j,k,l,m,n)
                 lo_pos = i
              ENDIF
 101       CONTINUE
	   DO 110 i = lo_s1, hi_s1
	      IF ( com(i,j,k,l,m,n) .NE. bad_res ) THEN
	         res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
                 lo_val = com(i,j,k,l,m,n)
                 lo_pos = i
	         GOTO 110
	      ENDIF
* ... look forward for next valid point
              IF ( hi_pos .LT. i ) THEN
                 DO 104 ii = i+1, hi_edge
                    IF ( com(ii,j,k,l,m,n) .NE. bad_res ) THEN
                       hi_pos = ii
                       hi_val = com(ii,j,k,l,m,n)
                       GOTO 108
                    ENDIF
 104             CONTINUE
                 hi_pos = no_point
              ENDIF
* ... choose closest valid point
 108          IF ( has_mod_void ) THEN
*    ... forbid crossing a subspan modulo void point
	         IF (lo_pos.NE.no_point) THEN
	           IF (i/npts .NE. lo_pos/npts) lo_pos=no_point
	         ENDIF
	         IF (hi_pos.NE.no_point) THEN
	           IF (i/npts .NE. hi_pos/npts) hi_pos=no_point
	         ENDIF
	      ENDIF

	      IF ( lo_pos.EQ.no_point ) THEN
                 IF ( hi_pos.EQ.no_point ) THEN
                    res(i,j,k,l,m,n) = bad_res
                 ELSE
                    res(i,j,k,l,m,n) = hi_val
                 ENDIF
              ELSE
                 IF ( hi_pos.EQ.no_point ) THEN
                    res(i,j,k,l,m,n) = lo_val
                 ELSEIF ( i-lo_pos .EQ. hi_pos-i ) THEN
                    res(i,j,k,l,m,n) = ( lo_val + hi_val ) /2.
                 ELSEIF ( i-lo_pos .LT. hi_pos-i ) THEN
                    res(i,j,k,l,m,n) = lo_val
                 ELSE
                    res(i,j,k,l,m,n) = hi_val
                 ENDIF
              ENDIF
	      IF (has_mod_void) THEN
	         IF (MOD(i,npts) .EQ. 0)
     .              res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
	      ENDIF
 110	   CONTINUE

* FILL ALONG Y AXIS
	ELSEIF ( idim .EQ. y_dim ) THEN
	   DO 210 n = lo_s6, hi_s6
	   DO 210 m = lo_s5, hi_s5
	   DO 210 l = lo_s4, hi_s4
	   DO 210 k = lo_s3, hi_s3
	   DO 210 i = lo_s1, hi_s1
           lo_pos = no_point
           hi_pos = no_point
           DO 201 j = lo_edge, lo_s2
              IF ( com(i,j,k,l,m,n) .NE. bad_res ) THEN
                 lo_val = com(i,j,k,l,m,n)
                 lo_pos = j
              ENDIF
 201       CONTINUE
	   DO 210 j = lo_s2, hi_s2
	      IF ( com(i,j,k,l,m,n) .NE. bad_res ) THEN
	         res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
                 lo_val = com(i,j,k,l,m,n)
                 lo_pos = j
	         GOTO 210
	      ENDIF
* ... look forward for next valid point
              IF ( hi_pos .LT. j ) THEN
                 DO 204 jj = j+1, hi_edge
                    IF ( com(i,jj,k,l,m,n) .NE. bad_res ) THEN
                       hi_pos = jj
                       hi_val = com(i,jj,k,l,m,n)
                       GOTO 208
                    ENDIF
 204             CONTINUE
                 hi_pos = no_point
              ENDIF
* ... choose closest valid point
 208          IF ( has_mod_void ) THEN
*    ... forbid crossing a subspan modulo void point
	         IF (lo_pos.NE.no_point) THEN
	           IF (j/npts .NE. lo_pos/npts) lo_pos=no_point
	         ENDIF
	         IF (hi_pos.NE.no_point) THEN
	           IF (j/npts .NE. hi_pos/npts) hi_pos=no_point
	         ENDIF
	      ENDIF

             IF ( lo_pos.EQ.no_point ) THEN
                 IF ( hi_pos.EQ.no_point ) THEN
                    res(i,j,k,l,m,n) = bad_res
                 ELSE
                    res(i,j,k,l,m,n) = hi_val
                 ENDIF
              ELSE
                 IF ( hi_pos.EQ.no_point ) THEN
                    res(i,j,k,l,m,n) = lo_val
                 ELSEIF ( j-lo_pos .EQ. hi_pos-j ) THEN
                    res(i,j,k,l,m,n) = ( lo_val + hi_val ) /2.
                 ELSEIF ( j-lo_pos .LT. hi_pos-j ) THEN
                    res(i,j,k,l,m,n) = lo_val
                 ELSE
                    res(i,j,k,l,m,n) = hi_val
                 ENDIF
              ENDIF
	      IF (has_mod_void) THEN
	         IF (MOD(j,npts) .EQ. 0)
     .              res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
	      ENDIF
 210	   CONTINUE

* FILL ALONG Z AXIS
	ELSEIF ( idim .EQ. z_dim ) THEN
	   DO 310 n = lo_s6, hi_s6
	   DO 310 m = lo_s5, hi_s5
	   DO 310 l = lo_s4, hi_s4
	   DO 310 j = lo_s2, hi_s2
	   DO 310 i = lo_s1, hi_s1
           lo_pos = no_point
           hi_pos = no_point
           DO 301 k = lo_edge, lo_s3
              IF ( com(i,j,k,l,m,n) .NE. bad_res ) THEN
                 lo_val = com(i,j,k,l,m,n)
                 lo_pos = k
              ENDIF
 301       CONTINUE
	   DO 310 k = lo_s3, hi_s3
	      IF ( com(i,j,k,l,m,n) .NE. bad_res ) THEN
	         res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
                 lo_val = com(i,j,k,l,m,n)
                 lo_pos = k
	         GOTO 310
              ENDIF
* ... look forward for next valid point
              IF ( hi_pos .LT. k ) THEN
                 DO 304 kk = k+1, hi_edge
                    IF ( com(i,j,kk,l,m,n) .NE. bad_res ) THEN
                       hi_pos = kk
                       hi_val = com(i,j,kk,l,m,n)
                       GOTO 308
                    ENDIF
 304             CONTINUE
                 hi_pos = no_point
              ENDIF
* ... choose closest valid point
 308          IF ( has_mod_void ) THEN
*    ... forbid crossing a subspan modulo void point
	         IF (lo_pos.NE.no_point) THEN
	           IF (k/npts .NE. lo_pos/npts) lo_pos=no_point
	         ENDIF
	         IF (hi_pos.NE.no_point) THEN
	           IF (k/npts .NE. hi_pos/npts) hi_pos=no_point
	         ENDIF
	      ENDIF

              IF ( lo_pos.EQ.no_point ) THEN
                 IF ( hi_pos.EQ.no_point ) THEN
                    res(i,j,k,l,m,n) = bad_res
                 ELSE
                    res(i,j,k,l,m,n) = hi_val
                 ENDIF
              ELSE
                 IF ( hi_pos.EQ.no_point ) THEN
                    res(i,j,k,l,m,n) = lo_val
                 ELSEIF ( k-lo_pos .EQ. hi_pos-k ) THEN
                    res(i,j,k,l,m,n) = ( lo_val + hi_val ) /2.
                 ELSEIF ( k-lo_pos .LT. hi_pos-k ) THEN
                    res(i,j,k,l,m,n) = lo_val
                 ELSE
                    res(i,j,k,l,m,n) = hi_val
                 ENDIF
              ENDIF
	      IF (has_mod_void) THEN
	         IF (MOD(k,npts) .EQ. 0)
     .              res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
	      ENDIF
 310	   CONTINUE

* FILL ALONG T AXIS
	ELSEIF ( idim .EQ. t_dim ) THEN
	   DO 410 n = lo_s6, hi_s6
	   DO 410 m = lo_s5, hi_s5
	   DO 410 k = lo_s3, hi_s3
	   DO 410 j = lo_s2, hi_s2
	   DO 410 i = lo_s1, hi_s1
           lo_pos = no_point
           hi_pos = no_point
           DO 401 l = lo_edge, lo_s4
              IF ( com(i,j,k,l,m,n) .NE. bad_res ) THEN
                 lo_val = com(i,j,k,l,m,n)
                 lo_pos = l
              ENDIF
 401       CONTINUE
	   DO 410 l = lo_s4, hi_s4
	      IF ( com(i,j,k,l,m,n) .NE. bad_res ) THEN
	         res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
                 lo_val = com(i,j,k,l,m,n)
                 lo_pos = l
	         GOTO 410
	      ENDIF
              IF ( hi_pos .LT. l ) THEN
* ... look forward for next valid point
                 DO 404 ll = l+1, hi_edge
                    IF ( com(i,j,k,ll,m,n) .NE. bad_res ) THEN
                       hi_pos = ll
                       hi_val = com(i,j,k,ll,m,n)
                       GOTO 408
                    ENDIF
 404             CONTINUE
                 hi_pos = no_point
              ENDIF
* ... choose closest valid point
 408          IF ( has_mod_void ) THEN
*    ... forbid crossing a subspan modulo void point
	         IF (lo_pos.NE.no_point) THEN
	           IF (l/npts .NE. lo_pos/npts) lo_pos=no_point
	         ENDIF
	         IF (hi_pos.NE.no_point) THEN
	           IF (l/npts .NE. hi_pos/npts) hi_pos=no_point
	         ENDIF
	      ENDIF

              IF ( lo_pos.EQ.no_point ) THEN
                 IF ( hi_pos.EQ.no_point ) THEN
                    res(i,j,k,l,m,n) = bad_res
                 ELSE
                    res(i,j,k,l,m,n) = hi_val
                 ENDIF
              ELSE
                 IF ( hi_pos.EQ.no_point ) THEN
                    res(i,j,k,l,m,n) = lo_val
                 ELSEIF ( l-lo_pos .EQ. hi_pos-l ) THEN
                    res(i,j,k,l,m,n) = ( lo_val + hi_val ) /2.
                 ELSEIF ( l-lo_pos .LT. hi_pos-l ) THEN
                    res(i,j,k,l,m,n) = lo_val
                 ELSE
                    res(i,j,k,l,m,n) = hi_val
                 ENDIF
              ENDIF
	      IF (has_mod_void) THEN
	         IF (MOD(l,npts) .EQ. 0)
     .              res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
	      ENDIF
 410	   CONTINUE


* FILL ALONG E AXIS
	ELSEIF ( idim .EQ. e_dim ) THEN
	   DO 510 n = lo_s6, hi_s6
	   DO 510 l = lo_s4, hi_s4
	   DO 510 k = lo_s3, hi_s3
	   DO 510 j = lo_s2, hi_s2
	   DO 510 i = lo_s1, hi_s1
           lo_pos = no_point
           hi_pos = no_point
           DO 501 m = lo_edge, lo_s5
              IF ( com(i,j,k,l,m,n) .NE. bad_res ) THEN
                 lo_val = com(i,j,k,l,m,n)
                 lo_pos = m
              ENDIF
 501       CONTINUE
	   DO 510 m = lo_s5, hi_s5
	      IF ( com(i,j,k,l,m,n) .NE. bad_res ) THEN
	         res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
                 lo_val = com(i,j,k,l,m,n)
                 lo_pos = m
	         GOTO 510
	      ENDIF
              IF ( hi_pos .LT. m ) THEN
* ... Look forward for next valid point
                 DO 504 mm = m+1, hi_edge
                    IF ( com(i,j,k,l,mm,n) .NE. bad_res ) THEN
                       hi_pos = mm
                       hi_val = com(i,j,k,l,mm,n)
                       GOTO 508
                    ENDIF
 504             CONTINUE
                 hi_pos = no_point
              ENDIF
* ... choose closest valid point
 508          IF ( has_mod_void ) THEN
*    ... forbid crossing a subspan modulo void point
	         IF (lo_pos.NE.no_point) THEN
	           IF (m/npts .NE. lo_pos/npts) lo_pos=no_point
	         ENDIF
	         IF (hi_pos.NE.no_point) THEN
	           IF (m/npts .NE. hi_pos/npts) hi_pos=no_point
	         ENDIF
	      ENDIF

              IF ( lo_pos.EQ.no_point ) THEN
                 IF ( hi_pos.EQ.no_point ) THEN
                    res(i,j,k,l,m,n) = bad_res
                 ELSE
                    res(i,j,k,l,m,n) = hi_val
                 ENDIF
              ELSE
                 IF ( hi_pos.EQ.no_point ) THEN
                    res(i,j,k,l,m,n) = lo_val
                 ELSEIF ( m-lo_pos .EQ. hi_pos-m ) THEN
                    res(i,j,k,l,m,n) = ( lo_val + hi_val ) /2.
                 ELSEIF ( m-lo_pos .LT. hi_pos-m ) THEN
                    res(i,j,k,l,m,n) = lo_val
                 ELSE
                    res(i,j,k,l,m,n) = hi_val
                 ENDIF
              ENDIF
	      IF (has_mod_void) THEN
	         IF (MOD(m,npts) .EQ. 0)
     .              res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
	      ENDIF
 510	   CONTINUE

* FILL ALONG F AXIS
	ELSEIF ( idim .EQ. f_dim ) THEN
	   DO 610 m = lo_s5, hi_s5
	   DO 610 l = lo_s4, hi_s4
	   DO 610 k = lo_s3, hi_s3
	   DO 610 j = lo_s2, hi_s2
	   DO 610 i = lo_s1, hi_s1
           lo_pos = no_point
           hi_pos = no_point
           DO 601 n = lo_edge, lo_s6
              IF ( com(i,j,k,l,m,n) .NE. bad_res ) THEN
                 lo_val = com(i,j,k,l,m,n)
                 lo_pos =n
              ENDIF
 601       CONTINUE
	   DO 610 n = lo_s6, hi_s6
	      IF ( com(i,j,k,l,m,n) .NE. bad_res ) THEN
	         res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
                 lo_val = com(i,j,k,l,m,n)
                 lo_pos = n
	         GOTO 610
	      ENDIF
              IF ( hi_pos .LT. n ) THEN
* ... Look forward for next valid point
                 DO 604 nn = n+1, hi_edge
                    IF ( com(i,j,k,l,m,nn) .NE. bad_res ) THEN
                       hi_pos = nn
                       hi_val = com(i,j,k,l,m,nn)
                       GOTO 608
                    ENDIF
 604             CONTINUE
                 hi_pos = no_point
              ENDIF
* ... choose closest valid point
 608          IF ( has_mod_void ) THEN
*    ... forbid crossing a subspan modulo void point
	         IF (lo_pos.NE.no_point) THEN
	           IF (n/npts .NE. lo_pos/npts) lo_pos=no_point
	         ENDIF
	         IF (hi_pos.NE.no_point) THEN
	           IF (n/npts .NE. hi_pos/npts) hi_pos=no_point
	         ENDIF
	      ENDIF

              IF ( lo_pos.EQ.no_point ) THEN
                 IF ( hi_pos.EQ.no_point ) THEN
                    res(i,j,k,l,m,n) = bad_res
                 ELSE
                    res(i,j,k,l,m,n) = hi_val
                 ENDIF
              ELSE
                 IF ( hi_pos.EQ.no_point ) THEN
                    res(i,j,k,l,m,n) = lo_val
                 ELSEIF ( n-lo_pos .EQ. hi_pos-n ) THEN
                    res(i,j,k,l,m,n) = ( lo_val + hi_val ) /2.
                 ELSEIF ( n-lo_pos .LT. hi_pos-n ) THEN
                    res(i,j,k,l,m,n) = lo_val
                 ELSE
                    res(i,j,k,l,m,n) = hi_val
                 ENDIF
              ENDIF
	      IF (has_mod_void) THEN
	         IF (MOD(n,npts) .EQ. 0)
     .              res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
	      ENDIF
 610	   CONTINUE

	ENDIF

* always success
	DO_FILL_NEAR = ferr_ok
	RETURN

	END

      SUBROUTINE READTHD(ITAPEI,ITAPEO,NDATA,DI,TI,DF,TF,DT,IPRNT,
     1IWRITE,EXKEEP)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)readthd.f	1.1    3/10/88
C**
C**
C***********************************************************************        C**
C**                 EPIC
C**
C***********************************************************************        C**
C**
C
C  THIS SUBROUTINE WILL CALL HDRT1 TO READ IN A TIME SERIES HEADER FROM TAPE
C  ITAPEI, AND WILL CONTINUE TO READ IN HEADERS AS LONG AS THE 'HEADER
C  FOLLOWING' FLAG IS SET (LINE 2 COL 79). IF IPRNT IS TRUE, ALL 
C  HEADERS WILL BE WRITTEN TOP OUTPUT TAPE 6. IF IWRITE IS TRUE, THE
C  FIRST HEADER WILL BE WRITTEN TO TAPE ITAPEO
C
C  WRITTEN 10/84 BY M. VERSCHELL
C
      LOGICAL IPRNT,IWRITE,EXKEEP
      CHARACTER*80 THEADER(8)
      COMMON /COMTHDR/ THEADER
      CHARACTER*80 THEAD2(8)
      COMMON /comnxt/ THEAD2

      CHARACTER*1 BLANK
      DATA BLANK/' '/
C
C  READ IN FIRST HEADER, REPEAT UNTIL REQUESTED CAST (NCAST1) IS FOUND
C
  100 CALL HDRT1 (ITAPEI,NDATA,DI,TI,DF,TF,DT)
C
C  PRINT OR WRITE IT OUT AS REQUESTED
C
      IF (IPRNT) THEN
        WRITE(6,200) (THEADER(I),I=1,8)
  200   FORMAT(8(1X,A80/)/)
      ENDIF
      IF (IWRITE) THEN
        DO 300 I=1,8
          IF ((.NOT.EXKEEP).AND.(I.EQ.2)) THEN
            WRITE (ITAPEO) THEADER(I)(1:78),BLANK,THEADER(I)(80:80)
          ELSE
            WRITE (ITAPEO) THEADER(I)
          ENDIF
  300   CONTINUE
      ENDIF
C
C  IF N FLAG SET READ IN NEXT HEADER
C
        IF (THEADER(2)(79:79).EQ.'N') THEN
400       CALL NXTHDR(ITAPEI)
          IF (IPRNT) THEN
            IF (THEAD2(2)(78:78) .EQ. 'P') WRITE (6,201)
201         FORMAT (/' Composite series composed of these pieces:'/)
            WRITE (6,200) (THEAD2(I),I=1,8)
          ENDIF
          IF ((EXKEEP).AND.(IWRITE)) THEN
            DO 500 I=1,8
            WRITE (ITAPEO) THEADER(I)
  500       CONTINUE
          ENDIF
          IF (THEAD2(2)(79:79).EQ.'N') GOTO 400
        ENDIF
      RETURN
      END

	SUBROUTINE GET_DELTA_CONTEXT ( slash_dx0, delta_given, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* interpret delta coordinate limits of the FORM DX
* ... slash_dx0 is the qualifier number of dx less 1
* qualifiers are assumed to be ordered dx,dy,dz,dt,di,dj,dk,dl

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200: 10/27/89
*	  5/2/90 - half extracted to APPLY_DELTA_CONTEXT
* V420 (IBM/AIX port of V411): 10/5/95 - buffer for "READ(var,*"
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

* specifiers may give coordinate in subscript units (/DI,/DJ,/DK,/DL) or
* may give coordinate in "world" units (/DX,/DY,/DZ,/DT)
* the specifiers may be of the following forms:
*	/q=val			specifies a single delta
*	/q=val_1:val_2		specifies a separate delta for lowe and upper

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'errmsg.parm'	
	include 'ferret.parm'	
	include 'xcontext.cmn'
	include 'xdelta_context.cmn'
	include 'xprog_state.cmn'

* calling arguments:
	LOGICAL		delta_given
	INTEGER		slash_dx0, status

* internal variables:
	INTEGER		TM_LENSTR1, colon_pos, wworss, idim, iqual, loc, rlen
	CHARACTER	string*40, raw_string*44

* initialize
	delta_given = .FALSE.
	DO 10 idim = 1, nferdims
 10	dcx_given( idim ) = .FALSE.

* decode the delta qualifiers
	DO 200 wworss = 0, (nferdims+1), nferdims
	DO 100 idim = 1, nferdims

	   iqual = slash_dx0 + wworss + idim
	   loc = qual_given( iqual )
	   IF ( loc .EQ. 0 ) GOTO 100

	   delta_given = .TRUE.
	   IF ( dcx_given(idim) ) GOTO 5100
	   dcx_given(idim) = .TRUE.

* get the qualifier string
	   raw_string = cmnd_buff(qual_start(loc):qual_end(loc))
	   rlen = TM_LENSTR1(raw_string)
	   CALL EQUAL_STRING( raw_string, string, status )

* decode it
	   colon_pos = INDEX( string, ':' )
	   IF ( colon_pos .EQ. 0 ) THEN
	      READ( string, *, ERR=5200 ) dcx_lo(idim)
	      dcx_hi(idim) = dcx_lo(idim)		   
	   ELSE
*             Appending space just to get rid of a nonsense compiler warning
	      raw_string = string(:colon_pos-1)//' '
	      READ( raw_string, *, ERR=5200 ) dcx_lo(idim)	! AIX 10/95
	      raw_string = string(colon_pos+1:)
	      READ( raw_string, *, ERR=5200 ) dcx_hi(idim)	! AIX 10/95
	   ENDIF

* is it ww or ss ?
	   dcx_by_ss(idim) = wworss .EQ. nferdims

 100	CONTINUE
 200	CONTINUE

* success
	status = ferr_ok
	RETURN

* error exits
 5000	RETURN
 5100	CALL ERRMSG( ferr_relative_coord, status, 
     .		     'subscript and world position given on same axis: '//
     .		     raw_string(:rlen), *5000)
 5200	CALL ERRMSG( ferr_erreq, status, raw_string(:rlen), *5000)

	END

	LOGICAL FUNCTION TM_ITS_SUBSPAN_MODULO (axis)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Return TRUE if the indicated axis is both modulo and has a modulo length
* that is less than (or not equal to) its full span

* V541 *sh* 2/02
* V552 *acm*6/03  Too precise a test. When modulo_axlen is from a cdf file, 
*                 it is single precision. When put into double prec, the last 
*                 several digits have random stuff, so got a return of TRUE  
*                 from this fcn when it wasnt.  Do single-precision comparison.
* V720 *acm* 3/17 Fix ticket 2520. Axis longer than modulo lenght was marked subspan.
*      *acm* 8/18 Call TM_FPEQ_SNGL to make the comparison of axis lengths in 
*                 single precision.

	include 'tmap_dims.parm'
	include	'xtm_grid.cmn_text'

* calling argument declarations
	INTEGER axis

* internal variable declarations
	REAL*8 TM_WW_AXLEN, TM_MODULO_AXLEN
        LOGICAL TM_FPEQ_SNGL
        REAL wwlen, modlen
	REAL*4 rwwlen, rmodlen

	IF ( axis .LT. 0 .OR. axis .GT. line_ceiling ) THEN
	   TM_ITS_SUBSPAN_MODULO = .FALSE.
	ELSEIF ( line_modulo(axis) ) THEN

C for ticket 2520: axis that is slightly too LONG, was marked as subspan!
           wwlen = TM_WW_AXLEN(axis)
           modlen = TM_MODULO_AXLEN(axis) 

	   rwwlen = wwlen
	   rmodlen = modlen
	   TM_ITS_SUBSPAN_MODULO = (.NOT. TM_FPEQ_SNGL(rwwlen, rmodlen) )
     .                              .AND. (wwlen.LT.modlen)

	ELSE 
	   TM_ITS_SUBSPAN_MODULO = .FALSE.
	ENDIF

	RETURN
	END

C
C
C

        INTEGER FUNCTION TM_ITS_SUBSPAN_MODULO_INT(axis)
C
C For calling from C since it is dangerous to assume 
C what Fortran LOGICAL and their values are in C.
C
        INTEGER axis
        LOGICAL TM_ITS_SUBSPAN_MODULO

        IF ( TM_ITS_SUBSPAN_MODULO(axis) ) THEN
            TM_ITS_SUBSPAN_MODULO_INT = 1
        ELSE
            TM_ITS_SUBSPAN_MODULO_INT = 0
        ENDIF

        RETURN
        END

	SUBROUTINE GRAD_P_CLINIC   (	rhok   , mrhok   , 
     .					dpdx   , mdpdx   , 
     .					dpdy   , mdpdy 		)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute horizontal components of grad p assuming constant surface pressure

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 1/14/87 extracted from SUBROUTINE CLINIC
*			 with major modifications to convert i-k oriented
*			 calculations to i-j oriented calculations
* revision 0.1 - 4/3/87  corrected j offset error
* V200:  7/27/89 - 4D symmetrical version
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN
* V420 - 2/96 - fix bug in bounds checking on j loop

#ifdef unix
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl.parm'		! parameter definitions
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xonedim.cmn'	! geometric constants
	include 'xcontext.cmn'
#else
	INCLUDE 'FERRET_CMN:FERRET.PARM'
	INCLUDE 'FERRET_CMN:GFDL.PARM'		! parameter definitions
	INCLUDE	'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE	'FERRET_CMN:XMEM_SUBSC.CMN'
	INCLUDE 'FERRET_CMN:XONEDIM.CMN'	! geometric constants
	INCLUDE 'FERRET_CMN:XCONTEXT.CMN'
#endif

* calling argument declarations:
	INTEGER	mrhok, mdpdx, mdpdy

* subscript ranges from memory variable table ...
	REAL    rhok( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit ),
     .		dpdx( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,m2lot:m2hit ),
     .		dpdy( m3lox:m3hix,m3loy:m3hiy,m3loz:m3hiz,m3lot:m3hit )

* internal variable declarations:
	INTEGER	i_lo, i_hi, j_lo, j_hi, i, j, k, l
	REAL	bad_rhok, bad_dpdx, bad_dpdy,
     .		fact1, fact2, udif(im), vdif(im), udif1, vdif1, dpdx1, dpdy1

* --- end of introductory code ---

* limits for calculation
	i_lo = mr_lo_s1(mdpdx)
	i_hi = mr_hi_s1(mdpdx)
	j_lo = mr_lo_s2(mdpdx)
	j_hi = mr_hi_s2(mdpdx)

* flag for bad/missing data
	bad_rhok = mr_bad_data( mrhok )
	bad_dpdx = mr_bad_data( mdpdx )
	bad_dpdy = mr_bad_data( mdpdy )

* ***************************************************************
* ORIGINAL GFDL 205 CODE UPON WHICH CALCULATION IS BASED
*
*  226 C   FIND HYDROSTATIC PRESSURE GRADIENT AT FIRST LEVEL
*  227 C
*  228       FACT1=GRAV*DZZ(1)*CSR(J)
*  229       FACT2=DYU2R(J)*GRAV*DZZ(1)
*  230       DO 260 I=1,IMT
*  231       UDIF(I,1)=RHON(I+1,1)-RHOS(I,1)
*  232       VDIF(I,1)=RHON(I,1)-RHOS(I+1,1)
*  233       DPDX(I,1)=(FACT1*(UDIF(I,1)-VDIF(I,1)))*DXU2R(I)
*  234       DPDY(I,1)=(UDIF(I,1)+VDIF(I,1))*FACT2
*  235  260  CONTINUE
*  236 C
*  237 C   FIND HYDROSTATIC PRESSURE GRADIENT AT OTHER LEVELS
*  238 C
*  239       FACT1=0.5*CSR(J)*GRAV
*  240       FACT2=DYU4R(J)*GRAV
*  241       DO 270 K=2,KM
*  242       DO 270 I=1,IMT
*  243       DPDX(I,K)=RHON(I,K-1)+RHON(I,K)
*  244       DPDY(I,K)=RHOS(I,K-1)+RHOS(I,K)
*  245  270  CONTINUE
*  246       DO 273 K=2,KM
*  247       DO 273 I=1,IMT
*  248       UDIF(I,K)=DPDX(I+1,K)-DPDY(I  ,K)
*  249       VDIF(I,K)=DPDX(I  ,K)-DPDY(I+1,K)
*  250       DPDX(I,K)=(FACT1*(UDIF(I,K)-VDIF(I,K)))*DZZ2D(I,K)*DXU2R2D(I,K)
*  251       DPDY(I,K)=(FACT2*(UDIF(I,K)+VDIF(I,K)))*DZZ2D(I,K)
*  252  273  CONTINUE
*  253       DO 275 K=1,KMM1
*  254       DO 275 I=1,IMT
*  255       DPDX(I,K+1)=DPDX(I,K)+DPDX(I,K+1)
*  256       DPDY(I,K+1)=DPDY(I,K)+DPDY(I,K+1)
*  257  275  CONTINUE

* ******************************************************************

	DO 2000 l = mr_lo_s4(mdpdx), mr_hi_s4(mdpdx)
	DO 2000 k = mr_lo_s3(mdpdx), mr_hi_s3(mdpdx)

* top level doesn't require recursive computation - deeper levels do
	IF ( k .GT. 1 ) GOTO 500

c find hydrostatic pressure gradient at first level
	DO 260 j = j_lo, j_hi
	   fact1 = grav * dzz(1) * csr(j)
	   fact2 = dyu2r(j) * grav * dzz(1)
	DO 260 i = i_lo, i_hi
* ... cant compute derivatives at fringes of full grid
! pre 2/96	   IF ( i .EQ. im .OR. j .EQ. 1 ) THEN
	   IF ( i .EQ. im .OR. j .EQ. jm ) THEN
	      dpdx(i,j,k,l) = bad_dpdx
	      dpdy(i,j,k,l) = bad_dpdy
	      GOTO 260
	   ENDIF

	   IF ( rhok(i  ,j+1,k,l) .EQ. bad_rhok
     .	    .OR.rhok(i+1,j+1,k,l) .EQ. bad_rhok
     .	    .OR.rhok(i+1,j  ,k,l) .EQ. bad_rhok
     .	    .OR.rhok(i  ,j  ,k,l) .EQ. bad_rhok ) THEN
	      dpdx(i,j,k,l) = bad_dpdx
	      dpdy(i,j,k,l) = bad_dpdy
	   ELSE
	      udif1 = rhok(i+1,j+1,k,l) - rhok(i  ,j  ,k,l)
	      vdif1 = rhok(i  ,j+1,k,l) - rhok(i+1,j  ,k,l)
	      dpdx(i,j,k,l) = ( fact1*(udif1-vdif1) ) * dxu2r(i)
	      dpdy(i,j,k,l) = ( udif1+vdif1 ) * fact2
	   ENDIF
 260	CONTINUE
	GOTO 2000

**************************************************************************
* find hydrostatic pressure gradient at deeper levels
 500	CONTINUE

	DO 270 j = j_lo, j_hi
	   fact1 = 0.5 * csr(j) * grav
	   fact2 = dyu4r(j) * grav

	DO 270 i = i_lo, i_hi
* ... cant compute derivatives at fringes of full grid
! pre 2/96	   IF ( i .EQ. im .OR. j .EQ. 1 ) THEN
	   IF ( i .EQ. im .OR. j .EQ. jm ) THEN
	      dpdx(i,j,k,l) = bad_dpdx
	      dpdy(i,j,k,l) = bad_dpdy
	      GOTO 270
	   ENDIF

	   IF ( rhok(i  ,j+1,k-1,l) .EQ. bad_rhok
     .	   .OR. rhok(i  ,j+1,k  ,l) .EQ. bad_rhok
     .	   .OR. rhok(i  ,j  ,k-1,l) .EQ. bad_rhok
     .	   .OR. rhok(i  ,j  ,k  ,l) .EQ. bad_rhok
     .	   .OR. rhok(i+1,j+1,k-1,l) .EQ. bad_rhok
     .	   .OR. rhok(i+1,j+1,k  ,l) .EQ. bad_rhok
     .	   .OR. rhok(i+1,j  ,k-1,l) .EQ. bad_rhok
     .	   .OR. rhok(i+1,j  ,k  ,l) .EQ. bad_rhok ) THEN
	      dpdx(i,j,k,l) = bad_dpdx
	      dpdy(i,j,k,l) = bad_dpdy
	      GOTO 270
	   ENDIF

* ... compute increment to grad P for this level
* ... combining 2 adjacent rho planes - else results would be on w planes
	   udif1 = ( rhok(i+1,j+1,k-1,l) + rhok(i+1,j+1,k,l) )
     .		 - ( rhok(i  ,j  ,k-1,l) + rhok(i  ,j  ,k,l) )
	   vdif1 = ( rhok(i  ,j+1,k-1,l) + rhok(i  ,j+1,k,l) )
     .		 - ( rhok(i+1,j  ,k-1,l) + rhok(i+1,j  ,k,l) )
	   dpdx1 = ( fact1*( udif1-vdif1 ) ) * dzz(k) * dxu2r(i)
	   dpdy1 = ( fact2*( udif1+vdif1 ) ) * dzz(k)

* ... combine with results from next shallower level
	   dpdx(i,j,k,l) = dpdx(i,j,k-1,l) + dpdx1
	   dpdy(i,j,k,l) = dpdy(i,j,k-1,l) + dpdy1
 270	CONTINUE

 2000	CONTINUE
	RETURN
	END

	SUBROUTINE DISTRIB_MSG ( )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* display messages pertinent to distribution

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V200:  7/12/91 for Unix version
* V230: 5/4/92 - modified text for politeness
* V312: 5/19/94 - call PROCLAIM from here to simplify the MAIN program
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

	include 'tmap_dims.parm'
	include 'xprog_state.cmn'
        include 'xrevision.cmn'

* calling argument declarations:

* internal variable declarations:

* this message on "BETA" versions
      IF ( progname_mod(1:1) .NE. ' ' ) THEN

	WRITE ( ttout_lun, 3000 ) 
     .    'For information on obtaining a copy of this program contact'
	WRITE ( ttout_lun, 3000 ) 
     .       '   Steve Hankin / ferret@noaapmel.gov / (206)526-6080'
	WRITE ( ttout_lun, 3000 ) 
     .    'Please notify us if you distribute this program'
	WRITE ( ttout_lun, * ) 
      ENDIF

* this message on all versions (5/94)
      CALL PROCLAIM ( ttout_lun, '          ' )


 3000	FORMAT ( ' ***  ',A )

	RETURN
	END

      SUBROUTINE vec_arrows (xx1, yy1, xx2, yy2, vel, xadd) 

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any             or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER

*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*

*       *acm* 8/01/2001  based on strmar which came from NCAR streamline code.
*    
*  Called by vecfld.
*  Plot arrowheads for vectors in vel in curvilinear coordinates.
*  arguments xx1,yy1,xx2,yy2 are arrow ends in world coordinates.
*  argument vclen is vector velocity, already in curvilinear system.

*  *acm*  12/7/01 Trap cases with dx=dy=0; atan2 fcn returns NAN under OSF.
*                 Also remove VMS includes.
*                 Declare all variables.
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus
* V684 *adm* 12/12 Changes for VECTOR/MODULO on curvilinear plots.

*  Argument declarations.
      REAL xx1, yy1, xx2, yy2, vel, xadd

      REAL a160
      PARAMETER (a160 = 160.0*3.1416/180.0)
      REAL arrlen

        include 'vector_inc.decl'
        include 'VECTOR.INC'
        include 'xcurvilinear.cmn'

C     Curvilinear coordinates declarations
      INTEGER status
#ifdef double_p
      real*8 x_curv, y_curv
#else
      real x_curv, y_curv
#endif

      REAL small, dir, addx1, addy1, addx2, addy2, xxc, yyc, xxd, yyd

      DATA small/1.e-6/

*  If the points are too close together, return

      IF (ABS(xx2-xx1) .LT. small   .AND. 
     .    ABS(yy2-yy1) .LT. small) RETURN

*  Set directions for arrows.

      x_curv = xx2
      y_curv = yy2
      CALL curv_coord (x_curv, y_curv, 1, 1.0, 1.0, status)
      xxc=x_curv
      yyc=y_curv

      x_curv = xx1
      y_curv = yy1
      CALL curv_coord (x_curv, y_curv, 1, 1.0, 1.0, status)
      xxd=x_curv
      yyd=y_curv

*  Set arrow direction

      dir = atan2(yyc-yyd, xxc-xxd)

*  Set arrow length scale based on vel.

      arrlen = 0.2* vel
      addx1 = arrlen* cos(dir+a160)
      addy1 = arrlen* sin(dir+a160)
      addx2 = arrlen* cos(dir-a160)
      addy2 = arrlen* sin(dir-a160)

      IF (curvilinear) THEN
	  xxc = xxc + xadd

          CALL plot (xxc, yyc, 0, 0)
          CALL plot (xxc+addx1, yyc+addy1, 1, 0)
          CALL plot (xxc, yyc, 0, 0)
          CALL plot (xxc+addx2, yyc+addy2, 1, 0)
          CALL plot (xxc, yyc, 0, 0)
          
      ELSE

         CALL plot (xx2, yy2, 0, 0)
         CALL plot (xx2+addx1, yy2+addy1, 1, 0)
         CALL plot (xx2, yy2, 0, 0)
         CALL plot (xx2+addx2, yy2+addy2, 1, 0)
         CALL plot (xx2, yy2, 0, 0)

      ENDIF

      RETURN
      END

	CHARACTER*(*) FUNCTION VAR_TITLE_ONLY( cx, tlen )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* For ticket 2331, variable-title option
* create a title for a memory variable including only the variable's title
* If no title, then the variable name, or if an expression, its definition.

* programmer - Ansley Manke from VAR_TITLE
* revision 0.0 - 2/6/2017


        IMPLICIT NONE
        include	'tmap_dims.parm'
	include	'xdset_info.cmn_text'
	external xdset_info_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'xvariables.cmn'
	include	'xcontext.cmn'
	include	'xalgebra.cmn'
        include 'errmsg.parm'

* calling argument declarations:
	INTEGER	cx, tlen

* internal variable declarations:
	LOGICAL 	NC_GET_ATTRIB, ACTS_LIKE_FVAR, got_it
	INTEGER 	TM_LENSTR1, maxlen, cat, var, idim, slen, 
     .			trans,uvar, item, start, end, dset, 
     .                  varid,attlen, attoutflag, status
        REAL            vals
	CHARACTER	VAR_CODE*128, SANITARY_VAR_CODE*128, PAREN_SURROUND*200,
     .                  VAR_UNITS*64, REPLACE_DEQ*180,   ! .GT. uvar_text_len
     .                  buff*2048, varname*128

* initialize
	maxlen	= LEN( VAR_TITLE_ONLY )

* initialize
	var = cx_variable( cx )
	cat = cx_category( cx )

	IF     ( ACTS_LIKE_FVAR(cat) ) THEN
	   IF ( ds_var_title( var )(1:1) .NE. ' ' ) THEN
	      VAR_TITLE_ONLY = ds_var_title( var )
	   ELSE
              dset = cx_data_set(cx)
              IF (dset .NE. pdset_irrelevant .AND. 
     .            dset .NE. unspecified_int4) THEN
! is it in the linked-list for dset. If so get attr info, including original 
                 varname = SANITARY_VAR_CODE( cat, var )
                 CALL CD_GET_VAR_ID (dset, varname, varid, status)
                 got_it = status .EQ. ferr_ok .AND.
     .              NC_GET_ATTRIB (dset, varid, 'long_name',
     .             .TRUE., varname, 2048, attlen, attoutflag,
     .             buff, vals)
                 VAR_TITLE_ONLY = buff
                 IF (VAR_TITLE_ONLY .EQ. ' ') VAR_TITLE_ONLY = varname
              ELSE
                 VAR_TITLE_ONLY = VAR_CODE( cat, var )
!	         VAR_TITLE_ONLY = '"'//var_title(:TM_LENSTR1(var_title))//'"'
              ENDIF
	   ENDIF

	ELSEIF ( cat .EQ. cat_user_var  ) THEN

	   IF ( uvar_title( var ) .EQ. ' ' ) THEN
	      VAR_TITLE_ONLY = uvar_name_code(var)
	      IF (VAR_TITLE_ONLY(1:3) .EQ. 'EX#') VAR_TITLE_ONLY = 
     .          REPLACE_DEQ(uvar_text(var)(:TM_LENSTR1(uvar_text(var)) ))
	   ELSE
	      VAR_TITLE_ONLY = uvar_title( var )
	   ENDIF


	ELSEIF ( cat .EQ. cat_attrib_val  ) THEN

	   uvar = cx_variable(cx)
	   VAR_TITLE_ONLY = uvar_text(uvar)

	   IF ( uvar_title( uvar ) .EQ. ' ' ) THEN
	      VAR_TITLE_ONLY = REPLACE_DEQ(
     .             uvar_text(uvar)(:TM_LENSTR1(uvar_text(uvar)) ))
	   ENDIF

	ELSEIF ( cat .EQ. cat_pseudo_var ) THEN

	   VAR_TITLE_ONLY = alg_pvar(var)

	ELSEIF ( cat .EQ. cat_dummy_var ) THEN

	   VAR_TITLE_ONLY = 'dummy'

	ELSEIF ( cat .EQ. cat_temp_var ) THEN

	   VAR_TITLE_ONLY = 'temp var'

	ELSEIF ( cat .EQ. cat_constant ) THEN

	   VAR_TITLE_ONLY = 'constant'

	ELSEIF ( cat .EQ. cat_const_var ) THEN

	   uvar = cx_variable(cx)/1000
           item = cx_variable(cx) - 1000*uvar
           start = uvar_item_start( item, uvar )
           end   = uvar_item_end  ( item, uvar )
	   VAR_TITLE_ONLY = uvar_text(uvar)(start:end)

	ELSEIF ( cat .EQ. cat_string ) THEN

* determine the string to be stored
           uvar = cx_variable(cx)/1000
           item = cx_variable(cx) - 1000*uvar
           start = uvar_item_start( item, uvar )
           end   = uvar_item_end  ( item, uvar )
	   VAR_TITLE_ONLY = uvar_text(uvar)(start:end)

	ELSEIF ( cat .EQ. cat_counter_var ) THEN

	   VAR_TITLE_ONLY = 'counter'

	ELSE

	   VAR_TITLE_ONLY = 'bad_cat'

	ENDIF

* if it wont fit indicate that with a "*" at the end
	tlen = MIN( maxlen, TM_LENSTR1(VAR_TITLE_ONLY) )
	IF ( tlen .EQ. maxlen ) VAR_TITLE_ONLY(maxlen:maxlen) = '*'

	RETURN
	END

	SUBROUTINE PUT_CMND_KEY( cmnd, string, xll, yll, xsize, ysize, lab_ht )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* create a key for a plot using PLOT+ movable labels
* that will document a SHADE, CONTOUR or VECTOR overlay
* (xsize,ysize) is the size of the "key box" (including the line specimen
* (xll,yll) is the lower left corner of the box

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V200:	  2/9/90
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'plot_setup.parm'
	include	'command.parm'
	include	'xplot_setup.cmn'

* calling argument declarations
	INTEGER cmnd
	REAL	xll, yll, xsize, ysize, lab_ht
	CHARACTER string*(*)

* internal variable declarations
	REAL	ymid, xmid
	CHARACTER	cmnd_name*8

	ymid = yll + ysize*0.5
	IF ( cmnd .EQ. cmnd_vector ) THEN
	   xmid = xsize*(1.-key_line_frac)
	   WRITE ( ppl_buff, '(2F6.1)' ) xll+(1.05*xmid), ymid
	   CALL PPLCMD (' ',' ',0,'VECKEY/NOUSER '//ppl_buff, 1, 1 )
	   CALL BOX_LABEL( ppl_movlab, string,
     .			   xll, yll, xmid , ysize,
     .			   lab_ht, ppl_right_just,
     .			   lab_loc_absolute, lab_loc_absolute )
	ELSE
	   IF ( cmnd .EQ. cmnd_contour ) THEN
	      cmnd_name = 'CONTOUR:'
	   ELSE
	      cmnd_name = 'SHADE:  '
	   ENDIF
	   xmid = xsize*key_line_frac
	   CALL BOX_LABEL( ppl_movlab, cmnd_name,
     .			   xll, yll, .95*xmid, ysize,
     .			   lab_ht, ppl_right_just,
     .			   lab_loc_absolute, lab_loc_absolute )
	   CALL BOX_LABEL( ppl_movlab, string,
     .			   xll+xmid, yll, xsize-xmid, ysize,
     .			   lab_ht, ppl_left_just,
     .			   lab_loc_absolute, lab_loc_absolute )

	ENDIF

	RETURN
	END

	SUBROUTINE CHECK_FORMAT( string, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Check a FORTRAN FORMAT string for superficial syntax errors

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V301 1/94 - extracted from EQUAL_FORMAT
* V320 8/94 *kob* -IBM port - had to use risc buff for string concats
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

* calling argument declarations
	INTEGER		status
	CHARACTER*(*)	string

* internal variable declarations
        LOGICAL TM_DIGIT
	INTEGER	left_paren, right_paren, integer_form

	include 'ferret.parm'
	include 'errmsg.parm'
!	include 'xprog_state.cmn'
#ifdef NO_PASSED_CONCAT
	include 'xrisc.cmn'
#endif

* check out user-specified format
	left_paren  = INDEX( string, '(' )
	right_paren = INDEX( string, ')' )
	IF ( left_paren .EQ. 0 
     .	.OR. left_paren .GE. right_paren ) GOTO 5040
	integer_form = MAX( INDEX( string, 'I' ),
     .		            INDEX( string, 'i' ) )
	IF ( integer_form .NE. 0 ) THEN
           IF ( TM_DIGIT(string(integer_form:)) )GOTO 5050
        ENDIF

* success
	status = ferr_ok
	RETURN

* syntax error
 5000	RETURN
#ifdef NO_PASSED_CONCAT	
 5040   risc_buff = string
	CALL ERRMSG( ferr_syntax, status,
     .			'unknown format or format need parenthesis: '//pCR//
     .			risc_buff, *5000 )
 5050   risc_buff = string
	CALL ERRMSG( ferr_syntax, status,
     .			'floating pt. formats only:'//risc_buff, *5000 )
#else
 5040	CALL ERRMSG( ferr_syntax, status,
     .			'unknown format or format need parenthesis: '//pCR//
     .			string, *5000 )
 5050	CALL ERRMSG( ferr_syntax, status,
     .			'floating pt. formats only:'//string, *5000 )
#endif
	END

        SUBROUTINE GET_FRAME_SIZE (ws_id,status,x_pixel_dim,y_pixel_dim)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Capture size in pixels of GKS ws with id ws_id
*       J Davison 12.23.92
*	Mod 3.11.93 for Ferret to capture entire screen when in viewport
* 1/97 *kob* - Linux Port - had to move variable assignments off of
*               declaration line.
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus.

        IMPLICIT NONE
        include 'errmsg.parm'
        include 'pltcom_dat.decl'
        include 'PLTCOM.DAT'

	integer		error_status,transno,ws_id
	integer		x_pixel_dim,y_pixel_dim
	integer		status,new_trans
	PARAMETER	( new_trans = 10 )

	real*4		rzero, fctx,fcty, world(4),
     .			x_minw,x_maxw,y_minw,y_maxw,ndc(4)

******************************************************************************

*	GET WORLD COORDINATES AND PIXEL DIMENSIONS OF FRAME
	call  gqcntn (error_status,transno)
	if (error_status .ne. 0) goto 1000

	rzero = 0.0

        IF(ASIZE.GT.BSIZE)THEN
           FCTY=BSIZE/ASIZE
           FCTX=1.0
        ELSE
           FCTX=ASIZE/BSIZE
           FCTY=1.0
        ENDIF
	CALL GSWN(new_trans, rzero, asize, rzero, bsize )
	CALL GSVP(new_trans, rzero, fctx,  rzero, fcty )
	call gselnt (new_trans)

	call gqnt (new_trans,error_status,world,ndc)
	if (error_status .ne. 0) goto 1000

        x_minw = world(1)
        x_maxw = world(2)
        y_minw = world(3)
        y_maxw = world(4)

	call gqpxad(ws_id,x_minw,y_maxw,x_maxw,y_minw,
     .	error_status,x_pixel_dim,y_pixel_dim)

	if (error_status .ne. 0) goto 1000
	
	call gselnt (transno)
        status = ferr_ok
        return

*	GKS ERROR EXIT
1000	call gselnt (ws_id)
	status = ferr_tmap_error
	return

	end

	SUBROUTINE CONFORMABLE_AGG_GRID (agg_dim, vname, imemb,
     .					 res_grid, res_cat, res_var,
     .					 com_grid, com_cat, com_var,
     .					 orig_grid, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* test that the grid of a member of an aggregation is conformable with the
* grid of the aggregation result.
* scalar axes in the result must correspond to scalar axes in the member
* axes with ranges must be the very same axis ... and not compressed
* success or failure is indicated by the return status

* V698 3/16 *sh*
* V741 *acm* 5/18 Promoting global attributes to a variable in ensembles

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'
	include	'xtext_info.cmn'
	include 'xtm_grid.cmn_text'   ! for grid_line
	include 'xfr_grid.cmn'

* calling argument declarations:
	INTEGER res_grid, res_cat, res_var, agg_dim,
     .		com_grid, com_cat, com_var, orig_grid, imemb, status
	CHARACTER*(*) vname

* internal variable declarations
	LOGICAL SCALAR_GRID_LINE
	INTEGER	TM_LENSTR1, idim, slen, vlen
	CHARACTER LEFINT*6

	IF (com_grid .EQ. mgrid_abstract) GOTO 4000

	DO idim = 1, nferdims
	   IF (idim .EQ. agg_dim) THEN
	      IF (.NOT.SCALAR_GRID_LINE(idim, com_grid, com_cat, com_var)) GOTO 5100
	   ELSEIF (agg_dim.EQ.F_dim .AND. idim.EQ.T_dim) THEN
	      IF (grid_line(idim,com_grid) .NE. grid_line(idim,orig_grid))
     .						      GOTO 5100
	   ELSEIF (SCALAR_GRID_LINE(idim, res_grid, res_cat, res_var)) THEN
	      IF (SCALAR_GRID_LINE(idim, com_grid, com_cat, com_var)) THEN
* ... single point component axis need not match result context
*     e.g. Z=0:500@ave on component may map to Z=250 single point result 
	         CYCLE
	      ELSE
	         GOTO 5100
	      ENDIF
	   ELSE
	      IF (grid_line(idim,com_grid) .NE. grid_line(idim,res_grid))
     .							GOTO 5100
* ... a LET/D compressed to a point may share axis but still be nonconformable
	      IF (SCALAR_GRID_LINE(idim, com_grid, com_cat, com_var)) GOTO 5100
	   ENDIF
	ENDDO

* success
 4000	status = ferr_ok
	RETURN

* error exit
 5000	RETURN
 5100	vlen = TM_LENSTR1(vname)
	CALL ERRMSG(ferr_aggregate_error, status,
     .		    'grid definition of '// vname(:vlen)//
     .		    ' has changed on axis '//ww_dim_name(idim)//
     .		    ' of agg member '//LEFINT(imemb,slen), *5000)
	END	

	SUBROUTINE EF_GET_DATE_TSTEP ( grid, dim, tstep, precision, date )
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Return a string giving the date for a particular timestep
* This is done by figuring the offset from
* 01-JAN-0000 00:00:00 in seconds, and then calculating the date.
*
* This is an older version of TSTEP_TO_DATE which was revised for better
* output formatting in Ferret v6.0.  This version gives a fixed unchanging
* format.
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.
* v75  *acm* 3/18  Changes to allow for timesteps in fractional seconds
* v74+ *acm* 12/18 Issue 1902, fractional seconds only when time units are seconds
*                  use AINT call not INT when comparing values, large numbers of seconds
* v745 *acm* 12/18  Issue 1909, option to write dates in ISO8601 format
* v7441*acm* 12/18 Issue 1910: Allow dates in commands to be in ISO 8601 form, yyyy-mm-dd

* Arguments:
*	grid	 - grid containing a time axis
*	dim      - dimension (t_dim or f_dim)
*	tstep    - time step
*	precision- precision (1 to 6 for day,mon,yr,hr,min,sec, respectively )
*			(use ABS(precision) - neg. indicates truncate left 0s)
*	date	 - returned string containing date in ASCII form
*

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'ferret.parm'
        include 'xunits.cmn_text'
	include 'xtext_info.cmn'

* calling argument declarations
	CHARACTER*(*)	date
	INTEGER		grid, dim, precision
	REAL*8		tstep
*
* Local definitions
        LOGICAL         ITSA_TRUEMONTH_AXIS, modulo
	CHARACTER*30	SECS_TO_DATE_OUT, buff
	CHARACTER*48	TM_FMT, buff2
	CHARACTER*2     linedir
	INTEGER		TM_GET_CALENDAR_ID, TM_LENSTR1,  
     .                  axis, status, prec, cal_id, nfrac, slen
	REAL*8		start_secs, offset_secs, this_secs, val
	REAL*8		SECS_FROM_BC

!	REAL*8		start_secs, offset_secs, this_secs, prec_fact(6)
!	DATA	prec_fact	/  31536000.,  2628000.,  86400.,  3600.,
!     .				   60., 1./

* initialize
	prec = ABS(precision)
        linedir = 'TI'
	IF (dim .EQ. f_dim) linedir = 'FI'  ! formatted forecast date

* get the axis number
	axis = grid_line( dim, grid )
	modulo = line_modulo(axis)
#ifdef double_p	
	IF ( axis .EQ. mnormal .OR. axis .EQ. munknown ) THEN
	   WRITE ( date, * ) (tstep)
	   RETURN
	ELSEIF ( line_direction(axis) .NE. linedir ) THEN
	   WRITE ( date, * ) (tstep)
	   RETURN
	ENDIF
#else
	IF ( axis .EQ. mnormal .OR. axis .EQ. munknown ) THEN
	   WRITE ( date, * ) SNGL(tstep)
	   RETURN
	ELSEIF ( line_direction(axis) .NE. linedir ) THEN
	   WRITE ( date, * ) SNGL(tstep)
	   RETURN
	ENDIF
#endif

* get the calendar type

        cal_id = TM_GET_CALENDAR_ID ( line_cal_name(axis) )

* First find the offset from 01-JAN-0000 00:00:00 from the descriptor file
	start_secs = SECS_FROM_BC( line_t0(axis), cal_id, status )

* Find the number of seconds since start of data set for this time step
	offset_secs = tstep*line_tunit( axis )
	IF (ITSA_TRUEMONTH_AXIS(axis)) offset_secs = tstep* un_convert(pun_day)  

* Total seconds to this time step since 01-JAN-0000 00:00:00
	this_secs = start_secs + offset_secs

* round off date instead of truncating 
* ( people do not normally view dates this way )
!	this_secs = ( DNINT(this_secs/prec_fact(prec)) + 0.5 ) * prec_fact(prec)

* Convert to date

	buff = SECS_TO_DATE_OUT(this_secs, cal_id, modulo, prec)
*       SECS_TO_DATE_OUT has already dealt with only printing 
*       the appropriate values for precision 1 to 6
	date = buff

* If fractional seconds are requested....
	IF ( prec .GT. 6 ) THEN	
	   IF (line_tunit(axis) .EQ. 1) THEN  ! Deal with fractional seconds
	      val = AINT(tstep)
	      IF (val .NE. tstep) THEN
	         val = tstep - val
	         buff2 = TM_FMT(val, 4, 16, nfrac)
		 date = buff(:TM_LENSTR1(buff))//buff2(2:nfrac)
	      ELSE 
	         date = buff(:TM_LENSTR1(buff))//'.0'
	      ENDIF
	   ENDIF
	ENDIF

	slen = TM_LENSTR1(date)
	CALL CHECK_DATE_REFORMAT (date, slen, cal_id, status)

* Finished
	RETURN
	END

	SUBROUTINE COPY_AGG_INTO ( src, msrc, cxs, agg_dim, dst, mdst, aloc )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* copy data from source grid into dstination grid using limits of source
* context (i.e. destination grid is ASSUMED) big enough to hold data.
* The source grid does not have an ensemble/forecast axis (dimension 5 or 6) 
* but the destination axis does. Copy the aggregation member into the e- or 
* f-axis location pointed to by index aloc.
*
* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Thermal Modeling and Analysis Program
*
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V695 2/15 *acm* 6D add aggregation in forecast direction
* V698 3/16 *sh* make any scalar axis of member conformable with result
*
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'

* calling argument declarations:
	INTEGER msrc, cxs, mdst, dcx, aloc, agg_dim
	REAL    src( * ), dst( * )

* internal variable declarations
	LOGICAL SCALAR_GRID_LINE
	INTEGER idim, soffset, doffset, mdel,
     .		dgrid, dcat, dvar,
     .		smlo(nferdims), smhi(nferdims),
     .		dmlo(nferdims), dmhi(nferdims),
     .		cxlo(nferdims), cxhi(nferdims)

* initialize
	dgrid = mr_grid(mdst)
	dcat  = mr_category(mdst)
	dvar  = mr_variable(mdst)
 
* set-up modified limits wherever delta is significant
* cuz the FORTRAN dimensioned size can only have delta of 1 

	DO idim = 1,nferdims
	  IF (idim.NE.agg_dim
     .  .AND. SCALAR_GRID_LINE(idim,dgrid,dcat,dvar)) THEN
* ... any scalar-length axis of source is conformable with dest
*     (if dst is scalar, then we know src will be too)
	     cxlo(idim) = 1
	     cxhi(idim) = 1
	     dmlo(idim) = 1
	     dmhi(idim) = 1
	     smlo(idim) = 1
	     smhi(idim) = 1
	  ELSEIF (mr_delta(idim,msrc) .NE. unspecified_val8) THEN
            mdel = NINT(mr_delta(idim,msrc))

	    IF (mr_delta(idim,msrc).NE.mr_delta(idim,mdst)
     .	   .OR. mr_delta(idim,msrc).NE.cx_delta(idim,cxs) ) CALL WARN
     .		('Internl_delta_err')
	    soffset = (mr_lo_ss(msrc,idim)-cx_lo_ss(cxs,idim))/
     .			mdel  + 1
	    doffset = (mr_lo_ss(mdst,idim)-cx_lo_ss(cxs,idim))/
     .			mdel  + 1
	    cxlo(idim) = 1

	    cxhi(idim) = 1 + (cx_hi_ss(cxs,idim)-cx_lo_ss(cxs,idim))/
     .			     mdel
	    dmlo(idim) = doffset
	    dmhi(idim) = doffset +
     .			     (mr_hi_ss(mdst,idim)-mr_lo_ss(mdst,idim))/
     .			     mdel
	    smlo(idim) = soffset
	    smhi(idim) = soffset + 
     .			     (mr_hi_ss(msrc,idim)-mr_lo_ss(msrc,idim))/
     .			     mdel
	  ELSE
	    cxlo(idim) = cx_lo_ss(cxs, idim)
	    cxhi(idim) = cx_hi_ss(cxs, idim)
	    dmlo(idim) = mr_lo_ss(mdst,idim)
	    dmhi(idim) = mr_hi_ss(mdst,idim)
	    smlo(idim) = mr_lo_ss(msrc,idim)
	    smhi(idim) = mr_hi_ss(msrc,idim)
	  ENDIF
	ENDDO

	IF (mr_type(msrc) .EQ. ptype_string ) THEN
	   CALL COPY_AGG_PTR_INTO_SUB( aloc, cxlo, cxhi, agg_dim,
     .			    src, smlo(1), smhi(1),
     .				 smlo(2), smhi(2),
     .				 smlo(3), smhi(3),
     .				 smlo(4), smhi(4),
     .				 smlo(5), smhi(5),
     .				 smlo(6), smhi(6),
     .			    dst, dmlo(1), dmhi(1),
     .				 dmlo(2), dmhi(2),
     .				 dmlo(3), dmhi(3),
     .				 dmlo(4), dmhi(4),
     .				 dmlo(5), dmhi(5),
     .				 dmlo(6), dmhi(6) )
	ELSE
	   CALL COPY_AGG_INTO_SUB( aloc, cxlo, cxhi, agg_dim,
     .			    src, smlo(1), smhi(1),
     .				 smlo(2), smhi(2),
     .				 smlo(3), smhi(3),
     .				 smlo(4), smhi(4),
     .				 smlo(5), smhi(5),
     .				 smlo(6), smhi(6),
     .			    dst, dmlo(1), dmhi(1),
     .				 dmlo(2), dmhi(2),
     .				 dmlo(3), dmhi(3),
     .				 dmlo(4), dmhi(4),
     .				 dmlo(5), dmhi(5),
     .				 dmlo(6), dmhi(6),
     .				 cx_bad_data(cxs),
     .				 mr_bad_data(mdst) )
	ENDIF

	RETURN
	END 

	SUBROUTINE AUX_REGRID_LIMS_2D_TF( dst_cx, src_cx, axis_list, naxis,
     .			                 aux1, mr1, cx1, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* This routine handles the special case of forecast model aggregations
* It determines the range of souce data on the F and T axes in the 2D time
* form that is needed to create calendar-time x lag-forecast form

* In generic terms, the descript of the routine is this:
* Given a context describing data to be regridded to a destination grid
* create the description of the needed source data in the source context
* Use the auxiliary variables to determine the index range of data needed

* The 2D time field is the auxiliary regrid control variable. It contains
* times that are partially duplicated from one forecat index to the next
* The orthoganalization process removes the duplication by shifting the start
* time index of each successive forcast, so that all forecasts lie on the
* same-single time axis

* When called the source context should be a copy of the destination context 
* This routine is almost a copy of AUX_REGRID_LIMS_1D_T.  The difference is
* that the user cannot limit the N range of source data needed through the /N 
* or /F qualifier.  Instead this code determines the N range needed to fullfill
* the requested time range

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

*v695+ 3/15 *sh* almost a copy of AUX_REGRID_LIMS_1D_T

	IMPLICIT NONE

	include 'tmap_dims.parm'
	include 'implicit.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xtm_grid.cmn_text'   ! for line_delta and line_regular

* calling argument declarations:
	INTEGER	src_cx, dst_cx, naxis, axis_list(naxis), status,
     .		mr1, cx1, mr2, cx2, mr3, cx3 
        REAL*8  aux1(m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif )

* internal variable declarations:
	INTEGER	KNOWN_GRID, CGRID_AXIS,
     .		idim, src_grid, i, j, k, l, m, n, trans,
     .		ndim, dim(nferdims), looking_for_first,
     .		ldstmin, ldstmax, llmin, llmax, llo, lhi, ldel,
     .		nlo, nhi, nmin, nmax, axis
	REAL*8  TM_WORLD, axmax, axmin, bad_aux, t, t1, steps,
     .		tdstrt, tdend, tstepmin, tstepmax
!, f_delta, t_delta

* initialize
	bad_aux = mr_bad_data( mr1 )
!	idim     = axis_list(1)
	llo      = cx_lo_s4(cx1)   ! 2d time array limit - should always be 1
	lhi      = cx_hi_s4(cx1)   ! should always be N
	nlo      = m1lof	   ! should always be 1
	nhi      = m1hif	   ! should always be dimension size of F
	i        = cx_lo_s1(cx1)   ! fixed index since aux field is 2d
	j        = cx_lo_s2(cx1)
	k        = cx_lo_s3(cx1)
	m        = cx_lo_s5(cx1)
	tstepmin = aux1(i,j,k,llo,m,nlo) ! low-left corner of 2d time array
	tstepmax = aux1(i,j,k,lhi,m,nhi) ! upper right
	tdstrt   = TM_WORLD(cx_lo_s4(dst_cx), cx_grid(dst_cx),
     .			  t_dim, box_middle) ! 'd' for destination start time
	tdend    = TM_WORLD(cx_hi_s4(dst_cx), cx_grid(dst_cx),
     .			  t_dim, box_middle)
	llmin  = llo	! initial default
	llmax  = lhi
	nmin   = nlo
	nmax   = nhi 		

* insert source grid (the defining grid for this variable)
* XXXX TEMPORARY -- ?move this block of code to AUX_VAR_REGRID when 2D curv is added?
	src_grid = KNOWN_GRID( cx_data_set(src_cx),
     .			       cx_category(src_cx),
     .			       cx_variable(src_cx)  )
	cx_grid( src_cx ) = src_grid
	cx_unstand_grid( src_cx ) = .FALSE.
	is_phase( isp )   = prgrd_from_source
	cx_naux( src_cx ) = 0
        DO 100 idim = 1, nferdims
           cx_aux_var  (idim, src_cx) = unspecified_int4
           cx_aux_cat  (idim, src_cx) = unspecified_int4
           cx_aux_stat (idim, src_cx) = paux_stat_na
 100    CONTINUE

* commented out these checks for regular time steps, because of monthly axes
!* sanity check the target T axis
!	axis = CGRID_AXIS(t_dim,dst_cx)
!	IF (.NOT. line_regular(axis)) GOTO 5050
!	IF (lhi .GT. llo) THEN
!	   IF (line_delta(axis)
!     .	   .NE.(aux1(i,j,k,llo+1,m,nlo)-aux1(i,j,k,llo,m,nlo))) GOTO 5055
!	ENDIF
!
* sanity check the target F axis
	axis = CGRID_AXIS(f_dim,dst_cx)
	IF (.NOT. line_regular(axis)) GOTO 5060
!	IF (nhi .GT. nlo) THEN
!	   f_delta = line_delta(axis)
!	   IF ( f_delta
!     .	   .NE.(aux1(i,j,k,llo,m,nlo+1)-aux1(i,j,k,llo,m,nlo))) GOTO 5065
!	ENDIF


* ideally we should check that the units of the 2D time field are the same as the units of the
* 1D time axis, but since typically Ferret code is creating the 1d time, we'll allow laziness

* this routine only for t_dim -- index-based remapping of time locations
	trans = cx_regrid_trans(t_dim,src_cx)
	IF (trans .NE. pauxrgrd_fmrc) 
     .	  CALL ERRMSG( ferr_internal, status, 'unkwn rgrd trans', *5000)

* make sure that the auxiliary variable is monotonic
* (not regularly spaced cuz we havvvvvvvvvve to support monthly data)
*	The 2D time array can never theoretically be non-monotonic
*       FT aggregations are new and unreliable
	DO n = nlo, nhi
	   looking_for_first = 0
           DO l = llo, lhi
	      t = aux1(i,j,k,l,m,n)
	      IF (t .EQ. bad_aux) THEN
	         GOTO 5150
	      ELSEIF (looking_for_first .EQ. 0) THEN
	         t1 = t
	         looking_for_first = 1
	      ELSE
	         IF (looking_for_first .EQ. 1) THEN
!	            t_delta = t-t1
!	            IF (t_delta .LE.0.0) GOTO 5100
	            IF (t .LE. t1) GOTO 5100
	         ENDIF
!	         IF ((t-t1) .NE. t_delta) GOTO 5100  ! need not be regular
	         t1 = t
	      ENDIF
	   ENDDO
	ENDDO

!* the delta in F must be an integer multiple of the delta in T
!	steps = f_delta / t_delta
!	IF (steps .NE. INT(steps)) GOTO 5200

* the relationship between the time steps in the 2D aux time field (cx1)
* and the same times in the destination field looks something
* like this

*          **  2d aux times    **  ==>   ** cal-T x lag-F field **

*   12  1011(0)   1015(1)   1019(2)        1019(2) 1019(3) 1019(4)     20
*   11  1010(0)   1014(1)   1018(2)        1018(2) 1018(3) 1018(4)     19
*   10  1009(0)   1013(1)   1017(2)        1017(2) 1017(3) 1017(4)     18
*    9  1008(0)   1012(1)   1016(2)        1016(2) 1016(3) 1016(4)     17
*    8  1007(0)   1011(1)   1015(2)        1015(1) 1015(2) 1015(3)     16
*    7  1006(0)  >1010(1)   1014(2)        1014(1) 1014(2) 1014(3)     15
*    6  1005(0)   1009(1)   1013(2)        1013(1) 1013(2) 1013(3)     14
*    5  1004(0)   1008(1)   1012(2)        1012(1) 1012(2) 1012(3)     13
*    4  1003(0)   1007(1)   1011(2)        1011(0) 1011(1) 1011(2)     12
*    3  1002(0)   1006(1)   1010(2)        1010(0) 1010(1) 1010(2)     11
*    2  1001(0)  >1005(1)   1009(2)        1009(0) 1009(1) 1009(2)     10
*    1  1000(0)   1004(1)   1008(2)        1008(0) 1008(1) 1008(2)      9
*    ^                                                                  ^
*    |                                                                  |
* l in src_cx                                                     l in dst_cx 

* say that the requested time range is T=1005:1010 (marked above)
* The lowest L index of source data needed is the index at which the START time
*    is first encountered as we loop down the forecasts searching lo to hi
* The highest L index of source data needed is the index at which the END  time
*    is first encountered as we loop up   the forecasts searching hi to lo

*************************************************************************
*!!! >>> EFFICIENCY NOTE  <<< !!!
* In some important situations this is a very inefficient way to appproach
* the FT re-organization that is performed here. The most important example
* is when the user requests the "best time series" -- i.e. N=1 only, which
* gives a time series of the initial time steps of the model following each
* initialization.  In that case the efficient approach is to individually
* request the sequence of time series fragments and concatenate them.
* (Visualize how to obtain first column of the right hand block above)
* Instead this code requests the full 2D block of data.  Inefficient!
*************************************************************************

* bail out if the requested min exceeds the available range or similar max
	IF (tdstrt .GT. tstepmax
     .  .OR. tdend .LT. tstepmin ) THEN
* ... no regridding is possible - result will be a field of missing data
* ... provide a nominal data region that is not trouble to get
	   llmax = llmin  ! request a single point region only of source data
	   nmax  = nmin
	   GOTO 500
	ENDIF

* determine the minimal forecast index range (i.e. with relevant timesteps)
	DO n = nlo, nhi
	   t  = aux1(i,j,k,llo,m,n)
	   t1 = aux1(i,j,k,lhi,m,n)
	   IF (t1 .GE. tdstrt
     .   .AND. t  .LE. tdend  ) THEN
* ... found first forecast with relevant time steps
	      nmin = n
	      EXIT
	   ENDIF
	ENDDO
	DO n = nhi, nlo, -1
	   t  = aux1(i,j,k,llo,m,n)
	   t1 = aux1(i,j,k,lhi,m,n)
	   IF (t1 .GE. tdstrt
     .   .AND. t  .LE. tdend  ) THEN
* ... found last forecast with relevant time steps
	      nmax = n
	      EXIT
	   ENDIF
	ENDDO
	IF (nmin .GT. nmax) nmax = nmin

* always request the full source time range (entire forecasts)
	llmin = cx_lo_s4(cx1)
	llmax = cx_hi_s4(cx1)

* apply the T limits that have been determined
 500	idim = t_dim
	IF (llmin .GT. llmax) llmax = llmin  ! may not be needed?
	cx_lo_ss ( src_cx, idim )  = llmin
        cx_hi_ss ( src_cx, idim )  = llmax
        cx_by_ss ( idim, src_cx )  = .TRUE.

        cx_lo_ww ( idim, src_cx )  = unspecified_val8
        cx_hi_ww ( idim, src_cx )  = unspecified_val8
        cx_delta ( idim, src_cx )  = unspecified_val8
        cx_trans ( idim, src_cx )  = trans_no_transform
        cx_trans_arg(idim,src_cx)  = bad_val4
        cx_given( idim, src_cx )  = .FALSE.
        cx_regrid_trans(idim,src_cx) = unspecified_int4 
        cx_formatted( idim )   = .FALSE.

	CALL FLESH_OUT_AXIS( idim, src_cx, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* apply the F limits that have been determined
	idim = f_dim
	cx_lo_ss ( src_cx, idim )  = nmin
        cx_hi_ss ( src_cx, idim )  = nmax
        cx_by_ss ( idim, src_cx )  = .TRUE.

        cx_lo_ww ( idim, src_cx )  = unspecified_val8
        cx_hi_ww ( idim, src_cx )  = unspecified_val8
        cx_delta ( idim, src_cx )  = unspecified_val8
        cx_trans ( idim, src_cx )  = trans_no_transform
        cx_trans_arg(idim,src_cx)  = bad_val4
        cx_given( idim, src_cx )  = .FALSE.
        cx_regrid_trans(idim,src_cx) = unspecified_int4 
        cx_formatted( idim )   = .FALSE.

	CALL FLESH_OUT_AXIS( idim, src_cx, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* success
        status = ferr_ok
	RETURN

* error exit
 5000	RETURN
! 5050   CALL ERRMSG( ferr_invalid_command, status,
!     .		'target 1D time axis is not regular', *5000)
! 5055	CALL ERRMSG( ferr_invalid_command, status,
!     .		'delta T of target 1D time axis doesnt match the data', *5000)
 5060   CALL ERRMSG( ferr_invalid_command, status,
     .		'target forecast lag time axis is not regular', *5000)
! 5065	CALL ERRMSG( ferr_invalid_command, status,
!     .		'delta T of forecast lag axis doesnt match the data', *5000)
 5100   CALL ERRMSG( ferr_invalid_command, status,
     .		'2D T-F times are not strictly increasing on T and F', *5000)
 5150   CALL ERRMSG( ferr_invalid_command, status,
     .		'2D T-F times include missing value', *5000)
! 5200   CALL ERRMSG( ferr_invalid_command, status,
!     .		'Lag axis of F axis is not an integer number of time steps',
!     .		*5000)
	END

*  rr_tauy.F
*
*     Rick Romea
*     Feb. 4, 2000
*
*   Sea Surface Wind Stress  (DYNE/CM**2)  
*  
************************************************************************

      SUBROUTINE RR_tauy_init(id)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

      CALL ef_set_desc             (id, 
     .       'Meridional Wind Stress(dyn/cm^3)')
      CALL ef_set_num_args         (id, 4)
      CALL ef_set_axis_inheritance (id, IMPLIED_BY_ARGS,IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS,IMPLIED_BY_ARGS)
      CALL ef_set_axis_reduction   (id, RETAINED,RETAINED,         
     .                                  RETAINED,RETAINED)          
      CALL ef_set_arg_name         (id, ARG1, 'U')
      CALL ef_set_arg_desc         (id, ARG1, 'Zonal wind speed')
      CALL ef_set_arg_unit         (id, ARG1, 'm/s')
      CALL ef_set_arg_type         (id, ARG1, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG1, YES,YES,YES,YES)

      CALL ef_set_arg_name         (id, ARG2, 'V')
      CALL ef_set_arg_desc         (id, ARG2, 'Meridional wind speed')
      CALL ef_set_arg_unit         (id, ARG2, 'm/s')
      CALL ef_set_arg_type         (id, ARG2, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2, YES,YES,YES,YES)

      CALL ef_set_arg_name         (id, ARG3, 'AIRT')
      CALL ef_set_arg_desc         (id, ARG3, 'AIR TEMPERATURE')
      CALL ef_set_arg_unit         (id, ARG3, 'oC')
      CALL ef_set_arg_type         (id, ARG3, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG3, YES,YES,YES,YES)

      CALL ef_set_arg_name         (id, ARG4, 'SST')
      CALL ef_set_arg_desc         (id, ARG4, 'Sea Surface Temperature')
      CALL ef_set_arg_unit         (id, ARG4, 'oC')
      CALL ef_set_arg_type         (id, ARG4, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2, YES,YES,YES,YES)

      END

c*******************************************************************

      SUBROUTINE RR_tauy_compute(id,arg_1,arg_2,arg_3,arg_4,result)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS)
      REAL bad_flag_result
      REAL arg_1  (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .             mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2  (mem2lox:mem2hix, mem2loy:mem2hiy, 
     .             mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3  (mem3lox:mem3hix, mem3loy:mem3hiy, 
     .             mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL arg_4  (mem4lox:mem4hix, mem4loy:mem4hiy, 
     .             mem4loz:mem4hiz, mem4lot:mem4hit)
      REAL result (memreslox:memreshix, memresloy:memreshiy, 
     .             memresloz:memreshiz, memreslot:memreshit)

      INTEGER  res_lo_ss (4)
      INTEGER  res_hi_ss (4)
      INTEGER  res_incr  (4)

      INTEGER  arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER  arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER  arg_incr  (4,EF_MAX_ARGS)

      INTEGER  i,  j,  k,  l
      INTEGER  i1, j1, l1
      INTEGER  i2, j2, l2
      INTEGER  i3, j3, l3
      INTEGER  i4, j4, l4

      REAL AirDensity
      PARAMETER (AirDensity = 0.00125)
      REAL zu
      PARAMETER (zu = 10.)
      REAL zt
      PARAMETER (zt = 10.)
      REAL zq
      PARAMETER (zq = 0.)
      REAL Cd, uz
      REAL QZ,TOL,UW,WT,WQ

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags      (id, bad_flag,  bad_flag_result)

      ! This is a dummy axis, since z is reduced
      DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

        l1 = arg_lo_ss(T_AXIS,ARG1)
        l2 = arg_lo_ss(T_AXIS,ARG2)
        l3 = arg_lo_ss(T_AXIS,ARG3)
        l4 = arg_lo_ss(T_AXIS,ARG4)

        DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

          j1 = arg_lo_ss(Y_AXIS,ARG1) 
          j2 = arg_lo_ss(Y_AXIS,ARG2) 
          j3 = arg_lo_ss(Y_AXIS,ARG2) 
          j4 = arg_lo_ss(Y_AXIS,ARG3) 
        
          DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            i1 = arg_lo_ss(X_AXIS,ARG1) 
            i2 = arg_lo_ss(X_AXIS,ARG2)
            i3 = arg_lo_ss(X_AXIS,ARG3)
            i4 = arg_lo_ss(X_AXIS,ARG4)
 
            DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
              
              IF ( arg_1(i1,j1,k,l1) .EQ. bad_flag(ARG1) .OR.
     .            arg_2(i2,j2,k,l2) .EQ. bad_flag(ARG2) .OR.
     .            arg_3(i3,j3,k,l3) .EQ. bad_flag(ARG3) .OR.
     .            arg_4(i4,j4,k,l4) .EQ. bad_flag(ARG4) )THEN
                 result(i,j,k,l) = bad_flag_result
              ELSE

                uz = SQRT(arg_1(i1,j1,k,l1)*arg_1(i1,j1,k,l1)
     .                +  arg_2(i2,j2,k,l2)*arg_2(i2,j2,k,l2))
                IF (uz .LT. 0.1) THEN
                  result(i,j,k,l) = 0.
                ELSE 
                  CALL Bulk(uz,zu,arg_3(i3,j3,k,l3),zt,QZ,zq,
     .                       arg_4(i4,j4,k,l4),TOL,UW,WT,WQ,Cd)
                  result(i,j,k,l) = AirDensity * Cd * uz 
     .                                * arg_2(i2,j2,k,l2)*1.e4
                ENDIF 
              ENDIF

              i1 = i1 + arg_incr(X_AXIS,ARG1)
              i2 = i2 + arg_incr(X_AXIS,ARG2)
              i3 = i3 + arg_incr(X_AXIS,ARG3)
              i4 = i4 + arg_incr(X_AXIS,ARG4)
            ENDDO ! i index

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
            j2 = j2 + arg_incr(Y_AXIS,ARG2)
            j3 = j3 + arg_incr(Y_AXIS,ARG3)
            j4 = j4 + arg_incr(Y_AXIS,ARG4)
          ENDDO ! j index

          l1 = l1 + arg_incr(T_AXIS,ARG1)
          l2 = l2 + arg_incr(T_AXIS,ARG2)
          l3 = l3 + arg_incr(T_AXIS,ARG3)
          l4 = l4 + arg_incr(T_AXIS,ARG4)
        ENDDO ! l index

      ENDDO  ! k index

      END





	SUBROUTINE BULK(UZ,ZU,TZ,ZT,QZ,ZQ,TSFC,TOL,UW,WT,WQ,CD)

*	Minor (I hope) mods made for SSMI stress calc's
*	J Davison 1.24.91
*	No mods made for ECMWF stress calc's
*	J Davison 3.22.93

C	FOLLOWING PROCEDURES AND COEFFICIENTS IN LARGE AND POND (1981 AND
C	1982 BULK; ESTIMATE
C		1) TOL, THE STABILITY PARAMETER Z/L AT Z=10 METERS
C		2)  UW, THE KINEMATIC MOMENTUM FLUX (M/S)**2
C		3)  WT, THE KINEMATIC SENSIBLE HEAT FLUX (DEGREES M/S)
C		4)  WQ, THE KINEMATIC LATENT HEAT FLUX (M/S, G/M**3)
C
C	FROM	1)  UZ, THE MEAN WIND SPEED  [M/S -- JD 1.24.91] AT HEIGHT ZU
C		2)  TZ, THE MEAN AIR TEMPERATURE (CELSIUS)       AT HEIGHT ZT
C		3)  QZ, THE MEAN AIR HUMIDITY (G/M**3)           AT HEIGHT ZQ
C		4) TSFC, THE SEA SURFACE TEMPERATURE (CELSIUS)
C
c      OPTIONS  1) set ZQ=0 to assume a relative humidity of RH=75%
c                DEH changed so RH is set in calling pgm and passed thru common
c                if zq=0.    change made 12/30/85

*		 Not 'passed thru common' but initialized in a data stmt JD 1.91

C		2) SET ZT=0 TO FIND ONLY UW AT NEUTRAL STABILITY
C		3) SET ZU=0 TO RETURN ONLY WITH TOL
C
C     ASSUME	1) A NEUTRAL 10M DRAG COEFFICIENT CDN=0.00115  U10<UCH  11M/S
C				          =0.00049 + 0.000065  U10>UCH  11M/S
C		2) A NEUTRAL 10M STANTON NUMBER   CTN=0.00115  Z/L<0    0
C						     =0.00075  Z/L>0    0
C		3) A NEUTRAL 10M DALTON NUMBER    CEN=0.00115  ALWAYS
C		4) VONK = 0.40 VON KARMAN'S CONSTANT
C		5) THE SMALL WT REGRESSION, WTR BELOW IF BIG=FALSE
C		       WITH A=(.0008,  Z/L>0)   =(.0010,  Z/L<0)
	LOGICAL BIG

*  ARGUMENT DECLARATIONS

      REAL UZ, ZU, TZ, ZT, QZ, ZQ, TSFC, TOL, UW, WT, WQ, CD

*  LOCAL VARIABLE DECLARATIONS

      INTEGER iter
      REAL    a, u, dth, t, cda, cts, ctu, cea, uch, rh, vonk, delth, 
     .        qsat, delq, tkelv, f1, t0, udt, f2, wtr, u3, zuol, ztol, 
     .        zqol, p10, pg10, s10, sg10, phim, phi, psim, phit, psimt, 
     .        psit, phiq, psimq, rk, up, cp, u10, diff, cdn, sqcd, rcd,
     .        ctn, rcdt, ct, rkt, dth10, cen, rcdq, ce, psi, psiq

	WTR(A,U,DTH) = 0.002 + A*U*DTH
C
C		6) THE SATURATION HUMIDITY OF AIR AT T CELSIUS QSAT(T) SAT(T) I
C
	QSAT(T) = 640380000./EXP(5107.4/(273.16 + T))
C
	DATA CDA,CTS,CTU,CEA,UCH/0.00115,0.00075,0.00115,0.00115,10./
	DATA RH,VONK/0.75,0.40/

*	Mod made to incorporate INITAL2 within the BULK subroutine JD 1.24.91
	tol = 0.0
	uw  = 0.0
	wt  = 0.0
	wq  = 0.0
	cd  = 0.0
*	End mod JD 1.24.91

C				ARE THE TEMPERATURES RELIABLE??

	IF(ZT .GT. 0.2) GO TO 1
	TOL = 0.0
	GO TO 3
C
C YES		CALCULATE A BULK STABILITY PARAMETER AT 10 METERS FROM
C		   DELTH, SURFACE-AIR POTENTIAL TEMPERATURE DIFFERENCE
C		   QSFC,  SURFACE  ABSOLUTE  HUMIDITY
C		   T0,    LOCAL MEAN VIRTUAL TEMPERATURE
   1	DELTH = TSFC-TZ-0.01*ZT
	IF(ZQ .LE. 0.0) QZ = RH*QSAT(TZ)
	DELQ = 0.98*QSAT(TSFC)-QZ
	TKELV = 273.16 + TZ
	F1 = 0.00000172
	T0 = TKELV + QZ*F1*TKELV**2
C
C		IS /WT/ LARGE ENOUGH TO USE TRANSFER COEFFICIENTS?
C
	UDT = UZ*DELTH
	IF((UDT .LT. 10.) .AND. (UDT .GT. -15.)) GO TO 2
C YES
	BIG = .TRUE.
	F2 = 1.00
	IF(DELTH .LT. 0.0) F2 = 0.70
	TOL = 0.0 - 1000.*F2/T0/UZ**2*(DELTH + F1/F2*DELQ*T0**2)
	GO TO 3
C
C NO		       DEAL WITH SMALL SENSIBLE HEAT FLUXES
C
   2	BIG = .FALSE.
	A = 0.0010
	IF(DELTH .LT. 0.0) A = 0.0008
	WT = WTR(A,UZ,DELTH)
	WQ = CEA*UZ*DELQ
	U3 = (SQRT(CDA)*UZ)**3
	TOL = 0.0 - 39./U3/T0*(WT + F1*WQ*T0**2)
C
C		RETURN WITH ONLY TOL IF ZU NOT GREATER THAN 0.2
C 
  3	IF(ZU .LE. 0.2) RETURN
	ZUOL = TOL*ZU/10.0
	ZTOL = TOL*ZT/10.0
	ZQOL = TOL*ZQ/10.0
C		EVALUATE THE STABILITY FUNCTIONS IN FZOL
	CALL FZOL(TOL,P10,PG10,S10,SG10)
	CALL FZOL(ZUOL,PHIM,PHI,PSIM,PSI)
	CALL FZOL(ZTOL,PHI,PHIT,PSIMT,PSIT)
	CALL FZOL(ZQOL,PHI,PHIQ,PSIMQ,PSIQ)
C
C	SOLVE FOR U10 AND CDN ITERATIVELY
C
	RK = (ALOG(ZU/10.0) - PSIM + S10)/VONK
	ITER = 1
	UP = UZ/(1.0 + SQRT(CDA)*RK)
  22	CP = CDA
	IF(UP .GT. UCH) CP = (0.49 + 0.065*UP)/1000.
	U10 = UZ/(1.0 + SQRT(CP)*RK)
	DIFF = (UP - U10)/UP
	UP = U10
	IF(DIFF .LE. 0.01) GO TO 4
	ITER = ITER + 1
	IF(ITER .LE. 5) GO TO 22
	WRITE(8,66) ITER,U10,DIFF,CP
  66	FORMAT('-',5X,'TOO BAD, FAILED TO CONVERGE IN 5 ITERATIONS',
     .  I6,3F16.4)
	STOP
C
C		SOLVED FOR U10, NOW FIND CDN AND CD
C		THEN GET UW FROM BULK FORMULA
C
   4	CDN = CDA
	IF(U10 .GT. UCH) CDN = (0.49 + 0.065*U10)/1000.
	SQCD = SQRT(CDN)
	RCD = 1.0 + SQCD/VONK*(ALOG(ZU/10.0) - PSIM)
	CD = CDN/RCD**2
	UW = 0.0 - CD*UZ**2
C
C		SENSIBLE HEAT FLUX IF ZT SET GREATER THAN 0.02
C
	IF(ZT .LE. 0.02) GO TO 5
	CTN = CTU
	IF(DELTH .LT. 0.0) CTN = CTS
	RCDT = 1.0 + SQCD/VONK*(ALOG(ZT/10.0) - PSIMT)
	CT = CTN/RCDT/(1.0 + CTN/VONK/SQCD*(ALOG(ZT/10.) - PSIT))
	WT = CT*UZ*DELTH
	IF(BIG) GO TO 5
C			CALCULATE SMALL SENSIBLE HEAT FLUX
	RKT = (ALOG(ZT/10.0) - PSIT + SG10)/VONK
	DTH10 = DELTH - CT/SQRT(CD)*RKT*(DELTH)
	WT = WTR(A,U10,DTH10)
C
C		LATENT (MOISTURE) FLUX IF ZQ SET GREATER THAN 0.02
C
   5	IF(ZQ .LE. 0.02) RETURN
	CEN = CEA
	RCDQ = 1.0 + SQCD/VONK*(ALOG(ZQ/10.0) - PSIMQ)
	CE = CEN/RCDQ/(1.0 + CEN/VONK/SQCD*(ALOG(ZQ/10.) - PSIQ))
	WQ = CE*UZ*DELQ
	RETURN
	END
C
	SUBROUTINE FZOL(ZOL,PHIM,PHIG,PSIM,PSIG)
C FZOL:		SUBROUTINE TO ESTIMATE THE STABILITY FUNCTIONS
C		USING THE MOST UP TO DATE FLUX-PROFILE RELATIONSHIPS
C

*  ARGUMENT DECLARATIONS

        REAL ZOL,PHIM,PHIG,PSIM,PSIG

*  LOCAL VARIABLE DECLARATIONS

	IF(ZOL .GE. 0.0) GO TO 2
C		UNSTABLE
	X = (1.0 - 16.0*ZOL)**0.25
	PHIM = 1.0/X
	PHIG = PHIM**2
	PSIG = 2.0*ALOG(0.5 + 0.5*X**2)
	PSIM = 0.5*PSIG + 2.0*ALOG(0.5*(1.0 + X)) - 2.0*ATAN(X) + 1.571
	RETURN
C
C		STABLE
C
  2	PHIG = 1.0 + 7.0*ZOL
	PHIM = 1.0 + 7.0*ZOL
	PSIG = -7.0*ZOL
	PSIM = -7.0*ZOL
	RETURN
	END

	SUBROUTINE COMPLETE_MISSING_LIMITS( cx )


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 


* Replace unspecified limits in the given context with full-span limits
* (not clear how cx_given sould be set ...)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

*  V500 *sh* 3/99
*       *sh* 4/99 - bug fix: ABSTRACT axes completed on some user vars
*	*sh* 4/99 - add mode_stupid check
*		    MODE STUPID:weak_cache in case future EF problems arise
*	*sh* 5/99 - complete limits on implicit axes
*  V510 *sh* 4/00 - netCDF variables may now have dynamic axes, so chg the
*		    logic that checked for these
*  V520 *sh* 6/00 - a cmnd with unspecified lims a conflicting X axes like
*			LIST Xshort-Xlong
*		    needs to generate an error. It does not because this
*		    routine requests I=1:short from both components.
*		    Change cx_by_ss to FALSE in here -- meaning that the
*		    misleading behavior can occur only when each component
*		    has the same number of points in the same world coord span
*
*  V541 *kob* 10/02 - BUG FIX - need to check the axis number for the 
*                               abstract grid for EACH dimension - not
*                               just x dimension, in order to correctly
*                               have limits set
* V550 *sh* 11/02 - added remark about weak_cache to 4/99 comments
*			(remark copied from ChangeLog)
* ??? v570 *acm* 7/04  do we want to use mabstract = grid_line( idim, saved_abstract_grid )
*                      instead of getting the line from mgrid_abstract ???
* v602 *acm* 12/06 use TM_GET_GRIDNUM ('ABSTRACT') to get the grid number of the grid
*                  of abstract axes; mgrid_abstract and saved_abstract_grid refer to the
*                  grid of a SET GRID gridname command.
* v6.11 *acm* 4/08 Fix bug 1558: revert previous changes.
*                  When we WANT the grid of a SET GRID gridname command, need to use
*                  mgrid_abstract and saved_abstract_grid. I no longer know the reason 
*                  for the previous change; it does not seem to fix any listed bug and
*                  reverting does not break anything...
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V690 1/14 *sh* removed special behavior for mode_stupid
* V698 3/16 *sh* added logic for cat_ef_time2d (ACTS_LIKE_FVAR)

	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'ferret.parm'
	include 'implicit.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
	include 'xfr_grid.cmn'

* calling argument declarations:
	INTEGER	cx

* internal variable declarations:
	LOGICAL ACTS_LIKE_FVAR, needs_limits, its_unspec
	INTEGER TM_GET_GRIDNUM,
     .          idim, cat, var, grid, mabstract, line, status, grr

* possible skip this routine
! commented this out 1/2014 cuz it causes a crash in aux var processing
! and it isn't clear why Ferret should function correctly when this line is here
!	IF (mode_stupid) GOTO 1000

* initialize
	var  = cx_variable( cx )
	cat  = cx_category( cx )
	grid = cx_grid    ( cx )

        grr = TM_GET_GRIDNUM ('ABSTRACT')

	DO 100 idim = 1, nferdims

* get the axis number for the abstract axis

           grr = saved_abstract_grid
           IF (grr .EQ. unspecified_int4) grr = mgrid_abstract
	   mabstract = grid_line( idim, mgrid_abstract )

	   IF ( cx_by_ss(idim, cx) ) THEN
	      its_unspec = cx_lo_ss(cx,idim) .EQ. unspecified_int4
	   ELSE
	      its_unspec = cx_lo_ww(idim,cx) .EQ. unspecified_val8
	   ENDIF

	   IF ( its_unspec ) THEN

	      line = grid_line( idim, grid )

 11	    needs_limits = line .NE. mnormal
     .		       .AND. line .NE. mabstract

* If the limits are given in the definition of the variable (e.g. A=B[J=3:5])
* then it is not possible to complete the limits from the axis length, alone.
* (5/99) However, do complete implicit axis ( >=max_lines ) lims, since
* implicit axes are always full length. This will improve cache hits on
* LOAD a, where a=netCDFvar[i=1:10:2] which uses netCDF strides
* WARNING: For b=a[i=10:100:10];c=b[i=3:5] we have an implicit axis where the
* axis length is NOT applicable. HOPEFULL completing these limits will not
* cause a problem.
* Note: 4/00 Since netCDF axes are now dynamic we can no longer use max_lines
*	as a test of anything significant. I replaced the restriction 
*	    " .	    .AND.  line .LT. max_lines ) THEN"
*	with a test on line_parent. ALERT!

	      IF ( needs_limits .AND. cat.EQ.cat_user_var
     .	    .AND.  line_class(line) .NE. pline_class_stride ) THEN
	         needs_limits = uvar_given(idim,var) .GE. uvlim_needed
	      ENDIF

	      IF ( needs_limits ) THEN

	         cx_by_ss(idim, cx) = .TRUE.
	         IF ( ACTS_LIKE_FVAR(cat) ) THEN
	            CALL VAR_SS_LIMS( idim, cx,
     .				      cx_lo_ss(cx,idim),
     .				      cx_hi_ss(cx,idim)  )
	         ELSE
	            cx_lo_ss(cx,idim) = 1
	            cx_hi_ss(cx,idim) = line_dim( line )
	         ENDIF

*  set cx_given to match behavior of "SET REGION limits"
	         cx_given(idim, cx) = .FALSE.

* flesh out the world coordinates, too
	         CALL  FLESH_OUT_AXIS( idim, cx, status )
* ... status ignored ...

* matches to this region must be based on world coordinates (see 6/00 comments)
	         cx_by_ss(idim, cx) = .FALSE.


	      ENDIF

	   ENDIF

 100	CONTINUE

 1000	RETURN

	END

	SUBROUTINE TM_SECS_TO_YMDHMS ( num_secs, cal_id, 
     .     year, month, day, hour, minute, second, status )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Will convert secs since 01-JAN-0000 00:00:00 to numeric values year, month,
* day, hour, minute, second.
* From tm_secs_to_date.F
*
* Written 12/2016 By Ansley Manke PMEL/ SDIG
* 5/2020 Issue 1906: treat Proleptic-Gregorian identically to Gregorian
*
* Argument definitions
	REAL*8	num_secs
	INTEGER	cal_id, year, month, day, hour, minute, 
     .		second, status

* Include files
	include 'tmap_errors.parm'
        include 'calendar.decl'
        include 'calendar.cmn'

*
* Local Definition

	INTEGER		leapadj, cent_cnt,year_cnt, cent4_cnt, year4_cnt, 
     .			tot_days, tmp_days, ge59
	REAL		yeardays, a
	REAL*8		secs_in_minute, secs_in_hour, secs_in_day,
     .      secs_in_year, secs_in_4years, secs_in_cent,
     .      secs_in_4cents, total_secs, leap_yr_days

	PARAMETER	(secs_in_minute	= 60.0,
     .      secs_in_hour   = secs_in_minute*60.0,
     .      secs_in_day    = secs_in_hour*24.0)

C       CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

	status = merr_ok

* trap invalid input

	IF ( num_secs.LT.0) THEN
	   year = 1
	   month = 1 
	   day = 0
	   hour = 0
	   minute = 0
	   second = 0
	   GOTO 5000
	ENDIF
	IF ( num_secs.LT.0 .OR. 
     .       cal_id.LT.gregorian .OR. cal_id.GT.max_calendars) THEN
	   status = merr_time_string
	   GOTO 5000
	ENDIF

C  Get calendar attributes
        CALL TM_GET_CALENDAR_ATTRIBUTES (cal_id, num_months, 
     .                      num_days, yeardays, month_names,
     .                      days_in_month, days_before_month, 
     .                      month_by_day)

*******************************************************************************
* HANDLE GREGORIAN CALENDAR FIRST  
*******************************************************************************
	if (cal_id.eq.gregorian .or. cal_id.eq.proleptic) then

*          INITIALIZE
	   leap_yr_days = num_days + 1.0

	   secs_in_year	  = secs_in_day*num_days
	   secs_in_4years = 
     .      secs_in_day*(3*num_days + leap_yr_days)
	   secs_in_cent   = 
     .      secs_in_day*(76*num_days + 24*leap_yr_days)
	   secs_in_4cents = 4*secs_in_cent+secs_in_day
	   total_secs = num_secs

*          SUBTRACT YEAR 0 OFF (IT'S A LEAP YEAR)
	   total_secs = total_secs - secs_in_year - secs_in_day

*          MAKE SURE WE AREN'T WORKING IN YEAR 0
	   IF (total_secs .GE. 0) THEN

*             DECIDE WHICH CENTURY IT IS
	      cent4_cnt = INT(total_secs/secs_in_4cents)
	      total_secs = total_secs - cent4_cnt*secs_in_4cents
	      cent_cnt = INT(total_secs/secs_in_cent)
*             DEC 31 ON LEAP CENTURY TEST (YEARS 400,800,1200...)
	      IF (cent_cnt .EQ. 4 .AND.
     .         total_secs .GE. cent4_cnt-secs_in_day)   cent_cnt = 3
	      total_secs = total_secs - cent_cnt*secs_in_cent
	      year = 400*cent4_cnt + 100*cent_cnt
	  
*             DECIDE WHAT YEAR IT IS EXACTLY (1 YEAR FOR YEAR 0)
	      year4_cnt = INT(total_secs/secs_in_4years)
	      total_secs = total_secs - year4_cnt*secs_in_4years
	      year_cnt = INT(total_secs/secs_in_year)
*             DEC 31 ON LEAP YEAR TEST (YEARS 0,4,8,12...)
	      IF (year_cnt .EQ. 4 .AND.
     .         total_secs .GE. secs_in_4years-secs_in_day)   year_cnt = 3
	      total_secs = total_secs - year_cnt*secs_in_year
	      year = year + 4*year4_cnt + year_cnt + 1
	      
	   ELSE
*             Year 0 stuff
	      year = 0
	      total_secs = total_secs + secs_in_year + secs_in_day
	   ENDIF

*          IS THIS A LEAP YEAR? (EVERY 4TH CENTURY IS, OTHERWISE CENTURY ISN'T)
	   leapadj = 0
	   IF (MOD(year,400) .EQ. 0) THEN
	      leapadj = 1
	   ELSE IF (MOD(year,4) .EQ. 0 .AND. MOD(year,100) .NE. 0) THEN
	      leapadj = 1
	   ENDIF

*          HOW  MANY DAYS INTO YEAR IS THIS
	   tot_days = INT(total_secs/secs_in_day)
	   total_secs = total_secs - tot_days*secs_in_day
	   
*          DECIDE WHAT MONTH/DAY IT IS
c acm  The following INT evaluates to 0 when tot_days=59 under Linux
c acm  using FLOAT(tot_days) does not change this
c acm  Use a simpler IF test instead.

c acm	   tmp_days = tot_days - leapadj*INT(tot_days/366. + 307./366.)

           ge59 = 0
           IF (tot_days .GE. 59) ge59 = 1
	   tmp_days = tot_days - leapadj* ge59
	   IF (tmp_days .LT. 0) THEN
              STOP 'negative subscript in TM_SECS_TO_YMDHMS'
	   ENDIF
	   month = month_by_day(tmp_days+1)
	   leapadj = INT(month/12. +.75)*leapadj
	   day = tot_days - (days_before_month(month)+leapadj) + 1
	   
*          CALCULATE NUMBER OF HOURS
	   hour = INT(total_secs/secs_in_hour)
*          SUBTRACT SECONDS FOR NUMBER OF HOURS
	   total_secs = total_secs - secs_in_hour*(hour)
*          CALCULATE NUMBER OF MINUTES
	   minute = INT(total_secs/secs_in_minute)
*          SUBTRACT SECONDS FOR NUMBER OF MINUTES
	   total_secs = total_secs - secs_in_minute*(minute)
*          CALCULATE NUMBER OF SECONDS
	   second = total_secs

*******************************************************************************
* HANDLE JULIAN CALENDAR   
*******************************************************************************
	ELSE IF (cal_id .eq. julian) then

*          INITIALIZE
	   leap_yr_days = num_days + 1.0

	   secs_in_year	  = secs_in_day*num_days
	   secs_in_4years = 
     .      secs_in_day*(3*num_days + leap_yr_days)
	   total_secs = num_secs

*          SUBTRACT YEAR 0 OFF (IT'S A LEAP YEAR)
	   total_secs = total_secs - secs_in_year - secs_in_day


*          MAKE SURE WE AREN'T WORKING IN YEAR 0
	   IF (total_secs .GE. 0) THEN

	      year = 0
	  
*             DECIDE WHAT YEAR IT IS EXACTLY (1 YEAR FOR YEAR 0)
	      year4_cnt = INT(total_secs/secs_in_4years)
	      total_secs = total_secs - year4_cnt*secs_in_4years

	      year_cnt = INT(total_secs/secs_in_year)
*             DEC 31 ON LEAP YEAR TEST (YEARS 0,4,8,12...)
	      IF (year_cnt .EQ. 4 .AND.
     .         total_secs .GE. secs_in_4years-secs_in_day)   year_cnt = 3
	      total_secs = total_secs - year_cnt*secs_in_year
	      year = year + 4*year4_cnt + year_cnt + 1
	      
	   ELSE
*             Year 0 stuff
	      year = 0
	      total_secs = total_secs + secs_in_year + secs_in_day
	   ENDIF

*          IS THIS A LEAP YEAR?
	   leapadj = 0
	   IF (MOD(year,4) .EQ. 0) leapadj = 1

*          HOW  MANY DAYS INTO YEAR IS THIS
	   tot_days = INT(total_secs/secs_in_day)
	   total_secs = total_secs - tot_days*secs_in_day

*          DECIDE WHAT MONTH/DAY IT IS

c acm  The following INT evaluates to 0 when tot_days=59 under Linux
c acm  using FLOAT(tot_days) does not change this
c acm  Use a simpler IF test instead.

c acm	   tmp_days = tot_days - leapadj*INT(tot_days/366. + 307./366.)

           ge59 = 0
           IF (tot_days .GE. 59) ge59 = 1
	   tmp_days = tot_days - leapadj* ge59

	   IF (tmp_days .LT. 0) THEN
              STOP 'negative subscript in TM_SECS_TO_YMDHMS'
	   ENDIF
	   month = month_by_day(tmp_days+1)
	   leapadj = INT(month/12. +.75)*leapadj
	   day = tot_days - (days_before_month(month)+leapadj) + 1
	   
*          CALCULATE NUMBER OF HOURS
	   hour = INT(total_secs/secs_in_hour)
*          SUBTRACT SECONDS FOR NUMBER OF HOURS
	   total_secs = total_secs - secs_in_hour*(hour)
*          CALCULATE NUMBER OF MINUTES
	   minute = INT(total_secs/secs_in_minute)
*          SUBTRACT SECONDS FOR NUMBER OF MINUTES
	   total_secs = total_secs - secs_in_minute*(minute)
*          CALCULATE NUMBER OF SECONDS
	   second = total_secs

******************************************************************************
* ALL OTHER SUPPORTED AND REGULAR CALENDARS
******************************************************************************
	ELSE IF (cal_id .GT. gregorian   .AND.  cal_id .NE. julian .AND.
     .           cal_id .LE. max_calendars) THEN

*          INITIALIZE
	   secs_in_year	= secs_in_day*num_days
	   secs_in_cent = 100*secs_in_year
	   total_secs = num_secs

*          SUBTRACT YEAR 0 OFF
	   total_secs = total_secs - secs_in_year

*          MAKE SURE WE AREN'T WORKING IN YEAR 0
	   IF (total_secs .GE. 0) THEN

*             DECIDE WHICH CENTURY IT IS
	      cent_cnt = INT(total_secs/secs_in_cent)
	      total_secs = total_secs - cent_cnt*secs_in_cent
	      year = 100*cent_cnt
	  
*             DECIDE WHAT YEAR IT IS EXACTLY (1 YEAR FOR YEAR 0)
	      year_cnt = INT(total_secs/secs_in_year)
	      total_secs = total_secs - year_cnt*secs_in_year
	      year = year + year_cnt + 1
	      
	   ELSE
*             Year 0 stuff
	      year = 0
	      total_secs = total_secs + secs_in_year
	   ENDIF

*          HOW  MANY DAYS INTO YEAR IS THIS
	   tot_days = INT(total_secs/secs_in_day)
	   total_secs = total_secs - tot_days*secs_in_day
	   
*          DECIDE WHAT MONTH/DAY IT IS
	   month = month_by_day(tot_days+1)
	   day = tot_days - days_before_month(month) + 1
	   
*          CALCULATE NUMBER OF HOURS
	   hour = INT(total_secs/secs_in_hour)
*          SUBTRACT SECONDS FOR NUMBER OF HOURS
	   total_secs = total_secs - secs_in_hour*(hour)
*          CALCULATE NUMBER OF MINUTES
	   minute = INT(total_secs/secs_in_minute)
*          SUBTRACT SECONDS FOR NUMBER OF MINUTES
	   total_secs = total_secs - secs_in_minute*(minute)
*          CALCULATE NUMBER OF SECONDS
	   second = total_secs
	END IF

	status = merr_ok

 5000	RETURN

	END

	SUBROUTINE RSMNMX

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* revised for TMAP
* from PPLUS :
*	Directory PMEL:[PLOT5.PPLV11.PLOT]MINMAX.FOR

* search for "TMAP" to find all revisions
* *sh* - 1/27/89 corrected bug: min/max search improperly rejects LIMITs points
* *sh* - 12/8/93 corrected bug: vectors blow on divied by zero attempt
* *jd* - 4.20.99 Don't delete symbols {X,Y}{MIN,MAX} in overlay plots
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long

C
C	RESET MIN MAX SYMBOLS AND SET LINE_COUNT TO ZERO
C
        include 'switch_inc.decl'
        include 'SWITCH.INC'
        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'lines_inc.decl'
        include 'LINES.INC'

	CHARACTER SYM*120,TEMP*2
C
	SYM='*PPL$LINE_COUNT'
	TEMP='0'
	CALL PUTSYM(SYM,TEMP,1,IER)
C
	DO 10 I=1,LNUM
	WRITE(SYM,999)'XMIN',I
999	FORMAT('*PPL$',A,'(',I2,')')
	CALL DELSYM(SYM,IER)
	WRITE(SYM,999)'XMAX',I
	CALL DELSYM(SYM,IER)
	WRITE(SYM,999)'YMIN',I
	CALL DELSYM(SYM,IER)
	WRITE(SYM,999)'YMAX',I
	CALL DELSYM(SYM,IER)
C
	WRITE(SYM,999)'XFIRST',I
	CALL DELSYM(SYM,IER)
	WRITE(SYM,999)'XLAST',I
	CALL DELSYM(SYM,IER)
	WRITE(SYM,999)'YFIRST',I
	CALL DELSYM(SYM,IER)
	WRITE(SYM,999)'YLAST',I
	CALL DELSYM(SYM,IER)
10	CONTINUE
C
*jd*begin
	IF(.NOT.SOVER)THEN
	   SYM='*PPL$XMIN'
	   CALL DELSYM(SYM,IER)
	   SYM='*PPL$XMAX'
	   CALL DELSYM(SYM,IER)
	   SYM='*PPL$YMIN'
	   CALL DELSYM(SYM,IER)
	   SYM='*PPL$YMAX'
	   CALL DELSYM(SYM,IER)
	ENDIF
*jd*end
	SYM='*PPL$ZMIN'
	CALL DELSYM(SYM,IER)
	SYM='*PPL$ZMAX'
	CALL DELSYM(SYM,IER)
	sym='*PPL$XHIGH'
	CALL DELSYM(SYM,IER)
	sym='*PPL$YHIGH'
	CALL DELSYM(SYM,IER)
	sym='*PPL$XLOW'
	CALL DELSYM(SYM,IER)
	sym='*PPL$YLOW'
	CALL DELSYM(SYM,IER)
	RETURN
	END

	INTEGER FUNCTION DO_FILL_INTERP_DSG( idim, dset, nfeatures, maxobs,
     .				com, com_mr, com_cx,
     .				res, res_mr, res_cx,
     .				coords )


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* fill along axis idim by interpolating from the closest available valid pt
* for data on Distributed Sampling Geometries grids


* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Science Data Integration Group
* 2/2019
* V76   1/20 *acm* Orientation of Point-type data set to e_dim

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include	'xprog_state.cmn'
	include 'xdyn_linemem.cmn_text'
	include 'xdset_info.cmn_text'
	include 'xdsg_context.cmn'

* calling argument declarations:
	INTEGER	idim, com_mr, com_cx, res_mr, res_cx, dset, nfeatures, maxobs
	REAL	coords(*)
	REAL	com   (*),
     .          res   (*)

* internal variable declarations:
	INTEGER i, ii, lo_index, hi_index, look, i1
	REAL	bad_res, bad_com, lo_coord, hi_coord, coord, val, 
     .          lo_val, hi_val, boxdel, boxmean, boxstd

	LOGICAL	fmask(nfeatures), omask(maxobs), no_lo_val
	INTEGER ifeature, iobs, flen, base, orientation, row_size_lm, 
     .          dsg_fmt_grid, dsg_coord_lm

* initialize
	bad_res = mr_bad_data( com_mr )

* initialize
	orientation = dsg_orientation(dset)
	
	IF (dsg_row_size_var(dset) .GT. 0) row_size_lm = dsg_loaded_lm(dsg_row_size_var(dset))
	bad_res = mr_bad_data( res_mr )
	bad_com = mr_bad_data( com_mr )

* get feature mask and dsg grid and coordinate information
        CALL MAKE_DSG_FEATURE_MASK(dset, res_cx, fmask, nfeatures)

	row_size_lm  = dsg_loaded_lm(dsg_row_size_var(dset))
	dsg_fmt_grid = dsg_xlate_grid(dset)
	orientation  = dsg_orientation(dset)
	dsg_coord_lm = cxdsg_coord_lm(orientation)

* ... For coordinates use index values within the feature. 
*     DSGTODO: Use coordinate data such as time or depth, 
*     and earth-distance? If so compute per feature

	DO i = 1, maxobs
	   coords(i) = i
	ENDDO
	   
	   

* ****** PERFORM THE COMPUTATION *****
	IF (idim.EQ.orientation .AND. orientation.LE.t_dim) THEN 

* *** true ragged array processing:

	   base = 0    ! obs index at end of preceding feature

* ... loop over the features
	   ftrloop: DO ifeature = 1, nfeatures 

	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
	      iobs = base

* ... have the user's WW constraints removed this feature?
	      IF (.NOT.fmask(ifeature)) THEN
	         DO i = 1, flen
	            iobs = iobs + 1   ! index in the contig ragged array
	            res(iobs) = bad_res
		 ENDDO
                 base = base + flen
                 CYCLE  ftrloop
              ENDIF

* Get and save box sizes for all feature coordinates. Feature-mask applied later.
* For coordinates, distance-along-path, for trajectories, or the coordinate data 
* for time or profile types

              IF (orientation .EQ. x_dim) THEN

	         val = 1.  ! the unit, not applied here
	         CALL BOXES_DSG (orientation, flen, val, 
     .		   dsg_linemem(dsg_coord_lm)%ptr(base+1), 
     .		   dsg_linemem(cxdsg_coord_lm(y_dim))%ptr(base+1), coords)
           
* array coords congains the box sizes.
* Sum the box-sizes along the trajectory to create the "coordinate" list
* Large box-sizes greater than 2 std are replaced by nearby box size

	         coords(1) = 0.
	         DO i = 2, flen

		    boxdel = coords(i)

		    IF (boxdel .GT. 2.* boxstd) THEN
		       IF (i.GT.1) THEN
		          boxdel = MIN( boxstd, coords(i-1) )
		       ELSEIF (i.LT.flen) THEN
		          boxdel = MIN( boxstd, coords(i+1) )
		       ELSE
		          boxdel = boxmean
		       ENDIF
	            ENDIF

	            coords(i) = coords(i-1) + boxdel
	         ENDDO



              ELSE
	
* The coordinates for this feature.
	         iobs = base
	         DO i = 1, flen
	            iobs = iobs + 1
                    coords(i) = dsg_linemem(dsg_coord_lm)%ptr(iobs)
		 ENDDO

              ENDIF


	      iobs = base

* ... get observation-level mask for this feature
	      CALL MAKE_DSG_OBS_MASK(dset, com_cx, ifeature, base,
     .				     omask, flen)

* ... Initialize - is the first data in this feature valid?

              no_lo_val = .TRUE.
              val = com(iobs+1 )
	      IF (val .NE. bad_com ) THEN
                 lo_val = val
	         lo_index = 1
	         lo_coord = coords(1)
                 no_lo_val = .FALSE.
	      ENDIF

* ... loop over the observations within each feature
	      oloop: DO i = 1, flen
	         iobs = iobs + 1   ! index in the contig ragged array
	         res(iobs) = bad_res

	         IF (.NOT.omask(i)) CYCLE oloop

* ... the input data value
                 val = com(iobs)

	         IF ( val .NE. bad_com ) THEN

		    res(iobs) = val
		    lo_val = val
		    lo_index = i
		    lo_coord = coords(i)
		    no_lo_val = .FALSE.

	         ELSE
		 
		    IF (no_lo_val) THEN
* ... no lower valid point
		       res(iobs) = bad_res
		       CYCLE oloop
		    ENDIF

* ... look forward from current position for next valid point

                    hi_index = 0
		    lookup: DO ii = i+1, flen
                       look = ii
		       IF ( com(ii+base) .NE. bad_com ) THEN
                          hi_val = com(ii+base)
	                  hi_index = ii
		          hi_coord = coords(ii)
			  EXIT  lookup
                       ENDIF
                    ENDDO lookup

		    IF (hi_index .NE. 0) THEN

* ... fill in interpolating value
		       coord    = coords(i)
		       res(iobs) = ( hi_val*(coord-lo_coord)
     .                            +  lo_val*(hi_coord-coord) )
     .                            / (hi_coord - lo_coord)
		    ENDIF

	         ENDIF

              ENDDO  oloop

              base = base + flen

	   ENDDO  ftrloop



	ELSE

* *** a simple list of instances:


	   DO ifeature = 1, nfeatures
	      coords(ifeature) = ifeature
	      res(ifeature) = bad_res
	   ENDDO

	   no_lo_val = .TRUE.
	   DO i1 = 1, nfeatures
	      IF (fmask(i1) ) EXIT
	   ENDDO
	   val = com(i1 )
	   
	   IF (val .NE. bad_com) THEN
	      lo_val = val
	      lo_index = i1
	      lo_coord = coords(i1)
	      no_lo_val = .FALSE.
	   ENDIF

	   DO ifeature = i1, nfeatures 

* ... have the user's WW constraints removed this feature?
	      IF (.NOT.fmask(ifeature)) CYCLE

* ... the input data value
              val = com(ifeature)

	      IF ( val .NE. bad_com ) THEN
	         res(ifeature) = val
		 lo_val = val
		 lo_index = ifeature
		 lo_coord = coords(ifeature)
		 no_lo_val = .FALSE.

	      ELSE

	         IF (no_lo_val) THEN
* ... no lower valid point
	            res(iobs) = bad_res
	            CYCLE
		 ENDIF

* ... look forward from current position for next valid point

		 hi_index = 0
		 DO ii = ifeature+1, nfeatures
		    look = ii
		    IF (.NOT.fmask(ii)) CYCLE
		    IF ( com(ii) .NE. bad_com ) THEN
                       hi_val = com(ii)
	               hi_index = look
		       hi_coord = coords(ii)
	               CYCLE  ! this loop
		    ENDIF
		 ENDDO

		 IF (hi_index .NE. 0) THEN

* ... fill in interpolating value
		    coord    = coords(i)
		    res(ifeature) = ( hi_val*(coord-lo_coord)
     .                             +  lo_val*(hi_coord-coord) )
     .                            / (hi_coord - lo_coord)
		 ENDIF

	      ENDIF

           ENDDO  ! ifeature

	ENDIF     ! simple list of instances


* always success
	DO_FILL_INTERP_DSG = ferr_ok
	RETURN

	END

      SUBROUTINE ADD_ATTRIBUTE( grid_data, mr, varattname, dset, 
     .         attype_spec, attoutflag, new_att, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*  add a new attribute to a variable

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP
* 9/2005
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V698  5/16 *acm* Ticket 2416 allow all output types for DEFINE ATT.


      include 'tmap_dims.parm'
      INCLUDE 'ferret.parm'
      INCLUDE 'errmsg.parm'
      INCLUDE 'xvariables.cmn'
      INCLUDE 'netcdf.inc'

* local parameter declarations:
      INTEGER  max_line_len
      PARAMETER ( max_line_len = 2048 )

* calling argument declarations:

      LOGICAL new_att
      INTEGER mr, attype_spec, dset, attoutflag, status
      REAL grid_data(mr_lo_ss(mr,1):mr_hi_ss(mr,1),
     .               mr_lo_ss(mr,2):mr_hi_ss(mr,2),
     .               mr_lo_ss(mr,3):mr_hi_ss(mr,3),
     .               mr_lo_ss(mr,4):mr_hi_ss(mr,4),
     .               mr_lo_ss(mr,5):mr_hi_ss(mr,5),
     .               mr_lo_ss(mr,6):mr_hi_ss(mr,6))
      CHARACTER*(*) varattname

* local variable declarations: 
      
      LOGICAL valid, do_err
      INTEGER MR_DIM_LEN, TM_LENSTR1, varid, idim, ndims, attlen,
     .        attype, span, lo(nferdims), hi(nferdims), del(nferdims), slen, vlen
      REAL dummy
      CHARACTER GET_STRING_ELEMENT*2048, TM_FMT*2048, attbuff*2048, 
     .          varname*512, attname*128

      vlen = TM_LENSTR1(varattname)  
      new_att = .TRUE.

! Check that the expresssion is 1-D and if it is a string, just 1 value.

      ndims = 0
      attlen = 0
      DO 30 idim = 1, nferdims
         span = MR_DIM_LEN(idim, mr )
         valid = mr_lo_ss( mr,idim ) .NE. unspecified_int4
         IF (span .GT. 0 .AND. valid ) ndims = ndims + 1
         attlen = MAX(attlen, span)
 30   CONTINUE

* * * * * DETERMINE INDEX LIMITS * * *
      DO 40 idim = 1, nferdims
         lo(idim) = mr_lo_ss( mr, idim )
         hi(idim) = mr_hi_ss( mr, idim )
         del(idim)= 1
 40   CONTINUE

      IF (ndims .LT. 0 .OR. ndims .GT. 1) GOTO 5100

* Reconcile data types for the attribute. If requested to add a float attribute
* but the expression is a string, it is an error.  If a string was requested,
* we can convert a numeric value to string below.

      IF (attype_spec .EQ. ptype_unknown) THEN
         attype = NCFLOAT
         IF (mr_type(mr) .EQ. ptype_string) attype = NCCHAR 
      ELSE
         attype = attype_spec
      ENDIF
      IF (attype .NE. NCCHAR .AND. 
     .    mr_type(mr) .EQ. ptype_string) GOTO 5300

* See if the attribute already exists for the variable. (If it does
* then one can use SET ATT). The flag do_err is false so no error message 
* is issued in break_varattname if attr does not exist.

      do_err = .FALSE.
      CALL BREAK_VARATTNAME ( varattname, dset, varname, 
     .              attname, varid, do_err, status )

      IF (status .NE. ferr_ok) THEN
         IF (attype .EQ. NCCHAR ) THEN

* Requested string but provided a numeric expression.
* Use first value of expression.

            IF (mr_type(mr) .NE. ptype_string) THEN
               attbuff = TM_FMT( 
     .             grid_data(lo(1),lo(2),lo(3),lo(4),lo(5),lo(6)),
     .             8, 40, slen)
               IF (attlen .GT. 1) THEN 
                  CALL WARN ('Requested string attribute using a ',
     .            'numeric expression. Using first value and ',
     .            'converting to string')
                  attlen = 1
               ENDIF

            ELSE
               IF (attlen .GT. 1) GOTO 5200
               attbuff = GET_STRING_ELEMENT(
     .           lo(1), hi(1), lo(2), hi(2), lo(3), hi(3), 
     .	         lo(4), hi(4), lo(5), hi(5), lo(6), hi(6),
     .           grid_data, lo(1), lo(2), lo(3), lo(4), lo(5), lo(6),
     .	         max_line_len, slen)

               dummy = 1.
               attlen = TM_LENSTR1(attbuff)    

            ENDIF
            CALL CD_PUT_NEW_ATTR (dset, varid, attname, attype, attlen, 
     .         attoutflag, attbuff, dummy, status)  

         ELSE 
            CALL CD_PUT_NEW_ATTR (dset, varid, attname, attype, attlen, 
     .         attoutflag, attbuff, 
     .         grid_data(lo(1),lo(2),lo(3),lo(4),lo(5),lo(6)), status)      
         ENDIF

!  If attribute already exists, error

      ELSE
c         GOTO 5400
         new_att = .FALSE.
      ENDIF

 5000 RETURN
 5100 attbuff = varattname(:vlen)
      CALL ERRMSG( ferr_syntax, status,
     .  'attribute values must be 1 dimensional: '//
     .   attbuff(:vlen),*5000 )

 5200 attbuff = varattname(:vlen)
      CALL ERRMSG( ferr_syntax, status,
     .  'String attribute may contain just one string: '//
     .  attbuff(:vlen),*5000 )

 5300 attbuff = varattname(:vlen)
      CALL ERRMSG( ferr_syntax, status,
     .  'Attribute type does not match expression: '//
     .   attbuff(:vlen),*5000)

 5400 attbuff = varattname(:vlen)
      CALL ERRMSG( ferr_syntax, status,
     .  'Attribute already exists: '//attbuff(:vlen)//
     .  ' Use SET ATTRIBUTE to change an attribute',*5000)

      END

      SUBROUTINE PROF( KMIX,	UK,  muk,
     .				VK,  mvk,
     .				ROK, mrok,
     .				RNUE,mrnue, HNUE,mhnue  )	! 1522 mod

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* calculate vertical mixing coefficients

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/7/86	extracted from SUBROUTINE HDIFFUS
*			with major modifications to convert i-k oriented
*			calculations to i-j oriented calculations
* revision 0.1 - 5/7/87 - changes in IF tests to avoid under/over flow
* V200:  7/25/89 - 4D symmetrical
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN

#ifdef unix
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl.parm'		! parameter definitions
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xonedim.cmn'	! geometric constants
	include 'xcontext.cmn'
#else
	INCLUDE 'FERRET_CMN:FERRET.PARM'
	INCLUDE 'FERRET_CMN:GFDL.PARM'		! parameter definitions
	INCLUDE	'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE	'FERRET_CMN:XMEM_SUBSC.CMN'
	INCLUDE 'FERRET_CMN:XONEDIM.CMN'	! geometric constants
	INCLUDE 'FERRET_CMN:XCONTEXT.CMN'
#endif

* calling argument declarations:
	INTEGER	KMIX, muk, mvk, mrok, mrnue, mhnue
* subscript ranges from memory variable table ...
	REAL      uk( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit ),
     .		  vk( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,m2lot:m2hit ),
     .		 rok( m3lox:m3hix,m3loy:m3hiy,m3loz:m3hiz,m3lot:m3hit ),
     .		rnue( m4lox:m4hix,m4loy:m4hiy,m4loz:m4hiz,m4lot:m4hit ),
     .		hnue( m5lox:m5hix,m5loy:m5hiy,m5loz:m5hiz,m5lot:m5hit )

* internal variable declarations:
	INTEGER	i, j, k, l
	REAL	bad_uk, bad_vk, bad_ro, bad_rnue, bad_hnue,
     .		fricmax, gr, di, windmix

      DATA FRICMAX / 50./,GR/980./					! 1541

* flag(s) for bad or missing values
	bad_uk = mr_bad_data ( muk  )
	bad_vk = mr_bad_data ( mvk  )
	bad_ro = mr_bad_data ( mrok )
	bad_rnue = mr_bad_data ( mrnue )   ! added 2/93
	bad_hnue = mr_bad_data ( mhnue )   ! added 2/93

	DO 1000 l = mr_lo_s4(mrnue), mr_hi_s4(mrnue)
	DO 1000 k = mr_lo_s3(mrnue), mr_hi_s3(mrnue)

	IF ( k .LT. kmix ) THEN 	! kmix may be generalized to im x jm

	DO 50 j = mr_lo_s2(mrnue), mr_hi_s2(mrnue)
	DO 50 i = mr_lo_s1(mrnue), mr_hi_s1(mrnue)

	IF ( uk  (i,j,k,l) .EQ. bad_uk
     .	.OR. vk  (i,j,k,l) .EQ. bad_vk
     .	.OR. rok (i,j,k,l) .EQ. bad_ro ) THEN
	   rnue(i,j,k,l) = bad_rnue
	   hnue(i,j,k,l) = bad_hnue
	   GOTO 50
	ENDIF

      HNUE(i,j,k,l)=((Uk(I,j,K+1,l)-Uk(i,j,k,l))**2
     .		   + (Vk(I,j,k+1,l)-Vk(i,j,k,l))**2)	! 1545 mod
C									! 1547
C     COMPUTE RICHARDSON NUMBER						! 1548
C									! 1549
	di = dzz(k+1)		! ref.   1088   DI(I,K)=ZDZZ(K+1)-ZDZZ(K)
	HNUE(i,j,k,l)= GR*DI*(ROk(I,j,k+1,l)-ROk(i,j,k,l))
     .		     /(HNUE(i,j,k,l)+1.E-20)! 1552 mod

C									! 1553
C     NEG RICH NUMBERS WILL BE HANDLED BY CONVECTIVE ADJUSTMENT!	! 1554
C									! 1555
	hnue(i,j,k,l) = ABS( hnue(i,j,k,l) )			     ! 1556 mod

* under/over flow fix
	IF ( hnue(i,j,k,l) .GT. 1.E11 ) THEN
	 rnue(i,j,k,l) = bam
	 hnue(i,j,k,l) = bah
	 GOTO 50
	ENDIF

      HNUE(i,j,k,l)=1.+5.*HNUE(i,j,k,l)					! 1559
C									! 1561
C     COMPUTE VERTICAL VISCOSITY					! 1562
C									! 1563
      RNUE(i,j,k,l) = FRICMAX / HNUE(i,j,k,l)**2		! 1566 mod
C									! 1567
C     COMPUTE VERTICAL DIFFUSIVITY					! 1568
C									! 1569
      HNUE(i,j,k,l)=RNUE(i,j,k,l)/HNUE(i,j,k,l)+BAH		! 1572 mod
C									! 1573
C     ADD IN BACKGROUND							! 1574
C									! 1575
      RNUE(i,j,k,l)=RNUE(i,j,k,l)+BAM				! 1578 mod
 50	CONTINUE

	ELSE

C									! 1579
C     SET BACKGROUND VALUES BELOW LEVEL KMIX				! 1580
C									! 1581
	DO 60 j = mr_lo_s2(mrnue), mr_hi_s2(mrnue)
	DO 60 i = mr_lo_s1(mrnue), mr_hi_s1(mrnue)		! 1583 mod 
      RNUE(i,j,k,l)=BAM							! 1584
  60  HNUE(i,j,k,l)=BAH							! 1585

	ENDIF
C									! 1586
C     APPROX HIGH FREQ WIND MIXING NEAR SURFACE				! 1587
C									! 1588
	IF ( k .EQ. 1 ) THEN
      WINDMIX=10.							! 1589
	DO 70 j = mr_lo_s2(mrnue), mr_hi_s2(mrnue)
	DO 70 i = mr_lo_s1(mrnue), mr_hi_s1(mrnue)		! 1590 mod 
      IF (   rnue(i,j,k,l) .NE. bad_rnue
     . .AND. RNUE(i,j,k,l) .LT. WINDMIX ) RNUE(i,j,k,l)=WINDMIX	! 1591 mod
      IF (   hnue(i,j,k,l) .NE. bad_hnue
     . .AND. HNUE(i,j,k,l) .LT. WINDMIX ) HNUE(i,j,k,l)=WINDMIX	! 1592 mod
70    CONTINUE								! 1593
	ENDIF

 1000	CONTINUE

      RETURN								! 1594
      END								! 1595

*
* samplexy_closest.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without anx fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and anx derivative works thereof, and
*  its supporting documentation for anx purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in anx publications that result from
*  the use of this software or in anx product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in anx advertising or publicity to endorse or promote anx products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with anx support, consulting,
*  training or assistance of anx kind with regard to the use, operation
*  and performance of this software nor to provide the user with anx
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND Anx EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR Anx SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR Anx DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
*
*   Version of samplexy to get data at the nearest grid point rather
*   than doing interpolation.
*
* This function samples 4-d data on the x and y axes indicated by args 2 and 3
* 9/10/99  Ansley Manke 
*         Result is abstract on the x axis, normal on the y axis,
*         and keeps the z and t axes of the input 4-d data.
*
* 5/2020  Remove the contents and point to samplexy_nrst
*

      SUBROUTINE samplexy_closest_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CHARACTER*100 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT ('This function is discontinued. It is renamed to SAMPLEXY_NRST')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'DAT_TO_SAMPLE')
      CALL ef_set_arg_desc(id, arg, 'variable (x,y,z,t,e,f) to sample')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'XPTS')
      CALL ef_set_arg_desc(id, arg, 'X values of sample points')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'YPTS')
      CALL ef_set_arg_desc(id, arg, 'Y values of sample points')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE samplexy_closest_compute(id, arg_1, arg_2, arg_3,
     .        result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)


 999  CALL ef_bail_out (id, 'This function has been replaced by SAMPLEXY_NRST')

      RETURN
      END

	block data pltdat_block_data

C	Initialization of PLTCOM.DAT common block.  Must be done in 
C	a block data stmt in FORTRAN 90.  *jd* Linux port 12.96
C       All ports should have this, not just Linux (for sh libs) *js* 8.97

      include 'PLTCOM.DAT'

      DATA A/0.0/,AMAX/7500.0/,AMIN/0.0/,AOLD/0.0/,AORIGN/500.0/,
     * AOSOLD/0.0/,ASIZE/7500.0/,B/0.0/,BAUDR/4800/,BMAX/5625.0/,
     * BMIN/0.0/,BOLD/0.0/,BORIGN/750.0/,BOSOLD/0.0/,BSIZE/5625.0/,
     * COLD/0.0/,COLOUR/1/,DSEG/150.0,100.0,150.0,100.0/,FACTOR/1000.0/,
     * FZCNT/1/,GKSOPN/.FALSE./,GRAPHF/.FALSE./,HMARK/10./,HPSCLA/779./,
     * HPSCLB/719.0/,IPRIM/0/,ISEQ/1/,LOSFLG/0/,LOWFLG/0/,LPEN/.FALSE./,
     * LUHP/8/,LUTK/9/,LUSY/10/,MIRAF/.FALSE./,MIRBF/.FALSE./,
     * NEWFIL/.TRUE./,OLDGZA/0/,OLDGZB/0/,OLDHTA/0/,OLDHTB/0/,
     * OLDHPA/0.0/,OLDHPB/0.0/,OWFLG/0/,PLTFLG/.FALSE./,PLTOHA/.06/,
     * PLTOHB/.07200/,PLTOTA/0.1364/,PLTOTB/0.1385/,
     * PMODE/ALPHA/,PTYPE/0/,ROTAT/.FALSE./,SAVEF/.FALSE./,
     * TEKOPN/.FALSE./,
     * THIGHT/5.625/,TSCLA/1023.0/,TSCLB/779.0/,TTYPE/4010/,TWIDTH/7.5/,
     * VIEWF/.FALSE./,XOLD/-0.5/,XSCALE/1000.0/,YOLD/-0.75/,
     * YSCALE/1000.0/,WINDOF/.FALSE./,ZOLD/0.0/,ZSCALE/1000.0/,
     * ZTEMP/0.0/
	data filez/'zeta.plt'/,filet/'/dev/tty'/
	DATA TEKON/27,67,69/,TEKOFF/27,67,70,22,22/,
     * HOME/29,56,117,32,64/

	end

	SUBROUTINE TM_FILL ( a_lo_x, a_lo_y, a_lo_z, a_lo_t,
     .                       a_hi_x, a_hi_y, a_hi_z, a_hi_t,
     .			     region, value )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Fill a 4D region of data with a single specified value

* V500 *sh* 3/99 

#include "gt_lib.parm"


* calling argument declarations
	INTEGER		a_lo_x, a_lo_y, a_lo_z, a_lo_t,
     .                  a_hi_x, a_hi_y, a_hi_z, a_hi_t
	REAL		value, 
     .                  region(a_lo_x:a_hi_x,a_lo_y:a_hi_y,
     .                      a_lo_z:a_hi_z,a_lo_t:a_hi_t,
     .			    unspecified_int4:unspecified_int4,
     .			    unspecified_int4:unspecified_int4)


* internal variable declarations
	INTEGER		i, j, k, l, m, n
	INTEGER		a_lo_e, a_lo_f, a_hi_e, a_hi_f

	DO 100 n = a_lo_f, a_hi_f
	DO 100 m = a_lo_e, a_hi_e
	DO 100 l = a_lo_t, a_hi_t
	DO 100 k = a_lo_z, a_hi_z
	DO 100 j = a_lo_y, a_hi_y
	DO 100 i = a_lo_x, a_hi_x

	    region(i,j,k,l,unspecified_int4,unspecified_int4) = value

 100	CONTINUE

	RETURN
	END

	SUBROUTINE XEQ_PLOT

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute the plot command

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 7/8/87  - based on XEQ_CONTOUR rev. 0.3
* revision 0.1 - 7/28/87 - added CALL DISP_PREP
* revision 0.2 - 3/2/88  - added safety check for data range prior to plotting
* revision 0.3 - 4/12/88 - added /NOLABELS
* revision 0.4 - 4/28/88 - moved rev. 0.2 check to PLOT_SET_UP
* revision 0.5 - 8/2/88  - added mode wait
* revision 1.0 - 9/21/88 - do_labels --> no_labels: /NOLABEL processing chged
* V200:   1/8/89 - using keys - major rewrite
*	 3/13/90 - check status from DISP_PREP
*	  5/8/90 - allow PLOT/VS to overlay 2D fields
* V230:  7/23/92 - when /LINE_STYLE is given /SYMBOLS must default to OFF
* V301:	  1/7/94 - bug fix: (see DISP_DATA_SET_UP) must unprotect plot data
*        1/27/94 - raise limit on /LINE=# from num_plain (6) to num_fancy_lines
* V312: 5/94 - array "memory" as a calling argument
* V320:   1/20/94 - changes to SAVE_FRAME call reflecting C-based procedures
*	  1/27/95 - default style for /VS is now /SYMBOLS_ONLY
* V450:  5/29/97 - added /NOAXES qualifier
* V500   4.27.99 - *jd* NLINES command added to clean up after/before POLYGON
* V510 *sh* 3/00 - added PLOT/COLOR=/SIZE= qualifiers
* V521 6/00 *sh* - bug fix: PLOT/LINE/SYM should auto-select colors
* V530 *sh* 1/01 - added PLOT/STEP
* V530 *acm* 5/01 - added PLOT/DASH
*	            and PLOT/SYMBOL=dot
* V533 *acm* 6/01 - add arguments is_logh, is_logv to PLOT_SET_UP call, 
*                  set log axes, inverse log axes and log depth axes with
*                  /VLOG or /HLOG
*      *acm* 7/01 - Add /AXES=TOP,BOT,LEFT,RIGHT
*		    & call ax_on_off to implement /NOAXES.
*      *acm* 10/01  remove VMS includes
* V540 *acm*  2/02  restore persistence of PPL AXSET settings
* V541 *acm*  3/02  Make PPL AXSET settings persist, but not settings
*                   done with qualifiers /AXES= or /NOAXES
* V541 *acm*  3/02  Allow PLOT/VS/LINE/DASH
* V541 *ACM*  8/02  Remove the call with dot_sym=99 for PLOT/SYM=DOT-- need
*                      to resolve PPLUS issues with polymark first.
* V550 *acm* 12/02  Restore dot_sym = 99 and warnings that /THICK and /SIZE 
!                    do not apply to DOT
* v554 *acm* 11/03  Bug fix: plot/sym/size=  didnt change the size; the size
*                   was always being reset to the default, not just on sym=dot.
* v554: *acm* 2/04 add /HGRAT /VGRAT to draw optional graticule lines at tic marks
* V580: *acm*11/04 add PLOT/NOKEY qualifier (bug 1089)
* V580 *acm*11/04  (bug 1085) Allow JFness to be set when cycling through colors 
*                  automatically. In call to line_style, when color = -11  then 
*                  thin line, color=-21 then JF=2, when color=-31 then thick=3
* V581 *acm* 5/05  fix bug 1250: step=connected. Need to use EQUAL_STR to get the
*                  argument to /STEP, then compare to see if it equals uppercase 'CON'
* V600 *acm* 5/06  increase length of buff, for longer arugments to /DASH=
* V600 *acm* 5/06  with MODE LINECOLORS, number of lines not limited to num_fancy_lines
* V6.11 4/08 *acm* Fixes for bug 1571; call to PPL_AXES_RESTORE moved to DISP_INIT
* V612 *acm*  8/08 Fixing bug 1038. No Valid Data labeled as on 2D plots. If 
*                  there is no valid data, get the info from plot_set_up and add 
*                  a to the plot. If this is an overlay, that is added to the label
*                  in plot_set_up.
* V612 *acm* 10/08 No Valid Data labeled If there is no valid data, only add this
*                  information to the label in plot_set_up. (see bugs 1038 and 1565)
* V6.2  *acm* 11/08Fix bug 1609: If the plot is an overlay then do not process /AXES=
*                  or /NOAXES. Axes are never drawn for overlays anyway.
* V6.2  *acm& 2/09 Fix choice of color settings with /PEN and /THICK when we have 
*                  increased the num of colors with MODE linecolors
* V6.85 *acm* 3/13 Fix ticket 2049; check we can open palette file
* V6.85 *acm* 9/13 New qualifier PLOT/%%%%%%% for first color in multi-line plot
* http://www.pmel.noaa.gov/maillists/tmap/ferret_users/fu_2013/msg00536.html

* V6.92 *acm* 6/14 New color /key options: any of /key=horizontal,centerlabel
* V6.94 *acm* 2/15 Ticket 2231: New /key option for multiple plot lines: /key=titles
* v696 *acm*  6/15 PLOT/VS/GAPLOC to define seperate line segments on
*                  PLOT/VS/RIBBON plots (LAS ticket 1597 and others). Could implement
*                  this later for other PLOT/VS plots.
* v697 *acm* 12/15 Ticket 2331, add flag changed_key to common, to restore the color key
*                  style after a color plot and also after SHADE/SET; SHADE.
* v698 *sh* 3/16   added PLOT/ALONG=axis
* V698  4/16 *acm* New PLOT/SKIP=
* V7    *acm* 6/16 Ticket 2434: command qualifiers /DEGMINSEC= /HALFSPAC
*                  DEGMINSEC=1 for Deg-Min axis labels, =2 for Deg-Min-Sec. Default = 1
*                  /HALFSPAC adds a half space between the degree sign and E/W or N/S
* V702 1/17 *sh* for trac enhancement #2369 -- dynamic memory management 
* V71  *acm* 2/17  More on ticket 2231. Initialize flag use_keys.
* V73  3/18 *kms*  make dot_sym (99) a makedot.cmn parameter DOTSYMIM
* V74+ 4/18 *acm*  Changes for plotting DSG datasets and trajectories. Pulled 
*                  ribbon-plotting setup into its own routine ribbon_plot_set_up.
* V74+ 4/18 *acm*  Automatically do a colored trajectory plot for the command "PLOT var" 
*                  if it's a DSG trajectory set.
* V74+ 4/18 *acm*  Updates to DSG plotting
* v744 *acm* 11/18 Issue 1786: graticule lines & axes drawn if PLOT/OVER/AXES given
* V751 6/19 *acm*  DSG data cannot be subsetted by index in I,J,K,L; only by coordinates
*                  /X= /Y= /Z= /T=  or with /E= or /M=
* V751 7/19 *acm*  DSG-enabled Ferret: More control of line legends with PLOT/KEY and PLOT/NOKEY
* V751 8/19 *acm*  DSG-enabled Ferret: argumemnt to ITSA_DSG_TRAJ is no longer a dummy
* V76  1/20 *acm*  working with Point-type dsg data
* V76  4/20 *acm*  New flag ribbon_on so that RIBBON/SET; PPL PLOT works correctly

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'plot_setup.parm'
	include 'slash.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'
	include 'xplot_setup.cmn'
        include 'switch_inc.decl'
        include 'SWITCH.INC'
        include 'data_inc.decl'
        include 'DATA.INC'
        include 'PPLDAT.INC'
        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'lines_inc.decl'
        include 'LINES.INC'
	include 'cont_inc.decl' ! with iautoc and nlev
        include 'CONT.INC'
        include 'makedot.cmn'
	include 'xtext_info.cmn'

	
* calling argument declarations:

* internal variable declarations:
	LOGICAL		TM_HAS_STRING, ITSA_DSG_TRAJ, ITSA_DSG_POINTS, 
     .			overlay, transpz, versus,
     .			no_labels, set_up, noaxes, axes, use_line,
     .			is_logh, is_logv, nokey, no_data, no_range,
     .			do_key, spectrum, addgaps, along
	INTEGER		TM_LENSTR1, TM_LENSTR, STR_UPCASE, STR_SAME,
     .                  symbol, color, color1, status,
     .			loc, limit, slen, thick, step_inc,
     .			ax1_work, ax2_work,
     .			do_dash, s1, s2, it_start(4), it_end(4),
     .			nparm, num_it, i, iax(4), i1,
     .                  loch, locv, nvs, skipsym, dsgtype
	REAL		val, sym_size, dashstyle(4), only_val
	CHARACTER	LEFINT*4, buff*128
	
	CHARACTER	TM_INQ_PATH*2048, sfile*2048
	INTEGER ncolors

* set up the graphics environment and get the data
	CALL START_PPLUS
	CALL DISP_DATA_SET_UP(  ax1_work, ax2_work, status )
	IF ( status .NE. ferr_ok ) GOTO 5100

        ncolors = mode_arg(pmode_linecolors,1)

* Initialize the lines buffer in PPL before setting up
	overlay   = qual_given( slash_plot_over_plot ).GT.0
	if (overlay) SOVER = .true.

	if (sover) then
CC      *jd* NLINES initializes SOVER, and resets MIN/MAX. Don't execute. 
CC       => Set values here instead.
	   LINEN=0
	   IBASE=1
	   PBUF=0
	   LNUM=1
	else
	   CALL PPLCMD ( from, line, 0, 'NLINES', 1, 1 )
	endif

* initialize
	no_labels = qual_given( slash_plot_nolabels  ).GT.0
	transpz   = qual_given( slash_plot_transpz   ).GT.0
	versus    = qual_given( slash_plot_vs	     ).GT.0
	set_up	  = qual_given( slash_plot_set_up    ).GT.0
	along     = qual_given( slash_plot_along     ).GT.0
	color     = 1

	IF (along .AND. versus) THEN
	   CALL WARN("/ALONG ignored.  Incompatible with PLOT/VS") 
	   along = .FALSE.
	ENDIF

* On overlays don't draw axes unless specificially requested with /AXES
* (e.g.so graticule lines can be overlaid on a final plot.)

	noaxes    = qual_given( slash_noaxes         ).GT.0
        IF (overlay) THEN
	   noaxes = .FALSE.
	   axes = .FALSE.
	ENDIF
	axes      = qual_given( slash_plot_axes      ).GT.0

	is_logh   = qual_given( slash_is_logh        ).GT.0
	is_logv   = qual_given( slash_is_logv        ).GT.0

	symbol	  = unspecified_int4
	sym_size  = 0.08	! default plot mark size
	thick	  = 1		! default thickness
	color     = qual_on	! automatic selection as default
	step_inc  = 1
        do_dash   = 0		! default no dashes

	IF ( .NOT.overlay ) CALL DISP_INIT(no_labels,is_cx,num_uvars_in_cmnd)
	CALL DISP_PREP( status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* change default style to symbols, only if PLOT/VS (1/27/95)
	IF ( versus ) THEN
	   symbol = qual_on
	   use_line = .FALSE.
	ELSE
	   use_line = .TRUE.
	ENDIF

* decode qualifiers
* ... PLOT/SYMBOL=n
	loc = qual_given( slash_plot_symb )
	IF ( loc .GT. 0  ) THEN

*  Is it SYMBOL=DOT?
	   CALL EQUAL_STRING( cmnd_buff(qual_start(loc):qual_end(loc)),
     .                        buff, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   IF (buff .EQ. 'DOT') THEN
              symbol = DOTSYMIM
           ELSE

	      CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      val, status )	! syntax check
	      IF ( status .NE. ferr_ok ) GOTO 5000

	      IF ( val .NE. unspecified_val4 ) THEN
	         limit = max_sym 
	         IF ( val.LE. 0.0 .OR. val.GT.limit ) GOTO 5200
	         symbol = NINT( val )	! user-specified symbol
	      ELSE
	         symbol = qual_on		! auto selection of symbols
	      ENDIF
           ENDIF
	   use_line = .FALSE.		! default to no line w/ symbol
! 6/00	   color = 1			! default symbol color	      
	ENDIF
* ... PLOT/SYM_SIZE=float
	loc = qual_given( slash_plot_symsize )
	IF ( loc .GT. 0  ) THEN
	   IF ( symbol .EQ. unspecified_int4 ) THEN
	       symbol = qual_on		! turn on symbols if needed
	       use_line = .FALSE.
	       color = 1	
	   ENDIF
	   CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      val, status )	! syntax check
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   IF ( val .NE. unspecified_val4 ) THEN
	      IF ( val.LE. 0.0 ) GOTO 5210
	      sym_size = val		! user-specified symbol
              IF ( symbol .GE. DOTSYMIM) THEN
                 CALL WARN ('/SIZE= ignored  on /SYMBOL=DOT ')
                 sym_size = 0.08
              ENDIF
	   ENDIF
	ENDIF
* ... PLOT/COLOR[=n]
        color1 = 1
	loc = qual_given( slash_plot_color )
	IF ( loc .GT. 0  ) THEN
	   color1 = color
	   CALL EQUAL_COLOR( cmnd_buff(qual_start(loc):qual_end(loc)),
     .                           color, status )
           IF ( status .NE. ferr_ok ) GOTO 5000
           s1 = INDEX( cmnd_buff(qual_start(loc):qual_end(loc)), '=' )	   
           IF ( s1 .EQ. 0 ) THEN
	      color = color1
	      color1 = 2
	      IF ( overlay ) GOTO 5510  ! /COLOR w/o argument not allowed for overlay
	   ENDIF
	ENDIF

* ... PLOT/THICKNESS=n
 	loc = qual_given( slash_plot_thick )
	IF ( loc .GT. 0  ) THEN

	   CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			   val, status )	! syntax check
	   IF ( status .NE. ferr_ok ) GOTO 5000

           IF ((ncolors .EQ. 6) .AND. 
     .               (val .NE. 1  .AND. color .EQ. 19) ) GOTO 5460  ! Only have thin white line

	   IF ( val .NE. unspecified_val4 ) THEN
	      IF ( val.LE.0.0 .OR. val.GT.3 ) GOTO 5400
	      thick = NINT( val )	! user-specified line style
	   ELSE
	      thick = 2  ! default if no value is specified
	   ENDIF

	   IF ( color .EQ. qual_on ) THEN
	   
              IF ( symbol .GE. DOTSYMIM) THEN
                 CALL WARN ('/THICKNESS ignored  on /SYMBOL=DOT ')
	         IF (color .GT. ncolors) color = MOD(color-1,ncolors)+1  ! eliminate thickness
              ELSE
                 color = color-10*(thick-1)
              ENDIF
           ELSE
	      IF (color .GT. ncolors) color = MOD(color-1,ncolors)+1  ! eliminate thickness
	      color = ncolors*(thick-1) + color
              IF ( symbol .GE. DOTSYMIM) THEN
                 CALL WARN ('/THICKNESS ignored  on /SYMBOL=DOT ')
	         color = MOD(color-1,ncolors)+1  ! eliminate thickness
              ENDIF
           ENDIF

	ENDIF
* ... PLOT/LINE_STYLE=n
	loc = qual_given( slash_plot_line )
	IF ( loc .GT. 0  ) THEN
	   use_line = .TRUE.
	   CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      val, status )	! syntax check
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   IF ( val .NE. unspecified_val4 ) THEN
c	      limit = num_fancy_lines 			!was num_plain 1/94
              limit = 3*mode_arg(pmode_linecolors,1)
	      IF ( val.LE. 0.0 .OR. val.GT.limit ) GOTO 5200
	      color = NINT( val )	! user-specified line style
	   ENDIF
* ... default to no symbols when /LINE_STYLE, alone, is given
* 	or for PLOT/VS/LINE  (1/27/95)
           IF ( symbol .EQ. unspecified_int4
     .	   .OR. (versus.AND.qual_given(slash_plot_symb).EQ.0) ) 
     .							symbol = qual_off
	ENDIF

* ... PLOT/SKIP=n

	skipsym = 1
	loc = qual_given( slash_plot_skip )
	IF ( loc .GT. 0) THEN
	   CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      val, status )	! syntax check
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   IF ( val .NE. unspecified_val4 ) skipsym = NINT( val )
	ENDIF 

* ... /KEY[=title]  for control over labeling the multi-line legend

	loc = qual_given( slash_plot_key )
	use_keys = .TRUE.

	IF ( loc .GT. 0) THEN
	   CALL EQUAL_STRING( cmnd_buff(qual_start(loc):qual_end(loc)),
     .                        buff, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   IF (TM_LENSTR(buff) .GT. 0) THEN
	      IF ( TM_HAS_STRING(buff, 'TIT') ) use_keys = .FALSE.
	   ENDIF
	ENDIF
	

* ... /DEGMINSEC[=1 or 2] Request deg/min or deg/min/sec axis labels
	loc = qual_given( slash_plot_dms )
        dms = 0
	IF ( loc .GT. 0) THEN
	   CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      val, status )
           dms = 1
           IF (val .GT. 0) THEN
	      dms = val
	      IF (dms .GT. 2) GOTO 5530
	   ENDIF
	ENDIF

* ... /SPACELAB Request deg/min or deg/min/sec axis labels
	loc = qual_given( slash_plot_halfsp )
	IF ( loc .GT. 0) THEN
	   CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      val, status )
           lonlatspace = 1
           IF (val .GE. 0) lonlatspace = val
	ENDIF

* PLOT/RIBBON for multi-colored "ribbon" line
	ribbon_plot = qual_given(slash_plot_ribbon) .GT. 0

* Automatically plot dsg trajectories as if /ribbon/vs with lon, lat, and color
* If they've sent more than one variable, that's an error unless it's a non-map 
* scatter plot; use PLOT/VS or PLOT/VS/RIBBON)
 
	IF (grid_is_dsg) THEN
	   IF (ITSA_DSG_TRAJ (is_cx(1)) .OR. ITSA_DSG_POINTS (is_cx(1)) ) THEN
	      IF (num_uvars_in_cmnd .EQ. 1) THEN  
	         versus = .TRUE.
	         ribbon_plot = .TRUE.
	      ELSE
	         IF (.NOT. versus) GOTO 5700
	      ENDIF
	   ENDIF

* Did they try to limit the data by index, e.g. PLOT/I=  or PLOT/L=

	   DO i = 1, t_dim
	      IF (cx_lo_ss(cx_cmnd, i) .NE. unspecified_int4) GOTO 5800
	   ENDDO

	ENDIF

	ribbon_on = ribbon_plot  !  Flag to PPLUS in LINES.INC

* A "gaps" variable specifies the end of line segments to draw.
* Implemented only for PLOT/VS/RIBBON
	addgaps   = qual_given( slash_plot_gap       ).GT.0
	IF (addgaps .AND. .NOT.ribbon_plot) GOTO 5600

	IF ( ribbon_plot  ) THEN
	   CALL RIBBON_PLOT_SET_UP (versus, num_uvars_in_cmnd, addgaps, 
     .			            thick, overlay, spectrum, status)
	   color = thick
	ENDIF 

* ... PLOT/STEP[=CONNECTED]
	loc = qual_given( slash_plot_step )
	IF ( loc .GT. 0  .AND. .NOT.versus ) THEN
	   CALL EQUAL_STRING( cmnd_buff(qual_start(loc):qual_end(loc)),
     .                        buff, status )
           IF ( status .NE. ferr_ok ) GOTO 5000
	   IF ( buff(1:3) .EQ. 'CON' ) THEN
	      step_inc = 2	    
	   ELSEIF ( buff(1:3) .EQ. ' ' ) THEN
	      step_inc = 3
	   ELSE
	      GOTO 5220
	   ENDIF
	ENDIF	   

* ... PLOT/DASH=(dn1,up1,dn2,up2)
*     3/02 No reason we can't do PLOT/VS/DASH 

	loc = qual_given( slash_plot_dash )
	IF ( loc .GT. 0 ) THEN
	   CALL EQUAL_STR_LC( cmnd_buff(qual_start(loc):qual_end(loc)),
     .                        buff, status )
           IF ( status .NE. ferr_ok ) GOTO 5000
           do_dash = 1

           DO 100 i = 1, 4
              dashstyle(i) = 0.
 100       ENDDO

	   IF ( buff .NE. ' ' ) THEN
* Check for optional parentheses

              slen = TM_LENSTR1(buff)
              s1 = 1
              s2 = slen
              IF (buff(1:1) .EQ. '(' )THEN
                  s1 = 2
                  s2 = slen-1
                  IF ( buff(slen:slen) .NE. ')' ) GOTO 5420
              ENDIF

              nparm = 4
              CALL parse_comma_list ( buff, s1, s2, nparm, num_it,
     .             it_start, it_end, status)
              IF (status .EQ. ferr_ok .AND. it_start(1) .GT. it_end(1)) THEN
                 DO 200 i = 1, 4
                    dashstyle(i) = 0.
 200             ENDDO
              ELSE IF (status .NE. ferr_ok .OR. num_it .LT. nparm) THEN
                 GOTO 5420
              ELSE
                 DO 300 i = 1, nparm
                    READ (buff(it_start(i):it_end(i)), *) dashstyle(i)
                    IF (dashstyle(i) .LT. 0.) GOTO 5430
 300             CONTINUE
              ENDIF
           ENDIF
              
	ENDIF	   


* ... PLOT/hgrat[=dash or line, color=, JF[=] ] default is line
*     hgrat line type: 0=tics only, 1=dash 2=line

	loch = qual_given(slash_plot_hgrat)

* ... PLOT/vgrat[=dash or line, color=, JF[=] ] default is line
*     vgrat line type: 0=tics only, 1=dash 2=line

	locv = qual_given(slash_plot_vgrat)

        IF (loch .EQ. 0  .AND. locv .EQ. 0) THEN
           loch = qual_given(slash_plot_grat)
           locv = qual_given(slash_plot_grat)
        ENDIF

        CALL SET_GRATICULES(loch, locv, status)

* ... PLOT/NOKEY (default is key on)
* Note: "/KEY" refers to the legend on PLOT and to the color bar on SHADE

	nokey = qual_given(slash_plot_nokey) .GT. 0
     .     .OR. (qual_given(slash_plot_title) .GT. 0 .AND. .NOT.overlay)
	
	IF (grid_is_dsg) nokey = qual_given(slash_plot_nokey) .GT. 0

* set up the axes and title and load the data into PPLUS

	CALL PLOT_SET_UP   ( 	
     .				overlay,
     .				transpz,
     .				versus,
     .				no_labels,
     .				symbol,
     .				sym_size,
     .				color,
     .				color1,
     .				use_line,
     .				step_inc,
     .				do_dash,
     .				dashstyle,
     .				is_logh, 
     .				is_logv,
     .				nokey, 
     .				addgaps,
     .				no_range,
     .				only_val,
     .				skipsym,
     .				is_mr,
     .				is_cx,
     .				num_uvars_in_cmnd,
     .				workmem(ax1_work)%ptr,
     .				workmem(ax2_work)%ptr,
     .				status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	
	IF (need_histo) iautoc = 1

c when it's an overlay, 'No Valid Data' is part of the plot key,
c done in plot_set_up.

* is the no valid input data?
              no_data =  no_range .AND. only_val.EQ.bad_val4

* turn off axes? 
	IF ( noaxes ) THEN 
           DO 400 i = 1, 4
              iax(i) = 0
 400       ENDDO
        ENDIF

* turn on (one or more) axes? (7/11/01)

* ... PLOT/AXES=(TOP,BOTTOM,LEFT,RIGHT)
	IF ( axes ) THEN
           loc = qual_given( slash_plot_axes )
	   CALL EQUAL_STR_LC( cmnd_buff(qual_start(loc):qual_end(loc)),
     .                        buff, status )
           IF ( status .NE. ferr_ok ) GOTO 5000

	   IF ( buff .NE. ' ' ) THEN

* Get arguments, if any.  Otherwise turn on all axes
              slen = TM_LENSTR1(buff)
              s1 = 1
              s2 = slen
              IF (buff(1:1) .EQ. '(' )THEN
                  s1 = 2
                  s2 = slen-1
                  IF ( buff(slen:slen) .NE. ')' ) GOTO 5440
              ENDIF

              nparm = 4
              CALL PARSE_COMMA_LIST ( buff, s1, s2, nparm, 
     .             num_it, it_start, it_end, status)
              IF (status .EQ. ferr_ok .AND. it_start(1) .GT. it_end(1)) THEN	! /AXES=()
                 DO 500 i = 1, 4
                    iax(i) = 0
 500             ENDDO
              ELSE IF (status .NE. ferr_ok .OR. num_it .LT. nparm) THEN
                 GOTO 5440
              ELSE
                 DO 600 i = 1, nparm
                    READ (buff(it_start(i):it_end(i)), *) iax(i)
                    IF (iax(i) .LT. 0  .OR.  iax(i) .GT. 1) GOTO 5450
 600             CONTINUE
              ENDIF
           ELSE		! turn on all axes
	      DO 700 i = 1, 4
		 iax(i) = 1
 700	      CONTINUE
           ENDIF
              
	ENDIF

*  Turn off or on axes, including time axes.
        IF (axes .OR. noaxes) CALL ax_on_off (iax, overlay)

* /set_up only requested ?
	IF ( set_up ) GOTO 1000

* plot it 
	IF (ribbon_plot) THEN
	   IF ( overlay ) THEN
	      CALL PPLCMD ( ' ', ' ', 0, 'RIBBON/OVER/' //ppl_wait//' ', 1, 1 )
	   ELSE
	      CALL PPLCMD ( ' ', ' ', 0, 'RIBBON/LATCH/'//ppl_wait//' ', 1, 1 )
	   ENDIF
 
	ELSE
	
	   IF ( overlay ) THEN
	      CALL PPLCMD ( ' ', ' ', 0, 'PLOT/OVER/' //ppl_wait//' ', 1, 1 )
	   ELSE
	      CALL PPLCMD ( ' ', ' ', 0, 'PLOT/LATCH/'//ppl_wait//' ', 1, 1 )
	   ENDIF
	ENDIF

* restore axes? (5/29/97  revised 3/2002
        IF ( axes .or. noaxes ) CALL PPL_AXES_RESTORE

* restore default color key style?
        IF (changed_key ) CALL PPLCMD (from, line, 0, 'S_KEY 0', 1, 1 )

* restore dash settings? (5/29/97  revised 3/2002
        IF ( do_dash .EQ. 1 ) CALL PPL_DASH_RESTORE

* interrupt occurred during plot ?
	IF ( ppl_interrupted ) GOTO 1000

* capture the bit map ?
	IF ( qual_given( slash_plot_frame ) .GT. 0 ) THEN
	   CALL SAVE_FRAME( frame_file, "HDF", status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	ENDIF

*  Save log axis state

	IF (overlay) THEN
	   is_logh = h_logaxis
	   is_logv = v_logaxis
	ELSE
	   h_logaxis = is_logh
	   v_logaxis = is_logv 
	ENDIF
	
* Ribbon plot? protect the new colors and restore the original color spectrum
           IF ( spectrum ) THEN
              CALL PPL_SHASET( 'PROTECT' )
              CALL PPL_SHASET( 'SPECTRUM' )
           ENDIF


* release the memory used for axis buffers
! PLOT/ALONG does a hack to num_uvars_in_cmnd that can lead to a problem
! in GET_PROT_CMND_DATA if the same argument string is re-used in the next cmnd
 1000	IF (along) num_uvars_in_cmnd = 1
	IF (grid_is_dsg .AND. .NOT.versus) 
     .	  CALL RESET_DSG (num_uvars_in_cmnd, is_cx)
	CALL FREE_WS_DYNMEM( ax1_work )
	CALL FREE_WS_DYNMEM( ax2_work )
	CALL UNPROTECT_CMND_DATA			! 1/94
 5100	RETURN

* error exits
 5000	GOTO 1000
 5200	CALL ERRMSG( ferr_out_of_range, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .		'Legal range is 1 to '//LEFINT(limit,slen), *1000 )
 5210	CALL ERRMSG( ferr_out_of_range, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .		'Symbol size must be positive ', *1000 )
 5220	CALL ERRMSG( ferr_syntax, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .		'optionally /STEP=connected', *1000 )
 5400	CALL ERRMSG( ferr_out_of_range, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .		'Legal range is 1 to 3', *1000 )
 5420	CALL ERRMSG( ferr_syntax, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .	'DASH[=(dn1,up1,dn2,up2)] takes 4 arguments or no argument', *1000 )
 5430	CALL ERRMSG( ferr_out_of_range, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .		'DASH arguments must be positive', *1000 )
 5440	CALL ERRMSG( ferr_syntax, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .	'AXES[=(TOP,BOTTOM,LEFT,RIGHT)] takes 4 arguments or no argument', *1000 )
 5450	CALL ERRMSG( ferr_out_of_range, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .		'AXES arguments must be 0 or 1', *1000 )
 5460	CALL ERRMSG( ferr_out_of_range, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .		'/COLOR=WHITE only available with /THICK=1', *1000 )

 5510	CALL ERRMSG( ferr_syntax, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .	'/COLOR must have an argument for PLOT/OVERLAY', *1000 )

 5530	CALL ERRMSG( ferr_syntax, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .		'Argument to DegMinSec qualifier must be 1 or 2', *1000 )
 5600	CALL ERRMSG( ferr_syntax, status, 
     .	'PLOT/GAPLOC applies only to PLOT/VS/RIBBON', *1000 )
 5700	CALL ERRMSG( ferr_syntax, status, 
     .	'DSG trajectory map plot uses one variable. '//
     .		'Did you mean PLOT/VS or PLOT/VS/RIBBON?', *1000 )
 5800	CALL ERRMSG( ferr_syntax, status, 
     .	'Limits by subscript /'//ss_dim_name(i)//
     .	'= invalid for DSG data. Use /'//ww_dim_name(i)//
     .	'= limits or select by feature', *1000 )

	END

        SUBROUTINE LIST_CMND_DATA_XML( grid_data, mr, cx,
     .                             ax_buff, heading, head_enh, recsofar,
     .                             perm, clobber, dods_file, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* list a gridded variable stored in memory - 0 to 6 dimensions
* Note: the looping/axis labelling procedures of LIST_MULTI are cleaner and
*	more efficient than this - this could be improved easily (*sh* 7/90)

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Thermal Modeling and Analysis Program
*
* V67  *acm* 2/11 XML fixes. New attribute formatting, ![CDATA] escape, upper/lowercase handling.
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)


	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'xdset_info.cmn_text'
	include 'xtm_grid.cmn_text'		! for line_units and t0
	external xdset_info_data
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'slash.parm'
	include 'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xprog_state.cmn'
	include 'xcontext.cmn'
	include 'xtext_info.cmn'
	include 'xinterrupt.cmn'
	include 'xrisc.cmn'
	include 'calendar.decl'
	include 'calendar.cmn'

* local parameter declarations:
	INTEGER		 min_field_width, max_line_len
	PARAMETER     ( min_field_width = 4,
     .			max_line_len = 10000 )

* calling argument declarations:
	LOGICAL		heading, head_enh, clobber
	INTEGER		mr, cx, perm(nferdims), recsofar, status
	REAL grid_data(m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit,m1loe:m1hie,m1lof:m1hif),
     .       ax_buff(*)
        CHARACTER*(*) dods_file
	
* local variable declarations:
	LOGICAL		GEOG_LABEL, TM_DFPEQ, 
     .			line_too_long, del_col_changed, all_bad,
     .			valid(nferdims), need_doc(nferdims), span(nferdims), do_unform,
     .			do_stream, do_comma_del, do_tab_del, itsa_string,
     .			fortran_selfdoc, do_auto_fmt, do_dods, norow
	INTEGER		TM_LENSTR, TM_LENSTR1, CX_DIM_LEN,
     .			FIELD_WIDTH, MGRID_SIZE,
     .			GET_MAX_C_STRING_LEN, TM_GET_CALENDAR_ID,
     .			width, w0, grid, dlen, prec_digits,
     .			ndim, lo(nferdims), hi(nferdims), del(nferdims),
     .			i, j, k, l, m, n, npts, line_length, dset,
     .			temp, num_fld_est, nleft, nright, alen, num_fields,
     .			idim, vlen, istart, iend, ifield,
     .			cleft, usable_line_len, max_fields, row_ax,
     .			col_ax, places, col_dec, row_dec, row_wld, 
     .			numbers, first, slen, llen, axis, lp, cal_id,
     .                  wkblk, ndig(nferdims)
	CHARACTER*255	VAR_TITLE, VAR_TITLE_MOD, PAREN_SURROUND, vname_buff
* V500: *kob* 3/99 - up VAR_UNITS from 32 to 64 
	CHARACTER	AX_TITLE*32, VAR_UNITS*64, LEFINT*8, TM_FMT*16,
     .			GET_STRING_ELEMENT*512,
     .			line_buff*10000, entry_value*30, row_value*30,
     .                  k_value*30, l_value*30,
     .			good_data_form*10, row_ss_fmt*14, tab_or_comma*1,
     .			bad_data_form*10, col_head_format*32, cal_name*32
	REAL		BOX_SIZE, big, small, biggest, bad_data, value
	REAL*8		TM_WORLD, val8, val_last, diff_min, diff_ave, count

* convenience equivalence:
	INTEGER		lo1, lo2, lo3, lo4, lo5, lo6, 
     .			hi1, hi2, hi3, hi4, hi5, hi6, 
     .			del1, del2, del3, del4, del5, del6
     .			i1, i2, i3, i4, i5, i6
	EQUIVALENCE	(i1, pt(1)) , (i2, pt(2)) , (i3, pt(3)),  (i4,pt(4)),
     .			(i5, pt(5)),  (i6,pt(6)),
     .			(lo1, lo(1)), (lo2, lo(2)), (lo3,lo(3)),  (lo4,lo(4)),
     .			(lo5,lo(5)),  (lo6,lo(6)),
     .			(hi1, hi(1)), (hi2, hi(2)), (hi3,hi(3)),  (hi4,hi(4)),
     .			(hi5,hi(5)),  (hi6,hi(6)),
     .			(del1,del(1)),(del2,del(2)),(del3,del(3)),(del4,del(4)),
     .			(del5,del(5)),(del6,del(6))

* initialize
	status		= ferr_ok
	grid		= mr_grid( mr )
	bad_data	= mr_bad_data( mr )
	line_too_long	= .FALSE.
	del_col_changed	= .FALSE.
	width		= min_field_width
        do_unform       = list_fmt_type .EQ. plist_unformatted
        do_dods         = list_fmt_type .EQ. plist_dods
        do_stream       = list_fmt_type .EQ. plist_stream
        do_comma_del    = list_fmt_type .EQ. plist_comma_del
        do_tab_del      = list_fmt_type .EQ. plist_tab_del
        do_auto_fmt     = list_fmt_type .EQ. plist_default
	fortran_selfdoc = head_enh .AND. list_format_given
	itsa_string     = mr_type(mr) .EQ. ptype_string
        norow = qual_given(slash_list_norow) .GT. 0

* determine precision for outputting values
	lp = qual_given( slash_list_precision ) 
	IF ( lp .GT. 0 ) THEN
	   CALL EQUAL_VAL( cmnd_buff(qual_start(lp):qual_end(lp)),
     .                     value, status )
           IF ( status .NE. ferr_ok ) GOTO 5000
	   prec_digits = MAX(1.,MIN(value, 16.))	! 1 to 16	   
	ELSE
	   prec_digits = list_digits
	ENDIF

* determine maximum width of the output records
	lp = qual_given( slash_list_width )
	IF ( lp .GT. 0 ) THEN
	   CALL EQUAL_VAL( cmnd_buff(qual_start(lp):qual_end(lp)),
     .                     value, status )
           IF ( status .NE. ferr_ok ) GOTO 5000
	   i = value
	   line_length  = MIN(ABS(i),max_line_len)
	ELSE
	   line_length  = 130
	ENDIF

* determine row and column axes and how many axes are "significant"
	row_ax = perm(1)
	col_ax = perm(2)
	ndim = 0
	DO 10 ndim = nferdims, 1, -1
	   IF ( CX_DIM_LEN( perm(ndim), cx ) .GT. 1 ) GOTO 20
 10	CONTINUE
	ndim = 0
 20	DO 30 idim = 1, nferdims
	   span(idim) = CX_DIM_LEN( perm(idim), cx ) .GT. 1
	   valid(idim) = cx_lo_ss( cx, perm(idim) ) .NE. unspecified_int4
 30	CONTINUE
* * * * * * WRITE INTRODUCTORY LINES * * * * *
	IF ( do_unform .OR. do_stream .OR. do_dods .OR.
     .       .NOT.heading ) GOTO 200
* ... first the variable name
	vname_buff   = VAR_TITLE( cx )
	vlen   = TM_LENSTR1( vname_buff )
	vname_buff   = vname_buff(:vlen)//' '//
     .				PAREN_SURROUND(VAR_UNITS(cx), alen)
        slen=TM_LENSTR1(vname_buff)
	CALL SPLIT_LIST(pttmode_explct, list_lun,
     .		'<variable>'//vname_buff(:slen)
     .          //'</variable>', 0)

* ... qualify title with modification line ?
	vname_buff = VAR_TITLE_MOD( cx )
	vlen   = TM_LENSTR( vname_buff )
	IF ( vlen .GT. 0 ) CALL SPLIT_LIST( pttmode_explct, list_lun,
     .			'                        '//vname_buff(1:vlen),
     .				      vlen+24)

* ... then DATA SET
	dset = cx_data_set(cx)
	IF ( dset .NE. pdset_irrelevant .AND.        ! for REPEAT/RANGE vars, add 
     .       dset .NE. unspecified_int4) THEN        ! check for unspecified_int4
* ... title
	   CALL GET_DSET_TITLE( cx_data_set(cx), line_buff, slen )
	   IF (line_buff .NE. ' ') THEN
             slen=TM_LENSTR1(line_buff)
	     CALL SPLIT_LIST(pttmode_explct, list_lun,
     .		  '<dataset>'//line_buff(:slen)//'</dataset>',0)
	   ENDIF
* ... find split point between filename and path
	   slen = TM_LENSTR1(ds_des_name(dset))
	   DO i = slen, 1, -1
	      IF ( ds_des_name(dset)(i:i) .EQ. '/' ) GOTO 34
	   ENDDO
	   i = 0
* ... filename
 34	   CALL SPLIT_LIST(pttmode_explct, list_lun,
     .	        '<filename>'//
     .		ds_des_name(dset)(i+1:slen)//'</filename>', 0)
* ... DODS URL BASE or ABSOLUTE PATH
* *kob* v553 - CYGWIN paths are always preceded by '.'
#ifdef __CYGWIN__
	   IF (i.GT.0 .AND.  ds_des_name(dset)(2:2).EQ.'\')
#else
	   IF (i.GT.0 .AND.  ds_des_name(dset)(1:1).NE.'.')
#endif
     .			CALL SPLIT_LIST(pttmode_explct, list_lun,
     .			'<filepath>'//
     .			ds_des_name(dset)(:i)//'</filepath>',0)
	ENDIF

* ... BAD FLAG: xxx
	IF (.NOT.fortran_selfdoc) THEN
	   IF (.NOT.do_auto_fmt) THEN
	     line_buff = ' '
	     WRITE ( line_buff, '(1PG14.7)' ) cx_bad_data(cx)
             slen=TM_LENSTR1(line_buff)
	     CALL SPLIT_LIST( pttmode_explct, list_lun,
     .			'<badflag>'//
     .		        line_buff(:slen)//'</badflag>', 0)
	   ENDIF
* ... SUBSET:   e.g. "Nx by Ny (longitude-latitude)"
	   line_buff = '<subset>'
	   l = 8
	   DO idim = 1, nferdims
	      IF ( span(idim) ) THEN
	         i = perm(idim)
	         j = CX_DIM_LEN ( i, cx )
	         line_buff = line_buff(:l)//LEFINT( j, vlen )
	         l = l + vlen
	         line_buff = line_buff(:l)//' by '
	         l = l + 4
	      ENDIF
	   ENDDO
	   IF ( l.GT.8) THEN
	      line_buff(l-3:l+7) = ' points (  '
	      l = l + 5
	      DO idim = 1, nferdims
	         IF ( span(idim) ) THEN
	            line_buff = line_buff(:l)//
     .				AX_TITLE(perm(idim), cx_grid(cx), vlen)
	            l = l + vlen
	            line_buff = line_buff(:l)//'-'
	            l = l + 1
	         ENDIF
	      ENDDO
	      line_buff(l:l) = ')'
	      CALL SPLIT_LIST(pttmode_explct, list_lun,
     .			      line_buff(:l)//'</subset>', 0)
	   ENDIF
	ENDIF

* ... which axes require labels
	DO 35 idim = 1, nferdims
 35	need_doc(idim) = .TRUE.
	IF ( .NOT.(do_unform.OR.do_dods.OR.list_format_given) ) THEN
	   DO 36 idim = 1, ndim
 36	   need_doc(idim) = CX_DIM_LEN( perm(idim), cx ) .EQ. 1
	ENDIF

* ... if not indicated in time label show a nonstandard calendar name
	cal_name = line_cal_name( grid_line(t_dim, grid) )
	cal_id = TM_GET_CALENDAR_ID (cal_name)
	DO i = 1, nferdims
	   idim = perm(i)
	   IF ( .NOT.need_doc(i) .AND. idim.EQ.t_dim .AND.
     .	     cal_id .LE. max_calendars) THEN
	      slen = TM_LENSTR(cal_name)
	      CALL SPLIT_LIST( pttmode_explct, list_lun,
     .                  '             CALENDAR : '
     .			//cal_name(:slen), slen+24)
	   ENDIF
	ENDDO

* ... region information
	DO 60 i = 1, nferdims
	   idim = perm(i)
	   IF ( need_doc(i) ) THEN
	      IF ( cx_lo_ww( idim,cx ) .NE. unspecified_val8 ) THEN 
	         CALL ASCII_LIMITS( cx, idim, line_buff, vlen )
	         col_head_format = AX_TITLE( idim, grid, alen )
	         IF (alen .LT. 9) alen = 9

                 CALL SPLIT_LIST( pttmode_explct, list_lun,
     .                 '<'//col_head_format( :alen )//'>'
     .                 //line_buff(1:vlen)//
     .                 '</'//col_head_format( :alen)//'>', 0)

	      ENDIF
	   ENDIF
 60	CONTINUE

* * * * * DETERMINE LIST LIMITS * * *
 200	DO 210 i = 1, nferdims
	   idim = perm(i)
	   lo(i) = cx_lo_ss( cx, idim )
	   hi(i) = cx_hi_ss( cx, idim )
	   del(i)= 1
 210	CONTINUE



* * * * *  ENHANCED HEADING STUFF (10/94) * * * * *
	IF ( fortran_selfdoc ) THEN
* ... GEOMETRY: xxx
	   line_buff = ' '
	   i = 1	   
	   DO 220 idim = 1, nferdims
	      IF ( span(idim) ) THEN
	         line_buff(i:i) = ww_dim_name(perm(idim))
	         i = i + 1
	      ENDIF
 220	   CONTINUE
	   CALL SPLIT_LIST(pttmode_explct, list_lun,
     .				'             GEOMETRY: '//
     .			 	line_buff(:i), i+23)

* ... SIZE: xxx
	   line_buff = ' '
	   l = 1
	   DO 230 idim = 1, nferdims
	      IF ( span(idim) ) THEN
	         i = perm(idim)
	         j = CX_DIM_LEN ( i, cx )
	         line_buff = line_buff(:l)//LEFINT( j, vlen )
	         l = l + vlen + 2
	      ENDIF
 230	   CONTINUE
	   CALL SPLIT_LIST(pttmode_explct, list_lun,
     .				'             SIZE: '//
     .			 	line_buff(:l), l+19)

* ... FORTRAN FORMAT: xxx
	   IF ( list_format .EQ. '(5(1PG12.5))' ) THEN
	      CALL SPLIT_LIST(pttmode_explct, list_lun,
     .		'             FORTRAN FORMAT: (5F12.5)', 37 )
	   ELSE
	      CALL SPLIT_LIST(pttmode_explct, list_lun,
     .		'             FORTRAN FORMAT: '//list_format, 0)
	   ENDIF

* ... MISSING VALUE FLAG: xxx
	   line_buff = ' '
	   WRITE ( line_buff, 3062 ) cx_bad_data(cx)
 3062	   FORMAT( 13x,'MISSING VALUES FLAG: ',1PG14.7)
	   CALL SPLIT_LIST( pttmode_explct, list_lun, line_buff, 0 )

* ... axis COORDINATES:
	   DO 250 idim = 1, nferdims
	      IF ( span(idim) ) THEN
	         line_buff = ' '
	         i = perm(idim)
	         axis = grid_line(i, cx_grid(cx) )
	         WRITE ( line_buff, 3065 ) ww_dim_name(i)
 3065	         FORMAT(A1,' COORDINATES: ')
	         line_buff(16:) = line_units(axis)
	         alen = TM_LENSTR1( line_buff )
	  	 IF (  i .EQ. t_dim ) THEN		! add T0=
	            IF ( GEOG_LABEL(i,cx_grid(cx)) ) THEN 
	               line_buff(alen+2:) =  '(T0='//line_t0(axis)
                       IF (line_shift_origin(axis)) 
     .                  line_buff(alen+2:) =  '(T0=01-JAN-0001 00:00:00'
	               alen = TM_LENSTR1( line_buff )
	               line_buff(alen+1:) =  ')'
	               alen = alen + 1
	            ENDIF
	         ENDIF
	         CALL SPLIT_LIST(pttmode_explct,list_lun,line_buff,alen)
	         npts =  hi(idim)-lo(idim)+1
                 CALL MAKE_AXIS(cx_grid(cx),i,lo(idim),hi(idim),ax_buff)
! Note: FORMATTED output cannot be passed through SPLIT_AXIS because a
!	single WRITE may imply many records of output
	         WRITE ( list_lun, list_format ) (ax_buff(j),j=1,npts)
	      ENDIF
 250	   CONTINUE
* ... DATA:
	     CALL SPLIT_LIST(pttmode_explct, list_lun, 'DATA:', 5 )
	ENDIF

* * * * * LIST DATA UNFORMATTED OR WITH USER FORMAT (no frills)


	IF ( do_dods) THEN
           CALL WRITE_DODS_FMT (grid_data, 
     .           m1lox,m1hix, m1loy,m1hiy, m1loz,m1hiz, m1lot,m1hit, 
     .           m1loe,m1hie, m1lof,m1hif, ax_buff, dods_file, clobber, status)

* done - 
	   RETURN
        ENDIF

	IF ( do_unform
     .	.OR. do_stream
     .	.OR. list_format_given ) THEN

	   DO 300 n = lo6, hi6, del6
	   DO 300 m = lo5, hi5, del5
	   DO 300 l = lo4, hi4, del4
	   DO 300 k = lo3, hi3, del3
	   DO 300 j = lo2, hi2, del2
	      IF ( interrupted ) RETURN
! ----- start string handler -------------
	      IF (itsa_string) THEN
	         llen = 0
	         DO 270 i = lo1, hi1, del1
	            line_buff(llen+1:) = GET_STRING_ELEMENT(
     .			m1lox,m1hix,m1loy,m1hiy,m1loz,m1hiz,m1lot,m1hit,m1loe,m1hie,
     .			m1lof,m1hif,grid_data,i,j,k,l,m,n,max_line_len,slen )
	            llen = MIN(max_line_len-1, llen+slen)
	            IF (do_stream) THEN
	               llen = llen + 1
	               line_buff(llen:llen) = CHAR(0) ! NULL terminator
	            ENDIF
 270		 CONTINUE
	         IF ( do_unform ) THEN
	            WRITE (list_lun, ERR=5010) line_buff(:llen)
	         ELSEIF ( do_stream ) THEN
	            recsofar = recsofar + 1
	            WRITE (list_lun, REC=recsofar, ERR=5010)
     .						 line_buff(:llen)
	         ELSE
! Note: FORMATTED output cannot be passed through SPLIT_AXIS because a
!	single WRITE may imply many records of output
	            DO 272 i = lo1, hi1, del1
	               line_buff = GET_STRING_ELEMENT(
     .			m1lox,m1hix,m1loy,m1hiy,m1loz,m1hiz,m1lot,m1hit,,m1loe,m1hie,
     .			m1lof,m1hif,grid_data,i,j,k,l,m,n,max_line_len,slen )
	               WRITE (list_lun,list_format, ERR=5010)
     .							line_buff(:slen)
 272		    CONTINUE
	         ENDIF
	         GOTO 300
	      ENDIF
! ----- end string handler -------------
	      IF ( do_unform ) THEN
	         WRITE (list_lun, ERR=5010)
     .			( grid_data(i,j,k,l,m,n),i = lo1, hi1, del1 )

	      ELSEIF ( do_stream ) THEN				! 12/94
	         DO 298 i = lo1, hi1, del1
	            recsofar = recsofar + 1
	            WRITE (list_lun, REC=recsofar, ERR=5010)
     .						grid_data(i,j,k,l,m,n)
 298		 CONTINUE
	      ELSE
! Note: FORMATTED output cannot be passed through SPLIT_AXIS because a
!	single WRITE may imply many records of output
#ifdef DEC_FORTRAN
* on DEC compilers a field too small for the value generates an ERR= branch
	         WRITE (list_lun,list_format, IOSTAT=ios)
     .			( grid_data(i,j,k,l,m,n),i = lo1, hi1, del1 )
	         IF ( ios.NE.0 .AND. ios.NE.63 ) GOTO 5010  ! 63 = fmt conv err
#else
	         WRITE (list_lun,list_format, ERR=5010)
     .			( grid_data(i,j,k,l,m,n),i = lo1, hi1, del1 )
#endif
	      ENDIF
 300	   CONTINUE

* done - go home
	   RETURN

* 9/95 - COMMA OR TAB DELIMITED OUTPUT ... some frills  but not too many
* (note that indent levels aren't changed for k and l loops)
	ELSEIF ( do_comma_del .OR. do_tab_del ) THEN
* ... column headings for tab and comma-delimited output (9/95)
	   IF ( do_comma_del ) THEN
	      tab_or_comma = ','
	   ELSEIF( do_tab_del ) THEN
	      tab_or_comma = CHAR(9)
	   ENDIF
	   line_buff(1:line_length) = 'coordinates'//tab_or_comma
	   alen = 12

* Get number of decimal places for formatting the row coordinates

           ndig(row_ax)= ax_dec_pt(row_ax)
           CALL NDIG_COORDS (grid, row_ax, lo1, hi1, del1, 
     .        bad_data, ndig(row_ax), ax_dec_pt(row_ax) )

* Get number of decimal places for formatting the column coordinates

           ndig(col_ax) = ax_dec_pt(col_ax)
           CALL NDIG_COORDS (grid, col_ax, lo2, hi2, del2, 
     .        bad_data, ndig(col_ax), ax_dec_pt(col_ax) )

* Get number of decimal places for formatting coordinate labels

           ndig(perm(3)) = ax_dec_pt(perm(3))
	   IF ( ndim .GE. 3 .AND. valid(3) .AND. 
     .          ax_dec_pt(perm(3)) .GE. 0 ) 
     .        CALL NDIG_COORDS (grid, perm(3), lo3, hi3, del3, 
     .           bad_data, ndig(perm(3)), ax_dec_pt(perm(3)) )

           ndig(perm(4)) = ax_dec_pt(perm(4))
	   IF ( ndim .GE. 4 .AND. valid(4) ) 
     .        CALL NDIG_COORDS (grid, perm(4), lo4, hi4, del4, 
     .           bad_data, ndig(perm(4)), ax_dec_pt(perm(4)) )

           ndig(perm(5)) = ax_dec_pt(perm(5))
	   IF ( ndim .GE. 5 .AND. valid(5) ) 
     .        CALL NDIG_COORDS (grid, perm(5), lo5, hi5, del5, 
     .           bad_data, ndig(perm(5)), ax_dec_pt(perm(5)) )

           ndig(perm(6)) = ax_dec_pt(perm(6))
	   IF ( ndim .GE. 6 .AND. valid(6) ) 
     .        CALL NDIG_COORDS (grid, perm(6), lo6, hi6, del6, 
     .           bad_data, ndig(perm(6)), ax_dec_pt(perm(6)) )

* Write coordinates

	   DO 330 i = lo1, hi1, del1
	      val8 = TM_WORLD( i, grid, row_ax, box_middle )
	      width = FIELD_WIDTH(val8, grid, row_ax, ndig(row_ax),
     .					numbers)
	      alen = alen + width
	      IF ( alen .GT. max_line_len ) THEN
	         line_buff(max_line_len-18:max_line_len) = 
     .			'** line too long **'
	         alen = max_line_len
	         GOTO 331
	      ENDIF
	      CALL TRANSLATE_TO_WORLD
     .		      ( val8,
     .			row_ax,
     .			grid,
     .			ndig(row_ax),
     .			line_buff(alen-(width-1):alen) )
	      IF ( i .LT. hi1 ) THEN
	         alen = alen + 1
	         line_buff(alen:alen) = tab_or_comma
	      ENDIF
 330	   CONTINUE
 331	   CALL SPLIT_LIST(pttmode_explct, list_lun,
     .				line_buff(:alen), alen )
	   DO 350 n = lo6, hi6, del6
* ... label the block of blocks (6th dimension)
	      IF ( ndim .GE. 6 .AND. valid(6) ) THEN
	         CALL POS_LAB( l, cx, perm(6),
     .			    ndig(perm(6)), line_buff, alen )
	         CALL SPLIT_LIST(pttmode_explct, list_lun,
     .			' ---- '//line_buff(:alen), 6+alen )
	      ENDIF
	   DO 350 l = lo5, hi5, del5
* ... label the block of blocks (5th dimension)
	      IF ( ndim .GE. 5 .AND. valid(5) ) THEN
	         CALL POS_LAB( l, cx, perm(5),
     .			    ndig(perm(5)), line_buff, alen )
	         CALL SPLIT_LIST(pttmode_explct, list_lun,
     .			' ---- '//line_buff(:alen), 6+alen )
	      ENDIF
	   DO 350 l = lo4, hi4, del4
* ... label the block of blocks (4th dimension)
	      IF ( ndim .GE. 4 .AND. valid(4) ) THEN
	         CALL POS_LAB( l, cx, perm(4),
     .			    ndig(perm(4)), line_buff, alen )
	         CALL SPLIT_LIST(pttmode_explct, list_lun,
     .			' ---- '//line_buff(:alen), 6+alen )
	      ENDIF
	   DO 350 k = lo3, hi3, del3
* ... label a single block (3rd dimension)
	      IF ( ndim .GE. 3 .AND. valid(3) ) THEN
	         CALL POS_LAB( k, cx, perm(3),
     .			       ndig(perm(3)), line_buff, alen )
	         CALL SPLIT_LIST(pttmode_explct, list_lun,
     .			' ---- '//line_buff(:alen), 6+alen )
	      ENDIF
	   DO 350 j = lo2, hi2, del2
	      IF ( interrupted ) RETURN
* ...  create label for this row
	         IF ( ndim .GE. 2 .AND. valid(2) ) THEN
	            CALL TRANSLATE_TO_WORLD
     .		      ( TM_WORLD( j, grid, col_ax, box_middle ),
     .			col_ax, grid, ndig(col_ax), line_buff(:16) )
	            alen = TM_LENSTR1(line_buff(:16))
	         ELSE	! 1D row-only (will this ever happen?)
	            line_buff(1:5) = 'row 1'	
	            alen = 5
	         ENDIF
* ...  and append the values for this row
	         DO 340 i = lo1, hi1, del1
	            IF ( itsa_string ) THEN
	               line_buff = line_buff(:alen)//tab_or_COMMA//
     .			GET_STRING_ELEMENT(
     .			m1lox,m1hix,m1loy,m1hiy,m1loz,m1hiz,m1lot,m1hit,m1loe,m1hie,
     .			m1lof,m1hif,grid_data,i,j,k,l,m,n,max_line_len,vlen )
	            ELSE
	               line_buff = line_buff(:alen)//tab_or_COMMA//
     .			TM_FMT(grid_data(i,j,k,l,m,n),prec_digits,16,vlen)
	            ENDIF
	            alen = alen+vlen+1
	            IF ( alen .GT. max_line_len ) THEN
	               line_buff(max_line_len-18:max_line_len) = 
     .			'** line too long **'
	               alen = max_line_len
	               GOTO 341
	            ENDIF
 340	         CONTINUE
 341	         CALL SPLIT_LIST(pttmode_explct, list_lun,
     .				line_buff(:alen), alen )
 350	   CONTINUE
* done - go home
	   RETURN
	ENDIF

* * * * PREPARE FORMATS ADAPTED TO THE DATA AND AXIS RANGES
* ... row labelling
	IF ( ndim .GE. 2 .AND. valid(2) ) THEN
	   CALL ROW_COORD_FMT( col_ax, cx, lo2, hi2, del2,
     .			       row_ss_fmt, col_dec, row_wld, cleft )
	ELSE
	   cleft = 7
	   line_buff(:cleft) = ' '		! just 1 value to write
	ENDIF
        IF (norow) cleft = 0

	usable_line_len = line_length - cleft
	max_fields = usable_line_len / min_field_width
* ... column labelling - how many decimal places for coordinate label ?
	IF ( ndim .GE. 1 .AND. valid(1) ) THEN
	   small = +1.E33
	   DO 404 i = lo1, hi1, del1
	      small = MIN( small, BOX_SIZE( i, grid, row_ax ) )
 404	   CONTINUE	      
	   CALL GET_PREC_DIGITS( cx_lo_ww(row_ax,cx),
     .				 cx_hi_ww(row_ax,cx),
     .				 small, places, row_dec )
	   row_dec = row_dec + 1		! add 1 more, arbitrarily
	ENDIF

* ... determine numeric format to fit nicely on the line
* ... first find largest value to be printed
! bug here since the mem res data limits may not match the cx limits 8/00 *sh*
	IF ( itsa_string ) THEN
	   nleft = GET_MAX_C_STRING_LEN(mr_c_pointer(mr), MGRID_SIZE(mr))
	   all_bad = .FALSE.
	ELSE
	   CALL MINMAX(grid_data, MGRID_SIZE(mr), bad_data, small, big)
	   all_bad = small .EQ. arbitrary_large_val4

* . . . how many digits right and left of decimal point ?
 	   biggest = MAX( ABS( small ), big )
	   CALL GET_SIG_DIGITS( biggest, prec_digits, nleft, nright )
	   nleft = MAX( 1, nleft )			! at least "0" to left
	ENDIF

* . . . unreasonable line length ?
 410	IF ( ndim .EQ. 0 ) THEN
	   num_fields = 1
	ELSE
	   num_fields = ABS( (hi1-lo1) / del1  + 1 )
	   IF ( num_fields .GT. max_fields ) line_too_long = .TRUE.
* . . . shorten the line to something that will fit
	   IF ( line_too_long ) THEN
	      num_fld_est	= usable_line_len / width
	      temp		= ABS(hi1-lo1) / num_fld_est + 1.
	      del1		= SIGN( temp, del1 )		! for del1<0
	      num_fields 	= ABS( (hi1-lo1) / del1 + 1 )
	      del_col_changed	= .TRUE.
	   ENDIF
	ENDIF

* . . . determine FORTRAN format for listing
	IF ( all_bad ) THEN
	   width = min_field_width
	   WRITE ( bad_data_form, 3002 ) min_field_width
 3002	FORMAT ( '(A',I2,')' )	
	ELSE
	   IF ( itsa_string ) THEN
	      width = nleft + 2
	   ELSE
	      CALL VAR_DATA_FMT( nleft, nright, prec_digits, min_field_width,
     .			      width, good_data_form, bad_data_form )
	   ENDIF
	ENDIF

* . . . will it fit ? - if not go back and try again with a shorter line
	dlen = cleft + width*num_fields
* . . . *kob* 9/03 - we do not want to set line_to_long to true for strings -
*                    results in a hang because dlen doesn't get changed or 
*                    shortened and so this will always be true for long strings
*		     and we will be sent back to 410 ad naseum
	IF ( dlen .GT. line_length .AND. .NOT. itsa_string ) THEN
	   line_too_long = .TRUE.
	   GOTO 410
	ENDIF
	
* . . . notify operator if were skipping some data
	IF ( del_col_changed ) THEN
	   WRITE ( line_buff, 3005 ) del1
 3005	FORMAT ( 5X,' ... listing every',I4,'th point' )
	   CALL SPLIT_LIST(pttmode_explct, list_lun, line_buff, 35 )
	ENDIF

* . . . write a heading line of coordinate values and subscripts ?
	IF ( heading .AND. ndim.GE.1 .AND. valid(1) ) THEN
	   line_buff(1:line_length) = ' '
	   w0 = cleft + 2	! 2 col arbitrary shift to align
	   DO 420 i = lo1, hi1, del1
	      val8 = TM_WORLD( i, grid, row_ax, box_middle )
	      first = FIELD_WIDTH(val8, grid, row_ax, row_dec, numbers)
	      first = 1 + MAX( 0, (width-first)/2 )	! centered
	      CALL TRANSLATE_TO_WORLD
     .		      ( val8,
     .			row_ax,
     .			grid,
     .			row_dec,
     .			line_buff(w0+first:w0+width) )
	      w0 = w0 + width
 420	   CONTINUE
	   CALL SPLIT_LIST(pttmode_explct, list_lun,
     .				' '//line_buff(:w0), w0+1 )

* . . .  then subscript values ...
	   WRITE ( col_head_format, 3020 ) cleft+1-(width-3)/2,
     .					      num_fields,  width
	   WRITE ( line_buff, col_head_format ) ( i,i = lo1,hi1,del1 ) 
 3020	   FORMAT ( '(',I2,'X,',I5,'I',I2,')' )	! eg. "( 8X, 10I 6)"
	   CALL SPLIT_LIST(pttmode_explct, list_lun, line_buff, 0 )
	ENDIF

* . . . list column of latitudes backwards (north to south)
	IF ( col_ax.EQ.Y_dim .AND. GEOG_LABEL(y_dim,grid) ) THEN
	   del2 = -1
	   temp = lo2
	   lo2  = hi2
	   hi2  = temp
	ENDIF

* * * * *  WRITE FORMATTED DATA LINES * * * * *
* each line has format: "coord/sub: data1 data2 data3 ..."
* for a 2D field a single block of such lines is printed
* for a 3D field each block is separated by an identifier of the 3rd axis
* for a 4D field each block of blocks is further separated and identified

	DO 550 n = lo6, hi6, del6

* label the block of blocks (4th dimension)
	   IF ( ndim .GE. 6 .AND. valid(6) ) THEN
	      CALL POS_LAB( l, cx, perm(6),
     .			    ax_dec_pt(perm(6)), line_buff, alen )
	      CALL SPLIT_LIST(pttmode_explct, list_lun,
     .             '  <6D value=\''//line_buff(:alen)//'\'>', 0)
	   ENDIF

	DO 540 m = lo5, hi5, del5     

* label the block of blocks (5th dimension)
	   IF ( ndim .GE. 5 .AND. valid(5) ) THEN
	      CALL POS_LAB( l, cx, perm(5),
     .			    ax_dec_pt(perm(5)), line_buff, alen )
	      CALL SPLIT_LIST(pttmode_explct, list_lun,
     .             '  <5D value=\''//line_buff(:alen)//'\'>', 0)
	   ENDIF

	DO 530 l = lo4, hi4, del4

           CALL SPLIT_LIST(pttmode_explct, list_lun,
     .            '<tgroup>',0)                 


* label the block of blocks (4th dimension)
	   IF ( ndim .GE. 4 .AND. valid(4) ) THEN
	      CALL POS_LAB( l, cx, perm(4),
     .			    ax_dec_pt(perm(4)), line_buff, alen )
	      CALL SPLIT_LIST(pttmode_explct, list_lun,
     .             '  <4D value=\''//line_buff(:alen)//'\'>', 0)
	   ENDIF

	   DO 520 k = lo3, hi3, del3

*    label a single block (3rd dimension)
	      IF ( ndim .GE. 3 .AND. valid(3) ) THEN
                 CALL TRANSLATE_TO_WORLD
     .                ( TM_WORLD( k, grid, perm(3), box_middle ),
     .                  perm(3), grid, ax_dec_pt(perm(3)), k_value )
                    slen= TM_LENSTR1(k_value)

	         CALL SPLIT_LIST(pttmode_explct, list_lun,
     .            '    <3D value=\''//k_value(:slen)//'\'>',0)                 
	      ENDIF

	      DO 510 j = lo2, hi2, del2
*       create carefully sized label for this row
	         IF ( ndim .GE. 2 .AND. valid(2) .AND. 
     .               (.NOT.norow) ) THEN

	            CALL TRANSLATE_TO_WORLD
     .		      ( TM_WORLD( j, grid, col_ax, box_middle ),
     .                  col_ax, grid, col_dec, row_value )
                    slen= TM_LENSTR1(row_value)
                    CALL SPLIT_LIST(pttmode_explct, list_lun,
     .                  '       <row value=\''//row_value(:slen)
     .                  //'\'>', 0)

	         ENDIF
	         ifield = 0

	         DO 500 i = lo1, hi1, del1
* put values into the output line buffer
	         ifield = ifield + 1
	         iend   = cleft + ifield*width
	         istart = iend - width + 1
	         IF (itsa_string) THEN
	           line_buff(istart:istart) = '"'
	           line_buff(istart+1:iend) = GET_STRING_ELEMENT(
     .			m1lox,m1hix,m1loy,m1hiy,m1loz,m1hiz,m1lot,m1hit,
     .			m1loe,m1hie,m1lof,m1hif,grid_data,i,j,k,l,m,n,width-2,slen)
	           IF (slen .GT. width-2) THEN
	              line_buff(iend-3:iend) = '..."'
	           ELSE
	              line_buff(istart+slen+1:istart+slen+1) = '"'
	           ENDIF
	         ELSE
	           value = grid_data(i,j,k,l,m,n)
	           IF ( value .NE. bad_data ) THEN
	              WRITE ( entry_value, good_data_form ) value
	           ELSE
	              WRITE ( entry_value,  bad_data_form ) '....'
	           ENDIF
	         ENDIF
                 slen=TM_LENSTR1(entry_value)
                 CALL SPLIT_LIST(pttmode_explct, list_lun,
     .           '         <entry>'//entry_value(3:slen)//'</entry>', 0)

 500	         CONTINUE

	         IF ( interrupted ) RETURN
                 IF ( ndim .GE. 2 .AND. valid(2) .AND.
     .               (.NOT.norow) ) THEN

                     CALL SPLIT_LIST(pttmode_explct, list_lun,
     .                '       </row>', 0)
                 ENDIF

 510	      CONTINUE
              IF ( ndim .GE. 3 .AND. valid(3) ) THEN
                  CALL SPLIT_LIST(pttmode_explct, list_lun,
     .             '    </3D>', 0)
              ENDIF

 520	   CONTINUE
           IF ( ndim .GE. 4 .AND. valid(4) ) THEN
               CALL SPLIT_LIST(pttmode_explct, list_lun,
     .             '  </4D>', 0)
           ENDIF

           CALL SPLIT_LIST(pttmode_explct, list_lun,
     .            '</tgroup>',0)                 

 530	CONTINUE
 
           IF ( ndim .GE. 5 .AND. valid(5) ) THEN
               CALL SPLIT_LIST(pttmode_explct, list_lun,
     .             '  </5D>', 0)
           ENDIF

 540	CONTINUE
 
           IF ( ndim .GE. 6 .AND. valid(6) ) THEN
               CALL SPLIT_LIST(pttmode_explct, list_lun,
     .             '  </6D>', 0)
           ENDIF               

 550	CONTINUE

* successful completion
	RETURN

* error exits
 5000	RETURN
 5010	CALL ERRMSG( ferr_erreq, status, list_format, *5000 )
	END

      SUBROUTINE TAYIS4(TLO,ITIME1,ITIME2,DT,NSMTIC,LABEL,IHDB,IDDB,
     .    TFACT,X,XFACT,CSIZE,xacross,hgrat,hcolor,hline,color0,
     .    is_hours_axis)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* 
* From tayis0: separate routine for hour:min labeling on time axes
C V7.1 *acm* 8/2016 Ticket 2466: Graticule lines too dense
* *acm* - 8/16   ticket 1787: restore pen 0 correctly after graticule
* *acm* - 9/16   ticket 2466: graticule lines on major tics by default
*                Rewrite this routine to make it echo taxis4.F
* *acm* - 1/17   Fix too-many labels on tic marks. Add year to Month-Day labels
* *acm* - 3/18   Issue #1856 Additions for high-res time axes; e.g. plot a minute of data
* V74  *acm* -11/18 Issue #1900 Fixes for tic marks and PLOT/OVERLAY with short-interval time
* V745 *acm* 3/19 Draw tic marks on top of any graticule lines so 
*                 dashes or color are covered up by the tic mark
C
C**
C**    @(#)tayis4.f	1.1   12/09/15
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C     THIS ROUTINE PLOTS A TIME AXIS AND LABELS IT WITH THE HOUR, MINUTE.
C     VARIBLES:
C         TLO=X VALUE CORRESPONDING TO THE START TIME.
C         ITIME1 = START TIME (IE.  7708190100)
C                  WE RESTRICT THE PERMISSIBLE START TIMES TO BE
C                  EVEN HOURS.  (THAT IS THE LAST 4 DIGITS OF ITIME1
C                  MUST BE 0)
C         ITIME2 = END TIME (IE   7709072300)
C                  THIS IS THE FIRST HOUR NOT TO BE PLOTTED, AND IT
C                  MUST BE AN EVEN HOUR.
C         DT = SAMPLING RATE IN MINUTES.
C         NSMTIC = NUMBER OF SMALL TICS TO MAKE EACH HOUR.
C         LABEL > 0 IF LABELS ARE TO BE DRAWN ABOVE THE AXIS.
C               = 0 IF NO LABELS ARE TO BE DRAWN.
C               < 0 IF LABEL ARE TO BE DRAWN BELOW THE AXIS.
C         IABS(LABEL) = 1 FOR LABELS OF THE STYLE
C                  1..........1..........1..........1..........1
C                       3           4          5        6
C                                    JUN 7
C         IHDB = PRINT LABELS OF HOURS DIVIBLE BY THIS NUMBER ONLY.
C                IF(IHDB = 0) PRINT NO DAY LABELS.
C         IDDB = PRINT LABELS OF DAYS DIVISIBLE BY THIS NUMBER ONLY.
C                IF(IDDB = 0) PRINT NO MONTH LABELS.
C                THIS VARIBLE ONLY APPLYS WHEN IABS(LABEL) = 1
C         TFACT = (LENGTH OF T AXIS IN INCHES)/(LENGTH OF T AXIS IN USER
C         X = X COORDINATE OF TIME AXIS. 
C         XFACT = (LENGTH OF X AXIS IN INCHES)/(LENGTH OF X AXIS IN USER 
C         CSIZE = SIZE TO DRAW HOUR LABELS.
C                 DAY LABELS WILL BE 1.5 TIMES AS LARGE.
C
C
C     The original routine was first written by David Mandel in July 1980.
C
	CHARACTER ITIME3*14,DATE*6,BUFF*14,YEAR*4
	CHARACTER ITIME*14,ITIME1*14,ITIME2*14,SYM*21
	COMMON/TICS/TSMX,TLX,TSMY,TLY,IX,IY
	COMMON/AXLWID/XWID,YWID

	REAL*8  DIFF, difft
	REAL*8  td, xtemp1, tfact_d, xfact_d
	REAL    delt, rem, angl, t_max
	INTEGER is_hours_axis, labint, ticint, hrint, i_ticint
	LOGICAL hvytic, labsecs, datelabel

* Parameters for drawing tics across plot

        REAL xacross
        REAL dash1_1, dash1_2, dash1_3, dash1_4
        REAL dash2_1, dash2_2, dash2_3, dash2_4
        REAL hgrat(4,2)        ! line type: 0=tics only, <0=line, >0=dash lengths 
        INTEGER hcolor(*)      ! pen number for graticule lines
	INTEGER hcolor0	       ! pen number to restore
        LOGICAL hline, do_line ! If true, do the lines across.
        LOGICAL solid1, solid2   ! solid lines across at tics
        LOGICAL dashed1, dashed2 ! dashed lines across at tics
        INTEGER ltic, color1, color2
	LOGICAL heavy_at_labels  ! When lots of tic marks, make heavy 
				 !tic/graticule at the location of labels.

* TMAP interrupt flag
	include 'xinterrupt.cmn'
        include 'century.cmn'  ! with MONYRLAB flag
	
  80	FORMAT(I2.2)
  82	FORMAT(I2.2,':00')
  84	FORMAT(I2.2,':',I2.2)
  86    FORMAT(I2.2,':',I2.2,':',I2.2)

	difft = DIFF(ITIME1,ITIME2)
	angl = 0.

C     CHECK THE PARAMETERS PASSED TO THE SUBROUTINE.

        IF(ITIME1(13:14)//ITIME1(1:12).GE.
     .	   ITIME2(13:14)//ITIME2(1:12)) STOP',3'

C     SET PARAMETERS.
        TIC = 60./DT  
        TICd = 60./DT  
        NTIC = NSMTIC + 1
        delt = 1.  ! This is in minutes
        labint = 120
	ticint = labint
	hrint = 1

	labsecs = .FALSE.
	datelabel = .FALSE.
	
	t_max = TLO + DIFF(ITIME1, ITIME2)/dt
      
! On short-time interval axes, tic and label interval
! for hours axis (is_hours_axis eq 1) if difft > 60,
! then labint, ticint should be on the hour or half hour, so
! multiples of 30.
! for more than 8 hours, label on a multiple of even hours, 
! for more than 12 hours, label on a multiple of 4 hours, 
! up to a max of 36 hours labeled hh:mm (set in taxis_style)

	IF (is_hours_axis.EQ.1) THEN
           labint = 30
           delt = 1.
	   ticint = 5
           IF (difft .GE.  300) labint = 60
           IF (difft .GE.  600) labint = 120
	   IF (difft .GE.  300) ticint = 30
           IF (difft .GE.  800) hrint = 2
           IF (difft .GE. 1200) hrint = 4
        ENDIF
        IF (is_hours_axis.EQ.2) THEN
           labint = 10
           delt = 1
	   ticint = 1
           IF (difft .LE. 30) labint = 5
           IF (difft .LE. 20) labint = 4
           IF (difft .LE. 10) labint = 1
           IF (difft .GE. 60) ticint = 2
           IF (difft .GE. 120) ticint = 4
           IF (difft .GE. 240) ticint = 4

           ! make the tic interval go evenly into the label interval 
           IF (MOD(labint,ticint) .NE. 0) THEN
              i_ticint = INT(labint/ticint)
              ticint = MAX(INT(labint/i_ticint), 1)
           ENDIF
        ENDIF

        tic = delt/dt
        ticd = delt/dt

C set up for plotting graticules across at tic marks
        
        solid1 = (hgrat(1,1).LT.0 .AND. hgrat(2,1).LT.0 .AND.  
     .            hgrat(3,1).LT.0 .AND.  hgrat(4,1).LT.0 )
        solid2 = (hgrat(1,2).LT.0 .AND. hgrat(2,2).LT.0 .AND.  
     .            hgrat(3,2).LT.0 .AND.  hgrat(4,2).LT.0 )
        dashed1 = (hgrat(1,1).GT.0 .OR. hgrat(2,1).GT.0 .OR.  
     .            hgrat(3,1).GT.0 .OR.  hgrat(4,1).GT.0 )
        dashed2 = (hgrat(1,2).GT.0 .OR. hgrat(2,2).GT.0 .OR.  
     .            hgrat(3,2).GT.0 .OR.  hgrat(4,2).GT.0 )

     	do_line = hline

        color1 = hcolor(1)
        color2 = hcolor(2)

        IF (dashed1) THEN
           dash1_1 = hgrat(1,1)
           dash1_2 = hgrat(2,1)
           dash1_3 = hgrat(3,1)
           dash1_4 = hgrat(4,1)
        ENDIF
        IF (dashed2) THEN
           dash2_1 = hgrat(1,2)
           dash2_2 = hgrat(2,2)
           dash2_3 = hgrat(3,2)
           dash2_4 = hgrat(4,2)
        ENDIF
C

	IF(NSMTIC.LT.0)THEN
		IHVY=-6
		INML=-5
	ELSE
		IHVY=-10
		INML=-6
		TDIST = TIC/NTIC
	ENDIF
	IF(LABEL+IY.EQ.0)THEN
		XTEMP=0.0
	ELSE
		XTEMP=TLY*0.5
	ENDIF
	IF(IHDB.NE.0)THEN
	FIHDB=0.0
	ELSE
	FIHDB=-1.4
	ENDIF

      XTEMP1=X+DBLE(LABEL*(0.9*CSIZE+XTEMP)/XFACT) - 1.5*CSIZE/XFACT

      IF(LABEL.LT.0) THEN
          XTEMP2=X-((4.0+FIHDB)*CSIZE+XTEMP)/XFACT - 1.5*CSIZE/XFACT
      ELSE
         XTEMP2=X+3*CSIZE/XFACT
      ENDIF

      IF(LABEL.NE.0)YWID=(4.0+FIHDB)*CSIZE+XTEMP
      T=TLO  ! Time in hours, plot units
      td = tlo
      ITIME=ITIME1
      CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
      TDAY=T

      tfact_d = tfact
      xfact_d = xfact
	
      CALL PLOT(X,TLO,0,0)
      IF (MOD(imin,labint) .EQ. 0) THEN
         CALL PLOTT7(X,TLO,XFACT,TFACT,1,IHVY) ! draw to the location and make a mark
      ELSE
	 CALL PLOTT7(X,TLO,XFACT,TFACT,1,INML)
      ENDIF
	
      CALL TIME1(1,ITIME,2,' ',I3,ITIME3,delt)  ! next time stepping from 1 (arg 1) to 2 (arg 2) -- return ITIME3
      ITIME = ITIME3

c Check whether to make an hour label at the start of the axis
c ihdb is hour-label frequency
      IF (IABS(LABEL).EQ.1 .AND. (ihdb.EQ.1 .OR. delt.LE.1.)) THEN
	 IF (IMIN .EQ. 0) THEN
	    WRITE(SYM,82) IHR
	    CALL scinot_d(XTEMP1,td,angl,CSIZE,5,SYM,0,wid,xfact_d, tfact_d)
	 ENDIF
      ENDIF

c ----  count number of large tics. If no large tics will be drawn
c ----  then will want to draw graticule lines at the small ones.

c Set itime1, itime3 as above

      ITIME=ITIME1
      CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
      CALL TIME1(1,ITIME,2,' ',I3,ITIME3,delt) 
      ITIME = ITIME3

C      LOOP: counting large tics.
       ltic = 0
  110  CONTINUE

	CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
  	CALL TIME1(1,ITIME,2,' ',I3,ITIME3,delt)
	ITIME=ITIME3

	IF(ITIME(13:14)//ITIME(1:12) .LE.
     .     ITIME2(13:14)//ITIME2(1:12)) THEN
	   IF (difft.LE.12 .AND. sec.EQ.0.) THEN 
	      ltic = ltic+1
	   ELSE
              IF (imin.EQ.0. .AND. ihr.NE.0) THEN
                 ltic = ltic+1
              ELSEIF (MOD(imin,labint).EQ.0) THEN
                 ltic = ltic+1
              ENDIF
	   ENDIF
	   GO TO 110
        ENDIF

c Interval is a minute or less. Set controls for this case

	IF (ltic.EQ.0 .AND. delt.LE.1) THEN

           labsecs = .TRUE.

	   ltic = delt*60./ 15.
	   delt = 0.25

	   ticd = (DIFF(ITIME1, ITIME2)/dt)/ FLOAT(ltic)
	   tic = ticd
	   
	   XTEMP1 = XTEMP1 - 1.1*CSIZE/XFACT
	   XTEMP2 = XTEMP2 - 2.1*CSIZE/XFACT
	ENDIF
! IF no large tics, and if graticules at just the large tics were
! requested, then plot graticules at the small tics

	IF (ltic .EQ. 0) THEN   
           IF ( (.NOT.solid2) .AND. (solid1) ) THEN
              solid2 = solid1
              color2 = color1
           ENDIF
           IF ( (.NOT.dashed2) .AND. (dashed1) ) THEN 
              dashed2 = dashed1
              dash2_1 = dash1_1
              dash2_2 = dash1_2
              dash2_3 = dash1_3
              dash2_4 = dash1_4
              color2 = color1
           ENDIF

        ENDIF

! IF many large tics, make fewer - at the locations of labels
        heavy_at_labels = ltic .GT. 20

! Restore the state of ITIME, ITIME3
      ITIME=ITIME1
      CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)

      CALL TIME1(1,ITIME,2,' ',I3,ITIME3,delt)
      ITIME = ITIME3

c ----

C     LOOP:  Draw the axis line, tics, and labels

   10 CALL PLOT(X,T,0,0)
      IF ( interrupted ) RETURN		! TMAP interrupt
      
*    do not draw a graticule line along the upper axis
	   do_line = ( ITIME3(13:14)// ITIME3(1:10).LT.
     .	              ITIME2(13:14)//ITIME2(1:10)) 

c        Any small tics?
      DO 20 I=1,NSMTIC

              IF ((solid2.OR.dashed2) .AND. do_line) THEN ! make line across
                 CALL COLOR(color2)
                 IF (dashed2) THEN
                    CALL DASHSZ(dash2_1,dash2_2,dash2_3,dash2_4)
                    CALL DASHES
                 ENDIF
                 CALL PLOT(X,T+FLOAT(I)*TDIST,0,0) 
                 CALL PLOT(xacross,T+FLOAT(I)*TDIST,1,0)
                 CALL PLOT(X,T+FLOAT(I)*TDIST,0,0) 
                 CALL COLOR(color0)
                 CALL VECTRS
              ENDIF
              CALL PLOTT7(X,T+FLOAT(I)*TDIST,XFACT,TFACT,1,INML)

   20 CONTINUE
      CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)

*    do not draw a graticule line along the upper axis
	   do_line = ( ITIME3(13:14)// ITIME3(1:10).LT.
     .	              ITIME2(13:14)//ITIME2(1:10)) 
	  
      hvytic = (MOD(imin,labint) .EQ. 0)
      IF (heavy_at_labels) THEN
         hvytic = ( (imin .EQ. 0 .AND. MOD(ihr,hrint).EQ.0) .OR. 
     .              (MOD(imin,labint) .EQ. 0 .AND. hrint.LE.1) .OR. 
     .               ltic.EQ.0 )
      ENDIF

      IF(hvytic)THEN
	
              IF ((solid1.OR.dashed1) .AND. do_line) THEN ! make line across
                 CALL COLOR(color1)
                 IF (dashed1) THEN
                    CALL DASHSZ(dash1_1,dash1_2,dash1_3,dash1_4)
                    CALL DASHES
                 ENDIF
                 CALL PLOT(X,t+tic,0,0) 
                 CALL PLOT(xacross,t+tic,1,0)
                 CALL PLOT(X,t+tic,0,0) 
                 CALL COLOR(color0)
                 CALL VECTRS
              ENDIF
             CALL PLOTT7(X,T+TIC,XFACT,TFACT,1,IHVY)
      
      ELSE
         IF (MOD(imin,ticint).EQ.0) THEN
		    
c           graticule line at tic
            IF ((solid2.OR.dashed2) .AND. do_line) THEN ! make line across
               CALL COLOR(color2)
               IF (dashed2) THEN
                  CALL DASHSZ(dash2_1,dash2_1,dash2_3,dash2_4)
                  CALL DASHES
               ENDIF
               CALL PLOT(x,t+tic,0,0) 
               CALL PLOT(xacross,t+tic,1,0)
               CALL PLOT(x,t+tic,0,0) 
               CALL COLOR(color0)
               CALL VECTRS
            ENDIF
            CALL PLOTT7(X,T+TIC,XFACT,TFACT,1,INML)

         ELSE 
            CALL PLOT(X,T+TIC,1,0)
         ENDIF

      ENDIF

C THE LABELS

      IF (IABS(LABEL).EQ.1) THEN
         IF (MOD(imin,labint) .EQ. 0 .AND. hrint.LE.1 .AND. labsecs) THEN
            WRITE(SYM,86) ihr, imin, isec
            CALL scinot_d(XTEMP1,Td+TICd,0.,CSIZE,8,SYM,0,wid,xfact_d, tfact_d)

         ELSE
            IF (imin .EQ. 0 .AND. MOD(ihr,hrint).EQ.0) THEN
               WRITE(SYM,82) IHR
               CALL scinot_d(XTEMP1,Td+TICd,0.,CSIZE,5,SYM,0,wid,xfact_d, tfact_d)
            ELSE
               IF (MOD(imin,labint) .EQ. 0 .AND. hrint.LE.1) THEN
                  WRITE(SYM,84) ihr, imin
                  CALL scinot_d(XTEMP1,Td+TICd,0.,CSIZE,5,SYM,0,wid,xfact_d, tfact_d)
               ENDIF
            ENDIF
         ENDIF
      ENDIF

c Label with day/year below the axis

      CALL TIME1(1,ITIME,2,' ',I3,ITIME3,delt)
      IF(IDDB.EQ.0.OR.IABS(LABEL).NE.1) GO TO 70
      CALL TIME3(ITIME3,IYR3,IMON3,IDAY3,IHR3,IMIN3,ISEC3,ICEN3)
      IF(IDAY.EQ.IDAY3) GO TO 70
      IF(IDAY.NE.IDDB*(IDAY/IDDB))GO TO 60
C   ELSE:
      IF(T-TDAY.GT.180./DT) THEN
         CALL TIME2(ITIME,SYM)
         READ(SYM,55) DATE, YEAR
55	 FORMAT(6X,A6,1X,A4)
65       FORMAT(A6,1X,A4)
	 WRITE (BUFF, 65) DATE, YEAR
	 TSYM=TDAY+(T+TIC-TDAY-SYMWID(CSIZE,14,BUFF)/TFACT)*.5
	 CALL SYMBEL(XTEMP2,TSYM,90.,CSIZE,14,BUFF)
         datelabel = .TRUE.
      ENDIF
   60 TDAY=T+TIC
   70 CONTINUE
      ITIME=ITIME3
      T=T+TIC
      td = td + ticd
      t=td

      IF(ITIME(13:14)//ITIME(1:12) .LE.
     .   ITIME2(13:14)//ITIME2(1:12)) GO TO 10

c Finish out the line
      CALL PLOT (X,TLO,0,0)
      t = TLO + DIFF(ITIME1, ITIME2)/dt
      CALL PLOT (X,T,1,0)

* Label with day/year for axes shorter than an hour

      IF (IABS(LABEL).EQ.1 .AND. IDDB.NE.0 .AND. .NOT.datelabel) THEN
         CALL TIME2(ITIME,SYM)
	 READ(SYM,55) DATE, YEAR
         WRITE (BUFF, 65) DATE, YEAR
         TSYM=TLO + 0.5*DIFF(ITIME1, ITIME2)/dt - 0.5*SYMWID(CSIZE,14,BUFF)/TFACT
         CALL SYMBEL(XTEMP2,TSYM,90.,CSIZE,14,BUFF)
      ENDIF

      CALL COLOR(color0)

      RETURN
      END

*
* samplexy_curv.F
*
* Ansley Manke
* 4/03 
* ???  Note: does not currently deal with modulo data  ???
* 1/06 Remove calls to SIGN to compile with f90 on IRIX.

* This function samples 4-d curvlinear data on the x and y axes 
* indicated by args 4 and 5
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE samplexy_curv_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      CHARACTER*100 fcn_desc
      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns data sampled at a set of (X,Y) points, ',
     .   'using linear interpolation')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 5)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, ABSTRACT, 
     .     NORMAL, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)

      CALL ef_set_num_work_arrays(id, 1)

      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'DAT_TO_SAMPLE')
      CALL ef_set_arg_desc(id, arg, 'variable (x,y,z,t) to sample')
      CALL ef_set_axis_influence(id, arg, NO, NO, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'DAT_LON')
      CALL ef_set_arg_desc(id, arg, 'longitudes of input variable')
      CALL ef_set_axis_influence(id, arg, NO, NO, YES, YES)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'DAT_LAT')
      CALL ef_set_arg_desc(id, arg, 'latitudes of input variable')
      CALL ef_set_axis_influence(id, arg, NO, NO, YES, YES)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'XPTS')
      CALL ef_set_arg_desc(id, arg, 'X values of sample points')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'YPTS')
      CALL ef_set_arg_desc(id, arg, 'Y values of sample points')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* loss               lo subscript for an axis
*
* hiss               hi subscript for an axis
*

      SUBROUTINE samplexy_curv_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER my_lo_l, my_hi_l
      INTEGER nx, ny, nz, nt

*     Use utility functions to get context information about the 
*     1st argument, to set the abstract axis lo and hi indices.

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nx = arg_hi_ss(X_AXIS, ARG4) - arg_lo_ss(X_AXIS, ARG4) + 1
      ny = arg_hi_ss(Y_AXIS, ARG4) - arg_lo_ss(Y_AXIS, ARG4) + 1
      nz = arg_hi_ss(Z_AXIS, ARG4) - arg_lo_ss(Z_AXIS, ARG4) + 1
      nt = arg_hi_ss(T_AXIS, ARG4) - arg_lo_ss(T_AXIS, ARG4) + 1

      my_lo_l = 1
      my_hi_l = max(nx,ny,nz,nt)

      CALL ef_set_axis_limits(id, X_AXIS, my_lo_l, my_hi_l)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE samplexy_curv_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_lens(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER nx, ny

      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

*  workspace for saving locations of xpt in arg2 array.

      nx = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) 
      ny = arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) 

*  xlocations
      CALL ef_set_work_array_dims (id, 1, 1, 1, 1, 1, nx*ny, 2, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END
*
* In this subroutine we compute the result
*



      SUBROUTINE samplexy_curv_compute(id, arg_1, arg_2, arg_3, arg_4, 
     .       arg_5, result, xlocations)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .     mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .     mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz,
     .     mem3lot:mem3hit)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz,
     .     mem4lot:mem4hit)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz,
     .     mem5lot:mem5hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .      memresloz:memreshiz, memreslot:memreshit)


* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable's axes.

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      COMMON /STOR/ mxdat, mydat
      INTEGER mxdat, mydat
      INTEGER nx, nxx, nxy, nxz, nxt
      INTEGER ny, nyx, nyy, nyz, nyt
      INTEGER ndimx, ndimy
      INTEGER nx1, nx2, nx3, ny1, ny2, ny3

*  Set up work arrays

      REAL xlocations(wrk1lox:wrk1lox+(wrk1hix-wrk1lox),wrk1loy:wrk1hiy,
     .                wrk1loz:wrk1hiz, wrk1lot:wrk1hit)
      REAL ylocations(2)

      INTEGER i, j, k, l
      INTEGER i1,j1,k1,l1
      INTEGER i2,j2,k2,l2
      INTEGER i3,j3,k3,l3
      INTEGER i4,j4,k4,l4
      INTEGER i5,j5,k5,l5

      INTEGER ibot, itop, jbot, jtop
      INTEGER nloc, iloc, ptloc, icross
      REAL xpt, ypt, ydiff, yd
      REAL fxbot, fxtop, fbb, ftb, fbt, ftt
      REAL xbot, xtop, ybot, ytop
      REAL frac
      CHARACTER*255 err_msg

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

C Check that first 3 args are on the same grid.

      nx1 = arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 1
      nx2 = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1
      nx3 = arg_hi_ss(X_AXIS,ARG3) - arg_lo_ss(X_AXIS,ARG3) + 1
      ny1 = arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 1
      ny2 = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1
      ny3 = arg_hi_ss(X_AXIS,ARG3) - arg_lo_ss(X_AXIS,ARG3) + 1

      IF (nx1 .NE. nx2 .OR. nx2 .NE. nx3 .OR. nx1 .NE. nx3) THEN
         err_msg ='Arguments 1, 2, and 3 must have the same XY grid'
         GO TO 999
      ENDIF
      IF (ny1 .NE. ny2 .OR. ny2 .NE. ny3 .OR. ny1 .NE. ny3) THEN
         err_msg ='Arguments 1, 2, and 3 must have the same XY grid'
         GO TO 999
      ENDIF

C Check that sample x and y are simple lists of points - same length

      nxx = arg_hi_ss(X_AXIS,ARG4) - arg_lo_ss(X_AXIS,ARG4) + 1
      nxy = arg_hi_ss(Y_AXIS,ARG4) - arg_lo_ss(Y_AXIS,ARG4) + 1
      nxz = arg_hi_ss(Z_AXIS,ARG4) - arg_lo_ss(Z_AXIS,ARG4) + 1
      nxt = arg_hi_ss(T_AXIS,ARG4) - arg_lo_ss(T_AXIS,ARG4) + 1
      nx = max(nxx, nxy, nxz, nxt)

      nyx = arg_hi_ss(X_AXIS,ARG5) - arg_lo_ss(X_AXIS,ARG5) + 1
      nyy = arg_hi_ss(Y_AXIS,ARG5) - arg_lo_ss(Y_AXIS,ARG5) + 1
      nyz = arg_hi_ss(Z_AXIS,ARG5) - arg_lo_ss(Z_AXIS,ARG5) + 1
      nyt = arg_hi_ss(T_AXIS,ARG5) - arg_lo_ss(T_AXIS,ARG5) + 1
      ny = max(nyx, nyy, nyz, nyt)

      ndimx = 0
      ndimy = 0
      DO 110 i = X_AXIS,T_AXIS
         IF(arg_hi_ss(i,ARG4) - arg_lo_ss(i,ARG4) .GT.0) ndimx=ndimx + 1
         IF(arg_hi_ss(i,ARG5) - arg_lo_ss(i,ARG5) .GT.0) ndimy=ndimy + 1
  110 CONTINUE

      IF (nx .NE. ny   .OR.  ndimx .GT. 1  .OR. ndimy .GT.1) THEN
         err_msg = 
     .  'Arguments 4 and 5 must be 1-dimensional lists of equal length'
         GO TO 999
      ENDIF


*  For each (xpt,ypt) pair, search the data arrays arg2,arg3
*  for the nearest higher (x,y) lat-lon coordinates.  Interpolate 
*  arg_1 in 2 directions for the result.

      i4 = arg_lo_ss(X_AXIS,ARG4)
      j4 = arg_lo_ss(Y_AXIS,ARG4)
      k4 = arg_lo_ss(Z_AXIS,ARG4)
      l4 = arg_lo_ss(T_AXIS,ARG4)

      i5 = arg_lo_ss(X_AXIS,ARG5)
      j5 = arg_lo_ss(Y_AXIS,ARG5)
      k5 = arg_lo_ss(Z_AXIS,ARG5)
      l5 = arg_lo_ss(T_AXIS,ARG5)

      j = res_lo_ss(Y_AXIS)
      DO 600 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

* Find all locations of xpt in arg_2, longitudes of data

	 xpt = arg_4(i4,j4,k4,l4)

         k2 = arg_lo_ss(Z_AXIS,ARG2)
         l2 = arg_lo_ss(T_AXIS,ARG2)

         nloc = 0

         DO 200 j2 = arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS,ARG2)
            i2 = arg_lo_ss(X_AXIS,ARG2)
c            icross = SIGN(1, (xpt - arg_2(i2,j2,k2,l2)) )
            icross = 1
            IF ((xpt - arg_2(i2,j2,k2,l2)) .LT. 0.) icross = -1

            DO 100 i2 = arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS,ARG2)
c               iloc = SIGN(1, (xpt-arg_2(i2,j2,k2,l2)) )
               iloc = 1
               IF ((xpt-arg_2(i2,j2,k2,l2)) .LT. 0. ) iloc = -1

               IF (icross .NE. iloc)THEN
                  nloc = nloc + 1
                  xlocations(nloc,1,1,1) = MAX(i2-1,1)
                  xlocations(nloc,2,1,1) = j2
c                  icross = SIGN(1, (xpt - arg_2(i2,j2,k2,l2)) )
                  icross = 1
                  IF ((xpt - arg_2(i2,j2,k2,l2)) .LT. 0.) icross = -1
               ENDIF

  100       CONTINUE
  200    CONTINUE

* Which of those locations is nearest xpt in arg_3, latitudes of data?

         ypt = arg_5(i5,j5,k5,l5)
         ydiff = ABS(bad_flag_result)
         ptloc = 1

         k3 = arg_lo_ss(Z_AXIS,ARG3)
         l3 = arg_lo_ss(T_AXIS,ARG3)

         DO 300 iloc = 1, nloc
            i3 = xlocations(iloc,1,1,1)
            j3 = xlocations(iloc,2,1,1)
               yd = ABS(ypt - arg_3(i3,j3,k3,l3))

            IF ( yd .LT. ydiff ) THEN
               ylocations(1) = i3
               ylocations(2) = j3
               ydiff = yd
               ptloc = iloc
            ENDIF
  300   CONTINUE

        ibot = xlocations(ptloc,1,1,1)
        jbot = xlocations(ptloc,2,1,1)
        IF (ibot .GE. arg_hi_ss(X_AXIS,ARG1) ) ibot = ibot - 1
        IF (jbot .GE. arg_hi_ss(Y_AXIS,ARG1) ) jbot = jbot - 1

        itop = ibot + 1
        jtop = jbot + 1

*  First interpolate in x, getting values of the fcn at (x,jbot)  and (x,jtop)


         k1 = arg_lo_ss(Z_AXIS,ARG1)
         k2 = arg_lo_ss(Z_AXIS,ARG2)
         k3 = arg_lo_ss(Z_AXIS,ARG3)
         DO 500 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

            l1 = arg_lo_ss(T_AXIS,ARG1)
            l2 = arg_lo_ss(T_AXIS,ARG2)
            l3 = arg_lo_ss(T_AXIS,ARG3)
            DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

               IF (ibot .GE. arg_lo_ss(X_AXIS,ARG1)  .AND. 
     .              itop .LT. arg_hi_ss(X_AXIS,ARG1) ) THEN

                  xbot = arg_2(ibot,jbot,k2,l2)
                  xtop = arg_2(itop,jbot,k2,l2)
      
                  fbb = arg_1(ibot,jbot,k1,l1) 
                  ftb = arg_1(itop,jbot,k1,l1)
                  fbt = arg_1(ibot,jtop,k1,l1)
                  ftt = arg_1(itop,jtop,k1,l1)

                  IF (fbb .NE. bad_flag(ARG1)  .AND.
     .                ftb .NE. bad_flag(ARG1)  .AND.
     .                fbt .NE. bad_flag(ARG1)  .AND.
     .                ftt .NE. bad_flag(ARG1) ) THEN


                     frac = (xpt - xbot ) / (xtop - xbot)
                     fxbot = fbb + frac* (ftb - fbb)
                     fxtop = fbt + frac* (ftt - fbt)

*  Now interpolate in y, getting value at (x,y)

                     IF (jbot .GE. arg_lo_ss(Y_AXIS,ARG1)  .AND. 
     .                   jtop .LE. arg_hi_ss(Y_AXIS,ARG1) ) THEN
                        ybot = arg_3(ibot,jbot,k3,l3)
                        ytop = arg_3(ibot,jtop,k3,l3)

                        frac = (ypt - ybot)/ (ytop - ybot)
                           result(i,j,k,l) = fxbot + frac* (fxtop-fxbot)
                        ELSE
                              result(i,j,k,l) = bad_flag_result
                        ENDIF

                     ELSE
                        result(i,j,k,l) = bad_flag_result
                     ENDIF		! bad_flag(ARG1) test
                  ENDIF


               l1 = l1 + arg_incr(T_AXIS,ARG1)
               l2 = l2 + arg_incr(T_AXIS,ARG2)
               l3 = l3 + arg_incr(T_AXIS,ARG3)

 400        CONTINUE

            k1 = k1 + arg_incr(Z_AXIS,ARG1)
            k2 = k2 + arg_incr(Z_AXIS,ARG2)
            k3 = k3 + arg_incr(Z_AXIS,ARG3)
 500     CONTINUE

         i4 = i4 + arg_incr(X_AXIS,ARG4)
         j4 = j4 + arg_incr(Y_AXIS,ARG4)
         k4 = k4 + arg_incr(Z_AXIS,ARG4)
         l4 = l4 + arg_incr(T_AXIS,ARG4)

         i5 = i5 + arg_incr(X_AXIS,ARG5)
         j5 = j5 + arg_incr(Y_AXIS,ARG5)
         k5 = k5 + arg_incr(Z_AXIS,ARG5)
         l5 = l5 + arg_incr(T_AXIS,ARG5)
600   CONTINUE

      RETURN
 999  CALL ef_bail_out (id, err_msg)

      END

	CHARACTER*(*) FUNCTION VAR_TRANS( idim, cx, out_len )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* create a string of the form NAME[Z
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  7/21/89 - extracted from DIAG_OP
* V230:  11/4/92 - expanded user variable name length
* V500 *kob* 3/99- up VAR_CODE and local variable var to 64 chars
* V552 *acm* 4/03- up VAR_CODE decl from 64 to 128 chars
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
*       *acm*11/16 write a shortened var name to diag output when name is super long

        IMPLICIT NONE
* calling argument declarations:
	INTEGER	idim, cx, out_len

* internal variable declarations:
	INTEGER	  TM_LENSTR1, slen, vlen
	CHARACTER VAR_CODE*128, CX_DIM_STR*48,
     .            var*128, out_buff*80, dim_str*48

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'xcontext.cmn'
	include	'xtext_info.cmn'

* internal parameter declarations:
	LOGICAL     full_precision, toolong
	PARAMETER ( full_precision = .TRUE. )

* initialize
	var = VAR_CODE( cx_category(cx), cx_variable(cx) )
        vlen = TM_LENSTR1( var )
	toolong = vlen .GT. 60

* TRANSFORMATION
* "VAR_NAME[x=lo:hi@TRN:n,D=#]"
	dim_str = CX_DIM_STR( idim, cx, ':',  full_precision, slen )
	IF (toolong) THEN
	   WRITE (out_buff,3000) var(:50), dim_str(:slen), cx_data_set(cx)
	ELSE
	   vlen = MIN(70, vlen)
	   WRITE (out_buff,3100) var(:vlen), dim_str(:slen), cx_data_set(cx)
	ENDIF
	CALL TM_PACK_STRING( out_buff, out_buff, 1, 80, out_len )

 3000	FORMAT (A,' ... [',A,',D=',I3,']')
 3100	FORMAT (A,'[',A,',D=',I3,']')

	VAR_TRANS = out_buff


	RETURN
	END

*
* maxstrlen.F
*
* Ansley Manke
* May 2002
*
* Returns max length of strings in input array.
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, maxstrlen )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )


      SUBROUTINE maxstrlen_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V


      CALL ef_set_desc(id,
     .  'Demo Function:Returns the max length of strings in A' )

      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance(id, NORMAL, NORMAL, NORMAL, NORMAL)
      CALL ef_set_result_type(id, FLOAT_RETURN)

      CALL ef_set_piecemeal_ok(id, YES, YES, YES, YES)

      arg = 1
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_desc(id, arg, 'Array of strings')
      CALL ef_set_arg_type (id, arg, STRING_ARG)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


* In this subroutine we compute the result
*
      SUBROUTINE maxstrlen_compute(id, arg_1, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* Single precision Ferret: string arg and result need to be twice the length.
      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif

      REAL arg_1(strdf,mem1lox:mem1hix, mem1loy:mem1hiy, 
     .     mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)
      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER atype, iarg, slen
      CHARACTER*100 errmsg

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)

      CALL ef_get_arg_type (id, 1, atype)
      IF (atype .NE. STRING_ARG) THEN
        errmsg = 'must call with string argument'
        GO TO 5000
      ENDIF

      iarg = 1

      CALL EF_GET_STRING_ARG_MAX_LEN (id, iarg, arg_1, slen)
      result(res_lo_ss(X_AXIS), res_lo_ss(Y_AXIS), 
     .       res_lo_ss(Z_AXIS), res_lo_ss(T_AXIS))  = slen

      RETURN 
 5000 CALL EF_BAIL_OUT(id,errmsg)

      RETURN
      END

	CHARACTER*20 FUNCTION ALG_TRANS_TITL( trans, cx )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* return the title of the given transformation

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* revision 0.0 - 4/28/87
* V430: 7/96 if a 4D transformation then pre-pend the axes involved
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

        IMPLICIT NONE
* calling argument declarations:
	INTEGER	trans, cx

* internal variable declarations:
	INTEGER	i, i4d, ndim, tcode
	CHARACTER prefix*5

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xtext_info.cmn'
	include 'xalgebra.cmn'
	include 'xcontext.cmn'

* identify the code from known codes
	DO 100 tcode = 1, num_transforms
	   IF ( trans .EQ. alg_trans_num(tcode) )	GOTO 200
 100	CONTINUE

* unknown code
	ALG_TRANS_TITL = '???'
	RETURN

* is this a 4D transformation? If so, include axis prefix to the transformation
 200	DO 250 i4d = 1, num_4d_trans
	   IF ( trans .EQ. alg_4d_trans(i4d) ) THEN
	      prefix = ' '
	      ndim = 0
	      DO 240 i = 1, 4
	         IF (cx_trans(i,cx) .EQ. trans) THEN
	            ndim = ndim + 1
	            prefix = prefix(:ndim)//ww_dim_name(i)
	         ENDIF
 240	      CONTINUE
	      ALG_TRANS_TITL = prefix(2:ndim+1)//alg_trans_title(tcode)(3:)
	      RETURN
	   ENDIF
 250	CONTINUE	

* not a 4D transform -- simply return the text
	ALG_TRANS_TITL = alg_trans_title(tcode)
	RETURN
	END

	SUBROUTINE CD_PUT_AGG_MEMB_GRID (agg_dset, vname, imemb, igrid, status)
*  
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP 
*
* Given aggregate datset, variable name in the set, aggregate member number,
* store a new grid number.

* for var in aggregate member-dataset:
* for members of the aggregate, imemb (id= sequence number 1,2,3,...
*   igrid    Ferret grid number
*   iline    Ferret line number of aggregate dimension
*   vtype    1=file-var, 3=user-var
*   mdset    Ferret dataset number
*   nv       sequence number in ds_var_code or uvar_name_code
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE

* Argument declarations
  
	CHARACTER*(*) vname
	INTEGER agg_dset, imemb, igrid, status

* Local variable declarations
	INTEGER NCF_ADD_AGG_VAR_INFO, NCF_PUT_AGG_MEMB_GRID, varid

	CALL CD_GET_VAR_ID (agg_dset, vname, varid, status)

	status = NCF_PUT_AGG_MEMB_GRID( agg_dset, varid, imemb, igrid)

	RETURN
	END

        SUBROUTINE CD_MAKE_FMRC_AXES(dset, varid, vname, vartype,
     .                tstart, tend, delta, fevery, tevery, nT, nF,
     .                axlagt, axcalt, axlagf, axcalf, iline, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*.
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE.
*

* this routine synthesizes the T axis calendar time and F axis lead time
* axes that are needed to support FMRC visualization and analysis

* V695+ *acm* and *sh*
* V698 2/16 *sh* - if identical pre-existing axes exist, re-use them
* V698 3/16 *sh* - F-lag axis starts at 1/2 avg_lag (low cell bound at zero)
* V698  4/16 *acm* new TM_UNITS_CAL to account for calendar in units id
* V71 12/16 *acm* Ticket 2158: working with true monthly time axes. fmrc axis is
*                 not defined as true month.
* V72 6/17 *acm* For trac enhancement #767 -- dynamic coordinate storage

* include files
        include 'netcdf.inc'
        include 'tmap_errors.parm'
#include "gt_lib.parm"
        include 'tmap_dims.parm'
#include "tmap_dset.parm"
        include 'xdset_info.cmn_text'

        include 'xtm_grid.cmn_text'
        external xgt_grid_data
        include 'xbuild_grids.cmn'

        external xdset_info_data
        include 'xdset_info.cd_equiv'
        include 'xio.cmn_text'
        include 'xunits.cmn_text'
        external xunits_data
c        include 'calendar.decl'
c        include 'calendar.cmn'

* calling argument declarations
        REAL*8 tstart, tend, delta
        INTEGER dset, varid, vartype, fevery, tevery,
     .          nT, nF, axlagt, axcalt, axlagf, axcalf, iline, status
        CHARACTER*(*) vname

* internal variable declarations
        INTEGER bufflen
        PARAMETER (bufflen = 256)
        CHARACTER TM_STRING*13, buff*256, dbuf*3, vupcase*128

        LOGICAL TM_DFPEQ_TOL, TM_FPEQ_EPS, NC_GET_ATTRIB, ITSA_TRUEMONTH_AXIS,
     .          coordvar, got_it, do_warn, ok_cal, yyyymmdd_time, got_torg,
     .          true_month
        INTEGER STR_UPCASE, TM_LENSTR1, TM_GET_CALENDAR_ID, TM_UNIT_ID,
     .          TM_UNITS_CAL, TM_FIND_LIKE_DYN_LINE, STR_SAME,
     .          i, l, n,  nvdim, vdims(8), nvatts,
     .          outflag, next_line_storage, pre_exist,
     .          maxlen, attlen, attoutflag, cal_id, since_T0, slen, vlen,
     .          units, istat, nlag, nleadtimes, indx
        REAL    val


* initialize things
        do_warn = .FALSE.

*********  FIRST THE 1D CALENDAR TIME AXIS OF THE FMRC  *************
* Define new axis

        CALL TM_ALLO_TMP_LINE (axcalt, status)

* Get units, calendar, origin
* Get the calendar name.

      line_cal_name(axcalt) = 'GREGORIAN'   ! default
      maxlen = bufflen
      vlen = TM_LENSTR1(vname)
      got_it = NC_GET_ATTRIB( dset, varid, 'calendar', do_warn,
     .                        vname(:vlen), maxlen, attlen, attoutflag,
     .                        buff, val)
      IF (got_it) then
         CALL CD_GET_CALENDAR_NAME(buff, ok_cal)
         IF (ok_cal) THEN
            line_cal_name(axcalt) = buff
         ELSE
            slen = TM_LENSTR1(buff)
            CALL TM_NOTE('calendar attribute for 2D Time variable "'//
     .                   vname(:vlen)//'" is not recognized: '//
     .                   buff(1:slen), lunit_errors)
            CALL TM_NOTE('Assuming Gregorian calendar', lunit_errors)
         ENDIF
      ENDIF
      cal_id = TM_GET_CALENDAR_ID (line_cal_name(axcalt))

* optional units for axis (may contain "tunits since T0_date" 2/95)
      line_units(axcalt) = ' '   ! default
      maxlen = bufflen
      got_it = NC_GET_ATTRIB( dset, varid, 'units', do_warn,
     .                        vname(:vlen), maxlen, attlen, attoutflag,
     .                        buff, val)
      since_T0 = MAX( INDEX(buff,'since'), INDEX(buff,'SINCE') )
      yyyymmdd_time = buff(1:15) .EQ. 'yyyymmddhhmmss'

      IF ( since_T0 .GT. 2 ) THEN
         line_units(axcalt) = buff(:since_T0-1)  ! just the "tunits" part

         istat = STR_UPCASE( dbuf, buff(1:3) )

         slen = TM_LENSTR1(buff)
         IF ( slen .GT. since_T0 + 5) THEN

            got_torg = .TRUE.
            CALL TM_DATE_REFORMAT(buff(since_T0+6:),pdate_numslashnum,
     .                            cal_id, line_t0(axcalt),
     .                            pdate_vax, .FALSE., status )

c fix for bug 1394
c If the part after since is not a date/time, just keep the whole
c string as the units.  i.e., "days_since_event".

            IF ( status .NE. merr_ok ) THEN
               line_units(axcalt) = buff(1:slen)
               got_torg = .FALSE.
               since_t0 = 0
               status = merr_ok
            ENDIF
         ELSE
            since_t0 = 0        ! flag that no T0 was present
         ENDIF
      ELSEIF ( yyyymmdd_time ) THEN
         line_units(axcalt) = 'days'
         line_t0(axcalt) = ' ' ! to be determined when coords are read
         got_torg = .TRUE.
      ELSE
         IF (got_it) line_units(axcalt) = buff
         got_torg = .FALSE.
      ENDIF

* ... decode the units

      units = TM_UNIT_ID( line_units(axcalt) )

* Named calendar with unit=month or year gets length according to calendar's year length.

      true_month = ITSA_TRUEMONTH_AXIS(axcalt)
      IF (true_month) THEN
         true_month = .FALSE.
         units = pun_day
         line_units(axcalt) = un_name(units) ! make it days, NOT true-month
      ENDIF

      units = TM_UNITS_CAL( units, cal_id, true_month )

      line_unit_code(axcalt) = units
      IF  ( units.EQ.0 .AND. line_units(axcalt) .NE. ' ' ) THEN
         CALL TM_NOTE('Units on axis "'//vname(:vlen)//
     .      '" are not recognized: '//line_units(axcalt), lunit_errors)
         CALL TM_NOTE('They will not be convertible:', lunit_errors)
      ENDIF
      IF ( units .GE. 0 ) THEN
         line_tunit(axcalt) = real4_init
      ELSE
         line_tunit(axcalt) = un_convert(line_unit_code(axcalt))
      ENDIF

* The units must describe calendar time

      ! check that this has mapped to the right TF orientation
      IF (line_tunit(axcalt) .NE. real4_init) THEN
         line_direction(axcalt) = 'TI'
      ELSE
         GOTO 5400
      ENDIF

      line_regular(axcalt)   = .TRUE.
      line_start(axcalt)     = tstart
      line_delta(axcalt)     = delta
      line_dim(axcalt)       = NINT((tend - tstart + delta)/delta)
      line_subsc1 (axcalt)   = unspecified_int4

* Save the axis name (upper case)
      CALL TM_NEW_LINE_NAME('TF_CAL_T', buff)
      line_name(axcalt)      = buff
      line_name_orig(axcalt) = buff
      line_dattype(axcalt)   = nf_double

*********  THE SUPERLINE FORECAST INITIALIZATION TIME AXIS  *************
! per Andrew W., this axis has been shifted 1/2. cell to the left
! so that the F coordinate lies on the low limit (initialization time) of
! the 1st time coordinate from each forecast
      CALL TM_ALLO_TMP_LINE (axcalf, status)
      CALL TM_NEW_LINE_NAME('TF_CAL_F', buff)
      line_name(axcalf)      = buff
      line_name_orig(axcalf) = buff
      line_regular(axcalf)   = .TRUE.
      line_start(axcalf)     = tstart - 0.5 * delta
      line_delta(axcalf)     = delta
      line_dim(axcalf)       = nF * fevery

* inherit time units from the calendar time axis just created
      line_cal_name(axcalf)  = line_cal_name(axcalt)
      line_unit_code(axcalf) = line_unit_code(axcalt)
      line_units(axcalf)     = line_units(axcalt)
      line_tunit(axcalf)     = line_tunit(axcalt)
      line_t0(axcalf)        = line_t0(axcalt)
      line_direction(axcalf) = 'FI'
      line_dattype(axcalf)   = nf_double

*********  THE ACTUAL FORECAST INITIALIZATION TIME AXIS  *************
! per Andrew W., this axis has been shifted 1/2. cell to the left
! so that the F coordinate lies on the low limit (initialization time) of
! the 1st time coordinate from each forecast
      line_regular(iline)    = .TRUE.
      line_start(iline)      = tstart - 0.5 * delta
      line_delta(iline)      = delta * fevery
      line_dim(iline)        = nF

* inherit time units from the calendar time axis just created
      line_cal_name(iline)   = line_cal_name(axcalt)
      line_unit_code(iline)  = line_unit_code(axcalt)
      line_units(iline)      = line_units(axcalt)
      line_tunit(iline)      = line_tunit(axcalt)
      line_t0(iline)         = line_t0(axcalt)
      line_direction(iline)  = 'FI'
      line_dattype(iline)    = nf_double

*********  THE FORECAST LEAD TIME AXIS OF THE FMRC  *************
      nleadtimes = nT * tevery
      CALL TM_NEW_LINE_NAME('TF_LAG_F', buff)
      CALL TM_MAKE_BASIC_AXIS(buff, delta/2., delta,
     .                        nleadtimes, axlagf, status)

* inherit time units from the calendar time axis just created
      line_cal_name(axlagf)  = line_cal_name(axcalt)
      line_unit_code(axlagf) = line_unit_code(axcalt)
      line_units(axlagf)     = line_units(axcalt)
      line_tunit(axlagf)     = line_tunit(axcalt)
      line_t0(axlagf)        = line_t0(axcalt)
      line_direction(axlagf) = 'FF'
      line_dattype(axlagf)   = nf_double

*********  THE SUPERLINE TIME LAG AXIS OF THE FMRC  *************
      nleadtimes = nT * tevery
      CALL TM_NEW_LINE_NAME('TF_LAG_T', buff)
      CALL TM_MAKE_BASIC_AXIS(buff, delta/2., delta,
     .                        nleadtimes, axlagt, status)

* inherit time units from the calendar time axis just created
      line_cal_name(axlagt)  = line_cal_name(axcalt)
      line_unit_code(axlagt) = line_unit_code(axcalt)
      line_units(axlagt)     = line_units(axcalt)
      line_tunit(axlagt)     = line_tunit(axcalt)
      line_t0(axlagt)        = line_t0(axcalt)
      line_direction(axlagt) = 'TT'
      line_dattype(axlagt)   = nf_double

********************
* If axes are an exact duplicate of a pre-existing axis, then use that instead.
* (Shared axes are needed in order to E-aggregate multiple FMRCs)
      pre_exist = TM_FIND_LIKE_DYN_LINE( axlagt )
      IF (pre_exist .NE. unspecified_int4) THEN
         CALL TM_DEALLO_DYN_LINE(axlagt)
         axlagt = pre_exist
      ENDIF
      pre_exist = TM_FIND_LIKE_DYN_LINE( axcalf )
      IF (pre_exist .NE. unspecified_int4) THEN
         CALL TM_DEALLO_DYN_LINE(axcalf)
         axcalf = pre_exist
      ENDIF
      pre_exist = TM_FIND_LIKE_DYN_LINE( axcalt )
      IF (pre_exist .NE. unspecified_int4) THEN
         CALL TM_DEALLO_DYN_LINE(axcalt)
         axcalt = pre_exist
      ENDIF
      pre_exist = TM_FIND_LIKE_DYN_LINE( axlagf )
      IF (pre_exist .NE. unspecified_int4) THEN
         CALL TM_DEALLO_DYN_LINE(axlagf)
         axlagf = pre_exist
      ENDIF

* successful completion
        status = merr_ok

 5000   RETURN

 5400   CALL TM_ERRMSG(merr_notimeinfo, status, 'CD_MAKE_FMRC_AXES',
     .     no_descfile, no_stepfile, 'unrecognizable time encoding',
     .     no_errstring, *5000)
        RETURN
        END

*
* status.F
*
* Jonathan Callahan
* Feb 19th 1998
*
* This function checks the input variable for bad data
* and returns 0 (no bad flags) or 1 (bad flags found)
*
* NB_ External functions need to have regions defined on
*     the arguments to have those regions used in the
*     external function calculation.  Regions defined
*     with SET REGION will not have the desired effect.
*
*     Use a command like:
*
*     let a = status(sst[x=180:160w,y=0:20n,l=1])
*


*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE status_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

      CALL ef_version_test(ef_version)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,'test for bad flags in data' )

      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance(id, NORMAL, 
     .     NORMAL, NORMAL, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, 'none')
      CALL ef_set_arg_desc(id, arg, 'data to be checked')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, YES)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE status_compute(id, arg_1, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

	  INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      print *, ' result lo limits', res_lo_ss
      print *, ' result hi limits', res_hi_ss

* We'll give the data the benefit of the doubt and assume that
* it's good unless we find out otherwise.

      DO 40 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
         DO 30 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            DO 20 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
               DO 10 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

                  result(i,j,k,l) = 0

 10            CONTINUE
 20         CONTINUE
 30      CONTINUE
 40   CONTINUE

*
* Note that we are looping on the argument subscripts rather than
* the result subscripts (the normal way).  That's because the result
* has axes which are normal and the loop count on those normal axes 
* will be one.
*
      i = res_lo_ss(X_AXIS)
      DO 400 i1=arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)

         j = res_lo_ss(Y_AXIS)
         DO 300 j1=arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)

            k = res_lo_ss(Z_AXIS)
            DO 200 k1=arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)

               l = res_lo_ss(T_AXIS)
               DO 100 l1=arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)

                  IF ( arg_1(i1,j1,k1,l1) .EQ. bad_flag(1) ) THEN

                     result(i,j,k,l) = 1

                  END IF

                  l = l + res_incr(T_AXIS)
                  
 100           CONTINUE

               k = k + res_incr(Z_AXIS)
 200        CONTINUE

            j = j + res_incr(Y_AXIS)
 300     CONTINUE

         i = i + res_incr(X_AXIS)
 400  CONTINUE
      
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	INTEGER FUNCTION EZ_PERMUTED_INDEX( )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* work routine for EZ_READ when /ORDER is not the default X-Y-Z-T-E-F
* Determine the single-dimensioned array index equivalent to the 6D
* (i,j,k,l,m,n) of the "next" word to be stored

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Thermal Modeling and Analysis Program

* revision 0.00 -  3/4/94 *sh*
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files
* V694 11/14 *acm* Ticket 2217: permuted ASCII reading in 6D

* calling arguments:
* None - all indexing is done in COMMON to maximize speed (and because
* algorithm is based on incrementing the last position rather than 
* recomputing cold from arguments

* internal variable declarations:

	include 'tmap_dims.parm'
        include 'xez_order.cmn_text'

* convenience equivalences
	INTEGER	nx, ny, nz, nt, ne, nf,
     .		 i,  j,  k,  l, m, n,
     .		o1, o2, o3, o4, o5, o6
	EQUIVALENCE (eznn(1),nx), (eznn(2),ny), (eznn(3),nz), 
     .		    (eznn(4),nt), (eznn(5),ne),
     .		    (ezii(1),i),(ezii(2),j),(ezii(3),k),
     .		    (ezii(4),l),(ezii(5),m),(ezii(6),n),
     .		    (ezorder(1),o1), (ezorder(2),o2), 
     .		    (ezorder(3),o3), (ezorder(4),o4), 
     .		    (ezorder(5),o5), (ezorder(6),o6) 


* local variable definitions:

* increment all nferdims subscripts in appropriate permutation

	ezii(o1) = ezii(o1) + 1
	IF ( ezii(o1) .GE. eznn(o1) ) THEN
	   ezii(o1) = 0
	   ezii(o2) = ezii(o2) + 1
	   IF ( ezii(o2) .GE. eznn(o2) ) THEN
	      ezii(o2) = 0
	      ezii(o3) = ezii(o3) + 1
	      IF ( ezii(o3) .GE. eznn(o3) ) THEN
	         ezii(o3) = 0
	         ezii(o4) = ezii(o4) + 1


	         IF ( ezii(o4) .GE. eznn(o4) ) THEN
	            ezii(o4) = 0
	            ezii(o5) = ezii(o5) + 1

		    
	            IF ( ezii(o5) .GE. eznn(o5) ) THEN
	               ezii(o5) = 0
	               ezii(o6) = ezii(o6) + 1
	            ENDIF

	         ENDIF

	      ENDIF
	   ENDIF
	ENDIF

* compute the 1D index

	EZ_PERMUTED_INDEX = 
     .     ( nx*(ny*(nz*(nt*(ne*n + m) + l) + k) + j) + i ) + 1

	RETURN

      END

	SUBROUTINE XEQ_IF

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* sets up the control stack (COMMON/~CONTROL/) to handle single line
* conditional "IF" or the IF-stack (ifstk) to handle multiple line IF
* Single line IF (e.g. IF cond THEN command1 ELSE command2 ENDIF)
* or a multi-line IF -- e.g.
*	IF cond THEN
*	   commands ...
*	ELIF cond2 THEN
*	   commands ...
*	ELSE
*	   commands ...
*	ENDIF

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V420:  4/96
*        5/96 - allow for multi-line IF clause inside of skipped clause
* V500:  6/99 - bug fix for final quote in IF 1  THEN SAY "I is too big" ENDIF
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V693+ *sh* 12/14 1- init ifstk_skipping to count nested IFs while skipping
*                  2- screen for ELIF used in a single line syntax
*	           3- on error csp drop must occur before call to ERRMSG
*	           4- improved error message for "IF some expression THEN ..."
* V695+ *sh* 2/15 - added support for _DQ_

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'command.parm'
	include 'errmsg.parm'
	include 'gfdl_vms.parm'
	include 'xcontext.cmn'
	include 'xcontrol.cmn'
	include 'xprog_state.cmn'

* local variable declarations
	LOGICAL TRUE_OR_FALSE, condition, has_false_clause,
     .		non_executed_if
	INTEGER	STR_CASE_BLIND_COMPARE, STR_UPCASE,
     .		vax_code, if_type, iarg,
     .		true_clause_start, true_clause_end, false_clause_start,
     .		false_clause_end, status, csp1, tmp_stat, iend

* 6/96: Are we really going to process this IF or merely register that
* a (skipped) IF clause has been opened?
* e.g. in this example the first ENDIF is ignorable
*       IF yes THEN
*	  do stuff
*       ELSE
*         IF condition THEN
*           do stuff
*         ENDIF			! <=== must be skipped
*       ENDIF
	IF (if_conditional) THEN				! nested IF?
	   IF (if_doing(ifstk).NE.pif_doing_clause) THEN	! skipped IF?
	      IF ( num_args .LE. 2 ) THEN		! multi-line nested IF?
* ...       bump the IF stack - set up to skip this entire IF clause
	         IF ( ifstk .GE. max_ifstk ) GOTO 5400
	         ifstk = ifstk + 1
	         if_doing(ifstk) = pif_skip_to_endif
	         if_cs(ifstk) = if_cs(ifstk-1)
	         ifstk_skipping = 0     ! counts nested IFs while skipping
	      ENDIF
	      RETURN
	   ENDIF
	ENDIF

* check that something was given to "if" on
	IF ( num_args .LT. 2 ) GOTO 5100

* determine if the condition is true or false
	condition = TRUE_OR_FALSE(cmnd_buff(arg_start(1):arg_end(1)),
     .				  status)
	IF ( status .NE. ferr_ok ) GOTO 5000

* whether single line or multi the second argument should be "THEN"
* a common user error is to use arithmetic expression for the conditional
* without grave accents.  In this case the THEN exists, but is not argument 2
	DO iarg = 2, num_args
	   vax_code = STR_CASE_BLIND_COMPARE(
     .				cmnd_buff(arg_start(iarg):arg_end(iarg)),
     .				'THEN' )
	   IF (vax_code .EQ. vms_str_success) GOTO 100
	ENDDO
* ... no THEN was provided
	GOTO 5200
 100	IF (iarg .GT. 2) GOTO 5210

* determine the nature of the IF clause -- single line or multi
	IF ( num_args .GT. 2 ) THEN

* ***** process a single line IF *****
* Single line logic is handled on the control stack since input for dependent
* clauses comes from internal control
* allocate next spot for the IF control on the control stack
	   CALL STACK_PTR_UP( csp, cs_max, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   csp1 = csp

* save the full command string converted to upper case
	   vax_code = STR_UPCASE( cs_text( csp ), cmnd_buff )


* pattern: *** IF condition THEN true_clause ELSE false_clause (ENDIF) ***
	   true_clause_start = 3
* try to find "ELSE"
	   DO iarg = 3, num_args
	      IF (cs_text(csp)(arg_start(iarg):arg_end(iarg))
     .						.EQ. 'ELSE' ) THEN
		 has_false_clause   = .TRUE.
	         true_clause_end    = iarg - 1
	         false_clause_start = iarg + 1		         
	         GOTO 200
	      ENDIF
	   ENDDO
	   has_false_clause = .FALSE.

* check for ELIF used in a single line syntax -- trap as a syntax error
* (just out of laziness.  In 15 years no one has asked for this.)
 200	   DO iarg = 3, num_args
	      IF (cs_text(csp)(arg_start(iarg):arg_end(iarg))
     .						.EQ. 'ELIF' ) THEN
	         CALL STACK_PTR_DN( csp, 0, tmp_stat )
	         GOTO 5250
	      ENDIF
	   ENDDO

* is there an implicit or an explicit "ENDIF"?
	   DO 300 iarg = num_args, 3, -1
	      IF (cs_text(csp)(arg_start(iarg):arg_end(iarg))
     .						.EQ. 'ENDIF' 
     .	     .OR. cs_text(csp)(arg_start(iarg):arg_end(iarg))
     .						.EQ. 'ENDI'   ) THEN
	         IF (iarg .NE. num_args ) THEN
	            CALL STACK_PTR_DN( csp, 0, tmp_stat )
	            GOTO 5300
	         ENDIF
	         IF (has_false_clause) THEN
	            false_clause_end = num_args - 1
	         ELSE
	            true_clause_end  = num_args - 1
	         ENDIF
	         GOTO 400
	      ENDIF
 300	   CONTINUE
* ... no - there is no terminating "ENDIF"	   
	   IF (has_false_clause) THEN
	      false_clause_end = num_args
	   ELSE
	      true_clause_end  = num_args
	   ENDIF

* prepare the clause to be executed
 400	   IF ( condition ) THEN
* ... 6/99 bug fix (hack) -- final quotation mark missed in
*	IF 1 THEN SAY "I is too big" ENDIF
*     because arg_start/arg_end are pre-trimmed wrt enclosing quotes
	      iend =  arg_end(true_clause_end)
	      IF     (iend+1 .LE. len_cmnd) THEN
	         IF (cmnd_buff(iend+1:iend+1).EQ.'"') iend = iend + 1
	         IF (iend+4 .LE. len_cmnd) THEN
	            IF (cmnd_buff(iend+1:iend+4).EQ.'_DQ_') iend = iend + 4
	         ENDIF
	      ENDIF
	      cs_text(csp) = cmnd_buff(arg_start(true_clause_start):
     .				       iend)
	   ELSEIF ( has_false_clause ) THEN
* ... 6/99 bug fix (hack) -- final quotation mark missed in
*	IF 1 THEN SAY "I is too big" ENDIF
*     because arg_start/arg_end are pre-trimmed wrt enclosing quotes
	      iend =  arg_end(false_clause_end)
	      IF    (iend+1 .LE. len_cmnd) THEN
	         IF (cmnd_buff(iend+1:iend+1).EQ.'"'   ) iend = iend + 1
	         IF (iend+4 .LE. len_cmnd) THEN
	            IF (cmnd_buff(iend+1:iend+4).EQ.'_DQ_') iend = iend + 4
	         ENDIF
	      ENDIF
	      cs_text(csp) = cmnd_buff(arg_start(false_clause_start):
     .				       iend)
	   ELSE
* ... false condition and no ELSE clause
	      CALL STACK_PTR_DN( csp, 0, tmp_stat )
	      RETURN
	   ENDIF

* tell 'em who owns this level
	   cs_cmnd_num( csp ) = cmnd_if

* only for a single command, though
	   cs_phase(csp) = 0

* tell 'em we've taken over and start workin'
	   cs_in_control = .TRUE.
	   input_source  = input_from_cs
	ELSE

* ***** process a multi-line IF *****
* bump the IF stack
	   IF ( ifstk .GE. max_ifstk ) GOTO 5400
	   ifstk = ifstk + 1

* say which IF clause to execute
	   IF ( condition ) THEN
	      if_doing(ifstk) = pif_doing_clause	! IF TRUE THEN xxx
	   ELSE
	      if_doing(ifstk) = pif_skip_to_clause	! IF FALSE ... ELSE xxx
	   ENDIF

* save where we are in the control stack for error checking
	   if_cs(ifstk) = csp
	   if_conditional = .TRUE.

	ENDIF

	RETURN
	
* error exit
* ... control stack pointer, CSP, corrected in GFD_ERROR_HANDLER
 5000	RETURN
 5100	CALL ERRMSG( ferr_syntax, status, 'IF what ?', *5000)
 5200	CALL ERRMSG( ferr_syntax, status, 'IF without THEN'//
     .			pCR//cmnd_buff(:len_cmnd), *5000 )
 5210	CALL ERRMSG( ferr_syntax, status,
     .	'"IF condition THEN" requires a simple 0 or 1 (or True or False)'//
     .			pCR//cmnd_buff(:len_cmnd), *5000 )
 5250	CALL ERRMSG( ferr_syntax, status,
     .			'ELIF cannot be used in single line IF'//
     .			pCR//cmnd_buff(:len_cmnd), *5000 )
 5300	CALL ERRMSG( ferr_syntax, status, 'Trash after ENDIF'//
     .			pCR//cmnd_buff(:len_cmnd), *5000 )
 5400	CALL ERRMSG( ferr_invalid_command, status, 'IFs nested too deep',
     .							*5000 )
	END

	SUBROUTINE GET_PREC_DIGITS( lo_val, hi_val, small_val, places, right )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine the number of characters and the number of decimal places needed
* to represent the range of data from lo_val to hi_val with precision small_val

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 8/18/87
* revision 0.1 - 7/21/88  - eliminated LOG(0) error in big_10 calculation
* V580 *acm* 12/04 Fix bug 1129; formatting axis for small lon/lat ranges
*                  Note this changes some LIST output by removing a space.
* V600:  1/06 *acm*  prevent values of LOG10(0.0) if small_val = 0 

        IMPLICIT NONE

* calling argument declarations:
	INTEGER		places, right
	REAL		small_val
	REAL*8		lo_val, hi_val

* internal variable declarations:
	INTEGER		big_10, left
	REAL		big

*  left	 - number of digits needed left of decimal
*  right - number of digits needed right of decimal

* decimal places to resolve small_val
	IF ( small_val .GE. 1.0 ) THEN
	   right = 0
	ELSE IF (small_val .EQ. 0.) THEN
           right = 1
        ELSE
	   right = 1 - INT( LOG10(small_val) )

* Change the rounding; if small_val is exactly a power of 10, 
* computtation just abvoe is incorrect. Say if small_val is 0.01, 
* then the computation of right says that 3 digits to the right 
* needed; should be 2.
           IF (INT( LOG10(small_val) ) .EQ. LOG10(small_val) )
     .        right = right - 1
	ENDIF

* integer places to represent the largest label
	big = MAX( ABS(hi_val), ABS(lo_val) )
	IF ( big .EQ. 0 ) THEN
	   left = 1
	ELSE
	   big_10  = INT( LOG10( 1.01*big ) )
	   IF ( big_10 .GT. 0 ) THEN
	      left = big_10 + 1
	   ELSE
	      left = 1			! 0.xxx
	   ENDIF
	   IF ( lo_val .LT. 0 ) left = left + 1	! minus sign
	ENDIF

* total places
	IF ( right .EQ. 0 ) THEN
	   places = left		! xxxx
	ELSE
	   places = left + 1 + right	! xx.xxx
	ENDIF

	RETURN
      END

*
* bin_index_wt.F
*
* Ansley Manke
* October 2002
*
* This function sorts the indicies, and gathers them into bins, along
* with their associated weights.  Returns the weights for each bin, 
* followed by missing-data after the last bin.
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE bin_index_wt_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      CHARACTER*100 fcn_desc
      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns data, gathered into bins on the X axis')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, ABSTRACT, NORMAL, NORMAL, NORMAL)

      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'INDEX')
      CALL ef_set_arg_desc(id, arg, 'Bin indices: sorted, 1D on x axis')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'WT')
      CALL ef_set_arg_desc(id, arg, 'Weight for with each index')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'INDXMAX')
      CALL ef_set_arg_desc(id, arg, 'Maximum index value')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE bin_index_wt_result_limits(id)
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER my_lo_l, my_hi_l
      REAL size

*
*     Use utility functions to get context information about the arguments.
*

      CALL ef_get_one_val(id, ARG3, size)

      my_lo_l = 1
      my_hi_l = INT(size + 1)

      CALL ef_set_axis_limits(id, X_AXIS, my_lo_l, my_hi_l)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


* In this subroutine we compute the result
*
      SUBROUTINE bin_index_wt_compute(id, arg_1, arg_2, arg_3,result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, 
     .           mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, 
     .           mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER id
      INTEGER ndx, m_indx
      INTEGER m, nsrt
      INTEGER i, j, k, l
      INTEGER i1, j1, k1, l1

*  Get subscript ranges

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)


      j1 = arg_lo_ss(Y_AXIS, ARG1)
      k1 = arg_lo_ss(Z_AXIS, ARG1)
      l1 = arg_lo_ss(T_AXIS, ARG1)
      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      l = res_lo_ss(T_AXIS)

      DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
          result(i,j,k,l) = 0.0
  100 CONTINUE

      ndx = res_lo_ss(X_AXIS)
      DO 200 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)
          IF (INT(arg_1(i1,j1,k1,l1)) .EQ. ndx) THEN
              result(ndx,j,k,l) = result(ndx,j,k,l) + arg_2(i1,j1,k1,l1)
          ELSEIF (INT(arg_1(i1,j1,k1,l1)) .GT. 0) THEN
              ndx = INT(arg_1(i1,j1,k1,l1))
              result(ndx,j,k,l) = arg_2(i1,j1,k1,l1)
          ENDIF
  200 CONTINUE

      DO 300 i = ndx+1, res_hi_ss(X_AXIS)
         result(i,j,k,l) = bad_flag_result
  300 CONTINUE
      
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* samplet_date.F
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* This function samples data along the L axis at a set of times: 
* yr,mo,da,hr,min,sec

* 5/20/99  Ansley Manke 
*         Times may be oriented along any axis; 
*         Result is abstract on the sampled axis.
* 3/1/00  ACM fixed bug in definition of the work array datebuf
* 7/2000  ACM inherit axes only from the data variable, not dates!
* 4/2001  *ACM* add error message

*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE samplet_date_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CHARACTER*100 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT 
     .  ('Returns data sampled by interpolating ',
     .   'to a set of times')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 7)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, ABSTRACT,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 3)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'DAT_TO_SAMPLE')
      CALL ef_set_arg_desc(id, arg, 'data to sample at set of times')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, NO, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'YR')
      CALL ef_set_arg_desc(id, arg, 'Year(s) yyyy')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'MO')
      CALL ef_set_arg_desc(id, arg, 'Month(s), integer mm')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'DAY')
      CALL ef_set_arg_desc(id, arg, 'Day(s) of month dd')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'HR')
      CALL ef_set_arg_desc(id, arg, 'Hour(s) hh')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 6
      CALL ef_set_arg_name(id, arg, 'MIN')
      CALL ef_set_arg_desc(id, arg, 'Minute(s) mm')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 7
      CALL ef_set_arg_name(id, arg, 'SEC')
      CALL ef_set_arg_desc(id, arg, 'Second(s) ss')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* loss               lo subscript for an axis
*
* hiss               hi subscript for an axis
*

      SUBROUTINE samplet_date_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER my_lo_l, my_hi_l
      INTEGER nx, ny, nz, nt, ne, nf

*     Use utility functions to get context information about the 
*     2nd argument, to set the abstract axis lo and hi indices.

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nx = arg_hi_ss(X_AXIS, ARG2) - arg_lo_ss(X_AXIS, ARG2) + 1
      ny = arg_hi_ss(Y_AXIS, ARG2) - arg_lo_ss(Y_AXIS, ARG2) + 1
      nz = arg_hi_ss(Z_AXIS, ARG2) - arg_lo_ss(Z_AXIS, ARG2) + 1
      nt = arg_hi_ss(T_AXIS, ARG2) - arg_lo_ss(T_AXIS, ARG2) + 1
      ne = arg_hi_ss(T_AXIS, ARG2) - arg_lo_ss(T_AXIS, ARG2) + 1
      nf = arg_hi_ss(T_AXIS, ARG2) - arg_lo_ss(T_AXIS, ARG2) + 1

*  Use the subscripts for ARG2 for the abstract axis limits; could be on any axis

      my_lo_l = 1
      my_hi_l = MAX(nx,ny,nz,nt,ne,nf)
      CALL ef_set_axis_limits(id, T_AXIS, my_lo_l, my_hi_l)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE samplet_date_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
*
* Set the work arrays, X/Y/Z/T/E/F dimensions
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER mtdat, mt2, mt20
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

*  Use utility functions to get context information about the 1st
*  argument, to set the work arrays for the input argument time axis..

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      mtdat = arg_hi_ss(T_AXIS, ARG1) - arg_lo_ss(T_AXIS, ARG1) + 1
      mt2 = mtdat* 2	! real*8  takes twice what a real*4 does
      mt20 = mtdat* 20	! character*20: character*1 takes 1 byte

*  taxdat (real*8)
      CALL ef_set_work_array_dims_6d(id, 1,
     .                                1, 1, 1, 1, 1, 1,
     .                              mt2, 1, 1, 1, 1, 1)

*  datebuf (character*20)
      CALL ef_set_work_array_dims_6d(id, 2,
     .                                1, 1, 1, 1, 1, 1,
     .                             mt20, 1, 1, 1, 1, 1)

*  date_axis
      CALL ef_set_work_array_dims_6d(id, 3,
     .           arg_lo_ss(T_AXIS,ARG1), 1, 1, 1, 1, 1,
     .           arg_hi_ss(T_AXIS,ARG1), 1, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE samplet_date_compute(id, arg_1, arg_2, arg_3,
     .                             arg_4, arg_5, arg_6, arg_7, result,
     .                            taxdat, datebuf, date_axis)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz, 
     .           mem4lot:mem4hit, mem4loe:mem4hie, mem4lof:mem4hif)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz, 
     .           mem5lot:mem5hit, mem5loe:mem5hie, mem5lof:mem5hif)
      REAL arg_6(mem6lox:mem6hix, mem6loy:mem6hiy, mem6loz:mem6hiz, 
     .           mem6lot:mem6hit, mem6loe:mem6hie, mem6lof:mem6hif)
      REAL arg_7(mem7lox:mem7hix, mem7loy:mem7hiy, mem7loz:mem7hiz, 
     .           mem7lot:mem7hit, mem7loe:mem7hie, mem7lof:mem7hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

      REAL*8 taxdat(wrk1lox:wrk1hix/2, wrk1loy:wrk1hiy,
     .              wrk1loz:wrk1hiz, wrk1lot:wrk1hit,
     .              wrk1loe:wrk1hie, wrk1lof:wrk1hif)
      CHARACTER*20 datebuf(wrk2lox:wrk2hix/20, wrk2loy:wrk2hiy,
     .                     wrk2loz:wrk2hiz, wrk2lot:wrk2hit,
     .                     wrk2loe:wrk2hie, wrk2lof:wrk2hif)
      REAL date_axis(wrk3lox:wrk3hix, wrk3loy:wrk3hiy,
     .               wrk3loz:wrk3hiz, wrk3lot:wrk3hit,
     .               wrk3loe:wrk3hie, wrk3lof:wrk3hif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER iarg
      INTEGER i, j, k, l, m, n
      INTEGER arg
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2
      INTEGER i3, j3, k3, l3, m3, n3
      INTEGER i4, j4, k4, l4, m4, n4
      INTEGER i5, j5, k5, l5, m5, n5
      INTEGER i6, j6, k6, l6, m6, n6
      INTEGER i7, j7, k7, l7, m7, n7
      INTEGER mnth, numtimes
      INTEGER lbot, ltop, status
      REAL ayr, amo, ada, ahr, amn, asc
      REAL byr, bmo, bda, bhr, bmn, bsc
      REAL tbot, ttop, timepoint, frac

      CHARACTER*100 errtxt

      CHARACTER*3 months(12), cmon
      DATA months/'JAN', 'FEB', 'MAR', 'APR', 'MAY', 'JUN',
     .            'JUL', 'AUG', 'SEP', 'OCT', 'NOV', 'DEC'/

  20  FORMAT (f2.0, 1x, a3, 1x, f4.0, 3(1x,f2.0))

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      iarg = 1
      CALL ef_get_coordinates (id, ARG1, T_AXIS, 
     .       arg_lo_ss(T_AXIS, ARG1), arg_hi_ss(T_AXIS, ARG1), taxdat)

      numtimes = arg_hi_ss(T_AXIS, ARG1) - arg_lo_ss(T_AXIS, ARG1) + 1
      CALL ef_get_axis_dates (id, ARG1, taxdat, numtimes, datebuf)

      l1 = arg_lo_ss(T_AXIS,ARG1)
      DO 60 l = 1, numtimes
         READ (datebuf(l,1,1,1,1,1), 20, err=900) bda, cmon, byr,
     .                                            bhr, bmn, bsc
         bmo = 0
         DO 40 mnth = 1, 12
            IF ( cmon .eq. months(mnth) ) bmo = mnth
   40    CONTINUE
         CALL day_of_year(bmo, bda, byr, status, errtxt)
         IF (status .NE. 0) GO TO 1000
         bmn = bmn + bsc/ 60.
         bhr = bhr + bmn/ 60.
         bda = bda + bhr/ 24.
         date_axis(l1,1,1,1,1,1) = byr + bda / 365.2425
         l1 = l1 + arg_incr(T_AXIS,ARG1)
   60 CONTINUE

      l2 = arg_lo_ss(T_AXIS,ARG2)
      l3 = arg_lo_ss(T_AXIS,ARG3)
      l4 = arg_lo_ss(T_AXIS,ARG4)
      l5 = arg_lo_ss(T_AXIS,ARG5)
      l6 = arg_lo_ss(T_AXIS,ARG6)
      l7 = arg_lo_ss(T_AXIS,ARG7)
      DO  400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

*  Get the time to sample, whichever axis of arg_2 thru arg_7 it is on.

         CALL pickindex(arg_2, l, ayr)
         CALL pickindex(arg_3, l, amo)
         CALL pickindex(arg_4, l, ada)
         CALL pickindex(arg_5, l, ahr)
         CALL pickindex(arg_6, l, amn)
         CALL pickindex(arg_7, l, asc)

*  Check that we do have a valid time.

         lbot = 0
         IF (ayr .NE. bad_flag(ARG2) .AND. 
     .       amo .NE. bad_flag(arg3) .AND. 
     .       ada .NE. bad_flag(arg4) .AND. 
     .       ahr .NE. bad_flag(arg5) .AND. 
     .       amn .NE. bad_flag(arg6) .AND. 
     .       asc .NE. bad_flag(arg7) ) THEN

            CALL day_of_year(amo, ada, ayr, status, errtxt)
            IF (status .NE. 0) GO TO 1000

            amn = amn + asc/ 60.
            ahr = ahr + amn/ 60.
            ada = ada + ahr/ 24.
            timepoint = ayr + ada / 365.2425

*  Search the 1st argument for the points before and after the requested time,
*  interpolate to set the result.

            DO 80 l1 = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)
               IF (timepoint .GE. date_axis(l1,1,1,1,1,1)) lbot = l1
   80       CONTINUE
            ltop = lbot + 1

            IF (lbot .GE. arg_lo_ss(T_AXIS,ARG1)  .AND. 
     .          ltop .LE. arg_hi_ss(T_AXIS,ARG1)) THEN

               tbot = date_axis(lbot,1,1,1,1,1)
               ttop = date_axis(ltop,1,1,1,1,1)
               frac = (timepoint - tbot) / (ttop - tbot)
            ENDIF

         ENDIF

*  Loop over all space and interpolate.
  
         n1 = arg_lo_ss(F_AXIS,ARG1)
         n2 = arg_lo_ss(F_AXIS,ARG2)
         n3 = arg_lo_ss(F_AXIS,ARG3)
         n4 = arg_lo_ss(F_AXIS,ARG4)
         n5 = arg_lo_ss(F_AXIS,ARG5)
         n6 = arg_lo_ss(F_AXIS,ARG6)
         n7 = arg_lo_ss(F_AXIS,ARG7)
         DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

         m1 = arg_lo_ss(E_AXIS,ARG1)
         m2 = arg_lo_ss(E_AXIS,ARG2)
         m3 = arg_lo_ss(E_AXIS,ARG3)
         m4 = arg_lo_ss(E_AXIS,ARG4)
         m5 = arg_lo_ss(E_AXIS,ARG5)
         m6 = arg_lo_ss(E_AXIS,ARG6)
         m7 = arg_lo_ss(E_AXIS,ARG7)
         DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

         k1 = arg_lo_ss(Z_AXIS,ARG1)
         k2 = arg_lo_ss(Z_AXIS,ARG2)
         k3 = arg_lo_ss(Z_AXIS,ARG3)
         k4 = arg_lo_ss(Z_AXIS,ARG4)
         k5 = arg_lo_ss(Z_AXIS,ARG5)
         k6 = arg_lo_ss(Z_AXIS,ARG6)
         k7 = arg_lo_ss(Z_AXIS,ARG7)
         DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

            j1 = arg_lo_ss(Y_AXIS,ARG1)
            j2 = arg_lo_ss(Y_AXIS,ARG2)
            j3 = arg_lo_ss(Y_AXIS,ARG3)
            j4 = arg_lo_ss(Y_AXIS,ARG4)
            j5 = arg_lo_ss(Y_AXIS,ARG5)
            j6 = arg_lo_ss(Y_AXIS,ARG6)
            j7 = arg_lo_ss(Y_AXIS,ARG7)
            DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

               i1 = arg_lo_ss(X_AXIS, ARG1)
               i2 = arg_lo_ss(X_AXIS, ARG2)
               i3 = arg_lo_ss(X_AXIS, ARG3)
               i4 = arg_lo_ss(X_AXIS, ARG4)
               i5 = arg_lo_ss(X_AXIS, ARG5)
               i6 = arg_lo_ss(X_AXIS, ARG6)
               i7 = arg_lo_ss(X_AXIS, ARG7)
               DO  100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS) 

                  IF ( lbot .GE. arg_lo_ss(T_AXIS,ARG1) .AND. 
     .                 ltop .LE. arg_hi_ss(T_AXIS,ARG1) ) THEN
                     IF ( arg_1(i1,j1,k1,lbot,m1,n1) 
     .                          .NE. bad_flag(ARG1)     .AND.
     .                    arg_1(i1,j1,k1,ltop,m1,n1)
     .                          .NE. bad_flag(ARG1) )     THEN
                        result(i,j,k,l,m,n) = 
     .                        arg_1(i1,j1,k1,lbot,m1,n1) + 
     .                        frac * ( arg_1(i1,j1,k1,ltop,m1,n1) -
     .                                 arg_1(i1,j1,k1,lbot,m1,n1)  )
                     ELSE
                        result(i,j,k,l,m,n) = bad_flag_result
                     ENDIF
                  ELSE
                     result(i,j,k,l,m,n) = bad_flag_result
                  ENDIF

                  i1 = i1 + arg_incr(X_AXIS,ARG1)
                  i2 = i2 + arg_incr(X_AXIS,ARG2)
                  i3 = i3 + arg_incr(X_AXIS,ARG3)
                  i4 = i4 + arg_incr(X_AXIS,ARG4)
                  i5 = i5 + arg_incr(X_AXIS,ARG5)
                  i6 = i6 + arg_incr(X_AXIS,ARG6)
                  i7 = i7 + arg_incr(X_AXIS,ARG7)
  100          CONTINUE

               j1 = j1 + arg_incr(Y_AXIS,ARG1)
               j2 = j2 + arg_incr(Y_AXIS,ARG2)
               j3 = j3 + arg_incr(Y_AXIS,ARG3)
               j4 = j4 + arg_incr(Y_AXIS,ARG4)
               j5 = j5 + arg_incr(Y_AXIS,ARG5)
               j6 = j6 + arg_incr(Y_AXIS,ARG6)
               j7 = j7 + arg_incr(Y_AXIS,ARG7)
  200       CONTINUE

            k1 = k1 + arg_incr(Z_AXIS,ARG1)
            k2 = k2 + arg_incr(Z_AXIS,ARG2)
            k3 = k3 + arg_incr(Z_AXIS,ARG3)
            k4 = k4 + arg_incr(Z_AXIS,ARG4)
            k5 = k5 + arg_incr(Z_AXIS,ARG5)
            k6 = k6 + arg_incr(Z_AXIS,ARG6)
            k7 = k7 + arg_incr(Z_AXIS,ARG7)
  300    CONTINUE

            m1 = m1 + arg_incr(E_AXIS,ARG1)
            m2 = m2 + arg_incr(E_AXIS,ARG2)
            m3 = m3 + arg_incr(E_AXIS,ARG3)
            m4 = m4 + arg_incr(E_AXIS,ARG4)
            m5 = m5 + arg_incr(E_AXIS,ARG5)
            m6 = m6 + arg_incr(E_AXIS,ARG6)
            m7 = m7 + arg_incr(E_AXIS,ARG7)
  500    CONTINUE

            n1 = n1 + arg_incr(F_AXIS,ARG1)
            n2 = n2 + arg_incr(F_AXIS,ARG2)
            n3 = n3 + arg_incr(F_AXIS,ARG3)
            n4 = n4 + arg_incr(F_AXIS,ARG4)
            n5 = n5 + arg_incr(F_AXIS,ARG5)
            n6 = n6 + arg_incr(F_AXIS,ARG6)
            n7 = n7 + arg_incr(F_AXIS,ARG7)
  600    CONTINUE

* End of loop over all space; go on to next specified time

         l2 = l2 + arg_incr(T_AXIS,ARG2)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
         l3 = l3 + arg_incr(T_AXIS,ARG3)
         l4 = l4 + arg_incr(T_AXIS,ARG4)
         l5 = l5 + arg_incr(T_AXIS,ARG5)
         l6 = l6 + arg_incr(T_AXIS,ARG6)
         l7 = l7 + arg_incr(T_AXIS,ARG7)
  400 CONTINUE

      RETURN 

  900 WRITE (errtxt,*) 'error reading date buffer ', 
     .                 l, datebuf(l1,1,1,1,1,1)
 1000 CALL EF_BAIL_OUT(id, errtxt)
      RETURN
      END

	SUBROUTINE DEALLO_ALL_GRIDS

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* deallocate all scratch space from the grid COMMON stack
* (9/95) also deallocate any dynamic grids that were in progress
* (used following error conditions)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  6/22/89
* V230:  7/24/92 - bug fix: loop index (igrid)  wasn't used inside loop
*                           grd_stk_ptr was!
* V420:  9/20/95 - deallocate dynamic grids, too
*Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'interp_stack.parm'
	include 'xprog_state.cmn'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xfr_grid.cmn'

* internal variable declarations
	INTEGER	igrid, i, cx, status

* deallocate the temporary grids from the upper grid stack
* (see documentation in tm_allo_dyn_grid)
* this may occasionally also deallocate associated dynamic axes
	DO 100 igrid = grd_stk_ptr, max_grids-1
	   CALL DEALLO_GRID(status)
	   IF ( status .NE. ferr_ok ) THEN	
	      grd_stk_ptr = max_grids
	      GOTO 150			! internal error!!
	   ENDIF
 100	CONTINUE

* Deallocate any dynamic grid (and associated memory vars) the need for which
* has been terminated by this error condition.
* A record of all of the dynamic grids in progress is implicitly available
* on the interpretation stack.
 150 	DO 200 cx = cx_stack_ptr, cx_stack_ptr_base, -1
	   IF ( cx_has_impl_grid(cx) .AND. cx_grid(cx).GT.max_grids) THEN
	      CALL DEALLO_DYN_GRID(cx_grid(cx))
	      cx_has_impl_grid(cx) = .FALSE.
	   ENDIF
 200	CONTINUE

	RETURN
	END

	SUBROUTINE SORT_FMRC_DSETS (nsets_in, member_sets, maxmembers,
     .				    nsets_out, nt_out, status)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* NOAA/PMEL, Seattle, WA - TMAP 

* sort the given list of datasets based upon the starting time steps
* and insert dummy dataset where the forecast sequence has gaps
*
* V698 *sh* 11/15 
*            2/16 -- allow missing datasets among nsets_in
*            3/16 -- bug fix in epsilon used to screen bad gaps

* calling arguments
*   nsets_in		- number of datasets given to be aggregated (input)
*   member_sets		- array of open dataset numbers (input-output)
*   maxmembers		- maximum number of members allowes (input)
*   nsets_out		- number of datasets including dummy fillers (output)
*   nt_out		- time ax len (in case inconsistent) (output)
*   status		- return staus (output)

        IMPLICIT NONE
        include 'tmap_errors.parm'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
        include 'xprog_state.cmn'
	include 'xtm_grid.cmn_text'  
	include 'errmsg.parm'
	include 'netcdf.inc'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xfr_grid.cmn'
	include 'xdiag_ctrl.cmn_text'

* calling argument declarations:
	INTEGER nsets_in, nsets_out, nt_out,
     .		maxmembers, member_sets(maxmembers)

* local variable declarations:
	LOGICAL alteredDelta
	INTEGER	ivar, grid, grid1, iset, dset, dset1, taxis, taxis1,
     .		status, nadded, ngap, i, nsets, itmp_memb(maxmembers),
     .		deltaFactor
	REAL TDEST_WORLD, TM_WORLD, d, epsilon, gap, deltaT, deltaT_0,
     .		start_time(maxmembers), rindices(maxmembers),
     .		d_ratio, d_ratio_int
	CHARACTER LEFINT*8

* initialize
	dset1  = member_sets(1)
	taxis1 = ds_time_axis(dset1)
	nt_out = line_dim(taxis1)
	status = ferr_ok
	IF (nsets_in .LE. 1) RETURN

* since forecast series must be regular, and the code below
* is able to detect gaps in the list of forecasts given,we
* will simply remove the user-specified gaps, knowing they
* will be re-inserted automatically
	ngap = 0
	iset = 1
	DO WHILE (iset+ngap .LT. nsets_in)
	   IF (member_sets(iset) .EQ. pdset_dummy) THEN
	      ngap = ngap + 1
	   ELSE
	      iset = iset + 1
	   ENDIF
	   member_sets(iset) = member_sets(iset+ngap)
	ENDDO
	nsets = nsets_in - ngap
	nsets_out = nsets

* locate a variable in the first dataset that uses this time axis
	DO ivar = 1, maxvars
           IF ( ds_var_setnum(ivar) .NE. dset1 ) CYCLE
	   grid1 = ds_grid_number(ivar)
	   IF (grid_line(t_dim,grid1) .EQ. taxis1) GOTO 100
	ENDDO
	GOTO 5100

* loop through the datasets extracting the start time from each one
* Apply the T0 encoding of the first dataset to all
 100	start_time(1) = TM_WORLD( 1, grid1, t_dim, box_middle )
	DO iset = 2, nsets
	   dset  = member_sets(iset)
	   taxis = ds_time_axis(dset)
           IF (line_name_orig(taxis) .NE. line_name_orig(taxis1)) GOTO 5100
	   
* ... length of T axis in the aggregation will be the MIN of all members
	   IF (line_dim(taxis) .LT. nt_out) nt_out = line_dim(taxis)

* ... locate a variable in the first dataset that uses this time axis
	   DO ivar = 1, maxvars
              IF ( ds_var_setnum(ivar) .NE. dset ) CYCLE
	      grid = ds_grid_number(ivar)
	      IF (grid_line(t_dim,grid) .EQ. taxis) GOTO 200
	   ENDDO
	   GOTO 5100

* ... save the start time of this dataset
 200	   CALL TDEST_WORLD_INIT (grid, grid1, t_dim, status)
	   IF (status .NE. ferr_ok) GOTO 5100 
	   start_time(iset) = TDEST_WORLD(1, grid, t_dim, box_middle)
	ENDDO

* sort the dates and the dataset list
* ... put indices into REAL array
	DO iset = 1, nsets
	   rindices(iset) = iset
	ENDDO
	CALL HEAP2(start_time, rindices, unspecified_val8, nsets)
* ... reorder the dataset numbers to match the sort
	DO iset = 1, nsets
	   itmp_memb(iset) = member_sets(NINT(rindices(iset)))
	ENDDO
* ... copy the sorted list back into the input array
	DO iset = 1, nsets
	   member_sets(iset) = itmp_memb(iset)
	ENDDO

* determine the intended delta-T between the (ordered) forecasts
* ... first get the minimum delta-T
	deltaT_0 = start_time(2) - start_time(1)
	DO iset = 2, nsets
	   d = start_time(iset)-start_time(iset-1)
	   IF ( d .LT. deltaT_0) deltaT_0 = d
	ENDDO
	IF (deltaT_0 .EQ. 0.0) GOTO 5250

* for monthly data delta-T may vary from 28 to 31, so allow a margin of error
	epsilon = 1.0001 * (31.-28.)/28.

* now re-evaluate the deltas to find the lowest common denominator
* i.e. if we discover there is a gap of size 1.5*deltaT, that means that
* the correct delta is new_delta= 0.5*deltaT.  This re-interprets our two
* gaps as 2*new_delta and 3*new_delta
	deltaFactor = 1
	deltaT = deltaT_0
	alteredDelta = .TRUE.
	DO WHILE (alteredDelta)
	   alteredDelta = .FALSE.
	   DO iset = 2, nsets
	      d = start_time(iset)-start_time(iset-1)
	      d_ratio = d/deltaT
* delta ratio must be an integer within epsilon threshold
	      d_ratio_int = FLOAT(INT(d_ratio + 0.49))
	      IF (ABS(d_ratio-d_ratio_int)/d_ratio .GT. epsilon) THEN
* ... we have the wrong deltaT -- try an integer fraction of it
	         deltaFactor = deltaFactor + 1
	         IF (deltaFactor .GT. 4) GOTO 5200
	         deltaT = deltaT_0 / deltaFactor
	         alteredDelta = .TRUE.
	         EXIT    ! try again with smaller delta
	      ENDIF
	   ENDDO
	ENDDO

* loop through the data set list inserting dummys where there are gaps
	ngap = 0    ! not needed?
	nadded = 0
	iset = 1
	DO WHILE (iset .LT. nsets_out)
	   iset = iset + 1
	   d = start_time(iset)-start_time(iset-1)
	   IF (ABS(d-deltaT)/deltaT .GT. epsilon) THEN
* ... we have a gap (or at least an irregularity)
	      gap = d/deltaT
	      ngap = INT(gap + 0.5)      ! here ngap=1 means nothing missing
	      ngap = ngap - 1		 ! now  ngap=0 means nothing missing
	      nsets_out = nsets_out + ngap
	      IF (nsets_out .GT. maxmembers) THEN
	         nsets_out = maxmembers   ! needed to clean up files after err
	         GOTO 5200
	      ENDIF
*     ... open the gap
	      DO i = nsets_out, iset+ngap, -1
	         member_sets(i) = member_sets(i-ngap)
	         start_time (i) = start_time (i-ngap)
	      ENDDO
*     ... fill the gap
	      DO i = iset, iset+ngap-1
	         member_sets(i) = pdset_dummy
	      ENDDO
	      iset = iset + ngap
	   ENDIF
	ENDDO

	RETURN

* error exits
 5000	RETURN
 5100	CALL WARN(
     .		'Unable to sort forecast datasets due to corrupted times.')
	GOTO 5000
 5200	CALL ERRMSG( ferr_aggregate_error, status,
     .		'forecast start times are irregular or too gappy', *5000 )
 5250	CALL ERRMSG( ferr_aggregate_error, status,
     .		'some files have duplicate forecast start times', *5000 )

	END

! rect_to_curv.F
! 
! renamed from hinterp_bilinear.F  
! From Matt Harrison hinterp.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
! to CALL only the bilinear interpolation modules, and
! recast in F77-compileable code.
! ACM 3/2004
!
! mjh@gfdl.gov
! 2/20/2003
!  
! 11/19/2007 fix bug 1553 looping over k,l
! 03/22/2016 fix error message, source longigude within 2*pi
! 
! In this subroutine we provide information about
! the function.  The user configurable information 
! consists of the following:
!
! descr              Text description of the function
!
! num_args           Required number of arguments
!
! axis_inheritance   Type of axis for the result
!                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
!                       CUSTOM          - user defined axis
!                       IMPLIED_BY_ARGS - same axis as the incoming argument
!                       NORMAL          - the result is normal to this axis
!                       ABSTRACT        - an axis which only has index values
!
! piecemeal_ok       For memory optimization:
!                       axes where calculation may be performed piecemeal
!                       ( YES, NO )
! 
!
! For each argument we provide the following information:
!
! name               Text name for an argument
!
! unit               Text units for an argument
!
! desc               Text description of an argument
!
! axis_influence     Are this argument's axes the same as the result grid?
!                       ( YES, NO )
!
! axis_extend       How much does Ferret need to extend arg limits relative to result 
!


      SUBROUTINE rect_to_curv_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER   id, arg

!**********************************************************************
!                                           USER CONFIGURABLE PORTION |
!                                                                     |
!                                                                     V

      CHARACTER*100  descr

      CALL ef_set_desc(id,
     .  'Regrid from rectangular to curvilinear grid')
      CALL ef_set_num_args(id, 4)
      CALL ef_set_num_work_arrays(id, 8)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'V')
      CALL ef_set_arg_desc(id, arg,
     ,  'variable V(x,y,z,t,e,f) on rectilinear grid')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'lon_bounds_out')
      CALL ef_set_arg_unit(id, arg, 'degrees')
      CALL ef_set_arg_desc(id, arg, 
     .  'Destination curvilinear grid longitude bounds(2-D)')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'lat_bounds_out')
      CALL ef_set_arg_unit(id, arg, 'degrees')
      CALL ef_set_arg_desc(id, arg, 
     .  'Destination curvilinear grid latitude bounds(2-D)')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, NO, NO, NO, NO)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'missing_allowed')
      WRITE (descr, 20)
   20 FORMAT ('number of missing values allowed in four ',
     .        'surrounding source cells: 0 to 3')
      CALL ef_set_arg_desc(id, arg, descr)
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

!                                                                     ^
!                                                                     |
!                                           USER CONFIGURABLE PORTION |
!***********************************************************************

      RETURN 
      END  ! subroutine rect_to_curv_init

*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE rect_to_curv_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work array X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*
      INTEGER array_num, nx, ny
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

*   real wti(nlon_dst,nlat_dst,2)      
*   weights for bilinear interpolation 

      array_num = 1
      CALL ef_set_work_array_dims_6d(id, array_num,
     .     arg_lo_ss(X_AXIS,ARG3), arg_lo_ss(Y_AXIS,ARG3), 1, 1, 1, 1,
     .     arg_hi_ss(X_AXIS,ARG3), arg_hi_ss(Y_AXIS,ARG3), 2, 1, 1, 1)
     
*  real wtj(nlon_dst,nlat_dst,2)      
*  weights for bilinear interpolation 

      array_num = 2
      CALL ef_set_work_array_dims_6d(id, array_num,
     .     arg_lo_ss(X_AXIS,ARG3), arg_lo_ss(Y_AXIS,ARG3), 1, 1, 1, 1,
     .     arg_hi_ss(X_AXIS,ARG3), arg_hi_ss(Y_AXIS,ARG3), 2, 1, 1, 1)

*  real*8 in_lon_lat(max(nlat_src+1, nlon_src+1), 2) 
*  edges of x,y input axes, will be declared real*8
      array_num = 3
      nx = arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 2
      ny = arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1) + 2
      nx = MAX(nx,ny)
      CALL ef_set_work_array_dims_6d(id, array_num,
     .                                1, 1, 1, 1, 1, 1,
     .                             2*nx, 4, 1, 1, 1, 1)

*  real rad_lon_lat(max(nlat_src+1, nlon_src+1), 2) 
*  edges of input axes, will be declared real, converted to radians

      array_num = 4
      CALL ef_set_work_array_dims_6d(id, array_num,
     .                                1, 1, 1, 1, 1, 1,
     .                               nx, 2, 1, 1, 1, 1)

*  real out_lon(nlon_dst, nlat_dst)  
*  edges of output longitude grid, will be converted to radians

      array_num = 5
      nx = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1
      ny = arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) + 1
      CALL ef_set_work_array_dims_6d(id, array_num,
     .                                1,  1, 1, 1, 1, 1,
     .                               nx, ny, 1, 1, 1, 1)

*  real out_lat(nlon_dst, nlat_dst)      
*  edges of output latitude grid, will be converted to radians

      array_num = 6
      nx = arg_hi_ss(X_AXIS,ARG3) - arg_lo_ss(X_AXIS,ARG3) + 1
      ny = arg_hi_ss(Y_AXIS,ARG3) - arg_lo_ss(Y_AXIS,ARG3) + 1
      CALL ef_set_work_array_dims_6d(id, array_num,
     .                                1,  1, 1, 1, 1, 1,
     .                               nx, ny, 1, 1, 1, 1)

*  integer i_lon(nlon_dst,nlat_dst,2) 
* indices for bilinear interpolation 
* These will be declared integer inside the compute routine

      array_num = 7
      CALL ef_set_work_array_dims_6d(id, array_num,
     .     arg_lo_ss(X_AXIS,ARG3), arg_lo_ss(Y_AXIS,ARG3), 1, 1, 1, 1,
     .     arg_hi_ss(X_AXIS,ARG3), arg_hi_ss(Y_AXIS,ARG3), 2, 1, 1, 1)

*  integer j_lat(nlon_dst,nlat_dst,2) 
*  indices for bilinear interpolation 
*  These will be declared integer inside the compute routine

      array_num = 8
      CALL ef_set_work_array_dims_6d(id, array_num,
     .     arg_lo_ss(X_AXIS,ARG3), arg_lo_ss(Y_AXIS,ARG3), 1, 1, 1, 1,
     .     arg_hi_ss(X_AXIS,ARG3), arg_hi_ss(Y_AXIS,ARG3), 2, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


!
! In this subroutine we compute the result
!
      SUBROUTINE rect_to_curv_compute(id, arg_1, arg_2, arg_3, 
     .          arg_4, result, wti, wtj, in_lon_lat,
     .          rad_lon_lat, out_lon, out_lat, i_lon, j_lat)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz, 
     .           mem4lot:mem4hit, mem4loe:mem4hie, mem4lof:mem4hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

      REAL wti(wrk1lox:wrk1hix, wrk1loy:wrk1hiy,
     .         wrk1loz:wrk1hiz, wrk1lot:wrk1hit,
     .         wrk1loe:wrk1hie, wrk1lof:wrk1hif)
      REAL wtj(wrk2lox:wrk2hix, wrk2loy:wrk2hiy,
     .         wrk2loz:wrk2hiz, wrk2lot:wrk2hit,
     .         wrk2loe:wrk2hie, wrk2lof:wrk2hif)
      REAL*8 in_lon_lat(wrk3lox:wrk3hix/2, wrk3loy:wrk3hiy,
     .                  wrk3loz:wrk3hiz, wrk3lot:wrk3hit,
     .                  wrk3loe:wrk3hie, wrk3lof:wrk3hif)
      REAL rad_lon_lat(wrk4lox:wrk4hix, wrk4loy:wrk4hiy,
     .                 wrk4loz:wrk4hiz, wrk4lot:wrk4hit,
     .                 wrk4loe:wrk4hie, wrk4lof:wrk4hif)
      REAL out_lon(wrk5lox:wrk5hix, wrk5loy:wrk5hiy,
     .             wrk5loz:wrk5hiz, wrk5lot:wrk5hit,
     .             wrk5loe:wrk5hie, wrk5lof:wrk5hif)
      REAL out_lat(wrk6lox:wrk6hix, wrk6loy:wrk6hiy,
     .             wrk6loz:wrk6hiz, wrk6lot:wrk6hit,
     .             wrk6loe:wrk6hie, wrk6lof:wrk6hif)
      INTEGER i_lon(wrk7lox:wrk7hix, wrk7loy:wrk7hiy,
     .              wrk7loz:wrk7hiz, wrk7lot:wrk7hit,
     .              wrk7loe:wrk7hie, wrk7lof:wrk7hif)
      INTEGER j_lat(wrk8lox:wrk8hix, wrk8loy:wrk8hiy,
     .              wrk8loz:wrk8hiz, wrk8lot:wrk8hit,
     .              wrk8loe:wrk8hie, wrk8lof:wrk8hif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

!**********************************************************************
!                                           USER CONFIGURABLE PORTION |
!                                                                     |
!                                                                     V

      INTEGER  idim, i, j, k, l, m, n, verbose
      INTEGER  i1, j1, k1, l1, m1, n1, nx, ny,
     .         nlon_src, nlat_src, nlon_dst, nlat_dst
      REAL missing_permit, pi, pi180
      CHARACTER*16 axname(6), ax_units(6) 
      LOGICAL back(6), modulo(6), reg(6), its_dsg

      CHARACTER*128 err_msg

* Does the variable come from a Discrete Sampling Geometries dataset?  
* If so the function doesn't apply.

      CALL EF_GET_ITS_DSG(id, ARG1, its_dsg )
      IF (its_dsg) THEN
         err_msg = 
     . 'Data is from a Discrete Sampling Geometries (DSG) dataset. Function does not apply.'
	GOTO 999
      ENDIF

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id,bad_flag,bad_flag_result)

! Get edges of coordinate boxes on input axes.  Convert to radians.

      pi =  4.*ATAN(1.)
      pi180 = pi/ 180.

      CALL ef_get_box_limits(id, ARG1, X_AXIS,
     .                       arg_lo_ss(X_AXIS, ARG1), 
     .                       arg_hi_ss(X_AXIS, ARG1), 
     .                       in_lon_lat(1,1,1,1,1,1),
     .                       in_lon_lat(1,3,1,1,1,1))

! last box upper limit
      nx = arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 1
      in_lon_lat(nx+1,1,1,1,1,1) = in_lon_lat(nx,3,1,1,1,1)

c      idim = 1
c      CALL EF_GET_COORDINATES (id, arg, idim,
c     .     arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)+1, 
c     .     in_lon_lat(1,1,1,1) )

! Transform degrees to radians

      nx = arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 2
      DO i = 1, nx
        rad_lon_lat(i,1,1,1,1,1) = pi180 * in_lon_lat(i,1,1,1,1,1)
      ENDDO

      CALL ef_get_box_limits(id, ARG1, Y_AXIS,
     .                       arg_lo_ss(Y_AXIS, ARG1), 
     .                       arg_hi_ss(Y_AXIS, ARG1), 
     .                       in_lon_lat(1,2,1,1,1,1),
     .                       in_lon_lat(1,4,1,1,1,1))

! last box upper limit
      ny = arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1) + 1
      in_lon_lat(ny+1,2,1,1,1,1) = in_lon_lat(ny,4,1,1,1,1)

c      idim = 2
c      CALL EF_GET_COORDINATES (id, arg, idim,
c     .     arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)+1, 
c     .     in_lon_lat(1,2,1,1) )

! Transform degrees to radians

      ny = arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1) + 2
      DO i = 1, ny
        rad_lon_lat(i,2,1,1,1,1) = pi180 * in_lon_lat(i,2,1,1,1,1)
      ENDDO

      n = arg_lo_ss(F_AXIS,ARG2)
      m = arg_lo_ss(E_AXIS,ARG2)
      l = arg_lo_ss(T_AXIS,ARG2)
      k = arg_lo_ss(Z_AXIS,ARG2)
      DO j = arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS,ARG2)
         DO i = arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS,ARG2)
            out_lon(i,j,1,1,1,1) = pi180 * arg_2(i,j,k,l,m,n)
         ENDDO
      ENDDO

      n = arg_lo_ss(F_AXIS,ARG3)
      m = arg_lo_ss(E_AXIS,ARG3)
      l = arg_lo_ss(T_AXIS,ARG3)
      k = arg_lo_ss(Z_AXIS,ARG3)
      DO j = arg_lo_ss(Y_AXIS,ARG3), arg_hi_ss(Y_AXIS,ARG3)
         DO i = arg_lo_ss(X_AXIS,ARG3), arg_hi_ss(X_AXIS,ARG3)
            out_lat(i,j,1,1,1,1) = pi180 * arg_3(i,j,k,l,m,n)
         ENDDO
      ENDDO

      CALL ef_get_axis_info_6d(id,ARG1,axname,ax_units,back,modulo,reg)

! Number of missing cells to allow (0 to 3)

      CALL ef_get_one_val (id, ARG4, missing_permit)
      IF (missing_permit .LT. 0 .OR. missing_permit .GT. 3) 
     .    CALL ef_bail_out (id, 'argument 6 must be between 0 and 3')

! nlon_src and nlat_src without the extra element for upper grid box (why?)

      nlon_src = nx-1
      nlat_src = ny-1
      nlon_dst = arg_hi_ss(X_AXIS,ARG3) - arg_lo_ss(X_AXIS,ARG3) + 1
      nlat_dst = arg_hi_ss(Y_AXIS,ARG3) - arg_lo_ss(Y_AXIS,ARG3) + 1

      verbose = 0
      CALL horiz_interp_init_bili (id, wti, wtj, i_lon, j_lat,
     .           nlon_src, nlat_src, nlon_dst, nlat_dst,
     .           rad_lon_lat(1,1,1,1,1,1), rad_lon_lat(1,2,1,1,1,1),
     .           out_lon, out_lat, verbose, modulo(1) )

      i1 = arg_lo_ss(X_AXIS,ARG1)
      j1 = arg_lo_ss(Y_AXIS,ARG1)

      i = res_lo_ss(X_AXIS)
      j = res_lo_ss(Y_AXIS)

      n1 = arg_lo_ss(F_AXIS,ARG1)
      DO n = res_lo_ss(F_AXIS),res_hi_ss(F_AXIS)

      m1 = arg_lo_ss(E_AXIS,ARG1)
      DO m = res_lo_ss(E_AXIS),res_hi_ss(E_AXIS)

      l1 = arg_lo_ss(T_AXIS,ARG1)
      DO l = res_lo_ss(T_AXIS),res_hi_ss(T_AXIS)

         k1 = arg_lo_ss(Z_AXIS,ARG1)
         DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

            CALL horiz_interp_bili ( wti, wtj, i_lon, j_lat,
     .                 nlon_src, nlat_src, nlon_dst, nlat_dst,
     .                 arg_1(i1,j1,k1,l1,m1,n1), result(i,j,k,l,m,n),
     .                 verbose, bad_flag(ARG1), bad_flag_result,
     .                 missing_permit)

            k1 = k1 + arg_incr(Z_AXIS,ARG1)
         ENDDO

         l1 = l1 + arg_incr(T_AXIS,ARG1)
      ENDDO

         m1 = m1 + arg_incr(E_AXIS,ARG1)
      ENDDO

         n1 = n1 + arg_incr(F_AXIS,ARG1)
      ENDDO

!                                                                     ^
!                                                                     |
!                                           USER CONFIGURABLE PORTION |
!**********************************************************************


      RETURN 
      
 999  CALL ef_bail_out (id, err_msg)

      RETURN 

      END  ! subroutine rect_to_curv_compute

* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*    horiz_interp_init_bili

! From module hinterp_subs_mod


! <CONTACT EMAIL='bw@gfdl.noaa.gov'>
!   Bruce Wyman
! </CONTACT>

! <HISTORY SRC='http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/'/>

! <OVERVIEW>
!   Performs spatial interpolation between grids.
! </OVERVIEW>

! <DESCRIPTION>
!     This module can interpolate data from rectangular/tripolar grid
!     to rectangular/tripolar grid. Three interpolation schems are used here.
!     when the source grid is tripolar grid, inverse of square distance weighted
!     scheme (spherical regrid) is used. When the source grid is rectangular 
!     longitude/latitude grid, any one of following three schemes can be applied: 
!     conservation scheme that conserves the area-weighed integral of the input field, 
!     bilinear interpolation that use the surround four source grid to interpolate onto
!     the destination grid, spherical regrid that use thes inverse of square distance
!     as weight. User can choose the interpolation method in the horiz_interp_init.
!     when the source grid is rectangular grid (1D), the default method is conserve
!     scheme. When the source grid is tripolar grid (2D), spherical regrid is the 
!     default algorithm and no other scheme can be applied. 

!     There is an optional mask field for missing input data.
!     An optional output mask field may be used in conjunction with
!     the input mask to show where output data exists.
! </DESCRIPTION>

!-----------------------------------------------------------------------
!
!        Performs spatial interpolation between grids.
!
!-----------------------------------------------------------------------

      


!---- interfaces ----



! <INTERFACE NAME='horiz_interp_init'>
!   <OVERVIEW>
!      Allocates space and initializes a derived-type variable
!      that contains pre-computed interpolation indices and weights.
!   </OVERVIEW>
!   <DESCRIPTION>
!      Allocates space and initializes a derived-type variable
!      that contains pre-computed interpolation indices and weights
!      for improved performance of multiple interpolations between
!      the same grids. This routine does not need to be called if you
!      are doing a single grid-to-grid interpolation.
!   </DESCRIPTION>
!   <IN NAME='lon_in' TYPE='real' DIM='dimension(:), dimension(:,:)' UNITS='radians'>
!      Longitude (in radians) for source data grid. when lon_in is 1D, it is the longitude
!      edges and its value are for adjacent grid boxes and must increase 
!      in value. When lon_in is 2D, there are two cases: one is the longitude edges stored as
!      pairs for each grid box (when interp_method is 1(conservative)), the other is the longitude
!      of the center of each grid box. 
!   </IN>
!   <IN NAME='lat_in' TYPE='real' DIM='dimension(:), dimension(:,:)' UNITS='radians'>
!      Latitude (in radians) for source data grid. when lat_in is 1D, it is the latitude
!      edges and its value are for adjacent grid boxes and must increase 
!      in value. When lat_in is 2D, it is the longitude of the center of each grid box.
!      When interp_method is 1(conservative) or 2(bilinear), lon_in should be 1D.
!   </IN>
!   <IN NAME='lon_out' TYPE='real' DIM='dimension(:), dimension(:,:)' UNITS='radians' >
!      Longitude (in radians) for source data grid. when lon_in is 1D, it is the longitude
!      edges and its value are for adjacent grid boxes and must increase 
!      in value. When lon_in is 2D, there are two cases: one is the longitude edges stored as
!      pairs for each grid box (when interp_method is 1), the other is the longitude
!      of the center of each grid box (when interp_method is 2). 
!   </IN>
!   <IN NAME='lat_out' TYPE='real' DIM='dimension(:), dimension(:,:)' UNITS='radians' >
!      Latitude (in radians) for source data grid. when lat_in is 1D, it is the latitude
!      edges and its value are for adjacent grid boxes and must increase 
!      in value. When lat_in is 2D, there are two cases: one is the latitude edges stored as
!      pairs for each grid box (when interp_method is 1), the other is the latitude
!      of the center of each grid box (when interp_method is 2).
!   </IN>
!   <IN NAME='verbose' TYPE='integer'>
!      Integer flag that controls the amount of printed output.
!      verbose = 0, no output; = 1, min,max,means; = 2, still more
!   </IN>
!   <IN NAME='interp_method' TYPE='integer'> 
!      interpolation method, = 1, using conservation scheme,
!      = 2, using bilinear interpolation, = SPHERICA(3),using spherical regrid.
!      when source grid is 1d, default value is CONSERVE; when source grid is 2d,
!      default value is 'SPHERICA'.
!   </IN>
!   <IN NAME = 'src_modulo' >
!      Indicate the source data grid is cyclic or not.
!   </IN>
!   <OUT NAME='Interp' >
!      A derived-type variable containing indices and weights used for subsequent 
!      interpolations. To reinitialize this variable for a different grid-to-grid 
!      interpolation you must first use the 'horiz_interp_end' interface.
!   </OUT>


! </INTERFACE>


C      real wti(nlon_dst,nlon_dst,2)      !weights for bilinear interpolation 
C      real wtj(nlat_dst,nlat_dst,2)
C      integer i_lon(nlon_dst,nlon_dst,2) !indices for bilinear interpolation 
C      integer j_lat(nlat_dst,nlat_dst,2)
C      integer nlon_src, nlat_src         !size of source grid
C      integer nlon_dst, nlat_dst         !size of destination grid
C      integer interp_method              !interpolation method.
                                         !  =1, conservative scheme
                                         !  =2, bilinear interpolation
                                         !  =3, spherical regrid


C Interp list:
C wti, wtj, i_lon, j_lat, nlon_src, nlat_src, nlon_dst, nlat_dst

C Interp allocation from subroutine horiz_interp_init_bili 

      subroutine horiz_interp_init_bili (id, wti, wtj, i_lon, j_lat,  
     .                 nlon_src, nlat_src, nlon_dst, nlat_dst, lon_in,
     .                 lat_in, lon_out, lat_out, verbose, src_modulo )

!-----------------------------------------------------------------------
C inputs
C  From type horiz_interp_type, variable Interp


      real wti(nlon_dst,nlat_dst,2)      !weights for bilinear interpolation 
      real wtj(nlon_dst,nlat_dst,2)
      integer i_lon(nlon_dst,nlat_dst,2) !indices for bilinear interpolation 
      integer j_lat(nlon_dst,nlat_dst,2)
      integer nlon_src, nlat_src         !size of source grid
      integer nlon_dst, nlat_dst         !size of destination grid

C Other inputs

      real lon_in(*) , lat_in(*)
      real lon_out(nlon_dst,nlat_dst), lat_out(nlon_dst,nlat_dst)
      integer id, verbose
      logical src_modulo
!-----------------------------------------------------------------------
C  Other declarations

      integer INDP, nlon_in, nlat_in, nlon_out, nlat_out, n, m,
     .   i, j, ie, is, je, js, istart, jstart, iend, jend, 
     .   ln_err, lt_err, na, warns
      real wtw, wte, wts, wtn, lon, lat, pi, tpi, hpi,      
     .   glt_min, glt_max, gln_min, gln_max, min_lon, max_lon

! parameters
      real epsln, large
      integer stdout 
      parameter (epsln=1.e-10, large=1.e20, stdout = 6)

      pi  =  3.14159265358979323846 
      hpi = 0.5*pi
      tpi = 4.0*hpi
      glt_min = hpi
      glt_max = -hpi
      gln_min = tpi
      gln_max = -tpi
      min_lon = 0.0
      max_lon = tpi
      ln_err = 0
      lt_err = 0

      warns = verbose

      nlon_in = nlon_src  
      nlat_in = nlat_src
      nlon_out = nlon_dst
      nlat_out = nlat_dst

      if(lon_in(nlon_in) - lon_in(1) .gt. tpi + epsln) 
     . call ef_bail_out (id, 
     . 'The range of source grid longitude may be no larger than 2*pi')

      if(lon_in(1) .lt. 0.0) then
        min_lon = lon_in(1)
        max_lon = lon_in(nlon_in)
      endif

!     find longitude points of data within interval [-360., 360.]
      istart = 1
      do i=2,nlon_in
        if (lon_in(i-1) .lt. -tpi .and. lon_in(i) .ge. -tpi) istart = i
      enddo 
      iend = nlon_in
      do i=2,nlon_in
        if (lon_in(i-1) .lt. tpi  .and. lon_in(i) .ge. tpi) iend = i
      enddo

!     find latitude points of data within interval [-90., 90.]
      jstart = 1
      do j=2,nlat_in
        if (lat_in(j-1) .lt. -1.0 * hpi .and. 
     .      lat_in(j  ) .ge. -1.0 * hpi) jstart = j
      enddo 
      jend = nlat_in
      do j=2,nlat_in
        if (lat_in(j-1) .lt. hpi .and. lat_in(j) .ge.hpi ) jend = j
      enddo

      do n = 1, nlat_out
      do m = 1, nlon_out
        lon = lon_out(m,n)
        lat = lat_out(m,n)

        if(lon .lt. min_lon) then
         lon = lon + tpi
        else if(lon .gt. max_lon) then
         lon = lon - tpi
        endif
! when the input grid is in not cyclic, the output grid should located inside
! the input grid
      if(.not. src_modulo) then
        if((lon .lt. lon_in(1)) .or. (lon .gt. lon_in(nlon_in))) 
     .   call ef_bail_out(id, 
     .'input grid not modulo, output grid must be inside input grid')


      endif

      glt_min = min(lat,glt_min)
      glt_max = max(lat,glt_max)
      gln_min = min(lon,gln_min)
      gln_max = max(lon,gln_max)

      na = iend - istart + 1
      is = INDP(lon, lon_in(istart), na ) + istart - 1
      if( lon_in(is) .gt. lon ) is = max(is - 1,istart)
      if( lon_in(is) .eq. lon .and. is .eq. nlon_in) 
     .      is = max(is - 1,istart)
      ie = min(is+1,iend)
      if(lon_in(is) .ne. lon_in(ie) .and. lon_in(is) .le. lon) then
        wtw = ( lon_in(ie) - lon) / (lon_in(ie) - lon_in(is) )
      else
! east or west of the last data value. this could be because a
! cyclic condition is needed or the dataset is too small. 
        ln_err = 1
        ie = istart
        is = iend
        if (lon_in(ie) .ge. lon ) then
           wtw = (lon_in(ie) -lon)/(lon_in(ie)-lon_in(is)+tpi+epsln)
        else
          wtw = (lon_in(ie) -lon+tpi+epsln)/
     .          (lon_in(ie)-lon_in(is)+tpi+epsln)
        endif   
      endif
      wte = 1. - wtw

      na = jend - jstart + 1
      js = INDP(lat, lat_in(jstart), na ) + jstart - 1

      if( lat_in(js) .gt. lat ) js = max(js - 1, jstart)
      if( lat_in(js) .eq. lat .and. js .eq. jend) 
     .     js = max(js - 1, jstart)
      je = min(js + 1, jend)

      if ( lat_in(js) .ne. lat_in(je) .and. lat_in(js) .le. lat) then
        wts = ( lat_in(je) - lat )/(lat_in(je)-lat_in(js))
      else
!     north or south of the last data value. this could be because a
!     pole is not included in the data set or the dataset is too small.
!     in either case extrapolate north or south
         lt_err = 1
         wts = 1.
      endif

      wtn = 1. - wts
      
            i_lon (m,n,1) = is
            i_lon (m,n,2) = ie
            j_lat (m,n,1) = js
            j_lat (m,n,2) = je
            wti   (m,n,1) = wtw
            wti   (m,n,2) = wte
            wtj   (m,n,1) = wts
            wtj   (m,n,2) = wtn
      
      enddo
      enddo
      if (ln_err .eq. 1 .and. warns .GT. 0) then
        write (stdout,'(/,(1x,a))') 
     . '==> Warning: the geographic data set does not extend far   ', 
     . '             enough east or west - a cyclic boundary       ', 
     . '             condition was applied. check if appropriate   '
         write (stdout,'(/,(1x,a,2f8.4))') 
     . '    data required between longitudes:', gln_min, gln_max,     
     . '    data set is between longitudes:', 
     .   lon_in(istart), lon_in(iend)
         warns = warns - 1
       endif
!
       if (lt_err .eq. 1 .and. warns .GT. 0) then
         write (stdout,'(/,(1x,a))')
     . '==> Warning: the geographic data set does not extend far   ',
     . '             enough north or south - extrapolation from    ',
     . '             the nearest data was applied. this may create ',
     . '             artificial gradients near a geographic pole   ' 
         write (stdout,'(/,(1x,a,2f8.4))')
     . '    data required between latitudes:', glt_min, glt_max,
     . '      data set is between latitudes:', 
     .   lat_in(jstart), lat_in(jend)
         warns = warns - 1
       endif

       return

      end ! subroutine horiz_interp_init_bili

* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      subroutine horiz_interp_bili ( wti, wtj, i_lon, j_lat,  
     .                    nlon_src, nlat_src, nlon_dst, nlat_dst, 
     .                    data_in, data_out, verbose, missing_value,
     .                    missing_result, missing_permit)
!-----------------------------------------------------------------------


!-----------------------------------------------------------------------
C  From type horiz_interp_type, variable Interp

      real wti(nlon_dst,nlat_dst,2)      !weights for bilinear interpolation 
      real wtj(nlon_dst,nlat_dst,2)
      integer i_lon(nlon_dst,nlat_dst,2) !indices for bilinear interpolation 
      integer j_lat(nlon_dst,nlat_dst,2)
      integer nlon_src, nlat_src         !size of source grid
      integer nlon_dst, nlat_dst         !size of destination grid

      real data_in(nlon_src, nlat_src)   ! input
      real data_out(nlon_dst, nlat_dst)  ! output
      integer verbose
      real missing_value                 ! missing flag of input
      real missing_result                ! missing flag for result
      real missing_permit                ! Number of missing cells to allow
!-----------------------------------------------------------------------
      integer nlon_in, nlat_in, nlon_out, nlat_out, n, m,
     .            is, ie, js, je, iverbose, num_missing, 
     .            miss_in, miss_out
      real  dwtsum, wtsum, min_in, max_in, avg_in, 
     .            min_out, max_out, avg_out, wtw, wte, wts, wtn
      real data(4)

! parameters
      real epsln, large
      parameter (epsln=1.e-10, large=1.e20)

      nlon_in  = nlon_src
      nlat_in  = nlat_src
      nlon_out = nlon_dst
      nlat_out = nlat_dst

      iverbose = verbose

      do n = 1, nlat_out
      do m = 1, nlon_out
      data_out(m,n) = 0.0

      is = i_lon (m,n,1) 
      ie = i_lon (m,n,2)
      js = j_lat (m,n,1)
      je = j_lat (m,n,2)
      wtw = wti(m,n,1)
      wte = wti(m,n,2)
      wts = wtj(m,n,1)
      wtn = wtj(m,n,2)
      data(1) = data_in(is,js)
      data(2) = data_in(ie,js)
      data(3) = data_in(ie,je)
      data(4) = data_in(is,je)

      call data_sum_bilinear ( data, wtw,wte, wts,wtn, dwtsum, wtsum, 
     .   num_missing, missing_value)

      if (num_missing .gt. missing_permit .or. wtsum .lt. epsln) then
        data_out(m,n) = missing_result
      else
        data_out(m,n) = dwtsum/wtsum
      endif
      enddo
      enddo

!***********************************************************************
! compute statistics: minimum, maximum, and mean
!-----------------------------------------------------------------------

!!      if (iverbose .GT. 0) then
!!
!!! compute statistics of input data
!!
!!       call stats_type2 (data_in, min_in, max_in, avg_in, 
!!   .           miss_in, missing_value)
!!
!!! compute statistics of output data
!!       call stats_type2 (data_out, min_out, max_out, avg_out, 
!!   .          miss_out, missing_value)
!!
!!!---- output statistics ----
!!! root_pe have the information of global mean, min and max
!!
!!       write (*,900)
!!       write (*,901)  min_in ,max_in, avg_in
!!         write (*,903)  miss_in
!!         write (*,902)  min_out,max_out,avg_out
!!         write (*,903)  miss_out
!! 900     format (/,1x,10('-'),' output from horiz_interp ',10('-'))
!! 901     format ('  input:  min=',f16.9,'  max=',f16.9,'  avg=',f22.15)
!! 902     format (' output:  min=',f16.9,'  max=',f16.9,'  avg=',f22.15)
!! 903     format ('          number of missing points = ',i6)
!!
!!      endif


      return

      end ! subroutine horiz_interp_bili

* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

       integer function INDP (value, array, ia)
       real array(*)
       real value
       integer ia
!
!=======================================================================
!
!     INDP = index of nearest data point within "array" corresponding to
!            "value".

!     inputs:
!     value  = arbitrary data...same units as elements in "array"
!     array  = array of data points  (must be monotonically increasing)

!     output:
!     INDP =  index of nearest data point to "value"
!             if "value" is outside the domain of "array" then INDP = 1
!             or "ia" depending on whether array(1) or array(ia) is
!             closest to "value"
!=======================================================================
!
       integer i
       logical keep_going
!
       do i=2,ia
         if (array(i) .lt. array(i-1)) then
         write (6,*) 
     .   ' => Error: array must be monotonically increasing in "INDP"', 
     .   '          when searching for nearest element to value=',value
         write (6,*) '           array(i) < array(i-1) for i=',i 
         write (6,*) '           array(i) for i=1..ia follows:'
         stop
        endif
      enddo
      if (value .lt. array(1) .or. value .gt. array(ia)) then
        if (value .lt. array(1))  INDP = 1
        if (value .gt. array(ia)) INDP = ia
      else
        i=1
        keep_going = .true.
        do while (i .le. ia .and. keep_going)
          i = i+1
          if (value .le. array(i)) then
            INDP = i
            if (array(i)-value .gt. value-array(i-1)) INDP = i-1
            keep_going = .false.
          endif
        enddo
      endif
      return
      end ! function INDP

* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      subroutine data_sum_bilinear ( data, wtw, wte, wts, wtn, 
     .                               dwtsum, wtsum, num_missing,
     .                               missing_value  )

!  sums up the data and weights for a single output grid box
!-----------------------------------------------------------------------
      real data(*)
      real wtw, wte, wts, wtn
      real dwtsum, wtsum
      integer num_missing
      real missing_value

!  dwtsum = sum(data*wt*mask)
!  wtsum  = sum(wt*mask)

      integer i
      real wt1, wt2
!-----------------------------------------------------------------------


      num_missing = 0
      dwtsum = 0.0
      wtsum  = 0.0

      do i = 1,4
      if(data(i) .eq. missing_value) then
         num_missing = num_missing + 1
      else
         if (i .eq. 1) then
            wt1= wtw
            wt2 = wts
         else if (i .eq. 2) then
            wt1= wte
            wt2 = wts
         else if (i .eq. 3) then
            wt1= wte
            wt2 = wtn
         else if (i  .eq. 4) then
            wt1= wtw 
            wt2 = wtn
         endif

         dwtsum = dwtsum + data(i) * wt1 * wt2
         wtsum  = wtsum + wt1 * wt2
      endif
      enddo

      return
      end ! subroutine data_sum_bilinear

* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!---This statistics is for bilinear interpolation and spherical regrid.

!!      subroutine stats_type2 ( dat, low, high, avg, miss, missing_value,
!!     .  nlon, nlat)
!!
!!      real dat(nlon,nlat)
!!      real low, high, avg  ! output
!!      integer miss         ! output
!!      real  missing_value  ! input
!!      integer nlon, nlat   ! input
!!
!!
!!      real dsum, npts
!!      integer n, m
!!
!!      dsum = 0.0
!!      miss = 0
!!      npts = 0
!!
!!      do n = 1, nlat
!!      do m = 1, nlon
!!      IF (dat(m,n) .NE. missing_value) THEN
!!         npts = npts + 1
!!         low = MIN( low, dat(m,n) )
!!         high = MAX (high, dat(m,n) )
!!         dsum = dsum + dat(m,n)
!!      ELSE
!!         miss = miss + 1
!!      ENDIF
!!      ENDDO
!!      ENDDO
!!
!!      if(npts .EQ. 0) then
!!         avg = missing_value
!!      else
!!         avg = dsum/real(npts)
!!      endif
!!   
!!      return
!!
!!      end  ! subroutine stats_type2


* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

	SUBROUTINE GCF_IMPOSE_AXES( cx_base, mrg_cx, uvar, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* at this point a grid has been determined which lacks only those
* axes which are to be imposed by a grid changing variable. This routine
* completes that grid and the uvar_given associated with it.

* V4500: 10/98 - *jc* logic for context passing
* V450: 1/97
* V510: *sh* 12/99 - bug fixes to uvar_given associated with GC variables
*	- 1) imposing an axis always makes limits on that axis uvlim_irrelevant
*	- 2) context limits on axes that do inherit must match exactly (cuz
*			we have no idea what goes on inside the EF)
*	*sh*  4/00 - all axes now maintain use counts, not just dynamic
* V533: *sh* 7/01 - improve caching of some functions -- like SPAWN that
*	            should have uvlim_hidden behavior equivalent to FFTA
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V697  12/15 *acm* Changes to add details on SHOW GRID uvar to indicate 
*                   compressed or subset of axes
* V740   4/18 *acm* Issue 1867: Restore pre-3/17 behavior for RESHAPE - 
*                   previous code change may have been an unintended checkin

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'ferret.parm'
	include 'grid_chg_fcns.parm'
	include 'errmsg.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include 'xgrid_chg_fcns.cmn'

* calling argument declarations
	INTEGER		cx_base, mrg_cx, uvar, status

* local variable declarations
	INTEGER WHICH_GCFCN
	INTEGER	gcfcn, idim, imp_ax, mrg_ax, mrg_grd, uvg,
     .		axis_source(nferdims), imposed_axes(nferdims), 
     .		axis_reduction(nferdims)


* initialize
* which grid changing variable?
	gcfcn = WHICH_GCFCN(uvar)

* which axes are involved?
	CALL GCF_GET_AXIS_SRCS( gcfcn, 1, axis_source )

* get the axis_reduction information
	IF ( gcfcn .GT. gfcn_num_internal ) THEN
       CALL EFCN_GET_AXIS_REDUCTION(gcfcn, axis_reduction)
	ENDIF

* get the replacement axes
	CALL GCF_GET_IMPOSED_AXES( gcfcn, cx_base, imposed_axes,
     .       status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* get the current grid
	mrg_grd = cx_grid( mrg_cx )


* loop through the axes
	DO 500 idim = 1, nferdims

	   mrg_ax  = grid_line ( idim, mrg_grd )

	   IF (    axis_source(idim).EQ.pgc_ignore_axis) THEN
	      GOTO 500
	   ELSEIF (axis_source(idim).EQ.pgc_impose_axis) THEN
	      imp_ax = imposed_axes(idim)
* ... since new axis is imposed old axis need not be allocated to result
	      CALL TM_USE_LINE(imp_ax)
	      CALL TM_DEALLO_DYN_LINE(mrg_ax)
	      grid_line( idim, mrg_grd ) = imp_ax
* ... imposing an axis implies that the gcvar doesn't depend on the axis cx
	      IF ( imp_ax .EQ. mnormal ) THEN
	         uvar_given(idim,uvar) = uvlim_irrelevant
	      ELSEIF ( gcfcn .GT. gfcn_num_internal ) THEN
	         uvar_given(idim,uvar) = uvlim_hidden	! 12/99
	      ELSEIF ( gcfcn .EQ. p_spawn ) THEN
	         uvar_given(idim,uvar) = uvlim_hidden   ! 7/01
	      ELSE
* ... allows XSEQUENCE, etc. context to be determined w/out full evaluation
*     This can make some scripts more efficient ... others maybe less because
*     uvlim_hidden would make caching more effective.  Example like
*       "let a = XSEQUENCE(J[j=1:5]); say `a[i=100:200],return=isize`"
*     can actually yield a wrong answer
	         uvar_given(idim,uvar) = uvlim_needed ! for fcns like RESHAPE
	      ENDIF
	   ELSE
* ... it is evidently, a mergible axis ... continue on
	      CONTINUE
	   ENDIF	      

* For grid-changing functions (that may perform operations analagous to
* averaging) a cache hit requires an exact match on all relevant limits
* (Note: this is over-kill for some functions, but has
* impacts only on cache efficiency)

c For SHOW GRID with details e.g. compressed axes or subsets these settings
c wind up returning result of COMPRESSED for axes unaffected by the function.
c add logic to change uvar_given only when the gcf changes the axis. 

           IF ( gcfcn .GT. gfcn_num_internal ) THEN
	      IF (axis_source(idim) .EQ. pgc_impose_axis) THEN
                 uvg = uvar_given(idim,uvar)
                 IF (    uvg.GE.uvlim_gvn_gnl    .AND.
     .                uvg.LE.uvlim_gvn_xact) THEN
                    uvar_given(idim,uvar) = uvlim_gvn_xact
                 ELSEIF (uvg.GE.uvlim_needed .AND.
     .                   uvg.LE.uvlim_need_xact) THEN
                    uvar_given(idim,uvar) = uvlim_need_xact
                 ENDIF
	      ENDIF
           ENDIF

 500	CONTINUE

* successfully merged
	status = ferr_ok
	RETURN

* error exit
 5000	RETURN
	END

	SUBROUTINE SHOW_1_DSVAR( lun, dset, vname, varid )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* output some lines describing a dataset (netCDF) variable

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V600 6/05 *acm* Attribute control.
* V685 5/13 *acm* Write the long_name not the variable number.

	include 'tmap_dims.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include	'ferret.parm'
	include	'xvariables.cmn'
	include	'xrisc.cmn'

* calling argument declarations:

	INTEGER	lun, dset, varid
	CHARACTER*(*) vname
	
* local variable declarations:
	LOGICAL NC_GET_ATTRIB_STRING, do_warn, got_it
	INTEGER TM_LENSTR1, slen, llen, maxlen, attlen, attoutflag
	CHARACTER*512 string

* initialize
	slen = TM_LENSTR1(vname)
	maxlen = 512

* variable name and definition
	risc_buff = ' '//vname(:slen)
        slen = slen + 1

        got_it = NC_GET_ATTRIB_STRING ( dset, varid, 'LONG_NAME',
     .                                   do_warn, vname, maxlen,
     .                                   attlen, attoutflag, string)

	IF (got_it) THEN
	   risc_buff = risc_buff(:slen)//': '
           slen = slen + 2
	   risc_buff = risc_buff(:slen)//string(:attlen)
           slen = slen + attlen
	ENDIF

	risc_buff = risc_buff(:slen)//', in dataset '
        slen = slen + 13

        llen = TM_LENSTR1(ds_des_name(dset))

        risc_buff = risc_buff(:slen)//ds_des_name(dset)(:llen)
        slen = slen + llen

	CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
	risc_buff = ' '

	RETURN
	END

c*
c* ef_get_res_subscripts_6d.F (formerly ef_get_res_subscripts.F)
c*
c* Jonathan Callahan
c* Apr 6th 1998
c*
c*
   
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
c*
c* Initialize the result context limits the EF will use.  
c*
*       3/12 *kms* Added E and F dimensions, appended _6D to subroutine name

      SUBROUTINE EF_GET_RES_SUBSCRIPTS_6D(id, res_lo_ss,
     .                                    res_hi_ss, res_incr)

      IMPLICIT NONE
      INCLUDE 'tmap_dims.parm'
      INCLUDE 'ferret.parm'
      INCLUDE 'xvariables.cmn'
      INCLUDE 'EF_Util.parm'

      INTEGER id,
     .        res_lo_ss(nferdims),
     .        res_hi_ss(nferdims),
     .        res_incr(nferdims)

      INTEGER idim, mres

c* The memory resident id for the rsult, "mres", was cached by 
c* Ferret and must be retrieved to be accessible to the external function.
      CALL EF_GET_MRES(mres)

      DO 100 idim=1,nferdims

         res_lo_ss(idim) = mr_lo_ss(mres, idim)
         res_hi_ss(idim) = mr_hi_ss(mres, idim)
         IF (res_lo_ss(idim) .EQ. res_hi_ss(idim)) 
     .        THEN
            res_incr(idim) = 0
         ELSE
            res_incr(idim) = 1
         ENDIF

 100  CONTINUE

      RETURN 
      END

	  SUBROUTINE CD_DSET_REMOTEOK(dset, ok_remote)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*

C Check whether we can define a LET/REMOTE variable in this dataset.
* Sets the flag  ds_accepts_remote for the dataset.

* include files
        include 'netcdf.inc'
	include 'tmap_errors.parm'
#include "gt_lib.parm"
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xdset_info.cd_equiv'

	INTEGER dset
	LOGICAL ok_remote

	LOGICAL TM_HAS_STRING
	INTEGER TM_LENSTR1, slen, vlen, ivar, cdfid, cdfstat, status
	CHARACTER vname*128, buff*3000, ebuff*3000

* Already checked? 
	IF (ds_accepts_remote(dset)) GOTO 5000

* If not an opendap set, then it does not accept remote definitions
	IF ( ds_des_name(dset)(1:7) .NE. 'http://') GOTO 5100

	DO 100 ivar = 1, maxvars
	   IF (ds_var_setnum(ivar) .EQ. dset) GOTO 110
 100	CONTINUE
        GOTO 5000	 !no variables in the datset, so return FALSE
 110	CONTINUE

	slen = TM_LENSTR1(ds_des_name(dset))

* If its already a datset with f-tds variable in it, it cannot be used.
* (depending on where we're calling this, there should be a message).

	IF (TM_HAS_STRING(ds_des_name(dset)(1:slen), 'letdeq1')) GOTO 5000

* Name of first variable, use it to define a variable name.

	vname = ds_var_code(ivar)
	vlen = TM_LENSTR1(vname)

* Construct a url which is the original url, with a variable defined,
* LET varname_1_NEW = 7
	
	buff = '{}{letdeq1 '//vname(:vlen)//'1_new=7}'
	slen = TM_LENSTR1(buff)

* Encode the variable definition, set up the full url, 
* and try to open it.

	CALL CD_ENCODE_URL ( buff, ebuff, status)

	slen = TM_LENSTR1(ds_des_name(dset))
	vlen = TM_LENSTR1(ebuff)
	buff = ds_des_name(dset)(:slen)//'_expr_'//ebuff(:vlen)

#ifdef usingDODSf2cUnderscore 
	cdfstat = NF_OPEN_(buff, NF_NOWRITE, cdfid) 
#else
	cdfstat = NF_OPEN(buff, NF_NOWRITE, cdfid) 
#endif

* If it could be opened, we can make remote-variable definitions.

	IF (cdfstat .EQ. NF_NOERR) THEN
	   ds_accepts_remote(dset) = .TRUE.

* close the url with f-tds var - we were just testing here.
#ifdef usingDODSf2cUnderscore
	   cdfstat = NF_CLOSE_( cdfid )
#else
	   cdfstat = NF_CLOSE( cdfid )
#endif

	ELSE
	   ds_accepts_remote(dset) = .FALSE.
	   CALL WARN ('dataset does not accept REMOTE variable definitions')
	ENDIF

 5000	ok_remote = ds_accepts_remote(dset)
	RETURN

 5100	CONTINUE
	ds_accepts_remote(dset) = .FALSE.
	CALL WARN ('dataset does not accept REMOTE variable definitions')
	END

	LOGICAL FUNCTION TM_CHECK_BNDS_CENTERED (line, line_edges, npts, 
     .		iaxis, doubletype)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Checks whether data points are all centered within the bounds on an axis
* Do this in single precision, as in the check for regular axis in cd_get_1_axis.

* 4/2004 ACM 
* V58+ *acm*  1/05 Fixes for irreg axes with bounds: This routine now checks
*                  whether the coordinates are centered in the bound boxes, and 
*                  whether the boxes are equal sized.
* V601 *acm* 9/19  Fix bug 1434; check bounds for regularly-spaced axes 
* V694  5/15 *acm* Match precision for bounds checks (as is done for coords).
* V72 6/17 *acm* for trac enhancement #767 -- dynamic coordinate storage 
*                line and line_edges are the coordinates and edges for this line
* V745 12/18 *acm* Noticed that regular clim axes from clim_axes_gregorian.nc were 
*                  shown as irregular ( MON_REG_GRG TIME 12mi). Use epsilon test 
*                  for comparing  diff_hi and diff_last (!)

	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data

* Argument declarations
	REAL	line(*), line_edges(*)
	LOGICAL doubletype, regular
	INTEGER npts, iaxis

* Local variable declarations
        LOGICAL TM_FPEQ_EPS, TM_DFPEQ_TOL, equal
	INTEGER i
        REAL diff_hi, diff_lo, diff_last
        REAL pt, del, blo, bhi
	REAL epsilon_21, epsilon
	REAL*8 depsilon_42, depsilon, first_delta

	epsilon_21 =  2.**(-21) 
	depsilon_42 =  2.**(-42) 

	first_delta = line(2) - line(1)

	depsilon = depsilon_42 * 2.*(ABS(line(1)) / first_delta )
	epsilon = epsilon_21 * 2.*(ABS(line(1)) / first_delta )

        IF (line_regular(iaxis)) THEN
           pt = line_start(iaxis)
           del = line_delta(iaxis) 

	   DO 100 i = 1, npts

             blo = line_edges(2*(i-1)+1)
             bhi = line_edges(2*(i-1)+2)

	     diff_hi = bhi - pt
             diff_lo = pt - blo

	     IF (doubletype) THEN
	       equal = TM_DFPEQ_TOL(diff_lo, diff_hi, depsilon)
	     ELSE
	       equal = TM_FPEQ_EPS(epsilon, diff_lo, diff_hi) 
	     ENDIF

	     IF ( .NOT. equal ) GOTO 500


             IF (i .GT. 1) THEN
                
		IF (doubletype) THEN
	           equal = TM_DFPEQ_TOL(diff_hi, diff_last, depsilon) 
		ELSE
	           equal = TM_FPEQ_EPS(epsilon, diff_hi, diff_last) 
		ENDIF
		IF ( .NOT. equal ) GOTO 500
		
	     ENDIF
             diff_last = diff_hi
             pt = float(i) * del + line_start(iaxis)

  100	   CONTINUE

        ELSE  ! not line_regular
   
	   DO 200 i = 1, npts
             blo = line_edges(2*(i-1)+1)
             bhi = line_edges(2*(i-1)+2)

             diff_hi = bhi - line(i)
             diff_lo = line(i)- blo

	     IF (doubletype) THEN
	       equal = TM_DFPEQ_TOL(diff_lo, diff_hi, depsilon)
	     ELSE
	       equal = TM_FPEQ_EPS(epsilon, diff_lo, diff_hi) 
	     ENDIF
	     IF ( .NOT. equal ) GOTO 500


             IF (i .GT. 1) THEN

		IF (doubletype) THEN
	           equal = TM_DFPEQ_TOL(diff_hi, diff_last, depsilon) 
		ELSE
	           equal = TM_FPEQ_EPS(epsilon, diff_hi, diff_last) 
		ENDIF
	        IF ( .NOT. equal ) GOTO 500

	     ENDIF
             diff_last = diff_hi

  200	   CONTINUE

        ENDIF

	TM_CHECK_BNDS_CENTERED = .TRUE.
	RETURN

 500	CONTINUE
	TM_CHECK_BNDS_CENTERED = .FALSE.
	RETURN

	END

* scat2grid_subs:  Subroutines called by the scat2grid functions.
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*

      SUBROUTINE pickout1 (atim, n, val)

      IMPLICIT NONE

*  ACM 5/2003
*  Called from the ave_scat2grid_t function.
*  Pick out nth item from atim, which is really 4-D 
*  with normal axes on three of the four axes.

      REAL atim(*)
      REAL val
      INTEGER n

      val = atim(n)

      RETURN
      END


      SUBROUTINE pickout2 (alon, alat, n, xx, yy)

      IMPLICIT NONE

*  ACM 3/2000
*  Called from the scatter*  gridding functins.
*  Pick out nth item from alon and alat, which are really 4-dimensioned arrays
*  with normal axes on three of the four axes.
*  (can be any variables, typically lon and lat)

      REAL alon(*), alat(*)
      REAL xx, yy
      INTEGER n

      xx = alon(n)
      yy = alat(n)

      RETURN
      END

      SUBROUTINE pickout3 (alon, alat, atimes, n, xx, yy, tt)

      IMPLICIT NONE

*  CALLed from the scatter*  gridding functins.
*  Pick out nth item from alon and alat, which are really 4-dimensioned arrays
*  with normal axes on three of the four axes.
*  (can be any variables, typically lon,lat,time or lon,lat,depth)

      REAL alon(*), alat(*), atimes(*)
      REAL xx, yy, tt
      INTEGER n

      xx = alon(n)
      yy = alat(n)
      tt = atimes(n)

      RETURN
      END

      SUBROUTINE pickout4 (alon, alat, atimes, vals, n, xx, yy, tt, vv)

      IMPLICIT NONE

*  Called from the scatter*  gridding functins.
*  Pick out nth item from alon, alat, atimes, which are really 4-dimensioned arrays
*  with normal axes on three of the four axes.
*  (can be any variables, typically lon,lat,time,value or lon,lat,depth,time, etc)

      REAL alon(*), alat(*), atimes(*), vals(*)
      REAL xx, yy, tt, vv
      INTEGER n

      xx = alon(n)
      yy = alat(n)
      tt = atimes(n)
      vv = vals(n)

      RETURN
      END

      SUBROUTINE pickout5 (alon, alat, adepths, atimes, vals, n, xx, yy, zz, tt, vv)

      IMPLICIT NONE

*  Called from the scatter*  gridding functins.
*  Pick out nth item from alon, alat, azdep, atimes, which are really 4-dimensioned arrays
*  with normal axes on three of the four axes.
*  (can be any variables, typically lon,lat,time,depth,value etc)

      REAL alon(*), alat(*), adepths(*), atimes(*), vals(*)
      REAL xx, yy, zz, tt, vv
      INTEGER n

      xx = alon(n)
      yy = alat(n)
      tt = atimes(n)
      zz = adepths(n)
      vv = vals(n)

      RETURN
      END


c************************************************************************
c...NOBS.....Based on gausswt, return only the # of obs in (x,y) gridbox
c............method is to call this sub for each data value
c............all calcs done in gridbox units
c............xx/x1/xf all in same units
c............yy/y1/yf all in same units

c  i	xx,yy=x/y location of data pt (data units)
c  i	nx,ny=size of grids
c  i	x1,y1=west/south edge of grid (center of 1st box in data units)
c  o 	obs(nx,ny) number of obs in each (x,y) gridbox
c--------------------------------------------------------------------------

	SUBROUTINE nobs (xx, yy, nx, ny, x1, y1, dx, dy, 
     .			 xf, yf, obs)

      IMPLICIT NONE

* Argument declarations

        INTEGER nx, ny
	REAL xx, yy, dx, dy, x1, y1, xf, yf, obs(nx,ny)

* Local variable declarations

        REAL xxg, yyg
        INTEGER ig, jg

	xxg = (xx-x1)/ dx + 1.		  ! grid values of data location
	yyg = (yy-y1)/ dy + 1.

c.................save the number of obs in each (x,y) gridbox
	ig = NINT(xxg)
	jg = NINT(yyg)
	IF (ig.GE.1 .AND. ig.LE.nx .AND. jg.GE.1 .AND. jg.LE.ny)
     .		obs(ig,jg) = obs(ig,jg)+1.

	RETURN
	END



c************************************************************************
c...NOBS.....Based on gausswt, return only the # of obs in (x,y) gridbox
c............method is to call this sub for each data value
c............all calcs done in gridbox units
c............xx/x1/xf all in same units
c............yy/y1/yf all in same units

c  i	xx,yy,tt=x/y/t location of data pt (data units)
c  i	nx,ny,nt=size of grids
c  i	x1,y1,L1=west/south/earliest edge of grid (center of 1st box in data units)
c  o 	obs(nx,ny,nt) number of obs in each (x,y,t) gridbox
c--------------------------------------------------------------------------

	SUBROUTINE nobsxyt (xx, yy, tt, nx, ny, nt, x1, y1, t1, 
     .                 dx, dy, dt, xf, yf, tf, obs)

      IMPLICIT NONE

* Argument declarations

        INTEGER nx, ny, nt
	REAL xx, yy, tt, x1, y1, t1, dx, dy, dt, xf, 
     .       yf, tf, obs(nx,ny,nt)

* Local variable declarations

        REAL xxg, yyg, ttg
        INTEGER ig, jg, Lg ! !!!!!!!!!!!!!!!!!!!!!!!! adding t dimension throughtout

	xxg = (xx-x1)/ dx + 1.		  ! grid values of data location
	yyg = (yy-y1)/ dy + 1.
	ttg = (tt-t1)/ dt + 1.

c.................save the number of obs in each (x,y,t) gridbox
	ig = NINT(xxg)
	jg = NINT(yyg)
	Lg = NINT(ttg)
	IF (ig.GE.1 .AND. ig.LE.nx .AND. jg.GE.1 .AND. jg.LE.ny .AND.
     .      Lg.GE.1 .AND. Lg.LE.nt   )
     .		obs(ig,jg,Lg) = obs(ig,jg,Lg)+1.

	RETURN
	END


      SUBROUTINE pickout (atim, n, val)

      IMPLICIT NONE

*  ACM 5/2003
*  Called from the ave_scat2grid_t function.
*  Pick out nth item from atim, which is really 4-D 
*  with normal axes on three of the four axes.

      REAL atim(*)
      REAL val
      INTEGER n

      val = atim(n)

      RETURN
      END

	SUBROUTINE TM_INT2_SWAP(ival2, author_cpu)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* byte-swap a 2-byte quantity to achieve big/little endian conversion

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX/VMS, DEC Ultrix, and SUN
*
* revision 0.0 - 2/13/92
* replaced "elif" syntax with
*	else
*	   if
*  for SGI port	 - kob 4/8/92
* bug fix -4/92- ival2 should be integer*2 declaration
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* calling argument declarations:
	INTEGER*2 ival2
	INTEGER author_cpu

* internal variable declarations:
        LOGICAL swap

      include 'cpu.parm'
#  ifdef sun
      BYTE bb(2),bdum
#  else
      INTEGER*1 bb(2),bdum
#  endif

        INTEGER*2 dum
	EQUIVALENCE (bb(1),dum)

***********   CONVERT between machine types   **************
*** use the pre-processor to select the target word type ***
#ifdef sun
* SUN is the platform in use
      swap = author_cpu .EQ. cptype_vax
     .  .OR. author_cpu .EQ. cptype_dec

#else
#	if unix
* DECstation is the platform in use
      		swap = author_cpu .EQ. cptype_sun

#	else
* VAX is the platform in use
      		swap = author_cpu .EQ. cptype_sun
#	endif
#endif

      IF (swap ) THEN
         dum = ival2
         bdum = bb(1)
         bb(1) = bb(2)
         bb(2) = bdum
         ival2 = dum
      ENDIF

      RETURN
      END

      SUBROUTINE SQUISH(JSTRNG,JFIRST,NPOS)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)squish.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C	Removes blank characters starting at position JFIRST
C	for the next NPOS characters and packs the characters
C	back into the original string.  Good for getting rid
C	of extra blanks.
C
C	JSTRNG -- character, input and output string
C	JFIRST -- INT, position to begin processing
C	NPOS -- INT, number of characters to process
C
C
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 

	CHARACTER*1 JSTRNG*(*),KLPAR,KRPAR,JBLNK,JCH
      LOGICAL REMOVE

      DATA KLPAR/'('/,KRPAR/')'/,JBLNK/' '/

      IF(NPOS.EQ.0)RETURN
      LAST=IABS(NPOS)+JFIRST-1
      REMOVE=.FALSE.
      IF(NPOS.LT.0)REMOVE=.TRUE.
      NEXT=JFIRST
      NPAREN=0

      DO 500 JPOS=JFIRST,LAST
	JCH=JSTRNG(JPOS:JPOS)
	JSTRNG(JPOS:JPOS)=JBLNK
      IF(JCH.NE.KLPAR)GO TO 100
      NPAREN=NPAREN+1
      GO TO 150

  100 IF(NPAREN.EQ.0)GO TO 200
      IF(JCH.NE.KRPAR)GO TO 300
      NPAREN=NPAREN-1
  150 IF(REMOVE)JCH=JBLNK
      GO TO 300

  200 IF(JCH.EQ.JBLNK)GO TO 500
  300 JSTRNG(NEXT:NEXT)=JCH
      NEXT=NEXT+1
  500 CONTINUE

      RETURN
      END

	SUBROUTINE COACHED_STR_SUB( sym_name, 
     .		in_str, coaching, out_str, len_out, status ) 

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* replace the input string with the text implied in the coaching
* possibly displaying an error string

* if the input string is blank and no default then report error
* if error text was supplied with coaching use it for error message

* coaching may include:
*	"default"	- default string if arg n doesn't exist
*	">default"	- default string if arg n doesn't match any options
*	"<errmsg"	- error   string 
*	"|option"     - an acceptable value for argument n
*	"|option>opt_replace"     - an acceptable value and replacement text
*  note that "*" will match any option so "|*>whatever" will substitute
*       "whatever" for anything

* USAGE EXAMPLES:
*		      "my_default_file|file1|file2"
* ... allow only instrings "file1", "file2", or blank which gets default

*		 or   "|file1|file2<This is not a valid file"
* ... allow only instrings "file1", "file2" - else an error message

*		 or   "|1>file1|2>file2<You must enter 1 or 2"
* ... allow only instrings "1" or "2" with replacement text for each

* STAR:		 or   "|file1>snoopy|file2>linus|*"
* ... allow any instring with replacement text for "file1" and "file2"
* STAR:		 or   "|file1>snoopy|file2>linus|*>no_match_file"
* ... gives replacement text for "file1" and "file2". Any other
* 	instring gets replaced by "no_match_file"
* Note: "*" effectively matches any instring given 


* table of behavior of ">default" vs "default":
*		no argument given	argument doesn't match options
*		-----------------	------------------------------
*    default  |   return default		error
*   >default  |	  return default 	   return default 

* not yet implemented:
*	$<		- input from stdin
*	$<!		- input from stdin - reprompted if not acceptable

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V420	2/29/96	- extracted from dollar_command for shared use by symbols
*
* 1/03 *kob* - need to accomodate g77 and it's inability to arbitrarily concatenate
* V580 *acm* 11/04 when command contains some error text, and an error condition
*                  is found, issue an error rather than just a note. (bug 1077)
* V500 *acm*  1/05 Fix the above within the ifdef NO_PASSED_CONCAT too
* V698 *acm*  4/16 Fix ticket 2398: report the argument as given, along with the error

* calling argument declarations:
	LOGICAL   err_subst
	INTEGER	  len_out, status
	CHARACTER sym_name*(*), in_str*(*), coaching*(*), out_str*(*)

* internal variable declarations:
* d default string
* e error string
* o options string
* r replacement strings

	LOGICAL errtxt, default, options, opt_replace,
     .		def_replace, opt_failed
	INTEGER	STR_CASE_BLIND_COMPARE, TM_LENSTR1,
     .		iptr, len_in, vax_code, errstat,
     .		dstart, ostart, estart, dend, oend, eend, ostart1, oend1,
     .		rstart, rend, right_star
#ifdef NO_PASSED_CONCAT
* Additional temp character buffer needed for concatenating error messages
*    required by g77 *kob* 1/03

	CHARACTER tmp_buff*2048
#endif

	include 'ferret.parm'
	include 'errmsg.parm'
	include 'gfdl_vms.parm'
	include 'xrisc.cmn'

* initialize
	status = ferr_ok
	err_subst = .FALSE.
	dstart = 1
	iptr = TM_LENSTR1(coaching)
	errtxt = .FALSE.
	options = .FALSE.
	default = .FALSE.
	opt_replace = .FALSE.
	def_replace = .FALSE.
	opt_failed  = .FALSE.
	IF ( in_str .EQ. ' ' ) THEN
	   len_in = 0
	ELSE
	   len_in = TM_LENSTR1(in_str)
	ENDIF
	len_out = len_in

* error string provided?
	estart = INDEX( coaching, '<' )
	errtxt = estart .GT. 0
	estart = estart + 1     ! right after "<"
	eend = iptr
	IF ( estart .GT. eend ) GOTO 5400
	IF ( errtxt ) THEN
	   dend = estart - 2
	   errstat = ferr_silent
	ELSE
	   dend = iptr
	   errstat = ferr_invalid_command
	ENDIF
	
* options provided?
	ostart = INDEX(coaching, '|')
	options = ostart .GT. 0
	ostart = ostart + dstart    ! right after first "|"
	IF ( errtxt ) THEN
	   oend = estart - 2
	ELSE
	   oend = iptr
	ENDIF

* default text provided?
	IF ( options ) THEN
	   default = ostart .GT. dstart+1
	   dend = ostart - 2
	ELSEIF ( errtxt ) THEN
	   IF ( estart .GT. dstart+1 ) GOTO 5500  ! error text AND default?
	   default = .FALSE.
	ELSE
	   default = .TRUE.
	ENDIF
* ... use the default if the given argument doesn't match any of the options?
	IF ( default .AND. options ) THEN
	   def_replace = coaching(1:1) .EQ. '>'
	   IF ( def_replace ) dstart = 2
	   IF ( dstart .GT. dend ) GOTO 5400
	   default = .NOT.def_replace
	ENDIF

* loop: compare the instring text provided with the allowable options  
	IF ( options .AND. len_out.GT.0 ) THEN
	   ostart1 = ostart
 200	   oend1 = INDEX( coaching(ostart1:oend), '|' )
	   IF ( oend1 .EQ. 0 ) THEN
	      oend1 = oend
	   ELSE
	      oend1 = ostart1 + oend1 - 2
	   ENDIF
* ... was replacement text provided ?
	   rend = oend1
 	   rstart = INDEX( coaching(ostart1:oend1), '>' )
	   opt_replace = rstart .GT. 0
	   IF ( opt_replace ) THEN
	      rstart = ostart1 + rstart
	      oend1 = rstart - 2
	      IF ( rstart .GT. rend ) GOTO 5400	
	   ENDIF
	   IF ( ostart1 .GT. oend1 ) GOTO 5400
* ... if this option is "*" it matches anything   (2/94)
	   IF ( coaching(ostart1:oend1) .EQ. '*' ) GOTO 400
* ... does the GO argument provided match this option ?
	   vax_code = STR_CASE_BLIND_COMPARE( coaching(ostart1:oend1),
     .	                                      in_str(:len_out) )
	   IF ( vax_code .EQ. vms_str_success ) THEN
	      GOTO 400          ! we got a match
	   ELSEIF ( rend+1 .LT. oend ) THEN
	      ostart1 = rend + 2
	      GOTO 200		! text didnt match - check next option
	   ELSE
	      len_out = 0        ! the argument text given was unacceptable
	      opt_replace = .FALSE.
	      opt_failed  = .TRUE.
	   ENDIF
	ENDIF

* if no argument text is provided then use alternative
 400	IF ( opt_replace ) THEN
* ... replace the given argument with the option replacement text provided

* ... 3/95 allow "*" on the right hand side replacement text  e.g. $5%|*>"*"%
	   right_star = INDEX(coaching(rstart:rend),'*')
	   IF ( right_star .GT. 0 ) THEN
* --- start of star substitution
	      IF ( len_in + rend-rstart .GT. 255 ) GOTO 5100
* ... text preceding the "*"
	      IF ( right_star .GT. 1 ) THEN
	         out_str = coaching(rstart:rstart+right_star-1)	         
	         len_out = right_star
	      ELSE
	         len_out = 1
	      ENDIF
* ... replacement text of "*", itself
	      out_str(len_out:) = in_str
	      len_out = len_out + len_in - 1
* ... text following the "*"
	      IF ( rstart+right_star-1 .LT. rend ) out_str(len_out+1:) =
     .			coaching(rstart+right_star:rend)	         
	      len_out = len_in + rend-rstart
* --- end of star substitution
	   ELSE
* ... no star involved -- a simple substitution ...
	      out_str = coaching(rstart:rend)
	      len_out = rend - rstart + 1	
	   ENDIF
	ELSEIF ( len_out.EQ.0
     .    .AND. (.NOT.opt_failed .AND. default
     .           .OR. opt_failed .AND. def_replace) ) THEN 
* ... replace the given argument with the default replacement text provided
	   out_str = coaching(dstart:dend)
	   len_out = dend - dstart + 1
	ELSEIF ( len_out.EQ.0 ) THEN
* ... nothing worked - we have a substitution error
	   GOTO 5200
	ELSE
* ... the input text will do just fine as-is
	   out_str = in_str
	   RETURN
	ENDIF

* success
	RETURN

* error exits
 5000   RETURN
 5100   CALL ERRMSG( ferr_invalid_command, status,
     .       'command argument strings are too long', *5000)
 5200	risc_buff = sym_name
	CALL ERRMSG( errstat, status,
     .       'Valid value needed for '//risc_buff, *5900)
 5400	risc_buff = coaching
	CALL ERRMSG( ferr_syntax, status,
     .       'empty text string provided with ">": '//risc_buff, *5000 )
 5500	risc_buff = coaching
	CALL ERRMSG( ferr_syntax, status,
     .       'both default and error strings given: '//risc_buff, *5000 )

* display the supplied error string or list the allowed options
#ifdef NO_PASSED_CONCAT
 5900   risc_buff = coaching(ostart:oend)
	tmp_buff = sym_name
	IF ( errtxt ) THEN
	   CALL ERRMSG( ferr_nomessge, status,
     .       coaching(estart:eend), *5000)
!	   CALL WARN( coaching(estart:eend) )
	ELSEIF ( options ) THEN
	   tmp_buff = sym_name
	   IF (tmp_buff(1:1) .EQ. 'a') tmp_buff(1:1) = 'A'
	   iptr = TM_LENSTR1(tmp_buff)
	   IF (len_in .EQ. 0) THEN
	      CALL WARN
     . 	       (tmp_buff(:iptr)//' was missing or empty.')
           ELSE
	      CALL WARN
     . 	       (tmp_buff(:iptr)//' received was: '
     .					//in_str(:len_in))
	   ENDIF
	   tmp_buff = sym_name
	   CALL WARN
     .	    ('Valid '//tmp_buff(:TM_LENSTR1(tmp_buff))
     .	         //' choices are: '//coaching(ostart:oend))
	ENDIF
	GOTO 5000
#else
 5900	IF ( errtxt ) THEN
	   CALL ERRMSG( ferr_nomessge, status,
     .       coaching(estart:eend), *5000)
!	   CALL WARN( coaching(estart:eend) )
	ELSEIF ( options ) THEN
	   CALL WARN
     .	('Aggument  '//sym_name//' received was: '
     .					//in_str(:len_out))
	   CALL WARN
     .	('Valid '//sym_name//' choices are: '
     .					//coaching(ostart:oend))
	   CALL WARN
     .	('Valid '//sym_name//' choices are: '
     .					//coaching(ostart:oend))
	ENDIF
	GOTO 5000
#endif

	END

	SUBROUTINE DISP_LABELS( joint_cx, year, cal_id )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* put background labels onto plot - data set name and information
* about axes not apparent on the plot (eg. time and depth in an xy view)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 7/13/87 - extracted from DISP_SET_UP and modified
* revision 0.1 - 2/25/87 - allowed for non_geographic labels
* revision 0.2 - 4/1/88  - increased AX_TITLE size for units
* revision 0.3 - 9/8/88  - added relative position flags to PUT_LABEL calls
* revision 0.4 - 9/21/88 - don't update label positions if /NOLABEL
* 			 - added time axis style: document year if taxis doesn't
*	(bug: the year displayed should be the minimum from all the contexts.
*		... laziness prevents me. *sh* )
* revision 0.5 -  9/1/89 - suppress "N/A" labelling of normal axes
* V200:  6/27/89 - ct-->cx for stylistic consistency
*		 - base axis labelling needs on cx_lo_ww vs. mnormal
*		 - check all variables in list to see if labels are needed
*	12/19/89 - eliminated the possibility of multiple data set variables
*	  1/4/89 - major revisions incorporating keys
* Unix/RISC port 5/91 *sh*: use data set name, only (full path is too long)
* V401: 6/23/95 - tag the movable labels by passing ppl_movlab minus nnn
* V510 *sh* 3/00 - add DODS URL label
* V530 *acm* 3/01 - add calendar name (if not Gregorian calendar)
* v533 *acm* 8/01 - test for calendar label had .LT. max_calendars; needs .LE.
*      *acm* 10/01  remove VMS includes
* V580 *acm* 11/04 - bug 1098 url is cut off; keep going to the last /
* V581: *acm*/3/05 - increase length of strings for dataset title to 1024
* V68  *acm*  4/11 - more on bug 1098. Call the url the OPeNDAP label, break it up.
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V7   *acm* 6/16 see ticket 2435. Tweak to split dataset labels after DATA SET:
* v74+ *acm* 5/18 See PyFerret issue #53: if the title is blank don't set up 
*                 the label or the symbol labnum_datitl
* v74+ *acm* 7/18 For plots of DSG data, write the upper-left labels as world coords
* v751 *acm* 9/18 Updates for user-defined variables on DSG grids

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'ferret.parm'
	include 'plot_setup.parm'
	include 'xplot_setup.cmn'
	include 'xcontext.cmn'
	include 'xtext_info.cmn'
	include 'axis_inc.decl'	! axis lengths
	include 'AXIS.INC'	! axis lengths
	include 'calendar.decl'
	include 'calendar.cmn'

* calling argument declarations:
	INTEGER		joint_cx, cal_id
	CHARACTER	year*4

* internal variable declarations:
	LOGICAL		show_year, has_mask
	CHARACTER	AX_TITLE*32, TM_GET_CALENDAR_NAME*32,
     .			line_buff*1024, genl_buff*255, cal_buff*32
	INTEGER		TM_LENSTR, TM_DSG_DSET_FROM_GRID, 
     .			idim, len, lablen,
     .			nlabs, dset_num, tlen, lab2, grid, dset_dsg
	REAL 		ul_yspace, ul_labht, ul_ypos, ul_ysqueeze,
     .			yoff, ur_labht
	EQUIVALENCE	( ppl_buff, genl_buff )	! save space

* extra upper left label to display the year ?(in case its not on the time axis)
	nlabs = ul_nlabs
	show_year = year .NE. unspecified_name4
	IF ( show_year ) nlabs = nlabs + 1
        IF (cal_id .GT. GREGORIAN .AND. cal_id .LE. max_calendars) 
     .     nlabs = nlabs + 1

* need to reduce size of upper left labels ?
	IF     ( nlabs .LE. 2 ) THEN
	   ul_ysqueeze = 1.0
	ELSEIF ( nlabs .EQ. 3 ) THEN
	   ul_ysqueeze = 0.85
	ELSE
	   ul_ysqueeze = 0.65
	ENDIF
	ul_yspace = ul_yspace0 * ul_ysqueeze
	ul_labht  = ul_labht0  * ul_ysqueeze

* define the position labels ("LATITUDE:", "DEPTH:", etc)
* ... stack them above one another in the upper left

        grid = cx_grid(joint_cx)
        dset_num = cx_data_set(joint_cx)
        IF (dset_num .GT. pdset_irrelevant) THEN
	   dset_dsg = TM_DSG_DSET_FROM_GRID( grid )
           IF (dset_dsg .GT. pdset_irrelevant) THEN
	      IF ( dsg_ragged(dset_dsg) ) grid = dsg_xlate_grid(dset_dsg) 
	      cx_grid(joint_cx) = grid
	      cx_data_set(joint_cx) = dset_dsg
	   ENDIF
        ENDIF

	ul_ypos = ul_yorigin + (nlabs-1)*ul_yspace
	DO 300 idim = 1, nferdims
	   IF ( ul_dolab(idim) ) THEN
	      CALL ASCII_LIMITS( joint_cx, idim, line_buff, len )

	      IF (idim .EQ. e_dim) THEN

		 CALL GET_DSG_MASK_TITLE (dset_num, genl_buff, has_mask, tlen)
		 IF (has_mask) THEN
		    IF (tlen .GT. 0) THEN
		       line_buff = 'Subset, '//genl_buff(:tlen)
		    ELSE 
		       line_buff = '(subset selected)'
		    ENDIF
		 ELSE
		    
		 ENDIF
		 
		 len = TM_LENSTR(line_buff)

	      ENDIF

	      genl_buff = AX_TITLE( idim, grid, tlen )

	      CALL PUT_LABEL( ppl_movlab-idim, ul_xorigin, ul_ypos,
     .			      ppl_left_just,
     .			      ul_labht,
     .			      genl_buff(:tlen)//' : '//line_buff(:len), 
     .			      lab_loc_absolute, lab_loc_axlen_plus )
	      ul_ypos = ul_ypos - ul_yspace
	   ENDIF
 300	CONTINUE

* ... add "YEAR : ($" ! kludge - unless year value indicates climatology
	IF ( show_year ) THEN
	   IF ( year .EQ. ' ' ) THEN
	         line_buff = 'climatology'
	         lablen = 11
	   ELSE
	         line_buff = year
	         lablen = 4
	   ENDIF
	   CALL PUT_LABEL( ppl_movlab-ppl_year, ul_xorigin, ul_ypos,
     .			ppl_left_just,
     .			ul_labht,
     .			'YEAR : '//line_buff(:lablen),
     .			lab_loc_absolute, lab_loc_axlen_plus )
	   ul_ypos = ul_ypos - ul_yspace
	ENDIF

* calendar label needed ?
        IF (cal_id .GT. GREGORIAN .AND. cal_id .LE. max_calendars) THEN
           cal_buff = TM_GET_CALENDAR_NAME (cal_id)
           lablen = TM_LENSTR(cal_buff)

	   CALL PUT_LABEL( ppl_movlab-ppl_calendar, ul_xorigin, ul_ypos,
     .			   ppl_left_just,
     .			   ul_labht,
     .			   'CALENDAR: '//cal_buff(:lablen), 
     .			   lab_loc_absolute, lab_loc_axlen_plus )
	ENDIF


* data set labels needed ?
	dset_num = cx_data_set( joint_cx )
	IF (  dset_num .NE. unspecified_int4
     .	.AND. dset_num .NE. pdset_irrelevant ) THEN
* ... name of data set
! 5/91	   CALL GET_DSET_NAME( dset_num, line_buff, lablen )
	   CALL GET_SHORT_DSET_NAME( dset_num, line_buff, lablen )

           yoff = ul_yorigin
           ur_labht = ul_labht0
	   IF ( ds_des_name(dset_num)(1:7) .EQ. 'http://' ) THEN
              yoff = ul_yorigin - 0.5*ul_yspace
              ur_labht = 0.75*ul_labht0
	   ENDIF
	   CALL BOX_LABEL( ppl_movlab-ppl_dset, 
     .			   'DATA SET: '//line_buff(:lablen),
     .			   0.0, yoff,
     .			   0.45*xlen,  1.5*letsize_dset_title,
     .			   ur_labht, ppl_right_just,
     .			   lab_loc_axlen_plus, lab_loc_axlen_plus )

* ... title of data set
	   CALL GET_DSET_TITLE( dset_num, line_buff, lablen )
	   IF (TM_LENSTR(line_buff) .GT. 0) 
     .	   CALL BOX_LABEL( ppl_movlab-ppl_datitl, line_buff(:lablen),
     .			   0.5, 0.3, 0.8*xlen, 1.5*letsize_dset_title,
     .			   letsize_dset_title, ppl_centered,
     .			   lab_loc_axlen_times, lab_loc_axlen_plus )
* ... OPeNDAP URL of data set
* bug 1098 url is cut off; keep going to the last /

	   IF ( ds_des_name(dset_num)(1:7) .EQ. 'http://' ) THEN
	      lablen = INDEX(ds_des_name(dset_num)(8:),'/')
              lab2 = lablen
              DO WHILE (lab2 .GT. 0)
 	         lab2 = INDEX(ds_des_name(dset_num)(8+lablen:),'/')
                 lablen = lablen + lab2
	      ENDDO
	      lablen = INDEX(ds_des_name(dset_num)(8+lablen:),'/')
     .		     + 7 + lablen

              yoff = ul_yorigin + 0.5*ul_yspace
	      CALL BOX_LABEL( ppl_movlab-ppl_dodsurl, 
     .			   'OPeNDAP URL: '//ds_des_name(dset_num)(:lablen),
     .			   0.0, yoff,
     .			   0.4*xlen,  1.5*letsize_dset_title,
     .			   ur_labht, ppl_right_just,
     .			   lab_loc_axlen_plus, lab_loc_axlen_plus )

	   ENDIF
	ENDIF


	RETURN
	END

	SUBROUTINE READ_BINARY ( memory, cx, mr, status )
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* read a stream formatted file 
* stolen from read_ez

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* 7/98 *js*  First version hacked from read_ez
* 3/99 *kob* - nag F90 wants to use eqv for logical expressions
* V552 4/03 *acm* Up VAR_CODE to 128 characters
* V552 5/03 *acm* Use ds_des_name(data_set) when opening the data; it has
*                 the pathname as well as the filename
* v604 *acm* 7/07 increase length of ds_name
* V63  *acm* 10/09 Changes for gfortran build
*       *acm* 3/12 cleanup old VMS ifdef
* V685 *acm* 1/13  Ticket 2030: if we run out of memory, issue a new message

	include	'tmap_errors.parm'
	include	'tmap_dims.parm'
	include	'xdset_info.cmn_text'
	external xdset_info_data
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xstep_files.cmn_text'
	external xstep_files_data
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'
	include	'xtext_info.cmn'

* calling argument declarations:
	INTEGER	cx, mr, status, fstatus
	REAL	memory( mem_blk_size, max_mem_blks ), fdummy(1)

* functions
	INTEGER BR_OPEN, BR_READ, BR_ADD_VAR

* internal variable declarations:
	INTEGER		nferdimsp1 
	PARAMETER	(nferdimsp1 = nferdims+1)
	INTEGER 	CGRID_SIZE, 
     .			idim, ask_var, category, data_set, grid, ivar,
     .			fvar, nvar20, the_var, nleft, 
     .			cx0, cx1, cx20(20), mr20(20),
     .			mr1, rec1, scnt,
     .			rec_to_read, nrepeat, columns, num_names, buffblk
	INTEGER         lengths(nferdimsp1), permutes(nferdimsp1), skip, doRead
	LOGICAL         firstTime
	CHARACTER	VAR_CODE*128
	CHARACTER*256   cerrmsg,ferrmsg
        CHARACTER*1024  cname

* --- end of introductory code ---

* nvar20  and the_var - value from 1 to 20      --> variable # within EZ set
* ask_var and fvar    - value from 1 to maxvars --> var # within DSET common

* initialize
	cx0 = cx_stack_ptr
	data_set = cx_data_set( cx )
	category = cx_category( cx )
	ask_var  = cx_variable( cx )
	grid = cx_grid( cx )
	fvar      = 0
	nvar20    = 0
	rec_to_read = 2**30      ! was 99999 - limited file reads
	firstTime = .true.
	skip = 0
	doRead = 0

* how many values of each variable are repeated on each record ?
	columns = ds_ntuple(data_set)
	num_names = ds_basic_axes(1, data_set)
	nrepeat = columns / num_names

* purge from memory any variables from this data set to avoid duplication
* (1 variable may be deleted at any time by memory management but this routine
*  always reads all of 'em)
* note: problem arises if variable is in use
!	CALL PURGE_DSET( data_set )

* create a memory variable for each of up-to-20 variables in the file
	DO ivar = 1, 20

* ... locate the next variable in this data set
	   DO fvar = fvar+1, maxvars
	      IF ( ds_var_setnum( fvar ) .EQ. data_set ) then
* ... is it a dummy '-' placeholder in the variable list ?
 		 IF (INDEX( ds_var_code(fvar),'-') .EQ. 0 ) THEN

* save record of which is the desired var
		    nvar20 = nvar20 + 1
		    IF ( fvar .EQ. ask_var ) the_var = nvar20

* ... create a context describing this variable
		    CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
		    IF ( status .NE. ferr_ok ) RETURN
		    cx20(nvar20) = cx_stack_ptr
		    CALL TRANSFER_CONTEXT( cx, cx_stack_ptr )
		    cx_variable( cx_stack_ptr ) = fvar
		    cx_grid( cx_stack_ptr ) = ds_grid_number( fvar )
		    cx_bad_data( cx_stack_ptr ) = ds_bad_flag( fvar ) ! 12/93 add'n
		    DO idim = 1, nferdims
		       cx_lo_ss( cx_stack_ptr, idim ) = ds_grid_start( idim, fvar )
		       cx_hi_ss( cx_stack_ptr, idim ) = ds_grid_end  ( idim, fvar )
		       cx_by_ss( idim, cx_stack_ptr ) = .TRUE.
* 3/99 *kob* - nag F90 wants to use eqv for logical expressions
		       if (firstTime .eqv. .TRUE.) THEN
			  lengths(idim) = ds_grid_end(idim,fvar) - 
     .		          ds_grid_start(idim,fvar) + 1
		       end if
		       CALL CONFINE_AXIS( idim, cx_stack_ptr, status )
		       IF ( status .NE. ferr_ok ) RETURN
		       CALL FLESH_OUT_AXIS( idim, cx_stack_ptr, status )
		       IF ( status .NE. ferr_ok ) RETURN
		    END DO
		    firstTime = .FALSE.

*       read only what will fit into smallest grid
		    rec1 = CGRID_SIZE(cx_stack_ptr) / nrepeat
		    rec_to_read = MIN( rec_to_read, rec1 )

*       reserve and catalog space for the result
		    CALL CREATE_MEM_VAR( cx_stack_ptr, mr20(nvar20), status )
		    IF ( status .NE. ferr_ok ) GOTO 5000
		 END IF
	      END IF
	   END DO
	END DO

* point to asked-for variable and create dummy entries for the rest
 500	mr = mr20( the_var )
	DO nleft = nvar20+1, 20
	   mr20(nleft) = dummy_mr
	END DO
	
* allocate a buffer big enough for one record
        CALL GET_WORK_SPC( columns, buffblk, status )	! was "nrepeat" B4 3/95
	IF ( status .NE. merr_ok ) GOTO 5500

* Get the current permutation list
	CALL BR_GET_PERMUTES(permutes)

* Get the skip header
	do scnt = 1, maxstepfiles
	   if (sf_setnum(scnt) .EQ. data_set) then
	      skip = sf_skip(scnt)
	      goto 3000
	   end if
	end do
 3000	continue

* initialize the binary reader
!	call toChar(ds_name(data_set), cname)
	call toChar(ds_des_name(data_set), cname)
	if (BR_OPEN(cname, lengths, permutes,
     1      skip) .eq. 0) goto 6000

	fvar = 0
	nvar20 = 0
	DO ivar = 1, 20
	   DO fvar = fvar+1, maxvars
	      IF ( ds_var_setnum( fvar ) .EQ. data_set ) then
 		 IF (INDEX( ds_var_code(fvar),'-') .EQ. 0 ) THEN
		    doRead = 1
		    nvar20 = nvar20 + 1
		    fstatus = BR_ADD_VAR(memory(1, mr_blk1(mr20(nvar20))),
     1		                 doRead)
		 ELSE
		    doRead = 0
		    fstatus = BR_ADD_VAR(fdummy, doRead)
		 END IF
		 if (fstatus .EQ. 0) goto 6000
	      END IF
	   END DO
	END DO


* read the data
	if (BR_READ() .EQ. 0) goto 6000



* free up the buffer space
        CALL  RELEASE_WORK_SPC

* flag that all the data is available
	DO 800 ivar = 1, nvar20
	   mr1 = mr20(ivar)
	   mr_protected( mr1 ) = mr_not_protected
	   CALL MR_NOT_IN_USE( mr1 )
 800	CONTINUE

* the data region obtained may be inadequate for the request
* ("cx" is request, "cx1" is available)
	cx1 = cx20(the_var)
	DO 900 idim = 1, nferdims
	   IF ( cx_hi_ss(cx,idim) .GT. cx_hi_ss(cx1,idim) ) THEN
	      IF ( cx_hi_ss(cx_last,idim) .NE. unspecified_int4
     .	     .OR.  cx_given(idim,cx) ) THEN
* ... error: the user explicitly requested more than there is
	         GOTO 5600
              ELSEIF (cx_lo_ss(cx,idim) .GT. cx_hi_ss(cx1,idim)) THEN
* ... requested data is completely out of range of disk data (2/93 bug fix)
                 GOTO 5600
	      ELSE
* ... no error: the region was filled in by FERRET automatically
	         cx_hi_ss(cx,idim) = cx_hi_ss(cx1,idim)
	         cx_hi_ww(idim,cx) = cx_hi_ww(idim,cx1)
	      ENDIF
	   ENDIF
 900	CONTINUE

* successful completion
	cx_stack_ptr = cx0
	CALL BR_CLOSE()
	RETURN

* error exit
 4900	nvar20 = nvar20 + 1		! delete all
 5000	cx_stack_ptr = cx0
	IF (nvar20 .GT. 1) THEN
	   WRITE ( ferrmsg, 1000 ) nvar20
           CALL WARN (ferrmsg)
	ENDIF
 1000   FORMAT ('Binary file reading: Insufficient memory reading variable ', i4)
	DO 5010 nleft = 1, nvar20-1	! delete all except last
 5010	CALL DELETE_VARIABLE(mr20(nleft))
        CALL  RELEASE_WORK_SPC
	CALL BR_CLOSE()
 5500	RETURN
 5600	CALL ERRMSG( ferr_limits, status,
     .		ww_dim_name(idim)//' axis of '//VAR_CODE(cat_file_var,ask_var),
     .		*5500 )
 6000	CALL BR_GET_ERROR(cerrmsg)
	CALL TM_CTOF_STRNG(cerrmsg, ferrmsg, 255)
	CALL TM_SPLIT_MESSAGE(err_lun, ' **ERROR: '//ferrmsg(1:LEN(ferrmsg)))
        CALL ERRMSG( ferr_TMAP_error, status, ' ', *4900 )
	END	

c-------------------------------------------------------------------------------
c     Convert a Fortran string to a zero delimited C string

      subroutine toChar(fstring, cstring)
      character*(*) fstring, cstring

      integer TM_LENSTR1
      integer length
      
      length = TM_LENSTR1(fstring)
      cstring = fstring(1:length)
      cstring(length+1:length+1) = char(0)
      return
      end

	SUBROUTINE GKSMV_makedot
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
*	Mod 1.9.90 J Davison to reduce the maximum #pts in any one call to 
*	polyline to 100 as GKS 4.0 under VMS 5.2, i.e., DECWindows, blows up
*	with too many points

*  8/2001  acm  for PLOT/SYMBOL=DOT
*  Version of GKSMV to be called by make_dot.  Call GPM for polymarker
*  rather than GPL (polyline) 
*
*  10/2001 Buffer calls to GPM.  Rename X and Y to xdot, ydot for clarity.
* V73  3/18 *kms*  For clarity, append MD to makedot.cmn values IPT, XDOT, 
*                  and YDOT; make MDOT (99) a makedot.cmn parameter DOTSYMIM
* V741 7/18 *acm*  Issue #1881
*                  Reset IPTMD after the call to plot a buffer's worth pf points

C
C	This routine creates a binary file that can be used to
c	construct device dependent plotting code
c
c
	include 'pltcom_dat.decl'
	include 'PLTCOM.DAT'
	include 'gkscm1_inc.decl'
	include 'GKSCM1.INC'

	IF(.NOT.GKSOPN)THEN
#ifdef core
            call crinit
#else
	    call gkinit
C
	    CALL GCLRWK(WSID,0)
#endif
	    GKSOPN=.TRUE.
	    LPEN=.NOT.PEN
	ENDIF

	IF(PEN)THEN
	  CALL GKPLOT_makedot(A,B,1)
	ELSE
	  CALL GKPLOT_makedot(A,B,0)
	ENDIF

	RETURN
	END

	SUBROUTINE GKPLOT_makedot(XN,YN,IP)
#ifdef core
        if(ip.ne.0)then
            call lineabs2(xn,yn)
        else
            call moveabs2(xn,yn)
        endif
#else
        INCLUDE         'makedot.cmn'    ! 10/01 *acm*

	IF(IP.EQ.0)THEN
	    CALL DOIT_makedot(IPTMD,XDOTMD,YDOTMD)
	    IPTMD=1
	ELSE
	    IPTMD=IPTMD+1
	    IF(IPTMD.GE.MAXDOT)THEN
		CALL DOIT_makedot(IPTMD,XDOTMD,YDOTMD)
		IPTMD=2
		XDOTMD(1)=XDOTMD(MAXDOT)
		YDOTMD(1)=YDOTMD(MAXDOT)
	    ENDIF
	ENDIF
	XDOTMD(IPTMD)=XN
	YDOTMD(IPTMD)=YN
#endif
	RETURN
        END

	SUBROUTINE DOIT_makedot(ipt,xdot,ydot)
	DIMENSION xdot(*),ydot(*)
	IF(ipt.LE.0)RETURN
	IF(ipt.EQ.1)THEN
	    xdot(2)=xdot(1)
	    ydot(2)=ydot(1)
	    ipt=2
	ENDIF
	CALL GPM(ipt,xdot,ydot)
	RETURN
	END

	SUBROUTINE TM_INIT_DYN_GRIDS

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Initialize machinery for dynamic grids and lines

* Steve Hankin  NOAA/PMEL/TMAP
*
* 9/13/95 for Ferret version 4.2
* V510 *sh* 3/00 - initialize "hooks" for managing temporary grids and lines
*      *sh* 5/00 - set line_keep_flag everywhere to FALSE
* V570 *acm*5/04 - remove line_has_edges flag; never used.
* V720 *sh* 4/17 - initialize malloc'ed line memory 

* Include files
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'implicit.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xdyn_linemem.cmn_text'

* Argument definitions

* Local definitions
	INTEGER i, lm


***** GRIDS *****
* grid(max_grids) is used as the chain start for the "in-use" grids
	grid_flink(max_grids) = max_grids	! points to self: empty chain

* grid(tmp_grid_hook) is used as the chain start for the "temporary" grids
	grid_flink(tmp_grid_hook) = tmp_grid_hook  ! points to self: empty

* no "dynamic" grids (above max_grids) are "used" (yet)
	DO 100 i = 1, max_dyn_grids
 100	grid_use_cnt(i) = 0

* all the "dynamic" grids (eq to or above max_grids) in the "free" linked list
	grid_free_ptr = max_grids+1
	DO 200 i = max_grids+1, max_dyn_grids
 200	grid_flink(i) = i+1
	grid_flink(max_dyn_grids) = 0	! end of chain

***** LINES *****
* line(max_lines) is used as the chain start for the "in-use" lines
	line_flink(max_lines) = max_lines	! points to self: empty chain

* line(tmp_line_hook) is used as the chain start for the "temporary" lines
	line_flink(tmp_line_hook) = tmp_line_hook  ! points to self: empty

* no "dynamic" lines (above max_lines) are "used" (yet)
	DO 300 i = 1, max_dyn_lines
	   line_use_cnt  (i) = 0
	   line_keep_flag(i) = .FALSE.
 300	CONTINUE
	DO 310 i = max_lines+1, max_dyn_lines
	   line_parent(i) = 0
	   line_class (i) = pline_class_basic
 310	CONTINUE

* all the "dynamic" lines (eq to or above max_lines) in the "free" linked list
	line_free_ptr = max_lines+1
	DO 400 i = max_lines+1, max_dyn_lines
 400	line_flink(i) = i+1
	line_flink(max_dyn_lines) = 0	! end of chain

* initialize the malloc-created line memory
	free_dyn_line(plm_free_base) = 1
	DO lm =  1, max_lm
	   free_dyn_line(lm) = lm+1
	   lm_size(lm) = 0
	   CALL TM_NULLIFY_LM(lm)
	ENDDO
	free_dyn_line(max_lm) = plm_free_base  ! loop back to list start

	RETURN

	END

      FUNCTION IGRNPT(window_id, show_menu, X,Y)
C** 
C**    @(#)igrinpt.F	1.2    3/27/88

*    modified 6/99 for Ferret V500 *sh* -- added new arguments and
*       return COMMON XGRINPT with information about what was digitized
*       New arguments:
*               show_menu
*    Note: this routine should really be split into two -- one to put up
*       the choice menu, another to get the position input. Taking the lazy
*       approach now ...
*
* v5.11 *kob* 5/00 - added ifdef to check for f90 - if so have to
*                    initialize has_new_mouse w/in block data since it
*                    exists in common
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     IGRNPT(X,Y)
C
C     THIS FUNCTION ALLOWS THE USER TO INPUT GRAPHICS INFORMATION
C     FROM A TEKTRONIX GRAPHICS TERMINAL TO HIS PROGRAM.  ON ALL
C     TEKTERMINALS OTHER THAN THE PLOTTERS, WHEN IGRNPT IS
C     CALLED, A FULL-SCREEN CROSS-HAIR CURSOR APPEARS.  THE CROSS
C     HAIR MAY BE POSITIONED ON THE SCREEN BY USE OF THE THUMB-
C     WHEELS OR JOYSTICK AS APPROPRIATE.  THE USER CAN CAUSE THE
C     COORDINATES OF THE CROSS HAIR TO BE SENT TO IGRNPT BY EN-
C     TERING A CHARACTER FROM THE KEYBOARD.  THE ASCII CODE FOR
C     THIS CHARACTER IS RETURNED AS THE VALUE OF THE FUNCTION, AND
C     THE COORDINATES IN USER'S UNITS ARE RETURNED IN THE PARAM-
C     ETERS.  ON THE TEKTRONIX PLOTTER, WHEN IGRNPT IS CALLED,
C     THE PROMPT LIGHT (4662) OR POINT LIGHT (4663) IS TURNED ON.
C     IF NECESSARY, THE PEN MAY BE POSITIONED BY USE OF THE JOY-
C     STICK.  THE USER CAN CAUSE THE COORDINATES OF THE PEN TO BE
C     SENT TO IGRNPT BY MOMENTARILY DEPRESSING THE CALL BUTTON
C     (4662) OR A POINT FUNCTION (4663).  THE PEN POSITION (0 =
C     UP, 1 = DOWN) IS RETURNED AS THE VALUE OF THE FUNCTION, AND
C     THE COORDINATES IN USER'S UNITS ARE RETURNED IN THE PARAM-
C     ETERS.
C
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Mods J Davison 3.21.94 for xgks
*	1) Change PET to 3
*	2) Change echo area for xgks coords in GINCH and not call GINLC
* 	*jd* linux port 12.96 change hp -> NEED_IAND for CPP choices

C
C V6.3 *acm* 9/09 Allow mouse clicks in windows other than window 1.
C            Note we get wrong rewults if the plot is in a viewport.
C
        LOGICAL show_menu
	INTEGER window_id
#ifndef core
C
C	GKS DATA FOR CHOICE AND LOCATOR INPUT
C
	INTEGER*4 SIZES(5),PET
	INTEGER*4 ERRIND,MODE,ESW,LDR,ISTAT,ICHOICE
	INTEGER*4 XFORM,WSTYPE,DCUNIT,NULLI
	INTEGER   CHCE(5)
	CHARACTER*10 STRING(5)
	CHARACTER*80 RECORD(10),CONID
	REAL EAREA(4),LOCX,LOCY,WIND(4),VIEW(4),NULLR
#else
	include 'CORECM.INC'
c
	integer initializedevice,setechoposition
	integer setecho,setechosurface
	integer awtbuttongetloc2,terminatedevice
	logical lablin
#endif
	CHARACTER*1 IMODE
	DIMENSION IN(8)
#ifdef unix
	INTEGER*2 T4662N(3),T4662F(3),T4663(6)
#else
	byte INN(8)
	byte T4662N(3),T4662F(3),T4663(6)
#endif
C
#ifdef unix
	include 'PLTCOM.DAT'
        include 'xgrinpt.cmn'
#else
	include 'pplinc:PLTCOM.DAT'
#endif
        integer iwkid
C
#ifndef core
	DATA CHCE/70,76,82,67,32/
#else
	data lablin/.false./
#endif
C
C
C
	DATA T4662N/27,67,75/,T4662F/27,67,76/,
     *  T4663/27,67,65,71,49,59/


CC	Linux port:
	integer octal37

#ifdef FORTRAN_90
	data 	octal37/O'37'/
#else
	data 	octal37/'37'O/
#endif

#ifdef FORTRAN_90
        external XGRINPT_BLKDAT
#else
        DATA has_new_mouse/ .FALSE. /   ! at program initialization
#endif


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C
C     SET ALPHAS MODE.
C
      IMODE = PMODE
      PMODE = ALPHA
C
C     IF THE LAST POINT WAS NOT PLOTTED BECAUSE THE PEN WAS UP,
C     PLOT THE POINT NOW.
C
      IF(SAVEF)CALL XYZPLT
C
C     RESTORE THE CURRENT PLOTTING MODE.
C
      PMODE = IMODE
C
C     CHECK THE PLOT TYPE.
C
	IF(PTYPE.GE.3)THEN
#ifdef core
c	    core device
c
c       locator stuff
c
        istat=initializedevice(LOCATOR,1)
        istat=initializedevice(BUTTON,1)
        istat=initializedevice(BUTTON,2)
        istat=initializedevice(BUTTON,3)
        istat=setechosurface(LOCATOR,1,vsurf)
	if(lablin)then
	    istat=setechoposition(LOCATOR,1,xsv,ysv)
	    istat=setecho(LOCATOR,1,2)
	else
            istat=setecho(LOCATOR,1,1)
	endif
c
        istat=awtbuttongetloc2(100000000,1,ibut,xout,yout)
        istat=awtbuttongetloc2(250000,1,ibut2,xout2,yout2)
        if(ibut2.ne.0.and.(.not.lablin))then
c
c       button pushed twice
c
            lablin=.true.
	    xsv=xout
	    ysv=yout
        else
            lablin=.false.
        endif
	if(bsize/asize .gt. 0.75)then
	    aold=xout*bsize/0.75
	    bold=bsize*yout/0.75
	else
	    aold=asize*xout
	    bold=yout*asize
	endif
	if(lablin)then
	    if(ibut.eq.1)then
		igrnpt=70
	    else
		igrnpt=76
	    endif
	else
	    if(ibut.eq.1)then
		igrnpt=32
	    else if(ibut.eq.2)then
		igrnpt=67
	    else
		igrnpt=82
	    endif
	endif
        istat=terminatedevice(BUTTON,1)
        istat=terminatedevice(BUTTON,2)
        istat=terminatedevice(BUTTON,3)
        istat=terminatedevice(LOCATOR,1)
#else
C
C	    GKS DEVICE
C
	    CALL PPLGFLUSH
	    iwkid = window_id  
	    CALL GQCHS(iwkid,1,10,ERRIND,MODE,ESW,ISTAT,ICHOICE,
     *	    PET,EAREA,LDR,RECORD)
	    STRING(5) = 'Left'
	    STRING(4) = 'Center'
	    STRING(3) = 'Right'
	    STRING(2) = 'Line'
	    STRING(1) = 'Arrow'
	    SIZES(5) = 4
	    SIZES(4) = 6
	    SIZES(3) = 5
	    SIZES(2) = 4
	    SIZES(1) = 5

#ifndef xgks
	    PET = 1
	    EAREA(1)=0.0
	    EAREA(2)=0.1
	    EAREA(3)=0.0
	    EAREA(4)=0.1
#else
            PET = 3
	    EAREA(1)=10.0
	    EAREA(2)=250.0
	    EAREA(3)=10.0
	    EAREA(4)=250.0
#endif
	    LDR=5
	    IRECSZ=10

	    CALL GPREC(0,NULLI,0,NULLR,5,SIZES,STRING,IRECSZ,
     *	    ISTAT,LDR,RECORD)
	    CALL GINCH(iwkid,1,1,5,PET,EAREA(1),EAREA(2),EAREA(3),
     *	    EAREA(4),LDR,RECORD)

        IF (show_menu) THEN     ! **************
	    CALL GRQCH(iwkid,1,ISTAT,ICHOICE)       ! put up menu and get answer
        ELSE
            ichoice = 5         ! always left justified
        ENDIF                   ! **************
	    IGRNPT=CHCE(ICHOICE)
	    CALL GSVPIP(1,0,0)
	    CALL GQLCS(iwkid,1,1,7,ERRIND,MODE,ESW,XFORM,LOCX,LOCY,
     *	    PET,EAREA,LDR,RECORD)
	    PET = 3
	    CALL GQWKC(iwkid,ERRIND,CONID,WSTYPE)
	    CALL GQDSP(WSTYPE,ERRIND,DCUNIT,DCX,DCY,IRSX,IRSY)
	    EAREA(2)=DCX
	    EAREA(4)=DCY

#ifndef xgks
	    CALL GINLC(iwkid,1,XFORM,LOCX,LOCY,PET,EAREA(1),EAREA(2),
     *	    EAREA(3),EAREA(4),LDR,RECORD)
#endif
	    CALL GSLCM(iwkid,1,0,1)
	    CALL GRQLC(iwkid,1,ISTAT,XFORM,LOCX,LOCY)  ! get mouse click (X,Y)
	    CALL GQNT(XFORM,ERRIND,WIND,VIEW)
	    AOLD= LOCX
	    BOLD= LOCY
#endif
	    GOTO 20
	ENDIF
      IF(.NOT.(IABS(PTYPE).EQ.2.OR.PTYPE.EQ.1))RETURN
C
C     CHECK THE TEKTERMINAL TYPE.
C
      IF(TTYPE .EQ. 4006)RETURN
C
C     WRITE OUT THE CHARACTER BUFFER.
C
      IF(TTYPE .EQ. -4662 .OR. TTYPE .EQ. -4663)GO TO 10
C
C     SELECT CROSS-HAIR CURSOR ADDRESS INPUT MODE ON OTHER TEK-
C     TRONIX GRAPHICS TERMINALS AND TURN ON THE CROSS HAIR.
C
        CALL CHOUT(ESC,1)
        CALL CHOUT(26,1)
C
C     READ THE CHARACTER THAT IS ENTERED FROM THE KEYBOARD AND THE
C     FOUR ADDITIONAL CHARACTERS GENERATED BY THE TEKTERMINAL.
C
	CALL CHDMP
#ifdef unix
	call chin(in,5,0)
# ifdef NEED_IAND
       IGRNPT = IAND(IN(1),127)
# else
       IGRNPT = AND(IN(1),127)
# endif
#else
	call chin(inn,5,0)
	do 100 ik=1,5
100	in(ik)=inn(ik)
	igrnpt = iand(in(1),'177'O)
#endif
C
C     CHECK THE TEKTERMINAL TYPE.
C
      IF(TTYPE .LT. 4100 .AND. TTYPE .NE. 4014)THEN
#ifdef unix
# ifdef NEED_IAND
C
C     CALCULATE THE COORDINATES OF THE POINT.  10 BIT TEK401X
C
        AOLD = FLOAT(IOR(ISHFT(IAND(IN(2),octal37),5),IAND(IN(3),octal37)
     *   )) / PLTOTA + AMIN
        BOLD = FLOAT(IOR(ISHFT(IAND(IN(4),octal37),5),IAND(IN(5),octal37)
     *   )) / PLTOTB + BMIN
      ELSE
C
C     CALCULATE THE COORDINATES OF THE POINT.  12 BIT TEK41XX
C
        AOLD = FLOAT(IOR(ISHFT(IAND(IN(2),octal37),7),ISHFT(IAND(IN(3),
     *   octal37),2))) / PLTOTA + AMIN
        BOLD = FLOAT(IOR(ISHFT(IAND(IN(4),octal37),7),ISHFT(IAND(IN(5),
     *   octal37),2))) / PLTOTB + BMIN
# else
C
C     CALCULATE THE COORDINATES OF THE POINT.  10 BIT TEK401X
C
        AOLD = FLOAT(OR(LSHIFT(AND(IN(2),31),5),AND(IN(3),31)
     *   )) / PLTOTA + AMIN
        BOLD = FLOAT(OR(LSHIFT(AND(IN(4),31),5),AND(IN(5),31)
     *   )) / PLTOTB + BMIN
      ELSE
C
C     CALCULATE THE COORDINATES OF THE POINT.  12 BIT TEK41XX
C
        AOLD = FLOAT(OR(LSHIFT(AND(IN(2),31),7),LSHIFT(AND(IN(3),
     *   31),2))) / PLTOTA + AMIN
        BOLD = FLOAT(OR(LSHIFT(AND(IN(4),31),7),LSHIFT(AND(IN(5),
     *   31),2))) / PLTOTB + BMIN
# endif
#else
C
C     CALCULATE THE COORDINATES OF THE POINT.  10 AIT TEK401X
C
        AOLD = FLOAT(IOR(ISHFT(IAND(IN(2),octal37),5),IAND(IN(3),octal37)
     *   )) / PLTOTA + AMIN
        BOLD = FLOAT(IOR(ISHFT(IAND(IN(4),octal37),5),IAND(IN(5),octal37)
     *   )) / PLTOTB + BMIN
      ELSE
C
C     CALCULATE THE COORDINATES OF THE POINT.  12 BIT TEK41XX
C
        AOLD = FLOAT(IOR(ISHFT(IAND(IN(2),octal37),7),ISHFT(IAND(IN(3),
     *   octal37),2))) / PLTOTA + AMIN
        BOLD = FLOAT(IOR(ISHFT(IAND(IN(4),octal37),7),ISHFT(IAND(IN(5),
     *   octal37),2))) / PLTOTB + BMIN
#endif
      ENDIF
      GO TO 20
C
C     CHECK THE GRAPHICS FLAG.
C
   10 IF(.NOT. GRAPHF)THEN
C
C     TRANSMIT THE 'PLOTTER ON' COMMAND TO THE TEKTRONIX PLOTTER.
C
        CALL CHOUT(TEKON,3)
      ENDIF
C
C     CHECK THE TEKTERMINAL TYPE.
C
      IF(TTYPE .EQ. -4662)THEN
C
C     TURN ON THE PROMPT LIGHT ON THE TEKTRONIX 4662 PLOTTER AND
C     READ THE SEVEN CHARACTERS GENERATED BY THE PLOTTER.  THEN
C     TURN OFF THE PROMPT LIGHT.
C
        CALL CHOUT(T4662N,3)
	CALL CHDMP
#ifdef unix
	call chin(in,7,0)
#else
	call chin(inn,7,0)
#endif
        CALL CHOUT(T4662F,3)
      ELSE
C
C     SELECT OPERATOR DIGITIZE MODE ON THE TEKTRONIX 4663 PLOTTER
C     AND READ THE SEVEN CHARACTERS GENERATED BY THE PLOTTER.
C
        CALL CHOUT(T4663,6)
	CALL CHDMP
#ifdef unix
	call chin(in,7,0)
#else
	call chin(inn,7,0)
#endif
      ENDIF
#ifdef unix
#ifdef sun
	igrnpt = rshift(and(in(7),4),2)
#else
# ifdef NEED_IAND
      IGRNPT = ISHFT(IAND(IN(7),4),-2)
# else
      IGRNPT = LSHIFT(AND(IN(7),4),-2)
# endif
#endif
#else
	do 200 ik=1,7
200	in(ik)=inn(ik)
	igrnpt=ishft(iand(in(7),4),-2)	
#endif
C
C     CALCULATE THE COORDINATES OF THE POINT.
C
#ifdef unix
#ifdef sun
      AOLD=FLOAT(OR(OR(LSHIFT(AND(IN(1),31),7),LSHIFT(AND(IN(3),
     * 31),2)),rSHIFT(AND(IN(5),31),3))) / PLTOTA + AMIN
      BOLD=FLOAT(OR(OR(LSHIFT(AND(IN(2),31),7),LSHIFT(AND(IN(4),
     * 31),2)),rSHIFT(AND(IN(6),31),3))) / PLTOTB + BMIN
#else
# ifdef NEED_IAND 
      AOLD=FLOAT(IOR(IOR(ISHFT(IAND(IN(1),octal37),7),ISHFT(IAND(IN(3),
     * octal37),2)),ISHFT(IAND(IN(5),octal37),-3))) / PLTOTA + AMIN
      BOLD=FLOAT(IOR(IOR(ISHFT(IAND(IN(2),octal37),7),ISHFT(IAND(IN(4),
     * octal37),2)),ISHFT(IAND(IN(6),octal37),-3))) / PLTOTB + BMIN
# else
      AOLD=FLOAT(OR(OR(LSHIFT(AND(IN(1),31),7),LSHIFT(AND(IN(3),
     * 31),2)),LSHIFT(AND(IN(5),31),-3))) / PLTOTA + AMIN
      BOLD=FLOAT(OR(OR(LSHIFT(AND(IN(2),31),7),LSHIFT(AND(IN(4),
     * 31),2)),LSHIFT(AND(IN(6),31),-3))) / PLTOTB + BMIN
# endif
#endif
#else
      AOLD=FLOAT(IOR(IOR(ISHFT(IAND(IN(1),octal37),7),ISHFT(IAND(IN(3),
     * octal37),2)),ISHFT(IAND(IN(5),octal37),-3))) / PLTOTA + AMIN
      BOLD=FLOAT(IOR(IOR(ISHFT(IAND(IN(2),octal37),7),ISHFT(IAND(IN(4),
     * octal37),2)),ISHFT(IAND(IN(6),octal37),-3))) / PLTOTB + BMIN
C
#endif
C
C     TRANSMIT THE 'PLOTTER OFF' COMMAND TO THE TEKTRONIX PLOTTER.
C
      CALL CHOUT(TEKOFF,5)
C
C     TRANSFORM THE POINT TO THE USER'S COORDINATE SYSTEM.
C
   20 CALL TFORMI(XNEW,YNEW,ZNEW)
      PENF = .FALSE.
      SAVEF = .TRUE.
      X = XNEW / XSCALE
      Y = YNEW / YSCALE
* ACM * How to detect if the plot is in a viewport and 
*       therefore if the mouse click was outside the 
*       viewport, the results of the mouse-click are
*       garbage ??  This is not quite it...
c      IF (AOLD.LT.1 .OR. BOLD.LT.1) THEN
c         X = -1.0E+34
c	 Y = -1.0E+34
c      ENDIF

* 6/99 send the results back to Ferret through COMMON
        has_new_mouse = .TRUE.
        xmouse = x
        ymouse = y
	wmouse = iwkid

C
C     RESET THE GRAPHICS FLAG.
C
      GRAPHF = .FALSE.
C
C     CHECK THE PLOTTING MODE.
C
      IF(PMODE .EQ. ALPHA)CALL ALPHAS
      RETURN
C
      END

	subroutine epictlab
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)epictlab.F	1.1    3/10/88
C**
C**
C***********************************************************************        C**
C**                 EPIC
C**
C***********************************************************************        C**
C**
c
c  Reads PLOT5 x- and y-axis labels from EPIC key file for EPIC time series
c  data.  Also extracts plot title from time series header:  "description"
c  at "locaion (depth zz m)", where description is descript field if it's
c  non-blank, project/experiment/mooring otherwise.
c
c  Sets PPLUS symbols for depth, lat, long, comment lines from header,
c  xlab, ylab, project, mooring, descript from header.
c
c  Sets PPLUS symbols for CTD report-generator graph title with
c  info from first 4 lines of CTD header.
c
c  Programmed by N. Soreide, May 86.
c  Modified to set PPLUS symbol PPL$EPIC_DATAFILE(n), NNS, Aug 87.
c  Modified for CTD report-generator, NNS, Dec 87.
c
#ifdef unix
	include 'PARAMPL5.DAT'
	include 'COMDATF.INC'
	include 'COMEPV.INC'
	include 'COMEPS.INC'
	include 'COMVAR.INC'
	include 'COMTHDR.INC'
	include 'LABELS.INC'
	include 'DATA.INC'
#else
	include 'pplinc:parampl5.dat'
	include 'epicinc:comdatf.inc'
	include 'epicinc:comepv.inc'
	include 'epicinc:comeps.inc'
	include 'epicinc:comvar.inc'
	include 'epicinc:comthdr.inc'
	include 'pplinc:labels.inc'
	include 'pplinc:data.inc'
#endif
	character labsml*3,comment*97,cloc*8,sym*30
	character chalat*8,chalon*9,chapro*10,chaexp*5,chamoo*5
	character chadep*7
	character ctdcast*19,ctddate*14,ctdtime*13,ctdlat*12,ctdlon*14
	character cnumber*3,dnumber*3
	equivalence (chalat,theader(1)(6:13)),
     1	(chalon,theader(1)(22:30)),
     1	(chapro,theader(2)(36:45)),
     1	(chaexp,theader(2)(48:52)),
     1	(chamoo,theader(1)(48:52)),
     1	(chadep,theader(1)(39:45))
	equivalence (ctdcast,theader(1)(1:19)),
     1	(ctddate,theader(1)(23:36)),
     1	(ctdlat,theader(2)(1:12)),
     1	(ctdlon,theader(2)(15:28)),
     1	(ctdtime,theader(1)(40:52))
c
c  Read x- and y-axis labels from EPIC key file.
c
	call ekeyopn
	if (jx .gt. 0) then
	    call ekeyrd (varcd(jx),labsml,xlab,comment)
	    write (sym,100) 'XLAB',linen
100	    format ('*PPL$EPIC_', A, '(', I2.2, ')')
	    nchars=lenstr(xlab)
	    call putsym(sym,xlab(1:nchars),nchars,ier)
	endif
	if (jy .gt. 0) then
	    call ekeyrd (varcd(jy),labsml,ylab,comment)
	    write (sym,100) 'YLAB',linen
	    nchars=lenstr(ylab)
	    call putsym(sym,ylab(1:nchars),nchars,ier)
	endif
	call ekeycls
c
c  Read Graph Title and set PPLUS symbols
c
	if (lsctd) then
	    write (sym,100) 'LATITUDE',linen
	    call putsym(sym,ctdlat,12,ier)
	    write (sym,100) 'LONGITUDE',linen
	    call putsym(sym,ctdlon,14,ier)
	    write (sym,100) 'CAST',linen
	    call putsym(sym,ctdcast,19,ier)
	    write (sym,100) 'DATE',linen
	    call putsym(sym,ctddate,14,ier)
	    write (sym,100) 'TIME',linen
	    call putsym(sym,ctdtime,13,ier)
c
	    write (sym,100) 'CTD1HD',linen
	    call putsym(sym,theader(1)(1:52),52,ier)
	    write (sym,100) 'CTD2HD',linen
	    call putsym(sym,theader(2)(1:52),52,ier)
	    write (sym,100) 'CTD3HD',linen
	    call putsym(sym,theader(3)(1:52),52,ier)
	    write (sym,100) 'CTD4HD',linen
	    call putsym(sym,theader(4)(1:52),52,ier)
c
c  Get cast number into a PPLUS global symbol.  Strip blanks and
c  leading zeros from the cast number.
c
	    cnumber(1:3)=theader(1)(17:29)
	    if (cnumber(1:1) .eq. '0') then
		if (cnumber(2:2) .eq. '0') then
		    dnumber(1:)=cnumber(3:3)
		    idnum=1
		else
		    dnumber(1:)=cnumber(2:3)
		    idnum=2
		endif
	    else
		dnumber=cnumber
		idnum=3
	    endif
	    call stripit(dnumber(1:idnum),idnum,' ',cnumber,icnum)
	    if (icnum .eq. 0) then
		cnumber(1:1)=' '
		icnum=1
	    endif
	    write (sym,100) 'CASTNUM',linen
	    call putsym(sym,cnumber(1:icnum),icnum,ier)
	else
	    ipro=lenstr(chapro)
	    iexp=lenstr(chaexp)
	    imoo=lenstr(chamoo)
	    idep=lenstr(chadep)
	    write (sym,100) 'LATITUDE',linen
	    call putsym(sym,chalat,8,ier)
	    write (sym,100) 'LONGITUDE',linen
	    call putsym(sym,chalon,9,ier)
	    write (sym,100) 'PROJECT',linen
	    call putsym(sym,chapro,10,ier)
	    write (sym,100) 'EXPERIMENT',linen
	    call putsym(sym,chaexp,5,ier)
	    write (sym,100) 'MOORING',linen
	    call putsym(sym,chamoo,5,ier)
	    write (sym,100) 'DEPTH',linen
	    call putsym(sym,chadep,7,ier)
	    write (sym,100) 'COMMENT_DATA',linen
	    call putsym(sym,theader(6),lenstr(theader(6)),ier)
	endif
	write (sym,100) 'COMMENT_FIRST',linen
	call putsym(sym,theader(7),lenstr(theader(7)),ier)
	write (sym,100) 'COMMENT_SECOND',linen
	call putsym(sym,theader(8),lenstr(theader(8)),ier)
	write (sym,100) 'DATAFILE',linen
	call putsym(sym,datafile,lenstr(datafile),ier)
C
	if (lsctd) then
	    lab1(1:)=ctdcast//' '// ctddate//' '//
     1	    ctdlat//' '//ctdlon
	else
	    xlat=geo1(theader(1)(5:13))
	    xlon=geo1(theader(1)(22:30))
	    call geochar(xlat,xlon,cloc)
	    nd=lenstr(theader(4)(1:26))
	    write (sym,100) 'DESCRIPT',linen
	    call putsym(sym,theader(4)(1:26),26,ier)
	    if (nd.eq.0) then
c
c  descript is blank, so use proj/exp/moorname where these aren't blank.
c
		if (ipro .eq. 0) then
		    nlab=0
		else
		    lab1(1:22)=chapro
		    nlab=lenstr(lab1(1:22))
		endif
		if (iexp .ne. 0) then
		    lab1(nlab+1:22)=' / '//chaexp(1:iexp)
		    nlab=lenstr(lab1(1:22))
		endif
		if (imoo .ne. 0) then
		    lab1(nlab+1:22)=' / '//chamoo(1:imoo)
		endif
		nlab=lenstr(lab1(1:22))
	    else
c
c  use descript for title
c
		lab1 (1:26)=theader(4)(1:26)
		nlab=nd
	    endif
	    lab1(nlab+1:)=' at ' //
     1	    cloc // ' (' // theader(1)(33:45)
     1	    // ')'
	    lab1(1:)='@TR'//lab1
	endif
	return
	end

	INTEGER FUNCTION STR_MATCH( test, list, n )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* identify the test string by finding it in the given list

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 10/20/87
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

* calling argument declarations:
	INTEGER		n
	CHARACTER*(*)	test, list(n)

* internal variable declarations:
	INTEGER		STR_CASE_BLIND_COMPARE, i, vax_code

	include 'ferret.parm'
	include 'gfdl_vms.parm'

* look through the list of possibilities
	DO 100 i = 1, n
	   vax_code = STR_CASE_BLIND_COMPARE( test, list(i) )
	   IF ( vax_code .EQ. vms_str_success ) THEN
	      STR_MATCH = i
	      RETURN
	   ENDIF
 100	CONTINUE

* no luck - we didn't find it
	STR_MATCH = atom_not_found

	RETURN
	END

*
* is_element_of_str.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* August 2005
*
*  For string arguments, 
*  Return logical value (integer 1 or 0); If argument 1 takes on any of 
*  the values of the second argument, return 1, else 0.

*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE is_element_of_str_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      CHARACTER*100 fcn_desc
      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns 1 if first argument contains any of the ',
     .        'values in argument 2, else 0')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 2)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, ABSTRACT, 
     .     NORMAL, NORMAL, NORMAL)

      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'VAR')
      CALL ef_set_arg_desc(id, arg, 'data to test')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
      CALL ef_set_arg_type (id, arg, STRING_ARG)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'VALUES')
      CALL ef_set_arg_desc(id, arg, 'strings to search for')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
      CALL ef_set_arg_type (id, arg, STRING_ARG)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE is_element_of_str_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      INTEGER my_lo_l, my_hi_l

*
*     Use utility functions to get context information about the arguments.
*     Set the abstract X axis.
*

      my_lo_l = 1
      my_hi_l = 1
      CALL ef_set_axis_limits(id, X_AXIS, my_lo_l, my_hi_l)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE is_element_of_str_compute(id, arg_1, arg_2, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

*   string args need to be twice the length.

      REAL arg_1(2,mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .     mem1lot:mem1hit)
      REAL arg_2(2,mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .     mem2lot:mem2hit)
 
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .      memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      INTEGER id, arg
      INTEGER i, j, k, l
      INTEGER i1, j1, k1, l1
      INTEGER i2, j2, k2, l2
      INTEGER slen1, slen2
      CHARACTER text1*20, text2*20

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

C  Check for strings matching arg2

      i = res_lo_ss(X_AXIS)
      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      l = res_lo_ss(T_AXIS)

      result(i,j,k,l) = 0.

      DO 400 i2=arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS, ARG2)
      DO 300 j2=arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS, ARG2)
      DO 200 k2=arg_lo_ss(Z_AXIS,ARG2), arg_hi_ss(Z_AXIS, ARG2)
      DO 100 l2=arg_lo_ss(T_AXIS,ARG2), arg_hi_ss(T_AXIS, ARG2)

         DO 410 i1=arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS, ARG1)
         DO 310 j1=arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS, ARG1)
         DO 210 k1=arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS, ARG1)
         DO 110 l1=arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS, ARG1)

            arg = 1
            CALL ef_get_string_arg_element(id, arg, arg_1, 
     .                                           i1,j1,k1,l1, text1)
            CALL ef_get_string_arg_element_len(id, arg, arg_1, 
     .                                           i1,j1,k1,l1, slen1)


            arg = 2
            CALL ef_get_string_arg_element(id, arg, arg_2, 
     .                                           i2,j2,k2,l2, text2)
            CALL ef_get_string_arg_element_len(id, arg, arg_2, 
     .                                           i2,j2,k2,l2, slen2)

            IF (slen1 .EQ. slen2) THEN
               IF (text1(:slen1) .EQ. text2(:slen2)) THEN
                  result(i,j,k,l) = 1.
                  GO TO 9000
               ENDIF
            ENDIF

 110     CONTINUE
 210     CONTINUE
 310     CONTINUE
 410     CONTINUE

 100  CONTINUE
 200  CONTINUE
 300  CONTINUE
 400  CONTINUE
      
9000  RETURN

      END
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

	SUBROUTINE WLDFLE(DFN,FNM,EFN,ISTAT,IFLAG)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)wldfle.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C	WLDFLE uses a file template with a supplied file name
C	to create a new file name the uses the template to fill
C	in an unspecified parts.  For example, you can use .EPIC
C	as the template and whenever you do not explicitly specify
C	a file extension .EPIC will be used.
C
C	DFN -- character, the template file name
C	FNM -- character, the user supplied file name
C	EFN -- character, the new file name (output)
C	ISTAT -- INT*4, status flag =1 success
C	IFLAG -- INT*$, a flag that gives a great deal of information
C			regarding the way the substitution took place.
C
	IMPLICIT INTEGER*4 (L)
	IMPLICIT INTEGER*2 (W)

#ifdef STAR_1_SUPPORTED
	IMPLICIT integer*1 (B)
#else
	IMPLICIT BYTE (B)
#endif

	CHARACTER DFN*(*),FNM*(*),EFN*(*),RSA*81
#ifdef unix
	EFN=FNM
#else
	INCLUDE '($RMSDEF)'
	INCLUDE '($FABDEF)'
	INCLUDE '($NAMDEF)'
	INTEGER*4 MASK,ISTAT,IFLAG,SYS$PARSE
	DATA MASK/0/
C
C	DEFINE THE FAB AND NAM
C
	RECORD /FABDEF/ FAB
	RECORD /NAMDEF/ NAM
C
C	SET THE FAB
C
	FAB.FAB$B_BID=FAB$C_BID
	FAB.FAB$B_BLN=FAB$C_BLN
	FAB.FAB$L_DNA=%LOC(DFN)
	FAB.FAB$B_DNS=MIN0(LEN(DFN),127)
	FAB.FAB$L_FNA=%LOC(FNM)
	FAB.FAB$B_FNS=MIN0(LEN(FNM),127)
	EFN=' '
	FAB.FAB$L_FOP=IBSET(MASK,FAB$V_OFP)
	FAB.FAB$W_IFI=0
	FAB.FAB$L_NAM=%LOC(NAM)
C
C	SET THE NAM
C
	NAM.NAM$B_BID=NAM$C_BID
	NAM.NAM$B_BLN=NAM$C_BLN
	NAM.NAM$L_ESA=%LOC(EFN)
	NAM.NAM$B_ESS=MIN0(LEN(EFN),127)
C	nam.nam$b_nop=IBSET(MASK,NAM$V_NOCONCEAL)
	NAM.NAM$B_NOP=IBSET(MASK,NAM$V_SYNCHK)
C
C	NAM$V_SYNCHK
C
	NAM.NAM$L_RLF=0
	NAM.NAM$L_RSA=%LOC(RSA)
	NAM.NAM$B_RSL=81
	NAM.NAM$L_FNB=0
C
C	call the system parsing routine
C
	ISTAT=SYS$PARSE(FAB)
	I=NAM.NAM$B_ESL
	EFN(I+1:)=' '
	IFLAG=NAM.NAM$L_FNB
	ISEM=INDEX(EFN,';')
	L=IBITS(IFLAG,NAM$V_wild_ver,NAM$S_wild_ver)
C
C	if the version was wild carded, i.e. * then
C	append a * to the file name
C
	IF(I.EQ.ISEM.AND.L.NE.0)THEN
	    EFN(I+1:)='* '
	ENDIF
#endif
	RETURN
	END

	LOGICAL FUNCTION TM_DATE_OK( date, cal_id )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine whether a date string is acceptably formatted

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* 7/92 *sh* 
* V530: *acm* 12/00 alternative calendar types; cal_id
* v7441*acm* 12/18 Issue 1910: Allow dates in commands to be in ISO 8601 form, yyyy-mm-dd
* v751 *acm*  6/19 Issue 1940: Require two dashes before trying to parse as an ISO 8601
* v76  1/2020 *acm* Getting error-reporting correct, logical time_err set when an 
*                  error was reported  translating iso-times and time invalid on 
*                  the given calendar: no need for more messages, e.g. translate_limit

     include 'tmap_errors.parm'
#include "gt_lib.parm"
	include 'calendar.decl'
	include 'calendar.cmn'

* calling argument declarations:
      CHARACTER*(*) date
      INTEGER cal_id

* internal variable declarations:
      INTEGER	TM_LENSTR1, i, ib, yr, mth, day, hr, min, sec, 
     .		slen, dash1, dash2, status
      REAL*8	value
      CHARACTER c*1, buff*26, buff2*26

* local parameter declarations:
      CHARACTER*1     tab
      PARAMETER     ( tab = CHAR(9))

	TM_DATE_OK = .FALSE.

* First, is it a date at all?  At least, it must start with a digit
* and contain a colon or a dash.  (some of the tests from TM_DATE)

* skip leading blanks
	slen = TM_LENSTR1(date)
	ib = 0
	DO i = 1, slen
	   c = date(i:i)
	   IF ( c .EQ. ' ' .OR. c .EQ. tab ) THEN
	      ib = i
	   ELSE
	      GOTO 200
	   ENDIF
	ENDDO
* buff is blank
	RETURN

* is first character a digit ?
 200    IF ( c .LT. '0' .OR. c .GT. '9' ) RETURN

	buff = date
	IF (ib.GT.0) buff = date(ib+1:slen)
	slen = TM_LENSTR1(buff)

* is there a colon or a dash?
      IF ( INDEX( buff, ':') .EQ. 0 .AND. INDEX( buff, '-') .EQ. 0)  RETURN

* Try translating the date (without any fractional seconds).
      slen = TM_LENSTR1(buff)
      IF (INDEX(buff, '.') .GT. 0) slen = INDEX(buff, '.') - 1

      CALL TM_BREAK_DATE( buff(:slen), cal_id,
     .                   yr, mth, day, hr, min, sec, status )

c 300  CONTINUE

* If couldn't parse the date, is it an ISO8601 formatted date? Is so translate 
* the date string to default date format.

      IF (status .NE. merr_ok) THEN
      
* Require 2 dashes to translate as an ISO8601 date
* Not starting with a dash, but at least with yy-

	 TM_DATE_OK = .FALSE.
	 dash1 = INDEX(buff, '-') 
	 IF (dash1 .LT. 3) GOTO 5000 
	 buff2 = buff(dash1+1:slen)
	 dash2 = INDEX(buff(dash1+1:slen), '-')
	 IF (dash2 .EQ. 0) GOTO 5000
         
	 CALL TM_DATE_REFORMAT( buff, pdate_numslashnum, cal_id,
     .                          buff2, pdate_vax, .TRUE., status)
	 IF ( status .EQ. merr_ok ) date = buff2
         IF (status .NE. merr_ok) time_err = .TRUE.

      ENDIF

      TM_DATE_OK = status .EQ. merr_ok


 5000 RETURN
      END

	SUBROUTINE AGG_CLEAN_GRIDS( dset, agg_dim, ens_ax, tlag_ax  )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* check among the temporary grids for duplicates. Remove duplication.
* Ensure that distinct grids have distinct names.

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V698 1/16 *sh* based upon code from CD_CLEAN_GRIDS
*      2/16 *sh* if identical pre-existing agg axes exists, re-use them

* argument definitions:
*       dset    - pointer to aggregated data set (input)
*	agg_dim	- axis of aggregation (E_dim or F_dim)  (input)
*	ens_ax	- aggregation axis of the ensemble (input)
*	tlag_ax	- time axis (F aggregation, only) (input)

* include files
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
        include 'xbuild_grids.cmn'
	include 'xtm_grid.cmn_text'
	include 'xdset_info.cmn_text'
        include 'netcdf.inc'

* argument declarations
	INTEGER	 dset, agg_dim, ens_ax, tlag_ax

* local variable declarations:
	LOGICAL TM_SAME_GRID_DEF, have_prev_ens, have_prev_tlag
	INTEGER TM_FIND_LIKE_DYN_LINE, ivar, gg,
     .		prev_tlag_ax, prev_ens_ax, accepted_grid, test_grid
	CHARACTER buff*8	 

* initialize
	have_prev_tlag = .FALSE.

********************
* avoid creating duplicate axes

* If the ensemble axis or the lag-time axis of an FMRC is an exact duplicate
* of a pre-existing axis use the previous one, instead
	prev_ens_ax = TM_FIND_LIKE_DYN_LINE( ens_ax )
	have_prev_ens = prev_ens_ax  .NE. unspecified_int4
	IF (agg_dim .EQ. F_dim) THEN
	   prev_tlag_ax = TM_FIND_LIKE_DYN_LINE( tlag_ax )
	   have_prev_tlag = prev_tlag_ax .NE. unspecified_int4
	ENDIF
	IF ( have_prev_ens .OR. have_prev_tlag ) THEN
* find the places that the new axes are in use. Replace them with pre_exist 
!     note: We should use the dset var LIST!   Super-inefficient loop here
	   varloop: DO ivar = 1, maxvars
	      IF ( ds_var_setnum(ivar) .NE. dset ) CYCLE varloop
	      gg = ds_grid_number(ivar)
* ... replace the duplicated axes with the previous identical ones
	      IF (have_prev_ens) THEN
	         IF (grid_line(agg_dim,gg) .EQ. ens_ax)
     .				grid_line(agg_dim,gg) = prev_ens_ax
	      ENDIF
	      IF (have_prev_tlag) THEN
	         IF (grid_line(t_dim,gg) .EQ. tlag_ax)
     .				grid_line(t_dim,gg) = prev_tlag_ax
	      ENDIF
	   ENDDO varloop

* delete the redundant axes
	   IF ( have_prev_ens ) THEN 
	      line_name(ens_ax) = char_init16 ! deallo'd in tm_garb_col
!	      CALL TM_DEALLO_DYN_LINE(ens_ax)
	      ens_ax = prev_ens_ax
	   ENDIF
	   IF ( have_prev_tlag ) THEN
	      line_name(tlag_ax) = char_init16 ! deallo'd in tm_garb_col
!	      CALL TM_DEALLO_DYN_LINE(tlag_ax)
	      tlag_ax = prev_tlag_ax
	   ENDIF
	ENDIF

* ****************
* grids

* check for duplicate grid guts
	accepted_grid = 0		! to get start of linked list
 10	CALL TM_NEXT_TMP_GRID( accepted_grid, *500)
	IF (grid_name(accepted_grid) .EQ. char_init) GOTO 10 ! already removed

	test_grid = accepted_grid
 20	CALL TM_NEXT_TMP_GRID( test_grid, *200)
	IF (grid_name(test_grid) .EQ. char_init) GOTO 100 ! already removed

* is the test grid a duplicate of the accepted grid?
	IF ( TM_SAME_GRID_DEF( accepted_grid, test_grid ) ) THEN
*  ... yes -- point its variables to the accepted grid
	   DO ivar = 1, maxvars
	      IF ( ds_var_setnum(ivar) .NE. dset ) CYCLE
	      IF ( ds_grid_number(ivar) .EQ. test_grid ) 
     .		   ds_grid_number(ivar) = accepted_grid
	   ENDDO
	   grid_name(test_grid) = char_init   ! throw it away
	ELSE
*  ... no -- make sure it has a unique name
	   CALL TM_NEW_GRID_NAME( grid_name(test_grid), buff )
	   grid_name(test_grid) = buff
	ENDIF
* inner loop -- Go back for another test_grid
 100	GOTO 20

* outer loop -- Go back for another accepted_grid
 200	GOTO 10

* we've tested the uniqueness of all temporary grids.  We're done.
 500	RETURN
	END

	SUBROUTINE DEALLO_UVAR_GRIDS( uvar )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* deallocate all dynamic grids associated with this user variable
* (clearing any memory references to this grid)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V420 9/8/95 - new
* V510 *sh* 4/00 - deallocate any grid, not just dynamic ones
* V533 *sh* 7/01 - set data type of grid/variable
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V699 *sh* 6/16 - variable uvar_grid replaced with LISTs in NCF_Util.c 
* V710 *acm* 18/25/16 - Ticket 2462 Issue the warnings only if in MODE DIAGNOSTIC 
* V710 *acm* 10/25/16 - Always issue the warnings: Memory-link fixes in NCF_Util.c 
* V710 *acm* 10/16 Ticket 2422: variables uvar_grid, uvar_data_type, uvar_aux_cat, 
*                  uvar_aux_var to be replaced with calls to LIST routines in NCF_Util.c 

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data

* calling argument declarations
	INTEGER	uvar

* local declarations
	INTEGER ngrids, saved_uvgrid, i, c_list_dset
	CHARACTER tmp_buff*256
	
	CALL GET_SAVED_UVAR_GRID_LIST_LEN(uvar, ngrids)

* THIS LOOP WILL BE REPLACED WITH a loop over ngrids (see above)
* using LIST controls that allow you to traverse the list from end-to-end:
* list_front, list_mvnext (?)

        IF (ngrids .GT. 0) THEN
	
* c_list_dset  - dataset value relevant in C LIST structures of NCF_Util.c

	   c_list_dset = uvar_dset(uvar)                    ! the dset that owns this LET/D
	   IF (c_list_dset .LE. pdset_irrelevant) c_list_dset = pdset_uvars  ! global uvars

	   DO i = 1, ngrids

	      CALL NCF_NEXT_UVAR_GRID_IN_LIST ( c_list_dset, uvar, i, saved_uvgrid )
	      IF ( saved_uvgrid.GE.1 .AND. saved_uvgrid.LE.max_dyn_grids ) 
     .           CALL DEALLO_DYN_GRID(saved_uvgrid)

	   ENDDO

        ENDIF

* free the LIST of grids associated with this uvar

	CALL FREE_UVAR_GRIDS(uvar)

	RETURN
	END

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* AIX replacement routine for CALL DATE(str) which
* is missing in IBM's xlf libraries

*	Steve Hankin 10/27/94
*
* *kob* 5/26/95	added ifdef HP_ADDS for gerror and flush which hp had prob's
*	        with

	SUBROUTINE AIX_DATE(str)

        IMPLICIT NONE
* calling argument declarations
	CHARACTER*(*) str

* local variable declarations
	CHARACTER aix_d_t*26

* call the AIX function
	CALL FDATE_(aix_d_t)

* dd-mmm-yy
	str = aix_d_t(9:10)//'-'//aix_d_t(5:7)//'-'//aix_d_t(23:24)

	RETURN
	END

***********************************************************************

* AIX replacement routine for CALL TIME(str) which
* is missing in IBM's xlf libraries

*	Steve Hankin 10/27/94

	SUBROUTINE AIX_TIME(str)

        IMPLICIT NONE
* calling argument declarations
	CHARACTER*(*) str

* local variable declarations
	CHARACTER aix_d_t*26

* call the AIX function
	CALL FDATE_(aix_d_t)

	str = aix_d_t(12:19)

	RETURN
	END

***********************************************************************

* AIX replacement routine for CALL FLUSH(lunit) which
* is missing in IBM's xlf libraries

*	Steve Hankin 10/31/94
*
*	*kob* 6/15/95 - for hp port -- changed lunit to 0 for fflush call
*
	SUBROUTINE FLUSH(lunit)

        IMPLICIT NONE
* calling argument declarations
	INTEGER lunit

#ifdef HP_ADDS
	call fflush(0)
#else
* call the AIX function
	CALL FLUSH_(lunit)
#endif
	RETURN
	END


***********************************************************************

* AIX replacement routine for CALL GETLOG(name) which
* is missing in IBM's xlf libraries

*	Steve Hankin 10/31/94

	SUBROUTINE GETLOG(name)

        IMPLICIT NONE
* calling argument declarations
	CHARACTER*(*) name        ! hope this is OK ??? CHAR*8 limit ?

* call the AIX function
	CALL GETLOG_(name)

	RETURN
	END

***********************************************************************

* AIX replacement routine for CALL FDATE(string) which
* is missing in IBM's xlf libraries

*	Steve Hankin 10/31/94

	SUBROUTINE FDATE(string)

        IMPLICIT NONE
* calling argument declarations
	CHARACTER*(*) string

* call the AIX function
	CALL FDATE_(string)

	RETURN
	END

#ifndef HP_ADDS
***********************************************************************

* AIX replacement routine for CALL GERROR(string) which
* is missing in IBM's xlf libraries

*	Steve Hankin 10/31/94

* Note that this routine does NOT attempt to reproduce the correct
*	behavior.  This is a matter of laziness because I could not think
*	of an easy way to create a system error that would be detected
*	at the TMAP library level from whence this routine is called

	SUBROUTINE GERROR(string)

        IMPLICIT NONE
* calling argument declarations
	CHARACTER*(*) string

* heres the cheap fix:
	string = 'AIX sys err msg inaccessible to FERRET'
	RETURN

***********************************************************************

	end
#endif

      SUBROUTINE READHD(ITAPEI,ITAPEO,NCAST,NDATA,NCAST1,IPRNT,
     1IWRITE,EXKEEP)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)readhd.f	1.1    3/10/88
C**
C**
C***********************************************************************        C**
C**                 EPIC
C**
C***********************************************************************        C**
C**
C  THIS SUBROUTINE WILL CALL FIRSTHDR TO READ IN A HEADER FROM TAPE
C  ITAPEI, AND WILL CONTINUE TO READ IN HEADERS AS LONG AS THE 'HEADER
C  FOLLOWING' FLAG IS SET (LINE 2 COL 79). IF IPRNT IS TRUE, ALL 
C  HEADERS WILL BE WRITTEN TOP OUTPUT TAPE 6. IF IWRITE IS TRUE, THE
C  FIRST HEADER WILL BE WRITTEN TO TAPE ITAPEO
C
C  WRITTEN 10/84 BY M. VERSCHELL
C
      LOGICAL IPRNT,IWRITE,EXKEEP
      CHARACTER*80 HEADER(8),BUFFER(8)
      COMMON /COMHDR/ HEADER
      COMMON /DUMMY/BUFFER
      CHARACTER*1 BLANK
      DATA BLANK/' '/
C
C  READ IN FIRST HEADER, REPEAT UNTIL REQUESTED CAST (NCAST1) IS FOUND
C
  100 CALL FRSTHD(ITAPEI,NCAST,NDATA)
      IF ((NCAST .NE. NCAST1).AND.(NCAST1 .NE. 0)) THEN
  150   IF (HEADER(2)(79:79).EQ.'N') THEN
          READ (ITAPEI,END=175) HEADER(1)
          GOTO 190
  175     READ (ITAPEI) HEADER(1)
  190     DO 195 J=2,8
          READ (ITAPEI) HEADER(J)
  195     CONTINUE 
          GOTO 150
        ELSE
          DO 197 I=1,NDATA
            READ(ITAPEI,END=197) DUM
  197     CONTINUE
        ENDIF
        GOTO 100
      ENDIF
C
C  PRINT OR WRITE IT OUT AS REQUESTED
C
      IF (IPRNT) WRITE(6,200) NCAST,NDATA,(HEADER(I),I=1,8)
CCCC  BUG IN CODE ... 200 FORMAT(1X,'NCAST='I3,'  NDATA=',I5/8(1X,A80/)/)
  200 FORMAT(1X,'NCAST=',I3,'  NDATA=',I5/8(1X,A80/)/)
      IF (IWRITE) THEN
        DO 300 I=1,8
          IF ((.NOT.EXKEEP).AND.(I.EQ.2)) THEN
            WRITE (ITAPEO) HEADER(I)(1:78),BLANK,HEADER(I)(80:80)
          ELSE
            WRITE (ITAPEO) HEADER(I)
          ENDIF
  300   CONTINUE
      ENDIF
C
C  IF N FLAG SET READ IN NEXT HEADER
C
      IF (HEADER(2)(79:79).EQ.'N') THEN
  400   CALL NXTHDR(ITAPEI)
        IF (IPRNT) WRITE (6,200) (BUFFER(I),I=1,8)
        IF ((EXKEEP).AND.(IWRITE)) THEN
          DO 500 I=1,8
            WRITE (ITAPEO) HEADER(I)
  500     CONTINUE
        ENDIF
        IF (BUFFER(2)(79:79).EQ.'N') GOTO 400
      ENDIF
      RETURN
      END

	SUBROUTINE  VEL_DIF_XY(	u     , mu     ,
     .				v     , mv     ,
     .				udfh  , mudfh	)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute horizontal diffusion of velocity components
* note: the identical code applies to both U and V
* ! temp - this is very inefficient code (as is XY_HDIFFUS) that could be
*	greatly sped up by pre-computation of coefficients

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 1/26/87 - extracted from SUBROUTINE CLINIC
*			with major modifications to convert i-k oriented
*			calculations to i-j oriented calculations
* revision 0.1 7/2/88  - added Am_factor
* V200:  7/27/89 - 4D symmetrical version
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN

#ifdef unix
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl.parm'		! parameter definitions
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xonedim.cmn'	! geometric constants
	include 'xcontext.cmn'
	include 'xdset_parms.cmn'	! with am_factor
#else
	INCLUDE 'FERRET_CMN:FERRET.PARM'
	INCLUDE 'FERRET_CMN:GFDL.PARM'		! parameter definitions
	INCLUDE	'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE	'FERRET_CMN:XMEM_SUBSC.CMN'
	INCLUDE 'FERRET_CMN:XONEDIM.CMN'	! geometric constants
	INCLUDE 'FERRET_CMN:XCONTEXT.CMN'
	INCLUDE 'TMAP_FORMAT:TMAP_DIMS.PARM'	! with maxdsets
	INCLUDE 'FERRET_CMN:XDSET_PARMS.CMN'	! with Am_factor
#endif

* calling argument declarations:
	INTEGER	mu, mv, mudfh

* subscript ranges from memory variable table ...
	REAL       u( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit ),
     .		   v( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,m2lot:m2hit ),
     .		udfh( m3lox:m3hix,m3loy:m3hiy,m3loz:m3hiz,m3lot:m3hit )

* internal variable declarations:
	LOGICAL	HOURLY_DATA
	INTEGER	i_lo, i_hi, j_lo, j_hi, k_lo, k_hi, l_lo, l_hi,
     .		i, j, k, l, dl, lb4
	REAL	bad_u, ccuj, dduj, gguj, hhuj, ew, ns, rest

	REAL	aauj(im), bbuj(im)
	EQUIVALENCE ( aauj(1), aatj(1) ) ,
     .		    ( bbuj(1), bbtj(1) )	! space saving

* --- end of introductory code ---
* use 1 hour separation for exact results on hourly data
	IF ( HOURLY_DATA(mr_grid(mudfh)) ) THEN
	   dl = -1
	ELSE
	   dl = 0
	ENDIF

* limits for calculation
	i_lo = mr_lo_s1(mudfh)
	i_hi = mr_hi_s1(mudfh)
	j_lo = mr_lo_s2(mudfh)
	j_hi = mr_hi_s2(mudfh)
	k_lo = mr_lo_s3(mudfh)
	k_hi = mr_hi_s3(mudfh)
	l_lo = mr_lo_s4(mudfh)
	l_hi = mr_hi_s4(mudfh)

* flag for bad/missing data
	bad_u = mr_bad_data( mu )

* Am coefficient (scaled by 10**7)
	Am = 1.E7 * dp_Am_factor( mr_data_set(mu) )

* ***************************************************************
* ORIGINAL GFDL 205 CODE UPON WHICH CALCULATION IS BASED
*
* 311 C   ADD IN HORIZONTAL VISCOUS EFFECTS
* 312 C
* 313 C     VARIABLE LATERAL FRICTION
* 314 C
* 315       CCUJ=AM*CST(J+1)*DYTR(J+1)*DYUR(J)*CSR(J)*XJT(J+1)
* 316       DDUJ=AM*CST(J  )*DYTR(J  )*DYUR(J)*CSR(J)*XJT(J)
* 317       DO 322 I=1,IMT
* 318       AAUJ(I)=AM*DXUR(I)*DXTR(I+1)*CSR(J)*CSR(J)*XIT(I+1)*XJV(J)
* 319       BBUJ(I)=AM*DXUR(I)*DXTR(I  )*CSR(J)*CSR(J)*XIT(I)*XJV(J)
* 320       C(I)=CCUJ*XIV(I)
* 321       D(I)=DDUJ*XIV(I)
* 322   322 CONTINUE
* 323 C
* 324       DO 3222 K=1,KM
* 325       DO 3222 I=1,IMT
* 326       ATJ(I,K)=AAUJ(I)
* 327       BTJ(I,K)=BBUJ(I)
* 328       TEMP2D(I,K)=C(I)
* 329 3222  TEMP(I,K)=D(I)
* 330 C
* 331       DO 320 K=1,KM
* 332       DO 320 I=1,IMT
* 333       UA(I,K)=UA(I,K)+ATJ(I,K)*(UB(I+1,K)-UB(I,K))-BTJ(I,K)*
* 334      *(UB(I,K)-UB(I-1,K))
* 335  320  CONTINUE
* 336       DO 323 K=1,KM
* 337       DO 323 I=1,IMT
* 338       UA(I,K)=UA(I,K)+TEMP2D(I,K)*(UBP(I,K)-UB(I,K))-TEMP(I,K)*
* 339      * (UB(I,K)-UBM(I,K))
* 340  323  CONTINUE
* 341       DO 330 K=1,KM
* 342       DO 330 I=1,IMT
* 343       VA(I,K)=VA(I,K)+ATJ(I,K)*(VB(I+1,K)-VB(I,K))-BTJ(I,K)*
* 344      *(VB(I,K)-VB(I-1,K))
* 345  330  CONTINUE
* 346       DO 333 K=1,KM
* 347       DO 333 I=1,IMT
* 348       VA(I,K)=VA(I,K)+TEMP2D(I,K)*(VBP(I,K)-VB(I,K))-TEMP(I,K)*
* 349      * (VB(I,K)-VBM(I,K))
* 350  333  CONTINUE

* 408 C     ALSO ADD IN REST OF VARIABLE HORIZONTAL DIFFUSION
* 409 C
* 410       GGUJ=AM*(1.0-TNG(J)*TNG(J))/(RADIUS*RADIUS)
* 411       HHUJ=2.*AM*SINE(J)/(RADIUS*CS(J)*CS(J))
* 412       DO 3591 K=1,KM
* 413       DO 3591 I=1,IMT
* 414       TEMP(I,K)=GGUJ*XIV(I)*XJV(J)
* 415 3591  TEMP2D(I,K)=HHUJ*XIV(I)*XJV(J)
* 416 C
* 417       DO 360 K=1,KM
* 418       DO 360 I=1,IMT
* 419       UA(I,K)=GM(I,K)*((UA(I,K)-DPDX(I,K)
* 420      * +TEMP(I,K)*U(I,K)-
* 421      *  TEMP2D(I,K)*DXU2R2D(I,K)*(V(I+1,K)-V(I-1,K))))
* 422  360  CONTINUE
* 423       DO 370 K=1,KM
* 424       DO 370 I=1,IMT
* 425       VA(I,K)=GM(I,K)*((VA(I,K)-DPDY(I,K)
* 426      * +TEMP(I,K)*V(I,K)+
* 427      *  TEMP2D(I,K)*DXU2R2D(I,K)*(U(I+1,K)-U(I-1,K))))
* 428  370  CONTINUE
*************************************************************************

	DO 320 j = j_lo, j_hi

* pre-compute some coefficients
	IF ( j .LT. jm ) THEN
	   ccuj=Am*cst(j+1)*dytr(j+1)*dyur(j)*csr(j)*xjt(j+1)
	   dduj=Am*cst(j  )*dytr(j  )*dyur(j)*csr(j)*xjt(j)
	   gguj=Am*(1.0-tng(j)*tng(j))/(radius*radius)
	   hhuj=2.*Am*sine(j)/(radius*cs(j)*cs(j))
	ENDIF
	DO 322 I = i_lo, MIN(i_hi,im-1)
	   aauj(i)=Am*dxur(i)*dxtr(i+1)*csr(j)*csr(j)*xit(i+1)*xjv(j)
	   bbuj(i)=Am*dxur(i)*dxtr(i  )*csr(j)*csr(j)*xit(i)*xjv(j)
 322	CONTINUE

	DO 320 l = l_lo, l_hi
* ... some data may be needed from 1 integration step earlier
	   lb4 = l + dl
	DO 320 k = k_lo, k_hi
	DO 320 i = i_lo, i_hi

	   IF ( i .EQ. 1 .OR. i .EQ. im
     .	  .OR.  j .EQ. 1 .OR. j .EQ. jm ) THEN
	      udfh(i,j,k,l) = bad_val4
	      GOTO 320
	   ENDIF

* V is assumed to have bad points exactly where U does ...
	   IF ( u(i  ,j  ,k,lb4) .EQ. bad_u
     .	   .OR. u(i-1,j  ,k,lb4) .EQ. bad_u
     .	   .OR. u(i+1,j  ,k,lb4) .EQ. bad_u
     .	   .OR. u(i  ,j-1,k,lb4) .EQ. bad_u
     .	   .OR. u(i  ,j+1,k,lb4) .EQ. bad_u ) THEN
	      udfh(i,j,k,l) = bad_val4
	      GOTO 320

	   ELSE
	   ew = ( aauj(i)* (u(i+1,j,k,lb4)-u(i  ,j,k,lb4))
     .		- bbuj(i)* (u(i  ,j,k,lb4)-u(i-1,j,k,lb4)) )
	   ns = ( ccuj   * (u(i,j+1,k,lb4)-u(i,j  ,k,lb4))
     .		- dduj   * (u(i,j  ,k,lb4)-u(i,j-1,k,lb4)) ) * xiv(i)
	   rest = ( gguj*u(i,j,k,l)
     .		- hhuj*dxu2r(i)*(v(i+1,j,k,l)-v(i-1,j,k,l)) )
     .		* xiv(i) * xjv(j)

	   udfh(i,j,k,l) = ( ew + ns + rest ) * cmonthly

	   ENDIF

 320	CONTINUE
	RETURN

	END

	SUBROUTINE GET_DSET_BAD( dset, varname, bad )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Return the bad-flag for the variable. For variables in netCDF datasets, 
* with scale and offset, the internal bad-flag may not match what is in
* the original file.  For `var,return=bad`, go get the original flag.

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA -SDIG
*
* revision 0.0 - 2/18
* For Issue # 1861, handling missing- and _FillValue with scale and offset
* this is for evaluating `var,RETURN=bad`


        IMPLICIT NONE
	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'ferret.parm'

* calling argument declarations:
	INTEGER		dset
	REAL		bad
	CHARACTER*(*)   varname

	LOGICAL		NC_GET_ATTRIB_DP, got_it
	INTEGER		varid, istat, attid, attlen, attoutflag
	REAL		miss_in
	CHARACTER*128   attname


	CALL CD_GET_VAR_ID (dset, varname, varid, istat)

	IF ( ds_type(dset).EQ.'CDF' .OR. ds_type(dset).EQ.'ECDF' 
     .          .OR. ds_type(dset).EQ.' MC' .OR. ds_type(dset).EQ.'ENS' 
     .          .OR. ds_type(dset).EQ.'FCT' .OR. ds_type(dset).EQ.'UNI') THEN

	   attname = 'missing_value'
	   got_it = NC_GET_ATTRIB_DP 
     .                (dset, varid, attname, .FALSE., varname, attlen, 
     .                attoutflag, miss_in)
	   IF (.NOT. got_it) THEN
	      attname = '_FillValue'
	      got_it = NC_GET_ATTRIB_DP 
     .                (dset, varid, attname, .FALSE., varname, attlen, 
     .                attoutflag, miss_in)
	   ENDIF
	   IF (got_it) bad = miss_in
	
	ENDIF



 


	RETURN
	END

        SUBROUTINE RIBBON_MISSING

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*

*       Sets the options for missing-data representation in RIBBON plots
*       (see shade_set for color spectra)

        include         'shade_vars.cmn'
        include 	'cmrdl_inc.decl'            
        include 	'CMRDL.INC'            
        include 	'gkscm1_inc.decl'            
        include 	'GKSCM1.INC'            
        include 	'gkscm2.cmn'            

	include        'gkspar.inc'


       	logical		there
        integer         beg,end                            
        character*2048   str                                

******************************************************************************

      	call upnsquish (label,str,end)
        call squish (label,1,2048)

*	If a spectrum is to be read, do that and set color
	beg = index (str,'SPECTRUM')
	if (beg .ne. 0) then
	   call RIBBON_READ (label,beg,end,there)
	   if (.not.there) return
	end if

*	Otherwise: if default colors requested, set them
	beg = index (str,'DEFAULT')
	if (beg .ne. 0) then
	   ribbon_miss(1) = -1.
	   ribbon_miss(2) = -1.
	   ribbon_miss(3) = -1.
	end if

*	Otherwise: if user has said BLANK, mark this with -2.
	beg = index (str,'BLANK')
	if (beg .ne. 0) then
	   ribbon_miss(1) = -2.
	   ribbon_miss(2) = -2.
	   ribbon_miss(3) = -2.
	end if

	return
	end


	SUBROUTINE RIBBON_READ (str,beg,end,there)

*	Mod *jd* 10.92 to allow memory reads
*	Mod *jd* 3.1.93 to use tm_inq_path

        include 	'tmap_errors.parm'    
	include		'cmrd_inc.decl'
	include		'CMRD.INC'
        include         'shade_vars.cmn'

	logical		there
	integer		beg,end,i,j,speclen,lnblk,status
        integer         test_end
	character*2048	str,sfile,instr,label,specdir,tm_inq_path
        character*2048   test_str
	external 	lnblk

        integer         mapping,percentage,value,level 
        INTEGER         TM_LENSTR1, ilen, slen
*******************************************************************************

*       DEFAULT MAPPING IS PERCENT FOR COMPATIBILITY WITH ORIGINAL SYSTEM
        rgb_mapping = percent

*	If no file name given, or its default, the line is black.
	if (end .lt. 10) then
	   there = .true.
	   return
	endif

	sfile = tm_inq_path (str(beg+9:end),'FER_PALETTE','.spk',
     .	.false.,status)

	if (status .ne. merr_ok) go to 100
	there = .true.

*	OPEN THE FILE

#ifdef NO_OPEN_READONLY
 5      open (70,file=sfile,status='old',err=100)
#else
 5      open (70,file=sfile,readonly,status='old',err=100)
#endif

	rgb_mapping = percent  ! always: 

*	NOW READ IN THE FIRST LEVEL AND SET THE RGB 
10	read (70,'(a)',end=30,err=90) instr
	do 15 i = 1,80
	   if (instr(i:i) .ne. ' ') then
	      j = i
	      goto 20
	   end if
15	end do
	goto 10

*	PERMIT COMMENTS 
20	if (instr(j:j) .eq. '!') goto 10

*       IGNORE MAPPING
        if (index(test_str, 'RGB_MAPPING') .ne. 0) goto 10

* read first color, set color by percent.
	call upnsquish (instr,test_str,test_end)
 
        call parsex (instr(j:j+79),80,p,iflg,m,label,n)
	
* Leave the values as percentages. Will be calling SET_ONE_COLOR
* which expects this.

	if (p(1) .GE. 0. .and. p(1) .LE. 100.) THEN
	   ribbon_miss(1) = p(2)
	   ribbon_miss(2) = p(3)
	   ribbon_miss(3) = p(4)
	ENDIF
	goto 30

30	close (70)
	return

*	ERROR WITH FILE ACCESS
90	close (70)
100	continue
	CALL WARN ('Unable to read ' //str(beg+9:end)//
     .	'.spk" to set missing-color for ribbon plot.')
	CALL WARN ('Defaulting to thin black line')

	return

	end

      SUBROUTINE CD_GET_VAR_ID (dset, vname, varid, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Read the linked list structure for netcdf variable information: 
* given dset and variable name return variable id

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP

* V600 6/05 *acm* Attribute control.
*      6/06 *acm* missing declarations of ncf functions
* V602  2/07 *acm* Fix bug 1492, changing attributes of coordinate variables 
*           *acm* Get rid of call to isit_coord_var, which could get us in 
*                 an endless loop (isit_coord_var calls cd_get_var_id).
* V611  5/08 *acm* Fix bug 1578, dataset specifier on the variable var[d=1].attr
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files
* V6.94 3/15 *acm* Fix ticket 2249: attribute handling for user-defined variables
* V698 *sh* 1/16 -- added status check/warning, since not checked by callers
* V699 *sh* 6/16 - bug fix:  this routine falsely identified Ferret child
*                  variables, which have names of the form "(Cnnn,Vmmm)" as
*                  coordinate variables.  It then returned a status indicating
*                  failure that was regarded as acceptable, presumably because
*                  a user may mis-type a coordinate variable name
*                  The result is that child variables did not get deleted.
* V7   *acm* 6/16 -The above fix needs to first check for string length.
* V7   *acm* 3/20 -Issue 1969: the case-sensitive match for names in quotes
*                  needs to be done on the incoming name not its upcased version.

* include files
#include "gt_lib.parm"
      INCLUDE "tmap_errors.parm"

* Argument declarations

      CHARACTER*(*) vname
      INTEGER dset, varid, status

* Internal declarations

      INCLUDE 'netcdf.inc'

      CHARACTER*512 buff
      LOGICAL coordvar
      INTEGER TM_LENSTR1, NCF_GET_VAR_ID, NCF_GET_VAR_ID_CASE,
     .        NCF_GET_VAR_AXFLAG, FIND_DSET_NUMBER, STR_UPCASE,
     .        slen, flen, dir, dset_num, bkt1, bkt2, istrt, iend, iset
      PARAMETER (flen=512)      ! size of variable name string

#ifdef sun
      BYTE      fhol(flen)      ! c-type Hollerith string buffer
#else
      INTEGER*1 fhol(flen)      ! c-type Hollerith string buffer
#endif 

      varid = 0
      status = atom_not_found

      dset_num = dset
      IF (dset_num .LT. -2) dset_num = -2

      istrt = STR_UPCASE(buff,vname)

* 6/16 *sh* **HACK!!!**
* ==> Detect Ferret child-variable name of the form "(C011,V007)"
* so they are not mis-identified as coordinate variable names
* (IMHO a low level routine such as this one should not be doing parsing)
      slen = TM_LENSTR1(vname)
      IF (slen .GE. 11) THEN
         IF  ( vname(1:1)   .EQ. '('
     .    .AND.vname(2:2)   .EQ. 'C'
     .    .AND.vname(6:6)   .EQ. ','
     .    .AND.vname(7:7)   .EQ. 'V'
     .    .AND.vname(11:11) .EQ. ')'  ) GOTO 500
      ENDIF

* Deal with coordinate variable names inside parenthese

      IF (vname(1:1) .EQ. '(' ) THEN
         slen = INDEX(buff,')') - 1 
         IF (slen .LE. 0) slen = TM_LENSTR1(buff)
         buff = vname(2:slen)
         buff(slen:slen) = ""
         slen = slen - 1
       
         CALL TM_FTOC_STRNG( buff(1:slen), fhol, flen )
         status = NCF_GET_VAR_ID(dset_num, varid, fhol)
         IF (status.NE.merr_ok .AND.
     .       INDEX(vname,'[') .GT. 0) GOTO 4000
         status = NCF_GET_VAR_AXFLAG (dset, varid, coordvar, dir)
         IF (.NOT. coordvar) THEN
	    status = atom_not_found 
	    GOTO 5000
	 ENDIF

* If theres also a dataset spec (xax)[d=1] on the orig variable name, 
* add that
 4000    CONTINUE
         IF ( INDEX(vname,'[') .GT. 0 ) THEN
            bkt1 = INDEX(vname, '[')
            bkt2 = INDEX(vname, ']')
            slen = TM_LENSTR1(buff)
            buff = buff(1:slen)//vname(bkt1:bkt2)
         ENDIF

      ENDIF 

* If there is a dataset spec, see if the variable is in that dataset.
* Look only at the d=n or d=dset_name. 
* Otherwise ignore what is in the brackets; this allows us to get
* attributes for LAS variables with region info.

      IF ( INDEX(buff,'[').GT.0) THEN
         
         istrt = STR_UPCASE(buff,buff)
	 istrt = INDEX(buff,'D=')
	 IF (istrt .GT. 0) THEN
	    istrt = INDEX(buff,'D=') + 2
	    iend = INDEX(buff(istrt:),',') - 1
	    IF (iend .LE. 0) THEN
	       iend = INDEX(buff,']') - 1
	    ELSE
	       iend = istrt+iend-1
	    ENDIF
	    iset = FIND_DSET_NUMBER(buff(istrt:iend))
	    IF (iset .NE. unspecified_int4) dset_num = iset
	 ENDIF
	 
	 istrt = INDEX(buff,'[') - 1
	 buff = buff(:istrt)
	 slen = TM_LENSTR1(buff)
      ENDIF

* If the name is in quotes, remove them, from the un-upcased version, and do a 
* case-sensitive search for the name.

 500  slen = TM_LENSTR1( buff )
      IF (buff(1:1) .EQ. "'" .AND. buff(slen:slen) .EQ. "'" ) THEN
         CALL TM_FTOC_STRNG( vname(2:slen-1), fhol, flen )
         status = NCF_GET_VAR_ID_CASE(dset_num, varid, fhol)
      ELSE
         CALL TM_FTOC_STRNG( buff(1:slen), fhol, flen )
         status = NCF_GET_VAR_ID(dset_num, varid, fhol) 
      ENDIF
      IF (status .NE. merr_ok) GOTO 5000
      dset = dset_num

* If the name is just a dot, it is the fake global-attributes variable

      IF (slen.EQ.1 .AND. buff(1:1) .EQ. ".") THEN
         varid = 0
	 status = merr_ok
      ENDIF
      RETURN

* error exit
 5000 IF (status .NE. atom_not_found) THEN
	slen = TM_LENSTR1(buff)
	CALL WARN('Error status from CD_GET_VAR_ID: '//buff(1:slen))
      ENDIF
      RETURN
      END

	SUBROUTINE COPY_GRID_TRANS_SUB( md1, md2,
     .		src, slox, shix, sloy, shiy, sloz, shiz, 
     .		slot, shit, sloe, shie, slof, shif, bad_src,
     .		dst, dlox, dhix, dloy, dhiy, dloz, dhiz, 
     .		dlot, dhit, dloe, dhie, dlof, dhif, bad_dst )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* copy data from one grid to another transposing dim1 and dim2 components

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V200:	10/16/89 - from COPY_GRID_TRANS
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

	include 'ferret.parm'

* calling argument declarations:
* note: dst has dimensions transposed
	INTEGER md1, md2,
     .		slox, shix, sloy, shiy, sloz, shiz, 
     .		slot, shit, sloe, shie, slof, shif,
     .		dlox, dhix, dloy, dhiy, dloz, dhiz, 
     .		dlot, dhit, dloe, dhie, dlof, dhif
	REAL    src( slox:shix,sloy:shiy,sloz:shiz,slot:shit,sloe:shie,slof:shif ),
     .		dst( md2, md1 )
	REAL	bad_src, bad_dst

* internal variable declarations:
	INTEGER	ii, jj, i, j, k, l, m, n 

* --- end of introductory code ---

	ii = 1
	jj = 1
	DO 100 n = dlof, dhif
	DO 100 m = dloe, dhie
	DO 100 l = dlot, dhit
	DO 100 k = dloz, dhiz
	DO 100 j = dloy, dhiy
	DO 100 i = dlox, dhix

	   dst(jj,ii) = src(i,j,k,l,m,n)

	   ii = ii + 1
	   IF ( ii .GT. md1 ) THEN
	      ii = 1
	      jj = jj + 1
	   ENDIF

 100	CONTINUE

* check for differing bad data flags in an efficient way ...
	IF ( bad_src .NE. bad_dst ) THEN
	   DO 200 ii = 1, md1
	   DO 200 jj = 1, md2

	      IF ( dst(jj,ii) .EQ. bad_src ) dst(jj,ii) = bad_dst

 200	   CONTINUE
	ENDIF

	RETURN
	END 

      SUBROUTINE GCF_GET_IMPOSED_AXES( gcfcn, cx_base, axes, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* supply the axes for those axes of the grid changing function which
* are "imposed" by the function

* the addition (or major modification) of an internal grid-changing function
* requires changes to these routines:
*	grid_chg_fcns.parm	- parameters to number the functions
*	XGRID_CHG_FCNS_DATA	- description of the function and args
*	DO_INTERNAL_GC_FCN	- code to execute the function
* (opt)	GCF_GET_IMPOSED_AXES	- return the "imposed" axes, if any
* (opt)	GCF_IMPOSE_RESULT_LIMS	- fill in limits of "imposed" axes, if any

* V450: 1/97
*	7/97 - slight reorg for external functions
* V491: 1/98 - make test function TIMES2 impose its T axis
*       2/99 changed UNRAVEL to XUNRAVEL. Added YUNRAVEL, ZUNRAVEL, TUNRAVEL
* V500: 7/99 *sh* - use of "grid_line(1,mgrid_abstract)" changed to
*               "grid_line(1,mgrid_xabstract)" since mgrid_abstract changes
*               with SET GRID
* V530: 10/00 *sh* - bug fix: need to pass an *array* of argument contexts
*       to the C routine efcn_get_custom_axes
*                  - changed EFCN_GET_CUSTOM_AXES so it returns a status
* V541: 2/02 *sh* - support for modulo length
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'grid_chg_fcns.parm'
	include 'EF_Util.parm'
	include 'xgrid_chg_fcns.cmn'
	include 'xtext_info.cmn'	! w/ ww_dim_name
	include 'xfr_grid.cmn'       ! w/ mgrid_abstract
	include 'xcontext.cmn'       ! for TIMES2
	include 'xvariables.cmn'     ! for TIMES2

* calling argument declarations
	INTEGER	gcfcn, cx_base, axes(*), status

* internal variable declarations
	LOGICAL known_limits
	INTEGER	CGRID_AXIS, TM_LENSTR1, CX_DIM_LEN, CAXIS_LEN,
     .          EFCN_GET_NUM_REQD_ARGS,
     .		cx, i, idim, axis_will_be(nferdims), n, grid, modulo
	REAL*8	TM_WORLD, dlo, dhi, del
	CHARACTER*40 GCF_NAME, buff, unit
        INTEGER EF_cx_list(EF_MAX_ARGS), narg

* Upon entry to this routine the context stack should be organized as
*	 	  default context (for this uvar)
*	 big_cx:  the merged grid context
* -->	cx_base:  argument N context
*		  argument N-1 context
*		  ...
*		  argument 1 context

* initialize
* ... consolidate info about function into local array to blur distinctions
*     between internal and external functions
	IF ( gcfcn .LE. gfcn_num_internal ) THEN
	   DO 10 idim = 1, nferdims
 10	   axis_will_be(idim) = gfcn_axis_will_be(idim,gcfcn)
	ELSE
	   call efcn_get_axis_will_be(gcfcn, axis_will_be)
	ENDIF

* process what axes we can: either "merged" (determined by grid stack logic),
*	NORMAL, and ABSTRACT ... but not IMPOSED ("supplied herein")
	DO 100 idim = 1, nferdims
	   IF (axis_will_be(idim) .EQ. pgc_axis_is_abstract) THEN
	      axes(idim) = grid_line(1,mgrid_xabstract)         ! 7/99 mod
	   ELSEIF (axis_will_be(idim) .EQ. pgc_axis_is_normal) THEN
	      axes(idim) = mnormal
	   ELSEIF (axis_will_be(idim) .EQ. pgc_axis_implied_by_args) 
     .             THEN
	      axes(idim) = unspecified_int4   ! ... determined elsewhere
           ELSEIF (axis_will_be(idim) .EQ. pgc_axis_supplied_herein) 
     .             THEN
* nothing to do here
	   ELSE	      
	      buff = GCF_NAME( gcfcn )
	      CALL ERRMSG(ferr_internal, status,
     .			'illegal axis merging parameter: '
     .			//ww_dim_name(idim)//' axis  of '
     .			//buff(:TM_LENSTR1(buff)), *5000 )
	   ENDIF
 100	CONTINUE

* *** XUNRAVEL, YUNRAVEL, ZUNRAVEL, TUNRAVEL, EUNRAVEL, FUNRAVEL functions ***
* The result of these functions are grids of ABSTRACT and NORMAL axes
*   .... 7/97 changes -- handled entirely within "typical" cases above

	IF ( gcfcn .EQ. p_reshape ) THEN
* *** RESHAPE function ***
* The second argument contains the desired grid. (It cannot simply be merged,
* however, because the result limits have no obvious relation to the inputs)
	   cx = cx_base 	! component 2: the reshaping grid
	   DO 210 idim = 1, nferdims
	      axes(idim) = CGRID_AXIS ( idim, cx )
 210	   CONTINUE

	ELSEIF ( gcfcn .EQ. p_times2 ) THEN
* *** TIMES2 (debugging) function ***
	   cx = cx_base 	! the argument context

	   IF ( CGRID_AXIS(t_dim,cx) .EQ. mnormal
     .	   .OR. CGRID_AXIS(t_dim,cx) .EQ. unspecified_int4 )
     .		CALL ERRMSG(ferr_unknown_arg, status,
     .			'arg of TIMES2(v) must have a T axis',*5000)

	   grid = cx_grid(cx)

* Note: This routine is called during the "getgrid" pass of Ferret.
* During the "getgrid" pass the context limits of the argument are not reliably
* available. For example, in "TIMES2(V)" the limits of V will appear
* to be cx_lo/hi_ss=1:1. Even in the case of TIMES2(V[L=1:4]) at this
* stage it will appear that V has limits L=1:4 but the actual arg
* that will be obtained later may differ (example: the definition of V may be
* LET V = V2[L=5:10]). The best that we can do about this situation is
* 1. check cx_given to determine if the limits were explicit. If not,
*	then use the limits of the full axis
* 2. in GCF_IMPOSE_RESULT_LIMS and again in the function, itself, double
*	check the axis we have defined against the actual argument recieved.
*	If the axis is inappropriate then flag an error and coach the user
*	that the argument limits are ambiguous or contradictory.

* compute the lo/hi/delta of the new custom (regular) axis

* are the argument's limits along this axis known ?
	known_limits = cx_given(t_dim, cx)	! given right in fcn arg list
	IF ( cx_category(cx) .EQ. cat_user_var ) THEN
* ... user variables may contain limits embedded in its definition
	   known_limits = known_limits .OR.
     .          uvar_given(t_dim,cx_variable(cx))
     .          .LE. uvlim_gvn_xact
	ENDIF
        IF ( known_limits ) THEN
* ... limits of arg are explicit -- use 'em

           n = CX_DIM_LEN(t_dim, cx)
           dlo = TM_WORLD(cx_lo_ss(cx,t_dim), cx_grid(cx), t_dim,
     .          box_middle )
           dhi = TM_WORLD(cx_hi_ss(cx,t_dim), cx_grid(cx), t_dim,
     .          box_middle )
	   ELSE
* ... limits of arg are not explicit -- use axis lims (and hope for the best!)
	      n = CAXIS_LEN(t_dim, cx)
	      dlo = TM_WORLD(1, cx_grid(cx), t_dim, box_middle )
	      dhi = TM_WORLD(n, cx_grid(cx), t_dim, box_middle )
	   ENDIF
	   IF ( n .EQ. 1 ) THEN
	      del = 1.D0
	   ELSE
	      del = (dhi-dlo)/(n-1)
	   ENDIF

*	Create and set the custom axis
* NOTE: It is important that **somewhere** inside of Ferret TM_MAKE_DYN_LINE
*	is called -- else it will not be linked in and available to the
*	external functions 
* Use TM_GET_LIKE_DYN_LINE to create axes which are children of an argument ax
	   CALL TM_MAKE_DYN_LINE(t_dim, dlo, dhi, del,
     .                                  'Hertz', .FALSE., 0.0D0,
     .                                  axes(t_dim), status)
	   IF (status .NE. ferr_ok) GOTO 5000


**************
*     FOR EXTERNAL FUNCTIONS


	ELSEIF (gcfcn .GT. gfcn_num_internal ) THEN

*   ... create a context list array
           narg = EFCN_GET_NUM_REQD_ARGS(gcfcn)
           DO 300 i = 1, narg
              EF_cx_list(i) = cx_stack_ptr - i + 1
 300       CONTINUE

           IF (axis_will_be(1) .EQ. pgc_axis_supplied_herein
     .          .OR. axis_will_be(2) .EQ. pgc_axis_supplied_herein
     .          .OR. axis_will_be(3) .EQ. pgc_axis_supplied_herein
     .          .OR. axis_will_be(4) .EQ. pgc_axis_supplied_herein
     .          .OR. axis_will_be(5) .EQ. pgc_axis_supplied_herein
     .          .OR. axis_will_be(6) .EQ. pgc_axis_supplied_herein) THEN
              CALL EFCN_GET_CUSTOM_AXES(gcfcn, EF_cx_list, status)
              IF (status .NE. ferr_ok) CALL ERRMSG
     .                          ( status, status, ' ', *5000) 
           ENDIF

           DO 400 idim = 1, nferdims

              IF (axis_will_be(idim) .EQ. pgc_axis_supplied_herein) THEN
                 CALL EFCN_GET_CUSTOM_AXIS(gcfcn, idim, dlo, dhi, del,
     .                unit, modulo)
                 CALL TM_MAKE_DYN_LINE(idim, dlo, dhi, del,
     .                unit, modulo, 0.0D0, axes(idim), status)
                 IF (status .NE. ferr_ok) GOTO 5000
              ENDIF


 400       CONTINUE

	ENDIF

* successful completion
	status = ferr_ok
	RETURN

* error exit
 5000	RETURN
	END

**   subroutine fillpoly(x,y,npts,index) *jc*

      subroutine fillpoly(xarg,yarg,npts,index,xadd,lmin,lmax)

      real xarg(*),yarg(*)
      integer npts,index
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
C** 
C**    @(#)fillpoly.F	1.2   1/27/91
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C      lots of places ---> PPLMOD_PPLCMD ---> PPLMOD_PLTIT 
C              ---> PPLMOD_PLOTZ ---> PPLMOD_ARFILL ---> PPLMOD_FILLPOLY
C       
C
C     call fillpoly(x,y,npts,index)
C
C     This subroutine creates a color filled convex polygon using the
C     using the coordinates.
C
C     THE VARIOUS PARAMETERS AND THEIR DEFINITIONS ARE LISTED
C     BELOW:
C        X,Y    - COORDINATES OF THE POLYGON`S CORNERS IN USER'S UNITS.
*	 ?? jd ?? Coordinates in inches from origin == nouser ??

C        npts   - number of vertices
C        index  - color index (0 - max_color)
C
C

*	MOD *JD* to include in TMAP PPL+ 1.14.92
*	Mod *jd* 10.12.92 for new hatching scheme
*	Mod *jd* 11.09.92 to get viewport size right for clipping
*     V4.50 *jc* 04.25.97 add 'curvilinear' capability
*                'x' and 'y' are  arrays of 50 to match xt, yt, etc.
*                (What is the maximum number of vertices in a polygon?)
*       Mod *jd* 02.16.99 Make arrays 128 not 50 for better FILL optimization
*     v5.51 *acm* 2/3/03 Get viewport sizing as in shade routines, using
*                        gks calls; else the clipping is wrong for fill 
*                        plots in viewports that were defined with /AXES.
*     v5.81 *acm* 4/05 Changes for FILL/MOD. Draw replications for curvilinear datasets
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus
* V687 *acm* 3/14 tickets 2151 and 2147: allow missing coordinate data in 3-arg 
*                 and 4-arg plot commands. 
* V698 *acm* 3/16 Ticket 2374: missing color when FILL extends over entire 
*                 modulo region

#ifdef double_p
      real*8 x(128),y(128), xplus
#else
      real x(128),y(128), xplus
#endif
      real xt(128),yt(128),xc(128),yc(128),xtrns,ytrns, temp_hi
      integer i,nout,fill_ndx
      real xadd, lmin, lmax

	include 'PLTCOM.DAT'
	include 'pltcom_dat.decl'
	include 'shade_vars.cmn'
        include 'axis_inc.decl'
        include 'AXIS.INC'
        include 'gkscm1_inc.decl'
        include 'GKSCM1.INC'
        include 'gkscm2.cmn' 
        INCLUDE 'gkspar.inc'
        include 'xcurvilinear.cmn'
	include 'ppl_in_ferret.cmn'	

      common/plyclp/acmin,acmax,bcmin,bcmax
      real acmin,acmax,bcmin,bcmax

      real vwidth,vheight,amax2,bmax2

*  From shade_sub; to use GKS calls to get scaling 

	INTEGER		error, trans_no
	REAL	 	w(4), v(4), wc(4)

	xplus = xadd

*     Get viewport width and height in ferret; otherwise leave it alone

      IF (ppl_in_ferret) THEN

*    Do scaling as in shade_sub, using gks calls.
*    Get proper scaling, world coordinates, etc for fill

	CALL gqcntn (error,trans_no)
	IF (error .NE. 0) GOTO 1000
	CALL gqnt (trans_no,error,w,v)
	IF (error .NE. 0) GOTO 1000

*     Get world coordinates for for clipping region.

	CALL get_world_coords (w,v,wc)

      else
	 amax2 = amax
	 bmax2 = bmax
      endif


*     We're not sure if the xarg and yarg indices are needed in the calling routine
*     so copy all of the values to the x() and y() arrays.
*
*     pplmod_fillpoly doesn't use the 'inverse' flag.  (Should it?)
         DO 1 i=1,npts
#ifdef double_p
            x(i) = DBLE(xarg(i))
            y(i) = DBLE(yarg(i))
#else
            x(i) = xarg(i)
            y(i) = yarg(i)
#endif
 1       CONTINUE 
         
*     Curvilinear section
      IF (curvilinear) THEN

         CALL CURV_COORD(x, y, npts, 1.0, 1.0, status) ! xform the pts
	 IF (curv_missing) RETURN

* add offset for modulo transformation.

           DO 48, i = 1, npts
              x(i) = x(i) + xplus
 48        CONTINUE

* What is the max and min x coordinate value covered by this call?

           DO 49, i = 1, npts
              lmin = MIN(lmin, x(i))
              lmax = MAX(lmax, x(i))
 49        CONTINUE
      ENDIF
c
c scale and transform the vertices

      do 5 i=1,npts

	    if (itypex .gt. 1) then
	       xtemp = xlen*log10(x(i)/xlo)/log10(xhi/xlo)
	    else
	       xtemp = xlen*(x(i) - xlo)/(xhi-xlo)
	    endif

	    if (itypey .gt. 1) then
	       ytemp = ylen*log10(y(i)/ylo)/log10(yhi/ylo)
	    else
	       ytemp = ylen*(y(i) - ylo)/(yhi-ylo)
	    endif

            XTEMP = xtemp * XSCALE
            YTEMP = ytemp * YSCALE
*         endif
c
         call tform(xtemp,ytemp,ztemp)
         xt(i)=anew
         yt(i)=bnew
c
 5    continue
c
c find clipping region
c
      if(windof)then
         acmin = wc(1)
         acmax = wc(2)
         bcmin = wc(3)
         bcmax = wc(4)
      else
         acmin = amin
         acmax = amax2
         bcmin = bmin
         bcmax = bmax2
      endif
c
c clip polygon
c
      call clippoly(xt,yt,npts,xc,yc,nout)
c
c ticket 2374
c If the rectangle extends beyond the acmin,acmax,bcmin,bcmax rectangle on 
c both ends, it may be because of moduloing, where the rectangle we are
c coloring extends the entire length or height of the plot. Split the
c rectangle into two, to fill it in.

      if(nout.eq.0) THEN

c This will happen only in the horizontal direction; rectangles are gathered up 
c only in the horiz.
         if (xt(1).LT.acmin .AND. xt(2).GT.acmax) THEN
	    temp_hi = xt(2)
	    xt(2) = (acmin+acmax)/2.
	    xt(3) =  xt(2)
	    call clippoly(xt,yt,npts,xc,yc,nout)
	    if (nout .ne. 0) then
	       fill_ndx = index + 2
	       call set_fill_ndx (fill_ndx) 
	       call gfa (nout,xc,yc)

	       xt(1) = xt(2)
	       xt(4) = xt(2)
	       xt(2) = temp_hi
	       xt(3) = temp_hi
	    
	       call clippoly(xt,yt,npts,xc,yc,nout)
	       if (nout .ne. 0) then
	          fill_ndx = index + 2
	          call set_fill_ndx (fill_ndx) 
	          call gfa (nout,xc,yc)
	       endif
	    endif
	    nout = 0  ! all done

         endif

      endif
      if(nout.eq.0) return
c

	fill_ndx = index + 2

	call set_fill_ndx (fill_ndx) 
	call gfa (nout,xc,yc)

 50   return
*     FATAL ERROR
1000  RETURN
      END
c
      subroutine clippoly(xt,yt,npts,xc,yc,nout)
      real xt(*),yt(*),xc(*),yc(*)
      integer npts,nout
c
      real x,y
      logical inregion
      integer i0,i1

      nout = 0
      do 10 i0 = 1,npts
         i1 = i0+1
         if(i1.gt.npts)i1=1
         if(inregion(xt(i0),yt(i0))) then
            call putunique(xt(i0),yt(i0),xc,yc,nout)
            if(inregion(xt(i1),yt(i1)))then
               call putunique(xt(i1),yt(i1),xc,yc,nout)
            else
               call getinterp(xt(i0),yt(i0),xt(i1),yt(i1),x,y)
               call putunique(x,y,xc,yc,nout)
            endif
         else
            if(inregion(xt(i1),yt(i1))) then
               call getinterp(xt(i1),yt(i1),xt(i0),yt(i0),x,y)
               call putunique(x,y,xc,yc,nout)
               call putunique(xt(i1),yt(i1),xc,yc,nout)
            endif
         endif
 10   continue

      if(nout .le. 2) nout = 0
      return
      end
c
      logical function inregion(x,y)
      real x,y
c
      common/plyclp/acmin,acmax,bcmin,bcmax
      real acmin,acmax,bcmin,bcmax
c
      inregion = ((x.ge.acmin) .and. (x.le.acmax)) .and. 
     *           ((y.ge.bcmin) .and. (y.le.bcmax))
      return
      end
c
      subroutine putunique(x, y, xc, yc, nout)
      real x,y,xc(*),yc(*)
      integer nout,i
c
      if(nout .eq. 0) goto 100
      do 10 i=1,nout
         if((x.eq.xc(i)) .and. (y.eq.yc(i)))return
 10   continue
 100  nout = nout + 1
      xc(nout)=x
      yc(nout)=y
      return
      end
c
      subroutine getinterp(xin,yin,xout,yout,x,y)
      real xin,yin,xout,yout,x,y
c
      common/plyclp/acmin,acmax,bcmin,bcmax
      real acmin,acmax,bcmin,bcmax
c
      real f
c
      if(xout.lt.acmin)then
         f = (acmin - xin)/(xout - xin)
      else if(xout.gt.acmax) then
         f = (acmax - xin)/(xout - xin)
      else
         goto 100
      endif
      x = xin + (f * (xout - xin))
      y = yin + (f * (yout - yin))
      if((y.ge.bcmin).and.(y.le.bcmax))return
 100  if(yout.lt.bcmin) then
         f = (bcmin - yin)/(yout - yin)
      else
         f = (bcmax - yin)/(yout - yin)
      endif
      x = xin + (f * (xout - xin))
      y = yin + (f * (yout - yin))
      return
      end

	INTEGER*4 FUNCTION GT_GET_TIME_AXIS ( dset_num, status )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
*  Will use the information stored in XSTEP_FILES.CMN to construct a temporary
*  time axis in XTM_GRID.CMN which will then be compared to pre-existing grids
*  stored in common. If a match is found the temporary axis is deleted and the
*  line number for the pre-existing axis is returned. If no match is found,
*  the temporary axis is moved to permanent storage, and it's line number is
*  returned.
*
*  Written 06/88 for PMEL/TMAP by M. Verschell
*
* revision 0.00 - 06/30/88
* revision 0.01 - 11/21/88 - variable unused check is now a specific char_initXX
* revision 0.10 - 12/12/88 - changed line slot location to last to first search,
*			     free line memory slot gotten by next_line_mem_pos
* revision 1.00 - 01/10/88 - Checks regularity of line before creating time axis
*			     changed check of regularity to check to see if all
*			     sf_delta's are equal. eliminated unused variables,
*			     restructured code arund these changes. Line slot
*			     now gotten by TM_FIND_LIKE_LINE.
* revision 1.01 - 02/06/88 - line_modulo not initialized - corrected *sh*
* revision 1.02 - 02/17/89 - Fixed next_line_mem_pos error(1 less than correct)
* 6/24/92 *sh* & *ko* - bug fix: logic for line_regular if gap in step files
*                     - fix to bug fix (8/92 *sh*) - prev_lastep was INTEGER 
* 8/28/96 *kob*	      - bug fix: change type of "itt" to real*8
*		      - bug fix: get rid of all bpos stuff and instead
*				 call tm_irregax_mid to set up box
*				 position stuff
* 9/5/96 *kob*	      - bug fix: change of itt to real created a problem at
*			         loop 110, because itt was being used as the
*			         loop variable.  Not all of the timesteps in
*				 each stepfile were being loaded into the 
*				 line_mem array.  Loop now based on calculated
*				 nteps_in_file.
* 5/14/96 *kob*	       -Linux port - added an "INT" in calculating nsteps in the 
*				     stepfile.  roundoff /dp differences were causing
*				     a problem in linux/nag f90, so we added a small
*				     number (dp_epsilon = 1.d-10) to make sure INT operation
*			   	     would give the correct integer.
* 12/00  *acm*		add cal_id for alternative calendar axes
* V541  4/02 *acm*      Improved error message if T0 missing or bad
* V581 *acm* 6/05 - For fix to bug 1271, add flag line_shift_origin
*            and restore original t0 on output
* V600 *acm* 6/05 new flag line_fixname stores whether axis name is changed on input.
* V62  *acm* 3/09 Save original name when axis name changed on input
* V65  *acm* 2/10- all warnings and notes to std error not std out
* V663 *acm* 6/10 Fix bug where error message on bad time axis in des file 
*                 overflows its text buffer
* v67  *ACM* 5/11 lengthen string for error messages: long filenames overran string
*      *acm* 3/12 not reading GT files any more but this routine is called for MC files.
*v73+  *acm*12/17 Fixes for non-gregorian time axis in descriptor files, issue #1850.

* CALLING ARGUMENTS
*	dset_num - the data set fow which a time axis is desired
*	status  - the returning status
	INTEGER*4	dset_num, status
*
* INCLUDE FILES
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'tmap_errors.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xstep_files.cmn_text'
	external xstep_files_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xunits.cmn_text'
	external xunits_data
	include 'xio.cmn_text'
	external xio_data
*
* LOCAL DEFINITIONS
	CHARACTER*1080	string
	CHARACTER*13	TM_STRING
        CHARACTER*20    buff
	INTEGER*4	scr, nsteps, istp, cpos, cpos1, bpos, bpos0,
     .			i1, i2, i3, i4, i5, i6, iunit, nline,
     .			nsteps_in_file,i, lenb
	INTEGER*4	TM_FIND_LIKE_LINE
        INTEGER         TM_LENSTR1, TM_GET_CALENDAR_ID, cal_id
	LOGICAL		TM_FPEQ, TM_CHECK_BOX_LOC
	REAL*8		delta, prev_lastep, itt		!*kob* 8/96
	PARAMETER	( scr = 0 )


* Initialize to "no line" for error return
        GT_GET_TIME_AXIS = int4_init

* Determine the length and delta of the time axis, check regularity, and find
* first timestep
	nsteps = 0
	delta = 0.
        prev_lastep = unspecified_int4
	line_regular(scr) = .TRUE.
	line_start(scr) = unspecified_val8
	DO 100 istp = 1, maxstepfiles
	  IF ( sf_setnum(istp)      .EQ. dset_num .AND.
     .	       sf_aux_set_num(istp) .EQ. 0              ) THEN
*           Use NINT instead of INT with the dp_epsilon added or subtracted
	    nsteps = nsteps +
     .        NINT((sf_lastep(istp)-sf_1step(istp))/sf_delta(istp)) + 1
	    IF (delta .EQ. 0) THEN
	      delta = sf_delta(istp)
	    ELSE IF (.NOT. TM_FPEQ(SNGL(delta),SNGL(sf_delta(istp)))) THEN
	      line_regular(scr) = .FALSE.
            ELSE IF ( prev_lastep .NE. unspecified_int4 ) THEN  ! *sh/ko* 6/92
               IF ( .NOT.TM_FPEQ(SNGL(delta),
     .                           SNGL(sf_1step(istp)-prev_lastep)))
     .              line_regular(scr) = .FALSE.
	    ENDIF
	    IF (line_start(scr) .EQ. unspecified_val8) 
     .	        line_start(scr) = sf_1step(istp)
            prev_lastep = sf_lastep(istp)
	  ENDIF
  100	CONTINUE
	line_dim(scr) = nsteps

	IF (line_regular(scr)) THEN
* ... regular
	  line_delta(scr) = delta
	ELSE
* ... irregular

          CALL GET_LINE_DYNMEM (nsteps, scr, status) 
          IF (status .NE. merr_ok) GOTO 9999

	  line_start(scr)   = unspecified_val8
	  line_delta(scr)   = unspecified_val8
	  cpos = 1
* Create the time axis and grid box list
* kob - 8/96 - modify so loop not based on itt (now a real) but instead on
*		nsteps_in_file
	  DO 120 istp = 1,maxstepfiles
	    IF ( sf_setnum(istp) .EQ. dset_num .AND.
     .	         sf_aux_set_num(istp) .EQ. 0         ) THEN
	      delta = sf_delta(istp)
*add sanity check for delta *kob* 8/96
	      IF (delta .EQ. 0 ) delta = 1
	      nsteps_in_file = NINT((sf_lastep(istp)-
     .                  sf_1step(istp))/delta) + 1
	      itt = sf_1step(istp)
	      DO 110 i = 1,nsteps_in_file
	         CALL PUT_LINE_COORD ( linemem(scr)%ptr, cpos, itt )
	         cpos = cpos+1
		 itt = itt + delta
  110	      CONTINUE
	    ENDIF

  120	  CONTINUE
          CALL TM_IRREGAX_MID( linemem(scr)%ptr, lineedg(scr)%ptr, nsteps )

	ENDIF

* Time axis created, fill in the missing pieces
* ... name?
        line_fixname(scr) = line_name(scr) .EQ. 'TIME'

	CALL TM_NEW_LINE_NAME('TIME',line_name(scr))
	IF (line_fixname(scr)) line_name_orig(scr) = 'TIME'

* ... calendar name?
	line_cal_name(scr) = ds_cal_name(dset_num)

* ...Time_step units
	line_t0(scr)        = ds_t0time(dset_num)
	line_tunit(scr)     = ds_time_unit(dset_num)
	DO 130 iunit = pun_1st_time, pun_last_time
	  IF ( line_tunit(scr) .EQ. un_convert(iunit) ) THEN
	    line_units(scr)     = un_name(iunit)
	    line_unit_code(scr) = iunit
	    GOTO 140
	  ENDIF
  130	CONTINUE
	line_units(scr)     = ' '
	line_unit_code(scr) = 0

* ...Set modulo
 140	line_modulo(scr)    = .FALSE.

* ...Check if time/date string conversion is possible

        cal_id = TM_GET_CALENDAR_ID (line_cal_name(scr))
        
        IF (line_shift_origin(scr)) THEN
           buff = '01-JAN-0001 00:00:00'
        ELSE
 	   buff = line_T0(scr)
        ENDIF

	CALL TM_BREAK_DATE( buff,cal_id,
     .                      i1,i2,i3,i4,i5,i6,status )
	IF ( line_tunit(scr) .LE. 0       .OR.
     .	     line_t0(scr)    .EQ. ' '     .OR.
     .	     status          .NE. merr_ok      ) THEN
	  line_direction(scr) = 'NA'
	  lenb = TM_LENSTR1 (ds_name(dset_num))
	  WRITE (string, 1000) ds_name(dset_num)(:lenb)
 1000	  FORMAT 
     .   ('missing or improper date/time format for T0 in ',A) 
         lenb = TM_LENSTR1( string )
         CALL TM_NOTE( string(:lenb), lunit_errors )

	ELSE
	  line_direction(scr) = 'TI'
	ENDIF

* ...Compare this with existing axis
	CALL TM_GET_LIKE_LINE(scr,line_name(scr),nline,status)
	IF (status .NE. merr_ok) GOTO 9200
* ...Warn about possible gaps in axis
* Bug fix - change next statment from compound if to if then ---kob 10/8/91
	IF (.NOT. line_regular(nline)) THEN
           IF (.NOT. TM_CHECK_BOX_LOC(linemem(scr)%ptr,
     .                   lineedg(scr)%ptr, nsteps ) ) GOTO 9100
        ENDIF
        CALL TM_COPY_LINE ( scr, nline )
        line_name(nline) = line_name(scr)

*  deallocate the temporary line storage used to compile the axis.
        IF ( .NOT. line_regular(scr) ) THEN
           CALL FREE_LINE_DYNMEM(scr)
           line_regular(scr) = .TRUE.
        ENDIF

* Time axis complete
	GT_GET_TIME_AXIS = nline

	status = merr_ok
	GOTO 9999

 9100   CONTINUE
        IF ( .NOT. line_regular(scr) ) THEN
           CALL FREE_LINE_DYNMEM(scr)
           line_regular(scr) = .TRUE.
        ENDIF
        CALL TM_ERRMSG (merr_badlinedef, status, 'GT_GET_TIME_AXIS',
     .			no_descfile, no_stepfile,
     .			'A gap or overlap exists in time axis',
     .			no_errstring, *9999)

 9200   CONTINUE
        IF ( .NOT. line_regular(scr) ) THEN
           CALL FREE_LINE_DYNMEM(scr)
           line_regular(scr) = .TRUE.
        ENDIF
        CALL TM_ERRMSG (merr_badlinedef, status, 'GT_GET_TIME_AXIS',
     .			no_descfile, no_stepfile,
     .			'error defining axis for descriptor file', no_errstring,
     .			*9999)

* Exit subroutine
 9999	RETURN
	END

	SUBROUTINE CD_SCAN_AUX_COORDS (dset, cdfid, native_tax, status)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Finds 'coordinates' attributes on variables and sets up linkages to handle
* CF auxiliary coordinates

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 4/15
* V698 *sh* 3/2016 - pass native_tax to CD_1D_LINE_FROM_2D
* V74+ *acm* 12/2018 - issue 1049: Skip over rare case of a string variable
*                      that looks to be a coordinate

* argument definitions:
*       dset        - TMAP data set pointer
*	cdfid       - netCDF open ID (should no longer be needed!!)
*	native_tax  - the official time axis of the dataset
*	status	    - return status

* include files

        include 'netcdf.inc'
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
        include 'xbuild_grids.cmn'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xtm_grid.cmn_text'
	        include 'xdset_info.cd_equiv'

* argument declarations
	INTEGER	 dset, cdfid, native_tax, status


* local parameter definitions:
	LOGICAL	    do_warn
	INTEGER     str_eq, max_names
	PARAMETER (str_eq = 0)
	PARAMETER (do_warn = .TRUE.)
	PARAMETER (max_names = 8)   ! max num of axis coordinates (variable) names for a variable


* local variable declarations:
	LOGICAL NC_GET_ATTRIB, got_it, coordvar

	INTEGER TM_LENSTR1, STR_CASE_BLIND_COMPARE, 
     .		i, tmvar, ivar, num_names, nvdim, all_outflag,
     .		maxlen, attlen, attoutflag, tmp, cdf_stat, nvatts,
     .		axcalt, axlagf, istat, vartyp, vlen, vdims(8)
	CHARACTER aux_coord_names*500, coord_name(max_names)*128,
     .		  vname*128, name*16
	REAL vals  ! potential numerical attributes

* loop through each variable in this TMAP data set
* if it has a "coordinates" attribute then associate it with that variable
* and flag that variable as an auxiliary coordinate

        DO tmvar = 1,maxvars
           IF ( ds_var_setnum(tmvar) .NE. dset ) CYCLE
           ivar = cd_varid(tmvar)

           CALL CD_GET_VAR_INFO (dset, ivar, vname, vartyp, nvdim, vdims,
     .                 nvatts, coordvar, all_outflag, istat)
	   vlen = TM_LENSTR1(vname)
	   IF (vartyp .EQ. ncchar) CYCLE

* THIS BOCK OF CODE WAS STARTED ONLY QUICKLY
* POSTPONED IT UNTIL LATER TO GET JUST THE 2D TIME FMRC FUNCTIONALITY
!* does it point explicitly to auxiliary coordinate  ?
!           maxlen = 240  
!           got_it = NC_GET_ATTRIB( dset, ivar, 'coordinates',
!     .                         .NOT.do_warn, ' ', maxlen, attlen,
!     .                         attoutflag, aux_coord_names, tmp )  
!           IF ( got_it ) THEN
!* parse the list of white-space-separated auxiliary variable names
!	      CALL TM_PARSE_STRING(aux_coord_names,max_names,
!     .				   coord_names,num_names)
!* ... this is a poorly formatted notice, but may never be issued
!	      IF (num_names .GT. max_names) CALL WARN(
!     .		 'netCDF coordinates attribute on variable '//
!     .		  ds_var_code(tmvar)//'has too many names')
!	      i = 1
!	      DO i=1, attlen
!	        IF (
!XXXXX  --INTERRUPTED AT EARLY STAGE OF WRITING THIS CODE
!for each variable that possess a coordinates attribute
!	- loop through the coordinate variables listed
!	- identify the orientation of each
!        - put Ferret attributes onto the parent variable pointing to
!              larerz target, time2d target, etc.
!        - set ds_its_aux_coord on the target variable
!          ENDIF
!after the loop, if an aux variable was targetted as the 2dtime variable
!then create TF_CAL_T and TF_LAG_F axes (move this logic from CD_SCAN_VARS) 

* !! TEMPORARILY!!! identify the 2d time variable from the attribute
* _ CoordinateAxisType
*  Eventually we will recognize it from an assemblage of facts.
*   o other variables point to it as a coordinate
*   o it is 2d in the tf plane

	   IF ( STR_CASE_BLIND_COMPARE(vname(:vlen), 'time').EQ.str_eq 
     .    .AND. nvdim .EQ. 2 ) THEN  
              maxlen = 16  
              got_it = NC_GET_ATTRIB( dset, ivar, '_CoordinateAxisType',
     .                            do_warn, vname(:vlen), maxlen, attlen,
     .                            attoutflag, name, vals ) 
              IF ( got_it
     .       .AND. STR_CASE_BLIND_COMPARE(name, 'Time').EQ.str_eq ) THEN
* ... Synthesize a 1D time axis and forecast lead time for the colection
*     Also modify the native time axis to become a true delta (lag) time
	         CALL CD_1D_LINE_FROM_2D (dset, cdfid, ivar, vname,
     .					  axcalt, axlagf, native_tax, status)
	      ENDIF
	   ENDIF
	ENDDO

*               ... Now set a global attribute for this dataset with the
*                   new axis name
* TBD

* successful completion
 	status = merr_ok
        RETURN

* error exit
 5900   RETURN
	END

*  fftsubs.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
* 
*   computation routines for FFT functions

      SUBROUTINE four_re (nd, x, a, b, wft)
      INTEGER nd, nf, i, j
      REAL x(*), wft(*) 
      REAL a(*), b(*), xn

c   uses NCAR FFTPACK code

C  Ansley Manke 1/2000 NOAA/PMEL   Return A, B real arrays with Fourier coefficients.
C  Uses notes by Ned Cokelet 1/2000 on Swartztrauber FFTPACK code.

c   Calls: RFFTF


C  NF = number of frequencies, half the number of times.
C  The code returns frequencies W(i) for i=0 to ND/2, with ND/2 rounded down.
C  We do not return a(0) = R1/ND
C  We return a(i) and b(i) for i=1,... ND/2  

      nf = nd/ 2

      CALL rfftf (nd, x, wft) 

C  Normalizing factor of 1./N

c      xn = 1.0
      xn = 1.0/ REAL(nd)

c   Save FFT coefficients in arrays a and b.
      
      j = 0
      DO i = 1, nf-1
        j = 2* i
        a(i) =  2.* xn* x(j)
        b(i) = -2.* xn* x(j+1) 
      ENDDO

C  Set a(nf) and b(nf) when nd is even/odd.

      IF (nf*2 .eq. nd) THEN		! even ND
         a(nf) = xn* x(nd)
         b(nf) = 0.
      ELSE				! odd ND
         a(nf) = 2.* xn* x(nd-1)
         b(nf) = -2.* xn* x(nd)
      ENDIF

      RETURN 
      END

                                                                 
C     SUBROUTINE RFFTF(N,R,WSAVE)                                               
C                                                                               
C     SUBROUTINE RFFTF COMPUTES THE FOURIER COEFFICIENTS OF A REAL              
C     PERODIC SEQUENCE (FOURIER ANALYSIS). THE TRANSFORM IS DEFINED             
C     BELOW AT OUTPUT PARAMETER R.                                              
C                                                                               
C     INPUT PARAMETERS                                                          
C                                                                               
C     N       THE LENGTH OF THE ARRAY R TO BE TRANSFORMED.  THE METHOD          
C             IS MOST EFFICIENT WHEN N IS A PRODUCT OF SMALL PRIMES.            
C             N MAY CHANGE SO LONG AS DIFFERENT WORK ARRAYS ARE PROVIDED        
C                                                                               
C     R       A REAL ARRAY OF LENGTH N WHICH CONTAINS THE SEQUENCE              
C             TO BE TRANSFORMED                                                 
C                                                                               
C     WSAVE   A WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 2*N+15.           
C             IN THE PROGRAM THAT CALLS RFFTF. THE WSAVE ARRAY MUST BE          
C             INITIALIZED BY CALLING SUBROUTINE RFFTI(N,WSAVE) AND A            
C             DIFFERENT WSAVE ARRAY MUST BE USED FOR EACH DIFFERENT             
C             VALUE OF N. THIS INITIALIZATION DOES NOT HAVE TO BE               
C             REPEATED SO LONG AS N REMAINS UNCHANGED THUS SUBSEQUENT           
C             TRANSFORMS CAN BE OBTAINED FASTER THAN THE FIRST.                 
C             THE SAME WSAVE ARRAY CAN BE USED BY RFFTF AND RFFTB.              
C                                                                               
C                                                                               
C     OUTPUT PARAMETERS                                                         
C                                                                               
C     R       R(1) = THE SUM FROM I=1 TO I=N OF R(I)                            
C                                                                               
C             IF N IS EVEN SET L =N/2   , IF N IS ODD SET L = (N+1)/2           
C                                                                               
C               THEN FOR K = 2,...,L                                            
C                                                                               
C                  R(2*K-2) = THE SUM FROM I = 1 TO I = N OF                    
C                                                                               
C                       R(I)*COS((K-1)*(I-1)*2*PI/N)                            
C                                                                               
C                  R(2*K-1) = THE SUM FROM I = 1 TO I = N OF                    
C                                                                               
C                      -R(I)*SIN((K-1)*(I-1)*2*PI/N)                            
C                                                                               
C             IF N IS EVEN                                                      
C                                                                               
C                  R(N) = THE SUM FROM I = 1 TO I = N OF                        
C                                                                               
C                       (-1)**(I-1)*R(I)                                        
C                                                                               
C      *****  NOTE                                                              
C                  THIS TRANSFORM IS UNNORMALIZED SINCE A CALL OF RFFTF         
C                  FOLLOWED BY A CALL OF RFFTB WILL MULTIPLY THE INPUT          
C                  SEQUENCE BY N.                                               
C                                                                               
C     WSAVE   CONTAINS RESULTS WHICH MUST NOT BE DESTROYED BETWEEN              
C             CALLS OF RFFTF OR RFFTB.                                          
C                                                                               
      SUBROUTINE RFFTF (N,R,WSAVE)                                              
      INTEGER N
      REAL       R(*)       ,WSAVE(*)             
C                                                                               
      IF (N .EQ. 1) RETURN                                                      
      CALL RFFTF1 (N,R,WSAVE,WSAVE(N+1),WSAVE(2*N+1))                           
      RETURN                                                                    
      END                                                                       
      SUBROUTINE RFFTF1 (N,C,CH,WA,IFAC)                                        
      INTEGER N, NF, NA, L2, IW, K1, KH, IP, L1, IDO, IDL1, IX2, IX3
      INTEGER I, IX4
      REAL       CH(*)      ,C(*)       ,WA(*)      ,IFAC(*)   
      NF = IFAC(2)                                                              
      NA = 1                                                                    
      L2 = N                                                                    
      IW = N                                                                    
      DO 111 K1=1,NF                                                            
         KH = NF-K1                                                             
         IP = IFAC(KH+3)                                                        
         L1 = L2/IP                                                             
         IDO = N/L2                                                             
         IDL1 = IDO*L1                                                          
         IW = IW-(IP-1)*IDO                                                     
         NA = 1-NA                                                              
         IF (IP .NE. 4) GO TO 102                                               
         IX2 = IW+IDO                                                           
         IX3 = IX2+IDO                                                          
         IF (NA .NE. 0) GO TO 101                                               
         CALL RADF4 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3))                        
         GO TO 110                                                              
  101    CALL RADF4 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3))                        
         GO TO 110                                                              
  102    IF (IP .NE. 2) GO TO 104                                               
         IF (NA .NE. 0) GO TO 103                                               
         CALL RADF2 (IDO,L1,C,CH,WA(IW))                                        
         GO TO 110                                                              
  103    CALL RADF2 (IDO,L1,CH,C,WA(IW))                                        
         GO TO 110                                                              
  104    IF (IP .NE. 3) GO TO 106                                               
         IX2 = IW+IDO                                                           
         IF (NA .NE. 0) GO TO 105                                               
         CALL RADF3 (IDO,L1,C,CH,WA(IW),WA(IX2))                                
         GO TO 110                                                              
  105    CALL RADF3 (IDO,L1,CH,C,WA(IW),WA(IX2))                                
         GO TO 110                                                              
  106    IF (IP .NE. 5) GO TO 108                                               
         IX2 = IW+IDO                                                           
         IX3 = IX2+IDO                                                          
         IX4 = IX3+IDO                                                          
         IF (NA .NE. 0) GO TO 107                                               
         CALL RADF5 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3),WA(IX4))                
         GO TO 110                                                              
  107    CALL RADF5 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3),WA(IX4))                
         GO TO 110                                                              
  108    IF (IDO .EQ. 1) NA = 1-NA                                              
         IF (NA .NE. 0) GO TO 109                                               
         CALL RADFG (IDO,IP,L1,IDL1,C,C,C,CH,CH,WA(IW))                         
         NA = 1                                                                 
         GO TO 110                                                              
  109    CALL RADFG (IDO,IP,L1,IDL1,CH,CH,CH,C,C,WA(IW))                        
         NA = 0                                                                 
  110    L2 = L1                                                                
  111 CONTINUE                                                                  
      IF (NA .EQ. 1) RETURN                                                     
      DO 112 I=1,N                                                              
         C(I) = CH(I)                                                           
  112 CONTINUE                                                                  
      RETURN                                                                    
      END                         
                                                                    
C     SUBROUTINE RFFTI(N,WSAVE)                                                 
C                                                                               
C     SUBROUTINE RFFTI INITIALIZES THE ARRAY WSAVE WHICH IS USED IN             
C     BOTH RFFTF AND RFFTB. THE PRIME FACTORIZATION OF N TOGETHER WITH          
C     A TABULATION OF THE TRIGONOMETRIC FUNCTIONS ARE COMPUTED AND              
C     STORED IN WSAVE.                                                          
C                                                                               
C     INPUT PARAMETER                                                           
C                                                                               
C     N       THE LENGTH OF THE SEQUENCE TO BE TRANSFORMED.                     
C                                                                               
C     OUTPUT PARAMETER                                                          
C                                                                               
C     WSAVE   A WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 2*N+15.           
C             THE SAME WORK ARRAY CAN BE USED FOR BOTH RFFTF AND RFFTB          
C             AS LONG AS N REMAINS UNCHANGED. DIFFERENT WSAVE ARRAYS            
C             ARE REQUIRED FOR DIFFERENT VALUES OF N. THE CONTENTS OF           
C             WSAVE MUST NOT BE CHANGED BETWEEN CALLS OF RFFTF OR RFFTB.        
C                                                                               
      SUBROUTINE RFFTI (N,WSAVE)      
      INTEGER N
      REAL       WSAVE(*)                                                  
C                                                                               
      IF (N .EQ. 1) RETURN                                                      
      CALL RFFTI1 (N,WSAVE(N+1),WSAVE(2*N+1))                                   
      RETURN                                                                    
      END                                                                       
      SUBROUTINE RFFTI1 (N,WA,IFAC)                                             
      INTEGER N, NL, NF, J, NTRY, NR, NQ, IB, I, IS, L1, NFM1, K1
      INTEGER IP, LD, IDO, IPM, II, L2
      REAL       WA(*)      ,IFAC(*)    ,NTRYH(4)         
      REAL TPI, ARGH, ARGLD, FI, ARG, DUM
      REAL PIMACH
      DATA NTRYH(1),NTRYH(2),NTRYH(3),NTRYH(4)/4,2,3,5/                         
      NL = N                                                                    
      NF = 0                                                                    
      J = 0                                                                     
  101 J = J+1                                                                   
      IF (J-4) 102,102,103                                                      
  102 NTRY = NTRYH(J)                                                           
      GO TO 104                                                                 
  103 NTRY = NTRY+2                                                             
  104 NQ = NL/NTRY                                                              
      NR = NL-NTRY*NQ                                                           
      IF (NR) 101,105,101                                                       
  105 NF = NF+1                                                                 
      IFAC(NF+2) = NTRY                                                         
      NL = NQ                                                                   
      IF (NTRY .NE. 2) GO TO 107                                                
      IF (NF .EQ. 1) GO TO 107                                                  
      DO 106 I=2,NF                                                             
         IB = NF-I+2                                                            
         IFAC(IB+2) = IFAC(IB+1)                                                
  106 CONTINUE                                                                  
      IFAC(3) = 2                                                               
  107 IF (NL .NE. 1) GO TO 104                                                  
      IFAC(1) = N                                                               
      IFAC(2) = NF                                                              
      TPI = 2.0*PIMACH(DUM)                                                     
      ARGH = TPI/FLOAT(N)                                                       
      IS = 0                                                                    
      NFM1 = NF-1                                                               
      L1 = 1                                                                    
      IF (NFM1 .EQ. 0) RETURN                                                   
      DO 110 K1=1,NFM1                                                          
         IP = IFAC(K1+2)                                                        
         LD = 0                                                                 
         L2 = L1*IP                                                             
         IDO = N/L2                                                             
         IPM = IP-1                                                             
         DO 109 J=1,IPM                                                         
            LD = LD+L1                                                          
            I = IS                                                              
            ARGLD = FLOAT(LD)*ARGH                                              
            FI = 0.                                                             
            DO 108 II=3,IDO,2                                                   
               I = I+2                                                          
               FI = FI+1.                                                       
               ARG = FI*ARGLD                                                   
               WA(I-1) = COS(ARG)                                               
               WA(I) = SIN(ARG)                                                 
  108       CONTINUE                                                            
            IS = IS+IDO                                                         
  109    CONTINUE                                                               
         L1 = L2                                                                
  110 CONTINUE                                                                  
      RETURN                                                                    
      END
   
      
      REAL FUNCTION PIMACH (DUM)                      
C     PI=3.1415926535897932384626433832795028841971693993751058209749446        
C                            
      REAL DUM
      PIMACH = 4.*ATAN(1.0)                                                     
      RETURN                                                                    
      END    
                                                                            
      SUBROUTINE RADFG (IDO,IP,L1,IDL1,CC,C1,C2,CH,CH2,WA)                      
      INTEGER IDO, IP, L1, IDL1, IPPH, IPP2, IDP2, NBD, IK, J, K, IS
      INTEGER IDIJ, I, JC, L, LC, J2, IC
      REAL       CH(IDO,L1,IP)          ,CC(IDO,IP,L1)          ,          
     1                C1(IDO,L1,IP)          ,C2(IDL1,IP),                      
     2                CH2(IDL1,IP)           ,WA(*)

      REAL TPI, DUM, ARG, DCP, DSP, AR1, AI1, AR1H, DC2, DS2, AR2, AI2
      REAL AR2H
      REAL PIMACH
      TPI = 2.0*PIMACH(DUM)                                                     
      ARG = TPI/FLOAT(IP)                                                       
      DCP = COS(ARG)                                                            
      DSP = SIN(ARG)                                                            
      IPPH = (IP+1)/2                                                           
      IPP2 = IP+2                                                               
      IDP2 = IDO+2                                                              
      NBD = (IDO-1)/2                                                           
      IF (IDO .EQ. 1) GO TO 119                                                 
      DO 101 IK=1,IDL1                                                          
         CH2(IK,1) = C2(IK,1)                                                   
  101 CONTINUE                                                                  
      DO 103 J=2,IP                                                             
         DO 102 K=1,L1                                                          
            CH(1,K,J) = C1(1,K,J)                                               
  102    CONTINUE                                                               
  103 CONTINUE                                                                  
      IF (NBD .GT. L1) GO TO 107                                                
      IS = -IDO                                                                 
      DO 106 J=2,IP                                                             
         IS = IS+IDO                                                            
         IDIJ = IS                                                              
         DO 105 I=3,IDO,2                                                       
            IDIJ = IDIJ+2                                                       
            DO 104 K=1,L1                                                       
               CH(I-1,K,J) = WA(IDIJ-1)*C1(I-1,K,J)+WA(IDIJ)*C1(I,K,J)          
               CH(I,K,J) = WA(IDIJ-1)*C1(I,K,J)-WA(IDIJ)*C1(I-1,K,J)            
  104       CONTINUE                                                            
  105    CONTINUE                                                               
  106 CONTINUE                                                                  
      GO TO 111                                                                 
  107 IS = -IDO                                                                 
      DO 110 J=2,IP                                                             
         IS = IS+IDO                                                            
         DO 109 K=1,L1                                                          
            IDIJ = IS                                                           
            DO 108 I=3,IDO,2                                                    
               IDIJ = IDIJ+2                                                    
               CH(I-1,K,J) = WA(IDIJ-1)*C1(I-1,K,J)+WA(IDIJ)*C1(I,K,J)          
               CH(I,K,J) = WA(IDIJ-1)*C1(I,K,J)-WA(IDIJ)*C1(I-1,K,J)            
  108       CONTINUE                                                            
  109    CONTINUE                                                               
  110 CONTINUE                                                                  
  111 IF (NBD .LT. L1) GO TO 115                                                
      DO 114 J=2,IPPH                                                           
         JC = IPP2-J                                                            
         DO 113 K=1,L1                                                          
            DO 112 I=3,IDO,2                                                    
               C1(I-1,K,J) = CH(I-1,K,J)+CH(I-1,K,JC)                           
               C1(I-1,K,JC) = CH(I,K,J)-CH(I,K,JC)                              
               C1(I,K,J) = CH(I,K,J)+CH(I,K,JC)                                 
               C1(I,K,JC) = CH(I-1,K,JC)-CH(I-1,K,J)                            
  112       CONTINUE                                                            
  113    CONTINUE                                                               
  114 CONTINUE                                                                  
      GO TO 121                                                                 
  115 DO 118 J=2,IPPH                                                           
         JC = IPP2-J                                                            
         DO 117 I=3,IDO,2                                                       
            DO 116 K=1,L1                                                       
               C1(I-1,K,J) = CH(I-1,K,J)+CH(I-1,K,JC)                           
               C1(I-1,K,JC) = CH(I,K,J)-CH(I,K,JC)                              
               C1(I,K,J) = CH(I,K,J)+CH(I,K,JC)                                 
               C1(I,K,JC) = CH(I-1,K,JC)-CH(I-1,K,J)                            
  116       CONTINUE                                                            
  117    CONTINUE                                                               
  118 CONTINUE                                                                  
      GO TO 121                                                                 
  119 DO 120 IK=1,IDL1                                                          
         C2(IK,1) = CH2(IK,1)                                                   
  120 CONTINUE                                                                  
  121 DO 123 J=2,IPPH                                                           
         JC = IPP2-J                                                            
         DO 122 K=1,L1                                                          
            C1(1,K,J) = CH(1,K,J)+CH(1,K,JC)                                    
            C1(1,K,JC) = CH(1,K,JC)-CH(1,K,J)                                   
  122    CONTINUE                                                               
  123 CONTINUE                                                                  
C                                                                               
      AR1 = 1.                                                                  
      AI1 = 0.                                                                  
      DO 127 L=2,IPPH                                                           
         LC = IPP2-L                                                            
         AR1H = DCP*AR1-DSP*AI1                                                 
         AI1 = DCP*AI1+DSP*AR1                                                  
         AR1 = AR1H                                                             
         DO 124 IK=1,IDL1                                                       
            CH2(IK,L) = C2(IK,1)+AR1*C2(IK,2)                                   
            CH2(IK,LC) = AI1*C2(IK,IP)                                          
  124    CONTINUE                                                               
         DC2 = AR1                                                              
         DS2 = AI1                                                              
         AR2 = AR1                                                              
         AI2 = AI1                                                              
         DO 126 J=3,IPPH                                                        
            JC = IPP2-J                                                         
            AR2H = DC2*AR2-DS2*AI2                                              
            AI2 = DC2*AI2+DS2*AR2                                               
            AR2 = AR2H                                                          
            DO 125 IK=1,IDL1                                                    
               CH2(IK,L) = CH2(IK,L)+AR2*C2(IK,J)                               
               CH2(IK,LC) = CH2(IK,LC)+AI2*C2(IK,JC)                            
  125       CONTINUE                                                            
  126    CONTINUE                                                               
  127 CONTINUE                                                                  
      DO 129 J=2,IPPH                                                           
         DO 128 IK=1,IDL1                                                       
            CH2(IK,1) = CH2(IK,1)+C2(IK,J)                                      
  128    CONTINUE                                                               
  129 CONTINUE                                                                  
C                                                                               
      IF (IDO .LT. L1) GO TO 132                                                
      DO 131 K=1,L1                                                             
         DO 130 I=1,IDO                                                         
            CC(I,1,K) = CH(I,K,1)                                               
  130    CONTINUE                                                               
  131 CONTINUE                                                                  
      GO TO 135                                                                 
  132 DO 134 I=1,IDO                                                            
         DO 133 K=1,L1                                                          
            CC(I,1,K) = CH(I,K,1)                                               
  133    CONTINUE                                                               
  134 CONTINUE                                                                  
  135 DO 137 J=2,IPPH                                                           
         JC = IPP2-J                                                            
         J2 = J+J                                                               
         DO 136 K=1,L1                                                          
            CC(IDO,J2-2,K) = CH(1,K,J)                                          
            CC(1,J2-1,K) = CH(1,K,JC)                                           
  136    CONTINUE                                                               
  137 CONTINUE                                                                  
      IF (IDO .EQ. 1) RETURN                                                    
      IF (NBD .LT. L1) GO TO 141                                                
      DO 140 J=2,IPPH                                                           
         JC = IPP2-J                                                            
         J2 = J+J                                                               
         DO 139 K=1,L1                                                          
            DO 138 I=3,IDO,2                                                    
               IC = IDP2-I                                                      
               CC(I-1,J2-1,K) = CH(I-1,K,J)+CH(I-1,K,JC)                        
               CC(IC-1,J2-2,K) = CH(I-1,K,J)-CH(I-1,K,JC)                       
               CC(I,J2-1,K) = CH(I,K,J)+CH(I,K,JC)                              
               CC(IC,J2-2,K) = CH(I,K,JC)-CH(I,K,J)                             
  138       CONTINUE                                                            
  139    CONTINUE                                                               
  140 CONTINUE                                                                  
      RETURN                                                                    
  141 DO 144 J=2,IPPH                                                           
         JC = IPP2-J                                                            
         J2 = J+J                                                               
         DO 143 I=3,IDO,2                                                       
            IC = IDP2-I                                                         
            DO 142 K=1,L1                                                       
               CC(I-1,J2-1,K) = CH(I-1,K,J)+CH(I-1,K,JC)                        
               CC(IC-1,J2-2,K) = CH(I-1,K,J)-CH(I-1,K,JC)                       
               CC(I,J2-1,K) = CH(I,K,J)+CH(I,K,JC)                              
               CC(IC,J2-2,K) = CH(I,K,JC)-CH(I,K,J)                             
  142       CONTINUE                                                            
  143    CONTINUE                                                               
  144 CONTINUE                                                                  
      RETURN                                                                    
      END                         
                                                                       
      SUBROUTINE RADF5 (IDO,L1,CC,CH,WA1,WA2,WA3,WA4)                           
      INTEGER IDO, L1, K, IDP2, I, IC
      REAL       CC(IDO,L1,5)           ,CH(IDO,5,L1)           ,          
     1                WA1(*)     ,WA2(*)     ,WA3(*)     ,WA4(*)    
      REAL CR2, CR3, CR4, CR5, CI2, CI3, CI4, CI5
      REAL TR2, TR3, TR4, TR5, TI2, TI3, TI4, TI5
      REAL DR2, DR3, DR4, DR5, DI2, DI3, DI4, DI5
      REAL TR11, TI11, TR12, TI12
      DATA TR11,TI11,TR12,TI12 /.309016994374947,.951056516295154,              
     1-.809016994374947,.587785252292473/                                       
      DO 101 K=1,L1                                                             
         CR2 = CC(1,K,5)+CC(1,K,2)                                              
         CI5 = CC(1,K,5)-CC(1,K,2)                                              
         CR3 = CC(1,K,4)+CC(1,K,3)                                              
         CI4 = CC(1,K,4)-CC(1,K,3)                                              
         CH(1,1,K) = CC(1,K,1)+CR2+CR3                                          
         CH(IDO,2,K) = CC(1,K,1)+TR11*CR2+TR12*CR3                              
         CH(1,3,K) = TI11*CI5+TI12*CI4                                          
         CH(IDO,4,K) = CC(1,K,1)+TR12*CR2+TR11*CR3                              
         CH(1,5,K) = TI12*CI5-TI11*CI4                                          
  101 CONTINUE                                                                  
      IF (IDO .EQ. 1) RETURN                                                    
      IDP2 = IDO+2                                                              
      DO 103 K=1,L1                                                             
         DO 102 I=3,IDO,2                                                       
            IC = IDP2-I                                                         
            DR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)                       
            DI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)                       
            DR3 = WA2(I-2)*CC(I-1,K,3)+WA2(I-1)*CC(I,K,3)                       
            DI3 = WA2(I-2)*CC(I,K,3)-WA2(I-1)*CC(I-1,K,3)                       
            DR4 = WA3(I-2)*CC(I-1,K,4)+WA3(I-1)*CC(I,K,4)                       
            DI4 = WA3(I-2)*CC(I,K,4)-WA3(I-1)*CC(I-1,K,4)                       
            DR5 = WA4(I-2)*CC(I-1,K,5)+WA4(I-1)*CC(I,K,5)                       
            DI5 = WA4(I-2)*CC(I,K,5)-WA4(I-1)*CC(I-1,K,5)                       
            CR2 = DR2+DR5                                                       
            CI5 = DR5-DR2                                                       
            CR5 = DI2-DI5                                                       
            CI2 = DI2+DI5                                                       
            CR3 = DR3+DR4                                                       
            CI4 = DR4-DR3                                                       
            CR4 = DI3-DI4                                                       
            CI3 = DI3+DI4                                                       
            CH(I-1,1,K) = CC(I-1,K,1)+CR2+CR3                                   
            CH(I,1,K) = CC(I,K,1)+CI2+CI3                                       
            TR2 = CC(I-1,K,1)+TR11*CR2+TR12*CR3                                 
            TI2 = CC(I,K,1)+TR11*CI2+TR12*CI3                                   
            TR3 = CC(I-1,K,1)+TR12*CR2+TR11*CR3                                 
            TI3 = CC(I,K,1)+TR12*CI2+TR11*CI3                                   
            TR5 = TI11*CR5+TI12*CR4                                             
            TI5 = TI11*CI5+TI12*CI4                                             
            TR4 = TI12*CR5-TI11*CR4                                             
            TI4 = TI12*CI5-TI11*CI4                                             
            CH(I-1,3,K) = TR2+TR5                                               
            CH(IC-1,2,K) = TR2-TR5                                              
            CH(I,3,K) = TI2+TI5                                                 
            CH(IC,2,K) = TI5-TI2                                                
            CH(I-1,5,K) = TR3+TR4                                               
            CH(IC-1,4,K) = TR3-TR4                                              
            CH(I,5,K) = TI3+TI4                                                 
            CH(IC,4,K) = TI4-TI3                                                
  102    CONTINUE                                                               
  103 CONTINUE                                                                  
      RETURN                                                                    
      END                           
                                                                  
      SUBROUTINE RADF2 (IDO,L1,CC,CH,WA1)                                       
      INTEGER IDO, L1, K, IDP2, I, IC
      REAL       CH(IDO,2,L1)           ,CC(IDO,L1,2)           ,          
     1                WA1(*)           
      REAL TR2, TI2
      DO 101 K=1,L1                                                             
         CH(1,1,K) = CC(1,K,1)+CC(1,K,2)                                        
         CH(IDO,2,K) = CC(1,K,1)-CC(1,K,2)                                      
  101 CONTINUE                                                                  
      IF (IDO-2) 107,105,102                                                    
  102 IDP2 = IDO+2                                                              
      DO 104 K=1,L1                                                             
         DO 103 I=3,IDO,2                                                       
            IC = IDP2-I                                                         
            TR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)                       
            TI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)                       
            CH(I,1,K) = CC(I,K,1)+TI2                                           
            CH(IC,2,K) = TI2-CC(I,K,1)                                          
            CH(I-1,1,K) = CC(I-1,K,1)+TR2                                       
            CH(IC-1,2,K) = CC(I-1,K,1)-TR2                                      
  103    CONTINUE                                                               
  104 CONTINUE                                                                  
      IF (MOD(IDO,2) .EQ. 1) RETURN                                             
  105 DO 106 K=1,L1                                                             
         CH(1,2,K) = -CC(IDO,K,2)                                               
         CH(IDO,1,K) = CC(IDO,K,1)                                              
  106 CONTINUE                                                                  
  107 RETURN                                                                    
      END      
                                                                       
      SUBROUTINE RADF3 (IDO,L1,CC,CH,WA1,WA2)                                   
      INTEGER IDO, L1, I, IC, K, IDP2
      REAL       CH(IDO,3,L1)           ,CC(IDO,L1,3)           ,          
     1                WA1(*)     ,WA2(*)     
      REAL TAUR, TAUI, CR2, DR2, DI2, DR3, DI3, CI2, TR2, TI2, TR3, TI3
      DATA TAUR,TAUI /-.5,.866025403784439/                                     
      DO 101 K=1,L1                                                             
         CR2 = CC(1,K,2)+CC(1,K,3)                                              
         CH(1,1,K) = CC(1,K,1)+CR2                                              
         CH(1,3,K) = TAUI*(CC(1,K,3)-CC(1,K,2))                                 
         CH(IDO,2,K) = CC(1,K,1)+TAUR*CR2                                       
  101 CONTINUE                                                                  
      IF (IDO .EQ. 1) RETURN                                                    
      IDP2 = IDO+2                                                              
      DO 103 K=1,L1                                                             
         DO 102 I=3,IDO,2                                                       
            IC = IDP2-I                                                         
            DR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)                       
            DI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)                       
            DR3 = WA2(I-2)*CC(I-1,K,3)+WA2(I-1)*CC(I,K,3)                       
            DI3 = WA2(I-2)*CC(I,K,3)-WA2(I-1)*CC(I-1,K,3)                       
            CR2 = DR2+DR3                                                       
            CI2 = DI2+DI3                                                       
            CH(I-1,1,K) = CC(I-1,K,1)+CR2                                       
            CH(I,1,K) = CC(I,K,1)+CI2                                           
            TR2 = CC(I-1,K,1)+TAUR*CR2                                          
            TI2 = CC(I,K,1)+TAUR*CI2                                            
            TR3 = TAUI*(DI2-DI3)                                                
            TI3 = TAUI*(DR3-DR2)                                                
            CH(I-1,3,K) = TR2+TR3                                               
            CH(IC-1,2,K) = TR2-TR3                                              
            CH(I,3,K) = TI2+TI3                                                 
            CH(IC,2,K) = TI3-TI2                                                
  102    CONTINUE                                                               
  103 CONTINUE                                                                  
      RETURN                                                                    
      END                                                                       
      SUBROUTINE RADF4 (IDO,L1,CC,CH,WA1,WA2,WA3)                               
      INTEGER IDO, L1, K, IDP2, I, IC
      REAL       CC(IDO,L1,4)           ,CH(IDO,4,L1)           ,          
     1                WA1(*)     ,WA2(*)     ,WA3(*)  
      REAL HSQT2
      REAL CR2, CR3, CR4, CI2, CI3, CI4
      REAL TR1, TR2, TR3, TR4, TI1, TI2, TI3, TI4
      DATA HSQT2 /.7071067811865475/                                            
      DO 101 K=1,L1                                                             
         TR1 = CC(1,K,2)+CC(1,K,4)                                              
         TR2 = CC(1,K,1)+CC(1,K,3)                                              
         CH(1,1,K) = TR1+TR2                                                    
         CH(IDO,4,K) = TR2-TR1                                                  
         CH(IDO,2,K) = CC(1,K,1)-CC(1,K,3)                                      
         CH(1,3,K) = CC(1,K,4)-CC(1,K,2)                                        
  101 CONTINUE                                                                  
      IF (IDO-2) 107,105,102                                                    
  102 IDP2 = IDO+2                                                              
      DO 104 K=1,L1                                                             
         DO 103 I=3,IDO,2                                                       
            IC = IDP2-I                                                         
            CR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)                       
            CI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)                       
            CR3 = WA2(I-2)*CC(I-1,K,3)+WA2(I-1)*CC(I,K,3)                       
            CI3 = WA2(I-2)*CC(I,K,3)-WA2(I-1)*CC(I-1,K,3)                       
            CR4 = WA3(I-2)*CC(I-1,K,4)+WA3(I-1)*CC(I,K,4)                       
            CI4 = WA3(I-2)*CC(I,K,4)-WA3(I-1)*CC(I-1,K,4)                       
            TR1 = CR2+CR4                                                       
            TR4 = CR4-CR2                                                       
            TI1 = CI2+CI4                                                       
            TI4 = CI2-CI4                                                       
            TI2 = CC(I,K,1)+CI3                                                 
            TI3 = CC(I,K,1)-CI3                                                 
            TR2 = CC(I-1,K,1)+CR3                                               
            TR3 = CC(I-1,K,1)-CR3                                               
            CH(I-1,1,K) = TR1+TR2                                               
            CH(IC-1,4,K) = TR2-TR1                                              
            CH(I,1,K) = TI1+TI2                                                 
            CH(IC,4,K) = TI1-TI2                                                
            CH(I-1,3,K) = TI4+TR3                                               
            CH(IC-1,2,K) = TR3-TI4                                              
            CH(I,3,K) = TR4+TI3                                                 
            CH(IC,2,K) = TR4-TI3                                                
  103    CONTINUE                                                               
  104 CONTINUE                                                                  
      IF (MOD(IDO,2) .EQ. 1) RETURN                                             
  105 CONTINUE                                                                  
      DO 106 K=1,L1                                                             
         TI1 = -HSQT2*(CC(IDO,K,2)+CC(IDO,K,4))                                 
         TR1 = HSQT2*(CC(IDO,K,2)-CC(IDO,K,4))                                  
         CH(IDO,1,K) = TR1+CC(IDO,K,1)                                          
         CH(IDO,3,K) = CC(IDO,K,1)-TR1                                          
         CH(1,2,K) = TI1-CC(IDO,K,3)                                            
         CH(1,4,K) = TI1+CC(IDO,K,3)                                            
  106 CONTINUE                                                                  
  107 RETURN                                                                    
      END                   

C      PROGRAM STAR
C		Copyright IBM Corporation 1989
C
C                      All Rights Reserved
C
C Permission to use, copy, modify, and distribute this software and its
C documentation for any purpose and without fee is hereby granted,
C provided that the above copyright notice appear in all copies and that
C both that copyright notice and this permission notice appear in
C supporting documentation, and that the name of IBM not be
C used in advertising or publicity pertaining to distribution of the
C software without specific, written prior permission.
C
C IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
C ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
C IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
C ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
C WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
C ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
C SOFTWARE.
C
C
C      DESCRIPTION:
C       This program draws a yellow star on a blue background and writes
C       the title 'Star' in green in under the star.
C      CONFORMANCE:
C       GKS level: ma
C       FORTRAN-77 binding with FORTRAN-77 Subset comments.
C       At least one output or outin workstation.
C
C      Define GKS constants.
C
       INTEGER GSOLID
       PARAMETER ( GSOLID = 1 )
       INTEGER GACENT,GAHALF
       PARAMETER ( GACENT = 2, GAHALF = 3 )
C
C      Implementation dependent constants.
C
       INTEGER ERROUT,TTOUT,WSTYPE,NBYTES
       PARAMETER ( ERROUT = 1, TTOUT = 5, WSTYPE = 4, NBYTES = -1 )
C
C      Define coordinates for drawing the star.
C   
       REAL STARX( 5 ),STARY( 5 )
       DATA STARX / 0.951057, -0.951057, 0.587785, 0.0, -0.587785 /
       DATA STARY / 0.309017, 0.309017, -0.951057, 1.0, -0.951057 /
C
C      Perform implementation dependent initialization
C
CC     OPEN ( TTOUT,STATUS='NEW' )
C      Open GKS and activate a workstation.
C
       CALL GOPKS ( ERROUT,NBYTES )
       CALL GOPWK ( 1,TTOUT,WSTYPE )
       CALL GACWK ( 1 )
C
C      Center the window around the origin.
C
       CALL GSWN ( 1,-1.25,1.25,-1.25,1.25 )
       CALL GSELNT ( 1 )
C
C      Define the colors we'll be using
C
       CALL GSCR ( 1,0,0.0,0.0,1.0 )
       CALL GSCR ( 1,1,1.0,1.0,0.0 )
       CALL GSCR ( 1,2,1.0,1.0,1.0 )
C
C      Fill the star with solid yellow.
C
       CALL GSFAIS ( GSOLID )
       CALL GSFACI ( 1 )
C
C      Draw the star.
C
       CALL GFA ( 5,STARX,STARY )
C
C      Select large characters centered under the star.
C
       CALL GSCHH ( 0.15 )
       CALL GSTXAL ( GACENT,GAHALF )
       CALL GSTXCI ( 2 )
C
C      Draw the title.
C
       CALL GTX ( 0.0,-1.1,'Star' )
C
C      FORTRAN 77 subset version.
C      CALL GTXS ( 0.0,-1.1,4,'Star' )

C
C      Wait for break
C
       PRINT *, 'Done.  Enter BREAK in window...'
       CALL BWAIT(1)

C
C      Close the workstation and shutdown GKS.
C 
       CALL GDAWK ( 1 )
       CALL GCLWK ( 1 )
       CALL GCLKS
       STOP
       END


       SUBROUTINE BWAIT(IWK)
       CHARACTER*80	RECORD
       CALL GINCH(IWK, 1, 0, 1, 0.0, 1279.0, 0.0, 1023.0, 1, RECORD)
       CALL GSCHM(IWK, 1, 0, 1)
10     CALL GRQCH(IWK, 1, ISTAT, ICHNR)
       IF (ISTAT .NE. 0) GOTO 10
       END

	INTEGER FUNCTION DO_SUM_DSG ( idim, arg, dset, nfeatures, maxobs,
     .				      com, com_mr, com_cx,
     .				      res, res_mr, res_cx,
     .				      counts	)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* find the SUM of value of the component grid along the obs or instance 
* axis of a DSG axis

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - SDIG
* 2/2019 from DO_MAX_DSG
* V76   1/20 *acm* Orientation of Point-type data set to e_dim

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include	'xprog_state.cmn'
	include 'xdyn_linemem.cmn_text'
	include 'xdset_info.cmn_text'
	include 'xdsg_context.cmn'

* calling argument declarations:
	INTEGER	idim, com_mr, com_cx, res_mr, res_cx, dset, nfeatures,
     .		maxobs
	REAL	arg, 
     .          com   (*),
     .          res   (*),  ! E=@AVE will have -999:-999
     .          counts(*)

* internal variable declarations:
	LOGICAL fmask(nfeatures), omask(maxobs)
	INTEGER ok, i, ifeature, iobs, flen, base, orientation, row_size_lm
	REAL	bad_res, bad_com, val

* internal parameter declaration
	REAL		too_small
	PARAMETER     ( too_small = -1.E33 )

* initialize
	orientation = dsg_orientation(dset)

	IF (dsg_row_size_var(dset) .GT. 0) row_size_lm = dsg_loaded_lm(dsg_row_size_var(dset))
	bad_res = mr_bad_data( res_mr )
	bad_com = mr_bad_data( com_mr )

* get feature mask
        CALL MAKE_DSG_FEATURE_MASK(dset, com_cx, fmask, nfeatures)


* ****** PERFORM THE COMPUTATION *****
	IF (idim.EQ.orientation .AND. orientation.LE.t_dim) THEN 
* *** true ragged array processing:
* compress each feature into a single value 
           base = 0    ! obs index at end of preceding feature
* ... loop over the features
	   DO ifeature = 1, nfeatures 

	      counts(ifeature) = 0.
	      res(ifeature) = 0.

	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length

* ... have the user's WW constraints removed this feature?
	      IF (.NOT.fmask(ifeature)) THEN
                 base = base + flen
                 CYCLE
              ENDIF

* ... get observation-level mask for this feature
	      CALL MAKE_DSG_OBS_MASK(dset, com_cx, ifeature, base,
     .				     omask, flen)
	
* ... loop over the observations within each feature
              iobs = base
	      DO i = 1, flen
	         iobs = iobs + 1   ! index in the contig ragged array

	         IF (.NOT.omask(i)) CYCLE

* ... the input data value
                 val = com(iobs)

	         IF ( val .EQ. bad_com ) CYCLE
	         counts(ifeature) = counts(ifeature) + 1.
	         res(ifeature) = res(ifeature) + val
              ENDDO

	      base = base + flen

           ENDDO

	ELSE

* *** a simple list of instances:
* compress along the instance (feature) axis resulting in just a single value
	   res(1) = 0      ! initialize sum
	   counts(1) = 0   ! number of valid component values found
	   DO ifeature = 1, nfeatures 

* ... have the user's WW constraints removed this feature?
	      IF (.NOT.fmask(ifeature)) CYCLE

	      IF ( com(ifeature) .EQ. bad_com ) CYCLE
	      counts(1) = counts(ifeature) + 1.
	      res(1) = res(1) + com(ifeature)
           ENDDO

	ENDIF

	RETURN
	END

	SUBROUTINE TM_BREAK_LINES (instring,linestart,lineend,numlines)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* This subroutine will "break up" the variable instring into individual
* strings and place them in the character array outstrings. The breaks
* occur at the marker <NL>.  Return numlines, the number of lines found.
*
* based on tm_break_str.F
* V685+ 12/13    - *acm*  bounds checking: dont refer to parts of the string outside its bounds.
*
* Arguments
	INTEGER		numlines, linestart(*), lineend(*)
	CHARACTER*(*)	instring
       
*
        CHARACTER*4     newline, upstring
	INTEGER		STR_UPCASE, TM_LENSTR1,
     .                  icode, inlen, lincnt, nlin, i, nchar

* Initialize
	inlen  = TM_LENSTR1(instring)
	lincnt = 0
	nlin = 1
        numlines = 1
	linestart(numlines) = 1
	lineend(numlines) = inlen

* If the label ends in <NL> then ignore that.

        IF (inlen .GE. 4) THEN
           ICODE = str_upcase (newline, instring(inlen-3:inlen))  
           IF (newline .EQ. '<NL>') inlen = inlen-3
        ENDIF

* Locate next character

100	CONTINUE
        DO 200 i = nlin, inlen
	   nchar = i
	   GOTO 300
200	CONTINUE

* no characters left

	GOTO 9900

* locate the next <NL> (end of a line)

300	DO 400 i = nchar,inlen
	  IF (instring(i:i) .EQ. '<') THEN

* New line found?

           IF (i.LT.inlen-3) THEN
	      upstring = instring(i:i+3)
	   ELSE
	      upstring = instring(i:inlen)
	   ENDIF
	      
           icode = STR_UPCASE (newline, upstring)  
           IF (newline .EQ. '<NL>') THEN
	      nlin = i + 4
              GOTO 500
            ENDIF
	  ENDIF
400	CONTINUE

* more characters left

	nlin = inlen + 1

500	lincnt = lincnt + 1
	linestart(lincnt) = nchar
	lineend(lincnt) = max(nchar,nlin-5)
	IF (nlin .LE. inlen) GOTO 100

* if at end of string loop at 100 will catch it

        numlines = lincnt
        lineend(lincnt) = inlen 

9900	RETURN
	END

	SUBROUTINE TM_FRIENDLY_READ( prompt, buff, * )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* get a line of input allowing full gnu-readline line editing
* take abnormal return if eof is encountered

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for DECstation computer under Ultrix and VMS operating systems
*
* rev 0.0 -   5/9/91
*  Sun Port 1/30/92 -kob-  added ifdef sun because uses BYTE whereas
*  DECstation uses  INTEGER*1
* 1/94 *sh* increased max read buffer len (blen) from 256 to 512
* 4/01 *sh* increased blen again -- to 2048

* calling argument declarations:
        CHARACTER*(*) prompt, buff

#ifdef unix

* internal variable declarations:
! "blen" must exceed the longest read
        INTEGER plen, blen
        PARAMETER (plen = 8, blen = 2048 )

#ifdef sun
        BYTE      hprompt(plen), hbuff(blen)
#else
        INTEGER*1 hprompt(plen), hbuff(blen)
#endif

* translate to null-terminated c-type strings
        CALL TM_FTOC_STRNG( prompt, hprompt, plen )

* call c-written routine to get input line
        CALL TM_FTOC_READLINE( hprompt, hbuff )

* translate received input line to FORTRAN character array
        CALL TM_CTOF_STRNG( hbuff, buff, blen )

* null string returned means that EOF (^D) was entered
        IF ( hbuff(1) .EQ. 4 ) RETURN 1     ! ^D passed

#else
        STOP 'TM_FRIENDLY_READ isn't used by VMS'
#endif
	RETURN
	END

	SUBROUTINE INIT_U_AGGREGATE_DSET (memb_dsetname_var,
     .	   nsets, have_expr, dname, dpath, dtitle, agg_dset, 
     .     agg_quiet, agg_hide, agg_dim, status )
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* initialize a new ensemble (E) or forecast (F) aggregated dataset
* Aggregation member variables may be a blend of file variables and LET/D vars
* Since the user may alter LET/D definitions after the aggregation has been
* defined, the following approach is taken to processing:
*  1) during DEFINE DATA/AGG the grids of all member variables are determined
*     This means that IS_UVAR_GRID is called for LET/D vars.
*     These grid numbers are stored in the aggregation LIST structures
*     The grids of the variables in the aggregated (parent) dataset are also
*     determined and stored in ds_grid_number as if they are file variables.
*     These grids are "static" as with file variables -- always valid. 
*  2) (TBD as of this writing!!!)==> the use counts of *all* member grids are
*     bumped, so that they cannot be deleted, even if LET/D definitions change
*  3) (TBD as of this writing!!!)==> at get_grid time all of the components
*     of the aggregation are checked to
*     ensure they have a grid (IS_UVAR_GRID) -- allowing for last-minute
*     LET/D var changes
*  4) during evaluation (in IS_STRIP and IS_AGGREGATE_GATHER) the variable
*     name and member dataset number are used to make a fresh determination of
*     the variable category and grid.  Error out if grid number has changed

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - SDIG
*
* V7   5/12 *acm* Union aggregations: DEFINE DATA/AGG/U
* V7.2 5/17 *acm* Ticket 2526 For SHOW DATA/MEMBERS of Union datasets need to 
*                 have called NCF_ADD_AGG_MEMBERto list the dataset members in 
*                 the linked-list structure for the union dataset

* arguments:
*	memb_dsetname_var - if have_expr, the variable of names (input)
*	nsets		- number of datasets in the aggregation (input)
*       have_expr	- flag if filenames were listed or in an expr (input)
*	dname		- dataset name to assign to the aggregation (input)
*	dpath		- dataset path name to assign to aggregation (input)
*	dtitle		- dataset title (input)
*	dset_num	- number assigned to this data set (output)
*       agg_quiet       - flag whether to report certain conditions (input)
*	agg_hide        - flag whether to hide the component datasets (input)
*	agg_dim		- axis of the aggregation (is irrelevant)
*	status		- return status (output)

      IMPLICIT NONE
	include 'netcdf.inc'
        include 'tmap_errors.parm'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xdset_info.cd_equiv'
	include 'xunits.cmn_text'
        include 'xprog_state.cmn'
	include 'xtm_grid.cmn_text'  
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xfr_grid.cmn'

* calling argument declarations:
	CHARACTER*(*)	dname, dpath, dtitle
	INTEGER		nsets, agg_dset, agg_dim, status
	LOGICAL		have_expr, agg_quiet, agg_hide
	REAL		memb_dsetname_var(*)

* parameter definitions
	INTEGER	pmaxvarsperset
	PARAMETER (pmaxvarsperset = 400)

* local variable declarations:
	LOGICAL match, itsa_uvar
	INTEGER	TM_LENSTR1, STR_SAME, NCF_ADD_AGG_MEMBER,
     .		iset, dset1, item, ii, max_str_len,member_sets(nsets), 
     .		nv, nvars, iline, slen, jlen, un_vars(pmaxvarsperset),
     .		num_indices, j, member, ignored_status
	REAL	sset
	CHARACTER TM_STRING*13
	CHARACTER*512 GET_STRING_ELEMENT_1D_X, memb_dsetname(nsets)
	CHARACTER*48 TM_FMT, strset
	CHARACTER*128 vname

* initialize
	max_str_len = 512
	nsets = nsets
	DO iset = 1, nsets
	   member_sets(iset) = pdset_dummy
	ENDDO

* check to see if this new dataset name matches an already-open dataset name.
* if so, thats an error
	DO iset = 1, maxdsets
           match = ds_name(iset) .EQ. dname
           IF ( match ) GOTO 5100
	ENDDO

* set up array of dataset identifier strings
*   these may be string dataset numers or names,  pre-init'ed or not
	IF (have_expr) THEN
*  ... dataset list passed through a string variable
	  DO iset = 1, nsets
	    memb_dsetname(iset) = GET_STRING_ELEMENT_1D_X(
     .			nsets,
     .                  memb_dsetname_var,iset,
     .			max_str_len,slen )
	  ENDDO
	ELSE
*  ... dataset names given by user on command line
	  DO iset = 1, nsets
	    memb_dsetname(iset) = cmnd_buff(item_start(iset):item_end(iset))
	  ENDDO
	ENDIF

* See if requested datasets are open and if not, try to open them.
	CALL CHECK_MEMBER_SETS (agg_dim, nsets, memb_dsetname,
     .				member_sets, status)
	IF (status .NE. ferr_ok) GOTO 9950

* Assign aggregate data set number, exiting if maximum number 
* of data sets are open
	DO iset = 1,maxdsets
	  IF (ds_name(iset) .EQ. char_init2048) THEN
	    agg_dset = iset
	    GOTO 220
	  ENDIF
	ENDDO
* ... too many data sets are open
	CALL TM_ERRMSG ( merr_dsetlim, status, 'INIT_U_AGGREGATE_DSET',
     .			 no_descfile, no_stepfile,
     .			 'MAX='//TM_STRING(DBLE(maxdsets)),
     .			 no_errstring, *9950)
 220	CONTINUE

* Create datset. Will delete it later if there are no aggregate variables found
* Note: the pattern will the first dataset given.  They may get reordered.
	iline = unspecified_int4
	agg_dim = unspecified_int4
	CALL CREATE_AGG_DSET (agg_dset, dname, dpath, dtitle,
     .			 nsets, member_sets(1), agg_dim, iline, status)  
	IF (status .NE. ferr_ok) GOTO 5300

* 1st member dset sets pattern for all to follow
	dset1 = member_sets(1)


*****
* find variables from the first dataset and register them in the aggregation.

	iset = dset1

	nvars = 0
!	DO nv = 1, max_uvar      ! brute-force equivalent loop
	CALL deleted_list_get_undel(uvar_num_items_head,
     .                              deleted_list_result(1),
     .                              max_uvar, num_indices )
	DO j = 1, num_indices
	   nv = deleted_list_result(j)
	   IF (uvar_dset(nv) .EQ. dset1) THEN
	      nvars = nvars + 1
	      un_vars(nvars) = nv
	      vname = uvar_name_code(nv)
	      itsa_uvar = .TRUE.
	      CALL DEFINE_U_AGGREGATE_VAR (agg_dset, iset, nvars, 
     .           vname, nv, itsa_uvar, nsets, status)
              IF (status .NE. ferr_ok) GOTO 5300
	   ENDIF
	ENDDO

* now find the file variables
        DO nv = 1, maxvars
	   IF (ds_var_setnum(nv) .EQ. dset1) THEN
* ... skip it if it duplicates a name already found as a LET/D variable
	      DO ii = 1, nvars
	         IF (STR_SAME(ds_var_code(un_vars(ii)),
     .			      ds_var_code(nv)           ) .EQ. 0) GOTO 300
	      ENDDO
	      nvars = nvars + 1
	      un_vars(nvars) = nv
	      vname = ds_var_code(nv)
	      itsa_uvar = .FALSE.
	      CALL DEFINE_U_AGGREGATE_VAR (agg_dset, iset, nvars, vname, nv, 
     .         itsa_uvar, nsets, status)
           IF (status .NE. ferr_ok) GOTO 5300
	   ENDIF
 300	   CONTINUE
	ENDDO
*****

* If no variables from the dataset, delete this dataset. 
	IF (nvars .EQ. 0) GOTO 5500

* *** loop over the member datasets ***
	DO iset = 2, nsets
	   member = member_sets(iset)
	   IF (member .EQ. pdset_dummy) CYCLE ! ignore dummy (missing) dataset

*****
* find variables from the other member datasets. Add new ones to the aggregation.

	   CALL deleted_list_get_undel(uvar_num_items_head,
     .                              deleted_list_result(1),
     .                              max_uvar, num_indices )
	   DO j = 1, num_indices
	      nv = deleted_list_result(j)
	      IF (uvar_dset(nv) .EQ. member) THEN
	         nvars = nvars + 1
	         un_vars(nvars) = nv
	         vname = uvar_name_code(nv)
	         itsa_uvar = .TRUE.
	         CALL DEFINE_U_AGGREGATE_VAR (agg_dset, member, nvars, 
     .               vname, nv, itsa_uvar, nsets, status)
	         IF (status .NE. ferr_ok) GOTO 5300
	      ENDIF
	   ENDDO

* now file variables
	   DO nv = 1, maxvars
	      IF (ds_var_setnum(nv) .EQ. member) THEN
* ... skip it if it duplicates a name already found as a LET/D variable
*     Issue a note unless they said /QUIET

	         DO ii = 1, nvars
	            IF (STR_SAME(ds_var_code(un_vars(ii)),
     .			      ds_var_code(nv)           ) .EQ. 0) THEN
                       sset = member
		       slen = TM_LENSTR1(ds_var_code(nv))
		       strset = TM_FMT(sset, 10, 10, jlen)
		       
                       IF (.NOT.agg_quiet) CALL WARN ('Skipping variable '//
     .			ds_var_code(nv)(:slen)//
     .			' from set '//strset(:jlen) //
     .			', already in the Union dataset.')
		       GOTO 400
	            ENDIF
	         ENDDO
	         nvars = nvars + 1
	         un_vars(nvars) = nv
	         vname = ds_var_code(nv)
	         itsa_uvar = .FALSE.
	         CALL DEFINE_U_AGGREGATE_VAR (agg_dset, member, nvars, 
     .            vname, nv, itsa_uvar, nsets, status)
	         IF (status .NE. ferr_ok) GOTO 5300
	      ENDIF
 400	   CONTINUE
  	   ENDDO


	ENDDO  ! 2, nsets

	IF (nvars .EQ. 0) GOTO 5500


* register member datasets to aggregate dataset
	DO iset = 1, nsets
	   status = NCF_ADD_AGG_MEMBER (agg_dset, iset, member_sets(iset)) 
	ENDDO

* If user requested /HIDE, then mark the member datasets for hidden status
	IF (agg_hide) THEN
 	   DO iset = 1, nsets
	      ds_hide (member_sets(iset)) = .TRUE. 
	   ENDDO
	ENDIF

* successful completion
	RETURN

* error bail out
* remove all hidden member datasets of the failed aggregation
* ... this is a little brute force in that it may cancel a previously opened
* ... dataset included using DEFINE DATA/AGG/HIDE (havnt checked carefully)
 5000	DO ii = 1, nsets
	   iset = member_sets(ii)
	   IF (iset .EQ. pdset_dummy
     .    .OR. iset .EQ. unspecified_int4) CYCLE
	   IF (ds_name(iset) .EQ. char_init2048) CYCLE ! already deleted
	   IF (ds_hide (iset)) CALL CANCEL_ONE_DATA_SET( iset, ignored_status )
	ENDDO
 6000	RETURN	

* Errors: too-many datasets open so aggregate dataset can't be opened,
* or error on a member dataset. 
* ?? If some member datasets were opened, close them??)
* Return no-dataset-number.

 9950	agg_dset = unspecified_int4
	status = ferr_TMAP_error
	GOTO 5000
* wipe out the partially-created aggregated dataset
 9960	CALL TM_PURGE_TMP_GRIDS(ignored_status)
	CALL TM_CLOSE_SET_COND_DEALLO( agg_dset, .FALSE., ignored_status )
	agg_dset = unspecified_int4
	GOTO 5000

 5100   CALL ERRMSG( ferr_invalid_command,status,
     .		'dataset name already in use: '
     .		//dname(:TM_LENSTR1(dname)), *5000 )
     
 5300	CALL ERRMSG( ferr_aggregate_error, status, ' ', *9950 )

 5500	CALL ERRMSG( ferr_aggregate_error, status,
     .		'No valid datasets ', 
     .		*9960 )

	END

	SUBROUTINE CS_SET_CONTEXT

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* transfer the information indicated in the current control stack level into
* the default ("LAST") context

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* revision 0.0 - 5/1/87
* V200:  6/15/89 - reordered lo/hi_ss args
* 9/97 *kob* - need to reset cx_calendar to false if cx_lo/hi_ww are
*              not used
* 12/97 *kob* - and set  cx_calendar to true if they are used....
* *acm* v580 11/04 Introducing cx_cal_id, saves the calendar ID used 
*                  when computing world coordinates
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V695  *acm* 2/15 cx_calendar stores info about calendar formatting of T and F axes

        IMPLICIT NONE
* internal variable declarations:
	INTEGER	idim

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'
	include 'xcontrol.cmn'

* initialize
	idim = cs_axis( csp )

* set up by subscript or by world coordinates
	cx_by_ss( idim, cx_last ) = cs_by_ss( csp )

	IF ( cs_by_ss( csp ) ) THEN
	   cx_lo_ss( cx_last, idim ) = cs_phase( csp )
	   cx_hi_ss( cx_last, idim ) = cs_phase( csp )
	   cx_lo_ww( idim, cx_last ) = unspecified_val8
	   cx_hi_ww( idim, cx_last ) = unspecified_val8
* kob 9/97 - need to reset cx_calendar as well
	   IF (idim .eq. t_dim .OR. idim .eq. f_dim) THEN
              cx_calendar(idim,cx_last) = .FALSE.
              cx_cal_id(cx_last) = unspecified_int4
           ENDIF
	ELSE
* kob 12/97 - i need to set cx_calendar to true here
 	   cx_lo_ss( cx_last, idim ) = unspecified_int4
	   cx_hi_ss( cx_last, idim ) = unspecified_int4
	   cx_lo_ww( idim, cx_last ) = cs_phase( csp )
	   cx_hi_ww( idim, cx_last ) = cs_phase( csp )
	   IF (idim .eq. t_dim) THEN
              cx_calendar(idim,cx_last) = cs_is_calendar_t(csp)
              cx_cal_id ( cx_last) = cs_cal_id(csp)
           ENDIF
	   IF (idim .eq. f_dim) THEN
              cx_calendar(idim,cx_last) = cs_is_calendar_f(csp)
              cx_cal_id ( cx_last) = cs_cal_id(csp)
           ENDIF
	ENDIF
	   
	RETURN
	END

	SUBROUTINE MAKE_STEP_AXIS( grid, idim, inc, lo_ss, hi_ss, axis )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* create a REAL*4 array of world coordinates over a range of subscripts along
* axis IDIM of grid GRID.  Begin the axis at subscript 1 of AXIS.
* If argument "inc" is 2 then output lo/hi limits for each point
* If "inc" is 3 then do lo/hi limits and duplicate upper limit

* programmer - steve hankin
* V530 *sh* 1/01 
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
* V698  *acm* 5/16 Ticket 1845, 2404 fix; adjusting plot-axis ends for subspan 
*		   modulo axes.

        IMPLICIT NONE
	include 'ferret.parm'
	include 'tmap_dims.parm'
        include 'xtm_grid.cmn_text'

* calling argument declarations:
	INTEGER	grid, idim, inc, lo_ss, hi_ss
	REAL    axis(*)

* internal variable declarations:
	LOGICAL TM_ITS_SUBSPAN_MODULO, is_subspan, void_at_start, void_at_end
	INTEGER	ito, i, iaxis
	REAL*8	TM_WORLD

	ito = 0
	iaxis = grid_line(idim,grid) 
	
        is_subspan = TM_ITS_SUBSPAN_MODULO( iaxis  )
        void_at_start = is_subspan .AND. (lo_ss.EQ.0)
        void_at_end  = is_subspan .AND. (hi_ss.EQ.line_dim(iaxis)+1 )

	IF (inc .EQ. 1) THEN
* make a simple axis - 1 output point per axis point
	   DO i = lo_ss, hi_ss
	      ito = ito + 1
	      axis(ito) = TM_WORLD( i, grid, idim, box_middle )
	   END DO
	   IF (is_subspan) THEN
	      IF (void_at_start) axis(1) = TM_WORLD( lo_ss, grid, idim, box_hi_lim )
	      IF (void_at_end) axis(ito) = TM_WORLD( hi_ss, grid, idim, box_lo_lim )
	   ENDIF

	ELSEIF (inc .EQ. 2) THEN
* make a 2-point "step" axis - output lo and hi points at each axis point
	   DO i = lo_ss, hi_ss
	      axis(ito+1) = TM_WORLD( i, grid, idim, box_lo_lim )
	      axis(ito+2) = TM_WORLD( i, grid, idim, box_hi_lim )
	      ito = ito + 2
	   END DO
	   IF (is_subspan) THEN
	      IF (void_at_start) axis(1) = TM_WORLD( lo_ss, grid, idim, box_hi_lim )
	      IF (void_at_end) axis(ito) = TM_WORLD( hi_ss, grid, idim, box_lo_lim )
	   ENDIF
	ELSE
* make a 3-point "step" axis - lo then hi twice
	   DO i = lo_ss, hi_ss
	      axis(ito+1) = TM_WORLD( i, grid, idim, box_lo_lim )
	      axis(ito+2) = TM_WORLD( i, grid, idim, box_hi_lim )
	      axis(ito+3) = axis(ito+2)
	      ito = ito + 3
	   END DO
	   IF (is_subspan) THEN
	      IF (void_at_start) axis(1) = TM_WORLD( lo_ss, grid, idim, box_hi_lim )
	      IF (void_at_end) axis(ito) = TM_WORLD( hi_ss, grid, idim, box_lo_lim )
	      IF (void_at_end) axis(ito-1) = axis(ito+hi_ss*3)
	   ENDIF
	ENDIF

	RETURN
	END

	SUBROUTINE MC_READ ( dset, ivar,
     .			a_lo_x, a_lo_y, a_lo_z, a_lo_t, a_lo_e, a_lo_f,
     .			a_hi_x, a_hi_y, a_hi_z, a_hi_t, a_hi_e, a_hi_f,
     .			use_lo, use_hi, stride,
     .			var, sf_num, status )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Reads a 4D block of data (lower D being a degenerate case with dimensions
* being 1 point thick) from a multi-file netCDF dataset
*
* written 8/95 by kob for pmel/tmap
* 11/96 *kob* - Linux Port
* 	      - replace end_read_tstep with a_hi_t as a clue for tm_subsc
* 7/97 *kob* - fix bug in which status is not being checked
* 5/98 *kob* - fix bug in which step files were not being properly reset after 
*              they were closed
* V500 5/99 *kob* - 1) fixed bug occurring when correctly setting up variable
*	               in common
*                   2) minor mod to only open set entire path of cdf file if it
*                      hasn't already been opened
*           *sh* - added strides to CD_READ call
* V510 *sh* 3/00 - increase allowable path name length
* v522 *kob* 12/00 - added xprog_state common file in order to check for
*                    mode diagnostic.  only do sanity checking on step
*                    files if mode diag is turned on.
* v531: *kob* 5/01 - fix erroneous error reporting at label 5100
* V552 5/03 *acm*: increase size of vname to 128 chars
* V570 4/04 *acm* when checking which stepfile to read from, use
*                 TM_FPEQ_TOL to see if the timestep is equal (within tolerance)
*                 to the start or end point of any of the files.
* V580 9/04 *acm* - Fix bug 982 If same variable name in multiple descriptor files, 
*                   mc_init_stepfile needs to know which file its from.
* V580 10/04*acm* - Get values for scale and offset attributes in each individual 
*                   step file.  Values returned by RETURN=nc_offset or RETURN=nc_scale 
*                   will return the last value used.
* v581 *acm* 4/2005  Add sf_ndxs and sf_ndxe to use indices rather than timesteps
*                     for indexing mc datasets in mc_read.
* v581 *acm* 7/2005  Fix bug in getting start and end indices.
* V600 *acm* 8/2005  fix bug 1332, calls to  CD_GET_ATTVAL and  CD_GET_ATTVAL
*                    need cd_varid(ivar) not cd_varid as the second argument.
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing
* V71  *acm* 1/17 Ticket 2493 The E and F dimensions are "outside" of T and so 
*                 just passing a start location into CD_READ to read in each file's 
*                 of data gave incorrect results.

* include files
        include 'netcdf.inc'
        include 'tmap_errors.parm'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'                ! data set dimension
#include "gt_lib.parm"
        include 'xdset_info.cmn_text'   ! data set info common
        external xdset_info_data
        include 'xstep_files.cmn_text'  ! step file common
        external xstep_files_data
        include 'xdset_info.cd_equiv'
        include 'xtm_grid.cmn_text'
        include 'xprog_state.cmn'
#ifdef sun
        include 'xmachine_byte.cmn'
#else
        include 'xmachine_int1.cmn'
#endif
        include 'xsys_names.cmn_text'


* arguments:
*	dset        - internal data set # (from GT_INIT_DSET)
*	ivar        - position in common of variable information
*       actual_dims - "a_" full dimensions of data_grid array passed
*	use_lo      - low indices of model data block desired
*	use_hi      - high indices of model data block desired
*	var         - array containing model data (output)
*	sf_num      - stepfile number (returned from GT_FIND_TSTEP (output)
*	status      - error status upon completion (output)
*
	INTEGER		dset, ivar, sf_num, status, ndim,
     .			a_lo_x, a_lo_y, a_lo_z, a_lo_t, a_lo_e, a_lo_f,
     .			a_hi_x, a_hi_y, a_hi_z, a_hi_t, a_hi_e, a_hi_f,
     .			use_lo(nferdims), use_hi(nferdims), stride(nferdims)
	REAL		var(a_lo_x:a_hi_x,
     .                      a_lo_y:a_hi_y,
     .                      a_lo_z:a_hi_z,
     .                      a_lo_t:a_hi_t,
     .                      a_lo_e:a_hi_e,
     .                      a_lo_f:a_hi_f)

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

* local definitions
	INTEGER*4 tmp_lo(nferdims), tmp_hi(nferdims), 
     .            start_read_lstep,end_read_lstep,
     .            idim,sfcnt,nsteps_to_read,
     .            grid, cdfstat, cdfid, l_sf1,offset,
     .            hi_offset,a_lo_t_offset,
     .            a_hi_t_offset, vartype, nvdims,vdims(8),nvatts,
     .		  varid, varpos,ndims,nvars, natts, recdim,
     .            npts, var_id,index, nsteps_in_file, vlen, end_lstep,
     .            line, m, n
	REAL*8	  TM_WORLD,start_tstep, end_tstep, start_read_tstep,
     .            end_read_tstep, epsilon
	INTEGER   TM_SUBSC, TM_LENSTR1, prev_steps
	LOGICAL   more_to_read, TM_FPEQ, TM_DFPEQ_TOL, CD_GET_ATTVAL, 
     .            got_scale, got_off, do_warn
        PARAMETER (do_warn = .TRUE. )
        CHARACTER*2048   TM_INQ_PATH, tstep_file
	CHARACTER*128 vname
	CHARACTER*64 dim_name
	INTEGER*4 STR_CASE_BLIND_COMPARE
	REAL*8 r8buff
	CHARACTER*13    TM_STRING

        epsilon = 4.E-15   ! for TM_DFPEQ_TOL

	start_tstep = TM_WORLD(a_lo_t,ds_grid_number(ivar),4,box_middle)
	end_tstep   = TM_WORLD(a_hi_t,ds_grid_number(ivar),4,box_middle)
	start_read_lstep = a_lo_t
        end_lstep = a_hi_t
	start_read_tstep = start_tstep
	do 10 idim=1, nferdims
		tmp_lo(idim) = use_lo(idim)
		tmp_hi(idim) = use_hi(idim)
 10	continue

	IF (grid_line(t_dim, ds_grid_number(ivar)) .EQ. mpsnorm) THEN
* let's open the netcdf file now
*first make sure we have the full path set
          tstep_file = TM_INQ_PATH( sf_name(mc_init_stepfile(dset)), 
     .                          tmap_tsteps, ' ',
     .                          .TRUE., status )
           IF ( status .NE. merr_ok ) GOTO 5000
           sf_name(mc_init_stepfile(dset)) = tstep_file     ! save exact path
*got the full path, let's open the file now
#ifdef usingDODSf2cUnderscore
	   cdfstat = NF_OPEN_(sf_name(mc_init_stepfile(dset)), 
     .                 NF_NOWRITE, cdfid)
#else
	   cdfstat = NF_OPEN(sf_name(mc_init_stepfile(dset)), 
     .                 NF_NOWRITE, cdfid)
#endif

	   IF (cdfstat .NE. NF_NOERR) GOTO 5100
	   sf_lunit(mc_init_stepfile(dset)) = cdfid

#ifdef usingDODSf2cUnderscore
	   cdfstat = NF_INQ_VAR_(cdfid, cd_varid(ivar), vname, vartype, 
     .          nvdims, vdims, nvatts)
#else
	   cdfstat = NF_INQ_VAR(cdfid, cd_varid(ivar), vname, vartype, 
     .          nvdims, vdims, nvatts)
#endif

           vlen = TM_LENSTR1(vname)

           got_scale = CD_GET_ATTVAL(cdfid,cd_varid(ivar),'scale_factor',
     .             do_warn,vname(:vlen),cd_scale_factor(ivar),1,status )
           got_off = CD_GET_ATTVAL( cdfid, cd_varid(ivar), 'add_offset',
     .             do_warn,vname(:vlen),cd_add_offset(ivar),1,status )

*read the data
	   CALL CD_READ( dset, ivar,
     .		a_lo_x, a_lo_y, a_lo_z, a_lo_t, a_lo_e, a_lo_f,
     .		a_hi_x, a_hi_y, a_hi_z, a_hi_t, a_hi_e, a_hi_f,
     .		use_lo, use_hi, stride,
     .		var(a_lo_x, a_lo_y, a_lo_z,
     .		a_lo_t, a_hi_e, a_hi_f),
     .		mc_init_stepfile(dset), status)

* 7/97 - *kob* error check as in tm_choose_read.F
	   if (status .NE. merr_ok) GOTO 5000

*close the netcdf file
	   CALL CD_CLOSE_SET( cdfid, status)
* 7/97 - *kob* error check as in tm_choose_read.F
	   if (status .NE. merr_ok) GOTO 5000
*5/98 - *kob* sf_lunit needs to reflect the above cdf close
*12/00- *kob* bug - use mc_init_stepfile not sfcnt - latter not set yet
	   sf_lunit(mc_init_stepfile(dset)) = file_not_open

	ELSE
* find correct file
           prev_steps = 0
! extremely inefficient loop: should use List structure to link stepfiles
 20	   DO 30 sfcnt = 1,maxstepfiles
	      IF (sf_setnum(sfcnt) .NE. dset) GOTO 30 ! right dataset?

c	      IF ((sf_1step(sfcnt).GT. start_read_tstep) .OR. ! contains timestep
c     .		   (sf_lastep(sfcnt) .LT. start_read_tstep)) GOTO 30

! compare indices -- contains timestep
	      IF ((sf_ndxs(sfcnt).LE. start_read_lstep) .AND. ! contains timestep
     .		   (sf_ndxe(sfcnt) .GE. start_read_lstep)) GOTO 40


 30	   CONTINUE
*       found it
	   
 40	   grid = ds_grid_number(ivar)
	   end_read_tstep = MIN(sf_lastep(sfcnt), end_tstep)
	   end_read_lstep = TM_SUBSC (end_read_tstep, grid, t_dim,
     .		a_hi_t)     !kob 11/96
	   
* correct indices, when there are multiple timesteps in sttepfiles/
           end_read_lstep = MIN(end_read_lstep, sf_ndxe(sfcnt) ) 
           end_read_lstep = MAX(start_read_lstep, end_read_lstep ) 

	   nsteps_to_read = end_read_lstep - start_read_lstep + 1
	   
* determine the index within the file to start at
c!c! uncomment this...
        grid = ds_grid_number(ivar)
	l_sf1 = TM_SUBSC (sf_1step(sfcnt), grid, t_dim,l_sf1)

* let's open the netcdf file now
*first make sure we have the full path set
* 5/99 *kob* only need to do this if the file hasn't already been opened
	   IF (.NOT. sf_valid(sfcnt)) THEN
	      tstep_file = TM_INQ_PATH( sf_name(sfcnt), tmap_tsteps, ' ',
     .                          .TRUE., status )
	      IF ( status .NE. merr_ok ) GOTO 5000
	      sf_name(sfcnt) = tstep_file ! save exact path
	   ENDIF

#ifdef usingDODSf2cUnderscore
	   cdfstat = NF_OPEN_(sf_name(sfcnt), NF_NOWRITE, cdfid) 
#else
	   cdfstat = NF_OPEN(sf_name(sfcnt), NF_NOWRITE, cdfid) 
#endif

	   IF (cdfstat .NE. NF_NOERR) GOTO 5100
	   sf_lunit(sfcnt) = cdfid

* Verify that this is the correct variable, and if not, set it correctly
* in common..
* 2/2007 Check for success of this NF_INQ_VAR call - if the previous cd_varid
*        saved from earlier file does not exist in this stepfile, then 
*        we want to go check the other vars in the file 

#ifdef usingDODSf2cUnderscore
	   cdfstat = NF_INQ_VAR_(cdfid, cd_varid(ivar), vname, vartype, 
     .		nvdims, vdims, nvatts)
#else
	   cdfstat = NF_INQ_VAR (cdfid, cd_varid(ivar), vname, vartype, 
     .		nvdims, vdims, nvatts)
#endif
	   IF ( (cdfstat .NE. NF_NOERR) .OR. 
     .          (STR_CASE_BLIND_COMPARE ( ds_var_code(ivar), vname) 
     .		  .NE. str_match) ) THEN
#ifdef usingDODSf2cUnderscore
	      cdfstat = NF_INQ_(cdfid, ndims, nvars, natts, recdim)
#else
	      cdfstat = NF_INQ(cdfid, ndims, nvars, natts, recdim)
#endif
	      do 50 varpos=1,nvars
* 5/99 - fix bug which was sending cd_varid(varps) to NF_INQ_VAR instead of varpos
#ifdef usingDODSf2cUnderscore
		 cdfstat = NF_INQ_VAR_(cdfid, varpos, vname, vartype, 
     .		      nvdims, vdims, nvatts)
#else
		 cdfstat = NF_INQ_VAR (cdfid, varpos, vname, vartype, 
     .		      nvdims, vdims, nvatts)
#endif
*5/99 - bug fix: need to test to see if sting is EQUAL rather than not equal *kob*
		 IF (STR_CASE_BLIND_COMPARE ( ds_var_code(ivar), 
     .		      vname) .EQ. str_match)	THEN
		    cd_varid(ivar) = varpos
		    goto 60 
		 ENDIF
 50	      CONTINUE
	   ENDIF	
 
 60	   offset = sf_ndxs(sfcnt) - prev_steps - 1
	   nsteps_in_file = sf_ndxe(sfcnt) - sf_ndxs(sfcnt) + 1 

*calculate offset used to read data into array, if neccessary
	   a_lo_t_offset = start_read_lstep - offset
	   a_hi_t_offset = end_read_lstep - offset

* 12/00 *kob* do no sanity checking unless mode diagnostic is turned
*             on.  This necessary for dods hdf-->nc translated files
	   IF (.NOT. mode_diagnostic) THEN
	      sf_valid(sfcnt) = .TRUE.
*       now verify the timestep value in the netcdf file
*       Note this will report errors for time aggregations that have different time origins
	   ELSE
	      IF (.NOT. sf_valid(sfcnt)) THEN
* Get the T dimension and look up its attributes

		 line = grid_line(t_dim, grid)
		 dim_name = line_name_orig(line)
		 vlen = TM_LENSTR1(dim_name)

#ifdef usingDODSf2cUnderscore
		 cdfstat = NF_INQ_VARID_(cdfid, dim_name(:vlen), var_id)
* *kob* had to add an ncvinq to find out variable type of dimension because
*		 NF_FLOAT dimensions were causing core dumps. 
		 cdfstat = NF_INQ_VAR_(cdfid, var_id, dim_name, vartype, nvdims, 
     .      	      vdims,nvatts)
#else
		 cdfstat = NF_INQ_VARID (cdfid, dim_name(:vlen), var_id)
* *kob* had to add an ncvinq to find out variable type of dimension because
*		 NF_FLOAT dimensions were causing core dumps. 
		 cdfstat = NF_INQ_VAR (cdfid, var_id, dim_name, vartype, nvdims, 
     .      	      vdims,nvatts)
#endif
		 CALL CD_RD_R8_1(cdfid,var_id,a_lo_t_offset,vartype,'Error',
     .      	      r8buff,status)
		 IF ( status .NE. merr_ok) GOTO 5000
		 
		 IF ( vartype .EQ. NF_DOUBLE) THEN
#ifdef usingDODSf2cUnderscore
		    cdfstat = NF_GET_VAR1_DOUBLE_(cdfid, var_id,
     .      	      a_lo_t_offset,r8buff)
#else
		    cdfstat = NF_GET_VAR1_DOUBLE(cdfid, var_id,
     .      	      a_lo_t_offset,r8buff)
#endif
		 ELSE
		 ENDIF
*       if an error is found, announce to user but continue on	
#ifdef double_p
		 IF (.NOT. TM_FPEQ((r8buff), 
     .                        (start_read_tstep))) THEN
#else
		 IF (.NOT. TM_FPEQ(SNGL(r8buff), 
     .                        SNGL(start_read_tstep))) THEN
#endif
		    CALL TM_ERRMSG (merr_stpmtch, status, 'MC_READ (ignore for TSERIES aggregation)',
     .           	 sf_setnum(sfcnt), sfcnt,
     .  		 TM_STRING(start_read_tstep), TM_STRING(r8buff),*70)
*Now check to make sure that the number of files in this stepfile pulled 
*from the descriptor agree with the number of points on the time axis
		 ELSE IF ( npts .NE. nsteps_in_file) THEN
		    sf_valid(sfcnt) = .FALSE.
		 ELSE
		    sf_valid(sfcnt) = .TRUE.
		 ENDIF
	      ENDIF
	   ENDIF
* determine local start and end indices
 70	   tmp_lo(4) = start_read_lstep -offset
	   tmp_hi(4) = tmp_lo(4) + (end_read_lstep - start_read_lstep)

* determine local scale and offset
           vlen = TM_LENSTR1(vname)

           got_scale = CD_GET_ATTVAL( cdfid, cd_varid(ivar), 'scale_factor',
     .             do_warn,vname(:vlen),cd_scale_factor(ivar),1,status )
           got_off = CD_GET_ATTVAL( cdfid, cd_varid(ivar), 'add_offset',
     .             do_warn,vname(:vlen),cd_add_offset(ivar),1,status )

           cd_scaled(ivar) = got_scale .OR. got_scale

* let's read the data (finally). 

* (Ticket 2493) The E and F dimensions are "outside" of T and so must be read 
* sequentially if we are going to call CD_READ to do this. (Is there a more 
* efficient solution?)

	   DO n = a_lo_f, a_hi_f
	      tmp_lo(6) = n
	      tmp_hi(6) = n
	      DO m = a_lo_e, a_hi_e
	         tmp_lo(5) = m
	         tmp_hi(5) = m
	         CALL CD_READ( dset, ivar,
     .		   a_lo_x, a_lo_y, a_lo_z, a_lo_t_offset, m, n, 
     .		   a_hi_x, a_hi_y, a_hi_z, a_hi_t_offset, m, n, 
     .	           tmp_lo, tmp_hi, stride,
     .	           var(a_lo_x, a_lo_y, a_lo_z,
     .	           a_lo_t+(start_read_lstep-use_lo(4)),
     .	           m, n),
     .		   sfcnt, status)
	      ENDDO
	   ENDDO
* 7/97 - *kob* error check as in tm_choose_read.F
	   if (status .NE. merr_ok) GOTO 5000
	  
*close the netcdf file
	   CALL CD_CLOSE_SET( cdfid, status)
* 7/97 - *kob* error check as in tm_choose_read.F
	   if (status .NE. merr_ok) GOTO 5000
*5/98 - *kob* sf_lunit needs to reflect the above cdf close
	   sf_lunit(sfcnt) = file_not_open

* Check to see if done reading
	   IF (end_read_lstep .LT. a_hi_t) THEN
	      start_read_lstep = end_read_lstep + 1
	      start_read_tstep = TM_WORLD(start_read_lstep,
     .        ds_grid_number(ivar),4,box_middle)
	      GOTO 20 
	   ENDIF
	   
	ENDIF
 200	RETURN

 5100  CALL TM_ERRMSG
     .     ( cdfstat+pcdferr, status, 'MC_READ', unspecified_int4,
     .     no_varid, no_errstring,
     .     no_errstring, *5000 )


 5000	RETURN


	END

	SUBROUTINE GET_SHORT_DSET_NAME( dset, name, len_text )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* get the name, only - not the full path) of the given data set
* if that is meaningful
* else get a string describing the nature of the name 

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* Unix/RISC port 5/2/91 *sh*: based on GET_DSET_NAME
* Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
* V510: *sh* 3/00 - IRI Web server trap - if "dods" is the dset name then
*		give long version 
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'ferret.parm'

* calling argument declarations:
	INTEGER		dset, len_text
	CHARACTER*(*)	name

* internal variable declarations:
	INTEGER		TM_LENSTR1, max_len_out, i1, slash

* internal parameter declarations
	INTEGER arb_outmax
	PARAMETER (arb_outmax = 40)	! limit DODS output len

* initialize
	max_len_out  = LEN( name )

* consider the options
	IF     ( dset .EQ. pdset_irrelevant	)	THEN	! no name
	   name  = 'N/A'
	   len_text = 3

	ELSE
	   len_text = TM_LENSTR1( ds_name( dset ) )
           IF ( len_text .GT. max_len_out ) THEN
* ... too long to fit
              name = ds_name(dset)(len_text-max_len_out+1:)
              len_text = max_len_out
	   ELSEIF ( ds_name(dset) .EQ. 'dods'
     .	    .AND.   ds_des_name(dset)(1:7) .EQ. 'http://' ) THEN
	      len_text = TM_LENSTR1(ds_des_name(dset))
* ... find start of IRI name as in "http://ip.address/directory/name/dods"
	      slash = INDEX(ds_des_name(dset)(8:),'/')
	      slash = 8 + slash + INDEX(ds_des_name(dset)(8+slash:),'/')
	      IF (slash .GT. 0 ) THEN
	         i1 = slash + 1
	      ELSE
	         i1 = MAX(1,len_text-max_len_out+1)
	         i1 = MIN(i1,arb_outmax)
	      ENDIF
              name = ds_des_name(dset)(i1:len_text)
              len_text = len_text - i1 + 1
           ELSE
              name = ds_name( dset )
           ENDIF

	ENDIF

	RETURN
	END

	SUBROUTINE DTYPI(IN,OUT)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)dtypi.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
	INTEGER OUT
	character LIST(48)*2,inc*2
	DATA LIST/'WJ','WI','WA','WC','AJ','AI','TJ','TI',
     *	'AP','WB','DB','AS','AD','  ','AU','AV','TX','TY',
     *	'SL','AT','RS','SP','RD','WT','WU','WV','WP','TL','  ','  ',
     *	'SA','CO','ID','ST','XX','YY','MA','AA','AC','TA','TC','TD',
     *	'TR','AS','ZF','PF','HC','DH'/
	K=IN-11
	read(list(k),999)out
999	format(a2)
	RETURN
	ENTRY IDTYP(IN,OUT)
	write(inc,999)in
	DO 10 I=1,48
	IF(INc.EQ.LIST(I))GOTO 11
10	CONTINUE
	RETURN
11	OUT=I+11
	RETURN
	END

	SUBROUTINE PROCESS_X_EVENTS

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Update ATC GKS workstations if necessary.  First attempt to
*	determine if this works and is a bit heavy handed.

*	J Davison 4.29.92
*	Mod *jd* 5.26.92 to include -5399 escape function
*       Mod *jd* 3.7.94  to include xgks event handling, on Solaris.  Renamed
*	from atc_update to process_x_events

#ifdef unix
        include         'gkscm2.cmn'
#else
        INCLUDE         'tmap_pplv11inc:tmap_gkscm2.inc'
#endif

#ifdef atc_gks
	integer 	i,err,num_open,wsid,num
        integer 	ierr, ia(3), lidr, lodr
        real		ra(1)
        character*80 	str(1), datarec(1), odr(1)

#   ifdef unix
        include        'gkspar.inc'
#   else
        INCLUDE        'atc_gksdir:gkspar.inc'
#   endif

******************************************************************************

	if (.not. gks_open) goto 1000

	call gqopwk (0,err,num_open,wsid)
	if (err. ne. 0) goto 1000

	do 10 i = 1,num_open
	   call gqopwk (i,err,num,wsid)
	   if (err. ne. 0) goto 10

           ia(1) = wsid
           call gprec (1,ia,0,ra,0,0,str,80,ierr,lidr,datarec)
           call guesc (-5399,lidr,datarec,80,lodr,odr)
10	continue

1000	return

#endif

#ifdef xgks
	if (gks_open) call xgks_x_events
#endif

	end

	SUBROUTINE DRAWVEC (xtail,ytail,xhead,yhead,rlen,icntrl,xf,yf)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)drawvec.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
	
#ifdef unix
	INCLUDE 'AXIS.INC'
	INCLUDE 'AXLWID.INC'
	INCLUDE 'CMRD.INC'
	INCLUDE 'LABCOM.INC'
	INCLUDE 'TAXIS.INC'
#else
        INCLUDE 'pplinc:AXIS.INC'
        INCLUDE 'pplinc:AXLWID.INC'
        INCLUDE 'pplinc:CMRD.INC'
        INCLUDE 'pplinc:LABCOM.INC'
        INCLUDE 'pplinc:TAXIS.INC'
#endif
	
	REAL minvec,maxarw,minarw,maxvel
	
	CHARACTER veclab*20
	
C  headfact is ratio of arrowhead length to vector length
	PARAMETER (headfact = 0.25)
C  minvec is minimum plotted vector (point plotted otherwise)
	PARAMETER (minvec = .0625)
C maxarw is length of vector above which arrowhead is of fixed size
	PARAMETER (maxarw = 2.0)
C minarw is length of vector below which arrowhead is of fixed size
	PARAMETER (minarw = .0625)
C pi is the constant pi
	PARAMETER (pi = 3.141592654)
C arwang is angle between vector and arrowhead in radians
	PARAMETER (arwang = pi/8.)
	
	dist(dx,dy) = SQRT(dx**2 + dy**2)
	
C If ictrl = -1 initialize maxvec, if = 1 display maxvec
	
	IF (icntrl .eq. 1) THEN
	    maxvel = xtail
	    xtail = xlo
	    ytail = ylo - (XWID + 2.0*HXLAB * (1-ITFLG) + 2.5*HLAB1)/YF
	    xhead = xlo + rlen*maxvel/XF
	    yhead = ytail
	    WRITE (veclab,1000) maxvel
1000	    FORMAT(F7.3)
	    xl = xhead + .125/xf
	    yl = yhead
	    CALL SYMBEL(XL,YL,0.,hlabs,7,veclab)
	ENDIF
	
C  Calculate length of vector in user units and in inches
	
	userdx = xhead - xtail
	userdy = yhead - ytail
	userlen = dist(userdx,userdy)
	
	realdx = userdx*xf
	realdy = userdy*yf
	reallen = dist(realdx,realdy)
	
C  If vector is too small plot a point only
	
	IF (reallen .LT. minvec) THEN
	    CALL PLOT(xtail,ytail,0,0)
	    CALL PLOT(xtail,ytail,1,0)
	    RETURN
	ENDIF
	
C Determine factor of arrowhead length
	
	IF (reallen .GT. maxarw) THEN
	    theadfact = maxarw*headfact/reallen
	ELSE IF (reallen .LT. minarw) THEN
	    theadfact = minarw*headfact/reallen
	ELSE
	    theadfact = headfact
	ENDIF
	
C Calculate coordinates of arrowhead
	
	cosarw = cos(arwang)
	sinarw = sin(arwang)
	xarwrgt = xhead - theadfact*(realdx*cosarw-realdy*sinarw)/xf
	yarwrgt = yhead - theadfact*(realdy*cosarw+realdx*sinarw)/yf
	xarwlft = xhead - theadfact*(realdx*cosarw+realdy*sinarw)/xf
	yarwlft = yhead - theadfact*(realdy*cosarw-realdx*sinarw)/yf
	
C Plot the vector
	
	CALL PLOT(xtail,ytail,0,0)
	CALL PLOT(xhead,yhead,1,0)
	CALL PLOT(xarwlft,yarwlft,0,0)
	CALL PLOT(xhead,yhead,1,0)
	CALL PLOT(xarwrgt,yarwrgt,1,0)
	
	RETURN
	END

	SUBROUTINE EQUAL_COLOR( string, icolor, status )


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* from a string of the form "name=value", return the "value" string
* if the string is simply "name" then return ' ' (blank)
* change the string to upper case

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V510 *sh* 3/00 - based upon EQUAL_STRING
*      *kob* 5/00 - minor change to declaration of colors array needed to
*                   compile under nag f95 for linux
* V520 6/00 *sh* - introduced "white" as color 19 (only thin available)
*
* 1/03 *kob* g77 port - requires use of risc_buff for concats
* V693+ *sh* 2/15 - added support for _DQ_ quotations

* calling argument declarations
	INTEGER		icolor, status
	CHARACTER*(*)	string

* internal parameter declarations
	INTEGER ncolor_string
	PARAMETER (ncolor_string = 7)

* internal variable declarations
	LOGICAL	MATCH4, TM_DIGIT
	INTEGER	TM_LENSTR1, STR_UPCASE, equal_pos, slen, strt, vax_code,
     .          TM_LENSTR, len_test, len_mchars
	REAL	val
*	CHARACTER	LEFINT*4, str*12, colors*12(6)
	CHARACTER	LEFINT*4, str*12
	CHARACTER*12    COLORS(ncolor_string)

* internal data declarations
	DATA colors/'BLACK','RED','GREEN',
     .		    'BLUE','LIGHTBLUE','PURPLE','WHITE'/


	include 'ferret.parm'
	include 'errmsg.parm'
	include 'plot_setup.parm'
	include 'xrisc_buff.cmn'
* initialize
	slen	  = TM_LENSTR1( string )
	equal_pos = INDEX( string, '=' )

	IF ( equal_pos .EQ. 0 ) THEN
	   str = ' '				! "name", alone
	   icolor = 1
	   RETURN

	ELSEIF ( equal_pos .EQ. slen ) THEN	
	   GOTO 5000				! "name ="

	ELSE

* find first non-blank
	   DO 100 strt = equal_pos+1, slen
 100	   IF ( string(strt:strt) .NE. ' ' ) GOTO 110
	   STOP '=_str'		! cannot occur

* remove quotation marks
 110	   IF ( string(strt:strt) .EQ. '"'
     .	  .AND. string(slen:slen) .EQ. '"' ) THEN
	      strt = strt + 1
	      slen = slen - 1
	   ELSEIF (string(strt:strt) .EQ. '_'
     .	     .AND. string(slen:slen) .EQ. '_' 
     .	     .AND. slen-strt.GE.8            ) THEN
	      IF (string(strt:strt+3) .EQ. '_DQ_'
     .	    .AND. string(slen-3:slen) .EQ. '_DQ_' ) THEN
	         strt = strt + 4
	         slen = slen - 4
	      ENDIF
	   ENDIF

	   IF ( strt .GT. slen ) THEN
	      str = ' '
	   ELSE
	     vax_code = STR_UPCASE( str, string(strt:slen) )
	   ENDIF

	ENDIF

	IF ( TM_DIGIT(str) ) THEN 
* ... color and thickness by number
           READ ( str, *, ERR=5000 ) val
cc	   IF ( val.LE. 0.0 .OR. val.GT.num_fancy_lines+1 ) GOTO 5200
	   icolor = NINT( val )	! user-specified line style
	 ELSE
* ... compare with allowable colors
           len_test = TM_LENSTR(str)
	   DO 200 icolor = 1, ncolor_string
              len_mchars = TM_LENSTR(colors(icolor)(:4))
	      IF ( MATCH4(str, len_test,
     .             colors(icolor),len_mchars ) ) GOTO 210
 200	   CONTINUE
	   GOTO 5100   ! unknown color
 210	   IF (icolor .EQ. 7) icolor = 19   ! WHITE
	ENDIF

* success
 1000	status = ferr_ok
 4999	RETURN

* syntax error
 5000	CALL ERRMSG( ferr_syntax, status, string, *4999 )
 5100	risc_buff = string
	CALL ERRMSG( ferr_invalid_command, status, 
     .		risc_buff(:TM_LENSTR1(risc_buff))//pCR//
     .	'Colors are Black,Red,Green,Blue,LightBlue,Purple, and White',
     .		*4999 )
 5200	risc_buff = string
	CALL ERRMSG( ferr_out_of_range, status, 
     .		risc_buff(:TM_LENSTR1(risc_buff))
     .          //pCR//'Legal range is 1 to '
     .		//LEFINT(num_fancy_lines+1,slen), *4999 )
	END

      SUBROUTINE SIZE(WIDTH,HEIGHT)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* revised for FERRET
* from PPLUS :

*	Directory PMEL:[PLOT5.LIBRARY.PLOT]

*	SIZE2.FOR;14              9   5-APR-1987 12:26

* search for "FERRET" to find all revisions
* *sh* 6/30/88 - rev 1.0 for FERRET 1.00+
*	- changed GKS size and location calculations to conform
*	- to SET WINDOW in FERRET
*	- note:	the changes here are to correct a bug that SET WIND/SIZE=n 1
*		is ignored if issued before the first GKS graphical output
* *sh* 8/16/88 - rev 1.1 for FERRET 1.10
*	- added immediate update of display after re-sizing
* *sh* 8/26/88 - rev 1.1 for FERRET 1.10+
*	- added code for SET WINDOW/VIEWPORT in FERRET
* *jd* 9.7.88  - rev 2.0
*	- Modified to properly handle those workstations (like TEK) that
*		do not use meters in their device coordinates and those
*		requiring ASAP deferral state
* *sh* 9/13/88 - rev 2.1 for FERRET 1.10+
*	- allow clipping flagged as OFF via vp_*clip.EQ.unspecified_val4
* *sh* 9/29/88 - rev 2.2 for FERRET 1.10+
*	- allow separate normalization transformation for each wsid (#=wsid)
*	  instead of all windows sharing #1
* *jd* 11.28.88
*	- Modified for compatibility to version 1.1 of PPL
* *sh* 9/29/88
*	- further PPLUS V11 compatibility mods - eliminated FERRET common
* *jd* 03.15.89
*	- Mod to improve GKS control -- removed GKS open and transferred to
*	  GKS_INIT_WS
* *jd* 10.26.89
*	- Mod to write workstation transform information to metafile
* *jd* 03.22.90
*	- Mod to accomodate having no open ws, but metafiles open, in Ferret
* *jd* 03.25.92 
*	- Mod to accommodate ATC GKS -- replaced GQDSP & GSWKVP
* *jd* 10.26.93
*	- Mod to eliminate private item (wsxform) for xgks
* *sh* 4/9/97
*	- check to make sure only GKSM metafiles (not CGM) get
*	  workstation sizing information
* *am* 1/07 V6.02 true batch mode for metafiles; flag meta_batch
*	  distinguises this case from other batch modes.
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus

*     PLOTTER DEPENDENT ROUTINE
*     CONTAINS PHYSICAL CHARACTERISTICS OF ALL LEGAL DEVICES.
*
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C     CALL SIZE(WIDTH,HEIGHT)
C
C     THIS SUBROUTINE DEFINES THE DIMENSIONS OF THE TOTAL PLOT-
C     TING AREA.  SUBSEQUENT TO A CALL TO SIZE, PLOTTING IS AL-
C     LOWED ONLY WITHIN THESE LIMITS.
C
C     THE VARIOUS PARAMETERS AND THEIR DEFINITIONS ARE LISTED
C     BELOW:
C        WIDTH  - TOTAL WIDTH OF THE PLOTTING AREA IN INCHES (OR
C                 MM).  WIDTH IS RESTRICTED TO A MAXIMUM OF 200
C                 INCHES ON THE ZETA PLOTTER AND 200 INCHES ON THE
C                 BENSON PLOTTER.
C        HEIGHT - TOTAL HEIGHT OF THE PLOTTING AREA IN INCHES
C                 (OR MM).  HEIGHT IS RESTRICTED TO A MAXIMUM OF
C                 34 INCHES ON THE ZETA PLOTTER AND 38 INCHES ON
C                 THE BENSON PLOTTER.
C
C     SIZE MAKES THE TEKTERMINAL AND PRINTRONIX PLOTTER APPEAR AS IF
C     THEY WERE WIDTH INCHES (OR MM) WIDE AND HEIGHT INCHES (OR
C     MM) HIGH.
C
C
* V68   *acm* 4/11 change how flag meta_batch is computed (different Makefile)
* V6.8 *acm* 7/9/2012 For batch graphics on RHEL6, change ITS_BATCH_GRAPHICS
*                     from logical to integer, then batch = ITS_BATCH_GRAPHICS().NE.0

   	include 'pltcom_dat.decl'	! with declarations
	include 'PLTCOM.DAT'	! with declarations
	include 'gkscm1_inc.decl'	! with declarations
	include 'GKSCM1.INC'	! with declarations
	include 'gkscm2.cmn'	! metafile info


#ifdef atc_gks
	include        'gkspar.inc'
#else
  	include        'gkspar.inc'
#endif

* special COMMON to let this routine know if FERRET is in control
	include 'ppl_in_ferret.cmn'

* If fortran 90, initialize in block data yabb *jd* Linux port 12.96
#ifdef FORTRAN_90
	external yabd
#else
	DATA	PPL_in_FERRET / .FALSE. /	
#endif
	REAL width, height

	LOGICAL TM_FPEQ_SNGL
        LOGICAL clip, its_meta, batch, meta_batch
	INTEGER ITS_GKSM, ITS_META_GRAPHICS, ITS_BATCH_GRAPHICS
	INTEGER ier, id, itype, imeter, irx, iry
	REAL	dmaxx, dmaxy, fcty, fctx, xln, yln, xmn, xmx, ymn, ymx, t,
     .		bigness, scale,
     .		tmxclip, tmyclip, tmxorg, tmyorg, tmsize, tmscale, 
     .          tmxll, tmyll

	LOGICAL SHRNKX,SHRNKY,FIRST
        SAVE fctx,fcty !Needed for Ultrix
C
      IF(WIDTH .EQ. 0.0 .OR. HEIGHT .EQ. 0.0)RETURN

      its_meta = ITS_META_GRAPHICS() .NE. 0
      batch = ITS_BATCH_GRAPHICS() .NE. 0
      meta_batch = .FALSE.
      IF (batch) THEN
         IF (its_meta) meta_batch = .TRUE.
      ENDIF
C
C     INSURE THAT THE PARAMETERS ARE POSITIVE AND CONVERT THEM
C     TO INTERNAL INCREMENTS.
C
      ANEW = FACTOR * ABS(WIDTH)
      BNEW = FACTOR * ABS(HEIGHT)

	IF ( TM_FPEQ_SNGL(ANEW,ASIZE) .AND. TM_FPEQ_SNGL(BNEW,BSIZE) ) THEN
#ifdef xgks
	   if (meta_actv .OR. meta_batch) then
	      IF (ITS_GKSM(meta_wsid) .EQ. 1) THEN	! *sh* 4/97
	         call gswkwn (meta_wsid,0.0,fctx,0.0,fcty)
	         call gswkvp (meta_wsid,0.0,asize/factor,0.0,bsize/factor)
	      ENDIF
	   end if
#else
	   if (meta_actv .OR. meta_batch call meta_ws_xform (fctx,fcty,asize,bsize) ! JD
#endif
	   RETURN
	end if
	ASIZE=ANEW
	BSIZE=BNEW
C
	IF(ROTAT)THEN
	T=ASIZE
	ASIZE=BSIZE
	BSIZE=T
	ENDIF
C
C     IN ACCORDANCE WITH THE PLOT TYPE, INSURE THAT THE DIMEN-
C     SIONS ARE NOT TOO LARGE.
C
*      Kill this *jd* 8.92
*      IF(PTYPE .EQ. 0 .OR. IABS(PTYPE) .GE. 2)THEN
*        IF(ASIZE .GT. 200000.0)ASIZE = 200000.0
*        IF(BSIZE .GT. 34000.0)BSIZE = 34000.0
*      ENDIF
C
C     COMPUTE THE TEKTERMINAL CONVERSION FACTORS.
C
	IF(TTYPE.GT.0)THEN
      IF(ASIZE / TWIDTH .GT. BSIZE / THIGHT)THEN
        PLTOTA = TSCLA / ASIZE
        PLTOTB = TSCLB / ASIZE * TWIDTH / THIGHT
      ELSE
        PLTOTA = TSCLA / BSIZE * THIGHT / TWIDTH
        PLTOTB = TSCLB / BSIZE
      ENDIF
	ELSE
	PLTOTA=TSCLA/(TWIDTH*FACTOR)
	PLTOTB=TSCLB/(THIGHT*FACTOR)
	ENDIF
C
C     SET THE MINIMUM AND MAXIMUM ALLOWABLE VALUES OF A AND B.
C
      AMIN = 0.0
      BMIN = 0.0
      AMAX = ASIZE
      BMAX = BSIZE
	IF(PTYPE.GT.2)THEN
	    IF(ASIZE.GT.BSIZE)THEN
		FCTY=BSIZE/ASIZE
		FCTX=1.0
	    ELSE
		FCTX=ASIZE/BSIZE
		FCTY=1.0
	    ENDIF
!	    IF(.NOT.GKSOPN)THEN
C
C	OPEN AND INITIALIZE GKS
C
!		CALL GOPKS(ERRFIL)
!		CALL GOPWK(WSID,CONID,WSTYPE)
!		CALL GACWK(WSID)
!
*               jd mod 9.7.88 begin
*		SET DEFERRAL STATE TO GENERATE OUTPUT AS SOON AS POSSIBLE
!               call gsds (wsid,gasap,gsuppd)
*               jd mod 9.7.88 end
!
!		GKSOPN=.TRUE.
!		LPEN=.NOT.PEN
!	    ENDIF

* FERRET insert 9/1/88 - modified 9/13/88 - and 1/19/89
* use normalization transforms to allow viewports within output window

* default window and viewport values (full window)
	tmxorg  = 0.0
	tmyorg  = 0.0
	tmxclip = 1.0
	tmyclip = 1.0
	tmsize  = 1.0
	tmscale = 1.0	! full sized
	tmxll   = 0.2
	tmyll   = 0.2
	clip    = .FALSE.

* FERRET in control ?
	IF ( PPL_in_FERRET ) CALL GET_VP_FROM_FERRET( tmxorg, tmyorg,
     .			     tmsize, tmscale, tmxclip, tmyclip, tmxll, tmyll )

* The following calls to GSVP, GSWN, GSELNT refer to wsid but are not
* restricted in action to a particular WS.  All WS's use the same normalization
* transform, the active one, set by SELNT.  In particular the metafile output
* WS will be affected by these calls. jd 3.15.89
*

* set viewport in NDC to limits requested
* 9/29 - "1" --> wsid *sh*

*	MAX function inserted JD 3.22.90	
	CALL GSVP(MAX (wsid,1), fctx*tmxorg, fctx*tmxclip, 
     .	fcty*tmyorg, fcty*tmyclip )

* set world coordinate window to preserve 1:1 aspect
* 9/29 - "1" --> wsid *sh*
	scale = 1.0 / SQRT( tmsize )
*	MAX function inserted JD 3.22.90	
	CALL GSWN(MAX (wsid,1), 0.0, ( tmxclip-tmxorg )*scale*asize,
     .				0.0, ( tmyclip-tmyorg )*scale*bsize  )

*select normalization transformation and turn on clipping
* 9/29 - "1" --> wsid *sh*
*	MAX function inserted JD 3.22.90	
	CALL GSELNT(MAX (wsid,1))
	IF ( clip ) THEN
	   CALL GSCLIP(gclip)
	ELSE
	   CALL GSCLIP(gnclip)
	ENDIF

* end of 9/1/88 and 9/13/88 FERRET mods
c
c	set up the size of the display window
c
	    CALL GQWKC(WSID,IER,ID,ITYPE)
*	    CALL GQDSP(ITYPE,IER,IMETER,DMAXX,DMAXY,IRX,IRY) Replaced 3.25.92
	    call query_display_size (ITYPE,IER,IMETER,DMAXX,DMAXY,IRX,IRY)
C
	    IF(WKSAUT)THEN
		XLN=ASIZE*2.54E-5
		YLN=BSIZE*2.54E-5

* FERRET mod: all lines below beginning with "!" have been commented out for
* FERRET: (ie. calculations for position and size of window have been changed)
!		FIRST=.TRUE.
!200		WKXMN=DMAXX-.0127-XLN
!		WKYMN=.00635
!C
!		SHRNKX=.FALSE.
!		SHRNKY=.FALSE.
!		IF(WKXMN.LT.0)THEN
!		    WKXMN=0.0
!		    YLN=YLN*DMAXX/XLN
!		    XLN=DMAXX
!		    SHRNKX=.TRUE.
!		ENDIF
!		IF(WKYMN+YLN.GT.DMAXY)THEN
!		    WKYMN=0.0
!		    XLN=XLN*DMAXY/YLN
!		    YLN=DMAXY
!		    SHRNKY=.TRUE.
!		ENDIF
!		IF(FIRST.AND.SHRNKX.AND.SHRNKY)THEN
!		    FIRST=.FALSE.
!		    GOTO 200
!		ENDIF
* FERRET insert: ************************************************************
* re-scale as requested by SET WINDOW command
	        xln = tmscale * xln
	        yln = tmscale * yln

* ... too big to fit ?
*	        bigness = MIN( dmaxx/xln, dmaxy/yln )
*	        IF ( bigness .LT. 1.0 ) THEN
*	           xln = xln * bigness
*	           yln = yln * bigness
*	        ENDIF

* ... put lower left of each window at a different place if possible
* ... further modified 8/26/88 to have resettable lower left
	        wkxmn = MIN( tmxll, dmaxx-xln )
	        wkymn = MIN( tmyll, dmaxy-yln )

* end of FERRET insert: ******************************************************
C
		WKXMX=WKXMN+XLN
		WKYMX=WKYMN+YLN
C
C	SET THE NDC WINDOW

*	Next 5 lines *jd* 3.25.92
	if (.not. PPL_IN_FERRET) then
	   call gswn(1,0.0,asize,0.0,bsize)
     	   call gsvp(1,0.0,fctx,0.0,fcty)
	   call gselnt (1)
	endif

C
*		CALL GSWKWN(WSID,0.0,FCTX,0.0,FCTY) Mod below made JD 3.22.90
		if (wsid .gt. 0 .AND. (.NOT.meta_batch)) 
     .              CALL GSWKWN(WSID,0.0,FCTX,0.0,FCTY)
#ifdef xgks
	   if (meta_actv .OR. meta_batch) then
	      call gswkwn (meta_wsid,0.0,fctx,0.0,fcty)
	      call gswkvp (meta_wsid,0.0,asize/factor,0.0,bsize/factor)
	   end if
#else
	   if (meta_actv .OR. meta_batch) call meta_ws_xform (fctx,fcty,asize,bsize) ! JD
#endif
C
C	SET DEVICE (WORKSTATION) VIEWPORT
C
*               jd mod 9.7.88 begin
                if (imeter .eq. 0) then
*                   CALL GSWKVP(WSID,WKXMN,WKXMX,WKYMN,WKYMX) Mod JD 3.22.90
* Replaced 3.25.92  if (wsid .gt. 0) CALL GSWKVP(WSID,WKXMN,WKXMX,WKYMN,WKYMX)
	            if (wsid .gt. 0) call set_window_size 
     .					(WSID,WKXMN,WKXMX,WKYMN,WKYMX)
                else
*                   USE DENBO INCHES
*                   CALL GSWKVP(WSID,0.0,dmaxx,0.0,dmaxy) Mod JD 3.22.90
* Replaced 3.25.92  if (wsid .gt. 0) CALL GSWKVP(WSID,0.0,dmaxx,0.0,dmaxy)
		    if (wsid .gt. 0) call set_window_size 
     .					(WSID,0.0,dmaxx,0.0,dmaxy)	
                end if
*               jd mod 9.7.88 end
	    ELSE
C
C	IF NOT AUTO WKXMN AND WKXMX ETC ARE FRACTIONS OF DMAXX
C	AND DMAXY
C
*		CALL GSWKWN(WSID,0.0,FCTX,0.0,FCTY) Mod JD 3.22.90
		if (wsid .gt. 0 .AND. (.NOT.meta_batch)) 
     .             CALL GSWKWN(WSID,0.0,FCTX,0.0,FCTY)

#ifdef xgks
	   if (meta_actv .OR. meta_batch) then
	      call gswkwn (meta_wsid,0.0,fctx,0.0,fcty)
	      call gswkvp (meta_wsid,0.0,asize/factor,0.0,bsize/factor)
	   end if
#else
	   if (meta_actv .OR. meta_batch) call meta_ws_xform (fctx,fcty,asize,bsize) ! JD
#endif
		XMN=DMAXX*WKXMN
		XMX=DMAXX*WKXMX
		YMN=DMAXY*WKYMN
		YMX=DMAXY*WKYMX
* 		CALL GSWKVP(WSID,XMN,XMX,YMN,YMX) Mod JD 3.22.90
* Replaced 3.92	if (wsid .gt. 0) CALL GSWKVP(WSID,XMN,XMX,YMN,YMX)
		if (wsid .gt. 0) call set_window_size 
     .					(WSID,XMN,XMX,YMN,YMX)	

	    ENDIF

* FERRET mod: force immediate update of display
*	   CALL GUWK( wsid, 1 ) Mod JD 3.22.90
	   if (wsid .gt. 0 .AND. (.NOT.meta_batch) ) CALL GUWK( wsid, 1 )
	ENDIF
C
C     CALCULATE THE OFF-SCREEN FLAG.
C
      LOSFLG = 0
      IF(AOLD - 0.001 .GT. AMAX)LOSFLG = 1
      IF(AOLD + 0.001 .LT. AMIN)LOSFLG = 2
      IF(BOLD - 0.001 .GT. BMAX)LOSFLG = LOSFLG + 4
      IF(BOLD + 0.001 .LT. BMIN)LOSFLG = LOSFLG + 8

      RETURN
C
      END

*
* string_to_id.F
*
* Ansley Manke
* March 2013
*
*  Convert a sorted list of strings to a list of numeric ID's:
*    the first string encountered is ID=1,
*    the next unique string encountered is ID=2, etc.
*
* This function takes two string arguments and one numeric argument.
* It returns a string result.  The result is the first N letters of the 
* first argument prepended to the string in the second argument, where N
* is the number of characters to take from the strings of arg1.
* 
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE string_to_id_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

      CALL ef_version_test(ef_version)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .  'Return numeric IDs for each new string in sorted list of strings')

      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     . IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'STRINGS')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'string argument')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)
      CALL ef_set_arg_type (id, arg, STRING_ARG)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE string_to_id_compute(id, arg_1,  result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result

*  ! string arg and result need to be twice the length.

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l, i1,i2,i3,i4
      INTEGER iarg, slen1, alen, nchar
      REAL value
      CHARACTER text1*1000, this_string*1000
      LOGICAL isnew

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      aindex = 0
      alen = 1
      this_string = " "

      i1 = arg_lo_ss(X_AXIS,ARG1)
      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               l1 = arg_lo_ss(T_AXIS,ARG1)
               DO 100 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
                  iarg = 1
 	          CALL EF_GET_STRING_ARG_ELEMENT (id, ARG1, arg_1, 
     .                                      i1,j1,k1,l1, slen1, text1)
                  CALL EF_GET_STRING_ARG_ELEMENT_LEN (id, iarg, arg_1, 
     .                                           i1,j1,k1,l1, slen1)

                  isnew = .FALSE.
                  IF (slen1 .EQ. alen) THEN
	             IF (text1(:slen1) .NE. this_string(:alen)) isnew = .TRUE.
                  ELSE
	             isnew = .TRUE.
                  ENDIF

                  IF (isnew) THEN
	             aindex = aindex + 1
	             this_string = text1
	             alen = slen1
                  ENDIF
	    
                  result(i,j,k,l) = aindex

                  l1 = l1 + arg_incr(T_AXIS,ARG1)
                  l2 = l2 + arg_incr(T_AXIS,ARG2)
 100           CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
               k2 = k2 + arg_incr(Z_AXIS,ARG2)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
            j2 = j2 + arg_incr(Y_AXIS,ARG2)
 300     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
         i2 = i2 + arg_incr(X_AXIS,ARG2)
 400  CONTINUE
 

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	SUBROUTINE DELETE_ONE_LINE (axis, status)
	
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*

* Delete a single axis (from xeq_cancel)

	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'tmap_errors.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
        include 'xtm_grid.cmn_text'

	INTEGER axis, slen, status
	CHARACTER*10 TM_FMT, buff
	REAL	raxis

	INTEGER TM_GET_GRID_OF_LINE, TM_GET_LINENUM, 
     .		grid, num_protected_axes

	raxis = axis
	buff = TM_FMT(raxis, 6, 10, slen)
	num_protected_axes = TM_GET_LINENUM( 'EZ' )  ! top protected axis

	IF ( axis .EQ. unspecified_int4 ) GOTO 6210
	IF ( axis .LE. num_protected_axes ) GOTO 6212
	line_keep_flag(axis) = .FALSE.  ! see tm_garb_col_grids.F
	IF (line_use_cnt(axis) .LE. 0) THEN
	   IF ( axis .LE. max_lines ) THEN
	      IF ( axis .LE. max_lines ) THEN
	         IF (.NOT. line_regular(axis))
     .                CALL PACK_LINE_STORAGE(axis)
	         line_name(axis) = char_init16
	      ELSE
	         CALL TM_DEALLO_DYN_LINE(axis)
	      ENDIF
	   ENDIF
	ELSE
*     ... cannot delete - in use.  Locate the grid that is using it.
	   grid = TM_GET_GRID_OF_LINE( axis )
	   CALL WARN( 'Not deleted: '//line_name(axis))
	   IF ( grid .NE. unspecified_int4 ) THEN
	      CALL WARN( 
     .		'Axis is in use by grid '//grid_name(grid))
	   ELSE
	      CALL ERRMSG(ferr_internal, status,
     .				'axis use count err', *5000)
	   ENDIF
	ENDIF

 5000	CONTINUE
	RETURN

 6210	CALL ERRMSG( ferr_invalid_command, status, 'unknown axis: '//
     .		     buff(:slen), *5000 )
 6212	CALL ERRMSG( ferr_invalid_command, status, 'protected axis: '//
     .		     buff(:slen), *5000 )

	END

	SUBROUTINE DISP_PREP( status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* prepare the plot package (PPLUS) for another variable.  This routine is
* called even for overlays

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 7/28/87
* revision 1.0 - 6/22/88 - added VECSET,
*			   added logical flags lev_given, len_given
* revision 1.1 -  9/8/88 - added cmnd_shade
* revision 1.2 - 4/26/89 - added direct control of PPLUS variable iautoc to
*			   prevent PPLUS from resetting contour intervals when
*			   /LEVELS_SAME is specified
* V200:  1/17/90 - bug fix: set nlev2 so PLOT+ doesn't forget # of contour levs
*		 (when levs are set automatically and then preserved via /LEV)
*	 3/13/90 - added CHECK_GRAPHICS and status return
*	 4/12/90 - same fix needed for /LEVELS is also needed in /LENGTH
*	 4/16/90 - allow /LEVEL="(lo,hi,delta)" and /LENGTH=val
* V313: *sh* AIX port.  Replace "LEV ()" with "LEV,()" so AIX space-squeezing
*		filter doesn't corrupt this routine
* V400:	 8/24/94 - allow /LEVELS=n to set the recommended number of levels
* V4.1+  7/25/95 - allow automatic centered levels and delta-only levels 
* v500 - 1/26/99 - *kob* add PPLCMD call for aline reinitialization - needed for
*                   nolabel plot overlays
* V608 - 10/07   - *acm* Give more detail int he error message when the number 
*                  of contour levels given is too large
* V630  *acm* 9/09 Introduction of syntax for variance-based and histogram levels
* V670  *acm* 2/11 Fix bug 1803. Centered levels confused with variance-based centered
*                  levels.
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V685+ 12/13    - *acm*  bounds checking; dont refer to parts of the string outside its bounds.
* V694   5/15    - *acm*  Ticket 2285: need to initialize iautoc to = 1 so overlay with /LEV=20V works.
* V695  *acm* 9/15 ticket 2311: variance-based levels on constant variables
* V695  *acm* 9/15 (not fully implemented) INT option for levels
* V6.86 *acm* 1/14 In above fix, let there be spaces before the file spec.
* v697 *acm* 12/15 Ticket 2331, add flag changed_key to common, and restore the color key
*                  style after a SHADE/SET; SHADE.
* v698 *acm*  2/16 Initialize the use_hist flag to false
* v698 *acm*  2/16 Allow for /LEV=h, histogram levels without specifying a number.

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'command.parm'
	include 'slash.parm'
	include 'plot_setup.parm'
	include 'xplot_setup.cmn'
	include 'xplot_state.cmn'
	include 'xprog_state.cmn'
	include 'parampl5_dat.decl'	! with inclen
	include 'PARAMPL5.DAT'	! with inclen
	include 'cont_inc.decl'	! with iautoc
	include 'CONT.INC'	! with iautoc
	include 'vector_inc.decl'	! with vauto
	include 'VECTOR.INC'	! with vauto

* calling argument declarations:
	INTEGER	status

* internal variable declarations:
	LOGICAL TM_DIGIT, lev_given, len_given,
     .		is_delta, is_std, is_mean, is_min, is_max, is_hist,
     .          is_centered, is_openlev, is_int, is_cv, get_more,
     .		has_std , has_mean, has_min, has_max, has_int
	INTEGER	TM_LENSTR1,TM_LENSTR, lev_loc, len_loc, str_1, str_len, 
     .          ii, ilen, ier, ist, nc, set_default_levs
	REAL	val
#ifdef double_p
	REAL*4  rbad_val4
#else
	REAL  rbad_val4
#endif

* v500 - 1/26/99 *kob* double buffer size for /levels text
* v532 - 5/11/01 *kob* increase buffer size for /levels text to 1028
	CHARACTER str_buff*1028
        CHARACTER*255 labsym_buff
	CHARACTER*1 cbuf

	CHARACTER TM_FMT*12, buffer*40, buff30*30

* is the graphics output device open and ready ??
	CALL CHECK_GRAPHICS( status )
	IF ( status .NE. ferr_ok ) RETURN

* initialize
	centered  = .FALSE.
	openlev = .FALSE.
	use_hist = .FALSE.	
	set_std = .FALSE.
	set_mean = .FALSE.
	set_min = .FALSE.
	set_max = .FALSE.
	set_delta = .FALSE.
	need_histo = .FALSE.
        need_std = .FALSE.

	rbad_val4 = bad_val4
	lev_mean = rbad_val4
	lev_std = rbad_val4
	lev_min = rbad_val4
	lev_max = rbad_val4

	ii = 0

* reinitialize - *kob* 
* forget line specimen definitions that were used in previous plots
        CALL PPLCMD ( from, line, 0, 'ALINE ', 1, 1 )

* if the colorkey was changed by a previous key=center, etc reset it.
        IF (changed_key ) THEN
           CALL PPLCMD (from, line, 0, 'S_KEY 0', 1, 1 )
           changed_key = .FALSE.
        ENDIF

* what qualifiers will effect the initialization of PLOT+

	lev_loc = qual_given( slash_levels )
	IF (cmnd_num.EQ.cmnd_plot) lev_loc = qual_given( slash_plot_levels )
	len_loc = qual_given( slash_length )
	lev_given    = ( cmnd_num.EQ.cmnd_contour .OR. 
     .                   cmnd_num.EQ.cmnd_shade   .OR.
     .                   cmnd_num.EQ.cmnd_polygon .OR. 
     .                   cmnd_num.EQ.cmnd_plot) .AND. lev_loc.NE.0
	len_given = cmnd_num .EQ. cmnd_vector
     .		.AND. len_loc .NE. 0

        contour_fewer = 1
        need_std = .FALSE.

	
        intlev = 0

	IF ( lev_given    ) THEN
           contour_fewer = 0
           CALL EQUAL_STRING(  
     .          cmnd_buff(qual_start(lev_loc):qual_end(lev_loc)), 
     .                        str_buff, status ) 

* Set symbol LEV_TEXT with the users input to the LABEL command.
* (Note that the above call has put str_buff into uppercase.)

        labsym_buff = "LEV_TEXT "//str_buff
        ilen = TM_LENSTR1(labsym_buff)
        ier = 0
        ist = 0
        CALL SETSYM (labsym_buff, ilen, ier, ist)

	IF ( str_buff .NE. ' ' ) THEN
	
	   neginf = .FALSE.
	   posinf = .FALSE.

* ... pass the levels string given by the user to PLOT+
	      str_len = TM_LENSTR1( str_buff )
	      IF ( str_buff(1:1) .NE. '('
     .	      .OR. str_buff(str_len:str_len) .NE. ')' ) THEN
* ... is this a /LEVELS=nDC specifier or a mistaken forgetting of parentheses?
*	/LEVELS=n for n levels
*	/LEVELS=nC for n centered levels
*	/LEVELS=xxD for levels specified by delta value
*	/LEVELS=xxDC for centered levels specified by delta value
*	/LEVELS=nv for n open-ended levels (possibly with specified MEAN and STD)
*	/LEVELS=xxMEAN for open-ended levels centered about mean value
*	/LEVELS=xxSTD for open-ended levels using given STD value
*	/LEVELS=xxMIN for open-ended levels on top, closed at MIN below
*	/LEVELS=xxMAX for open-ended levels on bottom, closed at MAX above

 1000            CONTINUE
	         is_std = .FALSE.
	         is_mean = .FALSE.
	         is_min = .FALSE.
	         is_max = .FALSE.
	         is_int = .FALSE.
	         is_hist = .FALSE.
	         is_delta = .FALSE.
	         is_cv = .FALSE.

		 iautoc = 1

	         val = bad_val4

	         is_centered =  str_buff(str_len:str_len) .EQ. 'C'
	         is_openlev =  str_buff(str_len:str_len) .EQ. 'V'

	         IF ( is_centered ) THEN
		    centered = .TRUE.
		    str_len = str_len - 1
	            qual_end(lev_loc) = qual_end(lev_loc) - 1
		    is_cv = .TRUE.
	         ENDIF
	         IF ( is_openlev ) THEN
		    openlev = .TRUE.
		    str_len = str_len - 1
	            qual_end(lev_loc) = qual_end(lev_loc) - 1
		    is_cv = .TRUE.
	         ENDIF

* set up some logicals -- with bounds checking we cannot refer to, e.g. 
* str_buff(str_len-2:str_len)  if str_len is less than 3...

		 has_std = .FALSE.
		 IF (str_len .GE. 3) THEN
		    has_std = str_buff(str_len-2:str_len) .EQ. 'STD'
		 ENDIF

		 has_mean = .FALSE.
                 IF (str_len .GE. 4) THEN
		    has_mean = str_buff(str_len-3:str_len) .EQ. 'MEAN'
		 ENDIF
		 
		 has_min = .FALSE.
		 IF (str_len .GE. 3) THEN
		    has_min = str_buff(str_len-2:str_len) .EQ. 'MIN'
		 ENDIF

		 has_max = .FALSE.
		 IF (str_len .GE. 3) THEN
		    has_max = str_buff(str_len-2:str_len) .EQ. 'MAX'
		 ENDIF

		 has_int = .FALSE.
		 IF (str_len .GE. 3) THEN
		    has_int = str_buff(str_len-2:str_len) .EQ. 'INT'
		 ENDIF

	         IF ( str_len .GT. 0 ) THEN
	            set_delta = str_buff(str_len:str_len) .EQ. 'D'
	            is_delta = str_buff(str_len:str_len) .EQ. 'D'
                    IF (has_std) THEN
                          set_delta = .FALSE.
			  is_delta = .FALSE.
		          is_std = .TRUE.
			  set_std = .TRUE.
			  openlev = .TRUE.
			  is_cv = .TRUE.
			  str_len = str_len - 3
	                  qual_end(lev_loc) = qual_end(lev_loc) - 3
                    ENDIF 
	            IF (str_len .EQ. 0 ) GOTO 5120

	            IF ( set_delta ) THEN
		       str_len = str_len - 1
	               qual_end(lev_loc) = qual_end(lev_loc) - 1
	            ENDIF
	            IF (str_len .EQ. 0 ) GOTO 5120

                    IF (has_mean) THEN
                       is_mean = .TRUE.
                       set_mean = .TRUE.
                       centered = .TRUE.
                       is_cv = .TRUE.
                       str_len = str_len - 4
                       qual_end(lev_loc) = qual_end(lev_loc) - 4
                    ENDIF 
	            IF (str_len .EQ. 0 ) GOTO 5120

                    IF (has_min) THEN
                       is_min = .TRUE.
                       set_min = .TRUE.
                       str_len = str_len - 3
                       qual_end(lev_loc) = qual_end(lev_loc) - 3
                    ENDIF 
	            IF (str_len .EQ. 0 ) GOTO 5120

                    IF (has_max) THEN
                       is_max = .TRUE.
                       set_max = .TRUE.
                       str_len = str_len - 3
                       qual_end(lev_loc) = qual_end(lev_loc) - 3
                    ENDIF 

                    IF (has_int) THEN
                       is_int = .TRUE.
		       intlev = 1
                       str_len = str_len - 3
                       qual_end(lev_loc) = qual_end(lev_loc) - 3
		    ENDIF

                    IF (str_buff(str_len:str_len) .EQ. 'H') THEN  ! histogram
                       is_hist = .TRUE.
                       str_len = str_len - 1
		       IF (str_len .NE. 0) qual_end(lev_loc) = qual_end(lev_loc) - 1
                    ENDIF 

                    str_1 = qual_start(lev_loc)

		    get_more = .FALSE.
	            IF (INDEX(str_buff(1:str_len),',') .GT. 0) THEN
		       str_1 = str_len
		       DO WHILE (INDEX(str_buff(str_1:str_1),',') .EQ. 0)
		          str_1 = str_1 - 1
	               ENDDO
		       str_1 = str_1 + 1
		       IF (str_1 .LE. str_len) THEN
      	                  READ (str_buff(str_1:str_len), *, err=5000) val
		          qual_end(lev_loc) = 
     .		          qual_end(lev_loc) - (str_len-str_1+1)  ! numb. len
                          get_more = .TRUE.
		       ENDIF
		       qual_end(lev_loc) = qual_end(lev_loc) - 1 ! comma
                       
                       str_1 = str_1 - 2
                       str_len = str_1
                    ELSE

* If its a number read it, otherwise will go back for another letter code.
		       get_more = .FALSE.
		       IF (qual_start(lev_loc) .LE. qual_end(lev_loc)) THEN
		          labsym_buff = 
     .                  cmnd_buff(qual_start(lev_loc):qual_end(lev_loc))
		          cbuf = 
     .                  cmnd_buff(qual_end(lev_loc):qual_end(lev_loc))
           	          IF ( TM_DIGIT(cbuf) ) THEN
     	                     CALL EQUAL_VAL(labsym_buff, val, status )
                             str_1 = 1
			  ELSE
			     get_more = .TRUE.  ! Get another letter-code
			  ENDIF
		       ENDIF
                    ENDIF

	            IF ( status .NE. ferr_ok ) GOTO 5000

 500		    CONTINUE
		    IF ( is_delta ) THEN
		       iautoc = 1
	               delta = val
	            ELSEIF (is_std) THEN
		       openlev = .TRUE.
	               lev_std = val
		       IF (lev_std .LE. 0.) GOTO 5210
	            ELSEIF ( is_mean) THEN
		       lev_mean = val
	            ELSEIF ( is_min) THEN
		       lev_min = val
	            ELSEIF ( is_max) THEN
		       lev_max = val
	            ELSEIF ( is_int) THEN
		       val = 0
		       intlev = 1
	            ELSEIF ( is_hist) THEN
		       lev_hist = val
		       need_histo = .TRUE.
		       IF (val .NE. bad_val4) THEN
		          nlev = val
		          IF (val.LE.0. .OR. val.GT.250.) GOTO 5160
		       ENDIF
		       IF (str_len .EQ. 0) THEN
		          lev_hist = nlev
		          get_more = .FALSE.
			  str_1 = 1
		       ENDIF
	            ELSEIF ( is_cv) THEN
		       IF (val .NE. bad_val4) THEN
		          nlev = val
			  iautoc = 1
		          IF (val.LE.0. .OR. val.GT.250.) GOTO 5150
		       ENDIF
		    ELSE

	               IF (val.LE.0 .OR. val.GT.250) GOTO 5150 
* ... set the /LEVELS=n recommendation specifier
		       iautoc = 1
	               nlev = val   ! levels set in PPLUS plotting routine
	            ENDIF
		    IF  (str_1 .GT. 1) GOTO 1000
		    IF  (get_more) GOTO 1000

	         ELSE
		    iautoc = 1
! "C" is equivalent to "nC" where n is the current mode nlevels setting
	            nlev = mode_arg(pmode_nlevels, 1)       
		    contour_fewer = 1  ! if its a contour line plot
	         ENDIF

* If requested both open-ended values and a min and max, use only
* the min and max, regardless of any Mean and Std settings
	         IF (set_min .AND. set_max) THEN
	            openlev = .FALSE.
	            SET_STD = .FALSE.
	            SET_MEAN = .FALSE.
	            LEV_STD = rbad_val4
	            LEV_MEAN = rbad_val4
	         ENDIF

* If requested centered, but no mean value given, set the mean to zero.
	         IF (centered) THEN
	            IF (LEV_MEAN .EQ. rbad_val4) LEV_MEAN = 0.
	            set_mean = .TRUE.
	         ENDIF

		 IF (is_int) THEN
		    openlev = .FALSE.
		    need_histo = .FALSE.
		    IF (set_min) lev_min = FLOOR(lev_min)
		    IF (set_max) lev_max = CEILING(lev_max)
		 ENDIF

* The processing always gets the data max/min.
* Flag to indicate whether we need to get mean/std from the data.
	         need_std = .FALSE.

		 IF (openlev .AND. 
     .               ( LEV_STD.EQ.rbad_val4 .OR. LEV_MEAN.EQ.rbad_val4) )
     .              need_std = .TRUE.

	      ELSE
	         CALL PPLCMD( from, line, 0,
     .			      'LEV,()'//str_buff(:str_len), 1, 1 )
	      ENDIF
	   ELSEIF ( iautoc .EQ. 1 ) THEN
* ... if levels were previously set automatically by PLOT+ and user has now
*     requested to reuse them --> make PLOT+ think they were set manually
	      iautoc = 0
	      nlev = nlev2 ! reuse # of levels from last plot
	   ENDIF
	ELSE
* ... set up for automatic levels
	   CALL PPLCMD ( from, line, 0, 'LEV,()', 1, 1 )
	ENDIF

* vector length ?
	IF ( len_given ) THEN
	   CALL EQUAL_STRING( 
     .           cmnd_buff(qual_start(len_loc):qual_end(len_loc)),
     .			      str_buff, status )
	   IF ( str_buff .NE. ' ' ) THEN
	      CALL EQUAL_VAL( 
     .             cmnd_buff(qual_start(len_loc):qual_end(len_loc)),
     .			      val, status )	! syntax check
	      IF ( status .NE. ferr_ok ) GOTO 5000
	      IF ( val .LE. 0.0 ) GOTO 5200
	      str_len = TM_LENSTR1( str_buff )
* ... send specified vector value to PLOT+
	      CALL PPLCMD ( from,line,0,'VECSET ,'//str_buff(:str_len),1,1 )
	   ELSE
* ... preserve previous length - possible auto length from PLOT+
	      IF ( vusrln .EQ. 0.0 ) vusrln = 1.0 ! has vec len been init'ed ?
	      vauto = .FALSE.
	   ENDIF
	ELSE
* ... set up for automatic vector lengths
	   CALL PPLCMD ( from, line, 0, 'VECSET', 1, 1 )
	ENDIF

* success
	RETURN

* error exit
 5000	RETURN
 5100	CALL ERRMSG( ferr_syntax, status,
     .		str_buff(:str_len)//' must be in parentheses', *5000 )
 5120	CALL ERRMSG( ferr_syntax, status,
     .		'LEVELS=xxD with xx value missing', *5000 )
 5150	CALL ERRMSG( ferr_invalid_command, status,
     .		'"'//str_buff(:str_len)//
     . '": Number of contour levels must be between 1 and 250',
     .		*5000 )
 5160	CALL ERRMSG( ferr_invalid_command, status,
     .		'"'//str_buff(:str_len)//
     . '": Number of histogram levels must be between 1 and 250',
     .		*5000 )
 5200	CALL ERRMSG( ferr_invalid_command, status,
     .		'zero vector length on /LENGTH=', *5000 )
 5210	CALL ERRMSG( ferr_out_of_range, status,
     .		'STD must be a positive number', *5000 )
	END

	SUBROUTINE IS_GRID_MODE( status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* set up interp stack to begin determining the grid of an algebraic expression

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  6/28/89
* V420:  1/95 - need to init cx_delta since it is used by dynamic axes
* V491:  12/97 - bug fix: need to initialize 
* V510: *sh* 4/00 - initialize the grid that is allocated to 
* V600  4/06 *acm* - misspelled variable found by Solaris compiler
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V695  *acm* 2/15 cx_calendar stores info about calendar formatting of T and F axes

        IMPLICIT NONE
* calling argument declarations:
	INTEGER	status

* internal variable declarations:
	INTEGER cx, big_cx, idim

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
#       include "tmap_dset.parm"
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'

* carve a space on the context stack for a "bland" (1:1,1:1,1:1,1:1,1:1,1:1) context
	cx = cx_stack_ptr
	cx_grid(cx) = unspecified_int4		! for pseudo_vars in pass 1
	DO 100 idim = 1, nferdims
	  cx_lo_ss(cx,idim) = 1
	  cx_hi_ss(cx,idim) = 1
	  cx_by_ss(idim,cx) = .TRUE.
	  cx_trans(idim,cx) = trans_no_transform
	  cx_given(idim,cx) = .FALSE.
	  cx_lo_ww(idim,cx) = unspecified_val8
	  cx_hi_ww(idim,cx) = unspecified_val8
	  cx_delta(idim,cx) = unspecified_val8
          cx_calendar(idim,cx) = .FALSE.
 100	CONTINUE
        cx_cal_id(cx) = unspecified_int4

* diagnostic alert
	IF ( mode_diagnostic )
     .			CALL DIAGNOSTIC_OUT( 'getgrid', cx, point_to_cx )

* initialize a level on the interpretion stack for the activity
	is_phase( isp ) = 0

* allocate another context for the "merged" grid
	CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	big_cx = cx_stack_ptr
	is_big_cx( isp ) = big_cx
	CALL ALLO_GRID( cx_grid(big_cx), status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	CALL INIT_GRID( cx_grid(big_cx), char_init16, mnormal )

* set flag indicating that the first component grid has not yet been encountered
	is_sum( isp ) = isalg_transfer
	RETURN

* error exit
 5000	RETURN
	END	

	SUBROUTINE LIST_MULTI_SUB( mr_list,cx_list,heading,
     .				  perm,ws,xact_range, has_size, bad,
     .				  pt_blk, size, msize, width, out,
     .				  status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* list several gridded variables with multiple variables per record

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:   7/5/90 - based on LIST_CMND_DATA
* V230:  6/18/92 - 2 bug fixes for listings with ambiguous coords
*       list/k=2/l=5/x=130e:180/y=0:20/d=gtsa056 temp,salt,u,v[k=1]
*                - use COMMON variable list_format_type
*        7/22/92 - identify "column 1", "column 2", ... in header (bug 7/31)
*        11/4/92 - expanded variable name length
* V300:  4/29/93 - fixed subscript bug for xact lists longer than mem_blk_size
* V301: 11/1/93 - change to WRITE(ERR=...) processing for DEC compilers
* V312: 5/94 - array "memory" as a calling argument
* V313: 8/14/94 *kob* IBM port - variable declaration for ss_save changed from
*				 integer to logical
*	31/10/94 *sh* and size of row_ss_fmt increased due to ROW_COORD_FMT chg
* V320: 12/29/94 - use SPLIT_LIST to redirect tty output for GUI
*Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
* V500 *kob* 3/99- up VAR_CODE and vcode decl's from 8 to 64 chars
* V530  8/00 - added support for string variables
* V552 *acm* 4/03- up VAR_CODE and vcode decl's from 64 to 128 chars
* V581: *acm*/3/05 - increase length of strings for dataset title to 1024
* V600: *acm* 8/05 - make multi-variable tab and comma-delimited listings of
*                    multiple variables like free-format listings, rather than 
*                    like LIST/SINGLY. (bug 1273)
* V600: *acm* 8/05 - Add new qualifier LIST/NOROWHEAD to remove labels that
*                    start each row labelling the coordinate values. (bug 1273)
* V600: *acm* 8/05 - fix bug 1313; reinitialize list_buffer after heading of 
*                    variable names on columns, before listing data
* V602: *acm 11/06 - fix bug 1451 when list/form=comma or /format=tab,
*                    and there is missing data, output a comma or tab
*                    placeholder for the missing values'
* V603: *acm* 6/07 - Fix bug 1388. LIST/PREC= did not work on multi-variable 
*                    listings but SET LIST/PREC=; LIST  did. The code to get
*                    the value of /PREC= was inside an IF block only executed for
*                    tab and comma formatting, and there was also an inconsistency
*                    in how the two flags were used: prec_digits(for LIST/PREC=) and
*                    list_digits(setting from SET LIST/PREC=)
* V610: *acm* 2/10 - Fix bug 1698. For tab and comma-delimited files,
*                    list out the missing data values. The point of these
*                    is that they'll be read into some other software e.g.
*                    spreadsheets, so the user wants the missing flags in there.
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V691+ *acm* 9/14 Ticket 2199: for string variables don't list a BAD FLAG in the header.
* V702: *sh*  2/17 Dynamic memory management (pt_blk no longer used)

	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'ferret.parm'
	include 'errmsg.parm'
	include	'slash.parm'
	include 'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xprog_state.cmn'
	include 'xcontext.cmn'
	include 'xtext_info.cmn'
	include 'xinterrupt.cmn'
	include 'xrisc.cmn'          ! 12/94 SPLIT_LIST buffer

* local parameter declarations:
	LOGICAL		no_decims
	INTEGER		line_length
	PARAMETER     ( line_length  = 2048,
     .			no_decims = .FALSE. )

* calling argument declarations:
	LOGICAL	heading
	INTEGER	mr_list(num_uvars_in_cmnd), cx_list(num_uvars_in_cmnd),
     .		perm(nferdims), ws, status
* ... work arrays ...
	LOGICAL		xact_range(ws), has_size(nferdims,ws)
	INTEGER		pt_blk(ws), size(nferdims,ws), msize(ws), width(ws)
	REAL		out(ws), bad(ws)
* ss_save removed from integer declaration and put in logical decl.  *kob* 8/94	
* V500 *kob* 3/99- up VAR_CODE and vcode decl's to 64 chars and KEY_STRING
*                  to 128 and VAR_UNITS to 64
* V552 *acm* 4/03- up VAR_CODE and vcode decl's from 64 to 128 chars
* local variable declarations:
	LOGICAL		all_bad, do_unform, ss_save, do_tab_del,
     .                  do_comma_del, norow
	INTEGER		TM_LENSTR1, CGRID_AXIS, GET_MAX_STRING_LEN,
     .			GET_OFFSET_C_STRING_LEN, 
     .			w0, w, data_len, nleft, nright, alen, blen,
     .			idim, vlen, cleft, col_ax, col_dec,
     .			cx, slen1, slen2, slen3, i, 
     .			ivar, point, iwd, dset, ax, new_ax,
     .			min_width, row_ww_wid, lp, prec_digits, ww,
     .			lo(nferdims), hi(nferdims), del(nferdims), 
     .			pt(nferdims), valid_ax(nferdims)
	CHARACTER*255	VAR_TITLE, VAR_TITLE_MOD, PAREN_SURROUND, vname_buff
	CHARACTER	KEY_STRING*128, AX_TITLE*32, VAR_UNITS*64, LEFINT*8,
     .			CX_DIM_STR*16, VAR_CODE*128, TM_FMT*16,
     .			buff1*16, buff2*16, buff3*16, line_buff*2048,
     .			row_ss_fmt*14, bad_ax*5, bad_buff*32,
     .			col_head_format*32, sep*1
	REAL		big, small, biggest, value
	REAL*8		TM_WORLD
	CHARACTER	good_fmt(max_intrp)*10, bad_fmt(max_intrp)*10,
     .			vcode(max_intrp)*128, tab_or_comma*1
#ifdef DEC_FORTRAN
	INTEGER		ios
#endif
* convenience equivalence:
	INTEGER		lo1, lo2, lo3, lo4, lo5, lo6, 
     .			hi1, hi2, hi3, hi4, hi5, hi6, 
     .			del1,del2,del3,del4,del5,del6, 
     .			i1, i2, i3, i4, i5, i6
	EQUIVALENCE	
     .  (i1, pt(1)) , (i2, pt(2)) , (i3, pt(3)),  (i4,pt(4)),   (i5, pt(5)),  (i6,pt(6)),
     .  (lo1, lo(1)), (lo2, lo(2)), (lo3,lo(3)),  (lo4,lo(4)),  (lo5,lo(5)),  (lo6,lo(6)),
     .  (hi1, hi(1)), (hi2, hi(2)), (hi3,hi(3)),  (hi4,hi(4)),  (hi5,hi(5)),  (hi6,hi(6)),
     .  (del1,del(1)),(del2,del(2)),(del3,del(3)),(del4,del(4)),(del5,del(5)),(del6,del(6))

* initialize

	status		= ferr_ok
        do_unform       = list_fmt_type .EQ. plist_unformatted
	risc_buff = ' '

        do_tab_del   = list_fmt_type .EQ. plist_tab_del
        do_comma_del = list_fmt_type .EQ. plist_comma_del

        norow = qual_given(slash_list_norow) .GT. 0

        IF ( do_comma_del .OR. do_tab_del ) THEN
* ... column headings for tab and comma-delimited output (9/95)
	   IF ( do_comma_del ) THEN
	      tab_or_comma = ','
	   ELSEIF( do_tab_del ) THEN
	      tab_or_comma = CHAR(9)
           ENDIF
              
	ENDIF

* determine precision for outputting values
	lp = qual_given( slash_list_precision ) 
	IF ( lp .GT. 0 ) THEN
           CALL EQUAL_VAL( cmnd_buff(qual_start(lp):qual_end(lp)),
     .                     value, status )
           IF ( status .NE. ferr_ok ) GOTO 5000
           prec_digits = MAX(1.,MIN(value, 16.))	! 1 to 16	   
	ELSE
           prec_digits = list_digits
	ENDIF

* determine list limits checking for conformable shapes of data to list
* ... for each axis each var must be same size or length 1
	DO 10 i = 1, nferdims
	   idim = perm(i)
	   lo(i) = unspecified_int4
	   hi(i) = unspecified_int4
	   del(i)= 1
	   DO 8 ivar = 1, num_uvars_in_cmnd
	      cx = cx_list(ivar)
	      IF ( cx_lo_ss(cx,idim) .NE. cx_hi_ss(cx,idim) ) THEN
	         IF ( lo(i) .EQ. unspecified_int4 ) THEN
	            lo(i) = cx_lo_ss( cx, idim )
	            hi(i) = cx_hi_ss( cx, idim )
	         ELSEIF ( lo(i) .NE. cx_lo_ss(cx,idim)
     .		     .OR. hi(i) .NE. cx_hi_ss(cx,idim) ) THEN
	            GOTO 5020	! not conformable shapes
	         ENDIF
	      ENDIF
 8	   CONTINUE
 10	CONTINUE

* compute lengths of each variables' axes
	DO 20 i = 1, nferdims
	   idim = perm(i)
	   DO 18 ivar = 1, num_uvars_in_cmnd
	      cx = cx_list(ivar)
	      has_size( i, ivar ) = cx_hi_ss(cx,idim) .GT. cx_lo_ss(cx,idim)
	      size( i, ivar ) = cx_hi_ss(cx,idim) - cx_lo_ss(cx,idim) + 1
 18	   CONTINUE
 20	CONTINUE

* ... and total size
	DO 25 ivar = 1, num_uvars_in_cmnd
	msize(ivar) = 1
	DO 25 idim = 1, nferdims	
 25	msize(ivar) = msize(ivar) * size(idim,ivar)	

* determine which axes have unambiguous coordinates (all variables that are
* not point locations on this axis must have the same coordinates)
* create a string (bad_ax) with a list of ambiguous axes and a list, valid_ax,
* of context pointers for axes with valid lists of coordinates
	sep = ' '
	bad_ax = ' '
	slen1 = 1	! length of bad axis string
	DO 30 i = 1, nferdims
	   idim = perm(i)
	   valid_ax(i) = 0	! assume ambiguous coordinates
	   ax = mnormal
	   DO 28 ivar = 1, num_uvars_in_cmnd
	      cx = cx_list(ivar)
	      new_ax = CGRID_AXIS( idim, cx )
	      IF ( new_ax .EQ. mnormal ) GOTO 28
* ... point location context needed if all vars have point locations
	      IF ( .NOT.has_size(i,ivar) ) THEN
	         IF ( ax .EQ. mnormal ) valid_ax(i) = -cx
	         GOTO 28
	      ENDIF
	      IF ( ax .EQ. mnormal ) THEN
	         ax = new_ax
	         valid_ax(i) = cx
	      ELSEIF ( ax .NE. new_ax
     .		.OR.   cx_lo_ss(cx,idim) .NE. lo(i) ) THEN
	         valid_ax(i) = 0	! ambiguous
	         bad_ax = bad_ax(:slen1)//sep//ww_dim_name(idim)
		 sep = ','
	         slen1 = MIN( slen1 + 2, 5 )  ! bug fix 6/92
	      ENDIF
 28	   CONTINUE
 30	CONTINUE

* ... warn of ambiguous coordinates if output is not to the screen
	IF ( slen1.GT.1 .AND. ttout_lun.NE.list_lun ) THEN
	   WRITE (risc_buff, 3010) bad_ax(2:slen1)
	   CALL SPLIT_LIST
     .		(pttmode_bull, ttout_lun, risc_buff, 0)
	   risc_buff = ' '
	ENDIF
	   
* (for optimization) which variables are full sized ?
	DO 40 ivar = 1, num_uvars_in_cmnd
	   cx = cx_list(ivar)
	   xact_range(ivar) = .TRUE.
	   DO 38 i = 1, nferdims
	      idim = perm(i)
	      IF ( lo(i) .EQ. hi(i) ) GOTO 38
	      IF ( cx_lo_ss(cx,idim) .NE. lo(i)
     .	      .OR. cx_hi_ss(cx,idim) .NE. hi(i) ) THEN
	         xact_range(ivar) = .FALSE.
	         GOTO 40
	      ENDIF
 38	   CONTINUE
 40	CONTINUE

* (for optimization) save stuff
	DO 50 ivar = 1, num_uvars_in_cmnd
	   cx = cx_list(ivar)
	   vcode(ivar)  = VAR_CODE( cx_category(cx), cx_variable(cx) )
	   bad(ivar)    = mr_bad_data(  mr_list(ivar) )
 50	CONTINUE

* * * * * * WRITE INTRODUCTORY LINES * * * * *
	IF ( do_unform .OR. .NOT.heading ) GOTO 200

* ... begin with warning if coordinates are ambiguous
	IF ( slen1 .GT. 1 ) THEN
	   WRITE ( risc_buff, 3010 ) bad_ax(2:slen1)
	   CALL SPLIT_LIST
     .		(pttmode_bull, list_lun, risc_buff, 0)
	   risc_buff = ' '
	ENDIF
 3010	FORMAT (' WARNING: Listed variables have ambiguous ',
     .            'coordinates on axes:',A)

* ... summarize what the contexts have in common
	CALL GRP_CX_DOC( cx_list, num_uvars_in_cmnd, cx_buff, cx_xtra_doc )

* ... data set information for all variables
	dset = cx_data_set( cx_buff )
	IF (  dset .NE. unspecified_int4
     .	.AND. dset .NE. pdset_irrelevant ) THEN
* ... name of data set
	   CALL GET_DSET_NAME( dset, line_buff, alen )
	   CALL SPLIT_LIST(pttmode_explct, list_lun,
     .		'             DATA SET: '//line_buff(:alen), alen+23)
 3020	   FORMAT( 13X,A)
* ... title of data set
	   CALL GET_DSET_TITLE( dset, line_buff, alen )
	   IF ( alen .GT. 1 ) CALL SPLIT_LIST(pttmode_explct, list_lun,
     .		'             '//line_buff(:alen), alen+13)
	ENDIF

* ... location information in common for all variables
	DO 70 i = 1, nferdims
	   idim = perm(i)
	   cx = ABS( valid_ax(i) )
           IF ( cx .LE. 0 ) GOTO 70     !  6/92 bug fix
	   IF ( cx_lo_ww(idim,cx_buff).EQ.unspecified_val8
     .	   .OR. cx_lo_ww(idim,cx_buff).EQ.unspec_val8_2 ) GOTO 70
	   CALL ASCII_LIMITS( cx_buff, idim, line_buff, vlen )
	   col_head_format = AX_TITLE( idim, cx_grid(cx), alen )
	   CALL SPLIT_LIST(pttmode_explct, list_lun,
     .		'             '//col_head_format( :alen )//
     .				': '// line_buff(1:vlen), 0)
 70	CONTINUE

* ... then variable titles and any special limits or data set for a variable
	DO 60 ivar = 1, num_uvars_in_cmnd
	   cx = cx_list(ivar)
	   line_buff = vcode(ivar)
	   alen = TM_LENSTR1( vcode(ivar) )
	   IF ( INDEX(line_buff(:alen),'#') .EQ. 0 ) line_buff =
     .				KEY_STRING(cx, cx_xtra_doc, alen )
	   vname_buff   = VAR_TITLE( cx )
	   vlen   = TM_LENSTR1( vname_buff )
	   vname_buff   = vname_buff(:vlen)//' '//
     .			PAREN_SURROUND(VAR_UNITS(cx), slen1)
	   vlen = vlen+1+slen1
	   vname_buff   =  vname_buff(:vlen)//
     .			PAREN_SURROUND(VAR_TITLE_MOD(cx),slen2)
	   vlen = vlen+slen2
	   risc_buff = ' '

	   bad_buff = ' '
	   blen = 1
! do not write a bad-flag notation for string variables.
           IF ((do_comma_del .OR. do_tab_del) .AND. 
     .         (mr_type(mr_list(ivar)) .NE. ptype_string)) THEN
             bad_buff = '   BAD FLAG : '// 
     .                  TM_FMT(bad(ivar),prec_digits,16,blen)
             blen = blen + 14
           ENDIF

	   IF ( line_buff(:vlen) .EQ. vname_buff(:vlen) ) THEN
	      WRITE ( risc_buff, 3028 ) ivar, line_buff(:alen), 
     .           bad_buff(:blen)
	      CALL SPLIT_LIST(pttmode_explct, list_lun, risc_buff, 0)
 3028         FORMAT (' Column',I3,': ',A, A) 
	   ELSE	      
	      WRITE ( risc_buff, 3030 ) ivar,
     .           line_buff(:alen), vname_buff(:vlen),bad_buff(:blen)
	      CALL SPLIT_LIST(pttmode_explct, list_lun, risc_buff, 0)
 3030	      FORMAT (' Column',I3,': ',A,' is ',A, A)
	   ENDIF
 60	CONTINUE

* * * * * LIST DATA UNFORMATTED OR WITH USER FORMAT (no frills)
* Note: cannot direct user format to GUI because records may be
* arbitrarily long
 200	IF ( do_unform .OR. list_format_given ) THEN
	   point = 0
	   DO 300 i6 = lo6, hi6, del6
	   DO 300 i5 = lo5, hi5, del5
	   DO 300 i4 = lo4, hi4, del4
	   DO 300 i3 = lo3, hi3, del3
	   DO 300 i2 = lo2, hi2, del2
	   DO 300 i1 = lo1, hi1, del1
	      IF ( interrupted ) RETURN
* default memory pointer for full-region variables
	      point = point + 1

* loop through all variables for each record
	      DO 250 ivar = 1, num_uvars_in_cmnd
	         IF (mr_type(mr_list(ivar)) .EQ. ptype_string) GOTO 5040
* ... optimized calculation for full-region variables
	         IF ( xact_range(ivar) ) THEN
	            out(ivar) = memry(mr_list(ivar))%ptr(point)
	         ELSE
* ... separate pointer calcs for non-full region variables
* ... e.g. a 2D field listed with a 3D will replicate at each 3rd-D location
	            iwd = 0
	            IF ( has_size(nferdims,ivar) ) iwd = (pt(nferdims)-lo(nferdims))
	            DO 240 i = nferdims-1, 1, -1
	            iwd = iwd*size(i,ivar)
		    IF ( has_size(i,ivar) ) iwd = iwd + (pt(i)-lo(i))
 240	            CONTINUE
	            out(ivar) = memry(mr_list(ivar))%ptr(iwd+1)
	         ENDIF
 250	      CONTINUE
	      IF ( do_unform ) THEN
	         WRITE (list_lun, ERR=5010)
     .			( out(ivar),ivar = 1, num_uvars_in_cmnd )
	      ELSE

	         WRITE (list_lun, list_format, ERR=5010)
     .			( out(ivar),ivar = 1, num_uvars_in_cmnd )
	      ENDIF
 300	   CONTINUE
* done - go home
	   RETURN
	ENDIF

* * * * PREPARE FORMATS ADAPTED TO THE DATA AND AXIS RANGES
* ... coordinate labelling at left of each record
	col_ax = perm(1)
	cx = valid_ax(1)
	CALL ROW_COORD_FMT( col_ax, cx, lo(1), hi(1), 1,
     .			    row_ss_fmt, col_dec, row_ww_wid, cleft )
	data_len = 0
        IF (norow) cleft = 0

* ... column labelling - variable codes for headings - FORTRAN formats for data
	DO 400 ivar = 1, num_uvars_in_cmnd

* ... determine numeric format to fit nicely in each field
* ... first find largest value to be printed
	   IF ( mr_type(mr_list(ivar)) .EQ. ptype_string ) THEN
	       nleft = GET_MAX_STRING_LEN(cx_list(ivar),
     .					  mr_list(ivar),
     .					  memry(mr_list(ivar))%ptr )
	   ELSE 
	      CALL MINMAX( memry(mr_list(ivar))%ptr, msize(ivar),
     .			   bad(ivar), small, big )
	      all_bad = small .EQ. arbitrary_large_val4

* . . . how many digits right and left of decimal point ?
	      biggest = MAX( ABS( small ), big )
	      CALL GET_SIG_DIGITS( biggest, prec_digits, nleft, nright )
	      nleft = MAX( 1, nleft )			! at least "0" to left
	   ENDIF

* ... field must be wide enough to accomodate the variable code heading
*     (to a max of 8 characters)
	   min_width = MIN( 8, TM_LENSTR1( vcode(ivar) ) + 1 )

* . . . determine FORTRAN format for listing of this variable
	   IF ( mr_type(mr_list(ivar)) .EQ. ptype_string ) THEN
              width(ivar) = MIN(nleft+3, 1020)  ! arbitrary 1020 char max   
	   ELSEIF ( all_bad ) THEN
	      width(ivar) = MAX(min_width, 5)
	      WRITE ( bad_fmt(ivar), 3002 ) 5
 3002	FORMAT ( '(A',I2,')' )	
	   ELSE
	      CALL VAR_DATA_FMT( nleft, nright, prec_digits, min_width,
     .			         width(ivar), good_fmt(ivar), bad_fmt(ivar) )
	   ENDIF

	   data_len = data_len + width(ivar)

 400	CONTINUE

* . . . will it fit ?
	IF ( data_len .GT. line_length-cleft ) GOTO 5030
	
* . . . write a heading line of variable codes
	IF ( heading ) THEN
           line_buff = ' '

           IF (do_comma_del .OR. do_tab_del) THEN
* ... Write entire variable names without cutting them off.

              slen1 = TM_LENSTR1( vcode(1) )
	      w0 = cleft - slen1 + MIN(width(1), slen1)
              IF (w0 .LE. 0 .OR. cleft .EQ. 0) w0 = 1
              DO 420 ivar = 1, num_uvars_in_cmnd

                 slen1 = TM_LENSTR1(vcode(ivar))
                 line_buff(w0:w0+slen1) = vcode(ivar)(:slen1)

                 IF (ivar .LT. num_uvars_in_cmnd)
     .              line_buff(w0+slen1:w0+slen1) = tab_or_comma
                 w0 = w0 + slen1 + 1
 420	      CONTINUE

           ELSE
* ... Not tab or comma delimited: use width of each field
 
	      w0 = cleft
	      slen1 = MIN( w0, TM_LENSTR1( vcode(1) ) )
              IF (cleft .EQ. 0) slen1 = TM_LENSTR1( vcode(1) )
	      w0 = w0 + width(1)
	      line_buff(w0-slen1:w0-1) = vcode(1)(:slen1)
              w0 = w0 + 1
              IF (num_uvars_in_cmnd .GT. 1) line_buff(w0:w0) = ' '

	      DO 421 ivar = 2, num_uvars_in_cmnd
                 line_buff(w0:w0) = ' '

                 slen2 = 0
                 IF ( TM_LENSTR1(vcode(ivar)) .LT. width(ivar) ) 
     .               slen2 = (width(ivar) - TM_LENSTR1(vcode(ivar)))/2
                 line_buff(w0+1+slen2:w0+width(ivar)) = vcode(ivar)

                 IF (ivar .EQ. num_uvars_in_cmnd)
     .              line_buff(w0+1+slen2:) = vcode(ivar)
                 w0 = w0 + width(ivar)
 421	      CONTINUE

           ENDIF


           w0 = TM_LENSTR1(line_buff) 
	   CALL SPLIT_LIST(pttmode_explct, list_lun, line_buff(1:w0), w0)
	ENDIF
        line_buff = ' '

* * * * *  WRITE FORMATTED DATA LINES * * * * *
* each line has format: "coord/sub: data1 data2 data3 ..."
* for a 1D field a single block of such lines is printed
* for a 2D field each block is separated by an identifier of the 3rd axis
* for a 3D field each block of blocks is further separated and identified
* etc. for a 4D field

* If the /NOROWLAB qualifier was given, do not do the "coord/sub:" on each data line

 3050   FORMAT (1X,4('-'),1X,A)
	point = -1
	DO 600 i6 = lo6, hi6, del6
* label the block of block of blocks (6th dimension)
	   risc_buff = ' '
	   IF ( hi6 .GT. lo6 ) THEN
	      CALL POS_LAB( i6, valid_ax(6), perm(6),
     .			    ax_dec_pt(perm(6)), line_buff, alen )
	      WRITE (risc_buff, 3050) line_buff(:alen)
	      CALL SPLIT_LIST(pttmode_explct, list_lun, risc_buff, 0)
	   ENDIF
	DO 600 i5 = lo5, hi5, del5
* label the block of block of blocks (5th dimension)
	   risc_buff = ' '
	   IF ( hi5 .GT. lo5 ) THEN
	      CALL POS_LAB( i5, valid_ax(5), perm(5),
     .			    ax_dec_pt(perm(5)), line_buff, alen )
	      WRITE (risc_buff, 3050) line_buff(:alen)
	      CALL SPLIT_LIST(pttmode_explct, list_lun, risc_buff, 0)
	   ENDIF
	DO 600 i4 = lo4, hi4, del4
* label the block of block of blocks (4th dimension)
	   risc_buff = ' '
	   IF ( hi4 .GT. lo4 ) THEN
	      CALL POS_LAB( i4, valid_ax(4), perm(4),
     .			    ax_dec_pt(perm(4)), line_buff, alen )
	      WRITE (risc_buff, 3050) line_buff(:alen)
	      CALL SPLIT_LIST(pttmode_explct, list_lun, risc_buff, 0)
	   ENDIF
	DO 600 i3 = lo3, hi3, del3
* label the block of blocks (3rd dimension)
	   IF ( hi3 .GT. lo3 ) THEN
	      CALL POS_LAB( i3, valid_ax(3), perm(3),
     .			    ax_dec_pt(perm(3)), line_buff, alen )
	      WRITE (risc_buff, 3050) line_buff(:alen)
	      CALL SPLIT_LIST(pttmode_explct, list_lun, risc_buff, 0)
	   ENDIF
	DO 600 i2 = lo2, hi2, del2
* label the block of blocks (3rd dimension)
	   IF ( hi2 .GT. lo2 ) THEN
	      CALL POS_LAB( i2, valid_ax(2), perm(2),
     .			    ax_dec_pt(perm(2)), line_buff, alen )
	      WRITE (risc_buff, 3050) line_buff(:alen)
	      CALL SPLIT_LIST(pttmode_explct, list_lun, risc_buff, 0)
	   ENDIF
	DO 600 i1 = lo1, hi1, del1
           line_buff = ' '
	   IF ( interrupted ) RETURN

*  create carefully sized label for this row
	   cx = valid_ax(1)

           IF (.NOT. norow) THEN
	      IF ( cx .GT. 0 ) THEN
	         CALL TRANSLATE_TO_WORLD( 
     .			TM_WORLD( i1, cx_grid(cx), perm(1), box_middle ),
     .			perm(1), cx_grid(cx), col_dec, line_buff(:row_ww_wid) )
	         WRITE ( line_buff(row_ww_wid+1:cleft), row_ss_fmt ) i1
	      ELSE
	         line_buff(1:1) = ss_dim_name(perm(1))
	         IF ( i1 .NE. unspecified_int4 ) THEN
	            WRITE ( line_buff(2:cleft), row_ss_fmt ) i1	! e.g. "I / 15:"
	         ELSE
	            line_buff(2:) = ' / *:'			! e.g. "I / *:"
	         ENDIF 
	      ENDIF
           ENDIF
           w0 = cleft

* default memory pointer for full-region variables
	   point = point + 1

* loop through all variables for each record
           ww = w0 + 1
	   DO 550 ivar = 1, num_uvars_in_cmnd
	      w = w0 + width(ivar) ! points to last column of field
	      IF ( mr_type(mr_list(ivar)) .EQ. ptype_string ) THEN
* ... string variable
	         IF ( xact_range(ivar) ) THEN
	            iwd = point
                 ELSE	
	            iwd = 0
	            IF ( has_size(nferdims,ivar) ) iwd = (pt(nferdims)-lo(nferdims))
	            DO 530 i = nferdims-1, 1, -1
                       iwd = iwd*size(i,ivar)
                       IF ( has_size(i,ivar) ) iwd = iwd + (pt(i)-lo(i))
 530	            CONTINUE
	         ENDIF

                 IF (do_comma_del .OR. do_tab_del) THEN
* ... tab or comma formatting
                    line_buff(ww:ww) = '"'
	            slen1 = GET_OFFSET_C_STRING_LEN(mr_c_pointer(mr_list(ivar)),
     .					 iwd )
	            CALL GET_OFFSET_C_STRING(mr_c_pointer(mr_list(ivar)),
     .				   iwd,
     .				   line_buff(ww+1:),
     .				   slen1    )
                    line_buff(ww+slen1+1:ww+slen1+1) = '"'

                    IF (ivar .LT. num_uvars_in_cmnd) 
     .                 line_buff(ww+slen1+2:ww+slen1+2) = tab_or_comma
                    ww = ww + slen1 + 3
                    w = ww               
                 ELSE
* ... not tab or comma formatting

	            line_buff(w0+2:w0+2) = '"'
	            line_buff(w0+3:w) = ' '
	            slen1 = GET_OFFSET_C_STRING_LEN(mr_c_pointer(mr_list(ivar)),
     .		  			 iwd )
	            CALL GET_OFFSET_C_STRING(mr_c_pointer(mr_list(ivar)),
     .				   iwd,
     .				   line_buff(w0+3:),
     .				   width(ivar)-2     )

	            IF (slen1 .GT. width(ivar)-2) THEN
	               line_buff(w-3:w) = '..."'
	            ELSE
	               line_buff(w0+slen1+3:w0+slen1+3) = '"'
	            ENDIF
                 ENDIF  ! tab-or-comma
	      ELSE
* ... numerical variable
* ... optimized calculation for full-region variables
	        IF ( xact_range(ivar) ) THEN
	           out(ivar) = memry(mr_list(ivar))%ptr(point+1)
	        ELSE
* ... separate pointer calcs for non-full region variables
* ... e.g. a 2D field listed with a 3D will replicate at each 3rd-D location
	           iwd = 0
	           IF ( has_size(nferdims,ivar) ) iwd = (pt(nferdims)-lo(nferdims))
	           DO 540 i = nferdims-1, 1, -1
	           iwd = iwd*size(i,ivar)
	           IF ( has_size(i,ivar) ) iwd = iwd + (pt(i)-lo(i))
 540	           CONTINUE
	           out(ivar) = memry(mr_list(ivar))%ptr(iwd+1)
	        ENDIF
	        IF ( out(ivar) .EQ. bad(ivar) ) THEN
                   IF (do_comma_del .OR. do_tab_del) THEN
                       line_buff = line_buff(:ww-1)//
     .	                   TM_FMT(out(ivar),prec_digits,16,vlen)
                       IF (ivar .LT. num_uvars_in_cmnd) 
     .                   line_buff(ww+vlen:ww+vlen) = tab_or_COMMA
     	               ww = ww+vlen+1
                       w = ww
                   ELSE
	              WRITE(line_buff(w0+1:w),bad_fmt(ivar)) '....'
                   ENDIF
	        ELSE
                   IF (do_comma_del .OR. do_tab_del) THEN
* ... tab or comma formatting
                       line_buff = line_buff(:ww-1)//
     .	                   TM_FMT(out(ivar),prec_digits,16,vlen)
                       IF (ivar .LT. num_uvars_in_cmnd) 
     .                   line_buff(ww+vlen:ww+vlen) = tab_or_COMMA
     	               ww = ww+vlen+1
                       w = ww
                    ELSE
	              WRITE(line_buff(w0+1:w),good_fmt(ivar)) out(ivar)
                    ENDIF
	        ENDIF
	      ENDIF
	      w0 = w

 550	   CONTINUE

* write the fully formatted line
           IF (do_comma_del .OR. do_tab_del) w0 = ww
	   CALL SPLIT_LIST(pttmode_explct, list_lun, line_buff, w0)
           line_buff = ' '
 600	   CONTINUE

* successful completion
	RETURN

* error exits
 5000	RETURN
 5010	CALL ERRMSG( ferr_erreq, status, list_format, *5000 )
 5020	ss_save = cx_by_ss(idim,cx)
	cx_by_ss(idim,cx) = .TRUE.
	buff1 = CX_DIM_STR( idim,cx,':',no_decims,slen1 )
	cx_by_ss(idim,cx) = ss_save
	cx_by_ss(idim,cx_buff) = .TRUE.
	cx_lo_ss(cx_buff,idim) = lo(i)
	cx_hi_ss(cx_buff,idim) = hi(i)
	buff2 = CX_DIM_STR( idim,cx_buff,':',no_decims,slen2 )
	buff3 = LEFINT(ivar,slen3)
	CALL ERRMSG( ferr_inconsist_plane, status,
     .		ww_dim_name(idim)//' axis'//pCR//
     .		'Variable '//buff3(:slen3)//' is '//buff1(:slen1)//pCR//
     .		'expression is '//buff2(:slen2), *5000 )
 5030	CALL ERRMSG( ferr_invalid_command, status,
     .		'list of variables too long for output lines'//pCR//
     .		'Reduce SET LIST/PRECISION or specify /FORMAT', *5000 )
 5040	CALL ERRMSG( ferr_invalid_command, status,
     .		'format disallowed for multiple variables w/ strings',
     .		*5000 )
	END

C XXXX-XXX (C) COPYRIGHT IBM CORPORATION 1988
C LICENSED MATERIALS - PROPERTY OF IBM
C REFER TO COPYRIGHT INSTRUCTIONS FORM NUMBER G120-2083
C
C IBM CONFIDENTIAL
C
C FORTRAN to C binding for XGKS
C
C    inqlun 
C
C Todd Gill
C TCS Development
C Cambridge MA
C
C $Id$
C $__Header$
C
C Return the name associated with a Fortran Logical Unit Number.
C Close the file if it's open.
C 
	SUBROUTINE INQLUN(LUN)
	INTEGER LUN
	LOGICAL NAMED,OPENED
	CHARACTER*(255) FNAME
	INQUIRE(UNIT=LUN,NAME=FNAME,NAMED=NAMED,OPENED=OPENED)
	IF (OPENED.AND.NAMED) CLOSE(UNIT=LUN)
	IF (NAMED) CALL SET_FNAME(FNAME)
	RETURN
	END

	INTEGER FUNCTION DSG_WHATS_IT ( grid )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine the DSG-ness of this grid.  It may be a
*    - non-DSG
*    - DSG instance variable
*    - DSG contiguous ragged array

* V720 *sh* 4/17

      include 'tmap_dims.parm'
      include 'implicit.parm'
      include 'ferret.parm'
      include 'xtm_grid.cmn_text'
      include 'xdset_info.cmn_text'
      include 'xfr_grid.cmn'

* argument declarations
	INTEGER grid

* internal variable declarations
	INTEGER line, dset, orient

* the test of DSG-ness is line_dsg_dset points to dset on the E axis
	line = grid_line(e_dim,grid)
	IF (line .EQ. mnormal) THEN
	   DSG_WHATS_IT = pdsg_not_dsg
	   RETURN
	ENDIF
	dset = line_dsg_dset(line)
	IF (dset .EQ. pline_not_dsg) THEN
	   DSG_WHATS_IT = pdsg_not_dsg
	   RETURN
	ENDIF

* we are looking at a DSG grid
* the test for contiguous ragged is the existence of a feature axis
* with line_dsg_dset == the dset
* For user-variables that use some grid-changin functions, the
* result is defined as having abstract axes (e.g. STRINDEX(expocode, "PAN")
* has an abstract axis in axes other than the E axis that it gets from expocode.


	orient = dsg_orientation(dset)
	line = grid_line(orient,grid)
	IF (grid_line(orient,grid) .EQ. mnormal  .OR. 
     .      grid_line(orient,grid) .EQ. grid_line(1,mgrid_xabstract)) THEN
	   DSG_WHATS_IT = pdsg_instance
	ELSEIF (line_dsg_dset(line) .EQ. pline_not_dsg) THEN
	   DSG_WHATS_IT = pdsg_not_dsg
	ELSE
	   DSG_WHATS_IT = pdsg_observation
	ENDIF

	IF (orient .EQ. e_dim) DSG_WHATS_IT = pdsg_instance

        RETURN
        END

	LOGICAL FUNCTION MATCH_QUOTED_NAME ( test_string, len_test, model_string, len_model_chars)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* check to see if test string is same as model string to full length of model
* string
* model string must be all upper case - test string ignores case
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 5/1/86
* revision 0.1 - 12/9/86 - allowed model_string of arbitrary length
* V495: 7/7/98 - *sh* if test name is in single quotes use case-sensitive comp.
*     : 9/30/98 - NAG F90 (linux) received error on above change.  
*                 need to put single  tick between double quotes  *kob*
* ywei 05/04   changed function prototype to allow speed up
*              before calling this function, make sure
*              len_test = TM_LENSTR(test_string)
*              len_model_chars = TM_LENSTR(model_string)
* 2/15 *sh* added support for _SQ_

* calling argument declarations:
	CHARACTER*(*)	model_string
	CHARACTER*(*)	test_string
        INTEGER         len_test
        INTEGER         len_model_chars

* internal variable declarations:
	LOGICAL         is_quoted, is_SQ
	INTEGER		len_model, i, len_test1
        LOGICAL         result

	len_model	= LEN( model_string )

* (7/98) is test string in quotations?

	is_quoted = test_string(1:1) .EQ. "'" 
	IF (is_quoted) is_quoted = test_string(len_test:len_test) .EQ. "'"
	IF (is_quoted) THEN
           len_test1 = len_test - 2
        ELSE
           len_test1 = len_test
        ENDIF

* _SQ_ as a possible substitute for "'"
	is_SQ = .FALSE.
	IF  ( test_string(1:1) .EQ. "_"
     .  .AND. len_test .GE. 8           ) THEN
	   is_SQ = test_string(1:4) .EQ. "_SQ_" 
	   IF (is_SQ) is_quoted = test_string(len_test-3:len_test)
     .				      .EQ. "_SQ_"
	   IF (is_SQ) len_test1 = len_test - 8
	ENDIF

* test string cannot be shorter than model or longer than fully terminated model
	IF (   len_test1       .LT. len_model_chars
     .	 .OR.( len_model_chars .LT. len_model		! fully terminated ?
     .	 .AND. len_test1       .GT. len_model_chars )	) GOTO 200


	IF (is_quoted) THEN
	   IF (model_string(1:len_model_chars)
     .	  .NE. test_string (2:len_model_chars+1)) GOTO 200
	ELSEIF (is_SQ) THEN
	   IF (model_string(1:len_model_chars)
     .	  .NE. test_string (5:len_model_chars+4)) GOTO 200
	ELSE
! sic - "tm_match_captial_name" is found in file tm_match_capital_name.c
           CALL tm_match_captial_name(test_string, model_string, 
     .          len_model_chars, result)
           IF(.NOT.result) GOTO 200	   
	ENDIF

* it matches
	MATCH_QUOTED_NAME = .TRUE.
	RETURN

* it doesn't match
 200	MATCH_QUOTED_NAME = .FALSE.
	RETURN

	END

	SUBROUTINE SHOW_1_FUNCTION( lun, its_gc, brief, detail, ifcn )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* output a text description about the specified function

* there are 3 classes of functions:
*  classic internal Ferret functions (non-grid-changing) e.g. SIN(X)
*  internal grid-changing functions
*  external grid changing functions

* programmer - steve hankin

* V450: 7/97
* 97.07.30 *jc* added code to enable external functions
* V500: 1/99 *sh* added support for string arguments to functions
* V510: 5/00 *sh* added argument "detail"
* V620:11/08 acm* On a show func/detail, list the alternative 
*                 function for other arg types, if it exists.
* V664  9/10 *kms* Increase slen and size of ef_descr to 128 to match
*                  the size of gfcn_descr and gfcn_arg_descr
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V6.8  acm  6/12 Implement mode_6d_lab, set by default. If cancelled, the 
*                 various SHOW commnands will not list info for E,F dimensions.
* V7    acm  6/16 Ticket 2437: Deprecating mode_6d_lab. 
*		  Adjust output to 6-D or 4-D grids

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'grid_chg_fcns.parm'
	include	'xalgebra.cmn'
	include	'xgrid_chg_fcns.cmn'
	include	'xtext_info.cmn'
	include	'xrisc.cmn'
	include 'xprog_state.cmn'

* calling argument declarations:
	LOGICAL	its_gc, brief, detail
	INTEGER	lun, ifcn
	
* local variable declarations:
	LOGICAL	its_reshape
	INTEGER TM_LENSTR, TM_LENSTR1, GCF_ARG_TYPE, GCF_FIND_FCN,
     .		ll, ll2, llsave, itype, narg, i, iarg, iarg2, idim
	CHARACTER units*40, gcf_name*40, ef_arg_name*40, ef_descr*128, 
     .		ef_units*40, ax_remark*64, alt_name*40
	INTEGER EFCN_SCAN, EFCN_GET_NUM_REQD_ARGS, EFCN_GATHER_INFO,
     .		axis_will_be(6), ifcn_alt

* local parameter definitions
	CHARACTER*4 indent
	PARAMETER ( indent = '    ' )
        INTEGER      slen
        PARAMETER  ( slen = 128 )

#ifdef sun
        BYTE      fhol(slen)    ! c-type Hollerith string buffer
#else
        INTEGER*1 fhol(slen)    ! c-type Hollerith string buffer
#endif
 
* initialize
	len_rbuff = LEN(risc_buff)	! maximum length
	its_reshape = ifcn .EQ. p_reshape

* 1st line -- function name with args in parens
* ... name
	IF ( .NOT.its_gc ) THEN
	   risc_buff = alg_fcn(ifcn)
	   narg = alg_num_fcn_args(ifcn)
	   iarg = alg_fcn_arg_ptr(ifcn)
	ELSEIF ( ifcn .LE. gfcn_num_internal ) THEN
	   risc_buff = gfcn_name(ifcn)
	   narg = gfcn_num_reqd_args(ifcn)
	   iarg = gfcn_arg_ptr(ifcn)
	ELSE
	   IF ( efcn_scan(gfcn_num_internal) .EQ. 0 ) THEN
	      ! JC_TODO: what if no external functions are found?
	      STOP 'no external functions found'
	   ELSE
	      IF ( efcn_gather_info(ifcn) .ne. 0 ) THEN
		 RETURN
	      ENDIF
	      risc_buff = gcf_name(ifcn)
	      narg = efcn_get_num_reqd_args(ifcn)
	      iarg = 1
	   ENDIF
	ENDIF

* ... open paren
	ll = TM_LENSTR1(risc_buff)
	risc_buff = risc_buff(:ll)//'('
	ll = ll + 1
	IF ( ll .GE. len_rbuff ) GOTO 200   ! undetected (unlikely) error

* ... first argument
	IF ( .NOT.its_gc ) THEN
	   risc_buff = risc_buff(:ll) // alg_arg_name(iarg)
	ELSEIF ( ifcn .LE. gfcn_num_internal ) THEN
	   risc_buff = risc_buff(:ll) // gfcn_arg_name(iarg)
	ELSE
           call efcn_get_arg_name(ifcn, iarg, fhol)
           call TM_CTOF_STRNG( fhol, ef_arg_name, slen)
	   risc_buff = risc_buff(:ll) // ef_arg_name
	ENDIF
	ll = TM_LENSTR1(risc_buff)
	IF ( ll .GE. len_rbuff ) GOTO 200   ! undetected (unlikely) error

* ... additional arguments, if any
        iarg2 = iarg
	DO 100 i = 2, narg
	   iarg2 = iarg2 + 1      ! point to next arg
	   risc_buff = risc_buff(:ll) // ','
	   ll = ll + 1
	   IF ( .NOT.its_gc ) THEN
	      risc_buff = risc_buff(:ll) // alg_arg_name(iarg2)
	   ELSEIF ( ifcn .LE. gfcn_num_internal ) THEN
	      risc_buff = risc_buff(:ll) // gfcn_arg_name(iarg2)
	   ELSE
	      call efcn_get_arg_name(ifcn, iarg2, fhol)
	      call TM_CTOF_STRNG( fhol, ef_arg_name, slen)
	      risc_buff = risc_buff(:ll) // ef_arg_name
	   ENDIF
	   ll = TM_LENSTR1(risc_buff)
	   IF ( ll .GE. len_rbuff ) GOTO 200   ! truncation error
 100	CONTINUE

* ... closing parenthesis
	risc_buff = risc_buff(:ll)//')'
	ll = ll + 1

* ... write out the function name with its args
 200	CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, ll)
	IF ( brief ) RETURN

* write 2nd line (if available) -- description of function
	IF ( .NOT.its_gc ) THEN
	   risc_buff = alg_fcn_descr(ifcn)
	ELSEIF ( ifcn .LE. gfcn_num_internal ) THEN
	   risc_buff = gfcn_descr(ifcn)
	ELSE
	   call efcn_get_descr(ifcn, fhol)
	   call TM_CTOF_STRNG( fhol, ef_descr, slen)
	   risc_buff = ef_descr
	ENDIF
	IF ( risc_buff .NE. ' ') CALL SPLIT_LIST
     .			(pttmode_explct, lun, indent//risc_buff, 0)

* tell about the result grid
	IF ( its_gc .AND. detail ) THEN
	   CALL SPLIT_LIST( pttmode_explct, lun,
     .		'        Axes of result:', 23)
	   IF ( ifcn .LE. gfcn_num_internal ) THEN
	      DO 210 idim = 1, nferdims
 210          axis_will_be(idim) = gfcn_axis_will_be(idim,ifcn)
	   ELSE
	      CALL EFCN_GET_AXIS_WILL_BE(ifcn, axis_will_be)
	   ENDIF
	   DO 220 idim = 1, nferdims
	      IF (its_reshape) THEN
	         ax_remark = 'inferred from argument B'
	      ELSEIF (axis_will_be(idim) .EQ. pgc_axis_is_abstract) THEN
                 ax_remark =
     .			'ABSTRACT (result will occupy indices 1...N)'
	      ELSEIF(axis_will_be(idim) .EQ. pgc_axis_is_normal) THEN
                 ax_remark = 'NORMAL (no axis)'
	      ELSEIF (axis_will_be(idim) .EQ. pgc_axis_implied_by_args) THEN
                 ax_remark = 'inherited from argument(s)'
	      ELSEIF (axis_will_be(idim) .EQ. pgc_axis_supplied_herein) THEN
	         ax_remark = 'created by this function'
	      ELSE
	         ax_remark = '???'
	      ENDIF
	      CALL SPLIT_LIST (pttmode_explct, lun,
     .		'          '//ww_dim_name(idim)//': '//ax_remark, 0)
 220	   CONTINUE
	ENDIF

* write list of arguments and their definitions
* ... "argname: description (units)"
	DO 500 i = 1, narg
* ... arg name
	   IF ( .NOT.its_gc ) THEN
	      risc_buff = alg_arg_name(iarg)
	   ELSEIF ( ifcn .LE. gfcn_num_internal ) THEN
	      risc_buff = gfcn_arg_name(iarg)
	   ELSE
	      call efcn_get_arg_name(ifcn, iarg, fhol)
	      call TM_CTOF_STRNG( fhol, ef_arg_name, slen)
	      risc_buff = ef_arg_name
	   ENDIF
	   ll = TM_LENSTR1(risc_buff)
	   IF ( ll .GE. len_rbuff ) GOTO 400   ! truncation error
* ... arg description
	   risc_buff = risc_buff(:ll) //': '
	   llsave = ll + 1		! save length of "arg:"
	   IF ( .NOT.its_gc ) THEN
	      risc_buff = risc_buff(:ll+2) // alg_arg_descr(iarg)
	   ELSEIF ( ifcn .LE. gfcn_num_internal ) THEN
	      risc_buff = risc_buff(:ll+2) // gfcn_arg_descr(iarg)
	   ELSE
	      call efcn_get_arg_desc(ifcn, iarg, fhol)
	      call TM_CTOF_STRNG( fhol, ef_descr, slen)
	      risc_buff = risc_buff(:ll+2) // ef_descr
	   ENDIF
* ... arg units
	   IF ( .NOT.its_gc ) THEN
	      units = alg_arg_units(iarg)
	   ELSEIF ( ifcn .LE. gfcn_num_internal ) THEN
	      units = gfcn_arg_units(iarg)
	   ELSE
	      call efcn_get_arg_unit(ifcn, iarg, fhol)
	      call TM_CTOF_STRNG( fhol, ef_units, slen)
	      units = ef_units
	   ENDIF
	   ll2 = TM_LENSTR(units)
	   IF ( ll2 .GT. 0 ) THEN
	      ll = TM_LENSTR1(risc_buff)
	      IF ( ll .GE. len_rbuff ) GOTO 400   ! truncation error
	      risc_buff = risc_buff(:ll) // ' (' //units(:ll2) //')'
	   ENDIF
	   ll = TM_LENSTR1(risc_buff)
* ... data type (if STRING)
	   IF ( .NOT.its_gc ) THEN
	      itype = parg_type_float
	   ELSE
	      itype = GCF_ARG_TYPE(ifcn, i)
	   ENDIF
	   IF (itype .EQ. parg_type_string) THEN
	       risc_buff = risc_buff(:ll) // ' (STRING)'
	   ELSE
	       IF (detail) risc_buff = risc_buff(:ll) // ' (FLOAT)'
	   ENDIF
	   ll = TM_LENSTR1(risc_buff)

* ... write the line
 400	   IF (ll .GT. llsave) CALL SPLIT_LIST
     .			(pttmode_explct, lun, indent//risc_buff, 4+ll)

* tell how the grid inheritance works
	IF ( its_gc .AND. detail ) THEN
	   CALL SPLIT_LIST( pttmode_explct, lun,
     .			'        Influence on output axes:', 0)
	   CALL GCF_GET_AXIS_SRCS(ifcn, i, axis_will_be)
	   DO 420 idim = 1, nferdims
	      IF (its_reshape) THEN
	         IF (i .EQ. 1) THEN
	            ax_remark =
     .	'none (if axis doesnt match B indicate arg limits with "[]")'
	         ELSE
	            ax_remark =
     .	'passed to result grid (use [] limits to define output region)'
	         ENDIF
	      ELSEIF (axis_will_be(idim) .EQ. pgc_merge_axis ) THEN
                 ax_remark = 'passed to result grid'
	      ELSE
	         ax_remark =
     .			'no influence (indicate argument limits with "[]")'
	      ENDIF
	      CALL SPLIT_LIST (pttmode_explct, lun,
     .		'          '//ww_dim_name(idim)//': '//ax_remark, 0)
 420	   CONTINUE
	ENDIF	

* ... go back for the next argument
	   iarg = iarg + 1      ! point to next arg
 500	CONTINUE

* See if there is a function for alternative argument types
	IF ( its_gc .AND. detail ) THEN

*          alt_name is blank-terminated (not null-terminated)
*          and is unchanged if alt_type_fcn does not exist
           alt_name = ' '
	   CALL efcn_get_alt_type_fcn( ifcn, alt_name )

	   ifcn_alt = GCF_FIND_FCN( alt_name )
	   IF (ifcn_alt .EQ. unspecified_int4) THEN
              RETURN
	   ELSE
	      CALL SPLIT_LIST( pttmode_explct, lun,
     .          indent//
     .          'Alternative function called for other argument types: '
     .          //alt_name, 0)
           ENDIF
	ENDIF

	RETURN
	END

	subroutine epicrd (ncast, ndata, leof, prhead)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)epicrd.F	1.1.1.1    10/21/88
C**
C**
C***********************************************************************        C**
C**                 EPIC
C**
C***********************************************************************        C**
C**
c
c  Reads name of a data file from unit lun11 (an EPIC file or other pointer
C  file for CTD data opened by subroutine epicopn).  If end-of-file
c  encountered on unit lun11,  leof is set .true.. Opens data file on unit
c  lun1 and reads header.  Prints header on output file if prhead is true,
c  not if false.  Reads number of variables and variable codes.  Returns
c  nvars and varcd(i) in common/comvar/.
c
c  Programmed by N Soreide, Jun 85.
c  Modified for other pointer file and variable info, NNS, Oct 85.
c
	character direct*20, filename*14, datafile*132, disk*11
	logical leof,prhead
c
	common /epiclun/ lun1,lun11,lun21
c
c Subroutine READHD
	character*80 header(8),buffer(8)
	common /comhdr/ header
	common/dummy/buffer
c
c  Subroutine EPICRD 
	character*4 varcd(20)
	common/comvar/ nvars,varcd
	common/comefil/datafile
	character line*132, dat*3
	common /comerd/ line
c
c  Subroutine EPICOPN EPIC file indicator
	logical lepic
	common /comepl/ lepic
c
c  Read data file name, open data file and read CTD header.
c
	if (lun1 .eq. 0) lun1 = 1
	if (lun11 .eq. 0) lun11=11
c
	call efile(datafile,dat,leof)
	if (leof) goto 300
c
	call upcase(datafile,132)
#ifdef unix
	open (unit=lun1, form='unformatted', status='old',
     *	file=datafile)
#else
	call upcase(datafile,80)
	open (unit=lun1, form='unformatted', status='old',
     *	readonly,file=datafile)
#endif
c
   	ndfile=lenstr(datafile)
	if (prhead) write (6,103) datafile(1:ndfile)
103	format (/ ' Data file name is ', a /)
c
c  Read header, get number of variables and variable codes.
c
	call readhd (lun1, 0, ncast, ndata, 0, prhead, .false., .false.)
	read (header(3)(79:80), 602) nvars
602	format (i2)
	read (header(5), 603) (varcd(i),i=1,nvars)
603	format (20a4)
	return
c
c  End-of-file encountered on list of data file names (EPIC file)
c
300	continue
	return
	end

	SUBROUTINE VAR_SS_LIMS( idim, cx, lo_ss, hi_ss )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* get the subscript limits for a "file variable"

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  5/19/89 - created
*	10/25/89 - streamlined determining file variable number
* V300: 10/28/93 - apply limits to pseudo-variables, too, if grid is suitable
*	note: this addition was made YEARS after the logic here was developed
*	      there are uncertainties whether special circumstances in FERRET
*	      may lead to problem behavior
*       *acm* 3/12 cleanup old VMS ifdef
* V698  3/16 *sh* added logic for cat_ef_time2d (ACTS_LIKE_FVAR)

	include 'tmap_dims.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include	'xfr_grid.cmn'	! 10/93

* calling argument declarations
	INTEGER idim, cx, lo_ss, hi_ss

* internal variable declarations
	LOGICAL ACTS_LIKE_FVAR
	INTEGER dset, cat, var, grid, line, status
	INTEGER TM_GET_GRIDNUM		! 10/93

* initialize
	dset = cx_data_set(cx)
	var  = cx_variable(cx)
	cat  = cx_category(cx)
	grid = cx_grid(cx)
	IF ( grid .NE. unspecified_int4 ) line = grid_line( idim, grid )

* pseudo-variables - added 10/93
* (must be a known axis and not be ABSTRACT)
	IF ( cat  .EQ. cat_pseudo_var
     . .AND. grid .NE. unspecified_int4
     . .AND. line .NE. unspecified_int4
     . .AND. grid .NE. TM_GET_GRIDNUM('ABSTRACT')  ) THEN
	   lo_ss = 1
	   hi_ss = line_dim( line )
	   RETURN
	ENDIF
* ... end of 10/93 additions

* cannot return answer under several conditions
	IF ( (.NOT.ACTS_LIKE_FVAR(cat) )
     .  .OR. dset .EQ. unspecified_int4
     .  .OR. line .EQ. mnormal
     .  .OR. cx_unstand_grid(cx)	 ) THEN
	   lo_ss = unspecified_int4
	   hi_ss = unspecified_int4
	   RETURN
	ENDIF

* return subscript limits
 110	lo_ss = ds_grid_start(idim, var)
	hi_ss = ds_grid_end  (idim, var)
 1000	RETURN
	END

	SUBROUTINE TM_STEP_TO_DATE ( dset_num, tstep, prec,
     .				     date, length, status )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* This function will return a string giving the date for a particular timestep
* for a particular data set. This is done by figuring the offset from
* 01-JAN-0000 00:00:00 in seconds, and then calculating the date.
*
* written 06/15/87 by Mark Verschell for PMEL/TMAP
*
* revision 0.00	- 06/15/87 - initial incarnation
* revision 0.20	- 06/26/87 - changed to subroutine and added length, status
* revision 0.21 - 07/15/88 - handles errors from TM_BREAK_DATE
*
* V530: *acm* 1/01 alternative calendar types; cal_id
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* Arguments:
*	dset_num - data set number
*	tstep    - time step
*	prec	 - precision (1 to 6 for seconds to years)
*	date	 - returned string containing date in ASCII form
*	length	 - length of date
*	status	 - status at return time
*
	CHARACTER*(*)	date
	INTEGER		dset_num, prec, length, status
	REAL*8		tstep
*
* Inclusions
*
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
	include 'xdset_info.cmn_text'
	external xdset_info_data

*
* Local definitions
*
	CHARACTER*20	TM_SECS_TO_DATE
	INTEGER		t0year, t0mon, t0day, t0hour, t0min, t0sec

	INTEGER 	TM_GET_CALENDAR_ID, cal_id, istat

	REAL*8		start_secs, offset_secs, this_secs, prec_fact(6)
	REAL*8		TM_SECS_FROM_BC

	DATA	prec_fact	/  1.,  60.,  3600.,  86400.,
     .				   86400., 86400./

* First find the offset from 01-JAN-0000 00:00:00 from the descriptor file

        cal_id = TM_GET_CALENDAR_ID (ds_cal_name(dset_num))
	CALL TM_BREAK_DATE (ds_t0time(dset_num), cal_id, t0year, 
     .			    t0mon, t0day, t0hour, t0min, t0sec, istat)
	IF (istat .NE. merr_ok) GOTO 9010
	start_secs = TM_SECS_FROM_BC (cal_id, t0year, t0mon, t0day,
     .				      t0hour, t0min, t0sec, istat)
	IF (istat .NE. merr_ok) GOTO 9010

* Find the number of seconds since start of data set for this time step
	offset_secs = tstep*ds_time_unit(dset_num)

* Total seconds to this time step since 01-JAN-0000 00:00:00
	this_secs = start_secs + offset_secs

* Adjust precision to desired amount by finding nearest multiple of precision
* base (e.g. if precision = day; find closest integer divisible by 86400, which
* is number of seconds in a day). If prec > 4 then find closest day and then
* modify string
	this_secs = DNINT(this_secs/prec_fact(prec)) * prec_fact(prec)

* Convert to date
	date = TM_SECS_TO_DATE(this_secs, cal_id, istat)
	IF (istat .NE. merr_ok) GO TO 9010

* Now if prec > 4 modify string
	IF (prec .EQ. 5) date(1:2) = '00'
	IF (prec .EQ. 6) date(1:6) = '00-   '

* Now truncate string to desired length
	IF (LEN(date) .GT. length) date(length+1:LEN(date)) = ' '

* Finished
	status = merr_ok
	GOTO 9990

* Errors
 9000	CALL TM_ERRMSG ( istat, status, 'TM_STEP_TO_DATE',
     .	                 dset_num, no_stepfile,
     .			 'DD-MMM-YYYY HH:MM:SS',ds_t0time(dset_num),
     .	                 *9990 )

 9010	status = istat
 9990	RETURN
	END

	SUBROUTINE TM_READ_GRIDFILE ( gfile_name, status)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Reads in grid and line definitions and coordinates from a specified .GRD file
*
* revision 0.00 - 05/07/87 - by Mark Verschell for PMEL/TMAP
* revision 1.00 - 05/17/87 - by Mark Verschell for PMEL/TMAP
* revision 1.10 - 08/17/88 - added removal of grid/lines defined by bad file
* revision 1.11 - 08/18/88 - loops from max,1 to find empty storage
* revision 1.12 - 08/20/88 - old name GT_READ_GRIDFILE, called from TM_INIT_DSET
* revision 2.00 - 10/05/88 - new procedures for detection of duplicates
*			     Duplicated name/defn is ignored.
*			     Duplicated name, new defn is an error.
* revision 2.10 - 10/25/88 - Modulo flag added for lines definitions
* revision 2.11 - 11/21/88 - variable used checks changed to char_initXX
* revision 2.20 - 11/22/88 - Removed references to dset_num.
* revision 2.30 - 11/29/88 - True check for unknown and normal axis. Grid_line
*			     now flagged with mpsunkn or mpsnorm.
* revision 2.40 - 12/12/88 - Changes to make use of next_line_mem_pos, including
*			     resetting it if error occurs, and incrementing it
*			     only when line defined and checked for duplication.
* revision 2.41 - 12/13/88 - Added call TM_FIND_*_SLOT to determine open space
* revision 2.50 - 12/15/88 - Reads E/W as long. N/S as lat. for regular axis
* revision 2.60 - 12/19/88 - Reads time axis info, added TIME definition to the
*			     gridfile format to get t0 and tunit for timeaxis
* revision 2.70 - 01/13/89 - Any line that isn't a GRID/LINE/TIME/COORD/Comment 
*			     is not a warning message; doesn't read tunit from
*			     TIME line - gets it from un_convert
* revision 2.71 - 01/23/89 - Moved next_line_mem_pos save to before INQUIRE.
* revision 2.72 - 02/17/89 - Fixed next_line_mem_pos error (1 less than correct)
* revision 2.73 - 01/20/91 - added ifdef unix for default file
* Unix/RISC port - 4/24/91 *sh*: uses TM_INQ_PATH to locate grid file
*                              : changed "WARNING" to "Note"
*                              : allowed axis units of "none" or "n/a"
*                        10/91 : "grd" --> ".grd" for default extension
* bug fix - 10/2/91 - commented out statments 9000 and 9710 because there were
*                      no paths to these statements.  This was caught by ver.3
*                      of f77, but not ver. 2.1  ---kob
* bug fix - 6/24/92 - allow blank lines in gridfile
* bug fix - 1/4/93 *sh* - many error exits closed the unopened lunit
*                       - I added variable "opened"
* IBM Port- 4apr94 *kob* : readonly not allowed in file open statement
*			 : with IBM xlf compiler, added "ifdef" check
* *sh* 3/2/95 - informative messages issued through TM_NOTE (for GUI)
* *sh* 9/95 (for V420): axes need not have T0 to be valid.  Disable this check.
* 10/96 *kob* - Linux port - had to move variable assignments off of
*		declaration line.
* V500: 7/99 *sh* - bug fix: need consistent use of char_init16 on line_name
* V510: *sh* 8/99 bug fix: grid_out_prod not set for NORMAL axis
*			(see err500_del_var_corruption)
*	     4/00 - netCDF files now defining dynamic grids and axes. Need
*		to check among these for previously defined objects
* V541: *sh* 2/02 - minor change to set line_modulo_len
* V581 *acm* 6/05 - For fix to bug 1271, add flag line_shift_origin
* V65  *acm* 2/10- all warnings and notes to std error not std out

* arguments
	CHARACTER*(*)	gfile_name
	INTEGER*4	status

        include 'tmap_errors.parm'

c GET RID OF THIS ROUTINE?  Otherwise work out dynamic line allocation.

	CALL TM_ERRMSG (merr_notsupport, status, 'TM_READ_GRIDFILE',
     .			no_descfile, no_stepfile,
     .			'Gridfiles no longer supported', no_errstring, *5000)

 5000	RETURN
	END

	RECURSIVE FUNCTION TM_WORLD_AX( isubscript, iaxis,
     .					where_in_box ) RESULT(world_ax_result)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* convert a subscript value on an axis into a "world" coordinate
* position within the grid box corresponding to the given subscript is
* determined by the value where_in_box

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V530 10/00 *sh* - extracted from tm_world so that it could be called from
*		    routines that know the axis but not a container grid
* V533 6/01 *sh* - using TM_AXIS_RECURSIVE
*      10/01 *kob* - change TM_AXIS_RECURSIVE to proper logical type
* V541 2/02 *sh* - added support for subspan modulo axes
*		 - slight change to calculation for all modulo axes
* V542 10/02 *sh* - bug fix for irregular, subspan modulo
* V542 10/02 *sh* - bug fix for irregular, subspan modulo
* V71  12/16 *acm* Ticket 2158: working with true monthly time axes.
*                  call tm_tcoord_trumonth to return the correct
*                  coordinate value for irregular months corresponding 
*                  to the calendar

* Include files
#include "gt_lib.parm"
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xunits.cmn_text'
	external xunits_data
	include 'implicit.parm'

* calling argument declarations:
	REAL*8  world_ax_result
	INTEGER	isubscript, iaxis, where_in_box

* internal variable declarations:
	LOGICAL	TM_AXIS_RECURSIVE, TM_ITS_SUBSPAN_MODULO,
     .		ITSA_TRUEMONTH_AXIS, recursive, true_month
	INTEGER	TM_MODULO_LINE_DIM, isub, line_len, rmod, new_ss, 
     .		lo_ss, hi_ss, parent_len, new_where
	REAL*8	TM_WORLD_RECUR, TM_MODULO_AXLEN, GET_LINE_COORD,
     .		midpoint, box_size, tempwld, lo, hi

* initialize
	line_len = TM_MODULO_LINE_DIM( iaxis )
	true_month = ITSA_TRUEMONTH_AXIS(iaxis)

* if this is a child (e.g. every Nth point) of an irregularly-spaced
* axis then use a recursive C routine to find the answer
	recursive = iaxis .GT. max_lines
	IF ( recursive ) 
     .    recursive = TM_AXIS_RECURSIVE(iaxis, true_month)

	IF (recursive) THEN 
	world_ax_result = unspecified_val8  ! default

	IF (line_class(iaxis) .EQ. PLINE_CLASS_STRIDE) THEN 
* in irreg axis striding the box edges cannot simply be read from
* the box edge array (think about it) So we have xtra logic here.

	new_ss = INT(line_start(iaxis)) + (isubscript-1)* INT(line_delta(iaxis))
	IF ( line_regular(iaxis) .OR. where_in_box.EQ.BOX_MIDDLE ) THEN 

	  world_ax_result = TM_WORLD_AX (new_ss, line_parent(iaxis),
     .					where_in_box)
	    
* Extra logic for irregular axis strides
	ELSE  
* cases to consider: interpolate to neighbor above or below
* use lower or upper limit of entire axis

	  IF (where_in_box .EQ.  BOX_LO_LIM) THEN
	    lo_ss = INT(line_start(iaxis))
     .		    + (isubscript-2)* INT(line_delta(iaxis))
	    hi_ss = new_ss
	  ELSE
	    lo_ss = new_ss
	    hi_ss = INT(line_start(iaxis))
     .		     + (isubscript-0)* INT(line_delta(iaxis))
	  ENDIF

	  parent_len = line_dim( line_parent(iaxis))
	  IF ( line_modulo( line_parent(iaxis) ) 
     .	       .OR. (lo_ss.GE.1 .AND. hi_ss.LE.parent_len) ) THEN ! interpolate 
	    new_where = BOX_MIDDLE
	    world_ax_result = 0.5 * 
     .		   ( TM_WORLD_AX (lo_ss, line_parent(iaxis),new_where) + 
     .		     TM_WORLD_AX (hi_ss, line_parent(iaxis),new_where) )

	  ELSE IF (where_in_box .EQ.  BOX_LO_LIM) THEN  ! lower axis edge  
	    new_ss = 1
	    world_ax_result = TM_WORLD_AX (new_ss, line_parent(iaxis), where_in_box)
	  ELSE ! upper axis edge 
	    new_ss = parent_len
	    world_ax_result = TM_WORLD_AX (new_ss, line_parent(iaxis), where_in_box)
	  ENDIF

* Fix for getting data at ends when subspan modulo strides, irregular axis.
	  
	  IF ( TM_ITS_SUBSPAN_MODULO(line_parent(iaxis)) .AND. 
     .	       line_modulo(line_parent(iaxis)) .AND. 
     .	       parent_len.GT.0 ) THEN
            IF (lo_ss .EQ. 0 .OR. lo_ss .EQ. -1) THEN
	      new_where = BOX_LO_LIM
	      lo_ss = 1
	      world_ax_result = 
     .		   TM_WORLD_AX (lo_ss, line_parent(iaxis),new_where)

            ELSE IF (hi_ss .EQ. parent_len+1) THEN
	      new_where = BOX_HI_LIM
	      hi_ss = parent_len
	      world_ax_result = 
     .		   TM_WORLD_AX (hi_ss, line_parent(iaxis),new_where)
            ENDIF

	  ENDIF

	ENDIF 

! end of recursive for strides case
	ELSE IF (line_class(iaxis) .EQ. PLINE_CLASS_MIDPT) THEN
	   world_ax_result = TM_WORLD_AX(isubscript, iaxis, where_in_box)

	ENDIF ! line_class: stride, or midpoint

	RETURN
	ENDIF  ! end of recursive  recursive 

* force given subsc to data range as appropriate for modulo or non-modulo axes
	IF ( line_modulo( iaxis ) ) THEN
	  isub = MOD(isubscript-1,line_len) + 1
	  IF (isub .LE. 0) isub = isub + line_len
	ELSE
	  isub = MIN( line_len, MAX( 1, isubscript ) )
	ENDIF

	IF ( TM_ITS_SUBSPAN_MODULO(iaxis) .AND. isub.EQ.line_len ) THEN
* given index falls in the "void" region of a subspan modulo axis
* ... get the box_hi_lim of the Nth point in the core region
	  CALL TM_WW_AXLIMS(iaxis, lo, hi)
* ... now where within the grid box ?
	  IF ( where_in_box .EQ. box_lo_lim ) THEN
	    tempwld = hi
	  ELSEIF ( where_in_box .EQ. box_middle ) THEN
	    tempwld = ((lo+line_modulo_len(iaxis)) + hi) / 2.
	  ELSE
	    tempwld = lo + line_modulo_len(iaxis)
	  ENDIF
	  IF (isubscript .LE. 0) THEN
	    rmod = isubscript/line_len - 1
	  ELSE
	    rmod = (isubscript-1)/line_len
	  ENDIF
	  world_ax_result = tempwld + rmod* line_modulo_len(iaxis)

	ELSEIF ( line_regular( iaxis ) ) THEN
* regularly spaced points
* ... calculate midpoint and box_size values
	  midpoint = line_start(iaxis) + (isub-1)* line_delta(iaxis)
	  box_size = line_delta(iaxis)
* ... now where within the grid box ?
	  IF ( where_in_box .EQ. box_lo_lim ) THEN
	    tempwld = midpoint - ( box_size / 2. )
	  ELSEIF ( where_in_box .EQ. box_middle ) THEN
	    tempwld = midpoint
	  ELSE
	    tempwld = midpoint + ( box_size / 2. )
	  ENDIF

* Was it at true-month axis?  If so, adjust. 

	  IF (true_month) CALL TM_TCOORD_TRUMONTH (iaxis, 
     .			  midpoint, where_in_box, tempwld)

	  IF ( line_modulo( iaxis ) ) THEN
	    IF (isubscript .LE. 0) THEN
	      rmod = isubscript/line_len - 1
	    ELSE
	      rmod = (isubscript-1)/line_len
	    ENDIF
	    world_ax_result = tempwld + rmod*TM_MODULO_AXLEN(iaxis)
	  ELSE
	    world_ax_result = tempwld
	  ENDIF

	ELSE
* irregularly spaced points

* ... now where within the grid box ?
	  IF ( where_in_box .EQ. box_lo_lim ) THEN
	    tempwld = GET_LINE_COORD (lineedg(iaxis)%ptr, isub)
	  ELSEIF ( where_in_box .EQ. box_middle ) THEN
	    tempwld =  GET_LINE_COORD (linemem(iaxis)%ptr, isub)
	  ELSE
	    tempwld = GET_LINE_COORD (lineedg(iaxis)%ptr, isub+1)
	  ENDIF

	  IF ( line_modulo( iaxis ) ) THEN
	    IF (isubscript .LE. 0) THEN
	      rmod = isubscript/line_len - 1
	    ELSE
	      rmod = (isubscript-1)/line_len
	    ENDIF
	    world_ax_result = tempwld + rmod*TM_MODULO_AXLEN(iaxis)
	  ELSE
	    world_ax_result = tempwld
	  ENDIF

	ENDIF

	RETURN
	END

        subroutine contur(z,nxs,nys,px,py,nx,ny,xf,xoff,yf,yoff,
     *	zlev,ndecl,lwgtl,lclr,nlev,hgt,narc,ang,xct,yct,xadd,lmin,lmax)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* revised for TMAP
* from PPLUS :
*	Directory PMEL:[PLOT5.PPLV11.PLOTLIB]CONTUR.FOR

* search for "TMAP" to find all revisions
* *sh*  - 1/23/89 added interrupt detection
* *sh*  - 2/15/89 corrected ATAN error for vertical labels
*		  ... no explicit declarations (too much trouble !) so it must
*		      be compiled with /WARNINGS=NODECLARATIONS
* !!! ALSO :  Routine overflows bounds at line
*		610	xx(l)= px(il)*xf + xoff
*	      ...bounds checking is OFF to match Denbo's compile stmt
* *sh*  - applied Don's 12/9/88 mods (creating v1.4 of code CONTUR)
*		... replaced earlier ATAN patch with Don's version
*
* *tc*  - 1/15/93 put in option for 'draftsman' style (horz) contour labels, 
*            ...logical variable draftsman turns on or off
* *tc*  - 1/26/93 put in spline under tension fit for contour lines.  uses
*                 spline_tension variable to determine tension.
* *tc*  - 5/04/93 mod to correct bug resulting zag near labels, with tension
*		  > 0, and recapture original behavior w tension=0.
*
* *jd	- 3/29/94 fix bug where specification of zero height contour labels
*		  bombs out on ALPHA machines (divide by zero)
* *jc*  - 3/26/99 added transformation to curvilinear coordinates
*  v581 5/2005 *acm* Add CONTOUR/MOD capability for modulo replications for 
*                    curvilinear data
* V630  *acm* 9/09 change a message only
C  v67  2/2011 *acm* Fix ticket 1799; do contouring in larger sections.
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus
* V687 *acm* 3/14 tickets 2151 and 2147: allow missing coordinate data in 3-arg 
*                 and 4-arg plot commands. 

****************************************************************************
C**
C**    @(#)contur.F	1.2    7/30/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
c     given heights z defined over a rectangular grid,contours are drawn
c     at specified levels. there are provisions for labeling the
c     contours,blanking regions of the rectangle,and making the contours
c     more smooth flowing.
c
c     z(i,j),i=1,nx j=1,ny  is the input array of heights.points in
c          undefined regions of z should be set to 1.e35
c     x1,y1,xl,yl are the lower left and upper right corners of
c          the grid on the plotter in inches.
c     zlev(k),k=1,nlev is the array of levels to be contoured
c     ndecl(k),k=1,nlev gives the number of decimal places in the
c          contour labels. -1=no decimal. -2 or less=no label.
c     lwgtl(k),k=1,nlev  gives the weight of the contour line.
c          1 or less=standard line. 2=heavy line. 3=dotted line.
c     hgt = height of characters of labels in inches.
c     narc = 1,2,3 ... 10 .  an arc of narc subsegments  replaces each
c     st line segment of a contour. the arc will match slopes with
c     the adjacent arcs.   care should be taken here as overlapping of
c     contours is possible when narc is used. narc=1 has no effect.
c**
c**	ang = angle to rotate the contour plot
c**	xct = x center about which to rotate it
c**	yct = y center about which to rotate plot
c**
c     ind10 should be dimensioned at least nx by ny/10 rounded up.
c     kab should be dimensioned at least nx/10+2 by ny/10+2 .
c     If these dimensions are raised, increase the size of workspace
c     s, x, y, x_curv, y_curv proportionally.
c
c     oceanography emr   dec/69
	dimension z(nxs,nys),px(nx),py(ny),s(6000),ind10(300,40)
	dimension x(6000),y(6000)
	dimension zmaxb(10,10),zminb(10,10),kab(40,40)

	dimension  zlev(*),  ndecl(*),lwgtl(*),xc(11),yc(11),ixpon(10)
	dimension lclr(*)

	dimension isin(4),ind(4),xx(4),yy(4),zz(4),lused(4),kabov(4)
	common/rotcon/xk,yk,snthta,csthta
! TMAP mod, spline fit:
! added gkscm2.cmn which includes spline_tension and draftsman

	include 'gkscm2.cmn'
	include 'dashzz_inc.decl'
	include 'DASHZZ.INC'
	include 'conlab_inc.decl'
	include 'CONLAB.INC'
	include 'pltcom_dat.decl'
	include 'PLTCOM.DAT'
        include 'xcurvilinear.cmn'

* TMAP interrupt flag

	include 'xinterrupt.cmn'

	integer*4 ixpon,ind10,jbit,ind1,indl
	character frmt*20,str*40
	integer colold
! TMAP mod, horz contour labels:
! set up arrays for storing labels and such.  mlab is the maximum number
! of contour labels expected on any ONE contour line in the plot.
	parameter (mlab=200)
	real xlabp(mlab),ylabp(mlab),xlabc(mlab),ylabc(mlab),widthp
        realxadd,lmin,lmax

C	Place init into data stmt *jd* 12.96 linux
	integer	nlabp,nlabc
	data	nlabp /0/,nlabc /0/

	integer iatime(3)
! TMAP mod, spline fit:
	parameter (msplsz=2000)
	real splxp(msplsz),splyp(msplsz),spltmp(msplsz),spls(msplsz)
	integer splier

C     Curvilinear coordinates declarations
        integer icurv, status
#ifdef double_p
	real*8 x_curv(6000), y_curv(6000)
#else
	real x_curv(6000), y_curv(6000)
#endif
c
c     initialize
c*******************************************************************************
c
	if(nlev)1200,1200,12
12	pi=3.1415926

c
c	apply the rotation and scaling
c
	thta=ang*pi/180.
	snthta=sin(thta)
	csthta=cos(thta)
	xxct=xct*xf+xoff
	yyct=yct*yf+yoff
	xk=-xxct*csthta+yyct*snthta+xxct
	yk=-yyct*csthta-xxct*snthta+yyct
c	dslab=100.
c	dslab=5.
	colold=colour
	icolro=0
	slab1f=.4
	isin(1)=0
	isin(2)=1
	isin(3)=0
	isin(4)=-1
	big=.9e35
	nxm1=nx-1
	nym1=ny-1
	hhgt = hgt /2.
	ny10=(ny-1)/10+1
	do 17 jbit=1,10
17	ixpon(jbit)=4**(jbit-1)
c
c     get zmax,zmin,zrng,weezee
c*******************************************************************************
c
	iblk=max0(nx/10+1,5)
	jblk=max0(ny/10+1,5)
	zmax=-1.e35
	zmin=1.e35
	ib=0
	do 55 istrt=1,nx,iblk
	ib=ib+1
	iend=min0(istrt+iblk,nx)
	jb=0
	do 55 jstrt=1,ny,jblk
	jb=jb+1
	jend=min0(jstrt+jblk,ny)
	zmaxbl=-1.e35
	zminbl=1.e35
	do 50 i=istrt,iend
	do 50 j=jstrt,jend
	zij=z(i,j)
	if(zij.gt.big) go to 50
	zmaxbl=amax1(zij,zmaxbl)
	zminbl=amin1(zminbl,zij)
50	continue
	zmax=amax1(zmaxbl,zmax)
	zmin=amin1(zminbl,zmin)
	zmaxb(ib,jb)=zmaxbl
	zminb(ib,jb)=zminbl
55	continue
	zrng=(zmax-zmin)*1.1
	if(zrng)1200,1200,60
60	weezee = zrng*.0002
c
c     main loop over all contour levels
c*******************************************************************************
c
	do 1100  lev=1,nlev
! TMAP mod, horz contour labels:
! remember where the contour labels were for the previous contour line.
! these will be compared to the location of labels on the current line to
! determine any conflicts.
	if (draftsman) then
	  do 1102, k1=1,nlabc
	    xlabp(k1)=xlabc(k1)
	    ylabp(k1)=ylabc(k1)
1102	  continue
	  nlabp=nlabc
	  nlabc=0
	  widthp=width
	endif
	IF ( interrupted ) GOTO 1200		! TMAP interrupt processing
	zc = zlev(lev)
c**	if((zmax-zc)*(zc-zmin))1100,1100,70
c** replace with a less prone to overflow calculation
c**
	if(zc.ge.zmax .or. zc.le.zmin)goto 1100
70	ndec = ndecl(lev)
	icolr=lclr(lev)
	lwgt = lwgtl(lev)
	do 75 i=1,nx
	do 75 j=1,ny10
75	ind10(i,j)=0
c
c     get label width
c*******************************************************************************
c
	if(ndec.ge.0)then
	    write(frmt,999)ndec
999	    format('(a10,f20.',i2.2,',a10)')
	    write(str,frmt)conpre,zc,conpst
	else
	    write(str,998)conpre,int(zc+sign(0.5,zc)),conpst
998	    format(a10,i20,a10)
	endif
	call squish(str,1,40)
	nchar=lnblk(str,40)
	width=symwid(hgt,nchar,str)+hhgt
	if(icolr.ne.icolro)then
	    if(icolr.eq.0)then
		call color(colold)
	    else
		call color(icolr)
	    endif
	    icolro=icolr
	endif
c	nchar = ndec+2
c	if(nchar)120,120,100
c100	abzrnd = abs(zc)+.5/10.**max0(0,ndec)
c	do 110 k=1,10
c	if(abzrnd-10**k)120,110,110
c110	nchar=nchar+1
c120	nchar=nchar+1
c	if(ndec.lt.0)cthen
c	    width= hgt *(nchar*9.+8.)/8.
c	else
c	    width= hgt *((nchar-1)*9.+13.)/8.
c	endif
c
c     loop over the grid searching for a contour entering square ii,jj
c     thru side 1 or 4.      (the contour must be unused)
c*******************************************************************************
c
	ib=0
	do 1010 istrt=1,nx,iblk
	iend=min0(istrt+iblk,nx+1)
	ib=ib+1
	jb=0
	do 1010 jstrt=1,ny,jblk
	jb=jb+1
	if(zmaxb(ib,jb).lt.zc .or. zminb(ib,jb).gt.zc) go to 1010
	jend=min0(jstrt+jblk,ny+1)
	do 200 i=istrt,iend
	ikab=i-istrt+1
	do 200 j=jstrt,jend
	jkab=j-jstrt+1
	kabij=10
	if(i.gt.nx .or. j.gt.ny) go to 200
	zij=z(i,j)
	if(zij.gt.big) go to 200
	if(abs(zij-zc).le.weezee) zij=zc+sign(weezee,zij-zc)
	kabij=-1
	if(zij.gt.zc) kabij=1
200	kab(ikab,jkab)=kabij
	iendm1=iend-1
	jendm1=jend-1
	do 1000 ii=istrt,iendm1
	ikab=ii-istrt+1
	do 1000 jj=jstrt,jendm1
	jkab=jj-jstrt+1
	i=ii
	j=jj
	kabij=kab(ikab,jkab)
	kabip1=kab(ikab+1,jkab)
	kabjp1=kab(ikab,jkab+1)
	jwrd=(j-1)/10+1
	j2bit=j-(jwrd-1)*10
	ind1=ind10(i,jwrd)/ixpon(j2bit)
	ind1=ind1-(ind1/4)*4
	lused4=ind1/2
	lused1=ind1-2*lused4
	iretrn=300
	ll=1
	if(kabij+kabip1+lused1.eq.0) go to 540
	ll=4
	if(kabij+kabjp1+lused4.eq.0) go to 540
	go to 1000
300	continue
340	lin = ll
	k=1
	nseg = 1
c
c     given entrance to square(i,j) on side lin, record the entrance
c     point x(k),y(k).  set lin to used.
c*******************************************************************************
c
350	lp1 = lin+1-(lin/4)*4
	lp2 = lp1+1-(lp1/4)*4
	lm1 = lp2+1-(lp2/4)*4
	if(iretrn-360)355,360,360
355	k=k+1
	frac = (zc-zz(lin))/(zz(lp1)-zz(lin))
	x(k) = xx(lin)+ (xx(lp1)-xx(lin))*frac
	y(k) = yy(lin)+ (yy(lp1)-yy(lin))*frac
	iind=i+lp2/4
	jind=j+lp1/4
	lhor = lin-(lin/2)*2
	jwrd=(jind-1)/10+1
	j2bit=jind-(jwrd-1)*10
#ifdef unix
        ind10(iind,jwrd)=ind10(iind,jwrd)+int(2.-lhor)*ixpon(j2bit)
#else
	ind10(iind,jwrd)=ind10(iind,jwrd)+jint(2.-lhor)*ixpon(j2bit)
#endif
c
c     see if an exit exists on side l-1,l+1,or l+2. if so choose the one
c     closest to side l. if the exit is already used terminate x,y.
c*******************************************************************************
c
360	iretrn = 350
	lexit = lm1
	if(kabov(lin)+kabov(lm1))380,370,380
370	if(kabov(lp1)+kabov(lp2))450,390,450
380	if(kabov(lp1)+kabov(lp2))410,400,410
390	flm1 = (zc-zz(lin))/(zz(lm1)-zc)
	flp1 = (zc-zz(lp1))/(zz(lp2)-zc)
	if(lused(lp1).eq.1) go to 450
	if(flm1.le.flp1 .and. lused(lm1).eq.0) go to 450
400	lexit = lp1
	go to 450
410	lexit = lp2
	if(kabov(lp2)+kabov(lm1))470,450,470
450	if(lused(lexit))530,530,460
460	kmax=k+1
	x(kmax)=x(2)
	y(kmax)=y(2)
	x(1) = x(k)
	y(1)=y(k)
	x(k+2)=x(3)
	y(k+2)=y(3)
	klosed=1
	go to 700
c
c     no exit.  if nseg=1 reverse x,y and continue.
c               if nseg=2 terminate x,y.
c*******************************************************************************
c
470	if(kabov(lp2)+kabov(lm1)-15)480,480,500
480	kda=lin
	kdb=lp2
	if(kabov(lp2)-5)495,495,490
490	kda = lm1
	kdb = lp1
495	k=k+1
	frac = (zc-zz(kda))/(zz(kdb)-zz(kda))
	x(k) = xx(kda) + (xx(kdb)-xx(kda))*frac
	y(k) = yy(kda) + (yy(kdb)-yy(kda))*frac
500	if(nseg-1)510,510,505
505	kmax=k
	x(1)=x(2)
	y(1)=y(2)
	x(k+1)=x(k)
	y(k+1)=y(k)
	klosed=0
	go to 700
510	iretrn=360
	nseg = 2
	kh = 1+k/2
	do 520 kk=2,kh
	kkr = k+2-kk
	xkk=x(kk)
	ykk=y(kk)
	x(kk)= x(kkr)
	y(kk)= y(kkr)
	x(kkr)=xkk
520	y(kkr)=ykk
	i=ii
	j=jj
	lexit=ll
c
c     find square entered by present exit. get xx,yy,zz,kabov for each
c     corner and lused for each side.
c*******************************************************************************
c
530	i= i+ isin(lexit)
	jsub=5-lexit
	j= j +isin(jsub)
	lin=lexit+2 - ((lexit+1)/4)*4
c
c
540	do 620 l=1,4
	jl=j+(l-1)/2
	lp1=l+1-(l/4)*4
	il=i+(lp1-1)/2
	ind(l)=0
	zz(l)=1.e35
	kabov(l)=10
	if(il*(nx+1-il))610,610,550
550	if(jl*(ny+1-jl))610,610,560
560	if(z(il,jl)-big)570,610,610
570	jwrd=(jl-1)/10+1
	j2bit=jl-(jwrd-1)*10
	indl=ind10(il,jwrd)/ixpon(j2bit)
	ind(l)=indl-(indl/4)*4
	zz(l)=z(il,jl)
	if(abs(zz(l)-zc)-weezee)580,580,590
580	zz(l)=zc+sign(weezee,zz(l)-zc)
590	kabov(l)=-1
	if(zz(l)-zc)610,610,600
600	kabov(l)=1
 610    xx(l)= px(il)*xf + xoff
620	yy(l)= py(jl)*yf + yoff
	lused(4) = ind(1)/2
	lused(1) = ind(1)-2*lused(4)
	lused(2) = ind(2)/2
	lused(3) = ind(4)-(ind(4)/2)*2
	if(iretrn-350) 300,350,350
c
c     the arrays x,y are now complete. calculate distance s along
c     the contour. start plotting the contour
c*******************************************************************************
c
700	s(2)=0.
	if(kmax-2)1000,1000,720

c
c     For the three argument contour command, the px and py arrays contain
c     fractional indices instead of axis values.  At this point in the code,
c     the x and y arrays contain the page coordinates.  Here we undo the
c     factor(xf/yf) and offset(xoff/yoff) calculations to retrieve the fractional
c     indices, call CURV_COORD() to converts these indices into the transformed
c     axis values, and then reapply the offset and factor.
c
 720    IF (curvilinear) THEN
           DO 722 icurv=1, kmax
              x_curv(icurv)=(x(icurv)-xoff)/xf
              y_curv(icurv)=(y(icurv)-yoff)/yf
 722       CONTINUE

           CALL CURV_COORD(x_curv, y_curv, kmax, 1.0, 1.0, status) ! xform the pts
	   IF (curv_missing) GOTO 1000

           DO 724 icurv=1, kmax
              x(icurv)=(x_curv(icurv)+xadd)*xf + xoff
              y(icurv)=y_curv(icurv)*yf + yoff
              lmin = MIN(lmin, x_curv(icurv))
              lmin = MAX(lmax, x_curv(icurv))
 724       CONTINUE
        ENDIF

        do 750 k=3,kmax
	dxx = x(k)-x(k-1)
	dyy = y(k)-y(k-1)
750	s(k) = s(k-1)+ sqrt(dxx*dxx+dyy*dyy)
	smax = s(kmax)
	slab1 = smax*slab1f
! TMAP mod, spline fit:
! initialize spline work arrays if using spline under tension fit.
	if (spline_tension.ne.0.) then
	  call kurv1(kmax-1,x(2),y(2),0.,0.,3,splxp,splyp,
     ,      spltmp,spls,spline_tension,splier)
	  if (splier.ne.0) then
	  endif
	endif
! TMAP mod, horz contour labels:
! this is where the initial offset is set for a contour label on a contour
! line.  the first label is shifted in dslab-stest distance from the edge, not 
! dslab as might be expected.  modify the stest line to get something you like.
	if (draftsman) then
	  stest = max1(0.0,dslab-slab1)                 ! original code
c
c	  stest = max1(0.0,dslab-dslab*0.5*		! shifted by 1/2 the
c     .      (smax/dslab-float(int(smax/dslab))))	! excess of n dslab labels
c
c	  call itime(iatime)				! more of a random
c	  slab1 = smax*0.4*rand(iatime(3)*k)+0.1	! starting point
c	  stest = max1(0.0,dslab-slab1)			! iatime(3) is sec
c
c	  stest = max1(0.0,dslab-width)			! inset width
c
c	  stest = max1(0.0,dslab*(1.0-0.2))		! inset 0.2 * dslab
c
	else
	  stest = max1(0.0,dslab-slab1)
	endif
	k=2
	call plotny(x(2),y(2),3,0)
c
c     check conditions for labelling.
c*******************************************************************************
c
755	if(ndec+2)900,900,760
760	km1= max0(k-1,2)
	stest = stest + s(k)-s(km1)
	if(stest-dslab)900,770,770
770	if(smax-s(k)-2.0*width)900,900,780
780	kp1=k+1
	if(lev.eq.1) go to 785
	dlev=abs(zlev(lev)-zlev(lev-1))
	xt = (x(k) - xoff)/xf
	yt = (y(k) - yoff)/yf
	do 781 i=1,nx-1
	if(xt.ge.px(i) .and. xt.le.px(i+1))goto 782
781	continue
782	do 783 j=1,ny-1
! TMAP mod 4/19/89 - applied fixes from DON
!	if(yt.ge.py(i) .and. yt.le.py(i+1))goto 784	! original code
	if(yt.ge.py(j) .and. yt.le.py(j+1))goto 784
783	continue
784	i=min0(i,nx-1)
	j=min0(j,ny-1)
	dx=(px(i+1)-px(i))*xf
	dy=(py(j+1)-py(j))*yf
	if(z(i+1,j).ge.big)then
	    dzdx=0.0
	else
	    dzdx=(z(i+1,j)-z(i,j))/dx
	endif
	if(z(i,j+1).ge.big)then
	    dzdy=0.0
	else
	    dzdy=(z(i,j+1)-z(i,j))/dy
	endif
c**	dzdg=sqrt(dzdx*dzdx+dzdy*dzdy)
c** replace with a less prone to overflow calculation
c**
	dzdg=abs(dzdx)+abs(dzdy)
! TMAP mod, horz contour labels:
! this section checks to make sure that at this x,y, the contour label
! will not hit another contour line if it gets written.  it does this
! by comparing the amount of space between contour lines versus the 
! width and height of the label.  this should work most of the time, but
! not all the time because it only checks at this one point.  if the contour 
! lines are very wigly, it's possible that a label could be written that would
! overlie another contour line.  hopefully the check on space/arc would
! remove this case though.
	if (draftsman) then
          if (dzdy.ne.0.) then
	    cspacey=abs(dlev/dzdy)
            if (cspacey.lt.hgt*1.05) go to 900
	  endif
	  if (dzdx.ne.0.) then
	    cspacex=abs(dlev/dzdx)
            if (cspacex.lt.width*1.05) go to 900
	  endif
        else
	  if(dzdg.eq.0.) go to 785
	  cspace=dlev/dzdg
	  if(cspace.lt.hgt*.90) go to 900
        endif
785	continue
	do 800 kk = kp1,kmax
	dxx = x(kk)-x(k)
	dyy = y(kk)-y(k)
	space = sqrt(dxx*dxx+dyy*dyy)
	ark =s(kk)-s(k)
! TMAP mod, horz contour labels:
! this section decides whether a label can fit along this section of contour 
! line.  the label will fit if the gap in the contour line is EITHER wide enough 
! (dxx >~ spacex) OR high enough (dyy >~ hgt) where spacex and spacey is the 
! amount of space (in x or y) that is needed to write the label.  change spacex 
! and spacey to alter the gap size.  spacex and spacey are also used farther 
! below.  spacex=width is pretty straight forward.  spacey=hgt should be the
! appropriate y space but this doesn't work so well.  adding a little extra
! hgt was necessary and then the slope of the contour line needed to be taken
! into account.  this was found by trial and error.
	if (draftsman) then
	  spacey=hgt+0.4*hgt+hgt*abs(dyy/space)*abs(dyy/space)
	  spacex=width
	  if(abs(dyy)-spacey)791,792,792
791	  if(abs(dxx)-spacex)800,792,792
792	  if(space/ark-.95)900,810,810
	else
	  if(space-width)800,790,790
790	  if(space/ark-.95)900,810,810
        endif
800	continue
	go to 900
c
c     draw the label
c*******************************************************************************
c
! TMAP mod, horz contour labels:
! move the stest=0. to just after symbel is called.  this has the same
! effect and allows for further conflicts to be checked below without reseting
! this parameter.  setting this parameter to 0. effectively causes the next
! label to be written dslab distance over while not reseting stest indicates
! that the label was not written and that there should only be a minor shift
! before trying to write the label again.
!810	stest=0.
810	continue
c	do 812 kkk=1,5
c	dxx=x(kk-1)+(x(kk)-x(kk-1))*.2*kkk-x(k)
c	dyy=y(kk-1)+(y(kk)-y(kk-1))*.2*kkk-y(k)
c	space=sqrt(dxx*dxx+dyy*dyy)
c	if(space-width)812,812,815
c812	continue
c815	continue
c	xendl = x(k) + width*dxx/space
c	yendl = y(k) + width*dyy/space
	xa=x(kk-1)-x(k)
	xb=x(kk)-x(kk-1)
	ya=y(kk-1)-y(k)
	yb=y(kk)-y(kk-1)
	aa=xb*xb+yb*yb
	bb=xa*xb+ya*yb
	cc=xa*xa+ya*ya-width*width
	zxy=(-bb+sqrt(bb*bb-aa*cc))/aa
! TMAP mod, horz contour labels:
! this section determines the x and y extent of the gap in the contour
! line.  dxx and dyy depend on whether the label fits in an x-dir
! gap or a y-dir gap.  basically, dxx =~ width of label and dyy =~ ya+yb
! if x-dir and dyy =~ hgt and dxx =~ xa+xb if y-dir.  need to watch for
! xb or yb equal to zero.  if there is a divide by zero, handle it a 
! little differently.
	if (draftsman) then
          if (abs(dyy).ge.spacey.and.abs(dxx).ge.spacex) then
            if (abs(dyy)/spacey.lt.abs(dxx)/spacex) then
	      dxx=spacex*sign(1.0,(x(kk)-x(k)))
	      if (xb.eq.0.) then
	        dyy=spacey*sign(1.0,(y(kk)-y(k)))
	      else
	        dyy=ya+yb*(spacex-abs(xa))/abs(xb)
	      endif
            else
	      dyy=spacey*sign(1.0,(y(kk)-y(k)))
	      if (yb.eq.0.) then
	        dxx=spacex*sign(1.0,(x(kk)-x(k)))
	      else
	        dxx=xa+xb*(spacey-abs(ya))/abs(yb)
	      endif
            endif
	  elseif (abs(dyy).ge.spacey) then
	    dyy=spacey*sign(1.0,(y(kk)-y(k)))
	    if (yb.eq.0.) then
	      dxx=spacex*sign(1.0,(x(kk)-x(k)))
	    else
	      dxx=xa+xb*(spacey-abs(ya))/abs(yb)
	    endif
          elseif (abs(dxx).ge.spacex) then
	    dxx=spacex*sign(1.0,(x(kk)-x(k)))
	    if (xb.eq.0.) then
	      dyy=spacey*sign(1.0,(y(kk)-y(k)))
	    else
	      dyy=ya+yb*(spacex-abs(xa))/abs(xb)
	    endif
	  else
	    print*,' error e1 in pplmod_contur.F'
	    stop
	  endif
	else
	  dxx=xa+xb*zxy
	  dyy=ya+yb*zxy
	endif
	xendl=x(k)+dxx
	yendl=y(k)+dyy
! TMAP mod, spline fit:
! modify xendl and yendl if doing a spline_tension fit.  xendl and yendl are
! between fixed points.  x(k),y(k) and x(kk),y(kk) are fixed points and a spline
! fit to those points will just return themselves, so don't bother.  if narc
! is less than 2, then no interpolation points will be calculated and this
! step can be skipped.  it is possible that the transformed xendl and yendl
! will not satisfy all the label criteria for gap size, arc, etc.  if this
! leads to labels looking poor, a fix will be needed.
	if (narc.gt.1.and.spline_tension.ne.0.) then
          splt=(spls(kk-1)-((x(kk)-xendl)**2+(y(kk)-yendl)**2)**0.5)/
     /         spls(kmax-1)
          call kurv2(splt,xs,ys,kmax-1,x(2),y(2),
     *               splxp,splyp,spls,spline_tension)
	  xendl=xs
	  yendl=ys
	endif
c**
c**	add rotation code for label
c**
	xst=x(k)*csthta-y(k)*snthta+xk
	yst=y(k)*csthta+x(k)*snthta+yk
	xstp=xendl*csthta-yendl*snthta+xk
	ystp=yendl*csthta+xendl*snthta+yk
	dxx=xstp-xst
	dyy=ystp-yst
c
! TMAP mod, horz contour labels:
! set angle, xlab, and ylab where xlab,ylab is the starting position where
! the label should be written.  also, loops 818 and 819 make sure that the
! contour label won't hit it's own contour line somewhere else.  this is not 
! an issue with non-draftsman labels because the label is always along a 
! segment of the contour line.  with draftsman labels, the label may only cut 
! into a small segment of the contour line.  then later, the contour line may 
! turn sharply, come back, and cross over the just written label.  if this is
! the case, don't write the label.
	if (draftsman) then
	  angle = 0.
	  xlab = (xst+xstp)*0.5-0.5*width+0.5*hhgt
	  ylab = (yst+ystp)*0.5-0.5*hgt
	  xcen = (xst+xstp)*0.5
	  ycen = (yst+ystp)*0.5
	  do 818 k1=1,k-1
	    if ((abs(x(k1)  -xcen).lt.(width*0.5)).or.
     .	        (abs(x(k1+1)-xcen).lt.(width*0.5))) then
	      if ((ycen-y(k1))*(ycen-y(k1+1)).lt.0.) goto 900
c	      if (abs(y(k1)-ycen).lt.hgt*0.5) goto 900
c	      if (abs(y(k1+1)-ycen).lt.hgt*0.5) goto 900
	    endif
818	  continue
	  do 819 k1=kk+1,kmax
	    if ((abs(x(k1)  -xcen).lt.(width*0.5)).or.
     .	        (abs(x(k1-1)-xcen).lt.(width*0.5))) then
	      if ((ycen-y(k1))*(ycen-y(k1-1)).lt.0.) goto 900
c	      if (abs(y(k1)-ycen).lt.hgt*0.5) goto 900
c	      if (abs(y(k1-1)-ycen).lt.hgt*0.5) goto 900
	    endif
819	  continue
	else
	  angle = 90. 
! TMAP patch - Don's version of ARCSIN fix - 4/19/89
          if(dyy.lt.0.0)angle=-90.
! end of TMAP patch 4/19/89
	  if(dxx)820,830,820 
820	  angle = atan(dyy/dxx)*180./pi 
830	  if(dxx) 850,840,840 
840	  if (width .eq. 0.0) then
	     xlab = xst
             ylab = yst
          else
             xlab = xst+ hhgt*(0.5*dxx+dyy)/width
	     ylab = yst+ hhgt*(0.5*dyy-dxx)/width
	  endif
	  go to 860
850	  if (width .eq. 0.0) then
	     xlab = xstp
             ylab = ystp
          else
	     xlab = xstp-hhgt*(0.5*dxx+dyy)/width
	     ylab = ystp-hhgt*(0.5*dyy-dxx)/width
	  endif
	endif
c
! TMAP mod, horz contour labels:
! this loop checks to make sure the current label is not going to conflict
! with a label written on the previous contour line.  the current contour
! label is compared with all nlabp previous labels on the previous contour
! line.  if there is an overlap, then don't write the current label.  the
! allowable 'closeness' can be adjusted by altering xdelc, ydelc, xdelp, and
! ydelp where the labels are about width/widthp wide and hgt/hgt tall.  the
! c at the end of the variable represents 'current' and the p represents the
! previous contour line.  cen is where the center of the label is and del is
! the amount of space from the center that the label wants all to itself.  line
! 860 was altered from the original contur.F.  it used to point to the call
! symbel line below.
860	continue
	if (draftsman) then
	  xcenc=(xst+xstp)*0.5
	  ycenc=(yst+ystp)*0.5
	  xdelc=width *0.5+hgt*0.15
	  ydelc=hgt   *0.5+hgt*0.12
	  xdelp=widthp*0.5+hgt*0.15
	  ydelp=hgt   *0.5+hgt*0.12
	  do 861 k1=1,nlabp
	    xcenp=xlabp(k1)+widthp*0.5
	    ycenp=ylabp(k1)+hgt*0.5
	    if (((xcenc-xdelc).lt.(xcenp+xdelp)).and.
     .	        ((xcenc+xdelc).gt.(xcenp-xdelp)).and.
     .	        ((ycenc+ydelc).gt.(ycenp-ydelp)).and.
     .	        ((ycenc-ydelc).lt.(ycenp+ydelp))) goto 900
861	  continue
	endif
! TMAP mod, horz contour labels:
! draw the label and reset stest to 0. which indicates that the label has
! been drawn.  the next label should be dslab distance over.
!860	call symbel(xlab,ylab,angle,hgt,nchar,str)	! original code (860)
	call symbel(xlab,ylab,angle,hgt,nchar,str)
	stest=0.
! TMAP mod, horz contour labels:
! this section of code stores the contour label locations for the current
! contour line so they can be compared to the labels for the next contour line
	if (draftsman) then
	  nlabc=nlabc+1
	  xlabc(nlabc)=xlab
	  ylabc(nlabc)=ylab
	endif

	call plotny(xendl,yendl,3,0)
! TMAP mod, spline fit:
! if spline_tension.ne.0 then you want to do a spline fit in the area
! of the label.  otherwise (original spline), just draw a straight line 
! between the 2 points and don't do the spline.  the original way of
! doing this is pretty ugly.
        if (spline_tension.eq.0.) then
	  call plotny(x(kk),y(kk),2,lwgt)		! original code
	  k=kk						! original code
	  go to 920					! original code
        else
	  k=kk-1					! start of new code
	  call arc(x(k-1),y(k-1),narc+1,.001,xc,yc,npt,
     ,      k-1,kmax-1,x(2),y(2),splxp,splyp,spls,spline_tension)
c
	  dendl=(xendl-x(k))**2+(yendl-y(k))**2
	  do 911 kk1 = 2,npt-1
	    if (((xc(kk1)-x(k))**2+(yc(kk1)-y(k))**2).gt.dendl)
     .        call plotny(xc(kk1),yc(kk1),2,lwgt)
911	  continue
	  call plotny(x(kk),y(kk),2,lwgt)
	  k=k+1
	  goto 920					! end of new code
        endif
c
c     plot the segment from xk,yk to  x(k+1),y(k+1).
c*******************************************************************************
c
! TMAP mod, spline fit:
! call arc with the ability to call the spline fit.  pass lots more variables.
900	call arc(x(k-1),y(k-1),narc+1,.001,xc,yc,npt,
     ,      k-1,kmax-1,x(2),y(2),splxp,splyp,spls,spline_tension)
c
c check for lines crossing the branch cut in curvilinear grids. Pick up the pen.
	IF (curvilinear) THEN
	   kk1 = 2
	   IF (ABS(x_curv(k+1)-x_curv(k)) .GT. 190) call plotny(xc(kk1),yc(kk1),3,lwgt)
	ENDIF

	do 910 kk1 = 2,npt
910	call plotny(xc(kk1),yc(kk1),2,lwgt)
	k=k+1
920	if(k-kmax)755,1000,1000
1000	continue
1010	continue
c
1100	continue
1200	if(colour.ne.colold)call color(colold)
	return
	end

      SUBROUTINE GCF_IMPOSE_RESULT_LIMS( gcfcn,  mr_list,
     .     cx_list, res_cx, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Complete the context for the result of a grid-changing function.
* Fill in the limits for those axes of the grid changing function which
* were "imposed" by the function.
* Reconcile the limits of the arguments with the limits of the result where
* offsets are imposed.

* the addition (or major modification) of an internal grid-changing function
* requires changes to these routines:
*	grid_chg_fcns.parm	- parameters to number the functions
*	XGRID_CHG_FCNS_DATA	- description of the function and args
*	DO_INTERNAL_GC_FCN	- code to execute the function
* (opt)	GCF_GET_IMPOSED_AXES	- return the "imposed" axes, if any
* (opt)	GCF_IMPOSE_RESULT_LIMS	- fill in limits of "imposed" axes, if any

* V450: 1/97
* *jc* 12/97 adding external function capabilities
* V491: 1/98 - added TIMES2, which imposes its T axis
* *jc* 01/98 put includes first
* V491+ 10/98 *sh* - the RESHAPE function failed to "confine" axes at end
*                see err491_reshape_limits.jnl
* V500:  1/99 *sh* remove test code regarding function TIMES2
*       a.k.a. "ECHO"  now used for string argument testing
*       2/99 changed UNRAVEL to XUNRAVEL. Added YUNRAVEL, ZUNRAVEL, TUNRAVEL
* V510: 9/99 *sh* - added SAMPLE* functions
*       1/00 *sh* - RESHAPE behavior to inherit explicit cx lims from arg 2
* V530: 10/00 *sh* - added return status to efcn_get_result_lims
* V533: 7/01 *sh* - added SPAWN function
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V6.8  *acm* 5/12 Add EUNRAVEL, FUNRAVEL
* V720: 4/17 *acm* Add direction-changing functions as a subset of grid-changing ones

* debug declarations for TIMES2
!	INTEGER	n_com1, n_grid, com1_grid
!	REAL*8	TM_WORLD, dlo_com1, dlo_grid, dhi_com1, dhi_grid

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'grid_chg_fcns.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xgrid_chg_fcns.cmn'

* calling argument declarations
	INTEGER	gcfcn, cx_list(*), mr_list(*), res_cx, status

* internal variable declarations
	LOGICAL fix_me(nferdims)
	INTEGER	CGRID_SIZE, CAXIS_LEN, CGRID_AXIS, CX_DIM_LEN,
     .		com1_cx, com2_cx, idim, filled, size, uvar,
     .		res_grd, outlen(nferdims), accum(2:nferdims),
     .		lo_off(nferdims),  hi_off(nferdims), action(nferdims),
     .		axis_will_be(nferdims), lo_lim, hi_lim

* initialize
	uvar = cx_variable(res_cx)
	res_grd = cx_grid(res_cx)

* get "axis_will_be()" for external functions
	IF (gcfcn .GT. gfcn_num_internal ) THEN
	   CALL EFCN_GET_AXIS_WILL_BE(gcfcn, axis_will_be)
	ENDIF

* Fill in the limits for those axes of the grid changing function which
* were "imposed" by the function.

* (1/98)  *** all CUSTOM axes ***
* If the function creates and imposes a custom axis (see GCF_GET_IMPOSED_AXES)
*     then result lims are assumed BY DEFAULT to fill the limits of that axis
* The function itself may over-ride this assumption and impose other limits
*     or detect an error.
	DO 100 idim = 1, nferdims
	   IF (gcfcn .LE. gfcn_num_internal ) THEN
* ... internal function imposing custom axis?
	     IF (  gfcn_axis_will_be(idim,gcfcn)
     .	      .NE. pgc_axis_supplied_herein) GOTO 100	! 100 if not custom
	   ELSE
* ... external function imposing custom axis?
              IF (  axis_will_be(idim) .NE.
     .             pgc_axis_supplied_herein) GOTO 100 ! 100 if not custom
	   ENDIF

* get size of custom output axis
	   size = CAXIS_LEN ( idim, res_cx )

* impose full length on result
	   cx_lo_ss(res_cx, idim) = 1
	   cx_hi_ss(res_cx, idim) = size
	   cx_by_ss(idim, res_cx) = .TRUE.
	   CALL FLESH_OUT_AXIS( idim, res_cx, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
 100	CONTINUE

* *** XSEQUENCE function ***
	IF ( gcfcn .EQ. p_xunravel ) THEN
* X axis is imposed as ABSTRACT
* size of output on X is total size of input of component
	   com1_cx = cx_list(1) 	! only one argument to function
	   cx_lo_ss(res_cx,x_dim) = 1
	   cx_hi_ss(res_cx,x_dim) = CGRID_SIZE(com1_cx)
	   cx_by_ss(x_dim, res_cx) = .TRUE.
	   CALL FLESH_OUT_AXIS( x_dim, res_cx, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	
* *** YSEQUENCE function ***
	ELSEIF ( gcfcn .EQ. p_yunravel ) THEN
* Y axis is imposed as ABSTRACT
* size of output on Y is total size of input of component
	   com1_cx = cx_list(1) 	! only one argument to function
	   cx_lo_ss(res_cx,y_dim) = 1
	   cx_hi_ss(res_cx,y_dim) = CGRID_SIZE(com1_cx)
	   cx_by_ss(y_dim, res_cx) = .TRUE.
	   CALL FLESH_OUT_AXIS( y_dim, res_cx, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000


* *** ZSEQUENCE function ***
	ELSEIF ( gcfcn .EQ. p_zunravel ) THEN
* Z axis is imposed as ABSTRACT
* size of output on Z is total size of input of component
	   com1_cx = cx_list(1) 	! only one argument to function
	   cx_lo_ss(res_cx,z_dim) = 1
	   cx_hi_ss(res_cx,z_dim) = CGRID_SIZE(com1_cx)
	   cx_by_ss(z_dim, res_cx) = .TRUE.
	   CALL FLESH_OUT_AXIS( z_dim, res_cx, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000


* *** TSEQUENCE function ***
	ELSEIF ( gcfcn .EQ. p_tunravel ) THEN
* T axis is imposed as ABSTRACT
* size of output on T is total size of input of component
	   com1_cx = cx_list(1) 	! only one argument to function
	   cx_lo_ss(res_cx,t_dim) = 1
	   cx_hi_ss(res_cx,t_dim) = CGRID_SIZE(com1_cx)
	   cx_by_ss(t_dim, res_cx) = .TRUE.
	   CALL FLESH_OUT_AXIS( t_dim, res_cx, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000

* *** ESEQUENCE function ***
	ELSEIF ( gcfcn .EQ. p_eunravel ) THEN
* E axis is imposed as ABSTRACT
* size of output on E is total size of input of component
	   com1_cx = cx_list(1) 	! only one argument to function
	   cx_lo_ss(res_cx,e_dim) = 1
	   cx_hi_ss(res_cx,e_dim) = CGRID_SIZE(com1_cx)
	   cx_by_ss(e_dim, res_cx) = .TRUE.
	   CALL FLESH_OUT_AXIS( e_dim, res_cx, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000

* *** FSEQUENCE function ***
	ELSEIF ( gcfcn .EQ. p_funravel ) THEN
* F axis is imposed as ABSTRACT
* size of output on F is total size of input of component
	   com1_cx = cx_list(1) 	! only one argument to function
	   cx_lo_ss(res_cx,f_dim) = 1
	   cx_hi_ss(res_cx,f_dim) = CGRID_SIZE(com1_cx)
	   cx_by_ss(f_dim, res_cx) = .TRUE.
	   CALL FLESH_OUT_AXIS( f_dim, res_cx, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000

* *** SPAWN function ***
	ELSEIF ( gcfcn .EQ. p_spawn ) THEN
* X axis is imposed as ABSTRACT
* size of output on X is the number of strings to come from the Unix system
* command -- an unknown value at this point. Arbitrarily we assume 2000
* here and revise if necessary in STORE_SYS_STRINGS
	   cx_lo_ss(res_cx,x_dim) = 1
	   cx_hi_ss(res_cx,x_dim) = 2000 ! arbitrary
	   cx_by_ss(x_dim, res_cx) = .TRUE.
	   CALL FLESH_OUT_AXIS( x_dim, res_cx, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000


* *** SAMPLE* functions ***
	ELSEIF ( gcfcn .GE. p_samplei 
     .    .AND.  gcfcn .LE. p_samplen ) THEN
* specified axis is imposed as ABSTRACT
* size of output on that axis is total size of component 1, the index list
	   com1_cx = cx_list(1) 	! only one argument to function
           idim =  gcfcn - p_samplei + 1
	   cx_lo_ss(res_cx,idim) = 1
	   cx_hi_ss(res_cx,idim) = CGRID_SIZE(com1_cx)
	   cx_by_ss(idim, res_cx) = .TRUE.
	   CALL FLESH_OUT_AXIS( idim, res_cx, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	

* *** TIMES2 (debug) function ***
! commented out with ifdef 1/99 *sh*
! old test code for internal gc func TIMES2 - generate custom t axis
*	ELSEIF ( gcfcn .EQ. p_times2 ) THEN

* T axis gets custom-inserted
*	   com1_cx = cx_list(1) 	! only one argument to function
*	   com1_grid = cx_grid(com1_cx)

* check that result axis limits match the argument
* ... argument range
*	   n_com1   = CX_DIM_LEN(t_dim, com1_cx)
*	   dlo_com1 = TM_WORLD(cx_lo_ss(com1_cx,t_dim), com1_grid, t_dim,
*     .						box_middle )
*	   dhi_com1 = TM_WORLD(cx_hi_ss(com1_cx,t_dim), com1_grid, t_dim,
*     .						box_middle )

* ... custom axis range
*	   n_grid   = CAXIS_LEN(t_dim, res_cx)
*	   dlo_grid = TM_WORLD(1,      res_grd, t_dim, box_middle )
*	   dhi_grid = TM_WORLD(n_grid, res_grd, t_dim, box_middle )
*
* sanity checking -- messages to help with debugging
*	   IF (n_com1   .NE. n_grid  )
*     .			CALL WARN('TIMES2 grid size mismatch')
*	   IF (dlo_com1 .NE. dlo_grid)
*     .			CALL WARN('TIMES2 low limit mismatch')
*	   IF (dhi_com1 .NE. dhi_grid)
*     .			CALL WARN('TIMES2 high limit mismatch')


* *** RESHAPE function ***
* Determine how far the input data will fill the result grid
* Note that for those axes where the result axis is the same as the comp 1 axis
* the arg 1 limits should be preserved
* e.g. RESHAPE(SST,G_Z12_TYEAR) should preserve the X and Y limits
	ELSEIF ( gcfcn .EQ. p_reshape ) THEN
	   com1_cx = cx_list(1) 	! the input data
	   size = CGRID_SIZE(com1_cx)

* ... get "action" which tells which result axes inherit the comp 1 limits
	   CALL GCF_GET_ARG_LIMS (gcfcn, 1, com1_cx, res_grd,
     .		lo_off,  hi_off, action, status)
	   IF ( status .NE. ferr_ok) GOTO 5000

* ... determine the size of the output "container"
	   com2_cx = cx_list(2) 	! the reshaping grid
	   DO 310 idim = 1, nferdims
              IF ( action(idim) .EQ. ppass_along ) THEN
	         outlen(idim) = CX_DIM_LEN(idim, com1_cx)
	      ELSE
                 outlen(idim) = CX_DIM_LEN(idim, com2_cx) ! inherit if explicit
              ENDIF
 310	   CONTINUE

        

* set default limits: full ax len or match com1 depending on "action"
	   DO 320 idim = 1, nferdims
	      fix_me(idim) = CGRID_AXIS(idim, res_cx) .NE. mnormal
	      IF ( fix_me(idim) ) THEN
	        IF ( action(idim) .EQ. ppass_along ) THEN
	           cx_lo_ss(res_cx,idim) = cx_lo_ss(com1_cx,idim)
	           cx_hi_ss(res_cx,idim) = cx_hi_ss(com1_cx,idim)
	        ELSE
	           cx_lo_ss(res_cx,idim) = cx_lo_ss(com2_cx,idim)
	           cx_hi_ss(res_cx,idim) = cx_hi_ss(com2_cx,idim)
	        ENDIF
	      ELSE
	         cx_lo_ss(res_cx,idim) = unspecified_int4
	         cx_hi_ss(res_cx,idim) = unspecified_int4
	      ENDIF
* ... all axes of length 1 provide no opportunity for adjusting output
	      IF (outlen(idim) .EQ. 1) fix_me(idim) = .FALSE.
 320	   CONTINUE

* accumulate the axis lengths to help with calculation
* Note: this can cause integer overflow for grid with ABSTRACT axes
*	a cheap fix (7/97) checks for size above 9999999
	   accum(2) = outlen(1)
	   DO 330 idim = 3, nferdims
	      IF (accum(idim-1) .GE. 9999999
     .	     .OR. outlen(idim-1) .GE. 9999999 ) THEN
	         accum(idim) = 9999999
	      ELSE
	         accum(idim) = accum(idim-1) * outlen(idim-1)
	      ENDIF
 330	   CONTINUE
* figure out how high the input data really fills the output grid
* Note that the input data may not fit into an integer number of output
* rows and columns. If not, round up to allow room, and fill bad flags in
* DO_INTERNAL_GC_FCN, to complete the unfinished rows.
	   DO 340 idim = nferdims, 2, -1
	      filled = size/accum(idim)   ! integer arithmatic
	      IF ( filled.GT.0 .AND. fix_me(idim) ) THEN
	         IF ( size .GT. filled*accum(idim) ) filled = filled + 1
	         cx_hi_ss(res_cx,idim) = MIN(outlen(idim), filled) +
     .					 cx_lo_ss(res_cx,idim) - 1
	         GOTO 360	! break from loop
	      ELSE
	         cx_hi_ss(res_cx,idim) = cx_lo_ss(res_cx,idim)
	      ENDIF
 340	   CONTINUE
* ... it all fits into the lowest order row (which may not be the X axis)
	   DO 350 idim = 1, nferdims
	      IF (fix_me(idim)) THEN
	         cx_hi_ss(res_cx,idim) = cx_lo_ss(res_cx,idim) - 1
     .				       + size
	         GOTO 360
	      ENDIF
 350	   CONTINUE

* flesh out the axes
 360       DO 370 idim = 1, nferdims
              CALL CONFINE_AXIS( idim, res_cx, status )
              IF ( status .NE. ferr_ok ) GOTO 5000  ! added 10/98 *sh*
	      cx_by_ss(idim, res_cx) = .TRUE.
	      CALL FLESH_OUT_AXIS( idim, res_cx, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
 370	   CONTINUE

*
* THIS NEXT SECTION DEALS WITH EXTERNAL FUNCTIONS
*

	ELSEIF ( gcfcn .GT. gfcn_num_internal ) THEN

* ... does the external function need to impose special size limits
*     onto the result? (perhaps a parameter of the function determines this?)
* ... If so, impose 'em here

           IF (axis_will_be(1) .EQ. pgc_axis_is_abstract
     .          .OR. axis_will_be(2) .EQ. pgc_axis_is_abstract
     .          .OR. axis_will_be(3) .EQ. pgc_axis_is_abstract
     .          .OR. axis_will_be(4) .EQ. pgc_axis_is_abstract
     .          .OR. axis_will_be(5) .EQ. pgc_axis_is_abstract
     .          .OR. axis_will_be(6) .EQ. pgc_axis_is_abstract)	THEN
              CALL EFCN_GET_RESULT_LIMITS(gcfcn,  mr_list, 
     .             cx_list, status)
              IF (status .NE. ferr_ok) CALL ERRMSG
     .                          ( status, status,' ', *5000 )
           ENDIF

	   DO 450 idim = 1, nferdims

* If the axis is abstract ... 
*   get the lo and hi limits for this axis
*   create one as in *SEQUENCE above

	      IF (axis_will_be(idim) .EQ. pgc_axis_is_abstract)	THEN

		 CALL EFCN_GET_AXIS_LIMITS(gcfcn, idim, lo_lim, hi_lim)
		 cx_lo_ss(res_cx,idim) = lo_lim
		 cx_hi_ss(res_cx,idim) = hi_lim
		 cx_by_ss(idim, res_cx) = .TRUE.
		 IF (has_uvar_dc) CALL GCF_SET_ABSTRACT_AXIS (res_grd, idim)
		 CALL FLESH_OUT_AXIS( idim, res_cx, status )
		 IF ( status .NE. ferr_ok ) GOTO 5000

		 IF (has_uvar_dc) uvar_given(idim,uvar) = uvlim_hidden


* If the axis is normal ... nothing needs to be done
*  - if the function set using a dimension argument, limits need resetting  

	      ELSEIF (axis_will_be(idim) .EQ. pgc_axis_is_normal) THEN

		 CALL GCF_SET_NORMAL_AXIS (res_grd, idim)
		 CALL FLESH_OUT_AXIS (idim, res_cx, status)  ! set everything needed in the cx
		 IF (has_uvar_dc) uvar_given(idim,uvar) = uvlim_irrelevant

* If the axis is custom

	      ELSEIF (axis_will_be(idim) .EQ. pgc_axis_supplied_herein)
     .                THEN
* do nothing.  accept the limits defined at the top.

*		 CALL ERRMSG( ferr_internal, status,
*     .                'gcf_impose_result_lims: external function'// 
*     .                'custom axes not supported', *5000 )


* If the axis is implied_by_args ... nothing needs to be done

*	      ELSEIF (axis_will_be(idim) .EQ. pgc_axis_implied_by_args)
*     .             THEN
*       do nothing

	      ENDIF

 450	   CONTINUE

	ELSE

	   CONTINUE	! this function does not impose any limits

	ENDIF

	RETURN

* error exit
 5000	RETURN
	END

*
* dot_y.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* May 2017 Ansley Manke
*
* compute the dot product of two arguments along a shared axis
*




      SUBROUTINE dot_y_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

      CALL ef_set_desc(id, 'Compute the inner product of two variables along Y-axis')
      CALL ef_set_num_args(id, 2)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, NORMAL, 
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'VAR1')
      CALL ef_set_arg_desc(id, arg, 'Variable 1')
      CALL ef_set_axis_influence_6d(id, arg,
     .                                YES, YES, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'VAR2')
      CALL ef_set_arg_desc(id, arg, 'Variable 2')
      CALL ef_set_axis_influence_6d(id, arg,
     .                                YES, YES, YES, YES, YES, YES)

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE dot_y_compute(id, arg_1, arg_2, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1, i2, j2, k2, l2, m2, n2
      CHARACTER*100 errtxt

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* check to make sure both variables share the common axis
      IF ( (arg_lo_ss(Y_AXIS, ARG1) .EQ. ef_unspecified_int4) .OR. 
     .     (arg_hi_ss(Y_AXIS, ARG1) .EQ. ef_unspecified_int4) .OR. 
     .     (arg_lo_ss(Y_AXIS, ARG2) .EQ. ef_unspecified_int4) .OR. 
     .     (arg_hi_ss(Y_AXIS, ARG2) .EQ. ef_unspecified_int4) 
     .      ) THEN
         WRITE(errtxt,*) 'Y axis of arguments 1 and 2 cannot be a normal axis'
         GOTO 999
      ENDIF
      IF ( arg_hi_ss(Y_AXIS, ARG1) - arg_lo_ss(Y_AXIS, ARG1) .NE. 
     .     arg_hi_ss(Y_AXIS, ARG2) - arg_lo_ss(Y_AXIS, ARG2) ) THEN
         WRITE(errtxt,*) 'Y axis of Arguments 1 and 2 must be the same length'
         GOTO 999
      ENDIF

* Initialize the result, F90 initialize whole array

      result = bad_flag_result  

* Compute the dot product

      n1 = arg_lo_ss(F_AXIS,ARG1)
      n2 = arg_lo_ss(F_AXIS,ARG2)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

       m1 = arg_lo_ss(E_AXIS,ARG1)
       m2 = arg_lo_ss(E_AXIS,ARG2)
       DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

        l1 = arg_lo_ss(T_AXIS,ARG1)
        l2 = arg_lo_ss(T_AXIS,ARG2)
        DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         k1 = arg_lo_ss(Z_AXIS,ARG1)
         k2 = arg_lo_ss(Z_AXIS,ARG2)
         DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

          i1 = arg_lo_ss(X_AXIS,ARG1)
          i2 = arg_lo_ss(X_AXIS,ARG2)
          DO 200 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

	   j  = res_lo_ss(Y_AXIS)
           j2 = arg_lo_ss(Y_AXIS,ARG2)
           DO 100 j1 = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)

            IF ( arg_1(i1,j1,k1,l1,m1,n1) .NE. bad_flag(ARG1) .AND. 
     .	         arg_2(i2,j2,k2,l2,m2,n2) .NE. bad_flag(ARG2) ) THEN

               IF (result(i,j,k,l,m,n) .EQ. bad_flag_result) THEN
	          result(i,j,k,l,m,n) =  
     .	            arg_1(i1,j1,k1,l1,m1,n1)* arg_2(i2,j2,k2,l2,m2,n2)

               ELSE

	          result(i,j,k,l,m,n) = result(i,j,k,l,m,n) + 
     .	            arg_1(i1,j1,k1,l1,m1,n1)* arg_2(i2,j2,k2,l2,m2,n2)

               ENDIF

            ENDIF
           j2 = j2 + arg_incr(Y_AXIS,ARG2)
 100       CONTINUE

           i1 = i1 + arg_incr(X_AXIS,ARG1)
           i2 = i2 + arg_incr(X_AXIS,ARG2)
 200      CONTINUE

          k1 = k1 + arg_incr(Z_AXIS,ARG1)
          k2 = k2 + arg_incr(Z_AXIS,ARG2)
 300     CONTINUE

         l1 = l1 + arg_incr(T_AXIS,ARG1)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
 400    CONTINUE

        m1 = m1 + arg_incr(E_AXIS,ARG1)
        m2 = m2 + arg_incr(E_AXIS,ARG2)
 500   CONTINUE

       n1 = n1 + arg_incr(F_AXIS,ARG1)
       n2 = n2 + arg_incr(F_AXIS,ARG2)
 600  CONTINUE

      RETURN

 999  CALL EF_BAIL_OUT(id, errtxt)

      RETURN 
      END

	SUBROUTINE DO_AUX_REGRID_LINE_LIN ( axis,
     .					 src_line,
     .					 kmin_src, kmax_src,
     .					 indices, coef,
     .					 kmin_dst, kmax_dst,
     .					 kdlo_ok,  kdhi_ok,
     .					 bad_src,  bad_dst, ascending,
     .				         dst_line             )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* regrid a single line using linear interpolation
* using the index pointers and coefficients provided

* v690 11/13 *sh*

        IMPLICIT NONE
        include 'tmap_dims.parm'
        include 'errmsg.parm'
	include	'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'

* calling argument declarations:
	LOGICAL	ascending
	INTEGER	axis, kmin_src,kmax_src, kmin_dst, kmax_dst, kdlo_ok, kdhi_ok,
     .		indices (kmin_dst:kmax_dst)
        REAL    src_line(kmin_src:kmax_src),
     .		dst_line(kmin_dst:kmax_dst),
     .		coef    (kmin_dst:kmax_dst),
     .		bad_src, bad_dst

* internal variable declarations:
        INTEGER ndx_lo, k, kinc1
        REAL    frac

* initialize
	IF (ascending) THEN
	   kinc1 = 1
	ELSE
	   kinc1 = -1
	ENDIF

* loop performing linear interpolations
	DO 1000 k = kdlo_ok, kdhi_ok   ! dest Z axis

	   ndx_lo = indices(k)
	   frac   = coef(k)

           IF ( frac .LT. 0.0 ) THEN
              dst_line(k) = bad_dst
           ELSEIF ( src_line(ndx_lo) .EQ. bad_src ) THEN
              dst_line(k) = bad_dst
           ELSEIF ( frac .EQ. 1.0 ) THEN
              dst_line(k) = src_line(ndx_lo)
           ELSEIF ( src_line(ndx_lo+kinc1) .EQ. bad_src ) THEN
              dst_line(k) = bad_dst
           ELSE
* ... interpolate data from com1 field to get result
              dst_line(k) = 
     .                 frac  * src_line(ndx_lo)
     .            + (1-frac) * src_line(ndx_lo+kinc1)
           ENDIF
 1000   CONTINUE

	RETURN
	END

	INTEGER*4 FUNCTION TM_FIND_LIKE_DYN_GRID( target )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Locate a grid from the dynamic grid area (above max_grids)
* that matches the target grid

* Steve Hankin  NOAA/PMEL/TMAP

* 9/13/95 for Ferret version 4.2
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* Include files
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'tmap_errors.parm'
	include 'xtm_grid.cmn_text'
	include 'xio.cmn_text'
	external xgt_grid_data

* Argument definitions
	INTEGER target

* Local definitions
	LOGICAL     TM_SAME_GRID_DEF
	INTEGER specimen

* initialize linked list search
	specimen =  grid_flink(max_grids)

* compare with the grids in the "used" list
 100	CONTINUE

	IF ( specimen .EQ. max_grids ) THEN
	   TM_Find_like_dyn_grid = unspecified_int4	! no match found
	   RETURN

	ELSEIF ( specimen .EQ. target ) THEN	
	   specimen = grid_flink(specimen)		! skip over self

	ELSEIF ( TM_SAME_GRID_DEF( target, specimen ) ) THEN
	   TM_Find_like_dyn_grid = specimen
	   RETURN					! success

	ELSE
	   specimen = grid_flink(specimen)		! keep looking

	ENDIF

	GOTO 100
	END

	SUBROUTINE PURGE_AUX_VAR_DEPENDENTS

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* eliminate all stored mrs whose values depend upon ref to an auxiliary var

* V690: 1/14 *sh* 

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xvariables.cmn'

* calling argument declaration:

* internal variable declarations:
	INTEGER	mr

* ?? since this is called always following DELETE_ALL_UVARS 
*    could this be made more efficient by calling deleted_list_get_undel
*    and loopong only through file variables in memory?

	DO mr = 1, max_mrs
	   IF ( mr_protected( mr ) .EQ. mr_deleted ) CYCLE
	   IF ( mr_naux     ( mr ) .EQ. 0          ) CYCLE

	   IF (  mr_protected( mr ) .NE. mr_not_protected
     .	   .AND. mr_protected( mr ) .NE. mr_perm_protected )
     .		STOP 'var prot err --> UVAR'

	   CALL DELETE_VARIABLE( mr )

	ENDDO

	RETURN
	END

	CHARACTER*(*) FUNCTION LEGAL_CHARS( string, leg_len )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* remove all non-character (non-digit) data from a string - return final length

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 9/26/87

        IMPLICIT NONE
* calling argument declarations
	CHARACTER*(*)	string
	INTEGER		leg_len

* local variable declarations:
	INTEGER TM_LENSTR, mlen, slen, s
	CHARACTER char1*1

* initialize
	slen	= TM_LENSTR( string )
	mlen	= LEN( LEGAL_CHARS )
	leg_len	= 0

* loop through input string character by character
	DO 100 s = 1, slen
	   char1 = string(s:s)
	   IF ( char1 .GE. '0' .AND. char1 .LE. '9'
     .	   .OR. char1 .GE. 'A' .AND. char1 .LE. 'Z'
     .	   .OR. char1 .GE. 'a' .AND. char1 .LE. 'z' ) THEN
	      leg_len = leg_len + 1
	      LEGAL_CHARS( leg_len:leg_len ) = char1
	      IF ( leg_len .EQ. mlen ) RETURN
	   ENDIF
 100	CONTINUE

	RETURN
	END

	SUBROUTINE DO_AUX_VAR_REGRID_1D  ( axis, aux_has_cell_pts,
     .				           src,  msrc, src_cx,
     .				           dst,  mdst, dst_cx,
     .				           pos,  mpos, pos_cx,
     .					   kmin_pos, kmax_pos, 
     .					   kmin_src, kmax_src, 
     .					   kmin_dst, kmax_dst    )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* perform a 1D axis regrid (not just Z axis) guided by an auxiliary variable
* containing coord positions
* allow for the usual Ferret promotion of point axes to match span axes
* where either the source data or the position field may have degenerate axes
* (typically the position array will be degenerate in T, E and F) 
* numerical code lifted from do_internal_gc_fcn.F, ZAXREPLACE
* When comparing to that code
*      dst == res
*      src == com1
*      pos == com2
* Note that "k" that is found in the name of some variables is a meaningless
* hold-over from the original K-only version of this routine


* v690 11/13-4/14 *sh*
* V693+ 11/14 *sh* renaming 'sigma' as 'layerz' throughout
* v695+ 3/15 *sh*  change to call name to accommodate T axis regridding
* v698+ 5/15 *sh* linear regrid allows monotonic, but averaging doesnt
*       6/15 *sh* bug fix in determination of ascending affects
*                 false_1pt_regrid [gz(aux)=pt]
* V700 11/16 *sh* fixed bug in koffset_false lingering from K-only regrid
*                 days of this routine
* V702 1/17 *sh* for trac enhancement #2369 -- dynamic memory management 

        IMPLICIT NONE
        include 'tmap_dims.parm'
        include 'errmsg.parm'
	include	'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	
* calling argument declarations:
	LOGICAL	aux_has_cell_pts
	INTEGER	axis,
     .		msrc, mdst, mpos, src_cx, dst_cx, pos_cx,
     .		kmin_src, kmax_src, kmin_dst, kmax_dst, kmin_pos, kmax_pos
        REAL    src( m4lox:m4hix,m4loy:m4hiy,m4loz:m4hiz,
     .               m4lot:m4hit,m4loe:m4hie,m4lof:m4hif ),
     .          dst( m5lox:m5hix,m5loy:m5hiy,m5loz:m5hiz,
     .               m5lot:m5hit,m5loe:m5hie,m5lof:m5hif ),
     .          pos( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif )


* internal variable declarations:
	LOGICAL	new_aux_line, has_valid, ascending, false_1pt_regrid,
     .		monotonic_block
        INTEGER CX_DIM_LEN,
     .          idim,
     .          i,   j,   k,   l,   m,   n,
     .          is,  js,  ks,  ls,  ms,  ns,
     .          ip,  jp,  kp,  lp,  mp,  np,
     .          si0, sj0, sk0, sl0, sm0, sn0,
     .          pi0, pj0, pk0, pl0, pm0, pn0,
     .          dsi, dsj, dsk, dsl, dsm, dsn,
     .          dpi, dpj, dpk, dpl, dpm, dpn
        INTEGER ndx_lo, wkblk, kdmax, ss, trans, klook, khiok,
     .		koffset_false, kstart, kend, n_ascnd, n_desnd
        REAL    bad_src, bad_dst, bad_pos, zval, v0, v1
        REAL*8  TM_WORLD
* internally declared work arrays
	INTEGER	indices(kmin_dst:kmax_dst+1),
     .		dstlo(nferdims), dsthi(nferdims)
	REAL	  posline(kmin_pos:kmax_pos),srcline(kmin_src:kmax_src),
     .		  dstline(kmin_dst:kmax_dst),
     .		dstcoords(kmin_dst:kmax_dst+1),coef(kmin_dst:kmax_dst+1)


* equivalence conveniences
* "inc" is the increments for each axis of each component
* "lo"  is the starting subscript (minus 1) for each axis of each component
* "s" is the source data (src)
* "p" is the position data (pos) 
* "d" indicates the delta increment
* "0" indicates the start (lo) index
        INTEGER srcinc(nferdims), srclo(nferdims),
     .		posinc(nferdims), poslo(nferdims)
        EQUIVALENCE
     .	    (srcinc(1),dsi), (srcinc(2),dsj), (srcinc(3),dsk),
     .	    (srcinc(4),dsl), (srcinc(5),dsm), (srcinc(6),dsn),
     .	    (posinc(1),dpi), (posinc(2),dpj), (posinc(3),dpk),
     .	    (posinc(4),dpl), (posinc(5),dpm), (posinc(6),dpn),
     .	    (srclo(1), si0), (srclo(2), sj0), (srclo(3), sk0),
     .	    (srclo(4), sl0), (srclo(5), sm0), (srclo(6), sn0),
     .	    (poslo(1), pi0), (poslo(2), pj0), (poslo(3), pk0),
     .	    (poslo(4), pl0), (poslo(5), pm0), (poslo(6), pn0)

*==========================

* initialize
	kdmax = kmax_dst
	false_1pt_regrid = cx_aux_stat(axis,dst_cx)
     .		      .EQ. paux_stat_false_1pt_regrid
*   koffset_false fixes ss of -999 used as a valid position in the dest axis
* ==> "k" in names is a misleading relic of the Z-only origins of this routine
!	koffset_false = kmin_dst - m5loz   ! old Z-axis specific logic
	koffset_false = kmin_dst - lo_ss(5,axis)
	trans = cx_regrid_trans(axis,dst_cx)

* flag(s) for bad or missing values
        bad_src = mr_bad_data( msrc )
        bad_dst = mr_bad_data( mdst )
        bad_pos = mr_bad_data( mpos )

* compute the delta increment for each axis
* this allows "promotion" of degenerate axes
        DO 10 idim = 1, nferdims
	   dstlo(idim) = mr_lo_ss(mdst,idim)
	   dsthi(idim) = mr_hi_ss(mdst,idim)
           IF ( CX_DIM_LEN(idim,src_cx) .EQ. 1 ) THEN
              srcinc(idim) = 0
           ELSE
              srcinc(idim) = 1
           ENDIF
           IF ( CX_DIM_LEN(idim,pos_cx) .EQ. 1 ) THEN
              posinc(idim) = 0
           ELSE
              posinc(idim) = 1
           ENDIF
 10     CONTINUE
* ... a dummy loop on the designated axis 
	dstlo(axis)  = 1
	dsthi(axis)  = 1
	srcinc(axis) = 0
	posinc(axis) = 0

* compute the starting subscript for each axis of each component
* (pre-decrement by 1 delta for looping ahead)
* NOTE: 
        DO 20 idim = 1, nferdims
	   srclo(idim) = cx_lo_ss(src_cx,idim) - srcinc(idim)
	   poslo(idim) = cx_lo_ss(pos_cx,idim) - posinc(idim)
 20	CONTINUE

* extract the list of target coordinates
	IF (trans .EQ. pauxrgrd_linear ) THEN
	   IF (false_1pt_regrid) THEN
* ... false 1pt regridding - e.g. Z=100
	      dstcoords(kmin_dst) = cx_lo_ww(axis, dst_cx)
	   ELSE
	      DO k = kmin_dst, kmax_dst
                 dstcoords(k) = TM_WORLD(k,cx_grid(dst_cx),axis,box_middle)
	      ENDDO
	   ENDIF
	ELSEIF (trans .EQ. pauxrgrd_pwlave ) THEN
	   IF (false_1pt_regrid) THEN
* ... false 1pt regridding - e.g. Z=100:200@ave
	      dstcoords(kmin_dst  ) = cx_lo_ww(axis, dst_cx)
	      dstcoords(kmin_dst+1) = cx_hi_ww(axis, dst_cx)
	   ELSE
	      DO k = kmin_dst, kmax_dst
                 dstcoords(k) = TM_WORLD(k,cx_grid(dst_cx),axis,box_lo_lim)
	      ENDDO
	      dstcoords(kmax_dst+1) =
     .		    TM_WORLD(kmax_dst,cx_grid(dst_cx),axis,box_hi_lim)
	   ENDIF
	   kdmax = kdmax + 1
	ELSE
	   STOP 'do_aux_var_regrid_trns'   ! checked in AUX_REGRID_LIMS
	ENDIF

* initial code does only the Z axis, based upon "ZAXREPLACE(V,ZVALS,ZAX)"
* of old ... regrid a layer-Z-coordinate variable, V (src), onto
* a depth axis, ZAX, (Z axis of dst) guided by the depths in ZVALS (pos)


* loop over the X,Y,T,E,F range of the input fields
	new_aux_line = .TRUE.
	is = si0
	ip = pi0
	DO 1000 i = dstlo(x_dim), dsthi(x_dim)
	 is = is + dsi
	 IF (dpi .NE. 0) THEN
	   ip = ip + dpi
	   new_aux_line = .TRUE.
	 ENDIF
	 js = sj0
	 jp = pj0
	 DO 1000 j = dstlo(y_dim), dsthi(y_dim)
	  js = js + dsj
	  IF (dpj .NE. 0) THEN
	    jp = jp + dpj
	    new_aux_line = .TRUE.
	  ENDIF
	   ks = sk0
	   kp = pk0
	   DO 1000 k = dstlo(z_dim), dsthi(z_dim)
	    ks = ks + dsk
	    IF (dpk .NE. 0) THEN
	      kp = kp + dpk
	      new_aux_line = .TRUE.
	    ENDIF
	    ls = sl0
	    lp = pl0
	    DO 1000 l = dstlo(t_dim), dsthi(t_dim)
	     ls = ls + dsl
	     IF (dpl .NE. 0) THEN
	       lp = lp + dpl
	       new_aux_line = .TRUE.
	     ENDIF
	     ms = sm0
	     mp = pm0
	     DO 1000 m = dstlo(e_dim), dsthi(e_dim)
	      ms = ms + dsm
	      IF (dpm .NE. 0) THEN
	        mp = mp + dpm
	        new_aux_line = .TRUE.
	      ENDIF
	      ns = sn0
	      np = pn0
	      DO 1000 n = dstlo(f_dim), dsthi(f_dim)
	       ns = ns + dsn
	       IF (dpn .NE. 0) THEN
	         np = np + dpn
	         new_aux_line = .TRUE.
	       ENDIF


* compute on the source and destination coords only if they differ from last
	     IF (new_aux_line) THEN
* extract the line of coord vals from the aux variable at this location
* 6/2015-- do full region so that we get a reliable determination of ascending vs descending
	        CALL EXTRACT_ARG1_LINE( pos, axis, kmin_pos, kmax_pos,
     .				        ip, jp, kp, lp, mp, np, posline )


* 5/15 - allow for non-monotonic position array.
* PROGRAMMER NOTE: The 5/15 changes make this code seriously sub-optimal
* The code immediately following could be blended with the routines
* HUNT_INDICES and FULL_SCAN_INDICES to make something both smaller and faster

* check for a single contiguous block of monotonic points
	        monotonic_block = .FALSE.
	        n_ascnd = 0
	        n_desnd = 0
	        kstart = kmax_src
	        kend   = kmin_src

* ... count ascending and descending pairs
		v0 = posline(kmin_pos)
	        DO ss = kmin_pos+1, kmax_pos
		   v1 = posline(ss)
	           IF (v1 .NE. bad_pos) THEN
	              IF (v1 .GT. v0) THEN
	                 n_ascnd = n_ascnd + 1
	              ELSEIF (v1 .LT. v0) THEN
	                 n_desnd = n_desnd + 1
	              ENDIF
	              v0 = v1
	           ENDIF
	        ENDDO

* ... assess the monotonicity
*     Note: through this approach columns may differ in direction in pathological data!!
	        ascending = n_ascnd .GE. n_desnd

* ... find start of non-bad block
	        DO ss = kmin_src, kmax_src
	           IF (posline(ss) .NE. bad_pos) THEN
	              kstart = ss
	              GOTO 510
	           ENDIF
	        ENDDO
* ... find end of non-bad block
 510	        DO ss = kmax_src, kstart, -1
	           IF (posline(ss) .NE. bad_pos) THEN
	              kend = ss
	              GOTO 590
	           ENDIF
	        ENDDO

* ... no non-bad-block exists
	        CONTINUE

 590		CALL FULL_SCAN_INDICES(posline(kmin_src), kmin_src, kmax_src,
     .				  kstart, kend,
     .				  bad_pos, dstcoords,
     .				  indices, coef, kmin_dst, kdmax,
     .				  ascending, has_valid )
	        klook = kmin_dst
	        khiok = kdmax
	        IF (trans .EQ. pauxrgrd_pwlave ) khiok = khiok-1
	        new_aux_line = .FALSE.
	     ENDIF

	     IF (has_valid) THEN
* extract the line of source vals 
	        CALL EXTRACT_ARG4_LINE( src, axis, kmin_src, kmax_src,
     .					is, js, ks, ls, ms, ns, srcline )

* perform the regridding
	        IF (trans .EQ. pauxrgrd_linear ) THEN
* ... by linear interpolation to target cell coordinate points
	           CALL DO_AUX_REGRID_LINE_LIN (axis,
     .				  srcline,
     .				  kmin_src, kmax_src,
     .				  indices,  coef,
     .				  kmin_dst, kmax_dst,
     .				  klook,    khiok,
     .				  bad_src,  bad_dst, ascending,
     .				  dstline             )
	        ELSEIF (trans .EQ. pauxrgrd_pwlave ) THEN
* ... by within-target-cell averaging   (count non-monotonic positions)
	           CALL DO_AUX_REGRID_LINE_AVE (axis,
     .				  srcline,  posline(kmin_src),
     .				  kmin_src, kmax_src,
     .				  indices,  coef,
     .				  kmin_dst, kmax_dst,
     .				  klook,    khiok,
     .				  bad_src,  bad_dst, bad_pos,
     .				  ascending,
     .				  dstline             )
	        ENDIF

* put the line of results into the destination array
	        CALL PUT_ARG5_LINE(
     .			dst, axis, klook, khiok, koffset_false,
     .			i, j, k, l, m, n, dstline )

	     ENDIF

 1000	CONTINUE

* successful completion.  Clean up.
        CALL RELEASE_DYN_WORK_SPACE
        RETURN

* error exit
 5000	RETURN
	END

	SUBROUTINE CD_GET_1_DEP_VAR ( dset, cdfid, ivcd, las_pos, global_bad, 
     .				      ivtm, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Loads common blocks XDSET_INFO and XSTEP_FILES with vital system and
* background information for a single dependent variable from a netCDF file
* It processes FERRET special attributes without regard to whether variables
* are "generic" or "FERRET"

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V500 3/99 *sh* -- new with code extracted from cd_scan_vars.F
*      4/99 *kob*: increase size of vname from 24 to 64 chars
* V533 6/01 *sh* -- set the variables data type
* V542 11/02*acm*  For 4-D string NetCDF files, allow nvdim to be 5 when
*                  code checks for "Unsupported netCDF # of axes".
* V552 5/03 *acm*: increase size of vname from 64 to 128 chars
* V600 *ACM* attribute control. 
*             Replace NCAINQ with CD_GET_VAR_ATT_INFO
*             Change call to CD_GET_ATTRIB to NC_GET_ATTRIB - get attrib from 
*               linked list structure
*             CD_GET_ATTVAL replaced by NC_GET_ATTRIB, which now returns  
*               strings or real values according to attrib type
* V600  4/06 *acm* - additional declarations found by Solaris compiler
* V600  6/06 *acm*   CD_GET_VAR_ATT_INFO uses varid and attid rather than attname.
* V62   2/09 *acm* - allow for string-type missing and fill attributes to be read.
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V663 *acm* 7/10  If neither missing_flag nor _FillValue attribute, use NaN.
*                  but set an output attribute containing the Ferret default.
* v67   2/11 *acm* Do the notes about no missing/fillvalue for each variable,
*             when in diagnostic mode. So move that back to cd_get_1_dep_var.
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing
* V6931 12/14 *acm* Fix ticket 2223: switch_nan needs to use the Ferret
*		    missing-value flag.
* V695 4/15 *sh* added support for CF auxiliary coordinate variables

* argument definitions:
*       dset    - pointer to TMAP data set
*	cdfid   - id of currently open CDF file
*	ivcd	- variable id in netCDF file
*	las_pos  - TMAP variable pointer for last variable stored (for optimization, only - "1" OK) 
*	global_bad - a global bad value flag for all vars in dada set

*	ivtm	- returned TMAP variable pointer for the new variable (0 if unsuccessful)
*	status	- return status

* argument declarations:
	INTEGER	      dset, cdfid, ivcd, las_pos, ivtm, status
	REAL	      global_bad

* include files


        include 'netcdf.inc'
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'xdset_info.cmn_text'
	external xdset_info_data
        include 'xdset_info.cd_equiv'
        include 'xio.cmn_text'
        external xio_data
	include 'xdiag_ctrl.cmn_text'
	external xdiag_ctrl_data

      LOGICAL NC_GET_ATTRIB_FLOAT, NC_GET_ATTRIB_STRING, 
     .        NC_GET_ATTRIB, CD_GET_BOUNDS,
     .        got_it, got_bad, got_missing, tf2,
     .        do_warn, coordvar, its_epic
      PARAMETER (do_warn = .TRUE. )
      INTEGER TM_LENSTR1, TM_FERRET_VARTYPE, 
     .        cdfstat, idim,
     .        vartyp, nvdim, vdims(8), nvatts, vlen,
     .        recdim, istat, lasdim, attype, attlen, attoutflag, 
     .        maxlen, all_outflag, attid
      REAL    val
* 4/99 *kob* increase size of vname
      CHARACTER    vname*128, aname*128, buff*128
      CHARACTER*13 TM_STRING

      INTEGER tt  ! nice short name
      EQUIVALENCE (tt,lunit_errors)


* special equivalence (cannot include in tmap_format/xdset_info.cd_equiv because "BYTE"
* isn't supported on DECstation
* reorder loop logic because linux cpp didn't like it *kob* 10/96


#ifdef NEED_BYTE
      BYTE cd_data_type(maxvars)
#else
      INTEGER*1 cd_data_type(maxvars)
#endif


      EQUIVALENCE ( ds_precision, cd_data_type )

           its_epic = ds_type(dset) .EQ. 'ECDF'

* get the vital statistics for this variable

           CALL CD_GET_VAR_INFO(dset, ivcd, vname, vartyp, 
     .                 nvdim, vdims, nvatts, coordvar, 
     .                 all_outflag, status)
           IF ( status .NE. merr_ok ) GOTO 5200
           vlen = TM_LENSTR1(vname)

* find the next storage position in TMAP common
	  DO 150 ivtm = las_pos,maxvars
	    IF (ds_var_setnum(ivtm) .EQ. set_not_open) GOTO 151
  150     CONTINUE
* oops - no room left for new variables
	  GOTO 5100

* set obvious defaults for this variable
 151	  cd_varid(ivtm)        = ivcd ! netCDF variable ID
          ds_var_setnum(ivtm  ) = dset
          ds_var_title(ivtm)    = ' '
          ds_var_titl_mod(ivtm) = ' '
          ds_var_units(ivtm)    = ' '
	  ds_missing_flag(ivtm)	= global_bad
	  ds_bad_flag(ivtm)	= ds_missing_flag(ivtm)
	  ds_precision(ivtm)	= 'SINGLE'
          cd_scale_factor(ivtm) = 1.0
          cd_add_offset(ivtm)   = 0.0
          cd_scaled(ivtm)       = .FALSE.
	  ds_its_aux_coord(ivtm) = .FALSE.
	  DO 160 idim = 1, nferdims
             ds_grid_start(idim,ivtm)= unspecified_int4
             ds_grid_end  (idim,ivtm)= unspecified_int4
  	     ds_ordering(idim,ivtm)= unspecified_int4
 160      CONTINUE

* is it a supported data type ?
          cd_data_type(ivtm) = vartyp
	  ds_var_type(ivtm) = TM_FERRET_VARTYPE(vartyp)  ! 6/01

* is it a supported dimensionality ?
          IF ( nvdim .GT. nferdims+1 ) THEN
             CALL TM_NOTE('Unsupported netCDF # of axes for variable '
     .             //vname(:vlen), tt )
             GOTO 200
          ENDIF

C Can get chunking, deflate, etc. for vars in file.
c#ifdef usingDODSf2cUnderscore 
c           cdfstat = NF_INQ_FORMAT_(cdfid, cdfformat)
c#else
c           cdfstat = NF_INQ_FORMAT (cdfid, cdfformat) 
c#endif
c        IF (cdfformat .EQ. NF_FORMAT_NETCDF4) THEN
c           cdfstat = NF_INQ_VAR_DEFLATE(cdfid, ivcd, shuffle,
c     .                 deflate, deflate_level)
c           cdfstat = NF_INQ_VAR_CHUNKING(cdfid, ivcd, contiguous, 
c     .                 chunks)
c        ENDIF

* see what generic attributes can be read: long_name, units, missing_value
* If no long_name, then see if this is an F-TDS url with a ferret_definition
* attribute and use that for the title.

          IF (nvatts .GT. 0) THEN
             maxlen = 128
             got_it = NC_GET_ATTRIB_STRING( dset, ivcd, 'long_name',
     .                     .NOT.do_warn, vname(:vlen), maxlen, attlen, 
     .                     attoutflag, ds_var_title(ivtm))

             IF (.NOT. got_it) THEN  !an F-TDS URL may have ferret_definition
	        
                got_it = NC_GET_ATTRIB_STRING( dset, ivcd, 
     .                     'ferret_definition',
     .                     .NOT.do_warn, vname(:vlen), maxlen, attlen, 
     .                     attoutflag, ds_var_title(ivtm))
             ENDIF

             maxlen = 128
             got_it = NC_GET_ATTRIB_STRING( dset, ivcd, 'long_name_mod',
     .                     .NOT.do_warn, vname(:vlen), maxlen, attlen, 
     .                     attoutflag, ds_var_titl_mod(ivtm))

             maxlen = 64
             got_it = NC_GET_ATTRIB_STRING( dset, ivcd, 'units',
     .                     do_warn, vname(:vlen), maxlen, attlen, 
     .                     attoutflag, ds_var_units(ivtm))

             got_it = NC_GET_ATTRIB_FLOAT( dset, ivcd, 'scale_factor',
     .                     do_warn, vname(:vlen), attlen, 
     .                     attoutflag, cd_scale_factor(ivtm))

             tf2    = NC_GET_ATTRIB_FLOAT( dset, ivcd, 'add_offset',
     .                     do_warn, vname(:vlen), attlen, 
     .                     attoutflag, cd_add_offset(ivtm))

             cd_scaled(ivtm) = got_it .OR. tf2

* netCDF files may use "standard" attributes missing_value and/or
* _FillValue to flag bad data
* For the NOAA COOP standard the missing_value flag must be stored in the
* packed data type.  If so it must be unpacked.  (2/95)
	     
	     CALL CD_GET_VAR_ATT_ID (dset, ivcd, 'missing_value', 
     .                  attid, istat)
	     IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, 
     .                 ivcd, attid, aname, attype, attlen, attoutflag, 
     .                 istat)
     
             IF (attype .NE. NF_CHAR) THEN
                got_bad = NC_GET_ATTRIB_FLOAT( dset, ivcd, 
     .                'missing_value',
     .                do_warn, vname(:vlen), attlen,
     .                attoutflag, ds_bad_flag(ivtm))
             ELSE
  	        maxlen = 128
                got_bad = NC_GET_ATTRIB( dset, ivcd, 'missing_value',
     .                do_warn, vname(:vlen), maxlen, attlen,
     .                attoutflag, buff,  ds_bad_flag(ivtm))
             ENDIF


	     
	     CALL CD_GET_VAR_ATT_ID (dset, ivcd, '_FillValue', 
     .                  attid, istat)
	     IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, 
     .                 ivcd, attid, aname, attype, attlen, attoutflag, 
     .                 istat)
     
             IF (attype .NE. NF_CHAR) THEN
                got_missing = NC_GET_ATTRIB_FLOAT( dset, ivcd, 
     .                '_FillValue',
     .                do_warn, vname(:vlen), attlen,
     .                attoutflag, ds_missing_flag(ivtm))
             ELSE
  	        maxlen = 128
                got_missing = NC_GET_ATTRIB( dset, ivcd, '_FillValue',
     .                do_warn, vname(:vlen), maxlen, attlen,
     .                attoutflag, buff,  ds_bad_flag(ivtm))
             ENDIF

* ... need to unpack the missing_value flag?
*
* The CF standard says: 
* The missing values of a variable with scale_factor and/or add_offset 
* attributes (see section Section 8.1, Packed Data) are interpreted 
* relative to the variable's external values, i.e., the values stored 
* in the netCDF file. Applications that process variables that have 
* attributes to indicate both a transformation (via a scale and/or 
* offset) and missing values should first check that a data value is 
* valid, and then apply the transformation. Note that values that are 
* identified as missing should not be transformed. 
* This means that the missing_value and _FillValue are in packed-type,
* and to test unpacked data against the bad value, they need to be unpacked.
*
*     (note that the netCDF library insists on _FillValue's data type)
             IF ( vartyp.LE.NF_INT .AND. cd_scaled(ivtm) ) THEN
                IF ( got_bad ) THEN
                   CALL CD_GET_VAR_ATT_ID (dset, ivcd, 'missing_value', 
     .                  attid, istat)
                   IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, 
     .                 ivcd, attid, aname, attype, attlen, attoutflag, 
     .                 istat)
	           IF ( attype .EQ. vartyp ) ds_bad_flag(ivtm) =
     .			ds_bad_flag(ivtm)*cd_scale_factor(ivtm)
     .			+ cd_add_offset(ivtm)
	        ENDIF

* ... *kob* Also need to see about unpacking _FillValue
                IF ( got_missing ) THEN
                   CALL CD_GET_VAR_ATT_ID (dset, ivcd, '_FillValue', 
     .                  attid, istat)
                   IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, 
     .                  ivcd, attid, aname, attype, attlen, attoutflag, 
     .                  istat )
	           IF ( attype .EQ. vartyp ) ds_missing_flag(ivtm) =
     .	   		ds_missing_flag(ivtm)*cd_scale_factor(ivtm)
     .			+ cd_add_offset(ivtm)
	        ENDIF
             ENDIF
             IF ( got_bad .AND. .NOT.got_missing )
     .           ds_missing_flag(ivtm) =  ds_bad_flag(ivtm)
             IF ( got_missing .AND. .NOT.got_bad )
     .           ds_bad_flag(ivtm) =  ds_missing_flag(ivtm)
	        
* if neither missing flag nor _FillValue was defined, use NaN.
             IF ( .NOT.got_missing .AND. .NOT.got_bad .AND. .NOT.its_epic) THEN
                CALL SET_NAN (ds_missing_flag(ivtm))
		CALL SWITCH_NAN(ds_bad_flag(ivtm), ds_missing_flag(ivtm), bad_r4)
		IF (do_warn .AND. tmap_diag_on) CALL WARN(
     .'No missing_value or _FillValue attribute. Using NaN for variable: ' 
     . //vname(:vlen)) 

             ENDIF

*  *kob* call SWITCH_NAN to make sure if NaN exisits, its in ds_missing_flag
	     CALL SWITCH_NAN(ds_bad_flag(ivtm), ds_missing_flag(ivtm), bad_r4)

* see what special FERRET attributes can be read: axis ordering and
* sub-hyperslab bounds
             maxlen = nferdims
             got_it = NC_GET_ATTRIB( dset, ivcd, 'axis_order',
     .                do_warn, vname(:vlen), maxlen, attlen, 
     .                attoutflag, buff, val)
             lasdim = 0
             IF (got_it) THEN
                DO 170 idim = 1, nferdims
                   IF ( buff(idim:idim) .EQ. ' ' ) THEN
                     ds_ordering(idim,ivtm) = 0
                     GOTO 170
                  ELSEIF ( buff(idim:idim) .EQ. 'T' ) THEN
                     ds_ordering(idim,ivtm) = 4
                  ELSE
                     ds_ordering(idim,ivtm) = ICHAR(buff(idim:idim))-87 ! XYZ->123
                  ENDIF
                  IF ( ds_ordering(idim,ivtm) .LT. 0
     .            .OR. ds_ordering(idim,ivtm) .GT. nferdims ) THEN 
                     CALL TM_NOTE(
     .                     'Illegal netCDF "axis_order" for variable '
     .                     //vname(:vlen), tt )
		     GOTO 200
                   ENDIF
                   IF ( ds_ordering(idim,ivtm) .LE. lasdim ) THEN
                      CALL TM_NOTE(
     .                     '"axis_order" permutations not supported: '
     .                        //vname(:vlen), tt )
                      GOTO 200
                   ENDIF
                   lasdim = ds_ordering(idim,ivtm)
 170            CONTINUE
             ENDIF

* does this variable have a FERRET "parent grid" ?
* if so check for explicit hyperslab limits
             buff = ' '   ! problems from characters beyond 16
             maxlen = 16 !gridnamlen
             got_it = NC_GET_ATTRIB( dset, ivcd, 'parent_grid',
     .                           do_warn, vname(:vlen), maxlen, attlen, 
     .                           attoutflag, buff, val)
             IF ( got_it ) THEN
                got_it = CD_GET_BOUNDS(cdfid, ivcd, 
     .                     ds_grid_start(1,ivtm), ds_grid_end(1,ivtm), 
     .                     recdim, status )
                IF ( status .NE. merr_ok ) GOTO 5900
             ENDIF

          ENDIF ! nvatts > 0

* officially claim this variable slot
* 7/98 - save in case-sensitive form at this point -- will check over later
*        ds_var_code(ivtm) = vname
         CALL string_array_modify(ds_var_code_head, ivtm, 
     .                            vname, LEN(vname))

* successful completion - variable cataloged
 1000	status = merr_ok
	RETURN

* no variable created
 200	ivtm = 0	! flag for no success
	GOTO 1000

* ERROR MESSAGES
 5100	CALL TM_ERRMSG ( merr_varlim, status, 'CD_GET_1_DEP_VAR',
     .			 dset, no_stepfile,
     .			 'MAX='//TM_STRING(DBLE(maxvars)),
     .			 no_errstring, *5900)

 5200   CALL TM_ERRMSG
     .     ( cdfstat+pcdferr, status, 'CD_GET_1_DEP_VAR', cdfid,
     .        no_varid, no_errstring, no_errstring, *5900 )

* error exit
 5900	ivtm = 0
	RETURN
	END

      SUBROUTINE RR_wuz_Qiao_init(id)
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id
      CALL ef_set_desc             (id,'w du/dz from Qiao (1997)')
      CALL ef_set_num_args         (id,2)
      CALL ef_set_axis_inheritance (id,IMPLIED_BY_ARGS, 
     . IMPLIED_BY_ARGS,IMPLIED_BY_ARGS,IMPLIED_BY_ARGS)
      CALL ef_set_arg_name         (id,ARG1,'w') 
      CALL ef_set_arg_desc         (id,ARG1,'w-computed')
      CALL ef_set_arg_unit         (id,ARG1,'cm/sec')
      CALL ef_set_arg_type         (id,ARG1,FLOAT_ARG)
      CALL ef_set_axis_influence   (id,ARG1,YES,YES,YES,YES)
      CALL ef_set_arg_name         (id,ARG2,'u4')
      CALL ef_set_arg_desc         (id,ARG2,'u-station 4')
      CALL ef_set_arg_unit         (id,ARG2,'cm/sec')
      CALL ef_set_arg_type         (id,ARG2,FLOAT_ARG)
      CALL ef_set_axis_influence   (id,ARG2,YES,YES,YES,YES)
      END


      SUBROUTINE RR_wuz_Qiao_compute(id,arg_1,arg_2,result)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'
      REAL dz,arg_1 (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .               mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL    arg_2 (mem2lox:mem2hix, mem2loy:mem2hiy, 
     .               mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL    result(memreslox:memreshix,memresloy:memreshiy,
     .               memresloz:memreshiz,memreslot:memreshit)
      INTEGER res_lo_ss(4),res_hi_ss(4),res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS),arg_hi_ss(4,EF_MAX_ARGS)
      INTEGER arg_incr(4,EF_MAX_ARGS)
      INTEGER i,j,k,l,i1,j1,k1,l1,i2,j2,k2,l2,iZ,id
      REAL*8  zW(1024)

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_coordinates    (id, ARG1, Z_AXIS, 
     .              arg_lo_ss(Z_AXIS,ARG1),arg_hi_ss(Z_AXIS,ARG1), zW)
      i  = res_lo_ss(X_AXIS)
      i1 = arg_lo_ss(X_AXIS,ARG1) 
      i2 = arg_lo_ss(X_AXIS,ARG2) 
      j  = res_lo_ss(Y_AXIS)
      j1 = arg_lo_ss(Y_AXIS,ARG1) 
      j2 = arg_lo_ss(Y_AXIS,ARG2) 
      l1 = arg_lo_ss(T_AXIS,ARG1) 
      l2 = arg_lo_ss(T_AXIS,ARG2) 
      DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         iZ = 1
         k1 = arg_lo_ss(Z_AXIS,ARG1)
         k2 = arg_lo_ss(Z_AXIS,ARG2)
         DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

           !  ARG_1 = w     ARG_2 = u4

           IF(k.EQ.res_lo_ss(Z_AXIS))THEN
              dz = 100. * (zW(1)+zW(2))/2.
              result(i,j,k,l) = ARG_1(i1,j1,k1,l1)/2.
     .                   *(ARG_2(i2,j2,k2,l2)-
     .                        ARG_2(i2,j2,k2+1,l2))/dz
           ELSEIF(k.EQ. res_hi_ss(Z_AXIS))THEN  ! last z point
              result(i,j,k,l) =  result(i,j,k-1,l)
           ELSE
              dz = 100. * (zW(iZ+1)-zW(iZ-1))/2.
              result(i,j,k,l) = (ARG_1(i1,j1,k1,l1) +
     .                            ARG_1(i1,j1,k1+1,l1))/2
     .                   *(ARG_2(i2,j2,k2,l2)-
     .                        ARG_2(i2,j2,k2+1,l2))/dz    
           ENDIF
           iZ = iZ + 1
           k1 = k1 + arg_incr(Z_AXIS,ARG1)
           k2 = k2 + arg_incr(Z_AXIS,ARG2)
         ENDDO 
         l1 = l1 + arg_incr(T_AXIS,ARG1)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
      ENDDO               
      END				

      SUBROUTINE MERGE_AXIS_WITH_OFFSETS( dflt_cx, mrg_cx, com_cx, 
     .     idim, lo_off, hi_off )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Take an argument axis which has offsets and merge it into the
* result context.

*     JC_TODO: Explanation of logic and scenarios

* programmer - jonathan callahan
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V500:  4/9/98   - extracted from merge_context
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V685  *acm* 12/13 Fix bug in 6D Ferret decclarations, lo_off and hi_off
* V695  *acm* 2/15 cx_calendar stores info about calendar formatting of T and F axes

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'

* calling argument declarations
	INTEGER	dflt_cx, mrg_cx, com_cx, idim, lo_off(*), hi_off(*)

* local variable declarations
	INTEGER	temp_ss, ui4


*     do the following for cx_lo_ss and then cx_hi_ss
*     If the default context is undefined
*        get argument context (undo offsets)
*        If merge context is undefined:    use arg context
*        Else:                             use intersection of mrg_cx and arg cx
*        Endif
*     Else context is defined
*        merge context = default context
*        prefill with missing value flag
*     Endif

        ui4 = unspecified_int4

        IF ( cx_lo_ss(dflt_cx,idim) .EQ. ui4 ) THEN
           temp_ss = cx_lo_ss(com_cx, idim) - lo_off(idim)
           IF ( cx_lo_ss(mrg_cx,idim) .EQ. ui4 ) THEN
              cx_lo_ss(mrg_cx,idim) = temp_ss
           ELSE
              cx_lo_ss(mrg_cx,idim) = 
     .             MIN(cx_lo_ss(mrg_cx,idim),temp_ss)
           ENDIF

        ELSE
           cx_lo_ss(mrg_cx,idim) = cx_lo_ss(dflt_cx,idim)
*     prefill with bad flags

        ENDIF
        
        IF ( cx_hi_ss(dflt_cx,idim) .EQ. ui4 ) THEN
           temp_ss = cx_hi_ss(com_cx,idim) - hi_off(idim)
           IF ( cx_hi_ss(mrg_cx,idim) .EQ. ui4 ) THEN
              cx_hi_ss(mrg_cx,idim) = temp_ss
           ELSE
              cx_hi_ss(mrg_cx,idim) = 
     .             MIN(cx_hi_ss(mrg_cx,idim),temp_ss)
           ENDIF

        ELSE
           cx_hi_ss(mrg_cx,idim) = cx_hi_ss(dflt_cx,idim)
*     prefill with bad flags

        ENDIF


*     JC_TODO: should I implement pieces of code from TRANSFER_AXIS?
*
*	cx_lo_ss ( dest, idim )   = cx_lo_ss ( source, idim )
*	cx_hi_ss ( dest, idim )   = cx_hi_ss ( source, idim )
*	cx_lo_ww ( idim, dest )   = cx_lo_ww ( idim, source )
*	cx_hi_ww ( idim, dest )   = cx_hi_ww ( idim, source )
*	cx_trans ( idim, dest )   = cx_trans ( idim, source )
*	cx_by_ss ( idim, dest )   = cx_by_ss ( idim, source )
*	cx_given ( idim, dest )   = cx_given ( idim, source )
*	cx_trans_arg(idim, dest)  = cx_trans_arg(idim, source)
** 8/97 *kob* 	
*	IF (idim .EQ. t_dim .OR. idim .eq. f_dim) 
*     .        cx_calendar(idim,dest) = cx_calendar(idim,source)


* successful completion
 100	RETURN
	END

	SUBROUTINE GET_LINE_DYNMEM( rqst_size, iaxis, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* allocate the requested amount of dynamic coordinate storage (using c or python malloc)
* malloc is done in c (or python), but has to call back into F90 to set pointer
* the hierarchy of calls is as follows for allocating memory for coordinate storage.
*   get_ax_linemem.F ==> get_ax_mem.c ==> store_line_ptr.F

* programmer - Ansley Manke
* V72 6/17 *acm* For trac enhancement #767 -- dynamic coordinate storage 
*                Following main-memory dynamic allocation methods

                
        IMPLICIT NONE
	include	'tmap_dims.parm'
	include 'errmsg.parm'
	include	'ferret.parm'
#       include "tmap_dset.parm"
        include 'xtm_grid.cmn_text'
        external xgt_grid_data
	include 'xvariables.cmn'
	include 'xprog_state.cmn'

* calling argument declarations:
	INTEGER	iaxis, status
	INTEGER rqst_size

* internal variable declarations:

	INTEGER*8 i8_rqst_size

	i8_rqst_size = rqst_size

	IF (line_allocated (iaxis) .GT. 0) THEN

	   IF (line_use_cnt(iaxis) .LE. 0) THEN
 	      IF ( iaxis .LE. max_lines ) THEN
 	         CALL FREE_LINE_DYNMEM ( iaxis )  ! checks that irreg coords are stored
		 line_name(iaxis) = char_init16
 	      ENDIF
 	   ENDIF

	ENDIF

* allocate the dynamic memory
        CALL GET_LINEMEM(iaxis, i8_rqst_size, status)
        IF (status .NE. ferr_ok) GOTO 5300

* and for edges
	i8_rqst_size = rqst_size + 1
        CALL GET_EDGMEM(iaxis, i8_rqst_size, status)
        IF (status .NE. ferr_ok) GOTO 5300

	line_allocated (iaxis) = rqst_size
	RETURN


***********************
* error exits
 5000	RETURN

 5300	CALL ERRMSG( ferr_insuff_memory,status,' ', *5310)
 5310	CALL SPLIT_LIST(pttmode_explct, show_lun,
     .		'    The OS refuses to supply memory for coordinate storage',0 )

        GOTO 5000

	END

	SUBROUTINE TM_TRANSLATE_LAT_LONG (string,idim,answer,status)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* convert an ascii representation of a latitude or longitude value into 
* a floating point value using special format rules
*
* possible formats:
*   x coord:  #  or #E  or  #W  for East  or West,  respectively
*   y coord:  #  or #S  or  #N  for South or North, respectively
*   z coord:  #
*   t coord:  #  or dd-mmm-yyyy@hh-mm-ss  eg 14-JAN-1986@11:15
*
* programmer - Mark Verschell
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.00 - 12/14/88 - from program by Steve Hankin
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* include files
	include 'tmap_errors.parm'
#include "gt_lib.parm"


	CHARACTER*(*)	string
	LOGICAL		n_given, s_given, e_given, w_given
	INTEGER		n_pos, s_pos, e_pos, w_pos, end_pos, status, idim
	REAL*8		answer

* initialize
	n_pos = MAX ( INDEX(string,'N'), INDEX(string,'n') )
	s_pos = MAX ( INDEX(string,'S'), INDEX(string,'s') )
	e_pos = MAX ( INDEX(string,'E'), INDEX(string,'e') )
	w_pos = MAX ( INDEX(string,'W'), INDEX(string,'w') )

	n_given = n_pos .GT. 0
	s_given = s_pos .GT. 0
	e_given = e_pos .GT. 0
	w_given = w_pos .GT. 0

* how much of the string is numeric ?
	end_pos = LEN ( string )
	IF ( n_given.OR.s_given.OR.e_given.OR.w_given )	end_pos = end_pos - 1

* decode the value
	READ ( string(1:end_pos), * , ERR=9000 ) answer

* make corrections for latitude/longitude notation
	IF  ( n_given ) THEN

* latN - no change
	  IF ( idim .NE. y_dim ) GOTO 9000
	ELSEIF ( s_given ) THEN

* latS - make negative
	  IF ( idim .NE. y_dim ) GOTO 9000
	  answer = -answer
	ELSEIF ( e_given ) THEN

* longE - no change
	  IF ( idim .NE. x_dim ) GOTO 9000
	ELSEIF ( w_given ) THEN

* longW - convert	
	  IF ( idim .NE. x_dim ) GOTO 9000
	  answer = 360. - answer
	ENDIF

	status = merr_ok
	GOTO 9990

* errors
 9000	CALL TM_ERRMSG ( merr_syntax, status, 'TM_TRANSLATE_LAT_LONG',
     .	                 no_descfile, no_stepfile, 
     .			 string, no_errstring, *9990 )

 9990	RETURN
	END

        SUBROUTINE DSG_TRAJ_PLOT_SET_UP( 
     .				overlay, no_labels, symbol, sym_size, color, 
     .				color1, use_line, do_dash, dashstyle, nokey,
     .				is_traj, only_val, skipsym, mv_list, 
     .				cx_list, nmv, indep_dat, dep_dat, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* set up for line plot by loading data and title and defining axis formats

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - SDIG
*
* based on plot_set_up, Set up to draw trajectory plots from a dsg trajectory dataset
* v7.4+ *acm* 7/2018 color-by trajectory, even if the trajectory variable is a string.
* v7.4+ *acm* 7/2018 set up colorbar as for ribbon plots
* V7.4+ *acm*  8/18 DSG-enabled Ferret: line-key labels may be strings or numeric values
*                    from a feature-direction metadata variable.
* V7.4+ *acm* 10/18 Handle single-point trajectories: plot a symbol
* V7.5+ *acm*  6/19 Better handling of plotting longitudes without branch jumps.  
*                   Do masking correctly.
* V7.51 *acm*  8/19 getting min/max of longitudes and latitudes
* V7.51 *acm*  8/19 Ticket 1953, masking and min/max of dependent axis data
* V7.6  *acm*  1/20 Set up for plotting Points-type datasets as ribbon plots
*                   with symbols. Flag is_traj indicates trajectory data type
* V7.6  *acm*  3/20 Ignore PLOT/LEVELS=v when color=by the id_variable. This 
*                   doesn't make sense and makes a screwy plot.
* V760 *acm* 3/20 Customize plot for case when constraints result in no features
* V760 *acm* 4/20 PLOT_DSG_CHECK_LON360 now applies a lon-360 conversion of the 
*                 longitudes if it'll be better and /HLIM not given
* V760 *acm* 5/20 initialize dep_dim. Was unset when we get latitude from the DSG dataset

	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
        include 'xunits.cmn_text'
	include 'ferret.parm'
	include 'plot_setup.parm'
	include 'errmsg.parm'
	include 'slash.parm'
	include 'xplot_setup.cmn'
	include 'xcontext.cmn'
	include 'xdsg_context.cmn'
	include 'xvariables.cmn'
	include 'xdset_info.cmn_text'
	include 'xdyn_linemem.cmn_text'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'
	include 'xtext_info.cmn'
        include 'axis_inc.decl'    ! with axis lengths
        include 'AXIS.INC'         ! with axis lengths	
	include 'taxis_inc.decl'
	include 'TAXIS.INC'
	include 'PPLDAT.INC'
        include 'switch_inc.decl'
        include 'SWITCH.INC'

* calling argument declarations:
	LOGICAL		overlay, no_labels, use_line,
     .			nokey, is_traj
	INTEGER		symbol, color, color1, do_dash, skipsym,
     .			nmv, mv_list( nmv ), cx_list( nmv ), status
	REAL		sym_size, dashstyle(*), only_val
	REAL		indep_dat(*), dep_dat(*)     ! dynamic space allocation
 
* V500 *kob* 3/99- up VAR_CODE and VAR_UNITS to 64 chars
* internal variable declarations:

	LOGICAL		NO_LINE_RANGE, GEOG_LABEL, TM_ITSA_DSG_RAGGED,
     .			versus, all_1_ind, all_1_dep, formatted, use_nice, 
     .			this_no_range(max_line_on_plot), indep_is_log, set_lev, 
     .			its_dsg, mask_applied, user_hlim
	CHARACTER*2040	plot_title
	CHARACTER	LEFINT*8, LEFT_REAL*16, FULL_VAR_TITLE*2040,
     .			indep_ax*1, dep_ax*1, tstyle*3, 
     .			buff1*40, buff2*16, t1_date*14, tref*14, fmt*4
	INTEGER		TM_LENSTR1, CGRID_SIZE, CGRID_AXIS, 
     .			TM_DSG_DSET_FROM_GRID, TM_DSG_NFEATURES, TM_DSG_OBS_GRID,
     .			mv, cx, slen, ito, indep_lab, dep_lab, nline_in_mem,
     .			indep_dim, npts, dep_dim, npts2, ndv, var1,
     .			grid, grid1, ipl, ndim, dims(6),
     .			slen2, slen3, tax, plot_mem_used, i,
     .			pxlim, pylim, phlim, pvlim, pindeplim, pdeplim,
     .			dep_axtyp, indep_axtyp, the_taxis, ribbon_var, 
     .			gap_var, iiunits, iaxis, hblk1, mvh_temp, 
     .			nkey_entries, itmp, igrd_save, cal_id_1,
     .			icode, dset, nfeatures, obsdimlen, fline,
     .			idim, coord_lm, ivar, ptitl, dim(nferdims), numcx,
     .			dep_nok, indep_nok, line_symbol, nmasked 

        INTEGER         iunits, junits
	CHARACTER*1     axdir(nferdims), ax1

	REAL		val1, dt_min, lo, hi, dep_len, 
     .			ind_len, first, last, hlen, dep_lo, 
     .			dep_hi, indep_lo, indep_hi
	REAL		ind_min, ind_max, dep_min, dep_max, 
     .			delta, tmp, labsize
	REAL*4 rbad

* local parameter declarations:
	LOGICAL		range_rqd
	PARAMETER     ( range_rqd = .TRUE. )
	DATA axdir / 'X', 'Y', 'Z', 'T', 'E', 'F' /

* signal that plot set-up has begun
	IF ( mode_diagnostic ) CALL SPLIT_LIST(pttmode_ops, ttout_lun,
     .				'setting up plot', 15)

* initialize

	ind_max = arbitrary_small_val8
	ind_min = arbitrary_large_val8
	versus = .TRUE.
	cx   = cx_list( nmv )
	mv   = mv_list( nmv )
	indep_dim = plot_axis(1)
	dep_dim = plot_axis(2)
	nline_in_mem = 0
	phlim = qual_given( slash_hlimits )
	pvlim = qual_given( slash_vlimits )
	pxlim = qual_given( slash_xlimits )	! deprecated
	pylim = qual_given( slash_ylimits )	! deprecated
	dep_axtyp = 1
	indep_axtyp = 1
	indep_is_log = .FALSE.
	mod_vs_x = .FALSE.
	mod_vs_y = .FALSE.
        nkey_entries = nmv
	itmp = mnormal
	icode = 0
	ribbon_var = 1
	hlen = xlen 
	line_symbol = symbol

	! dummy values
	cal_id_1 = 0
	t1_date = ' '
	tref = ' '

* For DSG dataset get number of features and obsdimlen

	grid1 = cx_grid( cx )

	IF (  qual_given(slash_plot_along) .GT. 0 )  
     .	       CALL WARN ('PLOT/ALONG is ignored for discrete DSG data')
	grid = cx_grid(is_cx(nmv))
	dset = TM_DSG_DSET_FROM_GRID( grid )
	nfeatures = TM_DSG_NFEATURES( grid )
	its_dsg = .TRUE.    
	CALL TM_DSG_FACTS( grid, idim, obsdimlen, fline, its_dsg )
	IF (.NOT. its_dsg) GOTO 5200

* The variable may be on the feature-axis. We will deal with that later but
* for getting the lon/lat data we need the obs grid.

         IF ( .NOT. TM_ITSA_DSG_RAGGED( grid ) ) THEN
	    indep_dim = idim
	    grid1 = TM_DSG_OBS_GRID(dset)
	 ENDIF
 

* check for improper data supplied
	IF ( overlay ) THEN
	   CALL GET_CX_DIMS( cx, ndim, dims )
           IF ( twodee_on ) indep_dim = dims(1)       ! 3/93
	   IF ( ndim.NE.1 .OR. dims(1).NE.indep_dim ) GOTO 5120
	ELSE
	   ndim = nplot_axis
	   IF ( ndim .GT. 1 ) GOTO 5110
	ENDIF

* Overlay plots, keep the setting of IAUTOT that was set on the underlay plot.

	IF (overlay) THEN
	   iautot_save = iautot
	   iautot = 0
	ENDIF

	dep_ax    = 'Y'
	indep_ax  = 'X'
	dep_lab   = ppl_ylab
	indep_lab = ppl_xlab
	ind_len   = xlen
	dep_len   = ylen
	IF ( pxlim.GT.0 ) THEN
	   pindeplim = pxlim
	ELSE
	   pindeplim = phlim
	ENDIF 
	IF ( pylim.GT.0 ) THEN
	   pdeplim = pylim
	ELSE
	   pdeplim = pvlim
	ENDIF

* do not re-draw the main label, logo, other labels from the underlay plot
	IF (overlay) THEN
	   nlabs_on = 0  
	   CALL PPLCMD ( from, line, 0, 'LABS ', 1, 1 )	
	ENDIF

	IF ( no_labels ) CALL PPLCMD ( from, line, 0, 'LABS ', 1, 1 )

	var1 = 1        ! The variable sent in is the color-by variable.
	ndv  = 1	! # of dependent variables

* * * * * * *    - - - INDEPENDENT AXIS DATA - - - * * * * * * * * *
	
* Get the LONGITUDE coordinate data

	idim = 1
	iaxis = grid_line(idim, dsg_xlate_grid(dset))
	iunits = line_unit_code ( iaxis )
	IF (iunits .NE. 4) GOTO 5130  ! must be longitude coordinates

	IF ( line_dim (iaxis) .NE. obsdimlen) GOTO 5140 

	ivar = dsg_coord_var(idim,dset)
	coord_lm = dsg_loaded_lm(ivar)  ! line memory table indices

	DO i = 1, obsdimlen
	   indep_dat(i) = dsg_linemem(coord_lm)%ptr(i)
	ENDDO

	npts = obsdimlen

	IF (nmv .GT. 1) THEN
	   cx = cx_list(1)
	   mv = mv_list(1)
	   indep_dim = plot_axis(1)
	   CALL EXTRACT_LINE ( cx,
     .                      memry(mv)%ptr,
     .                      mv,
     .                      indep_dat,
     .                      indep_dim,
     .                      ndim,
     .                      npts,
     .                      status)
	   IF (npts .NE. obsdimlen) THEN
	      status = 0
	      GOTO 5140
	   ENDIF
	   numcx = 1  ! The context should come from the color-by var
	   CALL GRP_CX_DOC( cx_list(nmv), numcx, cx_plot, key_doc )
	ENDIF	

*  Check for longitudes crossing the dateline. Looks only at location data in features
*  included in any feature-level mask, which is applied in PLOT_DSG_APPLY_OBS_MASK

	user_hlim = pindeplim .GT. 0
	CALL PLOT_DSG_CHECK_LON360 (dset, cx_list(nmv), indep_dat, bad_val4, 
     .                    npts, nfeatures, ind_min, ind_max, user_hlim)

* ... Apply an obs mask if any - this will cause the right range to be set on the
*     lon/ lat axes

	cxdsg_empty_set = .FALSE.

	CALL PLOT_DSG_APPLY_OBS_MASK (dset, cx_list(nmv), nfeatures, obsdimlen, 
     .		   indep_dat, nmasked)
     

! Or set npts = 2, and use cx_lo_ww and cx_hi_ww if they are the requested constraints...

	IF (nmasked .EQ. 0) THEN
	   cxdsg_empty_set = .TRUE.
	   cxdsg_orient = dsg_orientation(dset)

	   indep_nok = 0
	   nmasked = 2
	   sym_size = 0.001
	   nokey = .TRUE.
	   qual_given(slash_plot_nokey) = 1
	   nokey = .TRUE.

	   delta = unspecified_val8
	   ind_min = cx_lo_ww(x_dim, cx)
	   ind_max = cx_hi_ww(x_dim, cx)

	   ! Check against dsg lon coord range usin MODSCAT as in MAKE_DSG_OBS_MASK

	   indep_dat(1) = bad_val4 
	   indep_dat(2) = bad_val4
	ELSE
	   mask_applied = nmasked .LT. npts
	   CALL MINMAX( indep_dat, nmasked, bad_val4, ind_min, ind_max, indep_nok )

* ... force axis scaling if the data has no range
	   all_1_ind = NO_LINE_RANGE( indep_dat, nmasked, mr_bad_data(mv), val1 )
	   delta = unspecified_val8

	   IF ( pindeplim .GT. 0 ) THEN
	      IF ( pxlim.GT.0 .AND. .NOT.denig_xylim_msg_done ) THEN
	         CALL WARN( '/XLIMITS and /YLIMITS are deprecated.')
	         CALL WARN( 'Use /HLIMITS and /VLIMITS instead.')
	         denig_xylim_msg_done = .TRUE.
	      ENDIF

              CALL EQUAL_RANGE(
     .			cmnd_buff(qual_start(pindeplim):qual_end(pindeplim)),
     .			indep_dim, ind_min, ind_max, delta,
     .			formatted, range_rqd, cal_id_1, status )

              IF ( status .NE. ferr_OK ) GOTO 5000

	   ELSEIF ( all_1_ind .AND. .NOT.overlay ) THEN
	      IF ( val1 .EQ. mr_bad_data(mv) ) THEN
	         delta = 1.
	         ind_min = 0.D0
	         ind_max = 1.D0
	      ELSE
	         delta = 1.
	         ind_min = val1 - delta
	         ind_max = val1 + delta
	      ENDIF
	   ELSE
	      CALL MINMAX( indep_dat, nmasked, bad_val4, lo, hi, indep_nok )
	      IF (indep_nok .EQ. 0) THEN ! all missing
	         ind_min = -1.
	         ind_max =  1.
	      ELSE
	         ind_min = lo
	         ind_max = hi
	      ENDIF
	   ENDIF

	ENDIF   ! cxdsg_empty_set 

* Set up independent axis for plotting

	IF (.NOT.overlay) THEN

	   CALL AXIS_ENDS(indep_ax,indep_dim,grid1,ind_min,ind_max,
     .                       delta, indep_is_log, indep_axtyp, versus, status)

	   IF ( status .NE. ferr_ok ) THEN
              first = ind_min
              last  = ind_max
	      GOTO 5170
	   ENDIF

* This routine checks the units and the setting for formatted lon/lat axes
* If the formatting has been turned off, resets iunits and flag mod_vs_x.

	   CALL GET_AXIS_FORMAT( ind_min, ind_max, delta, fmt, use_nice )
	   IF (cxdsg_empty_set) use_nice = .FALSE.
	   IF (use_nice) THEN
	      ppl_buff = 'XFOR,('//fmt(:TM_LENSTR1(fmt))//
     .                   ',''''LONE'''')'
	      CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
	      CALL LON_LAT_FMT (x_dim, 'X')
	      mod_vs_x = .TRUE.
	   ENDIF  
		  
           CALL PPLCMD ( from, line, 0, 'YFOR 0', 1, 1 ) ! for now, anyway	
	      
        ELSE ! overlay
           CALL PPLCMD ( from, line, 0, indep_ax//'FOR 0', 1, 1 )

           mod_vs_x = .TRUE.
           mod_vs_y = .FALSE.

	ENDIF

* set up PLOT5 to ignore bad data flag
	ppl_buff = ' '
	WRITE ( ppl_buff, 3005 ) bad_val4, indep_ax
	CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1)

 3005	FORMAT ( 'LIMITS ',G15.8,1X,A1,'EQ' )

	ind_min = val1 ! used in the case of only 1 valid data

* * * * * * *    - - - LATITUDE DATA - - - * * * * * * * * *

	IF (cxdsg_empty_set) THEN
	   npts2 = 2
	   dep_nok = 0
	   dep_min = cx_lo_ww(y_dim, cx)
	   dep_max = cx_hi_ww(y_dim, cx)
	   dep_dat(1) = bad_val4
	   dep_dat(2) = bad_val4

	ELSE

	   idim = 2
	   iaxis = grid_line(idim, dsg_xlate_grid(dset))
	   iunits = line_unit_code ( iaxis )
	   IF (iunits .NE. 4) GOTO 5130  ! must be latitude coordinates

	   IF ( line_dim (iaxis) .NE. obsdimlen) GOTO 5140 

	   ivar = dsg_coord_var(idim,dset)
	   coord_lm = dsg_loaded_lm(ivar)  ! line memory table indices

	   DO i = 1, obsdimlen
	      dep_dat(i) = dsg_linemem(coord_lm)%ptr(i)
	   ENDDO

	   all_1_dep = .TRUE.
	   only_val  = bad_val4

	   IF (nmv .GT. 1) THEN
            mv   = mv_list( 2 )
            cx   = cx_list( 2 )
            CALL EXTRACT_LINE (  cx,
     .                          memry(mv)%ptr,
     .                          mv,
     .                          dep_dat,
     .                          dep_dim,
     .                          ndim,
     .                          npts2,
     .                          status  )
	      IF (npts .NE. obsdimlen) THEN
	         status = 0
	         GOTO 5140
	      ENDIF
	   ENDIF

* ... Apply an obs mask if any - this will cause the right range to be set on the
*     lon/ lat axes

	   IF (mask_applied) CALL PLOT_DSG_APPLY_OBS_MASK (dset, cx_list(nmv), 
     .		   nfeatures, obsdimlen, dep_dat, nmasked)

* Set up the dependent axis.

	   all_1_dep = NO_LINE_RANGE( dep_dat, nmasked, bad_val4, val1 )
	   CALL MINMAX( dep_dat, nmasked, bad_val4, dep_lo, dep_hi, dep_nok )
	   IF (dep_nok .EQ. 0) THEN ! all missing
	      dep_min = -1
	      dep_max =  1
	   ELSE
	      dep_min = dep_lo
	      dep_max = dep_hi
	      IF (all_1_dep) THEN
	         delta = 1.
	         dep_min = dep_lo - delta
	         dep_max = dep_hi + delta
	      ENDIF
	   ENDIF

	ENDIF ! cxdsg_empty_set


	IF (.NOT.overlay) THEN

	   delta = unspecified_val8    
	   CALL AXIS_ENDS(dep_ax, dep_dim, grid1, dep_min, dep_max,
     .                      delta, indep_is_log, dep_axtyp, versus, status)

	   CALL GET_AXIS_FORMAT( dep_min, dep_max, delta, 
     .                 fmt, use_nice )
	   IF (cxdsg_empty_set) use_nice = .FALSE.
	   IF (use_nice) THEN
	      ppl_buff = 'YFOR,('//fmt(:TM_LENSTR1(fmt))//
     .                       ',''''LAT'''')'
	      CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
	   ENDIF
	ENDIF  ! not overlay

	IF ( all_1_dep ) only_val = val1

* pass the data to PLOT+

	   WRITE ( ppl_buff, 3005 ) bad_val4, dep_ax
	   CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )

	   IF (overlay) SOVER = .true.
	   icode = 0
	   npts2 = nmasked
	   IF (indep_nok.EQ.1 .OR. dep_nok.EQ.1) THEN
	      dep_dat(1) = dep_lo
	      indep_dat(1) = ind_min
	      npts2 = 1
	      indep_nok = 1
	      IF (line_symbol.EQ.qual_off .OR. 
     .            line_symbol.EQ.unspecified_int4) 
     .            line_symbol = qual_on  ! draw point with a symbol
	   ENDIF

	   
* set PLOT+ memory required, longitudes, latitudes, color var, gaps var

	   plot_mem_used = 2* 4* npts2

	   CALL PPLLDX_envelope(icode,indep_dat,dep_dat,npts2,
     .                             t1_date, tref, dt_min, plot_mem_used)

* ... increment number of lines on plot
	   nline_on     = nline_on     + 1
	   nline_in_mem = nline_in_mem + 1
	   CALL LINE_STYLE(line_symbol, sym_size, skipsym, color, color1, use_line,
     .			   do_dash, dashstyle, nline_in_mem, nline_on)

* * * * * * *    - - - LOAD DATA - - - * * * * * * * * *

* load color-by data into dep_dat

	ipl = nmv
	mv   = mv_list( ipl )
	cx   = cx_list( ipl )
	grid = cx_grid( cx )

* set up a color-by variable

	IF (cxdsg_empty_set) THEN
*          ... The dep_dat setup from above remains in place.
	   need_histo = .FALSE.
	   dep_min = -1.
	   dep_max =  1.
	   dep_dat(1) = 1.
	   dep_dat(2) = 1.
	   
	   CALL RIBBON_PLOTKEY_SETUP (overlay, status)
	ELSE


* ... For a dsg dataset, they can ask to color by a feature-level variable
*     such as an ID. That variable can be a string. Either way use it to 
*     create colorbar label strings and then set values to integer trajectory-
*     number for drawing the trajectories.

* determine 6D shape of context, get size of color var
	   CALL GET_CX_DIMS_ZERO( cx, ndim, dim )
	   dep_dim = dim(1)
	   npts2 = CGRID_SIZE(cx)

	   CALL EXTRACT_LINE (	cx,
     .				memry(mv)%ptr,
     .				mv,
     .				dep_dat,
     .				dep_dim,
     .				ndim,
     .				npts2,
     .				status	)
 
	   IF ( status .NE. ferr_ok ) GOTO 5000

* default color key
	   CALL RIBBON_PLOTKEY_SETUP (overlay, status)
	   IF (status .NE. ferr_ok) GOTO 5000

	   set_lev = .FALSE.  ! will auto-set levels

* If color by a nfeatures variable, expand to the length of the obs axis.
* If they didn't specify /LEVELS, set levels, use a centered-label color 
* key and label the key with the feature variable. Do this even for numeric 
* feature-id, label by feature variable, in order of feature number. These
* aren't taken to be increasing numeric values that could be used to set 
* numeric levels.

* Only do this for Trajetory data - for a dataset of type Points, number of points 
* is always number of features and features are length 1.

	   IF (npts2.EQ.nfeatures .AND. is_traj) THEN

	      IF (qual_given(slash_plot_levels) .EQ. 0) THEN
	         CALL SET_DSG_ID_LEV 
     .              (dset, cx, nfeatures, dep_dat, mr_type(mv), changed_key)
 
	        set_lev = .TRUE.
	      ELSE

* If they said /levels=v this doesnt make sense.  Just use linear levs.
	         IF (need_std) THEN
	            need_std = .FALSE.
	            CALL USE_LINEAR_LEVELS
	         ENDIF
	         set_lev = .TRUE.
	      ENDIF

	      IF (npts2 .EQ. nfeatures) THEN
	         DO i = 1, npts2
	            dep_dat(i) = i
	         ENDDO
	      ENDIF

* Expand feature number to fill the obs direction using the mask
	      CALL DSG_OBS_BY_FEATURE_VAR (dset, cx, nfeatures, obsdimlen, dep_dat)
	      npts2 = npts

* Set the cx_plot  limits from the command context so the plot labels will be correct
	      CALL DSG_ID_CX (cx, nfeatures)

	   ENDIF
	
	   IF (mask_applied) CALL PLOT_DSG_APPLY_OBS_MASK (dset, cx_list(nmv), 
     .		   nfeatures, obsdimlen, dep_dat, nmasked)
	
* Compute the mean and standard dev for ribbon-color variable, 
	   CALL MINMAX( dep_dat, nmasked, bad_val4, dep_min, dep_max, dep_nok )

* Compute the mean and standard dev for ribbon-color variable, 
* needed for computing color levels. Results stored in PPLUS common.
* If histogram-based levels are requested, compute the 
* histogram bins.
* send REAL*4 rbad to compare with lev_max, lev_min inside compute_mnstd
* If the user set some /LEVELS then compute_mnstd just returns 


	ENDIF ! cxdsg_empty_set


	IF (need_histo) THEN
* create temporary buffer to contain workspace
	   CALL CREATE_TEMP_MEM_VAR( cx, mvh_temp, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   plot_mem_used = plot_mem_used + 2* npts
	   CALL COMPUTE_HISTO_BINS (dep_dat, memry(mvh_temp)%ptr, 
     .            mr_bad_data(mv), nmasked, status) 
     
* ... clean up temporary variable
	   CALL DELETE_VARIABLE( mvh_temp )
	ELSE IF (.NOT.set_lev) THEN
	   rbad = bad_val4
	   CALL COMPUTE_MNSTD (dep_dat, mr_bad_data(mv), need_std, nmasked, rbad, status)

	   IF (need_std .AND. status.NE.ferr_ok) THEN
* ... set up for automatic levels
	      CALL PPLCMD ( from, line, 0, 'LEV,()', 1, 1 )
	      CALL USE_LINEAR_LEVELS
	      status = ferr_ok
	   ENDIF

	ENDIF
 
* pass the data to PLOT+

	WRITE ( ppl_buff, 3005 ) mr_bad_data( mv ), dep_ax
	
	
	CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )

	IF (overlay) SOVER = .true.

* See pplldx comments. When loading the color-by variable lon vertical time axis
* this forces the right combination of settings.

	icode = 2
	IF (indep_nok .EQ. 1) THEN
	   dep_dat(1) = dep_min
	   npts = 1
	ENDIF
	CALL PPLLDX_envelope(icode,indep_dat,dep_dat,nmasked,
     .                             t1_date, tref, dt_min, plot_mem_used)

* ... increment number of lines on plot
	nline_on     = nline_on     + 1
	nline_in_mem = nline_in_mem + 1

* ... assign line style for the data plotting:
	CALL LINE_STYLE(line_symbol, sym_size, skipsym, color, color1, use_line,
     .			   do_dash, dashstyle, nline_in_mem, nline_on)
 
*     Create a gaps-variable. Any masking is applied as the gaps are marked.

	IF (indep_nok .EQ. 1) THEN
	   dep_dat(1) = 1.
	   npts = 1
	ELSE
	   IF (.NOT.cxdsg_empty_set) CALL DSG_OBS_MARK_GAPS (dset, cx, nfeatures, obsdimlen, dep_dat)
	ENDIF
	
	CALL PPLLDX_envelope(icode, indep_dat, dep_dat, nmasked,
     .                             t1_date, tref, dt_min, plot_mem_used)

	nline_on     = nline_on     + 1
	nline_in_mem = nline_in_mem + 1

	ppl_buff = ' '
	gap_var = 4
	WRITE ( ppl_buff, 3007 ) gap_var
	CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1)
 3007	FORMAT ( 'GAPLOC ',I5 )

	CALL LINE_STYLE(line_symbol, sym_size, skipsym, color, color1, use_line,
     .			   do_dash, dashstyle, nline_in_mem, nline_on)

        nline_on = nline_on + color1 - 1

* axis scaling and formatting apply possible user settings
* ... independent axis

	IF ( .NOT.overlay ) THEN

* ... dependent axis scaling
*  force axis scaling if the data has no range

	   IF ( pdeplim .GT. 0 ) THEN
	      IF (pylim.GT.0 .AND. .NOT.denig_xylim_msg_done) THEN
	         CALL WARN( '/XLIMITS and /YLIMITS are deprecated.')
	         CALL WARN( 'Use /HLIMITS and /VLIMITS instead.')
	         denig_xylim_msg_done = .TRUE.
	      ENDIF

	      CALL EQUAL_RANGE(
     .			cmnd_buff(qual_start(pdeplim):qual_end(pdeplim)),
     .			dep_dim, dep_min, dep_max, delta,
     .			formatted, range_rqd, cal_id_1, status )
	      IF ( status .NE. ferr_OK ) GOTO 5000

	      CALL AXIS_ENDS( dep_ax, the_taxis, grid, dep_min, dep_max, 
     .                        delta, indep_is_log, dep_axtyp, versus, status )
	      IF ( status .NE. ferr_OK ) THEN
                 first = dep_min
                 last  = dep_max
                 GOTO 5170
              ENDIF

	   ELSEIF ( all_1_dep ) THEN
	      IF (only_val .EQ. bad_val4) val1 = 0.0	! 10/99
	      delta = 1.
	      IF (val1 .NE. 0) delta = 0.1* val1
	      
	      CALL AXIS_ENDS( dep_ax, the_taxis, grid,val1-delta,val1+delta,delta,
     .                        indep_is_log, dep_axtyp, versus, status )   
	      IF ( status .NE. ferr_OK ) THEN
                  first = val1-delta
		  last  = val1+delta
		  GOTO 5170
	      ENDIF   

	   ENDIF

           ax1 = axdir(indep_dim)
  	   CALL PPLCMD ( from, line, 0, 'SET AX_HORIZ '//ax1, 1, 1 )
	ENDIF

*  TITLES
* Main plot title. Add a "Colored by var2" label for the ribbon color variable
*
	hlen = xlen ! single-precision xlen from PPLUS common -> double prec. var

	IF ( .NOT.no_labels ) 
     .          CALL LINE_PLOT_LABELS (var1, nkey_entries, ndv, cx_list, 
     .		this_no_range, overlay, versus, nokey, .FALSE., 
     .		tstyle, cal_id_1, ribbon_var, indep_lab, dep_lab, 
     .		ind_min, dep_len, hlen, nfeatures, dset, 
     .		dsg_feature_var(dset) )

* set flag indicating a 2D plot is on the screen, and now that things are set up,
* tell any subsequent plots that it's an XY plot
	IF (.NOT.overlay) twodee_on = .TRUE.

	plot_axis(1) = 1
	plot_axis(2) = 2

* successful completion

	status = ferr_ok
	IF (overlay) iautot = iautot_save
	RETURN

* error exit
 5000	CALL PPLCMD ( from, line, 0, 'NLINES', 1, 1 )	! wipe buffers clean
 	IF (itmp .NE. mnormal) CALL TM_DEALLO_DYN_LINE( itmp )
	RETURN

 5110	dep_ax = LEFINT( ndim, slen )
	CALL ERRMSG( ferr_dim_underspec, status, 
     .			'specified data is not a line'//pCR//
     .			' - its a '//dep_ax(:slen)//'D region: "'//
     .			cmnd_buff(:len_cmnd)//'"', *5000 )
 5120	CALL ERRMSG( ferr_dim_underspec, status, 
     .			'overlay is on a different axis'//pCR//
     .			'"'//cmnd_buff(:len_cmnd)//'"', *5000 )

 5130	CALL ERRMSG( ferr_dim_underspec, status, 
     .			'longitude,latitude coordinate variables not found'//pCR//
     .			'Is this a trajectory dataset?'//pCR//
     .			'"'//cmnd_buff(:len_cmnd)//'"', *5000 )
        
 5140	CALL ERRMSG( ferr_dim_underspec, status, 
     .			'longitude,latitude coordinates must be on observation-axis'//pCR//
     .			'Is this a trajectory dataset?'//pCR//
     .			'"'//cmnd_buff(:len_cmnd)//'"', *5000 )
     
        
 5150	CALL ERRMSG( ferr_data_type, status, 
     .			'Cannot plot data type of string on the observation axis'//pCR//
     .			'"'//cmnd_buff(:len_cmnd)//'"', *5000 )
        

 5170	buff1 = LEFT_REAL (first, '(G15.3)', slen)
	buff2 = LEFT_REAL (last, '(G15.3)', slen2)
	CALL ERRMSG( ferr_out_of_range, status,
     . 'Limits for log axis negative or too small: '//
     .  buff1(:slen)// ' : '//  buff2(:slen2), *5000 )

 5200	CALL ERRMSG( ferr_grid_definition, status,
     .		'Data grid is not a DSG grid ',
     .		*5000 )

	END

      SUBROUTINE getlabfonts (lab, lnbeg, lnend, jln, fontprefix,
     .          npnew, nfnew, newfont, newpen, nchr)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* v580 10/05 *acm* Fix for bug1003; pen may be changed by @Cnnn as well
*                  as @Pn. In saving info about color/font changes from
*                  one line to the next in multi-line lables, allow for
*                  @Cnnn syntax.
* V683 12/12 *acm* Fix for applying a font setting in multiple line labels
* V69+  5/14 *acm* Fix for ascii font in multi-line labels, ticket 2176

* Argument declarations

      CHARACTER*(*) lab, newfont, newpen, fontprefix
      INTEGER lnbeg(*), lnend(*), npnew, nfnew, nchr, jln

* Local variable definitions

      CHARACTER*1 fcode, fnext, ichr
      INTEGER TM_LOC_STRING, ioc, loc, ii, eloc
      LOGICAL digit, isc, ascfnt

      npnew = 0
      nfnew = 0
      newfont = ""
      newpen = ""

* Is the current setting an ASCII font
      ascfnt = (fontprefix(1:2).EQ.'@A' .OR. fontprefix(1:2).EQ.'@a') 

      nchr = lnend(jln) - lnbeg(jln) + 1
      ioc = 0
      loc = TM_LOC_STRING(lab(lnbeg(jln):lnend(jln)),"@",ioc)

      IF ( loc .GT. 0) THEN

* Is the ASCII font escaped before the first font/pen setting?
         DO ii = lnbeg(jln), lnbeg(jln)+loc
            ichr = lab(ii:ii)
            IF (ichar(ichr) .eq.27 .AND. ii .LT. lnbeg(jln)+loc+1) THEN
               ascfnt = .FALSE.
	       eloc = ii
	       GOTO 100
	    ENDIF
         ENDDO
 100     CONTINUE

* Font/pen settings are only applied if it's not the ascii font or
* the @ was escaped.

	 IF (.NOT. ascfnt) THEN
            fcode = lab(lnbeg(jln)+loc:lnbeg(jln)+loc)
	    fnext = lab(lnbeg(jln)+loc+1:lnbeg(jln)+loc+1)
   
	    digit = (fcode .EQ. 'C'  .OR.  fcode .EQ. 'c') 
	    digit = ( fnext .GE. '0' .AND. fnext .LE. '9')
	    isc = ((fcode .EQ. 'C'  .OR.  fcode .EQ. 'c') .AND.digit) 

            IF (fcode .EQ. 'P'  .OR.  fcode .EQ. 'p') THEN
               newpen(1:3) = lab(lnbeg(jln)+loc-1:lnbeg(jln)+loc+1)
               npnew = 3
            ELSE IF ((fcode .EQ. 'C'  .OR.  fcode .EQ. 'c') .AND.digit) THEN
               newpen(1:5) = lab(lnbeg(jln)+loc-1:lnbeg(jln)+loc+3)
               npnew = 5
            ELSE 
               newfont(1:3) = lab(lnbeg(jln)+loc-1:lnbeg(jln)+loc+1)
               nfnew = 3

            ENDIF
	 ENDIF
         nloc = loc

* Is the current setting an ASCII font
         ascfnt = (fontprefix(1:2).EQ.'@A' .OR. fontprefix(1:2).EQ.'@a') 

! Save the last pen and font change on this line.

         DO WHILE (nloc .NE. 0) 
            ioc = ioc + 1
            nloc = TM_LOC_STRING(lab(lnbeg(jln):lnend(jln)),"@",ioc)
            IF (nloc .GT. 0) THEN

* Is the ASCII font escaped before the first font/pen setting?
               DO ii = eloc+1, lnbeg(jln)+nloc+1
                  ichr = lab(ii:ii)
                  IF (ichar(ichr) .eq.27 .AND. i .LT. lnbeg(jln)+nloc+1)  THEN
                     ascfnt = .FALSE.
	             GOTO 200
                  ENDIF
               ENDDO
 200           CONTINUE

* Font/pen settings are only applied if it's not the ascii font or
* the @ was escaped.

	       IF (.NOT. ascfnt) THEN
                  fcode = lab(lnbeg(jln)+nloc:lnbeg(jln)+nloc)
                  IF (fcode .EQ. 'P'  .OR.  fcode .EQ. 'p') THEN
                    newpen(1:3) = lab(lnbeg(jln)+nloc-1:lnbeg(jln)+nloc+1)
                    npnew = 3
                  ELSE IF (fcode .EQ. 'C'  .OR.  fcode .EQ. 'c') THEN
                    newpen(1:5) = lab(lnbeg(jln)+nloc-1:lnbeg(jln)+nloc+3)
                    npnew = 5
                  ELSE

                    newfont(1:3) = lab(lnbeg(jln)+nloc-1:lnbeg(jln)+nloc+1)
                    nfnew = 3
                  ENDIF

	       ENDIF ! .not.ascfnt

            ENDIF ! nloc.gt.0
	    	       
         ENDDO ! while nloc eq 0

      ENDIF    ! loc gt 0

      RETURN
      END

	LOGICAL FUNCTION UNIT_CHG_AX( cx, idim, trans )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* if a transformation has changed the units of this variable return the info

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:   1/12/90
* V420: send back the transformation that has been applied
* V603 5/07  *acm* - added MODNBD modulo regridding statistic
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'xcontext.cmn'

* calling argument declarations
	INTEGER	cx, idim, trans

* internal variable declarations
* ...

* transformations are performed from x to t order.
* It is the LAST transformation that determines the units (at least so far)
* (probably a very imperfect test ... 11/95)
	DO 100 idim = nferdims, 1, -1
	   IF ( cx_trans(idim,cx) .EQ. trans_locate ) THEN
	      trans = punit_mod_loc
	      GOTO 200
	   ELSEIF (cx_trans(idim,cx) .EQ. trans_variance
     .	     .OR. ( cx_unstand_grid(cx)
     .	      .AND. (cx_regrid_trans(idim,cx).EQ.prgrd_variance
     .	        .OR. cx_regrid_trans(idim,cx).EQ.prgrd_modvar)  ) ) THEN
	      trans = punit_mod_variance
	      GOTO 200
	   ELSEIF (cx_trans(idim,cx) .EQ. trans_bad_pt
     .	      .OR. cx_trans(idim,cx) .EQ. trans_good_pt
     .	      .OR. ( cx_unstand_grid(cx)
     .	       .AND. (cx_regrid_trans(idim,cx).EQ.prgrd_good_pt
     .		 .OR. cx_regrid_trans(idim,cx).EQ.prgrd_modngd
     .		 .OR. cx_regrid_trans(idim,cx).EQ.prgrd_modnbd)  ) ) THEN
	      trans = punit_mod_npoints
	      GOTO 200
	   ENDIF
 100	CONTINUE

* no unit change
	UNIT_CHG_AX = .FALSE.
	RETURN
	
* yes, unit change
 200	UNIT_CHG_AX = .TRUE.
	RETURN

	END

	INTEGER*4 FUNCTION TM_FIND_LIKE_GRID ( gridnum )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Check to see if an existing grid is identical to the grid pointed to by
* "gridnum".
*
* by M. Verschell PMEL/TMAP
*
* revision 0.00 - 05/18/88
* revision 0.01 - 11/21/88 - variable used check changed to specific char_initXX
* revision 1.0 - 2/92 *sh* - removed guts to TM_SAME_GRID_DEF
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* Include files
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'xtm_grid.cmn_text'
	external xgt_grid_data


* Argument definitions
	INTEGER*4   gridnum

* Local definitions
        LOGICAL     TM_SAME_GRID_DEF
	INTEGER*4   j

* Loop through the grids comparing the axis names
	DO 100 j = 1, max_grids
	  IF (grid_name(j).NE.char_init16 .AND. j.NE.gridnum) THEN
             IF ( TM_SAME_GRID_DEF( gridnum, j ) ) THEN
 	        TM_Find_like_grid = j
                RETURN
             ENDIF
          ENDIF
  100	CONTINUE

* matching grid doesn't exist
	TM_Find_like_grid = unspecified_int4
	RETURN

	END

        SUBROUTINE DEFINE_T_AGG_MC_DSET(dset_name, dset_path,
     .                   dset_title, nagfiles, memb_filename,
     .                   tline, tmatch, toverlap, dset_num, status)

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE.
*
*
* Define and initialize a MC (T-aggregated netCDF) dataset from a list
* of member filenames and metadata about the times they contain
* Since this code is derived from the old MC descriptor file logic, its
* internals simulate the reading of a descriptor file
* The first netCDF file in the list will be opened and inspected
* in the process of creating the aggregation.

* V695+ *sh* 10/15 new routine -- built as hack on tm_init_dset.F
* V698 *sh* 1/16  pass explicit path name (for "USE file.agg" compatibility)
*                 date-sort the file list in BUILD_T_AGG_AXIS

* arguments:

*	dset_name	- dataset name to assign to the aggregation (input)
*	dset_path	- dataset path to assign to the aggregation (input)
*	dset_title	- dataset title (input)
*	nagfiles	- number of files in the aggregation (input)
*	memb_filename	- array of filenames (input)
*       tline           - user-provided time axis to use (input, can be unspecified)
*       tmatch          - method of matching times to tline (input, can be empty);
*                         eg, '@ASN', '@BIN', '@XACT', '@XACT:0.001'
*       toverlap        - allowed number of overlapping time values per datset (input);
*                         negative (such as unspecified_int4) == unlimited
*	dset_num	- number assigned to this data set (output)
*	status		- return status (output)
*

        IMPLICIT NONE
* Argument definitions
	INTEGER		nagfiles, dset_num, tline, toverlap, status
	CHARACTER*(*)	dset_name, dset_path, dset_title, tmatch
	CHARACTER*512	memb_filename(nagfiles)

* Parameter and common files
        include 'ferret.parm'
        include 'errmsg.parm'
        include 'tmap_errors.parm'              ! error codes
#include "tmap_dset.parm"
        include 'tmap_dims.parm'                ! data set dimensions
        include 'xprog_state.cmn'
	include 'xtm_grid.cmn_text'
	include 'xio.cmn_text'
        external xio_data
        include 'xdset_info.cmn_text'   ! data set common
        external xdset_info_data
        include 'xsys_names.cmn_text'
        external xsys_names_data
        include 'xdiag_ctrl.cmn_text'
        external xdiag_ctrl_data
        include 'xrisc_buff.cmn'

* Internal declarations
        INTEGER memb_nstep_start(nagfiles), memb_nsteps(nagfiles),
     .          member_order(nagfiles)
	REAL*8  memb_tstep_start(nagfiles), memb_tstep_end(nagfiles)
        LOGICAL	match
	INTEGER	TM_LENSTR1, tmap_status
	INTEGER	dlen, slen, iset, idim
	INTEGER	perm(nferdims), memb_order(nagfiles)
	CHARACTER LEFINT*16, buff*16
        LOGICAL ok_re_use_existing, tregular, use_strict

* initialize
	dlen = TM_LENSTR1( dset_name )
	DO idim = 1, nferdims
 	   perm(idim) = unspecified_int4 ! dummy USE/ORDER= qualifier
	ENDDO

* check to see if the aggregation name is already in use
	DO iset = 1, maxdsets
           match = ds_name(iset) .EQ. dset_name
           IF ( match ) GOTO 5100
  	ENDDO

* initialize the first file in the aggregation
* ... it will serve as a pattern of the time-dependent variables that will
*     be presumed to exist in all other files of the aggregation
        ok_re_use_existing = .FALSE.
        tregular = .FALSE.
        use_strict = .FALSE.
        CALL TM_INIT_DSET(memb_filename(1), ok_re_use_existing, perm,
     .                    dset_num, tregular, use_strict, mode_dsg, tmap_status)

	IF (tmap_status.NE.merr_ok) GOTO 5010
	CALL CD_NCCLOSE ( dset_num, status)
	IF ( status .NE. merr_ok ) GOTO 5010

        IF ( tline .NE. unspecified_int4 ) THEN
* Verify and assign the given time axis for the aggregration
           CALL ASSIGN_T_AGG_AXIS(tline, tmatch, toverlap, dset_num,
     .       nagfiles, memb_filename, memb_tstep_start, memb_tstep_end,
     .       memb_nstep_start, memb_nsteps, memb_order, status)
        ELSE
* Build the aggregated time axis by reading the coord from the netCDF files
           CALL BUILD_T_AGG_AXIS(dset_num, nagfiles, memb_filename,
     .             memb_tstep_start, memb_tstep_end, memb_nstep_start,
     .             memb_nsteps, memb_order, status)
        ENDIF
        IF (status .NE. ferr_ok) GOTO 9900

* Use individual file metadata to simulate an MC descriptor ("Multifile Cdf")
        CALL INIT_T_AGG_MC_DSET(dset_num, nagfiles, memb_filename,
     .          memb_tstep_start, memb_tstep_end, memb_nstep_start,
     .          memb_nsteps, memb_order, status)
	IF (status .NE. merr_ok) GOTO 9900

* change the dataset metadata to make this into an aggregation
	ds_type(dset_num) = '  MC'
	ds_name(dset_num) = dset_name
	ds_des_name(dset_num) = dset_path
	IF (dset_title .NE. char_init) ds_title(dset_num) = dset_title
	buff = LEFINT(nagfiles, slen)
	ds_mod_title(dset_num)      = 'T-aggregation of '
     .				// buff(:slen)//' netCDF files'
	ds_regsteps(dset_num) = line_regular(ds_time_axis(dset_num))

! stuff done in MC descriptors.  Needed here ??
!	CALL TM_MAKE_4D_GRIDS(dset_num,status)
!* ?? need to do this for remote mc aggregations ??
!	CALL TM_DSET_USE_GRIDS( dset_num )

* success
	RETURN

* errors
 5010	CALL ERRMSG( ferr_TMAP_error, status, ' ', *5000 )

 5100   CALL ERRMSG( ferr_invalid_command,status,
     .		'given aggregation dataset name already in use: '
     .		//dset_name(:dlen), *5000 )

* get out from error
 9900	CALL TM_PURGE_TMP_GRIDS(TMAP_status)
	CALL TM_CLOSE_SET ( dset_num, TMAP_status )
 9950	dset_num = unspecified_int4
 5000	RETURN
	END

	SUBROUTINE ATSTRT(FILE,LINE,LEN,IER)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)atstrt.F	1.2    5/26/88
C**
C**
C***********************************************************************
C**
C**		    PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C**	Subprogram called:
C**		CALL ATSTRT(FILE,LINE,LEN,IER)
C**
C**	Parameters:
C**		FILE -- File to open for next command file (char*80)
C**		LINE -- String containing symbols to be passed (char*2048)
C**		LEN  -- Length of LINE
C**		IER  -- Error code
C**			0 = success
C**			9 = command file open error
C**
C**	Description:
C**		Opens FILE as the next command file.  Also updates
C**		CMDLEV and creates the appropriate user key file.
C**
C**	History:
C**	    Written: 
C**		26-JAN-86	by Donald W. Denbo
C**	    Modified:
C**		15-JUN-86	by Donald W. Denbo
C**		  Changes to support memory buffer added
C**
C**
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
C v552 *acm* 3/03 Longer strings: changes for multi-line labels
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long

	INCLUDE 'CMDCOM.INC'
	INCLUDE 'SYMKEY.INC'
	INCLUDE 'SYSTEM.INC'
	INCLUDE 'SWITCH.INC'
	INCLUDE 'LUNITS.INC'

	CHARACTER FILE*(*),LINE*(*),TO*80,TEMP*2048
	CHARACTER SYM*120
	INTEGER LEN
	IER=0
	CMDLEV=CMDLEV+1
	IF(CMDLEV.GT.1)THEN
	    IF(.NOT.(TERMF.OR.MEMBUF))THEN
		close(cmdlun)
		CMLINE(CMDLEV-1)=LINCNT
	    ENDIF
	    MEMBUF=.FALSE.
	    TERMF=.FALSE.
	    WRITE(TO,999)CMDLEV
999	    FORMAT('PPL$KEY.',I3.3)
	    SMKEY2=.TRUE.
	    keyln2=keyln2+1
	    call dbmopen(to,11,keyln2)
	ENDIF
	CMFILE(CMDLEV)=FILE
	CMECHO(CMDLEV-1)=ECHOF
	CMDEBG(CMDLEV-1)=DEBUGF
	CMQUIE(CMDLEV-1)=QUIETF
	CMLOG(CMDLEV-1)=LOGCMF
	CMIFLV(CMDLEV-1)=IFLEV
	CMWHLV(CMDLEV-1)=WHLEV
	DO 20 I=1,WHLEV
20	CMWHLN(CMDLEV-1,I)=WHLINE(I)
	IFLEV=0
	WHLEV=0
	DEBUGF=SDEBUG
	QUIETF=SQUIET
	LOGCMF=SLOG
	CMDFIL=FILE
	IF(CMDLEV.GT.1)ECHOF=SECHO
	LINCNT=0
	ISYM=LNBLK(FILE,80)
	SYM='*PPL$COMMAND_FILE'
	CALL PUTSYM(SYM,FILE,ISYM,IER)
	IF(.NOT.MEMBUF)THEN
#ifdef unix
	    OPEN(CMDLUN,FILE=FILE,STATUS='OLD',ERR=1000)
#else
	    OPEN(CMDLUN,FILE=FILE,STATUS='OLD',readonly,ERR=1000)
#endif
	ENDIF
C
C	PROCESS COMMAND LINE
C
	IL=LEN
	IF(LEN.GT.0.AND.LINE.NE.' ')THEN
C
C	    PROCESS AND PARSE COMMAND LINE
C
	    ICNT=1
100	    ISPC=INDEX(LINE,' ')
	    IF(LINE(1:1).EQ.'"')THEN
C
C		QUOTED STRING, FIND CLOSING QUOTE
C
		IQTE=0
		TEMP=LINE(2:)
		LINE=TEMP
200		ISPC=INDEX(LINE(IQTE+1:),'"')+IQTE
		IF(LINE(ISPC+1:ISPC+1).EQ.'"')THEN
		    TEMP=LINE(:ISPC)
		    TEMP(ISPC+1:)=LINE(ISPC+2:)
		    LINE=TEMP
		    IQTE=ISPC
		    IL=IL-1
		    GOTO 200
		ENDIF
	    ENDIF
	    WRITE(TO,997)ICNT
997	    FORMAT('P(',I3.3,')')
	    CALL PUTSYM(TO,LINE,ISPC-1,IER)
	    TEMP=LINE(ISPC+1:)
	    IL=IL-ISPC
	    DO 10 I=1,IL
	    IF(TEMP(I:I).NE.' ')GOTO 11
10	    CONTINUE
	    RETURN
11	    LINE=TEMP(I:)
	    ICNT=ICNT+1
	    IL=IL-I+1
	    GOTO 100
	ENDIF
	RETURN
C
C	ERROR IN OPENING 'FILE' AS COMMAND INPUT
C
1000	IF(.NOT.QUIETF)WRITE(LTTOUT,996)FILE
996	FORMAT(' - Command file not found - '/1X,A79)
	CALL ATEND
	IER=9
	RETURN
	END

	SUBROUTINE CD_NCCLOSE ( dset, status )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Just do an nc_close on the ncid for the dataset. We're going to 
* re-open it with F-TDS variable definitions, so leave all the
* dataset initialization information in place.
*
* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Thermal Modeling and Analysis Program
* 2/2013  Ferret v6.85

* v695+ *sh* 11/15 - bug fix: sf_lunit(dset) does not necessarily contain
*	                      the currently open netcdf file ID
*
* arguments:
*	dset	- data set number 


	include 'tmap_dims.parm'
#  include "tmap_dset.parm"
	include 'xstep_files.cmn_text'
	include 'xdset_info.cmn_text'
	external xstep_files_data

* Argument variable declarations
	INTEGER   dset, status

* Internal variable declarations
	INTEGER	istep

* 11/15
* sf_lunit(dset) does not reliably point to the currently open netCDF ID for
* this daatset beacuse a single dset can own many stepfiles -- for example
* in an MC aggregation.  Consult the variable ds_open(dset) to find the
* currently open stepfile number

	istep = ds_open(dset)
	CALL CD_CLOSE_SET( sf_lunit(istep), status )

* set flag indicating the file is no longer open
	sf_lunit(istep) = file_not_open
	
	RETURN
	END

	SUBROUTINE TM_CHECK_LINE_EDGES ( line, line_edges, npts, 
     .      iaxis, reversed, vname, vlen, is_double, regular, ok)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* Checks for edge coordinate data in a netCDF file

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - SDIG

* revision 0.0 - 6/17
* V72 6/17 *acm* for trac enhancement #767 -- dynamic coordinate storage 

* argument declarations

	LOGICAL reversed, is_double, its_irregular, regular, ok
	REAL line(*), line_edges(*)
	INTEGER npts, vlen, iaxis, bad_bndsid
	CHARACTER*(*) vname

* Local declarations	
	LOGICAL TM_CHECK_BOX_LOC, TM_CHECK_BNDS_CENTERED
	INTEGER i, irev, npp1
	REAL tmp8

* if the coordinates were reversed then the box edges must be, too
	IF ( reversed .AND.  npts .GT. 1) THEN
           npp1 = npts+1
	   DO i = 1, npp1/2
	      tmp8 = line_edges(i)
	      line_edges(i) = line_edges(npp1+1-i)
	      line_edges(npp1+1-i) = tmp8
	   ENDDO
	ENDIF

*  Checks to make sure coordinates are enclosed by boxes on the axis

        IF ( .NOT.TM_CHECK_BOX_LOC(line, line_edges, npts) ) THEN
           ok = .FALSE.
        ELSE 

* check to see that each data point is contained inside its box.
* See if they're centered after all.

           regular = TM_CHECK_BNDS_CENTERED(line, line_edges, npts, iaxis, is_double)
	   ok = .TRUE.
        ENDIF

	RETURN
	END

	LOGICAL FUNCTION TM_DATE( string )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* naive test to see if the given string may be a date
* complete date format is dd-mmm-yy:hh:mm:ss where mmm is a string
* naive test insists that
*     1) first character is a digit
*     2) contains : or -
*     3) if "-" must be followed by 3 characters

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.00 - 3/12/91 needed for Unix/RISC port
* 1/03 *kob* - g77 port - g77 won't allow intrinsic functions in PARAMETER
*                         statements.  use an character constant instead
*

* calling argument declarations:
	CHARACTER*(*)	string

* internal variable declarations:
	INTEGER		i, ip, slen
	CHARACTER*1	c
	
* local parameter declarations:
        CHARACTER*1     tab
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
#else
	PARAMETER     ( tab = CHAR(9))
#endif

* initialize assuming failure
	TM_DATE = .FALSE.

* skip leading blanks
        slen = LEN(string)
	DO 100 i = 1, slen
	   c = string(i:i)
	   IF ( c .NE. ' ' .AND. c .NE. tab ) GOTO 200
 100	CONTINUE
* string is blank
	RETURN

* is first character a digit ?
* modified 6/92 -- kob
* 200    IF ( c .LE. '0' .OR. c .GE. '9' ) RETURN
 200    IF ( c .LT. '0' .OR. c .GT. '9' ) RETURN

* is there a colon ?
        IF ( INDEX( string, ':') .GT. 0 ) THEN
           TM_DATE = .TRUE.
           RETURN
        ENDIF

* is there a dash ?
        ip = INDEX( string, '-')
        IF ( ip .EQ. 0 ) RETURN

* do three letters follow the dash ?
        IF ( slen .LT. ip+3 ) RETURN
        DO 300 i = ip+1, ip+3
           c = string(i:i)
           IF ( ( c.GE.'A' .AND. c.LE.'Z' )
     .    .OR.  ( c.GE.'a' .AND. c.LE.'z' ) ) GOTO 300
* not a letter
	   RETURN
 300    CONTINUE

* it meets the requirements
        TM_DATE = .TRUE.
        RETURN

        END

	SUBROUTINE NETCDF4_CANCEL_SETTINGS
* 
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or 'bug fixes'.
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP 'AS IS' AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Reset the settings for netcdf4 output datasets and store in common.

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Thermal Modeling and Analysis Program
*
* revision 0.0 - 1/13/2010

        include 'netcdf4_settings.cmn'

	netcdf4_type = 3
	xchunk_size  = 0
	ychunk_size  = 0
	zchunk_size  = 0
	tchunk_size  = 0
	echunk_size  = 0
	fchunk_size  = 0
	deflate_lev  = 0
	shuffle_flag = 0
	endian_code  = 0

	netcdf4_type_set = netcdf4_type
	xchunk_size_set  = xchunk_size
	ychunk_size_set  = ychunk_size
	zchunk_size_set  = zchunk_size
	tchunk_size_set  = tchunk_size
	echunk_size_set  = echunk_size
	fchunk_size_set  = fchunk_size
	deflate_lev_set  = deflate_lev
	shuffle_flag_set = shuffle_flag
	endian_code_set  = endian_code

	RETURN
	END

	LOGICAL FUNCTION SCALAR_GRID_LINE( idim, grid, cat, var)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* determine if the indicated axis is a single point axis
* meaning line_dim of 1 or NORMAL, or user variable compressed to a point

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - TMAP 
*
* V698 3/16 *sh*

* arguments:
* inputs:
*	idim	  - dimension to test (input)
*	grid	  - grid to test (input)
*	cat	  - category of variable to test (input)  (only uvars matter)
*	var	  - (user) variable to test (input)

      IMPLICIT NONE
	include 'netcdf.inc'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xtm_grid.cmn_text'  
	include 'xvariables.cmn'

* calling argument declarations:
	INTEGER idim, grid, cat, var

* local variable declarations:
	INTEGER line

* initialize
	line = grid_line(idim, grid)

* is the axis unit length
	IF (line .EQ. mnormal
     .	.OR.line_dim(line) .EQ. 1) GOTO 1000

* is this a user variable compressed to a point
	IF (cat .EQ. cat_user_var) THEN
	   IF (uvar_given(idim,var).EQ.uvlim_gvn_xact
     .    .OR. uvar_given(idim,var).EQ.uvlim_need_xact  ) GOTO 1000
	ENDIF

* not a unity length axis
	SCALAR_GRID_LINE = .FALSE.
	RETURN

* yes, a unity length line
 1000	SCALAR_GRID_LINE = .TRUE.
	RETURN

	END

        SUBROUTINE DEFINE_F_AGGREGATE_GRID(agg_dset, tcoordname, 
     .     nvars, vname, fvar, iline, agg_lag_t, ref_grid, 
     .     member_sets, nsets, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Define ensemble or forecast axis and grid using that axis.
* For uvars, grid is set to
* unspecified_int4 when calling this. Will defer the grid check for later.

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP 
*
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V695+ 4/15 *acm* and *sh* -- added support for forecast aggregations
* V698 1/16 *sh* - support gappy and inconsistent length forecast members
* V698 3/16 *sh* - shift both lag axes and F-calendar to pts at low cell edge
* V710 *acm* 10/16 Ticket 2422: variables uvar_grid, uvar_data_type, uvar_aux_cat, 
*                  uvar_aux_var to be replaced with calls to LIST routines in NCF_Util.c 
* v71  12/16 *acm* Ticket 2158: working with true monthly time axes.
* v72   6/17 *acm* Variable type in aggregations should match what is in the member files
* v74  10/18 *kms* Split E and F aggregation routines
* V751 *acm* 6/19 Remove unused declarations

      IMPLICIT NONE
        include 'tmap_errors.parm'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xdset_info.cd_equiv'
        include 'xprog_state.cmn'
	include 'xtm_grid.cmn_text'  
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xfr_grid.cmn'
	include 'interp_stack.parm'
	include 'netcdf.inc'

* calling argument declarations:
	INTEGER agg_dset, nvars, fvar, iline, agg_lag_t, ref_grid,
     .		member_sets(*), nsets, status
	CHARACTER*(*) vname, tcoordname

* local variable declarations:
        LOGICAL ITS_FMRC_2DTIME, TM_DFPEQ, 
     .          its_dynamic, itsa_uvar, has_edges, has_gaps,
     .          found_fvar, ef_ordered_time2d, true_month
	INTEGER STR_SAME, TM_LENSTR1,
     .		big_cx, igrid, idim, agg_grid, nv, type, ii, iset, slen, 
     .		ndim, vtype, i2, i,
     .		npts, nT, nF, lagF, ipt, iline2, memb_grid, it2d,
     .		gap_size, max_gap_size, l,
     .		axlagt, axcalt, axlagf, axcalf, gg, ipt1, ipte, fax,
     .		nv_dummy, igrid_dummy, vtype_dummy, num_indices,
     .		ef_time2d_dset, ef_time2d_grid, iaxis, fvartype,
     .		time2dline, superline, tevery, fevery
	REAL*8  TDEST_WORLD, TM_WORLD_AX, GET_LINE_COORD, 
     .		tcoord, tedge, tstart, fcoord, delta, tend

* Getting info back from the attribute-handling structure
        INTEGER maxlen
        PARAMETER (maxlen = 128)
	CHARACTER*(maxlen) dimname, buff, name1
	INTEGER varid, t2did, tline, g2d, globalid, ref_id, attlen,
     .		attype, attoutflag
        REAL    attvals(10)

* initialize
	tline = unspecified_int4
	has_gaps = .FALSE.
	ef_ordered_time2d = .FALSE.
	ef_time2d_dset = ds_var_setnum(fvar)
	time2dline = unspecified_int4

* Get the file-variable type
        slen = TM_LENSTR1(vname)
	varid = 0
        CALL CD_GET_VAR_TYPE (ef_time2d_dset, varid, vname(:slen), 
     .                        fvartype, status)

* Define aggregate grid

      igrid = unspecified_int4
      IF (ref_grid .NE. unspecified_int4) THEN
	 CALL TM_ALLO_TMP_GRID (igrid, status)
         IF (status .NE. ferr_ok) GOTO 5000

         DO 700 idim = 1, nferdims
            grid_line(idim, igrid) = grid_line(idim,ref_grid)
 700     CONTINUE
	 tline = grid_line(t_dim, igrid)
	 IF (ef_ordered_time2d) THEN
	    ef_time2d_grid = ref_grid  ! grid of fvar (w/out agg axis)
	 ELSE
	    grid_line(f_dim, igrid) = iline
	 ENDIF
* for FMRC agg the shared T axis is a time lag 
	 IF (agg_lag_t .NE. unspecified_int4) THEN
	    grid_line(t_dim, igrid) = agg_lag_t 
	 ENDIF
* Make up a unique grid name for aggregate grid
         grid_name(igrid) = 'GFN'
! as temps all have same name -- duplicates are resolved in AGG_CLEAN_GRIDS
!         CALL TM_NEW_GRID_NAME( grid_name(igrid), buff )
!         grid_name(igrid) = buff

	 agg_grid = igrid
      ENDIF

* ds_var slot, fill with aggregate variable in aggregate dataset.
      itsa_uvar = .FALSE.
      DO 720 nv = 1, maxvars
	      IF ( STR_SAME(ds_var_code(nv),char_init) .EQ. 0 ) GOTO 725
 720	CONTINUE
 725	ds_var_setnum(nv)   = agg_dset
	CALL string_array_modify(ds_var_code_head, nv, 
     .         ds_var_code(fvar), LEN(ds_var_code(fvar)))
! ?? better: inherit these attibutes from members in SET_AGG_VAR_ATTS
	ds_var_title(nv)    = ds_var_title(fvar)
	IF ( ds_var_title(nv) .EQ. char_init128) 
     .       ds_var_title(nv)  = ds_var_code(nv)
	ds_var_titl_mod(nv) = ds_var_titl_mod(fvar)
	ds_var_units(nv)    = ds_var_units(fvar)
	ds_missing_flag(nv) = ds_missing_flag(fvar)	! was bad_val4
	ds_bad_flag(nv)     = ds_bad_flag(fvar)		! was bad_val4
	ds_var_type(nv)     = ds_var_type(fvar)
	cd_scale_factor(nv) = 1.
	cd_add_offset(nv)   = 0.
	cd_scaled(nv)       = .FALSE.

	IF (ref_grid .NE. unspecified_int4) THEN
	   ndim = 1
	   DO 730 idim = 1, nferdims
	      ds_grid_start(idim,nv)= ds_grid_start(idim,fvar)
	      ds_grid_end(idim,nv)  = ds_grid_end(idim,fvar)
	      ds_ordering(idim,nv)  = ds_ordering(idim,fvar)
	      IF (ds_ordering(ndim,fvar) .GT. 0) ndim = ndim + 1
 730	   CONTINUE
           ds_grid_start(f_dim,nv) = 1
           ds_grid_end(f_dim,nv) = nsets
           ds_ordering(ndim,nv) = f_dim  ! last dimension of the grid
* ... limit T axis length to the T length of the F aggregation
           IF (agg_lag_t.NE.unspecified_int4)
     .		ds_grid_end(t_dim,nv) = line_dim(agg_lag_t)

	   ds_grid_number(nv) = agg_grid
	ENDIF

* Type should be what is in the original file
	IF (ds_var_type(nv) .EQ. ptype_string) THEN
	   type = NCCHAR
	ELSE
	   type = fvartype
	ENDIF

* Hook the aggregated variable into the linked list structures
	CALL CD_ADD_VAR( agg_dset, vname, nvars, 
     .         ds_var_title(nv), ds_var_units(nv), type, 
     .         .FALSE., ds_bad_flag(nv), status)
        IF (nvars .EQ. 1) name1 = vname

* If this is a forecast aggregation, then the 2D time var has been defined 
* (or will be, just below). Add a coordinates attribute to variables 
* in the FMRC dataset which now have a 2D forecast-time coordinate variable. 
* Also add an attribute _ftime2d pointing to TIME2D
	     
	IF (grid_line(t_dim, agg_grid).NE.int4_init) THEN
	   buff = " "
	   slen = 0
	   DO 2200 idim = nferdims, 1, -1 
	      IF (grid_line(idim, agg_grid) .NE. int4_init) THEN
	         dimname = line_name(grid_line(idim, agg_grid))
		 IF (idim .EQ. t_dim) dimname = tcoordname
	         IF (slen.EQ.0) THEN
		    buff = dimname(:TM_LENSTR1(dimname) )
		 ELSE
 	            buff = buff(:slen)//' '//dimname(:TM_LENSTR1(dimname) )
                 ENDIF
		 slen = TM_LENSTR1(buff)
	      ENDIF
 2200	   CONTINUE
	   CALL CD_GET_VAR_ID (agg_dset, vname, varid, status)
	   slen = TM_LENSTR1(buff)
	   attoutflag = 1
	   attype = NCCHAR
	   CALL CD_PUT_NEW_ATTR (agg_dset, varid, 'coordinates', attype, 
     .             slen, attoutflag, buff, 0., status )

	   slen = TM_LENSTR1(tcoordname)
	   attoutflag = 1
	   attype = NCCHAR
	   CALL CD_PUT_NEW_ATTR (agg_dset, varid, '_ftime2d', attype, 
     .             slen, attoutflag, tcoordname, 0., status )

	ENDIF

* Add aggregate-grid info to the lists in aggregate datset and aggregate-grid list.
* Mark user-variables with a grid number of -999.  Note if there is a LET/D variable
* that duplicates the name of a file var it is the file var that gets registered,
* even though the LET/D var has precedence during evaluation.  This allows for the
* possibility that the LET/D var may be cancelled.  But it also allows the possibility
* that the grid of the fvar is unacceptable -- a chance of a crash for a pathological
* dataset.
	dsets: DO ii = 1, nsets
	   iset = member_sets(ii)
* ... special hack for the TF_TIMES 2d time array when it is E-aggregated
	   IF (ef_ordered_time2d) THEN
	      vtype = cat_ef_time2d
	      CALL CD_ADD_AGG_VAR_INFO (agg_dset, vname, ii, vtype, 
     .                ef_time2d_dset, ef_time2d_grid, iline, fvar, status)
	      CYCLE dsets
	   ENDIF
	   found_fvar = .FALSE.
	   IF (iset .NE. pdset_dummy) THEN
* ... add this member data set as an fvar as part of this aggregated variable
	      DO nv = 1, maxvars
	         IF ( (ds_var_setnum(nv) .EQ. iset) .AND. 
     .                (STR_SAME(ds_var_code(nv), vname) .EQ. 0) ) THEN
	            igrid = ds_grid_number(nv)
		    vtype = cat_file_var
	            CALL CD_ADD_AGG_VAR_INFO (agg_dset, vname, ii, vtype, 
     .                iset, igrid, iline, nv, status)
	            found_fvar = .TRUE.
	            EXIT
	         ENDIF
	      ENDDO
	      IF (.NOT.found_fvar) THEN
* ... add this member data set as a LET/D as part of this aggregated variable
* ... optimize search using deleted_list_get_undel
!	         DO nv = 1, max_uvar      ! brute-force equivalent loop
		 CALL deleted_list_get_undel(uvar_num_items_head,
     .                              deleted_list_result(1),
     .                              max_uvar, num_indices )
	         DO i = 1, num_indices
	            nv = deleted_list_result(i)
	            IF ( uvar_num_items(nv) .EQ. uvar_deleted) CYCLE
	            IF ( (uvar_dset(nv) .EQ. iset) .AND. 
     .                   (STR_SAME(uvar_name_code(nv), vname) .EQ. 0) ) THEN
		       vtype = cat_user_var

		       CALL GET_SAVED_UVAR_GRID(nv, iset, igrid)
	               CALL CD_ADD_AGG_VAR_INFO (agg_dset, vname, ii, vtype, 
     .                   iset, igrid, iline, nv, status)
* ... bump the use count for this grid to protect it from being deleted if
*     the user changes the LET/D definition -- grid is needed during the
*     gather process (IS_STRIP & IS_AGGREGATE_GATHER).
*  ==> be sure to un-use (deallo) it when the aggregation gets canceled
*  ==> or if an error occurs prior to the complete initialization of this agg
	               CALL TM_USE_DYN_GRID(igrid)
	               EXIT
	            ENDIF
	         ENDDO
	      ENDIF
	   ELSE
* ... add the dummy data set as a part of this variable 
*     Note that the first member of the agg by common sense cannot be a dummy
	      CALL CD_ADD_AGG_VAR_INFO (agg_dset, vname, ii, vtype_dummy, 
     .             pdset_dummy, igrid_dummy, iline, nv_dummy, status)
	   ENDIF
* ... grab information from the first dataset to reuse with dummy datasets 
	   IF (ii .EQ. 1) THEN
*    ... OK_AS_AGG_VAR guarantees grid is always valid -- even for LET/D vars
	      IF (igrid .EQ. unspecified_int4)
     .           STOP 'DEFINE_F_AGGREGATE_GRID grid err'
	      nv_dummy = nv
	      igrid_dummy = igrid
	      vtype_dummy = cat_file_var
	   ENDIF
	ENDDO dsets

 
************* FMRC setup **************************************************
* Define 2D time variable and then the special axes needed for FMRC dataset
* The code that follows should be executed only once for an FMRC aggregation
* We use the test of whether the tcoordname variable is already defined
* to bail out if the code has already been run.
* (Cleaner code might be possible by removing the code below to a separate
* subroutine that is called just once before processing the individual vars
* of the aggregations.)

	IF (tline.NE.unspecified_int4) THEN

	   CALL CD_GET_VAR_ID (agg_dset, tcoordname, t2did, status)
	   IF (status .EQ. ferr_ok) GOTO 4000  ! BAIL OUT -- already defined

	   igrid = 0
  760	   CALL TM_ALLO_TMP_GRID (igrid, status)
	   IF (status .NE. ferr_ok) GOTO 5000
	   CALL TM_NEW_GRID_NAME ( 'FTI', buff )
           grid_name(igrid) = buff
	   g2d = igrid

* ds_var slot, define TIME2D

	   DO 770 nv = 1, maxvars
	      IF ( STR_SAME(ds_var_code(nv),char_init) .EQ. 0 ) GOTO 775
 770	   CONTINUE
 775	   ds_var_setnum(nv)   = agg_dset
	   CALL string_array_modify(ds_var_code_head, nv, 
     .         tcoordname, LEN(tcoordname))
	   ds_var_title(nv)    = 'Forecast time step matrix'
	   ds_var_titl_mod(nv) = ' '
	   ds_var_type(nv)     = ptype_float
	   ds_missing_flag(nv) = bad_val4
	   ds_bad_flag(nv)     = bad_val4
	   cd_scale_factor(nv) = 1.
	   cd_add_offset(nv)   = 0.
	   cd_scaled(nv)       = .FALSE.
* ... re-assemble units = 'days since 15-jan-1982' from units and t0
	   slen = TM_LENSTR1(line_units(tline))
	   ds_var_units(nv)    = line_units(tline)(:slen) // ' since '
     .			      // line_t0(tline)

	   IF (g2d .NE. unspecified_int4) THEN
	      DO 780 idim = 1, nferdims
	         grid_line(idim, g2d) = 0   ! presumably =mpsnorm ??
	         ds_grid_start(idim,nv) = 1
	         ds_grid_end(idim,nv) = 1
	         ds_ordering(idim,nv) = 0
 780	      CONTINUE

* grid for TIME2D actually uses the superset axis defined later
* reassign once that has been figured out
	      grid_line(t_dim, g2d) = grid_line(t_dim,agg_grid)
	      grid_line(f_dim, g2d) = iline

	      ds_grid_start(t_dim,nv) = 1
	      ds_grid_end(t_dim,nv) = line_dim(agg_lag_t)  ! limit to agg dim
	      ds_ordering(1,nv) = t_dim

	      ds_grid_start(f_dim,nv) = 1
	      ds_grid_end(f_dim,nv) = nsets
              ds_ordering(2,nv) = f_dim

	      ds_grid_number(nv) = g2d
	   ENDIF

* ... save the sequence number of this variable, so we can cache it later
	   it2d = nv

	   type = NCDOUBLE
	   nvars = nvars + 1
      
	   CALL CD_ADD_VAR( agg_dset, tcoordname, nvars, 
     .         ds_var_title(nv), ds_var_units(nv), type, 
     .         .FALSE., ds_bad_flag(nv), status)

* Add the aggregate-grid info with CALL CD_ADD_AGG_VAR_INFO
* save the grid of the member datasets so we can get back the
* right time axis for each member, but set member dataset to 0
* because the 2d Time variable is not in the member sets.

	   DO 790 ii = 1, nsets
              iset = member_sets(ii)
	      DO 795 i2 = 1, maxvars
	         IF ( (ds_var_setnum(i2) .EQ. iset) .AND. 
     .                (STR_SAME(ds_var_code(i2), name1) .EQ. 0) ) 
     .            igrid = ds_grid_number(i2)
 795	      CONTINUE

	      iset = pagg_promotion_indicator_dset
	      vtype = cat_agg_f_var 
	      CALL CD_ADD_AGG_VAR_INFO (agg_dset, tcoordname, ii, vtype, 
     .             iset, igrid, iline, nv, status)
 790	   CONTINUE

* Give the time2D variable _CoordinateAxisType and calendar atts

	   CALL CD_GET_VAR_ID (agg_dset, tcoordname, t2did, status)
	   attoutflag = 1
	   attype = NCCHAR
	   CALL CD_PUT_NEW_ATTR (agg_dset, t2did, '_CoordinateAxisType', 
     .       attype, 4, attoutflag, 'Time', 0., status )
	   slen = TM_LENSTR1(line_cal_name(tline))
	   attoutflag = 1
	   attype = NCCHAR
	   CALL CD_PUT_NEW_ATTR (agg_dset, t2did, 'calendar', attype, 
     .       slen, attoutflag, line_cal_name(tline), 0., status )

* an FMRC needs 4 axes:
* 2 are the native axes of the data grids in compressed block FMRC form
*   - native T: a lag axis of time steps between each successive forecast
*   - native F: a calendar axis of times at which each run was initiated
* 2 are target regridding axes:
*   - target T: a calendar axis of the target times being forecast
*   - target F: a lag (lead) axis of time steps prior to the target time

* first define the two target axes
* Assemble the 2D time array in line_mem and call CD_MAKE_FMRC_AXES
* Save it at the start of available line storage memory
* Also save the time box edge positions in line_mem above the 2d array
* line_mem contents will be:  2d_times, 2d_lo_lims, hi_lim_of_last_time
	   nT = line_dim(grid_line(t_dim,agg_grid))
	   nF = line_dim(grid_line(f_dim,agg_grid))

* DYN linemem: allocate coordinate memory linemem for 2d_times and lineedg is the upper
* 

* KMS - The time axis for the FMRC then needs to be on a time axis that is a superset
* of both the forecasted (verification) times and the initialization times.
*
* Assume the forecasted and initialization time axes are regular.  I think a reasonable 
* assumption.  Also assume that an initialization time after the first forecast matches 
* a forecasted time for the first forecast.  This might be a less reasonable assumption.
* (If this becomes a problem, may have have the user provide the axis to use.)
*
* To define this superaxis, need to find the a pair of times where a forecasted time equals
* an initialization time (stepsF * deltaF == stepsT * deltaT); eg, the third forecasted 
* time is the same time as the second initialization time.  Then the delta of the superset 
* time axis is the delta of one divided by number steps for the other to the common time 
* (deltaF / stepsT == deltaT / stepsF).

* get the forecasted times for the first forecast - must exist
           CALL TM_ALLO_TMP_LINE(superline, status)
           IF ( status .NE. ferr_ok) GOTO 5200
           CALL GET_LINE_DYNMEM(nT, superline, status)
           IF ( status .NE.ferr_ok) GOTO 5100
           IF ( member_sets(1) .EQ. pdset_dummy ) 
     .        GOTO 5300
           CALL CD_GET_AGG_VAR_INFO (agg_dset, vname, 1, 
     .        vtype, iset, memb_grid, iline2, nv, status)
           IF (status .NE. ferr_ok) GOTO 5200
* ... if the first member has a LET/D var, use time axis info from another var
           IF ( memb_grid .EQ. unspecified_int4 )
     .          memb_grid = igrid_dummy
* set up to translate all times to the T0 of the first member
           CALL TDEST_WORLD_INIT (memb_grid, ref_grid, t_dim, status)
           IF (status .NE. ferr_ok) GOTO 5000 
           DO i2 = 1, nT
              tcoord = TDEST_WORLD(i2, memb_grid, t_dim, box_middle)
              CALL PUT_LINE_COORD(linemem(superline)%ptr, i2, tcoord)
           ENDDO
           tstart = GET_LINE_COORD(linemem(superline)%ptr, 1)

* Loop over the initialization times for forecasts after the first, looking for one 
* that matches a forecasted time for the first forecast.  Start with closest forecasts, 
* to (hopefully) give the smallest superset axis.
           DO ii = 2, nsets
              IF (member_sets(ii) .NE. pdset_dummy) THEN
                 CALL CD_GET_AGG_VAR_INFO(agg_dset, vname, ii, 
     .              vtype, iset, memb_grid, iline2, nv, status)
                 IF (status .NE. ferr_ok) GOTO 5200
* ... if the first member has a LET/D var, use time axis info from another var
                 IF (memb_grid .EQ. unspecified_int4) 
     .               memb_grid = igrid_dummy
* set up to translate all times to the T0 of the first member
                 CALL TDEST_WORLD_INIT(memb_grid, ref_grid, t_dim, status)
                 IF (status .NE. ferr_ok) GOTO 5000 
                 fcoord = TDEST_WORLD(1, memb_grid, t_dim, box_middle)
                 DO i2 = 2, nT
                    tcoord = GET_LINE_COORD(linemem(superline)%ptr, i2)
                    IF ( TM_DFPEQ(tcoord, fcoord) ) THEN
* deltaT = (tcoord-tstart)/(i2-1), stepsF = (ii-1), delta = deltaT/stepsF
*    or looking at it the other way (fstart == tstart):
* deltaF = (fcoord-fstart)/(ii-1), stepsT = (i2-1), delta = deltaF/stepsT
                       delta = (tcoord-tstart) / ((i2-1)*(ii-1))
                       fevery = i2 - 1 
                       tevery = ii - 1
                       GOTO 800
                    ENDIF
                 ENDDO
              ENDIF
           ENDDO
* If got here, no initialization time matched a forecasted time in the first forecast
           GOTO 5400

 800       CONTINUE
* get the last forecasted time for the last forecast - must exist
           IF ( member_sets(nsets) .EQ. pdset_dummy ) 
     .        GOTO 5500
           CALL CD_GET_AGG_VAR_INFO (agg_dset, vname, nsets, 
     .        vtype, iset, memb_grid, iline2, nv, status)
           IF (status .NE. ferr_ok) GOTO 5200
* ... if the first member has a LET/D var, use time axis info from another var
           IF ( memb_grid .EQ. unspecified_int4 )
     .          memb_grid = igrid_dummy
* set up to translate all times to the T0 of the first member
           CALL TDEST_WORLD_INIT (memb_grid, ref_grid, t_dim, status)
           IF (status .NE. ferr_ok) GOTO 5000 
           tend = TDEST_WORLD(nT, memb_grid, t_dim, box_middle)

* Remove any common denominators in fevery and tevery and factor them into delta;
* e.g., fevery=8, tevery=12, delta=0.5 ==> fevery=2, tevery=3, delta=2.0
           ii = 2
           DO WHILE ( (ii .LE. tevery) .AND. (ii .LE. fevery) )
              IF ( (MOD(fevery,ii) .EQ. 0) .AND. 
     .             (MOD(tevery,ii) .EQ. 0) ) THEN
                 fevery = fevery / ii
                 tevery = tevery / ii
                 delta = delta * ii
              ELSE IF ( ii .EQ. 2 ) THEN
*                2 -> 3
                 ii = ii + 1
              ELSE
*                3 -> 5 -> 7 -> ...
                 ii = ii + 2
              ENDIF
           ENDDO

* So want FMRC transforms put onto this superset time axis defined by tstart, tend, and delta
* A new forecast series starts every fevery steps on this axis.
* A forecast gives predictions every tevery steps on this axis.
* Undefined should remain in locations not assigned in the 2D superset time axis

* make the FMRC regrid target axes: T-calendar and F-lag
* as well as the source superset source T-lag and F-calendar axes.
* Also iline which is the actual F-calendar source axis
* (t2did still holds the id of the tcoordname 2d time array)
           CALL CD_MAKE_FMRC_AXES(agg_dset, t2did, tcoordname,
     .        ds_var_type(nv), tstart, tend, delta, fevery, tevery,
     .        nT, nF, axlagt, axcalt, axlagf, axcalf, iline, status)
           IF (status .NE. merr_ok) GOTO 5000

* Since a regular axes was assumed, can fill the 2D time array from the above information.
* This 2D array, saved in linear memory, are the times of each forecasted value (inner loop) 
* for each forecast (outer loop) - on the superset axis
           npts = nT * tevery * nF * fevery
           CALL TM_ALLO_TMP_LINE(time2dline, status)
           IF (status .NE. ferr_ok) GOTO 5200
           CALL GET_LINE_DYNMEM (npts, time2dline, status) 
           IF (status .NE. ferr_ok) GOTO 5100
           ipt = 1
           DO ii = 1, nF * fevery
              fcoord = tstart + (ii-1) * delta
              DO i2 = 1, nT * tevery
                 tcoord = fcoord + (i2-1) * delta
                 CALL PUT_LINE_COORD(linemem(time2dline)%ptr, ipt, tcoord)
                 tedge  = tcoord - 0.5 * delta
                 CALL PUT_LINE_COORD(lineedg(time2dline)%ptr, ipt, tedge)
                 ipt = ipt + 1
              ENDDO
           ENDDO
* add the final upper edge value
           tedge = tstart + (nF * fevery - 1) * delta 
     .                    + (nT * tevery - 1) * delta + 0.5 * delta
           CALL PUT_LINE_COORD(lineedg(time2dline)%ptr, npts+1, tedge)

* reset the grid for the 2D time array to use the superset axis
           grid_line(t_dim, g2d) = axlagt
           grid_line(f_dim, g2d) = axcalf
           ds_grid_end(t_dim,it2d) = nT * tevery
           ds_grid_end(f_dim,it2d) = nF * fevery

* save the 2D time step array in c memory cache
* to be recovered as needed by FIND_MEM_VAR
           CALL CACHE_FULL_ARRAY(linemem(time2dline)%ptr, npts, 
     .                           ds_var_c_cache_ptr(it2d))

* ... assign global attributes pointing to the target regrid axes
*    (CF requires variable attributes, but they are helpful as globals, too)
           CALL CD_GET_VAR_ID (agg_dset, '.', globalid, status)
           attoutflag = 1
           attype = NCCHAR
           slen = TM_LENSTR1(line_name(axcalt))
           CALL CD_PUT_NEW_ATTR (agg_dset, globalid, '_cal_t_ax', attype, 
     .             slen, attoutflag, line_name(axcalt), 0., status )
           slen = TM_LENSTR1(line_name(axlagf))
           CALL CD_PUT_NEW_ATTR (agg_dset, globalid, '_lag_f_ax', attype, 
     .             slen, attoutflag, line_name(axlagf), 0., status )
           slen = TM_LENSTR1(line_name(axcalf))
           CALL CD_PUT_NEW_ATTR (agg_dset, globalid, '_cal_f_ax', attype, 
     .             slen, attoutflag, line_name(axcalf), 0., status )
           slen = TM_LENSTR1(line_name(axlagt))
           CALL CD_PUT_NEW_ATTR (agg_dset, globalid, '_lag_t_ax', attype, 
     .             slen, attoutflag, line_name(axlagt), 0., status )

* make the regrid target axes non-temporary and set use counts to 1
           CALL TM_RE_ALLO_TMP_LINE(axcalt)
           CALL TM_USE_LINE(axcalt)
           CALL TM_RE_ALLO_TMP_LINE(axlagf)
           CALL TM_USE_LINE(axlagf)
           CALL TM_RE_ALLO_TMP_LINE(axcalf)
           CALL TM_USE_LINE(axcalf)
           CALL TM_RE_ALLO_TMP_LINE(axlagt)
           CALL TM_USE_LINE(axlagt)

	ENDIF  ! end of forecast aggregation special coordinate creation
* F-agg atts _cal_t_ax and _lag_f_a_x point to the special regridding axes
 4000   CONTINUE
          slen = TM_LENSTR1(line_name(axcalt))
          attoutflag = 1
          attype = NCCHAR
          CALL CD_PUT_NEW_ATTR (agg_dset, varid, '_cal_t_ax', attype, 
     .             slen, attoutflag, line_name(axcalt), 0., status )
          CALL CD_PUT_NEW_ATTR (agg_dset, varid, '_lag_f_ax', attype, 
     .             slen, attoutflag, line_name(axlagf), 0., status )
          CALL CD_PUT_NEW_ATTR (agg_dset, varid, '_cal_f_ax', attype, 
     .             slen, attoutflag, line_name(axcalf), 0., status )
          CALL CD_PUT_NEW_ATTR (agg_dset, varid, '_lag_t_ax', attype, 
     .             slen, attoutflag, line_name(axlagt), 0., status )

* Done with the 2D array which has been stored (or not if an error)
 5000   IF (time2dline .NE. unspecified_int4) THEN
           IF (line_allocated(time2dline) .GT. 0) 
     .        CALL FREE_LINE_DYNMEM(time2dline)
        ENDIF
        RETURN

 5100	CALL ERRMSG(ferr_aggregate_error,status,
     .	        'unable to define forecast aggregation', *5000)
 5200	CALL ERRMSG(ferr_internal, status, 'DEFINE_F_AGGREGATE_GRID!',
     .		 *5000)
 5300	CALL ERRMSG(ferr_aggregate_error, status,
     .		'no suitable file vars in 1st aggregation member', *5000)
 5400   CALL ERRMSG(ferr_aggregate_error, status,
     .          'no common forecasted and initialization time', *5000)
 5500	CALL ERRMSG(ferr_aggregate_error, status,
     .		'no suitable file vars in last aggregation member', *5000)
	END

	SUBROUTINE SHOW_DIM_XML( dim_name, dim_len, lun )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* display basic facts about the given dimension (which is not a coordiante axis) 
* in xml-style format 

* programmer - Ansley Manke, based on show_line_xml.F
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* Dec-2013

        IMPLICIT NONE
	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include	'ferret.parm'
	include 'xrisc.cmn'

* calling argument declarations
	CHARACTER*(*)   dim_name
	INTEGER 	dim_len, lun

* local variable declarations:
	INTEGER		slen
	CHARACTER	TM_FMT*48, outbuff*20
        CHARACTER       attname*128, attbuff*2048, 
     .                  outstring*2048

 2010	FORMAT ( '<dimension name="', A, '">' )
 2030	FORMAT ('<attribute name="', A, '" type="short">' )
 2050   FORMAT ('   <value>', A, '</value>')
 2060   FORMAT ('</attribute>')
 2080	FORMAT ( '</dimension>' )

	CALL ESCAPE_FOR_XML (dim_name, outstring, slen)
	WRITE ( risc_buff, 2010 ) outstring(1:slen)
	CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
	
* Length of dimension

	attname = 'length'
	CALL ESCAPE_FOR_XML(attname, outstring, slen)
	WRITE ( risc_buff, 2030 ) outstring(:slen)
	CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

	attbuff = TM_FMT(DBLE(dim_len), 0, 14, slen)
	CALL ESCAPE_FOR_XML (attbuff, outstring, slen)
	WRITE ( risc_buff, 2050 ) outstring(1:slen)
	CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

	WRITE ( risc_buff, 2060 )
	CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

* closing tag

	WRITE ( risc_buff, 2080 ) 
	CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

	RETURN
	END

	CHARACTER*14 FUNCTION WHOI_DATE( grid, idim, tstep )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* create a string of the form YYYYMMDDHHMMSS (was YYMMDDHHMM) from the time step

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 3/15/88
* revision 0.1 - 1/18/89 - BREAK_DATE --> TM_BREAK_DATE
* V200:  1/31/90 - fixed bug with climatological axes (years "0000" and "0001"
*		   but produce the same WHOI dates)
* V420: 11/27/95 - 4-digit YEARS!!
* v530  12/19/00 *acm* cal_id for alternative calendar axis types
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
*                  A time axis may be a T axis or F axis
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.

	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
        include 'xunits.cmn_text'
	include 'ferret.parm'

* calling argument declarations
	INTEGER	grid, idim
	REAL*8	tstep

* internal variable declarations
	LOGICAL		ITSA_TRUEMONTH_AXIS
	INTEGER 	yr100, yr, mon, day, hr, min, sec,
     .			status, i, axis
	INTEGER		TM_GET_CALENDAR_ID, cal_id
	CHARACTER*20	TM_SECS_TO_DATE, date
	REAL*8		start_secs, offset_secs, this_secs
	REAL*8		SECS_FROM_BC

* get the axis number
	axis = grid_line( idim, grid )
	IF ( axis .EQ. mnormal .OR. axis .EQ. munknown ) THEN
	   WHOI_DATE = '00000000000000'
	   RETURN
	ELSEIF ( line_direction(axis) .NE. 'TI' .AND. 
     .           line_direction(axis) .NE. 'FI' ) THEN
	   WHOI_DATE = '00000000000000'
	   RETURN
	ENDIF

* First find the offset from 01-JAN-0000 00:00:00 from the descriptor file

        cal_id = TM_GET_CALENDAR_ID ( line_cal_name(axis) )
	start_secs = SECS_FROM_BC( line_t0(axis), cal_id, status )

* Find the number of seconds since start of data set for this time step
	offset_secs = tstep*line_tunit( axis )

* A true-month axis has line-units of month, but output units of days
	IF (ITSA_TRUEMONTH_AXIS(axis)) offset_secs = tstep* un_convert(pun_day)

* Total seconds to this time step since 01-JAN-0000 00:00:00
	this_secs = start_secs + offset_secs

* Convert to date
	date = TM_SECS_TO_DATE(this_secs, cal_id)

* break the date string into component integer values
	CALL TM_BREAK_DATE( date, cal_id, yr, mon, day, hr, min,
     .                      sec, status )
	yr100 = yr/100		! 1980 --> 19
	yr = yr - (yr100*100)	! 1982 --> 82

* assemble the pieces in WHOI format
	WRITE (WHOI_DATE,3000) yr100,yr,mon,day,hr,min,sec
 3000	FORMAT (7I2.2)

	RETURN
	END

*
*  scat2gridlaplace_yz
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE.
*
* Ansley Manke
* July 28 1998
*
* Returns variable interpolated onto an equally-spaced Y-Z grid.
* Input is scattered triples: (y, z, variable) , may be functions of X,T,E,F.
* Output is gridded data in X,Y,Z,T,E,F.  Calls routine "zgrid_laplace".
*
* Nov 13, 2000 1) Allow modulo axes: if modulo take points from other end
*                 to use in gridding each end
*              2) Check that the scattered points are listed on the I,J,or
*                 K axis only, as they may be functions of time.
*  (12/1/2000) 3) If the destination axis is modulo, treat the scattered
*                 points as modulo too.
*
*   12/7/2000  Add error checking on gridding parameters
*    5/2001    Let variable,  be a function of Z and/or T
*
*  11/12/2002  Remove option 2) above: the spatial location of the scattered points
*              is a 1-D list.
*   2/ 9/2005  When we fixed the argument limit machinery this fcn
*              breaks if the output axes are limited by some context.
*              use ef_set_axis_extend to force the regridding to be
*              done on the unrestricted output grid.
*  8/26/2008   The functions call zgrid from the PPLUS code. This function has
*              some hard-wired workspace limited to 50K points. Instead allocate
*              work arrays here and pass them to zgrid_laplace in this directory
*              with no changes other than the work array declarations.
*
*  *kms* 4/2012 Removed extending result grid axes with ef_unspecified_int4: 
*               this appears to destroy the axes of the result grid as demonstrated
*               by the listing in bn_scat2grid_test.jnl.  Now it is up to the
*               the user to give (not truncate) the result grid axes:
*      let sgrid = scat2gridlaplace_xy(xpts, ypts, variable, x[gx=xax5], y[gy=yax5], 5., 5)
*      load sgrid  ! <--- without this, the following uses a 1-element Y axis
*      list/x=4:5/y=1 sgrid

* In this subroutine we provide information about
* the function.  The user configurable information
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
*
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result
*


      SUBROUTINE scat2gridlaplace_yz_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id, 'Use Laplace weighting to grid ' //
     .                     'scattered data to a YZ grid.')
      CALL ef_set_num_args(id, 7)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 8)

* YZ grid is determined by arguments 4 and 5, the result's y and z axes.

      arg = 1
      CALL ef_set_arg_name(id, arg, 'YPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'Y coordinates of scattered YZ locations')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'ZPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'Z coordinates of scattered YZ locations')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'F')
      CALL ef_set_arg_desc(id, arg,
     .        'variable at scattered YZ locations. ' //
     .        'May also be fcn of X,T,E,F')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, NO, NO, YES, YES, YES)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'YAXPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'Y axis coordinates of a regular output grid')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, YES, NO, NO, NO, NO)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'ZAXPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'Z axis coordinates of a regular output grid')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, YES, NO, NO, NO)

      arg = 6
      CALL ef_set_arg_name(id, arg, 'KAY')
      CALL ef_set_arg_desc(id, arg,
     .        'Laplace/spline mixing parameter KAY; ' //
     .        '0.0=pure Laplace; inf=pure spline')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 7
      CALL ef_set_arg_name(id, arg, 'NRNG')
      CALL ef_set_arg_desc(id, arg,
     .        'Effect parameter NRNG; grid vals ' //
     .        'undef if > NRNG grid steps from pts')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE scat2gridlaplace_yz_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER nyout, nzout, ny2, nz2
      INTEGER nxin, nyin, nzin, ntin, nein, nfin, nin

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nxin = 1 + arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1)
      nyin = 1 + arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1)
      nzin = 1 + arg_hi_ss(Z_AXIS,ARG1) - arg_lo_ss(Z_AXIS,ARG1)
      ntin = 1 + arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1)
      nein = 1 + arg_hi_ss(E_AXIS,ARG1) - arg_lo_ss(E_AXIS,ARG1)
      nfin = 1 + arg_hi_ss(F_AXIS,ARG1) - arg_lo_ss(F_AXIS,ARG1)
      nin = MAX(nxin,nyin,nzin,ntin,nein,nfin)
*  If modulo axis, the scatter arrays are extended for values
*  within nrng of the cut-point.  Worst case: everything gets
*  duplicated at both ends; thus three times the points for
*  each modulo axis.
      nin = 9 * nin

      nyout = 1 + arg_hi_ss(Y_AXIS,ARG4) - arg_lo_ss(Y_AXIS,ARG4)
      nzout = 1 + arg_hi_ss(Z_AXIS,ARG5) - arg_lo_ss(Z_AXIS,ARG5)

      ny2 = nyout * 2
      nz2 = nzout * 2

* yax  output y axis
      CALL ef_set_work_array_dims_6d(id, 1,
     .                                1, 1, 1, 1, 1, 1,
     .                              ny2, 1, 1, 1, 1, 1)

* zax  output z axis
      CALL ef_set_work_array_dims_6d(id, 2,
     .                                1, 1, 1, 1, 1, 1,
     .                              nz2, 1, 1, 1, 1, 1)

* zgridded  work array - gridded data.
      CALL ef_set_work_array_dims_6d(id, 3,
     .                                1,     1, 1, 1, 1, 1,
     .                            nyout, nzout, 1, 1, 1, 1)

* yscat - scattered points with gaps removed and extended for modulo
      CALL ef_set_work_array_dims_6d(id, 4,
     .                                1, 1, 1, 1, 1, 1,
     .                              nin, 1, 1, 1, 1, 1)

* zscat - scattered points with gaps removed and extended for modulo
      CALL ef_set_work_array_dims_6d(id, 5,
     .                                1, 1, 1, 1, 1, 1,
     .                              nin, 1, 1, 1, 1, 1)

* fscat - scattered points with gaps removed and extended for modulo
      CALL ef_set_work_array_dims_6d(id, 6,
     .                                1, 1, 1, 1, 1, 1,
     .                              nin, 1, 1, 1, 1, 1)

* zgrid_laplace work array zpij
      CALL ef_set_work_array_dims_6d(id, 7,
     .                                1, 1, 1, 1, 1, 1,
     .                              nin, 1, 1, 1, 1, 1)

* zgrid_laplace work array knxt
      CALL ef_set_work_array_dims_6d(id, 8,
     .                                1, 1, 1, 1, 1, 1,
     .                              nin, 1, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE scat2gridlaplace_yz_compute(id, arg_1, arg_2, arg_3,
     .                            arg_4, arg_5, arg_6, arg_7, result,
     .                            yax, zax, zgridded, yscat, zscat,
     .                            fscat, zpij, knxt)

*  arg_1  ypts \
*  arg_2  zpts  > scattered y,z,variable,  triples to be gridded. F can be fcn of x,t,e,f
*  arg_3  variable, /
*  arg_4  yaxis of new grid
*  arg_5  zaxis of new grid
*  arg_6  interpolation parameter   kay
*  arg_7  interpolation parameter   nrng

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz,
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz,
     .           mem4lot:mem4hit, mem4loe:mem4hie, mem4lof:mem4hif)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz,
     .           mem5lot:mem5hit, mem5loe:mem5hie, mem5lof:mem5hif)
      REAL arg_6(mem6lox:mem6hix, mem6loy:mem6hiy, mem6loz:mem6hiz,
     .           mem6lot:mem6hit, mem6loe:mem6hie, mem6lof:mem6hif)
      REAL arg_7(mem7lox:mem7hix, mem7loy:mem7hiy, mem7loz:mem7hiz,
     .           mem7lot:mem7hit, mem7loe:mem7hie, mem7lof:mem7hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* Ignore the unused final dimensions in the work arrays since
* Fortran is column major
      REAL*8 yax(wrk1lox:wrk1hix/2)
      REAL*8 zax(wrk2lox:wrk2hix/2)
      REAL zgridded(wrk3lox:wrk3hix, wrk3loy:wrk3hiy)
      REAL yscat(wrk4lox:wrk4hix)
      REAL zscat(wrk5lox:wrk5hix)
      REAL fscat(wrk6lox:wrk6hix)
      REAL zpij(wrk7lox:wrk7hix)
      REAL knxt(wrk8lox:wrk8hix)

* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable''s axes.

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      REAL zgridbad
      PARAMETER (zgridbad = 1.e+35)  ! missing-data flag used by zgrid_laplace

      INTEGER i, j, k, l, m, n
      INTEGER idx, lo_ss, hi_ss
      INTEGER nypts, nzpts, npts, nscat
      INTEGER ny, nz
      INTEGER i3, j3, k3, l3, m3, n3
      INTEGER ylo, yhi, zlo, zhi
      INTEGER nrng
      REAL y1, z1, dy, dz
      REAL kay
      CHARACTER*250 errtxt

C  variables for checking axis characteristics (modulo, regular)
      CHARACTER ax_name(6)*16, ax_units(6)*16
      LOGICAL backward(6), mdulo(6), regular(6)
      LOGICAL moduloy, moduloz
      REAL*8 modylen, modzlen

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*  Check to see if output axes are regular, and get modulo characteristics
      CALL ef_get_axis_info_6d(id, ARG4, ax_name, ax_units,
     .                         backward, mdulo, regular)
      IF ( .NOT. regular(Y_AXIS) ) THEN
         errtxt = 'Output axes must be REGULARLY spaced'
         GOTO 999
      ENDIF
      moduloy = mdulo(Y_AXIS)
      IF ( moduloy ) THEN
         CALL ef_get_axis_modulo_len(id, ARG4, Y_AXIS, modylen)
      ENDIF

      CALL ef_get_axis_info_6d(id, ARG5, ax_name, ax_units,
     .                         backward, mdulo, regular)
      IF ( .NOT. regular(Z_AXIS) ) THEN
         errtxt = 'Output axes must be REGULARLY spaced'
         GOTO 999
      ENDIF
      moduloz = mdulo(Z_AXIS)
      IF ( moduloz ) THEN
         CALL ef_get_axis_modulo_len(id, ARG5, Z_AXIS, modzlen)
      ENDIF

*  Find number of points in scattered input points.  1-D arrays defining the
*  scattered data points may lie on the X, Y, Z, T, E, or F axis of the input
*  arguments.
*  Using as flattened arrays, so consider all axes.

      nypts = 0
      DO 20 idx = X_AXIS, F_AXIS
         lo_ss = arg_lo_ss(idx,ARG1)
         hi_ss = arg_hi_ss(idx,ARG1)
         IF ( lo_ss .NE. ef_unspecified_int4 ) THEN
            IF ( nypts .NE. 0 ) THEN
               nypts = nypts * (hi_ss - lo_ss + 1)
            ELSE
               nypts = hi_ss - lo_ss + 1
            ENDIF
         ENDIF
  20  CONTINUE

      nzpts = 0
      DO 30 idx = X_AXIS, F_AXIS
         lo_ss = arg_lo_ss(idx,ARG2)
         hi_ss = arg_hi_ss(idx,ARG2)
         IF ( lo_ss .NE. ef_unspecified_int4 ) THEN
            IF ( nzpts .NE. 0 ) THEN
               nzpts = nzpts * (hi_ss - lo_ss + 1)
            ELSE
               nzpts = hi_ss - lo_ss + 1
            ENDIF
         ENDIF
  30  CONTINUE

      IF ( nypts .NE. nzpts ) THEN
         WRITE (errtxt,90) ' YPTS,', ' ZPTS ', nypts, nzpts
         GOTO 999
      ENDIF

* Verify the number of values given in ARG3 makes sense
      ylo = arg_lo_ss(Y_AXIS,ARG3)
      yhi = arg_hi_ss(Y_AXIS,ARG3)
      zlo = arg_lo_ss(Z_AXIS,ARG3)
      zhi = arg_hi_ss(Z_AXIS,ARG3)

      IF ( (yhi .GT. ylo) .AND. (zhi .GT. zlo) ) THEN
         errtxt = 'F() data values defined on both Y and Z axis'
         GOTO 999
      ELSE IF ( yhi .GT. ylo ) THEN
         npts = yhi - ylo + 1
         IF ( nypts .NE. npts ) THEN
            WRITE (errtxt,90) ' YPTS,', ' F(Y) ', nypts, npts
            GOTO 999
         ENDIF
      ELSE IF ( zhi .GT. zlo ) THEN
         npts = zhi - zlo + 1
         IF ( nypts .NE. npts ) THEN
            WRITE (errtxt,90) ' YPTS,', ' F(Z) ', nypts, npts
            GOTO 999
         ENDIF
      ELSE IF ( (ylo .NE. ef_unspecified_int4) .OR.
     .          (zlo .NE. ef_unspecified_int4) ) THEN
         npts = 1
         IF ( nypts .NE. npts ) THEN
            WRITE (errtxt,90) ' YPTS,', ' F()  ', nypts, npts
            GOTO 999
         ENDIF
      ELSE
         errtxt = 'No data in scattered y, z points.  ' //
     .            'F() data values must be defined on Y or Z axis.'
         GOTO 999
      ENDIF
  90  FORMAT('Input scattered', 2A6, 'have different # of points', 2I8)

*  Compute number of points in output axes.

      lo_ss = arg_lo_ss(Y_AXIS,ARG4)
      hi_ss = arg_hi_ss(Y_AXIS,ARG4)
*  Check that yax is a Y axis
      IF ( lo_ss .EQ. ef_unspecified_int4 ) THEN
         errtxt = 'Fourth argument must be a Y axis'
         GO TO 999
      ENDIF
      ny = hi_ss - lo_ss + 1

      lo_ss = arg_lo_ss(Z_AXIS,ARG5)
      hi_ss = arg_hi_ss(Z_AXIS,ARG5)
*  Check that zax a Z axis
      IF ( lo_ss .EQ. ef_unspecified_int4 ) THEN
         errtxt = 'Fifth argument must be a Z axis'
         GO TO 999
      ENDIF
      nz = hi_ss - lo_ss + 1

C  Get coordinates of output axes.

      CALL ef_get_coordinates(id, ARG4, Y_AXIS, arg_lo_ss(Y_AXIS, ARG4),
     .                        arg_hi_ss(Y_AXIS, ARG4), yax)

      CALL ef_get_coordinates(id, ARG5, Z_AXIS, arg_lo_ss(Z_AXIS, ARG5),
     .                        arg_hi_ss(Z_AXIS, ARG5), zax)

*  Set start and delta for output axes.

      y1 = yax(1)
      z1 = zax(1)

      IF ( ny .GT. 1 ) THEN
         dy = yax(2) - yax(1)
      ELSE
         errtxt = 'More than one output Y coordinate required'
         GOTO 999
      ENDIF
      IF ( nz .GT. 1 ) THEN
         dz = zax(2) - zax(1)
      ELSE
         errtxt = 'More than one output Z coordinate required'
         GOTO 999
      ENDIF

*  Get interpolation parameters.

      kay = arg_6(arg_lo_ss(X_AXIS,ARG6), arg_lo_ss(Y_AXIS,ARG6),
     .            arg_lo_ss(Z_AXIS,ARG6), arg_lo_ss(T_AXIS,ARG6),
     .            arg_lo_ss(E_AXIS,ARG6), arg_lo_ss(F_AXIS,ARG6))
      IF ( kay .LT. 0. ) THEN
         errtxt = 'Gridding parameter KAY must be nonnegative'
         GOTO 999
      ENDIF

      nrng = arg_7(arg_lo_ss(X_AXIS,ARG7), arg_lo_ss(Y_AXIS,ARG7),
     .             arg_lo_ss(Z_AXIS,ARG7), arg_lo_ss(T_AXIS,ARG7),
     .             arg_lo_ss(E_AXIS,ARG7), arg_lo_ss(F_AXIS,ARG7))
      IF ( nrng .LE. 0 ) THEN
         errtxt = 'Gridding parameter NRNG must be a positive integer'
         GOTO 999
      ENDIF

*  Compute result at each X, T, E, F

      n3 = arg_lo_ss(F_AXIS,ARG3)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

      m3 = arg_lo_ss(E_AXIS,ARG3)
      DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

      l3 = arg_lo_ss(T_AXIS,ARG3)
      DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

      i3 = arg_lo_ss(X_AXIS,ARG3)
      DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

*  If there is a missing value routine zgrid does not grid the data in
*  a zone around that point, even if there are other nearby good data
*  points.  Remove missing/bad data from the input (y,z,f) points.
*  Assigns yscat, zscat, fscat, and nscat.

         CALL nobadyz(arg_1, arg_2, arg_3,
     .                bad_flag(ARG1), bad_flag(ARG2), bad_flag(ARG3),
     .                npts, i3, ylo, yhi, zlo, zhi, l3, m3, n3,
     .                yscat, zscat, fscat, nscat)

*  If an output axis is modulo, apply modulo adjustment to that coordinate
*  of the scattered points.
         IF ( moduloy ) THEN
            CALL modscat(yax(1), yax(ny), modylen, nscat, yscat)
         ENDIF
         IF ( moduloz ) THEN
            CALL modscat(zax(1), zax(nz), modzlen, nscat, zscat)
         ENDIF

*  If an output axis is modulo, mirror the scattered points within NRNG
*  of each end to the other end of the region.  Extends yscat, zscat,
*  fscat, and updates nscat to the new count.
         IF ( moduloy ) THEN
            CALL copyscat(yax, ny, nrng, nscat, yscat, zscat, fscat)
         ENDIF
         IF ( moduloz ) THEN
            CALL copyscat(zax, nz, nrng, nscat, zscat, yscat, fscat)
         ENDIF

*  Initialize zgridded to all zeros

         DO k3 = 1, nz
            DO j3 = 1, ny
               zgridded(j3,k3) = 0.0
            ENDDO
         ENDDO

*  Grid the data.

         CALL zgrid_laplace(zgridded, ny, nz, ny, nz, y1, z1,
     .      dy, dz, yscat, zscat, fscat, zpij, knxt, nscat, kay, nrng)

*  Put zgridded into result variable.  Use "bad_flag_result" rather than
*  "zgridbad" to mark bad data.

         k3 = 1
         DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

            j3 = 1
            DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

               IF ( zgridded(j3,k3) .EQ. zgridbad ) THEN
                  result(i,j,k,l,m,n) = bad_flag_result
               ELSE
                  result(i,j,k,l,m,n) = zgridded(j3,k3)
               ENDIF

               j3 = j3 + 1
  200       CONTINUE

            k3 = k3 + 1
  300    CONTINUE

         i3 = i3 + arg_incr(X_AXIS,ARG3)
  100 CONTINUE

         l3 = l3 + arg_incr(T_AXIS,ARG3)
  400 CONTINUE

         m3 = m3 + arg_incr(E_AXIS,ARG3)
  500 CONTINUE

         n3 = n3 + arg_incr(F_AXIS,ARG3)
  600 CONTINUE

      RETURN

  999 CALL EF_BAIL_OUT(id, errtxt)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN
      END


      SUBROUTINE nobadyz(yin, zin, fin, bady, badz, badf,
     .                   npts, i3, ylo, yhi, zlo, zhi, l3, m3, n3,
     .                   yscat, zscat, fscat, nscat)

* ACM 11/00 change so not exact comparison: wasnt catching all bad values.
* ACM  5/01 properly deal with f-scattered points which may be fcns of x and t

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      LOGICAL TM_FPEQ

*  Input arguments
      REAL yin(*), zin(*)
      REAL fin(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz,
     .         mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)
      REAL bady, badz, badf
      INTEGER npts, i3, ylo, yhi, zlo, zhi, l3, m3, n3

*  Output arguments
      REAL yscat(*), zscat(*), fscat(*)
      INTEGER nscat

*  Local variables
      INTEGER idx, j3, k3

      nscat = 0

      IF ( yhi .GT. ylo ) THEN

         DO 100 idx = 1, npts
            IF ( TM_FPEQ(yin(idx), bady) ) GOTO 100
            IF ( TM_FPEQ(zin(idx), badz) ) GOTO 100
            j3 = ylo + idx - 1
            k3 = zlo
            IF ( TM_FPEQ(fin(i3,j3,k3,l3,m3,n3), badf) ) GOTO 100
            nscat = nscat + 1
            yscat(nscat) = yin(idx)
            zscat(nscat) = zin(idx)
            fscat(nscat) = fin(i3,j3,k3,l3,m3,n3)
  100    CONTINUE

      ELSE

         DO 200 idx = 1, nscat
            IF ( TM_FPEQ(yin(idx), bady) ) GOTO 200
            IF ( TM_FPEQ(zin(idx), badz) ) GOTO 200
            j3 = ylo
            k3 = zlo + idx - 1
            IF ( TM_FPEQ(fin(i3,j3,k3,l3,m3,n3), badf) ) GOTO 200
            nscat = nscat + 1
            yscat(nscat) = yin(idx)
            zscat(nscat) = zin(idx)
            fscat(nscat) = fin(i3,j3,k3,l3,m3,n3)
  200    CONTINUE

      ENDIF

      RETURN
      END


C**
C**  Comments from routine ZGRID used in the PLOT+ graphics package; 
C**  the code is part of Ferret which calls PLOT+
C**
C**	subroutine zgrid(z,nxsize,nysize,nx,ny,x1,y1,dx,dy, 
C**     1	xp,yp,zp,n,cay,nrng) 
C** 
C**    @(#)zgrid	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
c     sets up square grid for contouring , given arbitrarily placed 
c     data points. laplace interpolation is used. 
c     the method used here was lifted directly from notes left by 
c     mr ian crain formerly with the comp.science div. 
c     info on relaxation soln of laplace eqn supplied by dr t murty. 
c     fortran ii   oceanography/emr   dec/68   jdt 
c 
c     z = 2-d array of hgts to be set up. points outside region to be 
c     contoured should be initialized to 10**35 . the rest should be 0.0 
c     nx,ny = max subscripts of z in x and y directions . 
c     x1,y1 = coordinates of z(1,1) 
c     dx,dy = x and y increments . 
c     xp,yp,zp = arrays giving position and hgt of each data point. 
c     n = size of arrays xp,yp and zp . 
c 
c     modification feb/69   to get smoother results a portion of the 
c     beam eqn  was added to the laplace eqn giving 
c     delta2x(z)+delta2y(z) - k(delta4x(z)+delta4y(z)) = 0 . 
c     k=0 gives pure laplace solution.  k=inf. gives pure spline solution. 
c     cayin = k = amount of spline eqn (between 0 and inf.) 
c     nrng...grid points more than nrng grid spaces from the nearest 
c            data point are set to undefined. 
c 
c     modification dec23/69   data pts no longer moved to grid pts. 
c 
c     modification may 5 79  common blocks work1 and work2 must 
c     be dimension at least n points long by the user.  common 
c     block work3 must be dimensioned at least ny points long. 
c 
c	modification june 17,1985 - handles data values of 1e35. if at
c	least one data value near a grid point is equal to 1e35, the z
c	array is initialized to 1e35 at that grid point
c	- by g.r. halliwell
c

	SUBROUTINE TAYIS1(TLO,ITIME1,ITIME2,DT,NSMTIC,LABEL,IDDB,IMDB,
     *	TFACT,X,XFACT,CSIZE,xacross,hgrat,hcolor,hline,color0)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* revised for TMAP
* from PPLUS :
*	Directory PMEL:[PLOT5.PPLV11.PLOTLIB]TAYIS1.FOR

* search for "TMAP" to find all revisions
* *sh*  - 1/23/89 added interrupt detection
*		  ... no explicit declarations (too much trouble !) so it must
*		      be compiled with /WARNINGS=NODECLARATIONS
C *acm* 1/24/00 Y2k Bug -- Put century at start  when comparing 
C                 ITIME to ITIME2 at loop 10
C *acm* 4/25/00 Further fix to the above - .LT. test rather than .LE.

C
* *jd* Mod for 4 digit years 11.27.95
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
C *acm* 03/04  new arguments and code for plotting graticule lines across plot. 
C V65  *acm*  1/10 New time-axis style for DAY and MONTH, DMY: adds the
C                  year to DAY,MONTH or to MONTH.
* *acm* - 8/16   ticket 1787: restore pen 0 correctly after graticule
* V745 *acm* 3/19 Draw tic marks on top of any graticule lines so 
*                 dashes or color are covered up by the tic mark

C**
C**    @(#)tayis1.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     THIS ROUTINE PLOTS A TIME AXIS AND LABELS IT WITH THE DAY OF THE M
C     AND THE MONTH.
C     VARIBLES:
C         TLO=X VALUE CORRESPONDING TO THE START TIME.
C         ITIME1 = START TIME (IE.  7708190000)
C                  WE RESTRICT THE PERMISSIBLE START TIMES TO BE
C                  EVEN DAYS.  (THAT IS THE LAST 6 DIGITS OF ITIME1
C                  MUST BE 0)
C         ITIME2 = END TIME (IE   7709070000)
C                  THIS IS THE FIRST DAY NOT TO BE PLOTTED, AND IT
C                  MUST BE AN EVEN DAY.
C         DT = SAMPLING RATE IN MINUTES.
C         NSMTIC = NUMBER OF SMALL TICS TO MAKE EACH DAY.
C                = 23 FOR HOURLY TICS.
C                = 11 FOR BIHOURLY TICS.
C                   ETC.
C         LABEL > 0 IF LABELS ARE TO BE DRAWN ABOVE THE AXIS.
C               = 0 IF NO LABELS ARE TO BE DRAWN.
C               < 0 IF LABEL ARE TO BE DRAWN BELOW THE AXIS.
C         IABS(LABEL) = 1 FOR LABELS OF THE STYLE
C                  1..........1..........1..........1..........1
C                       3           4          5        6
C                                      JUN
C         IABS(LABEL) = 2 FOR LABELS OF THE STYLE
C                  1..........1..........1..........1..........1
C                     JUN  3     JUN  4      JUN  5    JUN  6
C         IDDB = PRINT LABELS OF DAYS DIVIBLE BY THIS NUMBER ONLY.
C                IF(IDDB = 0) PRINT NO DAY LABELS.
C         IMDB = PRINT LABELS OF MONTHS DIVISIBLE BY THIS NUMBER ONLY.
C                IF(IMDB = 0) PRINT NO MONTH LABELS.
C                THIS VARIBLE ONLY APPLYS WHEN IABS(LABEL) = 1
C         TFACT = (LENGTH OF T AXIS IN INCHES)/(LENGTH OF T AXIS IN USER
C         Y = Y COORDINATE OF TIME AXIS.
C         YFACT = (LENGTH OF Y AXIS IN INCHES)/(LENGTH OF Y AXIS IN USER
C         CSIZE = SIZE TO DRAW DAY LABELS.
C                 MONTH LABELS WILL BE 1.5 TIMES AS LARGE.
C
C     THERE WAS A MODIFICATION TO THIE IN JUNE 1980.  THE
C     SOLE PURPOSE FOR THIS MODIFICATION WAS TO IMPROVE 'S
C     EFFICIENCY.
C
	CHARACTER ITIME3*14
	CHARACTER SYM*21,ITIME1*(*),ITIME*14,ITIME2*(*),MON*3,DAY*2,
     .		  YEAR*4, BUFF*8
	COMMON/TICS/TSMX,TLX,TSMY,TLY,IX,IY
	COMMON/AXLWID/XWID,YWID

* Parameters for drawing tics across plot

        REAL xacross
        REAL dash1_1, dash1_2, dash1_3, dash1_4
        REAL dash2_1, dash2_2, dash2_3, dash2_4
        REAL hgrat(4,2)        ! line type: 0=tics only, <0=line, >0=dash lengths 
        INTEGER hcolor(*)      ! pen number for graticule lines
	INTEGER color0	       ! pen number to restore 
        LOGICAL hline, do_line ! If true, do the lines across.
        LOGICAL solid1, solid2   ! solid lines across at tics
        LOGICAL dashed1, dashed2 ! dashed lines across at tics
        INTEGER ltic, color1, color2

* TMAP interrupt flag

	include 'xinterrupt.cmn'
        include 'century.cmn'
        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'lines_inc.decl'
        include 'LINES.INC'
        INCLUDE 'pen_inc.decl'  ! with IPEN(1)
        INCLUDE 'PEN.INC'

C     CHECK THE PARAMETERS PASSED TO THE SUBROUTINE.
	IF(ITIME1(7:10).NE.'0000')STOP ',1'
	IF(ITIME2(7:10).NE.'0000')STOP ',2'

C set up for plotting graticules across at tic marks
        
        solid1 = (hgrat(1,1).LT.0 .AND. hgrat(2,1).LT.0 .AND.  
     .            hgrat(3,1).LT.0 .AND.  hgrat(4,1).LT.0 )
        solid2 = (hgrat(1,2).LT.0 .AND. hgrat(2,2).LT.0 .AND.  
     .            hgrat(3,2).LT.0 .AND.  hgrat(4,2).LT.0 )
        dashed1 = (hgrat(1,1).GT.0 .OR. hgrat(2,1).GT.0 .OR.  
     .            hgrat(3,1).GT.0 .OR.  hgrat(4,1).GT.0 )
        dashed2 = (hgrat(1,2).GT.0 .OR. hgrat(2,2).GT.0 .OR.  
     .            hgrat(3,2).GT.0 .OR.  hgrat(4,2).GT.0 )

     	do_line = hline

        color1 = hcolor(1)
        color2 = hcolor(2)

        IF (dashed1) THEN
           dash1_1 = hgrat(1,1)
           dash1_2 = hgrat(2,1)
           dash1_3 = hgrat(3,1)
           dash1_4 = hgrat(4,1)
        ENDIF
        IF (dashed2) THEN
           dash2_1 = hgrat(1,2)
           dash2_2 = hgrat(2,2)
           dash2_3 = hgrat(3,2)
           dash2_4 = hgrat(4,2)
        ENDIF

C     SET PARAMETERS.

*     *jd Number of arguments of TIME3 calls reduced to 6.  TIME3 uses only
*     the first 6, 'seconds' are not handled.  Done for MAC 7.92

	TIC = 1440./DT
	NTIC = NSMTIC + 1
	IF(NSMTIC.LT.0)THEN
	    IHVY=-6
	    INML=-5
	ELSE
	    IHVY=-10
	    INML=-6
	    TDIST = TIC/NTIC
	ENDIF
	IF(LABEL+IY.EQ.0)THEN
	    XTEMP=0.0
	ELSE
	    XTEMP=TLY*0.5
	ENDIF
	IF(IDDB.NE.0)THEN
	    FIDDB=0.0
	ELSE
	    FIDDB=-1.4
	ENDIF
	IF(LABEL.LT.0) THEN
	    XTEMP1=X-(1.4*CSIZE+XTEMP)/XFACT
	    XTEMP2=X-((4.0+FIDDB)*CSIZE+XTEMP)/XFACT
	ELSE
* ... corrected tabulation error in next line *sh* 1/23/89
	    XTEMP1=X+(0.4*CSIZE+XTEMP)/XFACT
	    XTEMP2=X+((2.5+FIDDB)*CSIZE+XTEMP)/XFACT
	ENDIF
	IF(LABEL.NE.0)YWID=(4.0+FIDDB)*CSIZE+XTEMP


	T=TLO
	ITIME=ITIME1
	CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
	TMON=T
	CALL PLOT(X,TLO,0,0)
	IF(IDAY.EQ.1)THEN
	    CALL PLOTT7(X,TLO,XFACT,TFACT,1,IHVY)
	ELSE
	    CALL PLOTT7(X,TLO,XFACT,TFACT,1,INML)
	ENDIF

c ----  count number of large tics. If no large tics will be drawn
c ----  then will want to draw graticule lines at the small ones.

      ITIME=ITIME1
      CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)

C      LOOP like loop 10 below
      ltic = 0
  110 CONTINUE
      IF ( interrupted ) RETURN		! TMAP interrupt
      
      CALL TIME1(1,ITIME,2,' ',I3,ITIME3,1440.)
      CALL TIME3(ITIME3,IYR3,IMON3,IDAY3,IHR3,IMIN3,ISEC3,ICEN3)

      ITIME=ITIME3
      IF(ITIME(13:14)//ITIME(1:12) .LT. 
     .       ITIME2(13:14)//ITIME2(1:12) ) THEN
         IF (IDAY3.EQ.1) ltic = ltic + 1  !It is a large tic.
         GO TO 110
      ENDIF

! IF no large tics, and if graticules at just the large tics were
! requested, then plot graticules at the small tics

	IF (ltic .EQ. 0) THEN   
           IF ( (.NOT.solid2) .AND. (solid1) ) THEN
              solid2 = solid1
              color2 = color1
           ENDIF
           IF ( (.NOT.dashed2) .AND. (dashed1) ) THEN 
              dashed2 = dashed1
              dash2_1 = dash1_1
              dash2_2 = dash1_2
              dash2_3 = dash1_3
              dash2_4 = dash1_4
              color2 = color1
           ENDIF
        ENDIF
c ----

      ITIME=ITIME1
      CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)

C      LOOP:
10	CALL PLOT(X,T,0,0)
	IF ( interrupted ) RETURN		! TMAP interrupt
	
*    do not draw a graticule line along the upper axis
	  do_line = ( ITIME3(13:14)// ITIME3(1:10).LT.
     .	              ITIME2(13:14)//ITIME2(1:10)) 

	DO 20 I=1,NSMTIC
        
                 IF ((solid2.OR.dashed2) .AND. do_line) THEN ! make line across
                    CALL COLOR(color2)
                    IF (dashed2) THEN
                       CALL DASHSZ(dash2_1,dash2_2,dash2_3,dash2_4)
                       CALL DASHES
                    ENDIF
                    CALL PLOT(x,T+FLOAT(I)*TDIST,0,0) 
                    CALL PLOT(xacross,T+FLOAT(I)*TDIST,1,0)
                    CALL PLOT(x,T+FLOAT(I)*TDIST,0,0) 
                    CALL COLOR(color0)
                    CALL VECTRS
                 ENDIF
	CALL PLOTT7(X,T+FLOAT(I)*TDIST,XFACT,TFACT,1,-5)


20	CONTINUE
	CALL TIME1(1,ITIME,2,' ',I3,ITIME3,1440.)
	CALL TIME3(ITIME3,IYR3,IMON3,IDAY3,IHR3,IMIN3,ISEC3,ICEN3)
	
*    do not draw a graticule line along the upper axis
	  do_line = ( ITIME3(13:14)// ITIME3(1:10).LT.
     .	              ITIME2(13:14)//ITIME2(1:10)) 

	IF(IDAY3.EQ.1)THEN
              IF ((solid1.OR.dashed1) .AND. do_line) THEN ! make line across
                 CALL COLOR(color1)
                 IF (dashed1) THEN
                    CALL DASHSZ(dash1_1,dash1_2,dash1_3,dash1_4)
                    CALL DASHES
                 ENDIF
                 CALL PLOT(x,t+tic,0,0) 
                 CALL PLOT(xacross,t+tic,1,0)
                 CALL PLOT(x,t+tic,0,0) 
                 CALL COLOR(color0)
                 CALL VECTRS
              ENDIF
	    CALL PLOTT7(X,T+TIC,XFACT,TFACT,1,IHVY)
	ELSE

                 IF ((solid2.OR.dashed2) .AND. do_line) THEN ! make line across
                    CALL COLOR(color2)
                    IF (dashed2) THEN
                       CALL DASHSZ(dash2_1,dash2_2,dash2_3,dash2_4)
                       CALL DASHES
                    ENDIF
                    CALL PLOT(x,t+tic,0,0) 
                    CALL PLOT(xacross,t+tic,1,0)
                    CALL PLOT(x,t+tic,0,0) 
                    CALL COLOR(color0)
                    CALL VECTRS
                 ENDIF
	    CALL PLOTT7(X,T+TIC,XFACT,TFACT,1,INML)

	ENDIF
C         THE LABELS
	CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
	IF(IDDB.EQ.0.OR.LABEL.EQ.0) GO TO 50
	IF(IDAY.NE.IDDB*(IDAY/IDDB)) GO TO 50
	CALL TIME2(ITIME,SYM)
	READ(SYM,30) MON,DAY
30	FORMAT(6X,A3,1X,A2,1X,A4)
	IF(DAY(1:1).EQ.' ')THEN
	    NC=1
	    DAY=DAY(2:2)
	ELSE
	    NC=2
	ENDIF
	IF(IABS(LABEL).EQ.1)THEN
	    TSYM=T+(TIC-SYMWID(CSIZE,NC,DAY)/TFACT)*.5
	    CALL SYMBEL(XTEMP1,TSYM,90.,CSIZE,NC,DAY)
	ELSE
	    WRITE(SYM,40)MON,DAY
40	    FORMAT(A3,' ',A2)
	    TSYM=T+(TIC-SYMWID(CSIZE,6,SYM)/TFACT)*.5
	    CALL SYMBEL(XTEMP1,TSYM,90.,CSIZE,6,SYM)
	ENDIF
50	CONTINUE
	IF(IMDB.EQ.0.OR.IABS(LABEL).NE.1) GO TO 70
	IF(IMON.EQ.IMON3) GO TO 70
	IF(IMON.NE.IMDB*(IMON/IMDB)) GO TO 60
C             ELSE:
	IF(T-TMON.GT.4320./DT)THEN
	    CALL TIME2(ITIME,SYM)
	    READ(SYM,30)MON,DAY, year
            IF (monyrlab) THEN
 	       WRITE (buff, 100) mon, year
 100	       FORMAT (A3, ' ', A4)
               TSYM=TMON+(T+TIC-TMON-SYMWID(1.5*CSIZE,8,BUFF)/TFACT)*.5
	       CALL SYMBEL(XTEMP2,TSYM,90.,1.5*CSIZE,8,buff)
	    ELSE
	       TSYM=TMON+(T+TIC-TMON-SYMWID(1.5*CSIZE,3,MON)/TFACT)*.5
	       CALL SYMBEL(XTEMP2,TSYM,90.,1.5*CSIZE,3,MON)
            ENDIF
	ENDIF
60	TMON=T+TIC
70	CONTINUE
	ITIME=ITIME3
	T=T+TIC
c	IF(ITIME.LT.ITIME2) GO TO 10
        IF(ITIME(13:14)//ITIME(1:12) .LT.
     .       ITIME2(13:14)//ITIME2(1:12)) GO TO 10
     
	IF(IMDB.EQ.0) RETURN
	IF(IABS(LABEL).EQ.1.AND.IMON.EQ.IMDB*(IMON/IMDB)
     .	.AND.IDAY3.GE.4)THEN
	    CALL TIME2(ITIME,SYM)
	    READ(SYM,30)MON,DAY, year
            IF (monyrlab) THEN
 	       WRITE (buff, 100) mon, year
               TSYM=TMON+(T+TIC-TMON-SYMWID(1.5*CSIZE,8,BUFF)/TFACT)*.5
	       CALL SYMBEL(XTEMP2,TSYM,90.,1.5*CSIZE,8,buff)
	    ELSE
	       TSYM=TMON+(T+TIC-TMON-SYMWID(1.5*CSIZE,3,MON)/TFACT)*.5
	       CALL SYMBEL(XTEMP2,TSYM,90.,1.5*CSIZE,3,MON)
            ENDIF
	ENDIF
	RETURN
	END

	    

	SUBROUTINE DEFINE_AGGREGATE_GRID (agg_dset, nvars, vname,
     .      fvar, iline, grid, agg_dim, member_sets, nsets)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Define ensemble axis and grid using that axis. For uvars, grid is 
* set to unspecified_int4 when calling this. Will defer the grid check for later.

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP 
*
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE

      IMPLICIT NONE
        include 'tmap_errors.parm'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xdset_info.cd_equiv'
        include 'xprog_state.cmn'
	include 'xtm_grid.cmn_text'  
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xfr_grid.cmn'
	include 'interp_stack.parm'
	include 'netcdf.inc'

* calling argument declarations:
	INTEGER agg_dset, nvars, fvar, iline, grid,
     .		agg_dim, member_sets(*), nsets
	CHARACTER*(*) vname

* local variable declarations:
	LOGICAL	its_dynamic, itsa_uvar
	INTEGER STR_SAME,
     .		big_cx, igrid, idim, gnum, nv, type, 
     .		ii, iset, slen, vtype, status

* Just for testing, get info back from the attribute-handling structure
	CHARACTER varname*128, name*128
	INTEGER vartype, nvdims, vdims(8), nvatts, all_outflag, varid
	LOGICAL coordvar

* Define aggregate grid

      igrid = unspecified_int4
      IF (grid .NE. unspecified_int4) THEN
         igrid = 0
         CALL TM_NEXT_TMP_GRID (igrid, 710)
  710    CALL TM_ALLO_TMP_GRID (igrid, status)
         IF (status .NE. ferr_ok) GOTO 5000

         DO 700 idim = 1, nferdims
            grid_line(idim, igrid) = grid_line(idim,grid)
  700    CONTINUE
         grid_line(agg_dim, igrid) = iline
         
* Make up a unique grid name for aggregate grid
           IF (agg_dim .EQ. 5) grid_name(igrid) = 'GEN'
           IF (agg_dim .EQ. 6) grid_name(igrid) = 'GFN'
           CALL TM_NEW_GRID_NAME( grid_name(igrid), name )
           grid_name(igrid) = name

	   gnum = igrid
      ENDIF

* ds_var slot, fill with aggregate variable in aggregate dataset.

      itsa_uvar = .FALSE.
      DO 720 nv = 1, maxvars
	      IF ( STR_SAME(ds_var_code(nv),char_init) .EQ. 0 ) GOTO 725
 720	CONTINUE
 725	ds_var_setnum(nv)   = agg_dset
	CALL string_array_modify(ds_var_code_head, nv, 
     .         ds_var_code(fvar), LEN(ds_var_code(fvar)))
	ds_var_title(nv)    = ds_var_title(fvar)
	IF ( ds_var_title(nv) .EQ. char_init128) 
     .       ds_var_title(nv)  = varname
	ds_var_titl_mod(nv) = ds_var_titl_mod(fvar)
	ds_var_units(nv)    = ds_var_units(fvar)
	ds_var_type(nv)     = ds_var_type(fvar)
	ds_missing_flag(nv) = bad_val4
	ds_bad_flag(nv)     = bad_val4
	cd_scale_factor(nv) = 1.
	cd_add_offset(nv)   = 0.
	cd_scaled(nv)       = .FALSE.

	IF (grid .NE. unspecified_int4) THEN
	   DO 730 idim = 1, nferdims
	      ds_grid_start(idim,nv)= ds_grid_start(idim,fvar)
	      ds_grid_end(idim,nv)  = ds_grid_end(idim,fvar)
	      ds_ordering(idim,nv)  = ds_ordering(idim,fvar)
 730	   CONTINUE
	   ds_ordering(agg_dim,nv) = agg_dim
	   ds_grid_start(agg_dim,nv) = 1
	   ds_grid_end(agg_dim,nv) = nsets
	   ds_grid_number(nv) = gnum
	ENDIF

* Type should be NCFLOAT or NCCHAR
	IF (ds_var_type(nv) .EQ. ptype_string) THEN
	   type = NCCHAR
	ELSE
	   type = NCFLOAT
	ENDIF
      
	CALL CD_ADD_VAR( agg_dset, vname, nvars, 
     .         ds_var_title(nv), ds_var_units(nv), type, 
     .         .FALSE., ds_bad_flag(nv), status)

* Add aggregate-grid info to the lists in aggregate datset and aggregate-grid list.
* Mark user-variables with a grid number of -999

	DO 750 ii = 1, nsets
	   iset = member_sets(ii)
	   DO 740 nv = 1, maxvars
	      IF ( (ds_var_setnum(nv) .EQ. iset) .AND. 
     .             (STR_SAME(ds_var_code(nv), vname) .EQ. 0) ) THEN
	         igrid = ds_grid_number(nv)
		 vtype = 1 ! file var
	         CALL CD_ADD_AGG_VAR_INFO (agg_dset, vname, ii, vtype, 
     .             iset, igrid, iline, nv, status)
	      ENDIF
	      IF ( (uvar_dset(nv) .EQ. iset) .AND. 
     .             (STR_SAME(uvar_name_code(nv), vname) .EQ. 0) ) THEN
	         igrid = unspecified_int4
		 vtype = 3 ! user var
	         CALL CD_ADD_AGG_VAR_INFO (agg_dset, vname, ii, vtype, 
     .             iset, igrid, iline, nv, status)
	      ENDIF
 740	   CONTINUE
 750	CONTINUE

 5000	RETURN
     
	END

	SUBROUTINE get_scriptfile_name ( name, ipath )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*	Ansley Manke PMEL/TMAP
*	8/2003

* V602 1/07 Fix bug 1410: If the script name contains a relative path name,
*           it was not recognized as a valid path/filename.  Need to check for
*           PathSeparator in the filename.  (previously looked for 1st character /)
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

* Get script file name from common, for running with the comand line option
*  ferret -script 
* 

	include 'tmap_dims.parm'
	INCLUDE 'xprog_state.cmn'
#include "gt_lib.parm"

* calling argument declarations:
	CHARACTER*(*)	name
        INTEGER ipath

* Get the name and set a flag if the name begins with a path.

        name = scriptfile_name
        ipath = 0
        IF ( INDEX( scriptfile_name, PathSeparator) .GT. 0) ipath = 1

	RETURN
	END

	SUBROUTINE SHOW_DATA_SET_VARS( lun, dset, full, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* describe the variables in the named data set

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 -  1/10/89 - based on SHOW_DATA_SET 0.2
*			  - with added world coordinate output
* V200:  8/31/90 - changed field widths for subscript limits
* Unix/RISC port 3/11/91 *sh* - eliminated "unaligned data access" errors when
*                               writing variables
* V230: ?? - formatting changes to accomodate indices of more than 4 digits
*     6/92 - locate a grid using this time axis for "time range"
*     7/92 - bypass listing of variables named "-" (EZ data sets)
*    11/92 - increased length of variable names 8 --> 24 characters
* V301: 3/94 - bug fix: no time range display for T-independent data sets
*    3/16/94 - repaired bug introduced 3/3/94 for EZ data set
* V320: 12/29/94 - use SPLIT_LIST to redirect tty output for GUI
*	 1/18/95 - show units in full listing  
* V402: 8/95 - Added support for  LET/D=dset var = ...
*	     - Added missing data flag to outputs
* V420:	10/95 - extended missing flag output to cover dual flags
* V500: 3/99 *kob* - added check for NORMAL Axes - output only ... rather
*                    than a 1:1 or 100:100
*       4/99 *kob* - bug fix to above - check grid_line to see if axis is
*                    truly normal
* V510: 4/00 *sh* - search dynamic grids for netCDF time axis
* V530: 10/00 *sh* - added information about data typed
* v530  *acm* 3/01 - Show calendar name for alternative calendar types.
* 2/03 *kob* - g77 port - g77 won't allow intrinsic functions in PARAMETER
*                         statements.  use an octal constant instead 
* V570  *acm* when showing calendar, need  cal_id .LE. max_calendars, not .LT.
* V600  *acm* 1/06  prevent values of LOG10(0.0) 
* V68   *acm* 12/11 Fix ticket 1905. Axis-lengths that need more than 6 characters
*                   were being cut off.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V6.8  acm  6/12 Implement mode_6d_lab, set by default. If canceled, the 
*                 various SHOW commnands will not list info for E,F dimensions.
* v6.85  *acm* 4/13 Can show grid for variables in an ensemble aggregated dataset.
* v6.85  *acm* 10/13 See ticket 1098, extraneous lines when error getting grid.
* V695 *acm*  2/15 For Forecast aggregations, call the ds_type 'FCT'
* v695 *acm*  4/15 Bug fix: output written in loop 300 was cut off
* V698 2/16 *acm*  For ticket 1786: if mode_upcase is canceled write axis name
*                  using original upper/lowercase spelling
* V7   *acm*  6/12 Add Union aggregations: DEFINE DATA/AGG/U, ds_type 'UNI'
* V7    acm  6/16 Ticket 2437: Deprecating mode_6d_lab. 
*		  Adjust output to 6-D or 4-D grids
* V720  3/17 *acm*  clean up long commented-out code referring to aggregations 
*       4/17 *sh* report DSG ragged axis length as "tot 15"
* V720 *acm* 5/17 Implement specific calls in place of CD_GET_VAR_INFO
* V741 *acm* 5/18 Promoting global attributes to a variable in ensembles: list 
*                 the variables synthesized by aggregations with a separator ---
* V743 *acm* 10/10 Fix issue 1897: datasets with E or F axis in any grids gets 6 columns
* V74+ 7/18 *acm* For DSG datasets, if we synthesized a RowSize var, don't show it.
* V751 *acm* 6/19 Remove unused declarations
* V751 6/19 *acm* TM_FMT rewrite: formatting of lon/lat coordinate strings
* V751 7/18 *acm* Call single routine for DSG feature-type names
* V751 8/18 *acm* List the coordinate ranges if DSG dataset
* V76  1/20 *acm* working with Point-type dsg data 
* V76  2/20 *acm* move the code for listin the DSG coordinate ranges
*                 to its own routine, also called by SHOW GRID.
* V76  2/20 *acm* Clean up the SHOW DATA/FULL output for DSG grids -
*                 coordinate info is only at the end of the listing

        IMPLICIT NONE
	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'ez_lib.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'errmsg.parm'
	include 'xez_info.cmn_text'
	external xez_info_data
	include	'ferret.parm'
	include	'xvariables.cmn'
	include	'xtext_info.cmn'
	include	'xprog_state.cmn'
	include	'xrisc.cmn'
	include 'calendar.decl'
	include 'calendar.cmn'

* calling argument declarations:
	LOGICAL	full
	INTEGER	lun, dset, status
	
* local variable declarations:

	LOGICAL		FOUR_D_GRID, TM_ITSA_DSG_RAGGED,
     .			first_time, its_delimited, is_undetermined, coordvar,
     .			its_dsg, grid_dsg, first_note, got_it, has_mask
	INTEGER 	TM_LENSTR1, TM_LENSTR, TM_GET_CALENDAR_ID, GRID_FROM_NAME, 
     .			STR_DNCASE,  
     .			ivar, i, dlen, len, grid, taxis, slen(nferdims), tlen, 
     .			nfields, kvar, field_types(maxezvars), 
     .			cal_id, len_cal, j, num_indices, rlen(nferdims), iok,
     .			listdims, idim, igrid, nv, varid, dsg_orient, ndec
	CHARACTER	LEFINT*16, LOHI_STRING*48, TM_FMT*48, 
     .			TM_GET_CAL*32, CD_DSG_FEATURENAME*20,
     .			line*255, cal_name*32
	REAL*8		TM_WORLD, lo, hi
        CHARACTER       rbuff(12)*8, short*6, long*16, delims*128, c*1

* internal parameter declarations:
        CHARACTER*1     tab
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
#else
	PARAMETER     ( tab = CHAR(9))
#endif


* initialize
	its_delimited = ds_type(dset) .EQ. pds_type_ez
     .            .AND. ds_parm_text(1,dset)(:4) .eq. 'DELI'
	IF (its_delimited) THEN
	   CALL GET_DELIMITED_INFO(nfields, field_types, delims, 
     .				   ds_file_info_ptr(dset) )
	ENDIF

* If the dataset is a DSG dataset, note the FeatureType
        its_dsg = .FALSE.
	DO ivar = 1, maxvars
	   igrid = ds_grid_number(ivar)
	   IF (igrid .EQ. int4_init) CYCLE
	   IF (TM_ITSA_DSG_RAGGED(igrid)) THEN
	      its_dsg = .TRUE.
	      EXIT
	   ENDIF
	ENDDO
	IF (its_dsg) THEN

	   dsg_orient = dsg_orientation(dset)

	   risc_buff = '       DSG Feature type '
	   tlen = TM_LENSTR1( risc_buff ) + 1
	   risc_buff = risc_buff(:tlen)//  CD_DSG_FEATURENAME(dsg_orient)

	   IF (dsg_orient.LT.pfeatureType_Trajectory .OR. 
     .         dsg_orient.GT.pfeatureType_Point) risc_buff = ''

	   tlen = TM_LENSTR1( risc_buff )
	   IF (tlen .GT. 0)  CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0) 
	   
* Is a feature mask set on this dataset?
	   IF (dsg_msk_lm(dset) .NE. int4_init .AND. dsg_msk_lm(dset).NE.unspecified_int4) THEN 
	      risc_buff = 'Mask on features has been set: '
	      tlen = TM_LENSTR1( risc_buff ) + 1
	      
	      CALL GET_DSG_MASK_TITLE (dset, risc_buff(tlen+1:), has_mask, dlen)

	      tlen = TM_LENSTR1( risc_buff ) 
	      IF (dlen .EQ. 0) tlen = tlen - 1

	      IF (tlen .GT. 0)  CALL SPLIT_LIST(pttmode_explct, lun, risc_buff(:tlen), 0) 
	   ENDIF ! feature-mask

	ENDIF

	first_note = .TRUE.

* If mode 6d_lab has been canceled, we will list only the first 4 dimensions.

	listdims = 0
	IF ( .NOT. mode_6d_lab) listdims = 4
	status = ferr_ok

* Adjust number of dimensions. If all grids are 4D, will just show those.

	IF (mode_6d_lab) THEN
	listdims = 0

	DO 80 ivar = 1, maxvars
	   IF ( ds_var_setnum(ivar) .NE. dset ) GOTO 80
           IF ( ds_var_code(ivar) .EQ. '-' ) GOTO 80  
* ... output variable code, title and subscript bounds within grid

	   is_undetermined = .TRUE.
	   DO 40 idim = 1, nferdims
	      IF (ds_grid_start(1,ivar) .NE. int4_init) 
     .            is_undetermined = .FALSE. 
  40	   CONTINUE

* Is this an aggregated dataset? - if so then we can go get the grid.
* GRID_FROM_NAME increments the use count for the grid, so call
* DEALLO_DYN_GRID to restore the count where it should be.

           IF (is_undetermined .AND. 
     .         (ds_type(dset).EQ.'ENS' .OR. ds_type(dset).EQ.'FCT' 
     .          .OR. ds_type(dset).EQ.'UNI')) THEN
              IF (ds_type(dset).EQ.'UNI') THEN
	         igrid = ds_grid_number(ivar)
	      ELSE
	         igrid = GRID_FROM_NAME(ds_var_code(ivar), cx_last, status)
	         IF (status .NE. ferr_ok) GOTO 5000
	         CALL TM_DEALLO_DYN_GRID (igrid)  
	      ENDIF

           ELSE
	      igrid = ds_grid_number(ivar)
           ENDIF

           IF (.NOT.is_undetermined) THEN	
	      IF ( FOUR_D_GRID(igrid)) THEN
	         listdims = MAX(listdims,4)
	      ELSE
	         listdims = 6
	      ENDIF
           ENDIF
 80	CONTINUE

	IF (listdims .EQ. 0) listdims = nferdims
	ENDIF ! adjusting listdims

* describe the variables in the set

	risc_buff = ' '
        IF (listdims .EQ. nferdims) THEN
           WRITE ( risc_buff, 3200 )
        ELSE
           WRITE ( risc_buff, 3210 )
        ENDIF

	CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0) 


	kvar = 0
	DO 400 ivar = 1, maxvars
	   IF ( ds_var_setnum(ivar) .NE. dset ) GOTO 400
	   kvar = kvar + 1
           IF ( ds_var_code(ivar) .EQ. '-' ) GOTO 400  

	   IF (its_dsg .AND. ds_var_code(ivar) .EQ. 'ferRowSize') GOTO 400
	   
* ... output variable code, title and subscript bounds within grid

	   is_undetermined = .TRUE.
	   DO 200 idim = 1, nferdims
	      IF (ds_grid_start(1,ivar) .NE. int4_init) 
     .            is_undetermined = .FALSE. 
  200	   CONTINUE

* Is this an aggregated dataset? - if so then we can go get the grid.
* GRID_FROM_NAME increments the use count for the grid, so call
* DEALLO_DYN_GRID to restore the count where it should be.

           IF (is_undetermined .AND. 
     .         (ds_type(dset).EQ.'ENS' .OR. ds_type(dset).EQ.'FCT' 
     .          .OR. ds_type(dset).EQ.'UNI')) THEN
              IF (ds_type(dset).EQ.'UNI') THEN
	         igrid = ds_grid_number(ivar)
	      ELSE
	         igrid = GRID_FROM_NAME(ds_var_code(ivar), cx_last, status)
	         IF (status .NE. ferr_ok) GOTO 5000
	         CALL TM_DEALLO_DYN_GRID (igrid)  

*  Fill the grid in as in define_ef_aggregate_grid

	         IF (igrid .NE. unspecified_int4) THEN
	            DO 220 nv = 1, maxvars
	               IF (ds_grid_number(nv) .EQ. igrid) EXIT ! loop
 220	            CONTINUE
	         ENDIF

	      ENDIF

	      IF (nv .LE. maxvars) THEN
	         DO 230 idim = 1, nferdims
	            ds_grid_start(idim,ivar)= ds_grid_start(idim,nv)
	            ds_grid_end(idim,ivar)  = ds_grid_end(idim,nv)
	            ds_ordering(idim,ivar)  = ds_ordering(idim,nv)
 230	         CONTINUE
	         is_undetermined = .FALSE.
              ENDIF
           ELSE
	      igrid = ds_grid_number(ivar)
           ENDIF

           IF (.NOT.is_undetermined) THEN
	      
	      grid_dsg = TM_ITSA_DSG_RAGGED(igrid)
	      IF (grid_dsg) dsg_orient = dsg_orientation(dset)

              DO 100 i = 1, listdims
                 WRITE( rbuff(i+listdims),'(I8)' ) ds_grid_start(i,ivar)
                 IF (FLOAT(ds_grid_start(i,ivar)) .EQ. 0.0) THEN
                    slen(i) = 1
                 ELSE
                    slen(i)  = LOG10( FLOAT(ds_grid_start(i,ivar)) )
                 ENDIF
                 slen(i)  = MIN( 6, 8-slen(i) )   ! last few characters in buffer
                 long = LEFINT(ds_grid_end(i,ivar),dlen)
                 rlen(i) = dlen
                 short = LEFINT(ds_grid_end(i,ivar),dlen)
                 rbuff(i) = short
 100          CONTINUE
           ENDIF

* List synthesized variable in aggregations after a separator

	   IF ( (ds_var_title(ivar)(1:12) .EQ. 'Global Att *' .OR.
     .	         ds_var_title(ivar)(1:20) .EQ. 'Member dataset names')
     .	         .AND. first_note) THEN
	      line = ' ------------------------------'
	      CALL SPLIT_LIST(pttmode_explct, lun, line, 0) 
	      first_note = .FALSE.
           ENDIF

	   line = ds_var_code(ivar)
	   IF (.NOT.mode_upcase_output) THEN  ! get original variable name
	      CALL CD_GET_VAR_ID (dset, ds_var_code(ivar), varid, status)
	      CALL CD_GET_VAR_VARNAME (dset, varid, line, status)
	   ENDIF

* ... separate into two lines if variable code is too long (11/92)
           IF ( TM_LENSTR1( line ) .GT. 8 ) THEN
	      risc_buff = ' '
              WRITE ( risc_buff, '(1X,A)' ) line
	      CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0) 
              line = ' '
           ENDIF
	   IF (is_undetermined) THEN 
	      WRITE ( risc_buff, 4011 )	line,
     .				        ds_var_title(ivar),
     .				        '... Aggregate grid undetermined' 
           ELSE
	      WRITE ( risc_buff, 4010 )	line,
     .				        ds_var_title(ivar),
     .	     (rbuff(i+listdims)(slen(i):),rbuff(i)(:6),i=1,listdims)

 4010	      FORMAT( 1X,A8,1X,A31,T42,6(A,':',A) )
 4011	      FORMAT( 1X,A8,1X,A31,T42,A )
* *kob* 3/99 check for NORMAL Axis and insert ... rather than 1:1 
              DO 150 i = 1, listdims
	         IF ( grid_line(i,ds_grid_number(ivar)) .EQ. mnormal) THEN
		    tlen = 34 + (i*10)
		    risc_buff(tlen:tlen+2) = '...'
	         ENDIF
 150	      CONTINUE
* *sh* 4/17 a DSG obs axis actually shows the total of feature lengths
	      IF (grid_dsg) THEN
	         tlen = 34 + (dsg_orient*10) - 2
	         risc_buff(tlen:tlen+4+rlen(dsg_orient))
     .			= 'tot '//rbuff(dsg_orient)(:rlen(dsg_orient))
	      ENDIF

           ENDIF

* See if any axis lengths were too long for the standard formatting.
* Do a more brute-force formatting which may or may not line up 
* all variables perfectly

           iok = 1
           DO 160 i = 1, listdims
	      IF (rlen(i) .GT. 6) iok = 0
 160	   CONTINUE

	   IF (iok .EQ. 0) THEN  ! re-format the line for this variable

* List synthesized variable in aggregations after a separator

           IF ( (ds_var_title(ivar)(1:12) .EQ. 'Global Att *'.OR.
     .	         ds_var_title(ivar)(1:20) .EQ. 'Member dataset names')
     .	       .AND. first_note) THEN
	      line = ' ------------------------------'
	      CALL SPLIT_LIST(pttmode_explct, lun, line, 0) 
	      first_note = .FALSE.
           ENDIF

	   line = ds_var_code(ivar)
	   IF (.NOT.mode_upcase_output) THEN  ! get original variable name
	      CALL CD_GET_VAR_ID (dset, ds_var_code(ivar), varid, status)
	      CALL CD_GET_VAR_VARNAME (dset, varid, line, status)
	   ENDIF
* ... separate into two lines if variable code is too long (11/92)
           IF ( TM_LENSTR1( line ) .GT. 8 ) THEN
	      risc_buff = ' '
              WRITE ( risc_buff, '(1X,A)' ) line
	      CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0) 
              line = ' '
           ENDIF

	   WRITE ( risc_buff, 4010 )	line,
     .				        ds_var_title(ivar)
           tlen = MAX(40, TM_LENSTR1(risc_buff))
	   risc_buff(tlen+1:tlen+2) = '  ' 
           tlen = tlen + 2

           DO 170 i = 1, listdims
	      IF ( grid_line(i,ds_grid_number(ivar)) .EQ. mnormal) THEN
		 risc_buff(tlen:tlen+8) = '   ...   '
		 tlen = tlen + 9
              ELSE
                 long = LEFINT(ds_grid_start(i,ivar),dlen)
	         risc_buff(tlen+1:tlen+dlen) = long(1:dlen)
	         tlen = TM_LENSTR1(risc_buff)
	         risc_buff(tlen+1:tlen+1) = ":"
	         tlen = tlen + 1
                 long = LEFINT(ds_grid_end(i,ivar),dlen)
	         risc_buff(tlen+1:tlen+dlen) = long(1:dlen)
	         tlen = TM_LENSTR1(risc_buff)
	         risc_buff(tlen+1:tlen+2) = '  ' 
	         tlen = tlen + 2

	      ENDIF
 170	   CONTINUE
	   ENDIF ! iok

 3200	FORMAT(' name',T11,'title',T45,'I',T55,'J',T65,'K',T75,'L',T85,'M',T95,'N')
 3210	FORMAT(' name',T11,'title',T45,'I',T55,'J',T65,'K',T75,'L')

* ... write to array first to avoid line wraps due to blanks at end
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0) 

* ... if there is modifying title info give it to
	      IF ( ds_var_titl_mod(ivar) .NE. ' '  ) CALL SPLIT_LIST
     .	(pttmode_explct, lun, '       ('//
     .	ds_var_titl_mod(ivar)(:TM_LENSTR1(ds_var_titl_mod(ivar)))
     .	//')', 0) 

* "FULL" output, only below
	   IF ( full ) THEN
	      grid = ds_grid_number(ivar)

* ... data type if interesting
	      IF (ds_var_type(ivar) .EQ. ptype_string ) THEN
	        CALL SPLIT_LIST(pttmode_explct, lun,
     .		'            '//'Data type = TEXT', 28)
	      ELSEIF (its_delimited                   ) THEN
	        CALL SPLIT_LIST(pttmode_explct, lun,
     .		'            '//'Data type = NUMERIC', 31)
	      ENDIF

* ... field type conversion
	      IF (its_delimited) THEN
	        CALL SPLIT_LIST(pttmode_explct, lun,
     .		'            '//'Conversion /TYPE='//
     .			     ftyp_name(field_types(kvar)), 0)
	      ENDIF

* ... "<units> on grid <name> with 1E35 & -999 for missing data"
	      dlen = TM_LENSTR1( ds_var_units(ivar) )
	      line = '             '//ds_var_units(ivar)(:dlen)//
     .		' on grid '//grid_name(grid)
	      dlen = TM_LENSTR1( line )
#ifdef NO_PREPEND_STRING
*             Appending space just to get rid of a nonsense compiler warning
	      risc_buff = line(:dlen)//' '
	      len_rbuff = dlen
	      line = risc_buff(:len_rbuff)//' with '//
#else
	      line = line(:dlen)//' with '//
#endif
     .				TM_FMT(ds_bad_flag(ivar),7,14,dlen)
	      dlen = TM_LENSTR1( line )
	      IF ( ds_bad_flag(ivar) .NE. ds_missing_flag(ivar) ) THEN
#ifdef NO_PREPEND_STRING
*             Appending space just to get rid of a nonsense compiler warning
	      risc_buff = line(:dlen)//' '
	      len_rbuff = dlen
	      line = risc_buff(:len_rbuff)//' & '//
#else
	         line = line(:dlen)//' & '//
#endif
     .				TM_FMT(ds_missing_flag(ivar),7,14,dlen)
	         dlen = TM_LENSTR1( line )
	      ENDIF
	      line = line(:dlen)//' for missing data'
	      CALL SPLIT_LIST(pttmode_explct, lun, line, 0)
* ... world coordinate limits
	      line = ' '
	      len = 1
	      DO 300 i = 1, listdims
	         IF (its_dsg) CYCLE  ! DSG coords summarized later.
	         IF ( grid_line(i,grid) .NE. mnormal ) THEN

		    IF (i .NE. t_dim) THEN  ! Skip time dim

	               lo = TM_WORLD( ds_grid_start(i,ivar), grid, i, box_lo_lim )
	               hi = TM_WORLD( ds_grid_end  (i,ivar), grid, i, box_hi_lim )

		       ndec = ax_dec_pt(i)

		       ndec = -5  ! 
		       IF (i .EQ. y_dim) ndec = -3
#ifdef NO_PREPEND_STRING
*                      Appending space just to get rid of a nonsense compiler warning
	               risc_buff = line(:len)//' '
 	               len_rbuff = len
		       line = risc_buff(:len_rbuff)// ww_dim_name(i) // '=' //
#else
		       line = line(:len) // ww_dim_name(i) // '=' //
#endif
     .			 LOHI_STRING( lo,hi,i,grid,':',ndec,dlen )
     .			 // '  '
	               len = MIN( 128, len+4+dlen )
	            ENDIF ! Skip time dim

	         ENDIF
 300	      CONTINUE
	      CALL SPLIT_LIST(pttmode_explct, lun,
     .		'            '//line(:len), len+12)
	   ENDIF

 400	CONTINUE

* If the dataset is a DSG dataset, show the x, y, z, t range for the 
* observation variables.

	IF ( full  .AND. grid_dsg) CALL SHOW_DSG_RANGES ( dset, .FALSE., lun )

* describe the time range (uses "grid" from last variable displayed)
	taxis = ds_time_axis(dset)
c	IF ( full  .AND. grid_dsg) taxis = grid_line(t_dim, dsg_xlate_grid(dset))

* ... check among the static grids
        DO 500 grid = 1, max_grids
 500    IF ( grid_line(t_dim,grid) .EQ. taxis ) GOTO 520
* ... check among the dynamic grids
	grid = 0
 510	CALL TM_NEXT_DYN_GRID( grid, *515)
	  IF ( grid_line(t_dim,grid) .EQ. taxis ) GOTO 520
	GOTO 510
 515	grid = 1		!  internal error if we get here !!
 520    IF ((.NOT.grid_dsg) .AND. full .AND. taxis.NE.mnormal
     .		  .AND. taxis.NE.unspecified_int4) THEN    ! bug fix: 3/94
	   len = line_dim( taxis )
	   lo = TM_WORLD( 1,   grid, t_dim, box_middle )
	   hi = TM_WORLD( len, grid, t_dim, box_middle )
	   line = LOHI_STRING( lo,hi,t_dim,grid,' to ',ax_dec_pt(t_dim),dlen )
	   IF (.NOT. grid_dsg) CALL SPLIT_LIST(pttmode_explct, lun, ' ', 1)

* calendar name?  only if not Gregorian.
	   cal_name = TM_GET_CAL (grid)
	   cal_id = TM_GET_CALENDAR_ID (cal_name)
	   IF (cal_id .GT. gregorian .AND. cal_id .LE. max_calendars) THEN
	      len_cal = TM_LENSTR(cal_name)
	      CALL SPLIT_LIST(pttmode_explct, lun,
     .	       '  time range: '//line(:dlen)//
     .	       ' Calendar:'//cal_name(:len_cal), 0) 
	   ELSE
	      CALL SPLIT_LIST(pttmode_explct, lun,
     .			'  time range: '//line(:dlen), 0) 
	   ENDIF
	ENDIF

* show the data-set-specific user-defined variables
* Skip intermediate variables by checking uvar_parent

	first_time = .TRUE.
*	DO 600 i = 1, max_uvar
*	   IF (uvar_num_items(i) .EQ. uvar_deleted  ) GOTO 600
        CALL deleted_list_get_undel(uvar_num_items_head,
     .                              deleted_list_result(1),
     .                              max_uvar, num_indices )
        DO 600 j = 1, num_indices
           i = deleted_list_result(j)
	   IF (uvar_dset(i) .EQ. dset .AND.
     .         uvar_parent(i) .EQ. 0   ) THEN
	      IF ( first_time ) THEN
	         CALL SPLIT_LIST(pttmode_explct, lun,
     .			' ------------------------------', 31) 
	         first_time = .FALSE.
	      ENDIF
	      CALL  SHOW_1_UVAR(lun, i, line, ' ', full)
	   ENDIF
 600	CONTINUE

* end with a blank line
	CALL SPLIT_LIST(pttmode_explct, lun, ' ', 1) 

* show delimiters used for delimited files
	IF (full .AND. its_delimited) THEN
* ... convert delimiter string into readabl;e form
	  line = ' '
	  len = 0
* ... a DO-WHILE loop until the null is encountered
	  i = 0
 700	  i = i + 1
	    c = delims(i:i)
	    IF (c.EQ.CHAR(0)) THEN
	      len = len - 1   ! remove final comma
	      GOTO 710
	    ELSEIF (c.EQ.tab) THEN
	      len = len + 2
#ifdef NO_DOUBLE_ESCAPE_SLASH
              line(len-1:len) = '\'//'t'
#else
              line(len-1:len) = '\\'//'t'
#endif	     
	    ELSEIF (c.EQ.',') THEN
	      len = len + 2
#ifdef NO_DOUBLE_ESCAPE_SLASH
              line(len-1:len) = '\'//','
#else
              line(len-1:len) = '\\'//','
#endif	     
	    ELSEIF ( (c.GE.' ' .AND. c.LE.'~') )THEN
	      len = len + 1
	      line(len:len) = c  ! printable character
	    ELSE
	      len = len + 3
	      WRITE (line(len-2:len),'(I3.3)') ICHAR(c) 
	    ENDIF
	    len = len + 1
	    line(len:len) = ','
	  GOTO 700
 710	  CALL SPLIT_LIST(pttmode_explct, lun,
     .			  ' /DELIMITERS="'//line(:len)//'"', len+15) 
	ENDIF

5000    RETURN
5100	CALL ERRMSG( ferr_invalid_command, status,
     .		     'variable has more than 4 dimensions. Set mode 6D_LAB'
     .		     //pCR//'Output will automatically adjust to 4D or 6D grid'
     .		     //pCR//cmnd_buff(:len_cmnd),
     .			*5000 )
	END

        SUBROUTINE TM_CHECK_FMRC_BNDS_ATTRIB (dset, nT, nF, vname, vlen, 
     .                                   bname, bndid, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*

* CHECK OUT THE VALIDITY OF THE 2D time_bounds VARIABLE NAMED IN NETCDF FILE

* V698+ *sh* patterned closely after TM_CHECK_BNDS_ATTRIB

	INCLUDE 'tmap_dims.parm'
        INCLUDE 'xtm_grid.cmn_text'
        INCLUDE 'xio.cmn_text'
        INCLUDE 'tmap_errors.parm'
        INCLUDE 'errmsg.parm'

* argument declarations

      INTEGER dset, nT, nF, vlen, bndid, status
      CHARACTER*(*) bname, vname

* Local variable declarations
      LOGICAL coordvar
      INTEGER TM_LENSTR1
      INTEGER blen, soft_err, vartype, ivar, npts, 
     .        nvdims, vdims(8), nvatts, all_outflag
      CHARACTER*132 buff, vbuff

* does the bounds variable pointed to really exist ?
        blen = TM_LENSTR1(bname)
        CALL CD_GET_VAR_ID (dset, bname, bndid, status)

        IF (bndid .LE. 0) THEN
           soft_err = 21
           GOTO 6000
        ENDIF

* get the vital statistics of the bounds variable

        CALL CD_GET_VAR_INFO (dset, bndid, bname, vartype, 
     .            nvdims, vdims, nvatts, coordvar, all_outflag, status)

        IF ( nvdims .NE. 3 ) THEN
           soft_err = 22
           GOTO 6000
        ENDIF
         
* check for error conditions: bounds is 2 by nF by nT
        CALL CD_GET_DS_DIMS (dset, vdims(1), buff, npts, status)
        IF (status.NE.ferr_ok) GOTO 5100   ! should never happen
        IF ( npts .NE. 2 ) THEN
           soft_err = 23
           GOTO 6000
        ENDIF

* check for error conditions: 2nd dimension of bounds is nT
        CALL CD_GET_DS_DIMS (dset, vdims(2), buff, npts, status)
        IF (status.NE.ferr_ok) GOTO 5100   ! should never happen
        IF ( npts .NE. nT ) THEN
           soft_err = 23
           GOTO 6000
        ENDIF

* check for error conditions: 3nd dimension of bounds is nF
        CALL CD_GET_DS_DIMS (dset, vdims(3), buff, npts, status)
        IF (status.NE.ferr_ok) GOTO 5100   ! should never happen
        IF ( npts .NE. nF ) THEN
           soft_err = 23
           GOTO 6000
        ENDIF

        status = merr_ok
        RETURN

* error messages

 6000   CALL TM_NOTE( 'netCDF FMRC bounds defn err', lunit_errors )
        buff = bname
        vbuff = vname
        IF ( soft_err .EQ. 21 ) THEN
           CALL TM_NOTE('Bounds definition "'//buff(:blen)//
     .                   '" points to no existing axis', lunit_errors )
        ELSEIF ( soft_err .EQ. 22 ) THEN
           CALL TM_NOTE('Bounds definition "'//buff(:blen)//
     .                   '" is not 3D', lunit_errors )
        ELSEIF ( soft_err .EQ. 23 ) THEN
           CALL TM_NOTE('Bounds "'//buff(:blen)//
     .          '" must be 2 by dimensions of '
     .          //vbuff(:vlen), lunit_errors )
        ENDIF
        CALL TM_NOTE( 'Ignoring BOUNDS attribute', lunit_errors )

        status = merr_ok + 1
        RETURN

 5100   status = pcdferr
        RETURN

        END

	BLOCK DATA XPLOT_STATE_DATA

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* initialization for plotted output state variables

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 6/4/86
* revision 1.0 - 6/28/88 - major re-write for multiple windows
* revision 1.1 - 8/26/88 - added multiple viewports and consolidated window
*			   sizing
* revision 1.2 - 1/24/89 - added ppl_interrupted
* V200: 10/29/89 - "FULL" viewport is just like others.  Default is NONE
* V230:  11/4/92 - 4 corner viewports (ll,lr,ul,ur) with clipping ON
* V301:  22/2/94 - changed wn_scale(1) from 1.0 to 0.7
* V500: 6/99 *sh* - added saved time axis information
* V540: 9/01 *sh* - added vp_by_axis
* V63  *acm* 10/09 Changes for gfortran build
* V54+: *acm*5/08 - added transparent (from xplot_setup)

        IMPLICIT NONE
	include	'ferret.parm'
	include	'xplot_state.cmn'

	INTEGER i

* local parameter declarations:
	INTEGER		mwn_maxm1,
     .			mvp_maxm9
	PARAMETER     ( mwn_maxm1  = max_windows - 1,
     .			mvp_maxm9 = max_viewport - 9 )

	DATA	pplus_started	/ .FALSE. /
	DATA	ppl_interrupted / .FALSE. /

	DATA curr_seg_name / 0 /	! to be incremented for each new sgmt
        
        DATA no_plot_yet/.TRUE./

	DATA	wn_open	  / max_windows * .FALSE. /
	DATA	wn_active / max_windows * .FALSE. /
	DATA	wn_scale  /wn_dflt_scale, mwn_maxm1 * wn_dflt_scale /

* lower left default window positions
*	DATA xlowlef / .20, .004, .20,  .008, .06 , 0.09, .012, 0.10  /
*	DATA ylowlef / .20, .004, .008, .20,  .012, 0.06, .10 , 0.05  /
* *kob* 1/00 add an extra data value because we now have 
*        max 9 windows - not sure if .2 is the correct one to use..
	DATA xlowlef / .20, .004, .20,  .008, .06 , 0.09, .012, 0.10,.20  /
	DATA ylowlef / .20, .004, .008, .20,  .012, 0.06, .10 , 0.05,.20  /

* various pre-programmed viewport choices
	DATA	vp_num / mvp_dflt /

	DATA	vp_name ( mvp_dflt ) / 'NONE' /,	! whole window
     .		vp_size ( mvp_dflt ) / 1.0 /,
     .		vp_xorg ( mvp_dflt ) / 0.0 /,
     .		vp_yorg ( mvp_dflt ) / 0.0 /,
     .		vp_xclip( mvp_dflt ) / unspecified_val4 /,
     .		vp_yclip( mvp_dflt ) / unspecified_val4 /,
     .		vp_by_axis(mvp_dflt) / .FALSE. /

	DATA	vp_name ( 1 ) / 'UPPER' /,	! upper half
     .		vp_size ( 1 ) / 1.0 /,
     .		vp_xorg ( 1 ) / 0.0 /,
     .		vp_yorg ( 1 ) / 0.5 /,
     .		vp_xclip( 1 ) / 1.0 /,
     .		vp_yclip( 1 ) / 1.0 /,
     .		vp_by_axis(1) / .FALSE. /

	DATA	vp_name ( 2 ) / 'LOWER' /,	! lower half
     .		vp_size ( 2 ) / 1.0 /,
     .		vp_xorg ( 2 ) / 0.0 /,
     .		vp_yorg ( 2 ) / 0.0 /,
     .		vp_xclip( 2 ) / 1.0 /,
     .		vp_yclip( 2 ) / 0.5 /,
     .		vp_by_axis(2) / .FALSE. /

	DATA	vp_name ( 3 ) / 'RIGHT' /,	! right half
     .		vp_size ( 3 ) / 1.0 /,
     .		vp_xorg ( 3 ) / 0.5 /,
     .		vp_yorg ( 3 ) / 0.0 /,
     .		vp_xclip( 3 ) / 1.0 /,
     .		vp_yclip( 3 ) / 1.0 /,
     .		vp_by_axis(3) / .FALSE. /

	DATA	vp_name ( 4 ) / 'LEFT' /,	! left half
     .		vp_size ( 4 ) / 1.0 /,
     .		vp_xorg ( 4 ) / 0.0 /,
     .		vp_yorg ( 4 ) / 0.0 /,
     .		vp_xclip( 4 ) / 0.5 /,
     .		vp_yclip( 4 ) / 1.0 /,
     .		vp_by_axis(4) / .FALSE. /

	DATA	vp_name ( 5 ) / 'LL' /,	! Lower Left
     .		vp_size ( 5 ) / 0.5 /,
     .		vp_xorg ( 5 ) / 0.0 /,
     .		vp_yorg ( 5 ) / 0.0 /,
     .		vp_xclip( 5 ) / 0.5 /,
     .		vp_yclip( 5 ) / 0.5 /,
     .		vp_by_axis(5) / .FALSE. /

	DATA	vp_name ( 6 ) / 'LR' /,	! Lower Right
     .		vp_size ( 6 ) / 0.5 /,
     .		vp_xorg ( 6 ) / 0.5 /,
     .		vp_yorg ( 6 ) / 0.0 /,
     .		vp_xclip( 6 ) / 1.0 /,
     .		vp_yclip( 6 ) / 0.5 /,
     .		vp_by_axis(6) / .FALSE. /

	DATA	vp_name ( 7 ) / 'UL' /,	! Upper Left
     .		vp_size ( 7 ) / 0.5 /,
     .		vp_xorg ( 7 ) / 0.0 /,
     .		vp_yorg ( 7 ) / 0.5 /,
     .		vp_xclip( 7 ) / 0.5 /,
     .		vp_yclip( 7 ) / 1.0 /,
     .		vp_by_axis(7) / .FALSE. /

	DATA	vp_name ( 8 ) / 'UR' /,	! Upper Right
     .		vp_size ( 8 ) / 0.5 /,
     .		vp_xorg ( 8 ) / 0.5 /,
     .		vp_yorg ( 8 ) / 0.5 /,
     .		vp_xclip( 8 ) / 1.0 /,
     .		vp_yclip( 8 ) / 1.0 /,
     .		vp_by_axis(8) / .FALSE. /

	DATA	vp_name ( 9 ) / 'FULL' /,	! FULL window
     .		vp_size ( 9 ) / 1.0 /,
     .		vp_xorg ( 9 ) / 0.0 /,
     .		vp_yorg ( 9 ) / 0.0 /,
     .		vp_xclip( 9 ) / 1.0 /,
     .		vp_yclip( 9 ) / 1.0 /,
     .		vp_by_axis(9) / .FALSE. /

	DATA	(vp_name(i),i=10,max_viewport) /mvp_maxm9*unspecified_name4/

	DATA has_time_axis/.FALSE./

	DATA transparent	/ 0 /

	END

      subroutine arfill(z,x,y,nx,ny)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*	
*     The variable nlev2 is passed here as nlev *jd*
*
C** 
C**    @(#)arfill.F	1.6    2/6/91
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C     lots of places ---> PPLMOD_PPLCMD ---> PPLMOD_PLTIT 
C              ---> PPLMOD_PLOTZ ---> PPLMOD_ARFILL
C
C     This subroutine ...
C
C     z      - actual 2-D array of data values to be contoured
C     x      - array of grid points along the X axis
C     y      - array of grid points along the Y axis
C     nx     - number of X grid points
C     ny     - number of Y grid points
C
C
*	MODS JD 1.13.92 To fit into TMAP PPL+
*	Mod  *jd* 10.26.93 eliminate private item for meta_shade_set in xgks
*			 - not replaced with appropriate code yet
* 	Mod *jd * 1.30.96  Fix bug in fill --- missing value flag is 
*				unrecognized.
C     V4.50 *jc* 5.97 Major cleanup and commenting
C     V4.50 *jc* 5.97 Add curvilinear coordinates code
C     v5.00 *jd* 2.99 Add fill optimization 
*     V5.81 ACM 3/05  Other routines (drawpoly, buffer_fillpoly, flush_buffered_fillpoly)
*                     removed to their own files.
*     v5.81 *acm* 4/05 Changes for FILL/MOD. Draw replications for curvilinear datasets
C V602 *acm* 2/07 check status coming out of CURV_COORD_RANGE; part of fix to bug 1485
* v68  *acm* 4/08 Allow shade, vector plots of degenerate regions - world region 
*              within a grid cell

	include 	'ARFILL.INC'
        include         'GKSCM1.INC'
        include         'gkscm2.cmn'
        include         'miss_inc.decl'
        include         'MISS.INC'
        include         'xcurvilinear.cmn'
        include         'xinterrupt.cmn' ! 1/89 *sh*
        include         'ppl_in_ferret.cmn'
        include         'shade_vars.cmn'
	include		'parampl5_dat.decl'
	include		'PARAMPL5.DAT'
	include		'cont_inc.decl'
	include		'CONT.INC'
        INCLUDE         'errmsg.parm'

        integer nx,ny
        real z(nx,ny),x(nx),y(ny)

        real x_extra,y_extra
        integer i,nnx,nny, ilo, ihi, jlo, jhi, status
	real xadd,xinv,yinv,w(4),v(4),ndc(4),uc(4)

        real lmin, lmax

C     *jd* mod to allow filling single level fields
        if (nlev .le. 1) return

	shd_levels = nlev - 1
	shd_levels = MAX(nlev2-1,1) ! this is how it is in SHADE.F

C     DETERMINE PATTERNS OR COLORS TO SET BUNDLED FILL AREA REPRESENTATIONS
        call set_fill_area_rep(wsid,wstype)

C     WRITE OUT SHD_LEVELS & SHADE SETTINGS TO METAFILE (4.91)
#ifndef xgks
        if (meta_actv) call meta_shade_set
#endif

C     The FILL command does not deal with curvilinear modulo axes properly.
C     The problem is seen in polar projections where the longitude 0E and
C     longitude 360E are not connected: a small pie wedge is left blank.
C
C     To remedy this, we should test for modulo_curvilinear axes and
C     replicate the appropriate row/column in the z array before 
C     breaking the data up into small triangles (or squares) which
C     are then fed to drawpoly().
C
C     If an axis is modulo_curvi we will increase nnx(nny) by one and
C     create an extra point for the end of that axis
C     This code works properly for regularly gridded axes.  For irregular
C     axes it is as good a guess as any.

C acm 4/05 When plotting curvilinear data with FILL/MODULO put this logic into effect

        IF (xmodulo) dim1_modulo = .TRUE.
        if (curvilinear .and. dim1_modulo) then
           x_extra = x(nx) + (x(nx)-x(nx-1))
           nnx = nx+1
        else
           nnx = nx
        endif
 
        if (curvilinear .and. dim2_modulo) then
           y_extra = y(ny) + (y(ny)-y(ny-1))
           nny = ny+1
        else
           nny = ny
        endif

* Get range of indices for the curvi X,Y coordinates actually needed for the 
* hlimits, vlimits that were requested.


*	GET PROPER SCALING, NDC COORDINATES, ETC FOR FILL
	CALL gqcntn (error,trans_no)
	IF (error .NE. 0) GOTO 1000

	CALL gqnt (trans_no,error,w,v)
	IF (error .NE. 0) GOTO 1000

	CALL get_user_coords (w,v,ndc,uc,xinv,yinv)

        IF (curvilinear) THEN
           CALL CURV_COORD_RANGE (uc, ilo, ihi, jlo, jhi, status )
           IF (status .NE. ferr_ok) GOTO 1000
        ENDIF
      
        big = ABS(badx)
        lmin = big
        lmax = -1*big
        xadd = 0.

       CALL ARFILL_SECTION(x, y, z, zlev, nx, ny, nlev, nnx, nny, 
     .       x_extra, y_extra, lmin, lmax, ilo, ihi, jlo, jhi, xadd, 
     .       status)

       if (status .eq. ferr_interrupt) go to 1000

        IF (xmodulo .AND. curvilinear) THEN
           xrange = 360
           IF (.NOT. units_degrees) xrange = wwxmax - wwxmin
           nleft = 0
           nright = 0
           IF (lmin .GT. uc(1) ) nleft =  1 + INT(lmin - uc(1) )/ xrange
           IF (lmax .LT. uc(2) ) nright = 1 + INT(uc(2) - lmax )/ xrange
           nleft = MAX(nleft,1)
           nright = MAX(nright,1)

           IF (nleft .GT. 0) THEN
              xadd = 0.
              DO 100 i = 1, nleft
                 xadd = xadd - xrange
                 CALL ARFILL_SECTION(x, y, z, zlev, nx, ny, nlev, 
     .               nnx, nny, x_extra, y_extra, lmin, lmax, ilo, 
     .               ihi, jlo, jhi, xadd, status)
                 IF (status .EQ. ferr_interrupt) GOTO 1000
 100          CONTINUE
           ENDIF

           IF (nright .GT. 0) THEN
              xadd = 0.
              DO 110 i = 1, nright
                 xadd = xadd + xrange
                 CALL ARFILL_SECTION(x, y, z, zlev, nx, ny, nlev, 
     .               nnx, nny, x_extra, y_extra, lmin, lmax, ilo, 
     .               ihi, jlo, jhi, xadd, status)
                 IF (status .EQ. ferr_interrupt) GOTO 1000
 110          CONTINUE
           ENDIF
         
        ENDIF   ! xmodulo
C     
C     Generate a color/gray scale key.
C     Restore standard key style afterward (do this here, to 
C     catch both contour and contour/set calls).
C     
        if (do_key .AND. .NOT.interrupted .AND. status .EQ. ferr_ok) THEN
            call key ! 1/89 - *sh*
           CALL SHADE_KEY_CONT (0)
        ENDIF

1000    return
        end

	SUBROUTINE TM_PACK_STRING(in_string,out_string,start,end,len_out)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* remove blanks and tabs from the designated portion of the string

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Thermal Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.00 - 03/04/87
* 2/03 *kob* - g77 port - g77 won't allow intrinsic functions in PARAMETER
*                         statements.  use an character constant instead

*
* calling argument declarations:
	INTEGER		start, end, len_out
	CHARACTER*(*)	in_string, out_string

* internal parameter declarations:
	CHARACTER*1	tab
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
#else
	PARAMETER     ( tab = CHAR(9))
#endif

* internal variable declarations:
	INTEGER	i_in, i_out, str_len, str_end

* true string length
	str_len = MIN( LEN(in_string), LEN(out_string) )
	str_end = MIN( str_len, end )

* transfer all characters until "start" to output string
	DO 10 i_in = 1, start
 10	out_string( i_in:i_in ) = in_string( i_in:i_in )

* pack the indicated region
	i_out = start

	DO 100 i_in = start, str_end
* ... skip hole ?
	   IF ( in_string( i_in:i_in ) .EQ. ' '
     .	   .OR. in_string( i_in:i_in ) .EQ. tab ) GOTO 100

* ... transfer character to output
	   out_string( i_out:i_out ) = in_string( i_in:i_in )
	   i_out = i_out + 1
 100	CONTINUE
	   
* transfer the remainder to the output
	DO 200 i_in = str_end+1, str_len
	   out_string( i_out:i_out ) = in_string( i_in:i_in )
	   i_out = i_out + 1
 200	CONTINUE

* length of packed output string
	len_out = i_out - 1

* blank out old shifted characters at right hand end
	DO 300 i_out = i_out, str_len
 300	out_string(i_out:i_out) = ' '

	RETURN
	END

	SUBROUTINE OV_GRP_CX_DOC( ov_cx, ncx, flags )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* merge additional variable contexts with those already merged into the
* joint context for a plot to produce a list of documentation flags suitable
* to make a key for this new context.  See GRP_CX_DOC

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V200:	  2/2/90
* V230:  7/22/92 - added overlay argument to ADDL_CX_DOC
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V685+ *acm* 12/13 For 6D Ferret, the array coming in as flags is longer for extra dimensions

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'xcontext.cmn'
	include	'xplot_setup.cmn'

* calling argument declarations
	INTEGER ncx, ov_cx(ncx)
	LOGICAL	flags(0:12)

* internal variable declarations
	INTEGER	i

* internal parameter declarations:
        LOGICAL overlay
        PARAMETER ( overlay = .TRUE. )
           
* make a fresh copy of cx_plot and key_doc to keep current with the plot labels
	CALL TRANSFER_CONTEXT( cx_plot, cx_buff )
	DO 100 i = 0, 10
 100	flags(i) = key_doc(i)

* merge the additional contexts
	DO 200 i = 1, ncx
 200	CALL ADDL_CX_DOC( cx_buff, ov_cx(i), overlay, flags )

	RETURN
	END

	LOGICAL FUNCTION NO_GRID_RANGE( grid, n, mg, val1 )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine if all the data indicated are of the same value

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/2/88
* V200:  5/19/89 - 4D symmetrical
* V68    4/11  Allow shade, vector plots of degenerate regions - world region 
*              within a grid cell
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'

* calling argument declarations:
	INTEGER	n, mg
	REAL 	val1, grid( n )

* internal variable declarations:
	INTEGER	i
	REAL	bad_flag

* initialize
	bad_flag = mr_bad_data( mg )

* comparison value (ends up as first non-bad value)
	val1 = bad_flag

* check all data within the indicated context
	DO 100 i = 1, n
	   IF ( grid(i) .NE. val1 ) THEN
	      IF     ( val1       .EQ. bad_flag ) THEN
	         val1 = grid(i)
	      ELSEIF ( grid(i) .NE. bad_flag .OR. n.EQ.1 ) THEN
	         NO_GRID_RANGE = .FALSE.
	         RETURN
	      ENDIF
	   ENDIF
 100	CONTINUE

* they were all identical - val1=bad_flag if they were all bad
	NO_GRID_RANGE = .TRUE.
	RETURN
	END

	SUBROUTINE FLAG2DDUPS( n, x, y, epsx, epsy, dup, seq )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* Locate the duplicate coordinate pairs in a list of coordinates
* Will be regarded as duplicate if X lies within espx distance and ditto y
* The array "dup" will contain the number of duplicate "mates" for any
*   given coordinate (i.e. 0 if no matches)
* The array "seq' will contain the sequence number 0,1,2,... of the mates 

* V530 *sh* 2/01

* Argument declarations
	INTEGER	n
	REAL	epsx, epsy, x(n), y(n), dup(n), seq(n)

* Internal variable declarations
        INTEGER ii, jj, ndup
        REAL xtarget, ytarget

* initialize
        DO ii = 1, n
          dup(ii) = 0
          seq(ii) = 0
        END DO

* find and label duplicates
        DO ii = 1, n
           
* locate a unique coordinate
           IF (dup(ii) .EQ. 0 ) THEN
             xtarget = x(ii)
             ytarget = y(ii)

* mark sequence numbers for duplicates of this target
             ndup = 0
             DO jj = ii+1, n
               IF (dup(jj) .EQ. 0 ) THEN
                  IF ( (ABS(xtarget-x(jj)) .LE. epsx)
     .           .AND. (ABS(ytarget-y(jj)) .LE. epsy) ) THEN
                    ndup = ndup + 1
                    seq(jj) = ndup
                  ENDIF
               ENDIF
             END DO

* mark number of duplicates found on each member of duplicate group
             dup(ii) = ndup
             IF (ndup .GT. 0) THEN
               DO jj = ii+1, n
                 IF ( (dup(jj).EQ.0)
     .          .AND. (seq(jj).GT.0) ) dup(jj) = ndup 
               END DO
             ENDIF

           ENDIF
        END DO

	RETURN
	END

      SUBROUTINE CD_ADD_VAR (dset, varname, varid, title, units, 
     .                       type, coordvar, bad, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Add a variable to the linked list structure.  dset = -1 (pdset_uvars
* in ferret.parm) will be the pseudo-dset containing attribute info for 
* user variables.

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP
*
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V698 *sh* 1/16 -- added status check/warning, since not checked by callers
*
* include files

      INCLUDE "tmap_dtypes.parm"
      INCLUDE "netcdf.inc"
      INCLUDE 'tmap_errors.parm'

* Argument declarations
      LOGICAL coordvar

      CHARACTER*(*) varname, title, units
      INTEGER dset, varid, type, status
      REAL bad

* Internal declarations

      INTEGER TM_LENSTR1, TM_LENSTR, NCF_ADD_VAR, slen, flen, dset_num
      REAL*8 badd
      CHARACTER*2048 buff

      PARAMETER (flen=2048)
#ifdef sun
      BYTE      vhol(flen)      ! c-type Hollerith string buffer
      BYTE      thol(flen)
      BYTE      uhol(flen)
#else
      INTEGER*1 vhol(flen)      ! c-type Hollerith string buffer
      INTEGER*1 thol(flen)
      INTEGER*1 uhol(flen)
#endif 

* translate strings for C routine

      buff = varname
      slen = TM_LENSTR1( buff )
      CALL TM_FTOC_STRNG( buff(1:slen), vhol, flen )

      buff = title
      slen = TM_LENSTR1( buff )
      CALL TM_FTOC_STRNG( buff(1:slen), thol, flen )

      buff = units
      slen = TM_LENSTR( buff )
      CALL TM_FTOC_STRNG( buff(1:slen), uhol, flen )

* attribute structure has missing data flag as double precision

      badd = bad

      dset_num = dset
      status = NCF_ADD_VAR( dset_num, varid, type, coordvar,
     .                      vhol, thol, uhol, badd)

      IF (status .NE. pcd_ferr_ok) CALL WARN('ERROR in CD_ADD_VAR')

      RETURN
      END

*
*  tracks2grid_mask_ave_xyt.F
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* June 2009  from scatgrid_nobs_xyt
*
* 9/ 3/2015 Fix LAS/SOCAT ticket 1720, missingness patterns in cruise-weighted 
*           vs unweighted gridded fields.
* 1/27/2016 Apply modulo operation to scattered longitudes or time if the output
*           axis is a modulo axis.
*
* The input data points are not a simple scatter.  They are cruise tracks 
* strung one after another .  (Each track will be a contiguous block of points 
* in the input data arrays. )  And the subtlety is that each cruise needs to 
* receive the same weight when determining the average for a cell, rather than 
* each individual data point.  Which means effectively that you need to have 
* two averaging processes .  You need to have a buffer (the individual cruise 
* buffer) that is the size and shape of the output grid in which you average 
* each individual cruise.  And then when the final point of each cruise from 
* the input data is encountered, you need to add (average) the points from the 
* individual cruise buffer into the output buffer, re-zeroing the individual 
* cruise buffer as you do so, so it is ready to average the next cruise. 
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE  tracks2grid_mask_ave_xyt_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CHARACTER*126 buff
      WRITE (buff, 10)
   10 FORMAT ('Average by cruise, when gridding scattered ',
     .        'data to XYT grid where output grid is masked.')
      CALL ef_set_desc(id, buff)

      CALL ef_set_num_args(id, 9)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS,
     .        IMPLIED_BY_ARGS, NORMAL, IMPLIED_BY_ARGS)

      CALL ef_set_num_work_arrays(id, 8)

* Output grid is determined by arguments 4, 5, 6, the result's x, y, t axes. 

      arg = 1
      CALL ef_set_arg_name(id, arg, 'VAR')
      CALL ef_set_arg_desc(id, arg, 
     .     'Variable at scattered input XYT. Enter a scalar to just count Obs.')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'XPTS')
      CALL ef_set_arg_desc(id, arg, 
     .     'X coordinates of scattered input triples')

      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'YPTS')
      CALL ef_set_arg_desc(id, arg, 
     .     'Y coordinates of scattered input triples')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'TPTS')
      CALL ef_set_arg_desc(id, arg, 
     .     'T coordinates of scattered input triples')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'ICRUISE')
      CALL ef_set_arg_desc(id, arg, 
     .     'Cruise ID at scattered input locations')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 6
      CALL ef_set_arg_name(id, arg, 'XAXPTS')
      CALL ef_set_arg_desc(id, arg, 
     . 'X axis coordinates of the output grid, with same units as xpts')
      CALL ef_set_axis_influence(id, arg, YES, NO, NO, NO)

      arg = 7
      CALL ef_set_arg_name(id, arg, 'YAXPTS')
      CALL ef_set_arg_desc(id, arg, 
     . 'Y axis coordinates of the output grid, with same units as ypts')
      CALL ef_set_axis_influence(id, arg, NO, YES, NO, NO)

      arg = 8
      CALL ef_set_arg_name(id, arg, 'TAXPTS')
      WRITE (buff, 20)
   20 FORMAT ('T axis coordinates, of the output grid, with same ',
     .       'units and origin as tpts')
      CALL ef_set_arg_desc(id, arg, buff)
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, YES)

      arg = 9
      CALL ef_set_arg_name(id, arg, 'MASK')
      CALL ef_set_arg_desc(id, arg,  
     .                   'XY mask on the output grid 1=valid, 0=ignore')
      CALL ef_set_axis_influence(id, arg, YES, YES, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN 
      END
*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE tracks2grid_mask_ave_xyt_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
* 
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_dims(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER nxout, nyout, ntout, nx2, ny2, nt2
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nxout = 1 + arg_hi_ss(X_AXIS,ARG6) - arg_lo_ss(X_AXIS,ARG6)
      nyout = 1 + arg_hi_ss(Y_AXIS,ARG7) - arg_lo_ss(Y_AXIS,ARG7)
      ntout = 1 + arg_hi_ss(T_AXIS,ARG8) - arg_lo_ss(T_AXIS,ARG8)

* xaxlo  output x axis
      CALL ef_set_work_array_dims (id, 1, 1, 1, 1, 1, nxout, 1, 1, 1)
* xaxhi  output x axis
      CALL ef_set_work_array_dims (id, 2, 1, 1, 1, 1, nxout, 1, 1, 1)

* yaxlo  output y axis
      CALL ef_set_work_array_dims (id, 3, 1, 1, 1, 1, nyout, 1, 1, 1)
* yaxhi  output y axis
      CALL ef_set_work_array_dims (id, 4, 1, 1, 1, 1, nyout, 1, 1, 1)

* taxlo  output t axis
      CALL ef_set_work_array_dims (id, 5, 1, 1, 1, 1, ntout, 1, 1, 1)
* taxhi  output t axis
      CALL ef_set_work_array_dims (id, 6, 1, 1, 1, 1, ntout, 1, 1, 1)

* obs_cruise  work array - sum and counts of observations per cruise
* x,y,t direction: output grid
* z direction: 1..2
      CALL ef_set_work_array_dims (id, 7, 1, 1, 1, 1, 
     .                             nxout, nyout, 2, ntout)

* obs  work array - work array - sum and counts of observations
* x,y,t direction: output grid
* z direction: 1..2
      CALL ef_set_work_array_dims (id, 8, 1, 1, 1, 1, 
     .                             nxout, nyout, 2, ntout)

      RETURN
      END


*
* In this subroutine we compute the result
*

      SUBROUTINE tracks2grid_mask_ave_xyt_compute(id, arg_1, arg_2, arg_3, 
     .     arg_4, arg_5, arg_6, arg_7, arg_8, arg_9, result, 
     .     xaxlo, xaxhi, yaxlo, yaxhi, taxlo, taxhi, obs_cruise, obs)

*  arg_1  var
*  arg_2  xpts  \
*  arg_3  ypts   | Scattered x,y triples to be gridded.
*  arg_4  tpts  / 
*  arg_5  icruise
*
*  arg_6  xaxis of new grid   
*  arg_7  yaxis of new grid
*  arg_8  taxis of new grid
*  arg_9  xy mask for output grid

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .     mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, 
     .     mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, 
     .     mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, 
     .     mem4loz:mem4hiz, mem4lot:mem4hit)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, 
     .     mem5loz:mem5hiz, mem5lot:mem5hit)
      REAL arg_6(mem6lox:mem6hix, mem6loy:mem6hiy, 
     .     mem6loz:mem6hiz, mem6lot:mem6hit)
      REAL arg_7(mem7lox:mem7hix, mem7loy:mem7hiy, 
     .     mem7loz:mem7hiz, mem7lot:mem7hit)
      REAL arg_8(mem8lox:mem8hix, mem8loy:mem8hiy, 
     .     mem8loz:mem8hiz, mem8lot:mem8hit)
      REAL arg_9(mem9lox:mem9hix, mem9loy:mem9hiy, 
     .     mem9loz:mem9hiz, mem9lot:mem9hit)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      INTEGER i, j, k, l, m, n
      INTEGER i1, i2, j1, k1, l1, k2
      INTEGER i6,j7,L8,i6n,j7n,L8n

      INTEGER nxpts, npts
      INTEGER nx, ny, nt
      INTEGER i1n, i2n
      INTEGER obs_only

      REAL x1, y1, t1, icruise, ncruise, xf, yf, tf
      REAL xx, yy, tt, vv

*  variables for checking axis characteristics (modulo axes)
      CHARACTER ax_name(6)*16, ax_units(6)*16
      LOGICAL backward(6), mdulo(6), regular(6)
      LOGICAL modulox, modulot
      REAL*8 modxlen, modtlen

*  Dimension the work arrays

      REAL*8 xaxlo(wrk1lox:wrk1hix)
      REAL*8 xaxhi(wrk2lox:wrk2hix)
      REAL*8 yaxlo(wrk3lox:wrk3hix)
      REAL*8 yaxhi(wrk4lox:wrk4hix)
      REAL*8 taxlo(wrk5lox:wrk5hix)
      REAL*8 taxhi(wrk6lox:wrk6hix)

      REAL obs_cruise(wrk7lox:wrk7hix, wrk7loy:wrk7hiy,
     .               wrk7loz:wrk7hiz, wrk7lot:wrk7hit)
      REAL obs(wrk8lox:wrk8hix, wrk8loy:wrk8hiy,
     .               wrk8loz:wrk8hiz, wrk8lot:wrk8hit)

      CHARACTER*250 errtxt

      REAL*8 dx, dy, dt, xxbeg, xxend, yybeg, yyend
      REAL*8 xax1,xaxf, yax1,yaxf, tax1,taxf
      INTEGER indx(4,2)

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)


*  Check to see if the output X-axis is modulo (does not need to be regular)
      CALL ef_get_axis_info_6d(id, ARG6, ax_name, ax_units,
     .                         backward, mdulo, regular)
      modulox = mdulo(X_AXIS)
      IF ( modulox ) THEN
         CALL ef_get_axis_modulo_len(id, ARG6, X_AXIS, modxlen)
      ENDIF

*  Check to see if the output T-axis is modulo (does not need to be regular)
      CALL ef_get_axis_info_6d(id, ARG6, ax_name, ax_units,
     .                         backward, mdulo, regular)
      modulot = mdulo(T_AXIS)
      IF ( modulot ) THEN
         CALL ef_get_axis_modulo_len(id, ARG8, T_AXIS, modtlen)
      ENDIF

      obs_only = 0	! 0 = var 1 is a variable to average.
                        ! 1 = Compute a count of cruises with an obs in the grid cells

*  Find number of points in scattered input points.  1-D arrays defining the 
*  scattered data points may lie on the X, Y, Z, or T axis of the input arguments.

      nxpts = 0

      DO 100 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG2) .GE. 1) THEN
            i1 = arg_lo_ss(m,ARG2)
            i1n = arg_hi_ss(m,ARG2)
            if (i1n-i1 .NE. 0) nxpts = 1 + (i1n - i1)
            IF (nxpts .EQ. 0) GOTO 900
         ENDIF
 100  CONTINUE

      npts = 1
      DO 110 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG1) .GE. 1) THEN
            i2 = arg_lo_ss(m,ARG1)
            i2n = arg_hi_ss(m,ARG1)
            npts = 1 + (i2n - i2)
            IF ((npts.NE.1) .AND. (npts.NE.nxpts)) GOTO 900
         ENDIF
 110  CONTINUE
      IF (npts .EQ. 1) obs_only = 1  ! just count up the obs

      DO 120 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG3) .GE. 1) THEN
            i2 = arg_lo_ss(m,ARG3)
            i2n = arg_hi_ss(m,ARG3)
            npts = 1 + (i2n - i2)
            IF (npts .NE. nxpts) GOTO 900
         ENDIF
 120  CONTINUE

      DO 130 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG4) .GE. 1) THEN
            i2 = arg_lo_ss(m,ARG4)
            i2n = arg_hi_ss(m,ARG4)
            npts = 1 + (i2n - i2)
            IF (npts .NE. nxpts) GOTO 900
         ENDIF
 130  CONTINUE

      DO 140 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG5) .GE. 1) THEN
            i2 = arg_lo_ss(m,ARG5)
            i2n = arg_hi_ss(m,ARG5)
            npts = 1 + (i2n - i2)
            IF (npts .NE. nxpts) GOTO 900
         ENDIF
 140  CONTINUE

      nscat = nxpts

*  Compute number of points in output axes.

      i6 = ef_unspecified_int4
      j7 = ef_unspecified_int4
      L8 = ef_unspecified_int4

      i6 = arg_lo_ss(X_AXIS,ARG6)
      i6n = arg_hi_ss(X_AXIS,ARG6)

      j7 = arg_lo_ss(Y_AXIS,ARG7)
      j7n = arg_hi_ss(Y_AXIS,ARG7)

      L8 = arg_lo_ss(T_AXIS,ARG8)
      L8n = arg_hi_ss(T_AXIS,ARG8)

      nx = 1 + (i6n - i6)
      ny = 1 + (j7n - j7)
      nt = 1 + (L8n - L8)

*  Check that xax is a X axis and yax a Y axis

      IF (i6 .EQ. ef_unspecified_int4) THEN
         WRITE (errtxt, *) 'Sixth argument must be a X axis'
         GO TO 999
      ENDIF
      IF (j7 .EQ. ef_unspecified_int4) THEN
         WRITE (errtxt, *) 'Seventh argument must be a Y axis'
         GO TO 999
      ENDIF
      IF (L8 .EQ. ef_unspecified_int4) THEN
         WRITE (errtxt, *) 'Eighth argument must be a T axis'
         GO TO 999
      ENDIF

C  Get coordinates of output axes.

      CALL EF_GET_BOX_LIMITS(id, ARG6, X_AXIS,
     .   arg_lo_ss(X_AXIS, ARG6), arg_hi_ss(X_AXIS, ARG6), xaxlo, xaxhi)

      CALL EF_GET_BOX_LIMITS(id, ARG7, Y_AXIS,
     .   arg_lo_ss(Y_AXIS, ARG7), arg_hi_ss(Y_AXIS, ARG7), yaxlo, yaxhi)

      CALL EF_GET_BOX_LIMITS(id, ARG8, T_AXIS,
     .   arg_lo_ss(T_AXIS, ARG8), arg_hi_ss(T_AXIS, ARG8), taxlo, taxhi)

*  Get first coordinates of output axes.

      call ef_get_coordinates(id, ARG6, X_AXIS, 
     .   arg_lo_ss(X_AXIS, ARG6), arg_lo_ss(X_AXIS, ARG6), xax1)
      call ef_get_coordinates(id, ARG7, X_AXIS, 
     .   arg_lo_ss(Y_AXIS, ARG7), arg_lo_ss(Y_AXIS, ARG7), yax1)
      x1 = xax1
      y1 = yax1

*  Compute result

*  Initialize counts.

      k2 = 2
      IF (obs_only .EQ. 1) k2 = 1

      DO L = 1, nt
      DO k = 1, k2
      DO j = 1, ny
      DO i = 1, nx
         obs(i,j,k,L) = 0.
      ENDDO
      ENDDO
      ENDDO
      ENDDO

      DO L = 1, nt
      DO k = 1, k2
      DO j = 1, ny
      DO i = 1, nx
         obs_cruise(i,j,k,L) = 0.
      ENDDO
      ENDDO
      ENDDO
      ENDDO

*  Loop over x and y, compute the number of observations for the gaussian-weighted 
*  mapping onto the grid.  Lat and longitude may be on the X,Y,Z or T axis of ARG1 
*  and ARG2, sending them to a subroutine collapses the extra dimensions so the
*  value can be found.

      n = 1
      CALL pickoutxytcv (obs_only, arg_1, arg_2, arg_3, arg_4, arg_5,
     .           n, vv, xx, yy, tt, ncc)
      icruise = ncc

*  If output axis is modulo, apply modulo adjustment to that coordinate
*  of the scattered point.
         IF ( modulox ) THEN
            CALL modscat(xaxlo(1), xaxhi(nx), modxlen, 1, xx)
         ENDIF
         IF ( modulot ) THEN
            CALL modscat(taxlo(1), taxhi(nt), modtlen, 1, tt)
         ENDIF


* For each cruise keep track of the index range it spans in the result grid
* Then at the end of the cruise need only to process that subset of the grid.
      indx(1,1) = nx
      indx(1,2) = 1
      indx(2,1) = ny
      indx(2,2) = 1
      indx(4,1) = nt
      indx(4,2) = 1
      
      DO 300 n = 1, nscat

         CALL pickoutxytcv (obs_only, arg_1, arg_2, arg_3, arg_4, arg_5,
     .           n, vv, xx, yy, tt, ncc)
         IF (vv .EQ. bad_flag(ARG1) .OR. xx .EQ. bad_flag(ARG2) .OR. 
     .          yy .EQ. bad_flag(ARG3) .OR. tt .EQ. bad_flag(ARG4) ) GOTO 300
     


*  If output axis is modulo, apply modulo adjustment to that coordinate
*  of the scattered point.
         IF ( modulox ) THEN
            CALL modscat(xaxlo(1), xaxhi(nx), modxlen, 1, xx)
         ENDIF
         IF ( modulot ) THEN
            CALL modscat(taxlo(1), taxhi(nt), modtlen, 1, tt)
         ENDIF


	 if (xx.LT.xaxlo(1) .OR. xx.GT.xaxhi(nx)) GOTO 300
	 if (yy.LT.yaxlo(1) .OR. yy.GT.yaxhi(ny)) GOTO 300
	 if (tt.LT.taxlo(1) .OR. tt.GT.taxhi(nt)) GOTO 300

         IF (ncc .NE. icruise) THEN
	    
            DO L = indx(4,1), indx(4,2)
            DO j = indx(2,1), indx(2,2)
            DO i = indx(1,1), indx(1,2)
	       IF (obs_only .EQ. 0) THEN
                  IF (obs_cruise(i,j,2,L) .GT. 0.) THEN
                     obs(i,j,1,L) = obs(i,j,1,L) + 
     .                 obs_cruise(i,j,1,L)/obs_cruise(i,j,2,L)
                     obs(i,j,2,L) = obs(i,j,2,L) + 1.
		  ENDIF
                  obs_cruise(i,j,1,L) = 0.
                  obs_cruise(i,j,2,L) = 0.
               ELSE
                  IF (obs_cruise(i,j,1,L) .GT. 0.) THEN
                     obs(i,j,1,L) = obs(i,j,1,L) + 1.
                  ENDIF
                  obs_cruise(i,j,1,L) = 0.
               ENDIF
            ENDDO
            ENDDO
            ENDDO

	    icruise = ncc

* reset indices
            indx(1,1) = nx
            indx(1,2) = 1
            indx(2,1) = ny
            indx(2,2) = 1
            indx(4,1) = nt
            indx(4,2) = 1
	    
	 ENDIF

         CALL nobsxytv (obs_only, xx, yy, tt, vv, nx, ny, nt, 
     .           xaxlo,xaxhi, yaxlo,yaxhi, taxlo,taxhi, indx, obs_cruise)

 300     CONTINUE

* Get data from the last cruise
	    
      DO L = indx(4,1), indx(4,2)
      DO j = indx(2,1), indx(2,2)
      DO i = indx(1,1), indx(1,2)
         IF (obs_only .EQ. 0) THEN
            IF (obs_cruise(i,j,2,L) .GT. 0.) THEN
               obs(i,j,1,L) = obs(i,j,1,L) + 
     .                 obs_cruise(i,j,1,L)/obs_cruise(i,j,2,L)
               obs(i,j,2,L) = obs(i,j,2,L) + 1.
            ENDIF
            obs_cruise(i,j,1,L) = 0.
            obs_cruise(i,j,2,L) = 0.
         ELSE
            IF (obs_cruise(i,j,1,L) .GT. 0.) THEN
               obs(i,j,1,L) = obs(i,j,1,L) + 1.
            ENDIF
               obs_cruise(i,j,1,L) = 0.
         ENDIF
      ENDDO
      ENDDO
      ENDDO

*  Put gridded fcn into result variable.

      IF (obs_only .EQ. 0) THEN
         k = res_lo_ss(Z_AXIS)
         L1 = 1
         DO 420 L = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
            j1 = 1
            DO 410 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
               i1 = 1
               DO 400 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
                  IF (obs(i1,j1,2,L1) .GT. 0.) THEN
                     result(i,j,k,l) = obs(i1,j1,1,L1)/obs(i1,j1,2,L1)
		  ELSE
                     result(i,j,k,l) = bad_flag_result
		  ENDIF

                  i1 = i1 + 1
 400           CONTINUE
               j1 = j1 + 1

 410        CONTINUE
            L1 = L1 + 1
 420     CONTINUE

      ELSE
         k = res_lo_ss(Z_AXIS)
         L1 = 1
         DO 520 L = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
            j1 = 1
            DO 510 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
               i1 = 1
               DO 500 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
                  result(i,j,k,l) = obs(i1,j1,1,L1)
                  i1 = i1 + 1
 500           CONTINUE
               j1 = j1 + 1

 510        CONTINUE
            l1 = l1 + 1
 520     CONTINUE

      ENDIF

      RETURN

900   CONTINUE

      IF (nxpts .NE. npts) THEN
         WRITE (errtxt,20)
      ELSE IF (nxpts .EQ. 0) THEN
         WRITE (errtxt, 30)
      ENDIF
      GOTO 999 

 999  CALL EF_BAIL_OUT(id, errtxt)
      RETURN

   20 FORMAT 
     . ('Input scattered var,x,y,t,cruiseID have different # of points')

   30 FORMAT ('No data in scattered x,y,t points')


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      END




      SUBROUTINE pickoutxytcv (obs_only, vars, alon, alat, atimes,
     .   cruises, n, vv, xx, yy, tt, ncc)

*  Called from the scatter* family of gridding functions.
*  Pick out nth item from a set of arrays, which are really 
*  4-dimensioned arrays with normal axes on three of the four axes.

      REAL alon(*), alat(*), atimes(*), cruises(*), vars(*)
      REAL xx, yy, tt, vv
      INTEGER obs_only, n, ncc

      vv = 1.
      IF (obs_only .EQ. 0) vv = vars(n)
      xx = alon(n)
      yy = alat(n)
      tt = atimes(n)
      ncc = cruises(n)

      RETURN
      END

	SUBROUTINE FIELD_MINMAX_SUB ( arr, cx,
     .		slox, shix, sloy, shiy, sloz, shiz, slot, shit,
     .		sloe, shie, slof, shif, bad, lo, hi )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* support routine for FIELD_MINMAX with unsubscripted limits

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V450: 3/97
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

	include	'tmap_dims.parm'
	include 'ferret.parm'
	include	'xcontext.cmn'

* calling argument declarations:
	INTEGER cx, slox, shix, sloy, shiy, sloz, shiz, 
     .		slot, shit, sloe, shie, slof, shif
	REAL    arr( slox:shix,sloy:shiy,sloz:shiz,slot:shit,sloe:shie,slof:shif ),
     .		bad, lo, hi

* internal variable declarations:
	INTEGER	i, j, k, l, m, n

* --- end of introductory code ---

* initialize
	hi = arbitrary_small_val4
	lo = arbitrary_large_val4

	DO 100 n = cx_lo_s6(cx), cx_hi_s6(cx)
	DO 100 m = cx_lo_s5(cx), cx_hi_s5(cx)
	DO 100 l = cx_lo_s4(cx), cx_hi_s4(cx)
	DO 100 k = cx_lo_s3(cx), cx_hi_s3(cx)
	DO 100 j = cx_lo_s2(cx), cx_hi_s2(cx)
	DO 100 i = cx_lo_s1(cx), cx_hi_s1(cx)

	   IF (arr(i,j,k,l,m,n) .NE. bad) THEN
	      IF (arr(i,j,k,l,m,n) .LT. lo) lo = arr(i,j,k,l,m,n)
	      IF (arr(i,j,k,l,m,n) .GT. hi) hi = arr(i,j,k,l,m,n)
	   ENDIF
	   
 100	CONTINUE

	RETURN
	END 

	SUBROUTINE PURGE_ALL_UVARS_EXCEPT_EX

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* eliminate all stored user variables from memory except for the current EX#
* expression

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V702 *sh* 1/17 - for dynamic memory -- based upon PURGE_ALL_UVARS

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xvariables.cmn'

* internal variable declarations:
	INTEGER	uvar, i, j, num_indices

        CALL deleted_list_get_undel(uvar_num_items_head, 
     .                          deleted_list_result(1),
     .                          max_uvar, num_indices )
        DO j = 1, num_indices
           uvar = deleted_list_result(j)

* do not delete EX#n variables as they may be actively in use
* as in "set att temp.missing_value = 12"
	   IF (uvar_name_code(uvar)(1:3) .EQ. 'EX#'    ) CYCLE

* eliminate all memory resident instances of this variable
	   CALL PURGE_USER_VAR( uvar )

* back to initial defaults (see INIT_UVAR)
* (eliminate all grid information that may have been rendered incorrect)
	   CALL DEALLO_UVAR_GRIDS(uvar)

*       bug fix: 11/91 *************
* must reset ALL of the state variables as set up in INIT_UVAR
* by default assume the definition requires an external data set specification
           uvar_need_dset( uvar ) = .TRUE.

* by default assume that all limits are irrelevant
           DO 320 i = 1, nferdims
 320       uvar_given(i,uvar) = uvlim_irrelevant
* end of bug fix: 11/91 *************

	ENDDO

	CALL PURGE_AUX_VAR_DEPENDENTS

	RETURN
	END

	SUBROUTINE IS_UVAR_GRID( *, *, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* examine an algebraic evpression component by component on the 
* interpretation stack in order to determine a defining grid for the overall
* expression.
* Detailed description of the underlying logic is in MERGE_CONTEXT
* Note: When pseudo-variables are used (eg. LIST U/Z[K=1:3]) the grids for them
*	may not be known until all other components are examined.  In this
*	case a 2nd pass is required

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V200:  6/20/89
* V230:  7/21/92 - separate error message for cvar grid unknown
* V411  8/28/95 - variables defined with LET/D= need uvar_need_dset=TRUE
* V420   9-11/95 - dynamic axes and grids
*	 12/95	- set uvar_mod_pseudo if there is a pseudo-var dependency
* V450:  1/97 - process alg_child_var
*	      - and process grid-changing variables
*        7/97 - generate child var name using GCF_PARENT_UVAR
* V500: *sh* 12/98 - support for cat_const_var -- fixed arrays like "{1,3,5}"
*       *sh*  2/99 - if ABSTRACT grid or normal axis then use XABSTRACT (or
*                       YABSTRACT, ZABSTRACT, TABSTRACT)
*		     A significant consequence of this is that 2 passes are
*		     needed ANY TIME that pseudo-variables which do not state
*		     their own axes are used, becuase they may be generating
*		     abstract axes. For example, the grid of "SST+Z"
* v500: *kob* 3/99 - fixed which crashed ferret when  let/d didn't have a 
*                    dataset present
*	*sh* 3/99 - bug fix: bug introduced with string arguments 
*	*sh* 4/99 - bug fix: 2/99 2nd pass check "need_another_pass" state
*		is lost is a component is fetched afterwards. Instead, save
*		this state as a negative is_phase
*       *kob* 4/99 - bug fix: using /d in the definition of a dataset
*                    independent variable caused a crash.
* V510: 8/99 *sh* - allow G=uvar on both uvars and pseudo-vars.
*			If uvar grid is unknown, go get it!
*	1/00 *sh* - bug fix for nested GC variables 
*	4/00 *sh* - netCDF grids are now dynamic so 2nd pass check to deallo
*			dynamic grid needs logic change
* V530 10/00 *sh* - fixed bug that was revealed by new ability of
*		    GCF_IMPOSE_AXES to take an error exit
*	          - process string variables so that they may be obtained
*		    by EFs during custom axis creation
* V533 7/01 *sh* - save the data type of the result
*	         - process alg_if_marker in support of IF cond THEN string
* V540 10/01 *sh* - fix bug in IF-THEN hack when 2nd pass is required
* V541  4/02 *sh* - fix bug in IF-THEN: err540_data_type.jnl
*                   constants were not processed, so PLOT IF X GT 5 THEN 1
*                   failed to pick up the data type of the constant 1
* v552: 4/03 *acm*  Increase length of variable names to 128 characters
*                   (variables are up to 128, so **name** needs extra space
*                   i.e. for a transformation specifier)
* v552: 5/03 *acm*  Use just the current item when dealing w/ G=uvar with 
*                   target grid not yet known (intermediate variable buff)
* v554: 1/04 *acm* Counter variables for REPEAT/RANGE=/NAME=
* V600 8/05 *acm* - Add variable type attrib_val for definitions of the form
*                   varname.attname
* V603 5/07 *acm* - Fix bug 1507: if start = end, then definition of name 
*                   leaves name blank. assign a longer string to name and 
*                   then just send the first character to GET_VAR_CONTEXT
* V611 5/08 *acm*   Fix bug 1578; dataset specifiers applied correctly 
*                   var[d=1].attname
* V615 11/08*acm*    Fix bug 1421: if variable in expr is undefined call 
*                   DEALLO_UNFORMED_GRID to correctly back out of the 
*                   dynamic grid that was partially defined.
* V615 11/08*acm* - fixing bug 1523. If the variable contains a grid-changing 
*                   function, mark it as such for repl_exprns to get the 
*                   correct size.
* V615 11/08*acm*   For linux, pass dummy status flag to DEALLO_UNFORMED_GRID. 
*                   The status flag that is passed back must remain set to 
*                   non-ferr_ok to exit properly from the command.
*       *acm* 3/12  Add E and F dimensions (use nferdims in tmap_dims.parm)
* V690 9/13-2/14 *sh*   support for auxiliary var regridding: temp[gz(depth)=zax]
* V694  *acm* 1214 Fixing ticket 2220
* V694 *acm*  5/15 Fix ticket 2213 
* V698 *sh* 1/16   tweaks to aggregates to ensure all LET/D grids found
* V698 *acm* 1/16  change remaining dset=-1 to the parameter dset=pdset_uvars
* V698  3/16 *acm* Removed Philander-Seigel code including diagnostic 
*                  variables, pre-defined axes and grids, cat_calc_var.
* V698  3/16 *acm* Remove unneeded xdset_parms.cmn
* v698 5/16  *acm* ticket 2413: New attribute keywords ncoordvars, coordnames
*                  return info about coordinate-variables in datasets
* V699  5/16 *sh*  replace variable uvar_grid with calls to c LIST structures
* V710 *acm* 10/16 Ticket 2422: variables uvar_grid, uvar_data_type, uvar_aux_cat, 
*                  uvar_aux_var to be replaced with calls to LIST routines in NCF_Util.c 
* V720  3/17 *acm*  clean up long commented-out code referring to aggregations 
* V720: 4/17 *acm* Add direction-changing functions as a subset of grid-changing ones
* V720: 6/17 *acm* Fix ticket 2547: the grid and type of uvars are stored, but the
*                  information may be collected on different passes through this routine.
* V74+  5/18 *acm* issue 1868: gridding transforms that will grid to same axis

        IMPLICIT NONE
* calling argument declarations:
	INTEGER	status
* normal return is for error conditions
* exit #1 is to request grid for a component ( stack has been pushed )
* exit #2 is to signal that the grid has been obtained and stored in uvar_grid

#include "netcdf.inc"
	include	'tmap_errors.parm'
	include 'tmap_dims.parm'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'
	include	'xfr_grid.cmn'

* internal variable declarations:
	LOGICAL	ITSA_GCVAR, ITSA_CONST_VAR, ITSA_DCVAR, REGRID_TO_SELF,
     .		its_dynamic, its_gc, need_another_pass,
     .		saved_ifthen_type, do_err, ok_remote,
     .		getting_aux_var, its_const_var, its_dc, self_gridding
	INTEGER KNOWN_GRID, STR_SAME,
     .		TM_LENSTR1, GCF_PARENT_UVAR, GCF_PARENT_CHAR, 
     .		NCF_GET_AGG_COUNT, iaux,
     .		hi_cx, lo_cx, big_cx, aux_cx, start, end, grid,
     .		i, dset, uvar, item, itype, idim, gnum, nitem, uv_grd,
     .		var, len_name, pass_number, cx_save, this_dset,
     .		ifthen_data_type, varid, alen, attype, attlen,
     .          attoutflag, attid, bracket, dot, dsloc, endbracket,
     .          status_deallo, agg_grid, agg_line, agg_len, agg_dset,
     .		imemb, memb_cat, memb_dset, memb_grid, iline, nv,
     .		hi_cat, hi_var, vlen, slen, dummy_aux(nferdims),
     .		use_axis, std_axis
	INTEGER igrid_test

	CHARACTER VAR_CODE*128, LEFINT*6,
     .		  name*512, buff*2048, varname*512, 
     .            attname*128, aname*128, newname*512

*        ... interpretation stack setup at the time this is called ...
*	stack level		stack contents
*	isp+1	<--	level to get grids for components
*	 isp	<--	current level: evaluate user-variable grid

* --- end of introductory code ---

* initialize
	lo_cx  = is_cx( isp )
	big_cx = is_big_cx( isp )
	grid   = cx_grid(big_cx)
	uvar   = is_uvar( isp )
	dset   = cx_data_set( lo_cx )
	nitem  = uvar_num_items( uvar )
	its_gc = ITSA_GCVAR(uvar)
	its_dc = ITSA_DCVAR(uvar)
	has_uvar_gc = has_uvar_gc .OR. its_gc  ! for repl_exprns fixing bug 1523
	has_uvar_dc = .FALSE.                  ! function changes based on args
	is_uvar_const = ITSA_CONST_VAR(uvar)   ! for repl_exprns fixing bug 2213
* ... initialization to support 2/99 pass-2 changes
	pass_number = 1

	cx_type(big_cx) = ptype_unknown   ! initialize; fixing ticket 2547
! 4/99
	need_another_pass = is_phase(isp) .LT. 0  ! saved from last time here
	is_phase(isp) = ABS( is_phase(isp) )
	cx_save = cx_stack_ptr		! restored on pass #2 (2/99)
	saved_ifthen_type = .FALSE.
	getting_aux_var = .FALSE.
* when auxiliary grid information is irrelevant ... 
	DO idim = 1, nferdims
	   dummy_aux(idim) = -12345   ! visible in debugging
	ENDDO

* process the next item in the expression from the uvar buffer (last to first)
 100	is_phase(isp) = is_phase(isp) + 1
	item = nitem - is_phase(isp)	+ 1	! point into uvar_text
	IF ( item .LT. 1 ) GOTO 1000		! have processed entire def'n
	itype = uvar_item_type ( item, uvar )
	start = uvar_item_start( item, uvar )
	end   = uvar_item_end  ( item, uvar )
	IF     ( itype .EQ. alg_pseudo_var  ) THEN
	   GOTO 200
	ELSEIF ( itype .EQ. alg_const_var   ) THEN
	   GOTO 250
	ELSEIF ( itype .EQ. alg_child_var   ) THEN
	   GOTO 300
	ELSEIF ( itype .EQ. alg_variable    ) THEN
	   GOTO 305
	ELSEIF ( itype .EQ. alg_attrib_val  ) THEN
	   GOTO 359
	ELSEIF ( itype .EQ. alg_string      ) THEN
	   GOTO 400
	ELSEIF ( itype .EQ. alg_constant    ) THEN
	   GOTO 410
	ELSEIF ( itype .EQ. alg_counter_var   ) THEN
	   GOTO 420
	ELSEIF ( itype .EQ. alg_then_marker ) THEN  ! marks where the IF was
	   GOTO 450
	ELSE
	   GOTO 100
	ENDIF

* pseudo-variable: merge into grid if it has explicit grid info
 200	CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) RETURN
	hi_cx = cx_stack_ptr
	CALL PSEUDO_VAR_CONTEXT( uvar_text(uvar)(start:end),
     .				 lo_cx,
     .				 hi_cx,
     .				 idim,
     .				 status )
	IF ( status .NE. ferr_ok ) RETURN
* 12/95: flag any axes of this uvar that depend on the pseudo-variable
* (note XBOX probably doesn't need this but, hey, what the heck)
	uvar_mod_pseudo(idim,uvar) = .TRUE.
* did we get a grid for the pseudo-variable ?
	IF ( cx_grid(hi_cx) .LT. unspecified_int4 ) THEN
	   GOTO 800
	ELSEIF ( cx_grid(hi_cx) .NE. unspecified_int4 ) THEN
	   GOTO 500		! yup - merge it
	ELSE
* nope! Set flag indicating a 2nd pass is needed
	   uvar_given( idim, uvar ) = uvlim_unknown  ! ?? irrelevant from 2/99
	   need_another_pass = .TRUE.
	   cx_stack_ptr = cx_stack_ptr - 1
	ENDIF
	GOTO 100

* constant-array-variable (of type alg_const_var):
 250	CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) RETURN
	hi_cx = cx_stack_ptr
        CALL CONST_VAR_CONTEXT ( uvar_text(uvar)(start:end),
     .                           uvar,
     .                           item,
     .                           lo_cx,
     .                           hi_cx,
     .                           status )
	IF ( status .NE. ferr_ok ) RETURN
	GOTO 500		! go merge it

* child variable: treat it just like a regular variable except that 
* its name is not found in the text. Instead generate its name from
* its position and its parent variable
* see IS_ALGEBRA for example
 300	CALL GCF_CHILD_VAR_NAME( GCF_PARENT_UVAR(uvar),
     .				 GCF_PARENT_CHAR(uvar,start), name )
	len_name = TM_LENSTR1(name)
	GOTO 310

* variable: parse name, get full expression context
 305	name = uvar_text(uvar)(start:end)
	len_name = end-start+1
 310	CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	hi_cx = cx_stack_ptr
	CALL GET_VAR_CONTEXT (  name(:len_name),
     .				lo_cx,
     .				hi_cx,
     .				status )
	IF ( status .NE. ferr_ok ) THEN
	   status_deallo = status
	   CALL DEALLO_UNFORMED_GRID (status_deallo)
	   GOTO 5000
	ENDIF

***
* A digression from the usual grid-getting:
* if this variable belongs to an aggregated dataset there may be LET/D uvars
* included in the definition of that dataset. The user may have changed
* those LET/D defnitions since defining the aggregation.  We need to ensure
* that the grids of any new LET/D uvars are known.
	IF ( cx_category(hi_cx).EQ.cat_agg_e_var .OR. 
     .       cx_category(hi_cx).EQ.cat_agg_f_var ) THEN
	   agg_dset = cx_data_set( hi_cx )
	   status = NCF_GET_AGG_COUNT (agg_dset, agg_len)
* loop over the member vars of the aggregation
	   DO imemb = 1, agg_len
* ... first get the information that was true at the time of DEFINE DATA/AGG
	      varname = VAR_CODE(cx_category(hi_cx), cx_variable(hi_cx))
	      CALL CD_GET_AGG_VAR_INFO (agg_dset, varname, imemb, 
     .            memb_cat, memb_dset, memb_grid, iline, nv, status)
* ... ignore dummy datasets and synthetic 2D coordinate variable, tf_times
	      IF (memb_dset .EQ. pagg_promotion_indicator_dset
     .	      .OR.memb_dset .EQ. pdset_dummy                   ) CYCLE

	      IF (memb_cat .EQ. cat_agg_gpromote) THEN
		 var = 0
		 hi_cat = cat_attrib_val  
	         cx_data_set(hi_cx) = memb_dset
		 uv_grd = KNOWN_GRID( cx_data_set(hi_cx), cat_attrib_val, var )
		 GOTO 500
	      ENDIF

* ... now get info of the variable currently associated with this name
	      varname = VAR_CODE( memb_cat, nv )
	      vlen = TM_LENSTR1(varname)
	      CALL FIND_VAR_NAME (memb_dset,varname, hi_cat, hi_var )
	      IF (hi_var .EQ. munknown_var_name) CALL ERRMSG
     .			(ferr_aggregate_error, status,"variable "//
     .			 varname(:vlen)//" not found in member "//
     .			 LEFINT(imemb, slen), *5000)
	      uv_grd = KNOWN_GRID(memb_dset, hi_cat, hi_var)
	      IF (uv_grd .EQ. unspecified_int4) THEN
	         IF (hi_cat .NE. cat_user_var) GOTO 9000  ! internal error
* ... we have found a LET/D valiable with unknown grid
* ... set up the context to describe that variable
*     (the current hi_cx may include regridding and all sorts of stuff)
	         CALL INIT_EMPTY_CONTEXT(hi_cx)
	         cx_data_set(hi_cx) = memb_dset
	         cx_variable(hi_cx) = hi_var
	         cx_category(hi_cx) = cat_user_var
!	         CALL GET_AGG_MEMB_UVAR_CONTEXT(memb_dset, hi_var, hi_cx)
* ... when the grid has been determined we want to come back to this aggregated
*     variable and check for other new LET/D vars that may lack grids
*     so we set the "phase" back to where it was when we started this pass
	         is_phase(isp) = is_phase(isp) - 1
* ... create a new ISP stack level to get the grid of that user variable
	         GOTO 900
	      ENDIF
	   ENDDO
	ENDIF
***

***
* Another digression from the usual grid-getting:
* When regridding using auxiliary variable(s) has been requested, we have to
* ensure that the grids of the aux variables are known
* (Note that aux var grids do not get merged into the parent grid)
	IF  ( cx_unstand_grid(hi_cx)
     .	.AND. cx_naux(hi_cx) .GT. 0 ) THEN
	   CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   aux_cx = cx_stack_ptr
	   DO 330 iaux = 1, cx_naux(hi_cx)
	      CALL GET_AUX_VAR_CONTEXT( hi_cx, aux_cx, iaux, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
	      IF ( cx_grid( aux_cx ) .EQ. unspecified_int4 ) THEN
	         CALL TRANSFER_CONTEXT(aux_cx, hi_cx)
	         cx_stack_ptr = cx_stack_ptr - 1
	         GOTO 900   ! go get this aux var grid
	      ENDIF
 330	   CONTINUE
*  ... return now to normal grid determination for the variable being regridded
	   cx_stack_ptr = cx_stack_ptr - 1
	ENDIF
***

* handle variable regridded to a uvar which has unknown grid (8/99) 
	IF ( cx_unstand_grid(hi_cx)
     . .AND. cx_grid(hi_cx) .LT. unspecified_int4 ) GOTO 800

* do we know the defining grid for the component ?
* (not necessarily the same as the returned grid --> there may be a regrid )
	IF ( cx_category(hi_cx) .EQ. cat_user_var ) THEN
* ... 12/95: inherit the pseudo-variable flag from any component that has it
	   var = cx_variable(hi_cx)
	   DO 350 idim = 1, nferdims
	      IF (uvar_mod_pseudo(idim,var))
     .			uvar_mod_pseudo(idim,uvar) = .TRUE.
 350	   CONTINUE
	   uv_grd = KNOWN_GRID( cx_data_set(hi_cx), cat_user_var, var )
	   IF ( uv_grd .EQ. unspecified_int4 ) THEN
	      GOTO 900	! uvar grid not known --> get it
	   ELSE
	      GOTO 500	! uvar grid known --> merge it
	   ENDIF

	ELSEIF ( cx_grid(hi_cx) .NE. unspecified_int4 ) THEN
	   GOTO 500	! know grid --> merge it
	ELSE
	   GOTO 9000	! err: grid for non-user vars should always be known
	ENDIF

* variable.attname: parse name, get needed parts of context for attribute

 359	name = uvar_text(uvar)(start:end)
	len_name = end-start+1

! If there is a region spec on the variable, ignore it. If the region spec
! is after the attribute name, we will apply it to the attribute.
! e.g. var[d=1,x=180:300].units, just return the units; x=180:300 is irrelevent
!      var.special_params[i=1:3] want to return items 1 thru 3 of the attribute

        bracket = INDEX(name, '[')
        IF (bracket .GT. 0) THEN
           dot = INDEX(name, '.')
           IF (dot .GT. bracket) THEN
              dsloc = MAX(INDEX(name, 'd='), INDEX(name, 'D=') )
              IF (dsloc .GT. 0) THEN 
                 DO 360 i = dsloc+1, len_name
                    IF (name(i:i) .EQ. ',') GOTO 370
                    IF (name(i:i) .EQ. ']') GOTO 370
 360             CONTINUE
 370             CONTINUE
                 endbracket = INDEX(name, ']')
                 newname = name(1:bracket)//'d='//name(dsloc+2:i-1)//']'//name(endbracket+1:len_name)
                 len_name = TM_LENSTR1(newname)
                 name = newname
              ELSE
                 endbracket = INDEX(name, ']')
                 newname = name(1:bracket-1)//name(endbracket+1:len_name)
                 len_name = TM_LENSTR1(newname)
                 name = newname
              ENDIF
           ENDIF
        ENDIF

 	CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	hi_cx = cx_stack_ptr
	CALL GET_VAR_CONTEXT (  name(:len_name),
     .				lo_cx,
     .				hi_cx,
     .				status )
	IF ( status .NE. ferr_ok ) GOTO 5000

        dset = cx_data_set(hi_cx)
        IF (dset .EQ. pdset_irrelevant) dset = pdset_uvars
        do_err = .TRUE.
        varname = ' '
        attname = ' '
        CALL  BREAK_VARATTNAME (  name(:len_name), dset, varname, 
     .                            attname, varid, do_err, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* Get attribute type and length
        
* See if it is a pseudo-attribute attnames, ndims, etc.

        attype = NCFLOAT

        IF (STR_SAME(attname, 'attnames') .EQ. 0  .OR. 
     .       STR_SAME(attname, 'dimnames') .EQ. 0 .OR. 
     .       STR_SAME(attname, 'coordnames') .EQ. 0 ) THEN
           attype = NCCHAR
        ELSE IF (STR_SAME(attname, 'ndims') .EQ. 0  .OR.
     .      STR_SAME(attname, 'type') .EQ. 0  .OR.
     .      STR_SAME(attname, 'nvars') .EQ. 0  .OR.
     .      STR_SAME(attname, 'ncoordvars') .EQ. 0  .OR.
     .      STR_SAME(attname, 'nattrs') .EQ. 0 ) THEN
           attype = NCFLOAT

        ELSE IF (STR_SAME (varname, '.') .EQ. 0) THEN
           IF (STR_SAME(attname, 'varnames') .EQ. 0   .OR.
     .         STR_SAME(attname, 'dimnames') .EQ. 0 .OR.
     .         STR_SAME(attname, 'coordnames') .EQ. 0 ) THEN
              attype = NCCHAR

           ELSE IF (STR_SAME(attname, 'attnames') .EQ. 0   .OR.
     .           STR_SAME(attname, 'ndims')  .EQ. 0  .OR.
     .           STR_SAME(attname, 'nattrs') .EQ. 0  .OR.
     .           STR_SAME(attname, 'nvars')  .EQ. 0  .OR.
     .           STR_SAME(attname, 'ncoordvars') .EQ. 0 ) THEN
              attype = NCFLOAT
           ENDIF

* Otherwise get att type from the linked-list structure

        ELSE
           CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid,
     .               status)
           IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, varid,
     .        attid, aname, attype, attlen, attoutflag, status )
        ENDIF

        IF (attype .EQ. NCCHAR) THEN
           cx_type(hi_cx) = ptype_string
	ELSE
	   cx_type(hi_cx) = ptype_float
	ENDIF

* The attribute handling needed to know if this was a dataset variable (dset > 0) 
* or a user-defined variable that depends on a dataset (dset=pdset_uvars). Now reset the
* dataset to the value from cx_data_set

        dset = cx_data_set(hi_cx)
        IF (dset .EQ. pdset_irrelevant) dset = pdset_uvars
        
* set the X axis limits equal to the length of the array
c	cx_lo_ss(hi_cx, x_dim) = 1
c	cx_hi_ss(hi_cx, x_dim) = attlen !!
        IF (attype .EQ. NCCHAR) cx_hi_ss(hi_cx, x_dim) = 1

* The grid is abstract 

	var = cx_variable(hi_cx)
        uv_grd = KNOWN_GRID( cx_data_set(hi_cx), cat_attrib_val, var )

	IF ( cx_unstand_grid(hi_cx)
     . .AND. cx_grid(hi_cx) .LT. unspecified_int4 ) GOTO 800


* do we know the defining grid for the component ?
* (not necessarily the same as the returned grid --> there may be a regrid )

	IF ( cx_grid(hi_cx) .NE. unspecified_int4 ) THEN
	   GOTO 500	! know grid --> merge it
	ELSE
	   GOTO 9000	! err: grid for varname.attname is known
	ENDIF

        GOTO 500

* string constant
 400	CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) RETURN
	hi_cx = cx_stack_ptr
        CALL STRING_CONTEXT (   uvar,
     .                          item,
     .                          lo_cx,
     .                          hi_cx,
     .                          status )
        IF ( status .NE. ferr_ok ) RETURN
	GOTO 500		! go merge it

* constant (float)
* this block is only for the purpose of setting the data type of the result
* ... in case the result is only a constant (in an IF-THEN expression)
! ... The grid is unspecified for a constant
 410	IF ( is_sum(isp) .EQ. isalg_transfer ) THEN
	   CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   hi_cx = cx_stack_ptr
           CALL CONSTANT_CONTEXT ( uvar_text(uvar)(start:end),
     .                             lo_cx,
     .                             hi_cx,
     .                             status )
           IF ( status .NE. ferr_ok ) RETURN
	   cx_type(big_cx) = cx_type(hi_cx)
	   cx_stack_ptr = cx_stack_ptr - 1
	ENDIF
	GOTO 100

* counter variable (repeat/range=)
* this block is only for the purpose of setting the data type of the result
! ... The grid is unspecified for a constant
 420	IF ( is_sum(isp) .EQ. isalg_transfer ) THEN
	   CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   hi_cx = cx_stack_ptr
           name = '1'
           CALL CONSTANT_CONTEXT ( name,
     .                             lo_cx,
     .                             hi_cx,
     .                             status )
           IF ( status .NE. ferr_ok ) RETURN
	   cx_type(big_cx) = cx_type(hi_cx)
	   cx_stack_ptr = cx_stack_ptr - 1
	ENDIF
	GOTO 100

* "IF" marker in an "IF condition THEN result1 ELSE result2" structure
* ... The data type of the result depends only on the result clauses
* ... prepare to restore the data type after the "condition" is processed
* ... Note: expressions are processed here from high item backwards so
*           the "condition" is the last thing to be procesed 
 450	saved_ifthen_type = .TRUE.
	ifthen_data_type = cx_type(big_cx)
	GOTO 100

* create, initialize buffer to receive the grid
 500	IF ( is_sum(isp) .EQ. isalg_transfer) THEN
	   grid = cx_grid(big_cx)
	   CALL INIT_EMPTY_CONTEXT( big_cx)
	   CALL INIT_GRID(grid, 'UVAR', mnormal)
	   cx_grid(big_cx) = grid
	   is_sum( isp ) = isalg_merge_n
	ENDIF

* merge the newly acquired grid with the previously merged ones
	grid = cx_grid(big_cx)
	CALL MERGE_GRID( item, its_gc, uvar_text(uvar)(start:end),
     .			 big_cx, hi_cx, uvar, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	IF (saved_ifthen_type) cx_type(big_cx) = ifthen_data_type

* 1/97: For GC variables, the last GC function argument has just been merged.
* Now we need to finish by imposing any axes that the function requires.
* The context stack at this point has these contents
* 	  default context (var=uvar, region=(1:1,1:1,1:1,1:1) for base var)
* big_cx: the merged grid context
*   -->	  argument N context
*	  argument N-1 context
*	  ...
*	  argument 1 context
* So big_cx+1 is passed as a pointer to the argument contexts  
	IF (its_gc) THEN
	   IF (item.EQ.1) THEN
	      CALL GCF_IMPOSE_AXES( big_cx+1, big_cx, uvar, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
	   ENDIF
	ENDIF
	
* release context stack space for component just merged
* 1/97: release it if and only if it is not a grid-changing variable.
* For grid changing variable we may need the list of contexts for all of the
* arguments to the GC function in order to determine the imposed axes.
* The depth of the stack needed for this should be 2+nargs
* Note that nargs is always nitem-1 since grid-changing variabless always
* compile to uvar_item_type = arg1 arg2 ... argn gc_function
* BUT that this routine examines items in reverse order (why?) so item=1
* is the key that we are evaluating the last argument for the GC variable.
* Note that in principle there should be no problem handling the stack in
* this manner (popping it only after all arguments are evaluated)
* for all uvars; handling GC variables differently was a choice in
* order to minimize changes to already working code
	IF ( is_phase(isp).NE.0 ) THEN
	   IF (.NOT.its_gc) THEN
	      cx_stack_ptr = cx_stack_ptr - 1
	   ENDIF
	ENDIF
	 
	GOTO 100

* deal with G=uvar with target grid not yet known -- get the target grid (8/99)
 800	CONTINUE
* ... decode the character position of the "G=" target variable name
* 5/03 bug fix acm: use buff here for just the current item, not the 
*                   whole uvar_text(uvar) 
* 
        buff = uvar_text(uvar)(start:end)
	end = (-cx_grid(hi_cx))/2000
	start = (-cx_grid(hi_cx)) - 2000*end + unspecified_int4
* 2/03 *kob* g77 port - need the '*' on call to errmsg to make it an
*                       alternate return label, rather than passing
*                       by reference
	IF ( start .LT. 0
     .  .OR. end   .LT. start
     .	.OR. end   .GT. cmnd_buff_len ) CALL ERRMSG(
     .			ferr_internal, status, 'G=uvar', *5000)

	name = buff(start:end)
	len_name = end - start + 1
        
* Fix bug 1507: if start = end, then the above assignment leaves name blank (!)
        IF (len_name .EQ. 1) name = buff(start:end+1)

* ... the context stack is already pushed from above
	CALL GET_VAR_CONTEXT (  name(:len_name),
     .				lo_cx,
     .				hi_cx,
     .				status )
	IF ( status .NE. ferr_ok ) GOTO 5000


* grid for this component is not known.  Back to IS stack to get it
* ... repeat this phase again when we get back
 900	is_phase(isp) = is_phase(isp) - 1
	IF (need_another_pass) is_phase(isp) = -1 * is_phase(isp)  ! 4/99
* load the new variable info onto the IS stack
	CALL PUSH_INTERP_STACK( isp, status )
	IF ( status .NE. ferr_ok ) RETURN
	is_cx   ( isp ) = hi_cx
	is_uvar ( isp ) = cx_variable( hi_cx )
	is_act  ( isp ) = isact_get_grid	! temp diagnostic

* Fixing ticket 2547. Save the type now. Later passes do not do the ifthen_type logic.
	
	IF (cx_type(big_cx).NE.cx_none .AND. cx_type(big_cx).NE.unspecified_int4) THEN
	   CALL SAVE_UVAR_TYPE(uvar, cx_type(big_cx), this_dset)
	ENDIF

	RETURN 1
	
***  DONE - clean up
 1000	CONTINUE
* for grid-changing vars all of the arguments contextx are still on the stack 
	IF ( its_gc ) THEN
	   DO 1010 i = 1, nitem - 1
	      cx_stack_ptr = cx_stack_ptr - 1
 1010	   CONTINUE
	ENDIF
* have any variables been encountered ?
* is this a completely abstract expression like X+Y*2 ?
* ... 8/95 check uvar_dset: LET/D variable needs uvar_need_dset always true 

	IF ( is_sum(isp) .EQ. isalg_transfer ) THEN
	   IF ( uvar_dset(uvar).EQ.unspecified_int4 ) THEN
	      uvar_need_dset(uvar) = .FALSE.
	      
	      CALL SAVE_UVAR_GRID(uvar, mgrid_abstract, ptype_float,
     .				  pdset_irrelevant)
* ... 6/16 init aux info just for house-keeping
	      CALL SAVE_UVAR_AUX_INFO(uvar,
     .                         dummy_aux, dummy_aux, pdset_irrelevant)
	   ELSE		! defined with LET/D
!	      uvar_need_dset(uvar) = .TRUE.	! always TRUE anyway
* *kob* 4/99 bug fix - check to see if let/d is dataset independent
	      IF (dset .EQ. unspecified_int4) THEN
	         CALL SAVE_UVAR_GRID(uvar, mgrid_abstract, ptype_float,
     .				     pdset_irrelevant)
* ... 6/16 init aux info just for house-keeping
	         CALL SAVE_UVAR_AUX_INFO(uvar,
     .                         dummy_aux, dummy_aux, pdset_irrelevant)
              ELSE
	         CALL SAVE_UVAR_GRID(uvar, mgrid_abstract, ptype_float, dset)
* ... 6/16 init aux info just for house-keeping
	         CALL SAVE_UVAR_AUX_INFO(uvar, dummy_aux, dummy_aux, dset)
	      ENDIF
	   ENDIF
	   gnum = mgrid_abstract
	   CALL TM_USE_DYN_GRID( mgrid_abstract )
	   GOTO 2000
	ENDIF

* catalog this result checking for matching previously existing grid

* For dimension-changing function, make a new grid and copy gnum to it
* The function will change the grid so we do not want to use existing one.

	IF (its_dc .OR. self_gridding) THEN
	   CALL TM_MAKE_NEW_DYN_GRID(grid, gnum, status )
 	ELSE     
	   CALL TM_GET_LIKE_DYN_GRID(grid, its_dynamic, gnum, 
     .				grd_stk_ptr, status )  
 	ENDIF
	IF (status .NE. merr_ok) GOTO 5000
	IF ( its_dynamic ) THEN
	   IF ( mode_diagnostic )  CALL DIAG_OP
     .	     ('allocate', isact_class_impl_grid, gnum, 0)
	ENDIF

* point uvar to its grid (possibly need different grid for each dset)
* ... 8/95 check uvar_dset: LET/D variable needs uvar_need_dset always true 
* ... 3/99 but LET/D ("default") needs uvar_need_dset FALSE 
* ... 11/02 LET/D needs uvar_need_dset FALSE only when there is no dataset
*           associated with the variable.  In the case where LET/D wants the
*           default dataset associated with the variable, it should be true
*           so remove the 3/99 additions - which fixed a bug which occured
*           only when a let/d was done and no dataset was initialized.  This
*           was the incorrect place to fix that bug.

        IF ( uvar_dset(uvar).EQ.unspecified_int4 )
     .            uvar_need_dset(uvar) = .NOT.cx_dset_gvn(big_cx)

	IF ( uvar_need_dset(uvar) .AND. dset .NE. unspecified_int4) THEN
	   this_dset = dset
	ELSE
	   this_dset = pdset_irrelevant
	ENDIF

* store the important stuff!
	CALL SAVE_UVAR_GRID(uvar, gnum, cx_type(big_cx), this_dset)
	CALL SAVE_UVAR_AUX_INFO(uvar,
     .       cx_aux_cat(1,big_cx), cx_aux_var(1,big_cx), this_dset)

* * * SECOND PASS CHECK * * *
* need a second pass to include pseudo_vars in calculation ?
 2000	IF ( need_another_pass ) THEN 
* ... uvar_grid and data set info are NOT re-initialized
	   IF ( pass_number .GT. 1 ) GOTO 9000	! caught in a loop ...
	   DO 1110 i = 1, nferdims
 1110	   uvar_given(i,uvar) = uvlim_irrelevant

* 6/16 comment as we switch to LIST-based management of uvar grids:
* ... the following commented-out SAVE_UVAR_GRID call was initially inserted
*     for consistency with the pre-LIST code. Studying the comments we see
*     that the storage of this unspecified_int grid value was introduced to
*     fix a bug (10/00) and actually contradicts the explicit comment that 
*     "are NOT initialized" just above. Because 'this_dset' reflects context
*     left by previous commands, it is not reliably correct for the current
*     grid determination.  The result is that on occasion an unspecified_int4
*     value gets falsely stored under an irrelevant dataset, and not removed,
*     thereby mildly corrupting the uvar grid LISTs.  I see no value in storing
*     it so I've commented it out. But the possibility exists of an unforseen
*     interaction.  There must be some reason that the previous code set
*     these unspecified values, right?
!	   CALL SAVE_UVAR_GRID(uvar, unspecified_int4, unspecified_int4,
!     .			       this_dset)
	   is_phase( isp ) = 0
	   is_sum( isp ) = isalg_transfer
	   cx_stack_ptr = cx_save
	   need_another_pass = .FALSE.
	   pass_number = pass_number + 1
	   saved_ifthen_type = .FALSE.
	   cx_grid( lo_cx ) = gnum	! set default for pseudo-vars
* ... deallocate the grid just obtained since it will be
*     allocated again on the next pass
! pre-4/00 IF (gnum .GT. max_grids ) CALL TM_DEALLO_DYN_GRID( gnum )
	   CALL TM_DEALLO_DYN_GRID( gnum )
* ... release the use-count hold that the temporary grid has on the axes
*	since it will be re-asserted on the second pass
*	We need to retain the grid, itself, because it is used on pass 2
	   DO 1120 i = 1, nferdims
	      CALL TM_DEALLO_DYN_LINE(grid_line(i,grid))
 1120	   CONTINUE
	   IF ( mode_diagnostic ) THEN
	      CALL DIAG_OP('dealloc ',isact_class_impl_grid,gnum,0)
	      CALL DIAGNOSTIC_OUT( 'pass #2', lo_cx, point_to_cx )
	   ENDIF
	   GOTO 100
	ENDIF

* release context (lo_cx, big_cx), IS and grid stack space used in grid-getting
	IF ( big_cx .NE. cx_stack_ptr
     .	.OR. big_cx .NE. lo_cx+1 ) WRITE (6, *) 'uvar_stk_err' ! temp diag
	cx_stack_ptr = cx_stack_ptr - 2
	isp = isp - 1
	CALL DEALLO_GRID( status )
	IF ( status .NE. ferr_ok ) GOTO 5000
c        IF ( itype .EQ. alg_attrib_val  ) THEN
c           uvar_dset(uvar) = unspecified_int4  ! or irrelevant??
c        ENDIF

* Is it a LET/REMOTE variable?
* ! do we need to find a slot in rvar_uvar, and index the rvars with "rvar", 
* !or just use same indexing as for regular user-vars?


        IF (uvar_remote(uvar)) THEN 

	   CALL CD_DSET_REMOTEOK(dset, ok_remote)
	   IF (ok_remote) THEN
	      uvar_remote(uvar) = .TRUE. 
	      rvar_uvar(uvar) = uvar  
	      rvar_dset(uvar) = dset
c	      rvar_on_server(uvar) = .FALSE. 
	   ELSE
	      uvar_remote(uvar) = .FALSE. 
	   ENDIF
	ENDIF

	RETURN 2

* error exit
 5000	CALL DEALLO_ALL_GRIDS
	RETURN
 9000	CALL ERRMSG( ferr_internal, status, 'is_uvar_grid', *5000 )

	END	

	INTEGER FUNCTION DO_SUM( idim, arg,
     .				 com, com_mr, com_cx,
     .				 res, res_mr, res_cx,
     .				 buff	)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute a simple sum of the data between the indicated limits
* Boxes at the ends of the region will always be fully counted - no weighting
* based on the fraction of the box within the region as with integrals

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V230: 12/91 - based on DO_MAX
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V702 *sh* 11/16 this routine now performs accumulation only.  Initialization
*                 and finalizing called separately from IS_TRANS
* V71  *acm* 12/16 Send extra-buffer space that was allocated for the 
*                 accumulation/finalization, to store counts. To distinguish 
*                all-missin data with a value of zero, from all-zero sums.

        IMPLICIT NONE
	include	'errmsg.parm'
	include 'ferret.parm'
	include	'tmap_dims.parm'
	include 'xcontext.cmn'
	include	'xdset_info.cmn_text'

* calling argument declarations:
	INTEGER	idim, com_mr, com_cx, res_mr, res_cx
	REAL	arg, buff(*),
     .          com( * ), res( * )

* internal variable declarations:
	LOGICAL TM_ITSA_DSG
	INTEGER CGRID_SIZE, TM_DSG_DSET_FROM_GRID, TM_DSG_NFEATURES,
     .		size, grid, dset, nfeatures, maxobs, mr_list(2)
	REAL	little_val, big_val

* Get size of result array to locate buffer area just beyond
* Pass extra-buffer portion of res array to accumulate counts
* - to distinguish between an all-missing and an all-zero sum.

	size = CGRID_SIZE(res_cx)
	
	grid = cx_grid(res_cx)

	IF (TM_ITSA_DSG(grid)) THEN 
* DSG ragged array
	   dset = TM_DSG_DSET_FROM_GRID(grid)
	   nfeatures = TM_DSG_NFEATURES(grid)
* ... get the length of the longest feature
	   CALL DSG_COORD_LIMS(dset, pdsg_row_size, little_val, big_val)
	   maxobs = big_val

	   mr_list(1) = com_mr
	   mr_list(2) = res_mr
	   CALL NON_ARRAY_SUBSC( mr_list, 2 )
	   CALL DSG_ARRAY_SUBSC( mr_list, 2, dsg_orientation(dset) )

	   CALL DO_SUM_DSG (idim, arg, dset, nfeatures, maxobs,
     .                      com, com_mr, com_cx,
     .                      res, res_mr, res_cx,
     .                      res(size+1)	)
	
	ELSE

	   CALL DO_SUM_SUB (idim, arg,
     .                   com, com_mr, com_cx,
     .                   res, res_mr, res_cx,
     .                   res(size+1)	)
	
	ENDIF


	DO_SUM = ferr_ok
	RETURN
	END

	INTEGER FUNCTION TM_GET_VARNUM( vname, dset )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* given a variable name supposed to be in the indicated data set return the
* TMAP variable ID

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/92
* V500 4/99 *kob*: increase upcase_var from 24 to 64 chars - to match passed in vname
* V552 5/03 *acm*: increase size of upcase_var from 64 to 128 chars
* calling argument declarations

	INTEGER		dset
	CHARACTER*(*)	vname

* include files
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'xdset_info.cmn_text'
	external xdset_info_data

* local variable declarations:
      INTEGER STR_UPCASE, TM_LENSTR1, istat, slen, ivar
      CHARACTER upcase_var*128

* convert to upper case
      istat = STR_UPCASE( upcase_var, vname )     ! 4/91
      slen  = TM_LENSTR1( vname )

* locate the variable code among the variables in this data set
      DO 100 ivar = 1,maxvars

          IF ( ds_var_setnum(ivar) .NE. dset ) GOTO 100

          IF ( ds_var_code(ivar)(:slen) .EQ. upcase_var(:slen) ) THEN
            TM_GET_VARNUM = ivar
            RETURN
          ENDIF

 100  CONTINUE

* not found
      TM_GET_VARNUM = unspecified_int4
      RETURN
      END

	SUBROUTINE XEQ_VECTOR

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute the VECTOR command

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer uvnder VMS operating system
*
* revision 0.0 - 1/7/87
* revision 0.1 - 2/25/87 - changes for INTERPRETATION STACK
* revision 0.2 - 6/24/87 - provisions to permit 90 degree data-plane transpose
*			   and to separate DISP_INIT from DISP_SET_UP
* revision 0.3 - 7/8/87  - DISP_LABELS separated from DISP_SET_UP
* revision 0.4 - 7/28/87 - added CALL DISP_PREP
* revision 0.5 - 8/11/87 - VECKEY relocates according to title position
* revision 0.6 - 8/26/87 - dont transpose on XT plots
* revision 0.7 - 3/2/88  - check for valid data range before loading
* revision 0.8 - 4/14/88 - added /NOLABELS and range check --> DISP_SET_UP
* revision 0.9 - 4/28/88 - added only_x to DISP_SET_UP
* revision 1.0 - 6/22/88 - compute axis aspect correction using PPLUS AXIS.INC
*			   axis lengths
* revision 1.1 - 8/1/88  - corrected bug: x_skip said "Y" and visa versa
*			   added MODE WAIT
* revision 1.2 - 9/21/88 - do_labels --> no_labels: /NOLABEL processing chged
* V200:  5/19/89 - 4D symmetrical
*	  1/4/89 - using keys for labelling
*	 3/13/90 - check status from DISP_PREP
* V301: 12/8/93  - added VECTOR/XSKIP/YSKIP
* 	  1/7/94 - bug fix: (see DISP_DATA_SET_UP) must unprotect plot data
*	 2/10/94 - added /PEN=
* V312: 5/94 - array "memory" as a calling argument
* V320: 12/29/94 - use SPLIT_LIST to redirect tty output for GUI
*	 1/20/94 - changes to SAVE_FRAME call reflecting C-based procedures
* V450:  5/29/97 - added /NOAXES qualifier (eventually for curvilinear plots)
* V510 *sh* 12/99 - allow plots of all-missing data
*		  - replace /PEN qualifier with /COLOR, supporting named colors
*      5/00 *sh* - restored the /PEN qualifier (with "denigrated" remark
*      10/00 *AM* - added VECTOR/FLOWLINE (alias FLOWLINE)
* V530 *sh* 1/01 - change "denigrated" to "deprecated"
*      *acm*6/01 - add arguments is_logh, is_logv to DISP_SET_UP call.
*                  (only used for PLOT command)
*      *acm* 7/01 - Add VECTOR/AXES=TOP,BOT,LEFT,RIGHT
*      *acm* 7/01 - Add /AXES=TOP,BOT,LEFT,RIGHT
*		    & call ax_on_off to implement /NOAXES.
*      *acm* 10/01  remove VMS includes
* V540 *acm*  2/02  restore persistence of PPL AXSET settings
* V541 *acm*  3/02  Make PPL AXSET settings persist, but not settings
*                   done with qualifiers /AXES= or /NOAXES
*      *acm*  4/02  If this is an overlay, and there is no valid data, 
*                   do not put "No Valid Data" across the middle of the plot.
*                   Instead (in disp_set_up) add this information to the
*                   variable name in the key below the plot.
*      *acm*  5/02  Add /NOKEY option.  Also, if /NOLAB specifed, do not
*                   plot a key.
* V550: *acm*11/02 add argument is_shade to DISP_SET_UP call (not used by vector)
* V552: *acm* 5/03 add argument use_cell to DISP_SET_UP call (not used by vector)
* v554: *acm* 2/04 add /HGRAT /VGRAT to draw optional graticule lines at tic marks
* V606  8/07 *acm* Send informational and error messages that are returned from 
*                  commands via SPLIT_LIST to std error rather than std out.
* V6.11 4/08 *acm* Fixes for bug 1571; call to PPL_AXES_RESTORE moved to DISP_INIT
* V614  *acm* 10/08 - add new MODE NODATA_LAB to control the NO VALID DATA label.
*                  Put it on plots only when this mode is set.
* V6.2  *acm* 11/08Fix bug 1609: If the plot is an overlay then do not process /AXES=
*                  or /NOAXES. Axes are never drawn for overlays anyway.
* V6.2  *acm& 2/09 Fix choice of color settings with /PEN and /THICK when we have 
*                  increased the num of colors with MODE linecolors
* V6.63 *acm* 7/10 Save symbols PPL_VEC_XSKIP, PPL_VEC_YSKIP containing the 
*                  Vector XSKIP and YSKIP values.
* V6.63 *acm* 7/10 Save symbols PPL_VEC_XSKIP, PPL_VEC_YSKIP containing the 
*                  Vector XSKIP and YSKIP values. (PPL_VECLEN is saved in vecfld)
* V6.63 *acm* 7/10 Add VECTOR/KEY to force key even if /NOLAB
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
*                  A time axis may be a T axis or F axis
* V697 *acm* 12/15 Fixes for bug 2327 move call of PPL_AXES_RESTORE back to end of plot routines
* V702 1/17 *sh* for trac enhancement #2369 -- dynamic memory management 
* V74  1/18 *am* for issue #1854, extra argument to DISP_SET_UP
* v744 *acm* 11/18 Issue 1786: graticule lines & axes drawn if PLOT/OVER/AXES given


        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include	'plot_setup.parm'
	include	'slash.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'
	include 'xplot_setup.cmn'
	include 'xpplus.cmn'
        include 'axis_inc.decl'       ! with axis lengths	
        include 'AXIS.INC'       ! with axis lengths	
	include 'xrisc.cmn'          ! 12/94 SPLIT_LIST buffer


* calling argument declarations:

* internal variable declarations:
	LOGICAL		overlay, transpz, no_labels, no_x_rng,
     .			set_up, noaxes, axes, no_data, flows, 
     .			is_logh, is_logv, no_key, yes_key,
     .			is_shade, use_cell, inc_grid
	INTEGER		TM_LENSTR1, status, cx, 
     .			loc, ipen, thick,
     .			dim1, dim2, asp,
     .			ax1_work, ax2_work,
     .			x_skip, y_skip,
     .                  density, slen, i, nparm, num_it, 
     .			s1, s2, it_start(4), it_end(4), iax(4),
     .                  loch, locv, ier, ist
        INTEGER   STR_UPCASE, i1
	REAL		only_x, aspect, vbuf, xloc, yloc
	CHARACTER	buff*25


* internal parameter declarations:
	LOGICAL		norm_dims_only, vector
	PARAMETER     ( norm_dims_only  = .FALSE.,
     .			vector		= .TRUE.)
	INTEGER ncolors

* set up the graphics environment and get the data
	CALL START_PPLUS
	CALL DISP_DATA_SET_UP(  ax1_work, ax2_work, status )
	IF ( status .NE. ferr_ok ) GOTO 5100

* make sure the number of expressions given is even ( x and y components )
	IF ( MOD( num_uvars_in_cmnd, 2 ) .NE. 0 ) CALL ERRMSG
     .		(ferr_invalid_command,status,
     .		 'VECTOR requires paired components',*5000)

* initialize
	overlay   = qual_given( slash_vect_over_plot ).GT.0 .AND. twodee_on
	no_labels = qual_given( slash_vect_nolabels  ).GT.0
	transpz   = qual_given( slash_vect_transpz   ).GT.0
	set_up	  = qual_given( slash_shad_set_up    ).GT.0

* On overlays don't draw axes unless specificially requested with /AXES
* (e.g.so graticule lines can be overlaid on a final plot.)

	noaxes    = qual_given( slash_noaxes         ).GT.0
        IF (overlay) THEN
	   noaxes = .FALSE.
	   axes = .FALSE.
	ENDIF
	axes      = qual_given( slash_vect_axes      ).GT.0

	flows     = qual_given( slash_vect_flowline  ).GT.0
	is_logh   = .FALSE.  ! Not valid quals
	is_logv   = .FALSE.  ! for vector

	no_key = .FALSE.
        IF (no_labels) no_key = .TRUE.

	IF (qual_given( slash_vect_nokey ).GT.0)  no_key    = .TRUE.

	! for vector, key even if /NOLAB
	IF (qual_given( slash_vect_key) .GT.0) THEN
	   no_key    = .FALSE.
	   yes_key   = .TRUE.  ! to override settings where no key would be drawn.
	ENDIF

        is_shade  = .FALSE.
        use_cell  = .FALSE.
        ncolors = mode_arg(pmode_linecolors,1)

	IF ( .NOT.overlay ) CALL DISP_INIT(no_labels,is_cx,num_uvars_in_cmnd)
* ... default orientation for YT and ZT VECTORs has time on horizontal
	IF ( (plot_axis(2).EQ.t_dim .OR. plot_axis(2).EQ.f_dim) .AND. 
     .		plot_axis(1).NE.x_dim ) transpz = .NOT.transpz

	CALL DISP_PREP( status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* possibly transpose the axes
	IF ( transpz ) THEN
	   dim2 = plot_axis(1)
	   dim1 = plot_axis(2)
	ELSE
	   dim1	= plot_axis(1)
	   dim2	= plot_axis(2)
	ENDIF

* scale-ratio correction requested ?
	IF ( qual_given( slash_vect_aspect ) .GT. 0 ) THEN
	   asp = qual_given( slash_vect_aspect )
	   CALL EQUAL_VAL( cmnd_buff(qual_start(asp):qual_end(asp)),
     .			   aspect, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   IF ( aspect .EQ. unspecified_val4 ) aspect = ylen/xlen
	   IF ( aspect .LE. 0.0 ) CALL ERRMSG( ferr_out_of_range,
     .		status, cmnd_buff(qual_start(asp):qual_end(asp)), *5000 )
	ELSE
	   aspect = 0.0
	ENDIF

* user-specified pen color ?  (2/94)
	loc = MAX( qual_given(slash_pen), qual_given(slash_color))
	IF ( loc .GT. 0 ) THEN
	   IF (.NOT.denig_pen_msg_done .AND. qual_given(slash_pen).GT.0)
     .									THEN
	      CALL WARN( '/PEN is deprecated. Use /COLOR.')
	      denig_pen_msg_done = .TRUE.
	   ENDIF
	   CALL EQUAL_COLOR( cmnd_buff(qual_start(loc):qual_end(loc)),
     .                           ipen, status )
           IF ( status .NE. ferr_ok ) GOTO 5000
	ELSE
	   ipen = -1	! auto-select in DISP_SET_UP
	ENDIF
* ... VECTOR/THICKNESS=n
	loc = qual_given( slash_vect_thick )
	IF ( loc .GT. 0  ) THEN
	   IF ( ipen .EQ. -1 ) ipen = 1  ! /THICK alone means "BLACK"
	   ipen = MOD(ipen-1,ncolors)+1  ! eliminate thickness
	   CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			   vbuf, status )	! syntax check
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   IF ( vbuf .NE. unspecified_val4 ) THEN
	      IF ( vbuf.LE.0.0 .OR. vbuf.GT.3 ) GOTO 5400
	      thick = NINT( vbuf )	! user-specified line style
	   ELSE
	      thick = 2  ! default if no value is specified
	   ENDIF
	   ipen = ncolors*(thick-1) + ipen
	ENDIF

* for flowline plots, get the density
        density = 0
        IF (flows) THEN 
	   loc = qual_given( slash_vect_density )
	   IF ( loc .GT. 0 ) THEN
	      CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			   vbuf, status )
	      IF ( status .NE. ferr_ok ) RETURN
	      IF ( vbuf .EQ. unspecified_val4 ) THEN
	         density = 1.
	      ELSE
	         density = ABS(vbuf)
	      ENDIF
           ELSE
              density = 5
           ENDIF
        ENDIF

* ... VECTOR/hgrat[=dash or line] default is dash
*     hgrat line type: 0=tics only, 1=dash 2=line

	loch = qual_given(slash_vect_hgrat)

* ... VECTOR/vgrat[=dash or line] default is dash
*     vgrat line type: 0=tics only, 1=dash 2=line

	locv = qual_given(slash_vect_vgrat)
        
        IF (loch .EQ. 0  .AND. locv .EQ. 0) THEN
           loch = qual_given(slash_vect_grat)
           locv = qual_given(slash_vect_grat)
        ENDIF

        CALL set_graticules(loch, locv, status)

* set up title and load the x component data into PPLUS

	inc_grid = .FALSE.
	CALL DISP_SET_UP   ( 	
     . 			 	vector,
     .				is_shade,
     .				use_cell,
     .				aspect,
     .				overlay,
     .				transpz,
     .				no_labels,
     .				no_x_rng,
     .				only_x,
     .                          density,
     .				is_logh, 
     .				is_logv,
     .				is_mr,
     .				num_uvars_in_cmnd,
     .				is_cx,
     .				is_uvar,	
     .				workmem(ax1_work)%ptr,
     .				workmem(ax2_work)%ptr,
     .				ipen,
     .				inc_grid,
     .				set_up,
     .				status )

	IF ( status .NE. ferr_ok ) GOTO 5000

* is there no valid input data?
        no_data =  no_x_rng .AND. only_x.EQ.bad_val4

c when it's an overlay, 'No Valid Data' is part of the plot key,
c done in disp_set_up. If mode_nodata_lab is false then leave this off.

        IF (.NOT. overlay .AND. no_data .AND. mode_nodata_lab) 
     .                  CALL PUT_LABEL( ppl_movlab, 0.5, 0.5,
     .                  ppl_centered, letsize_title,
     .                  'No Valid Data',
     .                  lab_loc_axlen_times, lab_loc_axlen_times )

* increment counter of vector fields on the screen
	nvect_on = nvect_on + 1

* special set-up required only for the VECTOR command
        IF (no_data) no_key  = .TRUE.  ! regardless of /KEY or /NOKEY setting

         IF ( .NOT.overlay .AND. .NOT.no_data .AND. .NOT.no_key) THEN
* ... vector length key below plot title (overlay written as key)
            xloc = (xlen/2.) - 0.5
            yloc = -1.*yorg + 0.2
            WRITE ( ppl_buff, '(2F6.1)' ) xloc, yloc
            CALL PPLCMD (' ',' ',0,'VECKEY/NOUSER '//ppl_buff, 1, 1 )
         ENDIF   

	IF ( overlay .AND. yes_key ) THEN  ! force key in the middle under the title.
* ... vector length key below plot title (overlay written as key)
           xloc = (xlen/2.) - 0.5
           yloc = -1.*yorg + 0.2
	   WRITE ( ppl_buff, '(2F6.1)' ) xloc, yloc
	   CALL PPLCMD (' ',' ',0,'VECKEY/NOUSER '//ppl_buff, 1, 1 )
	ENDIF	

	IF (no_key) THEN
* ... no vector-length key.  
	   CALL PPLCMD (' ',' ',0,'VECKEY 0', 1, 1 )
	ENDIF	

* turn off axes? 
	IF ( noaxes ) THEN 
           DO 300 i = 1, 4
              iax(i) = 0
 300       ENDDO
        ENDIF

* turn on (one or more) axes? (7/11/01)

* ... PLOT/AXES=(TOP,BOTTOM,LEFT,RIGHT)
	IF ( axes ) THEN
           loc = qual_given( slash_vect_axes )
	   CALL EQUAL_STR_LC( cmnd_buff(qual_start(loc):qual_end(loc)),
     .                        buff, status )
           IF ( status .NE. ferr_ok ) GOTO 5000

	   IF ( buff .NE. ' ' ) THEN

* Get arguments, if any.  Otherwise turn on all axes
              slen = TM_LENSTR1(buff)
              s1 = 1
              s2 = slen
              IF (buff(1:1) .EQ. '(' )THEN
                  s1 = 2
                  s2 = slen-1
                  IF ( buff(slen:slen) .NE. ')' ) GOTO 5440
              ENDIF
              nparm = 4
              CALL parse_comma_list ( buff, s1, s2, nparm, 
     .             num_it, it_start, it_end, status)

              IF (status .EQ. ferr_ok .AND. it_start(1) .GT. it_end(1)) THEN	! /AXES=()
                 DO 400 i = 1, 4
                    iax(i) = 0
 400             ENDDO
              ELSE IF (status .NE. ferr_ok .OR. num_it .LT. nparm) THEN
                 GOTO 5440
              ELSE
                 DO 500 i = 1, nparm
                    READ (buff(it_start(i):it_end(i)), *) iax(i)
                    IF (iax(i) .LT. 0  .OR.  iax(i) .GT. 1) GOTO 5450
 500             CONTINUE
              ENDIF
           ELSE		! turn on all axes
	      DO 600 i = 1, 4
		 iax(i) = 1
 600	      CONTINUE
           ENDIF

       	ENDIF	

*  Turn off or on axes, including time axes.
        IF (axes .OR. noaxes) CALL ax_on_off (iax, overlay)

* done now if /set_up, only
	IF ( set_up) GOTO 1000

* sub-sample the vectors to make a cleaner plot ?
* *ACM 10/00*  do not subsample if its a flowline plot

        IF (.NOT. flows) THEN
	   cx   = is_cx( 1 )
	   loc = qual_given( slash_vect_xskip )
	   IF ( loc .GT. 0 ) THEN
	      CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			   vbuf, status )
	      IF ( status .NE. ferr_ok ) RETURN
	      IF ( vbuf .EQ. unspecified_val4 ) THEN
	         x_skip = 1.
	      ELSE
	         x_skip = ABS(vbuf)
	      ENDIF
	   ELSE
	      x_skip = ( cx_hi_ss(cx,dim1)-cx_lo_ss(cx,dim1) )
     .		 / max_x_vec + 1
	      IF ( x_skip .NE. 1 ) THEN
	         risc_buff = ' '	         
	         WRITE ( risc_buff, 3000 ) x_skip, 'X'
	         CALL SPLIT_LIST(pttmode_explct, err_lun, risc_buff, 0)
	      ENDIF
	   ENDIF
	   loc = qual_given( slash_vect_yskip )
	   IF ( loc .GT. 0 ) THEN
	      CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			   vbuf, status )
	      IF ( status .NE. ferr_ok ) RETURN
	      IF ( vbuf .EQ. unspecified_val4 ) THEN
	         y_skip = 1.
	      ELSE
	         y_skip = ABS(vbuf)
	      ENDIF
	   ELSE
	      y_skip = ( cx_hi_ss(cx,dim2)-cx_lo_ss(cx,dim2) )
     .	   	    / max_y_vec + 1
	      IF ( y_skip .NE. 1 ) THEN 
	         risc_buff = ' '	         
	         WRITE ( risc_buff, 3000 ) y_skip, 'Y'
	         CALL SPLIT_LIST(pttmode_explct, err_lun, risc_buff, 0)
	      ENDIF
	   ENDIF
 3000	   FORMAT (' Using every ',I3,'th vector in the ',
     .            A1,' direction')
	   WRITE ( ppl_buff, '(2I4)' ) x_skip, y_skip

* plot it with vector arrows
	   IF (  overlay ) THEN
	      CALL PPLCMD (' ',' ',0,
     .		'VECTOR/OVER/' //ppl_wait//' '//ppl_buff, 1, 1 )
	   ELSE
	      CALL PPLCMD (' ',' ',0,
     .		'VECTOR/LATCH/'//ppl_wait//' '//ppl_buff, 1, 1 )
	   ENDIF

C   Save the skip values in a symbol PPL_VEC_XSKIP, PPL_VEC_YSKIP

	   WRITE ( ppl_buff, 3010 ) x_skip
 3010	   FORMAT ('PPL_VEC_XSKIP', i4)
	   ier = 0
	   ist = 0
	   CALL SETSYM (ppl_buff, 17, ier, ist)

	   WRITE ( ppl_buff, 3020 ) y_skip
 3020	   FORMAT ('PPL_VEC_YSKIP', i4)
	   ier = 0
	   ist = 0
	   CALL SETSYM (ppl_buff, 17, ier, ist)

        ELSE  

* plot it with flowlines

           CALL flow_set_up (is_mr, is_cx, transpz)

* special set-up required only for the VECTOR/FLOW command
	IF ( .NOT.overlay .AND. .NOT.no_data ) THEN
* ... vector length key below plot title (overlay written as key)
           xloc = (xlen/2.) - 0.5
           yloc = -1.*yorg + 0.2
	   WRITE ( ppl_buff, '(2F6.1)' ) xloc, yloc
	   CALL PPLCMD (' ',' ',0,'VECKEY/NOUSER '//ppl_buff, 1, 1 )

           IF (no_key) THEN
	      CALL PPLCMD (' ',' ',0,'VECKEY 0', 1, 1 )
	   ENDIF	

	ENDIF	

           WRITE (ppl_buff, '(I4)') density
	   IF (  overlay ) THEN
	      CALL PPLCMD (' ',' ',0,
     .		'FLOWLINE/OVER/' //ppl_wait//' '//ppl_buff, 1, 1 )

	   ELSE
	      CALL PPLCMD (' ',' ',0,
     .		'FLOWLINE/LATCH/'//ppl_wait//' '//ppl_buff, 1, 1 )
	   ENDIF
        ENDIF

* restore axes? (5/29/97  revised 3/2002
        IF ( axes .or. noaxes ) CALL PPL_AXES_RESTORE

* interrupt occurred during plot ?
	IF ( ppl_interrupted ) GOTO 1000

* capture the bit map ?
	IF ( qual_given( slash_vect_frame ) .GT. 0 ) THEN
	   CALL SAVE_FRAME( frame_file, "HDF", status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	ENDIF

* release the memory used for axis buffers
 1000 	CALL FREE_WS_DYNMEM( ax1_work )
	CALL FREE_WS_DYNMEM( ax2_work )
	CALL UNPROTECT_CMND_DATA			! 1/94
 5100	RETURN

* error exits
 5000	GOTO 1000
 5400	CALL ERRMSG( ferr_out_of_range, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .		'Legal range is 1 to 3', *5000 )
 5440	CALL ERRMSG( ferr_syntax, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .	'AXES[=(TOP,BOTTOM,LEFT,RIGHT)] takes 4 arguments or no argument', *1000 )
 5450	CALL ERRMSG( ferr_out_of_range, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .		'AXES arguments must be 0 or 1', *1000 )
	END

	SUBROUTINE CDF_LIST_DSG ( dset, cdfid, fname, append, nvars,
     .			     nfeatures, nobs_in, longest_feature,
     .			     mr_list, cx_list, title,
     .			     out_type, quiet, do_coords, status )


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Write the indicated list of variables out in netCDF format where
* data is from a DSG datset, writing to a ragged-array DSG netCDF file.

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Science Data Integration Group

* 10/2018
*  2/2019 add /APPENDing as an option, for LET/D variables.
*         TODO:
*         At present the routine does not check the grids but will let the 
*         subroutine calls report any errors.  When appending, masks etc
*         get set up, but it doesn't make any sense to apply them.  
*  6/2019 *acm* MASK_DSG_OBSVAR call has changed, for use by trajectory-plotting 
*  8/2019 *acm* Allow writing user-defined varaibles to DSG datasets
* V751 *acm* 11/19 new qualifier SAVE/NOCOORDS: subroutine calls change.
* V76  *acm*  4/20 Fix when setting instance_var flag. 
* V76  *acm*  4/20 Fix for data type, writing string data
* V76  *acm*  4/20 Additions for writing subsets of point datasets
* v7.6 *acm* 5/20 Issue 1876: can read string-typed data, write as char.

        include 'netcdf.inc'
#include "netcdf_declareUnderscore.inc"
        include 'tmap_errors.parm'
        include 'cd_lib.parm'
        include 'cdf_tmap.parm'
        include 'tmap_dims.parm'
        include 'xtm_grid.cmn_text'
	include 'xdset_info.cmn_text'
	include 'xdset_info.cd_equiv'
	include 'xdyn_linemem.cmn_text'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
	include 'xrevision.cmn'
	include 'xtoday.cmn'
	include 'xinterrupt.cmn'
        include 'netcdf4_settings.cmn'

* calling argument declarations:
        LOGICAL         append, quiet, do_coords
	INTEGER		dset, cdfid, nvars, mr_list(nvars), cx_list(nvars),
     .			keepax_flag, nfeatures, nobs_in, longest_feature, status
        CHARACTER*(*)   fname, title, out_type

* internal variable declarations:

	INTEGER	  max_len
	PARAMETER (max_len = 2048)

        LOGICAL         TM_LEGAL_NAME, NC_GET_ATTRIB, TM_ITSA_DSG, 
     .			itsa_uvar, its_cdf, new, mode_up_in, flushed, 
     .			enhead,itsa_string, output_units, output_title,
     .                  output_history, get_ds, edges_flag,
     .                  got_it, got_title, got_units, got_history,
     .                  got_missing, got_fill, do_warn, coordvar,
     .                  process_feature(nfeatures), process_obs(nobs_in), 
     .                  has_mask, have_dimname,
     .                  instance_coord(4), relevant_coord(4),
     .                  instance_var(nvars), point_var(nvars),
     .                  instance_vars_only, point_vars_only, synthetic_rowsiz, 
     .                  ragged, no_id

	INTEGER		TM_LENSTR1, GET_MAX_C_STRING_LEN, STR_SAME,MGRID_SIZE, 
     .			CGRID_SIZE, DSG_WHATS_IT, STR_DNCASE, TM_DSG_DSET_FROM_GRID,
     .			cx, mr, grid,  ivar, nready, lbuff, cdfstat, 
     .                  idim, i, recdim, do_bounds, cat, var, cat1, var1, 
     .			iaxis, final_status, maxstrlen, 
     .			write_lo(nferdims), write_hi(nferdims), 
     .			lo_e(nferdims), hi_e(nferdims), 
     .			lo_o(nferdims), hi_o(nferdims), stride(nferdims),
     .                  dset_last, dset_num, attid, len, varid, vartype, 
     .                  nvdims,  nvatts, vdims(8), iatt, slen, alen, 
     .                  attype, attlen, attoutflag, all_outflag,
     .                  outtype, egrid, ogrid, maxlen, fvar_varid,
     .                  ifeature, ifeat, iobs, n_feat, n_obs, nobsf,
     .                  orientation, obsdimlen, featr_ivar, featr_mr, coord_lm(4), 
     .                  ptr, bufflen, line, gxlate, row_size_lm, clen, nblank,
     .                  slen1, slen2, idummy_line, base, fobs, count,
     .                  line_fcoord, line_obscoord, dummy, nmasked, dset_dsg,
     .                  dndims, dlen, dnv, ngatts, ftype, f_direc
	REAL*8		GET_LINE_COORD, vals(100), bad, val, scalefac, addoff

	CHARACTER	SANITARY_VAR_CODE*128, TM_FMT*48,
     .                  CD_DSG_FEATURENAME*20, CD_AXIS_NAME*128, 
     .                  varcode*128, varname*128, buff*2048, 
     .                  buff1*128, buff2*128, obsdimname*128, 
     .                  ftrname*20, attname*128, out_typ_in*20

* local parameter declarations:

* For error messages
	CHARACTER*9 typnam(6)
	DATA typnam/'NC_BYTE', 'NC_CHAR', 'NC_SHORT', 'NC_INT', 
     .            'NC_FLOAT', 'NC_DOUBLE'/
	
* initialize
	ivar = 1  ! just house-keeping -- make sure all is init'ed
	flushed = .FALSE. ! on error, whether OK variables were written
	final_status = ferr_ok  ! innocent unless proven guilty
	do_warn = .NOT.quiet
	got_missing = .FALSE.
	got_fill = .FALSE.
	recdim = no_dim
	enhead = .FALSE.
	edges_flag = .FALSE.
	do_bounds  = -1
	itsa_uvar = .FALSE.
	itsa_string = .FALSE.
	keepax_flag = 0
	maxlen = 128
	its_cdf = .TRUE.  ! later, write data to cdf from other sources...
	
	out_typ_in = out_type
	mode_up_in =  mode_upcase_output
	mode_upcase_output = .FALSE.

	egrid = mgrid_buff
	ogrid = mgrid_buff
	line_fcoord = mnormal
	line_obscoord = mnormal

* Some sanity checking

	ivar = 1
	cx  = cx_list(ivar)
	grid	= cx_grid( cx )
	grid_is_dsg = TM_ITSA_DSG( grid )

* For handling user-vars and expressions based in another non-dsg dataset
	dset_dsg = TM_DSG_DSET_FROM_GRID( grid )  

	dset_num = cx_data_set( cx_list(ivar) )
	dset_num = dset_dsg

* The variables must all be from the same DSG dataset.

* are there any observation vars?  Or is this all instance vars?
	point_vars_only    = .TRUE.
	instance_vars_only = .TRUE.
	DO ivar = 1, nvars
	   cx  = cx_list(ivar)
           IF (cx_data_set( cx ).GT.pdset_irrelevant .AND. cx_data_set(cx).NE.dset) GOTO 4200  ! error message for inconsistent datasets

	   grid	= cx_grid( cx )
	   instance_var(ivar) = DSG_WHATS_IT(grid) .EQ. pdsg_instance
	   point_var(ivar) = CGRID_SIZE(cx) .EQ. 1
	   IF (.NOT.point_var(ivar)   ) point_vars_only    = .FALSE.
	   IF (.NOT.instance_var(ivar)) instance_vars_only = .FALSE.

	   orientation = dsg_orientation(dset_num)
	ENDDO

	ivar = 1
	cx  = cx_list(ivar)
	grid	= cx_grid( cx )

* The varid of the feature-id variable
 
	varcode = SANITARY_VAR_CODE(cat_file_var, dsg_feature_var(dset) )
	CALL CD_GET_VAR_ID  (dset, varcode, fvar_varid, status)
	buff1 = varcode

* which dimensions are relevant to show

	have_dimname = .FALSE.

	gxlate = dsg_xlate_grid(dset)
	DO idim = 1, 4
	   line = grid_line(idim, gxlate)
	   relevant_coord(idim) =  line.NE.mnormal .AND. .NOT.point_vars_only
	   IF (relevant_coord(idim)) THEN
	      ivar = dsg_coord_var(idim,dset)
	      coord_lm(idim) = dsg_loaded_lm(ivar)  ! line-memory table indices
	      instance_coord(idim) = line_dim(line) .EQ. nfeatures

* get obs dimension name ! test this with NCEI files that have vars on (trajectory,obs) axis
* with trajectory length = 1

	      IF (.NOT. instance_coord(idim) .AND. .NOT. have_dimname) THEN
	        
	         varcode = SANITARY_VAR_CODE( cat_file_var, ivar )
		 CALL CD_GET_VAR_ID (dset, varcode, varid, status)

		 CALL CD_GET_VAR_DIMS_INFO (dset, varid, varcode, nvdims, vdims, status)
	         CALL CD_GET_DS_DIMS (dset, vdims(1), obsdimname, i, status)
	         have_dimname = .TRUE.
	      ENDIF

	   ENDIF

	ENDDO

* For new files, the feature-id var has been loaded, after the data variables requested 
* in the LIST command. Find it and keep track its order as loaded.

	featr_ivar = var_name_nonexist

	DO ivar = 1, nvars
	   cx  = cx_list(ivar)
	   mr  = mr_list(ivar)
	   cat = cx_category(cx)
	   var = cx_variable(cx)
	   varcode = SANITARY_VAR_CODE( cat, var )
	   CALL CD_GET_VAR_ID (dset, varcode, varid, status)

	   IF (varid .EQ. fvar_varid) THEN
	      featr_ivar = ivar
	      featr_mr = mr
	      EXIT
	   ENDIF
	ENDDO

	ivar = 1
	cx   = cx_list(ivar)
	grid = cx_grid( cx )

* Create a mask showing which features to list.
	cx  = cx_list(ivar)
	CALL MAKE_DSG_FEATURE_MASK(dset, cx, process_feature, nfeatures)

* Find the number of features to list after masking, and the count
* of obs to write after masking.

* If the incoming file has no rowsize and if there is just one feature, we treat 
* the dataset as a 1-D DSG file and we have synthezised a RowSize for internal use.
* In this case skip writing a RowSize.
* also skip RowSize if it's a point-type dataset
 
	varid = dsg_row_size_varid(dset)
	synthetic_rowsiz = (varid .EQ. unspecified_int4) 

	IF (synthetic_rowsiz) THEN

	   n_feat = 1
	   n_obs = nobs_in
	   IF (orientation .EQ. e_dim) THEN
	      
	      n_feat = 0
	      DO ifeature = 1, nfeatures
	        IF (process_feature(ifeature)) n_feat = n_feat + 1
	      ENDDO
	      n_obs = n_feat
	   ENDIF

	ELSE
	   row_size_lm = dsg_loaded_lm(dsg_row_size_var(dset))

	   n_feat = 0
	   base = 0     ! obs index at end of preceding feature
	   n_obs = 0     
	   DO ifeature = 1, nfeatures
	     nobsf = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
	     IF (process_feature(ifeature)) THEN

* ... get observation-level mask for this feature
	        CALL MAKE_DSG_OBS_MASK(dset, cx, ifeature, base, process_obs, nobsf)
	        fobs = 0
	        DO iobs = 1, nobsf
	           IF (process_obs(iobs)) fobs = fobs + 1
	        ENDDO
	        IF (fobs .GT. 0) THEN
	           n_obs = n_obs + fobs
		   n_feat = n_feat + 1
	        ELSE
	           process_feature(ifeature) = .FALSE.
	        ENDIF
	    ENDIF
	     base = base + nobsf
	   ENDDO

	ENDIF

* Empty request is an error
	IF (n_feat .EQ. 0) GOTO 4300  ! 

* Sanity check: names and size of dimensions of appended variable against file.
* (should check the rowsize coords too...)

	IF (append) THEN

	   status = NF_INQ ( cdfid, dndims, dnv, ngatts, recdim )
	   recdim = no_dim

	   CALL CD_DSG_GET_FEATURETYPE (cdfid, ftype, f_direc, ragged, do_warn)
	   IF (orientation.NE.f_direc .OR. .NOT.ragged) GOTO 4400


	   DO i = 1, dndims
	      status = NF_INQ_DIMNAME (cdfid, i, varname)
	      IF (STR_SAME(buff1, varname) .EQ. 0) THEN
	         status =  NF_INQ_DIMLEN(cdfid, i, dlen)
		 IF (status .EQ. NF_NOERR) THEN
		    idim = 5
		    IF (dlen .NE. n_feat) GOTO 4500
		 ENDIF
	      ENDIF

	      IF (STR_SAME(obsdimname, varname) .EQ. 0) THEN
	         status =  NF_INQ_DIMLEN(cdfid, i, dlen)
		 IF (status .EQ. NF_NOERR) THEN
		    idim = orientation
		    IF (dlen .NE. n_obs) GOTO 4500
		 ENDIF
	      ENDIF
	   ENDDO 
	ENDIF

* write the featureType global attribute

	ftrname = CD_DSG_FEATURENAME(dsg_orientation(dset))
	slen = TM_LENSTR1( ftrname )
	attname = 'featureType'

*-*-*-*-*-*-*-*-*-*-*-*-
	IF (.NOT. append) CALL CD_WRITE_ATTRIB(cdfid, pcdf_global,
     .              attname, ftrname(:slen), .FALSE., status )

* ... Define the feature-length variables specific to DSG files:  
*     feature-id variable, rowSize

* ... Define 1-D storage for masked data in the feature-direction (E-dir).
*     The masked data  in the feature-direction (E-dir) will be stored 
*     in lineedg(line_fcoord)

	CALL TM_ALLO_TMP_LINE(line_fcoord, status)
	CALL GET_LINE_DYNMEM (n_feat, line_fcoord, status)

	line_dim(line_fcoord)  = n_feat
	line_regular(line_fcoord)  = .FALSE.
	line_dim_only(line_fcoord) = .TRUE.

* get feature dimension name

	CALL CD_GET_VAR_DIMS_INFO (dset, fvar_varid, varcode, nvdims, vdims, status)
	CALL CD_GET_VAR_TYPE (dset, fvar_varid, varcode, vartype, status)
	IF (vartype .EQ. NF_CHAR) THEN 
	   CALL CD_GET_DS_DIMS (dset, vdims(2), line_name(line_fcoord), i, status)
	ELSE
	   CALL CD_GET_DS_DIMS (dset, vdims(1), line_name(line_fcoord), i, status)
	ENDIF
	line_name_orig(line_fcoord) = line_name(line_fcoord)

* ... And a grid for feature variables

	egrid = 0
	CALL TM_ALLO_TMP_GRID (egrid, status)
	IF (status .NE. ferr_ok) GOTO 5000

	DO idim = 1, nferdims
	   grid_line(idim, egrid) = mnormal
	ENDDO
	grid_line(e_dim, egrid) = line_fcoord

* ... Assign coordinates to the feature-axis for writing

	DO count = 1, n_feat
	  val = count
	  CALL PUT_LINE_COORD(linemem(line_fcoord)%ptr, count, val)
	ENDDO

* ... Define the output obs dimension, with the number of masked obs
*     The masked data  in the obs direction (obs-dir) will be stored 
*     in the lineedg(line_obscoord)

	CALL TM_ALLO_TMP_LINE(line_obscoord, status)
	CALL GET_LINE_DYNMEM (n_obs, line_obscoord, status)

	line_name(line_obscoord) = obsdimname
	line_name_orig(line_obscoord) = obsdimname
	line_dim(line_obscoord)  = n_obs
	line_regular(line_obscoord) = .FALSE.
	line_dim_only(line_obscoord)  = .TRUE.

* ... And a grid for obs variables

c	IF (.NOT. instance_vars_only) THEN
	ogrid = 0
	CALL TM_ALLO_TMP_GRID (ogrid, status)
	IF (status .NE. ferr_ok) GOTO 5000

	DO idim = 1, nferdims
	   grid_line(idim, ogrid) = mnormal
	ENDDO

	grid_line(orientation, ogrid) = line_obscoord

	DO idim = 1, nferdims
	   lo_o(idim) = unspecified_int4
	   hi_o(idim) = unspecified_int4
	ENDDO
	lo_o(orientation) = 1
	hi_o(orientation) = n_obs

* ... Assign coordinates for the obs-axis of masked data

	count = 0
	base = 0     ! obs index at end of preceding feature
	DO ifeature = 1, nfeatures
	  IF (synthetic_rowsiz) THEN
	     nobsf = n_obs
	     IF (orientation .EQ. e_dim) nobsf = 1
	  ELSE
	     nobsf = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
	  ENDIF
	  IF (process_feature(ifeature)) THEN

* ... get observation-level mask for this feature
	     CALL MAKE_DSG_OBS_MASK(dset, cx, ifeature, base, process_obs, nobsf)

*    indices of obs written in this feature after masking

	     DO iobs = 1, nobsf
	        IF (process_obs(iobs)) THEN
	           count = count + 1       ! coordinate index on output feature axis
		   val = count
	           CALL PUT_LINE_COORD(linemem(line_obscoord)%ptr, count, val)
		ENDIF
	     ENDDO

	  ENDIF

	  base = base + nobsf
	ENDDO

* ... when appending, do not set up the DSG feature, rowSize or coordinate variables

	IF (.NOT. append) THEN ! *-*-*-*-*-*-*-*-*-*-*-*-

* ... Define the feature-id variable

* ... Get the feature-id variable name and type.  If it's string, get the 
*     string-dimension lengthin maxstrlen, and buff2 is the string-dimension name.

	CALL CD_GET_VAR_INFO (dset, fvar_varid, varcode, vartype, nvdims, 
     .            vdims, nvatts, coordvar, all_outflag, status)
	IF (vartype .EQ. NF_CHAR) THEN
	   CALL CD_GET_DS_DIMS (dset, vdims(1), buff2, maxstrlen, status)

	   out_type = 'DFLT'
	   itsa_string = .TRUE.
	   
	ENDIF

* If the variable in the dataset is type string, synthesize a name for the string-length dimension.

	IF (vartype .EQ. nf_string) THEN
	
	   CALL CD_GET_DS_DIMS (dset, vdims(1), buff2, maxstrlen, status)
	   buff2 = TM_FMT(FLOAT(maxstrlen), 5, 12, slen)
	   buff2 = 'STRING1_'//buff2(:slen)
	ENDIF

	outtype = vartype
	
	CALL CDF_SET_OUT_TYPE (dset, fvar_varid, itsa_uvar, 
     .                itsa_string, out_type, outtype, status)

	grid = egrid

	DO idim = 1, nferdims
	   lo_e(idim) = unspecified_int4
	   hi_e(idim) = unspecified_int4
	ENDDO
	lo_e(e_dim) = 1
	hi_e(e_dim) = n_feat

	attname = 'cf_role'
	got_it = NC_GET_ATTRIB (
     .		  	     dset, fvar_varid, attname, .FALSE., ftrname,
     .		  	     maxlen, attlen, attoutflag, buff1, vals)

	no_id = (orientation.EQ.e_dim .AND. .NOT.got_it)   ! ?? or just .NOT.got_it ??
	
	IF (.NOT. no_id) THEN
	   CALL CD_MAKE_VAR( cdfid, dset, varcode, outtype, maxstrlen,
     .               grid, lo_e, hi_e, recdim, enhead, new, 
     .               edges_flag, do_bounds, mode_upcase_output, 
     .               keepax_flag, date_fmt_out,
     .               netcdf4_type, xchunk_size, 
     .               ychunk_size, zchunk_size, tchunk_size, 
     .               deflate_lev, shuffle_flag, endian_code, buff2,
     .               do_coords, status )

* ... Set attributes for feature-id variable

	   attname = 'long_name'
	   got_it = NC_GET_ATTRIB (
     .		  	     dset, fvar_varid, attname, .FALSE., ftrname,
     .		  	     maxlen, attlen, attoutflag, buff1, vals)

	   IF (status .NE. ferr_ok) buff1 = ftrname(:slen)//' ID'
	   lbuff = TM_LENSTR1(buff1)
	
	   CALL CD_WRITE_ATTRIB(cdfid, varcode, attname,
     .                              buff1(:lbuff), .FALSE., status )
     
	   attname = 'cf_role'
	   got_it = NC_GET_ATTRIB (
     .		  	     dset, fvar_varid, attname, .FALSE., ftrname,
     .		  	     maxlen, attlen, attoutflag, buff1, vals)

	   IF (status .NE. ferr_ok) THEN
	      status = STR_DNCASE(buff1, ftrname)
	      slen = TM_LENSTR1(buff1)
 	      buff1 = ftrname(:slen)//'_id'
	   ENDIF

	   lbuff = TM_LENSTR1(buff1)
	   CALL CD_WRITE_ATTRIB(cdfid, varcode, attname,
     .                              buff1(:lbuff), .FALSE., status )

	ENDIF  ! no_od


* ... Now define the rowSize var. It has the same output grid.
*     The way things are stored, dsg_row_size_var(dset) contains the line-memory 
*     location of the data, and dsg_row_size_varid the varid of rowSize in datast dset.
	
	varid = dsg_row_size_varid(dset)

	IF (.NOT. synthetic_rowsiz) THEN
	   CALL CD_GET_VAR_VARNAME (dset, varid, varcode, status)

	   outtype = nf_int
	   CALL CD_MAKE_VAR( cdfid, dset, varcode, outtype, maxstrlen,
     .               grid, lo_e, hi_e, recdim, enhead, new, 
     .               edges_flag, do_bounds, mode_upcase_output, 
     .               keepax_flag, date_fmt_out,
     .               netcdf4_type, xchunk_size, 
     .               ychunk_size, zchunk_size, tchunk_size, 
     .               deflate_lev, shuffle_flag, endian_code, buff2,
     .               do_coords, status )

* ... Set attributes for rowSize variable

	   attname = 'long_name'
	   buff1 = 
     .	      'Number of Observations for this '//ftrname(:TM_LENSTR1(ftrname))
	   lbuff = TM_LENSTR1(buff1)
	
	   CALL CD_WRITE_ATTRIB(cdfid, varcode, attname,
     .                              buff1(:lbuff), .FALSE., status )
     
	   attname = 'sample_dimension'
	   buff1 = line_name(line_obscoord)
	   lbuff = TM_LENSTR1(buff1)
	   CALL CD_WRITE_ATTRIB(cdfid, varcode, attname,
     .                              buff1(:lbuff), .FALSE., status )

	ENDIF  ! synthesized rowsize in incoming file


	bad = bad_val4  ! default bad value for remaining variables
	itsa_uvar = .FALSE.
	itsa_string = .FALSE.

* ... Define world-coordinate variables in x, y, z, t directions 

	DO idim = 1, 4
	   IF ( relevant_coord(idim) ) THEN

	      line = grid_line(idim, gxlate)  

*  Use the coordinate name and type from the incoming file
	      varcode = line_name_orig (line)  

	      dummy = 0
	      CALL CD_GET_VAR_TYPE (dset, dummy, varcode, vartype, status)
	      dummy = -1
	      outtype = vartype
	      CALL CDF_SET_OUT_TYPE (dset, dummy, itsa_uvar, 
     .                itsa_string, out_type, outtype, status)

	      IF (instance_coord(idim)) THEN
* ... feature coordinate

		 grid = egrid
	         CALL CD_MAKE_VAR( cdfid, dset, varcode, outtype, maxstrlen,
     .               egrid, lo_e, hi_e, recdim, enhead, new, 
     .               edges_flag, do_bounds, mode_upcase_output, 
     .               keepax_flag, date_fmt_out,
     .               netcdf4_type, xchunk_size, 
     .               ychunk_size, zchunk_size, tchunk_size, 
     .               deflate_lev, shuffle_flag, endian_code, buff2,
     .               do_coords, status )

	      ELSE
* ... obs coordinate

		 grid = ogrid
	         CALL CD_MAKE_VAR( cdfid, dset, varcode, outtype, maxstrlen,
     .               grid, lo_o, hi_o, recdim, enhead, new, 
     .               edges_flag, do_bounds, mode_upcase_output, 
     .               keepax_flag, date_fmt_out,
     .               netcdf4_type, xchunk_size, 
     .               ychunk_size, zchunk_size, tchunk_size, 
     .               deflate_lev, shuffle_flag, endian_code, buff2,
     .               do_coords, status )

	      ENDIF

* ... attributes for the coordinate variable
* Write the attributes from a dataset variable as requested by the settings 
* The title, units, and history may be updated later.

	      IF (all_outflag .GT. 0) 
     .          CALL CDF_LIST_DSETVAR_ATTS (dset, itsa_uvar, its_cdf, 
     .           varid, varcode, bad, outtype, cdfid, do_warn, 
     .           scalefac, addoff, got_title, output_title, got_history, 
     .           output_history, got_units, output_units, status)

	      IF (status .NE. ferr_ok) GOTO 5400

* Write variable title, units, title modifier, history if not already done

              CALL CDF_LIST_DEFAULT_ATTS (dset, varid, varcode, cx_none, cdfid, 
     .          outtype, all_outflag, itsa_uvar, got_title, output_title, 
     .          got_history, output_history,  got_units, output_units, status )	
	      IF (status .NE. ferr_ok) GOTO 5400   

	   ENDIF
	ENDDO  ! coordinate variables


	ENDIF   ! IF (.NOT. append) THEN  *-*-*-*-*-*-*-*-*-*-*-*-

*  Loop to create all of the variables
*  (defer writing of binary data until end) 

        dset_last = dset

	out_type = out_typ_in  ! restore incoming data-type requested
	DO 100 ivar = 1, nvars

	   IF (ivar .EQ. featr_ivar) CYCLE  ! already set up the feature-id variable

	   cx  = cx_list(ivar)
	   mr  = mr_list(ivar)
	   cat = cx_category(cx)
	   var = cx_variable(cx)
	   varcode = SANITARY_VAR_CODE( cat, var )
	   got_title = .FALSE.
	   got_units = .FALSE.
	   got_history = .FALSE.
	   output_title = .TRUE.  ! output the var long_name by default
	   output_units = .FALSE.
	   output_history = .TRUE.
	   itsa_string = cx_type(cx) .EQ. ptype_string

	   bad = mr_bad_data(mr)


* Check that they haven't asked to write the feature-id variable, rowsize, 
* or a coordinate. Those are already done.

	   CALL CD_GET_VAR_VARNAME (dset, fvar_varid, varname, status)
	   IF (STR_SAME(varcode, varname) .EQ. 0) CYCLE

	   IF (.NOT.synthetic_rowsiz) THEN
	      CALL CD_GET_VAR_VARNAME (dset, dsg_row_size_varid(dset), varname, status)
	      IF (STR_SAME(varcode, varname) .EQ. 0) CYCLE
	   ENDIF
	   
	   DO idim = 1, 4
	      IF ( relevant_coord(idim) ) THEN
	         line = grid_line(idim, gxlate)  
	         varname = line_name_orig (line)
	         IF (STR_SAME(varcode, varname) .EQ. 0) GOTO 100
	      ENDIF
	   ENDDO

* is it in the linked-list for dset. If so get attr info, including original 
* upper/lowercase form of the name. If mode upcase_output is set, then upcase 
* the variable name.
* If it is a LET/D= user-var its linked list info is with that datset.
 
* For user-defined variables, with double-precision Ferret, write as double-precision
* unless the user has requested otherwise.

	   itsa_uvar = cat .EQ. cat_user_var

	   dset = cx_data_set(cx)
	   IF (dset .EQ. pdset_irrelevant) dset = pdset_uvars
	   IF (itsa_uvar .AND. dset .LE. pdset_irrelevant)  dset = pdset_uvars

	   CALL CD_GET_VAR_ID (dset, varcode, varid, status)
	   IF (status .NE. ferr_ok) THEN
	      IF (itsa_uvar .AND. dset.GE.pdset_irrelevant) THEN
	         dset = pdset_uvars
	         CALL CD_GET_VAR_ID (dset, varcode, varid, status)
	         IF (status .NE. ferr_ok) dset = dset_last
	      ENDIF
	   ENDIF

	   vartype = 0
	   outtype = 0

	   IF (status .EQ. ferr_ok) 
     .       CALL CD_GET_VAR_INFO (dset, varid, varname, vartype, nvdims, 
     .            vdims, nvatts, coordvar, all_outflag, status)

	   varcode = varname
	   IF (mode_upcase_output) CALL STR_UPCASE( varcode, varname)

	   CALL CDF_SET_OUT_TYPE (dset, varid, itsa_uvar, 
     .                itsa_string, out_type, outtype, status)
	   IF (status .NE. ferr_ok) GOTO 5500

	   IF (cat .EQ. cat_pseudo_var)  GOTO 5600

* allowed name?
	   IF (cat .NE. cat_file_var) THEN
	      IF ( .NOT.TM_LEGAL_NAME(varcode) ) GOTO 5200
	      CALL FIND_VAR_NAME ( pdset_irrelevant, varcode, cat1, var1 )
	      IF (  var1 .NE. munknown_var_name
     .      .AND. cat1 .EQ. cat_pseudo_var    ) GOTO 5200
	   ENDIF

* if a string variable, then find max len
* If the len comes back as 0 the variable contains just null strings.
* Set maxstrlen to 1, else we cant define the variable.
	   IF (itsa_string) THEN
	      maxstrlen = GET_MAX_C_STRING_LEN(
     .				  mr_c_pointer(mr), MGRID_SIZE(mr))
	      IF (maxstrlen .LE. 0) maxstrlen = 1
	   ELSE
	      maxstrlen = 0
	   ENDIF

* create the variable and its grid (coordinate output gets deferred)

	   IF (varid .GT. 0) THEN
              CALL  CD_GET_VAR_VARNAME (dset, varid, varname, status)
              varcode = varname
              IF (mode_upcase_output) CALL STR_UPCASE( varcode, varname)
	   ENDIF

* If this is a user var the axes are based on the defining dset (if any).
	   dset_num = dset
	   IF (dset.EQ.pdset_uvars .AND. cx_data_set( cx ).GT.0)
     .        dset_num = cx_data_set( cx ) 

* Use the max string length from the originating dataset.
* buff2 is dimension name for string-length.
	   buff2 = " "
	   IF (vartype .EQ. NF_CHAR .AND. dset .GE. 1) THEN
	     buff2 = ""
	     IF (dset_num.GE.1 .AND.(.NOT.itsa_uvar)) THEN
	        CALL CD_GET_DS_DIMS (dset_num, vdims(1), buff2, len, status)
	        IF (maxstrlen .LE. len) maxstrlen = len
	     ENDIF
	   ENDIF

	   IF (instance_var(ivar) ) THEN
	      grid = egrid 
	      CALL CD_MAKE_VAR( cdfid, dset_dsg, varcode, outtype, maxstrlen,
     .               grid, lo_e, hi_e, recdim, enhead, new, 
     .               edges_flag, do_bounds, mode_upcase_output, 
     .               keepax_flag, date_fmt_out,
     .               netcdf4_type, xchunk_size, 
     .               ychunk_size, zchunk_size, tchunk_size, 
     .               deflate_lev, shuffle_flag, endian_code, buff2,
     .               do_coords, status )

	   ELSE
	      grid = ogrid
	      CALL CD_MAKE_VAR( cdfid, dset_dsg, varcode, outtype, maxstrlen,
     .               grid, lo_o, hi_o, recdim, enhead, new, 
     .               edges_flag, do_bounds, mode_upcase_output, 
     .               keepax_flag, date_fmt_out,
     .               netcdf4_type, xchunk_size, 
     .               ychunk_size, zchunk_size, tchunk_size, 
     .               deflate_lev, shuffle_flag, endian_code, buff2,
     .               do_coords, status )
	   ENDIF

	   IF ( status .NE. merr_ok ) GOTO 5800

* if its a newly-created variable write attributes
	   IF ( new ) THEN

* If the variable is to be written scaled, set the scale and offset
*  values that will be written as attributes and sent to CD_WRITE_VAR. 

	      IF (varid .GT. 0) CALL CDF_SET_SCALE (dset, varid, 
     .        do_warn, scalefac, addoff, ferr_ok, status)

* Write the attributes from a dataset variable as requested by the settings 
* The title, units, and history may be updated later.
* (If a file variable came in with an "axis" attribute, the DSG file won't be 
*  correct - axis atts are only on coordinates - so don't write that attrib.)
	      
              CALL CD_GET_VAR_ATT_ID (dset, varid, "axis", attid, status)
	      IF (attid.GT.0 .AND. dset.GT.pdset_irrelevant) CALL CD_SET_ATT_FLAG(dset, varid, "axis", 0, status)

	      IF (all_outflag.GT.0 .AND. varid.GT.0) 
     .          CALL CDF_LIST_DSETVAR_ATTS (dset, itsa_uvar, its_cdf, 
     .           varid, varcode, bad, outtype, cdfid, do_warn,  
     .           scalefac, addoff, got_title, output_title, got_history, 
     .           output_history, got_units, output_units, status)

	      IF (status .NE. ferr_ok) GOTO 5400

* Write variable title, units, title modifier, history if not already done
	      CALL CDF_LIST_DEFAULT_ATTS (dset, varid, varcode, cx, cdfid, 
     .          outtype, all_outflag, itsa_uvar, got_title, output_title, 
     .          got_history, output_history,  got_units, output_units, status )	
	      IF (status .NE. ferr_ok) GOTO 5400   

	   ENDIF  ! writing attributes of file or user variables

 100    CONTINUE  ! loop over nvars

	nready = nvars

	dset = dset_dsg

*****
* Finally, write all of the coordinates and data values -- in netCDF DATA mode
* Note that this block of code is also executed following an error to
* ensure that all deferred coordinates and "ready" variables are flushed
 400	flushed = .TRUE.	! errors from here to exit may leave corrupted file
*
* ...  write the deferred coordinates
*
	IF (.NOT. append) THEN
	   CALL CD_WRITE_DEFER_COORD( cdfid, status )
	   IF ( status .NE. merr_OK ) GOTO 5800
	ENDIF

* ...
* ...
* ... Now write all the data

* ... when appending, do not write the DSG feature, rowSize or coordinate variables

	IF (.NOT. append) THEN  !*-*-*-*-*-*-*-*-*-*-*-*-

*     DSG-specific variables
	
* ... The masked feature ID's
* ... Mask the feature-id variable for writing
	
*	which mr goes with feature-var
	
	IF (.NOT. no_id) THEn
	   CALL MASK_DSG_FVAR ( nfeatures, process_feature, dset, 
     .              memry(featr_mr)%ptr, lineedg(line_fcoord)%ptr )

	   DO idim = 1, nferdims
	       write_lo(idim) = unspecified_int4
	       write_hi(idim) = unspecified_int4
	   ENDDO
	   write_lo(e_dim) = 1
	   write_hi(e_dim) = n_feat

	   CALL CD_GET_VAR_VARNAME (dset, fvar_varid, varcode, status)

           grid = egrid
	   CALL CD_WRITE_DSG_DATA (cdfid, varcode, grid, 
     .                 write_lo, write_hi, lineedg(line_fcoord)%ptr, 
     .                 mode_upcase_output, bad, status )

	ENDIF  ! no_id

* ... Compute the output obs len to write using RowSizes of masked data 
*     values; mask may select only part of a given feature

	IF (.NOT. synthetic_rowsiz) THEN
	   row_size_lm = dsg_loaded_lm(dsg_row_size_var(dset))

	   count = 0
	   base = 0     ! obs index at end of preceding feature  
	   DO ifeature = 1, nfeatures
	      nobsf = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
	      IF (process_feature(ifeature)) THEN
	         count = count + 1

* ... get observation-level mask for this feature
*      and compute the number of obs from features after masking

	         CALL MAKE_DSG_OBS_MASK(dset, cx, ifeature, base, process_obs, nobsf)
	         fobs = 0
	         DO iobs = 1, nobsf
	            IF (process_obs(iobs)) fobs = fobs + 1
	         ENDDO

	         val = fobs
	         CALL PUT_LINE_COORD(lineedg(line_fcoord)%ptr, count, val)
	      ENDIF
	      base = base + nobsf
	   ENDDO
	
	   CALL CD_GET_VAR_VARNAME (dset, dsg_row_size_varid(dset), varcode, status)

* ... Same grid as the feature-id variable
           grid = egrid
	   CALL CD_WRITE_DSG_DATA (cdfid, varcode, grid, 
     .                 write_lo, write_hi, lineedg(line_fcoord)%ptr, 
     .                 mode_upcase_output, bad, status )

	ENDIF  ! synthetic_rowsiz


* ... Now the coordinate variables with mask applied

	DO idim = 1, 4
	   IF ( relevant_coord(idim) ) THEN

	      line = grid_line(idim, gxlate)  
	      varcode = line_name_orig (line)  

* ... instance coordinates
	      IF (instance_coord(idim)) THEN

		 grid = egrid
		 DO i = 1, nferdims
	            write_lo(i) = unspecified_int4
		    write_hi(i) = unspecified_int4
		 ENDDO
		 write_lo(e_dim) = 1
		 write_hi(e_dim) = n_feat

		 CALL MASK_DSG_FVAR (nfeatures, process_feature, dset, 
     .              dsg_linemem(coord_lm(idim))%ptr, lineedg(line_fcoord)%ptr)

		 CALL CD_WRITE_DSG_DATA (cdfid, varcode, grid, 
     .                 write_lo, write_hi, lineedg(line_fcoord)%ptr, 
     .                 mode_upcase_output, bad, status )

* ... obs coordinates.  nmasked returned by mask_dsg_obsvar is the same as n_obs.
	      ELSE

		 grid = ogrid
		 DO i = 1, nferdims
	            write_lo(i) = unspecified_int4
		    write_hi(i) = unspecified_int4
		 ENDDO

		 write_lo(orientation) = 1
		 write_hi(orientation) = n_obs 
		 
		 IF (synthetic_rowsiz) THEN
		    CALL CD_WRITE_DSG_DATA (cdfid, varcode, grid, 
     .                 write_lo, write_hi, dsg_linemem(coord_lm(idim))%ptr, 
     .                 mode_upcase_output, bad, status )
		 ELSE
                   CALL MASK_DSG_OBSVAR (nfeatures, process_feature, process_obs,
     .               dsg_linemem(row_size_lm)%ptr, dset, cx,
     .               dsg_linemem(coord_lm(idim))%ptr, lineedg(line_obscoord)%ptr, 
     .               nmasked)

                   CALL CD_WRITE_DSG_DATA (cdfid, varcode, grid, 
     .                 write_lo, write_hi, lineedg(line_obscoord)%ptr, 
     .                 mode_upcase_output, bad, status )
		 ENDIF

	      ENDIF

	   ENDIF  ! relevant_coord

	ENDDO     ! idim


	ENDIF   ! IF (.NOT. append) THEN *-*-*-*-*-*-*-*-*-*-*-*-


*
* write the variables
*
	DO 500 ivar = 1, nready

	   IF (ivar .EQ. featr_ivar) CYCLE  ! already wrote up the feature-id variable

	   cx  = cx_list(ivar)
	   mr  = mr_list(ivar)
	   grid	= cx_grid( cx )
	   dset_num = cx_data_set( cx )
	   cat = cx_category(cx)
	   var = cx_variable(cx)
	   bad = mr_bad_data(mr)
	   varcode = SANITARY_VAR_CODE( cat, var )
	   itsa_uvar = cat .EQ. cat_user_var

	   dset = dset_dsg

* Check that they haven't asked to write the feature-variable, rowsize, 
* or a coordinate. Those are already done.

           CALL CD_GET_VAR_VARNAME (dset, fvar_varid, varname, status)
	   IF (STR_SAME(varcode, varname) .EQ. 0) CYCLE

	   IF (dset .GT. pdset_irrelevant .AND. .NOT.synthetic_rowsiz) THEN
	      CALL CD_GET_VAR_VARNAME (dset, dsg_row_size_varid(dset), varname, status)
	      IF (STR_SAME(varcode, varname) .EQ. 0) CYCLE
	   ENDIF

	   DO idim = 1, 4
	      IF ( relevant_coord(idim) ) THEN
	         line = grid_line(idim, gxlate)  
	         varname = line_name_orig (line)
	         IF (STR_SAME(varcode, varname) .EQ. 0) GOTO 500 
	      ENDIF
	   ENDDO


* For user-defined variables, with double-precision Ferret, write as double-precision
* unless the user has requested otherwise.  Use the same upper- or lower-case spelling
* as when the variable was created above.

	   itsa_uvar = cat .EQ. cat_user_var

	   dset = cx_data_set(cx)
	   IF (dset .EQ. pdset_irrelevant) dset = pdset_uvars
	   IF (itsa_uvar .AND. dset .LE. pdset_irrelevant)  dset = pdset_uvars

	   CALL CD_GET_VAR_ID (dset, varcode, varid, status)
	   IF (status .NE. ferr_ok) THEN
	      IF (itsa_uvar .AND. dset.GE.pdset_irrelevant) THEN
	         dset = pdset_uvars
	         CALL CD_GET_VAR_ID (dset, varcode, varid, status)
	         IF (status .NE. ferr_ok) dset = dset_last
	      ENDIF
	   ENDIF

	   vartype = 0
	   outtype = 0
 
	   IF (status .EQ. ferr_ok) 
     .       CALL CD_GET_VAR_INFO (dset, varid, varname, vartype, nvdims, 
     .            vdims, nvatts, coordvar, all_outflag, status)
     
	   varcode = varname
	   IF (mode_upcase_output) CALL STR_UPCASE( varcode, varname)

* check for interrupts - dont check again until entire variable is written
	   IF (interrupted) CALL ERRMSG(ferr_interrupt,status,' ',*5800)


* write the data for this variable

	   IF (instance_var(ivar) ) THEN
	      grid = egrid
	      
	      DO i = 1, nferdims
	         write_lo(i) = unspecified_int4
	         write_hi(i) = unspecified_int4
	      ENDDO
	      write_lo(e_dim) = 1
	      write_hi(e_dim) = n_feat

	      CALL MASK_DSG_FVAR ( nfeatures, process_feature, dset_dsg, 
     .              memry(mr)%ptr, lineedg(line_fcoord)%ptr )

	      CALL CD_WRITE_DSG_DATA (cdfid, varcode, grid, 
     .                 write_lo, write_hi, lineedg(line_fcoord)%ptr, 
     .                 mode_upcase_output, bad, status )

	   ELSE
	      grid = ogrid
	      DO i = 1, nferdims
	         write_lo(i) = unspecified_int4
	         write_hi(i) = unspecified_int4
	      ENDDO
	      write_lo(orientation) = 1
	      write_hi(orientation) = n_obs

	      IF (synthetic_rowsiz) THEN
		 val = n_obs  ! stand-in for rowsize
		 CALL MASK_DSG_OBSVAR ( nfeatures, process_feature, process_obs,
     .               val, dset_dsg, cx, 
     .               memry(mr)%ptr, lineedg(line_obscoord)%ptr, nmasked )
	      ELSE
	        CALL MASK_DSG_OBSVAR ( nfeatures, process_feature, process_obs,
     .               dsg_linemem(row_size_lm)%ptr, dset_dsg, cx, 
     .               memry(mr)%ptr, lineedg(line_obscoord)%ptr, nmasked )
	      ENDIF

	      CALL CD_WRITE_DSG_DATA (cdfid, varcode, grid, 
     .                 write_lo, write_hi, lineedg(line_obscoord)%ptr, 
     .                 mode_upcase_output, bad, status )

	   ENDIF

	 IF ( status .NE. merr_ok ) GOTO 5800
 500	CONTINUE

* close the file

        cdfstat = NF_CLOSE(cdfid)
        IF ( cdfstat .NE. NF_NOERR ) CALL TM_ERRMSG
     .     ( cdfstat+pcdferr, status, 'CDF_LIST', unspecified_int4,
     .     no_varid, 'could not close CDF output file: ',
     .     fname, *5000 )


* final completion -- maybe after an error
	status = final_status

	mode_upcase_output = mode_up_in
 5000	CONTINUE

* Deallocate the temporary grids and axes used (as in RESET_DSG)
	IF (egrid .NE. mgrid_buff) CALL TM_DEALLO_DYN_GRID( egrid )
	IF (ogrid .NE. mgrid_buff) CALL TM_DEALLO_DYN_GRID( ogrid )

	IF (line_fcoord .NE. mnormal) CALL FREE_LINE_DYNMEM (line_fcoord)
	IF (line_obscoord .NE. mnormal) CALL FREE_LINE_DYNMEM (line_obscoord)

	RETURN

* error exit(s)

 4200	CALL ERRMSG ( ferr_invalid_command, status,
     .        'Writing to DSG file: variables must all be from the same DSG dataset: '//varcode,
     .        *5000 )
 4300	CALL ERRMSG ( ferr_invalid_command, status,
     .        'Writing to DSG file: Subset or mask results in no data: '//varcode,
     .        *5000 )

 4400	CALL ERRMSG ( ferr_invalid_command, status,
     .        'Appending DSG variable to file that is not DSG or different featureType',
     .        *5000 )

 4500	CALL ERRMSG ( ferr_invalid_command, status,
     .        'Appending to DSG file: Size of '//varname(:TM_LENSTR1(varname))//
     .        ' dimension does not match dimension in file: '//varcode,
     .        *5000 )

 5100    CALL ERRMSG ( ferr_invalid_command, status,
     .                 'Writing to DSG file but feature-type is not set: '//varcode,
     .                 *5800 )

 5200    CALL ERRMSG ( ferr_syntax, status,
     .                 'illegal output variable name: '//varcode,
     .                 *5210 )

 5210    CALL TM_NOTE(
     .    'Name must use letters and digits beginning with a letter',
     .                 err_lun )
         CALL TM_NOTE( 'X,Y,Z,Y,I,J,K,L,XBOX,... are reserved names',
     .                 err_lun )
         CALL TM_NOTE( 'Use the LET command to define a legal name',
     .                 err_lun )
         GOTO 5800
 5220    CALL ERRMSG ( ferr_syntax, status,
     .                 'error writing variable: '//varcode,
     .                 *5800 )

 5400    CALL ERRMSG ( ferr_TMAP_error, status, ' ', *5000 )

 5500    CALL ERRMSG ( ferr_TMAP_error, status,
     .                 'unable to set variable type for output: '//varcode,
     .                 *5800 )

 5600    CALL ERRMSG ( ferr_invalid_command, status,
     .                 'Writing psedo-variables to DSG files is not implemented: '//varcode,
     .                 *5800 )

 5800   CALL ERRMSG ( ferr_TMAP_error, final_status, ' ', *5810 )
 5810	nready = ivar - 1
	IF (.NOT.flushed) GOTO 400 ! yea ... a bit of spagetti code ... 

	cdfstat = NF_CLOSE(cdfid)
	GOTO 5000
	
	END

	SUBROUTINE CD_GET_CALENDAR_NAME (calname, ok_cal)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*.
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Given a string with a calendar name, match the first 3 characters 
* with the list of allowed names or with the words STANDARD or 
* PROLEPTIC_GREGORIAN and return the standard name.
* v744 11/2011 *acm* Issue 1906: If PROLEPTIC_GREGORIAN is given then 
*                  override mixed-gregorian calendar handling. 

* Include files
        include 'calendar.decl'
        include 'calendar.cmn'
        include 'errmsg.parm'
        include 'xio.cmn_text'

* Argument declarations
	LOGICAL ok_cal
	CHARACTER*(*) calname

* Internal variables
	INTEGER STR_UPCASE, TM_LENSTR1, i, istat, ncal, slen
	CHARACTER*65 allcals

	INTEGER tt  ! nice short name
	EQUIVALENCE (tt,lunit_errors)

	istat = STR_UPCASE (calname, calname)

	IF (calname(1:3) .EQ. '360') calname = '360_DAY' 
	IF (calname .EQ. 'STANDARD') calname = 'GREGORIAN' 
	IF (calname(1:6) .EQ. 'PROLEP') calname = 'PROLEPTIC_GREGORIAN' 
	IF (calname(1:6) .EQ. 'COMMON') calname = 'NOLEAP' 
	IF (calname(1:3) .EQ. '365') calname = 'NOLEAP' 
	IF (calname(1:3) .EQ. '366') calname = 'ALL_LEAP' 

	ok_cal = .FALSE.
	ncal = 1
	allcals = " "

	DO 100 i = 1, mxcals
	   slen = TM_LENSTR1( allowed_calendars(i) )
	   allcals(ncal:) = allowed_calendars(i)(:slen)//','
	   ncal = ncal + slen + 1

	   IF (calname(1:3) .EQ. allowed_calendars(i)(1:3) ) THEN
              ok_cal = .TRUE.
              calname = allowed_calendars(i)
	      GOTO 120
	   ENDIF
  100	CONTINUE
	
        slen = TM_LENSTR1( allcals)
	CALL TM_NOTE('Valid calendars are '//allcals(:slen-1), tt)

  120	CONTINUE
	RETURN
	END

c*
c* ef_get_one_val_sub_sub.F
c*
c* Jonathan Callahan
c* Dec 17th 1997
c*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
c*
c*
c* This subroutine extracts a single value from a memory block.
c*
c* Currently, no checking is done.
c*

      SUBROUTINE EF_GET_ONE_VAL_SUB_SUB(data, lox, hix, loy, hiy,
     .                    loz, hiz, lot, hit, loe, hie, lof, hif, 
     .                    value, status)

      IMPLICIT NONE
      INTEGER status, lox, hix, loy, hiy, loz, hiz,
     .                lot, hit, loe, hie, lof, hif
      REAL data(lox:hix, loy:hiy, loz:hiz, lot:hit, loe:hie, lof:hif)
      REAL value

      value = data(lox, loy, loz, lot, loe, lof)

      RETURN
      END

      SUBROUTINE CD_GET_CHUNK_CACHE (cache_size, cache_nelems, 
     .    cache_preemption, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Get current chunk cache settings. 

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP

* revision 0.0 - 1/2010

      INCLUDE 'netcdf.inc'
      INCLUDE 'netcdf4_settings.cmn'
      INCLUDE 'tmap_errors.parm'

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

* argument declarations:
      INTEGER cache_size, cache_nelems, cache_preemption, status

* local variable declarations:
      INTEGER cdfstat

C Get the cache size for the files to be opened in this session.

C Get chunk cache sizes.
#ifdef usingDODSf2cUnderscore
      cdfstat = NF_GET_CHUNK_CACHE_(cache_size, cache_nelems, 
     .     cache_preemption)
#else
      cdfstat = NF_GET_CHUNK_CACHE(cache_size, cache_nelems, 
     .     cache_preemption)
#endif

      IF (cdfstat .NE. NF_NOERR) GOTO 5100 

C If it hasnt been done yet, save the default value
      IF (default_cache_size .EQ. 0) default_cache_size = cache_size

      status = merr_ok
 5000 RETURN
 5100 CALL TM_ERRMSG (cdfstat+pcdferr, status, 'CD_SET_CHUNK_CACHE',
     .     no_descfile, no_stepfile, 
     .    'Getting chunk cache settings',
     .     no_errstring, *5000 )
      END

	LOGICAL FUNCTION GEOG_LABEL( idim, grid )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine whether a particular axis of a grid represents geographical
* locations (lat.,long., etc.) requiring special label formatting

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 2/25/88
* V230: 4/92 *sh*  only return .TRUE. for time axis if t0_date is valid
*       7/92 - use TM_DATE_OK for this
*            - vertical axis requires meters units AND UD orientation
* V320: 12/19/94 - recognize millibars and decibars as special axes
* v491: 2/23/98 *kob* - add check for undefined axis which can cause
*                       a crash if REPEAT command doesn't have fully 
*                       mature context to work with.
* V530: *acm* 12/00 alternative calendar types; cal_id
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
*                  Allow for F to be a time axis.


        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
        include 'tmap_errors.parm'
	external xgt_grid_data
        include 'xunits.cmn_text'
        external xunits_data
	include 'ferret.parm'
	include 'xtext_info.cmn'
	include 'xprog_state.cmn'

* calling argument declarations:
	INTEGER		idim, grid

* internal variable declarations:
        LOGICAL         TM_DATE_OK
	INTEGER		TM_GET_CALENDAR_ID, cal_id, i, line
	CHARACTER*2	line_code

* check for program bug	! temp
	IF ( grid .EQ. unspecified_int4 ) STOP 'no_grd_orient'

* see if labeling modes are disabled, first
	IF ( .NOT.ax_fmt(idim) ) THEN
	   GEOG_LABEL = .FALSE.
           RETURN
	ENDIF

* initialize
	line = grid_line( idim, grid )
* 2/98 *kob* add check for undefined axis 
	IF ( line .EQ. mnormal .OR. line .EQ. munknown 
     .         .OR. line .EQ. unspecified_int4) THEN
	   GEOG_LABEL = .FALSE.
	   RETURN
	ELSE
	   line_code = line_direction( line )
	ENDIF

* the use of line_direction is kludgy
* (it combines orientation, reversal, and formatting in an inadequate way)
        IF ( idim .LE. 2 ) THEN
           GEOG_LABEL = line_code .EQ. axis_orients(idim)
        ELSEIF ( idim .EQ. z_dim ) THEN
* for Z also insist on units of m because DU/UD is used to indicate reversal
           GEOG_LABEL =((line_code .EQ. 'UD'
     .            .AND. line_unit_code(line) .EQ. pun_meters)
     .    .OR.		(line_code .EQ. 'UD'
     .		   .AND. line_unit_code(line) .EQ. pun_millibars)
     .    .OR.		(line_code .EQ. 'UD'
     .		   .AND. line_unit_code(line) .EQ. pun_decibars) )
        ELSE
*  4/92 addition:  check for valid time axis T0

*  1/01 addition: cal_id
           cal_id = TM_GET_CALENDAR_ID (line_cal_name(line))
           GEOG_LABEL = (line_code.EQ.'TI' .OR. line_code.EQ.'FI')
     .            .AND. TM_DATE_OK( line_t0(line), cal_id )
        ENDIF

	RETURN
	END

	SUBROUTINE  W_ON_UV( ufuw, mufuw,
     .			     vfvn, mvfvn,
     .			     w_u , mw_u )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute W ( vertical velocity ) on UV columns via zero divergence condition

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 -1/21/87 extracted from SUBROUTINE CLINIC
*			with major modifications to convert i-k oriented
*			calculations to i-j oriented calculations
* V200:  7/27/89 - 4D symmetrical version
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN

#ifdef unix
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl.parm'		! parameter definitions
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xonedim.cmn'	! geometric constants
	include 'xcontext.cmn'
#else
	INCLUDE 'FERRET_CMN:FERRET.PARM'
	INCLUDE 'FERRET_CMN:GFDL.PARM'		! parameter definitions
	INCLUDE	'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE	'FERRET_CMN:XMEM_SUBSC.CMN'
	INCLUDE 'FERRET_CMN:XONEDIM.CMN'	! geometric constants
	INCLUDE 'FERRET_CMN:XCONTEXT.CMN'
#endif

* calling argument declarations:
	INTEGER	mufuw, mvfvn, mw_u

* subscript ranges from memory variable table ...
	REAL    ufuw( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit ),
     .		vfvn( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,m2lot:m2hit ),
     .		 w_u( m3lox:m3hix,m3loy:m3hiy,m3loz:m3hiz,m3lot:m3hit )

* internal variable declarations:
	INTEGER	i_lo, i_hi, j_lo, j_hi, i, j, k, l
	REAL	bad_ufuw, bad_vfvn, bad_w_u, factor

* --- end of introductory code ---

* limits for calculation
	i_lo = mr_lo_s1(mw_u)
	i_hi = mr_hi_s1(mw_u)
	j_lo = mr_lo_s2(mw_u)
	j_hi = mr_hi_s2(mw_u)

* flag for bad/missing data
	bad_ufuw = mr_bad_data( mufuw )
	bad_vfvn = mr_bad_data( mvfvn )
	bad_w_u  = mr_bad_data( mw_u )

* ***************************************************************
* ORIGINAL GFDL 205 CODE UPON WHICH CALCULATION IS BASED
*
* 700  C   TRANSFER THINGS IN PREPARATION FOR NEXT CALL
* 701  C
* 702        FACTOR=CS(J)*DYU(J)*CSR(J+1)*DYUR(J+1)
* 703        DO 644 K=1,KM
* 704        DO 644 I=1,IMT
* 705        FVSU(I,K)=FVN(I,K)*FACTOR
* 706   644  CONTINUE

* 214  C   COMPUTE VERTICAL VELOCITY IN U,V COLUMNS
* 215  C
* 216        DO 250 K=1,KM
* 217        DO 250 I=1,IMT
* 218        W(I,K+1)=C2DZ2D(I,K)*((FUW(I+1,K)-FUW(I,K))*DXU2R2D(I,K)+FVN(I,K)
* 219       1    -FVSU(I,K))
* 220   250  CONTINUE
* 221        DO 255 K=1,KM
* 222        DO 255 I=1,IMT
* 223        W(I,K+1)=W(I,K)+W(I,K+1)
* 224   255  CONTINUE
*************************************************************************
	DO 2000 l = mr_lo_s4(mw_u), mr_hi_s4(mw_u)
	DO 2000 k = mr_lo_s3(mw_u), mr_hi_s3(mw_u)

C   COMPUTE VERTICAL VELOCITY IN U,V COLUMNS
* first compute incremental dW for this layer
	DO 250 j = j_lo, j_hi
	   IF ( j .GT. 1 ) factor = cs(j-1) * dyu(j-1) * csr(j) * dyur(j)
	DO 250 i = i_lo, i_hi

	   IF ( j .EQ. 1 .OR. i .EQ. im ) THEN
	      w_u(i,j,k,l) = bad_val4
	      GOTO 250
	   ENDIF

	   IF ( ufuw(i  ,j  ,k,l) .EQ. bad_ufuw
     .	    .OR.ufuw(i+1,j  ,k,l) .EQ. bad_ufuw
     .	    .OR.vfvn(i  ,j  ,k,l) .EQ. bad_vfvn
     .	    .OR.vfvn(i  ,j-1,k,l) .EQ. bad_vfvn ) THEN

	      w_u(i,j,k,l) = bad_val4

	   ELSE

	      w_u(i,j,k,l) = c2dz(k)*
     .			( (ufuw(i+1,j,k,l)-ufuw(i,j,k,l)) * dxu2r(i) 
     .			 + vfvn(i,j,k,l) - (factor * vfvn(i,j-1,k,l)) )

	   ENDIF

 250	CONTINUE

* now add this dW to w's from above
	IF ( k .GT. 1 ) THEN
	   DO 255 j = j_lo, j_hi
	   DO 255 i = i_lo, i_hi

	      IF ( w_u(i,j,k-1,l) .EQ. bad_w_u ) THEN

	         w_u(i,j,k,l) = bad_val4

	      ELSE

	         w_u(i,j,k,l) = w_u(i,j,k-1,l) + w_u(i,j,k,l)

	      ENDIF

 255	   CONTINUE

	ENDIF

 2000	CONTINUE

	RETURN
	END

	SUBROUTINE STMNMX(X,NSIZE,XMIN1,XMAX1,YMIN1,YMAX1)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* revised for TMAP
* from PPLUS :
*	Directory PMEL:[PLOT5.PPLV11.PLOT]MINMAX.FOR

* search for "TMAP" to find all revisions
* *sh* - 1/27/89 corrected bug: min/max search improperly rejects LIMITs points
* *sh* - 12/8/93 corrected bug: vectors blow on divied by zero attempt
* *jd* - 4.20.99 Don't delete symbols {X,Y}{MIN,MAX} in overlay plots
* V580 *acm* 8/04  Allow for PPL POLYGON as well as PPL FILLPOL after a POLY/SET command.
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long
* v695 9/15 *acm* write values to PPL* symbols using 6 digits not 4

	DIMENSION X(NSIZE)
C**
C**    @(#)minmax.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'lines_inc.decl'
        include 'LINES.INC'
        include 'data_inc.decl'
        include 'DATA.INC'
        include 'miss_inc.decl'
        include 'MISS.INC'
	include 'hd_inc.decl'
	include 'HD.INC'
        include 'switch_inc.decl'
        include 'SWITCH.INC'
        include 'pltl_inc.decl'
        include 'PLTL.INC'

	CHARACTER SYM*120,VAL*10
C
	SYM='*PPL$LINE_COUNT'
	WRITE(VAL,'(I2)')LINEN
	CALL PUTSYM(SYM,VAL,2,IER)
C
	IF(LINEN.EQ.0)THEN
C
C	CONTOUR FORM
C
*jd*begin
	    IF (.NOT.SOVER) THEN
	       SYM='*PPL$XMIN'
	       CALL PUTVAL(SYM,XMIN1,7,IER)
C       
	       SYM='*PPL$XMAX'
	       CALL PUTVAL(SYM,XMAX1,7,IER)
C       
	       SYM='*PPL$YMIN'
	       CALL PUTVAL(SYM,YMIN1,7,IER)
C       
	       SYM='*PPL$YMAX'
	       CALL PUTVAL(SYM,YMAX1,7,IER)
	    ENDIF
*jd*end

c	find the min and max and the locations of them
c
	    ZMIN=1.E38
            ZMAX=-ZMIN
	    jmn=1
	    jmx=1
	    imx=1
	    imn=1
	    if(jtype.eq.-1)then
		ivlen=nx*ny
	    else
		ivlen=nx*ny+nx+ny
	    endif
            DO 300 I=1,NX
            DO 300 J=1,NY
		if(jtype.ge.0)then
* TMAP mods begin:
* note: a major bug still exists here: X and Y screening set by LIMITS command
*	are ignored
*  LIMITS screening test for jtype.ge.0 moved from below
                    XT=X(NX*(J-1)+I)
        	    IF(ZLE.AND.XT.LE.CMZLE)GOTO 300
        	    IF(ZEQ.AND.XT.EQ.CMZEQ)GOTO 300
        	    IF(ZGE.AND.XT.GE.CMZGE)GOTO 300
		else
                    xtt1=x(nx*(j-1)+i)
                    xtt2=x(ivlen+nx*(j-1)+i)
*  ... LIMITS screening test for vector plots modified
!	old code:   if (xtt1.ge.1.e35 .or. xtt2.ge.1.e35) goto 300
        	    IF(ZLE.AND.xtt1.LE.CMZLE)GOTO 300
        	    IF(ZEQ.AND.xtt1.EQ.CMZEQ)GOTO 300
        	    IF(ZGE.AND.xtt1.GE.CMZGE)GOTO 300
        	    IF(ZLE.AND.xtt2.LE.CMZLE)GOTO 300
        	    IF(ZEQ.AND.xtt2.EQ.CMZEQ)GOTO 300
        	    IF(ZGE.AND.xtt2.GE.CMZGE)GOTO 300
		    xt=sqrt(xtt1**2+xtt2**2)
		endif
* end of TMAP mod
        	IF(XT.LT.ZMIN)then
		    ZMIN=XT
		    jmn=j
		    imn=i
		endif
        	IF(XT.GT.ZMAX)then
		    ZMAX=XT
		    jmx=j
		    imx=i
		endif
300         CONTINUE
	    if(abs(jtype).eq.2)then
		ivlen=nx*ny
		xhigh=x(ivlen+imx)
		xlow=x(ivlen+imn)
c
		ivlen=ivlen+nx
		yhigh=x(ivlen+jmx)
		ylow=x(ivlen+jmn)
	    else
!*sh*		dx=(xmax-xmin)/(nx-1)
		dx=(xmax-xmin)/MAX(nx-1,1)
		xhigh=xmin+dx*(imx-1)
		xlow=xmin+dx*(imn-1)
c
!*sh*		dy=(ymax-ymin)/(ny-1)
		dy=(ymax-ymin)/MAX(ny-1,1)
		yhigh=ymin+dy*(jmx-1)
		ylow=ymin+dy*(jmn-1)
	    endif
c
	    SYM='*PPL$ZMIN'
	    CALL PUTVAL(SYM,ZMIN,7,IER)
C
	    SYM='*PPL$ZMAX'
	    CALL PUTVAL(SYM,ZMAX,7,IER)
c
	    sym='*PPL$XHIGH'
	    call putval(sym,xhigh,7,IER)
c
	    sym='*PPL$YHIGH'
	    call putval(sym,yhigh,7,IER)
c
	    sym='*PPL$XLOW'
	    call putval(sym,xlow,7,IER)
c
	    sym='*PPL$YLOW'
	    call putval(sym,ylow,7,IER)

C       Don't define line symbols for FILLPOL/POLYGON
	ELSE if (makep .ne. 'FILLPOL' .AND. makep .ne. 'POLYGON') then
C
C	LINE DATA

	    WRITE(SYM,998)'XMIN',LINEN
998	    FORMAT('*PPL$',A,'(',I2,')')
	    CALL PUTVAL(SYM,XMIN1,7,IER)
C
	    WRITE(SYM,998)'XMAX',LINEN
	    CALL PUTVAL(SYM,XMAX1,7,IER)
C
	    WRITE(SYM,998)'YMIN',LINEN
	    CALL PUTVAL(SYM,YMIN1,7,IER)
C
	    WRITE(SYM,998)'YMAX',LINEN
	    CALL PUTVAL(SYM,YMAX1,7,IER)

* If its a ribbon plot, we need the min and max of the color-by variable.
	    IF (linen .EQ. 2) THEN
	       zmin = ymin1
	       zmax = ymax1
	    ENDIF

C
C	SET FIRST - LAST VALUES
C
	    IBASEX=0
	    IBASEY=NSIZE/2
	    DO 10 I=1,LINEN-1
	    LEN=LLENG(I)
	    IBASEX=IBASEX+LEN
	    IBASEY=IBASEY+LEN
10	    CONTINUE
	    LEN=LLENG(LINEN)
	    DO 20 J=1,LEN
	    IF((XLE.AND.X(IBASEX+J).LE.CMXLE).OR.
     *		(XEQ.AND.X(IBASEX+J).EQ.CMXEQ).OR.
     *		(XGE.AND.X(IBASEX+J).GE.CMXGE).OR.
     *		(YLE.AND.X(IBASEY+J).LE.CMYLE).OR.
     * 	(YEQ.AND.X(IBASEY+J).EQ.CMYEQ).OR.
     *		(YGE.AND.X(IBASEY+J).GE.CMYGE))GOTO 20
	    XT=X(IBASEX+J)*XFCT(I)+XOFF(I)
	    YT=X(IBASEY+J)*YFCT(I)+YOFF(I)
	    WRITE(SYM,998)'XFIRST',LINEN
	    CALL PUTVAL(SYM,XT,7,IER)
	    WRITE(SYM,998)'YFIRST',LINEN
	    CALL PUTVAL(SYM,YT,7,IER)
	    GOTO 30	
20	    CONTINUE
30	    DO 40 J=LEN,1,-1
	    IF((XLE.AND.X(IBASEX+J).LE.CMXLE).OR.
     *		(XEQ.AND.X(IBASEX+J).EQ.CMXEQ).OR.
     *		(XGE.AND.X(IBASEX+J).GE.CMXGE).OR.
     *		(YLE.AND.X(IBASEY+J).LE.CMYLE).OR.
     *		(YEQ.AND.X(IBASEY+J).EQ.CMYEQ).OR.
     *		(YGE.AND.X(IBASEY+J).GE.CMYGE))GOTO 40
	    XT=X(IBASEX+J)*XFCT(I)+XOFF(I)
	    YT=X(IBASEY+J)*YFCT(I)+YOFF(I)
	    WRITE(SYM,998)'XLAST',LINEN
	    CALL PUTVAL(SYM,XT,7,IER)
	    WRITE(SYM,998)'YLAST',LINEN
	    CALL PUTVAL(SYM,YT,7,IER)
	    GOTO 50
40	    CONTINUE
	ENDIF
50	RETURN
	END

      SUBROUTINE STRING_CONDITIONAL (operation, num_com, com_cx,
     .				 com1, mr1,
     .				 com2, mr2,
     .				 com3, mr3,
     .				 res, mres )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* perform a conditional choice on string variables
!   IF cond THEN string1_array ELSE string2_array

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V533 *sh* 7/01 - based upon OPERATE.F
* V67  *acm 3/11 - Fix bugs 1764,1795 (copy/paste errors in setting up 3rd component)
* V671 7/11  *acm* Ticket 1868 IFV - masking expressions with ifValid, treating 
*		   zero as valid. 
*		   (String expressions with IFV are identical to behavior with IF.)
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V751 11/19 *acm* fix copy-paste bug in ELSE

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include 'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xcontext.cmn'

* calling argument declarations:
	INTEGER	operation, num_com, com_cx(4), mr1, mr2, mr3, mres, i3, n2
	REAL    com1( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit,m1loe:m1hie,m1lof:m1hif )
        REAL*8	com2( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,m2lot:m2hit,m2loe:m2hie,m2lof:m2hif ),
     .  	com3( m3lox:m3hix,m3loy:m3hiy,m3loz:m3hiz,m3lot:m3hit,m3loe:m3hie,m3lof:m3hif ),
     .  	res( m5lox:m5hix,m5loy:m5hiy,m5loz:m5hiz,m5lot:m5hit,m5loe:m5hie,m5lof:m5hif )

* internal variable declarations:
	INTEGER CX_DIM_LEN,
     .          i, j, k, l, m, n, icom, idim,
     .		i1, j1, k1, l1, m1, n1, i2, j2, k2, l2, m2, n2
     .		i3, j3, k3, l3, m3, n3,
     .		di1, dj1, dk1, dl1, dm1, dn1, 
     .		di2, dj2, dk2, dl2, dm2, dn2,
     .		di3, dj3, dk3, dl3, dm3, dn3,
     .		si1, sj1, sk1, sl1, sm1, sn1, 
     .		si2, sj2, sk2, sl2, sm2, sn2,
     .		si3, sj3, sk3, sl3, sm3, sn3, 
     .          op
        REAL    bad1

* equivalence conveniences. Arrays are (idim, icom)
* "inc" is the increments for each axis of each component
* "lo"  is the starting subscript (minus 1) for each axis of each component
	INTEGER	inc(nferdims,4), lo(nferdims,4)
	EQUIVALENCE
     .	(lo(1,1),si1), (lo(2,1),sj1), (lo(3,1),sk1), (lo(4,1),sl1), (lo(5,1),sm1), (lo(6,1),sn1), 
     .	(lo(1,2),si2), (lo(2,2),sj2), (lo(3,2),sk2), (lo(4,2),sl2), (lo(5,2),sm2), (lo(6,2),sn2), 
     .	(lo(1,3),si3), (lo(2,3),sj3), (lo(3,3),sk3), (lo(4,3),sl3), (lo(5,3),sm3), (lo(6,3),sn3),
     .	(inc(1,1),di1),(inc(2,1),dj1),(inc(3,1),dk1),(inc(4,1),dl1),(inc(5,1),dm1),(inc(6,1),dn1), 
     .	(inc(1,2),di2),(inc(2,2),dj2),(inc(3,2),dk2),(inc(4,2),dl2),(inc(5,2),dm2),(inc(6,2),dn2), 
     .	(inc(1,3),di3),(inc(2,3),dj3),(inc(3,3),dk3),(inc(4,3),dl3),(inc(5,3),dm3),(inc(6,3),dn3)

* flag for bad or missing values
        bad1 = mr_bad_data ( mr1 )

* compute the delta increment for each axis of each component
	DO 2 icom = 1, num_com
	DO 2 idim = 1, nferdims
	   IF ( CX_DIM_LEN(idim,com_cx(icom)) .EQ. 1 ) THEN
	      inc(idim,icom) = 0
	   ELSE
	      inc(idim,icom) = 1
	   ENDIF
 2	CONTINUE

* compute the starting subscript for each axis of each component
* (pre-decrement by 1 delta for looping ahead)
	DO 4 icom = 1, num_com
	DO 4 idim = 1, nferdims
 4	lo(idim,icom) = cx_lo_ss(com_cx(icom),idim) - inc(idim,icom)

* operator number (1 thru 3 OK)
        op = operation
        IF (op .EQ. 5) op = 3  ! IFV works as for IF
        IF (op.LT.1 .OR. op.GT.3) STOP 'STR OP?'

        GOTO (100,200,300) op

 100	CONTINUE
* "THEN" - comes from IF (condition) THEN (choice)   ... no "ELSE" given
* component 1 is the condition.  component 2 is the choice
 200	n1 = sn1
	n2 = sn2
	DO 210 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	  DO 210 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 210 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  k1 = sk1
	  k2 = sk2
	   DO 210 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   j1 = sj1
	   j2 = sj2
	    DO 210 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    i1 = si1
	    i2 = si2
	     DO 210 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2

	   IF ( com1(i1,j1,k1,l1,m1,n1) .NE. bad1
     .	  .AND. com1(i1,j1,k1,l1,m1,n1) .NE. 0.0       ) THEN
              CALL COPY_C_STRING(com2(i2,j2,k2,l2,m2,n2), res(i,j,k,l,m,n))
           ELSE
              CALL SET_NULL_C_STRING(res(i,j,k,l,m,n))
           ENDIF

 210	CONTINUE
	RETURN

* "ELSE" - comes from IF (condition) THEN (choice1) ELSE (choice2)
* component 1 is the condition.  components 2 and 3 are the choices
 300	n1 = sn1
	n2 = sn2
	n3 = sn3
	DO 310 n = mr_lo_s6(mres), mr_hi_s6(mres)
	n1 = n1 + dn1
	n2 = n2 + dn2
	n3 = n3 + dn3
	m1 = sm1
	m2 = sm2
	m3 = sm3
	 DO 310 m = mr_lo_s5(mres), mr_hi_s5(mres)
	 m1 = m1 + dm1
	 m2 = m2 + dm2
	 m3 = m3 + dm3
	  l1 = sl1
	  l2 = sl2
	  l3 = sl3
	  DO 310 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  l3 = l3 + dl3
	  k1 = sk1
	  k2 = sk2
	  k3 = sk3
	   DO 310 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   k3 = k3 + dk3
	   j1 = sj1
	   j2 = sj2
	   j3 = sj3
	    DO 310 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    j3 = j3 + dj3
	    i1 = si1
	    i2 = si2
	    i3 = si3
	     DO 310 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2
	     i3 = i3 + di3

	   IF ( com1(i1,j1,k1,l1,m1,n1) .NE. bad1
     .	  .AND. com1(i1,j1,k1,l1,m1,n1) .NE. 0.0       ) THEN
              CALL COPY_C_STRING(com2(i2,j2,k2,l2,m2,n2), res(i,j,k,l,m,n))
           ELSE
              CALL COPY_C_STRING(com3(i3,j3,k3,l3,m3,n3), res(i,j,k,l,m,n))
           ENDIF

 310	CONTINUE
	RETURN

        END

	SUBROUTINE GCF_CHILD_VAR_NAME( parent_uvar, char1, name )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* return the (hidden) name of a child variable constructed from
* the number of its parent variable and the start character of the
* grid-changing reference within the parent definition

* For example, in the definition
*     yes? LET var = 2 * GC_FUNCT( a,b,c )
* the string "GC_FUNCT( a,b,c )" would become a child variable with a name
* based on the uvar number of "var" and a start char of 5 (following "2 * ")

* V450: 12/96
*        7/7/97 - revert to one name in all cases -- use DIAGNOSTIC_OUT
*                 to make diagnostic output more readable
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

* calling argument declarations
	INTEGER		parent_uvar, char1
	CHARACTER	name*(*)

* internal variable declarations

	include	'tmap_dims.parm'
	include 'ferret.parm'

* sanity check
	IF ( LEN(name) .LT. 11 ) THEN
	   STOP 'GCF_CHILD_VAR_NAME'
	ENDIF

!	IF ( char1.LT.100 .AND. parent_uvar.LT.100) THEN
!	   WRITE (name, 3000) char1, parent_uvar
! 3000	   FORMAT ('(C',I2.2,',V',I2.2,')')	! e.g. "(C12,V02)"
!	ELSE
	   WRITE (name, 3100) char1, parent_uvar
 3100	   FORMAT ('(C',I3.3,',V',I3.3,')')	! e.g. "(C112,V002)"
!	ENDIF

	RETURN
	END

	SUBROUTINE CD_GET_BAD_FLAGS (dset, varid, ds_bad, ds_miss, 
     .                               bad_default, var, nsiz)


* Consolidate to one bad-value - needed for the fix to 1861...
	INTEGER dset, varid, nsiz
	REAL    ds_bad, ds_miss, bad_default, var(*)



	LOGICAL NC_GET_ATTRIB, do_warn, scaled,
     .		got_fill, got_bad, got_scale, got_offset
	INTEGER maxlen, attlen, attoutflag
	CHARACTER*10 dum_name, buff
	REAL	scale, offset

*  vname in the call below is only for error messages, used only if
*  do_warn is set.

	do_warn = .FALSE.
	dum_name = 'dummy'
	maxlen = 10

* Get the missing and fill value attributes
*   _FillValue --> ds_missing_flag(ivtm)
*   missing_value --> ds_bad_flag(ivtm)

	got_fill = NC_GET_ATTRIB( dset, varid, '_FillValue',
     .                     do_warn, dum_name, maxlen, attlen, 
     .                     attoutflag, buff, ds_miss)
	got_bad = NC_GET_ATTRIB( dset, varid, 'missing_value',
     .                     do_warn, dum_name, maxlen, attlen, 
     .                     attoutflag, buff, ds_bad)

	IF (got_bad  .AND. .NOT.got_fill) ds_miss = ds_bad
	IF (got_fill .AND. .NOT.got_bad ) ds_bad = ds_miss

* If neither is set, use NaN
	IF (.NOT.got_fill .AND. .NOT.got_bad) THEN
	   CALL SET_NAN (ds_bad)
	   CALL SET_NAN (ds_miss)
	   CALL SWITCH_NAN(ds_miss, ds_bad, bad_default)
	ELSE

* Call SWITCH_NAN to make sure if NaN exists, its in ds_missing_flag
	   CALL SWITCH_NAN(ds_bad, ds_miss, bad_default)
	ENDIF

* Consolidate to one bad-value in the data

	CALL TM_SWITCH_BAD ( ds_miss, ds_bad, var, nsiz )

* Are there scale and offset attributes?

	maxlen = 2
	scale = 1.
	got_scale = NC_GET_ATTRIB( dset, varid, 'scale_factor',
     .	          do_warn, dum_name, maxlen, attlen, 
     .	          attoutflag, buff, scale)

	offset = 0.
	got_offset = NC_GET_ATTRIB( dset, varid, 'add_offset',
     .	          do_warn, dum_name, maxlen, attlen, 
     .	          attoutflag, buff, offset)

	IF ( got_scale .OR. got_offset) CALL TM_SCALE_SWITCH_BAD (
     .                   scale, offset, ds_bad, bad_default, var, nsiz )


	RETURN
	END

      SUBROUTINE CIRCLE(XCENT,YCENT,DEG1,DEG2,XRAD,YRAD,PRECSN)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)circle.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     CALL CIRCLE(XCENT,YCENT,DEG1,DEG2,XRAD,YRAD,PRECSN)
C
C     THIS SUBROUTINE DRAWS AN ARC CENTERED AT A SPECIFIED LOCA-
C     TION AND HAVING A SPECIFIED RADIUS IN THE X- AND Y-DIREC-
C     TIONS.
C
C     THE VARIOUS PARAMETERS AND THEIR DEFINITIONS ARE LISTED
C     BELOW:
C        XCENT  - X-COORDINATE OF THE CENTER OF THE ARC IN USER'S
C                 UNITS.
C        YCENT  - Y-COORDINATE OF THE CENTER OF THE ARC IN USER'S
C                 UNITS.
C        DEG1   - INITIAL ANGLE OF THE ARC IN DEGREES RELATIVE TO
C                 THE X-AXIS.
C        DEG2   - FINAL ANGLE OF THE ARC IN DEGREES RELATIVE TO
C                 THE X-AXIS.
C        XRAD   - X-DIRECTION RADIUS OF THE ARC IN USER'S UNITS.
C        YRAD   - Y-DIRECTION RADIUS OF THE ARC IN USER'S UNITS.
C        PRECSN - LENGTH OF THE INDIVIDUAL LINE SEGMENTS IN THE
C                 ARC IN INCHES (OR MM).
C
C
#ifdef unix
	include 'PLTCOM.DAT'
#else
	include 'pplinc:PLTCOM.DAT'
#endif
C
C     CONVERT THE INITIAL AND FINAL ANGLES TO RADIANS.
C
      ANGLE1 = 0.01745329251994 * DEG1
      ANGLE2 = 0.01745329251994 * DEG2
C
C     MOVE TO THE INITIAL POINT ON THE ARC WITH THE PEN UP.
C
      X = XCENT + XRAD * COS(ANGLE1)
      Y = YCENT + YRAD * SIN(ANGLE1)
      CALL PLOT(X,Y,0,0)
      RADIUS = AMAX1(ABS(XRAD * XSCALE),ABS(YRAD * YSCALE))
C
C     IF THE RADIUS IS ZERO, THE ARC CONSISTS OF A SINGLE POINT.
C
      IF(RADIUS .EQ. 0.0 .OR. ANGLE1 .EQ. ANGLE2)GO TO 30
      CHANGE = ABS(PRECSN * FACTOR / RADIUS)
      ANGLE = ANGLE1
      IF(ANGLE1 .GT. ANGLE2)GO TO 20
C
C     DRAW THE COUNTER-CLOCKWISE ARC AS A SERIES OF SMALL LINE
C     SEGMENTS.
C
   10 ANGLE = ANGLE + CHANGE
      IF(ANGLE .GE. ANGLE2)GO TO 30
      X = XCENT + XRAD * COS(ANGLE)
      Y = YCENT + YRAD * SIN(ANGLE)
      CALL PLOT(X,Y,1,0)
      GO TO 10
C
C     DRAW THE CLOCKWISE ARC AS A SERIES OF SMALL LINE SEGMENTS.
C
   20 ANGLE = ANGLE - CHANGE
      IF(ANGLE .LE. ANGLE2)GO TO 30
      X = XCENT + XRAD * COS(ANGLE)
      Y = YCENT + YRAD * SIN(ANGLE)
      CALL PLOT(X,Y,1,0)
      GO TO 20
C
C     MOVE TO THE FINAL POINT ON THE ARC.
C
   30 X = XCENT + XRAD * COS(ANGLE2)
      Y = YCENT + YRAD * SIN(ANGLE2)
      CALL PLOT(X,Y,1,0)
      RETURN
C
      END

	subroutine zgrid_laplace(z,nxsize,nysize,nx,ny,x1,y1,dx,dy, 
     1	xp,yp,zp,zpij,knxt,n,cay,nrng) 
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)zgrid.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
c     sets up square grid for contouring , given arbitrarily placed 
c     data points. laplace interpolation is used. 
c     the method used here was lifted directly from notes left by 
c     mr ian crain formerly with the comp.science div. 
c     info on relaxation soln of laplace eqn supplied by dr t murty. 
c     fortran ii   oceanography/emr   dec/68   jdt 
c 
c     z = 2-d array of hgts to be set up. points outside region to be 
c     contoured should be initialized to 10**35 . the rest should be 0.0 
c     nx,ny = max subscripts of z in x and y directions . 
c     x1,y1 = coordinates of z(1,1) 
c     dx,dy = x and y increments . 
c     xp,yp,zp = arrays giving position and hgt of each data point. 
c     n = size of arrays xp,yp and zp . 
c 
c     modification feb/69   to get smoother results a portion of the 
c     beam eqn  was added to the laplace eqn giving 
c     delta2x(z)+delta2y(z) - k(delta4x(z)+delta4y(z)) = 0 . 
c     k=0 gives pure laplace solution.  k=inf. gives pure spline solution. 
c     cayin = k = amount of spline eqn (between 0 and inf.) 
c     nrng...grid points more than nrng grid spaces from the nearest 
c            data point are set to undefined. 
c 
c     modification dec23/69   data pts no longer moved to grid pts. 
c 
c     modification may 5 79  common blocks work1 and work2 must 
c     be dimension at least n points long by the user.  common 
c     block work3 must be dimensioned at least ny points long. 
c 
c	modification june 17,1985 - handles data values of 1e35. if at
c	least one data value near a grid point is equal to 1e35, the z
c	array is initialized to 1e35 at that grid point
c	- by g.r. halliwell
c
c  8/26/2008   This is exactly zgrid from the PPLUS code. This function has
c              some hard-wired workspace limited to 50K points. For the external
c              functions scat2gridlplace*, instead allocate work arrays in the 
c              external functions and pass them to zgrid_laplace.F
c
c*******************************************************************************
c 
c	vax/vms
c
	IMPLICIT REAL(A-H, O-Z), INTEGER(I-N)
	real z(nxsize,nysize),xp(n),yp(n),zp(n),zpij(n)
        integer knxt(n)
c
c	end vax/vms
c
c	rsx-11m
c
c	virtual z(nxsize,nysize),xp(n),yp(n),zp(n),zpij(10000),knxt(10000)
c
c	end rsx-11m
c
	dimension imnew(1000),kksav(500)
 
	itmax=100 
	eps=.002 
	big=.9e35 
c 
c     get zbase which will make all zp values positive by 20*(zmax-zmin) 
c*******************************************************************************
c 
c**   grh modification
	zmin=big
	zmax=-big
	do 20 k=1,n 
	if(zp(k).ge.1e35)goto 20
c**
	if(zp(k)-zmax)14,14,12 
12	zmax=zp(k) 
14	if(zp(k)-zmin)16,20,20 
16	zmin=zp(k) 
20	continue 
	zrange=zmax-zmin 
	zbase=zrange*20.-zmin 
	hrange=amin1(dx*(nx-1) , dy*(ny-1)) 
	derzm=2.*zrange/hrange 
c 
c     set pointer array knxt 
c*******************************************************************************
c 
	do 60 kk=1,n 
	k=1+n-kk 
        IF (k .le. 51514) then
          nothing = 0
        endif
	knxt(k)=0 
	i= (xp(k)-x1)/dx + 1.5 
	if(i*(nx+1-i))60,60,35 
35	j= (yp(k)-y1)/dy + 1.5 
	if(j*(ny+1-j))60,60,40 
40	if(z(i,j)-big)45,60,60 
45	knxt(k)=n+1 
	if(z(i,j))55,55,50 
50	knxt(k)= z(i,j)+.5 
55	z(i,j)=k 
60	continue 
c 
c     affix each data point zp to its nearby grid point.  take avg zp if 
c     more than one zp nearby the grid point. add zbase and complement. 
	do 80 k=1,n 
	if(knxt(k))80,80,65 
65	npt=0 
c**   grh modification
	imask=0
c**
	zsum=0. 
	i= (xp(k)-x1)/dx + 1.5 
	j =(yp(k)-y1)/dy + 1.5 
	kk=k 
70	npt=npt+1 
c**   grh modification
	kksav(npt)=kk
	if(zp(kk).gt.big)imask=1
c**
	zsum=zsum+ zp(kk) 
	knxt(kk)=-knxt(kk) 
	kk = -knxt(kk) 
	if(kk-n)70,70,75 
c**	grh modification
75	if(imask.eq.0)then
	z(i,j) = -zsum/npt-zbase 
	else
	z(i,j) = 1.e35
	do 76 i=1,npt
76	knxt(kksav(i))=0
	endif
c**
80	continue 
c 
c     initially set each unset grid point to value of nearest known pt. 
c*******************************************************************************
c 
	do 110 i=1,nx 
	do 110 j=1,ny 
	if(z(i,j))110,100,110 
100	z(i,j) = -1.e35 
110	continue 
	do 199 iter=1,nrng 
	nnew=0 
	do 197 i=1,nx 
	do 197 j=1,ny 
	if(z(i,j)+big)152,192,192 
152	if(j-1)162,162,153 
153	if(jmnew)154,154,162 
154	zijn=abs(z(i,j-1)) 
	if(zijn-big)195,162,162 
162	if(i-1)172,172,163 
163	if(imnew(j))164,164,172 
164	zijn=abs(z(i-1,j)) 
	if(zijn-big)195,172,172 
172	if(j-ny)173,182,182 
173	zijn=abs(z(i,j+1)) 
	if(zijn-big)195,182,182 
182	if(i-nx)183,192,192 
183	zijn=abs(z(i+1,j)) 
	if(zijn-big)195,192,192 
192	imnew(j)=0 
	jmnew=0 
	go to 197 
195	imnew(j)=1 
	jmnew=1 
	z(i,j)=zijn 
	nnew=nnew+1 
197	continue 
	if(nnew)200,200,199 
199	continue 
200	continue 
	do 202 i=1,nx 
	do 202 j=1,ny 
	abz=abs(z(i,j)) 
	if(abz-big)202,201,201 
201	z(i,j)=abz 
202	continue 
c 
c     improve the non-data points by applying point over-relaxation 
c     using the laplace-spline equation  (carres method is used) 
c*******************************************************************************
c 
	dzrmsp=zrange 
	relax=1.0 
	do 4000 iter=1,itmax 
	dzrms=0. 
	dzmax=0. 
	npg =0 
	do 2000 i=1,nx 
	do 2000 j=1,ny 
	z00=z(i,j) 
	if(z00-big)205,2000,2000 
205	if(z00)2000,208,208 
208	wgt=0. 
	zsum=0. 
c 
	im=0 
	if(i-1)570,570,510 
510	zim=abs(z(i-1,j)) 
	if(zim-big)530,570,570 
530	im=1 
	wgt=wgt+1. 
	zsum=zsum+zim 
	if(i-2)570,570,540 
540	zimm=abs(z(i-2,j)) 
	if(zimm-big)560,570,570 
560	wgt=wgt+cay 
	zsum=zsum-cay*(zimm-2.*zim) 
570	if(nx-i)700,700,580 
580	zip=abs(z(i+1,j)) 
	if(zip-big)600,700,700 
600	wgt=wgt+1. 
	zsum=zsum+zip 
	if(im)620,620,610 
610	wgt=wgt+4.*cay 
	zsum=zsum+2.*cay*(zim+zip) 
620	if(nx-1-i)700,700,630 
630	zipp=abs(z(i+2,j)) 
	if(zipp-big)650,700,700 
650	wgt=wgt+cay 
	zsum=zsum-cay*(zipp-2.*zip) 
700	continue 
c 
	jm=0 
	if(j-1)1570,1570,1510 
1510	zjm=abs(z(i,j-1)) 
	if(zjm-big)1530,1570,1570 
1530	jm=1 
	wgt=wgt+1. 
	zsum=zsum+zjm 
	if(j-2)1570,1570,1540 
1540	zjmm=abs(z(i,j-2)) 
	if(zjmm-big)1560,1570,1570 
1560	wgt=wgt+cay 
	zsum=zsum-cay*(zjmm-2.*zjm) 
1570	if(ny-j)1700,1700,1580 
1580	zjp=abs(z(i,j+1)) 
	if(zjp-big)1600,1700,1700 
1600	wgt=wgt+1. 
	zsum=zsum+zjp 
	if(jm)1620,1620,1610 
1610	wgt=wgt+4.*cay 
	zsum=zsum+2.*cay*(zjm+zjp) 
1620	if(ny-1-j)1700,1700,1630 
1630	zjpp=abs(z(i,j+2)) 
	if(zjpp-big)1650,1700,1700 
1650	wgt=wgt+cay 
	zsum=zsum-cay*(zjpp-2.*zjp) 
1700	continue 
c 
	dz=zsum/wgt-z00 
	npg=npg+1 
	dzrms=dzrms+dz*dz 
	dzmax=amax1(abs(dz),dzmax) 
	z(i,j)=z00+dz*relax 
2000	continue 
c 
c 
c     shift data points zp progressively back to their proper places as 
c     the shape of surface z becomes evident. 
c*******************************************************************************
c 
	if(iter-(iter/10)*10) 3600,3020,3600 
3020	do 3400 k=1,n 
	knxt(k) =iabs(knxt(k)) 
	if(knxt(k))3400,3400,3030 
3030	x=(xp(k)-x1)/dx 
	i=x+1.5 
	x= x+1.-i 
	y=(yp(k)-y1)/dy 
	j=y+1.5 
	y=y+1.-j 
	zpxy = zp(k)+zbase 
	z00 = abs(z(i,j)) 
c 
	zw=1.e35 
	if(i-1)3120,3120,3110 
3110	zw = abs(z(i-1,j)) 
3120	ze=1.e35 
	if(i-nx)3130,3140,3140 
3130	ze = abs(z(i+1,j)) 
3140	if(ze-big)3160,3150,3150 
3150	if(zw-big)3180,3170,3170 
3160	if(zw-big)3200,3190,3190 
3170	ze=z00 
	zw=z00 
	go to 3200 
3180	ze=2.*z00-zw 
	go to 3200 
3190	zw = 2.*z00-ze 
c 
3200	zs=1.e35 
	if(j-1)3220,3220,3210 
3210	zs = abs(z(i,j-1)) 
3220  	zn= 1.e35 
	if(j-ny)3230,3240,3240 
3230	zn = abs(z(i,j+1)) 
3240	if(zn-big)3260,3250,3250 
3250	if(zs-big)3280,3270,3270 
3260	if(zs-big)3300,3290,3290 
3270	zn= z00 
	zs= z00 
	go to 3300 
3280	zn = 2.*z00-zs 
	go to 3300 
3290	zs = 2.*z00-zn 
c 
3300	a=(ze-zw)*.5 
	b=(zn-zs)*.5 
	c=(ze+zw)*.5-z00 
	d=(zn+zs)*.5-z00 
	zxy=z00+a*x+b*y+c*x*x+d*y*y 
	delz=z00-zxy 
	delzm=derzm*(abs(x)*dx+abs(y)*dy)*.80 
	if(delz-delzm)3355,3355,3350 
3350	delz=delzm 
3355	if(delz+delzm)3360,3365,3365 
3360	delz=-delzm 
3365	zpij(k)=zpxy+delz 
3400	continue 
c 
	do 3500 k=1,n 
	if(knxt(k))3500,3500,3410 
3410	npt=0 
	zsum = 0. 
	i= (xp(k)-x1)/dx + 1.5 
	j= (yp(k)-y1)/dy + 1.5 
	kk = k 
3420	npt = npt+1 
	zsum = zsum + zpij(kk) 
	knxt(kk)= -knxt(kk) 
	kk = -knxt(kk) 
	if(kk-n)3420,3420,3430 
3430	z(i,j) =  -zsum/npt 
3500	continue 
3600	continue 
c 
c     test for convergence 
c*******************************************************************************
c 
	if(npg.eq.0)goto 4010
	dzrms=sqrt(dzrms/npg) 
	root =dzrms/dzrmsp 
	dzrmsp=dzrms 
	dzmaxf=dzmax/zrange 
	if(iter-(iter/10)*10-2)3715,3710,3715 
3710	dzrms8 = dzrms 
3715	if(iter-(iter/10)*10)4000,3720,4000 
3720	root = sqrt(sqrt(sqrt(dzrms/dzrms8))) 
	if(root-.9999)3730,4000,4000 
3730	if(dzmaxf/(1.-root)-eps)4010,4010,3740 
c 
c     improve the relaxation factor. 
c*******************************************************************************
c 
3740	if((iter-20)*(iter-40)*(iter-60))4000,3750,4000 
3750	if(relax-1.-root)3760,4000,4000 
3760	tpy =(root+relax-1.)/relax 
	rootgs = tpy*tpy/root 
	relaxn= 2./(1.+sqrt(1.-rootgs)) 
	if(iter-60)3780,3785,3780 
3780	relaxn= relaxn-.25*(2.-relaxn) 
3785	relax = amax1(relax,relaxn) 
4000	continue 
4010	continue 
c 
c     remove zbase from array z and return. 
c 
	do 4500 i=1,nx 
	do 4500 j=1,ny 
	if(z(i,j)-big)4400,4500,4500 
4400	z(i,j)=abs(z(i,j))-zbase 
4500	continue 
	return 
	end 

	LOGICAL FUNCTION INHERITED_LIMITS( idim, cx )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine if the limits given within a definition (or within component
* variables of the definition) should be inherited by a parent definition

* for example: if A=SST[T=1-jan-1980:1-jan-1990]
* then "A+5" inherits the 1:5 info
* but A[gt=monthly_clim@mod] does NOT inherit -- the modulo regridding
* swallows up the limits information and produces, always, a full axis
* of (probably 12) values, as if no limits had been given.

* Note: this logic is also applicable to inplicit axes. For example,
* A=SST[X=160e:160w:.2] has explicit limits but the resulting new axis
* created is always provided in full, as if no limits had been given.

* However, this routine did not exist at the time that implicit axes
* were developed ... so a kludgy work-around (IS_RECONCILE(?)) was developed.


* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V420: 1/96
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'

* calling argument declarations:
	INTEGER	idim, cx

* internal variable declarations:
* ...

* limits are inheritible unless modulo regridding was applied

	INHERITED_LIMITS = .NOT.cx_unstand_grid(cx)
     .			 .OR. 
     .      (cx_regrid_trans(idim,cx).LT.prgrd_modulo
     . .OR.  cx_regrid_trans(idim,cx).GT.prgrd_modmax)

	RETURN
	END

	SUBROUTINE PPL_SHASET( string )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute a PLOT+ SHASET command with the given string as argument

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V230: 11/92 - for color map protection during viewport manipulations
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

	include 'plot_setup.parm'
	include 'xrisc.cmn'		! to fix RISC FORTRAN bug

* calling argument declarations:
	CHARACTER*(*)	string

* internal variable declarations:

* initialize fixed length string for RISC (needed for DEC f77 v2.1)
	risc_buff = string
	len_rbuff = MIN( size_rbuff, LEN(string) )

* send the command to PLOT+  "SHASET [string]"
	CALL PPLCMD ( from, line, 0,
     .                'SHASET '//risc_buff(:len_rbuff), 1, 1 )

* always successful
        RETURN
	END

	SUBROUTINE SECS_TO_YMDHMS ( num_secs,
     .				    yr, mon, day, hr, min, sec )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Will break secs since 01-JAN-0000 00:00:00 into separate yr,mo,day,hr,min,sec
* fields

* V530 *sh* 1/02 - based upon tm_secs_to_date.F
* V6.31 *acm* 11/09 Simplify the logic which decides what month/day it is
*             as is already done in tm_secs_to_date.

* Argument declarations
	INTEGER	yr, mon, day, hr, min
	REAL	sec
	REAL*8	num_secs
	
*
* Local Definition
	INTEGER		month_by_day(365), leapadj, cent_cnt,
     .			year_cnt, cent4_cnt, year4_cnt, tot_days,
     .			tmp_days, days_before_month(12), ge59
	REAL*8		secs_in_minute, secs_in_hour, secs_in_day,
     .			secs_in_year, secs_in_4years, secs_in_cent,
     .			secs_in_4cents, total_secs

	PARAMETER	(secs_in_minute	 = 60.,
     .			 secs_in_hour	 = secs_in_minute*60.,
     .			 secs_in_day	 = secs_in_hour*24.,
     .			 secs_in_year	 = secs_in_day*365.,
     .			 secs_in_4years	 = secs_in_day*(3*365.+366.),
     .			 secs_in_cent    = secs_in_day*(76*365.+24*366.),
     .			 secs_in_4cents  = 4*secs_in_cent+secs_in_day)

	DATA month_by_day /31*01, 28*02, 31*03, 30*04, 31*05, 30*06,
     .			   31*07, 31*08, 30*09, 31*10, 30*11, 31*12/
	DATA days_before_month	/   0,  31,  59,  90, 120, 151,
     .				  181, 212, 243, 273, 304, 334/

* trap invalid input
	IF ( num_secs .LT. 0 ) THEN
	   yr = 0
	   mon = 1
	   day = 1
	   hr = 0
	   min = 0
	   sec = 0.0
	   RETURN
	ENDIF

* Initialize
	total_secs = num_secs

* Subtract year 0 off (it's a leap year)
	total_secs = total_secs - secs_in_year - secs_in_day

* make sure we aren't working in year 0
	IF (total_secs .GE. 0) THEN

* Decide which century it is
	  cent4_cnt = INT(total_secs/secs_in_4cents)
	  total_secs = total_secs - cent4_cnt*secs_in_4cents
	  cent_cnt = INT(total_secs/secs_in_cent)
* Dec 31 on leap century test (years 400,800,1200...)
	  IF (cent_cnt .EQ. 4                         .AND.
     .	      total_secs .GE. cent4_cnt-secs_in_day)   cent_cnt = 3
	  total_secs = total_secs - cent_cnt*secs_in_cent
	  yr = 400*cent4_cnt + 100*cent_cnt

* Decide what year it is exactly (1 year for year 0)
	  year4_cnt = INT(total_secs/secs_in_4years)
	  total_secs = total_secs - year4_cnt*secs_in_4years
	  year_cnt = INT(total_secs/secs_in_year)
* Dec 31 on leap year test (years 0,4,8,12...)
	  IF (year_cnt .EQ. 4                         .AND.
     .	      total_secs .GE. secs_in_4years-secs_in_day)   year_cnt = 3
	  total_secs = total_secs - year_cnt*secs_in_year
	  yr = yr + 4*year4_cnt + year_cnt + 1

	ELSE
* Year 0 stuff
	  yr = 0
	  total_secs = total_secs + secs_in_year + secs_in_day
	ENDIF

* Is this a leap year? (every 4th century is, otherwise century isn't)
	leapadj = 0
	IF (MOD(yr,400) .EQ. 0) THEN
	  leapadj = 1
	ELSE IF (MOD(yr,4) .EQ. 0 .AND. MOD(yr,100) .NE. 0) THEN
	  leapadj = 1
	ENDIF

* How many days into year is this
	tot_days = INT(total_secs/secs_in_day)
	total_secs = total_secs - tot_days*secs_in_day

* Decide what month/day it is

	ge59 = 0
	IF (tot_days .GE. 59) ge59 = 1
	tmp_days = tot_days - leapadj* ge59

	IF (tmp_days .LT. 0) STOP 'negative subscript in TM_SECS_TO_DATE'
	mon = month_by_day(tmp_days+1)

	leapadj = INT(mon/12. +.75)*leapadj
	day = tot_days - (days_before_month(mon)+leapadj) + 1

* Calculate number of hours
	hr = INT(total_secs/secs_in_hour)
* Subtract seconds for number of hours
	total_secs = total_secs - secs_in_hour*(hr)
* Calculate number of minutes
	min = INT(total_secs/secs_in_minute)
* Subtract seconds for number of minutes
	total_secs = total_secs - secs_in_minute*(min)
* Calculate number of seconds
	sec = total_secs

* finished
9990	RETURN
	END

      SUBROUTINE NDIG_COORDS (grid, ax, lo, hi, del, bad_data, ndig, ndig_default)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Compute the number of digits needed to list the coordinates along
* an axis with enough resolution to distinguish them.
* Called by list_cmnd_data.F
*
* Ferret v5.80 9/02/2004  ACM
* V600:  1/06 *acm*  prevent values of LOG10(0.0)

      IMPLICIT NONE
      INCLUDE 'ferret.parm'

* calling argument declarations
      INTEGER grid, ax, lo, hi, del, ndig, ndig_default
      REAL bad_data

* Internal variable declarations
      REAL*8 TM_WORLD, val8, val_last, diff_min, diff_ave, count
      LOGICAL TM_DFPEQ
      INTEGER i

* Special formatting codes for time axes etc.

      IF (ndig_default .LE. 0) THEN
         ndig = ndig_default
         RETURN
      ENDIF

* Get number of decimal places for formatting the coordinates

      val_last = bad_data
      diff_min = ABS(bad_data)
      diff_ave = 0.D0
      count = 0.

* Find the smallest difference from one coordinate to the next.
* also compute the average difference, in case two coordinates
* are very close together.

      DO 310 i = lo, hi, del
         val8 = TM_WORLD( i, grid, ax, box_middle )

         IF (val8 .NE. bad_data .AND. val_last .NE. bad_data) THEN
            diff_min = MIN(diff_min, ABS(val8-val_last) )
            diff_ave = diff_ave + ABS(val8-val_last)
            count = count + 1
         ENDIF

         val_last = val8
 310  CONTINUE
      
      IF (count .GT. 0) THEN
         diff_ave = diff_ave/count
         IF ( TM_DFPEQ(diff_min,0.D0) ) diff_min = diff_ave
         IF (diff_min .NE. 0) THEN 
            ndig = 1 - INT(LOG10(diff_min))
         ELSE
            ndig = 1
         ENDIF
         ndig = MAX(ndig, ndig_default )
      ELSE
         ndig = ndig_default
      ENDIF

      RETURN
      END

*
* samplei_multi.F
*
* Ansley Manke
* Dec 1998
*
* This function samples data along the I axis using a set of indices
* which may be different for the j,k,L dimensions.
* 4/5/99  Ansley Manke 
*         Indices may be oriented along any axis; 
*         Result is abstract on the sampled axis.
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE samplei_multi_init(id)

      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      CHARACTER*100 fcn_desc
      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns data sampled according to I indices which ',
     . 'may vary in JKL')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 2)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, ABSTRACT, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)

      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'I_INDICES')
      CALL ef_set_arg_desc(id, arg, 'indices upon which to sample')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'DAT_TO_SAMPLE')
      CALL ef_set_arg_desc(id, arg, 'data to sample using I indices')
      CALL ef_set_axis_influence(id, arg, NO, YES, YES, YES)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* loss               lo subscript for an axis
*
* hiss               hi subscript for an axis
*

      SUBROUTINE samplei_multi_result_limits(id)

      INCLUDE 'EF_Util.cmn'

      INTEGER id
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER my_lo_l, my_hi_l
      INTEGER nx, ny, nz, nt

*     Use utility functions to get context information about the 
*     1st argument, to set the abstract axis lo and hi indices.

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nx = arg_hi_ss(X_AXIS, ARG1) - arg_lo_ss(X_AXIS, ARG1) + 1
      ny = arg_hi_ss(Y_AXIS, ARG1) - arg_lo_ss(Y_AXIS, ARG1) + 1
      nz = arg_hi_ss(Z_AXIS, ARG1) - arg_lo_ss(Z_AXIS, ARG1) + 1
      nt = arg_hi_ss(T_AXIS, ARG1) - arg_lo_ss(T_AXIS, ARG1) + 1

      my_lo_l = 1
      my_hi_l = nx
      IF (arg_hi_ss(X_AXIS, ARG1) - arg_lo_ss(X_AXIS, ARG1) .EQ. 0)
     .    my_hi_l = max(nx,ny,nz,nt)

      CALL ef_set_axis_limits(id, X_AXIS, my_lo_l, my_hi_l)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END
*
* In this subroutine we compute the result
*
      SUBROUTINE samplei_multi_compute(id, arg_1, arg_2, result)

      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .     mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .     mem2lot:mem2hit)
     .     
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .      memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      INTEGER id, i, j, k, l
      INTEGER i1, j1, k1, l1
      INTEGER j2, k2, l2
      INTEGER iorder
      REAL aorder

      INTEGER nlen(3), unspecified_int4
      CHARACTER*8 lefint, aindex(3) 
      CHARACTER*100 errtxt

      unspecified_int4 = -111

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      j1 = arg_lo_ss(Y_AXIS,ARG1)
      j2 = arg_lo_ss(Y_AXIS,ARG2)
      DO 400 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS) 

         k1 = arg_lo_ss(Z_AXIS,ARG1)
         k2 = arg_lo_ss(Z_AXIS,ARG2)
         DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

            l1 = arg_lo_ss(T_AXIS,ARG1)
            l2 = arg_lo_ss(T_AXIS,ARG2)
            DO 200 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

                i1 = arg_lo_ss(X_AXIS,ARG1)
                DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

*  Get the index to sample, whichever axis of arg_1 it is on.

                   aorder = arg_1(i1,j1,k1,l1)
                   IF (i1 .EQ. unspecified_int4) 
     .                  CALL pickindex(arg_1, i, aorder)
                   iorder = aorder

*  Check that we do have an index of ARG_2; set the result

                  IF (aorder .EQ. bad_flag(ARG1)) THEN
                     result(i,j,k,l) = bad_flag_result
                  ELSE

                     IF (iorder .LT. arg_lo_ss(X_AXIS,ARG2)  .OR.
     .                   iorder .GT. arg_hi_ss(X_AXIS,ARG2) ) THEN
                        GO TO 999
                     ELSE

                        IF (arg_2(iorder,j2,k2,l2) .EQ. bad_flag(ARG2))
     .                   THEN
                           result(i,j,k,l) = bad_flag_result
                        ELSE
                           result(i,j,k,l) = arg_2(iorder,j2,k2,l2)
 
                        END IF
                     END IF
                  END IF

                  i1 = i1 + arg_incr(X_AXIS,ARG1)
 100           CONTINUE

               l1 = l1 + arg_incr(T_AXIS,ARG1)
               l2 = l2 + arg_incr(T_AXIS,ARG2)
 200        CONTINUE

            k1 = k1 + arg_incr(Z_AXIS,ARG1)
            k2 = k2 + arg_incr(Z_AXIS,ARG2)
 300     CONTINUE

         j1 = j1 + arg_incr(Y_AXIS,ARG1)
         j2 = j2 + arg_incr(Y_AXIS,ARG2)
 400  CONTINUE

      RETURN 

999   CONTINUE

      aindex(1) = LEFINT(iorder,nlen(1))
      aindex(2) = LEFINT(arg_lo_ss(X_AXIS,ARG2),nlen(2))
      aindex(3) = LEFINT(arg_hi_ss(X_AXIS,ARG2),nlen(3))

      WRITE (errtxt,*) 'Sampling index ', aindex(1)(1:nlen(1)), 
     . ' in ARG1 is outside the range of I indices for ARG2 (', 
     .  aindex(2)(1:nlen(2)), ':', aindex(3)(1:nlen(3)), ')'

      CALL ef_bail_out(id, errtxt)

      RETURN
      END

	SUBROUTINE APPLY_AUTO_CURV( full_var_name, cx, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*  setup auto-curvilinear loading of aux vars and regridding
*      z = pt               ==> interpolation computed as a hidden curvi regrid
*      z = lo:hi@ave        ==> a compressing xform computed as a hidden curvi
*				regridding operation using pcwz averaging
* 
*      z = lo:hi:delta      ==> a curvi regrid via linear interpolation
*      z = lo:hi:delta@ave  ==> a curvi regrid via piececwise averaging

* V690 12/13 *sh* - hidden curvi regrids added 4/14
* V693+ 11/14 *sh* renaming 'sigma' as 'layerz' throughout
* V695+  3/15 *sh* added pauxrgrd_fmrc for GT(time2d)+1d and GF(time2d)=1d
* V698+  6/15 *sh* generalize single_pt applicable to all axes

	IMPLICIT NONE

	include 'tmap_dims.parm'
	include 'errmsg.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
	include 'xtext_info.cmn'

* calling argument declarations
	INTEGER cx, status
	CHARACTER*(*) full_var_name

* internal variable declarations
	LOGICAL	single_pt
	INTEGER	idim, impl_grid
	REAL	range, midpt


* if any axes are set up for manual aux regridding, that takes precedence
	IF (cx_naux(cx) .GT. 0) RETURN

* loop over the implied curvilinear axes -- set them up for curvi regridding
	DO idim = 1, nferdims

* not a relevant axis?
	   IF (cx_aux_stat(idim,cx) .EQ. paux_stat_na) CYCLE

* if the region was specified by subscript suppresses implicit curvi regridding
	   IF (cx_given(idim,cx)
     .	 .AND. cx_by_ss(idim,cx)) CYCLE     ! ignore by_ss region limits

* by default assume that we will be regridding this axis
* a regrid implies that the aux axis status is "used"
	  cx_aux_stat(idim,cx) = paux_stat_used 

* single point Z-axis regrid?
	   single_pt = cx_lo_ww(idim,cx) .EQ. cx_hi_ww(idim,cx)
     .	     .OR.    ( cx_trans(idim,cx) .EQ. trans_average
     .           .AND. cx_delta(idim,cx) .EQ. unspecified_val8 )

* modify the xform or regridding xform to be an aux var regrid xform
	   IF     ( single_pt ) THEN   ! Z=pt or Z=lo:hi@ave
	      IF ( cx_trans(idim,cx) .EQ. trans_no_transform ) THEN
	         cx_regrid_trans(idim,cx) = pauxrgrd_linear
	      ELSEIF ( cx_trans(idim,cx) .EQ. trans_average ) THEN 
	         cx_regrid_trans(idim,cx) = pauxrgrd_pwlave
	      ELSE
	         GOTO 5200
	      ENDIF
	      cx_trans(idim,cx) = trans_no_transform
	   ELSEIF ( cx_regrid_trans(idim,cx) .EQ. prgrd_average 
     .	       .OR. cx_trans(idim,cx)        .EQ. trans_average ) THEN
!	      CALL WARN_OCCASIONALLY(
!     .		   'Box-averaging not available for layerz axis '//
!     .		   'regridding.'//pCR//
!     .		   '           Using piecewise linear averaging instead, '//
!     .		   'equivalent to gz(depth)=0:100@plave', 10, 101)
	       cx_regrid_trans(idim,cx) = pauxrgrd_pwlave
	       cx_trans       (idim,cx) = trans_no_transform
	   ELSEIF (cx_regrid_trans(idim,cx) .EQ. prgrd_linear_interp) THEN
	       cx_regrid_trans(idim,cx) = pauxrgrd_linear
	   ELSEIF (cx_trans       (idim,cx) .NE. trans_no_transform
     .	      .OR. cx_regrid_trans(idim,cx) .NE. unspecified_int4 ) THEN
	       GOTO 5200
	   ENDIF

* modify the interpretation of the region to accommodate the curvi operations
	   IF (cx_g_eq_regrid(idim)) THEN
* GZ=axis or GZ=lo:hi:delta
	      cx_aux_stat(idim,cx) = paux_stat_used  ! gz syntax sets itself up
	   ELSEIF (single_pt) THEN
* set up a "false regridding" by falsely setting cx_unstand_grid
* and setting cx_aux_stat as a flag that it is not a real regrid
* This is because we want to invoke the curvilinear regridding machinery
* but we want the result to remain on the original grid -- not unique 1pt grids
* Else layerz_temp[Z=50] and layerz_temp[Z=100] would get differing grids
	      cx_unstand_grid(cx) = .TRUE.
	      cx_aux_stat(idim,cx) = paux_stat_false_1pt_regrid
!	   ELSEIF (cx_regrid_trans(idim,cx) .EQ. pauxrgrd_pwlave
!     .	     .AND. cx_delta(idim,cx)        .EQ. unspecified_val8) THEN
!* Z=lo:hi@ave ==> regrid to a single point axis with these lo:hi end points
!	      range = cx_hi_ww(idim,cx) - cx_lo_ww(idim,cx)
!	      midpt = (cx_hi_ww(idim,cx) + cx_lo_ww(idim,cx)) / 2.
!	      cx_lo_ww(idim,cx) = midpt - range/2
!	      cx_hi_ww(idim,cx) = midpt + range/2
!	      cx_delta(idim,cx) = pauto_1pt_ax
	   ELSEIF ( cx_delta(idim,cx) .NE. unspecified_val8 ) THEN
* z=lo:hi:delta and z=lo:hi:delta@ave
	      CONTINUE
!	   ELSEIF (cx_given(idim,cx)
!     .	     .AND. cx_lo_ww(idim,cx) .EQ. cx_hi_ww(idim,cx)) THEN
!* Z=pt ==> regrid to a 1 point axis axis by interpolation
!	      cx_delta(idim,cx) = pauto_1pt_ax
	   ELSE
* no regridding after all -- just getting the aux vars for plotting
	      cx_aux_stat(idim,cx) = paux_stat_needed
	   ENDIF
	   cx_implicit_aux(cx) = .TRUE.
	   cx_naux(cx) = cx_naux(cx) + 1

* curvilinear and layerz regridding that are not single_pt imply a new target axis
* if it was not already created by GET_CONTEXT_MODS then create it here
	   IF (.NOT.(    single_pt
     .	            .OR. cx_aux_stat(idim,cx).EQ.paux_stat_needed
     .	            .OR. cx_unstand_grid(cx)
     .		    .OR. cx_has_impl_grid(cx))      ) THEN
	      CALL ALLO_GRID_TO_CX(cx,impl_grid,status)
	      IF ( status .NE. ferr_ok ) GOTO 5000
	      cx_unstand_grid(cx) = .TRUE.
	   ENDIF
	ENDDO

	status = ferr_ok
 5000	RETURN

* error exits
 5200	CALL ERRMSG( ferr_invalid_command, status,
     .	     'xform not (yet) supported on auxiliary variable regridding: '
     .		//full_var_name, *5000)

	END

	SUBROUTINE ATEND
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)atend.F	1.2    5/26/88
C**
C**
C***********************************************************************
C**
C**		    PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C**	Subprogram called:
C**		CALL ATEND
C**
C**	Parameters:
C**
C**	Description:
C**		ATEND closes the currently open command file and user
C**		key file and returns to the previous command file.
C**
C**	History:
C**	    Written: 
C**		26-JAN-86	by Donald W. Denbo
C**	    Modified:
C**		15-JUN-86	by Donald W. Denbo
C**		  changes for memory buffer added
C**
C*** V686 *acm* 11/13 Allow symbol names to be up to 120 characters long

	include 'SYSTEM.INC'
	include 'CMDCOM.INC'
	include 'SYMKEY.INC'
	INCLUDE 'LUNITS.INC'

	CHARACTER KFILE*30,SYM*120
	DONEF=CMDLEV.EQ.1
	IF(DONEF)THEN
C
C	DONE -- FINISH UP AND EXIT
C
	    RETURN
	ENDIF
C
C	CLOSE USER KEY FILE AND CURRENT COMMAND FILE
C
	call dbmclear(keyln2)
	keyln2=keyln2-1
	CLOSE(CMDLUN)
C
C	RESET COMMAND FILE 
C
	CMDLEV=CMDLEV-1
	IFLEV=CMIFLV(CMDLEV)
	WHLEV=CMWHLV(CMDLEV)
	SKIPIF=.FALSE.
	SKIPWH=.FALSE.
	DO 10 I=1,WHLEV
10	WHLINE(I)=CMWHLN(CMDLEV,I)
	CMDFIL=CMFILE(CMDLEV)
	LINCNT=CMLINE(CMDLEV)
	ECHOF=CMECHO(CMDLEV)
	DEBUGF=CMDEBG(CMDLEV)
	QUIETF=CMQUIE(CMDLEV)
	LOGCMF=CMLOG(CMDLEV)
#ifdef unix
	IF(CMDFIL.EQ.'/dev/tty')THEN
#else
	if(cmdfil.eq.'TT:')then
#endif
	    TERMF=.TRUE.
	    IF(.NOT.QUIETF)WRITE(LTTOUT,997)
997	    FORMAT(' Control returned to keyboard')
#ifdef unix
	    OPEN(CMDLUN,FILE=CMDFIL,STATUS='OLD')
#endif
	ELSE IF(CMDFIL.EQ.'$$MEMBUF$$')THEN
	    TERMF=.FALSE.
	    MEMBUF=.TRUE.
	ELSE
C
C	OPEN OLD COMMAND FILE AND SKIP TO CORRECT LINE
C
#ifdef unix
	    OPEN(CMDLUN,FILE=CMDFIL,STATUS='OLD')
#else
	    open(cmdlun,file=cmdfil,readonly,status='old')
#endif
	    DO 100 I=1,LINCNT
	    READ(CMDLUN,998)
998	    FORMAT(1X)
100	    CONTINUE
	ENDIF
	ISYM=LNBLK(CMDFIL,80)
	SYM='*PPL$COMMAND_FILE'
	CALL PUTSYM(SYM,CMDFIL,ISYM,IER)
	IF(CMDLEV.GT.1)THEN
C
C	OPEN OLD USER KEY FILE
C
	    WRITE(KFILE,999)CMDLEV
999	    FORMAT('PPL$KEY.',I3.3)
	    call dbmopen(kfile,11,keyln2)
	ELSE
	    SMKEY2=.FALSE.
	ENDIF
	RETURN
	END

	BLOCK DATA XCONTEXT_DATA

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* variable declarations for COMMON/ XCONTEXT /
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 6/25/86
* revision 1.0 - 9/22/87 - added negative contexts for stored regions
* revision 1.1 - 3/10/88 - added "0:" to _ss limits
* revision 1.2 - 7/8/88  - added cx_grid to initializations
* revision 1.3 - 7/28/88 - initialize cx_stack_ptr
* revision 1.4 - 1/3/89  - added regridding transformations
* V200:  6/28/89 - eliminated _dim%,_norm,_rotation, added ss equivalences
*		 - added cx_ovsiz to get oversized regions to fill contour plots
*		 - eliminated _relative
*	12/18/89 - added cx_plot (max_context-->max_cx), cx_xtra_doc
* Ultrix/RISC port - 2/2/91 - Ultrix compiler doesnt permit variable to be
*		defined multiple times by DATA statements
*		Unix version requires implicit DO loops to be spelled out to
*		avoid duplicate initialization
*                   9/24/91 - fixed errors introduced by the above: pre-defined
*                             regions "W", "T", etc. not properly initialized
*                            (Arguably better to do this in a ferret_init file)
* V230:  1/30/92: Sun port - fixed cx_name data initialization
* V420: 9/8/95 - added initializations for implicit grid creation
* V580: 11/04  - new cx_cal_id 
*        2/12 *kms* Add the E and F dimensions (set to nferdims in tmap_dims.parm)
* V685 3/13 *sh* - support for auxiliary regridding variables
* V7.6 3/20 *acm - initialize the flag cxdsg_empty_set

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'
	include 'xdsg_context.cmn'

	INTEGER	    ndcx, ndneg, num_cx_undefined, num_cx_predefined, 
     .              all_undefined, ndm2t3, ndt3
	PARAMETER ( ndcx  = nferdims * max_cx,
     .		    num_cx_predefined = 3, ! 0, -1 and -2 are named cx's T,W,N
     .		    num_cx_undefined = max_cx_predefined - num_cx_predefined,
     .		    ndneg = nferdims * num_cx_undefined, 
     .              all_undefined = max_cx+max_cx_predefined,
     .              ndm2t3 = (nferdims - 2) * 3,
     .              ndt3 = nferdims * 3 )
	INTEGER	    i, j

	DATA	cx_stack_ptr	/ cx_stack_ptr_base /

	DATA	cx_data_set	/ max_cx*unspecified_int4	/,
     .		cx_grid		/ max_cx*unspecified_int4	/,
     .		cx_variable	/ max_cx*unspecified_int4	/,
     .		cx_category	/ max_cx*unspecified_int4	/,
     .		cx_has_impl_grid/ max_cx*.FALSE.		/

* initialize positive subscripts
	DATA	((cx_lo_ww(i,j),i=1,nferdims),j=1,max_cx)/ ndcx *unspecified_val8 /
	DATA	((cx_hi_ww(i,j),i=1,nferdims),j=1,max_cx)/ ndcx *unspecified_val8 /
	DATA	((cx_lo_ss(i,j),i=1,max_cx),j=1,nferdims)/ ndcx *unspecified_int4 /
	DATA	((cx_hi_ss(i,j),i=1,max_cx),j=1,nferdims)/ ndcx *unspecified_int4 /
	DATA	cx_delta	/ ndcx*unspecified_val8		/
	DATA	((cx_trans(i,j),i=1,nferdims),j=1,max_cx)
     .                                  / ndcx *trans_no_transform /
	DATA	((cx_trans_arg(i,j),i=1,nferdims),j=1,max_cx)/ ndcx *bad_val4	 /
	DATA	((cx_by_ss(i,j),i=1,nferdims),j=1,max_cx)/ ndcx *.FALSE.	 /
	DATA	((cx_given(i,j),i=1,nferdims),j=1,max_cx)/ ndcx *.FALSE.	 /
	DATA	((cx_aux_var (i,j),i=1,nferdims),j=1,max_cx)/ ndcx *unspecified_int4 /
	DATA	((cx_aux_cat (i,j),i=1,nferdims),j=1,max_cx)/ ndcx *unspecified_int4 /
	DATA	((cx_aux_stat(i,j),i=1,nferdims),j=1,max_cx)/ ndcx *paux_stat_na /

* initialize undefined negative subscripts
	DATA	((cx_lo_ww(i,j),i=1,nferdims),j=min_context,-3)
     .					/ ndneg *unspecified_val8 /
	DATA	((cx_hi_ww(i,j),i=1,nferdims),j=min_context,-3)
     .					/ ndneg *unspecified_val8 /
	DATA	((cx_lo_ss(i,j),i=min_context,-3),j=1,nferdims)
     .					/ ndneg *unspecified_int4 /
	DATA	((cx_hi_ss(i,j),i=min_context,-3),j=1,nferdims)
     .					/ ndneg *unspecified_int4 /
	DATA	((cx_trans(i,j),i=1,nferdims),j=min_context,-3)
     .					/ ndneg *trans_no_transform /
	DATA	((cx_trans_arg(i,j),i=1,nferdims),j=min_context,-3)
     .					/ ndneg *bad_val4	 /
	DATA	((cx_by_ss(i,j),i=1,nferdims),j=min_context,-3)
     .					/ ndneg *.FALSE.	 /
	DATA	((cx_given(i,j),i=1,nferdims),j=min_context,-3)
     .					/ ndneg *.FALSE.	 /


	DATA
     .		cx_unstand_grid	/ max_cx*.FALSE.		/,
     .		cx_regrid_trans	/ ndcx*unspecified_int4	/

	DATA	cx_ovsiz(cx_last)/ ovsiz_off /

        DATA     cx_cal_id / all_undefined*unspecified_int4	/

* pre-initialize unused named region subscripts
* (added exact limits 1/92 for Sun port)
	DATA	(cx_name(i),i=min_context,-3)/
     .		num_cx_undefined*unspecified_name4 /

* pre-initialize subscripts and axes of "W", "T", and "N" regions
* (added 9/91 for Ultrix port)
	DATA	((cx_lo_ww(i,j),i=3,nferdims),j=-2,0)
     .					/ ndm2t3*unspecified_val8 /
	DATA	((cx_hi_ww(i,j),i=3,nferdims),j=-2,0)
     .					/ ndm2t3*unspecified_val8 /
	DATA	((cx_lo_ss(i,j),i=-2,0),j=1,nferdims)
     .					/ ndt3*unspecified_int4 /
	DATA	((cx_hi_ss(i,j),i=-2,0),j=1,nferdims)
     .					/ ndt3*unspecified_int4 /
	DATA	((cx_trans(i,j),i=3,nferdims),j=-2,0)
     .					/ ndm2t3*trans_no_transform /
	DATA	((cx_trans_arg(i,j),i=3,nferdims),j=-2,0)
     .					/ ndm2t3*bad_val4	 /
	DATA	((cx_by_ss(i,j),i=3,nferdims),j=-2,0)
     .					/ ndm2t3*.FALSE.	 /

	DATA	cx_name(0)		/ 'W    ' /	!"W"hole GFDL region
	DATA	cx_lo_ww( x_dim, 0 )	/ 130.	/,
     .		cx_hi_ww( x_dim, 0 )	/ 290.	/,
     .		cx_lo_ww( y_dim, 0 )	/ -28.9	/,
     .		cx_hi_ww( y_dim, 0 )	/ +48.6	/,
     .		cx_by_ss( x_dim, 0 )	/ .FALSE. /,
     .		cx_by_ss( y_dim, 0 )	/ .FALSE. /,
     .		cx_trans   ( x_dim, 0 )	/ trans_no_transform /,
     .		cx_trans   ( y_dim, 0 )	/ trans_no_transform /,
     .		cx_trans_arg(x_dim, 0 )	/ bad_val4	/,
     .		cx_trans_arg(y_dim, 0 )	/ bad_val4	/,
     .		cx_given( x_dim, 0 )	/ .TRUE.  /,
     .		cx_given( y_dim, 0 )	/ .TRUE.  /,
     .		cx_given( z_dim, 0 )	/ .FALSE. /,
     .		cx_given( t_dim, 0 )	/ .FALSE. /,
     .		cx_given( e_dim, 0 )	/ .FALSE. /,
     .		cx_given( f_dim, 0 )	/ .FALSE. /

	DATA	cx_name(-1)		/ 'T    ' /	! "T"ropical Pacific
	DATA	cx_lo_ww( x_dim,-1 )	/ 130.	/,
     .		cx_hi_ww( x_dim,-1 )	/ 290.	/,
     .		cx_lo_ww( y_dim,-1 )	/ -23.5	/,
     .		cx_hi_ww( y_dim,-1 )	/ +23.5	/,
     .		cx_by_ss( x_dim,-1 )	/ .FALSE. /,
     .		cx_by_ss( y_dim,-1 )	/ .FALSE. /,
     .		cx_trans   ( x_dim,-1 )	/ trans_no_transform /,
     .		cx_trans   ( y_dim,-1 )	/ trans_no_transform /,
     .		cx_trans_arg(x_dim,-1 )	/ bad_val4	/,
     .		cx_trans_arg(y_dim,-1 )	/ bad_val4	/,
     .		cx_given( x_dim,-1 )	/ .TRUE.  /,
     .		cx_given( y_dim,-1 )	/ .TRUE.  /,
     .		cx_given( z_dim,-1 )	/ .FALSE. /,
     .		cx_given( t_dim,-1 )	/ .FALSE. /,
     .		cx_given( e_dim,-1 )	/ .FALSE. /,
     .		cx_given( f_dim,-1 )	/ .FALSE. /

	DATA	cx_name(-2)		/ 'N    '/	! "N"arrow tropical slab
	DATA	cx_lo_ww( x_dim,-2 )	/ 130.	/,
     .		cx_hi_ww( x_dim,-2 )	/ 290.	/,
     .		cx_lo_ww( y_dim,-2 )	/ -9.8	/,
     .		cx_hi_ww( y_dim,-2 )	/ +9.8	/,
     .		cx_by_ss( x_dim,-2 )	/ .FALSE. /,
     .		cx_by_ss( y_dim,-2 )	/ .FALSE. /,
     .		cx_trans   ( x_dim,-2 )	/ trans_no_transform /,
     .		cx_trans   ( y_dim,-2 )	/ trans_no_transform /,
     .		cx_trans_arg(x_dim,-2 )	/ bad_val4	/,
     .		cx_trans_arg(y_dim,-2 )	/ bad_val4	/,
     .		cx_given( x_dim,-2 )	/ .TRUE.  /,
     .		cx_given( y_dim,-2 )	/ .TRUE.  /,
     .		cx_given( z_dim,-2 )	/ .FALSE. /,
     .		cx_given( t_dim,-2 )	/ .FALSE. /,
     .		cx_given( e_dim,-2 )	/ .FALSE. /,
     .		cx_given( f_dim,-2 )	/ .FALSE. /

	DATA  cxdsg_empty_set /.FALSE./

	END

	SUBROUTINE IS_DO_GC_FCN
     .			(  uvar, alg_text, lo_isp, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* do bookkeeping and call up calculation to perform grid changing fcn
* (which may be an externally-defined function)

* V450:  1/97 - based on IS_DO_OP
*        7/97 - added status and memory args to DO_INTERNAL_GC_FCN call
*       7/25/97 - increase number of args allowed from 5 to 10
* V500:  1/99 *sh* Trap as errors attempts to use string variables as
*		arguments ti internal functions.
*		Strings may be passed only to external functions
* V530:  8/00 *sh* - check on string data type -- not category
* V533:  6/01 *sh* - support for args that may be string or float
* V540: *sh* 10/01 - use improved data typing general parameter parg_type_* defs
* 1/03 *kob* g77 port requires risc buff for arbitrary string concats
*  V6.0 *acm*  5/06 string results for external functions, set return type.
* V6.2 *acm* 11/08 New function efcn_get_alt_type_fcn gets the name of a 
*                  function to call if the arguments are of a different type 
*                  than defined in the current function. e.g. this lets the 
*                  user reference XCAT with string arguments and Ferret will 
*                  run XCAT_STR
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
*      *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V68   3/12 *KMS/ACM* see 6D branch: working on string bugs. Remove overloading
*                   of argument/return-type variable and predimensional (data size)
*                   array parameter (pointer size to one in double-precision Ferret).
* V694  *acm* 1214 Fixing ticket 2220: varname.attname in a function argument
* V710 *acm* 10/16 Ticket 2422: variables uvar_grid, uvar_data_type, uvar_aux_cat, 
*                  uvar_aux_var to be replaced with calls to LIST routines in NCF_Util.c
* V710 *acm*  4/17 Implement ability to run one of a family of functions based on 
*                  arguments that indicate the coordinate directions to operate on,
*                  e.g. DOT(VAR1,VAR2,2) to compute the inner product of the 
*                  variables in the Y direction by running dot_y
* v74  *acm*  1/18 Fixing issue 1575, setting uvar_given for result of grid-changing functions
*                  that return results on abstract axes.
* v74  *acm*  3/18 Backing off the fix for 1575, see comments 3/16/2018

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
        include 'grid_chg_fcns.parm'
	include	'rpn.parm'
	include	'xvariables.cmn'
	include	'xcontext.cmn'
	include	'xalgebra.cmn'
	include	'xtext_info.cmn'
	include	'xfr_grid.cmn'	! w/ mgrid_abstract
	include 'xgrid_chg_fcns.cmn'
	include 'xrisc_buff.cmn' 
c	include 'xtm_grid.cmn_text'  ! with line_name

* calling arguments
	INTEGER		uvar, lo_isp, status
	CHARACTER*(*)	alg_text

* local variables
	LOGICAL	ITS_UN_CACHED, not_reusable, check_alt_fcn
	INTEGER	GCF_FIND_FCN, GCF_find_dir_fcn, GCF_NUM_ARGS, GCF_ARG_TYPE,
     .		MGRID_SIZE_DELTA, GCF_ARG_EVAL_ORDER, EFCN_GET_RTN_TYPE, CGRID_AXIS,
     .		ifcn, icom, iarg, num_com, mr, res_cx,
     .		mr1, mr2, mr3, mr4, mr5, mr6, mr7, mr8, mr9, impl_grid,
     .          typ1, typ2, typ3, typ4, typ5, typ6, typ7, typ8, typ9,
     .          typr, pdim1, pdim2, pdim3, pdim4, pdim5, pdim6, pdim7,
     .          pdim8, pdim9, pdimr, frame_bottom, com_cx, res_mr,
     .          itype, arg_first_mismatch, slen, iset, igrid, idim,
     .          aux_cat(nferdims), aux_var(nferdims), 
     .          idir_args(nferdims), idir_vals(nferdims), num_dirs, ival
        CHARACTER TM_FMT*48, GCF_NAME*40, alt_name*40
	REAL	oneval

* convenience equivalences
	INTEGER	com(10), typ(9), pdim(9)
	EQUIVALENCE (com(1),mr1), (com(2),mr2), (com(3),mr3), (com(4),mr4),
     .              (com(5),mr5),
     .		    (com(6),mr6), (com(7),mr7), (com(8),mr8), (com(9),mr9),
     .              (com(10),res_mr)
	EQUIVALENCE (typ(1),typ1), (typ(2),typ2), (typ(3),typ3),
     .		    (typ(4),typ4), (typ(5),typ5), (typ(6),typ6),
     .		    (typ(7),typ7), (typ(8),typ8), (typ(9),typ9)
        EQUIVALENCE (pdim(1),pdim1), (pdim(2),pdim2), (pdim(3),pdim3),
     .              (pdim(4),pdim4), (pdim(5),pdim5), (pdim(6),pdim6),
     .              (pdim(7),pdim7), (pdim(8),pdim8), (pdim(9),pdim9)

* local parameter declarations
* ... pfloat_words indicates that each float value in an array is 1 word
* ... ptpr_words   indicates that each pointer     in an array is 2 word
* These are assigned to pdim values
	INTEGER	    pfloat_words, pptr_words
#ifdef double_p
	PARAMETER  (pfloat_words = 1,
     .		    pptr_words   = 1 )
#else
	PARAMETER  (pfloat_words = 1,
     .		    pptr_words   = 2 )
#endif

*        ... interpretation stack setup at the time this is called ...
*	stack level		stack contents
*	 isp	<--	most recently obtained component for calculation
*	isp-1		...
*	isp-2	<--	...	other components of this expression on stack
*	isp-n		...
*	lo_isp	<--	level at which expression evaluation was called

* the "frame_bottom" is the isp level that will be left when the components of
* the current calculation (1 to 3) are reduced to a single value.
* on exit isp will point to the frame bottom and the result will be left there

* initialize all data types to default of FLOAT
        DO icom = 1, 9
          typ(icom) = parg_type_float
          pdim(icom) = pfloat_words
        ENDDO

* identify the text of the particular function
*	(internal or external GC fcn handled the same)
	ifcn = GCF_FIND_FCN( alg_text )
	IF ( ifcn .EQ. unspecified_int4 ) STOP ' bad GC fcn err'
	num_com = GCF_NUM_ARGS( ifcn )

* sanity check on stack contents
	frame_bottom = isp - num_com + 1
	IF ( frame_bottom .LE. lo_isp ) CALL ERRMSG
     .		( ferr_syntax, status, 'RPN', *5000 )

* point to the memory resident components
* (if fewer than 9 components default extras to dummy)
	DO icom = 1, num_com
	   com(icom) = is_mr(frame_bottom+icom-1)
	ENDDO
	DO icom = num_com+1, 9
	   com(icom) = dummy_mr
	ENDDO

* trap attempts to pass arguments of the wrong type (1/99)

        arg_first_mismatch = 0
        check_alt_fcn = .FALSE.
	DO 100 icom = 1, num_com
	   iarg = GCF_ARG_EVAL_ORDER(ifcn, icom)
	   itype = GCF_ARG_TYPE(ifcn, iarg)
	   com_cx  = is_cx(frame_bottom+icom-1)
           IF ( cx_type(com_cx) .EQ. ptype_string ) THEN
              typ(icom) = parg_type_string
              pdim(icom) = pptr_words
           ENDIF
	   IF ( (cx_type(com_cx) .EQ. ptype_string)
     .	        .NEQV. (itype .EQ. parg_type_string) ) THEN
	      IF (itype .NE. parg_type_float_or_string)  
     .           check_alt_fcn = .TRUE.
	   ENDIF
	   IF (check_alt_fcn .AND. arg_first_mismatch.EQ.0)
     .        arg_first_mismatch = iarg
 100	CONTINUE

* Does the function designate an alternate function for strings?
* If so, check the argument types for it.

        IF (check_alt_fcn) THEN
*          alt_name is blank-terminated (not null-terminated)
*          and is unchanged if alt_type_fcn does not exist
           alt_name = ' '
	   CALL efcn_get_alt_type_fcn( ifcn, alt_name )  
	   ifcn = GCF_FIND_FCN( alt_name )
	   IF (ifcn .EQ. unspecified_int4) GOTO 5200

* re-initialize all data types to default of FLOAT
           DO icom = 1, 9
             typ(icom) = parg_type_float
             pdim(icom) = pfloat_words
           ENDDO
      	   DO 101 icom = 1, num_com
	      iarg = GCF_ARG_EVAL_ORDER(ifcn, icom)
	      itype = GCF_ARG_TYPE(ifcn, iarg)
	      com_cx  = is_cx(frame_bottom+icom-1)
              IF (cx_type(com_cx) .EQ. ptype_string) THEN
                 typ(icom) = parg_type_string
                 pdim(icom) = pptr_words
              ENDIF
	      IF ( (cx_type(com_cx) .EQ. ptype_string)
     .	           .NEQV. (itype .EQ. parg_type_string) ) THEN
	         IF (itype .NE. parg_type_float_or_string) 
     .              GOTO 5200
	      ENDIF
 101	   CONTINUE
        ENDIF


* Does the function designate an alternate function depending on a 'direction' argument?
* If so update alg_text and ifcn

        has_uvar_dc = .FALSE.
        IF ( ifcn .LE. GFCN_NUM_INTERNAL ) THEN

	   CALL GCF_GET_ALT_FCN_DIR_ARG ( ifcn, idir_args )
	   num_dirs = 0
	   DO idim = 1, nferdims
	      idir_vals(idim) = 0
	   ENDDO

* Collect the directions to use in determing the alt fcn. 
* allow them to be out of dimension order.
	   DO idim = 1, nferdims 
	      IF (idir_args(idim) .GT. 0) THEN
	         CALL RETURN_ONE_VAL (memry(com(idir_args(idim)))%ptr, oneval)
	         ival = INT(oneval)
		 IF (ival.GE.1 .AND. ival.LE.nferdims) THEN
		    IF (idir_vals(ival) .NE. 0) GOTO 5300
		    num_dirs = num_dirs + 1
	            idir_vals(ival) = ival
		 ELSE
		    GOTO 5300  ! invalid value for a direction-setting arg
		 ENDIF
	      ENDIF
	   ENDDO

	   IF (num_dirs .GT. 0) THEN
	      CALL GCF_SET_ALT_FCN_FOR_DIR (ifcn, idir_vals, num_dirs)
	      IF (ifcn .EQ. unspecified_int4 ) GOTO 5400
	      has_uvar_dc = .TRUE.
	   ENDIF
        ENDIF

* the merged context is already nearly complete
	res_cx = is_big_cx(lo_isp)

* determine data type of result - and set pdimr and typr
        IF ( ifcn .LE. GFCN_NUM_INTERNAL ) THEN
*          only truly-internal grid-changing functions get here
*          Ferret already knows the return type since it may depend on argument type
*          (under the get_uvar_grid - is_uvar_grid - merge_grid calling stack)

           iset = cx_data_set(res_cx)
           IF (iset .EQ. unspecified_int4) iset = pdset_irrelevant
	   
	   itype = ptype_unknown
	   CALL GET_SAVED_UVAR_DTYPE(uvar, iset, itype) 

           cx_type(res_cx) = itype
           IF ( cx_type(res_cx) .EQ. ptype_string ) THEN
              typr = pfcn_rtn_string
              pdimr = pptr_words
           ELSE IF ( cx_type(res_cx) .EQ. ptype_float ) THEN
              typr = pfcn_rtn_float
              pdimr = pfloat_words
           ELSE
              STOP 'IS_DO_GC_FCN cs_type(res_cx) is neither ptype_string nor ptype_float'
           ENDIF
        ELSE
*          get the return type from the external function information
*          this includes "external" functions internalized (statically linked in)
           typr = EFCN_GET_RTN_TYPE (ifcn)
           IF ( typr .EQ. pfcn_rtn_string ) THEN
              cx_type(res_cx) = ptype_string
              pdimr = pptr_words
           ELSE IF ( typr .EQ. pfcn_rtn_float ) THEN
              cx_type(res_cx) = ptype_float
              pdimr = pfloat_words
           ELSE
              STOP 'IS_DO_GC_FCN typr is neither pfcn_rtn_string nor pfcn_rtn_float'
           ENDIF

           iset = cx_data_set(res_cx)
           IF (iset .EQ. unspecified_int4) iset = pdset_irrelevant

* Get the stored grid, then save the newly found type with it. The call to
* SAVE_UVAR_GRID wipes out the grid information so also get and re-save the 
* Auxiliary regridding info.
	   
	   CALL GET_SAVED_UVAR_DTYPE(uvar, iset, itype)
	   IF (itype .NE. cx_type(res_cx)) THEN
	      CALL GET_SAVED_UVAR_GRID(uvar, iset, igrid)
	      CALL GET_SAVED_UVAR_AUX_INFO(uvar, iset, aux_cat, aux_var, status)

	      CALL SAVE_UVAR_GRID( uvar, igrid, cx_type(res_cx), iset )
	      CALL SAVE_UVAR_AUX_INFO(uvar, aux_cat, aux_var, iset)
	   ENDIF

        ENDIF

* need to fill in those axes that the function "imposes"
	CALL GCF_IMPOSE_RESULT_LIMS( ifcn,  is_mr(lo_isp+1),
     .			 is_cx(lo_isp+1), res_cx, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
        

* allocate memory space for result
	CALL CREATE_MEM_VAR( res_cx, res_mr, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	mr_category( res_mr ) = cat_temp_var
	mr_variable( res_mr ) = res_mr	! cat_temp_var vars point to themselves
	IF (cx_type(res_cx) .EQ. ptype_string) THEN
	   CALL INIT_C_STRING_ARRAY( MGRID_SIZE_DELTA(res_mr),
     .                               memry(res_mr)%ptr,
     .                               mr_c_pointer(res_mr)      )
	ENDIF

* set up 6D array limits as unsubscripted variables in COMMON
	CALL NON_ARRAY_SUBSC( com, 10 )

* perform the operation

	IF (IFCN .LE. GFCN_NUM_INTERNAL) THEN

	  CALL DO_INTERNAL_GC_FCN( 
     .		ifcn, num_com, is_cx(frame_bottom),
     .		memry(mr1)%ptr, mr1, pdim1, typ1,
     .		memry(mr2)%ptr, mr2, pdim2, typ2,
     .		memry(mr3)%ptr, mr3, pdim3, typ3,
     .		memry(mr4)%ptr, mr4, pdim4, typ4,
     .		memry(mr5)%ptr, mr5, pdim5, typ5,
     .		memry(mr6)%ptr, mr6, pdim6, typ6,
     .		memry(mr7)%ptr, mr7, pdim7, typ7,
     .		memry(mr8)%ptr, mr8, pdim8, typ8,
     .		memry(mr9)%ptr, mr9, pdim9, typ9,
     .		memry(res_mr)%ptr, res_mr, pdimr, typr,
     .		res_cx, status )

c  Fixing issue 1575. If the result grid has an abstract axis in the aa direction, 
c  then set uvar_given(aa_dim,uvar) = uvlim_gvn_gnl

cc	  DO idim = 1, nferdims 
cc	     IF (line_name(CGRID_AXIS(idim,res_cx)) .EQ. 'ABSTRACT') 
cc     .		uvar_given(idim,uvar) = uvlim_gvn_gnl
cc	  ENDDO
  
	ELSE 

	  CALL DO_EXTERNAL_GC_FCN( 
     .			ifcn, num_com, com, is_cx(frame_bottom),
     .			memry(mr1)%ptr, mr1,
     .			memry(mr2)%ptr, mr2,
     .			memry(mr3)%ptr, mr3,
     .			memry(mr4)%ptr, mr4,
     .			memry(mr5)%ptr, mr5,
     .			memry(mr6)%ptr, mr6,
     .			memry(mr7)%ptr, mr7,
     .			memry(mr8)%ptr, mr8,
     .			memry(mr9)%ptr, mr9,
     .			memry(res_mr)%ptr, res_mr,
     .			status )

c  If the result grid has an abstract axis in the aa direction, 
c  then set uvar_given

cc	  DO idim = 1, nferdims 
cc	     IF (line_name(CGRID_AXIS(idim,res_cx)) .EQ. 'ABSTRACT') 
cc     .		uvar_given(idim,uvar) = uvlim_gvn_gnl
cc	  ENDDO

	ENDIF
	IF ( status .NE. ferr_ok ) GOTO 5100

* clean up 
 
* ... if any components were un_cached we must uncache the result
	not_reusable = .FALSE.
	DO 2050 icom = isp, frame_bottom, -1
 2050	IF ( ITS_UN_CACHED(is_mr(icom)) ) not_reusable = .TRUE.
	IF ( not_reusable ) CALL UN_CACHE( res_mr )

* ...release component cx stack space
	DO 2100 isp = isp, frame_bottom, -1
	   IF ( is_cx(isp) .NE. cx_stack_ptr ) WRITE (6,*) 'OP_STK??'	! temp
	   cx_stack_ptr = cx_stack_ptr - 1
	   mr  = is_mr( isp )
	   IF ( mr_protected(mr) .EQ. mr_temporary
     .	   .OR. mr_category (mr) .EQ. cat_temp_var ) THEN
	      CALL DELETE_VARIABLE( mr )
	   ELSE
	      CALL MR_NOT_IN_USE( mr )
	   ENDIF
* (9/95) deallocate dynamic grids from components
	   com_cx = is_cx(isp)
	   IF ( cx_has_impl_grid(com_cx) ) THEN
	      impl_grid = cx_grid(com_cx)
	      CALL DEALLO_DYN_GRID(impl_grid)
	      cx_has_impl_grid(com_cx) = .FALSE.
	   ENDIF
 2100	CONTINUE

* collapse the interp stack frame
	isp = frame_bottom
	is_mr( isp ) = res_mr

* save the result context at the cx level previously used by the 1st component
	cx_stack_ptr = cx_stack_ptr + 1
	CALL TRANSFER_CONTEXT( res_cx, cx_stack_ptr )

	is_cx( isp ) = cx_stack_ptr

	RETURN

* error exit
 5000	RETURN
 5100	CALL DELETE_VARIABLE(res_mr)
	GOTO 5000
* 1/03 *kob* g77 port requires risc buff for arbitrary string concats
* Could not match argument types
 5200   risc_buff = alg_text
	alt_name = TM_FMT(DBLE(arg_first_mismatch), 0, 22, slen)
	CALL ERRMSG( ferr_invalid_command, status,
     .		'string/numeric data type mix-up. Argument '//
     .		alt_name(:slen)//' : '//risc_buff, *5000 )

* Invalid value for for direction
 5300   risc_buff = alg_text
	CALL ERRMSG( ferr_invalid_command, status,
     .          'Arguments for direction of function must not repeat '//
     .          'and be between 1 and 6 '//
     .          risc_buff, *5000 )


* Could not find alternative function for direction
 5400   risc_buff = alg_text
	CALL ERRMSG( ferr_invalid_command, status,
     .		'Could not find alternative function for directions given '//
     .		risc_buff, *5000 )

	END

* 
*  expndi_by.F
* 
*  Steve Hankin
*  1/16/2001
*  ACM v6.85 3/2013 Fix handling of bad-flags coming in on Arg 1
* 
*  Expand argument 1 by inserting a gap before each valid point in 
* argument 2 along axis I
*  Argument 2 may be multidimensional
 
*  In this subroutine we provide information about
*  the function.  The user configurable information 
*  consists of the following:
* 
*  descr              Text description of the function
* 
*  num_args           Required number of arguments
* 
*  axis_inheritance   Type of axis for the result
*                        ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                        CUSTOM          - user defined axis
*                        IMPLIED_BY_ARGS - same axis as the incoming argument
*                        NORMAL          - the result is normal to this axis
*                        ABSTRACT        - an axis which only has index values
* 
*  piecemeal_ok       For memory optimization:
*                        axes where calculation may be performed piecemeal
*                        ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE expndi_by_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .       'Expand arg1 by inserting gaps before valid pts of arg 2' )

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                ABSTRACT,        IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)


      arg = 1
      CALL ef_set_arg_name(id, arg, 'dat')
      CALL ef_set_arg_desc(id, arg, 'variable to gap-expand on I axis')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, YES, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'mask')
      CALL ef_set_arg_desc(id, arg,
     .          'valid/bad points guiding gap insertions (multi-D)')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, YES, YES, YES, YES, YES)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'outsize')
      CALL ef_set_arg_desc(id, arg,
     .          'I size of result (constant)')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END






*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE expndi_by_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      REAL size

*
*     Use utility functions to get context information about the arguments.
*

      CALL ef_get_one_val(id, ARG3, size)

      CALL ef_set_axis_limits(id, X_AXIS, 1, INT(ABS(size)))

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END



* 
*  In this subroutine we compute the result
* 
      SUBROUTINE expndi_by_compute(id, arg_1, arg_2, arg_3, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2
      INTEGER imax

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      imax = res_hi_ss(X_AXIS)

* pre-fill the entire output result with missing value flags
*  (since each I-sequence in mask may have different number of valid pts)
      DO 10 n=res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
      DO 10 m=res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
      DO 10 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
      DO 10 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
      DO 10 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
      DO 10 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
         result(i,j,k,l,m,n) = bad_flag_result
 10   CONTINUE

* fill in the points as specified by the mask
      n1 = arg_lo_ss(F_AXIS,ARG1)
      n2 = arg_lo_ss(F_AXIS,ARG2)
      DO 600 n=res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

         m1 = arg_lo_ss(E_AXIS,ARG1)
         m2 = arg_lo_ss(E_AXIS,ARG2)
         DO 500 m=res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

            l1 = arg_lo_ss(T_AXIS,ARG1)
            l2 = arg_lo_ss(T_AXIS,ARG2)
            DO 400 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

               k1 = arg_lo_ss(Z_AXIS,ARG1)
               k2 = arg_lo_ss(Z_AXIS,ARG2)
               DO 300 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

                  j1 = arg_lo_ss(Y_AXIS,ARG1)
                  j2 = arg_lo_ss(Y_AXIS,ARG2)
                  DO 200 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

                     i1 = arg_lo_ss(X_AXIS,ARG1)
                     i  = res_lo_ss(X_AXIS)
                     DO 100 i2 = arg_lo_ss(X_AXIS,ARG2),
     .                           arg_hi_ss(X_AXIS,ARG2)

                        IF ( arg_2(i2,j2,k2,l2,m2,n2)
     .                       .NE. bad_flag(2) ) THEN
*                          Insert a gap
                           IF (i .GT. imax) CALL EF_BAIL_OUT(id,
     .                                          'Arg 3 size too small')
                           result(i,j,k,l,m,n) = bad_flag_result
                           i = i + 1
                        ENDIF
                        IF (i .GT. imax) CALL EF_BAIL_OUT(id,
     .                                          'Arg 3 size too small')
                        IF ( arg_1(i1,j1,k1,l1,m1,n1) .NE. bad_flag(1) ) 
     .                    result(i,j,k,l,m,n) = arg_1(i1,j1,k1,l1,m1,n1) 

                        i1 = i1 + arg_incr(X_AXIS,ARG1)
                        i = i + 1
 100                 CONTINUE

                     j1 = j1 + arg_incr(Y_AXIS,ARG1)
                     j2 = j2 + arg_incr(Y_AXIS,ARG2)
 200              CONTINUE

                  k1 = k1 + arg_incr(Z_AXIS,ARG1)
                  k2 = k2 + arg_incr(Z_AXIS,ARG2)
 300           CONTINUE

               l1 = l1 + arg_incr(T_AXIS,ARG1)
               l2 = l2 + arg_incr(T_AXIS,ARG2)
 400        CONTINUE

            m1 = m1 + arg_incr(E_AXIS,ARG1)
            m2 = m2 + arg_incr(E_AXIS,ARG2)
 500     CONTINUE

         n1 = n1 + arg_incr(F_AXIS,ARG1)
         n2 = n2 + arg_incr(F_AXIS,ARG2)
 600  CONTINUE

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	SUBROUTINE CDF_PREP_CACHE( dflt_cx, filename, nvars, 
     .			           mrlist, cxlist, clobber, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* setup to create a DODS NetCDF cache
* create a list of contexts appropriate to describe the (1,1,1,1) element
* of each variable in the DODS data set.

* programmer - steve hankin

* V450	11/96

* V600 *acm* 3/06  fixing bugs 439&1390, new arg to get_new_cx.
*       *acm* 3/12 cleanup old VMS ifdef
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V685 *acm*  3/13 For Ensemble aggregations, call the ds_type 'ENS'
* V695 *acm*  2/15 For Forecast aggregations, call the ds_type 'FCT'
* V7   *acm*  6/12 Add Union aggregations: DEFINE DATA/AGG/U, ds_type 'UNI'


        IMPLICIT NONE
        include 'tmap_errors.parm'
        include 'tmap_dims.parm'
        include 'xdset_info.cmn_text'
	include	'ferret.parm'
	include	'slash.parm'
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xprog_state.cmn'
	include 'xrisc_buff.cmn'

* calling argument declarations:
	LOGICAL clobber
	INTEGER dflt_cx, nvars, mrlist(*), cxlist(*), status
	CHARACTER TM_INQ_PATH*2048, filename*(*)

* local variable declarations
	LOGICAL		TM_HAS_STRING, fexist, ok_cache
	INTEGER		TM_LENSTR1,
     .			qfile, dset, cx0, cx, ivar, idim, flen, dlen,
     .			iin, iout
	CHARACTER	ch*1, raw_name*200

* local parameter declarations
	INTEGER         slash_file
	PARAMETER     ( slash_file    = 12+1)

* determine the data set in question
        CALL GET_NEW_CX( dflt_cx, cx_cmnd, .TRUE., status )
        IF ( status .NE. ferr_ok ) GOTO 5000
	dset = cx_data_set(cx_cmnd)
	IF ( dset .EQ. unspecified_int4 ) GOTO 5100
	ok_cache = ( TM_HAS_STRING(ds_type(dset),'CDF') .OR. 
     .		     TM_HAS_STRING(ds_type(dset),'ENS') .OR. 
     .		     TM_HAS_STRING(ds_type(dset),'FCT') .OR.
     .		     TM_HAS_STRING(ds_type(dset),'UNI') .OR.
     .               TM_HAS_STRING(ds_des_name(dset)(:8), 'http://') )
        IF (.NOT. ok_cache) GOTO 5200

* determine the directory to receive the cached file
        qfile = qual_given( slash_file )
        IF ( qfile .GT. 0 ) THEN
           CALL EQUAL_STR_LC(
     .			cmnd_buff(qual_start(qfile):qual_end(qfile)),
     .                  raw_name, status )
           IF ( status .NE. ferr_ok ) GOTO 5000
* ... translate a possible env. var. at start of directory name.
*	Make sure the directory exists.
	   filename = TM_INQ_PATH( raw_name, ' ', ' ',
     .			.TRUE., status )
           IF ( status .NE. merr_ok ) GOTO 5000
	ELSE
	   filename = '.'
        ENDIF

* create the file name from the directory name
* ... name too long to cache?
	flen = TM_LENSTR1(filename)
	dlen = TM_LENSTR1(ds_des_name(dset))
	IF ( LEN(ds_des_name(dset)) .EQ. dlen ) GOTO 5300
	IF ( LEN(filename) .LE. flen+dlen-7 ) GOTO 5300
	filename(flen+1:flen+1) = '/'		! after user-supplied directory
	iout = flen+2				
	DO 10 iin = 8, dlen			! just past the "http://"
	   ch = ds_des_name(dset)(iin:iin)	
	   IF ( ch .EQ. '/' ) THEN
	      filename(iout:iout) = '_'
	   ELSE
	      filename(iout:iout) = ch 
	   ENDIF
	   iout = iout + 1
 10	CONTINUE

* if the file already exists and we are not in clobber mode ---> error
	IF ( .NOT.clobber ) THEN
	   INQUIRE( FILE = filename, EXIST = fexist )
	   IF ( fexist ) GOTO 5400
	ENDIF

* create a base context
        CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
        IF ( status .NE. ferr_ok ) GOTO 5000
        cx0 = cx_stack_ptr
        cx_data_set(cx0) = dset
        cx_category(cx0) = cat_file_var
        DO 20 idim = 1, nferdims
          cx_lo_ss(cx0,idim) = 1
          cx_hi_ss(cx0,idim) = 1
          cx_by_ss(idim,cx0) = .TRUE.
          cx_trans(idim,cx0) = trans_no_transform
          cx_given(idim,cx0) = .FALSE.
          cx_delta(idim,cx0) = unspecified_val8
 20    CONTINUE

* set up one dummy variable for each variable in the data set
	nvars = 0
	DO 100 ivar = 1, maxvars
	   IF ( ds_var_setnum(ivar) .NE. dset ) GOTO 100
           CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
           IF ( status .NE. ferr_ok ) GOTO 5000
           cx = cx_stack_ptr
	   nvars = nvars + 1
	   cxlist(nvars) = cx
	   CALL TRANSFER_CONTEXT(cx0, cx)
           cx_variable(cx) = ivar
	   cx_grid(cx)     = ds_grid_number(ivar)
	   cx_bad_data(cx) = ds_bad_flag( ivar )
	   DO 110 idim = 1, nferdims
	      CALL FLESH_OUT_AXIS( idim, cx, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
 110	   CONTINUE
	   CALL CREATE_TEMP_MEM_VAR( cx, mrlist(nvars), status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   CALL UN_CACHE( mrlist(nvars) )
!	   memory(1, mr_blk1(mrlist(nvars))) = 0.0    ! just good house-keeping
 100	CONTINUE

* echo the name of the output cache file
* 1/03 *kob* g77 port demands the use of risc_buff
	risc_buff = filename(1:TM_LENSTR1(filename))
	CALL SPLIT_LIST(pttmode_bull, ttout_lun,
     .		' LISTing to file '//risc_buff,0)

	RETURN

* error exits
 5000	CALL DELETE_MRS_IN_PROGRESS		! remove temporary vars
	RETURN
 5100	CALL ERRMSG( ferr_invalid_command, status,
     .			'no data set specified to cache', *5000 )
 5200	CALL ERRMSG( ferr_invalid_command, status,
     .			'can only cache a DODS NetCDF data set', *5000 )
 5300	CALL ERRMSG( ferr_invalid_command, status,
     .			'URL string too long to cache', *5000 )

* 1/03 *kob* g77 port demands the use of risc_buff
 5400	risc_buff = filename
	CALL ERRMSG( ferr_invalid_command, status,
     .			'/CLOBBER not specified and file exists: '
     .			//risc_buff, *5000 )

	END

      SUBROUTINE YAXIS2(X,XFACT,YLO,YHI,YUNIT,LABEL,IFORMT,IAXIS,
     * YFACT,CSIZE,xacross,hgrat,hcolor,hline,color0)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)yaxis2.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
* *acm* - 6/01   changes to allow plot qualifiers to set log axes,
*                inverse log axes and log depth axes.
* *acm* - 8/16   ticket 1787: restore pen 0 correctly after graticule

	CHARACTER YLAB*20,IFORMT*(*),YFRMT*12
	COMMON/TICS/TSMX,TLX,TSMY,TLY,IX,IY
	COMMON/AXLWID/XWID,YWID

* Parameters for drawing tics across plot

        REAL xacross
        REAL dash1_1, dash1_2, dash1_3, dash1_4 
        REAL dash2_1, dash2_2, dash2_3, dash2_4
        REAL hgrat(4,2)        ! line type: 0=tics only, <0=line, >0=dash lengths 
        REAL yt
        INTEGER hcolor(*)      ! pen number for graticule lines
        INTEGER color0         ! pen number to restore
        LOGICAL hline          ! If true, do the lines across.
        LOGICAL solid1,solid2  ! solid lines across at large, small tics
        LOGICAL dashed1, dashed2 ! dashed lines across at large, small tics

        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'lines_inc.decl'
        include 'LINES.INC'
        INCLUDE 'pen_inc.decl'  ! with IPEN(1)
        INCLUDE 'PEN.INC'

C
C     THIS ROUTINE PLOTS SEVERAL TYPES OF BASE 10 LOG YAXIS.
C         X,XFACT,YFACT HAVE THEIR USUAL MEANINGS.
C         IF CSIZE > 0 THE LABELS HAVE THAT HEIGHT.
C         IF CSIZE < 0 THE LABELS HAVE HEIGHT -CSIZE AND HAVE
C             NEGATIVE THEIR TRUE VALUE.
C         YLO AND YHI ARE THE LOGS OF YOUR YLO AND YHI IN USER UNITS.
C         YUNIT IS ALSO THE LOG OF WHAT IT IS IN USER UNITS.
C         LABEL = -1 FOR LABELING ON THE LEFT OF YOUR Y AXIS.
C         LABEL = +1 FOR LABELING ON THE RIGHT OF YOUR Y AXIS.
C         LABEL =  0 FOR NO LABELS.
C         IFORMT = TO BE FILLED IN LATER.
C
C         IAXIS = STYLE OF AXIS.
C                = 0 FOR NO AXIS
C                = 1 FOR A SIMPLE LOG AXIS WITH ONE LABEL PER DECADE.
C                  IN THIS CASE YLO, YHI MUST= LOG(POWER OF 10)
C                  AND IFORMT IS IGNORED.
C                  YUNIT MUST = LOG(POWER OF 10)
C               GE 2  GIVES THE INVERSE SCALE OF IAXIS = 1

      IF(IAXIS.EQ.0) RETURN
      ABSSZ=ABS(CSIZE)
      TYLO=IFIX(1.0001*YLO)
      TYHI=IFIX(1.0001*YHI)
      TYUNIT=IFIX(1.0001*YUNIT)
      NDEC=TYHI-TYLO
!      IF(NDEC.LT.1) STOP 'YLO,YHI'
      IF(NDEC.LT.1) THEN
         NDEC = -1* ndec
         SGN  = TYHI	! use SGN as a dummy
         TYHI = TYLO
         TYLO = SGN
      ENDIF

C
C	DRAW AXIS
C
	IF(IAXIS.EQ.1)THEN
		Y=TYLO
		SGN= 1.0
	ELSE
		Y=TYHI
		SGN=-1.0
	ENDIF
 
        solid1 = (hgrat(1,1).LT.0 .AND. hgrat(2,1).LT.0 .AND.  
     .            hgrat(3,1).LT.0 .AND.  hgrat(4,1).LT.0 )
        solid2 = (hgrat(1,2).LT.0 .AND. hgrat(2,2).LT.0 .AND.  
     .            hgrat(3,2).LT.0 .AND.  hgrat(4,2).LT.0 )
        dashed1 = (hgrat(1,1).GT.0 .OR. hgrat(2,1).GT.0 .OR.  
     .            hgrat(3,1).GT.0 .OR.  hgrat(4,1).GT.0 )
        dashed2 = (hgrat(1,2).GT.0 .OR. hgrat(2,2).GT.0 .OR.  
     .            hgrat(3,2).GT.0 .OR.  hgrat(4,2).GT.0 )
        IF (dashed1) THEN
           dash1_1 = hgrat(1,1)
           dash1_2 = hgrat(2,1)
           dash1_3 = hgrat(3,1)
           dash1_4 = hgrat(4,1)
        ENDIF
        IF (dashed2) THEN
           dash2_1 = hgrat(1,2)
           dash2_2 = hgrat(2,2)
           dash2_3 = hgrat(3,2)
           dash2_4 = hgrat(4,2)
        ENDIF

	IF  (IAXIS .LE. 3) THEN
	   CALL PLOT(X,Y,0,0)
	   CALL PLOTT7(X,Y,XFACT,YFACT,1,-6)
	   DO 110 I=1,NDEC    ! large tics

	      DO 100 J=2,9    ! small tics

                 CALL PLOTT7(X,Y+SGN*(I-1+ALOG10(FLOAT(J))),XFACT,YFACT,1,-5)

                 IF ((solid2.OR.dashed2) .AND. hline) THEN ! make line across
                   yt = Y+SGN*(I-1+ALOG10(FLOAT(J)))
                   CALL COLOR(hcolor(2))
                    IF (dashed2) THEN
                       CALL DASHSZ(dash2_1,dash2_2,dash2_3,dash2_4)
                       CALL DASHES
                    ENDIF
                    CALL PLOT(X,yt,0,0) 
                    CALL PLOT(xacross,yt,1,0)
                    CALL PLOT(X,yt,0,0) 
                    CALL COLOR(color0)
                    CALL VECTRS
                 ENDIF
             
100           CONTINUE

              CALL PLOTT7(X,Y+SGN*I,XFACT,YFACT,1,-6) ! draw large tic

              IF ((solid1.OR.dashed1) .AND. hline) THEN ! make line across
                 yt = Y+SGN*I
                 CALL COLOR(hcolor(1))
                 IF (dashed1) THEN
                    CALL DASHSZ(dash1_1,dash1_2,dash1_3,dash1_4)
                    CALL DASHES
                 ENDIF
                 CALL PLOT(X,yt,0,0) 
                 CALL PLOT(xacross,yt,1,0)
                 CALL PLOT(X,yt,0,0) 
                 CALL COLOR(color0)
                 CALL VECTRS
              ENDIF

110        CONTINUE

	ELSE

C  for DEPTH axes, Y plot coordinates are reversed on page.

           YTEMP = Y + SGN* NDEC
	   CALL PLOT(X,YTEMP,0,0)
	   CALL PLOTT7(X,YTEMP,XFACT,YFACT,1,-6)
	   DO 130 I=1,NDEC      ! large tics
	      DO 120 J=2,9      ! small tics
                 CALL PLOTT7(X,YTEMP+(I-1+ALOG10(FLOAT(J))),XFACT,YFACT,1,-5)

                 IF ((solid2.OR.dashed2) .AND. hline) THEN ! make line across
                   yt = YTEMP+(I-1+ALOG10(FLOAT(J)))
                   CALL COLOR(hcolor(2))
                    IF (dashed2) THEN
                       CALL DASHSZ(dash2_1,dash2_2,dash2_3,dash2_4)
                       CALL DASHES
                    ENDIF
                    CALL PLOT(X,yt,0,0) 
                    CALL PLOT(xacross,yt,1,0)
                    CALL PLOT(X,yt,0,0) 
                    CALL COLOR(color0)
                    CALL VECTRS
                 ENDIF

120           CONTINUE
              CALL PLOTT7(X,YTEMP+I,XFACT,YFACT,1,-6)  ! make large tic
              
              IF ((solid1.OR.dashed1) .AND. hline) THEN ! make line across
                 yt = ytemp+i
                 CALL COLOR(hcolor(1))
                 IF (dashed1) THEN
                    CALL DASHSZ(dash1_1,dash1_2,dash1_3,dash1_4)
                    CALL DASHES
                 ENDIF
                 CALL PLOT(X,yt,0,0) 
                 CALL PLOT(xacross,yt,1,0)
                 CALL PLOT(X,yt3/2/2004,0,0) 
                 CALL COLOR(color0)
                 CALL VECTRS
              ENDIF

130        CONTINUE
        ENDIF
C
C	DRAW LABELS
C
	IF(LABEL.EQ.0)RETURN
	IF(LABEL+IY.EQ.0)THEN
		XTEMP=0.0
	ELSE
		XTEMP=TLY*0.5
	ENDIF
	IF(LABEL.EQ.1)THEN
		IPOS=2
	ELSE
		IPOS=1
	ENDIF
	YWID=0.75*ABSSZ+XTEMP
	XTEMP=X+LABEL*YWID/XFACT
	IF(CSIZE.LT.0.)THEN
		NC=5
		YFRMT='(''-E'',I3)'
	ELSE
		NC=4
		YFRMT='(''E'',I3)'
	ENDIF
	YWIDT=0.0
	DO 200 I=0,NDEC
c	WRITE(YLAB,YFRMT)IFIX(SGN*(Y-TYUNIT+I))	! wrong nums for log depth axis 

	IF (SGN .GE. 0) THEN
            WRITE(YLAB,YFRMT)IFIX((Y-TYUNIT+SGN*I))
            YTEMP = Y + SGN*I

C  for DEPTH axes, Y plot coordinates are reversed on page.

        ELSE IF (SGN .LT. 0.)THEN
            WRITE(YLAB,YFRMT)IFIX((Y-TYUNIT+SGN*(NDEC-I)))
            YTEMP = Y + SGN*(NDEC-I)
        ENDIF

	CALL SCINOT(XTEMP,YTEMP,0.,ABSSZ,NC,YLAB,IPOS,WID,XFACT,YFACT)

	IF(WID.GT.YWIDT)YWIDT=WID
200	CONTINUE
	YWID=YWID+YWIDT
	RETURN
	END

	SUBROUTINE BOX_LABEL( lab_type, string, xpos, ypos, xsize, ysize,
     .			      lab_ht, justify, xaxrel, yaxrel )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* create a PLOT+ label that fits within the designated box
* if necessary, use commas in the text as places where the string can be broken
* into 2 lines
* the position given refers to the lower left of the box

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V200:	  2/2/90
*	 3/30/90 - use font info in calling SYMWID
* Unix/RISC port - 1/91 - cant use "//" with CHAR*(*)
* v552 *acm* 3/03 multi-line strings in titles and labels.
*                 If the string starts with @ do not set ASCII font
*                 for title and X and Y label; lets user set pen and font.
*                 Note can do colors and ASCII fonts, if set pen first: @P2@AC
* V68  *acm*  4/11 - more on bug 1098. Break up labels by sending <NL> to pplus
*                    instead of creating multiple moveable labels. 
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* v690 *sh* 3/16 - use a new list of potential break characters
*                - lower the width threshold for decidint to break into 2
*                - see "tuned up" comment.  Only search for "," if bad break
*                - DP conversion bug fix:  "ht" was used instead of "rht" 
* V7   *acm* 6/16 see ticket 2435. Tweak to split dataset labels after DATA SET:

        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'plot_setup.parm'
	include 'xprog_state.cmn'
	include 'xrisc.cmn'

* calling argument declarations
	INTEGER lab_type, justify, xaxrel, yaxrel, k, numlines
	REAL	xpos, ypos, xsize, ysize, lab_ht
	CHARACTER string*(*), font*3

* internal variable declarations
        INTEGER lnbeg(250), lnend(250)
	INTEGER	TM_LENSTR1, STR_SAME, i, slen, nfont, brk_pt, 
     .          nex_brk_pt, las_brk_pt, nlines, ibr
	REAL	ymid, width, frac, frac_width, las_frac, xend,
     .          htsave, ht
        REAL*4  SYMWID, rht
	CHARACTER*1 break_char, break_chars(6)

* initialize
	ymid = ypos + ysize*0.5
	ht = MIN( lab_ht, ysize )
	slen = TM_LENSTR1( string )

* Choose the break character. If there are commas use them. If there
* are any slashes, use that.  Else use underscore or dash.
! 3/16 -- this logic could be tuned up.  Here we select the first occurrence 
! of a particular break char, based priority ordering.  Below, if the
! break is in the wrong place, we insist on keeping the same break char,
! and we only look forward in the string.
	break_chars(1) = ','
	break_chars(2) = ' '
	break_chars(3) = '['
	break_chars(4) = ':'
	break_chars(5) = '/'
	break_chars(6) = '-'
	DO ibr = 1, 5
	   break_char = break_chars(ibr)
	   brk_pt = INDEX( string(:slen), break_char )
	   IF (brk_pt .GT. 0) EXIT
	ENDDO

* Hack: Break DATA SET string after DATA SET: not between DATA and SET.
	IF (slen.GT.8) THEN
	IF (STR_SAME(string(1:8), 'DATA SET').EQ.0) THEN
	   DO ibr = 1, 5
	      break_char = break_chars(ibr)
	      brk_pt = INDEX( string(6:slen), break_char )
	      IF (brk_pt .GT. 0) EXIT
	   ENDDO
	   brk_pt = brk_pt + 5
	ENDIF
	ENDIF

* ... brk_pt will = 0 here if nothing found
	IF (break_char .EQ. '[') brk_pt = MAX(1,brk_pt-1) ! break before "[" 
	risc_buff = string			! for RISC/FORTRAN

* compute the width of the string in the font that it will be presented
        numlines = 1
        call tm_break_lines (string, lnbeg, lnend, numlines)

* select PLOT+ font

        nfont = 0

	IF ( .NOT.mode_font_ascii ) THEN
	   font = ' '
	ELSEIF ( lab_type .EQ. ppl_title ) THEN
	   font = '@AC'
           nfont = 3
	ELSE
	   font = '@AS'
           nfont = 3
	ENDIF

* Let user select the font if they want

        IF (string(1:1) .EQ. "@") THEN
           font = ' '
           nfont = 0
        ENDIF

        width = 0.
        rht = ht
        DO 330 k = 1, numlines
           slen = lnend(k) - lnbeg(k) + 1
           risc_buff = string(lnbeg(k):lnend(k) )
           width = MAX(width, DBLE(SYMWID( rht, 
     .          slen+nfont, font//risc_buff(:slen) )))
  330      CONTINUE

	slen = TM_LENSTR1( string )
	risc_buff = string			! for RISC/FORTRAN

* left or right justify or center
	xend = xpos
	IF ( xaxrel .EQ. lab_loc_absolute ) THEN
	   IF ( justify .EQ. ppl_right_just ) THEN
	      xend = xpos + xsize   
	   ELSEIF ( justify .EQ. ppl_centered ) THEN
	      xend = xpos + 0.5*xsize
	   ENDIF
	ENDIF

* titles and axis labels cannot be broken into multiple lines
* (unless the user does it with <NL> inserted in the strings)

	nlines = 2
	IF ( (lab_type.EQ.ppl_title) .OR. (lab_type.EQ.ppl_xlab) 
     .        .OR. (lab_type.EQ.ppl_ylab)  ) THEN
	   nlines = 1
	ENDIF

* should we write the label in a single line ?
! 3/2016 *sh* -- there's a fudge factor here multiplying xsize
! dunno what is wrong in the calcs that makes this the thing to do
! Was 1.8.  Now 1.15
	IF ( nlines .LT. 2
     .	.OR. width .LE. xsize*1.15
     .	.OR. brk_pt.EQ.0 .OR. brk_pt.EQ.slen ) GOTO 500

* it's too big - we will try to write it as 2 lines
* ... break into pieces as close to halves as possible
	las_frac = 999.0
 100	IF ( .NOT.mode_font_ascii ) THEN
	   rht = ht
	   frac_width = DBLE(SYMWID(rht,brk_pt,string(:brk_pt) ))
	ELSEIF ( lab_type .EQ. ppl_title ) THEN
	   rht = ht
c	   frac_width = DBLE(SYMWID( ht, brk_pt+3, '@AC'//risc_buff(:brk_pt)  ))
	   frac_width = DBLE(SYMWID( rht, brk_pt, risc_buff(:brk_pt)  ))
	ELSE
	   rht = ht
c	   frac_width = DBLE(SYMWID( ht, brk_pt+3, '@AS'//risc_buff(:brk_pt)  ))
	   frac_width = DBLE(SYMWID( rht, brk_pt, risc_buff(:brk_pt)  ))
	ENDIF
	frac = frac_width / width
	IF ( frac.LT.0.2 .OR. frac .GT.0.8) THEN
! insist on breaking off at least .2 of its length
	   break_char = ','  ! 3/2016 -- only look for commas
	   nex_brk_pt = INDEX( string(brk_pt+1:), break_char ) + brk_pt
	   IF ( nex_brk_pt.EQ.brk_pt .OR. nex_brk_pt.EQ.slen ) GOTO 200
	   las_frac   = frac
	   las_brk_pt = brk_pt
	   brk_pt     = nex_brk_pt
	   GOTO 100

	ELSEIF ( frac .GT. las_frac ) THEN
	   brk_pt = las_brk_pt
	   frac = las_frac

	ENDIF

* don't break into 2 lines unless both lines are reasonably long
	IF ( frac.LT.0.2 .OR. frac.GT.0.8 ) GOTO 500

* WRITE STRING AS 2 LINES
* Adjusting height so we don't take more vertical space than expected

 200	width = MAX(frac, 1.-frac) * width
	ht = MIN( ysize*0.4, ht*MIN(1.,xsize/width) )

! 3/16 -- the labels are just a tad too tall -- colliding together
	ht = 0.95*ht  ! 3/16

* ... line 1<NL>line 2
	CALL PUT_LABEL( lab_type, xend, ymid, justify, ht,
     .			string(:brk_pt)//'<NL>'//string(brk_pt+1:), 
     .			xaxrel, yaxrel )
	RETURN


* WRITE STRING AS 1 LINE
 500	htsave = ht

* Adjust character size for the length of the longest line
        ht = ht * MIN(1., 1.25* xsize/width)

* Adjust character size for the number of lines
        IF (lab_type .NE. ppl_movlab) THEN
           IF  (numlines .GE. 4 .AND. ht .EQ. htsave) ht = 0.5*ht
           IF  (numlines .EQ. 3 .AND. ht .EQ. htsave) ht = 0.65*ht
           IF  (numlines .EQ. 2 .AND. ht .EQ. htsave) ht = 0.8*ht
        ENDIF

	CALL PUT_LABEL( lab_type, xend, ymid-0.5*ht, justify, ht,
     .			string(:slen), xaxrel, yaxrel )
	RETURN
	END

	SUBROUTINE CD_WRITE_GRID ( cdfid, dset, grid, lo, hi, recdim, 
     .                           itsa_slab, gname, edges_flag, 
     .                           do_bounds, mode_upcase_output, 
     .                           keepax_flag, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Write a grid definition out to the current output netCDF file

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 3/92
*               10/92 - put into netCDF into define mode before writing attribs
*		1/95  - change in "parent" argument to cd_write_axis (now int)
*   11/95 - *sh* use CD_AXIS_NAME rather than line_name for dynamic lines
*    2/96 - *sh* same deal for dynamic grids ... a quick fix right here
* v500 *kob*  3/99 - change lengths of CD_CHILDAX_NAME, CD_AXIS_NAME,
*                    lname to 64 from 24 to match longer line_name
* v570 *acm*  6/04 - changes to use bounds attribute
* V602 *acm* 11/06 - Fix bug 1471; new routine CD_AXIS_OUTNAME gets correct 
*                    output axis name.
* V62  *acm*  2/09 - Fix bug 1634: allow SAVE/KEEP_AXISNAMES so that child axis names
*                    arent written. They can get too long for OPeNDAP library calls
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V67  *acm* 3/11  Fix bug 1750. Revert to older behavior: if grid uses same axis
*                  name but different contents, write both to file with the name
*                  Ferret uses internally.
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing
* V685 6/13 *acm* new qualifier SAVE/NOBOUNDS
* V685 6/13 *acm* Dont add SAVE/NOCOORDS
* V687 3/14 *acm* Fix ticket 1750. Write Ferret-internal axis names to cdf files, unless
*                 the user has said /KEEP_AXISNAMES
* V69+ 4/14 *acm* After the above fix, need a tweak to be able to append to files having 
*                 dimensions that are not coordinate variables
* V710 9/16 *acm* Use ww_dim_name from xtext_info.cmn

* argument definitions:
*     cdfid   - netCDF id number for already opened CDF file
*     grid    - TMAP grid id
*     lo      - low indices of variable hyperslab
*     hi      - high indices of variable hyperslab
*     recdim  - which axis (1-4) is to be the CDF record axis
*     itsa_slab- does the underlying variable need a formal grid defn
*     gname   - the name of the parent grid created
*     status  - return status

* include files
        include 'netcdf.inc'
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
        include 'cdf_tmap.parm'
#include "gt_lib.parm"
        include 'cd_lib.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xtext_info.cmn'  ! with ww_dim_name

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

* argument declarations
      LOGICAL itsa_slab, mode_upcase_output
      INTEGER cdfid, dset, grid, lo(nferdims), hi(nferdims), recdim, 
     .        edges_flag, keepax_flag, do_bounds, status
      CHARACTER*(*) gname

* local variable declarations:
      LOGICAL gmod, name_from_grid, dim_only
      INTEGER TM_LENSTR1, 
     .        defid, defdim, nlen, slen, cdfstat, iaxis, idim, glen, i
      CHARACTER CD_CHILDAX_NAME*132, CD_AXIS_OUTNAME*132, CD_AXIS_NAME*132,
     .		names*132, lname*132

* are the axes, alone, enough of a grid definition
      IF ( .NOT.itsa_slab ) GOTO 100

* put CDF into define mode so attributes can be written
      CALL CD_SET_MODE(cdfid, pcd_mode_define, status)
      IF ( status .NE. merr_ok ) RETURN

* create "grid_definition" dimension name if not already in the file
#ifdef usingDODSf2cUnderscore
       	cdfstat = NF_INQ_DIMID_( cdfid, 'grid_definition', defdim)
      IF ( cdfstat .NE. NF_NOERR ) cdfstat = NF_DEF_DIM_ 
     .     ( cdfid, 'grid_definition', 1, defdim )
#else
       	cdfstat = NF_INQ_DIMID( cdfid, 'grid_definition', defdim)
      IF ( cdfstat .NE. NF_NOERR ) cdfstat = NF_DEF_DIM 
     .     ( cdfid, 'grid_definition', 1, defdim )
#endif


* create an output grid name that reflects axes which have been averaged, etc.
* and a string with a list of the axis names (starting w/ 2 blanks)
      gname = grid_name(grid)
      glen = TM_LENSTR1( gname )
! 2/96 - strip parentheses from dynamic grid name
      IF ( gname(1:1).EQ.'(' .AND. glen.GT.2 ) THEN
	gname = gname(2:glen-1)
	glen = glen - 2
      ENDIF
! 2/96 - end of insertion
      gmod = .FALSE.
      names = ' '
      nlen = 1
      DO 50 idim = 1, nferdims
         iaxis = grid_line(idim, grid)

         lname = CD_AXIS_NAME( dset, grid, idim, slen )
         IF (keepax_flag .EQ. 1)  lname = 
     .        CD_AXIS_OUTNAME( dset, grid, idim, slen )

         IF ( iaxis .EQ. mpsnorm ) THEN
            names = names(:nlen)//' '//'NORMAL'
         ELSEIF ( lo(idim) .EQ. unspecified_int4 ) THEN
            names = names(:nlen)//' '//'NORMAL'
            IF ( gmod ) THEN
               gname = gname(:glen)//ww_dim_name(idim)
               glen = glen + 1
            ELSE
               gname = gname(:glen)//'_N'//ww_dim_name(idim)
               gmod = .TRUE.
               glen = glen + 3
            ENDIF

         ELSEIF ( lname .EQ. 'ABSTRACT' .AND. (keepax_flag.EQ.0)) THEN
            names = names(:nlen)//' '//
     .           CD_CHILDAX_NAME( ww_dim_name(idim)//'AX',
     .                            lo(idim), hi(idim), i )
         ELSE
            names = names(:nlen)//' '//lname
         ENDIF
         nlen = TM_LENSTR1(names)
 50   CONTINUE

* does this grid already exist ? (no consistency check if so)
#ifdef usingDODSf2cUnderscore
      cdfstat = NF_INQ_VARID_( cdfid, gname(:glen), defid )
#else
      cdfstat = NF_INQ_VARID ( cdfid, gname(:glen), defid )
#endif
      IF ( cdfstat .EQ. NF_NOERR ) GOTO 1000

* create a dummy variable for this grid definition
#ifdef usingDODSf2cUnderscore
      cdfstat = NF_DEF_VAR_( cdfid, gname(:glen), NF_CHAR, 1,
     .                defdim, defid )
#else
      cdfstat = NF_DEF_VAR ( cdfid, gname(:glen), NF_CHAR, 1,
     .                defdim, defid )
#endif

* write the axis list as an attribute of the grid
#ifdef usingDODSf2cUnderscore
      cdfstat = NF_PUT_ATT_TEXT_( cdfid, defid, 'axes', nlen-2,
     .             names(3:))
#else
      cdfstat = NF_PUT_ATT_TEXT ( cdfid, defid, 'axes', nlen-2,
     .             names(3:))
#endif

* create the parent axes
 100  DO 200 idim = 1, nferdims
         IF ( grid_line(idim, grid) .NE. mpsnorm
     .  .AND. lo(idim) .NE. unspecified_int4     ) THEN
            CALL CD_WRITE_AXIS( cdfid, dset, grid, idim, 
     .           idim.EQ.recdim,
     .           lo(idim), hi(idim), pcdf_full_span, 
     .           edges_flag, do_bounds, mode_upcase_output,
     .           keepax_flag, name_from_grid, dim_only, status ) 

            IF ( status .NE. merr_ok ) GOTO 5900
         ENDIF
 200  CONTINUE

* successful completion
 1000 status = merr_ok
      RETURN

* error exit
 5900   RETURN
	END

*           rr_grad_ps_v.F
*
*          Rick Romea
*           Jan. 24, 2000
*
*     Surface pressure gradient term in the v momentum equation
*     Units :     cm/s/s
*     MOM2 Grid:  U   
*
************************************************************************

      SUBROUTINE RR_grad_ps_v_init(id)
	IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

      CALL ef_set_desc             (id,
     .'Surface (barotropic) -dp/dy term (cm/s^2) on the MOM2 U Grid')
      CALL ef_set_num_args         (id, 2)
      CALL ef_set_has_vari_args    (id, NO)
      CALL ef_set_axis_inheritance (id, IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok     (id,  NO,  NO,  NO,  NO)

      CALL ef_set_arg_name         (id, ARG1, 'U')
      CALL ef_set_arg_desc         (id, ARG1,
     . 'Zonal velocity,required to access MOM2 U Grid. ')
      CALL ef_set_arg_unit         (id, ARG1, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG1, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG1, YES, YES, YES, YES)
      CALL ef_set_axis_extend      (id, ARG1, X_AXIS,0,+1)
      CALL ef_set_axis_extend      (id, ARG1, Y_AXIS,0,+1)
      
      CALL ef_set_arg_name         (id, ARG2, 'SURF_PRESS')
      CALL ef_set_arg_desc         (id, ARG2,
     . 'Surface Pressure, on the MOM2 T Grid. ')
      CALL ef_set_arg_unit         (id, ARG2, 'g/cm/sec^2')
      CALL ef_set_arg_type         (id, ARG2, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2, NO, NO, NO, YES)
      CALL ef_set_axis_extend      (id, ARG2, X_AXIS,0,+1)
      CALL ef_set_axis_extend      (id, ARG2, Y_AXIS,0,+1)
      END

************************************************************************

      SUBROUTINE RR_grad_ps_v_compute(id, arg_1, arg_2, result)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS)
      REAL bad_flag_result
      REAL arg_1  (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .             mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2  (mem2lox:mem2hix, mem2loy:mem2hiy, 
     .             mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL result (memreslox:memreshix, memresloy:memreshiy, 
     .             memresloz:memreshiz, memreslot:memreshit)

      INTEGER  res_lo_ss (4)
      INTEGER  res_hi_ss (4)
      INTEGER  res_incr  (4)

      INTEGER  arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER  arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER  arg_incr  (4,EF_MAX_ARGS)

      INTEGER i,  j,  k,  l
      INTEGER i1, j1, k1, l1

      REAL*8         yU(1024)

      INTEGER        ilat

      CHARACTER *16  ax_name(4)
      CHARACTER *16  ax_units(4)
      LOGICAL        backward(4)
      LOGICAL        modulo(4)
      LOGICAL        regular(4)

      REAL       dyt

	INCLUDE 'rr_parameters.h'

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags      (id, bad_flag,  bad_flag_result)

      ! Get U grid coordinates

      CALL ef_get_coordinates    (id, ARG1, Y_AXIS, 
     .                            arg_lo_ss(Y_AXIS,ARG1),
     .                            arg_hi_ss(Y_AXIS,ARG1), yU)

      ! check axis units

      CALL ef_get_axis_info  (id, ARG2, ax_name, ax_units, 
     .                                backward, modulo, regular) 
      IF     ( ax_units(1) .NE. 'deg'       .AND.
     .         ax_units(1) .NE. 'lon'       .AND.
     .         ax_units(1) .NE. 'degrees_E' .AND.
     .         ax_units(1) .NE. 'longitude' .AND.
     .         ax_units(1) .NE. 'Longitude' .AND. 
     .         ax_units(1) .NE. 'LONGITUDE' ) THEN
        WRITE (6,*)'Longitude axis units =', ax_units(1) 
        ! CALL ef_bail_out(id,'Longitude axis must be in degrees')
      ENDIF

      IF     ( ax_units(2) .NE. 'deg'       .AND.
     .         ax_units(2) .NE. 'lat'       .AND.
     .         ax_units(2) .NE. 'degrees_N' .AND.
     .         ax_units(2) .NE. 'latitude'  .AND.
     .         ax_units(2) .NE. 'Latitude'  .AND. 
     .         ax_units(2) .NE. 'LATITUDE' ) THEN
        WRITE (6,*)'Latitude axis units =', ax_units(2) 
        ! CALL ef_bail_out(id,'Latitude axis must be in degrees')
      ENDIF

      ! start the loop

      iLat = 1
      j1 = arg_lo_ss(Y_AXIS,ARG2) 
      DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

         dyt = SNGL  (yU(iLat+1)-yU(iLat)) * Longitude_to_cm

         i1 = arg_lo_ss(X_AXIS,ARG2) 
         DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG2)
            DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               l1 = arg_lo_ss(T_AXIS,ARG2)
               DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

                  IF (
     .              arg_2(i1,  j1,  k1,l1) .EQ. bad_flag(ARG2) .OR.
     .              arg_2(i1,  j1+1,k1,l1) .EQ. bad_flag(ARG2) .OR.
     .              arg_2(i1,  j1-1,k1,l1) .EQ. bad_flag(ARG2) .OR.
     .              arg_2(i1+1,j1,  k1,l1) .EQ. bad_flag(ARG2) .OR.
     .              arg_2(i1+1,j1+1,k1,l1) .EQ. bad_flag(ARG2) .OR.
     .              arg_2(i1+1,j1-1,k1,l1) .EQ. bad_flag(ARG2) .OR.
     .              arg_2(i1-1,j1,  k1,l1) .EQ. bad_flag(ARG2) .OR.
     .              arg_2(i1-1,j1+1,k1,l1) .EQ. bad_flag(ARG2) .OR.
     .              arg_2(i1-1,j1-1,k1,l1) .EQ. bad_flag(ARG2) 
     .                      ) THEN
                     result(i,j,k,l) = bad_flag_result
                  ELSE
                     result(i,j,k,l) = - (
     .                            arg_2(i1+1,j1+1,k1,l1)
     .                        +   arg_2(i1  ,j1+1,k1,l1)
     .                        -   arg_2(i1+1,j1  ,k1,l1)
     .                        -   arg_2(i1  ,j1  ,k1,l1)
     .                ) / 2. / rho_zero / dyt
     .                 * sec_per_month
                  ENDIF

                  l1 = l1 + arg_incr(T_AXIS,ARG2)
               ENDDO

               k1 = k1 + arg_incr(Z_AXIS,ARG2)
            ENDDO

            i1 = i1 + arg_incr(X_AXIS,ARG2)
         ENDDO

         iLat = iLat + 1
         j1 = j1 + arg_incr(Y_AXIS,ARG2)
      ENDDO
      END

	SUBROUTINE CD_DSG_GRIDS ( dset, cdfid, temp_axnams, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Loads the common block XGRID with grid definitions from a CF-DSG
* netCDF file 
* also initialize grid limits (lo hi bounds on each axis) for these variables

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V720 4/17 *sh*
* V74+ 4/18 *acm* Getting DSG grids
* V74+ 4/18 *acm* Allow for the NCEI-style datasets which are one feature
*                 per file but they put the obs variables on 2D grids, 
*                 temp(feature, nobs)
* V74+ 4/18 *acm* Allow scalar variables on normal grid
* V74+ 6/18 *acm* Check the feature direction and report errors. 
* V74+ 7/18 *acm* Handle a rowsize variable that we have synthesized 
*                 when there's not one in the file. 
* V74+ 7/18 *acm* Better handling of grids of char variables
* V76  1/20 *acm* Fix access to rowsize variable. 
*                 Handle point datasets. 
* V76  1/20 *acm* Orientation of Point-type data set to e_dim

* argument definitions:
*       dset        - TMAP data set pointer
*	cdfid	    - netCDF id number for already opened CDF file
*       temp_axnams - nferdims axis names per grid: temp until grids are assembled
*	status	    - return status

* include files

        include 'netcdf.inc'
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
	include 'errmsg.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
        include 'xbuild_grids.cmn'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xio.cmn_text'
	external xio_data
	include 'xtm_grid.cmn_text'
	        include 'xdset_info.cd_equiv'

* argument declarations
	INTEGER	 dset, cdfid, status
	CHARACTER*128 temp_axnams(nferdims,max_temp_grid)

* local variable declarations:
* *kob* explicit definitions not allowed on decl line in linux...
*       moved them to parameter line 10/96
      LOGICAL coordvar, one_by_nobs
      INTEGER TM_LENSTR1, TM_FIND_GRID_SLOT,
     .	      i, tmvar, ivar, vartyp, nvdims, vdims(8), nvatts, vlen,
     .	      all_outflag, idim, tmpgrid, obs_orient, igrid, grid_cnt,
     .	      istat, ax_len, check_dir
      CHARACTER name*128, vname*128
      CHARACTER*20 CD_DSG_FEATURENAME
      CHARACTER*2  direc(4)

      DATA	direc(1) / 'XY' /,
     .		direc(2) / 'XY' /,
     .		direc(3) / 'Z ' /,
     .		direc(4) / 'T' /

* initialize temporary grid name pointer
	num_tmp_grids = 0
	DO i = max_grids, grid_ceiling
	   tmp_nam_ptr(i) = 0
	ENDDO
	obs_orient = dsg_orientation(dset)
	
	check_dir = x_dim
	IF (obs_orient .EQ. pfeatureType_Trajectory) check_dir = x_dim
	IF (obs_orient .EQ. pfeatureType_Profile   ) check_dir = z_dim
	IF (obs_orient .EQ. pfeatureType_TimeSeries) check_dir = t_dim 

* * * * loop through each variable in this TMAP data set * * *
* if it doesn't have a grid pointer create a suitable one and point to it
        DO tmvar = 1,maxvars
           IF ( ds_var_setnum(tmvar) .NE. dset ) CYCLE
           ivar = cd_varid(tmvar)

* get the vital statistics for this variable
           CALL CD_GET_VAR_INFO(dset, ivar, vname, vartyp, nvdims,
     .                 vdims, nvatts, coordvar, all_outflag, istat)
           IF (istat.NE.merr_ok) CALL TM_ERRMSG
     .     ( istat+pcdferr,status,'CD_DSG_GRIDS',cdfid,ivar,
     .       no_errstring, no_errstring, *5900 )
           vlen = TM_LENSTR1(vname)

* The rowsize variable may have been constructed in cd_dsg_scan_vars. If so,
* use the grid from the feature-id variable.

	   IF (tmvar .EQ.  dsg_row_size_var(dset)) THEN
	      IF (vname .EQ. 'ferRowSize' .AND.
     .            ds_grid_number(dsg_feature_var(dset)) .NE. int4_init) THEN
	         i = dsg_feature_var(dset)
		 ds_grid_number(tmvar) = ds_grid_number(i)
	         DO idim = 1, nferdims
                    ds_grid_start(idim,tmvar) = ds_grid_start(idim,i)
                    ds_grid_end  (idim,tmvar) = ds_grid_end  (idim,i)
	         ENDDO

		 GOTO 5000
	      ENDIF 
	   ENDIF


* if a string variable, the first dimension is the string axis (ignore it)
	   IF (vartyp .EQ. NF_CHAR) THEN
	      IF (nvdims .GT. 1) nvdims = nvdims - 1
	      vdims(1) = vdims(2)
	   ENDIF

* use the next grid building slot to build a grid for this variable
           tmpgrid = num_tmp_grids + 1

* initialize the grid axis info
	   DO idim = 1, nferdims
              temp_axnams(idim,tmpgrid) = 'NORMAL'
	      ds_ordering  (idim,tmvar) = 0
              ds_grid_start(idim,tmvar) = 1
              ds_grid_end  (idim,tmvar) = 1
	   ENDDO

* all DSG grids have the E axis of instances (scalars handled below).
             
	   temp_axnams(5,tmpgrid) = line_name(dsg_instance_axis)
	   ds_grid_end(5,tmvar)   = line_dim (dsg_instance_axis)

* assign the remaining grid info
	   IF (vdims(1) .EQ. dsg_instance_dim) THEN
* ... 1D instance grid
	      ds_ordering(1,tmvar) = 5

* ... This allows for the NCEI-style files which are a single feature
*     with obs variables on a nobs by 1 grid

	      one_by_nobs = (nvdims.EQ.2 .AND. 
     .             line_dim (dsg_instance_axis).EQ.1 .AND. 
     .             vdims(2).EQ.dsg_obs_dim) 

	      IF (one_by_nobs) THEN
	         temp_axnams(obs_orient,tmpgrid) = line_name(dsg_obs_axis)
	         ds_grid_end(obs_orient,tmvar)   = line_dim (dsg_obs_axis)
	         ds_ordering(2,tmvar) = 5
	         ds_ordering(1,tmvar) = obs_orient
	      ENDIF

	   ELSEIF (vdims(1) .EQ. dsg_obs_dim) THEN
* ... 2D observation grid 
	      temp_axnams(obs_orient,tmpgrid) = line_name(dsg_obs_axis)
	      ds_grid_end(obs_orient,tmvar)   = line_dim (dsg_obs_axis)
	      ds_ordering(2,tmvar) = 5
	      ds_ordering(1,tmvar) = obs_orient

* scalar variables are allowed, normal grid.
	   ELSEIF (nvdims.EQ.0) THEN
              temp_axnams(5,tmpgrid) = 'NORMAL'
	      ds_grid_end(5,tmvar)   = 1

	   ELSE
	      
* ... variable does not belong with this DSG dataset

* TODO: maybe other variables should be ignored (removed from dset)
*         rather than aborting the DSG processing

	      GOTO 4100
	   ENDIF

* Does the data have obs data along the direction relative to the feature type?
* e.g. timeseries feature type must have time on the obs axis, trajectory data
* must have data in X,Y

	   IF (tmvar .EQ. dsg_coord_var(check_dir, dset) .AND. 
     .         dsg_feature_type(dset).NE.pfeatureType_Point) THEN
	      IF ( ds_grid_end(obs_orient,tmvar) .NE. line_dim(dsg_obs_axis) ) 
     .              GOTO 4200
	   ENDIF

	   IF (nvdims.GE.2 .AND. line_dim (dsg_instance_axis).GT.1 .AND. 
     .             vdims(2).EQ.dsg_obs_dim) GOTO 4100

* ... does Ferret's "native taxis" apply to a DSG?  TBD
* TBD??:  we could create a dataset time axis using min/max and
* time encoding from the DSG time coordinate variable
* would that make the Ferret time code easier to use?
* Would need to pass this back as an argument
!	   native_tax = mpsnorm

* is the temporary grid we just created unique ?
* (code copied unaltered from CD_GET_GENERIC_GRIDS)
* DSGTBD: worth it to make this block a subroutine?
	   igrid = 0
 300	   CALL TM_NEXT_TMP_GRID( igrid, *320)
	      grid_cnt = tmp_nam_ptr(igrid)
              DO 310 idim = 1, nferdims
                 IF ( temp_axnams(idim,tmpgrid )
     .          .NE.  temp_axnams(idim,grid_cnt) ) GOTO 300
 310          CONTINUE
* ... not unique - exact match with one that already exists
              GOTO 350
 320	   CONTINUE
 
* allocate a new grid
* find next location to store info; if too many grids - give error
	  CALL TM_ALLO_TMP_GRID(igrid, status)
	  IF (status .NE. merr_ok) GOTO 5900

* make up a unique grid name "GXXnn" where XX is hashed from data set name
          grid_name(igrid) = 'G'//cd_dset_code(dset)(:2)
          CALL TM_NEW_GRID_NAME( grid_name(igrid), name )
          grid_name(igrid) = name

* basic defaults
          grid_rotation(igrid) = 0.0
          DO 340 idim = 1, nferdims
 340      grid_out_prod(idim,igrid) = .TRUE.

* save a pointer to this grid for the TMAP variable
 350      ds_grid_number(tmvar) = igrid

       ENDDO  ! loop tmvar over vars

* successful completion
 5000 	status = merr_ok
        RETURN

* error exits
* soft error - reject this as a dsg_ragged dataset, but soldier on as a netCDF
 4100	CALL TM_NOTE("invalid CF-DSG variable: "//vname(:vlen)//
     .		     " in file: "//ds_name(dset), lunit_errors)
! DSGTBD: Have not checked that aborted DSG leads to valid gridded file.
!     Probably not.  Need to decide how much trouble to go to.
	GOTO 5900

 4200	CONTINUE

	name = CD_DSG_FEATURENAME (dsg_user_direction)
	vlen = TM_LENSTR1( name )

 	CALL TM_ERRMSG (merr_dsg_grid, status, 'CD_DSG_GRIDS',
     .     no_descfile, no_stepfile,
     .     'FeatureType '//name(:vlen)//
     .     ' must have observations along '//direc(dsg_user_direction),
     .     no_errstring, *5900)

* error exit
 5900	CONTINUE
	CALL TM_GARB_COL_GRIDS (dset)
	CALL CD_RELEASE_DSG_INSTANCE_VARS(dset)
	dsg_ragged(dset) = .FALSE.
	
        RETURN
	END

	INTEGER FUNCTION AUX_AXIS_FROM_ARG( cx, arg_num )

*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* given the argument number within a specified aux var regrid
* return the corresponding axis orientation (idim)

	IMPLICIT NONE

	include	'ferret.parm'
        include 'tmap_dims.parm'
	include	'xcontext.cmn'

* calling argument declarations:
	INTEGER	 cx, arg_num

* internal variable declarations:
	INTEGER	 i, idim


* which auxiliary var is the subject of interest?
* e.g. for "temp[gz(depth)=zax]" the argument "depth" is found in the z dim
	i = 1
	DO 100 idim = 1, nferdims
	   IF (cx_aux_stat(idim, cx) .NE. paux_stat_na ) THEN
! ??     .	 .AND. cx_aux_stat(idim, cx) .NE. paux_passed  ) THEN
	      IF (i .EQ. arg_num) THEN
	         GOTO 1000
	      ELSE
	         i = i + 1  ! not the right argument yet
	      ENDIF
	   ENDIF
 100	CONTINUE
* ... should never land here
	CALL WARN( 'YIKES: aux_var_crptn' )

 1000	AUX_AXIS_FROM_ARG = idim
	RETURN
	END

* 
*  expndi_id_by_z_counts.F
* 
*  Ansley Manke (from expndi_by_z)
*  8/24/2011
* 
* Create a variable with profile ID, where argument 1 is the length
* of the variable to be put into an XZ structure from it with the 
* Z length specified by column 2.  This creates an "ID" variable to
* go along with the XZ variable defined by expndi_by_z_counts.
 
*  In this subroutine we provide information about
*  the function.  The user configurable information 
*  consists of the following:
* 
*  descr              Text description of the function
* 
*  num_args           Required number of arguments
* 
*  axis_inheritance   Type of axis for the result
*                        ( CUSTOM, IMPLIED_BY_Z_ARGS, NORMAL, ABSTRACT )
*                        CUSTOM          - user defined axis
*                        IMPLIED_BY_Z_ARGS - same axis as the incoming argument
*                        NORMAL          - the result is normal to this axis
*                        ABSTRACT        - an axis which only has index values
* 
*  piecemeal_ok       For memory optimization:
*                        axes where calculation may be performed piecemeal
*                        ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE expndi_id_by_z_counts_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .  'Create 2D list, ID by profile-length on an XZ grid.' )

      CALL ef_set_num_args(id, 2)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, ABSTRACT, 
     .     IMPLIED_BY_ARGS, ABSTRACT, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'counts')
      CALL ef_set_arg_desc(id, arg,
     .          'count of values in each profile')
      CALL ef_set_axis_influence(id, arg, NO, YES, NO, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'max profile len')
      CALL ef_set_arg_desc(id, arg,
     .          'K size of result (constant)')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END






*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE expndi_id_by_z_counts_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      REAL size
      integer arg, nx, nz
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

*
*     Use utility functions to get context information about the arguments.
*
* output X axis size
* output Z axis size

* Length of x

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      arg = 1
      nx = arg_hi_ss(X_AXIS,arg) - arg_lo_ss(X_AXIS,arg) + 1
      CALL ef_set_axis_limits(id, X_AXIS, 1, nx)

* Length of z 
      CALL ef_get_one_val(id, ARG2, size)
      nz = INT(size)

      CALL ef_set_axis_limits(id, X_AXIS, 1, nx)
      CALL ef_set_axis_limits(id, Z_AXIS, 1, nz)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END



* 
*  In this subroutine we compute the result
* 
      SUBROUTINE expndi_id_by_z_counts_compute(id, arg_1, arg_2, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy,
     .	   mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy,
     .     mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1
      INTEGER iout, kout, isum
      REAL size, xlen, zlen

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* Length of x*z 

      xlen = arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 1
      zlen = res_hi_ss(Z_AXIS) - res_lo_ss(Z_AXIS) + 1

* arg 1 must not depend on z
      IF ( (arg_lo_ss(Z_AXIS,ARG1) .NE. arg_hi_ss(Z_AXIS,ARG1)) ) CALL
     .           EF_BAIL_OUT(id, 'Z size of arg 1 must be 1')

* pre-fill the entire output result with missing value flags
*  (since length of each profile may have different number of pts)
      DO 60 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         DO 50 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            DO 40 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
               DO 30 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
 30            result(i,j,k,l) = bad_flag_result
 40         CONTINUE
 50      CONTINUE
 60   CONTINUE

* fill in the points as specified by the counts
      k1 = arg_lo_ss(Z_AXIS,ARG1)

      l1 = arg_lo_ss(T_AXIS,ARG1)
      DO 400 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            i1 = 1
            DO 200 iout = 1, NINT(xlen)
               DO 100 kout = 1, NINT(arg_1(iout,j1,k1,l1))
                  result(iout,j,kout,l) = iout
                  i1 = i1 + 1
 100           CONTINUE
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 300     CONTINUE

         l1 = l1 + arg_incr(T_AXIS,ARG1)
 400  CONTINUE
      
         
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

* 
*  pco2.F
* 
*  Andreas Schmittner (andreas@passagen.uni-kiel.de)
*  Mai 26th 2004
* 
*  Returns pCO2 of water
* 
* 
*


      SUBROUTINE pco2_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .  'returns pCO2 (ppmv=uatm) using OCMIP routines' )

      CALL ef_set_num_args(id, 4)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'TEMP')
      CALL ef_set_arg_unit(id, arg, 'deg C')
      CALL ef_set_arg_desc(id, arg, 'temperature')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'SALT')
      CALL ef_set_arg_unit(id, arg, 'su')
      CALL ef_set_arg_desc(id, arg, 'salinity')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'DIC')
      CALL ef_set_arg_unit(id, arg, 'mmol/m^3')
      CALL ef_set_arg_desc(id, arg, 'dissolved inorganic carbon')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'ALK')
      CALL ef_set_arg_unit(id, arg, 'mmol/m^3')
      CALL ef_set_arg_desc(id, arg, 'total alkalinity')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


* 
*  In this subroutine we compute the result
* 
      SUBROUTINE pco2_compute(id, arg_1, arg_2, arg_3, arg_4, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy,
     .	   mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy,
     .     mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy,
     .     mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy,
     .     mem4loz:mem4hiz, mem4lot:mem4hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1
      INTEGER i2, j2, k2, l2
      INTEGER i3, j3, k3, l3
      INTEGER i4, j4, k4, l4
      real pt_in,sit_in,atmpres,phlo,phhi,co2ccn, ph, co2star, 
     .     co2starair, dco2star, pco2surf, dpco2, pco2atm

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      co2ccn=280.
      pt_in=0.5125e-3           !mol/m^3
      atmpres=1.0               !atm
      sit_in=7.6875e-03         !mol/m^3
      phlo=6.
      phhi=9.

      i1 = arg_lo_ss(X_AXIS,ARG1)
      i2 = arg_lo_ss(X_AXIS,ARG2)
      i3 = arg_lo_ss(X_AXIS,ARG3)
      i4 = arg_lo_ss(X_AXIS,ARG4)
      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         j2 = arg_lo_ss(Y_AXIS,ARG2)
         j3 = arg_lo_ss(Y_AXIS,ARG3)
         j4 = arg_lo_ss(Y_AXIS,ARG4)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            k2 = arg_lo_ss(Z_AXIS,ARG2)
            k3 = arg_lo_ss(Z_AXIS,ARG3)
            k4 = arg_lo_ss(Z_AXIS,ARG4)
            DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

            l1 = arg_lo_ss(T_AXIS,ARG1)
            l2 = arg_lo_ss(T_AXIS,ARG2)
            l3 = arg_lo_ss(T_AXIS,ARG3)
            l4 = arg_lo_ss(T_AXIS,ARG4)
            DO 100 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)


                  IF ( arg_1(i1,j1,k1,l1) .EQ. bad_flag(1) .OR. 
     .                 arg_2(i2,j2,k2,l2) .EQ. bad_flag(2) .OR.
     .                 arg_3(i3,j3,k3,l3) .EQ. bad_flag(3) .OR.
     .                 arg_4(i4,j4,k4,l4) .EQ. bad_flag(4) ) THEN

                     result(i,j,k,l) = bad_flag_result

                  ELSE

                     call co2calc(arg_1(i1,j1,k1,l1)
     &                    ,arg_2(i2,j2,k2,l2),arg_3(i3,j3,k3,l3)
     &                    ,arg_4(i4,j4,k4,l4),pt_in,sit_in
     &                    ,phlo,phhi,ph,co2ccn,atmpres,co2star
     &                    ,co2starair,dco2star,pCO2surf,dpco2
     &                    ,pCO2atm)
                     result(i,j,k,l) = pCO2surf

                  END IF


                  l1 = l1 + arg_incr(T_AXIS,ARG1)
                  l2 = l2 + arg_incr(T_AXIS,ARG2)
                  l3 = l3 + arg_incr(T_AXIS,ARG3)
                  l4 = l4 + arg_incr(T_AXIS,ARG4)
 100           CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
               k2 = k2 + arg_incr(Z_AXIS,ARG2)
               k3 = k3 + arg_incr(Z_AXIS,ARG3)
               k4 = k4 + arg_incr(Z_AXIS,ARG4)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
            j2 = j2 + arg_incr(Y_AXIS,ARG2)
            j3 = j3 + arg_incr(Y_AXIS,ARG3)
            j4 = j4 + arg_incr(Y_AXIS,ARG4)
 300     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
         i2 = i2 + arg_incr(X_AXIS,ARG2)
         i3 = i3 + arg_incr(X_AXIS,ARG3)
         i4 = i4 + arg_incr(X_AXIS,ARG4)
 400  CONTINUE
      
         
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

c_ ---------------------------------------------------------------------
c_ RCS lines preceded by "c_ "
c_ ---------------------------------------------------------------------
c_
c_ $Source$ 
c_ $Revision$
c_ $Date$   ;  $State$
c_ $Author$ ;  $Locker$
c_
c_ ---------------------------------------------------------------------
c_ $Log$
c_ Revision 1.1  2004/06/01 17:38:06  ansley
c_ add pco2 function from Andreas Schmittner
c_
c_ Revision 1.8  1999/07/16 11:40:33  orr
c_ Modifications by Keith Lindsay to fix inconsistency with common block
c_ "species" (not the same in "ta_iter_1.f").
c_ Also comment lines changed/added by J. Orr.
c_
c_ Revision 1.7  1999/04/26  13:04:54  orr
c_ Modified USAGE comment, to include new arguments
c_
c_ Revision 1.6  1999/04/14 12:55:52  orr
c_ Changed units for input arguments for tracers:
c_ formerly in mol/metric ton (T); now in mol/m^3.
c_ Used 1024.5 kg/m^3 as a constant conversion factor.
c_ Modelers can now pass tracers on a per volume basis, as carried in models.
c_
c_ Revision 1.5  1999/04/06 16:57:37  orr
c_ Changed calc of dpCO2 to account for diff atm pressure
c_
c_ Revision 1.4  1999/04/06 13:17:58  orr
c_ Added 2 output arguments: pCO2surf and dpCO2
c_ (see section 4 of Biotic HOWTO)
c_
c_ Revision 1.3  1999/04/05 15:59:11  orr
c_ Cleaned up comments regarding units
c_
c_ Revision 1.2  1999/04/04 02:35:00  orr
c_ Changed units for input and output tracers:
c_ previously in umol/kg; now in mol/T
c_ Can also pass input and output in mol/m^3 with little error.
c_
c_ Revision 1.1  1999/04/03  21:59:56  orr
c_ Initial revision
c_
c_ ---------------------------------------------------------------------
c_ 
      subroutine co2calc(t,s,dic_in,ta_in,pt_in,sit_in
     &                  ,phlo,phhi,ph,xtco2in,atmpres,co2star
     &                  ,co2starair,dco2star,pCO2surf,dpCO2
     &                  ,pCO2atm)
C
C-------------------------------------------------------------------------
C SUBROUTINE CO2CALC
C
C PURPOSE
C       Calculate delta co2* from total alkalinity and total CO2 at
C temperature (t), salinity (s) and "atmpres" atmosphere total pressure. 
C
C USAGE
C       call co2calc(t,s,dic_in,ta_in,pt_in,sit_in
C    &                  ,phlo,phhi,ph,xco2_in,atmpres
C    &                  ,co2star,dco2star,pCO2surf,dpco2)
C
C INPUT
C       dic_in = total inorganic carbon (mol/m^3) 
C                where 1 T = 1 metric ton = 1000 kg
C       ta_in  = total alkalinity (eq/m^3) 
C       pt_in  = inorganic phosphate (mol/m^3) 
C       sit_in = inorganic silicate (mol/m^3) 
C       t      = temperature (degrees C)
C       s      = salinity (PSU)
C       phlo   = lower limit of pH range
C       phhi   = upper limit of pH range
C       xco2_in=atmospheric mole fraction CO2 in dry air (ppmv) 
C       atmpres= atmospheric pressure in atmospheres (1 atm==1013.25mbar)
C
C       Note: arguments dic_in, ta_in, pt_in, sit_in, and xco2_in are 
C             used to initialize variables dic, ta, pt, sit, and xco2.
C             * Variables dic, ta, pt, and sit are in the common block 
C               "species".
C             * Variable xco2 is a local variable.
C             * Variables with "_in" suffix have different units 
C               than those without.

C OUTPUT
C       co2star  = CO2*water (mol/m^3)
C       dco2star = delta CO2 (mol/m^3)
c       pco2surf = oceanic pCO2 (ppmv)
c       dpco2    = Delta pCO2, i.e, pCO2ocn - pCO2atm (ppmv)
C
C IMPORTANT: Some words about units - (JCO, 4/4/1999)
c     - Models carry tracers in mol/m^3 (on a per volume basis)
c     - Conversely, this routine, which was written by observationalists 
c       (C. Sabine and R. Key), passes input arguments in umol/kg  
c       (i.e., on a per mass basis)
c     - I have changed things slightly so that input arguments are in mol/m^3,
c     - Thus, all input concentrations (dic_in, ta_in, pt_in, and st_in) 
c       should be given in mol/m^3; output arguments "co2star" and "dco2star"  
c       are likewise in mol/m^3.

C FILES and PROGRAMS NEEDED
C       drtsafe
C       ta_iter_1
C
C--------------------------------------------------------------------------
C
        include "species.h"
        real invtk,is,is2,xtco2in
c        real k0,k1,k2,kkw,kb,ks,kf,k1p,k2p,k3p,ksi
        real drtsafe
        real t, s, dic_in, ta_in, pt_in, sit_in, phlo, phhi, ph, 
     .       atmpres, co2star, co2starair, dco2star, pco2surf, dpco2, 
     .       pco2atm, permil, permeg, xtco2, tk, tk100, tk1002, dlogtk, 
     .       sqrtis, s2, sqrts, s15, scl, ff, x1, x2, xacc, htotal, 
     .       htotal2

        external ta_iter_1
C

c       ---------------------------------------------------------------------
C       Change units from the input of mol/m^3 -> mol/kg:
c       (1 mol/m^3)  x (1 m^3/1024.5 kg)
c       where the ocean's mean surface density is 1024.5 kg/m^3
c       Note: mol/kg are actually what the body of this routine uses 
c       for calculations.  
c       ---------------------------------------------------------------------
        permil = 1.0 / 1024.5
c       To convert input in mol/m^3 -> mol/kg 
        pt=pt_in*permil
        sit=sit_in*permil
        ta=ta_in*permil
        dic=dic_in*permil

c       ---------------------------------------------------------------------
C       Change units from uatm to atm. That is, atm is what the body of 
c       this routine uses for calculations.
c       ---------------------------------------------------------------------
        permeg=1.e-6
c       To convert input in uatm -> atm
        xtco2=xtco2in*permeg
c       ---------------------------------------------------------------------
C
C*************************************************************************
C Calculate all constants needed to convert between various measured
C carbon species. References for each equation are noted in the code. 
C Once calculated, the constants are
C stored and passed in the common block "const". The original version of this
C code was based on the code by Dickson in Version 2 of "Handbook of Methods
C for the Analysis of the Various Parameters of the Carbon Dioxide System
C in Seawater", DOE, 1994 (SOP No. 3, p25-26). 
C
C Derive simple terms used more than once
C
        tk = 273.15 + t
        tk100 = tk/100.0
        tk1002=tk100*tk100
        invtk=1.0/tk
        dlogtk=log(tk)
        is=19.924*s/(1000.-1.005*s)
        is2=is*is
        sqrtis=sqrt(is)
        s2=s*s
        sqrts=sqrt(s)
        s15=s**1.5
        scl=s/1.80655
C
C f = k0(1-pH2O)*correction term for non-ideality
C
C Weiss & Price (1980, Mar. Chem., 8, 347-359; Eq 13 with table 6 values)
C
        ff = exp(-162.8301 + 218.2968/tk100  +
     &          90.9241*log(tk100) - 1.47696*tk1002 +
     &          s * (.025695 - .025225*tk100 + 
     &          0.0049867*tk1002))
C
C K0 from Weiss 1974
C
        k0 = exp(93.4517/tk100 - 60.2409 + 23.3585 * log(tk100) +
     &          s * (.023517 - 0.023656 * tk100 + 0.0047036 * tk1002))

C
C kk1 = [H][HCO3]/[H2CO3]
C k2 = [H][CO3]/[HCO3]
C
C Millero p.664 (1995) using Mehrbach et al. data on seawater scale 
C
        kk1=10**(-1*(3670.7*invtk - 62.008 + 9.7944*dlogtk -
     &          0.0118 * s + 0.000116*s2))
C
        k2=10**(-1*(1394.7*invtk + 4.777 - 
     &          0.0184*s + 0.000118*s2))
C
C kb = [H][BO2]/[HBO2]
C
C Millero p.669 (1995) using data from Dickson (1990)
C
        kb=exp((-8966.90 - 2890.53*sqrts - 77.942*s +
     &          1.728*s15 - 0.0996*s2)*invtk +
     &          (148.0248 + 137.1942*sqrts + 1.62142*s) +
     &          (-24.4344 - 25.085*sqrts - 0.2474*s) *
     &          dlogtk + 0.053105*sqrts*tk)
C
C k1p = [H][H2PO4]/[H3PO4]
C
C DOE(1994) eq 7.2.20 with footnote using data from Millero (1974)
C
        k1p = exp(-4576.752*invtk + 115.525 - 18.453 * dlogtk +
     &          (-106.736*invtk + 0.69171) * sqrts +
     &          (-0.65643*invtk - 0.01844) * s)
C
C k2p = [H][HPO4]/[H2PO4]
C
C DOE(1994) eq 7.2.23 with footnote using data from Millero (1974))
C
        k2p = exp(-8814.715*invtk + 172.0883 - 27.927 * dlogtk +
     &          (-160.340*invtk + 1.3566) * sqrts +
     &          (0.37335*invtk - 0.05778) * s)
C
C------------------------------------------------------------------------
C k3p = [H][PO4]/[HPO4]
C
C DOE(1994) eq 7.2.26 with footnote using data from Millero (1974)
C
        k3p = exp(-3070.75*invtk - 18.141 + 
     &          (17.27039*invtk + 2.81197) *
     &          sqrts + (-44.99486*invtk - 0.09984) * s)
C
C------------------------------------------------------------------------
C ksi = [H][SiO(OH)3]/[Si(OH)4]
C
C Millero p.671 (1995) using data from Yao and Millero (1995)
C
        ksi = exp(-8904.2*invtk + 117.385 - 19.334 * dlogtk +
     &          (-458.79*invtk + 3.5913) * sqrtis +
     &          (188.74*invtk - 1.5998) * is +
     &          (-12.1652*invtk + 0.07871) * is2 +
     &          log(1.0-0.001005*s))
C
C------------------------------------------------------------------------
C kkw = [H][OH]
C
C Millero p.670 (1995) using composite data
C
        kkw = exp(-13847.26*invtk + 148.9652 - 23.6521 * dlogtk +
     &          (118.67*invtk - 5.977 + 1.0495 * dlogtk) *
     &          sqrts - 0.01615 * s)
C
C------------------------------------------------------------------------
C ks = [H][SO4]/[HSO4]
C
C Dickson (1990, J. chem. Thermodynamics 22, 113)
C
        ks=exp(-4276.1*invtk + 141.328 - 23.093*dlogtk +
     &          (-13856*invtk + 324.57 - 47.986*dlogtk) * sqrtis +
     &          (35474*invtk - 771.54 + 114.723*dlogtk) * is -
     &          2698*invtk*is**1.5 + 1776*invtk*is2 +
     &          log(1.0 - 0.001005*s))
C
C------------------------------------------------------------------------
C kf = [H][F]/[HF]
C
C Dickson and Riley (1979) -- change pH scale to total
C
        kf=exp(1590.2*invtk - 12.641 + 1.525*sqrtis +
     &          log(1.0 - 0.001005*s) + 
     &          log(1.0 + (0.1400/96.062)*(scl)/ks))
C
C------------------------------------------------------------------------
C Calculate concentrations for borate, sulfate, and fluoride
C
C Uppstrom (1974)
        bt = 0.000232 * scl/10.811
C Morris & Riley (1966)
        st = 0.14 * scl/96.062
C Riley (1965)
        ft = 0.000067 * scl/18.9984
c        write(*,*) 'co2calc'
c        write(*,*) k0,kk1,k2,kkw,kb,ks,kf,k1p,k2p,k3p,ksi
c        write(*,*) ff,htotal
c        write(*,*) bt,st,ft,sit,pt,ta

C*************************************************************************
C
C Calculate [H+] total when DIC and TA are known at T, S and 1 atm.
C The solution converges to err of xacc. The solution must be within
C the range x1 to x2.
C
C If DIC and TA are known then either a root finding or iterative method
C must be used to calculate htotal. In this case we use the Newton-Raphson
C "safe" method taken from "Numerical Recipes" (function "rtsafe.f" with
C error trapping removed).
C
C As currently set, this procedure iterates about 12 times. The x1 and x2
C values set below will accomodate ANY oceanographic values. If an initial
C guess of the pH is known, then the number of iterations can be reduced to
C about 5 by narrowing the gap between x1 and x2. It is recommended that
C the first few time steps be run with x1 and x2 set as below. After that,
C set x1 and x2 to the previous value of the pH +/- ~0.5. The current
C setting of xacc will result in co2star accurate to 3 significant figures
C (xx.y). Making xacc bigger will result in faster convergence also, but this
C is not recommended (xacc of 10**-9 drops precision to 2 significant figures).
C
C Parentheses added around negative exponents (Keith Lindsay)
C
        x1 = 10.0**(-phhi)
        x2 = 10.0**(-phlo)
        xacc = 1.e-10
        htotal=drtsafe(ta_iter_1,x1,x2,xacc)

c        write(*,*) 'htotal', htotal 
C
C Calculate [CO2*] as defined in DOE Methods Handbook 1994 Ver.2, 
C ORNL/CDIAC-74, Dickson and Goyet, eds. (Ch 2 p 10, Eq A.49)
C
        htotal2=htotal*htotal
        co2star = 1.0
        co2star=dic*htotal2/(htotal2 + kk1*htotal + kk1*k2)
        co2starair=xtco2*ff*atmpres
        dco2star=co2starair-co2star
        ph=-log10(htotal)

c        write(*,*) 'co2calc'
c        write(*,*) k12,k12p,k123p
c        write(*,*) k0,kk1,k2,kkw,kb,ks,kf,k1p,k2p,k3p,ksi
c        write(*,*) 'co2calc',ff,htotal
c        write(*,*) bt,st,ft,sit,pt,ta
c        write(*,*) 'CO2CALC' 
c        write(*,*) 'starair, star', co2starair, co2star
c        write(*,*) 'dic, dic_in', dic, dic_in
c        write(*,*) 'dco2star', dco2star
c        write(*,*) 'ph',ph

c
c       ---------------------------------------------------------------
cc      Add two output arguments for storing pCO2surf
cc      Should we be using K0 or ff for the solubility here?
c       ---------------------------------------------------------------
        pCO2surf = co2star / ff
        dpCO2    = pCO2surf - xtco2*atmpres
        pCO2atm = (pCO2surf - dpCO2) / permeg
c        dco2star = dpCO2*ff
C
C  Convert units of output arguments
c      Note: co2star and dco2star are calculated in mol/kg within this routine 
c      Thus Convert now from mol/kg -> mol/m^3
       co2star  = co2star / permil
       dco2star = dco2star / permil


c      Note: pCO2surf and dpCO2 are calculated in atm above. 
c      Thus convert now to uatm
       pCO2surf = pCO2surf / permeg
       dpCO2    = dpCO2 / permeg
c       dco2star = dco2star/ permeg
C
        return
        end

! source file: /home/andreas/models/UVic/2.6/npzd_co2/ctr/updates/ta_iter_1.F
c_ ---------------------------------------------------------------------
c_ RCS lines preceded by "c_ "
c_ ---------------------------------------------------------------------
c_
c_ $Source$
c_ $Revision$
c_ $Date$   ;  $State$
c_ $Author$ ;  $Locker$
c_
c_ ---------------------------------------------------------------------
c_ $Log$
c_ Revision 1.1  2004/06/01 17:38:06  ansley
c_ add pco2 function from Andreas Schmittner
c_
c_ Revision 1.2  1999/09/01 17:55:41  orr
c_ Fixed sign error in dfn/dx following remarks of C. Voelker (10/Aug/1999)
c_
c_ Revision 1.1  1999/04/03 22:00:42  orr
c_ Initial revision
c_
c_ ---------------------------------------------------------------------
c_

        subroutine ta_iter_1(x,fn,df)
      include "species.h"
        real k12,k12p,k123p
        real  x, fn, df, x2, x3, c, a, a2, da, b, b2, db
c        real k0,k1,k2,kw,kb,ks,kf,k1p,k2p,k3p,ksi
C
C This routine expresses TA as a function of DIC, htotal and constants.
C It also calculates the derivative of this function with respect to
C htotal. It is used in the iterative solution for htotal. In the call
C "x" is the input value for htotal, "fn" is the calculated value for TA
C and "df" is the value for dTA/dhtotal
C
c        write(*,*) 'ta_iter_1'
c        write(*,*) k0,k1,k2,kw,kb,ks,kf,k1p,k2p,k3p,ksi
c        write(*,*) ff,htotal
c        write(*,*) bt,st,ft,sit,pt,ta
c        write(*,*) x

	x2=x*x
	x3=x2*x
	k12 = kk1*k2
	k12p = k1p*k2p
	k123p = k12p*k3p
	c = 1.0 + st/ks
	a = x3 + k1p*x2 + k12p*x + k123p
	a2=a*a
	da = 3.0*x2 + 2.0*k1p*x + k12p
	b = x2 + kk1*x + k12
	b2=b*b
	db = 2.0*x + kk1

C
C	fn = hco3+co3+borate+oh+hpo4+2*po4+silicate+hfree+hso4+hf+h3po4-ta
C
	fn = kk1*x*dic/b +
     &	     2.0*dic*k12/b +
     &	     bt/(1.0 + x/kb) +
     &	     kkw/x +
     &	     pt*k12p*x/a +
     &	     2.0*pt*k123p/a +
     &	     sit/(1.0 + x/ksi) -
     &	     x/c -
     &	     st/(1.0 + ks/(x*c)) -
     &	     ft/(1.0 + kf/x) -
     &	     pt*x3/a -
     &	     ta

C
C	df = dfn/dx
C
	df = ((kk1*dic*b) - kk1*x*dic*db)/b2 -
     &	     2.0*dic*k12*db/b2 -
     &	     bt/kb/(1.0+x/kb)**2. -
     &	     kkw/x2 +
     &	     (pt*k12p*(a - x*da))/a2 -
     &	     2.0*pt*k123p*da/a2 -
     &	     sit/ksi/(1.0+x/ksi)**2. -
     &	     1.0/c +
     &	     st*(1.0 + ks/(x*c))**(-2.0)*(ks/(c*x2)) +
     &	     ft*(1.0 + kf/x)**(-2.)*kf/x2 -
     &	     pt*x2*(3.0*a-x*da)/a2

c        write(*,*) k12,k12p,k123p
c        write(*,*) fn, df

	return
	end


! source file: /home/andreas/models/UVic/2.6/npzd_co2/ctr/updates/drtsafe.F
c_ ---------------------------------------------------------------------
c_ RCS lines preceded by "c_ "
c_ ---------------------------------------------------------------------
c_
c_ $Source$
c_ $Revision$
c_ $Date$   ;  $State$
c_ $Author$ ;  $Locker$
c_
c_ ---------------------------------------------------------------------
c_ $Log$
c_ Revision 1.1  2004/06/01 17:38:06  ansley
c_ add pco2 function from Andreas Schmittner
c_
c_ Revision 1.1  1999/04/03 22:00:42  orr
c_ Initial revision
c_
c_ ---------------------------------------------------------------------
c_
       REAL FUNCTION DRTSAFE(FUNCD,X1,X2,XACC)
      include "species.h"

      real funcd, x1, x2, xacc, fl, df, fh, xl, xh, swap, dxold,
     .     dx, f, temp
      integer j, maxit
C
C	File taken from Numerical Recipes. Modified  R.M.Key 4/94
C
      MAXIT=100
      CALL FUNCD(X1,FL,DF)
      CALL FUNCD(X2,FH,DF)
      IF(FL .LT. 0.0) THEN
        XL=X1
        XH=X2
      ELSE
        XH=X1
        XL=X2
        SWAP=FL
        FL=FH
        FH=SWAP
      END IF
      DRTSAFE=.5*(X1+X2)
      DXOLD=ABS(X2-X1)
      DX=DXOLD
      CALL FUNCD(DRTSAFE,F,DF)
      DO 100, J=1,MAXIT
        IF(((DRTSAFE-XH)*DF-F)*((DRTSAFE-XL)*DF-F) .GE. 0.0 .OR.
     &	      ABS(2.0*F) .GT. ABS(DXOLD*DF)) THEN
          DXOLD=DX
          DX=0.5*(XH-XL)
          DRTSAFE=XL+DX
          IF(XL .EQ. DRTSAFE)RETURN
        ELSE
          DXOLD=DX
          DX=F/DF
          TEMP=DRTSAFE
          DRTSAFE=DRTSAFE-DX
          IF(TEMP .EQ. DRTSAFE)RETURN
	END IF
        IF(ABS(DX) .LT. XACC)RETURN
        CALL FUNCD(DRTSAFE,F,DF)
        IF(F .LT. 0.0) THEN
          XL=DRTSAFE
          FL=F
        ELSE
          XH=DRTSAFE
          FH=F
        END IF
  100  CONTINUE
      RETURN
      END

	INTEGER FUNCTION DO_SHIFT (	idim, arg,
     .					com, com_mr, com_cx,
     .					res, res_mr, res_cx,
     .					wkbuf	)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* shift the data from a component grid into the result grid along axis idim
* by amount ishift

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 8/17/87
* revision 0.1 - 9/9/87  - changed from subroutine to function
* revision 0.2 - 10/4/88 - kludge fix for 1-D variables where dim1=dim2
* V200:   6/6/89 - 4D symmetrical - major re-write
*       10/11/89 - modified array declarations using XMEM_SUBSC.CMN
* V230:   8/3/92 - bug: if the requested region had unspecified limits then
*                  the component is full-span so subtracting shf results in
*                  exceeding subscript bounds
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xprog_state.cmn'

* calling argument declarations:
	INTEGER	idim, com_mr, com_cx, res_mr, res_cx
	REAL	arg, wkbuf(*), 
     .          com( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          res( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif )

* internal variable declarations:
	INTEGER ii, shf, i, j, k, l, m, n,
     .          lo_sub(nferdims), hi_sub(nferdims)
	REAL	bad_res

* internal (convenience) equivalences
	INTEGER	lo_s1, lo_s2, lo_s3, lo_s4, lo_s5, lo_s6,
     .          hi_s1, hi_s2, hi_s3, hi_s4, hi_s5, hi_s6
	EQUIVALENCE (lo_s1, lo_sub(1)) , (lo_s2, lo_sub(2)),
     .		    (lo_s3, lo_sub(3)) , (lo_s4, lo_sub(4)),
     .		    (lo_s5, lo_sub(5)) , (lo_s6, lo_sub(6)),
     .		    (hi_s1, hi_sub(1)) , (hi_s2, hi_sub(2)),
     .		    (hi_s3, hi_sub(3)) , (hi_s4, hi_sub(4)),
     .		    (hi_s5, hi_sub(5)) , (hi_s6, hi_sub(6))

* diagnostic mode output: " doing --> VAR_NAME[x=lo:hi@TRN:n,D=#]"
	IF ( mode_diagnostic ) 	CALL DIAG_OP
     .				( 'doing', isact_class_trans, res_cx, idim )

* initialize
	shf = INT(arg)
	bad_res = mr_bad_data( res_mr )

* compute limits within which calculation is possible
	DO 10 ii = 1, nferdims
	   lo_sub(ii) = cx_lo_ss(res_cx,ii)
	   hi_sub(ii) = cx_hi_ss(res_cx,ii)
 10	CONTINUE
	lo_sub(idim) = cx_lo_ss(com_cx,idim) - shf
	hi_sub(idim) = cx_hi_ss(com_cx,idim) - shf
        IF ( lo_sub(idim) .LT. cx_lo_ss(res_cx,idim) ) 
     .                  lo_sub(idim) = cx_lo_ss(res_cx,idim)  ! 8/92
        IF ( hi_sub(idim) .GT. cx_hi_ss(res_cx,idim) ) 
     .                  hi_sub(idim) = cx_hi_ss(res_cx,idim)  ! 8/92

* SHIFT ALONG X
	IF ( idim .EQ. x_dim ) THEN
	   DO 100 n = lo_s6, hi_s6
	   DO 100 m = lo_s5, hi_s5
	   DO 100 l = lo_s4, hi_s4
	   DO 100 k = lo_s3, hi_s3
	   DO 100 j = lo_s2, hi_s2
	   DO 100 i = lo_s1, hi_s1
 100	   res(i,j,k,l,m,n) = com(i+shf,j,k,l,m,n)

* SHIFT ALONG Y
	ELSEIF ( idim .EQ. y_dim ) THEN
	   DO 200 n = lo_s6, hi_s6
	   DO 200 m = lo_s5, hi_s5
	   DO 200 l = lo_s4, hi_s4
	   DO 200 k = lo_s3, hi_s3
	   DO 200 j = lo_s2, hi_s2
	   DO 200 i = lo_s1, hi_s1
 200	   res(i,j,k,l,m,n) = com(i,j+shf,k,l,m,n)

* SHIFT ALONG Z
	ELSEIF ( idim .EQ. z_dim ) THEN
	   DO 300 n = lo_s6, hi_s6
	   DO 300 m = lo_s5, hi_s5
	   DO 300 l = lo_s4, hi_s4
	   DO 300 k = lo_s3, hi_s3
	   DO 300 j = lo_s2, hi_s2
	   DO 300 i = lo_s1, hi_s1
 300	   res(i,j,k,l,m,n) = com(i,j,k+shf,l,m,n)

* SHIFT ALONG T
	ELSEIF ( idim .EQ. t_dim ) THEN
	   DO 400 n = lo_s6, hi_s6
	   DO 400 m = lo_s5, hi_s5
	   DO 400 l = lo_s4, hi_s4
	   DO 400 k = lo_s3, hi_s3
	   DO 400 j = lo_s2, hi_s2
	   DO 400 i = lo_s1, hi_s1
 400	   res(i,j,k,l,m,n) = com(i,j,k,l+shf,m,n)

* SHIFT ALONG E
	ELSEIF ( idim .EQ. e_dim ) THEN
	   DO 500 n = lo_s6, hi_s6
	   DO 500 m = lo_s5, hi_s5
	   DO 500 l = lo_s4, hi_s4
	   DO 500 k = lo_s3, hi_s3
	   DO 500 j = lo_s2, hi_s2
	   DO 500 i = lo_s1, hi_s1
 500	   res(i,j,k,l,m,n) = com(i,j,k,l,m+shf,n)

* SHIFT ALONG F
	ELSEIF ( idim .EQ. f_dim ) THEN
	   DO 600 n = lo_s6, hi_s6
	   DO 600 m = lo_s5, hi_s5
	   DO 600 l = lo_s4, hi_s4
	   DO 600 k = lo_s3, hi_s3
	   DO 600 j = lo_s2, hi_s2
	   DO 600 i = lo_s1, hi_s1
 600	   res(i,j,k,l,m,n) = com(i,j,k,l,m,n+shf)

	ENDIF

* always successful
	DO_SHIFT = ferr_ok

	RETURN
	END

	SUBROUTINE PROCESS_IF( cmnd_string, slen,
     .			       do_verify, prefix, raw_cmnd, * )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* this routine is called when the process of obtaining Ferret commands is
* under the control of a multi-line IF clause
* This routine inspects the currently available command and decides whether
* to execute it or to skip it. It also updates the IF-stack as needed.

* Note that error checking need not be done in this routine because the
* "logical control" tokens "IF", "ELSE", "ELIF", and "ENDIF" are themselves
* commands which will check for errors and set appropriate states

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V420:  4/28/96
*     : bug fix 5/96: ENDIF processed wrong for nested IF
* V530: 1/01 *sh* - skip white space at start of line
* 2/03 *kob* - g77 port - g77 won't allow intrinsic functions in PARAMETER
*                         statements.  use an octal constant instead
* 10/05 *acm*  Fix bug 918, parsing immediate mode expr when they are inside
*              a conditional, using the IF STACK.
* 12/05 *acm*  Fix bug 1368. if skipping commands, also skip one-line if-then-condition
* V6.01 10/06 *acm*  Fix bug 1446 in the loop DO 200 when testing for a tab character, the
*              index should be i not ic1. The perils of cut-and-pasting text from elsewhere!
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V693+ *sh* echoing of command lines is done here when inside of an IF block
*        To avoid the confusing output of "ENDIF" during a skipped IF block
*        count skipped nested IF statements using ifstk_skipping
*        Note that this routine has been pretty trashed by repeated edits
*        It should really be re-written, but seems risky (else I'd do it)

        IMPLICIT NONE
* calling argument declarations:
	LOGICAL		do_verify
	INTEGER		slen
	CHARACTER	cmnd_string*(*), prefix*5, raw_cmnd*(*)
* RETURN 1 - used when the current command should be **skipped**

* internal variable declarations:
	INTEGER	STR_CASE_BLIND_COMPARE, ic1,
     .		status	! not returned
        INTEGER STR_UPCASE, i, cmnd_len
	LOGICAL ITSA_1LINEIF, 
     .		its_endif, its_else, its_elif, its_if, one_liner

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'command.parm'
	include 'gfdl_vms.parm'
	include 'xprog_state.cmn'
        include 'xrisc.cmn'

* internal parameter declarations:
	INTEGER		TM_LENSTR1
        CHARACTER*1     tab
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
#else
	PARAMETER     ( tab = CHAR(9))
#endif

* sanity check
	IF ( ifstk.LT.1 .OR. ifstk.GT.max_ifstk ) GOTO 5000

        i = STR_UPCASE (risc_buff, cmnd_buff)
* skip initial white space
	DO ic1 = 1, slen
	   IF (cmnd_string(ic1:ic1).NE. ' '
     .   .AND. cmnd_string(ic1:ic1).NE. tab) GOTO 100
	END DO
! should never arrive here ...
	ic1 = 1

* check for IF or ENDIF
 100	its_endif =
     .	      STR_CASE_BLIND_COMPARE(cmnd_string(ic1:ic1+3),'ENDI')
     .		 .EQ. vms_str_success
	its_if   =
     .	     (STR_CASE_BLIND_COMPARE(cmnd_string(ic1:ic1+2),'IF ')
     .		 .EQ. vms_str_success)
     .  .OR. (STR_CASE_BLIND_COMPARE(cmnd_string(ic1:ic1+2),'IF'//tab)
     .		 .EQ. vms_str_success)

* Fix bug 918: do NOT always execute IF and ENDIF statements!
cc	IF (its_if .OR. its_endif) RETURN

        IF ((its_if .OR. its_endif) .AND. 
     .      if_doing(ifstk) .EQ. pif_doing_clause) GOTO 1000

	IF (if_conditional .AND. its_if ) THEN     ! nested IF?
	   IF (if_doing(ifstk).NE.pif_doing_clause) THEN	! skipped IF?

* --- here is cause of bug 1368: if the current statement is a one-line IF statement, 
* --- and we are skipping commands, we want to just skip this one too.
* --- Check whether the current command is a one-line IF condition THEN command
* --- and if so skip it, otherwise bump the IF stack.

            IF (its_if) THEN
	       one_liner = ITSA_1LINEIF(risc_buff(:slen),slen)
	    ELSE
	       one_liner = .FALSE.
	    ENDIF

	    IF ( num_args .LE. 2 .AND. .NOT. one_liner) THEN  ! multi-line nested IF?
* ...       bump the nested IF counting stack 
	         ifstk_skipping = ifstk_skipping + 1
                 RETURN 1    ! skip this command
	      ENDIF
	   ENDIF
	ENDIF
        
	IF (if_conditional .AND. its_endif ) THEN     ! nested IF?
	   IF (if_doing(ifstk).NE.pif_doing_clause) THEN	! skipped IF?

	      IF (ifstk_skipping .GT. 0) THEN
	         ifstk_skipping = ifstk_skipping - 1 ! decrement nest level
	         RETURN 1    ! skip this ENDIF command
	      ENDIF
! commented out this code 12/14 -- is it needed?
* Skipped if inside a repeat?  will have a ; or a ) after it.
* One more fix: if the ; or ) follows a ! then ignore.
!           IF (INDEX(risc_buff, ')') .GT. INDEX(risc_buff,'ENDIF'))THEN
!	      IF (INDEX(risc_buff, '!') .GT. 0) THEN
!                IF (INDEX(risc_buff, ')') .LT. INDEX(risc_buff,'!'))
!     .            its_endif = .FALSE.
!              ELSE
!                 its_endif = .FALSE.
!              ENDIF
!	   ENDIF
!
!           IF (INDEX(risc_buff, ';') .GT. INDEX(risc_buff,'ENDIF'))THEN
!	      IF (INDEX(risc_buff, '!') .GT. 0) THEN
!                IF (INDEX(risc_buff, ';') .LT. INDEX(risc_buff,'!'))
!     .            its_endif = .FALSE.
!              ELSE
!                 its_endif = .FALSE.
!              ENDIF
	   ENDIF
        ENDIF

	IF (its_endif) GOTO 1000  ! process any ENDIF not being skipped

* now check each of the possible IF execution states
	IF ( if_doing(ifstk) .EQ. pif_skip_to_endif ) THEN
* skip everything until ENDIF is encountered
	   RETURN 1   ! skip this command

	ELSEIF ( if_doing(ifstk) .EQ. pif_doing_clause ) THEN
* execute everything cuz we're "doing" the clause
	   GOTO 1000

	ELSEIF ( if_doing(ifstk) .EQ. pif_skip_to_clause ) THEN

* check for ELSE or ELIF at the level from which skipping was initiated
	   its_else  =
     .	      STR_CASE_BLIND_COMPARE(cmnd_string(ic1:ic1+3),'ELSE')
     .	 	    .EQ. vms_str_success
	   its_elif  =
     .	      STR_CASE_BLIND_COMPARE(cmnd_string(ic1:ic1+3),'ELIF')
     .		    .EQ. vms_str_success
	   IF ((its_else .OR. its_elif) 
     .	. AND. ifstk_skipping .EQ. 0  ) GOTO 1000

* nope - just an ordinary command ... keep skipping 
	   RETURN 1    ! skip this command

	ELSE
* unknown if condition
	   GOTO 5000

	ENDIF

* this command needs to be executed
* echo it if requested to do so
 1000	IF (do_verify) THEN
	   slen = TM_LENSTR1(raw_cmnd)
	   IF (prefix .EQ. ' ') THEN
* ... separate SPLIT_LIST call to avoid single char ' ' prefix
	      CALL SPLIT_LIST(pttmode_ops, ttout_lun,
     .				 raw_cmnd, slen  )
	   ELSE
	      CALL SPLIT_LIST(pttmode_ops, ttout_lun,
     .			prefix//raw_cmnd, slen+5 )
	   ENDIF
	ENDIF
	RETURN


 5000	CALL ERRMSG(ferr_internal, status, 'ifstk!!', *1000)

 5400	CALL ERRMSG( ferr_invalid_command, status, 'IFs nested too deep',
     .							*5000 )
     
        END

	SUBROUTINE TM_SCALE_ALL ( factor, offset, array, vartyp, n  )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* rescale an array: multiply by a scale factor and add an offset

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* revision 0.0 1/2010 for TMAP library
* Scale the bad data too... on input to netCDF we scale all the data,
* compute the missing flag for internal use as indat*inscale + inoff
*
* To write scaled data, scale all of it by ferretdat(1./inscale) - (inoff/inscale)
* the scaling to be used is sent into this routine.
* v6.8 3/14/2012 *acm* fix for scaled SHORT data and double-precision Ferret.
* v6.85 6/2012   *acm* The min size for a SHORT integer is -32768

* include files
      INCLUDE 'netcdf.inc'

* calling argument declarations:
      INTEGER n, vartyp
      REAL factor, offset, array(*)

* internal variable declarations:
      LOGICAL TM_FPEQ_SNGL
      INTEGER i
      REAL*4 aa, sbad, sbadn

* For short output datatype, the scaling and un-scaling
* can result in data outside the range of SHORT on output.
* FLOAT offset and scale factor are converted to DOUBLE, then
* 1./scale is computed, and re-applied to the data.
* This is a bit of a hack. 

      IF (vartyp .EQ. NF_SHORT) THEN
         sbad = 32767
         sbadn = -32768
         DO 100 i = 1, n
	    array(i) = array(i)*factor + offset
	    aa = array(i)
	    IF (TM_FPEQ_SNGL(aa,sbad) ) array(i) = sbad
	    IF (TM_FPEQ_SNGL(aa,sbadn) ) array(i) = sbadn
 100     CONTINUE

      ELSE
         DO 200 i = 1, n
             array(i) = array(i)*factor + offset
 200     CONTINUE
      ENDIF

      RETURN
      END

*
* bin_index_wt.F
*
* Ansley Manke
* October 2002
*
* This function sorts the indicies, and gathers them into bins, along
* with their associated weights.  Returns the weights for each bin, 
* followed by missing-data after the last bin.
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE bin_index_wt_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      CHARACTER*100 fcn_desc
      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns data, gathered into bins on the X axis')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id, ABSTRACT, NORMAL, NORMAL,
     .                                    NORMAL,   NORMAL, NORMAL)

      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'INDEX')
      CALL ef_set_arg_desc(id, arg, 'Bin indices: sorted, 1D on x axis')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'WT')
      CALL ef_set_arg_desc(id, arg, 'Weight for each index')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'INDXMAX')
      CALL ef_set_arg_desc(id, arg, 'Length of result axis')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, NO, NO)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE bin_index_wt_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER my_lo_l, my_hi_l
      REAL size

*
*     Use utility functions to get context information about the arguments.
*

      CALL ef_get_one_val(id, ARG3, size)

      my_lo_l = 1
      my_hi_l = INT(size + 1)

      CALL ef_set_axis_limits(id, X_AXIS, my_lo_l, my_hi_l)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


* In this subroutine we compute the result
*
      SUBROUTINE bin_index_wt_compute(id, arg_1, arg_2, arg_3, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER ndx
      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1

*  Get subscript ranges

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      j1 = arg_lo_ss(Y_AXIS, ARG1)
      k1 = arg_lo_ss(Z_AXIS, ARG1)
      l1 = arg_lo_ss(T_AXIS, ARG1)
      m1 = arg_lo_ss(E_AXIS, ARG1)
      n1 = arg_lo_ss(F_AXIS, ARG1)
      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      l = res_lo_ss(T_AXIS)
      m = res_lo_ss(E_AXIS)
      n = res_lo_ss(F_AXIS)

      DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
          result(i,j,k,l,m,n) = 0.0
  100 CONTINUE

      ndx = res_lo_ss(X_AXIS)
      DO 200 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)
          ndx = INT(arg_1(i1,j1,k1,l1,m1,n1))
	  IF (  ndx .GT. 0 .AND. ndx .LE. res_hi_ss(X_AXIS) ) THEN
             result(ndx,j,k,l,m,n) = result(ndx,j, k, l, m, n) +
     .                               arg_2(i1, j1,k1,l1,m1,n1)
          ENDIF
  200 CONTINUE

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*------------------------------fft_re.F--------------------------------
*
* fft_re.F
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* Dec 1998
*
* v5.50  *acm* 10/02 Simplify the error message for missing data when the 
*                    input is a simple 1-D time series.
* V5.53  *acm*  6/03 Correct the frequency axis:  why was there a factor of
*                     1.001 in freqn = 1.001*yquist?
*
* This function returns the real part of the FFT transform. The result time
* axis is a custom axis in period 1./time  The time axis must be regular.

*  NOTE:
*  IT IS GENERALLY ADVISABLE TO INCLUDE EXPLICIT LIMITS WHEN WORKING WITH
*  FUNCTIONS THAT REPLACE AXES. FOR EXAMPLE, THE CONSIDER THE FUNCTION
*  SORTL(v). THE EXPRESSION
*       LIST/L=6:10 SORTL(v)
*  IS NOT EQUIVALENT TO
*       LIST SORTL(v[L=6:10])
*  THE FORMER WILL LIST THE 6TH THROUGH 10TH SORTED INDICES FROM THE ENTIRE
*  L RANGE OF VARIABLE V. THE LATTER WILL LIST ALL OF THE INDICES THAT
*  RESULT FROM SORTING v[L=6:10].
*  
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE fft_re_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id, 'Computes real part of fft transform' )
      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, CUSTOM,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 4)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'Variable with regular time axis.')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, NO, YES, YES)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END


      SUBROUTINE fft_re_custom_axes(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                      
*
*     Use utility functions to get grid information about the 
*     argument; use this info to determine the custom axis lo/hi/del 

      INTEGER nfreq_lo_l, nfreq_hi_l
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER arg, nd
      CHARACTER outunits*32
      REAL boxsize(1)
      CHARACTER ax_name(6)*16, ax_units(6)*16
      LOGICAL backward(6), modulo(6), regular(6)

      arg = 1
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      CALL ef_get_axis_info_6d(id, arg, ax_name, ax_units,
     .                         backward, modulo, regular)

      CALL ef_get_box_size(id, arg, T_AXIS, arg_lo_ss(T_AXIS,arg), 
     .                     arg_lo_ss(T_AXIS,arg), boxsize)

      IF ( arg_hi_ss(T_AXIS,arg) - arg_lo_ss(T_AXIS,arg) .EQ. 0 ) THEN
         nfreq_lo_l = 1
         nfreq_hi_l = 2
      ELSE
         nfreq_lo_l = arg_lo_ss(T_AXIS,arg)
         nfreq_hi_l = arg_hi_ss(T_AXIS,arg)
      ENDIF

      nd = abs(nfreq_hi_l - nfreq_lo_l) + 1

C  The FFT code returns frequencies W(k) for k=1 to N/2, with N/2 rounded down

c      nfreq = nd/2	
c      yquist = 1./(2.*boxsize(1))		! Nyquist frequency
c
c      freq1 = 1.* yquist/ float(nfreq)
c!      freqn = 1.001*yquist  !  WHY THE 1.001???
c      freqn = yquist
c
cC  Set label for the frequency axis CYC/units.
c
c      outunits = 'CYC/' // ax_units(T_AXIS)
c
c      CALL ef_set_custom_axis (id, T_AXIS, freq1, freqn, freq1, 
c     .                         outunits, NO)


C Use ef_set_freq_axis (if we could let freq1, freqn be double precision
C in the ef_set_custom_axis call, that would be equivalent.)
C
C  Set label for the frequency axis CYC/units.

      outunits = 'CYC/' // ax_units(T_AXIS)

      CALL ef_set_freq_axis (id, T_AXIS, nd, boxsize(1), outunits, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE fft_re_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER ntime, nfreq
      INTEGER arg
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      arg = 1
      ntime = arg_hi_ss(T_AXIS,arg) - arg_lo_ss(T_AXIS,arg) + 1

C  The FFT code returns frequencies W(k) for k=1 to N/2, with N/2 rounded down

      nfreq = ntime/ 2
      if (ntime .ne. nfreq*2) nfreq = (ntime+1)/2 ! see FFTPACK comments in rfftf

      CALL ef_set_axis_limits(id, T_AXIS, 1, nfreq)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE fft_re_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
* 
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER mtdat, mtwork
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      mtdat = 1 + arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1)

      mtwork = 2.5* mtdat + 15

* a
      CALL ef_set_work_array_dims_6d(id, 1,
     .                                1, 1, 1, 1, 1, 1,
     .                            mtdat, 1, 1, 1, 1, 1)

* b
      CALL ef_set_work_array_dims_6d(id, 2,
     .                                1, 1, 1, 1, 1, 1,
     .                            mtdat, 1, 1, 1, 1, 1)

* wft
      CALL ef_set_work_array_dims_6d(id, 3,
     .                                1, 1, 1, 1, 1, 1,
     .                           mtwork, 1, 1, 1, 1, 1)

* ts
      CALL ef_set_work_array_dims_6d(id, 4,
     .                                1, 1, 1, 1, 1, 1,
     .                            mtdat, 1, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE fft_re_compute(id, arg_1, result, a, b, wft, ts)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

      REAL a(wrk1lox:wrk1hix, wrk1loy:wrk1hiy, wrk1loz:wrk1hiz,
     .       wrk1lot:wrk1hit, wrk1loe:wrk1hie, wrk1lof:wrk1hif)
      REAL b(wrk2lox:wrk2hix, wrk2loy:wrk2hiy, wrk2loz:wrk2hiz,
     .       wrk2lot:wrk2hit, wrk2loe:wrk2hie, wrk2lof:wrk2hif)
      REAL wft(wrk3lox:wrk3hix, wrk3loy:wrk3hiy, wrk3loz:wrk3hiz,
     .         wrk3lot:wrk3hit, wrk3loe:wrk3hie, wrk3lof:wrk3hif)
      REAL ts(wrk4lox:wrk4hix, wrk4loy:wrk4hiy, wrk4loz:wrk4hiz,
     .        wrk4lot:wrk4hit, wrk4loe:wrk4hie, wrk4lof:wrk4hif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CHARACTER ax_name(6)*16, ax_units(6)*16
      LOGICAL backward(6), modulo(6), regular(6)
      INTEGER arg, nd, nf
      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1
      CHARACTER*128 err_msg

   40 FORMAT ('FFT_RE encountered missing data at (i,j,k,l,m,n)', 6I5)
   50 FORMAT ('FFT_RE encountered missing data at L=', I5)

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*  number of time points.

      arg = 1
      nd = (arg_hi_ss(T_AXIS,arg) - arg_lo_ss(T_AXIS,arg) + 1)
      nf = nd/ 2

*  Check that the time axis is regular.

      CALL ef_get_axis_info_6d(id, 1, ax_name, ax_units,
     .                         backward, modulo, regular)
      IF (.NOT. regular(T_AXIS)) THEN
         WRITE (err_msg, *) 'Time axis must be a regular axis'
         GO TO 999
      ENDIF

*  Set WFT for fft; prime factorization of ND and trig functions.

      CALL rffti (nd, wft)

      n1 = arg_lo_ss(F_AXIS,ARG1)
      DO 600 n=res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

      m1 = arg_lo_ss(E_AXIS,ARG1)
      DO 500 m=res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

      k1 = arg_lo_ss(Z_AXIS,ARG1)
      DO 300 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 200 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            i1 = arg_lo_ss(X_AXIS,ARG1)
            DO 100 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

* Calculate the FFT for each time series which have no missing data.
* Make a simple error message if we have a 1-D input time series.

               l1 =arg_lo_ss(T_AXIS,ARG1)
               DO 400 l = 1, nd

                  IF (arg_1(i1,j1,k1,l1,m1,n1) .EQ. bad_flag(ARG1)) THEN
                     IF ( i1 .EQ. ef_unspecified_int4 .AND.
     .                    j1 .EQ. ef_unspecified_int4 .AND.
     .                    k1 .EQ. ef_unspecified_int4 .AND.
     .                    m1 .EQ. ef_unspecified_int4 .AND.
     .                    n1 .EQ. ef_unspecified_int4 ) THEN
                        WRITE (err_msg, 50) l
                     ELSE
                        WRITE (err_msg, 40) i1,j1,k1,l,m1,n1
                     ENDIF
                     GO TO 999 
                  ENDIF
                  ts(l,1,1,1,1,1) = arg_1(i1,j1,k1,l1,m1,n1)

                  l1 = l1 + arg_incr(T_AXIS,ARG1)
 400           CONTINUE

               CALL four_re (nd, ts, a, b, wft)

               DO 410 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS) 
                   result(i,j,k,l,m,n) = a(l,1,1,1,1,1)
 410           CONTINUE

               i1 = i1 + arg_incr(X_AXIS,ARG1)
 100        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 200     CONTINUE

         k1 = k1 + arg_incr(Z_AXIS,ARG1)
 300  CONTINUE

         m1 = m1 + arg_incr(E_AXIS,ARG1)
 500  CONTINUE

         n1 = n1 + arg_incr(F_AXIS,ARG1)
 600  CONTINUE

      RETURN

 999  CALL ef_bail_out (id, err_msg)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

        SUBROUTINE READSQ(X,NXS,NYS,NSIZE,IBASE,NAME)
	DIMENSION X(NSIZE),XT(1000,20)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)readsq.F	1.2    3/18/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
#ifdef unix
        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'zgridd_inc.decl'
        include 'ZGRIDD.INC'
        include 'zgrid_inc.decl'
        include 'ZGRID.INC'
        include 'lines_inc.decl'
        include 'LINES.INC'
        include 'hd_inc.decl'
        include 'HD.INC'
        include 'data_inc.decl'
        include 'DATA.INC'
        include 'cmrd_inc.decl'
        include 'CMRD.INC'
        include 'cmrdl_inc.decl'
        include 'CMRDL.INC'
        include 'labels_inc.decl'
        include 'LABELS.INC'
        include 'miss_inc.decl'
        include 'MISS.INC'
        include 'lunits_inc.decl'
        include 'LUNITS.INC'
        include 'system_inc.decl'
        include 'SYSTEM.INC'
        include 'comeps_inc.decl'
        include 'COMEPS.INC'
        include 'comthdr_inc.decl'
        include 'COMTHDR.INC'
        include 'taxis_inc.decl'
        include 'TAXIS.INC'
        include 'axisl_inc.decl'
        include 'AXISL.INC'
        include 'switch_inc.decl'
        include 'SWITCH.INC'
#else
        INCLUDE 'tmap_pplv11inc:tmap_PARAMPL5.DAT'
        INCLUDE 'tmap_pplv11inc:tmap_ZGRIDD.INC'
        INCLUDE 'tmap_pplv11inc:tmap_ZGRID.INC'
        INCLUDE 'tmap_pplv11inc:tmap_LINES.INC'
        INCLUDE 'tmap_pplv11inc:tmap_HD.INC'
        INCLUDE 'tmap_pplv11inc:tmap_DATA.INC'
        INCLUDE 'tmap_pplv11inc:tmap_CMRD.INC'
        INCLUDE 'tmap_pplv11inc:tmap_CMRDL.INC'
        INCLUDE 'tmap_pplv11inc:tmap_LABELS.INC'
        INCLUDE 'tmap_pplv11inc:tmap_MISS.INC'
        INCLUDE 'tmap_pplv11inc:tmap_LUNITS.INC'
        INCLUDE 'TMAP_PPLV11INC:SYSTEM_INC.DECL'
        INCLUDE 'PPLV11INC:SYSTEM.INC'
        INCLUDE 'tmap_pplv11inc:tmap_COMEPS.INC'
        INCLUDE 'tmap_pplv11inc:tmap_COMTHDR.INC'
        INCLUDE 'tmap_pplv11inc:tmap_TAXIS.INC'
        INCLUDE 'tmap_pplv11inc:tmap_AXISL.INC'
        INCLUDE 'TMAP_PPLV11INC:SWITCH_INC.DECL'
        INCLUDE 'PPLV11INC:SWITCH.INC'
#endif
	INTEGER*4 IEPIC1,IEPIC2
	CHARACTER NAME*(*)
C     NREC=NUMBER OF RECORDS TO BE READ
C     NGRP=NUMBER OF GROUPS TO BE READ PER RECORD
C     NVAR=NUMBER OF VARIABLE PER GROUP
	IX=IBASE-1
	IY=NSIZE/2+IX
	IF(SVECTR)THEN
	    IVLEN=NX*NY
	    IF(JX.GT.0.and.JZ.GT.0)THEN
		IF(IZLEN.EQ.0)IZLEN=IZSE
	    ELSE
		IZLEN=NX*NY
	    ENDIF
	    NREC=IZLEN/NGRP
	ELSE
	    IVLEN=0
	    IZLEN=0
	    IF(JX.GT.0.AND.JZ.GT.0)THEN
	    	CALL STPRMP('rd>',3)
	    	IF(.NOT.QUIETF)WRITE(LTTOUT,'('' ENTER # PTS TO READ'')')
	     	CALL GETCMD(STRING,ISLEN,ICOM,P,IFLG,M,LABEL,N,LBSTRT)
	    	CALL STPRMP('ppl+>',5)
C
C	RSX-11M
C
C	CLOSE(6)
C	OPEN(LMULT,FILE='SY:QZZDAT.DAT',STATUS='NEW',FORM='UNFORMATTED')
C
C	END RSX-11M
C
	    	IF(IFLG(1).EQ.0)P(1)=IZSE
	    	NREC=MIN0(IZSE,INT(P(1)))/NGRP
	    END IF
	ENDIF
	II=1
	JJ=1
	DO 50 KK=1,NREC
	IF(IFORM(1:3).NE.'UNF'.AND.IFORM(1:3).NE.'EPI')THEN
	    IF(IFORM(1:4).EQ.'FREE')THEN
		READ(LUNN,*,END=11,ERR=1000)((XT(K,J),J=1,NVAR),
     *		K=1,NGRP)
	    ELSE
		READ(LUNN,IFORM,END=11,ERR=1000)((XT(K,J),J=1,NVAR),
     *		K=1,NGRP)
	    END IF
	ELSE
C     IF UNFORMATTED USE NGRP OR NREC WHICH EVER IS LARGER
	    READ(LUNN,END=11,ERR=1000)((XT(K,J),J=1,NVAR),K=1,NGRP)
	END IF
	IF(JZ.GT.0)GOTO 100
	IF(JX.GT.0)THEN
	    IF(JY.GT.0)THEN
		DO 20 I=1,NGRP
		X(IX+II)=XT(I,JX)
		X(IY+II)=XT(I,JY)
20		II=II+1
	    ELSE
C
C		If EPIC data and switch STIME (read EPIC time words),
C		make time variable = a sequence number which is 1 for
C		ITSTRT (usually first data point) and for which an
C		increment of 1 is 1 DT unit (usually 1440 minutes).
C		Offset by epico, which is delta-t for time series
C		on data file header (to get to center of time interval
C		if that is non-zero), unless lsoffs=.false.
C
		IF (LSTIME .AND. IFORM(1:3).EQ.'EPI') THEN
		    IF (LSOFFS) THEN
		        READ (THEADER(3)(61:78),222) EPICO
222		        FORMAT (E18.0)
		        EPICO=EPICO/2./DT
		    ELSE
		        EPICO=0.
		    ENDIF
		    READ (ITSTRT,221) EPDATE,EPTIME
221		    FORMAT (F6.0,F4.0)
		    CALL EPICSQ (EPDATE,EPTIME,IEPIC1)
		    DO 200 I=1,NGRP
		    X(IX+II)=XT(I,JX)
		    CALL EPICSQ (XT(I,1),XT(I,2),IEPIC2)
		    X(IY+II) = FLOAT(IEPIC2-IEPIC1) / DT + 1. + EPICO
200		    II=II+1
		ELSE
		    DO 21 I=1,NGRP
		    X(IX+II)=XT(I,JX)
		    X(IY+II)=FLOAT(II)
21		    II=II+1
	    	ENDIF
	    END IF
	ELSE
	    IF (LSTIME .AND. IFORM(1:3).EQ.'EPI') THEN
		IF (LSOFFS) THEN
		    READ (THEADER(3)(61:78),222) EPICO
		    EPICO=EPICO/2./DT
		ELSE
		    EPICO=0.
		ENDIF
		READ (ITSTRT,221) EPDATE,EPTIME
		CALL EPICSQ (EPDATE,EPTIME,IEPIC1)
	        DO 210 I=1,NGRP
		CALL EPICSQ (XT(I,1),XT(I,2),IEPIC2)
		X(IX+II) = FLOAT(IEPIC2-IEPIC1) / DT + 1. + EPICO
	        X(IY+II)=XT(I,JY)
210	        II=II+1
	    ELSE
	        DO 22 I=1,NGRP
	        X(IX+II)=FLOAT(II)
	        X(IY+II)=XT(I,JY)
22	        II=II+1
	    ENDIF
	END IF
	GOTO 50
100	IF(JX.LE.0)THEN
	    DO 30 IC=1,NGRP
	    X(IVLEN+NXS*(JJ-1)+II)=XT(IC,JZ)
	    IF(ITYPEZ.EQ.0)THEN
		II=II+1
		IF(II.GT.NX)THEN
		    JJ=JJ+1
		    II=1
		ENDIF
	    ELSE
		JJ=JJ+1
		IF(JJ.GT.NY)THEN
		    II=II+1
		    JJ=1
		ENDIF
	    END IF
30     CONTINUE
	ELSE
	    DO 31 IC=1,NGRP
C
C	RSX-11M
C
C	WRITE(LMULT)XT(IC,JX),XT(IC,JY),XT(IC,JZ)
C
C	END RSX-11M
C
C	VAX/VMS
C
	    XX(II)=XT(IC,JX)
	    YY(II)=XT(IC,JY)
	    ZZ(II)=XT(IC,JZ)
	    II=II+1
C
C	END VAX/VMS
C
31	    CONTINUE
	ENDIF
50	CONTINUE
11	LEN=(KK-1)*NGRP
	LLENG(LINEN)=LEN
	IF(LEN.LE.0)RETURN
	IF(JZ.GT.0)GOTO 400
	JTYPE=1
	ZMIN=0.
	ZMAX=ZMIN
	XMIN=1.E38
	YMIN=XMIN
	XMAX=-XMIN
	YMAX=XMAX
	DO 23 I=1,LEN
	IF((XLE.AND.X(IX+I).LE.CMXLE).OR.
     *	   (XEQ.AND.X(IX+I).EQ.CMXEQ).OR.
     *	   (XGE.AND.X(IX+I).GE.CMXGE).OR.
     *	   (YLE.AND.X(IY+I).LE.CMYLE).OR.
     *	   (YEQ.AND.X(IY+I).EQ.CMYEQ).OR.
     *	   (YGE.AND.X(IY+I).GE.CMYGE))GOTO 23
	IF(X(IX+I).LT.XMIN)XMIN=X(IX+I)
	IF(X(IX+I).GT.XMAX)XMAX=X(IX+I)
	IF(X(IY+I).LT.YMIN)YMIN=X(IY+I)
	IF(X(IY+I).GT.YMAX)YMAX=X(IY+I)
23	CONTINUE
	RETURN
400	JTYPE=0
	IF(SVECTR)JTYPE=-1
C
C	RSX-11M
C
C	IF(JX.GT.0)THEN
C	CLOSE(6)
C	OPEN(LMULT,FILE='SY:ECHO.DAT',STATUS='OLD',ACCESS='APPEND',
C     *	CARRIAGECONTROL='LIST')
C	ENDIF
C
C	END RSX-11M
C
	IF(.NOT.SVECTR)THEN
	    CALL STPRMP('rd>',3)
	    IF(.NOT.QUIETF)WRITE(LTTOUT,'('' ENTER XMIN,XMAX,YMIN,YMAX'')')
	    CALL GETCMD(STRING,ISLEN,ICOM,P,IFLG,M,LABEL,N,LBSTRT)
	    CALL STPRMP('ppl+>',5)
	    XMIN=P(1)
	    XMAX=P(2)
	    YMIN=P(3)
	    YMAX=P(4)
	ENDIF
	IF(JX.GT.0)THEN
	    DX=(XMAX-XMIN)/FLOAT(NX-1)
	    DY=(YMAX-YMIN)/FLOAT(NY-1)
	    IZLEN=LEN
C
C	RSX-11M
C
C	CLOSE(LMULT)
C	OPEN(LMULT,FILE='SY:QZZCMD.DAT',STATUS='NEW',FORM='UNFORMATTED')
C	WRITE(LMULT)LEN,NX,NY,XMIN,YMIN,DX,DY,CAY,NRNG
C	CLOSE(LMULT)
C	CALL GETLUN(LTTOUT,DAT)
C	WRITE(DV,'(I2)')DEV
C	IF(DEV.LT.10)DV(1:1)='0'
C	CMDLIN(28:29)=DV
C	CALL SPAWN(MCR,,,,,,,CMDLIN,29)
C	CALL STOP
C	OPEN(LMULT,FILE='SY:QZZDAT.DAT',STATUS='OLD',FORM='UNFORMATTED')
C	DO 500 I=1,NX
C	DO 500 J=1,NY
C	READ(LMULT)X(NXS*(J-1)+I)
C500	CONTINUE
C	CLOSE(LMULT,DISP='DELETE')
C	OPEN(LMULT,FILE='SY:ECHO.DAT',STATUS='OLD',ACCESS='APPEND',
C     *	CARRIAGECONTROL='LIST')
C
C	END RSX-11M
C
C	VAX/VMS
C
	    DO 500 I=1,NX
	    DO 500 J=1,NY
	    X(IVLEN+NXS*(J-1)+I)=0.0
500	    CONTINUE
	    IF(CAY.GE.0)THEN
		CALL ZGRID(X(IVLEN+1),NX,NY,NX,NY,XMIN,YMIN,DX,DY,
     *		XX,YY,ZZ,LEN,CAY,NRNG)
	    ELSE
		CALL LINEAR(X(IVLEN+1),NX,NY,NX,NY,XMIN,YMIN,DX,DY,
     *		XX,YY,ZZ,LEN,CAY,NRNG)
	    ENDIF
C
C	END VAX/VMS
C
	ENDIF
	RETURN
C	ERRORS
1000	IF(.NOT.QUIETF)WRITE(LTTOUT,
     *	'('' FATAL READ ERRORS IN READSEQ'')')
	IF(.NOT.QUIETF)WRITE(LTTOUT,9999) NAME,IFORM
9999	FORMAT('  NAME= ',A30,'   TYPE= ',A20)
#ifndef unix
	CALL ERRTST(64,I)
#endif
	RETURN
	END

	SUBROUTINE MASKED_DSG_RANGE (dset, cx, idim, lo, hi)


* If there are constraints on a DSG dataset, that affects the region in all
* directions, e.g. list/x= /y= affects the time range of data as well.
* Return the data range after applying the current context with any constraints
* This routine defines mask-array sizes and calls a subroutine to do the work.
* V76  4/20 *acm*  use the dsg_xlate_grid virtual grid with DSG coordinate variables

        IMPLICIT NONE

        include 'tmap_dims.parm'
        include 'ferret.parm'
        include 'errmsg.parm'
        include 'xcontext.cmn'
        include 'xdset_info.cmn_text'
        include 'xdsg_context.cmn'

	INTEGER dset, cx, idim
	REAL	lo, hi

	INTEGER TM_DSG_NFEATURES, grid, nfeatures, nobs
	REAL	min_obs, max_obs, low, hig

	grid = dsg_xlate_grid(dset)
	nfeatures = TM_DSG_NFEATURES(grid)

* max_obs, length of longest feature 
	CALL DSG_COORD_LIMS(dset, pdsg_row_size, min_obs, max_obs)
	nobs = max_obs

	CALL MASKED_DSG_RANGE_SUB (dset, cx, grid, nfeatures, nobs, 
     .         idim, lo, hi)

	RETURN
	END

	SUBROUTINE XEQ_HELP

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute the HELP command

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 4/3/86 - dummy version
* revision 1.0 - 5/13/87 - calls VMS utility routines
* revision 1.1 - 3/7/88  - changed help file name to logical name
* revision 1.2 - 4/26/88 - added PUT_OUTPUT/GET_INPUT
* revision 1.3 - 6/22/88 - changed GFDL_HELP --> FERRET_HELP
* revision 1.4 - 8/3/88  - Top level of help library, "FERRET", removed
* V230: 8/26/92 - added Unix version - entirely separate from VMS
* V320: 12/29/94 - use SPLIT_LIST to redirect tty output for GUI
* V5.0: 1/1/99 - Start up appropriate Web browser on PC
* v500: 1/26/99 - *kob* update help to reflect current options

* V5.6  3/2004 - update help to point only to web resources and SHOW commands
* V606  8/07 *acm* Send informational and error messages that are returned from 
*                  commands via SPLIT_LIST to std error rather than std out.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
        include 'ferret.parm'
        include 'xprog_state.cmn'


	CALL SPLIT_LIST(pttmode_help, err_lun,
     .   ' Detailed help is available online at http://ferret.pmel.noaa.gov'
     .								, 0)

	CALL SPLIT_LIST(pttmode_help, err_lun,
     .   ' To obtain a list of FERRET commands type    SHOW COMMANDS'
     .								, 0)

	CALL SPLIT_LIST(pttmode_help, err_lun,
     .' To obtain a list of FERRET functions type    SHOW FUNCTIONS'
     .								, 0)

	CALL SPLIT_LIST(pttmode_help, err_lun,
     .' To obtain a list of FERRET transforms type    SHOW TRANSFORM'
     .								, 0)

        RETURN

	END

	SUBROUTINE CD_WRITE_VAR ( cdfid, dset, vname, grid, lo,
     .                            hi, dat, edges_flag, do_bounds, 
     .                            mode_upcase_output, 
     .                            keepax_flag, user_var, fer_bad, 
     .                            do_coords, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Write a hyperslab of data into the current output netCDF file

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 3/92
*  performance: 10/92 consolidated record axis data writes under 1 ncendf call
*                     and use CD_SET_MODE to change between data & define modes
*  12/92: coordinate variables -> double precision
*   1/95: use cd_get_generic_bounds to synchronize output in files without
*	  the slab_(min/max)_limits machinery 
* 10/96 *kob* - Linux port - had to move variable assignments off of
*		declaration line.
*	      - had to use F90 Intrinsic function TRANSFER to properly
*		pass single values to NCVPT as arrays of 1 element
* 6/97	*kob* - fix introduced bug in call to NCVPT
* V533 *sh* 6/01 - add support for string variables (NF_CHAR)
* V552 *acm* 5/03   increase vbuff to 128 chars 
* V570 *acm*  5/04 write bounds 2xN coordinates when record axis is irregular.
* V600 *acm*  6/05 Attribute control. Get info from linked-list structure.
* V601 *acm* 10/06 Fix bug 1461: bounds variable was created for output in cd_write_axis
*                  with an upcased variable name, e.g. TIME_bnds. Here we need to upcase
*                  as well when finding bndid (if mode upcase_output is set).
* V602 *acm* 11/06 - Fix bug 1471; new routine CD_AXIS_OUTNAME gets correct 
*                    output axis name.
* V63  *acm   9/09 Fix bug 1692: issue an error message if we try to append irreg timesteps
*                  to a previously-regular axis that didn't have a bounds attribute.
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library. 
* V641 *acm* 1/10  Fix bug 1715 and output of packed data.
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing
*      4/12 *acm* fix for finding the record axis, never axes 5 or 6.
* V685 6/13 *acm* new qualifier SAVE/NOBOUNDS
* V685 6/13 *acm* Dont add SAVE/NOCOORDS
* V687 3/14 *acm* Fix ticket 1750. Write Ferret-internal axis names to cdf files, unless
*                 the user has said /KEEP_AXISNAMES
* V69+ 7/14 *acm* Further fix to 1750. Ticket 2182: Keep case of axis name consistent when
*                 creating and writing axis bounds.
* V69+ *acm*  9/14 Ticket 1758. Memory request uses number of blocks not words
* V694 *acm*  3/15 Ticket 2240. Get scale, offset, and bad per variable from the dataset 
*                  being written.
* V71 12/16 *acm* Ticket 2158: working with true monthly time axes. Write these axes
*                  as irregularly spaced daily axes. For true-month axes, call TM_WORLD 
*                  to write any true-month time coordinates as days.
* V702 1/17 *sh* for trac enhancement #2369 -- dynamic memory management 
*	         including bug fix in computation of npts, work mem size
*                also: bug fix of unitialized "count" variable
* v73+ *acm* 12/2017 Issue # 1846, writing user-variables with scale_factor, add_offset
* V74  *acm*  2/2018 Issue # 1861, handling missing- and _FillValue with scale and offset
* V74  *acm*  7/2018 Issue # 1882, save/append with bounds and irreg data
* V751 *acm* 11/19 *acm* new qualifier SAVE/NOCOORDS

* argument definitions:
*     cdfid   - netCDF id number for already opened CDF file
*     dset    - dset (if netcdf file, for getting name and attribute 
*               info from linked-list structure  
*     vname   - name of variable
*     grid    - defining grid for variable
*     lo      - low indices of variable hyperslab
*     hi      - high indices of variable hyperslab
*     dat     - data values to write
*     status  - return status

* include files
        include 'netcdf.inc'
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
        include 'cdf_tmap.parm'
        include 'ferret.parm'
        include 'xvariables.cmn'
	include 'xdset_info.cmn_text'
	external xdset_info_data
        include 'xunits.cmn_text'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

* argument declarations
      LOGICAL mode_upcase_output, do_coords
      INTEGER cdfid, dset, grid, lo(nferdims), hi(nferdims), 
     .        edges_flag, do_bounds, keepax_flag, status
      CHARACTER*(*) vname
      REAL dat(*), fer_bad

* local variable declarations:
* *kob* explicit definitions not allowed on decl line in linux...
*       moved it to parameter line 10/96
      INTEGER TM_LENSTR1, STR_SAME,
     .        start(nferdims), count(nferdims), idim, iaxis, cdfstat, vlen,
     .        slab_min(nferdims), slab_max(nferdims), tmrecax, cdrecax,
     .	      dims, varid, wrkspc,
     .        hilim, i100, i, j, k, l, m, n, recaxvar, lorec, hirec, rectyp,
     .	      vartyp, nvdim, vdims(8), nvatts, bndstart(2), bndcount(2),
     .        mblk1, nblks, npts, savecount, llen, grid_blocks, wunits
      INTEGER*8 rqst_size
      LOGICAL CD_GET_BOUNDS, TM_ABSTRACT_AXIS, TM_DFPEQ, CD_GET_ATTVAL, 
     .        MATCH_NAME, ITSA_TRUEMONTH_AXIS,
     .        got_it, scaled, writebounds, do_warn, true_month,user_var,  
     .        ldo(nferdims)
      CHARACTER*13 TM_STRING
      CHARACTER*1  dimnam(nferdims)
      DATA  	   dimnam/'I','J','K','L','M','N'/
      CHARACTER*128 vbuff     ! needed because of fussy f772.1 DEC compiler
      REAL   bad, r_scale, r_offset, secspmon, secs_p_unit, unit_p_mon
      REAL*8 scalefac, addoff
      REAL*8 r100_8(200)
      REAL*8 TM_WORLD
      
      INTEGER bndid, nlen, elen, reset, numvals, nv 
      CHARACTER name*128, buff*128, CD_AXIS_OUTNAME*128, CD_AXIS_NAME*128

      REAL*4 r100_4(200)
      REAL*8 new_box_lo, old_box_hi, reset_bnd_lo, missflag
c      EQUIVALENCE (r100_8, r100_4)

* For error message
      CHARACTER*9 typnam(12)
      DATA typnam/'NC_BYTE', 'NC_CHAR', 'NC_SHORT', 'NC_INT', 
     .            'NC_FLOAT', 'NC_DOUBLE', 'NC_UBYTE', 'NC_USHORT',
     .            'NC_UINT', 'NC_INT64', 'NC_UINT64', 'NC_STRING'/

* initialize
      vlen = TM_LENSTR1( vname )
      writebounds = do_bounds .GT. 0
      IF (.NOT.do_coords) writebounds = .FALSE.

      DO idim = 1, nferdims
         count(idim) = 0
      ENDDO

* get the variable id
      cdfstat = NF_INQ_VARID(cdfid, vname(:vlen), varid)
      IF ( cdfstat .NE. NF_NOERR ) GOTO 5100

* get the vital statistics for this variable
      cdfstat = NF_INQ_VAR (cdfid, varid, vbuff, vartyp, nvdim,
     .             vdims, nvatts)

* Get values for scalefac, addoff and bad-flag set in cdf_list for this variable

      scalefac = 1.
      addoff = 0.
      numvals = 1
      do_warn = .FALSE.
      got_it = CD_GET_ATTVAL ( cdfid, varid, "scale_factor",
     .                        do_warn, vname,
     .                        scalefac, numvals, nv )
      got_it = CD_GET_ATTVAL ( cdfid, varid, "add_offset",
     .                        do_warn, vname,
     .                        addoff, numvals, nv )
      got_it = CD_GET_ATTVAL ( cdfid, varid, "missing_value",
     .                        do_warn, vname,
     .                        bad, numvals, nv )
      IF (.NOT.got_it) got_it = 
     .         CD_GET_ATTVAL ( cdfid, varid, "_FillValue",
     .                        do_warn, vname,
     .                        bad, numvals, nv )

* enter data mode so data can be read and written
* (CD_GET_GENERIC_BOUNDS needs to read coordinate values)
      CALL CD_SET_MODE(cdfid, pcd_mode_data, status)
      IF ( status .NE. merr_ok ) RETURN

* get the hyperslab limits of this variable as stored in the file
      got_it = CD_GET_BOUNDS( cdfid, varid, slab_min, slab_max,
     .                        tmrecax, status )
      IF ( status .NE. merr_ok ) GOTO 5900


* Generic bounds -- if not writing coordinates at all this will be just 1 thru npts

      IF (.NOT. do_coords) THEN
         DO idim = 1, nferdims
	    ldo(nferdims) = line_dim_only(grid_line(idim,grid))
	    line_dim_only(grid_line(idim,grid)) = .TRUE.
	 ENDDO
      ENDIF


      IF (.NOT.got_it) CALL CD_GET_GENERIC_BOUNDS
     . ( cdfid, varid, grid, lo, slab_min, slab_max, tmrecax, status )

      IF ( status .NE. merr_ok ) GOTO 5900
      
* restore line_dim_only

      IF (.NOT. do_coords) THEN
         DO idim = 1, nferdims
	    line_dim_only(grid_line(idim,grid)) = ldo(nferdims) 
	 ENDDO
      ENDIF

* special check for abstract axes (kludge!) - length, only
* if i=5:15 overwrites i=1:10 it will be detected but
* if i=6:15 overwrite i=1:10 it still will not be detected resulting in an
* unhelpful error message, below

* issue 1871: Dont reset the slab range on an abstract axis. 
* Can't make an example of what was trying to be handled previously.
	 
         DO 10 idim = 1, nferdims
            IF ( idim .EQ. tmrecax ) GOTO 10
            iaxis = grid_line(idim, grid)
            IF ( TM_ABSTRACT_AXIS(iaxis)
     .     .AND. lo(idim).NE.unspecified_int4) THEN
               IF ( hi(idim)-lo(idim)
     .         .GT. slab_max(idim)-slab_min(idim) ) GOTO 5250
c               slab_min(idim) = lo(idim)
c               slab_max(idim) = hi(idim)
            ENDIF
 10      CONTINUE
* ... possible unnecessary record axis check
         IF ( lo(t_dim).EQ.unspecified_int4 ) tmrecax = 0

* check for valid limits (must be consistent with first time write)
* When reading a 4D file with 6D Ferret, skip checks when slab_min, 
* slab_max have been set to  unspecified_int4

      DO 100 idim = 1, nferdims
         IF ( idim .EQ. tmrecax ) GOTO 100
	 IF (slab_min(idim) .EQ. unspecified_int4 ) GOTO 100
         IF ( lo(idim) .EQ. unspecified_int4 ) THEN
            IF ( slab_min(idim) .NE. 1 ) GOTO 5200
         ELSE
            IF ( lo(idim) .LT. slab_min(idim)
     .      .OR. hi(idim) .GT. slab_max(idim) ) GOTO 5200
         ENDIF
 100  CONTINUE

* determine the start and count as netCDF will want them
* and determine which axis (cdrecax = 1-4) of THIS (possibly less than 4D)
* variable is the record axis.  
* 4/2012 6D Ferret: Note that dimensions 5 and 6 will NOT
* be the record axis. 

* (the complex logic for this is to allow future record axes not to be T)
      cdrecax = tmrecax
      dims = 0
      DO 200 idim = 1, nferdims
         iaxis = grid_line(idim, grid)
         IF ( iaxis.EQ.mnormal .OR. lo(idim).EQ.unspecified_int4) THEN
* TODO: this logic is NOT ok for 6D, it assumes rec ax # is larger than other axes. 
*       Wind up with cdrecax = 0...
            IF ( dims.LE.tmrecax .AND. idim.LE.4 ) cdrecax = cdrecax - 1   ! logic ok ??
         ELSE
            dims = dims + 1
            start(dims) = lo(idim) - slab_min(idim) + 1
            count(dims) = hi(idim) - lo(idim) + 1
         ENDIF
 200  CONTINUE

* synchronize with data already in the file along the record dimension
* then write the coordinate values to the file

* is record axis involved in this variable (e.g. time-independent) ?
      IF ( tmrecax .NE. 0 ) THEN
         lorec = lo(tmrecax)
         hirec = hi(tmrecax)
      ELSE
         lorec = unspecified_int4
      ENDIF
      IF ( lorec .NE. unspecified_int4 ) THEN

         CALL CD_REC_SYNCH( cdfid, lorec, hirec, tmrecax,
     .               grid, start(cdrecax), recaxvar, rectyp, 
     .               reset, old_box_hi, new_box_lo, writebounds,
     .               status )

         IF ( status .NE. merr_ok ) GOTO 5900
	 IF (.NOT. do_coords) GOTO 400

	 
         iaxis = grid_line(tmrecax, grid)
	 IF (line_dim_only(iaxis)) GOTO 400

* RESET flag: need to adjust box limits and possibly add a void point between the 
* last cell of the existing axis and the lower bound of the axis being appended

        IF (reset .NE. 0) THEN    
            IF (reset .EQ. 2) THEN  ! just need to adjust low bound of new axis.
               reset_bnd_lo = new_box_lo

            ELSE IF (reset .EQ. 1) THEN  ! write a void point

               savecount = count(cdrecax)
               count(cdrecax) = 1

**************************************

* Write out  an extra point on the axis; NC library 
* writes fill-missflagged data for the extra point?  


               r100_8(1) = (old_box_hi + new_box_lo)/2.D0

#ifdef FORTRAN_90
            cdfstat = NF_PUT_VARA_DOUBLE(cdfid, recaxvar, 
     .                 TRANSFER(start(cdrecax),start,1),
     .                 TRANSFER(1,count,1), 
     .		       TRANSFER(r100_8,r100_4))
#else
	    cdfstat = NF_PUT_VARA_DOUBLE(cdfid, recaxvar,
     .                 start(cdrecax), 1, r100_8)
#endif
            IF ( cdfstat .NE. NF_NOERR ) GOTO 5300


* Now write the bounds for this point

            r100_8(1) = old_box_hi
            r100_8(2) = new_box_lo

            bndstart(1) = 1
            bndcount(1) = 2
            bndstart(2) = start(cdrecax)
            bndcount(2) = 1

            cdfstat = NF_PUT_VARA_DOUBLE(cdfid, bndid, bndstart,
     .		           bndcount, r100_8)
            IF ( cdfstat .NE. NF_NOERR ) GOTO 5300

* Write a time-step slab containing missing data
            npts = 1
            DO 220  idim = 1, nferdims
! *sh* commented out 1/17 -- why was this line ever here?
! npts is udes to compute the work memory size.  Excluding recdim is
! inconsistent with the loop a few lines below where the work memory is filled
!               IF ( idim .EQ. tmrecax ) GOTO 220
               IF ( count(idim) .GT. 0 ) npts = npts* count(idim)
 220        CONTINUE

* allocate memory for missing-data
! Note: This code belongs in the Ferret libraries, rather than
!       in the TMAP libs, as it calls upon Ferret COMMON and memory mgmt

!DYNMEM_FIXME
* COMPUTE # BLOCKS NEEDED
!            grid_blocks = ( npts*4 + mem_blk_size - 1 ) / mem_blk_size
!
!            CALL GET_MEMORY( npts*4, grid_blocks, mblk1, nblks, status )
!            IF ( status .NE. merr_ok ) GOTO 5900

	    wrkspc = 4  ! arbitrarily slot 4 of Ferret tempry work storage
            rqst_size = npts * 4
	    CALL GET_WS_DYNMEM( rqst_size, wrkspc, status )
	    IF ( status .NE. merr_ok ) GOTO 5900

            CALL CD_GET_MISSING_FLAG (cdfid, varid, vname, .TRUE., 
     .           missflag, status)
            IF (status .EQ. 0) missflag = unspecified_val4

            npts = 1
	    workmem(wrkspc)%ptr(npts) = missflag
! 1/17 *sh* note that recdim is not excluded from this look
            DO 240 i = 1, MAX(count(1),1)
            DO 240 j = 1, MAX(count(2),1)
            DO 240 k = 1, MAX(count(3),1)
            DO 240 l = 1, MAX(count(4),1)
            DO 240 m = 1, MAX(count(5),1)
            DO 240 n = 1, MAX(count(6),1)
               workmem(wrkspc)%ptr(npts) = missflag
               npts = npts + 1
 240        CONTINUE

            CALL CD_WRITE_VAR_SUB( cdfid, varid, vartyp, dims, start,
     .             count, vdims(1), workmem(wrkspc)%ptr, cdfstat )
 
            CALL FREE_WS_DYNMEM( wrkspc )
            start(cdrecax) = start(cdrecax) + 1
            count(cdrecax) = savecount
         ENDIF

      ENDIF  ! Reset
**************************************

* write the record axis coords (buffer 100 at a time) (12/92 REAL*8 option)
* (code lifted from CD_REC_SYNCH 10/92)

         DO 310 i100 = lorec, hirec, 100
            hilim = MIN(i100+99, hirec)
            DO 300 i = i100, hilim
               r100_8(i-i100+1) = TM_WORLD(i,grid,tmrecax,box_middle)
               IF ( rectyp .EQ. NF_FLOAT ) r100_4(i-i100+1)
     .                                  = r100_8(i-i100+1)
 300        CONTINUE

#ifdef FORTRAN_90
	    cdfstat = NF_PUT_VARA_DOUBLE(cdfid, recaxvar, 
     .                 TRANSFER(i100-lorec+start(cdrecax),start,1),
     .                 TRANSFER(hilim-i100+1,count,1), 
     .		       TRANSFER(r100_8,r100_4) )
#else
	    cdfstat = NF_PUT_VARA_DOUBLE(cdfid, recaxvar, 
     .                 i100-lorec+start(cdrecax),
     .                 hilim-i100+1, r100_8)
#endif
            IF ( cdfstat .NE. NF_NOERR ) GOTO 5300
 310     CONTINUE

* Now write the bounds, if record axis is irregular, or if /BOUNDS was requested.

         iaxis = grid_line(tmrecax, grid)


	 IF (do_bounds .GE. 0) THEN
         IF ( (.NOT.line_regular(iaxis) .OR. writebounds .OR. 
     .          ITSA_TRUEMONTH_AXIS(iaxis) ) .AND. 
     .        (edges_flag .EQ. 0) ) THEN

            name = CD_AXIS_NAME( dset, grid, tmrecax, nlen )
            IF (keepax_flag .EQ. 1) name = CD_AXIS_OUTNAME( dset, grid, tmrecax, nlen )
    
* If mode upcase_output is set, then upcase the name

            IF (mode_upcase_output) THEN
               CALL STR_UPCASE( buff, name)
               name = buff
            
* If not mode upcase_output, then keep the incoming case. 
            ELSE 
               buff = CD_AXIS_OUTNAME( dset, grid, tmrecax, llen )
               IF (STR_SAME(name, buff) .EQ. 0) THEN 
	          name = buff
	          nlen = llen
               ENDIF
            ENDIF

            name = name(:nlen)//'_bnds'
            elen = nlen + 5
	    cdfstat = NF_INQ_VARID(cdfid, name(:elen),  bndid)
	    IF (cdfstat .NE. NF_NOERR ) THEN

* If bounds variable not found in file we're appending to, and the user 
* didn't specificially ask for /BOUNDS, just don't write bounds here either
	       IF (do_bounds .EQ. 0) THEN
	          writebounds = .FALSE.
	          GOTO 340
	       ELSE
	          GOTO 5400
	       ENDIF
	       
	    ENDIF
	       

            DO 330 i100 = lorec, hirec, 100
               hilim = MIN(i100+99, hirec)
               r100_8(1) = TM_WORLD(i100,grid,tmrecax,box_lo_lim)
               DO 320 i = i100, hilim
                  j = 2*(i-i100+1)-1
                  r100_8(2*(i-i100+1)-1) = TM_WORLD(i,grid,tmrecax,box_lo_lim)
                  r100_8(2*(i-i100+1)) = TM_WORLD(i,grid,tmrecax,box_hi_lim)
                  IF ( rectyp .EQ. NF_FLOAT ) r100_4(i-i100+1)
     .                                  = r100_8(i-i100+1)
 320           CONTINUE

               bndstart(1) = 1
               bndstart(2) = i100-lorec+start(cdrecax)
               bndcount(1) = 2
               bndcount(2) =  hilim-i100+1

               IF (reset_bnd_lo .NE. 0.D0) THEN
                  r100_8(i100-lorec+start(cdrecax)) = reset_bnd_lo
                  reset_bnd_lo = 0.D0
               ENDIF

	       cdfstat = NF_PUT_VARA_DOUBLE(cdfid, bndid, bndstart,
     .		           bndcount, r100_8)
               IF ( cdfstat .NE. NF_NOERR ) GOTO 5300
 330        CONTINUE
         ENDIF
         ENDIF
 340	 CONTINUE

      ENDIF ! IF ( lorec

*xxxx   Never scale the missing flag: instead we read data, insert the default missing-flag
*xxxx   for internal use in computing etc, and then on output restore the
*xxxx   packing, and the incoming missing-data flag.
*XXXXXXXXXXXXXXXX OLD BEHAVIOR was XXXXXXXXXXXXXXXX
* Scale the bad data too... on input to netCDF we scale all the data,
* compute the missing flag for internal use as indat*inscale + inoff
* and insert that internal missing flag.
*
* To write scaled data, scale all of it by ferretdat(1./inscale) - (inoff/inscale)
* the scaling to be used is sent into this routine.

*XXXXXXXXXXXXXXXX OLD BEHAVIOR above XXXXXXXXXXXXXXXX

 400  CONTINUE

      scaled = .FALSE.
      r_offset = 0.
      r_scale = 1.

      IF ( .NOT. TM_DFPEQ(scalefac, 1.D0) .OR. 
     .     .NOT. TM_DFPEQ(addoff, 0.D0) ) THEN

         IF (.NOT. TM_DFPEQ(scalefac, 0.D0) ) THEN
	    r_scale = 1. /scalefac
            r_offset = -1.D0* addoff* r_scale
         ENDIF

         npts = 1
         DO 250  idim = 1, nferdims
            IF ( count(idim) .GT. 0 ) npts = npts* count(idim)
 250     CONTINUE

	 IF (user_var) THEN
	    CALL TM_SCALE_NOBAD( r_scale, r_offset, dat, npts, bad, vartyp )
	 ELSE

c file var: rescale, skipping missing and restoring the _FillValue from the input file.
            CALL TM_SCALE_SWITCH_BAD ( r_scale, r_offset, fer_bad, bad, dat, npts )
	 ENDIF

         scaled = .TRUE.
      ENDIF

* write the slab

      CALL CD_WRITE_VAR_SUB( cdfid, varid, vartyp, dims, start, count, 
     .	vdims(1), dat, cdfstat )

* If rescaled above, restore it to previous values so it can be reused 

      IF ( scaled ) THEN
         r_scale = scalefac
         r_offset = addoff
	 
	 IF (user_var) THEN
	    CALL TM_SCALE_NOBAD( r_scale, r_offset, dat, npts, bad, vartyp )
	 ELSE

c unpack again, skipping missing and going back to Ferret internal bad-flag.
            CALL TM_SCALE_SWITCH_BAD ( r_scale, r_offset, bad, fer_bad, dat, npts )

	 ENDIF
      ENDIF

      IF ( cdfstat .EQ. -60) GOTO 5260
      IF ( cdfstat .NE. NF_NOERR ) GOTO 5300

* successful completion
 1000 status = merr_ok
      RETURN

* error messages
 5100 CALL TM_ERRMSG
     . ( merr_unkvar, status, 'CD_WRITE_VAR', unspecified_int4,
     .   unspecified_int4,
     .   'variable was never created in CDF file',
     .   vname(:vlen), *5900 )

 5200 vbuff = vname   ! needed because of fussy DEC f77 v2.1 compiler
      CALL TM_ERRMSG (merr_outofgrid, status, 'CD_WRITE_VAR',
     .     no_descfile, no_stepfile,
     .     vbuff(:vlen)//'['//dimnam(idim)//'='//
     .     TM_STRING(DBLE(lo(idim)))//':'//
     .     TM_STRING(DBLE(hi(idim)))//']',
     .     vbuff(:vlen)//'['//dimnam(idim)//'='//
     .     TM_STRING(DBLE(slab_min(idim)))//':'//
     .     TM_STRING(DBLE(slab_max(idim)))//']',
     .     *5900)

 5250 vbuff = vname 
      CALL TM_ERRMSG (merr_outofgrid, status, 'CD_WRITE_VAR',
     .     no_descfile, no_stepfile, 
     .    'inconsistent '//dimnam(idim)//' axis length for '//
     .     vbuff(:vlen), no_errstring, *5900 )
     

 5260 vbuff = vname 
      CALL TM_ERRMSG (cdfstat+pcdferr, status, 'CD_WRITE_VAR',
     .     no_descfile, no_stepfile, 
     .    'data in variable '//vbuff(:vlen)//
     .    ' not representable in output type '//typnam(vartyp),
     .     no_errstring, *5900 )

 5300 CALL TM_ERRMSG
     . ( cdfstat+pcdferr, status, 'CD_WRITE_VAR', unspecified_int4,
     . no_varid, 'failure writing to CDF output file',
     . no_errstring, *5900 )

 5400  CALL TM_ERRMSG
     . ( cdfstat+pcdferr, status, 'CD_WRITE_VAR', 
     .   no_descfile, no_stepfile, name(:elen)//' not found. '//
     . 'Attempt to append to NetCDF axis having no bounds attribute. '//
     . 'Use /NOBOUNDS or rewrite original data with bounds.',
     . no_errstring, *5900 )

* error exit
 5900   RETURN
	END

	SUBROUTINE PARSEV(LINE,UPLINE,ILEN,RESULT,IER,IPOS)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)parsev.f	1.2    5/26/88
C**
C**
C***********************************************************************
C**
C**		    PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C**	Subprogram called:
C**		call parsev(line,upline,ilen,result,ier,ipos)
C**
C**	Parameters:
C**		line -- input line (char*2048)
C**		upline -- input line capitals (char*2048)
C**		ilen -- length of line
C** 	result -- output (logical)
C**		ier -- error code
C**		       6 = no operator found
C**		ipos -- position error was found in line
C**
C**	Description:
C**		Parses the logical expression for both if and while
C**		statements.  Returns a logical result, either true or
C**		false.
C**
C**	History:
C**	    Written: 
C**		3-SEP-86	by Donald W. Denbo
C**	    Modified:
C**
C**
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
C* v552 *acm* 3/03 Longer strings: changes for multi-line labels
* v580 *acm* 8/04 Change use of 256 to buflen+1, 
*                 where buflen is defined in cmndlen.inc
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long

        INCLUDE 'cmndlen.inc'

	CHARACTER LINE*(*),UPLINE*(*),EXP1*2048,EXP2*2048
	LOGICAL RESULT,NUM1,NUM2,NUM
	IER=0
C
C	CHECK FOR OPERATORS
C
	IEQ=INDEX(UPLINE,'.EQ.')
	IF(IEQ.LE.0)THEN
	    IEQ=buflen+1
	ELSE
	    ISW=1
	ENDIF
	INE=INDEX(UPLINE,'.NE.')
	IF(INE.LE.0)THEN
	    INE=buflen+1
	ELSE
	    ISW=2
	ENDIF
	ILT=INDEX(UPLINE,'.LT.')
	IF(ILT.LE.0)THEN
	    ILT=buflen+1
	ELSE
	    ISW=3
	ENDIF
	IGT=INDEX(UPLINE,'.GT.')
	IF(IGT.LE.0)THEN
	    IGT=buflen+1
	ELSE
	    ISW=4
	ENDIF
	ILE=INDEX(UPLINE,'.LE.')
	IF(ILE.LE.0)THEN
	    ILE=buflen+1
	ELSE
	    ISW=5
	ENDIF
	IGE=INDEX(UPLINE,'.GE.')
	IF(IGE.LE.0)THEN
	    IGE=buflen+1
	ELSE
	    ISW=6
	ENDIF
	IOP=MIN0(IEQ,INE,ILT,IGT,ILE,IGE)
	IF(IOP.GE.buflen+1)THEN
C
C	NO OPERATOR FOUND
C
	    IER=6
	    IPOS=1
	    RETURN
	ENDIF
C
C	GET EXPRESSIONS
C
	I=1
100	IF(LINE(I:I).NE.' ')GOTO 110
	I=I+1
	GOTO 100
110	EXP1=LINE(I:IOP-1)
	LEN1=LNBLK(EXP1,IOP-I)
	I=IOP+4
120	IF(LINE(I:I).NE.' ')GOTO 130
	I=I+1
	GOTO 120
130	EXP2=LINE(I:ILEN)
	LEN2=LNBLK(EXP2,ILEN-I+1)
C
C	EVALUATE EXPRESSIONS
C
	CALL EXPEVL(EXP1,LEN1,X1,NUM1,IER)
	CALL EXPEVL(EXP2,LEN2,X2,NUM2,IER)
	NUM=NUM1.AND.NUM2
C
C	DO TEST
C
	IF(NUM)THEN
	    GOTO(201,202,203,204,205,206)ISW
201	    RESULT=X1.EQ.X2
     	    GOTO 210
202	    RESULT=X1.NE.X2
	    GOTO 210
203	    RESULT=X1.LT.X2
	    GOTO 210
204	    RESULT=X1.GT.X2
	    GOTO 210
205	    RESULT=X1.LE.X2
	    GOTO 210
206	    RESULT=X1.GE.X2
210	    CONTINUE
	ELSE
	    GOTO(301,302,303,304,305,306)ISW
301	    RESULT=EXP1(:LEN1).EQ.EXP2(:LEN2)
	    GOTO 310
302	    RESULT=EXP1(:LEN1).NE.EXP2(:LEN2)
	    GOTO 310
303	    RESULT=EXP1(:LEN1).LT.EXP2(:LEN2)
	    GOTO 310
304	    RESULT=EXP1(:LEN1).GT.EXP2(:LEN2)
	    GOTO 310
305	    RESULT=EXP1(:LEN1).LE.EXP2(:LEN2)
	    GOTO 310
306	    RESULT=EXP1(:LEN1).GE.EXP2(:LEN2)
310	    CONTINUE
	ENDIF
	RETURN
	END
	SUBROUTINE EXPEVL(STRING,SLEN,X,NUM,IER)
C**
C**
C***********************************************************************
C**
C**		    PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C**	Subprogram called:
C**		call expevl(string,slen,x,num,ier)
C**
C**	Parameters:
C**		string -- input expression (char*2048)
C**		slen  -- length of string
C**		x -- numeric result
C**		num -- logical for number (logical)
C**		ier -- error code
C**		       7 = unmatched "
C**
C**	Description:
C**		Evaluates expression.
C**
C**	History:
C**	    Written: 
C**		3-SEP-86	by Donald W. Denbo
C**	    Modified:
C**
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*       *jd* 11.94 - modified for AIX port
*       Modification uses TM_NUMBER to determine if "value" is a number rather
*       than the ERR= branch of a READ which fails on AIX/xlf

C**
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 

	CHARACTER STRING*(*),TEMP*2048,FRMT*120
	INTEGER SLEN
	LOGICAL NUM

        LOGICAL TM_NUMBER                ! ** TMAP mod 11/94 **

	NUM=.FALSE.
C
C	CHECK FOR STRING
C
	IER=0
	SLEN=LNBLK(STRING,SLEN)
	STRING=STRING(:SLEN)
	IF(STRING(1:1).EQ.'"')THEN
	    IF(STRING(SLEN:SLEN).NE.'"')THEN
		IER=7
		RETURN
	    ENDIF
	    TEMP=STRING(2:SLEN-1)
	    SLEN=SLEN-2
	ELSE
C
C	CHECK FOR NUMBER
C
	    if(slen.eq.1)then

#ifdef AIX_XLF
            IF ( .NOT.TM_NUMBER(string) ) GOTO 100 ! TMAP Mod
#endif
		read(string,'(i1)',err=100)jk
		x=jk
	    else
	        WRITE(FRMT,999)SLEN
999	    FORMAT('(E',I3.3,'.0)')

#ifdef AIX_XLF
            IF ( .NOT.TM_NUMBER(string) ) GOTO 100 ! TMAP Mod
#endif
	    READ(STRING,FRMT,ERR=100)X
	    endif
	    NUM=.TRUE.
	    RETURN
	ENDIF
200	IF(SLEN.EQ.0)GOTO 300
	if(slen.eq.1)then
#ifdef AIX_XLF
            IF ( .NOT.TM_NUMBER(temp) ) GOTO 300 ! TMAP Mod
#endif
	    read(temp,'(i1)',err=300)jk
	    x=jk
	else
	    WRITE(FRMT,999)SLEN
#ifdef AIX_XLF
            IF ( .NOT.TM_NUMBER(temp) ) GOTO 300 ! TMAP Mod
#endif
	    READ(TEMP,FRMT,ERR=300)X
	endif
	NUM=.TRUE.
300	STRING=TEMP
	RETURN
100	CALL GETSYM(STRING(:30),TEMP,SLEN,IER2)
	IF(IER2.NE.0)THEN
	    STRING=' '
	    SLEN=0
	    RETURN
	ENDIF
	GOTO 200
	END

	SUBROUTINE INTERP_CONTEXT ( isp_base, cx, name_code, status )



*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Determine the complete context of a user variable -- its grid
* and all region information including region info that is embedded inside
* of sub-definitions. For example 
*	LET expr = A[l=1:5]; LET A = SST[X=130E:80W]
* would need to include the X limits, too, in the final result 

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V510: 3/00 *sh* extracted from INTERP_STACK
* V530: 3/01 *sh* bug fix - deallocate implicit grid 
* V531: 4/01 *sh* insert missing value flag into the context
* V532: 6/01 *sh* bug fix:  CALL DEALLO_UNFORMED_GRID instead of DEALLO_GRID
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V685: 1/13 *sh* ensure that sst[L=@ave] is recognized as a compressed axis
* V702 1/17 *sh* for trac enhancement #2369 -- dynamic memory management

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'

* calling argument declarations:
	INTEGER		isp_base, cx, status
	CHARACTER*(*)	name_code

* internal variable declarations:
	LOGICAL		explicit_qualifiers
	INTEGER		UVAR_NUMBER, KNOWN_GRID, idim, uvar,
     .			start, end, mod_cx

* calling arguments:
* in	isp_base	- stack level at which to begin calculations
*			  ( all levels below remain untouched )
* in	cx		- context slot to return
* in	name_code	- name of uvar to be evaluated
* out	status		- completion code


* locate the requested variable in the uvar variables
	uvar = UVAR_NUMBER( name_code )
	IF ( uvar .EQ. unspecified_int4 ) CALL ERRMSG
     .		( ferr_internal, status, 'intp_stk', *5000 )
	
* initialize the default context for the quantity to evaluate
	cx_variable( cx ) = uvar
	cx_category( cx ) = cat_user_var
	cx_grid    ( cx ) =
     .		KNOWN_GRID(cx_data_set(cx),cat_user_var,uvar)

* initialize base level of the interpretation stack
* ... ( see PUSH_INTERP_STACK for isp>isp_base )
	isp = isp_base			! stack pointer
	is_cx  ( isp ) = cx	! context for stack activities
	is_uvar( isp ) = uvar	! pointer to text buffer

* when called the request is ALWAYS for an untransformed implicitly defined
* user variable (e.g. "LIST U" or "LIST SIN(X+Y)"
* determine its grid, if necessary - then flesh out the requested dimensions
	IF ( cx_grid(cx) .EQ. unspecified_int4 ) THEN
	   CALL GET_UVAR_GRID( uvar,cx_data_set(cx),status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   cx_grid(cx) =
     .		KNOWN_GRID(cx_data_set(cx),cat_user_var,uvar)
	ENDIF

* flesh out the requested dimensions (noting if there are any)
	explicit_qualifiers = .FALSE.
	DO 5 idim = 1, nferdims
	   IF ( uvar_given( idim, uvar ) .GE. uvlim_needed
     .	   .OR. cx_given( idim,cx ) ) THEN
	      explicit_qualifiers = explicit_qualifiers
     .			       .OR. cx_given(idim,cx )
	      CALL CONFINE_AXIS( idim, cx, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
	      CALL FLESH_OUT_AXIS( idim, cx, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
	   ENDIF
 5	CONTINUE
	
* copy uvar_* limits into the output context
	DO 100 idim = 1, nferdims
	   IF ( cx_lo_ss(cx, idim) .EQ. unspecified_int4 ) THEN
	      IF ( uvar_given(idim,uvar) .GE. uvlim_gvn_gnl
     .       .AND. uvar_given(idim,uvar) .LE. uvlim_gvn_xact ) THEN
	         cx_lo_ss(cx, idim) = uvar_lo_ss(uvar, idim)
	         cx_hi_ss(cx, idim) = uvar_hi_ss(uvar, idim)
	         cx_lo_ww (idim, cx) = uvar_lo_ww(idim, uvar)
	         cx_hi_ww (idim, cx) = uvar_hi_ww(idim, uvar)
	         cx_by_ss (idim, cx) = uvar_by_ss(idim, uvar)
	      ENDIF
	   ENDIF
 100	CONTINUE

* if the expression is a single variable, then "EX#1" becmes that variable
	IF ( uvar_num_items(uvar) .EQ. 1
     . .AND. uvar_item_type(1,uvar) .EQ. alg_variable ) THEN
	   start = uvar_item_start( 1, uvar )
	   end   = uvar_item_end  ( 1, uvar )
	   CALL PARSE_NAM_DSET( uvar_text(uvar)(start:end),
     .				cx, cx_data_set(cx),
     .				cx_category(cx),
     .				cx_variable(cx), mod_cx, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   IF ( cx_has_impl_grid(mod_cx) ) THEN
	      CALL DEALLO_UNFORMED_GRID( status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
	   ENDIF
	ENDIF

* fill in any unspecified limits with information from the grid
	CALL COMPLETE_MISSING_LIMITS(cx)

* *sh* 1/2013
* make sure that the cx_lo/hi_ss limits of compressed axes are unset
	DO 200 idim = 1, nferdims
	   IF ( uvar_given(idim,uvar) .EQ. uvlim_need_xact ) THEN
	      cx_lo_ss(cx, idim) = unspecified_int4
	      cx_hi_ss(cx, idim) = unspecified_int4
	   ENDIF
 200	CONTINUE


* insert the missing value flag
	CALL GET_CONTEXT_BAD_FLAG(cx)

* success
	RETURN

* error exit - clean up
 5000	CALL RELEASE_DYN_WORK_SPACE
	CALL DELETE_MRS_IN_PROGRESS
	CALL UNPROTECT_ALL_MRS
	CALL DEALLO_ALL_GRIDS
        CALL CLEAN_STACK
	RETURN
	END

	SUBROUTINE INITIALIZE_FERRET

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* initialize run-time variables and I/O in preparation to begin execution
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/26/86
* revision 0.1 - 12/11/86 - explicit OPEN of SYS_OUTPUT with 255 byte RECL
*			    and 255 byte RECL on journal file OPEN
* revision 0.2 - 1/30/87 - modified for mr_protected declared as INTEGER
*			   and RADIUS made a parameter in FERRET.PARM
* revision 0.3 - 5/1/87  - EXTERNAL *CONTROL and no LIST file opened
* revision 0.4 - 9/14/87 - added VMS calls to turn on line recall
* revision 0.5 - 11/30/87- added call to enable ^C interrupts
* revision 0.6 - 2/18/88 - converted X axes to "regular" format
* revision 0.7 - 5/2/88  - changed GFDL.JNL to GFDL_JOURNAL (logical) and added
*			   ERR= branch to OPEN
* revision 0.8 - 6/29/88  - changed GFDL_JOURNAL to FERRET_JOURNAL
*			    and today_time in hours:minutes, only
*			    determine mode (interactive) here
* revision 0.9 - 7/21/88 - memory initialization done by INIT_MEMORY
* revision 1.0 - 8/12/88 - added FERRET_INIT optioal initialization file
* revision 1.1 -11/22/88 - new TM IO library
* revision 1.2 - 2/2/89  - allow program to continue w/out journal file
* V200:  6/22/89 - define special grids at run time
*	 12/6/89 - initialize mode_GKS and mode_wait
* Unix/RISC port - 1/91 ... several OS dependencies fixed
*                - 9/91 - fixed err handling when journal file cant be opened
*                - 10/91 - hook to enable PLOT+ braindead features
*                - 10/91 -   FER_INIT ==> .ferret
* V230:  5/14/92 - on SGI (with no backing store) set REFRESH mode
* V300:  5/12/93 - split journal file init into another file
*		 - relocated sgi IFDEF to default REFRESH to ON
*       10/25/93 - default MODE REFRESH ON for **all** systems
*	 2/24/94 - small change due to mode_state as a 2D variable
*	 3/14/94 - base initial state of mode refresh on "ifdef X_REFRESH"
* V312:  5/19/94 - significant portions of routine removed to new MAIN program
* V313: 10/27/94 - *sh* AIX port: avoid the routine name "time"
* V420:  9/19/95 - call TM_INIT_DYN_GRIDS for dynamic (implicit) grid creation
* Linux port *kob* 3/96 - had to add calls to use F90 data and time routine
*		     rather than f77 default routines.
* V602  2/07 *acm* Fix bug 1492, changing attributes of coordinate variables 
*                  Use pseudo-dataset of user-defined axes to keep track of attributes.
* V65   2/10 *acm*- Changes for CLOCK symbols that work with gfortran as well as g77.
*                   see special_symbol.F
* V68   1/12 *acm* declarations changes for double-precision ferret.
*       3/12 *acm* cleanup ifdefs and unnecessary include files
* V698  3/16 *acm* Removed Philander-Seigel code including diagnostic 
*                  variables, pre-defined axes and grids, cat_calc_var.

        IMPLICIT NONE
        include 'tmap_errors.parm'  ! error codes
	include 'tmap_dims.parm'
	include 'xio.cmn_text'
        include 'xdset_info.cmn_text'
	external xio_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'gfdl_vms.parm'
	include	'errmsg.parm'
	include	'gfdl.parm'			! from phil/sieg
	include	'xonedim.cmn'		! from phil.sieg
	include 'xprog_state.cmn'
        include 'xalgebra.cmn'
	include 'xvariables.cmn'
	include 'xtoday.cmn'

* local variable declarations:
	LOGICAL	GKS_WINDOWS, fexist
	INTEGER	TM_LENSTR1, ito, ifrom, mem_blk, mr, iset, status
      integer icount, irate, imax
	REAL	DTIME, radian, cm2deg
	REAL*4  TArray(2), dtime_res


*************** I/O ************************************************************
	interactive = .TRUE.

* determine default GKS usage based on system logon device
	mode_GKS = GKS_WINDOWS()
	mode_wait = .NOT.mode_GKS	! no wait after plot on window device

* turn on segment-based screen refresh or screen updates dont always work
#ifdef X_REFRESH
      CALL TM_SET_FREE_EVENT(1)
      mode_state( pmode_xwindows, 1 ) = .TRUE.
#else
      mode_state( pmode_xwindows, 1 ) = .FALSE.
#endif
        CONTINUE
	
*********************** Climatological axes ************************************
	CALL TM_SET_CLIM_AXES

* set up special grids
	CALL DEFINE_SPECIAL_GRIDS   ! label 1000 moved here 9/91 *sh*

* initialize dynamic grid management
	CALL TM_INIT_DYN_GRIDS

*************** TODAY'S DATE ***************************************************


#ifdef AIX_XLF
	CALL AIX_DATE( today_date )
	CALL AIX_TIME( today_time )
#elif F90_DATE_TIME
	CALL FDATE(today_date)
	CALL FTIME(today_time)
#else
*	CALL DATE( today_date )
*	CALL TIME( today_time )
* *kob*  try new routine for y2k fix
	CALL GET_DATE_AND_TIME (today_date, today_time)
#endif
	today_time = today_time(:5)	! w/out seconds

* DTIME returns a real number which is the running time for this 
* process since the last call to DTIME. TIMEARRAY(1) reports the user time, 
* and TIMEARRAY(2) supports the system time. Argument 2 is the sum of the two.
* Call the routine to initialize the result. It can be updated by evaluating 
* the symbol DELTA_CPU. See special_symbol.F

      dtime_res = DTime(TArray)
      cpu_last = 0.0  ! in common xtoday.cmn

* ALso a special symbol CLOCK_SECS, the delta seconds in clock time since Ferret
* session is initialized.  Save clock_start_count to subtract from the value
* when this symbol is updated.

      CALL System_Clock(icount, irate, imax)
      clock_start_count = icount

* initialize pseudo-dataset in linked-list structure which will contain all 
* user variables and their attributes.
* Also another pseudo-dataset to contain user-defined coordinate variables (axes). 

        iset  = -1;
        CALL ncf_init_uvar_dset( iset )
        iset  = -2;
        CALL ncf_init_uax_dset( iset )

*************** STATE VARIABLES ************************************************
* see BLOCK DATA initialization of COMMON/ XPROG_STATE /

*********************** GRIDS **************************************************
c	CALL GFDL_TERMS

	RADIAN=57.29578							! 1027
	cm2deg = radian / radius



*************** MISCELLANEOUS **************************************************
* TMAP librabry routine errors to same output unit as other errors
	lunit_errors = err_lun

*************** INITIALIZE SPECIAL CHARACTERS *************************
*
*       Initialize special characters in COMMON - needed for g77 port to
*         comply with other compilers *kob*  3/03
	pCR = CHAR(15)

*************** BRAINDEAD PLOT+ ******************************************
        CALL PPL_BDEAD

        CALL string_array_init(alg_pvar_head,
     .                         num_pseudo_vars,
     .                         8,
     .                         alg_pvar(1))

        CALL string_array_init(countervar_name_head,
     .                         num_counter_vars,
     .                         128,
     .                         countervar_name(1))

        CALL string_array_init(uvar_name_code_head,
     .                         max_uvar,
     .                         128,
     .                         uvar_name_code(1))

        CALL string_array_init(ds_var_code_head,
     .                         maxvars,
     .                         128,
     .                         ds_var_code(1))

        CALL deleted_list_init(uvar_num_items_head,
     .                         uvar_num_items(1),
     .                         max_uvar,
     .                         uvar_deleted)

	RETURN

	END

! curv_to_rect_fsu.F
! From Matt Harrison hinterp.F
! to call only the spherical interpolation modules, and
! recast in F77-compileable format.
!
! This is a special version of curv_to_rect, but with num_nbrs = 1 not 4.
! the mapping function computed at FSU uses just one neighbor.
!   
!   -- Check use of and document issue of cell bounds 
!      vs cell centers.
!
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*


* acm 12/2004 Compute the sum of weights in routine apply_mapping; 
*             sum of weights used when there is good data contributing 
*             to the destination point.
*             Remove use of mask_dst variable; never used.
* acm  3/2005 The curvilinear data may be a subset.  If it was saved
*             with SAVE/HEADING=ENHANCED, then the lo and hi subscripts
*             in the dataset correspond to the subset, and we can use
*             a map pre-computed using the entire dataset for this regridding.
*             Pass the subscripts of the input curvilinear data to the 
*             apply_mapping routine (if not a subset these are 1:max_ss).
* ACM  1/2009 Correct bug with the indices passed into apply_mapping; Treating
*             indices as if they start at 1 inside that routine lets us compute 
*             and apply mapping functions based on subsets of the grid


! In this SUBROUTINE we provide information about
! the function.  The user configurable information 
! consists of the following:
!
! descr              Text description of the function
!
! num_args           Required number of arguments
!
! axis_inheritance   Type of axis for the result
!                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
!                       CUSTOM          - user defined axis
!                       IMPLIED_BY_ARGS - same axis as the incoming argument
!                       NORMAL          - the result is normal to this axis
!                       ABSTRACT        - an axis which only has index values
!
! piecemeal_ok       For memory optimization:
!                       axes where calculation may be performed piecemeal
!                       ( YES, NO )
! 
!
! For each argument we provide the following information:
!
! name               Text name for an argument
!
! unit               Text units for an argument
!
! desc               Text description of an argument
!
! axis_influence     Are this argument's axes the same as the result grid?
!                       ( YES, NO )
!
! axis_extend       How much does Ferret need to extend arg limits relative to result 
!


      SUBROUTINE curv_to_rect_fsu_init(id)
        
      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER   id, arg
      CHARACTER*100  descr

!**********************************************************************
!                                           USER CONFIGURABLE PORTION |
!                                                                     |
!                                                                     V

      WRITE (descr, 10)
   10 FORMAT
     .('Apply mapping to regrid from curvilinear to rectangular grid')
      CALL ef_set_desc(id, descr)

      CALL ef_set_num_args(id, 2)

      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS,  
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'V')
      CALL ef_set_arg_desc(id, arg, 
     .  'Variable to regrid, on curvilinear grid V(x,y,z,t)')
      CALL ef_set_axis_influence(id, arg, NO, NO, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'mapping')
      WRITE (descr, 30)
   30 FORMAT ('mapping computed by curv_to_rect_MAP')
      CALL ef_set_arg_desc(id, arg, descr)
      CALL ef_set_axis_influence(id, arg, YES, YES, NO, NO)

!                                                                     ^
!                                                                     |
!                                           USER CONFIGURABLE PORTION |
!***********************************************************************

      RETURN 
      END  ! SUBROUTINE curv_to_rect_fsu_init


!
! In this SUBROUTINE we compute the result
!
      SUBROUTINE curv_to_rect_fsu_compute(id, arg_1, arg_2, result)

      IMPLICIT none
      
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'
      
      INTEGER  id

      REAL  bad_flag(EF_MAX_ARGS), bad_flag_result

      REAL  arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .       mem1lot:mem1hit)
      REAL  arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .       mem2lot:mem2hit)

      REAL  result(memreslox:memreshix, memresloy:memreshiy, 
     .      memresloz:memreshiz, memreslot:memreshit)

! After initialization, the 'res_' arrays contain indexing information 
! for the result axes.  The 'arg_' arrays will contain the indexing 
! information for each variable's axes. 

      INTEGER  res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER  arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .         arg_incr(4,EF_MAX_ARGS)
      
!**********************************************************************
!                                           USER CONFIGURABLE PORTION |
!                                                                     |
!                                                                     V

      INTEGER  i, j, k, l, i1, j1, k1, l1, i2, j2, k2, l2, ih, jh,
     .         num_nbrs, nlon_src, nlat_src, nlon_dst, nlat_dst

      num_nbrs = 4
      num_nbrs = 1
      
      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id,bad_flag,bad_flag_result)

      nlon_src = arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 1
      nlat_src = arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1) + 1

      nlon_dst = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1
      nlat_dst = arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) + 1

      i1 = arg_lo_ss(X_AXIS,ARG1)
      j1 = arg_lo_ss(Y_AXIS,ARG1)
      ih = arg_hi_ss(X_AXIS,ARG1)
      jh = arg_hi_ss(Y_AXIS,ARG1)

      i2 = arg_lo_ss(X_AXIS,ARG2)
      j2 = arg_lo_ss(Y_AXIS,ARG2)
      k2 = arg_lo_ss(Z_AXIS,ARG2)
      l2 = arg_lo_ss(T_AXIS,ARG2)

      i = res_lo_ss(X_AXIS)
      j = res_lo_ss(Y_AXIS)

      l1 = arg_lo_ss(T_AXIS,ARG1)
      DO l = res_lo_ss(T_AXIS),res_hi_ss(T_AXIS)

         k1 = arg_lo_ss(Z_AXIS,ARG1)
         DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

c     .        i1, ih, j1, jh,  ! line 2 of this call WAS... 
c     .        1,nlon_src, 1,nlat_src,  ! Or try  
            CALL apply_mapping ( arg_1(i1,j1,k1,l1), 
     .        i1, ih, j1, jh,
     .        arg_2(i2,j2,k2,l2), arg_2(i2,j2,k2,l2+1),
     .        arg_2(i2,j2,k2,l2+2), result(i,j,k,l), nlon_src,
     .        nlat_src, nlon_dst, nlat_dst, num_nbrs, 
     .        bad_flag(ARG1), bad_flag_result )

            k1 = k1 + arg_incr(Z_AXIS,ARG1)
         ENDDO

         l1 = l1 + arg_incr(T_AXIS,ARG1)
      ENDDO


!                                                                     ^
!                                                                     |
!                                           USER CONFIGURABLE PORTION |
!**********************************************************************

      RETURN 
      END  ! SUBROUTINE curv_to_rect_fsu_compute

!#######################################################################
            
       subroutine apply_mapping (data_in, ilo, ihi, jlo, jhi,
     .                           wt, i_lon, j_lat, data_out, 
     .                           nlon_src, nlat_src, nlon_dst, nlat_dst,
     .                           num_nbrs, bad_flag_in, bad_flag_out)

! This is the last set of loops from horiz_interp_sphe, applying wt
! to the data to compute the regridded result.

! acm 7/2004 Add variable COUNT to set data to missing if there is nothing added
! to the sum in a given output grid cell.  This had been done in the original code
! by seeing if the value is a "land" value, but it is not general enough for our
! purposes.

! acm 12/2004 Compute the sum of weights here; weights only used when there
!             is good data contributing to the destination point.

       integer ilo, ihi, jlo, jhi
       real data_in(ilo:ihi, jlo:jhi)     ! input field
       real data_out(nlon_dst, nlat_dst)  ! output
       real wt(nlon_dst, nlat_dst, num_nbrs)  

       real i_lon(nlon_dst,nlat_dst,num_nbrs)
       real j_lat(nlon_dst,nlat_dst,num_nbrs) 

       real bad_flag_in, bad_flag_out

       integer nlon_src, nlat_src, nlon_dst, nlat_dst, 
     .         num_nbrs

!--- some local variables ----------------------------------------
       integer nlon_in, nlat_in, nlon_out, nlat_out, num_neighbors,
     .               m, n, k, i, j
       real sum
       logical okij
!-----------------------------------------------------------------

! parameters
      real epsln, large
cc      parameter (epsln=1.e-10, large=1.e20)
      parameter (epsln=4.e-7, large=1.e20)

         nlon_in  = nlon_src
         nlat_in  = nlat_src
         nlon_out = nlon_dst
         nlat_out = nlat_dst   
         num_neighbors = num_nbrs

         do m=1,nlon_out
         do n=1,nlat_out

            data_out(m,n) = 0.0
            sum=0.0
            do k=1, num_neighbors
               i = i_lon(m,n,k)
               j = j_lat(m,n,k)

               okij = .TRUE.
               IF (i .LT. ilo  .OR. i .GT. ihi) THEN
                  okij = .FALSE.
               ENDIF
               IF (j .LT. jlo  .OR.  j .GT. jhi) THEN
                  okij = .FALSE.
               ENDIF


               if (i.GT.0 .and. j.GT.0 .AND. okij) THEN
                  IF (data_in(i,j) .NE. bad_flag_in ) THEN
                     data_out(m,n) = data_out(m,n)+
     .                                  data_in(i,j)*wt(m,n,k)
                     sum = sum + wt(m,n,k)
                  endif
               else
                  data_out(m,n) = bad_flag_out
                  GO TO 33
               endif
            enddo

            IF (sum .GT. epsln) THEN
               data_out(m,n) = data_out(m,n)/sum
            ELSE
               data_out(m,n) = bad_flag_out
            ENDIF
  33        continue

         enddo
         enddo
      

         return
       end ! subroutine horiz_interp_sphe
      
      

	SUBROUTINE INIT_FTDS_DSET ( dset, uvar, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* v6.85 *acm* Ferret with LET/REMOTE
* Reset the url for the dataset with its f-tds variable definitions.

        IMPLICIT NONE
* calling argument declarations:
	INTEGER		dset, uvar, status

* local variable declarations
	INTEGER TM_LENSTR1, nvars, nv, slen, vlen, varid, ivar
	CHARACTER buff*3000, ebuff*3000, vname*128

* Includes
	include 'tmap_errors.parm'
        include 'tmap_dims.parm'
        include 'xtm_grid.cmn_text'
        external xgt_grid_data
	include	'ferret.parm'
	include	'interp_stack.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
        include 'xdset_info.cmn_text'
        external xdset_info_data

	IF (rvar_on_server(uvar)) RETURN

	buff = '_expr_{}{'
	slen = TM_LENSTR1(buff)
	nvars = 0

	DO 100 ivar = 1, maxvars
	   IF (uvar_remote(ivar) .AND. rvar_dset(ivar) .EQ. dset) THEN

* Concatenate multiple definitions with _cr_ not with ;
	      IF (nvars .GT. 0) 
     .	        buff = buff(:slen)//'_cr_'
	      slen = TM_LENSTR1(buff)

	      vname = uvar_name_code(ivar)
	      vlen = TM_LENSTR1(vname)
              buff = buff(:slen)//'letdeq1 '//vname(:vlen)//'='

	      slen = TM_LENSTR1(buff)
	      vlen = TM_LENSTR1(uvar_text(ivar))
              buff = buff(:slen)//uvar_text(ivar)(:vlen)
	      slen = TM_LENSTR1(buff)

	      nv = ivar
	      nvars = nvars + 1

	   ENDIF
  100	CONTINUE

	IF (nvars .EQ. 0) GOTO 5100
	
* Close the url

	buff = buff(:slen)//'}'
* Encode the definitions
	CALL CD_ENCODE_URL ( buff, ebuff, status)
	IF (status .NE. ferr_ok) GOTO 5200
	
* Next make the full url and try to open it.

	slen = TM_LENSTR1(ds_des_name(dset))
	vlen = TM_LENSTR1(ebuff)
	buff = ds_des_name(dset)(:slen)//ebuff(:vlen)


* nc_close the dataset. We're going to re-open it with the
* F-TDS variable definitions

	CALL CD_NCCLOSE (dset, status)

* Reopen dataset with the f-tds variables. Save its cdfid in
* the storege for this dset.

	CALL CD_NCOPEN (buff, dset, status)

	IF (status .NE. ferr_ok) THEN  ! Just reopen the original dataset
	   buff = ds_des_name(dset)
	   CALL CD_NCOPEN (buff, dset, status)
	   status = ferr_remotevar_error
	   GOTO 5000
	ENDIF

* Now will get varids and stuff.

	DO 200 ivar = 1, maxvars
	   IF (uvar_remote(ivar) .AND. rvar_dset(ivar) .EQ. dset) THEN

	      vname = uvar_name_code(ivar)
	      CALL CD_NF_GET_VARID ( dset, vname, varid, status )
	      IF (status .NE. ferr_ok) GOTO 5300

	      rvar_varid (ivar) = varid
	      rvar_on_server (ivar) = .TRUE.  ! Definition in current url.
	      IF (ivar .GE. nv) GOTO 300
	   ENDIF
  200	CONTINUE

  300	CONTINUE

 5000	RETURN
 5100   goto 5000 ! ? need message - no remote vars for this dataset
 5200   buff = 'Error encoding F-TDS url for LET/REMOTE definitions '
        CALL ERRMSG(ferr_remotevar_error, status, buff, *5000 )

 5300   CONTINUE !  need error handling - error getting varid
	buff = 'Error getting remote variable id for LET/REMOTE definition'
        CALL ERRMSG (ferr_remotevar_error, status, buff, *5000 )

	END

	SUBROUTINE FLAG2DDUPS( n, x, y, epsx, epsy, dup, seq )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* Locate the duplicate coordinate pairs in a list of coordinates
* Will be regarded as duplicate if X lies within espx distance and ditto y
* The array "dup" will contain the number of duplicate "mates" for any
*   given coordinate (i.e. 0 if no matches)
* The array "seq" will contain the sequence number 0,1,2,... of the mates 

* V530 *sh* 2/01

        IMPLICIT NONE

* Argument declarations
	INTEGER	n
	REAL	epsx, epsy, x(n), y(n), dup(n), seq(n)

* Internal variable declarations
        INTEGER ii, jj, ndup
        REAL xtarget, ytarget

* initialize
        DO ii = 1, n
          dup(ii) = 0
          seq(ii) = 0
        END DO

* find and label duplicates
        DO ii = 1, n
           
* locate a unique coordinate
           IF (dup(ii) .EQ. 0 ) THEN
             xtarget = x(ii)
             ytarget = y(ii)

* mark sequence numbers for duplicates of this target
             ndup = 0
             DO jj = ii+1, n
               IF (dup(jj) .EQ. 0 ) THEN
                  IF ( (ABS(xtarget-x(jj)) .LE. epsx)
     .           .AND. (ABS(ytarget-y(jj)) .LE. epsy) ) THEN
                    ndup = ndup + 1
                    seq(jj) = ndup
                  ENDIF
               ENDIF
             END DO

* mark number of duplicates found on each member of duplicate group
             dup(ii) = ndup
             IF (ndup .GT. 0) THEN
               DO jj = ii+1, n
                 IF ( (dup(jj).EQ.0)
     .          .AND. (seq(jj).GT.0) ) dup(jj) = ndup 
               END DO
             ENDIF

           ENDIF
        END DO

	RETURN
	END

	SUBROUTINE CD_DIM_STATUS (cdfid, name, nlen, dim_status)


* dim_status = 0 if dimension does not yet written
*            = 1 if dimension exists but there is not a coordinate variable
*            = 2 if dimension and coordinate variable are already in the file

* include files

	include 'netcdf.inc'

	INTEGER cdfid, nlen, dim_status
	CHARACTER*(*) name

	INTEGER cdfstat, dimid, axid

	dim_status = 0

	cdfstat = NF_INQ_DIMID( cdfid, name(:nlen), dimid)

* already defined ? (limited consistency checking)
	IF ( cdfstat .EQ. NF_NOERR ) THEN

* ... is there a coordinate variable by the same name ?
	   cdfstat = NF_INQ_VARID( cdfid, name(:nlen), axid )

	   IF ( cdfstat .EQ. NF_NOERR ) THEN
	      dim_status = 1 
	   ELSE

* The dimension matches but there is no coord var. 
* This lets us append variables to a DSG file.

	      IF (cdfstat .EQ. nf_enotvar) dim_status = 1
	   ENDIF

* other cases, dim_status remains 0.  What else could there be? ...

	ENDIF

	RETURN
	END

	SUBROUTINE TSTEP_TO_DATE ( grid, idim, tstep, precision, date )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Return a string giving the date for a particular timestep
* This is done by figuring the offset from
* 01-JAN-0000 00:00:00 in seconds, and then calculating the date.
*
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* rev. 0.0 3/17/88 - based on TM_STEP_TO_DATE by *mv*
* rev. 0.1 - 2/16/89 - TM_SECS_TO_DATE --> SECS_TO_DATE
* V300 4/93 - crash if precision exceeds 6
* V530: *acm* 12/00 add calendar types; cal_id
* V600 - SECS_TO_DATE --> SECS_TO_DATE_OUT for better formatting
* V610: *acm*  2/08 Fix bug 762: if the axis is not modulo, always list the
*                   year (previously never listed year 0 or year 1)
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
*       *acm* 3/12 6D Ferret: Add E and F dimensions 
*                  A time axis may be a T axis or F axis.
* V698  *acm* 5/16 Ticket 2405: MODE CALENDAR:auto
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.

* Arguments:
*	grid	 - grid containing a time axis
*	tstep    - time step
*	precision- precision (1 to 6 for day,mon,yr,hr,min,sec, respectively )
*			(use ABS(precision) - neg. indicates truncate left 0's)
*	date	 - returned string containing date in ASCII form
*

	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'ferret.parm'
	include 'xtext_info.cmn'
        include 'xunits.cmn_text'
        external xunits_data

* calling argument declarations
	CHARACTER*(*)	date
	INTEGER		grid, idim, precision
	REAL*8		tstep
*
* Local definitions
        LOGICAL         ITSA_TRUEMONTH_AXIS, modulo
	CHARACTER*20	SECS_TO_DATE_OUT, buff, dms
	INTEGER		TM_GET_CALENDAR_ID, DATE_PREC, axis, status, prec, 
     .                  cal_id
	REAL*8		start_secs, offset_secs, this_secs, delta
	REAL*8		SECS_FROM_BC

!	REAL*8		start_secs, offset_secs, this_secs, prec_fact(6)
!	DATA	prec_fact	/  31536000.,  2628000.,  86400.,  3600.,
!     .				   60., 1./

* initialize
	prec = ABS(precision)

* get the axis number
#ifdef double_p
	axis = grid_line( idim, grid )
	IF ( axis .EQ. mnormal .OR. axis .EQ. munknown ) THEN
	   WRITE ( date, * ) (tstep)
	   RETURN
	ELSEIF ( (line_direction(axis).NE.'TI') .AND.
     .           (line_direction(axis).NE.'FI')  ) THEN
	   WRITE ( date, * ) (tstep)
	   RETURN
	ENDIF
#else	
	axis = grid_line( idim, grid )
	IF ( axis .EQ. mnormal .OR. axis .EQ. munknown ) THEN
	   WRITE ( date, * ) SNGL(tstep)
	   RETURN
	ELSEIF ( (line_direction(axis).NE.'TI') .AND.
     .           (line_direction(axis).NE.'FI')  ) THEN
	   WRITE ( date, * ) SNGL(tstep)
	   RETURN
	ENDIF
#endif


* get the calendar type

        cal_id = TM_GET_CALENDAR_ID ( line_cal_name(axis) )

* First find the offset from 01-JAN-0000 00:00:00 from the descriptor file
	start_secs = SECS_FROM_BC( line_t0(axis), cal_id, status )

* Find the number of seconds since start of data set for this time step
	offset_secs = tstep*line_tunit( axis )

* True-month axis? A true-month step has been converted from month to days
	IF (ITSA_TRUEMONTH_AXIS(axis)) offset_secs = tstep* un_convert(pun_day)  

* Total seconds to this time step since 01-JAN-0000 00:00:00
	this_secs = start_secs + offset_secs

* round off date instead of truncating 
* ( people don't normally view dates this way )
!	this_secs = ( DNINT(this_secs/prec_fact(prec)) + 0.5 ) * prec_fact(prec)

*** Do all this higher up for plots, as is done for listings, where date_prec is
*** called in row_coord_fmt.

* Will write only month-day in labels for monthly climatology
        modulo = line_modulo(axis)

* Convert to date
	date = SECS_TO_DATE_OUT(this_secs, cal_id, modulo, prec)


* Finished
	RETURN
	END

	SUBROUTINE PUT_LABEL(	labnum,
     .				xpos, ypos,
     .				justify,
     .				labht,
     .				string,
     .				xaxrel, yaxrel )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* define a single label to PPLUS after checking to see if it needs to be shrunk
* save its definition in a PPLUS symbol for customizing by user
* possibly place the label on the plot relative to axis lengths

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 7/14/87
* revision 0.1 - 9/23/87 - removed @AS - implied via DFLTFNT command
* revision 0.2 - 3/23/88 - replaced @AS using SET MODE FONT_ASCII
* revision 0.3 - 4/7/88  - added PPLUS symbol definition
* revision 0.4 - 9/8/88  - added *axrel - relative to axis length calc.
* revision 0.5 - 9/21/88 - no action if no_labels
* V200:   1/3/89 - label numbers maintained internally
*		 - no automatic shrinking of text string (maxlen removed)
*		 - plot5_cmnd --> ppl_buff
*		 - AS and AC fonts put into label but not into symbol
* Unix/RISC port - 2/91 - cannot "//" with CHAR*(*) variables
*                       - cannot use char functions in write stmts
* V320: 8/18/94	- *kob* IBM port - need to use intrinsic function REAL instead
*			           of SNGL for ibm
* V400: 6/22/95 - *sh* define movable label numbers as symbols when requested
*		  (requested by subtracting axis number from ppl_movlab)
* V420: 2/1/96  - *sh* If "string" is blank output "<ESC>@AC" to wipe out
*		   previous label
* V510: *sh8 3/00 - add DODS URL label
* V533: *sh8 7/01 - if label contains single tic marks double them so PLOT+
*		    doesn't try to interpret symbols
* 2/03 *kob* - g77 port - g77 won't allow intrinsic functions in PARAMETER
*                         statements.  use an octal constant instead 
* 7/10 *acm* - ticket 1747: LABNUM_CALEN for automatically generated CALENDAR
*              label, points to the PPL LAB# number.
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
*      *kms* 5/12 Always use generic REAL instead of specific SNGL 
*                 (SNGL must have a double-precision or complex argument)
* V68  *acm* 5/12  Dont write the font to xlab, ylab if they are blank strings.
* V686 *acm* 12 13 set up the label symbols LABNUM_E and LABNUM_F

	include 'tmap_dims.parm'
	include 'plot_setup.parm'
	include 'xprog_state.cmn'
	include 'xplot_setup.cmn'
	include 'xtext_info.cmn'
	include 'axis_inc.decl'	! axis lengths
	include 'AXIS.INC'		! axis lengths
	include 'xrisc.cmn'		! to fix RISC FORTRAN bug

* PLOT+ parameter fom PPLV11INC:PARAMPL5.DAT
	INTEGER		nlabs
	PARAMETER     ( nlabs=50 )

* calling argument declarations:
	INTEGER		labnum, justify, xaxrel, yaxrel
	REAL		xpos, ypos, labht
	CHARACTER*(*)	string

* internal variable declarations:
	INTEGER		flen, lsym, ii
	CHARACTER	TM_FMT*4, font*3, buf4*4,
     .			labname(ppl_dset:ppl_calendar)*6
	REAL 		xp, yp

* local parameter declarations:
	INTEGER		maxsym, len_in, i
	CHARACTER*1	esc
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( esc = o'033' ,
#else
	PARAMETER     ( esc = CHAR(27),
#endif
     .			maxsym = 102   )! max. symbol length for PPLUS (PPL bug)

* data initialization
	DATA labname(ppl_dset)/'DSET'/,
     .	     labname(ppl_aspect)/'ASPECT'/,
     .	     labname(ppl_year)/'YEAR'/,
     .	     labname(ppl_datitl)/'DATITL'/,
     .	     labname(ppl_offset)/'OFFSET'/,
     .	     labname(ppl_dodsurl)/'DODS'/,
     .	     labname(ppl_calendar)/'CALEND'/


* if label has single tic marks double them so PLOT+ doesnt interpret symbols
	IF ( INDEX(string,"'date'") .GT. 0 ) THEN
* ... hack to let PLOT+ date time symbols be evaluated (using single tics)
	  risc_buff = string
	  len_in = MIN( size_rbuff, LEN(string) )
	ELSE
	  risc_buff = ' '
	  len_in = MIN( size_rbuff-1, LEN(string) )
	  len_rbuff = 0
	  DO i = 1, len_in
	    len_rbuff = len_rbuff+1
	    risc_buff(len_rbuff:len_rbuff) = string(i:i)
	    IF (string(i:i) .EQ. "'") THEN
	      len_rbuff = len_rbuff+1
	      risc_buff(len_rbuff:len_rbuff) = "'" ! 2 tics together
	    ENDIF
	  ENDDO
	ENDIF

* adjust positions relative to axis lengths if requested
	xp = xpos
	yp = ypos
	IF ( xaxrel .EQ. lab_loc_axlen_plus ) THEN
	   xp = xp + xlen
	ELSEIF ( xaxrel .EQ. lab_loc_axlen_times ) THEN
	   xp = xp * xlen
	ENDIF
	IF ( yaxrel .EQ. lab_loc_axlen_plus ) THEN
	   yp = yp + ylen
	ELSEIF ( yaxrel .EQ. lab_loc_axlen_times ) THEN
	   yp = yp * ylen
	ENDIF

* PPLUST symbols strings cannot exceed maxsym
	lsym = MIN( maxsym, len_rbuff )

* select PLOT+ font
	IF ( string .EQ. ' ' ) THEN
	   font = esc // '@AC '
	ELSEIF ( .NOT.mode_font_ascii ) THEN
	   font = ' '
	ELSEIF ( labnum .EQ. ppl_title ) THEN
	   font = '@AC'
	ELSE
	   font = '@AS'
	ENDIF

* Let user select the font if they want

        IF (string(1:1) .EQ. "@") THEN
           font = ' '
        ENDIF

* define the label to PPLUS
	IF     ( labnum .EQ. ppl_title ) THEN
* ... TITLE
	   WRITE ( ppl_buff, 3200) labht, font//risc_buff(:len_rbuff)
	   CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
	   WRITE ( ppl_buff, 3500 ) 'TIT', risc_buff(:lsym)
	   CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
	ELSEIF ( labnum .EQ. ppl_xlab ) THEN
* ... XLAB
	   IF (risc_buff(:len_rbuff) .NE. ' ') 
     .			CALL PPLCMD( from, line, 0,
     .			'XLAB '//font//risc_buff(:len_rbuff), 1, 1 )
	   WRITE ( ppl_buff, 3300 ) labht
	   CALL PPLCMD( from, line, 0, ppl_buff, 1, 1 )
	   WRITE ( ppl_buff, 3500 ) 'X', risc_buff(:lsym)
	   CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
	ELSEIF ( labnum .EQ. ppl_ylab ) THEN
* ... YLAB
	   IF (risc_buff(:len_rbuff) .NE. ' ') 
     .			CALL PPLCMD( from, line, 0,
     .			'YLAB '//font//risc_buff(:len_rbuff), 1, 1 )
	   WRITE ( ppl_buff, 3400 ) labht
	   CALL PPLCMD( from, line, 0, ppl_buff, 1, 1 )
	   WRITE ( ppl_buff, 3500 ) 'Y', risc_buff(:lsym)
	   CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
	ELSE
* ... LABS (PLOT+ movable labels)
	   nlabs_on = nlabs_on + 1
* ... check for PLOT+ limit (no error chack there)
	   IF ( nlabs_on .GT. nlabs ) CALL WARN( 'PLOT+ label limit exceeded' )
	   WRITE ( ppl_buff, 3000 ) nlabs_on,xp,yp,justify,
     .				    font//risc_buff(:len_rbuff)
	   CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
	   WRITE ( ppl_buff, 3100 ) nlabs_on, labht
	   CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
#ifdef double_p
           buf4 = TM_FMT(DBLE(nlabs_on),3,3,flen)      ! for Unix/RISC
#else
           buf4 = TM_FMT(REAL(nlabs_on),3,3,flen)      ! for Unix/RISC
#endif
	   WRITE ( ppl_buff, 3500 ) buf4(:flen),  risc_buff(:lsym)
	   CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
* ... define a PLOT+ symbol containing the label number "SET LABNUM_X 4"
*	or LABNUM_DSET, LABNUM_YEAR, etc.
	   ii = ppl_movlab - labnum
	   IF ( ii.GE.1 .AND. ii.LE.nferdims ) THEN
	      WRITE ( ppl_buff, 3500 )
     .			"num_"//ww_dim_name(ii), buf4(:flen)
	      CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
	   ELSEIF ( ii.GE.ppl_dset  .AND. ii.LE.ppl_calendar ) THEN
	      WRITE ( ppl_buff, 3500 )
     .			"num_"//labname(ii), buf4(:flen)
	      CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
	   ENDIF
	ENDIF

* successful completion every time
	RETURN
 3000	FORMAT('LABS/NOUSER ',I3,1X,2(F6.2,1X),I3,1X,A)
 3100	FORMAT('HLABS ',I3,1X,F6.3 )
 3200	FORMAT('TITLE ',F6.3,1X,A)
 3300   FORMAT('LABSET,,', F6.3 )	! "LABSET,,x.x"
 3400   FORMAT('LABSET,,,', F6.3 )	! "LABSET,,,x.x"
 3500   FORMAT('SET LAB',A,1X, A)	! "SET LABxxx string"
	END

*
* ffta_sample.F
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* Dec 1998
*
*
* This function computes fft amplitude spectrum for each time series.  Result
* time axis is a custom axis in period 1./time  The input variable must have
* the time axis specified explicitly in the function call e.g. 
*    LET ssffta_sample = ffta_sample(ssttim[l=1:492])
* and the time axis must be regular.

*  Note current limitations as of 1-Jan-2000
*   - Will have a utility to get the length of the input time axis at the
*     point when the custom freq axis is set up, to use in computing the
*     length of the frequency axis.  Currently need to specify explicitly, 
*     in the function call e.g. ffta_sample(sst[l=1:400]).

*  NOTE:
*  IT IS GENERALLY ADVISABLE TO INCLUDE EXPLICIT LIMITS WHEN WORKING WITH
*  FUNCTIONS THAT REPLACE AXES. FOR EXAMPLE, THE CONSIDER THE FUNCTION
*  SORTL(v). THE EXPRESSION
*       LIST/L=6:10 SORTL(v)
*  IS NOT EQUIVALENT TO
*       LIST SORTL(v[L=6:10])
*  THE FORMER WILL LIST THE 6TH THROUGH 10TH SORTED INDICES FROM THE ENTIRE
*  L RANGE OF VARIABLE V. THE LATTER WILL LIST ALL OF THE INDICES THAT
*  RESULT FROM SORTING v[L=6:10].
*  
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE ffta_sample_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

      CHARACTER*110 arg_desc, fcn_desc

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      WRITE (fcn_desc, 20)
      CALL ef_set_desc(id, fcn_desc)
   20 FORMAT ( 'Computes fft amplitude spectra, ',
     .          'normalized by 1/N' )

      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, CUSTOM)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      CALL ef_set_num_work_arrays(id, 4)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      WRITE (arg_desc, 10) 
   10 FORMAT ('Variable with regular time axis. Specify time ', 
     .         'explicitly e.g. ffta_sample(var[l=1,120])')

      CALL ef_set_arg_desc(id, arg, arg_desc)

      CALL ef_set_axis_influence(id, arg, YES, YES, YES, NO)


*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END


      SUBROUTINE ffta_sample_custom_axes(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                      
*
*     Use utility functions to get grid information about the 
*     argument; use this info to determine the custom axis lo/hi/del 

      INTEGER nfreq_lo_l, nfreq_hi_l

      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

      INTEGER arg
      INTEGER nfreq, nd

      REAL yquist, freq1, freqn
      
      CHARACTER outunits*32
      REAL boxsize(1)
         
      CHARACTER ax_name(4)*16, ax_units(4)*16
      LOGICAL backward(4), modulo(4), regular(4)
      
      arg = 1
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      CALL ef_get_axis_info(id, arg, ax_name, ax_units, backward,
     .     modulo, regular)

      CALL ef_get_box_size(id, arg, T_AXIS, arg_lo_ss(T_AXIS,arg), 
     .               arg_lo_ss(T_AXIS,arg), boxsize)

      IF ( arg_hi_ss(T_AXIS,arg) - arg_lo_ss(T_AXIS,arg) .EQ. 0 ) THEN
         nfreq_lo_l = 1
         nfreq_hi_l = 2
      ELSE
         nfreq_lo_l = arg_lo_ss(T_AXIS,arg)
         nfreq_hi_l = arg_hi_ss(T_AXIS,arg)
      ENDIF

      nd = abs(nfreq_hi_l - nfreq_lo_l) + 1

C  The FFT code returns frequencies W(k) for k=1 to N/2, with N/2 rounded down

      nfreq = nd/2	

      yquist = 1./(2.*boxsize(1))		! Nyquist frequency

      freq1 = 1.* yquist/ float(nfreq)
      freqn = 1.001*yquist

C  Set label for the frequency axis CYC/units.

      outunits = 'CYC/' // ax_units(T_AXIS)

      CALL ef_set_custom_axis (id, T_AXIS, freq1, freqn, freq1, 
     .   outunits, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE ffta_sample_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER ntime, nfreq

      INTEGER arg
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


*     Use utility functions to get context information about the argument.

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nfreq = 1

      arg = 1
      ntime = arg_hi_ss(T_AXIS,arg) - arg_lo_ss(T_AXIS,arg) + 1

C  The FFT code returns frequencies W(k) for k=1 to N/2, with N/2 rounded down

      nfreq = ntime/ 2
      if (ntime .ne. nfreq*2) nfreq = (ntime+1)/2 ! see FFTPACK comments in rfftf

      CALL ef_set_axis_limits(id, T_AXIS, 1, nfreq)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE ffta_sample_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
* 
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_dims(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER mtdat, mtwork
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      mtdat = 1 + arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1)

      mtwork = 2.5* mtdat + 15
  
* a
      CALL ef_set_work_array_dims (id, 1, 1, 1, 1, 1, mtdat, 1, 1, 1)

* b
      CALL ef_set_work_array_dims (id, 2, 1, 1, 1, 1, mtdat, 1, 1, 1)

* wft
      CALL ef_set_work_array_dims (id, 3, 1, 1, 1, 1, mtwork, 1, 1, 1)

* ts
      CALL ef_set_work_array_dims (id, 4, 1, 1, 1, 1, mtdat, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE ffta_sample_compute(id, arg_1, result, a, b, wft, ts)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id, arg

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      CHARACTER ax_name(4)*16, ax_units(4)*16
      LOGICAL backward(4), modulo(4), regular(4)

*  Dimension work arrays

      REAL a(wrk1lox:wrk1hix, wrk1loy:wrk1hiy,
     .               wrk1loz:wrk1hiz, wrk1lot:wrk1hit)
      REAL b(wrk2lox:wrk2hix, wrk2loy:wrk2hiy,
     .               wrk2loz:wrk2hiz, wrk2lot:wrk2hit)
      REAL wft(wrk3lox:wrk3hix, wrk3loy:wrk3hiy,
     .               wrk3loz:wrk3hiz, wrk3lot:wrk3hit)
      REAL ts(wrk4lox:wrk4hix, wrk4loy:wrk4hiy,
     .               wrk4loz:wrk4hiz, wrk4lot:wrk4hit)

      REAL aa, bb
      INTEGER nd, nf
      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1

      CHARACTER*80 err_msg

   40 FORMAT ('FFTA encountered missing data at (i,j,k,l)', 4I5)

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*  number of time points.

      arg = 1
      nd = (arg_hi_ss(T_AXIS,arg) - arg_lo_ss(T_AXIS,arg) + 1)
      nf = nd/ 2

*  Check that the time axis is regular.

      CALL ef_get_axis_info (id, 1, ax_name, ax_units, backward,
     .     modulo, regular)

      IF (.NOT. regular(T_AXIS)) THEN
            WRITE (err_msg, *) 'Time axis must be a regular axis'
            GO TO 999
      ENDIF

*  Set WFT for fft; prime factorization of ND and trig functions.

      CALL rffti (nd, wft)

      i1 = arg_lo_ss(X_AXIS,ARG1)
      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

*
* Calculate the FFT for each time series which have no missing data.

               l1 =arg_lo_ss(T_AXIS,ARG1)
               DO 100 l = 1, nd
                  IF (arg_1(i1,j1,k1,l1) .EQ. bad_flag(ARG1)) THEN
                     WRITE (err_msg, 40) i1,j1,k1,l
                     GO TO 999 
                  ENDIF

                  ts(l,1,1,1) = arg_1(i1,j1,k1,l1)
                  l1 = l1 + arg_incr(T_AXIS,ARG1)
 100           CONTINUE


               l1 = arg_lo_ss(T_AXIS,ARG1)
               l = res_lo_ss(T_AXIS)

               CALL four_re (nd, ts, a, b, wft)

               DO 110 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS) 
                   aa = a(l,1,1,1)
                   bb = b(l,1,1,1)
                   result(i,j,k,l) = SQRT(aa*aa + bb*bb)
 110           CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 300     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
 400  CONTINUE

      RETURN

 999  CALL ef_bail_out (id, err_msg)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END
      

	SUBROUTINE FULL_SCAN_INDICES (src, ksmin, ksmax,
     .				 ks_start, ks_end,
     .				 bad_src, targ,
     .				 indices, coefs, kdmin, kdmax,
     .				 ascnd, has_valid )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Routine to determine nearest neighbor index (lower index)
*	on GRID1 for points on GRID2.

*       Code is a delta on HUNT_INDICES.  That routine assumes src array
*       is sorted, so it can use a binary search.  This routine uses a
*       full scan to find nearest indices, and then continues the scan to make
*       sure the result is not multiple-valued (a result of non-monotonic src)

*       Note that the TARG array is always ascending

* variable naming:
*	's' refers to the source array -- the incoming list of values
*	'd' refers to the destination arrays -- the outgoing indices and coefs
*	min/max refer to the dimensioned limits of arrays
*	_ok refers to to limits within which the arrays contain valid values


* V698 *sh* 5/15 derived from Ferret source routine HUNT_INDICES

        IMPLICIT NONE
	include 'ferret.parm'

* calling argument declarations
	LOGICAL	ascnd, has_valid
	INTEGER	ksmin, ksmax, ks_start, ks_end, kdmin, kdmax,
     .		indices(kdmin:kdmax)
	REAL	src(ksmin:ksmax),
     .			targ(kdmin:kdmax), coefs(kdmin:kdmax),
     .			bad_src

* internal variable declarations
	INTEGER	ks, kd, slo, shi, sincr, nfound, ksfound, ksprev
	REAL	vt, v0, v1

********************************************
* initialize
	has_valid = .FALSE.
	ksfound = ks_start    ! any valid index may go with coef=bad_val4

* initialize loop direction
	IF (ascnd) THEN
	  sincr = 1
	  slo   = ks_start
	  shi   = ks_end
	ELSE
	  sincr = -1
	  slo   = ks_end
	  shi   = ks_start
	ENDIF

* outer loop - target axis points
	DO kd = kdmin, kdmax

* inner loop - a column of non-monotonic (semi-ordered) auxiliary coordinates
	   vt = targ(kd)
	   nfound = 0
	   v0 = src(slo)
	   DO ks = slo, shi, sincr

	      IF (ks .NE. slo) v0 = v1   ! preceding test point
	      v1 = src(ks)               ! new test point

* does our target exactly match this src value?
	      IF (vt .EQ. v1) THEN
	         ksfound = ks
	         nfound = nfound + 1
	         CYCLE
	      ENDIF

* does our target value lie between two valid src values? 
	      IF (v0 .NE. bad_src
     .      .AND. v1 .NE. bad_src ) THEN
* ... target lies between if sign of diff product is non-negative  
	         IF ( ((vt-v0)*(v1-vt)) .GT. 0.0) THEN
	            ksfound = ks
	            nfound = nfound + 1
	         ENDIF
	      ENDIF
	   ENDDO

* save result
	   indices(kd) = ksfound
	   coefs(kd) = bad_val4

	   IF (nfound .EQ. 1) THEN
	      ksprev = ksfound-sincr
	      IF (vt .EQ. src(ksfound) ) THEN
!	         indices(kd) = ksfound
	         coefs(kd) = 1.0
	         has_valid = .TRUE.
	      ELSEIF (src(ksfound) .GT. src(ksprev) ) THEN ! only ordered ok
	         indices(kd) = ksprev
	         coefs(kd) = (src(ksfound)-vt) / (src(ksfound)-src(ksprev))
	         has_valid = .TRUE.
	      ENDIF
	   ENDIF
	
	ENDDO     ! end outer loop      

	RETURN
	END

	RECURSIVE SUBROUTINE CANCEL_DATA_SET( dset, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* close a dataset
* remove from memory any cached data that may depend upon this dataset
* if the dataset is a part of an E or F aggregations refuse to close
* unless all datasets are being closed (slash/all)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V695 *sh* 1/16 - bulk of logic moved to CANCEL_ONE_DATA_SET 
* V698  3/16 *acm* Remove unneeded xdset_parms.cmn
* V7   *acm*  6/12 Add Union aggregations: DEFINE DATA/AGG/U, ds_type 'UNI'

* calling arguments
*  dset      -  (input) dataset number to be closed
*  status    - (output) return status

        IMPLICIT NONE
	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'tmap_errors.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xrisc.cmn'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data

* calling argument declarations:
	INTEGER	dset, status

* local variable declarations:
	LOGICAL	IS_AGG_MEMBER, is_member, more
	INTEGER	one_set_status, parent, imemb, nmemb, membset
 
* initialize
	status = ferr_ok
	IF (ds_name(dset) .EQ. char_init2048) RETURN  ! already deleted
	more = .TRUE.

* is the requested dataset part of an aggregation?
* If so, this is an implicit request to (recursively) cancel the parent, too
* Remember that E aggs can be members of F aggs and visa versa
	DO WHILE (more)
	   IF ( IS_AGG_MEMBER(dset, 1, parent, more) ) THEN
	      CALL WARN('Dataset used in aggregation.  '//
     .		        'Canceling aggregation, '//ds_name(parent))
	      CALL CANCEL_DATA_SET(parent, status)
	      IF (status .NE. ferr_ok) GOTO 5000
	   ENDIF
	ENDDO

* delete all user defined data from memory for similar reasons
* (note: this is unnecessarily strict - could be refined in the future)
	CALL PURGE_ALL_UVARS

* if this dataset is an aggregation, cancel hidden member datasets, too
* unless they are also members in some other aggregation
	IF (ds_type(dset).EQ.'ENS' .OR. ds_type(dset).EQ.'FCT' 
     .      .OR. ds_type(dset).EQ.'UNI') THEN

* ... loop over aggregation members
	   CALL CD_GET_AGG_DSET_INFO (dset, nmemb, status)
	   IF (status .NE. ferr_ok) CALL WARN('crptn: isit_agg_member')
	   DO imemb = 1, nmemb
	      CALL CD_GET_AGG_DSET_MEMBER (dset, imemb, membset, status)
	      IF (status .NE. ferr_ok)  CALL WARN('crptn: cancel_data_set')
	      IF (ds_name(membset) .EQ. char_init2048) CYCLE ! already deleted?

* ... if not a member of some other aggregation: cancel the hidden member
	      is_member = IS_AGG_MEMBER(membset, 1, parent, more)
	      IF ( is_member .AND. .NOT.more ) THEN
	         IF (ds_hide(membset)) CALL CANCEL_ONE_DATA_SET
     .							(membset, status)
	         IF (status .NE. ferr_ok) GOTO 5000
	      ENDIF
	   ENDDO
	ENDIF

* finally cancel the requested dataset
	CALL CANCEL_ONE_DATA_SET(dset, status)
	IF (status .NE. ferr_ok) GOTO 5000

* success
        RETURN

* error exits
 5000	RETURN
	END

        SUBROUTINE SET_NUM_LINECOLORS 
        
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*  5/2006 ACM
*  v6.00 Sets the number of line colors that will be allowed.
* V602: *acm* 1/07 Changes for metafile-batch mode

	INCLUDE 'cmrd_inc.decl'
        INCLUDE 'CMRD.INC'
        INCLUDE 'parampl5_dat.decl'
        INCLUDE 'PARAMPL5.DAT'
        INCLUDE 'plt_inc.decl'
        INCLUDE 'PLT.INC'
        INCLUDE 'pen_inc.decl'
        INCLUDE 'PEN.INC'
        INCLUDE 'gkscm1_inc.decl'            
        INCLUDE 'GKSCM1.INC'     
        INCLUDE 'gkscm2.cmn'                   

******************************************************************************

        INTEGER no_plots_yet

*	If no args, reset to default number of 6 colors
	IF (m .EQ. 0) THEN
           num_line_colors = 6

*	Else set to value in P(1) 
        ELSE IF (p(1) .GE. 6) THEN
           num_line_colors = p(1)
        ELSE 
           num_line_colors = 6
        ENDIF

        no_plots_yet = 0
        no_plots_yet = p(2)

* For metafiles, setup line bundles here so we can 
* save the color definitions.

        IF (gks_open .AND. .NOT.meta_clsplt .AND. no_plots_yet.EQ.1) 
     .      CALL SETUP_LINE_BUNDLES (wsid, wstype)

        RETURN
	END

	SUBROUTINE  VEL_ADV_EW ( fuw , mfuw,
     .				 u   , mu  ,
     .				 uadx, muadx )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute zonal advection of velocity components
* note: the identical code applies to both U and V

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 -1/23/87 extracted from SUBROUTINE CLINIC
*			with major modifications to convert i-k oriented
*			calculations to i-j oriented calculations
* revision 0.1 - 4/14/87 - converted incorrect flux-form calculation to
*			   true advection
* V200:  7/27/89 - 4D symmetrical version
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN

#ifdef unix
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl.parm'		! parameter definitions
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xonedim.cmn'	! geometric constants
	include 'xcontext.cmn'
#else
	INCLUDE 'FERRET_CMN:FERRET.PARM'
	INCLUDE 'FERRET_CMN:GFDL.PARM'		! parameter definitions
	INCLUDE	'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE	'FERRET_CMN:XMEM_SUBSC.CMN'
	INCLUDE 'FERRET_CMN:XONEDIM.CMN'	! geometric constants
	INCLUDE 'FERRET_CMN:XCONTEXT.CMN'
#endif

* calling argument declarations:
	INTEGER	mfuw, mu, muadx

* subscript ranges from memory variable table ...
	REAL     fuw( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit ),
     .		   u( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,m2lot:m2hit ),
     .		uadx( m3lox:m3hix,m3loy:m3hiy,m3loz:m3hiz,m3lot:m3hit )

* internal variable declarations:
	INTEGER	i_lo, i_hi, j_lo, j_hi, i, j, k, l
	REAL	bad_u, bad_fuw, dqudx, qdudx

* --- end of introductory code ---

* limits for calculation
	i_lo = mr_lo_s1(muadx)
	i_hi = mr_hi_s1(muadx)
	j_lo = mr_lo_s2(muadx)
	j_hi = mr_hi_s2(muadx)

* flag for bad/missing data
	bad_u   = mr_bad_data( mu )
	bad_fuw = mr_bad_data( mfuw )

* ***************************************************************
* ORIGINAL GFDL 205 CODE UPON WHICH CALCULATION IS BASED
*
* 282 C   COMPUTE EFFECT OF HORIZONTAL ADVECTION IN MOMENTUM EQUATIONS
* 283 C
* 284       DO 300 K=1,KM
* 285       DO 300 I=1,IMT
* 286       TEMP2D(I,K)=FUW(I+1,K)*(U(I+1,K)+U(I,K))
* 287  300  CONTINUE
* 288       DO 303 K=1,KM
* 289       DO 303 I=1,IMT
* 290       UA(I,K)=(TEMP2D(I-1,K)-TEMP2D(I,K))*DXU2R2D(I,K)
* 291  303  CONTINUE

* 297       DO 310 K=1,KM
* 298       DO 310 I=1,IMT
* 299       TEMP2D(I,K)=FUW(I+1,K)*(V(I+1,K)+V(I,K))
* 300  310  CONTINUE
* 301       DO 313 K=1,KM
* 302       DO 313 I=1,IMT
* 303       VA(I,K)=(TEMP2D(I-1,K)-TEMP2D(I,K))*DXU2R2D(I,K)
* 304  313  CONTINUE
*************************************************************************
	DO 2000 l = mr_lo_s4(muadx), mr_hi_s4(muadx)
	DO 2000 k = mr_lo_s3(muadx), mr_hi_s3(muadx)

	DO 300 j = j_lo, j_hi

* to save half of the additions ...
*	   IF ( i .NE. 1 ) tempim1 = fuw(i,j,k,l) * (u(i,j,k,l)+u(i-1,j,k,l))

	DO 300 i = i_lo, i_hi

	   IF ( i .EQ. 1 .OR. i .EQ. im ) THEN
	      uadx(i,j,k,l) = bad_val4
	      GOTO 300
	   ENDIF

	   IF ( u(i-1,j,k,l) .EQ. bad_u
     .	    .OR.u(i  ,j,k,l) .EQ. bad_u
     .	    .OR.u(i+1,j,k,l) .EQ. bad_u
     .	    .OR.fuw(i  ,j,k,l) .EQ. bad_fuw
     .	    .OR.fuw(i+1,j,k,l) .EQ. bad_fuw ) THEN
  
	      uadx(i,j,k,l) = bad_val4

	   ELSE

! temp - future performance:  tempi = fuw(i+1,j,k,l) * (u(i+1,j,k,l)+u(i,j,k,l))

* flux-form calculation: compute +d/dx(QU) ( where "Q" may be "U" or "V" )
	      dqudx = ( fuw(i+1,j,k,l) * (u(i+1,j,k,l)+u(i,j,k,l)) 
     .		    -   fuw(i  ,j,k,l) * (u(i,j,k,l)+u(i-1,j,k,l)) ) * dxu2r(i)

* compute +Q*d/dx(U)
	      qdudx = u(i,j,k,l) * (fuw(i+1,j,k,l) - fuw(i,j,k,l)) * dxur(i)

* compute -U*d/dx(Q) = Q*d/dx(U) - d/dx(QU)
	      uadx(i,j,k,l) = ( qdudx - dqudx ) * cmonthly

	   ENDIF

 300	CONTINUE
 2000	CONTINUE
	RETURN
	END

	SUBROUTINE SET_VAR( vname, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* perform a SET VARIABLE on a variable from a data set of type EZ

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200: 10/23/89
* 	 3/26/90 - renamed from SET_EZ_VAR.  Allowed user-defined vars
* V230:  7/23/92 - trap attempts to set units on user variable
*       10/22/92 - added units on uvars  (increased units string to 24 chars)
*        11/9/92 - made units and title case-sensitive
* V402: 7/95 - use PARSE_NAM_DSET instead of PARSE_NAM_DSET_GRD so the
*		grid is never determined and the underlying uvar defn need
*		not be based on variables that are valid at this moment
* V420: 10/95 - can apply SET VARIABLE/BAD=/UNIT=/TITLE= to GT and CDF files
*Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
* V510 5/00 *sh* - allow SET VARIABLE/BAD applied to user variables
*		 - on file variables (e.g. netCDF) interchange the 2 missing
*		   flags so that the output will inherit the manually set value
* V533 6/01 *sh* - added SET VARIABLE/NAME
*		 - increased units char buffer to 64

* v533 9/01 *acm*- Check that SET VARIABLE/NAME doesnt give a name already in the dataset
*                - and that not using a variable from a GT or TS data set
* V552: 4/03 *acm* - add SET VARIABLE/SCALEFAC/OFFSET
* v552: 4/03 *acm*  Increase length of variable names to 128 characters
* v553: 7/03 *kob* - Add SET VARIABLE/bad=NaN ability
* V600:11/05 *acm* - issue error for SET VAR/SCALE/OFFSET if dset = -111 
* V600: 2/06 *acm* - For attribute-access additions, add new SET VAR/OUTTYPE=
* V600  4/06 *acm* - additional declarations found by Solaris compiler
* v600  4/06 *acm* - Change the call to set_nan from a float function to void, passing
*                    back the result as an argument. Needed for port to 64-bit 
* V601 10/06 *acm* - When units, title, or missing is set, change the corresponding
*                    value or string in the attribute linked-list structure.
* V608 11/07 *acm* - If doing SET VAR/UNITS, /TITLE, /BAD on a a user variable,
*                    and that attribute was not previously set, add it.
* V616  1/09 *acm* - Fix ticket 1615, If doing SET VAR/UNITS, /TITLE, /BAD on a
*                    var from an EZ dataset, set the appropriate attributes.
* V619  2/09 *acm* - Fix SET VAR/OUTTYPE= when the variable is a user var that
*                    yet has dset=n.
* V630  9/09 *acm* - Fix bug 1646: write the attribute Ferret_Precision_Note, when
*                    converting to Double from another data type, but only if the
*                    attribute isnt already there.
* V64  10/09 *acm* longer string length for grid_name
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V683 8/12  *acm* Move writing of notes about output precision to cdf_list.F
* V685 *acm*  3/13 For Ensemble aggregations, call the ds_type 'ENS'
* V690 *sh* 1/14   Added SET VARIABLE/SIGMA=varname
* V690 *acm*  3/14 Fix ticket 2152, error messages on illegal SET VAR/NAME
* V693+ 11/14 *sh* renaming 'sigma' as 'layerz' throughout
* V695 *acm*  2/15 For Forecast aggregations, call the ds_type 'FCT'
* V698 *sh*  4/16  allow SET VARIABLE on agg dsets
* V7   *acm* 5/16  Fix ticket 2432, see alsoticket 2352. For LET/D variables 
*                  look for info under that dataset
* V7   *acm*  6/12 Add Union aggregations: DEFINE DATA/AGG/U, ds_type 'UNI'
* V720 *acm* 5/17 Implement specific calls in place of CD_GET_VAR_INFO

	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'tmap_errors.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'slash.parm'
        include 'xcontext.cmn'
	include 'xprog_state.cmn'
	include 'xvariables.cmn'
	include 'xrisc.cmn'
        include 'netcdf.inc'

* calling argument declarations
	INTEGER		status
	CHARACTER	vname*(*)

* internal variable declarations:
	LOGICAL		VALID_GRID, TM_LEGAL_NAME, TM_HAS_STRING,
     .			ACTS_LIKE_FVAR,
     .                  have_mods, ez, gtts, ncfile
	INTEGER		GRID_FROM_NAME, TM_LENSTR1, STR_UPCASE, mod_cx,
     .			i, dset, grid, cat, var, loc, TMAP_status, 
     .			testvar, outtype_flag, varid, attid, attype, attlen, 
     .			attoutflag, vartype, cx, idum
	REAL		bad, scalefac, offset, val, dummy
	CHARACTER	grid_name*64, title*128, units*128, newname*128,
     .                  is_nan*3, flag*10, typflag*10, varattname*512,
     .                  varname*128, attname*128, buf*2, newname_lc*128,
     .			layerz_ref*128

* Initialize

	grid      = unspecified_int4
	bad       = real4_init
	scalefac  = real4_init
	offset    = real4_init
        have_mods = .FALSE.
        gtts      = .FALSE.
        ncfile    = .FALSE.
        ez        = .FALSE.
	newname   = char_init128
	title     = char_init128
	units     = char_init64
	grid_name = char_init16
	layerz_ref= char_init128

* note:  this routine manages 

* decode specified variable name of form VNAME[D=dset]
	dset = unspecified_int4			! default is global variable
	CALL PARSE_NAM_DSET( vname, cx_last, dset,
     .			     cat, var, mod_cx, status )
* ... RISC FORTRAN bug prevents "//" on char*(*) variable vname
	risc_buff = vname
	len_rbuff = LEN(vname)
	IF ( status .NE. ferr_ok ) RETURN
	IF ( var .EQ. munknown_var_name ) GOTO 5005

* May be an EZ or user-defined variable
!	IF ( cat .EQ. cat_file_var ) THEN    ! pre 4/16
	IF ( ACTS_LIKE_FVAR(cat) ) THEN
	   ez = ds_type(dset) .EQ. pds_type_ez
!	   IF ( .NOT. ez ) GOTO 5010		! removed restriction 10/95
	ELSEIF ( cat .EQ. cat_user_var ) THEN   ! uvars bad, too, until 10/92
           ez = .FALSE.
	ELSE
	   GOTO 5015
	ENDIF

* process qualifiers given

* SET VAR/NAME=

	loc = qual_given( slash_set_var_name )
	IF ( loc .GT. 0 ) THEN

* SET VAR/NAME does not work for GT, TS datasets where sanity check is done
* in gt_find_rec.F comparing var name to the name in the dataset.

	   IF (dset .GT. 0) THEN
	      gtts = ( (ds_type(dset) .EQ. pds_type_gt)  .OR. 
     .              (ds_type(dset) .EQ. pds_type_ts) )
	      IF ( gtts ) GOTO 5600
	   ENDIF

	   have_mods = .TRUE.
           CALL EQUAL_STR_LC 
     .             ( cmnd_buff(qual_start(loc):qual_end(loc)),
     .               newname_lc, status )
           IF ( status .NE. ferr_ok ) RETURN
	   status = STR_UPCASE (newname, newname_lc)

* check that the name isnt already in the data set.
           CALL FIND_VAR_NAME ( dset, newname, idum, testvar )
	   len_rbuff = TM_LENSTR1(newname_lc)
           IF (  testvar .NE. munknown_var_name ) GOTO 5400

	   IF ( .NOT.TM_LEGAL_NAME(newname) ) THEN
	      risc_buff = vname
	      len_rbuff = LEN(vname)
              GOTO 5200
           ENDIF
	ELSE
	   newname = char_init128
	ENDIF

* SET VAR/SCALEFAC only for NetCDF datasets

	loc = qual_given( slash_set_var_scale )
	IF ( loc .GT. 0 ) THEN

           IF (dset .EQ. unspecified_int4) GOTO 5700
	   ncfile = (TM_HAS_STRING(ds_type(dset), 'CDF') .OR.
     .               TM_HAS_STRING(ds_type(dset), 'MC') .OR.
     .               TM_HAS_STRING(ds_type(dset), 'ENS') .OR.
     .               TM_HAS_STRING(ds_type(dset), 'FCT') .OR.
     .               TM_HAS_STRING(ds_type(dset), 'UNI') .OR.
     .               TM_HAS_STRING(ds_type(dset), 'GT')  )
	   IF ( .NOT. ncfile ) GOTO 5700

	   have_mods = .TRUE.
	   CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			   scalefac, status )
           IF ( status .NE. ferr_ok ) RETURN
	ELSE
	   scalefac = real4_init
	ENDIF

* SET VAR/OFFSET only for NetCDF datasets

	loc = qual_given( slash_set_var_offset )
	IF ( loc .GT. 0 ) THEN

           IF (dset .EQ. unspecified_int4) GOTO 5700
	   ncfile = (TM_HAS_STRING(ds_type(dset), 'CDF') .OR.
     .               TM_HAS_STRING(ds_type(dset), 'MC') .OR.
     .               TM_HAS_STRING(ds_type(dset), 'ENS') .OR.
     .               TM_HAS_STRING(ds_type(dset), 'FCT') .OR.
     .               TM_HAS_STRING(ds_type(dset), 'UNI') .OR.
     .               TM_HAS_STRING(ds_type(dset), 'GT')  )
	   IF ( .NOT. ncfile ) GOTO 5800

	   have_mods = .TRUE.
	   CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			   offset, status )
           IF ( status .NE. ferr_ok ) RETURN
	ELSE
	   offset = real4_init
	ENDIF

* SET VAR/TITLE=

	loc = qual_given( slash_set_var_title )
	IF ( loc .GT. 0 ) THEN
	   have_mods = .TRUE.
           CALL EQUAL_STR_LC( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      title, status )
           IF ( status .NE. ferr_ok ) RETURN
	ELSE
	   title = char_init80
	ENDIF

* SET VAR/UNITS=

	loc = qual_given( slash_set_var_unit )
	IF ( loc .GT. 0 ) THEN
	   have_mods = .TRUE.
           CALL EQUAL_STR_LC( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      units, status )
           IF ( status .NE. ferr_ok ) RETURN
	ELSE
	   units = char_init16
	ENDIF

* SET VAR/GRID=

	loc = qual_given( slash_set_var_grid )
	IF ( loc .GT. 0 ) THEN
	   have_mods = .TRUE.
           CALL EQUAL_STRING( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      grid_name, status )
           IF ( status .NE. ferr_ok ) RETURN
	   grid = GRID_FROM_NAME( grid_name, cx_last, status )
           IF ( status .NE. ferr_ok ) RETURN
	   IF ( .NOT.VALID_GRID( grid ) ) GOTO 5500
	ELSE
	   grid = int4_init
	ENDIF

* SET VAR/BAD=

	loc = qual_given( slash_set_var_bad )
	IF ( loc .GT. 0 ) THEN
	   have_mods = .TRUE.
* *kob* 7/03 - Add check for bad=NaN
	   CALL EQUAL_STRING (cmnd_buff(qual_start(loc):qual_end(loc)),
     .                         is_nan, status)
           IF ( status .NE. ferr_ok ) RETURN     ! *sh* 1/14 added status check
	   IF (is_nan .EQ. ' ') GOTO 5550
	   IF (TM_HAS_STRING(is_nan, 'NaN')) THEN
              CALL SET_NAN(bad)
	   ELSE
	      CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			   bad, status )
	      IF ( status .NE. ferr_ok ) RETURN
	   ENDIF
	ELSE
	   bad = real4_init
	ENDIF

* SET VAR/LAYERZ=
* creates an attribute __layerz_ref_ that contains the desired auxiliary variable name
	loc = qual_given( slash_set_var_layerz )
	IF ( loc .GT. 0 ) THEN
	   have_mods = .TRUE.
	   CALL EQUAL_STRING (cmnd_buff(qual_start(loc):qual_end(loc)),
     .                        layerz_ref, status)
           IF ( status .NE. ferr_ok ) RETURN
	   IF (layerz_ref .EQ. ' ') GOTO 5550
	   IF ( .NOT.TM_LEGAL_NAME(layerz_ref) ) GOTO 5560
	ENDIF

* SET VAR/OUTTYPE= INTYPE, FLOAT, INT, SHORT

	loc = qual_given( slash_set_var_outtype )
	IF ( loc .GT. 0 ) THEN
	   have_mods = .TRUE.
           CALL EQUAL_STR_LC( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      flag, status )
           IF ( status .NE. ferr_ok ) RETURN
           i = STR_UPCASE (typflag, flag)

           IF (typflag(1:5) .EQ. 'INPUT'  ) THEN   ! input type
              outtype_flag = 99  ! do not change from incoming type
           ELSE IF (typflag(1:3) .EQ. 'BYT' .OR. typflag(1:4).EQ.'INT1') THEN
              outtype_flag = 1   ! NC_BYTE
           ELSE IF (typflag(1:3) .EQ. 'SHO' .OR. typflag(1:4).EQ.'INT2') THEN
              outtype_flag = 3   ! NC_SHORT
           ELSE IF (typflag(1:3) .EQ. 'INT' .OR. typflag(1:4).EQ.'INT4') THEN
              outtype_flag = 4   ! NC_INT (4-byte integer)
           ELSE IF (typflag(1:3) .EQ. 'FLO' .OR. typflag(1:3).EQ.'REA') THEN
              outtype_flag = 5   ! NC_FLOAT
           ELSE IF (typflag(1:3) .EQ. 'DOU') THEN
              outtype_flag = 6   ! NC_DOUBLE
           ELSE
              GOTO 5900
           ENDIF

* get dataset from varname.attname
* evaluate the context without computing the expression to get the dataset

           IF (dset .EQ. unspecified_int4) THEN

	      IF (cat .EQ. cat_user_var) THEN 
	         dset = pdset_uvars
	      ELSE

                 CALL GET_NEW_CX( cx_last, cx_cmnd, .TRUE., status )
                 IF ( status .NE. ferr_ok ) GOTO 5000
 
                 CALL EVAL_CONTEXT ( cx_cmnd, varattname, status )
                 IF ( status .NE. ferr_ok ) GOTO 5000

                 cx = is_cx( 1 )
                 dset = cx_data_set(cx) 
                 IF (dset .EQ. pdset_irrelevant) THEN
                    dset = cx_data_set(cx_last) 
                    cx = cx_last
                 ENDIF

              ENDIF

           ENDIF

* Make sure we have varid for varname, then reset the variable type.

           CALL CD_GET_VAR_ID (dset, vname, varid, status)
	   
           IF  (cat.EQ.cat_user_var .AND. status.NE.ferr_ok) THEN 
	      dset = pdset_uvars
  	      CALL CD_GET_VAR_ID (dset, vname, varid, status)
           ENDIF

* Get input type, store in variable outtype_flag
           IF (outtype_flag .EQ. 99) THEN
              CALL CD_GET_VAR_TYPE (dset, varid, vname, vartype, status)
              outtype_flag = vartype 
           ENDIF

           CALL CD_SET_VAR_TYPE (dset, varid, outtype_flag, status )
           IF (status .NE. ferr_ok) GOTO 5000

        ENDIF

* Apply the changes in Ferret structures, and in the linked-list structure.

        IF (dset .EQ. unspecified_int4) dset = pdset_uvars ! user variable
        CALL CD_GET_VAR_ID (dset, vname, varid, status)


* note on EZ vars:
* modifying the variable info invalidates data in memory
*        the purging of memory variables below is unnecessarily strict in both
*	 the uvar and fvar cases.  FVAR's can be modified in memory to change
*	 mr_grid, units, etc.  They need to be deleted only if they were on 
* 	 non-standard grids or units.  The UVAR's need to be purged only if
*	 they depend on the FVAR being changed)
	IF ( ez ) THEN
	   IF ( have_mods ) THEN

* The following block of code -- setting the layerz reference -- appears identically
* in 3 places.  Similar duplication of code for the other attributes.
* The reason is that the management of dset and varid is context dependent.
* CD_GET_VAR_ID is for example called 3 times immediately preceding this block
* Cleanup would be desirable: a single, reliable routine that returns varid;
* called just once; and then factor out the duplicated code
	      IF ( layerz_ref .NE. char_init128 ) THEN
                 attlen = TM_LENSTR1(layerz_ref)
                 attname = patnam_layerz
                 CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status) 
                 IF (attid .GT. 0) THEN
                    CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, 
     .                attname, attype, attlen, attoutflag, status )
                    CALL CD_REPLACE_ATTR (dset, varid, attname, attype, attlen, 
     .              layerz_ref, dummy, status)
                 ELSE
                    attype = NCCHAR
                    attoutflag = 1
                    CALL CD_PUT_NEW_ATTR (dset, varid, attname, attype, 
     .                 attlen, attoutflag, layerz_ref, dummy, status )
                 ENDIF
              ENDIF

	      CALL PURGE_FILE_VAR( var ) ! remove memory-resident variables
	      CALL PURGE_ALL_UVARS	 ! delete (possibly dependent) uvars
	      CALL EZ_MOD_VARS( dset,var,varid,
     .			        newname,title,units,grid,bad,tmap_status )
	      IF ( tmap_status .NE. merr_ok ) THEN
	         status = ferr_TMAP_error
	         RETURN
	      ENDIF
	   ENDIF

!	ELSEIF ( cat .EQ. cat_file_var ) THEN  ! pre 4/16
	ELSEIF ( ACTS_LIKE_FVAR(cat) ) THEN
* ... other file variables (10/95)
	   IF ( grid .NE. int4_init   ) GOTO 5112
	   IF ( bad  .NE. real4_init  ) THEN
	      CALL PURGE_FILE_VAR( var ) ! remove memory-resident variables
	      CALL PURGE_ALL_UVARS	 ! delete (possibly dependent) uvars
	      ds_missing_flag(var) = ds_bad_flag(var)	      
              ds_bad_flag    (var) = bad

              attlen = 1
              attname = 'missing_value'
              CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)
              IF (attid .GT. 0) THEN
                 CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, 
     .             attname, attype, attlen, attoutflag, status )
                 CALL CD_REPLACE_ATTR (dset, varid, attname, attype, attlen, 
     .           buf, bad, status)
              ENDIF
              attname = '_FillValue'
              CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)
              IF (attid .GT. 0) THEN
                 CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, 
     .             attname, attype, attlen, attoutflag, status )
                 CALL CD_REPLACE_ATTR (dset, varid, attname, attype, attlen, 
     .           buf, bad, status)
              ENDIF

	   ENDIF
*	   IF (newname.NE. char_init16 ) ds_var_code ( var ) = newname
	   IF (newname.NE. char_init128 )
     .         CALL string_array_modify( ds_var_code_head, var,
     .                                   newname, LEN(newname))

	   IF ( units .NE. char_init16 ) THEN
              ds_var_units( var ) = units

              attlen = TM_LENSTR1(units)
              attname = 'units'
              CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)
              IF (attid .GT. 0) THEN
                 CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, 
     .             attname, attype, attlen, attoutflag, status )
                 CALL CD_REPLACE_ATTR (dset, varid, attname, attype, attlen, 
     .           units, dummy, status)
              ELSE
                 attype = NCCHAR
                 attoutflag = 1
                 CALL CD_PUT_NEW_ATTR (dset, varid, attname, attype, 
     .              attlen, attoutflag, units, dummy, status )
              ENDIF
           ENDIF

	   IF ( title .NE. char_init128 ) THEN  ! changed from char_init80 1/14
              ds_var_title( var ) = title

              attlen = TM_LENSTR1(title)
              attname = 'long_name'
              CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)
              IF (attid .GT. 0) THEN
                 CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, 
     .             attname, attype, attlen, attoutflag, status )
                 CALL CD_REPLACE_ATTR (dset, varid, attname, attype, attlen, 
     .           title, dummy, status)
              ELSE
                 attype = NCCHAR
                 attoutflag = 1
                 CALL CD_PUT_NEW_ATTR (dset, varid, attname, attype, 
     .              attlen, attoutflag, title, dummy, status )
              ENDIF
           ENDIF

	   IF ( layerz_ref .NE. char_init128 ) THEN
              attlen = TM_LENSTR1(layerz_ref)
              attname = patnam_layerz
              CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)
              IF (attid .GT. 0) THEN
                 CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, 
     .             attname, attype, attlen, attoutflag, status )
                 CALL CD_REPLACE_ATTR (dset, varid, attname, attype, attlen, 
     .           layerz_ref, dummy, status)
              ELSE
                 attype = NCCHAR
                 attoutflag = 1
                 CALL CD_PUT_NEW_ATTR (dset, varid, attname, attype, 
     .              attlen, attoutflag, layerz_ref, dummy, status )
              ENDIF
	      CALL PURGE_ALL_UVARS	 ! delete (possibly dependent) uvars
           ENDIF

           IF (scalefac .NE. real4_init .AND. ncfile) THEN
	      CALL PURGE_FILE_VAR( var ) ! remove memory-resident variables
	      CALL PURGE_ALL_UVARS	 ! delete (possibly dependent) uvars
              ds_var_scale(var) = scalefac
              ds_var_scaleit(var)       = .TRUE.
           ENDIF
           IF (offset .NE. real4_init .AND. ncfile) THEN
	      CALL PURGE_FILE_VAR( var ) ! remove memory-resident variables
	      CALL PURGE_ALL_UVARS	 ! delete (possibly dependent) uvars
              ds_var_off(var)   = offset
              ds_var_scaleit(var)       = .TRUE.
           ENDIF
	ELSE

* ... user-defined var
	   IF ( grid .NE. int4_init   ) GOTO 5110
*	   IF (newname.NE. char_init16 ) uvar_name_code(var)= newname
	   IF (newname.NE. char_init128 ) 
     .         CALL string_array_modify(uvar_name_code_head,
     .                                  var,
     .                                  newname,
     .                                  LEN(newname))

           dset = pdset_uvars ! user variables
           CALL CD_GET_VAR_ID (dset, vname, varid, status)

	   IF ( units .NE. char_init16 ) THEN
              uvar_units( var )  = units

              attlen = TM_LENSTR1(units)
              attname = 'units'
              CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)
              IF (attid .GT. 0) THEN
                 CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, 
     .             attname, attype, attlen, attoutflag, status )
                 CALL CD_REPLACE_ATTR (dset, varid, attname, attype, attlen, 
     .           units, dummy, status)
              ELSE
                 attype = NCCHAR
                 attoutflag = 1
                 CALL CD_PUT_NEW_ATTR (dset, varid, attname, attype, 
     .              attlen, attoutflag, units, dummy, status )
              ENDIF
           ENDIF
     
	   IF ( title .NE. char_init128 ) THEN
              uvar_title( var ) = title

              attlen = TM_LENSTR1(title)
              attname = 'long_name'
              CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)
              IF (attid .GT. 0) THEN
                 CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, 
     .             attname, attype, attlen, attoutflag, status )
                 CALL CD_REPLACE_ATTR (dset, varid, attname, attype, attlen, 
     .           title, dummy, status)
              ELSE
                 attype = NCCHAR
                 attoutflag = 1
                 CALL CD_PUT_NEW_ATTR (dset, varid, attname, attype, 
     .              attlen, attoutflag, title, dummy, status )
              ENDIF
           ENDIF

	   IF ( layerz_ref .NE. char_init128 ) THEN
              attlen = TM_LENSTR1(layerz_ref)
              attname = patnam_layerz
              CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)
              IF (attid .GT. 0) THEN
                 CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, 
     .             attname, attype, attlen, attoutflag, status )
                 CALL CD_REPLACE_ATTR (dset, varid, attname, attype, attlen, 
     .           layerz_ref, dummy, status)
              ELSE
                 attype = NCCHAR
                 attoutflag = 1
                 CALL CD_PUT_NEW_ATTR (dset, varid, attname, attype, 
     .              attlen, attoutflag, layerz_ref, dummy, status )
              ENDIF
	      CALL PURGE_ALL_UVARS	 ! delete (possibly dependent) uvars
           ENDIF

	   IF ( bad  .NE. real4_init  ) THEN
	      CALL PURGE_ALL_UVARS	 ! delete invalidated uvars
	      uvar_bad_data(var) = bad

              attlen = 1
              attname = 'missing_value'
              CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)
              IF (attid .GT. 0) THEN
                 CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, 
     .             attname, attype, attlen, attoutflag, status )
                 CALL CD_REPLACE_ATTR (dset, varid, attname, attype, attlen, 
     .           buf, bad, status)
              ELSE
                 attype = NCFLOAT
                 attoutflag = 1
                 CALL CD_PUT_NEW_ATTR (dset, varid, attname, attype, 
     .              attlen, attoutflag, buf, bad, status )
              ENDIF

              attname = '_FillValue'
              CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)
              IF (attid .GT. 0) THEN
                 CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, 
     .             attname, attype, attlen, attoutflag, status )
                 CALL CD_REPLACE_ATTR (dset, varid, attname, attype, attlen, 
     .           buf, bad, status)
              ELSE
                 attype = NCFLOAT
                 attoutflag = 1
                 CALL CD_PUT_NEW_ATTR (dset, varid, attname, attype, 
     .              attlen, attoutflag, buf, bad, status )
              ENDIF
	   ENDIF

	ENDIF

! Replace the name in the linked-list structure.
	IF (newname .NE. char_init128 ) 
     .      CALL CD_RENAME_VAR (dset, varid, newname_lc, status)

* successful completion
	status = ferr_ok
	RETURN

* error exits
 5000	RETURN
 5005	CALL ERRMSG( ferr_unknown_variable, status,
     .		    '(data set ok ?): '//risc_buff(:len_rbuff), *5000 )
! 5010	CALL ERRMSG( ferr_invalid_command, status,
!     .		risc_buff(:len_rbuff)//' is from a self-documented data set'
!     .		//pCR//'Can only SET VARIABLE on variable from an EZ data set',
!     .							 *5000 )
 5015	CALL ERRMSG( ferr_invalid_command, status,
     .		'Cannot SET VARIABLE on '//risc_buff(:len_rbuff)//pCR//
     .		'Only on variables from "EZ" data sets',
     .							 *5000 )
!     .		'Only on user-defined and variables from "EZ" data sets',
 5100	CALL ERRMSG( ferr_erreq, status,
     .		cmnd_buff(qual_start(loc):qual_end(loc)), *5000 )
 5110   CALL ERRMSG( ferr_invalid_command, status,
     .               'cannot specify grid for '//risc_buff(:len_rbuff)//
     .		      pCR//
     .               'Grid for a user-defined variable is implied '//
     .               'by its definition', *5000 )
 5112   CALL ERRMSG( ferr_invalid_command, status,
     .               'cannot specify grid for '//risc_buff(:len_rbuff),
     .               						*5000 )
 5200	CALL ERRMSG( ferr_invalid_command, status,
     .               'illegal new name given for '
     .			//risc_buff(:len_rbuff),
     .               						*5000 )
 5400	CALL PARSE_NAM_DSET( newname, cx_last, dset,
     .			     cat, var, mod_cx, status )
!	IF (cat .EQ. cat_file_var) THEN   ! pre 4/16
	IF (ACTS_LIKE_FVAR(cat)) THEN
           CALL ERRMSG( ferr_invalid_command, status,
     .               'illegal new name.  Variable '
     .			//newname_lc(:len_rbuff)//' exists in dataset ',
     .                                                          *5000 )
        ELSE
           CALL ERRMSG( ferr_invalid_command, status,
     .               'illegal new name.  Variable '
     .			//newname_lc(:len_rbuff)//' already defined ',
     .                                                          *5000 )
        ENDIF
 5500	CALL ERRMSG( ferr_grid_definition, status, grid_name, *5000 )

 5550	CALL ERRMSG( ferr_unknown_arg, status, 'argument required', *5000)

 5560	CALL ERRMSG( ferr_invalid_command, status,
     .			'referenced variable is not an acceptable name', *5000)

 5600	CALL ERRMSG( ferr_invalid_command, status,
     .               'Cannot SET VARIABLE/NAME= with GT or TS datasets',
     .               						*5000 )
 5700	CALL ERRMSG( ferr_invalid_command, status,
     .           'Can SET VARIABLE/SCALEFAC= only with NetCDF datasets',
     .               						*5000 )
 5800	CALL ERRMSG( ferr_invalid_command, status,
     .           'Can SET VARIABLE/OFFSET= only with NetCDF datasets',
     .               						*5000 )
     
 5900	CALL ERRMSG( ferr_unknown_arg, status,
     .'Can SET VARIABLE/OUTTYPE=INPUT, DOUBLE, FLOAT, INT, SHORT, BYTE',
     .               						*5000 )

	END

	BLOCK DATA XSTEP_FILES_DATA

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* various pre-defined variables for COMMON/Xstep_files
* programmer - mark verschell
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.00 - 08/19/86
* revision 0.10 - 07/22/88 - Added TS variables
* revision 0.11 - 11/21/88 - variable initialization changed to char_initXX
* revision 0.12 - 04/24/91 - *sh* unix/RISC port: increased sf_name size
* Linux port -kob - 3/97 - Modify include for tmap_dset.parm to be a
*			   preprocessor include for F90 - needed because
*			   tmap_dset.parm contains an ifdef
* v581 *acm* 4/2005  Add sf_ndxs and sf_ndxe to use indices rather than timesteps
*                     for indexing mc datasets in mc_read.
* V701  7/16 *kms* Initialize sf_name with maxstepfile*char_init2048

#include "tmap_dset.parm"		
	include 'tmap_dims.parm'
	include 'xstep_files.cmn_text'


	DATA	sf_name			/maxstepfiles*char_init2048/
	DATA	sf_setnum		/maxstepfiles*set_not_open/
	DATA	sf_aux_set_num		/maxstepfiles*set_not_open/
	DATA	sf_nrecperstep		/maxstepfiles*int4_init/
	DATA	sf_skip			/maxstepfiles*int4_init/
	DATA	sf_1step		/maxstepfiles*real8_init/
	DATA	sf_lastep		/maxstepfiles*real8_init/
	DATA	sf_delta		/maxstepfiles*real8_init/
	DATA	sf_reclen		/maxstepfiles*int4_init/
	DATA	sf_valid		/maxstepfiles*.FALSE./
	DATA	sf_lunit		/maxstepfiles*file_not_open/
	DATA	sf_index		/maxstepfiles*char_init23/
	DATA	sf_regvars		/maxstepfiles*.TRUE./
	DATA	sf_regtimes		/maxstepfiles*.TRUE./
	DATA	sf_ndxs 		/maxstepfiles*int4_init/
	DATA	sf_ndxe 		/maxstepfiles*int4_init/
	DATA	vf_firstvar		/maxvarfiles*int4_init/
	DATA	vf_lastvar		/maxvarfiles*int4_init/

	END

*
* sorti_str.F
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* Nov 2008
* V6.2 *acm* SORTI for strings
*
* This function sorts data on x axis in increasing order.
* Returns index of sorted values.  
*
*  NOTE:
*  IT IS GENERALLY ADVISABLE TO INCLUDE EXPLICIT LIMITS WHEN WORKING WITH
*  FUNCTIONS THAT REPLACE AXES. FOR EXAMPLE, THE CONSIDER THE FUNCTION
*  SORTL(v). THE EXPRESSION
*  	LIST/L=6:10 SORTL(v)
*  IS NOT EQUIVALENT TO
*  	LIST SORTL(v[L=6:10])
*  THE FORMER WILL LIST THE 6TH THROUGH 10TH SORTED INDICES FROM THE ENTIRE
*  L RANGE OF VARIABLE V. THE LATTER WILL LIST ALL OF THE INDICES THAT
*  RESULT FROM SORTING v[L=6:10].
*  
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE sorti_str_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      CHARACTER*100 fcn_desc
      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns indices of string data, sorted ',
     .        'on the I axis in increasing order')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 1)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, ABSTRACT, IMPLIED_BY_ARGS,
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)

      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

c      CALL ef_set_num_work_arrays(id, 2)
      CALL ef_set_num_work_arrays(id, 1)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'DAT')
      CALL ef_set_arg_desc(id, arg, 'String variable to sort in I')
      CALL ef_set_axis_influence(id, arg, NO, YES, YES, YES)
      CALL ef_set_arg_type (id, arg, STRING_ARG)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END


*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE sorti_str_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER my_lo_l, my_hi_l

      INTEGER arg
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

*
*     Use utility functions to get context information about the arguments.
*

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      my_lo_l = 1
      my_hi_l = 1

      arg = 1

      my_hi_l = arg_hi_ss(X_AXIS,arg) - arg_lo_ss(X_AXIS,arg) + 1


      CALL ef_set_axis_limits(id, X_AXIS, my_lo_l, my_hi_l)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE sorti_str_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
* 
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_dims(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER mxdat
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      mxdat = 1 + arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1)


c* sort_dat
c      CALL ef_set_work_array_dims (id, 1, 1, 1, 1, 1, mxdat, 20, 1, 1)  !!!????

* sort_indx
      CALL ef_set_work_array_dims (id, 2, 1, 1, 1, 1, mxdat, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END

*
* In this subroutine we compute the result
*
c      SUBROUTINE sorti_str_compute(id, arg_1, result, sort_dat, sort_indx)
      SUBROUTINE sorti_str_compute(id, arg_1, result, sort_indx)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(2,mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER id
      INTEGER nbad, m_indx
      INTEGER m, nsrt
      INTEGER i, j, k, l
      INTEGER i1, j1, k1, l1

*  Dimension work arrays

c      CHARACTER*20 sort_dat(wrk1lox:wrk1hix, wrk1loy:wrk1hiy,
c     .               wrk1loz:wrk1hiz, wrk1lot:wrk1hit)
      REAL sort_indx(wrk2lox:wrk2hix, wrk2loy:wrk2hiy,
     .               wrk2loz:wrk2hiz, wrk2lot:wrk2hit)

      character*20 my_sort_dat(50)

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)


      j1 = arg_lo_ss(Y_AXIS, ARG1)
      DO 600 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

         k1 = arg_lo_ss(Z_AXIS, ARG1)
         DO 500 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

            l1 = arg_lo_ss(T_AXIS, ARG1)
            DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

               nsrt = 0
               nbad = 0

               i1 = arg_lo_ss(X_AXIS,ARG1)
               DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

                  nsrt = nsrt + 1
                  CALL EF_GET_STRING_ARG_ELEMENT(id, ARG1, arg_1,
     .                       i2,j2,k2,l2, slen, my_sort_dat(nsrt) )
                  sort_indx(nsrt,1,1,1) = i1

                  i1 = i1 + arg_incr(X_AXIS,ARG1)
 100           CONTINUE
      
*
* Sort based on sort_dat.  sort_indx goes along for the ride,
* elements moved when elements of sort_dat moved.
*
               IF (nsrt .GT. 1) CALL HEAP2_STR (my_sort_dat, 
     .                                   sort_indx, nsrt)

               DO 200 m = 1, nsrt
                  result(m,j,k,l) = sort_indx(m,1,1,1)
 200           CONTINUE

               DO 300 m = 1, nbad
                  m_indx = m + nsrt
                  result(m_indx,j,k,l) = bad_flag_result
 300           CONTINUE

               l1 = l1 + arg_incr(T_AXIS, ARG1)
 400        CONTINUE

            k1 = k1 + arg_incr(Z_AXIS, ARG1)
 500     CONTINUE

         j1 = j1 + arg_incr(Y_AXIS, ARG1)
 600  CONTINUE
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END
      SUBROUTINE HEAP2_STR (RA, IB, N)

C  Ansley Manke
C  From Numerical Recipes, Heapsort subroutine SORT2
C  with change noted below for the case where N=1

      INTEGER N
      CHARACTER RA(*), RRA

      INTEGER L, IR, J, I, NGD
      REAL IB(*), IIB

* From SHELLR
* since the input array may be large but sparse, begin by sorting
* the missing value flags to the end of the list

      ngd = 0
      DO j = 1, n
c         IF (RA(j) .NE. bad) THEN
            ngd = ngd + 1
            RA(ngd) = RA(j)
            IB(ngd) = IB(j)
c          ENDIF 
      END DO

c      DO j = ngd+1, nc
c         RA(j) = bad
c         IB(j) = 0.0  ! just for house-keeping
c      END DO

      L = NGD/2 + 1
      IR = NGD

      IF (NGD .LT. 1) RETURN

   10 CONTINUE
         IF (L .GT. 1) THEN
            L = L - 1
            RRA = RA(L)
            IIB = IB(L)
         ELSE
            RRA = RA(IR)
            IIB = IB(IR) 
            RA(IR) = RA(1)
            IB(IR) = IB(1)
            IR = IR - 1
            IF (IR .LE. 1) THEN	! *acm* Num Recipes has .EQ. here,
				!       but this fails in the case where	
				!       the loop starts with L=1
               RA(1) = RRA
               IB(1) = IIB
               RETURN
            ENDIF
          ENDIF

          I = L
          J = L + L
   20     IF (J .LE. IR) THEN
             IF (J .LT. IR) THEN
                IF (RA(J) .LT. RA(J+1)) J = J + 1
             ENDIF
             IF (RRA .LT. RA(J)) THEN
                RA(I) = RA(J)
                IB(I) = IB(J)
                I = J
                J = J + J
             ELSE
                J = IR + 1
             ENDIF
             GO TO 20
          ENDIF

          RA(I) = RRA
          IB(I) = IIB
      GO TO 10

      END

      SUBROUTINE SHELLR(SDAT, IDAT, BAD, N)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*from http://www.cs.mcgill.ca/~ratzer/progs15_6.html  23-APR-1998
*  Gerald Ratzer, McGill school of Computer Science, McGill University,
*  Montreal, Quebec, Canada

* Changed data to REAL. Added IDAT, to sort along with SDAT.  
* Removed NCOUNTS, NCOMP, NSWAP.

* V530 *sh* - based on SHELL (also in Ferret)
* optimized for missing value flags in input (sort to end of list)



      REAL     SDAT(*),IDAT(*), BAD, tmp
      INTEGER  N, M
      INTEGER  I, J, ngd

* since the input array may be large but sparse, begin by sorting
* the missing value flags to the end of the list
        ngd = 0
        DO j = 1, n
           IF (sdat(j) .NE. bad) THEN
              ngd = ngd + 1
              sdat(ngd) = sdat(j)
              idat(ngd) = idat(j)
           ENDIF 
        END DO

        DO j = ngd+1, n
           sdat(j) = bad
           idat(j) = 0.0  ! just for house-keeping
        END DO

* now sort only the valid (non-BAD) inputs
      M=ngd
      DO WHILE (M .gt. 1)
         M=(M+2)/3
         DO I=M+1,ngd
            DO J=I,M+1,-M
               IF (SDAT(J-M).GE. SDAT(J)) THEN
                 tmp = sdat(j)
                 sdat(j) = sdat(j-m)
                 sdat(j-m) = tmp
                 tmp = idat(j)
                 idat(j) = idat(j-m)
                 idat(j-m) = tmp
               ENDIF
            END DO 
         END DO 
      END DO
      RETURN
      END

	LOGICAL FUNCTION TRUE_OR_FALSE (string, status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* check to see if the string represents a TRUE condition or a FALSE one
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V420  4/25/96
*	7/96 - minor compiler bug fix -- eliminate unuser RETURN
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

        IMPLICIT NONE
* calling argument declarations:
	INTEGER		status
	CHARACTER*(*)	string

	include	'ferret.parm'
	include 'errmsg.parm'

* local parameter declarations
	INTEGER nyes, nno
	PARAMETER (nyes = 4,
     .		   nno  = 6)

* local variable declarations
	LOGICAL TM_DIGIT
	INTEGER	STR_MATCH, i
	REAL	value
	CHARACTER*8 yes_strings(nyes), no_strings(nno)

	DATA (yes_strings(i),i=1,nyes)/'TRUE','T','Y','YES'/
	DATA (no_strings(i),i=1,nno)/'FALSE','F','N','NO','BAD','MISSING'/
	
* initialize
	status = ferr_ok

* a blank string is a "false"
	IF ( string .EQ. ' ' ) GOTO 2000

* if the string is numerical then "0" is false, all other is true
	IF ( TM_DIGIT(string) ) THEN
	   READ ( string, *, ERR=5100) value
	   IF ( value .EQ. 0.0 ) THEN
	      GOTO 2000
	   ELSE
	      GOTO 1000
	   ENDIF

* if the string is non-numerical then try matching
	ELSE
	   i = STR_MATCH( string, yes_strings, nyes )
	   IF ( i .NE. atom_not_found ) GOTO 1000	! a valid TRUE
	   i = STR_MATCH( string, no_strings,  nno  )
	   IF ( i .NE. atom_not_found ) GOTO 2000	! a valid FALSE
	   GOTO 5100					! syntax err

	ENDIF

* return TRUE
 1000	TRUE_OR_FALSE = .TRUE.
	RETURN

* return FALSE
 2000	TRUE_OR_FALSE = .FALSE.
	RETURN


* error exit
 5100	TRUE_OR_FALSE = .FALSE.		! included for whiny OSF compiler
        CALL ERRMSG( ferr_syntax, status, string, *2000 )
	END

	BLOCK DATA XCALC_VARS_DATA

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* initialization of COMMON / XCALC_VARS /

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  7/21/89 - extracted from XVARIABLES_DTA with extensive changes
*	10/12/89 - added cvar_num_results data
*	 2/26/90 - CAIR requires only one component in the 4D version 2.00
* Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
*         2/12 *kms* Add the E and F dimensions

        IMPLICIT NONE
#include "tmap_dset.parm"
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'	! .cmn_text has an external
	include 'ferret.parm'
	include 'instance_table.parm'
	include 'xcalc_vars.cmn'

	INTEGER	i

* local parameter declarations:
	INTEGER     ptstep_1hr_b4, pcair_special, pairt_special, 
     .              ptemp_special
	PARAMETER ( ptstep_1hr_b4 = pcv_hourly_0 - 1,
     .		    pcair_special = pcair  + pcv_spec_flg,
     .		    pairt_special = pairt + pcv_spec_flg,
     .		    ptemp_special = ptemp + pcv_spec_flg )

* number of calculatable variables defined in this BLOCK DATA
	DATA num_calc_vars	/ 59 /

* computable variables pre-defined in program
	DATA cvar_primary_name	( pqcdz )
     .				/'VERTICAL HEAT DIFFUSION COEFFICIENT'/
	DATA cvar_name_code	( pqcdz ) / 'QCDZ'	/
	DATA cvar_unit_code	( pqcdz ) / pudiffusion /
	DATA cvar_frame_start	( pqcdz ) / to_qcdz	/
	DATA cvar_frame_length	( pqcdz ) / qcdz_frame	/
	DATA cvar_num_results	( pqcdz ) / 2	/	! also PCDZ
	DATA ( cvar_axes(i,pqcdz),i=1,3 ) / mxt, myt, mzw/

	DATA cvar_primary_name	( ppcdz )
     .				/'VERTICAL MOMENTUM DIFFUSION COEFFICIENT'/
	DATA cvar_name_code	( ppcdz ) / 'PCDZ'	/
	DATA cvar_unit_code	( ppcdz ) / pudiffusion /
	DATA cvar_frame_start	( ppcdz ) / to_pcdz	/
	DATA cvar_frame_length	( ppcdz ) / pcdz_frame	/
	DATA cvar_num_results	( ppcdz ) / 2	/	! also QCDZ
	DATA ( cvar_axes(i,ppcdz),i=1,3 ) / mxu, myu, mzw /

	DATA cvar_primary_name	( prho0 ) / 'DENSITY REFERENCED TO SURFACE'/
	DATA cvar_name_code	( prho0 ) / 'RHO0'	/
	DATA cvar_unit_code	( prho0 ) / punot_app	/
	DATA cvar_frame_start	( prho0 ) / to_rho0	/
	DATA cvar_frame_length	( prho0 ) / rho0_frame	/
	DATA cvar_num_results	( prho0 ) / 1	/
	DATA ( cvar_axes(i,prho0),i=1,3 ) / mxt, myt, mzt /

	DATA cvar_primary_name	( pqdfz ) 
     .				/ 'VERTICAL HEAT DIFFUSION' /
	DATA cvar_name_code	( pqdfz ) / 'QDFZ'	/
	DATA cvar_unit_code	( pqdfz ) / putemp_dt	/
	DATA cvar_frame_start	( pqdfz ) / to_qdfz	/
	DATA cvar_frame_length	( pqdfz ) / qdfz_frame	/
	DATA cvar_num_results	( pqdfz ) / 1	/
	DATA ( cvar_axes(i,pqdfz),i=1,3 ) / mxt, myt, mzt /

	DATA cvar_primary_name	( pqdfh ) / 'HORIZONTAL HEAT DIFFUSION' /
	DATA cvar_name_code	( pqdfh ) / 'QDFH'	/
	DATA cvar_unit_code	( pqdfh ) / putemp_dt	/
	DATA cvar_frame_start	( pqdfh ) / to_qdfh	/
	DATA cvar_frame_length	( pqdfh ) / qdfh_frame	/
	DATA cvar_num_results	( pqdfh ) / 1	/
	DATA ( cvar_axes(i,pqdfh),i=1,3 ) / mxt, myt, mzt /

	DATA cvar_primary_name	( pqadx ) / 'ZONAL HEAT ADVECTION' /
	DATA cvar_name_code	( pqadx ) / 'QADX'	/
	DATA cvar_unit_code	( pqadx ) / putemp_dt	/
	DATA cvar_frame_start	( pqadx ) / to_qadx	/
	DATA cvar_frame_length	( pqadx ) / qadx_frame	/
	DATA cvar_num_results	( pqadx ) / 1	/
	DATA ( cvar_axes(i,pqadx),i=1,3 ) / mxt, myt, mzt /

	DATA cvar_primary_name	( pqady ) / 'MERIDIONAL HEAT ADVECTION' /
	DATA cvar_name_code	( pqady ) / 'QADY'	/
	DATA cvar_unit_code	( pqady ) / putemp_dt	/
	DATA cvar_frame_start	( pqady ) / to_qady	/
	DATA cvar_frame_length	( pqady ) / qady_frame	/
	DATA cvar_num_results	( pqady ) / 1	/
	DATA ( cvar_axes(i,pqady),i=1,3 ) / mxt, myt, mzt /

	DATA cvar_primary_name	( pqadz ) / 'VERTICAL HEAT ADVECTION' /
	DATA cvar_name_code	( pqadz ) / 'QADZ'	/
	DATA cvar_unit_code	( pqadz ) / putemp_dt	/
	DATA cvar_frame_start	( pqadz ) / to_qadz	/
	DATA cvar_frame_length	( pqadz ) / qadz_frame	/
	DATA cvar_num_results	( pqadz ) / 1	/
	DATA ( cvar_axes(i,pqadz),i=1,3 ) / mxt, myt, mzt /

	DATA cvar_primary_name	( pqad  ) / 'TOTAL HEAT ADVECTION' /
	DATA cvar_name_code	( pqad  ) / 'QAD '	/
	DATA cvar_unit_code	( pqad  ) / putemp_dt	/
	DATA cvar_frame_start	( pqad  ) / to_qad 	/
	DATA cvar_frame_length	( pqad  ) / qad _frame	/
	DATA cvar_num_results	( pqad  ) / 1	/
	DATA ( cvar_axes(i,pqad ),i=1,3 ) / mxt, myt, mzt /

	DATA cvar_primary_name	( pqdf  ) / 'TOTAL HEAT DIFFUSION' /
	DATA cvar_name_code	( pqdf  ) / 'QDF '	/
	DATA cvar_unit_code	( pqdf  ) / putemp_dt	/
	DATA cvar_frame_start	( pqdf  ) / to_qdf 	/
	DATA cvar_frame_length	( pqdf  ) / qdf _frame	/
	DATA cvar_num_results	( pqdf  ) / 1	/
	DATA ( cvar_axes(i,pqdf ),i=1,3 ) / mxt, myt, mzt /

	DATA cvar_primary_name	( pqeva ) / 'EVAPORATIVE HEAT' /
	DATA cvar_name_code	( pqeva ) / 'QEVA'	/
	DATA cvar_unit_code	( pqeva ) / puheat_flux	/
	DATA cvar_frame_start	( pqeva ) / to_qeva	/
	DATA cvar_frame_length	( pqeva ) / qeva_frame	/
	DATA cvar_num_results	( pqeva ) / 2	/	! also computes QSEN
	DATA ( cvar_axes(i,pqeva),i=1,3 ) / mxt, myt, mnormal /

	DATA cvar_primary_name	( ptau  ) / 'MAGNITUDE OF WIND STRESS' /
	DATA cvar_name_code	( ptau  ) / 'TAU '	/
	DATA cvar_unit_code	( ptau  ) / pupressure	/
	DATA cvar_frame_start	( ptau  ) / to_tau 	/
	DATA cvar_frame_length	( ptau  ) / tau _frame	/
	DATA cvar_num_results	( ptau  ) / 1	/
	DATA ( cvar_axes(i,ptau ),i=1,3 ) / mxt, myt, mnormal /

	DATA cvar_primary_name	( pqsen ) / 'SENSIBLE HEAT'/
	DATA cvar_name_code	( pqsen ) / 'QSEN'	/
	DATA cvar_unit_code	( pqsen ) / puheat_flux	/
	DATA cvar_frame_start	( pqsen ) / to_qsen	/
	DATA cvar_frame_length	( pqsen ) / qsen_frame	/
	DATA cvar_num_results	( pqsen ) / 2	/	! also computes QEVA
	DATA ( cvar_axes(i,pqsen),i=1,3 ) / mxt, myt, mnormal /

	DATA cvar_primary_name	( pqrad ) / 'RADIATIVE HEAT' /
	DATA cvar_name_code	( pqrad ) / 'QRAD'	/
	DATA cvar_unit_code	( pqrad ) / puheat_flux	/
	DATA cvar_frame_start	( pqrad ) / to_qrad	/
	DATA cvar_frame_length	( pqrad ) / qrad_frame	/
	DATA cvar_num_results	( pqrad ) / 1	/
	DATA ( cvar_axes(i,pqrad),i=1,3 ) / mxt, myt, mnormal /

	DATA cvar_primary_name	( pqflx ) / 'SURFACE HEAT FLUX' /
	DATA cvar_name_code	( pqflx ) / 'QFLX'	/
	DATA cvar_unit_code	( pqflx ) / puheat_flux	/
	DATA cvar_frame_start	( pqflx ) / to_qflx	/
	DATA cvar_frame_length	( pqflx ) / qflx_frame	/
	DATA cvar_num_results	( pqflx ) / 1	/
	DATA ( cvar_axes(i,pqflx),i=1,3 ) / mxt, myt, mnormal /

	DATA cvar_primary_name	( prho  ) / 'NORMALIZED DENSITY'/
	DATA cvar_name_code	( prho  ) / 'RHO'	/
	DATA cvar_unit_code	( prho  ) / punot_app	/
	DATA cvar_frame_start	( prho  ) / to_rho	/
	DATA cvar_frame_length	( prho  ) / rho_frame	/
	DATA cvar_num_results	( prho  ) / 1	/
	DATA ( cvar_axes(i,prho ),i=1,3 ) / mxt, myt, mzt /

	DATA cvar_primary_name	( pdpdx ) 
     .				/ 'd/dX( BAROCLINIC PRESSURE )'/
	DATA cvar_name_code	( pdpdx ) / 'DPDX'	/
	DATA cvar_unit_code	( pdpdx ) / pupres_dx	/
	DATA cvar_frame_start	( pdpdx ) / to_dpdx	/
	DATA cvar_frame_length	( pdpdx ) / dpdx_frame	/
	DATA cvar_num_results	( pdpdx ) / 2	/	! also DPDY
	DATA ( cvar_axes(i,pdpdx),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( pdpdy ) 
     .				/ 'd/dY( BAROCLINIC PRESSURE )'/
	DATA cvar_name_code	( pdpdy ) / 'DPDY'	/
	DATA cvar_unit_code	( pdpdy ) / pupres_dx	/
	DATA cvar_frame_start	( pdpdy ) / to_dpdy	/
	DATA cvar_frame_length	( pdpdy ) / dpdy_frame	/
	DATA cvar_num_results	( pdpdy ) / 2	/	! also DPDX
	DATA ( cvar_axes(i,pdpdy),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( pw_u  ) 
     .				 / 'VERTICAL VELOCITY COMPUTED ON UV GRID' /
	DATA cvar_name_code	( pw_u  ) / 'W_U '	/
	DATA cvar_unit_code	( pw_u  ) / puvelocity	/
	DATA cvar_frame_start	( pw_u  ) / to_w_u	/
	DATA cvar_frame_length	( pw_u  ) / w_u_frame	/
	DATA cvar_num_results	( pw_u  ) / 1	/
	DATA ( cvar_axes(i,pw_u ),i=1,3 ) / mxu, myu, mzw /

	DATA cvar_primary_name	( puavz ) 
     .				 / 'VERTICALLY AVERAGED ZONAL VELOCITY'	/
	DATA cvar_name_code	( puavz ) / 'UAVZ'	/
	DATA cvar_unit_code	( puavz ) / puvelocity	/
	DATA cvar_frame_start	( puavz ) / to_uavz	/
	DATA cvar_frame_length	( puavz ) / uavz_frame	/
	DATA cvar_num_results	( puavz ) / 2	/	! also VAVZ
	DATA ( cvar_axes(i,puavz),i=1,3 ) / mxu, myu, mnormal /

	DATA cvar_primary_name	( pvavz ) 
     .				 / 'VERTICALLY AVERAGED MERIDIONAL VELOCITY' /
	DATA cvar_name_code	( pvavz ) / 'VAVZ'	/
	DATA cvar_unit_code	( pvavz ) / puvelocity	/
	DATA cvar_frame_start	( pvavz ) / to_vavz	/
	DATA cvar_frame_length	( pvavz ) / vavz_frame	/
	DATA cvar_num_results	( pvavz ) / 2	/	! also UAVZ
	DATA ( cvar_axes(i,pvavz),i=1,3 ) / mxu, myu, mnormal /

	DATA cvar_primary_name	( pfuw  ) 
     .					/ 'ZONAL ADVECTIVE COEFFICIENT, FUW' /
	DATA cvar_name_code	( pfuw  ) / 'FUW ' 	/
	DATA cvar_unit_code	( pfuw  ) / puvelocity	/
	DATA cvar_frame_start	( pfuw  ) / to_fuw 	/
	DATA cvar_frame_length	( pfuw  ) / fuw_frame	/
	DATA cvar_num_results	( pfuw  ) / 1	/
	DATA ( cvar_axes(i,pfuw ),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( pfvn  ) 
     .				/ 'MERIDIONAL ADVECTIVE COEFFICIENT, FVN' /
	DATA cvar_name_code	( pfvn  ) / 'FVN '	/
	DATA cvar_unit_code	( pfvn  ) / puvelocity	/
	DATA cvar_frame_start	( pfvn  ) / to_fvn 	/
	DATA cvar_frame_length	( pfvn  ) / fvn_frame	/
	DATA cvar_num_results	( pfvn  ) / 1	/
	DATA ( cvar_axes(i,pfvn ),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( puadx ) / 'ZONAL ADVECTION OF U' /
	DATA cvar_name_code	( puadx ) / 'UADX'	/
	DATA cvar_unit_code	( puadx ) / puvel_dt	/
	DATA cvar_frame_start	( puadx ) / to_uadx	/
	DATA cvar_frame_length	( puadx ) / uadx_frame	/
	DATA cvar_num_results	( puadx ) / 1	/
	DATA ( cvar_axes(i,puadx),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( puady ) / 'MERIDIONAL ADVECTION OF U' /
	DATA cvar_name_code	( puady ) / 'UADY'	/
	DATA cvar_unit_code	( puady ) / puvel_dt	/
	DATA cvar_frame_start	( puady ) / to_uady	/
	DATA cvar_frame_length	( puady ) / uady_frame	/
	DATA cvar_num_results	( puady ) / 1	/
	DATA ( cvar_axes(i,puady),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( puadz ) / 'VERTICAL ADVECTION OF U' /
	DATA cvar_name_code	( puadz ) / 'UADZ'	/
	DATA cvar_unit_code	( puadz ) / puvel_dt	/
	DATA cvar_frame_start	( puadz ) / to_uadz	/
	DATA cvar_frame_length	( puadz ) / uadz_frame	/
	DATA cvar_num_results	( puadz ) / 1	/
	DATA ( cvar_axes(i,puadz),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( pvadx ) / 'ZONAL ADVECTION OF V' /
	DATA cvar_name_code	( pvadx ) / 'VADX'	/
	DATA cvar_unit_code	( pvadx ) / puvel_dt	/
	DATA cvar_frame_start	( pvadx ) / to_vadx	/
	DATA cvar_frame_length	( pvadx ) / vadx_frame	/
	DATA cvar_num_results	( pvadx ) / 1	/
	DATA ( cvar_axes(i,pvadx),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( pvady ) / 'MERIDIONAL ADVECTION OF V' /
	DATA cvar_name_code	( pvady ) / 'VADY'	/
	DATA cvar_unit_code	( pvady ) / puvel_dt	/
	DATA cvar_frame_start	( pvady ) / to_vady	/
	DATA cvar_frame_length	( pvady ) / vady_frame	/
	DATA cvar_num_results	( pvady ) / 1	/
	DATA ( cvar_axes(i,pvady),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( pvadz ) / 'VERTICAL ADVECTION OF V' /
	DATA cvar_name_code	( pvadz ) / 'VADZ'	/
	DATA cvar_unit_code	( pvadz ) / puvel_dt	/
	DATA cvar_frame_start	( pvadz ) / to_vadz	/
	DATA cvar_frame_length	( pvadz ) / vadz_frame	/
	DATA cvar_num_results	( pvadz ) / 1	/
	DATA ( cvar_axes(i,pvadz),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( pudfh ) / 'HORIZONTAL DIFFUSION OF U' /
	DATA cvar_name_code	( pudfh ) / 'UDFH'	/
	DATA cvar_unit_code	( pudfh ) / puvel_dt	/
	DATA cvar_frame_start	( pudfh ) / to_udfh	/
	DATA cvar_frame_length	( pudfh ) / udfh_frame	/
	DATA cvar_num_results	( pudfh ) / 1	/
	DATA ( cvar_axes(i,pudfh),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( pudfz ) / 'VERTICAL DIFFUSION OF U' /
	DATA cvar_name_code	( pudfz ) / 'UDFZ'	/
	DATA cvar_unit_code	( pudfz ) / puvel_dt	/
	DATA cvar_frame_start	( pudfz ) / to_udfz	/
	DATA cvar_frame_length	( pudfz ) / udfz_frame	/
	DATA cvar_num_results	( pudfz ) / 1	/
	DATA ( cvar_axes(i,pudfz),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( pvdfh ) / 'HORIZONTAL DIFFUSION OF V' /
	DATA cvar_name_code	( pvdfh ) / 'VDFH'	/
	DATA cvar_unit_code	( pvdfh ) / puvel_dt	/
	DATA cvar_frame_start	( pvdfh ) / to_vdfh	/
	DATA cvar_frame_length	( pvdfh ) / vdfh_frame	/
	DATA cvar_num_results	( pvdfh ) / 1	/
	DATA ( cvar_axes(i,pvdfh),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( pvdfz ) / 'VERTICAL DIFFUSION OF V' /
	DATA cvar_name_code	( pvdfz ) / 'VDFZ'	/
	DATA cvar_unit_code	( pvdfz ) / puvel_dt	/
	DATA cvar_frame_start	( pvdfz ) / to_vdfz	/
	DATA cvar_frame_length	( pvdfz ) / vdfz_frame	/
	DATA cvar_num_results	( pvdfz ) / 1	/
	DATA ( cvar_axes(i,pvdfz),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( pucoi ) 
     .				/ 'U DUE TO IMPLICIT CORIOLIS CORRECTION' /
	DATA cvar_name_code	( pucoi ) / 'UCOI'	/
	DATA cvar_unit_code	( pucoi ) / puvel_dt	/
	DATA cvar_frame_start	( pucoi ) / to_ucoi	/
	DATA cvar_frame_length	( pucoi ) / ucoi_frame	/
	DATA cvar_num_results	( pucoi ) / -9999	/
	DATA ( cvar_axes(i,pucoi),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( pvcoi )  
     .				/ 'V DUE TO IMPLICIT CORIOLIS CORRECTION' /
	DATA cvar_name_code	( pvcoi ) / 'VCOI'	/
	DATA cvar_unit_code	( pvcoi ) / puvel_dt	/
	DATA cvar_frame_start	( pvcoi ) / to_vcoi	/
	DATA cvar_frame_length	( pvcoi ) / vcoi_frame	/
	DATA cvar_num_results	( pvcoi ) / -9999	/
	DATA ( cvar_axes(i,pvcoi),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( pubpi ) 
     .				/ 'U DUE TO BAROCLINIC PRESSURE EFFECTS' /
	DATA cvar_name_code	( pubpi ) / 'UBPI'	/
	DATA cvar_unit_code	( pubpi ) / puvel_dt	/
	DATA cvar_frame_start	( pubpi ) / to_ubpi	/
	DATA cvar_frame_length	( pubpi ) / ubpi_frame	/
	DATA cvar_num_results	( pubpi ) / 1	/
	DATA ( cvar_axes(i,pubpi),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( pvbpi ) 
     .				/ 'V DUE TO BAROCLINIC PRESSURE EFFECTS' /
	DATA cvar_name_code	( pvbpi ) / 'VBPI'	/
	DATA cvar_unit_code	( pvbpi ) / puvel_dt	/
	DATA cvar_frame_start	( pvbpi ) / to_vbpi	/
	DATA cvar_frame_length	( pvbpi ) / vbpi_frame	/
	DATA cvar_num_results	( pvbpi ) / 1	/
	DATA ( cvar_axes(i,pvbpi),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( pubwi ) / 'U DUE TO WIND STRESS EFFECTS' /
	DATA cvar_name_code	( pubwi ) / 'UBWI'	/
	DATA cvar_unit_code	( pubwi ) / puvel_dt	/
	DATA cvar_frame_start	( pubwi ) / to_ubwi	/
	DATA cvar_frame_length	( pubwi ) / ubwi_frame	/
	DATA cvar_num_results	( pubwi ) / 1	/
	DATA ( cvar_axes(i,pubwi),i=1,3 ) / mxu, myu, mnormal /

	DATA cvar_primary_name	( pvbwi ) / 'V DUE TO WIND STRESS EFFECTS' /
	DATA cvar_name_code	( pvbwi ) / 'VBWI'	/
	DATA cvar_unit_code	( pvbwi ) / puvel_dt	/
	DATA cvar_frame_start	( pvbwi ) / to_vbwi	/
	DATA cvar_frame_length	( pvbwi ) / vbwi_frame	/
	DATA cvar_num_results	( pvbwi ) / 1	/
	DATA ( cvar_axes(i,pvbwi),i=1,3 ) / mxu, myu, mnormal /

	DATA cvar_primary_name	( pucoe ) 
     .				/ 'U DUE TO EXPLICIT CORIOLIS CALCULATION' /
	DATA cvar_name_code	( pucoe ) / 'UCOE'	/
	DATA cvar_unit_code	( pucoe ) / puvel_dt	/
	DATA cvar_frame_start	( pucoe ) / to_ucoe	/
	DATA cvar_frame_length	( pucoe ) / ucoe_frame	/
	DATA cvar_num_results	( pucoe ) / 2	/	! also VCOE
	DATA ( cvar_axes(i,pucoe),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( pvcoe ) 
     .				/ 'V DUE TO EXPLICIT CORIOLIS CALCULATION' /
	DATA cvar_name_code	( pvcoe ) / 'VCOE'	/
	DATA cvar_unit_code	( pvcoe ) / puvel_dt	/
	DATA cvar_frame_start	( pvcoe ) / to_vcoe	/
	DATA cvar_frame_length	( pvcoe ) / vcoe_frame	/
	DATA cvar_num_results	( pvcoe ) / 2	/	! also UCOE
	DATA ( cvar_axes(i,pvcoe),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( puad  ) / 'TOTAL ADVECTION OF U' /
	DATA cvar_name_code	( puad  ) / 'UAD '	/
	DATA cvar_unit_code	( puad  ) / puvel_dt	/
	DATA cvar_frame_start	( puad  ) / to_uad 	/
	DATA cvar_frame_length	( puad  ) / uad _frame	/
	DATA cvar_num_results	( puad  ) / 1	/
	DATA ( cvar_axes(i,puad ),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( pvad  ) / 'TOTAL ADVECTION OF V' /
	DATA cvar_name_code	( pvad  ) / 'VAD '	/
	DATA cvar_unit_code	( pvad  ) / puvel_dt	/
	DATA cvar_frame_start	( pvad  ) / to_vad 	/
	DATA cvar_frame_length	( pvad  ) / vad _frame	/
	DATA cvar_num_results	( pvad  ) / 1	/
	DATA ( cvar_axes(i,pvad ),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( pudf  ) / 'TOTAL DIFFUSION OF U' /
	DATA cvar_name_code	( pudf  ) / 'UDF '	/
	DATA cvar_unit_code	( pudf  ) / puvel_dt	/
	DATA cvar_frame_start	( pudf  ) / to_udf 	/
	DATA cvar_frame_length	( pudf  ) / udf _frame	/
	DATA cvar_num_results	( pudf  ) / 1	/
	DATA ( cvar_axes(i,pudf ),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( pvdf  ) / 'TOTAL DIFFUSION OF V' /
	DATA cvar_name_code	( pvdf  ) / 'VDF '	/
	DATA cvar_unit_code	( pvdf  ) / puvel_dt	/
	DATA cvar_frame_start	( pvdf  ) / to_vdf 	/
	DATA cvar_frame_length	( pvdf  ) / vdf _frame	/
	DATA cvar_num_results	( pvdf  ) / 1	/
	DATA ( cvar_axes(i,pvdf ),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( pdudt ) / 'd/dt(U)'	/
	DATA cvar_name_code	( pdudt ) / 'DUDT'	/
	DATA cvar_unit_code	( pdudt ) / puvel_dt	/
	DATA cvar_frame_start	( pdudt ) / to_dudt	/
	DATA cvar_frame_length	( pdudt ) / dudt_frame	/
	DATA cvar_num_results	( pdudt ) / 1	/
	DATA ( cvar_axes(i,pdudt),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( pdvdt ) / 'd/dt(V)'/
	DATA cvar_name_code	( pdvdt ) / 'DVDT'	/
	DATA cvar_unit_code	( pdvdt ) / puvel_dt	/
	DATA cvar_frame_start	( pdvdt ) / to_dvdt	/
	DATA cvar_frame_length	( pdvdt ) / dvdt_frame	/
	DATA cvar_num_results	( pdvdt ) / 1	/
	DATA ( cvar_axes(i,pdvdt),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( pdwdt ) / 'd/dt(W)'/
	DATA cvar_name_code	( pdwdt ) / 'DWDT'	/
	DATA cvar_unit_code	( pdwdt ) / puvel_dt	/
	DATA cvar_frame_start	( pdwdt ) / to_dwdt	/
	DATA cvar_frame_length	( pdwdt ) / dwdt_frame	/
	DATA cvar_num_results	( pdwdt ) / 1	/
	DATA ( cvar_axes(i,pdwdt),i=1,3 ) / mxu, myu, mzw /

	DATA cvar_primary_name	( pdtdt ) / 'd/dt(TEMPERATURE)'/
	DATA cvar_name_code	( pdtdt ) / 'DTDT'	/
	DATA cvar_unit_code	( pdtdt ) / putemp_dt	/
	DATA cvar_frame_start	( pdtdt ) / to_dtdt	/
	DATA cvar_frame_length	( pdtdt ) / dtdt_frame	/
	DATA cvar_num_results	( pdtdt ) / 1	/
	DATA ( cvar_axes(i,pdtdt),i=1,3 ) / mxt, myt, mzt /

	DATA cvar_primary_name	( pubps ) 
     .				/ 'U DUE TO SURFACE PRESSURE EFFECTS' /
	DATA cvar_name_code	( pubps ) / 'UBPS'	/
	DATA cvar_unit_code	( pubps ) / puvel_dt	/
	DATA cvar_frame_start	( pubps ) / to_ubps	/
	DATA cvar_frame_length	( pubps ) / ubps_frame	/
	DATA cvar_num_results	( pubps ) / 1	/
	DATA ( cvar_axes(i,pubps),i=1,3 ) / mxu, myu, mnormal /

	DATA cvar_primary_name	( pvbps ) 
     .				/ 'V DUE TO SURFACE PRESSURE EFFECTS' /
	DATA cvar_name_code	( pvbps ) / 'VBPS'	/
	DATA cvar_unit_code	( pvbps ) / puvel_dt	/
	DATA cvar_frame_start	( pvbps ) / to_vbps	/
	DATA cvar_frame_length	( pvbps ) / vbps_frame	/
	DATA cvar_num_results	( pvbps ) / 1	/
	DATA ( cvar_axes(i,pvbps),i=1,3 ) / mxu, myu, mnormal /

	DATA cvar_primary_name	( psali ) 
     .				/ 'SALINITY'/
	DATA cvar_name_code	( psali ) / 'SALI'	/
	DATA cvar_unit_code	( psali ) / puppt	/
	DATA cvar_frame_start	( psali ) / to_sali	/
	DATA cvar_frame_length	( psali ) / sali_frame	/
	DATA cvar_num_results	( psali ) / 1	/
	DATA ( cvar_axes(i,psali),i=1,3 ) / mxt, myt, mzt /

	DATA cvar_primary_name	( pdens ) 
     .				/ '(DENSITY-1)*1000'		/
	DATA cvar_name_code	( pdens ) / 'DENS'	/
	DATA cvar_unit_code	( pdens ) / pudensity	/
	DATA cvar_frame_start	( pdens ) / to_dens	/
	DATA cvar_frame_length	( pdens ) / dens_frame	/
	DATA cvar_num_results	( pdens ) / 1	/
	DATA ( cvar_axes(i,pdens),i=1,3 ) / mxt, myt, mzt /

	DATA cvar_primary_name	( pubp  ) 
     .				/ 'U DUE TO TOTAL PRESSURE' /
	DATA cvar_name_code	( pubp  ) / 'UBP '	/
	DATA cvar_unit_code	( pubp  ) / puvel_dt	/
	DATA cvar_frame_start	( pubp  ) / to_ubp 	/
	DATA cvar_frame_length	( pubp  ) /  ubp_frame	/
	DATA cvar_num_results	( pubp  ) / 1	/
	DATA ( cvar_axes(i,pubp ),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( pvbp  ) 
     .				/ 'V DUE TO TOTAL PRESSURE' /
	DATA cvar_name_code	( pvbp  ) / 'VBP '	/
	DATA cvar_unit_code	( pvbp  ) / puvel_dt	/
	DATA cvar_frame_start	( pvbp  ) / to_vbp 	/
	DATA cvar_frame_length	( pvbp  ) /  vbp_frame	/
	DATA cvar_num_results	( pvbp  ) / 1	/
	DATA ( cvar_axes(i,pvbp ),i=1,3 ) / mxu, myu, mzt /

	DATA cvar_primary_name	( pcmsk ) / 'CONVECTIVE ADJUSTMENT MASK'/
	DATA cvar_name_code	( pcmsk ) / 'CMSK'	/
	DATA cvar_unit_code	( pcmsk ) / punot_app	/
	DATA cvar_frame_start	( pcmsk ) / to_cmsk	/
	DATA cvar_frame_length	( pcmsk ) / cmsk_frame	/
	DATA cvar_num_results	( pcmsk ) / 1	/
	DATA ( cvar_axes(i,pcmsk),i=1,3 ) / mxt, myt, mzt /

	DATA cvar_primary_name	( pw_t  ) 
     .				/ 'VERTICAL VELOCITY COMPUTED ON TS GRID'/
	DATA cvar_name_code	( pw_t  ) / 'W_T '	/
	DATA cvar_unit_code	( pw_t  ) / puvelocity	/
	DATA cvar_frame_start	( pw_t  ) / to_w_t 	/
	DATA cvar_frame_length	( pw_t  ) /  w_t_frame	/
	DATA cvar_num_results	( pw_t  ) / 1	/
	DATA ( cvar_axes(i,pw_t ),i=1,3 ) / mxt, myt, mzw /

	DATA cvar_primary_name	( pcair ) / 'CLIMATOLOGICAL AIR TEMPERATURE'/
	DATA cvar_name_code	( pcair ) / 'CAIR'	/
	DATA cvar_unit_code	( pcair ) / putemperature /
	DATA cvar_frame_start	( pcair ) / to_cair	/
	DATA cvar_frame_length	( pcair ) / cair_frame	/
	DATA cvar_num_results	( pcair ) / 1	/
	DATA ( cvar_axes(i,pcair),i=1,3 ) / mxt, myt, mnormal /

	DATA cvar_primary_name	( pair  ) / 'AIR TEMPERATURE'/
	DATA cvar_name_code	( pair  ) / 'AIR '	/
	DATA cvar_unit_code	( pair  ) / putemperature /
	DATA cvar_frame_start	( pair  ) / to_air 	/
	DATA cvar_frame_length	( pair  ) / air_frame	/
	DATA cvar_num_results	( pair  ) / 1	/
	DATA ( cvar_axes(i,pair ),i=1,3 ) / mxt, myt, mnormal /

********************************************************************************
* variable instances needed to  compute cvar variables

	DATA cv_category (to_qcdz+1)/ cat_file_var	/
	DATA cv_variable (to_qcdz+1)/ pu		/
	DATA cv_lo_d1  (to_qcdz+1)/ 0		/
	DATA cv_hi_d1  (to_qcdz+1)/ 0		/
	DATA cv_lo_d2  (to_qcdz+1)/ 0		/
	DATA cv_hi_d2  (to_qcdz+1)/ 0		/
	DATA cv_lo_d3  (to_qcdz+1)/ 0		/
	DATA cv_hi_d3  (to_qcdz+1)/ 1		/
	DATA cv_lo_d4  (to_qcdz+1)/ 0		/
	DATA cv_hi_d4  (to_qcdz+1)/ 0		/
	DATA cv_lo_d5  (to_qcdz+1)/ 0		/
	DATA cv_hi_d5  (to_qcdz+1)/ 0		/
	DATA cv_lo_d6  (to_qcdz+1)/ 0		/
	DATA cv_hi_d6  (to_qcdz+1)/ 0		/

	DATA cv_category (to_qcdz+2)/ cat_file_var	/
	DATA cv_variable (to_qcdz+2)/ pv		/
	DATA cv_lo_d1  (to_qcdz+2)/ 0		/
	DATA cv_hi_d1  (to_qcdz+2)/ 0		/
	DATA cv_lo_d2  (to_qcdz+2)/ 0		/
	DATA cv_hi_d2  (to_qcdz+2)/ 0		/
	DATA cv_lo_d3  (to_qcdz+2)/ 0		/
	DATA cv_hi_d3  (to_qcdz+2)/ 1		/
	DATA cv_lo_d4  (to_qcdz+2)/ 0		/
	DATA cv_hi_d4  (to_qcdz+2)/ 0		/
	DATA cv_lo_d5  (to_qcdz+2)/ 0		/
	DATA cv_hi_d5  (to_qcdz+2)/ 0		/
	DATA cv_lo_d6  (to_qcdz+2)/ 0		/
	DATA cv_hi_d6  (to_qcdz+2)/ 0		/

	DATA cv_category (to_qcdz+3)/ cat_calc_var	/
	DATA cv_variable (to_qcdz+3)/ prho0 		/
	DATA cv_lo_d1  (to_qcdz+3)/ 0		/
	DATA cv_hi_d1  (to_qcdz+3)/ 0		/
	DATA cv_lo_d2  (to_qcdz+3)/ 0		/
	DATA cv_hi_d2  (to_qcdz+3)/ 0		/
	DATA cv_lo_d3  (to_qcdz+3)/ 0		/
	DATA cv_hi_d3  (to_qcdz+3)/ 1		/
	DATA cv_lo_d4  (to_qcdz+3)/ 0		/
	DATA cv_hi_d4  (to_qcdz+3)/ 0		/
	DATA cv_lo_d5  (to_qcdz+3)/ 0		/
	DATA cv_hi_d5  (to_qcdz+3)/ 0		/
	DATA cv_lo_d6  (to_qcdz+3)/ 0		/
	DATA cv_hi_d6  (to_qcdz+3)/ 0		/

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	DATA cv_category (to_pcdz+1)/ cat_file_var	/
	DATA cv_variable (to_pcdz+1)/ pu		/
	DATA cv_lo_d1  (to_pcdz+1)/ 0		/
	DATA cv_hi_d1  (to_pcdz+1)/ 0		/
	DATA cv_lo_d2  (to_pcdz+1)/ 0		/
	DATA cv_hi_d2  (to_pcdz+1)/ 0		/
	DATA cv_lo_d3  (to_pcdz+1)/ 0		/
	DATA cv_hi_d3  (to_pcdz+1)/ 1		/
	DATA cv_lo_d4  (to_pcdz+1)/ 0		/
	DATA cv_hi_d4  (to_pcdz+1)/ 0		/
	DATA cv_lo_d5  (to_pcdz+1)/ 0		/
	DATA cv_hi_d5  (to_pcdz+1)/ 0		/
	DATA cv_lo_d6  (to_pcdz+1)/ 0		/
	DATA cv_hi_d6  (to_pcdz+1)/ 0		/

	DATA cv_category (to_pcdz+2)/ cat_file_var	/
	DATA cv_variable (to_pcdz+2)/ pv		/
	DATA cv_lo_d1  (to_pcdz+2)/ 0		/
	DATA cv_hi_d1  (to_pcdz+2)/ 0		/
	DATA cv_lo_d2  (to_pcdz+2)/ 0		/
	DATA cv_hi_d2  (to_pcdz+2)/ 0		/
	DATA cv_lo_d3  (to_pcdz+2)/ 0		/
	DATA cv_hi_d3  (to_pcdz+2)/ 1		/
	DATA cv_lo_d4  (to_pcdz+2)/ 0		/
	DATA cv_hi_d4  (to_pcdz+2)/ 0		/
	DATA cv_lo_d5  (to_pcdz+2)/ 0		/
	DATA cv_hi_d5  (to_pcdz+2)/ 0		/
	DATA cv_lo_d6  (to_pcdz+2)/ 0		/
	DATA cv_hi_d6  (to_pcdz+2)/ 0		/

	DATA cv_category (to_pcdz+3)/ cat_calc_var	/
	DATA cv_variable (to_pcdz+3)/ prho0 		/
	DATA cv_lo_d1  (to_pcdz+3)/ 0		/
	DATA cv_hi_d1  (to_pcdz+3)/ 0		/
	DATA cv_lo_d2  (to_pcdz+3)/ 0		/
	DATA cv_hi_d2  (to_pcdz+3)/ 0		/
	DATA cv_lo_d3  (to_pcdz+3)/ 0		/
	DATA cv_hi_d3  (to_pcdz+3)/ 1		/
	DATA cv_lo_d4  (to_pcdz+3)/ 0		/
	DATA cv_hi_d4  (to_pcdz+3)/ 0		/
	DATA cv_lo_d5  (to_pcdz+3)/ 0		/
	DATA cv_hi_d5  (to_pcdz+3)/ 0		/
	DATA cv_lo_d6  (to_pcdz+3)/ 0		/
	DATA cv_hi_d6  (to_pcdz+3)/ 0		/

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	DATA cv_category (to_rho0+1)/ cat_file_var	/
	DATA cv_variable (to_rho0+1)/ ptemp		/
	DATA cv_lo_d1  (to_rho0+1)/ 0		/
	DATA cv_hi_d1  (to_rho0+1)/ 0		/
	DATA cv_lo_d2  (to_rho0+1)/ 0		/
	DATA cv_hi_d2  (to_rho0+1)/ 0		/
	DATA cv_lo_d3  (to_rho0+1)/ 0		/
	DATA cv_hi_d3  (to_rho0+1)/ 0		/
	DATA cv_lo_d4  (to_rho0+1)/ 0		/
	DATA cv_hi_d4  (to_rho0+1)/ 0		/
	DATA cv_lo_d5  (to_rho0+1)/ 0		/
	DATA cv_hi_d5  (to_rho0+1)/ 0		/
	DATA cv_lo_d6  (to_rho0+1)/ 0		/
	DATA cv_hi_d6  (to_rho0+1)/ 0		/

	DATA cv_category (to_rho0+2)/ cat_file_var	/
	DATA cv_variable (to_rho0+2)/ psalt		/
	DATA cv_lo_d1  (to_rho0+2)/ 0		/
	DATA cv_hi_d1  (to_rho0+2)/ 0		/
	DATA cv_lo_d2  (to_rho0+2)/ 0		/
	DATA cv_hi_d2  (to_rho0+2)/ 0		/
	DATA cv_lo_d3  (to_rho0+2)/ 0		/
	DATA cv_hi_d3  (to_rho0+2)/ 0		/
	DATA cv_lo_d4  (to_rho0+2)/ 0		/
	DATA cv_hi_d4  (to_rho0+2)/ 0		/
	DATA cv_lo_d5  (to_rho0+2)/ 0		/
	DATA cv_hi_d5  (to_rho0+2)/ 0		/
	DATA cv_lo_d6  (to_rho0+2)/ 0		/
	DATA cv_hi_d6  (to_rho0+2)/ 0		/

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	DATA cv_category (to_qdfz+1)/ cat_file_var	/
	DATA cv_variable (to_qdfz+1)/ ptemp		/
	DATA cv_lo_d1  (to_qdfz+1)/ 0		/
	DATA cv_hi_d1  (to_qdfz+1)/ 0		/
	DATA cv_lo_d2  (to_qdfz+1)/ 0		/
	DATA cv_hi_d2  (to_qdfz+1)/ 0		/
	DATA cv_lo_d3  (to_qdfz+1)/ -1		/
	DATA cv_hi_d3  (to_qdfz+1)/ +1		/
	DATA cv_lo_d4  (to_qdfz+1)/ ptstep_1hr_b4	/
	DATA cv_hi_d4  (to_qdfz+1)/ ptstep_1hr_b4	/
	DATA cv_lo_d5  (to_qdfz+1)/ 0		/
	DATA cv_hi_d5  (to_qdfz+1)/ 0		/
	DATA cv_lo_d6  (to_qdfz+1)/ 0		/
	DATA cv_hi_d6  (to_qdfz+1)/ 0		/

	DATA cv_category (to_qdfz+2)/ cat_calc_var	/
	DATA cv_variable (to_qdfz+2)/ pqcdz		/
	DATA cv_lo_d1  (to_qdfz+2)/ 0		/
	DATA cv_hi_d1  (to_qdfz+2)/ 0		/
	DATA cv_lo_d2  (to_qdfz+2)/ 0		/
	DATA cv_hi_d2  (to_qdfz+2)/ 0		/
	DATA cv_lo_d3  (to_qdfz+2)/ -1		/
	DATA cv_hi_d3  (to_qdfz+2)/ 0		/
	DATA cv_lo_d4  (to_qdfz+2)/ ptstep_1hr_b4	/
	DATA cv_hi_d4  (to_qdfz+2)/ ptstep_1hr_b4	/
	DATA cv_lo_d5  (to_qdfz+2)/ 0		/
	DATA cv_hi_d5  (to_qdfz+2)/ 0		/
	DATA cv_lo_d6  (to_qdfz+2)/ 0		/
	DATA cv_hi_d6  (to_qdfz+2)/ 0		/

	DATA cv_category (to_qdfz+3)/ cat_calc_var	/
	DATA cv_variable (to_qdfz+3)/ pqflx		/
	DATA cv_lo_d1  (to_qdfz+3)/ 0		/
	DATA cv_hi_d1  (to_qdfz+3)/ 0		/
	DATA cv_lo_d2  (to_qdfz+3)/ 0		/
	DATA cv_hi_d2  (to_qdfz+3)/ 0		/
	DATA cv_lo_d3  (to_qdfz+3)/ 0		/
	DATA cv_hi_d3  (to_qdfz+3)/ 0		/
	DATA cv_lo_d4  (to_qdfz+3)/ ptstep_1hr_b4	/
	DATA cv_hi_d4  (to_qdfz+3)/ ptstep_1hr_b4	/
	DATA cv_lo_d5  (to_qdfz+3)/ 0		/
	DATA cv_hi_d5  (to_qdfz+3)/ 0		/
	DATA cv_lo_d6  (to_qdfz+3)/ 0		/
	DATA cv_hi_d6  (to_qdfz+3)/ 0		/

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	DATA cv_category (to_qdfh+1)/ cat_file_var	/
	DATA cv_variable (to_qdfh+1)/ ptemp		/
	DATA cv_lo_d1  (to_qdfh+1)/ -1		/
	DATA cv_hi_d1  (to_qdfh+1)/ +1		/
	DATA cv_lo_d2  (to_qdfh+1)/ -1		/
	DATA cv_hi_d2  (to_qdfh+1)/ +1		/
	DATA cv_lo_d3  (to_qdfh+1)/ 0		/
	DATA cv_hi_d3  (to_qdfh+1)/ 0		/
	DATA cv_lo_d4  (to_qdfh+1)/ ptstep_1hr_b4	/
	DATA cv_hi_d4  (to_qdfh+1)/ ptstep_1hr_b4	/
	DATA cv_lo_d5  (to_qdfh+1)/ 0		/
	DATA cv_hi_d5  (to_qdfh+1)/ 0		/
	DATA cv_lo_d6  (to_qdfh+1)/ 0		/
	DATA cv_hi_d6  (to_qdfh+1)/ 0		/

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	DATA cv_category (to_qadx+1)/ cat_file_var	/
	DATA cv_variable (to_qadx+1)/ ptemp		/
	DATA cv_lo_d1  (to_qadx+1)/ -1		/
	DATA cv_hi_d1  (to_qadx+1)/ +1		/
	DATA cv_lo_d2  (to_qadx+1)/ -1		/
	DATA cv_hi_d2  (to_qadx+1)/ 0		/
	DATA cv_lo_d3  (to_qadx+1)/ 0		/
	DATA cv_hi_d3  (to_qadx+1)/ 0		/
	DATA cv_lo_d4  (to_qadx+1)/ 0		/
	DATA cv_hi_d4  (to_qadx+1)/ 0		/
	DATA cv_lo_d5  (to_qadx+1)/ 0		/
	DATA cv_hi_d5  (to_qadx+1)/ 0		/
	DATA cv_lo_d6  (to_qadx+1)/ 0		/
	DATA cv_hi_d6  (to_qadx+1)/ 0		/

	DATA cv_category (to_qadx+2)/ cat_file_var	/
	DATA cv_variable (to_qadx+2)/ pu		/
	DATA cv_lo_d1  (to_qadx+2)/ -1		/
	DATA cv_hi_d1  (to_qadx+2)/ 0		/
	DATA cv_lo_d2  (to_qadx+2)/ -1		/
	DATA cv_hi_d2  (to_qadx+2)/ 0		/
	DATA cv_lo_d3  (to_qadx+2)/ 0		/
	DATA cv_hi_d3  (to_qadx+2)/ 0		/
	DATA cv_lo_d4  (to_qadx+2)/ 0		/
	DATA cv_hi_d4  (to_qadx+2)/ 0		/
	DATA cv_lo_d5  (to_qadx+2)/ 0		/
	DATA cv_hi_d5  (to_qadx+2)/ 0		/
	DATA cv_lo_d6  (to_qadx+2)/ 0		/
	DATA cv_hi_d6  (to_qadx+2)/ 0		/

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	DATA cv_category (to_qady+1)/ cat_file_var	/
	DATA cv_variable (to_qady+1)/ ptemp		/
	DATA cv_lo_d1  (to_qady+1)/ 0		/
	DATA cv_hi_d1  (to_qady+1)/ 0		/
	DATA cv_lo_d2  (to_qady+1)/ -1		/
	DATA cv_hi_d2  (to_qady+1)/ +1		/
	DATA cv_lo_d3  (to_qady+1)/ 0		/
	DATA cv_hi_d3  (to_qady+1)/ 0		/
	DATA cv_lo_d4  (to_qady+1)/ 0		/
	DATA cv_hi_d4  (to_qady+1)/ 0		/
	DATA cv_lo_d5  (to_qady+1)/ 0		/
	DATA cv_hi_d5  (to_qady+1)/ 0		/
	DATA cv_lo_d6  (to_qady+1)/ 0		/
	DATA cv_hi_d6  (to_qady+1)/ 0		/

	DATA cv_category (to_qady+2)/ cat_file_var	/
	DATA cv_variable (to_qady+2)/ pv		/
	DATA cv_lo_d1  (to_qady+2)/ -1		/
	DATA cv_hi_d1  (to_qady+2)/ 0		/
	DATA cv_lo_d2  (to_qady+2)/ -1		/
	DATA cv_hi_d2  (to_qady+2)/ 0		/
	DATA cv_lo_d3  (to_qady+2)/ 0		/
	DATA cv_hi_d3  (to_qady+2)/ 0		/
	DATA cv_lo_d4  (to_qady+2)/ 0		/
	DATA cv_hi_d4  (to_qady+2)/ 0		/
	DATA cv_lo_d5  (to_qady+2)/ 0		/
	DATA cv_hi_d5  (to_qady+2)/ 0		/
	DATA cv_lo_d6  (to_qady+2)/ 0		/
	DATA cv_hi_d6  (to_qady+2)/ 0		/

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	DATA cv_category (to_qadz+1)/ cat_file_var	/
	DATA cv_variable (to_qadz+1)/ ptemp		/
	DATA cv_lo_d1  (to_qadz+1)/ 0		/
	DATA cv_hi_d1  (to_qadz+1)/ 0		/
	DATA cv_lo_d2  (to_qadz+1)/ 0		/
	DATA cv_hi_d2  (to_qadz+1)/ 0		/
	DATA cv_lo_d3  (to_qadz+1)/ -1		/
	DATA cv_hi_d3  (to_qadz+1)/ +1		/
	DATA cv_lo_d4  (to_qadz+1)/ 0		/
	DATA cv_hi_d4  (to_qadz+1)/ 0		/
	DATA cv_lo_d5  (to_qadz+1)/ 0		/
	DATA cv_hi_d5  (to_qadz+1)/ 0		/
	DATA cv_lo_d6  (to_qadz+1)/ 0		/
	DATA cv_hi_d6  (to_qadz+1)/ 0		/

	DATA cv_category (to_qadz+2)/ cat_file_var	/
	DATA cv_variable (to_qadz+2)/ pw		/
	DATA cv_lo_d1  (to_qadz+2)/ 0		/
	DATA cv_hi_d1  (to_qadz+2)/ 0		/
	DATA cv_lo_d2  (to_qadz+2)/ 0		/
	DATA cv_hi_d2  (to_qadz+2)/ 0		/
	DATA cv_lo_d3  (to_qadz+2)/ -1		/
	DATA cv_hi_d3  (to_qadz+2)/ 0		/
	DATA cv_lo_d4  (to_qadz+2)/ 0		/
	DATA cv_hi_d4  (to_qadz+2)/ 0		/
	DATA cv_lo_d5  (to_qadz+2)/ 0		/
	DATA cv_hi_d5  (to_qadz+2)/ 0		/
	DATA cv_lo_d6  (to_qadz+2)/ 0		/
	DATA cv_hi_d6  (to_qadz+2)/ 0		/

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	DATA cv_category (to_qad +1)/ cat_calc_var	/
	DATA cv_variable (to_qad +1)/ pqadx		/
	DATA cv_lo_d1  (to_qad +1)/ 0		/
	DATA cv_hi_d1  (to_qad +1)/ 0		/
	DATA cv_lo_d2  (to_qad +1)/ 0		/
	DATA cv_hi_d2  (to_qad +1)/ 0		/
	DATA cv_lo_d3  (to_qad +1)/ 0		/
	DATA cv_hi_d3  (to_qad +1)/ 0		/
	DATA cv_lo_d4  (to_qad +1)/ 0		/
	DATA cv_hi_d4  (to_qad +1)/ 0		/
	DATA cv_lo_d5  (to_qad +1)/ 0		/
	DATA cv_hi_d5  (to_qad +1)/ 0		/
	DATA cv_lo_d6  (to_qad +1)/ 0		/
	DATA cv_hi_d6  (to_qad +1)/ 0		/

	DATA cv_category (to_qad +2)/ cat_calc_var	/
	DATA cv_variable (to_qad +2)/ pqady		/
	DATA cv_lo_d1  (to_qad +2)/ 0		/
	DATA cv_hi_d1  (to_qad +2)/ 0		/
	DATA cv_lo_d2  (to_qad +2)/ 0		/
	DATA cv_hi_d2  (to_qad +2)/ 0		/
	DATA cv_lo_d3  (to_qad +2)/ 0		/
	DATA cv_hi_d3  (to_qad +2)/ 0		/
	DATA cv_lo_d4  (to_qad +2)/ 0		/
	DATA cv_hi_d4  (to_qad +2)/ 0		/
	DATA cv_lo_d5  (to_qad +2)/ 0		/
	DATA cv_hi_d5  (to_qad +2)/ 0		/
	DATA cv_lo_d6  (to_qad +2)/ 0		/
	DATA cv_hi_d6  (to_qad +2)/ 0		/

	DATA cv_category (to_qad +3)/ cat_calc_var	/
	DATA cv_variable (to_qad +3)/ pqadz		/
	DATA cv_lo_d1  (to_qad +3)/ 0		/
	DATA cv_hi_d1  (to_qad +3)/ 0		/
	DATA cv_lo_d2  (to_qad +3)/ 0		/
	DATA cv_hi_d2  (to_qad +3)/ 0		/
	DATA cv_lo_d3  (to_qad +3)/ 0		/
	DATA cv_hi_d3  (to_qad +3)/ 0		/
	DATA cv_lo_d4  (to_qad +3)/ 0		/
	DATA cv_hi_d4  (to_qad +3)/ 0		/
	DATA cv_lo_d5  (to_qad +3)/ 0		/
	DATA cv_hi_d5  (to_qad +3)/ 0		/
	DATA cv_lo_d6  (to_qad +3)/ 0		/
	DATA cv_hi_d6  (to_qad +3)/ 0		/

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	DATA cv_category (to_qdf +1)/ cat_calc_var	/
	DATA cv_variable (to_qdf +1)/ pqdfh		/
	DATA cv_lo_d1  (to_qdf +1)/ 0		/
	DATA cv_hi_d1  (to_qdf +1)/ 0		/
	DATA cv_lo_d2  (to_qdf +1)/ 0		/
	DATA cv_hi_d2  (to_qdf +1)/ 0		/
	DATA cv_lo_d3  (to_qdf +1)/ 0		/
	DATA cv_hi_d3  (to_qdf +1)/ 0		/
	DATA cv_lo_d4  (to_qdf +1)/ 0		/
	DATA cv_hi_d4  (to_qdf +1)/ 0		/
	DATA cv_lo_d5  (to_qdf +1)/ 0		/
	DATA cv_hi_d5  (to_qdf +1)/ 0		/
	DATA cv_lo_d6  (to_qdf +1)/ 0		/
	DATA cv_hi_d6  (to_qdf +1)/ 0		/

	DATA cv_category (to_qdf +2)/ cat_calc_var	/
	DATA cv_variable (to_qdf +2)/ pqdfz		/
	DATA cv_lo_d1  (to_qdf +2)/ 0		/
	DATA cv_hi_d1  (to_qdf +2)/ 0		/
	DATA cv_lo_d2  (to_qdf +2)/ 0		/
	DATA cv_hi_d2  (to_qdf +2)/ 0		/
	DATA cv_lo_d3  (to_qdf +2)/ 0		/
	DATA cv_hi_d3  (to_qdf +2)/ 0		/
	DATA cv_lo_d4  (to_qdf +2)/ 0		/
	DATA cv_hi_d4  (to_qdf +2)/ 0		/
	DATA cv_lo_d5  (to_qdf +2)/ 0		/
	DATA cv_hi_d5  (to_qdf +2)/ 0		/
	DATA cv_lo_d6  (to_qdf +2)/ 0		/
	DATA cv_hi_d6  (to_qdf +2)/ 0		/

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	DATA cv_category (to_qeva+1)/ cat_calc_var	/
	DATA cv_variable (to_qeva+1)/ ptau		/
	DATA cv_lo_d1  (to_qeva+1)/ 0		/
	DATA cv_hi_d1  (to_qeva+1)/ 0		/
	DATA cv_lo_d2  (to_qeva+1)/ 0		/
	DATA cv_hi_d2  (to_qeva+1)/ 0		/
	DATA cv_lo_d3  (to_qeva+1)/ 0		/
	DATA cv_hi_d3  (to_qeva+1)/ 0		/
	DATA cv_lo_d4  (to_qeva+1)/ 0		/
	DATA cv_hi_d4  (to_qeva+1)/ 0		/
	DATA cv_lo_d5  (to_qeva+1)/ 0		/
	DATA cv_hi_d5  (to_qeva+1)/ 0		/
	DATA cv_lo_d6  (to_qeva+1)/ 0		/
	DATA cv_hi_d6  (to_qeva+1)/ 0		/

	DATA cv_category (to_qeva+2)/ cat_file_var	/
	DATA cv_variable (to_qeva+2)/ ptemp 		/
	DATA cv_lo_d1  (to_qeva+2)/ 0		/
	DATA cv_hi_d1  (to_qeva+2)/ 0		/
	DATA cv_lo_d2  (to_qeva+2)/ 0		/
	DATA cv_hi_d2  (to_qeva+2)/ 0		/
	DATA cv_lo_d3  (to_qeva+2)/ 0		/
	DATA cv_hi_d3  (to_qeva+2)/ 0		/
	DATA cv_lo_d4  (to_qeva+2)/ 0		/
	DATA cv_hi_d4  (to_qeva+2)/ 0		/
	DATA cv_lo_d5  (to_qeva+2)/ 0		/
	DATA cv_hi_d5  (to_qeva+2)/ 0		/
	DATA cv_lo_d6  (to_qeva+2)/ 0		/
	DATA cv_hi_d6  (to_qeva+2)/ 0		/

	DATA cv_category (to_qeva+3)/ cat_calc_var	/
	DATA cv_variable (to_qeva+3)/ pair		/
	DATA cv_lo_d1  (to_qeva+3)/ 0		/
	DATA cv_hi_d1  (to_qeva+3)/ 0		/
	DATA cv_lo_d2  (to_qeva+3)/ 0		/
	DATA cv_hi_d2  (to_qeva+3)/ 0		/
	DATA cv_lo_d3  (to_qeva+3)/ 0		/
	DATA cv_hi_d3  (to_qeva+3)/ 0		/
	DATA cv_lo_d4  (to_qeva+3)/ 0		/
	DATA cv_hi_d4  (to_qeva+3)/ 0		/
	DATA cv_lo_d5  (to_qeva+3)/ 0		/
	DATA cv_hi_d5  (to_qeva+3)/ 0		/
	DATA cv_lo_d6  (to_qeva+3)/ 0		/
	DATA cv_hi_d6  (to_qeva+3)/ 0		/

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	DATA cv_category (to_tau +1)/ cat_file_var	/
	DATA cv_variable (to_tau +1)/ ptaux		/
	DATA cv_lo_d1  (to_tau +1)/ -1		/
	DATA cv_hi_d1  (to_tau +1)/ 0		/
	DATA cv_lo_d2  (to_tau +1)/ -1		/
	DATA cv_hi_d2  (to_tau +1)/ 0		/
	DATA cv_lo_d3  (to_tau +1)/ 0		/
	DATA cv_hi_d3  (to_tau +1)/ 0		/
	DATA cv_lo_d4  (to_tau +1)/ 0		/
	DATA cv_hi_d4  (to_tau +1)/ 0		/
	DATA cv_lo_d5  (to_tau +1)/ 0		/
	DATA cv_hi_d5  (to_tau +1)/ 0		/
	DATA cv_lo_d6  (to_tau +1)/ 0		/
	DATA cv_hi_d6  (to_tau +1)/ 0		/

	DATA cv_category (to_tau +2)/ cat_file_var	/
	DATA cv_variable (to_tau +2)/ ptauy		/
	DATA cv_lo_d1  (to_tau +2)/ -1		/
	DATA cv_hi_d1  (to_tau +2)/ 0		/
	DATA cv_lo_d2  (to_tau +2)/ -1		/
	DATA cv_hi_d2  (to_tau +2)/ 0		/
	DATA cv_lo_d3  (to_tau +2)/ 0		/
	DATA cv_hi_d3  (to_tau +2)/ 0		/
	DATA cv_lo_d4  (to_tau +2)/ 0		/
	DATA cv_hi_d4  (to_tau +2)/ 0		/
	DATA cv_lo_d5  (to_tau +2)/ 0		/
	DATA cv_hi_d5  (to_tau +2)/ 0		/
	DATA cv_lo_d6  (to_tau +2)/ 0		/
	DATA cv_hi_d6  (to_tau +2)/ 0		/

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	DATA cv_category (to_qsen+1)/ cat_calc_var	/
	DATA cv_variable (to_qsen+1)/ ptau 		/
	DATA cv_lo_d1  (to_qsen+1)/ 0		/
	DATA cv_hi_d1  (to_qsen+1)/ 0		/
	DATA cv_lo_d2  (to_qsen+1)/ 0		/
	DATA cv_hi_d2  (to_qsen+1)/ 0		/
	DATA cv_lo_d3  (to_qsen+1)/ 0		/
	DATA cv_hi_d3  (to_qsen+1)/ 0		/
	DATA cv_lo_d4  (to_qsen+1)/ 0		/
	DATA cv_hi_d4  (to_qsen+1)/ 0		/
	DATA cv_lo_d5  (to_qsen+1)/ 0		/
	DATA cv_hi_d5  (to_qsen+1)/ 0		/
	DATA cv_lo_d6  (to_qsen+1)/ 0		/
	DATA cv_hi_d6  (to_qsen+1)/ 0		/

	DATA cv_category (to_qsen+2)/ cat_file_var	/
	DATA cv_variable (to_qsen+2)/ ptemp		/
	DATA cv_lo_d1  (to_qsen+2)/ 0		/
	DATA cv_hi_d1  (to_qsen+2)/ 0		/
	DATA cv_lo_d2  (to_qsen+2)/ 0		/
	DATA cv_hi_d2  (to_qsen+2)/ 0		/
	DATA cv_lo_d3  (to_qsen+2)/ 0		/
	DATA cv_hi_d3  (to_qsen+2)/ 0		/
	DATA cv_lo_d4  (to_qsen+2)/ 0		/
	DATA cv_hi_d4  (to_qsen+2)/ 0		/
	DATA cv_lo_d5  (to_qsen+2)/ 0		/
	DATA cv_hi_d5  (to_qsen+2)/ 0		/
	DATA cv_lo_d6  (to_qsen+2)/ 0		/
	DATA cv_hi_d6  (to_qsen+2)/ 0		/

	DATA cv_category (to_qsen+3)/ cat_calc_var	/
	DATA cv_variable (to_qsen+3)/ pair		/
	DATA cv_lo_d1  (to_qsen+3)/ 0		/
	DATA cv_hi_d1  (to_qsen+3)/ 0		/
	DATA cv_lo_d2  (to_qsen+3)/ 0		/
	DATA cv_hi_d2  (to_qsen+3)/ 0		/
	DATA cv_lo_d3  (to_qsen+3)/ 0		/
	DATA cv_hi_d3  (to_qsen+3)/ 0		/
	DATA cv_lo_d4  (to_qsen+3)/ 0		/
	DATA cv_hi_d4  (to_qsen+3)/ 0		/
	DATA cv_lo_d5  (to_qsen+3)/ 0		/
	DATA cv_hi_d5  (to_qsen+3)/ 0		/
	DATA cv_lo_d6  (to_qsen+3)/ 0		/
	DATA cv_hi_d6  (to_qsen+3)/ 0		/

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	DATA cv_category (to_qrad+1)/ cat_file_var	/
	DATA cv_variable (to_qrad+1)/ ptemp_special	/
	DATA cv_lo_d1  (to_qrad+1)/ 0		/
	DATA cv_hi_d1  (to_qrad+1)/ 0		/
	DATA cv_lo_d2  (to_qrad+1)/ 0		/
	DATA cv_hi_d2  (to_qrad+1)/ 0		/
	DATA cv_lo_d3  (to_qrad+1)/ 0		/	! SST
	DATA cv_hi_d3  (to_qrad+1)/ 0		/	! SST
	DATA cv_lo_d4  (to_qrad+1)/ 0		/
	DATA cv_hi_d4  (to_qrad+1)/ 0		/
	DATA cv_lo_d5  (to_qrad+1)/ 0		/
	DATA cv_hi_d5  (to_qrad+1)/ 0		/
	DATA cv_lo_d6  (to_qrad+1)/ 0		/
	DATA cv_hi_d6  (to_qrad+1)/ 0		/

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	DATA cv_category (to_qflx+1)/ cat_calc_var	/
	DATA cv_variable (to_qflx+1)/ pqeva		/
	DATA cv_lo_d1  (to_qflx+1)/ 0		/
	DATA cv_hi_d1  (to_qflx+1)/ 0		/
	DATA cv_lo_d2  (to_qflx+1)/ 0		/
	DATA cv_hi_d2  (to_qflx+1)/ 0		/
	DATA cv_lo_d3  (to_qflx+1)/ 0		/
	DATA cv_hi_d3  (to_qflx+1)/ 0		/
	DATA cv_lo_d4  (to_qflx+1)/ 0		/
	DATA cv_hi_d4  (to_qflx+1)/ 0		/
	DATA cv_lo_d5  (to_qflx+1)/ 0		/
	DATA cv_hi_d5  (to_qflx+1)/ 0		/
	DATA cv_lo_d6  (to_qflx+1)/ 0		/
	DATA cv_hi_d6  (to_qflx+1)/ 0		/

	DATA cv_category (to_qflx+2)/ cat_calc_var	/
	DATA cv_variable (to_qflx+2)/ pqsen		/
	DATA cv_lo_d1  (to_qflx+2)/ 0		/
	DATA cv_hi_d1  (to_qflx+2)/ 0		/
	DATA cv_lo_d2  (to_qflx+2)/ 0		/
	DATA cv_hi_d2  (to_qflx+2)/ 0		/
	DATA cv_lo_d3  (to_qflx+2)/ 0		/
	DATA cv_hi_d3  (to_qflx+2)/ 0		/
	DATA cv_lo_d4  (to_qflx+2)/ 0		/
	DATA cv_hi_d4  (to_qflx+2)/ 0		/
	DATA cv_lo_d5  (to_qflx+2)/ 0		/
	DATA cv_hi_d5  (to_qflx+2)/ 0		/
	DATA cv_lo_d6  (to_qflx+2)/ 0		/
	DATA cv_hi_d6  (to_qflx+2)/ 0		/

	DATA cv_category (to_qflx+3)/ cat_calc_var	/
	DATA cv_variable (to_qflx+3)/ pqrad		/
	DATA cv_lo_d1  (to_qflx+3)/ 0		/
	DATA cv_hi_d1  (to_qflx+3)/ 0		/
	DATA cv_lo_d2  (to_qflx+3)/ 0		/
	DATA cv_hi_d2  (to_qflx+3)/ 0		/
	DATA cv_lo_d3  (to_qflx+3)/ 0		/
	DATA cv_hi_d3  (to_qflx+3)/ 0		/
	DATA cv_lo_d4  (to_qflx+3)/ 0		/
	DATA cv_hi_d4  (to_qflx+3)/ 0		/
	DATA cv_lo_d5  (to_qflx+3)/ 0		/
	DATA cv_hi_d5  (to_qflx+3)/ 0		/
	DATA cv_lo_d6  (to_qflx+3)/ 0		/
	DATA cv_hi_d6  (to_qflx+3)/ 0		/

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	DATA cv_category (to_rho +1)/ cat_file_var	/
	DATA cv_variable (to_rho +1)/ ptemp		/
	DATA cv_lo_d1  (to_rho +1)/ 0		/
	DATA cv_hi_d1  (to_rho +1)/ 0		/
	DATA cv_lo_d2  (to_rho +1)/ 0		/
	DATA cv_hi_d2  (to_rho +1)/ 0		/
	DATA cv_lo_d3  (to_rho +1)/ 0		/
	DATA cv_hi_d3  (to_rho +1)/ 0		/
	DATA cv_lo_d4  (to_rho +1)/ 0		/
	DATA cv_hi_d4  (to_rho +1)/ 0		/
	DATA cv_lo_d5  (to_rho +1)/ 0		/
	DATA cv_hi_d5  (to_rho +1)/ 0		/
	DATA cv_lo_d6  (to_rho +1)/ 0		/
	DATA cv_hi_d6  (to_rho +1)/ 0		/

	DATA cv_category (to_rho +2)/ cat_file_var	/
	DATA cv_variable (to_rho +2)/ psalt		/
	DATA cv_lo_d1  (to_rho +2)/ 0		/
	DATA cv_hi_d1  (to_rho +2)/ 0		/
	DATA cv_lo_d2  (to_rho +2)/ 0		/
	DATA cv_hi_d2  (to_rho +2)/ 0		/
	DATA cv_lo_d3  (to_rho +2)/ 0		/
	DATA cv_hi_d3  (to_rho +2)/ 0		/
	DATA cv_lo_d4  (to_rho +2)/ 0		/
	DATA cv_hi_d4  (to_rho +2)/ 0		/
	DATA cv_lo_d5  (to_rho +2)/ 0		/
	DATA cv_hi_d5  (to_rho +2)/ 0		/
	DATA cv_lo_d6  (to_rho +2)/ 0		/
	DATA cv_hi_d6  (to_rho +2)/ 0		/

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	DATA cv_category (to_dpdx+1)/ cat_calc_var	/
	DATA cv_variable (to_dpdx+1)/ prho		/
	DATA cv_lo_d1  (to_dpdx+1)/ 0		/
	DATA cv_hi_d1  (to_dpdx+1)/ +1		/
	DATA cv_lo_d2  (to_dpdx+1)/ 0		/
	DATA cv_hi_d2  (to_dpdx+1)/ +1		/
	DATA cv_lo_d3  (to_dpdx+1)/ 0		/	! needs k=1 absolute
	DATA cv_hi_d3  (to_dpdx+1)/ 0		/
	DATA cv_lo_d4  (to_dpdx+1)/ 0		/
	DATA cv_hi_d4  (to_dpdx+1)/ 0		/
	DATA cv_lo_d5  (to_dpdx+1)/ 0		/
	DATA cv_hi_d5  (to_dpdx+1)/ 0		/
	DATA cv_lo_d6  (to_dpdx+1)/ 0		/
	DATA cv_hi_d6  (to_dpdx+1)/ 0		/

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	DATA cv_category (to_dpdy+1)/ cat_calc_var	/
	DATA cv_variable (to_dpdy+1)/ prho		/
	DATA cv_lo_d1  (to_dpdy+1)/ 0		/
	DATA cv_hi_d1  (to_dpdy+1)/ +1		/
	DATA cv_lo_d2  (to_dpdy+1)/ 0		/
	DATA cv_hi_d2  (to_dpdy+1)/ +1		/
	DATA cv_lo_d3  (to_dpdy+1)/ 0		/	! needs k=1 absolute
	DATA cv_hi_d3  (to_dpdy+1)/ 0		/
	DATA cv_lo_d4  (to_dpdy+1)/ 0		/
	DATA cv_hi_d4  (to_dpdy+1)/ 0		/
	DATA cv_lo_d5  (to_dpdy+1)/ 0		/
	DATA cv_hi_d5  (to_dpdy+1)/ 0		/
	DATA cv_lo_d6  (to_dpdy+1)/ 0		/
	DATA cv_hi_d6  (to_dpdy+1)/ 0		/

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	DATA cv_category (to_w_u +1)/ cat_calc_var	/
	DATA cv_variable (to_w_u +1)/ pfuw		/
	DATA cv_lo_d1  (to_w_u +1)/ 0		/
	DATA cv_hi_d1  (to_w_u +1)/ +1		/
	DATA cv_lo_d2  (to_w_u +1)/ 0		/
	DATA cv_hi_d2  (to_w_u +1)/ 0		/
	DATA cv_lo_d3  (to_w_u +1)/ 0		/
	DATA cv_hi_d3  (to_w_u +1)/ 0		/
	DATA cv_lo_d4  (to_w_u +1)/ 0		/
	DATA cv_hi_d4  (to_w_u +1)/ 0		/
	DATA cv_lo_d5  (to_w_u +1)/ 0		/
	DATA cv_hi_d5  (to_w_u +1)/ 0		/
	DATA cv_lo_d6  (to_w_u +1)/ 0		/
	DATA cv_hi_d6  (to_w_u +1)/ 0		/

	DATA cv_category (to_w_u +2)/ cat_calc_var	/
	DATA cv_variable (to_w_u +2)/ pfvn		/
	DATA cv_lo_d1  (to_w_u +2)/ 0		/
	DATA cv_hi_d1  (to_w_u +2)/ 0		/
	DATA cv_lo_d2  (to_w_u +2)/ -1		/
	DATA cv_hi_d2  (to_w_u +2)/ 0		/
	DATA cv_lo_d3  (to_w_u +2)/ 0		/
	DATA cv_hi_d3  (to_w_u +2)/ 0		/
	DATA cv_lo_d4  (to_w_u +2)/ 0		/
	DATA cv_hi_d4  (to_w_u +2)/ 0		/
	DATA cv_lo_d5  (to_w_u +2)/ 0		/
	DATA cv_hi_d5  (to_w_u +2)/ 0		/
	DATA cv_lo_d6  (to_w_u +2)/ 0		/
	DATA cv_hi_d6  (to_w_u +2)/ 0		/

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	DATA cv_category (to_uavz+1)/ cat_file_var	/
	DATA cv_variable (to_uavz+1)/ ppsi		/
	DATA cv_lo_d1  (to_uavz+1)/ 0		/
	DATA cv_hi_d1  (to_uavz+1)/ +1		/
	DATA cv_lo_d2  (to_uavz+1)/ 0		/
	DATA cv_hi_d2  (to_uavz+1)/ +1		/
	DATA cv_lo_d3  (to_uavz+1)/ 0		/
	DATA cv_hi_d3  (to_uavz+1)/ 0		/
	DATA cv_lo_d4  (to_uavz+1)/ 0		/
	DATA cv_hi_d4  (to_uavz+1)/ 0		/
	DATA cv_lo_d5  (to_uavz+1)/ 0		/
	DATA cv_hi_d5  (to_uavz+1)/ 0		/
	DATA cv_lo_d6  (to_uavz+1)/ 0		/
	DATA cv_hi_d6  (to_uavz+1)/ 0		/

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	DATA cv_category (to_vavz+1)/ cat_file_var	/
	DATA cv_variable (to_vavz+1)/ ppsi		/
	DATA cv_lo_d1  (to_vavz+1)/ 0		/
	DATA cv_hi_d1  (to_vavz+1)/ +1		/
	DATA cv_lo_d2  (to_vavz+1)/ 0		/
	DATA cv_hi_d2  (to_vavz+1)/ +1		/
	DATA cv_lo_d3  (to_vavz+1)/ 0		/
	DATA cv_hi_d3  (to_vavz+1)/ 0		/
	DATA cv_lo_d4  (to_vavz+1)/ 0		/
	DATA cv_hi_d4  (to_vavz+1)/ 0		/
	DATA cv_lo_d5  (to_vavz+1)/ 0		/
	DATA cv_hi_d5  (to_vavz+1)/ 0		/
	DATA cv_lo_d6  (to_vavz+1)/ 0		/
	DATA cv_hi_d6  (to_vavz+1)/ 0		/

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	DATA cv_category (to_fuw +1)/ cat_file_var	/
	DATA cv_variable (to_fuw +1)/ ppsi		/
	DATA cv_lo_d1  (to_fuw +1)/ -1		/	! extra for UAVZ
	DATA cv_hi_d1  (to_fuw +1)/ +1		/	! extra for UAVZ
	DATA cv_lo_d2  (to_fuw +1)/ 0		/
	DATA cv_hi_d2  (to_fuw +1)/ +1		/
	DATA cv_lo_d3  (to_fuw +1)/ 0		/
	DATA cv_hi_d3  (to_fuw +1)/ 0		/
	DATA cv_lo_d4  (to_fuw +1)/ 0		/
	DATA cv_hi_d4  (to_fuw +1)/ 0		/
	DATA cv_lo_d5  (to_fuw +1)/ 0		/
	DATA cv_hi_d5  (to_fuw +1)/ 0		/
	DATA cv_lo_d6  (to_fuw +1)/ 0		/
	DATA cv_hi_d6  (to_fuw +1)/ 0		/

	DATA cv_category (to_fuw +2)/ cat_calc_var	/
	DATA cv_variable (to_fuw +2)/ puavz		/
	DATA cv_lo_d1  (to_fuw +2)/ -1		/
	DATA cv_hi_d1  (to_fuw +2)/ 0		/
	DATA cv_lo_d2  (to_fuw +2)/ 0		/
	DATA cv_hi_d2  (to_fuw +2)/ 0		/
	DATA cv_lo_d3  (to_fuw +2)/ 0		/
	DATA cv_hi_d3  (to_fuw +2)/ 0		/
	DATA cv_lo_d4  (to_fuw +2)/ 0		/
	DATA cv_hi_d4  (to_fuw +2)/ 0		/
	DATA cv_lo_d5  (to_fuw +2)/ 0		/
	DATA cv_hi_d5  (to_fuw +2)/ 0		/
	DATA cv_lo_d6  (to_fuw +2)/ 0		/
	DATA cv_hi_d6  (to_fuw +2)/ 0		/

	DATA cv_category (to_fuw +3)/ cat_file_var	/
	DATA cv_variable (to_fuw +3)/ pu		/
	DATA cv_lo_d1  (to_fuw +3)/ -1		/
	DATA cv_hi_d1  (to_fuw +3)/ 0		/
	DATA cv_lo_d2  (to_fuw +3)/ 0		/
	DATA cv_hi_d2  (to_fuw +3)/ 0		/
	DATA cv_lo_d3  (to_fuw +3)/ 0		/
	DATA cv_hi_d3  (to_fuw +3)/ 0		/
	DATA cv_lo_d4  (to_fuw +3)/ 0		/
	DATA cv_hi_d4  (to_fuw +3)/ 0		/
	DATA cv_lo_d5  (to_fuw +3)/ 0		/
	DATA cv_hi_d5  (to_fuw +3)/ 0		/
	DATA cv_lo_d6  (to_fuw +3)/ 0		/
	DATA cv_hi_d6  (to_fuw +3)/ 0		/

***************************************************************************

	DATA cv_category (to_fvn +1)/ cat_file_var	/
	DATA cv_variable (to_fvn +1)/ ppsi		/
	DATA cv_lo_d1  (to_fvn +1)/ 0		/
	DATA cv_hi_d1  (to_fvn +1)/ +1		/
	DATA cv_lo_d2  (to_fvn +1)/ 0		/	! extra for VAVZ
	DATA cv_hi_d2  (to_fvn +1)/ +2		/	! extra for VAVZ
	DATA cv_lo_d3  (to_fvn +1)/ 0		/
	DATA cv_hi_d3  (to_fvn +1)/ 0		/
	DATA cv_lo_d4  (to_fvn +1)/ 0		/
	DATA cv_hi_d4  (to_fvn +1)/ 0		/
	DATA cv_lo_d5  (to_fvn +1)/ 0		/
	DATA cv_hi_d5  (to_fvn +1)/ 0		/
	DATA cv_lo_d6  (to_fvn +1)/ 0		/
	DATA cv_hi_d6  (to_fvn +1)/ 0		/

	DATA cv_category (to_fvn +2)/ cat_calc_var	/
	DATA cv_variable (to_fvn +2)/ pvavz		/
	DATA cv_lo_d1  (to_fvn +2)/ 0		/
	DATA cv_hi_d1  (to_fvn +2)/ 0		/
	DATA cv_lo_d2  (to_fvn +2)/ 0		/
	DATA cv_hi_d2  (to_fvn +2)/ +1		/
	DATA cv_lo_d3  (to_fvn +2)/ 0		/
	DATA cv_hi_d3  (to_fvn +2)/ 0		/
	DATA cv_lo_d4  (to_fvn +2)/ 0		/
	DATA cv_hi_d4  (to_fvn +2)/ 0		/
	DATA cv_lo_d5  (to_fvn +2)/ 0		/
	DATA cv_hi_d5  (to_fvn +2)/ 0		/
	DATA cv_lo_d6  (to_fvn +2)/ 0		/
	DATA cv_hi_d6  (to_fvn +2)/ 0		/

	DATA cv_category (to_fvn +3)/ cat_file_var	/
	DATA cv_variable (to_fvn +3)/ pv		/
	DATA cv_lo_d1  (to_fvn +3)/ 0		/
	DATA cv_hi_d1  (to_fvn +3)/ 0		/
	DATA cv_lo_d2  (to_fvn +3)/ 0		/
	DATA cv_hi_d2  (to_fvn +3)/ +1		/
	DATA cv_lo_d3  (to_fvn +3)/ 0		/
	DATA cv_hi_d3  (to_fvn +3)/ 0		/
	DATA cv_lo_d4  (to_fvn +3)/ 0		/
	DATA cv_hi_d4  (to_fvn +3)/ 0		/
	DATA cv_lo_d5  (to_fvn +3)/ 0		/
	DATA cv_hi_d5  (to_fvn +3)/ 0		/
	DATA cv_lo_d6  (to_fvn +3)/ 0		/
	DATA cv_hi_d6  (to_fvn +3)/ 0		/

*****************************************************************************

	DATA cv_category (to_uadx+1)/ cat_calc_var	/
	DATA cv_variable (to_uadx+1)/ pfuw		/
	DATA cv_lo_d1  (to_uadx+1)/ 0		/
	DATA cv_hi_d1  (to_uadx+1)/ +1		/
	DATA cv_lo_d2  (to_uadx+1)/ 0		/
	DATA cv_hi_d2  (to_uadx+1)/ 0		/
	DATA cv_lo_d3  (to_uadx+1)/ 0		/
	DATA cv_hi_d3  (to_uadx+1)/ 0		/
	DATA cv_lo_d4  (to_uadx+1)/ 0		/
	DATA cv_hi_d4  (to_uadx+1)/ 0		/
	DATA cv_lo_d5  (to_uadx+1)/ 0		/
	DATA cv_hi_d5  (to_uadx+1)/ 0		/
	DATA cv_lo_d6  (to_uadx+1)/ 0		/
	DATA cv_hi_d6  (to_uadx+1)/ 0		/

	DATA cv_category (to_uadx+2)/ cat_file_var	/
	DATA cv_variable (to_uadx+2)/ pu		/
	DATA cv_lo_d1  (to_uadx+2)/ -1		/
	DATA cv_hi_d1  (to_uadx+2)/ +1		/
	DATA cv_lo_d2  (to_uadx+2)/ 0		/
	DATA cv_hi_d2  (to_uadx+2)/ 0		/
	DATA cv_lo_d3  (to_uadx+2)/ 0		/
	DATA cv_hi_d3  (to_uadx+2)/ 0		/
	DATA cv_lo_d4  (to_uadx+2)/ 0		/
	DATA cv_hi_d4  (to_uadx+2)/ 0		/
	DATA cv_lo_d5  (to_uadx+2)/ 0		/
	DATA cv_hi_d5  (to_uadx+2)/ 0		/
	DATA cv_lo_d6  (to_uadx+2)/ 0		/
	DATA cv_hi_d6  (to_uadx+2)/ 0		/

*****************************************************************************

	DATA cv_category (to_uady+1)/ cat_calc_var	/
	DATA cv_variable (to_uady+1)/ pfvn		/
	DATA cv_lo_d1  (to_uady+1)/ 0		/
	DATA cv_hi_d1  (to_uady+1)/ 0		/
	DATA cv_lo_d2  (to_uady+1)/ -1		/
	DATA cv_hi_d2  (to_uady+1)/ 0		/
	DATA cv_lo_d3  (to_uady+1)/ 0		/
	DATA cv_hi_d3  (to_uady+1)/ 0		/
	DATA cv_lo_d4  (to_uady+1)/ 0		/
	DATA cv_hi_d4  (to_uady+1)/ 0		/
	DATA cv_lo_d5  (to_uady+1)/ 0		/
	DATA cv_hi_d5  (to_uady+1)/ 0		/
	DATA cv_lo_d6  (to_uady+1)/ 0		/
	DATA cv_hi_d6  (to_uady+1)/ 0		/

	DATA cv_category (to_uady+2)/ cat_file_var	/
	DATA cv_variable (to_uady+2)/ pu		/
	DATA cv_lo_d1  (to_uady+2)/ 0		/
	DATA cv_hi_d1  (to_uady+2)/ 0		/
	DATA cv_lo_d2  (to_uady+2)/ -1		/
	DATA cv_hi_d2  (to_uady+2)/ +1		/
	DATA cv_lo_d3  (to_uady+2)/ 0		/
	DATA cv_hi_d3  (to_uady+2)/ 0		/
	DATA cv_lo_d4  (to_uady+2)/ 0		/
	DATA cv_hi_d4  (to_uady+2)/ 0		/
	DATA cv_lo_d5  (to_uady+2)/ 0		/
	DATA cv_hi_d5  (to_uady+2)/ 0		/
	DATA cv_lo_d6  (to_uady+2)/ 0		/
	DATA cv_hi_d6  (to_uady+2)/ 0		/

*****************************************************************************

	DATA cv_category (to_uadz+1)/ cat_file_var	/
	DATA cv_variable (to_uadz+1)/ pu		/
	DATA cv_lo_d1  (to_uadz+1)/ 0		/
	DATA cv_hi_d1  (to_uadz+1)/ 0		/
	DATA cv_lo_d2  (to_uadz+1)/ 0		/
	DATA cv_hi_d2  (to_uadz+1)/ 0		/
	DATA cv_lo_d3  (to_uadz+1)/ -1		/
	DATA cv_hi_d3  (to_uadz+1)/ +1		/
	DATA cv_lo_d4  (to_uadz+1)/ 0		/
	DATA cv_hi_d4  (to_uadz+1)/ 0		/
	DATA cv_lo_d5  (to_uadz+1)/ 0		/
	DATA cv_hi_d5  (to_uadz+1)/ 0		/
	DATA cv_lo_d6  (to_uadz+1)/ 0		/
	DATA cv_hi_d6  (to_uadz+1)/ 0		/

	DATA cv_category (to_uadz+2)/ cat_calc_var	/
	DATA cv_variable (to_uadz+2)/ pw_u		/
	DATA cv_lo_d1  (to_uadz+2)/ 0		/
	DATA cv_hi_d1  (to_uadz+2)/ 0		/
	DATA cv_lo_d2  (to_uadz+2)/ 0		/
	DATA cv_hi_d2  (to_uadz+2)/ 0		/
	DATA cv_lo_d3  (to_uadz+2)/ -1		/
	DATA cv_hi_d3  (to_uadz+2)/ 0		/
	DATA cv_lo_d4  (to_uadz+2)/ 0		/
	DATA cv_hi_d4  (to_uadz+2)/ 0		/
	DATA cv_lo_d5  (to_uadz+2)/ 0		/
	DATA cv_hi_d5  (to_uadz+2)/ 0		/
	DATA cv_lo_d6  (to_uadz+2)/ 0		/
	DATA cv_hi_d6  (to_uadz+2)/ 0		/

**************************************************************************

	DATA cv_category (to_vadx+1)/ cat_calc_var	/
	DATA cv_variable (to_vadx+1)/ pfuw		/
	DATA cv_lo_d1  (to_vadx+1)/ 0		/
	DATA cv_hi_d1  (to_vadx+1)/ +1		/
	DATA cv_lo_d2  (to_vadx+1)/ 0		/
	DATA cv_hi_d2  (to_vadx+1)/ 0		/
	DATA cv_lo_d3  (to_vadx+1)/ 0		/
	DATA cv_hi_d3  (to_vadx+1)/ 0		/
	DATA cv_lo_d4  (to_vadx+1)/ 0		/
	DATA cv_hi_d4  (to_vadx+1)/ 0		/
	DATA cv_lo_d5  (to_vadx+1)/ 0		/
	DATA cv_hi_d5  (to_vadx+1)/ 0		/
	DATA cv_lo_d6  (to_vadx+1)/ 0		/
	DATA cv_hi_d6  (to_vadx+1)/ 0		/

	DATA cv_category (to_vadx+2)/ cat_file_var	/
	DATA cv_variable (to_vadx+2)/ pv		/
	DATA cv_lo_d1  (to_vadx+2)/ -1		/
	DATA cv_hi_d1  (to_vadx+2)/ +1		/
	DATA cv_lo_d2  (to_vadx+2)/ 0		/
	DATA cv_hi_d2  (to_vadx+2)/ 0		/
	DATA cv_lo_d3  (to_vadx+2)/ 0		/
	DATA cv_hi_d3  (to_vadx+2)/ 0		/
	DATA cv_lo_d4  (to_vadx+2)/ 0		/
	DATA cv_hi_d4  (to_vadx+2)/ 0		/
	DATA cv_lo_d5  (to_vadx+2)/ 0		/
	DATA cv_hi_d5  (to_vadx+2)/ 0		/
	DATA cv_lo_d6  (to_vadx+2)/ 0		/
	DATA cv_hi_d6  (to_vadx+2)/ 0		/

*****************************************************************************

	DATA cv_category (to_vady+1)/ cat_calc_var	/
	DATA cv_variable (to_vady+1)/ pfvn		/
	DATA cv_lo_d1  (to_vady+1)/ 0		/
	DATA cv_hi_d1  (to_vady+1)/ 0		/
	DATA cv_lo_d2  (to_vady+1)/ -1		/
	DATA cv_hi_d2  (to_vady+1)/ 0		/
	DATA cv_lo_d3  (to_vady+1)/ 0		/
	DATA cv_hi_d3  (to_vady+1)/ 0		/
	DATA cv_lo_d4  (to_vady+1)/ 0		/
	DATA cv_hi_d4  (to_vady+1)/ 0		/
	DATA cv_lo_d5  (to_vady+1)/ 0		/
	DATA cv_hi_d5  (to_vady+1)/ 0		/
	DATA cv_lo_d6  (to_vady+1)/ 0		/
	DATA cv_hi_d6  (to_vady+1)/ 0		/

	DATA cv_category (to_vady+2)/ cat_file_var	/
	DATA cv_variable (to_vady+2)/ pv		/
	DATA cv_lo_d1  (to_vady+2)/ 0		/
	DATA cv_hi_d1  (to_vady+2)/ 0		/
	DATA cv_lo_d2  (to_vady+2)/ -1		/
	DATA cv_hi_d2  (to_vady+2)/ +1		/
	DATA cv_lo_d3  (to_vady+2)/ 0		/
	DATA cv_hi_d3  (to_vady+2)/ 0		/
	DATA cv_lo_d4  (to_vady+2)/ 0		/
	DATA cv_hi_d4  (to_vady+2)/ 0		/
	DATA cv_lo_d5  (to_vady+2)/ 0		/
	DATA cv_hi_d5  (to_vady+2)/ 0		/
	DATA cv_lo_d6  (to_vady+2)/ 0		/
	DATA cv_hi_d6  (to_vady+2)/ 0		/

*****************************************************************************

	DATA cv_category (to_vadz+1)/ cat_file_var	/
	DATA cv_variable (to_vadz+1)/ pv		/
	DATA cv_lo_d1  (to_vadz+1)/ 0		/
	DATA cv_hi_d1  (to_vadz+1)/ 0		/
	DATA cv_lo_d2  (to_vadz+1)/ 0		/
	DATA cv_hi_d2  (to_vadz+1)/ 0		/
	DATA cv_lo_d3  (to_vadz+1)/ -1		/
	DATA cv_hi_d3  (to_vadz+1)/ +1		/
	DATA cv_lo_d4  (to_vadz+1)/ 0		/
	DATA cv_hi_d4  (to_vadz+1)/ 0		/
	DATA cv_lo_d5  (to_vadz+1)/ 0		/
	DATA cv_hi_d5  (to_vadz+1)/ 0		/
	DATA cv_lo_d6  (to_vadz+1)/ 0		/
	DATA cv_hi_d6  (to_vadz+1)/ 0		/

	DATA cv_category (to_vadz+2)/ cat_calc_var	/
	DATA cv_variable (to_vadz+2)/ pw_u		/
	DATA cv_lo_d1  (to_vadz+2)/ 0		/
	DATA cv_hi_d1  (to_vadz+2)/ 0		/
	DATA cv_lo_d2  (to_vadz+2)/ 0		/
	DATA cv_hi_d2  (to_vadz+2)/ 0		/
	DATA cv_lo_d3  (to_vadz+2)/ -1		/
	DATA cv_hi_d3  (to_vadz+2)/ 0		/
	DATA cv_lo_d4  (to_vadz+2)/ 0		/
	DATA cv_hi_d4  (to_vadz+2)/ 0		/
	DATA cv_lo_d5  (to_vadz+2)/ 0		/
	DATA cv_hi_d5  (to_vadz+2)/ 0		/
	DATA cv_lo_d6  (to_vadz+2)/ 0		/
	DATA cv_hi_d6  (to_vadz+2)/ 0		/

**************************************************************************

	DATA cv_category (to_udfh+1)/ cat_file_var	/
	DATA cv_variable (to_udfh+1)/ pu		/
	DATA cv_lo_d1  (to_udfh+1)/ -1		/
	DATA cv_hi_d1  (to_udfh+1)/ +1		/
	DATA cv_lo_d2  (to_udfh+1)/ -1		/
	DATA cv_hi_d2  (to_udfh+1)/ +1		/
	DATA cv_lo_d3  (to_udfh+1)/ 0		/
	DATA cv_hi_d3  (to_udfh+1)/ 0		/
	DATA cv_lo_d4  (to_udfh+1)/ ptstep_1hr_b4	/
	DATA cv_hi_d4  (to_udfh+1)/ 0		/
	DATA cv_lo_d5  (to_udfh+1)/ 0		/
	DATA cv_hi_d5  (to_udfh+1)/ 0		/
	DATA cv_lo_d6  (to_udfh+1)/ 0		/
	DATA cv_hi_d6  (to_udfh+1)/ 0		/

	DATA cv_category (to_udfh+2)/ cat_file_var	/
	DATA cv_variable (to_udfh+2)/ pv		/
	DATA cv_lo_d1  (to_udfh+2)/ -1		/
	DATA cv_hi_d1  (to_udfh+2)/ +1		/
	DATA cv_lo_d2  (to_udfh+2)/ -1		/
	DATA cv_hi_d2  (to_udfh+2)/ +1		/
	DATA cv_lo_d3  (to_udfh+2)/ 0		/
	DATA cv_hi_d3  (to_udfh+2)/ 0		/
	DATA cv_lo_d4  (to_udfh+2)/ 0		/
	DATA cv_hi_d4  (to_udfh+2)/ 0		/
	DATA cv_lo_d5  (to_udfh+2)/ 0		/
	DATA cv_hi_d5  (to_udfh+2)/ 0		/
	DATA cv_lo_d6  (to_udfh+2)/ 0		/
	DATA cv_hi_d6  (to_udfh+2)/ 0		/

**************************************************************************

	DATA cv_category (to_udfz+1)/ cat_calc_var	/
	DATA cv_variable (to_udfz+1)/ ppcdz		/
	DATA cv_lo_d1  (to_udfz+1)/ 0		/
	DATA cv_hi_d1  (to_udfz+1)/ 0		/
	DATA cv_lo_d2  (to_udfz+1)/ 0		/
	DATA cv_hi_d2  (to_udfz+1)/ 0		/
	DATA cv_lo_d3  (to_udfz+1)/ -1		/
	DATA cv_hi_d3  (to_udfz+1)/ 0		/
	DATA cv_lo_d4  (to_udfz+1)/ ptstep_1hr_b4	/
	DATA cv_hi_d4  (to_udfz+1)/ ptstep_1hr_b4	/
	DATA cv_lo_d5  (to_udfz+1)/ 0		/
	DATA cv_hi_d5  (to_udfz+1)/ 0		/
	DATA cv_lo_d6  (to_udfz+1)/ 0		/
	DATA cv_hi_d6  (to_udfz+1)/ 0		/

	DATA cv_category (to_udfz+2)/ cat_file_var	/
	DATA cv_variable (to_udfz+2)/ pu		/
	DATA cv_lo_d1  (to_udfz+2)/ 0		/
	DATA cv_hi_d1  (to_udfz+2)/ 0		/
	DATA cv_lo_d2  (to_udfz+2)/ 0		/
	DATA cv_hi_d2  (to_udfz+2)/ 0		/
	DATA cv_lo_d3  (to_udfz+2)/ -1		/
	DATA cv_hi_d3  (to_udfz+2)/ +1		/
	DATA cv_lo_d4  (to_udfz+2)/ ptstep_1hr_b4	/
	DATA cv_hi_d4  (to_udfz+2)/ ptstep_1hr_b4	/
	DATA cv_lo_d5  (to_udfz+2)/ 0		/
	DATA cv_hi_d5  (to_udfz+2)/ 0		/
	DATA cv_lo_d6  (to_udfz+2)/ 0		/
	DATA cv_hi_d6  (to_udfz+2)/ 0		/

	DATA cv_category (to_udfz+3)/ cat_calc_var	/
	DATA cv_variable (to_udfz+3)/ pubwi		/
	DATA cv_lo_d1  (to_udfz+3)/ 0		/
	DATA cv_hi_d1  (to_udfz+3)/ 0		/
	DATA cv_lo_d2  (to_udfz+3)/ 0		/
	DATA cv_hi_d2  (to_udfz+3)/ 0		/
	DATA cv_lo_d3  (to_udfz+3)/ 0		/
	DATA cv_hi_d3  (to_udfz+3)/ 0		/
	DATA cv_lo_d4  (to_udfz+3)/ ptstep_1hr_b4	/
	DATA cv_hi_d4  (to_udfz+3)/ ptstep_1hr_b4	/
	DATA cv_lo_d5  (to_udfz+3)/ 0		/
	DATA cv_hi_d5  (to_udfz+3)/ 0		/
	DATA cv_lo_d6  (to_udfz+3)/ 0		/
	DATA cv_hi_d6  (to_udfz+3)/ 0		/

**************************************************************************

	DATA cv_category (to_vdfh+1)/ cat_file_var	/
	DATA cv_variable (to_vdfh+1)/ pv		/
	DATA cv_lo_d1  (to_vdfh+1)/ -1		/
	DATA cv_hi_d1  (to_vdfh+1)/ +1		/
	DATA cv_lo_d2  (to_vdfh+1)/ -1		/
	DATA cv_hi_d2  (to_vdfh+1)/ +1		/
	DATA cv_lo_d3  (to_vdfh+1)/ 0		/
	DATA cv_hi_d3  (to_vdfh+1)/ 0		/
	DATA cv_lo_d4  (to_vdfh+1)/ ptstep_1hr_b4	/
	DATA cv_hi_d4  (to_vdfh+1)/ 0		/
	DATA cv_lo_d5  (to_vdfh+1)/ 0		/
	DATA cv_hi_d5  (to_vdfh+1)/ 0		/
	DATA cv_lo_d6  (to_vdfh+1)/ 0		/
	DATA cv_hi_d6  (to_vdfh+1)/ 0		/

	DATA cv_category (to_vdfh+2)/ cat_file_var	/
	DATA cv_variable (to_vdfh+2)/ pu		/
	DATA cv_lo_d1  (to_vdfh+2)/ -1		/
	DATA cv_hi_d1  (to_vdfh+2)/ +1		/
	DATA cv_lo_d2  (to_vdfh+2)/ -1		/
	DATA cv_hi_d2  (to_vdfh+2)/ +1		/
	DATA cv_lo_d3  (to_vdfh+2)/ 0		/
	DATA cv_hi_d3  (to_vdfh+2)/ 0		/
	DATA cv_lo_d4  (to_vdfh+2)/ 0		/
	DATA cv_hi_d4  (to_vdfh+2)/ 0		/
	DATA cv_lo_d5  (to_vdfh+2)/ 0		/
	DATA cv_hi_d5  (to_vdfh+2)/ 0		/
	DATA cv_lo_d6  (to_vdfh+2)/ 0		/
	DATA cv_hi_d6  (to_vdfh+2)/ 0		/

**************************************************************************

	DATA cv_category (to_vdfz+1)/ cat_calc_var	/
	DATA cv_variable (to_vdfz+1)/ ppcdz		/
	DATA cv_lo_d1  (to_vdfz+1)/ 0		/
	DATA cv_hi_d1  (to_vdfz+1)/ 0		/
	DATA cv_lo_d2  (to_vdfz+1)/ 0		/
	DATA cv_hi_d2  (to_vdfz+1)/ 0		/
	DATA cv_lo_d3  (to_vdfz+1)/ -1		/
	DATA cv_hi_d3  (to_vdfz+1)/ 0		/
	DATA cv_lo_d4  (to_vdfz+1)/ ptstep_1hr_b4	/
	DATA cv_hi_d4  (to_vdfz+1)/ ptstep_1hr_b4	/
	DATA cv_lo_d5  (to_vdfz+1)/ 0		/
	DATA cv_hi_d5  (to_vdfz+1)/ 0		/
	DATA cv_lo_d6  (to_vdfz+1)/ 0		/
	DATA cv_hi_d6  (to_vdfz+1)/ 0		/

	DATA cv_category (to_vdfz+2)/ cat_file_var	/
	DATA cv_variable (to_vdfz+2)/ pv		/
	DATA cv_lo_d1  (to_vdfz+2)/ 0		/
	DATA cv_hi_d1  (to_vdfz+2)/ 0		/
	DATA cv_lo_d2  (to_vdfz+2)/ 0		/
	DATA cv_hi_d2  (to_vdfz+2)/ 0		/
	DATA cv_lo_d3  (to_vdfz+2)/ -1		/
	DATA cv_hi_d3  (to_vdfz+2)/ +1		/
	DATA cv_lo_d4  (to_vdfz+2)/ ptstep_1hr_b4	/
	DATA cv_hi_d4  (to_vdfz+2)/ ptstep_1hr_b4	/
	DATA cv_lo_d5  (to_vdfz+2)/ 0		/
	DATA cv_hi_d5  (to_vdfz+2)/ 0		/
	DATA cv_lo_d6  (to_vdfz+2)/ 0		/
	DATA cv_hi_d6  (to_vdfz+2)/ 0		/

	DATA cv_category (to_vdfz+3)/ cat_calc_var	/
	DATA cv_variable (to_vdfz+3)/ pvbwi		/
	DATA cv_lo_d1  (to_vdfz+3)/ 0		/
	DATA cv_hi_d1  (to_vdfz+3)/ 0		/
	DATA cv_lo_d2  (to_vdfz+3)/ 0		/
	DATA cv_hi_d2  (to_vdfz+3)/ 0		/
	DATA cv_lo_d3  (to_vdfz+3)/ 0		/
	DATA cv_hi_d3  (to_vdfz+3)/ 0		/
	DATA cv_lo_d4  (to_vdfz+3)/ ptstep_1hr_b4	/
	DATA cv_hi_d4  (to_vdfz+3)/ ptstep_1hr_b4	/
	DATA cv_lo_d5  (to_vdfz+3)/ 0		/
	DATA cv_hi_d5  (to_vdfz+3)/ 0		/
	DATA cv_lo_d6  (to_vdfz+3)/ 0		/
	DATA cv_hi_d6  (to_vdfz+3)/ 0		/

**************************************************************************

	DATA cv_category (to_ucoi+1)/ cat_file_var	/
	DATA cv_variable (to_ucoi+1)/ ptemp		/
	DATA cv_lo_d1  (to_ucoi+1)/ 0		/
	DATA cv_hi_d1  (to_ucoi+1)/ 0		/
	DATA cv_lo_d2  (to_ucoi+1)/ 0		/
	DATA cv_hi_d2  (to_ucoi+1)/ 0		/
	DATA cv_lo_d3  (to_ucoi+1)/ 0		/
	DATA cv_hi_d3  (to_ucoi+1)/ 0		/
	DATA cv_lo_d4  (to_ucoi+1)/ 0		/
	DATA cv_hi_d4  (to_ucoi+1)/ 0		/
	DATA cv_lo_d5  (to_ucoi+1)/ 0		/
	DATA cv_hi_d5  (to_ucoi+1)/ 0		/
	DATA cv_lo_d6  (to_ucoi+1)/ 0		/
	DATA cv_hi_d6  (to_ucoi+1)/ 0		/

**************************************************************************

	DATA cv_category (to_vcoi+1)/ cat_file_var	/
	DATA cv_variable (to_vcoi+1)/ ptemp		/
	DATA cv_lo_d1  (to_vcoi+1)/ 0		/
	DATA cv_hi_d1  (to_vcoi+1)/ 0		/
	DATA cv_lo_d2  (to_vcoi+1)/ 0		/
	DATA cv_hi_d2  (to_vcoi+1)/ 0		/
	DATA cv_lo_d3  (to_vcoi+1)/ 0		/
	DATA cv_hi_d3  (to_vcoi+1)/ 0		/
	DATA cv_lo_d4  (to_vcoi+1)/ 0		/
	DATA cv_hi_d4  (to_vcoi+1)/ 0		/
	DATA cv_lo_d5  (to_vcoi+1)/ 0		/
	DATA cv_hi_d5  (to_vcoi+1)/ 0		/
	DATA cv_lo_d6  (to_vcoi+1)/ 0		/
	DATA cv_hi_d6  (to_vcoi+1)/ 0		/

**************************************************************************

	DATA cv_category (to_ubpi+1)/ cat_calc_var	/
	DATA cv_variable (to_ubpi+1)/ pdpdx		/
	DATA cv_lo_d1  (to_ubpi+1)/ 0		/
	DATA cv_hi_d1  (to_ubpi+1)/ 0		/
	DATA cv_lo_d2  (to_ubpi+1)/ 0		/
	DATA cv_hi_d2  (to_ubpi+1)/ 0		/
	DATA cv_lo_d3  (to_ubpi+1)/ 0		/
	DATA cv_hi_d3  (to_ubpi+1)/ 0		/
	DATA cv_lo_d4  (to_ubpi+1)/ 0		/
	DATA cv_hi_d4  (to_ubpi+1)/ 0		/
	DATA cv_lo_d5  (to_ubpi+1)/ 0		/
	DATA cv_hi_d5  (to_ubpi+1)/ 0		/
	DATA cv_lo_d6  (to_ubpi+1)/ 0		/
	DATA cv_hi_d6  (to_ubpi+1)/ 0		/

**************************************************************************

	DATA cv_category (to_vbpi+1)/ cat_calc_var	/
	DATA cv_variable (to_vbpi+1)/ pdpdy		/
	DATA cv_lo_d1  (to_vbpi+1)/ 0		/
	DATA cv_hi_d1  (to_vbpi+1)/ 0		/
	DATA cv_lo_d2  (to_vbpi+1)/ 0		/
	DATA cv_hi_d2  (to_vbpi+1)/ 0		/
	DATA cv_lo_d3  (to_vbpi+1)/ 0		/
	DATA cv_hi_d3  (to_vbpi+1)/ 0		/
	DATA cv_lo_d4  (to_vbpi+1)/ 0		/
	DATA cv_hi_d4  (to_vbpi+1)/ 0		/
	DATA cv_lo_d5  (to_vbpi+1)/ 0		/
	DATA cv_hi_d5  (to_vbpi+1)/ 0		/
	DATA cv_lo_d6  (to_vbpi+1)/ 0		/
	DATA cv_hi_d6  (to_vbpi+1)/ 0		/

**************************************************************************

	DATA cv_category (to_ubwi+1)/ cat_file_var	/
	DATA cv_variable (to_ubwi+1)/ ptaux		/
	DATA cv_lo_d1  (to_ubwi+1)/ 0		/
	DATA cv_hi_d1  (to_ubwi+1)/ 0		/
	DATA cv_lo_d2  (to_ubwi+1)/ 0		/
	DATA cv_hi_d2  (to_ubwi+1)/ 0		/
	DATA cv_lo_d3  (to_ubwi+1)/ 0		/
	DATA cv_hi_d3  (to_ubwi+1)/ 0		/
	DATA cv_lo_d4  (to_ubwi+1)/ 0		/
	DATA cv_hi_d4  (to_ubwi+1)/ 0		/
	DATA cv_lo_d5  (to_ubwi+1)/ 0		/
	DATA cv_hi_d5  (to_ubwi+1)/ 0		/
	DATA cv_lo_d6  (to_ubwi+1)/ 0		/
	DATA cv_hi_d6  (to_ubwi+1)/ 0		/

**************************************************************************

	DATA cv_category (to_vbwi+1)/ cat_file_var	/
	DATA cv_variable (to_vbwi+1)/ ptauy		/
	DATA cv_lo_d1  (to_vbwi+1)/ 0		/
	DATA cv_hi_d1  (to_vbwi+1)/ 0		/
	DATA cv_lo_d2  (to_vbwi+1)/ 0		/
	DATA cv_hi_d2  (to_vbwi+1)/ 0		/
	DATA cv_lo_d3  (to_vbwi+1)/ 0		/
	DATA cv_hi_d3  (to_vbwi+1)/ 0		/
	DATA cv_lo_d4  (to_vbwi+1)/ 0		/
	DATA cv_hi_d4  (to_vbwi+1)/ 0		/
	DATA cv_lo_d5  (to_vbwi+1)/ 0		/
	DATA cv_hi_d5  (to_vbwi+1)/ 0		/
	DATA cv_lo_d6  (to_vbwi+1)/ 0		/
	DATA cv_hi_d6  (to_vbwi+1)/ 0		/

**************************************************************************

	DATA cv_category (to_ucoe+1)/ cat_file_var	/
	DATA cv_variable (to_ucoe+1)/ pu		/
	DATA cv_lo_d1  (to_ucoe+1)/ 0		/
	DATA cv_hi_d1  (to_ucoe+1)/ 0		/
	DATA cv_lo_d2  (to_ucoe+1)/ 0		/
	DATA cv_hi_d2  (to_ucoe+1)/ 0		/
	DATA cv_lo_d3  (to_ucoe+1)/ 0		/
	DATA cv_hi_d3  (to_ucoe+1)/ 0		/
	DATA cv_lo_d4  (to_ucoe+1)/ 0		/
	DATA cv_hi_d4  (to_ucoe+1)/ 0		/
	DATA cv_lo_d5  (to_ucoe+1)/ 0		/
	DATA cv_hi_d5  (to_ucoe+1)/ 0		/
	DATA cv_lo_d6  (to_ucoe+1)/ 0		/
	DATA cv_hi_d6  (to_ucoe+1)/ 0		/

	DATA cv_category (to_ucoe+2)/ cat_file_var	/
	DATA cv_variable (to_ucoe+2)/ pv		/
	DATA cv_lo_d1  (to_ucoe+2)/ 0		/
	DATA cv_hi_d1  (to_ucoe+2)/ 0		/
	DATA cv_lo_d2  (to_ucoe+2)/ 0		/
	DATA cv_hi_d2  (to_ucoe+2)/ 0		/
	DATA cv_lo_d3  (to_ucoe+2)/ 0		/
	DATA cv_hi_d3  (to_ucoe+2)/ 0		/
	DATA cv_lo_d4  (to_ucoe+2)/ 0		/
	DATA cv_hi_d4  (to_ucoe+2)/ 0		/
	DATA cv_lo_d5  (to_ucoe+2)/ 0		/
	DATA cv_hi_d5  (to_ucoe+2)/ 0		/
	DATA cv_lo_d6  (to_ucoe+2)/ 0		/
	DATA cv_hi_d6  (to_ucoe+2)/ 0		/

**************************************************************************

	DATA cv_category (to_vcoe+1)/ cat_file_var	/
	DATA cv_variable (to_vcoe+1)/ pu		/
	DATA cv_lo_d1  (to_vcoe+1)/ 0		/
	DATA cv_hi_d1  (to_vcoe+1)/ 0		/
	DATA cv_lo_d2  (to_vcoe+1)/ 0		/
	DATA cv_hi_d2  (to_vcoe+1)/ 0		/
	DATA cv_lo_d3  (to_vcoe+1)/ 0		/
	DATA cv_hi_d3  (to_vcoe+1)/ 0		/
	DATA cv_lo_d4  (to_vcoe+1)/ 0		/
	DATA cv_hi_d4  (to_vcoe+1)/ 0		/
	DATA cv_lo_d5  (to_vcoe+1)/ 0		/
	DATA cv_hi_d5  (to_vcoe+1)/ 0		/
	DATA cv_lo_d6  (to_vcoe+1)/ 0		/
	DATA cv_hi_d6  (to_vcoe+1)/ 0		/

	DATA cv_category (to_vcoe+2)/ cat_file_var	/
	DATA cv_variable (to_vcoe+2)/ pv		/
	DATA cv_lo_d1  (to_vcoe+2)/ 0		/
	DATA cv_hi_d1  (to_vcoe+2)/ 0		/
	DATA cv_lo_d2  (to_vcoe+2)/ 0		/
	DATA cv_hi_d2  (to_vcoe+2)/ 0		/
	DATA cv_lo_d3  (to_vcoe+2)/ 0		/
	DATA cv_hi_d3  (to_vcoe+2)/ 0		/
	DATA cv_lo_d4  (to_vcoe+2)/ 0		/
	DATA cv_hi_d4  (to_vcoe+2)/ 0		/
	DATA cv_lo_d5  (to_vcoe+2)/ 0		/
	DATA cv_hi_d5  (to_vcoe+2)/ 0		/
	DATA cv_lo_d6  (to_vcoe+2)/ 0		/
	DATA cv_hi_d6  (to_vcoe+2)/ 0		/

**************************************************************************

	DATA cv_category (to_uad +1)/ cat_calc_var	/
	DATA cv_variable (to_uad +1)/ puadx		/
	DATA cv_lo_d1  (to_uad +1)/ 0		/
	DATA cv_hi_d1  (to_uad +1)/ 0		/
	DATA cv_lo_d2  (to_uad +1)/ 0		/
	DATA cv_hi_d2  (to_uad +1)/ 0		/
	DATA cv_lo_d3  (to_uad +1)/ 0		/
	DATA cv_hi_d3  (to_uad +1)/ 0		/
	DATA cv_lo_d4  (to_uad +1)/ 0		/
	DATA cv_hi_d4  (to_uad +1)/ 0		/
	DATA cv_lo_d5  (to_uad +1)/ 0		/
	DATA cv_hi_d5  (to_uad +1)/ 0		/
	DATA cv_lo_d6  (to_uad +1)/ 0		/
	DATA cv_hi_d6  (to_uad +1)/ 0		/

	DATA cv_category (to_uad +2)/ cat_calc_var	/
	DATA cv_variable (to_uad +2)/ puady		/
	DATA cv_lo_d1  (to_uad +2)/ 0		/
	DATA cv_hi_d1  (to_uad +2)/ 0		/
	DATA cv_lo_d2  (to_uad +2)/ 0		/
	DATA cv_hi_d2  (to_uad +2)/ 0		/
	DATA cv_lo_d3  (to_uad +2)/ 0		/
	DATA cv_hi_d3  (to_uad +2)/ 0		/
	DATA cv_lo_d4  (to_uad +2)/ 0		/
	DATA cv_hi_d4  (to_uad +2)/ 0		/
	DATA cv_lo_d5  (to_uad +2)/ 0		/
	DATA cv_hi_d5  (to_uad +2)/ 0		/
	DATA cv_lo_d6  (to_uad +2)/ 0		/
	DATA cv_hi_d6  (to_uad +2)/ 0		/

	DATA cv_category (to_uad +3)/ cat_calc_var	/
	DATA cv_variable (to_uad +3)/ puadz		/
	DATA cv_lo_d1  (to_uad +3)/ 0		/
	DATA cv_hi_d1  (to_uad +3)/ 0		/
	DATA cv_lo_d2  (to_uad +3)/ 0		/
	DATA cv_hi_d2  (to_uad +3)/ 0		/
	DATA cv_lo_d3  (to_uad +3)/ 0		/
	DATA cv_hi_d3  (to_uad +3)/ 0		/
	DATA cv_lo_d4  (to_uad +3)/ 0		/
	DATA cv_hi_d4  (to_uad +3)/ 0		/
	DATA cv_lo_d5  (to_uad +3)/ 0		/
	DATA cv_hi_d5  (to_uad +3)/ 0		/
	DATA cv_lo_d6  (to_uad +3)/ 0		/
	DATA cv_hi_d6  (to_uad +3)/ 0		/

**************************************************************************

	DATA cv_category (to_vad +1)/ cat_calc_var	/
	DATA cv_variable (to_vad +1)/ pvadx		/
	DATA cv_lo_d1  (to_vad +1)/ 0		/
	DATA cv_hi_d1  (to_vad +1)/ 0		/
	DATA cv_lo_d2  (to_vad +1)/ 0		/
	DATA cv_hi_d2  (to_vad +1)/ 0		/
	DATA cv_lo_d3  (to_vad +1)/ 0		/
	DATA cv_hi_d3  (to_vad +1)/ 0		/
	DATA cv_lo_d4  (to_vad +1)/ 0		/
	DATA cv_hi_d4  (to_vad +1)/ 0		/
	DATA cv_lo_d5  (to_vad +1)/ 0		/
	DATA cv_hi_d5  (to_vad +1)/ 0		/
	DATA cv_lo_d6  (to_vad +1)/ 0		/
	DATA cv_hi_d6  (to_vad +1)/ 0		/

	DATA cv_category (to_vad +2)/ cat_calc_var	/
	DATA cv_variable (to_vad +2)/ pvady		/
	DATA cv_lo_d1  (to_vad +2)/ 0		/
	DATA cv_hi_d1  (to_vad +2)/ 0		/
	DATA cv_lo_d2  (to_vad +2)/ 0		/
	DATA cv_hi_d2  (to_vad +2)/ 0		/
	DATA cv_lo_d3  (to_vad +2)/ 0		/
	DATA cv_hi_d3  (to_vad +2)/ 0		/
	DATA cv_lo_d4  (to_vad +2)/ 0		/
	DATA cv_hi_d4  (to_vad +2)/ 0		/
	DATA cv_lo_d5  (to_vad +2)/ 0		/
	DATA cv_hi_d5  (to_vad +2)/ 0		/
	DATA cv_lo_d6  (to_vad +2)/ 0		/
	DATA cv_hi_d6  (to_vad +2)/ 0		/

	DATA cv_category (to_vad +3)/ cat_calc_var	/
	DATA cv_variable (to_vad +3)/ pvadz		/
	DATA cv_lo_d1  (to_vad +3)/ 0		/
	DATA cv_hi_d1  (to_vad +3)/ 0		/
	DATA cv_lo_d2  (to_vad +3)/ 0		/
	DATA cv_hi_d2  (to_vad +3)/ 0		/
	DATA cv_lo_d3  (to_vad +3)/ 0		/
	DATA cv_hi_d3  (to_vad +3)/ 0		/
	DATA cv_lo_d4  (to_vad +3)/ 0		/
	DATA cv_hi_d4  (to_vad +3)/ 0		/
	DATA cv_lo_d5  (to_vad +3)/ 0		/
	DATA cv_hi_d5  (to_vad +3)/ 0		/
	DATA cv_lo_d6  (to_vad +3)/ 0		/
	DATA cv_hi_d6  (to_vad +3)/ 0		/

**************************************************************************

	DATA cv_category (to_udf +1)/ cat_calc_var	/
	DATA cv_variable (to_udf +1)/ pudfh		/
	DATA cv_lo_d1  (to_udf +1)/ 0		/
	DATA cv_hi_d1  (to_udf +1)/ 0		/
	DATA cv_lo_d2  (to_udf +1)/ 0		/
	DATA cv_hi_d2  (to_udf +1)/ 0		/
	DATA cv_lo_d3  (to_udf +1)/ 0		/
	DATA cv_hi_d3  (to_udf +1)/ 0		/
	DATA cv_lo_d4  (to_udf +1)/ 0		/
	DATA cv_hi_d4  (to_udf +1)/ 0		/
	DATA cv_lo_d5  (to_udf +1)/ 0		/
	DATA cv_hi_d5  (to_udf +1)/ 0		/
	DATA cv_lo_d6  (to_udf +1)/ 0		/
	DATA cv_hi_d6  (to_udf +1)/ 0		/

	DATA cv_category (to_udf +2)/ cat_calc_var	/
	DATA cv_variable (to_udf +2)/ pudfz		/
	DATA cv_lo_d1  (to_udf +2)/ 0		/
	DATA cv_hi_d1  (to_udf +2)/ 0		/
	DATA cv_lo_d2  (to_udf +2)/ 0		/
	DATA cv_hi_d2  (to_udf +2)/ 0		/
	DATA cv_lo_d3  (to_udf +2)/ 0		/
	DATA cv_hi_d3  (to_udf +2)/ 0		/
	DATA cv_lo_d4  (to_udf +2)/ 0		/
	DATA cv_hi_d4  (to_udf +2)/ 0		/
	DATA cv_lo_d5  (to_udf +2)/ 0		/
	DATA cv_hi_d5  (to_udf +2)/ 0		/
	DATA cv_lo_d6  (to_udf +2)/ 0		/
	DATA cv_hi_d6  (to_udf +2)/ 0		/

**************************************************************************

	DATA cv_category (to_vdf +1)/ cat_calc_var	/
	DATA cv_variable (to_vdf +1)/ pvdfh		/
	DATA cv_lo_d1  (to_vdf +1)/ 0		/
	DATA cv_hi_d1  (to_vdf +1)/ 0		/
	DATA cv_lo_d2  (to_vdf +1)/ 0		/
	DATA cv_hi_d2  (to_vdf +1)/ 0		/
	DATA cv_lo_d3  (to_vdf +1)/ 0		/
	DATA cv_hi_d3  (to_vdf +1)/ 0		/
	DATA cv_lo_d4  (to_vdf +1)/ 0		/
	DATA cv_hi_d4  (to_vdf +1)/ 0		/
	DATA cv_lo_d5  (to_vdf +1)/ 0		/
	DATA cv_hi_d5  (to_vdf +1)/ 0		/
	DATA cv_lo_d6  (to_vdf +1)/ 0		/
	DATA cv_hi_d6  (to_vdf +1)/ 0		/

	DATA cv_category (to_vdf +2)/ cat_calc_var	/
	DATA cv_variable (to_vdf +2)/ pvdfz		/
	DATA cv_lo_d1  (to_vdf +2)/ 0		/
	DATA cv_hi_d1  (to_vdf +2)/ 0		/
	DATA cv_lo_d2  (to_vdf +2)/ 0		/
	DATA cv_hi_d2  (to_vdf +2)/ 0		/
	DATA cv_lo_d3  (to_vdf +2)/ 0		/
	DATA cv_hi_d3  (to_vdf +2)/ 0		/
	DATA cv_lo_d4  (to_vdf +2)/ 0		/
	DATA cv_hi_d4  (to_vdf +2)/ 0		/
	DATA cv_lo_d5  (to_vdf +2)/ 0		/
	DATA cv_hi_d5  (to_vdf +2)/ 0		/
	DATA cv_lo_d6  (to_vdf +2)/ 0		/
	DATA cv_hi_d6  (to_vdf +2)/ 0		/

**************************************************************************

	DATA cv_category (to_dudt+1)/ cat_file_var	/
	DATA cv_variable (to_dudt+1)/ pu   		/
	DATA cv_lo_d1  (to_dudt+1)/ 0		/
	DATA cv_hi_d1  (to_dudt+1)/ 0		/
	DATA cv_lo_d2  (to_dudt+1)/ 0		/
	DATA cv_hi_d2  (to_dudt+1)/ 0		/
	DATA cv_lo_d3  (to_dudt+1)/ 0		/
	DATA cv_hi_d3  (to_dudt+1)/ 0		/
	DATA cv_lo_d4  (to_dudt+1)/ -1		/
	DATA cv_hi_d4  (to_dudt+1)/ +1		/
	DATA cv_lo_d5  (to_dudt+1)/ 0		/
	DATA cv_hi_d5  (to_dudt+1)/ 0		/
	DATA cv_lo_d6  (to_dudt+1)/ 0		/
	DATA cv_hi_d6  (to_dudt+1)/ 0		/

**************************************************************************

	DATA cv_category (to_dvdt+1)/ cat_file_var	/
	DATA cv_variable (to_dvdt+1)/ pv   		/
	DATA cv_lo_d1  (to_dvdt+1)/ 0		/
	DATA cv_hi_d1  (to_dvdt+1)/ 0		/
	DATA cv_lo_d2  (to_dvdt+1)/ 0		/
	DATA cv_hi_d2  (to_dvdt+1)/ 0		/
	DATA cv_lo_d3  (to_dvdt+1)/ 0		/
	DATA cv_hi_d3  (to_dvdt+1)/ 0		/
	DATA cv_lo_d4  (to_dvdt+1)/ -1		/
	DATA cv_hi_d4  (to_dvdt+1)/ +1		/
	DATA cv_lo_d5  (to_dvdt+1)/ 0		/
	DATA cv_hi_d5  (to_dvdt+1)/ 0		/
	DATA cv_lo_d6  (to_dvdt+1)/ 0		/
	DATA cv_hi_d6  (to_dvdt+1)/ 0		/

**************************************************************************

	DATA cv_category (to_dwdt+1)/ cat_file_var	/
	DATA cv_variable (to_dwdt+1)/ pw   		/
	DATA cv_lo_d1  (to_dwdt+1)/ 0		/
	DATA cv_hi_d1  (to_dwdt+1)/ 0		/
	DATA cv_lo_d2  (to_dwdt+1)/ 0		/
	DATA cv_hi_d2  (to_dwdt+1)/ 0		/
	DATA cv_lo_d3  (to_dwdt+1)/ 0		/
	DATA cv_hi_d3  (to_dwdt+1)/ 0		/
	DATA cv_lo_d4  (to_dwdt+1)/ -1		/
	DATA cv_hi_d4  (to_dwdt+1)/ +1		/
	DATA cv_lo_d5  (to_dwdt+1)/ 0		/
	DATA cv_hi_d5  (to_dwdt+1)/ 0		/
	DATA cv_lo_d6  (to_dwdt+1)/ 0		/
	DATA cv_hi_d6  (to_dwdt+1)/ 0		/

**************************************************************************

	DATA cv_category (to_dtdt+1)/ cat_file_var	/
	DATA cv_variable (to_dtdt+1)/ ptemp		/
	DATA cv_lo_d1  (to_dtdt+1)/ 0		/
	DATA cv_hi_d1  (to_dtdt+1)/ 0		/
	DATA cv_lo_d2  (to_dtdt+1)/ 0		/
	DATA cv_hi_d2  (to_dtdt+1)/ 0		/
	DATA cv_lo_d3  (to_dtdt+1)/ 0		/
	DATA cv_hi_d3  (to_dtdt+1)/ 0		/
	DATA cv_lo_d4  (to_dtdt+1)/ -1		/
	DATA cv_hi_d4  (to_dtdt+1)/ +1		/
	DATA cv_lo_d5  (to_dtdt+1)/ 0		/
	DATA cv_hi_d5  (to_dtdt+1)/ 0		/
	DATA cv_lo_d6  (to_dtdt+1)/ 0		/
	DATA cv_hi_d6  (to_dtdt+1)/ 0		/

**************************************************************************

	DATA cv_category (to_ubps+1)/ cat_calc_var	/
	DATA cv_variable (to_ubps+1)/ pudf		/
	DATA cv_lo_d1  (to_ubps+1)/ 0		/
	DATA cv_hi_d1  (to_ubps+1)/ 0		/
	DATA cv_lo_d2  (to_ubps+1)/ 0		/
	DATA cv_hi_d2  (to_ubps+1)/ 0		/
	DATA cv_lo_d3  (to_ubps+1)/ 0		/
	DATA cv_hi_d3  (to_ubps+1)/ 0		/
	DATA cv_lo_d4  (to_ubps+1)/ 0		/
	DATA cv_hi_d4  (to_ubps+1)/ 0		/
	DATA cv_lo_d5  (to_ubps+1)/ 0		/
	DATA cv_hi_d5  (to_ubps+1)/ 0		/
	DATA cv_lo_d6  (to_ubps+1)/ 0		/
	DATA cv_hi_d6  (to_ubps+1)/ 0		/

	DATA cv_category (to_ubps+2)/ cat_calc_var	/
	DATA cv_variable (to_ubps+2)/ puad		/
	DATA cv_lo_d1  (to_ubps+2)/ 0		/
	DATA cv_hi_d1  (to_ubps+2)/ 0		/
	DATA cv_lo_d2  (to_ubps+2)/ 0		/
	DATA cv_hi_d2  (to_ubps+2)/ 0		/
	DATA cv_lo_d3  (to_ubps+2)/ 0		/
	DATA cv_hi_d3  (to_ubps+2)/ 0		/
	DATA cv_lo_d4  (to_ubps+2)/ 0		/
	DATA cv_hi_d4  (to_ubps+2)/ 0		/
	DATA cv_lo_d5  (to_ubps+2)/ 0		/
	DATA cv_hi_d5  (to_ubps+2)/ 0		/
	DATA cv_lo_d6  (to_ubps+2)/ 0		/
	DATA cv_hi_d6  (to_ubps+2)/ 0		/

	DATA cv_category (to_ubps+3)/ cat_calc_var	/
	DATA cv_variable (to_ubps+3)/ pucoe		/
	DATA cv_lo_d1  (to_ubps+3)/ 0		/
	DATA cv_hi_d1  (to_ubps+3)/ 0		/
	DATA cv_lo_d2  (to_ubps+3)/ 0		/
	DATA cv_hi_d2  (to_ubps+3)/ 0		/
	DATA cv_lo_d3  (to_ubps+3)/ 0		/
	DATA cv_hi_d3  (to_ubps+3)/ 0		/
	DATA cv_lo_d4  (to_ubps+3)/ 0		/
	DATA cv_hi_d4  (to_ubps+3)/ 0		/
	DATA cv_lo_d5  (to_ubps+3)/ 0		/
	DATA cv_hi_d5  (to_ubps+3)/ 0		/
	DATA cv_lo_d6  (to_ubps+3)/ 0		/
	DATA cv_hi_d6  (to_ubps+3)/ 0		/

	DATA cv_category (to_ubps+4)/ cat_calc_var	/
	DATA cv_variable (to_ubps+4)/ pubpi		/
	DATA cv_lo_d1  (to_ubps+4)/ 0		/
	DATA cv_hi_d1  (to_ubps+4)/ 0		/
	DATA cv_lo_d2  (to_ubps+4)/ 0		/
	DATA cv_hi_d2  (to_ubps+4)/ 0		/
	DATA cv_lo_d3  (to_ubps+4)/ 0		/
	DATA cv_hi_d3  (to_ubps+4)/ 0		/
	DATA cv_lo_d4  (to_ubps+4)/ 0		/
	DATA cv_hi_d4  (to_ubps+4)/ 0		/
	DATA cv_lo_d5  (to_ubps+4)/ 0		/
	DATA cv_hi_d5  (to_ubps+4)/ 0		/
	DATA cv_lo_d6  (to_ubps+4)/ 0		/
	DATA cv_hi_d6  (to_ubps+4)/ 0		/

	DATA cv_category (to_ubps+5)/ cat_calc_var	/
	DATA cv_variable (to_ubps+5)/ pdudt		/
	DATA cv_lo_d1  (to_ubps+5)/ 0		/
	DATA cv_hi_d1  (to_ubps+5)/ 0		/
	DATA cv_lo_d2  (to_ubps+5)/ 0		/
	DATA cv_hi_d2  (to_ubps+5)/ 0		/
	DATA cv_lo_d3  (to_ubps+5)/ 0		/
	DATA cv_hi_d3  (to_ubps+5)/ 0		/
	DATA cv_lo_d4  (to_ubps+5)/ 0		/
	DATA cv_hi_d4  (to_ubps+5)/ 0		/
	DATA cv_lo_d5  (to_ubps+5)/ 0		/
	DATA cv_hi_d5  (to_ubps+5)/ 0		/
	DATA cv_lo_d6  (to_ubps+5)/ 0		/
	DATA cv_hi_d6  (to_ubps+5)/ 0		/

**************************************************************************

	DATA cv_category (to_vbps+1)/ cat_calc_var	/
	DATA cv_variable (to_vbps+1)/ pvdf		/
	DATA cv_lo_d1  (to_vbps+1)/ 0		/
	DATA cv_hi_d1  (to_vbps+1)/ 0		/
	DATA cv_lo_d2  (to_vbps+1)/ 0		/
	DATA cv_hi_d2  (to_vbps+1)/ 0		/
	DATA cv_lo_d3  (to_vbps+1)/ 0		/
	DATA cv_hi_d3  (to_vbps+1)/ 0		/
	DATA cv_lo_d4  (to_vbps+1)/ 0		/
	DATA cv_hi_d4  (to_vbps+1)/ 0		/
	DATA cv_lo_d5  (to_vbps+1)/ 0		/
	DATA cv_hi_d5  (to_vbps+1)/ 0		/
	DATA cv_lo_d6  (to_vbps+1)/ 0		/
	DATA cv_hi_d6  (to_vbps+1)/ 0		/

	DATA cv_category (to_vbps+2)/ cat_calc_var	/
	DATA cv_variable (to_vbps+2)/ pvad		/
	DATA cv_lo_d1  (to_vbps+2)/ 0		/
	DATA cv_hi_d1  (to_vbps+2)/ 0		/
	DATA cv_lo_d2  (to_vbps+2)/ 0		/
	DATA cv_hi_d2  (to_vbps+2)/ 0		/
	DATA cv_lo_d3  (to_vbps+2)/ 0		/
	DATA cv_hi_d3  (to_vbps+2)/ 0		/
	DATA cv_lo_d4  (to_vbps+2)/ 0		/
	DATA cv_hi_d4  (to_vbps+2)/ 0		/
	DATA cv_lo_d5  (to_vbps+2)/ 0		/
	DATA cv_hi_d5  (to_vbps+2)/ 0		/
	DATA cv_lo_d6  (to_vbps+2)/ 0		/
	DATA cv_hi_d6  (to_vbps+2)/ 0		/

	DATA cv_category (to_vbps+3)/ cat_calc_var	/
	DATA cv_variable (to_vbps+3)/ pvcoe		/
	DATA cv_lo_d1  (to_vbps+3)/ 0		/
	DATA cv_hi_d1  (to_vbps+3)/ 0		/
	DATA cv_lo_d2  (to_vbps+3)/ 0		/
	DATA cv_hi_d2  (to_vbps+3)/ 0		/
	DATA cv_lo_d3  (to_vbps+3)/ 0		/
	DATA cv_hi_d3  (to_vbps+3)/ 0		/
	DATA cv_lo_d4  (to_vbps+3)/ 0		/
	DATA cv_hi_d4  (to_vbps+3)/ 0		/
	DATA cv_lo_d5  (to_vbps+3)/ 0		/
	DATA cv_hi_d5  (to_vbps+3)/ 0		/
	DATA cv_lo_d6  (to_vbps+3)/ 0		/
	DATA cv_hi_d6  (to_vbps+3)/ 0		/

	DATA cv_category (to_vbps+4)/ cat_calc_var	/
	DATA cv_variable (to_vbps+4)/ pvbpi		/
	DATA cv_lo_d1  (to_vbps+4)/ 0		/
	DATA cv_hi_d1  (to_vbps+4)/ 0		/
	DATA cv_lo_d2  (to_vbps+4)/ 0		/
	DATA cv_hi_d2  (to_vbps+4)/ 0		/
	DATA cv_lo_d3  (to_vbps+4)/ 0		/
	DATA cv_hi_d3  (to_vbps+4)/ 0		/
	DATA cv_lo_d4  (to_vbps+4)/ 0		/
	DATA cv_hi_d4  (to_vbps+4)/ 0		/
	DATA cv_lo_d5  (to_vbps+4)/ 0		/
	DATA cv_hi_d5  (to_vbps+4)/ 0		/
	DATA cv_lo_d6  (to_vbps+4)/ 0		/
	DATA cv_hi_d6  (to_vbps+4)/ 0		/

	DATA cv_category (to_vbps+5)/ cat_calc_var	/
	DATA cv_variable (to_vbps+5)/ pdvdt		/
	DATA cv_lo_d1  (to_vbps+5)/ 0		/
	DATA cv_hi_d1  (to_vbps+5)/ 0		/
	DATA cv_lo_d2  (to_vbps+5)/ 0		/
	DATA cv_hi_d2  (to_vbps+5)/ 0		/
	DATA cv_lo_d3  (to_vbps+5)/ 0		/
	DATA cv_hi_d3  (to_vbps+5)/ 0		/
	DATA cv_lo_d4  (to_vbps+5)/ 0		/
	DATA cv_hi_d4  (to_vbps+5)/ 0		/
	DATA cv_lo_d5  (to_vbps+5)/ 0		/
	DATA cv_hi_d5  (to_vbps+5)/ 0		/
	DATA cv_lo_d6  (to_vbps+5)/ 0		/
	DATA cv_hi_d6  (to_vbps+5)/ 0		/

**************************************************************************

	DATA cv_category (to_sali+1)/ cat_file_var	/
	DATA cv_variable (to_sali+1)/ psalt		/
	DATA cv_lo_d1  (to_sali+1)/ 0		/
	DATA cv_hi_d1  (to_sali+1)/ 0		/
	DATA cv_lo_d2  (to_sali+1)/ 0		/
	DATA cv_hi_d2  (to_sali+1)/ 0		/
	DATA cv_lo_d3  (to_sali+1)/ 0		/
	DATA cv_hi_d3  (to_sali+1)/ 0		/
	DATA cv_lo_d4  (to_sali+1)/ 0		/
	DATA cv_hi_d4  (to_sali+1)/ 0		/
	DATA cv_lo_d5  (to_sali+1)/ 0		/
	DATA cv_hi_d5  (to_sali+1)/ 0		/
	DATA cv_lo_d6  (to_sali+1)/ 0		/
	DATA cv_hi_d6  (to_sali+1)/ 0		/

**************************************************************************

	DATA cv_category (to_dens+1)/ cat_file_var	/
	DATA cv_variable (to_dens+1)/ ptemp		/
	DATA cv_lo_d1  (to_dens+1)/ 0		/
	DATA cv_hi_d1  (to_dens+1)/ 0		/
	DATA cv_lo_d2  (to_dens+1)/ 0		/
	DATA cv_hi_d2  (to_dens+1)/ 0		/
	DATA cv_lo_d3  (to_dens+1)/ 0		/
	DATA cv_hi_d3  (to_dens+1)/ 0		/
	DATA cv_lo_d4  (to_dens+1)/ 0		/
	DATA cv_hi_d4  (to_dens+1)/ 0		/
	DATA cv_lo_d5  (to_dens+1)/ 0		/
	DATA cv_hi_d5  (to_dens+1)/ 0		/
	DATA cv_lo_d6  (to_dens+1)/ 0		/
	DATA cv_hi_d6  (to_dens+1)/ 0		/

	DATA cv_category (to_dens+2)/ cat_file_var	/
	DATA cv_variable (to_dens+2)/ psalt		/
	DATA cv_lo_d1  (to_dens+2)/ 0		/
	DATA cv_hi_d1  (to_dens+2)/ 0		/
	DATA cv_lo_d2  (to_dens+2)/ 0		/
	DATA cv_hi_d2  (to_dens+2)/ 0		/
	DATA cv_lo_d3  (to_dens+2)/ 0		/
	DATA cv_hi_d3  (to_dens+2)/ 0		/
	DATA cv_lo_d4  (to_dens+2)/ 0		/
	DATA cv_hi_d4  (to_dens+2)/ 0		/
	DATA cv_lo_d5  (to_dens+2)/ 0		/
	DATA cv_hi_d5  (to_dens+2)/ 0		/
	DATA cv_lo_d6  (to_dens+2)/ 0		/
	DATA cv_hi_d6  (to_dens+2)/ 0		/

**************************************************************************

	DATA cv_category (to_ubp +1)/ cat_calc_var	/
	DATA cv_variable (to_ubp +1)/ pubpi		/
	DATA cv_lo_d1  (to_ubp +1)/ 0		/
	DATA cv_hi_d1  (to_ubp +1)/ 0		/
	DATA cv_lo_d2  (to_ubp +1)/ 0		/
	DATA cv_hi_d2  (to_ubp +1)/ 0		/
	DATA cv_lo_d3  (to_ubp +1)/ 0	/
	DATA cv_hi_d3  (to_ubp +1)/ 0	/
	DATA cv_lo_d4  (to_ubp +1)/ 0		/
	DATA cv_hi_d4  (to_ubp +1)/ 0		/
	DATA cv_lo_d5  (to_ubp +1)/ 0		/
	DATA cv_hi_d5  (to_ubp +1)/ 0		/
	DATA cv_lo_d6  (to_ubp +1)/ 0		/
	DATA cv_hi_d6  (to_ubp +1)/ 0		/

	DATA cv_category (to_ubp +2)/ cat_calc_var	/
	DATA cv_variable (to_ubp +2)/ pubps		/
	DATA cv_lo_d1  (to_ubp +2)/ 0		/
	DATA cv_hi_d1  (to_ubp +2)/ 0		/
	DATA cv_lo_d2  (to_ubp +2)/ 0		/
	DATA cv_hi_d2  (to_ubp +2)/ 0		/
	DATA cv_lo_d3  (to_ubp +2)/ 0		/
	DATA cv_hi_d3  (to_ubp +2)/ 0		/
	DATA cv_lo_d4  (to_ubp +2)/ 0		/
	DATA cv_hi_d4  (to_ubp +2)/ 0		/
	DATA cv_lo_d5  (to_ubp +2)/ 0		/
	DATA cv_hi_d5  (to_ubp +2)/ 0		/
	DATA cv_lo_d6  (to_ubp +2)/ 0		/
	DATA cv_hi_d6  (to_ubp +2)/ 0		/

**************************************************************************

	DATA cv_category (to_vbp +1)/ cat_calc_var	/
	DATA cv_variable (to_vbp +1)/ pvbpi		/
	DATA cv_lo_d1  (to_vbp +1)/ 0		/
	DATA cv_hi_d1  (to_vbp +1)/ 0		/
	DATA cv_lo_d2  (to_vbp +1)/ 0		/
	DATA cv_hi_d2  (to_vbp +1)/ 0		/
	DATA cv_lo_d3  (to_vbp +1)/ 0	/
	DATA cv_hi_d3  (to_vbp +1)/ 0	/
	DATA cv_lo_d4  (to_vbp +1)/ 0		/
	DATA cv_hi_d4  (to_vbp +1)/ 0		/
	DATA cv_lo_d5  (to_vbp +1)/ 0		/
	DATA cv_hi_d5  (to_vbp +1)/ 0		/
	DATA cv_lo_d6  (to_vbp +1)/ 0		/
	DATA cv_hi_d6  (to_vbp +1)/ 0		/

	DATA cv_category (to_vbp +2)/ cat_calc_var	/
	DATA cv_variable (to_vbp +2)/ pvbps		/
	DATA cv_lo_d1  (to_vbp +2)/ 0		/
	DATA cv_hi_d1  (to_vbp +2)/ 0		/
	DATA cv_lo_d2  (to_vbp +2)/ 0		/
	DATA cv_hi_d2  (to_vbp +2)/ 0		/
	DATA cv_lo_d3  (to_vbp +2)/ 0		/
	DATA cv_hi_d3  (to_vbp +2)/ 0		/
	DATA cv_lo_d4  (to_vbp +2)/ 0		/
	DATA cv_hi_d4  (to_vbp +2)/ 0		/
	DATA cv_lo_d5  (to_vbp +2)/ 0		/
	DATA cv_hi_d5  (to_vbp +2)/ 0		/
	DATA cv_lo_d6  (to_vbp +2)/ 0		/
	DATA cv_hi_d6  (to_vbp +2)/ 0		/

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	DATA cv_category (to_cmsk+1)/ cat_file_var	/
	DATA cv_variable (to_cmsk+1)/ ptemp		/
	DATA cv_lo_d1  (to_cmsk+1)/ 0		/
	DATA cv_hi_d1  (to_cmsk+1)/ 0		/
	DATA cv_lo_d2  (to_cmsk+1)/ 0		/
	DATA cv_hi_d2  (to_cmsk+1)/ 0		/
	DATA cv_lo_d3  (to_cmsk+1)/ -1		/
	DATA cv_hi_d3  (to_cmsk+1)/ +1		/
	DATA cv_lo_d4  (to_cmsk+1)/ 0		/
	DATA cv_hi_d4  (to_cmsk+1)/ 0		/
	DATA cv_lo_d5  (to_cmsk+1)/ 0		/
	DATA cv_hi_d5  (to_cmsk+1)/ 0		/
	DATA cv_lo_d6  (to_cmsk+1)/ 0		/
	DATA cv_hi_d6  (to_cmsk+1)/ 0		/

	DATA cv_category (to_cmsk+2)/ cat_file_var	/
	DATA cv_variable (to_cmsk+2)/ psalt		/
	DATA cv_lo_d1  (to_cmsk+2)/ 0		/
	DATA cv_hi_d1  (to_cmsk+2)/ 0		/
	DATA cv_lo_d2  (to_cmsk+2)/ 0		/
	DATA cv_hi_d2  (to_cmsk+2)/ 0		/
	DATA cv_lo_d3  (to_cmsk+2)/ -1		/
	DATA cv_hi_d3  (to_cmsk+2)/ +1		/
	DATA cv_lo_d4  (to_cmsk+2)/ 0 		/
	DATA cv_hi_d4  (to_cmsk+2)/ 0 		/
	DATA cv_lo_d5  (to_cmsk+2)/ 0		/
	DATA cv_hi_d5  (to_cmsk+2)/ 0		/
	DATA cv_lo_d6  (to_cmsk+2)/ 0		/
	DATA cv_hi_d6  (to_cmsk+2)/ 0		/

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	DATA cv_category (to_w_t +1)/ cat_file_var	/
	DATA cv_variable (to_w_t +1)/ pu		/
	DATA cv_lo_d1  (to_w_t +1)/ -1		/
	DATA cv_hi_d1  (to_w_t +1)/ 0		/
	DATA cv_lo_d2  (to_w_t +1)/ -1		/
	DATA cv_hi_d2  (to_w_t +1)/ 0		/
	DATA cv_lo_d3  (to_w_t +1)/ 0		/
	DATA cv_hi_d3  (to_w_t +1)/ 0		/
	DATA cv_lo_d4  (to_w_t +1)/ 0		/
	DATA cv_hi_d4  (to_w_t +1)/ 0		/
	DATA cv_lo_d5  (to_w_t +1)/ 0		/
	DATA cv_hi_d5  (to_w_t +1)/ 0		/
	DATA cv_lo_d6  (to_w_t +1)/ 0		/
	DATA cv_hi_d6  (to_w_t +1)/ 0		/

	DATA cv_category (to_w_t +2)/ cat_file_var	/
	DATA cv_variable (to_w_t +2)/ pv		/
	DATA cv_lo_d1  (to_w_t +2)/ -1		/
	DATA cv_hi_d1  (to_w_t +2)/ 0		/
	DATA cv_lo_d2  (to_w_t +2)/ -1		/
	DATA cv_hi_d2  (to_w_t +2)/ 0		/
	DATA cv_lo_d3  (to_w_t +2)/ 0		/
	DATA cv_hi_d3  (to_w_t +2)/ 0		/
	DATA cv_lo_d4  (to_w_t +2)/ 0		/
	DATA cv_hi_d4  (to_w_t +2)/ 0		/
	DATA cv_lo_d5  (to_w_t +2)/ 0		/
	DATA cv_hi_d5  (to_w_t +2)/ 0		/
	DATA cv_lo_d6  (to_w_t +2)/ 0		/
	DATA cv_hi_d6  (to_w_t +2)/ 0		/

**************************************************************************

	DATA cv_category (to_cair+1)/ cat_file_var	/
	DATA cv_variable (to_cair+1)/ pairt_special	/
	DATA cv_lo_d1  (to_cair+1)/ 0		/
	DATA cv_hi_d1  (to_cair+1)/ 0		/
	DATA cv_lo_d2  (to_cair+1)/ 0		/
	DATA cv_hi_d2  (to_cair+1)/ 0		/
	DATA cv_lo_d3  (to_cair+1)/ 0		/
	DATA cv_hi_d3  (to_cair+1)/ 0		/
	DATA cv_lo_d4  (to_cair+1)/ 0		/
	DATA cv_hi_d4  (to_cair+1)/ 0		/
	DATA cv_lo_d5  (to_cair+1)/ 0		/
	DATA cv_hi_d5  (to_cair+1)/ 0		/
	DATA cv_lo_d6  (to_cair+1)/ 0		/
	DATA cv_hi_d6  (to_cair+1)/ 0		/

**************************************************************************

	DATA cv_category (to_air +1)/ cat_file_var	/
	DATA cv_variable (to_air +1)/ ptemp		/
	DATA cv_lo_d1  (to_air +1)/ 0		/
	DATA cv_hi_d1  (to_air +1)/ 0		/
	DATA cv_lo_d2  (to_air +1)/ 0		/
	DATA cv_hi_d2  (to_air +1)/ 0		/
	DATA cv_lo_d3  (to_air +1)/ 0		/
	DATA cv_hi_d3  (to_air +1)/ 0		/
	DATA cv_lo_d4  (to_air +1)/ 0		/
	DATA cv_hi_d4  (to_air +1)/ 0		/
	DATA cv_lo_d5  (to_air +1)/ 0		/
	DATA cv_hi_d5  (to_air +1)/ 0		/
	DATA cv_lo_d6  (to_air +1)/ 0		/
	DATA cv_hi_d6  (to_air +1)/ 0		/

	DATA cv_category (to_air +2)/ cat_calc_var	/
	DATA cv_variable (to_air +2)/ pcair_special	/
	DATA cv_lo_d1  (to_air +2)/ 0		/
	DATA cv_hi_d1  (to_air +2)/ 0		/
	DATA cv_lo_d2  (to_air +2)/ 0		/
	DATA cv_hi_d2  (to_air +2)/ 0		/
	DATA cv_lo_d3  (to_air +2)/ 0		/
	DATA cv_hi_d3  (to_air +2)/ 0		/
	DATA cv_lo_d4  (to_air +2)/ 0		/
	DATA cv_hi_d4  (to_air +2)/ 0		/
	DATA cv_lo_d5  (to_air +2)/ 0		/
	DATA cv_hi_d5  (to_air +2)/ 0		/
	DATA cv_lo_d6  (to_air +2)/ 0		/
	DATA cv_hi_d6  (to_air +2)/ 0		/

	END

	CHARACTER*(*) FUNCTION AUTO_FILENAME( coding, cx, mr, flen )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* create a string describing the data set, region, transformations and variable
* that is suitable for a filename for listed output

* format is Wdddddddvvvv.iiiiijjjjjkkkkklllllmmmmmnnnnn
* where ddddd is the data set id
* 	vvvv identifies the variable or expression
* and	iiiii,jjjjj,kkkkk,lllll,mmmmm,nnnnn identify the axis regions and transformations

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 9/26/87
* revision 0.1 - 3/10/88 - eliminated HASH_NAME (moved to VAR_CODE)
* revision 0.2 - 6/27/88 - "coding" received in CALL instead of XPROG_STATE.CMN
* V200:  5/19/89 - 4D symmetrical
*	12/19/89 - eliminated the possibility of multiple data set variables
* Unix/RISC port - 9/91 - GET_DSET_NAME --> GET_SHORT_DSET_NAME (no path)
* SUN port - cleaned up the calculation of flen using risc_buff
* V230:  6/9/92 - distinct requirements for netCDF: "F" leadin character and
*                 extension ".cdf"
*               - also added protections against name overflowing buffer
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xtext_info.cmn'
	include 'xprog_state.cmn'
        include 'xrisc.cmn'

* calling argument declarations
	CHARACTER*(*)	coding
	INTEGER		cx, mr, flen

* local parameter declarations:
	LOGICAL    no_decims
	PARAMETER( no_decims = .FALSE. )

* local variable declarations:
	LOGICAL	  include_dset, include_vcode, include_axis(nferdims)
	CHARACTER LOHI_WORLD*24, LEGAL_CHARS*24, CX_DIM_STR*24,
     .		  LEFINT*4, SANITARY_VAR_CODE*4
	INTEGER TM_LENSTR,
     .		slen, leg_len, dset, idim, minus, mp
	
* determine special mods requested via "AUTO-q" where "q" is X,Y,Z,T,I,J,K,L,D,V
	minus = INDEX( coding, '-' )
	IF ( minus .EQ. 0 ) THEN
	   include_dset  = .TRUE.
	   include_vcode = .TRUE.
	   DO 10 idim = 1, nferdims
 10	   include_axis( idim ) = .TRUE.
	ELSE
	   mp = minus + 1
	   include_dset  = INDEX(coding(mp:), 'D' ) .EQ. 0
	   include_vcode = INDEX(coding(mp:), 'V' ) .EQ. 0
	   DO 20 idim = 1, nferdims
	   include_axis( idim ) = 
     .			INDEX(coding(mp:), ww_dim_name(idim) ) .EQ. 0
     .		  .AND. INDEX(coding(mp:), ss_dim_name(idim) ) .EQ. 0
 20	   CONTINUE
	ENDIF

* don't include information on axes that are irrelevant
	DO 30 idim = 1, nferdims
	  IF ( cx_lo_ww(idim,cx) .EQ. unspecified_val8 )
     .						include_axis(idim) = .FALSE.
 30	CONTINUE

* special lead-in characters (so DIR listings are neat)
        IF ( list_fmt_type .EQ. plist_unformatted ) THEN
           risc_buff = 'UNF'
           flen = 3
        ELSEIF ( list_fmt_type .EQ. plist_epic ) THEN
           risc_buff = 'EP'
           flen = 2
        ELSEIF ( list_fmt_type .EQ. plist_gt ) THEN
           risc_buff = 'GT'
           flen = 2
        ELSEIF ( list_fmt_type .EQ. plist_CDF ) THEN
           risc_buff = 'F'
           flen = 1
        ELSE
           risc_buff = 'W'
	   flen = 1
        ENDIF

* data set name or "nnnsets"
	IF ( include_dset ) THEN
	   dset = cx_data_set( cx )
	   IF ( dset .NE. pdset_irrelevant ) THEN
	      CALL GET_SHORT_DSET_NAME( dset, risc_buff(flen+1:), slen )
	      flen = flen + slen
	   ENDIF
	ENDIF

* variable code or Ennn ( random hashed number to represent the expression )
	IF ( include_vcode ) THEN
           risc_buff( flen+1:flen+4 ) = SANITARY_VAR_CODE
     .                          ( mr_category(mr), mr_variable(mr) )
	   flen = TM_LENSTR( risc_buff(:flen+4) )
	ENDIF

* netCDF filenames replace the elaborate AUTOFILENAME extension with ".cdf"
        IF ( list_fmt_type .EQ. plist_CDF ) THEN
           risc_buff = risc_buff(:flen) // '.cdf'
           flen = flen + 4
        ELSE
* non-netCDF filenames:
* point to separate name from extension
	   flen = flen + 1
	   risc_buff( flen:flen ) = '.'

* all relevant axis limits
	   DO 100 idim = 1, nferdims
	      IF ( include_axis( idim ) 
     .	  .   AND. cx_lo_ss( cx, idim ) .NE. unspecified_int4 ) THEN
	         risc_buff( flen+1:) = LEGAL_CHARS(
     .		   CX_DIM_STR(idim,cx,':',no_decims,slen), leg_len )
	         flen = flen + leg_len
	      ENDIF
 100	   CONTINUE
        ENDIF

* pass result back - overwrite garbage from "LEGAL_CHARS" with blanks
        risc_buff(flen+1:) = ' '
	AUTO_FILENAME = risc_buff

	RETURN
	END

	SUBROUTINE RE_ASSIGN_VARIABLE( mr, new_cx )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* re-assign the data which is currently cataloged in the memory variable
* table under mr to the context information stored in new_cx

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 2/19/87
* V200:  6/20/89 - improved deletion priority scheme
*		 - variable is assumed NOT to be in deletion chain
*		 - use ASSIGN_MR_CX
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V702:  3/17 *sh* dynamic memory management

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'

* calling argument declarations:
	INTEGER mr, new_cx

* internal variable declarations:
	INTEGER HASH_CX, prev, next, pile, head

* this should never happen, but to be safe ...
	IF (mr_protected(mr) .EQ. mr_not_protected) THEN
	   CALL WARN("crptn??: re_assign_variable")
	   essential_mem = essential_mem + mr_size(mr)
	   IF (essential_mem.GT.peak_essential_mem) 
     .		peak_essential_mem = essential_mem
	ENDIF

* flag the variabe as in progress
	mr_protected(mr) = mr_in_progress

* make this mem var the property of the new context
	CALL ASSIGN_MR_CX( new_cx, mr )

* correct the links to put this in the right hash pile
*    ... remove variable slot from hash pile doubly linked list
	   prev = mv_blink( mr )
	   next = mv_flink( mr )
	   mv_flink( prev ) = next
	   mv_blink( next ) = prev
*    ... add the slot to the head of the correct hash pile
	   pile = HASH_CX( new_cx )
	   head = mv_flink( pile )
	   mv_flink( pile ) = mr
	   mv_flink( mr ) = head
	   mv_blink( mr ) = pile
	   mv_blink( head ) = mr

	RETURN
	END

	subroutine ekeyrd (varcd, labsml, label, comment)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)ekeyrd.F	1.1.1.1    7/30/88
C**
C**
C***********************************************************************        C**
C**                 EPIC
C**
C***********************************************************************        C**
C**
c
c  Reads EPICKEY file (Unit lun21) to get short graph label, full label and
c  comment for variable code varcd.
c
c  Programmed by N. Soreide, Oct 85.
c
	common /epiclun/ lun1,lun11,lun21
c
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
C
C *kob* 1/03 - g77 port requires format of nX, rather than just X.  
C              Assuming 1x is proper
	character varcd*(*), labsml*(*), label*(*), comment*(*)
#ifdef unix
	character varrd*4
#endif
c
	if (lun21 .eq. 0) lun21=21
#ifdef unix
	rewind(lun21)
10	read (lun21, 100,err=200,end=200) varrd, labsml, label, comment
100	format (a4, 1x, a3, 1x, a25, 1x, a97)
	if(varrd.ne.varcd)goto 10
#else
        read (lun21, 100, key=varcd, err=200) labsml, label, comment
100     format (4x, x, a3, x, a25, x, a97)
#endif
	return
c
200	labsml(1:)=' '
	label(1:)=' '
	comment(1:)=' '
	return
	end

	SUBROUTINE IS_PROMOTE_GLOBAL( *, *, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Issue 1667
* create a string or float abstract array containing an attribute value
* from a global attribute of the dataset
* v751 *acm*  6/19 Allow for longer strings as attribute values


        IMPLICIT NONE
        include 'tmap_dims.parm'
#       include "tmap_dset.parm"
        include 'xdset_info.cmn_text'
#include "netcdf.inc"
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xvariables.cmn'
	include	'xcontext.cmn'
	include	'xprog_state.cmn'

* calling argument declarations:
	INTEGER status

* internal variable declarations:
        LOGICAL	NC_GET_ATTRIB, att_done, got_it, gedit
	CHARACTER*128 VAR_CODE, varname, rqst_name, attname
	CHARACTER*1028 buff
	CHARACTER*48  TM_FMT, numstr
	CHARACTER*1   null, comma
	INTEGER	CGRID_SIZE, STR_SAME, TM_LENSTR1,
     .		mr, cx, size, n, dset, vtype, varid, rqst_type, attype, 
     .          attlen, ndims, nvars, ngatts, recdim, iatt, nvatts, idim, 
     .          nd, attoutflag, i, cat, attid, npts, nddims, blen, nlen, maxlen
	INTEGER*8 n8
	REAL	bad

        REAL*8, DIMENSION(:), ALLOCATABLE :: attvals

* --- end of introductory code ---
* initialize

	cx = is_cx( isp )
	size = CGRID_SIZE(cx)
	dset = cx_data_set( cx )
	vtype = cx_type( cx )
	bad  = cx_bad_data(cx)
	null = ''
	attype = ptype_unknown
	maxlen = 1028
        
        IF (dset .LE. pdset_irrelevant) dset = cx_data_set( is_cx(isp-1) )

        CALL CD_GET_DS_INFO (dset, nddims, nvars, ngatts, recdim, status)

* reserve and catalog space for the result
* or delete and re-create if already exists?  

	mr = is_mr(isp)
	CALL CREATE_TEMP_MEM_VAR( cx, mr, status ) 
	IF ( status .NE. ferr_ok ) GOTO 5000

* diagnostic output
	IF (mode_diagnostic) 
     .      CALL DIAGNOSTIC_OUT ('global_attrib_val', mr, point_to_mr)
	
	rqst_name = VAR_CODE(cx_category(is_cx(isp-1)), cx_variable(is_cx(isp-1)))

* Destination type is string or numeric
	rqst_type = cx_type(is_cx(isp-1))

* Is the user asking for the member dataset names?  Use attname to store the dset name

        attname =  'member_dset'
        IF (STR_SAME(attname, rqst_name) .EQ. 0) THEN 
	    CALL GET_SHORT_DSET_NAME(dset, attname, attlen)
	    nd = 1
	    CALL INIT_C_STRING_ARRAY( 1, memry(mr)%ptr,
     .				     mr_c_pointer(mr)    )
	    CALL STORE_STRING(attname(1:attlen), mr, nd-1, status)
	    GOTO 1000
        ENDIF

* Is the user asking for the value of a global attribute?

        varname = '.'
        CALL CD_GET_VAR_ID (dset, varname, varid, status)

	nlen = TM_LENSTR1(rqst_name)
	nd = INDEX(rqst_name, '_G_')
	IF (nd .GT. 0) THEN
	   gedit = .TRUE.
	   DO iatt = 1, ngatts
              CALL CD_GET_VAR_ATT_NAME (dset, varid, iatt, attname, status)
              IF (STR_SAME(attname, rqst_name) .EQ. 0) THEN
	         gedit = .FALSE.   ! original att was renamed, adding _g_
		 EXIT
               ENDIF
	    ENDDO
	    
	    IF (gedit) rqst_name = rqst_name(:nd-1)
	ENDIF

	att_done = .FALSE.
        attloop: DO iatt = 1, ngatts
           CALL CD_GET_VAR_ATT_NAME (dset, varid, iatt, attname, status)
           IF (STR_SAME(attname, rqst_name) .EQ. 0) THEN 

              CALL CD_GET_VAR_ATT_INFO (dset, varid, iatt, 
     .                 attname, attype, attlen, attoutflag, status )

	      IF ( attype .EQ. NCCHAR ) THEN

* ... set up FORTRAN-independent pointer
	         CALL INIT_C_STRING_ARRAY( 1, memry(mr)%ptr,
     .				     mr_c_pointer(mr)    )
* ... string
	         CALL ATTRIB_STRING (cx, mr, dset, varid, 
     .			         varname, rqst_name, status)
	      ELSE

* ... numeric
	         IF (attlen.EQ.1 .AND. rqst_type.NE.ptype_string)  THEN 
                    CALL ATTRIB_VALS (memry(mr)%ptr, 
     .                  size, n, dset, varid, varname, rqst_name, status)
	         ELSE

* For multi-valued numeric, turn it into a string listing the values.

* ... set up FORTRAN-independent pointer
                    CALL INIT_C_STRING_ARRAY( 1, memry(mr)%ptr,
     .				     mr_c_pointer(mr)    )

		    ALLOCATE (attvals(attlen))

		    got_it = NC_GET_ATTRIB ( dset, varid, attname,
     .                           .FALSE., varname, maxlen,
     .                           attlen, attoutflag, buff, attvals )
		    IF (.NOT. got_it) GOTO 5000

		    blen = 1
		    comma = ','
		    DO i = 1, attlen
		       numstr = TM_FMT(attvals(i), 7, 14, nlen)
		       buff(blen:) = numstr(:nlen)
		       blen = blen + nlen
		       IF (i .EQ. attlen) comma = ''
		       buff(blen:) = comma
		       blen = blen+1
		    ENDDO

c store in string variable

		    n = 1
		    blen = TM_LENSTR1(buff)
		    CALL STORE_STRING(buff(1:blen), mr, n-1, status)

		    DEALLOCATE(attvals)

	         ENDIF

	      ENDIF
              IF ( status .NE. ferr_ok ) GOTO 5000

	      att_done = .TRUE.
	      EXIT attloop
           ENDIF

        ENDDO attloop

* ... The attribute is not present in this member set.
*     Fill in with a null or missing value

        IF (.NOT. att_done) THEN

           IF ( attype .EQ. ptype_unknown) THEN
              IF (vtype .EQ. ptype_string) THEN
		 attype = NCCHAR
              ELSE
		 attype = NCFLOAT
              ENDIF
           ENDIF

           IF ( attype .EQ. NCCHAR ) THEN
              CALL INIT_C_STRING_ARRAY( 1, memry(mr)%ptr,
     .				     mr_c_pointer(mr)    )
              CALL STORE_STRING(null(:0), mr, 0, status)
           ELSE
              CALL FILL_MEMORY ( mr, bad )
           ENDIF
        ENDIF

* result is ready to return to the stack
1000    CONTINUE
        is_mr( isp ) = mr
        mr_bad_data(mr) = cx_bad_data(cx)

	mr_protected(mr) = mr_in_progress 

* got the requested component
	RETURN 2

! RETURN 1, which is to request a sub-component, is never used ...

* error exit
 5000	RETURN
	END	

*
* samplexyt_nrst.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without anx fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and anx derivative works thereof, and
*  its supporting documentation for anx purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in anx publications that result from
*  the use of this software or in anx product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in anx advertising or publicity to endorse or promote anx products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with anx support, consulting,
*  training or assistance of anx kind with regard to the use, operation
*  and performance of this software nor to provide the user with anx
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND Anx EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR Anx SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR Anx DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
*  -------------------------------------------------------------------
*
* This function samples 4-d data at the x, y, t locations indicated by 
* args 2, 3,4
* 1/18/08  Ansley Manke 
*         Result is abstract on the x axis, normal on the y and t axes,
*         and keeps the z axes of the input 4-d data
* 5/15/08 Deal with sample indices outside the axis range of the grid
* 6/15/08 When the x axis is modulo the above threw out data unnecessarily
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE samplexyt_nrst_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CHARACTER*100 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns data sampled at a set of (X,Y,T) points, ',
     .        'using nearest grid intersection')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 4)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                ABSTRACT,        NORMAL,
     .                                IMPLIED_BY_ARGS, NORMAL,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 9)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'DAT_TO_SAMPLE')
      CALL ef_set_arg_desc(id, arg, 'variable (x,y,z,t,e,f) to sample')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, YES, NO, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'XPTS')
      CALL ef_set_arg_desc(id, arg, 'X values of sample points')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'YPTS')
      CALL ef_set_arg_desc(id, arg, 'Y values of sample points')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'TPTS')
      CALL ef_set_arg_desc(id, arg, 'T values of sample points')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* loss               lo subscript for an axis
*
* hiss               hi subscript for an axis
*

      SUBROUTINE samplexyt_nrst_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER my_lo, my_hi
      INTEGER nx, ny, nz, nt, ne, nf

*     Use utility functions to get context information about the 
*     second argument, to set the abstract axis lo and hi indices.

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nx = arg_hi_ss(X_AXIS, ARG2) - arg_lo_ss(X_AXIS, ARG2) + 1
      ny = arg_hi_ss(Y_AXIS, ARG2) - arg_lo_ss(Y_AXIS, ARG2) + 1
      nz = arg_hi_ss(Z_AXIS, ARG2) - arg_lo_ss(Z_AXIS, ARG2) + 1
      nt = arg_hi_ss(T_AXIS, ARG2) - arg_lo_ss(T_AXIS, ARG2) + 1
      ne = arg_hi_ss(E_AXIS, ARG2) - arg_lo_ss(E_AXIS, ARG2) + 1
      nf = arg_hi_ss(F_AXIS, ARG2) - arg_lo_ss(F_AXIS, ARG2) + 1

      my_lo = 1
      my_hi = max(nx,ny,nz,nt,ne,nf)

      CALL ef_set_axis_limits(id, X_AXIS, my_lo, my_hi)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END
*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE samplexyt_nrst_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

*  xaxdat
      CALL ef_set_work_array_dims_6d(id, 1,
     .          arg_lo_ss(X_AXIS,ARG1), 1, 1, 1, 1, 1,
     .          arg_hi_ss(X_AXIS,ARG1)+1, 1, 1, 1, 1, 1)

*  yaxdat
      CALL ef_set_work_array_dims_6d(id, 2,
     .          arg_lo_ss(Y_AXIS,ARG1), 1, 1, 1, 1, 1,
     .          arg_hi_ss(Y_AXIS,ARG1), 1, 1, 1, 1, 1)

*  taxdat
      CALL ef_set_work_array_dims_6d(id, 3,
     .          arg_lo_ss(T_AXIS,ARG1), 1, 1, 1, 1, 1,
     .          arg_hi_ss(T_AXIS,ARG1)+1, 1, 1, 1, 1, 1)
     
*  xboxlo
      CALL ef_set_work_array_dims_6d(id, 4,
     .          arg_lo_ss(X_AXIS,ARG1), 1, 1, 1, 1, 1,
     .          arg_hi_ss(X_AXIS,ARG1), 1, 1, 1, 1, 1)

*  xboxhi
      CALL ef_set_work_array_dims_6d(id, 5,
     .          arg_lo_ss(X_AXIS,ARG1), 1, 1, 1, 1, 1,
     .          arg_hi_ss(X_AXIS,ARG1), 1, 1, 1, 1, 1)

*  yboxlo
      CALL ef_set_work_array_dims_6d(id, 6,
     .          arg_lo_ss(Y_AXIS,ARG1), 1, 1, 1, 1, 1,
     .          arg_hi_ss(Y_AXIS,ARG1), 1, 1, 1, 1, 1)

*  yboxhi
      CALL ef_set_work_array_dims_6d(id, 7,
     .          arg_lo_ss(Y_AXIS,ARG1), 1, 1, 1, 1, 1,
     .          arg_hi_ss(Y_AXIS,ARG1), 1, 1, 1, 1, 1)

*  tboxlo
      CALL ef_set_work_array_dims_6d(id, 8,
     .          arg_lo_ss(T_AXIS,ARG1), 1, 1, 1, 1, 1,
     .          arg_hi_ss(T_AXIS,ARG1), 1, 1, 1, 1, 1)

*  tboxhi
      CALL ef_set_work_array_dims_6d(id, 9,
     .          arg_lo_ss(T_AXIS,ARG1), 1, 1, 1, 1, 1,
     .          arg_hi_ss(T_AXIS,ARG1), 1, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE samplexyt_nrst_compute(id, arg_1, arg_2, arg_3, arg_4,
     .         result, xaxdat, yaxdat, taxdat, xboxlo, xboxhi, 
     .         yboxlo, yboxhi, tboxlo, tboxhi)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz, 
     .           mem4lot:mem4hit, mem4loe:mem4hie, mem4lof:mem4hif)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz, 
     .           mem5lot:mem5hit, mem5loe:mem5hie, mem5lof:mem5hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* Ignore the Y/Z/T/E/F dimensions in the work arrays since
* they are not used and Fortran is column major
      REAL*8 xaxdat(wrk1lox:wrk1hix)
      REAL*8 yaxdat(wrk2lox:wrk2hix)
      REAL*8 taxdat(wrk3lox:wrk3hix)
      REAL*8 xboxlo(wrk4lox:wrk4hix)
      REAL*8 xboxhi(wrk5lox:wrk5hix)
      REAL*8 yboxlo(wrk6lox:wrk6hix)
      REAL*8 yboxhi(wrk7lox:wrk7hix)
      REAL*8 tboxlo(wrk8lox:wrk8hix)
      REAL*8 tboxhi(wrk9lox:wrk9hix)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER STR_UPCASE
      LOGICAL TM_FPEQ, full_span

      INTEGER nx, nxx, nxy, nxz, nxt, nxe, nxf
      INTEGER ny, nyx, nyy, nyz, nyt, nye, nyf
      INTEGER nt, ntx, nty, ntz, ntt, nte, ntf
      INTEGER ndimx, ndimy, ndimt
      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2
      INTEGER i3, j3, k3, l3, m3, n3
      INTEGER i4, j4, k4, l4, m4, n4
      INTEGER ic, imatch, jmatch, lmatch, xflag
      INTEGER ibot, itop, jbot, jtop, lbot, ltop
      INTEGER xlo, xhi, ylo, yhi, tlo, thi
      INTEGER ilo, ihi, jlo, jhi, llo, lhi
      LOGICAL ok, its_dsg
      REAL fxbot, fxtop, fbb, ftb, fbt, ftt, aa, bb
      REAL xbot, xtop, ybot, ytop, tbot, ttop
      REAL x_to_xbot, x_to_xtop, y_to_ybot, y_to_ytop, t_to_tbot, t_to_ttop

      REAL dx, dy, dt, delmodx, delmodt, xpt, ypt, tpt
      REAL dxlo, dxhi, dylo, dyhi, dtlo, dthi
      CHARACTER err_msg*255, test_str*16

C  variables for checking axis characteristics (modulo axes)

      CHARACTER ax_name(6)*16, ax_units(6)*16
      LOGICAL backward(6), modulo(6), regular(6)

* Does the variable come from a Discrete Sampling Geometries dataset?  

      CALL EF_GET_ITS_DSG(id, ARG1, its_dsg )
      IF (its_dsg) THEN
         err_msg = 
     . 'Data is from a Discrete Sampling Geometries (DSG) dataset. Function does not apply.'
        GOTO 999
      ENDIF

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      nxx = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1
      nxy = arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) + 1
      nxz = arg_hi_ss(Z_AXIS,ARG2) - arg_lo_ss(Z_AXIS,ARG2) + 1
      nxt = arg_hi_ss(T_AXIS,ARG2) - arg_lo_ss(T_AXIS,ARG2) + 1
      nxe = arg_hi_ss(E_AXIS,ARG2) - arg_lo_ss(E_AXIS,ARG2) + 1
      nxf = arg_hi_ss(F_AXIS,ARG2) - arg_lo_ss(F_AXIS,ARG2) + 1
      nx = MAX(nxx, nxy, nxz, nxt, nxe, nxf)

      nyx = arg_hi_ss(X_AXIS,ARG3) - arg_lo_ss(X_AXIS,ARG3) + 1
      nyy = arg_hi_ss(Y_AXIS,ARG3) - arg_lo_ss(Y_AXIS,ARG3) + 1
      nyz = arg_hi_ss(Z_AXIS,ARG3) - arg_lo_ss(Z_AXIS,ARG3) + 1
      nyt = arg_hi_ss(T_AXIS,ARG3) - arg_lo_ss(T_AXIS,ARG3) + 1
      nye = arg_hi_ss(E_AXIS,ARG3) - arg_lo_ss(E_AXIS,ARG3) + 1
      nyf = arg_hi_ss(F_AXIS,ARG3) - arg_lo_ss(F_AXIS,ARG3) + 1
      ny = MAX(nyx, nyy, nyz, nyt, nye, nyf)

      ntx = arg_hi_ss(X_AXIS,ARG4) - arg_lo_ss(X_AXIS,ARG4) + 1
      nty = arg_hi_ss(Y_AXIS,ARG4) - arg_lo_ss(Y_AXIS,ARG4) + 1
      ntz = arg_hi_ss(Z_AXIS,ARG4) - arg_lo_ss(Z_AXIS,ARG4) + 1
      ntt = arg_hi_ss(T_AXIS,ARG4) - arg_lo_ss(T_AXIS,ARG4) + 1
      nte = arg_hi_ss(E_AXIS,ARG4) - arg_lo_ss(E_AXIS,ARG4) + 1
      ntf = arg_hi_ss(F_AXIS,ARG4) - arg_lo_ss(F_AXIS,ARG4) + 1
      nt = MAX(ntx, nty, ntz, ntt, nte, ntf)

      ndimx = 0
      ndimy = 0
      ndimt = 0
      DO 10 i = X_AXIS,F_AXIS
         IF ( arg_hi_ss(i,ARG2) .GT. arg_lo_ss(i,ARG2) )
     .       ndimx = ndimx + 1
         IF ( arg_hi_ss(i,ARG3) .GT. arg_lo_ss(i,ARG3) )
     .       ndimy = ndimy + 1
         IF ( arg_hi_ss(i,ARG4) .GT. arg_lo_ss(i,ARG4) )
     .       ndimt = ndimt + 1
   10 CONTINUE

      IF ((nx .NE. ny) .OR. (nx .NE. nt) .OR. 
     .    (ndimx .GT. 1) .OR. (ndimy .GT. 1) .OR. (ndimt .GT. 1)) THEN
         WRITE (err_msg, 20)
         GO TO 999
      ENDIF

   20 FORMAT('Arguments 2, 3, and 4 must be 1-dimensional ',
     .       'lists of equal length')

*  Get x, y, t coordinates of the data to be sampled.

      ilo = arg_lo_ss(X_AXIS,ARG1)
      ihi = arg_hi_ss(X_AXIS,ARG1)
      jlo = arg_lo_ss(Y_AXIS,ARG1)
      jhi = arg_hi_ss(Y_AXIS,ARG1)
      llo = arg_lo_ss(T_AXIS,ARG1)
      lhi = arg_hi_ss(T_AXIS,ARG1)

      CALL ef_get_coordinates(id, ARG1, X_AXIS, ilo, ihi, xaxdat)
      CALL ef_get_coordinates(id, ARG1, Y_AXIS, jlo, jhi, yaxdat)
      CALL ef_get_coordinates(id, ARG1, T_AXIS, llo, lhi, taxdat)
      CALL ef_get_box_lo_lim(id, ARG1, T_AXIS, llo, lhi, tboxlo)
      CALL ef_get_box_hi_lim(id, ARG1, T_AXIS, llo, lhi, tboxhi)

*  Check to see if input x axis is modulo, and if axes are regular.

      CALL ef_get_axis_info_6d(id, ARG1, ax_name, ax_units,
     .                         backward, modulo, regular)
      IF ( regular(1) ) THEN
         dx = xaxdat(ilo+1) - xaxdat(ilo)
         dxlo = dx/2.
         dxhi = dx/2.
      ELSE
         CALL ef_get_box_limits(id, ARG1, X_AXIS, ilo, ihi,
     .                          xboxlo, xboxhi)
         dxlo = (xboxlo(ilo+1) - xboxlo(ilo) ) / 2.
         dxhi = (xboxhi(ihi) - xboxhi(ihi-1) ) / 2.
      ENDIF

      IF ( regular(2) ) THEN
         dy = yaxdat(jlo+1) - yaxdat(jlo)
         dylo = dy/2.
         dyhi = dy/2.
      ELSE
         CALL ef_get_box_limits(id, ARG1, Y_AXIS, jlo, jhi,
     .                          yboxlo, yboxhi)
         dylo = (yboxlo(jlo+1) - yboxlo(jlo) )/ 2.
         dyhi = (yboxhi(jhi) - yboxlo(jhi-1) )/ 2.
      ENDIF

      IF ( regular(3) ) THEN
         dt = taxdat(llo+1) - yaxdat(llo)
         dtlo = dy/2.
         dthi = dy/2.
      ELSE
         CALL ef_get_box_limits(id, ARG1, T_AXIS, llo, lhi,
     .                          tboxlo, tboxhi)
         dtlo = (tboxlo(llo+1) - tboxlo(llo) )/ 2.
         dthi = (tboxhi(lhi) - tboxlo(lhi-1) )/ 2.
      ENDIF
      

*  Check to see if input x axis is modulo

      CALL ef_get_axis_info_6d(id, ARG1, ax_name, ax_units,
     .                         backward, modulo, regular)

      xlo = arg_lo_ss(X_AXIS,ARG1)
      xhi = arg_hi_ss(X_AXIS,ARG1)
      ylo = arg_lo_ss(Y_AXIS,ARG1)
      yhi = arg_hi_ss(Y_AXIS,ARG1)
      tlo = arg_lo_ss(T_AXIS,ARG1)
      thi = arg_hi_ss(T_AXIS,ARG1)

      IF ( modulo(1) ) THEN
         ic = STR_UPCASE (test_str, ax_units(1))
         ok = (test_str(1:3) .EQ. 'DEG') 
         dx = xaxdat(ilo+1) - xaxdat(ilo)
         delmodx = (xaxdat(ihi) + dxhi) -
     .             (xaxdat(ilo) - dxlo)
         IF ( .NOT. regular(1) )
     .      delmodx = xboxhi(ihi) - xboxlo(ilo)
         IF ( ok ) THEN 
            full_span = (delmodx .GT. 360.-dx)
            delmodx = 360.
         ELSE
            full_span = .TRUE.
         ENDIF
      ENDIF

      IF ( modulo(4) ) THEN
	 dt = tboxhi(tlo) - tboxlo(tlo)
	 delmodt = taxdat(thi) - taxdat(tlo) + dt
	 IF (.NOT.regular(4)) delmodt = tboxhi(thi) - tboxlo(tlo)
	 taxdat(thi+1) = taxdat(tlo)
      ENDIF

*  For each (xpt,ypt,tpt) triple, 
*  1) search the time coordinates of arg 1 for the nearest Time match
*  2) search the data array arg_1 for the nearest higher (x,y) grid 
*     coordinates.  Interpolate in 2 directions for the result.

      i2 = arg_lo_ss(X_AXIS,ARG2)
      j2 = arg_lo_ss(Y_AXIS,ARG2)
      k2 = arg_lo_ss(Z_AXIS,ARG2)
      l2 = arg_lo_ss(T_AXIS,ARG2)
      m2 = arg_lo_ss(E_AXIS,ARG2)
      n2 = arg_lo_ss(F_AXIS,ARG2)

      i3 = arg_lo_ss(X_AXIS,ARG3)
      j3 = arg_lo_ss(Y_AXIS,ARG3)
      k3 = arg_lo_ss(Z_AXIS,ARG3)
      l3 = arg_lo_ss(T_AXIS,ARG3)
      m3 = arg_lo_ss(E_AXIS,ARG3)
      n3 = arg_lo_ss(F_AXIS,ARG3)

      i4 = arg_lo_ss(X_AXIS,ARG4)
      j4 = arg_lo_ss(Y_AXIS,ARG4)
      k4 = arg_lo_ss(Z_AXIS,ARG4)
      l4 = arg_lo_ss(T_AXIS,ARG4)
      m4 = arg_lo_ss(E_AXIS,ARG4)
      n4 = arg_lo_ss(F_AXIS,ARG4)

* Y-axis and T-axis is normal to the result
      j = res_lo_ss(Y_AXIS)
      l = res_lo_ss(T_AXIS)

      DO 700 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         xpt = arg_2(i2,j2,k2,l2,m2,n2)
         ypt = arg_3(i3,j3,k3,l3,m3,n3)
         tpt = arg_4(i4,j4,k4,l4,m4,n4)

         IF ( xpt .EQ. bad_flag(ARG2) .OR.
     .        ypt .EQ. bad_flag(ARG3) .OR.
     .        tpt .EQ. bad_flag(ARG4) ) THEN
            DO 30 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
            DO 30 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
            DO 30 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
               result(i,j,k,l,m,n) = bad_flag_result
   30       CONTINUE
*           Go to the next triplet of coordinates
            GOTO 690
         ENDIF

* Try to get tpt in range if the T-axis is modulo
         IF ( modulo(4) ) THEN
            DO WHILE ( tpt .GE. tboxhi(thi) ) 
               tpt = tpt - delmodt
            ENDDO
            DO WHILE ( tpt .LT. tboxlo(tlo) )
               tpt = tpt + delmodt
            ENDDO
         ENDIF

* Check if tpt is in the T-axis range.
         lbot = ef_unspecified_int4
         lmatch = ef_unspecified_int4
         DO 410 l1 = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)
            IF ( TM_FPEQ(tpt, taxdat(l1)) ) THEN
               lmatch = l1
               GOTO 420
            ELSE IF ( tpt .GE. tboxlo(l1) ) THEN
               lbot = l1
            ENDIF
  410    CONTINUE

* Check that tpt is not beyond the upper end of the T-axis range.
         IF ( tpt .GT. tboxhi(thi) ) THEN
            IF ( .NOT. modulo(4) )
     .         lbot = ef_unspecified_int4
         ENDIF

  420    IF ( lmatch .NE. ef_unspecified_int4 ) THEN
            lbot = lmatch
            ltop = lmatch
         ELSE IF ( lbot .NE. ef_unspecified_int4 ) THEN
*           using cell bounds tboxlo, tboxhi
            ltop = lbot
         ELSE
*           tpt outside the grid
            DO 430 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
            DO 430 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
            DO 430 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
               result(i,j,k,l,m,n) = bad_flag_result
  430       CONTINUE
*           Go to the next triplet of coordinates
            GOTO 690
         ENDIF

         tbot = tboxlo(lbot)
         ttop = tboxhi(ltop)

         IF ( modulo(4) .AND. (ttop .LT. tbot) ) THEN
            lbot = thi
            ltop = tlo
            tbot = tbot - delmodt
            IF ( tpt .GT. ttop )
     .         tpt = tpt - delmodt
         ENDIF

         t_to_tbot = ABS(tpt - tbot)
         t_to_ttop = ABS(tpt - ttop)
         IF (t_to_tbot .LE. t_to_ttop) THEN
            l1 = lbot
         ELSE
            l1 = lbot+1
         ENDIF
         IF (l1.LT.arg_lo_ss(T_AXIS,ARG1) .OR. l1.GT.arg_hi_ss(T_AXIS,ARG1)) THEN
	    l1 = ef_unspecified_int4
	 ENDIF

* Flag for outside of a modulo axis
         xflag = 0

* Check if xpt is in the x-axis range.
         ibot = ef_unspecified_int4
         itop = ef_unspecified_int4
         imatch = ef_unspecified_int4
*  Locate the X point within the range of modulo X axis 
*  If we have the whole span, then use the point at the other
*  end to handle points within a half-grid cell of the edge.

         IF ( modulo(1) .AND. full_span ) THEN
            IF ( xpt .GE. xaxdat(ihi) .AND.
     .           xpt .LE. xaxdat(ihi) + dxhi ) THEN
               ibot = ihi
               xflag = 1
            ELSE IF ( xpt .GE. xaxdat(ihi) ) THEN
               DO WHILE ( xpt .GE. xaxdat(ihi) ) 
                  xpt = xpt - delmodx
               ENDDO
            ENDIF

            IF ( xpt .LT. xaxdat(ilo) .AND.
     .           xpt .GE. xaxdat(ilo) - dxlo ) THEN
               itop = ilo
               xflag = -1
            ELSE IF ( xpt .LT. xaxdat(ilo) ) THEN
               DO WHILE (xpt .LT. xaxdat(ilo) )
                  xpt = xpt + delmodx
               ENDDO
            ENDIF
	 ENDIF

* Source variable has subspan-modulo axis 

         IF ( modulo(1) .AND. .NOT.full_span ) THEN
            IF (modulo(1) .AND. xpt .GE. xaxdat(ihi) ) THEN
               DO WHILE ( xpt .GE. xaxdat(ihi) ) 
               xpt = xpt - delmodx
               ENDDO
            ENDIF

	    IF (modulo(1) .AND. xpt .LT. xaxdat(ilo) ) THEN
               DO WHILE (xpt .LT. xaxdat(ilo) )
                  xpt = xpt + delmodx
               ENDDO
            ENDIF
         ENDIF

         DO 120 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)
            IF ( TM_FPEQ(xpt, xaxdat(i1)) ) THEN
               imatch = i1
               GOTO 130
            ELSE IF ( i1  .EQ. arg_lo_ss(X_AXIS,ARG1)     .AND.
     .                xpt .LT. xaxdat(i1)       .AND.
     .                xpt .GT. xaxdat(i1)-dxhi  .AND.
     .               .NOT. modulo(1) ) THEN
               ibot = i1
            ELSE IF ( xpt .GE. xaxdat(i1) ) THEN
               ibot = i1
            ENDIF
 120     CONTINUE

         IF ( .NOT. modulo(1) .OR. (modulo(1) .AND..NOT.full_span )) THEN
            IF ( xpt .GT. xaxdat(ihi) .AND.
     .           xpt .LT. xaxdat(ihi) + dxhi ) THEN
               ibot = ihi
            ELSE IF ( xpt .GT. xaxdat(ihi) ) THEN
               ibot = ef_unspecified_int4   ! ARG_2 XPT outside of range 
            ENDIF
         ENDIF

* If the data is at the very top or bottom of a full-span modulo x axis, get the
* point from the other end.

         IF ( xflag .EQ. 1 ) THEN
            ibot = ihi
            itop = ilo
         ENDIF
         IF ( xflag .EQ. -1 ) THEN
            itop = ilo
            ibot = ihi
         ENDIF

 130    IF ( imatch .NE. ef_unspecified_int4 ) THEN
            ibot = imatch
            itop = imatch
         ELSE IF ( ibot .NE. ef_unspecified_int4 ) THEN
* If modulo(1) then there is an extra xaxdat so itop is in range
            itop = ibot + 1
         ELSE
*           xpt is outside the grid
            DO 140 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
            DO 140 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
            DO 140 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
               result(i,j,k,l,m,n) = bad_flag_result
  140       CONTINUE
*           Go to the next triplet of coordinates
            GOTO 690
         ENDIF

         xbot = xaxdat(ibot)
         xtop = xaxdat(itop)
         IF ( modulo(1) .AND. (xtop .LT. xbot) ) THEN
            ibot = xhi
            itop = xlo
            xbot = xbot - delmodx
            IF (xpt .GT. xtop)
     .         xpt = xpt - delmodx
         ENDIF
         x_to_xbot = ABS(xpt - xbot)
         x_to_xtop = ABS(xpt - xtop)
         IF (x_to_xbot .LE. x_to_xtop) THEN
            i1 = ibot
         ELSE
            i1 = ibot+1
         ENDIF
         IF (i1.LT.arg_lo_ss(X_AXIS,ARG1) .OR. i1.GT.arg_hi_ss(X_AXIS,ARG1)) THEN
	    IF (modulo(1) .AND. full_span) THEN 
	       IF (i1.LT.arg_lo_ss(X_AXIS,ARG1)) i1 = arg_hi_ss(X_AXIS,ARG1)
	       IF (i1.GT.arg_hi_ss(X_AXIS,ARG1)) i1 = arg_lo_ss(X_AXIS,ARG1)
	    ELSE
	       i1 = ef_unspecified_int4
	    ENDIF
	 ENDIF

* Check if ypt is in the Y-axis range.
         jbot = ef_unspecified_int4
         jmatch = ef_unspecified_int4

         DO 210 j1 = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)
            IF ( TM_FPEQ(ypt, yaxdat(j1)) ) THEN
               jmatch = j1
               GOTO 220
            ELSE IF ( ypt .GT. yaxdat(j1) ) THEN
               jbot = j1
            ENDIF
  210    CONTINUE

* Check that ypt is not beyond the upper end of the Y-axis range.
         IF ( ypt .GT. yaxdat(yhi) ) THEN
             jbot = ef_unspecified_int4
         ENDIF

  220    IF ( jmatch .NE. ef_unspecified_int4 ) THEN
            jbot = jmatch
            jtop = jmatch
         ELSE IF ( jbot .NE. ef_unspecified_int4) THEN
            jtop = jbot + 1
         ELSE
*           ypt outside the grid
            DO 230 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
            DO 230 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
            DO 230 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
               result(i,j,k,l,m,n) = bad_flag_result
  230       CONTINUE
*           Go to the next triplet of coordinates
            GOTO 690
         ENDIF

         ybot = yaxdat(jbot)
         ytop = yaxdat(jtop)
         y_to_ybot = ABS(ypt - ybot)
         y_to_ytop = ABS(ypt - ytop)
         IF (y_to_ybot .LE. y_to_ytop) THEN
            j1 = jbot
         ELSE
            j1 = jbot+1
         ENDIF
         IF (j1.LT.arg_lo_ss(Y_AXIS,ARG1) .OR. j1.GT.arg_hi_ss(Y_AXIS,ARG1)) THEN
	    j1 = ef_unspecified_int4
	 ENDIF



* Loop through the Z/E/F axes, assigning results for this coordinate pair
         n1 = arg_lo_ss(F_AXIS,ARG1)
         DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

         m1 = arg_lo_ss(E_AXIS,ARG1)
         DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               IF ( i1 .EQ. ef_unspecified_int4 .OR.
     .              j1 .EQ. ef_unspecified_int4 .OR.
     .              l1 .EQ. ef_unspecified_int4) THEN 
                  result(i,j,k,l,m,n) = bad_flag_result
               ELSE
	          result(i,j,k,l,m,n) = arg_1(i1,j1,k1,l1,m1,n1)
               ENDIF

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
 300        CONTINUE

            m1 = m1 + arg_incr(E_AXIS,ARG1)
 500     CONTINUE

            n1 = n1 + arg_incr(F_AXIS,ARG1)
 600     CONTINUE

* Only one of the ARG2, one of the ARG3, and one of ARG4 actually increments
 690     i2 = i2 + arg_incr(X_AXIS,ARG2)
         j2 = j2 + arg_incr(Y_AXIS,ARG2)
         k2 = k2 + arg_incr(Z_AXIS,ARG2)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
         m2 = m2 + arg_incr(E_AXIS,ARG2)
         n2 = n2 + arg_incr(F_AXIS,ARG2)

         i3 = i3 + arg_incr(X_AXIS,ARG3)
         j3 = j3 + arg_incr(Y_AXIS,ARG3)
         k3 = k3 + arg_incr(Z_AXIS,ARG3)
         l3 = l3 + arg_incr(T_AXIS,ARG3)
         m3 = m3 + arg_incr(E_AXIS,ARG3)
         n3 = n3 + arg_incr(F_AXIS,ARG3)

         i4 = i4 + arg_incr(X_AXIS,ARG4)
         j4 = j4 + arg_incr(Y_AXIS,ARG4)
         k4 = k4 + arg_incr(Z_AXIS,ARG4)
         l4 = l4 + arg_incr(T_AXIS,ARG4)
         m4 = m4 + arg_incr(E_AXIS,ARG4)
         n4 = n4 + arg_incr(F_AXIS,ARG4)
  700 CONTINUE

      RETURN

  999 CALL ef_bail_out (id, err_msg)

      END

	INTEGER FUNCTION PRCD (ndx,ptr,atom_type,atom_id)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Function to determine precedence values of atoms in the infix
*	string and the stack

*	J Davison TMAP/JISAO/PMEL/NOAA
*	10.22.87
* V200: 11/23/89 - changed constants for parameter names !!!
* 12/96 *kob* - Linux Port - had to move variable assignments off of
*               declaration line. used DATA rather than PARAMETER stmnt.
* V450: 12/96 - add check for grid changing functions
* V500: 12/98 *sh* - add check for alg_const_var (like "{1,3,5}")
*	 1/99 *sh* - add check for alg_string
* v554:  1/04 *acm* - add check for alg_counter_var
* V600 8/05 *acm* - Add variable type attrib_val 
* V671 7/11  *acm* Ticket 1868 IFV - masking expressions with ifValid, treating 
*		   zero as valid. 
* V720: 4/17 *acm* add direction-changing functions as a subset of grid-changing ones

	include		'ferret.parm'
	include		'rpn.parm'

	integer 	ndx,ptr,atom_type(*),atom_id(*)

	integer		i
	integer		lp_prc(2)
	DATA 		lp_prc/23,0/
	integer		op_prc(2,13)
	DATA		op_prc/11,12,11,12,13,14,13,14,16,15,5,6,
     .			3,4,9,10,9,10,9,10,9,10,9,10,7,8/
	integer		punc_prc(2,3)
	DATA		punc_prc/0,-999,23,0,0,-999/
	integer		atom_prc(2,alg_log_vstruct)

! V450: 12/96 - added initializations for alg_grid_chg_fcn and alg_child_var
	DATA	(atom_prc(i,alg_operator),i=1,2)/-888,-888/,
     .		(atom_prc(i,alg_constant),i=1,2)/21,22/,
     .		(atom_prc(i,alg_variable),i=1,2)/21,22/,
     .		(atom_prc(i,alg_punctuation),i=1,2)/-888,-888/,
     .		(atom_prc(i,alg_function),i=1,2)/17,18/,
     .		(atom_prc(i,alg_pseudo_var),i=1,2)/21,22/,
     .		(atom_prc(i,alg_log_struct),i=1,2)/1,2/,
     .		(atom_prc(i,alg_operand),i=1,2)/21,22/,
     .		(atom_prc(i,alg_finished),i=1,2)/0,-999/,
     .		(atom_prc(i,alg_dir_chg_fcn),i=1,2)/17,18/,
     .		(atom_prc(i,alg_grid_chg_fcn),i=1,2)/17,18/,
     .		(atom_prc(i,alg_child_var),i=1,2)/21,22/,
     .		(atom_prc(i,alg_const_var),i=1,2)/21,22/,
     .		(atom_prc(i,alg_string),i=1,2)/21,22/,
     .		(atom_prc(i,alg_counter_var),i=1,2)/21,22/,
     .		(atom_prc(i,alg_attrib_val),i=1,2)/21,22/,
     .		(atom_prc(i,alg_log_vstruct),i=1,2)/1,2/

********************************************************************************

*	IS THIS THE LEFT PARENTHESIS PUT ON STACK AT BEGINNING?
	if (ptr .eq. added_left_paren) then
	   prcd = lp_prc(ndx)
	   return
	end if

*	IF AN OPERATOR, DETERMINE PRECEDENCE FROM OP_PRC
	if (atom_type(ptr) .eq. alg_operator) then
	   prcd = op_prc(ndx,atom_id(ptr))
	   goto 100
	end if

*	IF A PUNCTUATION ATOM, FROM PUNC_PRC
	if (atom_type(ptr) .eq. alg_punctuation) then
	   prcd = punc_prc(ndx,atom_id(ptr))
	   goto 100
	end if

*	OTHERWISE FROM ATOM_PRC
	prcd = atom_prc(ndx,atom_type(ptr))

*	CHECK FOR ERRORS
100	if (prcd .eq. -888) stop 'precedence function is fatally flawed'
	if (prcd .eq. -999) stop
     .		'right paren, comma, or alg_finished on stack'
	return

	end

	program binary
	character file*120
	integer*2 ascii(128),icnt,ibase,irast,ilen
c
	integer*2 x(5000),y(5000)
c
	integer ij
	call getarg(1,file)
	open(1,file=file,status='old')
	call getarg(2,file)
	if(file.eq.' ')call exit(0)
	open(2,file=file,status='new',form='unformatted')
	read(1,987)icnt,ibase,irast
987	format(1x,i2,2i4)
	if(icnt.eq.99)then
	read(1,985)(ascii(ij),ij=1,128)
	ilen=ascii(128)
	else
	read(1,985)(ascii(ij),ij=1,icnt+1)
	ilen=ascii(icnt+1)
	do 1010 ij=icnt+1,128
1010	ascii(ij)=1
	endif
985	format(1x,20i4)
	read(1,984)(x(ij),ij=1,ilen)
	read(1,984)(y(ij),ij=1,ilen)
984	format(1x,40i2)
	close(1)
	write(2)icnt,ibase,irast,ilen
	write(2)(ascii(ij),ij=1,127)
	write(2)(x(ij),ij=1,ilen)
	write(2)(y(ij),ij=1,ilen)
	close(2)
	end

	SUBROUTINE LINFIT(ILNE,X,NSIZE,IBASE,PBUF)
	DIMENSION X(NSIZE)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)linfit.F	1.1    3/10/88
C**
* v580 *acm* 8/04 Change use of 256 to buflen+1, 
*                 where buflen is defined in cmndlen.inc
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long
* V694  *acm*  1/15 Changes to allow two time axes on plot (F-T)
* V695  *acm*  9/15 Changes for hour:min labeling on time axes
* v695 9/15 *acm* write values to PPL* symbols using 6 digits not 4
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**

	INCLUDE 'PARAMPL5.DAT'
	INCLUDE 'LINES.INC'
	INCLUDE 'DATA.INC'
	INCLUDE 'CMRD.INC'
	INCLUDE 'LUNITS.INC'
	INCLUDE 'SYSTEM.INC'
        INCLUDE 'cmndlen.inc'

	CHARACTER OUT*80,SYM*120
C
C	DO A LEAST SQUARES FIT ON LINE 'ILNE', PLACE THE RESULT INTO
C	THE ECHO FILE AND INTO 'LINEN+1' AND CLEAN UP VARIABLES
C
C	CALCULATE BASE FOR REGRESSION DATA
C
	CALL SETFIT(ILNE,X,NSIZE,IBASEJ,XIMIN,XIMAX)
	NPTS=LLENG(ILNE)
	CALL CORREL(X,NSIZE,IBASEJ,NPTS,XIMIN,XIMAX,R,A,B,AS,BS,VAR,STD)
C
C	WRITE RESULTS INTO GLOBAL SYMBOLS
C
	SYM='*PPL$LF_R2'
	WRITE(OUT,'(F10.4)')R*R
	CALL PUTSYM(SYM,OUT,10,IER)
	SYM='*PPL$LF_A'
	CALL PUTVAL(SYM,A,7,IER)
	SYM='*PPL$LF_A_STDEV'
	CALL PUTVAL(SYM,AS,7,IER)
	SYM='*PPL$LF_B'
	CALL PUTVAL(SYM,B,7,IER)
	SYM='*PPL$LF_B_STDEV'
	CALL PUTVAL(SYM,BS,7,IER)
	SYM='*PPL$LF_VAR'
	CALL PUTVAL(SYM,VAR,7,IER)
	SYM='*PPL$LF_RES_VAR'
	ST2=STD*STD
	CALL PUTVAL(SYM,ST2,7,IER)
C
C	WRITE STATS INTO ECHO FILE AND ON SCREEN
C
	WRITE(OUT,999)
	IF(.NOT.QUIETF)WRITE(LTTOUT,991)OUT
	NOUT=LNBLK(OUT,80)
	CALL ECHO(OUT,NOUT)
	WRITE(OUT,998)NPTS
	IF(.NOT.QUIETF)WRITE(LTTOUT,991)OUT
	NOUT=LNBLK(OUT,80)
	CALL ECHO(OUT,NOUT)
	WRITE(OUT,997)XIMIN,XIMAX
	IF(.NOT.QUIETF)WRITE(LTTOUT,991)OUT
	NOUT=LNBLK(OUT,80)
	CALL ECHO(OUT,NOUT)
	WRITE(OUT,996)R*R
	IF(.NOT.QUIETF)WRITE(LTTOUT,991)OUT
	NOUT=LNBLK(OUT,80)
	CALL ECHO(OUT,NOUT)
	WRITE(OUT,995)A,AS
	IF(.NOT.QUIETF)WRITE(LTTOUT,991)OUT
	NOUT=LNBLK(OUT,80)
	CALL ECHO(OUT,NOUT)
	WRITE(OUT,994)B,BS
	IF(.NOT.QUIETF)WRITE(LTTOUT,991)OUT
	NOUT=LNBLK(OUT,80)
	CALL ECHO(OUT,NOUT)
	WRITE(OUT,993)VAR
	IF(.NOT.QUIETF)WRITE(LTTOUT,991)OUT
	NOUT=LNBLK(OUT,80)
	CALL ECHO(OUT,NOUT)
	WRITE(OUT,992)STD*STD
	IF(.NOT.QUIETF)WRITE(LTTOUT,991)OUT
	NOUT=LNBLK(OUT,80)
	CALL ECHO(OUT,NOUT)
999	FORMAT(
     *  'C --  LINFIT RESULTS      Y = A + B*X')
998	FORMAT(
     *  'C --                 LENGTH = ',I10)
997	FORMAT(
     *  'C --  X LIMITS USED FOR FIT = ',1PG10.3,',',G10.3)
996	FORMAT(
     *  'C --                     R2 = ',0PF10.4)
995	FORMAT(
     *  'C --  REGRESSION COEFFS:  A = ',1PG10.3,'   ST-DEV = ',G10.3)
994	FORMAT(
     *  'C --                      B = ',  G10.3,'   ST-DEV = ',G10.3)
993	FORMAT(
     *  'C --         TOTAL VARIANCE = ',G10.3)
992	FORMAT(
     *  'C --      RESIDUAL VARIANCE = ',G10.3)
991	FORMAT(1X,A70)
C
C	INSERT INTO NEXT LINE
C
	CALL GETFIT(X,NSIZE,IBASE,XIMIN,XIMAX,A,B,PBUF)
	RETURN
	END
	SUBROUTINE GETFIT(X,NSIZE,IBASE,XIMIN,XIMAX,A,B,PBUF)
	DIMENSION X(NSIZE)
#ifdef  unix
	INCLUDE 'PARAMPL5.DAT'
	INCLUDE 'LINES.INC'
	INCLUDE 'DATA.INC'
	INCLUDE 'CMRD.INC'
	INCLUDE 'LUNITS.INC'
	INCLUDE 'SYSTEM.INC'
#else
        INCLUDE 'pplinc:PARAMPL5.DAT'
        INCLUDE 'pplinc:LINES.INC'
        INCLUDE 'pplinc:DATA.INC'
        INCLUDE 'pplinc:CMRD.INC'
        INCLUDE 'pplinc:LUNITS.INC'
        INCLUDE 'CMDINC:SYSTEM.INC'
#endif
	CHARACTER OUT*80
	LINEN=LINEN+1
	XMIN=XIMIN
	XMAX=XIMAX
	IF(M.GE.4.AND.IFLG(4).EQ.1)XMIN=P(4)
	IF(M.GE.5.AND.IFLG(5).EQ.1)XMAX=P(5)
	YMIN=A+B*XMIN
	YMAX=A+B*XMAX
	IX=IBASE-1
	IY=NSIZE/2+IX
C
C	LOAD FITTED LINE
C
	WRITE(OUT,996)XMIN,XMAX
	IF(.NOT.QUIETF)WRITE(LTTOUT,997)OUT
997	FORMAT(1X,A79)
	NOUT=LNBLK(OUT,80)
	CALL ECHO(OUT,NOUT)
996	FORMAT(
     *  'C -- X LIMITS USED FOR LINE = ',1PG10.3,',',G10.3)
	X(IX+1)=XMIN
	X(IY+1)=YMIN
	X(IX+2)=XMAX
	X(IY+2)=YMAX
	LLENG(LINEN)=2
	CALL STMNMX(X,NSIZE,XMIN,XMAX,YMIN,YMAX)
	IBASE=IBASE+2
	IF(.NOT.QUIETF)WRITE(LTTOUT,999)
999	FORMAT(1X,'     2 POINTS READ')
	lnum=linen
	RETURN
	END
      SUBROUTINE CORREL (X,NSIZE,IBASE,N,XMN,XMX,R,A,B,AS,BS,VAR,STD)
#ifdef  unix
	INCLUDE 'MISS.INC'
#else
	INCLUDE 'pplinc:MISS.INC'
#endif
C
C     COMPUTES THE SAMPLE CORRELATION, R, BETWEEN TWO ARRAYS OF VALUES
C     (X,Y) WITH N DATA POINTS. CALCULATES CORRELATION SIGNIFICANCE
C     PARAMETERS - T (UNCORRELATED POPULATION) AND Z (CORRELATED
C     POPULATION).
C     ALSO CALCULATES LINEAR REGRESSION COEFFICIENTS (A,B)
C
C     PROGRAMMED BY JIM HOLBROOK, AUG, 72.
C
      DIMENSION X(NSIZE)
      IX=IBASE
      IY=NSIZE/2+IX
      XX=0.
      YY=0.
      XY=0.
      X1=0.
      Y1=0.
	NN=N
	N=0
      DO 900 I=1,NN
	XT=X(IX+I)
	YT=X(IY+I)
	IF(XT.LT.XMN.OR.XT.GT.XMX)GOTO 900
	IF((XLE.AND.XT.LE.CMXLE).OR.
     *	   (XEQ.AND.XT.EQ.CMXEQ).OR.
     *	   (XGE.AND.XT.GE.CMXGE).OR.
     *	   (YLE.AND.YT.LE.CMYLE).OR.
     *	   (YEQ.AND.YT.EQ.CMYEQ).OR.
     *	   (YGE.AND.YT.GE.CMYGE))GOTO 900
	N=N+1
      XY=XY+XT*YT
      X1=X1+XT
      Y1=Y1+YT
      XX=XX+XT**2
      YY=YY+YT**2
900	CONTINUE
      XN=N
      A=(XX*Y1-X1*XY)/(XN*XX-X1*X1)
      B=(XN*XY-X1*Y1)/(XN*XX-X1*X1)
      S=(-2.0*(B*XY-A*B*X1+A*Y1)+B*B*XX+XN*A*A+YY)
      S=SQRT(S/(XN-2))
      AS=S*SQRT(XX/(XN*XX-X1*X1))
      BS=S*SQRT(1.0/(XX-X1*X1/XN))
      R1=XN*XY-X1*Y1
      R2=(XN*XX-X1**2)*(XN*YY-Y1**2)
 903  R=R1/SQRT(R2)
	VAR=(YY/N-(Y1/N)**2)
      IF (ABS(R-1.) .LE. 1.E-6) R=1.
      STD=VAR*(1-R*R)
      STD=SQRT(STD)
      RETURN
      END
	SUBROUTINE SETFIT(ILNE,X,NSIZE,JBASE,XIMIN,XIMAX)
	DIMENSION X(NSIZE)
	INCLUDE 'PARAMPL5.DAT'
	INCLUDE 'MISS.INC'
	INCLUDE 'LINES.INC'
	INCLUDE 'DATA.INC'
	INCLUDE 'CMRD.INC'
	INCLUDE 'CMRDL.INC'
	INCLUDE 'AXISL.INC'
	INCLUDE 'TAXIS.INC'

	REAL*8 DIFF
	CHARACTER DATE*10
	IF((ITFLG.EQ.1.OR.ITFLG.EQ.2).AND.N.NE.0)THEN
C
C	PARSE THE LABEL FOR MIN AND MAX TIMES
C
200	IW=INDEX(LABEL,'W')
	IF(IW.EQ.0)GOTO 100
	ICM=INDEX(LABEL,',')
	ISPC=INDEX(LABEL,' ')
	IF(ICM.EQ.0)ICM=buflen+1
	IF(ISPC.EQ.0)ISPC=buflen+1
	IF(ICM.LT.IW)THEN
		M=M+1
		IFLG(M)=0
		LABEL=LABEL(ICM+1:)
	ELSE
		IEND=MIN0(ICM,ISPC,N)
		ILEN=IEND-IW-2
		DATE=LABEL(IW+1:IEND-1)
		IF(ILEN.LT.10)DATE(ILEN+1:)='0000000000'
		M=M+1
		IFLG(M)=1
		P(M)=DIFF(ITSTRT,DATE)/DT+1.0
		LABEL=LABEL(IEND+1:)
	ENDIF
	GOTO 200
	ENDIF
100	JBASE=0
	DO 10 J=1,ILNE-1
10	JBASE=JBASE+LLENG(J)
C
	N=LLENG(ILNE)
C
C	FIND XMIN, AND XMAX
C
	XMIN=1.E38
	XMAX=-XMIN
	DO 20 I=1,LLENG(ILNE)
	IF((XLE.AND.X(JBASE+I).LE.CMXLE).OR.
     *	   (XEQ.AND.X(JBASE+I).EQ.CMXEQ).OR.
     *	   (XGE.AND.X(JBASE+I).GE.CMXGE))GOTO 20
	IF(X(JBASE+I).LT.XMIN)XMIN=X(JBASE+I)
	IF(X(JBASE+I).GT.XMAX)XMAX=X(JBASE+I)
20	CONTINUE
C
C	TEST FOR MIN AND MAX
C
	IF(M.GE.2.AND.IFLG(2).EQ.1)THEN
		XIMIN=P(2)
	ELSE
		XIMIN=XMIN
	ENDIF
	IF(M.GE.3.AND.IFLG(3).EQ.1)THEN
		XIMAX=P(3)
	ELSE
		XIMAX=XMAX
	ENDIF
	RETURN
	END

	SUBROUTINE TM_ADJUST_BOUNDS(iaxis, npts, modlen, axwwlen, ok)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Addressing ticket 2504:
* If coordinates on an irregular axis lie within the modulo length but 
* their bounds make the axis too long, reset the bounds so the axis 
* is the modulo length. This is only called when Ferret is generating
* bounds on a DEFINE AXIS given without cell edges or from a netCDF file
* where bounds were not included in the file.
*
* V72 6/17 *acm* for trac enhancement #767 -- dynamic coordinate storage
*
* return axwwlen

#	include	"tmap_dset.parm"
	include	'tmap_dims.parm'
	include 'xtm_grid.cmn_text'

* Argument declarations
	LOGICAL ok
	INTEGER iaxis, npts
	REAL	modlen, axwwlen

* Local declarations
	LOGICAL TM_FPEQ
	INTEGER TM_LENSTR1, ipt1, ipte
	REAL	GET_LINE_COORD, TM_WW_AXLEN, 
     .		delta, pt1, ptn
	REAL*4	r4delta

* 
	ok = .TRUE.
	axwwlen = TM_WW_AXLEN(iaxis)

* Exit if the modulo length is 0. which indicates modulo length is axis length.
	IF (modlen .EQ. 0.) GOTO 5000

* Exit if the axis length is within the modulo length.
	IF (axwwlen .LE. modlen) GOTO 5000

* Exit if the line is regularly spaced
	IF ( line_regular(iaxis) ) GOTO 5000

	pt1 = GET_LINE_COORD (linemem(iaxis)%ptr,1)
	ptn = GET_LINE_COORD (linemem(iaxis)%ptr, npts)
	delta = modlen - (ptn  - pt1)
	
	CALL PUT_LINE_COORD ( lineedg(iaxis)%ptr, 1, pt1 - delta/2. )
	CALL PUT_LINE_COORD ( lineedg(iaxis)%ptr, npts+1, ptn + delta/2. )

* did the adjustment keep the length within the defined moudulo length?
* (probably always the case if we've got this far.)

	axwwlen = TM_WW_AXLEN(iaxis)
	
	r4delta = axwwlen ! single precision
	delta = r4delta
	ok = (TM_FPEQ(delta, modlen))
	IF (.NOT.ok) axwwlen = 0.
	
 5000	RETURN
	END

	INTEGER*4 FUNCTION TM_FIND_LINE_SLOT ( islot )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Locates an unused space in XGRID common for a new line. If no space available,
* returns error.
*
* revision 0.00 - 11/22/88
* revision 1.00 - 12/13/88 - changed to reverse order search
* bug fix - 10/2/91 - inserted comma in statement 9000 right before the *9999.  This error was
*                     caught by version 3 of f77, but not 2.1.    kob
* Arguments
	INTEGER*4	islot
*
* *kob* 10/96 	- Linux port.  Linux didn't like tabs between "include"
*	          and what was being included.  removed them
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* Parameters and commons
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
	include 'tmap_errors.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data

*
* Local declarations
	CHARACTER*13	TM_STRING
	INTEGER*4	igrd
*
	DO 100 igrd = max_lines,1,-1
	  IF (line_name(igrd) .NE. char_init16) THEN
	    IF (igrd .EQ. max_lines) GOTO 9000
	    islot = igrd + 1
	    GOTO 200
	  ENDIF
  100	CONTINUE
	islot = 1
  200	TM_FIND_LINE_SLOT = merr_ok
	GOTO 9999
*
* No slot available
 9000	CALL TM_ERRMSG (merr_linelim, TM_FIND_LINE_SLOT,
     .	                'TM_FIND_LINE_SLOT', no_descfile, no_stepfile,
     .	                'MAX='//TM_STRING(DBLE(max_lines)), 
     .                   no_errstring,*9999)


 9999	RETURN
	END

	SUBROUTINE IS_DO_OP(  alg_type, alg_text, lo_isp, 
     ,                       ifv, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* do bookkeeping and call up calculation to perform op_num between
* 0,1,2 or 3 grids

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* revision 0.0 - 2/13/87 - based on ALG_DO_OP rev 1.0
* revision 1.0 - 8/11/87 - allowed for expanding grids: lines to planes, etc.
* revision 1.1 - 9/30/87 - added mr_perm_prot
* revision 1.2 - 2/18/88 - bug fix: LOAD/i=lo:hi/j=j1/k=k1/l=lo:hi temp,salt
*				    LIST/i=i1 temp salt +
*				  --> dimension error: tries to expand temp,salt
*				and check the data planes before GRID_OPERATIO*
* revision 1.3 - 7/8/88  - make sure subscript limits are adequate
* revision 1.4 - 1/31/89 - passed num_com to GRID_OPERATION
* V200:  6/20/89 - re-worked user defined variable logic
*	10/16/89 - set up adjustable array limits with NON_ARRAY_SUBSC
*	11/27/89 - IF-THEN-ELSE logic
* V230:   8/7/92 - upped to 4 the number of arguments a function can use
* V312: 5/94 - array "memory" as a calling argument
* V400: corrected bad type declaration of STR_MATCH (found by IBM compiler)
* V420: 9/95 - deallocate dynamic grids from components that had 'em
*       10/5 ... a subtle change required by this is that the result must not
*	       explicitly require the same grid as the first component  (lest
*	       the result get deleted when that grid is deallocated.  In
*	       fact, the true result grid and context are created by the
*	       individual mergers of each component ... never by examining
*	       the grid that results from this routine.  Thus (experimentally)
*	       we will always represent the output of this routine as being
*	       on grid ABSTRACT.  Hopefully, there will be no side-effects.
*	11/95 - if any of the components are non-reusabe ("un_cached") so
*		must be the result
* V500:  1/99 *sh* Trap as errors attempts to use string variables as
*		arguments. Strings may be passed only to grid-changing
*		functions (see IS_DO_GC_FC)
* V530:  8/00 *sh* added support for string arrays
* V533:  7/01 *sh* improved support for string arrays -- logical operations
* V630:  9/09 *acm* Fix bug 1380: If the operation is a EQ,NE,LT,LE,GT,GE on 
*                 string arguments, the result is numeric. Set cx_type(res_cx) 
*                 accordingly, then compound conditinals will work.
* V671 7/11  *acm* Ticket 1868 IFV - masking expressions with ifValid, treating 
*		   zero as valid.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V68  3/12  *acm* The string operations EQ, NE, LT, etc return a float-type result.
*                  Reset mr_type; it has already been set to string elsewhere.
* V694 5/14  *acm* Ticket 2234: Issue an error instead of returning missing results on 
*                  inappropriate use of string arguments in numeric expressions or mixed
*                  string/numeric expressions with logic operators. See bn_strings.jnl
* V720 5/17 *sh*  added support for operations on DSG ragged arrays 
* V76  1/20 *acm* Implementing Point-type DSG datasets 

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'xdset_info.cmn_text'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'rpn.parm'
	include	'xvariables.cmn'
	include	'xcontext.cmn'
	include	'xalgebra.cmn'
	include	'xtext_info.cmn'
	include	'xfr_grid.cmn'	! w/ mgrid_abstract

* calling arguments
	LOGICAL		ifv
	INTEGER		alg_type, lo_isp, status
	CHARACTER*(*)	alg_text

* local variables
	LOGICAL	ITS_UN_CACHED, TM_ITSA_DSG,
     .		not_reusable, arg_types_matched, numerical_op, its_dsg
	INTEGER	CX_DIM_LEN, STR_MATCH, MGRID_SIZE_DELTA,
     .		TM_DSG_DSET_FROM_GRID, TM_DSG_NFEATURES,
     .		ifcn, iop, ilogic, icom, idim, num_com, mr, res_cx,
     .		mr1, mr2, mr3, mr4, impl_grid, arg_type, i1,
     .		frame_bottom, op_num, res_len, com_len, com_cx, res_mr,
     .		dsg_grid, dset, i8_size, nfeatures, nobs, orientation

* convenience equivalences
	INTEGER	com(5)
	EQUIVALENCE (com(1),mr1), (com(2),mr2), (com(3),mr3), (com(4),mr4),
     .              (com(5),res_mr)

* local parameter declarations
	INTEGER	     p_log_op_first, p_log_op_last  ! see operate.F
	PARAMETER  ( p_log_op_first = 8,
     .		     p_log_op_last = 13 )

*        ... interpretation stack setup at the time this is called ...
*	stack level		stack contents
*	 isp	<--	most recently obtained component for calculation
*	isp-1		...
*	isp-2	<--	...	other components of this expression on stack
*	isp-n		...
*	lo_isp	<--	level at which expression evaluation was called
*
* eg. for tau ^ 2 as a part of the full expression
*			level isp     will contain the constant 2
*			level isp-1   will contain tau
*		and the alg_type/alg_text will point to "^"

* the "frame_bottom" is the isp level that will be left when the components of
* the current calculation (1 to 3) are reduced to a single value.
* on exit isp will point to the frame bottom and the result will be left there

* initialize DSG info
* since an abstract grid is substituted below for the result, and we may be
* operating on entirely intermediate results, we cannot follow the usual route
* of learning the DSG-ness of the calculation from the grid.  Instead we
* look at the grid of the result uvar
! TBD: not sure if it matters whether we use is_big_cx or is_cx
	dsg_grid = cx_grid(is_big_cx(lo_isp))
	its_dsg = TM_ITSA_DSG(dsg_grid)
	IF (its_dsg) THEN
          dset      = TM_DSG_DSET_FROM_GRID( dsg_grid )
          nfeatures = TM_DSG_NFEATURES( dsg_grid )
          nobs        = dsg_obs_dimlen(dset)
	  orientation = dsg_orientation(dset)
	ENDIF

* identify the text of the particular item within the algebraic class
* ... function
	IF     ( alg_type .EQ. alg_function   ) THEN
	   ifcn = STR_MATCH( alg_text, alg_fcn, num_functions )
	   IF ( ifcn .EQ. atom_not_found ) STOP ' bad fcn err'
	   num_com = alg_num_fcn_args( ifcn )
	   op_num  = ifcn + offset_functions
* ... operator
	ELSEIF ( alg_type .EQ. alg_operator   ) THEN
	   iop = STR_MATCH ( alg_text, alg_op, num_operators )
	   IF ( iop .EQ. atom_not_found ) STOP ' bad op err'
	   num_com = 2
	   op_num  = iop
* ... logic structure
	ELSEIF ( alg_type .EQ. alg_log_struct .OR.
     .           alg_type .EQ. alg_log_vstruct ) THEN
	   ilogic = STR_MATCH (	alg_text, alg_struct, num_log_structs )
	   IF ( ilogic .EQ. atom_not_found ) STOP ' bad if-then err'
	   IF ( ilogic .EQ. pthen ) THEN
	      num_com = 2	! IF ... THEN ...
	   ELSEIF ( ilogic .EQ. pelse ) THEN
	      num_com = 3	! IF ... THEN ... ELSE ...
	   ELSE
	      STOP 'bad if'
	   ENDIF
	   op_num  = ilogic + offset_logic_struc
	   IF (alg_type .EQ. alg_log_vstruct) op_num = op_num + 2
	ELSE
	   STOP '??? fcn or op'
	ENDIF
	frame_bottom = isp - num_com + 1
	IF ( frame_bottom .LE. lo_isp ) CALL ERRMSG
     .		( ferr_syntax, status, 'RPN', *5000 )

* classify the data type of the arguments
* ... ignore type of "cond" in IF cond THEN result
	IF ( alg_type .EQ. alg_log_struct .OR.
     .       alg_type .EQ. alg_log_vstruct ) THEN
	  i1 = 2 ! ignore "cond"
	ELSE
	  i1 = 1
	ENDIF
	arg_type =  cx_type(is_cx(frame_bottom+i1-1))
	arg_types_matched = .TRUE.
	DO 100 icom = i1, num_com
	   com_cx  = is_cx(frame_bottom+icom-1)
	   IF (arg_type .NE. cx_type(com_cx) ) THEN
	     arg_types_matched = .FALSE.
	     arg_type = ptype_float
	   ENDIF
 100	CONTINUE

* allocate context space for the result
	CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) RETURN
	res_cx = cx_stack_ptr

* use first component context as the default
	CALL TRANSFER_CONTEXT( is_cx(frame_bottom), res_cx )
	cx_category( res_cx ) = cat_temp_var
	cx_variable( res_cx ) = 1		! in case it is a constant
	cx_grid    ( res_cx ) = mgrid_abstract	! see 10/5 notes above
	cx_type    ( res_cx ) = arg_type

* stretch sizes to maxes for all components on each axis
* e.g. temp[k=1] + temp[K=1:3] needs 3 in the K direction
* also - if there is a meaningful axis then use it
* e.g. I[i=1] + J[j=1]   --> use the J axis although it is only length 1
	DO 210 idim = 1, nferdims
	   res_len = CX_DIM_LEN( idim, res_cx )
	   DO 200 icom = 2, num_com
	      com_cx  = is_cx(frame_bottom+icom-1)
	      com_len = CX_DIM_LEN( idim, com_cx )
	      IF ( com_len .GT. res_len
     .	     .OR.  ( cx_lo_ww(idim,res_cx) .EQ. unspecified_val8
     .	       .AND. cx_lo_ww(idim,com_cx) .NE. unspecified_val8 ) ) THEN
	         CALL TRANSFER_AXIS( idim, com_cx, res_cx )
	         res_len = com_len
	      ENDIF
 200	   CONTINUE
 210	CONTINUE

* Fix up the DSG result context
* A DSG ragged array may appear as a 2D obs X E grid at this point
* If so, remove the E, as the orientation axis is the full ragged dim in length
* Doesn't apply to point data...

	IF (its_dsg .AND. orientation.LT.e_dim) THEN
	    IF (cx_hi_ss(res_cx,orientation) .NE. unspecified_int4) THEN
	       IF (cx_hi_ss(res_cx, e_dim) .NE. unspecified_int4) THEN
	    	  cx_lo_ss(res_cx, e_dim) = unspecified_int4 
	          cx_hi_ss(res_cx, e_dim) = unspecified_int4
	       ENDIF
	    ENDIF
	ENDIF
 
* allocate memory space for result
	CALL CREATE_MEM_VAR( res_cx, res_mr, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	mr_variable( res_mr ) = res_mr	! cat_temp_var vars point to themselves

* special HACK to support "a"+"b" (see MERGE_GRID)
	IF ( mr_type(res_mr) .EQ. ptype_string ) THEN
           CALL INIT_C_STRING_ARRAY( MGRID_SIZE_DELTA(res_mr),
     .                               memry(res_mr)%ptr,
     .                               mr_c_pointer(res_mr)      )
	ENDIF

* point to the memory resident components
* (if fewer than 4 components default extras to dummy)
	DO 300 icom = 1, num_com
 300	com(icom) = is_mr(frame_bottom+icom-1)
	DO 310 icom = num_com+1, 4
 310	com(icom) = dummy_mr

* set up 4D array limits as unsubscripted variables in COMMON
	CALL NON_ARRAY_SUBSC( com, 5 )

* operation relevant ONLY to numerical arguments? (neither "+" nor logical op)
	numerical_op =  .NOT.
     .	     (	(op_num.EQ.1)
     .     .OR. (op_num.GE.p_log_op_first .AND. op_num.LE.p_log_op_last)
     .     .OR. (op_num.GT.offset_logic_struc)   )

* perform the operation
	IF (its_dsg) THEN
* ... adjust the indices into 2D form for convenient DSG processing
	  CALL DSG_ARRAY_SUBSC( com, 5, orientation )
* ... good housekeeping: flag unprocessed features of the DSG result
*     to make them readily visible during code development
! DSGTBD: eventually this will be needed only in diagnostic mode
	  CALL FILL_MEMORY ( res_mr, dsg_masked_out_flag ) 
* ... get work space needed for masks
	  i8_size = nfeatures
	  CALL GET_DYN_WORK_SPACE( i8_size, status )
* ... finally do the operation
! DSGTBD:  still need DSG versions of string subroutines below
	  CALL DSG_OPERATE (op_num, num_com, ifv, res_cx, is_cx(frame_bottom),
     .			 dset,
     .			 nfeatures,
     .			 workmem(plegacy_work_buffer)%ptr,
     .			 memry(mr1)%ptr,   mr1,
     .			 memry(mr2)%ptr,   mr2,
     .			 memry(mr3)%ptr,   mr3,
     .			 memry(mr4)%ptr,   mr4,
     .			 memry(res_mr)%ptr, res_mr )

	ELSEIF (.NOT.arg_types_matched ) THEN 
* ... allow mix of float and string arguments (lets us use symbols as numbers)
	    CALL FILL_MEMORY ( res_mr, mr_bad_data(res_mr) )

	ELSEIF ( arg_type.EQ.ptype_string .AND. numerical_op ) THEN 
* ... inappropriate use of string arguments
* Issue an error instead of returning missing results on 
* inappropriate use of string arguments
	    GOTO 5200

	ELSEIF (arg_type.EQ.ptype_string) THEN
	  IF (op_num .EQ. 1 ) THEN  ! "+"
	    CALL STRING_CONCATENATE
     .		       ( is_cx(frame_bottom),
     .			 memry(mr1)%ptr,   mr1,
     .			 memry(mr2)%ptr,   mr2,
     .			 memry(res_mr)%ptr, res_mr )
	  ELSEIF (op_num .GT. offset_logic_struc) THEN
	    CALL STRING_CONDITIONAL
     .		       ( op_num-offset_logic_struc,
     .			 num_com, is_cx(frame_bottom),
     .			 memry(mr1)%ptr,   mr1,
     .			 memry(mr2)%ptr,   mr2,
     .			 memry(mr3)%ptr,   mr3,
     .			 memry(res_mr)%ptr, res_mr )
	  ELSE  ! "EQ", "NE", "LT", ...
	    CALL STRING_OPERATE
     .		       ( op_num, is_cx(frame_bottom),
     .			 memry(mr1)%ptr,   mr1,
     .			 memry(mr2)%ptr,   mr2,
     .			 memry(res_mr)%ptr, res_mr )
            cx_type(res_cx) = ptype_float
            mr_type(res_mr) = ptype_float
	  ENDIF
	ELSE
	  CALL OPERATE ( op_num, num_com, ifv, is_cx(frame_bottom),
     .			 memry(mr1)%ptr,   mr1,
     .			 memry(mr2)%ptr,   mr2,
     .			 memry(mr3)%ptr,   mr3,
     .			 memry(mr4)%ptr,   mr4,
     .			 memry(res_mr)%ptr, res_mr )
	ENDIF

* clean up 
* ... deallocate result context space
	cx_stack_ptr = cx_stack_ptr - 1

* ... if any components were un_cached we must uncache the result
	not_reusable = .FALSE.
	DO 2050 icom = isp, frame_bottom, -1
 2050	IF ( ITS_UN_CACHED(is_mr(icom)) ) not_reusable = .TRUE.
	IF ( not_reusable ) CALL UN_CACHE( res_mr )

* ...release component cx stack space
	DO 2100 isp = isp, frame_bottom, -1
	   IF ( is_cx(isp) .NE. cx_stack_ptr ) WRITE (6,*) 'OP_STK??'	! temp
	   cx_stack_ptr = cx_stack_ptr - 1
	   mr  = is_mr( isp )
	   IF ( mr_protected(mr) .EQ. mr_temporary
     .	   .OR. mr_category (mr) .EQ. cat_temp_var ) THEN
	      CALL DELETE_VARIABLE( mr )
	   ELSE
	      CALL MR_NOT_IN_USE( mr )
	   ENDIF
* (9/95) deallocate dynamic grids from components
! instead make the result depend on grid ABSTRACT
!* or, if the result requires
!* the same grid, then pass responsibility for deallocating it later along to
!* the result context. The use count is decremented (by calling DEALLO...)
!* for each additional component that may have shared use of this dynamic grid.
	   com_cx = is_cx(isp)
	   IF ( cx_has_impl_grid(com_cx) ) THEN
	      impl_grid = cx_grid(com_cx)
!	      IF ( cx_grid(res_cx) .EQ. impl_grid ) THEN
! 10/5	         IF ( cx_has_impl_grid(res_cx) )
! idea    .				CALL DEALLO_DYN_GRID(impl_grid)
!	         cx_has_impl_grid(res_cx) = .TRUE.	!inherit responsibility
!	      ELSE
	         CALL DEALLO_DYN_GRID(impl_grid)
!	      ENDIF
	      cx_has_impl_grid(com_cx) = .FALSE.
	   ENDIF
 2100	CONTINUE

* collapse the interp stack frame
	isp = frame_bottom
	is_mr( isp ) = res_mr

* save the result context at the cx level previously used by the 1st component
	cx_stack_ptr = cx_stack_ptr + 1
	CALL TRANSFER_CONTEXT( res_cx, cx_stack_ptr )
!	IF ( cx_has_impl_grid(res_cx) ) THEN
! 10/5 	   cx_has_impl_grid(cx_stack_ptr) = .TRUE.
! idea	   cx_has_impl_grid(res_cx)       = .FALSE.
!	ENDIF
	is_cx( isp ) = cx_stack_ptr

	RETURN

* error exit
 5000	RETURN
 5100	CALL ERRMSG( ferr_invalid_command, status,
     .		'cannot use a string as an argument to: '//alg_text, *5000 )
 5200	CALL ERRMSG( ferr_invalid_command, status,
     .		'cannot use strings in numerical expression', *5000 )
	END

      SUBROUTINE LIST(LLUN,X,NSIZE,ARG)
	DIMENSION X(NSIZE)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
C**
C**    @(#)list.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
*	Modified to include SHADE and ALINE parameter listing J Davison
*	11.9.89
*	*jd* 3.19.93 Mod to include listing of T Craig's spline and draftsman
*	*jd* 1.6.94  Mod to list PLTNME -- metafile name
*	*jd* 11.20.95 Mod to accommodate 14 digit time string (format 9984).
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
*	Modified to include PATTERN  parameter listing J Davison 10.26.98
*       Modified to include RGB mapping status *jd* 10.98/1.99
* V510: *sh* 3/00 - restrict LIST LINES to at most NLINES
*                 - fixed up LIST STATS format
* V530: *acm* 1/01- list the allowable calendar names; do not point to 
*		    "the loaded calendar".  calendar type goes with each grid.
* V540: *sh* 9/01 - changed LIST YAXIS output to say "YROG+" instead of "XORG="
* 3/99  *kob* had to move initialization of var solid off decl. line - for linux
* V552 *acm* 3/03 For SHAKEY info, write out location of key, whether it was
*                 automatically set or set by user with SHASET
* V694  *acm*  1/15 Changes to allow two time axes on plot (F-T)

        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'axis_inc.decl'
        include 'AXIS.INC'
        include 'lines_inc.decl'
        include 'LINES.INC'
        include 'pen_inc.decl'
        include 'PEN.INC'
        include 'labels_inc.decl'
        include 'LABELS.INC'
        include 'labcom_inc.decl'
        include 'LABCOM.INC'
        include 'cont_inc.decl'
        include 'CONT.INC'
        include 'dashzz_inc.decl'
        include 'DASHZZ.INC'
        include 'conlab_inc.decl'
        include 'CONLAB.INC'
        include 'plt_inc.decl'
        include 'PLT.INC'
        include 'hab_inc.decl'
        include 'HAB.INC'
        include 'data_inc.decl'
        include 'DATA.INC'
        include 'cmrd_inc.decl'
        include 'CMRD.INC'
        include 'cmrdl_inc.decl'
        include 'CMRDL.INC'
        include 'hd_inc.decl'
        include 'HD.INC'
        include 'taxis_inc.decl'
        include 'TAXIS.INC'
        include 'tics_inc.decl'
        include 'TICS.INC'
        include 'tics2_inc.decl'
        include 'TICS2.INC'
        include 'axisl_inc.decl'
        include 'AXISL.INC'
        include 'xylabp_inc.decl'
        include 'XYLABP.INC'
        include 'miss_inc.decl'
        include 'MISS.INC'
        include 'zgrid_inc.decl'
        include 'ZGRID.INC'
        include 'lunits_inc.decl'
        include 'LUNITS.INC'
        include 'vector_inc.decl'
        include 'VECTOR.INC'
        include 'system_inc.decl'
        include 'SYSTEM.INC'
        include 'shade_vars.cmn'
        include 'aline.cmn'
        include 'gkscm2.cmn'
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
        include 'calendar.decl'
        include 'calendar.cmn'



	integer		x_do_key,x_orient,solid, my_loc
        DATA            solid/21/
	logical		none
	character*5	drafts_txt
	character*6	x_user
        character*10    mapping

	COMMON/PLTCM2/PMODE,FILEZ,FILET
	CHARACTER PMODE*1,FILEZ*81,FILET*81
	CHARACTER ARG*(*),LST(24)*10,AUTO(2)*6,TYPEL(6)*12,CLEV(0:3)*4
	CHARACTER TYPE(3)*7,JTY(-2:2)*30,TIC(-1:1)*7
	CHARACTER LT(-1:1)*6,AT(0:2)*7,IZT(0:3)*8,TAXTYP(-1:1)*5
	CHARACTER SYM*21,SYM2*21,SYM3*21,ONOFF(0:1)*3
        CHARACTER POINTER1*4,POINTER2*25

	DATA LST/'XAXIS','YAXIS','LINES','LABELS','STATS','LEVELS',
     *'READ','CONSET','LABSET','TAXIS','TICS','DATA','PLOT','DATPT',
     *'TRANSXY','LIMITS','VECTOR','SHASET','SHAKEY','ALINE','PLTNME',
     *'PATSET','APATTERNS','CALENDAR'/

	DATA AUTO/'MANUAL','AUTO'/,ONOFF/'OFF','ON'/
	DATA TAXTYP/'YAXIS','OFF','XAXIS'/
	DATA IZT/'OFF','X AXIS','Y AXIS','POINTS'/
	DATA TYPEL/'NO MARK','MARK','END PTS','ONLY MARK',
     *'DASH','DASH END PTS'/,CLEV/'    ','LINE','DARK','DASH'/
	DATA TIC/'OUTSIDE','BOTH','INSIDE'/
	DATA JTY/'VECTOR VARIABLE GRID','VECTOR','CONTOUR',
     *		'LINES','CONTOUR VARIABLE GRID'/
	DATA TYPE/'NORMAL','LOG','INV LOG'/
	DATA LT/'LEFT','CENTER','RIGHT'/,AT/'NO LINE','LINE','FANCY'/

***************************************************************************

	IF(QUIETF)RETURN

	CALL UPPER(ARG,30)

	DO 10 I=1,24
           IF(ARG.EQ.LST(I))GOTO 11
 10     CONTINUE

        WRITE(LTTOUT,9986) ARG
 9986   FORMAT(' ILLEGAL LIST OPTION',2X,A10)
        GOTO 5000

 11     GOTO (100,200,300,400,500,600,700,800,900,1000,1100,500,1300,
     *       1400,1500,1600,1700,1800,1900,2000,2100,2200,2300,2400),I


C     XAXIS
100   WRITE(LLUN,'(//9X,''XAXIS QUALITIES'')')
      WRITE(LLUN,9999)XLO,XHI,XTIC,XLEN,XCSIZE,
     *ONOFF(IAXON(1)),ONOFF(IAXON(2))
9999  FORMAT(9X,'LO=',1PE9.2,' HI=',E9.2,' TIC=',E9.2,
     *' LEN=',E9.2,' CSIZE=',E9.2,/,9X,' TOP AXIS= ',A3,
     *' BOTTOM AXIS= ',A3)
      WRITE(LLUN,9998)AUTO(IAUTOX+1),TYPE(ITYPEX),NMTCX,LINTX,
     *LABELX,NSIGX,NTICX
9998  FORMAT(9X,A6,2X,A6,' NMTC=',I3,' LINT=',I3,' LABEL=',
     *I3,' NSIG=',I3,' NTIC=',I3)
      IF(IFRX.EQ.' ')THEN
      WRITE(LLUN,9988) 'X', XORG
9988  FORMAT(9X,A1,'ORG=',1PE9.2,'  AUTO LABELLING')
      ELSE
      WRITE(LLUN,9987) 'X',XORG,IFRX
9987  FORMAT(9X,A1,'ORG=',1PE9.2,'  LABEL FORMAT=',2X,A20)
      ENDIF
      GOTO 5000
C     YAXIS
200   WRITE(LLUN,'(//9X,''YAXIS QUALITIES'')')
      WRITE(LLUN,9975)YLO,YHI,YTIC,YLEN,YCSIZE,
     *ONOFF(IAXON(3)),ONOFF(IAXON(4))
9975  FORMAT(9X,'LO=',1PE9.2,' HI=',E9.2,' TIC=',E9.2,
     *' LEN=',E9.2,' CSIZE=',E9.2,/,9X,' LEFT AXIS= ',A3,
     *' RIGHT AXIS= ',A3)
      WRITE(LLUN,9998)AUTO(IAUTOY+1),TYPE(ITYPEY),NMTCY,LINTY,
     *LABELY,NSIGY,NTICY
      IF(IFRY.EQ.' ')THEN
      WRITE(LLUN,9988) 'Y',YORG
      ELSE
      WRITE(LLUN,9987) 'Y',YORG,IFRY
      ENDIF
      GOTO 5000
C     LINES
300   WRITE(LLUN,9996)
9996  FORMAT(//8X,'MARK',3X,'TYPE',5X,'MARKH',3X,'DN1',
     *3X,'UP1',3X,'DN2',3X,'UP2',2X,'LEN',2X,'PEN')
      DO 301 I=1,MIN(LNUM, NLINES)      ! 3/00 to allow large NPOLYGON
      WRITE(LLUN,9997)IMARK(I),TYPEL(ITYPE(I)+1),HMARK(I),DN1(I),
     *UP1(I),DN2(I),UP2(I),LLENG(I),IPEN(I)
9997  FORMAT(8X,I2,1X,A12,5F6.3,I6,I4)
301   CONTINUE
	WRITE(LLUN,9981)IPEN(0)
9981	FORMAT(/8X,'DEFAULT PEN= ',I2)
      GOTO 5000
C     LABELS
400   WRITE(LLUN,9991)LAB1
9991  FORMAT(1X,A79)
      WRITE(LLUN,9991)XLAB
      WRITE(LLUN,9991)YLAB
	IF(NLAB.NE.0)WRITE(LLUN,9979)
9979	FORMAT(/10X,'XPOS',7X,'YPOS',5X,'HGT',3X,'ROT',3X,'UNITS')
      DO 403 I=1,NLAB
	NCR=LNBLK(LABS(I),255)
	IF(USRLBS(I))THEN
	    SYM='USER'
	ELSE
	    SYM='SYSTEM'
	ENDIF
      WRITE(LLUN,9980)I,XLABS(I),YLABS(I),RHLABS(I),INT(RLABS(I)),
     *SYM,LABS(I)(:NCR)
9980	FORMAT(' LAB',I2,1P2E11.3,0PF6.3,I5,2X,A6,2X,A)
	WRITE(LLUN,9974)XLLABS(I),YLLABS(I),AT(LLTYPE(I)),LT(LTYPE(I))
9974	FORMAT(' LINE PT:',3X,1P2E10.3,2X,A7,5X,A6,' JUSTIFY LABEL')
403	CONTINUE
      GOTO 5000
C     STATS
500   WRITE(LLUN,9995)JTY(JTYPE)
9995  FORMAT(//9X,'DATA OF TYPE',1X,A)
      WRITE(LLUN,9994)XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX
9994  FORMAT(19X,'MIN',12X,'MAX'/9X,'X',1P2E15.4/
     *9X,'Y',2E15.4/9X,'Z',2E15.4)
      IF(JTYPE.LE.0.OR.JTYPE.EQ.2)THEN
      WRITE(LLUN,'(9X,''NX='',I4,'' NY='',I4)')NX,NY
      ELSE
      WRITE(LLUN,'(9X,''LINE'',I3,'' READ'')')LINEN
      DO 501 I=1,LNUM
      WRITE(LLUN,'(9X,''LINE='',I3,'' LEN='',I6)')I,LLENG(I)
501	CONTINUE
      END IF
	IF(ARG.EQ.LST(12))GOTO 1200
      GOTO 5000
C     LEVELS
600   WRITE(LLUN,'(//9X,''LEVEL'',7X,''TYPE'',7X,''NDIG'',7X,''PEN'')')
      NL=NLEV2
      IF(IAUTOC.EQ.0)NL=NLEV
      DO 601 I=1,NL
	NDEC=LDIG(I)
	ICOLR=LCLR(I)
      WRITE(LLUN,'(9X,1PE9.2,3X,A6,2I9)')ZLEV(I),CLEV(LWGT(I)),NDEC,
     *ICOLR
601	CONTINUE
      GOTO 5000
C     READ
700   WRITE(LLUN,9990)IFORM,ITYPEZ,JTY(JTYPE)
9990  FORMAT(//9X,'THE FORMAT IS'/9X,A80/9X,'ITYPEZ=',I2,
     *'  DATA IS ',A7)
      WRITE(LLUN,9989)JX,JY,JZ,NVAR,NGRP,NREC,LINEN,NX,NY
9989  FORMAT(9X,'JX=',I2,'  JY=',I2,'  JZ=',I2/
     *9X,'NO. VARS PER GROUP=',I6/9X,'NO. GRPS PER RECORD=',I6/
     *9X,'NO. OF RECORDS=',I6/9X,'LINEN=',I6,'  NX=',I6,'  NY=',I6)
      GOTO 5000
C     CONSET
800   if (draftsman) then
	drafts_txt = 'TRUE '
      else
      	drafts_txt = 'FALSE'
      end if
      WRITE(LLUN,9993)HGT,NSIGC,NARC,DASHLN,SPACLN,CAY,NRNG,DSLAB,
     *CANGLE,spline_tension,drafts_txt
9993  FORMAT(//9X,'CONTOUR CONSTANTS'/9X,'HGT=',1PE9.2,' NSIG=',I3,
     *' NARC=',I3,' DASHLN=',E9.2,/9X,'SPACLN=',E9.2,' CAY=',
     *E9.2,' NRNG=',I3,' DSLAB=',E9.2,' ANGLE=',G9.2,
     */9x,'SPLINE TENSION=',e9.2,' DRAFTSMAN=',a5)

      WRITE(LLUN,9971)CONPRE,CONPST
9971  FORMAT(9X,'LABEL PREFIX= ',A10,'   POSTFIX= ',A10)
      GOTO 5000
C     LABSET
900   WRITE(LLUN,'(//9X,''LABEL CHAR HEIGHTS'')')
      WRITE(LLUN,9992)HLAB1,HXLAB,HYLAB,HLABS
9992  FORMAT(9X,'HLAB1=',1PE9.2,' HXLAB=',E9.2,' HYLAB=',
     *E9.2,' HLABS=',E9.2)
      GOTO 5000

C     TAXIS
1000  WRITE(LLUN,'(//9X,''TAXIS QUALITIES'')')
      WRITE(LLUN,9985)TLO,DT,TCSIZE,ITYPET,VANG,
     *ONOFF(IAXON(1)),ONOFF(IAXON(2))
9985  FORMAT(9X,'LO=',1PE9.2,' DT=',E9.2,' CSIZE=',E9.2,
     *' TYPE= TAXIS',I1,' VANG=',E9.2,/,9X,' TOP AXIS= ',A3,
     *' BOTTOM AXIS= ',A3)

      CALL TIME2(IT1,SYM)
      CALL TIME2(IT2,SYM2)
      CALL TIME2(ITSTRT,SYM3)

      WRITE(LLUN,9984) IT1(13:14)//IT1(1:12),SYM,
     *IT2(13:14)//IT2(1:12),SYM2,ITSTRT(13:14)//ITSTRT(1:12),
     *SYM3,NMTCT,LABELT,
     *IFDB,ISDB,TAXTYP(MIN(ITFLG,1)),onoff(iautot)

9984  FORMAT(9X,'  TMIN=',A14,1x,A21,/9X,'  TMAX=',A14,1x,A21/9X,
     *'TSTART=',A14,1x,A21,/9X,'NMTC=',I3,' LABEL=',I3,' IFDB=',I3,
     *' ISDB=',I3,' TAXIS= ',A5,' IAUTOT= ',a3)
      GOTO 5000

C     TICS
1100  WRITE(LLUN,9983)TSMX,TLX,TSMY,TLY
9983  FORMAT(9X,'SMALL XTIC=',1PE10.3,'   LARGE XTIC=',E10.3,
     */9X,'SMALL YTIC=',E10.3,'   LARGE YTIC=',E10.3)
      WRITE(LLUN,9982)TIC(ITX),TIC(ITY)
9982  FORMAT(9X,'X AXIS TICS ',A7,'   Y AXIS TICS ',A7)
	GOTO 5000
C	DATA
1200	CALL DATLST(LLUN,X,NSIZE,NX,NY)
	GOTO 5000
C	PLOT
1300	WRITE(LLUN,9977)WIDTH,HEIGHT,MOD,IR
9977	FORMAT(9X,'WIDTH= ',F7.2,'  HEIGHT= ',F7.2,'  TKTYPE=',I5
     *  ,'  BAUD=',I5)
	WRITE(LLUN,9978)ONOFF(IWIND),ONOFF(IP(1)),ICROSS,ICODE
9978	FORMAT(9X,'WINDOW= ',A3,'  BOX= ',A3,'  CROSS=',I2,
     *  '  PLTYPE=',I3)
***	WRITE(LLUN,9972)PMODE,FILEZ
	WRITE(LLUN,9972)PMODE,meta_file
9972	FORMAT(9X,'PLOT MODE= ',A3/9X,'PLOT FILE= ',A)
	GOTO 5000
C	DATPT
1400	WRITE(LLUN,9973)IZT(IZTYP),IZMRK,IZLEN
9973	FORMAT(9X,'GRID POINTS = ',A8,' MARK= ',I4,' LEN=',I10)
	GOTO 5000
C	TRANSXY
1500	WRITE(LLUN,9970)
9970	FORMAT(9X,'LINE',4X,'XFACT',5X,'XOFF',6X,'YFACT',4X,'YOFF')
	DO 1501 I=1,LNUM
	WRITE(LLUN,9969)I,XFCT(I),XOFF(I),YFCT(I),YOFF(I)
9969	FORMAT(9X,I3,1X,1P4E10.2)
1501	CONTINUE
	GOTO 5000
C	LIMITS
1600	WRITE(LLUN,9976)XLE,CMXLE,XEQ,CMXEQ,XGE,CMXGE,
     *	YLE,CMYLE,YEQ,CMYEQ,YGE,CMYGE,
     *	ZLE,CMZLE,ZEQ,CMZEQ,ZGE,CMZGE
9976	FORMAT(9X,'TEST',4X,'TRUE/FALSE',7X,'VALUE'//
     *  10X,'XLE',8X,L1,8X,1PE11.3/
     *  10X,'XEQ',8X,L1,8X,1PE11.3/
     *  10X,'XGE',8X,L1,8X,1PE11.3/
     *  10X,'YLE',8X,L1,8X,1PE11.3/
     *  10X,'YEQ',8X,L1,8X,1PE11.3/
     *  10X,'YGE',8X,L1,8X,1PE11.3/
     *  10X,'ZLE',8X,L1,8X,1PE11.3/
     *  10X,'ZEQ',8X,L1,8X,1PE11.3/
     *  10X,'ZGE',8X,L1,8X,1PE11.3)
	GOTO 5000
C	VECTOR
1700	WRITE(LLUN,9968)VLEN,VUSRLN,VAUTO
9968	FORMAT(9X,'SCALE LENGTH = ',F5.3,'  SCALE = ',1PG10.3,
     *  '  AUTO SCALE = ',L4)
***     *	'  AUTO SCALE = ',L)
	WRITE(LLUN,9967)VXLOC,VYLOC,VUSER,VKEY,LT(IFIX(VPOS)),VFRMT
9967	FORMAT(9X,'XPOS = ',1PG10.3,'  YPOS = ',G10.3,
     *  '  USER = ',L4,'  DRAW KEY = ',L4/9X,'JUSTIFY ',A8,2X,A20)
***     *	'  USER = ',L,'  DRAW KEY = ',L/9X,'JUSTIFY ',A8,2X,A20)
	goto 5000

*	Mods to include shade and aline info JD 11.9.89
C	SHASET info
1800	if (.not. custom_colors) then
	   write (llun,10011)
	   goto 5000
	end if
10011	format (/9x/,'DEVICE DEFAULT COLORS ARE SET')

        if (rgb_mapping .eq. percent) then
            mapping = 'Percent'
          else if (rgb_mapping .eq. by_value) then
            mapping = 'By_value'
          else if (rgb_mapping .eq. by_level) then
            mapping = 'By_level'
        end if

        if (rgb_mapping .ne. by_level) then
           write (llun,10001) mapping
10001      format (/9x, 'RGB_MAPPING ', a,
     .       //9x,'SET POINT',7x,'RED',7x,'GREEN',8x,'BLUE')
        else
           write (llun,11001) mapping
11001      format (/9x, 'RGB_MAPPING ', a,
     .       //9x,'    LEVEL',7x,'RED',7x,'GREEN',8x,'BLUE')
        end if

	if (rgb_mapping .ne. by_level) then
           do 1801 i = 1,ncl
              write (llun,10002) 
     .             slvl(i),sr(i)*100.0,sg(i)*100.0,sb(i)*100.0 
 1801      continue
10002      format (9x,f9.1,5x,f5.1,7x,f5.1,7x,f5.1)
        else
           do 1802 i = 1,ncl
              write (llun,11002) 
     .             i,sr(i)*100.0,sg(i)*100.0,sb(i)*100.0 
 1802      continue
11002      format (9x,i9,5x,f5.1,7x,f5.1,7x,f5.1)
        end if
	goto 5000

C	SHAKEY info
1900	write (llun,10003) 
10003	format (/9x,'DO KEY',2x,'ORIENT',2x,'LAB SIZE',2x,
     .  'LAB INC',2x,'LAB DIG',2x,'LAB LEN')
		
	if (do_key) then                             
	   x_do_key = 1
	else
	   x_do_key = 0
	end if

	if (vertical_key) then
	   x_orient = 1
	else
	   x_orient = 0
	end if

	write (llun,10004) x_do_key,x_orient,klab_size,klab_incr,
     .				klab_dig,klab_len
10004	format (9x,i6,2x,i6,2x,f8.2,2x,i7,2x,i7,2x,i7)

c  Write out location of key, whether it was user-located or automatically set


        IF (kuser_loc(1) .OR. kuser_loc(2) .OR.
     .      kuser_loc(3) .OR. kuser_loc(4) ) THEN
            WRITE (llun,10005)
        ELSE
	   WRITE (llun,10007) 
        ENDIF

	write (llun,10006) kx_lo/1000.0,kx_hi/1000.0,     
     .		              ky_lo/1000.0,ky_hi/1000.0

10005	format (//9x,'X LO',5x,'X HI',5x,'Y LO',5x,'Y HI')
10006	format (4x,4f9.2)
10007	format (//9x,'DEFAULT KEY POSITIONING'/
     .            9x,'X LO',5x,'X HI',5x,'Y LO',5x,'Y HI')
	goto 5000

C	ALINE info
2000	none = .true.
	do 2001 i = 1,lnum    
	   if (aline_on(i)) none = .false.
2001	continue

	if (none) then
	   write (llun,10008)
	   goto 5000
	end if
10008	format (//9x,'NO LINES SET')

	write (llun,10009)
10009	format (//9x,'LINE #',5x,'UNITS',5x,'X MIN',5x,'Y MIN',
     .                                   5x,'X MAX',5x,'Y MAX')
	do 2002 i = 1,lnum
	   if (.not. aline_on(i)) goto 2002

	   if (aline_user(i)) then
	      x_user = '  USER'
	   else
	      x_user = 'NOUSER'
	   end if

	   write (llun,10010) i,x_user,aline_minx(i),aline_miny(i),
     .				aline_maxx(i),aline_maxy(i)
2002	continue
10010	format (9x,i6,4x,a6,4f10.2)
	goto 5000
*	10011 format stmt is used above -- start with 10012

*	PLTNME listing
2100	write (llun,10012) meta_file

10012   format (/9x,'METAFILE NAME'/9x,a)
	goto 5000

*       LIST CURRENT PATTERNS
 2200   write (llun,10014) 
10014   format (/9x,'PATTERN ORDER',2x,'PATTERN NAME')

	do 2201 i = 1,npat
	   write (llun,10015) i, pattern_list(patterns(i))
 2201   end do
10015   format (19x,i3,2x,a25)

	goto 5000

*       LIST AVAILABLE PATTERNS
* 3/99  *kob* fix up format statment - caught by nag f90
 2300   write (llun,10016)
10016   format (/9x,'AVAILABLE PATTERNS'/9x,'------------------')

 2301   write (llun,10017) pattern_list(solid)
        do 2302 i = 1,20
	   write (llun,10017) pattern_list(i)
 2302   end do
10017   format (9x,a25)
	goto 5000

*       LIST CURRENT CALENDAR
 2400   write (llun,10018)
10018   format (/9x,'SUPPORTED CALENDARS'/9x,'-------------------')

        do 2401 i = 1, max_calendars
              pointer1 = ' '
              pointer2 = ' '
        write (llun,10019) pointer1, allowed_calendars(i), pointer2
 2401   end do

10019   format(9x,a,a,a)
        goto 5000

5000	RETURN
      END

C eofsubs.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
* 
C  EOF code from Billy Kessler.  For cases where time series do not
C  have any gaps.  Implemented 7/2001
C
C  At end are routines count_eof and pack_eof written with Dai McClurg
C  to count the good timeseries and pack the X,Y,T  array into an neof by T
C  array.
C
C
C  Ansley Manke       Change dimension statements for arguments to be (*) or
C                     (NX,*), etc.  The work arrays in the calling functions
C                     have extra space to accomodate I = 1,N... BB(I+1) in 
C                     QRSYM, for example.
C
C                     Declare all variables.
C
C Aug 2001 move to fer/efi directory, EPFs to be statically linked to Ferret.  
C	   Change INCLUDE statements to remove directory spec.
C

C v5.41 *kob* 6/02 - remove unneeded ferret_cmn from INCLUDE lines - 
C                    cygwin does not like them for some reason
C
c Date: Thu, 18 Jan 2001 16:44:10 -0800 (PST)
c From: kessler@pmel.noaa.gov (Billy Kessler)
c Subject: more EOF code (reverse time and space)
c 
c The attached code (one file) contains the following subroutines:
c 
c First set are three different front ends that call the
c routines at bottom that do the work:
c 
c EOFIN         ! for usual EOFs (more times than locations)
c EOFIN2	! EOFs when there are more locations than times
c EOFIN3C	! routine that allows weighting the data (probably 
c	           get rid of this one for ferret)
c
c These are the black-box routines that do the actual work
c 
c FRACVAR	! find percent variance at each point
c QRSYM		! call all the other routines in turn
c HOUSEH	! Householder tridiagonalization of matrix
c QRSTD		! find eigenvalues of tridiagonal matrix
c TRIDIN	! find eigenvectors of tridiagonal matrix
c BACKS		! does something
c 
c * Actually, either EOFIN or EOFIN2 produces exactly the same
c result (but see note 1). These two routines do not care about 
c zero eigenvalues, so there is really no restriction at all on 
c their use. However, EOFIN2 will be faster if there are more 
c locations than times. So a possible choice for this whole mess 
c would be just to use EOFIN for all cases (except for gappy time 
c series). That might be the most straightforward thing to do,
c even if it is not the most elegant code.
c 
c Notes: 
c 
c Note 1: The eigenvalues out of EOFIN2 differ from those of EOFIN
c by the factor (NT/NX). THis is due to the fact that there are NT 
c non-zero eigenvalues produced by EOFIN2 (since it assumes that NT<NX), 
c while there are NX produced by EOFIN. However, I have scaled the 
c EOFs and PCs to be identical. This should not matter to anyone.
c 
c Note 3: Differences between the outputs of these three occur for
c the higher eigenvalues/vectors, as the values of the eigenvalues
c come down towards the computational noise and slight differences
c in cutoff values hardwired into the routines. These are iterative
c search routines and I have not tried to make the cutoffs (when the
c routine decides it has found a value) consistent. This should not 
c matter for geophysical work.
c 
c Note 4: Odd results can occur in SVDEOF for input fields that do
c not have NX degrees of freedom. I spent an embarrassingly long
c amount of time this afternoon "debugging" a test program that I
c was feeding a simple idealized (product of sinusoids) field. The
c field could be represented in only a handful of eigenvectors, but
c SVDEOF cranked off NX of them, and the higher eigenvalues were
c pure noise. Some of them were large though, and overwhelmed the
c others. So if you are making up test fields, use the RANDU 
c function to add sufficient noise to "use up" all the eigenvectors.
c This will not be a problem for geophysical fields, which always
c have sufficient noise. For some reason EOFIN and EOFIN2 do not
c appear to have this problem.
c 
c Note 5: I wrote this code in 1982-83, with Nancy Soreide (then a 
c programmer for Stan Hayes) holding my hand. It was the first thing
c I did as a graduate student.
c 
c Billy

C-------------------------------------------------------------------------------
C	EOFSUB_2.FOR MODIFIES TRIDIN TO PASS OVERFLOW. SEE NEAR END OF TRIDIN.
C	ALSO MODIFIES QRSYM TO NOTE PROGRESS TO 6.
C-------------------------------------------------------------------------------

C.................EOFIN.FOR is a front end to the EOF subroutines which follow.
C.................Arrangement of output:
C					  VEC(position,EOF#)
C					  TAF(EOF#,time)

c	Variables:
c	data(nx,nt)	I/O	original data		Returned demeaned
c	nx		I	number of spatial locations
c	nt		I	number of time realizations
c	val(nx)		O	eigenvalues (Lambda)
c	vec(nx,nx)	O	eigenvectors (Lambda*U). Same units as data.
c	taf(nx,nt)	O	time amplitude functions (V). Dimensionless.
c	pct(nx)		O	% variance represented by each EOF.
		
	SUBROUTINE EOFIN(DATA,NX,NT,VAL,VEC,TAF,PCT,C,eofwork)

        IMPLICIT NONE

C  Calling argument declarations.

        INTEGER   NX, NT
	REAL      DATA(NX,*),PCT(*),VAL(*),VEC(NX,*),TAF(NX,*),C(NX,*)
	REAL eofwork(*)

C  Internal declarations

	INTEGER I, J, I1, I2, IE, IS
	REAL TVAR, RNT
C---------------------------------------------------------------------
C.................Find mean, demean DATA.
C.................Note PCT is used first as a dummy to save the mean.
	RNT = NT
	DO 100 I=1,NX
	PCT(I)=0.0
	DO 110 J=1,NT
110	PCT(I)=PCT(I)+DATA(I,J)/RNT
	DO 120 J=1,NT
120	DATA(I,J)=DATA(I,J)-PCT(I)
100	CONTINUE
C--------------------------------------------------------------------
C.................Form the mean product matrix.
	DO 210 I1=1,NX
	DO 211 I2=1,NX

	DO 200 J=1,NT
200	C(I1,I2) = C(I1,I2) + DATA(I1,J) * DATA(I2,J)

	C(I1,I2) = C(I1,I2)/ RNT

211	CONTINUE
210	CONTINUE
C------------------------------------------------------------------------
C.................Call the subroutines which do the work.

	CALL QRSYM(C,NX,VAL,VEC, eofwork)

C.................VEC(IS,IE) is arranged so that IS indexes the space
C.................dimension of each eigenvector and IE the EOF number.
C------------------------------------------------------------------------
C.................Find the percentage of total variance accounted for by
C.................each eigenvector.
	TVAR=0.0
	DO 220 I=1,NX
220	TVAR=TVAR+VAL(I)
	DO 221 I=1,NX
221	PCT(I)=100.*ABS(VAL(I)/TVAR)
C------------------------------------------------------------------------
C.................Renormalize EOFs.
C.................Thus EOFs have units of data, while time amplitude functions
C.................are dimensionless.
C.................Thus the sum of the squares of a given EOF = eigenvalue.
C.................And the mean of a given TAF = 1.
C-------------------------------------------------------------------------
C.................First compute the time amplitude function from the data.
C.................Renormalize each TAF by dividing by SQRT of its eigenvalue.

	DO 350 J=1,NT			! loop over time
	DO 360 IE=1,NX			! loop over EOF numbers

	TAF(IE,J)=0.0

	DO 370 IS=1,NX
370	TAF(IE,J) = TAF(IE,J) + VEC(IS,IE)*DATA(IS,J)/SQRT(ABS(VAL(IE)))

360	CONTINUE
350	CONTINUE

C.................Renormalize each EOF by the SQRT of its eigenvalue.

	DO 300 IE=1,NX			! loop over EOF numbers
	DO 310 IS=1,NX
310	VEC(IS,IE) = VEC(IS,IE)*SQRT(ABS(VAL(IE)))
300	CONTINUE
C----------------------------------------------------------------------
	RETURN
	END
		

C************************************************************************


c -+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

C  eofin_chel_gap from Billy Kessler.  
C  Ansley Manke 9/98  Change to have the bad-data flag "realbad" an argument
C                     and to test for .GT. realbad rather than .LT.
C                     Add argument pct_cutoff for where to stop the computations
C                     that normalize eigenvectors and compute time functions,
C                     and returning nout = number of functions to output.
C  Ansley Manke 8/99  Change dimension statements for arguments to be (*) or
C                     (NX,*), etc.  The work arrays in the calling functions
C                     now have extra space to accomodate I = 1,N... BB(I+1) in 
C                     QRSYM, for example.
C  Ansley Manke 10/00 Change bad-data flag "realbad"  to bad_flag_dat
C                     and a separate flag for bad_flag_result, the bad-data
C                     flag for the result.
C  Ansley Manke 1/01  declare all variables.
C
C  Ansley Manke 5/01  remove pct_cutoff as a parameter
C 
C  Ansley Manke 9/05  Make all workspace be allocated as external function work 
C                     arrays. Arrays in TRIDIN passed in rather than declared.
C  Ansley Manke 7/12  Changes for solving EOF's in double precision.
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c	eof_gap_sub4.f 
c	implements Chelton's '82 method for finding EOFs of gappy time series.
c	4 fixes a few imprecisions in earlier versions:
c		1) sets negative eigenvalues to eps = 1/10th smallest EV
c		2) blanks TAF if ALL data missing at a given time realization.
c	If no gaps, reduces to ordinary EOFs (but computationally wasteful).
c	Requires eigenvalue finder SUBROUTINEs in eofsub_2.for.
c	Gaps assumed to be marked by values = 1.e34.
c***************************************************************************

C..........SUBROUTINE EOFIN_CHEL_GAP 
c..........is a front end to the EOF SUBROUTINEs in eofsub_2.for.


c	Variables:
c	data(nx,nt)	I/O	original data.	Returned demeaned.
c	nx		I	number of spatial locations
c	nt		I	number of time realizations
c	val(nx)		O	eigenvalues (Lambda)
c	vec(nx,nx)	O	eigenvectors (Lambda*U). Same units as data.
c	taf(nx,nt)	O	time amplitude functions (V). Dimensionless.
c	pct(nx)		O	% variance represented by each EOF.
c	c(nx,nx)	O	work space for cov matrix (garbage output)

C..........Arrangement of output:
C					  VEC(position,EOF#)
C					  TAF(EOF#,time)
		
C---------------------------------------------------------------------
      SUBROUTINE EOFIN_CHEL_GAP (DATA,NX,NT,VAL,VEC,TAF,PCT,C, 
     +      eofwork, bad_flag_dat, bad_flag_result, err_msg, ier)

        IMPLICIT NONE

        INTEGER nx
	REAL DATA(NX,*), PCT(*), VAL(*), VEC(NX,*),
     +            TAF(NX,*), C(NX,*)

      CHARACTER*(*) err_msg

      INTEGER nt, ier, ix, i2, it, i, j, i1, ie, npr,
     .        ic, is
      REAL ct, eps, sumljgji, beta, tvar

      REAL eofwork(*)
      REAL bad_flag_dat, bad_flag_result

C---------------------------------------------------------------------
c.............initializations.

        ier = 0
	do 50 ix=1,nx
	val(ix)=0.
	pct(ix)=0.
	do 51 i2=1,nx
	vec(ix,i2)=0.
51	c(ix,i2)=0.
	do 52 it=1,nt
52	taf(ix,it)=0.
50	continue
C---------------------------------------------------------------------
C.................Find mean, demean DATA.
C.................Note PCT is used first as a dummy to save the mean.
	DO 100 I=1,NX
	ct=0.
	DO 110 J=1,NT
	if (data(i,j).GT.bad_flag_dat) then
		PCT(I)=PCT(I)+DATA(I,J)
		ct=ct+1.
	endif
110	continue
	if (ct.gt.0.) then
		pct(i)=pct(i)/ct
	else
	   write(err_msg,*) ' EOFIN_CHEL_GAP found the time series',
     .                     ' at ix=',i,' with no values.'
           ier = 1
	   return
	endif
	DO 120 J=1,NT
	if (data(i,j).GT.bad_flag_dat) then
		DATA(I,J)=DATA(I,J)-PCT(I)
	endif
120	continue
100	CONTINUE
C--------------------------------------------------------------------
C.................Form the mean product matrix.
	DO 210 I1=1,NX
	DO 210 I2=1,NX

	ct=0.
	DO 200 J=1,NT
	if (data(i1,j).GT.bad_flag_dat .and. data(i2,j).GT.bad_flag_dat) then
		ct=ct+1.
		C(I1,I2) = C(I1,I2) + DATA(I1,J) * DATA(I2,J)
	endif
200	continue

	if (ct.gt.0.) then
		c(i1,i2)=c(i1,i2)/ct
	else
           write(err_msg,*) ' EOFIN_CHEL_GAP found no overlapping',
     .       ' values in two time series at EOF-1D-coordinates ', 
     .       i1,i2, ' Will be a zero in covariance matrix'
           ier = 1
           return
	endif

210	CONTINUE
C------------------------------------------------------------------------
C.................Call the subroutines which do the work.

	CALL QRSYM(C,NX,VAL,VEC, eofwork) 

C.................VEC(IS,IE) is arranged so that IS indexes the space
C.................dimension of each eigenvector and IE the EOF number.
C------------------------------------------------------------------------
c...................check for negative eigenvalues, set to eps.
	do 250 ie=1,nx
250	if (val(ie).lt.0.) GOTO 251
	GOTO 252

251	continue
cc 251	write(6,*) 'Found a negative eigenvalue. EV#',ie,
cc     .        ' Further checking ...'
cc 251	write(6,*) 'Found a negative eigenvalue. Further checking ...'

	eps=1.e20
	do 255 ie=1,nx
255	if (abs(val(ie)).lt.eps) eps=abs(val(ie))
	eps=eps/10.
cc	write(6,*) 'Setting epsilon to',eps
cc	write(6,*) '= 1/10th of the smallest eigenvalue'
	do 256 ie=1,nx
	if (val(ie).lt.0.) then
cc		write(6,*) 'Setting EV #',ie,' =',val(ie),
cc     .					' to epsilon (=',eps,')'
		val(ie)=eps
	endif
256	continue
252	continue

C----------------------------------------------------------------------
C !ACM  Array pctis used as a dummy array below, and we will compute it 
C       again before returning.
C.................Find the percentage of total variance accounted for by
C.................each eigenvector.
c.................Place this at the end to be able to use pct as dummy
c.................for counting missing data in TAF calculation.
	TVAR=0.0
	DO 1220 I=1,NX
1220	TVAR=TVAR+VAL(I)
	DO 1221 I=1,NX
	PCT(I)=100.*ABS(VAL(I)/TVAR)
c 1221	IF (PCT(I) .GE. pct_cutoff) NX_compute = I
1221	CONTINUE

C------------------------------------------------------------------------
C.................Renormalize EOFs.
C.................Thus EOFs have units of data, while time amplitude functions
C.................are dimensionless.
C.................Thus the sum of the values of a given EOF = SQRT(eigenvalue).
C.................And the mean of a given TAF = 1.
C-------------------------------------------------------------------------
C.................First compute the time amplitude function from the data.
C.................Renormalize each TAF by dividing by SQRT of its eigenvalue.

c...........................loop over time

c        nout = NX
	DO 350 J=1,NT
	npr = nt/ 10 
        if (nt .gt. 100) npr = (npr/ 10) * 10     

c............find out if any gaps exist at this time.
c............use ic to count them and pct(nx) to keep track of where they are.
	ic=0
	do 400 is=1,nx
	if (data(is,j).GT.bad_flag_dat) then
		ic=ic+1
		pct(is)=0.
	else
		pct(is)=1.
	endif
400	continue

c..............if no blanks at this time, compute TAF as usual.
	if (ic.eq.nx) then
c................................loop over EOF numbers, then over space.
		DO 360 IE=1,NX

		DO 370 IS=1,NX
370		TAF(IE,J) = TAF(IE,J) + 
     .			    VEC(IS,IE)*DATA(IS,J)
360		CONTINUE
	elseif (ic.eq.0) then
c..............If there are NO data values at time j, then blank the TAF.
		do 450 ie=1,nx
450		taf(ie,j)=bad_flag_result
	else
c.............If there are some blanks, then use Chelton's estimate Beta_i(t).
c.............Now use c(nx,nx) as dummy to keep Chelton's Gamma_ji.
c.............Fill c(i,j), where i and j are both EOF #s. 
c.............Sum over MISSING data points only.

		do 410 i1=1,NX
		do 410 i2=1,nx
		   c(i1,i2)=0.
		   do 415 ix=1,nx
415		   if (pct(ix).eq.1)
     .			c(i1,i2)=c(i1,i2)+vec(ix,i1)*vec(ix,i2)
410		continue

c..................Loop over EOF numbers.
		do 420 ie=1,NX

c......................Find Beta_i(t) from Gamma_ij.
c......................Also need the sum of Lambda_j*Gamma_ji**2 over all j.ne.i

c.......................loop 430 sums over space.
		   sumljgji=0.
                   do 430 i2=1,nx
430                if (i2.ne.ie) sumljgji=sumljgji+val(i2)*c(i2,ie)**2
c
c  Billy said to replace the loop below with the one above. This is the
c    problem that Mick spotted. 
c
c		   do 430 i2=1,nx
c		   if (i2.eq.ie) GOTO 431
c 430		   sumljgji=sumljgji+val(i2)*c(i2,ie)**2
c
431		   continue

c.....................find beta.
		   beta = ( (1.-c(ie,ie)) * val(ie) ) / 
     .			 ( val(ie) * (1.-c(ie,ie))**2 + sumljgji )

c...................Now find TAF. Summation in space over existing points only.
		   do 440 is=1,nx
440			if (pct(is).eq.0.) taf(ie,j) = taf(ie,j) + 
     .			   	beta * vec(is,ie) * data(is,j)

420		continue


	endif
		
350	CONTINUE

C-------------------------------------------------------------------------
C.................Renormalize each EOF by the SQRT of its eigenvalue.
c.................loop over EOF numbers, then over space.

	DO 300 IE=1,NX
	do 315 j=1,nt

315	if (taf(ie,j) .GT. bad_flag_dat) taf(ie,j)=taf(ie,j)/sqrt(val(ie))
	DO 316 IS=1,NX
316	VEC(IS,IE) = VEC(IS,IE)*SQRT(VAL(IE))
300	CONTINUE
C----------------------------------------------------------------------
C.................Find the percentage of total variance accounted for by
C.................each eigenvector.
c.................Place this at the end to be able to use pct as dummy
c.................for counting missing data in TAF calculation.
	TVAR=0.0
	DO 220 I=1,NX
220	TVAR=TVAR+VAL(I)
	DO 221 I=1,NX
221	PCT(I)=100.*ABS(VAL(I)/TVAR)
C------------------------------------------------------------------------
	RETURN
	END

C************************************************************************
      SUBROUTINE QRSYM (A,N,E,X, eofwork)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER N
      REAL A(N,*),E(*),X(N,*)

* No need to declare Z,T,E,F dimensions since they are not used
* and Fortran arrays are column major
      REAL eofwork(wrk9lox:wrk9hix, wrk9loy:wrk9hiy)

*  
* 5/99 ACM  Use a work array eofwork rather than explicitly dimensioned
*           arrays ALPHA, BETA, BB, and P (originally declared in HOUSEH)
c      DIMENSION ALPHA(4000),BETA(4000),BB(4000)

      INTEGER nb
      REAL rnorm, eps
      REAL macheps

      nb=n

* Set macheps once and pass into QRSTD where its used as ETA
* and into TRIDIN.
* Assign 2**(-48) to a variable so it is the correct size REAL
* (should this be different under double-precision?)
      macheps = 2.**(-48)

      CALL HOUSEH(A,N,eofwork(1,1),eofwork(1,2),NB,
     .            eofwork(1,4))

      CALL QRSTD (eofwork(1,1),eofwork(1,2),N,E,
     .            eofwork(1,3),RNORM,MACHEPS, EPS)

      CALL TRIDIN(eofwork(1,1),eofwork(1,2),N,E,RNORM,
     .            N,macheps,X,NB,eofwork(1,5),eofwork(1,6),
     .            eofwork(1,7),eofwork(1,8),eofwork(1,9),
     .            eofwork(1,10) )

      CALL BACKS(eofwork(1,2),A,N,X,N,EPS,NB)

      RETURN
      END


C**********************************************************************

      SUBROUTINE HOUSEH (G,N,A,B,NB, p)

c  7/2002 ACM  Make the sums etc for calculating the matrix inverse
c              double precision.

      INTEGER NB
      REAL G(NB,*),A(*),B(*)

c      DIMENSION P(2000)
      REAL P(*)

      INTEGER n, n2, k, k1, i, j, i1
      REAL*8 sum, sigma, absb, alpha, beta, gamma, t

      N2=N-2
      IF(N2)45,44,2
    2 DO 43 K=1,N2
      A(K)=G(K,K)
      SUM=0
      K1=K+1
      DO 8 I=K1,N
    8 SUM=SUM+G(I,K)**2
      SIGMA=SUM
      ABSB=SQRT(SIGMA)
      ALPHA=G(K+1,K)
      BETA=-ABSB
      IF(ALPHA)15,16,16
   15 BETA=ABSB
   16 B(K)=BETA
      IF(SIGMA)18,43,18
   18 GAMMA=1/(SIGMA-ALPHA*BETA)
      G(K+1,K)=ALPHA-BETA		! change C so now not Mean Prod Matrix
      DO 27 I=K1,N
      SUM=0
      DO 23 J=K1,I
   23 SUM=SUM+G(I,J)*G(J,K)
      IF(I.EQ.N)GO TO 27
      I1=I+1
      DO 26 J=I1,N
   26 SUM=SUM+G(J,I)*G(J,K)
   27 P(I)=GAMMA*SUM
      SUM=0
      DO 30 I=K1,N
   30 SUM=SUM+G(I,K)*P(I)
      T=0.5*GAMMA*SUM
      DO 32 I=K1,N
   32 P(I)=P(I)-T*G(I,K)
      DO 35 I=K1,N
      DO 35 J=K1,I
   35 G(I,J)=G(I,J)-G(I,K)*P(J)-P(I)*G(J,K)
   43 CONTINUE
   44 A(N-1)=G(N-1,N-1)
      B(N-1)=G(N,N-1)
   45 A(N)=G(N,N)
      B(N)=0.0
      RETURN
      END

C************************************************************************

      SUBROUTINE QRSTD (ALPHA,BETA,N,E,BB,RNORM,ETA,EPS)
      REAL ALPHA(*),BETA(*),E(*),BB(*)

      INTEGER n, i, k, m, n1, i1, j
      REAL eta, delta, t, r, w, c, s, shift, g, p, ek1, rnorm, eps


C W.KAHAN AND J.VARAH, TWO WORKING ALGORITHMS FOR THE EIGENVALUES OF A
C SYMMETRIC TRIDIAGONAL MATRIX. TECHNICAL REPORT NO. CS43, AUGUST 11,
C 1966. COMP.SC.DEPT. STANFORD UNIVERSITY.

      DO 2 I=1,N
      E(I)=ALPHA(I)
      BB(I+1)=BETA(I)**2
    2 continue
      BB(1)=0.0
      BB(N+1)=0.0
C INFINITY NORM OF TRIDIAGONAL MATRIX
      RNORM=0.0
      DO 5 I=1,N
    5 RNORM=AMAX1(RNORM,SQRT(BB(I))+ABS(E(I))+SQRT(BB(I+1)))
C ETA = RELATIVE MACHINE PRECISION
      DELTA=ETA*RNORM
      EPS=DELTA**2
      IF (EPS.EQ.0) RETURN
      K=N
    6 M=K
      IF(M.LE.0)GO TO 56
    8 K=K-1
      IF(BB(K+1).GE.EPS)GO TO 8
C NEXT
      IF(K.NE.M-1)GO TO 13
      BB(K+1)=0.0
      GO TO 6
C TWOBY2
   13 T=E(M)-E(M-1)
      R=BB(M)
      IF(K.GE.M-2)GO TO 22
      W=BB(M-1)
      C=T**2
      S=R/(C+W)
      IF(S*(W+S*C).GE.EPS)GO TO 22
      M=M-1
      BB(M+1)=0.0
      GO TO 13
C END NEGLIGIBLE BB
   22 IF(ABS(T).GE.DELTA)GO TO 25
      S=SQRT(R)
      GO TO 28
   25 W=2.0/T
      S=W*R/(SQRT(W**2*R+1.0)+1.0)
   28 IF(K.NE.M-2)GO TO 33
      E(M)=E(M)+S
      E(M-1)=E(M-1)-S
      BB(K+1)=0.0
      GO TO 6
C DO A QR STEP ON ROWS AND COLUMNS K+1 THROUGH M
   33 SHIFT=E(M)+S
      IF(ABS(T).GE.DELTA)GO TO 37
      W=E(M-1)-S
      IF(ABS(W).LT.ABS(SHIFT))SHIFT=W
   37 S=0.0
      G=E(K+1)-SHIFT
      C=1.0
      GO TO 45
C LOOP
   40 C=P/T
      S=W/T
      W=G
      EK1=E(K+1)
      G=C*(EK1-SHIFT)-S*W
      E(K)=(W-G)+EK1
C ENTRY
   45 IF(ABS(G).GE.DELTA)GO TO 48
      IF(G.GE.0.0)GO TO 47
      G=G-C*DELTA
      GO TO 48
   47 G=G+C*DELTA
   48 P=G**2/C
      K=K+1
      W=BB(K+1)
      T=W+P
      BB(K)=S*T
   50 IF(K.LT.M)GO TO 40
      E(K)=G+SHIFT
      GO TO 6
C SORT
   56 IF(N.EQ.1)RETURN
      N1=N-1
      DO 70 I=1,N1
      K=I
      T=E(I)
      I1=I+1
      DO 62 J=I1,N
      IF(E(J).LE.T)GO TO 62
      T=E(J)
      K=J
   62 CONTINUE
      IF(I.EQ.K)GO TO 70
      E(K)=E(I)
      E(I)=T
   70 CONTINUE
      RETURN
      END

C*************************************************************************

      SUBROUTINE TRIDIN (C,B,N,W,NORM,M1,MACHEPS,Z,NB,M,P,Q,R,INT,X)

      INTEGER nb, nminus1, ii
      REAL C(*),B(*),W(*),Z(NB,*),
     .     M(*),P(*),Q(*),R(*),INT(*),X(*)

C J.H.WILKINSON, CALCULATION OF THE EIGENVECTORS OF A SYMMETRIC
C TRIDIAGONAL MATRIX BY INVERSE ITERATION. NUMERISCHE MATHEMATIK 4,
C 368-376 (1962)

* 9/05 ACM  Use a work array eofwork rather than explicitly dimensioned
*           arrays M, P, Q, R, INT, and X

c      REAL M(4000),P(4000),Q(4000),R(4000),INT(4000),X(4002)

      INTEGER N,M1
      REAL NORM,MACHEPS

      INTEGER I,J
c      REAL BI,BI1,Z1,LAMBDA,U,S,V,H,EPS,ETA
      REAL BI,BI1,LAMBDA,U,V,H,EPS,ETA,BIG,BIGGER


* In single-precision these were 1.e10 and 1.e20
* Determined by trial and error.
	
#ifdef double_p
      big = 1.E20
      bigger = 1.E30
#else
      big = 1.E10
      bigger = 1.E20
#endif

      IF (N-1)10,20,30
   20 Z(1,1)=1.
   10 RETURN
   30 CONTINUE
      LAMBDA=NORM
      EPS=MACHEPS*NORM
      DO 90 J=1,M1
      LAMBDA=LAMBDA-EPS
      IF(W(J).LT.LAMBDA)LAMBDA=W(J)
      U=C(1)-LAMBDA
      V=B(1)
      IF(V.EQ.0)V=EPS
      NMINUS1=N-1
      DO 60 I=1,NMINUS1
      BI=B(I)
      IF(BI.EQ.0)BI=EPS
      BI1=B(I+1)
      IF(BI1.EQ.0)BI1=EPS
      IF(ABS(BI).LT.ABS(U))GO TO 50
      M(I+1)=U/BI
      IF((M(I+1).EQ.0).AND.(BI.LE.EPS))M(I+1)=1
      P(I)=BI
      Q(I)=C(I+1)-LAMBDA
      R(I)=BI1
      U=V-M(I+1)*Q(I)
      V=-M(I+1)*R(I)
      INT(I+1)=+1
      GO TO 60
   50 M(I+1)=BI/U
      P(I)=U
      Q(I)=V
       R(I)=0
      U=C(I+1)-LAMBDA-M(I+1)*V
      V=BI1
      INT(I+1)=-1
   60 CONTINUE
      P(N)=U
      Q(N)=0
      R(N)=0
      X(N+1)=0
      X(N+2)=0
      H=0
      ETA=1.0/N
      DO 67 II=1,N
      I=N-II+1
      U=ETA-Q(I)*X(I+1)-R(I)*X(I+2)
      IF(P(I).NE.0)GO TO 65
      X(I)=U/EPS
      GO TO 66
   65 X(I)=U/P(I)
   66 H=H+ABS(X(I))
   67 CONTINUE
      DO 68 I=1,N
   68 X(I)=X(I)/H
      DO 75 I=2,N
      IF(INT(I).LE.0)GO TO 70
      U=X(I-1)
      X(I-1)=X(I)
      X(I)=U-M(I)*X(I-1)
      GO TO 75
   70 X(I)=X(I)-M(I)*X(I-1)
   75 CONTINUE
      H=0
      DO 82 II=1,N
      I=N-II+1
      U=X(I)-Q(I)*X(I+1)-R(I)*X(I+2)
      IF(P(I).NE.0)GO TO 80
      X(I)=U/EPS
      GO TO 81
   80 X(I)=U/P(I)
C   81 H=H+X(I)**2
 81   IF (X(I).GT.BIG) THEN
        H=BIGGER
      ELSE
        H=H+X(I)**2
      ENDIF
   82 CONTINUE
      H=SQRT(H)
C STORE VECTORS AS COLUMNS
      DO 85 I=1,N
   85 Z(I,J)=X(I)/H
   90 CONTINUE
      RETURN
      END

C**********************************************************************

      SUBROUTINE BACKS (BETA,A,N,X,M1,EPS,NB)
      INTEGER n, nb, m1 
      REAL BETA(*), A(NB,*), X(NB,*), EPS

      INTEGER j, kk, k, k1, i
      REAL s


C BACKTRANSFORMATION

   73 IF (N.LE.2)RETURN
      DO 90 J=1,M1
      DO 85 KK=3,N
      K=N-KK+1
   76 IF (ABS(BETA(K)).LE.EPS) GO TO 85
      S=0.0
      K1=K+1
      DO 75 I=K1,N
   75 S=S+A(I,K)*X(I,J)
      S=S/(BETA(K)*A(K1,K))
      DO 80 I=K1,N
   80 X(I,J)=X(I,J)+S*A(I,K)
   85 CONTINUE
   90 CONTINUE

      RETURN
      END

************************************************************************

      SUBROUTINE count_neof (arg_1, neof, ok, nx, ny, nt, k1, m1, n1,
     .                       arg_lo_ss, arg_hi_ss, arg_incr, mx, 
     .                       flag, frac_timeser, err_msg, ier)

*  Find number of time series with valid data.  This will be neof.
*  Set array OK to mark which (x,y) have some good data.

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

* arguments
      INTEGER neof, nx, ny, nt, k1, m1, n1, mx, ier
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL ok(nx,ny)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      REAL flag, frac_timeser
      CHARACTER*(*) err_msg

* local variables
      INTEGER i, j, i1, j1, l1
      REAL a_nt

*  Set array ok = 1 if frac_timeser fraction of valid data exists at the point.

      a_nt = float(nt)

      neof = 0
      j1 = arg_lo_ss(Y_AXIS,ARG1)
      DO 30 j = 1, ny
         i1 = arg_lo_ss(X_AXIS,ARG1)
         DO 20 i = 1, nx

            ok(i,j) = 0.
            DO 10 l1 = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)
               IF (arg_1(i1,j1,k1,l1,m1,n1) .ne. flag) then
                  ok(i,j) = ok(i,j) + 1.
               endif
  10        CONTINUE
            ok(i,j) = ok(i,j) / a_nt
            IF (ok(i,j) .GE. frac_timeser) neof = neof + 1 

            i1 = i1 + arg_incr(X_AXIS,ARG1) 
  20     CONTINUE
         j1 = j1 + arg_incr(Y_AXIS,ARG1) 
  30  CONTINUE

      ier = 0
      IF (neof .gt. mx) then
        WRITE(err_msg,*) 'Increase parameter mx in eof.F ',
     .                   'Set mx at least', neof
        ier = 1
        RETURN
      ENDIF

      RETURN
      END

************************************************************************

      SUBROUTINE pack_ef (arg_1, ddat_1d, isave_jsave, neof,  
     .                    ok, frac_timeser, nx, ny, nt, k1, m1, n1,
     .                    arg_lo_ss, arg_hi_ss, arg_incr)

*  put arg_1(x,y,t) into one list ddat_1d(neof,nt)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER neof, nx, ny, nt, k1, m1, n1
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL ddat_1d(neof,nt)
      REAL isave_jsave(wrk7lox:wrk7hix, wrk7loy:wrk7hiy,
     .                 wrk7loz:wrk7hiz, wrk7lot:wrk7hit,
     .                 wrk7loe:wrk7hie, wrk7lof:wrk7hif)
      REAL ok(nx,ny)
      REAL frac_timeser
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      INTEGER i, j, l, i1, j1, l1
      INTEGER ipack

      ipack = 0

      j1 = arg_lo_ss(Y_AXIS,ARG1)
      DO 130 j = 1, ny
         i1 = arg_lo_ss(X_AXIS,ARG1)
         DO 120 i = 1, nx
            IF (ok(i,j) .GE. frac_timeser) THEN
               ipack = ipack + 1
 
               isave_jsave(ipack,1,1,1,1,1) = i
               isave_jsave(ipack,2,1,1,1,1) = j
 
               l1 = arg_lo_ss(T_AXIS,ARG1)
               DO 110 l = 1, nt
                  ddat_1d(ipack, l) = arg_1(i1,j1,k1,l1,m1,n1)
                  l1 = l1 + arg_incr(T_AXIS,ARG1) 
 110           CONTINUE

             ENDIF
             i1 = i1 + arg_incr(X_AXIS,ARG1) 
 120     CONTINUE
         j1 = j1 + arg_incr(Y_AXIS,ARG1) 
 130  CONTINUE

      RETURN
      END

	DOUBLE PRECISION FUNCTION TWORLD( subsc, grid, idim, where_in_box )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* convert a subscript value on a grid into a "world" coordinate
* if the axis is a valid time axis then convert the time step value into
* seconds from jan-1-0000:00:00 so that all time axes are on an absolute scale

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 7/26/88
* revision 0.1 -12/30/88 - added where_in_box
* V230:  7/20/92 - check for valid time axis T0
* V530: *acm* 12/00 alternative calendar types; cal_id
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 6D Ferret: Add E and F dimensions 
*                  A time axis may be a T axis or F axis, so idim is 
*                  now an arg to TSTEP_TO_SECS

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'ferret.parm'

* calling argument declarations:
	INTEGER	subsc, grid, idim, where_in_box, 
     .          TM_GET_CALENDAR_ID, cal_id

* internal variable declarations:
        LOGICAL TM_DATE_OK
        INTEGER line
	REAL*8	TM_WORLD, TSTEP_TO_SECS, ww

* standard conversion into world coordinates
	ww = TM_WORLD( subsc, grid, idim, where_in_box )
	TWORLD = ww

* special treatment of calendar time axis
	IF ( idim .EQ. t_dim .OR. idim .EQ. f_dim ) THEN
           line = grid_line( idim, grid )
           cal_id = TM_GET_CALENDAR_ID ( line_cal_name(line) )
           IF ( TM_DATE_OK( line_t0(line), cal_id )  )
     .     TWORLD = TSTEP_TO_SECS( grid, idim, ww )
	ENDIF
	RETURN
	END

	SUBROUTINE CRAWL_DEPENDENCIES
     .		(  expression, base_cx, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* this routine is derived from EVAL_EXPR, much split off into INIT_DEPENDENCIES
* see that routine for a discussion of how it is implemented
* instead of evaluating the expression, it determines the dependencies in it

* base_isp, base_cx allow the calling program to set base levels for work on
* the stack, allowing pre-existing stack contents to be protected

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V685+ 9/13 *sh*  

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xdependency_tree.cmn'

* calling argument declarations
	INTEGER	base_cx, status
	CHARACTER*(*) expression

* local variable declarations
	INTEGER		UVAR_NUMBER, uvar_pointer, i
	CHARACTER	EXPR_NAME*8

* initialize

* store expression in the uvar list names as "EX#1"
	CALL DELETE_OLD_EXPR
	CALL BREAK_UP_EXPR( expression, num_uvars_in_cmnd, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

	DO 100 i = 1, num_uvars_in_cmnd
* set up the stacks to look at this expression
	   uvar_pointer = UVAR_NUMBER( EXPR_NAME(i) )  ! (easier way to do this?)
           IF ( uvar_pointer .EQ. unspecified_int4 ) CALL ERRMSG
     .             ( ferr_internal, status, 'crawl_dep', *5000 )
	   cx_stack_ptr = base_cx
	   CALL TRANSFER_CONTEXT( cx_cmnd, base_cx )
           cx_variable( base_cx ) = uvar_pointer
           cx_category( base_cx ) = cat_user_var
           isp = dependency_root_level     ! set stack pointer to base
           is_cx  ( isp ) = base_cx        ! context for stack activities
           is_uvar( isp ) = uvar_pointer   ! pointer to text buffer

* start a new dependency tree
	   dependency_current_tree_start = dependency_nrows + 1
	
* when called the request is ALWAYS for an untransformed implicitly defined
           CALL GET_DEPENDENCIES( uvar_pointer,
     .		dependency_dflt_dset, workmem(plegacy_work_buffer)%ptr,
     .		status )
           IF ( status .NE. ferr_ok ) GOTO 5000

! temp diagnostic
	   IF ( cx_stack_ptr .NE. base_cx ) WRITE (6,*) 'get_expr_dep???'
 100	CONTINUE

	RETURN

* error exit
 5000	CALL EXIT_DEPENDENCY_MODE
     	RETURN
	END

	INTEGER FUNCTION DO_EVENT(	idim, arg,
     .					com, com_mr, com_cx,
     .					res, res_mr, res_cx,
     .					buff	)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* the indicated argument value is regarded as an "event threshhold".
* Any time that the component variable crosses or lands on this value
* an "event" occurs and the output should step up by "1" to indicate it.
* If an exact match occurs, step up ON that value.
* If a crossing occurs, step up on the first value AFTER the crossing.  

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V533:  6/01 - new routine based on DO_DIST_LOC
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* v685   5/13 *acm* Fix ticket 2054, EVNT in z direction - typo in equiv.

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include	'xprog_state.cmn'

* calling argument declarations:
	INTEGER	idim, com_mr, com_cx, res_mr, res_cx
	REAL	arg, buff(*),
     .          com( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          res( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif )

* internal variable declarations:
        LOGICAL first_pt, first_lt
* *kob* 6.01 - step_val needs to be integer
	INTEGER step_val, i, j, k, l, m, n,
     .          lo_sub(nferdims), hi_sub(nferdims)
	REAL	bad_com

* internal (convenience) equivalences
	INTEGER	lo_s1, lo_s2, lo_s3, lo_s4, lo_s5, lo_s6,
     .          hi_s1, hi_s2, hi_s3, hi_s4, hi_s5, hi_s6
	EQUIVALENCE (lo_s1, lo_sub(1)) , (lo_s2, lo_sub(2)),
     .		    (lo_s3, lo_sub(3)) , (lo_s4, lo_sub(4)),
     .		    (lo_s5, lo_sub(5)) , (lo_s6, lo_sub(6)),
     .		    (hi_s1, hi_sub(1)) , (hi_s2, hi_sub(2)),
     .		    (hi_s3, hi_sub(3)) , (hi_s4, hi_sub(4)),
     .		    (hi_s5, hi_sub(5)) , (hi_s6, hi_sub(6))

* diagnostic mode output: " doing --> VAR_NAME[x=lo:hi@TRN:n,D=#]"
	IF ( mode_diagnostic ) 	CALL DIAG_OP
     .				( 'doing', isact_class_trans, res_cx, idim )

* initialize
	bad_com = mr_bad_data( com_mr )
        
* calculation limits
	DO 10 i = 1, nferdims
	   lo_sub(i) = cx_lo_ss(res_cx,i)
	   hi_sub(i) = cx_hi_ss(res_cx,i)
 10	CONTINUE

* SEARCH ALONG X AXIS
	IF ( idim .EQ. x_dim ) THEN
	   DO 110 n = lo_s6, hi_s6
	   DO 110 m = lo_s5, hi_s5
	   DO 110 l = lo_s4, hi_s4
	   DO 110 k = lo_s3, hi_s3
	   DO 110 j = lo_s2, hi_s2
	      step_val = 0
              first_pt = .TRUE.
	      DO 100 i = lo_s1, hi_s1
                 IF ( com(i,j,k,l,m,n) .EQ. bad_com ) THEN
	            first_pt = .TRUE.
                 ELSEIF ( com(i,j,k,l,m,n) .EQ. arg ) THEN
* ... exact equality
	            step_val = step_val + 1
	            first_pt = .TRUE.
                 ELSEIF ( first_pt ) THEN
* ... first non-bad value
                    first_pt = .FALSE.
                    first_lt = com(i,j,k,l,m,n) .LT. arg
                 ELSEIF ( first_lt .NEQV.
     .                    (com(i,j,k,l,m,n) .LT. arg) ) THEN
* ... found a "crossing"
	            step_val = step_val + 1
	            first_lt = .NOT. first_lt
                 ENDIF
		 res(i,j,k,l,m,n) = step_val
 100          CONTINUE
 110       CONTINUE

* SEARCH ALONG Y AXIS
	ELSEIF ( idim .EQ. y_dim ) THEN
	   DO 210 n = lo_s6, hi_s6
	   DO 210 m = lo_s5, hi_s5
	   DO 210 l = lo_s4, hi_s4
	   DO 210 k = lo_s3, hi_s3
	   DO 210 i = lo_s1, hi_s1
	      step_val = 0
              first_pt = .TRUE.
	      DO 200 j = lo_s2, hi_s2
                 IF ( com(i,j,k,l,m,n) .EQ. bad_com ) THEN
	            first_pt = .TRUE.
                 ELSEIF ( com(i,j,k,l,m,n) .EQ. arg ) THEN
* ... exact equality
	            step_val = step_val + 1
	            first_pt = .TRUE.
                 ELSEIF ( first_pt ) THEN
* ... first non-bad value
                    first_pt = .FALSE.
                    first_lt = com(i,j,k,l,m,n) .LT. arg
                 ELSEIF ( first_lt .NEQV.
     .                    (com(i,j,k,l,m,n) .LT. arg) ) THEN
* ... found a "crossing"
	            step_val = step_val + 1
	            first_lt = .NOT. first_lt
                 ENDIF
		 res(i,j,k,l,m,n) = step_val
 200         CONTINUE
 210      CONTINUE

* SEARCH ALONG Z AXIS
	ELSEIF ( idim .EQ. z_dim ) THEN
	   DO 310 n = lo_s6, hi_s6
	   DO 310 m = lo_s5, hi_s5
	   DO 310 l = lo_s4, hi_s4
	   DO 310 j = lo_s2, hi_s2
	   DO 310 i = lo_s1, hi_s1
	      step_val = 0
              first_pt = .TRUE.
	      DO 300 k = lo_s3, hi_s3
                 IF ( com(i,j,k,l,m,n) .EQ. bad_com ) THEN
	            first_pt = .TRUE.
                 ELSEIF ( com(i,j,k,l,m,n) .EQ. arg ) THEN
* ... exact equality
	            step_val = step_val + 1
	            first_pt = .TRUE.
                 ELSEIF ( first_pt ) THEN
* ... first non-bad value
                    first_pt = .FALSE.
                    first_lt = com(i,j,k,l,m,n) .LT. arg
                 ELSEIF ( first_lt .NEQV.
     .                    (com(i,j,k,l,m,n) .LT. arg) ) THEN
* ... found a "crossing"
	            step_val = step_val + 1
	            first_lt = .NOT. first_lt
                 ENDIF
		 res(i,j,k,l,m,n) = step_val
 300         CONTINUE
 310      CONTINUE

* SEARCH ALONG T AXIS
	ELSEIF ( idim .EQ. t_dim ) THEN
	   DO 410 n = lo_s6, hi_s6
	   DO 410 m = lo_s5, hi_s5
	   DO 410 k = lo_s3, hi_s3
	   DO 410 j = lo_s2, hi_s2
	   DO 410 i = lo_s1, hi_s1
	      step_val = 0
              first_pt = .TRUE.
	      DO 400 l = lo_s4, hi_s4
                 IF ( com(i,j,k,l,m,n) .EQ. bad_com ) THEN
	            first_pt = .TRUE.
                 ELSEIF ( com(i,j,k,l,m,n) .EQ. arg ) THEN
* ... exact equality
	            step_val = step_val + 1
	            first_pt = .TRUE.
                 ELSEIF ( first_pt ) THEN
* ... first non-bad value
                    first_pt = .FALSE.
                    first_lt = com(i,j,k,l,m,n) .LT. arg
                 ELSEIF ( first_lt .NEQV.
     .                    (com(i,j,k,l,m,n) .LT. arg) ) THEN
* ... found a "crossing"
	            step_val = step_val + 1
	            first_lt = .NOT. first_lt
                 ENDIF
		 res(i,j,k,l,m,n) = step_val
 400         CONTINUE
 410      CONTINUE

* SEARCH ALONG E AXIS
	ELSEIF ( idim .EQ. e_dim ) THEN
	   DO 510 n = lo_s6, hi_s6
	   DO 510 l = lo_s4, hi_s4
	   DO 510 k = lo_s3, hi_s3
	   DO 510 j = lo_s2, hi_s2
	   DO 510 i = lo_s1, hi_s1
	      step_val = 0
              first_pt = .TRUE.
	      DO 500 m = lo_s5, hi_s5
                 IF ( com(i,j,k,l,m,n) .EQ. bad_com ) THEN
	            first_pt = .TRUE.
                 ELSEIF ( com(i,j,k,l,m,n) .EQ. arg ) THEN
* ... exact equality
	            step_val = step_val + 1
	            first_pt = .TRUE.
                 ELSEIF ( first_pt ) THEN
* ... first non-bad value
                    first_pt = .FALSE.
                    first_lt = com(i,j,k,l,m,n) .LT. arg
                 ELSEIF ( first_lt .NEQV.
     .                    (com(i,j,k,l,m,n) .LT. arg) ) THEN
* ... found a "crossing"
	            step_val = step_val + 1
	            first_lt = .NOT. first_lt
                 ENDIF
		 res(i,j,k,l,m,n) = step_val
 500         CONTINUE
 510      CONTINUE

* SEARCH ALONG F AXIS
	ELSEIF ( idim .EQ. f_dim ) THEN
	   DO 610 m = lo_s5, hi_s5
	   DO 610 l = lo_s4, hi_s4
	   DO 610 k = lo_s3, hi_s3
	   DO 610 j = lo_s2, hi_s2
	   DO 610 i = lo_s1, hi_s1
	      step_val = 0
              first_pt = .TRUE.
	      DO 600 n = lo_s6, hi_s6
                 IF ( com(i,j,k,l,m,n) .EQ. bad_com ) THEN
	            first_pt = .TRUE.
                 ELSEIF ( com(i,j,k,l,m,n) .EQ. arg ) THEN
* ... exact equality
	            step_val = step_val + 1
	            first_pt = .TRUE.
                 ELSEIF ( first_pt ) THEN
* ... first non-bad value
                    first_pt = .FALSE.
                    first_lt = com(i,j,k,l,m,n) .LT. arg
                 ELSEIF ( first_lt .NEQV.
     .                    (com(i,j,k,l,m,n) .LT. arg) ) THEN
* ... found a "crossing"
	            step_val = step_val + 1
	            first_lt = .NOT. first_lt
                 ENDIF
		 res(i,j,k,l,m,n) = step_val
 600         CONTINUE
 610      CONTINUE

	ENDIF

* always success
	DO_EVENT = ferr_ok
	RETURN

	END

	SUBROUTINE SHOW_GRID( grid, cx, uvgrid, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* describe the axes of a grid and then give coordinate data about those
* axes as indicated in cx

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 9/23/87
* revision 0.1 - 2/18/88 - checks subscript limits on axes
*			   and allows non-geographical, +/- oriented axes
* revision 0.2 - 3/18/88 - decimal places automated for sig. figs.
*			 - time step written in calendar mode
*			 - interruptable; - axis unit labels via AX_TITLE
* revision 1.0 - 8/1/88  - created LINE_FACTS and removed half of code to it
* revision 1.1 - 8/16/88 - eliminated units column, added delta in coord display
* V200:  5/19/89 - reordered lo/hi_ss arguments
*        9/22/89 - change to LINE_FACTS call for abstract axis orientations
* Unix/RISC port 3/18/91 *sh*: can't use function in WRITE list
*                            - corrected use of risc_buff (was right justified)
* V300:  5/28/93 - bug fix: incorrect branch for mnormal or munknown axis
* V320: 12/29/94 - use SPLIT_LIST to redirect tty output for GUI
*	  1/5/95 - changed default precision from 5 to 7  (and for
*		   dates to seconds) 
* kob*   9/97 - replaced call to ISUBSCRIPT w/ call to ISUBSCR_CX in order
*               to have access to context information - needed for negative
*               time step processing
* *kob*  1/98 - add calls to convert cx_lo/hi_ww to tsteps before calling
*               ISUBSCR_CX
* V500 - *sh* 4/99 - extracted guts of code to SHOW_LINE_COORDS to be shared
*		by the SHOW AXIS command
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V6.8  acm  6/12 Implement mode_6d_lab, set by default. If canceled, the 
*                 various SHOW commnands will not list info for E,F dimensions.
* V691+ 8/14 *acm* Fix ticket 2194: SHOW with /OUTFILE and not /XML. 
* V697  12/15 *acm* Changes to add details on SHOW GRID uvar to indicate 
*                   compressed or subset of axes
* V697  12/15 *acm* Changes to formatting the output that shows subsets
* V7    acm  6/16 Ticket 2437: Deprecating mode_6d_lab. 
*		  Adjust output to 6-D or 4-D grids

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'slash.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'
	include 'xrisc.cmn'
	include 'xvariables.cmn'

* calling argument declarations
	LOGICAL uvgrid 
	INTEGER grid, cx, status

* local variable declarations:
	LOGICAL FOUR_D_GRID
	INTEGER i, idim, listdims, uvar

	listdims = nferdims
	IF (FOUR_D_GRID(grid)) listdims = 4

* Getting details about the grid of a user-variable
        uvar = -1
	IF (uvgrid) uvar = is_uvar(isp)

* list and describe the axes of the grid
	risc_buff = ' '
	IF (uvgrid) THEN
	   WRITE ( risc_buff, 3100 )
	ELSE
	   WRITE ( risc_buff, 3000 )
	ENDIF

	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	DO 110 idim = 1, listdims
	   CALL LINE_FACTS( show_lun, idim, grid, idim, uvar )
 110	CONTINUE

* list the data on any axis that has been especially requested
*		via (eg.) /X=lo:hi or /X alone
	DO 130 idim = 1, listdims
	   IF ( qual_given( slash_show_grid_x0+idim ) .GT. 0
     .	  .OR.  qual_given( slash_show_grid_i0+idim ) .GT. 0 ) THEN
	     CALL SHOW_LINE_COORDS( grid, cx, idim )
	   ENDIF
 130	CONTINUE

* successful completion
 1000	RETURN

 3000	FORMAT (T2,'name',T13,'axis',T31,'# pts',T39,'start',T60,
     .          'end' )

 3100	FORMAT (T2,'name',T13,'axis',T31,'# pts',T39,'start',T60,
     .          'end',T80,'subset' )

5000    RETURN
	END

	SUBROUTINE GET_UVAR_GRID( uvar, dset, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Determine the defining grid for user-defined variable, uvar
* The procedure is performed on the (IS) interpretation stack using stack
* frames on the IS stack, the CX (context) stack and the grid stack.
* In order the determine the requested grid the grids for all of the user
* variables on which the definition depends must also be known or determined.
* Thus, the process is inherently recursive - requiring the stack usage from
* FORTRAN.
* Each stack frame is 1 IS level, 2 CX levels and 1 grid.
* On successful exit from this routine all stacks should be left in their
* original states.

* Example:
*	yes? DEFINE NEW1 = TEMP[Z=@AVE]
*	yes? DEFINE NEW2 = NEW1 * X
*	yes? LIST/Z=0:100/X=180:160W NEW2

* ... to get the grid for NEW2 the grid for NEW1 must be determined.

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  7/5/89  
* V698 *sh* 1/16 - altered method of obtaining grids of LET/D uvars used in
*                  E and F aggregations

* calling argument declarations:
	INTEGER		uvar, dset, status

* internal variable declarations:
	INTEGER		isp_orig, cx_orig, cx, idim


! debug includes 11/6/94 *sh*
        include 'tmap_errors.parm'
        include 'tmap_dims.parm'
        include 'xtm_grid.cmn_text'
        external xgt_grid_data

	include	'ferret.parm'
	include	'interp_stack.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'

* pre-load the variable info onto the CX stack
	cx_orig = cx_stack_ptr
	CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	cx = cx_stack_ptr
	cx_data_set(cx) = dset
	cx_variable(cx) = uvar
	cx_category(cx) = cat_user_var

* pre-load the variable info onto the IS stack
	isp_orig = isp
	CALL PUSH_INTERP_STACK( isp, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	is_cx   ( isp ) = cx
	is_uvar ( isp ) = uvar
	is_act  ( isp ) = isact_get_grid	! vs isact_get_agg_grid

* initialize the stacks - (repeated for each component)

 100	CALL IS_GRID_MODE( status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* evaluate the grid by merging component grids
*  ... exit 100 is to evaluate the grid for a component uvar
*  ... exit 300 means that a grid has been obtained
*  ... "normal" return indicates an error has occurred
 200	CALL IS_UVAR_GRID( *100, *300, status )
	GOTO 5000
 
* a grid has been obtained.  Are we done ?
 300	IF ( isp .EQ. isp_orig ) THEN
* ... yes - clean up and go home
	   IF ( cx_stack_ptr .NE. cx_orig ) WRITE (6,*) 'usr_v_gd'	! temp
	   RETURN
	ELSE
* ... no - go back for more
	   GOTO 200
	ENDIF

* error exit
 5000	IF ( status .EQ. ferr_stack_ovfl )
     .		CALL WARN( 'Check for recursion in variable definitions' )
	RETURN
	END

	SUBROUTINE  VEL_ADV_NS ( fvn , mfvn,
     .				 v   , mv  ,
     .				 vady, mvady )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute meridional advection of velocity components
* note: the identical code applies to both U and V

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 -1/23/87 extracted from SUBROUTINE CLINIC
*			with major modifications to convert i-k oriented
*			calculations to i-j oriented calculations
* revision 0.1 - 4/14/87 - converted incorrect flux-form calculation to
*			   true advection
* V200:  7/27/89 - 4D symmetrical version
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN

#ifdef unix
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl.parm'		! parameter definitions
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xonedim.cmn'	! geometric constants
	include 'xcontext.cmn'
#else
	INCLUDE 'FERRET_CMN:FERRET.PARM'
	INCLUDE 'FERRET_CMN:GFDL.PARM'		! parameter definitions
	INCLUDE	'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE	'FERRET_CMN:XMEM_SUBSC.CMN'
	INCLUDE 'FERRET_CMN:XONEDIM.CMN'	! geometric constants
	INCLUDE 'FERRET_CMN:XCONTEXT.CMN'
#endif

* calling argument declarations:
	INTEGER	mfvn, mv, mvady

* subscript ranges from memory variable table ...
	REAL     fvn( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit ),
     .		   v( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,m2lot:m2hit ),
     .		vady( m3lox:m3hix,m3loy:m3hiy,m3loz:m3hiz,m3lot:m3hit )

* internal variable declarations:
	INTEGER	i_lo, i_hi, j_lo, j_hi, i, j, k, l
	REAL	bad_v, bad_fvn, factor, dQVdy, QdVdy, fvst_ij

* --- end of introductory code ---

* limits for calculation
	i_lo = mr_lo_s1(mvady)
	i_hi = mr_hi_s1(mvady)
	j_lo = mr_lo_s2(mvady)
	j_hi = mr_hi_s2(mvady)

* flag for bad/missing data
	bad_v   = mr_bad_data( mv )
	bad_fvn = mr_bad_data( mfvn )

* ***************************************************************
* ORIGINAL GFDL 205 CODE UPON WHICH CALCULATION IS BASED
*
* 282       C   COMPUTE EFFECT OF HORIZONTAL ADVECTION IN MOMENTUM EQUATIONS

* 292       DO 305 K=1,KM
* 293       DO 305 I=1,IMT
* 294       UA(I,K)=UA(I,K)
* 295      2 -FVN(I,K)*(UP(I,K)+U(I,K))+FVSU(I,K)*(U(I,K)+UM(I,K))
* 296  305  CONTINUE

* 305       DO 315 K=1,KM
* 306       DO 315 I=1,IMT
* 307       VA(I,K)=VA(I,K)
* 308      2 -FVN(I,K)*(VP(I,K)+V(I,K))+FVSU(I,K)*(V(I,K)+VM(I,K))
* 309  315  CONTINUE
*************************************************************************

	DO 305 j = j_lo, j_hi

	   IF ( j .GT. 1 ) factor = cs(j-1) * dyu(j-1) * csr(j) * dyur(j)

	DO 305 l = mr_lo_s4(mvady), mr_hi_s4(mvady)
	DO 305 k = mr_lo_s3(mvady), mr_hi_s3(mvady)
	DO 305 i = i_lo, i_hi

	   IF ( j .EQ. 1 .OR. j .EQ. jm ) THEN
	      vady(i,j,k,l) = bad_val4
	      GOTO 305
	   ENDIF

	   IF ( v(i,j-1,k,l) .EQ. bad_v
     .	    .OR.v(i,j  ,k,l) .EQ. bad_v
     .	    .OR.v(i,j+1,k,l) .EQ. bad_v
     .	    .OR.fvn(i,j  ,k,l) .EQ. bad_fvn
     .	    .OR.fvn(i,j-1,k,l) .EQ. bad_fvn ) THEN
  
	      vady(i,j,k,l) = bad_val4

	   ELSE

* flux-form calculation ( note 1/dy imbedded in FVN )
* "Q" may be "U" or "V"
	      fvst_ij = fvn(i,j-1,k,l) * factor
	      dQVdy   =( fvn(i,j,k,l) * (v(i,j+1,k,l)+v(i,j,k,l  ))
     .		       - fvst_ij      * (v(i,j,k,l  )+v(i,j-1,k,l)) )

* compute Q*d/dy(V)
	      QdVdy = v(i,j,k,l) * ( fvn(i,j,k,l) - fvst_ij ) * 2.0

* compute -Vd/dy(Q) = Qd/dy(V) - d/dy(QV)
	      vady(i,j,k,l) = ( QdVdy - dQVdy ) * cmonthly

	   ENDIF

 305	CONTINUE
	RETURN
	END

	LOGICAL FUNCTION ITSA_MODULO_CURVI_AXIS_SUB ( xfield, yfield,
     1    slox_dim1, shix_dim1, slox_dim2, shix_dim2, 
     2    sloy_dim1, shiy_dim1, sloy_dim2, shiy_dim2, dim1_or_2	)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*       support routine for ITSA_MODULO_CURVI_AXIS
*       
*       programmer - jonathan callahan
*       NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

*       V450: 4/97
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

*
*       ... ---> DISP_SET_UP ---> LOAD_CURVILINEAR
*               ---> ITSA_MODULO_CURVI_AXIS ---> ITSA_MODULO_CURVI_AXIS_SUB
*       
*       This function checks to see if an an axis is modulo after it has been
*       transformed by the 'curvilinear' transformations.  Curvilinear transformations
*       are invoked by giving Ferret a 3-argument SHADE, or FILL command.
*
*       For an axis to be modulo, in curvilinear coordinates, it must be
*       modulo in normal coordinates AND the transformation must leave the page
*       position of the first point on the axis 'very near' the page position
*       of the last point on the axis.
*
*       Every (x,y) pair (eg. (Lon,Lat)) in the range of data is transformed to
*       a new page position by the curvilinear transofmation.  The transformed
*       page positions (in user coordinates) are stored in the 'xfield' and 
*       'yfield' 2D arrays.  The 'slox_' and 'sloy_' values are used to dimension
*       the arrays.  'dim1_or_2' has a value of 1 or 2 and specifies which page
*       dimension we are looking at.
*
*       To determine 'very near' we will use the 'wwx~' and 'wwy~' values
*       stored in xcurvilinear.cmn.  These contain the X- and Y-axis maximum and minimum
*       page positions (in user coordinates).

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include	'xcontext.cmn'
	include 'xcurvilinear.cmn'  

*       calling argument declarations:
c *kob* 8/97 had to move the continuation marker to col 5 - it was in col 8
c       this bombed aix compiler, though it seems to work on others
	INTEGER slox_dim1, shix_dim1, slox_dim2, shix_dim2, 
     1    sloy_dim1, shiy_dim1, sloy_dim2, shiy_dim2, dim1_or_2
	REAL    xfield( slox_dim1:shix_dim1, slox_dim2:shix_dim2 ),
     1    yfield( sloy_dim1:shiy_dim1, sloy_dim2:shiy_dim2 )

*       internal variable declarations:
	INTEGER	i, imax, number_of_x_cells, number_of_y_cells
	REAL page_width, page_height, minimum_width, minimum_height

*       --- end of introductory code ---

	ITSA_MODULO_CURVI_AXIS_SUB = .TRUE.

*       The number of cells better be the same whether I calculate it from
*       the X or from the Y dimensioning

	number_of_x_cells = shix_dim1 - slox_dim1
	number_of_y_cells = shix_dim2 - slox_dim2


*       An **arbitrary** definition of whats 'very close'

	minimum_width = (wwxmax - wwxmin) / sqrt(real(number_of_x_cells))
	minimum_height = (wwymax - wwymin) / sqrt(real(number_of_y_cells))


*       Now check the horizontal distance between the first and last X indices

*       When dim1 is modulo:
	IF (dim1_or_2 .EQ. 1) THEN

	   DO 100 i = xpos_loss_dim2, xpos_hiss_dim2
	      IF ( ( xfield(xpos_hiss_dim1,i) - xfield(xpos_loss_dim1,i) ) 
     .               .GT. minimum_width ) THEN
		 ITSA_MODULO_CURVI_AXIS_SUB = .FALSE.
		 RETURN
	      ENDIF
 100	   CONTINUE

*       When dim2 is modulo:
	ELSE

	   DO 200 i = xpos_loss_dim1, xpos_hiss_dim1
	      IF ( ( xfield(i,xpos_hiss_dim2) - xfield(i,xpos_loss_dim2) ) 
     .                    .GT. minimum_width ) THEN
		 ITSA_MODULO_CURVI_AXIS_SUB = .FALSE.
		 RETURN
	      ENDIF
 200	   CONTINUE

	ENDIF



*       Now check the vertical distance between the first and last Y indices

*       When dim1 is modulo:
	IF (dim1_or_2 .EQ. 1) THEN

	   DO 300 i = ypos_loss_dim2, ypos_hiss_dim2
	      IF ( ( yfield(ypos_hiss_dim1,i) - yfield(ypos_loss_dim1,i) ) 
     .                  .GT. minimum_height ) THEN
		 ITSA_MODULO_CURVI_AXIS_SUB = .FALSE.
		 RETURN
	      ENDIF
 300	   CONTINUE

*       When dim2 is modulo:
	ELSE

	   DO 400 i = ypos_loss_dim1, ypos_hiss_dim1
	      IF ( ( yfield(i,ypos_hiss_dim2) - yfield(i,ypos_loss_dim2) ) 
     .                   .GT. minimum_height ) THEN
		 ITSA_MODULO_CURVI_AXIS_SUB = .FALSE.
		 RETURN
	      ENDIF
 400	   CONTINUE

	ENDIF

	RETURN
	END 

c     
c     efcn_copy_array_dims.F
c     
c     Jonathan Callahan
c     Sep 22nd 1998
c     

c     
c     This subroutine is called by efcn_compute_ inside EF_ExternalUtil.c. 
c     It copies all of the dimensioning information from xmem_subsc.cmn to
c     the equivalent slots in ef_mem_subsc.cmn.
c     

      SUBROUTINE EFCN_COPY_ARRAY_DIMS

      IMPLICIT NONE
      INCLUDE 'tmap_dims.parm'
      INCLUDE 'xmem_subsc.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      mem1lox = m1lox
      mem1loy = m1loy
      mem1loz = m1loz
      mem1lot = m1lot
      mem1loe = m1loe
      mem1lof = m1lof

      mem1hix = m1hix
      mem1hiy = m1hiy
      mem1hiz = m1hiz
      mem1hit = m1hit
      mem1hie = m1hie
      mem1hif = m1hif

      mem2lox = m2lox
      mem2loy = m2loy
      mem2loz = m2loz
      mem2lot = m2lot
      mem2loe = m2loe
      mem2lof = m2lof

      mem2hix = m2hix
      mem2hiy = m2hiy
      mem2hiz = m2hiz
      mem2hit = m2hit
      mem2hie = m2hie
      mem2hif = m2hif

      mem3lox = m3lox
      mem3loy = m3loy
      mem3loz = m3loz
      mem3lot = m3lot
      mem3loe = m3loe
      mem3lof = m3lof

      mem3hix = m3hix
      mem3hiy = m3hiy
      mem3hiz = m3hiz
      mem3hit = m3hit
      mem3hie = m3hie
      mem3hif = m3hif

      mem4lox = m4lox
      mem4loy = m4loy
      mem4loz = m4loz
      mem4lot = m4lot
      mem4loe = m4loe
      mem4lof = m4lof

      mem4hix = m4hix
      mem4hiy = m4hiy
      mem4hiz = m4hiz
      mem4hit = m4hit
      mem4hie = m4hie
      mem4hif = m4hif

      mem5lox = m5lox
      mem5loy = m5loy
      mem5loz = m5loz
      mem5lot = m5lot
      mem5loe = m5loe
      mem5lof = m5lof

      mem5hix = m5hix
      mem5hiy = m5hiy
      mem5hiz = m5hiz
      mem5hit = m5hit
      mem5hie = m5hie
      mem5hif = m5hif

      mem6lox = m6lox
      mem6loy = m6loy
      mem6loz = m6loz
      mem6lot = m6lot
      mem6loe = m6loe
      mem6lof = m6lof

      mem6hix = m6hix
      mem6hiy = m6hiy
      mem6hiz = m6hiz
      mem6hit = m6hit
      mem6hie = m6hie
      mem6hif = m6hif

      mem7lox = m7lox
      mem7loy = m7loy
      mem7loz = m7loz
      mem7lot = m7lot
      mem7loe = m7loe
      mem7lof = m7lof

      mem7hix = m7hix
      mem7hiy = m7hiy
      mem7hiz = m7hiz
      mem7hit = m7hit
      mem7hie = m7hie
      mem7hif = m7hif

      mem8lox = m8lox
      mem8loy = m8loy
      mem8loz = m8loz
      mem8lot = m8lot
      mem8loe = m8loe
      mem8lof = m8lof

      mem8hix = m8hix
      mem8hiy = m8hiy
      mem8hiz = m8hiz
      mem8hit = m8hit
      mem8hie = m8hie
      mem8hif = m8hif

      mem9lox = m9lox
      mem9loy = m9loy
      mem9loz = m9loz
      mem9lot = m9lot
      mem9loe = m9loe
      mem9lof = m9lof

      mem9hix = m9hix
      mem9hiy = m9hiy
      mem9hiz = m9hiz
      mem9hit = m9hit
      mem9hie = m9hie
      mem9hif = m9hif

      memreslox = m10lox
      memresloy = m10loy
      memresloz = m10loz
      memreslot = m10lot
      memresloe = m10loe
      memreslof = m10lof

      memreshix = m10hix
      memreshiy = m10hiy
      memreshiz = m10hiz
      memreshit = m10hit
      memreshie = m10hie
      memreshif = m10hif

      RETURN 
      END

	SUBROUTINE DIAGNOSTIC_OUT( action, isub, pointer_type )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* output a line describing the activity in progress

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/5/87
* V200:  5/19/89 - re-ordered lo/hi_ss args
* V320: 12/29/94 - use SPLIT_LIST to redirect tty output for GUI
* V420: 12/20/95 - do not print isub - changes too much between revisions
* Linux Port 12/96 *kob* - missing comma in 3000 format statement 
*                          discovered by f90 compiler
* 			 - Added a preprocessor include for tmap_dset.parm
*			   because it needed a preprocessor.
* V450: 7/7/97 - make a readable short name from VAR_CODE
* V500 *kob* 3/99- up VAR_CODE  to 64 chars and change buff24 to buff64
* V530 9/00 *sh* - output context or mr pointer rather than data set
* V552 *acm* 4/03- up VAR_CODE  to 128 chars and change buff64 to buff128
* V63  *acm* 10/09 Changes for gfortran build
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V680  5/12 *acm* Add dataset ID to diagnostic output
* V6.8  acm  6/12 Implement mode_6d_lab, set by default. If cancelled, the 
*                 output will not list info for E,F dimensions.
* V7    acm  6/16 Ticket 2437: Deprecating mode_6d_lab. 
*		  Adjust output to 6-D or 4-D grids
* V702 *sh* 1/17  7 digit integer output fields instead of 5

* calling argument declarations:
	INTEGER		isub, pointer_type
	CHARACTER*(*)	action

* internal argument declarations:
	LOGICAL	    FOUR_D_GRID
	INTEGER	    TM_LENSTR1, lenbuff, i, listdims
	CHARACTER   VAR_CODE*128, buff128*128, buff8*8

	include	'tmap_dims.parm'
	include	'ferret.parm'
#	include	"tmap_dset.parm"
	include	'xprog_state.cmn'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include 'xrisc.cmn'		! 12/94 SPLIT_LIST buffer


* If mode 6d_lab has been cancelled, we will list info only for 
* the first 4 dimensions.  This test fails for some EX# expressions.

	listdims = nferdims
	IF ( pointer_type .EQ. point_to_cx ) THEN
	   IF ( FOUR_D_GRID(cx_grid(isub)) ) listdims = 4
	ELSe
	   IF ( FOUR_D_GRID(mr_grid(isub)) ) listdims = 4
	ENDIF

	risc_buff = ' '

* readable variable name code
	IF ( pointer_type .EQ. point_to_cx ) THEN
 	   buff128 = VAR_CODE( cx_category(isub), cx_variable(isub) )
	ELSE
	   buff128 = VAR_CODE( mr_category(isub), mr_variable(isub) )
	ENDIF
	IF ( buff128(:2) .EQ. '(C' ) THEN
! ... use low order 2 digits from 3-digit numbers (shortening to 2-digits)
	   buff8 = '(C'//buff128(4:5)//',V'//buff128(9:10)
	ELSE
	   lenbuff = TM_LENSTR1(buff128)
! ... assemble short name from beginning and end of full name 
	   IF (lenbuff .GT. 8 ) THEN
	      buff8 = buff128(1:3)//'-'//buff128(lenbuff-3:lenbuff)
	      IF (buff128(1:1) .EQ. '{') buff8 = buff128(1:4)//'...'//'}'
	   ELSE
	      buff8 = buff128
	   ENDIF
	ENDIF

      IF (listdims .EQ. nferdims) THEN

	IF ( pointer_type .EQ. point_to_cx ) THEN
	   WRITE ( risc_buff,3000 )
     .			action,
     .		 	buff8,
     .			'C',isub,
     .			cx_data_set(isub),
     .			(cx_lo_ss(isub,i),cx_hi_ss(isub,i),i=1,listdims)
	   CALL SPLIT_LIST(pttmode_ops, ttout_lun, risc_buff, 0 )
	ELSE
	   WRITE ( risc_buff,3000 )
     .			action,
     .			buff8,
     .			'M',isub,
     .			mr_data_set(isub),
     .			(mr_lo_ss(isub,i),mr_hi_ss(isub,i),i=1,listdims)
	   CALL SPLIT_LIST(pttmode_ops, ttout_lun, risc_buff, 0 )
	ENDIF

      ELSE

	IF ( pointer_type .EQ. point_to_cx ) THEN
	   WRITE ( risc_buff,3100 )
     .			action,
     .		 	buff8,
     .			'C',isub,
     .			cx_data_set(isub),
     .			(cx_lo_ss(isub,i),cx_hi_ss(isub,i),i=1,listdims)
	   CALL SPLIT_LIST(pttmode_ops, ttout_lun, risc_buff, 0 )
	ELSE
	   WRITE ( risc_buff,3100 )
     .			action,
     .			buff8,
     .			'M',isub,
     .			mr_data_set(isub),
     .			(mr_lo_ss(isub,i),mr_hi_ss(isub,i),i=1,listdims)
	   CALL SPLIT_LIST(pttmode_ops, ttout_lun, risc_buff, 0 )
	ENDIF

      ENDIF

 3000	FORMAT (1X,A,1X,A8,1X,A1,':',I3,' dset:',i4,
     . ' I:',2I7,'  J:',2I5,'  K:',2I5,'  L:',2I7,'  M:',2I5,'  N:',2I5)
 3100	FORMAT (1X,A,1X,A8,1X,A1,':',I3,' dset:',i4,
     . ' I:',2I7,'  J:',2I5,'  K:',2I5,'  L:',2I7)

	RETURN
	END	

*
* matlab.F
*
* Joe Sirott
*
*


*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )


      SUBROUTINE matlab_func_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,'test of MATLAB function calls')

      CALL ef_set_num_args(id, 2)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'S')
      CALL ef_set_arg_unit(id, arg, 'PSU')
      CALL ef_set_arg_desc(id, arg, 'Salinity')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)
      arg = 2
      CALL ef_set_arg_name(id, arg, 'T')
      CALL ef_set_arg_unit(id, arg, 'deg C')
      CALL ef_set_arg_desc(id, arg, 'Temperature')
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END



      SUBROUTINE matlab_func_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*     You could use utility functions at this point to get 
*     context information about the other arguments.  This info 
*     could be used to update the custom or abstract axis lo and hi
*     indices.

c      call ef_set_axis_limits(id, X_AXIS, 1, 1)


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END



* In this subroutine we compute the result
*
      SUBROUTINE matlab_func_compute(id, arg_1, arg_2, result)

C ACM  xmem_subsc.cmn change to EF_mem_subsc.cmn'

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

C ACM  change m1lox to mem1lox, etc.

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, 
     .           mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL result(mem10lox:mem10hix, mem10loy:mem10hiy, 
     .           mem10loz:mem10hiz, mem10lot:mem10hit)
c
c Ahh, Ferret and FORTRAN. No dynamic memory allocation, 
c so set some array  limits for temporary storage and 
c hope for the best.
c
      INTEGER MAXY,MAXZ
      parameter(MAXY=1024,MAXZ=1024)
      REAL stemp(MAXY, MAXZ)
      REAL ttemp(MAXY, MAXZ)

C ACM  call ef_get_coordinates with REAL*8 array to get coord values

      REAL*8 ptemp(MAXZ)
      REAL ptemp4(MAXZ)
      REAL rtemp(MAXY, MAXZ)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l
      INTEGER i1, j1, j2, k2, k1, l1, ysize,  zsize
      LOGICAL firstTime

      firstTime = .true.

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      ysize = arg_hi_ss(Y_AXIS, ARG1) - arg_lo_ss(Y_AXIS, ARG1) + 1
      zsize = arg_hi_ss(Z_AXIS, ARG1) - arg_lo_ss(Z_AXIS, ARG1) + 1
c
c TODO -- Error checking
c 

c
c Get the depth axis for pressure
c

      CALL ef_get_coordinates(id, ARG1, Z_AXIS, 
     1       arg_lo_ss(Z_AXIS, ARG1), arg_hi_ss(Z_AXIS, ARG1), ptemp )


C ACM  Stick the coordinates in REAL arrays.  (also in the line above, a
C      Z_axis was typed as X_axis)

      DO l = 1, zsize
         ptemp4(l) = ptemp(l)
      ENDDO

      i1 = res_lo_ss(X_AXIS)
      DO i=arg_lo_ss(X_AXIS, ARG1), arg_hi_ss(X_AXIS, ARG1)
         l1 = res_lo_ss(T_AXIS)
         DO l=arg_lo_ss(T_AXIS, ARG1), arg_hi_ss(T_AXIS, ARG1)

c
c Copy slices to buffers
c 
            j2 = 1
            do j=arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)
               k2 = 1
               do k=arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)
                  stemp(j2,k2) = arg_1(i,j,k,l)
                  ttemp(j2,k2) = arg_2(i,j,k,l)
                  k2 = k2 + 1
               end do
               j2 = j2 + 1
            end do
            
c
c Get the results from MATLAB
c
            call matlab_func_demo(firstTime,stemp,ttemp,ptemp4,
     1            rtemp,ysize, zsize, bad_flag(1), MAXY, MAXZ)
            firstTime = .false.
c
c Copy the results from MATLAB into the Ferret buffer
c
            j2 = 1
            do j1=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
               k2 = 1
               do k1=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
c                  write(6,*) i1,j1,k1,l1,j2,k2,rtemp(j2, k2)
                  result(i1,j1,k1,l1) = rtemp(j2, k2)
                  k2 = k2 + 1
               end do
               j2 = j2 + 1
            end do
c
c Copy to results array
c
            
            l1 = l1 + 1
         end do
         i1 = i1 + 1
      end do
            
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	LOGICAL FUNCTION NC_GET_ATTRIB_DP ( dset, varid, attrib,
     .                                   do_warn, vname, attlen, 
     .                                   attoutflag, dvals )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* get double-precision attribute values from a netCDF data structure if
* the attribute exists
* 
* Based on CD_GET_ATTRIB
* V600 -  5/05 *acm*  Attribute handling upgrade. Rework to read information 
*                     from data strucure rather than the netCDF file.
*                     Replace NCAINQ with CD_GET_VAR_ATT_INFO
*                     Replace NCAGTC with CD_GET_VAR_ATTR
*                     This routine now returns both character and real results,
*                     so it replaces CD_GET_ATTVAL.
*         6/06 *acm*  replace istat with status
* V602  2/07 *acm* Fix bug 1492, changing attributes of coordinate variables 
* V602 *acm* make sure lena=length of attr name is defined before writing warning
* V63  *acm* 10/09 Changes for gfortran build
* V65  *acm* 1/10  Make sure parameters values are consistent with 
*                              whats in netcdf.inc from netcdf4.
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* argument definitions:
*	dset	 - dataset number
*       varid    - variable id 
*       attrib   - attribute to search for
*	do_warn	 - logical flag to issue warning if invalid attribute
*                - warnings are never issued if attribute doesn't exit
*       vname    - name of variable owning attribute (used in error msgs)
*       attlen   - length of output (string length or number of values)
*       attoutflag- 1 if attribute to be written to output files, 0 if not
*       dvals    - array in which to return result if numerical type

* argument declarations
      LOGICAL       do_warn
      INTEGER	    dset, varid, attlen, attoutflag
      CHARACTER*(*) attrib, vname
      real*8        dvals(*)

#include "gt_lib.parm"
      include 'netcdf.inc'
      include 'xio.cmn_text'
      include 'tmap_errors.parm'
      include 'xrisc_buff.cmn'

* internal variable declarations:
      LOGICAL too_long
      INTEGER TM_LENSTR1, NCF_GET_VAR_ATTR,
     .        lena, lenb, attype, status, i, dset_num, attid
      CHARACTER*128 aname

      INTEGER tt  ! nice short name
      EQUIVALENCE (tt,lunit_errors)

      INTEGER slen, flen
      PARAMETER (flen=size_rbuff)        ! size of attribute string
#ifdef sun
      BYTE      fhol(flen), ghol(flen)      ! c-type Hollerith string buffer
#else
      INTEGER*1 fhol(flen), ghol(flen)     ! c-type Hollerith string buffer
#endif 

       NC_GET_ATTRIB_DP = .FALSE.
       IF (dset .EQ. unspecified_int4) RETURN
       IF (varid .LT. 0) RETURN

* initialize
       too_long = .FALSE.

* inquire about the attribute by name, using its id number

      CALL CD_GET_VAR_ATT_ID (dset, varid, attrib, attid, status)
      IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, varid, attid,
     .                   aname, attype, attlen, attoutflag, status )

      IF ( status .NE. merr_ok ) THEN
         NC_GET_ATTRIB_DP = .FALSE.
         RETURN  ! doesn't exist
      ENDIF

      lena = TM_LENSTR1( aname )
      CALL TM_FTOC_STRNG (aname(:lena), ghol, flen)

* Get attribute length and value

      dset_num = dset
      IF (dset_num .LT. -2) dset_num = -2
      status = NCF_GET_VAR_ATTR(dset_num, varid, ghol, fhol, attlen, dvals)

      IF ( status .NE. merr_ok ) THEN
         NC_GET_ATTRIB_DP = .FALSE.
         attlen = 0
         attoutflag = 0
         RETURN  
      ENDIF

      NC_GET_ATTRIB_DP = .TRUE.

      RETURN

      END

	SUBROUTINE XEQ_WIRE

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute the WIRE (3D wireframe) command

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V230  6/8/92 - for new command, WIRE: this routine based on XEQ_CONTOUR
*       10/22/92 - removed unnecessary shade_vars.cmn
*       12/2/92  - added /ZSCALE qualifier
* V301:	  1/7/94 - bug fix: (see DISP_DATA_SET_UP) must unprotect plot data
* 	 1/10/94 - change to DISP_SET_UP call to accomodate CONTOUR/PEN
* V312: 5/94 - array "memory" as a calling argument
* V320:   1/20/94 - changes to SAVE_FRAME call reflecting C-based procedures
* 12/96 *kob* - Linux Port - had to move variable assignments off of
*               declaration line.
* V530: *acm*6/01 - add arguments is_logh, is_logv to DISP_SET_UP call.
*                  (only used for PLOT command)
* V550: *acm*11/02 add argument is_shade to DISP_SET_UP call (not used by wire)
*                  remove VMS includes.
* V552: *acm* 5/03 add argument use_cell to DISP_SET_UP call (not used by wire)
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
*                  A time axis may be a T axis or F axis
* V702 1/17 *sh* for trac enhancement #2369 -- dynamic memory management 
* V72  5/17 acm* Ticket 2530 add WIRE/COLOR= 
* V74  1/18 *am* for issue #1854, extra argument to DISP_SET_UP

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'plot_setup.parm'
	include 'slash.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'
	include 'xplot_setup.cmn'

	
* calling argument declarations:

* internal variable declarations:
	LOGICAL	  no_range, overlay, no_labels, transpz, got_vpoint,
     .		  is_logh, is_logv, is_shade, use_cell, set_up, inc_grid
	INTEGER	  status, qp,
     .		  ax1_work, ax2_work, density, ipen
	REAL	  only_val, aspect
	PARAMETER (aspect = 0.0) 		!kob 12/96
	CHARACTER vpoint*24, zlims*24, zscale*24

* internal parameter declarations:
	LOGICAL		norm_dims_only, not_vector
	PARAMETER     ( norm_dims_only  = .FALSE.,
     .			not_vector	= .FALSE.)

* set up the graphics environment
	CALL START_PPLUS

* get the data (possibly ?? on a slightly oversized region)
	CALL DISP_DATA_SET_UP(  ax1_work, ax2_work, status )
	IF ( status .NE. ferr_ok ) GOTO 5100

* initialize
	overlay   = qual_given( slash_wire_over      ).GT.0 .AND. twodee_on
	no_labels = qual_given( slash_wire_nolabels  ).GT.0
	transpz   = qual_given( slash_wire_transpz   ).GT.0
	is_logh   = qual_given( slash_is_logh        ).GT.0 ! Not valid quals
	is_logv   = qual_given( slash_is_logv        ).GT.0 ! for wire fill
        is_shade  = .FALSE.
        use_cell  = .FALSE.

	IF ( .NOT.overlay ) CALL DISP_INIT(no_labels,
     .                                     is_cx, num_uvars_in_cmnd)
* ... default orientation for YT and ZT contours has time on horizontal
	IF ( (plot_axis(2).EQ.t_dim .OR. plot_axis(2).EQ.f_dim) .AND. 
     .		plot_axis(1).NE.x_dim ) transpz = .NOT.transpz

* get wire frame parameters (just get 'em as text strings)
* /VIEW = x,y,z
        vpoint = ' '
        qp = qual_given( slash_wire_view )
        got_vpoint = qp .GT. 0
        IF ( got_vpoint ) THEN
           CALL EQUAL_STRING( cmnd_buff(qual_start(qp):qual_end(qp)),
     .                     vpoint, status )
           IF ( status .NE. ferr_ok ) RETURN
        ENDIF
* /ZLIMITS = lo,hi
        zlims = ' '
        qp = qual_given( slash_wire_zlimits )
        IF ( qp .GT. 0 ) THEN
           CALL EQUAL_STRING( cmnd_buff(qual_start(qp):qual_end(qp)),
     .                     zlims, status )
           IF ( status .NE. ferr_ok ) RETURN
        ENDIF
* /ZSCALE=scale
        zscale = ' '
        qp = qual_given( slash_wire_zscale )
        IF ( qp .GT. 0 ) THEN
           CALL EQUAL_STRING( cmnd_buff(qual_start(qp):qual_end(qp)),
     .                     zscale, status )
           IF ( status .NE. ferr_ok ) RETURN
        ENDIF

* ... /COLOR=color name or pen number
	qp = qual_given(slash_wire_color)
	IF ( qp .GT. 0 ) THEN
           CALL EQUAL_COLOR( cmnd_buff(qual_start(qp):qual_end(qp)),
     .                           ipen, status )
           IF ( status .NE. ferr_ok ) GOTO 5000
	ELSE
	   ipen = -1	! auto-select in DISP_SET_UP
	ENDIF

* prepare PLOT+ environment
	CALL DISP_PREP( status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	
* /set_up only requested ?
	set_up    = qual_given( slash_cont_set_up    ).GT.0

        density = 0	! not used; vec/flow needs it in set up

* set up the axes and title and load the data into PPLUS

	inc_grid = set_up
	CALL DISP_SET_UP   ( 	
     .				not_vector,
     .                          is_shade,
     .                          use_cell,
     .				aspect,
     .				overlay,
     .				transpz,
     .				no_labels,
     .				no_range,
     .				only_val,
     .                          density,
     .				is_logh, 
     .				is_logv,
     .				is_mr,		! pass list
     .				num_uvars_in_cmnd,
     .				is_cx,		! pass list
     .				is_uvar,	
     .				workmem(ax1_work)%ptr,
     .				workmem(ax2_work)%ptr,
     .				ipen,
     .				set_up,
     .				set_up,
     .				status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* change "window" state in PLOT+
	CALL PPLCMD ( from, line, 0, 'WINDOW OFF', 1, 1 )

* set the view point
        IF ( got_vpoint ) 
     .       CALL PPLCMD ( from, line, 0, 'VPOINT '//vpoint, 1, 1 )

* /set_up only requested ?
	IF ( set_up ) GOTO 1000

* draw it 
	IF ( overlay ) THEN
	   CALL PPLCMD ( ' ', ' ', 0,
     .	                 'VIEW/OVER/' //ppl_wait//' '
     .                                //zscale//',,'//zlims, 1, 1 )
	ELSE
	   CALL PPLCMD ( ' ', ' ', 0,
     .			'VIEW/LATCH/'//ppl_wait//' '
     .                               //zscale//',,'//zlims, 1, 1 )
	ENDIF

* interrupt occurred during plot ?
	IF ( ppl_interrupted ) GOTO 1000

* capture the bit map ?
	IF ( qual_given( slash_wire_frame ) .GT. 0 ) THEN
	   CALL SAVE_FRAME( frame_file, "HDF", status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	ENDIF

* release the memory used for axis buffers
 1000 	CALL FREE_WS_DYNMEM( ax1_work )
	CALL FREE_WS_DYNMEM( ax2_work )
	CALL UNPROTECT_CMND_DATA			! 1/94
 5100	RETURN

* error exits
 5000	GOTO 1000
	END

*
* sampleyz.F
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without anx fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and anx derivative works thereof, and
*  its supporting documentation for anx purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in anx publications that result from
*  the use of this software or in anx product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in anx advertising or publicity to endorse or promote anx products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with anx support, consulting,
*  training or assistance of anx kind with regard to the use, operation
*  and performance of this software nor to provide the user with anx
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND Anx EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR Anx SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR Anx DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* From samplexy.F
* Wednesday, May 02, 2001
* 11-Jan-06 *acm* declare ylo, yhi, zlo, zhi as integer not real
*
* This function samples 4-d data at y and z pts indicated by args 2 and 3
* 
*         Result is abstract on the Y axis, normal on the z axis,
*         and keeps the x and t axes of the input 4-d data.

* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE sampleyz_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      CHARACTER*100 fcn_desc
      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns data sampled at a set of (Y,X) points, ',
     .   'using linear interpolation')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, ABSTRACT, 
     .     NORMAL, IMPLIED_BY_ARGS)

      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      CALL ef_set_num_work_arrays(id, 2)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'DAT_TO_SAMPLE')
      CALL ef_set_arg_desc(id, arg, 'variable (x,y,z,t) to sample')
      CALL ef_set_axis_influence(id, arg, YES, NO, NO, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'YPTS')
      CALL ef_set_arg_desc(id, arg, 'Y values of sample points')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'ZPTS')
      CALL ef_set_arg_desc(id, arg, 'Z values of sample points')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* loss               lo subscript for an axis
*
* hiss               hi subscript for an axis
*

      SUBROUTINE sampleyz_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER mz_lo_l, mz_hi_l
      INTEGER nx, ny, nz, nt

*     Use utility functions to get context information about the 
*     1st argument, to set the abstract axis lo and hi indices.

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nx = arg_hi_ss(X_AXIS, ARG2) - arg_lo_ss(X_AXIS, ARG2) + 1
      ny = arg_hi_ss(Y_AXIS, ARG2) - arg_lo_ss(Y_AXIS, ARG2) + 1
      nz = arg_hi_ss(Z_AXIS, ARG2) - arg_lo_ss(Z_AXIS, ARG2) + 1
      nt = arg_hi_ss(T_AXIS, ARG2) - arg_lo_ss(T_AXIS, ARG2) + 1

      mz_lo_l = 1
      mz_hi_l = max(nx,ny)
      mz_hi_l = max(mz_hi_l,nz)
      mz_hi_l = max(mz_hi_l,nt)

      CALL ef_set_axis_limits(id, Y_AXIS, mz_lo_l, mz_hi_l)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END
*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE sampleyz_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_lens(id,array #,ylo,zlo,zlo,tlo,yhi,zhi,zhi,thi)
*
      INTEGER myl, myh, mzl, mzh

      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

*  Allocate double the length of the axes for REAL*8 work arrays.

      myl = arg_lo_ss(Y_AXIS,ARG1)
      mzl = arg_lo_ss(Z_AXIS,ARG1)

      myh = myl + 
     .     2* (arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1) + 1)
      mzh = mzl + 
     .     2* (arg_hi_ss(Z_AXIS,ARG1) - arg_lo_ss(Z_AXIS,ARG1) + 1)

*  yax
      CALL ef_set_work_array_dims (id, 1, myl, 1, 1, 1, myh, 1, 1, 1)

*  zax
      CALL ef_set_work_array_dims (id, 2, mzl, 1, 1, 1, mzh, 1, 1, 1)


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*

      SUBROUTINE sampleyz_compute(id, arg_1, arg_2, arg_3, result,
     .       yax, zax)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .     mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .     mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz,
     .     mem3lot:mem3hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .      memresloz:memreshiz, memreslot:memreshit)


* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable's axes.

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      COMMON /STOR/ mydat, mzdat
      INTEGER mydat, mzdat
      INTEGER ny, nyx, nyy, nyz, nyt
      INTEGER nz, nzx, nzy, nzz, nzt
      INTEGER ndimy, ndimz

*  Set up work arrays

      REAL*8 yax(wrk1lox:wrk1lox+(wrk1hix-wrk1lox)/2,wrk1loy:wrk1hiy,
     .               wrk1loz:wrk1hiz, wrk1lot:wrk1hit)
      REAL*8 zax(wrk2lox:wrk2lox+(wrk2hix-wrk2lox)/2,wrk2loy:wrk2hiy,
     .               wrk2loz:wrk2hiz, wrk2lot:wrk2hit)

      INTEGER i, j, k, l
      INTEGER i1,j1,k1,l1
      INTEGER i2,j2,k2,l2
      INTEGER i3,j3,k3,l3

      INTEGER jmatch, kmatch
      INTEGER jbot, jtop, kbot, ktop
      REAL fbot, ftop, fbb, ftb, fbt, ftt
      REAL ybot, ytop, zbot, ztop
      REAL frac
      CHARACTER*255 err_msg

C  variables for checking axis characteristics (modulo axes)

      CHARACTER ax_name(4)*16, ax_units(4)*16
      LOGICAL backward(4), modulo(4), regular(4)
      REAL delmody, delmodz, ypt, zpt
      INTEGER ylo, yhi, zlo, zhi

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      nyx = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1
      nyy = arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) + 1
      nyz = arg_hi_ss(Z_AXIS,ARG2) - arg_lo_ss(Z_AXIS,ARG2) + 1
      nyt = arg_hi_ss(T_AXIS,ARG2) - arg_lo_ss(T_AXIS,ARG2) + 1
      ny = max(nyx, nyy, nyz, nyt)

      nzx = arg_hi_ss(X_AXIS,ARG3) - arg_lo_ss(X_AXIS,ARG3) + 1
      nzy = arg_hi_ss(Y_AXIS,ARG3) - arg_lo_ss(Y_AXIS,ARG3) + 1
      nzz = arg_hi_ss(Z_AXIS,ARG3) - arg_lo_ss(Z_AXIS,ARG3) + 1
      nzt = arg_hi_ss(T_AXIS,ARG3) - arg_lo_ss(T_AXIS,ARG3) + 1
      nz = max(nzx, nzy, nzz, nzt)

      ndimy = 0
      ndimz = 0
      DO 110 i = X_AXIS, T_AXIS
         IF (arg_hi_ss(i,ARG2) - arg_lo_ss(i,ARG2) .GT.0) 
     .       ndimy = ndimy + 1
         IF (arg_hi_ss(i,ARG3) - arg_lo_ss(i,ARG3) .GT.0) 
     .       ndimz= ndimz + 1
  110 CONTINUE

      IF (ny .NE. nz   .OR.  ndimy .GT. 1  .OR. ndimz .GT.1) THEN
         WRITE (err_msg, 10)
         GO TO 999
      ENDIF

   10 FORMAT(
     . 'Arguments 2 and 3 must be 1-dimensional lists of equal length')

*  Get y and z coordinates of the data to be sampled.

      CALL ef_get_coordinates(id, ARG1, Y_AXIS,
     .   arg_lo_ss(Y_AXIS, ARG1), arg_hi_ss(Y_AXIS, ARG1), yax)
      CALL ef_get_coordinates(id, ARG1, Z_AXIS,
     .   arg_lo_ss(Z_AXIS, ARG1), arg_hi_ss(Z_AXIS, ARG1), zax)

      i2 = arg_lo_ss(X_AXIS,ARG2)
      j2 = arg_lo_ss(Y_AXIS,ARG2)
      k2 = arg_lo_ss(Z_AXIS,ARG2)
      l2 = arg_lo_ss(T_AXIS,ARG2)

      i3 = arg_lo_ss(X_AXIS,ARG3)
      j3 = arg_lo_ss(Y_AXIS,ARG3)
      k3 = arg_lo_ss(Z_AXIS,ARG3)
      l3 = arg_lo_ss(T_AXIS,ARG3)

*  Check to see if input y or z  axis is modulo

      CALL ef_get_axis_info (id, ARG1, ax_name, ax_units, backward, 
     .                       modulo, regular)

      ylo = arg_lo_ss(Y_AXIS,ARG1)
      yhi = arg_hi_ss(Y_AXIS,ARG1)
      zlo = arg_lo_ss(Z_AXIS,ARG1)
      zhi = arg_hi_ss(Z_AXIS,ARG1)

      IF ( modulo(1) ) delmody = yax(yhi,1,1,1) - yax(ylo,1,1,1)
      IF ( modulo(2) ) delmodz = zax(zhi,1,1,1) - zax(zlo,1,1,1)

*  For each (ypt,zpt) pair, search the data array 
*   arg_1 for the nearest higher (y,z) grid coordinates.  Interpolate 
*   in 2 directions for the result.

      i2 = arg_lo_ss(X_AXIS,ARG2)
      j2 = arg_lo_ss(Y_AXIS,ARG2)
      k2 = arg_lo_ss(Z_AXIS,ARG2)
      l2 = arg_lo_ss(T_AXIS,ARG2)

      i3 = arg_lo_ss(X_AXIS,ARG3)
      j3 = arg_lo_ss(Y_AXIS,ARG3)
      k3 = arg_lo_ss(Z_AXIS,ARG3)
      l3 = arg_lo_ss(T_AXIS,ARG3)

      k = res_lo_ss(Z_AXIS)
      DO 500 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

         jbot = ef_unspecified_int4	! Check if ypt points in xax range.
         jmatch = 0

	 ypt = arg_2(i2,j2,k2,l2)
         DO 100 j1 = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)
            IF (ypt .GE. yax(j1,1,1,1)) jbot = j1
            if (ypt .EQ. yax(j1,1,1,1)) jmatch = j1

cbf      may be some derivation from the exact value can be allowed:
cbf      if (ypt - yax(j1,1,1,1)).le.eps)   jmatch = j1

*  Locate the Y point within the range of modulo Y axis 

	    IF (modulo(2)) THEN
	       DO WHILE (ypt .GE. yax(yhi,1,1,1) ) 
                  ypt = ypt - delmody
	       ENDDO
	       DO WHILE (ypt .LT. yax(ylo,1,1,1) )
		  ypt = ypt + delmody
	       ENDDO
	    ENDIF

  100    CONTINUE

         j1 = arg_hi_ss(Y_AXIS,ARG1)
         IF (ypt .GT. yax(j1,1,1,1)) THEN
             jbot = ef_unspecified_int4		! ARG_2 ypt outside of range 
						! (non modulo)
         ENDIF

cbf       for matching the next neighbour is not of interest
         IF (jmatch .NE. 0) then
            jtop = jbot
         ELSE
            jtop = jbot + 1
         ENDIF
         IF (jbot .EQ. ef_unspecified_int4) jtop = jbot

cbf        analogously in z direction
         kbot = ef_unspecified_int4	! Check if zpt points in yax range.
         kmatch = 0

	 zpt = arg_3(i3,j3,k3,l3)
         DO 200 k1 = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)
            IF (zpt .GE. zax(k1,1,1,1) ) kbot = k1
            IF (zpt .EQ. zax(k1,1,1,1) ) kmatch = k1
cbf         IF (zpt - zax(k1,1,1,1) ) .LE. eps) kmatch = k1

*  Locate the Z point within the range of modulo Z axis 

	    IF (modulo(3)) THEN
	       DO WHILE (zpt .GE. zax(zhi,1,1,1) ) 
                  zpt = zpt - delmodz
	       ENDDO
	       DO WHILE (zpt .LT. zax(zlo,1,1,1) )
		  zpt = zpt + delmodz
	       ENDDO
	    ENDIF

  200    CONTINUE
         k1 = arg_hi_ss(Z_AXIS,ARG1)
         IF (arg_3(i3,j3,k3,l3) .GE. zax(k1,1,1,1) ) THEN
            kbot = ef_unspecified_int4		! ARG_3 zpt outside of range 
						! (non modulo)

         ENDIF

c         print *, ' ypt,zpt,jbot,kbot', ypt,zpt,jbot,kbot

         IF (kmatch .NE. 0) then
            ktop = kbot
         ELSE
            ktop = kbot + 1
         ENDIF
         IF (kbot .EQ. ef_unspecified_int4) ktop = kbot

         i1 = arg_lo_ss(X_AXIS,ARG1)
         DO 400 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

            l1 = arg_lo_ss(T_AXIS,ARG1)
            l2 = arg_lo_ss(T_AXIS,ARG2)
            l3 = arg_lo_ss(T_AXIS,ARG3)
            DO 300 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

*  First interpolate in y, getting values of the fcn at (y,kbot) and (y,ktop)

	       IF (jbot .EQ. ef_unspecified_int4  .OR.  
     .		   kbot .EQ. ef_unspecified_int4) THEN
                 result(i,j,k,l) = bad_flag_result
	       ELSE 
                  IF (jbot .GE. arg_lo_ss(Y_AXIS,ARG1)  .AND.
     .                jtop .LE. arg_hi_ss(Y_AXIS,ARG1) ) THEN

                     ybot = yax(jbot,1,1,1)
                     ytop = yax(jtop,1,1,1)

                     fbb = arg_1(i1,jbot,kbot,l1)
                     fbt = arg_1(i1,jtop,kbot,l1)	!
                     ftb = arg_1(i1,jbot,ktop,l1)	!
                     ftt = arg_1(i1,jtop,ktop,l1)

                     IF (fbb .NE. bad_flag(ARG1)  .AND.
     .                   ftb .NE. bad_flag(ARG1)  .AND.
     .                   fbt .NE. bad_flag(ARG1)  .AND.
     .                   ftt .NE. bad_flag(ARG1) ) THEN

cbf                 for matching x-axis no interpolation is need
                          if (jmatch.eq.0) then
                             fbot = fbb
                             ftop = fbt
                          else
                             frac = (ypt - ybot )/ (ytop - ybot)
                             fbot = fbb + frac* (ftb - fbb)
                             ftop = fbt + frac* (ftt - fbt)
                          endif

*  Now interpolate in z, getting value at (y,z)

                       IF (kbot .GE. arg_lo_ss(Z_AXIS,ARG1)  .AND.
     .                     ktop .LE. arg_hi_ss(Z_AXIS,ARG1) ) THEN
                          zbot = zax(kbot,1,1,1)
                          ztop = zax(ktop,1,1,1)

                          if(kmatch.eq.0) then
                             result(i,j,k,l) = fbot
                          else
                            frac = (zpt - zbot)/ (ztop-zbot)

                            result(i,j,k,l) = fbot + frac* 
     .                                         (ftop - fbot)

                          endif
                       ELSE
                           result(i,j,k,l) = bad_flag_result
                       ENDIF

                    ELSE
                        result(i,j,k,l) = bad_flag_result
                    ENDIF  ! bad_flag(ARG1) test
                  ENDIF	   ! fbb,ftp, etc not bad flags

	       ENDIF  ! jtop, ktop not ef_unspecified_int4

               l1 = l1 + arg_incr(T_AXIS,ARG1)

 300        CONTINUE

            i1 = i1 + arg_incr(X_AXIS,ARG1)
 400     CONTINUE

         i2 = i2 + arg_incr(X_AXIS,ARG2)
         j2 = j2 + arg_incr(Y_AXIS,ARG2)
         k2 = k2 + arg_incr(Z_AXIS,ARG2)
         l2 = l2 + arg_incr(T_AXIS,ARG2)

         i3 = i3 + arg_incr(X_AXIS,ARG3)
         j3 = j3 + arg_incr(Y_AXIS,ARG3)
         k3 = k3 + arg_incr(Z_AXIS,ARG3)
         l3 = l3 + arg_incr(T_AXIS,ARG3)
         k = k + res_incr(Z_AXIS)
500   CONTINUE


      RETURN
 999  CALL ef_bail_out (id, err_msg)

      END

	LOGICAL FUNCTION CD_GET_ATTVALC ( dset, varid, attrib,
     .                                    do_warn, vname,
     .                                    val, blank_val )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* This routine is like cd_attval except that it allows for the possibility
* that the required numerical value is stored in a character attribute
* and it can return only a single value

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* 2/02  *sh*
* 1/03 **ACM** add this note: (no code changes)
*      Note that under OSF (and PC? ) CD_GET_ATTVALC returns TRUE when 
*      the value of the attribute contains a non-numeric string, say "F".  
*      Under Solaris and Linux, returns FALSE. If the value of the modulo 
*      attribute is type character, this function tries to read a numeric 
*      value from a character buffer . For solaris, linux, this read:
*
*      	     READ (buff,*,ERR=5000) val  ! convert text to value
*
*      returns an error and goes to 5000 if the contents of buff is not  
*      a number.  For OSF, reads anyway, returning -1 when the character 
*      string is T, or 0 for all other characters. 
* V600 *ACM* attribute control. 
*             Replace NCAINQ with CD_GET_VAR_ATT_INFO
*             Change call to CD_GET_ATTRIB to NC_GET_ATTRIB - get attrib from linked list structure
*             CD_GET_ATTVAL replaced by NC_GET_ATTRIB, which now returns  
*               strings or real values according to attrib type
* V602 *acm* make sure lena=length of attr name is defined before writing warning
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 2/10- all warnings and notes to std error not std out
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* argument definitions:
*	dset	 - dataset id number for already opened CDF file
*       varid    - variable id in netCDF file
*       attrib   - attribute to search for
*	do_warn	 - logical flag to issue warning if invalid attribute
*       vname    - name of variable owning attribute (used in error msgs)
*       val      - array into which to return result
*       blank_val- if a blank character attribute, then return this default

* argument declarations
      LOGICAL       do_warn
      INTEGER	    dset, varid
      CHARACTER*(*) attrib, vname
      REAL	    val, blank_val

      include 'xio.parm'
      include 'netcdf.inc'
      include 'tmap_errors.parm'

* internal variable declarations:
      LOGICAL NC_GET_ATTRIB
      INTEGER attlen, attoutflag
      INTEGER TM_LENSTR1, lena, attype, attid, status
      REAL tmp
      CHARACTER buff*132, aname*132

* inquire about the attribute by name, getting its id number

      CALL CD_GET_VAR_ATT_ID (dset, varid, attrib, attid, status)
      IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, 
     .                  aname, attype, attlen, attoutflag, status )
      lena = TM_LENSTR1( aname )

      IF ( status .EQ. merr_ok ) THEN
	IF (attype .EQ. NF_CHAR) THEN
* get a text attribute as a value

	   CD_GET_ATTVALC = NC_GET_ATTRIB(dset,varid,aname(:lena),
     .                            do_warn,vname,132, attlen,  
     .                            attoutflag, buff, tmp )
	   IF (.NOT.CD_GET_ATTVALC) THEN
	     RETURN
	   ELSEIF (buff .EQ. ' ') THEN
	     val = blank_val
	   ELSE
	     READ (buff,*,ERR=5000) val  ! convert text to value
	   ENDIF 
	 ELSE
* get a value attribute
	   CD_GET_ATTVALC = NC_GET_ATTRIB(dset, varid, aname(:lena),
     .                                    do_warn, vname, 1, attlen,
     .                                    attoutflag,  buff, val )
	 ENDIF
      ELSE
* didnt get nothin
	 CD_GET_ATTVALC = .FALSE.
      ENDIF

      RETURN

* error exit
 5000 CONTINUE
c      IF (do_warn) THEN
c       lena = TM_LENSTR1( aname )
c	CALL TM_NOTE('Undecipherable value of netCDF attribute '//
c     .		      attrib(:lena)//' on variable '//vname, lunit_errors)
c	CALL TM_NOTE('"buff(:TM_LENSTR1(buff))"', lunit_errors)
c      ENDIF
      CD_GET_ATTVALC = .FALSE.
      RETURN
      END

	CHARACTER*(*) FUNCTION GET_UNIQUE_DSET_NAME ( dset )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Return the short datset name, unless there is another dataset open with
* the identical name. In that case return the full name with path or url.

*  ACM 10/2013

        IMPLICIT NONE
        include 'tmap_errors.parm'      ! error codes
#include "tmap_dset.parm"
        include 'tmap_dims.parm'        ! data set dimensions
        include 'xdset_info.cmn_text'   ! data set common
        external xdset_info_data

* argument
	INTEGER dset

* local variable definitions
	INTEGER STR_SAME, slen, iset, ic
	CHARACTER*2048  dset_name


* get the short name of this dataset

	 dset_name = ds_name(dset)

* If no name, return.

	 GET_UNIQUE_DSET_NAME = dset_name
	 IF ( ds_name(dset) .EQ. char_init2048 ) GOTO 120

         DO 110 iset = 1,maxdsets
           IF (ds_name(iset) .EQ. char_init2048) GOTO 110
	   IF (iset .EQ. dset) GOTO 110
	   ic = STR_SAME (dset_name, ds_name(iset))
           IF (ic .EQ. 0) THEN
	       GET_UNIQUE_DSET_NAME = ds_des_name(dset)
               GOTO 120
	   ENDIF
           
  110   CONTINUE

        GET_UNIQUE_DSET_NAME = dset_name

  120   CONTINUE
	RETURN
	END

      SUBROUTINE COLOR(ICODE)
C**
C**    @(#)color.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     CALL COLOR(ICODE)
C
C     THIS SUBROUTINE SELECTS A PEN ON THE TEKTRONIX 4663 PLOTTER,
C     THE HP PLOTTER, AND THE ZETA PLOTTER AND CONTROLS THE SIX-
C     POSITION TURRET HEAD ON THE GERBER PLOTTER.  IT CAN BE USED
C     TO CHANGE THE COLOR OF THE INK USED FOR PLOTTING.
C
C
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Modified J Davison JISAO/PMEL/TMAP 3.23.89
*	To accomodate GKS changes to bundled line attributes
 
*  8/2001  acm  for PLOT/SYMBOL=DOT
*  Call GSPMI for polymarker with call to GSPLI for polyline
*      *acm* 10/01  remove VMS includes

	integer	icode

#ifdef unix
        INTEGER TEKCLR(6),TK41XX(3)
        INTEGER NUM(0:15),setlineindex
#else
	byte TEKCLR(6),TK41XX(3)
        byte NUM(0:15)
#endif
	character*1 cnum(0:8)
C
	include 'pltcom_dat.decl'
	include 'PLTCOM.DAT'
	include 'gkscm1_inc.decl'
	include 'GKSCM1.INC'
	include 'pltl_inc.decl'
	include 'PLTL.INC'

C
	data cnum/'0','1','2','3','4','5','6','7','8'/
        DATA NUM/48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63/
c	DATA TEKCLR/'`','h','e','m','f','n'/,TK41XX/27,77,76/
	DATA TEKCLR/96,104,101,109,102,110/,TK41XX/27,77,76/
C	DATA TEKPEN/27,67,66,80/
C
C     CHECK THE PLOT TYPE.
C
       GO TO(10,50,40,10,10,20,20),PTYPE + 3
C	GOTO (50,50,40,30,40),PTYPE + 3
C
10	IF(TTYPE.LT.0)GOTO 100
	COLOUR=ICODE
	IF(TTYPE.LT.4100)THEN
	IF(COLOUR.LT.1.OR.COLOUR.GT.6)COLOUR=1
C
C	SEND SEQUENCE FOR TEK 4014 TERMINAL
C
	CALL CHOUT(ESC,1)
	CALL CHOUT(TEKCLR(COLOUR),1)
	ELSE
	IF(COLOUR.LT.0.OR.COLOUR.GT.15)COLOUR=15
C
C	SEND SEQUENCE FOR TEK 41XX TERMINALS
C

CC	Mod for linux *jd* 12.96  
CC	"Inconsistent structure for arg 1 in call to CHOUT" compiler error
CC	as CHOUT is called with arg 1 a scalar, and also an array.
CC	Will commence using the compile option -mismatch, where 
CC	match of subroutine arguments is not forced.


	CALL CHOUT(TK41XX,3)
	CALL CHOUT(NUM(COLOUR),1)
	ENDIF	
C
C     CHECK THE TEKTERMINAL TYPE.
C
C   10 IF(TTYPE .EQ. -4663)THEN
C        COLOUR = ICODE
C
C     CHECK FOR A LEGAL PEN COLOR CODE.
C
C        IF(COLOUR .LT. 1 .OR. COLOUR .GT. 2)COLOUR = 1
C
C     CHECK THE GRAPHICS FLAG.
C
C        IF(.NOT. GRAPHF)THEN
C
C     TRANSMIT THE 'PLOTTER ON' COMMAND TO THE TEKTRONIX PLOTTER.
C
C	CALL (TEKON,3)
C        ENDIF
C
C     SELECT THE APPROPRIATE PEN.
C
C	CALL CHOUT(TEKPEN,4)
C        CALL CHOUT(COLOUR + 48,1)
C
C     CHECK THE GRAPHICS FLAG.
C
C        IF(.NOT. GRAPHF)THEN
C
C     TRANSMIT THE 'PLOTTER OFF' COMMAND TO THE TEKTRONIX PLOTTER.
C
C	CALL CHOUT(TEKOFF,5)
C
C     WRITE OUT THE CHARACTER BUFFER.
C
C          CALL CHDMP
C        ENDIF
C      ENDIF
C     CHECK FOR OTHER PLOTTING DEVICES.
C
	GOTO 100
C
C	GKS COLOR AND SETUP
C
20	COLOUR=ICODE
	IF(.NOT.GKSOPN)THEN
#ifdef core
            call crinit
#else
	    call gkinit
	    CALL GCLRWK(WSID,0)
#endif
C
	    GKSOPN=.TRUE.
	ENDIF
	CALL PPLGFLUSH
#ifdef core
        istat=setlineindex(icode)
#else
*	CALL GSPLCI(ICODE) ! original
*	CALL GSPMCI(ICODE) ! acm 8/7/01 for reference,not called
#endif

1000	call gspli (max(icode,1)) ! JD 3.23.89 & 3.13.90
	call gspmi (max(icode,1)) ! acm 8/7/01  polymarker index

100	GOTO(50,30,30,30,40,30,40),PTYPE + 3
   40  COLOUR = ICODE
	IF(.NOT.PLTFLG)THEN
C	INITIALIZE THE BINARY BUFFER WITH WIDTH,HEIGHT
C	OF THE PLOTTING AREA
C
	CALL BINBUF(ASIZE,BSIZE)
	PLTFLG=.TRUE.
	ENDIF
C
C	SELECT THE PEN
C
	CALL BINBUF(FLOAT(COLOUR),-1.)
	PEN=.FALSE.
	LPEN=.NOT.PEN
      GOTO 30
C
50	COLOUR=ICODE
C
C	COLOR ON THE HP7475
C
	IF(COLOUR.LT.1.OR.COLOUR.GT.8)COLOUR=1
	IF(.NOT.PLTFLG)THEN
	CALL ZBUFFT('DF;',3)
	PLTFLG=.TRUE.
	ENDIF
	CALL ZBUFFT('PU;SP',5)
	CALL ZBUFFT(CNUM(COLOUR),1)
	CALL ZBUFFT(';',1)
	PEN=.FALSE.
	LPEN=.NOT.PEN
30	RETURN
      END

	SUBROUTINE DSG_LABEL_NOFEATURE ( dummy, labsize, status)

* 3/26/20 
* Use annotation-calls to put a label "No Profile Data in Selection" 
* across a plot where constraints resulted in no features selected.

        IMPLICIT NONE
	include 'errmsg.parm'

	CHARACTER*(*)	dummy
	REAL		labsize
	INTEGER		status

	REAL		xloc, yloc, halign, valign, angle
	INTEGER		nlab

	xloc = 0.5
	yloc = 0.5
	halign = 0.
	valign = 0.
	angle = 0.0
	nlab = 0  ! define next moveable label

c  first 3 argument are user, nouser, norm
	CALL SETUP_ANNOTATION (.FALSE., .FALSE., .TRUE.,  
     .         xloc, yloc, halign, valign, angle, labsize, status)

	IF (status .EQ. ferr_ok) CALL PUT_ANNOTATION (
     .         .FALSE., .FALSE., .TRUE., xloc, yloc, halign, 
     .         angle, labsize, nlab, dummy, status)

	RETURN
	END   

	SUBROUTINE CD_ASSOC_GRIDS (dset, reversed, 
     .				   temp_axnams, status)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Creates the association of the FERRET variables with their parent grids
* within a netCDF file
* Checks that all variables in the data set have associated grids.

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 2/92
* 2/95 - added support for reverse-ordered coordinate axes
* Linux port -kob - 3/97 - Modify include for tmap_dset.parm to be a
*			   preprocessor include for F90 - needed because
*			   tmap_dset.parm contains an ifdef
* V500:  4/99 *kob* - increase size of temp_axnams and vname from 16 to 64
* V510 *sh* 3/00 - convert to use of dynamic grids and axes
* V533 *sh* 6/01 - support for string variables
* V552:  3/03 *acm* - increase size of vname to 128
* V600 *ACM* attribute control. 
*             NCVINQ replaced by CD_GET_VAR_INFO
*             NCDINQ replaced by CD_GET_DS_DIMS
*             Change call to CD_GET_ATTRIB to NC_GET_ATTRIB
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing
* TODO: initially leave this as 4D -- what to do with old files that have 4 slab min/max?

* argument definitions:
*       dset        - TMAP data set pointer
*       reversed    - logical array to record which axes have reversed coords
*       temp_axnams - temporary storage of axis names to construct grids
*	status	    - return status

* include files

        include 'netcdf.inc'
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
        include 'xbuild_grids.cmn'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xtm_grid.cmn_text'
	        include 'xdset_info.cd_equiv'

* argument declarations
	INTEGER	 dset, status
        LOGICAL  reversed(max_lines:line_ceiling)
* 4/99 *kob* 
	CHARACTER*128 temp_axnams(nferdims,max_temp_grid)

* local parameter definitions:
      INTEGER     str_eq
      PARAMETER ( str_eq = 0 )

* local variable declarations:
* move do_warn assignment to paramater for linux *kob*
      LOGICAL NC_GET_ATTRIB,
     .        got_it, do_warn
      PARAMETER (do_warn = .TRUE.)
      INTEGER STR_CASE_BLIND_COMPARE,
     .        igrid, iaxis, istat, tmvar, ivar, ndim, idim,
     .        maxlen, attlen, attoutflag, all_outflag
      REAL    tmp
      CHARACTER*16 gname
* variables for final (unnecessary?) check
      CHARACTER TM_STRING*13, vname*128, buff*128
      INTEGER TM_LENSTR1,
     .        vartyp, nvdim, vdims(8), nvatts, dim, npts, vlen
      LOGICAL coordvar

* *kob* explicit definitions not allowed on decl line in linux...moved it to parameter line
      CHARACTER*1     dimnam(nferdims)
      DATA dimnam/'I', 'J', 'K', 'L', 'M', 'N'/

* loop through each variable in this TMAP data set
* if it has a "parent_grid" then associate it with that grid
* if not then make sure it has a grid associated

        DO 1000 tmvar = 1,maxvars
           IF ( ds_var_setnum(tmvar) .NE. dset ) GOTO 1000
           ivar = cd_varid(tmvar)

* does it point explicitly to a parent grid ?
          maxlen = 16  !gridnamlen
          got_it = NC_GET_ATTRIB( dset, ivar, 'parent_grid',
     .                         .NOT.do_warn, ' ', maxlen, attlen,
     .                         attoutflag, gname, tmp )  
          IF ( .NOT.got_it ) THEN
* ... check that it is a current temporary grid -- should ALWAYS be true
	     IF (ds_grid_number(tmvar) .LT. max_grids    ) GOTO 5100
	     IF (tmp_nam_ptr(ds_grid_number(tmvar)).EQ.0 ) GOTO 5100
             GOTO 1000
          ENDIF

* locate the grid it points to
	  igrid = 0	! to get start of linked list
 100	  CALL TM_NEXT_TMP_GRID( igrid, *5100)
             istat = STR_CASE_BLIND_COMPARE(gname, grid_name(igrid))
             IF ( istat .EQ. str_eq ) THEN
                ds_grid_number(tmvar) = igrid
                GOTO 110
             ENDIF
	  GOTO 100

* set ds_ordering if not explicitly given in file
* e.g. map X NORMAL Z T to 1 3 4 0
 110      IF ( ds_ordering(1,tmvar) .EQ. unspecified_int4 ) THEN
             DO 190 idim = 1, nferdims
 190         ds_ordering(idim,tmvar) = 0
             ndim = 0
             DO 200 idim = 1, 4
                IF ( grid_line(idim,igrid) .EQ. mpsnorm ) GOTO 200
                ndim = ndim + 1
                ds_ordering(ndim,tmvar) = idim
 200         CONTINUE
          ENDIF

* count the number of axes in the grid
          ndim = 0
          DO 220 idim = 1, 4
             IF ( grid_line(idim,igrid).NE.mpsnorm ) ndim = ndim + 1
 220      CONTINUE
          
* set ds_grid_start if not explicitly given in file
          IF ( ds_grid_start(1,tmvar) .EQ. unspecified_int4 ) THEN
             DO 300 idim = 1, 4
 300         ds_grid_start(idim,tmvar) = 1
          ENDIF
	  
* set ds_grid_end if not explicitly given in file
          IF ( ds_grid_end(1,tmvar) .EQ. unspecified_int4 ) THEN
             DO 400 idim = 1, 4
                iaxis = grid_line(idim,igrid)
                IF ( iaxis .EQ. mpsnorm ) THEN
                   ds_grid_end(idim,tmvar) = 1
                ELSE
                   ds_grid_end(idim,tmvar) = line_dim(iaxis)
                ENDIF
 400         CONTINUE
          ENDIF

* TODO won't need this after implementing full 6D treatment here.
          DO 410 idim = 5, nferdims
             ds_grid_start(idim,tmvar) = 1
 410         ds_grid_end(idim,tmvar) = 1

* check that the parent lo/hi limits are consistent with the variable slab size

          CALL CD_GET_VAR_INFO (dset, ivar, vname, vartyp, nvdim, vdims,
     .                 nvatts, coordvar, all_outflag, istat)
          vlen = TM_LENSTR1(vname)

* ... if a string variable, the first dimension is the string axis (ignore it)
	  IF (vartyp .EQ. NF_CHAR) THEN
	     nvdim = nvdim - 1
	     DO idim = 1, nvdim
	        vdims(idim) = vdims(idim+1)
	     ENDDO
	  ENDIF
          IF ( ndim .NE. nvdim ) GOTO 5300 
          DO 500 idim = 1, 4
             dim = ds_ordering(idim,tmvar)
             IF ( dim .EQ. 0 ) GOTO 500
!             IF ( dim .EQ. unspecified_int4 ) dim = idim
             CALL CD_GET_DS_DIMS ( dset, vdims(idim), buff, npts, istat )
             IF ( npts .NE.
     .          ds_grid_end(dim,tmvar)-ds_grid_start(dim,tmvar)+1 )
     .               GOTO 5200
 500      CONTINUE

* flag (negative) the axes that have reverse-ordered coordinates
	  DO 610 idim = 1, 4
	     dim = ds_ordering(idim,tmvar)
             IF ( dim .EQ. 0 ) GOTO 610
* At this stage the axis pointers have not yet been inserted into the
* parent grid definitions (we still have to check for duplicate def'ns, etc.)
* So we need to check by name (among the axes defined in this data set)
* to find this axis and see if this axis is reversed.
	     IF ( grid_line(dim,igrid) .EQ. unspecified_int4 ) THEN
	       vname = temp_axnams(dim, tmp_nam_ptr(igrid))
	       iaxis = 0	! to get start of linked list
* ... search the linked list of axes defined in this dtaa set
 600	       CALL TM_NEXT_TMP_LINE( iaxis, *610)
                 IF ( vname .EQ. line_name(iaxis) ) THEN
	           IF (reversed(iaxis)) ds_ordering(idim,tmvar) = -1*dim
                   GOTO 610
                 ENDIF
	       GOTO 600
	    ENDIF
 610	  CONTINUE

 1000   CONTINUE

* successful completion
 	status = merr_ok
        RETURN

* error messages
 5100   CALL TM_ERRMSG(merr_unkgrid, status, 'CD_ASSOC_GRIDS',
     .       dset, no_stepfile,
     .       'CDF grid name: '//gname, no_errstring, *5900)

 5200   CALL TM_ERRMSG(merr_badsubscr, status, 'CD_ASSOC_GRIDS',
     .       dset, no_stepfile, 'CDF variable "'//vname(:vlen)//
     .       '" on '//dimnam(dim)//'='//
     .       TM_STRING(DBLE(ds_grid_start(dim,tmvar)))//'-'//
     .       TM_STRING(DBLE(ds_grid_end  (dim,tmvar))),
     .       no_errstring, *5900)

 5300   CALL TM_ERRMSG(merr_gridpredef, status, 'CD_ASSOC_GRIDS',
     .       dset, no_stepfile,
     .       '# of dims in variable '//vname(:vlen)//
     .       ' does not match grid '//gname, no_errstring, *5900)

* error exit
 5900   RETURN
	END

 	SUBROUTINE PLTIT(X,NXS)
*   
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written per/x=178.5:179.5 uwndion is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* revised for TMAP
* from PPLUS :
*	Directory PMEL:[PLOT5.LIBRARY.PLOT]
*	PLTIT.FOR;34              6  25-AUG-1987 15:23

* search for "TMAP" to find all revisions
* *sh* 6/30/88 - rev 1.0 - for FERRET 1.00+
*	- added calls to SEG_ON and SEG_OFF to imbed graphics in a segment
*	- this permits resizing of windows
* *jd* 9.7.88  - rev 2.0  
*	- Modified to call SHADE
* *jd* 11.28.88
*	- Modified to be compatible with version 1.1 PPL
* *sh*  - added interrupt detection and "in FERRET" detection
* *jd*  - added call to ALINE_SUB 10.17.89  (interrupts: 12.7.89)
* *jd*	- mod to handle metafiles 11.6.89
* *jd*	- mod to handle Ferret viewports 12.1.89
* *sh*  - mod to permit cancelling of all GKS output windows from Ferret
* *jd*  - mod to handle CLSPLT with metafiles
* *jd*  - mod to include AREA 1.14.92
* *jd*  - mod to add interrupts to PLOT calls
* *jd*  - mod to protect colors used already in shade plots 10.01.92
* *jd*  - mod to add PPLP version number in metafile
* *jd*  - mod to eliminate version number in xgks version
* *jd*  - mod to fix bug with WS not open error 11.4.93
* *jd*  - mod to fix bug in FILL, borders being overwritten and not redrawn,
*	  with call to daxis_box 8.18.95 - also use with SHADE
* *jd*	- mod to put back use of daxis as cross and interior tics are
*	  lost without it.
* *sh*  - added commands PLOTPOL and FILLPOL
* *jd*	- put in daxis after FILLPOL
* *acm*	- 10/2000 add VECTOR/FLOWLINE, alias FLOWLINE
* *acm* - 12/2001 send third argument to FLOWLINE, work array for the
*         flag grid, now allocated in disp_set_up.F
* *acm* - 10/02 After FILL plot (plotz) call WINDOW to restore values of
*         XMIN, XMAX, YMIN, YMAX. Else DAXIS plot calls are not in range.
* *acm* - 10/02 bug fix: start index of X as the third argument to FLOWLINE
*         was icorrect for irregular-grid case (JTYPE .ne. -1) See PPLLDC.
* *acm*   V550 11/02 For fine grids, XLPLOT, XHPLOT, YLPLOT, YHPLOT 
*         computations need to be done in double precision.
* *acm*   V550 12/02 For lines which are plotted with symbols, plot a 
*            key having 3 points.
* *acm*   v552  3/03 add word POLYGON so can say PPL FILLPOL, or PPL POLY
 
* V554  9/03 *acm* Compute XLPLOT etc in double precision: for fine
*                  grids in curvlinear coordinates; xtm, xtx are axis indices
*                  (like 4000) and xhi, xlo are in the final curvilinear 
*                  coordinates (like 0.0218) so adding xtm+xlo as R*4 loses 
*                  the precision in xtm. See also plotz.F, setax.F
* V602  1/07 *acm* true batch mode for metafiles; flag meta_batch
*                  distinguises this case from other batch modes.
* V6.11 4/08 *acm* Fixes for bug 1571
* *acm* 5/09 *acm* Fixes for bug 1663. When redrawing axes after a POLY/OVERLAY
*                  do not do any axis labels
* V6.5  3/10 *acm* When re-plotting axes, do not redraw the main label.
* v68  *acm* 4/08 Allow shade, vector plots of degenerate regions - world region 
*              within a grid cell
** V68   *acm* 4/11 change how flag meta_batch is computed (different Makefile)
* V6.8 *acm* 7/9/2012 For batch graphics on RHEL6, change ITS_BATCH_GRAPHICS
*                     from logical to integer, then batch = ITS_BATCH_GRAPHICS().NE.0
* V694  *acm*  5/15 Ticket 2283. Handling axis scaling for ribbon plots.
* V694  *acm*  1/15 Changes to allow two time axes on plot (F-T)
* V694  *acm*  2/15 Fix ticket 2232; redraw plot axes on line plots
* V694  *acm*  5/15 correct the setting of is_ribbon
* V695  *acm*  9/15 Changes for hour:min labeling on time axes
* V695 *acm*   5/15 Ticket 2279: Draw axis lines, tics and labels only once
*	       as for pyFerret
* V697 *acm*  12/15 Ticket 2334: For time roundoff on overlays, changing 
*                  things only for the short-time-axis case.
* V 7 *acm*   6/16 Ticket 2435: moveable labels in PyFerret when using PyFerret fonts
* V73+ 1/18 *acm*  Changes for Issue 1009; precsision in time info sent to pplus for 2D plots
* V74  *acm* -11/18 Issue #1900 Fixes for tic marks and PLOT/OVERLAY with short-interval time
* v744 *acm* 11/18 Issue 1786: graticule lines & axes drawn if PLOT/OVER/AXES given
* v76  *acm*  4/20 New flag ribbon_on so that RIBBON/SET; PPL PLOT works correctly

*****************************************************

* local variable declarations for PLTIT (for TMAP)
	REAL	x, xf, yf, xl, yl, xh, yh, xti, xtl, thi
	REAL*8	DIFF, XLPLOT,YLPLOT,XHPLOT,YHPLOT
	REAL	xtm,ytm,xtx,ytx,minx,maxx,miny,maxy
	INTEGER nxs, nmx, nmy, ivloc, ip1, ip2, ip3, ip4, a_line,
     .          LABELX_save, LABELY_save, LABELT_save
	LOGICAL DRAW, did_draw

* TMAP include files with explicit type declarations:
	include 'parampl5_dat.decl'
	include 'PARAMPL5.DAT'

	DIMENSION X(NXS) ! Was VIRTUAL, changed for linux *jd*
	include 'lines_inc.decl'
	include 'LINES.INC'
	include 'pen_inc.decl'
	include 'PEN.INC'
	include 'axis_inc.decl'
	include 'AXIS.INC'
	include 'hd_inc.decl'
	include 'HD.INC'
	include 'taxis_inc.decl'
	include 'TAXIS.INC'
	include 'axisl_inc.decl'
	include 'AXISL.INC'
	include 'plt_inc.decl'
	include 'PLT.INC'
	include 'pltl_inc.decl'
	include 'PLTL.INC'
	include 'mplot_inc.decl'
	include 'MPLOT.INC'
	include 'cmrd_inc.decl'
	include 'CMRD.INC'
	include 'prmcom_inc.decl'
	include 'PRMCOM.INC'
	include 'switch_inc.decl'
	include 'SWITCH.INC'
	include 'system_inc.decl'
	include 'SYSTEM.INC'
	include 'cont_inc.decl'  !added to get ivcomp v1.1
	include 'CONT.INC'  !added to get ivcomp v1.1
	include 'xinterrupt.cmn'	! 1/89 *sh* - interrupts
	include 'labels_inc.decl'
	include 'LABELS.INC'
	include 'miss_inc.decl'
	include 'MISS.INC'


* special COMMON to let this routine know if FERRET is in control

	include 'ppl_in_ferret.cmn'
	include 'aline.cmn'	! jd for aline call
	include 'gkscm2.cmn' 
	include 'shade_vars.cmn' 


	LOGICAL CLEAR,CONTR,no_vpt_flag, is_ribbon

	INTEGER ITS_META_GRAPHICS, ITS_BATCH_GRAPHICS
        LOGICAL its_meta, batch, meta_batch
	INTEGER ipv
	REAL	fp_xfac, fp_yfac

*	*jd* linux port 12.96 Add external stmt below
	external size, scale

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

        its_meta = ITS_META_GRAPHICS() .NE. 0
        batch = ITS_BATCH_GRAPHICS() .NE. 0
	meta_batch = .FALSE.
	IF (batch) THEN
	   IF (its_meta) meta_batch = .TRUE.
	ENDIF

	IF(((MAKEP.EQ.'CONTOUR'.OR.MAKEP.EQ.'VIEW'.or.
     *     makep.eq.'FILL'.or.makep.eq.'PIXEL'.or.
     *       makep.eq.'SHADE')  
     *	  .AND.JTYPE.EQ.1).OR.
     *	  ((MAKEP.EQ.'VECTOR').AND.JTYPE.GT.-1).OR.
     *	  ((MAKEP.EQ.'FLOWLINE').AND.JTYPE.GT.-1).OR.
     *	  ((MAKEP.EQ.'PLOT'.OR.MAKEP.EQ.'PLOTV'.OR.
     *	  MAKEP.EQ.'PLOTUV'.OR.MAKEP.EQ.'VELVCT'.OR.
     *	  MAKEP.EQ.'PLOTPOL'.OR.MAKEP.EQ.'FILLPOL')
     *	  .AND.JTYPE.NE.1))RETURN
	CONTR=MAKEP.EQ.'CONTOUR'.OR.MAKEP.EQ.'VIEW'
     *		.OR.MAKEP.EQ.'VECTOR'.or.makep.eq.'SHADE'   
     *          .or.makep.eq.'FLOWLINE'
     *          .or.makep.eq.'FILL'.or.makep.eq.'PIXEL'
	CLEAR = .NOT.SOVER .AND. IMCNT.LE.1 .AND. .NOT.PLTOPN
C	SETUP AXIS FOR ALL PLOT TYPES.

*below	no_vpt_flag = .not.(vpt_was_set .and. ppl_viewports_active)!12.1.89 JD
*	MOD TO PROTECT COLORS ALREADY USED IN SHADE & FILL - took out for now
*	if (clear .and. no_vpt_flag) then
*	   protect_used_colors = .false.
*	   lo_color_ndx = 0
*	else
*	   protect_used_colors = .true.
*	endif

	if ( 
     .      ((.not.meta_actv).AND. (.not.meta_batch) ) .or.
     .      first_meta) goto 10		!12.1.89 JD

*	VPT_WAS_SET is used to check whether viewports were set the last time
*	Ferret made a plot call. It is however cleared, when CLSPLT is invoked,
*	as the continuity of viewport use is broken.

	no_vpt_flag = .not.(vpt_was_set .and. ppl_viewports_active)!12.1.89 JD
	if (clear .and. no_vpt_flag) then			!12.1.89 JD

	   if (.not. meta_clsplt) then				!1.25.90 JD
              call gdawk (meta_wsid)     			!11.6.89 JD
	      call gclwk (meta_wsid, batmode)
	      close (meta_lun)					!11.6.89 JD
*             TEMP FIX DUE TO GKS BUG  *JD* 5.91
* ----        close (aux_lun)
	   end if						!11.6.89 JD

	   call open_metafile					!11.6.89 JD
	   call gacwk (meta_wsid)				!11.6.89 JD
#ifndef xgks
	   call meta_version					!2.24.93
#endif
	   IF (.NOT. meta_batch) meta_actv = .true.					!11.6.89 JD
	   meta_clsplt = .false.				!1.25.90 JD
	end if							!11.6.89 JD
10      if (meta_actv.OR. meta_batch) then ! Put both following stmts in if section
           first_meta = .false.                                 !12.1.89 JD
           vpt_was_set = ppl_viewports_active                   !12.1.89 JD
        end if              ! to fix viewport metafile bug 11.4.93
	IF(.NOT.SOVER .AND. .NOT.PLTOPN)CALL SIZE(WIDTH,HEIGHT)
#ifdef unix
*       call flush(lttout)
#endif
***********************************************
* TMAP check that output window is active
	IF ( PPL_in_FERRET ) CALL CK_GKS_ACTIVE( *4999 )
***********************************************
	CALL OPNDEV(TERMF,CLEAR)
***********************************************
* TMAP addition to turn on segment
	IF ( PPL_in_FERRET ) CALL SEG_ON( )                              
***********************************************
	CALL COLOR(IPEN(0))

	IF (MAKEP .EQ. 'PLOT'. AND.ribbon_on) MAKEP = 'RIBPLOT'
	IF(.NOT.SOVER)THEN
	    is_ribbon = MAKEP.EQ.'RIBPLOT'
	    CALL SETAX(X,NXS,XF,YF,XL,YL,XH,YH,NMX,NMY,XTI,XTL,is_ribbon)

	    DRAW = .TRUE.
	    IF (makep.EQ.'FILL' .OR. makep.EQ.'SHADE' .OR. 
     .          makep.EQ.'POLYGON' .OR. makep.EQ.'FILLPOL') DRAW = .FALSE.

	    IF (ABS(XF) .GT. CMZGE .OR. ABS(YF) .GT. CMZGE) GOTO 3333  ! fill/contour but 1 grid point
	    CALL DAXIS(XF,YF,NMX,NMY,DRAW)

		XLPLOT=DBLE(XL) 
		XHPLOT=DBLE(XH)
		YLPLOT=DBLE(YL)
		YHPLOT=DBLE(YH)

		call trans (0,xmin,ymin,xtm,ytm)
		call trans (0,xmax,ymax,xtx,ytx)

		XLPLOT=(DBLE(xtm)-DBLE(XLO) )*DBLE(XF) 
		XHPLOT=DBLE(XLEN)+(DBLE(xtx)-DBLE(XHI) )*DBLE(XF)
		YLPLOT=(DBLE(ytm)-DBLE(YLO) )*DBLE(YF)
		YHPLOT=DBLE(YLEN)+(DBLE(ytx)-DBLE(YHI) )*DBLE(YF)

	    IF ( interrupted ) GOTO 3333		! 1/89 - *sh*
	    IF (ITFLG.EQ.1) THEN
	       TLOX_save = XLO
	       THIX_save = XHI
	    ENDIF
	    IF(ITFLG.EQ.-1 .OR. ITFLG.EQ.2) THEN
	       TLOY_save = YLO
	       THIY_save = YHI
	    ENDIF
	ELSE
	    IF(ITFLG.NE.0)THEN
	        ! Handle time as in setax for short-time axes
		! Round off to the nearest minute 
	        IF (is_hours_axis .GT. 0) CALL FIXTIM (ITMIN,ITMAX,IT1,IT2,4)
		TLO = 1. - DIFF(IT1,ITSTRT)/DT
	        THI=TLO+DIFF(IT1,IT2)/DT
		IF (is_hours_axis .GT. 0) THEN
		   IF (ITFLG.EQ. 1) THEN
		      tlo = TLOX_save
		      thi = THIX_save
		   ENDIF
		   IF (ITFLG.EQ.-1 .OR. ITFLG.EQ.2) THEN
		      tlo = TLOY_save
		      thi = THIY_save
		   ENDIF
		ENDIF
	    ENDIF
	    IF(ITFLG.EQ.1 .OR. ITFLG.EQ.2)THEN
		XTI=XHI
		XTL=XLO
		XHI=THI
		XLO=TLO
		IF (contr) CALL CHECK_T_SCALE ('X', xlo, xhi)
	    ELSE IF(ITFLG.EQ.-1 .OR. ITFLG.EQ.2)THEN
		YTI=YHI
		YTL=YLO
		YHI=THI
		YLO=TLO
		IF (contr) CALL CHECK_T_SCALE ('Y', ylo, yhi)
	    ENDIF
	    IF(CONTR)THEN
		call trans (0,xmin,ymin,xtm,ytm)
		call trans (0,xmax,ymax,xtx,ytx)

		XLPLOT=(DBLE(xtm)-DBLE(XLO) )*DBLE(XF) 
		XHPLOT=DBLE(XLEN)+(DBLE(xtx)-DBLE(XHI) )*DBLE(XF)
		YLPLOT=(DBLE(ytm)-DBLE(YLO) )*DBLE(YF)
		YHPLOT=DBLE(YLEN)+(DBLE(ytx)-DBLE(YHI) )*DBLE(YF)

	    ENDIF
	ENDIF

C	DRAW AXIS AND LABELS
C	DO PLOTTING
C
	IF(IWIND.GT.0)CALL WINDOW(XLO,YLO,XHI,YHI)
C
	IF(MAKEP.EQ.'CONTOUR'.or.makep.eq.'FILL'.or.
     *     makep.eq.'PIXEL')THEN
	    IF(JTYPE.EQ.-1.AND.ivcomp.eq.2) then
	   	IVLOC=NX*NY+1
	    ELSE IF(JTYPE.EQ.-2.AND.ivcomp.eq.2) then
		IVLOC=NX*NY+NX+NY+1
	    ELSE
		IVLOC=1
	    ENDIF
	    CALL PLOTZ(X(IVLOC),XF,YF,XLPLOT,YLPLOT,XHPLOT,YHPLOT)

C  Call WINDOW to restore values of XMIN, XMAX, YMIN, YMAX. 

	    IF(MAKEP.EQ.'FILL') THEN
               IF(IWIND.GT.0)CALL WINDOW(XLO,YLO,XHI,YHI)
            ENDIF

	ELSE IF(MAKEP.EQ.'PLOT') THEN
	   IPV = 0
	   CALL PLOTXY(X,NXS,XF,YF,IPV)
	   if (interrupted) go to 3333

****    JD * ALINE CALL 
	   CALL WINDOW(0.,0.,0.,0.)
C
	    do 100 a_line = 1,lnum
		if (.not. aline_on(a_line)) goto 100

		if (aline_user(a_line)) then
		   minx = aline_minx(a_line)
		   miny = aline_miny(a_line)
		   maxx = aline_maxx(a_line)
		   maxy = aline_maxy(a_line)
		else
		   call point_convert (aline_minx(a_line),aline_miny(a_line),
     .		   minx,miny)
		   call point_convert (aline_maxx(a_line),aline_maxy(a_line),
     .		   maxx,maxy)
		end if

***  ACM 12/02 For lines which are plotted with symbols, plot a 
***            key having 3 points.

C		call aline_sub (x,nxs,a_line,minx,miny,maxx,maxy)
		call line_key (x,nxs,a_line,minx,miny,maxx,maxy)
		IF ( interrupted ) GOTO 3333 !*jd* 8.3.92
100	    continue

	   
* See ticket 2565, shifted lbels on time overlay plots
	   IF(SOVER) THEN 
	     IF (ITFLG.EQ.1 .OR. ITFLG.EQ.2) THEN
	      XHI = XTI
	      XLO = XTL
	     ELSEIF (ITFLG.EQ.-1 .OR. ITFLG.EQ.-2) THEN
	      YHI = YTI
	      YLO = YTL
	     ENDIF
	   ENDIF


****

	ELSE IF(MAKEP.EQ.'RIBPLOT') THEN
	   CALL PLOTXY_RIBBON(X,NXS,XF,YF)
	   IF ( interrupted ) GOTO 3333

	ELSE IF(MAKEP.EQ.'VECTOR')THEN
	    IF(JTYPE.EQ.-1)THEN
		CALL VECFLD(X(1),X(NX*NY+1),NX,NY,X(1),X(1),XF,YF)
		IF ( interrupted ) GOTO 3333 !*jd* 8.3.92
	    ELSE
		IP1=NX*NY+1
		IP2=IP1+NX
		IP3=IP2+NY
  		CALL VECFLD(X(1),X(IP3),NX,NY,X(IP1),X(IP2),XF,YF)
		IF ( interrupted ) GOTO 3333 !*jd* 8.3.92
	    ENDIF
****
C ACM Add FLOWLINE call based on VECFLD

	ELSE IF(MAKEP.EQ.'FLOW')THEN
	    IF(JTYPE.EQ.-1)THEN
		CALL FLOWLINE(X(1),X(NX*NY+1),X(2*NX*NY+1),
     .            NX,NY,X(1),X(1),XF,YF)
		IF ( interrupted ) GOTO 3333 
	    ELSE
		IP1=NX*NY+1
		IP2=IP1+NX
		IP3=IP2+NY
                IP4=2*NX*NY + 2*(NX+NY)
  		CALL FLOWLINE(X(1),X(IP3),X(IP4),NX,NY,X(IP1),
     .             X(IP2),XF,YF)
		IF ( interrupted ) GOTO 3333
	    ENDIF
        ELSE IF(MAKEP.EQ.'VELVCT')THEN
c	    CALL VELVCT(X,NXS,XF,YF)
	    IPV = 2
	    CALL PLOTXY(X,NXS,XF,YF,IPV)
		IF ( interrupted ) GOTO 3333 !*jd* 8.3.92
	ELSE IF(MAKEP.EQ.'PLOTV'.OR.MAKEP.EQ.'PLOTUV')THEN
c	    CALL PLOTV(X,NXS,XF,YF)
	    IPV=1
	    CALL PLOTXY(X,NXS,XF,YF,IPV)

		IF ( interrupted ) GOTO 3333 !*jd* 8.3.92
	ELSE IF(MAKEP.EQ.'VIEW')THEN
	    IF(JTYPE.EQ.-1.AND.ivcomp.eq.2) then
	   	IVLOC=NX*NY+1
	    ELSE IF(JTYPE.EQ.-2.AND.ivcomp.eq.2) then
		IVLOC=NX*NY+NX+NY+1
	    ELSE
		IVLOC=1
	    ENDIF
	    CALL VIEW(X(IVLOC))
		IF ( interrupted ) GOTO 3333 !*jd* 8.3.92
***************************************************
* TMAP addition for SHADE call
        else if (makep .eq. 'SHADE') then
            IF(JTYPE.EQ.-1.AND.ivcomp.eq.2) then
                IVLOC=NX*NY+1
		IP1=NX*NY+1
		IP2=IP1+NX
		IP3=IP2+NY
                IP4=2*NX*NY + 2*(NX+NY)
            ELSE IF(JTYPE.EQ.-2.AND.ivcomp.eq.2) then
                IVLOC=NX*NY+NX+NY+1
            ELSE
                IVLOC=1
                IP4=NX*NY+1
            ENDIF
            call shade(x(ivloc), x(IP4) )
	    IF ( interrupted ) GOTO 3333		! 1/89 - *sh*

***************************************************
* TMAP addition for PLOTPOL call
	ELSE IF(MAKEP.EQ.'PLOTPOL')THEN

	   STOP  'PLOTPOL not yet implemented'
c	    CALL PLOTPOL(X,NXS,XF,YF)
	    IPV=3
	    CALL PLOTXY(X,NXS,XF,YF,IPV)
	    IF ( interrupted ) GOTO 3333
***************************************************
* TMAP addition for FILLPOL call
	ELSE IF(MAKEP.EQ.'FILLPOL' .OR. MAKEP.EQ.'POLYGON')THEN
* Get the time-axis scale right. These factors account for the fact
* that the scaling is set for the range of thde polygon data but we are
* rescaling the overlay to be on the entire underlying time axis
	    fp_xfac = 1.
	    fp_yfac = 1.
	    IF (SOVER .AND. ITFLG.NE.0) THEN
	       IF  (ITFLG.EQ.1 .OR. ITFLG.EQ.2) THEN
	          fp_xfac = (THIX_save-TLOX_save)/(xhi-xlo)  ! expand range by this factor
		  XHI = THIX_save 
		  XLO = TLOX_save
	       ELSE IF (ITFLG.EQ.11 .OR. ITFLG.EQ.2) THEN
	          fp_yfac = (THIY_save-TLOY_save)/(yhi-ylo)
		  YHI = THIY_save 
		  YLO = TLOY_save
	       ENDIF
	    ENDIF
	    CALL FILLPOL(X,NXS,XF,YF,fp_xfac,fp_yfac)
	    IF ( interrupted ) GOTO 3333

	    if (sline) then
	       CALL WINDOW(0.,0.,0.,0.)
	       
*              Only one line at a time to label
	       do 200 a_line = 1,1
		  if (.not. aline_on(a_line)) goto 200
		  
		  if (aline_user(a_line)) then
		     minx = aline_minx(a_line)
		     miny = aline_miny(a_line)
		     maxx = aline_maxx(a_line)
		     maxy = aline_maxy(a_line)
		  else
		     call point_convert 
     .	               (aline_minx(a_line),aline_miny(a_line),
     .		        minx,miny)
		     call point_convert 
     .	               (aline_maxx(a_line),aline_maxy(a_line),
     .                  maxx,maxy)
		  end if
		  call aline_sub (x,nxs,a_line,minx,miny,maxx,maxy)
		  
		  IF ( interrupted ) GOTO 3333 !*jd* 8.3.92
 200	       continue
	    end if


***************************************************
	ENDIF

 3333	CONTINUE					! 1/89 - *sh*
* post-interrupt re-entry				! 1/89 - *sh*
	
* Draw the plot axes 

	did_draw = draw
	IF (.NOT.SOVER .OR. axes_on_overlay) THEN
	   IF (axes_on_overlay) lab1 = ' '
	   DRAW = .FALSE.
	   CALL DAXIS(XF,YF,NMX,NMY,DRAW)
	   DRAW = (.NOT.did_draw .OR. axes_on_overlay)
	   CALL DAXIS(XF,YF,NMX,NMY,DRAW)
	   CALL SCALE(XF,YF,XORG,YORG,XLO,YLO)
	   axes_on_overlay = .FALSE.
	ENDIF
	
	IF (SOVER) lab1 = ' '
C
	CALL WINDOW(0.,0.,0.,0.)
C
C Put movable labels on
	IF ( .NOT.interrupted ) CALL DAXIS2(XF,YF,NMX,NMY) ! 1/89 - *sh*
	IF (SOVER) THEN
	   IF(ITFLG.EQ.1 .OR. ITFLG.EQ.2)THEN
	       XHI=XTI
	       XLO=XTL
	   ELSE IF(ITFLG.EQ.-1 .OR. ITFLG.EQ.2)THEN
	       YHI=YTI
	       YLO=YTL
	   ENDIF
	ENDIF

*************************************
* TMAP addition: close segment and possibly write "** INTERRUPTED **" on plot
	IF ( PPL_in_FERRET ) CALL SEG_OFF
	IF ( interrupted ) CALL INTERRUPT( *5000 )	! 1/89 - *sh*
 4999	RETURN
 5000	CALL SAY_INTERRUPTED
*************************************
	RETURN
	END

      SUBROUTINE SAVE_UVAR_TYPE( uvar, uvdtype, dset )
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*

* store the data type that has been determined to be correct for this
* uvar (a LET expression), when evaluated in the given dset

* V699 5/16 *sh* new routine created to avoid the 2d uvar_grid array
* V720: 6/17 *acm* Fix ticket 2547: the grid and type of uvars are stored, but the
*                  information may be collected on different calls from is_uvar_grid.

        include 'ferret.parm'
        include 'tmap_dims.parm'
        include 'xvariables.cmn'

* calling argument declarations
        INTEGER uvar, uvdtype, dset

* internal variable declarations
        INTEGER NCF_SET_UVAR_GRID,
     .          c_list_dset, context_dset, pretype, savetype,
     .          dummy_grid, status

* c_list_dset  - dset value relevant in C LIST structures of NCF_Util.c
* context_dset - dset for which grid of this uvar has been determined

        IF ( uvar_dset(uvar) .GT. pdset_irrelevant) THEN
* ... LET/D= variable
          c_list_dset  = uvar_dset(uvar) ! the dset that owns this LET/D
          context_dset = uvar_dset(uvar) ! only one dset is possible
        ELSE
* ... global LET variable
          c_list_dset  = pdset_uvars  ! fake dataset of global uvars
          context_dset = dset
        ENDIF

* We may have already stored the grid. 

	CALL GET_SAVED_UVAR_GRID ( uvar, c_list_dset, dummy_grid )

* store the grid
        status = NCF_SET_UVAR_GRID( c_list_dset, uvar,
     .                              dummy_grid, uvdtype, context_dset )

* Note that an ATOM_NOT_FOUND error is not trapped
* We should really trap it and call ERRMSG(ferr_internal)

        RETURN
        END

c*
c* ef_convert_date_string.F
c*
c* Ansley Manke * 
c* 12/2018
c*
c*
c* This routine converts a date string of the form yyyy-mm-dd hh:mm:ss to
c* the default format dd-MMM-yyyy hh:mm:ss
c*

      SUBROUTINE ef_convert_date_string(datestring, status)

      IMPLICIT NONE
      INCLUDE 'tmap_dims.parm'
      INCLUDE 'ferret.parm'
      INCLUDE 'calendar.decl'
      INCLUDE 'calendar.cmn'

* argument declarations
      INTEGER status
      CHARACTER*(*) datestring

* Internal declarations
      INTEGER infmt, outfmt, cal
      CHARACTER*30 buff

* Initialize
      infmt = pdate_numslashnum
      outfmt = pdate_vax
      cal = gregorian  ! doesn't matter just for reformatting a date

      status = 0  ! just local setting not Ferret-status code
      IF (datestring(5:5) .NE. '-' ) RETURN

      CALL TM_DATE_REFORMAT( datestring, infmt, cal, buff, outfmt, .FALSE., status)
      IF (status .EQ. 3) THEN
         status = 0
	 datestring = buff
      ENDIF

      RETURN 
      END

	SUBROUTINE XEQ_GO

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute the GO command
* GO filename	indicates that the commands in file filename are to be executed

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 4/8/86
* revision 1.0 - 4/29/87 - added ability to nest GO commmands
*			 - eliminated pretenses of batch mode
* revision 1.1 - 7/22/88 - enhanced error message for no filename given
* Unix/RISC port - change OPEN statement for Unix
* V300: 4/93 - implemented arguments to GO commands (save command string here)
*	6/93 - bug fix to arguments when filename is in quotes
* V314 8/24/94 *kob* IBM port - READONLY not allowed in open statements on
*				IBM
*			      - SHARED not allowed in open statementson IBM..
*				add an ifdef NO_OPEN_SHARED
* V320: 10/94 - added GO/HELP filename
*	12/94 - added definition of PLOT+ symbol 'GO_FILE' if PLOT+ is running
*		and the GO command is given from the keyboard
*    12/29/94 - use SPLIT_LIST to redirect tty output for GUI
* V411: 9/11/95 (IBM port) variable go_help assigned to integer expression
* V510 *sh* 3/00 -- increase allowed path name length
* V606  8/07 *acm* Send informational and error messages that are returned from 
*                  commands via SPLIT_LIST to std error rather than std out.
* V610  2/08 *acm* Always define a symbol LAST_GO_FILE with the name of the jnl script.
* V618  1/09 *acm* The last character of symbol LAST_GO_FILE was chopped off. Fix this.
* V66   *kms* 5/10 LIB_GET_LUN is a subroutine, not a function
* V687  *ACM* 3/14 for ticket 2044 write note !Enter_GO with script and arguments, only 
*                  if SET REDIRECT is turned on.
* V698 *sh* 3/16 - define GO_FILE always

! Note: A known "bug" of the 12/94 GO_FILE symbol is that the PLOT+ symbol
!	GO_FILE gets defined only **after** PLOT+ has already placed a window
!	on the screen and a GO command is executed.  This means that if the
!       GO file to create a plot contains the first command that opens
!       an output window the symbol GO_FILE will **not** be defined.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
        include 'tmap_errors.parm'
	include 'ferret.parm'
	include 'command.parm'
	include 'errmsg.parm'
	include 'plot_setup.parm'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'		! 12/94
	include 'xcontrol.cmn'
	include 'xcontrol.equiv'
	include 'xrisc.cmn'

* internal variable declarations:
	LOGICAL	go_help
	INTEGER	TM_LENSTR1,
     .		temp_lun, status, TMAP_status,
     .          file_opened, ier, ist, len_string, slen
        CHARACTER TM_INQ_PATH*2048, cbuff*2048

* internal parameter declarations
	INTEGER     slash_go_help
	PARAMETER ( slash_go_help = 0 + 1 )
	
* was /HELP given ?
	go_help = qual_given( slash_go_help ) .GT. 0	! added ".GT. 0" 9/95

* check syntax
	IF     ( num_args .EQ. 0 ) THEN
	   IF (go_help) THEN
	      CALL SPLIT_LIST(pttmode_help, err_lun,
     .			' Use the GO command to name a file of FERRET'//
     .			' commands to be executed.', 0)
	      CALL SPLIT_LIST(pttmode_help, err_lun,
     .			 '     e.g.   yes? GO filename', 0)
	      CALL SPLIT_LIST(pttmode_help, err_lun, ' ', 1)
	      CALL SPLIT_LIST(pttmode_help, err_lun,
     .			' Use "GO/HELP filename" to read documentation in '//
     .			' the file to be executed.', 0)
	      RETURN
	   ELSE
	      CALL ERRMSG( ferr_unknown_arg, status,
     .			cmnd_buff(:len_cmnd)//': What file ?', *5000 )
	   ENDIF
	ENDIF

* check path list to find the "GO" file
        cbuff = TM_INQ_PATH( cmnd_buff(arg_start(1):arg_end(1)),
     .                   'FER_GO', '.jnl', .TRUE., TMAP_status )
        IF ( TMAP_status .NE. merr_ok ) GOTO 5100

* kob 1/2006 - need this after backing out of yonghua's changes 
*get a logical unit number and open the command file
	CALL LIB_GET_LUN( temp_lun )

* display HELP lines using the "more" command on the system
	IF (go_help) THEN
	   CALL SPLIT_LIST(pttmode_help, err_lun,
     .		' Full path name: '//cbuff(:TM_LENSTR1(cbuff)), 0) 

	   CALL SYSTEM( 'more -d '//cbuff(:TM_LENSTR1(cbuff)) )
	   RETURN
	ENDIF

* OPEN the file in preparation for reading commands from it
	OPEN(	UNIT=temp_lun,
     .		FILE=cbuff,
#ifdef READONLY_ALLOWED
     .		READONLY,
#endif
#ifdef NO_OPEN_SHARED
#else
     .		SHARED,
#endif
     .		STATUS='OLD',
     .		ERR=5010 )

*  back out of yonghua's routine call because of 64bit problems *kob**     
*        my_cbuff = cbuff
*        CALL my_open(temp_lun,cbuff,LEN(cbuff),file_opened)
*        if(file_opened.EQ.0) goto 5010
* inform the control stack that it has taken control at a new level
	CALL STACK_PTR_UP( csp, cs_max, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	cs_in_control = .TRUE.
	cs_cmnd_num( csp ) = cmnd_go
	cs_lun( csp ) = temp_lun
	cmnd_lun = temp_lun
	input_source = input_from_file

* GO line will be parsed by DOLLAR_ARG - un-do parsing of PARSE_COMMAND
	CALL ALL_1_ARG
	cs_text( csp ) = cmnd_buff(arg_start(1):arg_end(1))
	
* ... Write note with script and arguments, only if SET REDIRECT is turned on.
        IF (redirect_stdout_flags .NE. redirect_none) THEN
	   risc_buff = '! Enter_GO '//cs_text(csp)(:TM_LENSTR1(cs_text(csp)) )
	   slen = 0
	   CALL SPLIT_LIST(pttmode_explct, ttout_lun, risc_buff, slen)
	ENDIF

	ier = 0
	ist = 0
	len_string = TM_LENSTR1( cbuff )

* define the symbol 'GO_FILE' -- it will always refer to the GO file currently
* in control.  Resets when the current script ends.
	cs_go_filename( csp) = cbuff   ! save the name to pop back later
	CALL SETSYM ('GO_FILE '//cbuff, 8+len_string, 
     .                 ier, ist)

* define the symbol 'LAST_GO_FILE' no matter what... -- it will refer to the
* last GO file that has been initiated.  When a GO file is initiated from
* within another and then comes to an end, LAST_GO_FILE will no longer be the
* one that is currently in control
	CALL SETSYM ('LAST_GO_FILE '//cbuff, 13+len_string, 
     .                 ier, ist)

* successful completion
	RETURN

* error exits
 5000	RETURN
 5010	CALL ERRMSG( ferr_erreq, status,
     .		cmnd_buff(arg_start(1):arg_end(1)), *5000)
 5100	CALL ERRMSG( ferr_TMAP_error, status, ' ', *5000)
 5200	CALL ERRMSG( ferr_out_of_range, status, 'GO/HELP=#-of_lines',
     .		*5000)
	END

*
*  scat2gridgauss_xy_v0
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE.
*
* Ansley Manke
* July 28 1998
*  revised 2/00 to use work arrays
* June 2000 ACM pass 4 gridding arguments:  y and z radius of influence,
*               and cutoff.
c V62 *ACM* 2/2009 Call gausswt2_v0, with the original treatment of the
c            cutoff parameter, for backwards compatibility.
*
* Nov 13, 2000 1) Allow modulo axes: if modulo take points from other end
*                 to use in gridding each end
*              2) Check that the scattered points are listed on the I,J,or
*                 K axis only, as they may be functions of time.
*  (12/1/2000) 3) If the destination axis is modulo, treat the scattered
*                 points as modulo too.
*
*   12/7/2000  Add error checking on gridding parameters
*              X and Y scattered points are 1-D lists on any axis.
*
*    5/2001    Let variable,  be a function of Z and/or T
* v5.41 5/02   Fix bug (typo); Gridding to modulo X axis wasnt done.

*  11/12/2002  Remove option 2) above: the spatial location of the scattered points
*              is a 1-D list.

* Returns variable interpolated onto an equally-spaced X-Y grid.
* Input is scattered triples: (x, y, variable) , f may be function of time, z
* Output is gridded data in x, y and time.  Calls routine "gausswt2_v0".
*

*
* In this subroutine we provide information about
* the function.  The user configurable information
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
*
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result
*


      SUBROUTINE  scat2gridgauss_xy_v0_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id, 'Use Gaussian v0 weighting to grid ' //
     .                     'scattered data to an XY grid.')
      CALL ef_set_num_args(id, 9)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 4)

* XY grid is determined by arguments 4 and 5, the result's x and y axes.

      arg = 1
      CALL ef_set_arg_name(id, arg, 'XPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'X coordinates of scattered XY locations')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'YPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'Y coordinates of scattered XY locations')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'F')
      CALL ef_set_arg_desc(id, arg,
     .        'variable at scattered XY locations. ' //
     .        'May also be fcn of Z,T,E,F')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, YES, YES, YES, YES)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'XAXPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'X axis coordinates of a regular output grid')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, NO, NO, NO, NO, NO)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'YAXPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'Y axis coordinates of a regular output grid')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, YES, NO, NO, NO, NO)

      arg = 6
      CALL ef_set_arg_name(id, arg, 'XSCALE')
      CALL ef_set_arg_desc(id, arg,
     .  'Mapping scale in X direction, in data units (e.g. km or lon)')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 7
      CALL ef_set_arg_name(id, arg, 'YSCALE')
      CALL ef_set_arg_desc(id, arg,
     .  'Mapping scale in Y direction, in data units (e.g. km or lat)')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 8
      CALL ef_set_arg_name(id, arg, 'CUTOFF')
      CALL ef_set_arg_desc(id, arg,
     .        'Weight cutoff: use pts within cutoff*scale')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 9
      CALL ef_set_arg_name(id, arg, '0')
      CALL ef_set_arg_desc(id, arg,
     .        'Not used; included for backwards compatibility')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE scat2gridgauss_xy_v0_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER nxout, nyout, nx2, ny2

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nxout = 1 + arg_hi_ss(X_AXIS,ARG4) - arg_lo_ss(X_AXIS,ARG4)
      nyout = 1 + arg_hi_ss(Y_AXIS,ARG5) - arg_lo_ss(Y_AXIS,ARG5)

      nx2 = nxout * 2
      ny2 = nyout * 2

* xax  output x axis
      CALL ef_set_work_array_dims_6d(id, 1,
     .                                1, 1, 1, 1, 1, 1,
     .                              nx2, 1, 1, 1, 1, 1)

* yax  output y axis
      CALL ef_set_work_array_dims_6d(id, 2,
     .                                1, 1, 1, 1, 1, 1,
     .                              ny2, 1, 1, 1, 1, 1)

* grid  work array - gridded data.
      CALL ef_set_work_array_dims_6d(id, 3,
     .                                1,     1, 1, 1, 1, 1,
     .                            nxout, nyout, 1, 1, 1, 1)

* wate - weights.
      CALL ef_set_work_array_dims_6d(id, 4,
     .                                1,     1, 1, 1, 1, 1,
     .                            nxout, nyout, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*

      SUBROUTINE scat2gridgauss_xy_v0_compute(id, arg_1, arg_2, arg_3,
     .                           arg_4, arg_5, arg_6, arg_7, arg_8,
     .                           arg_9, result, xax, yax, grid, wate)

*  arg_1  xpts \
*  arg_2  ypts  > Scattered x,y,variable,  triples to be gridded.
*  arg_3  variable, /    variable, can be fcn of z, t, e, f
*  arg_4  xaxis of new grid
*  arg_5  yaxis of new grid
*  arg_6  interpolation parameter   xscale
*  arg_7  interpolation parameter   yscale
*  arg_8  interpolation parameter   cutoff
*  arg_9  not used

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz,
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz,
     .           mem4lot:mem4hit, mem4loe:mem4hie, mem4lof:mem4hif)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz,
     .           mem5lot:mem5hit, mem5loe:mem5hie, mem5lof:mem5hif)
      REAL arg_6(mem6lox:mem6hix, mem6loy:mem6hiy, mem6loz:mem6hiz,
     .           mem6lot:mem6hit, mem6loe:mem6hie, mem6lof:mem6hif)
      REAL arg_7(mem7lox:mem7hix, mem7loy:mem7hiy, mem7loz:mem7hiz,
     .           mem7lot:mem7hit, mem7loe:mem7hie, mem7lof:mem7hif)
      REAL arg_8(mem8lox:mem8hix, mem8loy:mem8hiy, mem8loz:mem8hiz,
     .           mem8lot:mem8hit, mem8loe:mem8hie, mem8lof:mem8hif)
      REAL arg_9(mem9lox:mem9hix, mem9loy:mem9hiy, mem9loz:mem9hiz,
     .           mem9lot:mem9hit, mem9loe:mem9hie, mem9lof:mem9hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* Ignore the unused final dimensions in the work arrays since
* Fortran is column major
      REAL*8 xax(wrk1lox:wrk1hix/2)
      REAL*8 yax(wrk2lox:wrk2hix/2)
      REAL grid(wrk3lox:wrk3hix, wrk3loy:wrk3hiy)
      REAL wate(wrk4lox:wrk4hix, wrk4loy:wrk4hiy)

* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable''s axes.

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l, m, n
      INTEGER idx, lo_ss, hi_ss
      INTEGER nxpts, nypts, nscat
      INTEGER nx, ny, nt
      INTEGER i3, j3, k3, l3, m3, n3
      INTEGER xlo, xhi, ylo, yhi
      REAL x1, y1, t1, xf, yf, tf
      REAL xx, yy, tt
      REAL xsc, ysc, tsc
      REAL cutoff
      REAL val
      REAL dx, dy, xcut, ycut, xxbeg, xxend, yybeg, yyend
      INTEGER iwflag
      CHARACTER*250 errtxt

C  variables for checking axis characteristics (modulo axes)
      CHARACTER ax_name(6)*16, ax_units(6)*16
      LOGICAL backward(6), mdulo(6), regular(6)
      LOGICAL modulox, moduloy
      REAL*8 modxlen, modylen

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*  Check to see if output axes are regular, and get modulo characteristics
      CALL ef_get_axis_info_6d(id, ARG4, ax_name, ax_units,
     .                         backward, mdulo, regular)
      IF ( .NOT. regular(X_AXIS) ) THEN
         errtxt = 'Output axes must be REGULARLY spaced'
         GOTO 999
      ENDIF
      modulox = mdulo(X_AXIS)
      IF ( modulox ) THEN
         CALL ef_get_axis_modulo_len(id, ARG4, X_AXIS, modxlen)
      ENDIF

      CALL ef_get_axis_info_6d(id, ARG5, ax_name, ax_units,
     .                         backward, mdulo, regular)
      IF ( .NOT. regular(Y_AXIS) ) THEN
         errtxt = 'Output axes must be REGULARLY spaced'
         GOTO 999
      ENDIF
      moduloy = mdulo(Y_AXIS)
      IF ( moduloy ) THEN
         CALL ef_get_axis_modulo_len(id, ARG5, Y_AXIS, modylen)
      ENDIF

*  Find number of points in scattered input points.  1-D arrays defining the
*  scattered data points may lie on the X, Y, Z, T, E, or F axis of the input
*  arguments.
*  Using as flattened arrays, so consider all axes.

      nxpts = 0
      DO 10 idx = X_AXIS, F_AXIS
         lo_ss = arg_lo_ss(idx,ARG1)
         hi_ss = arg_hi_ss(idx,ARG1)
         IF ( lo_ss .NE. ef_unspecified_int4 ) THEN
            IF ( nxpts .NE. 0 ) THEN
               nxpts = nxpts * (hi_ss - lo_ss + 1)
            ELSE
               nxpts = hi_ss - lo_ss + 1
            ENDIF
         ENDIF
  10  CONTINUE

      nypts = 0
      DO 20 idx = X_AXIS, F_AXIS
         lo_ss = arg_lo_ss(idx,ARG2)
         hi_ss = arg_hi_ss(idx,ARG2)
         IF ( lo_ss .NE. ef_unspecified_int4 ) THEN
            IF ( nypts .NE. 0 ) THEN
               nypts = nypts * (hi_ss - lo_ss + 1)
            ELSE
               nypts = hi_ss - lo_ss + 1
            ENDIF
         ENDIF
  20  CONTINUE

      IF ( nxpts .NE. nypts ) THEN
         WRITE (errtxt,90) ' XPTS,', ' YPTS ', nxpts, nypts
         GOTO 999
      ENDIF

* Verify the number of values given in ARG3 makes sense
      xlo = arg_lo_ss(X_AXIS,ARG3)
      xhi = arg_hi_ss(X_AXIS,ARG3)
      ylo = arg_lo_ss(Y_AXIS,ARG3)
      yhi = arg_hi_ss(Y_AXIS,ARG3)

      IF ( (xhi .GT. xlo) .AND. (yhi .GT. ylo) ) THEN
         errtxt = 'F() data values defined on both X and Y axis'
         GOTO 999
      ELSE IF ( xhi .GT. xlo ) THEN
         nscat = xhi - xlo + 1
         IF ( nxpts .NE. nscat ) THEN
            WRITE (errtxt,90) ' XPTS,', ' F(X) ', nxpts, nscat
            GOTO 999
         ENDIF
      ELSE IF ( yhi .GT. ylo ) THEN
         nscat = yhi - ylo + 1
         IF ( nxpts .NE. nscat ) THEN
            WRITE (errtxt,90) ' XPTS,', ' F(Y) ', nxpts, nscat
            GOTO 999
         ENDIF
      ELSE IF ( (xlo .NE. ef_unspecified_int4) .OR.
     .          (ylo .NE. ef_unspecified_int4) ) THEN
         nscat = 1
         IF ( nxpts .NE. nscat ) THEN
            WRITE (errtxt,90) ' XPTS,', ' F()  ', nxpts, nscat
            GOTO 999
         ENDIF
      ELSE
         errtxt = 'No data in scattered x, y points.  ' //
     .            'F() data values must be defined on X or Y axis.'
         GOTO 999
      ENDIF
  90  FORMAT('Input scattered', 2A6, 'have different # of points', 2I8)

*  Compute number of points in output axes.

      lo_ss = arg_lo_ss(X_AXIS,ARG4)
      hi_ss = arg_hi_ss(X_AXIS,ARG4)
*  Check that xax is an X axis
      IF ( lo_ss .EQ. ef_unspecified_int4 ) THEN
         errtxt = 'Fourth argument must be an X axis'
         GO TO 999
      ENDIF
      nx = hi_ss - lo_ss + 1

      lo_ss = arg_lo_ss(Y_AXIS,ARG5)
      hi_ss = arg_hi_ss(Y_AXIS,ARG5)
*  Check that yax a Y axis
      IF ( lo_ss .EQ. ef_unspecified_int4 ) THEN
         errtxt = 'Fifth argument must be a Y axis'
         GO TO 999
      ENDIF
      ny = hi_ss - lo_ss + 1

C  Get coordinates of output axes.

      CALL ef_get_coordinates(id, ARG4, X_AXIS, arg_lo_ss(X_AXIS, ARG4),
     .                        arg_hi_ss(X_AXIS, ARG4), xax)

      CALL ef_get_coordinates(id, ARG5, Y_AXIS, arg_lo_ss(Y_AXIS, ARG5),
     .                        arg_hi_ss(Y_AXIS, ARG5), yax)

*  Set start and end for output axes.

      x1 = xax(1)
      y1 = yax(1)

      xf = xax(nx)
      yf = yax(ny)

*  Time parameters for subroutine gausswt.  Calling with 1 time.

      nt = 1
      tt = 1.
      t1 = 1.
      tf = 1.
      tsc = 1.

*  iwflag=1 for time wrapping; 0 for no wrapping

      iwflag = 0

*  Get interpolation parameters: mapping scales (data units)

      xsc = arg_6(arg_lo_ss(X_AXIS,ARG6), arg_lo_ss(Y_AXIS,ARG6),
     .            arg_lo_ss(Z_AXIS,ARG6), arg_lo_ss(T_AXIS,ARG6),
     .            arg_lo_ss(E_AXIS,ARG6), arg_lo_ss(F_AXIS,ARG6))
      IF ( xsc .LE. 0. ) THEN
         errtxt = 'X mapping scale parameter must be positive'
         GOTO 999
      ENDIF

      ysc = arg_7(arg_lo_ss(X_AXIS,ARG7), arg_lo_ss(Y_AXIS,ARG7),
     .            arg_lo_ss(Z_AXIS,ARG7), arg_lo_ss(T_AXIS,ARG7),
     .            arg_lo_ss(E_AXIS,ARG7), arg_lo_ss(F_AXIS,ARG7))
      IF ( tsc .LE. 0. ) THEN
         errtxt = 'Y mapping scale parameter must be positive'
         GOTO 999
      ENDIF

*  And cutoff parameter:

      cutoff = arg_8(arg_lo_ss(X_AXIS,ARG8), arg_lo_ss(Y_AXIS,ARG8),
     .               arg_lo_ss(Z_AXIS,ARG8), arg_lo_ss(T_AXIS,ARG8),
     .               arg_lo_ss(E_AXIS,ARG8), arg_lo_ss(F_AXIS,ARG8))

      IF ( cutoff .LE. 0. ) THEN
         errtxt = 'Cutoff parameter must be positive'
         GOTO 999
      ENDIF

*  Compute result at each Z, T, E, F

      n3 = arg_lo_ss(F_AXIS,ARG3)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

      m3 = arg_lo_ss(E_AXIS,ARG3)
      DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

      l3 = arg_lo_ss(T_AXIS,ARG3)
      DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

      k3 = arg_lo_ss(Z_AXIS,ARG3)
      DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

*  Initialize sums of values and weights.

         DO j3 = 1, ny
            DO i3 = 1, nx
               grid(i3,j3) = 0.
            ENDDO
         ENDDO

         DO j3 = 1, ny
            DO i3 = 1, nx
               wate(i3,j3) = 0.
            ENDDO
         ENDDO

*  Loop over x and y, compute the weighted sums for gaussian-weighted mapping
*  onto the grid.  Args 1-2 may be on the X,Y,Z,T,E or F axis of ARG1 and
*  ARG2, sending them to a subroutine collapses the extra dimensions so the
*  value can be found.

         DO 700 idx = 1, nscat

            CALL pickout2(arg_1, arg_2, idx, xx, yy)
            IF ( xhi .GT. xlo ) THEN
               i3 = xlo + idx - 1
               j3 = ylo
            ELSE
               i3 = xlo
               j3 = ylo + idx - 1
            ENDIF
            val = arg_3(i3,j3,k3,l3,m3,n3)

            IF (  xx .EQ. bad_flag(ARG1) .OR.
     .            yy .EQ. bad_flag(ARG2) .AND.
     .           val .EQ. bad_flag(ARG3) ) GOTO 700

*  If an output axis is modulo, apply modulo adjustment to that coordinate
*  of the scattered point.
            IF ( modulox ) THEN
               CALL modscat(xax(1), xax(nx), modxlen, 1, xx)
            ENDIF
            IF ( moduloy ) THEN
               CALL modscat(yax(1), yax(ny), modylen, 1, yy)
            ENDIF

            CALL gausswt2_v0(xx, yy, tt, val, grid, wate, nx,
     .                    ny, nt, x1, y1, t1, xf, yf, tf, xsc,
     .                    ysc, tsc, cutoff, iwflag, nx, ny)

C ACM modulo 11/9/00  Put points within cutoff of the end just beyond the
C                     other end, and use in the gridding computation.

            IF ( modulox ) THEN
               dx = xf - x1
               IF (nx .GT. 1) dx = (xf-x1)/real(nx-1)  ! gridbox size in data units
               xcut = cutoff*xsc/dx                    ! cutoff scaled to grid units

               IF ( (xx-x1 .GE. 0.) .AND. (xx-x1 .LT. xcut) ) THEN
                  xxend = xf + (xx-x1)
                  CALL gausswt2_v0(xxend, yy, tt, val, grid, wate, nx,
     .                          ny, nt, x1, y1, t1, xf, yf, tf, xsc,
     .                          ysc, tsc, cutoff, iwflag, nx, ny)
               ENDIF

               IF ( (xf-xx .GE. 0.) .AND. (xf-xx .LT. xcut) ) THEN
                  xxbeg = x1 - (xf-xx)
                  CALL gausswt2_v0(xxbeg, yy, tt, val, grid, wate, nx,
     .                          ny, nt, x1, y1, t1, xf, yf, tf, xsc,
     .                          ysc, tsc, cutoff, iwflag, nx, ny)
               ENDIF
            ENDIF

            IF ( moduloy ) THEN
               dy = yf - y1
               IF (ny .GT. 1) dy = (yf-y1)/real(ny-1)  ! gridbox size in data units
               ycut = cutoff*ysc/dy                    ! cutoff scaled to grid units

               IF ( (yy-y1 .GE. 0.) .AND. (yy-y1 .LT. ycut) ) THEN
                  yyend = yf + (yy-y1)
                  CALL gausswt2_v0(xx, yyend, tt, val, grid, wate, nx,
     .                          ny, nt, x1, y1, t1, xf, yf, tf, xsc,
     .                          ysc, tsc, cutoff, iwflag, nx, ny)
               ENDIF

               IF ( (yf-yy .LT. 0.) .AND. (yf-yy .LT. ycut) ) THEN
                  yybeg = y1 - (yf-yy)
                  CALL gausswt2_v0(xx, yybeg, tt, val, grid, wate, nx,
     .                          ny, nt, x1, y1, t1, xf, yf, tf, xsc,
     .                          ysc, tsc, cutoff, iwflag, nx, ny)
               ENDIF
            ENDIF

 700     CONTINUE

*  Put gridded fcn into result variable, dividing by summed weights. (as in
*  gaussfin, but indices needn't start at 1)

         j3 = 1
         DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            i3 = 1
            DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

               IF ( wate(i3,j3) .GT. 0. ) THEN
                  result(i,j,k,l,m,n) = grid(i3,j3) / wate(i3,j3)
               ELSE
                  result(i,j,k,l,m,n) = bad_flag_result
               ENDIF

               i3 = i3 + 1
 100        CONTINUE

            j3 = j3 + 1
 200     CONTINUE

         k3 = k3 + arg_incr(Z_AXIS,ARG3)
 300  CONTINUE

         l3 = l3 + arg_incr(T_AXIS,ARG3)
 400  CONTINUE

         m3 = m3 + arg_incr(E_AXIS,ARG3)
 500  CONTINUE

         n3 = n3 + arg_incr(F_AXIS,ARG3)
 600  CONTINUE

      RETURN

 999  CALL EF_BAIL_OUT(id, errtxt)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN
      END

*
*  scat2grid_nobs_xy
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE.
*
* Ansley Manke
* February 9, 2005 from scat2gridgauss_xy

* Returns # observations in each grid cell when a variable is interpolated
* onto an equally-spaced X-Y grid.  Input is scattered locations xpts, ypts
* and the desired result grid. Output is # observations in each grid cell
* when data is gridded in x and y.  Calls routine "nobs" based on Billy
* Kessler's gaussmap-subs.
*
*
* In this subroutine we provide information about
* the function.  The user configurable information
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
*
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result
*


      SUBROUTINE  scat2grid_nobs_xy_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .        'Count observations when gridding scattered ' //
     .        'data to XY grid using Gaussian function')
      CALL ef_set_num_args(id, 4)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                NORMAL,          NORMAL,
     .                                NORMAL,          NORMAL)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 3)

* Output grid is determined by arguments 3 and 4, the result's x and y axes.

      arg = 1
      CALL ef_set_arg_name(id, arg, 'XPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'X coordinates of scattered XY locations')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'YPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'Y coordinates of scattered XY locations')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'XAXPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'X axis coordinates of a regular output grid')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, NO, NO, NO, NO, NO)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'YAXPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'Y axis coordinates of a regular output grid')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, YES, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE scat2grid_nobs_xy_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER nxout, nyout, nx2, ny2

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nxout = 1 + arg_hi_ss(X_AXIS,ARG3) - arg_lo_ss(X_AXIS,ARG3)
      nyout = 1 + arg_hi_ss(Y_AXIS,ARG4) - arg_lo_ss(Y_AXIS,ARG4)

      nx2 = nxout * 2
      ny2 = nyout * 2

* xax  output x axis
      CALL ef_set_work_array_dims_6d(id, 1,
     .                                1, 1, 1, 1, 1, 1,
     .                              nx2, 1, 1, 1, 1, 1)

* yax  output y axis
      CALL ef_set_work_array_dims_6d(id, 2,
     .                                1, 1, 1, 1, 1, 1,
     .                              ny2, 1, 1, 1, 1, 1)

* obs  work array - counts of observations
      CALL ef_set_work_array_dims_6d(id, 3,
     .                                1,     1, 1, 1, 1, 1,
     .                            nxout, nyout, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*

      SUBROUTINE scat2grid_nobs_xy_compute(id, arg_1, arg_2, arg_3,
     .                                  arg_4, result, xax, yax, obs)

*  arg_1  xpts  \  Scattered x,y pairs to be gridded.
*  arg_2  ypts  /
*  arg_3  xaxis of new grid
*  arg_4  yaxis of new grid

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz,
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz,
     .           mem4lot:mem4hit, mem4loe:mem4hie, mem4lof:mem4hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* Ignore the unused final dimensions in the work arrays since
* Fortran is column major
      REAL*8 xax(wrk1lox:wrk1hix/2)
      REAL*8 yax(wrk2lox:wrk2hix/2)
      REAL obs(wrk3lox:wrk3hix, wrk3loy:wrk3hiy)

* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable''s axes.

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l, m, n
      INTEGER idx, lo_ss, hi_ss
      INTEGER nxpts, nypts, nscat
      INTEGER nx, ny
      INTEGER i1, j1
      REAL x1, y1, xf, yf
      REAL xx, yy
      REAL dx, dy, xxbeg, xxend, yybeg, yyend
      CHARACTER*250 errtxt

C  variables for checking axis characteristics (modulo axes)
      CHARACTER ax_name(6)*16, ax_units(6)*16
      LOGICAL backward(6), mdulo(6), regular(6)
      LOGICAL modulox, moduloy
      REAL*8 modxlen, modylen

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*  Check to see if output axes are regular, and get modulo characteristics
      CALL ef_get_axis_info_6d(id, ARG3, ax_name, ax_units,
     .                         backward, mdulo, regular)
      IF ( .NOT. regular(X_AXIS) ) THEN
         errtxt = 'Output axes must be REGULARLY spaced'
         GOTO 999
      ENDIF
      modulox = mdulo(X_AXIS)
      IF ( modulox ) THEN
         CALL ef_get_axis_modulo_len(id, ARG3, X_AXIS, modxlen)
      ENDIF

      CALL ef_get_axis_info_6d(id, ARG4, ax_name, ax_units,
     .                         backward, mdulo, regular)
      IF ( .NOT. regular(Y_AXIS) ) THEN
         errtxt = 'Output axes must be REGULARLY spaced'
         GOTO 999
      ENDIF
      moduloy = mdulo(Y_AXIS)
      IF ( moduloy ) THEN
         CALL ef_get_axis_modulo_len(id, ARG4, Y_AXIS, modylen)
      ENDIF

*  Find number of points in scattered input points.  1-D arrays defining the
*  scattered data points may lie on the X, Y, Z, T, E, or F axis of the input
*  arguments.
*  Using as flattened arrays, so consider all axes.

      nxpts = 0
      DO 10 idx = X_AXIS, F_AXIS
         lo_ss = arg_lo_ss(idx,ARG1)
         hi_ss = arg_hi_ss(idx,ARG1)
         IF ( lo_ss .NE. ef_unspecified_int4 ) THEN
            IF ( nxpts .NE. 0 ) THEN
               nxpts = nxpts * (hi_ss - lo_ss + 1)
            ELSE
               nxpts = hi_ss - lo_ss + 1
            ENDIF
         ENDIF
  10  CONTINUE

      nypts = 0
      DO 20 idx = X_AXIS, F_AXIS
         lo_ss = arg_lo_ss(idx,ARG2)
         hi_ss = arg_hi_ss(idx,ARG2)
         IF ( lo_ss .NE. ef_unspecified_int4 ) THEN
            IF ( nypts .NE. 0 ) THEN
               nypts = nypts * (hi_ss - lo_ss + 1)
            ELSE
               nypts = hi_ss - lo_ss + 1
            ENDIF
         ENDIF
  20  CONTINUE

      IF ( nxpts .NE. nypts ) THEN
         WRITE (errtxt,90) ' XPTS,', ' YPTS ', nxpts, nypts
         GOTO 999
      ENDIF
  90  FORMAT('Input scattered', 2A6, 'have different # of points', 2I8)

      IF ( nxpts .LE. 0 ) THEN
         errtxt = 'No data in scattered x, y points'
         GOTO 999
      ENDIF

      nscat = nxpts

*  Compute number of points in output axes.

      lo_ss = arg_lo_ss(X_AXIS,ARG3)
      hi_ss = arg_hi_ss(X_AXIS,ARG3)
*  Check that xax is an X axis
      IF ( lo_ss .EQ. ef_unspecified_int4 ) THEN
         errtxt = 'Third argument must be an X axis'
         GO TO 999
      ENDIF
      nx = hi_ss - lo_ss + 1

      lo_ss = arg_lo_ss(Y_AXIS,ARG4)
      hi_ss = arg_hi_ss(Y_AXIS,ARG4)
*  Check that yax a Y axis
      IF ( lo_ss .EQ. ef_unspecified_int4 ) THEN
         errtxt = 'Fourth argument must be a Y axis'
         GO TO 999
      ENDIF
      ny = hi_ss - lo_ss + 1

C  Get coordinates of output axes.

      CALL ef_get_coordinates(id, ARG3, X_AXIS, arg_lo_ss(X_AXIS, ARG3),
     .                        arg_hi_ss(X_AXIS, ARG3), xax)

      CALL ef_get_coordinates(id, ARG4, Y_AXIS, arg_lo_ss(Y_AXIS, ARG4),
     .                        arg_hi_ss(Y_AXIS, ARG4), yax)

*  Set start, end, and delta for output axes.

      x1 = xax(1)
      y1 = yax(1)

      xf = xax(nx)
      yf = yax(ny)

*  Gridbox sizes in data units
      dx = xf - x1
      IF ( nx .GT. 1 ) dx = (xf-x1) / REAL(nx-1)
      dy = yf - y1
      IF ( ny .GT. 1 ) dy = (yf-y1) / REAL(ny-1)

*  Compute result

*  Initialize counts.

      DO j = 1, ny
         DO i = 1, nx
            obs(i,j) = 0.
         ENDDO
      ENDDO

*  Loop over x and y, compute the number of observations for the gaussian-weighted
*  mapping onto the grid.  Lat and longitude may be on the X,Y,Z,T,E, or F axis of
*  ARG1 and ARG2, sending them to a subroutine collapses the extra dimensions so
*  the value can be found.

      DO 700 idx = 1, nscat

         CALL pickout2(arg_1, arg_2, idx, xx, yy)
         IF ( xx .EQ. bad_flag(ARG1) .OR.
     .        yy .EQ. bad_flag(ARG2) ) GOTO 700

*  If an output axis is modulo, apply modulo adjustment to that coordinate
*  of the scattered point.
         IF ( modulox ) THEN
            CALL modscat(xax(1), xax(nx), modxlen, 1, xx)
         ENDIF
         IF ( moduloy ) THEN
            CALL modscat(yax(1), yax(ny), modylen, 1, yy)
         ENDIF

         CALL nobs(xx, yy, nx, ny, x1, y1, dx, dy, xf, yf, obs)

C ACM modulo 11/9/00  Put points within dx or dy of the end just beyond the
C                     other end, and use in the gridding computation.

         IF ( modulox ) THEN
            IF ( (xx-x1 .GE. 0.) .AND. (xx-x1 .LT. dx) ) THEN
               xxend = xf + (xx-x1)
               CALL nobs(xxend, yy, nx, ny, x1, y1, dx, dy, xf, yf, obs)
            ENDIF

            IF ( (xf-xx .GE. 0.) .AND. (xf-xx .LT. dx) ) THEN
               xxbeg = x1 - (xf-xx)
               CALL nobs(xxbeg, yy, nx, ny, x1, y1, dx, dy, xf, yf, obs)
            ENDIF
         ENDIF

         IF ( moduloy ) THEN
            IF ( (yy-y1 .GE. 0.) .AND. (yy-y1 .LT. dy) ) THEN
               yyend = yf + (yy-y1)
               CALL nobs(xx, yyend, nx, ny, x1, y1, dx, dy, xf, yf, obs)
            ENDIF

            IF ( (yf-yy .LT. 0.) .AND. (yf-yy .LT. dy) ) THEN
               yybeg = y1 - (yf-yy)
               CALL nobs(xx, yybeg, nx, ny, x1, y1, dx, dy, xf, yf, obs)
            ENDIF
         ENDIF

 700  CONTINUE

*  Put gridded fcn into result variable.
*  The result is normal to the Z, T, E, and F axes
      k = res_lo_ss(Z_AXIS)
      l = res_lo_ss(T_AXIS)
      m = res_lo_ss(E_AXIS)
      n = res_lo_ss(F_AXIS)

      j1 = 1
      DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

         i1 = 1
         DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

            result(i,j,k,l,m,n) = obs(i1,j1)

            i1 = i1 + 1
 100     CONTINUE

         j1 = j1 + 1
 200  CONTINUE

      RETURN

 999  CALL EF_BAIL_OUT(id, errtxt)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END

*           rr_diff_ux.F
*
*           Rick Romea
*           Jan. 24, 2000
*
*     Zonal momemtum diffusive term :  Am u_xx
*     Units :     cm/s/s
*     MOM2 Grid:  U   
*
*******************************************************************

      SUBROUTINE RR_diff_ux_init(id)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

      CALL ef_set_desc             (id,
     .'Am(d^2u/dx^2) momentum diffusive term (cm/s^2);MOM2 U Grid')
      CALL ef_set_num_args         (id, 2)
      CALL ef_set_axis_inheritance (id, IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok     (id, NO, NO, YES, YES)

      ! Define first argument (U)

      CALL ef_set_arg_name         (id, ARG1, 'U')
      CALL ef_set_arg_desc         (id, ARG1,
     . 'Zonal velocity, on the MOM2 U Grid. ')
      CALL ef_set_arg_unit         (id, ARG1, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG1, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG1, YES, YES, YES, YES)
      CALL ef_set_axis_extend      (id, ARG1, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG1, Y_AXIS,-1,+1)

      ! Define second argument (TEMP)

      CALL ef_set_arg_name         (id, ARG2, 'TEMP')
      CALL ef_set_arg_desc         (id, ARG2,
     . 'Potential temperature, required to access MOM2 T Grid. ')
      CALL ef_set_arg_unit         (id, ARG2, 'deg-C')
      CALL ef_set_arg_type         (id, ARG2, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2, NO, NO,YES,YES)
      CALL ef_set_axis_extend      (id, ARG2, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG2, Y_AXIS,-1,+1)

      END


      SUBROUTINE RR_diff_ux_compute(id, arg_1, arg_2, result)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER        id

      REAL           bad_flag(EF_MAX_ARGS)
      REAL           bad_flag_result

      REAL           arg_1 (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .                      mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL           arg_2 (mem2lox:mem2hix, mem2loy:mem2hiy, 
     .                      mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL           result (memreslox:memreshix,memresloy:memreshiy,
     .                       memresloz:memreshiz,memreslot:memreshit)

      INTEGER        res_lo_ss (4)
      INTEGER        res_hi_ss (4)
      INTEGER        res_incr  (4)

      INTEGER        arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER        arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER        arg_incr  (4,EF_MAX_ARGS)

      INTEGER        i,  j,  k,  l
      INTEGER        i1, j1, k1, l1

      REAL*8         yU(1024)
      REAL*8         xU(1024)
      REAL*8         yT(1024)
      REAL*8         xT(1024)
      INTEGER        ilat
      INTEGER        ilon
      CHARACTER *16  ax_name(4)
      CHARACTER *16  ax_units(4)
      LOGICAL        backward(4)
      LOGICAL        modulo(4)
      LOGICAL        regular(4)

      REAL dxt, dxu, dyt
      REAL diff_fe 
      REAL csu,xjt
      INCLUDE 'rr_parameters.h'

C*********************************************************************
C
C     THIS IS THE MOM2 CODE:
C
c     dyt     = latitudinal height of "t" grid box (in cm)
c     dxt     = longitudinal width of "t" grid box at the equator (cm)
c     dxu     = longitudinal width of "u,v" grid box at the equator (cm) 
c     dyu     = latitudinal height of "u,v" grid box (cm)
C
c     dus     = yu(j) - yt(j)
c     dun     = yt(j+1) - yu(j)
c     duw     = xu(i) - xt(i)
c     due     = xt(i+1) - xu(i)
C
c     yu(j)   = latitude of the jth "u,v" point in degrees 
c     yt(j)   = latitude of the jth "t" point in degrees   
c     xt(i)   = longitude of the ith "t" point in degrees  
c     xu(i)   = longitude of the ith "u,v" point in degrees
C
c
c     csu     = cosine of "u" grid point latitude
c     csur    = reciprocal of "csu"
c     dxu     = longitudinal width of "u,v" grid box at the equator (cm) 
c     dxur    = reciprocal of "dxu"
c     dxt     = longitudinal width of "t" grid box at the equator (cm)
c     dxtr    = reciprocal of "dxt"
c
c     am      = constant lateral viscosity coeff for momentum (input)
c
C     DIFF_Ux(i,k,j)  =(diff_fe(i,k,j)-diff_fe(i-1,k,j))*csudxur(i,j)
C     csudxur(i,j)    = csur(j)*dxur(i)
C     diff_fe(i,k,j)  = am_csudxtr(i,j)*(u(i+1,k,j,n)-u(i,k,j,n))
C     am_csudxtr(i,j) = am*xjt(j)*csur(j)*dxtr(i+1)
C     xjt(j)          = 3.166*dyt(j)*dytr(50)-2.166
C
C
C*********************************************************************

      !  Statement functions

      dxt(i) = SNGL (xU(i)   - xU(i-1)) * Longitude_to_cm
      dxu(i) = SNGL (xT(i+1) - xT(i))   * Longitude_to_cm
      dyt(j) = SNGL (yU(j)   - yU(j-1)) * Latitude_to_cm
      csu(i) = cos(SNGL(yU(i)) * Degrees_to_radians) 

!      xjt(i) = 3.166*dyt(i)/dyt(50)-2.166
      xjt(i) = 3.166*dyt(i)/dyt_ref-2.166


      diff_fe(i,j,k,l,iLat,iLon) = am * xjt(iLat)/csu(iLat)/dxt(iLon)
     .                  *(arg_1(i+1,j,k,l) - arg_1(i,j,k,l))

      ! Get axis data

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags      (id, bad_flag,  bad_flag_result)
      CALL ef_get_coordinates    (id, ARG1, X_AXIS, 
     .                            arg_lo_ss(X_AXIS,ARG1),
     .                            arg_hi_ss(X_AXIS,ARG1), xU)
      CALL ef_get_coordinates    (id, ARG1, Y_AXIS, 
     .                            arg_lo_ss(Y_AXIS,ARG1),
     .                            arg_hi_ss(Y_AXIS,ARG1), yU)
      CALL ef_get_coordinates    (id, ARG2, X_AXIS, 
     .                            arg_lo_ss(X_AXIS,ARG2),
     .                            arg_hi_ss(X_AXIS,ARG2), xT)
      CALL ef_get_coordinates    (id, ARG2, Y_AXIS, 
     .                            arg_lo_ss(Y_AXIS,ARG2),
     .                            arg_hi_ss(Y_AXIS,ARG2), yT)

      ! Check axis units:  bail out if not lat and lon.

      CALL ef_get_axis_info      (id, ARG1, ax_name, ax_units, 
     .                                backward, modulo, regular) 
      IF     ( ax_units(1) .NE. 'deg'       .AND.
     .         ax_units(1) .NE. 'degrees_E'       .AND.
     .         ax_units(1) .NE. 'longitude' .AND.
     .         ax_units(1) .NE. 'Longitude' .AND. 
     .         ax_units(1) .NE. 'LONGITUDE' ) THEN
        WRITE (6,*)'Longitude axis units =', ax_units(1) 
        !CALL ef_bail_out(id,'Longitude axis must be in degrees')
      ENDIF

      IF     ( ax_units(2) .NE. 'deg'       .AND.
     .         ax_units(2) .NE. 'degrees_N'       .AND.
     .         ax_units(2) .NE. 'latitude'  .AND.
     .         ax_units(2) .NE. 'Latitude'  .AND. 
     .         ax_units(2) .NE. 'LATITUDE' ) THEN
        WRITE (6,*)'Latitude axis units =', ax_units(2) 
        !CALL ef_bail_out(id,'Latitude axis must be in degrees')
      ENDIF

      l1 = arg_lo_ss(T_AXIS,ARG1) 
      DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         k1 = arg_lo_ss(Z_AXIS,ARG1)
         DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
            ilat = 2  
            j1 = arg_lo_ss(Y_AXIS,ARG1) + 1
            DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
               iLon = 2
               i1 = arg_lo_ss(X_AXIS,ARG1) + 1
               DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

                  IF (arg_1(i1,  j1,  k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1+1,j1,  k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1-1,j1,  k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1,  j1+1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1+1,j1+1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1-1,j1+1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1,  j1-1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1+1,j1-1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1-1,j1-1,k1,l1) .EQ. bad_flag(ARG1) )THEN
                     result(i,j,k,l) = bad_flag_result
                  ELSE
                     result(i,j,k,l) =
     .                   (diff_fe(i1,j1,k1,l1,iLat,iLon) - 
     .                    diff_fe(i1-1,j1,k1,l1,iLat,iLon-1) ) 
     .                       /dxu(iLon)/csu(iLat)*sec_per_month
                  ENDIF
                  iLon = iLon + 1
                  i1 = i1 + arg_incr(X_AXIS,ARG1)
               ENDDO
               iLat = iLat + 1
               j1 = j1 + arg_incr(Y_AXIS,ARG1)
            ENDDO               
            k1 = k1 + arg_incr(Z_AXIS,ARG1)
         ENDDO
         l1 = l1 + arg_incr(T_AXIS,ARG1)
      ENDDO
      END

*
*  subtract.F
*
*  Jonathan Callahan
*  Feb 19th 1998
*
*  Returns the difference of two arguments.
*


*
*  In this subroutine we provide information about
*  the function.  The user configurable information
*  consists of the following:
*
*  descr              Text description of the function
*
*  num_args           Required number of arguments
*
*  axis_inheritance   Type of axis for the result
*                        ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                        CUSTOM          - user defined axis
*                        IMPLIED_BY_ARGS - same axis as the incoming argument
*                        NORMAL          - the result is normal to this axis
*                        ABSTRACT        - an axis which only has index values
*
*  piecemeal_ok       For memory optimization:
*                        axes where calculation may be performed piecemeal
*                        ( YES, NO )
*
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result
*


      SUBROUTINE subtract_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

      CALL ef_version_test(ef_version)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,'(demonstration function) returns: A - B' )
      CALL ef_set_num_args(id, 2)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, YES, YES, YES, YES, YES, YES)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'B')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
*  In this subroutine we compute the result
*
      SUBROUTINE subtract_compute(id, arg_1, arg_2, result)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable's axes.

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,  j,  k,  l,  m,  n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      n1 = arg_lo_ss(F_AXIS,ARG1)
      n2 = arg_lo_ss(F_AXIS,ARG2)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

       m1 = arg_lo_ss(E_AXIS,ARG1)
       m2 = arg_lo_ss(E_AXIS,ARG2)
       DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

        l1 = arg_lo_ss(T_AXIS,ARG1)
        l2 = arg_lo_ss(T_AXIS,ARG2)
        DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         k1 = arg_lo_ss(Z_AXIS,ARG1)
         k2 = arg_lo_ss(Z_AXIS,ARG2)
         DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

          j1 = arg_lo_ss(Y_AXIS,ARG1)
          j2 = arg_lo_ss(Y_AXIS,ARG2)
          DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

           i1 = arg_lo_ss(X_AXIS,ARG1)
           i2 = arg_lo_ss(X_AXIS,ARG2)
           DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

            IF ( (arg_1(i1,j1,k1,l1,m1,n2) .EQ. bad_flag(ARG1)) .OR.
     .           (arg_2(i2,j2,k2,l2,m2,n2) .EQ. bad_flag(ARG2)) ) THEN

               result(i,j,k,l,m,n) = bad_flag_result

            ELSE

               result(i,j,k,l,m,n) = arg_1(i1,j1,k1,l1,m1,n1) -
     .                               arg_2(i2,j2,k2,l2,m2,n2)

            ENDIF

            i1 = i1 + arg_incr(X_AXIS,ARG1)
            i2 = i2 + arg_incr(X_AXIS,ARG2)
 100       CONTINUE
     
           j1 = j1 + arg_incr(Y_AXIS,ARG1)
           j2 = j2 + arg_incr(Y_AXIS,ARG2)
 200      CONTINUE

          k1 = k1 + arg_incr(Z_AXIS,ARG1)
          k2 = k2 + arg_incr(Z_AXIS,ARG2)
 300     CONTINUE

         l1 = l1 + arg_incr(T_AXIS,ARG1)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
 400    CONTINUE

        m1 = m1 + arg_incr(E_AXIS,ARG1)
        m2 = m2 + arg_incr(E_AXIS,ARG2)
 500   CONTINUE

       n1 = n1 + arg_incr(F_AXIS,ARG1)
       n2 = n2 + arg_incr(F_AXIS,ARG2)
 600  CONTINUE

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END

*
* compressl.F
*
* Ansley Manke
* August 1998
*
* This function compresses data on L axis, ending with missing data.
*
*  NOTE:
*  IT IS GENERALLY ADVISABLE TO INCLUDE EXPLICIT LIMITS WHEN WORKING WITH
*  FUNCTIONS THAT REPLACE AXES. FOR EXAMPLE, THE CONSIDER THE FUNCTION
*  COMPRESSL(v). THE EXPRESSION
*  	LIST/L=6:10 COMPRESSL(v)
*  IS NOT EQUIVALENT TO
*  	LIST COMPRESSL(v[L=6:10])
*  THE FORMER WILL LIST THE 6TH THROUGH 10TH COMPRESSED INDICES FROM THE ENTIRE
*  L RANGE OF VARIABLE V. THE LATTER WILL LIST ALL OF THE INDICES THAT
*  RESULT FROM COMPRESSING v[L=6:10].
*  
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE compressl_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      CHARACTER*100 fcn_desc
      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns data, compressed along the L axis: Missing ',
     .        'points moved to the end')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 1)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, ABSTRACT)

      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'DAT')
      CALL ef_set_arg_desc(id, arg, 'variable to compress in L')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, NO)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END


*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE compressl_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER my_lo_l, my_hi_l

      INTEGER arg
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

*
*     Use utility functions to get context information about the arguments.
*

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      my_lo_l = 1
      my_hi_l = 1

      arg = 1

      my_hi_l = arg_hi_ss(T_AXIS,arg) - arg_lo_ss(T_AXIS,arg) + 1


      CALL ef_set_axis_limits(id, T_AXIS, my_lo_l, my_hi_l)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE compressl_compute(id, arg_1, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER id
      INTEGER nbad, m_indx
      INTEGER m, nsrt
      INTEGER i, j, k, l
      INTEGER i1, j1, k1, l1

*  Get subscript ranges

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      i1 = arg_lo_ss(X_AXIS, ARG1)
      DO 500 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS, ARG1)
         DO 400 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            k1 = arg_lo_ss(Z_AXIS, ARG1)
            DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               nsrt = 0
               nbad = 0

               l1 = arg_lo_ss(T_AXIS,ARG1)
               DO 100 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

                  IF (arg_1(i1,j1,k1,l1) .NE. bad_flag(1)) THEN
                     nsrt = nsrt + 1
                     result(i,j,k,nsrt) = arg_1(i1,j1,k1,l1)

                  ELSE
                     nbad = nbad + 1
                  END IF

                  l1 = l1 + arg_incr(T_AXIS,ARG1)
 100           CONTINUE
      
*
* Compress argument, putting bad data at the end.
*
               DO 200 m = 1, nbad
                  m_indx = m + nsrt
                  result(i,j,k,m_indx) = bad_flag_result
 200           CONTINUE

               k1 = k1 + arg_incr(Z_AXIS, ARG1)
 300        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS, ARG1)
 400     CONTINUE

         i1 = i1 + arg_incr(X_AXIS, ARG1)
 500  CONTINUE
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

      INTEGER FUNCTION TM_GET_CALENDAR_ID (cal_name)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
C     Return the calendar id associated with cal_name, a calendar name
C     Zero is returned if cal_name is not a valid calendar.
C     J Davison 10.99
C     V 1.0
C
C     0.00000000000000000000000000000000000000000000000000000000000000001

C 2/13/01  ACM  test for the calendar names: 
C 4/30/04       add 366_DAY, ALL_LEAP, and 365_DAY
C	"STANDARD" which is equivalent to 'GREGORIAN'
C	"COMMON_YEAR" and 365_DAY" for "NOLEAP"
C	"D360"  or "360" for "360DAY"
C	"366_DAY" for "ALL_LEAP"
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files, add disclaimer
* v744 11/2011 *acm* Issue 1906: If PROLEPTIC_GREGORIAN is given then 
*                  override mixed-gregorian calendar handling. 

      include 'calendar.decl'
      include 'calendar.cmn'

      integer         end,ndx
      character*255   test_string

      character*(*)   cal_name

*************************************************************************

C     MOVE INPUT STRING TO UPPER CASE
      call upnsquish (cal_name,test_string,end)

C  Allow STANDARD same calendar as GREGORIAN
      IF (test_string(1:3) .EQ. 'STA')  test_string = 'GREGORIAN'
      IF (test_string(1:3) .EQ. 'PRO')  test_string = 'PROLEPTIC_GREGORIAN'
      IF (test_string(1:3) .EQ. 'COM')  test_string = 'NOLEAP'
      IF (test_string(1:3) .EQ. '365')  test_string = 'NOLEAP'
      IF (test_string(1:3) .EQ. '366')  test_string = 'ALL_LEAP'
      IF (test_string(1:3) .EQ. 'D36')  test_string = '360DAY'
      IF (test_string(1:3) .EQ. '360')  test_string = '360DAY'

C     LOCATE NAME IN CALENDAR TABLE
      do 10 ndx = 1, max_calendars
         if (test_string(1:3) .eq. allowed_calendars(ndx)(1:3))
     .        goto 100
 10   end do

C     ERROR: CALENDAR NOT FOUND
      tm_get_calendar_id = 0
      goto 1000

C     CALENDAR FOUND, RETURN ID
 100  tm_get_calendar_id = ndx
 1000 return

      end

	SUBROUTINE CURV_COORD_RANGE_SUB ( uc, xfield, yfield, ilo, ihi, 
     .              jlo, jhi, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Compute the range within X and Y coordinates actually needed for the 
* hlimits and vlimits that were requested.
*
* V581:  1/2005 ACM 
* V600:  9/2005 acm Fix bug 1342, curvi data with 1-d coordinates.
*                   The loop 200 controls were wrong.
* V600:  4/2006 fix bug where if an axis is reversed (depth axis) the
*               comparisons also need to be reversed.
* V602:  2/2007 Fix bug 1485; when determining the range of indices to
*               use loop over the indices used in the projection; minss_dim1
*               minss_dim2 etc. 
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus.
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V687 *acm* 3/14 tickets 2151 and 2147: allow missing coordinate data in 3-arg 
*                 and 4-arg plot commands. 

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include	'xvariables.cmn'
	include	'xcurvilinear.cmn'

* calling argument declarations:
	INTEGER ilo, ihi, jlo, jhi, status
#ifdef double_p
	REAL*4  uc(*)
	REAL*8	xfield(xpos_loss_dim1:xpos_hiss_dim1,
     .		       xpos_loss_dim2:xpos_hiss_dim2),
     .		yfield(ypos_loss_dim1:ypos_hiss_dim1,
     .		       ypos_loss_dim2:ypos_hiss_dim2)
#else
	REAL    uc(*)
	REAL	xfield(xpos_loss_dim1:xpos_hiss_dim1,
     .		       xpos_loss_dim2:xpos_hiss_dim2),
     .		yfield(ypos_loss_dim1:ypos_hiss_dim1,
     .		       ypos_loss_dim2:ypos_hiss_dim2)
#endif

* internal variable declarations:

	LOGICAL TM_FPEQ 
	INTEGER i, j, i1, i2, j1, j2
        REAL xx, yy, up, dn

        ilo = MAX(minss_dim1, maxss_dim1)
        ihi = MIN(minss_dim1, maxss_dim1)
        
        up = MAX(uc(1), uc(2))
        dn = MIN(uc(1), uc(2))

* Loop over the indices to be used for the projection.
* For map projections, a coord field may be 1D, in which case
* set any missing indices to the unspecified-int flag.

        i1 = minss_dim1
        IF (xpos_loss_dim1 .EQ. unspecified_int4) i1 = xpos_loss_dim1
        i2 = maxss_dim1
        IF (xpos_hiss_dim1 .EQ. unspecified_int4) i2 = xpos_hiss_dim1
        j1 = minss_dim2
        IF (xpos_loss_dim2 .EQ. unspecified_int4) j1 = xpos_loss_dim2
        j2 = maxss_dim2
        IF (xpos_hiss_dim2 .EQ. unspecified_int4) j2 = xpos_hiss_dim2

        DO 100 i = i1, i2
        DO 100 j = j1, j2
           xx = xfield(i,j)
	   IF ( xx .EQ. badxcurv) THEN
c              GOTO 5100 
              GOTO 100 
           ELSE
              IF ( xx .GE. dn.AND.  xx .LE. up ) THEN
                 ilo = MIN(i,ilo)
                 ihi = MAX(i,ihi)
              ENDIF
	      IF (TM_FPEQ(xx, dn)) ilo = MIN(i,ilo)
	      IF (TM_FPEQ(xx, up)) ihi = MAX(i,ihi)
           ENDIF
  100   CONTINUE

        jlo = MAX(minss_dim2, maxss_dim2)
        jhi = MIN(minss_dim2, maxss_dim2)

        up = MAX(uc(3), uc(4))
        dn = MIN(uc(3), uc(4))

* Loop over the indices to be used for the projection.
* For map projections, a coord field may be 1D, in which case
* set any missing indices to the unspecified-int flag.

        i1 = minss_dim1
        IF (ypos_loss_dim1 .EQ. unspecified_int4) i1 = ypos_loss_dim1
        i2 = maxss_dim1
        IF (ypos_hiss_dim1 .EQ. unspecified_int4) i2 = ypos_hiss_dim1
        j1 = minss_dim2
        IF (ypos_loss_dim2 .EQ. unspecified_int4) j1 = ypos_loss_dim2
        j2 = maxss_dim2
        IF (ypos_hiss_dim2 .EQ. unspecified_int4) j2 = ypos_hiss_dim2

        DO 200 i = i1, i2
        DO 200 j = j1, j2
           yy = yfield(i,j)
	   IF ( yy .EQ. badycurv) THEN
c              GOTO 5200 
              GOTO 200 
           ELSE
              IF ( yy .GE. dn .AND. yy .LE. up ) THEN
                 jlo = MIN(j, jlo)
                 jhi = MAX(j, jhi)
              ENDIF
	      IF (TM_FPEQ(yy, dn)) jlo = MIN(j, jlo)
	      IF (TM_FPEQ(yy, up)) jhi = MAX(j, jhi)
           ENDIF
  200   CONTINUE

* successful completion
	status = ferr_ok
	RETURN

* error exit
 5000	RETURN
 5100	CALL ERRMSG( ferr_out_of_range, status,
     .		'X coordinates'//pCR//
     .		'missing value where val is needed', *5000)
 5200	CALL ERRMSG( ferr_out_of_range, status,
     .		'Y coordinates'//pCR//
     .		'missing value where val is needed', *5000)
	END 

	SUBROUTINE GET_AUTO_AUX_VARS( var, cat, dataset,
     .			              curv_vars, curv_cats )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine if curvilinear coordinates are applicable on a particular variable
* by looking for the __LayerzRef_ and __CurviRef_ attributes
* These may have been set either automatically, based upon CF 'coordinates'
* and 'formula_terms' attributes found in a netCDF file, or have been set
* manually using the SET VARIABLE/LAYERZ and /CURV commands

* inputs: var, cat, dset -- describe the variable for which we are seeking
*		auxiliary coordinates
* outputs: curv_vars, curv_cats -- the identities of the aux variables

* *sh* 12/13
* V693+ 11/14 *sh* renaming 'sigma' as 'layerz' throughout
* V7    5/16 *acm* See ticket 2352. For LET/D variables look for info under that dataset
* V710 *acm* 10/16 Ticket 2422: variables uvar_grid, uvar_data_type, uvar_aux_cat, 
*                  uvar_aux_var to be replaced with calls to LIST routines in NCF_Util.c 

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include 'xcommand.cmn'
	include 'xprog_state.cmn'
	include 'xvariables.cmn'
	include 'xdset_info.cmn_text'

* calling argument declarations
	INTEGER	 var, cat, dataset,
     .		 curv_vars(nferdims), curv_cats(nferdims)

* internal variable declarations
	LOGICAL	  NC_GET_ATTRIB, got_it
	INTEGER	  TM_LENSTR1, 
     .		  idim, dset, attlen, attoutflag, maxlen, varid, slen,
     .		  vcat, vvar, status
	INTEGER   aux_cat(nferdims), aux_var(nferdims)  !From GET_SAVED_UVAR_AUX_INFO 
	REAL	  attvals(10)   ! only if __LayerzRef_ mis-defined as numeric!
	CHARACTER VAR_CODE*128, refvarname*128, varname*128,
     .		  dsetname*128

* XXXXX TEMPORARY -- if this is a uvar need to look at inherited uvar_aux*
* as sources of curvilinear aux infor BUT will they be defined  get_grid 

* initialize
	dset = dataset
	DO idim = 1, nferdims
	   curv_vars(idim) = unspecified_int4
	   curv_cats(idim) = unspecified_int4
	ENDDO
	varname = VAR_CODE(cat, var)

* user-defined variables may be associated with inherited auxiliary variables
	IF (cat .EQ. cat_user_var) THEN
	
	   CALL GET_SAVED_UVAR_AUX_INFO(var, dataset, aux_cat, aux_var, status)
	   IF (status .EQ. ferr_ok) THEN
	      DO idim = 1, nferdims
	         IF (uvar_aux_stat(var,idim) .EQ. paux_stat_passed
     .	        .OR. uvar_aux_stat(var,idim) .EQ. paux_stat_needed ) THEN
	            curv_vars(idim) = aux_var(idim)
	            curv_cats(idim) = aux_cat(idim)
	         ENDIF
	      ENDDO
	   ENDIF  ! status from GET_SAVED_UVAR_AUX_INFO

	ENDIF  ! user_var

* get the variable ID in the linked list  (user vars stored under dset=pdset_uvars)
	IF (cat .EQ. cat_user_var) THEN
	   dset = pdset_uvars  ! signals a uvar
	   CALL CD_GET_VAR_ID (dset, varname, varid, status) 

* Check whether its a LET/D variable, stored with its dataset.
	   IF (dset.EQ.pdset_uvars .AND. status.NE.ferr_ok) THEN
	      IF (dataset .GT. pdset_irrelevant) 
     .      CALL CD_GET_VAR_ID (dataset, varname, varid, status)
              IF (status .EQ. ferr_ok) dset = dataset
	   ENDIF
	   
	ELSE
	   CALL CD_GET_VAR_ID (dset, varname, varid, status) 
	ENDIF

* get the attribute value of '__LayerzRef_' (patnam_layerz)
        maxlen = LEN(refvarname)
        got_it = NC_GET_ATTRIB ( dset, varid, patnam_layerz,
     .                           .FALSE., varname, maxlen,
     .                           attlen, attoutflag, refvarname,
     .                           attvals )
        IF (.NOT.got_it) RETURN

* Find the variable that has been named
* NOTE:  wired to do only a Z axis  at this time  XXXXXXXXXXX
        CALL FIND_VAR_NAME( dataset,
     .			    refvarname,
     .			    vcat, vvar )
	IF (vvar .EQ. munknown_var_name) THEN
* .... "Variable TEMP associated with non-existent layerz variable DEPTH"
*      "in levitus_climatology"
	   CALL GET_SHORT_DSET_NAME(dataset, dsetname, slen )
	   CALL WARN('Variable '//varname(:TM_LENSTR1(varname)) //
     .		' associated with non-existent layerz variable ' //
     .		refvarname(:TM_LENSTR1(refvarname)) // pCR //
     .		'           in ' //dsetname(:slen) )
	ELSE
	   curv_vars(z_dim) = vvar
	   curv_cats(z_dim) = vcat
	ENDIF

 5000	RETURN

* error exits

	END

*
* convolvej.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
** Ansley Manke
* Feb 1999
* V6.2 2/2009 Fix bug 1640; treatment of missing data was incorrect.
*     03/2012 *kms* Fix bug 1928 - do not exceed bounds with an even number of weights
*
* This external function convolves the component grid, com, with the weight 
* function, wt  along the J axis (see Ferret routine CONVOLVE)
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE convolvej_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CHARACTER*100 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT ('Convolve J component of variable with weight function')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 2)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'COM')
      CALL ef_set_arg_desc(id, arg, 
     .  'Variable in Y (and perhaps X,Z,T,E,F) to convolve')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'WEIGHT')
      CALL ef_set_arg_desc(id, arg, 'Weight function')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE convolvej_compute (id, arg_1, arg_2, result )

*
*
*  From FERRET subroutine CONVOLVE, for the j-axis.
*
* convolve the component grid, com, with the weight function, wt
* along axis idim
* note: the component context may not be of adequate size for the full
*       calculation.  Missing data flags will be inserted where computation is
*       impossible
* also: when bad data points are encountered in the component data all
*       result data depending on it are flagged as bad, too


      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      REAL comp, sum, weight
      INTEGER i, j, k, l, m, n, jj
      INTEGER xlen, ylen, zlen, tlen, elen, flen
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2
      INTEGER wlen, hlo, hhi

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)
      
* CONVOLVE ALONG Y AXIS (arg_1) using weights (arg_2)

* Half the weighting function; weights from -hlen to hlen (now: hlo to hhi)

      xlen = (arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1) 
      ylen = (arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) + 1) 
      zlen = (arg_hi_ss(Z_AXIS,ARG2) - arg_lo_ss(Z_AXIS,ARG2) + 1) 
      tlen = (arg_hi_ss(T_AXIS,ARG2) - arg_lo_ss(T_AXIS,ARG2) + 1) 
      elen = (arg_hi_ss(E_AXIS,ARG2) - arg_lo_ss(E_AXIS,ARG2) + 1) 
      flen = (arg_hi_ss(F_AXIS,ARG2) - arg_lo_ss(F_AXIS,ARG2) + 1) 

      wlen = MAX(xlen, ylen, zlen, tlen, elen, flen)
      hhi = wlen / 2
      hlo = (-1) * hhi
      IF ( MOD(wlen,2) .EQ. 0 ) hlo = hlo + 1

      n1 = arg_lo_ss(F_AXIS,ARG1)
      DO 700 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
       
         m1 = arg_lo_ss(E_AXIS,ARG1)
         DO 600 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
       
            l1 = arg_lo_ss(T_AXIS,ARG1)
            DO 500 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
       
               k1 = arg_lo_ss(Z_AXIS,ARG1)
               DO 400 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

                  j1 = arg_lo_ss(Y_AXIS,ARG1)
                  DO 300 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

                     i1 = arg_lo_ss(X_AXIS,ARG1)
                     DO 200 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS) 

                        sum = 0.0
                        i2 = arg_lo_ss(X_AXIS,ARG2)
                        j2 = arg_lo_ss(Y_AXIS,ARG2)
                        k2 = arg_lo_ss(Z_AXIS,ARG2)
                        l2 = arg_lo_ss(T_AXIS,ARG2)
                        m2 = arg_lo_ss(E_AXIS,ARG2)
                        n2 = arg_lo_ss(F_AXIS,ARG2)

                        DO 100 jj = hlo, hhi

                           IF (j1+jj .LT. arg_lo_ss(Y_AXIS,ARG1)  .OR.
     .                         j1+jj .GT. arg_hi_ss(Y_AXIS,ARG1) ) THEN
                              result(i,j,k,l,m,n) = bad_flag_result
                              GOTO 190
                           ELSE
                              comp = arg_1(i1,j1+jj,k1,l1,m1,n1)
                              IF ( comp .EQ. bad_flag(ARG1) ) THEN
                                 result(i,j,k,l,m,n) = bad_flag_result
                                 GOTO 190
                              ENDIF
                              weight = arg_2(i2,j2,k2,l2,m2,n2)
                              sum = sum + comp * weight
                           ENDIF

                           i2 = i2 + arg_incr(X_AXIS,ARG2)
                           j2 = j2 + arg_incr(Y_AXIS,ARG2)
                           k2 = k2 + arg_incr(Z_AXIS,ARG2)
                           l2 = l2 + arg_incr(T_AXIS,ARG2)
                           m2 = m2 + arg_incr(E_AXIS,ARG2)
                           n2 = n2 + arg_incr(F_AXIS,ARG2)

 100                    CONTINUE
                        result(i,j,k,l,m,n) = sum

 190                    i1 = i1 + arg_incr(X_AXIS,ARG1)
 200                 CONTINUE

                     j1 = j1 + arg_incr(Y_AXIS,ARG1)
 300              CONTINUE

                  k1 = k1 + arg_incr(Z_AXIS,ARG1)
 400           CONTINUE

               l1 = l1 + arg_incr(T_AXIS,ARG1)
 500        CONTINUE

            m1 = m1 + arg_incr(E_AXIS,ARG1)
 600     CONTINUE

         n1 = n1 + arg_incr(F_AXIS,ARG1)
 700  CONTINUE

      RETURN
      END

	SUBROUTINE CONVOLVE(	idim, hlen, wt,
     .				com, com_mr, com_cx,
     .				res, res_mr, res_cx )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* convolve the component grid, com, with the weight function, wt
* along axis idim
* note: the component context may not be of adequate size for the full
*	calculation.  Missing data flags will be inserted where computation is
*	impossible
* also: when bad data points are encountered in the component data all
*	result data depending on it are flagged as bad, too

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  6/2/89
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN 
* V500: bug fix *sh* & *kob* 4/99 -  add code to make sure that component
*                                    limits are adequate
* V550: support for subspan modulo axes -- ensure that convolution does not
*	cross the void point
*
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'

* calling argument declarations:
	INTEGER	idim, hlen, com_mr, com_cx, res_mr, res_cx
	REAL	wt(-hlen:hlen),
     .		com( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .		     m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .		res( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .		     m2lot:m2hit,m2loe:m2hie,m2lof:m2hif )

* internal variable declarations:
	LOGICAL TM_ITS_SUBSPAN_MODULO, has_mod_void
	INTEGER	TM_MODULO_LINE_DIM, CGRID_AXIS, 
     .		i, j, k, l, m, n, ii,
     .		lo_sub(nferdims), hi_sub(nferdims), lo_lim, hi_lim,
     .		hlen1, lo_modlim, hi_modlim, nmod, nmod_prev, modlen
	REAL	bad_com, bad_res, comp, sum

* internal (convenience) equivalences
	INTEGER lo_s1, lo_s2, lo_s3, lo_s4, lo_s5, lo_s6,
     .          hi_s1, hi_s2, hi_s3, hi_s4, hi_s5, hi_s6
	EQUIVALENCE (lo_s1, lo_sub(1)) , (lo_s2, lo_sub(2)),
     .		    (lo_s3, lo_sub(3)) , (lo_s4, lo_sub(4)),
     .		    (lo_s5, lo_sub(5)) , (lo_s6, lo_sub(6)),
     .		    (hi_s1, hi_sub(1)) , (hi_s2, hi_sub(2)),
     .		    (hi_s3, hi_sub(3)) , (hi_s4, hi_sub(4)),
     .		    (hi_s5, hi_sub(5)) , (hi_s6, hi_sub(6))

* initialize
	bad_com = mr_bad_data( res_mr )
	bad_res = mr_bad_data( com_mr )
	hlen1 = hlen
	lo_lim = cx_lo_ss(com_cx,idim)
	hi_lim = cx_hi_ss(com_cx,idim) 
	nmod_prev = -99999

* compute limits within which calculation is possible
	DO 10 ii = 1, nferdims
	   lo_sub(ii) = cx_lo_ss(res_cx,ii)
	   hi_sub(ii) = cx_hi_ss(res_cx,ii)
 10	CONTINUE

* it his a subspan modulo axis?
	has_mod_void = TM_ITS_SUBSPAN_MODULO( CGRID_AXIS(idim,com_cx) )
	IF (has_mod_void) THEN
	   modlen = TM_MODULO_LINE_DIM( CGRID_AXIS(idim,com_cx) )
	   has_mod_void = lo_lim.LE.0 .OR. hi_lim.GE.modlen
	ENDIF

* !temp - not optimized for speed yet
* ... though treating each axis separately is to avoid testing inside the loop
* CONVOLVE ALONG X AXIS
	IF ( idim .EQ. x_dim ) THEN
	   DO 110 n = lo_s6, hi_s6
	   DO 110 m = lo_s5, hi_s5
	   DO 110 l = lo_s4, hi_s4
	   DO 110 k = lo_s3, hi_s3
	   DO 110 j = lo_s2, hi_s2
	   DO 110 i = lo_s1, hi_s1
	      IF (has_mod_void) THEN
*  ... do not allow convolution across the modulo void
	         IF (i.GE.1) THEN  ! get # of modulos to curr index
	            nmod = (i-1)/modlen 
	         ELSE
	            nmod = i/modlen - 1
	         ENDIF
	         IF ( nmod .NE. nmod_prev ) THEN
	            nmod_prev = nmod
	            lo_modlim = nmod*modlen + 1
	            hi_modlim = (nmod+1) * modlen
	            lo_lim = MAX( lo_modlim, cx_lo_ss(com_cx,idim) )
	            hi_lim = MIN( hi_modlim, cx_hi_ss(com_cx,idim)  )
	         ENDIF
	      ENDIF
	      sum = 0.0
	      DO 100 ii = -hlen1, hlen1
* test limits of component data before using
                 IF ( i+ii .GE. lo_lim
     .          .AND. i+ii .LE. hi_lim ) THEN
                    comp = com(i+ii,j,k,l,m,n)
                 ELSE
                    res(i,j,k,l,m,n) = bad_res
                    GOTO 110
                 ENDIF

	         IF ( comp .EQ. bad_com ) THEN
	            res(i,j,k,l,m,n) = bad_res
	            GOTO 110
	         ELSE
	            sum = sum + comp*wt(ii)
	         ENDIF
 100	      CONTINUE
	      res(i,j,k,l,m,n) = sum
 110	   CONTINUE

* CONVOLVE ALONG Y AXIS
	ELSEIF ( idim .EQ. y_dim ) THEN
	   DO 210 n = lo_s6, hi_s6
	   DO 210 m = lo_s5, hi_s5
	   DO 210 l = lo_s4, hi_s4
	   DO 210 k = lo_s3, hi_s3
	   DO 210 j = lo_s2, hi_s2
	      IF (has_mod_void) THEN
*  ... do not allow convolution across the modulo void
	         IF (j.GE.1) THEN  ! get # of modulos to curr index
	            nmod = (j-1)/modlen 
	         ELSE
	            nmod = j/modlen - 1
	         ENDIF
	         IF ( nmod .NE. nmod_prev ) THEN
	            nmod_prev = nmod
	            lo_modlim = nmod*modlen + 1
	            hi_modlim = (nmod+1) * modlen
	            lo_lim = MAX( lo_modlim, cx_lo_ss(com_cx,idim) )
	            hi_lim = MIN( hi_modlim, cx_hi_ss(com_cx,idim)  )
	         ENDIF
	      ENDIF
	   DO 210 i = lo_s1, hi_s1
	      sum = 0.0
	      DO 200 ii = -hlen1, hlen1
* test limits of component data before using
                 IF ( j+ii .GE. lo_lim
     .          .AND. j+ii .LE. hi_lim ) THEN
                    comp = com(i,j+ii,k,l,m,n)
                 ELSE
                    res(i,j,k,l,m,n) = bad_res
                    GOTO 210
                 ENDIF

	         IF ( comp .EQ. bad_com ) THEN
	            res(i,j,k,l,m,n) = bad_res
	            GOTO 210
	         ELSE
	            sum = sum + comp*wt(ii)
	         ENDIF
 200	      CONTINUE
	      res(i,j,k,l,m,n) = sum
 210	   CONTINUE

* CONVOLVE ALONG Z AXIS
	ELSEIF ( idim .EQ. z_dim ) THEN
	   DO 310 n = lo_s6, hi_s6
	   DO 310 m = lo_s5, hi_s5
	   DO 310 l = lo_s4, hi_s4
	   DO 310 k = lo_s3, hi_s3
	      IF (has_mod_void) THEN
*  ... do not allow convolution across the modulo void
	         IF (k.GE.1) THEN  ! get # of modulos to curr index
	            nmod = (k-1)/modlen 
	         ELSE
	            nmod = k/modlen - 1
	         ENDIF
	         IF ( nmod .NE. nmod_prev ) THEN
	            nmod_prev = nmod
	            lo_modlim = nmod*modlen + 1
	            hi_modlim = (nmod+1) * modlen
	            lo_lim = MAX( lo_modlim, cx_lo_ss(com_cx,idim) )
	            hi_lim = MIN( hi_modlim, cx_hi_ss(com_cx,idim)  )
	         ENDIF
	      ENDIF
	   DO 310 j = lo_s2, hi_s2
	   DO 310 i = lo_s1, hi_s1
	      sum = 0.0
	      DO 300 ii = -hlen1, hlen1
* test limits of component data before using
                 IF ( k+ii .GE. lo_lim
     .          .AND. k+ii .LE. hi_lim ) THEN
                    comp = com(i,j,k+ii,l,m,n)
                 ELSE
                    res(i,j,k,l,m,n) = bad_res
                    GOTO 310
                 ENDIF

	         IF ( comp .EQ. bad_com ) THEN
	            res(i,j,k,l,m,n) = bad_res
	            GOTO 310
	         ELSE
	            sum = sum + comp*wt(ii)
	         ENDIF
 300	      CONTINUE
	      res(i,j,k,l,m,n) = sum
 310	   CONTINUE

* CONVOLVE ALONG T AXIS
	ELSE IF ( idim .EQ. t_dim ) THEN
	   DO 410 n = lo_s6, hi_s6
	   DO 410 m = lo_s5, hi_s5
	   DO 410 l = lo_s4, hi_s4
	      IF (has_mod_void) THEN
*  ... do not allow convolution across the modulo void
	         IF (l.GE.1) THEN  ! get # of modulos to curr index
	            nmod = (l-1)/modlen 
	         ELSE
	            nmod = l/modlen - 1
	         ENDIF
	         IF ( nmod .NE. nmod_prev ) THEN
	            nmod_prev = nmod
	            lo_modlim = nmod*modlen + 1
	            hi_modlim = (nmod+1) * modlen
	            lo_lim = MAX( lo_modlim, cx_lo_ss(com_cx,idim) )
	            hi_lim = MIN( hi_modlim, cx_hi_ss(com_cx,idim)  )
	         ENDIF
	      ENDIF
	   DO 410 k = lo_s3, hi_s3
	   DO 410 j = lo_s2, hi_s2
	   DO 410 i = lo_s1, hi_s1
	      sum = 0.0
	      DO 400 ii = -hlen1, hlen1
* test limits of component data before using
                 IF ( l+ii .GE. lo_lim
     .          .AND. l+ii .LE. hi_lim ) THEN
                    comp = com(i,j,k,l+ii,m,n)
                 ELSE
                    res(i,j,k,l,m,n) = bad_res
                    GOTO 410
                 ENDIF

	         IF ( comp .EQ. bad_com ) THEN
	            res(i,j,k,l,m,n) = bad_res
	            GOTO 410
	         ELSE
	            sum = sum + comp*wt(ii)
	         ENDIF
 400	      CONTINUE
	      res(i,j,k,l,m,n) = sum
 410	   CONTINUE

* CONVOLVE ALONG E AXIS
	ELSE IF ( idim .EQ. e_dim ) THEN
	   DO 510 n = lo_s6, hi_s6
	   DO 510 m = lo_s5, hi_s5
	      IF (has_mod_void) THEN
*  ... do not allow convolution across the modulo void
	         IF (m.GE.1) THEN  ! get # of modulos to curr index
	            nmod = (m-1)/modlen 
	         ELSE
	            nmod = m/modlen - 1
	         ENDIF
	         IF ( nmod .NE. nmod_prev ) THEN
	            nmod_prev = nmod
	            lo_modlim = nmod*modlen + 1
	            hi_modlim = (nmod+1) * modlen
	            lo_lim = MAX( lo_modlim, cx_lo_ss(com_cx,idim) )
	            hi_lim = MIN( hi_modlim, cx_hi_ss(com_cx,idim)  )
	         ENDIF
	      ENDIF
	   DO 510 l = lo_s4, hi_s4
	   DO 510 k = lo_s3, hi_s3
	   DO 510 j = lo_s2, hi_s2
	   DO 510 i = lo_s1, hi_s1
	      sum = 0.0
	      DO 500 ii = -hlen1, hlen1
* test limits of component data before using
                 IF ( m+ii .GE. lo_lim
     .          .AND. m+ii .LE. hi_lim ) THEN
                    comp = com(i,j,k,l,m+ii,n)
                 ELSE
                    res(i,j,k,l,m,n) = bad_res
                    GOTO 510
                 ENDIF

	         IF ( comp .EQ. bad_com ) THEN
	            res(i,j,k,l,m,n) = bad_res
	            GOTO 510
	         ELSE
	            sum = sum + comp*wt(ii)
	         ENDIF
 500	      CONTINUE
	      res(i,j,k,l,m,n) = sum
 510	   CONTINUE

* CONVOLVE ALONG F AXIS
	ELSE IF ( idim .EQ. f_dim ) THEN
	   DO 610 n = lo_s6, hi_s6
	      IF (has_mod_void) THEN
*  ... do not allow convolution across the modulo void
	         IF (n.GE.1) THEN  ! get # of modulos to curr index
	            nmod = (n-1)/modlen 
	         ELSE
	            nmod = n/modlen - 1
	         ENDIF
	         IF ( nmod .NE. nmod_prev ) THEN
	            nmod_prev = nmod
	            lo_modlim = nmod*modlen + 1
	            hi_modlim = (nmod+1) * modlen
	            lo_lim = MAX( lo_modlim, cx_lo_ss(com_cx,idim) )
	            hi_lim = MIN( hi_modlim, cx_hi_ss(com_cx,idim)  )
	         ENDIF
	      ENDIF
	   DO 610 m = lo_s5, hi_s5
	   DO 610 l = lo_s4, hi_s4
	   DO 610 k = lo_s3, hi_s3
	   DO 610 j = lo_s2, hi_s2
	   DO 610 i = lo_s1, hi_s1
	      sum = 0.0
	      DO 600 ii = -hlen1, hlen1
* test limits of component data before using
                 IF ( n+ii .GE. lo_lim
     .          .AND. n+ii .LE. hi_lim ) THEN
                    comp = com(i,j,k,l,m,n+ii)
                 ELSE
                    res(i,j,k,l,m,n) = bad_res
                    GOTO 610
                 ENDIF

	         IF ( comp .EQ. bad_com ) THEN
	            res(i,j,k,l,m,n) = bad_res
	            GOTO 610
	         ELSE
	            sum = sum + comp*wt(ii)
	         ENDIF
 600	      CONTINUE
	      res(i,j,k,l,m,n) = sum
 610	   CONTINUE

	ENDIF

	RETURN
	END

	SUBROUTINE TM_IRREGAX_MID( line, line_edges, npts )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Fill in the midpoint values as the default boundaries between grid
* boxes

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 2/93 - code lifted from cd_get_1_axis
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* V72 6/17 *acm* For trac enhancement #767 -- dynamic coordinate storage 
*                The argument is the coordinates for just this line

* argument definitions:
*	line	 - coordinates of the line in dynamic memory
*	line_edges - coordinates of the bounds in dynamic memory
*	npt	 - length of axis

* argument declarations
	REAL	line(*), line_edges(*)
	INTEGER	npts

* internal variable declarations:
        INTEGER i

* include files
	include 'tmap_dims.parm'
#include "gt_lib.parm"
	include 'xio.cmn_text'
	external xio_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data

* nominal treatment for one-point axis.

        IF (npts .EQ. 1) THEN
           i = 1
	   line_edges(i) = line(i) - 1. 
           line_edges(i+1) = line(i) + 1. 
	   RETURN
	ENDIF

* compute midpoints lying between coordinates
        DO i = 1, npts-1
           line_edges(i+1) = (line(i)+line(i+1)) / 2.0D0 
	ENDDO

* lower bound of first box
        line_edges(1)   = line(1) - (line(2)-line(1))/2.D0

* upper bound of last box
        line_edges(npts+1) = line(npts) + (line(npts)-line(npts-1))/2.D0

        RETURN
	END

	CHARACTER*(*) FUNCTION KEY_STRING( cx, flags, slen )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* generate a string that describes the given context using the flags as
* guidelines for what limits, transformations, etc. to document

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V200: 1/2/89
* V230:  11/4/92 - expanded variable name length
* V420:	 9/25/95 - comments appropriate to dynamic grids
* V500 *kob* 3/99- up VAR_CODE  to 64 chars and VAR_TITLE to 128
* V552 *acm* 4/03- up VAR_CODE  to 128 chars and name to 256 (ds_name)
* V67  *acm* 3/11- fix ticket 1821
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V685+ *acm* 12/13 For 6D Ferret, the array coming in as flags is longer for extra dimensions
*       *acm*  1/18 check for dataset is not set before using it

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include	'ferret.parm'
	include	'xcontext.cmn'
	include	'xtext_info.cmn'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'xdset_info.cmn_text'
	external xdset_info_data

* calling argument declarations
	LOGICAL	flags(0:12)
	INTEGER	cx, slen

* local variable declarations:
	LOGICAL		save_by_ss
	INTEGER		TM_LENSTR1, idim, maxlen, plen, categ, var, dset
	CHARACTER 	ALG_TRANS_CODE*3, ARG_STRING*12, VAR_CODE*128,
     .			VAR_TITLE*128, CX_DIM_STR*40, REGRID_COMMENTS*64,
     .			prefix*1, dim_name*1, name*256

* local parameter declarations:
	LOGICAL		full_prec
	PARAMETER     ( full_prec = .TRUE. )

* initialize
	var     = cx_variable( cx )
	categ   = cx_category( cx )
	dset    = cx_data_set( cx )
	prefix = '['
	maxlen = LEN( KEY_STRING )

* begin with the code for this variable	
	KEY_STRING = VAR_CODE( categ, var )
	IF ( INDEX(KEY_STRING,'#') .GT. 0 ) KEY_STRING = VAR_TITLE ( cx )
	IF ( INDEX(KEY_STRING,'(C') .GT. 0 .AND. INDEX(KEY_STRING,',V') .GT. 0) 
     .                                KEY_STRING = VAR_TITLE ( cx )
	slen = TM_LENSTR1( KEY_STRING )

* document the data set
	IF ( flags(pdoc_dset) .AND. cx_data_set(cx).NE.pdset_irrelevant 
     .       .AND. cx_data_set(cx).NE.unspecified_int4) THEN
	   name = ds_name( cx_data_set(cx) )
	   plen = TM_LENSTR1(name)
	   KEY_STRING = KEY_STRING(:slen)//prefix//'D='//name(:plen)
	   slen = MIN( maxlen, slen+plen+3 )
	   prefix = ','
	ENDIF	   

* document any regridding
* (as of FERRET v2.00 the flag for this is ignored)
	IF ( cx_unstand_grid(cx) ) THEN
	   KEY_STRING = KEY_STRING(:slen)//prefix//'G='//
     .			REGRID_COMMENTS(cx, plen)
	   slen = MIN( maxlen, slen+3+plen )
	   prefix = ','
	ENDIF

* document each axis (and it's transformation) that's requested
	DO 100 idim = 1, nferdims
* ... all keys in world coordinates
	   save_by_ss = cx_by_ss( idim, cx )
	   cx_by_ss( idim, cx ) = .FALSE.
	   IF ( flags(idim)
     .    .AND. cx_lo_ww(idim,cx) .NE. unspecified_val8
     .    .AND. cx_lo_ww(idim,cx) .NE. unspec_val8_2	) THEN
	      KEY_STRING = KEY_STRING(:slen)//prefix//
     .				CX_DIM_STR(idim,cx,':',full_prec,plen)
	      slen = MIN( maxlen, slen+plen+1 )
	      prefix = ','
	   ELSEIF ( flags(idim+pdoc_offset_xform)
     .    .AND. cx_trans(idim,cx) .NE. trans_no_transform
     .    .AND. cx_trans(idim,cx) .NE. unspecified_int4 ) THEN
	      IF ( cx_by_ss( idim, cx ) ) THEN
	         dim_name = ss_dim_name( idim )
	      ELSE
	         dim_name = ww_dim_name( idim )
	      ENDIF
	      KEY_STRING = KEY_STRING(:slen)//prefix//dim_name//'=@'//
     .				ALG_TRANS_CODE( cx_trans( idim, cx )) //
     .				ARG_STRING( cx_trans_arg( idim, cx ))
	      slen = TM_LENSTR1( KEY_STRING )
	      prefix = ','
	   ENDIF
* ... restore " by subscript" info
	   cx_by_ss( idim, cx ) = save_by_ss
 100	CONTINUE

* clean up
	IF ( prefix .EQ. ',' ) THEN
	   KEY_STRING = KEY_STRING(:slen)//']'
	   slen = MIN( maxlen, slen+1 )
	ENDIF
	IF ( slen .EQ. maxlen ) KEY_STRING(slen:slen) = '*'

	RETURN
	END

	CHARACTER*14 FUNCTION ABS_WHOI_DATE( secsfrombc, cal_id )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* create a string of the form YYMMDDHHMM from the absolute time in seconds

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V300: 10/93 *sh*  most of the code lifted from WHOI_DATE
* V420: 11/27/95 - 4-digit YEARS!!
* v530: 1/01  *acm*  calendar ID passed in for alternative calendar types
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'ferret.parm'

* calling argument declarations
	REAL*8	secsfrombc

* internal variable declarations
	INTEGER 	yr100, yr, mon, day, hr, min, sec,
     .			status, i, axis, grid
	INTEGER		cal_id
	CHARACTER*20	TM_SECS_TO_DATE, date

* Convert to date string
	date = TM_SECS_TO_DATE(secsfrombc, cal_id)

* break the date string into component integer values
	CALL TM_BREAK_DATE( date, cal_id, yr, mon, day, hr, min, 
     .                      sec, status )
	yr100 = yr/100		! 1980 --> 19
	yr = yr - (yr100*100)	! 1982 --> 82

* assemble the pieces in WHOI format
	WRITE (ABS_WHOI_DATE,3000) yr100,yr,mon,day,hr,min,sec
 3000	FORMAT (7I2.2)

	RETURN
	END

	SUBROUTINE SAMPLE( memory, mr_list, cx_list, nvars,
     .			   opt1_string, opt2_string, file_given,
     .			   fname, fmt, binary, columns, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* sample the given field at the specified XYZT coordinates
* opt1_string contains special instructions
*	"FILL" indicates to fill holes when the field contains missing values
* opt2_string contains flags to indicate if the coordinates are given as
*	world positions (C=Coordinate) or subscripts (I=index)

*  USER/COMMAND=SAMPLE/OPT1=FILL,STANDARD_BAD/OPT2=CCII/FILE=outfile/FORM=(F10)

* The format may be a FORTRAN FORMAT or "UNFORMATTED", or,
* "UNFORMATTED:columns" - the latter produces condensed output (results, only)

* Each output record will consist of
*	value xcoord ycoord zcoord tcoord code
* where "code" is 0=fully successful
*		  1=successful with hole filling
*              -1-4=failed due to beyond input data limits on axis -code
*		 -9=failed due to hole in input data field
*		-99=failed due to hole in input coordinates

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V301:  1/94
*
* V312: 5/94 - array "memory" as a calling argument
* V314: 8/22/94 *kob* IBM port: 1) ACCESS=APPEND not allowed in file opens - added
*				   ifdef NO_ACCESS_APPEND check
*				2) TM_HAS_STRING incorrectly defined as INTEGER
*				3) inherited length string concats are not legal -
*					use risc buff
* Linux Port 5/97 *kob* - had to add ifdef F90_OPEN_FILE_APPEND because f90
*			  uses "POSITION" instead of "ACCESS" to specify 
*			  opening a file for append.
* v552  4/03 *acm* up VAR_TRANS to 150 characters (variables are up to 128, plus
*                  space for the transformation specifier)
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xprog_state.cmn'
	include 'xtext_info.cmn'
#ifdef NO_PASSED_CONCAT	
	include 'xrisc.cmn'
#endif

* calling argument declarations:
	LOGICAL	file_given, binary
	INTEGER	nvars, mr_list(nvars), cx_list(nvars), columns, status
	REAL	memory( mem_blk_size, max_mem_blks )
	CHARACTER opt1_string*(*), opt2_string*(*), fname*(*), fmt*(*)

* internal variable declarations:
	LOGICAL	fill, standard_bad, tempx, tempy, tempz, tempt,
     .		TM_HAS_STRING
	INTEGER	TM_LENSTR1, CGRID_SIZE, STR_UPCASE,
     .		CX_DIM_LEN,
     .		mblk1, nblks, col_mblk1, col_nblks, slen,
     .		ssorww(4), out_lun,
     .		i, flen, fmlen, npts, cx, ndim, dim(4), cxpts(2:5)
	REAL	missing
	CHARACTER VAR_TRANS*150, buff*150
	
* internal parameter definitions
	INTEGER by_ss, by_ww, by_nothin
	PARAMETER ( by_ss=1, by_ww=2, by_nothin=0 )

* DECODE THE OPT1 COMMAND QUALIFIER:
* /OPT1 = "FILL,STANDARD_BAD"
	slen = TM_LENSTR1( opt1_string )
	fill = TM_HAS_STRING(opt1_string(:slen),'FILL')
	standard_bad = TM_HAS_STRING(opt1_string(:slen),'STANDARD')
	IF ( .NOT.fill .AND. .NOT.standard_bad .AND. opt1_string.NE.' ' 
     .	.AND. .NOT.TM_HAS_STRING(opt1_string(:slen),'HOLE') ) GOTO 5100

* Must be exactly 5 arguments given
* arguments 2-5 must be either same size or constants
	IF ( nvars .NE. 5 ) GOTO 5200
	npts = unspecified_int4
	DO 100 i = 2, 5
	   cx = cx_list(i)
	   CALL GET_CX_DIMS( cx, ndim, dim ) 
	   cxpts(i) = CGRID_SIZE( cx )	
	   IF ( cxpts(i) .NE. 1 ) THEN
	      IF ( npts .EQ. unspecified_int4 ) npts = cxpts(i)
	      IF ( npts .NE. CGRID_SIZE( cx ) ) GOTO 5300
	   ENDIF
 100	CONTINUE
	IF ( npts .EQ. unspecified_int4 ) npts = 1
	
* determine what to output for missing data points
	IF ( standard_bad ) THEN
	   missing = bad_val4
	ELSE
	   missing = mr_bad_data(mr_list(1))
	ENDIF

* Decode the specification of subscript or world coordinate
* /OPT2 = "C" (all coordinates) or "I" (all indices) or "CCIN", ...
	DO 200 i = 1, 4
 200	ssorww(i) = by_ww			! default to "C"
	IF ( opt2_string .NE. ' ' ) THEN
	   i = STR_UPCASE( opt2_string, opt2_string )
	   slen = TM_LENSTR1( opt2_string )
	   IF ( slen.NE.1 .AND. slen.NE.4 ) GOTO 5400
	   IF ( slen.EQ.1 ) THEN     ! replicate single char shorthand
	      DO 210 i = 2, 4
 210	      opt2_string(i:i) = opt2_string(1:1)
	   ENDIF
	   DO 220 i = 1, 4
	      IF ( opt2_string(i:i) .EQ. 'C' ) THEN
	         ssorww(i) = by_ww
	      ELSEIF ( opt2_string(i:i) .EQ. 'I' ) THEN
	         ssorww(i) = by_ss
	      ELSEIF ( opt2_string(i:i) .EQ. 'N' ) THEN
	         ssorww(i) = by_nothin
	      ELSE
	         GOTO 5400
	      ENDIF
 220	   CONTINUE
	ENDIF

* narrow the ssorww choices if only a bad_flag was given for a coord
	DO 250 i = 2,5
	   IF ( cxpts(i).EQ.1 .AND. ( memory(1,mr_blk1(mr_list(i)))
     .		.EQ. mr_bad_data(mr_list(i)) )  ) ssorww(i-1) = by_nothin
 250	CONTINUE

* make sure the field of data provided doesn't create ambiguities on the
* unsampled axes  (i.e. multiple points provided but no sampling coordinates)
	cx = cx_list(1)
	DO 300 i = 1, 4
	   IF ( ssorww(i) .EQ. by_nothin
     .	   .AND. CX_DIM_LEN(i, cx) .GT. 1 ) GOTO 5500
 300	CONTINUE	

* make sure there is no attempt to sample on a normal axis
	DO 400 i = 1, 4
	   IF ( ssorww(i) .NE. by_nothin
     .	   .AND. cx_lo_ss(cx,i) .EQ. unspecified_int4 ) GOTO 5700
 400	CONTINUE	

* insert the default filename based on format type
* or prepare for terminal output
	IF ( file_given ) THEN
	   IF ( fname .EQ. ' ' ) THEN
	      IF ( binary ) THEN
	         fname = 'fer_sample.unf'
	      ELSE
	         fname = 'fer_sample.dat'
	      ENDIF
	   ENDIF
	ENDIF
	IF ( .NOT.binary .AND. fmt.EQ.' ' )
     .			fmt = '(5(1PG14.6),0PF5.0)'   ! "0P" for DEC bug
	flen = TM_LENSTR1( fname )
	fmlen = TM_LENSTR1( fmt )

* allocate memory for consolidated 4D coordinates
	CALL GET_MEMORY( npts*4, mblk1, nblks, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* allocate memory for output record buffer if needed
	IF ( columns .GT. 0 ) THEN
	   CALL GET_MEMORY( columns, col_mblk1, col_nblks, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	ELSE
	   col_mblk1 = 1	! dummy, unused
	ENDIF

* Open the output file
	IF ( file_given ) THEN
	   IF ( fmt .EQ. ' ' ) THEN
	      OPEN( UNIT        = default_list_lun,
     .              FILE        = fname,
     .              FORM        = 'UNFORMATTED',
#ifdef NO_ACCESS_APPEND	
#else
#ifdef F90_OPEN_FILE_APPEND
     .		    POSITION    = 'APPEND',
#else
     .              ACCESS      = 'APPEND',
#endif
#endif
     .              STATUS      = 'UNKNOWN',
     .              ERR         = 5600 )
!	      WRITE (ttout_lun, 3000) 'binary', fname(:flen)
	   ELSE
	      OPEN( UNIT        = default_list_lun,
     .              FILE        = fname,
     .              FORM        = 'FORMATTED',
#ifdef NO_ACCESS_APPEND	
#else
#ifdef F90_OPEN_FILE_APPEND
     .		    POSITION    = 'APPEND',
#else
     .              ACCESS      = 'APPEND',
#endif
#endif
     .              STATUS      = 'UNKNOWN',
     .              ERR         = 5600 )
!	      WRITE (ttout_lun, 3000) 'ASCII', fname(:flen)
	   ENDIF
! 3000	   FORMAT (' Sampled output is in ',A,' file ',A)
	   out_lun = default_list_lun
	ELSE
	   out_lun = ttout_lun
	ENDIF

* call the SAMPLing work routine
	CALL SAMPLE_SUB( memory, cx_list(2), mr_list(2), npts, cxpts,
     .	memory(1, mr_blk1(mr_list(1))), mr_list(1), cx_list(1),
     .	missing,
     .	memory(1, mblk1), memory(1, col_mblk1), 
     .  fmt(1:fmlen), fill, ssorww,
     .	out_lun, binary, columns, status )
     
* close the output file
	IF ( file_given ) CLOSE(UNIT=out_lun, ERR=5600)

* cleanup
 1000	CALL FREE_MEMORY( mblk1, nblks )
	IF ( columns .GT. 0 ) THEN
	   CALL FREE_MEMORY( col_mblk1, col_nblks )
	ENDIF
	RETURN

* error exits
 5000	RETURN
#ifdef NO_PASSED_CONCAT
 5100	risc_buff = opt1_string(:slen)
	CALL ERRMSG( ferr_invalid_command, status,
     .		    '/OPT1='//risc_buff//pCR//
     .		    'May be "FILL" or "HOLES" with "STANDARD_BAD"',
     .		     *5000 )
#else
 5100	CALL ERRMSG( ferr_invalid_command, status,
     .		    '/OPT1='//opt1_string(:slen)//pCR//
     .		    'May be "FILL" or "HOLES" with "STANDARD_BAD"',
     .		     *5000 )
#endif
 5200	CALL ERRMSG( ferr_invalid_command, status,
     .		    'arguments must be field,xpts,ypts,zpts,tpts', *5000 )
 5300	CALL ERRMSG( ferr_invalid_command, status,
     .		    '# of X,Y,Z, and T coordinates must each be same or 1',
     .		    *5000 )
#ifdef NO_PASSED_CONCAT
 5400   risc_buff = opt2_string(:slen)
	CALL ERRMSG( ferr_invalid_command, status,
     .   '/OPT2='//risc_buff//pCR//
     .   'Must be xxxx - 4 letters of "C"(coord),'
     .   //' "I"(index) or "N"(N/A)',
     .		    *5000 )
#else
 5400	CALL ERRMSG( ferr_invalid_command, status,
     .   '/OPT2='//opt2_string(:slen)//pCR//
     .   'Must be xxxx - 4 letters of "C"(coord),'
     .   //' "I"(index) or "N"(N/A)',
     .		    *5000 )
#endif
 5500	buff = VAR_TRANS(i, cx, slen )
	CALL ERRMSG( ferr_invalid_command, status,
     .  'Sampling of '//buff(:slen)//' is ambiguous on '//
     .	ww_dim_name(i)//' axis', *5000 )
 5600	CALL ERRMSG( ferr_erreq,status,fname,*1000 )
 5700	buff = VAR_TRANS(i, cx, slen )
	CALL ERRMSG( ferr_invalid_command, status,
     .  'Attempt to sample normal '//ww_dim_name(i)//' axis of '//
     .  buff(:slen), *5000 )

	END

	SUBROUTINE GET_FVARS_LIST_BY_ATTNAME_AND_VAL
     .			(attname, attstring, maxlist,
     .			 id_list, dset_list, nfound  )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* return a list of all file variables that have a particular given value for
* a given string attribute
* intended usage:  find variables that have __LAYERZ_REF__'="DEPTH"
* Note: if the incoming string is unspecified_name4, then all attrib vals match

* V690: 2/14 *sh* 
* V693+ 11/14 *sh* renaming 'sigma' as 'layerz' throughout

        IMPLICIT NONE
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl_vms.parm'
	include 'xdset_info.cmn_text'
	include 'xvariables.cmn'
	include 'xrisc.cmn'

* calling argument declaration:
	CHARACTER*(*) attname, attstring
	INTEGER	maxlist, id_list(maxlist), dset_list(maxlist), nfound

* internal parameter declarations
	INTEGER	maxlen
	PARAMETER (maxlen = 50)

* internal variable declarations:
	LOGICAL NC_GET_ATTRIB, found_one, no_match_needed
	INTEGER	ivar, dset, status, varid, attid, attlen, attoutflag,
     .		vax_code, STR_CASE_BLIND_COMPARE
	REAL	attvals(maxlen)
	CHARACTER retstring*(maxlen)

* initialize
	no_match_needed = attstring .EQ. unspecified_name4
	nfound = 0

* loop through the file variables
	DO ivar = 1, maxvars
	   dset = ds_var_setnum(ivar)
	   IF ( dset .EQ. set_not_open ) CYCLE

	   CALL CD_GET_VAR_ID (dset, ds_var_code(ivar), varid, status)

           found_one = NC_GET_ATTRIB ( dset, varid, patnam_layerz,
     .                               .FALSE., ds_var_code(ivar), maxlen,
     .                               attlen, attoutflag, retstring,
     .                               attvals )
* ... attrib name matches.
*     if necessary now also check if the contents match
           IF (found_one) THEN
	      found_one = no_match_needed
	      IF (.NOT.no_match_needed) THEN
	         vax_code = STR_CASE_BLIND_COMPARE(attstring,retstring)
	         found_one = vax_code .EQ. vms_str_success
	      ENDIF
	      IF (found_one) THEN
	         nfound = nfound + 1
	         id_list  (nfound) = varid
	         dset_list(nfound) = dset
	         IF (nfound .EQ. maxlist) RETURN  ! hacky but good enuf
	      ENDIF
	   ENDIF
	ENDDO

	RETURN
	END

	SUBROUTINE IS_REGRID(  *, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* regrid thae data from the source grid to the destination grid

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 7/25/88
* revision 0.1 -12/30/88 - eliminated P1 and Q1 from regrid call
*			 - renamed DO_REGRID --> DO_LIN_REGRID
* revision 0.2 -  1/9/89 - added xy average regridding
* V200:  8/2/89 - 4D symmetrical version - usually 1 axis per regrid
*	10/16/89 - set up adjustable array limits with NON_ARRAY_SUBSC
*	 11/3/89 - if destination limits are unknown use full axis length
*	 12/1/89 - allow XY average regridding - code split to RCVD_REGRID
* V230:  8/22/92 - added @ASN and @AVE regridding
* V300:  3/16/93 - allow regridding where the source range falls entirely
*                  between points on the destination axis (all bad_data result)
* V312: 5/94 - array "memory" as a calling argument
* V420: 9/95	 - Support for implicit grids: deallocate after it is used
*      11/95	 - added modulo (climatological) regridding
*      12/95	 - added modngd, modmin, etc. (climatological) regridding
*	1/96	 - bug check against attempt to regrid a compressed axis
*	1/29/96	 - regridding @SUM and @NGD are not weighted
*		   (done in ave_regrid_1_axis instead of window_regrid_1_axis)
* V491: 10/97 *sh* - add G=@XACT
* V500:  5/99 *sh* - check if implicit regridding was already done by netCDF
*			read using strides (check cx_delta of src cx)
*		     Allow for the possibility of multiple axes
* V530:  3/01 *sh* - added g=ax@nrst
* V530:	 3/01 *acm* return a status flag from rcvd_regrid, tests for
*                   valid calendar axes.
* V533:	 6/01 *sh* - some regridding ops not allowed for string arrays
*		   - mr_delta changes the handling of stride regridding
* v541:  2/02 *kob*- on hankin request add an initialization line for
*                    cx_delta in loop 500
* V541:  4/02 *sh* - bug fix: delta not removed from result despite 
*                  the fact that result is on a new axis where the delta 
*                  is implicit rather than explicit in the axis definition 
*                  see err540_strides_rev.jnl 
* V552:  4/04 *acm* - bug fix.  For @AVE and related transforms @SUM, etc.
*                     send src_lo_ss and src_hi_ss for the range on the src
*                     axis.  Previous use of mr_lo_ss and mr_hi_ss can result
*                     in incorrect results when a larger then needed chunk
*                     of source data is already in4/15/03 memory
* V554:  3/04 *acm* Fix the check for done_by_strides.
* V603 5/07  *acm* - added MODNBD modulo regridding statistic
* V671:  6/11 *acm*  New 2D linear xy regridding, fixing ticket 1862
*                    The XY linear regridding matches past Ferret behavior, 
*                    not using bilinear regridding for now
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V68+ 4/12  *acm*   Fix ticket 1931: the work space for XY linear regridding
*                    was computed incorrectly.
* V696 *acm* 11/15 Added @BIN and @NBIN regridding transforms
* V698 *acm*  3/16 Ticket 2278: add an attribute with time range when
*                  saving a modulo-regridded variable to netCDF
* V702 3/17 *sh* for trac enhancement #2369 -- dynamic memory management 
* V720: 6/17 *acm* Ticket 2346: new @IIN regridding transform

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xprog_state.cmn'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xalgebra.cmn'   ! with alg_regrid_code

* calling argument declarations:
	INTEGER	status
* normal exit is for error conditions
* exit #1 is to signal completion of the activity at this stack level

* internal variable declarations:
	LOGICAL	TM_ITS_CDF, 
     .		xy_regrid, valid, valid_y, has_impl_save, done_by_strides,
     .		itsa_string
	INTEGER hi_isp, lo_isp, axis, cx_valid, idim,
     .		rgrd_trans, mrlist(5), wk_size, wk_size2,
     .		dst_cx, src_cx, dst_mr, src_mr, ngd_mr, ave_mr,
     .		axis_list(nferdims), naxis, i, nbd_mr, nxsrc
	INTEGER*8 i8_size
	CHARACTER dtype*4

*        ... interpretation stack setup at the time this is called ...
*	stack level		stack contents
*	isp+2	<--	level of next activity
*	hi_isp	<--	level at which component was obtained
*	lo_isp	<--	level at which regrid was requested (current isp)
* --- end of introductory code ---

* initialize
	lo_isp   = isp                     
	hi_isp   = lo_isp + 1
	src_mr   = is_mr( hi_isp )
	dst_cx   = is_cx( lo_isp )
	src_cx   = is_cx( hi_isp )
	axis	 = is_axis( lo_isp )
	naxis	 = 1
	axis_list(1) = axis
	itsa_string = cx_type(src_cx) .EQ. ptype_string

* what is the regridding transformation for this axis ?
	rgrd_trans = cx_regrid_trans( axis, dst_cx )
	xy_regrid = ( (rgrd_trans .EQ. prgrd_xy_ave) .OR. 
     .                (rgrd_trans .EQ. prgrd_xy_lin) )
	IF ( xy_regrid ) THEN
	   IF ( mode_diagnostic ) WRITE (ttout_lun,*) 'regrid XY'
	   IF (axis.NE.x_dim) CALL ERRMSG
     .		( ferr_internal, status, 'rgrd_xy_regrid', *5000 )	! diagnostic
	   naxis = 2
	   axis_list(2) = y_dim
	ENDIF

* bug check:  has someone attempted to regrid a compressed axis?
* (possible bug in check ... could we have unspec limits for another reason?)
	IF ( cx_category(src_cx) .EQ. cat_user_var
     . .AND. cx_lo_ss(src_cx,axis) .EQ. unspecified_int4 ) THEN
	   IF (  uvar_given(axis,cx_variable(src_cx))
     .	    .NE. uvlim_irrelevant )			 CALL ERRMSG
     .		( ferr_invalid_command, status,
     .		 'attempt to regrid on a compressed axis', *5000 )
	ENDIF

* (5/99) for netCDF variables strides may have been used in READ_TM and
* the regridding already performed there. The src cx then contains the
* limits appropriate to netCDF ... not to Ferret. So, make the source cx
* into a clone of the final result.

* (3/04) do not check for has_impl_grid: when we have done a DEFINE GRID/like=var
* for later comparisons, this grid was stored as a static grid, but we have still 
* read the data using strides, and therefore do not need to do a regridding operation.

	IF ( cx_category(dst_cx) .EQ. cat_file_var ) THEN
	   done_by_strides = 
     .		TM_ITS_CDF(cx_data_set(dst_cx), dtype )
c     .    .AND. cx_has_impl_grid(dst_cx)
     .	  .AND. cx_delta(axis,src_cx) .NE. unspecified_val8
	ELSE
	   done_by_strides = .FALSE.
	ENDIF
	IF (done_by_strides) THEN
	   DO 400 idim = axis+1, nferdims
	      IF (cx_delta(idim,src_cx) .NE. unspecified_val8) THEN
	         naxis = naxis + 1
	         axis_list(naxis) = idim
	      ENDIF
 400	   CONTINUE
	ENDIF

* Make the destination context like the source data context on all except
* the regrid axis.  That one keeps the user-requested size.
* (Other axes may have been modified by information embedded within a
* user-variable definition.  An alternative (untested 8/89) approach is to
* call PASS_AMBIG_LI** for uvars)
	CALL TRANSFER_CONTEXT( src_cx, cx_buff )
	DO 500 i = 1, naxis 
	   idim = axis_list(i)
	   CALL TRANSFER_AXIS( idim, dst_cx, cx_buff )
	   cx_regrid_trans( idim, cx_buff ) = cx_regrid_trans( idim, dst_cx )
	   cx_delta(idim,cx_buff) = unspecified_val8
 500	CONTINUE
	cx_grid( cx_buff ) = cx_grid( dst_cx )
	cx_unstand_grid( cx_buff ) = .TRUE.
	has_impl_save = cx_has_impl_grid(dst_cx)
	CALL TRANSFER_CONTEXT( cx_buff, dst_cx )
	cx_has_impl_grid(dst_cx) = has_impl_save	! preserve this flag

* create a context with the limits that can actually be regridded
* ... if limits were unspecified in request allow full axis size
	IF (done_by_strides) THEN
	   cx_valid = dst_cx
	   valid = .TRUE.
	ELSE
	   cx_valid = cx_buff
	   CALL RCVD_REGRID( src_cx, dst_cx, axis, wk_size,
     .		 cx_lo_ss(cx_valid,axis), cx_hi_ss(cx_valid,axis), status )
	   cx_by_ss( axis, cx_valid ) = .TRUE.
           valid = cx_lo_ss(cx_valid,axis) .LE. cx_hi_ss(cx_valid,axis)  ! 3/93
           IF ( valid ) THEN   ! 3/93
	      CALL CONFINE_AXIS( axis, cx_valid, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
           ENDIF
	   IF ( xy_regrid ) THEN
	      CALL RCVD_REGRID( src_cx, dst_cx, y_dim, wk_size2,
     .		cx_lo_ss(cx_valid,y_dim),cx_hi_ss(cx_valid,y_dim), status)
	      cx_by_ss( y_dim, cx_valid ) = .TRUE.
              valid_y = cx_lo_ss(cx_valid,y_dim)
     .             .LE. cx_hi_ss(cx_valid,y_dim)
              IF ( valid_y ) THEN
	         CALL CONFINE_AXIS( y_dim, cx_valid, status )
	         IF ( status .NE. ferr_ok ) GOTO 5000
              ENDIF
              valid = valid .AND. valid_y
	   ENDIF
	ENDIF

* create a space for the new result possibly with the edges flagged as bad
	CALL NEW_MR_W_EDGES(  cx_valid, dst_cx, dst_mr, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	is_mr( lo_isp ) = dst_mr

* cannot actually regrid if the ranges aren't valid -> all bad result
        IF ( .NOT.valid ) GOTO 1000      ! 3/93

* diagnostic message ?
	IF (mode_diagnostic) THEN
	   IF (done_by_strides) THEN
	      CALL DIAGNOSTIC_OUT('nulrgd ',dst_mr,  point_to_mr)
	   ELSE
	      CALL DIAGNOSTIC_OUT('regrid ',dst_mr,  point_to_mr)
	   ENDIF
	ENDIF

* set up 4D array limits as unsubscripted variables in COMMON
	mrlist(1) = src_mr
	mrlist(2) = dst_mr
	CALL NON_ARRAY_SUBSC( mrlist, 2 )

* reserve working array space
	IF ( rgrd_trans .EQ. prgrd_xy_ave) THEN
	   i8_size = wk_size+wk_size2
	ELSEIF (rgrd_trans .EQ. prgrd_xy_lin) THEN
	   nxsrc = cx_hi_ss(src_cx,x_dim)-cx_lo_ss(src_cx,x_dim) + 1
	   i8_size = nxsrc*wk_size2+2*(wk_size+wk_size2)
	ELSE
	   i8_size = 2*wk_size
	ENDIF
	CALL GET_DYN_WORK_SPACE( i8_size, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* do the regridding
	IF ( done_by_strides ) THEN
	   CALL COPY_GRID( memry(src_mr)%ptr,  src_mr,
     .			   memry(dst_mr)%ptr,  dst_mr )
	ELSEIF ( rgrd_trans .EQ. prgrd_linear_interp ) THEN
	   IF ( itsa_string ) GOTO 5010
	   CALL DO_LIN_REGRID( cx_valid, axis,
     .			memry(src_mr)%ptr, src_mr,
     .			memry(dst_mr)%ptr, dst_mr,
     .			workmem(plegacy_work_buffer)%ptr,
     .			wk_size+1, 2*wk_size )
	ELSEIF ( rgrd_trans .EQ. prgrd_associate ) THEN
	   CALL DO_ASN_REGRID( cx_valid, axis,
     .			memry(src_mr)%ptr, src_mr,
     .			memry(dst_mr)%ptr, dst_mr )
	ELSEIF ( rgrd_trans .EQ. prgrd_average
     .	 .OR.    rgrd_trans .EQ. prgrd_variance
     .	 .OR.    rgrd_trans .EQ. prgrd_sum
     .	 .OR.    rgrd_trans .EQ. prgrd_good_pt ) THEN
	   IF ( itsa_string ) GOTO 5010
	   CALL DO_AVE_REGRID( cx_valid, axis, rgrd_trans,
     .			memry(src_mr)%ptr, src_mr,
     .			memry(dst_mr)%ptr, dst_mr,
     .			workmem(plegacy_work_buffer)%ptr, src_cx, dst_cx,
     .                  wk_size+1 )
	ELSEIF ( rgrd_trans .EQ. prgrd_xy_ave ) THEN
	   IF ( itsa_string ) GOTO 5010
	   CALL DO_XYAVE_REGRID( cx_valid,
     .			memry(src_mr)%ptr, src_mr,
     .			memry(dst_mr)%ptr, dst_mr,
     .			workmem(plegacy_work_buffer)%ptr, src_cx, dst_cx,
     .                  wk_size+1, wk_size+wk_size2 )
	ELSEIF ( rgrd_trans .EQ. prgrd_xy_lin ) THEN
	   IF ( itsa_string ) GOTO 5010
	   CALL DO_XYLIN_REGRID( cx_valid,
     .			memry(src_mr)%ptr, src_mr,
     .			memry(dst_mr)%ptr, dst_mr,
     .			workmem(plegacy_work_buffer)%ptr, src_cx, dst_cx,
     .                  wk_size+1, 2*wk_size+1, 
     .                  2*wk_size+wk_size2+1, 2*(wk_size+wk_size2)+1, 
     .                  nxsrc*wk_size2+2*(wk_size+wk_size2) )
	ELSEIF ( rgrd_trans.EQ.prgrd_min
     .	   .OR. rgrd_trans.EQ.prgrd_max ) THEN
	   IF ( itsa_string ) GOTO 5010
	   CALL DO_WINDOW_REGRID( cx_valid, axis, rgrd_trans,
     .			memry(src_mr)%ptr, src_mr,
     .			memry(dst_mr)%ptr, dst_mr,
     .			workmem(plegacy_work_buffer)%ptr, wk_size+1)
	ELSEIF ( rgrd_trans .EQ. prgrd_xact_pts ) THEN
	   CALL DO_XACT_REGRID( cx_valid, axis,
     .			memry(src_mr)%ptr, src_mr,
     .			memry(dst_mr)%ptr, dst_mr,
     .			workmem(plegacy_work_buffer)%ptr, wk_size+1,
     .			2*wk_size )
	ELSEIF ( rgrd_trans .EQ. prgrd_nearest ) THEN
	   CALL DO_NEAREST_REGRID( cx_valid, axis,
     .			memry(src_mr)%ptr, src_mr,
     .			memry(dst_mr)%ptr, dst_mr,
     .			workmem(plegacy_work_buffer)%ptr, wk_size+1,
     .			2*wk_size )
	ELSEIF ( rgrd_trans .EQ. prgrd_bin
     .	 .OR.    rgrd_trans .EQ. prgrd_nbin ) THEN
	   CALL DO_BIN_REGRID( cx_valid, axis, rgrd_trans,
     .			memry(src_mr)%ptr, src_mr,
     .			memry(dst_mr)%ptr, dst_mr,
     .			workmem(plegacy_work_buffer)%ptr, src_cx, dst_cx,
     .                  wk_size+1 )

	ELSEIF ( rgrd_trans .EQ. prgrd_iin ) THEN
	   CALL DO_IIN_REGRID( cx_valid, axis,
     .			memry(src_mr)%ptr, src_mr,
     .			memry(dst_mr)%ptr, dst_mr,
     .			workmem(plegacy_work_buffer)%ptr, wk_size+1, status )
     
	   IF ( status .NE. ferr_ok ) GOTO 5100

* modulo regridding
	ELSE
	   IF ( itsa_string ) GOTO 5010
* ... for all modulo regridding cases allocate a temp variable to contain
* ... the modngd (number of valid points) result -- this is used in all
* ... of the modulo calculations.
* ... For modvar (variance) also allocate a temp space for the average
* ... which is needed in the process of computing the variance
* ... For modnbd (number of invalid points) also allocate a temp space for 
* ... the count of number of bad values 
	   ave_mr = dummy_mr	! component 3 default

	   CALL CREATE_TEMP_MEM_VAR(cx_valid,ngd_mr,status)
	   IF ( status .NE. ferr_ok ) GOTO 5100
	   mr_regrid_trans ( axis, ngd_mr ) =  prgrd_modngd

	   CALL CREATE_TEMP_MEM_VAR(cx_valid,nbd_mr,status)
	   IF ( status .NE. ferr_ok ) GOTO 5100
	   mr_regrid_trans ( axis, nbd_mr ) =  prgrd_modnbd

	   IF ( rgrd_trans .EQ. prgrd_modvar ) THEN
	      CALL NEW_MR_W_EDGES(cx_valid,dst_cx,ave_mr,status)
	      IF ( status .NE. ferr_ok ) GOTO 5100
!	      mr_regrid_trans ( axis, ave_mr ) = prgrd_modulo	! bookkeeping
	   ENDIF

* set up 4D array limits and do the regridding
	   mrlist(3) = ngd_mr
	   mrlist(4) = nbd_mr
	   mrlist(5) = ave_mr
	   CALL NON_ARRAY_SUBSC( mrlist, 5 )
	   CALL MODULO_REGRID( cx_valid, axis, rgrd_trans,
     .			memry(src_mr)%ptr, src_mr,
     .			memry(dst_mr)%ptr, dst_mr,
     .			memry(ngd_mr)%ptr, ngd_mr,
     .			memry(nbd_mr)%ptr, nbd_mr,
     .			memry(ave_mr)%ptr, ave_mr )

* ... For modulo regrid in time, add an attribute listing the source dates

	   IF (axis .EQ. t_dim) CALL DEFINE_CLIMAT_ATT (src_cx)

* ... delete temporary variables
	   CALL DELETE_VARIABLE( ngd_mr )
	   CALL DELETE_VARIABLE( nbd_mr )
	   IF ( rgrd_trans .EQ.  prgrd_modvar ) THEN
	      CALL DELETE_VARIABLE( ave_mr )
	   ENDIF

	ENDIF
        CALL  RELEASE_DYN_WORK_SPACE

* indicate we are done with the component
 1000   CALL MR_NOT_IN_USE( src_mr )
	IF (done_by_strides) CALL DELETE_VARIABLE( src_mr ) ! invalid lims in mr

* intermediate grid ? deallocate grid space and delete intermediate data
	IF ( is_phase( lo_isp ) .EQ. prgrd_from_ntrmed ) THEN
	   CALL DEALLO_GRID( status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   IF ( mr_protected(src_mr) .EQ. mr_not_protected )
     .			CALL DELETE_VARIABLE ( src_mr )
	ENDIF

* pop off context used by source grid
        cx_stack_ptr = cx_stack_ptr - 1
	RETURN 1

* error exits
 5000	RETURN
 5010	CALL ERRMSG( ferr_invalid_command, status,
     .		'cant use this regrid transform on strings: @'
     .		//alg_regrid_code(rgrd_trans), *5000)
 5100	CALL DELETE_MRS_IN_PROGRESS
	GOTO 5000
	END	

*           rr_dsdt.F
*
*           Rick Romea
*           Jan. 5, 2000
*
*     (Backward) time derivative of SALT
*     Equation :  dSALT/dt = [ SALT(t) - SALT(t-1) ] / dt
*     Units :     (SALINITY(ppm) - 0.035) / s
*     MOM2 Grid:  T  
*
*****************************************************************

      SUBROUTINE RR_dsdt_init(id)
	IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id, arg
      arg = 1

      CALL ef_set_desc             (id,
     .'d SALT/dt (Backward) time derivative (SALT/s);MOM2 T Grid')
      CALL ef_set_num_args         (id, 1)
      CALL ef_set_axis_inheritance (id, IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok     (id, YES, YES, YES, NO)
      CALL ef_set_arg_name         (id, arg, 'SALT')
      CALL ef_set_arg_desc         (id, arg,
     . 'Salt, on the MOM2 T Grid.')
      CALL ef_set_arg_unit         (id, arg,
     . '(SALINITY(ppt) - 35) /1000')
      CALL ef_set_arg_type         (id, arg, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, arg, YES, YES, YES, YES)

      !  Extend the time axis one point backward

      CALL ef_set_axis_extend      (id, arg, T_AXIS,-1,0)
      END


      SUBROUTINE RR_dsdt_compute(id, arg_1, result)
	IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'
      
      INTEGER id

      REAL           bad_flag(EF_MAX_ARGS)
      REAL           bad_flag_result      
      REAL arg_1  (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .             mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL result (memreslox:memreshix, memresloy:memreshiy, 
     .             memresloz:memreshiz, memreslot:memreshit)
      INTEGER        res_lo_ss (4)
      INTEGER        res_hi_ss (4)
      INTEGER        res_incr  (4)

      INTEGER        arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER        arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER        arg_incr  (4,EF_MAX_ARGS)

      INTEGER        i,  j,  k,  l
      INTEGER        i1, j1, k1, l1

      REAL*8         RR_times(1024)
      LOGICAL        RR_badDt
      REAL           RR_dt
      REAL           RR_factor
      INTEGER        iT

      CHARACTER *16  ax_name(4)
      CHARACTER *16  ax_units(4)
      LOGICAL        backward(4)
      LOGICAL        modulo(4)
      LOGICAL        regular(4)

      INCLUDE 'rr_parameters.h'

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags      (id, bad_flag,  bad_flag_result)
      CALL ef_get_coordinates    (id, ARG1, T_AXIS, 
     .                            arg_lo_ss(T_AXIS,ARG1),
     .                            arg_hi_ss(T_AXIS,ARG1), RR_times)

      CALL ef_get_axis_info(id, ARG1, ax_name, ax_units, 
     .                                backward, modulo, regular) 

      IF (ax_units(4) .EQ. 'sec' ) THEN 
         RR_factor = 1.
      ELSEIF (ax_units(4) .EQ. 'min')THEN
         RR_factor = 60.   
      ELSEIF (ax_units(4) .EQ. 'hour' .OR. 
     .        ax_units(4) .EQ. 'hours' )THEN
         RR_factor = 3600.  
      ELSEIF (ax_units(4) .EQ. 'day' .OR.
     .        ax_units(4) .EQ. 'days'  )THEN
         RR_factor = 86400. 
      ELSE
        WRITE (6,*)'Time axis units =', ax_units(4) 
        !CALL ef_bail_out(id,
        !.        'Time axis not specified as  sec, min, hour,or day.')
      ENDIF

      iT = 2
      l1 = arg_lo_ss(T_AXIS,ARG1) + 1     ! Note: extended time axis
      DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         
         RR_dt =  SNGL(RR_times(iT) - RR_times(iT-1))
         RR_badDt = RR_dt .EQ. 0.
 
         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            i1 = arg_lo_ss(X_AXIS,ARG1)
            DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

               k1 = arg_lo_ss(Z_AXIS,ARG1)
               DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

                  IF (arg_1(i1,j1,k1,l1)   .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1,j1,k1,l1-1) .EQ. bad_flag(ARG1) .OR.
     .                RR_badDt) THEN
                     result(i,j,k,l) = bad_flag_result
                  ELSE
                     result(i,j,k,l) = ( arg_1(i1,j1,k1,l1)
     .                    -   arg_1(i1,j1,k1,l1-1) ) / RR_dt
     .                    / RR_factor	 * sec_per_month
                  ENDIF
               
                  k1 = k1 + arg_incr(Z_AXIS,ARG1)
               ENDDO

               i1 = i1 + arg_incr(X_AXIS,ARG1)
            ENDDO

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
         ENDDO

         iT = iT + 1
         l1 = l1 + arg_incr(T_AXIS,ARG1)
      ENDDO

      END

	SUBROUTINE OPEN_METAFILE

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Routine to open GKS metafile
*	J Davison JISAO/PMEL/TMAP
*	3.15.89
*	12.20.89 *sh* - added GKS_X_CONID code for FERRET
*       03.25.91 *jd* - took out of INIT_GKS_WS to have two subroutines
*       rather than 1 with 2 entry points
*       04.22.91 *jd* - mods to support new metafile translator
*       05.06.81 *jd* - mod to maintain metafile version #'s on ultrix
*       01.06.94 *jd*   Mod to put line color rep info into metafile for xgks
*       7.26.97  *js*   Restored call to set line bundles. Forced to be same
*                          as XGKS bundles. Added subroutine query_xgks_wkstn
*                          to support workstation queries on metafiles. Fixed
*                          bug where setup_line_bundles always called with type
*                           ws_xwindow
*       2.20.98 *kob* - moved query_xgks_wkstn to its own routine.  causing
*                       problems when trying to link gksm2ps
* V602  1/07 *acm*  true batch mode for metafiles; flag meta_batch
*         distinguises this case from other batch modes.
* V68   *acm* 4/11 change how flag meta_batch is computed (different Makefile)
* V6.8 *acm* 7/9/2012 For batch graphics on RHEL6, change ITS_BATCH_GRAPHICS
*                     from logical to integer, then batch = ITS_BATCH_GRAPHICS().NE.0

	include 'pltcom_dat.decl'! with declarations    
	include 'PLTCOM.DAT'! with declarations    
	include 'gkscm1_inc.decl'! with declarations    
	include 'GKSCM1.INC'! with declarations    
	include 'gkscm2.cmn'! with declarations    
	include 'ppl_in_ferret.cmn'
	include 'ws_types.cmn'
	INCLUDE	'parampl5_dat.decl'
	INCLUDE	'PARAMPL5.DAT'
        INCLUDE 'pen_inc.decl'  ! with num_line_colors
        INCLUDE 'PEN.INC'

        integer       park_stat


#ifdef atc_gks
	include        'gkspar.inc'
#else
  	include        'gkspar.inc'
#endif

	integer 	ndx,type,error,len,tm_lenstr
	real		red,green,blue

	integer		errind,errnr,fctid
	integer         theWsType


	INTEGER ITS_META_GRAPHICS, ITS_BATCH_GRAPHICS
        LOGICAL its_meta, batch, meta_batch

C	XGKS DOESN'T DEFINE GMOUTP 
	integer		gmoutp
	parameter	(gmoutp=2)


***************************************************************************

*	Opens metafile but does not activate it.

*	OPEN METAFILE WS 
#ifdef unix
        call tm_park_last_version (meta_file,park_stat)
#   ifndef atc_gks
	open (unit=meta_lun,file=meta_file,status='new',err=100)
#   endif
#else
	open (unit=meta_lun,file=meta_file,status='new',err=100,
     .	disp='delete')
#endif
#ifdef atc_gks
*	OPEN OUTPUT GKSM METAFILE
*       TEST TO SEE IF FILE NAME IS VALID -- ATC DOESN'T EXPLICITLY OPEN FILE
	open (unit=meta_lun,file=meta_file,status='new',err=100)
        close (meta_lun,status='delete')

	call guesc050 (meta_lun,meta_file)
	theWsType = 1002
	call gopwk(meta_wsid,meta_lun,1002)
#else
	theWsType = gmoutp
#endif

	call gopwk(meta_wsid,meta_lun,theWsType)
*	call gsds (meta_wsid,gasap,gsuppd) !Better to be 'At Some TIme'
	call gsds (meta_wsid,gasti,gsuppd) 

*	IS THE GUWK CALL NEEDED FOR THE METAFILE TOO? DON'T KNOW...
*       WILL TRY TO LIVE W/O IT
*	call guwk (meta_wsid,gpostp?gperfo)

*	SET UP DEFAULT LINE BUNDLES FOR METAFILE WS
*    -- PLACE NO LINE BUNDLE INFO IN METAFILE (4.22.91)
*    -- Changed back to placing line bundle info in metafile (7.26.97)
	call setup_line_bundles (meta_wsid,theWsType) 

	meta_open = .true.
!	meta_actv = .false.

        its_meta = ITS_META_GRAPHICS() .NE. 0
        batch = ITS_BATCH_GRAPHICS() .NE. 0
	meta_batch = .FALSE.
        IF (batch) THEN
           IF (its_meta) meta_batch = .TRUE.
        ENDIF

#ifdef xgks
	if (meta_actv .OR. meta_batch) then
*		ALLOW NO WHITE LINES IN METAFILE (FOR NOW)
                call gqcr (wsid,1,type,error,red,green,blue)
                if (error .eq. 0) then
		   if (red   .eq. 1.0 .and. 
     .		       green .eq. 1.0 .and.
     .		       blue  .eq. 1.0) then
                      call gscr (meta_wsid,1,0.0,0.0,0.0)
		    else
                      call gscr (meta_wsid,1,red,green,blue)
		    endif
                else
                   call gscr (meta_wsid,1,0.0,0.0,0.0)
                endif

                do ndx = 2,num_line_colors
                   call gqcr (wsid,ndx,type,error,red,green,blue)
                   if (error .eq. 0) then
                      call gscr (meta_wsid,ndx,red,green,blue)
                   else
                      call gscr (meta_wsid,ndx,0.0,0.0,0.0)
                   endif
                end do
	end if
#endif
                                                        
 20     return

*	ERR open metafile
100	len = tm_lenstr (meta_file)  
#ifdef F90_SYSTEM_ERROR_CALLS
	call linux_perror('**ERROR: '//meta_file(1:len))
#else
	call perror ( '**ERROR: '//meta_file(1:len))
#endif
	return	
	
	end

      SUBROUTINE HDRT1 (ITAPEI, NDATA, DI, TI, DF, TF, DT)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)hdrt1.f	1.1    3/10/88
C**
C**
C***********************************************************************        C**
C**                 EPIC
C**
C***********************************************************************        C**
C**
C
C  THIS SUBROUTINE WILL READ FIRST HEADER FROM AN EPIC TIME SERIES DATA FILE ON
C  TAPE ITAPEI. IT WILL RETURN INITIAL AND FINAL DATES (TI,TF) AND DT.
C  THE WHOLE HEADER WIL BE RETURNED IN THEADER.
C
C  PROGRAMMED 10/84 BY M. VERSCHELL
C
C  MODIFIED 3/86, NNS.
C
C *kob* 1/03 - g77 port requires format of nX, rather than just X.  
C              Assuming 1x is proper
      CHARACTER*80 THEADER(8)
      COMMON /COMTHDR/ THEADER
C
C  READ IN HEADER FROM TAPE ITAPEI
C
      READ (ITAPEI) THEADER(1)
      GOTO 100
  100 DO 150 J=2,8
      READ (ITAPEI) THEADER(J)
  150 CONTINUE 
C
C  IF HEADER READ IN CORRECTLY, ISOLATE AND CONVERT STARTING TIME 
C
      READ(THEADER(1)(55:78),200) DI,TI,DF,TF
  200 FORMAT(F6.0,1X,F4.0,2X,F6.0,1X,F4.0)
      READ(THEADER(3)(55:78),300) NDATA,DT
  300 FORMAT(I6,E18.0)
      RETURN
      END

	REAL*8 FUNCTION WHOI2BC( whoi )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Convert a WHOI-formatted date of yymmddhhmm to minutes since 1-JAN-0000
*
* Steve Hankin - NOAA/PMEL/TMAP
*
* version 0.0 - based on TM_SECS_FROM_BC by Mark Verschell
* version 0.1 - calls TM_SECS_FROM_BC
* version 0.2 - bug fix: add 1900 to year
* Mod 11.22.95 J Davison for 4 digit year 
*
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
* Mod J Davison 10.15.99 Add multi calendar support. Call new routine.
*  *acm* 12/00 Change calendars to match NetCDF standard 

      INCLUDE 'calendar.decl'
      INCLUDE 'calendar.cmn'


* Argument definitions
	CHARACTER*(*)	whoi
*
* Local Definition
	INTEGER		year, month, day, hour, minute, second
	INTEGER		century
	REAL*8		TM_SECS_FROM_BC


	integer         status

****************************************************************************

* read the WHOI-formatted string
	READ ( whoi, 3000 ) year, month, day, hour, minute, second, century
 3000	FORMAT (7I2.2)
!!!!!	second = 0
	year = year + century*100

* call TMAP library routine and convert seconds to minutes
	WHOI2BC = TM_SECS_FROM_BC ( calendar_id,
     .    year, month, day, hour, minute, second, status )
     .		  / 60.D0

	RETURN
	END

	SUBROUTINE CD_GET_PARENT_GRIDS (dset,temp_axnams,status)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Loads the common block XGRID with explicitly given grid definitions from a
* netCDF file - i.e. grid definitions for variables that have a
* "parent_grid = name" attribute

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 2/92 - adds a new data set format to TMAP libraries
*              - based on TM_READ_GRIDFILE
* 10/96 *kob* - Linux port - had to move variable assignments off of
*		declaration line.
* V500: 4/99 *kob* - increase size of temp_axnams and vname to 64
* V510 *sh* 3/00 - convert to use of dynamic grids and axes
* V552 *acm* 5/03   increase vnameto 128 chars 
* V600 *ACM* attribute control. 
*             Change call to CD_GET_ATTRIB to NC_GET_ATTRIB - get attrib from 
*               linked list structure
*             CD_GET_ATTVAL replaced by NC_GET_ATTRIB, which now returns  
*               strings or real values according to attrib type
*             Replace NCINQ with NCF_INQ_DS
*             Replace NCVINQ for variables, with CD_GET_VAR_INFO
*             Replace NCDINQ with CD_GET_DS_DIMS
* V600  4/06 *acm* - additional declarations found by Solaris compiler
* V602  2/07 *acm* Fix bug 1492, changing attributes of coordinate variables 
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing
* TODO: initially leave this as 4D -- what to do with old files that have 4 slab min/max?

* argument definitions:
*	dset	       - Ferret dataset number for already opened CDF file
*       temp_axnams    - 4 axis names per grid: temp until grids are assembled
*	status	       - return status

* include files

        include 'netcdf.inc'
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
        include 'xbuild_grids.cmn'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xio.cmn_text'
	external xio_data
	include 'xtm_grid.cmn_text'
		include 'xunits.cmn_text'
	external xunits_data

* argument declarations
	INTEGER	 dset, status
* 4/99 *kob*
        CHARACTER*128 temp_axnams(nferdims,max_temp_grid)

* local parameter definitions:
      INTEGER     str_eq
      PARAMETER ( str_eq = 0 )

* local variable declarations:
* *kob* explicit definitions not allowed on decl line in linux...
*       moved it to parameter line 10/96
      LOGICAL NC_GET_ATTRIB, 
     .        got_it, do_warn, centers, coordvar
      PARAMETER (do_warn = .TRUE. ) 
      PARAMETER (centers = .TRUE. )
      INTEGER TM_LENSTR1,
     .        STR_CASE_BLIND_COMPARE, STR_UPCASE, NCF_INQ_DS,
     .        ndims, nvars, ngatts, recdim, igrid, 
     .        ivar, vartyp, nvdims, vdims(8), nvatts, vlen,
     .        grid_cnt, istat, idim, npts, maxlen, attlen,
     .        attoutflag, all_outflag, dset_num
      REAL    tmp
* 4/99 *kob*
      CHARACTER vname*128, words(8)*24
      CHARACTER*132 TM_CMPRSS, buff
      CHARACTER*1024 cbuff

      INTEGER tt  ! nice short name
      EQUIVALENCE (tt,lunit_errors)

* get the vital statistics for the data set 

        dset_num = dset
        IF (dset_num .LT. -2) dset_num = -2
        istat = NCF_INQ_DS (dset_num, ndims, nvars, ngatts, recdim )

        IF ( istat .NE. merr_ok ) CALL TM_ERRMSG
     .     ( istat+pcdferr, status, 'CD_GET_PARENT_GRIDS', dset,
     .        no_varid, no_errstring, no_errstring, *5900 )

* * * * loop through all variables in the net CDF file * * *
        DO 500 ivar = 1,nvars
      
* get the vital statistics about this variable

           CALL CD_GET_VAR_INFO (dset, ivar, vname, vartyp, nvdims,
     .                 vdims, nvatts, coordvar, all_outflag, istat)
           IF ( istat .NE. merr_ok ) CALL TM_ERRMSG
     .     ( istat+pcdferr,status,'CD_GET_PARENT_GRIDS',dset,ivar,
     .       no_errstring, no_errstring, *5900 )
           vlen = TM_LENSTR1(vname)

* is it a definition for a parent grid ? (1D based on 'grid_definition' )
          IF ( nvdims .NE. 1 ) GOTO 500

          CALL CD_GET_DS_DIMS (dset, vdims(1), buff, npts, istat)

          istat = STR_CASE_BLIND_COMPARE('grid_definition', buff(:15) )
          IF ( istat .NE. str_eq ) GOTO 500

* find next location to store info; if too many grids - give error
	  CALL TM_ALLO_TMP_GRID(igrid, status)
	  IF (status .NE. merr_ok) GOTO 5900

* get the mandatory list of axis names for this grid
          maxlen = 132
          got_it = NC_GET_ATTRIB( dset, ivar, 'axes', do_warn, 
     .                          vname(:vlen), maxlen, attlen, 
     .                          attoutflag, buff, tmp)
          IF ( .NOT.got_it ) THEN
             CALL TM_NOTE(
     .            '"axes" attribute missing from grid definition', tt)
             CALL TM_NOTE('grid defintion ignored: '//vname(:vlen), tt)
             GOTO 500
          ENDIF

* store grid name (upper case)
          istat = STR_UPCASE( grid_name(igrid), vname )

* parse the list and store the axis names in the temporary grid definition
	  grid_cnt = num_tmp_grids    ! temporary name holder pointer
	  cbuff = TM_CMPRSS(buff)
	  DO 180 idim =1, 4
 180      words(idim) = ' '
	  CALL TM_BREAK_STR(cbuff, words, 4)
          DO 185 idim = 1, 4
 185      istat = STR_UPCASE( temp_axnams(idim,grid_cnt), words(idim) )

* flag the axes that are normal in the grid so grid associations can be made
          DO 186 idim = 1, 4
             IF ( temp_axnams(idim,grid_cnt) .EQ. 'NORMAL' ) THEN
                grid_line(idim, igrid) = mpsnorm
             ELSE
                grid_line(idim, igrid) = unspecified_int4
             ENDIF
 186      CONTINUE

* get optional rotation parameter (not a string parameter)
          maxlen = 1
          got_it = NC_GET_ATTRIB( dset, ivar,  'rotation', do_warn, 
     .                          vname(:vlen), maxlen, attlen, attoutflag, 
     .                          buff, grid_rotation(igrid))

          IF ( got_it .AND. grid_rotation(igrid).NE.0.0) THEN
             CALL TM_NOTE ('rotated grids not supported - using 0.0: '
     .                      //vname(:vlen), tt)
             grid_rotation(igrid) = 0.0
          ELSE
             grid_rotation(igrid) = 0.0    ! default
          ENDIF

* get optional inner/outer product list
          maxlen = 132
          got_it = NC_GET_ATTRIB( dset, ivar, 'axis_assn', do_warn, 
     .                        vname(:vlen), maxlen, attlen, attoutflag, 
     .                        buff, tmp)
          IF ( got_it ) THEN
* ... parse the inner/outer list and store it in the grid definition
	     cbuff = TM_CMPRSS(buff)
	     DO 190 idim =1, 4
 190         words(idim) = ' '
	     CALL TM_BREAK_STR(cbuff, words, 4)
             DO 200 idim = 1, 4
                istat = STR_CASE_BLIND_COMPARE('OUTER',words(idim))
                IF ( istat .EQ. str_eq ) THEN
                   grid_out_prod(idim,igrid) = .TRUE.
                ELSE
                   CALL TM_NOTE ('inner product grids not supported: '
     .                         //vname(:vlen), tt )
                   grid_out_prod(idim,igrid) = .TRUE.
                ENDIF
 200         CONTINUE
          ELSE
             DO 210 idim = 1, 4
 210         grid_out_prod(idim,igrid) = .TRUE.    ! default
          ENDIF

 500    CONTINUE

* successful completion
 	status = merr_ok
        RETURN

* error exit
 5900   RETURN
	END

	SUBROUTINE EQUAL_DELIMIT( string, outstring, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* from a string of the form "DELIMITER=xxxx" determine the list of field
* delimiters and return in outstring

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V530: *sh* 11/00
* 2/03 *kob* - g77 port - g77 won't allow intrinsic functions in PARAMETER
*                         statements.  use an octal constant instead 
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

        IMPLICIT NONE
* calling argument declarations
	INTEGER		status
	CHARACTER*(*)	string, outstring

* internal variable declarations
	INTEGER	TM_LENSTR1, n, llen, pos, ll, ic
	CHARACTER buff*80, buff1*8

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'

* internal parameter declarations:
        CHARACTER*1     tab
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
#else
	PARAMETER     ( tab = CHAR(9))
#endif

* input is comma separated, may include "\t", "\,", and HEX characters

* get the input string
        CALL EQUAL_STR_LC( string, buff, status )   ! lower case 11/92
        IF ( status .NE. ferr_ok ) RETURN

! initialize
	n = 0
	llen = TM_LENSTR1(buff)
	
* parse out the next field (implied DO-WHILE loop)
 100	pos = INDEX(buff,',')   ! points to the terminating comma
	  IF (pos.EQ.0) THEN
	    pos = llen + 1
	  ELSEIF (pos.EQ.1) THEN
	    GOTO 5100   ! null delimiter
*  ... escaped comma?
#ifdef NO_DOUBLE_ESCAPE_SLASH
	  ELSEIF (buff(pos-1:pos-1).EQ.'\') THEN
#else
	  ELSEIF (buff(pos-1:pos-1).EQ.'\\') THEN
#endif	    
	    ll = INDEX(buff(pos+1:),',')
	    IF (ll.EQ.0) THEN
	      pos = llen + 1
	    ELSE
	      pos = pos + ll
	    ENDIF 
	  ENDIF

* interpret the next delimiter
	  n = n + 1
#ifdef NO_DOUBLE_ESCAPE_SLASH
	  IF (buff(1:1).EQ.'\') THEN
#else
	  IF (buff(1:1).EQ.'\\') THEN
#endif	     
	    IF (buff(2:2).EQ.'t' .OR. buff(2:2).EQ.'T') THEN
	      outstring(n:n) = tab
	    ELSEIF (buff(2:2).EQ.'b' .OR. buff(2:2).EQ.'B' ) THEN
	      outstring(n:n) = ' '
	    ELSEIF (buff(2:2).EQ.'n' .OR. buff(2:2).EQ.'N') THEN
	      outstring(n:n) = CHAR(12) ! newline character
	    ELSE
	      outstring(n:n) = buff(2:2)
	    ENDIF
	  ELSEIF ( buff(1:1).GE.'0'
     .	     .AND. buff(1:1).LE.'9'
     .	     .AND. pos.GT.2 ) THEN
	    buff1 = buff(:pos-1)
	    READ(buff1,'(I4)',ERR=5100) ic
	    IF (ic.GT.127) GOTO 5100
	    outstring(n:n) = CHAR(ic)  ! any decimal value
	  ELSEIF (pos.GT.2) THEN
	     GOTO 5100
	  ELSE
	    outstring(n:n) = buff(1:1)
	  ENDIF

* ... shift to the next field in the buffer
	  buff = buff(pos+1:)
	  llen = llen - pos
	IF (llen.GT.0) GOTO 100 
* -- end of implied DO-WHILE loop

* terminate with a NULL (C-style)
	outstring(n+1:n+1) = CHAR(0)

* success
	status = ferr_ok
	RETURN

* syntax error
 5000	RETURN
 5100	CALL ERRMSG( ferr_syntax, status, buff(pos:llen), *5000 )
	END

	CHARACTER*13 FUNCTION TM_STRING ( dval )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
*  Will take a double precision real and output it as a string. It will be
*  written as an integer if there is no fractional part and the value is
*  under 1,000,000 , otherwise it will be written out in G format.
*
*  written 3/87 by M. Verschell for PMEL/TMAP
*
* revision 0.00 - 03/15/87
* revision 0.10 - 02/15/89 - added temporary string
* revision 0.20 - 07/14/89 - changed format from 1PG12.6 to 1PG12.5 to catch
*			   - all real numbers
*
* argument
	REAL*8	dval
* local variable
	CHARACTER*13	temp

	temp(1:13) = ' '
	IF (ABS(dval) .LT. 1D6) THEN
	  IF (dval .EQ. DBLE(INT(dval))) THEN
	    WRITE (temp(1:12),'(I12)') INT(dval)
	    GOTO 999
	  ENDIF
	ENDIF

	WRITE (temp(1:12),'(1PG12.5)') dval

999	TM_STRING = temp
	RETURN
	END

	SUBROUTINE PARSE_COMMA_LIST ( buffer, istart, iend, max_items, 
     .				      num_it, it_start, it_end, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* find the boundaries of the "items" that are separated by commas
* istart and iend delimit the search region within the buffer and are
* both assumed to represent the positions of non-blank characters
* likewise the returned item limits will represent non-blank characters
*
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 4/7/86
* revision 1.0 - 7/28/88 - complete re-write to cope wit imbedded "[" and ""
* revision 1.1 - 8/9/88  - allow multiple commas for PLOT+ compatibility
* V230:  8/4/92 - error message lacks blanks
* V320: 12/29/94 - use WARN to avoid direct tty output (for GUI)
* Linux Port - 12/96 *kob
*	     - had to close open quotes in above comment line - linux f77
*	       was freaking out because of it...
* V530: *sh* 3/01 - remove surrounding quotes from items in list
* V532: *sh* 5/01 - ignore commas embedded in parentheses
*		  - allow for nested parens and brackets
* V533: *sh* 7/01 - allow both single and double quoted strings
* 1/03 *kob* g77 port -  Need to use risc_buff for arbitrary concatenations
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V693 *sh* 12/14 added support for _DQ_ and _SQ_ style of quotation marks
*                 changed unpaired [], {}, "", '', etc from error to acceptable

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'	! for ttout_lun
	include 'xrisc.cmn'

* calling argument declarations:
	CHARACTER*(*)	buffer
	INTEGER		istart, iend, max_items, num_it,
     .			it_start(max_items), it_end(max_items), status

* internal variable declarations:
	INTEGER		ip, i, nest_level
	CHARACTER*8	LEFINT

* initialize
	risc_buff = buffer		! for RISC/FORTRAN
	num_it = 0
	ip = istart

* TOP OF LOOP
 10	CONTINUE

	IF ( buffer(ip:ip) .EQ. ' '
     .  .OR. buffer(ip:ip) .EQ. '	' ) THEN
* skip past leading tabs and blanks to find first character
	   ip = ip + 1
	   IF ( ip .GT. iend ) GOTO 1000
	   GOTO 10
	ELSE
* found first character of item
	   IF ( num_it .EQ. max_items ) GOTO 6000
	   num_it = num_it + 1
	   it_start(num_it) = ip
	ENDIF

* comma alone representing a place holder ?
	IF ( buffer(ip:ip) .EQ. ',' ) THEN
	   it_end(num_it) = ip
	   ip = ip + 1
	   IF ( ip .GE. iend ) GOTO 1000
	   GOTO 10
	ENDIF

* search for end of item
	ip = ip - 1
 30	ip = ip + 1
	IF ( ip .GE. iend ) THEN
	   it_end(num_it) = iend
	   GOTO 1000
	ENDIF

* ... ignore commas sandwiched between [ ]
	IF ( buffer(ip:ip) .EQ. '[' ) THEN
	   nest_level = -1  ! will be immediately incremented
	   DO 40 i = ip, iend
	      IF ( buffer(i:i) .EQ. '[' ) THEN
	         nest_level = nest_level + 1
	      ELSEIF ( buffer(i:i) .EQ. ']' ) THEN
	         IF (nest_level .GT. 0) THEN
	            nest_level = nest_level - 1
	         ELSE
	            ip = i
	            GOTO 30
	         ENDIF
	      ENDIF
 40	   CONTINUE
	   GOTO 5020	! unpaired


* ... ignore commas sandwiched between ( )
	ELSEIF ( buffer(ip:ip) .EQ. '(' ) THEN
	   nest_level = -1  ! will be immediately incremented
	   DO 45 i = ip, iend
	      IF ( buffer(i:i) .EQ. '(' ) THEN
	         nest_level = nest_level + 1
	      ELSEIF ( buffer(i:i) .EQ. ')' ) THEN
	         IF (nest_level .GT. 0) THEN
	            nest_level = nest_level - 1
	         ELSE
	            ip = i
	            GOTO 30
	         ENDIF
	      ENDIF
 45	   CONTINUE
	   GOTO 5020	! unpaired

* ... ignore commas sandwiched between " "
	ELSEIF ( buffer(ip:ip) .EQ. '"' ) THEN
	   DO 50 i = ip+1, iend
	      IF ( buffer(i:i) .EQ. '"' ) THEN
	         ip = i
	         GOTO 30
	      ENDIF
 50	   CONTINUE
	   GOTO 5020	! unpaired

* ... ignore commas sandwiched between ' '   ! 7/01
	ELSEIF ( buffer(ip:ip) .EQ. "'" ) THEN
	   DO i = ip+1, iend
	      IF ( buffer(i:i) .EQ. "'" ) THEN
	         ip = i
	         GOTO 30
	      ENDIF
	   ENDDO
	   GOTO 5020	! unpaired

* ... ignore commas sandwiched between _DQ_ or _SQ_ ! 12/14
	ELSEIF ( buffer(ip:ip) .EQ. "_" 
     .     .AND. ip+3 .LE. iend         ) THEN
           IF ( buffer(ip:ip+3) .EQ. p_DQ_quote ) THEN
	      DO i = ip+4, iend-3
	         IF ( buffer(i:i+3) .EQ. p_DQ_quote ) THEN
	            ip = i+3
	            GOTO 30
	         ENDIF
	      ENDDO
	      GOTO 5020	! unpaired
           ELSEIF ( buffer(ip:ip+3) .EQ. p_SQ_quote ) THEN
	      DO i = ip+4, iend-3
	         IF ( buffer(i:i+3) .EQ. p_SQ_quote ) THEN
	            ip = i+3
	            GOTO 30
	         ENDIF
	      ENDDO
	      GOTO 5020	! unpaired
           ENDIF
           GOTO 30      ! just a harmless "_"

* ... comma as terminator
	ELSEIF ( buffer(ip:ip) .EQ. ',' ) THEN
* ... search backwards for the last non-blank/tab
	   DO 60 i = ip-1,it_start(num_it),-1
	      IF ( buffer(i:i) .NE. ' '
     .	     .AND. buffer(i:i) .NE. '	' ) THEN
	         it_end(num_it) = i
	         ip = ip + 1
	         GOTO 10
	      ENDIF
 60	   CONTINUE
	   it_end(num_it) = it_start(num_it)
	   ip = it_start(num_it) + 1
	   GOTO 10

* any other character
	ELSE
	   GOTO 30

	ENDIF	   

* remove surrounding quotes from individual items
 1000	DO i = 1, num_it
	   IF (buffer(it_start(i):it_start(i)) .EQ. '"'
     .   .AND. buffer(it_end  (i):it_end  (i)) .EQ. '"' ) THEN
	      IF ( it_end(i) .GT. it_start(i)+1 ) THEN
	         it_start(i) = it_start(i) + 1
	         it_end(i)   = it_end(i)   - 1
	      ENDIF
	   ENDIF
	ENDDO
	RETURN

* error exits
 5000	RETURN
 5020	CALL ERRMSG( ferr_syntax, status,
     .		'unpaired quotations, parens, or brackets '
     .           //pCR//risc_buff(istart:iend), *5000 )

* warning exit
* *kob 1/03 g77 port needs risc buff
 6000	risc_buff = buffer(istart:iend)
	CALL WARN( 'command incompletely processed: '
     .		//risc_buff )
	CALL WARN( 'Maximum items in command: '//LEFINT(max_items,i))
	RETURN

	END

*
* nco_attr.F
*
* Ansley Manke
* March 1, 2005
* V62  6/08 *acm* Increase attribute buffer size to 2048
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
*
* This function spawns a netCDF edit call, ncatted to edit 
* an attribute (e.g. new attribute, edit or delete atttibute,
* or add lines to the global history attribute)
*
* 
*  Notes: 
* 1) our ncatted does not have the i data type.  It returns the messages
* 
* > ncatted -O -h -a missing_value,A,o,i,3 x.nc 
* ncatted: ERROR 'i' is not a supported netCDF data type
* ncatted: HINT: Valid data types are 'c' = char, 'f' = float, 'd' = double, 's' = short, 'l' = long, 'b' = byte

* 2) errors from ncatted do not stop the function from returning normally.

      SUBROUTINE nco_attr_init(id)

* Define arguments and result

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

      CALL ef_set_desc(id, 
     .  'Call ncatted to edit attributes in a netCDF file' )
      CALL ef_set_num_args(id, 6)
      CALL ef_set_axis_inheritance_6d(id,
     .                                ABSTRACT, NORMAL,
     .                                NORMAL,   NORMAL,
     .                                NORMAL,   NORMAL)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'FileName')
      CALL ef_set_arg_desc(id, arg, 'netCDF file name')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)
      CALL ef_set_arg_type(id, arg, STRING_ARG)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'VariableName')
      CALL ef_set_arg_desc(id, arg, 'Variable name (or global)')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)
      CALL ef_set_arg_type(id, arg, STRING_ARG)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'AttributeName')
      CALL ef_set_arg_desc(id, arg, 'Attribute to change')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)
      CALL ef_set_arg_type(id, arg, STRING_ARG)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'AttType')
      CALL ef_set_arg_desc(id, arg, 'Attribute type')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)
      CALL ef_set_arg_type(id, arg, STRING_ARG)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'Mode')
      CALL ef_set_arg_desc(id, arg, 'o=edit, a=append, d=delete')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)
      CALL ef_set_arg_type(id, arg, STRING_ARG)

      arg = 6
      CALL ef_set_arg_name(id, arg, 'AttributeValue')
      CALL ef_set_arg_desc(id, arg, 'new value of attribute')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)
      CALL ef_set_arg_type(id, arg, STRING_ARG)

      RETURN 
      END

* Define abstract output axis: 1 value

      SUBROUTINE nco_attr_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id
      INTEGER ivalue

      ivalue = 1
      CALL ef_set_axis_limits(id, X_AXIS, ivalue, ivalue)

      RETURN 
      END

*
* Compute the result
*
      SUBROUTINE nco_attr_compute(id, arg_1, arg_2, arg_3, arg_4, 
     .           arg_5, arg_6, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif

      INTEGER id

      REAL arg_1(strdf,
     .           mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(strdf,
     .           mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(strdf,
     .           mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)
      REAL arg_4(strdf,
     .           mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz, 
     .           mem4lot:mem4hit, mem4loe:mem4hie, mem4lof:mem4hif)
      REAL arg_5(strdf,
     .           mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz, 
     .           mem5lot:mem5hit, mem5loe:mem5hie, mem5lof:mem5hif)
      REAL arg_6(strdf,
     .           mem6lox:mem6hix, mem6loy:mem6hiy, mem6loz:mem6hiz, 
     .           mem6lot:mem6hit, mem6loe:mem6hie, mem6lof:mem6hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

      INTEGER TM_LENSTR, TM_LENSTR1
      INTEGER arg, blen, slen
      INTEGER i, j, k, l, m, n
      REAL attval, val
      REAL*8 dattval
      INTEGER*2 isattval 
      INTEGER iattval
      CHARACTER*1 battval
      CHARACTER*1 mode, atttype
      CHARACTER*3 atttype_in
      CHARACTER*1024 filename
      CHARACTER*254 variablename, attributename, errmsg
      CHARACTER*2048 buff, attributevalue

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      arg = 1
      CALL ef_get_arg_string(id, arg, filename)
      arg = 2
      CALL ef_get_arg_string(id, arg, variablename)
      arg = 3
      CALL ef_get_arg_string(id, arg, attributename)
      arg = 4
      CALL ef_get_arg_string(id, arg, atttype_in)
      arg = 5
      CALL ef_get_arg_string(id, arg, mode)
      arg = 6
      CALL ef_get_arg_string(id, arg, attributevalue)

      IF (TM_LENSTR(atttype_in) .GT. 1) THEN
         CALL EF_BAIL_OUT(id, 
     .       'Attribute type must be f, d, i, l, s, c, or b')
      ELSE
         atttype = atttype_in(1:1)
      ENDIF

      IF ( atttype .EQ. 'i' .OR. atttype .EQ. 'l' .OR.
     .     atttype .EQ. 'I' .OR. atttype .EQ. 'L') atttype = 'l'

* Check for valid values of mode

      IF (mode .EQ. 'o' .OR. mode .EQ. 'O') THEN
         mode = 'o'
      ELSE IF (mode .EQ. 'a' .OR. mode .EQ. 'A') THEN
         mode = 'a'
      ELSE IF (mode .EQ. 'd' .OR. mode .EQ. 'D') THEN
         mode = 'd'
      ELSE
         CALL EF_BAIL_OUT(id, 'Mode must be o, a, or d')
      ENDIF

* Build the string for the ncatted command
* ncatted -O -h att_nm,var_nm,mode,att_type,att_val filename
* Mode will always be o for overwrite

      buff = 'ncatted -O -h -a '
      blen = 17

      slen = TM_LENSTR(attributename)
      buff = buff(1:blen)//attributename(1:slen)//','
      blen = blen + slen + 1

      slen = TM_LENSTR(variablename)
      buff = buff(1:blen)//variablename(1:slen)//','//mode(1:1)//','
      blen = blen + slen + 3

      slen = TM_LENSTR(atttype)
      buff = buff(1:blen)//atttype(1:slen)//','
      blen = blen + slen + 1

! ncatted -O -h -a cartesian_axis,LAT,o,c,"Z" x.nc

* Read the attribute value based on its type.
* See documentation at the end of this file for attribute types.

      IF (atttype .EQ. 'f' .OR. atttype .EQ. 'F') THEN
         READ (attributevalue,*,err=501) attval
         slen = TM_LENSTR(attributevalue)
         buff = buff(1:blen)//attributevalue(1:slen)
         blen = blen + slen

      ELSE IF (atttype .EQ. 'd' .OR. atttype .EQ. 'D') THEN
         READ (attributevalue,*,err=502) dattval
         slen = TM_LENSTR(attributevalue)
         buff = buff(1:blen)//attributevalue(1:slen)
         blen = blen + slen

      ELSE IF (atttype .EQ. 'i' .OR. atttype .EQ. 'l' .OR.
     .         atttype .EQ. 'I' .OR. atttype .EQ. 'L') THEN
         READ (attributevalue,*,err=503) iattval
         READ (attributevalue,*,err=503) attval
         val = iattval
         IF (val .NE. attval) GOTO 503
         slen = TM_LENSTR(attributevalue)
         buff = buff(1:blen)//attributevalue(1:slen)
         blen = blen + slen

      ELSE IF (atttype .EQ. 's' .OR. atttype .EQ. 'S') THEN
         READ (attributevalue,*,err=504) isattval
         WRITE (attributevalue,*) isattval
         slen = TM_LENSTR(attributevalue)
         buff = buff(1:blen)//attributevalue(1:slen)
         blen = blen + slen

      ELSE IF (atttype .EQ. 'c' .OR. atttype .EQ. 'C') THEN
         slen = TM_LENSTR(attributevalue)
         buff = buff(1:blen)//'"'//attributevalue(1:slen)//'"'
         blen = blen + slen + 3

      ELSE IF (atttype .EQ. 'b' .OR. atttype .EQ. 'B') THEN
         READ (attributevalue,*,err=505) battval
         slen = TM_LENSTR(attributevalue)
         buff = buff(1:blen)//attributevalue(1:slen)
         blen = blen + slen

      ELSE
         CALL EF_BAIL_OUT(id, 
     .       'Attribute type must be f, d, i, s, c, or b')
      ENDIF

* Append the file name

      slen = TM_LENSTR(filename)
      buff = buff(1:blen)//' '//filename(1:slen)
      blen = blen + slen + 1

* Spawn the command 

      i = res_lo_ss(X_AXIS)
      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      l = res_lo_ss(T_AXIS)
      m = res_lo_ss(E_AXIS)
      n = res_lo_ss(F_AXIS)
      result(i,j,k,l,m,n) = bad_flag_result

      CALL system( buff(1:blen) )

      result(i,j,k,l,m,n) = 1
      RETURN 

501   slen = TM_LENSTR1(attributevalue)
      errmsg = 'Error reading attribute value as floating-point '
     .         //attributevalue(1:slen)
      CALL EF_BAIL_OUT(id, errmsg)

502   slen = TM_LENSTR1(attributevalue)
      errmsg = 'Error reading attribute value as double-precision '
     .         //attributevalue(1:slen)
      CALL EF_BAIL_OUT(id, errmsg)

503   slen = TM_LENSTR1(attributevalue)
      errmsg = 'Error reading attribute value as an integer '
     .         //attributevalue(1:slen)
      CALL EF_BAIL_OUT(id, errmsg)

504   slen = TM_LENSTR1(attributevalue)
      errmsg = 'Error reading attribute value as a short integer '
     .         //attributevalue(1:slen)
      CALL EF_BAIL_OUT(id, errmsg)

505   slen = TM_LENSTR1(attributevalue)
      errmsg = 'Error reading attribute value as a byte '
     .         //attributevalue(1:slen)
      CALL EF_BAIL_OUT(id, errmsg)

      END

* ncatted documentation: here are the attribute types      
* f    Float. Value(s) specified in att_val will be stored as netCDF intrinsic type NC_FLOAT.
* d    Double. Value(s) specified in att_val will be stored as netCDF intrinsic type NC_DOUBLE.
* i    Integer. Value(s) specified in att_val will be stored as netCDF intrinsic type NC_INT.
* l    Long. Value(s) specified in att_val will be stored as netCDF intrinsic type NC_LONG.
* s    Short. Value(s) specified in att_val will be stored as netCDF intrinsic type NC_SHORT.
* c    Char. Value(s) specified in att_val will be stored as netCDF intrinsic type NC_CHAR.
* b    Byte. Value(s) specified in att_val will be stored as netCDF intrinsic type NC_BYTE. 
* 
* 3.1 netCDF external data types
* 
* The external types supported by the netCDF interface are:
* 
* char    8-bit characters intended for representing text.
* byte    8-bit signed or unsigned integers (see discussion below).
* short  16-bit signed integers.
* int    32-bit signed integers.
* float  real 32-bit IEEE floating-point.
* double 64-bit IEEE floating-point. 

	SUBROUTINE SAMPLE_SUB(  memory, cx_list, mr_list, npts, cxpts,
     .				field, mfield, cxfield, fill_value,
     .				coords, out_buf,
     .				fmt, fix_holes, ssorww,
     .				out_lun, binary, columns, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* sample the given field at the specified XYZTEF coordinates

* Each output record will consist of
*	value xcoord ycoord zcoord tcoord code
* where "code" is 0=fully successful
*		  1=successful with extrapolation
*              -1-4=failed due to beyond input data limits on axis -code
*		 -9=failed due to hole in input data field
*		-99=failed due to hole in input coordinates

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V301:  1/94
* V312: 5/94 - array "memory" as a calling argument
* V541: 2/02 *sh* - added support for modilo lengths
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xprog_state.cmn'
	include 'xmem_subsc.cmn'

* calling argument declarations:
	LOGICAL fix_holes, binary
	INTEGER	cx_list(4), mr_list(4), npts, cxpts(4), columns,
     .		mfield, cxfield, ssorww(4), out_lun, status
	REAL	memory( mem_blk_size, max_mem_blks )
	REAL	coords(npts, 4), out_buf(columns), fill_value,
     .		field( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit )
	CHARACTER fmt*(*)

* internal parameter definitions
	INTEGER     by_ss, by_ww, by_nothin
	PARAMETER ( by_ss=1, by_ww=2, by_nothin=0 )

* internal variable declarations:
	LOGICAL	extrapolate, condensed
	INTEGER	TM_MODULO_LINE_DIM,
     .		ii(4), di(4), ss(4,2), grid, idim, mr, mv_temp, ipt,
     .		i, j, k, l, ix, jy, kz, lt, hi_surrnd(4), nbuf, llen,
     .		nfix, ssfix(4,-1:1), ssp1(4), ssm1(4), line, lohi
	REAL lin_fact(4), surrnd(2,2,2,2), result, missing, res_flag,
     .		coord, missing_coord(4), sumfix
	
* equivalences
	INTEGER ss_lo(4), ss_hi(4), ihi, jhi, khi, lhi
	EQUIVALENCE (ss(1,1),ss_lo), (ss(1,2),ss_hi),
     .		    (hi_surrnd(1), ihi), (hi_surrnd(2), jhi),
     .		    (hi_surrnd(3), khi), (hi_surrnd(4), lhi)

* *** INITIALIZE ***
* background quantities
	condensed = columns .GT. 0
	nbuf = 0
	missing = mr_bad_data(mfield)
	grid = mr_grid(mfield)
	DO 10 idim = 1, 4
 10	missing_coord(idim) = mr_bad_data(mr_list(idim))

* extract the 4 coordinate variables into a single 4D array
	DO 100 idim = 1, 4
	   mr = mr_list(idim)
	   CALL CREATE_TEMP_MEM_VAR( cx_list(idim), mv_temp, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   CALL COPY_GRID(memory(1,mr_blk1(mr)),mr,
     .		          coords(1,idim), mv_temp )
	   CALL DELETE_VARIABLE( mv_temp )
 100	CONTINUE

* input sampling coordinates are a mix of single point and n point arrays
* ... ii - sample coordinate pointers (increment by delta each loop)
* ... di - delta for sample coordinate pointer (0 or 1)
	DO 200 idim = 1, 4
	   ii(idim) = 1
	   IF ( cxpts(idim) .EQ. 1 ) THEN
	      di(idim) = 0
	   ELSE
	      di(idim) = 1
	   ENDIF
 200	CONTINUE

* prepare those axes on which there will be no interpolating
* ... hi_surrnd - # of pts surrounding requested coord on each axis (1 or 2)
* ... also preload the subscript limits to avoid redoing it npts times below
	DO 210 idim = 1, 4
	   IF ( ssorww(idim) .EQ. by_nothin ) THEN
	      hi_surrnd(idim) = 1		! no interp on this axis
	      ss_lo(idim) = cx_lo_ss(cxfield, idim)
	      ss_hi(idim) = ss_lo(idim)			! needed to automate
	      lin_fact(idim) = unspecified_int4		! not needed
	   ELSE
	      hi_surrnd(idim) = 2		! interpolate on this axis
	      ss_lo(idim) = unspecified_int4
	   ENDIF
 210	CONTINUE

* *** START OF LOOP OVER ALL SAMPLING POINTS ***
	DO 2000 ipt = 1, npts

* initialize next sample point
	   res_flag = 0.

* determine the lo and hi subscript bounds of the surrounding points
* and the interpolation cooeficients for each axis
	   DO 500 idim = 1, 4
	      coord = coords(ii(idim), idim)
	      IF ( ssorww(idim) .NE. by_nothin
     .	     .AND. coord .EQ. missing_coord(idim) ) THEN
	         res_flag = -idim
	         result = fill_value
	         GOTO 1000
	      ELSEIF ( ssorww(idim) .EQ. by_ss ) THEN   ! e.g. j=55.2
	         ss_lo(idim) = INT( coord )
	         ss_hi(idim) = INT( coord + .99999 )
	         lin_fact(idim) = ss_hi(idim) - coord
	      ELSEIF ( ssorww(idim) .EQ. by_ww ) THEN
	         CALL SS_NEIGHBORS( coord, grid, idim, extrapolate,
     .				ss_lo(idim), ss_hi(idim), lin_fact(idim) )
	         IF ( extrapolate ) THEN
	            IF ( fix_holes ) THEN
	               res_flag = 1.
	            ELSE
	               res_flag = -idim
	               result = fill_value
	               GOTO 1000
	            ENDIF
	         ENDIF
	      ENDIF
 500	   CONTINUE

* check that all subscripts are within the given range of the field
	   DO 600 idim = 1, 4
	      IF ( ss_lo(idim) .LT. cx_lo_ss(cxfield, idim)
     .	      .OR. ss_hi(idim) .GT. cx_hi_ss(cxfield, idim)
     .        .OR. ss_lo(idim) .GT. ss_hi(idim)  ) THEN
	         res_flag = -idim
	         result = fill_value
	         GOTO 1000
	      ENDIF
 600	   CONTINUE

* pre-cleanse array if diagnostic testing in progress
	   IF ( mode_diagnostic ) THEN
	      DO 650 i = 1, ihi
	      DO 650 j = 1, jhi
	      DO 650 k = 1, khi
	      DO 650 l = 1, lhi
 650	      surrnd(i,j,k,l) = bad_val4
	   ENDIF

* assemble the 4-dimensional collection of surrounding points
	   DO 700 i = 1, ihi
	   DO 700 j = 1, jhi
	   DO 700 k = 1, khi
	   DO 700 l = 1, lhi
 700	   surrnd(i,j,k,l) = field(ss(x_dim,i),
     .				      ss(y_dim,j),
     .				      ss(z_dim,k),
     .				      ss(t_dim,l) )
! diag	WRITE (6,'(A/,4(1PG15.6))') ' Surrounding: ',surrnd

* check for missing values - try to fill them in if requested
	   DO 850 l = 1, lhi
	   DO 850 k = 1, khi
	   DO 850 j = 1, jhi
	   DO 850 i = 1, ihi
	      IF ( surrnd(i,j,k,l) .EQ. missing ) THEN
	         IF ( fix_holes ) THEN
* ... Try to fill hole with the average of all surrounding values
*     Procedure is to locate the subscripts surrounding the missing point
*     that may contain valid data and to average all of the data found.
*     The axes may be modulo - in which case wrap around the subscripts.
*     The supplied data (context) may or may not provide the surrounding pts   
	            nfix = 0
	            sumfix = 0.0		
	            DO 800 idim =  1, 4
	            DO 800 lohi = -1, 1
 800	            ssfix(idim,lohi) = ss(idim,i) + lohi
	            DO 810 idim = 1, 4    	 ! modulo-based subscripts
	               line = grid_line(idim,grid)
	               llen = TM_MODULO_LINE_DIM(line)
	               IF ( line.EQ.mnormal .OR. line.EQ.munknown ) GOTO 810
	               IF ( line_modulo(line) ) THEN
		          IF ( ssfix(idim,-1) .EQ. 0 )
     .					ssfix(idim,-1) = llen
		          IF ( ssfix(idim,+1) .GT. llen )
     .					ssfix(idim,+1) = 1
	               ENDIF
 810	            CONTINUE
	            DO 820 idim = 1, 4		! check context limits
	               IF (ssfix(idim,-1).LT.cx_lo_ss(cxfield,idim)
     .		       .OR.ssfix(idim,-1).GT.cx_hi_ss(cxfield,idim) ) THEN
	                  ssm1(idim) = 0
	               ELSE
	                  ssm1(idim) = -1
	               ENDIF
	               IF (ssfix(idim,+1).LT.cx_lo_ss(cxfield,idim)
     .		       .OR.ssfix(idim,+1).GT.cx_hi_ss(cxfield,idim) ) THEN
	                  ssp1(idim) = 0
	               ELSE
	                  ssp1(idim) = +1
	               ENDIF
 820	            CONTINUE
	            DO 830 lt = ssfix(t_dim,ssm1(t_dim)),
     .				ssfix(t_dim,ssp1(t_dim))
	            DO 830 kz = ssfix(z_dim,ssm1(z_dim)),
     .				ssfix(z_dim,ssp1(z_dim))
	            DO 830 jy = ssfix(y_dim,ssm1(y_dim)),
     .				ssfix(y_dim,ssp1(y_dim))
	            DO 830 ix = ssfix(x_dim,ssm1(x_dim)),
     .				ssfix(x_dim,ssp1(x_dim))
	               IF ( field(ix,jy,kz,lt) .NE. missing ) THEN
	                  nfix = nfix + 1
	                  sumfix = sumfix +  field(ix,jy,kz,lt)
	               ENDIF
 830	            CONTINUE
	            IF ( nfix .GT. 0 ) THEN
	               surrnd(i,j,k,l) = sumfix/nfix
	               res_flag = 1.
	            ELSE
	               res_flag = -9.
	               result = fill_value
	               GOTO 1000  
	            ENDIF
	         ELSE
* ... dont even try to fill the hole
	            res_flag = -9.
	            result = fill_value
	            GOTO 1000
	         ENDIF
	      ENDIF
 850	   CONTINUE

* compute the interpolated value from the fully-specified surrounding points
* ... interpolate on T axis 
	   IF (ssorww(t_dim) .NE. by_nothin) THEN
	      DO 910 i = 1,ihi
	      DO 910 j = 1,jhi
	      DO 910 k = 1,khi
 910	      surrnd(i,j,k,1) =   lin_fact(t_dim)  * surrnd(i,j,k,1)
     .			    + (1.-lin_fact(t_dim)) * surrnd(i,j,k,2)
	   ENDIF
* ... interpolate on Z axis 
	   IF (ssorww(z_dim) .NE. by_nothin) THEN
	      DO 920 i = 1,ihi
	      DO 920 j = 1,jhi
 920	      surrnd(i,j,1,1) =   lin_fact(z_dim)  * surrnd(i,j,1,1)
     .			    + (1.-lin_fact(z_dim)) * surrnd(i,j,2,1)
	   ENDIF
* ... interpolate on Y axis 
	   IF (ssorww(y_dim) .NE. by_nothin) THEN
	      DO 930 i = 1,ihi
 930	      surrnd(i,1,1,1) =   lin_fact(y_dim)  * surrnd(i,1,1,1)
     .			    + (1.-lin_fact(y_dim)) * surrnd(i,2,1,1)
	   ENDIF
* ... interpolate on X axis 
	   IF (ssorww(x_dim) .NE. by_nothin) THEN
	      surrnd(1,1,1,1) =   lin_fact(x_dim)  * surrnd(1,1,1,1)
     .			    + (1.-lin_fact(x_dim)) * surrnd(2,1,1,1)
	   ENDIF
	   result = surrnd(1,1,1,1)

* output the result
 1000	   IF ( binary ) THEN
	      IF ( condensed ) THEN
	         nbuf = nbuf + 1
	         out_buf(nbuf) = result
	         IF ( nbuf .EQ. columns ) THEN
	            WRITE ( out_lun ) out_buf
	            nbuf = 0
	         ENDIF
	      ELSE
	         WRITE ( out_lun ) result,
     .				(coords(ii(i),i),i=1,4), res_flag
	      ENDIF
	   ELSE
	       WRITE ( out_lun, fmt ) result,
     .				(coords(ii(i),i),i=1,4), res_flag
	   ENDIF
	
! diag	   WRITE (6,*) 'Result: ',result
! diag	   WRITE (6,*) 'lo/hi subscripts: ',((ss(idim,i),i=1,2),idim=1,4)
! diag	   WRITE (6,*) 'factors: ',lin_fact

* prepare for the next sample point
	   DO 1100 idim = 1, 4
 1100	   ii(idim) = ii(idim) + di(idim)

 2000	CONTINUE

* check for any output remaining in the output record buffer
	IF ( condensed .AND. nbuf.GT.0 ) 
     .		CALL WARN( 'Output columns didnt match sampling coordinates')

* success!
	RETURN

* error exits
 5000	RETURN

	END

* 
*  Subroutines for TAX_* functions
* 
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without anx fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and anx derivative works thereof, and
*  its supporting documentation for anx purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in anx publications that result from
*  the use of this software or in anx product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in anx advertising or publicity to endorse or promote anx products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with anx support, consulting,
*  training or assistance of anx kind with regard to the use, operation
*  and performance of this software nor to provide the user with anx
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND Anx EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR Anx SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR Anx DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
****************************************************************
*
* V6.2 ACM 2/12/2008  Fix bug 1629 in JULIAN_DAY_OF_YEAR. Always
*          set ndaymo(2) to either 28 or 29. It does not get reset
*          by the DATA statement on re-entry to the routine.
* v745 *acm* 12/18  Issue 1909, option to write dates in ISO8601 format
* v745 *acm* 12/18  New TAX_DATE_STRINGS called by TAX_DATESTRING fcn

      SUBROUTINE LOWER_CASE(TEXT)
      IMPLICIT NONE
      CHARACTER*(*) TEXT
*
*     Converts a string to lowercase.
*
      EXTERNAL LENGTH_OF_TEXT
      INTEGER  LENGTH_OF_TEXT
      CHARACTER*1 LETTER
      INTEGER ISHIFT,I
      ISHIFT=ICHAR('a')-ICHAR('A')
      DO 10 I=1,LENGTH_OF_TEXT(TEXT)
        LETTER=TEXT(I:I)
        IF('A'.LE.LETTER.AND.LETTER.LE.'Z') THEN
          TEXT(I:I)=CHAR(ICHAR(LETTER)+ISHIFT)
        END IF
   10 CONTINUE
      RETURN
      END

***************************************************************
*
      INTEGER FUNCTION LENGTH_OF_TEXT(TEXT)
      IMPLICIT NONE
      CHARACTER*(*) TEXT
*
*     Computes the length of a string without trailing blanks.
*
      INTEGER I

      DO 1 I=LEN(TEXT),1,-1
        IF(TEXT(I:I).NE.' ') THEN
          GO TO 2
        END IF
    1 CONTINUE
      I=1
    2 CONTINUE
      LENGTH_OF_TEXT=I

      RETURN
      END


************************************************************************      
*     This subroutine returns day number of current year and the total 
*     number of days of current year.
      SUBROUTINE JULIAN_DAY_OF_YEAR(cmon, imon, day_of_mon, iyear, 
     .           day_of_year, days_this_year)

*     Convert day of month to day of year

      IMPLICIT NONE

* calling arguments
      INTEGER imon, day_of_mon, iyear, 
     .           day_of_year, days_this_year
      CHARACTER*3 cmon

* Local variables
      INTEGER i 
      CHARACTER*3 months(12)
      INTEGER ndaymo(12)

      DATA months/'JAN', 'FEB', 'MAR', 'APR', 'MAY', 'JUN', 'JUL',
     .            'AUG', 'SEP', 'OCT', 'NOV', 'DEC'/

      DATA ndaymo/31,28,31,30,31,30,31,31,30,31,30,31/

* If they sent in a character month, convert it to month number
      IF (cmon .NE. 'XXX') THEN
         imon = 0
         DO 100 i=1,12
             IF(cmon .EQ. months(i)) imon = i 
 100     CONTINUE
      ENDIF

*     Check if it is a leap year
* (Fixing bug 1639, need ELSE ndaymo(2) = 28; the data statement 
* above does NOT reset the value to 28 next time we enter this routine!!  

      IF ( ((mod(iyear,4) .EQ. 0) .AND. (mod(iyear,100) .NE. 0)) 
     .     .OR.
     .     (mod(iyear, 400) .EQ. 0)) THEN
          ndaymo(2) = 29
      ELSE 
          ndaymo(2) = 28
      END IF

*     Compute day number within current year
      day_of_year = day_of_mon
      DO 200 i =1, imon -1
          day_of_year = day_of_year + ndaymo(i) 
 200  CONTINUE

*     Compute total days of current year
      days_this_year = 0
      DO 300 i =1, 12 
          days_this_year = days_this_year + ndaymo(i)
 300  CONTINUE

      RETURN
      END

* **********************************************************************

*     Convert day of month to day since 1900
*     Returns -1 if the year is before 1900

      SUBROUTINE JULIAN_DAY_OF_YEAR1900(cmon, imon, day_of_mon, iyear,
     .   day_since_1900)

      IMPLICIT NONE
      
* calling arguments

      INTEGER imon, day_of_mon, iyear, day_since_1900
      CHARACTER*3 cmon

      INTEGER i, j
      INTEGER yrstart,yrend
      LOGICAL isafter1900
      CHARACTER*3 months(12)
      INTEGER day_of_year, ndaymo(12)

      DATA months/'JAN', 'FEB', 'MAR', 'APR', 'MAY', 'JUN', 'JUL',
     .            'AUG', 'SEP', 'OCT', 'NOV', 'DEC'/

      DATA ndaymo/31,28,31,30,31,30,31,31,30,31,30,31/

* If they sent in a character month, convert it to month number
      IF (cmon .NE. 'XXX') THEN
         imon = 0
         DO 100 i=1,12
             IF(cmon .EQ. months(i)) imon = i 
 100     CONTINUE
      ENDIF

      yrstart = 1900
      yrend = iyear-1
      isafter1900 = .TRUE. 
      day_since_1900 = -1

      IF(iyear .LT. 1900) THEN
          yrstart = iyear+1
          yrend = 1899
          isafter1900 = .FALSE.          
          day_since_1900 = 0
      ENDIF

*     Total days between yrstart and yrend
      DO 200 i = yrstart, yrend

*     Check if it is a leap year
          IF ( ((mod(i,4) .EQ. 0) .AND. (mod(i,100) .NE. 0))
     .     .OR.
     .     (mod(i, 400) .EQ. 0)) THEN
              ndaymo(2) = 29
          ELSE
              ndaymo(2) = 28
          ENDIF
 
          day_since_1900 = day_since_1900 + 
     .                    (ndaymo(2) + 7*31 + 4*30)

 200  CONTINUE

*     Add days of current year
      IF ( ((mod(iyear,4) .EQ. 0) .AND. (mod(iyear,100) .NE. 0))
     .     .OR.
     .     (mod(iyear, 400) .EQ. 0)) THEN
          ndaymo(2) = 29
      ELSE
          ndaymo(2) = 28
      ENDIF

      IF(isafter1900) THEN
*     Year after 1900
          day_of_year = day_of_mon
          DO 300 j =1, imon -1
              day_of_year = day_of_year + ndaymo(j)
 300      CONTINUE
       
          day_since_1900 = day_since_1900 + day_of_year
      ELSE
*     Year before 1900
          day_of_year = day_of_mon
          DO 400 j =1, imon -1
              day_of_year = day_of_year + ndaymo(j)
 400      CONTINUE

          day_since_1900 = -1*(day_since_1900 + 
     .                     ndaymo(2) + 7*31 + 4*30- day_of_year+1)

      ENDIF

      RETURN
      END
*                                                                      ^
*                                                                      |
*                                                                      |
* **********************************************************************


      SUBROUTINE tax_format_message (L1, err_msg)
C   Create a message saying arg1 values at index are duplicate

      IMPLICIT NONE
      INTEGER L1
      CHARACTER*(*) err_msg
      
      REAL v1, v2
      INTEGER n1, n2
      CHARACTER TM_FMT*48, buff1*15, buff2*15

      v1 = L1-1
      v2 = L1
      buff1 = TM_FMT(v1, 10, 12, n1) 
      buff2 = TM_FMT(v2, 10, 10, n2) 
      
      IF (n1 .GE. 14 .OR. n2 .GE. 14) THEN
         WRITE (err_msg, 1014) L1-1, L1
      ELSEIF (n1 .GE. 12 .OR. n2 .GE. 12) THEN
         WRITE (err_msg, 1012) L1-1, L1
      ELSEIF (n1 .GE. 10 .OR. n2 .GE. 10) THEN
         WRITE (err_msg, 1010) L1-1, L1
      ELSEIF (n1 .GE. 8 .OR. n2 .GE. 8) THEN
         WRITE (err_msg, 1008) L1-1, L1
      ELSE
         WRITE (err_msg, 1000) buff1(1:n1), buff2(1:n1)
      ENDIF

1000  FORMAT ('Duplicate times in ARG1, may arise from double- to single- ',
     .          'precision conversion. At indices ', A, ',', A)
1014  FORMAT ('Duplicate times in ARG1, may arise from double- to single- ',
     .          'precision conversion. At indices ', 2i16)
1012  FORMAT ('Duplicate times in ARG1, may arise from double- to single- ',
     .          'precision conversion. At indices ', 2i14)
1010  FORMAT ('Duplicate times in ARG1, may arise from double- to single- ',
     .          'precision conversion. At indices ', 2i12)
1008  FORMAT ('Duplicate times in ARG1, may arise from double- to single- ',
     .          'precision conversion. At indices ', 2i10)

      RETURN
      END

      

      SUBROUTINE TAX_REFORMAT_DATE (indate, outdate, dlen)

* From tm_date_reformat, just the portion that calls TM_BREAK_FMT_DATE_C

*     If there is a T between the date and time (as in GRIB files) replace with a space.

        IMPLICIT NONE
#include "gt_lib.parm"

	CHARACTER*(*)   indate, outdate
	INTEGER		dlen

	CHARACTER*32 buff

	INTEGER TM_BREAK_FMT_DATE_C, slen, year, month, day,
     .          hour, minute, second, status, outform
	PARAMETER ( slen = 32)

	REAL fsecond
#ifdef sun
	BYTE       dhol(slen)     !c-type Hollerith string buffers
#else
	INTEGER*1  dhol(slen)     !c-type Hollerith string buffers
#endif

*     If there is a T between the date and time (as in GRIB files) replace with a space.
        buff = indate
	IF (buff(11:11) .EQ. 'T') buff(11:11) = ' '
	IF (buff(11:11) .EQ. 'Z') buff(11:11) = ' '
 
* Break up into year, month, day, ...
	CALL TM_FTOC_STRNG( buff(:slen), dhol, slen)
	status = TM_BREAK_FMT_DATE_C(dhol, year, month,
     .                              day, hour, minute, fsecond)
	IF ( status .NE. 0 ) GOTO 5100

	second = NINT(fsecond)       ! information loss ...

* and reassemble it into the desired output format
	outform = pdate_vax 

	CALL TM_MAKE_FMT_DATE ( outform, outdate, year, month, day,
     .                         hour, minute, second, dlen )

 5000	RETURN
 5100	outdate = 'xxx'
        dlen = 3
	GOTO 5000
	END



* Convert time coordinates to dates.  If fractional seconds are needed
* for the formatting, this may be run a second time for consistent formatting
* when some times fall on an even second.

      SUBROUTINE TAX_DATE_STRINGS (arg_1, result, arg_lo_ss, arg_incr, 
     .                res_lo_ss, res_hi_ss, get_prec, dir, precistring, 
     .                tmodulo, bad_flag, status)


      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .           memresloz:memreshiz, memreslot:memreshit,
     .           memresloe:memreshie, memreslof:memreshif)

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS)
      INTEGER get_prec, dir, status

      LOGICAL tmodulo, default_datefmt, first

      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i3, j3, k3, l3, m3, n3
      INTEGER slen, dlen, prec_full
      CHARACTER*35 datestring
      CHARACTER*(*) precistring
      REAL*8 ddate

      status = 0
      prec_full = 7
      first = .TRUE.

      n1 = arg_lo_ss(F_AXIS,ARG1)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

      m1 = arg_lo_ss(E_AXIS,ARG1)
      DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

      l1 = arg_lo_ss(T_AXIS,ARG1)
      DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

      k1 = arg_lo_ss(Z_AXIS,ARG1)
      DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

      j1 = arg_lo_ss(Y_AXIS,ARG1)
      DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

      i1 = arg_lo_ss(X_AXIS,ARG1)
      DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         ddate = arg_1(i1,j1,k1,l1,m1,n1) 
         ddate = ddate  
         IF ( ddate .eq. bad_flag(ARG1) ) THEN
	     datestring = '...'
             slen = 3   
	     CALL EF_PUT_STRING(datestring, slen,
     .                                  result(i,j,k,l,m,n))
	     CYCLE
	  ENDIF

*     Get the date string corresponding to time ddate for the variable ARG2
         CALL EF_GET_AXIS_DATES (id, ARG2, ddate, dir, 1, 
     .                   prec_full, dlen, datestring)

* Are we using the default date format or ISO-8601 format? 

         IF (first) THEN
	    default_datefmt = (datestring(3:3) .EQ. '-')
	    first = .FALSE.
	 ENDIF

*     Assign the appropriate substring to the result.
            
         IF (default_datefmt) THEN  ! formatting as Ferret-style date strings

	    IF ( .NOT. tmodulo ) THEN

	       IF ( precistring .EQ. 'sec' ) THEN
                  slen = MAX(dlen, 20)
                  CALL EF_PUT_STRING(datestring, slen,
     .                               result(i,j,k,l,m,n))
               ELSE IF ( precistring .EQ. 'min' ) THEN
                  slen = 17
                  CALL EF_PUT_STRING(datestring(1:17), slen,
     .                               result(i,j,k,l,m,n))
               ELSE IF ( precistring .EQ. 'hou' ) THEN
                  slen = 14
                  CALL EF_PUT_STRING(datestring(1:14), slen,
     .                               result(i,j,k,l,m,n))
               ELSE IF ( precistring .EQ. 'day' ) THEN
                  slen = 11
                  CALL EF_PUT_STRING(datestring(1:11), slen,
     .                               result(i,j,k,l,m,n))
               ELSE IF ( precistring .EQ. 'mon' ) THEN
                  slen = 8
                  CALL EF_PUT_STRING(datestring(4:11), slen,
     .                               result(i,j,k,l,m,n))
               ELSE IF ( precistring .EQ. 'yea' ) THEN
                  slen = 4
                  CALL EF_PUT_STRING(datestring(8:11), slen,
     .                               result(i,j,k,l,m,n))
               ELSE
                  slen = 20
                  CALL EF_PUT_STRING (datestring, slen,
     .                               result(i,j,k,l,m,n))
               ENDIF

            ELSE  ! modulo time axis.  datestring looks like 15-FEB 02:54:36

               IF ( precistring .EQ. 'sec' ) THEN
                  slen = 15
                  CALL EF_PUT_STRING(datestring(1:15), slen,
     .                               result(i,j,k,l,m,n))
               ELSE IF ( precistring .EQ. 'min' ) THEN
                  slen = 12
                  CALL EF_PUT_STRING(datestring(1:12), slen,
     .                               result(i,j,k,l,m,n))
               ELSE IF ( precistring .EQ. 'hou' ) THEN
                  slen = 9
                  CALL EF_PUT_STRING(datestring(1:9), slen,
     .                               result(i,j,k,l,m,n))
               ELSE IF ( precistring .EQ. 'day' ) THEN
                  slen = 6
                  CALL EF_PUT_STRING(datestring(1:6), slen, 
     .                               result(i,j,k,l,m,n))
               ELSE IF ( precistring .EQ. 'mon' ) THEN
                  slen = 3
                  CALL EF_PUT_STRING(datestring(4:6), slen,
     .                               result(i,j,k,l,m,n))
               ELSE IF ( precistring .EQ. 'yea' ) THEN
                  datestring = '...'
                  slen = 3
                  CALL EF_PUT_STRING(datestring, slen,
     .                               result(i,j,k,l,m,n))
               ELSE
                           slen = 15
                           CALL EF_PUT_STRING(datestring, slen,
     .                                        result(i,j,k,l,m,n))
               ENDIF

            ENDIF  ! Modulo time

         ELSE  ! Iso8601, datestring = 'yyyy-mm-dd hh:mm:ss"
            IF ( precistring .EQ. 'sec' ) slen = MAX(dlen, 20)
            IF ( precistring .EQ. 'min' ) slen = 16
            IF ( precistring .EQ. 'hou' ) slen = 13
            IF ( precistring .EQ. 'day' ) slen = 10
            IF ( precistring .EQ. 'mon' ) slen = 7
            IF ( precistring .EQ. 'yea' ) slen = 4
            CALL EF_PUT_STRING(datestring, slen, result(i,j,k,l,m,n))

         ENDIF

         i1 = i1 + arg_incr(X_AXIS,ARG1)
 100  CONTINUE

         j1 = j1 + arg_incr(Y_AXIS,ARG1)
 200  CONTINUE

         k1 = k1 + arg_incr(Z_AXIS,ARG1)
 300  CONTINUE

         l1 = l1 + arg_incr(T_AXIS,ARG1)
 400  CONTINUE

         m1 = m1 + arg_incr(E_AXIS,ARG1)
 500  CONTINUE

         n1 = n1 + arg_incr(F_AXIS,ARG1)
 600  CONTINUE

	status = 0
	
	RETURN

	END

	SUBROUTINE XEQ_REPEAT

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* sets up the control stack (COMMON/~CONTROL/) to repeat the indicated
* command for a range of default contexts
* eg. "REPEAT/T=27740:35000:10 CONTOUR/@N/K=1 TEMP"

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 4/29/87
* revision 0.1 - 9/16/87 - unknown_qual_bad moved to FERRET.PARM
* revision 0.2 - 9/25/87 - added "d" notation for REPEAT limits
* revision 0.3 - 4/11/88 - special checks on T axis for calendar notation
* revision 0.4 - 7/27/88 - added default context to GET_CONTEXT_MODS call
* revision 0.5 -10/31/88 - limits reversed for negative delta
* V200:  6/15/89 - eliminated "d" notation and "relative" logic
* Unix/RISC port - 1/91 - cant use "/star" in documentation
* V230:  7/23/92 - added cs_save_* to restore context after REPEAT loops
*       - add check on cx_calendar rather than cx_lo/hi_ww to indicate 
*         whether time is date or timesteps
* 12/97 *kob* - use new logical cs_is_calendar
* V554 1/04 *acm* - additions for /RANGE repeat loop control
* V56  3/04 *acm* - initialize cat flag before error checks; change messages when
*                   user attempts to use a pseudo-variables for /NAME=
*      6/04 ywei  - changed MATCH_NAME to allow optimization
* V57  6/04 *acm* - clean up declarations
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction.
* V695  *acm* 2/15 cx_calendar stores info about calendar formatting of T and F axes
*                  Likewise cs_calendar_f for the F information in the command stack

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'command.parm'
	include 'errmsg.parm'
	include 'slash.parm'
	include 'xcontext.cmn'
	include 'xcontrol.cmn'
	include 'xprog_state.cmn'
	include 'xtext_info.cmn'
	include 'xplot_state.cmn'
	include 'xplot_setup.cmn'
	include	'gkscm1_inc.decl'	! with gks common
	include	'GKSCM1.INC'            ! with gks common
        include 'rpn.parm'              ! with maxatoms
        include 'xalgebra.cmn'
        include 'xvariables.cmn'

* local variable declarations
	LOGICAL	by_date, report_unknown, range
	INTEGER	INDEX, i, idim, limits_cx, status, csp1, rlo, rhi, rdel
	REAL*8	temp
 
	INTEGER STR_UPCASE, TM_LENSTR1, loc, equal_pos, last_pos, 
     .          cvar, istart, iflag, locr, cat, var, slen,
     .          j, num_indices
	REAL val
	CHARACTER counter_name*128
	LOGICAL loop

* check that something was given to repeat
	IF ( num_args .EQ. 0 ) CALL ERRMSG
     .			( ferr_invalid_command, status, 'REPEAT what ?', *5000 )


* Did they specify /NAME without /RANGE=?

          loc = qual_given(slash_repeat_name) 
          IF (loc .GT. 0) THEN
             locr = qual_given(slash_repeat_range) 

	     IF (locr .LE. 0) GO TO  5100

          ENDIF

*acm 1/01 check to see if we are using /RANGE=
       loc = qual_given(slash_repeat_range) 
       range = (qual_given(slash_repeat_range) .GT. 0)
       IF (range) THEN
          idim = 1

           last_pos = qual_end(loc)
           equal_pos = 
     .          INDEX(cmnd_buff(qual_start(loc):last_pos), '=') +
     .          qual_start(loc) - 1


* Did they specify /RANGE and also /I/J/K/L/M/N/X/Y/Z/T/E/F ?
	   report_unknown = .FALSE.
	   limits_cx = cx_stack_ptr_base + 1
	   CALL INIT_CONTEXT_MODS ( limits_cx )
	   CALL GET_CONTEXT_MODS ( cx_last,
     .				cmnd_buff,
     .				limits_cx,
     .				max_qual_list,
     .				num_qualifiers,
     .				qual_start,
     .				qual_end,
     .				report_unknown,
     .				status	)
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   DO 100 i = 1, nferdims
	      IF ( cx_given(i,limits_cx) ) GOTO 5300
 100	   CONTINUE

* Are we using a name for the repeat counter?
          counter_name = 'REPCOUNT'

          loc = qual_given(slash_repeat_name) 
          IF (loc .GT. 0) THEN

	     CALL EQUAL_STR_LC( cmnd_buff(qual_start(loc):qual_end(loc)),
     .                        counter_name, status )

             IF ( status .NE. ferr_ok ) GOTO 5000

* Check for legal name: not already defined, not a pseudo-var
* Only check for pseudo_vars I,J,K,L,M,N, X,Y,Z,T,E,F.  These cannot
* be used as counter vars.

             cat = 0
	     CALL FIND_VAR_NAME ( pdset_irrelevant, counter_name, 
     .                            cat, var )
             IF ( cat .EQ. cat_pseudo_var   ) THEN

	         CALL string_array_find(alg_pvar_head,
     .                           counter_name,
     .                           LEN(counter_name),
     .                           string_array_result(1),
     .                           max_uvar,
     .                           num_indices)
                 IF(num_indices.GT.0) THEN
                    var=string_array_result(1)
                    IF(var.LE.9)THEN
                        GOTO 5200
                    ELSE
                        GOTO 5250
                    ENDIF
                 ENDIF
             ENDIF
             IF ( cat .EQ. cat_counter_var   ) GOTO 5400

          ENDIF

* allocate next spot for the given limits on the control stack
* ... but leave the stack in place in case of errors in this routine

	   CALL STACK_PTR_UP( csp, cs_max, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   csp1 = csp
	   CALL STACK_PTR_DN( csp, 0, status )

* File the expression and name in the counter-variable area and set up the
* context so the command stack can be loaded 

           istart = 1
	   CALL INIT_COUNTER_VAR ( counter_name, cmnd_buff(equal_pos+1:last_pos), 
     .             istart, last_pos-equal_pos, rlo, rhi, rdel, cvar, status )

	   IF ( status .NE. ferr_ok ) RETURN

* load the start and end limits and the increment

           cs_by_ss( csp1 ) = .TRUE.
	   cs_delta( csp1 ) = rdel
	   cs_limit( csp1 ) = rhi
	   cs_phase( csp1 ) = rlo
	
* error message if delta is 0

           IF (cs_delta( csp1 ) .EQ. 0) CALL ERRMSG( ferr_invalid_command, status,
     .			'Delta value on REPEAT must be nonzero', *5000 )

* save the current context so it can be restored afterwards

           cs_save_by_ss( csp1 ) = cx_by_ss(idim,cx_last)
           IF ( cs_save_by_ss(csp1) ) THEN
              cs_save_lo( csp1 ) = cx_lo_ss (cx_last,idim)
              cs_save_hi( csp1 ) = cx_hi_ss (cx_last,idim)
           ELSE
              cs_save_lo( csp1 ) = cx_lo_ww (idim,cx_last)
              cs_save_hi( csp1 ) = cx_hi_ww (idim,cx_last)
              cs_save_cal( csp1) = cx_cal_id (cx_last)
           ENDIF

* Save name of REPEAT/RANGE variable

           csp_cvar(cvar) = csp1
           IF (counter_name .EQ. 'repcount') THEN
              cs_repeatname( csp1 ) = 'REPCOUNT'
           ELSE
              iflag = STR_UPCASE( cs_repeatname( csp1 ), counter_name )
           ENDIF

* stack bump  ???
	   CALL STACK_PTR_UP( csp, cs_max, status )

* load the axis to which the limits apply
	   cs_axis( csp ) = idim

* load the command line to be repeatedly executed
	   cs_text( csp ) = cmnd_buff( arg_start(1):len_cmnd )

* and tell 'em who owns this level
	   cs_cmnd_num( csp ) = cmnd_repeat

* and set the default context in preparation for first call
!	   CALL CS_SET_CONTEXT  !??? Not for REPEAT/RANGE

* success - tell 'em we've taken over and start workin'
	   cs_in_control = .TRUE.
	   input_source  = input_from_cs

* kob 1/01 - check to see if there is a loop in the repeat command.  if so, set
*            cs_loop accordingly
	   loc = qual_given(slash_repeat_loop)
	   IF (loc .GT. 0) THEN
	      loop = .TRUE.
	      cs_start(csp1) = cs_phase(csp1)
	      CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .	           val, status ) ! syntax check
	      IF ( val .NE. unspecified_val4 .AND. val .NE. 0) THEN
                 cs_loop(csp1) = INT(val)
	      ELSE
                  cs_loop(csp1) = 1
	      ENDIF
	   ENDIF
*kob 1/01 check to see if we are in an animation repeat loop
	   animate = qual_given(slash_repeat_animate) .GT. 0
           IF (animate) THEN
* set first_frame to true - we don't need to animate first frame - its
*   already in the plot window
	      first_frame = .TRUE. 
	   ENDIF

        ELSE  ! not /RANGE

* get the limits for repeating
*  eg. "REPEAT/X=160E:140W:10 LIST/X=-5D:+5D/Y=0D:5D TEMP"
	   limits_cx = cx_stack_ptr_base + 1
* *kob* 1/00 - dont report unknown command qualifiers
	   report_unknown = .FALSE.
	   CALL INIT_CONTEXT_MODS ( limits_cx )


	   CALL GET_CONTEXT_MODS ( cx_last,
     .				cmnd_buff,
     .				limits_cx,
     .				max_qual_list,
     .				num_qualifiers,
     .				qual_start,
     .				qual_end,
     .				report_unknown,
     .				status	)

	   IF ( status .NE. ferr_ok ) GOTO 5000

* determine the (unique) axis of REPEATing
	   idim = unspecified_int4
	   DO 200 i = 1, nferdims
	      IF ( cx_given(i,limits_cx) ) THEN
	         IF ( idim .EQ. unspecified_int4 ) THEN
	            idim = i
	         ELSE
	            CALL ERRMSG( ferr_invalid_command, status,
     .			'Use nested REPEAT for multiple axes', *5000 )
	         ENDIF
 	      ENDIF
 200	   CONTINUE
	   IF ( idim .EQ. unspecified_int4 ) CALL ERRMSG
     .		(ferr_invalid_command,status,'REPEAT on which axis ?',*5000)

* allocate next spot for the given limits on the control stack
* ... but leave the stack in place in case of errors in this routine
	   CALL STACK_PTR_UP( csp, cs_max, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   csp1 = csp
	   CALL STACK_PTR_DN( csp, 0, status )

* load the start and end limits and the increment

	   cs_by_ss( csp1 ) = cx_by_ss( idim, limits_cx )
           IF ( cx_delta( idim, limits_cx ) .EQ. unspecified_val8 ) THEN
	      cs_delta( csp1 ) = 1
	   ELSE
	      cs_delta( csp1 ) = cx_delta( idim, limits_cx )
	   ENDIF
	   IF ( cs_by_ss( csp1 ) ) THEN
	      cs_limit( csp1 ) = cx_hi_ss( limits_cx, idim )
	      cs_phase( csp1 ) = cx_lo_ss( limits_cx, idim )
	   ELSE
	      cs_limit( csp1 ) = cx_hi_ww( idim, limits_cx )
	      cs_phase( csp1 ) = cx_lo_ww( idim, limits_cx )
           ENDIF

* error message if delta is 0

           IF (cs_delta( csp1 ) .EQ. 0) CALL ERRMSG( ferr_invalid_command, status,
     .			'Delta value on REPEAT must be nonzero', *5000 )

           cs_repeatname( csp1 ) = unspecified_name4

* save the current context so it can be restored afterwards

           cs_save_by_ss( csp1 ) = cx_by_ss(idim,cx_last)
           IF ( cs_save_by_ss(csp1) ) THEN
              cs_save_lo( csp1 ) = cx_lo_ss (cx_last,idim)
              cs_save_hi( csp1 ) = cx_hi_ss (cx_last,idim)
           ELSE
              cs_save_lo( csp1 ) = cx_lo_ww (idim,cx_last)
              cs_save_hi( csp1 ) = cx_hi_ww (idim,cx_last)
              cs_save_cal(csp1 ) = cx_cal_id (cx_last)
           ENDIF

* special check for the validity of time axis limits: calendar dates are
* stored as negative seconds since 1-jan-0000:00:00:00
* 8/97 *kob* use cx_calender to check if time is date rather than time step
* 12/97 *kob* set new logical cs_is_calendar now as well
	   by_date = ( idim .EQ. t_dim .OR. idim .EQ. f_dim )
     .	   .AND. ( .NOT.cx_by_ss(idim,limits_cx) )
     .	   .AND. ( cx_calendar(idim,limits_cx) )
* ... delta value in hours: hours-->seconds (to add to secs from BC)
	   IF ( by_date ) THEN
               cs_delta(csp1) =  -3600. * cs_delta(csp1)
	       IF ( idim .EQ. t_dim) cs_is_calendar_t(csp1) = .TRUE.
	       IF ( idim .EQ. f_dim) cs_is_calendar_f(csp1) = .TRUE.
               cs_cal_id(csp1) = 1
	   ENDIF

* reverse limits if negative delta is desired
	   IF (( ( .NOT.by_date .AND. (cs_delta(csp1) .LT. 0.0D0) )
     .   	.OR. (      by_date .AND. (cs_delta(csp1) .GT. 0.0D0) ) ) ) THEN
	      temp = cs_phase(csp1)
	      cs_phase(csp1) = cs_limit(csp1)
	      cs_limit(csp1) = temp
	   ENDIF

* from here on no errors can occur so make the stack bump permanent
	   CALL STACK_PTR_UP( csp, cs_max, status )

* load the axis to which the limits apply
	   cs_axis( csp ) = idim

* load the command line to be repeatedly executed
	   cs_text( csp ) = cmnd_buff( arg_start(1):len_cmnd )

* and tell 'em who owns this level
	   cs_cmnd_num( csp ) = cmnd_repeat

* and set the default context in preparation for first call
	   CALL CS_SET_CONTEXT

* success - tell 'em we've taken over and start workin'
   	   cs_in_control = .TRUE.
	   input_source  = input_from_cs

* kob 1/01 - check to see if there is a loop in the repeat command.  if so, set
*            cs_loop accordingly
	      loc = qual_given(slash_repeat_loop)
	      IF (loc .GT. 0) THEN
	         loop = .TRUE.
	         cs_start(csp1) = cs_phase(csp1)
	         CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .	              val, status ) ! syntax check
	         IF ( val .NE. unspecified_val4 .AND. val .NE. 0) THEN
	   	    cs_loop(csp1) = INT(val)
	         ELSE
		    cs_loop(csp1) = 1
	         ENDIF
	      ENDIF
*kob 1/01 check to see if we are in an animation repeat loop
	   animate = qual_given(slash_repeat_animate) .GT. 0
           IF (animate) THEN
* set first_frame to true - we don't need to animate first frame - its
*   already in the plot window
	     first_frame = .TRUE. 
	   ENDIF

        ENDIF  ! IF (range)

	RETURN

* error exit
* ... control stack pointer, CSP, corrected in GFD_ERROR_HANDLER
 5000	RETURN

 5100	CALL ERRMSG( ferr_invalid_command, status,
     .		'REPEAT/NAME requires /RANGE', *5000 )
 5200   CALL ERRMSG( ferr_syntax,status,
     .  counter_name(1:1)//
     . ' is a pseudo-variable; '
     . //'cannot use with REPEAT/RANGE/NAME.'
     . //' Instead use REPEAT/'//counter_name(1:1)//'=',*5000 )
 5250  slen = TM_LENSTR1(counter_name)
       CALL ERRMSG( ferr_syntax,status,
     .  counter_name(1:slen)//' is a pseudo-variable; '
     . //'cannot use with REPEAT/RANGE/NAME=',*5000 )
 5300   CALL ERRMSG( ferr_syntax,status,
     .  'REPEAT/RANGE cannot be used with an axis qualifier '//
     .  cmnd_buff ,*5000 )

 5400   CALL ERRMSG( ferr_syntax,status,
     .  'nested REPEAT loops with the same counter name '
     .             //counter_name,*5000 )

	END

*
* zreverse.F
*
* Ansley Manke
* Sep 15 2004
*
* This function returns the Z values of the input variables,
* reversed and on an abstract Z axis. Other axes are unchanged.
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE zreverse_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

      CALL ef_version_test(ef_version)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     . 'Returns values reversed in Z direction on an abstract Z axis')

      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, ABSTRACT, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 'Variable to reverse')
      CALL ef_set_axis_influence(id, arg, YES, YES, NO, YES)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END



      SUBROUTINE zreverse_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER nz

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nz = arg_hi_ss(Z_AXIS,ARG1) - arg_lo_ss(Z_AXIS,ARG1) + 1

      call ef_set_axis_limits(id, Z_AXIS, 1, nz)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE zreverse_compute(id, arg_1, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

	  INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER i1,j1,k1,l1

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      i = res_lo_ss(X_AXIS)
      DO 400 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)

         j = res_lo_ss(Y_AXIS)
         DO 300 j1 = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)

            k = res_lo_ss(Z_AXIS)
            DO 200 k1 = arg_hi_ss(Z_AXIS,ARG1),arg_lo_ss(Z_AXIS,ARG1),-1

               l = res_lo_ss(T_AXIS)
               DO 100 l1 = arg_lo_ss(T_AXIS,ARG1),arg_hi_ss(T_AXIS,ARG1)

                  IF (arg_1(i1,j1,k1,l1) .EQ. bad_flag(ARG1)) THEN
                     result(i,j,k,l) = bad_flag_result
                  ELSE
                     result(i,j,k,l) = arg_1(i1,j1,k1,l1)
                  ENDIF

                  l = l + res_incr(T_AXIS)
 100           CONTINUE

               k = k + res_incr(Z_AXIS)
 200        CONTINUE

            j = j + res_incr(Y_AXIS)
 300     CONTINUE

         i = i + res_incr(X_AXIS)
 400  CONTINUE
      
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

* V530 10/00 *sh* - added COMPLEX declarations to force link FORTRAN complex
* variable code for use in external functions
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

	subroutine fakes

        IMPLICIT NONE
	include	'errmsg.parm'

	INTEGER status
	COMPLEX a

        entry	odr_op
        entry	odr_quit
        entry	movie_close
        entry	odr_init
        entry	movie_open
	CALL ERRMSG( ferr_not_implemented, status,
     .				'Unix-based laser disk movies', *20 )
 20     write (0,*)  'Use the HDF-based on-screen animations'
        write (0,*)  'or use the VMS version of FERRET'
	a=CMPLX(0.,1.)
	a=AIMAG(a) 
	RETURN

        entry	epic_list
	CALL ERRMSG( ferr_not_implemented, status,
     .				'EPIC output', *30 )
 30     write (0,*)  'EPIC format is not yet available under Unix'
        write (0,*)  'Use the VMS version of FERRET if available'
        RETURN

	entry	 gks_open_ws
	stop	'gks_open_ws not available'
	entry	 is_autogrid
	stop	'is_autogrid not available'
	end

	SUBROUTINE NAME_EQUAL_STRING_VATT (nambuff, start_pos, status)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* decode "NAME = expression" on a command line
! when the name is a varname.attname, do not upcase the attribute name.

* programmer - Ansley Manke - for attribute handling
* Derived from NAME_EQUAL_STRING
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include	'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'

* calling argument declarations:
	INTEGER		start_pos, status
	CHARACTER*(*) nambuff

* local variable declarations:
	INTEGER STR_UPCASE, pos, i1

	CHARACTER*1 tab
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
#else
	PARAMETER     ( tab = CHAR(9))
#endif

* find name to define
* 2 syntaxes are allowed: "DEFINE VAR NAME=TEXT", "DEFINE VAR NAME TEXT"
* in the latter be careful that "TEXT" may contain "="
	pos = INDEX(cmnd_buff(arg_start(1):len_cmnd), '=')
* ... is it a legit = sign or one used within [] further on in expression ?
	IF ( num_args .GT. 1 ) THEN
	   IF ( pos+arg_start(1)-1 .GT. arg_start(2) ) pos = 0
	ENDIF
	IF ( pos .EQ. 0 ) THEN
* ... no "=" separator
	   nambuff = cmnd_buff( arg_start(1):arg_end(1) )
	   IF ( num_args .LT. 2 ) GOTO 400
	   pos = arg_start(2)
	ELSE
* ... yes "=" separator
	   pos = pos + arg_start(1)	! character after "="
*    ... hunt backwards for end of variable name
	   nambuff = '(none)'
	   DO 101 i1 = pos-2, arg_start(1), -1
	      IF ( cmnd_buff(i1:i1).EQ.' '
     .	      .OR. cmnd_buff(i1:i1).EQ.tab ) THEN
	         CONTINUE
	      ELSE
	         GOTO 102
	      ENDIF
 101	   CONTINUE
	   GOTO 5100
 102	   nambuff = cmnd_buff( arg_start(1):i1 )
*    ... find next non-blank, non-tab after "=" -- start of expression
	   DO 105 pos = pos, len_cmnd
	      IF ( cmnd_buff(pos:pos) .NE. ' ' 
     .	     .AND. cmnd_buff(pos:pos) .NE. tab  ) GOTO 106
 105	   CONTINUE
	   GOTO 400	! no text following equal sign
 106	   CONTINUE
           IF (INDEX(nambuff,'[') .GT. 0)   ! get the rest of the [d=] spec
     .        nambuff = cmnd_buff( arg_start(1):len_cmnd )
	ENDIF
	GOTO 500

* no text follows the name -- this is just a name.
 400	start_pos = 0
	GOTO 1000

* save starting position of the text
 500	start_pos = pos


* success
 1000	status = ferr_ok
	RETURN

* error exit
 5000	RETURN
 5100 	CALL ERRMSG( ferr_syntax, status,
     .			cmnd_buff(:len_cmnd)//' ???', *5000 )


	END

      CHARACTER*(*)FUNCTION TM_INQ_PATH
     .   ( fname, path, def_ext, do_errmsg, status )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Find the full path name of the given file
* failure to find a file in a status of merr_not_mounted
* depending on the logical do_errmsg an error message may be issued

* using this routine is "nearly" OS-independent between VMS and UNIX
* environment variables substitute for VMS logicals
* the interpretation of the default extension is a little different
* ... on UNIX it must be ".xxx" on VMS it can be name.xxx

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX/VMS

* revision 0.00 - 10/23/89 - code lifted from TM_INIT_DSET by Mark Verschell
* Unix/RISC FORTRAN port 3/7/91 *sh* - OS-specific file syntaxes
*                          - generalized to promote VMS/Unix similarities
* revision 1.00 - 10/17/91 - <kob>
*                          - separate path (if it exists) from file name
*                            and pass them to tm_path_list as two unique
*                            variables.
* revison 1.01  - 2/13/92  - increased size of TM_PATH_LIST, path_list to 512
*  *sh* 2/12/93 - corrected bug due to increased path_list (2/13/92) - it was
*		  equivalenced to "risc_buff" which was too short
*
*  *sh* 5/28/93 - if filename begins with $ then translate the environment var
*		  (this is a partial sol'n - doesn't deal with embedded $'s)
*
* IBM port 14apr94 *kob* : IBM will only allow character string lengths
*			    between 1 and 500.
*			 : CHARACTER*(*) variables cannot be used in concatenations,
*			   so I used risc_buff.
* v530 *kob* 1/00 - minor mods for remote mc aggregations
* 1/03 - *kob* g77 port - Need to use risc_buff for arbitrary concatenations.  Remove
*                         ifdef AIX and just use risc_buff by default
* 2/05 *acm* V58+  increase length of path_list string for FDS and other cases
*                  where environment variables get very long (bug 1169)
* V685+ 12/13    - *acm*  bounds checking: dont refer to parts of the string outside its bounds.

* arguments:
*	fname	   - filename - possibly lacking extension
*                             - possibly including explicit path 
*       path       - default logical or environment variable with path
*	def_ext	   - default file extension
*       do_errmsg  - give error message for file-not-found

* Argument definitions
        LOGICAL         do_errmsg
	INTEGER		set_cnt, status
	CHARACTER*(*)	fname, path, def_ext

* Parameter and common files
	include 'tmap_errors.parm'		! error codes
#include "gt_lib.parm"
	include 'xrisc_buff.cmn'


* local valiable declarations
#ifdef AIX_XLF
        CHARACTER TM_PATH_LIST*8190, path_list*8190
#else
        CHARACTER TM_PATH_LIST*8192, path_list*8192
#endif
        INTEGER TM_LENSTR1, STR_SAME, plen,flen,i,postslash
	LOGICAL is_http

!!!! bug 2/93        EQUIVALENCE ( path_list, risc_buff )

* path may be an environment variable (UNIX) with a path list or
* a logical name (VMS).  Failing that, it is ignored.
*

* reset postslash to 0 every time code enters here. If not reset, it causes
* a problem with the relative version numbers, cutting off first character
* of filename.
      postslash = 0
      flen = TM_LENSTR1(fname)

* Set up a logical. With strict bounds checking, a string of length 3
* cant be used in  *** IF ( fname(1:4) .EQ. 'http') THEN ***

       is_http = .FALSE.
       IF (flen .GT. 3) THEN
          is_http  = (fname(1:4) .EQ. 'http')
       ENDIF

* if a pathname exists, we want to extract it from the file name,  and
* pass them to tm_path_list as two separate, but lovely, entities.
* *** start of 5/93 addition
      IF ( fname(1:1) .EQ. '$' ) THEN
* ... translate "$" environment variable at beginning of filename
	 postslash = INDEX( fname ,PathSeparator ) + 1
	 IF ( postslash .EQ. 1 ) THEN
	    CALL GETENV( fname(2:flen), path_list )
	    postslash = flen + 1       ! entire filename from environment var
	 ELSE
	    CALL GETENV( fname(2:postslash-2), path_list )
	 ENDIF		
	 IF ( path_list .EQ. ' ' ) GOTO 5202
	 plen = TM_LENSTR1( path_list )
* ... transfer "morepath" info in the case of $ENVIRONMENT/morepath/filename
	 DO 5 i = flen-1,postslash+1,-1
	    IF ( fname(i:i) .EQ. PathSeparator ) THEN
	       path_list = path_list(:plen)//PathSeparator
     .              //fname(postslash:i-1)
	       plen = TM_LENSTR1( path_list )
	       postslash = i+1
	       GOTO 6
	    ENDIF
 5	 CONTINUE
 6	 IF ( plen .LT. LEN(path_list) ) THEN
            plen = plen + 1                ! mandatory ' ' at end
         ELSE
            GOTO 5100
         ENDIF
* *** end of 5/93 addition
      ELSEIF ( path .EQ. ' ' ) THEN
         path_list = ' '
         plen = 1
* *kob* 11/00 Allow DODS files as MC sets - just use full http address
      ELSEIF ( is_http ) THEN
         TM_INQ_PATH=fname(:flen)
         status = merr_ok
         GOTO 9900
      ELSEIF ( INDEX( fname ,PathSeparator ) .GT. 0 ) THEN
         DO 10 i = flen-1,1,-1
            IF ( fname(i:i) .EQ. PathSeparator ) THEN
               postslash = i+1
               GOTO 11
         ENDIF
 10      continue
 11      path_list =   fname(:postslash-2)
         plen = TM_LENSTR1(path_list)
         plen = plen + 1
* Otherwise, use the environment paths.
      ELSE
         CALL GETENV( path, path_list )    ! ' ' if no translation
         plen = TM_LENSTR1( path_list )
         IF ( plen .LT. LEN(path_list) ) THEN
            plen = plen + 1                ! mandatory ' ' at end
         ELSE
            GOTO 5100
         ENDIF
      ENDIF

* evaluate the path
* Send path and filename seperately to tm_path_list.
      IF (postslash .EQ. 0) postslash = 1

! The INQUIRE statement inside TM_PATH_LIST fails on names longer 
! than 256 chars causing a BUS error, so dont look in the DODS 
! cache for the file.
c
c is the above still true?
c
      flen = TM_LENSTR1(fname)
c      IF (flen .GT. 256 .AND.
c     .  STR_SAME(path, 'FER_DODS_CACHE_DIR').EQ.0 ) THEN 
c         status = merr_notmounted
c
c      ELSE
         IF (postslash .LE. flen) THEN
            TM_INQ_PATH = TM_PATH_LIST( path_list(:plen), 
     .                               fname(postslash:),def_ext, 
     .                               do_errmsg, status )
         ELSE   ! this option if entire name is an environment var
            TM_INQ_PATH = TM_PATH_LIST( path_list(:plen), 
     .                               ' ',def_ext, 
     .                               do_errmsg, status )
         ENDIF
c      ENDIF

      RETURN

* error exits
 5100 CALL TM_ERRMSG (merr_syntax, status, 'TM_INQ_PATH',
     .			unspecified_int4, no_stepfile,
     .			'path list too long',
     .                  no_errstring, *9900)
 5202 risc_buff = fname
      CALL TM_ERRMSG (merr_syntax, status, 'TM_INQ_PATH',
     .			unspecified_int4, no_stepfile,
     .			'unknown environment variable: '//risc_buff(1:flen),
     .                  no_errstring, *9900)
 9900 RETURN
      END

	SUBROUTINE OVSIZ_CX( cx )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* expand the context to grab more data than currently indicated

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  5/26/89
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include 'xprog_state.cmn'

* calling argument declarations:
	INTEGER	cx

* internal variable declarations:
	LOGICAL	ovsiz, user_var
	INTEGER	grid, idim, ndim, pdim, dim(nferdims), ss, ii, status, var
	REAL*8	TM_WORLD

* initialize
	user_var = cx_category(cx) .EQ. cat_user_var
	var	 = cx_variable(cx)
	grid	 = cx_grid(cx)
	CALL GET_CX_DIMS( cx, ndim, dim )

* can only perform over-sizing on a plane
* cannot rely on ndim. e.g.: CONTOUR/k=lo:hi/i=lo:hi/j=lo:hi NEW
*			where DEFINE VARIABLE NEW = U[K=@AVE]
	pdim = 0
	DO 100 ii = 1, ndim
	   idim = dim(ii)
	   IF ( user_var ) THEN
	      IF ( uvar_given(idim,var) .EQ. uvlim_needed ) pdim = pdim + 1
	   ELSE
	      pdim = pdim + 1
	   ENDIF
 100	CONTINUE
	IF ( pdim .NE. 2 ) GOTO 1000

	DO 200 ii = 1, ndim
	   idim = dim(ii)

* cannot resize safely if limits are given WITHIN user-var def'n
	   IF ( user_var ) THEN
	      IF ( uvar_given(idim,var) .NE. uvlim_needed ) GOTO 200
	   ENDIF

* assume resizing isn't needed until proven otherwise
	   ovsiz = .FALSE.	
* check lower limit
	   ss = cx_lo_ss( cx, idim )
	   IF ( cx_lo_ww(idim,cx) .LT. TM_WORLD(ss,grid,idim,box_middle) )
     .									  THEN
	        cx_lo_ss( cx, idim ) = ss - 1
	        ovsiz = .TRUE.
	   ENDIF
* check upper limit
	   ss = cx_hi_ss( cx, idim )
	   IF ( cx_hi_ww(idim,cx) .GT. TM_WORLD(ss,grid,idim,box_middle) )
     .									  THEN
	        cx_hi_ss( cx, idim ) = ss + 1
	        ovsiz = .TRUE.
	   ENDIF
* re-flesh axis if necessary
	   IF ( ovsiz ) THEN
	      cx_by_ss(idim,cx) = .TRUE.
	      CALL CONFINE_AXIS  ( idim, cx, status )	! ignore status
	      CALL FLESH_OUT_AXIS( idim, cx, status )	! ignore status
	   ENDIF
 200	CONTINUE

* flag that no further oversizing is needed
 1000	cx_ovsiz(cx) = ovsiz_off

	RETURN
	END

	SUBROUTINE TEK4107_FILL_REP (zwsid)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Setup the fill area indices for colors on TEK 4107 WS

*	J Davison JISAO/PMEL/TMAP
*	9.2.88/3.15.89
*	*jd* 2.19.92 mod to support atc gks

#ifdef unix
        include         'shade_vars.cmn'
	include		'ws_types.cmn'
#else
        INCLUDE         'tmap_pplv11inc:tmap_shade_vars.inc'
	include		'tmap_pplv11inc:ws_types.inc'
#endif

#ifdef atc_gks
#   ifdef unix
	include        'gkspar.inc'
#   else
	INCLUDE        'atc_gksdir:gkspar.inc'
#   endif
#else
#   ifdef unix
  	include        'gkspar.inc'
#   else
  	INCLUDE        'sys$library:gksdefs.bnd'
#   endif
#endif

	integer		zwsid,color,ndx

********************************************************************************

*	SET THE COLOR TABLE TO CUSTOM COLORS OR TO THE DEFAULT SELECTION
	if (custom_colors) then 
	   call setup_color_table (zwsid,2,14)
	else	
	   call set_default_colors (zwsid,ws_tek4107,2,14)
	end if

*	GO THRU AVAILABLE INDICES FOR FILL REP
	do 100 ndx = 1,shd_levels
	   color = 2 + (ndx-1)*14/(shd_levels)
	   call gsfar (zwsid,ndx+1,gsolid,1,color)
100	continue
	return

	end

	program drwmarks
	character val*3
	character text*30
	data text/'Plot Marks'/
	call rotate(-90.0)
	call pltype(1)
	call size(10.5,8.2)
	call scale(1.,1.,1.,0.,0.,-8.2)
	sze=.21
	call markh(sze)
c	call erase
	call opndev(.true.,.true.)
	im=0
	x=1.8+2*1.4-sze*10*0.5
	call symbol(x,8.0,0.0,sze,10,text)
	do 10 j=1,5
	do 20 i=1,18
	x=1.8+(j-1)*1.4
	y=7.5-i*0.4
	write(val,999)im
999	format(i2,'=')
	s=x-sze*3
	call symbol(s,y,0.0,sze,3,val)
	call plot(x+0.25,y+sze*0.5,0,0)
	call mark(im)
	im=im+1
	if(im.gt.88)goto 100
20	continue
10	continue
100	call clsdev(.true.,.true.)
	call exit
	end

*
* compressl.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* August 1998
*
* This function compresses data on L axis, ending with missing data.
*
*  NOTE:
*  IT IS GENERALLY ADVISABLE TO INCLUDE EXPLICIT LIMITS WHEN WORKING WITH
*  FUNCTIONS THAT REPLACE AXES. FOR EXAMPLE, THE CONSIDER THE FUNCTION
*  COMPRESSL(v). THE EXPRESSION
*  	LIST/L=6:10 COMPRESSL(v)
*  IS NOT EQUIVALENT TO
*  	LIST COMPRESSL(v[L=6:10])
*  THE FORMER WILL LIST THE 6TH THROUGH 10TH COMPRESSED INDICES FROM THE ENTIRE
*  L RANGE OF VARIABLE V. THE LATTER WILL LIST ALL OF THE INDICES THAT
*  RESULT FROM COMPRESSING v[L=6:10].
*  
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE compressl_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CHARACTER*100 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns data, compressed along the L axis: Missing ',
     .        'points moved to the end')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 1)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, ABSTRACT,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'DAT')
      CALL ef_set_arg_desc(id, arg, 'variable to compress in L')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, NO, YES, YES)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END


*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE compressl_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER my_lo_l, my_hi_l

      INTEGER arg
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

*
*     Use utility functions to get context information about the arguments.
*

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      my_lo_l = 1
      my_hi_l = 1

      arg = 1

      my_hi_l = arg_hi_ss(T_AXIS,arg) - arg_lo_ss(T_AXIS,arg) + 1


      CALL ef_set_axis_limits(id, T_AXIS, my_lo_l, my_hi_l)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE compressl_compute(id, arg_1, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER ndx, nsrt, nbad
      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1

*  Get subscript ranges

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      n1 = arg_lo_ss(F_AXIS, ARG1)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

         m1 = arg_lo_ss(E_AXIS, ARG1)
         DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

            k1 = arg_lo_ss(Z_AXIS, ARG1)
            DO 400 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               j1 = arg_lo_ss(Y_AXIS, ARG1)
               DO 300 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

                  i1 = arg_lo_ss(X_AXIS, ARG1)
                  DO 200 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

                     nsrt = 0
                     nbad = 0

                     l1 = arg_lo_ss(T_AXIS, ARG1)
                     DO 100 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

                        IF ( arg_1(i1,j1,k1,l1,m1,n1)
     .                               .NE. bad_flag(1) ) THEN
                           nsrt = nsrt + 1
                           result(i,j,k,nsrt,m,n) = 
     .                               arg_1(i1,j1,k1,l1,m1,n1)
                        ELSE
                           nbad = nbad + 1
                        ENDIF

                        l1 = l1 + arg_incr(T_AXIS,ARG1)
 100                 CONTINUE

*
* Compress argument, putting bad data at the end.
*
                     DO 150 ndx = 1, nbad
                        nsrt = nsrt + 1
                        result(i,j,k,nsrt,m,n) = bad_flag_result
 150                 CONTINUE

                     i1 = i1 + arg_incr(X_AXIS, ARG1)
 200              CONTINUE

                  j1 = j1 + arg_incr(Y_AXIS, ARG1)
 300           CONTINUE

               k1 = k1 + arg_incr(Z_AXIS, ARG1)
 400        CONTINUE

            m1 = m1 + arg_incr(E_AXIS, ARG1)
 500     CONTINUE

         n1 = n1 + arg_incr(F_AXIS, ARG1)
 600  CONTINUE

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

	SUBROUTINE PUTVAL(STR,X,IPRES,IER)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)putval.f	1.2    5/26/88
C**
C**
C***********************************************************************
C**
C**		    PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C**	Subprogram called:
C**		CALL PUTVAL(STR,X,IPRES,IER)
C**
C**	Parameters:
C**		STR -- Symbol name (char*120)
C**		X -- Real value of symbol
C**		IPRES -- number of digits, i.e, 1PG10.IPRES
C**		IER -- error code
C**			0 = sucess
C**			1 = error other than symbol not found
C**
C**	Description:
C**		Updates or creates the value for symbol STR.
C**
C**	History:
C**	    Written:
C**		14-JAN-1987	by Donald W. Denbo
C**	    Modified:
C**
C**
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
C * v552 *acm* 3/03 Longer strings: changes for multi-line labels
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long

	CHARACTER STR*(*),VAL*2048,FRMT*120
	IP=IPRES
	IF(IPRES.GT.10.OR.IPRES.LT.0)IP=4
	IL=IP+7
	WRITE(FRMT,999)IL,IP
999	FORMAT('(1PG',I3.3,'.',I3.3,')')
	WRITE(VAL,FRMT)X
100	IF(VAL(1:1).EQ.' ')THEN
	    VAL=VAL(2:)
	    IL=IL-1
	    GOTO 100
	ENDIF
	NC=LNBLK(VAL,IL)
	CALL PUTSYM(STR,VAL,NC,IER)
	RETURN
	END

	SUBROUTINE ADJUST_COPY_LIMITS (axis, mchunk, sorted_indices,
     .				       phase, max_phase)

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* a "chunk" of source data is available. The variable sorted_indices contains
* a list of subscript values to be pulled from that source data . The current
* value of "phase" indicates the index of the highest sorted_index that
* we intend to use from the chunk of source data. In this routine we
* check to see if more source data might be available that was expected, and
* if so, we adjust the phase upward to utilize all of what's available
* ==> this routine is solely to optimize performance

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V510: 10/99 *sh*
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include 'ferret.parm'
!	include	'xcontext.cmn'
	include	'xvariables.cmn'

* calling argument declarations:
	INTEGER  axis, mchunk, phase, max_phase
	REAL    sorted_indices(max_phase)


* internal variable declarations
	INTEGER max_available, lo_phase, hi_phase, test

* A typical scenario for the use of this routine might be as follows:
*   sorted list of subscripts at which to sample: {11,12,14,16,18,20}
*   souce data along axis extends from 1:19
*   current phase=3 (sorted_indices(phase)=14)
*   so we should adjust phase to a new value of 5 (sorted_indices(phase)=18)

* initialize
	max_available = mr_hi_ss(mchunk,axis)

* screen out obvious cases
	IF (sorted_indices(phase) .GE. max_available) THEN
* ... current phase is already as high as it can be
	   RETURN   ! phase is OK as-is
	ELSEIF (sorted_indices(max_phase) .LE. max_available) THEN
* ... can utilize the entire chunk of data available
	   phase = max_phase
	   RETURN
	ENDIF 

* initialize search for max that can be used from the chunk
	lo_phase = phase
	hi_phase = max_phase

* binary search 
 100	test = (lo_phase+hi_phase)/2
	IF (sorted_indices(test) .GT. max_available) THEN
	   hi_phase = test
	   GOTO 100
	ELSEIF (sorted_indices(test+1) .GT. max_available) THEN
	   phase = test
	   RETURN
	ELSE
	   lo_phase = test
	   GOTO 100
	ENDIF

	END 

	SUBROUTINE TPLOT_AXIS_ENDS (plt_ax_lo, plt_ax_hi, cal_id, tstyle)

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* 11/2016 ACM, see ticket 2483

* Reset plt_ax_lo, plt_ax_hi to the values that PPLUS will use for the
* ends of the time axis that it draws. plt_ax_lo are in seconds since 0000
* This must be preceded by a call to TAXIS_STYLE to set t_axtyp.


        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'xplot_setup.cmn'

	REAL plt_ax_lo, plt_ax_hi
	INTEGER cal_id
	CHARACTER*3 tstyle

	INTEGER t_axtyp
	REAL	WHOI2BC
	CHARACTER*14 ABS_WHOI_DATE, whoimin, whoimax, 
     .			whoimin_axlo, whoimax_axhi


* only need this call once for a line plot.

	IF (adjust_time) RETURN

* translate to WHOI-formatted dates
	whoimin =  ABS_WHOI_DATE( plt_ax_lo, cal_id )
	whoimax =  ABS_WHOI_DATE( plt_ax_hi, cal_id )

* put the century digits at the end, as FIXTIM expects
	whoimin = whoimin(3:14)//whoimin(1:2)
	whoimax = whoimax(3:14)//whoimax(1:2)

* t_axtyp is the time style used by PPLUS

	if (tstyle.EQ.'MIN') then
	   t_axtyp=0
	else if (tstyle(1:1).EQ.'H') then
	   t_axtyp=0
	else if (tstyle(1:1).EQ.'D') then
	   t_axtyp=0
	else if (tstyle(1:1).EQ.'M') then
	   t_axtyp=1
	else
	   t_axtyp=3
	endif

	CALL FIXTIM (whoimin, whoimax, whoimin_axlo, whoimax_axhi, t_axtyp)

* Translate back to seconds-since 0000
	plt_ax_lo = 60.* WHOI2BC( whoimin_axlo )
	plt_ax_hi = 60.* WHOI2BC( whoimax_axhi ) 

	adjust_time = .TRUE.

	RETURN
	END

	SUBROUTINE PARSE_STRING_LIST( cx, string, mr, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* return an array of strings from a list of the form
* { "string 1", "string 2", "string 3"}

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V530: *sh*  8/00
* V533: *sh*  7/01 - allow single quoted strings
*		   - save null strings for missing values
* V540:  9/01 *sh* - change "SYSTEM:" to "SPAWN:"
* 2/03 *kob* - g77 port - g77 won't allow intrinsic functions in PARAMETER
*                         statements.  use an octal constant instead 
* 2/07 *acm* - fix bug 1488; if the last item is a missing string, save that.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* 2/15 *sh* added support for _DQ_ and _SQ_

* calling argument declarations
	INTEGER		cx, mr, status
	CHARACTER*(*)	string

* internal variable declarations
	LOGICAL		stored, in_quote, do_system_cmnd,
     .			doub_atom,  sing_atom,  DQ_atom,  SQ_atom,
     .			doub_quote, sing_quote, DQ_quote, SQ_quote
	INTEGER 	TM_LENSTR1, STR_CASE_BLIND_COMPARE,
     .			i, n, nnew, spos, slen, str_start, vax_code, istat
	CHARACTER	c*1

* internal parameter declarations
	CHARACTER*1     tab
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
#else
	PARAMETER     ( tab = CHAR(9))
#endif

	include	'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'gfdl_vms.parm'
	include 'xvariables.cmn'

* initialize
	n      = 1
	spos   = 1
	slen   = TM_LENSTR1( string )
	stored    = .FALSE.
	in_quote  = .FALSE.
	do_system_cmnd = .FALSE.

* trim around the enclosing "{}" brackets
	IF ( string(slen:slen) .EQ. '}' ) slen = slen - 1

* dont process trailing blanks
        i = slen
        DO WHILE ( string(i:i) .EQ. ' ' ) 
           slen = slen - 1
           i = i-1
        ENDDO

	IF ( string (1:1) .EQ. '{' ) spos = 2
	IF ( spos .GE. slen ) GOTO 5000

* loop through the text counting commas
	i = spos - 1
	DO WHILE ( i .LT. slen )
	   i = i + 1 
	   c = string(i:i)

* ... identify quotation atoms
	   doub_atom = c.EQ.'"'
	   sing_atom = c.EQ."'"
	   IF (i+3 .LE. slen) THEN
	      DQ_atom = string(i:i+3) .EQ. "_DQ_"
	      SQ_atom = string(i:i+3) .EQ. "_SQ_"
	   ELSE
	      DQ_atom = .FALSE.
	      SQ_atom = .FALSE.
	   ENDIF

	   IF (in_quote) THEN
* ... possibly escape the next character
#ifdef NO_DOUBLE_ESCAPE_SLASH
              IF (c .EQ. '\') THEN  ! ' sing quote char for emacs sanity
#else
              IF (c .EQ. '\\') THEN
#endif
	         i = i + 1   ! skip processing of next character 
	      ELSEIF  (doub_atom .AND. doub_quote
     .	         .OR.  sing_atom .AND. sing_quote 
     .	         .OR.  DQ_atom   .AND. DQ_quote 
     .	         .OR.  SQ_atom   .AND. SQ_quote ) THEN
* ... close of paired-quote string -- save the string
	         IF (str_start .LT. i) THEN
	            IF ( do_system_cmnd ) THEN
	               CALL STORE_SYS_STRINGS(string(str_start:i-1),
     .					       cx, mr, n, nnew, status)
	               n = n + nnew - 1
	            ELSE
	               CALL STORE_STRING(string(str_start:i-1),
     .				         mr, n-1, status)
	            ENDIF
	         ELSE
	            CALL SAVE_C_STRING(0,0,mr_c_pointer(mr),n-1,istat) ! NULL
	         ENDIF
	         IF (status .NE. ferr_ok) GOTO 5000
	         stored = .TRUE.
	         do_system_cmnd = .FALSE.
	         in_quote = .FALSE.
	         IF (DQ_atom .OR. SQ_atom) i = i + 3
	      ENDIF

	   ELSEIF (doub_atom.OR.sing_atom.OR.DQ_atom.OR.SQ_atom) THEN
*  ... opening a paired-quote string
	      doub_quote = doub_atom
	      sing_quote = sing_atom
	      DQ_quote   = DQ_atom
	      SQ_quote   = SQ_atom
	      IF (stored) GOTO 5000
	      in_quote = .TRUE.
	      IF (DQ_quote .OR. SQ_quote ) THEN
	         str_start = i + 4
	      ELSE
	         str_start = i + 1
	      ENDIF
	   ELSEIF (c .EQ. ',') THEN
	      IF (.NOT.stored) THEN
	        CALL SAVE_C_STRING(0,0,mr_c_pointer(mr),n-1,istat) ! NULL
	      ENDIF
	      IF (i.EQ.slen) THEN     ! missing string at the end of the list
	        CALL SAVE_C_STRING(0,0,mr_c_pointer(mr),n,istat) ! NULL
	      ENDIF
	      n = n+1
	      stored = .FALSE.
	      do_system_cmnd = .FALSE.
	   ELSEIF (c.EQ.'s' .OR. c.EQ.'S' ) THEN
	      IF ( i+6 .GT. slen ) GOTO 5000
	      vax_code = STR_CASE_BLIND_COMPARE(string(i:i+5), 'SPAWN:')
	      IF( vax_code .NE. vms_str_success ) GOTO 5000
	      i = i + 5
	      do_system_cmnd = .TRUE.
	   ELSE
	      IF (c .NE. ' '
     .	    .AND. c .NE. tab ) GOTO 5000
	   ENDIF
	ENDDO
	IF (in_quote) GOTO 5000

* success
 1000	status = ferr_ok
	RETURN

* syntax error
 4999	RETURN
 5000	CALL ERRMSG( ferr_syntax, status, string(i:), *4999 )

	END

*
* scat2ddups.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE.
*
* Steve Hankin
* Jan, 2001


* In this subroutine we provide information about
* the function.  The user configurable information
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
*
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result
*


      SUBROUTINE scat2ddups_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id, 'Flag non-unique points. '
     .            // 'L=1 - # dups of this pt, L=2 - index of dup pt')

      CALL ef_set_num_args(id, 4)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, ABSTRACT,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name (id, arg, 'coord 1')
      CALL ef_set_arg_unit(id, arg, 'none')
      CALL ef_set_arg_desc(id, arg,
     .         'Coordinate 1 (normally longitude)')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, NO, YES, YES)

      arg = 2
      CALL ef_set_arg_name (id, arg, 'coord 2')
      CALL ef_set_arg_unit(id, arg, 'none')
      CALL ef_set_arg_desc(id, arg,
     .         'Coordinate 2 (normally latitude)')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, NO, YES, YES)

      arg = 3
      CALL ef_set_arg_name (id, arg, 'epsilon 1')
      CALL ef_set_arg_unit(id, arg, 'none')
      CALL ef_set_arg_desc(id, arg,
     .         'Two coord 1s within epsilon 1 considered duplicates')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 4
      CALL ef_set_arg_name (id, arg, 'epsilon 2')
      CALL ef_set_arg_unit(id, arg, 'none')
      CALL ef_set_arg_desc(id, arg,
     .         'Two coord 2s within epsilon 2 considered duplicates')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN
      END


*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE scat2ddups_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

        CALL EF_SET_AXIS_LIMITS(id, T_AXIS, 1, 2)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE scat2ddups_compute(id, arg_1, arg_2, arg_3, arg_4,
     .                              result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
* Arguements 3 and 4 are single floating-point values
      REAL arg_3, arg_4

      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable''s axes.

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER ii, size1, size2

* get the subscripting limits and flags
      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* check to make sure that we were not passed a span along the T axis
      IF ( (arg_lo_ss(T_AXIS,ARG1) .NE. arg_hi_ss(T_AXIS,ARG1)) .OR.
     .     (arg_lo_ss(T_AXIS,ARG2) .NE. arg_hi_ss(T_AXIS,ARG2)) ) THEN
         CALL EF_BAIL_OUT(id, 'Cannot handle a T range on argument')
         STOP 'EF_BAIL_OUT returned'
      ENDIF

* ensure that the sizes of the inputs match
      size1 = 1
      size2 = 1
      DO ii = X_AXIS,F_AXIS
         size1 = size1 * (arg_hi_ss(ii,ARG1) - arg_lo_ss(ii,ARG1) + 1)
         size2 = size2 * (arg_hi_ss(ii,ARG2) - arg_lo_ss(ii,ARG2) + 1)
      END DO
      IF ( size1 .NE. size2 ) THEN
         CALL EF_BAIL_OUT(id, 'Coordinate arrays are not conformable')
         STOP 'EF_BAIL_OUT returned'
      ENDIF

* ensure that the epsilon values make sense
      IF ( arg_3 .LT. 0.0 .OR. arg_4 .LT. 0.0 ) THEN
         CALL EF_BAIL_OUT(id, 'Negative epsilon value')
         STOP 'EF_BAIL_OUT returned'
      ENDIF

* flag the duplicates
      CALL FLAG2DDUPS( size1,
     .                 arg_1(arg_lo_ss(X_AXIS,ARG1),
     .                       arg_lo_ss(Y_AXIS,ARG1),
     .                       arg_lo_ss(Z_AXIS,ARG1),
     .                       arg_lo_ss(T_AXIS,ARG1),
     .                       arg_lo_ss(E_AXIS,ARG1),
     .                       arg_lo_ss(F_AXIS,ARG1)),
     .                 arg_2(arg_lo_ss(X_AXIS,ARG2),
     .                       arg_lo_ss(Y_AXIS,ARG2),
     .                       arg_lo_ss(Z_AXIS,ARG2),
     .                       arg_lo_ss(T_AXIS,ARG2),
     .                       arg_lo_ss(E_AXIS,ARG2),
     .                       arg_lo_ss(F_AXIS,ARG2)),
     .                 arg_3,
     .                 arg_4,
     .                 result(memreslox, memresloy, memresloz,
     .                                1, memresloe, memreslof),
     .                 result(memreslox, memresloy, memresloz,
     .                                2, memresloe, memreslof) )

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN
      END

	INTEGER FUNCTION IGRID ( data_set, category, variable, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* find the defining grid for the given variable
* if unknown - go get it

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 4/23/86
* revision 0.6 - 11/22/88- new TM IO library var_gridber --> ds_grid_number
* V200:   7/6/89 - most guts removed to KNOWN_GRID
*	 8/29/89 - trap pseudo-variable grid requests
*	 3/26/90 - improved error messages
* V230:  7/21/92 - improved error message for unknown GFDL diagnostic var
* V510:  8/99 *sh* - bug uncovered allowing DEFINE GRID/LIKE=user_var
*		     if GET_UVAR_GRID is called the dset returned may be 0
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V698  3/16 *acm* Removed Philander-Seigel code including diagnostic 
*                  variables, pre-defined axes and grids, cat_calc_var.
* V710 *acm* 10/16 Ticket 2422: variables uvar_grid, uvar_data_type, uvar_aux_cat, 
*                  uvar_aux_var to be replaced with calls to LIST routines in NCF_Util.c 

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xvariables.cmn'
	include	'xalgebra.cmn'

* calling argument declarations:
	INTEGER	data_set, category, variable, status

* internal variable declarations:
	INTEGER	KNOWN_GRID, TM_LENSTR1, dset

* only user variables have a status issue
	status = ferr_ok

* check for pseudo-variable
	IF ( category .EQ. cat_pseudo_var ) CALL ERRMSG
     .		( ferr_invalid_command, status,	'pseudo-variable '
     .		//alg_pvar(variable)(:TM_LENSTR1(alg_pvar(variable)))
     .		//' cannot be used this way',
     .		*5000 )

	IGRID = KNOWN_GRID( data_set, category, variable )

	IF ( IGRID .NE. unspecified_int4 ) RETURN

* grid unknown
	IF ( category .NE. cat_user_var ) THEN
	   CALL ERRMSG( ferr_internal, status, 'IGRID', *5000 )
	ENDIF

* allow "abstract" expressions that don't depend on data set
* Note (8/99): since GET_UVAR_GRID has not yet been called, we cannot assume
*   that uvar_need_dset(variable) is known at this time. Recheck below. 
	IF ( .NOT.uvar_need_dset(variable)
     .	   .OR. data_set .EQ. unspecified_int4 ) THEN
	   dset = pdset_irrelevant
	ELSE
	   dset = data_set
	ENDIF

	CALL GET_UVAR_GRID( variable, dset, status )

* the variable definition may contain its data set info internally -- in which
*  case, the dset to use is pdset_irrelevant
	IF ( .NOT.uvar_need_dset(variable) )  dset = pdset_irrelevant

	CALL GET_SAVED_UVAR_GRID(variable,dset, IGRID)

	RETURN

* error exit
 5000	RETURN
	END

* fill_xy.F
*
* Martin Schmidt
* Sept. 2001
*
* This function fill missing values by averaging over the neigbourhood
*


*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE fill_xy_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

      CALL ef_version_test(ef_version)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     . 'fills missing values with average nearest neighbour values' )

      CALL ef_set_num_args(id, 3)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 'this arg is filled')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'B')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 
     &     'mask (1 -> fill, missing -> do not fill)')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'C')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 'the maximum number of fill-passes')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO )
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE fill_xy_compute(id, arg_1, arg_2, arg_3, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, 
     .           mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, 
     .           mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)
      REAL work_old (mem1lox:mem1hix, mem1loy:mem1hiy)
      REAL work_new (mem1lox:mem1hix, mem1loy:mem1hiy)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1
      INTEGER i2, j2, k2, l2
      INTEGER i3, j3, k3, l3
      integer iavr, is, js, icl, icr, jcl, jcu
      integer npass, npassmax
      real    tavr
      logical ready, not_land
      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)
      l1 = arg_lo_ss(T_AXIS,ARG1)
      l2 = arg_lo_ss(T_AXIS,ARG2)
      l3 = arg_lo_ss(T_AXIS,ARG3)
      DO 400 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         k1 = arg_lo_ss(Z_AXIS,ARG1)
         k2 = arg_lo_ss(Z_AXIS,ARG2)
         k3 = arg_lo_ss(Z_AXIS,ARG3)
         DO 300 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
            ready = .false.
            j1 = arg_lo_ss(Y_AXIS,ARG1)
            DO j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
               i1 = arg_lo_ss(X_AXIS,ARG1)
               DO i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
                  work_new(i1,j1) = arg_1(i1,j1,k1,l1)
                  i1 = i1 + arg_incr(X_AXIS,ARG1)
               enddo
               j1 = j1 + arg_incr(Y_AXIS,ARG1)
            enddo
            npass = 0
            i3 = arg_lo_ss(X_AXIS,ARG3)
            j3 = arg_lo_ss(Y_AXIS,ARG3)
            npassmax = arg_3(i3,j3,k3,l3)
            do while (.not.ready)
               ready = .true.
               j1 = arg_lo_ss(Y_AXIS,ARG1)
               DO j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
                  i1 = arg_lo_ss(X_AXIS,ARG1)
                  DO i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
                     work_old(i1,j1) =work_new(i1,j1)
                     i1 = i1 + arg_incr(X_AXIS,ARG1)
                  enddo
                  j1 = j1 + arg_incr(Y_AXIS,ARG1)
               enddo
               j1 = arg_lo_ss(Y_AXIS,ARG1)
               j2 = arg_lo_ss(Y_AXIS,ARG2)
	       DO 201 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
                  i1 = arg_lo_ss(X_AXIS,ARG1)
                  i2 = arg_lo_ss(X_AXIS,ARG2)
                  DO 101 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
		     if (arg_2(i2,j2,k2,l2) .ne. bad_flag(2)
     &                    .and.work_old(i1,j1).eq.bad_flag(1))then
                        tavr= 0.
                        iavr= 0
                        icl = max0(mem1lox,i1-1)
                        icr = min0(mem1hix,i1+1)
                        jcl = max0(mem1loy,j1-1)
                        jcu = min0(mem1hiy,j1+1)
                        do is=icl, icr
                           do js=jcl, jcu
                              if(work_old(is,js).ne.bad_flag(1)) then
                                 tavr=tavr+work_old(is,js)
                                 iavr=iavr+1
                              endif
                           enddo
                        enddo
! If valid surrounding points have been found, replace the missing value
! with the average over the neigbouring points
! Since something has changed, a new pass is required -> ready = .false.
                        if (iavr.ne.0) then
                           if (iavr.eq.1) then
! If the only only found point is at the corner, an ill posed
! cellular automaton has to be avoided
                              if (work_old(icl,jcu).eq.bad_flag(1).and.
     &                            work_old(icr,jcu).eq.bad_flag(1).and.
     &                            work_old(icr,jcl).eq.bad_flag(1).and.
     &                            work_old(icl,jcl).eq.bad_flag(1)) then
                                 work_new(i1,j1)=tavr/iavr
                                 ready = .false.
                              endif
                           else
                              work_new(i1,j1)=tavr/iavr
                              ready = .false.
                           endif
                        endif
		     endif
                     i1 = i1 + arg_incr(X_AXIS,ARG1)
                     i2 = i2 + arg_incr(X_AXIS,ARG2)
 101              CONTINUE
                  j1 = j1 + arg_incr(Y_AXIS,ARG1)
                  j2 = j2 + arg_incr(Y_AXIS,ARG2)
 201           CONTINUE
               npass = npass + 1
               if (npass.eq.npassmax) ready = .true.
            enddo
            j1 = arg_lo_ss(Y_AXIS,ARG1)
            DO 202 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
               i1 = arg_lo_ss(X_AXIS,ARG1)
               DO 102 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
                  result(i,j,k,l) = work_new(i1,j1)
                  i1 = i1 + arg_incr(X_AXIS,ARG1)
 102           CONTINUE
               j1 = j1 + arg_incr(Y_AXIS,ARG1)
 202        CONTINUE
            k1 = k1 + arg_incr(Z_AXIS,ARG1)
            k2 = k2 + arg_incr(Z_AXIS,ARG2)
 300     CONTINUE
         l1 = l1 + arg_incr(T_AXIS,ARG1)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
 400  CONTINUE
      
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	CHARACTER*(*) FUNCTION GET_STRING_ELEMENT_1D_X(
     .			hix,
     .			ptr_array, i, 
     .			maxlen, slen)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* This routine is a shorthand for calling GET_STRING_ELEMENT for the special
* case of a 1D array of strings on the X axis

* V698:12/15 *sh*

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include 'ferret.parm'
	include 'EF_Util.parm'

* calling argument declarations
	INTEGER  hix, i, maxlen, slen
	REAL*8	 ptr_array(*)

* internal declarations
	CHARACTER GET_STRING_ELEMENT*512

* note: the "512" is an arbitrary assignment ... presumably tells the compiler
* the length of intermediate buffer to provide (??)

	GET_STRING_ELEMENT_1D_X = GET_STRING_ELEMENT(
     .			1,hix,
     .                  1,1, 1,1, 1,1, 1,1, 1,1,
     .                  ptr_array,i,1,1,1,1,1,
     .			maxlen,slen )

	RETURN
	END
 

	SUBROUTINE DSG_OBS_MARK_GAPS (dset, cx, nfeatures, nobs_total, vals)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - SDIG program
* 4/24/2018
*
* Define a variable of length nobs_total where the end of each feature 
* is marked by the value 1. The routine plotxy_ribbon can then treat 
* this as agap-marking variable and pick up the pen after drawing to the 
* associated points.

* programmer - Ansley Manke  
* NOAA/PMEL, Seattle, WA - Science Data Integration Group
*
* V7.4+ *acm*  4/2018
* V7.5+ *acm*  6/2019  Do obs masking as we go, so if using just subsets of features 
*                      the gaps are in the right places2018
* V7.51 *acm*  7/2019  If the length sent in is the nfeatures length, send back an
*                      array that's all zero.

	include 'tmap_dims.parm'
	include 'xdset_info.cmn_text'
	include 'xdyn_linemem.cmn_text'

* calling argument declarations:
	INTEGER	dset, cx, nfeatures, nobs_total
	REAl vals(*)


* internal variable declarations:
	LOGICAL process_feature(nfeatures), process_obs(nobs_total)
	INTEGER	ifeature, iobs, nobs, row_size_lm, base, fobs, nmasked, nobsf

	row_size_lm = dsg_loaded_lm(dsg_row_size_var(dset))

* If the operation's being done on a feature-variable, set the "gaps" to all 0.
* e.g. a plot of lon vs lat for a set of timeseries stations.

	IF (nobs_total .EQ. nfeatures) THEN
	   DO iobs = 1, nobs_total
	      vals(iobs) = 0.
	   ENDDO

	   RETURN

	ENDIF

* create variable that's 1 at the start of each trajectory, 0 otherwise

	CALL MAKE_DSG_FEATURE_MASK(dset, cx, process_feature, nfeatures)


	nmasked = 0  ! overall count after masking
	base = 0     ! obs index at end of preceding feature
	fobs = 0     ! count of masked data in each feature
	
	DO ifeature = 1, nfeatures
	   nobsf = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
	   IF (process_feature(ifeature)) THEN

* ... define observation-level mask for this feature
	      CALL MAKE_DSG_OBS_MASK(dset, cx, ifeature, base, process_obs, nobsf)
	      fobs = 0
	      DO iobs = 1, nobsf
	         IF (process_obs(iobs)) THEN
		    fobs = fobs+1
		    nmasked = nmasked+1
		    vals(nmasked) = 0.
	         ENDIF

* ...  if masking keeps some but not all elements of feature, mark a gap.
	         IF (iobs.GT.1 .AND. process_obs(iobs) .AND. nmasked.GT.1) THEN
		    IF (.NOT.process_obs(iobs-1) ) vals(nmasked-1) = 1.
		 ENDIF
	      ENDDO

* Mark last element of feature, if it had any valid data

	      IF (fobs.GT.0) vals(nmasked) = 1.

	   ENDIF
	   
	   base = base + nobsf
	ENDDO

* End of last feature isn't a gap.
	IF (nmasked.GT.0) vals(nmasked) = 0.  

	RETURN
	END

*
* ereverse.F
*
* Ansley Manke
* May 2012
*
* This function returns the E values of the input variables,
* reversed and on an abstract E axis. Other axes are unchanged.
*
*
* In this subroutine we provide information about
* the function.  The user configurable information
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
*
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument''s axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result
*


      SUBROUTINE ereverse_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .  'Returns values reversed in E direction on an abstract E axis')
      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                ABSTRACT,        IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'Variable to reverse the E axis')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, NO, YES)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


      SUBROUTINE ereverse_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER nm

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nm = arg_hi_ss(E_AXIS,ARG1) - arg_lo_ss(E_AXIS,ARG1) + 1

      CALL ef_set_axis_limits(id, E_AXIS, 1, nm)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE ereverse_compute(id, arg_1, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable''s axes.

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      n = res_lo_ss(F_AXIS)
      DO 600 n1 = arg_lo_ss(F_AXIS,ARG1), arg_hi_ss(F_AXIS,ARG1)

      m = res_lo_ss(E_AXIS)
      DO 500 m1 = arg_hi_ss(E_AXIS,ARG1), arg_lo_ss(E_AXIS,ARG1), -1

      l = res_lo_ss(T_AXIS)
      DO 400 l1 = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)

      k = res_lo_ss(Z_AXIS)
      DO 300 k1 = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)

      j = res_lo_ss(Y_AXIS)
      DO 200 j1 = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)

      i = res_lo_ss(X_AXIS)
      DO 100 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)

         IF ( arg_1(i1,j1,k1,l1,m1,n1) .EQ. bad_flag(ARG1) ) THEN
            result(i,j,k,l,m,n) = bad_flag_result
         ELSE
            result(i,j,k,l,m,n) = arg_1(i1,j1,k1,l1,m1,n1)
         ENDIF

         i = i + res_incr(X_AXIS)
 100  CONTINUE

         j = j + res_incr(Y_AXIS)
 200  CONTINUE

         k = k + res_incr(Z_AXIS)
 300  CONTINUE

         l = l + res_incr(T_AXIS)
 400  CONTINUE

         m = m + res_incr(E_AXIS)
 500  CONTINUE

         n = n + res_incr(F_AXIS)
 600  CONTINUE

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END

	SUBROUTINE EZ_Mod_Dset (dset,title,ezform,grid,skip,order,status)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* A routine to fill in the "missing" gaps in the XDSET_INFO entry for an EZ_
* data set. All parameters (except dset) are optional, however, any unused
* parameters must be filled with char_init, or int4_init depending on type.
*
* revision 0.00 - 08/14/89
* revision 0.01 - 04/25/91 *sh* Unix/RISC port: longer des name
* revision 1.0	- 1/10/94 *kob* file/order upgrade to allow specification
*		  of axis permutations.
* V530: change to xez_info.cmn requires ez_lib.parm first
* v540 *acm* 10/01 increase length of ds_name
* v540 *acm* 10/01  remove VMS include statements
* V581 *acm*/3/05 - increase length of strings for dataset title to 1024 
* v604 *acm* 7/07 increase length of ds_name, ds_des_name
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing
* V685+ 12/13 *acm* 6D Ferret: passed-in array had fixed dimensino of 4
* V701  7/16 *kms* Compare ds_name to char_init2048 instead of char_init1024

* Arguments:
*	dset	- data set number
*	title	- data set title
*	ezform	- reading format
*	grid	- grid data is on (spread over all variables)
*	skip	- number of heading records to skip
* 	order   - array specifying data order	1/94 *kob*
*	status	- (output)
*
	CHARACTER*(*)	title, ezform
	INTEGER*4	dset, grid, skip, order(*), status,idim
*
* Include files
	include 'tmap_dims.parm'  
#include "tmap_dset.parm"  
	include 'tmap_errors.parm'
	include 'ez_lib.parm'
	include 'xez_info.cmn_text'  
	external xez_info_data
	include 'xdset_info.cmn_text'  
	external xdset_info_data
	include 'xstep_files.cmn_text'
	external xstep_files_data
*
* Local definitions
	INTEGER*4	vcnt, scnt
*
* Does data set exist?
	IF (ds_name(dset) .EQ. char_init2048) GOTO 9000
*
* Defining title?
	IF (title .NE. char_init1024) ds_title(dset) = title
*
* Defining reading format?
	IF (ezform .NE. char_init16) THEN
	  ds_parm_name(1,dset) = 'FORMAT'
	  ds_parm_text(1,dset) = ezform
	ENDIF
*
* Defining grid number? (fills in ALL variables)
	IF (grid .NE. int4_init) THEN
	  DO 100 vcnt = 1,maxvars
	  IF (ds_var_setnum(vcnt) .NE. dset) GOTO 100
	  ds_grid_number(vcnt) = grid
* Fill in the data order  *kob* 1/94
	  IF (order(1) .NE. int4_init) THEN
	    DO 150 idim=1,nferdims
	    ds_ordering(idim,vcnt) = order(idim) 
 150	  CONTINUE
	  ENDIF
	  CALL EZ_UPDATE_VAR(vcnt)
 100	  CONTINUE	  
	ENDIF

*
* Defining skip header records?
	IF (skip .NE. int4_init) THEN
	  DO 200 scnt = 1,maxstepfiles
  200	  IF (sf_setnum(scnt) .EQ. dset) sf_skip(scnt) = skip
	ENDIF
	status = merr_ok
	GOTO 9990
*
* Error messages
 9000	CALL TM_ERRMSG( merr_dsetnf, status, 'EZ_MOD_DSET',
     .			no_descfile, no_stepfile,
     .			no_errstring, no_errstring, *9990)
*
* finished
 9990	RETURN
	END

        SUBROUTINE STORE_NUL_WS_PTR(ws, array)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* this routine is called from C
* store pointer to a zero-length array into an F90 pointer in the ws table
*
* V702 1/17 *sh* for trac enhancement #2369 -- dynamic memory management 

        IMPLICIT NONE

* calling argumemnts
        INTEGER ws
        REAL(8), TARGET :: array(0)

        include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xvariables.cmn'

* store the pointer
        workmem(ws)%ptr => array

        RETURN

	END

      SUBROUTINE CMRDST(LUN,FILE,CH) 
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)cmrdst.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C 
C     WRITTEN IN JULY 1980  THIS ROUTINE 
C     ALLOWS ALTERNAME INPUT  LUN,NAME AND 
C     TERMINATOR CHARACTER LT 
C 
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 

      COMMON/CDFTN5/LN 
      COMMON/CEFTN5/IN,IA,LT,NAME,INTEMP
      COMMON/CPFTN5/PRMPT
      CHARACTER FILE*(*),CH*(*),IN*80,IA*1,LT*1,NAME*81,INTEMP*80
      CHARACTER PRMPT*40

#ifdef unix
      external init_cdepftn5
#else
      DATA LN,LT,NAME/5,'|','TT:'/,PRMPT/'('' *'',$)'/
#endif

      LN=LUN 
      IF(CH.NE.' ')LT=CH 
      IF(FILE(1:1).EQ.' ')RETURN 
      NAME=FILE 
      CLOSE(LN) 
#ifdef unix
	IF(NAME.EQ.'/dev/tty')THEN
#else
	if(name.eq.'TT:')then
#endif
	OPEN(LN,FILE=NAME,STATUS='UNKNOWN') 
	ELSE
#ifdef unix
	OPEN(LN,FILE=NAME,STATUS='OLD',ERR=1000)
#else
	OPEN(LN,FILE=NAME,STATUS='OLD',readonly,ERR=1000)
#endif
	ENDIF
      RETURN 
1000	WRITE(5,*)' ERROR OPENING: ',NAME
	STOP
      END 


#ifdef unix

CC    Created this for FORTRAN_90 compile, but will be acceptable by 
CC    all UNIX

      block data init_cdepftn5

      COMMON/CDFTN5/LN 
      COMMON/CEFTN5/IN,IA,LT,NAME,INTEMP
      COMMON/CPFTN5/PRMPT

      CHARACTER FILE*81,CH*1,IN*80,IA*1,LT*1,NAME*81,INTEMP*80
      CHARACTER PRMPT*40

      DATA LN,LT,NAME/5,'|','/dev/tty'/,PRMPT/'('' *'',$)'/
      DATA IN/' '/ 

      end

#endif

	SUBROUTINE DO_AVE_INT(	action, idim, com_lo, com_hi,
     .				com, com_mr, com_cx,
     .				res, res_mr, res_cx,
     .				box, weights )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* perform both accumulation of values needed for both averaging and integrating
* (definite) - since they differ only by a multiplying factor

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V200: ????
*      10/11/89 - modified array declarations using XMEM_SUBSC.CMN
* V230:  5/6/92 - COS correction checks that J location is defined
*       8/10/92 - weights were wrong for integration within a single box
*                 added "IF (point)" logic
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.
* V702 *sh* 11/16 this routine now performs accumulation only.  Initialization
*                 and finalizing called separately from IS_TRANS
* V72  *acm* 5/17 Fix ticket 2538: scatter/gather weights when average 
*                 over a "point"

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xunits.cmn_text'
	external xunits_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data

* internal variable declarations:
	LOGICAL	GEOG_COS_FACTOR, ITSA_TRUEMONTH_AXIS,
     .          need_cos, integrate, point
	INTEGER i, j, k, l, m, n, grid, pt, lo, hi, axis
	REAL	BOX_SIZE, unit, bad_com, bad_res, cos_factor,
     .          ybxlo, ybxhi, bx
	REAL*8	TM_WORLD, dsum, bsum

* calling argument declarations:
	INTEGER	action, idim, com_lo, com_hi, com_mr, com_cx, res_mr, res_cx
	REAL    com     ( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .                    m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          res     ( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .                    m2lot:m2hit,m2loe:m2hie,m2lof:m2hif ),
     .          weights ( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .                    m2lot:m2hit,m2loe:m2hie,m2lof:m2hif ),
     .		box( com_lo:com_hi )

* --- end of introductory code ---

* initialize
	grid = mr_grid( com_mr )
	axis = grid_line( idim, grid )
	pt   = cx_lo_ss( res_cx, idim )
	lo   = com_lo
	hi   = com_hi
	bad_com = mr_bad_data( com_mr )
	bad_res = mr_bad_data( res_mr )
	integrate = action .EQ. isact_integ_def
        point = .FALSE.

* get and save grid box sizes (weights) just once for efficiency
        IF ( lo .EQ. hi ) THEN    ! 8/92
           box(lo) = cx_hi_ww(idim,res_cx) - cx_lo_ww(idim,res_cx)
           point = box(lo) .EQ. 0.0
        ELSE
	   DO 100 i = lo, hi
 100	   box(i)  = BOX_SIZE( i, grid, idim )
* 11/16 ... end boxes may be only partial cells
	   IF (TM_WORLD(lo, grid, idim, box_lo_lim)
     .    .LT. cx_lo_ww(idim,res_cx)                ) box(lo) = 
     .			TM_WORLD(lo, grid, idim, box_hi_lim)
     .		      - cx_lo_ww(idim,res_cx)
	   IF (TM_WORLD(hi, grid, idim, box_hi_lim)
     .    .GT. cx_hi_ww(idim,res_cx)                ) box(hi) =
     .			cx_hi_ww(idim,res_cx)
     .		      - TM_WORLD(hi, grid, idim, box_lo_lim)
        ENDIF

* perform integrations on standard units if possible
	IF ( integrate ) THEN
	   unit = un_convert( line_unit_code(axis) )
	   IF (ITSA_TRUEMONTH_AXIS(axis)) unit = un_convert(pun_day)
	   DO 110 i = lo, hi
 110	   box(i) = box(i) * unit
	ENDIF

* AVERAGE/INTEGRATE
* (is double precision summing necessary ? *sh* 6/89)
* ALONG X AXIS
* (note: X integration is a special case because it requires COSINE(lat) )
	IF ( idim .EQ. x_dim ) THEN
	   need_cos = GEOG_COS_FACTOR( idim, grid )
     .                .AND. cx_lo_s2(com_cx).NE.unspecified_int4
	   DO 210 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   cos_factor = 1.
	   IF ( need_cos .AND. integrate ) THEN
#ifdef double_p
	      cos_factor = COS( deg2rad *       
     .             TM_WORLD(j, grid, y_dim, box_middle) ) 
              ybxlo = deg2rad* 
     .             TM_WORLD(j,grid,y_dim,box_lo_lim)
              ybxhi = deg2rad* 
     .             TM_WORLD(j,grid,y_dim,box_hi_lim)
#else
	      cos_factor = COS( deg2rad *       
     .             SNGL( TM_WORLD(j, grid, y_dim, box_middle) ) ) 
              ybxlo = deg2rad* 
     .             SNGL( TM_WORLD(j,grid,y_dim,box_lo_lim) )
              ybxhi = deg2rad* 
     .             SNGL( TM_WORLD(j,grid,y_dim,box_hi_lim) )
#endif
              bx = ABS(ybxhi - ybxlo)
	      cos_factor = ABS( SIN(ybxhi) - SIN(ybxlo) )/ bx
	   ENDIF
	   DO 210 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 210 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 210 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 210 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
              IF ( point ) THEN  ! 8/92
                 IF ( com(lo,j,k,l,m,n) .EQ. bad_com ) THEN
                    res(pt,j,k,l,m,n) = bad_res
                 ELSEIF ( integrate ) THEN
                    res(pt,j,k,l,m,n) = 0.0
                 ELSE
                    res(pt,j,k,l,m,n) = com(lo,j,k,l,m,n)
                 ENDIF
		 weights(pt,j,k,l,m,n) = 1.0
                 GOTO 210
              ENDIF
	      dsum = 0.0D0	! data
	      bsum = 0.0D0	! boxes
	      DO 200 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_com ) GOTO 200
	         bsum = bsum + box(i)
	         dsum = dsum + box(i)*com(i,j,k,l,m,n)
 200	      CONTINUE
	      res(pt,j,k,l,m,n) = res(pt,j,k,l,m,n) + dsum* cos_factor
	      weights(pt,j,k,l,m,n) = weights(pt,j,k,l,m,n) + bsum

 210	   CONTINUE

* ALONG Y AXIS
	ELSEIF ( idim .EQ. y_dim ) THEN
	   DO 310 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 310 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 310 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 310 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 310 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
              IF ( point ) THEN   ! 8/92
                 IF ( com(i,lo,k,l,m,n) .EQ. bad_com ) THEN
                    res(i,pt,k,l,m,n) = bad_res
                 ELSEIF ( integrate ) THEN
                    res(i,pt,k,l,m,n) = 0.0
                 ELSE
                    res(i,pt,k,l,m,n) = com(i,lo,k,l,m,n)
                 ENDIF
		 weights(i,pt,k,l,m,n) = 1.0
                 GOTO 310
              ENDIF
	      dsum = 0.0D0	! data
	      bsum = 0.0D0	! boxes
	      DO 300 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_com ) GOTO 300
	         bsum = bsum + box(j)
	         dsum = dsum + box(j)*com(i,j,k,l,m,n)
 300	      CONTINUE
	      res(i,pt,k,l,m,n) = res(i,pt,k,l,m,n) + dsum
	      weights(i,pt,k,l,m,n) = weights(i,pt,k,l,m,n) + bsum
 310	   CONTINUE

* ALONG Z AXIS
	ELSEIF ( idim .EQ. z_dim ) THEN
	   DO 410 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 410 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 410 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 410 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 410 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
              IF ( point ) THEN    ! 8/92
                 IF ( com(i,j,lo,l,m,n) .EQ. bad_com ) THEN
                    res(i,j,pt,l,m,n) = bad_res
                 ELSEIF ( integrate ) THEN
                    res(i,j,pt,l,m,n) = 0.0
                 ELSE
                    res(i,j,pt,l,m,n) = com(i,j,lo,l,m,n)
                 ENDIF
                 weights(i,j,pt,l,m,n) = 1.0
                 GOTO 410
	      ENDIF
	      dsum = 0.0D0	! data
	      bsum = 0.0D0	! boxes
	      DO 400 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_com ) GOTO 400
	         bsum = bsum + box(k)
	         dsum = dsum + box(k)*com(i,j,k,l,m,n)
 400	      CONTINUE
              res(i,j,pt,l,m,n) = res(i,j,pt,l,m,n) + dsum
              weights(i,j,pt,l,m,n) = weights(i,j,pt,l,m,n) + bsum
 410	   CONTINUE

* ALONG T AXIS
	ELSEIF ( idim .EQ. t_dim ) THEN
	   DO 510 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 510 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 510 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 510 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 510 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
              IF ( point ) THEN
                 IF ( com(i,j,k,lo,m,n) .EQ. bad_com ) THEN
                    res(i,j,k,pt,m,n) = bad_res
                 ELSEIF ( integrate ) THEN
                    res(i,j,k,pt,m,n) = 0.0
                 ELSE
                    res(i,j,k,pt,m,n) = com(i,j,k,lo,m,n)
                 ENDIF
		 weights(i,j,k,pt,m,n) = 1.0
                 GOTO 510
              ENDIF
	      dsum = 0.0D0	! data
	      bsum = 0.0D0	! boxes
	      DO 500 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_com ) GOTO 500
	         bsum = bsum + box(l)
	         dsum = dsum + box(l)*com(i,j,k,l,m,n)
 500	      CONTINUE
* ... accumulate weighted values and weights
	      weights(i,j,k,pt,m,n) = weights(i,j,k,pt,m,n) + bsum
	      res    (i,j,k,pt,m,n) = res    (i,j,k,pt,m,n) + dsum
 510	   CONTINUE


* ALONG E AXIS
	ELSEIF ( idim .EQ. e_dim ) THEN
	   DO 610 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 610 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 610 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 610 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 610 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
              IF ( point ) THEN
                 IF ( com(i,j,k,l,lo,n) .EQ. bad_com ) THEN
                    res(i,j,k,pt,m,n) = bad_res
                 ELSEIF ( integrate ) THEN
                    res(i,j,k,l,pt,n) = 0.0
                 ELSE
                    res(i,j,k,l,pt,n) = com(i,j,k,l,lo,n)
                 ENDIF
		 weights(i,j,k,l,pt,n) = 1.0
                 GOTO 610
              ENDIF
	      dsum = 0.0D0	! data
	      bsum = 0.0D0	! boxes
	      DO 600 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_com ) GOTO 600
	         bsum = bsum + box(m)
	         dsum = dsum + box(m)*com(i,j,k,l,m,n)
 600	      CONTINUE
	      res(i,j,k,l,pt,n) = res(i,j,k,l,pt,n) + dsum
	      weights(i,j,k,l,pt,n) = weights(i,j,k,l,pt,n) + bsum
 610	   CONTINUE


* ALONG F AXIS
	ELSEIF ( idim .EQ. f_dim ) THEN
	   DO 710 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 710 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 710 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 710 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 710 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
              IF ( point ) THEN
                 IF ( com(i,j,k,l,m,lo) .EQ. bad_com ) THEN
                    res(i,j,k,l,m,pt) = bad_res
                 ELSEIF ( integrate ) THEN
                    res(i,j,k,l,m,pt) = 0.0
                 ELSE
                    res(i,j,k,l,m,pt) = com(i,j,k,l,m,lo)
                 ENDIF
		 weights(i,j,k,l,m,pt) = 1.0
                 GOTO 710
              ENDIF
	      dsum = 0.0D0	! data
	      bsum = 0.0D0	! boxes
	      DO 700 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_com ) GOTO 700
	         bsum = bsum + box(n)
	         dsum = dsum + box(n)*com(i,j,k,l,m,n)
 700	      CONTINUE
	      res(i,j,k,l,m,pt) = res(i,j,k,l,m,pt) + dsum
	      weights(i,j,k,l,m,pt) = weights(i,j,k,l,m,pt) + bsum
 710	   CONTINUE

	ENDIF

	RETURN
	END

	LOGICAL FUNCTION OK_JUXTAPO (las_ptr,inf_ptr,atom_type,atom_id)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Determines whether juxtaposition of two atom types in the infix string
*	is allowed in the syntax of things.

*	J Davison TMAP/JISAO/PMEL/NOAA
*	10.22.87
* V200: 11/23/89 - replaced constants with parameter names and strings !!!
* 12/96 *kob* - Linux Port - had to move variable assignments off of
*               declaration line. used DATA rather than PARAMETER stmnt.
* V450: 12/96 - add checks for grid changing functions and child variables
* V500: 12/98 *sh*  added alg_const_var -- for fixed arrays such as "{1,3,5}"
*	 1/99 - added alg_string   
* V554 1/04 *acm* Add category alg_counter_var for counter variables; REPEAT/RANGE=/NAME=
* V600 8/05 *acm* - Add variable type attrib_val for definitions of the form
*                   varname.attname
* V671 7/11  *acm* Ticket 1868 IFV - masking expressions with ifValid, treating 
*		   zero as valid. 
* V720: 4/17 *acm* add direction-changing functions as a subset of grid-changing ones

	include		'ferret.parm'
	include		'rpn.parm'
	include		'xalgebra.cmn'

	CHARACTER	punct*1
	integer		las_ptr,inf_ptr,atom_type(*),atom_id(*)
	integer		atom(2),ndx(2),i,val
	integer		kar_matrix(8,8)
	DATA	 	kar_matrix	/0,0,1,0,0,1,0,0,
     .					1,1,0,1,1,0,1,0,
     .					1,1,0,1,1,0,1,0,
     .					0,0,1,0,0,1,0,0,
     .					1,1,0,1,1,0,1,1,
     .					0,0,1,0,0,1,0,0,
     .					0,0,1,1,1,1,0,0,
     .					1,1,0,1,1,0,1,0/

*******************************************************************************

	atom(1) = las_ptr
	atom(2) = inf_ptr

	do 100 i = 1,2

*	   LEFT_PAREN PLACED ON LEFT END OF INFIX STRING
	   if (atom(i) .eq. added_left_paren) then
	      ndx(i) = 5
	      goto 100
	   end if

*	   ALL OPERATORS EXCEPT NOT
	   if (atom_type(atom(i)) .eq. alg_operator) then
	      if (alg_op(atom_id(atom(i))) .ne. 'NOT' )then
		 ndx(i) = 1
	      else 
	         ndx(i) = 2
	      end if
	      goto 100
	   end if

*	   CONSTANT, VARIABLE, PSEUDO-VARIABLE OR OPERAND
	   if  (atom_type(atom(i)) .eq. alg_constant
     .	   .or.	atom_type(atom(i)) .eq. alg_variable
     .	   .or.	atom_type(atom(i)) .eq. alg_pseudo_var
     .	   .or.	atom_type(atom(i)) .eq. alg_const_var
     .	   .or.	atom_type(atom(i)) .eq. alg_string
     .	   .or.	atom_type(atom(i)) .eq. alg_child_var
     .	   .or. atom_type(atom(i)) .eq. alg_operand
     .	   .or. atom_type(atom(i)) .eq. alg_counter_var
     .	   .or. atom_type(atom(i)) .eq. alg_attrib_val ) then
	      ndx(i) = 3
	      goto 100
	   end if

*	   COMMA,LEFT OR RIGHT PARENTHESIS
	   if (atom_type(atom(i)) .eq. alg_punctuation ) then
	      punct = alg_punct( atom_id(atom(i)) )
	      if ( punct .eq. ',' ) ndx(i) = 4
	      if ( punct .eq. '(' ) ndx(i) = 5
	      if ( punct .eq. ')' ) ndx(i) = 6
	      goto 100
	   end if

*	   WHERE,THEN OR ELSE
	   if (atom_type(atom(i)) .eq. alg_log_struct) then
	      ndx(i) = 7
	      goto 100
	   end if

*	   IFV,THEN OR ELSE
	   if (atom_type(atom(i)) .eq. alg_log_vstruct) then
	      ndx(i) = 7
	      goto 100
	   end if

*	   FUNCTION
	   if (atom_type(atom(i)) .eq. alg_function
     .	  .OR. atom_type(atom(i)) .eq. alg_grid_chg_fcn
     .	  .OR. atom_type(atom(i)) .eq. alg_dir_chg_fcn) then
	      ndx(i) = 8
	      goto 100
	   end if

*	   ALG_FINISHED (INTERPRETED AS A RIGHT PARENTHESIS)
	   if (atom_type(atom(i)) .eq. alg_finished) then
	      ndx(i) = 6
	      goto 100
	   end if

	   stop 'unknown atom type encountered in ok_juxtapo'
100	continue

	val = kar_matrix(ndx(1),ndx(2))	   

	if (val .eq. 0) then
	   ok_juxtapo = .false.
	else
	   ok_juxtapo = .true.
	end if

	return 
	end

	BLOCK DATA XPLOT_SETUP_DATA

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* initialization of COMMON / XPLOT_SETUP /
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.1 - 9/12/88 - reduced number of defined colors to 10
* V200: 12/21/89
* V540: *sh* 9/01 - added xwhitelo, ywhitelo, ...
* V63  *acm* 10/09 Changes for gfortran build
*      *kms*  2/12 Include tmap_dims.parm for nferdims used by xplot_setup.cmn
* V698 *sh* 3/16 - adjusted key_xorigin and key_ywhite_space
* V76 *acm* 11/19 -  Issue 1960: Multi-column line keys for overlays: change ovkey_xorigin

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xplot_setup.cmn'

	DATA
     .		saved_ppl_yax	/ .FALSE. /,
     .		key_xspace0	/ 3.0 /,	! nominal X space for keys
     .		key_yspace0	/ 0.25 /,	! nominal Y space for keys
     .		key_labht0	/ 0.12 /,	! nominal label height for keys
     .		key_xorigin	/ 0.75  /,	! leftmost x loc. of keys
     .		key_yorigin	/ -0.85 /,	! y loc. of topmost keys
     .		key_xwhite_space/ 0.3  /,	! x space between keys
     .		key_ywhite_space/ 0.05 /,	! y space between keys
     .		key_line_frac   / 0.25 /,	! line specimen width

     .		ovkey_xspace	/ 2.1 /,
     .		ovkey_yspace	/ 0.18 /,
     .		ovkey_labht	/ 0.08 /,
     .		ovkey_xorigin	/-1.1  /,
     .		ovkey_yorigin	/-0.6 /,
     .		ul_labht0	/0.12 /,
     .		ul_yspace0	/0.2  /,
     .		ul_xorigin	/ 0.0 /,	! measured from Y axis
     .		ul_yorigin	/ 0.6 /,	! measured from top x axis
     .		xwhitelo	/ 1.2 /,	! PLOT+ xorigin
     .		ywhitelo	/ 1.4 /,	! PLOT+ yorigin
     .		xwhitehi	/ 1.0 /,
     .		ywhitehi	/ 1.4 /

	END

	INTEGER FUNCTION ISUBSCRIPT ( world_coord, grid, idim, round_code )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* convert a "world" coordinate into the subscript value on an axis of the grid
* box containing this value.  When the coordinate lies directly on the boundary
* use round_code to resolve the ambiguity.

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 4/16/86
* revision 1.0 - 3/10/86 - grid lines stored in COMMON/~VARIABLES/
* revision 1.2 - 3/23/87 - added new TMAP library: time axes, file var. names
* revision 1.3 - 2/18/88 - incorporated "regular" axes; trapped "unspecified"
*			    world coordinate input
* revision 1.4 - 7/28/88 - interpret negative times as seconds since 1-JAN-0000
* revision 1.5 -12/14/88 - incorporate new IO library with grid box lower bounds
*			   instead of box sizes
* revision 2.0 - 2/3/89  - incorporated modulo axes and reorganized
* Unix/RISC port - 1/91 - cant use "/star" in comment lines on Unix
*                  7/91 - eliminated unneeded common *variables and errmsg.parm
*                 10/92 - bug fix for modulo axis point that lies exactly on a
*                         multiple of the axis length (search "10/92")
* V301: 2/7/94 - bug in calculation of "last"for regular axes.  This bug never
*		 showed up in program behavior - possibly because
*		 GRID_WORLD_EXTREMES is always called first (?)
* V420: 10/95 - for axes which are children of others avoid direct use of
*		line_mem -- instead use TM_WORLD
*	 1/96 - bug fix: many references to sub0 remained despite 10/95 chgs
* 9/97 *kob* - w/ negative time axis capablities, this routine will not have
*	      to worry about date strings...
* V541: *sh* 2/02 - added support for subspan modulo axes
* V673: *acm* 10/11 Bug 1888. Single-precision calculations in the block starting
*                   * quick sol'n if axis points are regularly spaced
*                   did not give enough accuracy for axes defined in terms of 
*                   seconds.  Convert all this to double-precision calculations.

	include 'tmap_dims.parm'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'

* calling argument declarations:
	INTEGER	grid, idim, round_code
	REAL*8	world_coord

* internal variable declarations:
	LOGICAL	TM_DFPEQ, TM_ITS_SUBSPAN_MODULO, regular
	INTEGER	lo_look, hi_look, axis, ibot, itop, look,
     .		line_len, isubsc, num_mod
	REAL*8	TM_WORLD, TM_WW_AXLEN, 
     .		wwindex, wcoord, half_way, start, aend, span, 
     .		first, last, dsubsc

* which axis are we on ?
	axis    = grid_line ( idim, grid )
	line_len = line_dim( axis )

* check for peculiar calls
	IF (  axis .EQ. mnormal
     .	 .OR. axis .EQ. munknown ) THEN
	   ISUBSCRIPT = axis
	   RETURN
	ELSEIF ( world_coord .EQ. unspecified_val8 ) THEN
	   ISUBSCRIPT = unspecified_int4
	   RETURN
	ENDIF

	   wcoord = world_coord

* special consideration for sub-span modulo axis outside its core range
	IF (TM_ITS_SUBSPAN_MODULO(axis) ) THEN
	   CALL TM_WW_AX_1_N(axis, start, aend)
	   IF ( wcoord.LT.start .OR. wcoord.GT.aend ) THEN
	      line_len = line_len + 1
	      regular = .FALSE.
	   ELSE
	      regular = line_regular( axis )
	   ENDIF
	ELSE
	   regular = line_regular( axis )
	ENDIF

* initialize pointers for axes with irregularly spaced points
	IF ( .NOT.regular ) THEN
	   ibot  = 1
	   itop  = line_len
	ENDIF

* Modulo axis: translate world coord to within axis range
	IF ( line_modulo( axis ) ) THEN
* ... begin by computing axis limits as outer edges of end boxes
	   span = TM_WW_AXLEN(axis)
	   CALL TM_WW_AXLIMS(axis, start, aend)
	   IF (TM_ITS_SUBSPAN_MODULO(axis)) THEN
	      span = line_modulo_len(axis)
	      aend = start + span
	   ENDIF

* ... now translate to within axis limits saving modulo number
	   IF (.NOT.TM_DFPEQ(wcoord, aend) .AND. (wcoord .GT. aend)) THEN
	      num_mod = ( wcoord - start ) / span
! 10/92 bug fix: if wcoord is an exact multiple of length (e.g. wccord=24.
!       start=0., span=12.) then modulo remap to top of ax rather than bottom
              IF ( wcoord .EQ. start+num_mod*span )
     .                          num_mod = num_mod - 1
	   ELSEIF ( wcoord .LT. start ) THEN
	      num_mod = ( wcoord - aend  ) / span		! (negative)
	   ELSE
	      num_mod = 0
	   ENDIF
	   wcoord = wcoord - num_mod*span
	ENDIF

* get positions of first and last points on axis
	IF ( regular ) THEN
	   first = line_start( axis )
	   last  = first + line_delta(axis) * (line_len-1) !4/94 was *line_len
        ELSE
           first = TM_WORLD(       1, grid, idim, box_middle)
           last  = TM_WORLD(line_len, grid, idim, box_middle)
	ENDIF

* immediate solutions for given point beyond axis ends
	IF ( wcoord .LE. first ) THEN
	   isubsc = 1
	ELSEIF ( wcoord .GE. last) THEN
	   isubsc = line_len

* quick sol'n if axis points are regularly spaced
	ELSEIF ( regular ) THEN
	   dsubsc = (wcoord-first)/line_delta(axis) + .5
	   isubsc = INT( dsubsc )
	   IF ( TM_DFPEQ(dsubsc,DBLE( isubsc )) ) THEN
* ...... value is on box boundary
	      IF     ( round_code .EQ. round_up ) THEN
	         isubsc = isubsc + 1
	      ELSEIF ( round_code .EQ. round_dn ) THEN
	         CONTINUE
	      ELSE
	         STOP 'ISUBSCRIPT round code'
	      ENDIF
	   ELSE
* ...... value is not on box boundary
	      isubsc = isubsc + 1
	   ENDIF

	ELSE
* binary search if axis points are irregularly spaced
* initialize search
	   lo_look  = ibot - 1
	   hi_look  = itop + 1	
	   look     = ( lo_look + hi_look ) / 2

* top of search loop
 100       wwindex = TM_WORLD(look, grid, idim, box_middle)
	   IF ( wcoord .GE. wwindex ) THEN

* answer is somewhere above current "look" position
* keep looking at higher values setting this as new low limit for search
	      lo_look = look
	      look = ( look + hi_look + 1 ) / 2

	   ELSE
* answer is somewhere below current "look" position
* keep looking at lower values setting this as new high limit for search
	      hi_look = look
	      look = ( look + lo_look ) / 2

	   ENDIF

* have we narrowed it to a 1 point range ?
	   IF ( hi_look - lo_look .LE. 1 ) THEN

* yes - we found it - choose box containing it
* ... box boundary between lo_look and hi_look
	      half_way = TM_WORLD(hi_look, grid, idim, box_lo_lim)

* value on box boundary ?
	      IF ( TM_DFPEQ( half_way, wcoord ) ) THEN
	         IF     ( round_code .EQ. round_up ) THEN
		    isubsc = hi_look
	         ELSEIF ( round_code .EQ. round_dn ) THEN
		    isubsc = lo_look
	         ELSE
	            STOP 'ISUBSCRIPT round code'
	         ENDIF

* no. value in upper half of box ?
	      ELSEIF ( wcoord .GE. half_way ) THEN
	         isubsc = hi_look

* no. value must be in lower half of box
	      ELSE
	         isubsc = lo_look

	      ENDIF
	   ELSE

* no - keep looking
	      GOTO 100
	   ENDIF
	ENDIF

* add modulo axis correction
	IF ( line_modulo(axis) ) THEN
	   ISUBSCRIPT = isubsc + num_mod*line_len
	ELSE
	   ISUBSCRIPT = isubsc
	ENDIF

	RETURN
	END

c*
c* ef_get_arg_subscripts_6d.F (formerly ef_get_arg_subscripts.F)
c*   
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
c* Jonathan Callahan
c* Feb 19th 1998
c*
c*
c* Initialize the context limits the EF will use.  
c*
c* V510 12/99 *sh* - cope with unspecified limits (default=full axis range)
c*               and limits embedded inside of user variable definitions
c*               as in LET a = sst[L=5:9]; LIST FFT(a) (info from uvar_*)
c*      3/00 *sh* - bug fix: above logic applies only to CUSTOM axes 
*       3/12 *kms* Added E and F dimensions, appended _6D to subroutine name
*                  Reduced the outer dimensionality of arg_lo_ss, arg_hi_ss,
*                  and arg_incr from EF_MAX_ARG+1 to EF_MAX_ARGS

      SUBROUTINE EF_GET_ARG_SUBSCRIPTS_6D(id, arg_lo_ss, arg_hi_ss, 
     .                                    arg_incr)

      IMPLICIT NONE
      INCLUDE 'tmap_dims.parm'
      INCLUDE 'ferret.parm'
      INCLUDE 'xcontext.cmn'
      INCLUDE 'xvariables.cmn'
      INCLUDE 'EF_Util.parm'

* argument declarations
      INTEGER id, arg_lo_ss(nferdims,EF_MAX_ARGS),
     .            arg_hi_ss(nferdims,EF_MAX_ARGS),
     .            arg_incr (nferdims,EF_MAX_ARGS)


* internal variable declarations
      LOGICAL embedded_limits
      INTEGER idim, iarg, num_reqd_args, cat, var
      INTEGER cx_list(EF_MAX_ARGS), ax_src(nferdims)
      INTEGER efcn_get_num_reqd_args

      num_reqd_args = efcn_get_num_reqd_args(id)
      CALL efcn_get_axis_will_be(id, ax_src)

c* The context list was cached by Ferret and must be retrieved
c* to be accessible to the external function.
      CALL EF_GET_CX_LIST(cx_list)

      DO 200 idim=1,nferdims

         DO 100 iarg=1, num_reqd_args

            IF ( cx_given(idim,cx_list(iarg)) ) THEN
* limits are explicit in the top-level expression
              arg_lo_ss(idim,iarg) = cx_lo_ss(cx_list(iarg), idim)
              arg_hi_ss(idim,iarg) = cx_hi_ss(cx_list(iarg), idim)
            ELSE
* are there explicit limits embedded within user-var definitions?
              cat = cx_category( cx_list(iarg) )
              var = cx_variable( cx_list(iarg) )
              IF ( cat .EQ. cat_user_var ) THEN
                 embedded_limits =
     .                 uvar_given(idim,var) .GE. uvlim_gvn_gnl
     .           .AND. uvar_given(idim,var) .LE. uvlim_gvn_xact
              ELSE
                 embedded_limits = .FALSE.
              ENDIF
              IF ( embedded_limits ) THEN
* ... get embedded explicit limits from the user-variable definition
                arg_lo_ss(idim,iarg) = uvar_lo_ss(var, idim)
                arg_hi_ss(idim,iarg) = uvar_hi_ss(var, idim)
              ELSE
                IF (ax_src(idim) .NE. CUSTOM) THEN
* ... result axis inherits limits from SET REGION and command qualifiers, etc.
* NOTE: ARG LIMITS WILL BE WRONG IF USED DURING GRID-CREATION
*       (which should never happen ...)
                  arg_lo_ss(idim,iarg) = cx_lo_ss(cx_list(iarg), idim)
                  arg_hi_ss(idim,iarg) = cx_hi_ss(cx_list(iarg), idim)
                ELSE
* ... result axis is imposed by the EF and this arg has no explicit limits
*     so infer the limits from the nature of the variable
                  IF (  cat .EQ. cat_file_var ) THEN
*    ... get limits of file variable (possibly less than full-axis)
                    CALL VAR_SS_LIMS( idim, cx_list(iarg),
     .                                arg_lo_ss(idim,iarg),
     .                                arg_hi_ss(idim,iarg) )
                  ELSE
*    ... assume the full span of the defining axis as the default range
                    CALL GRID_SUBSCRIPT_EXTREMES_NO_MOD(
     .                  arg_lo_ss(idim,iarg),
     .                  arg_hi_ss(idim,iarg),
     .                  cx_grid(cx_list(iarg)), idim)
                  ENDIF
                ENDIF
              ENDIF
            ENDIF

* fill in the delta to indicate if a range is available
            IF (arg_lo_ss(idim,iarg) .EQ. arg_hi_ss(idim,iarg)) 
     .           THEN
               arg_incr(idim, iarg) = 0
            ELSE
               arg_incr(idim, iarg) = 1
            ENDIF

 100     CONTINUE

 200  CONTINUE

* Fill in "unused" values for the unused arguments - for checking in the 4D version
      DO 400 iarg=num_reqd_args+1, EF_MAX_ARGS
         DO 300 idim=1,nferdims
            arg_lo_ss(idim, iarg) = unspecified_int4
            arg_hi_ss(idim, iarg) = unspecified_int4
            arg_incr (idim, iarg) = 0
 300     CONTINUE
 400  CONTINUE

      RETURN 
      END

	SUBROUTINE REPLACE_BAD_DATA( src, msrc, cx, old_bad )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* replace all occurances of the value "old_bad" with the bad data flag
* associated with this msrc

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* revision 0.0 - 3/19/87
* V200:  5/18/89 - 4D-symmetrical version
*	10/16/89 - modified array declarations using REPLACE_BAD_DATA_SUB
* V500: 2/18/99 - *kob* - call new C routine REPLACE_BAD_DATA_SUB which
*                         will check for use of NaN as missing/bad flag.  new
*                         routine is also simpler and faster
* V541: *sh* 4/02 - need to use MGRID_SIZE_DELTA to determine the size
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'

* calling argument declarations:
* 2/99 *kob* add new variable size and reference to function MGRID_SIZE
	INTEGER	msrc, cx, size, MGRID_SIZE_DELTA
	REAL    src( * )
	REAL	old_bad

	size = MGRID_SIZE_DELTA(msrc)
        CALL REPLACE_BAD_DATA_SUB( old_bad, src, size,
     .                            mr_bad_data(msrc) )

	RETURN
	END

* scat2grid_subs:  Subroutines called by the scat2grid functions.
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*

      SUBROUTINE pickout1 (atim, n, val)


*  ACM 5/2003
*  Called from the ave_scat2grid_t function.
*  Pick out nth item from atim, which is really 4-D 
*  with normal axes on three of the four axes.

      REAL atim(*)
      REAL val
      INTEGER n

      val = atim(n)

      RETURN
      END


      SUBROUTINE pickout2 (alon, alat, n, xx, yy)


*  ACM 3/2000
*  Called from the scatter*  gridding functins.
*  Pick out nth item from alon and alat, which are really 4-dimensioned arrays
*  with normal axes on three of the four axes.
*  (can be any variables, typically lon and lat)

      REAL alon(*), alat(*)
      REAL xx, yy
      INTEGER n

      xx = alon(n)
      yy = alat(n)

      RETURN
      END

      SUBROUTINE pickout3 (alon, alat, atimes, n, xx, yy, tt)

*  CALLed from the scatter*  gridding functins.
*  Pick out nth item from alon and alat, which are really 4-dimensioned arrays
*  with normal axes on three of the four axes.
*  (can be any variables, typically lon,lat,time or lon,lat,depth)

      REAL alon(*), alat(*), atimes(*)
      REAL xx, yy, tt
      INTEGER n

      xx = alon(n)
      yy = alat(n)
      tt = atimes(n)

      RETURN
      END

      SUBROUTINE pickout4 (alon, alat, atimes, vals, n, xx, yy, tt, vv)

*  Called from the scatter*  gridding functins.
*  Pick out nth item from alon and alat, which are really 4-dimensioned arrays
*  with normal axes on three of the four axes.
*  (can be any variables, typically lon,lat,time,value or lon,lat,depth,time, etc)

      REAL alon(*), alat(*), atimes(*), vals(*)
      REAL xx, yy, tt, vv
      INTEGER n

      xx = alon(n)
      yy = alat(n)
      tt = atimes(n)
      vv = vals(n)

      RETURN
      END

c************************************************************************
c...NOBS.....Based on gausswt, return only the # of obs in (x,y) gridbox
c............method is to call this sub for each data value
c............all calcs done in gridbox units
c............xx/x1/xf all in same units
c............yy/y1/yf all in same units

c  i	xx,yy=x/y location of data pt (data units)
c  i	nx,ny=size of grids
c  i	x1,y1=west/south edge of grid (center of 1st box in data units)
c  o 	obs(nx,ny) number of obs in each (x,y) gridbox
c--------------------------------------------------------------------------

	SUBROUTINE nobs (xx, yy, nx, ny, x1, y1, dx, dy, 
     .			 xf, yf, obs)


* Argument declarations

        INTEGER nx, ny
	REAL xx, yy, dx, dy, x1, y1, xf, yf, obs(nx,ny)

* Local variable declarations

        REAL xxg, yyg
        INTEGER ig, jg

	xxg = (xx-x1)/ dx + 1.		  ! grid values of data location
	yyg = (yy-y1)/ dy + 1.

c.................save the number of obs in each (x,y) gridbox
	ig = NINT(xxg)
	jg = NINT(yyg)
	IF (ig.GE.1 .AND. ig.LE.nx .AND. jg.GE.1 .AND. jg.LE.ny)
     .		obs(ig,jg) = obs(ig,jg)+1.

	RETURN
	END



c************************************************************************
c...NOBS.....Based on gausswt, return only the # of obs in (x,y) gridbox
c............method is to call this sub for each data value
c............all calcs done in gridbox units
c............xx/x1/xf all in same units
c............yy/y1/yf all in same units

c  i	xx,yy,tt=x/y/t location of data pt (data units)
c  i	nx,ny,nt=size of grids
c  i	x1,y1,L1=west/south/earliest edge of grid (center of 1st box in data units)
c  o 	obs(nx,ny,nt) number of obs in each (x,y,t) gridbox
c--------------------------------------------------------------------------

	SUBROUTINE nobsxyt (xx, yy, tt, nx, ny, nt, x1, y1, t1, 
     .                 dx, dy, dt, xf, yf, tf, obs)


* Argument declarations

        INTEGER nx, ny, nt
	REAL xx, yy, tt, x1, y1, t1, dx, dy, dt, xf, 
     .       yf, tf, obs(nx,ny,nt)

* Local variable declarations

        REAL xxg, yyg, ttg
        INTEGER ig, jg, Lg ! !!!!!!!!!!!!!!!!!!!!!!!! adding t dimension throughtout

	xxg = (xx-x1)/ dx + 1.		  ! grid values of data location
	yyg = (yy-y1)/ dy + 1.
	ttg = (tt-t1)/ dt + 1.

c.................save the number of obs in each (x,y,t) gridbox
	ig = NINT(xxg)
	jg = NINT(yyg)
	Lg = NINT(ttg)
	IF (ig.GE.1 .AND. ig.LE.nx .AND. jg.GE.1 .AND. jg.LE.ny .AND.
     .      Lg.GE.1 .AND. Lg.LE.nt   )
     .		obs(ig,jg,Lg) = obs(ig,jg,Lg)+1.

	RETURN
	END


      SUBROUTINE pickout (atim, n, val)


*  ACM 5/2003
*  Called from the ave_scat2grid_t function.
*  Pick out nth item from atim, which is really 4-D 
*  with normal axes on three of the four axes.

      REAL atim(*)
      REAL val
      INTEGER n

      val = atim(n)

      RETURN
      END

	SUBROUTINE CLEAN_COORD_STRING ( idim, string )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* replace the blank in "dd-mmm-yyyy hh:mm:ss" with a colon
* axe the time field from climatological dates: "dd-mmm      hh:mm" -> "dd-mmm"
* replace 19E(379) with the unambiguous 379E

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V300:  8/27/93
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction. 

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'xvariables.cmn'

* calling argument declarations:
	INTEGER idim
	CHARACTER*(*) string

* internal variable declarations:
	INTEGER		TM_LENSTR1, i, i0, slen

	IF ( idim.EQ.y_dim .OR. idim.EQ.z_dim ) RETURN

	slen = TM_LENSTR1( string )

	IF ( idim .EQ. t_dim .OR. idim .EQ. f_dim ) THEN
* FIX TIMES
	   IF ( slen .LE. 11 ) RETURN   	! date, only - no time
	   IF ( string(3:3) .NE. '-' ) RETURN	! not a date string

	   IF ( string(9:9) .EQ. ' ' ) THEN
* wipe out time on climatological dates
	      DO 100 i = 7, slen
	        string(i:i) = ' '
 100	      CONTINUE
	   ELSE
	     string(12:12) = ':'
	   ENDIF

	ELSE
* FIX LONGITUDES
	   i0 = INDEX( string, '(' )      ! e.g."19E(379)"
	   IF ( i0 .GT. 0 ) THEN
	      DO 200 i = i0+1, slen-1     ! --> "379(379)"
 200	      string(i-i0:i-i0) = string(i:i)
	      DO 210 i = slen-i0, slen    ! --> "379     "
 210	      string(i:i) = ' '
	      slen = slen-i0
	      string(slen:slen) = 'E'     ! --> "379E"
	   ENDIF

	ENDIF

	RETURN
	END

	SUBROUTINE CANCEL_ONE_DATA_SET( dset, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* close a single dataset
* if this dataset is an aggregation remove its special axes

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:	10/20/89 - extracted from XEQ_CANCEL with enhancements to accept /ALL
*		   and data set names
*	 12/8/89 - if saved_dset is cancelled then indicate that
* Unix/RISC port 8/91 *sh*
*     bug fix: calling var, iset, was used as an internal loop index
* Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
* V533: *sh* 6/01 - close set after deletions to avoid "%%" diagnostics
* V685 *acm* 4/13 - If its a member of an aggregation, also close the agg
* V698 *sh* 1/16 - complexity removed to the parent routine, CANCEL_DATA_SET
* V698  3/16 *acm* Removed Philander-Seigel code including diagnostic 
*                  variables, pre-defined axes and grids, cat_calc_var.
*            *sh*  deallo special E and F axes even if user has re-defined them

* calling arguments
*  dset      -  (input) dataset number to be closed
*  status    - (output) return status

        IMPLICIT NONE
	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'tmap_errors.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xrisc.cmn'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data

* calling argument declarations:
	INTEGER	dset, status

* local variable declarations:
	LOGICAL NC_GET_ATTRIB_STRING, got_it
	INTEGER TM_GET_LINENUM
	INTEGER	iclim, iclim_user, i, nmemb, imemb, membset, 
     .          ivar, axis, varid, parent,
     .          memb_cat, memb_dset, memb_grid, iline, memb_var,
     .          attid, attype, attlen, attoutflag
	CHARACTER axname*12, attname*12

* local parameter declarations
	LOGICAL do_warn
	INTEGER max_slen
	PARAMETER (do_warn = .TRUE.,
     .		   max_slen = 12)


* since ensembles create so much dataset proliferation, need a diagnostic
* message to see what is being canceled
	IF (mode_diagnostic) CALL SPLIT_LIST(pttmode_ops, ttout_lun,
     .		' canceling dset '//ds_des_name(dset), 0 )

* delete any memory variables from this data set
* ( necessary because their pointers will lead to incorrect data set 
*   information and possibly misleading output )
	CALL ERASE_DSET( dset )

* If canceling an F aggregation then ...
* de-allocate special axes TF_LAG_F and TF_CAL_T
* get the names of these special axes from the attribute pointers
	IF (ds_type(dset).EQ.'FCT') THEN
	   CALL CD_GET_VAR_ID (dset, '.', varid, status)
	   CALL CD_GET_VAR_ATT_ID (dset, varid, '_cal_t_ax', attid, status)
	   IF (status.EQ.atom_not_found) GOTO 5100
           CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, 
     .                attname, attype, attlen, attoutflag, status )
	   IF (status.EQ.atom_not_found) GOTO 5100
	   got_it = NC_GET_ATTRIB_STRING (dset, varid, attname, 
     .                                do_warn, 'global', max_slen,  
     .                                attlen, attoutflag, axname)
	   axis = TM_GET_LINENUM(axname)
	   CALL TM_DEALLO_DYN_LINE(axis)

	   CALL CD_GET_VAR_ATT_ID (dset, varid, '_lag_f_ax', attid, status)
	   IF (status.EQ.atom_not_found) GOTO 5100
           CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, 
     .                attname, attype, attlen, attoutflag, status )
	   IF (status.EQ.atom_not_found) GOTO 5100
	   got_it = NC_GET_ATTRIB_STRING (dset, varid, attname, 
     .                                do_warn, 'global', max_slen, 
     .                                attlen, attoutflag, axname)
	   axis = TM_GET_LINENUM(axname)
	   CALL TM_DEALLO_DYN_LINE(axis)
	ENDIF

* really close and cancel the data set
	CALL TM_CLOSE_SET( dset, status )
	IF ( status .NE. merr_ok ) RETURN

        RETURN

* error exits
 5000	RETURN
 5100	CALL ERRMSG(ferr_internal, status, 'cancel_data_set', *5000 )

	END

	SUBROUTINE EQUAL_RANGE( string,idim,lo,hi,delta,formatted,
     .				range_rqd, cal_id, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* from a string of the form "name=value", return the lo/high value range
* if the string is simply "name" then return unspecified values
* the "delta" value is optional - return unspecfied_val8 if not given

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V3.00  20/10/93 - *sh*
* V3.20  18/08/94 - *kob*  IBM port requires use of RISC buff for string concat's
* 1/97 *kob* - Linux Port - had to move variable assignments off of
*               declaration line.
* V500 *sh* - 6/99 check for quotations around text (e.g. date strings)
* V521 *sh* - added boolean "range_rqd" argument
* V530 *acm* - send cal_id to TRANSLATE_LIMIT
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction.
* V693+ *sh* 2/15 - added support for _DQ_ quotations
*		    mixing double quote marks and _DQ_ may lead to a bad place

* calling argument declarations
	LOGICAL		formatted, range_rqd
	INTEGER		idim, cal_id, status
	REAL*8		lo, hi, delta
	CHARACTER*(*)	string

* internal variable declarations
	LOGICAL		has_delta, ldummy, not_by_ss, in_quote, in_DQ
	PARAMETER 	(not_by_ss =  .FALSE.)
	INTEGER 	equal_pos, colon1, colon2, end2, slen, i
	REAL*8		tmp

	include 'ferret.parm'
	include 'errmsg.parm'
#ifdef NO_PASSED_CONCAT
	include 'xrisc.cmn'
#endif

* initialize
	status = ferr_ok
	slen	  = LEN( string )
	equal_pos = INDEX( string, '=' )

* check for gross syntax errors
	IF ( equal_pos .EQ. 0 ) THEN
	   GOTO 5000
	ELSEIF ( equal_pos .EQ. slen ) THEN	
	   GOTO 5000				! "name ="
	ELSEIF ( string(equal_pos+1:) .EQ. ' ' ) THEN
	   GOTO 5000				! "name =    "
! removed 6/99 so quotations wouldn't be trapped here
!	ELSEIF ( .NOT.TM_DIGIT(string(equal_pos+1:)) ) THEN
!	   GOTO 5000				! "name = text"
	ENDIF

* lo:hi:delta parsing and syntax checking
	colon1 = 0
	in_quote = .FALSE.
	in_DQ    = .FALSE.
	i = equal_pos
	DO WHILE (i .LT. slen)
	   i = i + 1
	   IF (string(i:i) .EQ. '"') THEN
	      in_quote = .NOT.in_quote
	   ELSEIF (string(i:i) .EQ. '_' .AND. i+3 .LE. slen ) THEN
	      IF (string(i:i+3) .EQ. "_DQ_" ) THEN
	         in_DQ = .NOT.in_DQ
	         i = i + 3
	      ENDIF
	   ELSEIF (in_quote .OR. in_DQ) THEN
	      CONTINUE	! skip text inside of quotation
	   ELSEIF (string(i:i) .EQ. ':') THEN
	      colon1 = i
	      GOTO 110
	   ENDIF
	ENDDO
	IF ( in_quote .OR. in_DQ) GOTO 5000
	IF (colon1 .EQ. 0 ) GOTO 5000

 110	colon2 = colon1
	i = colon1
	DO WHILE (i .LT. slen)
	   i = i + 1
	   IF (string(i:i) .EQ. '"') THEN
	      in_quote = .NOT.in_quote
	   ELSEIF (string(i:i) .EQ. '_' .AND. i+3 .LE. slen ) THEN
	      IF (string(i:i+3) .EQ. "_DQ_" ) THEN
	         in_DQ = .NOT.in_DQ
	         i = i + 3
	      ENDIF
	   ELSEIF (in_quote .OR. in_DQ) THEN
	      CONTINUE	! skip text inside of quotation
	   ELSEIF (string(i:i) .EQ. ':') THEN
	      colon2 = i
	      GOTO 210
	   ENDIF
	ENDDO
	IF ( in_quote ) GOTO 5000
 210	has_delta = colon2 .GT. colon1
	IF ( has_delta ) THEN
	    end2 = colon2 - 1
	    IF ( slen .LE. colon2 ) GOTO 5000
	ELSE
	   end2 = slen
	ENDIF
	IF ( end2 .LE. colon1 ) GOTO 5000

* translate the low limit
	CALL TRANSLATE_LIMIT( string(equal_pos+1:colon1-1), idim,
     .			      not_by_ss, lo, formatted, cal_id, status )
	IF ( status .NE. ferr_ok ) RETURN

* translate the high limit
	CALL TRANSLATE_LIMIT( string(colon1+1:end2), idim,
     .			      not_by_ss, hi, formatted, cal_id, status )
	IF ( status .NE. ferr_ok ) RETURN

* optionally translate the delta value
	IF ( has_delta ) THEN
	   CALL TRANSLATE_LIMIT( string(colon2+1:slen), idim,
     .			      not_by_ss, delta, ldummy, cal_id, status )
	   IF ( status .NE. ferr_ok ) RETURN
	ELSE
	   delta = unspecified_val8
	ENDIF
	
* date strings are returned negative from TRANSLATE_LIMIT
	IF ( formatted .AND. (idim .EQ. t_dim .OR. idim .EQ. f_dim) ) THEN
	   delta = unspecified_val8	! can't modify time axis with delta
	   has_delta = .FALSE.
	   lo = -1 * lo
	   hi = -1 * hi
	   IF ( lo .GT. hi ) THEN	! PLOT+ cant handle reversed dates
	      tmp = lo
	      lo = hi
	      hi = tmp
	   ENDIF
	ENDIF
      
* two possible notations to indicate reserved limits
* change lo:hi:-delta  to hi:lo:delta
	IF ( has_delta .AND. delta .LT. 0.D0 ) THEN
	   IF ( lo .LT. hi ) THEN
	      tmp = lo
	      lo = hi
	      hi = tmp
	   ENDIF
	   delta = ABS( delta )
	ENDIF

* check for valid range
	IF ( range_rqd ) THEN
	   IF ( lo .EQ. hi ) GOTO 5100
	ENDIF

* success
 1000	RETURN

* errors
 5000	CALL ERRMSG( ferr_syntax, status, string, *1000 )
#ifdef NO_PASSED_CONCAT	
 5100	risc_buff= string
 	CALL ERRMSG( ferr_invalid_command, status,
     .		'Must give a range: '//risc_buff, *1000 )
#else
 5100	CALL ERRMSG( ferr_invalid_command, status,
     .		'Must give a range: '//string, *1000 )
#endif
	END

	SUBROUTINE CREATE_TEMP_MEM_VAR( cx, mr, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* allocate and claim sufficient memory space, and assign and fill a slot in the 
* memory variable table for the variable or expression indicated in the context
* -- flag the variable as temporary

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 4/14/88 - from CREATE_MEM_VAR ver 0.0
* V530   8/00 *sh* - double the memory allocation for string variables
*			(to support 64 bit pointers)
* V533   6/01 *sh* - use CGRID_SIZE_DELTA to allow mem vars with delta values
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V69+ *acm*  9/14 Ticket 1758. Memory request uses number of blocks not words
* V702 1/16 *sh*: find MR slot here, before calling ASSIGN_VARIABLE
*		  for trac enhancement #2369 -- dynamic memory management 

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'

* calling argument declarations:
	INTEGER	cx, mr, status

* internal variable declarations:
	INTEGER*8 i8_size
	REAL R_CGRID_SIZE_DELTA, rgrid_size

* get a free slot in the memory variable table -- delete another var if needed
	CALL FIND_MR_SLOT( mr, status )
	IF ( status .NE. ferr_ok ) RETURN

* amount of storage space required
* Compute as a real - grid sizes may overflow integer storage.

	rgrid_size = R_CGRID_SIZE_DELTA( cx )  ! as a real

* ... note: later we will want an array of word sizes indexed by type
#ifdef double_p
	IF (cx_type(cx) .EQ. ptype_string) rgrid_size = rgrid_size
#else
	IF (cx_type(cx) .EQ. ptype_string) rgrid_size = rgrid_size*2 ! 8 byte ptr
#endif

* claim the dynamic storage space needed
	i8_size = rgrid_size
	CALL GET_MR_DYNMEM( i8_size, mr, status )
	IF ( status .NE. ferr_ok ) THEN
	   CALL MR2FREELIST(mr)
	   RETURN
	ENDIF

* catalog it in the memory variable table
	CALL ASSIGN_TEMP_VAR( cx, mr, status )
	IF ( status .NE. ferr_ok ) RETURN

* hook it into the right cache search list
	CALL HOOK_MR_SLOT( cx, mr)

	RETURN
	END

	SUBROUTINE CROSS
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)cross.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
#ifdef unix
	INCLUDE 'PARAMPL5.DAT'
	INCLUDE 'AXIS.INC'
	INCLUDE 'LABCOM.INC'
	INCLUDE 'LINES.INC'
#else
	INCLUDE 'pplinc:PARAMPL5.DAT'
	INCLUDE 'pplinc:AXIS.INC'
	INCLUDE 'pplinc:LABCOM.INC'
	INCLUDE 'pplinc:LINES.INC'
#endif
	IF(ICROSS.EQ.1)THEN
	    IF(XLO.LT.0..AND.XHI.GT.0.)THEN
		CALL PLOT(0.,YLO,0,0)
		CALL PLOT(0.,YHI,1,0)
	    ENDIF
	    IF(YLO.LT.0..AND.YHI.GT.0.)THEN
		CALL PLOT(XLO,0.,0,0)
		CALL PLOT(XHI,0.,1,0)
	    ENDIF
	ELSE IF(ICROSS.NE.0)THEN
	    IF(ICROSS.EQ.2.OR.ICROSS.EQ.4)THEN
		DO 90 I=1,LNUM
		DO 95 J=I+1,LNUM
		IF(YOFF(I).EQ.YOFF(J))GOTO90
95		CONTINUE
		CALL PLOT (XLO,YOFF(I),0,0)
		CALL PLOT (XHI,YOFF(I),1,0)
90		CONTINUE
	    ENDIF
	    IF(ICROSS.GE.3)THEN
		DO 100 I=1,LNUM
		DO 105 J=I+1,LNUM
		IF(XOFF(I).EQ.XOFF(J))GOTO 100
105		CONTINUE
		CALL PLOT(XOFF(I),YLO,0,0)
		CALL PLOT(XOFF(I),YHI,1,0)
100		CONTINUE
	    ENDIF
	ENDIF
	RETURN
	END

*           rr_diff_umetric.F
*
*           Rick Romea
*           Jan. 24, 2000
*
*     Computes the zonal momentum diffusive metric term  
*     Units :     cm/s/s
*     MOM2 Grid:  U   
*
*******************************************************************

      SUBROUTINE RR_diff_umetric_init(id)
	IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

      CALL ef_set_desc             (id,
     .'Zonal momentum diffusive metric (cm/s^2); MOM2 U Grid')
      CALL ef_set_num_args         (id, 2)
      CALL ef_set_axis_inheritance (id, IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok     (id, NO, NO, YES, YES)

      ! Define first argument (U)

      CALL ef_set_arg_name         (id, ARG1, 'U')
      CALL ef_set_arg_desc         (id, ARG1,
     . 'Zonal velocity, on the MOM2 U Grid. ')
      CALL ef_set_arg_unit         (id, ARG1, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG1, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG1, YES, YES, YES, YES)

      ! Define second argument (V)

      CALL ef_set_arg_name         (id, ARG2, 'V')
      CALL ef_set_arg_desc         (id, ARG2,
     . 'Meridional velocity, on the MOM2 U Grid. ')
      CALL ef_set_arg_unit         (id, ARG2, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG2, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2,YES,YES,YES,YES)
      CALL ef_set_axis_extend      (id, ARG2, X_AXIS,-1,+1)
      END


      SUBROUTINE RR_diff_umetric_compute(id, arg_1, arg_2, result)
	IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER        id

      REAL           bad_flag(EF_MAX_ARGS)
      REAL           bad_flag_result

      REAL           arg_1 (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .                      mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL           arg_2 (mem2lox:mem2hix, mem2loy:mem2hiy, 
     .                      mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL           result (memreslox:memreshix,memresloy:memreshiy,
     .                       memresloz:memreshiz,memreslot:memreshit)

      INTEGER        res_lo_ss (4)
      INTEGER        res_hi_ss (4)
      INTEGER        res_incr  (4)

      INTEGER        arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER        arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER        arg_incr  (4,EF_MAX_ARGS)

      INTEGER        i,  j,  k,  l
      INTEGER        i1, j1, k1, l1
      INTEGER        i2, j2, k2, l2

      INTEGER        ilat,iLon
      CHARACTER *16  ax_name(4)
      CHARACTER *16  ax_units(4)
      LOGICAL        backward(4)
      LOGICAL        modulo(4)
      LOGICAL        regular(4)

      REAL dxt, dxmetr,csu,sine,tng,am3,am4,a3,a4

      REAL*8         xU(1024)
      REAL*8         yU(1024)

      INCLUDE 'rr_parameters.h'

C**********************************************************

c MOM2 CODE:

c     csu     = cosine of "u" grid point latitude
c     dxt     = longitudinal width of "t" grid box at the equator (cm)
c     amix    = am

c      DIFF_metric(i,k,j,n) = am3(j)*u(i,k,j,n) + am4(j,n)*dxmetr(i)
c     &                    *(u(i+1,k,j,3-n) - u(i-1,k,j,3-n))

c      am3(j)   =  amix*(1-tng(j)*tng(j))/(radius**2)
c      am4(j,1) = -amix*2*sine(j)/(radius*csu(j)*csu(j))
c      am4(j,2) = -am4(j,1)
     
c      tng(j)   = sine(j)/csu(j)
c      sine(j)  = sin(phi(j))
c      dxmetr(i) = 1 / (dxt(i) + dxt(i+1))

C***************************************************


      dxt(iLon)    = SNGL(xU(iLon)-xU(iLon-1))*Longitude_to_cm
      dxmetr(iLon) = 1. / (dxt(iLon) + dxt(iLon+1))

      csu(iLat)  = cos(SNGL(yU(iLat)) * Degrees_to_radians) 
      sine(iLat) = sin(SNGL(yU(iLat)) * Degrees_to_radians)
      tng(iLat)  = sine(iLat)/csu(iLat)
      am3(iLat)  =  am*(1-tng(iLat)*tng(iLat))/(RR_radius**2)
      am4(iLat)  = -am*2.*sine(iLat)/(RR_radius*csu(iLat)*csu(iLat))

      ! Get axis data

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags      (id, bad_flag,  bad_flag_result)
      CALL ef_get_coordinates    (id, ARG1, X_AXIS, 
     .                            arg_lo_ss(X_AXIS,ARG1),
     .                            arg_hi_ss(X_AXIS,ARG1), xU)
      CALL ef_get_coordinates    (id, ARG1, Y_AXIS, 
     .                            arg_lo_ss(Y_AXIS,ARG1),
     .                            arg_hi_ss(Y_AXIS,ARG1), YU)

      ! Check axis units:  bail out if not lat and lon.

      CALL ef_get_axis_info  (id, ARG1, ax_name, ax_units, 
     .                                backward, modulo, regular) 
      IF     ( ax_units(1) .NE. 'deg'       .AND.
     .         ax_units(1) .NE. 'degrees_E'       .AND.
     .         ax_units(1) .NE. 'longitude' .AND.
     .         ax_units(1) .NE. 'Longitude' .AND. 
     .         ax_units(1) .NE. 'LONGITUDE' ) THEN
        WRITE (6,*)'Longitude axis units =', ax_units(1) 
        !CALL ef_bail_out(id,'Longitude axis must be in degrees')
      ENDIF

      IF     ( ax_units(2) .NE. 'deg'       .AND.
     .         ax_units(2) .NE. 'degrees_N'       .AND.
     .         ax_units(2) .NE. 'latitude'  .AND.
     .         ax_units(2) .NE. 'Latitude'  .AND. 
     .         ax_units(2) .NE. 'LATITUDE' ) THEN
        WRITE (6,*)'Latitude axis units =', ax_units(2) 
        !CALL ef_bail_out(id,'Latitude axis must be in degrees')
      ENDIF

      l1 = arg_lo_ss(T_AXIS,ARG1) 
      l2 = arg_lo_ss(T_AXIS,ARG2) 
      DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         
         k1 = arg_lo_ss(Z_AXIS,ARG1)
         k2 = arg_lo_ss(Z_AXIS,ARG2)
         DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

            ilat = 1  
            j1 = arg_lo_ss(Y_AXIS,ARG1)
            j2 = arg_lo_ss(Y_AXIS,ARG2)
            DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
               
               a3 = am3(iLat)
               a4 = am4(iLat)

               iLon = 1
               i1 = arg_lo_ss(X_AXIS,ARG1)
               i2 = arg_lo_ss(X_AXIS,ARG2)
               DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

                  IF (arg_1(i1,  j1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_2(i2+1,j2,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2,  j2,k2,l2) .EQ. bad_flag(ARG2) )THEN
                     result(i,j,k,l) = bad_flag_result
                  ELSE
                     result(i,j,k,l) = ( 
     .                    a3*arg_1(i1,j1,k1,l1)
     .                  + a4*dxmetr(iLon)
     .                     *(arg_2(i2+1,j2,k2,l2)-
     .                       arg_2(i2-1,j2,k2,l2)) 
     .                              ) * sec_per_month
                  ENDIF

                  iLon = iLon + 1
                  i1 = i1 + arg_incr(X_AXIS,ARG1)
                  i2 = i2 + arg_incr(X_AXIS,ARG2)
               ENDDO

               iLat = iLat + 1
               j1 = j1 + arg_incr(Y_AXIS,ARG1)
               j2 = j2 + arg_incr(Y_AXIS,ARG2)
            ENDDO               

            k1 = k1 + arg_incr(Z_AXIS,ARG1)
            k2 = k2 + arg_incr(Z_AXIS,ARG2)
         ENDDO

         l1 = l1 + arg_incr(T_AXIS,ARG1)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
      ENDDO

      END

	SUBROUTINE CD_INIT_DSET ( dset, perm, tregular, use_strict,
     .				  ok_share_taxis, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Initialize a netCDF file so it behaves like a TMAP GT or TS data set

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 2/92
* 2/95 - added support for reverse-ordered coordinate axes
* *sh* 11/12/96 - changes to accomodate caching of DODS data 
* Linux Port - 6/97 *kob*  - use a cpp include for tmap_dset.parm

* argument definitions:
*    dset(input)   - pointer to TMAP data set
*    perm(input)   - array describing the permutation of axes in the dataset
*    tregular(input) - if true dont read full time axis - just 1st and last pts
*    use_strict(input) - if true do not allow micro-adjustment for monotonicity
*    status (output) - return status

* 11/97 *kob* - added a close on the cdfid for the netcdf file for
*               mc datasets only.  
* 4/98 *kob* - need to explicitely declare istat
* 5/98 *kob* - make sure that the sf_lunit is reset to file_not_open
*              when cdf file is closed - for mc datasets only
* V500 *sh* 3/99 - consolidated cd_scan_vars and cd_get_axes
*     *kob* 4/99 - increase size of temp_axnams to 64
*     *sh*  6/99 - added "perm" (permutation) argument
* V510 *sh* 3/00 - added tregular argument
*	    3/00 - convert to using dynamic grids and axes
* 4/03 *acm* - Use STR_SAME to compare strings
* V600 *acm* 6/05 - Attribute control-get information from linked-list struct
* V601 *acm* 6/06 - Fix bug 1459: when closing a stepfile that may be open,
*                   reset sf_lunit flag for cd_stepfile(dset), not for dset.
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V68  *acm* 1/12  added use_strict argument for ticket 1910: micro-adjusting
*                  on repeated coordinates in netCDF/OPeDNAP datasets
* V695+ *sh* 4/15  scan the dataset for auxiliary coordinate connections
* V698+ *sh* 11/15 add arg ok_share_taxis so DEFINE DATA/AGG/T can safely 
*		   modify T axis gleaned from first file in time series
* V698  *sh*  3/16 pass native_tax to CD_SCAN_AUX_VARS as lag_T ax of the FMRC

* include files
#include "gt_lib.parm"
	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'tmap_errors.parm'
        include 'xbuild_grids.cmn'
* add below *kob* 5/98
	include 'xstep_files.cmn_text'
	include 'xdset_info.cmn_text'
	external xdset_info_data
        include 'xdset_info.cd_equiv'

* argument declarations:
	LOGICAL tregular, use_strict, ok_share_taxis
	INTEGER	dset, perm(*), status

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
        INCLUDE 'netcdf.inc'
#include "netcdf_declareUnderscore.inc"


* local variable declarations:
      INTEGER STR_SAME, cdfid, remote_dods_id,istat, native_tax
* 4/99 *kob* increase temp_axnams
      CHARACTER*128 temp_axnams(nferdims,max_temp_grid)
      LOGICAL reversed(max_lines:line_ceiling), shifted

* open the netCDF data file and save global information
      CALL CD_OPEN_DSET ( dset, cdfid, remote_dods_id, status )
      IF ( status .NE. merr_ok ) GOTO 5990

* Save netcdf file attribs in linked list structure

      CALL CD_STORE_DSET_ATTRS ( dset, cdfid, status )
      IF ( status .NE. merr_ok ) GOTO 5990

* Use the dataset/variable/attribute data structure to load what was
* previously done in cd_open_dset.

      CALL CD_LOAD_DSET_ATTRS (dset, cdfid, status)

* get "TMAP" special parameters
      CALL CD_GET_TMAP_PARMS ( dset, cdfid, status )
      IF ( status .NE. merr_ok ) GOTO 5980

* read through the netCDF variables to read variable attributes
* and  load the TMAP axes
      CALL CD_SCAN_VARS( dset, cdfid, reversed, tregular, use_strict, status )
      IF ( status .NE. merr_ok ) GOTO 5900

* build grids for variables w/out parent grids and associate with variables
      CALL CD_GET_GENERIC_GRIDS (dset,cdfid,temp_axnams,reversed,
     .				 perm, native_tax, status)
      IF ( status .NE. merr_ok ) GOTO 5900

* build grids for variables with parent grids
      CALL CD_GET_PARENT_GRIDS (dset,temp_axnams,status)
      IF ( status .NE. merr_ok ) GOTO 5900

* associate the parent grids with data set variables      
      CALL CD_ASSOC_GRIDS (dset, reversed, temp_axnams, status)
      IF ( status .NE. merr_ok ) GOTO 5900

* replace name linkages between axes and grids with pointers.  Delete dups
      CALL CD_CLEAN_GRIDS ( dset, cdfid, temp_axnams,
     .			    ok_share_taxis, native_tax, status )
      IF ( status .NE. merr_ok ) GOTO 5900

      CALL CD_CONSISTENT_AXIS_ORIENT (dset, reversed, perm, status)
      IF ( status .NE. merr_ok ) GOTO 5900

* identify and set up auxiliary coordinate linkages
      CALL CD_SCAN_AUX_COORDS( dset, cdfid, native_tax, status )
      IF ( status .NE. merr_ok ) GOTO 5900

* set use counts and clean up temporary grids and axes
      CALL TM_GARB_COL_GRIDS (dset)

* summarize the special axes in the data set
      CALL CD_GET_TIME_AXIS( dset, t_dim, status )
      IF ( status .NE. merr_ok ) GOTO 5900  ! *sh* ok after TM_GARB_COL_GRIDS?

* if using a DODS cache then create the illusion of remote access
      IF (remote_dods_id .NE. -1) THEN
         CALL CD_DODS_CONTROL( dset, cdfid, remote_dods_id, status )
         IF ( status .NE. merr_ok ) GOTO 5900! *sh* ok after TM_GARB_COL_GRIDS?
      ENDIF

! for multiple files ... maybe
! *kob* 11/97 - close cdf files which are a part of a multi-file netcdf set
!* close the netCDF file
! 5/98 *kob* - reset sf_lunit as well
! 10/06 *acm*  bug 1459 sf_lunit of the correct stepfile...
! 11/06 *acm   no... It turns out that sf_lunit is set in cd_load_dset_attrs 
!              only if the dataset is NOT a mc dataset; it's a "place-holder" 
!              setting for single-file datasets. sf_lunit should NOT be reset
!              here for mc datasets at all.

      IF (STR_SAME(ds_type(dset), '  MC') .EQ. 0) THEN
#ifdef usingDODSf2cUnderscore
        istat = NF_CLOSE_( cdfid )
#else
        istat = NF_CLOSE( cdfid )
#endif
c        sf_lunit(dset) = file_not_open
c        sf_lunit( cd_stepfile(dset) ) = file_not_open
      ENDIF
* successful completion
      status = merr_ok
      RETURN

* error exit
 5900 CALL CD_ABORT_GRIDS
 5980 CONTINUE
#ifdef usingDODSf2cUnderscore
      IF (remote_dods_id .NE. 0) istat = NF_CLOSE_( remote_dods_id )
#else
      IF (remote_dods_id .NE. 0) istat = NF_CLOSE( remote_dods_id )
#endif
 5990 RETURN
      END

	SUBROUTINE IS_SUBSPAN_FILL(  *, *, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* fill in the phantom "void" point that fills the gap between the length N
* of a native subspan modulo axis, and the virtual length N+1

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V541: *sh* 2/02
* V56: *acm* 4/04  If data was read using strides, then the axis having
*                  a delta is ok.

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'
	include	'xtext_info.cmn'

* calling argument declarations:
	INTEGER	status
* normal return is for error conditions
* exit #1 is to request another grid ( stack has been pushed )
* exit #2 is to signal completion of the activity at this stack level

*   ... interpretation stack setup at the time this is called ...
*	stack level		stack contents
*	isp+1	<--	level of last activity ( component just computed )
*	 isp	<--	current stack level (for moduloing )

* internal variable declarations:
	INTEGER CAXIS_MODLEN, MGRID_SIZE_DELTA,
     .		com_mr, res_mr, com_cx, res_cx,	com_isp, res_isp,
     .		npts, idim
	LOGICAL	TM_ITS_CDF, done_by_strides
        CHARACTER dtype*4

* --- end of introductory code ---

* initialize
	res_isp    = isp
	com_isp    = isp + 1
	res_mr     = is_mr( res_isp )
	com_mr     = is_mr( com_isp )
	res_cx     = is_cx( res_isp )
	com_cx     = is_cx( com_isp )
	idim       = is_axis( res_isp )
	npts	   = CAXIS_MODLEN( idim, com_cx )

* Check if a stride was specified on the axis.
* This is ok if data was read with strides

        done_by_strides = cx_category(res_cx) .EQ. cat_file_var 
     .    .AND. TM_ITS_CDF(cx_data_set(res_cx), dtype )
     .	  .AND. cx_delta(idim,res_cx) .NE. unspecified_val8

	IF (.NOT. done_by_strides .AND. 
     .      cx_delta(idim,res_cx) .NE. unspecified_val8) THEN
	  CALL ERRMSG( ferr_internal, status,
     .		      'IS_SUBSPAN_FILL: delta found on axis', *5900) 
	ENDIF

* diagnostic mode output: " doing subspan void VAR_NAME[x=lo:hi,D=#]"
	IF ( mode_diagnostic ) 	CALL DIAG_OP
     .		( 'doing', isact_class_subspan_fill, com_cx, idim )


* initialize the result
* 11/95 complete the result context in case it has some unspecified limits
* (note: this never occurs on file variables because INTERP_STACK completes
*	 the context to make memory caching more efficient)
	CALL RECONCILE_COM_DST_CX( com_cx, res_cx, idim )

* create context and mem. res. space if this is the first component recieved
	CALL CREATE_MEM_VAR( res_cx, res_mr, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	is_mr( res_isp ) = res_mr

	IF ( mr_type(res_mr) .EQ. ptype_string ) THEN
	   CALL INIT_C_STRING_ARRAY( MGRID_SIZE_DELTA(res_mr),
     .                               memry(res_mr)%ptr,
     .                               mr_c_pointer(res_mr)      )
	   CALL SET_NULL_C_STRING_ARRAY(mr_c_pointer(res_mr),
     .                                  MGRID_SIZE_DELTA(res_mr) )

	ENDIF

* 11/95: if there might be voids in the result pre-fill with missing data flags
* to-do: could make this more efficient and fill only the "N+1" virtual point.
	IF ( mr_type(res_mr) .EQ. ptype_float  ) CALL FILL_MEMORY
     .				( res_mr, mr_bad_data(res_mr) )

* Copy the component data into the result (unless the silly user
*  requested the void point, alone
	IF ( cx_lo_ss(res_cx, idim) .LT. npts ) CALL COPY_INTO
     .		       ( memry(com_mr)%ptr, com_mr, com_cx,
     .			 memry(res_mr)%ptr ,res_mr )

* Successful completion of modulo operation
	CALL MR_NOT_IN_USE( com_mr )	! remove memory protection on component
!	IF (mr_delta(idim,com_mr).NE.unspecified_val8)
!     .		 CALL DELETE_VARIABLE( com_mr )  ! invalid since using mr_delta
	cx_stack_ptr = cx_stack_ptr - 1 ! pop com_cx  from context stack
	status = ferr_ok
	RETURN 2

* error exits
 5000	RETURN
 5900	CALL MR_NOT_IN_USE( com_mr )
	GOTO 5000
	END	

*
* convolvel.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
** Ansley Manke
* Feb 1999
*
* This external function convolves the component grid, com, with the weight 
* function, wt  along the L axis (see Ferret routine CONVOLVE)
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE convolvel_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      CHARACTER*100 fcn_desc
      WRITE (fcn_desc, 10)
   10 FORMAT ('Convolve L component of variable with weight function')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 2)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)

      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'COM')
      CALL ef_set_arg_desc(id, arg, 
     .  'Variable in T (and perhaps X,Y,Z) to convolve')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'WEIGHT')
      CALL ef_set_arg_desc(id, arg, 'Weight function')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
	SUBROUTINE convolvel_compute (id, arg_1, arg_2, result )

*
*
*  From FERRET subroutine CONVOLVE, for the i-axis.
*
* convolve the component grid, com, with the weight function, wt
* along axis idim
* note: the component context may not be of adequate size for the full
*	calculation.  Missing data flags will be inserted where computation is
*	impossible
* also: when bad data points are encountered in the component data all
*	result data depending on it are flagged as bad, too


      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id
      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .     mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .     mem2lot:mem2hit)
     .     
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .      memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      REAL comp, sum, weight
      INTEGER i, j, k, l
      INTEGER xlen, ylen, zlen, tlen, ll
      INTEGER i1, j1, k1, l1
      INTEGER i2, j2, k2, l2
      INTEGER wlen, hlen

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)
      
* CONVOLVE ALONG T AXIS (arg_1) using weights (arg_2)

* Half the weighting function; weights from -hlen to hlen.

      xlen = (arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1) 
      ylen = (arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) + 1) 
      zlen = (arg_hi_ss(Z_AXIS,ARG2) - arg_lo_ss(Z_AXIS,ARG2) + 1) 
      tlen = (arg_hi_ss(T_AXIS,ARG2) - arg_lo_ss(T_AXIS,ARG2) + 1) 

      wlen = max(xlen, ylen, zlen, tlen)
      IF  (MOD(wlen,2) .EQ. 0) wlen = wlen + 1
      hlen = wlen/ 2

      i1 = arg_lo_ss(X_AXIS,ARG1)
      DO 500 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 400 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
       
               l1 = arg_lo_ss(T_AXIS,ARG1)
               DO 200 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS) 

                  sum = 0.0
                  i2 = arg_lo_ss(X_AXIS,ARG2)
                  j2 = arg_lo_ss(Y_AXIS,ARG2)
                  k2 = arg_lo_ss(Z_AXIS,ARG2)
                  l2 = arg_lo_ss(T_AXIS,ARG2)

                  DO 100 ll = -hlen, hlen

                     IF (l1+ll .LT. arg_lo_ss(T_AXIS,ARG1)  .OR.
     .                   l1+ll .GT. arg_hi_ss(T_AXIS,ARG1) ) THEN
                        result(i,j,k,l) = bad_flag_result
                        GOTO 190

                     ELSE
                        comp = arg_1(i1,j1,k1,l1+ll)
                        IF (i2 .LT. arg_lo_ss(X_AXIS,ARG2)  .OR.
     .                      i2 .GT. arg_hi_ss(X_AXIS,ARG2)  .OR.
     .                      j2 .LT. arg_lo_ss(Y_AXIS,ARG2)  .OR.
     .                      j2 .GT. arg_hi_ss(X_AXIS,ARG2)  .OR.
     .                      k2 .LT. arg_lo_ss(Z_AXIS,ARG2)  .OR.
     .                      k2 .GT. arg_hi_ss(Z_AXIS,ARG2)  .OR.
     .                      l2 .LT. arg_lo_ss(T_AXIS,ARG2)  .OR.
     .                      l2 .GT. arg_hi_ss(T_AXIS,ARG2)) THEN
                               weight = 0.
                        ELSE
                           weight = arg_2(i2,j2,k2,l2)
                        ENDIF

                        IF ( comp .EQ. bad_flag(ARG1)) THEN
                           result(i,j,k,l) = bad_flag_result
                           GOTO 190
                        ELSE
                           sum = sum + comp* weight
                        ENDIF
                     ENDIF

                     i2 = i2 + arg_incr(X_AXIS,ARG2)
                     j2 = j2 + arg_incr(Y_AXIS,ARG2)
                     k2 = k2 + arg_incr(Z_AXIS,ARG2)
                     l2 = l2 + arg_incr(T_AXIS,ARG2)

 100                 CONTINUE
                     result(i,j,k,l) = sum

 190                 l1 = l1 + arg_incr(T_AXIS,ARG1)
 200              CONTINUE

                  k1 = k1 + arg_incr(Z_AXIS,ARG1)
 300           CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 400     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
 500  CONTINUE

      RETURN
      END	

	SUBROUTINE TM_FTOC_STRNG ( fstrng, cstrng, clen )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* convert a FORTRAN-style character string to a null-terminated Hollerith
* suitable for passing to a c routine
* normally the c string should be at least 1 byte longer than the FORTRAN
*    string to accomodate the null terminator
* note:  if the FORTRAN string contains terminating blanks they WILL be passed
*        to the c string.  Pass the FORTRAN string with its exact length if
*        this is not desired.
*   e.g. CALL TM_FTOC_STRNG ( fstrng(:flen), cstrng, clen )

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for DECstation computer under Ultrix operating system
*
* rev 0.0 -   5/6/91
*  Sun Port 1/30/92 -kob-  added ifdef sun because uses BYTE where DECstation uses
*                          INTEGER*1
*calling arguments:
* fstrng - CHARACTER string (passed by descriptor)
* cstrng - BYTE (INTEREG*1) string (passed by pointer)
* clen   - length of passed Hollerith array

#ifdef unix
* calling argument declarations:
        INTEGER clen
        CHARACTER*(*) fstrng

#ifdef sun
        BYTE      cstrng(clen)
#else
	INTEGER*1 cstrng(clen)
#endif

* internal variable declarations:
	INTEGER	i, flen

* length of input string
        flen = LEN(fstrng)

* copy from CHARACTER to null-terminated Hollerith
        IF ( clen .GT. flen ) THEN
           DO 100 i = 1, flen
 100       cstrng(i) = ICHAR( fstrng(i:i) )
           cstrng(flen+1) = 0

        ELSE
* ... may be prematurely truncated ...
           DO 200 i = 1, clen-1
 200       cstrng(i) = ICHAR( fstrng(i:i) )
           cstrng(clen) = 0

        ENDIF

	RETURN
#else
        STOP 'TM_FTOC_STRNG is for Unix systems, only'
#endif
	END

	DOUBLE PRECISION FUNCTION TM_WORLD ( isubscript, grid, idim,
     .					     where_in_box )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* convert a subscript value on a grid into a "world" coordinate
* position within the grid box corresponding to the given subscript is
* determined by the value where_in_box

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* revision 0.00 - 04/16/86
* revision 1.00 - 03/10/87 - line data in COMMON/*VARIABLES*/
* revision 1.10 - 03/23/87 - added new TMAP library: time axes, file var. names
* revision 1.20 - 02/18/88 - incorporated "regular" axes; trapped "unspecified"
*			     subscripts
* revision 1.30 - 08/09/88 - mod to reflect storage of box coords not sizes (mv)
* revision 1.31 - 11/29/88 - munknown, mnormal changed to mpsnorm, mpsunkn (mv)
* revision 2.00 - 12/12/88 - changed to reflect storage of box locations instead
*			     of box sizes for irregular axis... (mv)
* revision 2.10 - 01/25/89 - Added ability to handle regular modulo axis
* revision 2.11 - 01/07/91 - added "*" to comment above for RISC compiler
* 10/16/95 - for Ferret V4.20 - added recursive response for child axes of
*			irregularly-spaced axes
* *kob* 10/96   - Linux port.  Linux didn't like tabs between "include"
*                 and what was being included.  removed them
* *sh* 9/99 - allow input subscript to be unspecified_int4 as long as the
*		underlying axis is modulo
* V530 *sh* 10/00 - guts extracted into TM_WORLD_AX
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files
* v71  12/16 *acm* Ticket 2158: working with true monthly time axes.
*
* If this is a 'true-month' axis, TM_WORLD_AX will convert the result 
* to the correct true month length. Return the result in units of days.

* Include files
#include "gt_lib.parm"
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data

* calling argument declarations:
	INTEGER	isubscript, grid, idim, where_in_box

* internal variable declarations:
	LOGICAL ITSA_TRUEMONTH_AXIS, true_month
	INTEGER	iaxis
	REAL*8	TM_WORLD_AX, timefac

* initialize
	iaxis    = grid_line( idim, grid )
	IF ( iaxis .EQ. mpsnorm
     .	.OR. iaxis .EQ. mpsunkn
     .	.OR. (isubscript .EQ. unspecified_int4 
     .	      .AND. .NOT.line_modulo(iaxis) )     ) THEN
	  TM_WORLD = unspecified_val8
	  RETURN
	ENDIF

	TM_WORLD = TM_WORLD_AX ( isubscript, iaxis, where_in_box )

	true_month = ITSA_TRUEMONTH_AXIS(iaxis)
	IF (true_month) THEN
 
* Convert the time coordinate on a true-month axis to days.
	   CALL TM_MONTH_TIME_FACTOR (grid, true_month, timefac)
	   TM_WORLD = TM_WORLD* timefac

	ENDIF

	RETURN
	END

	SUBROUTINE DSG_OBS_BY_FEATURE_VAR (
     .              dset, cx, nfeatures, nobs_total, vals)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - SDIG program
* 4/24/2018

* Define a variable of length nobs_total with values of a feature variable,
* expanding feature-var to an obs axis. Purpose e.g. to do a trajectory 
* plot colored by feature id.  
* On input "var" contains the feature-length variable, on output it has those
* values expanded onto nobs-length variables


* programmer - Ansley Manke  
* NOAA/PMEL, Seattle, WA - Science Data Integration Group
*
* V7.4+ *acm*  4/2018

	include 'tmap_dims.parm'
	include 'xdset_info.cmn_text'
	include 'xdyn_linemem.cmn_text'
	include 'xtm_grid.cmn_text'

* calling argument declarations:
	INTEGER	dset, cx, nfeatures, nobs_total, status
	REAl	vals(*)

* internal variable declarations:
	INTEGER i, irow_l, irow_f, ifeature, iobs, nobs, row_size_lm
	REAL	GET_LINE_COORD, fnum

	row_size_lm = dsg_loaded_lm(dsg_row_size_var(dset))

* Put the feature-var values into some dummy storage. line_0 

	CALL GET_LINE_DYNMEM (nfeatures, line_0, status)

	DO ifeature = 1, nfeatures
	    CALL PUT_LINE_COORD(linemem(line_0)%ptr, ifeature, vals(ifeature))
	ENDDO

* create variable that's constant feature-var for each feature

	irow_f = 1
	irow_l = 0
	DO ifeature = 1, nfeatures 

* ... get observation index range this feature

	   nobs = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
	   irow_l = irow_f+nobs-1

	   fnum = GET_LINE_COORD (linemem(line_0)%ptr, ifeature)
	   DO iobs = irow_f, irow_l
	      vals(iobs) = fnum
	   ENDDO
	   irow_f = irow_l + 1
	ENDDO

*  deallocate the extra n storage used for feature variable.
	CALL FREE_LINE_DYNMEM(line_0)

	RETURN

	END

	SUBROUTINE GET_DSG_MASK_TITLE (dset, title, has_mask, slen)

	include 'errmsg.parm'

	LOGICAL has_mask
	INTEGER dset, slen
	CHARACTER*(*) title
	
	LOGICAL NC_GET_ATTRIB_STRING
	INTEGER varid, attid, maxlen, attoutflag, status
	CHARACTER v*1, attname*32

* Initialize 

	has_mask = .FALSE.
	slen = 0

	attname = '__feature_mask_'
	varid = 0
	v = '.'

	CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status) 
	IF (attid .LE. 0 .OR. status .NE. ferr_ok) GOTO 5010

	maxlen = 128
	has_mask = NC_GET_ATTRIB_STRING ( dset, varid, attname,
     .                                   .FALSE., v, maxlen,
     .                                   slen, attoutflag, title)

 5000	RETURN
 5010	slen = 0

	END

	SUBROUTINE SET_VP_SYMBOLS( scale, vp_size, xfrac, yfrac,
     .			           xspc_lo, yspc_lo, xspc_hi, yspc_hi,
     .                             xov,  yov,  xcv,  ycv)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Set additional viewport symbols. Here is what happens with the scaling
* 11/30/04 change names of margin symbols.
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus.


ccc    DEFINE VIEWPORT/XLIM=xlo:xyi/YLIM=ylo:yhi[/TEXT=n/ my_view
ccc
ccc     vp_size(ivp) = value given by DEF VIEW/TEXT=      ! See xeq_define.F 
ccc                    or, SQRT( (xhi-xlo)) * (yhi-ylo) )
ccc
ccc	scale = 1.0 / SQRT( ABS(vp_size(vp_num)) )        ! See set_viewport.F
ccc                                                       ! if /TEXT=1, vp_size=1, scale=1
ccc
ccc     xfrac = scale*(xhi-xlo)
ccc     yfrac = scale*(yhi-ylo)

ccc	xsize = xfrac*width                               ! These are the viewport lengths 
ccc	ysize = yfrac*height                              ! reported by VP_WIDTH, VP_HEIGHT

* 11/16/2004 *acm*  from set_ax_sizes

        IMPLICIT NONE
	include 'plot_setup.parm'
c        include 'xplot_setup.cmn'      ! 10/91 for saved_ppl_yax
c        include 'PLT.INC'

* calling argument declarations:
        REAL*4 vp_size
        REAL*4 scale, xfrac, yfrac,
     .       xspc_lo, yspc_lo, xspc_hi, yspc_hi,
     .       xov,  yov,  xcv,  ycv

* internal variable declarations:
	INTEGER slen
	CHARACTER TM_FMT_SNGL*48, buff*24

	buff = TM_FMT_SNGL(scale,-3,8,slen) 
	CALL PPLCMD ( from, line, 0, 'SET VP_SCALE '//buff(1:slen), 1, 1 )
 
c	buff = TM_FMT_SNGL(vp_size,-3,8,slen) 
c	CALL PPLCMD ( from, line, 0, 'SET VP_SIZE '//buff(1:slen), 1, 1 )

c	buff = TM_FMT_SNGL(xfrac,-3,8,slen) 
c	CALL PPLCMD ( from, line, 0, 'SET VP_XSC '//buff(1:slen), 1, 1 )
	
c	buff = TM_FMT_SNGL(yfrac,-3,8,slen) 
c	CALL PPLCMD ( from, line, 0, 'SET VP_YSC '//buff(1:slen), 1, 1 )
        
c	buff = TM_FMT_SNGL(xspc_lo,-3,8,slen) 
c	CALL PPLCMD ( from, line, 0, 'SET VP_XORG '//buff(1:slen), 1, 1 )
        
	buff = TM_FMT_SNGL(xspc_hi,-3,8,slen) 
	CALL PPLCMD ( from, line, 0, 'SET VP_RT_MARGIN '//buff(1:slen), 1, 1 )
        
c	buff = TM_FMT_SNGL(yspc_lo,-3,8,slen) 
c	CALL PPLCMD ( from, line, 0, 'SET VP_YORG '//buff(1:slen), 1, 1 )
        
	buff = TM_FMT_SNGL(yspc_hi,-3,8,slen) 
	CALL PPLCMD ( from, line, 0, 'SET VP_TOP_MARGIN '//buff(1:slen), 1, 1 )

	buff = TM_FMT_SNGL(xov,-3,8,slen) 
	CALL PPLCMD ( from, line, 0, 'SET VP_XLO '//buff(1:slen), 1, 1 )

	buff = TM_FMT_SNGL(xcv,-3,8,slen) 
	CALL PPLCMD ( from, line, 0, 'SET VP_XHI '//buff(1:slen), 1, 1 )

	buff = TM_FMT_SNGL(yov,-3,8,slen) 
	CALL PPLCMD ( from, line, 0, 'SET VP_YLO '//buff(1:slen), 1, 1 )

	buff = TM_FMT_SNGL(ycv,-3,8,slen) 
	CALL PPLCMD ( from, line, 0, 'SET VP_YHI '//buff(1:slen), 1, 1 )

	RETURN
	END

	SUBROUTINE CD_CLOSE_SET ( cdfid, status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Close a netCDF file 

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 6/92
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files
* V7.21 8/17 *kms* ignore close errors - assume already closed

* argument definitions:
*       cdfid   - returned pointer to open CDF file
*	status	- return status

* argument declarations:
	INTEGER	      cdfid, status

* include files
        include 'netcdf.inc'
        include 'tmap_errors.parm'

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

* local variable declarations:
      INTEGER cdfstat

* close the netCDF file
#ifdef usingDODSf2cUnderscore
        cdfstat = NF_CLOSE_( cdfid )
#else
        cdfstat = NF_CLOSE( cdfid )
#endif
C assume any errors are because the file is already closed,
C either from an error or from improper marking when previously closed
C       IF ( cdfstat .NE. NF_NOERR ) GOTO 5100

* successful completion
        status = merr_ok
        RETURN

* error exit
C 5000   RETURN
C 5100   CALL TM_ERRMSG(pcdferr+pcdferrmax,
C     .         status, 'CD_CLOSE_SET', cdfid, -999,
C     .         no_errstring, no_errstring, *5000 )
	END

	SUBROUTINE XEQ_LIST

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute the LIST command

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 4/16/86
* revision 0.1 - 1/5/87	 - changes to accomodate multiple mrs in expression
* revision 0.2 - 2/25/87 - changes for INTERPRETATION STACK
* revision 0.3 - 8/29/87 - changes for unformatted LIST: OPEN file in this rout.
* revision 0.4 - 9/9/87  - added DSF_LIST call (Denbo's BIBO output)
* revision 0.5 - 9/16/87 - added want_cmnd_data to CALL GET_CMND_DATA
* revision 0.6 - 9/26/87 - added AUTO filename option and headers automatically
*			   for /APPEND when file doesn't exist
* revision 0.7 - 10/5/87 - revamped SET LIST logicals
* revision 0.8 - 3/7/88  - added list_TMAP
* revision 0.9 - 6/24/88 - use LIST/FILE[/APPEND] to direct output to file
*			 - allow multiple variables in a /FORMAT=GT list
* revision 1.0 - 2/22/89 - check for interrupts after each variable
* V200:  5/18/89 - minor changes for 4D-symmetrical
*		 - context passed in is_cx instead of is_big_cx
*		 - list_unformatted and list_format_given are cancelled at end
*	10/16/89 - set up adjustable array limits with NON_ARRAY_SUBSC
*		 - permutable listing order
*	12/19/89 - corrected bug in LIST/FORM=TMAP
*	 3/20/90 - eliminated forced heading for /APPEND when file doesn't exist
*	 4/27/90 - unformatted output types without a /FILE generate an error
*	 5/15/90 - DSF (BIBO) output neede to call AUTO_FILENAME, too
*	  7/2/90 - allow multiple variables per line, numerous style changes
*		 - interrupt checking inside list routines
*	 7/31/90 - added EPIC format and MULTI lists use work arrays
* Unix/RISC port - changed OPEN syntax for Unix filesystem
*                - changed /FILE= to preserve lower case
* SUN port 3/92 *sh* - unformatted record length in bytes
*                    - discovered "perm" is unitialized if not specified
* V230:  6/9/92 - added netCDF output including changes to the use of
*                 XPROG_STATE variables dealing w/ format type
*                 SET LIST is now effective only for the NEXT list
*       7/27/92 - don't remove protections from "command data" until AFTER
*                 listing because permutation requires memory management
*        8/6/92 - CDF was using is_mr instead of mr_perm (minimum reqsted reg.)
*           and - error during GET_PROT_CMND_DATA left /FORMAT= set
*      10/14/92 - bug fix: wrong GOTO following EQUAL_FORMAT error
* V300:    5/93 - error message bug: filename truncated
*	  10/93 - ALPHA port - explicit error message if file exists because
*		  OSF/1 error message is "Bad magic number"
* V314:	8/24/94 *kob* IBM port - RECORDTYPE not allowed in open statments under
*				 AIX fortran.  Add ifdef 1.
*	11/3/94 *sh* IBM port - ACCESS=APPEND isn't allowed but STATUS=OLD
*				defaults to this behavior
*	11/5/94 *sh* IBM port - disable GT format output on IBM.  Unable to
*			append on unformatted file (not checked thoroughly)
* V320:  5/94 - array "memory" as a calling argument
*	10/94 - added code for /HEADING=enhanced
*	11/94 - trap LIST/FORMAT without /FILE in GUI mode as an error
*	11/94 - added SAVE/HEADING="title"
*	12/94 - added /FORMAT=stream
*    12/29/94 - use SPLIT_LIST to redirect tty output for GUI
*     1/17/95 - increased output filename length from 100 characters to 200
*     1/25/95 - added /TITLE= and /HEADING=enhanced (and unenhanced) for netCDF
* V420   9/95 - added /FORMAT=comma and tab delimited
* Linux Port 5/97 *kob* - had to add ifdef F90_OPEN_FILE_APPEND because f90
*			  uses "POSITION" instead of "ACCESS" to specify 
*			  opening a file for append.  I also had to create a
*			  new variable called "fposition", which stores the 
*			  open position of the file, either "append" or "asis".
*			  this had to be done in order for a new file to have 
*			  a valid "position" for f90 opens.
* V430	 7/96 - *kob* reclen_in_bytes not appropriate for sgi..added 
*		      "ifndef sgi" to prevent 1 being set
* V450	11/96 - added LIST/CLOBBER
*		added pcdf_mode_cache for DODS caching
*       7/98 *js* Changed size of perm to 5 to support parsing of 
*                 xyztv permutations (unsupported for now)
*      12/98 *js* Disable listing to files if in secure mode
* V500  2/99  - *kob* added LIST/QUIET
*	5/99 - *sh- added arguments to EQUAL_PERMUTE
* V530  8/00 *sh* - bug fix of /CLOBBER with /FORM=STREAM
*		  - set reclen correctly for string output
*       *sh* 9/00  - added initial data type support in get_cmnd_data 
*	*sh* 11/00 - fixed bug: permutation for all vars written was determined
*		     from context of first var, only
*       *sh8 1/01  - bug fix to 11/00 bug fix!
* v542  *kob* 10/02 - add F90_OPEN_FILE_CLOBBER option to make sure that the F90 
*                     OPEN POSITION directive is not blank when opening an 
*                     existing file for rewrite.  This causes an F90 OPEN error
* V554 *acm* 9/03  Add output in /DODS binary format for list/format=DODS, 
*                  see the flag do_dods
* V581 *acm* 3/05  Increase length of string buff so that title can be longer.
* V600: *acm* 8/05 - make multi-variable tab and comma-delimited listings of
*                    multiple variables like free-format listings, rather than 
*                    like LIST/SINGLY. (bug 1273)
* V600  *acm* 4/06 change how mr_perm is passed to LIST_CMND_DATA,due to 64-bit problems  
* V602  *acm* 1/07 Use risc_buff rather than the local variable buff for reading inputs 
*                  and for the title - fixing bug 1482
* V604  *acm* 7/07 Dataset names have been increased to 1024, but on output this runs into
*                  conflicts with Fortran INQUIRE and OPEN calls. Disallow output names
*                  longer than 256 characters.
* V606  8/07 *acm* Send informational and error messages that are returned from 
*                  commands via SPLIT_LIST to std error rather than std out.
* V62  *acm*  2/09 - Fix bug 1634: allow SAVE/KEEP_AXISNAMES so that child axis names
*                    arent written. They can get too long for OPeNDAP library calls
* V62  *acm*  2/09 - Fix bug 1644: Dataset title was stored in risc_buff but if mode diag
*                    is turned on, the string was overwritten. Go back to a local buffer
*                    to store the title
* V6.5  *acm* 1/10 new qualifiers for LIST netCDF4: NCFORMAT,
*                  XCHUNK,YCHUNK,ZCHUNK,TCHUNK,COMPRESSION,SHUFFLE,ENDIAN
* V6.7  *acm* 3/11 Remove warning deprecating /RIGID. There are still valid reasons
*                  to want to set the time axis to NOT be the record axis.
* V68  *acm*  1/12 ifdef double_p for double-precision ferret.
* V683 *acm*  8/12 add new SAVE/OUTTYPE=  
* V685 *acm*  6/13 new qualifier SAVE/NOBOUNDS
* V685 *acm*  6/13 Dont add SAVE/NOCOORDS
* V690 *sh*   1/14 Automated 3-argument auxiliary (curvilinear) plotting
* V693+ 11/14 *sh* renaming 'sigma' as 'layerz' throughout
* V702 1/17 *sh* for trac enhancement #2369 -- dynamic memory management 
* V710 *acm*  1/17 Ticket 1480: When writing to netCDF, check whether the region on 
*                  modulo axes is just one grid-cell longer than the axis length,e.g. 
*                  if they gave a region of /X=0:360.  If so, write one grid-cell less 
*                  data so the axis can still be a valid modulo axis.
* v720 2/2017 *acm* Ticket 2513. If /RIGID write edges but do not write bounds or 
*                  bounds attribute.

	include 'tmap_dims.parm'
        include 'tmap_errors.parm'
	include	'ferret.parm'
	include	'slash.parm'
	include 'errmsg.parm'
	include 'interp_stack.parm'
        include 'gfdl_vms.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xprog_state.cmn'
	include 'xinterrupt.cmn'
        include 'xrisc.cmn'

* calling argument declarations:

* local variable declarations
	LOGICAL		is_secure
	LOGICAL		ITS_AUTO_CURVI,
     .			normal_file, fexist, heading, list_to_tty, do_multi,
     .			do_epic, do_cdf, do_unform, do_stream,
     .			do_comma_del, do_tab_del, do_dods, do_xml,
     .			permute, all_at_once, list_at_eof, head_enh,
     .			clobber, quiet, have_outtype, curvi_axes(nferdims), 
     .			do_shrink

	INTEGER		TM_LENSTR1, CX_DIM_LEN, STR_CASE_BLIND_COMPARE,
     .                  STR_UPCASE, GET_MAX_STRING_LEN,
     .			status, mr, cx, inext, ilist, wsize, vax_code,
     .			rlen, flen, reclen, i, cx1, qfile, idim,
     .			ndim, perm(7), mr_perm(max_intrp),
     .                  npermuted, recsofar, do_stream_phase, nvars,
     .                  edges_flag, keepax_flag, nn, slen, do_bounds,
     .			my_mr(max_intrp), my_cx(max_intrp), frame_bottom,
     .			nvars2list
	INTEGER*8	i8_size

	CHARACTER	AUTO_FILENAME*2048, filename*2048, raw_name*2048, 
     .			buff*2048, fstatus*8, faccess*12, fformatted*12,
     .			cdf_recax*1, fposition*12, out_type*6

* local parameter declarations
* *kob* 2/99 - add entries for quiet qualifier 
	INTEGER		slash_file, slash_append, slash_permute, slash_format,
     .			slash_seqntl, slash_rigid, slash_clobber, 
     .                  slash_quiet
	PARAMETER     (	slash_seqntl  = 15+1,
     .			slash_file    = 16+1,
     .			slash_append  = 17+1,
     .			slash_permute = 18+1,
     .			slash_format  = 19+1,
     .			slash_rigid   = 22+1,
     .			slash_clobber = 35+1,
     .                  slash_quiet   = 36+1)

* formatting information given ?
	i = qual_given( slash_format )
	IF ( i .GT. 0 ) THEN
	   CALL EQUAL_FORMAT( cmnd_buff(qual_start(i):qual_end(i)), status )
	   IF ( status .NE. ferr_ok ) GOTO 4999
	ENDIF

* did the user request to clobber previous output file versions
	clobber = qual_given( slash_clobber ) .GT. 0

* *kob* 2/99 - did the user request a quiet listing
	quiet = qual_given( slash_quiet ) .GT. 0

* special trap to create DODS cache version of NetCDF file
        IF ( list_fmt_type .EQ. plist_cdf_cache ) THEN
	   list_fmt_type = plist_default ! restore for next command
	   num_uvars_in_cmnd = 0	 ! wipe out past memory of expressions
	   CALL CDF_PREP_CACHE( cx_last, filename, nvars,
     .			   is_mr, is_cx, clobber, status )
	   IF ( status .NE. ferr_ok ) RETURN
           edges_flag = 0
           do_bounds = 0
	   keepax_flag = 0
	   out_type = "DFLT"
	   CALL CDF_LIST(  filename( 1:TM_LENSTR1(filename)), 
     .                    .FALSE., 'N', nvars, is_mr, is_cx,
     .			   ' ', .TRUE., pcdf_mode_cache, clobber, 
     .                    edges_flag, do_bounds, keepax_flag, out_type,  
     .                    status )
	   CALL DELETE_MRS_IN_PROGRESS		! remove temporary vars
	   RETURN
	ENDIF

* initialize
	list_at_eof  = list_append .OR. qual_given( slash_append ) .GT. 0
	do_epic	     = list_fmt_type .EQ. plist_epic
	do_cdf	     = list_fmt_type .EQ. plist_cdf
        do_unform    = list_fmt_type .EQ. plist_unformatted
        do_dods      = list_fmt_type .EQ. plist_dods
        do_stream    = list_fmt_type .EQ. plist_stream
        do_tab_del   = list_fmt_type .EQ. plist_tab_del
        do_comma_del = list_fmt_type .EQ. plist_comma_del
        do_stream_phase = 0		! for multi-variable stream
        do_xml       = list_fmt_type .EQ. plist_xml
	list_to_tty  = qual_given( slash_file ) .EQ. 0
     .            .AND. .NOT.(do_epic.OR.do_unform
     .			  .OR.do_cdf.OR.do_stream .OR. do_dods)
	normal_file  = .NOT.( list_to_tty .OR. do_epic .OR. do_cdf
     .			 .OR. do_stream .OR. do_dods) 
	permute      = qual_given( slash_permute ) .GT. 0
        npermuted    = 0
	recsofar     = 0
	
* Verboten to list to file if in secure mode
	IF (is_secure() .AND. .NOT. list_to_tty) then
	   call SPLIT_LIST(pttmode_help, err_lun,
     1	        'This command is not allowed.', 0)
	   return
	ENDIF

* in GUI mode you cannot use LIST/FORMAT without /FILE
	IF ( mode_gui.AND.list_format_given.AND.list_to_tty ) GOTO 5070

	IF ( do_stream .AND. list_at_eof ) CALL ERRMSG
     .		( ferr_not_implemented, status,
     .			'cannot /APPEND with STREAM format', *4999)

* /RIGID for netCDF ?  
* As of 2/2017, write bounds if /RIGID and irregular, rather than edges,
* unless they say /EDGES. So bounds are now treated in the default way when
* /RIGID is given.

        i = qual_given( slash_rigid )
        IF ( i .GT. 0 ) THEN
           cdf_recax = 'N'   ! no record axis
        ELSE
           cdf_recax = 'T'   ! "T" is record axis
        ENDIF

* /KEEP_AXISNAMES for netCDF ?
        i = slash_list_keepax
        i = qual_given( slash_list_keepax )
	keepax_flag = 0
        IF ( i .GT. 0 ) THEN
           keepax_flag = 1
        ENDIF

* /EDGES for netCDF ?
        edges_flag = 0
        IF ( qual_given(slash_list_edges) .GT. 0) edges_flag = 1

* /BOUNDS for netCDF ?
	do_bounds = 0
        IF (qual_given( slash_list_bounds ) .GT. 0) do_bounds = 1
        IF (qual_given( slash_list_nobounds ) .GT. 0) do_bounds = -1
 
* only for cdf, and not both edges and bounds.  Use BOUNDS if both specified.

        IF (do_bounds .GT. 0) THEN
           IF (.NOT. do_cdf) CALL WARN(
     .          '/BOUNDS is valid only for NetCDF output. Ignored')
           IF (edges_flag .GT. 0) THEN
             IF (qual_given( slash_list_edges ) .GT. 0)
     .            CALL WARN('Cannot have both /BOUNDS and /EDGES '//
     .           'Ignoring /EDGES')
              edges_flag = 0
           ENDIF
        ENDIF

* get the requested data somehow
* (leave the variables flagged as "in-use" 7/92)
	CALL GET_PROT_CMND_DATA (  cx_last, ptype_native, status )
	IF ( status .NE. ferr_ok ) THEN      ! 8/6/92
           list_fmt_type = plist_default ! restore for next command
	   list_format_given = .FALSE.
           RETURN
        ENDIF
	do_multi     = qual_given(slash_seqntl) .EQ. 0
     .		 .AND. num_uvars_in_cmnd .GT. 1
     .		 .AND. .NOT.do_stream
c     .		 .AND. .NOT.do_tab_del
c     .		 .AND. .NOT.do_comma_del

	all_at_once  = do_multi.OR.do_epic.OR.do_cdf

* permutation requested ?
        DO 10 idim = 1, nferdims+1
 10     perm(idim) = idim
	IF ( permute ) THEN
* ... user-specified permutation
	   i = qual_given( slash_permute )
	   CALL EQUAL_PERMUTE( cmnd_buff(qual_start(i):qual_end(i)),
     .			       .TRUE., .FALSE., .FALSE., perm, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	ENDIF

* consolidate the given variables and the aux vars they depend on into one list
	inext = 0
	DO i = 1, num_uvars_in_cmnd 
	   inext = inext + 1
	   my_mr(inext) = is_mr(i)
	   my_cx(inext) = is_cx(i)
* ... now put its aux vars into the list
	   IF ( ITS_AUTO_CURVI(i,curvi_axes) ) THEN
* TEMPORARY: need to ensure that 'coordinates' attributes are written to point
*	     variables to their auxiliary variables
*	     For uvars there may be no __LayerzRef_. Just uvar_aux_cat/var 
	      DO idim = 1, nferdims
	         IF (curvi_axes(idim)) THEN
	            inext = inext + 1
	            frame_bottom = is_aux_ptr(i)
	            my_mr(inext) = is_mr(frame_bottom+idim)
	            my_cx(inext) = is_cx(frame_bottom+idim)
	         ENDIF
	      ENDDO
	   ENDIF
	ENDDO
	nvars2list = inext   ! equals num_uvars_in_cmnd plus aux vars

* set up possible loop - if variable by variable output is requested
* this loop will be used - else all variables are output at once
	inext = 1
 100	mr = my_mr( inext )
	cx = my_cx( inext )

* ... determine heading request
	heading  = list_heading    ! default from SET LIST
	risc_buff = ' '
	IF ( qual_given( slash_list_nohead ) .GT. 0 ) heading = .FALSE.
* did they request an "enhanced" heading?
	i = qual_given( slash_list_head )
	IF ( i .GT. 0 ) THEN
	   heading = .TRUE.
	   CALL EQUAL_STRING(
     .                  cmnd_buff(qual_start(i):qual_end(i)),
     .                  risc_buff, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   head_enh = INDEX(risc_buff,"ENH") .GT. 0
	   IF ( .NOT.head_enh .AND. risc_buff.NE.' ' ) THEN
	      CALL WARN('Unrecognized option /'//
     .		         cmnd_buff(qual_start(i):qual_end(i)) )
	      CALL WARN('Valid option is /HEADING=ENHANCED')
	   ENDIF
* Enhanced heading is not consistent with KEEP_AXISNAMES flag
	   IF (keepax_flag .EQ. 1) THEN
	      CALL WARN
     .     ('/KEEP_AXISNAMES ignored. Inconsistent w/ enhanced heading.')
              keepax_flag = 0
	   ENDIF
	      
	ELSE
	   head_enh = .FALSE.
	ENDIF
	IF ( head_enh .AND. qual_given(slash_format).EQ.0 ) GOTO 5060
	IF ( head_enh .AND. (do_comma_del.OR.do_tab_del)  ) GOTO 5060

* did they request a title?
	i = qual_given( slash_list_title )
	IF ( i .GT. 0 ) THEN
	   CALL EQUAL_STR_LC(
     .                  cmnd_buff(qual_start(i):qual_end(i)),
     .                  buff, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	ELSE
	   buff = ' '
	ENDIF

* did they set an output type?
	out_type = "DFLT"
	i = qual_given( slash_list_outtype )
	IF ( i .GT. 0 ) THEN
           IF (.NOT. do_cdf) THEN
	      CALL WARN('/OUTTYPE is valid only for NetCDF output. Ignored')
	   ELSE
	      have_outtype = .FALSE.
	      CALL EQUAL_STRING(
     .                  cmnd_buff(qual_start(i):qual_end(i)),
     .                  out_type, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
	      have_outtype = ( INDEX(out_type,'DOU') .GT. 0 .OR.
     .                    INDEX(out_type,'FLO') .GT. 0 .OR. 
     .                    INDEX(out_type,'INT') .GT. 0 .OR.
     .                    INDEX(out_type,'SHO') .GT. 0 .OR.
     .                    INDEX(out_type,'BYT') .GT. 0 )
	      IF (.NOT. have_outtype) GOTO 5100
           ENDIF
	ENDIF

* Get any settings for netcdf-4 output

        IF (do_cdf) THEN
	   CALL NETCDF4_LIST_SETTINGS (status)
           IF ( status .NE. ferr_ok ) GOTO 5000
	ENDIF

* set up the output device
	IF ( list_to_tty ) THEN
* ... output to screen
	   list_lun = ttout_lun
	ELSE
* ... output to a file
	   IF ( do_unform ) THEN
	      fformatted = 'UNFORMATTED'
	   ELSE
	      fformatted = 'FORMATTED'
	   ENDIF
* ... get full file name - from LIST/FILE= or from SET LIST/FILE=
           raw_name = ' '
           qfile = qual_given( slash_file )
           IF ( qfile .GT. 0 ) THEN
#ifdef unix
* preserve case of filename for unix
              CALL EQUAL_STR_LC(
     .			cmnd_buff(qual_start(qfile):qual_end(qfile)),
     .                  raw_name, status )
#else
* VMS filenames in upper case always
              CALL EQUAL_STRING(
     .			cmnd_buff(qual_start(qfile):qual_end(qfile)),
     .                  raw_name, status )
#endif
           ENDIF
           IF ( status .NE. ferr_ok ) GOTO 5000
	   IF ( raw_name .EQ. ' ' .AND. do_stream_phase.EQ.0 ) THEN
* ... use default from SET LIST command
              vax_code = STR_CASE_BLIND_COMPARE(list_file(1:4),'AUTO')
	      IF ( vax_code .EQ. vms_str_success ) THEN
                 vax_code = STR_UPCASE( list_file, list_file )
	         raw_name = AUTO_FILENAME( list_file, cx, mr, rlen )
	      ELSE
	         raw_name = list_file
	      ENDIF
	   ELSEIF ( STR_CASE_BLIND_COMPARE(raw_name(1:4),'AUTO')
     .         .EQ. vms_str_success ) THEN
              vax_code = STR_UPCASE( raw_name, raw_name )
	      raw_name = AUTO_FILENAME( raw_name, cx, mr, rlen )
	   ENDIF
!	   rlen = TM_LENSTR1( raw_name )      ! ever used ???
           slen = TM_LENSTR1(raw_name)
           IF (slen .GT. 256 ) GOTO 5090
	   INQUIRE( FILE = raw_name, NAME = filename, EXIST = fexist )

	   flen = TM_LENSTR1( filename )
* ... forced heading ?
! (3/90)	   IF ( .NOT.fexist .AND. list_at_eof ) heading = .TRUE.
* ... append or not ?
	   IF ( fexist ) THEN    ! 10/93 logic change
	      IF ( list_at_eof ) THEN

#ifdef NO_ACCESS_APPEND
	         faccess = 'SEQUENTIAL'
#else
	         faccess = 'APPEND'
		 fposition = 'APPEND'
#endif
	         fstatus = 'OLD'
	      ELSEIF (do_stream) THEN
	         IF ( do_stream_phase .EQ. 0 ) THEN

	            IF ( clobber ) THEN
	               fstatus = 'OLD'
	            ELSE
	               CALL ERRMSG
     .		   ( ferr_invalid_command,  status,
     .              'file already exists: '//raw_name,
     .              *1000 )
	            ENDIF
	         ENDIF
	      ELSEIF ( clobber ) THEN	! 11/96
	         faccess = 'SEQUENTIAL'
	         fstatus = 'REPLACE'
#ifdef F90_OPEN_FILE_CLOBBER
		 fposition = 'ASIS'
#endif
	      ELSE
	         GOTO 5050	! attempt to clobber a file
	      ENDIF
	   ELSE
	      faccess = 'SEQUENTIAL'
	      fstatus = 'NEW'
	      fposition = 'asis'
	   ENDIF
* ... open or create it
* only output listing message if user didn't specify quiet *kob* 2/99
* For dods output, file is opened in the C routine called by write_dods_fmt.

           IF (.NOT.(do_EPIC) .AND. do_stream_phase.EQ.0 
     .                    .AND. .NOT.(quiet) )
     . 	          CALL SPLIT_LIST(pttmode_bull, err_lun,
     .		  ' LISTing to file '//raw_name(1:TM_LENSTR1(raw_name))
     .								,0)

	   IF ( normal_file ) THEN
	      OPEN( UNIT	= default_list_lun,
     .		    FILE	= raw_name,
     .		    FORM	= fformatted,
#ifdef F90_OPEN_FILE_APPEND
     .		    POSITION    = fposition,
#else
     .		    ACCESS	= faccess,
#endif
     .		    STATUS	= fstatus,
     .		    ERR		= 5010 )
	   ELSEIF ( do_stream .AND. do_stream_phase.EQ.0 ) THEN	! 12/94
	      reclen = 1  ! in bytes
	      DO 60 i = 1, nvars2list
	         IF ( mr_type(my_mr(i)) .EQ. ptype_string ) THEN
	            reclen = MAX(reclen,
     .			GET_MAX_STRING_LEN(my_cx(i), my_mr(i),
     .					   memry(my_mr(i))%ptr)+1 )
	         ELSE
	            reclen = MAX(reclen,4)
	         ENDIF
		 
#ifdef double_p
	         reclen = reclen * 2
#endif

 60	      CONTINUE
	      OPEN( UNIT	= default_list_lun,
     .		    FILE	= raw_name,
     .		    FORM	= 'UNFORMATTED',
     .		    ACCESS	= 'DIRECT',
     .		    STATUS	= fstatus,
#ifdef reclen_in_bytes
     .	            RECL	= reclen,
#else
     .	            RECL	= reclen/4,
#endif
     .		    ERR		= 5010 )
	      do_stream_phase = 1		! for multi-variables
	   ENDIF
	   list_lun = default_list_lun
	ENDIF

* reserve working arrays (different needs for each listing type)
	IF ( do_epic ) THEN
	   wsize = 1
	   DO 110 ilist = 1, nvars2list
 110	   wsize = MAX ( wsize, CX_DIM_LEN(t_dim,my_cx(ilist)) )
	   wsize = 3. * wsize
	ELSEIF ( do_multi ) THEN
	   wsize = nvars2list* (2*nferdims+6)
	ELSEIF ( all_at_once ) THEN
	   wsize = nvars2list
	ELSE
* ... allocate enough space for the longest axis
	   wsize = 1
	   DO 112 idim = 1, nferdims
 112	   wsize = MAX( wsize, CX_DIM_LEN(idim,cx))
	   IF (do_dods)THEN
              wsize = 1
              DO 113 idim = 1, nferdims
 113	        IF (CX_DIM_LEN(idim,cx) .GE. 1) 
     .             wsize = wsize * CX_DIM_LEN(idim,cx)
	   ENDIF
	ENDIF
	i8_size = wsize
	CALL GET_DYN_WORK_SPACE( i8_size, status )
	IF ( status .NE. ferr_ok ) GOTO 1000

* special handling of EPIC data - no permutations
	IF ( do_epic ) THEN
	   CALL EPIC_LIST( raw_name, my_mr, my_cx, 
     .			   workmem(plegacy_work_buffer)%ptr, wsize, status )
	   GOTO 1000
	ENDIF

* permute data to the desired output order

	IF ( all_at_once ) THEN
* ... if no axis order was specified determine the permutation
c bug fix: see err540_write_order.jnl move inside loop:
* ... Ticket 1480: When writing to netCDF, test the region 
*     on modulo axes 

c	   IF (.NOT.permute) CALL GET_CX_DIMS(cx,ndim, perm )
	   DO 200 ilist = 1, nvars2list
	      IF (.NOT.permute) CALL GET_CX_DIMS(my_cx(ilist),ndim,perm)
	      CALL SHRINK_FOR_MODULO (my_cx(ilist), my_mr(ilist), do_cdf,
     .				      do_shrink)
	      CALL CREATE_PERMUTATION(	my_cx  (ilist),
     .					my_mr  (ilist),
     .					perm, 
     .					mr_perm(ilist), do_shrink, status )
	      IF ( status .NE. ferr_ok ) GOTO 500
              npermuted = npermuted + 1
 200	   CONTINUE

* w/ the above fix, mr_perm is correct but perm needs to be reset.
	   IF (.NOT.permute) CALL GET_CX_DIMS(cx,ndim, perm )
	ELSE
* ... if no axis order was specified use the first variable as default
           IF ( .NOT.permute ) THEN
	      CALL GET_CX_DIMS( cx, ndim, perm )
* ... default listing for a line of data is a column
	      IF (ndim.EQ.1) THEN
	         i = perm(1)
	         perm(1) = perm(2)
	         perm(2) = i
	      ENDIF
	   ENDIF
	   CALL CREATE_PERMUTATION(cx,mr,perm,mr_perm,do_cdf,status)
	   IF ( status .NE. ferr_ok ) GOTO 500
           npermuted = npermuted + 1
	ENDIF

* list it
!jli: for list in xml
	IF (do_xml) THEN
*           CALL NON_ARRAY_SUBSC( mr_perm, 1 )
*           nn = mr_perm(1)
*           CALL LIST_CMND_DATA_XML( memory(1, mr_blk1(mr_perm(1))),
*     .                          nn, cx, memory(1, wkblk), 
*     .                          heading, head_enh, recsofar, perm, 
*     .                          clobber, raw_name, status)

	ELSEIF ( do_cdf ) THEN
	   CALL CDF_LIST(  raw_name( 1:TM_LENSTR1(raw_name)), 
     .                    list_at_eof, cdf_recax, nvars2list,
     .			  mr_perm, my_cx, buff, head_enh,
     .			  pcdf_mode_normal, clobber, edges_flag, do_bounds,
     .                    keepax_flag, out_type, quiet, status )

	ELSEIF( all_at_once ) THEN
	   CALL LIST_MULTI(  mr_perm, my_cx, heading, perm,
     .			    wsize, workmem(plegacy_work_buffer)%ptr,status )
	ELSE
	   CALL NON_ARRAY_SUBSC( mr_perm, 1 )
           nn = mr_perm(1)
	   CALL LIST_CMND_DATA( memry(mr_perm(1))%ptr,
     .                          nn, cx,  workmem(plegacy_work_buffer)%ptr, 
     .                          heading, head_enh, recsofar, perm, 
     .                          clobber, raw_name, status)
	ENDIF

* EXIT sequence
* ... relinquish working space
 500	CALL RELEASE_DYN_WORK_SPACE

* ... close any special output device
	IF ( normal_file ) CLOSE ( UNIT = list_lun, ERR = 5010 )

* ... delete permuted data if it was created
	DO 510 ilist = 1, npermuted
	   mr = mr_perm(ilist)
	   IF ( mr_protected(mr) .EQ. mr_temporary
     .	   .OR. mr_protected(mr) .EQ. mr_table_entry_only )
     .					CALL DELETE_VARIABLE( mr )
	   IF ( .NOT.all_at_once ) THEN
* ... loop back for next variable if appropriate
	      inext = inext + 1
	      IF ( do_stream) do_stream_phase = do_stream_phase + 1
	      IF ( status.EQ.ferr_OK .AND. inext.LE.nvars2list ) THEN
	         GOTO 100
	      ELSE
	         GOTO 1000
	      ENDIF
	   ENDIF
 510	CONTINUE

 1000   list_fmt_type = plist_default ! restore for next command
	list_format_given = .FALSE.
        CALL UNPROTECT_CMND_DATA
	IF ( do_stream .AND. do_stream_phase.GT.0)
     .			CLOSE ( UNIT = list_lun, ERR = 4999 )
 4999   RETURN

* error exit(s)
 5000   GOTO 1000
 5010	CALL ERRMSG( ferr_erreq,status,filename(:flen),*1000 )
 5040	CALL ERRMSG( ferr_invalid_command, status,
     .			'/EXTEND only allowed with CDF format', *1000 )
 5050	CALL ERRMSG( ferr_invalid_command, status,
     .			'/CLOBBER not specified and file exists: '
     .			//raw_name, *1000 )
 5060	CALL ERRMSG( ferr_invalid_command, status,
     .		'LIST/HEADING=enhanced needs a /FORMAT qualifier'//pCR//
     .		'	(format cannot be tab or comma)', *1000 )
 5070	CALL ERRMSG( ferr_invalid_command, status,
     .		'In GUI mode LIST/FORMAT reguires a named /FILE=', *1000 )
 5080	CALL ERRMSG( ferr_invalid_command, status,
     .			'/ORDER not allowed with V permutation (yet)', *1000 )
     
 5090	CALL ERRMSG( ferr_prog_limit, status,
     .  'Cannot write to file w/ name longer than 256 characters: '//pCR//
     .  'Limitation of Fortran INQUIRE and OPEN calls '	
     .			, *5000 )
     
 5100	CALL ERRMSG( ferr_invalid_command, status,
     .		'Unrecognized option/'//
     .          cmnd_buff(qual_start(i):qual_end(i)) //pCR//
     .		' Valid options are /OUTTYPE=DOUBLE,FLOAT,INT,SHORT,or BYTE', *1000 )
	END

	SUBROUTINE SHRINK_FOR_MODULO (cx, msrc, do_cdf, do_shrink)

* If the region was specified with world coordinates, e.g. X=0:360, but this makes
* the region just one cell too large to be corrrectly a modulo axis, then shrink
* the data by one, when writing a netCDF file. This way if the intent was, for
* instance, to shift a 20:380 axis to 0:360, we don't lose the correct modulo
* behavior and length.
* - If the region is larger than one cell over the modulo length, 
*   then the axis will be written as a non-modulo axis.
* - If the region was specified using indices, then the limits will be 
*   as specified, a non-modulo axis.

* Flag do_shrink is returned TRUE if one or more axes are shrunk


        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'

* Calling argument declarations	
	LOGICAL do_cdf, do_shrink
	INTEGER cx, msrc

* Local declarations	
	LOGICAL ITSA_MODULO_AXIS
	INTEGER	grid, idim, dimsiz, ax_min_ss, ax_max_ss
	   
	do_shrink = .FALSE.
	IF (.NOT. do_cdf) RETURN

* Adjust the context index range, only in the limted case defined above.

	grid = cx_grid ( cx )
	DO 100 idim = 1, nferdims
	   IF (.NOT.  ITSA_MODULO_AXIS( cx, idim )) GOTO 100
	   IF ( cx_by_ss(idim,cx) ) GOTO 100

	   dimsiz = mr_hi_ss(msrc,idim) - mr_lo_ss(msrc,idim)
	   CALL GRID_SUBSCRIPT_EXTREMES_NO_MOD(ax_min_ss, ax_max_ss, grid, idim)
	   IF (ax_max_ss-ax_min_ss .EQ. dimsiz-1) THEN
	      do_shrink = .TRUE.
	      cx_hi_ss(cx,idim) = cx_hi_ss(cx,idim) - 1
	   ENDIF
 100	CONTINUE
	      
	RETURN
	END

	SUBROUTINE IIN_REGRID (	cx_lims, idim, dst_lo, dst_hi,
     .				src, msrc, dst, mdst, box, itot, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* integrate the component along axis idim producing an "indefinite" integral
* placing the result on a grid which is 1 cell longer than the source grid,
* as described in ticket #2346.

* The indefinite integral transform returns a result that is shifted a half-cell 
* down from where it should be. Because the full cell is being integrated, the 
* result really ought to sit at the upper edge of the cell, not the cell center.

* 	programmer - Ansley Manke
* 	NOAA/PMEL,Seattle,WA - 
* 	revision 1.0 - 4/2017

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xcontext.cmn'
	include 'xunits.cmn_text'
	external xunits_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data

* CALLING ARGUMENT DECLARATIONS:
	INTEGER cx_lims, idim, dst_lo, dst_hi, msrc, mdst, itot, status
	REAL    src( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          dst( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif ),
     .		box(mr_lo_ss(msrc,idim):mr_hi_ss(msrc,idim))

* internal variable declarations:
	LOGICAL	GEOG_COS_FACTOR, ITSA_TRUEMONTH_AXIS, TM_DFPEQ,
     .          need_cos, blank
	INTEGER i, j, k, l, m, n, sgrid, dgrid, axis, src_lo, src_hi,
     .          ii, jj, kk, ll, mm, nn, is, js, ks, ls, ms, ns
	REAL	BOX_SIZE, unit, bad_src, bad_dst, cos_factor,
     .          ybxlo, ybxhi, bx
	REAL*8	TM_WORLD, dsum
	

* source and destination grids
	sgrid = mr_grid( msrc )
	dgrid = mr_grid( mdst )
	axis = grid_line( idim, sgrid )

* LIMITS FOR CALCULATION
        src_lo = mr_lo_ss(msrc,idim)
        src_hi = mr_hi_ss(msrc,idim)

* FLAG FOR BAD/MISSING DATA
        bad_src = mr_bad_data(msrc)
        bad_dst = mr_bad_data(mdst)

* Get and save grid box sizes (weights) just once for efficiency
* Check that grid boxes are the same size on source and destination axes

        is = src_lo
        DO 100 i = dst_lo, dst_hi
           IF (is.LT.src_lo .OR. is.GT.src_hi) GOTO 100
           bx =  BOX_SIZE( i, dgrid, idim )
           box(is)  = BOX_SIZE( i, sgrid, idim )
           IF (.NOT.TM_DFPEQ( bx, box(is) ) ) GOTO 5100
           is = is + 1
 100	CONTINUE

* No overlap between grids; return all-missing result
	blank = src_lo.GT.dst_hi .OR. src_hi.LT.dst_lo

* perform integrations on standard units if possible
	unit = un_convert( line_unit_code(axis) )
	IF (ITSA_TRUEMONTH_AXIS(axis)) unit = un_convert(pun_day)
	DO 110 i = src_lo, src_hi
 110	box(i) = box(i) * unit

* INTEGRATE
* ALONG X AXIS
* (note: X integration is a special case because it requires COSINE(lat) )
	IF ( idim .EQ. x_dim ) THEN
	   need_cos = GEOG_COS_FACTOR( idim, sgrid )
     .                .AND. cx_lo_s2(cx_lims).NE.unspecified_int4
	   DO 210 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
	   cos_factor = 1.D0
	   IF ( need_cos ) THEN
#ifdef double_p
	      cos_factor = COS( deg2rad *       
     .            TM_WORLD(j, sgrid, y_dim, box_middle) ) 
              ybxlo = deg2rad* 
     .            TM_WORLD(j,sgrid,y_dim,box_lo_lim)
              ybxhi = deg2rad* 
     .            TM_WORLD(j,sgrid,y_dim,box_hi_lim)
#else
	      cos_factor = COS( deg2rad *       
     .            SNGL( TM_WORLD(j, sgrid, y_dim, box_middle) ) ) 
              ybxlo = deg2rad* 
     .            SNGL( TM_WORLD(j,sgrid,y_dim,box_lo_lim) )
              ybxhi = deg2rad* 
     .            SNGL( TM_WORLD(j,sgrid,y_dim,box_hi_lim) )
#endif
              bx = ABS(ybxhi - ybxlo)
	      cos_factor = ABS( SIN(ybxhi) - SIN(ybxlo) )/ bx
	   ENDIF
	   DO 210 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	   DO 210 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	   DO 210 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	   DO 210 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	      dsum = 0.0D0
	      is = src_lo
	      DO 205 i = dst_lo, dst_hi

	         dst(i,j,k,l,m,n) = bad_dst
		 IF (blank) GOTO 205
	         IF (is.GT.src_hi .AND. is.EQ.dst_hi) GOTO 205

	         dst(i,j,k,l,m,n) = dsum * cos_factor

		 IF ( src(is,j,k,l,m,n) .EQ. bad_src ) THEN
* ... reject all data after a bad point
	            DO 200 ii = i, dst_hi
 200	              dst(ii,j,k,l,m,n) = bad_dst
	            GOTO 210
	         ENDIF
	         dsum = dsum + box(is)*src(is,j,k,l,m,n)
		 is = is + 1
 205	      CONTINUE
	      IF (is .EQ. dst_hi) dst(is,j,k,l,m,n) = dsum * cos_factor
 210	   CONTINUE

* ALONG Y AXIS
	ELSEIF ( idim .EQ. y_dim ) THEN
	   DO 310 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	   DO 310 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	   DO 310 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	   DO 310 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	   DO 310 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
	      dsum = 0.0D0
	      js = src_lo
	      DO 305 j = dst_lo, dst_hi

	         dst(i,j,k,l,m,n) = bad_dst
		 IF (blank) GOTO 305
	         IF (js.GT.src_hi .AND. js.EQ.dst_hi) GOTO 305

	         dst(i,j,k,l,m,n) = dsum
	         
		 IF ( src(i,js,k,l,m,n) .EQ. bad_src ) THEN
* ... reject all data after a bad point
	            DO 300 jj = j, dst_hi
 300	            dst(i,jj,k,l,m,n) = bad_dst
	            GOTO 310
	         ENDIF
	         dsum = dsum + box(js)*src(i,js,k,l,m,n)
		 js = js + 1
 305	      CONTINUE
	      IF (js .EQ. dst_hi) dst(i,js,k,l,m,n) = dsum
 310	   CONTINUE


* ALONG Z AXIS
	ELSEIF ( idim .EQ. z_dim ) THEN
	   DO 410 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	   DO 410 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	   DO 410 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	   DO 410 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
	   DO 410 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
	      dsum = 0.0D0
	      ks = src_lo
	      DO 405 k = dst_lo, dst_hi

	         dst(i,j,k,l,m,n) = bad_dst
		 IF (blank) GOTO 405
	         IF (ks.GT.src_hi .AND. ks.EQ.dst_hi) GOTO 405

	         dst(i,j,k,l,m,n) = dsum

	         IF ( src(i,j,ks,l,m,n) .EQ. bad_src ) THEN
* ... reject all data after a bad point
	            DO 400 kk = k, dst_hi
 400	            dst(i,j,kk,l,m,n) = bad_dst
	            GOTO 410
	         ENDIF
	         dsum = dsum + box(ks)*src(i,j,ks,l,m,n)
		 ks = ks + 1
 405	      CONTINUE
	      IF (ks .EQ. dst_hi) dst(i,j,ks,l,m,n) = dsum
 410	   CONTINUE

* ALONG T AXIS
	ELSEIF ( idim .EQ. t_dim ) THEN
	   DO 510 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	   DO 510 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	   DO 510 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	   DO 510 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
	   DO 510 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
	      dsum = 0.0D0
	      ls = src_lo
	      DO 505 l = dst_lo, dst_hi
	      
	         dst(i,j,k,l,m,n) = bad_dst
		 IF (blank) GOTO 505
	         IF (ls.GT.src_hi .AND. ls.EQ.dst_hi) GOTO 505

	         dst(i,j,k,l,m,n) = dsum

		 IF (ls .GT. src_hi) GOTO 510
	         IF ( src(i,j,k,ls,m,n) .EQ. bad_src ) THEN
* ... reject all data after a bad point
	            DO 500 ll = l, dst_hi
 500	            dst(i,j,k,ll,m,n) = bad_dst
	            GOTO 510
	         ENDIF
	         dsum = dsum + box(ls)*src(i,j,k,ls,m,n)
		 ls = ls + 1
 505	      CONTINUE
	      IF (ls .EQ. dst_hi) dst(i,j,k,ls,m,n) = dsum
 510	   CONTINUE

* ALONG E AXIS
	ELSEIF ( idim .EQ. e_dim ) THEN
	   DO 610 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	   DO 610 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	   DO 610 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	   DO 610 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
	   DO 610 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
	      dsum = 0.0D0
	      ms = src_lo
	      DO 605 m = dst_lo, dst_hi
	      
	         dst(i,j,k,l,m,n) = bad_dst
		 IF (blank) GOTO 605
	         IF (ms.GT.src_hi .AND. ms.EQ.dst_hi) GOTO 605

	         dst(i,j,k,l,m,n) = dsum

	         IF ( src(i,j,k,l,ms,n) .EQ. bad_src ) THEN
* ... reject all data after a bad point
	            DO 600 mm = m, dst_hi
 600	            dst(i,j,k,l,mm,n) = bad_dst
	            GOTO 610
	         ENDIF
	         dsum = dsum + box(ms)*src(i,j,k,l,ms,n)
		 ms = ms + 1
 605	      CONTINUE
	      IF (ms .EQ. dst_hi) dst(i,j,k,l,ms,n) = dsum
 610	   CONTINUE

* ALONG F AXIS
	ELSEIF ( idim .EQ. f_dim ) THEN
	   DO 710 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	   DO 710 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	   DO 710 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	   DO 710 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
	   DO 710 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
	      dsum = 0.0D0
	      ns = src_lo
	      DO 705 n = dst_lo, dst_hi
	      
	         dst(i,j,k,l,m,n) = bad_dst
		 IF (blank) GOTO 705
	         IF (ns.GT.src_hi .AND. ns.EQ.dst_hi) GOTO 705

	         dst(i,j,k,l,m,n) = dsum

	         IF ( src(i,j,k,l,m,ns) .EQ. bad_src ) THEN
* ... reject all data after a bad point
	            DO 700 nn = n, dst_hi
 700	            dst(i,j,k,l,m,nn) = bad_dst
	            GOTO 710
	         ENDIF
	         dsum = dsum + box(ns)*src(i,j,k,l,m,ns)
		 ns = ns + 1
 705	      CONTINUE
	      IF (ns .EQ. dst_hi) dst(i,j,k,l,m,ns) = dsum
 710	   CONTINUE

	ENDIF

 5000	RETURN

 5100	CALL ERRMSG(ferr_regrid, status,
     .    '@IIN regridding must be to axis with same grid-cell sizes', *5000 )


 5200	CALL ERRMSG(ferr_regrid, status,
     .    '@IIN regridding on non-overlapping grids', *5000 )

	END

	SUBROUTINE NETCDF4_SHOW_LIST_SETTINGS
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or 'bug fixes'.
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP 'AS IS' AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Get the settings for netcdf4 output datasets and show them as other
* SET LIST settings are shown

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Thermal Modeling and Analysis Program
*
* revision 0.0 - 1/13/2010
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
*       *acm* 2/16 add echunk and fchunk

* Qualilifiers for SET LIST: NCFORMAT,
* XCHUNK,YCHUNK,ZCHUNK,TCHUNK,DEFLATE,SHUFFLE,ENDIAN

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'slash.parm'
	include 'xcontext.cmn'
	include 'xprog_state.cmn'
	include 'errmsg.parm'
        include 'netcdf4_settings.cmn'
	include 'xrisc.cmn'          ! 12/94 SPLIT_LIST buffer

* calling argument declarations
	INTEGER		status

* internal variable declarations
	INTEGER  STR_SAME, loc, slen, nchunk
	CHARACTER TM_FMT*48, show_str*12
	REAL val

* initialize netcdf4-type stuff. If there has been a 
* SET LIST/NCFORMAT/ENDIAN/DEFLATE/SHUFFLE then these contain those values,
* otherwise they are set to the defaults


        risc_buff = '           ---- '
        CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
        risc_buff = '        NetCDF-4 settings: '
        CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)

* /NCFORMAT for netCDF4 types ?
* NETCDF4 and CLASSIC, or 4=NETCDF4, 3=CLASSIC, 64BIT_OFFSET(?)

        IF (netcdf4_type .EQ. 3) 
     .      risc_buff = '        NetCDF file type = classic'
	IF (netcdf4_type .EQ. 4) 
     .      risc_buff = '        NetCDF file type = NetCDF-4'
	IF (netcdf4_type .EQ. 6) 
     .      risc_buff = '        NetCDF file type = NF_64BIT_OFFSET'
	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)

* DEFLATE 
* Can set compression level though all indicatins are that value=1 is best
* deflate=0 means no deflate

        IF (deflate_lev .LE. 0) THEN
           risc_buff = 'Compression not set'
        ELSE 
	   WRITE (risc_buff, 1100) deflate_lev
	   CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	ENDIF
 1100   FORMAT (8X, 'Compression (deflate) level set to ', I1)

        nchunk = 0
        IF (xchunk_size_set .GT. 0) THEN
	   val = xchunk_size
           show_str = TM_FMT(val, 5, 12, slen)
	   WRITE (risc_buff, 1200) 'X', show_str(1:slen)
	   CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	   nchunk = nchunk + 1
	ENDIF
 1200   FORMAT (8X, A1,'CHUNK size set to ', A)
        IF (ychunk_size_set .GT. 0) THEN
	   val = ychunk_size
           show_str = TM_FMT(val, 5, 12, slen)
	   WRITE (risc_buff, 1200) 'Y', show_str(1:slen)
	   CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	   nchunk = nchunk + 1
	ENDIF

        IF (zchunk_size_set .GT. 0) THEN
	   val = zchunk_size
           show_str = TM_FMT(val, 5, 12, slen)
	   WRITE (risc_buff, 1200) 'Z', show_str(1:slen)
	   CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	   nchunk = nchunk + 1
	ENDIF

        IF (tchunk_size_set .GT. 0) THEN
	   val = tchunk_size
           show_str = TM_FMT(val, 5, 12, slen)
	   WRITE (risc_buff, 1200) 'T', show_str(1:slen)
	   CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	   nchunk = nchunk + 1
	ENDIF

        IF (echunk_size_set .GT. 0) THEN
	   val = echunk_size
           show_str = TM_FMT(val, 5, 12, slen)
	   WRITE (risc_buff, 1200) 'E', show_str(1:slen)
	   CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	   nchunk = nchunk + 1
	ENDIF

        IF (fchunk_size_set .GT. 0) THEN
	   val = fchunk_size
           show_str = TM_FMT(val, 5, 12, slen)
	   WRITE (risc_buff, 1200) 'F', show_str(1:slen)
	   CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	   nchunk = nchunk + 1
	ENDIF
        
	IF (nchunk .EQ. 0) THEN
	   risc_buff = '        NetCDF chunk sizes = default'
	   CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	ENDIF

* SHUFFLE 
* Shuffle = 0 or 1

	IF (shuffle_flag .EQ. 1) THEN
           risc_buff = '        SHUFFLE set to off'
	ELSE
           risc_buff = '        SHUFFLE set to on'
	ENDIF
	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)

! ENDIAN: native, little, big

	IF (endian_code .EQ. 0) THEN
           risc_buff = '        ENDIAN set to native'
	ELSEIF (endian_code .EQ. 1) THEN
           risc_buff = '        ENDIAN set to little'
	ELSEIF (endian_code .EQ. 2) THEN
           risc_buff = '        ENDIAN set to big'
	ENDIF
	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)

	RETURN

	END

        REAL FUNCTION RHO_UNESCO(salinity, temperature, pressure)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* The 1980 UNESCO International Equation of State (IES80)
* *sh* 8/5/92 - adapted from C version supplied by John Osborne, PMEL

*       This calculates rho (density kg/m^3) at salinity, 
*	temperature, and pressure.  This will be potential density if 
*	temperature is potential temperature.  The routine uses the high 
*	pressure equation of state from Millero et al. 1980 and the one-
*	atmosphere equation of state from Millero and Poisson 1981 as
*	reported in Gill 1982.  The notation follows Millero et al. 1980
*	and Millero and Poisson 1981.
*	
*	Note: the routine takes p in decibars and converts to bars for
*	the calculations.
*	
* References:	Millero, F.J., et al., 1980, Deep-Sea Res., 27A, 255-264.
*  Millero, F.J. and Alain Poisson, 1981, Deep-Sea Res., 28A, 625-629.
*  Gill, A.E., 1982, Atmosphere-Ocean Dynamics, Academic Press, Inc., 662 pp. 
*	
*	Input Units:
*			S: psu	T: deg. C	p: decibars.
*			
*	Output Units:
*			rho: kg/m^3
*			
*	Check values:
*			rho = 999.96675 	for S = 0,  T = 5,  p = 0
*			rho = 1027.675465 	for S = 35, T = 5,  p = 0
*			rho = 1062.538172 	for S = 35, T = 25, p = 10000.
			
* calling argument declaraions:

        IMPLICIT NONE

        REAL salinity, temperature, pressure

* internal variable declarations:
	REAL S, T, p, rootS
	REAL a, b, c, d, e
	REAL Aw, Bw, Kw
	REAL A2, B2, C2, Kzero, K
	REAL rhoW, rhoZero

* initialize
	S = salinity
	T = temperature
	p = pressure / 10.
	rootS = SQRT (S)

* rhoW is the density of pure water at temperature T.
	rhoW = ((((6.536332e-09 * T - 1.120083e-06) * T + 1.001685e-04)
     .		* T - 9.095290e-03) * T + 6.793952e-02) * T + 999.842594

	A2 = (((5.3875e-09 * T - 8.2467e-07) * T + 7.6438e-05)
     .		* T - 4.0899e-03) * T + 8.24493e-01

	B2 = (-1.6546e-06 * T + 1.0227e-04) * T - 5.72466e-03

	C2 = 4.8314e-04

* rhoZero is the one-atmosphere density of seawater
	rhoZero	= (C2 * S + B2 * rootS + A2) * S + rhoW

	IF ( pressure .EQ. 0.0 ) THEN
	   RHO_UNESCO = rhoZero
	   RETURN
        ENDIF

	a = ((-6.1670e-05 * T + 1.09987e-02) * T - 6.03459e-01) * T
     .		+ 54.6746

	b = (-5.3009e-04 * T + 1.6483e-02) * T + 7.944e-02

	c = (-1.6078e-06 * T - 1.0981e-05) * T + 2.2838e-03

	d = 1.91075e-04

	e = (9.1697e-10 * T + 2.0816e-08) * T - 9.9348e-07

	Aw = ((-5.77905e-07 * T + 1.16092e-04) * T + 1.43713e-03) * T
     .	       + 3.239908

	Bw = (5.2787e-08 * T - 6.12293e-06) * T + 8.50935e-05

* Kw is the secant bulk modulus of pure water at temperature T.
	Kw = (((-5.155288e-05 * T + 1.360477e-02) * T - 2.327105)
     .		* T + 148.4206) * T + 19652.21

* Kzero is the secant bulk modulus of seawater at one atmosphere.
	Kzero = (b * rootS + a) * S + Kw

* K is the secant bulk modulus of seawater at (S, T, p).
	K = ((e * p + d * rootS + c) * S + Bw * p + Aw) * p + Kzero

	RHO_UNESCO = rhoZero / (1.0 - (p / K))

	RETURN
	END

	SUBROUTINE CMDERR(IER,LINE,ILEN,IPOS)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C      @(#)cmderr.F	1.2    5/26/88
C  
C  
C                                                                      *
C  
C  		    PLOT+ Scientific Graphics System
C  
C                                                                      *
C  
C  
C  	Subprogram called:
C  		CALL CMDERR(IER,LINE,ILEN,IPOS)
C  
C  	Parameters:
C  		IER -- Error code
C  			0 = no error
C  			1 = symbol not found
C  			2 = unmatched single quote in parse
C  			3 = qualifier not found
C  			4 = then missing
C  			5 = nesting error for IF statement
C  			6 = logical operator not found
C  			7 = unmatched double quote in expression
C  			8 = nesting error for WHILE statement
C  			9 = syntax error
C  		       10 = unmatched (in LEV command
C  		       11 = exceeds maximum number of levels
C  		LINE -- Command line
C  		ILEN -- Length of LINE
C  		IPOS -- Position to mark
C  
C  	Description:
C  		Routine to print the input line and point to the
C  		offending element.  This command will abort the
C  		program if BATCHF is true.
C  
C  	History:
C  	    Written: 
C  		5-JAN-86	by Donald W. Denbo
C  	    Modified:
C  
C       11-Dec-2003 ACM Add the string **ERROR before the error message,
C                       to be consistent with Ferret error messages.
C  
C    V6.06 ACM Write error messages to Standard Error, unit number is LERROR
* V72  *acm*  6/17 - Call Ferret's errmsg routine for syntax errors calling 
*                    PPLUS, see ticket 2543

	INCLUDE 'SYSTEM.INC'
	INCLUDE 'CMDCOM.INC'
	INCLUDE 'LUNITS.INC'
	include 'errmsg.parm'

	integer TM_LENSTR1, slen, status
	CHARACTER LINE*(*),frmt*30
	CHARACTER ERRMES(11)*30
	DATA ERRMES/'Symbol not found','Unmatched ''',
     *	'Qualifier not recognized','THEN missing',
     *	'IF levels improperly nested','No operator found',
     *	'Unmatched "','WHILE levels improperly nested',
     *	'Syntax error','Unmatched (','Maximum no. levels exceeded'/

	IF(IER.EQ.0)RETURN
	slen = TM_LENSTR1(ERRMES(IER))
        CALL ERRMSG (ferr_ppl_error, status, ERRMES(IER)(:slen)//' PPLUS '//LINE(:ILEN), *5000)

 5000	RETURN
	END

	SUBROUTINE CD_READ_REMOTE ( dset, rvar_varid,
     .		a_lo_x, a_lo_y, a_lo_z, a_lo_t, a_lo_e, a_lo_f,
     .		a_hi_x, a_hi_y, a_hi_z, a_hi_t, a_hi_e, a_hi_f,
     .		use_lo, use_hi, stride, grid_start, 
     .		grid_end, grid_order, var, sf_num, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Reads a N-D block of data (3D, 2D being degenerate cases w/ 1 dimension being
* 1 time series) from TMAP data sets with LET/REMOTE definition.
*
* written 2/2013 by Ansley Manke PMEL/TMAP, from TM_CHOOSE_READ and CD_READ
* V751 *acm* 6/19 Remove unused declarations

* include files
        include 'netcdf.inc'
        include 'tmap_dims.parm'                ! data set dimension
        include 'tmap_errors.parm'              ! err code parm defs
#include "gt_lib.parm"
        include 'xtm_grid.cmn_text'             ! grid info
        external xgt_grid_data
        include 'xdset_info.cmn_text'   ! data set info common
        external xdset_info_data
        include 'xdset_info.cd_equiv'
	include 'xstep_files.cmn_text'	! step file common
	external xstep_files_data

* arguments:
*	dset        - internal data set # (from GT_INIT_DSET)
*       rvar_varid  - varid in ftds dataset to read
*       actual_dims - "a_" full dimensions of data_grid array passed
*	use_lo      - low indices of model data block desired
*	use_hi      - high indices of model data block desired
*	stride	    - every nth point to be read from disk file
*       gridlines   - lists the line ids that are part of the remote-variable grid
*	var         - array containing model data (output)
*	sf_num      - stepfile number (returned from GT_FIND_TSTEP (output)
*	status      - error status upon completion (output)
*
	INTEGER		dset, rvar_varid, sf_num, status, ndim,
     .		a_lo_x, a_lo_y, a_lo_z, a_lo_t, a_lo_e, a_lo_f,
     .		a_hi_x, a_hi_y, a_hi_z, a_hi_t, a_hi_e, a_hi_f,
     .		use_lo(*), use_hi(*), stride(*), 
     .		grid_start(*), grid_end(*), grid_order(*)
	REAL     	var(a_lo_x:a_hi_x,
     .                      a_lo_y:a_hi_y,
     .                      a_lo_z:a_hi_z,
     .                      a_lo_t:a_hi_t,
     .                      a_lo_e:a_hi_e,
     .                      a_lo_f:a_hi_f),
     .			baddat


* local definitions
* *kob* explicit definitions not allowed on decl line in linux...
*       moved it to parameter line 10/96
	LOGICAL      do_warn, already_scaled, got_it, tf2, 
     .               coordvar
        INTEGER      TM_LENSTR1,
     .               cdfid, varid, idim, lasdim, cdfstat, dim, idim2,
     .               start(nferdims), filsize(nferdims), totsize, 
     .               dim_lo(nferdims),dim_hi(nferdims), imap(nferdims), 
     .		     trans(nferdims), memsize(nferdims), count(nferdims),
     .		     grid_dims(nferdims), fildim, memdim, filstride(nferdims),
     .               maxlen, attlen, attoutflag, vtype, nvdims, nvatts, 
     .               outflag, dlen, err_status, i, permuted, strided
        REAL vdims(10), val
	CHARACTER*1	dimnam(nferdims)
	CHARACTER*13	TM_STRING
        CHARACTER*128   buff, vname
	DATA  		dimnam/'I','J','K','L','M','N'/
	CHARACTER*1024 ebuff, upstr  ! for nf_ error message

* special equivalence (cannot include in tmap_format/xdset_info.cd_equiv 
* because "BYTE" isn't supported on DECstation)
* 10/96 reorder the if def because linux cpp didn't like it

#ifdef unix
#ifdef sun
      BYTE cd_data_type(maxvars)
#else
      INTEGER*1 cd_data_type(maxvars)
#endif
#else
      BYTE cd_data_type(maxvars)
#endif
      EQUIVALENCE ( ds_precision, cd_data_type )

* initialize
        cdfid = sf_lunit(dset)
        varid = rvar_varid
        dim_lo(1) = a_lo_x
        dim_lo(2) = a_lo_y
        dim_lo(3) = a_lo_z
        dim_lo(4) = a_lo_t
        dim_lo(5) = a_lo_e
        dim_lo(6) = a_lo_f
        dim_hi(1) = a_hi_x
        dim_hi(2) = a_hi_y
        dim_hi(3) = a_hi_z
        dim_hi(4) = a_hi_t
        dim_hi(5) = a_hi_e
        dim_hi(6) = a_hi_f
	permuted  = 0
	strided  = 0
        do_warn = .TRUE.

* check for error conditions
	DO 10 idim = 1, nferdims
	      IF ( use_lo(idim) .LT. grid_start(idim) .OR.
     .	        use_hi(idim) .GT. grid_end(idim) ) GOTO 5200
	      IF ( use_lo(idim) .GT. use_hi(idim)
     .       .OR.  use_lo(idim) .LT. dim_lo(idim)
     .       .OR.  use_hi(idim) .GT. dim_hi(idim) ) GOTO 5300
 10     CONTINUE
* summarize the axis permutation specification in ds_order

        lasdim = 0
	ndim = 0
        DO 20 idim = 1, nferdims
           IF ( grid_order(idim) .EQ. 0 ) GOTO 20
	   ndim = ndim + 1
           IF ( ABS(grid_order(idim)) .LE. lasdim )
     .          permuted = 1
           lasdim = ABS(grid_order(idim))
 20     CONTINUE

* ... compress the list of relevant axes into grid_dims
	DO 30 idim = 1, nferdims
	   trans(idim) = grid_order(idim)
	   grid_dims(idim) = trans(idim)
 30	CONTINUE

	IF ( trans(1) .EQ. 0 ) THEN
* ... trap for scalar (no dimension) netCDF variables
	   trans(1) = 1
	   grid_dims(1) = 1
	ENDIF
	DO 34 idim = 1, ndim
	   DO 32 idim2 = idim+1, ndim
	      IF (grid_dims(idim) .GT. grid_dims(idim2)) THEN
	         dim = grid_dims(idim)
	         grid_dims(idim ) = grid_dims(idim2)
	         grid_dims(idim2) = dim
	      ENDIF
 32	   CONTINUE
 34	CONTINUE

* check for an attempt to read into a sub-portion of a grid
* (fully supported in GT and TS libs but only partially supported here)
* it is supported if the sub-region is contiguous - i.e. the sub-limits
* are along the slowest axis of non-unity size
        DO 60 idim = 1, nferdims
           IF ( dim_lo(idim) .NE. use_lo(idim)
     .     .OR. dim_hi(idim) .NE. use_hi(idim) ) THEN
              DO 50 idim2 = idim+1, nferdims
 50           IF ( dim_lo(idim2) .NE. dim_hi(idim2) ) GOTO 5400
           ENDIF
 60     CONTINUE

* determine size from the low/hi limits requested
* and compute lower corner relative to the hyper slab in the  netCDF file
* skip unused dimensions resulting from NORMAL axes
        DO 100 idim = 1, ndim
           fildim = trans(idim)
	   memdim = grid_dims(idim)
           filsize(fildim) = use_hi(memdim) - use_lo(memdim) + 1
	   count(fildim)   = (filsize(fildim)-1)/stride(memdim) + 1
           start(fildim)   = use_lo(memdim) 
	   filstride(fildim) = stride(memdim)
           IF (stride(memdim) .GT. 1) strided = 1
 100    CONTINUE

*  compute the memory array size (for cases where strides are used)
*  note: transposed compared to filsize
* *kob* 7/00 - totsize calculation now takes striding into account
	totsize = 1
	DO 200 idim = 1, nferdims
	   memsize(idim) =  (use_hi(idim)-use_lo(idim))/stride(idim) + 1
	   totsize = totsize * memsize(idim)
 200	CONTINUE

* compute the map vector (for strides, reversals, and permutations)
	DO 210 idim = 1, nferdims
 210	imap(idim) = 0
* for netCDF V3 the imap array is set up in number of array elements, not bytes
	imap(trans(1)) = 1

	DO 220 idim = 2,ndim
	   imap(trans(idim)) = imap(trans(idim-1))
     .			     * (1 + (memsize(grid_dims(idim-1))-1))
 220	CONTINUE
* ... compress the gaps out of the map -- e.g. XYT ==> has a zero in imap(3)
*     and other arrays
	idim2 = 0
	DO 225 idim = 1, nferdims
	   IF (imap(idim) .EQ. 0) GOTO 225
	   idim2 = idim2 + 1
	   imap(idim2)      = imap(idim)
	   filsize(idim2)   = filsize(idim)
	   start(idim2)     = start(idim)
	   count(idim2)     = count(idim)
	   filstride(idim2) = filstride(idim)
 225	CONTINUE

* read the data

        already_scaled = .FALSE.
        status = merr_ok

        CALL CD_READ_SUB(cdfid, varid, ndim, start, count,
     .		filstride, imap,
     .		var(use_lo(1),
     .              use_lo(2),
     .              use_lo(3),
     .              use_lo(4),
     .              use_lo(5),
     .              use_lo(6)), permuted, strided, cdfstat)
        IF ( cdfstat .NE. NF_NOERR ) GOTO 5500

* Data from F-TDS data reads should not be scaled. If it were,
* handle that here...


* successful completion

	status = merr_ok
	RETURN

* error messages
 5100	CALL TM_ERRMSG
     .     ( cdfstat+pcdferr, status, 'CD_READ', cdfid,
     .       varid, 'Failed attempting READ', no_errstring, *5900 )

 5200   CONTINUE 
	CALL CD_GET_VAR_INFO (dset, varid, vname, vtype, nvdims,
     .          vdims, nvatts, coordvar, outflag, status)
	CALL TM_ERRMSG (merr_outofgrid, status, 'CD_READ_REMOTE',
     .     dset, no_stepfile, 'variable '//
     .     vname(:TM_LENSTR1(vname))//
     .     ' requested '//
     .	   dimnam(idim)//'='//TM_STRING(DBLE(use_lo(idim)))//'-'//
     .	   TM_STRING(DBLE(use_hi(idim))), no_errstring, *5900)

 5300	CALL TM_ERRMSG(merr_badsubscr, status, 'CD_READ',
     .     dset, no_stepfile, 'for requested '//dimnam(idim)//
     .     ' subscripts', no_errstring, *5900)

 5400	CALL TM_ERRMSG(merr_notsupport, status, 'CD_READ',
     .     dset, no_stepfile,
     .     'modulo or random access on netCDF mid-dimension: '//
     .     dimnam(idim), ' ', *5900)

 5500	IF ( status .EQ. -1 ) THEN
 
	   CALL TM_ERRMSG( cdfstat+pcdferr, status, 'CD_READ',
     .	             cdfid, varid,
     .		    'unable to allocate memory for doub. prec. read',
     .		     no_errstring, *5900 )
	ELSE
	
           IF (cdfstat .LT. NF_NOERR) THEN
	      err_status = merr_nc_open 
	      CALL CD_TRANSLATE_ERROR (cdfstat, ebuff)
           ELSE IF (cdfstat .EQ. nf_interrupt) THEN
	      err_status = merr_read_interrupt
      
	      CALL CD_GET_VAR_INFO (dset, varid, vname, vtype, nvdims,
     .          vdims, nvatts, coordvar, outflag, status)

	      ebuff = 'Reading variable '//vname(:TM_LENSTR1(vname))//
     .          ', interrupted from command line'
           ENDIF

           CALL TM_ERRMSG
     .     ( err_status, status, 'CD_REMOTE_READ', dset,
     .        no_stepfile, ebuff, no_errstring, *5900 )

	ENDIF

 5900	RETURN
	END

*
* pass_thru_string.F
*
* Ansley Manke
* 15-dec-2003
*
* This function sets the return to be equal
* to argument, which is a string array.
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE pass_thru_string_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

      CALL ef_version_test(ef_version)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     . 'Demo Function: sets result equal to input' )

      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)
      CALL ef_set_result_type(id, STRING_RETURN)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'this arg is passed through')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)
      CALL ef_set_arg_type (id, 1, STRING_ARG)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE pass_thru_string_compute(id, arg_1, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

	  INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result

! string arg and result need to be twice the length.
      REAL arg_1(2,mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL result(2,memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      i1 = arg_lo_ss(X_AXIS,ARG1)
      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               l1 = arg_lo_ss(T_AXIS,ARG1)
               DO 100 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

                  CALL EF_PUT_STRING_PTR(arg_1(1,i1,j1,k1,l1),
     .                                   result(1,i,j,k,l) )

                  l1 = l1 + arg_incr(T_AXIS,ARG1)
 100           CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 300     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
 400  CONTINUE
      
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	subroutine upcase (string,nc)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)upcase.F	1.1    3/10/88
C**
C**
C***********************************************************************        C**
C**                 EPIC
C**
C***********************************************************************        C**
C**
c
c  Converts the n characters in chrstr to upper case.
c
c	converts the string to upper case
C
c	STRING -- character*80, input string
C	nc -- length of string
C
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 

#ifdef unix
	CHARACTER STRING*(*),CHR(26)
	DATA CHR/'A','B','C','D','E','F','G','H','I',
     1	'J','K','L','M','N','O','P','Q','R','S','T',
     2	'U','V','W','X','Y','Z'/
	AA=ICHAR('a')
	DO 100 I=1,NC
	IF(STRING(I:I).GE.'a'.AND.STRING(I:I).LE.'z')THEN
	K=ICHAR(STRING(I:I))-AA+1
	STRING(I:I)=CHR(K)
	ENDIF
100	CONTINUE
#else
        character string(nc),temp
c
        do 200 i=1,nc
          istr = str$upcase (temp, string(i))
          string(i)=temp
200     continue
#endif
	RETURN
	END

*
* write_webrow_gwt.F
*
* Ansley Manke
* April 2009
*
* This function writes a special webrowset file for LAS
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE write_webrow_gwt_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg
      CHARACTER*100 descrip


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      WRITE (descrip, 100)
      CALL ef_set_desc(id, descrip)
  100 FORMAT ('Write a webrowset file with cruise numbers and IDs')

      CALL ef_set_num_args(id, 4)
      CALL ef_set_axis_inheritance(id,  ABSTRACT,
     .     NORMAL, NORMAL, NORMAL)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'id')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_type (id, arg, STRING_ARG)
      CALL ef_set_arg_desc(id, arg, 'Cruise IDs (string)')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'name')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_type (id, arg, STRING_ARG)
      CALL ef_set_arg_desc(id, arg, 'Cruise name (string)')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'Cruise_Mask')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'Mask =1 at start of each cruise')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
      
      arg = 4
      CALL ef_set_arg_name(id, arg, 'filename')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_type (id, arg, STRING_ARG)
      CALL ef_set_arg_desc(id, arg, 'Filename to write')
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END



      SUBROUTINE write_webrow_gwt_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER nx

      nx = 1
      call ef_set_axis_limits(id, X_AXIS, 1, nx)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE write_webrow_gwt_compute(id, arg_1, arg_2, arg_3, arg_4, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id, arg

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(2,mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(2,mem2lox:mem2hix, mem2loy:mem2hiy, 
     .           mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, 
     .           mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, 
     .           mem4loz:mem4hiz, mem4lot:mem4hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER slen, blen, iunit, icruise, nd
      INTEGER i1,j1,k1,l1, i2,j2,k2,l2
      CHARACTER*512 fname
      CHARACTER*100 errtxt
      CHARACTER*512 buff, buff_cname

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

C  Get file name

      arg = 4
      CALL ef_get_arg_string(id, arg, fname)

      iunit = 19

       OPEN( UNIT        = iunit,
     .       FILE        = fname,
     .       FORM        = 'FORMATTED',
     .       ACCESS      = 'SEQUENTIAL',
     .       STATUS      = 'REPLACE',
     .       ERR         = 5010 )

* Write webrowset header.

      buff = "<?xml version='1.0'?>"
      slen = 21
      WRITE (iunit, 1000) buff(1:slen)
 1000 FORMAT(A)
      buff = "<webRowSet>"
      slen = 99
      WRITE (iunit, 1000) buff(1:slen)

      WRITE (iunit, *) '<data>'

* Write cruise ids and numbers to the webrowset file...

      j1 = arg_lo_ss(Y_AXIS,ARG1)
      k1 = arg_lo_ss(Z_AXIS,ARG1)
      l1 = arg_lo_ss(T_AXIS,ARG1)
      i = res_lo_ss(X_AXIS)

* If the cruise_name is different from the cruise_id,
* write the cruise_name in parentheses after the ID.

      icruise = 0
      DO 100 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)
         IF (arg_3(i1,j1,k1,l1) .NE. bad_flag(ARG3)) THEN
            icruise = icruise + 1 
	    IF (icruise .LT. 10) 
     .	       WRITE (iunit, 1010) icruise
	    IF (icruise .GE. 10 .AND. icruise .LT. 100) 
     .	       WRITE (iunit, 1012) icruise
	    IF (icruise .GE. 100) 
     .	        WRITE (iunit, 1014) icruise
	    IF (icruise .GE. 1000) 
     .	        WRITE (iunit, 1015) icruise

            CALL EF_GET_STRING_ARG_ELEMENT(id, ARG1, arg_1,
     .                          i1,j1,k1,l1, slen, buff)
            CALL EF_GET_STRING_ARG_ELEMENT(id, ARG2, arg_2,
     .                          i1,j1,k1,l1, blen, buff_cname)
            IF (slen .EQ. blen) THEN
	       IF (buff(:slen) .EQ. buff_cname(:slen)) blen = 0
	    ENDIF
            IF (blen .GT. 0) THEN
	       buff(slen+1:slen+2) = ' ('
	       slen = slen + 2
	       buff(slen+1:slen+blen) = buff_cname(:blen)
	       slen = slen + blen
	       buff(slen+1:slen+1) = ')'
	       slen = slen + 1
	    ENDIF

            WRITE (iunit, 1020) buff(1:slen)
	 ENDIF
 100  CONTINUE

1010  FORMAT('<currentRow>'/'<columnValue>'/I1/'</columnValue>')
1012  FORMAT('<currentRow>'/'<columnValue>'/I2/'</columnValue>')
1014  FORMAT('<currentRow>'/'<columnValue>'/I3/'</columnValue>')
1015  FORMAT('<currentRow>'/'<columnValue>'/I4/'</columnValue>')
1020  FORMAT('<columnValue>'/A/'</columnValue>'/'</currentRow>')

* Write closing tag.
      WRITE (iunit, 1030) 
1030  FORMAT ('</data>'/'</webRowSet>')

      CLOSE (iunit, ERR = 5020 )
      i = res_lo_ss(X_AXIS)
      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Y_AXIS)
      l = res_lo_ss(Y_AXIS)
      result(i,j,k,l) = 1.

      RETURN 

5010  CONTINUE
      WRITE(errtxt,*) 'Error opening file ', fname
      CALL EF_BAIL_OUT(id, errtxt)
      RETURN
5020  CONTINUE
      WRITE(errtxt,*) 'Error closing file ', fname
      CALL EF_BAIL_OUT(id, errtxt)
      RETURN

      END

	SUBROUTINE  VEL_DIF_Z (	cdz  , mcdz  ,
     .				u    , mu    ,
     .				ubwi , mubwi  ,
     .				udfz , mudfz    )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute vertical diffusion of velocity components
* add wind stress effects if at surface
* note: the identical code applies to both U and V

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 -1/23/87 extracted from SUBROUTINE CLINIC
*			with major modifications to convert i-k oriented
*			calculations to i-j oriented calculations
* revision 0.1 - 6/25/87 - added wind stress contribution at surface
* V200:  7/27/89 - 4D symmetrical version
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN
*	 3/13/90 - fixed bug at k.eq.km

#ifdef unix
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl.parm'		! parameter definitions
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xonedim.cmn'	! geometric constants
	include 'xcontext.cmn'
#else
	INCLUDE 'FERRET_CMN:FERRET.PARM'
	INCLUDE 'FERRET_CMN:GFDL.PARM'		! parameter definitions
	INCLUDE	'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE	'FERRET_CMN:XMEM_SUBSC.CMN'
	INCLUDE 'FERRET_CMN:XONEDIM.CMN'	! geometric constants
	INCLUDE 'FERRET_CMN:XCONTEXT.CMN'
#endif

* calling argument declarations:
	INTEGER	mcdz, mu, mubwi, mudfz

* subscript ranges from memory variable table ...
	REAL     cdz( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit ),
     .		   u( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,m2lot:m2hit ),
     .		ubwi( m3lox:m3hix,m3loy:m3hiy,            m3lot:m3hit ),
     .		udfz( m4lox:m4hix,m4loy:m4hiy,m4loz:m4hiz,m4lot:m4hit )

* internal variable declarations:
	LOGICAL HOURLY_DATA, need_wind
	INTEGER	i_lo, i_hi, j_lo, j_hi, i, j, k, l, dl, lp1
	REAL	bad_u, bad_cdz, bad_ubwi, up, down

* --- end of introductory code ---
* use 1 hour separation for exact results on hourly data
	IF ( HOURLY_DATA(mr_grid(mudfz)) ) THEN
	   dl = 1
	ELSE
	   dl = 0
	ENDIF

* limits for calculation
	i_lo = mr_lo_s1(mudfz)
	i_hi = mr_hi_s1(mudfz)
	j_lo = mr_lo_s2(mudfz)
	j_hi = mr_hi_s2(mudfz)

* flag for bad/missing data
	bad_u    = mr_bad_data( mu )
	bad_cdz  = mr_bad_data( mcdz )
	bad_ubwi = mr_bad_data( mubwi )

* ***************************************************************
* ORIGINAL GFDL 205 CODE UPON WHICH CALCULATION IS BASED
*
* 261       DO 280 K=1,KM
* 262       DO 280 I=1,IMT
* 263       UDIF(I,K)=UB(I,K)
* 264       VDIF(I,K)=VB(I,K)
* 265  280  CONTINUE

* 276       DO 295 I=1,IMT
* 277       KZ=KMU(I)
* 278       UDIF(I,KZ+1)=UB(I,KZ)
* 279       VDIF(I,KZ+1)=VB(I,KZ)
* 280  295  CONTINUE

* 352 C   ADD IN VERTICAL ADVECTION AND VERTICAL DIFFUSION

* 362       DO 345 K=1,KMP1
* 363       DO 345 I=1,IMT
* 364       TEMP2D(I,K)=UDIF(I,K-1)-UDIF(I,K)
* 365  345  CONTINUE
* 366       DO 348 K=1,KM
* 367       DO 348 I=1,IMT
* 368       UA(I,K)=UA(I,K)+EEM2D(I,K)*VVC(I,K-1)*TEMP2D(I,K)-
* 369      * FFM2D(I,K)*VVC(I,K)*TEMP2D(I,K+1)
* 370  348  CONTINUE

* 378       DO 355 K=1,KMP1
* 379       DO 355 I=1,IMT
* 380       TEMP2D(I,K)=VDIF(I,K-1)-VDIF(I,K)
* 381  355  CONTINUE
* 382       DO 356 K=1,KM
* 383       DO 356 I=1,IMT
* 384       VA(I,K)=VA(I,K)+EEM2D(I,K)*VVC(I,K-1)*TEMP2D(I,K)-
* 385      * FFM2D(I,K)*VVC(I,K)*TEMP2D(I,K+1)
* 386  356  CONTINUE
*************************************************************************
	DO 2000 l = mr_lo_s4(mudfz)-dl, mr_hi_s4(mudfz)-dl
	   lp1 = l + dl
	DO 2000 k = mr_lo_s3(mudfz), mr_hi_s3(mudfz)

* flag for surface wind effects
	need_wind = k .EQ. 1

	DO 345 j = j_lo, j_hi
	DO 345 i = i_lo, i_hi

	   IF (   u(i,j,k,l) .EQ. bad_u
     .	    .OR.cdz(i,j,k,l) .EQ. bad_cdz ) THEN
	       udfz(i,j,k,lp1) = bad_val4
	      GOTO 345
	   ENDIF

	   IF ( k .GT. 1 ) THEN
	      up = eem(k) * cdz(i,j,k-1,l) * ( u(i,j,k-1,l) - u(i,j,k,l) )
	   ELSE
	      up = 0.0
	   ENDIF

	   IF ( k .LT. km ) THEN
	      down = ffm(k) * cdz(i,j,k,l) * ( u(i,j,k,l) - u(i,j,k+1,l) )
	   ELSE
	      down = 0.0
	   ENDIF

	   udfz(i,j,k,lp1) = ( up - down ) * cmonthly

* add wind ?
	   IF ( need_wind ) THEN
	      IF ( ubwi(i,j,l) .EQ. bad_ubwi ) THEN
	         udfz(i,j,1,lp1) = bad_val4
	      ELSE
	         udfz(i,j,1,lp1) = udfz(i,j,1,lp1) + ubwi(i,j,l)
	      ENDIF
	   ENDIF

 345	CONTINUE
 2000	CONTINUE
	RETURN
	END

	SUBROUTINE CD_SET_MODE(cdfid, mode, status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Set the netCDF mode to DATA or DEFINE
* but first check to see if it is already in the desired mode

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 10/92
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* argument definitions:
*       cdfid   - returned pointer to open CDF file
*       mode    - parameter value from cdf_tmap.parm
*	status	- return status

* argument declarations:
	INTEGER	 cdfid, mode, status

* include files
        include 'netcdf.inc'
        include 'cdf_tmap.parm'
        include 'tmap_errors.parm'

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

* local variable declarations:
      INTEGER cdf_mode, cdfstat

* must be remembered between calls
      SAVE cdf_mode

      IF ( mode .EQ. cdf_mode ) THEN
         status = merr_ok
         RETURN      ! no change requested
      ELSEIF ( mode .EQ. pcd_mode_define ) THEN
* ... enter define mode
         cdfstat = NF_REDEF( cdfid )
         IF ( cdfstat .NE. NF_NOERR ) GOTO 5100
      ELSEIF ( mode .EQ. pcd_mode_data ) THEN
* ... enter data mode
         cdfstat = NF_ENDDEF( cdfid )
         IF ( cdfstat .NE. NF_NOERR ) GOTO 5100
      ENDIF

* save the specified mode (the only action taken when mode < 0)
      cdf_mode = ABS( mode ) 

* successful completion
      status = merr_ok
      RETURN

* error messages
 5100 CALL TM_ERRMSG
     .     ( cdfstat+pcdferr, status, 'CD_SET_MODE', cdfid,
     .     no_varid, 'could not change CDF mode', ' ', *5000 )

* error exit
 5000 RETURN
	END

      SUBROUTINE TM_YMD_TIME_CONVRT( yymmdd,
     .                               mon, day, yr, hr, min, sec)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* decode a double precision yyyymmddhhmmss into its component parts

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 2/95  -- specifically for accessing CDC files

* argument definitions:
*	yymmdd	 - double precision input
*       mon, day, yr, hr, min, sec  - pieces of time !!

* argument declarations
      INTEGER mon, day, yr, hr, min, sec
      REAL*8  yymmdd

* internal variable declarations
      INTEGER itmp, ymd, hms

* split off the hhmmss fields
      ymd = yymmdd/1000000		!yyyymmdd
      hms = yymmdd - ymd*1000000.D0	!hhmmss

      itmp = hms/100
      sec  = hms - 100*itmp
      hr   = itmp/100
      min  = itmp - 100*hr

      itmp = ymd/100
      day  = ymd - 100*itmp
      yr   = itmp/100
      mon  = itmp - 100*yr

* CDC uses a climatological month like "100000000" for January
* here we shift the day=0 to day=15, arbitrarily
      IF (day .EQ. 0) day = 15

* to avoid the damn nit-picky stuff about negative times we will encode
* the climatological dates as year 1
      IF ( yr .EQ. 0 ) yr = 1


      RETURN	
      END

	BLOCK DATA XMACHINE_DATA

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* variables to assist with the conversion of binary representations
* between differing cpu types
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* SUN port - 1/30/92 -kob-  use xmachine.cmn on SUN because it understands BYTE
*                             and use xmachine.cmn_text for DECstation because
*                             because it understands INTEGER*1
* replaced "elif" syntax with
*	else
*	   if
*  for SGI port	 - kob 4/8/92
* *kob* 10/96   - Linux port.  Linux didn't like tabs between "include"
*                 and what was being included.  removed themy

* revision 0.00 - 03/25/91
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

#ifdef sun
        include 'xmachine_byte.cmn'
#else
                include 'xmachine_int1.cmn'
#endif

#ifdef sun
        DATA    active_cpu  /cptype_sun/    
#else
#	if unix
        	DATA	active_cpu  /cptype_dec/   ! DECstation
#	else
        	DATA    active_cpu  /cptype_vax/   ! VAX
#	endif
#endif

	END

*
*  scat2gridgauss_xy
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE.
*
* Ansley Manke
* July 28 1998
*  revised 2/00 to use work arrays
* June 2000 ACM pass 4 gridding arguments:  y and z radius of influence,
*               and cutoff.
*
* Nov 13, 2000 1) Allow modulo axes: if modulo take points from other end
*                 to use in gridding each end
*              2) Check that the scattered points are listed on the I,J,or
*                 K axis only, as they may be functions of time.
*  (12/1/2000) 3) If the destination axis is modulo, treat the scattered
*                 points as modulo too.
*
*   12/7/2000  Add error checking on gridding parameters
*              X and Y scattered points are 1-D lists on any axis.
*
*    5/2001    Let variable,  be a function of Z and/or T
* v5.41 5/02   Fix bug (typo); Gridding to modulo X axis wasnt done.

*  11/12/2002  Remove option 2) above: the spatial location of the scattered points
*              is a 1-D list.

* Returns variable interpolated onto an equally-spaced X-Y grid.
* Input is scattered triples: (x, y, variable) , f may be function of time, z
* Output is gridded data in x, y and time.  Calls routine "gausswt2".
*

*
* In this subroutine we provide information about
* the function.  The user configurable information
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
*
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result
*


      SUBROUTINE  scat2gridgauss_xy_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id, 'Use Gaussian weighting to grid ' //
     .                     'scattered data to an XY grid.')
      CALL ef_set_num_args(id, 9)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 4)

* XY grid is determined by arguments 4 and 5, the result's x and y axes.

      arg = 1
      CALL ef_set_arg_name(id, arg, 'XPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'X coordinates of scattered XY locations')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'YPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'Y coordinates of scattered XY locations')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'F')
      CALL ef_set_arg_desc(id, arg,
     .        'variable at scattered XY locations. ' //
     .        'May also be fcn of Z,T,E,F')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, YES, YES, YES, YES)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'XAXPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'X axis coordinates of a regular output grid')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, NO, NO, NO, NO, NO)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'YAXPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'Y axis coordinates of a regular output grid')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, YES, NO, NO, NO, NO)

      arg = 6
      CALL ef_set_arg_name(id, arg, 'XSCALE')
      CALL ef_set_arg_desc(id, arg,
     .  'Mapping scale in X direction, in data units (e.g. km or lon)')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 7
      CALL ef_set_arg_name(id, arg, 'YSCALE')
      CALL ef_set_arg_desc(id, arg,
     .  'Mapping scale in Y direction, in data units (e.g. km or lat)')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 8
      CALL ef_set_arg_name(id, arg, 'CUTOFF')
      CALL ef_set_arg_desc(id, arg,
     .        'Weight cutoff: use pts within cutoff*scale')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 9
      CALL ef_set_arg_name(id, arg, '0')
      CALL ef_set_arg_desc(id, arg,
     .        'Not used; included for backwards compatibility')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE scat2gridgauss_xy_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER nxout, nyout, nx2, ny2

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nxout = 1 + arg_hi_ss(X_AXIS,ARG4) - arg_lo_ss(X_AXIS,ARG4)
      nyout = 1 + arg_hi_ss(Y_AXIS,ARG5) - arg_lo_ss(Y_AXIS,ARG5)

      nx2 = nxout * 2
      ny2 = nyout * 2

* xax  output x axis
      CALL ef_set_work_array_dims_6d(id, 1,
     .                                1, 1, 1, 1, 1, 1,
     .                              nx2, 1, 1, 1, 1, 1)

* yax  output y axis
      CALL ef_set_work_array_dims_6d(id, 2,
     .                                1, 1, 1, 1, 1, 1,
     .                              ny2, 1, 1, 1, 1, 1)

* grid  work array - gridded data.
      CALL ef_set_work_array_dims_6d(id, 3,
     .                                1,     1, 1, 1, 1, 1,
     .                            nxout, nyout, 1, 1, 1, 1)

* wate - weights.
      CALL ef_set_work_array_dims_6d(id, 4,
     .                                1,     1, 1, 1, 1, 1,
     .                            nxout, nyout, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*

      SUBROUTINE scat2gridgauss_xy_compute(id, arg_1, arg_2, arg_3,
     .                           arg_4, arg_5, arg_6, arg_7, arg_8,
     .                           arg_9, result, xax, yax, grid, wate)

*  arg_1  xpts \
*  arg_2  ypts  > Scattered x,y,variable,  triples to be gridded.
*  arg_3  variable, /    variable, can be fcn of z, t, e, f
*  arg_4  xaxis of new grid
*  arg_5  yaxis of new grid
*  arg_6  interpolation parameter   xscale
*  arg_7  interpolation parameter   yscale
*  arg_8  interpolation parameter   cutoff
*  arg_9  not used

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz,
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz,
     .           mem4lot:mem4hit, mem4loe:mem4hie, mem4lof:mem4hif)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz,
     .           mem5lot:mem5hit, mem5loe:mem5hie, mem5lof:mem5hif)
      REAL arg_6(mem6lox:mem6hix, mem6loy:mem6hiy, mem6loz:mem6hiz,
     .           mem6lot:mem6hit, mem6loe:mem6hie, mem6lof:mem6hif)
      REAL arg_7(mem7lox:mem7hix, mem7loy:mem7hiy, mem7loz:mem7hiz,
     .           mem7lot:mem7hit, mem7loe:mem7hie, mem7lof:mem7hif)
      REAL arg_8(mem8lox:mem8hix, mem8loy:mem8hiy, mem8loz:mem8hiz,
     .           mem8lot:mem8hit, mem8loe:mem8hie, mem8lof:mem8hif)
      REAL arg_9(mem9lox:mem9hix, mem9loy:mem9hiy, mem9loz:mem9hiz,
     .           mem9lot:mem9hit, mem9loe:mem9hie, mem9lof:mem9hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* Ignore the unused final dimensions in the work arrays since
* Fortran is column major
      REAL*8 xax(wrk1lox:wrk1hix/2)
      REAL*8 yax(wrk2lox:wrk2hix/2)
      REAL grid(wrk3lox:wrk3hix, wrk3loy:wrk3hiy)
      REAL wate(wrk4lox:wrk4hix, wrk4loy:wrk4hiy)

* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable''s axes.

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l, m, n
      INTEGER idx, lo_ss, hi_ss
      INTEGER nxpts, nypts, nscat
      INTEGER nx, ny, nt
      INTEGER i3, j3, k3, l3, m3, n3
      INTEGER xlo, xhi, ylo, yhi
      REAL x1, y1, t1, xf, yf, tf
      REAL xx, yy, tt
      REAL xsc, ysc, tsc
      REAL cutoff
      REAL val
      REAL dx, dy, xcut, ycut, xxbeg, xxend, yybeg, yyend
      INTEGER iwflag
      CHARACTER*250 errtxt

C  variables for checking axis characteristics (modulo axes)
      CHARACTER ax_name(6)*16, ax_units(6)*16
      LOGICAL backward(6), mdulo(6), regular(6)
      LOGICAL modulox, moduloy
      REAL*8 modxlen, modylen

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*  Check to see if output axes are regular, and get modulo characteristics
      CALL ef_get_axis_info_6d(id, ARG4, ax_name, ax_units,
     .                         backward, mdulo, regular)
      IF ( .NOT. regular(X_AXIS) ) THEN
         errtxt = 'Output axes must be REGULARLY spaced'
         GOTO 999
      ENDIF
      modulox = mdulo(X_AXIS)
      IF ( modulox ) THEN
         CALL ef_get_axis_modulo_len(id, ARG4, X_AXIS, modxlen)
      ENDIF

      CALL ef_get_axis_info_6d(id, ARG5, ax_name, ax_units,
     .                         backward, mdulo, regular)
      IF ( .NOT. regular(Y_AXIS) ) THEN
         errtxt = 'Output axes must be REGULARLY spaced'
         GOTO 999
      ENDIF
      moduloy = mdulo(Y_AXIS)
      IF ( moduloy ) THEN
         CALL ef_get_axis_modulo_len(id, ARG5, Y_AXIS, modylen)
      ENDIF

*  Find number of points in scattered input points.  1-D arrays defining the
*  scattered data points may lie on the X, Y, Z, T, E, or F axis of the input
*  arguments.
*  Using as flattened arrays, so consider all axes.

      nxpts = 0
      DO 10 idx = X_AXIS, F_AXIS
         lo_ss = arg_lo_ss(idx,ARG1)
         hi_ss = arg_hi_ss(idx,ARG1)
         IF ( lo_ss .NE. ef_unspecified_int4 ) THEN
            IF ( nxpts .NE. 0 ) THEN
               nxpts = nxpts * (hi_ss - lo_ss + 1)
            ELSE
               nxpts = hi_ss - lo_ss + 1
            ENDIF
         ENDIF
  10  CONTINUE

      nypts = 0
      DO 20 idx = X_AXIS, F_AXIS
         lo_ss = arg_lo_ss(idx,ARG2)
         hi_ss = arg_hi_ss(idx,ARG2)
         IF ( lo_ss .NE. ef_unspecified_int4 ) THEN
            IF ( nypts .NE. 0 ) THEN
               nypts = nypts * (hi_ss - lo_ss + 1)
            ELSE
               nypts = hi_ss - lo_ss + 1
            ENDIF
         ENDIF
  20  CONTINUE

      IF ( nxpts .NE. nypts ) THEN
         WRITE (errtxt,90) ' XPTS,', ' YPTS ', nxpts, nypts
         GOTO 999
      ENDIF

* Verify the number of values given in ARG3 makes sense
      xlo = arg_lo_ss(X_AXIS,ARG3)
      xhi = arg_hi_ss(X_AXIS,ARG3)
      ylo = arg_lo_ss(Y_AXIS,ARG3)
      yhi = arg_hi_ss(Y_AXIS,ARG3)

      IF ( (xhi .GT. xlo) .AND. (yhi .GT. ylo) ) THEN
         errtxt = 'F() data values defined on both X and Y axis'
         GOTO 999
      ELSE IF ( xhi .GT. xlo ) THEN
         nscat = xhi - xlo + 1
         IF ( nxpts .NE. nscat ) THEN
            WRITE (errtxt,90) ' XPTS,', ' F(X) ', nxpts, nscat
            GOTO 999
         ENDIF
      ELSE IF ( yhi .GT. ylo ) THEN
         nscat = yhi - ylo + 1
         IF ( nxpts .NE. nscat ) THEN
            WRITE (errtxt,90) ' XPTS,', ' F(Y) ', nxpts, nscat
            GOTO 999
         ENDIF
      ELSE IF ( (xlo .NE. ef_unspecified_int4) .OR.
     .          (ylo .NE. ef_unspecified_int4) ) THEN
         nscat = 1
         IF ( nxpts .NE. nscat ) THEN
            WRITE (errtxt,90) ' XPTS,', ' F()  ', nxpts, nscat
            GOTO 999
         ENDIF
      ELSE
         errtxt = 'No data in scattered x, y points.  ' //
     .            'F() data values must be defined on X or Y axis.'
         GOTO 999
      ENDIF
  90  FORMAT('Input scattered', 2A6, 'have different # of points', 2I8)

*  Compute number of points in output axes.

      lo_ss = arg_lo_ss(X_AXIS,ARG4)
      hi_ss = arg_hi_ss(X_AXIS,ARG4)
*  Check that xax is an X axis
      IF ( lo_ss .EQ. ef_unspecified_int4 ) THEN
         errtxt = 'Fourth argument must be an X axis'
         GO TO 999
      ENDIF
      nx = hi_ss - lo_ss + 1

      lo_ss = arg_lo_ss(Y_AXIS,ARG5)
      hi_ss = arg_hi_ss(Y_AXIS,ARG5)
*  Check that yax a Y axis
      IF ( lo_ss .EQ. ef_unspecified_int4 ) THEN
         errtxt = 'Fifth argument must be a Y axis'
         GO TO 999
      ENDIF
      ny = hi_ss - lo_ss + 1

C  Get coordinates of output axes.

      CALL ef_get_coordinates(id, ARG4, X_AXIS, arg_lo_ss(X_AXIS, ARG4),
     .                        arg_hi_ss(X_AXIS, ARG4), xax)

      CALL ef_get_coordinates(id, ARG5, Y_AXIS, arg_lo_ss(Y_AXIS, ARG5),
     .                        arg_hi_ss(Y_AXIS, ARG5), yax)

*  Set start and end for output axes.

      x1 = xax(1)
      y1 = yax(1)

      xf = xax(nx)
      yf = yax(ny)

*  Time parameters for subroutine gausswt.  Calling with 1 time.

      nt = 1
      tt = 1.
      t1 = 1.
      tf = 1.
      tsc = 1.

*  iwflag=1 for time wrapping; 0 for no wrapping

      iwflag = 0

*  Get interpolation parameters: mapping scales (data units)

      xsc = arg_6(arg_lo_ss(X_AXIS,ARG6), arg_lo_ss(Y_AXIS,ARG6),
     .            arg_lo_ss(Z_AXIS,ARG6), arg_lo_ss(T_AXIS,ARG6),
     .            arg_lo_ss(E_AXIS,ARG6), arg_lo_ss(F_AXIS,ARG6))
      IF ( xsc .LE. 0. ) THEN
         errtxt = 'X mapping scale parameter must be positive'
         GOTO 999
      ENDIF

      ysc = arg_7(arg_lo_ss(X_AXIS,ARG7), arg_lo_ss(Y_AXIS,ARG7),
     .            arg_lo_ss(Z_AXIS,ARG7), arg_lo_ss(T_AXIS,ARG7),
     .            arg_lo_ss(E_AXIS,ARG7), arg_lo_ss(F_AXIS,ARG7))
      IF ( tsc .LE. 0. ) THEN
         errtxt = 'Y mapping scale parameter must be positive'
         GOTO 999
      ENDIF

*  And cutoff parameter:

      cutoff = arg_8(arg_lo_ss(X_AXIS,ARG8), arg_lo_ss(Y_AXIS,ARG8),
     .               arg_lo_ss(Z_AXIS,ARG8), arg_lo_ss(T_AXIS,ARG8),
     .               arg_lo_ss(E_AXIS,ARG8), arg_lo_ss(F_AXIS,ARG8))

      IF ( cutoff .LE. 0. ) THEN
         errtxt = 'Cutoff parameter must be positive'
         GOTO 999
      ENDIF

*  Compute result at each Z, T, E, F

      n3 = arg_lo_ss(F_AXIS,ARG3)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

      m3 = arg_lo_ss(E_AXIS,ARG3)
      DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

      l3 = arg_lo_ss(T_AXIS,ARG3)
      DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

      k3 = arg_lo_ss(Z_AXIS,ARG3)
      DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

*  Initialize sums of values and weights.

         DO j3 = 1, ny
            DO i3 = 1, nx
               grid(i3,j3) = 0.
            ENDDO
         ENDDO

         DO j3 = 1, ny
            DO i3 = 1, nx
               wate(i3,j3) = 0.
            ENDDO
         ENDDO

*  Loop over x and y, compute the weighted sums for gaussian-weighted mapping
*  onto the grid.  Args 1-2 may be on the X,Y,Z,T,E or F axis of ARG1 and
*  ARG2, sending them to a subroutine collapses the extra dimensions so the
*  value can be found.

         DO 700 idx = 1, nscat

            CALL pickout2(arg_1, arg_2, idx, xx, yy)
            IF ( xhi .GT. xlo ) THEN
               i3 = xlo + idx - 1
               j3 = ylo
            ELSE
               i3 = xlo
               j3 = ylo + idx - 1
            ENDIF
            val = arg_3(i3,j3,k3,l3,m3,n3)

            IF (  xx .EQ. bad_flag(ARG1) .OR.
     .            yy .EQ. bad_flag(ARG2) .OR.
     .           val .EQ. bad_flag(ARG3) ) GOTO 700

*  If an output axis is modulo, apply modulo adjustment to that coordinate
*  of the scattered point.
            IF ( modulox ) THEN
               CALL modscat(xax(1), xax(nx), modxlen, 1, xx)
            ENDIF
            IF ( moduloy ) THEN
               CALL modscat(yax(1), yax(ny), modylen, 1, yy)
            ENDIF

            CALL gausswt2(xx, yy, tt, val, grid, wate, nx,
     .                    ny, nt, x1, y1, t1, xf, yf, tf, xsc,
     .                    ysc, tsc, cutoff, iwflag, nx, ny)

C ACM modulo 11/9/00  Put points within cutoff of the end just beyond the
C                     other end, and use in the gridding computation.

            IF ( modulox ) THEN
               dx = xf - x1
               IF (nx .GT. 1) dx = (xf-x1)/real(nx-1)  ! gridbox size in data units
               xcut = cutoff*xsc/dx                    ! cutoff scaled to grid units

               IF ( (xx-x1 .GE. 0.) .AND. (xx-x1 .LT. xcut) ) THEN
                  xxend = xf + (xx-x1)
                  CALL gausswt2(xxend, yy, tt, val, grid, wate, nx,
     .                          ny, nt, x1, y1, t1, xf, yf, tf, xsc,
     .                          ysc, tsc, cutoff, iwflag, nx, ny)
               ENDIF

               IF ( (xf-xx .GE. 0.) .AND. (xf-xx .LT. xcut) ) THEN
                  xxbeg = x1 - (xf-xx)
                  CALL gausswt2(xxbeg, yy, tt, val, grid, wate, nx,
     .                          ny, nt, x1, y1, t1, xf, yf, tf, xsc,
     .                          ysc, tsc, cutoff, iwflag, nx, ny)
               ENDIF
            ENDIF

            IF ( moduloy ) THEN
               dy = yf - y1
               IF (ny .GT. 1) dy = (yf-y1)/real(ny-1)  ! gridbox size in data units
               ycut = cutoff*ysc/dy                    ! cutoff scaled to grid units

               IF ( (yy-y1 .GE. 0.) .AND. (yy-y1 .LT. ycut) ) THEN
                  yyend = yf + (yy-y1)
                  CALL gausswt2(xx, yyend, tt, val, grid, wate, nx,
     .                          ny, nt, x1, y1, t1, xf, yf, tf, xsc,
     .                          ysc, tsc, cutoff, iwflag, nx, ny)
               ENDIF

               IF ( (yf-yy .LT. 0.) .AND. (yf-yy .LT. ycut) ) THEN
                  yybeg = y1 - (yf-yy)
                  CALL gausswt2(xx, yybeg, tt, val, grid, wate, nx,
     .                          ny, nt, x1, y1, t1, xf, yf, tf, xsc,
     .                          ysc, tsc, cutoff, iwflag, nx, ny)
               ENDIF
            ENDIF

 700     CONTINUE

*  Put gridded fcn into result variable, dividing by summed weights. (as in
*  gaussfin, but indices needn't start at 1)

         j3 = 1
         DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            i3 = 1
            DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

               IF ( wate(i3,j3) .GT. 0. ) THEN
                  result(i,j,k,l,m,n) = grid(i3,j3) / wate(i3,j3)
               ELSE
                  result(i,j,k,l,m,n) = bad_flag_result
               ENDIF

               i3 = i3 + 1
 100        CONTINUE

            j3 = j3 + 1
 200     CONTINUE

         k3 = k3 + arg_incr(Z_AXIS,ARG3)
 300  CONTINUE

         l3 = l3 + arg_incr(T_AXIS,ARG3)
 400  CONTINUE

         m3 = m3 + arg_incr(E_AXIS,ARG3)
 500  CONTINUE

         n3 = n3 + arg_incr(F_AXIS,ARG3)
 600  CONTINUE

      RETURN

 999  CALL EF_BAIL_OUT(id, errtxt)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN
      END

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
c*
c* This returns the name, title and units associated with
c* each axis of an argument.
c*
* 4D subroutine version which calls the 6D subroutine version and
* checks the E and F dimensions are unused
*

      SUBROUTINE EF_GET_AXIS_INFO(id, iarg, name, units,
     .                            backward, modulo, regular)

      IMPLICIT NONE
      INCLUDE 'tmap_dims.parm'

* argument declarations - 4D
      INTEGER id, iarg
      CHARACTER*(*) name(4), units(4)
      LOGICAL backward(4), modulo(4), regular(4)

* local variables
      CHARACTER*32  name_6d(nferdims), units_6d(nferdims)
      LOGICAL       backward_6d(nferdims), modulo_6d(nferdims),
     .              regular_6d(nferdims)
      INTEGER       ndx
      CHARACTER*128 buff

* call the 6D version
      CALL EF_GET_AXIS_INFO_6D(id, iarg, name_6d, units_6d,
     .                         backward_6d, modulo_6d, regular_6d)

* check E and F are unused
      DO 100 ndx = 5, nferdims
         IF ( (name_6d(ndx) .NE. 'unknown') .AND.
     .        (name_6d(ndx) .NE. 'normal') ) THEN
            WRITE (buff,50) ndx
 50         FORMAT ('Dimension ', I1,
     .              ' is used; use EF_GET_AXIS_INFO_6D instead')
            CALL EF_BAIL_OUT(id, buff)
            STOP 'EF_BAIL_OUT returned in EF_GET_AXIS_INFO'
         ENDIF
 100  CONTINUE

* copy to the 4D arrays
      DO 200 ndx = 1, 4
         name(ndx)     = name_6d(ndx)
         units(ndx)    = units_6d(ndx)
         backward(ndx) = backward_6d(ndx)
         modulo(ndx)   = modulo_6d(ndx)
         regular(ndx)  = regular_6d(ndx)
 200  CONTINUE

      RETURN 
      END

	SUBROUTINE INIT_MEMORY (vmem_size_arg)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* initialize memory management linked lists, etc.

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 7/21/88
* revision 0.1 - 8/15/88 - only initialize to max_mrs-1 - top is dummy
* revision 0.2 -11/22/88 - new TM IO library eliminating nblks_for_lines
* V200:  6/12/89 - initialize back link of memory regions
* V312:  5/19/94 - changes for reconfigurable (dynamic) memory
* V420: initialize the no-cache memory hash pointer
* V500: 4/99 *sh* - set mode desperate while we're at it
* V510: 2/00 *sh* initialize additional new hash piles
* V606: 8/07 *acm* Set a symbol with the current memory setting
* V62   5/09 *acm*- make FERRET_MEMORY a special symbol (remove 
*                 code defining it from this routine)
* V702: 1/17 *sh* for trac enhancement #2369 -- dynamic memory management 
*                - perform initial sanity check
* V72 : 5/17 *acm* rmem_size comes in as-is; handle it as in xeq_set for a 
*                  SET MEM/SIZ=

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'

* calling argument declarations:
	REAL vmem_size_arg

* internal variable declarations
	INTEGER	bigblk, mv, ws
        INTEGER i1, i2, len
	INTEGER*8 i8_val

* LINKS IN MEMORY VARIABLE TABLE
* ... all hash pile start pointers point to self (empty lists)
	DO 100 mv = pmv_lowest_head, -1
	   mv_flink(mv) = mv
	   mv_blink(mv) = mv
 100	CONTINUE
* ... free list (pointer at subscript 0) contains all table slots
	DO 110 mv = 0, max_mr_avail
	   mv_flink(mv) = mv + 1
	   mv_blink(mv) = unspecified_int4   ! bck link not used in free list
 110	CONTINUE
	mv_flink(max_mr_avail) = 0	     ! make list circular

* set MODE DESPERATE to 1/10 of full memory size
* the reason so small is that Ferret memory management is not aware of
* large hierarchies of definitions -- so a command like "LIST var"
* may involve far more data than the transformations of "var" alone
* 6/19: mode despearate is not used as of v7.2

c	mode_arg(pmode_desperate,1) = 0.1 *  pmax_mem_default

* initialize malloced dynamic memory management variables  (2/2017)
        DO mv = 1, max_mrs
           CALL NULLIFY_MR(mv)
           mr_size(mv) = 0
        ENDDO
        DO ws = 1, max_ws
           CALL NULLIFY_WS(ws)
           ws_size(ws) = 0
        ENDDO

* SET MEMORY limit default
* -memsize command-line argument passed in, handle as in xeq_set

	IF (vmem_size_arg .NE. 0.) THEN 
	   i8_val = (vmem_size_arg*1.0000000001D0) * 1000000  ! int tuncation issues ...
	   max_mem_allowed = i8_val 
	ELSE
	   max_mem_allowed = pmax_mem_default
	ENDIF

* accounting variables (see xvariables.cmn)
        total_mem = 0
        peak_mem = 0
        peak_essential_mem = 0
	need_memlim_warning = .TRUE.
	permanent_mem = 0
	essential_mem = 0

* sanity check
#ifndef NDEBUG
        CALL SANITY_CHECK_MEMORY("init_memory")
#endif

	RETURN
	END

	LOGICAL FUNCTION TM_ITSA_MODEL_RUN(name, source, expnum)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Determine if a particular data set represents a TMAP model run based on its
* name, only.

* Steve Hankin  NOAA/PMEL/TMAP

* 9/13/95 for Ferret version 4.2
* *kob* 10/96 - Linux port - changed function type from integer to
*                            logical
* Include files

* Argument definitions
	CHARACTER*(*) name, source, expnum

* Local definitions
	LOGICAL	TM_DIGIT
	INTEGER slen, ii, iiout
	CHARACTER*3 expdig

* initialize
	slen = LEN(name)

* name long enough to try decoding ("mtsa001" is minimal)?
	IF ( slen .LT. 7 ) GOTO 1000

* must start with "mt" or "mc"
	IF ( name(1:2).NE.'mt'
     . .AND. name(1:2).NE.'mc' ) GOTO 1000

* skip 1 character following "mt" and then look for a non-digit.
* (this kludge will work for "mtsa001" as well as "mt165w001" and "mt5n001")
	DO 100 ii = 4,slen
	  IF ( .NOT.TM_DIGIT(name(ii:ii)) ) GOTO 200
 100	CONTINUE
	GOTO 1000	! all digits!!

* there must be enough characters remaining for a 3-digit experiment code
 200	IF ( slen .LT. ii+3 ) GOTO 1000

* the next 3 characters must be digits
	iiout = 1
	DO 300 ii = ii+1,ii+3
	   IF ( TM_DIGIT(name(ii:ii)) ) THEN
	      expdig(iiout:iiout) = name(ii:ii)
	      iiout = iiout + 1
	   ELSE
	      GOTO 1000
	   ENDIF
 300	CONTINUE

* yes.  It's a TMAP MOM run
	source = 'MOM'
	expnum = '0'//expdig
	TM_ITSA_MODEL_RUN = .TRUE.
	RETURN

* nope.  It ain't a TMAP model run
 1000	TM_ITSA_MODEL_RUN = .FALSE.
	RETURN
 	END

	SUBROUTINE CHECK_DATE_REFORMAT (datestring, slen, cal_id, status)


* For option set by MODE DATE_FORMAT to write dates in ISO8601 format
* See if the output-format stored in the program setting date_fmt_out
* is pdate_numslashnum, and if so rewrite the date string in that form.
*
* V7.44+  Ansley Manke 2018-12-12
*         See GitHub issue #1909
* v7441*acm* 12/18 Issue 1910: Allow dates in commands to be in ISO 8601 form, yyyy-mm-dd

        include 'tmap_dims.parm'
        include 'tmap_errors.parm'
        include 'ferret.parm'
        include 'xprog_state.cmn'


	CHARACTER*(*)	datestring
	INTEGER		slen, cal_id, status

	LOGICAL		do_err
	CHARACTER*35	buff
	INTEGER		TM_LENSTR1
	
	do_err = .FALSE.
	
	IF (date_fmt_out .EQ. pdate_numslashnum) THEN 
	   CALL TM_DATE_REFORMAT( datestring, pdate_vax, cal_id,
     .				  buff, date_fmt_out, do_err, status)
	   IF (status .EQ. merr_ok) THEN
	      slen = TM_LENSTR1 (buff)
	      datestring = buff
	   ENDIF
	ENDIF

	RETURN
	END

	SUBROUTINE CD_MAKE_VAR ( cdfid, dset, varname, type, maxstrlen,
     .                           grid, lo, hi, recdim, enhead, new, 
     .                           edges_flag, do_bounds, mode_upcase_output,
     .                           keepax_flag, netcdf4_type, xchunk_size, 
     .                           ychunk_size, zchunk_size, tchunk_size, 
     .                           deflate_lev, shuffle_flag, endian_code,
     .                           stringdimname, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Define a variable for the current output netCDF file

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 3/92
*               10/92: set into define mode before creating variable
*  1/25/95 - *sh* added argument enhead.  If NOT enhead then don't call
*	      cd_make_grid and do make ALL necessary axes when making the
*	      child axes
*   11/95 - *sh* use CD_AXIS_NAME rather than line_name for dynamic lines
* 10/96 *kob* - Linux port - had to move variable assignments off of
*		declaration line.
*  5/97 *kob* - had to use DATA rather than PARAMATER statements for character
* 		strings, ie 'ijkl', for linux f90....
* v4.91 *kob* - increase size of CD_CHILDAX_NAME,CD_AXIS_NAME lname from
*               16 to 24
* v500 *kob*  3/99 - change lengths of CD_CHILDAX_NAME, CD_AXIS_NAME, lname,
*          cdfname, vname and gname to 64 from 24 to match longer line_name
* V533 *sh* 6/01 - added support for netCDF output string variables
*		 - check for consistency of data type on APPEND operations
* V552 *acm* 5/03   increase vname to 128 chars 
* V600 *acm* 6/05 - Attribute control. Get information from linked-list structure.
* V600 *acm* 6/06 - New MODE upcase_output controls whether axis names and variable in
*                   names are upcased cdf output.
* V601 *acm* 11/06 - Fix bug 1471; new routine CD_AXIS_OUTNAME gets correct 
*                    output axis name.
* V602 *acm*12/06 - Bug 1478: cd_isit_recdim needs mode_upcase_output.
* V62  *acm*  2/09 - Fix bug 1634: allow SAVE/KEEP_AXISNAMES so that child axis names
*                    arent written. They can get too long for OPeNDAP library calls
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V66  *acm* 3/10  Settings for NetCDF-4 files. 
* V66  *acm* 3/10  Check: If chunk size given is larger than grid size in that
*                  direction, then its an error.
* V67  *acm* 3/11  Fix bug 1750. Revert to older behavior: if grid uses same axis
*                  name but different contents, write both to file with the name
*                  Ferret uses internally.
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing
* V685 6/13 *acm* Dont add SAVE/NOCOORDS
* V686 12/13*acm* For string variables from datasets, keep the string-dimension name and length
*                 from the original dataset on output.
* V687 3/14 *acm* Fix ticket 1750. Write Ferret-internal axis names to cdf files, unless
*                 the user has said /KEEP_AXISNAMES
* V69+ 4/14 *acm* After the above fix, need a tweak to be able to append to files having 
*                 dimensions that are not coordinate variables
* V697 2/16 *acm* Remove unused variables from the call to CD_SET_COMPRESS
* V698  4/16 *acm* Fix ticket 2241: If file has dimension but not a coordinate 
*                  variable, do not write the coordinate variable, ONLY IF writing 
*                  the full-span in that direction.
* V710  9/16 *acm* Ticket 2459: If axis is already in the file with a different
*                  direction write axis with a unique name for this direction.

* argument definitions:
*     cdfid   - netCDF id number for already opened CDF file
*     varname - name of variable
*     type    - data type for variable
*    maxstrlen- if a string variable, longest string len
*     grid    - defining grid for variable
*     lo      - low indices of variable hyperslab
*     hi      - high indices of variable hyperslab
*     recdim  - which axis (1-4 or 0) is to be the CDF record axis
*     enhead  - make enhanced heading?  (with parent grid machinery)
*     new     - have we just created a new variable ?
*     netcdf4_type	- netcdf format: 4=netcdf4, 3=netcdf3(=classic), 6=64-bit
*     xchunk_size     - chunk size in X direction
*     ychunk_size     - chunk size in Y direction
*     zchunk_size     - chunk size in Z direction
*     tchunk_size     - chunk size in T direction
*     deflate_lev     - deflate_lev level (0 for no deflate_lev)
*     shuffle_flag    - shuffle - 0 or 1
*     endian_code     - native=0, little=1, big=0 match nf_endian_* params
*     status  - return status

* include files
        include 'netcdf.inc'
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
        include 'cdf_tmap.parm'
#include "gt_lib.parm"
	include 'cd_lib.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xtm_grid.cmn_text'
		include 'xio.cmn_text'

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

* argument declarations
      LOGICAL enhead, new, edges_flag, mode_upcase_output
      INTEGER cdfid, dset, type, maxstrlen, grid, lo(nferdims), hi(nferdims),
     .        recdim, keepax_flag, do_bounds, netcdf4_type, xchunk_size, 
     .        ychunk_size, zchunk_size, tchunk_size, 
     .        deflate_lev, shuffle_flag, endian_code, status
      CHARACTER*(*) varname, stringdimname

* local variable declarations:
      LOGICAL TM_ABSTRACT_AXIS, CD_USE_RECDIM, 
     .        itsa_slab, need_child(nferdims), itsa_strvar, 
     .        name_from_grid(nferdims), dim_only(nferdims)
      INTEGER TM_LENSTR1, CD_ISIT_RECDIM, CD_WRITE_STRDIM, STR_SAME,
     .        dimid(8), iaxis, cdfstat, dims, idim, varid, vartyp,
     .        nvdims, vdims(8), nvatts, nlen, glen, vlen, ax_type,
     .        lo2(nferdims), hi2(nferdims), what_recdim, strdim, dimsize,
     .        chunk_set, duplines, jaxis, ii
      REAL    val
* *kob*  - change lengths of CD_CHILDAX_NAME, CD_AXIS_NAME, lname,
*          cdfname, vname and gname to 64 from 24
* acm* vname to 128
      CHARACTER CD_CHILDAX_NAME*128, CD_AXIS_OUTNAME*128, CD_AXIS_NAME*128, 
     .		lname*128, cdfname*128, vname*128, gname*64, buff*128, 
     .		DIMDIR*1, TM_FMT*12, c_str*12, d_str*12

      INTEGER dlen, clen
      INTEGER chunks(nferdims)  

* *kob* explicit definitions not allowed on decl line in linux...
*       moved it to parameter line 10/96
      CHARACTER*1     dimnam(nferdims)
      CHARACTER*1     ww_dim_nam(nferdims)
      DATA dimnam/'I', 'J', 'K', 'L', 'M', 'N'/
      DATA ww_dim_nam/'X', 'Y', 'Z', 'T', 'E', 'F'/

* has the variable already been created ?
      vname = varname    ! Ultrix f77 is fussy about CHAR*(*) vars
      vlen = TM_LENSTR1( vname )
#ifdef usingDODSf2cUnderscore
      cdfstat = NF_INQ_VARID_(cdfid, vname(:vlen), varid)
#else
      cdfstat = NF_INQ_VARID(cdfid, vname(:vlen), varid)
#endif

      itsa_strvar = type .EQ. NF_CHAR

      new = cdfstat .NE. NF_NOERR


* already exists: limited consistency check - size of each axis, only
      IF ( .NOT.new ) THEN
#ifdef usingDODSf2cUnderscore
         cdfstat = NF_INQ_VAR_(cdfid, varid, vname, vartyp, 
     .                 nvdims, vdims, nvatts)
#else
         cdfstat = NF_INQ_VAR (cdfid, varid, vname, vartyp, 
     .                 nvdims, vdims, nvatts)
#endif
         IF ( CD_USE_RECDIM( cdfid, varid, status ) ) THEN
            recdim = t_dim
         ELSE
            recdim = 0
         ENDIF
         IF ( status .NE. merr_ok ) GOTO 5900
	 IF (type .NE. vartyp) GOTO 5050
* ... first dimension of string variable is actually max string len
	 IF (itsa_strvar) THEN
	   maxstrlen = vdims(1)
	   DO 10 idim = 1, 5
 10	   vdims(idim) = vdims(idim+1)
	   nvdims = nvdims - 1
	 ENDIF
         dims = 0
         DO 100 idim = 1, nferdims
            IF ( grid_line(idim,grid) .EQ. mpsnorm
     .      .OR. lo(idim) .EQ. unspecified_int4    ) GOTO 100
            dims = dims + 1
            IF ( dims .GT. nvdims ) GOTO 5100
! this check removed to cd_write_var to enable over-writing partial hyperslabs
!            IF ( idim .NE. recdim ) THEN
!               npts = CD_AXLEN( cdfid, vdims(dims), status )
!               IF ( status .NE. merr_ok ) GOTO 5900
!               IF ( npts .NE. hi(idim)-lo(idim)+1 ) GOTO 5300
!            ENDIF
 100     CONTINUE
         IF ( dims .NE. nvdims ) GOTO 5100    ! number of dimensions match ?
         GOTO 1000
      ENDIF

* if the time axis of this variable has already been created IT will 
* determine whether this variable uses the record dimension.  The request
* from the user will be over-ruled
      what_recdim = CD_ISIT_RECDIM( cdfid, dset, grid, t_dim, 
     .               mode_upcase_output, keepax_flag, status )
      IF ( what_recdim .EQ. pcdf_yes ) THEN
         recdim = t_dim
      ELSEIF ( what_recdim .EQ. pcdf_no ) THEN
         recdim = 0
      ELSE
* ... the dimension has yet to be defined - user request remains
         CONTINUE
      ENDIF

* determine if this variable needs parent/child axes
      itsa_slab = .FALSE.
      DO 200 idim = 1, nferdims
         need_child(idim) = .FALSE.
         IF ( idim .EQ. recdim ) GOTO 200
         iaxis = grid_line(idim,grid)
         IF ( iaxis .EQ. mpsnorm ) GOTO 200
         IF ( lo(idim) .EQ. unspecified_int4 ) GOTO 200
         IF ( TM_ABSTRACT_AXIS( iaxis ) ) GOTO 200
         need_child(idim) = lo(idim) .NE. 1
     .                 .OR. hi(idim) .NE. line_dim(iaxis)
         IF ( need_child(idim) ) THEN
	    itsa_slab = .TRUE.
	    IF ( enhead .AND.
     .	     (lo(idim).LT.1 .OR. hi(idim).GT.line_dim(iaxis))) THEN
		CALL TM_NOTE( 'Modulo '//ww_dim_nam(idim)//
     .		' axis is incompatible with enhanced netCDF heading'
     .							,lunit_errors )
		CALL TM_NOTE( 'Output file may not be readable by FERRET'
     .							,lunit_errors)
	    ENDIF
 	ENDIF
 200  CONTINUE

      IF ( enhead ) THEN
* create the parent grid needed for this variable
         CALL CD_WRITE_GRID( cdfid, dset, grid, lo, hi, recdim, itsa_slab,
     .                       gname,  edges_flag, do_bounds, 
     .                       mode_upcase_output, keepax_flag, 
     .                       status )
         IF ( status .NE. merr_ok ) RETURN

* create child axes where this variable doesn't run full-span on an axis
         DO 250 idim = 1, nferdims
            IF ( need_child(idim) ) THEN
               CALL CD_WRITE_AXIS( cdfid, dset, grid, idim, .FALSE.,
     .                   lo(idim), hi(idim), pcdf_child_span, 
     .                   .FALSE., .FALSE., mode_upcase_output, 
     .                   keepax_flag, name_from_grid(idim), dim_only(idim), 
     .                   status)
               IF ( status .NE. merr_ok ) GOTO 5900
            ENDIF
 250     CONTINUE
	 IF (itsa_strvar) strdim = CD_WRITE_STRDIM(cdfid, maxstrlen, stringdimname, status)
         IF ( status .NE. merr_ok ) GOTO 5900
      ELSE
* 1/95 - create the full-span or sub-span axes as appropriate
         DO 260 idim = 1, nferdims
	    dim_only(idim) = .FALSE.
	    IF ( grid_line(idim, grid) .NE. mpsnorm
     .      .AND. lo(idim) .NE. unspecified_int4     ) THEN
	      IF (need_child(idim)) THEN
	         ax_type = pcdf_sub_span
	      ELSE
	         ax_type = pcdf_full_span
	      ENDIF
              CALL CD_WRITE_AXIS( cdfid, dset, grid, idim, 
     .			       idim.EQ.recdim, lo(idim), hi(idim), 
     .			       ax_type, edges_flag, do_bounds, 
     .                         mode_upcase_output, keepax_flag, 
     .                         name_from_grid(idim), dim_only(idim), status )
              IF ( status .NE. merr_ok ) GOTO 5900
	    ENDIF
 260     CONTINUE
	 IF (itsa_strvar) strdim = CD_WRITE_STRDIM(cdfid, maxstrlen, stringdimname, status)
         IF ( status .NE. merr_ok ) GOTO 5900
      ENDIF

      do idim = 1, nferdims+1
	 dimid(idim) = 0
      enddo

* determine the netCDF dimension id's to use for the variable
      IF (itsa_strvar) THEN
	dimid(1) = strdim   ! 1st dim of string array is character axis
	dims = 1
      ELSE
        dims = 0
      ENDIF 

* Are there grid lines duplicated in the grid (see tiket 2459 for an example)
      duplines = 0
      DO 280 idim = 1, nferdims
         iaxis = grid_line(idim,grid)
	 IF (iaxis.NE.int4_init .AND. iaxis.GT.0) THEN
	    DO ii = 1, nferdims 
	       jaxis = grid_line(ii,grid)
	       IF (ii.NE.idim .AND. jaxis.EQ.iaxis) duplines = duplines+1
	    ENDDO
	 ENDIF
  280 CONTINUE

* get axis name. If mode upcase_output is set, then upcase the name

      DO 300 idim = 1, nferdims
         iaxis = grid_line(idim,grid)
         buff = CD_AXIS_NAME( dset, grid, idim, nlen )
         IF (keepax_flag .EQ. 1) buff = CD_AXIS_OUTNAME( dset, grid, idim, nlen )

	 IF (name_from_grid(idim)) THEN 
* using the basic name straight from the grid
            buff = line_name(iaxis)
	 ENDIF
         lname = buff
         IF (mode_upcase_output) THEN
	    CALL STR_UPCASE( lname, buff)
	 ELSE
	    IF (STR_SAME(CD_AXIS_NAME(dset, grid, idim, nlen), 
     .                   CD_AXIS_OUTNAME(dset, grid, idim, nlen)) .EQ. 0) THEN
	       buff = CD_AXIS_OUTNAME(dset, grid, idim, nlen)
               lname = buff
            ENDIF
         ENDIF

	 CALL CD_AXNAME_TO_WRITE (cdfid, idim, lname, nlen, cdfstat)
	 
c	 IF (dim_only(idim)) THEN 
c	    buff = CD_AXIS_OUTNAME(dset, grid, idim, nlen)
c            lname = buff
c         ENDIF

         IF ( iaxis .EQ. mpsnorm
     .   .OR. lo(idim) .EQ. unspecified_int4 ) GOTO 300
         dims = dims + 1
         IF ( TM_ABSTRACT_AXIS( iaxis ) ) THEN
! ... could probably use lname here, too *sh* 11/95
            cdfname = lname
            IF (keepax_flag .EQ. 0) 
     .       cdfname = CD_CHILDAX_NAME( lname,
     .                                 lo(idim), hi(idim), nlen )
         ELSEIF ( idim .NE. recdim
     .  .AND. ( lo(idim) .NE. 1
     .    .OR.  hi(idim) .NE. line_dim(iaxis) ) ) THEN
            cdfname = lname
            IF (keepax_flag .EQ. 0) 
     .       cdfname = CD_CHILDAX_NAME( lname,
     .                                 lo(idim), hi(idim), nlen )
         ELSE
            cdfname = lname
         ENDIF
         nlen = TM_LENSTR1( cdfname )
#ifdef usingDODSf2cUnderscore
         cdfstat = NF_INQ_DIMID_( cdfid, cdfname(:nlen), dimid(dims) )
#else
         cdfstat = NF_INQ_DIMID ( cdfid, cdfname(:nlen), dimid(dims) )
#endif
         IF ( cdfstat .NE. NF_NOERR ) GOTO 5200  ! it must already exist

         chunk_set = 0
         IF (netcdf4_type .EQ. 4) THEN
            IF (line_direction(iaxis) .EQ. 'WE' .OR.  
     .              line_direction(iaxis) .EQ. 'XX') THEN
               chunks(dims) = xchunk_size
	       DIMDIR = 'X'
	       dimsize = hi(idim) - lo(idim) + 1
	       IF (chunks(dims) .GT. dimsize ) GOTO 5700
	       IF (xchunk_size .GT. 0) chunk_set = 1
            ELSEIF (line_direction(iaxis) .EQ. 'SN' .OR.  
     .              line_direction(iaxis) .EQ. 'YY') THEN
               chunks(dims) = ychunk_size
	       DIMDIR = 'Y'
	       dimsize = hi(idim) - lo(idim) + 1
	       IF (chunks(dims) .GT. dimsize ) GOTO 5700
	       IF (ychunk_size .GT. 0) chunk_set = 1
            ELSEIF (line_direction(iaxis) .EQ. 'DU' .OR.  
     .              line_direction(iaxis) .EQ. 'UD') THEN
               chunks(dims) = zchunk_size
	       DIMDIR = 'Z'
	       dimsize = hi(idim) - lo(idim) + 1
	       IF (chunks(dims) .GT. dimsize ) GOTO 5700
	       IF (zchunk_size .GT. 0) chunk_set = 1
            ELSEIF (line_direction(iaxis) .EQ. 'TI' .OR.  
     .              line_direction(iaxis) .EQ. 'TT') THEN
               chunks(dims) = tchunk_size
	       DIMDIR = 'T'
	       dimsize = hi(idim) - lo(idim) + 1
	       IF (chunks(dims) .GT. dimsize ) GOTO 5700
	       IF (tchunk_size .GT. 0) chunk_set = 1
	    ENDIF

         ENDIF ! netcdf4

 300  CONTINUE

* If any chunk was set, then all must be set for the dimensions that are present.

      IF (chunk_set .GT. 0) THEN
         DO 350 idim = 1, nferdims
            IF (dimid(idim) .GT. 0 .AND. chunks(idim) .EQ. 0) GOTO 5600
 350     CONTINUE
      ENDIF

* put CDF into define mode so attributes can be written
      CALL CD_SET_MODE(cdfid, pcd_mode_define, status)
      IF ( status .NE. merr_ok ) RETURN

* create the new variable
#ifdef usingDODSf2cUnderscore
      cdfstat = NF_DEF_VAR_(cdfid, vname(:vlen), type, dims, dimid, varid)
#else
      cdfstat = NF_DEF_VAR(cdfid, vname(:vlen), type, dims, dimid, varid)
#endif
      IF ( cdfstat .NE. NF_NOERR ) GOTO 5400

C     Turn on deflate_lev and chunking

      IF (netcdf4_type .EQ. 4) THEN
         IF (deflate_lev .GT. 0) CALL CD_SET_COMPRESS (cdfid, varid,
     .         deflate_lev, chunks, shuffle_flag, endian_code, status)
      ENDIF ! netcdf4

* if the "unlimited" record dimension is in use place no limits on that axis
      DO 400 idim = 1, nferdims
         IF ( lo(idim) .EQ. unspecified_int4 ) THEN
            lo2(idim) = 1
            hi2(idim) = 1
         ELSE
            lo2(idim) = lo(idim)
            hi2(idim) = hi(idim)
         ENDIF
 400  CONTINUE
      IF  (  recdim .GT. 0 ) THEN
         lo2(recdim) = 0
         hi2(recdim) = 0
      ENDIF
 
* assign attributes if this is a hyperslab of the parent grid
* TODO: the whole mechanism of parent grids needs developing with 6D

      IF ( itsa_slab .AND. enhead) THEN
         glen = TM_LENSTR1( gname )

#ifdef usingDODSf2cUnderscore
         cdfstat = NF_PUT_ATT_TEXT_( cdfid, varid, 'parent_grid', glen,
     .                gname(:glen) )
         cdfstat = NF_PUT_ATT_INT_( cdfid, varid, 'slab_min_index', 
     .                NF_INT, 4, lo2 )
         cdfstat = NF_PUT_ATT_INT_( cdfid, varid, 'slab_max_index', 
     .                NF_INT, 4, hi2 )
#else
         cdfstat = NF_PUT_ATT_TEXT( cdfid, varid, 'parent_grid', glen,
     .                gname(:glen) )
         cdfstat = NF_PUT_ATT_INT( cdfid, varid, 'slab_min_index', 
     .                NF_INT, 4, lo2 )
         cdfstat = NF_PUT_ATT_INT( cdfid, varid, 'slab_max_index', 
     .                NF_INT, 4, hi2 )
#endif
      ENDIF

* successful completion
 1000 status = merr_ok
      RETURN

* error messages
 5050 CALL TM_ERRMSG
     . ( merr_badgriddef, status, 'CD_MAKE_VAR', unspecified_int4,
     .   unspecified_int4,
     .   'data type of variable '//vname(:vlen)//
     .   ' is inconsist. w/ CDF file',
     .   no_errstring, *5900 )

 5100 CALL TM_ERRMSG
     . ( merr_linepredef, status, 'CD_MAKE_VAR', unspecified_int4,
     .   unspecified_int4,
     .   '# of dims in variable '//vname(:vlen)//
     .   ' is inconsist. w/ CDF file',
     .   no_errstring, *5900 )

 5200 CALL TM_ERRMSG
     . ( merr_linepredef, status, 'CD_MAKE_VAR', unspecified_int4,
     .   unspecified_int4,
     .  'axis '//cdfname(:nlen)//' of grid for '
     .   //vname(:vlen)//' doesnt match CDF file',
     .   no_errstring, *5900 )

! 5300 CALL TM_ERRMSG
!     . ( merr_linepredef, status, 'CD_MAKE_VAR', unspecified_int4,
!     .   unspecified_int4,
!     .   dimnam(idim)//' axis length of '//vname(:vlen)//
!     .   ' inconsist. w/ CDF file',
!     .   no_errstring, *5900 )

 5400       CALL TM_ERRMSG
     .     ( cdfstat+pcdferr, status, 'CD_MAKE_VAR', cdfid,
     .       unspecified_int4, 'Failed creating variable '
     .       //vname(:vlen), no_errstring, *5900 )

* error exit
 5500  vlen = TM_LENSTR1( vname )
       WRITE (buff, 1010) ww_dim_nam(idim), vname(:vlen), dlen
 1010  FORMAT ('chunk size too large for ', A,' axis of grid for ',
     .   A,' must be less than axis length written', I8)
       CALL TM_ERRMSG
     . ( merr_chunk_spec, status, 'CD_MAKE_VAR', unspecified_int4,
     .   unspecified_int4, buff, no_errstring, *5900 )

 5600  CALL TM_ERRMSG
     .     ( merr_syntax, status, 'CD_MAKE_VAR', unspecified_int4, 
     .     unspecified_int4, 
     .     'If ChunkSize is set for any dimension'//
     .     ' of var, must set for all its dimensions', ' ', *5900 )

 5700  val = chunks(idim)
       c_str = TM_FMT(val, 5, 12, clen)
       val = dimsize
       d_str = TM_FMT(val, 5, 12, dlen)
       WRITE (buff, 1020) DIMDIR, c_str(1:clen), d_str(1:dlen)
 1020  FORMAT (A1,'ChunkSize ', A, 
     .         ' is larger than dimension length ', A)
       CALL TM_ERRMSG
     . ( merr_chunk_spec, status, 'CD_MAKE_VAR', unspecified_int4,
     .   unspecified_int4, buff, no_errstring, *5900 )
* error exit
 5900   RETURN
	END

	INTEGER FUNCTION TM_UNITS_CAL( inunit, cal_id, true_month )
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Reset the unit ID for a unit of month or year for non-gregorian calendars,
* according to calendar's year length.

*   v744 11/2011   *acm* If PROLEPTIC_GREGORIAN is given then override mixed-gregorian
*                  calendar handling. 
* 5/2020 Issue 1906: treat Proleptic-Gregorian identically to Gregorian

	include 'calendar.decl'
	include 'calendar.cmn'	
* Argument definitions
	LOGICAL true_month
	INTEGER inunit, cal_id

* Internal defitions
	INTEGER iun

	iun = inunit

C /calendar=/unit=year gets length of year in that calendar.
	IF (inunit .EQ. -6 .OR. inunit .EQ. -10) THEN  
	   IF (cal_id .EQ. d360) iun = -9
	   IF (cal_id .EQ. julian) iun = -12
	   IF (cal_id .EQ. noleap) iun = -11
	   IF (cal_id .EQ. all_leap) iun = -8
	ENDIF

C /units=months  is 1/12 of the length of the year

	IF (inunit .EQ. -5) THEN    ! 1/97: "-5" is "MONTHS"
	   IF (cal_id .eq. noleap) iun = -13
	   IF (cal_id .eq. julian) iun = -15
	   IF (cal_id .eq. d360  ) iun = -14
	   IF (cal_id .eq. all_leap) iun = -16
	   IF (true_month) THEN
	       IF (cal_id.eq.gregorian .or. cal_id.eq.proleptic) THEN
	          iun = -17
	       ELSE
	          iun = iun - 5
	      ENDIF
	   ENDIF
	ENDIF

	TM_UNITS_CAL = iun
	RETURN
	END

      REAL*8 FUNCTION DATYPE(JT,NCHAR)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)datype5.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
      DIMENSION LEN(48)
	character type(48)*8,ty*8
      DATA TYPE/'MAJ CRNT','MIN CRNT','ALG CRNT','CRS CRNT',
     *     'MAJ WIND','MIN WIND','MAJ STRS','MIN STRS',
     *     'ATM PRES','WET TEMP','DRY TEMP',
     1     'WIND SPD','WIND DIR',' ',
     1     'AIR U VL','AIR V VL','TAU X','TAU Y',
     2     'SEA LVL','AIR TEMP','RTR SPD','VEC SPD','VANE DIR',
     3     'TEMP','U VEL','V VEL','PRESSURE','TILT','EDDY KE',
     4     'EDDY PE','SALNIITY','COND','ISO DPTH','SIGMA-T','X','Y',
     5	   'MODE AMP','ALNG WND','CRS WND','ALG STRS','CRS STRS',
     6     'WND STRD','WND STRC','AJD SLVL','ZONAL HF','PLOAR HF',
     7     'HEAT CNT','DYN HGT'/
      DATA LEN/8,8,8,8,8,8,8,8,8,8,8,8,8,1,8,8,5,5,7,8,7,7,8,4,5,
     *     5,8,4,7,7,8,4,8,7,1,1,8,8,7,8,8,8,8,8,8,8,8,7/

      IF(JT.GE.12 .AND. JT.LE.59)GO TO 100
      write(ty,1000)JT
 1000 FORMAT(I3)
	read(ty,999)datype
999	format(a8)
	NCHAR=3
      GO TO 200

  100 read(type(jt-11),999)datype
      NCHAR=LEN(JT-11)
      IF(NCHAR.LE.0)NCHAR=1
 200  RETURN
      END

	SUBROUTINE SCINOT(X,Y,DEG,CSZE,NCHR,STR,ITYPE,WID,XF,YF)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)scinot.f	1.2    6/13/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port
C *acm* 11/05    Changes for deg-min-sec labelling. for these long
C                labels make the character size a bit smaller.
        REAL charsize
	CHARACTER STR*(*),ITMP*20,ITMP2*10,SUB*20,IC*1
	character ESTR*1,MESTR*2,lestr*1,lmestr*2
	data lestr,lmestr/'e','-e'/
	DATA ESTR,MESTR/'E','-E'/
c
        charsize = CSZE
	IF(NCHR.GT.20)RETURN
	ITMP=' '
	ITMP2=' '
	SUB=' '
	NS=0
	L=0
	J=1
	NE=0
	DO 10 NM=1,20
	IF(NM.GT.NCHR)GOTO 100
	IC=STR(NM:NM)
	IF(IC.EQ.' '.AND.J.EQ.1)GOTO 10
	IF(IC.EQ.estr.or.ic.eq.lestr.OR.IC.EQ.' ')GOTO 100
	IF(IC.EQ.'+'.OR.IC.EQ.'-')THEN
		IF(J.NE.1)THEN
			GOTO 100
		ELSE
			GOTO 20
		ENDIF
	ENDIF
	IF((IC.LT.'0'.OR.IC.GT.'9').AND.IC.NE.'.')THEN
		SUB=STR(NM:)
		NC=J-1
		NS=LNBLK(SUB,20)
		GOTO 1000
	ENDIF
20	ITMP(J:J)=IC
	J=J+1
10	CONTINUE
100	IF(IC.EQ.' '.OR.NM.GT.NCHR)GOTO 200
	NE=2
	IF(STR(1:1).NE.estr.AND.STR(1:2).NE.mestr
     *	.and.str(1:1).ne.lestr.and.str(1:2).ne.lmestr)THEN
	ITMP(J:J+1)=' x'
	J=J+2
	ENDIF
200	NC=J-1
	IF(NE.EQ.0)GOTO 1000
	IF(IC.EQ.estr.or.ic.eq.lestr)NM=NM+1
	IS=0
	DO 60 K=NM,20
	IF(K.GT.NCHR)GOTO 300
	IC=STR(K:K)
	IF(IC.EQ.' ')GOTO 60
	IF(IC.EQ.'+')GOTO 60
	IF(IC.EQ.'0'.AND.L+IS.EQ.0)GOTO 60
	IF((IC.LT.'0'.OR.IC.GT.'9').AND.IC.NE.'-')THEN
		SUB=STR(K:)
		NS=LNBLK(SUB,20)
		GOTO 300
	ENDIF
	IF(IC.EQ.'-')IS=-1
	L=L+1
	ITMP2(L:L)=IC
60	CONTINUE
300	IF(L.NE.0)GOTO 1000
	L=1
	ITMP2='0'
1000  IF (ns .GT. 6) charsize = 0.9* charsize
      C=COS(DEG*1.7453292E-2) 
      S=SIN(DEG*1.7453292E-2) 
      WID2=SYMWID(charsize,NE,'10') 
      WID1=SYMWID(charsize,NC,ITMP)+WID2 
      WID3=WID1+SYMWID(charsize*.75,L,ITMP2) 
      WID=WID3+SYMWID(charsize,NS,SUB)
      IF(ITYPE.EQ.3)RETURN 
      GO TO (1,2,3)ITYPE+1 
1     XL=X-WID*C*.5/XF+charsize*.5*S/XF 
      YL=Y-WID*S*.5/YF-charsize*.5*C/YF 
      GOTO 400 
2     XL=X-WID*C/XF+charsize*.5*S/XF 
      YL=Y-WID*S/YF-charsize*.5*C/YF 
      GOTO 400 
3     XL=X+charsize*.5*S/XF 
      YL=Y-charsize*.5*C/YF 
400   CALL SYMBEL(XL,YL,DEG,charsize,NC,ITMP) 
	IF(NE.NE.0)THEN
      CALL SYMBEL(XL+(WID1-WID2)*C/XF,YL+(WID1-WID2)*S/YF, 
     *DEG,charsize,NE,'10') 
      XLT=XL+WID1*C/XF-charsize*.625*S/XF 
      YLT=YL+WID1*S/YF+charsize*.625*C/YF 
      CALL SYMBEL(XLT,YLT,DEG,charsize*.75,L,ITMP2) 
	ENDIF
	XL=XL+WID3*C/XF
	YL=YL+WID3*S/YF
	CALL SYMBEL(XL,YL,DEG,charsize,NS,SUB)
      RETURN 
      END 

	SUBROUTINE INIT_UVAR_SUB ( name, text, title, units, dset, bad,
     .                             its_remote, implct_defn, uvar, parent_uvar,
     .			           at_type, at_id, at_start, at_end,
     .			           natom, txstart, txend, child, 
     .			           varname, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Fill in a user variable structure with a new expression
* Expression should arrive with the atoms identified in at_type but
* still in infix order. Since multiple expressions may exist within
* the same text string (text) this routine has txstart and txend
* to indicate the offsets for the particular expression in question

* V450:  12/96 - mostly borrowed from the previous INIT_UVAR
* *kob*  6/97 - rpn_order was erroneously declared as array of size 
*               max_exp, changed it to maxatoms
* V450:  7/97 - save the value of parent_uvar in uvar_parent
* V491:  12/97 - add check to ensure natom_rpn returned from RPN isn't
*                greater than max_uvar_items  *kob*
* V495: 7/7/98 - *sh* variable names in single quotes - don't upcase them
*     : 9/30/98 - NAG F90 (linux) received error on above change.  
*                 need to put single  tick between double quotes  *kob*
*               - also needed a definition for HEXDF variable used
* V500:  1/99 *sh* - don't upcase double quoted strings, either
*        3/99 *sh* - bug fix: pass the full error text to RPN, since
*			at_start, at_end are relative to full text buffer
*	12/99 *sh* - initialize uvar_lo/hi*
* V510: 5/00 *sh* - added "bad" (missing value flag) to arguments
* 1/03 *kob* g77 port - requires use of risc_buff for concats
*            bug fix - reference to uvar_text was missing uvar reference 
* V600  4/06 *acm* - additional declarations found by Solaris compiler     
* V601 11/06 *acm* - add user variables always to dataset pdset_uvars. Previously
*                    variables defined with LET/D= were added to that dataset.
* V602  2/07 *acm* Fix bug 1492, changing attributes of coordinate variables 
* V62   2/09 *acm* Pass the original upper/lowercase spelling of user-defined variable
*                  names to cd_add_var; name to be saved in the attribute structure, for 
*                  use when writing out user-defined variables when MODE UPCASE_OUTPUT 
*                  is cancelled.
* V63  *acm* 10/09 Changes for gfortran build
* V671 7/11  *acm* Ticket 1868 IFV - masking expressions with ifValid, treating 
*		   zero as valid. 
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V693+ *sh* 12/14 add support for _DQ_ and _SQ_ as qutation delimiters
*      *acm*  2/15 Prevent run-time errors in string length for _DQ_ handling
* V697 12/15 *acm* Ticket 2337 Increase length of cmnd buffer to 20480. If long
*                  var definition, just truncate it in uvar_text(uvar)
* V697  2/16 *acm* DO NOT Increase length of cmnd buffer to 20480
*                  but keep the other changes at that time, handling long 
*                  defintions
* V698  2/16 *acm* For ticket 2352: variables defined with LET/D are
*                  added to that dataset in the attribute structure.
* V699  5/16 *sh* pass uvar to CD_ADD_VAR encoded as negative for a LET/D uvar
*                 include EX# and child vars in the LIST structures
* V710 *acm* 10/16 Ticket 2422: remove unneeded call to DEALLO_UVAR_GRIDS. 
*                  Also clean up long-unused lines that were commented out.

	include 'tmap_dims.parm'
	include 'ferret.parm'	
	include 'errmsg.parm'	
	include 'rpn.parm'
	include 'xvariables.cmn'
	include 'xrisc_buff.cmn'

* calling argument declarations:
	LOGICAL		implct_defn, child, its_remote
	CHARACTER*(*)	name, text, title, units, varname
	INTEGER		dset, uvar, natom, txstart, txend, status,
     .			parent_uvar, 
     .			at_type  (maxatoms), at_id  (maxatoms),
     .			at_start (maxatoms), at_end (maxatoms)
	REAL		bad

* internal variable declarations:
	LOGICAL		inquote, toolong
	INTEGER	        TM_LENSTR1, TM_LENSTR, STR_SAME, i, idim,
     .                  natom_rpn, rpn_order(maxatoms), i2, quote_type,
     .                  dset_to_add, slen, iat, varid, type, coordvar
	CHARACTER	buff*255, c*1
! 6/16 -- declared but never used: CHARACTER attname*128

* internal parameter declarations
	INTEGER		p_single_quote, p_double_quote, p__DQ_, p__SQ_
	PARAMETER     ( p_single_quote = 1,
     .			p_double_quote = 2,
     .			p__DQ_         = 3,
     .			p__SQ_         = 4 )

* kob 9/30/98 This needed for 7/7/98 code addition
#ifdef FORTRAN_90
      INTEGER HEXDF
      DATA HEXDF/Z'DF'/
#endif


* initialize

* algebraic expression too long ?
	toolong =  ( txend-txstart .GE. uvar_text_len ) 
	IF (toolong) txend = uvar_text_len - 3

* convert to Reverse Polish (stack evaluation) order
	CALL RPN( text,
     .		  at_type, at_id, at_start, at_end,
     .            natom, natom_rpn, rpn_order,
     .            status, buff)
	IF ( status .NE. ferr_ok ) GOTO 5440
* kob 12/97 - natom_rpn cannot be greater than max_uvar_items
	IF (natom_rpn .GE. max_uvar_items) GOTO 5500

* copy name code and text into slot and change as needed to upper case
*	vax_code = STR_UPCASE( uvar_name_code( uvar ), name )
cc        CALL string_array_modify_upcase(uvar_name_code_head, uvar, 
cc     .                                  name, LEN(name))
        CALL string_array_modify_upcase(uvar_name_code_head, uvar, 
     .                                  name, LEN(name))

* (7/98) - don't upcase portions of the string inside single quotes
* (1/99) - same deal for double quotes
!	vax_code = STR_UPCASE( uvar_text     ( uvar ), text(txstart:txend) )
	uvar_text(uvar) = ' '
	i2 = 0
	inquote = .FALSE.
	i = txstart - 1
	DO WHILE (i .LT. txend)
	   i = i + 1
	   i2 = i2 + 1
	   c = text(i:i)
	   IF ( c .EQ. "'" ) THEN
* ... single quote -- start or end of string?
	      IF (inquote) THEN
	        IF (quote_type.EQ.p_single_quote) inquote = .FALSE.
	      ELSE
		inquote = .TRUE.
	        quote_type = p_single_quote
	      ENDIF
	   ELSEIF ( c .EQ. '"' ) THEN
* ... double quote -- start or end of string?
	      IF (inquote) THEN
	        IF (quote_type.EQ.p_double_quote) inquote = .FALSE.
	      ELSE
		inquote = .TRUE.
	        quote_type = p_double_quote
	      ENDIF
	   ELSEIF ( txend-txstart .GT. 7 .AND. i.LE.txend-3 ) THEN 
	      iat = 1
	      IF (text(i:i+3) .EQ. p_DQ_quote) THEN 
* ... found "_DQ_" -- start or end of string?
	        IF (inquote) THEN
	          IF (quote_type.EQ.p__DQ_) inquote = .FALSE.
	        ELSE
		  inquote = .TRUE.
	          quote_type = p__DQ_
	        ENDIF
	        uvar_text(uvar)(i2:i2+2) = text(i:i+2)
	        i  = i  + 3
	        i2 = i2 + 3
	      ELSEIF (text(i:i+3) .EQ. p_SQ_quote) THEN 
* ... found "_SQ_" -- start or end of string?
	        IF (inquote) THEN
	          IF (quote_type.EQ.p__SQ_) inquote = .FALSE.
	        ELSE
		  inquote = .TRUE.
	          quote_type = p__SQ_
	        ENDIF
	        uvar_text(uvar)(i2:i2+2) = text(i:i+2)
	        i  = i  + 3
	        i2 = i2 + 3
	      ENDIF
	   ENDIF
	   IF ( inquote .OR. (c .LT. 'a' .OR. c .GT. 'z' ) ) THEN
	      uvar_text(uvar)(i2:i2) = c   ! preserve case
	   ELSE
* ... convert lower case character to upper case
#if defined unix  && ! defined NEED_IAND
	      uvar_text(uvar)(i2:i2) = CHAR( AND('DF'X, ICHAR(c)) )
#else
# ifdef FORTRAN_90
	      uvar_text(uvar)(i2:i2) = CHAR( IAND(HEXDF, ICHAR(c)) )
# elif defined gfortran
	      uvar_text(uvar)(i2:i2) = CHAR( AND('DF'X, ICHAR(c)) )
#else
* VMS needs IAND
* bug fix - forgot (uvar) in var reference
	      uvar_text(uvar)(i2:12) = CHAR( IAND('DF'X, ICHAR(c)) )
# endif
#endif
	   ENDIF
	ENDDO
	IF (toolong) uvar_text(uvar)(uvar_text_len-2:uvar_text_len) = '...'

* (7/98) end of quote-sensitive case changing loop

c* copy title, units, dset, and missing flag into buffers
	uvar_title( uvar ) = title
        uvar_units( uvar ) = units
        uvar_dset ( uvar ) = dset
        uvar_bad_data ( uvar ) = bad
        uvar_remote ( uvar ) = its_remote

* Add variable to the user-variable dataset in the linked list structure.
* The variable type is not known at this time - will set it later when the
* variable gets loaded. 

* 6/16 *sh* include EX# expressions and child variables in the LIST structures

       type = 0
       coordvar = 0
! 6/16       IF (name(1:3) .NE. 'EX#' .AND. .NOT.child) THEN
       varid = -1 * uvar   ! signals uvar (vs fvar) inside NCF_UTIL.c
       IF (dset .GT. pdset_irrelevant) THEN
	  dset_to_add = dset
       ELSE
	  dset_to_add = pdset_uvars  ! special dset for global uvars
       ENDIF

* if no title was provided, then use the LET definition as the title
       IF (title .EQ. " ") THEN
          buff =  uvar_text(uvar)
       ELSE
          buff = title
       ENDIF

       CALL CD_ADD_VAR( dset_to_add, varname, varid, buff, units, 
     .         type, coordvar, bad, status)

       IF ( status .NE. ferr_ok ) GOTO 5600

* !!! All the rest of the uvar_*(uvar) properties could become attributes of this uvar !!!

* save the ID of the parent variable (or zero if this is a parent, itself)
	uvar_parent( uvar ) = parent_uvar

* place the list of atoms into the uvar in RPN order.
	DO 300 i = 1, natom_rpn
	   uvar_item_start(i,uvar) = at_start(rpn_order(i)) - txstart + 1
	   uvar_item_end  (i,uvar) = at_end  (rpn_order(i)) - txstart + 1
	   uvar_item_type (i,uvar) = at_type (rpn_order(i))
 300	CONTINUE
        uvar_ifv(uvar) = .FALSE.
        IF ( STR_SAME( uvar_text(uvar)(1:3), 'IFV' ) .EQ. 0 )  
     .      uvar_ifv(uvar) = .TRUE.

* store number of items in definition
*	uvar_num_items( uvar ) = natom_rpn
        CALL deleted_list_modify(uvar_num_items_head, uvar,
     .                           natom_rpn )

* by default assume the definition requires an external data set specification
	uvar_need_dset( uvar ) = .TRUE.

* by default assume that all limits are irrelevant
	DO 320 idim = 1, nferdims
	   uvar_lo_ss ( uvar, idim )  = unspecified_int4
	   uvar_hi_ss ( uvar, idim )  = unspecified_int4
	   uvar_lo_ww ( idim, uvar )  = unspecified_val8
	   uvar_hi_ww ( idim, uvar )  = unspecified_val8
	   uvar_by_ss ( idim, uvar )  = .FALSE.             !for bookkeeping
  	   uvar_given ( idim, uvar )  = uvlim_irrelevant
 320	CONTINUE

* by default assume that there are no pseudo-variables involved
	DO 330 idim = 1, nferdims
 330	uvar_mod_pseudo(idim,uvar) = .FALSE.

* successful completion
	status = ferr_ok
	RETURN

* error exit
 5000	RETURN
 5440	risc_buff = text(txstart:txend)
	CALL ERRMSG( ferr_syntax, status,
     .                  risc_buff(:TM_LENSTR1(risc_buff))
     .                  //pCR//buff, *5000 )
* 12/97 *kob*
 5500   CALL ERRMSG( ferr_expr_too_complex, status,
     .                  text(txstart:txend), *5000 )
 5600   slen = TM_LENSTR1(name)
        WRITE (risc_buff,*) 'error initializing ', name(:slen)
        slen = TM_LENSTR1(risc_buff)
        CALL ERRMSG( ferr_syntax, status,
     .               risc_buff(:slen), *5000 )

	END

    	SUBROUTINE XEQ_SHOW

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute the SHOW command

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 4/3/86
* revision 0.1 - 12/15/86
* revision 0.2 - 3/20/87 - changes for new TMAP library
* revision 0.3 - 5/1/87  - added SHOW MOVIE,SHOW LIST/OUT,
*			   SHOW EXPRESSION and SHOW REGION and "(default)" on
*			   SHOW DATA
* revision 0.4 - 5/1/87  - added SHOW VARIABLES/... and SHOW COMMANDS
* revision 0.5 - 6/30/87 - added variable subscript limits to SHOW VARI/DISK
* revision 0.6 - 7/15/87 - corrected arg 1 match on SHOW COMMAND name
* revision 0.7 - 8/29/87 - SHOW LIST updated for unformatted option
* revision 0.8 - 9/10/87 - SHOW LIST updated for BIBO option
* revision 0.9 - 9/16/87 - SHOW VAR --> SHOW DATA & SHOW MEMORY /added SHOW GRID
* revision 1.0 - 9/23/87 - SHOW REGION generalized to work with DEFINE REGION
* 			   and LIST heading option added
* revision 1.1 - 10/5/87 - revamped SHOW LIST logicals
* revision 1.2 - 2/18/88 - check for unspecified grid in SHOW GRID
* revision 1.3 - 3/25/88 - added list_TMAP, mode arguments and interrupts
* revision 1.4 - 4/7/88  - created sub. SHOW_DATA_SET - allow specified dset #
* revision 1.5 - 4/29/88 - allow specified variable in SHOW VAR
* revision 1.6 -  7/2/88 - modified SHOW LIST output
*			 - added SHOW WINDOWS
*			 - permitted SHOW MODE mode (named mode)
* revision 1.7 - 7/22/88 - added SHOW MEMORY/FREE using CHECK_MEMORY
* revision 1.8 - 7/28/88 - allow SHOW GRID to take grid or variable name with
*			   variable names having D= qualifiers
*			   SHOW DATA to accept name as well as number - default
*			   to /BRIEF
* revision 1.9 - 8/15/88 - added SHOW DATA/FILES
* revision 2.0 -  9/1/88 - added SHOW VIEWPORT
* revision 2.1 -11/23/88 - new TM IO library: FIND_LINE_NUMBER-->TM_GET_LINENUM
* revision 2.2 - 1/10/89 - SHOW GRID/ALL displays grid names, only
*			 - SHOW DATA defaults to name and variable list
* revision 2.3 - 2/16/89 - ds_open --> ds_name.EQ.char_init30 to test open-ness
* V200:  6/13/89 - SHOW_MEM_VARS doesn't require work space
*	10/20/89 - SHOW VARIABLES defaults to user-defined vars
*	10/29/89 - viewport 0 not showable
*	11/30/89 - SHOW GRID shows default and last
*	 12/6/89 - added mode_gks
* Unix/RISC port 4/25/91 *sh*: increased ds_name and xwind_node sizes
*                9/24/91 - increased size of "arg" to 8 characters for SHOW VAR
*                11/1/91 - 2 bug fixes: SHOW GRID
*                          1) check for unknown grid
*                          2) don't use comma item_list - it's used inside
* V230: 1/3/92 - added SHOW TRANSFORMS
*      5/14/92 - REMOTE_X mode was replaced by the REFRESH mode
*       6/8/92 - added SHOW ALIAS (allow arguments 7/29)
*       6/9/92 - SHOW LIST uses list_fmt_type
*      6/26/92 - commands, subcommands, and qualifiers 4-->8 characters
*     10/22/92 - added units on uvars, increased uvar name length
*     11/4+/92 - changed qualifiers and length of name on SHOW VIEWPORTS
*      11/9/92 - eliminate arguments from MODE GKS and MODE META
*      1/14/93 - updated SHOW MOVIE
* V300: 2/3/93 - added MODE VERIFY arguments
*      4/19/93 - old style vp's have negative vp_size and clip limits unknown
*      5/12/93 - added MODE PPLLIST and MODE JOURNAL filename
*      6/16/93 - added SHOW QUERIES
*       9/2/93 - reordered SHOW TRANSFORMS to group transforms better
* V301:1/12/94 - show MODE METAFILE filename
*      2/24/94 - incorporate a stack of past mode states
* V310:5/12/94 - fixed bug revealed by adding /ORDER to SET DATA (70th char)
* V320:5/17/94 - array "memory" is passed as argument
*	       - SHOW MEMORY now shows memory size, only
*     12/29/94 - added /FORMAT=STREAM to SHOW LIST 
* V320: 12/29/94 - use SPLIT_LIST to redirect tty output for GUI
*	 1/19/95 - explain "megaword" in SHOW MEMORY 
* V400:   2/6/95 - added SHOW SYMBOL
* V411:  7/95 - Added SHOW VAR output for  LET/D var = ...
* V420:  9/95 - added SHOW GRID/DYNAMIC
*	      - and SHOW LIST (tab and comma delimited formats)
*	11/95 - SHOW TRANSFORMS moved to 2 routines: SHOW_TRANSFORMS and
*						     SHOW_REGRID_TRANSFORMS
*	 4/96 - use arg_to_item to make comma-separated line blank sep
*	      - allow templates in SHOW VAR, GRID, AXIS, SYMBOL, ALIAS, VIEW
*		by using (case-sensitive) MATCH_TEMPLATE
*	      - changed SHOW VIEW and ALIAS from comma-separated to blank sep
*	      - added multi-argument capability to SHOW AXIS
*Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
* V420:  1/97 - bug fix: SHOW MEMORY/ALL is ignoring /ALL
* V450:  7/97 - don't show child variables in SHOW VARIABLE
*             - added SHOW FUNCTION -- with template matching (7/22)
* 97.07.31 *jc* - added external function code to SHOW FUNCTIONS
* *kob*  10/97 - added check for string length of zero at 1750.  This error
*                caught by new DEC f77 version
* V500 -3/99 *jc*  - added a blank line between internal and external functions
*                   - added /EXTERNAL qualifier to SHOW FUNCTION
*                   - fixed EFCN_MATCH_TEMPLATE to behave like MATCH_TEMPLATE
*                     so that multiple functions are shown
*       4/99 *sh* - added MODE STUPID:weak_cache
*       4/99 *sh* - added SHOW AXIS/lims=lo:hi
* V510 4/00 *sh* - netCDF grids are now dynamic
*      5/00 *sh* - added SHOW FUNC/DETAILS
* V522 7/00 *sh* - SHOW SYMBOLS now shows special symbols, too
* V530 8/00 *sh* - bug fix to SHOW SYMBOLS - avoid accidental PPL$XPIXEL eval
* V540 9/01 *sh* - SHOW VIEWPORT to show state of /AXES
* v540 *acm* 10/01 increase length of ds_name
* v540 *acm*  1/02 Change SHOW FUNC so that shared object files are 
*                  not listed on the command: SHO FUNC/INTERNAL func_name
* V554 *acm* 8/03  New calls to make XML-style output for SHOW DATA, SHOW DATA/VAR
*                  SHOW AXIS, SHOW GRID
* V554 *acm* 9/03  Add output for SHOW AXIS in /DODS binary format, 
*                  see the flag do_dods
* V570: *acm* 5/04 - add MODE GRATICULE[:argument] 
* V580: *acm* 10/04 - add xml tags <datasets>  </datasets>, dataset name and title
*                     <axes>  </axes> for SHOW AXIS/XML
* V580: *acm* 10/04 - Add xml output for global and dataset variables. SHOW_1_UVAR_XML
* V600: *acm*  7/05 Fix bug 1186: SHOW FUNC with * properly matches patterns for
*                   external functions as well as internally linked functions.
*                   call MATCH_TEMPLATE for all comparisons.
* V600  *acm*  8/05 Allow more digits in xrevision number
* V600: *acm*  6/05 - Attribute control: SHOW ATT varname[d=].attname SHOW ATT/ALL varname[d=]
*                     SHOW DATA/ATTR [d=]
* 9/06 *acm* 6.01  fixing bug 1439 long symbol values; change length of show_str to 2048
* V602  2/07 *acm* Fix bug 1492, changing attributes of coordinate variables 
* v604 *acm* 7/07 increase length of ds_name
* V604  *acm* 7/07 Dataset names have been increased to 1024, but on output this runs into
*                  conflicts with Fortran INQUIRE and OPEN calls. Disallow output names
*                  longer than 256 characters.
* V606  8/07 *acm* Send informational and error messages that are returned from 
*                  commands via SPLIT_LIST to std error rather than std out, but not
*                  the outputs of SHOW commands. These go to std out.
* V631 11/09 *acm* For XML-formatted output check for and replace the strings < > and &
*                  with &lt; etc.
* V65   3/10 *acm* Remove unused SHOW AXIS in /DODS binary format
* V65   3/10 *acm* SHOW/OUTFILE=  writes the output to a file rather than std out.
*                  Implemented so far only for SHOW AXIS, SHOW DATA, SHOW VAR, SHOW GRID,
*                  to be implemented for all SHOW subcommands in the future
* V67   *acm* 3/11 - Fix for ticket 1819, size of arg for MODE DESPERATE
* V67   *acm* 3/11 - Fix for ticket 1825, call cd_get_var_id instead of cd_get_var_seq
* v675  *acm  4/12 Fix ticket 1934, simpler SHOW ATTRIBUTE syntax.

*       *acm* 3/12 removing use of old GT and TS data formats
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm
* v675  *acm  4/12 Fix ticket 1934, simpler SHOW ATTRIBUTE syntax.
* V6.8  acm  6/12 Implement mode_6d_lab, set by default. If canceled, the 
*                 various SHOW commnands will not list info for E,F dimensions.
*                 SHOW with 6D variable and mode_6d_lab canceled, is an error.
* V683 *acm*  8/12 On SHOW LIST, show the output-type setting from SET LIST/OUTTYPE=  
* V685 *acm*  2/13 LET/REMOTE changes: show internally-defined climatological axes
*                  in xml output.
* V685 *acm*  6/13 Fixes for SHOW VAR/D= on file variables.
* V685 *sh*  9/13 Added SHOW VARIABLE/TREE  (a.k.a. /DEPENDENCIES)
* V690 *sh* 12/13 Added SHOW TRANSFORMS of auxiliary variable regridding
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long
* V690 *sh* 1/14 Add SHOW VAR/LAYERZ (formerly /SIGMA)
* V691+*acm* 8/14 Fix ticket 2188: SHOW MEMORY should say memory words are 8 bytes.
* V691+ 8/14 *acm* Fix ticket 2194: SHOW with /OUTFILE and not /XML. 
* V69+ *acm*  9/14 Ticket 1758. Memory request uses number of blocks not words
* V693+ 11/14 *sh* renaming 'sigma' as 'layerz' throughout
*        2/15 *sh* attempted but rejected hack to deal with left-over dset=-1
* V6796 11/15 *acm* Ticket 2322: report dataset name or number in error msg, 
*                   on SHOW DATA when datset not open
* V697  12/15 *acm* Changes to add details on SHOW GRID uvar to indicate 
*                   compressed or subset of axes
* V697  12/15 *acm* Fix call to routine SHOW_GRID
* V698 *sh* 1/16 Removed "Ferret-defined" annotation
* V698  2/16 *acm* For ticket 2352: variables defined with LET/D are
*                  added to that dataset in the attribute structure.
*           2/16 replaced char_init with char_init16 (untested) 
*                (this is the *only* place in all the code using char_init)
* V698  3/16 *acm* Removed Philander-Seigel code including diagnostic 
*                  variables, pre-defined axes and grids, cat_calc_var.
* V698  3/16 *acm* Changes for ticket 2078: improved SHOW COMMANDS
* V698  4/16 *acm* For ticket 2399: Apply MODE CALENDAR settings to F axes too
* V7    5/16 *acm* See ticket 2352. For LET/D variables look for info under that dataset
* V701 *acm* 10/16 Ticket 2422: variables uvar_grid, uvar_data_type, uvar_aux_cat, 
*                  uvar_aux_var to be replaced with calls to LIST routines in NCF_Util.c 
* V702 1/17 *sh* for trac enhancement #2369 -- dynamic memory management
* V720 3/17 *acm* Ticket 2132, attribute of user-defined variable, do not try to show dataset info

	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'gkscm2.cmn'
	include	'ferret.parm'
	include	'slash.parm'
	include 'errmsg.parm'
	include 'movies.parm'
	include 'gfdl_vms.parm'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xtext_info.cmn'
	include 'xcommand.cmn'
	include 'xrevision.cmn'
	include 'xinterrupt.cmn'
	include	'xfr_grid.cmn'
	include	'xgks_devices.cmn'
	include	'xalgebra.cmn'
	include	'xdependency_tree.cmn'
	include	'xgrid_chg_fcns.cmn'
	include 'xrisc.cmn'          ! 12/94 SPLIT_LIST buffer
        include 'EF_Util.cmn'
        include 'netcdf.inc'

* local parameter declarations:
	LOGICAL	    brief
	INTEGER	    len_show_str,
     .		    slash_mem_free,
     .		    slash_mem_diag,
     .		    slash_mem_temp,
     .		    slash_mem_perm,
     .		    slash_brief,
     .		    slash_full,
     .		    slash_vars,
     .		    slash_file,
     .		    slash_att,
     .		    slash_grid_dyn,
     .		    slash_var_dset,
     .		    slash_external,
     .		    slash_internal,
     .		    slash_xml,
     .		    slash_attr,
     .              slash_grid_xml,
     .              slash_axis_xml,
     .              slash_attr_dset,
     .              slash_attr_output
     .              
	PARAMETER ( len_show_str = 2048,		! length of output line buffer
     .		    brief	 = .TRUE.,
     .		    slash_mem_diag = 1 + 1,
     .		    slash_mem_temp = 1 + 2,
     .		    slash_mem_perm = 1 + 3,
     .		    slash_mem_free = 1 + 4,
     .		    slash_brief    = 1 + 1,
     .		    slash_full     = 1 + 2,
     .		    slash_vars     = 1 + 3,
     .		    slash_file     = 1 + 4,
     .		    slash_att      = 1 + 5,
     .		    slash_grid_dyn = 1 + 13,
     .		    slash_var_dset = 1 + 1,
     .		    slash_external = 1 + 2,
     .		    slash_internal = 1 + 3,
     .		    slash_xml      = 1 + 5,
     .		    slash_attr     = 1 + 6,
     .		    slash_grid_xml = 1 + 14,
     .		    slash_axis_xml = 1 + 13,
     .		    slash_attr_dset = 1 + 1,
     .		    slash_attr_output = 1 + 2)

* calling argument declarations:

* local variable declarations:
	LOGICAL	MATCH4, MATCH_TEMPLATE, IS_TEMPLATE, TM_HAS_STRING,
     .		NC_GET_ATTRIB, ITS_GIF_GRAPHICS, slash_all, limited_show, 
     .		nothing, sdetail, only_1, done_1, sfull, svars, sfile, 
     .		sbrief, first, sxml, clobber, append, firstxml, got_it, 
     .		coordvar, sattr, do_err, sho_out, its_gif, sh_att_dset, 
     .		lineok, sho_tree, uvgrid, showsub, sub_matched
	INTEGER TM_LENSTR1, TM_LENSTR, UVAR_NUMBER, STR_UPCASE,
     .		REGION_NUMBER, GRID_FROM_NAME, FIND_DSET_NUMBER,
     .		EFCN_MATCH_TEMPLATE, TM_GET_LINENUM, STR_SAME, TM_GET_GRIDNUM,
     .		category, mods_cx, grid, cx,
     .		status, iqual, mode, iset, i, icmnd, isub, n,
     .		len, len0, iuvar, ivar, dset, line, ivp, i1, i2,
     .		rqst_dset, tmp_grid, num_predefined_axes, 
     .          flen, wsize, len_test, len_mchars, outlist_file,
     .          j, num_indices, varid, attlen, maxlen, attype,
     .          vtype, nvdims, vdims(8), nvatts, iatt, dset_last,
     .          llen, loc, cat, var, attoutflag, all_outflag, dot, brkt,
     .          vseq, attid, save_deleted_list_result(max_uvar),
     .          cache_size, cache_nelems, cache_preemption,
     .          sho_file, idim, ndims, nvars, ngatts, recdim, npts,
     .          vartype, outflag, num_clim_1, num_clim_n,
     .          base_cx, base_isp, grid_blocks, lensub, len_msubs
        INTEGER saved_num_indices, saved_index_list(max_uvar),
     .                             arr_buff(max_uvar)
     
	INTEGER aux_cat(nferdims), aux_var(nferdims)  ! get info from LIST 

	REAL	xtemp, ytemp, attvals(100), cache_mb, cache_n, cache_p, rsize
	CHARACTER EXPR_NAME*8, TM_FMT*12, VAR_CODE*128, ALG_TRANS_CODE*3,
     .		default*10, show_str*2048, arg*128, name*128, argsym*120
	CHARACTER	varatt*641, varname*512, attname*128,
     .			efname*40, upname*40, aname*128, outstring*2048,
     .                  dname*128, sub4*4

* 10/01 *kob* had to change decl of axesOrCorner for picky f95
        CHARACTER*6 axesOrCorner(2)

	INTEGER efcn_scan

* local data declarations
        DATA axesOrCorner(1)/'axes '/,
     .       axesOrCorner(2)/'edges'/

* for string passing to C function in SHOW MODE FUNCTION
      INTEGER      slen, dlen
      PARAMETER  ( slen = ef_max_description )
#ifdef sun
      BYTE      fhol(slen)      ! c-type Hollerith string buffer
#else
      INTEGER*1 fhol(slen)      ! c-type Hollerith string buffer
#endif

* initialize
	show_lun = ttout_lun
	sxml = .FALSE.
!        IF (dset .EQ. -1) dset = unspecified_int4   ! 2/15: avoid left over -1

* command given with /ALL ?
	risc_buff = ' '
	slash_all = .FALSE.
	DO 10 iqual = 1, num_qualifiers
	IF ( qualifier_list( iqual ) .EQ. 1 ) slash_all = .TRUE.
 10	CONTINUE
	limited_show = subcmnd_num .NE. 1 .OR. .NOT. slash_all

* if the user entered a blank-separated list insteas of comma-separated
* then make it behave like a comma-separated list (4/96)
	CALL ARG_TO_ITEM

* select subcommand
	GOTO ( 100, 200, 300, 400, 500, 600, 700, 800, 900,1000,
     .        1100,1200,1300,1400,1500,1600,1700,1800,1900,2000,
     .	      2100,2200 )
     .								subcmnd_num

* SHOW '    ' - (no action)
* arrival at this point usually means an illegal subcommand was given
* and was assumed to be an argument by the command parser
 100	IF ( num_args .GE. 1 )
     .		CALL ERRMSG( ferr_invalid_subcmnd,status,
     .			cmnd_buff( arg_start(1):arg_end(1) ), *5000 )
	IF ( limited_show ) RETURN

* SHOW WINDOWS
 200	nothing = .TRUE.
	CALL SPLIT_LIST(pttmode_explct, show_lun, ' OPEN ACTIVE', 12)
	DO 210 i = 1, max_windows
	   IF ( wn_open( i ) ) THEN
	      nothing = .FALSE.
	      IF ( wn_active( i ) ) THEN
	         WRITE ( risc_buff, '(I4,T9,A)' ) i, '*'
	         CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	         risc_buff = ' '
	      ELSE
	         WRITE ( risc_buff, '(I4)' ) i
	         CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	         risc_buff = ' '
	      ENDIF
	   ENDIF
 210	CONTINUE
	IF ( nothing ) CALL SPLIT_LIST(pttmode_explct, show_lun,
     .		'   no windows open', 0) 
	IF ( limited_show ) RETURN

* SHOW REGION reg1,reg2,...,regn
 300	CONTINUE
* show default region
	IF ( num_args .EQ. 0 .OR. slash_all ) CALL SHOW_REGION( cx_last )
* show requested regions
	IF ( num_items .GE. 1 ) THEN
	   DO 320 i = 1, num_items
	      IF ( interrupted ) CALL ERRMSG
     .			( ferr_interrupt, status, ' ', *5000 )
	      arg = cmnd_buff( item_start(i):item_end(i) )
	      cx = REGION_NUMBER( arg )
	      IF ( cx .EQ. unspecified_int4 ) CALL ERRMSG
     .				( ferr_unknown_arg, status, arg, *5000 )
	      CALL SHOW_REGION( cx )
 320	   CONTINUE
	ELSEIF ( slash_all ) THEN
* show all user-defined and pre-defined regions
	   DO 330 cx = 0, min_context, -1
	      IF ( cx_name( cx ) .NE. unspecified_name4 )
     .			CALL SHOW_REGION( cx )
 330	   CONTINUE
	ENDIF
	IF ( limited_show ) RETURN

* SHOW AXIS
* show a particular named axis

400	IF ( num_args .EQ. 0 .AND. .NOT.slash_all ) THEN
	   CALL SPLIT_LIST(pttmode_explct, err_lun,
     .			'SHOW what axis ?', 0)
	   RETURN
	ENDIF
 	sxml  = qual_given( slash_axis_xml  ) .GT. 0 
        IF (sxml) firstxml = .TRUE.

* 	SHOW AXIS/FILE=[/APPEND][/CLOBBER]

        sho_file = qual_given( slash_show_axis_file )
	clobber = qual_given( slash_show_axis_clobber ) .GT. 0
	append = qual_given( slash_show_axis_append ) .GT. 0

	IF (sho_file .GT. 0) THEN
	   CALL OPEN_SHOW_FILE (show_lun, sho_file,  
     .                          clobber, append, status)
	   IF (status .NE. ferr_ok ) GOTO 5000
	ENDIF

* decode the limit qualifiers
	CALL STACK_PTR_UP ( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	mods_cx = cx_stack_ptr
	CALL INIT_CONTEXT_MODS( mods_cx )
	CALL GET_CONTEXT_MODS (	cx_last,
     .				cmnd_buff,
     .				mods_cx,
     .				max_qual_list,
     .				num_qualifiers,
     .				qual_start,
     .				qual_end,
     .				unknown_qual_ok,
     .				status	)
	IF ( status .NE. ferr_ok ) GOTO 5000

* "allocate" (use) scratch grid
        tmp_grid =  max_grids-2  ! see docs in TM_ALLO_DYN_GRID.F
        CALL INIT_GRID( tmp_grid, char_init16, mnormal )

* write column headings
        IF (.NOT.sxml) THEN
	   WRITE ( risc_buff, 3000 )
 3000	   FORMAT ( T2,'name',T13,'axis',T31,'# pts',T39,
     .           'start',T60,'end' )
	   CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
        ENDIF
	risc_buff = ' '
	IF ( num_args .GT. 0 ) THEN

	   DO 420 i = 1, num_items
* show the named line(s)
	      i1 = STR_UPCASE(name,cmnd_buff(item_start(i):item_end(i)))
*  ... first show the static lines
	      DO 410 line = 1, max_lines
	         IF ( interrupted ) CALL ERRMSG
     .			( ferr_interrupt, status, ' ', *5000 )
	         IF ( line_name(line) .EQ. char_init16 ) GOTO 410
	         IF ( line_name(line)(1:1) .EQ. '(' ) GOTO 410
	         IF (MATCH_TEMPLATE(line_name(line),name)) THEN
                   IF (sxml) THEN
                      IF (firstxml) THEN
                         risc_buff = '<axes>'
                         CALL SPLIT_LIST(pttmode_explct, show_lun,
     .                                risc_buff, 0)
                         firstxml = .FALSE.
                      ENDIF
                      CALL SHOW_LINE_XML( show_lun, line)

                   ELSE
                      CALL SHOW_LINE( line, .NOT.brief )
	              DO 405 i2 = 1, nferdims
	                IF (qual_given( slash_show_grid_x0+i2).GT.0
     .                 .OR. qual_given( slash_show_grid_i0+i2).GT.0)THEN
                         grid_line(i2,tmp_grid) = line
                         CALL SHOW_LINE_COORDS( tmp_grid, mods_cx, i2 )
                        ENDIF
 405                  CONTINUE
                   ENDIF

                 ENDIF
 410	      CONTINUE
*  ... then show the dynamic lines
              line = 0
 414          CALL TM_NEXT_DYN_LINE( line, *416)
	         IF ( interrupted ) CALL ERRMSG
     .			( ferr_interrupt, status, ' ', *5000 )
	         IF (MATCH_TEMPLATE(line_name(line),name)) THEN

                   IF (sxml) THEN
                      IF (firstxml) THEN
                         risc_buff = '<axes>'
                         CALL SPLIT_LIST(pttmode_explct, show_lun,
     .                                risc_buff, 0)
                         firstxml = .FALSE.
                      ENDIF
                      CALL SHOW_LINE_XML( show_lun, line)

                   ELSE
                      CALL SHOW_LINE( line, .NOT.brief )
	              DO 412 i2 = 1, nferdims
	                IF (qual_given( slash_show_grid_x0+i2).GT.0
     .              .OR. qual_given( slash_show_grid_i0+i2).GT.0) THEN
                         grid_line(i2,tmp_grid) = line
                         CALL SHOW_LINE_COORDS( tmp_grid, mods_cx, i2 )
                       ENDIF
 412                 CONTINUE
                   ENDIF

                 ENDIF
	         GOTO 414
 416          CONTINUE
 420	   CONTINUE
	ELSE

* show all the defined axes
*  ... first show the static lines (for XML output skip pre-defined axes)
           num_predefined_axes = TM_GET_LINENUM('EZ')
           num_clim_1 = TM_GET_LINENUM('MONTH_IRREG')
           num_clim_n = TM_GET_LINENUM('ABSTRACT') - 1
	   DO 450 line = 1, max_lines
	      IF ( interrupted ) CALL ERRMSG
     .			( ferr_interrupt, status, ' ', *5000 )
	      IF ( line_name(line) .EQ. char_init16) GOTO 450
              IF (.NOT.sxml) THEN
                 CALL SHOW_LINE( line, brief )
              ENDIF
	      lineok = ( line.GT.num_predefined_axes )
c	      lineok = ( line.GT.num_predefined_axes .OR.
c     .           (line.GE.num_clim_1 .AND. line.LE.num_clim_n) )
              IF (sxml .AND. lineok) THEN
                 IF (firstxml) THEN
                    risc_buff = '<axes>'
                    CALL SPLIT_LIST(pttmode_explct, show_lun,
     .                              risc_buff, 0)
                    firstxml = .FALSE.
                 ENDIF
                 CALL SHOW_LINE_XML( show_lun, line)
              ENDIF

 450	   CONTINUE
*  ... then show the dynamic lines
           line = 0
 460       CALL TM_NEXT_DYN_LINE( line, *470)
	      IF ( interrupted ) CALL ERRMSG
     .			( ferr_interrupt, status, ' ', *5000 )
              IF (sxml) THEN
                 IF (firstxml) THEN
                    risc_buff = '<axes>'
                    CALL SPLIT_LIST(pttmode_explct, show_lun,
     .                              risc_buff, 0)
                    firstxml = .FALSE.
                 ENDIF
                 CALL SHOW_LINE_XML( show_lun, line)

              ELSE
	         CALL SHOW_LINE( line, brief )
              ENDIF
              GOTO 460
 470       CONTINUE

	ENDIF
        IF (.NOT. firstxml .AND. sxml) THEN
           risc_buff = '</axes>'
           CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
        ENDIF
	
	IF (sho_file .GT. 0) CLOSE( UNIT = show_lun, ERR = 5000 )

	IF ( limited_show ) RETURN

* SHOW EXPRESSION
 500	IF ( num_uvars_in_cmnd .EQ. cmnd_uvars_not_given ) THEN
	   WRITE ( risc_buff, '(8X,A)' ) 
     .				'SET EXPRESSION has not been given or implied'
	   CALL SPLIT_LIST(pttmode_explct, err_lun, risc_buff, 0)
	   risc_buff = ' '
	ELSE
	   WRITE ( risc_buff, '(8X,A)' ) 'current output expression(s):'
	   CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	   risc_buff = ' '
	   DO 510 i = 1, num_uvars_in_cmnd
	      iuvar = UVAR_NUMBER( EXPR_NAME(i) )
	      IF ( iuvar .NE. unspecified_int4 ) THEN
	         WRITE (risc_buff,'(8X,A)')
     .			 uvar_text(iuvar)(:TM_LENSTR1(uvar_text(iuvar)))
	         CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	         risc_buff = ' '
	      ENDIF
 510	   CONTINUE
	ENDIF
	IF ( limited_show ) RETURN

* SHOW LIST
 600	WRITE ( risc_buff, 3600 ) '/PRECISION =', list_digits
	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	risc_buff = ' '
 3600	FORMAT ( 8X,'SET LIST',A,I4 )
        IF ( list_fmt_type .EQ. plist_unformatted ) THEN
	   WRITE ( risc_buff, 3605 ) 'UNFORMATTED'
	ELSEIF ( list_fmt_type .EQ. plist_epic ) THEN
	   WRITE ( risc_buff, 3605 ) 'EPIC'
	ELSEIF ( list_fmt_type .EQ. plist_cdf )   THEN
	   WRITE ( risc_buff, 3605 ) 'CDF'
	ELSEIF ( list_fmt_type .EQ. plist_stream )   THEN
	   WRITE ( risc_buff, 3605 ) 'STREAM'
	ELSEIF ( list_fmt_type .EQ. plist_comma_del )   THEN
	   WRITE ( risc_buff, 3605 ) 'COMMA_DELIMITED'
	ELSEIF ( list_fmt_type .EQ. plist_tab_del )   THEN
	   WRITE ( risc_buff, 3605 ) 'TAB_DELIMITED'
	ELSEIF ( list_format_given )	THEN
	   WRITE ( risc_buff, 3605 ) list_format(1:TM_LENSTR1(list_format))
	ELSE
	   WRITE ( risc_buff, 3605 ) '[Default]'
	ENDIF
	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	risc_buff = ' '
 3605	FORMAT ( 8X,'SET LIST/FORMAT = ',A )
	IF ( list_heading ) THEN
	   WRITE ( risc_buff, 3608 ) 'EN'
	ELSE
	   WRITE ( risc_buff, 3608 ) 'DIS'
	ENDIF
	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	risc_buff = ' '
 3608	FORMAT ( 8X,'SET LIST/HEADING is ',A,'ABLED' )
	IF ( list_append ) THEN
	   WRITE ( risc_buff, 3609 ) 'EN'
	ELSE
	   WRITE ( risc_buff, 3609 ) 'DIS'
	ENDIF
	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	risc_buff = ' '
 3609	FORMAT ( 8X,'SET LIST/APPEND is ',A,'ABLED' )
	IF ( list_file(1:4) .EQ. 'AUTO' ) THEN
	   WRITE ( risc_buff, 3620 ) list_file(1:TM_LENSTR1(list_file))//
     .							' [created by program]'
	ELSE
	   WRITE ( risc_buff, 3620 ) list_file(1:TM_LENSTR1(list_file))
	ENDIF
	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	risc_buff = ' '
 3620	FORMAT (8X,'SET LIST/FILE=',A,' ( when LIST/FILE is used )' )
	IF ( list_outtype(1:3) .EQ. 'DOU') WRITE ( risc_buff, 3630 ) 'Double'
	IF ( list_outtype(1:3) .EQ. 'FLO') WRITE ( risc_buff, 3630 ) 'Float'
	IF ( list_outtype(1:3) .EQ. 'INT') WRITE ( risc_buff, 3630 ) 'Int'
	IF ( list_outtype(1:3) .EQ. 'SHO') WRITE ( risc_buff, 3630 ) 'Short'
	IF ( list_outtype(1:3) .EQ. 'BYT') WRITE ( risc_buff, 3630 ) 'Byte'
	IF ( list_outtype(1:3) .EQ. 'DFL') WRITE ( risc_buff, 3630 ) '[Default]'

	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	risc_buff = ' '
 3630	FORMAT ( 8X,'SET LIST/OUTTYPE = ',A )

        CALL NETCDF4_SHOW_LIST_SETTINGS 
	IF ( limited_show ) RETURN

* SHOW DATA_SET
 700 	CALL SHOW_DATA(dset, status) 
  
        IF (status .NE. ferr_ok) GOTO 5000
	IF ( dset .EQ. unspecified_int4 ) GOTO 5071

	IF ( limited_show ) RETURN

* SHOW MODE mode
 800	WRITE ( risc_buff, 3800 )
	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	risc_buff = ' '
 3800	FORMAT( T7,'MODE',T23,'STATE',T36,'ARGUMENT' )
	slash_all = slash_all .OR. num_items .EQ. 0
	DO 850 mode = 1, max_modes
	   IF ( mode_name ( mode ) .EQ. pmode_unused ) GOTO 850
* show this mode ?
	   IF ( .NOT. slash_all ) THEN
              len_mchars = TM_LENSTR(mode_name(mode)(:4))
	      DO 810 i = 1, num_items
	         name = cmnd_buff( item_start(i):item_end(i) )
                 len_test = TM_LENSTR(name)
	         IF ( MATCH4( name, len_test,
     .             mode_name( mode),len_mchars )) GOTO 820
 810	      CONTINUE
	      GOTO 850	! no match
	   ENDIF
 820	   show_str = '      '//mode_name( mode )
	   IF ( mode_state( mode, 1 ) ) THEN
	      show_str(24:) = 'SET'
	   ELSE
	      show_str(21:) = 'CANCELED'
	   ENDIF
	   IF ( mode .EQ. pmode_time_lab ) THEN
	      show_str(36:) = date_labels( ABS(ax_dec_pt(t_dim)) )
	   ELSEIF ( mode .EQ. pmode_f_lab ) THEN
	      show_str(36:) = date_labels( ABS(ax_dec_pt(f_dim)) )
	   ELSEIF ( mode .EQ. pmode_verify ) THEN
	      show_str(36:) = verify_modes(mode_arg(mode,1))
	   ELSEIF ( mode .EQ. pmode_journal ) THEN
	      show_str(36:) = journal_file
	   ELSEIF ( mode .EQ. pmode_ppllist ) THEN
	      show_str(36:) = ppllist_file
	   ELSEIF ( mode .EQ. pmode_metafile ) THEN
	      show_str(36:) = meta_file			! from GKSCM2  1/94
	   ELSEIF ( mode .EQ. pmode_STUPID ) THEN
	      IF (mode_arg(mode,1).EQ.1) show_str(36:) = 'weak_cache'
	   ELSEIF ( mode .EQ. pmode_grat ) THEN
              dlen = TM_LENSTR1(mode_grat_buff)
	      show_str(36:) = mode_grat_buff(:dlen)
	   ELSEIF ( mode_arg( mode,1 ) .NE. unspecified_int4 ) THEN
	      WRITE ( show_str(36:42), '(I7)' ) mode_arg( mode,1 )
	      IF (STR_SAME(show_str(36:42), '*******') .EQ. 0) 
     .		 WRITE ( show_str(36:47), '(I11)' ) mode_arg( mode,1 )
	   ENDIF
	   CALL SPLIT_LIST(pttmode_explct, show_lun,
     .			show_str(:TM_LENSTR1(show_str)), 0)
 850	CONTINUE
	IF ( limited_show ) RETURN

* SHOW MOVIE
* Movies are discontinued with Ferret v6.6: NetCDF-4 / HDF5
 900    CONTINUE
        CALL WARN ( 'Movies are discontinued as of Ferret v6.6' )
	RETURN
        IF ( frame_file .EQ. ' ' ) THEN
           WRITE ( risc_buff, 3905 ) 'There is no SET MOVIE file name'
        ELSE
           WRITE ( risc_buff, 3905 ) 'SET MOVIE/FILE = '//
     .     frame_file(1:TM_LENSTR1(frame_file))
        ENDIF
	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	risc_buff = ' '
 	IF ( frame_file .eq. plaser_flag ) THEN
	   IF ( frame_on ) THEN
	      WRITE ( risc_buff, 3910 ) 'MOVIE', 'EN'
	   ELSE
	      WRITE ( risc_buff, 3910 ) 'MOVIE', 'DIS'
	   ENDIF
        ELSE
           IF ( frame_compress .EQ. 'RLE' ) THEN
              WRITE ( risc_buff, 3920 ) 'ON'
           ELSE
              WRITE ( risc_buff, 3920 ) 'OFF'
           ENDIF
        ENDIF
	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	risc_buff = ' '
 3905	FORMAT (8X,A)
 3910	FORMAT (8X,'SET ',A,' is ',A,'ABLED')
 3920	FORMAT (8X,'compression is ',A)
	IF ( limited_show ) RETURN

* SHOW VARIABLES

 1000   sxml  = qual_given(slash_show_var_xml) .GT. 0 
        IF (sxml) firstxml = .TRUE.

* get dset number if appropriate:  SHOW VAR/D=dset ...
	rqst_dset = unspecified_int4	
	iqual = qual_given( slash_var_dset )
	IF ( iqual .GT. 0 ) THEN
	   CALL EQUAL_STRING( cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .			   show_str, status )  ! show_str is just a buffer
	   IF ( status .NE. ferr_ok ) RETURN
	   IF ( show_str .NE. ' ' ) THEN
	      rqst_dset = FIND_DSET_NUMBER( show_str )
	      IF ( rqst_dset .EQ. unspecified_int4) THEN
	         CALL WARN('Unknown data set: '
     .			//show_str(:TM_LENSTR1(show_str)))
	         RETURN
	      ENDIF
	   ENDIF
	ENDIF

* ... SHOW VARIABLE/LAYERZ varname [,varname2, ...]
	IF (qual_given(slash_show_var_layerz) .GT. 0) THEN
	   IF (slash_all .OR. num_args.EQ.0) THEN
*    ... get list of varIDs of all variables that have __LayerzRef_ attribute
              CALL GET_FVARS_LIST_BY_ATTNAME_AND_VAL
     .            (patnam_layerz, unspecified_name4, max_uvar,
     .             arr_buff, saved_index_list, num_indices)
              CALL GET_UVARS_LIST_BY_ATTNAME_AND_VAL
     .	          (patnam_layerz, unspecified_name4, max_uvar-num_indices,
     .             arr_buff(num_indices+1),
     .             saved_index_list(num_indices+1), n )
              num_indices = num_indices + n
              IF (num_indices.EQ.0) RETURN
           ELSE
*    ... get list of varIDs of all variables requested
              num_indices = num_items
	      DO i1 = 1, num_indices
	         i2 = STR_UPCASE(varname,
     .			         cmnd_buff(item_start(i1):item_end(i1)))
                 len = item_end(i1) - item_start(i1) + 1
	         dset = unspecified_int4    ! to be determined during parse
	         CALL PARSE_NAM_DSET( varname, cx_last, dset,
     .			              cat, var, mods_cx, status )
	         IF ( status .NE. ferr_ok ) RETURN
	         IF ( var .EQ. munknown_var_name ) THEN
                    arg = varname
                    GOTO 5100    ! unknown variable
                 ENDIF
* get the variable ID in the linked list  (user vars stored under dset=pdset_uvars?)
                 IF (cat .EQ. cat_user_var) THEN 
                    rqst_dset = pdset_uvars  

* See if it's a LET/D variable, info stored with its dataset not pdset_uvars
                    CALL CD_GET_VAR_ID (rqst_dset, varname, varid, status)
                    IF (rqst_dset.EQ.pdset_uvars .AND. status.NE.ferr_ok) THEN
                       rqst_dset = dset
                       CALL CD_GET_VAR_ID (rqst_dset, varname, varid, status)
                    ENDIF
                    IF (status.NE.ferr_ok) GOTO 5100
                 ELSE
                    rqst_dset = dset
		    CALL CD_GET_VAR_ID (rqst_dset, varname, varid, status)
                 ENDIF

                 arr_buff(i1) = varid
                 saved_index_list(i1) = rqst_dset
              ENDDO
           ENDIF
* loop through the requested variables displaying layerz info
           DO i1 = 1, num_indices
* get the attribute value of '__LayerzRef_' (patnam_layerz)
              varid = arr_buff(i1)
              dset  = saved_index_list(i1)
              maxlen = size_rbuff
              CALL CD_GET_VAR_INFO (dset, varid, varname, vtype,
     .                              nvdims, vdims, nvatts, coordvar, 
     .                              all_outflag, status)
              len = TM_LENSTR1(varname)
              got_it = NC_GET_ATTRIB ( dset, varid, patnam_layerz,
     .                                 .TRUE., varname, maxlen,
     .                                 attlen, attoutflag, risc_buff,
     .                                 attvals )
              IF (.NOT.got_it) THEN
* ... we only arrive here if request was for named vars: SH VAR/SIG a, b, c
* ... no explicit layerz reference defined for this variable
                 show_str =
     .         '  No variable holds vertical (layerz) coordinates of '
     .                // varname(:len)

* look for inherited layerz dependencies 
	         dset = unspecified_int4    ! to be determined during parse
	         CALL PARSE_NAM_DSET( varname, cx_last, dset,
     .			              cat, var, mods_cx, status )
                 IF (cat .EQ. cat_user_var) THEN
* ... trigger grid-getting, which also gets layerz associations

                    grid = GRID_FROM_NAME
     .                    (cmnd_buff(item_start(i1):item_end(i1)),
     .			  cx_last, status )

c                    CALL GET_SAVED_UVAR_AUX_INFO(var, dset,
c     .				           aux_cat, aux_var, status)
c
c                    IF (status .EQ. ferr_ok) THEN
c		       IF (uvar_aux_stat(var, z_dim).EQ.paux_stat_conflict) THEN
c		          show_str = '   Components in the definition of ' // 
c     .		          varname(:len) //
c     .		           ' have conflicting LAYERZ references'
c		       ELSEIF (uvar_aux_stat(var,z_dim).EQ.paux_stat_passed
c     .		          .OR. uvar_aux_stat(var,z_dim).EQ.paux_stat_needed) THEN
c
c		          risc_buff = VAR_CODE(aux_cat(idim), aux_var(idim))
c		          attlen = TM_LENSTR1(risc_buff)
c		          show_str = '  ' // risc_buff(:attlen) //
c     .		           ' holds the vertical (layerz) coordinates of ' //
c     .		            varname(:len)
c		       ELSEIF (uvar_aux_stat(var,z_dim).EQ.paux_stat_used) THEN
c		          show_str = '  The definition of ' // 
c     .                            varname(:len) //
c     .                     ' contains explicit regrids of'//
c     .                     ' its LAYERZ coordinates'
c		       ENDIF 
c                    ELSE ! status from GET_SAVED_UVAR_AUX_INFO
c		       PRINT *, 'ERROR getting saved uvar_aux info !!!!!'
c                    ENDIF ! status from GET_SAVED_UVAR_AUX_INFO
                 ENDIF   ! is a uvar
              ELSE
* ... show the explicit __layerz_ref_ attribute value
                show_str = '  ' // risc_buff(:attlen) //
     .         ' holds the designated vertical (layerz) coordinates of ' //
     .          varname(:len)
              ENDIF
	      CALL SPLIT_LIST(pttmode_explct, show_lun, show_str, 0)
           ENDDO
           RETURN
	ENDIF

* 	SHOW VARIABLES/FILE=[/APPEND][/CLOBBER]

        sho_file  = qual_given( slash_show_var_file    )
	clobber   = qual_given( slash_show_var_clobber ) .GT. 0
	append    = qual_given( slash_show_var_append  ) .GT. 0
        sho_tree  = qual_given( slash_show_var_tree    ) .GT. 0

	IF (sho_file .GT. 0) THEN
	   CALL OPEN_SHOW_FILE (show_lun, sho_file, 
     .                          clobber, append, status)
	   IF (status .NE. ferr_ok ) GOTO 5000
	ENDIF

!* ... SHOW VARIABLES/DIAGNOSTIC
!        IF ( (slash_all .AND. .NOT.sho_tree)
!     .  .OR. qual_given(slash_show_var_diag) .GT. 0 ) THEN
!	   IF ( num_args .GT. 0 ) THEN
!	      arg = cmnd_buff(arg_start(1):arg_end(1))
!	   ELSE
!	      arg = unspecified_name4
!	   ENDIF
!	   rsize = FLOAT(max_mrs)
!	   
!* COMPUTE # BLOCKS NEEDED
!	   grid_blocks = ( INT(rsize) + mem_blk_size - 1 ) / mem_blk_size
!
!	   CALL GET_MEMORY( INT(rsize), grid_blocks, v1_blk1, v1_nblks, status )
!	   IF ( status .NE. ferr_ok ) GOTO 5000
!c	   CALL SHOW_DIAG_VARS( arg, memory(1,v1_blk1) )
!	   CALL FREE_MEMORY( v1_blk1, v1_nblks )
!	ENDIF

* ... SHOW VARIABLE/TREE [expr]
        IF ( sho_tree ) THEN 
*     /TREE=USER and /TREE=FILE
	   iqual = qual_given( slash_show_var_tree )
	   CALL EQUAL_STRING(cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .			   show_str, status )  ! show_str is just a buffer
	   IF ( status .NE. ferr_ok ) RETURN
	   IF     ( show_str(1:1) .EQ. 'A'
     .     .OR.     slash_all             ) THEN
             dependency_tree_show_uvars = .TRUE.  ! show all vars
             dependency_tree_show_fvars = .TRUE.
	   ELSEIF ( show_str(1:1) .EQ. ' '
     .         .OR. show_str(1:1) .EQ. 'U') THEN
             dependency_tree_show_uvars = .TRUE.  ! show user vars only
             dependency_tree_show_fvars = .FALSE.
	   ELSEIF ( show_str(1:1) .EQ. 'F' ) THEN
             dependency_tree_show_uvars = .FALSE. ! show file vars only
             dependency_tree_show_fvars = .TRUE.
           ELSE
              GOTO 5150
           ENDIF
           base_isp = 8
           base_cx = 8
           CALL INIT_DEPENDENCIES( cx_last, .TRUE., base_isp, status )
           IF (status.NE. ferr_ok) GOTO 5050
           IF (slash_all .OR. num_args.EQ.0) THEN
*       SHOW VAR/TREE  [no expression] with or without /ALL -- shows all uvars
              CALL DELETE_OLD_EXPR
              CALL deleted_list_get_undel(uvar_num_items_head, 
     .                          deleted_list_result(1),
     .                          max_uvar, num_indices )
              IF (num_indices .EQ. 0) GOTO 1010
* ... we need to save a private copy of the index list, else it gets corrupted
*       by a call to delete_list_get_undel in INIT_DEPENDENCIES
              saved_num_indices = num_indices
              DO 1007 i = 1, saved_num_indices
 1007         saved_index_list(i) = deleted_list_result(i)
              DO 1008 i = 1, saved_num_indices
                 CALL CRAWL_DEPENDENCIES
     .                          ( 
     .                          uvar_name_code(saved_index_list(i)), 
     .                          base_cx, status )
                 IF (status .NE. ferr_ok) GOTO 5050
 1008         CONTINUE
	   ELSE
*       SHOW VAR/TREE  expr1, expr2, ...
*  ... multiplicity of items is handled by BREAK_UP_EXPR in CRAWL_DEPENDENCIES
              CALL CRAWL_DEPENDENCIES
     .                   ( 
     .                     cmnd_buff(item_start(1):item_end(num_items)), 
     .                     base_cx, status )
              IF (status .NE. ferr_ok) GOTO 5050
           ENDIF
           CALL DISPLAY_DEPENDENCY( workmem(plegacy_work_buffer)%ptr )
 1010      CALL EXIT_DEPENDENCY_MODE
            IF (sho_file .GT. 0) CLOSE( UNIT = show_lun, ERR = 5000 )
           RETURN
        ENDIF

* ... SHOW VARIABLES/USER
	IF ( slash_all .OR. qual_given(slash_show_var_diag) .EQ. 0 ) THEN
* ... get dset number if appropriate:  SHOW VAR/USER/D=dset ...
	   iqual = qual_given( slash_var_dset )
	   IF ( iqual .GT. 0 ) THEN
	      CALL EQUAL_STRING( cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .			      show_str, status )  ! show_str is just a buffer
	      IF ( status .NE. ferr_ok ) GOTO 4030
	      IF ( show_str .EQ. ' ' ) THEN
	         rqst_dset = pdset_irrelevant	! global variables
	      ELSE
	         rqst_dset = FIND_DSET_NUMBER( show_str )
	         IF ( rqst_dset .EQ. unspecified_int4) THEN
	            CALL WARN('Unknown data set: '
     .			//show_str(:TM_LENSTR1(show_str)))
	            GOTO 4030
	         ENDIF
	      ENDIF
	   ELSE
	      rqst_dset = unspecified_int4	! all variables
	   ENDIF
* ... SHOW VAR specific_var ... various cases of how to show:
*	SHOW VAR name		- show ALL user variables of this name
*	SHOW VAR name[D=n]	- show only variable from named data set
*	SHOW VAR/D=n name	- show only variable from named data set

	   IF ( num_args .GT. 0 ) THEN
	      DO 1020 i = 1, num_items
	         i1 = STR_UPCASE(arg,cmnd_buff(item_start(i):item_end(i)))

	         IF ( INDEX(arg,'[') .GT. 0 ) THEN
* ... bug (minor): square brackets **may** not contain D=dset information
* 	a work-around: pass a context with data set info (instead of cx_last)
		    dset = pdset_irrelevant	! default (not used ...)
                    CALL PARSE_NAM_DSET(arg, cx_last, dset,
     .				     category, ivar, mods_cx, status)
                    IF (dset .EQ. pdset_irrelevant .AND. 
     .                  rqst_dset .NE. unspecified_int4)
     .                         dset = rqst_dset
	            IF (status .EQ. ferr_ok) THEN 
                       IF (category .EQ. cat_user_var) THEN
                          IF (sxml) THEN
	                     CALL SHOW_1_UVAR_XML 
     .                         (show_lun,ivar,show_str,firstxml)
                          ELSE
	                    CALL SHOW_1_UVAR
     .                      (show_lun,ivar,show_str,' ',.TRUE.)
                          ENDIF

*  if not a user var, see if its a dataset variable from a nc file.
                       ELSE
                         len = INDEX(arg,'[') - 1
                         IF (INDEX(arg,'.') .NE. 0) GOTO 5100
			 CALL CD_GET_VAR_ID (dset, arg(:len), varid, status)
                         IF (status .EQ. ferr_ok) THEN
			    CALL SHOW_1_DSVAR (show_lun, dset, arg, varid)
                         ENDIF
                       ENDIF

                    ENDIF
	         ELSEIF (  rqst_dset .NE. unspecified_int4) THEN
		    CALL FIND_VAR_NAME(rqst_dset,arg,category,ivar)
	            IF ( ivar .EQ. munknown_var_name
     .		        .OR. category .NE. cat_user_var ) THEN
     
*  if not a user var, see if its a dataset variable from a nc file.
                       len = TM_LENSTR1(arg)
                       IF (INDEX(arg,'.') .NE. 0) GOTO 5100
                       CALL CD_GET_VAR_ID (rqst_dset, arg(:len), varid, status)
                       IF (status .EQ. ferr_ok)  THEN
		          CALL SHOW_1_DSVAR (show_lun, rqst_dset, arg, varid)
                       ELSE 
                          GOTO 5100
                       ENDIF
                    ELSE
                       IF (sxml) THEN
	                  CALL SHOW_1_UVAR_XML 
     .                      (show_lun,ivar,show_str,firstxml)
                       ELSE
	                 CALL SHOW_1_UVAR
     .                      (show_lun,ivar,show_str,' ',.TRUE.)
                       ENDIF
                    ENDIF
	         ELSE
* ... show ALL user variables matching this name (or name template 4/96)
*	            DO 1015 ivar = 1, max_uvar
*	               IF (uvar_num_items(ivar).EQ.uvar_deleted) GOTO 1015
                    CALL deleted_list_get_undel(uvar_num_items_head,
     .                                         deleted_list_result(1),
     .                                         max_uvar, num_indices )
                    DO 1012, i2 = 1, max_uvar
                      save_deleted_list_result(i2) = 
     .                       deleted_list_result(i2)
 1012	            CONTINUE
                    DO 1015 j = 1, num_indices
                       ivar = save_deleted_list_result(j)
	               IF ( uvar_parent(ivar).NE.0
     .		      .AND. .NOT.mode_diagnostic   ) GOTO 1015     ! 7/97
!	               IF (MATCH_NAME(arg,uvar_name_code(ivar)))

                       IF (MATCH_TEMPLATE(uvar_name_code(ivar),arg))THEN
                         IF (sxml) THEN
     			    CALL SHOW_1_UVAR_XML
     .                         (show_lun,ivar,show_str,firstxml)
                         ELSE
     			    CALL SHOW_1_UVAR
     .				(show_lun, ivar, show_str,' ',.TRUE.)
                         ENDIF
                      ENDIF
 1015	            CONTINUE
	         ENDIF
 1020	      CONTINUE
	   ELSEIF (rqst_dset .NE. unspecified_int4) THEN
* ... show user variables belonging to the specified data set
*	      DO 1030 i = 1, max_uvar
*	         IF (uvar_num_items(i) .EQ. uvar_deleted  ) GOTO 1030
              CALL deleted_list_get_undel(uvar_num_items_head,
     .                                    deleted_list_result(1),
     .                                    max_uvar, num_indices )
              DO 1022, i2 = 1, max_uvar
                save_deleted_list_result(i2) = deleted_list_result(i2)
 1022         CONTINUE
              DO 1030 j = 1, num_indices
                 i = save_deleted_list_result(j)
	         IF (uvar_name_code(i)(1:3) .EQ. 'EX#'    ) GOTO 1030
	         IF ( rqst_dset .NE. uvar_dset(i)	  ) GOTO 1030
	         IF ( uvar_parent(i).NE.0
     .		 .AND. .NOT.mode_diagnostic		  ) GOTO 1030  ! 7/97
                 IF (sxml) THEN
                    CALL SHOW_1_UVAR_XML 
     .                      (show_lun,i,show_str,firstxml)
                 ELSE
                    CALL SHOW_1_UVAR
     .                 (show_lun,i,show_str,'     ',.TRUE.)
                 ENDIF
 1030	      CONTINUE
	   ELSE
* ... show ALL user variables of every stripe
* ... 8/95 sorted by data set
	      IF (.NOT. sxml) CALL SPLIT_LIST(pttmode_explct, show_lun,
     .			' Created by DEFINE VARIABLE:', 0)
* ... locate the highest data set number in use
	      DO 1035 i1 = maxdsets, 1, -1
	         IF ( ds_name(i1) .NE. char_init1024) GOTO 1040
 1035	      CONTINUE
 1040	      DO 1060 dset = 1, i1
* ... loop through the currently initialized data sets
*	         DO 1050 i = 1, max_uvar
*	            IF (uvar_num_items(i) .EQ. uvar_deleted  ) GOTO 1050
                 CALL deleted_list_get_undel(uvar_num_items_head,
     .                                      deleted_list_result(1),
     .                                      max_uvar, num_indices )
     
                 DO 1042, i2 = 1, max_uvar
                    save_deleted_list_result(i2) = 
     .		      deleted_list_result(i2)
 1042            CONTINUE
                 DO 1050 j = 1, num_indices
                    i = save_deleted_list_result(j)
	            IF (uvar_name_code(i)(1:3) .EQ. 'EX#'    ) GOTO 1050
	            IF ( dset .NE. uvar_dset(i)		     ) GOTO 1050
	            IF ( uvar_parent(i).NE.0
     .		    .AND. .NOT.mode_diagnostic		     ) GOTO 1050 ! 7/97

                    IF (sxml) THEN
                       CALL SHOW_1_UVAR_XML
     .                      (show_lun,i,show_str,firstxml)
                    ELSE
                       CALL SHOW_1_UVAR
     .                    (show_lun,i,show_str,'     ',.TRUE.)
                    ENDIF

 1050	         CONTINUE
 1060	      CONTINUE
* ... global variables defined without /D

	      first = .TRUE.

              CALL deleted_list_get_undel(uvar_num_items_head,
     .                                    deleted_list_result(1),
     .                                    max_uvar, num_indices )
              DO 1062, i2 = 1, max_uvar
                    save_deleted_list_result(i2) = 
     .		      deleted_list_result(i2)
 1062         CONTINUE
              DO 1070 j = 1, num_indices
                 i = save_deleted_list_result(j)
	         IF (uvar_name_code(i)(1:3) .EQ. 'EX#'    ) GOTO 1070
	         IF ( uvar_dset(i) .NE. unspecified_int4  ) GOTO 1070
	         IF ( uvar_parent(i).NE.0
     .		 .AND. .NOT.mode_diagnostic		  ) GOTO 1070  ! 7/97

                 IF (sxml) THEN
                    CALL SHOW_1_UVAR_XML
     .                      (show_lun,i,show_str,firstxml)
                 ELSE
		    IF ( first ) THEN
	               CALL SPLIT_LIST(pttmode_explct, show_lun,
     .	  ' >>> Definitions that replace any file variable of same name:'
     .    , 0)
	               first = .FALSE.	            
	            ENDIF
                    CALL SHOW_1_UVAR
     .                 (show_lun,i,show_str,'     ',.TRUE.)
                 ENDIF

 1070	      CONTINUE
* ... global variables defined with /D
	      first = .TRUE.
*	      DO 1080 i = 1, max_uvar
*	         IF (uvar_num_items(i) .EQ. uvar_deleted  ) GOTO 1080
              CALL deleted_list_get_undel(uvar_num_items_head,
     .                                    deleted_list_result(1),
     .                                    max_uvar, num_indices )
              DO 1072, i2 = 1, max_uvar
                    save_deleted_list_result(i2) = 
     .		      deleted_list_result(i2)
 1072         CONTINUE
              DO 1080 j = 1, num_indices
                 i = save_deleted_list_result(j)
	         IF (uvar_name_code(i)(1:3) .EQ. 'EX#'    ) GOTO 1080
	         IF ( uvar_dset(i) .NE. pdset_irrelevant  ) GOTO 1080
	         IF ( uvar_parent(i).NE.0
     .		 .AND. .NOT.mode_diagnostic		  ) GOTO 1080  ! 7/97

                 IF (sxml) THEN
                    CALL SHOW_1_UVAR_XML
     .                      (show_lun,i,show_str,firstxml)
                 ELSE
		    IF ( first ) THEN
	               CALL SPLIT_LIST(pttmode_explct, show_lun,
     .	' >>> Definitions used if no file variable of this name exists:'
     .    , 0)
	               first = .FALSE.	            
	            ENDIF
                    CALL SHOW_1_UVAR
     .                 (show_lun,i,show_str,'     ',.TRUE.)
                 ENDIF



 1080	      CONTINUE
	   ENDIF
 4010	FORMAT (1x,A,' = ',A)
 4020	FORMAT (T20,'"',A,'"')
	ENDIF
        IF (.NOT. firstxml .AND. sxml) THEN
           risc_buff = '</global>'
           CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
        ENDIF
 4030	CONTINUE
	IF (sho_file .GT. 0) CLOSE( UNIT = show_lun, ERR = 5000 )

	IF ( limited_show ) RETURN

* SHOW COMMAND/ALL /BRIEF [name] [subcommand]
 1100	only_1 = num_args .GT. 0
 
* /BRIEF or full list of subcommands and qualifiers?
 	sbrief  = qual_given( slash_brief ) .GT. 0 

	done_1 = .FALSE.
	IF ( .NOT.only_1 ) THEN
           show_str = TM_FMT(revision_level, 5, 12, dlen)
	   WRITE (risc_buff, 4100)
     .				program_name(1:len_program_name),
     .				progname_mod (1:len_progname_mod),
     .				show_str(1:dlen)
	   CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	   risc_buff = ' '
 4100	   FORMAT(' Commands in Program ',A,1X,A,' version',A,':')
	ENDIF
* ... loop through commands
        len_test = TM_LENSTR(cmnd_buff(arg_start(1):arg_end(1)))

* ... did they give a subcommand?
	sub_matched = .FALSE.
	showsub = (num_args .GE. 2)
	IF (showsub) THEN
	   sub4 = cmnd_buff(arg_start(2):arg_end(2))
	   IF ( INDEX(sub4,'/') .GT. 0) sub4 = sub4(:INDEX(sub4,'/')-1) 
           lensub = TM_LENSTR(sub4)
	ENDIF

	DO 1130 icmnd = 1, total_num_commands
	   IF ( commands(icmnd)(:4) .EQ. '****' ) GOTO 1130
	   IF (done_1) GOTO 1130
	   IF ( interrupted ) CALL ERRMSG
     .			( ferr_interrupt, status, ' ', *5000 )
* ... if  only 1 command is of interest is this it ?
           len_mchars = TM_LENSTR(commands(icmnd)(:4))
	   IF ( only_1 .AND. .NOT.MATCH4(cmnd_buff(arg_start(1):arg_end(1)),
     .		len_test,commands(icmnd),len_mchars) ) GOTO 1130
	   IF (only_1) done_1 = .TRUE.
	   len0 = TM_LENSTR1( commands(icmnd) )

* ... and for each command, its subcommands

	   DO 1120 isub = subcommand_pointer(icmnd),
     .			  subcommand_pointer(icmnd)+num_subcommands(icmnd)-1
              
	      IF ( subcommands(isub)(:4) .EQ. '****' ) GOTO 1120
	      IF (showsub) THEN 
	         len_msubs = TM_LENSTR(subcommands(isub)(:4)) 
	         IF (MATCH4(sub4,lensub, subcommands(isub),len_msubs)) THEN
                    IF (sub_matched) GOTO 1120  
		    sub_matched = .TRUE. ! return the first match, which is what Ferret will use
	         ELSE
		    GOTO 1120
	         ENDIF
	      ENDIF

	      show_str = commands(icmnd)(:len0) // ' ' // subcommands(isub)
	      len = TM_LENSTR1( show_str )

* ... and for each subcommand, its qualifiers (except on /BRIEF listing)
              IF (sbrief) GOTO 1115
	      DO 1110 iqual =   qualifier_pointer(isub),
     .				qualifier_pointer(isub)+num_qualifs(isub)-1
	         IF ( qualifiers(iqual)(:4) .EQ. '****' ) GOTO 1110
	         show_str = show_str(1:len) // '/' // qualifiers(iqual)
	         len = len + 1 + TM_LENSTR1( qualifiers(iqual) )
	         IF ( len .GE. 70 ) THEN
	            CALL SPLIT_LIST(pttmode_explct, show_lun,
     .				' '//show_str, len+1)
	            show_str = ' '
	            len = len0 + 2
	         ENDIF
 1110	      CONTINUE
 1115	      IF ( show_str .NE. ' ' ) CALL SPLIT_LIST
     .			(pttmode_explct, show_lun, ' '//show_str, len+1)

*  ... brief listing, show only the command names (if all commands)
	   IF (sbrief .AND. .NOT.only_1) GOTO 1130
 1120	   CONTINUE
 1130	CONTINUE
	IF ( only_1 .AND. .NOT.done_1 ) THEN
	   WRITE (risc_buff, 4150)
     .					cmnd_buff( arg_start(1):len_cmnd )
	   CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	   risc_buff = ' '
 4150	   FORMAT(' Not a recognized command: ',A)
	ENDIF
	IF ( .NOT.(only_1.AND.done_1) ) THEN
	   CALL SPLIT_LIST(pttmode_explct, show_lun,' ', 1)
	   CALL SPLIT_LIST(pttmode_explct, show_lun,
     .		' Use SHOW ALIAS to see alternative command names', 0)
	ENDIF
 1199	IF ( limited_show ) RETURN

* SHOW MEMORY
 1200   IF ( qual_given(slash_mem_diag) .GT. 0 ) THEN
* ... SHOW MEMORY/DIAGNOSTIC
           IF (nsplits .EQ. 0) THEN
	      CALL SPLIT_LIST(pttmode_explct, show_lun,
     .             '    No split/gather occurred in the last evaluation', 0)
           ELSE
	      CALL SPLIT_LIST(pttmode_explct, show_lun,
     .             '    Last gather', 0)
	      CALL SPLIT_LIST(pttmode_explct, show_lun,
     .             '        Variable    Axis   Xform     '
     .             //'Chunk    Repeated', 0)
              DO i = 1, nsplits
                 name = VAR_CODE(split_cat(i), split_var(i))
                 WRITE (risc_buff, 4201)
     .                          name,
     .                          ww_dim_name(split_axis(i)),
     .                          ALG_TRANS_CODE(split_trans(i)),
     .                          split_frag(i),
     .                          split_repeats(i)
	         CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)

                 IF (i .EQ. max_splits) THEN
                    CALL SPLIT_LIST(pttmode_explct, show_lun,
     .                      " ... and others", 0)
                    EXIT
                 ENDIF
              ENDDO
           ENDIF
* ... run the memory diagnostic as part of /DIAGNOSTIC
	   CALL CHECK_MEMORY( show_lun )
        ENDIF
 4201   FORMAT(8x,A15,A1,A8,I10,I12)

        CALL SHOW_MEM_USAGE_LINE('SET MEMORY/SIZE', max_mem_allowed)
        CALL SHOW_MEM_USAGE_LINE('Peak demand', peak_essential_mem)
        CALL SHOW_MEM_USAGE_LINE('Current cache', total_mem)
        IF (permanent_mem .NE. 0 ) THEN
           CALL SHOW_MEM_USAGE_LINE('Permanent', permanent_mem)
        ENDIF

	IF ( qual_given( slash_mem_free ) .GT. 0 ) THEN
	   CALL CHECK_MEMORY( show_lun )
	ELSEIF( slash_all
     .     .OR. qual_given(slash_mem_temp) .GT. 0
     .	   .OR. qual_given(slash_mem_perm) .GT. 0 ) THEN
	   CALL SHOW_MEM_VARS
	ENDIF
	IF ( limited_show ) RETURN

* SHOW GRID grid_or_var1 grid_or_var2 ... grid_or_varN
* first examine the context info ( /X ... etc. )
 1300	CALL STACK_PTR_UP ( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	mods_cx = cx_stack_ptr
 	sxml  = qual_given( slash_grid_xml  ) .GT. 0 


* 	SHOW GRID/OUTFILE=[/APPEND][/CLOBBER]
        sho_file = qual_given( slash_show_grid_file )
	clobber = qual_given( slash_show_grid_clobber ) .GT. 0
	append = qual_given( slash_show_grid_append ) .GT. 0

	IF (sho_file .GT. 0) THEN
	   CALL OPEN_SHOW_FILE (show_lun, sho_file,  
     .                          clobber, append, status)
	   IF (status .NE. ferr_ok ) GOTO 5000
	ENDIF

	CALL INIT_CONTEXT_MODS( mods_cx )
	CALL GET_CONTEXT_MODS (	cx_last,
     .				cmnd_buff,
     .				mods_cx,
     .				max_qual_list,
     .				num_qualifiers,
     .				qual_start,
     .				qual_end,
     .				unknown_qual_ok,
     .				status	)
	IF ( status .NE. ferr_ok ) GOTO 5000

	IF ( num_args .GE. 1 ) THEN

* loop through the variables named 
! bug fix: 11/91 *sh* : changed comma list to blank-separated argument list
!	    4/96: *sh* used ARG_TO_ITEM to harmonize
	   DO 1350 ivar = 1, num_items
	      i1 = STR_UPCASE(arg,cmnd_buff(item_start(ivar):item_end(ivar)))
	      IF ( IS_TEMPLATE( arg ) ) THEN
*    ... first check static grids
	         DO 1340 grid = 1, max_grids
	            IF ( grid_name(grid) .EQ. char_init16 ) GOTO 1340
	            IF (MATCH_TEMPLATE(grid_name(grid) ,arg)) THEN
	               WRITE ( risc_buff, 4220 ) '  '//grid_name(grid)
	               CALL SPLIT_LIST(pttmode_explct, show_lun,
     .				risc_buff, 0)
	               risc_buff = ' '
	            ENDIF
 1340	         CONTINUE
*    ... then check dynamic grids
                 grid = 0
 1344            CALL TM_NEXT_DYN_GRID( grid, *1346 )
	            IF (MATCH_TEMPLATE(grid_name(grid) ,arg)) THEN
	               WRITE ( risc_buff, 4220 ) '  '//grid_name(grid)
	               CALL SPLIT_LIST(pttmode_explct, show_lun,
     .				risc_buff, 0)
	               risc_buff = ' '
	            ENDIF
	            GOTO 1344
 1346               CONTINUE
	      ELSE
	         grid = GRID_FROM_NAME
     .                    ( cmnd_buff(item_start(ivar):item_end(ivar)),
     .			  cx_last, status )
	         IF ( status .NE. ferr_ok ) GOTO 1350
                 IF ( grid .EQ. unspecified_int4 ) GOTO 5300
	         IF (sxml) THEN 
                    CALL SHOW_GRID_XML(show_lun, grid, unspecified_int4 )
                 ELSE
	            WRITE ( risc_buff, 4210 ) grid_name( grid )
		    IF (dset.NE.unspecified_int4 .AND. dset.NE.pdset_irrelevant
     .		       .AND. dset.NE.pdset_uvars .AND. dset.NE.pdset_coordvars) THEN
	            IF ( TM_HAS_STRING(ds_type(dset), 'ENS') ) THEN
		       dlen = TM_LENSTR1(grid_name(grid) )
		       WRITE ( risc_buff, 4211) grid_name(grid)(:dlen)
		    ENDIF
	            IF ( TM_HAS_STRING(ds_type(dset), 'FCT') ) THEN
		       dlen = TM_LENSTR1(grid_name(grid) )
		       WRITE ( risc_buff, 4212) grid_name(grid)(:dlen)
		    ENDIF
		    ENDIF
	            CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)

* If this was a 'show grid grid_name' do not list the grid-line context information
		    i1 = TM_GET_GRIDNUM( arg )
		    uvgrid = (i1 .EQ. unspecified_int4 )

	            risc_buff = ' '
	            CALL SHOW_GRID( grid, mods_cx, uvgrid, status )
		    IF (status .NE. ferr_ok) GOTO 5000
	         ENDIF
	      ENDIF
 1350	   CONTINUE
 4210	   FORMAT ( 4X,'GRID ',A)
 4211	   FORMAT ( 4X,'GRID ',A, '  Ensemble Aggregetion Grid')
 4212	   FORMAT ( 4X,'GRID ',A, '  Forecast Aggregation Grid')

	ELSEIF( qual_given(slash_grid_dyn) .GT. 0 ) THEN
	   CALL SHOW_DYN_GRIDS(mods_cx)
	ELSEIF ( slash_all ) THEN
	   WRITE ( risc_buff, 4215 ) grid_name(mgrid_abstract)
	   CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	   risc_buff = ' '
 4215	   FORMAT(' Default grid for DEFINE VARIABLE is ',A)
* show 'em all the names
	   WRITE ( risc_buff, 4220 ) '** GRIDS NAMES **'
	   CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	   risc_buff = ' '
	   DO 1360 grid = 1, max_grids
	      IF ( interrupted ) CALL ERRMSG
     .			( ferr_interrupt, status, ' ', *5000 )
	      IF ( grid_name( grid ) .EQ. char_init16 ) GOTO 1360
	      WRITE ( risc_buff, 4220 ) '  '//grid_name( grid )
	      CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	      risc_buff = ' '
 4220	      FORMAT (4X,A)
 1360	   CONTINUE
*    ... then check dynamic grids
           grid = 0
 1370      CALL TM_NEXT_DYN_GRID( grid, *1379 )
	      IF ( grid_name(grid)(1:1) .EQ. '(' ) GOTO 1370
	      WRITE ( risc_buff, 4220 ) '  '//grid_name( grid )
	      CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	      risc_buff = ' '
	      GOTO 1370
 1379      CONTINUE

	ELSE
	   WRITE ( risc_buff, 4215 ) grid_name(mgrid_abstract)
	   CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	   risc_buff = ' '
* display the grid from last command
	   cx = is_cx( 1 )
	   IF ( cx.EQ.0 .OR. cx.EQ.unspecified_int4 )	GOTO 1390
	   grid = cx_grid( cx )
	   IF ( grid .EQ. unspecified_int4 ) 		GOTO 1390
	   WRITE ( risc_buff, 4200 ) grid_name(grid)
	   CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	   risc_buff = ' '
	   WRITE ( risc_buff, 4210 ) grid_name(grid)
	   CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	   risc_buff = ' '
 4200	   FORMAT (' Last successful data access was on grid ',A)
	   uvgrid = (grid_name(grid) .NE. char_init16) ! show context for last command
	   CALL SHOW_GRID( grid, mods_cx, uvgrid, status )
	   IF (status .NE. ferr_ok) GOTO 5000
	ENDIF

* release context stack space
	CALL STACK_PTR_DN ( cx_stack_ptr, cx_stack_ptr_base, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* successful completion
        IF (sho_file .GT. 0) CLOSE( UNIT = show_lun, ERR = 5000 )

 1390 	RETURN

* SHOW VIEWPORT view1,view2,...
* column headings
 1400	WRITE ( risc_buff, 3142 )
	CALL SPLIT_LIST(pttmode_explct, show_lun, ' ', 1)
	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	CALL SPLIT_LIST(pttmode_explct, show_lun, ' ', 1)
	risc_buff = ' '
 
	IF ( num_args .GE. 1 ) THEN
* ... loop through the viewports named
	   DO 1420 i = 1, num_items
* ... identify the viewport number from the template (or name)	      
	      i1 = STR_UPCASE(arg,cmnd_buff(item_start(i):item_end(i)))
	      DO 1410 ivp = 1, max_viewport
	         IF ( vp_name(ivp).EQ.unspecified_name4 ) GOTO 1410
	         IF ( MATCH_TEMPLATE(vp_name(ivp), arg) ) THEN 
		    IF ( vp_xclip(ivp) .EQ. unspecified_val4 ) THEN
		       xtemp = 0.0
		       ytemp = 0.0
		    ELSE
		       xtemp = vp_xclip(ivp)
		       ytemp = vp_yclip(ivp)
		    ENDIF
                    IF (vp_by_axis(ivp)) THEN
                      i2 = 1
                    ELSE
                      i2 = 2
                    ENDIF
	            WRITE (risc_buff,3146) vp_name(ivp), vp_size(ivp),
     .					   vp_xorg(ivp), xtemp,
     .					   vp_yorg(ivp), ytemp,
     .                                     axesOrCorner(i2)
	            CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	            risc_buff = ' '
	         ENDIF
 1410	      CONTINUE
 1420	   CONTINUE
	ELSE
* ... show 'em all
	   DO 1450 ivp = 1,max_viewport
	      IF ( vp_name(ivp).NE.unspecified_name4 ) THEN
		 IF ( vp_xclip(ivp) .EQ. unspecified_val4 ) THEN
		    xtemp = 0.0
		    ytemp = 0.0
		 ELSE
		    xtemp = vp_xclip(ivp)
		    ytemp = vp_yclip(ivp)
		 ENDIF		 
                 IF (vp_by_axis(ivp)) THEN
                   i2 = 1
                 ELSE
                   i2 = 2
                 ENDIF
	         WRITE (risc_buff,3146)	vp_name(ivp), vp_size(ivp),
     .					vp_xorg(ivp), xtemp,
     .					vp_yorg(ivp), ytemp,
     .                                  axesOrCorner(i2)
	         CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	         risc_buff = ' '
	      ENDIF
 1450	   CONTINUE
	ENDIF
* tell what's current
	WRITE ( risc_buff, 3148 ) vp_name(vp_num)
	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	risc_buff = ' '

 	RETURN
 3142	FORMAT(' name',T19,'text',T27,'xlimits',T39,'ylimits',T50,'mode')
 3146	FORMAT(1X,A,T18,F5.2,T26,F4.2,',',F4.2,T38,F4.2,',',F4.2,T50,A)
 3148	FORMAT( T4,'current viewport is ',A)

* SHOW TRANSFORMS
 1500   CONTINUE
	CALL SPLIT_LIST(pttmode_explct, show_lun,
     .		'variable transforms e.g.SST[T=1-jan:15-mar@DDC]', 47)
	CALL SHOW_TRANSFORMS
	CALL SPLIT_LIST(pttmode_explct, show_lun, ' ', 1)	! blank line
	CALL SHOW_REGRID_TRANSFORMS
	IF ( limited_show ) RETURN

* SHOW ALIAS
 1600   WRITE (risc_buff, 3160) 'Alias', 'Command'
	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	risc_buff = ' '
        WRITE (risc_buff, 3160) '-----', '-------'
	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	risc_buff = ' '
        IF ( num_args .EQ. 0 .OR. slash_all ) THEN
	   DO 1610 i = 1, total_num_alias
	      IF ( alias_name(i) .EQ. unspecified_name4 ) GOTO 1610
	      WRITE ( risc_buff, 3160 ) alias_name(i), alias(i)
	      CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	      risc_buff = ' '
 1610	   CONTINUE
        ELSE
           DO 1630 i1 = 1, num_items
	      i2 = STR_UPCASE(arg,cmnd_buff(item_start(i1):item_end(i1)))
	      DO 1620 i = 1, total_num_alias    
	         IF ( alias(i) .EQ. unspecified_name4 ) GOTO 1620
	         IF ( MATCH_TEMPLATE(alias_name(i), arg) ) THEN 
                    WRITE ( risc_buff, 3160 ) alias_name(i), alias(i)
	            CALL SPLIT_LIST(pttmode_explct, show_lun,
     .					risc_buff, 0)
	            risc_buff = ' '
                 ENDIF
 1620	      CONTINUE
 1630      CONTINUE
        ENDIF
 3160   FORMAT (T4,A,T16,A)
	IF ( limited_show ) RETURN

* SHOW SYMBOLS sym1 sym2 ...
*           or SHOW SYMBOL/ALL
 1700	slash_all = slash_all .OR. num_args .EQ. 0
* SPECIAL SYMBOLS
	i1=0
 1702   i1 = i1 + 1
        CALL SPECIAL_SYMBOL(i1, argsym,show_str,len) ! get next symbol namees
	len0 = TM_LENSTR1(argsym)
        IF(argsym .NE. ' ')THEN
	   IF ( num_args .GE. 1 ) THEN
* ... check the names specified by template matching 
	      DO 1703 i = 1, num_items
	         n = STR_UPCASE(arg,
     .			cmnd_buff(item_start(i):item_end(i)))
	         IF ( MATCH_TEMPLATE(argsym(:len0),arg) ) GOTO 1705
 1703         CONTINUE
	      GOTO 1702			! no match
	   ENDIF
* ... display the symbol definition
 1705      CALL SPECIAL_SYMBOL(0, argsym,show_str,len) ! get the sym value
           CALL SPLIT_LIST(pttmode_explct, show_lun,
     .			argsym(:len0)//' = "'//show_str(:len)//'"', 0)
           GOTO 1702
	ENDIF

* PLOT+ SYMBOLS
 1709   i1=0
 1710   CALL LSTSYM(argsym,show_str,len,i1,i2)	! get next symbol
	len0 = TM_LENSTR1(argsym)
        IF(i2.EQ.0)THEN
	   IF ( num_args .GE. 1 ) THEN
* ... check the names specified by template matching 
	      DO 1720 i = 1, num_items
	         n = STR_UPCASE(arg,
     .			cmnd_buff(item_start(i):item_end(i)))
	         IF ( MATCH_TEMPLATE(argsym(:len0),arg) ) GOTO 1750
 1720	      CONTINUE
	      GOTO 1710			! no match
	   ENDIF
* ... display the symbol definition
* *kob* 10/97 added check for len = 0
 1750	   IF ( len .GT. 0 ) THEN
	       CALL SPLIT_LIST(pttmode_explct, show_lun,
     .			argsym(:len0)//' = "'//show_str(:len)//'"', 0)
	   ELSE 
               CALL SPLIT_LIST(pttmode_explct, show_lun,
     .			argsym(:len0)//' = ""', 0)
	   ENDIF
           GOTO 1710
	ENDIF

* successful completion
 	RETURN

* SHOW ATTRIBUTE
 1800   CONTINUE

* 
* ... SHOW ATT varname.att ... various cases of how to show:
*       SHOW ATT/ALL varname    - show all attributes for var in current dset
*       SHOW ATT/ALL varname[D=n]
*	SHOW ATT varname.attrib	- show attrib on variable in current dset
*	SHOW ATT name[D=n]	- show attrib on variable from named data set
*	SHOW ATT/D=n varname.attrib - show attrib on variable from named data set
*	SHOW ATT/OUTPUT also list the output flag for the attribute

        sho_out = qual_given( slash_attr_output )  .GT. 0

        dset = cx_data_set(cx_last)
        dset_last = pdset_irrelevant

* ... get dset number if present:  SHOW ATT/D=dset ...
	iqual = qual_given( slash_attr_dset ) 
        IF ( iqual .GT. 0 ) THEN
	   CALL EQUAL_STRING( cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .			      show_str, status )  ! show_str is just a buffer
	   IF ( status .NE. ferr_ok ) RETURN
	   IF ( show_str .NE. ' ' ) THEN
	      dset = FIND_DSET_NUMBER( show_str )
	      IF ( dset .EQ. unspecified_int4) THEN
	         CALL WARN('Unknown data set: '
     .		 //show_str(:TM_LENSTR1(show_str)))
	         RETURN
	      ENDIF
	   ENDIF

        ELSE  ! get dataset from context or from [d=]
           show_str = cmnd_buff(item_start(1):item_end(1))

           CALL GET_NEW_CX( cx_last, cx_cmnd, .TRUE., status )
           IF ( status .NE. ferr_ok ) GOTO 5000

           coordvar = .FALSE.
           IF (show_str(1:1) .EQ. '(') THEN
              dset = cx_data_set(cx_cmnd)   ! initial value to try; will return dset
              CALL ISIT_COORD_VAR ( show_str, dset, 
     .              varname, coordvar, status )

              IF ( status .NE. ferr_ok ) THEN 
                 dset = pdset_coordvars  ! a user-defined axis (coordinate variable)
                 CALL ISIT_COORD_VAR ( show_str, dset, 
     .              varname, coordvar, status )
                    IF ( status .NE. ferr_ok ) THEN
                    dset = cx_data_set(cx_cmnd)
                    GOTO 5920
                 ENDIF
              ENDIF

           ELSE

* Get the dataset if given as [d=]

	      IF ( INDEX(show_str,'[') .GT. 0 ) THEN
                 dset = pdset_irrelevant	! default (not used ...)
                 CALL PARSE_NAM_DSET(show_str, cx_last, dset, cat, var,
     .                 mods_cx, status)
              ELSE
                 cx = is_cx( 1 )
                 IF (cx .EQ. 0 .OR. cx .EQ. unspecified_int4)
     .                cx = cx_cmnd
                dset = cx_data_set(cx)
              ENDIF
	   ENDIF

* See if the variable is a user-defined variable.

           varname = show_str
           dot = INDEX(show_str,'.')
	   brkt = INDEX(show_str,'[')
	   IF ( brkt .GT. 0 ) varname = show_str(1:brkt-1)
           IF (dot .GT. 0) varname = show_str(1:dot-1)
           CALL FIND_VAR_NAME(dset, varname, cat, var)
           IF (  var .NE. munknown_var_name .AND.
     .           cat .EQ. cat_user_var) dset = pdset_uvars

* Or use command context to get data set

           IF (dset .EQ. pdset_irrelevant .OR. 
     .        dset .EQ. unspecified_int4) dset = cx_data_set(cx_cmnd) 

	ENDIF

	IF ( num_args .EQ. 0  ) GOTO 5060

* Is it show att dataset-name or dataset-number?

        sh_att_dset = var .EQ. munknown_var_name
	IF (coordvar) sh_att_dset = .FALSE.       ! var not set for (coordvar) syntax
	IF (dot.GT.0) sh_att_dset = .FALSE.       ! it is show att varname.attname
                                                  ! it is show att . for global atts.
	IF ((dot.GT.0) .AND. TM_LENSTR(show_str) .EQ. 1) THEN
	   sh_att_dset = .FALSE. 
	   slash_all = .TRUE.
	ENDIF

	IF (sh_att_dset) THEN                    ! Do as for SHOW DAT/ATT
	   qual_given( slash_attr  ) = 1
	   CALL SHOW_DATA (dset, status)

        ELSE  ! It is show att for variable

        IF ( slash_all .OR. dot.EQ.0) THEN  ! SHOW ATT/ALL varname (/ALL optional)

           DO 1820 i = 1, num_items

	      varname = cmnd_buff( item_start(i):item_end(i) )
              IF(TM_HAS_STRING(varname, '.') ) THEN
                 varid = 0
                 CALL CD_GET_VAR_INFO (dset, varid, varname, vtype,
     .                              nvdims, vdims, nvatts, coordvar, 
     .                              all_outflag, status)
              ENDIF

              IF (dset .EQ. pdset_irrelevant .OR. 
     .            dset .EQ. unspecified_int4) GO TO 5072

* Check for the attribute info in "dset" found above, 
* or in the default datset indicated by cx_data_set(cx_last)

              CALL CD_GET_VAR_ID (dset, varname, varid, status)
              IF (status .NE. ferr_ok) THEN
	         iset = cx_data_set(cx_last)
		 CALL CD_GET_VAR_ID (iset, varname, varid, status)
		 IF (status .EQ. ferr_ok) dset = iset
	      ENDIF
              IF (status .NE. ferr_ok .OR. dset .EQ. unspecified_int4 .OR.
     .           (varid .EQ. 0 .AND.
     .           .NOT.TM_HAS_STRING(varname, '.')) ) GOTO 5200

* Header line

              IF (.NOT. sxml) THEN
                 IF (dset .NE. dset_last ) THEN
                    IF (dset .EQ. pdset_uvars) THEN
                       risc_buff = 
     .                   '     attributes for user-defined variables'
                    ELSE IF (dset .EQ. pdset_coordvars) THEN
                       risc_buff = 
     .                   '     attributes for coordinate axis'
                    ELSE
                       llen = TM_LENSTR1(ds_des_name(dset))
                       WRITE ( risc_buff, 4800 ) ds_des_name(dset)(:llen)
                    ENDIF
                    CALL SPLIT_LIST(pttmode_explct, show_lun, 
     .                     risc_buff, 0) 
                 ENDIF
                 dset_last = dset
              ENDIF

              CALL CD_GET_VAR_INFO (dset, varid, varname, vtype,
     .                              nvdims, vdims, nvatts, coordvar, 
     .                              all_outflag, status)

              DO 1810 iatt = 1, nvatts

                 CALL CD_GET_VAR_ATT_INFO (dset, varid, iatt, aname, 
     .               attype, attlen, attoutflag, status )

                 IF (status .NE. ferr_ok) GOTO 1810

                 maxlen = size_rbuff
                 IF (attype .NE. NCCHAR) maxlen = 10
                 got_it = NC_GET_ATTRIB ( dset, varid, aname,
     .                                   .TRUE., varname, maxlen,
     .                                   attlen, attoutflag, risc_buff, 
     .                                   attvals )

                 IF (got_it) THEN
                    IF (.NOT. sxml) 
     .                 CALL SHOW_ATTRIBUTE (varname, coordvar, aname, 
     .                              attype, attlen, risc_buff, attvals, 
     .                              attoutflag, sho_out)  

                 ENDIF
1810          CONTINUE

1820       CONTINUE 

        ELSE  ! SHOW ATT varname.attname

	   DO 1830 i = 1, num_items
	      IF ( interrupted ) CALL ERRMSG
     .			( ferr_interrupt, status, ' ', *5000 )

	      varatt = cmnd_buff( item_start(i):item_end(i) )

              IF (INDEX(varatt,'.') .EQ. 0) GOTO 5070

              IF ( INDEX(varatt,'[') .GT. 0 ) THEN

* ... bug (minor): square brackets **may** not contain D=dset information
* 	a work-around: pass a context with data set info (instead of cx_last)

                 dset = pdset_irrelevant	! default (not used ...)
                 CALL PARSE_NAM_DSET(varatt, cx_last, dset,
     .				     category, ivar, mods_cx, status)   

                 IF (dset .EQ. pdset_irrelevant .OR. 
     .               dset .EQ. unspecified_int4) THEN
                       varname = varatt
                       GO TO 5072
                  ENDIF
              ENDIF

* do_err: issue error message if attrib does not exist on varname.attname
              do_err = .TRUE.  
              CALL BREAK_VARATTNAME ( varatt, dset, varname, 
     .                  attname, varid, do_err, status )

              IF(TM_HAS_STRING(varname, '.') ) THEN
                 varid = 0
                 CALL CD_GET_VAR_INFO (dset, varid, varname, vtype,
     .                              nvdims, vdims, nvatts, coordvar, 
     .                              all_outflag, status)
              ENDIF


              IF (status .NE. ferr_ok) GOTO 5000

* get var name in the same case as in the file, and get coordvar,
* flag for whether the var is a coordinate axis

              CALL CD_GET_VAR_INFO (dset, varid, varname, vtype,
     .                              nvdims, vdims, nvatts, coordvar, 
     .                              all_outflag, status)

* Write header line

              IF (.NOT. sxml) THEN
                 IF (dset.NE.dset_last .AND. dset.GT.pdset_irrelevant) THEN
                    llen = TM_LENSTR1(ds_des_name(dset))
                    WRITE (risc_buff, 4800) ds_des_name(dset)(:llen)
                    CALL SPLIT_LIST(pttmode_explct, show_lun, 
     .                     risc_buff, 0) 
                 ENDIF
                 dset_last = dset
              ENDIF

              CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid,
     .               status)
              IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, varid,
     .               attid, aname, attype, attlen, attoutflag, status )

              maxlen = size_rbuff
              IF (attype .NE. NCCHAR) maxlen = 10
              got_it = NC_GET_ATTRIB ( dset, varid, aname,
     .                        .TRUE., varname, maxlen,
     .                        attlen, attoutflag, risc_buff, 
     .                        attvals )

              IF (varid .EQ. 0) THEN
              loc = INDEX(varatt, ".") - 1
                 varname = varatt(1:loc)
              ENDIF

              IF (got_it) CALL SHOW_ATTRIBUTE (varname, coordvar, aname,
     .                       attype, attlen, risc_buff, attvals, 
     .                       attoutflag, sho_out)

1830	   CONTINUE 
        ENDIF

        ENDIF  ! sh att dataset vs sho att variable

4800	FORMAT (T6,'attributes for dataset: ', A)

* successful completion
 	RETURN

* SHOW NCCACHE
 1900   CALL CD_GET_CHUNK_CACHE (cache_size, cache_nelems, 
     .    cache_preemption, status)
        cache_mb = cache_size/1.e6
	name = TM_FMT(cache_mb, 6, 12, dlen)
        show_str = 'Current NCDF Chunk Cache size '//name(1:dlen)
	len = TM_LENSTR1(show_str)

        cache_n = cache_nelems
	name = TM_FMT(cache_n, 6, 12, dlen)

	show_str = show_str(1:len)//' MB, n_elems = '//name(1:dlen)
	len = TM_LENSTR1(show_str)

        cache_p = cache_preemption
	name = TM_FMT(cache_p, 6, 12, dlen)

	show_str = show_str(1:len)//', preemption = '//name(1:dlen)
	len = TM_LENSTR1(show_str)

	CALL SPLIT_LIST(pttmode_explct, ttout_lun,
     .			show_str(1:len), 0)
	IF ( limited_show ) RETURN

* SHOW GIFFILE
 2000   its_gif = ITS_GIF_GRAPHICS()
        IF ( .NOT. its_gif ) THEN
	   CALL WARN ('Not in GIF mode: GIFFILE not set')
        ELSE
	   CALL GET_METAFILE_NAME(outstring)
 	   len = TM_LENSTR1(outstring)
	
 	   IF ( outstring(len-3:len) .EQ. '.gif'
     .       .OR. outstring(len-3:len) .EQ. '.GIF' )  THEN
 	      show_str = 'Current default gif filename: ' //outstring(1:len)
	  
 	      len = TM_LENSTR1(show_str)
	      CALL SPLIT_LIST(pttmode_explct, ttout_lun,
     .			show_str(1:len), 0)
 	   ENDIF
        ENDIF

	RETURN

* SHOW FUNCTIONS
 2100   CONTINUE
* /BRIEF or full description?
 	sbrief  = qual_given( slash_brief ) .GT. 0 
 	sdetail = qual_given( slash_show_func_detail ) .GT. 0 

* show a whole list or named functions, only?
	IF ( num_args .GT. 0 ) THEN

* ... one or more functions were explicitly named
	   DO 2110 i = 1, num_items
           i1 = STR_UPCASE(arg,cmnd_buff(item_start(i):item_end(i)))
	      len0 = item_end(i) - item_start(i) + 1
* ... identify the named function
* ... first try internal, non-grid-changing functions ...
	      DO 2104 i2 = 1, num_functions
	         IF ( interrupted ) CALL ERRMSG
     .			( ferr_interrupt, status, ' ', *5000 )
	         IF (MATCH_TEMPLATE(alg_fcn(i2),arg(:len0)))
     .           CALL SHOW_1_FUNCTION(show_lun, .FALSE.,
     .                                sbrief, sdetail, i2)
 2104         CONTINUE
* ... second try internal, grid-changing functions
	      DO 2106 i2 = 1, gfcn_num_internal
	         IF ( interrupted ) CALL ERRMSG
     .			( ferr_interrupt, status, ' ', *5000 )
              IF ( MATCH_TEMPLATE(gfcn_name(i2),arg(:len0)) ) CALL
     .                SHOW_1_FUNCTION(show_lun, .TRUE.,
     .                                sbrief, sdetail, i2)
 2106         CONTINUE
* ... third try external functions
              IF (qual_given(slash_internal) .EQ. 0) THEN
 	         DO 2108 i2 = gfcn_num_internal+1, gfcn_num_internal+
     .                efcn_scan(gfcn_num_internal)
	            IF ( interrupted ) CALL ERRMSG
     .			   ( ferr_interrupt, status, ' ', *5000 )

                 CALL EFCN_GET_NAME (i2, fhol)
                 CALL TM_CTOF_STRNG( fhol, efname, slen )
                 i1 = STR_UPCASE(upname, efname)

                 IF ( MATCH_TEMPLATE(upname,arg(:len0) )) CALL
     .               SHOW_1_FUNCTION(show_lun, .TRUE.,
     .                               sbrief, sdetail, i2)

c                 CALL TM_FTOC_STRNG( arg(:len0), fhol, slen )
c                 IF ( EFCN_MATCH_TEMPLATE(i2,fhol) .EQ. 1) CALL
c     .               SHOW_1_FUNCTION(show_lun, .TRUE.,
c     .                               sbrief, sdetail, i2)

 2108            CONTINUE  
              ENDIF
 2110      CONTINUE


* show lists of functions
	ELSE

* ... show all the internal functions (omit for SHOW FUNC/EXTERN)
	   IF ( qual_given(slash_external) .EQ. 0 ) THEN
* ... internal non-grid-changing functions
	      CALL SPLIT_LIST(pttmode_explct, show_lun,
     .			'Functions internal to Ferret:', 0)
	      DO 2120 i = 1, num_functions
	         IF ( alg_fcn(i) .NE. unspecified_name4 ) CALL
     .                SHOW_1_FUNCTION(show_lun, .FALSE.,
     .                  sbrief, sdetail, i)
 2120         CONTINUE
* ... internal grid-changing functions
	      DO 2130 i = 1, gfcn_num_internal
	         CALL SHOW_1_FUNCTION(show_lun, .TRUE.,
     .                  sbrief, sdetail, i)
 2130         CONTINUE
	   ENDIF

* ... show all the external functions
* 3/24/99 *kob* clean up duty - change below to blank space rather than
*               null string
	   IF ( qual_given(slash_internal) .EQ. 0 ) THEN
              CALL SPLIT_LIST(pttmode_explct, show_lun,
     .             ' ', 0)       ! Print a blank line
              CALL SPLIT_LIST(pttmode_explct, show_lun,
     .           'Externally defined functions available to Ferret:',
     .             0)
	      DO 2140 i = gfcn_num_internal+1, gfcn_num_internal+
     .             efcn_scan(gfcn_num_internal)
	         CALL SHOW_1_FUNCTION(show_lun, .TRUE.,
     .                  sbrief, sdetail, i)
 2140	      CONTINUE
	   ENDIF

	ENDIF
	IF ( limited_show ) RETURN

* SHOW QUERIES
 2200   CONTINUE
	DO 2210 i = 1, max_queries
	   IF ( queries(i) .NE. unspecified_name4 )CALL SPLIT_LIST
     .			(pttmode_explct, show_lun, queries(i), 0)
 2210	CONTINUE
	IF ( limited_show ) RETURN


* error exit
 5050   CALL RELEASE_DYN_WORK_SPACE
 5000	RETURN
 5071	name = cmnd_buff(arg_start(1):arg_end(1))
	CALL ERRMSG( ferr_unknown_data_set, status,
     .			name(:TM_LENSTR1(name)), *5000 )
 5072	CALL ERRMSG( ferr_invalid_command, status,
     .         'dataset not found for varname.attname '//
     .          varname(:TM_LENSTR1(varname)), *5000 )
 5100   CALL ERRMSG( ferr_unknown_variable, status, arg, *5000)
 5150   CALL ERRMSG( ferr_unknown_qualifier, status,
     .          'SHOW VAR/TREE= may take arguments ALL, FILE, '//
     .          'and USER (default)', *5000)
 5200	CALL ERRMSG( ferr_unknown_variable, status, varname, *5000 )
 5300   CALL ERRMSG( ferr_invalid_command, status, 'grid for '//
     .              cmnd_buff(item_start(ivar):item_end(ivar))
     .              //' is not available.'//pCR//
     .              '(LOAD this variable and try SHOW GRID again.)',
     .              *5000  )
 5060	CALL ERRMSG( ferr_invalid_command, status,
     .			'SHOW ATTRIBUTE given with no argument '
     .			, *5000 )
 5070	CALL ERRMSG( ferr_invalid_command, status,
     .	    'SHOW ATTRIBUTE given with no attribute: '//
     .	    'Use SHOW ATT/ALL varname, or SHOW ATT varname.attname '
     .			, *5000 )
 5080	CALL ERRMSG( ferr_prog_limit, status,
     .  'Cannot append to file w/ name longer than 256 characters: '//pCR//
     .  'Limitation of Fortran INQUIRE and OPEN calls '	
     .			, *5000 )
 5920	llen = TM_LENSTR(show_str)
	CALL ERRMSG( ferr_invalid_command, status,
     .   'variable, axis, or attribute does not exist '//
     .    show_str(:llen), *5000 )


 5930	CALL ERRMSG( ferr_invalid_command, status,
     .		'SHOW/FILE= what name?', *5000 )

 5090	CALL ERRMSG( ferr_prog_limit, status,
     .  'Cannot write to file w/ name longer than 256 characters: '//pCR//
     .  'Limitation of Fortran INQUIRE and OPEN calls '	
     .			, *5000 )

	END

	SUBROUTINE RDSEQ(X,NSIZE,PBUF,IBASE,FILE)
	DIMENSION X(NSIZE)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)rdseq.F	1.2    3/18/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long
* V695  *acm*  9/15 Changes for hour:min labeling on time axes

	INCLUDE 'PARAMPL5.DAT'
	INCLUDE 'HD.INC'
	INCLUDE 'TAXIS.INC'
	INCLUDE 'AXISL.INC'
	INCLUDE 'CMRD.INC'
	INCLUDE 'CMRDL.INC'
	INCLUDE 'DATA.INC'
	INCLUDE 'EPICLUN.INC'
	INCLUDE 'LINES.INC'
	INCLUDE 'LABCOM.INC'
	INCLUDE 'LABELS.INC'
	INCLUDE 'LUNITS.INC'
	INCLUDE 'SYSTEM.INC'
	INCLUDE 'SWITCH.INC'
	INCLUDE 'COMTHDR.INC'
	INCLUDE 'COMEPV.INC'
	INCLUDE 'COMEPS.INC'

	REAL*8	DIFF
	LOGICAL LEOF,LFIRST,LSTICK
	CHARACTER*10 CEPIC1,CEPIC2,FILE*(*)
	CHARACTER YES*3,NO*2,SYM*120,CSYM*6
	INTEGER PBUF
	DATA YES,NO/'YES','NO'/
C
	SYM='*PPL$EOF'
	CALL PUTSYM(SYM,NO,2,IER)
C
	IF(LINEN.EQ.0)CALL RSMNMX
	I=1
	IF(IFLG(4).NE.0.AND.M.GE.4)I=P(4)
	ITYPEZ=0
	IF(IFLG(3).NE.0.AND.M.GE.3)ITYPEZ=IFIX(P(3))
	ILOOP=I
	IF (IEFLG.EQ.1 .AND. IEPV2.EQ.10) THEN
	    ILOOP=I*2
	    LSTICK=.TRUE.
	ELSE
	    LSTICK=.FALSE.
	ENDIF
	LFIRST=.TRUE.
C_______
	DO 1603 JJ=1,ILOOP
	  IF(.NOT.SVECTR)THEN
	    IF(IFLG(1).EQ.0)THEN
		NX=NSIZE/2-IBASE
	    ELSE
		NX=IFIX(P(1))
	    ENDIF
	    IF(IFLG(2).EQ.0.OR.M.LT.2)THEN
		NY=1
	    ELSE
		NY=IFIX(P(2))
	    ENDIF
	    IF(JZ.NE.0)THEN
		IF(NX*NY.GT.NSIZE)THEN
		    IF(.NOT.QUIETF)WRITE(LTTOUT,9993)NX*NY
9993		    FORMAT(I10,' exceeds buffer')
		    GOTO 10
		ENDIF
	    ELSE
		NX=MIN0(NSIZE/2-IBASE,NX)
	    ENDIF
	  ENDIF
	    NREC=NX*NY/NGRP
	    LINEN=LINEN+1
	    IF(IFORM(1:3).EQ.'DSF'.OR.IFORM(1:4).EQ.'BIBO'
     *		.OR.IFORM(1:3).EQ.'PPL')THEN
		CALL REDSF(X,NX,NY,NSIZE,IBASE,FILE)
C
	    ELSE IF(IFORM(1:3).EQ.'EPI')THEN
		IF (LSCTD) THEN
		    IF (LSNEXT) BACKSPACE (LUN11)
		    CALL EPICRD (NCAST,NDATA,LEOF,.FALSE.)
		    DO 1050 IDUM1=1,8
1050		    THEADER(IDUM1)=HEADER(IDUM1)
		ELSE
		    IF (LSNEXT) BACKSPACE (LUN11)
		    CALL EPICTRD(IDUM1,XDATE,XTIME,XDAT2,XTIM2,
     1		            P(14),LEOF,.FALSE.)
		    IF (P(14) .LE. 0.) THEN
			P(14)=-P(14)
			LSTIME=.TRUE.
		     ENDIF
		ENDIF
		IF(LEOF)THEN
		    LINEN=LINEN+1
		    LLENG(LINEN)=0
		    GOTO 110
		ENDIF
C
C  GET U FOR STICK PLOT, SET UP FOR V ON NEXT PASS
C
		IF (LSTICK .AND. LFIRST) THEN
		    IEPV1=9
		    IEPV2=6
		    BACKSPACE (LUN11)
C
C  GET V FOR STICK PLOT
C
		ELSE IF (LSTICK) THEN
		    IEPV1=9
		    IEPV2=7
		ENDIF
		IF (IEFLG .EQ. 1) CALL EPICVC
C
C           JX=JY=0 IMPLIES BOTH AXES ARE TIME AXES.  BYPASS THIS
C           DATA SET.
C
		IF (JY.EQ.0 .AND. JX.EQ.0) THEN
		    LINEN=LINEN+1
		    LLENG(LINEN)=0
		    GOTO 110
		ENDIF
		IF (IGTLAB .EQ. 1) THEN
		    CALL EPICTLAB
		    IF (LSTICK .AND. (.NOT.LFIRST)) THEN
			IYLAB=MAX0 (INDEX(YLAB,',')+1, INDEX(YLAB,'(')-1)
			YLAB(1:)=YLAB(IYLAB:)
		    ENDIF
		ENDIF
		IF(ITFLG .NE. 0)THEN
C
C		Get end time adjusted by time offset if needed.
C
		    IF (LSOFFS) THEN
			CALL EPICTIMC (XDAT2,XTIM2,CEPIC1)
			CALL TIME1 (1,CEPIC1, 2,'          ',
     1			            ICEPIC2,CEPIC2,P(14)/2.)
			READ (CEPIC2,2003) XDAT2,XTIM2
2003			FORMAT (F6.0,F4.0)
		    ENDIF
C
C		Get time axis limits and set up for time variable.
C
		    CALL EPICTLIM (XDATE,XTIME,XDAT2,XTIM2)
		    CALL EPICTIMC (XDATE,XTIME,ICOM)
		    OFF=DIFF(ITSTRT,ICOM)/DT+1.
		    P(14)=P(14)/DT
		    IF (LSOFFS) OFF=OFF+P(14)/2.
		ENDIF
		IX=IBASE-1
		CALL READSQ(X,NX,NY,NSIZE,IBASE,FILE)
		IF (LSTICK .AND. LFIRST) REWIND LUN1
C
C	    SET NX TO ACTUAL NUMBER OF POINTS READ
C
		NX=LLENG(LINEN)
C
C	    IF SWITCH STIME IS FALSE, THE SEQUENCE NUMBER IS
C	    TRANSFORMED INTO UNITS OF TSTRT AND DT.
C
C	    IF SWITCH STIME IS TRUE (MEANING TO READ DATE/TIME WORDS
C	    FROM THE EPIC DATA FILE) THEN THE DATE/TIME WORDS WERE
C	    TRANSFORMED IN ROUTINE READSQ WHERE THE DATA FILE WAS READ.
C
		IF (ITFLG.EQ.1 .AND. .NOT.LSTIME) THEN
		    DO 2001 J=1,NX
			X(IX+J)=(FLOAT(J)-1.0)*P(14)+OFF
2001		    CONTINUE
		ELSE IF (ITFLG.EQ.-1 .AND. .NOT.LSTIME) THEN
		    IY=NSIZE/2 + IX
		    DO 2002 J=1,NX
			X(IY+J)=(FLOAT(J)-1.0)*P(14)+OFF
2002		    CONTINUE
		ENDIF
		IF (LSTICK) THEN
		    IEPV2=10
		    IEPV1=9
		    LFIRST=.NOT. LFIRST
		ENDIF
C
	    ELSE
		CALL READSQ(X,NX,NY,NSIZE,IBASE,FILE)
	    ENDIF
110	    IF(LLENG(LINEN).LE.0)THEN
		LINEN=LINEN-1
		IF(.NOT.QUIETF)WRITE(LTTOUT,'('' NO POINTS READ'')')
		IF(LINEN.EQ.0)PBUF=0
		SYM='*PPL$EOF'
		CALL PUTSYM(SYM,YES,3,IER)
		GOTO 10
	    END IF
	    IF(JTYPE.EQ.1)GOTO 1602
	    IF(.NOT.QUIETF)WRITE(LTTOUT,'('' CONTOUR DATA READ'')')
	    IF(.NOT.QUIETF)WRITE(LTTOUT,'('' NX='',I5,''  NY='',I5)')NX,NY
	    LNUM=1
	    IBASE=1
	    LINEN=0
	    CALL STMNMX(X,NSIZE,XMIN,XMAX,YMIN,YMAX)
	    GOTO 10
1602	    IF(.NOT.QUIETF)WRITE(LTTOUT,9990)LLENG(LINEN)
9990	    FORMAT(1X,I6,' POINTS READ')
	    WRITE (CSYM,9992)LLENG(LINEN)
9992	    FORMAT (I6)
	    SYM='*PPL$POINTS'
	    CALL PUTSYM(SYM,CSYM,6,IER)
	    PBUF=1
	    CALL STMNMX(X,NSIZE,XMIN,XMAX,YMIN,YMAX)
C
C	IF THE NEXT LINE WILL OVERFLOW THE BUFFER
C	SET UP LINEN SUCH THAT IT OVER WRITES THE LAST
C	LINE
C
	    LNUM=LINEN
	    IF(LINEN.GE.NLINES)THEN
		LINEN=NLINES - 1
	    ELSE
		IBASE=IBASE+LLENG(LINEN)
	    ENDIF
	    IF(.NOT.QUIETF)WRITE(LTTOUT,9991)LINEN
9991	    FORMAT(' LINE',I3,' READ')
1603	CONTINUE
C_______
10	RETURN
	
	ENTRY RDSEQ2(X,NSIZE,PBUF,IBASE,FILE)
#ifdef unix
	IF(.NOT.QUIETF)WRITE(LTTOUT,9990)LLENG(LINEN)
	PBUF=1
	CALL STMNMX(X,NSIZE,XMIN,XMAX,YMIN,YMAX)
C
C	IF THE NEXT LINE WILL OVERFLOW THE BUFFER
C	SET UP LINEN SUCH THAT IT OVER WRITES THE LAST
C	LINE
C
	LNUM=LINEN
	IF(LINEN.GE.NLINES)THEN
	    LINEN=NLINES - 1
	ELSE
	    IBASE=IBASE+LLENG(LINEN)
	ENDIF
	IF(.NOT.QUIETF)WRITE(LTTOUT,9991)LINEN
	GOTO 10
#else
	GOTO 1602
#endif
	END

	SUBROUTINE CD_READ_ONE (dset, ivar, index, dtype, val, buff, slen, status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Reads a single value or string from a netCDF variable, must be a 1-D var.

* written 8/18 (e.g. getting one value at a time from a DSG feature-id variable)
* v7.6 *acm* 5/20 Issue 1876: read string-typed data.

* include files
        include 'netcdf.inc'
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'		! data set dimension
#include "gt_lib.parm"
	include 'xdset_info.cmn_text'	! data set info common
	external xdset_info_data
	include 'xstep_files.cmn_text'	! step file common
	external xstep_files_data
        include 'xdset_info.cd_equiv'


* arguments:
*	dset        - internal data set # 
*	ivar        - position in common of variable information
*	index       - index of value of 1-d variable to read
*	val         - numeric value for num data
*	buff        - String returned for string data
*	dtype       - data type of the variable
*	slen        - length of string if string var
*	status      - error status upon completion (output)
*
	INTEGER		dset, ivar, i, index, dtype, slen, status
	REAL     	val
	CHARACTER*(*)	buff


* local definitions

        INTEGER	TM_LENSTR1, 
     .		cdfid, varid, nvdims, vdims(nferdims), 
     .		start(nferdims), imap(nferdims), count(nferdims),
     .		stride(nferdims), permuted, strided
        CHARACTER*128 vname

* initialize
        cdfid = sf_lunit(dset)
        varid = cd_varid(ivar)

        DO i = 1,maxvars
           IF (ds_var_setnum(i).EQ.dset .AND. cd_varid(i).EQ.ivar) THEN 
	      varid = cd_varid(i)
	      EXIT
	   ENDIF
	ENDDO

* Get variable type

	CALL CD_GET_VAR_TYPE (dset, varid, vname, dtype, status)

* This routine is only for 1-D variables. Check that.

        CALL CD_GET_VAR_DIMS_INFO (dset, varid, vname, nvdims, 
     .        vdims, status)

	IF (dtype .EQ. NF_CHAR) nvdims = nvdims-1
	IF (nvdims .NE. 1) GOTO 5100

	IF (dtype.EQ.NF_CHAR .OR. dtype.EQ.NF_STRING) THEN 
	   CALL CD_RD_STR_1(cdfid, varid, index, vname, buff, slen, status)
	ELSE
	   CALL CD_RD_R8_1(cdfid, varid, index, dtype, vname, val, status)
	ENDIF
	IF (status .NE. merr_ok) GOTO 5200

 5000	RETURN

 5100	CALL ERRMSG( merr_dsg_grid, status, 
     .     'Getting Feature IDs. Feature var not 1-D?',  *5000 )
 5200   CALL TM_ERRMSG
     .     ( status+pcdferr, status, 'CD_READ_one', cdfid, ivar,
     .       no_errstring, no_errstring, *5000 )

	END

	SUBROUTINE CD_SCAN_VARS(dset,cdfid,reversed,tregular,use_strict,status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user5/4/2005
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Loads common blocks XDSET_INFO, XSTEP_FILES, and grid COMMON with vital
* system and background information from a netCDF file
* It processes FERRET special attributes without regard to whether variables
* are "generic" or "FERRET"

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 2/92 - adds a new data set format to TMAP libraries
*              - based loosely on EZ_INIT_DSET
*      4/18/92 - replaced "elif" syntax with
*                   else
*                     if
*                for sgi port   *kob*
*      8/18/92 - variable name with attribute error messages
*       3/4/93 - read global bad data flag (for EPIC files)
*              - don't process EPIC variable 'time2'
*	  5/94 - added support for DOUBLE variables
*	 11/94 - ignore the "history" attribute.  Use "long_name_mod" instead.
*	  2/95 - check data type of missing_value.  Possibly convert
* 10/96 *kob* - Linux port - had to move variable assignments off of
*		declaration line.
* 7/98 *sh* - allow broader flexibility in variable names through retaining
*             original case when appropriate
* 1/99 *sh* - fixed bug introduced in 7/98 changes -- blows up when file has
*		only coord variables (e.g. climatological_axes)
* 2/99 *kob* - adding call to SWITCH_NAN for NaN recognition
* V500 3/99 *sh* -- most of this routine removed to cd_get_1_dep_var
*	and this routine consolidated with cd_get_axes. The consolidation
*	allows us to process invalid axes as dependent variables rather than
*	rejecting the netCDF file 
* 3/99 *kob* - make sure to pass the correct string length for newly upped
*              parameter values
* V510 *sh* 3/00: added tregular argument
*		- convert to dynamic grid and axis management
* V552 5/03 *acm*: increase size of vname from 64 to 128 chars
* V600 8/05 *amc*  Fix bug 1318, wrong string length of bname in last arg to CD_GET_ATTRIB
* V600 *ACM* attribute control. 
*             Change call to CD_GET_ATTRIB to NC_GET_ATTRIB - get attrib from 
*               linked list structure
*             CD_GET_ATTVAL replaced by NC_GET_ATTRIB, which now returns  
*               strings or real values according to attrib type
*             Replace NCINQ with NCF_INQ_DS
*             Replace NCVINQ for variables, with CD_GET_VAR_INFO
*             Replace NCDID with CD_GET_DIM_ID
*             Replace NCDINQ with CD_GET_DS_DIMS
* V601 *acm*  Fix bug 1445: if there were no global attributes, then the flag 
*             global_bad was not set (defaulted to 0). so for a netcdf file 
*             without global attributes, variables having no missing value 
*             flags got bad-flag of 0.
* V602  2/07 *acm* Fix bug 1492, changing attributes of coordinate variables 
* V67   1/11 *acm* Fix ticket 1777. If a coordinate variale is STRING, issue notes.
* V67   1/11 *acm* Fix ticket 1794. If no missing/fillvalue, issue a warning ONLY
*             when diagnostic mode is set.
* v67   2/11 *acm* Do the notes about no missing/fillvalue for each variable,
*             when in diagnostic mode. So move that back to cd_get_1_dep_var.
* V68   4/11 *acm* fix 1848: skip vars with dim>4 or string vars with dim>5
* V68  *acm* 1/12- added use_strict argument for ticket 1910: micro-adjusting on 
*                  repeated coordinates in netCDF/OPeDNAP datasets
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files
* V6.87 4/14 *acm* ticket 2146: if invalid bounds, make bounds a depend. var
* V695+ 4/15 *sh* support for auxiliary vars (coordinates attributes)
* v7.6 *acm* 5/20 Issue 1876: can read string-typed data, write as char.


* argument definitions:
*       dset    - pointer to TMAP data set
*	cdfid   - id of currently open CDF file
*	reversed    - logical array to record which axes have reversed coords
*	status	- return status

* include files
        include 'netcdf.inc'
	include 'tmap_errors.parm'
#include "gt_lib.parm"
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
	include 'xdset_info.cmn_text'

	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xbuild_grids.cmn'

	external xdset_info_data
        include 'xdset_info.cd_equiv'
        include 'xio.cmn_text'

* argument declarations:
	LOGICAL        reversed(max_lines:line_ceiling), tregular, use_strict
	INTEGER	      dset, cdfid, status

* local parameter definitions:
	LOGICAL	    do_warn
	INTEGER     str_eq
	PARAMETER ( str_eq = 0,
     .		    do_warn = .TRUE. )

* local variable declarations:
*  ivtm - TMAP library variable ID
*  ivcd - netCDF file variable ID
      LOGICAL NC_GET_ATTRIB, 
     .        TM_LEGAL_NAME, MATCH_NAME,
     .        got_it, got_bad, its_epic, 
     .        got_a_variable, failed_axis, 
     .        coordvar, has_gdef
      INTEGER STR_UPCASE, STR_CASE_BLIND_COMPARE, TM_LENSTR1, 
     .        TM_LENSTR, NCF_INQ_DS, STR_SAME,
     .        nvars,  ndims, ngatts, recdim, 
     .        cdfstat, las_pos, first_pos, iaxis,
     .        ivcd, ivtm, vartyp, nvdim, vdims(8), nvatts, i, vlen,
     .        istat, npts, epic_t2,
     .        nbvar, ivar, len_test, len_mchars, 
     .        attype, attlen, attoutflag, maxlen, iatt, 
     .        varid, all_outflag, dset_num, attid, bad_bndsid,
     .	      axcalt, axlagf

      REAL vals  ! potential numerical attributes
      CHARACTER*128 aname, line1d

* ?? how many bounds variables (bname) might there be ??

      INTEGER max_vnamelen
      PARAMETER (max_vnamelen = 128)
      CHARACTER    vname*128, name*16, buff*128
      CHARACTER*128 bname(30)
      REAL global_bad
      REAL dg_bad

      INTEGER tt  ! nice short name
      EQUIVALENCE (tt,lunit_errors)
* special equivalence (cannot include in tmap_format/xdset_info.cd_equiv because "BYTE"
* isn't supported on DECstation
* reorder loop logic because linux cpp didn't like it *kob* 10/96

#ifdef unix
#ifdef sun
      BYTE cd_data_type(maxvars)
#else
      INTEGER*1 cd_data_type(maxvars)
#endif
#else
      BYTE cd_data_type(maxvars)
#endif


      EQUIVALENCE ( ds_precision, cd_data_type )

* initialize: save the state of grid memory prior to any new definitions

* ... flag all axes as non-reversed as the default
	DO 10 i = max_lines, line_ceiling
 10	reversed(i) = .FALSE.

!* ... how many grid spaces used before we start ?
!	status = TM_FIND_GRID_SLOT ( firstgrid )
!        lastgrid = firstgrid - 1
!	IF (status .NE. merr_ok) GOTO 5900
!
!* ... how many line spaces used before we start ?
!	status = TM_FIND_LINE_SLOT ( firstax )
!        lastax = firstax - 1
!	IF (status .NE. merr_ok) GOTO 5900

* get the vital statistics for the data set 

        dset_num = dset
        IF (dset_num .LT. -2) dset_num = -2
        istat = NCF_INQ_DS (dset_num, ndims, nvars, ngatts, recdim )

        its_epic = ds_type(dset) .EQ. 'ECDF'

* set the  default value of the global_bad flag (used by EPIC but sometimes missing)
        IF ( its_epic ) THEN
           global_bad = 1.E35     ! default for EPIC
        ELSE
           global_bad = -1.E34    ! default for FERRET
        ENDIF

* See if there is a grid_definition dimension in the file
* If so will skip true-monthly axis computation in get-axis step.

	DO i = 1, ndims
           CALL CD_GET_DS_DIMS (dset, i, aname, npts, status)
	   has_gdef = (STR_SAME(aname, 'grid_definition') .EQ. 0) 
	   IF (has_gdef) EXIT  ! from loop
	ENDDO

* See if there is a global attribute missing_value in the file

        IF (ngatts .GT. 0) THEN
           CALL CD_GET_VAR_ID (dset, '.', varid, status)


* loop through global attributes looking for missing-value attrib
           DO 20 iatt = 1, ngatts

* get global attribute name
              name = ' '
              CALL CD_GET_VAR_ID (dset, '.', varid, status)
              CALL CD_GET_VAR_ATT_NAME( dset, varid, iatt, name, status)
              maxlen = 128
              IF ( name .EQ. 'missing_value' .OR. 
     .             name .EQ. 'MISSING_VALUE')
     .           got_bad = NC_GET_ATTRIB ( dset, varid, name, do_warn, 
     .                       '.', maxlen, attlen, attoutflag, 
     .                       buff, dg_bad)

              IF (got_bad) THEN
                 global_bad = dg_bad
              ENDIF
  20       CONTINUE

        ENDIF

*   * * * loop through all variables in the net CDF file * * *
*  Get any bounds attribute for each axis, save the bounds
*  name.  Then these names do not need to be processed as dependent 
*  variables.

        nbvar = 0
        DO 2000 ivcd = 1,nvars

* get the vital statistics for this variable

           CALL CD_GET_VAR_INFO (dset, ivcd, vname, vartyp,
     .                 nvdim, vdims, nvatts, coordvar, 
     .                 all_outflag, status)
           IF ( status .NE. merr_ok ) GOTO 5200
           vlen = TM_LENSTR1(vname)

* If it is marked as a coordinate variable but is of string type, then
* issue a message. The variable of the same name will contain the strings.

	   IF (coordvar .AND. (vartyp.EQ.NF_CHAR .OR. 
     .         vartyp.LT.NF_BYTE .OR. vartyp.GT.NF_DOUBLE) ) THEN 
	      CALL TM_NOTE(
     .           'Coordinate variable '//
     .           vname(:vlen)//' is of non-numeric type.', lunit_errors )
              status = STR_UPCASE( buff, vname )
              CALL TM_NOTE(
     .           'A dummy axis of subscripts will be used. '// 
     .           'Variable '//buff(:vlen)//' contains the strings', 
     .           lunit_errors )
              GOTO 400
	   ELSE IF (vartyp.LT.nf_byte .OR. vartyp.GT.nf_string) THEN
	      GOTO 5300
	   ENDIF
	    
*** DECIDE IF IT IS AN AXIS OR A DEPENDENT VARIABLE
* if it is not 1D it must be a dependent variable (3/99)

	   IF ( nvdim .NE. 1 ) GOTO 400

* if var name doesn't match a dim name it isn't a coordinate var
           CALL CD_GET_DIM_ID (dset, vname(:vlen), i)
           IF (i .EQ. atom_not_found) GOTO 400

* See if it has a bounds attribute 

           maxlen = 128
           got_it = NC_GET_ATTRIB( dset, ivcd, 'bounds',
     .              do_warn, vname(:vlen), maxlen, attlen, attoutflag, 
     .              bname(nbvar+1), vals )

           IF (got_it ) THEN

              CALL CD_GET_VAR_ATT_ID (dset, ivcd, 'bounds', attid, 
     .              status)
              IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, ivcd, 
     .              attid, aname, attype, attlen, attoutflag, istat )

              IF (attype .EQ. nf_char) THEN
                 nbvar = nbvar + 1
                 istat = STR_UPCASE( bname(nbvar), bname(nbvar) )
              ENDIF
           ENDIF

  400      CONTINUE
 2000   CONTINUE

*   * * * loop through all variables in the net CDF file * * *

* classify each as a coordinate variable (axis) or as a dependent
* variable. If a 1-D coordinate variable then TRY to interpret it,
* (in cd_get_1_axis) but if it proves to be invalid, then process
* it, instead, as a dependent variable
	las_pos  = 1    ! reduces redundant search for space
	got_a_variable = .FALSE.
	
	DO 1000 ivcd = 1,nvars

* initialize
	   failed_axis = .FALSE.

* get the vital statistics for this variable

           CALL CD_GET_VAR_INFO (dset, ivcd, vname, vartyp, nvdim,
     .                 vdims, nvatts, coordvar, all_outflag, status)
           IF ( status .NE. merr_ok ) GOTO 5200
           vlen = TM_LENSTR1(vname)

*** CHECK A NUMBER OF REASONS TO IGNORE THIS VARIABLE
* is the dimension name "grid_definition" ? If so, handled elsewhere

           CALL CD_GET_DS_DIMS (dset, vdims(1), buff, npts, istat)
           IF ( istat .NE. merr_ok ) GOTO 5200

           istat = STR_CASE_BLIND_COMPARE('grid_definition', buff(:15) )
           IF ( istat .EQ. str_eq ) GOTO 1000

* or is it milliseconds for an an EPIC time axis? If so, handled with "time"
           IF ( its_epic .AND. vname(:vlen).EQ.'time2' ) GOTO 1000

* Is it an edge definition ? If so, process w/ corresponding axis
           maxlen = max_vnamelen 
           got_it = NC_GET_ATTRIB( dset, ivcd, 'edges', do_warn, 
     .                            vname(:vlen), maxlen, attlen,
     .                            attoutflag, buff, vals)

           IF ( got_it .AND. buff.EQ.' ' ) GOTO 1000

* or is it really a child axis (avail for. generic CDF apps but not needed) ?
           maxlen = 16  !linenamlen
           got_it = NC_GET_ATTRIB( dset, ivcd, 'child_axis',
     .                            do_warn, vname(:vlen), maxlen, attlen,
     .                            attoutflag, name, vals ) 
           IF ( got_it ) GOTO 1000

* or is it really a bounds variable for an axis?  If so it is processed with the axis.

           len_test = TM_LENSTR(vname)
           IF (nbvar .GT. 0) then 
              DO 30 ivar = 1, nbvar
                 len_mchars = TM_LENSTR(bname(ivar))
                 IF (MATCH_NAME(vname, len_test, bname(ivar), len_mchars )) GOTO 1000
   30         CONTINUE
           ENDIF

* is it a supported dimensionality (6d, strings have extra dimension) ?
          IF ( nvdim .GT. nferdims+1 ) THEN
             CALL TM_NOTE('Unsupported netCDF # of axes for variable. Ignoring '
     .             //vname(:vlen), tt )
             GOTO 1000
          ENDIF

* is it a supported dimensionality (numeric can be 6D)?
          IF ( nvdim .GT. nferdims .AND. vartyp.NE. NCCHAR ) THEN
             CALL TM_NOTE('Unsupported netCDF # of axes for variable. Ignoring '
     .             //vname(:vlen), tt )
             GOTO 1000
          ENDIF

*** DECIDE IF IT IS AN AXIS OR A DEPENDENT VARIABLE
* if it is not 1D it must be a dependent variable (3/99)
	   IF ( nvdim .NE. 1 ) GOTO 500

* if for some reason it is desirable for an axis name not to match its dim
* name then the "parent_axis" attribute can flag that it is a parent axis 
           maxlen = 16  !linenamlen
           got_it = NC_GET_ATTRIB( dset, ivcd, 'parent_axis',
     .                            do_warn, vname(:vlen), maxlen,
     .                            attlen, attoutflag, name, vals )

           IF ( got_it ) GOTO 100

* if var name doesn't match a dim name it isn't a coordinate var
           CALL CD_GET_DIM_ID (dset, vname(:vlen), i)
           IF (i .EQ. atom_not_found) GOTO 500

* PROCESS AN AXIS	   
 100        CALL CD_GET_1_AXIS(dset, cdfid, ivcd, iaxis,
     .                         its_EPIC, reversed, tregular, use_strict, 
     .                         bad_bndsid, has_gdef, status)
           IF ( status .NE. merr_ok ) GOTO 5900

* invalid bounds or edges found. Make the bounds a dependent variable
	   IF (bad_bndsid .GT. 0) THEN
	     CALL CD_GET_1_DEP_VAR ( dset, cdfid, bad_bndsid, las_pos, global_bad, 
     .				   ivtm, status )
             GOTO 501
           ENDIF

	   IF (iaxis .NE. 0) GOTO 1000		! iaxis>0 if axis was made
	   failed_axis = .TRUE.			! go on and treat as a dep. var

* PROCESS A DEPENDENT VARIANLE
 500	   CALL CD_GET_1_DEP_VAR ( dset, cdfid, ivcd, las_pos, global_bad, 
     .				   ivtm, status )

 501       IF (status .NE. merr_ok) GOTO 5900
	   IF ( ivtm .NE. 0 ) THEN
	      las_pos = ivtm	! optimizes next hunt for slot
	      IF (.NOT.got_a_variable) THEN
	         first_pos = ivtm
	         got_a_variable = .TRUE.
	      ENDIF
	   ENDIF
	   IF ( failed_axis ) ds_var_titl_mod(ivtm) = 
     .				'invalid coordinate axis'
           
	   IF (bad_bndsid .GT. 0) THEN
	      ds_var_titl_mod(ivtm) = 'invalid axis bounds'
	      bad_bndsid = 0
	   ENDIF

* EPIC KLUDGE: if an EPIC file has an invalid "TIME" axis we want, not only
* "TIME" as a dependent variable, but also "TIME2"
	   IF ( its_epic .AND. vname(:vlen).EQ.'time' ) THEN
	      CALL CD_GET_VAR_ID ( dset, 'time2', epic_t2, status )
	      IF ( epic_t2 .GT. 0 ) THEN
	        CALL CD_GET_1_DEP_VAR (dset,cdfid, epic_t2,
     .			las_pos, global_bad, ivtm, status )
	        IF (status .NE. merr_ok) GOTO 5900
	        IF ( ivtm .NE. 0 ) THEN
	          las_pos = ivtm	! optimizes next hunt for slot
	          IF (.NOT.got_a_variable) THEN
	            first_pos = ivtm
	            got_a_variable = .TRUE.
	          ENDIF
	        ENDIF
	         ds_var_titl_mod(ivtm) = 'invalid EPIC time axis'
	     ENDIF
	   ENDIF

 1000    CONTINUE
*   * * * * * * * * * * * * * * * * * * * * * * * * 

* pass through the variable names making sure that case-sensitive
* duplicates (e.g. 'var' and 'VAR') retain case and that names which
* would be illegal variable names to Ferret are retained in original form


	IF (got_a_variable) THEN
	  DO 310 ivtm = first_pos,las_pos
	    IF (ds_var_setnum(ivtm) .NE. dset) GOTO 310
	    IF (.NOT.TM_LEGAL_NAME(ds_var_code(ivtm))) GOTO 310  ! leave as-is
* ... see if this name case-blind duplicates any other in the data set
	    DO 300 i = first_pos,las_pos
* ... *kob* v541 8/02 - need to also check and make sure we are still dealing with the
*     same dataset.  if not, when variables from different data sets are interleaved 
*     in ds_var_code this can cause Ferret to not properly upcase variables from 
*     one dset that have the same name as variables in another dset. 
	      IF ( i .EQ. ivtm .OR. ds_var_setnum(i) .NE. dset) GOTO 300
	      istat = STR_CASE_BLIND_COMPARE(ds_var_code(ivtm),
     .                                       ds_var_code(i)    )
	      IF ( istat .EQ. str_eq ) GOTO 310                  ! leave as-is
 300	    CONTINUE
* ... (finally) upcase the name
*	  istat = STR_UPCASE( ds_var_code(ivtm), ds_var_code(ivtm) )
          CALL string_array_modify_upcase(ds_var_code_head,ivtm,
     .                                    ds_var_code(ivtm),
     .                                    LEN(ds_var_code(ivtm)))
 310    CONTINUE
	ENDIF

* successful completion
	status = merr_ok
	RETURN

* ERROR MESSAGES
 5200   CALL TM_ERRMSG
     .     ( cdfstat+pcdferr, status, 'CD_SCAN_VARS', cdfid,
     .        no_varid, no_errstring, no_errstring, *5900 )
 5300   CALL TM_ERRMSG
     .     ( merr_notsupport, status, 'CD_SCAN_VARS', dset_num,
     .         no_stepfile, 
     .         'String Data Type not implemented: variable '//vname(:vlen),
     .         no_errstring,*5900)

* error exit
 5900   RETURN
	END

      SUBROUTINE maxMINMAX  (Z, L, MM, NN, neigh_x, neigh_y, badz, 
     .                      zmaxlist, nzmax)
C
C  based on NCAR routine MINMAX, return maxima
C  From the NCAR graphics library at http://ngwww.ucar.edu version 4.2
C  Modified by Ansley Manke to regurn only the maxima for subroutine findhi.F
C
C-------------------------------------------------------------
C	$Id$
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C This file is free software; you can redistribute it and/or modify
C it under the terms of the GNU General Public License as published
C by the Free Software Foundation; either version 2 of the License, or
C (at your option) any later version.
C
C This software is distributed in the hope that it will be useful, but
C WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
C General Public License for more details.
C
C You should have received a copy of the GNU General Public License
C along with this software; if not, write to the Free Software
C Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
C USA.
C-------------------------------------------------------------

CC THIS ROUTINE FINDS RELATIVE MINIMUMS AND MAXIMUMS.  A RELATIVE MINIMUM
C (OR MAXIMUM) IS DEFINED TO BE THE LOWEST (OR HIGHEST) POINT WITHIN
C A CERTAIN NEIGHBORHOOD OF THE POINT.  THE NEIGHBORHOOD USED HERE
C IS + OR - MN IN THE X DIRECTION AND + OR - NM IN THE Y DIRECTION.
C
C ORIGINATOR       DAVID KENNISON

C  Ansley Manke changes for Ferret 7/01
C	- remove sections that put label on plot
C	- use "bad value" rather than SPECIAL VALUE, SPVAL
C	- remove references to IOFFP, JOFFDT
c	- new code and my comments in lowercase
c	- return maxes.  For n = 1, nzmax:
c	    zmaxlist(1,n) = i index of zmax point
c	    zmaxlist(2,n) = j index of zmax point
c	    zmaxlist(3,n) = z value at zmax point
C
      IMPLICIT NONE
      integer	L, MM, NN, m, n, nm1, mm1, jp, im, mn, ip, is, it, ii,
     .		js, nm, jt, jk, ik, nzmax, neigh_x, neigh_y

      real	Z(L,NN), aa, an, badz, zmaxlist(3,*)
C
      M = MM
      N = NN

c      MN = min(2,MAX(2,IFIX(FLOAT(M)/8.)))
c      NM = min(2,MAX(2,IFIX(FLOAT(N)/8.)))

      MN = neigh_x
      NM = neigh_y

      nzmax = 0
C
      NM1 = N-1
      MM1 = M-1
C
C LINE LOOP FOLLOWS - THE COMPLETE TWO-DIMENSIONAL TEST FOR A MINIMUM OR
C MAXIMUM OF THE FIELD IS ONLY PERFORMED FOR POINTS WHICH ARE MINIMA OR
C MAXIMA ALONG SOME LINE - FINDING THESE CANDIDATES IS MADE EFFICIENT BY
C USING A COUNT OF CONSECUTIVE INCREASES OR DECREASES OF THE FUNCTION
C ALONG THE LINE
C
      DO 127 JP=2,NM1
C
         IM = MN-1
         IP = -1
         GO TO 126
C
C CONTROL RETURNS TO STATEMENT 10 AS LONG AS THE FUNCTION IS INCREASING
C ALONG THE LINE - WE SEEK A POSSIBLE MAXIMUM
C
  101    IP = IP+1
         AA = AN
         IF (IP .EQ. MM1) GO TO 104
         AN = Z(IP+1,JP)
         IF (AN.EQ.badz) GO TO 125
         IF (AA-AN) 102,103,104
  102    IM = IM+1
         GO TO 101
  103    IM = 0
         GO TO 101
C
C FUNCTION DECREASED - TEST FOR MAXIMUM ON LINE
C
  104    IF (IM .GE. MN) GO TO 106
         IS = max(1,IP-MN)
         IT = IP-IM-1
         IF (IS .GT. IT) GO TO 106
         DO 105 II=IS,IT
            IF (AA .LE. Z(II,JP)) GO TO 112
  105    CONTINUE
  106    IS = IP+2
         IT = min(M,IP+MN)
         IF (IS .GT. IT) GO TO 109
         DO 108 II=IS,IT
            IF (Z(II,JP).NE.badz) GO TO 107
            IP = II-1
            GO TO 125
  107       IF (AA .LE. Z(II,JP)) GO TO 112
  108    CONTINUE
C
C WE HAVE MAXIMUM ON LINE - DO TWO-DIMENSIONAL TEST FOR MAXIMUM OF FIELD
C
  109    JS = max(1,JP-NM)
         JT = min(N,JP+NM)
         IS = max(1,IP-MN)
         IT = min(M,IP+MN)
         DO 111 JK=JS,JT
            IF (JK .EQ. JP) GO TO 111
            DO 110 IK=IS,IT
               IF (Z(IK,JK).GE.AA .OR. (Z(IK,JK).EQ.badz)) GO TO 112
  110       CONTINUE
  111    CONTINUE

	 nzmax = nzmax + 1
	 zmaxlist(1,nzmax) = float(ip)
	 zmaxlist(2,nzmax) = float(jp)
	 zmaxlist(3,nzmax) = z(ip,jp)

  112    IM = 1
         IF (IP-MM1) 113,127,127
C
C CONTROL RETURNS TO STATEMENT 20 AS LONG AS THE FUNCTION IS DECREASING
C ALONG THE LINE - WE SEEK A POSSIBLE MINIMUM
C
  113    IP = IP+1
         AA = AN
         IF (IP .EQ. MM1) GO TO 116
         AN = Z(IP+1,JP)
         IF (AN.EQ.badz) GO TO 125
         IF (AA-AN) 116,115,114
  114    IM = IM+1
         GO TO 113
  115    IM = 0
         GO TO 113
C
C FUNCTION INCREASED - TEST FOR MINIMUM ON LINE
C
  116    IF (IM .GE. MN) GO TO 118
         IS = max(1,IP-MN)
         IT = IP-IM-1
         IF (IS .GT. IT) GO TO 118
         DO 117 II=IS,IT
            IF (AA .GE. Z(II,JP)) GO TO 124
  117    CONTINUE
  118    IS = IP+2
         IT = min(M,IP+MN)
         IF (IS .GT. IT) GO TO 121
         DO 120 II=IS,IT
            IF (Z(II,JP).NE.badz) GO TO 119
            IP = II-1
            GO TO 125
  119       IF (AA .GE. Z(II,JP)) GO TO 124
  120    CONTINUE
C
C WE HAVE MINIMUM ON LINE - DO TWO-DIMENSIONAL TEST FOR MINIMUM OF FIELD
C
  121    JS = max(1,JP-NM)
         JT = min(N,JP+NM)
         IS = max(1,IP-MN)
         IT = min(M,IP+MN)
         DO 123 JK=JS,JT
            IF (JK .EQ. JP) GO TO 123
            DO 122 IK=IS,IT
               IF (Z(IK,JK).LE.AA .OR. (Z(IK,JK).EQ.badz)) GO TO 124
  122       CONTINUE
  123    CONTINUE
C
  124    IM = 1
         IF (IP-MM1) 101,127,127
C
C SKIP SPECIAL VALUES ON LINE
C
  125    IM = 0
  126    IP = IP+1
         IF (IP .GE. MM1) GO TO 127
         IF (Z(IP+1,JP).EQ.badz) GO TO 125
         IM = IM+1
         IF (IM .LE. MN) GO TO 126
         IM = 1
         AN = Z(IP+1,JP)
         IF (Z(IP,JP)-AN) 101,103,113
C
  127 CONTINUE
C
      RETURN

      END

	SUBROUTINE PROCLAIM ( logical_unit, left_margin )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* introduce the program

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 4/3/86
* V400 - 3/95 - changed "Revision" to "Version"
* V402 - 8/95 - use XREVISION_TYPE to automate version info
* V510 6/00 *sh* - if revision_type is "()" ignore it
* v540 10/01 *kob* - add platform type to proclaim message and rearrange
*                   proclaim message
*      10/01 *kob* - insert missing comma in format statement
*                    discovered by linux compiler
*       8/05 *acm* - Allow more digits in xrevision number
* V63  *acm* 10/09 Changes for gfortran build

	include 'xrevision.cmn'
	include 'xrevision_type.cmn'
	include 'xtoday.cmn'
	include 'xmake_date.cmn'
	include 'xplatform_type.cmn'

* calling argument declarations:
	INTEGER		logical_unit
	CHARACTER*(*)	left_margin

* local variable definitions
	INTEGER TM_LENSTR1, len_platform_type, slen
        CHARACTER*12 TM_FMT, show_str

* get revision type info (8/95 - kind of a hack)
	IF ( revision_type .EQ. '()' ) THEN
	   progname_mod = ' '
	ELSE
	   progname_mod = revision_type
	ENDIF
	len_progname_mod = TM_LENSTR1(progname_mod)
	len_platform_type = TM_LENSTR1(platform_type)
        show_str = TM_FMT(revision_level, 5, 12, slen)

	WRITE  ( logical_unit, 3000)
     .				left_margin,
     .				left_margin, program_name(1:len_program_name),
     .                                       show_str(1:slen),
     .					     progname_mod(1:len_progname_mod), 
     .				left_margin, platform_type(1:len_platform_type),
     .                                       make_date,
     .				left_margin, today_date, today_time

 3000	FORMAT ( 1X,A,'NOAA/PMEL TMAP',/
     .           1X,A,A,1X,'v',A,1x,A,/
     .           1X,A,A,1X,'-',1X,A,/
     .           1X,2A,1X,A/ )

	RETURN
	END

	SUBROUTINE INTERP_STACK (  isp_base, dflt_cx,
     .				  name_code, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Return a grid of data and a buffer of context info about the grid given 
* a default context for evaluation and the text of an expression.
* Transformations, regrids, rotations, etc. are all controlled
* by this routine.  Nesting of these operations is possible because all
* operations are carried out on a stack - the "interpretation stack".
* The results are left on the interpretation stack at level isp_base
* The result computed, pointed to by is_mr(isp_base), is left protected

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 2/10/87
* .
* .
* .
* V200:  5/18/89 - 4D-symmetrical
*		 - implicit regridding
*		 - transformations not permitted on command line
*		 - eliminated get_ctxt_only from call
*		 - "cvar" evaluation is done on the IS stack
*		 - uvar grids determined in IGRID
*	 1/11/90 - added @LOC
*	 2/28/90 - added kludge code to double check memory before IS_READ
* for Unix/RISC port 9/91 - added Hanning,Parzen and Welch filters (windows)
*                         - added CLEAN_STACK for better error handling
* V230: 12/26/91 - added @SUM, @WEQ, @RSUM
*        1/22/92 - added @WEQ
*         2/3/92 - added @VAR, @NGD, and @NBD
*        3/23/92 - added @FLN (fill with linear interpolation)
* V312: 5/94  - array "memory" as a calling argument
* V320: 12/94 - added logic to trap modulo reads on file variables
*	 2/95 - added logic to trap reverse-direction axes and reverse them
* V420: 11/95 - moved modulo logic from file vars only to all variables
*		(12/95) screen out uvlim_*_xact from modulo
*	      - added isact_class_reconcile so cmnd qualifiers are
*		better processed
*	      - support for non-reusable results: if component is non-reusable
*		so is result (using ITS_UN_CACHED and UN_CACHE)
* V430: 7/96  - incorporate 4D transformations
* V450: 2/97  - Allow application of modulo to GC vars (but not other uvars)
* V455    9/97 - added transforms @CDA,CDB,CIA,CIB
* V500: 10/98 *jc* - added lines to ignore hidden @RDC
*	12/98 *sh* added call to IS_CONST_VAR to support {1,3,5} notation
*	 3/99 *sh* added call to COMPLETE_MISSING_LIMITS to improve cache hits
*		and corresponding change in file reading to restrict limits
*	 5/99 *sh* remove delta values error trap
*		(cx_delta is now used by netCDF vars to signal that the
*		read_tm should use strides)
* V510: 8/99 *sh* handle isact_sample
* V530: 11/00 *sh* - perform RESTRICT_FILE_LIMITS before recheck FIND_MEM_VAR
*		for improved cache hits (case; ASCII file reads where EZ axis
*		exceeds actual file size misses cache because
*		COMPLETE_MISSING_LIMITS inserts full EZ ax limits)
* V533: 6/01 *sh* - added @EVNT
* V541: 2/02 *sh* - added support for modulo lengths (subspan modulo)
* V554 1/04 *acm* - additions for /RANGE repeat loop control
* V603 4/07 *acm* - Fix bug 636;  Resolve any wierd cx_grid definitions leftover from get_context_mods
*                   before calling COMPLETE_MISSING_LIMITS. Bug occured from regridding a variable to 
*                   its own axis with [gt=var]
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V690 9/13-2/14 *sh* add support for aux var regridding: temp[gz(depth)=zax]
* V694 3/15 *acm* Fix ticket 2241: as for modulo replications, don't do the
*                 creation of virtual "void" point on subspan modulo axes for 
*                 user-variables that have compressed result.
* V695+ 5/15 *sh* FIND_MEM_VAR ==> FIND_MEM_VAR_INCL_C_CACHE
*	          delay stripping gather until after stripping regrids
* V695 *acm* 10/15 Fix #2319: @STD as a multi-D transform
* V698 *sh* 12/15 implement dummy data sets in forecast aggregations
* V698  3/16 *acm* Removed Philander-Seigel code including diagnostic 
*                  variables, pre-defined axes and grids, cat_calc_var.
* V680 *acm* 5/16  Fix ticket 2366, putting the subspan void point and modulo
*                  replications before transformations.
* V7    5/12 *acm* Union aggregations: DEFINE DATA/AGG/U
* V702 11/16 *sh*  split/gather on compressed axes -- see IS_TRANS calls
* V702  1/17 *sh*  for trac enhancement #2369 -- dynamic memory management

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xinterrupt.cmn'
	include	'xprog_state.cmn'
	include	'xfr_grid.cmn'

* calling argument declarations:
	INTEGER		isp_base, dflt_cx, status
	CHARACTER*(*)	name_code

* internal variable declarations:
	LOGICAL		ITS_UN_CACHED, ITSA_MODULO_REGRID, ITSA_GCVAR,
     .			ITSA_MODULO_GCF, TM_ITS_SUBSPAN_MODULO,
     .			look_again, modulo_axes(nferdims), 
     .			explicit_qualifiers, is_remote_var
	INTEGER		UVAR_NUMBER, KNOWN_GRID, CGRID_AXIS,
     .			CAXIS_MODLEN, TM_AXES_REVERSED, rev_axes(nferdims),
     .			cx, mr, idim, cat, act, uvar_pointer,
     .			com_mr, var, dset, slen, slen2
!	INTEGER*8	CGRID_SIZE8, cxsize
	CHARACTER	TM_FMT*12, num_str*12, num_str2*12

* external routines passed
	EXTERNAL	DO_SHIFT, DO_SMTH_BOX, DO_FILL_AVE, DO_AVERAGE,
     .			DO_INTEG_DEF, DO_4D_AVE, DO_4D_INT_DEF,
     .			DO_DERIV_FRWD, DO_DERIV_CNTR,DO_DERIV_BKWD,
     .			DO_SMTH_BINML, DO_MIN, DO_MAX, DO_INT_INDEF,
     .			DO_INTERPOLATE, DO_LOCATE, DO_SMTH_HANNG,
     .                  DO_SMTH_PARZN, DO_SMTH_WELCH, DO_SUM,
     .                  DO_DIST_LOC, DO_RUN_SUM, DO_NGOOD, DO_NBAD,
     .                  DO_VARIANCE, DO_FILL_INTERP, DO_FILL_NEAR,
     .			DO_4D_VAR,DO_4D_NGD,DO_4D_NBD,DO_4D_SUM,
     .			DO_NEAREST_DIST_ABOVE, DO_NEAREST_DIST_BELOW,
     .			DO_NEAREST_INDEX_ABOVE,DO_NEAREST_INDEX_BELOW,
     .			DO_EVENT, DO_SMTH_MEDIAN, DO_SMTH_MIN, DO_SMTH_MAX,
     .			DO_STDDEV, DO_AVG_WGT, DO_4D_AVE_WGT, DO_SMTH_BOX_P,
     .			DO_4D_STD

* calling arguments:
* in	isp_base	- stack level at which to begin calculations
*			  ( all levels below remain untouched )
* in	dflt_cx		- "default context" for evaluation of expression
* in	name_code	- name of uvar to be evaluated
* out	status		- completion code

* example of stack operations:
*	let DTDX = ( temp[i=+1d] - temp[i=-1d] ) / 2*dx
* ... and we wish to evaluate
*	LIST/X=170E:160W:10 U[G=TEMP,Z=@AVE] * DTDX

* outside of this routine the default context (from SET REGION,DATA,etc)
* has been modified by "/X=170E:160W:10" to produce dflt_cx
* Before entering this routine the text of the expression has been moved to 
* a numbered buffer in uvar_text and broken down into reverse Polish 
* ordered operations within other arrays in the uvar structure.

* When the stack is entered ( in isact_request mode ) it will detect the delta
* 10 degrees specified on the X axis and interpret this as an implicit request
* to regrid the data.  IS_STRIP will be called to strip this off by claiming
* a level on the IS stack for the regridding operation, incrementing the IS
* stack pointer, isp, and passing on the context (pointed to by is_cx)
* modified by the removal of ":10".

* Having no transformations or regrids in its current top level context 
* INTERP_STACK will then treat the context as an algebraic expression and
* IS_ALGEBRA will be given control.  IS_ALGEBRA will claim an IS stack level
* for its operations.  IS_ALGEBRA will parse the string "U[G=TEMP]",
* identifying data set, variable, grid, transformations, etc. and setting
* up a context that describes it.  The resulting request will then be passed
* back to INTERP_STACK at label 10 in IS_REQUEST mode.

* INTEEP_STACK will then detect the request for Z averaging.  Again,
* IS_STRIP will be called to allocate a stack level for the operation and
* strip the averaging request off in the context for the next stack level.

* INTEEP_STACK will then detect the explicit request for regridding and call
* IS_STRIP again to allocate a stack level for the operation and strip the
* regridding request off in the context for the next stack level.

* INTERP_STACK, again in IS_REQUEST mode, will then see that the context at the
* top of the stack now contains a request for a variable ("U") to be read and
* it will call IS_READ.  The variable will be read and the IS stack pointer
* will be decremented.

* INTERP_STACK now finds itself in regridding mode (isact_regrid) and calls
* IS_REGRID to perform the operation on the results just averaged.  When
* the regridding operation is completed isp is decremented.

* INTERP_STACK now finds itself in averaging mode (isact_average) and calls
* IS_AVERAGE to perform the operation on the results just read.  Again, when
* the averaging operation is completed the IS stack pointer,isp, is decremented.

* INTERP_STACK now finds itself back in algebra mode (isact_algebra) and calls
* IS_ALGEBRA giving it the requested component pointed to by is_mr on the IS
* stack.  IS_ALGEBRA then moves on to the next component, DTDX, parses the
* expression and passes the request back to INTERP_STACK. ... etc.
* When IS_ALGEBRA regains control again it will have the 2 needed operands
* on the stack and it will perform the requested multiplication operation.
* It will then detect that it has reached the end of the expression and
* decrement isp.

* INTERP_STACK now finds itself back in implicit regrid mode.  It calls
* IS_AUTOGRID to perform the required action.  IS_AUTOGRID decrements isp
* when it is finished.

* INTERP_STACK then finds itself back at the base IS stack level signaling 
* that the expression has been evaluated successfully.  It exits signalling
* successful completion.

* --- end of introductory code ---

* locate the requested variable in the uvar variables
	uvar_pointer = UVAR_NUMBER( name_code )
	IF ( uvar_pointer .EQ. unspecified_int4 ) CALL ERRMSG
     .		( ferr_internal, status, 'intp_stk', *5000 )
	
* initialize the default context for the quantity to evaluate
	cx_variable( dflt_cx ) = uvar_pointer
	cx_category( dflt_cx ) = cat_user_var
	cx_grid    ( dflt_cx ) =
     .		KNOWN_GRID(cx_data_set(dflt_cx),cat_user_var,uvar_pointer)

* initialize base level of the interpretation stack
* ... ( see PUSH_INTERP_STACK for isp>isp_base )
 6	isp = isp_base			     ! stack pointer
	is_cx     ( isp ) = dflt_cx	     ! context for stack activities
	is_uvar   ( isp ) = uvar_pointer     ! pointer to text buffer
	is_aux_ptr( isp ) = max_usable_intrp ! pointer to aux vars for plotting

* when called the request is ALWAYS for an untransformed implicitly defined
* user variable (e.g. "LIST U" or "LIST SIN(X+Y)"
* determine its grid, if necessary - then flesh out the requested dimensions
	IF ( cx_grid(dflt_cx) .EQ. unspecified_int4 ) THEN
	   CALL GET_UVAR_GRID( uvar_pointer,cx_data_set(dflt_cx),status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   cx_grid(dflt_cx) =
     .		KNOWN_GRID(cx_data_set(dflt_cx),cat_user_var,uvar_pointer)
	ENDIF

* flesh out the requested dimensions (noting if there are any)
	explicit_qualifiers = .FALSE.
	DO 5 idim = 1, nferdims
	   IF ( uvar_given( idim, uvar_pointer ) .GE. uvlim_needed
     .	   .OR. cx_given( idim,dflt_cx ) ) THEN
	      explicit_qualifiers = explicit_qualifiers
     .			       .OR. cx_given(idim,dflt_cx )
	      CALL CONFINE_AXIS( idim, dflt_cx, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
	      CALL FLESH_OUT_AXIS( idim, dflt_cx, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
	   ENDIF
 5	CONTINUE
	
* was a regridding operation implied through the command qualifier cx_delta?
* (5/99) test moved from transformation stripping section below
	DO 8 idim = 1, nferdims
	   IF ( cx_delta(idim, dflt_cx) .NE. unspecified_val8 ) THEN
	      CALL ERRMSG( ferr_invalid_command, status,
     .			'delta values may only modify variable names', *5000 )
	   ENDIF
 8	CONTINUE



* special pre-initialization of stack to reconcile differences between command
* qualifiers and expression -- e.g. LIST/I=1:5 a[i=3:4]
	IF ( explicit_qualifiers ) THEN
	   CALL IS_STRIP( isact_class_reconcile, 0, *10, status )
	   GOTO 5000
	ENDIF

******************************************************************************
* * * * * * TOP OF INTERPRETATION STACK - INITIALIZE STACK LEVEL * * * * * *
******************************************************************************
 10	is_act(isp)   = isact_request
	cx = is_cx( isp )
	cat  = cx_category( cx )
	var  = cx_variable( cx )
	dset = cx_data_set( cx )

! check that there are no corrupted string arrays in memory
! use for help diagnosing string pointer errors
!	CALL SANITY_CHECK_STRING_ARRAYS("INTERP_STACK")

* constants and pseudo-variables and counter variables may be handled immediately
* ... get user variable grids if unknown
	IF     ( dset .EQ. pdset_dummy ) THEN
	   CALL IS_DUMMY (  *2000, status )
	   GOTO 5000
	ELSEIF ( cat .EQ. cat_pseudo_var ) THEN
	   CALL IS_PSEUDO (  *2000, status )
	   GOTO 5000
	ELSEIF ( cat .EQ. cat_constant ) THEN
	   CALL IS_CONSTANT(  *2000, status )
	   GOTO 5000
* ... get a counter variable
	ELSEIF ( cat .EQ. cat_counter_var ) THEN
	   CALL IS_COUNTER_VAR   (var,  *2000, status )
	   GOTO 5000

        ENDIF

* 3/99 complete missing context limits as full-span: to improve cache hits

*      first resolve any wierd cx_grid definitions leftover from  get_context_mods
	IF (cx_grid(cx) .LT. unspecified_int4) THEN 
	   CALL GET_UVAR_GRID( uvar_pointer,cx_data_set(cx),status )
           IF ( status .NE. ferr_ok ) GOTO 5000
	   cx_grid(cx) =
     .		KNOWN_GRID(cx_data_set(cx),cat_user_var,uvar_pointer)
	ENDIF
        
        CALL COMPLETE_MISSING_LIMITS( cx )

* check in memory to see if we already have the data 
	CALL FIND_MEM_VAR_INCL_C_CACHE( cx, mr, search_by_value )
	IF ( mr .GT. mr_nonexist ) THEN
* ... yes - already in memory
	   is_mr( isp ) = mr
	   IF ( mr_category(mr) .EQ. cat_user_var ) THEN
	      CALL PASS_AMBIG_LIMS( cx, mr, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
	   ENDIF
	   GOTO 2000						! pop stack
	ENDIF

* check to make sure that this result can fit into memory.
*   added 2/2017 just in order to generate earlier, friendlier error message
! problem: the context, at least when a pseudo-variable is being evaluated
! may contain context limits (inherited from SET REGION or command qualifiers)
! that are actually irrelevant to the variable being evaluated.  The result is
! that CGRID_SIZE8 may return a result that is much larger than what is correct
! I left this block of code in just in case someone ever wants to follow this
! path.  It would be nicer to issue an error message at this early point.
!	IF (.NOT.mode_state(pmode_greedy,1)) THEN
!	   cxsize = CGRID_SIZE8( cx )
!	   IF (cxsize .GT. max_mem_allowed) THEN
!	      IF (cxsize .EQ. 99999999 ) THEN
!	         CALL ERRMSG(ferr_limits,status,
!     .		"Did you use an ABSTRACT axis without specifying limits?",
!     .			*5000)
!	      ELSE
!	         num_str  = TM_FMT( max_mem_allowed/1.E6, 3, 12, slen)
!		 num_str2 = TM_FMT( cxsize/1.E6,          3, 12, slen2)
!	         CALL ERRMSG( ferr_insuff_memory,status,
!     .		 "Size of request="//num_str2(:slen2)//
!     .		 " but currently SET MEMORY/SIZE="//num_str(:slen), *5000)
!	      ENDIF
!	   ENDIF
!	ENDIF

******************************************************************************
* * * * * * * * STRIP AWAY TRANSFORMATIONS ONTO STACK * * * * * * * * * * * * 
******************************************************************************



* ... strip off creation of virtual "void" point on subspan modulo axes

	CALL GET_CX_MODULO_AXES(cx,modulo_axes)
	DO 255 idim = 1, nferdims
	   IF ( modulo_axes(idim)
     .	  .AND. cx_lo_ss(cx,idim) .NE. unspecified_int4 ) THEN

	      IF ( cat .EQ. cat_user_var ) THEN
*    ... cannot modulo an average (or other compressed result)
	         IF ( uvar_given(idim,var) .EQ. uvlim_gvn_xact
     .		 .OR. uvar_given(idim,var) .EQ. uvlim_need_xact ) GOTO 255
	      ENDIF

	     IF (TM_ITS_SUBSPAN_MODULO(CGRID_AXIS(idim, cx))) THEN
	      IF (cx_hi_ss(cx,idim) .EQ. CAXIS_MODLEN(idim, cx)) THEN
	        CALL IS_STRIP(isact_class_subspan_fill,idim,*10,status)
	        GOTO 5000
	      ENDIF
	    ENDIF
	  ENDIF
 255	CONTINUE

* ... strip off "modulo" replications
*   ... but do not strip modulo at the topmost level
*     - else LIST/X=340:380 mod_var[X=@ave] will be wrong
	IF ( cat .EQ. cat_user_var ) THEN
	   IF (uvar_name_code(var)(1:3) .EQ. 'EX#'    ) GOTO 260
	ENDIF	   
	DO 250 idim = 1, nferdims
	   IF ( modulo_axes(idim)
     .	  .AND. cx_lo_ss(cx,idim) .NE. unspecified_int4 ) THEN
	      IF ( cat .EQ. cat_user_var ) THEN			! added 12/95
*    ... cannot modulo an average (or other compressed result)
	         IF ( uvar_given(idim,var) .EQ. uvlim_gvn_xact
     .		 .OR. uvar_given(idim,var) .EQ. uvlim_need_xact ) GOTO 250
*    ... do not apply modulo to pseudo-variables - else their values will not
*	 match the modulo axis indices and values
* 	 Exception to this is modulo regrids -- comments at end of IS_STRIP
	         IF ( uvar_mod_pseudo(idim,var)
     .		.AND. .NOT.ITSA_MODULO_REGRID(cx,idim) ) THEN
*    ... (2/97) imposed axis of a grid changing var can get moduloed 
		   IF ( ITSA_GCVAR(var) ) THEN
	              IF (.NOT.ITSA_MODULO_GCF(cx,idim)) GOTO 250
	           ELSE
	              GOTO 250
	           ENDIF
	         ENDIF
	      ENDIF
! 11/95 - known bug/feature:
! A[I=1:10] behaves inconsistently wrt  A[I=1:20] for A=VAR[I=3:7] on a
! modulo axis of length 10 because is_modulo reconciles differences between
! the component and the result differently from non-modulo vars
	      IF (cx_hi_ss(cx,idim ) .GT. CAXIS_MODLEN(idim,cx)
     .	     .OR. cx_lo_ss(cx,idim ) .LT. 1 ) THEN
	         CALL IS_STRIP( isact_class_modulo, idim, *10, status )
	         GOTO 5000
	      ENDIF
	   ENDIF
 250	CONTINUE
 260	CONTINUE

* ... strip off a transformation ?
* ... reverse loop order ensures that X transformations are done BEFORE
* ... the Y transformations. This is necessary for accuracy wrt. COS factors.
* ... By stripping X last it will be done first.
* 10/98 *jc* - need to ignore trans_reduce (see info in ctx/add_rdc_xform.F)
	DO 200 idim = nferdims, 1, -1
       IF ( cx_trans( idim, cx ) .NE. trans_no_transform
     .          .AND. cx_trans( idim, cx ) .NE. trans_reduced ) THEN
	      CALL IS_STRIP( isact_class_trans, idim, *10, status )
	      GOTO 5000
	   ENDIF
 200	CONTINUE

* ... strip off need for regridding data ?
	IF ( cx_unstand_grid( cx ) ) THEN
	   CALL IS_STRIP( isact_class_regrid, no_dim, *10, status )
	   GOTO 5000
	ENDIF

* ... strip off getting aux variables?
*     note that regridding already stripped, so this is always for 3-arg plots
	IF ( cx_naux(cx) .GT. 0 ) THEN
	   CALL IS_STRIP( isact_class_aux_plot_vars, no_dim, *10, status )
	   GOTO 5000
	ENDIF

* ... strip off need to gather aggregate components together ?
* do this *after* all xforms and regridding, so those operations are performed
* on the aggregated result
 	IF ( cat .EQ. cat_agg_e_var ) THEN
	   CALL IS_STRIP( isact_class_aggregate_gather, e_dim, *10, status )
	   GOTO 5000
	ENDIF
 	IF ( cat .EQ. cat_agg_f_var ) THEN
	   CALL IS_STRIP( isact_class_aggregate_gather, f_dim, *10, status )
	   GOTO 5000
	ENDIF
 	IF ( cat .EQ. cat_agg_u_var ) THEN
	   CALL IS_STRIP( isact_class_union_member, no_dim, *10, status )
	   GOTO 5000
	ENDIF

* ... reduce algebraic expression to its components ?

	IF ( cat .EQ. cat_user_var	) THEN

* * * * * * * * * * * * How to test whether uvar is an F-TDS remote var 
*  ??
	   is_remote_var = ( uvar_remote(var) )

	   IF (.NOT. is_remote_var) THEN
	      CALL IS_ALGEBRA(  *10, *2000, isp_base, status )
	   ELSE
	   
	      CALL INIT_FTDS_DSET ( cx_data_set(cx), var, status)
	      CALL IS_READ_REMOTE(  *10, *2000, status )
	   ENDIF

	   GOTO 5000

* ... read from disk ?
	ELSEIF ( cat .EQ. cat_file_var
     .	.OR.     cat .EQ. cat_file_rev	) THEN

	   IF ( cat .EQ. cat_file_var ) THEN

* ... trim context limits to what is available in file (ds_grid_start/end)
	      CALL RESTRICT_FILE_LIMITS( cx, look_again, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000

* ... kludge to avoid re-reading when regions aren't fully specified 2/90
	      DO 300 idim = 1, nferdims
	         IF ( cx_lo_ss( cx, idim ) .EQ. unspecified_int4 ) THEN
		    IF ( CGRID_AXIS(idim,cx) .EQ. mnormal ) GOTO 300
	            CALL FLESH_OUT_AXIS( idim, cx, status )
	            IF ( status .NE. ferr_ok ) GOTO 5000
	      	    look_again = .TRUE.
	         ENDIF
 300	      CONTINUE
	      IF ( look_again ) THEN
* ...         check again in memory - maybe we already have it after all
	         CALL FIND_MEM_VAR_INCL_C_CACHE( cx, mr, search_by_value)
	         IF ( mr .GT. mr_nonexist ) THEN
* ...            yes - already in memory ... worth the trouble
	            is_mr( isp ) = mr
	            GOTO 2000					! pop stack
	         ENDIF
	      ENDIF
	   
* ... check to see if any axes need reversal
	      IF ( TM_AXES_REVERSED(var,rev_axes) .GT. 0 ) THEN
	         CALL IS_STRIP( isact_class_reverse, 1, *10, status )
	         GOTO 5000
	      ENDIF
	   ENDIF

	   CALL IS_READ(  *10, *2000, status )
	   GOTO 5000

* ... get a "constant variable" (say, "{1,3,5}")
	ELSEIF ( cat .EQ. cat_const_var	) THEN
	   CALL IS_CONST_VAR   (  *10, *2000, status )
	   GOTO 5000

* ... get a string in qouble quotes
	ELSEIF ( cat .EQ. cat_string	) THEN
	   CALL IS_STRING   (  *10, *2000, status )
	   GOTO 5000

* ... get an attribute value
	ELSEIF ( cat .EQ. cat_attrib_val ) THEN
	   CALL IS_ATTRIB_VAL   (  *10, *2000, status )
	   GOTO 5000

* ... get a counter variable
c	ELSEIF ( cat .EQ. cat_counter_var ) THEN
c	   CALL IS_COUNTER_VAR   ( var,  *10, *2000, status )
c	   GOTO 5000

	ELSE
	   STOP 'is_unkn_object'
	ENDIF

******************************************************************************
* * * * * * POP THE STACK - A REQUESTED GRID HAS JUST BEEN OBTAINED * * * * *
******************************************************************************
* a ready-to-use-component has been found/created/read/etc.
* it will now be flagged as a component of a higher level operation
* if it has just been created it is not on the delete chain so just set
* its protection with one claim of "in-use".
* (9/99) when evaluating the SAMPLEI function, the intermediate result
* returned here might be a temporary variable. If so, leave it alone
 2000	mr = is_mr( isp )
	IF ( mr_protected(mr) .EQ. mr_temporary ) THEN
	   CONTINUE	! 9/99 - container result for SAMPLE* function
	ELSEIF ( mr_protected(mr) .EQ. mr_in_progress ) THEN
	   mr_protected(mr) = mr_not_protected + 1
	ELSEIF ( mr_protected(mr) .NE. mr_perm_protected ) THEN
	   CALL MR_IN_USE( mr )
	ENDIF

* check for asychronous interrupt received
	IF (interrupted) CALL ERRMSG( ferr_interrupt,status,' ',*5000 )


* DONE ?
 2120	IF     ( isp .LT. isp_base ) THEN
* ... yes - but with a serious error
	   STOP 'isp_undfl'	! IS stack underflowed
	ELSEIF ( isp .EQ. isp_base ) THEN
* ... yes - clean up and go home
	   CALL RELEASE_DYN_WORK_SPACE
	   RETURN
	ELSE
*    ... since the stack activity at this level is now completed it contains a
*	 component that is needed by the next lower level.  Change its activity
*	 to reflect its belonging to the lower level (needed when an algebraic
*	 operation needs multiple components so at each component isp level
*	 the "action" is still algebra after the component is obtained)
	   act = is_act( isp - 1 )
	   is_act( isp ) = act
	   isp = isp - 1

* ... not done - go back for more

******************************************************************************
* * * * * PERFORM TRANSFORMATIONS, ARITHMETIC, RE-GRIDDING, ETC. * * * * * *
******************************************************************************
	   IF     ( act .EQ. isact_request		) THEN
	      GOTO 10					! grid just obtained
	   ELSEIF ( act .EQ. isact_reconcile		) THEN
	      CALL IS_RECONCILE(  *10, *2500, status ) ! 11/95
	   ELSEIF ( act .EQ. isact_algebra		) THEN
	      CALL IS_ALGEBRA(  *10, *2500, isp_base, status )
	   ELSEIF ( act .EQ. isact_modulo		) THEN
	      CALL IS_MODULO(  *10, *2500, status )     ! 12/94
	   ELSEIF ( act .EQ. isact_subspan_fill		) THEN
	      CALL IS_SUBSPAN_FILL(  *10, *2500, status )! 7/02
	   ELSEIF ( act .EQ. isact_reverse		) THEN
	      CALL IS_REVERSE(  *10, *2500, status )     ! 2/95
	   ELSEIF ( act .EQ. isact_gather		) THEN
	      CALL IS_GATHER(  *10, *2500, status )
	   ELSEIF ( act .EQ. isact_aggregate_gather	) THEN
	      CALL IS_AGGREGATE_GATHER(  *10, *2500, status )
	   ELSEIF ( act .EQ. isact_get_union_member	) THEN
	      CALL IS_UNION_MEMBER(  *10, *2500, status )
	   ELSEIF ( act .EQ. isact_sample		) THEN
	      CALL IS_SAMPLE(  *10, *2500, status )
	   ELSEIF ( act .EQ. isact_interp		) THEN
	      CALL IS_TRANS(  DO_INTERPOLATE, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_average		) THEN
	      CALL IS_TRANS(  DO_AVERAGE, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_avg_wgt		) THEN
	      CALL IS_TRANS(  DO_AVG_WGT, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_4d_ave		) THEN	! 7/96
	      CALL IS_TRANS(  DO_4D_AVE, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_avg_4d_wgt		) THEN	
	      CALL IS_TRANS(  DO_4D_AVE_WGT, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_integ_def		) THEN	! 7/96
	      CALL IS_TRANS(  DO_INTEG_DEF, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_4d_int_def		) THEN
	      CALL IS_TRANS(  DO_4D_INT_DEF, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_shift		) THEN
	      CALL IS_TRANS(  DO_SHIFT, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_smth_box		) THEN
	      CALL IS_TRANS(  DO_SMTH_BOX, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_smth_box_p		) THEN
	      CALL IS_TRANS(  DO_SMTH_BOX_P, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_smth_binml		) THEN
	      CALL IS_TRANS(  DO_SMTH_BINML, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_smth_hanng		) THEN
	      CALL IS_TRANS(  DO_SMTH_HANNG, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_smth_max		) THEN
	      CALL IS_TRANS(  DO_SMTH_MAX, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_smth_median		) THEN
	      CALL IS_TRANS(  DO_SMTH_MEDIAN, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_smth_min		) THEN
	      CALL IS_TRANS(  DO_SMTH_MIN, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_smth_parzn		) THEN
	      CALL IS_TRANS(  DO_SMTH_PARZN, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_smth_welch		) THEN
	      CALL IS_TRANS(  DO_SMTH_WELCH, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_fill_ave		) THEN
	      CALL IS_TRANS(  DO_FILL_AVE, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_fill_interp		) THEN
	      CALL IS_TRANS(  DO_FILL_INTERP, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_fill_near		) THEN
	      CALL IS_TRANS(  DO_FILL_NEAR, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_deriv_fwrd		) THEN
	      CALL IS_TRANS(  DO_DERIV_FRWD, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_deriv_cntr		) THEN
	      CALL IS_TRANS(  DO_DERIV_CNTR, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_deriv_bkwd		) THEN
	      CALL IS_TRANS(  DO_DERIV_BKWD, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_min			) THEN
	      CALL IS_TRANS(  DO_MIN, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_max			) THEN
	      CALL IS_TRANS(  DO_MAX, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_integ_indef		) THEN
	      CALL IS_TRANS(  DO_INT_INDEF, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_locate		) THEN
	      CALL IS_TRANS(  DO_LOCATE, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_sum  		) THEN
	      CALL IS_TRANS(  DO_SUM, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_run_sum		) THEN
	      CALL IS_TRANS(  DO_RUN_SUM, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_variance		) THEN
	      CALL IS_TRANS(  DO_VARIANCE, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_std_dev		) THEN
	      CALL IS_TRANS(  DO_STDDEV, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_good_pt		) THEN
	      CALL IS_TRANS(  DO_NGOOD, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_bad_pt		) THEN
	      CALL IS_TRANS(  DO_NBAD, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_wgted_eq		) THEN
	      CALL IS_TRANS(  DO_DIST_LOC, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_regrid		) THEN
	      CALL IS_REGRID( *2500, status )
	   ELSEIF ( act .EQ. isact_auxvar_regrid
     .         .OR. act .EQ. isact_aux_plot_vars	) THEN
	      CALL IS_AUXVAR_REGRID(  *10, *2500, status )
	   ELSEIF ( act .EQ. isact_autogrid		) THEN
	      CALL IS_AUTOGRID( *2500, status )
	   ELSEIF ( act .EQ. isact_4d_var		) THEN	! 7/96
	      CALL IS_TRANS(  DO_4D_VAR, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_4d_good_pt		) THEN	! 7/96
	      CALL IS_TRANS(  DO_4D_NGD, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_4d_bad_pt		) THEN	! 7/96
	      CALL IS_TRANS(  DO_4D_NBD, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_4d_sum		) THEN	! 11/10
	      CALL IS_TRANS(  DO_4D_SUM, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_std_4d		) THEN
	      CALL IS_TRANS(  DO_4D_STD, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_nrst_dist_abv	) THEN	! 9/97
	      CALL IS_TRANS(  DO_NEAREST_DIST_ABOVE, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_nrst_dist_blw	) THEN	! 9/97
	      CALL IS_TRANS(  DO_NEAREST_DIST_BELOW, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_nrst_indx_abv	) THEN	! 9/97
	      CALL IS_TRANS(  DO_NEAREST_INDEX_ABOVE, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_nrst_indx_blw	) THEN	! 9/97
	      CALL IS_TRANS(  DO_NEAREST_INDEX_BELOW, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_event_mask		) THEN	! 6/01
	      CALL IS_TRANS(  DO_EVENT, *10, *2500, status )
	   ELSEIF ( act .EQ. isact_read			) THEN
	      WRITE (6,*) 'Tell FERRET programmer to check INTERP_STACK'
* ...	      could set "cat" and branch to above IS_READ
	      CALL IS_READ(  *10, *2000, status )    ! temp ?? needed ?
	   ELSE
              CALL ERRMSG( ferr_internal, status,
     .             'unknown transform', *5000 )
	   ENDIF
	   GOTO 5000		! error performing operation
	ENDIF

* 11/95 detour
* A result has just been obtained from a component.
* If the component was non-reusable then so is the result
* NOTE: this is not a complete check for inheritance of non-reusable results!!
*	- multiple components may have been used (e.g. IS_DO_OP)
*	- multiple results may have been computed (e.g. FFT's)
* Those special cases must be tracked inside the computing routines 
 2500	mr     = is_mr( isp )	! result (output)
	com_mr = is_mr( isp+1)	! component (input)
* ...  even if com_mr is wrong it doesn't cause trouble
	IF ( ITS_UN_CACHED( com_mr ) ) CALL UN_CACHE( mr )
	GOTO 2000

* error exit - clean up
 5000	CALL RELEASE_DYN_WORK_SPACE
	CALL DELETE_MRS_IN_PROGRESS
	CALL UNPROTECT_ALL_MRS
	CALL DEALLO_ALL_GRIDS
        CALL CLEAN_STACK
	RETURN
	END

	SUBROUTINE PPL_PATSET( string )

* execute a PLOT+ PATSET command with the given string as argument

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V230: 11/92 - for color map protection during viewport manipulations
* V491: 12.98 - add PPL_PATSET() for pattern support *jd*

	include 'plot_setup.parm'
	include 'xrisc.cmn'		! to fix RISC FORTRAN bug

* calling argument declarations:
	CHARACTER*(*)	string

* internal variable declarations:

* initialize fixed length string for RISC (needed for DEC f77 v2.1)
	risc_buff = string
	len_rbuff = MIN( size_rbuff, LEN(string) )

* send the command to PLOT+  "PATSET [string]"
	CALL PPLCMD ( from, line, 0,
     .                'PATSET '//risc_buff(:len_rbuff), 1, 1 )

* always successful
        RETURN
	END

c     
c     ef_bail_out.F
c        
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
c     Jonathan Callahan
c     Feb 19th 1998
c
c *acm* 11/05 V600  -- New symbol FER_LAST_ERROR contains all the text normally
c                       written to std out, put error text in common to save it
c             
c     
c     

c     
c     This subroutine bails out of an external function with
c     the error message passed in.
c     

      SUBROUTINE EF_BAIL_OUT(id, text)

      IMPLICIT NONE
      INCLUDE 'tmap_dims.parm'
      INCLUDE 'ferret.parm'
      INCLUDE 'errmsg.parm'
      INCLUDE 'EF_Util.parm'
      INCLUDE 'xerrmsg_text.cmn'


      INTEGER id
      CHARACTER*(*) text

c     internal parameter declarations:
      INTEGER      slen
      PARAMETER  ( slen = ef_max_description )
      CHARACTER*(EF_MAX_NAME_LENGTH) GCF_NAME

#ifdef sun
      BYTE      fhol(slen)      ! c-type Hollerith string buffer
#else 
      INTEGER*1 fhol(slen)      ! c-type Hollerith string buffer
#endif
      
      INTEGER TM_LENSTR1, llen
      
c     true string length
c     convert to a null-terminated Hollerith
c     call the external functions library routine to see if it is external
      
      llen = TM_LENSTR1( text )
      CALL TM_FTOC_STRNG( text(:llen), fhol, slen )

! Put name and text, and their lengths into common for error outputs.
      efname = GCF_NAME (id)
      len_efname = TM_LENSTR1( efname )
      ef_errtext = text
      len_eftext = llen

      CALL EF_ERR_BAIL_OUT( id, fhol )

      RETURN 
      END

	SUBROUTINE INIT_UVAR ( name, text, title, units, dset, bad,
     .                         implct_defn, uvar,
     .			       at_type, at_id, at_start, at_end,
     .			       natom, txstart, txend, varname, 
     .			       its_remote, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Compile a user variable structure into one or more user variables.
* Expression should arrive with the atoms identified in at_type but
* still in inifx order. Since multiple expressions may exist within
* the same text string (text) this routine has txstart and txend 
* to indicate the offsets to the particular expression in question

* The incoming expression may contain "grid-changing functions", for example
*	yes? LET vfft = TFFT(v) + A + B
* in which "TFFT" replaces the T axis in the course of computing an FFT.
* In such a case a "child variable" is created equivalent to 
*	yes? LET (013,001) = TFFT(v)
*	yes? LET vfft = (013,001) + A + B

* Note that the addition of grid-changing variables and child variables
* was introduced as a series of "hacks" that have made the code needlessly complex.
* Could be cleaned up ... (*sh*)


* revision 0.0 - 2/19/87
* revision 0.1 - 9/22/87 - ferr_uvar_max --> *_prog_limit
* V200:  6/20/89 - re-worked user defined variable logic
*		 - syntax checking on variable names
*       11/27/89 - major re-write for RPN ordering
*        2/19/90 - corrected error messages
* Unix/RISC port - 7/10/91 - shorter "line too long" text string
*       10/22/92 - added units on uvars
* V402:  7/95 - Added "dset" argument for  LET/D=dset var = ... 
* V420:  12/95 - initialize uvar_mod_pseudo
* V450:  12/96 - much of the guts of the routine moved to INIT_UVAR_SUB
*		 Call RPN from within this routine instead of beforehand
*		 in order to simplify breaking out of grid-changing functions
*         5/97 - create separate child vars for expressions used as args to
*		 a grid-changing function
*         7/97 - bug fix for case of GCFCN(a,b)
* V491:   2/98 - fix to 5/97 changes: a constant is an expression, too
* V500:  2/99 *sh* - bug fix for GC child var parsing
*		GCFCN((a)) generated an error -- paren problem
* V510: 10/99 *sh* - bug fix: if, say, SST[Y=5s:5N:1] is an argument to a GC
*		function, this routine must create a child variable so that
*		the implicit grid is "owned" by someone.
*	11/99 *sh* - bug fix: if child var occurred in the second (or higher)
*			expression in a line the child var name was wrong
*	12/99 *sh* - reverted to this code following temporary commenting out
*		of 10/99 fix by Ansley to keep EFs running. Changes to
*		EF_GET_ARG_SUBSCRIPTS now permit 10/99 change to work
*	1/00 *sh* - bug fix: parent_uvar was always set to ultimate ancestor
*		 instead of actual parent. Created gcf stack
* V510: 5/00 *sh* - added "bad" (missing value flag) to arguments
* 1/03 *kob* g77 port - requires use of risc_buff for concats
* V62   2/09 *acm* Pass the original upper/lowercase spelling of user-defined variable
*                  names to init_uvar_sub; name to be saved in the attribute structure, for 
*                  use when writing out user-defined variables when MODE UPCASE_OUTPUT 
*                  is cancelled.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V694  *acm* 1214 Fixing ticket 2220: a variablename.attname argument to a function
*                  needs to be added as a child variable
* V699 *sh* 6/16 bail out code at 5900 needs to clean up child LIST structures
* V720: 4/17 *acm* Add direction-changing functions as a subset of grid-changing ones
*                  A new grid is defined for these at grid initialization time; it
*                  will be changed later.

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'	
	include 'errmsg.parm'	
	include 'rpn.parm'
	include 'xvariables.cmn'
	include 'xrisc_buff.cmn'

* calling argument declarations:
	LOGICAL		implct_defn, its_remote
	CHARACTER*(*)	name, text, title, units, varname
	INTEGER		uvar, natom, txstart, txend, status,
     .			at_type  (maxatoms), at_id  (maxatoms),
     .			at_start (maxatoms), at_end (maxatoms), dset
	REAL		bad

* internal parameter declarations
	LOGICAL		itsa_gc
	INTEGER		max_gcf_stack
	PARAMETER     ( max_gcf_stack = 15 )
* internal variable declarations:
	LOGICAL		has_children, child, child_remote
	INTEGER		tlen, iat, paren_level, atoms_lost, uvar_child, gcfstk, 
     .			child_start, child_end, gc_arg_start, istart, iend,
     .			parent,
     .			gcf_start(0:max_gcf_stack), gcf_uvar(0:max_gcf_stack)
	CHARACTER	child_name*16

* initialize
	tlen  =  txend - txstart + 1
	has_children = .FALSE.

* find an unused uvar slot for the variable and initialize grid chg fcn stack
	DO 100 uvar = 1, max_uvar
	   IF ( uvar_num_items( uvar ) .EQ. uvar_deleted ) THEN
	      gcfstk = 0	
	      gcf_start(0) = 0
	      gcf_uvar (0) = uvar ! assignment never used but what the heck ...
*	      uvar_num_items( uvar ) = uvar_on_hold
              CALL deleted_list_modify(uvar_num_items_head, uvar,
     .                uvar_on_hold)
	      GOTO 200
	   ENDIF
 100	CONTINUE
	GOTO 5100

* scan the atoms for grid-changing functions. These functions need to
* be compiled each as a separate variable definition.
* These variables will be invisible to the user of Ferret (except when
* using mode diagnostic). They have the special property that their result
* grid cannot necessarily be inferred from the component arguments.
 200	paren_level = 0
	DO 300 iat = gcf_start(gcfstk)+1, natom
	   IF ( at_type(iat).EQ.alg_grid_chg_fcn .OR.  at_type(iat).EQ.alg_dir_chg_fcn ) THEN
* ... find the variable number for this "child variable"
*     Note that for the simple non-nested case of LET v = GCF(arg, arg, ...)
*     no child variables are needed - so at the end of this routine we clean
*     up left-over "on_hold" uvars
	      DO 250 uvar_child = 1, max_uvar
	         IF ( uvar_child .EQ. uvar ) GOTO 250
	         IF ( uvar_num_items( uvar_child ) .EQ. uvar_deleted ) GOTO 260
 250	      CONTINUE
	      GOTO 5900
 260	      gcfstk = gcfstk + 1 ! new stack level for the child
*	      uvar_num_items( uvar_child ) = uvar_on_hold
              CALL deleted_list_modify(uvar_num_items_head, uvar_child,
     .                                 uvar_on_hold)
	      gcf_uvar (gcfstk) = uvar_child
	      gcf_start(gcfstk) = iat
	      paren_level = 0
	   ELSEIF ( gcfstk .GT. 0
     .	    .AND.   at_type(iat).EQ. alg_punctuation ) THEN
	      IF ( at_id(iat) .EQ. left_paren ) THEN
	         paren_level = paren_level + 1
	      ELSEIF ( at_id(iat) .EQ. right_paren ) THEN
	         paren_level = paren_level - 1
	         child_end = iat
* ... found the bounds of a grid changing function call ?
	         IF ( paren_level .EQ. 0 ) GOTO 700
	      ENDIF
	   ENDIF
 300	CONTINUE
	IF ( gcfstk .NE. 0 ) GOTO 5200	! syntax error

* no (more) child definitions. Go initialize the parent
	GOTO 1000

* Grid-changing functions need to know the grids of each of their arguments
* This requires that each argument be "simple" -- expressions like a+b are not
* allowed. In this section, we scan the arguments of the grid-changing
* function and if we find a complex argument or a simple argument that  may
* have an implicit grid, we create a separate child
* variable from it
* At this point we know there are no grid-changing functions used in the args.
* In this very simple parsing operation any arg with more than one "atom"
* will generate a separate child variable, including "gcfcn( (A) )"
 700	child_start = gcf_start(gcfstk)
	gc_arg_start = child_start + 2		! past first paren 
	paren_level = 1
	DO 750 iat = child_start+2, child_end
	   IF ( at_type(iat) .NE. alg_punctuation ) GOTO 750
	   IF     ( at_id(iat) .EQ. left_paren  ) THEN
	      paren_level = paren_level + 1
	   ELSEIF ( at_id(iat) .EQ. right_paren ) THEN
	      paren_level = paren_level - 1
	   ENDIF
* ... check for the end of an argument -- comma or final paren
	   IF (  (at_id(iat).EQ.comma .AND. paren_level.EQ.1)
     .	    .OR. paren_level .EQ. 0   ) THEN
* ...(2/98) treat lone constant like a "complex" argument (an expression)
* ...(10/99)also treat sst[y=5s:5n:1] as a "complex" argument (has impl grid)
	      istart = at_start (gc_arg_start)
	      iend   = at_end   (gc_arg_start)

	      IF ( at_type(gc_arg_start) .EQ. alg_attrib_val) THEN
* ... make a varname.attname argument into a separate child variable
	         child_start = gc_arg_start
	         child_end = iat - 1
	         GOTO 800
              ENDIF

	      IF ( (at_type(gc_arg_start) .EQ. alg_child_var)
     .	     .OR.  ( (iat .EQ. gc_arg_start+1)
     .         .AND. (at_type(gc_arg_start) .NE. alg_constant)
     .	       .AND. (INDEX(text(istart:iend),'[').EQ.0)    )   ) THEN
* ... this argument is "simple" (a single atom) 
	         gc_arg_start = iat + 1	! look for next
	      ELSE
* ... make this (complex) argument into a separate child variable
	         child_start = gc_arg_start
	         child_end = iat - 1
	         GOTO 800
	      ENDIF	
	   ENDIF
 750	CONTINUE

* There were no complex arguments in this grid-changing function
* If the entire definition is LET A = GCFCN(args) then no need for child fcns
	IF ( gcfstk .EQ. 1
     . .AND. .NOT.has_children
     . .AND. child_start .LE. 1
     . .AND. child_end   .EQ. natom ) GOTO 1000

* generate name of child variable -- points to *ancestor*, not parent
 800	CALL GCF_CHILD_VAR_NAME( uvar,
     .				 at_start(child_start)-(at_start(1)-1),
     .				 child_name )
	itsa_gc = at_type(child_start) .EQ. alg_grid_chg_fcn .OR. 
     .            at_type(child_start) .EQ. alg_dir_chg_fcn

	IF ( itsa_gc ) THEN
	   uvar_child = gcf_uvar(gcfstk)
	   parent = gcf_uvar(gcfstk-1)
	ELSE
	   DO 850 uvar_child = 1, max_uvar
	      IF ( uvar_child .EQ. uvar ) GOTO 850
	      IF ( uvar_num_items( uvar_child ) .EQ. uvar_deleted ) THEN
	         parent = gcf_uvar(gcfstk)
	         GOTO 860
	      ENDIF
 850	   CONTINUE
	   GOTO 5900
	ENDIF

* initialize the child variable  its_remote is set .FALSE. for child variables. (?)
 860	child = .TRUE.
        child_remote = .FALSE.
        CALL INIT_UVAR_SUB (
     .			     child_name,
     .			     text, ' ', ' ', dset, bad,
     .                       child_remote, implct_defn, uvar_child,parent,
     .			     at_type(child_start), at_id(child_start),
     .			     at_start(child_start), at_end(child_start),
     .			     child_end-child_start+1,
     .			     at_start(child_start), at_end(child_end),
     .			     child, child_name, status )
	IF ( status .NE. ferr_OK ) GOTO 5900

* ... if the child we just created was a GC then pop the gc stack
	IF ( itsa_gc ) gcfstk = gcfstk - 1

* consolidate the parent atom definitions so that the child appears as a
* single atom (a variable) in the definition
	atoms_lost = child_end - child_start
	at_end(child_start) = at_end(child_end)
	at_type(child_start) = alg_child_var	! alg_variable w/ diff. naming 
	at_id(child_start)   = unspecified_int4
	DO 900 iat = child_end+1, natom
	   child_start = child_start + 1
	   at_start(child_start) = at_start(iat)
	   at_end(child_start)   = at_end(iat)
	   at_type(child_start)  = at_type(iat)
	   at_id(child_start)    = at_id(iat)
 900	CONTINUE
	natom = natom - atoms_lost
	has_children = .TRUE.
	GOTO 200		! back for more children

*============================================================

* initialize the parent user variable, "uvar"
 1000	child = .FALSE.
        CALL INIT_UVAR_SUB ( name, text, title, units, dset, bad,
     .                         its_remote, implct_defn, uvar, 0,
     .			       at_type, at_id, at_start, at_end,
     .			       natom, txstart, txend, child, varname,
     .			       status )

	IF ( status .NE. ferr_OK ) GOTO 5900

* clean up left-over on-hold variables
	DO 1100 uvar_child = 1, max_uvar
*	   IF (uvar_num_items(uvar_child) .EQ. uvar_on_hold)
*     .			uvar_num_items(uvar_child) = uvar_deleted
	   IF (uvar_num_items(uvar_child) .EQ. uvar_on_hold)
     .	      CALL deleted_list_modify(uvar_num_items_head, uvar_child,
     .                                  uvar_deleted )
 1100	CONTINUE

* successful completion
	status = ferr_ok
	RETURN

* error exit
* ... remove any holds left on variable slots
 5000	DO 5010 uvar = 1, max_uvar
* 5010	IF  ( uvar_num_items(uvar) .EQ. uvar_on_hold )
*     .	      uvar_num_items(uvar) = uvar_deleted
 5010	IF  ( uvar_num_items(uvar) .EQ. uvar_on_hold )
     .	  CALL deleted_list_modify(uvar_num_items_head, uvar,
     .                            uvar_deleted )
	RETURN

 5100	CALL ERRMSG( ferr_prog_limit, status,
     .		'too many user-defined variables'//pCR//
     .		'cancel or redefine some variables', *5000 )
 5200	risc_buff = text(txstart:txend)
	CALL ERRMSG( ferr_syntax, status,
     .		'unclosed parentheses: '//risc_buff, *5000 )

* remove all child variables of the variable being initialized
 5900	CALL GCF_CHILD_VAR_NAME( uvar, 0, child_name )
	DO 5910 uvar_child = uvar, max_uvar
	   IF ( uvar_name_code(uvar_child)(7:10)
     .     .EQ. child_name(7:10) ) THEN
	      CALL DELETE_USER_VAR(uvar_child, dset)
!*	      uvar_num_items( uvar_child ) = uvar_deleted
!              CALL deleted_list_modify(uvar_num_items_head, 
!     .                         uvar_child, uvar_deleted )
!
!*	      uvar_name_code( uvar_child ) = " "
!              CALL string_array_modify(uvar_name_code_head, uvar_child,
!     .                                  " ", 1)!
!
!	      uvar_text     ( uvar_child ) = " "
	   ENDIF
 5910	CONTINUE
	GOTO 5000

	END

	SUBROUTINE ATTRIB_VALS( array, nmax, n, 
     .			    dset, varid, varname, attname, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*

* get float attribute values

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP

* V600 8/18/05
* V670  2/11 *acm*   Fixes for inheriting attributes.

* calling argument declarations
	INTEGER		nmax, n, dset, varid, status
	REAL		array(*)
	CHARACTER*(*)	varname, attname

* internal variable declarations
        LOGICAL         NC_GET_ATTRIB, got_em, do_warn
	INTEGER 	TM_LENSTR1, attlen, vlen, alen, aflag
        CHARACTER*10    buff

	include 'ferret.parm'
        include 'errmsg.parm'

* initialize
	n = 0
        do_warn = .FALSE.

* Get float values 
	got_em = NC_GET_ATTRIB ( dset, varid, attname,
     .                           do_warn, varname, nmax,
     .                           attlen, aflag, buff, array )
        IF (.NOT. got_em) GOTO 5000
	n = attlen


* success
 	status = ferr_ok
	RETURN

* syntax error
 4999   RETURN
 5000	vlen = TM_LENSTR1(varname)
        alen = TM_LENSTR1(attname)
        buff = varname(:vlen)//"."//attname(:alen)
        vlen = vlen + alen + 1
        CALL ERRMSG( ferr_unknown_attribute, status, 
     .  'attribute not found:  '//buff(:vlen), *4999 )

	END

	SUBROUTINE EQUAL_TYPE( string, max_fields, nfields,
     .			       field_type, wk_start, wk_end, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* from a string of the form "TYPE=type1, type2, ..." determine the
* number of fields and their data types

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V530: 10/00 - for delimited reads
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

* calling argument declarations
	INTEGER		status
	INTEGER		max_fields, nfields
	INTEGER		field_type(max_fields),
     .			wk_start(max_fields), wk_end(max_fields)
	CHARACTER*(*)	string

* internal parameter declarations
	INTEGER	maxtypes
	PARAMETER (maxtypes = 8)

* internal variable declarations
	LOGICAL	MATCH4
	INTEGER	TM_LENSTR1, TM_LENSTR, iif, iit, equal_pos, slen,
     .          len_test, len_mchars
	CHARACTER*9 ftypes(maxtypes)

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'
	include 'xrisc.cmn'

* order of entries must match delimitedRead.h
	DATA ftypes(1)/'-'/,
     .	     ftypes(2)/'NUMERIC'/,
     .       ftypes(3)/'CHARACTER'/,
     .       ftypes(4)/'LATITUDE'/,
     .       ftypes(5)/'LONGITUDE'/,
     .       ftypes(6)/'DATE'/,
     .       ftypes(7)/'EURODATE'/,
     .       ftypes(8)/'TIME'/


* initialize
	slen      = TM_LENSTR1( string )
	equal_pos = INDEX( string, '=' )

	IF ( equal_pos .EQ. 0 ) THEN
	   nfields = 1
	   field_type(1) = 2  ! numeric as default for content-free /TYPE

	ELSEIF ( equal_pos .EQ. slen ) THEN
	  GOTO 5000                            ! "name ="

	ELSE

* parse the comma separated list into fields
	  CALL PARSE_COMMA_LIST ( string,
     .                            equal_pos+1,
     .                            slen,
     .                            max_fields,
     .                            nfields,
     .                            wk_start,
     .                            wk_end,
     .                            status          )
	  IF ( status .NE. ferr_ok ) GOTO 5000

* identify each field
	  DO 200 iif = 1, nfields
            len_test = TM_LENSTR(string(wk_start(iif):wk_end(iif)))
	    DO 100 iit = 1, maxtypes
              len_mchars = TM_LENSTR(ftypes(iit)(:4))
	      IF (MATCH4(string(wk_start(iif):wk_end(iif)),len_test,
     .			 ftypes(iit),len_mchars)) THEN
	        field_type(iif) = iit 
	        GOTO 200
	      ENDIF
 100	    CONTINUE
	    GOTO 5100
 200	  CONTINUE
	ENDIF

* success
	status = ferr_ok
	RETURN

* syntax error
 5000	RETURN

 5100	CALL ERRMSG(ferr_invalid_command, status, 'unknown data type',
     .		    string(wk_start(iif):wk_end(iif)), *5110)
 5110	risc_buff = ftypes(2)
	iif = 7
	DO 5120 iit = 3, maxtypes
	  risc_buff(iif:) = ','//ftypes(iit)
	  iif = iif + 1 + TM_LENSTR1(ftypes(iit))
 5120	CONTINUE
	CALL WARN('Valid types are: '//risc_buff(:iif))
	GOTO 5000

	END

	CHARACTER*(*) FUNCTION GET_STRING_ELEMENT(
     .			lox,hix,loy,hiy,loz,hiz,
     .			lot,hit,loe,hie,lof,hif,
     .			ptr_array, i, j, k, l, m, n,
     .			maxlen, slen)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Return the string stored at the indicated i,j,k,l,m,n, subscript
* The horse-pucky about the lo:hi subscripts is required because the pointer
* array needs to be dimensioned as 8-byte quantities

* V530: 8/00 *sh*
* V540: 1/02 *kob* - fix bug in which character array risc_buff was being
*                    passed to tm_ctof_string, which expects an integer array
*                    rather than a character array.  replace risc_buff and 
*                    size_rbuff with int_buff and size_ibuff which is 
*                    pulled from EF_Util.parm.
* V553: 9/03 *kob* - increase locbuff to 512 from 100 - it was cutting strings
*                    short*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
*       3/12 *kms*   int_buff and size_ibuff declared locally
* V691+:8/14 *acm* - increase locbuff to 2048 - it was cutting strings

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include 'ferret.parm'
	include 'EF_Util.parm'

* calling argument declarations
	INTEGER  lox,hix,loy,hiy,loz,hiz,lot,hit,loe,hie,lof,hif,
     .		 i, j, k, l, m, n, maxlen, slen
	REAL*8	 ptr_array(lox:hix,loy:hiy,loz:hiz,lot:hit,loe:hie,lof:hif)

* internal variable declarations
	INTEGER  GET_C_STRING_LEN, flen
	CHARACTER*2048 locbuff
        INTEGER size_ibuff
        PARAMETER ( size_ibuff = 2048 )
        INTEGER*2 int_buff(size_ibuff/2)

* get the string
        slen = GET_C_STRING_LEN(ptr_array(i,j,k,l,m,n))

* get the a null-terminated C string
        CALL GET_C_STRING(ptr_array(i,j,k,l,m,n), int_buff, slen+1)

* the longest length we can use ...
        flen = MIN(slen, size_ibuff)

* copy it into the FORTRAN string
        CALL TM_CTOF_STRNG (int_buff,locbuff, flen )

	
	GET_STRING_ELEMENT = locbuff(:flen)
	RETURN


	END
 

	SUBROUTINE FLOAT2STRING_FOR_XML (val, attype, strng, slen)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Write a floating-point value accurately to a string for XML output
*  Input is double precision floating-point number and the attribute
*  type that it had in the original dataset.
*  Return the string and string length

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* 27-Jun-2013

        include 'netcdf.inc'

* Argument declarations	
	REAL val
	CHARACTER*(*) strng
	INTEGER attype, slen

* Internal declarations
	LOGICAL TM_FPEQ
	CHARACTER TM_FMT*16
	INTEGER TM_LENSTR, STR_SAME, ival
	REAL test_val
  
  888	FORMAT(i16.0)

* Convert using TM_FMT

	strng = TM_FMT(val, 7,16,slen)

* If it's NaN, we are done.  See show_data_set_vars_xml. If the
* attribute is the _FillValue or missing_value, it has already 
* been converted to Ferret's default missing value, to match what
* Ferret will write into data varaibles.

	IF (STR_SAME(strng, 'NaN') .EQ. 0) THEN
	   CALL WARN('ATTRIBUTE is NaN')
	   slen = 3
	   GOTO 5000
	ENDIF

	IF (attype .EQ. nf_float .OR. attype .EQ. nf_double) THEN
	   slen = TM_LENSTR(strng)
	ELSE

* Check. Does the string correctly capture the value?

	   READ (strng, *) test_val
	   IF ( .NOT. TM_FPEQ (test_val, val) ) THEN

* Try with more digits
	      strng = TM_FMT(val, 9,16,slen)
	      READ (strng, *) test_val

* Still does not match. Write unformatted value. If it is
* known to be an integer, use a long integer format.

	      IF ( .NOT. TM_FPEQ (test_val, val) ) THEN
	         WRITE (strng, *) val
	         ival = val
	         IF (attype .EQ. nf_int) WRITE (strng, 888) ival
	      ENDIF

	      slen = TM_LENSTR(strng)
	   ENDIF
	ENDIF

 5000	CONTINUE
	RETURN
	END

	subroutine double(z,nxs,nys,nx,ny) 
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)double.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
c     the array z(i,j) i=1,nx j=1,ny  is expanded to twice its size , 
c     that is, z(i,j) i=1,2*nx-1,2  j=1,2*ny-1,2.  the spaces are filled 
c     using cubic polynomial interpolation.  undefined points of z 
c     should be set to 1.e35 . 
c     oceanography emr   december 1969. 
c 
c 
	dimension z(nxs,nys) 
	dimension  zz(4) 
c 
	nxd = 2*nx-1 
	nyd = 2*ny-1 
	nxdm2 =nxd-2 
	nydm2 =nyd-2 
	big =.9e35 
	big2 = big*2. 
c     spread existing points 
c 
c*******************************************************************************
c 
	do 20 ii = 1,nx 
	i= 1+nx-ii 
	id= i*2-1 
	do 20 jj = 1,ny 
	j= 1+ny-jj 
	jd = j*2-1 
20	z(id,jd)=z(i,j) 
c 
c     fill in half-way points of x-lines. 
c*******************************************************************************
c 
	do 90 i=1,nxdm2,2 
	do 90 j=1,nyd,2 
	z(i+1,j) = 1.e35 
	if(z(i,j)+z(i+2,j)-big)30,90,90 
30	zz(2)=z(i,j) 
	zz(3)=z(i+2,j) 
	zz(1)=1.e35 
	if(i-1)50,50,40 
40	zz(1)= z(i-2,j) 
50	zz(4)=1.e35 
	if(i-nxdm2)60,70,70 
60	zz(4)=z(i+4,j) 
70	call gethlf(zz,zzhalf)
80	z(i+1,j) = zzhalf 
90	continue 
c 
c     fill in half-way points of y-lines 
c*******************************************************************************
c 
	do 190 j = 1,nydm2,2 
	do 190 i = 1,nxd,2 
	z(i,j+1)=1.e35 
	if(z(i,j)+z(i,j+2)-big)130,190,190 
130	zz(2)= z(i,j) 
	zz(3)= z(i,j+2) 
	zz(1)=1.e35 
	if(j-1)150,150,140 
140	zz(1)= z(i,j-2) 
150	zz(4)= 1.e35 
	if(j-nydm2)160,170,170 
160	zz(4) = z(i,j+4) 
170	call gethlf(zz,zzhalf)
180	z(i,j+1)= zzhalf 
190	continue 
c 
c     fill in center-point of each square 
c*******************************************************************************
c 
	do 300 i = 1,nxdm2,2 
	do 300 j = 1,nydm2,2 
	z(i+1,j+1) = 1.e35 
	zsum = z(i,j)+z(i+2,j)+z(i  ,j+2)+z(i+2,j+2) 
	if(zsum-big)245,210,210 
210	if(zsum-big2)220,300,300 
220	if(z(i,j)+z(i+2,j+2)-big) 230,240,240 
230	z(i+1,j+1)  = (z(i,j)+z(i+2,j+2))*.5 
	go to 300 
240	z(i+1,j+1)  = (z(i+2,j)+z(i,j+2))*.5 
	go to 300 
245	zz(2)=  z(i,j+1) 
	zz(3)=  z(i+2,j+1) 
	zz(1)=1.e35 
	if(i-1) 260,260,250 
250	zz(1)= z(i-2,j+1) 
260	zz(4)=1.e35 
	if(i-nxdm2)270,280,280 
270	zz(4) =  z(i+4,j+1) 
280	call gethlf(zz,zzhalf)
290	z(i+1,j+1) = zzhalf 
300	continue 
	return 
	end
	subroutine gethlf(zz,zzhalf)
	dimension zz(4)
	big =.9e35 
c 
c     interpolation to get zz(2.5) . 
c*******************************************************************************
c 
400	if(zz(1)+zz(4)-big)420,430,430 
420	zzhalf = .5625*(zz(2)+zz(3)) -.0625*(zz(1)+zz(4)) 
	go to 480 
430	if(zz(1)-big)440,450,450 
440	zzhalf = .375*zz(3) +.75*zz(2) -.125*zz(1) 
	go to 480 
450	if(zz(4)-big) 460,470,470 
460	zzhalf=  .375*zz(2)+.75*zz(3)-.125*zz(4) 
	go to 480 
470	zzhalf = .5*(zz(2)+zz(3)) 
480	return
	end 

	SUBROUTINE TM_CHECK_LINE_BOUNDS ( line, line_bnds, npts, iaxis, 
     .      reversed, vname, vlen, is_double, regular, ok)


        include 'tmap_dims.parm'
        include 'xtm_grid.cmn_text'
        external xgt_grid_data
c#include "gt_lib.parm"

* argument declarations

	LOGICAL TM_CHECK_BNDS, TM_CHECK_BNDS_CENTERED, 
     .		reversed, is_double, its_irregular, regular, ok
	REAL line(*), line_bnds(*)
	INTEGER npts, vlen, iaxis, bad_bndsid
	CHARACTER*(*) vname

* Local declarations	
	INTEGER i, irev
	REAL tmp8

* if the coordinates were reversed then the box bounds must be, too 
        IF ( reversed  .AND.  npts .GT. 1) THEN
	   irev = 2*npts
           DO 550 i = 1, npts
               tmp8 = line_bnds(i)
	       line_bnds(i) = line_bnds(irev)
	       line_bnds(irev) = tmp8
	       irev = irev - 1
 550       CONTINUE
        ENDIF

* check to see that each data point is contained inside its box,
* and if the bounds are contiguous, warning user if not. 7/27/2017

        IF (.NOT. TM_CHECK_BNDS(line, line_bnds, npts, iaxis, is_double, vname) ) THEN  

           ok = .FALSE.
      
        ELSE  ! Only check for centered bounds if the bounds are valid

* For axes specified with BOUNDS, check whether coordinates are also 
* centered in the boxes, and whether the size of the boxes are equal.
* If there is one point, use upper and lower bound as given in the file 
* to determine line_delta.

           IF (TM_CHECK_BNDS_CENTERED(line, line_bnds, npts, iaxis, is_double)) THEN
* It's actually regular - save it as such
              IF (.NOT. line_regular(iaxis)) THEN
                 line_regular(iaxis) = .TRUE.
                 line_start  (iaxis) = line(1)
                 IF (npts .GT. 1) THEN
                    line_delta  (iaxis) = 
     .                (line(npts) - line(1))/DBLE(npts-1)
                 ELSE
                    line_delta(iaxis) = line_bnds(2)-line_bnds(1)
                 ENDIF
              ENDIF
           ELSE
              line_regular(iaxis) = .FALSE.
           ENDIF
	   ok = .TRUE.
	
        ENDIF  ! valid bounds, also checked centered

* If valid, will convert these bounds to edges back in the calling routine

	RETURN
	END

*
*  tracks2grid_std_xyt.F
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* October 2010 from tracks2grid_ave_xyt.F
*
* 9/ 3/2015 Fix LAS/SOCAT ticket 1720, missingness patterns in cruise-weighted 
*           vs unweighted gridded fields.
* 1/14/2016 Fix LAS/SOCAT ticket 1721, missing/zero where there should be data in cell
* 1/27/2016 Apply modulo operation to scattered longitudes or time if the output
*           axis is a modulo axis.
*
* This is the description of the averaging function.
* The input data points are not a simple scatter.  They are cruise tracks 
* strung one after another.  (Each track will be a contiguous block of points 
* in the input data arrays.)  And the subtlety is that each cruise needs to 
* receive the same weight when determining the average for a cell, rather than 
* each individual data point.  Which means effectively that you need to have 
* two averaging processes.  You need to have a buffer (the individual cruise 
* buffer) that is the size and shape of the output grid in which you average 
* each individual cruise.  And then when the final point of each cruise from 
* the input data is encountered, you need to add (average) the points from the 
* individual cruise buffer into the output buffer, re-zeroing the individual 
* cruise buffer as you do so, so it is ready to average the next cruise. 
*
* This function will return the std for the averages, based on weighted means,
* for small samples, http://wapedia.mobi/en/Weighted_mean#6. and
* http://wapedia.mobi/en/Weighted_mean#7.
* 
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE  tracks2grid_std_xyt_init(id)

      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CHARACTER*126 buff
      WRITE (buff, 10)
   10 FORMAT ('Weighted std by cruise, when gridding scattered ',
     .        'data to XYT grid')
      CALL ef_set_desc(id, buff)

      CALL ef_set_num_args(id, 8)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS,
     .        IMPLIED_BY_ARGS, NORMAL, IMPLIED_BY_ARGS)

      CALL ef_set_num_work_arrays(id, 8)

* Output grid is determined by arguments 4, 5, 6, the result's x, y, t axes. 

      arg = 1
      CALL ef_set_arg_name(id, arg, 'VARIABLE')
      CALL ef_set_arg_desc(id, arg, 'Variable at scattered input XYT.')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'XPTS')
      CALL ef_set_arg_desc(id, arg, 
     .     'X coordinates of scattered input triples')

      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'YPTS')
      CALL ef_set_arg_desc(id, arg, 
     .     'Y coordinates of scattered input triples')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'TPTS')
      CALL ef_set_arg_desc(id, arg, 
     .     'T coordinates of scattered input triples')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'ICRUISE')
      CALL ef_set_arg_desc(id, arg, 
     .     'Cruise ID at scattered input locations')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 6
      CALL ef_set_arg_name(id, arg, 'XAXPTS')
      CALL ef_set_arg_desc(id, arg, 
     .                   'X axis coordinates of a regular output grid')
      CALL ef_set_axis_influence(id, arg, YES, NO, NO, NO)

      arg = 7
      CALL ef_set_arg_name(id, arg, 'YAXPTS')
      CALL ef_set_arg_desc(id, arg, 
     .                   'Y axis coordinates of a regular output grid')
      CALL ef_set_axis_influence(id, arg, NO, YES, NO, NO)

      arg = 8
      CALL ef_set_arg_name(id, arg, 'TAXPTS')
      WRITE (buff, 20)
   20 FORMAT ('T axis coordinates, of a regular output grid, with same ',
     .       'units and origin as tpts')
      CALL ef_set_arg_desc(id, arg, buff)
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, YES)



*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN 
      END

*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE tracks2grid_std_xyt_work_size(id)

      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
* 
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_dims(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER nxout, nyout, ntout, nx2, ny2, nt2
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nxout = 1 + arg_hi_ss(X_AXIS,ARG6) - arg_lo_ss(X_AXIS,ARG6)
      nyout = 1 + arg_hi_ss(Y_AXIS,ARG7) - arg_lo_ss(Y_AXIS,ARG7)
      ntout = 1 + arg_hi_ss(T_AXIS,ARG8) - arg_lo_ss(T_AXIS,ARG8)

* xax  output x axis cell edges
      CALL ef_set_work_array_dims (id, 1, 1, 1, 1, 1, nxout, 2, 1, 1)

* yax  output y axis cell edges
      CALL ef_set_work_array_dims (id, 2, 1, 1, 1, 1, nyout, 2, 1, 1)

* Tax  output t axis cell edges
      CALL ef_set_work_array_dims (id, 3, 1, 1, 1, 1, ntout, 2, 1, 1)

* obs_cruise  work array - sum and counts of observations per cruise
* x,y,t direction: output grid
* z direction: 1..3
      CALL ef_set_work_array_dims (id, 4, 1, 1, 1, 1, 
     .                             nxout, nyout, 3, ntout)

* cell_avg  work array - work array - sum and counts over cruises for cell average
* x,y,t direction: output grid
* z direction: 1..2
      CALL ef_set_work_array_dims (id, 5, 1, 1, 1, 1, 
     .                             nxout, nyout, 2, ntout)

* wi_sums k=1, sum of cruiseweight wi = sum of obs in the cells
* x,y,t direction: output grid
* z direction: 1
      CALL ef_set_work_array_dims (id, 6, 1, 1, 1, 1, 
     .                             nxout, nyout, 1, ntout)

* cruisemean saving individual weighted cruise means. 
* for computing s^2  sum of wi*(xi - weighted_mean)**2
* x,y,t direction: output grid
* z direction: 30 (max cruises per cell?)
      CALL ef_set_work_array_dims (id, 7, 1, 1, 1, 1, 
     .                             nxout, nyout, 30, ntout)

* cruiseweight saving individual cruiseweight. 
* for computing s^2  sum of wi*(xi - weighted_mean)**2
* x,y,t direction: output grid
* z direction: 30 (max cruises per cell?)
      CALL ef_set_work_array_dims (id, 8, 1, 1, 1, 1, 
     .                             nxout, nyout, 30, ntout)

      RETURN
      END

*
* In this subroutine we compute the result
*

      SUBROUTINE tracks2grid_std_xyt_compute(id, arg_1, arg_2, arg_3, 
     .     arg_4, arg_5, arg_6, arg_7, arg_8, result, xax, yax, tax, 
     .     obs_cruise, cell_avg, wi_sums, cruisemean, cruiseweight)

*  arg_1  var
*  arg_2  xpts  \
*  arg_3  ypts   | Scattered x,y triples to be gridded.
*  arg_4  tpts  / 
*  arg_5  icruise
*
*  arg_6  xaxis of new grid   
*  arg_7  yaxis of new grid
*  arg_8  taxis of new grid

      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .     mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, 
     .     mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, 
     .     mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, 
     .     mem4loz:mem4hiz, mem4lot:mem4hit)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, 
     .     mem5loz:mem5hiz, mem5lot:mem5hit)
      REAL arg_6(mem6lox:mem6hix, mem6loy:mem6hiy, 
     .     mem6loz:mem6hiz, mem6lot:mem6hit)
      REAL arg_7(mem7lox:mem7hix, mem7loy:mem7hiy, 
     .     mem7loz:mem7hiz, mem7lot:mem7hit)
      REAL arg_8(mem8lox:mem8hix, mem8loy:mem8hiy, 
     .     mem8loz:mem8hiz, mem8lot:mem8hit)
      REAL arg_9(mem9lox:mem9hix, mem9loy:mem9hiy, 
     .     mem9loz:mem9hiz, mem9lot:mem9hit)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      INTEGER i, j, k, l, m, n
      INTEGER i6,j7,L8,i6n,j7n,L8n

      INTEGER nxpts, npts
      INTEGER nx, ny, nt
      INTEGER i1, i2, i1n, i2n
      INTEGER obs_only, icruise, ncc, nc_cell, nk

      REAL x1, y1, t1, xf, yf, tf
      REAL xx, yy, tt, vv

*  variables for checking axis characteristics (modulo axes)
      CHARACTER ax_name(6)*16, ax_units(6)*16
      LOGICAL backward(6), mdulo(6), regular(6)
      LOGICAL modulox, modulot
      REAL*8 modxlen, modtlen

      REAL dx, dy, xxbeg, xxend, yybeg, yyend
      REAL cellmean, wt_cruise_mean, unwtd_mean,
     .     wsumsq_ijl, wsumsq, diffsum, wtcruise,
     .     denom, v1, v2, wtsq

      REAL*8 xax1,xaxf, yax1,yaxf, tax1,taxf
      INTEGER indx(4,2), icstart, icend, nscat

*  Dimension the work arrays

      REAL*8 xax(wrk1lox:wrk1hix, wrk1loy:wrk1hiy,
     .               wrk1loz:wrk1hiz, wrk1lot:wrk1hit)
      REAL*8 yax(wrk2lox:wrk2hix, wrk2loy:wrk2hiy,
     .               wrk2loz:wrk2hiz, wrk2lot:wrk2hit)
      REAL*8 tax(wrk3lox:wrk3hix, wrk3loy:wrk3hiy,
     .               wrk3loz:wrk3hiz, wrk3lot:wrk3hit)
      REAL obs_cruise(wrk4lox:wrk4hix, wrk4loy:wrk4hiy,
     .               wrk4loz:wrk4hiz, wrk4lot:wrk4hit)
      REAL cell_avg(wrk5lox:wrk5hix, wrk5loy:wrk5hiy,
     .               wrk5loz:wrk5hiz, wrk5lot:wrk5hit)
      REAL wi_sums(wrk6lox:wrk6hix, wrk6loy:wrk6hiy,
     .               wrk6loz:wrk6hiz, wrk6lot:wrk6hit)
      REAL cruisemean(wrk7lox:wrk7hix, wrk7loy:wrk7hiy,
     .               wrk7loz:wrk7hiz, wrk7lot:wrk7hit)
      REAL cruiseweight(wrk8lox:wrk8hix, wrk8loy:wrk8hiy,
     .               wrk8loz:wrk8hiz, wrk8lot:wrk8hit)

      CHARACTER*250 errtxt

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*  Check to see if the output X-axis is modulo (does not need to be regular)
      CALL ef_get_axis_info_6d(id, ARG6, ax_name, ax_units,
     .                         backward, mdulo, regular)
      modulox = mdulo(X_AXIS)
      IF ( modulox ) THEN
         CALL ef_get_axis_modulo_len(id, ARG6, X_AXIS, modxlen)
      ENDIF

*  Check to see if the output T-axis is modulo (does not need to be regular)
      CALL ef_get_axis_info_6d(id, ARG6, ax_name, ax_units,
     .                         backward, mdulo, regular)
      modulot = mdulo(T_AXIS)
      IF ( modulot ) THEN
         CALL ef_get_axis_modulo_len(id, ARG8, T_AXIS, modtlen)
      ENDIF

      obs_only = 0	! Compute the std for average of variable (e.g. fco2)

*  Find number of points in scattered input points.  1-D arrays defining the 
*  scattered data points may lie on the X, Y, Z, or T axis of the input arguments.

      nxpts = 0

      DO 100 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG2) .GE. 1) THEN
            i1 = arg_lo_ss(m,ARG2)
            i1n = arg_hi_ss(m,ARG2)
            if (i1n-i1 .NE. 0) nxpts = 1 + (i1n - i1)
            IF (nxpts .EQ. 0) GOTO 900
         ENDIF
 100  CONTINUE

      npts = 1
      DO 110 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG1) .GE. 1) THEN
            i2 = arg_lo_ss(m,ARG1)
            i2n = arg_hi_ss(m,ARG1)
            npts = 1 + (i2n - i2)
            IF (npts.NE.nxpts) GOTO 900
         ENDIF
 110  CONTINUE

      DO 120 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG3) .GE. 1) THEN
            i2 = arg_lo_ss(m,ARG3)
            i2n = arg_hi_ss(m,ARG3)
            npts = 1 + (i2n - i2)
            IF (npts .NE. nxpts) GOTO 900
         ENDIF
 120  CONTINUE

      DO 130 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG4) .GE. 1) THEN
            i2 = arg_lo_ss(m,ARG4)
            i2n = arg_hi_ss(m,ARG4)
            npts = 1 + (i2n - i2)
            IF (npts .NE. nxpts) GOTO 900
         ENDIF
 130  CONTINUE

      DO 140 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG5) .GE. 1) THEN
            i2 = arg_lo_ss(m,ARG5)
            i2n = arg_hi_ss(m,ARG5)
            npts = 1 + (i2n - i2)
            IF (npts .NE. nxpts) GOTO 900
         ENDIF
 140  CONTINUE

      nscat = nxpts

*  Compute number of points in output axes.

      i6 = ef_unspecified_int4
      j7 = ef_unspecified_int4
      L8 = ef_unspecified_int4

      i6 = arg_lo_ss(X_AXIS,ARG6)
      i6n = arg_hi_ss(X_AXIS,ARG6)

      j7 = arg_lo_ss(Y_AXIS,ARG7)
      j7n = arg_hi_ss(Y_AXIS,ARG7)

      L8 = arg_lo_ss(T_AXIS,ARG8)
      L8n = arg_hi_ss(T_AXIS,ARG8)

      nx = 1 + (i6n - i6)
      ny = 1 + (j7n - j7)
      nt = 1 + (L8n - L8)

*  Check that xax is a X axis and yax a Y axis

      IF (i6 .EQ. ef_unspecified_int4) THEN
         WRITE (errtxt, *) 'Sixth argument must be a X axis'
         GO TO 999
      ENDIF
      IF (j7 .EQ. ef_unspecified_int4) THEN
         WRITE (errtxt, *) 'Seventh argument must be a Y axis'
         GO TO 999
      ENDIF
      IF (L8 .EQ. ef_unspecified_int4) THEN
         WRITE (errtxt, *) 'Eighth argument must be a T axis'
         GO TO 999
      ENDIF

C  Get coordinates of output axes.

      CALL EF_GET_BOX_LIMITS(id, ARG6, X_AXIS,
     .   arg_lo_ss(X_AXIS, ARG6), arg_hi_ss(X_AXIS, ARG6), xax(1,1,1,1), xax(1,2,1,1))

      CALL EF_GET_BOX_LIMITS(id, ARG7, Y_AXIS,
     .   arg_lo_ss(Y_AXIS, ARG7), arg_hi_ss(Y_AXIS, ARG7), yax(1,1,1,1), yax(1,2,1,1))

      CALL EF_GET_BOX_LIMITS(id, ARG8, T_AXIS,
     .   arg_lo_ss(T_AXIS, ARG8), arg_hi_ss(T_AXIS, ARG8), tax(1,1,1,1), tax(1,2,1,1))

*  Get first coordinates of output axes.

      call ef_get_coordinates(id, ARG6, X_AXIS, 
     .   arg_lo_ss(X_AXIS, ARG6), arg_lo_ss(X_AXIS, ARG6), xax1)
      call ef_get_coordinates(id, ARG7, X_AXIS, 
     .   arg_lo_ss(Y_AXIS, ARG7), arg_lo_ss(Y_AXIS, ARG7), yax1)
      x1 = xax1
      y1 = yax1

*  Compute result

*  Initialize counts.

      DO L = 1, nt
      DO k = 1, 2
      DO j = 1, ny
      DO i = 1, nx
         cell_avg(i,j,k,L) = 0.
      ENDDO
      ENDDO
      ENDDO
      ENDDO

      DO L = 1, nt
      DO k = 1, 3
      DO j = 1, ny
      DO i = 1, nx
         obs_cruise(i,j,k,L) = 0.
      ENDDO
      ENDDO
      ENDDO
      ENDDO

      DO L = 1, nt
      DO k = 1, 1
      DO j = 1, ny
      DO i = 1, nx
         wi_sums(i,j,k,L) = 0.
      ENDDO
      ENDDO
      ENDDO
      ENDDO

      DO L = 1, nt
      DO k = 1, wrk7hiz
      DO j = 1, ny
      DO i = 1, nx
         cruisemean(i,j,k,L) = 0.
      ENDDO
      ENDDO
      ENDDO
      ENDDO

      DO L = 1, nt
      DO k = 1, wrk7hiz
      DO j = 1, ny
      DO i = 1, nx
         cruiseweight(i,j,k,L) = 0.
      ENDDO
      ENDDO
      ENDDO
      ENDDO

*  Loop over x and y, compute the number of observations for the gaussian-weighted 
*  mapping onto the grid.  Lat and longitude may be on the X,Y,Z or T axis of ARG1 
*  and ARG2, sending them to a subroutine collapses the extra dimensions so the
*  value can be found.

      n = 1
      CALL pickoutxytcv (obs_only, arg_1, arg_2, arg_3, arg_4, arg_5,
     .           n, vv, xx, yy, tt, ncc)

*  If output axis is modulo, apply modulo adjustment to that coordinate
*  of the scattered point.
      IF ( modulox ) THEN
         CALL modscat(xax(1,1,1,1), xax(nx,2,1,1), modxlen, 1, xx)
      ENDIF
      IF ( modulot ) THEN
         CALL modscat(tax(1,1,1,1), tax(nt,2,1,1), modtlen, 1, tt)
      ENDIF

      icruise = ncc

* For each cruise keep track of the index range it spans in the result grid
* Then at the end of the cruise need only to process that subset of the grid.
      indx(1,1) = nx
      indx(1,2) = 1
      indx(2,1) = ny
      indx(2,2) = 1
      indx(4,1) = nt
      indx(4,2) = 1

      icstart = 1
      DO 300 n = 1, nscat

         CALL pickoutxytcv (obs_only, arg_1, arg_2, arg_3, arg_4, arg_5,
     .           n, vv, xx, yy, tt, ncc)
         IF (vv .EQ. bad_flag(ARG1) .OR. xx .EQ. bad_flag(ARG2) .OR. 
     .          yy .EQ. bad_flag(ARG3) .OR. tt .EQ. bad_flag(ARG4) ) GOTO 300

*  If output axis is modulo, apply modulo adjustment to that coordinate
*  of the scattered point.
         IF ( modulox ) THEN
            CALL modscat(xax(1,1,1,1), xax(nx,2,1,1), modxlen, 1, xx)
         ENDIF
         IF ( modulot ) THEN
            CALL modscat(tax(1,1,1,1), tax(nt,2,1,1), modtlen, 1, tt)
         ENDIF

* We have come to the end of a cruise loop over cells represented by the last cruise,
* summing and counting the observations in the cruise, computing cruiseweight. 
* cruisemean is weighted cruise mean in cell
* cruiseweight are variances for cruise mean in cell
* cell_avg(i,j,1,L) cruise mean averaged over cruises in cell
* cell_avg(i,j,2,L) is count of cruises in cell
* wi_sums(i,j,1,L) sum of cruiseweight wi in cell

         IF (ncc .NE. icruise) THEN  
	    icend = n-1

            DO L = indx(4,1), indx(4,2)
            DO j = indx(2,1), indx(2,2)
            DO i = indx(1,1), indx(1,2)

	       IF (obs_cruise(i,j,2,L).GT.0. .AND. obs_cruise(i,j,3,L).NE.0.) THEN

                  wt_cruise_mean = obs_cruise(i,j,1,L)/obs_cruise(i,j,3,L)

                  unwtd_mean = obs_cruise(i,j,1,L) ! nobsxytv_var returns mean already computed

                  cell_avg(i,j,1,L) = cell_avg(i,j,1,L) + wt_cruise_mean
                  cell_avg(i,j,2,L) = cell_avg(i,j,2,L) + 1.  

		  wi_sums(i,j,1,l) = wi_sums(i,j,1,l) + 1./obs_cruise(i,j,3,L)

		  nc_cell = cell_avg(i,j,2,L)
		  IF (nc_cell.GT.wrk7hiz) THEN
                     print *, 'Num_obs in cell at I,J,L = ', i,j,L, 
     .               ' is', nc_cell
		     CALL ef_bail_out (id,
     .      'too many cruises in cell. increase K size of work array 7,8')
		  ENDIF

		  cruisemean(i,j,nc_cell,l) = unwtd_mean
		  cruiseweight(i,j,nc_cell,l) = 1./obs_cruise(i,j,3,L)

	       ENDIF


            ENDDO
            ENDDO
            ENDDO

	    icruise = ncc

            DO L = indx(4,1), indx(4,2)
            DO j = indx(2,1), indx(2,2)
            DO i = indx(1,1), indx(1,2)
	       obs_cruise(i,j,1,L) = 0.
	       obs_cruise(i,j,2,L) = 0.
	       obs_cruise(i,j,3,L) = 0.
            ENDDO
            ENDDO
            ENDDO

* reset indices
            indx(1,1) = nx
            indx(1,2) = 1
            indx(2,1) = ny
            indx(2,2) = 1
            indx(4,1) = nt
            indx(4,2) = 1

	 ENDIF

*  Count and add up observations in each cell, in this cruise. 
     
         CALL nobsxytv_var (obs_only, xx, yy, tt, vv, nx, ny, nt, 
     .        xax(1,1,1,1), xax(1,2,1,1), yax(1,1,1,1), yax(1,2,1,1), 
     .        tax(1,1,1,1), tax(1,2,1,1), indx, obs_cruise)

 300  CONTINUE

* Get data from the last cruise

      icend = n-1

      DO L = indx(4,1), indx(4,2)
         DO j = indx(2,1), indx(2,2)
            DO i = indx(1,1), indx(1,2)

	       IF (obs_cruise(i,j,2,L).GT.0. .AND. obs_cruise(i,j,3,L).NE.0.) THEN

                  wt_cruise_mean = obs_cruise(i,j,1,L)/obs_cruise(i,j,3,L)

                  unwtd_mean = obs_cruise(i,j,1,L) ! nobsxytv_var returns mean already computed

                  cell_avg(i,j,1,L) = cell_avg(i,j,1,L) + wt_cruise_mean
                  cell_avg(i,j,2,L) = cell_avg(i,j,2,L) + 1.  

		  wi_sums(i,j,1,l) = wi_sums(i,j,1,l) + 1./obs_cruise(i,j,3,L)

		  nc_cell = cell_avg(i,j,2,L)
		  IF (nc_cell.GT.wrk7hiz) THEN
                     print *, 'Num_obs in cell at I,J,L = ', i,j,L, 
     .               ' is', nc_cell
		     CALL ef_bail_out (id,
     .      'too many cruises in cell. increase K size of work array 7,8')
		  ENDIF

		  cruisemean(i,j,nc_cell,l) = unwtd_mean
		  cruiseweight(i,j,nc_cell,l) = 1./obs_cruise(i,j,3,L)

	       ENDIF

            ENDDO
         ENDDO
      ENDDO
      
*  Put gridded fcn into result variable.
* wi_sums(i,j,1,L) sum of cruiseweight wi in cell
* V1 sum of cruiseweight
* V2 sum of cruiseweight squared
* for s^2  wsumsq sum of wi*(xi - weighted_mean)**2

      k = res_lo_ss(Z_AXIS)
      DO 420 L = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         DO 410 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            DO 400 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

               nc_cell = cell_avg(i,j,2,L)

               IF (nc_cell .EQ. 0) THEN
                   result(i,j,k,l) = bad_flag_result
               ELSE IF (nc_cell .EQ. 1) THEN
                   result(i,j,k,l) = 0.
c               ELSE IF (wi_sums(i,j,1,l).LE.1.e-6) THEN
c                   result(i,j,k,l) = bad_flag_result

* Compute sum of (cruise-cell-averages - weighted cell mean) squared\

               ELSE IF (nc_cell.GT.1 .AND. wi_sums(i,j,1,l).NE.0.) THEN

                  cellmean = cell_avg(i,j,1,L)/wi_sums(i,j,1,l)

                  wsumsq_ijl = 0.
                  wsumsq = 0.
		  v1 = 0.
                  DO 500, nk = 1, nc_cell
                      wtcruise = cruiseweight(i,j,nk,L)
		      unwtd_mean = cruisemean(i,j,nk,L)

		      wtsq = wtcruise*wtcruise
		      wsumsq = wsumsq + wtsq  

* Sum the squares of difference of unweighted cruise means 
* minus weighted cell mean

		      diffsum = unwtd_mean - cellmean
                      wsumsq_ijl = wsumsq_ijl + wtcruise*(diffsum)**2

 500              CONTINUE
                  V1 = wi_sums(i,j,1,l)
                  V2 = wsumsq
                  denom = V1*V1 - V2
		  
c                  IF (ABS(denom).GT.1.e-6) THEN
                  IF (ABS(denom).NE.0.) THEN
                     result(i,j,k,l) = SQRT(wsumsq_ijl* V1/denom)
                  ELSE
                     result(i,j,k,l) = bad_flag_result
                  ENDIF
	       ENDIF

 400        CONTINUE

 410     CONTINUE
 420  CONTINUE

      RETURN

900   CONTINUE

      IF (nxpts .NE. npts) THEN
         WRITE (errtxt,20)
      ELSE IF (nxpts .EQ. 0) THEN
         WRITE (errtxt, 30)
      ENDIF
      GOTO 999 

 999  CALL EF_BAIL_OUT(id, errtxt)
      RETURN

   20 FORMAT 
     . ('Input scattered var,x,y,t,cruiseID have different # of points')

   30 FORMAT ('No data in scattered x,y,t points')


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      END

      INTEGER FUNCTION STR_SAME( str1, str2 )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compare two strings disregarding spaces and case differences

* programmer - ANsley Manke (from str_case_blind_compare) 
*
* revision 0.0 -  4/02/03

* calling argument declarations:
      CHARACTER*(*) str1, str2

* local variable declarations:
      INTEGER      s1, s2, e1, e2
      CHARACTER*1  c1, c2

* local parameter declarations:
      INTEGER     STR_CASE_BLIND_COMPARE


* local parameter declarations:
        CHARACTER*1     tab
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
#else
	PARAMETER     ( tab = CHAR(9))
#endif

      e1 = LEN(str1)
      e2 = LEN(str2)

* skip leading blanks

      DO 100 s1 = 1, LEN(str1)
         c1 = str1(s1:s1)
         IF ( c1 .NE. ' ' .AND. c1 .NE. tab ) GOTO 200
 100  CONTINUE
 200  CONTINUE

      DO 300 s2 = 1, LEN(str2)
         c2 = str2(s2:s2)
         IF ( c2 .NE. ' ' .AND. c2 .NE. tab ) GOTO 400
  300 CONTINUE
  400 CONTINUE

      STR_SAME = STR_CASE_BLIND_COMPARE (str1(s1:e1), str2(s2:e2) )

      RETURN
      END

	SUBROUTINE IS_TRANS(  ROUTINE, *, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* create a complete context describing the result of the transformation
* create a memory resident slot to receive the result and initiate the
* transformation

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  6/1/89 - (based on IS_PLANE_TRANS)
*	10/16/89 - set up adjustable array limits with NON_ARRAY_SUBSC
*	 1/21/90 - pass ss limits from component back to result if unknown
* Unix/RISC port - 1/91 - need to declare "ROUTINE" external (???)
* V230:   8/2/92 - add comment re: cx_valid
*        9/10/92 - bypass error if interpolate is applied to a point
* V312: 5/94 - array "memory" as a calling argument
* V420: 11/95 - fix bug in explicit limits: LET A=TEMP[I=1:160]; STAT A[I=@MAX]
*		... result has one valid and 159 invalid points		 
* V430: 7/96 - incorporate 4D transformations
* V440: 8/96 - allocate memory for COS(lat) array before calling ROUTINE
* V450: 5/97 - fillers different from smoothers when component data is
*		insufficient for result. Should return original data rather
*		than an all-bad field.
* V455:  9/97 - OFFSET_SS returns status
*	11/13/97 - bug fix: @ITP component WW coords must bracket result
*	        (11/18/97 - repaired bug introduced 11/13)
* V491:  1/2/98 - component size can exceed result in case like
*                       let vx = SIN(X[X=1:60:1])
*                       list/i=13:18 vx[x=@sbx:3]
*               As an easy (but not necessarily "correct") fix  we REDUCE
*		the component size here to fit the result. We need to flag the
*		result as not cache-retreivable because the uvar_given value
*		indicates the result size is self-defined (Is this risky??)
* V500:  1/99 *sh* Trap as errors attempts to apply transform to string
*		variables
* V530:  8/00 *sh* changed string trap to be based on data type, not category
* V533:  7/01 *sh* transform @SHF supported for strings
* v552   4/03 *acm* up VAR_TRANS to 150 characters (variables are up to 128,
*                   plus space for the transformation specifier)
* V600  10/05 *acm* is bug 899: rather than the ungraceful STOP, issue an
*		    error message if a 4-D transform was requested but the
*		    dimensions are not available in the grid.
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V691+ *acm* 8/14 Fix ticket 2196. Fill transformations component index range
*		   should be limited to the range of the axis.
* V710  *acm* 9/16 For ticket 2469: Allow an average of an average and likewise
*		   @SUM, @MIN, @MAX 
* V702 *sh* 11/16 mods for trac #2428 - calculation in gathered fragments
*		   Compute transformations in 3 phases: i)initialize,
*		   ii) accumulate, and iii) finalize so that compressed axes
*		   may be split/gathered (in IS_STRIP and IS_GATHER)
* V702 *sh*  1/17 for trac enhancement #2369 -- dynamic memory management 
	
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xtext_info.cmn'
	include	'xalgebra.cmn'
	include	'xfr_grid.cmn'
	include 'xprog_state.cmn'

* calling argument declarations:
	INTEGER	status
* normal exit is for error conditions
* exit #1 is to signal completion of the activity at this stack level
	INTEGER	ROUTINE		! (returns status )
	EXTERNAL ROUTINE	! added for Unix/RISC/FORTRAN

* internal variable declarations:
* ... "res"="result" , "com"="component"
	LOGICAL	ITSA_FILL_TRANS, ITSA_MODULO_AXIS, its_4d, string_bad_good,
     .		string_com, need_init
	INTEGER CX_DIM_LEN, MGRID_SIZE_DELTA, DO_4D_STRING_TRANS, CAXIS_LEN,
     .		slen, cx_valid,
     .		res_isp, com_isp, res_cx, com_cx, com_mr, res_mr, idim,
     .		trans, grid, lo_off, hi_off, ss_lo, ss_hi,
     .		mrlist(2), axes(nferdims), idim1, i, ndim, axis, nbuffer,
     .		dflt_cx, frag
	INTEGER*8 i8_size
	REAL	arg
	REAL*8	TM_WORLD, ww, ww_lo, ww_hi, init_val
	CHARACTER VAR_TRANS*150, buff*150

* --- end of introductory code ---

* ***** initial set up and error checks *****
	res_isp	= isp
	com_isp	= res_isp + 1
	res_cx  = is_cx( res_isp )
	com_cx  = is_cx( com_isp )
        res_mr  = is_mr( res_isp ) ! gets set in isphase_initialize_transform
	com_mr	= is_mr( com_isp )
 	dflt_cx = is_big_cx( res_isp )
	frag    = is_sum   ( res_isp )
	idim1	= is_axis( res_isp )
	trans	= cx_trans( idim1, res_cx )
	arg	= cx_trans_arg( idim1, res_cx )
	grid    = cx_grid( com_cx )
	string_bad_good = .FALSE.
	string_com = .FALSE.
	need_init = .FALSE.

* determine if this is a 1D or a 4D (multiple axis) transformation
	its_4d = .FALSE.
	DO 110 i = 1, num_4d_trans
           IF ( trans .EQ. alg_4d_trans(i) ) its_4d = .TRUE.
 110	CONTINUE

* determine the axes to be transformed.
	IF (its_4d) THEN
	   ndim = 0
	   DO 120 idim = 1, nferdims
	     IF ( cx_trans(idim,res_cx) .EQ. trans ) THEN
	       ndim = ndim + 1
	       axes(ndim) = idim
* ... odd nesting of transforms that may happen from implicit interpolation
	       IF (cx_trans(idim,com_cx).NE.trans_no_transform) GOTO 5200
	     ENDIF
 120	   CONTINUE
	   IF (ndim.LE.1) GOTO 5400     !!  STOP 'is_trans:ndim = 0'
	ELSE
	   ndim = 1
	   axes(1) = idim1
* ... odd nesting of transforms that may happen from implicit interpolation
	   IF ( cx_trans(idim1,com_cx) .NE. trans_no_transform ) GOTO 5200
	ENDIF

* error check: attempt to transform a single point ?
* ( note: this won't catch a[k=1:5@sbx] where a=u[k=5]
* 	  but using CX_DIM_LEN rules out [Z=10:11@ave] within a single point)
	DO 200 i = 1, ndim
	  idim = axes(i)
	  IF ( cx_lo_ss(com_cx,idim) .EQ. unspecified_int4 ) THEN
             IF ( trans .NE. trans_interpolate .AND.
     .            trans .NE. trans_average .AND.
     .            trans .NE. trans_max .AND.
     .            trans .NE. trans_min .AND.
     .            trans .NE. trans_sum) GOTO 5100
	  ENDIF
 200	CONTINUE

* *sh* 10/92 MODE INTERPOLATE has lead to @ITP applied to inappropriate limits
*  errors were trapped mistakenly here for:
*       LIST/X=5.5  5.0 
*  and  LIST/X=5.5/Y=5.5 X  (err on Y axis)
*  this patch returns the component data as the result
        IF ( trans .EQ. trans_interpolate ) THEN
	   IF ( cx_lo_ss(com_cx,idim1) .EQ. unspecified_int4 ) THEN
              CALL TRANSFER_CONTEXT( com_cx, res_cx )
              CALL CREATE_MEM_VAR( res_cx, res_mr, status )
              IF ( status .NE. ferr_ok ) GOTO 5000
              CALL COPY_GRID(
     .           memry(com_mr)%ptr , com_mr,
     .           memry(res_mr)%ptr , res_mr )
              is_mr   (res_isp) = res_mr
              GOTO 1000
            ENDIF
         ENDIF

* ***** end of initial set up and error checks *****

* This is_phase branch occurs only when additional data has arrived to be
* accumulated in a split/gather operation
	IF (is_phase(res_isp) .EQ. isphase_accumulate_transform) GOTO 500
* 11111 start of isphase_initialize_transform 11111 *

* create a result context based on the received component
	cx_valid= cx_buff
	CALL TRANSFER_CONTEXT( com_cx, cx_valid )
	DO 300 i = 1, ndim
	   idim = axes(i)
* ... if the requested region was unknown use the component region

* ... abstract grid ignore a set region that may be in the res_cx.

	   IF ( cx_lo_ss(res_cx,idim).EQ.unspecified_int4
     .	   .AND.cx_lo_ww(idim,res_cx).NE.unspecified_val8 ) THEN
	      IF (cx_grid(com_cx) .GE. mgrid_abstract
     .	    .AND. cx_grid(com_cx) .LE. mgrid_fabstract ) THEN  
	         cx_lo_ss( res_cx, idim ) = cx_lo_ss(com_cx,idim)
	         cx_hi_ss( res_cx, idim ) = cx_hi_ss(com_cx,idim)
              ENDIF
	   ENDIF

	   IF (is_phase(res_isp) .EQ. isphase_initialize_transform
     .	.AND. idim.EQ.idim1 ) THEN
* 11/16 - we are initializing a result to be determined by a gather operation
* along the transformed axis
	      CONTINUE  ! leave result ax-s as-is
! note that this is an imperfect solution.  Might the requested result region
! be incorrect?  eg. LIST V[l=@ave], where v = v2[L=100:200]
! check with totalview whether the result incorrectly has full axis span
	   ELSEIF ( cx_lo_ss(res_cx,idim).EQ.unspecified_int4
     .	   .AND.cx_lo_ww(idim,res_cx).EQ.unspecified_val8 ) THEN
* 11/95 - FLESH_OUT_AXIS cannot be trusted to flesh this out.
*	  It puts responsibility for redundant limits onto the various interp
*	  stack routines (I guess ...)
	      CALL TRANSFER_AXIS( idim, com_cx, res_cx )
	      cx_trans( idim, res_cx ) = trans
	      cx_trans_arg( idim, res_cx ) = arg
	      cx_by_ss(idim,res_cx) = .TRUE.
	      IF ( trans  .GT. trans_compress_code ) THEN
	         cx_lo_ss( res_cx, idim ) = unspecified_int4
	         cx_hi_ss( res_cx, idim ) = unspecified_int4
	         cx_by_ss( idim, res_cx ) = .FALSE.
	      ENDIF
! pre=11/95cx_lo_ss(res_cx,idim) = cx_lo_ss(com_cx,idim)
!	         cx_hi_ss(res_cx,idim) = cx_hi_ss(com_cx,idim)
!	         cx_by_ss(idim,res_cx) = .TRUE.

* 11/95 - is interpolation the only case of a compressing transform
* where the component ww range normally doesn't match the result?
	   ELSEIF ( trans .EQ. trans_interpolate ) THEN
* ... component range must **bracket** the result, however (11/97)
	      ww    = cx_lo_ww(idim,res_cx)
	      ss_lo = cx_lo_ss(com_cx,idim)
	      ss_hi = cx_hi_ss(com_cx,idim)
	      ww_lo = TM_WORLD( ss_lo, grid, idim, box_lo_lim )
	      ww_hi = TM_WORLD( ss_hi, grid, idim, box_hi_lim )
* ... allow ww_lo>ww_hi to accomodate time encodings
	      IF ( (ww-ww_lo)*(ww-ww_hi) .GT. 0.0D0 ) GOTO 5300 

* 11/95 - compressing transform where variable limits are in a nested def'n
*    e.g.   list b[i=1:5] where b = a[i=@ave] and a = temp[i=1:100]
* ... use the inner limits (i=1:100) for the transformation
	   ELSEIF ( trans .GT. trans_compress_code
     .      .AND. (cx_lo_ww(idim,res_cx).NE.cx_lo_ww(idim,com_cx)
     .	    .OR.cx_hi_ww(idim,res_cx).NE.cx_hi_ww(idim,com_cx))   ) THEN
	      CALL TRANSFER_AXIS( idim, com_cx, res_cx )
	      cx_trans( idim, res_cx ) = trans
	      cx_lo_ss( res_cx, idim ) = unspecified_int4
	      cx_hi_ss( res_cx, idim ) = unspecified_int4
	      cx_by_ss( idim, res_cx ) = .FALSE.
	   ENDIF

	   CALL TRANSFER_AXIS( idim, res_cx, cx_valid )
	   CALL FLESH_OUT_AXIS( idim, cx_valid, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000

 300	CONTINUE

* the context is ready - carve out memory space for it
	CALL TRANSFER_CONTEXT( cx_valid, res_cx )
	
	IF ( cx_type(com_cx) .EQ. ptype_string ) THEN
	   string_com = .TRUE.
	   IF (trans .EQ. trans_good_pt    .OR.
     .         trans .EQ. trans_bad_pt     .OR.
     .         trans .EQ. trans_4d_good_pt .OR.
     .         trans .EQ. trans_4d_bad_pt ) THEN
               string_bad_good = .TRUE.
               cx_type(res_cx) = ptype_float
           ENDIF
        ENDIF

* 11/16: allow extra buffer space for accumulating weight values or counts?
	CALL TRANS_INIT_VALUE(idim1, res_cx,
     .			             need_init, init_val, nbuffer)

* allocate memory for the result
	CALL CREATE_MEM_VAR_W_BUFFER( res_cx, res_mr, nbuffer, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
* ... no nonger deferred.  Memory allocation for result has just been done.
	is_deferred_mem(res_isp  ) = 0  ! chunk  memory no longer deferred
	IF (res_isp .GT.1) is_deferred_mem(res_isp-1) = 0  ! result mem
	is_mr(res_isp) = res_mr
	IF ( mr_type(res_mr) .EQ. ptype_string .AND.
     .     (.NOT.string_bad_good)                    ) THEN
* ... only applicable to @SHF transformation; else will return a null string.
           CALL INIT_C_STRING_ARRAY( MGRID_SIZE_DELTA(res_mr),
     .                               memry(res_mr)%ptr,
     .                               mr_c_pointer(res_mr)      )
	ENDIF

* 11/16: pre-fill the result with an initialization value
	IF (need_init) CALL FILL_MEMORY( res_mr, init_val )

* if starting up a split/gather ...
	IF (is_phase(res_isp).EQ.isphase_initialize_transform) 
     .	    is_phase(res_isp)  = isphase_accumulate_transform

!* diagnostic message ?
!	IF (mode_diagnostic) CALL DIAGNOSTIC_OUT(
!     .		'@'//ALG_TRANS_CODE(trans)//'   ', res_mr, point_to_mr )

* component size may be inadequate for requested result
* pre-fill result with missing data flag if component is inadequate
* (7/96 - note that 4D transforms are always compressing transforms)
	IF ( trans .LT. trans_compress_code ) THEN
	   idim = idim1				! should be equal already
	   IF ( ITSA_FILL_TRANS(trans) ) THEN	! 5/97 - filler are difrnt
	      lo_off = 0
	      hi_off = 0
* 5/97: for fillers the DO_ routines handle result regions beyond the
*	bounds of the component data 
	   ELSE
	      CALL OFFSET_SS( idim, res_cx, lo_off, hi_off, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
	   ENDIF
* ... computable limits from component
* Note (8/92): when the requested limites are unknown the com_cx will be
*              full-width along idim so subtracting the offset limits leaves
*              cx_valid as beyond the possible range but no known crash results

	   cx_lo_ss( cx_valid, idim ) = cx_lo_ss( com_cx, idim ) - lo_off
	   cx_hi_ss( cx_valid, idim ) = cx_hi_ss( com_cx, idim ) - hi_off

* Ticket 2301: If the requested region is at the end of an axis, so the offset
* takes the high subscript below the axis start or the low subscript above the
* axis end, move the index limit(s) to the axis end. 
* (similar change in is_strip)
* Ticket 2314, tweak this logic

	   IF  ( .NOT. ITSA_MODULO_AXIS(com_cx, idim) ) THEN
	      cx_lo_ss( cx_valid, idim ) = MAX(1,cx_lo_ss( cx_valid, idim ))
	      cx_hi_ss( cx_valid, idim ) = MAX(1,cx_hi_ss( cx_valid, idim ))
	      cx_lo_ss( cx_valid, idim ) = MIN(CAXIS_LEN(idim,com_cx),
     .					       cx_lo_ss( cx_valid, idim ))
	      cx_hi_ss( cx_valid, idim ) = MIN(CAXIS_LEN(idim,com_cx),
     .					       cx_hi_ss( cx_valid, idim ))
	   ENDIF 

* insufficient component data to compute anything?
	   IF ( cx_lo_ss(cx_valid,idim) .GT. cx_hi_ss(cx_valid,idim) ) THEN
	      IF ( mr_type(res_mr) .EQ. ptype_string ) THEN
	        CALL SET_NULL_C_STRING_ARRAY(mr_c_pointer(res_mr),
     .                                       MGRID_SIZE_DELTA(res_mr) )
	      ELSE
	        CALL FILL_MEMORY( res_mr, mr_bad_data(res_mr) )
	      ENDIF
	      GOTO 1000
	   ENDIF

	   IF (  cx_lo_ss(res_cx,idim) .LT. cx_lo_ss(cx_valid,idim)
     .		.OR. cx_hi_ss(res_cx,idim) .GT. cx_hi_ss(cx_valid,idim) ) THEN
* ... insufficient component data to compute the entire requested region
	      CALL BAD_EDGES( cx_valid, memry(res_mr)%ptr, res_mr )
	   ELSEIF (  cx_lo_ss(res_cx,idim) .GT. cx_lo_ss(cx_valid,idim)
     .		.OR. cx_hi_ss(res_cx,idim) .LT. cx_hi_ss(cx_valid,idim) ) THEN
* ... *1/98* component data is BIGGER than expected for requested result
* ... reduce the apparent size of the component data (dangerous??)
* e.g.                      let vx = SIN(X[X=1:60:1])
*                           list/i=13:18 vx[x=@sbx:3]
*     Note that this situation occurs when the component variable being xformed
*	thinks that it has self-describing limits (uvar_given<uvlim_gvn_xact).
*       Since the transformed version of the variable (the result) is getting
*	its limits from elsewhere uncache the result so it won't be recalled.
*	==> THIS IS A KLUDGE: The right solution is that the limits i=13:18
*	should never get applied to vx ... but this is too difficult to
*	implement in GET_VAR_CONTEXT and PARSE_VAR_NAME
	      CALL UN_CACHE( res_mr )
* ... fillers and smoothers are equivalent here ... so recompute offsets
	      CALL OFFSET_SS( idim, res_cx, lo_off, hi_off, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
	      IF ( cx_lo_ss(res_cx,idim) .GT. cx_lo_ss(cx_valid,idim) )
     .			cx_lo_ss(com_cx,idim) = cx_lo_ss(res_cx,idim) + lo_off
	      IF ( cx_hi_ss(res_cx,idim) .LT. cx_hi_ss(cx_valid,idim) )
     .			cx_hi_ss(com_cx,idim) = cx_hi_ss(res_cx,idim) + hi_off

* The above can send the index range outside the line dimensions. Ticket 2196.
* If its modulo that's ok otherwise limit to the index rangen for the axis

	      axis = grid_line( idim, cx_grid(com_cx) )
	      IF (.NOT. line_modulo(axis)) THEN
	         cx_lo_ss(com_cx,idim) = MAX(1,
     .					     cx_lo_ss(com_cx,idim))
	         cx_hi_ss(com_cx,idim) = MIN(line_dim(axis),
     .				             cx_hi_ss(com_cx,idim))
	      ENDIF

	      cx_by_ss(idim,res_cx) = .TRUE.
	      CALL FLESH_OUT_AXIS( idim, com_cx, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
	   ENDIF
	ENDIF

* 11111 end of isphase_initialize_transform 11111 *

 500	CONTINUE
* 22222 start of isphase_accumulate_transform 22222 *

* set up 4D array limits as unsubscripted variables in COMMON
	mrlist(1) = com_mr
	mrlist(2) = res_mr
	CALL NON_ARRAY_SUBSC( mrlist, 2 )

* transformations applied to string arguments
	IF ( string_com ) THEN
	   IF (trans .EQ. trans_shift) THEN
	      CALL DO_STRING_SHIFT ( idim, arg,
     .		memry(com_mr)%ptr, com_mr, com_cx, ! component
     .		memry(res_mr)%ptr, res_mr, res_cx) ! result
	   ELSEIF (string_bad_good) THEN
	   
	      IF (its_4d) THEN
	         status = DO_4D_STRING_TRANS( trans,
     .		 memry(com_mr)%ptr, com_mr, com_cx, ! component
     .		 memry(res_mr)%ptr, res_mr, res_cx) ! result
	         IF ( status .NE. ferr_ok ) GOTO 5000
              ELSE
 	         CALL DO_STRING_GOODBAD ( idim, trans,
     .		 memry(com_mr)%ptr, com_mr, com_cx, ! component
     .		 memry(res_mr)%ptr, res_mr, res_cx) ! result                            ! result
	      ENDIF
	   ELSE
	     CALL SET_NULL_C_STRING_ARRAY(mr_c_pointer(res_mr),
     .                                    MGRID_SIZE_DELTA(res_mr) )
	   ENDIF
	   GOTO 1000
	ENDIF

* reserve working space for the transformation
* Note: this logic is a loose hodge-podge to get an upper bound size for all
* the different cases: 4D, 1D, with arguments, etc.
	i8_size = 1
	DO i = 1, ndim
	   idim = axes(i)
	   i8_size = i8_size + CX_DIM_LEN(idim,com_cx)
	ENDDO

* ... allow room for COS(lat) array during 4D transforms (8/96)
	IF (ndim .GT. 1 )  i8_size = i8_size + CX_DIM_LEN(y_dim,com_cx)
* ... set minimum work size
	i8_size = MAX( iswksiz, i8_size )
* ... for transforms like smoothers allow extra slop on each end 
	IF ( arg .NE. bad_val4 )  i8_size =
     .			MAX( i8_size, CX_DIM_LEN(idim1,res_cx)+INT(arg) )
	CALL GET_DYN_WORK_SPACE( i8_size, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* do the transform (or at least accumulate results in preparation to finalize)
	status = ROUTINE( idim, arg,
     .		memry(com_mr)%ptr, com_mr, com_cx, ! component
     .		memry(res_mr)%ptr, res_mr, res_cx, ! result
     .		workmem(plegacy_work_buffer)%ptr ) ! work space
	IF ( status .NE. ferr_ok ) GOTO 5000

* go back for more input data to compress into the transform?
	IF ( is_phase(res_isp) .EQ. isphase_accumulate_transform ) THEN

	   IF (cx_hi_ss(com_cx,idim1).LT.cx_hi_ss(dflt_cx,idim1) ) THEN
* yes - get next fragment

* ... remove component protections that signaled this calculation needed it
	      CALL MR_NOT_IN_USE( com_mr )	

* ... adjust the component limits to get the next fragment as setup by IS_STRIP
	      CALL DEFINE_NEXT_CHUNK_CX(idim1, com_cx, dflt_cx, frag, status)
	      IF ( status .NE. ferr_ok ) GOTO 5000
	      IF ( mode_diagnostic )
     .		   CALL DIAG_OP('doing', isact_class_cmp_gather_dummy,
     .							com_cx, idim1)
* ... push the interpretation stack and go get it
	      isp = com_isp
	      RETURN 1
	   ELSE
* no - all fragments have been processed.  Get ready to finalize
	      cx_stack_ptr = cx_stack_ptr - 1   ! free big_cx
	   ENDIF
	ENDIF

* finialize (e.g. average = WEIGHTED_SUM(values) / SUM(weights)
	CALL TRANS_FINALIZE( idim, arg,
     .		memry(res_mr)%ptr, res_mr, res_cx )

* remove component protections that signaled this calculation needed it
 1000	CALL MR_NOT_IN_USE( com_mr )	

* ... successful completion
*     free the context stack space
	cx_stack_ptr = cx_stack_ptr - 1
	is_phase(res_isp)  =   isphase_completed_transform ! housekeeping
	RETURN 2

* error exit
 5000	RETURN
 5100	buff = VAR_TRANS( idim, res_cx, slen )
	CALL ERRMSG( ferr_trans_nest, status,
     .		     buff(:slen)//' applied to point', *5000 )
 5200	buff = VAR_TRANS( idim, com_cx, slen )
	CALL ERRMSG( ferr_trans_nest, status, 'interpolation on '//
     .		     buff(:slen)//'--> DEFINE a new variable', *5000 )
 5300	buff = VAR_TRANS( idim, res_cx, slen )
	CALL ERRMSG( ferr_limits, status,
     .		     buff(:slen)//' exceeds interpolation range',
     .		     *5000 )
 5400	CALL ERRMSG( ferr_trans_nest, status,
     .		     ' not all dimensions present on grid',
     .		     *5000 )

	END	

	SUBROUTINE TM_GET_LIKE_GRID ( newgrid, newname, gridnum, status)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Will compare "newgrid" to other grid definitions in common. If there is a
* match then "gridnum" returns with the number of the match. If there is no
* match, then a new slot is located and the name "newname" is used to name it,
* and "gridnum" returns with the number of the new slot.
*
* revision 0.00 - 11/22/88
* V510 *sh* 4/00 - use TM_COPY_GRID_W_LINE_USE
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* Arguments
	INTEGER*4	newgrid, gridnum, status
	CHARACTER*(*)	newname
*
* INCLUDE FILES
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'tmap_errors.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data

*
* Local definitions
	INTEGER*4	grid_match
	INTEGER*4	TM_FIND_LIKE_GRID, TM_FIND_GRID_SLOT
*
* Check for match
	grid_match = TM_FIND_LIKE_GRID ( newgrid )
	IF (grid_match .NE. unspecified_int4) THEN
	  gridnum = grid_match
	  GOTO 9000
	ENDIF
*
* No match, find empty slot for storage
	status = TM_FIND_GRID_SLOT ( gridnum )
	IF (status .NE. merr_ok) GOTO 9000
*
* Move everything over
	CALL TM_COPY_GRID_W_LINE_USE( newgrid, gridnum )
*
* Name the new grid
	grid_name(gridnum) = newname
*
	status = merr_ok
 9000	RETURN
	END

	SUBROUTINE CD_MAKE_FMRC_FCAL_AXIS (dset, ens_ax, nF, axcalt, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*.
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*

* this routine synthesizes the F forecast initialization calendar axis,
* using initialization times stored temporarily in line_mem
* it does so by modifying the generic ensemble axis, "ens_ax"
* patterning after time axis info in axcalt

* V695+ *sh*
* v698  *acm* 4/16 remove unused function declarations

* include files
        include 'netcdf.inc'
	include 'tmap_errors.parm'
#include "gt_lib.parm"
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
	include 'xdset_info.cmn_text'

	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xbuild_grids.cmn'

	external xdset_info_data
        include 'xdset_info.cd_equiv'
        include 'xio.cmn_text'
        include 'xunits.cmn_text'
        external xunits_data
        include 'calendar.decl'
        include 'calendar.cmn'

* calling argument declarations
	INTEGER dset, ens_ax, nF, axcalt, status

* internal variable declarations
	INTEGER bufflen
	PARAMETER (bufflen = 256)
	CHARACTER TM_STRING*13, buff*256, dbuf*3, vupcase*128, pCR*1

	LOGICAL TM_DFPEQ_TOL, TM_FPEQ_EPS, NC_GET_ATTRIB, 
     .		coordvar, got_it, do_warn, ok_cal, yyyymmdd_time, got_torg
	INTEGER STR_UPCASE, TM_LENSTR1, TM_FIND_LIKE_DYN_LINE,
     .          i, l, n,  nvdim, vdims(8), nvatts, 
     .		npts_cdf, ipt1, ipte, iptn, iptnp1,
     .		outflag, next_line_storage, pre_exist,
     .		start(nferdims),count(nferdims), zero(nferdims),
     .          maxlen, attlen, attoutflag, cal_id, since_T0, slen, vlen, 
     .          units, istat, nlag, noverlap, nleadtimes
	REAL val, t0NextForecast
	REAL*8 depsilon_46, depsilon, dlast_coord, dfirs_coord,
     .       dfirst_delta, ddelta, avg_lag

        INTEGER tt  ! nice short name
        EQUIVALENCE (tt,lunit_errors)


* initialize things
	ipt1 = next_line_mem_pos
	ipte = ipt1 + nF - 1
      depsilon_46 =  2.**(-46) 

* from cd_get_1_axis.
* check for regular spacing according to the data type of incoming data.
* the variables (depsilon, etc) are in double precision. The tolerance
* chec, in TM_FPEQ_EPS is done to an equivalent single precision tol.

	dlast_coord = line_mem(ipte)
        dfirs_coord = line_mem(ipt1)
        dfirst_delta = line_mem(ipt1+1) - line_mem(ipt1)
        depsilon = depsilon_46 * 2.*(ABS(line_mem(ipt1)) / dfirst_delta )

	DO i = ipt1+2, ipte	
	   ddelta = line_mem(i) - line_mem(i-1)
	   IF (.NOT. TM_DFPEQ_TOL(dfirst_delta, ddelta, depsilon) ) GOTO 100
	ENDDO

* It's regular - save it as such
!	line_regular(ens_ax) = .TRUE.		! already set
	line_start  (ens_ax) = line_mem(ipt1)
	line_delta  (ens_ax) = 
     .              (line_mem(ipte)-line_mem(ipt1))/DBLE(nF-1)
!	line_subsc1 (ens_ax) = unspecified_int4  ! already set
	GOTO 200

*  Irregular
 100	line_regular(ens_ax) = .FALSE.
	line_subsc1(ens_ax)  = next_line_mem_pos
	IF ((next_line_mem_pos+2*nF+1).GT.maxlinestore) GOTO 5300
!	CALL TM_IRREGAX_MID( ipt1, nF )  -- not needed.  have real edges
        next_line_mem_pos =  next_line_mem_pos + 2*nF + 1
	
 200	CONTINUE
 
* inherit units from the calendar time axis just created
	line_unit_code(ens_ax) = line_unit_code(axcalt)
	line_units(ens_ax)     = line_units(axcalt)  
	line_tunit(ens_ax)     = un_convert(line_unit_code(ens_ax))

	line_t0(ens_ax)        = line_t0(axcalt)  
	line_direction(ens_ax) = 'FI'

* Save the axis name (upper case) and memory storage.  For all irregular axes, 
* we have saved N+1 edges for the axis cells. Increment the pointer.   
	CALL TM_NEW_LINE_NAME ( 'TF_CAL_F', buff )
	line_dattype(ens_ax) = nf_double
	line_name_orig(ens_ax) = buff
	i = STR_UPCASE( line_name(ens_ax), line_name_orig(ens_ax))

* successful completion
        status = merr_ok

 5000	RETURN


 5300	CALL TM_ERRMSG (merr_linstorlim, status, 'CD_MAKE_FMRC_FCAL_AXIS',
     .                  no_descfile, no_stepfile,
     .                  'MAX='//TM_STRING(DBLE(maxlinestore)),
     .                  no_errstring, *5000)

	RETURN
	END

	SUBROUTINE CREATE_COUNTER_LIST( string, array, nmax, status )
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*

* return a list of values for a counter (REPEAT/RANGE=string ) where
! string is the string, e.g. 10:1000:100

* ACM
* As in counter_var_context, without error checking since it has
* already been done in that routine.
* V554: *acm* 1/4

        IMPLICIT NONE
* calling argument declarations
	INTEGER		nmax, status
	REAL		array(nmax)
	CHARACTER*(*)	string

* internal variable declarations:

        INTEGER		TM_LENSTR, ATOM_POS,  slen, 
     .                  colon_pos, colon2_pos, lo_start, lo_end, hi_start, 
     .                  hi_end, dum, xlo, xhi, n
        LOGICAL         colon, colon2, fmat, use_subscripts
        REAL*8          ss_answer		

	include 'ferret.parm'
	include 'errmsg.parm'

* set the limits

        slen = TM_LENSTR(string)

* ... ":"
        lo_start = 1
        colon = .FALSE.
	colon_pos = ATOM_POS( string, ':' )
	lo_end	 = colon_pos - 1

*  ... second ":"

        colon2 = .FALSE.
	colon2_pos = ATOM_POS(string( colon_pos+1:slen ), ':' )
	colon2 = colon2_pos .NE. atom_not_found
	IF ( colon2 ) THEN
	   colon2_pos = colon2_pos + colon_pos
           hi_end     = colon2_pos - 1
	ELSE
	   hi_end     = slen
        ENDIF
	hi_start      = colon_pos + 1

* Call translate_limit to check syntax and set ss limits

        use_subscripts = .TRUE.
        dum = 1

	CALL TRANSLATE_LIMIT
     .		      (  string(lo_start:lo_end), x_dim,
     .			use_subscripts,
     .			ss_answer, fmat, dum, status )
        xlo = INT(ss_answer)

	CALL TRANSLATE_LIMIT
     .		      (  string(hi_start:hi_end), x_dim,
     .			use_subscripts,
     .			ss_answer, fmat, dum, status )
        xhi = INT(ss_answer)

        DO 100 n = xlo, xhi
           array(n) = n
  100   CONTINUE

* success
 1000	status = ferr_ok
	RETURN
        END

	SUBROUTINE TDEST_WORLD_INIT ( src_grid, dst_grid, idim, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Initialize COMMON in preparation for time coordinate conversion calls to
* TDEST_WORLD (see detailed docs in tdest_world.F)

* This routine exists to optimize performance in converting between time axes

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V312:  6/2/94
* V530: *acm* 12/00 alternative calendar types; cal_id
*             return source and dest cal_ids for get_linear_coef
* V673: *acm*  2/12 see ticket 1915. All computations of these factors need 
*             to be done in DOUBLE precision.
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction. 
* V695+ *sh* 5/15 calendar factor adjustments only if src/dst calendars differ
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.

	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xunits.cmn_text'
	external xunits_data
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xregrid.cmn'

* calling argument declarations:
	INTEGER	src_grid, dst_grid, idim, status

* internal variable declarations:
	LOGICAL TM_DATE_OK, ITSA_TRUEMONTH_AXIS
	INTEGER	TM_GET_CALENDAR_ID ,
     .          src_line, dst_line, src_cal_id, dst_cal_id
	REAL	CAL_FACTR
	REAL*8  SECS_FROM_BC, at0src, at0dst, usrc, udst, factor

* initialize
	tcnvrt_ok = .FALSE.
	cnvrt_src_grid = src_grid
	status = ferr_ok

* first check to see if calendar-based regridding between these two grids
* is possible
	IF ( src_grid .EQ. unspecified_int4
     .	.OR. dst_grid .EQ. unspecified_int4 ) STOP 'TDEST_WORLD_INIT'

	src_line = grid_line( idim, src_grid )
	dst_line = grid_line( idim, dst_grid )

        src_cal_id = TM_GET_CALENDAR_ID ( line_cal_name(src_line) )
        dst_cal_id = TM_GET_CALENDAR_ID ( line_cal_name(dst_line) )


	IF ( src_line .EQ. mnormal .OR. src_line .EQ. munknown
     .	.OR. dst_line .EQ. mnormal .OR. dst_line .EQ. munknown )
     .		CALL ERRMSG( ferr_internal, status,
     .				'date regrid on missing T axis', *5000 )
	IF ( line_direction(src_line) .NE. 'TI'
     .	.OR. line_direction(dst_line) .NE. 'TI' ) THEN
	   IF ( line_direction(src_line) .NE. 'FI'
     .	   .OR. line_direction(dst_line) .NE. 'FI' ) RETURN
        ENDIF

	IF ( .NOT. (TM_DATE_OK(line_t0(src_line), src_cal_id) 
     .	       .AND.TM_DATE_OK(line_t0(dst_line), dst_cal_id)) ) RETURN

* determine the units and absolute T0 for the two axes
	usrc = un_convert( line_unit_code(src_line) )
	IF ( ITSA_TRUEMONTH_AXIS(src_line) ) usrc = un_convert(pun_day)
	udst = un_convert( line_unit_code(dst_line) )
	IF ( ITSA_TRUEMONTH_AXIS(dst_line) ) udst = un_convert(pun_day)

	at0src = SECS_FROM_BC( line_t0(src_line), src_cal_id, status )
	IF ( status .NE. ferr_ok ) RETURN
	at0dst = SECS_FROM_BC( line_t0(dst_line), dst_cal_id, status )
	IF ( status .NE. ferr_ok ) RETURN

	IF (dst_cal_id .NE. src_cal_id) THEN
* ... make non-Gregorian calendar adjustments only if calendars differ
*     to avoid small roundoff issues
           IF (dst_cal_id .NE. 1) THEN
              factor = CAL_FACTR (dst_cal_id)
	      udst = udst* factor
	      at0dst = at0dst* factor
	   ENDIF

           IF (src_cal_id .NE. 1) THEN
	      factor = CAL_FACTR (src_cal_id)
	      usrc = usrc* factor
	      at0src = at0src* factor
	   ENDIF
	ENDIF

* determine the slope and intercept to be used in TDST_WORLD regridding
	tcnvrt_slope = usrc/udst
	tcnvrt_intercept = (at0src-at0dst) / udst

* success
	tcnvrt_ok = .TRUE.
	RETURN

* error exit
 5000	RETURN
	END

	INTEGER FUNCTION TM_SUBSC ( world_coord, grid, idim, clue )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* convert a "world" coordinate into the subscript value on an axis by finding
* the grid box that contains the world coordinate.
* A clue may be provided to speed processing of irregular axes

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 -  12/9/90 - based on FERRET's TM_SUBSC version 2.00
* NOTE: as of 9/90 regular axes have NOT been tested
* 1/95 *sh* inserted support for modulo axes from FERRET's ISUBSCRIPT
* 10/95 - use TM_WORLD instead of direct line_mem to support recursive cases
*  1/96 - many references to isub0 remained despite 10/95 changes
* *kob* 10/96   - Linux port.  Linux didn't like tabs between "include"
*                 and what was being included.  removed them
* V542 2/02 *sh* - added support for modulo length > axis length
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files
* V71  3/16 *acm* Ticket 2158: working with true monthly time axes.
* V71  1/17 *acm* Ticket 2496: make the result index consistent with the
*                 result form isubscr_cx when incoming coordinate value
*                 is ON a cell boundary

* calling arguments:
* world_coord	- coordinate value to be translated to subscript
* grid		- underlying grid number
* idim		- underlying axis number (1-nferdims)
* clue		- performance assist to code - check this as possible result

	include 'tmap_dims.parm'
#include "gt_lib.parm"
	include 'xtm_grid.cmn_text'
	external xgt_grid_data


* calling argument declarations:
	INTEGER	grid, idim, clue
	REAL*8	world_coord

* internal variable declarations:
	LOGICAL	TM_ITS_SUBSPAN_MODULO, ITSA_TRUEMONTH_AXIS, TM_DFPEQ, regular
	INTEGER	lo_look, hi_look, ibot, itop, look, axis,
     .		line_len, isubsc
	INTEGER	num_mod
	REAL 	subsc
	REAL*8	TM_WORLD, TM_WW_AXLEN,
     .		half_way, start, aend, span, first, last, wcoord, wwindex

* we need to be able to modify the search value for modulo axes
	wcoord = world_coord

* which axis are we on ?
	axis    = grid_line ( idim, grid )
	line_len = line_dim( axis )

* special consideration for sub-span modulo axis outside its core range
	IF (TM_ITS_SUBSPAN_MODULO(axis) ) THEN
	   CALL TM_WW_AX_1_N(axis, start, aend)
	   IF ( wcoord.LT.start .OR. wcoord.GT.aend ) THEN
	      line_len = line_len + 1
	      regular = .FALSE.
	   ELSE
	      regular = line_regular(axis) .AND. .NOT.ITSA_TRUEMONTH_AXIS(axis)
	   ENDIF
	ELSE
	   regular = line_regular(axis) .AND. .NOT.ITSA_TRUEMONTH_AXIS(axis)
	ENDIF

* initialize pointers for axes with irregularly spaced points
	IF ( .NOT.regular ) THEN
	   IF ( clue.GE.1 .AND. clue.LE.line_len ) THEN
	      wwindex = TM_WORLD(clue, grid, idim, box_middle)
* ... check clue - (clue accepted only for exact equality of coordinates)
	      IF ( wcoord .EQ. wwindex ) THEN
	         TM_SUBSC = clue
	         RETURN
	      ENDIF
	   ENDIF
	   ibot  = 1
	   itop  = line_len
	ENDIF

* Modulo axis: translate world coord to within axis range
        IF ( line_modulo( axis ) ) THEN
* ... begin by computing axis limits as outer edges of end boxes
	   span = TM_WW_AXLEN(axis)
	   CALL TM_WW_AXLIMS(axis, start, aend)
	   IF (TM_ITS_SUBSPAN_MODULO(axis)) THEN
	      span = line_modulo_len(axis)
	      aend = start + span
	   ENDIF

* ... now translate wcoord to within axis limits saving modulo number
           IF     ( wcoord .GT. aend  ) THEN
              num_mod = ( wcoord - start ) / span
! 10/92 bug fix: if wcoord is an exact multiple of length (e.g. wccord=24.
!       start=0., span=12.) then modulo remap to top of ax rather than bottom
              IF ( wcoord .EQ. start+num_mod*span )
     .                          num_mod = num_mod - 1
           ELSEIF ( wcoord .LT. start ) THEN
              num_mod = ( wcoord - aend  ) / span               ! (negative)
           ELSE
              num_mod = 0
           ENDIF
           wcoord = wcoord - num_mod*span
        ENDIF

* get positions of first and last points on axis
	IF ( regular ) THEN
	   first = line_start( axis )
	   last  = first + line_delta( axis ) * line_len
        ELSE
           first = TM_WORLD(       1, grid, idim, box_middle)
           last  = TM_WORLD(line_len, grid, idim, box_middle)
	ENDIF

* immediate solutions for given point beyond axis ends
	IF ( wcoord .LE. first ) THEN
	   isubsc = 1
	ELSEIF ( wcoord .GE. last) THEN
	   isubsc = line_len

* quick sol'n if axis points are regularly spaced
	ELSEIF ( regular ) THEN
#ifdef double_p
	   subsc  = ( (wcoord-first)/line_delta(axis) ) + .5
#else
	   subsc  = SNGL( (wcoord-first)/line_delta(axis) ) + .5
#endif
	   isubsc = INT( subsc ) + 1		! round up if ambiguous

	ELSE
* binary search if axis points are irregularly spaced
* initialize search
	   lo_look  = ibot - 1
	   hi_look  = itop + 1	
	   look     = ( lo_look + hi_look ) / 2

* top of search loop
 100       wwindex = TM_WORLD(look, grid, idim, box_middle)
	   IF ( wcoord .GE. wwindex ) THEN

* answer is somewhere above current "look" position
* keep looking at higher values setting this as new low limit for search
	      lo_look = look
	      look = ( look + hi_look + 1 ) / 2

	   ELSE
* answer is somewhere below current "look" position
* keep looking at lower values setting this as new high limit for search
	      hi_look = look
	      look = ( look + lo_look ) / 2

	   ENDIF

* have we narrowed it to a 1 point range ?
	   IF ( hi_look - lo_look .LE. 1 ) THEN

* yes - we found it - choose box containing it
* Change the logic if the point is on the boundary, returning the lower index.
* This is consistent with what isubscr_cx does.

* ... box boundary between lo_look and hi_look
	      half_way = TM_WORLD(hi_look, grid, idim, box_lo_lim)

* value on box boundary ?
	      IF ( TM_DFPEQ( half_way, wcoord ) ) THEN
	         isubsc = lo_look
	      ELSE

* no. value in upper half of box ?
	         IF ( wcoord .GT. half_way ) THEN
	            isubsc = hi_look

* no. value must be in lower half of box (or on the box boundary)
	         ELSE
	            isubsc = lo_look

	         ENDIF
	      ENDIF
	   ELSE

* no - keep looking
	      GOTO 100
	   ENDIF
	ENDIF

* insert modulo axis correction
        IF ( line_modulo(axis) ) THEN
           TM_SUBSC = isubsc + num_mod*line_len
        ELSE
           TM_SUBSC = isubsc
        ENDIF

	RETURN
	END

	SUBROUTINE MINSMOOTHER_DSG( idim, wlen, dset, nfeatures, 
     .				com, com_mr, com_cx,
     .				res, res_mr, res_cx, 
     .				list )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Compute the minimum of the requested length, along axis idim
* for data on Distributed Sampling Geometries grids
* note: the component context may not be of adequate size for the full
*	calculation.  Missing data flags will be inserted where computation is
*	impossible. If there is any data present in the window, the minimum
*       is computed based on that data. Minima are computed with the data
*       that is available in partial windows at the edges of the domain. 

* Ansley Manke
* NOAA/PMEL, Seattle, WA - Science Data Integration Group
*  3/2019
* V76   1/20 *acm* Orientation of Point-type data set to e_dim


        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include	'xdset_info.cmn_text'
	include 'xdyn_linemem.cmn_text'

* calling argument declarations:
	INTEGER	idim, wlen, dset, nfeatures, 
     .		com_mr, com_cx, res_mr, res_cx
	REAL	com   ( * ),
     .          res   ( * ), 
     .          list(*)

* internal variable declarations:
	LOGICAL fmask(nfeatures)
	INTEGER	i, ii, ndx, lo_lim, hi_lim, hlen, ifeature, iobs,
     .          flen, base, orientation, row_size_lm
	REAL    bad_com, bad_res, comp, cmin

* initialize
	bad_com = mr_bad_data( res_mr )
	bad_res = mr_bad_data( com_mr )

	hlen = wlen/2
	IF ( MOD(wlen,2) .EQ. 0)  hlen = (wlen+1)/2
	

* DSG-specific initialize
	orientation = dsg_orientation(dset)
	row_size_lm = dsg_loaded_lm(dsg_row_size_var(dset))

* get feature mask
        CALL MAKE_DSG_FEATURE_MASK(dset, res_cx, fmask, nfeatures)

	
* ****** PERFORM THE COMPUTATION *****

	IF (idim.EQ.orientation .AND. orientation.LE.t_dim) THEN 
* *** true ragged array processing:
* convolve independently along each feature
*     Work with all data in the feature. WW coordinate masking etc  
*     will be applied beforelisting or plotting

           base = 0    ! obs index at end of preceding feature
* ... loop over the features
	   DO ifeature = 1, nfeatures 

	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length

* ... have the user's constraints removed this feature?
	      IF (.NOT.fmask(ifeature)) THEN
                 base = base + flen
                 CYCLE
              ENDIF
	      
              lo_lim = 1
              hi_lim = flen

* ... loop over the observations within each feature
              iobs = base
	      DO i = 1, flen
	         iobs = iobs + 1

* ... convolve the neighboring points with the weights

	         cmin = ABS(bad_com)
	         ndx = 0
	         DO ii = -hlen, hlen
* ... test limits of component data before using
                    IF ( i+ii .GE. lo_lim
     .             .AND. i+ii .LE. hi_lim ) THEN
                       comp = com(iobs+ii)
                    ELSE
                       comp = bad_com
                    ENDIF

                    IF ( comp .NE. bad_com ) THEN
                       cmin = MIN(cmin, comp)
                       ndx = ndx + 1
                    ENDIF
	         ENDDO

	         IF (ndx .EQ. 0) THEN 
                    res(iobs) = bad_res
	         ELSE
                    res(iobs) = cmin
	         ENDIF

	      ENDDO
	      base = base + flen
	   ENDDO

	ELSE

* *** a simple list of instances:
* Process all features -- ignoring mask -- for the reasons stated in the intro

	   lo_lim = 1
	   hi_lim = nfeatures

	   DO ifeature = 1, nfeatures 

	      ndx = 0
	      DO ii = -hlen, hlen
* ... test limits of component data before using
                 IF ( ifeature+ii .GE. lo_lim
     .          .AND. ifeature+ii .LE. hi_lim ) THEN
                    comp = com(ifeature+ii)
                 ELSE
                    comp = bad_res
                 ENDIF
		 
                 IF ( comp.NE.bad_com .AND.comp.NE.dsg_masked_out_flag) THEN
                    cmin = MIN(cmin, comp)
                    ndx = ndx + 1
                 ENDIF

	         IF (ndx .EQ. 0) THEN 
                   res(ifeature) = bad_res
	         ELSE
                   res(ifeature) = cmin
	         ENDIF

	      ENDDO

	   ENDDO

	ENDIF

	RETURN
	END

	SUBROUTINE TM_Parse_String ( instr, ndim, outary, nvals )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Will take the input string "instr" and separate the individual items at space,
* tab, or commas. It will place the items in array outary, which is dimensioned
* ndim, and then return number of items found in nvals. If more than ndim items
* are found, then only ndim items will be saved, although total number of items
* found will be reported in nvals.
*
* revision 0.00 - 08/14/89
*
* 10/96 *kob* - Linux port - had to move variable assignments off of
*		declaration line.

* Arguments:
*	instr	- input string containing items to be parsed
*	ndim	- dimension of outary
*	outary	- array where individual items are stored
*	nvals	- number of items found in instr
*
	INTEGER*4	ndim, nvals
	CHARACTER*(*)	instr, outary(ndim)
*
* Local definitions
* *kob* explicit definitions not allowed on decl line in linux...
*       moved it to parameter line 10/96
	CHARACTER*1	blank, comma, tab
	PARAMETER      (blank = ' ',
     .                  comma = ',',
     .                	tab = 	'	')
	INTEGER*4	ilen, pos, start
*
* Initialize
	nvals = 0
	ilen = LEN(instr)
	pos = 1
*
* Locate non-blank, non-comma, non-tab
  100	IF (pos .GT. ilen) GOTO 900
	IF ( instr(pos:pos) .NE. blank .AND.
     .	     instr(pos:pos) .NE. comma .AND.
     .	     instr(pos:pos) .NE. tab         ) THEN
	  start = pos
	  GOTO 200
	ENDIF
	pos = pos + 1
	GOTO 100
*
* Found start of item, find blank, comma, or tab to locate end of item
  200	IF ( instr(pos:pos) .EQ. blank .OR.
     .	     instr(pos:pos) .EQ. comma .OR.
     .	     instr(pos:pos) .EQ. tab         ) GOTO 300
	pos = pos + 1
	IF (pos .GT. ilen) GOTO 300
	GOTO 200
*
* Found end of item, store it.
  300	nvals = nvals + 1
	IF (nvals .LE. ndim) outary(nvals) = instr(start:pos-1)
	GOTO 100
*
* End of string
  900	RETURN
	END

	SUBROUTINE EXTRACT_LINE_FAST( axis, block, bad_flag, i, j, l, m, n,
     .		cxloz, cxhiz,
     .		slox, shix, sloy, shiy, sloz, shiz, 
     .		slot, shit, sloe, shie, slof, shif,
     .		zline, klo, khi )


*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Extract a single line of data from a memory variable grid.
* Identify contiguously valid data region and report in klo, khi

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V690:  12/13 *sh* derived from EXTRACT_Z_LINE

* calling argument declarations:
	INTEGER axis,
     .		slox, shix, sloy, shiy, sloz, shiz, slot, shit,
     .		sloe, shie, slof, shif, i, j, l, m, n, 
     .		klo, khi, cxloz, cxhiz
	REAL    bad_flag,
     .		block( slox:shix,sloy:shiy,sloz:shiz,
     .		       slot:shit,sloe:shie,slof:shif ),
     .		zline(cxloz:cxhiz)

* internal variable declarations:
	LOGICAL	searching_for_valid
	INTEGER k

* initialize
	searching_for_valid = .TRUE.

* initialize
	klo = 0		! if unchanged at end signals no valid data found
	khi = 0

* extract the line
	DO 100 k = cxloz, cxhiz
 100	zline(k) = block(i,j,k,l,m,n)

* find the start and end of valid data
	DO 200 k = cxloz, cxhiz

* ... skip invalid values at start of line
	   IF ( searching_for_valid ) THEN
	      IF (zline(k) .EQ. bad_flag) GOTO 200
	      searching_for_valid = .FALSE.
	      klo = k
* ... terminate if invalid point encountered after valid points
	   ELSEIF ( zline(k) .EQ. bad_flag ) THEN
	      khi = k-1
	      GOTO 300
	   ENDIF

 200	CONTINUE
	khi = cxhiz

* successful completion
 300	RETURN
	END

      SUBROUTINE key_lo_inf_vert (px, py, ndx, v_inc,
     .          annotate_key, lab_digits, height)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Make the lowest box (triangle) for the color key when the low level is 
* value-to-minus-infinity
*
*  v581 *acm* 3/05 open levels (-INF) (INF)
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus
* V685 *acm* 5/13  changes for ribbon plots
* V674+ *acm* 10/18 Do not use a so many digits for key annotations

      INCLUDE 	'parampl5_dat.decl'
      INCLUDE 	'PARAMPL5.DAT'
      INCLUDE   'cont_inc.decl'
      INCLUDE	'CONT.INC'           ! with cont_key
      INCLUDE	'axis_inc.decl' 
      INCLUDE	'AXIS.INC'           ! with xorg, yorg
      INCLUDE	'PLTL.INC'           ! with makep
      INCLUDE	'hd_inc.decl'
      INCLUDE	'HD.INC'             ! with zmin, zmax


* Calling arguments
      REAL px(*),py(*), h_inc, height
      INTEGER ndx, annotate_key, lab_digits

* Internal declerations
      INTEGER maxlen, slen, ldigits
      REAL x1, x2, x3, x4, y1, y2, y3, y4
      REAL delx, xx, yy, xxx, yyy
      CHARACTER TM_FMT_SNGL*48, text*10

* save px and py values
      y1 = py(1)
      y2 = py(2)
      y3 = py(3)
      y4 = py(4)

      x1 = px(1)
      x2 = px(2)
      x3 = px(3)
      x4 = px(4)

* triangle.

      delx = x3 - x1

      px(1) = px(1) + delx/2.
      px(2) = x3
      px(3) = x4

      py(1) = py(3) - v_inc
      py(2) = py(3)

*	   CALL FILL AREA FOR THIS COLOR/GRAY VALUE
       call set_fill_ndx (ndx)
       call gfa (3,px,py)

* Outline
       px(4) = px(1)
       py(4) = py(1)
       IF (.NOT. cont_key) call gpl (4,px,py)
 
* Annotate min
      IF (annotate_key .GT. 0) THEN
         maxlen = 10
         ldigits = lab_digits+1
         text = TM_FMT_SNGL(zmin,ldigits,maxlen,slen)
	 xx = px(1)/1000.0 - xorg - (slen/2)* height
         yy = py(1)/1000.0 - yorg - 1.5* height
	 
* FILL AND SHADE USE DIFFERENT COORD SYSTEMS -- *jd* 6.4.93
         if (makep .eq. 'SHADE' .or. makep .eq. 'FILLPOL' .OR.
     .         makep .EQ. 'POLYGON' .or. makep .eq. 'RIBPLOT') then
	    call point_convert (xx,yy,xxx,yyy)
         else if (makep .eq. 'FILL') then
	    xxx = xx
	    yyy = yy
         endif

         call symbel (xxx,yyy,0.,height,slen,text(1:slen))
      ENDIF

* Restore px, py

      py(1) = y1
      py(2) = y2
      py(3) = y3
      py(4) = y4

      px(1) = x1
      px(2) = x2
      px(3) = x3
      px(4) = x4

      RETURN
      END

	SUBROUTINE TM_DSG_FACTS( grid, orientation, obsdimlen, 
     .			feature_line, is_dsg )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* return the feature orientation and netCDF dim length of the observations
* in a DSF file
* THIS ROUTINE SHOULD ONLY BE CALLED FOR GRIDS KNOWN TO BE DSG 

* V720 *sh* 4/17
* V74+ *acm* 9/18 Allow an abstract axis (e.g. merging grids)

      include 'netcdf.inc'
      include 'tmap_errors.parm'
      include 'tmap_dims.parm'
      include 'implicit.parm'
#include "gt_lib.parm"
      include 'xtm_grid.cmn_text'
      include 'xdset_info.cmn_text'
      include 'xfr_grid.cmn'

* argument declarations
	LOGICAL is_dsg
	INTEGER grid, orientation, obsdimlen, feature_line

* internal variable declarations
	INTEGER e_line, dset, mabstract, status

* the E axis points to the DSG orientation. 
* Or is this even a dsg grid? The dataset may be dsg, but what if we're just 
* defining some other variable, maybe defining a mask.

	e_line = grid_line(e_dim,grid)
	mabstract = grid_line( x_dim, mgrid_abstract )

	IF (e_line.EQ.mpsnorm .OR. e_line.EQ.mabstract) THEN
	   is_dsg = .FALSE.
	   GOTO 9999
	ENDIF

	dset = line_dsg_dset(e_line)
	
* this only happens if the programmer made an error
	IF (dset .EQ. pline_not_dsg) STOP 'TM_DSG_FACTS'

	orientation = dsg_orientation(dset)

	feature_line = grid_line(orientation,grid)

	obsdimlen = dsg_obs_dimlen(dset)

* success
        RETURN

* unreported error -- just a message
 9999	RETURN
 5100	CALL TM_ERRMSG (merr_undefline, status, 'TM_DSG_FACTS',
     .                       no_descfile, no_stepfile,
     .                       no_errstring, no_errstring, *9999)

        END

	CHARACTER*(*) FUNCTION LOHI_WORLD( idim,cx,to_word,full_prec,slen )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* create a string describing the world coordinate boundaries along an axis
* for example: 160E:140W or 10m (if lo depth = hi)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 9/26/87
* revision 0.1 - 2/25/88 - changed TRANSLATE_TO_WORLD call to allow non-lat/long
*			   formatting.
* revision 0.2 - 3/25/88 - number of decimals set in SET MODE command
*			   and possibly reverse ordering of time limits since
*			   stored times may be tsteps (for a particular T axis)
*			   or -1*(secs_from_BC)  (independent of partic. axis)
* revision 0.3 - 8/12/88 - negative times not converted to time steps
* revision 1.0 -  1/10/89- split off actual string creation into LOHI_STRING
* V200:  5/19/89 - 4D symmetrical - point limits have ww coords at box edges 
*	 3/22/90 - for cx.LE.cx_last use last successful grid
*	 9/11/90 - corrected bug: IF test treated cx_buff as a stored region
* V300:   2/3/93 - the 9/11/90 bug fix prevents the default region for being
*                  formatted
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
* V690 *sh* 1/14 - added kludge to display limits from aux var regrid by avg
* V698  *acm* 5/16 Ticket 2405: MODE CALENDAR:auto
* V698 *sh* 4/16 hack to format E axis limits as integers
*	         Note:  this is a poor fix.  See 4/16 note below

	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include 'xcontext.cmn'
	include 'xprog_state.cmn'
	include 'xvariables.cmn'	! added 3/90
	include 'xfr_grid.cmn'		! added 3/90
	include 'xunits.cmn_text'

* calling argument declarations
	LOGICAL	full_prec
	INTEGER	idim, cx, slen
	CHARACTER*(*) to_word

* internal variable declarations:
	LOGICAL	SCALAR_GRID_LINE, aux_span_compress, its_float
	INTEGER	DATE_PREC, sub_len, ndec, grid, line, status, 
     .          cx_try, cat, var, loss, hiss, delss, j, decimal
	REAL*8	TM_WORLD, BOX_SIZE, bc_to_t0, lo, hi, small
	CHARACTER*40	LOHI_STRING

* initialize
	IF (cx .GE. 1) THEN
	   aux_span_compress = cx_unstand_grid(cx)
     .			 .AND. cx_regrid_trans(idim,cx) .EQ. pauxrgrd_pwlave
	ELSE
	   aux_span_compress = .FALSE.
	ENDIF

* grid number is used to determine formatting option
* ( cx<0 for stored (named) regions )  (cx=cx_last for default region)
* 2/93 - treat cx_last like stored regions
* 2/93 - expanded the logic for finding **some** grid to use when their
*        isn't one - search up the context stack
        IF ( cx .LE. 0 .OR. cx .EQ. cx_last ) THEN
           cx_try = is_cx( 1 )
           IF ( cx_try.EQ.0 .OR. cx_try.EQ.unspecified_int4 ) THEN
              grid = unspecified_int4
           ELSE
              grid = cx_grid( cx_try )
           ENDIF
* ... desperation search added 2/3/93
* don't know why is_cx(1) isn'r reliable (havn't checked)
           IF ( grid .EQ. unspecified_int4 ) THEN
              DO 100 cx_try = cx_cmnd+1, cx_cmnd+5   ! arbitrary limit
                 grid = cx_grid( cx_try )
                 IF ( grid.NE.0 .AND. grid.NE.unspecified_int4) GOTO 200
 100          CONTINUE
           ENDIF
        ELSE
           grid = cx_grid( cx )
        ENDIF
	IF ( grid .EQ. unspecified_int4 ) grid = mgrid_abstract

* is this just a single grid box with the world coord box edges given ?
* 1/14: for gz(depth)=0:100@ave we have a valid single point target axis
* on which we want to document the axis limits (in cx_lo/hi_ww), rather
* than the point coordinate.  Look at cx_regrid_trans to decide.
 200	   IF ( cx_lo_ss(cx,idim) .NE. unspecified_int4
     .	.AND.cx_lo_ss(cx,idim) .EQ. cx_hi_ss(cx,idim) 
     .	.AND. .NOT.aux_span_compress				) THEN
	   lo = TM_WORLD( cx_lo_ss(cx,idim),grid, idim, box_middle )
	   hi = lo
	ELSE
	   lo = cx_lo_ww( idim, cx )
	   hi = cx_hi_ww( idim, cx )
	ENDIF

* hack for E axis positions, so @AVE gets labeled with integer index nos
* *sh* 4/16 - this is a poor place to have fixed this problem
*     better would be to create the concept of an "enumerated axis", which
*     should always be represented as an integer position.  A quick way to
*     do this is to create ITSA_ENUMERATED_AXIS, which (for now) answers .TRUE.
*     only for E axes with units of plag_ax_units_e = 'realization'
*     (This can be expanded later as more enumerated cases arise.)
*     Then in TM_WORLD when returning a coordinate on an enumerated axis ignore
*     box_lo_lim and box_hi_lim, returning box_middle (the integer position)
	its_float = lo .NE. INT(lo)
	IF (its_float .AND. idim.EQ.E_dim) THEN
	   line = grid_line(idim,grid)
	   IF ( (cx .GT. cx_buff)
     .    .AND. line_units(line).EQ.plag_ax_units_e ) THEN
	      cat = cx_category(cx)
	      var = cx_variable(cx) 
	      IF (cx_trans(idim,cx) .GT. trans_compress_code
     .	   .OR.   (cat.EQ.cat_user_var
     .       .AND. SCALAR_GRID_LINE(idim, grid, cat, var)) ) THEN
	         lo = lo + 0.5
	         hi = hi - 0.5
	      ENDIF
	   ENDIF
	ENDIF

* determine precision level for output string
	IF ( full_prec ) THEN
	   ndec = ax_dec_pt( idim )
	ELSE
	   ndec = 0
	ENDIF
	
* What precision is needed to represent this delta and world range ?
* Will write time string according to the resolution of the time axis
* Uses same method as for text listings

	decimal = ndec
	IF (idim.EQ.t_dim .AND. ABS(ndec).GT.6) THEN
	   loss = cx_lo_ss(cx,idim)
	   hiss = cx_hi_ss(cx,idim)
	   delss = 1
	   IF (loss .NE. unspecified_int4) delss = cx_delta (idim,cx)

* how large is the smallest "delta" world coordinate to represent ?
	   small = +1.E33
	   IF (line_delta(grid_line( idim, grid )) .NE. unspecified_val8) THEN
              small = line_delta( grid_line(idim, grid) )
	   ELSE
 	      DO j = cx_lo_ss(cx,idim), cx_hi_ss(cx,idim), delss
	         small = MIN( small, BOX_SIZE( j, grid, idim ) )
 	      ENDDO
	   ENDIF

	   decimal = DATE_PREC( grid, idim, small )
	   decimal = decimal + 1
	ENDIF

* create the string
	LOHI_WORLD = LOHI_STRING( lo,hi,idim,grid,to_word,decimal,slen )
	
	RETURN
	END

	SUBROUTINE PLOTXY_RIBBON(X,NXS,XF,YF)
C** 
C**    @(#)plotxy.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C  ARRAY X HOLDS X AND Y'S FOR ALL LINES.  DIMENSIONED FOR NXS.
C  ORDER AS FOLLOWS:  ALL X'S FOR LINE1, ALL X'S FOR LINE2,...
C                     STARTING AT X(NXS/2+1), ALL Y'S FOR LINE1,
C                     ALL Y'S FOR LINE2...
C  XF AND YF ARE FACTORS TO CONVERT TO INCHES FROM USER UNITS
C  
C  Ribbon Plots: lines colored by a variable along the line.
C  8/2012 ACM
C  For a ribbon plot, x's are at the start, Y1 are the Y values, and
C  Y2 are values by which to color the lines.
C
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

*  ACM 10/2012    Modulo-ing for PLOT/VS longitudes overlaid on a map.
* 1/2013  *acm* Fix ticket 2029, call to WS_LINE_SPECTRUM was missing an 
*               argument for setting up metafile plots.
*  ACM  2/2013    ticket 2141. Fix the modulo operation when the longitude
*                 range is over 360.
* ACM   5/2014  Fixes for changes of color in combination with handling
*               modulo longitude data
* V6.92 *acm* 6/14 New color /key options: any of /key=horizontal,centerlabel
* V6.94 *acm* 1/15 fix ticket 2216: when using (-inf), a color-by variable
*                  starting with missing was colored incorrectly.
* V6.94+ *acm* 3/15 Ticket 2247: singleton points in line plots marked with a dot
* v696 *acm*   6/15 PLOT/VS/RIBBON/GAPLOC to define seperate line segments on
*                   color PLOT/VS plots (LAS ticket 1597 and others)
* V698  4/16 *acm* New PLOT/NTH=

        include         'xinterrupt.cmn' ! 1/89 *sh*
        include         'ppl_in_ferret.cmn'

	INTEGER NXS
	REAL X(*), XS, YS

        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'axis_inc.decl'
        include 'AXIS.INC'
        include 'lines_inc.decl'
        include 'LINES.INC'
        include 'pen_inc.decl'
        include 'PEN.INC'
        include 'pltl_inc.decl'
        include 'PLTL.INC'
        include 'hd_inc.decl'
        include 'HD.INC'
        include 'miss_inc.decl'
        include 'MISS.INC'
        include 'taxis_inc.decl'
        include 'TAXIS.INC'
        include 'axisl_inc.decl'
        include 'AXISL.INC'
        include 'cmrd_inc.decl'
        include 'CMRD.INC'
	include 'gkscm1_inc.decl'   
	include 'GKSCM1.INC'
        include 'gkscm2.cmn'
        include 'gkspar.inc'
        include 'shade_vars.cmn'
        include 'makedot.cmn'
	include 'cont_inc.decl'
	include 'CONT.INC'

	REAL datum, xlast, ylast, frac, dx, dy, xi, yi, xhalf, yhalf
	INTEGER xpolybase, ypolybase, zpolybase, polysizemax, nl,
     .		nvertex, low_index, colr_ndx, last_colr_ndx, ncolors, 
     .		line_ndx, thick_offset, nseg, iseg, indx, inc, nskp, idec
	INTEGER GET_NDX, ibase, iline2, ilineg

	logical	isbad, last_bad, bad_blank, new_branch, md

        real            xadd, xaddlast, datx, daty, datxlast,datylast
        integer         ndx,type
	
	INTEGER		klast, mdot
	REAL		xtlast, ytlast


* GKS initialization vars
	integer		error,trans_no,cflag
        integer         my_trans
        data            my_trans/20/
	real	 	w(4),v(4),ndc(4),uc(4)
	real		xinv,yinv

*************************************

	nl = lnum

	xadd = 0.
	xadlast = 0.
	new_branch = .FALSE.
	MDOT = 99
C
C  JTYPE IS DATA TYPE (0 FOR 2D, 1 FOR 1D)
C
	IF(JTYPE.NE.1) RETURN
	I = 1

	IBASE=0
	IY=NXS/2
	CS=COS(VANG*.01745329252)
	SN=SIN(VANG*.01745329252)
	ZT=YF/XF
	ICNT=1
	IF(M.GE.2.AND.IFLG(2).NE.0)ICNT=P(2)

* Line 2 contains the variable on which to color. ZMAX and ZMIN are its 
* range.  Set levels and set up color line bundles.

C  Set the contour/color levels

	CALL SET_LEVELS_SHADE_FILL (status)
	shd_levels = MAX (nlev2-1,1)  ! as in shade_sub
	
* DETERMINE COLORS TO SET BUNDLED LINE REPRESENTATIONS
	CALL WS_LINE_SPECTRUM (wsid,wstype, low_index)

        IF (meta_actv .AND. .NOT. meta_clsplt) 
     .     CALL WS_LINE_SPECTRUM (meta_wsid,meta_wstype, low_index)

* For plotting missing values of the color-by variable.
* Code -1 is for the default, thin black line (or gray? Set in ws_line_spectrum)
* Code -2 is to lift the pen and make the segment blank.
* If a palette, then use the first color. This was set up in ws_line_spectrum.

	bad_blank = .FALSE.
	IF (ribbon_miss(1) .EQ. -2) THEN 
	   bad_blank = .TRUE.
	ENDIF

        ILINE2=IBASE+LLENG(I)
        ILINEG=IBASE+2*LLENG(I)
        igap = 0

C set decimation for symbols
        nskp = MAX(1,nskpsym(i))

        CALL MARKH(HMARK(I))

* IPEN contains the thickness setting.

	  ncolors = shd_levels
	  if (rgb_mapping .eq. by_level) ncolors = ncl

	  thick_offset = 0
	  IF (ipen(i) .EQ. 2) thick_offset = (ncolors+1) 
	  IF (ipen(i) .EQ. 3) thick_offset = 2*(ncolors+1) 

C     SET PLOT MODE

* standard line or point plot

	    IF(ITYPE(I).GE.4)THEN ! JD 3.22.89
	      CALL DASHSZ(DN1(I),UP1(I),DN2(I),UP2(I))
	      CALL DASHES
	    ELSE
	      CALL VECTRS
	    END IF
	    IF(ITYPE(I).EQ.3)THEN 
               CALL POINTS
               IF (imark(i) .eq. 99) ipt = 0
            ENDIF
	    IF(.NOT.(XLE.OR.XEQ.OR.XGE.OR.YLE.OR.YEQ.OR.YGE))THEN
C     DO NOT CHECK POINTS FOR MISSING DATA
	      CALL TRANS(I,X(IBASE+1),X(IY+IBASE+1),XT,YT)
	      CALL PLOT(XT,YT,0,0)
	      IF(ITYPE(I).NE.0.AND.ITYPE(I).NE.4)CALL MARK(IMARK(I))
	      IM=0
	      IF(ITYPE(I).EQ.1.OR.ITYPE(I).EQ.3)IM=IMARK(I)
	      DO 60 J=IBASE+1,IBASE+LLENG(I)
	        CALL TRANS(I,X(J),X(IY+J),XT,YT)
	        CALL PLOT(XT,YT,1,0)
60            CALL MARK(IM)
	    ELSE
C     CHECK POINTS FOR OUT OF RANGE   (CM)
	      DO 70 J=IBASE+1,IBASE+LLENG(I)
* ... locate first point
		IF(XLE.AND.X(J).LE.CMXLE)GOTO 70
		IF(XEQ.AND.X(J).EQ.CMXEQ)GOTO 70
		IF(XGE.AND.X(J).GE.CMXGE)GOTO 70
		IF(YLE.AND.X(IY+J).LE.CMYLE)GOTO 70
		IF(YEQ.AND.X(IY+J).EQ.CMYEQ)GOTO 70
		IF(YGE.AND.X(IY+J).GE.CMYGE)GOTO 70
		
		last_bad = .FALSE.
		
		datum = X(IY+J+ILINE2)
		IF (datum .EQ. -3.E33) datum = CMZGE  ! This value set in pplldx.
		  
	        colr_ndx = GET_NDX (datum,colr_ndx)
		CALL SET_RIBBON_NDX (colr_ndx)

	        line_ndx = colr_ndx + thick_offset + low_index - 1
	        IF (colr_ndx .EQ. -999) THEN 
		   colr_ndx = bad_ribbon_ndx
		   line_ndx = colr_ndx + low_index - 1
		   last_bad = .TRUE.
		ELSE
		   nothing = 0
		ENDIF

		CALL COLOR (line_ndx) 
		last_colr_ndx = colr_ndx
	
	        datx = X(J)
	        daty = X(IY+J)
		IF (MOD_VS_X .AND. datx .LT. xlo) THEN
		   xadd = 360.
		   datx = datx + xadd
		ELSE IF (MOD_VS_X .AND. datx .GT. xhi) THEN
		   xadd = -360.
		   datx = datx + xadd
		ENDIF
		xaddlast = xadd

	        CALL TRANS(I,datx,daty,XT,YT)
	        CALL PLOT(XT,YT,0,0)
		xlast = xt
		ylast = yt
		isbad = .FALSE.
	        IF(ITYPE(I).NE.0.AND.ITYPE(I).NE.4)CALL MARK(IMARK(I))
 	        IM=0
	        IF(ITYPE(I).EQ.1.OR.ITYPE(I).EQ.3)IM=IMARK(I)
	        GOTO 71
70	      CONTINUE
71	      IDN=1
	      idec =  0
	      IF (last_bad .AND. bad_blank) IDN = 0
* ... plot remaining points
	      DO 72 K=J+1,IBASE+LLENG(I)
		IF((XLE.AND.X(K).LE.CMXLE).OR.
     *		   (XEQ.AND.X(K).EQ.CMXEQ).OR.
     *		   (XGE.AND.X(K).GE.CMXGE).OR.
     *		 (YLE.AND.X(IY+K).LE.CMYLE).OR.
     *		 (YEQ.AND.X(IY+K).EQ.CMYEQ).OR.
     *		 (YGE.AND.X(IY+K).GE.CMYGE))THEN

		  IF (IDN .EQ. 1 .AND. klast.EQ.k-1) THEN ! prev pt was a singleton
                      CALL PLOT(XTLAST,YTLAST,0,0)
                      CALL MARK(MDOT)
		  ENDIF

	          IDN=0
	        ELSE
		
	          CALL PLOT(XT,YT,IDN,0)

	          datx = X(K)
	          daty = X(IY+K)

* if 1, then this is the end of a segment. Draw to it, and pick up the pen.
		  IF (gap_var.GT.0) igap = INT(X(IY+K+ILINEG)) 

		  IF (MOD_VS_X .AND. datx .LT. xlo) THEN 
		     xadd = 360.
		     datx = datx + xadd

		  ELSE IF (MOD_VS_X .AND. datx .GT. xhi) THEN  
		     xadd = -360.
		     datx = datx + xadd

		  ELSE
		     xadd = 0.

		  ENDIF

		  IF (xadd .NE. xaddlast) THEN
		     datxlast = datx - xadd + xaddlast
		     CALL TRANS(I,datxlast,daty,XT,YT)
		     CALL PLOT(xt,yt,idn,0)
		     CALL TRANS(I,datx,daty,XT,YT)
		     CALL PLOT(XT,YT,0,0)
		     CALL PLOT(XT,YT,IDN,0)
		     new_branch = .TRUE.
		  ENDIF

	          CALL TRANS(I,datx,daty,XT,YT)
		  xaddlast = xadd

! in LINE/FAST mode go halfway between the last point and this one, using previous color.
	          IF (ITYPE(I).NE.3) THEN
		     xhalf = xlast + (xt - xlast)/2
		     yhalf = ylast + (yt - ylast)/2

		     IF ((.NOT.new_branch)) THEN 
		     IF (RIBBON_FAST .OR. last_bad) THEN 
                        IF (last_bad .AND. bad_blank) THEN 
		           CALL PLOT(xhalf,yhalf,0,0)
		        ELSE
		           CALL PLOT(xhalf,yhalf,IDN,0)
		        ENDIF
		     ENDIF
		     ENDIF
		  ENDIF

		  datum = X(IY+K+ILINE2)
		  IF (datum .EQ. -3.E33) datum = CMZGE  ! This value set in pplldx.
		  
	          colr_ndx = GET_NDX (datum,colr_ndx)
		  CALL SET_RIBBON_NDX (colr_ndx)
	          line_ndx = colr_ndx + thick_offset + low_index - 1

	          IF (colr_ndx .EQ. -999 .AND.(.NOT.new_branch)) THEN
		     isbad = .true.
		     colr_ndx = bad_ribbon_ndx
		     line_ndx = colr_ndx + low_index - 1

		     IF ((bad_blank .AND. .NOT.last_bad) .AND. 
     .                   (ITYPE(I).NE.3)) CALL PLOT(xhalf,yhalf,IDN,0)
		     IF (bad_blank) IDN = 0
		ELSE
		   nothing = 0
		ENDIF
		  
	          IF (line_ndx .LT. 1) line_ndx = 1

	          IF ( colr_ndx.NE.last_colr_ndx) THEN
		     
* In default (not fast) mode, draw sub-segments filling in all the colors
* corresponding to the index range between the color at this point and the
* color at the previous point.

		     IF (.NOT.RIBBON_FAST .AND. 
     .                    .NOT.isbad .AND. .NOT.last_bad .AND.
     .                    ABS(colr_ndx-last_colr_ndx) .GT. 1 .AND.
     .                    (.NOT.new_branch) .AND. ITYPE(I).NE.3) THEN

		        nseg = ABS(colr_ndx-last_colr_ndx) 
		        frac = 1./FLOAT(nseg)
		        dx = (xt-xlast)
		        dx = (xt-xlast)* frac
		        dy = (yt-ylast)
		        dy = (yt-ylast)* frac
		        indx = 1
		        inc = 1
		        IF (last_colr_ndx .GT. colr_ndx) inc = -1
		        DO 80 iseg = last_colr_ndx+inc, colr_ndx, inc
			   xi = xlast + dx*indx
			   yi = ylast + dy*indx
	                   line_ndx = iseg + thick_offset + low_index - 1
		           IF (line_ndx .LT. 1) line_ndx = 1
	                   CALL PLOT(xi,yi,IDN,0)
	                   CALL COLOR (line_ndx) 
	                   CALL PLOT(xi,yi,IDN,0)
			   indx = indx + 1
80	                CONTINUE
			XT = xi  ! should already be??
			YT = yi
                      ELSEIF (.NOT.new_branch) THEN
	                IF (ITYPE(I).NE.3) CALL PLOT(xhalf,yhalf,IDN,0)
			IF (colr_ndx.NE.last_colr_ndx) CALL COLOR (line_ndx)
	                IF (ITYPE(I).NE.3) CALL PLOT(xhalf,yhalf,IDN,0)
	                IF (.NOT.new_branch) CALL PLOT(XT,YT,IDN,0)
		     ENDIF
		     IF (colr_ndx.NE.last_colr_ndx) CALL COLOR (line_ndx)
		  ENDIF

	          CALL PLOT(XT,YT,IDN,0)

	          IF (last_colr_ndx .EQ. bad_ribbon_ndx .AND. 
     .		       colr_ndx .NE. bad_ribbon_ndx) THEN
                     CALL COLOR (line_ndx) 
		  ENDIF

		  last_colr_ndx = colr_ndx
		  last_bad = .FALSE.
		  IF (isbad) last_bad = .TRUE.
		  isbad = .FALSE.
	  	  xlast = xt
		  ylast = yt
		  datxlast = datx
		  datylast = daty

		  if (interrupted) goto 51 ! *jd* 8.3.92
		  idec = idec + 1
		  md = MOD(idec,nskp) .EQ. 0
		  IF (bad_blank .AND. colr_ndx.EQ.bad_ribbon_ndx) THEN
		     nothing = 0
		  ELSE
	             IF (md) CALL MARK(IM)
	          ENDIF
		  CALL PLOT(XT,YT,IDN,0) 

	          IF(IDN.EQ.0)THEN
		    xtlast = xt
		    ytlast = yt
		    klast = k
	            IDN=1
	          ENDIF
		  new_branch = .FALSE.
	        END IF

* if gap_var = 1, then this is the end of a segment. Draw to it, and pick up the pen.
		IF (igap.GT.0) THEN
		   IDN = 0
		   CALL PLOT(XT,YT,IDN,0) 
		ENDIF

72	      CONTINUE
	    END IF
	    IF(ITYPE(I).EQ.2.OR.ITYPE(I).EQ.5)CALL MARK(IMARK(I))

          IF (imark(i) .eq. 99) THEN
             CALL doit_makedot(IPT,XDOT,YDOT)
             IPT = 0
          ENDIF
	if (interrupted) go to 51 !*jd* 8.3.92


*** FINALIZE
 51	CONTINUE
        IF (imark(i) .eq. 99) THEN
          CALL doit_makedot(IPT,XDOT,YDOT)
          IPT = 0
        ENDIF

        CALL COLOR(1)
*       DO THE KEY
C     Generate a color/gray scale key.
C     Restore standard key style afterward (do this here, to 
C     catch both plot and plot/set calls).
C     
        if (do_key .AND. .NOT.interrupted) THEN
            call key ! 1/89 - *sh*
           CALL SHADE_KEY_CONT (0)
        ENDIF
	RETURN

	END

	SUBROUTINE GET_AXIS_FORMAT( lo_val, hi_val, del_val, 
     .     fmt, use_nice )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* ACM 5/2005
* set up the format for PPLUS to properly label the axis tics
* Extracted from axis_format.F
* 
* 2/2008 ACM If the lo and hi value on the axis are the same '
* (which may happen in a PLOT/VS plot) we got a divide by zero.

* calling argument declarations:
	CHARACTER	fmt*4
	REAL*8		lo_val, hi_val, del_val
        LOGICAL         use_nice

* internal variable declarations:
	INTEGER		places, ndec
	REAL		res_del
	INTEGER		n_res

* decimal places needed for axis:
* ... sufficient digits to resolve the tic interval differences and
*     still display the largest axis labels
*  res_del	- labels will be accurate enough to resolve this delta value

* Compute n_res; round up (hi-lo)/(2*del_val)  We label half of the tic marks...

        n_res = INT(0.5+ ABS(hi_val - lo_val) / (2.D0*del_val) )
        IF (n_res .EQ. 0) n_res = del_val
	res_del = ABS( hi_val - lo_val ) / n_res
	CALL GET_PREC_DIGITS( hi_val, lo_val, res_del, places, ndec )

* format to use
* Let smaller ranges be labeled with longitude (range 161.123 to 161.130)
*	use_nice = places .LE. 6
	use_nice = places .LE. 7
	IF ( use_nice ) THEN
	   IF ( ndec .EQ. 0 ) THEN
	      fmt = 'I7'
	   ELSE
	      WRITE ( fmt, 3000 ) ndec
 3000	      FORMAT ('F8.',I1)
	   ENDIF
	ENDIF

        RETURN
        END

	SUBROUTINE SORT_LIST(n, valid_min, valid_max,
     .			     bad_flag_in, bad_flag_out,
     .			     list, indices, nvalid)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Sort an input list of values returning both the sorted list and the
* map vector (as floats)
* if there are missing values in the index list, sort em as if they are BIG


* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V510 *sh* 8/99
* V530 *sh* use sorting routine SHELL for improved performance
* V530 *acm* 1/23/01 replace shell sort with HEAPSORT for even 
*	better performance.
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

        IMPLICIT NONE
	include 'errmsg.parm'

* calling argument declarations:
	INTEGER n, valid_min, valid_max, nvalid
	REAL bad_flag_in, bad_flag_out, list(n), indices(n)

* internal variable declarations:
	INTEGER i

* initialize
	DO 10 i = 1,n
 10	indices(i) = i

* replace indices that are out of range with missing value flags
	DO 20 i = 1, n
	  IF (list(i) .GT. valid_max
     .   .OR. list(i) .LT. valid_min ) list(i) = bad_flag_in
 20	CONTINUE

* shell sort
c	CALL SHELLR(list,indices,bad_flag_in,n)
	CALL HEAP2(list, indices, bad_flag_in, n)

* count valid points
 300	nvalid = n
	DO 400 i = 1,n
	   IF ( list(i) .EQ. bad_flag_in ) nvalid = nvalid - 1
 400	CONTINUE

* reconcile bad flags and count valid points
	IF ( bad_flag_in .NE. bad_flag_out ) THEN
	   DO 500 i = 1,n
	      IF ( list(i).EQ.bad_flag_in ) list(i) = bad_flag_out
 500	   CONTINUE
	ENDIF

	RETURN
	END

	SUBROUTINE IS_CALC ( memory, *, *, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* get a grid of "calculated" data - ie. a variable which does not exist on
* disk but which can be computed from disk data by model-diagnostic code
* ( eg computing heat advection from temperature and velocity fields )

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 2/17/87
* V200:  7/24/89 - 4D symmetric version based on ISP stack

* calling argument declarations:
	INTEGER	status
	REAL	memory(*)
* normal exit is for error conditions
* exit #1 is to request another grid ( stack has been pushed )
* exit #2 is to signal completion of the activity at this stack level
* V312: 5/94 - array "memory" as a calling argument
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

* internal variable declarations:
	LOGICAL	dummy_next, special_var, k_eq1
	INTEGER hi_cx, lo_cx, lo_isp, cvar, nitem, item0, item, comp,
     .		next_var, dset

	include	'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'instance_table.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xcalc_vars.cmn'
	include	'xprog_state.cmn'
	include	'xdset_parms.cmn'

*        ... interpretation stack setup at the time this is called ...
*	stack level		stack contents
*	isp+1	<--	level of next activity ( component to get )
*	 isp	<--	... ( current stack level )
*	isp-1		...
*	isp-2	<--	...	components of this cvar on stack
*	isp-n		...
*	lo_isp	<--	level controlling evaluation of cvar

* --- end of introductory code ---

* test to see if first time called - designate stack activity as algebra
	IF ( is_act(isp) .EQ. isact_request ) THEN
	   lo_isp = isp
	   is_phase( lo_isp ) = 0
	   is_act  ( lo_isp ) = isact_calculate
	ELSE
	   isp = isp + 1			! point to component just got
	   lo_isp = is_obj( isp )
	   hi_cx  = is_cx( isp )
	ENDIF

* convenience values
	lo_cx  = is_cx( lo_isp )
	cvar   = cx_variable( lo_cx )
	dset   = cx_data_set( lo_cx )
	nitem  = cvar_frame_length( cvar )
	item0  = cvar_frame_start( cvar )

* special needs for components of some variables
	IF (cvar .GT. pcv_spec_flg) cvar = cvar - pcv_spec_flg
* ... variables always requiring k=1 as lower Z limit
	k_eq1 = cvar.EQ.pdpdx  .OR. cvar.EQ.pdpdy
     .	   .OR. cvar.EQ.pw_u   .OR. cvar.EQ.pw_t

* initialize stacks
	IF ( is_phase( lo_isp ) .EQ. 0 ) THEN
	   IF ( mode_diagnostic )
     .			CALL DIAGNOSTIC_OUT( 'compute', lo_cx, point_to_cx )
	   CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   hi_cx = cx_stack_ptr
	ENDIF

* set up to get next component
 100	is_phase(lo_isp) = is_phase(lo_isp) + 1
	item = is_phase(lo_isp)			! points into cvar table
	IF ( item .GT. nitem ) GOTO 1000
	comp = item + item0

* unravel the variable coding of the next component
	next_var = cv_variable( comp )
	special_var = next_var .GT. pcv_spec_flg
	IF ( special_var ) next_var = next_var - pcv_spec_flg

* the next component may be a dummy place holder
	IF ( special_var ) THEN
* this component was flagged for data-set-dependent special consideration
* ... different action depending on what variable needs this component
	   IF ( cvar .EQ. pqrad ) THEN
	      dummy_next = dp_phil_qflux( dset )	! need SST ?
	   ELSEIF ( cvar .EQ. pair ) THEN
	      dummy_next = dp_const_air_sst( dset )	! need CAIR ?
     .			.AND. cx_hi_ss(lo_cx,y_dim) .LT. 91
	   ELSEIF ( cvar .EQ. pcair ) THEN
	      dummy_next = .FALSE.
	   ELSE
	      CALL ERRMSG
     .			( ferr_internal, status, 'cv_spec_flg', *5000 )
	   ENDIF
	ELSEIF ( cv_lo_d3(comp) .GT. pcv_keq1_flg ) THEN
* component needed only at surface calculations
* ... are we at the surface ?
	   dummy_next = cx_lo_ss( lo_cx,z_dim ) .NE. 1
	ELSE
	   dummy_next = .FALSE.
	ENDIF

* process dummy place holder
	IF ( dummy_next ) THEN
	   isp = isp + 1
	   is_mr(isp) = dummy_mr
	   is_obj( isp ) = lo_isp	! claimed by this cvar calculation
	   GOTO 100
	ENDIF

* create context for the next component needed
	CALL CVAR_CONTEXT( lo_cx, hi_cx, comp, k_eq1, status )
	IF ( status .NE. ferr_ok ) RETURN

* request this variable on the interpretation stack ( via RETURN 1 )
	CALL PUSH_INTERP_STACK( isp, status )
	IF ( status .NE. ferr_ok ) RETURN
	is_cx ( isp ) = hi_cx
	is_obj( isp ) = lo_isp		! claimed by this cvar calculation
	IF ( cx_category(hi_cx) .EQ. cat_user_var ) THEN
* ... special action if this component variable is user-defined (uvar)
	   is_uvar( isp ) = cx_variable( hi_cx )
	ENDIF
	RETURN 1

* all components are ready - do the calculation
 1000	CALL CALC_CVAR( memory,
     .		        lo_cx, is_mr(lo_isp+1), is_mr(lo_isp), status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* pop off the stack space used by the components
	isp = isp - nitem

* pop off context used for components
	IF ( hi_cx .NE. cx_stack_ptr ) WRITE (6, *) 'is_calc_stk' ! temp diag
	cx_stack_ptr = cx_stack_ptr - 1
	RETURN 2

* error exit
 5000	RETURN
	END	

   	SUBROUTINE DO_QUERY( chout, fmt, query, tag, status ) 

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* respond to the specific QUERY command

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* for FERRET V300: 6/16/93
* V314: 8/19/94 *kob* IBM port - Modified format statements, added 
*				 ifdef MANDATORY_FORMAT_WIDTHS for I format
*			         descriptor 
* V320: 12/29/94 - use SPLIT_LIST to redirect tty output for GUI
* V420: 11/95 - bug in QUERY GRID if grid unknown:  LET A = I; QUERY GRID 1 A
* Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
* kob*   9/97 - replaced call to ISUBSCRIPT w/ call to ISUBSCR_CX in order
*               to have access to context information - needed for negative
*               time step processing
* V5.3  1/01 *acm* cal_id for alternative calendar types: call to TM_DATE_OK
* v540 *acm* 10/01 increase length of ds_name
* v540 *acm* 10/01  remove VMS include statements
* v604 *acm* 7/07 increase length of ds_name
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

        include 'tmap_dims.parm'
#        include "tmap_dset.parm"
        include 'xdset_info.cmn_text'
        external xdset_info_data
        include 'xtm_grid.cmn_text'
        external xgt_grid_data
        include 'xalt_messages.cmn_text'
        external xalt_messages_data
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'gfdl_vms.parm'
	include 'xprog_state.cmn'
	include 'xcommand.cmn'
	include 'xtext_info.cmn'
	include 'xcontext.cmn'
	include 'xalgebra.cmn'
	include 'xgui.cmn'
	include 'xrisc.cmn'          ! 12/94 SPLIT_LIST buffer

* calling argument declarations
	INTEGER chout, query, status
	CHARACTER*(*) fmt, tag

* local variable declarations:
	LOGICAL TM_DATE_OK, done, formatted, ww_given
	INTEGER	TM_LENSTR1, FIND_DSET_NUMBER, IGRID, TM_GET_LINENUM,
     .		STR_CASE_BLIND_COMPARE, TM_GET_GRIDNUM, ISUBSCR_CX,
     .		i, n, dim, dset, cat, var, axis, grid, reg, modulo,
     .		calendar, dummy, istat, slen, ds_var_len
	INTEGER TM_GET_CALENDAR_ID, cal_id


	REAL*8	TWORLD, TM_WORLD, lo, hi, delta
	CHARACTER TM_FMT*16, buff1*32, buff2*32

* initialize
	status = ferr_ok
	risc_buff = ' '
	IF ( query .GT. max_queries ) THEN
	   status = ferr_invalid_command
	   RETURN
	ENDIF

* respond to the appropriate query
	GOTO ( 100, 200, 300, 400, 500, 600, 700, 800, 900,1000,
     .	      1100,1200,1300,1400,1500,1600,1700,1800,1900,2000,
     .	      2100,2200,2300,2400,2500,2600,2700,2800,2900,3000 ) query
	
* STATUS
* error status of last command
 100	CONTINUE
	   IF ( gui_status .EQ. ferr_ok ) THEN
	      WRITE (risc_buff, fmt ) 0, queries(query), tag
	      CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)

	   ELSE
	      WRITE (risc_buff, fmt ) 1, queries(query), tag
	      CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
	      risc_buff = ' '
	      WRITE (risc_buff, '(I4)') gui_status
	      CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
	   ENDIF
	   gui_status = ferr_ok   ! clear it
	GOTO 4999

* MESSAGE
* messages from last command
 200	CONTINUE
	   WRITE (risc_buff, fmt ) alt_nlines, queries(query), tag
	   CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
	   DO 210 i = 1, alt_nlines
	      risc_buff = ' '
 	      WRITE (risc_buff,'(A)') alt_text(i)(1:TM_LENSTR1(alt_text(i)))
	      CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
 210	   CONTINUE
	   alt_nlines = 0   ! clear messages
	GOTO 4999

* DSET
* list of open data sets
 300	CONTINUE
*   ... count data sets
 	   n = 0
	   DO 310 i = 1,  maxdsets
 310	   IF ( ds_name(i) .NE. char_init1024) n = n + 1
*   ... list 'em
	   WRITE (risc_buff, fmt ) n, queries(query), tag
	   CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
	   DO 320 i = 1,  maxdsets
	      IF (ds_name(i).NE.char_init1024) THEN
	         WRITE (risc_buff,'(A)')
     .			ds_name(i)(1:TM_LENSTR1(ds_name(i)))
	         CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
	         risc_buff = ' '
	      ENDIF
 320	   CONTINUE
	GOTO 4999

* VARIABLE dset
* list variables in data set
 400	CONTINUE
	IF ( num_args .NE. 2 ) GOTO 5040
* ... identify the data set
	dset = FIND_DSET_NUMBER( cmnd_buff(arg_start(2):arg_end(2)) )
	IF ( dset .EQ. unspecified_int4 ) GOTO 5910
* ... pass1 to count variables in data set
	n = 0
	DO 410 var = 1, maxvars
	   IF ( ds_var_setnum(var) .NE. dset ) GOTO 410
	   IF ( ds_var_code(var) .EQ. '-' ) GOTO 410
	   n = n + 1
 410	CONTINUE
	WRITE (risc_buff, fmt ) n, queries(query), tag
	CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
* ... pass 2 to output variable names
	DO 420 var = 1, maxvars
           IF ( ds_var_setnum(var) .NE. dset ) GOTO 420
           IF ( ds_var_code(var) .EQ. '-' ) GOTO 420
*           WRITE (risc_buff,'(A)')
*     .			ds_var_code(var)(1:TM_LENSTR1(ds_var_code(var)))
           CALL string_array_get_strlen1(ds_var_code_head, var, ds_var_len)
           WRITE (risc_buff,'(A)')
     .			ds_var_code(var)(1:ds_var_len)

	   CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
	   risc_buff = ' '
 420    CONTINUE
	GOTO 4999

* GRID dset variable
* n-axis description of grid for given variable
* 5 records back: grid name and axis names with flags
 500	CONTINUE
	IF ( num_args .NE. 3 ) GOTO 5050
* ... identify the data set, then variable, then its grid
	dset = FIND_DSET_NUMBER( cmnd_buff(arg_start(2):arg_end(2)) )
	IF ( dset .EQ. unspecified_int4 ) GOTO 5910
	CALL FIND_VAR_NAME( dset, cmnd_buff(arg_start(3):arg_end(3)),
     .	                    cat, var )
	IF ( var .EQ. munknown_var_name ) GOTO 5920
	grid = IGRID ( dset, cat, var, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	IF ( grid .EQ. unspecified_int4 ) GOTO 5925
	WRITE (risc_buff, fmt ) 5, queries(query), tag
	CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
	risc_buff = ' '
	WRITE (risc_buff, '(A)')
     .			grid_name(grid)(1:TM_LENSTR1(grid_name(grid)))
	CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
* ... return the names of the axes and an inner/outer flag
	DO 510 dim = 1, nferdims
	   axis = grid_line( dim, grid )
	   IF ( axis .EQ. munknown ) THEN
	      CALL SPLIT_LIST(pttmode_explct, chout, 'UNKNOWN O', 9)
	   ELSEIF( axis .EQ. mnormal ) THEN
	      CALL SPLIT_LIST(pttmode_explct, chout, 'NORMAL O', 8)
	   ELSE
	      CALL SPLIT_LIST(pttmode_explct, chout,
     .					line_name(axis)//' O', 0)
	   ENDIF
 510    CONTINUE
	GOTO 4999

* AXIS  axname
* axis description: "npts reg modulo calendar lo_value delta unit_code units"
 600	CONTINUE
	IF ( num_args .NE. 2 ) GOTO 5060
	axis = TM_GET_LINENUM( cmnd_buff(arg_start(2):arg_end(2)) )
 610	IF ( axis .EQ. unspecified_int4 ) GOTO 5930
	GOTO 5000  ! not available yet

* COORDS axis
* coordinates of (irregular) axis
 700	CONTINUE
	GOTO 5000

* TRANS  *************
* list of transforms
 800	CONTINUE
* ... count the number of transforms
	n = 0
	DO 810 i = 4, num_transforms
	   IF ( i .EQ. 11 .OR. i .EQ. 12 
     .	   .OR. alg_trans_num( i ) .EQ. unspecified_int4 ) GOTO 810
	   n = n + 1	
 810	CONTINUE
	WRITE (risc_buff, fmt ) n, queries(query), tag
	CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
* ... each transform: XXX dflt_arg_or_* Compress_or_Span  "title"
	DO 820 i = 4, num_transforms
	   IF ( i .EQ. 11 .OR. i .EQ. 12 
     .	   .OR. alg_trans_num( i ) .EQ. unspecified_int4 ) GOTO 820
	   risc_buff = ' '
	   IF ( alg_trans_has_arg(i) ) THEN
	      buff1 = TM_FMT( alg_trans_dflt_arg(i), 3, 5, slen ) 
	      IF ( .NOT.alg_trans_its_int(i)
     .	     .AND. INDEX(buff1,'.') .EQ. 0  ) THEN
	         buff1 = buff1(:slen)//".0"
	         slen = slen + 2
	      ENDIF	
	   ELSE
	      buff1 = '*'
	   ENDIF
	   IF ( alg_trans_num(i) .GT. trans_compress_code ) THEN
	      buff2 = 'C'   ! compresses range of data
	   ELSE
	      buff2 = 'S'   ! span of data preserved
	   ENDIF
	   WRITE (risc_buff, 3800 )
     .			alg_trans_text(i) ,
     .			buff1(:TM_LENSTR1(buff1)),
     .			buff2,
     .			alg_trans_title(i)(:TM_LENSTR1(alg_trans_title(i)))
	   CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
 820	CONTINUE
 3800	FORMAT(A3,1X,A,1X,A1,' "',A,'"')
	GOTO 4999

* TRNARG (trans) ****will not be used!!*************
* argument description for given transform
 900	CONTINUE
* LVARS  *************
* list of LET-defined variables
 1000	CONTINUE
* DVARS (dset) *************
* list of LET-defined variables defined for data set
 1100	CONTINUE
* VBACKGROUND  (dset variable) *************
* background info about this variable
 1200	CONTINUE
	GOTO 5000
* DBACKGROUND (dset) *************
* background info about this data set
 1300	CONTINUE
	GOTO 5000
* WINDOWS  *************
* list of open windows
 1400	CONTINUE
	GOTO 5000
* WCURRENT  *************
* name of current window
 1500	CONTINUE
	GOTO 5000
* VPORTS  *************
* list of defined viewports
 1600	CONTINUE
	GOTO 5000
* VCURRENT  *************
* name of current viewport
 1700	CONTINUE
	GOTO 5000
* VIEW  (vport) *************
* definition of indicated viewport
 1800	CONTINUE
	GOTO 5000

* DCURRENT
* name of current data set
 1900	CONTINUE
	done = .FALSE.
	DO 1910 dset = 1, maxdsets
           IF ( ds_name(dset) .EQ. char_init1024) GOTO 1910
	   IF ( dset .EQ. cx_data_set(cx_last) ) THEN
	      WRITE (risc_buff, fmt ) 1, queries(query), tag
	      CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
	      risc_buff = ' '
	      WRITE (risc_buff, '(A)' )
     .			ds_name(dset)(1:TM_LENSTR1(ds_name(dset)))
	      CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
	      risc_buff = ' '
	      done = .TRUE.
	   ENDIF
 1910	CONTINUE
	IF ( .NOT.done ) THEN
	   WRITE (risc_buff, fmt ) 0, queries(query), tag
	   CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
	ENDIF
	GOTO 4999

* SPAN  dset variable
* return nferdims+1 records:
* 1 - the grid name for this variable
* 2-n the subssript, world coords, and world text limits along each axis
 2000	CONTINUE
	IF ( num_args .NE. 3 ) GOTO 5050
* ... identify the data set, then variable, then its grid
	dset = FIND_DSET_NUMBER( cmnd_buff(arg_start(2):arg_end(2)) )
	IF ( dset .EQ. unspecified_int4 ) GOTO 5910
	CALL FIND_VAR_NAME( dset, cmnd_buff(arg_start(3):arg_end(3)),
     .	                    cat, var )
	IF ( var .EQ. munknown_var_name ) GOTO 5920
	IF ( cat .NE. cat_file_var ) GOTO 5000
	grid = IGRID ( dset, cat, var, status )
        IF ( status .NE. ferr_ok ) GOTO 5000
	WRITE (risc_buff, fmt ) 5, queries(query), tag
	CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
	risc_buff = ' '
* ... return the grid name
	WRITE (risc_buff, '(A)' ) grid_name(grid)
     .	                          (1:TM_LENSTR1(grid_name(grid)))
	CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
	risc_buff = ' '
* ... return the subscript span along each axis
	DO 2010 dim = 1, nferdims
	   axis = grid_line( dim, grid )
	   IF ( axis .EQ. munknown
     .     .OR. axis .EQ. mnormal ) THEN
	      WRITE (risc_buff,3200) -111, -111, 0.D0, 0.D0, '*', '*'
	      CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
	   ELSE
	      lo = TM_WORLD(ds_grid_start(dim,var), grid, dim, box_middle)
	      hi = TM_WORLD(ds_grid_end  (dim,var), grid, dim, box_middle)
	      CALL TRANSLATE_TO_WORLD( lo,dim,grid,ax_dec_pt(dim),buff1 )
	      CALL TRANSLATE_TO_WORLD( hi,dim,grid,ax_dec_pt(dim),buff2 )
	      CALL CLEAN_COORD_STRING(dim, buff1(1:TM_LENSTR1(buff1)))
	      CALL CLEAN_COORD_STRING(dim, buff2(1:TM_LENSTR1(buff2)))
              WRITE (risc_buff,3200) ds_grid_start(dim,var),
     .				 ds_grid_end  (dim,var),
     .				 lo, hi,
     .				 buff1(1:TM_LENSTR1(buff1)),
     .				 buff2(1:TM_LENSTR1(buff2))
	      CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
	   ENDIF
	   risc_buff = ' '
 2010    CONTINUE
 3200	FORMAT(2I6,2(1PG14.5),2(1x,A))
	GOTO 4999

* GAXIS grid orientation    (like AXIS but different args)
 2100	CONTINUE
	IF ( num_args .NE. 3 ) GOTO 5210
	grid = TM_GET_GRIDNUM( cmnd_buff(arg_start(2):arg_end(2)) )
	IF ( grid .EQ. unspecified_int4 ) GOTO 5930
	DO 2110 dim = 1, nferdims
	  istat = STR_CASE_BLIND_COMPARE( ww_dim_name(dim),
     .				cmnd_buff(arg_start(3):arg_end(3)) )
	  IF ( istat .EQ. vms_str_success ) GOTO 2120
 2110	CONTINUE
	GOTO 5210
 2120	axis = grid_line( dim, grid )
	WRITE (risc_buff, fmt ) 1, queries(query), tag
	CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
	risc_buff = ' '
	IF ( axis .EQ. munknown
     .  .OR. axis .EQ. mnormal ) THEN
	   n = 0
	   lo = 0.D0
	   hi = 0.D0
	   delta = 0.D0
	   reg = 0
	   modulo = 0
	   calendar = 0
	ELSE
	   n = line_dim(axis)
	   lo = TWORLD(1, grid, dim, box_middle)
	   hi = TWORLD(n, grid, dim, box_middle)
	   delta = (hi-lo)/(n-1)
	   IF ( line_regular(axis) ) THEN
	      reg = 1
	   ELSE
	      reg = 0
	   ENDIF
	   IF ( line_modulo( axis ) ) THEN	
	      modulo = 1
	   ELSE
	      modulo = 0
	   ENDIF
           cal_id = TM_GET_CALENDAR_ID (line_cal_name(axis) )
	   IF ( TM_DATE_OK( line_t0(axis), cal_id)  ) THEN
	      calendar = 1
	   ELSE
	      calendar = 0
	   ENDIF
	ENDIF
	WRITE (risc_buff, 3060 ) n, reg, modulo, calendar,
     .			      lo, delta,
     .			      line_unit_code(axis),
     .			      line_units(axis)(1:TM_LENSTR1(line_units(axis)))
	CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
	GOTO 4999
 3060	FORMAT(I6,3I2,2(1PG14.5),I4,2X,A)

* GCOORDS grid orientation    (like COORDS but different args)
 2200	CONTINUE
	IF ( num_args .NE. 3 ) GOTO 5220
	grid = TM_GET_GRIDNUM( cmnd_buff(arg_start(2):arg_end(2)) )
	IF ( grid .EQ. unspecified_int4 ) GOTO 5930
	DO 2210 dim = 1, nferdims
	  istat = STR_CASE_BLIND_COMPARE( ww_dim_name(dim),
     .					 cmnd_buff(arg_start(3):arg_end(3)) )
	  IF ( istat .EQ. vms_str_success ) GOTO 2220
 2210	CONTINUE
	GOTO 5220
 2220	CALL GRID_SUBSCRIPT_EXTREMES( dummy, n, grid, dim )
	WRITE (risc_buff, fmt ) n+1, queries(query), tag
	CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
	risc_buff = ' '
* for each record write the coordinate and the lower box bound
	DO 2230 i = 1, n
	   WRITE (risc_buff, '(2(1PG14.5))' ) TWORLD(i, grid, dim, box_middle),
     .				   TWORLD(i, grid, dim, box_lo_lim)
	   CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
	   risc_buff = ' '
 2230	CONTINUE
	WRITE (risc_buff, '(2(1PG14.5))' ) -999.D0, TWORLD(n, grid, 
     .                             dim, box_hi_lim)
	CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
	risc_buff = ' '
	GOTO 4999

* SSPOINT grid orientation delta_index index
* given an index or a world coordinate return an index value
* that is offset by an index change delta_index
* The "orientation" parameter should match the "coordinate" wrt index or ww
 2300	CONTINUE
	IF ( num_args .NE. 5 ) GOTO 5230
	grid = TM_GET_GRIDNUM( cmnd_buff(arg_start(2):arg_end(2)) )
	IF ( grid .EQ. unspecified_int4 ) GOTO 5930
	DO 2310 dim = 1, nferdims ! match orientation against X,Y,Z,T,E,F
	  istat = STR_CASE_BLIND_COMPARE( ww_dim_name(dim),
     .				cmnd_buff(arg_start(3):arg_end(3)) )
	  IF ( istat .EQ. vms_str_success ) THEN
	     ww_given = .TRUE.
	     GOTO 2320
	  ENDIF
 2310	CONTINUE
	DO 2315 dim = 1, nferdims ! match orientation against I,J,K,L,M,N
	  istat = STR_CASE_BLIND_COMPARE( ss_dim_name(dim),
     .				cmnd_buff(arg_start(3):arg_end(3)) )
	  IF ( istat .EQ. vms_str_success ) THEN
	     ww_given = .FALSE.
             GOTO 2320
          ENDIF
 2315	CONTINUE
	GOTO 5230
#ifdef MANDATORY_FORMAT_WIDTHS
* no fixed field width works but "*" may cause problems too
* such as "Y" being an unacceptable integer
 2320	READ (cmnd_buff(arg_start(4):arg_end(4)), *,ERR=5304) n ! delta
#else
 2320	READ (cmnd_buff(arg_start(4):arg_end(4)), '(I)',ERR=5304) n ! delta
#endif
	IF ( ww_given ) THEN
	   axis = grid_line(t_dim, grid)
	   cal_id = TM_GET_CALENDAR_ID ( line_cal_name(axis) )
 	   CALL TRANSLATE_LIMIT( cmnd_buff(arg_start(5):arg_end(5)),
     .		           dim, .FALSE., lo, formatted, cal_id, status )
	   IF ( status .NE. ferr_ok ) GOTO 5315
	   i = ISUBSCR_CX( lo, grid, dim, cx_last, round_dn )
	ELSE
#ifdef MANDATORY_FORMAT_WIDTHS
* no fixed field width works but "*" may cause problems too
* such as "Y" being an unacceptable integer
	   READ (cmnd_buff(arg_start(5):arg_end(5)), *,ERR=5305) i
#else
	   READ (cmnd_buff(arg_start(5):arg_end(5)), '(I)',ERR=5305) i
#endif
	ENDIF
	i = MAX( i+n, 1 )
	WRITE (risc_buff, fmt ) 1, queries(query), tag
	CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
	risc_buff = ' '
	WRITE (risc_buff, '(I6)' ) i
	CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
	GOTO 4999

* WWPOINT grid orientation delta_index coordinate
* given a index or a world coordinate return both a formatted string
* for a world coordinate and a numerical value that are offset by an
* index change delta_index
* The "orientation" parameter should match the "coordinate" wrt index or ww
 2400	CONTINUE
	IF ( num_args .NE. 5 ) GOTO 5240
	grid = TM_GET_GRIDNUM( cmnd_buff(arg_start(2):arg_end(2)) )
	IF ( grid .EQ. unspecified_int4 ) GOTO 5930
	DO 2410 dim = 1, nferdims   ! match orientation against X,Y,Z,T
	  istat = STR_CASE_BLIND_COMPARE( ww_dim_name(dim),
     .				cmnd_buff(arg_start(3):arg_end(3)) )
	  IF ( istat .EQ. vms_str_success ) THEN
	      ww_given = .TRUE.
	      GOTO 2420
	  ENDIF
 2410	CONTINUE
	DO 2415 dim = 1, nferdims     ! match orientation against I,J,K,L,M,N
	  istat = STR_CASE_BLIND_COMPARE( ss_dim_name(dim),
     .				cmnd_buff(arg_start(3):arg_end(3)) )
	  IF ( istat .EQ. vms_str_success ) THEN
	      ww_given = .FALSE.
	      GOTO 2420
	  ENDIF
 2415	CONTINUE
	GOTO 5240
#ifdef MANDATORY_FORMAT_WIDTHS
* no fixed field width works but "*" may cause problems too
* such as "Y" being an unacceptable integer
 2420	READ (cmnd_buff(arg_start(4):arg_end(4)), *,ERR=5304) n ! delta
#else
 2420	READ (cmnd_buff(arg_start(4):arg_end(4)), '(I)',ERR=5304) n ! delta
#endif
	IF ( ww_given ) THEN
	   axis = grid_line(t_dim, grid)
	   cal_id = TM_GET_CALENDAR_ID ( line_cal_name(axis) )
 	   CALL TRANSLATE_LIMIT( cmnd_buff(arg_start(5):arg_end(5)),
     .		           dim, .FALSE., lo, formatted, cal_id, status )
	   IF ( status .NE. ferr_ok ) GOTO 5315
	   i = ISUBSCR_CX( lo, grid, dim, cx_last, round_dn )
	ELSE
#ifdef MANDATORY_FORMAT_WIDTHS
* no fixed field width works but "*" may cause problems too
* such as "Y" being an unacceptable integer
	   READ (cmnd_buff(arg_start(5):arg_end(5)), *,ERR=5305) i
#else
	   READ (cmnd_buff(arg_start(5):arg_end(5)), '(I)',ERR=5305) i
#endif	
	ENDIF
	i = MAX(i+n, 1)
	lo = TM_WORLD( i, grid, dim, box_middle )
	CALL TRANSLATE_TO_WORLD( lo,dim,grid,ax_dec_pt(dim),buff1 )
	CALL CLEAN_COORD_STRING( dim, buff1(1:TM_LENSTR1(buff1)) )
	WRITE (risc_buff, fmt ) 1, queries(query), tag
	CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
	risc_buff = ' '
	WRITE (risc_buff, '(A,1X,1PG14.5)' ) buff1( 1:TM_LENSTR1(buff1) ), lo
	CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
	GOTO 4999

* ****  *************
 2500	CONTINUE
	GOTO 5000
* ****  *************
 2600	CONTINUE
	GOTO 5000
* ****  *************
 2700	CONTINUE
	GOTO 5000
* ****  *************
 2800	CONTINUE
	GOTO 5000
* ****  *************
 2900	CONTINUE
	GOTO 5000
* ****  *************
 3000	CONTINUE
	GOTO 5000


* successful completion
 4999	RETURN

* error exits
 5000	WRITE (risc_buff, fmt ) 0, "*ERR", tag
	CALL SPLIT_LIST(pttmode_explct, chout, risc_buff, 0)
 	RETURN
 5040	CALL ERRMSG( ferr_invalid_command, status,
     .		     "QUERY VARIABLES needs data set as argument", *5000)
 5050	CALL ERRMSG( ferr_invalid_command, status,
     .		     "this QUERY needs data set and variable as argument",
     .		     *5000)
 5060	CALL ERRMSG( ferr_invalid_command, status,
     .		     'QUERY AXIS needs axis name as argument', *5000)
 5210	CALL ERRMSG( ferr_invalid_command, status,
     .		     'usage: QUERY GAXIS grid_name X_Y_Z_T_EorF', *5000)
 5220	CALL ERRMSG( ferr_invalid_command, status,
     .		     'usage: QUERY GCOORDS grid_name X_Y_Z_T_EorF', *5000)
 5230	CALL ERRMSG( ferr_invalid_command, status,
     .		     'usage: QUERY SSPOINT grid_name X_Y_Z_T_EorF delta index'
     .	             , *5000)
 5240	CALL ERRMSG( ferr_invalid_command, status,
     .		     'usage: QUERY WWPOINT grid_name X_Y_Z_T_EorF delta coord'
     .	             , *5000)
 5304	CALL ERRMSG( ferr_erreq, status,
     .		     cmnd_buff(arg_start(4):arg_end(4)), *5000 )
 5305	CALL ERRMSG( ferr_erreq, status,
     .		     cmnd_buff(arg_start(5):arg_end(5)), *5000 )
 5315	CALL ERRMSG( ferr_syntax, status,
     .		     cmnd_buff(arg_start(5):arg_end(5)), *5000 )
 5910	CALL ERRMSG( ferr_unknown_data_set, status,
     .		     cmnd_buff(arg_start(2):arg_end(2)), *5000)
 5920	CALL ERRMSG( ferr_unknown_variable, status,
     .		     cmnd_buff(arg_start(3):arg_end(3)), *5000)
 5925	CALL ERRMSG( ferr_unknown_grid, status,
     .		     cmnd_buff(arg_start(3):arg_end(3)), *5000)
 5930	CALL ERRMSG( ferr_unknown_arg, status,
     .		     cmnd_buff(arg_start(2):arg_end(2)), *5000)
	END

	SUBROUTINE SORT_TSERIES_DSETS (nmembers, nsteps, skip_edges,
     .				       memb_nsteps, memb_order,
     .				       tsteps, edges)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* NOAA/PMEL, Seattle, WA - TMAP 

* sort the time steps that have been pulled from the time series members
*
* V698 *sh* 1/16 

* calling arguments
*   nmembers	- number of members in aggregation (input)
*   nsteps	- total number of time steps in agg axis (input)
*   skip_edges	- flag to turn off cell edge processing (input)
*   memb_nsteps	- number of time steps from each member file (input)
*   memb_order	- ordering index of member files (input empty/output filled)
*   tsteps      - time step array as currently ordered (in/out)
*   edges       - edges array as currently ordered (in/out)

        include 'tmap_errors.parm'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
        include 'xprog_state.cmn'
	include 'xtm_grid.cmn_text'  
	include 'errmsg.parm'
	include 'netcdf.inc'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xfr_grid.cmn'
	include 'xdiag_ctrl.cmn_text'

* calling argument declarations:
	LOGICAL skip_edges
	INTEGER nmembers, nsteps, memb_nsteps(nmembers), memb_order(nmembers)
	REAL	tsteps(nsteps), edges(nsteps+nmembers)

* local variable declarations:
	LOGICAL sorted
	INTEGER lstart(nmembers), i, lin, lout, ifile
	REAL    tstart(nmembers), buff(nsteps+nmembers), rorder(nmembers)

* initialize
	sorted = .FALSE.
* ... starting index of each member file
	lstart(1) = 1
	DO i = 2, nmembers
	   lstart(i) = lstart(i-1) + memb_nsteps(i-1) 
	ENDDO
* ... starting time step of each member file
	DO i = 1, nmembers
	   tstart(i) = tsteps(lstart(i))
	ENDDO
* ... pre-sorted indices in a REAL array
	DO i = 1, nmembers
	   rorder(i) = i
	ENDDO

* sort the datasets by start date
	CALL HEAP2(tstart, rorder, unspecified_val8, nmembers)
* ... copy the sorted list back into the input array
	DO i = 1, nmembers
	   memb_order(i) = INT(rorder(i))
	   IF (memb_order(i) .NE. i) sorted = .TRUE.
	ENDDO

* did any re-ordering occur?
	IF (.NOT.sorted) RETURN

* sort the aggregated time axis coordinates
* ... copy into the buffer area in the correct order
	lout = 1
	DO i = 1, nmembers
	   ifile = memb_order(i)
	   lin = lstart(ifile)
	   DO WHILE (lin .LT. lstart(ifile)+memb_nsteps(ifile) )
	      buff(lout) = tsteps(lin)
	      lout = lout + 1
	      lin  = lin  + 1
	   ENDDO
	ENDDO
* ... copy the sorted time axis back
	DO lin = 1, nsteps
	   tsteps(lin) = buff(lin)
	ENDDO


* sort the aggregated time axis cell edges
	IF (skip_edges) RETURN

* ... starting index of edges based on N+1 points per member
	lstart(1) = 1
	DO i = 2, nmembers
	   lstart(i) = lstart(i-1) + memb_nsteps(i-1) + 1
	ENDDO
* ... copy into the buffer area in the correct order
	lout = 1
	DO i = 1, nmembers
	   ifile = memb_order(i)
	   lin = lstart(ifile)
	   DO WHILE (lin .LT. lstart(ifile)+memb_nsteps(ifile)+1 )
	      buff(lout) = edges(lin)
	      lout = lout + 1
	      lin  = lin  + 1
	   ENDDO
	ENDDO
* ... copy the sorted axis edges back
	DO lin = 1, nsteps+nmembers
	   edges(lin) = buff(lin)
	ENDDO

	END

	SUBROUTINE RESTORE_CURVI 
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE.  
*
* Restore settings for dynamic-memory pointers for the curvilinear coordinate data
*
* programmer - Ansley Manke
* PMEL SDIG, 1/19/2018
*
* The curvilinear 2-D coordinate data is passed to PPLUS using the pointers to  
* memory. If the command is e.g. a SHADE/SET, then the data for the curvilinear 
* coordinates has been loaded but may be lost if the commands that come after 
* /SET and before PPL SHADE include redefining any variable, which triggers a 
* freeing of memory. The mr_protected flag has been set to prevent these 
* variables from being freed.  Now that the plot is done, restore the settings 
* for mr_protected.

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'
        include 'xvariables.cmn'
	include 'xcurvilinear.cmn'

	IF (xmem_ptr .NE. mr_nonexist) THEN
	   IF (mr_protected(xmem_ptr) .LT. mr_keep_flag) THEN
	      mr_protected(xmem_ptr) = mr_protected(xmem_ptr) - mr_keep_now
	      CALL DELETE_VARIABLE(xmem_ptr)
	   ENDIF
	ENDIF
	   IF (ymem_ptr .NE. mr_nonexist) THEN
	   IF (mr_protected(ymem_ptr) .LT. mr_keep_flag) THEN
	      mr_protected(ymem_ptr) = mr_protected(ymem_ptr) - mr_keep_now
	      CALL DELETE_VARIABLE(ymem_ptr)
	   ENDIF
	ENDIF

	RETURN
	END

	SUBROUTINE EQUAL_RANGE_T( string,idim,grid,lo,hi,delta,cal_id,
     .				status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* from a string of the form "name=value", return the lo/high value range
* if the string is simply "name" then return unspecified values
* the "delta" value is optional - return unspecfied_val8 if not given

* This routine differs from EQUAL_RANGE in the treatment of time axes.
* This routine always returns a tstep value.  If MODE CALENDAR is TRUE
* this routine checks to make sure the points are ordered.

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V3.00  20/10/93 - *sh*
* V522 7/00 *sh* - added add'l argument to EQUAL_RANGE
* V5.3 *ACM* 3/01  send cal_id to EQUAL_RANGE_T
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction. The time 
*                  dimension is now an arg to SECS_TO_TSTEP.

* calling argument declarations
	INTEGER		idim, grid, cal_id, status
	REAL*8		lo, hi, delta
	CHARACTER*(*)	string

* internal variable declarations
	LOGICAL		GEOG_LABEL, formatted
	REAL*8		SECS_TO_TSTEP, tmp

* local parameter declarations:
	LOGICAL         range_rqd
	PARAMETER     ( range_rqd = .TRUE. )

	include 'ferret.parm'
	include 'errmsg.parm'

* first get EQUAL_RANGE to convert the data normally
	CALL EQUAL_RANGE( string, idim, lo, hi, delta,
     .			  formatted,  range_rqd, cal_id, status )
	IF ( status .NE. ferr_OK ) RETURN

	IF ( idim .EQ. t_dim .OR. idim .EQ. f_dim ) THEN
* if the time was given as a date convert it to a tstep

	   IF ( formatted ) THEN
	      lo = SECS_TO_TSTEP( grid, idim, lo )
	      hi = SECS_TO_TSTEP( grid, idim, hi )
	   ENDIF		

* if MODE CALENDAR is TRUE in FERRET make sure the times are ordered
	   IF ( GEOG_LABEL(idim,grid)
     .    .AND. lo .GT. hi		 ) THEN 
	      tmp = lo
	      lo = hi
	      hi = tmp
	   ENDIF
	ENDIF

* success
 1000	RETURN
	END

      REAL FUNCTION RANDU(JD)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* modified by steve hankin to contain explicit declarations
* and renamed RANDU from "UNI" in its original version from CMLIB
        IMPLICIT NONE
	INTEGER	JD,MDIG,I1MACH,M1,M2,JSEED,K0,K1,J0,J1,I,J,K

C***BEGIN PROLOGUE  UNI
C***DATE WRITTEN   810915
C***REVISION DATE  830805
C***CATEGORY NO.  L6A21
C***KEYWORDS  RANDOM NUMBERS, UNIFORM RANDOM NUMBERS
C***AUTHOR    BLUE, JAMES, SCIENTIFIC COMPUTING DIVISION, NBS
C             KAHANER, DAVID, SCIENTIFIC COMPUTING DIVISION, NBS
C             MARSAGLIA, GEORGE, COMPUTER SCIENCE DEPT., WASH STATE UNIV
C
C***PURPOSE  THIS ROUTINE GENERATES QUASI UNIFORM RANDOM NUMBERS ON [0,1
C             AND CAN BE USED ON ANY COMPUTER WITH WHICH ALLOWS INTEGERS
C             AT LEAST AS LARGE AS 32767.
C***DESCRIPTION
C
C       THIS ROUTINE GENERATES QUASI UNIFORM RANDOM NUMBERS ON THE INTER
C       [0,1).  IT CAN BE USED WITH ANY COMPUTER WHICH ALLOWS
C       INTEGERS AT LEAST AS LARGE AS 32767.
C
C
C   USE
C       FIRST TIME....
C                   Z = UNI(JD)
C                     HERE JD IS ANY  N O N - Z E R O  INTEGER.
C                     THIS CAUSES INITIALIZATION OF THE PROGRAM
C                     AND THE FIRST RANDOM NUMBER TO BE RETURNED AS Z.
C       SUBSEQUENT TIMES...
C                   Z = UNI(0)
C                     CAUSES THE NEXT RANDOM NUMBER TO BE RETURNED AS Z.
C
C
C..................................................................
C   NOTE: USERS WHO WISH TO TRANSPORT THIS PROGRAM FROM ONE COMPUTER
C         TO ANOTHER SHOULD READ THE FOLLOWING INFORMATION.....
C
C   MACHINE DEPENDENCIES...
C      MDIG = A LOWER BOUND ON THE NUMBER OF BINARY DIGITS AVAILABLE
C              FOR REPRESENTING INTEGERS, INCLUDING THE SIGN BIT.
C              THIS VALUE MUST BE AT LEAST 16, BUT MAY BE INCREASED
C              IN LINE WITH REMARK A BELOW.
C
C   REMARKS...
C     A. THIS PROGRAM CAN BE USED IN TWO WAYS:
C        (1) TO OBTAIN REPEATABLE RESULTS ON DIFFERENT COMPUTERS,
C            SET 'MDIG' TO THE SMALLEST OF ITS VALUES ON EACH, OR,
C        (2) TO ALLOW THE LONGEST SEQUENCE OF RANDOM NUMBERS TO BE
C            GENERATED WITHOUT CYCLING (REPEATING) SET 'MDIG' TO THE
C            LARGEST POSSIBLE VALUE.
C     B. THE SEQUENCE OF NUMBERS GENERATED DEPENDS ON THE INITIAL
C          INPUT 'JD' AS WELL AS THE VALUE OF 'MDIG'.
C          IF MDIG=16 ONE SHOULD FIND THAT
C            THE FIRST EVALUATION
C              Z=UNI(305) GIVES Z=.027832881...
C            THE SECOND EVALUATION
C              Z=UNI(0) GIVES   Z=.56102176...
C            THE THIRD EVALUATION
C              Z=UNI(0) GIVES   Z=.41456343...
C            THE THOUSANDTH EVALUATION
C              Z=UNI(0) GIVES   Z=.19797357...
C
C***REFERENCES  MARSAGLIA G., "COMMENTS ON THE PERFECT UNIFORM RANDOM
C                 NUMBER GENERATOR", UNPUBLISHED NOTES, WASH S. U.
C***ROUTINES CALLED  I1MACH,XERROR
C***END PROLOGUE  UNI
      INTEGER M(17)
C
      SAVE I,J,M,M1,M2
C
      DATA M(1),M(2),M(3),M(4),M(5),M(6),M(7),M(8),M(9),M(10),M(11),
     1     M(12),M(13),M(14),M(15),M(16),M(17)
     2                   / 30788,23052,2053,19346,10646,19427,23975,
     3                     19049,10949,19693,29746,26748,2796,23890,
     4                     29168,31924,16499 /
      DATA M1,M2,I,J / 32767,256,5,17 /
C***FIRST EXECUTABLE STATEMENT  UNI
      IF(JD .EQ. 0) GO TO 3
C  FILL
      MDIG=I1MACH(8)+1
C          BE SURE THAT MDIG AT LEAST 16...
      IF(MDIG.LT.16)CALL XERROR('UNI--MDIG LESS THAN 16',22,1,2)
      M1= 2**(MDIG-2) + (2**(MDIG-2)-1)
      M2 = 2**(MDIG/2)
      JSEED = MIN0(IABS(JD),M1)
      IF( MOD(JSEED,2).EQ.0 ) JSEED=JSEED-1
      K0 =MOD(9069,M2)
      K1 = 9069/M2
      J0 = MOD(JSEED,M2)
      J1 = JSEED/M2
      DO 2 I=1,17
        JSEED = J0*K0
        J1 = MOD(JSEED/M2+J0*K1+J1*K0,M2/2)
        J0 = MOD(JSEED,M2)
    2   M(I) = J0+M2*J1
      I=5
      J=17
C  BEGIN MAIN LOOP HERE
    3 K=M(I)-M(J)
      IF(K .LT. 0) K=K+M1
      M(J)=K
      I=I-1
      IF(I .EQ. 0) I=17
      J=J-1
      IF(J .EQ. 0) J=17
!      UNI=FLOAT(K)/FLOAT(M1)
      RANDU=FLOAT(K)/FLOAT(M1)
      RETURN
      END

	SUBROUTINE SHOW_DATA_SET_VARS_XML( lun, dset)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* List information about all variables in the data set in xml-style format

* programmer - Ansley Manke, based on show_data_set_vars.F
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* 6-Aug-2003
* V5.80 13-Sep-2004 *acm* Add data-set specific user variables to the listing
*       13-Oct-2004 *acm* Make the current dataset the default dataset so
*                         we can get all the info on dataset-specific user-defined
*                         variables in all files.
* V6.1  2/2008 *acm* Use attribute structure to get all attributes for the variable.
* V612  8/2007 *acm* Revert to old xml style output for infile_datatype and 
*                    ferret_datatype attributes
* V616 12/2008 *acm* Close the tag correctly; line written using format 2075 needs
*                    the attribute name given a second time.
* V616  1/2009 *acm* Fixing LAS ticket 481, new style of xml output
* V631 11/09 *acm* For XML-formatted output check for and replace the strings < > and &
*                  with &lt; etc.
* V650  2/10 *acm* LAS ticket 761: consistency of the missing-value flags. Use a Fortran
*                  format rather than TM_FMT to write the value to the xml output.
* V67  *acm* 2/11  XML fixes. New attribute formatting, ![CDATA] escape, upper/lowercase handling.
* V685 *acm* 2/13  Always list the default Ferret bad-flag in the xml header. The script 
*                  get_datavar.jnl under LAS iosp/scripts makes sure that is the value written 
*                  to the netcdf data files.
* V698  2/16 *acm* For ticket 2352: variables defined with LET/D are
*                  added to that dataset in the attribute structure, 
*                  and are shown with their dataset on SHOW DATA commands
* V7    6/16 *acm* Fix ticket 2441. For LET/D variables need to store the 
*                  uvar list in a local array. If using deleted_list_result,
*                  it got changed by the call to get the grid of the variable  
* V710 *acm* 10/16 Ticket 2422: variables uvar_grid, uvar_data_type, uvar_aux_cat, 
*                  uvar_aux_var to be replaced with calls to LIST routines in NCF_Util.c 

        IMPLICIT NONE
	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'ez_lib.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xez_info.cmn_text'
	external xez_info_data
	include	'ferret.parm'
	include	'xvariables.cmn'
	include	'xtext_info.cmn'
	include	'xprog_state.cmn'
	include	'xrisc.cmn'
	include	'xcontext.cmn'
	include 'errmsg.parm'
        include 'netcdf.inc'

* calling argument declarations:
	INTEGER	lun, dset
	
* local variable declarations:
	INTEGER   TM_LENSTR, TM_LENSTR1, GRID_FROM_NAME_XML,
     .            STR_SAME, 
     .            ivar, slen, llen, grid, cx_expr, dset_save,
     .            varid, vtype, nvdims, vdims(8), nvatts, blen, i, 
     .            len_attbuff, attoutflag, all_outflag, attid, 
     .            attlen, attype, iatt, iset, alen, npts, 
     .            num_indices, status, let_d_uvars_list(max_uvar), 
     .            itype
	REAL      vals(100)

        LOGICAL   NC_GET_ATTRIB, got_it, coordvar, newatt, have_units,
     .            have_title, have_dims


	CHARACTER TM_FMT*48
        CHARACTER show_str*128
        CHARACTER uvarname*150, attname*128, attbuff*2048, buff*128,
     .            outstring*2048, aname*128, atype*10

C New form for attribute output, dont implement it yet. (Check the
C Write statement that uses number 2075 when we change to using these.)

 2010  FORMAT ('<var name="', A, '">' )
 2020  FORMAT ('<attribute name="', A, '" type="char">' )
 2030  FORMAT ('<attribute name="', A, '" type="float">' )
 2040  FORMAT ('<attribute name="',  A, '" type="', A,'">' )

 2050  FORMAT ('   <value>', A, '</value>')
 2055  FORMAT ('   <value><![CDATA[', A, ']]></value>')
 2060  FORMAT ('</attribute>')

 2070  FORMAT ('</var>')

* describe the variables in the set, including a report on the axes of this grid.

* Initialize flag for writing axes that are used in the dataset variables.

	DO 100 i = 1, line_ceiling
	   line_write(i) = .FALSE.
 100	CONTINUE

* temporarily make this the default data set

        dset_save = cx_data_set(cx_last)
        cx_data_set(cx_last) = dset

	DO 400 ivar = 1, maxvars
	   IF ( ds_var_setnum(ivar) .NE. dset ) GOTO 400

           IF ( ds_var_code(ivar) .EQ. '-' ) GOTO 400  

* ... output variable code, units, grid, and type

*           slen = TM_LENSTR1(ds_var_code(ivar))

          uvarname = ds_var_code(ivar)

           CALL CD_GET_VAR_ID (dset, uvarname, varid, status)
           CALL CD_GET_VAR_INFO (dset, varid, uvarname, vtype, nvdims,
     .           vdims, nvatts, coordvar, all_outflag, status)

           CALL string_array_get_strlen1(ds_var_code_head, ivar, slen)
           CALL ESCAPE_FOR_XML (uvarname, outstring, slen)
           WRITE ( risc_buff, 2010 ) outstring(1:slen)
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

           slen = TM_LENSTR(ds_var_units(ivar))
           IF (ds_var_units(ivar)(1:2) .NE. char_init 
     .           .AND. slen.GT.0) THEN
              CALL ESCAPE_FOR_XML (ds_var_units(ivar), outstring, slen)
              WRITE ( risc_buff, 2020 ) 'units'
              CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
              WRITE (risc_buff, 2055) outstring(1:slen)
              CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
              WRITE ( risc_buff, 2060 ) 
              CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

           ENDIF

           slen = TM_LENSTR(ds_var_title(ivar))
           IF (ds_var_title(ivar)(1:2) .NE. char_init 
     .           .AND. slen.GT.0) THEN
              CALL ESCAPE_FOR_XML (ds_var_title(ivar), outstring, slen)
              WRITE ( risc_buff, 2020 ) 'long_name'
              CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
              WRITE (risc_buff, 2055) outstring(1:slen)
              CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
              WRITE ( risc_buff, 2060 ) 
              CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
           ENDIF

           slen = TM_LENSTR(ds_var_titl_mod(ivar))
           IF (ds_var_titl_mod(ivar)(1:2) .NE. char_init 
     .           .AND. slen.GT.0) THEN
              CALL ESCAPE_FOR_XML (ds_var_titl_mod(ivar), outstring, slen)
              WRITE ( risc_buff, 2020 ) 'history'
              CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
              WRITE (risc_buff, 2055) outstring(1:slen)
              CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
              WRITE ( risc_buff, 2060 ) 
              CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
           ENDIF

! missing_flag comes from attribute FillValue; 
! bad_flag comes from missing_value

          uvarname = ds_var_code(ivar)
          CALL CD_GET_VAR_ID (dset, uvarname, varid, status)
	   
          attname = '_FillValue'
          CALL CD_GET_VAR_ATT_ID (dset, varid, attname, iatt, status)
          IF (status .EQ. ferr_ok) THEN

             CALL CD_GET_VAR_ATT_INFO (dset, varid, iatt, attname, attype, 
     .          attlen, attoutflag, status )
             got_it = NC_GET_ATTRIB (dset, varid, attname, 
     .          .TRUE., uvarname, blen, attlen, 
     .          attoutflag, attbuff, vals)

* For double-prec Ferret, check whether we need more precision to write the value
* If the _FillValue or missing_value are NaN on input, change them to Ferret's 
* default missing value as Ferret does when writing data.

	     show_str = TM_FMT(vals(1), 7,16,slen)
	     IF (STR_SAME(show_str, 'NaN') .EQ. 0) THEN
	       vals(1) = bad_val4
	    ENDIF

	     CALL FLOAT2STRING_FOR_XML (vals(1), attype, show_str, slen)

             CALL ESCAPE_FOR_XML (show_str, outstring, slen)
             WRITE ( risc_buff, 2030 ) '_FillValue' 
             CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
             WRITE (risc_buff, 2050) outstring(1:slen)
             CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
             WRITE ( risc_buff, 2060 ) 
             CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
          ENDIF

          attname = 'missing_value'
          CALL CD_GET_VAR_ATT_ID (dset, varid, attname, iatt, status)
          IF (status .EQ. ferr_ok) THEN

             CALL CD_GET_VAR_ATT_INFO (dset, varid, iatt, attname, attype, 
     .          attlen, attoutflag, status )
             got_it = NC_GET_ATTRIB (dset, varid, attname, 
     .          .TRUE., uvarname, blen, attlen, 
     .          attoutflag, attbuff, vals)
	     
	     show_str = TM_FMT(vals(1), 7,16,slen)
	     IF (STR_SAME(show_str, 'NaN') .EQ. 0) THEN
	       vals(1) = bad_val4
	    ENDIF

	     CALL FLOAT2STRING_FOR_XML (vals(1), attype, show_str, slen)

             CALL ESCAPE_FOR_XML (show_str, outstring, slen)
             WRITE ( risc_buff, 2030 ) 'missing_value'
             CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
             WRITE (risc_buff, 2050) outstring(1:slen)
             CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
             WRITE ( risc_buff, 2060 ) 
             CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
          ENDIF

          IF (vtype .EQ. NF_CHAR ) THEN
             show_str = 'STRING'
          ELSE
             show_str = 'FLOAT'
          ENDIF
          CALL ESCAPE_FOR_XML (show_str, outstring, slen)
          WRITE ( risc_buff, 2020 ) 'ferret_datatype'
          CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

          WRITE (risc_buff, 2055) outstring(1:slen)
          CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
          WRITE ( risc_buff, 2060 ) 
          CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

* other attributes

           uvarname = ds_var_code(ivar)
           CALL CD_GET_VAR_ID (dset, uvarname, varid, status)
           CALL CD_GET_VAR_INFO (dset, varid, uvarname, vtype, nvdims,
     .           vdims, nvatts, coordvar, all_outflag, status)

* Data type of the variable in the file...

           IF (vtype .EQ. ncbyte ) THEN
              show_str = 'BYTE'
           ELSE IF (vtype .EQ. ncchar ) THEN
              show_str = 'CHAR'
           ELSE IF (vtype .EQ. ncshort ) THEN
              show_str = 'SHORT'
           ELSE IF (vtype .EQ. nclong ) THEN
              show_str = 'LONG'
           ELSE IF (vtype .EQ. ncfloat ) THEN
              show_str = 'FLOAT'
           ELSE IF (vtype .EQ. ncdouble ) THEN
              show_str = 'DOUBLE'
           ENDIF

           CALL ESCAPE_FOR_XML (show_str, outstring, slen)
           WRITE ( risc_buff, 2020 ) 'infile_datatype'
           CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

           WRITE (risc_buff, 2055) outstring(1:slen)
           CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
           WRITE ( risc_buff, 2060 ) 
           CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

* All attributes not already listed.
* Skip 'parent_grid', 'slab_min_index', 'slab_max_index' as these
* wind up causing an incomplete spec of the grid in the F-TDS dataset

           DO 200 iatt = 1, nvatts
              CALL CD_GET_VAR_ATT_INFO (dset, varid, iatt, attname, 
     .              attype, attlen, attoutflag, status )

              newatt = .TRUE.
              newatt = (STR_SAME(attname, 'units') .NE. 0)       .AND. 
     .              (STR_SAME(attname, 'long_name') .NE. 0)      .AND. 
     .              (STR_SAME(attname, 'history') .NE. 0)        .AND. 
     .              (STR_SAME(attname, 'missing_value') .NE. 0)  .AND. 
     .              (STR_SAME(attname, '_FillValue') .NE. 0)     .AND. 
     .              (STR_SAME(attname, 'parent_grid') .NE. 0)    .AND. 
     .              (STR_SAME(attname, 'slab_min_index') .NE. 0) .AND. 
     .              (STR_SAME(attname, 'slab_max_index') .NE. 0) .AND. 
     .              (STR_SAME(attname, 'ferret_datatype') .NE. 0) .AND. 
     .              (STR_SAME(attname, 'infile_datatype') .NE. 0)

              IF (newatt) THEN
                 blen = 2048  ! len of attbuff
                 got_it = NC_GET_ATTRIB (dset, varid, attname, 
     .                                .TRUE., uvarname, blen, attlen, 
     .                                attoutflag, attbuff, vals)
                 IF (attlen .GT. 0) THEN

                 CALL ESCAPE_FOR_XML (attname, aname, slen)

		 IF (attype .EQ. NCCHAR)   atype = 'char'
		 IF (attype .EQ. NCBYTE)   atype = 'byte'
		 IF (attype .EQ. NCSHORT)  atype = 'int'
		 IF (attype .EQ. NCLONG)   atype = 'int'
		 IF (attype .EQ. NCFLOAT)  atype = 'float'
		 IF (attype .EQ. NCDOUBLE) atype = 'double'
		 alen = TM_LENSTR1(atype)

		 WRITE (risc_buff, 2040) aname(1:slen), atype(1:alen)
		 CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

		 IF (attype .NE. NCCHAR) THEN
		    slen = 1
		    attbuff = ' '
		    DO 150 i = 1, attlen
                       CALL FLOAT2STRING_FOR_XML (vals(i), attype, buff, slen)

                       CALL ESCAPE_FOR_XML (buff, outstring, llen)
                       WRITE ( risc_buff, 2050 ) outstring(1:llen)
                       CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
 150                CONTINUE
		 ELSE 
		    CALL ESCAPE_FOR_XML (attbuff, outstring, llen)
		    WRITE ( risc_buff, 2055 ) outstring(1:llen)
		    CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
		 ENDIF

		 WRITE ( risc_buff, 2060 )
		 CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

              ENDIF  ! attlen GT 0
              ENDIF

 200       CONTINUE

           grid = ds_grid_number(ivar)

! If its a string get the name and length of the string dimension.
           IF (vtype .EQ. NCCHAR ) THEN
              CALL CD_GET_DS_DIMS (dset, vdims(1), buff, npts, status)
              CALL SHOW_GRID_STRING_XML (lun, grid, unspecified_int4,
     .                  buff, npts)
	   ELSE
              CALL SHOW_GRID_XML (lun, grid, unspecified_int4)
	   ENDIF

	   WRITE ( risc_buff, 2070 )
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

 400	CONTINUE

* show the data-set-specific user-defined variables

	CALL deleted_list_get_undel(uvar_num_items_head,
     .                              let_d_uvars_list(1),
     .                              max_uvar, num_indices )
	DO 600 ivar = 1, num_indices
           i = let_d_uvars_list(ivar)

	   IF (uvar_dset(i) .EQ. dset .AND.
     .         uvar_parent(i) .EQ. 0   ) THEN

* ... output variable code, units, grid, and type
*     Skip intermediate variables by checking uvar_parent

             uvarname = uvar_name_code(i)
             IF (uvar_parent(i) .NE. 0) GOTO 600
	     IF (uvarname(1:3) .EQ. 'EX#') GOTO 600

	     CALL CD_GET_VAR_ID (dset, uvarname, varid, status)
             CALL CD_GET_VAR_INFO (dset, varid, uvarname, vtype, nvdims, 
     .          vdims, nvatts, coordvar, all_outflag, status)

             CALL ESCAPE_FOR_XML (uvarname, outstring, slen)
             WRITE ( risc_buff, 2010 ) outstring(1:slen)


             CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
             slen = TM_LENSTR1(uvar_text(i))
             CALL ESCAPE_FOR_XML (uvar_text(i), outstring, slen)
             WRITE ( risc_buff, 2020 ) 'definition'
             CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
             WRITE (risc_buff, 2055) outstring(1:slen)
             CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
             WRITE ( risc_buff, 2060 ) 
             CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

* Write the units and title
             slen = TM_LENSTR(uvar_units(i))
             IF (uvar_units(i)(1:2) .NE. char_init 
     .             .AND. slen.GT.0) THEN
                slen = TM_LENSTR1(uvar_units(i))
                CALL ESCAPE_FOR_XML (uvar_units(i), outstring, slen)
                WRITE ( risc_buff, 2020 ) 'units'
                CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
                WRITE (risc_buff, 2055) outstring(1:slen)
                CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
                WRITE ( risc_buff, 2060 ) 
                CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
		have_units = .TRUE.
             ENDIF

             slen = TM_LENSTR(uvar_title(i))
             IF (uvar_title(i)(1:2) .NE. char_init 
     .             .AND. slen.GT.0) THEN
                CALL ESCAPE_FOR_XML (uvar_title(i), outstring, slen)
                WRITE ( risc_buff, 2020 ) 'long_name'
                CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
                WRITE (risc_buff, 2055) outstring(1:slen)
                CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
                WRITE ( risc_buff, 2060 ) 
                CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
		have_title = .TRUE.
             ENDIF

! missing_flag and _FillValue same for user-variable 

             CALL FLOAT2STRING_FOR_XML (uvar_bad_data(i), attype, show_str, slen)
             CALL ESCAPE_FOR_XML (show_str, outstring, slen)
             WRITE ( risc_buff, 2030 ) '_FillValue' 
             CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
             WRITE (risc_buff, 2050) outstring(1:slen)
             CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
             WRITE ( risc_buff, 2060 ) 
             CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

             WRITE ( risc_buff, 2030 ) 'missing_value'
             CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
             WRITE (risc_buff, 2050) outstring(1:slen)
             CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
             WRITE ( risc_buff, 2060 ) 
             CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)


* Now get other attributes that may have been assigned.

	     CALL CD_GET_VAR_ID (dset, uvarname, varid, status)
             CALL CD_GET_VAR_INFO (dset, varid, uvarname, vtype, nvdims, 
     .          vdims, nvatts, coordvar, all_outflag, status)
             IF (status .NE. ferr_ok) GOTO 600  ! or where?
             DO 700 iatt = 1, nvatts

                CALL CD_GET_VAR_ATT_INFO (dset, varid, iatt, attname, 
     .              attype, attlen, attoutflag, status )

* All attributes not already listed.
* Skip 'parent_grid', 'slab_min_index', 'slab_max_index' as these
* wind up causing an incomplete spec of the grid in the F-TDS dataset.
* For transformed variables, the range, min, and max from the original variable
* do not apply.
* Attributes are inherited from the defining variable. That variable got 
* attributes direction, infile_datatype when writing from the header file
* based on the original dataset. ferret_datatype is defined just above. 
* Skip those here.

                newatt = .TRUE.
                newatt = 
     .              (STR_SAME(attname, 'missing_value')  .NE. 0) .AND. 
     .              (STR_SAME(attname, '_FillValue')     .NE. 0) .AND. 
     .              (STR_SAME(attname, 'parent_grid')    .NE. 0) .AND. 
     .              (STR_SAME(attname, 'slab_min_index') .NE. 0) .AND. 
     .              (STR_SAME(attname, 'slab_max_index') .NE. 0) .AND. 
     .              (STR_SAME(attname, 'valid_range') .NE. 0) .AND. 
     .              (STR_SAME(attname, 'valid_min') .NE. 0) .AND. 
     .              (STR_SAME(attname, 'valid_max') .NE. 0) .AND. 
     .              (STR_SAME(attname, 'direction') .NE. 0) .AND. 
     .              (STR_SAME(attname, 'ferret_datatype') .NE. 0) .AND. 
     .              (STR_SAME(attname, 'infile_datatype') .NE. 0)

                IF (STR_SAME(attname, 'units').EQ.0 .AND.have_units) 
     .                newatt = .FALSE.
                IF (STR_SAME(attname, 'long_name').EQ.0 .AND.
     .                have_title) newatt = .FALSE.


                IF (newatt) THEN
                  blen = 2048  ! len of attbuff
                  got_it = NC_GET_ATTRIB (dset, varid, attname, 
     .                                .TRUE., uvarname, blen, attlen, 
     .                                attoutflag, attbuff, vals)
                  IF (attlen .GT. 0) THEN

                   CALL ESCAPE_FOR_XML (attname, aname, slen)

                   IF (attype .EQ. NCCHAR)   atype = 'char'
                   IF (attype .EQ. NCBYTE)   atype = 'byte'
                   IF (attype .EQ. NCSHORT)  atype = 'int'
                   IF (attype .EQ. NCLONG)   atype = 'int'
                   IF (attype .EQ. NCFLOAT)  atype = 'float'
                   IF (attype .EQ. NCDOUBLE) atype = 'double'
                   alen = TM_LENSTR1(atype)

                   WRITE (risc_buff, 2040) aname(1:slen), atype(1:alen)
                   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

                   IF (attype .NE. NCCHAR) THEN
                      slen = 1
                      attbuff = ' '
                      DO 750 i = 1, attlen
                         CALL FLOAT2STRING_FOR_XML (vals(i), attype, buff, slen)
                         CALL ESCAPE_FOR_XML (buff, outstring, llen)
                         WRITE ( risc_buff, 2050 ) outstring(1:llen)
                         CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
 750                  CONTINUE
                   ELSE 
		      CALL ESCAPE_FOR_XML (attbuff, outstring, llen)
		      WRITE ( risc_buff, 2055 ) outstring(1:llen)
		      CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
		   ENDIF

                   WRITE ( risc_buff, 2060 )
                   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

                 ENDIF  ! attlen GT 0
                ENDIF  ! newatt
 
 700         CONTINUE

* The grid, if available.
             grid = GRID_FROM_NAME_XML( uvarname, cx_last, cx_expr, status )
	     
             IF (status .EQ. ferr_ok .AND. grid.NE.unspecified_int4) THEN

* Once the grid is set, the dtype is also known. Write that, then the grid.

                iset = uvar_dset(i)
                IF (iset .LE. pdset_irrelevant) iset = pdset_uvars
                CALL GET_SAVED_UVAR_DTYPE(i, iset, itype)

                show_str = 'FLOAT'
                IF (itype .EQ. ptype_string ) show_str = 'STRING'

                CALL ESCAPE_FOR_XML (show_str, outstring, slen)
                WRITE ( risc_buff, 2020 ) 'ferret_datatype'
		
                CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

                WRITE (risc_buff, 2055) outstring(1:slen)
                CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
                WRITE ( risc_buff, 2060 ) 
                CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)      

	        CALL SHOW_GRID_XML (lun, grid, cx_expr)

	     ENDIF
             WRITE ( risc_buff, 2070 )
             CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
         ENDIF  ! uvar_dset(i) .EQ. dset .AND. uvar_parent(i) .EQ. 0
 600  CONTINUE


* Write the axes used in the dataset
      
      risc_buff = '</dataset>'
      CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
      risc_buff = '</datasets>'
      CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

      risc_buff = '<axes>'
      CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
      DO 800, i = 1, line_ceiling
         IF (line_write(i)) CALL SHOW_LINE_XML( show_lun, i)
 800  CONTINUE

      risc_buff = '</axes>'
      CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)

* were there string variables?  If so write basic info about their string dimensions.

      have_dims = .FALSE.
      DO 900 i = 1, maxvars
         IF ( ds_var_setnum(i) .NE. dset ) GOTO 900
         IF ( ds_var_code(i) .EQ. '-' ) GOTO 900  
         uvarname = ds_var_code(i)

         CALL CD_GET_VAR_ID (dset, uvarname, varid, status)
         CALL CD_GET_VAR_INFO (dset, varid, uvarname, vtype, nvdims,
     .         vdims, nvatts, coordvar, all_outflag, status)
         IF (vtype .EQ. NCCHAR ) THEN
            IF (.NOT.have_dims) THEN
               have_dims = .TRUE.
               risc_buff = '<dimensions>'
               CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
            ENDIF

	    CALL CD_GET_DS_DIMS (dset, vdims(1), buff, npts, status)
            CALL SHOW_DIM_XML(buff, npts, show_lun)
         ENDIF
 900  CONTINUE
                  
      IF (have_dims) THEN
         risc_buff = '</dimensions>'
         CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
       ENDIF

* Restore the default data set

      cx_data_set(cx_last) = dset_save

 5000 RETURN
 5100   CALL errmsg( ferr_unknown_grid, status, 
     .          'Cannot get grid for variable', *5000 )
      END

	SUBROUTINE FILL_FMRC_TIME_GAPS (has_gaps, time2d, edge2d,
     .					nt, nf, lagF, status)

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* NOAA/PMEL, Seattle, WA - TMAP 

* if there are gaps in the forecast array that was provided, there will be
* missing rows in the 2d time array.  This routine fills thos gaps.
*
* V698 *sh* 12/15 
* V710 *acm* 1/17 Fix ticket 2500: TM_DFPEQ to handle tiny precision differences

* calling arguments
*   has_gaps - (in) flag if gap-filling is needed
*   time2d - (in) 2d forecast time step array (with missing time series)
*   edge2d - (in) 2d forecast time lower bound array (also with missing points)
*   nT	   - (in) number of time pointss in each forecast
*   nF	   - (in) number of forecasts
*   lagF   - (in) number of model time steps of lag between forecasts (output)

* calling argument declarations:
	LOGICAL has_gaps
	INTEGER nT, nF, lagF, status
	REAL time2d(nT, nF), edge2d(nT, nF)

* internal variable declarations:
	LOGICAL TM_DFPEQ
	INTEGER ifcst, istep, ifcst2, istep2
	REAL	tref
	CHARACTER LEFINT*8

	include 'ferret.parm'
	include 'errmsg.parm'
	
* initialize
	status = ferr_ok

* determine the number of indices lagged between rows
* the first and last time series are guaranteed to be present
* find the column where it is first found in a subsequent row
	tref = time2d(nT,1)
	DO ifcst = 2, nF
* ... find the next forecast that exists
	   IF (time2d(1,ifcst) .EQ. unspecified_val8) CYCLE
* ... find the time step of this forecast where tref gets repeated
	   DO istep = nT, 1, -1
	      IF (TM_DFPEQ(time2d(istep, ifcst), tref)) THEN
	         lagF = (nT-istep)/(ifcst-1)
	         GOTO 100
	      ENDIF
	   ENDDO
	   GOTO 5100  ! tref not found in this forecast
	ENDDO
	GOTO 5100     ! should never get here

 100	IF (.NOT.has_gaps) RETURN    ! we computed lagF.  Thats enuf

* fill in the missing time step values from adjoining rows
	DO ifcst = 2, nF
* ... skip valid forecasts
	   IF (time2d(1,ifcst) .NE. unspecified_val8) CYCLE
* ... copy the upper times from the preceding forecast
	   DO istep = lagF+1, nT
	      time2d(istep-lagF, ifcst) = time2d(istep, ifcst-1)
	      edge2d(istep-lagF, ifcst) = edge2d(istep, ifcst-1)
	   ENDDO
* ... look ahead to find the next valid forecast
	   DO ifcst2 = ifcst+1, nF
	      IF (time2d(1,ifcst2) .NE. unspecified_val8) GOTO 110
	   ENDDO
	   GOTO 5100  ! can never get here cuz the final row always exists
* ... copy the lower times from this future forecast
 110	   istep2 = (ifcst2-ifcst)*lagF
	   IF (istep2 .GT. nT-lagF) GOTO 5100  ! void too long
	   DO istep = nT-lagF+1, nT
	      time2d(istep,ifcst) = time2d(istep-istep2, ifcst2)
	      edge2d(istep,ifcst) = edge2d(istep-istep2, ifcst2)
	   ENDDO
	ENDDO

* success
	status = ferr_ok
	RETURN

* error exits
 5000	RETURN
 5100	CALL ERRMSG( ferr_aggregate_error, status,
     .		'time steps corrupted or '//
     .		'too many missing forecasts in a row at forecast '//
     .		LEFINT(ifcst, ifcst2), *5000 )

	END

	SUBROUTINE APPLY_DSG_E_CONSTRAINTS(dset, cx)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* The E (=instances =features) ww limits on this context have been altered
* so re-compute the ww constraints in this context to reflect the restricted
* feature collection

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V720 5/17 *sh*

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xtm_grid.cmn_text'
	include 'xdset_info.cmn_text'
	include 'xdyn_linemem.cmn_text'
	include 'xcontext.cmn'
	include 'xdsg_context.cmn'
	include 'xvariables.cmn'

* calling argument declarations:
	INTEGER dset, cx

* internal variable declarations:
	INTEGER idim, rslm, base, ifeature, flen
	REAL	cmin(4), cmax(4), lolims(4), hilims(4)

* initialize
	rslm = dsg_loaded_lm(dsg_row_size_var(dset))
	DO idim = 1, 4
	  cmin(idim) = arbitrary_large_val8
	  cmax(idim) = arbitrary_small_val8
	ENDDO

* find the base index of the lowest unmasked E feature
	base = 0
	DO ifeature = 1, cxdsg_lo_e-1
	   base = base + dsg_linemem(rslm)%ptr(ifeature)
	ENDDO

* find the min and max coordinate limits including only features that are 
* NOT masked out by E limits
	DO ifeature = cxdsg_lo_e, cxdsg_hi_e
	   flen = dsg_linemem(rslm)%ptr(ifeature)
	   CALL	DSG_ONE_FEATURE_LIMS(dset, base, flen, ifeature,
     .				     lolims, hilims)
	   DO idim = 1, 4
	      IF (lolims(idim) .LT. cmin(idim)) cmin(idim) = lolims(idim)
	      IF (hilims(idim) .GT. cmax(idim)) cmax(idim) = hilims(idim)
	   ENDDO
	   base = base + flen
	ENDDO

* narrow the XYZT context lims as indicated by what we've just learned
	DO idim = 1, 4
	   IF (cx_lo_ww(idim,cx) .EQ. unspecified_val8) THEN
	      cx_lo_ww(idim,cx) = cmin(idim)
	   ELSE
	      IF (cmin(idim) .GT. cx_lo_ww(idim,cx))
     .				  cx_lo_ww(idim,cx) = cmin(idim)
	   ENDIF

	   IF (cx_hi_ww(idim,cx) .EQ. unspecified_val8) THEN
	      cx_hi_ww(idim,cx) = cmax(idim)
	   ELSE
	      IF (cmax(idim) .LT. cx_hi_ww(idim,cx))
     .				  cx_hi_ww(idim,cx) = cmax(idim)
	   ENDIF

	ENDDO

	RETURN
	END

* 
*  expndi_id_by_z_counts.F
* 
*  Ansley Manke (from expndi_by_z)
*  8/24/2011
* 
* Create a variable with profile ID, where argument 1 is the length
* of the variable to be put into an XZ structure from it with the 
* separation between Z columns given by the lengths specified in 
* argument 2. Argument 2 is a list of length N, where N is the number of 
* Z columns to create, and each item in the list is the length of that 
* column (the length of the cruise or profile). Thus the Z columns created 
* are "ragged" Typical use is that arg 1 is a collection of vertical casts 
* appended end-to-end and that arg 2 is the number of values in each cast.
* The sum of the values in arg 2 is the length of argument 1. 

*  Args 3 and 4 are constants -- the size of the X and Z axes, respectively
 
*  In this subroutine we provide information about
*  the function.  The user configurable information 
*  consists of the following:
* 
*  descr              Text description of the function
* 
*  num_args           Required number of arguments
* 
*  axis_inheritance   Type of axis for the result
*                        ( CUSTOM, IMPLIED_BY_Z_ARGS, NORMAL, ABSTRACT )
*                        CUSTOM          - user defined axis
*                        IMPLIED_BY_Z_ARGS - same axis as the incoming argument
*                        NORMAL          - the result is normal to this axis
*                        ABSTRACT        - an axis which only has index values
* 
*  piecemeal_ok       For memory optimization:
*                        axes where calculation may be performed piecemeal
*                        ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE expndi_id_by_z_counts_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .  'Create 2D list, ID by profile-length on an XZ grid. (Typ. to split Z-profiles)' )

      CALL ef_set_num_args(id, 2)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, ABSTRACT, 
     .     IMPLIED_BY_ARGS, ABSTRACT, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'counts')
      CALL ef_set_arg_desc(id, arg,
     .          'count of values in each profile')
      CALL ef_set_axis_influence(id, arg, NO, YES, NO, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'max profile len')
      CALL ef_set_arg_desc(id, arg,
     .          'K size of result (constant)')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END






*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE expndi_id_by_z_counts_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      REAL size
      integer arg, nx, nz
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

*
*     Use utility functions to get context information about the arguments.
*
* output X axis size
* output Z axis size

* Length of x

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      arg = 1
      nx = arg_hi_ss(X_AXIS,arg) - arg_lo_ss(X_AXIS,arg) + 1
      CALL ef_set_axis_limits(id, X_AXIS, 1, nx)

* Length of z 
      CALL ef_get_one_val(id, ARG2, size)
      nz = INT(size)

      CALL ef_set_axis_limits(id, X_AXIS, 1, nx)
      CALL ef_set_axis_limits(id, Z_AXIS, 1, nz)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END



* 
*  In this subroutine we compute the result
* 
      SUBROUTINE expndi_id_by_z_counts_compute(id, arg_1, arg_2, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy,
     .	   mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy,
     .     mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER j1, k1, l1
      INTEGER iout, kout, isum, kend, xlen, zlen
      REAL size

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* Length of x*z 

      xlen = arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 1
      zlen = res_hi_ss(Z_AXIS) - res_lo_ss(Z_AXIS) + 1

* arg 1 must not depend on z
      IF ( (arg_lo_ss(Z_AXIS,ARG1) .NE. arg_hi_ss(Z_AXIS,ARG1)) ) CALL
     .           EF_BAIL_OUT(id, 'Z size of arg 1 must be 1')

* pre-fill the entire output result with missing value flags
*  (since length of each profile may have different number of pts)
      DO 60 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         DO 50 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            DO 40 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
               DO 30 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
 30            result(i,j,k,l) = bad_flag_result
 40         CONTINUE
 50      CONTINUE
 60   CONTINUE

* fill in the points as specified by the counts
      k1 = arg_lo_ss(Z_AXIS,ARG1)

      l1 = arg_lo_ss(T_AXIS,ARG1)
      DO 400 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

	    i1 = 1
            DO 200 iout = 1, xlen
	       kend = INT(arg_2(iout,j2,k2,l2))
               DO 100 kout = 1, kend
                  result(iout,j,kout,l) = iout
                  i1 = i1 + 1
 100           CONTINUE
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 300     CONTINUE

         l1 = l1 + arg_incr(T_AXIS,ARG1)
 400  CONTINUE
      
         
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	SUBROUTINE AUX_REGRID_LIMS( dst_cx, src_cx, axis_list, naxis,
     .			aux1, mr1, cx1,
     .			aux2, mr2, cx2,
     .			aux3, mr3, cx3,
     .			status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Given a context describing data to be regridded to a destination grid
* create the description of the needed source data in the source context
* Use the auxiliary variables to determine the index range of data needed
* For example, if the regrid has requested depth from 0 to 100 and in the 
* auxiliary variable containing depths all of the values LE 100
* are in K=1:6 then we need only request source data over the range K=1:7 

* When called the source context should be a copy of the destination context 

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

*V685  4/13 *sh*
*V689+ 3/15 *sh* added T-axis F-T orthoganalization
*      5/15 *sh* generalize to allow 1D aux vars on all axes

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'implicit.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'

* calling argument declarations:
	INTEGER	src_cx, axis, dst_cx, naxis, axis_list(*), status,
     .		mr1, cx1, mr2, cx2, mr3, cx3 
        REAL*8  aux1(*), aux2(*), aux3(*)

* internal variable declarations
	INTEGER	axis1, axis2


* this is just a dispatch routine that fans out to routines
* based upon the number of dimensions in the regridding
	axis1 = axis_list(1)
	axis2 = axis_list(2)
	IF ( naxis .EQ. 1 ) THEN
	   IF ( axis1 .EQ. t_dim
     .    .AND. cx_regrid_trans(axis1,dst_cx) .EQ. pauxrgrd_fmrc) THEN
	      CALL AUX_REGRID_LIMS_1D_T( dst_cx, src_cx, axis1, naxis,
     .			                 aux1, mr1, cx1, status )
	   ELSE
	      CALL AUX_REGRID_LIMS_1D( dst_cx, src_cx, axis1,
     .				 mr_lo_ss(mr1,axis1), mr_hi_ss(mr1,axis1),
     .			         aux1, mr1, cx1, status )
	   ENDIF
	   IF (status .NE. ferr_ok) GOTO 5000

	ELSEIF (naxis .EQ. 2) THEN
	   IF ( axis1.EQ.t_dim .AND. axis2.EQ.f_dim) THEN
	      CALL AUX_REGRID_LIMS_2D_TF( dst_cx, src_cx, axis_list, naxis,
     .			                 aux1, mr1, cx1, status )
	   ELSE
	      CALL ERRMSG(ferr_too_many_args, status,
     .		'only 1D auxiliary variable regridding available at this time',
     .		 *5000 )
	   ENDIF

	ELSE
	      CALL ERRMSG(ferr_too_many_args, status,
     .		'only 1D auxiliary variable regridding available at this time',
     .		 *5000 )
	ENDIF

* success
        status = ferr_ok
	RETURN

* error exit
 5000	RETURN
! 5100	CALL ERRMSG( ferr_invalid_command, status,
!     .     '1-dim auxiliary variable regrid allowed'//
!     .	   ' on Z and T axes only', *5000)
	END

	SUBROUTINE COPY_AGG_PTR_INTO_SUB( aloc, cxlo, cxhi, agg_dim,
     .		src, slox, shix, sloy, shiy, sloz, shiz, 
     .		slot, shit, sloe, shie, slof, shif,
     .		dst, dlox, dhix, dloy, dhiy, dloz, dhiz, 
     .		dlot, dhit, dloe, dhie, dlof, dhif  )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* copy data from source grid into dstination grid using limits of source
* context (i.e. destination grid is ASSUMED) big enough to hold data
* Copy the aggregate member into Aggregate-axis location pointed to
* by index aloc.
*
* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Thermal Modeling and Analysis Program
*
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V695 2/15 *acm* 6D add aggregation in forecast direction
*
	include 'ferret.parm'

* calling argument declarations:
	INTEGER aloc, cxlo(*), cxhi(*), agg_dim,
     .		slox, shix, sloy, shiy, sloz, shiz, 
     .		slot, shit, sloe, shie, slof, shif,
     .		dlox, dhix, dloy, dhiy, dloz, dhiz, 
     .		dlot, dhit, dloe, dhie, dlof, dhif
	REAL*8  src( slox:shix,sloy:shiy,sloz:shiz,slot:shit,sloe:shie,slof:shif ),
     .		dst( dlox:dhix,dloy:dhiy,dloz:dhiz,dlot:dhit,dloe:dhie,dlof:dhif )

* internal variable declarations:
	INTEGER	i, j, k, l, m, n

* --- end of introductory code ---

	IF (agg_dim .EQ. e_dim) THEN
	   m = cxlo(agg_dim)
           DO 100 n = cxlo(6), cxhi(6)
	   DO 100 l = cxlo(4), cxhi(4)
	   DO 100 k = cxlo(3), cxhi(3)
	   DO 100 j = cxlo(2), cxhi(2)
	   DO 100 i = cxlo(1), cxhi(1)

	      CALL COPY_C_STRING( src(i,j,k,l,m,n), dst(i,j,k,l,aloc,n) )

 100	   CONTINUE
	ENDIF

	IF (agg_dim .EQ. f_dim) THEN
	   n = cxlo(agg_dim)
           DO 200 m = cxlo(5), cxhi(5)
	   DO 200 l = cxlo(4), cxhi(4)
	   DO 200 k = cxlo(3), cxhi(3)
	   DO 200 j = cxlo(2), cxhi(2)
	   DO 200 i = cxlo(1), cxhi(1)

	      CALL COPY_C_STRING( src(i,j,k,l,m,n), dst(i,j,k,l,m,aloc) )

 200	   CONTINUE
	ENDIF

	RETURN
	END 

	LOGICAL FUNCTION CD_GET_ATTVAL ( cdfid, varid, attrib,
     .                                   do_warn, vname,
     .                                   val, vlen, vback )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* get numerical attributes from a netCDF file if the attribute exists
* convert all attribute values to floating point
* the netCDF file is assumed to be open
* Note: this routine is "quick and dirty" - long arrays of non-float type
*       or high double precision exponents may blow it up

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 2/92
*
* 11/96 *kob*  - Linux Port
*	       - had to add an real*4 buffer to the buff equivalence.  
*		 Linux f77 complained aobut inconsistent datatypes
*
* 4/98  *kob*  - fix bug introduced by above.  Linux f90 compiler will not allow
*                r8 buff to be passed to NCAGT, complaining of inconsistent 
*                datatypes.  SO, r4buff is passed to NCAGT, but really only as the
*                address pointer.  then, when the values are actually used, r8buff
*                is the buffer from which they are read.  this allows dp attribute
*                values to be used correctly.
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V65  *acm* 2/10- all warnings and notes to std error not std out
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* argument definitions:
*	cdfid	 - netCDF id number for already opened CDF file
*       varid    - variable id in netCDF file
*       attrib   - attribute to search for
*	do_warn	 - logical flag to issue warning if invalid attribute
*       vname    - name of variable owning attribute (used in error msgs)
*       val      - array into which to return result
*       vlen     - maximum allowable return array len
*       vback    - number of elements in return array

* argument declarations
      LOGICAL       do_warn
      INTEGER	    cdfid, varid, vlen, vback
      CHARACTER*(*) attrib, vname
      REAL val(vlen)

      include 'netcdf.inc'
      include 'xio.cmn_text'

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

#  ifdef sun
      BYTE i1buff(132)
#  else
      INTEGER*1 i1buff(132)
#  endif

* internal variable declarations:
      INTEGER TM_LENSTR1, lena, attype, cdfstat, i
      CHARACTER*132 buff

* equivalent buffer arrays for various data types
      INTEGER*2 i2buff(64)
      INTEGER*4 i4buff(32)
      REAL*4 	r4buff(32)		!kob 11/96
      REAL*8    r8buff(16)
      EQUIVALENCE (buff,i1buff),
     .            (buff,i2buff),
     .            (buff,i4buff),
     .            (buff,r4buff),	!kob 11/96
     .            (buff,r8buff)

* inquire about the attribute by name
      lena = TM_LENSTR1( attrib )
#ifdef usingDODSf2cUnderscore
      cdfstat = NF_INQ_ATT_(cdfid, varid, attrib(:lena), attype, vback )
#else
      cdfstat = NF_INQ_ATT (cdfid, varid, attrib(:lena), attype, vback )
#endif
      IF ( cdfstat .EQ. NF_NOERR ) THEN
         IF ( vback .GT. vlen ) THEN
            buff = 'too many values in attribute "'//attrib(:lena)//
     .             '" in netCDF file variable: '//vname
            lena = TM_LENSTR1( buff )
            IF ( do_warn ) CALL TM_NOTE( buff(:lena), lunit_errors )
            CD_GET_ATTVAL = .FALSE.
         ELSEIF (attype.EQ.NF_FLOAT) THEN
#ifdef usingDODSf2cUnderscore
	    cdfstat = NF_GET_ATT_REAL_(cdfid, varid, attrib, r4buff)
#else
	    cdfstat = NF_GET_ATT_REAL (cdfid, varid, attrib, r4buff)
#endif
	    CD_GET_ATTVAL = .TRUE.
         ELSEIF (attype.EQ.NF_DOUBLE) THEN
#ifdef usingDODSf2cUnderscore
	    cdfstat = NF_GET_ATT_DOUBLE_(cdfid, varid, attrib, r4buff)
#else
	    cdfstat = NF_GET_ATT_DOUBLE (cdfid, varid, attrib, r4buff)
#endif
            CD_GET_ATTVAL = .TRUE.
         ELSEIF (attype.EQ.NF_INT1) THEN
#ifdef usingDODSf2cUnderscore
	    cdfstat = NF_GET_ATT_INT1_(cdfid, varid, attrib, r4buff)
#else
	    cdfstat = NF_GET_ATT_INT1 (cdfid, varid, attrib, r4buff)
#endif
            CD_GET_ATTVAL = .TRUE.
         ELSEIF (attype.EQ.NF_INT2) THEN  ! SHORT same as INT2
#ifdef usingDODSf2cUnderscore
	    cdfstat = NF_GET_ATT_INT2_(cdfid, varid, attrib, r4buff)
#else
	    cdfstat = NF_GET_ATT_INT2 (cdfid, varid, attrib, r4buff)
#endif
            CD_GET_ATTVAL = .TRUE.
         ELSEIF (attype.EQ.NF_INT) THEN  ! INT prev. also called LONG
#ifdef usingDODSf2cUnderscore
	    cdfstat = NF_GET_ATT_INT_(cdfid, varid, attrib, r4buff)
#else
	    cdfstat = NF_GET_ATT_INT (cdfid, varid, attrib, r4buff)
#endif
            CD_GET_ATTVAL = .TRUE.
         ELSE
            CD_GET_ATTVAL = .FALSE.
            vback = 0
	 ENDIF
	 
* convert data types
         IF (CD_GET_ATTVAL) THEN
            IF (attype.EQ.NF_BYTE .OR. attype.EQ.NF_CHAR ) THEN
               DO 100 i = 1, vback
 100           val(i) = i1buff(i)
            ELSEIF (attype.EQ.NF_INT2) THEN
               DO 200 i = 1, vback
 200           val(i) = i2buff(i)
            ELSEIF (attype.EQ.NF_INT ) THEN
               DO 300 i = 1, vback
 300           val(i) = i4buff(i)
            ELSEIF (attype.EQ.NF_FLOAT ) THEN
               DO 400 i = 1, vback
 400           val(i) = r4buff(i)  
            ELSE
               DO 500 i = 1, vback
 500           val(i) = r8buff(i)  
! 500           val(i) = r4buff(i)   ! kob 4/98
            ENDIF
	 ENDIF

      ELSE
         CD_GET_ATTVAL = .FALSE.
         vback = 0
      ENDIF

      RETURN
      END

	SUBROUTINE IS_MODULO(  *, *, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* pull together the pieces of a "modulo" (wrap-around) read along an axis by
* inserting pieces obtained by non-modulo reads (within the base axis limits)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V320: 19/9/94
* V420: 11/95 - added RECONCILE_COM_DST_CX for use in modulo regridding
*	      - auto-modulo (stripped off in INTERP_STACK for all classes
*		of variables) can no longer assume that the component data
*		lies strictly in the base region
*	      - If the result is "pathological" then flag it as "un-cached"
*		so it will not be reused.
* V533: *sh* 6/01 - allow modulo of variables with strides (cx_delta) 
* V550: *sh* 2/02 - added support for subspan modulo axes
*		    by CAXIS_LEN -> CAXIS_MODLEN
*		  - pre-fill strings with null strings as with FILL_MEMORY
* 560: *acm* 4/04 - stride/modulo fixes: use NINT to convert REAL*8 to integer
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

	include	'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'
	include	'xtext_info.cmn'

* calling argument declarations:
	INTEGER	status
* normal return is for error conditions
* exit #1 is to request another grid ( stack has been pushed )
* exit #2 is to signal completion of the activity at this stack level

*   ... interpretation stack setup at the time this is called ...
*	stack level		stack contents
*	isp+1	<--	level of last activity ( component just computed )
*	 isp	<--	current stack level (for moduloing )

* internal variable declarations:
	LOGICAL	TM_ITS_SUBSPAN_MODULO
	INTEGER CAXIS_MODLEN, CX_DIM_LEN, MODULO_PARITY, MGRID_SIZE_DELTA,
     .		CGRID_AXIS,
     .		com_mr, res_mr, com_cx, res_cx,	com_isp, res_isp,
     .		npts, idim, i, phase, res_lo, res_hi, xlate, nmod,
     .		tmp_mr, nrepl, rqst_cx, idel, lo_parity


* --- end of introductory code ---

* this routine attempt to replicate **whatever** component data has been
* supplied to form a modulo result.  Normally the component data will
* lie within the base range, 1 to Npts, (length of modulo cycle).  However,
* in odd cases the component data may be anywhere and of any size.  This
* routine will base its modulo output on the first Npts of the component
* data.  It will go back to get further component data only if instructed
* to do so by IS_STRIP (i.e. phase==isphase_1)


* |++++++++|--------|--------|--------|--------|   <-- replicated modulo axis
*                              |-------------|	   <-- available component data
*               |----------------|		   <-- requested region

* Examples of the odd cases would be
*   LIST/i=50:60 v5[i=30:40]    where v5 is on a 5 point modulo.
*   (The incoming component to modulo i=50:60 will be i=30:40.)
* or
*   LET v = temp[g=gmod,L=big:really_big]  ! regrid non-modulo to a modulo axis
*   LIST/L=1:48 v
*   (The incoming component is non-modulo and located at big L values.) 

* The special case in which IS_STRIP will supply data in two phases is when
* a small modulo result is requested that crosses a modulo boundary:
* |++++++++|--------|--------|--------|--------|   <-- replicated modulo axis
*                |-----|		   	   <-- requested region
*                 ^ | ^
*	Phase:    1   2

* initialize
	res_isp    = isp
	com_isp    = isp + 1
	res_mr     = is_mr( res_isp )
	com_mr     = is_mr( com_isp )
	res_cx     = is_cx( res_isp )
	rqst_cx    = is_big_cx( res_isp )
	com_cx     = is_cx( com_isp )
	idim       = is_axis( res_isp )
	npts	   = CAXIS_MODLEN( idim, com_cx )
	phase	   = is_phase(isp)
	IF (cx_delta(idim,res_cx) .EQ. unspecified_val8) THEN
	   idel = 1
	ELSE
	   idel = NINT(cx_delta(idim,res_cx))
	ENDIF
!	nonfactorstride = npts .NE. (npts/idel)*idel

* diagnostic mode output: " doing modulo VAR_NAME[x=lo:hi,D=#]"
	IF ( mode_diagnostic ) 	CALL DIAG_OP
     .				( 'doing',isact_class_modulo, com_cx, idim )

	IF (.NOT.(phase.EQ.isphase_allatonce
     .	     .OR. phase.EQ.isphase_1.OR.phase.EQ.isphase_2) ) CALL ERRMSG
     .		(ferr_internal, status, 'modulo_phase_err', *5000)

	IF ( phase .NE. 2 ) THEN

* 11/95 complete the result context in case it has some unspecified limits
* (note: this never occurs on file variables because INTERP_STACK completes
*	 the context to make memory caching more efficient)
	   CALL RECONCILE_COM_DST_CX( com_cx, res_cx, idim )

* create context and mem. res. space if this is the first component recieved
	   CALL CREATE_MEM_VAR( res_cx, res_mr, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   is_mr( res_isp ) = res_mr

	   IF ( mr_type(res_mr) .EQ. ptype_string ) THEN
	      CALL INIT_C_STRING_ARRAY( MGRID_SIZE_DELTA(res_mr),
     .                               memry(res_mr)%ptr,
     .                               mr_c_pointer(res_mr)      )
	      CALL SET_NULL_C_STRING_ARRAY(mr_c_pointer(res_mr),
     .                                     MGRID_SIZE_DELTA(res_mr) )
	   ENDIF

* 11/95: if there might be voids in the result pre-fill with missing data flags
	   IF ( CX_DIM_LEN(idim,com_cx) .LT. npts
     .	  .AND. mr_type(res_mr) .EQ. ptype_float  ) CALL FILL_MEMORY
     .				( res_mr, mr_bad_data(res_mr) )

	   ENDIF

* If the component received (com_cx) does not match the component requested
* (rqst_cx) then we can proceed with the modulo but other calculations
* should not reuse it as it may have voids.  For example, if npts=10 then
* the results of "list/i=1:15 v1[i=3:7]" should not be reused.
	IF (cx_lo_ss(com_cx,idim) .NE. cx_lo_ss(rqst_cx,idim)
     . .OR. cx_hi_ss(com_cx,idim) .NE. cx_hi_ss(rqst_cx,idim) ) 
     .						CALL UN_CACHE(res_mr)

* The internals of this routine require a dual look at the components that
* are recieved:  in the view that arrives with the components they are located
* within the base region (non-modulo, I=1:npts) of the variable.  In order to
* copy into the result, however, they must also be viewable in the subscript
* range(s) of the result.  For this purpose dual memory table entries are
* created that will describe the component data.  The dual version will be
* deleted before exiting this routine.
! (could probably factor this code into CREATE_PERMUTATION for cleanup)
	CALL FIND_MR_SLOT( tmp_mr, status )
	IF ( status .NE. ferr_ok ) GOTO 5910
	CALL HOOK_MR_SLOT( com_cx, tmp_mr )     ! 1/17 was inside FIND_MR_SLOT
	CALL ASSIGN_MR_CX( com_cx, tmp_mr )     ! affects diag output, only
	DO 100 i = 1, nferdims
	   mr_lo_ss(tmp_mr,i) = mr_lo_ss(com_mr,i)
	   mr_hi_ss(tmp_mr,i) = mr_hi_ss(com_mr,i)
 100	CONTINUE
	mr_size(tmp_mr)   =  mr_size(com_mr)
	memry(tmp_mr)%ptr => memry(com_mr)%ptr 
	mr_protected(tmp_mr) = mr_table_entry_only

* * * * *
* Copy the component data into the result, replicating as we go
* ... watch for delta not a factor of npts -- parity shifts at each replication
	nrepl = (cx_hi_ss(res_cx,idim) - cx_lo_ss(res_cx,idim))
     .		   / npts

	res_hi = cx_lo_ss(res_cx,idim) - idel
	DO 300 i = 1, nrepl + 1
	   res_lo = res_hi + idel
	   lo_parity = MODULO_PARITY(res_lo, npts, idel)
	   res_hi = MIN(res_lo+(((npts-lo_parity)/idel)*idel),
     .		        cx_hi_ss(res_cx,idim))
	   CALL SHORT_MOD_COPY( 
     .				res_lo, res_hi, idim,
     .				com_cx, tmp_mr, res_cx, res_mr)
 300	CONTINUE
* * * * *


* Set up context to go back for data that is still needed
	IF( phase .EQ. isphase_1 ) THEN
* ... update the original rqst_cx to make new request
*     note: the variable EX#N may have become category file variable in com_cx 

* to support subspan modulo axes allow for void points at axis ends
	   res_lo = cx_lo_ss(res_cx,idim)
	   res_hi = cx_hi_ss(res_cx,idim)
	   IF ( TM_ITS_SUBSPAN_MODULO(CGRID_AXIS(idim,res_cx)) ) THEN
	      IF (MOD(res_lo,npts) .EQ. 0) res_lo = res_lo + 1
	      IF (MOD(res_hi,npts) .EQ. 0) res_hi = res_hi - 1
	   ENDIF

* calculate modulo translation
	   nmod = res_hi / npts
	   IF ( res_hi .LE. 0 ) nmod = nmod - 1
	   xlate = nmod * npts

* set lo to the parity of the first point needed in the right hand modulo
	   lo_parity = MODULO_PARITY(res_lo, npts, idel)
	   i = res_lo+((npts-lo_parity)/idel+1)*idel
	   IF ((res_lo/npts)*npts .EQ. res_lo) i = i - idel
	   cx_lo_ss(rqst_cx, idim) = MODULO_PARITY(i, npts, idel)
	   cx_hi_ss(rqst_cx, idim) = res_hi - xlate
	   cx_by_ss(idim,rqst_cx) = .TRUE.
	   CALL FLESH_OUT_AXIS( idim, rqst_cx, status )
	   IF ( status .NE. ferr_ok ) GOTO 5900

* ... set up the request for the next component 
	   CALL TRANSFER_CONTEXT( rqst_cx, com_cx )

* ... remove the component protection that signaled we needed it here
	   CALL MR_NOT_IN_USE( com_mr )
	   CALL DELETE_VARIABLE( tmp_mr )  ! delete the extra table entry
	   IF (mr_delta(idim,com_mr).NE.unspecified_val8)
     .		 CALL DELETE_VARIABLE( com_mr )  ! invalid since using mr_delta

* ... push the interpretation stack and go get the final component
	   is_phase(isp) = isphase_2
	   isp = com_isp
	   status = ferr_ok
	   RETURN 1

* Successful completion of modulo operation
	ELSE
	   CALL MR_NOT_IN_USE( com_mr )	! remove memory protection on component
	   CALL DELETE_VARIABLE( tmp_mr )  ! delete extra table entry
	   IF (mr_delta(idim,com_mr).NE.unspecified_val8)
     .		 CALL DELETE_VARIABLE( com_mr )  ! invalid since using mr_delta
	   cx_stack_ptr = cx_stack_ptr - 1 ! pop rqst_cx from context stack
	   cx_stack_ptr = cx_stack_ptr - 1 ! pop com_cx  from context stack
	   status = ferr_ok
	   RETURN 2
	ENDIF

* error exits
 5000	RETURN
 5900	CALL DELETE_VARIABLE( tmp_mr )  ! delete extra table entry
 5910	CALL DELETE_VARIABLE( res_mr )  ! delete invalid result
	CALL MR_NOT_IN_USE( com_mr )
	GOTO 5000
	END	

	SUBROUTINE PLOT_ALONG_DATA_SET_UP( status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* modify the interpretation of the command data so it looks like
* a collection of 1D lines in the "/ALONG" direction
* this will be accomplished by generating a list of contexts, each for a
* single line, each pointing to the same, shared memory-resident array

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V698 *sh* 3/16
*      *sh* 4/16 - tweak decimation behavior

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'slash.parm'
	include 'command.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xprog_state.cmn'
	include 'xplot_setup.cmn'
	include 'xtext_info.cmn'
	
* calling argument declarations:
	INTEGER	status

* internal variable declarations:
	LOGICAL has_keys
	INTEGER	CX_DIM_LEN, iline, nlines, stride(nferdims),
     .		ss(nferdims), ssmin(nferdims), ssmax(nferdims),
     .		idim, along_dim, the_dim, ndim, dim(nferdims),
     .		max_along_lines, cx0, the_cx, nreduce_axes, loc, slen
	REAL	reduce_factor
	CHARACTER*1 buff1, LEFINT*8, buff8*8

* initialize
	DO idim = 1, nferdims
	   stride(idim) = 1
	ENDDO

* get the desired orientation   e.g. "/ALONG=T"
	loc = qual_given( slash_plot_along )
	CALL EQUAL_STRING( cmnd_buff(qual_start(loc):qual_end(loc)),
     .                     buff1, status )
	IF (status .NE. ferr_ok) GOTO 5000
	DO along_dim = 1, nferdims
	   IF ( buff1 .EQ. ww_dim_name(along_dim) ) GOTO 100
	ENDDO
* ... unrecognized orientation	         
	GOTO 5100

* can only be a single argument in this form of the command
 100	IF (num_uvars_in_cmnd .GT.1) GOTO 5200

* how many individual lines have been requested?
	CALL TRANSFER_CONTEXT( is_cx(1), cx_buff )
	CALL GET_CX_DIMS(cx_buff, ndim, dim)
	nlines = 1
	DO idim = 1, ndim
	   the_dim = dim(idim)
	   IF (the_dim .EQ. along_dim) CYCLE
	   nlines = nlines * CX_DIM_LEN(the_dim, cx_buff)
	ENDDO
	IF (nlines .EQ. 1) RETURN   ! no action needed here

* have plot keys been requested?
	has_keys = qual_given(slash_plot_nokey) .EQ. 0
     .       .AND. qual_given(slash_plot_title) .EQ. 0

* how many individual lines are allowed
* (max_key_entries smaller than max_line_on_plot)
	max_along_lines = max_noframe_context - is_cx(1) + 1
	IF (max_along_lines .GT. max_line_on_plot) max_along_lines =
     .						   max_line_on_plot
	IF (has_keys) THEN
	   max_along_lines = max_key_entries
	   IF (nlines .GT. max_key_entries) THEN
	      buff8 = LEFINT( max_key_entries,  slen  )
	      CALL WARN('Decimating PLOT/ALONG lines to /KEY limit of '
     .			// buff8(:slen) )
	   ENDIF
	ELSEIF (nlines .GT. max_along_lines) THEN
	   buff8 = LEFINT( max_along_lines,  slen  )
	   CALL WARN('Decimating PLOT/ALONG lines to /NOKEY limit of '
     .			// buff8(:slen) )
	ENDIF

* if this exceeds the max allowed, figure out how to stride the other axes
	IF (nlines .GT. max_along_lines) THEN
	   reduce_factor = FLOAT(nlines) / max_along_lines
	   nreduce_axes = ndim - 1   ! no striding on the /ALONG axis
* ... an axis with only 2 points cannot be strided
	   DO idim = 1, ndim
	      the_dim = dim(idim)
	      IF (the_dim .EQ. along_dim) CYCLE
	      IF (CX_DIM_LEN(the_dim,cx_buff).EQ.2) nreduce_axes =
     .		nreduce_axes - 1	 
	   ENDDO
* ... all axes of len>2 get the same stride
	   reduce_factor = reduce_factor ** (1./nreduce_axes)
	   reduce_factor = INT(reduce_factor+0.9999)  ! round up
	   DO idim = 1, ndim
	      the_dim = dim(idim)
	      IF (the_dim .EQ. along_dim) CYCLE
	      IF (CX_DIM_LEN(the_dim,cx_buff).EQ.2) CYCLE
	      stride(the_dim) = reduce_factor
	   ENDDO
* ... what is the resulting number of lines?
	   nlines = 1
	   DO idim = 1, ndim
	      the_dim = dim(idim)
	      IF (the_dim .EQ. along_dim) CYCLE
	      nlines = nlines *
     .		       INT(CX_DIM_LEN(the_dim,cx_buff)/stride(the_dim))
	   ENDDO
	   IF (nlines .GT. max_along_lines) GOTO 5300
	ENDIF

* initiailize the axis subscript counters
	DO idim = 1, ndim
	   the_dim = dim(idim)
	   IF (the_dim .EQ. along_dim) CYCLE
	   ssmin(the_dim) = cx_lo_ss(cx_buff,the_dim)
	   ssmax(the_dim) = cx_hi_ss(cx_buff,the_dim)
	   ss(the_dim)    = ssmin(the_dim)
	ENDDO

* populate the contexts
	cx0 = is_cx(1) - 1
	DO iline = 1, nlines

	   is_mr(iline) = is_mr(1)  ! a single mr shared by all
! removed cuz num_uvar_in_cmnd is reset to 1 at end of XEQ_PLOT. Have to reset
! it because when same identical expression is found in NEXT command,
! GET_PROT_CMND_DATA declines to re-parse it, so that EX#1 can remain in memory
!	   CALL MR_IN_USE(is_mr(1))

	   the_cx = cx0 + iline
	   is_cx(iline) = the_cx
	   CALL TRANSFER_CONTEXT( cx_buff, the_cx )

* ... set the per-axis positions up
	   DO idim = 1, ndim
	      the_dim = dim(idim)
	      IF (the_dim .EQ. along_dim) CYCLE
	      cx_by_ss(the_dim, the_cx) = .TRUE.
	      cx_lo_ss(the_cx,the_dim) = ss(the_dim)
	      cx_hi_ss(the_cx,the_dim) = ss(the_dim)
	      CALL FLESH_OUT_AXIS( the_dim, the_cx, status )
	      IF (status .NE. ferr_ok) GOTO 5000
	   ENDDO

* ... prepare for the next context
	   DO idim = 1, ndim
	      the_dim = dim(idim)
	      IF (the_dim .EQ. along_dim) CYCLE
	      ss(the_dim) = ss(the_dim) + stride(the_dim)
	      IF (ss(the_dim) .LE. ssmax(the_dim)) THEN
	         EXIT
	      ELSE
	         ss(the_dim) = ssmin(the_dim)
	         CONTINUE     ! continue to the next dimension
	      ENDIF
	   ENDDO
	ENDDO

* un-bump by one, for the original cx, which has been over-written
! commented out along with CALL MR_IN_USE above
!	CALL MR_NOT_IN_USE(is_mr(1))

* make the rest of Ferret believe that all these lines were asked for
	num_uvars_in_cmnd = nlines

* successful completion
	RETURN

* error exit2
 5000	RETURN
 5100	CALL ERRMSG(ferr_invalid_command, status,
     .          "PLOT/ALONG='axis', where axis = X,Y,Z,T,E or F", *5000)
 5200	CALL ERRMSG(ferr_invalid_command, status,
     .          "Use just a single argument with PLOT/ALONG", *5000)
 5300	CALL ERRMSG(ferr_internal, status,
     .		"plot_along_data_set_up strides ??!!", *5000)

	END

	SUBROUTINE FINALIZE_VARIANCE( trans, size,
     .				      res_mr, res, wsum, s )

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* finalize the result of average or definite integral based up accumulated
* WIGHTED_SUM(values) and SUM(weights)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V702 *sh* 11/16 this routine performs the finalization step that was
*		  previously a part of DO_VAR_SUB

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'interp_stack.parm'
!	include	'xcontext.cmn'
	include	'xvariables.cmn'
!	include	'xmem_subsc.cmn'
!	include 'xunits.cmn_text'
!	external xunits_data
!	include 'xtm_grid.cmn_text'
!	external xgt_grid_data

* calling argument declarations:
	INTEGER	trans, size, res_mr
	REAL    res(size), wsum(size), s(size)

* internal variable declarations:
	LOGICAL	variance
	INTEGER	i
	REAL	bad_res

* --- end of introductory code ---

* initialize
	variance = trans .EQ. trans_variance
     .        .OR. trans .EQ. trans_4d_var
	bad_res = mr_bad_data( res_mr )

* finalize (luv it!)
	DO i = 1, size
	   IF (wsum(i) .EQ. 0.0D0) THEN
	      res(i) = bad_res			! no input values
	   ELSEIF (variance) THEN
	      res(i) = s(i)/wsum(i)		! variance
	   ELSE
	      res(i) = SQRT(s(i)/wsum(i))	! standard deviation
	   ENDIF
	ENDDO

	RETURN
	END

	SUBROUTINE IS_STRIP( act_class, idim, *, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* strip away the requirement for a transformation of a variable on the
* interpretation stack by dedicating a stack level to the evaluation of that
* transformation and putting a request for the first required component of the
* calculation onto the stack.

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 4/21/87
* ... (many revisions) ... revision 1.0 - 7/25/88 - added re-gridding code
* V200:  7/20/89 - 4D symmetrical - major re-write
*	10/16/89 - correct bug in regrid code when axis=0
*	 2/19/90 - corrected bug on RETURN when no regrid to do
*	 2/27/90 - pass through unspecified regions to be handled later
* V301:  2/24/94 - small change due to mode_arg as a 2D variable
* V320:	 12/8/94 - add modulo operations on all file variables
*	 2/21/95 - add support for reversed coordinate axes
* V420:  9/97/95 - bug fix for index=0:npts ("GT" should be "GE")
* 	   11/95 - strip of modulo wraps and allow gathering on modulo regrid
*		 - also, only gather a calculation if mode despeerate is SET
*		 - changed "csize" into "cxsize" to psych out a weird OSF bug
*	 	 - added isact_class_reconcile for command qualifiers
*		 - check for explicit limits with @ITP 
* V430:     7/96 - incorporate 4D transformations:  AVE, VAR, DIN, NDG, NBD
* V490:  9/97 - *sh* OFFSET_SS returns status
*	     - *kob* replaced call to ISUBSCRIPT w/ call to ISUBSCR_CX in order
*               to have access to context information - needed for negative
*               time step processing
* V510: *sh* 9/99 - remove warning about too-negative modulo. Change in
*	TM_WORLD has hopefully made this a legitimate operation
*	*sh* 1/00 - bug fix: @ITP failed to set subscripts if exact grid point
* V533: *sh* 6/01 - support for combined netCDF strides (cx_delta) and modulo
* V541: *sh* 2/02 - support for modulo axis lengtha
* 560: *acm* 4/04 - stride/modulo fixes: use NINT to convert REAL*8 to integer
* V602  8/06 *jli* chages for native strides 
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V690+ 11/13 *sh* support for auxiliary var regridding: temp[gz(depth)=zax]
* V698 1/16 *sh* fix to bug #2347 (agg res var no instead of com var on stack)
*		 alter agg setup to detect LET/D vars at eval time
*      4/16 *sh* Allow that SET VAR/NAME= has altered the agg varname
* V7   5/12 *acm* Union aggregations: DEFINE DATA/AGG/U
* V702 11/16 *sh* Allow split/gather logic to be used on axis of a compressing
*                 transform.
* V720  5/17 *sh* support for DSG operations
* V741 *acm* 5/18 Promoting global attributes to a variable in ensembles
* V741 *acm* 6/18  Last bit of 1868: multi-D trans, if requested w/ some 
*                  directions orthogonal to grid, those should be ignored
* V751 *acm* 6/19 Remove unused declarations
* V76  *acm* 3/20 Implementing regridding to point-type DSG data

        IMPLICIT NONE
	include 'tmap_dims.parm'
#   include "tmap_dset.parm"
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'
	include	'xalgebra.cmn'
	include	'xax_speed.cmn'
        include 'xtm_grid.cmn_text'
        include 'xdset_info.cmn_text'   ! DSG stuff
        include 'xfr_grid.cmn'

* calling argument declarations:
	INTEGER	act_class, idim, status
* RETURN 1 - goes back to strip off any remaining transformations

* internal variable declarations:
	LOGICAL	ITSA_MODULO_REGRID, TM_ITS_SUBSPAN_MODULO,
     .		ITSA_MODULO_AXIS, TM_SAME_GRID_DEF,
     .		SCALAR_GRID_LINE, TM_ITSA_DSG, ITSA_REGRID_FROM_DSG,
     .		itsa_uvar, modulo_dest_regrid, allatonce, attoutflag, 
     .		got_it, its_dsg
	INTEGER	CGRID_SIZE_MAX, CAXIS_LEN, CAXIS_MODLEN, CX_DIM_LEN, 
     .		AUX_AXIS_FROM_ARG, CGRID_AXIS, POTENT_SIZE, 
     .		ISUBSCR_CX, TM_AXES_REVERSED, CGRID_SIZE, MODULO_PARITY,
     .		STR_SAME, TM_LENSTR1, KNOWN_GRID, 
     .		TM_DSG_DSET_FROM_GRID, TM_DSG_OBS_GRID, TM_DSG_ORIENTATION,
     .		nrev, reversed(nferdims), idel,
     .		trans, grid, dset, lo_off, hi_off, aclass,
     .		lo_cx, hi_cx, big_cx, lo_isp, i, axis,
     .		var, ss, lo_ss, hi_ss, res_size,
     .		nmod, nmodhi, npts, xlate, dup_cx, i4d,
     .          line, imemb, imemb_dset, grids_dset, len, ncomp,
     .		orig_grid, iline, attlen, maxlen, orig_cat, orig_var,
     .		memb_dset, hi_cat, hi_var, hi_grid, agg_vlen, memb_vlen, slen,
     .		orientation, itrns, ndim
	INTEGER*8 available_mem, biggest_allowed
	REAL*8	TM_WORLD, ww_given, ww_nrst
	CHARACTER*128 VAR_CODE, agg_vname, memb_vname
	CHARACTER*128 buff
	CHARACTER LEFINT*6

* --- end of introductory code ---
* initiailize - ! temp:always called at bottom of stack frame for transform
	aclass = act_class
	lo_isp = isp
	lo_cx  = is_cx( lo_isp )
	grid   = cx_grid( lo_cx )
	dset   = cx_data_set( lo_cx )
	var    = cx_variable( lo_cx )
	axis   = idim
	is_phase( lo_isp ) = unspecified_int4	! diag housekeeping
	is_sum  ( lo_isp ) = unspecified_int4	! diag housekeeping
	itsa_uvar = cx_category(lo_cx) .EQ. cat_user_var
	modulo_dest_regrid = .FALSE.		! if regrid requires modulo
	big_cx = lo_cx   ! initialize default. Used in compressed split/gather
	trans  = trans_no_transform
	its_dsg = TM_ITSA_DSG(grid)

* set up a context buffer to be modified for various grids needed
	CALL CREATE_NEW_CONTEXT( lo_cx, hi_cx, status )	! pushes stack
	IF ( status .NE. ferr_ok ) GOTO 5000

****************

 100	IF (aclass .EQ. isact_class_aggregate_gather) THEN

* SET UP TO GATHER THE COMPONENTS OF AN AGGREGATE VARIABLE
* ***==> SEE DOCUMENTATION of agg handling in header of INIT_EF_AGGREGATE_DSET
	   is_act( lo_isp ) = isact_aggregate_gather

* set result pointer to indicate no memory result has been created yet
	   is_mr( lo_isp ) = unspecified_int4

* Set up context (hi_cx) to get the first requested aggregate member
* Start with bookkeeping to prepare to request component
	   is_sum( lo_isp ) = cx_hi_ss(lo_cx, idim)
	   is_phase( lo_isp ) = cx_lo_ss(lo_cx, idim)
	   CALL TRANSFER_CONTEXT( lo_cx, hi_cx )

	   imemb = is_phase( lo_isp )
* ... there is no E-axis in an E-agg of FMRCs on the 2dtime var TF_TIMES 
	   IF (imemb .EQ. unspecified_int4) imemb = 1  ! presume TF_TIMES E-agg
	   agg_vname = VAR_CODE (cat_file_var, cx_variable(hi_cx))
	   agg_vlen = TM_LENSTR1(agg_vname)
	   CALL CD_GET_AGG_VAR_INFO (dset, agg_vname, imemb, orig_cat, 
     .                memb_dset, orig_grid, iline, orig_var, status)

* Is it the 2D Time variable for a Forecast-aggregation?  If so then
* the field was cached and retrieved by FIND_MEM_VAR_INCL_C_CACHE
	   IF (memb_dset .EQ. pagg_promotion_indicator_dset)
     .		CALL ERRMSG(ferr_internal, status,
     .		'aggregation cache failure in is_strip', *5000)

* for special case (hack) of an E-aggregation of FMRCs, the 2dtime array comes
* from one particular member
	   IF (orig_cat .EQ. cat_ef_time2d) THEN
	      hi_cat = cat_file_var
	      hi_var = orig_var
	      hi_grid = orig_grid

	   ELSEIF (orig_cat .EQ. cat_agg_gpromote) THEN
	      hi_cat = cat_agg_gpromote
	      hi_var = orig_var 
	      hi_grid = mgrid_abstract
	   ELSE

* a couple of 'delayed mode' use cases to beware -- actions the user may have
* taken **SINCE** the aggregation was defined:
*  1) user may have issued a SET VAR/NAME= (rename) of the aggregated variable
*  2) user may have issued a LET/D on a member variable
* If 1, then agg_vname will differ from memb_vname 
* If 2, then cat# and var# associated with member name may have changed
* Do a fresh "find" for the original member variable name
	      memb_vname = VAR_CODE(orig_cat, orig_var)
	      memb_vlen = TM_LENSTR1(memb_vname)
	      CALL FIND_VAR_NAME (memb_dset,memb_vname, hi_cat, hi_var )
	      IF (hi_var .EQ. munknown_var_name) CALL ERRMSG(
     .		  ferr_aggregate_error, status, 'variable '//
     .		  memb_vname(:memb_vlen)//' no longer found in agg member '//
     .		  LEFINT(imemb,slen), *5000)

* confirm grid has not changed since stored during DEFINE DATA/AGG
	      hi_grid = KNOWN_GRID(memb_dset, hi_cat, hi_var)
	      IF (hi_grid .EQ. unspecified_int4) THEN   ! can only be a uvar
* ... GET_UVAR_GRID uses the interp_stack, so bump isp
	         isp = lo_isp + 1
	         CALL GET_UVAR_GRID( hi_var, memb_dset, status )
	         isp = lo_isp  ! restore to value at start of routine
                 IF ( status .NE. ferr_ok ) GOTO 5000
	         hi_grid = KNOWN_GRID(memb_dset, hi_cat, hi_var)
	      ENDIF

* check that component grid is conformable with aggregation
* (grid may have changed due to new LET/D definition)
	      CALL CONFORMABLE_AGG_GRID(idim, memb_vname, imemb,
     .                                  grid, cat_file_var, var,
     .                                  hi_grid, hi_cat, hi_var,
     .                                  orig_grid, status )
	      IF (status .NE. ferr_ok) GOTO 5000

* scalar axes of components need not match the agg result
	      DO i = 1, nferdims
	         IF ( i .NE. idim
     .	        .AND. SCALAR_GRID_LINE(i, hi_grid, hi_cat, hi_var))
     .						CALL DEL_CX_DIM(idim, hi_cx) 
	      ENDDO

* the T axis of an F-aggregation has a single set of indices but the time
* values differ for each axis.  Indices are inherited from the lo_cx
	      IF (idim .EQ. f_dim) THEN
	         cx_by_ss(t_dim, hi_cx) = .TRUE.
	         CALL FLESH_OUT_AXIS(t_dim, hi_cx, status )
	         IF (status .NE. ferr_ok) GOTO 5000
	      ENDIF
	   ENDIF

* Set limits on agg-direction to be unspecified
	   CALL DEL_CX_DIM(idim, hi_cx)
	   cx_by_ss(idim,hi_cx) = .TRUE.

* set up the member variable
	   cx_data_set(hi_cx) = memb_dset
	   cx_category(hi_cx) = hi_cat
	   cx_variable(hi_cx) = hi_var
	   cx_grid    (hi_cx) = hi_grid
	   CALL GET_CONTEXT_BAD_FLAG(hi_cx)

	   is_uvar(lo_isp) = hi_var ! relevant if component 1 is LET/D

*-*-*-*-*-*-*-*-*-*-

	ELSEIF (aclass .EQ. isact_class_union_member) THEN

* SET UP TO RETURN A VARIABLE IN A UNION AGGREGATION
	   is_act( lo_isp ) = isact_get_union_member

* set result pointer to indicate no memory result has been created yet
	   is_mr( lo_isp ) = unspecified_int4
	   is_sum( lo_isp ) = 1  ! or something... Set these equal.
	   is_phase( lo_isp ) = 1

* Set up context (hi_cx) to get the requested aggregate member
* Start with bookkeeping to prepare to request component
	   CALL TRANSFER_CONTEXT( lo_cx, hi_cx )

	   agg_vname = VAR_CODE (cat_file_var, cx_variable(hi_cx))
	   agg_vlen = TM_LENSTR1(agg_vname)

* Get the member dataset, and the grid. imemb is the variable # in the union.

	   CALL CD_GET_VAR_ID (dset, agg_vname, imemb, status)
	   CALL CD_GET_AGG_VAR_INFO (dset, agg_vname, imemb, orig_cat, 
     .                memb_dset, orig_grid, iline, orig_var, status)

* a couple of 'delayed mode' use cases to beware -- actions the user may have
* taken **SINCE** the aggregation was defined:
*  1) user may have issued a SET VAR/NAME= (rename) of the aggregated variable
*  2) user may have issued a LET/D on a member variable
* If 1, then agg_vname will differ from memb_vname 
* If 2, then cat# and var# associated with member name may have changed
* Do a fresh "find" for the original member variable name

	      memb_vname = VAR_CODE(orig_cat, orig_var)
	      memb_vlen = TM_LENSTR1(memb_vname)
	      CALL FIND_VAR_NAME (memb_dset,memb_vname, hi_cat, hi_var )
	      IF (hi_var .EQ. munknown_var_name) CALL ERRMSG(
     .		  ferr_aggregate_error, status, 'variable '//
     .		  memb_vname(:memb_vlen)//' no longer found in agg member '//
     .		  LEFINT(imemb,slen), *5000)

* confirm grid has not changed since stored during DEFINE DATA/AGG
	      hi_grid = KNOWN_GRID(memb_dset, hi_cat, hi_var)
	      IF (hi_grid .EQ. unspecified_int4) THEN   ! can only be a uvar
* ... GET_UVAR_GRID uses the interp_stack, so bump isp
	         isp = lo_isp + 1
	         CALL GET_UVAR_GRID( hi_var, memb_dset, status )
	         isp = lo_isp  ! restore to value at start of routine
                 IF ( status .NE. ferr_ok ) GOTO 5000
	         hi_grid = KNOWN_GRID(memb_dset, hi_cat, hi_var)
	      ENDIF

* set up the member variable
	   cx_data_set(hi_cx) = memb_dset
	   cx_category(hi_cx) = hi_cat
	   cx_variable(hi_cx) = hi_var
	   cx_grid    (hi_cx) = hi_grid
	   CALL GET_CONTEXT_BAD_FLAG(hi_cx)

c	   CALL TRANSFER_CONTEXT( hi_cx, lo_cx )

	   is_uvar(lo_isp) = hi_var ! relevant if component 1 is LET/D

*-*-*-*-*-*-*-*-*-*-

**************
	ELSEIF ( its_dsg .AND. aclass.EQ.isact_class_trans) THEN

* SET UP FOR A DSG TRANSFORMATION
	   trans  = cx_trans( axis, lo_cx )
	   is_act  ( lo_isp ) = isact_trans_code + trans
	   is_phase( lo_isp ) = isphase_allatonce
	   cx_trans    ( axis, hi_cx ) = trans_no_transform
	   cx_trans_arg( axis, hi_cx ) = bad_val4
* if a compressing transformation on the orientation axis 
* (e.g. T=@AVE on a tSeries) then the source data (hi_cx) will be on the
* DSG observation grid, whereas the result (lo_cx) is on the instance grid
* see get_context_grid
	   IF ( trans .GT. trans_compress_code ) THEN
	      dset = TM_DSG_DSET_FROM_GRID(grid)
	      orientation = dsg_orientation(dset)
	      IF (axis .EQ. orientation) THEN
* ... replace obs grid with instance grid
*     FLESH_OUT_AXIS will insert the correct ss limits
	         cx_grid(hi_cx) = TM_DSG_OBS_GRID(dset)
	      ENDIF
* ... set ss limits to full nfeature or nobs as the case may be
	      CALL FLESH_OUT_AXIS( axis, hi_cx, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   ENDIF
* no fleshing out of axes is needed -- always get full-dset limits and always
* carry along the WW limits to use as constraints when working on the data

**************
	ELSEIF ( aclass .EQ. isact_class_trans) THEN

* SET UP FOR A TRANSFORMATION
	   trans  = cx_trans( axis, lo_cx )
	   is_act  ( lo_isp ) = isact_trans_code + trans
	   is_phase( lo_isp ) = isphase_allatonce
	   cx_trans    ( axis, hi_cx ) = trans_no_transform
	   cx_trans_arg( axis, hi_cx ) = bad_val4

* 6/98: If  the transform was marked as a 4D transform, but the grid 
*       doesn't have more than one of the requested axes, reset to 
*       the 1D transform.

	   transloop: DO itrns = 1, num_4d_trans
	     IF (trans .EQ. alg_4d_trans(itrns)) THEN 
	        ndim = 0
	        DO i = 1, nferdims
	           IF (cx_trans(i,lo_cx) .NE. trans_no_transform) ndim = ndim + 1
	        ENDDO
	
	        IF (ndim .EQ. 1) THEN
                    DO i = 1, nferdims       
                       IF ( cx_trans(i,lo_cx) .EQ. trans ) 
     .	                     cx_trans( i,lo_cx) = alg_1d_to_4d(itrns)
                    ENDDO
		   trans = alg_1d_to_4d(itrns)
		   is_act  ( lo_isp ) = isact_trans_code + trans
	        ENDIF
	        EXIT transloop
	     ENDIF
	   ENDDO transloop


* pass unspecified regions on through
	   IF ( cx_lo_ss(hi_cx,idim) .EQ. unspecified_int4
     .	 .AND.  trans .NE. trans_interpolate ) GOTO 200   ! 2/90

* possibly need different limits for component than for result
	   IF ( grid .NE. unspecified_int4 ) THEN
	      IF ( trans .LT. trans_compress_code ) THEN
	         CALL OFFSET_SS( axis, lo_cx, lo_off, hi_off, status )
		 IF ( status .NE. ferr_ok ) GOTO 5000
	         cx_lo_ss(hi_cx,axis) = cx_lo_ss(hi_cx,axis) + lo_off
	         cx_hi_ss(hi_cx,axis) = cx_hi_ss(hi_cx,axis) + hi_off

* Ticket 2301: If the requested region is at the end of an axis, so the offset
* takes the high subscript below the axis start or the low subscript above the
* axis end, definition, move the index limit(s) to the axis end. 
* (similar change in is_trans)
		 
		 IF  ( .NOT. ITSA_MODULO_AXIS(hi_cx, idim) ) THEN
		    IF (cx_hi_ss(hi_cx,axis) .LT.1) cx_hi_ss(hi_cx,axis) = 1
		    IF (cx_lo_ss(hi_cx,axis) .GT. CAXIS_LEN(axis,hi_cx)) 
     .                cx_lo_ss(hi_cx,axis) = CAXIS_LEN(axis,hi_cx)
		 ENDIF

	         cx_by_ss(axis,hi_cx) = .TRUE.
	         CALL CONFINE_AXIS( axis, hi_cx, status )
	         IF ( status .NE. ferr_ok ) GOTO 5000
* set up for interpolation
	      ELSEIF ( trans .EQ. trans_interpolate ) THEN
* ... 11/95: allow explicit "@ITP" but only with explicit coord cuz
*	when mode interp is cancelled coords get rounded early on
	         IF ( .NOT.mode_interpolate
     .		 .AND..NOT.cx_given(axis,lo_cx) ) CALL ERRMSG
     .		( ferr_invalid_command, status, 
     .                  '@ITP must be accompanied by explicit coord'
     .			//pCR
     .			//'e.g. "Z=@57@ITP" is OK but "Z=@ITP" is not',
     .								*5000 )
	         ww_given = cx_lo_ww(axis,hi_cx)
	         ss = ISUBSCR_CX(ww_given,grid,axis,hi_cx,round_dn)
	         ww_nrst = TM_WORLD( ss, grid, axis, box_middle )
	         CALL GRID_SUBSCRIPT_EXTREMES( lo_ss, hi_ss, grid, axis )
	         cx_by_ss(axis,hi_cx) = .TRUE.
	         IF ( ww_given .LT. ww_nrst ) THEN
	            cx_lo_ss(hi_cx,axis) = MAX( ss-1, lo_ss )
	            cx_hi_ss(hi_cx,axis) = ss
	         ELSEIF( ww_given .GT. ww_nrst ) THEN
	            cx_lo_ss(hi_cx,axis) = ss
	            cx_hi_ss(hi_cx,axis) = MIN( ss+1, hi_ss )
	         ELSE
	            cx_lo_ss(hi_cx,axis) = ss
	            cx_hi_ss(hi_cx,axis) = ss
	         ENDIF
	      ENDIF
	   ENDIF

* rebuild the axis now that we've messed with it
 200	   CALL FLESH_OUT_AXIS( axis, hi_cx, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000

* do the same for other transformed axes if this is a 4D transformation
	   DO 220 i4d = 1, num_4d_trans
	      IF ( trans .EQ. alg_4d_trans(i4d) ) THEN
	         DO 210 i = 1, nferdims 
	            IF (  cx_trans( i, hi_cx ) .NE. trans ) GOTO 210
	            IF ( i .EQ. idim ) GOTO 210  	! already done
	            cx_trans	( i, hi_cx ) = trans_no_transform
	            cx_trans_arg( i, hi_cx ) = bad_val4
	            CALL FLESH_OUT_AXIS( i, hi_cx, status )
	            IF ( status .NE. ferr_ok ) GOTO 5000
 210	         CONTINUE
	      ENDIF
 220	   CONTINUE

	ELSEIF( aclass .EQ. isact_class_regrid ) THEN
* SET UP FOR REGRIDDING
	   IF (its_dsg) THEN
	      CALL REGRID_TO_DSG_LIMS( lo_cx, hi_cx, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
	      axis = TM_DSG_ORIENTATION(grid)   ! really any old value ...
	      IF (axis.EQ.pfeatureType_Point) axis = pfeatureType_Trajectory
	      is_act ( lo_isp ) = isact_regrid
	   ELSEIF (ITSA_REGRID_FROM_DSG(lo_cx)) THEN
	      CALL REGRID_FROM_DSG_LIMS( lo_cx, hi_cx, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
	      axis = TM_DSG_ORIENTATION(grid)   ! really any old value ...
	      is_act ( lo_isp ) = isact_regrid
	   ELSEIF (cx_naux(lo_cx) .EQ. 0 ) THEN
* ... normal regridding
	      CALL REGRID_LIMS( lo_cx, hi_cx, axis, status, *6000 ) !ab ret->mod
	      IF ( status .NE. ferr_ok ) GOTO 5000
* ... see if no regridding was required after all
	      IF ( .NOT.cx_unstand_grid(lo_cx) ) THEN
	         cx_stack_ptr = cx_stack_ptr - 1	
	         RETURN 1					! mod 2/90
	      ENDIF
	      is_act ( lo_isp ) = isact_regrid
	   ELSE
* ... auxiliary variable regridding - set up to get the first aux var
* TEMPORARY:  ONLY HAS LOGIC TO SUPPORT 1D AT THIS POINT.  Hard-coded "1"'s
	      CALL GET_AUX_VAR_CONTEXT( lo_cx, hi_cx, 1, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
* ! temporary diagnostic check that grids of aux vars are found in get-grid phase
	      IF ( cx_grid(hi_cx) .EQ. unspecified_int4 ) 
     .		CALL ERRMSG(ferr_internal, status, 'auxvar grid??', *5000)
	      axis = AUX_AXIS_FROM_ARG(lo_cx, 1)
	      is_phase ( lo_isp ) = isphase_get_aux_var
	      is_sum ( lo_isp ) = 1        ! get the first aux var named
	      is_act ( lo_isp ) = isact_auxvar_regrid
	   ENDIF
	   aclass = isact_class_regrid

	ELSEIF( aclass .EQ. isact_class_aux_plot_vars ) THEN
* SET UP TO GET AUXILIARY ARGUMETS FOR 3-ARG PLOTS ONTO THE STACK
* ...  set up to get the first aux var
* NOTE:  ONLY HAS LOGIC TO SUPPORT 1D AT THIS POINT.  Hard-coded "1"'s
	   CALL GET_AUX_VAR_CONTEXT( lo_cx, hi_cx, 1, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   axis = AUX_AXIS_FROM_ARG(lo_cx, 1)
	   is_phase ( lo_isp ) = isphase_get_aux_var
	   is_sum ( lo_isp ) = 1        ! get the first aux var named
	   is_act ( lo_isp ) = isact_aux_plot_vars  ! a no-op place holder

	ELSEIF( aclass .EQ. isact_class_modulo ) THEN    ! 12/94 addition
* SET UP TO ASSEMBLE BASE COMPONENTS ONTO A MODULO AXIS
!* Let this potentially fatal error slide through because it is often safe and
!* it is a nuisance to the user to change ... I guess (???) *sh* 
!	   IF ( cx_lo_ss(lo_cx,axis) .LE. (unspecified_int4+10) ) THEN
!	      buff = VAR_TRANS(axis, lo_cx, i )
! 	      CALL WARN('Modulo axis index is too negative: '//
!     .		buff(:i))
!	      CALL WARN('This can crash FERRET!!!'//
!     .		' --> Use higher coordinate values.')
!	   ENDIF
* shift the requested range into the base modulo (1:n) limits
	   npts	   = CAXIS_MODLEN( axis, hi_cx )
	   nmod = ( cx_lo_ss(lo_cx, axis) - 1 ) / npts
	   IF ( cx_lo_ss(lo_cx, axis) .LE. 0 ) nmod = nmod - 1
	   xlate = npts * nmod
	   cx_lo_ss(hi_cx, axis) = cx_lo_ss(lo_cx, axis) - xlate
	   cx_hi_ss(hi_cx, axis) = cx_hi_ss(lo_cx, axis) - xlate
* for subspan modulo axis do not request the fictitious "n+1" point
	   IF ( TM_ITS_SUBSPAN_MODULO(CGRID_AXIS(axis, lo_cx)) ) THEN
	     IF (cx_lo_ss(hi_cx,axis).EQ.npts) THEN
	       IF (cx_hi_ss(hi_cx,axis).GT.npts) THEN
* ... improper translation was based upon void start point
	         nmod = nmod + 1
	         cx_lo_ss(hi_cx,axis) = 1
	         cx_hi_ss(hi_cx,axis) = cx_hi_ss(hi_cx,axis) - npts
	       ELSE
* ... only a void point was requested, hack is to request the last valid point
	         cx_lo_ss(hi_cx,axis) = npts - 1
	         cx_hi_ss(hi_cx,axis) = npts - 1
	       ENDIF
	     ENDIF
	     IF (cx_hi_ss(hi_cx,axis) .GE. npts)
     .	        cx_hi_ss(hi_cx,axis) = npts - 1
	   ELSE
* trim the (first) request to the limits of the data
	     IF (cx_hi_ss(hi_cx,axis) .GT. npts)
     .	        cx_hi_ss(hi_cx,axis) = npts
	   ENDIF
	   IF (cx_lo_ss(hi_cx,axis) .GT. cx_hi_ss(hi_cx,axis))
     .	     cx_lo_ss(hi_cx,axis) = cx_hi_ss(hi_cx,axis)

* if requested span exceeds axis length we can modulo from one request
* note that with strides the parity may shift in the right hand replication
*      regrid_lims only lets those cases thru to here if rqsted span le npts
	   allatonce = cx_hi_ss(lo_cx,axis)-cx_lo_ss(lo_cx,axis)
     .		  .GE. CAXIS_LEN(axis,lo_cx)
	   IF ( allatonce ) THEN
	     IF (cx_delta(axis,lo_cx) .EQ. unspecified_val8) THEN
	        cx_lo_ss(hi_cx, axis) = 1
	     ELSE
	        idel = NINT(cx_delta(axis,lo_cx))
	        cx_lo_ss(hi_cx, axis) = MODULO_PARITY(cx_lo_ss(lo_cx,axis),
     .					npts, idel)
	        allatonce = npts .EQ. (npts/idel)*idel   ! parity shift?
	     ENDIF
	   ENDIF
* ... always request full base region for modulo regridding
	   IF ( modulo_dest_regrid ) THEN
	      cx_lo_ss(hi_cx, axis) = unspecified_int4  ! implying "1"
	      cx_hi_ss(hi_cx, axis) = unspecified_int4  ! implying "npts"
!	      cx_lo_ss(hi_cx, axis) = 1
!	      cx_hi_ss(hi_cx, axis) = npts
	      cx_given(axis,hi_cx)  = .FALSE. !"explicit" lims f*ck PASS_AMBIG_
	   ENDIF
* ... rebuild the axis now that we've messed with it
	   cx_by_ss(axis,hi_cx) = .TRUE.
	   CALL FLESH_OUT_AXIS( axis, hi_cx, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
* ... clone the entire context to be requested (for sanity check in IS_MODULO)
	   CALL CREATE_NEW_CONTEXT( hi_cx,dup_cx,status ) ! pushes stack
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   is_big_cx(lo_isp) = hi_cx
	   hi_cx = dup_cx		! hi_cx on top for easier sanity checks
* ... prepare to assemble the modulo pieces
* ... only a single access needed (see IS_MODULO for logic details)
	   is_act ( lo_isp ) = isact_modulo
	   IF ( cx_hi_ss(lo_cx, axis) .GE. 1 ) THEN
	      nmodhi = ( cx_hi_ss(lo_cx, axis) - 1 ) / npts
	   ELSE
	      nmodhi = cx_hi_ss(lo_cx, axis) / npts - 1
	   ENDIF
	   IF ( allatonce .OR. nmod.EQ.nmodhi 		) THEN
	      is_phase ( lo_isp ) = isphase_allatonce
	   ELSE
	      is_phase ( lo_isp ) = isphase_1
	   ENDIF
	   aclass = isact_class_modulo

	ELSEIF( aclass .EQ. isact_class_subspan_fill ) THEN
* SET UP TO INSERT PHANTOM POINT INTO VOID AT END OF SUBSPAN MODULO AXIS
* ... update the axis, omitting the top point
	   npts	= CAXIS_LEN( axis, lo_cx )
	   IF (cx_hi_ss(hi_cx, axis) .NE. npts+1) CALL ERRMSG
     .		( ferr_internal, status, 'subspan_fill_not_N+1', *5000 )
	   cx_hi_ss(hi_cx, axis) = npts
	   IF ( cx_lo_ss(hi_cx, axis) .GT. npts )
     .			     cx_lo_ss(hi_cx, axis) = npts ! was void pt, alone
	   cx_by_ss(axis,hi_cx) = .TRUE.
	   CALL FLESH_OUT_AXIS( axis, hi_cx, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   is_act ( lo_isp ) = isact_subspan_fill
	   aclass = isact_class_subspan_fill

	ELSEIF( aclass .EQ. isact_class_reconcile ) THEN
* SET UP TO RECONCILE POSSIBLE DIFFERENCES BETWEEN REQUEST AND WHAT IS RECEIVED
	   is_act ( lo_isp ) = isact_reconcile
	   aclass = isact_class_reconcile
	   axis = 1	! kludge: prevents crash calling ITSA_MODULO_REGRID
!			! below because FORTRAN isn't smart like C about .AND.
	ELSEIF( aclass .EQ. isact_class_reverse ) THEN    ! 2/95 addition
* The data to be read are reversed on disk -- possibly along multiple axes
* Set up here to read the data raw (reversed) under category cat_file_rev
* in its reversed ordering.  Remember that it may only be a hyperslab of
* the full data on disk so use ds_grid_start/end instead of 1 to N.
* The data values will eventually be reversed in IS_REVERSE
	   cx_category(hi_cx) = cat_file_rev
	   nrev = TM_AXES_REVERSED(var,reversed) 
	   DO 250 i = 1, nrev
	      axis = reversed(i)
	      CALL VAR_SS_LIMS( axis, lo_cx, lo_ss, hi_ss )
	      xlate = cx_lo_ss(hi_cx, axis)

!             for a strided axis
              line = grid_line(axis,grid)
              IF(line_parent(line) .NE. 0) THEN 
                  hi_ss = line_dim(grid_line(axis,grid))
                  lo_ss = 1
              ENDIF

	      cx_lo_ss(hi_cx, axis) = hi_ss + lo_ss - cx_hi_ss(hi_cx,axis) 
	      cx_hi_ss(hi_cx, axis) = hi_ss + lo_ss - xlate

* ... don't rebuild the axis: the world coords are for unreversed axis
	      cx_by_ss(axis,hi_cx) = .TRUE.
 250	   CONTINUE	         
* ... prepare to read the raw,reversed data
	   is_act ( lo_isp ) = isact_reverse
	   aclass = isact_class_reverse

	ELSE
	   WRITE (6,*) 'unsupported act class',aclass
	ENDIF

* GATHER CHECK !!!
* if the grid we are about to request (hi_cx) is going to exceed reasonable
* size limits then try to split the calculation into fragments.
* For example, TEMP[I=1:100@DIN,J=1:100@AVE,K=1:25@AVE,L=1:100@AVE]
* the required data is 100x100x25x100 - TOO BIG !!
* Similarly, modulo regrids may involve source data greatly in excess
* of the result
! DSGTBD need to support split/gather on DSG regrids - temporarily bypassed
* NOTE: because Fortran does not short-circuit IF statements, the ITSA_MODULO_REGRID
*       will always be called regardless of other values.  A check was added to
*       ITSA_MODULO_REGRID to weed out invalid calls.
	IF ( (aclass.EQ.isact_class_trans
     .		.AND. trans.GT.trans_compress_code
     .		.AND. trans.NE.trans_interpolate
     .		.AND. .NOT.its_dsg)
     . .OR.  (aclass.EQ.isact_class_regrid
     .		.AND. (its_dsg
     .		  .OR. ITSA_MODULO_REGRID(lo_cx,axis)))		) THEN
* ... create the context of the first chunk, if possible
*     SETUP_GATHER may change nothing, or it may set up split/gather
*     in hi_cx, axis and the is_* variables
	   CALL SETUP_GATHER(aclass, lo_cx, hi_cx, lo_isp, axis, status)
	   IF (status .NE. ferr_ok) GOTO 5000
	ENDIF

* diagnostic mode output: "strip --> VAR_NAME[x=lo:hi@TRN:n,D=#]"
	IF ( mode_diagnostic ) 	CALL DIAG_OP('strip', aclass, lo_cx, axis)

* push stack to go after the requested component
	is_axis ( lo_isp ) = axis
	CALL PUSH_INTERP_STACK( isp, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	is_cx( isp ) = hi_cx
	IF (  is_act (lo_isp) .EQ. isact_auxvar_regrid
     .	.AND. cx_category(hi_cx) .EQ. cat_user_var ) THEN
* ... setup to evaluate auxiliary var that is user-defined (uvar)
	   is_uvar( isp ) = cx_variable( hi_cx )
	ENDIF

* successful completion
 1000	RETURN 1

* error exit
 5000	RETURN

* possible "kludge" jump point to switch from regridding to modulo
* Note that this kludge is not actually used because adequate testing is
* now (1/9/96) done in INTERP_STACK -- still retain this documentation here
* to explain the subtleties:
* This is needed to cover a subtlety that arises when pseudo-variables are
* combined with modulo operations. For the expression "A=TEMP-TEMP+I" we would
* like "I" to run from 1 to infinity -- not to modulo wrap at Nx
* (see uvar_mod_pseudo in INTERP_STACK). For this reason modulo operations are
* deferred on LET variables that contain pseudo-variables -- the modulo op
* is performed separately on each of the components in the LET variable
* definition allowing "I" to be evaluated on the full requested range.
* The present "kludge" is to cope with LIST/I=1:BIG A[GI=@MOD]. What the user
* presumably wants is to apply the I=1:BIG to the result of the GI=@MOD. So
* in this case we will NOT defer the modulo -- we will set up the stack to do
* the modulo right now.
 6000   aclass = isact_class_modulo
	CALL WARN('Internal: unexpected modulo jump!')
	modulo_dest_regrid = .TRUE.
	GOTO 100

	END

	CHARACTER*(*) FUNCTION CX_DIM_STR( idim,cx,to_word,full_prec,slen )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* create a string describing the region and transformation along an axis
* for example: X=160E:140W@SBX:5
* the argument full_prec ("full precision") indicates number of decimals for
* world coordinates (see LOHI_WORLD) or skip/not skip leading integer 0's

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 9/26/87
* V200:  5/19/89 - re-ordered _ss args
*		 - changed LEFINT from *4 to *8
*		 - allowed leading zeros as needed by size of cx_hi_ss
* V230:  6/22/92 - if ss limits are unspec. then use world limits regardless
*                  of cx_by_ss (needed for CDF_LIST documentation)
*        8/18/92 - eliminated string(1:) notation for MAC compatibility
* V533:  6/01 - allow for the possibility of negative subscripts
* V600:  1/06 *acm*  prevent values of LOG10(0.0) 
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V698 *sh* 3/2016 document a true E ensemble axis with dataset identifier

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xcontext.cmn'
	include 'xtext_info.cmn'
	include 'xdset_info.cmn_text'

* calling argument declarations
	LOGICAL	full_prec
	INTEGER	idim, cx, slen
	CHARACTER*(*) to_word

* local variable declarations:
	LOGICAL TM_HAS_STRING, its_ensemble
	CHARACTER LOHI_WORLD*44
	CHARACTER ALG_TRANS_CODE*3, ARG_STRING*12, LEFINT*8, buff*8
	INTEGER TM_LENSTR1, ENSEMBLE_MEMBER_DSET
	INTEGER llen, ndigits, cx_dim_str_len, dset, slen2, memb_dset

* initialize - put in "=" and blank out string
        cx_dim_str_len = LEN( CX_DIM_STR )
	CX_DIM_STR = '*='

* initialize special case of documenting an ensemble axis
	its_ensemble = .FALSE.
	IF (cx .GT. cx_buff) THEN
	   dset = cx_data_set(cx)
	   its_ensemble = idim .EQ. E_dim
     .		    .AND. dset.GT.pdset_irrelevant
     .	            .AND. dset.LE.max_gfdl_dsets
 	   IF (its_ensemble) THEN
	      its_ensemble = TM_HAS_STRING(ds_type(dset), 'ENS')
	   ENDIF
	ENDIF

* create "lo_limit" or "lo:hi" in subscript or world coords

* SUBSCRIPT NOTATION (I,J,K or L)
* ( added ".AND. cx_lo_ss(cx,idim) ..." 6/22 *sh*)
	IF ( cx_by_ss( idim, cx )
     . .AND. cx_lo_ss(cx,idim) .NE. unspecified_int4 ) THEN
	   CX_DIM_STR(1:1) = ss_dim_name( idim ) 
* lo limit
	   IF ( full_prec ) THEN
* ... only the minimum number of digits needed - maximum readability
	      CX_DIM_STR(3:cx_dim_str_len) =
     .                               LEFINT( cx_lo_ss(cx,idim), slen )
	      slen = slen + 2
	   ELSE
* ... uses leading zeros to ensure filenames generated automatically will colate
	      CX_DIM_STR(3:cx_dim_str_len) = '0000000000000000'
              IF (REAL(ABS(cx_hi_ss(cx,idim))) .NE. 0.) THEN
	         ndigits = LOG10( REAL(ABS(cx_hi_ss(cx,idim))) ) + 1.00001
              ELSE
	         ndigits = 1.00001
              ENDIF
	      IF ( cx_hi_ss(cx,idim) .LT. 0 ) ndigits = ndigits + 1
	      slen = 2 + ndigits	! right-most character
	      buff = LEFINT( cx_lo_ss(cx,idim), llen )
	      CX_DIM_STR(slen-llen+1:slen)=buff(:llen)
	   ENDIF
* hi limit - similar logic
	   IF ( cx_hi_ss(cx,idim) .NE. cx_lo_ss(cx,idim) ) THEN
	      slen = slen + 1
	      CX_DIM_STR(slen:slen) = ':'	
	      IF ( full_prec ) THEN
	         CX_DIM_STR(slen+1:cx_dim_str_len) =
     .                LEFINT(cx_hi_ss(cx,idim), llen)
	         slen = slen + 1 + llen
	      ELSE
	         buff = LEFINT( cx_hi_ss(cx,idim), llen )
	         slen = slen + ndigits
	         CX_DIM_STR(slen-llen+1:slen)=buff(:llen)
	      ENDIF
	   ENDIF
	   IF ( .NOT.full_prec ) CX_DIM_STR(slen+1:cx_dim_str_len)= ' '

* WORLD COORDINATE NOTATION
	ELSE
	   CX_DIM_STR(1:1) = ww_dim_name( idim )
	   CX_DIM_STR(3:cx_dim_str_len)  =
     .                 LOHI_WORLD( idim, cx, ':', full_prec, slen )
	   slen = slen + 2
	ENDIF

* transformation, if any ... "@ttt:n"
	IF ( cx_trans( idim, cx ) .NE. trans_no_transform ) THEN
	   CX_DIM_STR = CX_DIM_STR(1:slen) // '@' //
     .				ALG_TRANS_CODE( cx_trans( idim, cx )) //
     .				ARG_STRING( cx_trans_arg( idim, cx ))
	   slen = TM_LENSTR1( CX_DIM_STR )
	ENDIF

* a single ensemble member name
	IF ( its_ensemble
     .  .AND.cx_lo_ss(cx,idim).NE.unspecified_int4
     .  .AND.cx_lo_ss(cx,idim).EQ.cx_lo_ss(cx,idim) ) THEN


* ... get the special string that indicates the ensemble member
	   memb_dset = ENSEMBLE_MEMBER_DSET(dset, cx_lo_ss(cx,idim))
	   IF (  memb_dset.GT.pdset_irrelevant
     .	    .AND.memb_dset.LE.max_gfdl_dsets) THEN
	      slen2 = TM_LENSTR1( ds_name(memb_dset) )
	      slen2 = MIN(slen2, 12)  ! no more than 12 chars
	      CX_DIM_STR = CX_DIM_STR(1:slen) // ' ('
     .			// ds_name(memb_dset)(:slen2) // ')'	
	      slen = TM_LENSTR1( CX_DIM_STR )
	   ENDIF
	ENDIF
	
	RETURN
	END

	SUBROUTINE SETUP_ANNOTATION ( user, nouser, norm, xloc, yloc,
     .        halign, valign, angle, size, status)

* Create the PPL call to put an annotation on the page, convertint the
* requested location, angle, etc to locations on the page for the annotation
* type: /USER, /NOUSER, or /NORMalized 

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'slash.parm'
	include 'xplot_state.cmn'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
	include 'plot_setup.parm'
	include 'xplot_setup.cmn'
     
	LOGICAL user, norm, nouser
	INTEGER	status
	REAL	xloc, yloc, halign, angle, size

* local variable declarations:

	INTEGER	TM_LENSTR1,
     .		loc, rlen, item, itype, nchar, ierr
	REAL	val, xpos, ypos, valign, deg_to_rad, cos_ang, sin_ang, 
     .		a_dx, a_dy, hloc, xaxlen, yaxlen, rev, xrev, yrev, 
     .		xaxmin, xaxmax, yaxmin, yaxmax, xscale, yscale

	CHARACTER buff*20, symbuff*30

	xpos = xloc
	ypos = yloc

* Compute arguments to send to the PPL %LABEL command

* .../USER
	IF (user) THEN

* Get axis scaling.  For line plots and PLOT/SET the AXIS_MIN
* and AXIS_MAX symbols may not be set.

	   symbuff = 'XAXIS_MIN'
	   CALL GETSYM( symbuff, buff, nchar, ierr)
	   IF (nchar.EQ.0 .OR. ierr.EQ.1)  THEN
	      symbuff = 'PPL$YMIN1'
	      CALL GETSYM( symbuff, buff, nchar, ierr)
	      IF (nchar.EQ.0 .OR. ierr.EQ.1) GOTO 5400
	   ENDIF
	   READ(buff,*) xaxmin

	   symbuff = 'XAXIS_MAX'
	   CALL GETSYM( symbuff, buff, nchar, ierr)
	   IF (nchar.EQ.0 .OR. ierr.EQ.1)  THEN
	      symbuff = 'PPL$XMAX1'
	      CALL GETSYM( symbuff, buff, nchar, ierr)
	      IF (nchar.EQ.0 .OR. ierr.EQ.1) GOTO 5400
	   ENDIF
	   READ(buff,*) xaxmax
	   
	   symbuff = 'PPL$XLEN'
	   CALL GETSYM( symbuff, buff, nchar, ierr)
	   IF (nchar.EQ.0 .OR. ierr.EQ.1) GOTO 5400
	   READ(buff,*) xaxlen

	   symbuff = 'YAXIS_MIN'
	   CALL GETSYM( symbuff, buff, nchar, ierr)
	   IF (nchar.EQ.0 .OR. ierr.EQ.1) THEN
	      symbuff = 'PPL$YMIN1'
	      CALL GETSYM( symbuff, buff, nchar, ierr)
	      IF (nchar.EQ.0 .OR. ierr.EQ.1) GOTO 5400
	   ENDIF
	   READ(buff,*) yaxmin

	   symbuff = 'YAXIS_MAX'
	   CALL GETSYM( symbuff, buff, nchar, ierr)
	   IF (nchar.EQ.0 .OR. ierr.EQ.1) THEN
	      symbuff = 'PPL$YMAX1'
	      CALL GETSYM( symbuff, buff, nchar, ierr)
	      IF (nchar.EQ.0 .OR. ierr.EQ.1) GOTO 5400
	   ENDIF
	   READ(buff,*) yaxmax
	   
	   symbuff = 'PPL$YLEN'
	   CALL GETSYM( symbuff, buff, nchar, ierr)
	   IF (nchar.EQ.0 .OR. ierr.EQ.1) GOTO 5400
	   READ(buff,*) yaxlen

* is the axis reversed?

c	   symbuff = 'XAXIS_REVERSED'
c	   CALL GETSYM( symbuff, buff, nchar, ierr)
c	   IF (nchar.EQ.0 .OR. ierr.EQ.1) GOTO 5400
c	   READ(buff,*) rev
c	   IF (rev.EQ.0) xrev =  1
c	   IF (rev.EQ.1) xrev = -1

c	   symbuff = 'YAXIS_REVERSED'
c	   CALL GETSYM( symbuff, buff, nchar, ierr)
c	   IF (nchar.EQ.0 .OR. ierr.EQ.1) GOTO 5400
c	   READ(buff,*) rev
c	   IF (rev.EQ.0) yrev =  1
c	   IF (rev.EQ.1) yrev = -1

	   xrev = 1
	   yrev = 1
	   xscale = xrev*xaxlen/(xaxmax-xaxmin)
	   yscale = yrev*yaxlen/(yaxmax-yaxmin)

	   IF (halign .LE. -1) THEN
	      hloc = -1.
	   ELSEIF (halign .GE. 1) THEN
	      hloc = 1.
	   ELSE
	      hloc = 0.
	   ENDIF

	   deg_to_rad = 0.017453292
	   cos_ang = cos(angle*deg_to_rad)
	   sin_ang = sin(angle*deg_to_rad)
	   a_dx = ((hloc-halign)/2 * cos_ang + (1+valign)/2 * sin_ang) * size / xscale
	   a_dy = ((hloc-halign)/2 * sin_ang - (1+valign)/2 * cos_ang) * size / yscale

	   xloc = xpos + a_dx
	   yloc = ypos + a_dy

	   buff = 'USER'
	ENDIF

* .../NOUSER
	IF (nouser) THEN
	   
	   IF (halign .LE. -1) THEN
	      hloc = -1.
	   ELSEIF (halign .GE. 1) THEN
	      hloc = 1.
	   ELSE
	      hloc = 0.
	   ENDIF

	   deg_to_rad = 0.017453292
	   cos_ang = cos(angle*deg_to_rad)
	   sin_ang = sin(angle*deg_to_rad)
	   a_dx = ((hloc-halign)/2 * cos_ang + (1+valign)/2 * sin_ang) * size
	   a_dy = ((hloc-halign)/2 * sin_ang - (1+valign)/2 * cos_ang) * size

	   xloc = xpos + a_dx
	   yloc = ypos + a_dy

	   buff = 'NOUSER'
	ENDIF

* .../NORM
	IF (norm) THEN

* Get axis lengths. 
	   symbuff = 'PPL$XLEN'
	   CALL GETSYM( symbuff, buff, nchar, ierr)
	   IF (nchar.EQ.0 .OR. ierr.EQ.1) GOTO 5400
	   READ(buff,*) xaxlen
	   
	   symbuff = 'PPL$YLEN'
	   CALL GETSYM( symbuff, buff, nchar, ierr)
	   IF (nchar.EQ.0 .OR. ierr.EQ.1) GOTO 5400
	   READ(buff,*) yaxlen
	   
	   IF (halign .LE. -1) THEN
	      hloc = -1.
	   ELSEIF (halign .GE. 1) THEN
	      hloc = 1.
	   ELSE
	      hloc = 0.
	   ENDIF

	   deg_to_rad = 0.017453292
	   cos_ang = cos(angle*deg_to_rad)
	   sin_ang = sin(angle*deg_to_rad)
	   a_dx = ((hloc-halign)/2 * cos_ang + (1+valign)/2 * sin_ang) * size
	   a_dy = ((hloc-halign)/2 * sin_ang - (1+valign)/2 * cos_ang) * size

	   xloc = xpos*xaxlen + a_dx
	   yloc = ypos*yaxlen + a_dy

	ENDIF

	IF (halign .LE. -1) THEN
	   halign = -1.
	ELSEIF (halign .GE. 1) THEN
	   halign = 1.
	ELSE
	   halign = 0.
	ENDIF

 5000	RETURN


 5400   CALL ERRMSG (ferr_invalid_command, status, 
     .          'Could not get axis lengths for label positioning', *5000)

	END

	SUBROUTINE SETUP_SAMPLE(  cx_indices, mr_indices,
     .				 ifcn, big_cx, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 


* This routine sets up for the SAMPLE* functions
* When the user issues SAMPLEI({1,5,3,3,8},my_var) this routine will
* sort and store the given indices and prepare for isact_sample activities 

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V510: 8/99 *sh*
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'grid_chg_fcns.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'

* calling argument declarations:
	INTEGER	cx_indices, ifcn, mr_indices, big_cx, status

* ... interpretation stack setup at the time this is called ...
*	stack level		stack contents
*	isp+1	<--	level to request individual sample chunks
*	 isp	<--	current stack level (for sampling )

* internal variable declarations:
	LOGICAL TM_ITSA_DSG
	INTEGER CGRID_SIZE
	INTEGER n, dims(nferdims), ndim, hold_isp, cx_holder,
     .		min_ss, max_ss, res_grid,
     .		mr_sorted_indices, mr_index_map, axis, nvalid
	INTEGER*8 n8

* --- end of introductory code ---

* initialize
	hold_isp  = isp
	cx_holder = is_cx( hold_isp )
	res_grid  = cx_grid( cx_holder )

	IF (TM_ITSA_DSG( cx_grid(cx_holder) )) GOTO 5020

* Check that index list is 1D.
	CALL GET_CX_DIMS(cx_indices, ndim, dims)
	IF (ndim .GT. 1) GOTO 5010

* create memory managed work arrays for the sorted_indices and index_map
	n = CGRID_SIZE(cx_indices)
	n8 = n     ! promote to INTEGER*8
	CALL GET_WORK_MR(n8,mr_sorted_indices, status)
	IF ( status .NE. ferr_ok ) GOTO 5000
	CALL GET_WORK_MR(n8,mr_index_map, status)
	IF ( status .NE. ferr_ok ) GOTO 5000
!	mr_hi_ss(mr_index_map,x_dim) = n	! done in GET_WORK_MR

* extract the 1D list of indices to be obtained
        CALL EXTRACT_LINE ( cx_indices,
     .                      memry(mr_indices)%ptr,
     .                      mr_indices,
     .                      memry(mr_sorted_indices)%ptr,
     .                      dims,
     .                      ndim,
     .                      n,
     .                      status      )
        IF ( status .NE. ferr_ok ) GOTO 5000

* which axis is the sampling along?
	axis = ifcn - p_samplei + 1
	is_axis( hold_isp ) = axis

* sort the list of indices and store with a map of the sort
	CALL GRID_SUBSCRIPT_EXTREMES(min_ss, max_ss, res_grid, axis)
	CALL SORT_LIST(n, min_ss, max_ss,  
     .			   mr_bad_data(mr_indices),
     .			   mr_bad_data(mr_sorted_indices),
     .			   memry(mr_sorted_indices)%ptr,
     .			   memry(mr_index_map)%ptr, nvalid )

* pass the number of valid points through the (irrelevant) T axis indices
* of the (one-dimensional) mr_index_map array
	mr_lo_ss( mr_index_map, t_dim ) = nvalid
	mr_hi_ss( mr_index_map, t_dim ) = nvalid

* encode both the sorted indices and the index map into the hold_isp stack
	is_sum( hold_isp )  = mr_sorted_indices + 10000*mr_index_map

* tell the interp stack what activity we are about
	is_act ( hold_isp ) = isact_sample

* tell IS_SAMPLE that we're just beginning
	is_phase( hold_isp ) = 0

* setup the next stack level to grab the individual chunks
	CALL PUSH_INTERP_STACK( hold_isp, status )
	IF ( status .NE. ferr_ok) GOTO 5000
	is_obj( isp ) = hold_isp	! claimed by this level  (?ok?)

* allocate a context that will be modified for each chunk requested
	CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
        IF ( status .NE. ferr_ok ) RETURN
	CALL TRANSFER_CONTEXT( cx_holder, cx_stack_ptr )
	is_cx( isp ) = cx_stack_ptr

* now drop the isp pointer back down one, so that we will enter IS_SAMPLE
* in the same state that we would had we just grabbed the first chunk
* of sampled data
	isp = hold_isp

* the grid of the result is ABSTRACT on axis "axis". Need to correspondingly
* modify the context of the result
	cx_grid(cx_holder)     = cx_grid(big_cx)
!?	IF (cx_grid(cx_holder) .GT. max_grids)
!?     .			CALL TM_USE_DYN_GRID(cx_grid(cx_holder))
	cx_category(cx_holder) = cat_temp_var
	cx_has_impl_grid(cx_holder) = .FALSE.
	cx_lo_ss(cx_holder,axis) = 1
	cx_hi_ss(cx_holder,axis) = n
	cx_by_ss(axis,cx_holder) = .TRUE.
	CALL FLESH_OUT_AXIS( axis, cx_holder, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* other axes of the holder are not yet known. Result memory
* space will be allocated after the first "chunk" has been obtained
	is_mr( hold_isp ) = unspecified_int4

* diagnostic mode output: " doing gather VAR_NAME[x=lo:hi@TRN:n,D=#]"
	IF ( mode_diagnostic ) 	CALL DIAG_OP
     .		('doing', isact_class_sample, cx_holder, axis)

* success
	RETURN

* error exits
 5000	RETURN
 5010	CALL ERRMSG( ferr_invalid_command, status,
     .          'list of indices supplied to SAMPLE* must be 1D ',
     .          *5000)
 5020	CALL ERRMSG(ferr_invalid_command, status,
     .   'SAMPLE functions do not apply to data from '//
     .   'Discrete Sampling Geometries (DSG) dataset. '//
     .   'Use constraints or masks.', *5000 )
	END

	SUBROUTINE SET_GRATICULES(loch, locv, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* parse qualifier text to set up horizontal and vertical graticule lines 
* extending the tic marks across plots.
*
* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* Ferret v5.54   2/04
* V570: *acm* 5/04 - add MODE GRATICULE[:argument] 
* V570 *acm* 6/30/04 VGRAT with no argument needs to default to lines
* v580 *acm* 11/04   PLOT/HGRAT gave both horiz and vertical graticules
*                    need to initialize buff.
* V6.2  *acm& 2/09 Fix choice of color settings with /PEN and /THICK when we have 
*                  increased the num of colors with MODE linecolors
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'command.parm'
	include 'plot_setup.parm'
	include 'xprog_state.cmn'
        include 'axis_inc.decl'
        include 'AXIS.INC'

* calling argument declarations:
	INTEGER	loch, locv, status

* internal variable declarations:
	LOGICAL linetype, dashtype, thick, colr, small

	INTEGER	TM_LENSTR1, STR_UPCASE, str_len, ii, i1, i2, i3, i4, 
     .      i5, i6, index1, index2, s1, s2, 
     .      colorcode, tic1, ntic, itic, iflag, ncolors

        REAL thickness

	CHARACTER buff*1058
        CHARACTER msg*60


! Default, standard tics, no lines across plot.

        buff = ' '

        DO 100 ii = 1, 4
          hgrat(ii,1) = 0.
          hgrat(ii,2) = 0.
          vgrat(ii,1) = 0.
          vgrat(ii,2) = 0.
100     CONTINUE

        hcolor(1) = 1   ! default color is black
        hcolor(2) = 1
        vcolor(1) = 1
        vcolor(2) = 1

* If MODE GRAT was set, make those settings.  Any settings
* made on the command line will override these.

        IF (grat_on .AND. ((loch .EQ. 0) .AND. (locv .EQ. 0)) ) THEN
           DO 101 ii = 1, 4
             hgrat(ii,1) = -1.
             hgrat(ii,2) = 0.
             vgrat(ii,1) = -1.
             vgrat(ii,2) = 0.
101        CONTINUE

           iflag = STR_UPCASE (buff, mode_grat_buff)
        ENDIF

* HGRAT
        IF (.NOT. grat_on) buff = ' ' 
        IF (loch .GT. 0) THEN
           CALL EQUAL_STRING( cmnd_buff(qual_start(loch):qual_end(loch)),
     .                     buff, status )

* /HGRAT with no argument defaults to lines at large tic marks.

           DO 105 ii = 1, 4
             hgrat(ii,1) = -1.
105        CONTINUE

        ENDIF

        IF ( buff .EQ. ' ' ) GOTO 4999

        str_len = TM_LENSTR1(buff)
        i1 = 1
        IF (buff(1:1) .EQ. '(') i1 = 2
        i2 = str_len

        tic1 = 1   ! LARGE tics by default
        ntic = 1
        
        index1 = i1
        index2 = i2

        IF ( INDEX(buff(i1:i2), 'LAR') .GT. 0) THEN
           tic1 = 1   ! LARGE tics
           i3 = INDEX(buff(i1:i2), 'LAR' )
           i4 = MIN(INDEX(buff(i3:i2), 'SMA'), INDEX(buff(i3:i2), ')' ) )
           IF (i4 .GT. 0) THEN
              i4 = i4 + i3 - 2
           ELSE
              I4 = i2
           ENDIF

           index1 = i3
           index2 = i4
        ENDIF

        small = .FALSE.
        IF ( INDEX(buff(i1:i2), 'SMA') .GT. 0) small = .TRUE.
        IF (small) THEN
           i5 = INDEX(buff(i1:i2), 'SMA')
           i6 = MIN(INDEX(buff(i5:i2), 'LAR'), INDEX(buff(i5:i2), ')' ) )
           IF (i6 .GT. 0) THEN
              i6 = i6 + i5 - 2
           ELSE
              i6 = i2
           ENDIF

           ntic = 2

* If only small requsted, reset lines at large tics to off

           IF (INDEX(buff(i1:i2), 'LAR') .LE. 0) THEN
              tic1 = 2

              DO 106 ii = 1, 4
                hgrat(ii,1) = -0.
106           CONTINUE

              index1 = i5
              index2 = i6

           ENDIF
        ENDIF

        DO itic = tic1, ntic

* By default use solid lines
           DO 110 ii = 1, 4
              hgrat(ii,itic) = -1.
110        CONTINUE

           IF (buff(index1:index1) .EQ. '(') index1 = index1 + 1
           IF (buff(index2:index2) .EQ. ')') index2 = index2 - 1

           linetype = INDEX(buff(index1:index2), 'LIN') .GT. 0
           dashtype = INDEX(buff(index1:index2), 'DAS') .GT. 0
           thick = INDEX(buff(index1:index2), 'THI') .GT. 0
           colr = INDEX(buff(index1:index2), 'COL') .GT. 0

           IF (linetype .AND. dashtype) THEN
              CALL WARN (
     .         '/HGRAT specified with both LINE and DASH, using LINE')
              dashtype = .FALSE.
           ENDIF

           IF (linetype) THEN
              hgrat(1,itic) = -1.  ! for solid lines
              hgrat(2,itic) = -1.
              hgrat(3,itic) = -1.
              hgrat(4,itic) = -1.

           ELSE IF (dashtype) THEN
              hgrat(1,itic) = 0.03  ! set default values
              hgrat(2,itic) = 0.05
              hgrat(3,itic) = 0.0
              hgrat(4,itic) = 0.0
           ENDIF

           thickness = 1   ! default to thin line
           IF (thick) THEN
              s1 = INDEX(buff(index1:index2), 'THI') + index1 - 1
              s2 = INDEX(buff(s1:index2), ',') 
              IF (s2 .EQ. 0) THEN
                 s2 = index2
              ELSE
                 s2 = s2 + s1 - 2
              ENDIF 
              thickness = 2   ! default when /THICK specified
              IF (INDEX(buff(s1:s2), '=') .GT. 0) THEN
                 CALL EQUAL_VAL(buff(s1:s2), thickness, status )
                 IF ( status .NE. ferr_ok ) GOTO 5000
              ENDIF
              IF (thickness.LE.0 .OR. thickness.GT.3) GOTO 5150 
           ENDIF
 
           IF (colr) THEN
              s1 = INDEX(buff(index1:index2), 'COL') + index1 - 1
              s2 = INDEX(buff(s1:index2), ',')
              IF (s2 .EQ. 0) THEN
                 s2 = index2
              ELSE
                 s2 = s2 + s1 - 2
              ENDIF 
              hcolor(itic) = 1   ! default to black
              IF (INDEX(buff(s1:s2), '=') .GT. 0) THEN
                 CALL EQUAL_COLOR( buff(s1:s2), colorcode, status )
                 IF ( status .NE. ferr_ok ) GOTO 5000
                 hcolor(itic) = colorcode
              ELSE
                 WRITE (msg, 40) buff(s1:s2)
  40             FORMAT ( 'No color code given for /HGRAT=',A , 
     .                    '. Using black')
                 CALL WARN (msg)
              ENDIF

              IF (hcolor(itic).LE.0 .OR. hcolor(itic) .GT. 19) GOTO 5160
           ENDIF

* if colorcode = 19 then line is thin, white.

           ncolors = mode_arg(pmode_linecolors,1)
           IF (ncolors .EQ. 6) THEN
           IF (hcolor(itic) .LT. 19) 
     .        hcolor(itic) = ncolors*(thickness-1) + hcolor(itic) ! set color and thick
           ELSE
	      hcolor(itic) = ncolors*(thickness-1) + hcolor(itic) ! set color and thick
	   ENDIF

           index1 = i5
           index2 = i6

        ENDDO  ! back to to small htics, if requested.

* 
 4999   CONTINUE

*  /VGRAT

        IF (.NOT. grat_on) buff = ' ' 
        IF (locv .GT. 0) THEN
           CALL EQUAL_STRING( cmnd_buff(qual_start(locv):qual_end(locv)),
     .                     buff, status )

* /VGRAT with no argument defaults to lines at large tic marks.

           DO 115 ii = 1, 4
             vgrat(ii,1) = -1.
115        CONTINUE

        ENDIF
	IF ( buff .EQ. ' ' ) GOTO 5000  ! done

        str_len = TM_LENSTR1(buff)
        i1 = 1
        IF (buff(1:1) .EQ. '(') i1 = 2
        i2 = str_len

        tic1 = 1   ! LARGE tics by default
        ntic = 1
        
        index1 = i1
        index2 = i2

        IF ( INDEX(buff(i1:i2), 'LAR') .GT. 0) THEN
           tic1 = 1   ! LARGE tics
           i3 = INDEX(buff(i1:i2), 'LAR' )

           i4 = MIN(INDEX(buff(i3:i2), 'SMA'), INDEX(buff(i3:i2), ')' ) )
           IF (i4 .GT. 0) THEN
              i4 = i4 + i3 - 2
           ELSE
              I4 = i2
           ENDIF
           
           index1 = i3
           index2 = i4
        ENDIF

        small = .FALSE.
        IF ( INDEX(buff(i1:i2), 'SMA') .GT. 0) small = .TRUE.
        IF (small) THEN
           i5 = INDEX(buff(i1:i2), 'SMA')

           i6 = MIN(INDEX(buff(i5:i2), 'LAR'), INDEX(buff(i5:i2), ')' ) )
           IF (i6 .GT. 0) THEN
              i6 = i6 + i5 - 2
           ELSE
              i6 = i2
           ENDIF
           
           ntic = 2

* If only small requsted, reset lines at large tics to off

           IF (INDEX(buff(i1:i2), 'LAR') .LE. 0) THEN
              tic1 = 2

              DO 116 ii = 1, 4
                vgrat(ii,1) = -0.
116           CONTINUE

              index1 = i5
              index2 = i6

           ENDIF
        ENDIF

        DO itic = tic1, ntic

* By default use solid lines
           DO 120 ii = 1, 4
              vgrat(ii,itic) = -1.
120        CONTINUE

           IF (buff(index1:index1) .EQ. '(') index1 = index1 + 1
           IF (buff(index2:index2) .EQ. ')') index2 = index2 - 1

           linetype = INDEX(buff(index1:index2), 'LIN') .GT. 0
           dashtype = INDEX(buff(index1:index2), 'DAS') .GT. 0
           thick = INDEX(buff(index1:index2), 'THI') .GT. 0
           colr = INDEX(buff(index1:index2), 'COL') .GT. 0

           IF (linetype .AND. dashtype) THEN
              CALL WARN (
     .         '/VGRAT specified with both LINE and DASH, using LINE')
              dashtype = .FALSE.
           ENDIF

           IF (linetype) THEN
              vgrat(1,itic) = -1.  ! for solid lines
              vgrat(2,itic) = -1.
              vgrat(3,itic) = -1.
              vgrat(4,itic) = -1.

           ELSE IF (dashtype) THEN
              vgrat(1,itic) = 0.03 ! set default values
              vgrat(2,itic) = 0.05
              vgrat(3,itic) = 0.0
              vgrat(4,itic) = 0.0
           ENDIF

           thickness = 1   ! default to thin line
           IF (thick) THEN
              s1 = INDEX(buff(index1:index2), 'THI') + index1 - 1
              s2 = INDEX(buff(s1:index2), ',') 
              IF (s2 .EQ. 0) THEN
                 s2 = index2
              ELSE
                 s2 = s2 + s1 - 2
              ENDIF 
              thickness = 2   ! default when /THICK specified
              IF (INDEX(buff(s1:s2), '=') .GT. 0) THEN
                 CALL EQUAL_VAL(buff(s1:s2), thickness, status )
                 IF ( status .NE. ferr_ok ) GOTO 5000
              ENDIF
              IF (thickness.LE.0 .OR. thickness.GT.3) GOTO 5150 
           ENDIF
 
           IF (colr) THEN
              s1 = INDEX(buff(index1:index2), 'COL') + index1 - 1
              s2 = INDEX(buff(s1:index2), ',')
              IF (s2 .EQ. 0) THEN
                 s2 = index2
              ELSE
                 s2 = s2 + s1 - 2
              ENDIF 
              vcolor(itic) = 1   ! default to black
              IF (INDEX(buff(s1:s2), '=') .GT. 0) THEN
                  CALL EQUAL_COLOR( buff(s1:s2), colorcode, status )
                 IF ( status .NE. ferr_ok ) GOTO 5000
                 vcolor(itic) = colorcode
              ELSE
                 WRITE (msg, 60) buff(s1:s2)
  60             FORMAT ( 'No color code given for /VGRAT=',A , 
     .                    '. Using black')
                 CALL WARN (msg)
              ENDIF
              IF (vcolor(itic).LE.0 .OR. vcolor(itic) .GT. 19) GOTO 5160
           ENDIF

* if colorcode = 19 then line is thin, white.

           IF (ncolors .EQ. 6) THEN
           IF (vcolor(itic) .LT. 19) 
     .        vcolor(itic) = ncolors*(thickness-1) + vcolor(itic) ! set color and thick
           ELSE
	      vcolor(itic) = ncolors*(thickness-1) + vcolor(itic) ! set color and thick
	   ENDIF

           index1 = i5
           index2 = i6

        ENDDO  ! back to to small htics, if requested.

* success
        RETURN

* error exit
 5000	RETURN
 5100	CALL ERRMSG( ferr_syntax, status,
     .		buff(:str_len)//' midmatched parentheses', *5000 )
 5050	CALL ERRMSG( ferr_syntax, status,
     .		buff(:str_len), *5000 )
 5150	CALL ERRMSG( ferr_invalid_command, status,
     .		'"'//buff(:str_len)//
     .          '": thickness must be between 1 and 3',
     .		*5000 )
 5160	CALL ERRMSG( ferr_invalid_command, status,
     .		'"'//buff(s1:s2)//'": must be between 1 and 3',
     .		*5000 )
 5200	CALL ERRMSG( ferr_invalid_command, status,
     .		'zero vector length on /LENGTH=', *5000 )
	END

	SUBROUTINE CONFINE_AXIS( idim, cx, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* given a skeletal context with a known grid confine the context limits to
* on the given axis within the grid limits
* if date/time limits were specified convert to time steps here

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200: 5/26/89 - extracted from CONFINE_CONTEXT with improved error message
*	12/4/89 - improved error reporting
*	5/16/90 - further improved error reporting
*	 8/6/90 - error processing bug: "status" --> istat in SECS_FROM_BC
*       8/10/92 - don't eliminate transform because of lo=hi limits
* V230: 11/4/92 - expanded variable name length
* V420: 11/95 - change to philosophy of "explicit" contexts -- for
*		LET A=I[i=1:5:1] (dynamic axis) the expression A[I=10] should
*		be an error
*	      - allow explicit Z=100@ITP to pass through
*       - add check on cx_calendar rather than cx_lo/hi_ww to indicate whether time
*         is date or timesteps
* V491: 4/98 - fix bug in check for itsa_uvar -- was bypassing ALL processing
* V500 *kob* 3/99- up VAR_CODE  to 64 chars  and err_string from 48 to 64
*                  and VAR_TITLE from 24 to 128
* V520 *kob* 6/00 - had to had risc_buff text buffer for sgi output
* V530 *acm* 1/01 - add cal_id for alternative calendar types
* V552 *acm* 4/03- up VAR_CODE and err_str to 128 chars 
* V553 *acm* 8/03 - write an error message if time origin or time limits 
*                   were mis-defined.
* V554 *acm* 11/03 -Fix bug in the change just above: if times requested
*                   are outside the data bounds, give error message.
* V561 *acm*  4/04 -Fix bug plotting a noleap time axis: cx_lo_ww and cx_hi_ww
*                   are originally set without knowledge of calendar, so when
*                   resetting time step here, also reset the limits for cx_cmnd
* V580 *acm* 11/04  - Use cx_cal_id to keep track of which calendar 
*                     used when cx_lo_ww and cx_hi_ww are computed.
* V600 *acm* 11/05  - Fix for bug 1365; do not fix the world limits for cx_cmnd
*                     unless they were already set.
* V600 *acm*  4/06  - correct typo unspecified_val8
*      *acm*  4/12 6D Ferret: time axis may be in t or f direction.
* V680 *acm*  612  6D Ferret: Pull the calendar correction into a separate routine.
* V683  *acm*10/12 Improve handling of F axes and info about the calendar of the grid.
* V695  *acm* 2/15 cx_calendar stores info about calendar formatting of T and F axes
* V720  *sh*  4/17 support for DSG ragged contiguous grids
* V741 6/18 *acm* Handle modulo longitudes in DSG files
* V751 8/19 *acm* Issue 1954: For DSG grids allow for modulo longitudes for station locations
*                 of timeseries or profiles as well as trajectory data.
* V76  1/20 *acm* working with Point-type dsg data 

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'implicit.parm'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xvariables.cmn'
	include	'xcontext.cmn'
	include	'xtext_info.cmn'
	include 'xrisc.cmn'

* calling argument declarations:
	INTEGER	cx, idim, status

* internal variable declarations:
!	LOGICAL lim_redundant
	LOGICAL TM_ITSA_DSG, ITSA_DSG_POINTS, its_irrelevant, its_dsg
	INTEGER	ISUBSCRIPT, TM_LENSTR1, TM_DSG_DSET_FROM_GRID,
     .		dset, ss, min_ss, max_ss, lo_ss, hi_ss,
     .		axis, grid, lenstr, slen, cat, var, istat,
     .		orientation, obs_dimlen, fline
	REAL*8	ww, min_ww, max_ww, lo_ww, hi_ww
*                  and VAR_TITLE from 24 to 128
	CHARACTER VAR_CODE*128, CX_DIM_STR*48, VAR_TITLE*128,
     .		  buff*48, err_str*128, expr_num*1

* internal parameter declarations:
	LOGICAL     full_precision
	INTEGER	    err_ss_lims, err_ww_lims
	PARAMETER ( full_precision = .TRUE.,
     .		    err_ss_lims = -77,
     .		    err_ww_lims = -88 )

* initialize
	grid = cx_grid( cx )
	cat  = cx_category(cx)
	var  = cx_variable(cx)
	its_dsg = TM_ITSA_DSG(grid) .OR. ITSA_DSG_POINTS(cx)
	IF (its_dsg) THEN
	   dset = TM_DSG_DSET_FROM_GRID( grid )
	   CALL TM_DSG_FACTS( grid, orientation, obs_dimlen, fline, its_dsg )
	ENDIF

* (11/95) expressions such as "2+2"
	IF (cat .EQ. cat_user_var) THEN
	   its_irrelevant = uvar_given(idim,var)
     .			.EQ. uvlim_irrelevant
	ELSE
	   its_irrelevant = .FALSE.
	ENDIF

* axis for this dimension
	axis = grid_line( idim, grid )

* check for internal error left over from old TMAP library
	IF ( axis .EQ. munknown ) THEN
	   status = ferr_grid_definition
	   GOTO 5010
	
! this block of code appears in FLESH_OUT_AXIS instead, because cannot
! constrain the T axis limits until after they are converted to taxis encoding
!* *** DSG grid (4/17)
!	ELSEIF ( its_dsg .AND. idim.NE.f_dim		) THEN
!	   dset = TM_DSG_DSET_FROM_GRID(grid)
!	   CALL DSG_COORD_LIMS(dset, idim, min_ww, max_ww)
!	   IF (min_ww .EQ. unspecified_val8) GOTO 1000   ! irrelevant axis
!* ... constrain to the ww datset extremes
!	   IF  (cx_lo_ww(idim,cx) .EQ. unspecified_val8) THEN
!	      cx_lo_ww(idim,cx) = min_ww
!	      cx_hi_ww(idim,cx) = max_ww
!	   ELSE
!	      IF (cx_lo_ww(idim,cx) .LT. min_ww) cx_lo_ww(idim,cx) = min_ww 
!	      IF (cx_hi_ww(idim,cx) .GT. max_ww) cx_hi_ww(idim,cx) = max_ww 
!	   ENDIF
!	   GOTO 1000

* irrelevant normal axis  (was based on lim_redundant prior to 11/95)
	ELSEIF ( axis .EQ. mnormal ) THEN
	   GOTO 1000

* (11/95) limits on a constant are irrelevant
	ELSEIF ( cat .EQ. cat_constant ) THEN
	   GOTO 1000

* (11/95) expressions such as "2+2"
	ELSEIF ( its_irrelevant ) THEN
	   GOTO 1000

* positions were specified by subscript
	ELSEIF ( cx_by_ss( idim, cx ) ) THEN
	   status = err_ss_lims	! in case of error
* ... is there valid position data for this axis ?
	   IF ( cx_lo_ss( cx ,idim ) .EQ. unspecified_int4 ) GOTO 1000
* ... confine them to the limits of the defining grid
	   CALL GRID_SUBSCRIPT_EXTREMES(min_ss, max_ss, grid, idim)
	   lo_ss = MAX( min_ss, cx_lo_ss(cx,idim) )
	   hi_ss = MIN( max_ss, cx_hi_ss(cx,idim) )
* ... check for limit error
	   IF ( lo_ss .GT. hi_ss ) GOTO 5010
* ... success
	   cx_lo_ss( cx, idim ) = lo_ss
	   cx_hi_ss( cx, idim ) = hi_ss

* positions were specified by world coordinates
	ELSE
	   status = err_ww_lims	! in case of error
* ... is there valid position data for this axis ?
	   IF ( cx_lo_ww( idim, cx ) .EQ. unspecified_val8 ) GOTO 1000
* ... time/date strings are received as -1*(secs from BC)
* 8/97 *kob* use cx_calender to check if time is date rather than time step
* 2/01 *acm* reset time step if axis is a different calendar than Gregorian.
* 8/03 *acm* write error message if time origin or limits were mis-defined.
*11/04 *acm* reset time step only if axis is a different calendar than 
*            the calendar originally used to compute world coordinates

	   IF ( (idim .EQ. t_dim .OR. idim .EQ. f_dim) .AND.cx_calendar(idim,cx) ) THEN

	      CALL CALENDAR_AXIS (idim, grid, cx, istat)
	      IF (istat .NE. 2) THEN
	         IF (istat .EQ. -1) GOTO 5000

	      ENDIF

	      cx_calendar(idim,cx) = .FALSE. 

           ENDIF
* ... confine values to the limits of the defining grid
 4000	   CALL GRID_WORLD_EXTREMES( min_ww, max_ww, grid, idim )
	   lo_ww = MAX( cx_lo_ww( idim, cx ), min_ww )
	   hi_ww = MIN( cx_hi_ww( idim, cx ), max_ww )

	   IF (its_dsg .AND. idim.EQ.x_dim) THEN  ! Moduloing done elsewhere
	      lo_ww = cx_lo_ww( idim, cx_cmnd ) 
	      hi_ww = cx_hi_ww( idim, cx_cmnd )
	   ENDIF

* ... check for error in limits and possibly remove transformation
	   IF ( lo_ww .GT. hi_ww ) THEN
	      GOTO 5010
	   ENDIF
* ... success
	   cx_lo_ww( idim, cx ) = lo_ww
	   cx_hi_ww( idim, cx ) = hi_ww

	ENDIF

* successful completion
 1000	status = ferr_ok
	RETURN

* error exits
 5000	RETURN
* prepare detailed error string: variable name and range along axis
 5010	err_str = VAR_CODE(cat,var)
	IF ( INDEX( err_str,'#' ) .GT. 0 ) THEN
	   err_str = '"'//VAR_TITLE( cx )
	   lenstr  = TM_LENSTR1(err_str)
	   IF ( lenstr .GT. 20 ) THEN
	      err_str = err_str(:20)//'..."'
	   ELSE
	      err_str = err_str(:lenstr)//'"'
	   ENDIF
	ENDIF
	lenstr = TM_LENSTR1(err_str)
	IF ( cx_unstand_grid(cx) ) THEN
	   err_str = err_str(:lenstr)//' on grid '//grid_name(cx_grid(cx))
	   lenstr = TM_LENSTR1(err_str)
	ENDIF
	CALL TRANSFER_CONTEXT( cx, cx_buff )
	cx_trans( idim, cx_buff ) = trans_no_transform
	IF ( status .EQ. err_ss_lims ) THEN
	   cx_lo_ss(cx_buff,idim) = min_ss
	   cx_hi_ss(cx_buff,idim) = max_ss
	   GOTO 5900
	ELSEIF ( status .EQ. err_ww_lims ) THEN
	   cx_lo_ww(idim,cx_buff) = min_ww
	   cx_hi_ww(idim,cx_buff) = max_ww
	   GOTO 5900
	ELSEIF ( status .EQ. ferr_grid_definition ) THEN
	   CALL ERRMSG( ferr_grid_definition, status,
     .			err_str(:lenstr)//pCR//
     .			'Unknown '//ww_dim_name(idim)//' axis in grid '//
     .			grid_name(grid), *5000 )
	ELSE
!	   STOP 'CONFINE_AXIS'
           GO TO 5000
	ENDIF

 5900	buff = CX_DIM_STR(idim, cx, ':',full_precision,slen)
*       Appending space just to get rid of a nonsense compiler warning
	risc_buff = buff(:slen)//' '
        IF ( cx_hi_ss(cx,idim) .NE. cx_lo_ss(cx,idim) ) THEN
	   CALL ERRMSG( ferr_limits, status,
     .		err_str(:lenstr)//' is not in the range '//risc_buff//
     .		pCR//'Axis extremes are '//CX_DIM_STR(idim, cx_buff, 
     .					  ':',full_precision,slen), *5000 )

        ELSE
	   CALL ERRMSG( ferr_limits, status,
     .		err_str(:lenstr)//' does not exist at '//risc_buff//
     .		pCR//'Axis extremes are '//CX_DIM_STR(idim, cx_buff, 
     .					  ':',full_precision,slen), *5000 )
        ENDIF

	END

	INTEGER FUNCTION TM_GET_LINENUM (user_line)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Searches the list of pre-defined line_name's and returns the number
* associated with the line_name given by the user. If no match is found
* the value unspecified_int4 is returned.
*
* written 08/88 By M. Verschell for PMEL/TMAP
*
* revision 0.00 - 08/12/88
*
* *kob* 10/96 	- Linux port.  Linux didn't like tabs between "include"
*	          and what was being included.  removed them
* V510 *sh* 4/00 - conversion to dynamic grids and axes -- check 'em
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* Include files
#include "tmap_dset.parm"	
	include 'tmap_dims.parm'	! 
#include "gt_lib.parm"
	include 'xtm_grid.cmn_text'	! pre-defined grid common
	external xgt_grid_data

	CHARACTER*(*)	user_line
	INTEGER*4	nline, istat
	INTEGER*4	STR_CASE_BLIND_COMPARE

* check the static axes
	DO 100 nline=1,max_lines
	  istat = STR_CASE_BLIND_COMPARE(line_name(nline),user_line)
	  IF (istat .EQ. str_match) THEN
	    TM_GET_LINENUM = nline
	    GOTO 900
	  ENDIF
 100	CONTINUE

* check the dynamic grids
	nline = 0
 200	CALL TM_NEXT_DYN_LINE( nline, *299)
	  istat = STR_CASE_BLIND_COMPARE(line_name(nline),user_line)
	  IF (istat .EQ. str_match) THEN
	    TM_GET_LINENUM = nline
	    GOTO 900
	  ENDIF
	GOTO 200

* not found
 299	TM_GET_LINENUM = unspecified_int4

* found
 900	RETURN
	END

      SUBROUTINE flowline_sub (u, v, startflag, siz, den, nxs, nys,
     .                         px, py, xf, yf)


C**
C**    @(#)flowline_sub.F	    10/03/00
C**
C**
C***********************************************************************
C**
C**              PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*  ACM  From vecfld.F  9/00
*       and from GrADS module gxstrm.c
*       Draw flowlines based on a velocity field.
*  ACM  June 08, 2001  remove extra declaration of i, and
*       change MAX(1, x + 1) to MAX(1., x + 1)
*  ACM  Aug 2001 remove subroutine strmar to separate file (arrow-drawing)
*      *acm* 10/01  remove VMS includes
*  ACM  12/01 bug fix: jjndex not jjindex!
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long

        include 'ferret.parm'
        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'lines_inc.decl'
        include 'LINES.INC'
        include 'pen_inc.decl'
        include 'PEN.INC'
        include 'cmrd_inc.decl'
        include 'CMRD.INC'
        include 'miss_inc.decl'
        include 'MISS.INC'
        include 'switch_inc.decl'
        include 'SWITCH.INC'
        include 'hd_inc.decl'
        include 'HD.INC'
        include 'axis_inc.decl'
        include 'AXIS.INC'
        include 'labcom_inc.decl'
        include 'LABCOM.INC'
        include 'vector_inc.decl'
        include 'VECTOR.INC'
        include 'xcurvilinear.cmn'
        include         'xinterrupt.cmn' ! 1/89 *sh*
        include         'ppl_in_ferret.cmn'


*******************************************************************************



C	ARRAY X HOLD 2 GRIDS, U(X) IN THE FIRST
C	NX BY NY GRID AND V(Y) IN THE SECOND
C       startflag is a work array.
C
C  Calling argument declarations

      INTEGER siz, den, nxs, nys
      REAL xf, yf, px(nxs),py(nys), u(nx,ny), v(nx,ny), startflag(*)

C  From from GrADS module gxstrm.c
C See http://grads.sourcearchive.com/documentation/2.0.a7.1-3/main.html 
C void gxstrm (float *u, float *v, float *c, int is, int js,
C   float uund, float vund, float cund, int flag, float *shdlvs,
C   int *shdcls, int shdcnt, int den)

C  Changes:
C  Trans to Fortran
C  No colorizing the lines
C  Curvlinear coordinate transformation
C  Allow irregular grids  (ITYPE not -1)

C  Local declarations
      INTEGER is, js

      REAL up, vp, x, y, xx, yy, uv1, uv2, uv, vv1, vv2, vv, auv, avv, 
     .     xsav, ysav, xold, yold, fact, rscl, xxsv, yysv, xtm, ytm, 
     .     xtx, ytx, upsv, vpsv, xup, yup, xinterp, yinterp, 
     .     vel, velmean, sqsum, cos_factor, dx, dy, count, sd, xxc, yyc,
     .     upi, upj, upij, vpi, vpj, vpij, xfuser, yfuser, ylousr,
     .     xlousr, xt, yt, xx1, yy1, xl, yl, vfact
      INTEGER LNBLK, TM_LENSTR1, 
     .     i, ii, jj, ii1, ij1, i2, j2, mx, my, ipt, acnt, icol, 
     .     scol, dis, iindex, jjndex, ii1index, iacc, iisav, iscl, imn, 
     .     jmn, j, iz, jz, iss, jss, imx, jmx, iln, slen
      LOGICAL TM_FPEQ_SNGL, bflg

      CHARACTER*120 veclab, buff, symbuff
      EXTERNAL lnblk

C     Curvilinear coordinates declarations
      INTEGER status
#ifdef double_p
      REAL*8 x_curv, y_curv
#else
      REAL x_curv, y_curv
#endif

C First check that the curvilinear coordinate data is all present and accounted for.

      curv_missing = .FALSE.
      IF (curvilinear) THEN
         do j = 1, ny
         do i = 1, nx
            x_curv = i
	    y_curv = j
	    CALL curv_coord (x_curv, y_curv, 1, 1.0, 1.0, status)
	    IF (curv_missing) GOTO 5100
	 enddo
	 enddo
      ENDIF

C  From vector
      CALL COLOR(IPEN(1))

*  Get offset for true grid

      CALL trans(0,xmin,ymin,xtm,ytm)
      CALL trans(0,xmax,ymax,xtx,ytx)

      dx=(xtx-xtm)/MAX(nx-1,1)
      dy=(ytx-ytm)/MAX(ny-1,1)

      scol = -9
      icol = 1

      is = nx
      js = ny

C   Figure out the interval for the flag grid

      i = nx
      IF (ny .GT. i) i = ny
      iscl = 200/i
      iscl = iscl + den - 5
      if (iscl .LT. 1) iscl=1
      if (iscl .GT. 10) iscl=10
      fact = 0.5/REAL(iscl)
      rscl = REAL(iscl)
 
      iss = nx*iscl
      jss = ny*iscl

C  Get mean velocity for scaling the arrows

      sqsum = 0.
      vel = 0.
      velmean = 0.
      count = 0.
      DO i = 1, nx
         DO j = 1, ny 
            up = u(i,j)
            vp = v(i,j)
            IF (ZLE .AND. (up .LE. CMZLE .OR. vp .LE. CMZLE)) GO TO 89
            IF (ZEQ .AND. (up .EQ. CMZEQ .OR. vp .EQ. CMZEQ)) GO TO 89
            IF (ZGE .AND. (up .GE. CMZGE .OR. vp .GE. CMZGE)) GO TO 89

            vel = up*up + vp*vp
            sqsum = sqsum + vel
            vel = sqrt(vel)

            vel = max(vel, vel)
            velmean = velmean + vel
            count = count + 1.

  89        CONTINUE
         ENDDO
      ENDDO 
      IF (count .GT. 0.) THEN
        velmean = velmean/ count
        sd = sqrt(sqsum/ count - velmean* velmean)
      ENDIF

      IF (vauto) THEN
         vfact = 2./velmean
      ELSE
         vfact = 2./vusrln
      ENDIF

C  Initialize the flag grid

      DO i = 1, siz
         startflag(i) = 0.
      ENDDO

C   Loop through flag grid to look for start of flowlines.  
C     To start requires no flowlines drawn within surrounding 
C     flag boxes. 

      i2 = 1
      j2 = 1
      DO i=1, siz
         dis = 2
         IF (den .LT. 5) dis = 3
         IF (den .GT. 5) dis = 1
         imn = i2 - dis
         imx = i2 + dis + 1 
         jmn = j2 - dis
         jmx = j2 + dis + 1
         IF (imn .LT. 1) imn = 1
         IF (imx .GT. iss) imx = iss
         IF (jmn .LT. 1) jmn = 1
         IF (jmx .GT. jss) jmx = jss
         iacc = 0
         DO jz = jmn, jmx
            ipt = jz*iss + imn
            DO iz = imn, imx
              iacc = iacc + INT(startflag(ipt))
              ipt = ipt + 1
            ENDDO
         ENDDO
         IF (iacc .EQ. 0) THEN
            x = REAL((i2-1))/rscl
            y = REAL((j2-1))/rscl

            xsav = x
            ysav = y

            IF(JTYPE.EQ.-1)THEN
               xx = dx* x + xtm
               yy = dy* y + ytm
            ELSE
               mx = INT(x)
               my = INT(y) 
               xup = x - FLOAT(mx)
               yup = y - FLOAT(my)
               IF (mx+2 .LE. nxs) THEN
                 xinterp = px(mx+1) + xup* (px(mx+2) - px(mx+1))
               ELSE
                  xinterp = px(nxs)
               ENDIF

               IF (my+2 .LE. nys) THEN
                  yinterp = py(my+1) + yup* (py(my+2) - py(my+1))
               ELSE
                  yinterp = py(nys)
               ENDIF

	       call trans(0,xinterp,yinterp,xx,yy)
            ENDIF

            IF (curvilinear) THEN
               x_curv = xx
               y_curv = yy
               CALL curv_coord (x_curv, y_curv, 1, 1.0, 1.0, status) ! xform the pts

               xxc=x_curv
               yyc=y_curv
               CALL plot (xxc,yyc,0,0)
            ELSE
               CALL plot (xx,yy,0,0)
            ENDIF

            xxsv = xx 
            yysv = yy
            iisav = -999
            iacc = 0
            acnt = 0
            bflg = .FALSE.

            DO WHILE (x .GT. 0.0 .AND. x .LT. REAL(is-1) .AND. 
     .                y .GT. 0.0 .AND. y .LT. REAL(js-1)) 
               ii = INT(x) 
               jj = INT(y)
               xx = x - REAL(ii)
               yy = y - REAL(jj)

               iindex = ii + 1		! ACM: indices must start at 1 not 0.
               jjndex = jj + 1

               IF (jtype .NE. -1) THEN 

                  IF (iindex .LT. nxs) THEN
                     dx = px(iindex+1) - px(iindex)
                  ELSE 
                     dx = px(iindex) - px(iindex-1)
                  ENDIF
                  IF (jjndex .LT. nys) THEN
                     dy = py(jjndex+1) - py(jjndex)
                  ELSE 
                     dy = py(jjndex) - py(jjndex-1)
                  ENDIF

               ENDIF

               up  = u(iindex,jjndex)
               upi = u(iindex+1,jjndex)
               upj = u(iindex,jjndex+1)
               upij= u(iindex+1,jjndex+1)

               vp  = v(iindex,jjndex)
               vpi = v(iindex+1,jjndex)
               vpj = v(iindex,jjndex+1)
               vpij= v(iindex+1,jjndex+1)

               IF (ZLE .AND.
     .               (up .LE. CMZLE .OR. upi .LE. CMZLE .OR.
     .                upj.LE. CMZLE .OR. upij.LE. CMZLE .OR.          
     .                vp .LE. CMZLE .OR. vpi .LE. CMZLE .OR.
     .                vpj.LE. CMZLE .OR. vpij.LE. CMZLE)) GO TO 19

               IF (ZEQ .AND.
     .               (up .EQ. CMZEQ .OR. upi .EQ. CMZEQ .OR.
     .                upj.EQ. CMZEQ .OR. upij.EQ. CMZEQ .OR.          
     .                vp .EQ. CMZEQ .OR. vpi .EQ. CMZEQ .OR.
     .                vpj.EQ. CMZEQ .OR. vpij.EQ. CMZEQ)) GO TO 19

               IF (ZGE .AND.
     .               (up .GE. CMZGE .OR. upi .GE. CMZGE .OR.
     .                upj.GE. CMZGE .OR. upij.GE. CMZGE .OR.          
     .                vp .GE. CMZGE .OR. vpi .GE. CMZGE .OR.
     .                vpj.GE. CMZGE .OR. vpij.GE. CMZGE)) GO TO 19

               uv1 = up  + (upi - up)* xx
               uv2 = upj + (upij - upj)* xx
               uv  = uv1 + (uv2 - uv1)* yy

               vv1 = vp  + (vpi - vp)* xx
               vv2 = vpj + (vpij - vpj)* xx
               vv  = vv1 + (vv2-vv1)*yy

               auv = ABS(uv) 
               avv = ABS(vv)
               IF (auv .LT. 0.001 .AND. avv .LT. 0.001) GO TO 19

               IF (auv .GT. avv) THEN
                  uv = uv*fact/auv
                  vv = vv*fact/auv
               ELSE
                  uv = uv*fact/avv
                  vv = vv*fact/avv
               ENDIF

C From re_orient.F
C will we need COS(latitude) corrections ? ( the true dx may be dx*COS(lat) )
C compute COS(lat) correction at this latitude

               IF ( need_cos ) THEN
  
                  IF (JTYPE.EQ.-1)THEN
                     xx = dx* x + xtm
                     yy = dy* y + ytm
                  ELSE
                     mx = INT(x)
                     my = INT(y) 
                    xinterp = px(mx+1)
                     yinterp = py(my+1)
                     call trans(0,xinterp,yinterp,xx,yy)
                  ENDIF

                  cos_factor = COS( deg2rad * yy )
                  IF (trnspz) cos_factor = 1./COS( deg2rad * xx )
                  IF ( cos_factor .LT. 1.E-6 ) cos_factor = 1.E-6 !arbitrary fix /0
               ELSE
                 cos_factor = 1.0
               ENDIF

               x = x + uv/cos_factor
               y = y + vv/cos_factor

C  Correction for irregular grids and rectangular regions
C  and for latitude.

               IF (jtype .NE. -1) THEN	! get local dx, dy
                  mx = MAX(1., x + 1)
                  my = MAX(1., y + 1)
                  IF (mx .LT. nxs) THEN
                     dx = px(mx+1) - px(mx)
                  ELSE 
                     dx = px(mx) - px(mx-1)
                  ENDIF
                  IF (my .LT. nys) THEN
                     dy = py(my+1) - py(my)
                  ELSE 
                     dy = py(my) - py(my-1)
                  ENDIF
               ENDIF

               IF (.NOT. curvilinear) THEN
                  IF (.NOT. trnspz) THEN
                     x = x + uv/ (dx*cos_factor/dy)
                     y = y + vv/ (dy/(dx*cos_factor))
                  ELSE
                     x = x + uv/ (dx/(dy*cos_factor))
                     y = y + vv/ (dy*cos_factor/dx)
                  ENDIF
               ENDIF

               ii1 = INT(x*rscl)
               ij1 = INT(y*rscl)
               ii1 = ij1*iss + ii1
               ii1index = ii1 + 1

               IF (ii1 .LT. 0  .OR.  ii1 .GE. siz) GO TO 19
               IF (startflag(ii1index) .EQ. 1.) GO TO 19

               IF (ii1index .NE. iisav .AND. iisav.GT.0)
     .             startflag(iisav) = 1.
               IF (ii1index .EQ. iisav) THEN
                  iacc = iacc + 1
               ELSE
                  iacc = 0
               ENDIF

               IF (iacc .GT. 10) GO TO 19

               iisav = ii1index

               IF (JTYPE.EQ.-1)THEN
                  xx = dx* x + xtm
                  yy = dy* y + ytm

               ELSE
                  mx = INT(x)
                  my = INT(y) 
                  xup = x - FLOAT(mx)
                  yup = y - FLOAT(my)
                  IF (mx+2 .LE. nxs) THEN
                     xinterp = px(mx+1) + xup* (px(mx+2) - px(mx+1))
                  ELSE
                     xinterp = px(nxs)
                  ENDIF

                  IF (my+2 .LE. nys) THEN
                     yinterp = py(my+1) + yup* (py(my+2) - py(my+1))
                  ELSE
                     yinterp = py(nys)
                  ENDIF

                  call trans(0,xinterp,yinterp,xx,yy)
               ENDIF

               IF (icol .GT. -1) THEN
                  IF (bflg) THEN
                     
                     IF (curvilinear) THEN
                        x_curv = xold
                        y_curv = xold
                        CALL curv_coord (x_curv, y_curv, 1, 1.0, 1.0, 
     .                      status) ! xform the pts
                        xxc=x_curv
                        yyc=y_curv
                        CALL plot (xxc,yyc,0,0)
                     ELSE
                        CALL plot(xold,yold,0,0)
                     ENDIF

                     bflg = .FALSE.
                  ENDIF

                  IF (curvilinear) THEN
                     x_curv = xx
                     y_curv = yy
                     CALL curv_coord (x_curv, y_curv, 1, 1.0, 1.0, 
     .                   status) ! xform the pts
                     xxc=x_curv
                     yyc=y_curv
                     CALL plot (xxc,yyc,1,0)
                  ELSE
                     CALL plot(xx,yy,1,0)

                  ENDIF
               ELSE
                  bflg = .TRUE.
               ENDIF

               xold = xx
               yold = yy
               acnt = acnt + 1

C  Draw arrow heads

               IF (acnt .GT. 20) THEN

                 vel = SQRT(upsv*upsv + vpsv*vpsv)* vfact
                 IF (icol .GT. -1) 
     .              CALL strmar (xxsv, yysv, xx, yy, vel, xf, yf)
                  acnt = 0
               ENDIF

               xxsv = xx 
               yysv = yy
               upsv = up
               vpsv = vp
            ENDDO

   19       CONTINUE
            bflg = .FALSE.

C  The curve was stopped (either vel too small, or crosses another curve
C  or runs into an edge or bad data)  Go the other direction from where
C  we began the curve.

            x = xsav 
            y = ysav
            xx = dx* x + xtm
            yy = dy* y + ytm

            IF(JTYPE.EQ.-1)THEN
               xx = dx* x + xtm
               yy = dy* y + ytm
            ELSE
               mx = INT(x)
               my = INT(y) 
               xup = x - FLOAT(mx)
               yup = y - FLOAT(my)
               IF (mx+2 .LE. nxs) THEN
                  xinterp = px(mx+1) + xup* (px(mx+2) - px(mx+1))
               ELSE
                  xinterp = px(nxs)
               ENDIF

               IF (my+2 .LE. nys) THEN
                  yinterp = py(my+1) + yup* (py(my+2) - py(my+1))
               ELSE
                  yinterp = py(nys)
               ENDIF

	       call trans(0,xinterp,yinterp,xx,yy)
            ENDIF

            IF (curvilinear) THEN
               x_curv = xx
               y_curv = yy
               CALL curv_coord (x_curv, y_curv, 1, 1.0, 1.0, status) ! xform the pts
               xxc=x_curv
               yyc=y_curv
               CALL plot (xxc,yyc,0,0)
            ELSE
               CALL plot (xx,yy,0,0)
            ENDIF

            xxsv = xx
            yysv = yy

            iisav = -999
            iacc = 0
            acnt = 19

            DO WHILE (x .GT. 0.0 .AND. x .LT. REAL(is-1) .AND. 
     .                y .GT. 0.0 .AND. y .LT. REAL(js-1)) 
               ii = INT(x)
               jj = INT(y)
               xx = x - REAL(ii)
               yy = y - REAL(jj)

               iindex = ii + 1
               jjndex = jj + 1

               up  = u(iindex,  jjndex)
               upi = u(iindex+1,jjndex)
               upj = u(iindex,  jjndex+1)
               upij= u(iindex+1,jjndex+1)

               vp  = v(iindex,  jjndex)
               vpi = v(iindex+1,jjndex)
               vpj = v(iindex,  jjndex+1)
               vpij= v(iindex+1,jjndex+1)

               IF (ZLE .AND.
     .               (up .LE. CMZLE .OR. upi .LE. CMZLE .OR.
     .                upj.LE. CMZLE .OR. upij.LE. CMZLE .OR.          
     .                vp .LE. CMZLE .OR. vpi .LE. CMZLE .OR.
     .                vpj.LE. CMZLE .OR. vpij.LE. CMZLE)) GO TO 29

               IF (ZEQ .AND.
     .               (up .EQ. CMZEQ .OR. upi .EQ. CMZEQ .OR.
     .                upj.EQ. CMZEQ .OR. upij.EQ. CMZEQ .OR.          
     .                vp .EQ. CMZEQ .OR. vpi .EQ. CMZEQ .OR.
     .                vpj.EQ. CMZEQ .OR. vpij.EQ. CMZEQ)) GO TO 29

               IF (ZGE .AND.
     .               (up .GE. CMZGE .OR. upi .GE. CMZGE .OR.
     .                upj.GE. CMZGE .OR. upij.GE. CMZGE .OR.          
     .                vp .GE. CMZGE .OR. vpi .GE. CMZGE .OR.
     .                vpj.GE. CMZGE .OR. vpij.GE. CMZGE)) GO TO 29

               uv1 = up  + (upi - up)* xx
               uv2 = upj + (upij - upj)* xx
               uv  = uv1 + (uv2 - uv1)* yy

               vv1 = vp  + (vpi - vp)* xx
               vv2 = vpj + (vpij - vpj)* xx
               vv  = vv1 + (vv2 - vv1)* yy

               auv = ABS(uv) 
               avv = ABS(vv) 

               IF (auv .LT. 0.001 .AND. avv .LT. 0.001) GO TO 29
               IF (auv .GT. avv) THEN
                  uv = uv* fact/ auv
                  vv = vv* fact/ auv
               ELSE
                  uv = uv* fact/ avv
                  vv = vv* fact/ avv
               ENDIF


C From re_orient.F
C will we need COS(latitude) corrections ? ( the true dx may be dx*COS(lat) )
C compute COS(lat) correction at this latitude

           IF ( need_cos ) THEN

               IF (JTYPE.EQ.-1)THEN
                  xx = dx* x + xtm
                  yy = dy* y + ytm
               ELSE
                  mx = INT(x)
                  my = INT(y) 
                  xinterp = px(mx+1)
                  yinterp = py(my+1)
                  call trans(0,xinterp,yinterp,xx,yy)
              ENDIF

              cos_factor = COS( deg2rad * yy )
              IF (trnspz) cos_factor = 1./COS( deg2rad * xx )
              IF ( cos_factor .LT. 1.E-6 ) cos_factor = 1.E-6 !arbitrary fix /0
           ELSE
              cos_factor = 1.0
           ENDIF

C  travelling the other direction, so subtract 

               x = x - uv/cos_factor
               y = y - vv/cos_factor

C  Correction for irregular grids and rectangular regions.
C  and for latitude

               IF (jtype .NE. -1) THEN	! get local dx, dy
                  mx = MAX(1., x + 1)
                  my = MAX(1., y + 1)
                  IF (mx .LT. nxs) THEN
                     dx = px(mx+1) - px(mx)
                  ELSE 
                     dx = px(mx) - px(mx-1)
                  ENDIF
                  IF (my .LT. nys) THEN
                     dy = py(my+1) - py(my)
                  ELSE 
                     dy = py(my) - py(my-1)
                  ENDIF
               ENDIF

C  travelling the other direction, so subtract 
 
               IF (.NOT. curvilinear) THEN
                  IF (.NOT. trnspz) THEN
                     x = x - uv/ (dx*cos_factor/dy)
                     y = y - vv/ (dy/(dx*cos_factor))
                  ELSE
                     x = x - uv/ (dx/(dy*cos_factor))
                     y = y - vv/ (dy*cos_factor/dx)
                  ENDIF
               ENDIF

               ii1 = INT(x*rscl)
               ij1 = INT(y*rscl)
               ii1 = ij1*iss + ii1

               ii1index = ii1 + 1

               IF (ii1 .LT. 0  .OR.  ii1 .GE. siz) GO TO 29
               IF (startflag(ii1index) .EQ. 1.) GO TO 29

               IF (ii1 .NE. iisav .AND. iisav .GT. 0)startflag(iisav) =1. 

               IF (ii1index .EQ. iisav) THEN
                  iacc = iacc + 1
               ELSE
                  iacc = 0
               ENDIF

               IF (iacc .GT. 10) GO TO 29
               iisav = ii1index

               IF(JTYPE.EQ.-1)THEN      
                  xx = dx* x + xtm
                  yy = dy* y + ytm

               ELSE
                  mx = INT(x)
                  my = INT(y) 
                  xup = x - FLOAT(mx)
                  yup = y - FLOAT(my)
                  IF (mx+2 .LE. nxs) THEN
                     xinterp = px(mx+1) + xup* (px(mx+2) - px(mx+1))  
                  ELSE
                     xinterp = px(nxs)
                  ENDIF

                  IF (my+2 .LE. nys) THEN
                     yinterp = py(my+1) + yup* (py(my+2) - py(my+1))
                  ELSE
                     yinterp = py(nys)
                  ENDIF

                  call trans(0,xinterp,yinterp,xx,yy)
               ENDIF


               IF (icol .GT. -1) THEN
                  IF (bflg) THEN

                     IF (curvilinear) THEN
                        x_curv = xold
                        y_curv = xold
                        CALL curv_coord (x_curv, y_curv, 1, 1.0, 1.0, 
     .                      status) ! xform the pts
                        xxc=x_curv
                        yyc=y_curv
                        CALL plot (xxc,yyc,0,0)
                     ELSE
                        CALL plot(xold,yold,0,0)
                     ENDIF
                     bflg = .FALSE.
                  ENDIF

                  IF (curvilinear) THEN
                     x_curv = xx
                     y_curv = yy
                     CALL curv_coord (x_curv, y_curv, 1, 1.0, 1.0, 
     .                   status) ! xform the pts
                     xxc=x_curv
                     yyc=y_curv
                     CALL plot (xxc,yyc,1,0)
                  ELSE
                     CALL plot(xx,yy,1,0)
         
                  ENDIF
               ELSE
                  bflg = .TRUE.
               ENDIF

               xold = xx
               yold = yy
               acnt = acnt + 1

C  Draw arrow head
               IF (acnt .GT. 20) THEN
                 vel = SQRT(upsv*upsv + vpsv*vpsv)* vfact
                 IF (icol .GT. -1) 
     .              CALL strmar(xx, yy, xxsv, yysv, vel, xf, yf)
                  acnt = 0
               ENDIF

               xxsv = xx 
               yysv = yy
               upsv = up
               vpsv = vp
            ENDDO
   29       CONTINUE

         ENDIF
         i2 = i2 + 1
         IF (i2 .EQ. iss) THEN
            i2 = 1
            j2 = j2 + 1
         ENDIF

      ENDDO

C  From vector
C
C	DRAW SCALE  make arrow scale at XT,YT
C

C  Make a label containing the scale factor. 
C  Save it in a symbol even if the label not drawn.

	CALL COLOR(IPEN(0))
	WRITE (VECLAB,66) 1./vfact
  66    FORMAT ('flow arrow scale', 1pg8.2)

C   Save the value in a symbol PPL_VECLEN
	symbuff = 'PPL_VECLEN'
	CALL GETSYM( symbuff, buff, i2, i1 )
	IF ( i1 .EQ. 0 ) CALL DELSYM(symbuff,i1)
	slen = TM_LENSTR1(veclab)
	CALL PUTSYM( symbuff, veclab, slen, i2)

	IF(.NOT. VKEY)THEN
	    CALL COLOR(IPEN(0))
	    RETURN
	ENDIF
	CALL WINDOW(0.,0.,0.,0.)
     
	    IF(VUSER)THEN
	    	XFUSER=1.
		YFUSER=1.
		YLOUSR=0.
		XLOUSR=0.
	    ELSE
	    	XFUSER=XF
		YFUSER=YF
		XLOUSR=XLO
		YLOUSR=YLO
	    ENDIF

	XT=VXLOC/XFUSER+XLOUSR
	YT=VYLOC/YFUSER+YLOUSR
        
        XX1 = XT + 0.1/XFUSER  
	YY1 = YT 

C  Make a sample line and label it with the scale factor. 

        CALL PLOT (xx1,yy1,0,0)
        CALL PLOT (xt,yy1,1,0)

C	DRAW LABEL

	CALL COLOR(IPEN(0))
	ILN=LNBLK(VECLAB,30)
c	XL = XX1 + 2.* hlabs/XF+0.2/xf
	XL = XX1 + .125/XF
	YL = YY1 - HLABS*0.5/YF
	CALL SYMBEL(XL,YL,0.,HLABS,ILN,VECLAB)

3333	IF(IWIND.GT.0)CALL WINDOW(XLO,YLO,XHI,YHI)

      RETURN
* error exit
 5100 curv_missing = .TRUE.
      RETURN
      END

	SUBROUTINE CD_STORE_DSET ( dset, status)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* After a non- netCDF file is open, store dataset, variables, and attribute 
* information in linked list structure.

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP 

* V600 6/05 *acm* Attribute control.
* V600  4/06 *acm* - additional declarations found by Solaris compiler
* v604 *acm* 7/07 increase length of ds_name, ds_des_name
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* argument definitions:
*       dset    - pointer to TMAP data set
*	status	- return status

* argument declarations:
	INTEGER	      dset, status

* include files
        include 'netcdf.inc'
        include 'tmap_errors.parm'
	include 'tmap_dims.parm'
	include 'xstep_files.cmn_text'
        external xstep_files_data
	include 'xdset_info.cmn_text'
	external xdset_info_data
        include 'xdset_info.cd_equiv'

* local variable declarations:
      INTEGER NCF_INIT_OTHER_DSET, TM_LENSTR1

* For saving dataset information in linked list

      INTEGER NCF_GET_DSNUM, llen, slen1, slen2
      PARAMETER (slen1=2048)      ! size of ds_name string
      PARAMETER (slen2=2048)      ! size of ds_des_name string (should this be even longer??)

#ifdef sun
      BYTE      fhol_dsname(slen1)      ! c-type Hollerith string buffer
      BYTE      fhol_dspath(slen2)
#else
      INTEGER*1 fhol_dsname(slen1)      ! c-type Hollerith string buffer
      INTEGER*1 fhol_dspath(slen2)
#endif

* Save dataset info in GLOBAL_NCdsetList for attribute handling

      llen = TM_LENSTR1( ds_name(dset) )
      CALL TM_FTOC_STRNG( ds_name(dset)(1:llen), fhol_dsname, slen1 )
      llen = TM_LENSTR1( ds_des_name(dset) )
      CALL TM_FTOC_STRNG( ds_des_name(dset)(1:llen), fhol_dspath, slen2 )

      status = NCF_INIT_OTHER_DSET (dset, fhol_dsname, fhol_dspath) 

* successful completion
	
	RETURN
	END

*
* findhi.F
*
* Ansley Manke
* July 02, 2001
*
* This function locates local extrema, returning "highs".
*
* 1/21/01 change order of axes: result is on X axis, J index
*         gives component of result (x,y,z)
*         And change arguments 2 and 3 to RANGE rather than # Grid cells
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument''s axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE findhi_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CHARACTER*120 fcn_descr

      WRITE (fcn_descr,100) 
      CALL ef_set_desc(id, fcn_descr)
  100 FORMAT('Find local maxima of var, return',
     .        ' HIGHS on X axis. j=1 xpos,j=2 ypos,j=3 HI value')

      CALL ef_set_num_args(id, 3)
      CALL ef_set_axis_inheritance_6d(id,
     .                                ABSTRACT,        ABSTRACT,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 4)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'var in X,Y; optionally Z,T,E,F')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'XRANGE')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 
     .     'Find local maxima in neighborhood +- XRANGE, data units')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'YRANGE')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 
     .     'Find local maxmia in neighborhood +- YRANGE, data units')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE findhi_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER my_hi, nx, ny, arg
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

*
*     Use utility functions to get context information about the argument.
*

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      CALL ef_set_axis_limits(id, Y_AXIS, 1, 3)

      arg = 1
      nx = arg_hi_ss(X_AXIS,arg) - arg_lo_ss(X_AXIS,arg) + 1
      ny = arg_hi_ss(Y_AXIS,arg) - arg_lo_ss(Y_AXIS,arg) + 1

      my_hi = nx * ny   ! an absolute upper bound
      CALL ef_set_axis_limits(id, X_AXIS, 1, my_hi)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE findhi_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*
      INTEGER mx1, my1, mxy, mydim

      INTEGER iwork
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      mx1 = 1 + arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1)
      my1 = 1 + arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1)

      mydim = 3
      mxy = mx1 * my1

*  xyfield
      iwork = 1
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1,   1, 1, 1, 1, 1,
     .                              mx1, my1, 1, 1, 1, 1)

*  zmaxlist
      iwork = 2
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1,   1, 1, 1, 1, 1,
     .                            mydim, mxy, 1, 1, 1, 1)

*  xax
      iwork = 3
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                            2*mx1, 1, 1, 1, 1, 1)

*  yax
      iwork = 4
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                            2*my1, 1, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE findhi_compute(id, arg_1, arg_2, arg_3, result, 
     .                          xyfield, zmaxlist, xax, yax)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

      REAL xyfield(wrk1lox:wrk1hix, wrk1loy:wrk1hiy,
     .             wrk1loz:wrk1hiz, wrk1lot:wrk1hit,
     .             wrk1loe:wrk1hie, wrk1lof:wrk1hif)
      REAL zmaxlist(wrk2lox:wrk2hix, wrk2loy:wrk2hiy,
     .              wrk2loz:wrk2hiz, wrk2lot:wrk2hit,
     .              wrk2loe:wrk2hie, wrk2lof:wrk2hif)
      REAL*8 xax(wrk3lox:wrk3hix/2, wrk3loy:wrk3hiy,
     .           wrk3loz:wrk3hiz, wrk3lot:wrk3hit,
     .           wrk3loe:wrk3hie, wrk3lof:wrk3hif)
      REAL*8 yax(wrk4lox:wrk4hix/2, wrk4loy:wrk4hiy,
     .           wrk4loz:wrk4hiz, wrk4lot:wrk4hit,
     .           wrk4loe:wrk4hie, wrk4lof:wrk4hif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l, m, n,
     .        i1, j1, k1, l1, m1, n1,
     .        arg, nx, ny, nzmax, ip, jp,
     .        neigh_x, neigh_y
      REAL    dx, dy, xrange, yrange

      CHARACTER*255 err_msg

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*  Get the axis coordinates
      arg = 1
      CALL ef_get_coordinates(id, arg, X_AXIS, arg_lo_ss(X_AXIS,arg),
     .                        arg_hi_ss(X_AXIS,arg), xax)
      CALL ef_get_coordinates(id, arg, Y_AXIS, arg_lo_ss(Y_AXIS,arg),
     .                        arg_hi_ss(Y_AXIS,arg), yax)

      nx = arg_hi_ss(X_AXIS,arg) - arg_lo_ss(X_AXIS,arg) + 1
      ny = arg_hi_ss(Y_AXIS,arg) - arg_lo_ss(Y_AXIS,arg) + 1

      dx = xax(2,1,1,1,1,1) - xax(1,1,1,1,1,1)
      dy = yax(2,1,1,1,1,1) - yax(1,1,1,1,1,1)

*  Get the parameters neigh_x, neigh_y, to determine the region in which relative 
*  mins are found: 
C A RELATIVE MINIMUM (OR MAXIMUM) IS DEFINED TO BE THE LOWEST (OR HIGHEST) 
C POINT WITHIN A CERTAIN NEIGHBORHOOD OF THE POINT.  THE NEIGHBORHOOD USED 
C HERE IS + OR - neigh_x IN THE X DIRECTION AND + OR - neigh_y IN THE Y 
C DIRECTION

      CALL ef_get_one_val (id, ARG2, xrange)
      neigh_x = MAX(1, INT (xrange/dx))
      CALL ef_get_one_val (id, ARG3, yrange)
      neigh_y = MAX(1, INT (yrange/dy))

*  For each level and each time, call maxminmax to get the maxima.
*  Determine the coordinates of the max''s and put with the max value
*  into the result

      n1 = arg_lo_ss(F_AXIS,ARG1)
      DO 600 n=res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

      m1 = arg_lo_ss(E_AXIS,ARG1)
      DO 500 m=res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

      l1 = arg_lo_ss(T_AXIS,ARG1)
      DO 400 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         k1 = arg_lo_ss(Z_AXIS,ARG1)
         DO 300 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

            j1 = arg_lo_ss(Y_AXIS,ARG1)
            DO 200 j = 1, ny
               i1 = arg_lo_ss(X_AXIS,ARG1)
               DO 100 i = 1, nx
                  xyfield(i,j,1,1,1,1) = arg_1(i1,j1,k1,l1,m1,n1)
                  i1 = i1 + arg_incr(X_AXIS,ARG1)
  100          CONTINUE
               j1 = j1 + arg_incr(Y_AXIS,ARG1)
  200       CONTINUE

            CALL MAXMINMAX (xyfield, nx, nx, ny, neigh_x, neigh_y, 
     .                      bad_flag(ARG1), zmaxlist, nzmax)

C  result(i,1,k,l,m,n) = X index of max
C  result(i,2,k,l,m,n) = Y index of max
C  result(i,3,k,l,m,n) = z value at max

            DO 210 i = 1, nzmax
               ip = INT(zmaxlist(1,i,1,1,1,1))
               jp = INT(zmaxlist(2,i,1,1,1,1))
               result(i,1,k,l,m,n) = xax(ip,1,1,1,1,1)
               result(i,2,k,l,m,n) = yax(jp,1,1,1,1,1)
               result(i,3,k,l,m,n) = zmaxlist(3,i,1,1,1,1)
 210        CONTINUE

C  Fill end of result with missing-data flags

            DO 230 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
               DO 220 i = nzmax+1, res_hi_ss(X_AXIS)
                  result(i,j,k,l,m,n) = bad_flag_result
 220           CONTINUE
 230        CONTINUE

            k1 = k1 + arg_incr(Z_AXIS,ARG1)
 300     CONTINUE

         l1 = l1 + arg_incr(T_AXIS,ARG1)
 400  CONTINUE

         m1 = m1 + arg_incr(E_AXIS,ARG1)
 500  CONTINUE

         n1 = n1 + arg_incr(F_AXIS,ARG1)
 600  CONTINUE

      RETURN

 999  CALL ef_bail_out (id, err_msg)
      RETURN

      END

	REAL FUNCTION DAYS_FROM_DAY0( date0_days, year, month, day,
     .       rdum, status)


*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* return a relative day number since the day of date0_days where date0_days
* is in units of days since 1-JAN-0000

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V320 11/94 - in order to implement the DAY1900 function
*		based on tm_secs_from_bc by Mark Verschell
* V530 12/00 *sh* - bug fix: avoid crash if month is not in [1,12]
* V600 4/06  *acm*  return the result in rdum as well, for 64-bit build
* V68  *acm* 1/12  ifdef double_p for double-precision ferret
* V701 *acm* 7/16  ticket 2449: report incorrect choice of date/ eurodate as an error

        IMPLICIT NONE
        include 'errmsg.parm'

* calling argument declarations:

	REAL*8 date0_days
	INTEGER year, month, day, status
        REAL rdum

* Local Definition
	INTEGER		days_in_month(12), mnth
	REAL*8		secs_in_day,
     .			secs_in_year, secs_in_century, total_secs,
     .			total_days

	PARAMETER	(secs_in_day	 = 60.*60.*24.,
     .			 secs_in_year	 = secs_in_day*365.,
     .			 secs_in_century = secs_in_day*36524.)

	DATA days_in_month /   0,  31,  59,  90, 120, 151,
     .			     181, 212, 243, 273, 304, 334/

* to avoid crash for out of bounds month
	IF (month .GT. 12) THEN
	   mnth = 12
	   status = ferr_out_of_range 
	ELSEIF (month .LT. 1) THEN
	   mnth = 1
	   status = ferr_out_of_range 
	ELSE
	   mnth = month
	ENDIF

* add lots of seconds for each century since 0 day
	total_secs = secs_in_century * INT(year/100)
* add a day for every 400 years (leap year at centennial)
	total_secs = total_secs + secs_in_day*INT(year/400.+0.9975)
* add a year for each year since turn of century
	total_secs = total_secs + secs_in_year*MOD(year,100)
* add a day for each leap year since centennial (except for centennial)
	total_secs = total_secs + secs_in_day*INT((MOD(year,100)-1)/4)
* add seconds for number of months
	total_secs = total_secs + days_in_month(mnth)*secs_in_day
* add 1 day worth of seconds if this is leap year and past february
	IF (mnth .GT. 2) THEN
	  IF (MOD(year,400) .EQ. 0) THEN
	    total_secs = total_secs + secs_in_day
	  ELSE
	    IF (MOD(year,4) .EQ. 0 .AND. MOD(year,100) .NE. 0)
     .	          total_secs = total_secs + secs_in_day
	  ENDIF
	ENDIF
* add seconds for number of days
	total_secs = total_secs + secs_in_day*(day-1)

* convert to days and return result
	total_days = total_secs/secs_in_day - date0_days
	DAYS_FROM_DAY0 = total_days

        rdum = DAYS_FROM_DAY0

        RETURN
	END

	INTEGER FUNCTION DO_FILL_AVE(	idim, arg,
     .					com, com_mr, com_cx,
     .					res, res_mr, res_cx,
     .					buff	)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* fill along axis idim by a running mean window

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  6/2/89
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN
* V550 *sh* 8/2/02 - support for modulo lengths. ensure that filling 
*		    does not operate acros the subspan modulo void point
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include	'xprog_state.cmn'

* calling argument declarations:
	INTEGER	idim, com_mr, com_cx, res_mr, res_cx
	REAL	arg, buff(*),
     .          com( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          res( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif )

* internal variable declarations:
	LOGICAL	TM_ITS_SUBSPAN_MODULO, has_mod_void
	INTEGER	TM_MODULO_LINE_DIM, CGRID_AXIS, 
     .		i, j, k, l, m, n, ii, cnt, haf,
     .          lo_sub(nferdims), hi_sub(nferdims),
     .		ii_com, lo_com, hi_com, lo_com0, hi_com0,
     .		lo_modlim, hi_modlim, nmod, nmod_prev, modlen

	REAL	bad_res, sum, comp

* internal (convenience) equivalences
	INTEGER	lo_s1, lo_s2, lo_s3, lo_s4, lo_s5, lo_s6,
     .          hi_s1, hi_s2, hi_s3, hi_s4, hi_s5, hi_s6
	EQUIVALENCE (lo_s1, lo_sub(1)) , (lo_s2, lo_sub(2)),
     .		    (lo_s3, lo_sub(3)) , (lo_s4, lo_sub(4)),
     .		    (lo_s5, lo_sub(5)) , (lo_s6, lo_sub(6)),
     .		    (hi_s1, hi_sub(1)) , (hi_s2, hi_sub(2)),
     .		    (hi_s3, hi_sub(3)) , (hi_s4, hi_sub(4)),
     .		    (hi_s5, hi_sub(5)) , (hi_s6, hi_sub(6))

* diagnostic mode output: " doing --> VAR_NAME[x=lo:hi@TRN:n,D=#]"
	IF ( mode_diagnostic ) 	CALL DIAG_OP
     .				( 'doing', isact_class_trans, res_cx, idim )

* initialize
	haf = arg * .5
	bad_res = mr_bad_data( com_mr )
	nmod_prev = -99999

* compute limits within which calculation is straightforward
	DO 10 ii = 1, nferdims
	   lo_sub(ii) = cx_lo_ss(res_cx,ii)
	   hi_sub(ii) = cx_hi_ss(res_cx,ii)
 10	CONTINUE
	lo_com0 = cx_lo_ss(com_cx,idim)
	hi_com0 = cx_hi_ss(com_cx,idim)
	lo_com = lo_com0
	hi_com = hi_com0

* it his a subspan modulo axis?
	has_mod_void = TM_ITS_SUBSPAN_MODULO( CGRID_AXIS(idim,com_cx) )
	IF (has_mod_void) THEN
	   modlen = TM_MODULO_LINE_DIM( CGRID_AXIS(idim,com_cx) )
	   has_mod_void = lo_com.LE.0 .OR. hi_com.GE.modlen
	ENDIF

* FILL ALONG X AXIS
	IF ( idim .EQ. x_dim ) THEN
	   DO 110 n = lo_s6, hi_s6
	   DO 110 m = lo_s5, hi_s5
	   DO 110 l = lo_s4, hi_s4
	   DO 110 k = lo_s3, hi_s3
	   DO 110 j = lo_s2, hi_s2
	   DO 110 i = lo_s1, hi_s1
*  ... do not allow filling based upon values across a subspan modulo void
	      IF (has_mod_void) THEN
	         IF (MOD(i,modlen) .EQ. 0) THEN
	            res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
	            GOTO 110
	         ENDIF
	         nmod = (i-1)/modlen 
	         IF (i.LE.0) nmod = nmod - 1
	         IF ( nmod .NE. nmod_prev ) THEN
	            nmod_prev = nmod
	            lo_modlim = nmod*modlen + 1
	            hi_modlim = (nmod+1) * modlen
	            lo_com = MAX( lo_modlim, lo_com0 )
	            hi_com = MIN( hi_modlim, hi_com0 )
	         ENDIF
	      ENDIF
* ... end of subspan modulo adjustment
	      IF ( com(i,j,k,l,m,n) .NE. bad_res ) THEN
	         res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
	         GOTO 110
	      ENDIF
	      cnt = 0
	      sum = 0.0
	      DO 100 ii = -haf, haf
	         ii_com = i + ii
	         IF ( ii_com.LT.lo_com .OR. ii_com.GT.hi_com ) GOTO 100
	         comp = com(ii_com,j,k,l,m,n)
	         IF ( comp .NE. bad_res ) THEN
	            cnt = cnt + 1
	            sum = sum + comp
	         ENDIF
 100	      CONTINUE
	      IF ( cnt .GT. 0 ) THEN
	         res(i,j,k,l,m,n) = sum / cnt
	      ELSE
	         res(i,j,k,l,m,n) = bad_res
	      ENDIF
 110	   CONTINUE

* FILL ALONG Y AXIS
	ELSEIF ( idim .EQ. y_dim ) THEN
	   DO 220 n = lo_s6, hi_s6
	   DO 220 m = lo_s5, hi_s5
	   DO 220 l = lo_s4, hi_s4
	   DO 220 k = lo_s3, hi_s3
	   DO 220 j = lo_s2, hi_s2
*  ... do not allow filling based upon values across a subspan modulo void
	      IF (has_mod_void) THEN
	         IF (MOD(j,modlen) .EQ. 0) THEN
	            res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
	            GOTO 220
	         ENDIF
	         nmod = (j-1)/modlen 
	         IF (j.LE.0) nmod = nmod - 1
	         IF ( nmod .NE. nmod_prev ) THEN
	            nmod_prev = nmod
	            lo_modlim = nmod*modlen + 1
	            hi_modlim = (nmod+1) * modlen
	            lo_com = MAX( lo_modlim, lo_com0 )
	            hi_com = MIN( hi_modlim, hi_com0 )
	         ENDIF
	      ENDIF
* ... end of subspan modulo adjustment
	   DO 210 i = lo_s1, hi_s1
	      IF ( com(i,j,k,l,m,n) .NE. bad_res ) THEN
	         res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
	         GOTO 210
	      ENDIF
	      cnt = 0
	      sum = 0.0
	      DO 200 ii = -haf, haf
	         ii_com = j + ii
	         IF ( ii_com.LT.lo_com .OR. ii_com.GT.hi_com ) GOTO 200
	         comp = com(i,ii_com,k,l,m,n)
	         IF ( comp .NE. bad_res ) THEN
	            cnt = cnt + 1
	            sum = sum + comp
	         ENDIF
 200	      CONTINUE
	      IF ( cnt .GT. 0 ) THEN
	         res(i,j,k,l,m,n) = sum / cnt
	      ELSE
	         res(i,j,k,l,m,n) = bad_res
	      ENDIF
 210	   CONTINUE
 220	   CONTINUE

* FILL ALONG Z AXIS
	ELSEIF ( idim .EQ. z_dim ) THEN
	   DO 320 n = lo_s6, hi_s6
	   DO 320 m = lo_s5, hi_s5
	   DO 320 l = lo_s4, hi_s4
	   DO 320 k = lo_s3, hi_s3
*  ... do not allow filling based upon values across a subspan modulo void
	      IF (has_mod_void) THEN
	         IF (MOD(k,modlen) .EQ. 0) THEN
	            res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
	            GOTO 320
	         ENDIF
	         nmod = (k-1)/modlen 
	         IF (k.LE.0) nmod = nmod - 1
	         IF ( nmod .NE. nmod_prev ) THEN
	            nmod_prev = nmod
	            lo_modlim = nmod*modlen + 1
	            hi_modlim = (nmod+1) * modlen
	            lo_com = MAX( lo_modlim, lo_com0 )
	            hi_com = MIN( hi_modlim, hi_com0 )
	         ENDIF
	      ENDIF
* ... end of subspan modulo adjustment
	   DO 310 j = lo_s2, hi_s2
	   DO 310 i = lo_s1, hi_s1
	      IF ( com(i,j,k,l,m,n) .NE. bad_res ) THEN
	         res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
	         GOTO 310
	      ENDIF
	      cnt = 0
	      sum = 0.0
	      DO 300 ii = -haf, haf
	         ii_com = k + ii
	         IF ( ii_com.LT.lo_com .OR. ii_com.GT.hi_com ) GOTO 300
	         comp = com(i,j,ii_com,l,m,n)
	         IF ( comp .NE. bad_res ) THEN
	            cnt = cnt + 1
	            sum = sum + comp
	         ENDIF
 300	      CONTINUE
	      IF ( cnt .GT. 0 ) THEN
	         res(i,j,k,l,m,n) = sum / cnt
	      ELSE
	         res(i,j,k,l,m,n) = bad_res
	      ENDIF
 310	   CONTINUE
 320	   CONTINUE

* FILL ALONG T AXIS
	ELSEIF ( idim .EQ. t_dim ) THEN
	   DO 420 n = lo_s6, hi_s6
	   DO 420 m = lo_s5, hi_s5
	   DO 420 l = lo_s4, hi_s4
*  ... do not allow filling based upon values across a subspan modulo void
	      IF (has_mod_void) THEN
	         IF (MOD(l,modlen) .EQ. 0) THEN
	            res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
	            GOTO 420
	         ENDIF
	         nmod = (l-1)/modlen 
	         IF (l.LE.0) nmod = nmod - 1
	         IF ( nmod .NE. nmod_prev ) THEN
	            nmod_prev = nmod
	            lo_modlim = nmod*modlen + 1
	            hi_modlim = (nmod+1) * modlen
	            lo_com = MAX( lo_modlim, lo_com0 )
	            hi_com = MIN( hi_modlim, hi_com0 )
	         ENDIF
	      ENDIF
* ... end of subspan modulo adjustment
	   DO 410 k = lo_s3, hi_s3
	   DO 410 j = lo_s2, hi_s2
	   DO 410 i = lo_s1, hi_s1
	      IF ( com(i,j,k,l,m,n) .NE. bad_res ) THEN
	         res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
	         GOTO 410
	      ENDIF
	      cnt = 0
	      sum = 0.0
	      DO 400 ii = -haf, haf
	         ii_com = l + ii
	         IF ( ii_com.LT.lo_com .OR. ii_com.GT.hi_com ) GOTO 400
	         comp = com(i,j,k,ii_com,m,n)
	         IF ( comp .NE. bad_res ) THEN
	            cnt = cnt + 1
	            sum = sum + comp
	         ENDIF
 400	      CONTINUE
	      IF ( cnt .GT. 0 ) THEN
	         res(i,j,k,l,m,n) = sum / cnt
	      ELSE
	         res(i,j,k,l,m,n) = bad_res
	      ENDIF
 410	   CONTINUE
 420	   CONTINUE

* FILL ALONG E AXIS
	ELSEIF ( idim .EQ. e_dim ) THEN
	   DO 520 n = lo_s6, hi_s6
	   DO 520 m = lo_s5, hi_s5
*  ... do not allow filling based upon values across a subspan modulo void
	      IF (has_mod_void) THEN
	         IF (MOD(m,modlen) .EQ. 0) THEN
	            res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
	            GOTO 520
	         ENDIF
	         nmod = (m-1)/modlen 
	         IF (m.LE.0) nmod = nmod - 1
	         IF ( nmod .NE. nmod_prev ) THEN
	            nmod_prev = nmod
	            lo_modlim = nmod*modlen + 1
	            hi_modlim = (nmod+1) * modlen
	            lo_com = MAX( lo_modlim, lo_com0 )
	            hi_com = MIN( hi_modlim, hi_com0 )
	         ENDIF
	      ENDIF
* ... end of subspan modulo adjustment
	   DO 510 l = lo_s4, hi_s4
	   DO 510 k = lo_s3, hi_s3
	   DO 510 j = lo_s2, hi_s2
	   DO 510 i = lo_s1, hi_s1
	      IF ( com(i,j,k,l,m,n) .NE. bad_res ) THEN
	         res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
	         GOTO 510
	      ENDIF
	      cnt = 0
	      sum = 0.0
	      DO 500 ii = -haf, haf
	         ii_com = m + ii
	         IF ( ii_com.LT.lo_com .OR. ii_com.GT.hi_com ) GOTO 500
	         comp = com(i,j,k,l,ii_com,n)
	         IF ( comp .NE. bad_res ) THEN
	            cnt = cnt + 1
	            sum = sum + comp
	         ENDIF
 500	      CONTINUE
	      IF ( cnt .GT. 0 ) THEN
	         res(i,j,k,l,m,n) = sum / cnt
	      ELSE
	         res(i,j,k,l,m,n) = bad_res
	      ENDIF
 510	   CONTINUE
 520	   CONTINUE

* FILL ALONG F AXIS
	ELSEIF ( idim .EQ. f_dim ) THEN
	   DO 620 n = lo_s6, hi_s6
*  ... do not allow filling based upon values across a subspan modulo void
	      IF (has_mod_void) THEN
	         IF (MOD(n,modlen) .EQ. 0) THEN
	            res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
	            GOTO 620
	         ENDIF
	         nmod = (n-1)/modlen 
	         IF (n.LE.0) nmod = nmod - 1
	         IF ( nmod .NE. nmod_prev ) THEN
	            nmod_prev = nmod
	            lo_modlim = nmod*modlen + 1
	            hi_modlim = (nmod+1) * modlen
	            lo_com = MAX( lo_modlim, lo_com0 )
	            hi_com = MIN( hi_modlim, hi_com0 )
	         ENDIF
	      ENDIF
* ... end of subspan modulo adjustment
	   DO 610 m = lo_s5, hi_s5
	   DO 610 l = lo_s4, hi_s4
	   DO 610 k = lo_s3, hi_s3
	   DO 610 j = lo_s2, hi_s2
	   DO 610 i = lo_s1, hi_s1
	      IF ( com(i,j,k,l,m,n) .NE. bad_res ) THEN
	         res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
	         GOTO 610
	      ENDIF
	      cnt = 0
	      sum = 0.0
	      DO 600 ii = -haf, haf
	         ii_com = n + ii
	         IF ( ii_com.LT.lo_com .OR. ii_com.GT.hi_com ) GOTO 600
	         comp = com(i,j,k,l,m,ii_com)
	         IF ( comp .NE. bad_res ) THEN
	            cnt = cnt + 1
	            sum = sum + comp
	         ENDIF
 600	      CONTINUE
	      IF ( cnt .GT. 0 ) THEN
	         res(i,j,k,l,m,n) = sum / cnt
	      ELSE
	         res(i,j,k,l,m,n) = bad_res
	      ENDIF
 610	   CONTINUE
 620	   CONTINUE

	ENDIF

* always success
	DO_FILL_AVE = ferr_ok
	RETURN

	END

      SUBROUTINE TM_SET_CURRENT_CALENDAR (set_name, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
C     Set the current calendar name and id in common current_calendar
C     and loads calendar info into common.
C
C     Returns merr_varlim if calendar is invalid, merr_ok successful completion
C     J Davison 10.99
C     V 1.0

C  11/29/00  Ansley Manke  revise to match just 3 characters of allowed_calendars
* V6.74 3/12 *acm* cleanup: add disclaimer

C     0.00000000000000000000000000000000000000000000000000000000000000001

#ifdef unix
      include 'calendar.decl'
      include 'calendar.cmn'
      include 'tmap_errors.parm'
#else
      INCLUDE 'TMAP_FORMAT:TMAP_ERRORS.PARM'
#endif 
      integer         end, ndx, status
      character*255   test_string

      character*16    cal_name
      character*(*)   set_name

*************************************************************************

C     Move input string to upper case
      CALL upnsquish (set_name,test_string,end)

C     LOCATE NAME IN CALENDAR TABLE
      DO 10 ndx = 1, max_calendars
         IF (test_string(1:3) .EQ. allowed_calendars(ndx)(1:3)) 
     .        GOTO 100
 10   END DO

C     error: calendar not found

      status = merr_varlim
      goto 1000

C     calendar found, set current calendar

c 100  cal_name = test_string(1:end)

 100  cal_name = allowed_calendars(ndx)

      CALL tm_load_calendar (cal_name, status)

 1000 RETURN

      END

*
* zaxreplace_avg.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* Oct 1998
* 11/2001  clarify function description
*  7/2003  Bug fix; last source point wasnt associated with a dest box
*          when the destination axis continues beyond the source range
*
*
* Replace Z axis, using weighted averaging over bins
*

*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE zaxreplace_avg_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      CHARACTER*100 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT 
     .  ('regrid V onto Z axis of ZAX based on Z values in ZVALS ',
     .    'using weighted average' )
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)

      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, YES, YES, YES, NO)

      CALL ef_set_num_work_arrays(id, 8)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'V')
      CALL ef_set_arg_desc(id, arg, 
     .        'Variable on native z axis')
      CALL ef_set_axis_influence(id, arg, YES, YES, NO, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'ZVALS')
      CALL ef_set_arg_desc(id, arg, 
     .        'Destination Z axis values as a fcn of source Z axis')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'ZAX')
      CALL ef_set_arg_desc(id, arg, 
     .'Variable with desired z (depth) axis points')
      CALL ef_set_axis_influence(id, arg, NO, NO, YES, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE zaxreplace_avg_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_dims(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER mz2, mz3

      INTEGER iwork
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

*  Allocate double the dimension of the input arguments for work arrays
*  which will be REAL*8

      mz2 = 1 + ABS(arg_hi_ss(Z_AXIS,ARG2) - arg_lo_ss(Z_AXIS,ARG2))
      mz3 = 1 + ABS(arg_hi_ss(Z_AXIS,ARG3) - arg_lo_ss(Z_AXIS,ARG3))

      mz2 = 2* mz2
      mz3 = 2* mz3

*  zaxsrc
      iwork = 1
      CALL ef_set_work_array_dims (id, iwork, 1, 1, 1, 1, 
     .   1, 1, mz2, 1)

*  sbox_lo_lim
      iwork = 2
      CALL ef_set_work_array_dims (id, iwork, 1, 1, 1, 1, 
     .   1, 1, mz2, 1)

*  sbox_hi_lim
      iwork = 3
      CALL ef_set_work_array_dims (id, iwork, 1, 1, 1, 1, 
     .   1, 1, mz2, 1)

*  sbox_lo_new
      iwork = 4
      CALL ef_set_work_array_dims (id, iwork, 1, 1, 1, 1, 
     .   1, 1, mz2, 1)

*  sbox_hi_new
      iwork = 5
      CALL ef_set_work_array_dims (id, iwork, 1, 1, 1, 1, 
     .   1, 1, mz2, 1)

*  dbox_lo_lim
      iwork = 6
      CALL ef_set_work_array_dims (id, iwork, 1, 1, 1, 1, 
     .   1, 1, mz3, 1)

*  dbox_hi_lim
      iwork = 7
      CALL ef_set_work_array_dims (id, iwork, 1, 1, 1, 1, 
     .   1, 1, mz3, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE zaxreplace_avg_compute(id, arg_1, arg_2, arg_3, 
     .     result, zaxsrc, sbox_lo_lim, sbox_hi_lim, sbox_lo_new, 
     .     sbox_hi_new, dbox_lo_lim, dbox_hi_lim)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .     mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .     mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .     mem3lot:mem3hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER i, j, k, l
      INTEGER i1, j1, l1, i2, j2, l2, i3, j3, l3
      INTEGER ifirst, iw, nbox, nsrc
      INTEGER nsrc_lo, nsrc_hi
      REAL frac, xsrc_min, xsrc_max, xsrc_lo, xsrc_hi, xsrcdiff
      REAL wtd, arg1_val, arg1_val_last, wtd_last
      REAL*8 sum, wtdsum
      REAL dbox_lo, dbox_hi
c      CHARACTER*132 err_msg

*  Dimension work arrays

      REAL*8 zaxsrc(wrk1lox:wrk1hix, wrk1loy:wrk1hiy,
     .               wrk1loz:wrk1hiz/2, wrk1lot:wrk1hit)
      REAL*8 sbox_lo_lim(wrk2lox:wrk2hix, wrk2loy:wrk2hiy,
     .               wrk2loz:wrk2hiz/2, wrk2lot:wrk2hit)
      REAL*8 sbox_hi_lim(wrk3lox:wrk3hix, wrk3loy:wrk3hiy,
     .               wrk3loz:wrk3hiz/2, wrk3lot:wrk3hit)
      REAL*8 sbox_lo_new(wrk4lox:wrk4hix, wrk4loy:wrk4hiy,
     .               wrk4loz:wrk4hiz/2, wrk4lot:wrk4hit)
      REAL*8 sbox_hi_new(wrk5lox:wrk5hix, wrk5loy:wrk5hiy,
     .               wrk5loz:wrk5hiz/2, wrk5lot:wrk5hit)
      REAL*8 dbox_lo_lim(wrk6lox:wrk6hix, wrk6loy:wrk6hiy,
     .               wrk6loz:wrk6hiz/2, wrk6lot:wrk6hit)
      REAL*8 dbox_hi_lim(wrk7lox:wrk7hix, wrk7loy:wrk7hiy,
     .               wrk7loz:wrk7hiz/2, wrk7lot:wrk7hit)

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)


      CALL ef_get_coordinates(id, ARG2, Z_AXIS, 
     .   arg_lo_ss(Z_AXIS, ARG2), arg_hi_ss(Z_AXIS, ARG2), zaxsrc)

      CALL ef_get_box_limits(id, ARG2, Z_AXIS, arg_lo_ss(Z_AXIS, ARG2), 
     .   arg_hi_ss(Z_AXIS, ARG2), sbox_lo_lim, sbox_hi_lim)


      CALL ef_get_box_limits(id, ARG3, Z_AXIS, arg_lo_ss(Z_AXIS, ARG3), 
     .   arg_hi_ss(Z_AXIS, ARG3), dbox_lo_lim, dbox_hi_lim)

* 
*  Loop over x,y,t of the input fields
*
      ifirst = 1
      iw = 0

      i1 = arg_lo_ss(X_AXIS,ARG1)
      i2 = arg_lo_ss(X_AXIS,ARG2)
      i3 = arg_lo_ss(X_AXIS,ARG3)
      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         j2 = arg_lo_ss(Y_AXIS,ARG2)
         j3 = arg_lo_ss(Y_AXIS,ARG3)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            l1 = arg_lo_ss(T_AXIS,ARG1)
            l2 = arg_lo_ss(T_AXIS,ARG2)
            l3 = arg_lo_ss(T_AXIS,ARG3)
            DO 200 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

*

* -ACM- Note: need to think about backwards and forwards z axes: ht vs depth ?


*  Translate the source boxes to the new axis units.

               DO 500 k = arg_lo_ss(Z_AXIS,ARG1), 
     .                    arg_hi_ss(Z_AXIS,ARG1)

*  Find the point on the source axis just below the box limit.  Interpolate
*  to get the box limit in new units.

                  nbox = 1

                  DO WHILE (zaxsrc(1,1,nbox,1) .LT. 
     .                      sbox_lo_lim(1,1,k,1) )
                     nbox = nbox + 1
                  ENDDO

                  IF (nbox .eq. 1) THEN 
                     sbox_lo_new(1,1,k,1) = arg_2(i2,j2,nbox,l2)
                  ELSE
                     frac = (sbox_lo_lim(1,1,k,1) - 
     .                      zaxsrc(1,1,nbox-1,1))/
     .                   (zaxsrc(1,1,nbox,1) - zaxsrc(1,1,nbox-1,1)) 
                     sbox_lo_new(1,1,k,1) = arg_2(i2,j2,nbox-1,l2) + 
     .                      frac* 
     .                  (arg_2(i2,j2,nbox,l2) - arg_2(i2,j2,nbox-1,l2))
                  ENDIF


                  nbox = 1

                  DO WHILE (zaxsrc(1,1,nbox,1) .LT. sbox_hi_lim(1,1,k,1)
     .                      .AND.
     .                  nbox .lt. arg_hi_ss(Z_AXIS,ARG1))
                     nbox = nbox + 1
                  ENDDO

                  IF (nbox .eq. 1) THEN 
                     sbox_hi_new(1,1,k,1) = arg_2(i2,j2,nbox,l2) 
                  ELSE
                     frac = (sbox_hi_lim(1,1,k,1) - 
     .                       zaxsrc(1,1,nbox-1,1))/
     .                  (zaxsrc(1,1,nbox,1) - zaxsrc(1,1,nbox-1,1)) 
                     sbox_hi_new(1,1,k,1) = arg_2(i2,j2,nbox-1,l2) + 
     .                      frac* 
     .                   (arg_2(i2,j2,nbox,l2) - arg_2(i2,j2,nbox-1,l2))
                  ENDIF


  500          CONTINUE 

* For each z line accumulate weighted source points and weights to get
* the average value.   Loop through the each destination grid box.


               sum = 0.
               wtdsum = 0.
               DO 100 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

*  Find the first and last source point in this destination box

                  nsrc_lo = 1
                  nsrc_hi = 1

                  DO WHILE 
     .                  (sbox_lo_new(1,1,nsrc_lo,1) .LT. 
     .                      dbox_lo_lim(1,1,k,1) )
                     nsrc_lo = nsrc_lo + 1
                     IF (nsrc_lo .GT. arg_hi_ss(Z_AXIS, ARG2)) GO TO 11
                  ENDDO
  11              CONTINUE

*  Find any portion of the source box lying in the destination box.

                  DO WHILE 
     .                  (sbox_lo_new(1,1,nsrc_hi,1) .LE. 
     .                      dbox_hi_lim(1,1,k,1) )
                     nsrc_hi = nsrc_hi + 1
                     IF (nsrc_hi .GT. arg_hi_ss(Z_AXIS, ARG2)) GO TO 22
                  ENDDO
  22              CONTINUE

                  nsrc_hi = nsrc_hi - 1

*  No source boxes within this destination box.

                  IF (nsrc_hi .LT. nsrc_lo) THEN
                     IF (wtdsum .NE. 0.) THEN
                        result(i,j,k,l) = sum / wtdsum
                     ELSE
                        result(i,j,k,l) = bad_flag_result
                     ENDIF
                     GO TO 160
                  ENDIF

                  DO 90 nsrc = nsrc_lo, nsrc_hi

*  Get fraction of this source box lying within the destination box. 

	               xsrc_min = sbox_lo_new(1,1,nsrc,1)
	               xsrc_max = sbox_hi_new(1,1,nsrc,1)

                       dbox_hi = dbox_hi_lim(1,1,k,1)
                       dbox_lo = dbox_lo_lim(1,1,k,1)

	               xsrc_lo = MAX(xsrc_min, dbox_lo)
	               xsrc_hi = MIN(xsrc_max, dbox_hi)

                       xsrcdiff = xsrc_max - xsrc_min
                       wtd = 0.
                       IF (xsrcdiff .NE. 0.) 
     .                     wtd = (xsrc_hi - xsrc_lo)/xsrcdiff

                       arg1_val = arg_1(i1,j1,nsrc,l1)
                       IF (arg1_val .ne. bad_flag(ARG1)) THEN
	                  sum   = sum  + wtd * arg1_val
                          wtdsum  = wtdsum + wtd

                          arg1_val_last = arg1_val
                          wtd_last = wtd

                       ENDIF
  
  90              CONTINUE

* If we had any good data, calculate the average.

                  IF (wtdsum .NE. 0.) THEN
                     result(i,j,k,l) = sum / wtdsum

*  Start next average with remaining weighted part of the last box with
*  was not within the destination box.

                     sum = (1.- wtd_last)* arg1_val_last
                     wtdsum = 1.- wtd_last
                  ELSE 
                     result(i,j,k,l) = bad_flag_result
                     sum = 0.
                     wtdsum = 0.
                  ENDIF

 160              CONTINUE

 100           CONTINUE

               l1 = l1 + arg_incr(T_AXIS,ARG1)
               l2 = l2 + arg_incr(T_AXIS,ARG2)
               l3 = l3 + arg_incr(T_AXIS,ARG3)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
            j2 = j2 + arg_incr(Y_AXIS,ARG2)
            j3 = j3 + arg_incr(Y_AXIS,ARG3)
 300     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
         i2 = i2 + arg_incr(X_AXIS,ARG2)
         i3 = i3 + arg_incr(X_AXIS,ARG3)
 400  CONTINUE

      
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

	SUBROUTINE EXTRACT_DP_LINE( cx, grid_data, dp_line, idim, nout )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* extract a single line of data from a memory variable grid along axis idim
* no error checking is done

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  9/20/89 - 4D symmetrical
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

* 5/15 NOTE: the newer routine EXTRACT_ARG1_LINE can probably replace this
*      and is more appropriately sensitive to argument idim

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xmem_subsc.cmn'

* calling argument declarations:
	INTEGER	cx, mv, idim, nout
	REAL grid_data( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit,m1loe:m1hie,m1lof:m1hif )
	REAL*8	dp_line(nout)

* internal variable declarations:
	INTEGER	iout, i, j, k, l, m, n

* extract the line
	iout = 0
	DO 200 n = cx_lo_s6(cx), cx_hi_s6(cx)
	DO 200 m = cx_lo_s5(cx), cx_hi_s5(cx)
	DO 200 l = cx_lo_s4(cx), cx_hi_s4(cx)
	DO 200 k = cx_lo_s3(cx), cx_hi_s3(cx)
	DO 200 j = cx_lo_s2(cx), cx_hi_s2(cx)
	DO 200 i = cx_lo_s1(cx), cx_hi_s1(cx)

	   iout = iout + 1
	   dp_line( iout ) = grid_data( i,j,k,l,m,n )

 200	CONTINUE

	RETURN
	END

	LOGICAL FUNCTION TM_ITS_CDF ( dset, dtype )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine if this a netCDF data set
* the common variable cd_what_isit is modified only if it is EPIC

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V5.0 5/99 *sh* (used for strides, reversals, and permutates of netCDF files)
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* argument definitions:
*	dset	- data set number
*       dtype - returns the ds_type string

* argument declarations
      INTEGER dset

      include 'netcdf.inc'
      include 'tmap_errors.parm'
      include 'tmap_dims.parm'
      include 'xdset_info.cmn_text'
      external xdset_info_data
      include 'xdset_info.cd_equiv'


* internal variable declarations:
        LOGICAL result
        CHARACTER dtype*4

* initialize
        dtype = ' '

* sanity check
        IF ( dset.LE.0 .OR. dset.GT.maxdsets ) GOTO 1000

* 'CDF', 'ECDF', and 'MC' (??) are all netCDF data sets
! don't say yes for 'MC' as of 5/99 -- time axis requires special processing
        dtype = ds_type(dset)
        TM_ITS_CDF = dtype.EQ.'CDF' .OR. dtype.EQ.'ECDF'
        RETURN

* it is not netCDF
 1000   TM_ITS_CDF = .FALSE.
        RETURN
        END

	SUBROUTINE DELETE_ALL_UVAR_GRIDS

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* delete all the grids that have been determined for user variables

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V230:  8/10/92 - needed for DEFINE REGION which may change the implied
*                  context info of uvars using let x = var[@reg] notation
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include 'ferret.parm'	
	include 'xvariables.cmn'

* calling argument declarations:
* ...

* internal variable declarations:
	INTEGER	i, uvar, j, num_indices

* loop through the user-defined variables
*	DO 500 uvar = 1, max_uvar
*	   IF ( uvar_num_items( uvar ) .EQ. uvar_deleted ) GOTO 500
        CALL deleted_list_get_undel(uvar_num_items_head,
     .                              deleted_list_result(1),
     .                              max_uvar, num_indices )
        DO 500 j = 1, num_indices
           uvar = deleted_list_result(j)
* return to default that all limits are irrelevant
	   DO 100 i = 1, nferdims
 100	   uvar_given(i,uvar) = uvlim_irrelevant

* reset grid to unknown for all data sets and clear dynamic grid info
	   CALL DEALLO_UVAR_GRIDS(uvar)

 500	CONTINUE

 	RETURN
	END

	INTEGER FUNCTION TM_GET_LINEMATCH (gvn_line, dup_name, dup_guts)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Searches the list of pre-defined line_name's and returns the number
* associated with a "match" on lname. A match means that the the characters
* of lname are all found plus, optionally, digits. If no match is found
* the value unspecified_int4 is returned.

* dup_name - returned TRUE if there is an identical name match OR (there
*	     is a pattern name match AND the guts are identical)
* dup_guts - returned TRUE if there is a pattern name match AND the guts
*	     are identica


* V510 *sh* 4/00
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files
* V6.95+ 11/15 *sh*  when dup_guts is found do not return immediately -- 
*                    instead continue through the axes to see if there may
*                    also be a dup_name. This for special needs of creating
*		     an aggregated T axis by modifying the axis of the 1st file
*                   

* Include files
#include "tmap_dset.parm"	
	include 'tmap_dims.parm'	! 
#include "gt_lib.parm"

* argument variables
	LOGICAL		dup_name, dup_guts
	INTEGER		gvn_line

* local variable declarations
	LOGICAL		xact_name
	INTEGER*4	i

* initialize
	dup_name = .FALSE.
	TM_GET_LINEMATCH = unspecified_int4

* Note: the code logic appears to return the *last* dup_guts found, but
*       logic in Ferret ensures that there can be at most one such match 

* check the static axes
	DO 100 i=1,max_lines
	  CALL TM_GET_LINEMATCH_SUB(gvn_line, i, xact_name, dup_guts)
	  IF (dup_guts) TM_GET_LINEMATCH = i
	  IF (xact_name) dup_name = .TRUE.
 100	CONTINUE
 
* check the dynamic grids
	i = 0
 200	CALL TM_NEXT_DYN_LINE( i, *299)
	  CALL TM_GET_LINEMATCH_SUB(gvn_line, i, xact_name, dup_guts)
	  IF (dup_guts) TM_GET_LINEMATCH = i
	  IF (xact_name) dup_name = .TRUE.
	GOTO 200

 299	RETURN
	END

	SUBROUTINE MAKE_DSG_FEATURE_MASK(dset, cx, fmask, nfeatures )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Create a feature mask for a DSG based upon world coordinate limits
* in the given context

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V720 4/17 *sh*
* V73+ *acm* 12/17 INIT_CXDSG needs nfeatures
* V741 6/18 *acm* Mask check enhanced for partial overlap of feature and region
*                 and handle modulo longitudes
* V741 7/18 *acm* Fixes for modulo longitudes in computing whether context
*                 and coordinate regions overlap
* V74+ 8/18 *acm* More on modulo longitudes and the mask
* V76  1/20 *acm* working with Point-type dsg data

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xtm_grid.cmn_text'
	include 'xdset_info.cmn_text'
	include 'xdyn_linemem.cmn_text'
	include 'xcontext.cmn'
	include 'xdsg_context.cmn'
	include 'xprog_state.cmn'
	include 'xvariables.cmn'
#include "tmap_dset.parm"

* calling argument declarations:
	INTEGER dset, cx, nfeatures
	LOGICAL fmask(nfeatures)

* internal variable declarations:
        LOGICAL one_or_other, ismod, its_dsg, ignore_depth
	INTEGER grid, i, idim, lm, orientation, obsdimlen, feature_line
	REAL    GET_LINE_COORD, coord, ftr_lo(4,nfeatures), ftr_hi(4,nfeatures), 
     .		flo, fhi, axmod, bad, val

	axmod = 360.0

* Will allow depth coordinates to be missing for timeseries or trajectory data

	grid = dsg_xlate_grid(dset)
	CALL TM_DSG_FACTS( grid, orientation, obsdimlen, feature_line, its_dsg )
	ignore_depth = orientation.EQ.pfeatureType_Trajectory .OR. 
     .                 orientation.EQ.pfeatureType_Point .OR. 
     .                 orientation.EQ.pfeatureType_TimeSeries

! DSGTBD: presently the same constraints mask gets re-computed many times:
! ... during each IS_DO_OP, during regridding, and for final LIST, PLOT, etc.
! It would be desirable to avoid this. A way to do this would be
!  1. compute a unique hash based upon the XYZTE context constraints
!  2. save the masks that computed here in lm line memory
!  3. use the hash value and dataset number to recover the saved masks
!  4. clean out the stored masks (say?) when the dataset gets closed

* initialize
	cxdsg_constrain_e = .FALSE.
	IF (cx .GT. cx_none) CALL INIT_CXDSG(dset, cx, nfeatures)  ! summarize context ww limits

* preset the features and obs masks based upon E constraints
	IF (cxdsg_constrain_e) THEN
	   DO i = 1, nfeatures
	      fmask(i) = i .GE. cxdsg_lo_e .AND. i .LE. cxdsg_hi_e
	   ENDDO
	ELSE
	   DO i = 1, nfeatures
	      fmask(i) = .TRUE.
	   ENDDO
	ENDIF

* Did the user send in a mask with e.g. "PLOT/FMASK var, maskvals"

	IF (dsg_msk_lm(dset) .NE. unspecified_int4) THEN
	   DO i = 1, nfeatures 
	      val = GET_LINE_COORD (linemem(dsg_msk_lm(dset))%ptr, i)
	      fmask(i) = (val.NE.0. .AND. val.NE.bad_val4) 
	   ENDDO
	ENDIF

* quick exit?
	IF (cxdsg_no_coord_constraints .OR. cx .EQ. cx_none) RETURN

* get the coordinate extremes feature by feature
	CALL DSG_FEATURE_LIMS(dset, nfeatures, ftr_lo, ftr_hi)

* first mask at the feature level based on instance coordinates
	DO idim = 1, t_dim
	   IF (.NOT.cxdsg_constrain(idim)) CYCLE
	   IF (.NOT.cxdsg_has_coord(idim)) CYCLE
   
	   bad = cxdsg_bad_val(idim)
	   IF (cxdsg_is_obs_coord(idim)) THEN

* ... use the coordinate extremes for this feature

	      DO i = 1, nfeatures

	         IF (.NOT.fmask(i)) CYCLE

                 flo = ftr_lo(idim,i)
                 fhi = ftr_hi(idim,i)

		 IF ((flo.EQ.unspecified_val8 .OR. fhi.EQ.unspecified_val8) .AND.
     .		     (idim.EQ.z_dim.OR.idim.EQ.t_dim) .AND. 
     .		      ignore_depth ) CYCLE  ! Depths might be all bad, feature still ok

		 IF (idim .EQ. x_dim) THEN
		    CALL MODSCAT ( cxdsg_constrain_lo(idim), 
     .		       cxdsg_constrain_hi(idim), axmod, 1, flo)
		    CALL MODSCAT ( cxdsg_constrain_lo(idim), 
     .		       cxdsg_constrain_hi(idim), axmod, 1, fhi)
		    ismod = flo.NE.ftr_lo(idim,i) .OR. fhi.NE.ftr_hi(idim,i)
		 ENDIF 

* Does the requested region lie partially or entirely within the feature?
		 one_or_other =
     .              ( (cxdsg_constrain_lo(idim) .GE. flo .AND. 
     .                 cxdsg_constrain_lo(idim) .LE. fhi )      .OR.   
     .		      (cxdsg_constrain_hi(idim) .GE. flo .AND. 
     .		       cxdsg_constrain_hi(idim) .LE. fhi)     )

* or if the feature lies within the requested region that's ok too 
		 IF (.NOT.one_or_other) THEN
		    one_or_other =
     .              ( (flo .GE. cxdsg_constrain_lo(idim) .AND. 
     .                 flo .LE. cxdsg_constrain_hi(idim) )      .OR.   
     .		      (fhi .GE. cxdsg_constrain_lo(idim) .AND. 
     .		       fhi .LE. cxdsg_constrain_hi(idim))     )    
		 ENDIF

		 fmask(i) = fmask(i).AND. one_or_other
	      ENDDO

	   ELSE

* ... use the single point coordinate for this feature

	      lm = cxdsg_coord_lm(idim)
	      DO i = 1, nfeatures
	         coord = dsg_linemem(lm)%ptr(i)
	         IF (coord .EQ. bad) CYCLE
		 IF (idim .EQ. x_dim) CALL MODSCAT  (
     .		       cxdsg_constrain_lo(idim), 
     .		       cxdsg_constrain_hi(idim), axmod, 1, coord)

                 fmask(i) = fmask(i)
     .		  .AND. coord .LE. cxdsg_constrain_hi(idim) 
     .		  .AND. coord .GE. cxdsg_constrain_lo(idim)
	      ENDDO
	   ENDIF
	ENDDO

	RETURN
	END

	SUBROUTINE MC_INIT_DSET(dset_num,lunit,perm,tregular,use_strict,do_dsg,status)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Initialize a multifile (cdf) dataset.
*    - read in stepfile information from descriptor
*    - call cd_init_dset on first file of data set to set up all 
*      common information for the dataset, such as variables, etc
*    - read gridfile containg time axis definition and associate the
*      time axis with the parent grids
*
* *kob* 6/95  - modified from gt_init_dset.F
* *kob*	9/96  - uncommented check for delta = 0.  This should work and should
*		indicate a file with only one timestep in it, and therefore
*		a possible irregular data set.  At this time, this is not
*		implemented, and instead a message is issued which tells
*		the user to use 1 as the delta rather than 0.  
*
* *kob* 9/96  - it was decided by steve and myself that this code can not
*		handle mc data sets of netcdf files which have irregular
*		timesteps internally.  THis is because the timesteps are
*		never read from the netcdf files, except for the first one.
*		This opens up a can of worms, and we decided it would 
*		probably be best to await the netcdf-library capability to
*		access multiple netCDF files.
* Linux port -kob - 3/97 - Modify include for tmap_dset.parm to be a
*			   preprocessor include for F90 - needed because
*			   tmap_dset.parm contains an ifdef
*
* V500 *kob* 4/99 - removed unneeded variable_record namelista
*	*sh* 7/99 - added perm argument needed for netCDF permutations
* V510 *sh* 3/00 - added tregular argumant
* v581 *acm* 4/2005  Add sf_ndxs and sf_ndxe to use indices rather than timesteps
*                     for indexing mc datasets in mc_read.
* V65  *acm* 2/10- all warnings and notes to std error not std out
* V68  *acm* 1/12- added use_strict argument for ticket 1910: micro-adjusting on 
*                  repeated coordinates in netCDF/OPeDNAP datasets
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
* V682 *acm* 9/12  Fix ticket 1969: stepfiles may have 3- or 4-digit extensions 
*                  when listed under S_NUM_OF_FILES
* V698+ *sh* 11/15 new arg in call to CD_INIT_DSET ... not relevant here
* V698  3/16 *acm* Removed Philander-Seigel code including diagnostic variables, 
* pre-defined axes and grids.
* V745 *acm*  5/20  added mode_dsg to control turning off all DSG ops

* arguments:
*	dset_num	- number assigned to this data set (output)
*			  ( 1 <= dset_num <= maxdsets - see COMMON XDSET_INFO)
*	lunit		- logical unit descriptor is opened on
*	perm		- permutation of data (unused for MC data sets)
*	status		- return status
*
* 
* Argument definitions
	LOGICAL tregular, use_strict,do_dsg
	INTEGER		dset_num, lunit, perm(*), status

* Parameter and common files

	include 'tmap_errors.parm'		! error codes
#include "tmap_dset.parm"	
	include 'tmap_dims.parm'		! data set dimensions
#include "gt_lib.parm"
	include 'xio.cmn_text'
        external xio_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xdset_info.cmn_text'		! data set common
	external xdset_info_data
	include 'xstep_files.cmn_text'		! step file common
	external xstep_files_data

* Define variables from Set File namelist records

	include 'descript.def'


* Internal declarations
*	CHARACTER*18	reading_nml
*	INTEGER*4	stp_pos, min_file, max_file, file_num,
*     .			cnt_stp, istat
*        INTEGER*4       upstat
*	INTEGER		TM_GET_GRIDNUM, TM_LENSTR, STR_UPCASE
*	REAL		last_delta, file_trange, steps_in_file
*	LOGICAL		TM_FPEQ

        CHARACTER*11    temp_t0time
	CHARACTER*13	TM_STRING
	CHARACTER*18	reading_nml
	CHARACTER*64    string
	INTEGER*4	var_cnt, var_pos, ivar, npos, bypoint, byline,
     .			byplane, l_ivar, stp_pos, min_file, max_file,
     .			file_num, cnt_stp, nrecperstep, epos, first_file,
     .			file_cnt, stp_cnt, min_pos, max_pos,istat, lcnt,
     .			lline, file_reclen, prev_steps, lenb, dot, ic
        INTEGER*4       upstat
	INTEGER		TM_GET_GRIDNUM, TM_LENSTR, STR_UPCASE
	REAL*8		last_delta, file_trange, steps_in_file
	LOGICAL		TM_FPEQ

* local parameter definitions
* NOTE (11/15) - this parameter exists to avoid the chance that DEF DATA/AGG/T 
* may inadvertently modify the time axis of a previously inited dataset.
* It is remotely possible that the same risk (never detected) exists with
* MC datasets.  If so, then just set this to .FALSE. to fix it.
* in the MC dataset code -- that like
	LOGICAL ok_share_taxis
	PARAMETER (ok_share_taxis = .TRUE.)

* record 3 - required message 
*
	NAMELIST /MESSAGE_RECORD/d_alert_on_open,
     .				d_alert_on_output,d_message
*
*
*
	NAMELIST /EXTRA_RECORD/ d_extra_des_info
*
	NAMELIST /STEPFILE_RECORD/s_filename,s_aux_set_num,s_start,
     .				  s_end,s_delta,s_num_of_files,
     .				  s_regvarflag,s_index


	reading_nml = 'MESSAGE_RECORD'
	READ (lunit, NML=MESSAGE_RECORD, END=5000, ERR=5100)
	ds_alert_on_open(dset_num) = d_alert_on_open
	ds_alert_on_output(dset_num) = d_alert_on_output
	ds_message(dset_num) = d_message
	IF (d_alert_on_open) THEN
	   CALL WARN ('regarding '//
     .	      ds_name(dset_num)(:TM_LENSTR(ds_name(dset_num)))
     .	      //' ...')
	   CALL WARN(d_message)
	ENDIF

* Last data set record - EXTRA_RECORD

	reading_nml = 'EXTRA_RECORD'

	READ (lunit, NML=EXTRA_RECORD, END=5000, ERR=5100)
*	ds_extra_des_info(dset_num) = d_extra_des_info

* step records - one for each step file stored

	stp_pos = 1
	min_file = maxstepfiles
	max_file = 0
	file_num = 0
*	ds_regsteps(dset_num) = .TRUE.
	last_delta = -999.
	cnt_stp = 1
* kob 1/97 remove space between STEPFILE_RECORD and I2 and bump I2 up to
*        I3.  this is needed to prevent error message when more than
*        100 stepfiles are used.
        WRITE (reading_nml(1:18),'(''STEPFILE_RECORD'',I3)') cnt_stp

* Initialize some STEPFILE variables
	s_aux_set_num = 0
	s_regvarflag  = ' '
	s_index       = ' '
	s_delta	      = 0	! *sh* 9/90

        prev_steps = 0

  170	READ (lunit, NML=STEPFILE_RECORD, END=5000, ERR=5100)

* check to see if this is last step record
	IF (s_filename .EQ. end_of_stepfiles) GOTO 220

* Check for unsupported features
*kob* uncommented check for delta = 0.  This should be allowed in order to
* indicate an irregular file or a file with one timestep in it, but this is
* not supported as of now.  9/96
	  IF (s_regvarflag .NE. ' ') CALL TM_ERRMSG
     .		(merr_notsupport, status, 'MC_INIT_DSET',
     .		 dset_num, no_stepfile,
     .		 'Descriptor requests irregular variables',
     .		 no_errstring, *9900)
	  IF (s_delta .EQ. 0) CALL TM_ERRMSG
     .		(merr_notsupport, status, 'MC_INIT_DSET',
     .		 dset_num, no_stepfile,
     .		 'Descriptor requests delta of 0, please use 1',
     .		 no_errstring, *9900)
	  IF (s_index .NE. ' ') CALL TM_ERRMSG
     .		(merr_notsupport, status, 'MC_INIT_DSET',
     .		 dset_num, no_stepfile, 
     .		 'Descriptor requests INDEX files', no_errstring, *9900)

	cnt_stp = cnt_stp + 1
	WRITE (reading_nml(1:18),'(''STEPFILE_RECORD '',I2)') cnt_stp

* calculate time range per file and check for even number per file
	file_trange = (s_end+s_delta-s_start)/s_num_of_files
	IF ( s_delta .GT. 0 ) THEN
	   steps_in_file = file_trange / s_delta 
	   IF (ABS(steps_in_file/NINT(steps_in_file)-1.0) .GT. 1.E-6) THEN
              WRITE (string,1100)
 1100         FORMAT(' WARNING - NON-INTEGER NUMBER OF STEPS PER STEPFILE'/
     .               ' INDICATED IN DESCRIPTOR - TRYING TO CONTINUE ANYWAY')
              lenb = TM_LENSTR( string )
              CALL WARN( string(:lenb) )
	   ENDIF
	ENDIF


* compute how many records in each time step (with no tuples/missing vars)
	nrecperstep= nintro_recs
	DO 180 ivar = 1,maxvars
	  IF (ds_var_setnum(ivar) .NE. dset_num ) GOTO 180
	  nrecperstep= nrecperstep+ds_nrecpervar(ivar)
  180	CONTINUE

* figure out if we should read filename for file number (read P.R.G)
	IF (s_num_of_files .GT. 1) THEN
	  epos = TM_LENSTR(s_filename)
	  dot = 0
	  do ic = epos, 1, -1
	    IF (s_filename(ic:ic) .EQ. '.') GOTO 188
	    dot = dot + 1
	  enddo
  188	  CONTINUE
          dot = epos - dot + 1
	  READ  (s_filename(dot:epos),1200) first_file
 1200	  FORMAT(I3)
	ELSE
	  first_file = file_num+1
	ENDIF

	DO 210 file_cnt = first_file, first_file+s_num_of_files-1
	  file_num = file_cnt
* Find the next storage position for stepfiles in common
	  DO 190 stp_cnt = stp_pos,maxstepfiles
	    IF (sf_setnum(stp_cnt) .EQ. set_not_open) GOTO 200
  190	  CONTINUE
* No room left for new stepfiles
	  CALL TM_ERRMSG ( merr_filim, status, 'GT_INIT_DSET',
     .			   dset_num, no_stepfile,
     .			   'MAX='//TM_STRING(DBLE(maxstepfiles)),
     .			   no_errstring, *9900)

* smallest file number has smallest timestep (for ds_1step)
  200	  IF (file_cnt .LT. min_file
     .	      .AND. s_aux_set_num .EQ. main_set) THEN
	    min_file = file_cnt
	    min_pos  = stp_cnt
	  ENDIF
* largest file number has largest timestep (for ds_lastep)
	  IF (file_cnt .GT. max_file
     .	      .AND. s_aux_set_num .EQ. main_set) THEN
	    max_file = file_cnt
	    max_pos  = stp_cnt
	  ENDIF

* store values in common
* Modified to check for time-independance of data.  If so, the 1st and last
*   time steps are set to unspecified_val8 -----> 6/91 kob
          sf_reclen(stp_cnt) = file_reclen   ! *sh* 3/91
	  sf_name  (stp_cnt) = s_filename
          upstat = STR_UPCASE(temp_t0time,ds_t0time(dset_num))  ! kob 6/91
	  IF (s_num_of_files .GT. 1) THEN
	     IF (file_cnt .LE. 999) THEN
	        WRITE (sf_name(stp_cnt)(epos-3:epos),1300) file_cnt
 1300	        FORMAT('.',I3.3)
             ELSE
	        WRITE (sf_name(stp_cnt)(dot-1:dot+3),1301) file_cnt
 1301	        FORMAT('.',I4.4)
             ENDIF

 	     sf_1step(stp_cnt) = s_start +
     .				   file_trange*(file_cnt-first_file)
	     sf_lastep(stp_cnt) = sf_1step(stp_cnt)+file_trange-s_delta

	     sf_ndxs(stp_cnt) = 1 + steps_in_file* (file_cnt-first_file)
	     sf_ndxe(stp_cnt) = sf_ndxs(stp_cnt) + steps_in_file - 1

	  ELSEIF (INDEX(temp_t0time,'INDEPENDENT') .GT. 0) THEN  !
             sf_1step(stp_cnt) =  unspecified_val8               ! kob -            
             sf_lastep(stp_cnt) = unspecified_val8               ! 6/91
             sf_ndxs(stp_cnt) =  unspecified_int4          
             sf_ndxe(stp_cnt) = unspecified_int4 
          ELSE  
	     sf_1step (stp_cnt) = s_start
	     sf_lastep(stp_cnt) = s_end
	     sf_ndxs (stp_cnt) = 1 + prev_steps
c	     sf_ndxe(stp_cnt) = steps_in_file + sf_ndxs(stp_cnt) - 1 
	     sf_ndxe(stp_cnt) =INT(steps_in_file+0.5)+sf_ndxs(stp_cnt)-1   ! rounding wierdness

	  ENDIF
          prev_steps = sf_ndxe(stp_cnt)
	  sf_delta(stp_cnt) = s_delta
	  sf_setnum(stp_cnt) = dset_num
	  sf_aux_set_num(stp_cnt) = s_aux_set_num
	  sf_nrecperstep(stp_cnt) = nrecperstep
	  sf_lunit(stp_cnt) = file_not_open
	  sf_index(stp_cnt) = s_index
	  IF (s_regvarflag .EQ. ' ') sf_regvars(stp_cnt) = .TRUE.
	  IF (last_delta .EQ. -999.) last_delta = s_delta
	  IF (s_delta .NE. 0) THEN
	    sf_regtimes(stp_cnt) = .TRUE.
	  ELSE
	    sf_regtimes(stp_cnt) = .FALSE.
	  ENDIF
* removed SNGL function from evalutating last_delta because it isn't
* a real*8   *kob* 14apr94
* v51 - put it back in - last_delta IS a real*8
#ifdef double_p
	  ds_regsteps(dset_num) = ds_regsteps(dset_num) .AND.
     .				  sf_regtimes(stp_cnt) .AND.
     .		     TM_FPEQ((s_delta), (last_delta))
#else
	  ds_regsteps(dset_num) = ds_regsteps(dset_num) .AND.
     .				  sf_regtimes(stp_cnt) .AND.
     .		     TM_FPEQ(SNGL(s_delta), SNGL(last_delta))
#endif
	  stp_pos = stp_cnt
  210	CONTINUE
	GOTO 170

* successful completion
  220	ds_1step(dset_num)  = SNGL(sf_1step(min_pos))
	ds_lastep(dset_num) = SNGL(sf_lastep(max_pos))
	IF (ds_regsteps(dset_num)) THEN
	  ds_delstep(dset_num)  = SNGL(sf_delta(min_pos))
	ELSE
	  ds_delstep(dset_num) = 0.
	ENDIF
	status = merr_ok
	

	CALL CD_INIT_DSET( dset_num, perm, tregular, use_strict,
     .			   ok_share_taxis,do_dsg,status)

	GOTO 9990


* errors
 5000	CALL TM_ERRMSG (merr_nmlerr, status, 'MC_INIT_DSET',
     .			dset_num, no_stepfile,
     .			'Didn''t find: '//reading_nml,
     .			no_errstring, *9900)

 5100	CALL TM_ERRMSG (merr_nmlerr, status, 'MC_INIT_DSET',
     .			dset_num, no_stepfile,
     .			'Error in: '//reading_nml,
     .			no_errstring, *9900)

 5200	CALL TM_ERRMSG (merr_nmlerr, status, 'MC_INIT_DSET',
     .			dset_num, no_stepfile,
     .			'Error in stepfile names '//reading_nml,
     .			no_errstring, *9900)

* get out from error
 9900	CALL TM_CLOSE_SET ( dset_num, istat )

* get out
 9990	CLOSE (UNIT = lunit)
	CALL LIB_FREE_LUN (lunit)
	RETURN
	END

	LOGICAL FUNCTION TM_SAME_GRID_DEF( grid1, grid2 )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Check to see if the guts of the two grids are identical

* revision 0.00 - Steve Hankin - based on TM_FIND_LIKE_GRID by  M. Verschell
* 12/3/92 *sh* - on mpsnorm axes ignore inner/outer
* IBM port 14apr94 *kob* : Logical expressions need to be compared
*			   using NEQV and EQV
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing

* Include files

	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'xtm_grid.cmn_text'
	
* Argument definitions
	INTEGER*4	grid1, grid2

* Local definitions
	INTEGER*4	i

	DO 100 i=1,nferdims
	  IF (grid_line(i,grid1) .NE. grid_line(i,grid2) ) GOTO 1000
          IF ( grid_line(i,grid1) .NE. mpsnorm ) THEN           ! 12/3
             IF (grid_out_prod(i,grid1) .NEQV. grid_out_prod(i,grid2))
     .	                                                   GOTO 1000
          ENDIF
  100	CONTINUE

* All nferdims axis matched - check grid rotation
	IF (grid_rotation(grid1) .NE. grid_rotation(grid2)) GOTO 1000

* they match
  	TM_SAME_GRID_DEF = .TRUE.
        RETURN

* they don't match
 1000   TM_SAME_GRID_DEF = .FALSE.
        RETURN

	END

* 
*  expndi_by_m_counts_str.F
* 
*  Ansley Manke (from expndi_by_z_counts)
*  4/2014
* 
* Expand argument 1 by creating a 2D XE structure from it with the 
* separation between X rows given by the lengths specified in 
* argument 2. Argument 2 is a list of length N, where N is the number of 
* X rows to create, and each item in the list is the length of that 
* column (the length of the cruise or profile). Thus the X rows created 
* are "ragged" Typical use is that arg 1 is a collection of vertical casts 
* appended end-to-end and that arg 2 is the number of values in each cast.
* The sum of the values in arg 2 is the length of argument 1. 

*  Args 3 and 4 are constants -- the size of the X and E axes, respectively
 
*  In this subroutine we provide information about
*  the function.  The user configurable information 
*  consists of the following:
* 
*  descr              Text description of the function
* 
*  num_args           Required number of arguments
* 
*  axis_inheritance   Type of axis for the result
*                        ( CUSTOM, IMPLIED_BY_Z_ARGS, q, ABSTRACT )
*                        CUSTOM          - user defined axis
*                        IMPLIED_BY_Z_ARGS - same axis as the incoming argument
*                        NORMAL          - the result is normal to this axis
*                        ABSTRACT        - an axis which only has index values
* 
*  piecemeal_ok       For memory optimization:
*                        axes where calculation may be performed piecemeal
*                        ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE expndi_by_m_counts_str_init(id)

      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .  'Expand String-valued arg1 into an XE grid. (Split I variable into E-Rows)' )

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id, IMPLIED_BY_ARGS, NORMAL, 
     .     NORMAL, NORMAL, IMPLIED_BY_ARGS, NORMAL)
      CALL ef_set_result_type(id, STRING_RETURN)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'Data')
      CALL ef_set_arg_desc(id, arg, '1-D variable to expand')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, NO, NO)
      CALL ef_set_arg_type (id, arg, STRING_ARG)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'Row Sizes')
      CALL ef_set_arg_desc(id, arg,
     .          '1-D list on E axis: count of values in each feature')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, YES, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'Result X axis')
      CALL ef_set_arg_desc(id, arg,
     .          'Variable on a 1-D grid, axis of length max_row_len')
      CALL ef_set_axis_influence_6d(id, arg, YES, NO, NO, NO, NO, NO)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

* 
*  In this subroutine we compute the result
* 
      SUBROUTINE expndi_by_m_counts_str_compute(id, arg_1, arg_2, arg_3, 
     .                               result)

      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy,
     .	   mem1loz:mem1hiz, mem1lot:mem1hit,
     .	   mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy,
     .     mem2loz:mem2hiz, mem2lot:mem2hit,
     .	   mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy,
     .     mem3loz:mem3hiz, mem3lot:mem3hit,
     .	   mem3loe:mem3hie, mem3lof:mem3hif)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .     memresloz:memreshiz, memreslot:memreshit,
     .     memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(6), res_hi_ss(6), res_incr(6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS), arg_hi_ss(6,EF_MAX_ARGS),
     .     arg_incr(6,EF_MAX_ARGS)


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l,m,n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2
      INTEGER imax, iout, isum, mmax, mrow, mout, slen
      CHARACTER*2048 buff

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* limits on output arrays
        imax = res_hi_ss(X_AXIS)
        mmax = res_hi_ss(E_AXIS)

* sum of counts in arg 2 must be length of x-dimension of arg1

      do 20 i2 = arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS,ARG2)
      do 20 j2 = arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS,ARG2)
      do 20 k2 = arg_lo_ss(Z_AXIS,ARG2), arg_hi_ss(Z_AXIS,ARG2)
      do 20 L2 = arg_lo_ss(T_AXIS,ARG2), arg_hi_ss(T_AXIS,ARG2)
      do 20 n2 = arg_lo_ss(F_AXIS,ARG2), arg_hi_ss(F_AXIS,ARG2)
         isum = 0
         DO 10 m2 = arg_lo_ss(E_AXIS,ARG2), arg_hi_ss(E_AXIS,ARG2)
            IF  (arg_2(i2,j2,k2,l2,m2,n2) .EQ. bad_flag(ARG2) .OR. 
     .           INT(arg_2(i2,j2,k2,l2,m2,n2)) .LT. 0)
     .          CALL EF_BAIL_OUT(id, 'arg 2 must be non-missing counts GE zero')
            isum = isum + INT(arg_2(i2,j2,k2,l2,m2,n2))
 10   CONTINUE
         IF (isum .NE. (arg_hi_ss(X_AXIS,ARG1)-arg_lo_ss(X_AXIS,ARG1)+1) )
     .       CALL EF_BAIL_OUT(id, 
     .         'arg 2 values (counts) must sum to x-dimension length of of arg1 ')
 20   CONTINUE


* fill in the points as specified by the counts

      n1 = arg_lo_ss(F_AXIS,ARG1)
      n2 = arg_lo_ss(F_AXIS,ARG2)
      DO 400 n=res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

      l1 = arg_lo_ss(T_AXIS,ARG1)
      l2 = arg_lo_ss(T_AXIS,ARG2)
      DO 400 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

      k1 = arg_lo_ss(Z_AXIS,ARG1)
      k2 = arg_lo_ss(Z_AXIS,ARG2)
      DO 400 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

      j1 = arg_lo_ss(Y_AXIS,ARG1)
      j2 = arg_lo_ss(Y_AXIS,ARG2)
      DO 400 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

         i1 = arg_lo_ss(X_AXIS,ARG1)
         i2 = arg_lo_ss(X_AXIS,ARG2)

         m1 = arg_lo_ss(E_AXIS,ARG1)
         m2 = arg_lo_ss(E_AXIS,ARG2)
 
            i1 = 1
            DO 200 mout=arg_lo_ss(E_AXIS,ARG2),arg_hi_ss(E_AXIS,ARG2)
               DO 100 iout = 1, NINT(arg_2(i2,j2,k2,l2,mout,n1))
                  CALL EF_GET_STRING_ARG_ELEMENT_6D(id, ARG1, arg_1,
     .                             i1,j1,k1,l1,m1,n1, slen, buff)
                  CALL EF_PUT_STRING(buff, slen, result(iout,j,k,l,mout,n))

                  i1 = i1 + 1
 100           CONTINUE

 200        CONTINUE

         j1 = j1 + arg_incr(Y_AXIS,ARG1)
         j2 = j2 + arg_incr(Y_AXIS,ARG2)
         k1 = k1 + arg_incr(Z_AXIS,ARG1)
         k2 = k2 + arg_incr(Z_AXIS,ARG2)
         l1 = l1 + arg_incr(T_AXIS,ARG1)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
         n1 = n1 + arg_incr(F_AXIS,ARG1)
         n2 = n2 + arg_incr(F_AXIS,ARG2)
 400  CONTINUE
      
         
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*           rr_flux_sz.F
*
*           Rick Romea
*           Jan. 24, 2000      
*
*     Zonal nonlinear advective flux term:  - d(wS)/dz
*     Units :  (SALINITY(ppm) - 0.035) / s
*     MOM2 Grid:  T   
*
*******************************************************************

      SUBROUTINE RR_flux_sz_init(id)
	IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

      CALL ef_set_desc             (id,
     .'-d(wS)/dz advective momentum: flux-form (SALT/s);MOM2 T Grid')
      CALL ef_set_num_args         (id, 3)
      CALL ef_set_axis_inheritance (id, IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok     (id, NO, NO, NO, NO)

      ! Define first argument (U)

      CALL ef_set_arg_name         (id, ARG1, 'U')
      CALL ef_set_arg_desc         (id, ARG1,
     . 'Zonal velocity, on the MOM2 U Grid. ')
      CALL ef_set_arg_unit         (id, ARG1, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG1, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG1, YES, YES, YES, YES)
      CALL ef_set_axis_extend      (id, ARG1, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG1, Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG1, Z_AXIS,0,+1)

      ! Define second argument (W)

      CALL ef_set_arg_name         (id, ARG2, 'W')
      CALL ef_set_arg_desc         (id, ARG2,
     . 'Vertical velocity, at T cell bottom on the MOM2 Grid. ')
      CALL ef_set_arg_unit         (id, ARG2, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG2, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2, NO, NO, NO, YES)
      CALL ef_set_axis_extend      (id, ARG2, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG2, Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG2, Z_AXIS,0,+1)

      ! Define third argument (SALT)

      CALL ef_set_arg_name         (id, ARG3, 'SALT')
      CALL ef_set_arg_desc         (id, ARG3,
     . 'Salinity, on the MOM2 T Grid. ')
      CALL ef_set_arg_unit         (id, ARG3,
     . '(SALINITY(ppt) - 35) /1000')
      CALL ef_set_arg_type         (id, ARG3, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG3, NO, NO,YES,YES)
      CALL ef_set_axis_extend      (id, ARG3, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG3, Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG3, Z_AXIS,0,+1)

      END




      SUBROUTINE RR_flux_sz_compute(id, arg_1, arg_2, arg_3, result)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER        id

      REAL           bad_flag(EF_MAX_ARGS)
      REAL           bad_flag_result
      REAL           arg_1 (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .                      mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL           arg_2 (mem2lox:mem2hix, mem2loy:mem2hiy, 
     .                      mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL           arg_3 (mem3lox:mem3hix, mem3loy:mem3hiy, 
     .                      mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL           result (memreslox:memreshix,memresloy:memreshiy,
     .                       memresloz:memreshiz,memreslot:memreshit)

      INTEGER        res_lo_ss (4)
      INTEGER        res_hi_ss (4)
      INTEGER        res_incr  (4)

      INTEGER        arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER        arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER        arg_incr  (4,EF_MAX_ARGS)

      INTEGER        i,  j,  k,  l
      INTEGER        i2, j2, k2, l2
      INTEGER        i3, j3, k3, l3

      REAL*8         yU(1024)
      REAL*8         xU(1024)
      REAL*8         zW(1024)
      REAL*8         yT(1024)
      REAL*8         xT(1024)

      INTEGER        ilat
      INTEGER        ilon
      INTEGER        iZ

      CHARACTER*16   ax_name(4)
      CHARACTER*16   ax_units(4)
      LOGICAL        backward(4)
      LOGICAL        modulo(4)
      LOGICAL        regular(4)

      REAL           dxt, dyt, dxu, dyu
      REAL           dus, dun, duw, due
      REAL           adv_fb         
      INCLUDE 'rr_parameters.h'

C*********************************************************************
C
c     dzt     = vertical height of "u,v" or "t" grid box (in cm)
c     dyt     = latitudinal height of "t" grid box (in cm)
c     dxt     = longitudinal width of "t" grid box at the equator (cm)
c     dxu     = longitudinal width of "u,v" grid box at the equator (cm) 
c     dyu     = latitudinal height of "u,v" grid box (cm)
C
c     dus     = yu(j) - yt(j)
c     dun     = yt(j+1) - yu(j)
c     duw     = xu(i) - xt(i)
c     due     = xt(i+1) - xu(i)
C
c     yu(j)   = latitude of the jth "u,v" point in degrees 
c     yt(j)   = latitude of the jth "t" point in degrees   
c     xt(i)   = longitude of the ith "t" point in degrees  
c     xu(i)   = longitude of the ith "u,v" point in degrees
C 
C*********************************************************************

      dxt(i) = SNGL (xU(i)   - xU(i-1)) * Longitude_to_cm
      dyt(j) = SNGL (yU(j)   - yU(j-1)) * Latitude_to_cm
      dxu(i) = SNGL (xT(i+1) - xT(i))   * Longitude_to_cm
      dyu(j) = SNGL (yT(j+1) - yT(j))   * Latitude_to_cm
      dus(j) = SNGL (yU(j)   - yT(j))   * Latitude_to_cm
      dun(j) = SNGL (yT(j+1) - yU(j))   * Latitude_to_cm
      duw(i) = SNGL (xU(i)   - xT(i))   * Longitude_to_cm
      due(i) = SNGL (xT(i+1) - xU(i))   * Longitude_to_cm

      adv_fb(i2,j2,k2,l2,i3,j3,k3,l3) =  arg_2(i2,j2,k2,l2)
     .                  * (arg_3(i3,j3,k3,l3) + arg_3(i3,j3,k3+1,l3))

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags      (id, bad_flag,  bad_flag_result)
      CALL ef_get_coordinates    (id, ARG1, X_AXIS, 
     .                            arg_lo_ss(X_AXIS,ARG1),
     .                            arg_hi_ss(X_AXIS,ARG1), xU)
      CALL ef_get_coordinates    (id, ARG1, Y_AXIS, 
     .                            arg_lo_ss(Y_AXIS,ARG1),
     .                            arg_hi_ss(Y_AXIS,ARG1), yU)
      CALL ef_get_coordinates    (id, ARG2, Z_AXIS, 
     .                            arg_lo_ss(Z_AXIS,ARG2),
     .                            arg_hi_ss(Z_AXIS,ARG2), zW)
      CALL ef_get_coordinates    (id, ARG3, X_AXIS, 
     .                            arg_lo_ss(X_AXIS,ARG3),
     .                            arg_hi_ss(X_AXIS,ARG3), xT)
      CALL ef_get_coordinates    (id, ARG3, Y_AXIS, 
     .                            arg_lo_ss(Y_AXIS,ARG3),
     .                            arg_hi_ss(Y_AXIS,ARG3), yT)
      CALL ef_get_axis_info  (id, ARG1, ax_name, ax_units, 
     .                                backward, modulo, regular) 
      IF     ( ax_units(1) .NE. 'deg'       .AND.
     .         ax_units(1) .NE. 'lon'       .AND.
     .         ax_units(1) .NE. 'degrees_E' .AND.
     .         ax_units(1) .NE. 'longitude' .AND.
     .         ax_units(1) .NE. 'Longitude' .AND. 
     .         ax_units(1) .NE. 'LONGITUDE' ) THEN
        WRITE (6,*)'Longitude axis units =', ax_units(1) 
        !CALL ef_bail_out(id,'Longitude axis must be in degrees')
      ENDIF

      IF     ( ax_units(2) .NE. 'deg'       .AND.
     .         ax_units(2) .NE. 'degrees_N' .AND.
     .         ax_units(2) .NE. 'lat'       .AND.
     .         ax_units(2) .NE. 'latitude'  .AND.
     .         ax_units(2) .NE. 'Latitude'  .AND. 
     .         ax_units(2) .NE. 'LATITUDE' ) THEN
        WRITE (6,*)'Latitude axis units =', ax_units(2) 
        !CALL ef_bail_out(id,'Latitude axis must be in degrees')
      ENDIF
      CALL ef_get_axis_info  (id, ARG1, ax_name, ax_units, 
     .                                backward, modulo, regular) 
      IF     ( ax_units(3) .NE. 'm'           .AND.
     .         ax_units(3) .NE. 'meters'  .AND.
     .         ax_units(3) .NE. 'M'           .AND.
     .         ax_units(3) .NE. 'METERS' ) THEN
        WRITE (6,*)'Longitude axis units =', ax_units(1) 
        !CALL ef_bail_out(id,'Z axis must be in meters')
      ENDIF 


      l2 = arg_lo_ss(T_AXIS,ARG2) 
      l3 = arg_lo_ss(T_AXIS,ARG3) 
      DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         ilat = 2  
         j2 = arg_lo_ss(Y_AXIS,ARG2) + 1
         j3 = arg_lo_ss(Y_AXIS,ARG3) + 1
         DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
         
            iLon = 2
            i2 = arg_lo_ss(X_AXIS,ARG2) + 1
            i3 = arg_lo_ss(X_AXIS,ARG3) + 1
            DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

	         iZ = 1
               k2 = arg_lo_ss(Z_AXIS,ARG2)
               k3 = arg_lo_ss(Z_AXIS,ARG3)
               DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

                  IF (arg_2(i2,  j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2,  j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2,  j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_3(i3,  j3,  k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3+1,j3,  k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3-1,j3,  k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3,  j3+1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3+1,j3+1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3-1,j3+1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3,  j3-1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3+1,j3-1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3-1,j3-1,k3,l3) .EQ. bad_flag(ARG3)) THEN
                     result(i,j,k,l) = bad_flag_result
                  ELSE
                     IF (iZ .EQ. 1) THEN
                        result(i,j,k,l) =  
     .                           adv_fb(i2,j2,k2,l2,i3,j3,k3,l3)
     .                             / 2. / (zW(iZ)*Meters_to_cm)       
     .                              * sec_per_month
                     ELSE
                        result(i,j,k,l) = - ( 
     .      	                    adv_fb(i2,j2,k2-1,l2,i3,j3,k3-1,l3)
     .                          - adv_fb(i2,j2,k2,  l2,i3,j3,k3,  l3))
     .                         / 2. / (zW(iZ-1)-zW(iZ))/Meters_to_cm 
     .                            * sec_per_month
                     ENDIF
                  ENDIF

	            iZ = iZ + 1
                  k2 = k2 + arg_incr(Z_AXIS,ARG2)
                  k3 = k3 + arg_incr(Z_AXIS,ARG3)
               ENDDO

               iLon = iLon + 1
               i2 = i2 + arg_incr(X_AXIS,ARG2)
               i3 = i3 + arg_incr(X_AXIS,ARG3)
            ENDDO

            iLat = iLat + 1
            j2 = j2 + arg_incr(Y_AXIS,ARG2)
            j3 = j3 + arg_incr(Y_AXIS,ARG3)
         ENDDO

         l2 = l2 + arg_incr(T_AXIS,ARG2)
         l3 = l3 + arg_incr(T_AXIS,ARG3)
      ENDDO               
      END

	SUBROUTINE TRANSLATE_LAT_LONG(string, idim, answer, formatted, status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* convert an ascii representation of a latitude or longitude value into 
* a floating point value using special format rules

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 4/11/86
* revision 0.1 - 3/14/89 - return "formatted" flag
* V300  9/93 - insist that "N", "S", "E", "W" are the LAST character
* V420 (IBM/AIX port of V411): 10/5/95 - buffer "READ(var,*"
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

* possible formats:
*   x coord:  #  or #E  or  #W  for East  or West,  respectively
*   y coord:  #  or #S  or  #N  for South or North, respectively
*   z coord:  #
*   t coord:  #  or dd-mmm-yyyy@hh-mm-ss  eg 14-JAN-1986@11:15

	include 'errmsg.parm'
	include 'ferret.parm'

	CHARACTER*(*)	string
	LOGICAL		n_given, s_given, e_given, w_given, formatted
	INTEGER		n_pos, s_pos, e_pos, w_pos, slen, status, idim
	REAL*8		answer

* local declarations
	CHARACTER	buff*32		! 10/95

* initialize
	slen = LEN ( string )
	n_given = string(slen:slen).EQ.'N' .OR. string(slen:slen).EQ.'n'
	s_given = string(slen:slen).EQ.'S' .OR. string(slen:slen).EQ.'s'
	e_given = string(slen:slen).EQ.'E' .OR. string(slen:slen).EQ.'e'
	w_given = string(slen:slen).EQ.'W' .OR. string(slen:slen).EQ.'w'
	formatted = n_given .OR. s_given .OR. e_given .OR. w_given

* how much of the string is numeric ?
	IF ( formatted ) slen = slen - 1

* decode the value
	buff =  string(1:slen)		! 10/95
	READ ( buff, * , ERR=5000 ) answer

* make corrections for latitude/longitude notation
	IF     ( n_given ) THEN

* latN - no change
	   IF ( idim .NE. y_dim ) GOTO 5000
	ELSEIF ( s_given ) THEN

* latS - make negative
	   IF ( idim .NE. y_dim ) GOTO 5000
	   answer = -answer
	ELSEIF ( e_given ) THEN

* longE - no change
	   IF ( idim .NE. x_dim ) GOTO 5000
	ELSEIF ( w_given ) THEN

* longW - convert	
	   IF ( idim .NE. x_dim ) GOTO 5000
	   answer = 360. - answer
	ENDIF

	status = ferr_ok
	RETURN

* error exit
 5000	CALL ERRMSG	( ferr_syntax, status, string, *5010 )
 5010	RETURN
	END

	SUBROUTINE PURGE_ALL_UVARS_SUB( uvar)
	
* eliminate all stored user variables from memory
* pulled out of purge_all_uvars

* 3/2019  Ansley Manke

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xvariables.cmn'

	INTEGER uvar, i
	
	CALL PURGE_USER_VAR( uvar )

* back to initial defaults (see INIT_UVAR)
* (eliminate all grid information that may have been rendered incorrect)
	CALL DEALLO_UVAR_GRIDS(uvar)

* must reset ALL of the state variables as set up in INIT_UVAR
* by default assume the definition requires an external data set specification
        uvar_need_dset( uvar ) = .TRUE.

* by default assume that all limits are irrelevant
        DO i = 1, nferdims
	   uvar_given(i,uvar) = uvlim_irrelevant
        ENDDO

	RETURN
	END

	LOGICAL FUNCTION CD_GET_ATTRIB ( cdfid, varid, attrib,
     .                                   do_warn, vname,
     .                                   string, attlen, slen )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* get an attribute string from a netCDF file if the attribute exists and
* is of the right data type
* the netCDF file is assumed to be open

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 2/92
*              - 8/92: fixed garbled error message text
* V420 - 11/95 *sh* - only issue warning if non-blanks are truncated
*		    - increase reading buffer size to 256
* V581 -  5/05 *acm - increase reading buffer size to 1024.  Newer netCDF 
*                     libraries have apparently lifted the restriction.
*                     This lets us increase the size of e.g. the title attribute.
* V602 *acm* make sure lena=length of attr name is defined before writing warning
* V62  6/08 *acm* Increase reading buffer size to 2048 and check the status flag when
*            reading the attribute values.
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* argument definitions:
*	cdfid	 - netCDF id number for already opened CDF file
*       varid    - variable id in netCDF file
*       attrib   - attribute to search for
*	do_warn	 - logical flag to issue warning if invalid attribute
*                - warnings are never issued if attribute doesn't exits
*       vname    - name of variable owning attribute (used in error msgs)
*       string   - array into which to return result
*       attlen   - returned length of return string
*       slen     - maximum allowable return string

* argument declarations
      LOGICAL       do_warn
      INTEGER	    cdfid, varid, attlen, slen
      CHARACTER*(*) attrib, vname, string

      include 'netcdf.inc'
      include 'xio.cmn_text'

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

* internal variable declarations:
      LOGICAL too_long
      INTEGER TM_LENSTR1, lena, lenb, attype, cdfstat, i
      CHARACTER*2048 buff

      INTEGER tt  ! nice short name
      EQUIVALENCE (tt,lunit_errors)

* initialize
       string(:slen) = ' '
       too_long = .FALSE.

* inquire about the attribute by name
! 11/95 note:  NCAINQ appears not to return a meaningful attlen -- always 256
      lena = TM_LENSTR1( attrib )
      cdfstat = NF_INQ_ATT (cdfid, varid, attrib(:lena), attype, attlen )
      IF ( cdfstat .NE. NF_NOERR ) THEN
         attlen = 0
         CD_GET_ATTRIB = .FALSE.
         RETURN  ! doesn't exist
      ENDIF

      IF ( attype.NE.NF_CHAR .AND. attype.NE.NF_BYTE ) THEN
         buff = 'attribute must be a string'
         CD_GET_ATTRIB = .FALSE.
         GOTO 5000
      ELSE
         cdfstat = NF_GET_ATT_TEXT (cdfid, varid, attrib, buff)
	 IF (cdfstat .NE. NF_NOERR ) THEN
            CD_GET_ATTRIB = .FALSE.
            GOTO 5000
         ELSE
* ... f77 vs c bug:
* ... replace trailing nulls with blanks for FORTRAN strings
            DO 100 i = attlen, 1, -1
               IF ( ICHAR(buff(i:i)) .EQ. 0 ) THEN
               buff(i:i) = ' '
               ENDIF
 100        CONTINUE
            CD_GET_ATTRIB = .TRUE.
            string = buff
            IF ( TM_LENSTR1(buff(:attlen)) .GT. slen ) THEN
               too_long = .TRUE.
               buff = 'attribute truncated'	! warning msg
               GOTO 5000
            ENDIF

	 ENDIF
      ENDIF

      RETURN

* warning exits
 5000 lenb = TM_LENSTR1( buff )
      lena = TM_LENSTR1( attrib )
      buff = buff(:lenb)//': "'//attrib(:lena)//
     .             '" in netCDF variable: '//vname
      lenb = TM_LENSTR1( buff )
      IF ( do_warn ) CALL TM_NOTE( buff(:lenb), tt )
      IF ( do_warn.AND.too_long ) WRITE (tt,'(1X,A,I4)')
     .                              'Maximum characters: ',slen
      RETURN

      END

	subroutine fakes_ppl
        entry	xeq_plot
        stop	'xeq_plot has been removed for debugging'
        entry	xeq_ppl
        stop	'xeq_ppl has been removed for debugging'
        entry	xeq_contour
        stop    'xeq_contour has been removed for debugging'
        entry	xeq_vector
        stop    'xeq_vector has been removed for debugging'
        entry	xeq_shade
        stop    'xeq_shade has been removed for debugging'
        entry	xeq_wire
        stop    'xeq_wire has been removed for debugging'
        entry	set_window
        stop    'set_window has been removed for debugging'
        entry	set_viewport
        stop    'set_viewport has been removed for debugging'
        entry	cancel_window
        stop    'cancel_window has been removed for debugging'
        entry	start_pplus
        stop    'start_pplus has been removed for debugging'
        entry ck_gks_active
        stop  'ck_gks_active has been removed for debugging'
        entry viewport_number
        stop  'viewport_number has been removed for debugging'
        entry send_pltype
        stop  'send_pltype has been removed for debugging'
        entry gdsg
        stop  'gdsg has been removed for debugging'
        entry clsppl
        stop  'clsppl has been removed for debugging'
        entry disp_reset
        stop  'disp_reset has been removed for debugging'
        entry pplcmd
        stop  'pplcmd has been removed for debugging'
        entry gks_device_number
        stop  'gks_device_number has been removed for debugging'
        entry meta_device_number
        stop  'meta_device_number has been removed for debugging'
        entry compound_key
        stop  'compound_key has been removed for debugging'
        entry pos_lab
        stop  'pos_lab has been removed for debugging'
        end

	SUBROUTINE CDF_LIST_DEFAULT_ATTS (dset, varid, varcode,  
     .          cx, cdfid, outtype, all_outflag, itsa_uvar, 
     .          got_title, output_title, got_history, output_history, 
     .          got_units, output_units, status )
     

* 2/2019  Ansley Manke
* NOAA/PMEL, Seattle, WA - Science Data Integration Group

* On writing to netCDF, write out the attributes that are standard with
* all variables:
*
* - default missing/_FillValues variables -- may be rewritten later 
*    based on what's in the source dataset
* - variable title
* - long_name_mod with subset information
* - variable units
* - variable history, dataset of origin

        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'

	LOGICAL got_title, output_title, got_history, output_history, 
     .          got_units, output_units, itsa_uvar
	INTEGER dset, varid, outtype, cx, cdfid, all_outflag, status
	CHARACTER*(*) varcode


	LOGICAL NC_GET_ATTRIB_DP, NC_GET_ATTRIB, 
     .          got_it, full_precision, get_ds, need_doc
	INTEGER TM_LENSTR1, STR_SAME, 
     .          var, i, attoutflag, no_fill_flag, no_missing_flag, attid, 
     .          attype, attlen, lbuff, idim, maxlen, slen, dset_num
	REAL bad, vals(100), miss_in, fill_in
	CHARACTER VAR_TITLE*140, VAR_TITLE_MOD*140, VAR_UNITS*64, CX_DIM_STR*48, 
     .          c1*1, attname*1024, buff*1024, buff1*1024, buff2*1024

	full_precision = .TRUE.
	maxlen = 1024

	var = 0
	IF (cx .NE. cx_none) var = cx_variable(cx)

	dset_num = dset
	IF (cx .NE. cx_none) dset_num = cx_data_set(cx)

	status = ferr_ok

* If its a uvar or expression, write missing_value and _FillValue
* attributes with default Ferret values.

	IF (varid .LE. 0) THEN

	   attname = 'missing_value'
	   vals(1) = bad_val4
	   attlen = 1
	   attype = outtype
	   CALL CD_WRITE_ATTVAL_DP(cdfid, varcode,
     .                          attname, vals, attlen, attype, status )
	   attname = '_FillValue'
	   vals(1) = bad_val4
	   attlen = 1
	   attype = outtype
	   CALL CD_WRITE_ATTVAL_DP(cdfid, varcode,
     .                          attname, vals, attlen, attype, status )
	ENDIF

* variable title
* May already have this from Ferret variables from attribute structure, or if there
* is no long_name attribute, get it by means of VAR_TITLE.
	
	IF (.NOT. got_title) THEN
	   buff = ' '
	   IF (cx .NE. cx_none) buff = VAR_TITLE( cx )
	   lbuff = TM_LENSTR1( buff )

	   IF ( buff .NE. ' ' .AND. all_outflag .NE. 0 .AND.
     .                output_title ) THEN
	      CALL CD_WRITE_ATTRIB(cdfid, varcode, 'long_name',
     .                              buff(:lbuff), .FALSE., status )
	      IF ( status .NE. ferr_ok ) GOTO 5100
	      got_title = .TRUE.
	   ENDIF

	ENDIF

* modifier to variable title
* ..."compressing" transforms and limits not given in definitions
	buff = ' '
	lbuff = 1
	IF (cx .NE. cx_none) THEN
	   DO idim = 1, nferdims
	      need_doc =  cx_trans(idim,cx) .GT. trans_compress_code
	      IF ( itsa_uvar ) need_doc = need_doc
     .                    .OR. uvar_given(idim,var) .GT. uvlim_needed
	      IF ( need_doc ) THEN
	         IF ( lbuff .GT. 1 ) THEN      ! append a comma ?
	            buff = buff(:lbuff)//', '
	            lbuff = MIN( 140, lbuff+2)
	         ENDIF
	         buff = buff(:lbuff)//CX_DIM_STR(idim, cx, ':',full_precision,i)
	         lbuff = TM_LENSTR1( buff )
	      ENDIF
	   ENDDO

* ...other variable modifiers
	   c1 = VAR_TITLE_MOD( cx )
	   IF ( c1 .NE. ' ' ) THEN
	      IF ( lbuff .GT. 1 ) THEN
	         buff = buff(:lbuff)//', '
	         lbuff = MIN( 140, lbuff+2)
	      ENDIF
	      buff = buff(:lbuff)//VAR_TITLE_MOD( cx )
	      lbuff = TM_LENSTR1( buff )
	   ENDIF
	ENDIF

* ... write it to the file
	IF ( lbuff .GE. 2 .AND. all_outflag .NE. 0) THEN

* ..... unless the user has created a long_name_mod attribute, or asked that writing
*       it be turned off. See if long_name_mod attribute has been created.

	   attoutflag = 1
	   slen = TM_LENSTR1(varcode)
	   buff2 = varcode(1:slen)//'.long_name_mod'
	   IF (varid .GT. 0) THEN
	      CALL BREAK_VARATTNAME (buff2, dset, 
     .               buff1, attname, varid, .FALSE., status)

	      IF (status .EQ. ferr_ok) THEN

	         CALL CD_GET_VAR_ATT_ID (dset, varid, 'long_name_mod', attid, status)
	         IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, 
     .               attname, attype, attlen, attoutflag, status )

	         IF (attoutflag .EQ. 1) got_it = NC_GET_ATTRIB 
     .                ( dset, varid, attname, .FALSE., varcode, 
     .                  maxlen, attlen, attoutflag, buff(2:), vals)
	         lbuff = TM_LENSTR1( buff )
	      ENDIF
	   ENDIF
	   status = ferr_ok

	   IF (all_outflag .NE. 0 .AND. attoutflag .NE. 0)
     .         CALL CD_WRITE_ATTRIB(cdfid, varcode, 'long_name_mod',  
     .                buff(2:lbuff), .FALSE., status )

	   IF ( status .NE. ferr_ok ) GOTO 5100
	ENDIF

* units
	IF (.NOT.got_units .AND. all_outflag.NE.0 .AND.  output_units ) THEN
	   buff = ' '
	   IF (cx .NE. cx_none) buff = VAR_UNITS( cx )
	   lbuff = TM_LENSTR1( buff )

	   IF ( buff .NE. ' ' .AND. all_outflag .NE. 0 .AND. output_units ) THEN
	      CALL CD_WRITE_ATTRIB(cdfid, varcode, 'units',
     .                              buff(:lbuff), .FALSE., status )
	      IF ( status .NE. ferr_ok ) GOTO 5100
	   ENDIF
	ENDIF

* data set of origin
	IF ( dset .NE. pdset_irrelevant .AND. dset.NE.pdset_uvars) THEN
       
* ..... unless the user has created a history attribute, or asked that writing
*       it be turned off. See if there is a history attribute.
*       If the history attribute is just "from dsetname", or is not present,
*       then write the dataset and its path or URL.

	   attoutflag = 1
	   IF (varid .GT. 0) THEN
	      slen = TM_LENSTR1(varcode)
	      buff = varcode(1:slen)//'.history'
	      CALL BREAK_VARATTNAME (buff, dset, buff1, attname,
     .                   varid, .FALSE., status)

	      IF (status .EQ. ferr_ok) THEN
	         CALL CD_GET_VAR_ATT_ID (dset, varid, 'history', attid, status)
	         IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, 
     .                     attname, attype, attlen, attoutflag, status )

	         IF (attoutflag .EQ. 1) got_it = NC_GET_ATTRIB (
     .		  	     dset, varid, attname, .FALSE., varcode,
     .		  	     maxlen, attlen, attoutflag, buff, vals)
	         lbuff = TM_LENSTR1( buff )
	         IF (buff .EQ. ' ') THEN
	            buff = 'From '
	            CALL GET_DSET_NAME( dset, buff(6:), lbuff )
	            IF (buff(6:7) .EQ. './') 
     .                 CALL GET_SHORT_DSET_NAME( dset, buff(6:), lbuff )
	            lbuff = TM_LENSTR1( buff )
	         ELSE
	            get_ds = .FALSE.
	            IF (STR_SAME(buff(1:5), 'From ') .EQ. 0) THEN
	               CALL GET_SHORT_DSET_NAME( dset, buff1, lbuff )
	               IF (STR_SAME(buff(6:attlen), buff1) .EQ. 0) get_ds = .TRUE.
	            ENDIF
	         ENDIF
	      ENDIF

	      IF (status .NE. ferr_ok .OR. get_ds) THEN 
	         buff = 'From '
	         CALL GET_DSET_NAME( dset, buff(6:), lbuff )
	         IF (buff(6:7) .EQ. './') 
     .                 CALL GET_SHORT_DSET_NAME( dset, buff(6:), lbuff )
	         lbuff = TM_LENSTR1( buff )
	      ENDIF
	   
	   ELSE
	      buff = 'From '
	      CALL GET_DSET_NAME( dset_num, buff(6:), lbuff)
	      IF (buff(6:7) .EQ. './') CALL GET_SHORT_DSET_NAME
     .                 ( dset_num, buff(6:), lbuff )
	      lbuff = TM_LENSTR1( buff )
	   ENDIF ! varid .gt. 0

	   status = ferr_ok

	   IF (all_outflag .NE. 0 .AND. attoutflag .NE. 0) THEN
	      lbuff = TM_LENSTR1( buff )
	      CALL CD_WRITE_ATTRIB(cdfid, varcode, 'history', 
     .                              buff(:lbuff), .FALSE., status )
	   ENDIF
	   IF ( status .NE. ferr_ok ) GOTO 5100

	ELSEIF ( dset_num .NE. pdset_irrelevant .AND.
     .           dset_num .NE. pdset_uvars) THEN

* Write history attribute containing the data set of origin for user variable, 
* if the user has not created a history attribute for the variable.

	   IF (.NOT.got_history .AND. all_outflag.NE.0 .AND. 
     .         output_history ) THEN

	      attoutflag = 1
	      buff = 'From '
	      CALL GET_DSET_NAME(dset_num, buff(6:), lbuff)
	      IF (buff(6:7) .EQ. './') CALL GET_SHORT_DSET_NAME
     .                 ( dset_num, buff(6:), lbuff )
	      lbuff = TM_LENSTR1( buff )
	      status = ferr_ok

	      IF (all_outflag .NE. 0 .AND. attoutflag .NE. 0)
     .                 CALL CD_WRITE_ATTRIB(cdfid, varcode, 'history', 
     .                              buff(:lbuff), .FALSE., status )
	      IF ( status .NE. ferr_ok ) GOTO 5100
	   ENDIF
	ENDIF


 5100	RETURN	
	END

	SUBROUTINE MERGE_CONTEXT( its_gc, iarg, dflt_cx,
     .				  mrg_cx, com_cx, com_str, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* combine new space/time/data_set/variable/grid context information into a 
* single context checking for consistency 
* (the merged grid is determined in advance by IS_UVAR_GRID)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  6/20/89 - complete re-write
*	  4/2/90 - beef-up error message for incompatible axis lengths
* Unix/RISC port - 1/91 - cant use "//" with CHAR*(*) variable
*       10/27/92 - "documentation merge" option added
* V450: 1/97	 - changes to accomodate grid changing functions.
*		   MERGE_CONTEXT needs to know the argument number. Use this
*		   to determine the nature of the context merging.
* V533: *sh* 6/01 - merge data types (removed to MERGIFY_CX)
*		  - allow longer char buffer for error message to prevent
*			crash in pathological cases
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'grid_chg_fcns.parm'
	include	'xcontext.cmn'
	include	'xtext_info.cmn'
	include	'xfr_grid.cmn'
	include 'xrisc.cmn'

* calling argument declarations
	LOGICAL		its_gc
	INTEGER		iarg, dflt_cx, mrg_cx, com_cx, status
	CHARACTER*(*)	com_str

* local variable declarations
	LOGICAL		ss_save
	INTEGER		CGRID_AXIS, CX_DIM_LEN, WHICH_GCFCN,
     .			idim, mrg_ax, mrg_len, com_ax, com_len, 
     .			choice(4,5), i, icom, imrg, uvar,
     .			com_str_slen, mrg_str_slen,
     .			com_int_slen, mrg_int_slen, gcfcn,
     .			axis_source(nferdims), lo_off(nferdims),  
     .			hi_off(nferdims), action(nferdims)
	CHARACTER	CX_DIM_STR*24, LEFINT*8, com_lims*24, mrg_lims*24,
     .			com_int*8, mrg_int*8

* local parameter declarations:
	LOGICAL         no_decims
	INTEGER		TAX,   ERR,   BUG,   NA
	PARAMETER     ( TAX=1, ERR=2, BUG=3, NA=4,
     .			no_decims = .FALSE. )

* procedure:

* A major question to answer in determining a merged context is: Where does
* the context depend on the default region?  For example, TEMP[K=5] + TEMP[K=1]
* requires no additional Z axis input and no Z axis labelling is needed (since
* the information is part of the definition).  This non-dependence question
* must be resolved AT THE OUTSET or memory resident data cannot be located
* (cannot search memory without a fully specified context to look for).
*
* To address this question each context axis has the logical cx_given.
* This flag tells if the coordinates for that axis were explicitly modified
* in the most recent context level (e.g. TEMP[K=4] explicitly modifies the
* K/Z axis).

* Conformability of component dimensions must also be addressed.  An axis span
* of 1 can be combined with anything (e.g. TEMP[K=1] + TEMP) but lengths
* greater than 1 must match (e.g. TEMP[I=100:105] + TEMP[I=100:106] is illegal).

* When multiple component have differing underlying axis definitions
* another ambiguity must be resolved.
* (e.g. the vars. U and W are on staggered Z axes in many models so what is the
* Z axis of the expression U+W ?  How about U+W[K=1] ? )

* Ambiguities and conflicts are resolved by arbitrarily choosing:
*	1) the region from the first component with region IMPLICITLY defined
*	      ... or failing that ...
*	2) the region fom the first component with explicit region >1
*	      ... or failing that ...
*	3) the region from the first component with any explicit region

* Expressions which are given on the command line present a special case.
* e.g. LIST U[Z=10] should have the title of U and a depth label of 10 but
*      LIST VNEW after DEFINE VAR VNEW=U[Z=10] should have a title of VNEW
*      and no Z depth label.
* Thus on-command-line expressions are sent to this routine only when they
* have multiple component variables.

* The following table summarizes the logic of merging a new component context
* (com_cx) into a partially merged context (mrg_cx):
* "cx_given" on a component axis means that the location was given with the
*	     component (e.g. U[Z=0]) so it doesn't require outside information
* "cx_given" on a the merged context means that all components had cx_given

*	            1           2  COMPONENT    3             4
*		      cx_given		         .NOT.cx_given
*  size:            1          >1	        1	       >1
*             -----------------------------------------------------------------
*1          1 |   no action   | transfer axis | transfer axis | transfer axis |
* cx_given    -----------------------------------------------------------------
*2         >1 |   no action   |  no action    |    error      | transfer axis |
*	      -----------------------------------------------------------------
*3          1 |   no action   |    error      |  no action    | transf ax *** |
* NOT.cx_gvn  -----------------------------------------------------------------
*4         >1 |   no action   |  no action    |  no actn  *** |   no action   |
*             -----------------------------------------------------------------
*5 normal     | transfer axis | transfer axis | transfer axis | transfer axis |
*             -----------------------------------------------------------------

* error : cannot label expressions like yes? CONTOUR/K=1 U[K=1:3] - U
*	   since the first component requires a labeled axis and the
*	   second requires a single point to be named
* "***"	:  situation can occur only in cases like
*		DEFINE VAR TAVE = TEMP[K=@AVE]
*		DEFINE VAR DIFF = TEMP - TAVE
* ... so that both TEMP and TAVE have limits .NOT.given but one has length 1
*	and the other has length possible .GT. 1

	DATA (choice(i,1),i=1,4) / NA,  TAX, TAX, TAX /,
     .	     (choice(i,2),i=1,4) / NA,   NA, ERR, TAX /,
     .	     (choice(i,3),i=1,4) / NA,  ERR,  NA, TAX /,
     .	     (choice(i,4),i=1,4) / NA,   NA,  NA,  NA /
     .	     (choice(i,5),i=1,4) / TAX, TAX, TAX, TAX /

**************************************************************************
* get the variable under consideration from the merged context
	uvar = cx_variable( mrg_cx )

* merge data types  (removed to MERGIFY_CX -- uvars via uvar_data_type)
!	IF (cx_type(mrg_cx) .EQ. ptype_unknown) THEN
!	   cx_type(mrg_cx) = cx_type(com_cx)
!	ELSEIF( cx_type(mrg_cx) .NE. cx_type(com_cx) ) THEN
!! temporary hack until function return types are implemented
!	   cx_type(mrg_cx) = ptype_float
!	ENDIF

* is this a grid changing variable? (1/97)
	IF (its_gc) THEN
	   gcfcn = WHICH_GCFCN(uvar)
	   CALL GCF_GET_AXIS_SRCS(gcfcn, iarg, axis_source)
	   CALL GCF_GET_ARG_LIMS (gcfcn, iarg, com_cx, cx_grid(mrg_cx),
     .				 lo_off,  hi_off, action, status)
	   IF ( status .NE. ferr_ok ) GOTO 5000
	ENDIF

* initialize fixed length string for RISC
	risc_buff = com_str
	len_rbuff = MIN( size_rbuff, LEN(com_str) )

* loop through the axes
	DO 500 idim = 1,nferdims

* argument of grid-changing function? (1/97)
*
*     If we should ignore the axis:     don't merge
*     Else if we should impose an axis 
*        If (pset_to_unspec):           don't merge
*        Else (ppass_along):            imposed axis matches arg axis --> merge
*     Else (we should merge an axis)
*        If we have offsets:            special merge
*        Else:                          all OK --> merge
*     Endif

           IF (its_gc ) THEN

              IF (axis_source(idim).EQ.pgc_ignore_axis) THEN

                 GOTO 500

              ELSEIF (axis_source(idim).EQ.pgc_impose_axis) THEN

                 IF (action(idim) .EQ. pset_to_unspec) THEN
*     ... IS_DO_GC_FUNC will fill in the result limits on the imposed axes
                    GOTO 500    ! leave it in its initialized (vacant) condition
                 ELSE
*     ... This is the special case of an imposed axis that matches the argument ax
                    CONTINUE
                 ENDIF

              ELSE !(axis_source(idim) .EQ. pgc_merge_axis)

                 IF  (lo_off(idim).NE.0 .OR. hi_off(idim).NE.0) THEN
                    CALL MERGE_AXIS_WITH_OFFSETS(dflt_cx, mrg_cx, 
     .                   com_cx, idim, lo_off, hi_off)
                    GOTO 500
                 ELSE
                    CONTINUE
                 ENDIF

              ENDIF	 
              
           ENDIF


* ignore axes for which region isn't known (e.g. X axis of pseudo-variable "Y")
	   IF ( cx_lo_ww(idim,com_cx) .EQ. unspecified_val8 ) GOTO 500

*********************************************************************
* "documentation merge" option - a patch: 10/27/92
* For special case where both the component and the merged context represent
* idle, redundant documentation  e.g. TEMP[L=1:5@AVE] + TEMP[L=2:3@AVE]
* If the component context is the same as the merged then save it;
* if they differ then throw it away
           IF (cx_given(idim,com_cx)
     .           .AND. cx_lo_ss(com_cx,idim) .EQ. unspecified_int4
     .    .AND.cx_given(idim,mrg_cx)
     .           .AND. cx_lo_ss(mrg_cx,idim) .EQ. unspecified_int4) THEN
              IF ( cx_lo_ww(idim,com_cx).NE.cx_lo_ww(idim,mrg_cx)
     .       .OR.  cx_hi_ww(idim,com_cx).NE.cx_hi_ww(idim,mrg_cx) ) THEN
                 cx_lo_ww(idim,com_cx)= unspecified_val8
                 cx_hi_ww(idim,com_cx)= unspecified_val8
              ENDIF
           ENDIF
*********************************************************************

* get axes and lengths of data along them
	   mrg_ax  = CGRID_AXIS( idim, mrg_cx )
	   com_ax  = CGRID_AXIS( idim, com_cx )
	   mrg_len = CX_DIM_LEN( idim, mrg_cx )
	   com_len = CX_DIM_LEN( idim, com_cx )

* PRE-TEST FOR ERROR CONDITIONS
* ... non-conformable lengths
	   IF ( mrg_len .NE. com_len
     .    .AND. mrg_len.NE.1 .AND. com_len.NE.1 ) GOTO 5010

* ignore data from non-matching axes (warning was given during grid merge)
	   IF ( com_ax .NE. mrg_ax  ) GOTO 500
	   IF ( mrg_ax .EQ. mnormal ) GOTO 9000

* MERGE NEW COMPONENT WITH PREVIOUS DIMENSIONS
	   IF ( cx_given(idim,com_cx) ) THEN
	      icom = 1
	   ELSE
	      icom = 3
	   ENDIF
	   IF ( cx_given(idim,mrg_cx) ) THEN
	      imrg = 1
	   ELSE
	      imrg = 3
	   ENDIF
	   IF ( com_len .GT. 1 ) icom = icom + 1
	   IF ( mrg_len .GT. 1 ) imrg = imrg + 1
	   IF ( cx_lo_ss(mrg_cx,idim) .EQ. unspecified_int4 ) imrg = 5

* merge new component context with previous stuff
*	          TAX   ERR   BUG   NA
	   GOTO ( 100, 5020, 9000, 400 ) choice(icom,imrg)

* transfer axis (component transforms don't belong to the merged context)
 100	   CALL TRANSFER_AXIS( idim, com_cx, mrg_cx )
	   cx_trans    (idim, mrg_cx ) = trans_no_transform
	   cx_trans_arg(idim, mrg_cx ) = bad_val4

* "given" is false if any component doesn't have an explicit region
 400	   cx_given(idim,mrg_cx) = cx_given(idim,mrg_cx)
     .			     .AND. cx_given(idim,com_cx)

 500	CONTINUE

* successfully merged
	status = ferr_ok
	RETURN

* error exit
 5000	RETURN
* ... message to include "expr has N points (L=lo:hi)"
 5010	ss_save = cx_by_ss(idim,com_cx)
	cx_by_ss(idim,com_cx) = .TRUE.
	com_lims = CX_DIM_STR( idim,com_cx,':',no_decims,com_str_slen )
	cx_by_ss(idim,com_cx) = ss_save
	ss_save = cx_by_ss(idim,mrg_cx)
	cx_by_ss(idim,mrg_cx) = .TRUE.
	mrg_lims = CX_DIM_STR( idim,mrg_cx,':',no_decims,mrg_str_slen )
	cx_by_ss(idim,mrg_cx) = ss_save
	com_int = LEFINT(com_len,com_int_slen)
	mrg_int = LEFINT(mrg_len,mrg_int_slen)
	CALL ERRMSG( ferr_inconsist_plane, status,
     .		ww_dim_name(idim)//' axis'//pCR//
     .		risc_buff(:len_rbuff)//
     .		' has '//com_int(:com_int_slen)//' points ('//
     .					com_lims(:com_str_slen)//')'//pCR//
     .		'expression has '//mrg_int(:mrg_int_slen)//' points ('//
     .					mrg_lims(:mrg_str_slen)//')', *5000 )
 5020	CALL ERRMSG( ferr_inconsist_plane+ghelp_cue, status,
     .		'can''t label '//ww_dim_name(idim)//' axis of '//
     .		risc_buff(:len_rbuff), *5000 )
 9000	CALL ERRMSG( ferr_internal, status, 'merge_cx', *5000 )
	END

*
* transpose_xt.F
*
* 
* 
*
* This function sets the second argument to be equal
* to the first one.
*


*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE transpose_xt_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     . 'transposes X and T axes of given variable' )

      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance(id, ABSTRACT, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, ABSTRACT)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'VAR')
      CALL ef_set_arg_desc(id, arg, 'variable transposed in X and T')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES,YES)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


      SUBROUTINE transpose_xt_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      INTEGER my_lo_x, my_hi_x, my_lo_t, my_hi_t,nx,nt
      CHARACTER*100 errtxt

      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

*
*     Use utility functions to get context information about the arguments.
*     Set the abstract X and Y axes.
*

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nx = arg_hi_ss(X_AXIS, ARG1) - arg_lo_ss(X_AXIS, ARG1) + 1
      nt = arg_hi_ss(T_AXIS, ARG1) - arg_lo_ss(T_AXIS, ARG1) + 1
      
*     The below has the effect of translating any sub-matrix so that
*     the indices will always begin at 1

      my_lo_x = 1
      my_hi_x = nx
      my_lo_t = 1
      my_hi_t = nt



      CALL ef_set_axis_limits(id, X_AXIS, my_lo_t, my_hi_t)
      CALL ef_set_axis_limits(id, T_AXIS, my_lo_x, my_hi_x)


*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 

 999   CONTINUE

       CALL EF_BAIL_OUT(id, errtxt)

      END




*
* In this subroutine we compute the result
*
      SUBROUTINE transpose_xt_compute(id, arg_1, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

	  INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1
      CHARACTER*100 errtxt

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)


* check to make sure both axis have points to transpose
      IF ((arg_lo_ss(T_AXIS, ARG1) .EQ. ef_unspecified_int4) .OR. 
     .     (arg_hi_ss(T_AXIS, ARG1) .EQ. ef_unspecified_int4)) THEN
         write(errtxt,*) 'T axis cannot be a normal axis'
         GOTO 999
      ELSEIF  ((arg_lo_ss(X_AXIS, ARG1) .EQ. ef_unspecified_int4) .OR. 
     .        (arg_hi_ss(X_AXIS, ARG1) .EQ. ef_unspecified_int4)) THEN
         write(errtxt,*) 'X axis cannot be a normal axis'
         GOTO 999
      ENDIF

      k1 = arg_lo_ss(Z_AXIS, ARG1)
      DO 400 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
         j1 = arg_lo_ss(Y_AXIS, ARG1)
         DO 300 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            i1 = arg_lo_ss(X_AXIS, ARG1)
            DO 200 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS) 
                l1 = arg_lo_ss(T_AXIS, ARG1)
                DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS) 
                   IF (arg_1(i1,j1,k1,l1) .ne. bad_flag(ARG1)) THEN
                      result(i,j,k,l) = arg_1(i1,j1,k1,l1)
                   ELSE
                      result(i,j,k,l) = bad_flag_result
                   ENDIF
                   l1 = l1 + arg_incr(T_AXIS, ARG1)
 100            CONTINUE
                i1 = i1 + arg_incr(X_AXIS, ARG1)
 200         CONTINUE
             j1 = j1 + arg_incr(Y_AXIS, ARG1)
 300      CONTINUE
          k1 = k1 + arg_incr(Z_AXIS, ARG1)
 400   CONTINUE
       RETURN 
       
 999   CONTINUE

       CALL EF_BAIL_OUT(id, errtxt)
      
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

      SUBROUTINE XAXIS2(XLO,XHI,XUNIT,LABEL,IFORMT,IAXIS,
     * XFACT,Y,YFACT,CSIZE,yacross,vgrat,vcolor,vline,color0)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)xaxis2.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 

* *acm* - 6/01   changes to allow plot qualifiers to set log axes,
*                inverse log axes and log depth axes.
*acm* - 8/16   ticket 1787: restore pen 0 correctly after graticule


	CHARACTER XLAB*20,IFORMT*(*),XFRMT*12
	COMMON/TICS/TSMX,TLX,TSMY,TLY,IX,IY
	COMMON/AXLWID/XWID,YWID


* Parameters for drawing tics across plot

        REAL yacross
        REAL dash1_1, dash1_2, dash1_3, dash1_4
        REAL dash2_1, dash2_2, dash2_3, dash2_4 
        REAL vgrat(4,2)        ! line type: 0=tics only, <0=line, >0=dash lengths 
        REAL xt
        INTEGER vcolor(*)      ! pen number for graticule lines
	INTEGER color0	       ! pen number to restore 
        LOGICAL vline          ! If true, do the lines across.
        LOGICAL solid1, solid2 ! solid lines across at tics
        LOGICAL dashed1, dashed2 ! dashed lines across at tics

        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'lines_inc.decl'
        include 'LINES.INC'
        INCLUDE 'pen_inc.decl'  ! with IPEN(1)
        INCLUDE 'PEN.INC'
        
C
C     THIS ROUTINE PLOTS SEVERAL TYPES OF BASE 10 LOG XAXIS.
C         X,YFACT,XFACT HAVE THEIR USUAL MEANINGS.
C         IF CSIZE > 0 THE LABELS HAVE THAT HEIGHT.
C         IF CSIZE < 0 THE LABELS HAVE HEIGHT -CSIZE AND HAVE
C             NEGATIVE THEIR TRUE VALUE.
C         XLO AND XHI ARE THE LOGS OF YOUR XLO AND XHI IN USER UNITS.
C         XUNIT IS ALSO THE LOG OF WHAT IT IS IN USER UNITS.
C         LABEL = -1 FOR LABELING  BELOW OF YOUR X AXIS.
C         LABEL = +1 FOR LABELING ABOVE OF YOUR X AXIS.
C         LABEL =  0 FOR NO LABELS.
C         IFORMT = TO BE FILLED IN LATER.
C
C         IAXIS = STYLE OF AXIS.
C               = 0 FOR NO AXIS.
C               = 1 FOR A SIMPLE LOG AXIS WITH ONE LABEL PER DECADE.
C                  IN THIS CASE XLO, XHI MUST= LOG(POWER OF 10)
C                  AND IFORMT IS IGNORED.
C                  XUNIT MUST = LOG(POWER OF 10)
C               GE 2  THIS GIVES YOU THE INVERSE SCALE OF IAXIS =1
C
      IF(IAXIS.EQ.0) RETURN
      ABSSZ=ABS(CSIZE)
      TXLO=IFIX(1.0001*XLO)
      TXHI=IFIX(1.0001*XHI)
      TXUNIT=IFIX(1.0001*XUNIT)
      NDEC=TXHI-TXLO
!      IF(NDEC.LT.1) STOP 'XLO,XHI'

      IF(NDEC.LT.1) THEN
         NDEC = -1* ndec
         SGN  = TXHI	! use SGN as a dummy
         TXHI = TXLO
         TXLO = SGN
      ENDIF
C
C	DRAW AXIS
C
	IF(IAXIS.EQ.1)THEN
		X=TXLO
		SGN=+1.
	ELSE
		X=TXHI
		SGN=-1.
	ENDIF
        
        solid1 = (vgrat(1,1).LT.0 .AND. vgrat(2,1).LT.0 .AND.  
     .            vgrat(3,1).LT.0 .AND.  vgrat(4,1).LT.0 )
        solid2 = (vgrat(1,2).LT.0 .AND. vgrat(2,2).LT.0 .AND.  
     .            vgrat(3,2).LT.0 .AND.  vgrat(4,2).LT.0 )
        dashed1 = (vgrat(1,1).GT.0 .OR. vgrat(2,1).GT.0 .OR.  
     .            vgrat(3,1).GT.0 .OR.  vgrat(4,1).GT.0 )
        dashed2 = (vgrat(1,2).GT.0 .OR. vgrat(2,2).GT.0 .OR.  
     .            vgrat(3,2).GT.0 .OR.  vgrat(4,2).GT.0 )

        IF (dashed1) THEN
           dash1_1 = vgrat(1,1)
           dash1_2 = vgrat(2,1)
           dash1_3 = vgrat(3,1)
           dash1_4 = vgrat(4,1)
        ENDIF
        IF (dashed2) THEN
           dash2_1 = vgrat(1,2)
           dash2_2 = vgrat(2,2)
           dash2_3 = vgrat(3,2)
           dash2_4 = vgrat(4,2)
        ENDIF


	IF  (IAXIS .LE. 3) THEN

	   CALL PLOT(X,Y,0,0)
	   CALL PLOTT7(X,Y,XFACT,YFACT,1,-8)
	   DO 110 I=1,NDEC  ! large tics
	      DO 100 J=2,9     ! small tics
                 CALL PLOTT7(X+SGN*(I-1+ALOG10(FLOAT(J))),Y,XFACT,YFACT,1,-7)

                 IF ((solid2.OR.dashed2) .AND. vline) THEN ! make line across
                    xt = X+SGN*(I-1+ALOG10(FLOAT(J)))
                    CALL COLOR(vcolor(2))
                    IF (dashed2) THEN
                       CALL DASHSZ(dash2_1,dash2_2,dash2_3,dash2_4)
                       CALL DASHES
                    ENDIF
                    CALL PLOT(xt,Y,0,0) 
                    CALL PLOT(xt,yacross,1,0)
                    CALL PLOT(xt,Y,0,0) 
                    CALL COLOR(color0)
                    CALL VECTRS
                 ENDIF

100           CONTINUE
              CALL PLOTT7(X+SGN*I,Y,XFACT,YFACT,1,-8)
         
              IF ((solid1.OR.dashed1) .AND. vline) THEN ! make line across
                 xt = X+SGN*I
                 CALL COLOR(vcolor(1))
                 IF (dashed1) THEN
                    CALL DASHSZ(dash1_1,dash1_2,dash1_3,dash1_4)
                    CALL DASHES
                 ENDIF
                 CALL PLOT(xt,Y,0,0) 
                 CALL PLOT(xt,yacross,1,0)
                 CALL PLOT(xt,Y,0,0) 
                 CALL COLOR(color0)
                 CALL VECTRS
              ENDIF

110        CONTINUE
	ELSE

C  for DEPTH axes, X plot coordinates are reversed on page.

           XTEMP = X + SGN* NDEC
	   CALL PLOT(XTEMP,Y,0,0)
	   CALL PLOTT7(XTEMP,Y,XFACT,YFACT,1,-8)
	   DO 130 I=1,NDEC
	      DO 120 J=2,9
                 CALL PLOTT7(XTEMP+(I-1+ALOG10(FLOAT(J))),Y,XFACT,YFACT,1,-7)
                 
                 IF ((solid2.OR.dashed2) .AND. vline) THEN ! make line across
                    xt = XTEMP+(I-1+ALOG10(FLOAT(J)))
                    CALL COLOR(vcolor(2))
                    IF (dashed2) THEN
                       CALL DASHSZ(dash2_1,dash2_2,dash2_3,dash2_4)
                       CALL DASHES
                    ENDIF
                    CALL PLOT(xt,Y,0,0) 
                    CALL PLOT(xt,yacross,1,0)
                    CALL PLOT(xt,Y,0,0) 
                    CALL COLOR(color0)
                    CALL VECTRS
                 ENDIF

120           CONTINUE
              CALL PLOTT7(XTEMP+I,Y,XFACT,YFACT,1,-8)

              IF ((solid1.OR.dashed1) .AND. vline) THEN ! make line across
                 xt = XTEMP+I
                 CALL COLOR(vcolor(1))
                 IF (dashed1) THEN
                    CALL DASHSZ(dash1_1,dash1_2,dash1_3,dash1_4)
                    CALL DASHES
                 ENDIF
                 CALL PLOT(xt,Y,0,0) 
                 CALL PLOT(xt,yacross,1,0)
                 CALL PLOT(xt,Y,0,0) 
                 CALL COLOR(color0)
                 CALL VECTRS
              ENDIF

130        CONTINUE

c 120	   CALL PLOTT7(XTEMP+SGN*(I-1+ALOG10(FLOAT(J))),Y,XFACT,YFACT,1,-7)
c 130	   CALL PLOTT7(XTEMP+SGN*I,Y,XFACT,YFACT,1,-8)

        ENDIF
C
C	DRAW LABELS
C
	IF(LABEL.EQ.0)RETURN
	IF(LABEL+IX.EQ.0)THEN
		YTEMP=0.0
	ELSE
		YTEMP=TLX*0.5
	ENDIF
	IF(CSIZE.LT.0.)THEN
		NC=5
		XFRMT='(''-E'',I3)'
	ELSE
		NC=4
		XFRMT='(''E'',I3)'
	ENDIF
	XWID=1.9*ABSSZ+YTEMP
	YTEMP=Y+LABEL*(1.40*ABSSZ+YTEMP)/YFACT
	DO 200 I=0,NDEC

C	   WRITE(XLAB,XFRMT)IFIX(SGN*(X-TXUNIT+I))
	   IF (SGN .GE. 0.) THEN
	      WRITE(XLAB,XFRMT)IFIX(SGN*(X-TXUNIT+SGN*I))
	      XTEMP = X + SGN*I
	   ELSE
	      WRITE(XLAB,XFRMT)IFIX((X-TYUNIT+SGN*(NDEC-I)))
              XTEMP = X + SGN*(NDEC-I)
           ENDIF

	   CALL SCINOT(XTEMP,YTEMP,0.,ABSSZ,NC,XLAB,0,WID,XFACT,YFACT)
200	CONTINUE
	RETURN
	END

	SUBROUTINE NEW_MR_W_EDGES(cx_valid,cx_model,mr,status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* allocate and claim sufficient memory space, and assign and fill a slot in the 
* memory variable table for the variable or expression indicated in the context
* the region of valid data within the cx_model context is indicated by the
* cx_valid context ... fill the invalid regions with bad data flags

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:   8/3/89
* V312: 5/94 - array "memory" as a calling argument
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xvariables.cmn'

* calling argument declarations:
	INTEGER	cx_valid, cx_model, mr, status

* internal variable declarations
	INTEGER MGRID_SIZE

* create the memory variable
	CALL CREATE_MEM_VAR( cx_model, mr, status )
	IF ( status .NE. ferr_ok ) RETURN

	IF ( mr_type(mr) .EQ. ptype_string ) THEN
           CALL INIT_C_STRING_ARRAY( MGRID_SIZE(mr),
     .                               memry(mr)%ptr,
     .                               mr_c_pointer(mr)      )
	ENDIF

* fill edges
	CALL BAD_EDGES( cx_valid, memry(mr)%ptr, mr )

	RETURN
	END

	INTEGER FUNCTION TM_LOC_STRING( string, substring, ioc )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Case-independent search to find the "ioc"th occurrence of * "substring" 
* in "string".  If there are fewer than "ioc" occurrences, return 0.

* programmer - Ansley Manke, based on tm_has_string.F
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* revision 0.00 - 03/17/03

* calling argument declarations
        INTEGER ioc
	CHARACTER*(*)	string, substring

* local variable declarations
	INTEGER	STR_UPCASE, TM_LENSTR1,
     .		vms_stat, sublen, strlen, i, loc, maxstr
	
	PARAMETER (maxstr = 2048)
	CHARACTER*(maxstr)	up_string, up_sub, newstring

* length of substring
	sublen = MIN(maxstr, TM_LENSTR1( substring ))
	strlen = MIN(maxstr, TM_LENSTR1( string ))

        IF (ioc .LT. 1) ioc = 1

        IF (ioc .GT. strlen) THEN
	   TM_LOC_STRING = 0
	   RETURN
	ENDIF

	IF (sublen .GT. 512) THEN
	   TM_LOC_STRING = 0
	   RETURN
	ENDIF

* convert to upper case
	vms_stat = STR_UPCASE( up_string, string )
	vms_stat = STR_UPCASE( up_sub, substring(:sublen) )

* find the substring
	TM_LOC_STRING = INDEX( up_string, up_sub(:sublen) ) 
        IF (TM_LOC_STRING .GE. 1 .AND. ioc .GT. 1) THEN
           DO 100 i = 2, ioc
              loc = TM_LOC_STRING
              IF (loc+1 .LT. strlen) THEN
                 newstring = up_string(loc+1:strlen)
                 TM_LOC_STRING = INDEX( newstring, 
     .                               up_sub(:sublen) )
                 IF (TM_LOC_STRING .NE. 0) TM_LOC_STRING = 
     .                    TM_LOC_STRING + loc
              ENDIF
  100      CONTINUE
        ENDIF

	RETURN
	END

	SUBROUTINE CHOOSE_LINE_NAME (axis, original, axname)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* For the given axis number, return either line_name(axis) or
* line_name_orig(axis).  When mode_upcase is set, return the line_name
* version which has been upper-cased. 

* If mode_upcase is false, atempt to return line_name_orig.
* -- First check whether line_name_orig is defined. 
* -- If the lengths of line_name and line_name_orig differ, the line name was changed 
*    by Ferret for uniqueness. In these cases, check the value of the flag "original". 
* -- If mode_upcase is false, and original is true, then we want the original form 
*    no matter what. E.g. for xml output, we want the original axis name from the file.
*    For other cases, such as a generic SHOW GRID, we want the name in use for the 
*    Ferret session.
* V698 2/16 *acm*  For ticket 1786: if mode_upcase is canceled write axis name
*                  using original upper/lowercase spelling


        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
#	include "tmap_dset.parm"
	include 'xprog_state.cmn'

	LOGICAL original 
	INTEGER TM_LENSTR, axis
	CHARACTER*(*) axname

	axname = line_name(axis)

	IF (.NOT. mode_upcase_output) THEN

* If there is no good line_name_orig defined, keep line_name
	   IF (TM_LENSTR(line_name_orig(axis)).EQ.0  .OR.
     .         line_name_orig(axis)(1:2) .EQ. char_init) THEN
             axname = line_name(axis)

* If the axis has been renamed for uniqueness, return line_name
* unless original has been set.

	   ELSE IF (TM_LENSTR(line_name_orig(axis)) .NE. 
     .              TM_LENSTR(line_name(axis)     ) .AND. .NOT.original) THEN
             axname = line_name(axis)

* Otherwise if upcase is turned off, return line_name_orig
           ELSE
	      axname = line_name_orig(axis)
           ENDIF
	ENDIF

	
	RETURN
	END

	SUBROUTINE WS_LINE_BUNDLE (zwsid,zwstype)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that INCLUDEs this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Routine to set up the line bundles for generic WS's.
*	J Davison JISAO/PMEL/TMAP 3.23.89
*	*jd* 2.19.92 mod to support atc gks
*	*jd* 8.10.93 mod to support XGKS line colors -- force setting
*       *js* 7.31.97 mod to change call to gqlwk to query_xgks_wkstn

*       *acm* 8/2001  add polymarker call for PLOT/SYMBOL=DOT  
*       *acm* 4/2002  add polymarker calls for circles of different sizes
*                     and colors 1-6 are colored dots, 7-12 are small circles
*                     13-18 are larger circles.  /THICK makes them thicker.

* gsplr: wkid, line index, line type, linewidth scale factor, color index
* gspmr: wkid, marker index, marker type(dot=1), size (const for dot), color index

*        *acm* 12/4/02 NOTE: With changes to gksm2ps.c which multiply the 
*              size of the dots by 4, the output is consistent from 
*              ferret metafiles transformed to postscript, from 
*              "ferret -batch" output, and gif files.
*       *acm* 2/2003 polymarker dot line bundles had not been set for pen > 6
*  v600 *acm* 5/2006 User can change the number of line colors.

        INCLUDE 'parampl5_dat.decl'
        INCLUDE 'PARAMPL5.DAT'
        INCLUDE 'plt_inc.decl'
        INCLUDE 'PLT.INC'
        INCLUDE 'pen_inc.decl'  ! with num_line_colors
        INCLUDE 'PEN.INC'
	INCLUDE 'save_colors.cmn'

	integer		zwsid,zwstype,i,j

#ifdef atc_gks
	integer 	ltype(6)
	data	 	ltype/1,2,3,4,-1001,-1004/
#else
	integer 	ltype(6)
	data		ltype/1,2,3,4,-3,-4/
#endif

	integer		max_pline,max_pmark,max_text,max_fill_area
	integer		max_pattern,max_color,error
	integer		fktr, marktype, index
                                       
	real		thickness, dotsize, grey, frac
        real a, b, c

*******************************************************************************
*	WHAT IS AVAILABLE ON THIS WORKSTATION?
	call query_xgks_wkstn (zwstype,error,max_pline,max_pmark,
     .	            max_text,max_fill_area,max_pattern,max_color)
	if (error .ne. 0) goto 1000

        marktype = 1    ! polymarker type 1=dot
        dotsize = 1

*	COLOR OR MONOCHROME?
	if (max_color .le. 2) goto 100

*	COLOR WORKSTATIONS:
#ifdef xgks

        call gscr (zwsid,2,1.0,0.0,0.0)   ! pre-defined colors
        call gscr (zwsid,3,0.0,1.0,0.0)
        call gscr (zwsid,4,0.0,0.0,1.0)
        call gscr (zwsid,5,0.0,1.0,1.0)
        call gscr (zwsid,6,1.0,0.0,1.0) 
     
! Set up initial values for further colors as grey
! range them between 0.6,0.6,0.6 and 0.9,0.9,0.9

        IF (num_line_colors .GT. 6) THEN
           frac = (0.9-0.6)/FLOAT(num_line_colors - 6)
           grey = 0.6
           IF (num_line_colors .EQ. 1) grey = 0.8

           do 40 j = 7, num_line_colors     
              call gscr (zwsid,j,grey,grey,grey)
  40       continue
           grey = grey + frac
        ENDIF

	IF (saved_line_colors .GT. 0) THEN
	   CALL restore_saved_line_colors (zwsid)
	ENDIF

#endif

! Set line bundles

	do 20 j = 1, num_line_colors
	    
	   do 10 fktr = 1,3     ! thickness
              index = (fktr-1)*num_line_colors+j
              thickness = real(fktr)

	      call gspmr (zwsid,index,marktype,dotsize,j)
	      call gsplr (zwsid,index,1,thickness,j)
       
10	   continue
20	continue

	return

*	MONOCHROME WORKSTATIONS:
100	do 120 j = 1,3
	   thickness = real (j)
	   do 110 i = 1,6
	      call gspmr (zwsid,i+6*(j-1),ltype(i),thickness,1)
	      call gsplr (zwsid, i, marktype, dotsize, 1)
110	   continue
120	continue                   

	return

*	FATAL ERR
1000	return

	end

* chdir_pmel.F
*
* Change current working directory.
* -atw 10/17/01

      SUBROUTINE chdir_pmel_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

      CALL ef_version_test(ef_version)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      CALL ef_set_desc(id,'Change current working directory.' )
      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_type(id, arg, STRING_ARG)
      CALL ef_set_arg_name(id, arg, 'TO_DIRECTORY')
      CALL ef_set_arg_desc(id, arg, 'desired working directory')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES) 

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE chdir_pmel_compute(id, arg_1, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      INTEGER itest, ilen
      CHARACTER arg1_text*160
      INTEGER CHDIR, TM_LENSTR1

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      CALL ef_get_arg_string(id, 1, arg1_text)
      ilen = TM_LENSTR1(arg1_text)

      WRITE(*,*) 'Changing directory to: ',arg1_text(1:ilen)
      itest = CHDIR(arg1_text(1:ilen))

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

      INTEGER FUNCTION TM_LENSTR1 (line)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine the length of a character string as the position of the last 
* non-blank character
* unlike TM_LENSTR this routine will return a length of 1 (vs. 0) if the string
* is all blanks

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.00 - 05/05/87 - based on TM_LENSTR rev. 0.00
*
* calling argument declarations:
	CHARACTER*(*) line

* internal variable declarations:
	INTEGER	i, mright

* initialize: find highest possible right hand limit of string
	mright = LEN(line)

	DO 100 i = mright,1,-1
	IF (line(i:i) .NE. ' ') GOTO 200
 100	CONTINUE

* for all blanks
	TM_LENSTR1 = 1
	RETURN

* found non-blank
 200	TM_LENSTR1 = i
	RETURN
	END

	SUBROUTINE INIT_CONTEXT_MODS ( cx )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* prepare a clean,empty cx to receive a list of modifications

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - ????
* revision 0.1 -  4/1/89  - added regridding transformations
* V200:  6/28/89 - 4D symmetrical - init trans_arg, too, eliminate %%_relative
*		 - init cx_dset_gvn, cx_grid_needs_dset
* V420: 9/8/95 - added initializations for implicit grid creation
* 
*       8/97 *kob* - initalize cx_calendar - used to indicate whether a date
*                    contains a string 
* V510 *sh* - added cx_formatted
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V685 3/2013 *sh* initialize auxiliary regrid variable info
* V695  *acm* 2/15 cx_calendar stores info about calendar formatting of T and F axes

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'xcontext.cmn'

* calling argument declarations:
	INTEGER	cx

* internal variable declarations:
	INTEGER	idim, ivar

* initialize everything but region
	cx_variable( cx ) = unspecified_int4
	cx_category( cx ) = unspecified_int4
	cx_data_set( cx ) = unspecified_int4
	cx_dset_gvn( cx ) = .FALSE.
	cx_grid( cx )     = unspecified_int4
	cx_unstand_grid( cx )  = .FALSE.
	cx_has_impl_grid( cx ) = .FALSE.
	cx_grid_needs_dset     = .FALSE.
	
* initialize region
* note: ss specifications are not used in storing modifications
	DO 100 idim = 1, nferdims
	   cx_lo_ss ( cx, idim )  = unspecified_int4
	   cx_hi_ss ( cx, idim )  = unspecified_int4
	   cx_calendar(idim,cx)   = .FALSE.
	   cx_lo_ww ( idim, cx )  = unspecified_val8
	   cx_hi_ww ( idim, cx )  = unspecified_val8
	   cx_delta ( idim, cx )  = unspecified_val8
	   cx_trans ( idim, cx )  = trans_no_transform
	   cx_trans_arg  ( idim, cx ) = bad_val4
	   cx_by_ss      ( idim, cx ) = .FALSE.	!for bookkeeping
	   cx_given      ( idim, cx ) = .FALSE.
	   cx_aux_given  ( idim, cx ) = .FALSE.
	   cx_aux_stat   ( idim, cx ) = paux_stat_na
	   cx_regrid_trans(idim, cx ) = unspecified_int4 
	   cx_formatted( idim )	  = .FALSE.
100	CONTINUE

* initialize info about auxiliary regridding variables
	cx_naux( cx ) = 0
	DO 200 ivar = 1, nferdims
	   cx_aux_var  (ivar, cx) = unspecified_int4
	   cx_aux_cat  (ivar, cx) = unspecified_int4
 200	CONTINUE


	RETURN
	END

	SUBROUTINE MASK_DSG_FVAR (nfeatures, process_feature, dset, 
     .        source_data, put_data)

* Argument declarations
	LOGICAL process_feature(*)
	INTEGER nfeatures, dset, line_to_put
	REAL source_data(*), put_data(*)

* Local declarations
	INTEGER count, ifeature


	count = 0
	DO ifeature = 1, nfeatures
	   IF (process_feature(ifeature)) THEN
	      count = count + 1
	      put_data(count) = source_data(ifeature)
	   ENDIF
	ENDDO

	RETURN
	END

	SUBROUTINE CLRKLAB (labstring)

	INCLUDE 'parampl5_dat.decl'
	INCLUDE 'PARAMPL5.DAT'
	INCLUDE 'cont_inc.decl'
	INCLUDE 'CONT.INC'
	include		'cmrd_inc.decl'
	include		'CMRD.INC'   

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*

C 
C   Store strings to be used in colorbar labels, from label which is
C   the whole set of strings, up to 20 of them, separated by ampersands.
C
* V7.4+ 8/2018 ACM for DSG-enabled Ferret
* V7.51 6/2019 ACM Use Ampersand to separate strings, else the pplus parser is confused

	CHARACTER*(*) labstring

	INTEGER TM_LENSTR, i, slen, istr, ilab 
	CHARACTER*1 c, amper
	CHARACTER*48 TM_FMT_SNGL

C Initialize

	DO i = 1, 20
	   colorkey_labs(i) = " "
	ENDDO

	slen = TM_LENSTR(labstring)

	IF ( slen .EQ. 0 )THEN

* Numeric values were split up and put into P(). Turn them into strings.
	   IF (M.gt.0) THEN
	      DO i = 1, M
	         colorkey_labs(i) = TM_FMT_SNGL (P(i),  15, 20, slen)
	      ENDDO
	   ENDIF
	   GOTO 10

	ENDIF

* Strings: split up the label-string at the ampersands.

	amper = "&"
	istr = 1
	ilab = 1

	DO i = 1, slen
	   c = labstring(i:i)
	   IF (c .EQ. amper) THEN
	      ilab = ilab+1
	      istr = 1
	   ELSE
	      colorkey_labs(ilab)(istr:istr) = c
	      istr = istr+1
	   ENDIF
	ENDDO

10	CONTINUE


	RETURN
	END

	INTEGER FUNCTION KNOWN_GRID ( data_set, category, variable )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* find the defining grid for the given variable
* if unknown - return unknown flag

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:   7/6/89 - based on IGRID
* V230:  7/21/92 - check for unspecified data set on calc_var
* v554: 1/04 *acm* Counter variables for REPEAT/RANGE=/NAME=
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE

	include	'tmap_dims.parm'
#       include "tmap_dset.parm"
	include	'xdset_info.cmn_text'
	external xdset_info_data
	include	'ferret.parm'
	include	'xvariables.cmn'
	include	'xcalc_vars.cmn'
        include 'xfr_grid.cmn'

* calling argument declarations:
	INTEGER	data_set, category, variable

* internal variable declarations:
	INTEGER	dset

* different procedure for determining grid from each category
	IF     ( category .EQ. cat_file_var ) THEN

	   KNOWN_GRID = ds_grid_number( variable )

	ELSEIF ( category .EQ. cat_aggregate_var ) THEN

	   KNOWN_GRID = ds_grid_number( variable )
	   IF (ds_grid_number( variable ) .EQ. int4_init) 
     .	      KNOWN_GRID = unspecified_int4

	ELSEIF ( category .EQ. cat_calc_var ) THEN

           IF ( data_set .EQ. unspecified_int4 ) THEN
              KNOWN_GRID = unspecified_int4
           ELSE
	      KNOWN_GRID = cvar_grid( variable, data_set )
           ENDIF


	ELSEIF ( category .EQ. cat_user_var ) THEN

* ... allow "abstract" expressions that don't depend on data set
	   IF ( .NOT.uvar_need_dset(variable)
     .	   .OR. data_set .EQ. unspecified_int4 ) THEN
	      dset = pdset_irrelevant
	   ELSE
	      dset = data_set
	   ENDIF
	   KNOWN_GRID = uvar_grid( variable, dset )

	ELSEIF ( category .EQ. cat_temp_var ) THEN

	   KNOWN_GRID = mr_grid( variable )

	ELSEIF ( category .EQ. cat_counter_var ) THEN

	   KNOWN_GRID = mgrid_xabstract

	ELSEIF ( category .EQ. cat_attrib_val ) THEN  

	   KNOWN_GRID = mgrid_xabstract

	ELSE

	   STOP 'KNOWN_GR'

	ENDIF

	RETURN
	END

	LOGICAL FUNCTION TM_DIGIT_TEST( string )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* test to see if the string can be read as a number

* Ansley Manke 10/11/05
* from tm_digit.F


#include "gt_lib.parm"

* calling argument declarations:
	CHARACTER*(*)	string

* internal variable declarations:
        LOGICAl         maybe
	INTEGER		TM_LENSTR1, i, j
	CHARACTER*1	c
	
* local parameter declarations:
        CHARACTER*1     tab
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
#else
	PARAMETER     ( tab = CHAR(9))
#endif

* skip leading blanks
	DO 100 i = 1, LEN(string)
	   c = string(i:i)
	   IF ( c .NE. ' ' .AND. c .NE. tab ) GOTO 200
 100	CONTINUE

* string is blank
	TM_DIGIT_TEST = .FALSE.
	
* check first character
 200	TM_DIGIT_TEST =   c .EQ. '+'
     .		.OR. c .EQ. '-'
     .		.OR. c .EQ. '.'
     .		.OR. c .GE. '0' .AND. c .LE. '9'

* kludge check for "./name" (11/94 for AIX port)
	IF (c.EQ.'.' .AND. LEN(string).GE.2 )
     .		TM_DIGIT_TEST = string(2:2) .NE. PathSeparator

! dataset attributes ..attname
        IF (INDEX(string, '..') .GT. 0) TM_DIGIT_TEST = .FALSE.  

        IF (.NOT. TM_DIGIT_TEST) RETURN

* Check further characters.  There may be an E for exponent or a D for a double precision 

        IF (TM_LENSTR1(string) .LE. i) RETURN
        maybe = .FALSE.
	DO 300 j = i+1, TM_LENSTR1(string)
	   c = string(j:j)
           TM_DIGIT_TEST =   c .EQ. '+'
     .		.OR. c .EQ. '-'
     .		.OR. c .EQ. '.'
     .		.OR. c .GE. '0' .AND. c .LE. '9'
     .		.OR. c .EQ. 'E'
     .		.OR. c .EQ. 'e'
     .		.OR. c .EQ. 'D'
     .		.OR. c .EQ. 'd'
           IF (.NOT. TM_DIGIT_TEST) RETURN

           IF (maybe) THEN  ! previously hit an E or D, see if this next char is numeric
              TM_DIGIT_TEST =   c .EQ. '+'
     .		.OR. c .EQ. '-'
     .		.OR. c .EQ. '.'
     .		.OR. c .GE. '0' .AND. c .LE. '9'
              maybe = .FALSE.
              IF (.NOT. TM_DIGIT_TEST) RETURN
           ENDIF

           maybe = c .EQ. 'E'
     .		.OR. c .EQ. 'e'
     .		.OR. c .EQ. 'D'
     .		.OR. c .EQ. 'd'
 300	CONTINUE
        IF (maybe) TM_DIGIT_TEST = .FALSE.   ! ended with D or E

	RETURN

      END

	SUBROUTINE SHOW_LINE( line, brief )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* display basic facts about the given line

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 8/1/88
* V200:  9/22/89 - added "orient" for axes without particular orientations
* V320: 12/29/94 - use SPLIT_LIST to redirect tty output for GUI
* V530:  3/01    - indicate the calendar for non-Gregorian calendar types 
* V541 *sh*  2/02 - describe axis span and modulo length
* V553 *acm* 6/03 - Allow for line_direction code of 'XX' or 'YY'
* V581 *acm* 6/05 - For fix to bug 1271, add flag line_shift_origin
*            and restore original t0 on output
* V650  Write to show_lun which may be set to a file unit number rather than std out
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V695+  *sh* 5/15 show T0 for forecast calendar axes, too
* V697  12/15 *acm* Changes to add details on SHOW GRID uvar to indicate 
*                   compressed or subsetted axes
* V720 4/17 *sh* - support for DSG contiguous ragged arrays

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'implicit.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xunits.cmn_text'
	external xunits_data
	include	'ferret.parm'
	include 'xprog_state.cmn'
	include 'xtext_info.cmn'
	include 'calendar.decl'
	include 'calendar.cmn'

* calling argument declarations
	LOGICAL		brief
	INTEGER 	line

* local variable declarations:
	LOGICAL		TM_ITS_SUBSPAN_MODULO
	INTEGER		idim, orient, slen, i, idum
	INTEGER		TM_LENSTR1, TM_GET_CALENDAR_ID, cal_id
	CHARACTER	TM_FMT*48, buff*80, buff20*20
	REAL*8		TM_WW_AXLEN

* determine orientation
	DO 100 idim = 1, nferdims+1
	   IF ( line_direction(line) .EQ. axis_orients( idim ) ) THEN
	      orient = idim
	      GOTO 110
	   ENDIF
 100	CONTINUE
        IF (line_direction(line) .EQ. 'XX') THEN
           orient = 1
           idim = 1
           GOTO 110
        ENDIF
        IF (line_direction(line) .EQ. 'YY') THEN
           orient = 2
           idim = 2
           GOTO 110
        ENDIF
        IF (line_direction(line) .EQ. 'TT') THEN
           orient = 4
           idim = 4
           GOTO 110
        ENDIF
        IF (line_direction(line) .EQ. 'EE') THEN
           orient = 5
           idim = 5
           GOTO 110
        ENDIF
        IF (line_direction(line) .EQ. 'FF') THEN
           orient = 6
           idim = 6
           GOTO 110
        ENDIF

	orient = 0
	idim   = 1				! use X slot for non-oriented
 110	IF ( idim .EQ. nferdims+1 ) idim = 3	! DU --> UD on Z axis

* create a dummy grid with this axis
* (kludge to use existing code that works with grids)
	grid_line(idim, mgrid_buff) = line

* report basic facts using code from SHOW_GRID
* Last argument is user-var code, not needed here, but used when calling from SHOW_GRID
	buff20 = ' '
	idum = -1
	CALL LINE_FACTS( show_lun, idim, mgrid_buff, orient, idum )
	IF ( brief ) RETURN
* nothing more to show if the "line" represents a contiguous ragged array
	IF (idim.NE.e_dim .AND. line_dsg_dset(line).NE.pline_not_dsg) RETURN
!DSGTBD Is there more we'd like to tell about the contiguous ragged array?

* report /T0= for formatted time axis
	IF  ( line_direction(line) .EQ. 'TI' 
     .	.OR.  line_direction(line) .EQ. 'FI' ) THEN
            IF (line_shift_origin(line)) THEN
               buff20 = '01-JAN-0001 00:00:00'
            ELSE
 	       buff20 = line_t0(line)
            ENDIF
	   CALL SPLIT_LIST
     .		(pttmode_explct, show_lun, 'T0 = '//buff20, 0)

* report the calendar of a time axis if "interesting"
	   buff = line_cal_name (line)
	   cal_id = TM_GET_CALENDAR_ID (buff)
	   IF (cal_id .GT. gregorian .AND. cal_id .LE. max_calendars) THEN
	      slen = TM_LENSTR1(buff)
	      CALL SPLIT_LIST (pttmode_explct, show_lun, 
     .		               'CALENDAR = '//buff(:slen), 0)
	   ENDIF
	ENDIF

* report the full span of the axis
	buff =  '   Axis span (to cell edges) = '//
     .		TM_FMT( TM_WW_AXLEN(line),7,22,slen )
	slen = slen + 31

* if line is modulo, report its modulo cycle length
	IF ( line_modulo(line) ) THEN
	   IF ( TM_ITS_SUBSPAN_MODULO(line) ) THEN
	     buff = buff(:slen)// ' (modulo length = ' //
     .		   TM_FMT( line_modulo_len(line),7,22,i )
	     slen = slen + i + 18
	     buff = buff(:slen) //')'
	     slen = slen + 1
	   ELSE
	     buff = buff(:slen) // ' (modulo length = axis span)'
	     slen = slen + 28
	   ENDIF
	ENDIF
	CALL SPLIT_LIST (pttmode_explct, show_lun, buff, slen)

	RETURN
	END

*
* sampleyz.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without anx fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and anx derivative works thereof, and
*  its supporting documentation for anx purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in anx publications that result from
*  the use of this software or in anx product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in anx advertising or publicity to endorse or promote anx products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with anx support, consulting,
*  training or assistance of anx kind with regard to the use, operation
*  and performance of this software nor to provide the user with anx
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND Anx EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR Anx SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR Anx DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* From samplexy.F
* Wednesday, May 02, 2001
* 11-Jan-06 *acm* declare ylo, yhi, zlo, zhi as integer not real
*
* V68   3/12 Fix arg description.

* This function samples 4-d data at y and z pts indicated by args 2 and 3
* 
*         Result is abstract on the Y axis, normal on the z axis,
*         and keeps the x and t axes of the input 4-d data.

* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE sampleyz_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CHARACTER*100 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns data sampled at a set of (Y,Z) points, ',
     .        'using linear interpolation')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, ABSTRACT,
     .                                NORMAL,          IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 2)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'DAT_TO_SAMPLE')
      CALL ef_set_arg_desc(id, arg, 'variable (x,y,z,t,e,f) to sample')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, NO, NO, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'YPTS')
      CALL ef_set_arg_desc(id, arg, 'Y values of sample points')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'ZPTS')
      CALL ef_set_arg_desc(id, arg, 'Z values of sample points')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* loss               lo subscript for an axis
*
* hiss               hi subscript for an axis
*

      SUBROUTINE sampleyz_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER nx, ny, nz, nt, ne, nf
      INTEGER my_lo, my_hi

*     Use utility functions to get context information about the 
*     second argument, to set the abstract axis lo and hi indices.

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nx = arg_hi_ss(X_AXIS, ARG2) - arg_lo_ss(X_AXIS, ARG2) + 1
      ny = arg_hi_ss(Y_AXIS, ARG2) - arg_lo_ss(Y_AXIS, ARG2) + 1
      nz = arg_hi_ss(Z_AXIS, ARG2) - arg_lo_ss(Z_AXIS, ARG2) + 1
      nt = arg_hi_ss(T_AXIS, ARG2) - arg_lo_ss(T_AXIS, ARG2) + 1
      ne = arg_hi_ss(E_AXIS, ARG2) - arg_lo_ss(E_AXIS, ARG2) + 1
      nf = arg_hi_ss(F_AXIS, ARG2) - arg_lo_ss(F_AXIS, ARG2) + 1

      my_lo = 1
      my_hi = MAX(nx,ny,nz,nt,ne,nf)

      CALL ef_set_axis_limits(id, Y_AXIS, my_lo, my_hi)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END
*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE sampleyz_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER myl, myh, mzl, mzh

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

*  Allocate double the length of the axes for REAL*8 work arrays.

      myl = arg_lo_ss(Y_AXIS,ARG1)
      mzl = arg_lo_ss(Z_AXIS,ARG1)

      myh = myl + 
     .     2* (arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1) + 1)
      mzh = mzl + 
     .     2* (arg_hi_ss(Z_AXIS,ARG1) - arg_lo_ss(Z_AXIS,ARG1) + 1)

*  yaxdat
      CALL ef_set_work_array_dims_6d(id, 1,
     .                              myl, 1, 1, 1, 1, 1,
     .                              myh, 1, 1, 1, 1, 1)

*  zaxdat
      CALL ef_set_work_array_dims_6d(id, 2,
     .                              mzl, 1, 1, 1, 1, 1,
     .                              mzh, 1, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE sampleyz_compute(id, arg_1, arg_2, arg_3, result,
     .                            yaxdat, zaxdat)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* Ignore the Y/Z/T/E/F dimensions in the work arrays since
* they are not used and Fortran is column major
      REAL*8 yaxdat(wrk1lox:wrk1lox+(wrk1hix-wrk1lox)/2)
      REAL*8 zaxdat(wrk2lox:wrk2lox+(wrk2hix-wrk2lox)/2)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      LOGICAL TM_FPEQ

      INTEGER ny, nyx, nyy, nyz, nyt, nye, nyf
      INTEGER nz, nzx, nzy, nzz, nzt, nze, nzf
      INTEGER ndimy, ndimz
      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2
      INTEGER i3, j3, k3, l3, m3, n3
      INTEGER jmatch, kmatch
      INTEGER jbot, jtop, kbot, ktop
      INTEGER ylo, yhi, zlo, zhi
      REAL fybot, fytop, fbb, ftb, fbt, ftt
      REAL ybot, ytop, zbot, ztop
      REAL yfrac, zfrac
      REAL delmody, delmodz, ypt, zpt
      CHARACTER*255 err_msg

C  variables for checking axis characteristics (modulo axes)
      CHARACTER ax_name(6)*16, ax_units(6)*16
      LOGICAL backward(6), modulo(6), regular(6)

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

C Validate argument dimensions
      nyx = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1
      nyy = arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) + 1
      nyz = arg_hi_ss(Z_AXIS,ARG2) - arg_lo_ss(Z_AXIS,ARG2) + 1
      nyt = arg_hi_ss(T_AXIS,ARG2) - arg_lo_ss(T_AXIS,ARG2) + 1
      nye = arg_hi_ss(E_AXIS,ARG2) - arg_lo_ss(E_AXIS,ARG2) + 1
      nyf = arg_hi_ss(F_AXIS,ARG2) - arg_lo_ss(F_AXIS,ARG2) + 1
      ny = MAX(nyx, nyy, nyz, nyt, nye, nyf)

      nzx = arg_hi_ss(X_AXIS,ARG3) - arg_lo_ss(X_AXIS,ARG3) + 1
      nzy = arg_hi_ss(Y_AXIS,ARG3) - arg_lo_ss(Y_AXIS,ARG3) + 1
      nzz = arg_hi_ss(Z_AXIS,ARG3) - arg_lo_ss(Z_AXIS,ARG3) + 1
      nzt = arg_hi_ss(T_AXIS,ARG3) - arg_lo_ss(T_AXIS,ARG3) + 1
      nze = arg_hi_ss(E_AXIS,ARG3) - arg_lo_ss(E_AXIS,ARG3) + 1
      nzf = arg_hi_ss(F_AXIS,ARG3) - arg_lo_ss(F_AXIS,ARG3) + 1
      nz = MAX(nzx, nzy, nzz, nzt, nze, nzf)

      ndimy = 0
      ndimz = 0
      DO 10 i = X_AXIS,F_AXIS
         IF ( arg_hi_ss(i,ARG2) .GT. arg_lo_ss(i,ARG2) ) 
     .      ndimy = ndimy + 1
         IF ( arg_hi_ss(i,ARG3) .GT. arg_lo_ss(i,ARG3) ) 
     .      ndimz= ndimz + 1
   10 CONTINUE

      IF ( (ny .NE. nz) .OR. (ndimy .GT. 1) .OR. (ndimz .GT.1) ) THEN
         err_msg =
     .  'Arguments 2 and 3 must be 1-dimensional lists of equal length'
         GO TO 999
      ENDIF

*  Get y and z coordinates of the data to be sampled.

      CALL ef_get_coordinates(id, ARG1, Y_AXIS,
     .   arg_lo_ss(Y_AXIS, ARG1), arg_hi_ss(Y_AXIS, ARG1), yaxdat)
      CALL ef_get_coordinates(id, ARG1, Z_AXIS,
     .   arg_lo_ss(Z_AXIS, ARG1), arg_hi_ss(Z_AXIS, ARG1), zaxdat)

*  Check to see if input y or z axis is modulo

      CALL ef_get_axis_info_6d(id, ARG1, ax_name, ax_units,
     .                         backward, modulo, regular)

      ylo = arg_lo_ss(Y_AXIS,ARG1)
      yhi = arg_hi_ss(Y_AXIS,ARG1)
      zlo = arg_lo_ss(Z_AXIS,ARG1)
      zhi = arg_hi_ss(Z_AXIS,ARG1)

* Is this enough? (see samplexy and samplexyt)
      IF ( modulo(Y_AXIS) ) THEN
         delmody = yaxdat(yhi) - yaxdat(ylo)
      ENDIF
      IF ( modulo(Z_AXIS) ) THEN
         delmodz = zaxdat(zhi) - zaxdat(zlo)
      ENDIF

*  For each (ypt,zpt) pair, search the data array 
*   arg_1 for the nearest higher (y,z) grid coordinates.  Interpolate 
*   in 2 directions for the result.

      i2 = arg_lo_ss(X_AXIS,ARG2)
      j2 = arg_lo_ss(Y_AXIS,ARG2)
      k2 = arg_lo_ss(Z_AXIS,ARG2)
      l2 = arg_lo_ss(T_AXIS,ARG2)
      m2 = arg_lo_ss(E_AXIS,ARG2)
      n2 = arg_lo_ss(F_AXIS,ARG2)

      i3 = arg_lo_ss(X_AXIS,ARG3)
      j3 = arg_lo_ss(Y_AXIS,ARG3)
      k3 = arg_lo_ss(Z_AXIS,ARG3)
      l3 = arg_lo_ss(T_AXIS,ARG3)
      m3 = arg_lo_ss(E_AXIS,ARG3)
      n3 = arg_lo_ss(F_AXIS,ARG3)

* Z-axis is normal to the results
      k = res_lo_ss(Z_AXIS)

      DO 700 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

         ypt = arg_2(i2,j2,k2,l2,m2,n2)
         zpt = arg_3(i3,j3,k3,l3,m3,n3)

         IF ( ypt .EQ. bad_flag(ARG2) .OR.
     .        zpt .EQ. bad_flag(ARG3) ) THEN
            DO 30 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
            DO 30 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
            DO 30 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
            DO 30 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
               result(i,j,k,l,m,n) = bad_flag_result
   30       CONTINUE
*           Go to the next pair of coordinates
            GOTO 690
         ENDIF

* Try to get ypt in range if the Y-axis is modulo
         IF ( modulo(Y_AXIS) ) THEN
            DO WHILE ( ypt .GE. yaxdat(yhi) ) 
               ypt = ypt - delmody
            ENDDO
            DO WHILE ( ypt .LT. yaxdat(ylo) )
               ypt = ypt + delmody
            ENDDO
         ENDIF

* Check if ypt is in the Y-axis range.
         jbot = ef_unspecified_int4
         jmatch = ef_unspecified_int4

         DO 210 j1 = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)
            IF ( TM_FPEQ(ypt, yaxdat(j1)) ) THEN
               jmatch = j1
               GOTO 220
            ELSE IF ( ypt .GT. yaxdat(j1) ) THEN
               jbot = j1
            ENDIF
  210    CONTINUE

* Check that ypt is not beyond the upper end of the Y-axis range.
         IF ( ypt .GT. yaxdat(yhi) ) THEN
            jbot = ef_unspecified_int4
         ENDIF

  220    IF ( jmatch .NE. ef_unspecified_int4 ) THEN
            jbot = jmatch
            jtop = jmatch
         ELSE IF ( jbot .NE. ef_unspecified_int4 ) THEN
            jtop = jbot + 1
         ELSE
*           ypt outside the grid
            DO 230 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
            DO 230 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
            DO 230 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
            DO 230 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
               result(i,j,k,l,m,n) = bad_flag_result
  230       CONTINUE
*           Go to the next pair of coordinates
            GOTO 690
         ENDIF

         ybot = yaxdat(jbot)
         ytop = yaxdat(jtop)
         IF ( ytop .EQ. ybot ) THEN 
            yfrac = 0.
         ELSE
            yfrac = (ypt - ybot) / (ytop - ybot)
         ENDIF

* Try to get zpt in range if the Z-axis is modulo
         IF ( modulo(Z_AXIS) ) THEN
            DO WHILE ( zpt .GE. zaxdat(zhi) ) 
               zpt = zpt - delmodz
            ENDDO
            DO WHILE ( zpt .LT. zaxdat(zlo) )
               zpt = zpt + delmodz
            ENDDO
         ENDIF

* Check if zpt is in the Z-axis range.
         kbot = ef_unspecified_int4
         kmatch = ef_unspecified_int4

         DO 310 k1 = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)
            IF ( TM_FPEQ(zpt, zaxdat(k1)) ) THEN
               kmatch = k1
               GOTO 320
            ELSE IF ( zpt .GT. zaxdat(k1) ) THEN
               kbot = k1
            ENDIF
  310    CONTINUE

* Check that zpt is not beyond the upper end of the Z-axis range.
         IF ( zpt .GT. zaxdat(zhi) ) THEN
            kbot = ef_unspecified_int4
         ENDIF

  320    IF ( kmatch .NE. ef_unspecified_int4 ) THEN
            kbot = kmatch
            ktop = kmatch
         ELSE IF ( kbot .NE. ef_unspecified_int4 ) THEN
            ktop = kbot + 1
         ELSE
*           zpt outside the grid
            DO 330 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
            DO 330 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
            DO 330 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
            DO 330 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
               result(i,j,k,l,m,n) = bad_flag_result
  330       CONTINUE
*           Go to the next pair of coordinates
            GOTO 690
         ENDIF

         zbot = zaxdat(kbot)
         ztop = zaxdat(ktop)
         IF ( ztop .EQ. zbot ) THEN 
            zfrac = 0.
         ELSE
            zfrac = (zpt - zbot) / (ztop - zbot)
         ENDIF

         n1 = arg_lo_ss(F_AXIS,ARG1)
         DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

         m1 = arg_lo_ss(E_AXIS,ARG1)
         DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

         l1 = arg_lo_ss(T_AXIS,ARG1)
         DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

            i1 = arg_lo_ss(X_AXIS,ARG1)
            DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

*  First interpolate in y, getting values of the fcn at (y,kbot) and (y,ktop)
               fbb = arg_1(i1,jbot,kbot,l1,m1,n1)
               ftb = arg_1(i1,jtop,kbot,l1,m1,n1)
               fbt = arg_1(i1,jbot,ktop,l1,m1,n1)
               ftt = arg_1(i1,jtop,ktop,l1,m1,n1)

               IF ( fbb .NE. bad_flag(ARG1)  .AND.
     .              ftb .NE. bad_flag(ARG1)  .AND.
     .              fbt .NE. bad_flag(ARG1)  .AND.
     .              ftt .NE. bad_flag(ARG1) ) THEN

                  fybot = fbb + yfrac * (ftb - fbb)
                  fytop = fbt + yfrac * (ftt - fbt)

*  Now interpolate in z, getting value at (y,z)
                  result(i,j,k,l,m,n) = fybot + zfrac * (fytop - fybot)

               ELSE

*                 Some component was undefined
                  result(i,j,k,l,m,n) = bad_flag_result

               ENDIF

               i1 = i1 + arg_incr(X_AXIS,ARG1)
 100        CONTINUE

            l1 = l1 + arg_incr(T_AXIS,ARG1)
 400     CONTINUE

            m1 = m1 + arg_incr(E_AXIS,ARG1)
 500     CONTINUE

            n1 = n1 + arg_incr(F_AXIS,ARG1)
 600     CONTINUE

* Only one of the ARG2 and one of ARG3 actually increments
 690     i2 = i2 + arg_incr(X_AXIS,ARG2)
         j2 = j2 + arg_incr(Y_AXIS,ARG2)
         k2 = k2 + arg_incr(Z_AXIS,ARG2)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
         m2 = m2 + arg_incr(E_AXIS,ARG2)
         n2 = n2 + arg_incr(F_AXIS,ARG2)

         i3 = i3 + arg_incr(X_AXIS,ARG3)
         j3 = j3 + arg_incr(Y_AXIS,ARG3)
         k3 = k3 + arg_incr(Z_AXIS,ARG3)
         l3 = l3 + arg_incr(T_AXIS,ARG3)
         m3 = m3 + arg_incr(E_AXIS,ARG3)
         n3 = n3 + arg_incr(F_AXIS,ARG3)

 700  CONTINUE

      RETURN

 999  CALL ef_bail_out (id, err_msg)

      END

	SUBROUTINE GRP_CX_DOC( cx_list, ncx, joint_cx, flags )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* set up joint context and document flags to summarize the contexts
* of one or more variables that will be plotted (or listed) simultaneously
* For example, PLOT U[Z=20],U[Z=50] will place data set and X,Y,T locations
* in cx_plot and set up key_doc to display the Z location
* This routine is called at the start of each fresh (non-overlay) plot

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V200:	  2/2/90
* V230:  7/22/92 - added overlay argument to ADDL_CX_DOC
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
* V685+ *acm* 12/13 For 6D Ferret, the array coming in as flags is longer for extra dimensions

        IMPLICIT NONE
	include	'ferret.parm'

* calling argument declarations
	LOGICAL	flags(0:12)
	INTEGER	ncx, cx_list(ncx), joint_cx

* internal variable declarations
	INTEGER	i, idim

* internal parameter declarations:
        LOGICAL overlay
        PARAMETER ( overlay = .TRUE. )

* initialize the key documentation flags
	DO 100 i = 0, 10
 100	flags(i) = .FALSE.

* the context of the first variable is the starting point
	CALL TRANSFER_CONTEXT( cx_list(1), joint_cx )

* merge the other contexts with it
	DO 200 i = 2, ncx
 200	CALL ADDL_CX_DOC( joint_cx, cx_list(i), .NOT.overlay, flags )

* regridding is always displayed on the key, not the joint context
!	cx_unstand_grid( cx_plot ) = .FALSE.
	RETURN
	END

        SUBROUTINE save_scriptfile_name(name, clen, status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*        Ansley Manke PMEL/TMAP
*        8/2003  (based on save_metafile_name)
**       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

* Put script file name into common, for running with the comand line option
*  ferret -script 

        INCLUDE 'tmap_dims.parm'
        INCLUDE 'errmsg.parm'
        INCLUDE 'tmap_errors.parm'
        INCLUDE 'xprog_state.cmn'
        

* calling argument declarations:
        INTEGER clen, status
#ifdef sun
        BYTE name(clen) 
#else   
        INTEGER*1 name(clen)
#endif  

* Local variable declarations

        CHARACTER TM_INQ_PATH*2048, cbuff*2048, sname*2048

        LOGICAL TM_HAS_STRING
        INTEGER ok, TMAP_status

        CALL tm_ctof_strng(name, sname, clen)
        scriptfile_name(1:clen) = sname

! Save the state, running with -script switch

        its_script = .TRUE.

        IF (TM_HAS_STRING(sname, '.jnl')) THEN
           ok = 1
        ELSE 
           scriptfile_name(clen+1:clen+4) = '.jnl'
           clen = clen + 4
        ENDIF

! See if the file exists

        cbuff = TM_INQ_PATH (scriptfile_name(1:clen), 'FER_GO',
     .                       '.jnl', .TRUE., TMAP_status)

        IF ( TMAP_status .NE. merr_ok ) status = 0


 5000	RETURN
        END

	SUBROUTINE MASKED_DSG_RANGE_SUB ( dset, cx, grid, nfeatures, nobs,
     .                                idim, lo, hi)

* Return the lo and hi range for this coordinate direction after constraints
* applied.  
* V76  4/20 *acm*  Return longitude range using smaller of longitude or lon360

        IMPLICIT NONE

        include 'tmap_dims.parm'
        include 'ferret.parm'
        include 'xcontext.cmn'
        include 'xtm_grid.cmn_text'
        external xgt_grid_data
        include 'xdyn_linemem.cmn_text'
        include 'xdset_info.cmn_text'
        include 'xdsg_context.cmn'

	INTEGER dset, cx, grid, nfeatures, nobs, idim
	REAL	lo, hi

	LOGICAL process_feature(nfeatures), process_obs(nobs), instance_coord
	INTEGER	line, ifeature, iobs, base, fobs, nmasked, nobsf, 
     .		ivar, row_size_lm, coord_lm, count
	REAL    GET_LINE_COORD, low, hig, low360, hig360, coord, bad

* features included in the current masking.  If no constraints, 
* leave lo, hi unchanged.

	CALL MAKE_DSG_FEATURE_MASK(dset, cx, process_feature, nfeatures)
	IF (cx.NE.cx_none .AND. cxdsg_no_coord_constraints) GOTO 5000

	line = grid_line(idim, dsg_xlate_grid(dset))
	IF (line .EQ. mnormal) GOTO 5000

	instance_coord = line_dim(line) .EQ. nfeatures
	
	row_size_lm = dsg_loaded_lm(dsg_row_size_var(dset))
	IF (idim .LT. e_dim) THEN
	   ivar = dsg_coord_var(idim,dset)
	   coord_lm = dsg_loaded_lm(ivar) 
	   bad = cxdsg_bad_val(idim)
	ELSE
	   coord_lm = 0
	   bad = 0
	ENDIF

	low = arbitrary_large_val8
	hig = arbitrary_small_val8
	low360 = arbitrary_large_val8
	hig360 = arbitrary_small_val8

	base = 0     ! obs index at end of preceding feature
	fobs = 0     ! count of masked data in each feature
	count = 0    ! any data in the mask?

	DO ifeature = 1, nfeatures

	   nobsf = dsg_linemem(row_size_lm)%ptr(ifeature)
	   IF (instance_coord) nobsf = 1

	   IF (process_feature(ifeature)) THEN

	      IF (instance_coord) THEN
	         fobs = fobs + 1
		 count = count + 1
		 coord = ifeature
		 IF (idim .LT. e_dim) coord = dsg_linemem(coord_lm)%ptr(fobs)

		 IF (coord .EQ. bad) CYCLE
		 low = MIN(low, coord)
	         hig = MAX(hig, coord)  ! what about ftr_hi
		 IF (idim .EQ. x_dim) THEN
		    IF (coord .LT. 0.) coord = coord+360.
		    low360 = MIN(low360, coord)
	            hig360 = MAX(hig360, coord)
		 ENDIF

	      ELSE

* ... define observation-level mask for this feature

	         CALL MAKE_DSG_OBS_MASK (dset, cx, ifeature, base, 
     .					 process_obs, nobsf)

	         DO iobs = 1, nobsf
	            fobs = fobs+1
		    IF (process_obs(iobs)) THEN

		       count = count + 1
		       coord = dsg_linemem(coord_lm)%ptr(fobs)
		       
		       IF (coord .EQ. bad) CYCLE
		       low = MIN(low, coord)
		       hig = MAX(hig, coord)
		       IF (idim .EQ. x_dim) THEN
		          IF (coord .LT. 0.) coord = coord+360.
		          low360 = MIN(low360, coord)
	                  hig360 = MAX(hig360, coord)
		       ENDIF

	            ENDIF
		 ENDDO  ! iobs

	      ENDIF  ! instance_coord or not
	   
	   ELSE ! process_feature

	      fobs = fobs + nobsf

	   ENDIF ! process_feature
	   base = base + nobsf
	ENDDO

	IF (count .GT. 0) THEN
	   lo = low
	   hi = hig

	   IF (idim .EQ. x_dim) THEN
	      IF (hig360-low360 .LT. hi-lo) THEN
	         lo = low360
		 hi = hig360
	      ENDIF
	   ENDIF

	ENDIF

 5000	RETURN
	END

	SUBROUTINE CD_LOAD_DSET_ATTRS ( dset, cdfid, do_dsg, status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* get attribute information from linked lists, and store in TMAP XDSET_INFO common
* (based on cd_open_dset)

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP
* V600 6/05 *acm* Attribute control.
* V65  *acm* 2/10- all warnings and notes to std error not std out
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files
* V6.83 11/12 *acm* If there are multiple global atts including a 
*                   message attribute, issue the message just once.
* V698  3/16 *acm* Removed Philander-Seigel code including diagnostic variables, 
* pre-defined axes and grids.
* V720 4/17 *sh* identify DSG dataset
* V720 10/17 *acm* Change the NOTE on unknown featuretype. Web search returns 
*                  references to netCDF use of this attribute with values of 
*                  grid, swath, station, fmrc - not CF conventions DSG file
*                  types, but still valid values of the attribute for files. See 
*                  for instance the whole discussion under https://cf-trac.llnl.gov/trac/ticket/113
* V741  6/18 *acm* Apply USE/Feature= for dsg files, if different from native featuretype
*       7/18 *acm* More on use/feature. Allow /FEATURE=none. Use parameters for directions
* V751 8/18 *acm* don't issue a note if the file has featureType="grid"
* V76  1/20 *acm* Orientation of Point-type data set to e_dim
* V745 *acm*  5/20  added mode_dsg to control turning off all DSG ops
* V7.6 *acm* 6/20 Issue 1980: When possible open invalid DSG datasets anyway with NOTES.

* argument definitions:
*       dset    - pointer to TMAP data set
*	status	- return status

* argument declarations:

	LOGICAL	do_dsg
	INTEGER dset, cdfid, status

* include files
        include 'netcdf.inc'
        include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "gt_lib.parm"
#include "tmap_dset.parm"
	include 'xstep_files.cmn_text'
        external xstep_files_data
	include 'xdset_info.cmn_text'
	external xdset_info_data
        include 'xio.cmn_text'
        external xio_data
        include 'xdset_info.cd_equiv'
! kob 7/95
	include 'xsys_names.cmn_text'	            


* local variable declarations:
      INTEGER TM_HASH_NAME, TM_LENSTR1, STR_SAME, STR_CASE_BLIND_COMPARE,
     .        ndims, nvars, ngatts, recdim, cdfstat, 
     .        i, istep, varid, iatt, attlen, attoutflag, maxlen
      CHARACTER    TM_STRING*13, CD_DSG_FEATURENAME*20, name*128, cbuff32*32
      REAL val
      LOGICAL CD_ISIT_EPIC, NC_GET_ATTRIB, got_it, do_warn
      PARAMETER (do_warn = .TRUE. )

#ifdef FORTRAN_90
	INTEGER HEX40
	DATA HEX40/Z'40'/
#endif

* Default contents as per TMAP "Background record"
* if this is a MC data set, we don't want to reset these values
        IF (STR_SAME(ds_type(dset), '  MC') .NE. 0) THEN
		ds_title(dset)		= ' '
		ds_mod_title(dset)	= ' '
		ds_forcing_set(dset)	= ' '
		ds_t0time(dset)		= ' '
		ds_ntegrate_tstep(dset)	= 1
		ds_time_run(dset)	= ' '
		DO 120 i = 1,num_aux
  120		cd_what_isit(i,dset)= ' '
	ENDIF

* time axis
	ds_time_axis(dset) = unspecified_int4

* Load message record
	ds_alert_on_open(dset) 	= .FALSE.
	ds_alert_on_output(dset)= .FALSE.
	ds_message(dset)	= ' '

* save the "record" axis

        CALL NCF_INQ_DS (dset, ndims, nvars, ngatts, recdim )
        ds_time_axis(dset) = recdim

* does it have a (readable) title ?

* get global attribute from linked list structure
* loop through global attributes looking for title, title_mod

	dsg_ragged(dset) = .FALSE.

* get global attribute pseudo-variable id

        IF (ngatts .GT. 0) THEN
           CALL CD_GET_VAR_ID (dset, '.', varid, status)

           DO 100 iatt = 1, ngatts

              name = ' '
              CALL CD_GET_VAR_ATT_NAME( dset, varid, iatt, name, status)

* IF mode DSG is turned off, just don't mark the Dataset as a DSG file.
*
* identify a DSG dataset from its featureType attribute
* ... set dsg_ragged, dsg_feature_type and 
*     Note that dsg_ragged is only provisionally TRUE
*     In cd_dsg_init we check if truly a contiguous ragged dset
              IF (do_dsg .AND. name.EQ.'featureType') THEN

	         IF (dsg_user_direction .EQ. no_dim) THEN 
		    ! they said USE/FEATURE='none'
		    dsg_user_direction = int4_init
		 ELSE
	            dsg_ragged(dset) = .TRUE.   
                    maxlen = 32  ! for cbuff32
		    got_it = NC_GET_ATTRIB ( dset, varid, name, do_warn, 
     .                                   '.', maxlen, attlen, attoutflag, 
     .                                   cbuff32, val)
	            IF     (STR_CASE_BLIND_COMPARE(cbuff32,"timeseries") .EQ. str_match) THEN
	              dsg_feature_type(dset) = pfeatureType_TimeSeries
		       dsg_orientation(dset) = t_dim		! T axis
	            ELSEIF (STR_CASE_BLIND_COMPARE(cbuff32,"profile") .EQ. str_match) THEN
	              dsg_feature_type(dset) = pfeatureType_Profile
		       dsg_orientation(dset) = z_dim		! Z axis
	            ELSEIF (STR_CASE_BLIND_COMPARE(cbuff32,"trajectory") .EQ. str_match) THEN
	               dsg_feature_type(dset) = pfeatureType_Trajectory
		       dsg_orientation(dset) = x_dim		! X axis (arbitrarily)
	            ELSEIF (STR_CASE_BLIND_COMPARE(cbuff32,"point") .EQ. str_match) THEN
	               dsg_feature_type(dset) = pfeatureType_Point
		       dsg_orientation(dset) = e_dim		! E axis 
	            ELSEIF ( (STR_CASE_BLIND_COMPARE(cbuff32,"timeseriesprofile")
     .		           .EQ. str_match)
     .		    .OR.  (STR_CASE_BLIND_COMPARE(cbuff32,"trajectoryprofile")
     .			   .EQ. str_match)                                      )THEN
	               dsg_ragged(dset) = .FALSE.
	               CALL TM_NOTE('FEATURE-TYPE NOT YET IMPLEMENTED: '//cbuff32 , lunit_errors)
	               CALL TM_NOTE('Initializing as a non-DSG dataset', lunit_errors)
	            ELSE
	               dsg_ragged(dset) = .FALSE.
		       IF (STR_CASE_BLIND_COMPARE(cbuff32,"grid") .NE. str_match .AND. do_warn)
     .	                  CALL TM_NOTE("Ignoring non-DSG FeatureType: "//cbuff32 , lunit_errors)
	            ENDIF

c * ?? issue a note?  Could also call WARN_OCCASIONALLY...
c		    IF ( dsg_ragged(dset) ) THEN
c		       cbuff32 = CD_DSG_FEATURENAME(dsg_feature_type(dset))
c		       CALL WARN( 
c     .	                 'Dataset '//ds_name(dset)(:TM_LENSTR1( ds_name(dset) ))//
c     .	                 '  is a Discrete Sampling Geometries (DSG) dataset '//
c     .		                  'of type '//cbuff32(:TM_LENSTR1(cbuff32)) )
c		    ENDIF

* Apply a user-imposed direction SET DATA/FEATURE= if different from the file direction

		    IF (dsg_user_direction .NE. int4_init) THEN
		       IF (dsg_user_direction .EQ. dsg_orientation(dset) ) THEN
		          dsg_user_direction = int4_init
		       ELSE
		          dsg_orientation(dset) = dsg_user_direction
		          IF (dsg_orientation(dset) .GE. pfeatureType_Trajectory .AND.
     .		              dsg_orientation(dset) .LE. pfeatureType_Point)
     .		           dsg_feature_type(dset) = dsg_orientation(dset)
		       ENDIF
		    ENDIF
	      
	         ENDIF  ! dsg_user_direction set to no_dim

	      ENDIF


* *kob* 6/96 - don't do this if we have a mc dataset - title comes
*	       from the descriptor rather than the cdf file

              IF (STR_SAME(ds_type(dset), '  MC') .NE. 0) THEN
                 maxlen = LEN(ds_title(dset))
                 IF (name .EQ. 'title' .OR. name .EQ. 'TITLE')
     .              got_it = NC_GET_ATTRIB ( dset, varid, name, do_warn, 
     .                 '.', maxlen, attlen, attoutflag, ds_title(dset), 
     .                 val)
              ENDIF

* title modifier ?
* !! 4/17 comment: should be using STR_CASE_BLIND_COMPARE: e.g. "Title_mod" should match
              maxlen = LEN(ds_mod_title(dset))
               IF (name .EQ. 'title_mod' .OR. name .EQ. 'TITLE_MOD')
     .           got_it = NC_GET_ATTRIB ( dset, varid, name, do_warn, 
     .              '.', maxlen, attlen, attoutflag, 
     .              ds_mod_title(dset), val)
     
* does it have a message to display upon opening ?
              ds_alert_on_output(dset) = .FALSE.
              maxlen = LEN(ds_message(dset))
              IF (name .EQ. 'message' .OR. name .EQ. 'MESSAGE')
     .           ds_alert_on_open(dset) = NC_GET_ATTRIB ( dset, varid, 
     .                    name, do_warn, '.', maxlen, attlen, 
     .                    attoutflag, ds_message(dset), val)
  
* holler the message
              IF ( ds_alert_on_open(dset) ) THEN
	         CALL TM_NOTE('regarding '//
     .	   	   ds_des_name(dset)(:TM_LENSTR1(ds_des_name(dset)))
     .		   //' ...', lunit_errors)
	         CALL TM_NOTE(ds_message(dset), lunit_errors)
		 ds_alert_on_open(dset) = .FALSE.  ! Don't keep hollering for all global atts.
              ENDIF
 100       CONTINUE

        ENDIF  ! ngatts gt 0


* For non-DSG datasets, did they set a /Featuretype?
        IF (.NOT.dsg_ragged(dset) .AND. dsg_user_direction.NE.int4_init) THEN
           CALL WARN ('SET DATA/FEATURE= applies only to '//
     .           'Discrete Sampling Geometries datasets. Ignoring /FEATURE=')
           dsg_user_direction = int4_init
	ENDIF


* special TMAP parameters ?
* ... read global attributes beginning with "TMAP"

* Default contents as per TMAP "Format record" (is it EPIC? 3/93)
* -kob- only set ds_type to cdf if it isn't already set to MC 7/95

        IF ( ds_des_name(dset)(1:7) .EQ. 'http://') THEN
           ds_type(dset) = 'CDF'
        ELSEIF ( CD_ISIT_EPIC(dset, status) ) THEN
           ds_type(dset) = 'ECDF'
        ELSEIF ( ds_type(dset) .NE. '  MC' ) THEN
           ds_type(dset) = 'CDF'
        ENDIF
	ds_format(dset)	= '  1A'

* "unique" 2 letter code for this data set
        ds_prog_rev(dset) = ' '
        i = TM_HASH_NAME( ds_name(dset), 26*26-1 )
#ifdef FORTRAN_90
        ds_prog_rev(dset)(1:1) = CHAR( IOR(HEX40,i/26 + 1  ) )
        ds_prog_rev(dset)(2:2) = CHAR( IOR(HEX40,MOD(i,26) + 1 ) )
#else
        ds_prog_rev(dset)(1:1) = CHAR( IOR('40'X,i/26 + 1  ) )
        ds_prog_rev(dset)(2:2) = CHAR( IOR('40'X,MOD(i,26) + 1 ) )
#endif
* Allocate a "step file" slot to save CDF id and filename
* Find the next storage position for stepfiles in common
* only if the file is not a multi-file netcdf dataset
        IF (STR_SAME(ds_type(dset), '  MC') .NE. 0) THEN
c commented out diagnostic write statements
c	  write(6,*) 'sf_setnum......',sf_setnum(1)
c	  write(6,*) 'set_not_open...',set_not_open
          DO 190 istep = 1,maxstepfiles
            IF (sf_setnum(istep) .EQ. set_not_open) GOTO 200
 190      CONTINUE
* No room left for new stepfiles
          GOTO 5200

 200      sf_lunit ( istep ) = cdfid
          sf_setnum( istep ) = dset
          sf_name  ( istep ) = ds_des_name(dset) 
          cd_stepfile( dset ) = istep    ! step file containing desired data
          ds_open  ( dset )   = istep    ! which step file is currently open
	ENDIF

* successful completion
	status = merr_ok
	RETURN

* error messages
 5100   CALL TM_ERRMSG
     .     ( cdfstat+pcdferr, status, 'CD_OPEN_DSET', cdfid,
     .        no_varid, 'is this a CDF file ?', no_errstring, *5900 )

 5150   CALL TM_ERRMSG
     .     ( cdfstat+pcdferr, status, 'CD_OPEN_DSET', cdfid,
     .        no_varid, 'Unable to access remote URL', no_errstring,
     .		*5900 )

 5200   CALL TM_ERRMSG ( merr_filim, status, 'CD_OPEN_DSET',
     .                     dset, no_stepfile,
     .                     'MAX='//TM_STRING(DBLE(maxstepfiles)),
     .                     no_errstring, *5900)

*kob* 9/18
 5300  CALL TM_ERRMSG (merr_notmounted,status, 'CD_OPEN_DSET',dset,
     .                     no_stepfile,
     .                    'No files on-line from data set',
     .			   no_errstring,
     .                     *5900)
* erase any record of tampering with this data set
 5900   CALL TM_CLOSE_SET( dset, i )

* error exit
	RETURN
	END

      SUBROUTINE set_levels_shade_fill (status)
	
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* V630  *acm* 9/09 Introduction of syntax for variance-based and histogram levels
* V631  *acm*10/09 Fix bug 1704: LEVELS=xD was incorrect.
* V663  *acm* 5/10 Fix bug 1744: hang if /LEVELS=v and all missing data.
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus
* V697 *acm* 12/15 Fix ticket 2326: single level plus (inf) and/or (-inf)
* V698 *acm*  2/16 Send info that the levels are from a histogram to setlab_syms
* V720 *acm*  7/17 Ticket 2250: small-valued data caused an error computing number
*                  of interval-edges NLEV2
* V740 *acm*  2/18 Tweak for issue 1858: labels on contour lines for auto-generated 
*                  integer levels got unneeded digit after decimal point
* V74+  *acm* 3/18 Issue 1607.  /KEY=centerlab
*         For centered labels draw the plot so that the levels are describing 
*         the middle of the colors not the contour lines between colors.
*         Interpolate /LEVELS values to obtain new edge-values for the contours
*         and patch-edges

	include		'parampl5_dat.decl'
	include		'PARAMPL5.DAT'
	include		'axis_inc.decl'
	include		'AXIS.INC'
	include		'plt_inc.decl'
	include		'PLT.INC'
	include		'miss_inc.decl'
	include		'MISS.INC'
	include		'hd_inc.decl'
	include		'HD.INC'
	include		'cont_inc.decl'
	include		'CONT.INC'
        include         'errmsg.parm'
        include         'shade_vars.cmn'
	
* argument declarations
	INTEGER		status

* local declarations
	REAL		dz, fm, znp, zmp, dzmax, del
	INTEGER		m, jj
        LOGICAL		TM_FPEQ_SNGL, isinf, redo

        EXTERNAL range

	status = ferr_ok
	lev_str = 'none'
	IF (USE_HIST) lev_str = 'histogram'

	znp = 0.
	zmp = 0.
C       
C       IAUTOC = 1 means: compute levels from input data and number
C                         of levels

	IF (IAUTOC.EQ.1) THEN

	   IF (ZMIN.EQ.ZMAX) THEN

C             NLEV2=0 is the code in pplmod_plotz
	      NLEV2=1
              zlev(1) = zmin

	   ELSE IF (ZMIN .GT. CMZGE .AND. ZMAX .LE. CMZLE) THEN  ! all missing

C             NLEV2=0 is the code in pplmod_plotz
	      NLEV2=1
              zlev(1) = zmin

	   ELSE
C       
C       If set_delta is .true. the delta value has been set
C       elsewhere and we should calculate the max and min values
C       of the range based on this delta.
C       (This portion stolen from RANGE)

	      if (set_delta) then 

		 dz = delta
C       
C       CALCULATE THE MINIMUM VALUE OF THE RANGE
C       
		 FM = (zmin) / DZ
		 M = IFIX(FM)
		 IF (FM .LT. 0.0) M = M - 1
		 znp = DZ * FLOAT(M)
C       
C       CALCULATE THE MAXIMUM VALUE OF THE RANGE.
C       
		 FM = (zmax) / DZ
		 M = IFIX(FM)
		 IF(FM .GT. 0.0)M = M + 1
		 zmp = DZ * FLOAT(M)
C
C       Set levels centered about zero if centered is .true.
C
	         if (centered) then
		    if (abs(znp) .gt. abs(zmp)) then
		       zmp = -znp
		    else
		       znp = -zmp
		    endif
	         endif

C INTEGER based levels
	      else if (intlev.EQ.1) then 

		 znp = FLOOR(zmin)
		 zmp = CEILING(zmax)
C
C       Set levels centered about zero if centered is .true.
C
	         if (centered) then
		    if (abs(znp) .gt. abs(zmp)) then
		       zmp = -znp
		    else
		       znp = -zmp
		    endif
	         endif

	         dz = (zmp - znp)/nlev

		 if (dz.lt.1) then
		     dz = 1
		     i = 1
		     do il = FLOOR(znp),FLOOR(zmp)+1
		        zlev(i) = FLOAT(il)
			i = i+1
		     enddo
		     nlev2 = zmp-znp+2

		  else
		     dz = INT(dz)
		     zz = znp
		     i = 1
		     do while (zz.le. zmp)
		        zlev(i) = zz
			zz = zz + dz
			i = i+1
		     enddo
		     zlev(i) = zz
		     nlev2 = i
		  endif

c       Set THE MINIMUM AND MAXIMUM VALUE OF THE RANGE
		  znp = zlev(1)
		  zmp = zlev(nlev2)

c       Shift the color levels for centered-label key.

		  IF (center_key_labels) CALL SET_LEVELS_CENTERKEY (.TRUE.)

	      else if (openlev) then
	         CALL set_open_levels

C       Else we should allow RANGE to determine the max and min range
C       values and also the appropriate delta value. (ZNP, ZMP, DZ)

	      else

	         znp = zmin
	         zmp = zmax
	         if (centered) then
		    if (abs(znp) .gt. abs(zmp)) then
		       zmp = -znp + zmean
		    else
		       znp = -zmp + zmean
		    endif
	         endif
		 CALL RANGE(znp,zmp,NLEV,ZNP,ZMP,DZ)

	      endif

              IF (.NOT.openlev) THEN

* nlev2 is 1 more than the # of intervals; it is the edges of the intervals, i.e. 
* upper-limit of the uppermost interval minus the lower-limit of the low cell, 
* and then add 1.5 for correct roundoff.

	      NLEV2 = (ZMP-ZNP)/DZ + 1.5

c *acm* 4/08 Set jj as in plotz

              IF (TM_FPEQ_SNGL((ZNP + DZ*(NLEV2-1)), ZMP) .EQV. .FALSE.) THEN
                 IF (ZNP + DZ*(NLEV2-1) .LT. ZMP) NLEV2 = NLEV2 + 1
	      ENDIF

	      IF (ZMP-ZNP .EQ. 0) THEN
                 JJ=NSIGC
              ELSE
                 JJ=NSIGC-IFIX(ALOG10(ABS(ZMP-ZNP))+.5)
              ENDIF
c  Auto-generated integer levels? No need for digits after decimal pt
	      IF (DZ - IFIX(DZ) .EQ. 0.) JJ = 0 
              IF (JJ.LE.0) JJ=-1

c *acm* 3/04 under g77 on linux this incorrectly uses
c            low-order bits to reset NLEV2 example:
c             yes?shade/lev=c {-1.1, 1.1}* ysequence({1,1})

c       4/04  But, dont just skip this, use TM_FPEQ_SNGL to see if
c             values are equal... 
c       4/04  Also fix the negative-range case.

	      IF ( (ZNP + DZ*(NLEV2-1) .LT. ZMP) .AND. 
     .              .NOT. TM_FPEQ_SNGL(ZNP + DZ*(NLEV2-1), ZMP) ) THEN
		 NLEV2 = NLEV2 + 1
	      ENDIF

              IF (NLEV2 .GT. ICNLEV) GO TO 5000

C acm 12/01  Set LWGT for future contour line overlays.

	      DO 100 I=1,NLEV2 

                 LWGT(I)=2
                 LDIG(I)=-1
                 ZLEV(I)=ZNP+DZ*FLOAT(I-1)
                 IF (ABS(ZLEV(I)).LT.1.E-5*DZ) GOTO 100
                 IF (ZLEV(I).GT.0.) THEN
                    LWGT(I)=1
                 ELSE
                    LWGT(I)=3
                 END IF
                 LDIG(I)=JJ


 100	      CONTINUE 

              endif  ! openlev

	   ENDIF

	   
	   IF (center_key_labels) CALL SET_LEVELS_CENTERKEY (.TRUE.)


C       
C       Else IAUTOC != 1 means: use supplied levels
C       

C       
	ELSE  ! iautoc = 0

C	FIND MIN AND MAX as in lev.F from the Z levels.

	   DMIN=ZLEV(1)
	   IF (neginf) DMIN = ZLEV(2)
	   DMAX=DMIN
           DZMAX = 0.
	   DO 110 I=2,NLEV
	      IF(ZLEV(I).GT.DMAX)DMAX=ZLEV(I)
	      IF(ZLEV(I).LT.DMIN)DMIN=ZLEV(I)
              DZ = ZLEV(I)-ZLEV(I-1)
              IF (DZ .GT. DZMAX) DZMAX = DZ
110        CONTINUE

	   znp = dmin
	   zmp = dmax

	   isinf = (neginf .OR. posinf)
	   IF (.NOT.isinf .AND. (DMIN.EQ.DMAX)) THEN
c	      NLEV2=0
	      NLEV2=1
	   ELSE
	   
	   IF (openlev) THEN
	      CALL set_open_levels
	   ELSE
	      NLEV2=NLEV
              IF (neginf) zlev(1) = MIN( zlev(1), zmin-1. )

c       Shift the color levels for centered-label key.

              IF (center_key_labels) THEN
	         CALL SET_LEVELS_CENTERKEY (.TRUE.)
		 nlev = nlev2
	      ENDIF

              IF (posinf .AND. .NOT.center_key_labels) zlev(nlev) = MAX (zlev(nlev), zmax+1. )

	      IF (posinf .AND. neginf .AND. NLEV.EQ.3) THEN
	         nlev = 2
		 nlev2 = 2
	      ENDIF

C Compute the digits in the contour levels, and line characteristics
C these will not have been set before on, say a previous SHADE plot
C 8/07 ACM. Do this computation only for auto-level setting. If the user
C      has set levels, this is already done (and the values are different).

              IF (iautoc .EQ. 1) THEN
                 znp = dmin
                 zmp = dmax
                 dz = 0
                 IF (set_delta) THEN
                    dz = delta
	            IF (ZNP + DZMAX*(NLEV2-1) .LT. ZMP) NLEV2 = NLEV2 + 1
                 ENDIF

	         IF (ZMP-ZNP .EQ. 0) THEN
                    JJ=NSIGC
                 ELSE
                    JJ=NSIGC-IFIX(ALOG10(ABS(ZMP-ZNP))+.5)
                 ENDIF
                 IF (JJ.LE.0) JJ=-1

                 IF (NLEV2 .GT. ICNLEV) GO TO 5000

	         DO 106 I=1,NLEV2
		    LWGT(I)=2
		    LDIG(I)=-1
		    IF (ABS(ZLEV(I)).LT.1.E-5*DZMAX) GOTO 106
                    IF ( TM_FPEQ_SNGL( ABS(ZLEV(I)) ,0.) ) GOTO 106
		    IF (ZLEV(I).GT.0.) THEN
		       LWGT(I)=1
		    ELSE
		       LWGT(I)=3
		    END IF
		    LDIG(I)=JJ
 106	         CONTINUE
   
	      ENDIF
	   ENDIF

        ENDIF  ! openlev
	END IF

! Set ldig: If this is a contour plot, there may have been a 
! PPL CONSET which needs to be applied.

	If (NEWSIG.GT.0) then
	IF (ZMP-ZNP .EQ. 0) THEN
	   JJ=NSIGC
	ELSE
	   JJ=NSIGC-IFIX(ALOG10(ABS(ZMP-ZNP))+.5)
	ENDIF
	IF (JJ.LE.0) JJ=-1

	DO 107 I=1,NLEV2
	   LDIG(I)=-1
	   IF ( TM_FPEQ_SNGL( ABS(ZLEV(I)) ,0.) ) GOTO 107
	   LDIG(I)=JJ
 107	CONTINUE
	endif

* Now that the levels are set, create the LEVELS symbols

        CALL setlab_syms (ZLEV, MAX(NLEV2,1) )

	RETURN
 5000   status = ferr_out_of_range
        RETURN

	END

	SUBROUTINE DO_AUX_VAR_REGRID_2D_TF(
     .				           src,  msrc,  src_cx,
     .				           dst,  mdst,  dst_cx,
     .				           tsrc, mtsrc, tsrc_cx,
     .					   ldst_min, ldst_max ) 

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* perform a 1D t-axis "orthoganalization" regrid guided by an
* auxiliary variable containing a 2D array of time steps
* allow for the usual Ferret promotion of point axes to match span axes
* where either the source data or the position field may have degenerate axes
* (typically the position array will be degenerate in Z and E) 

* This code copied/modified from do_aux_var_regrid_1d_z.F

* V695+ 3/15 *sh*
* V698  3/16 *sh* - compute f_delta from the time2d field rather than F axis
*                   allowing the F axis to be redefined
* V702 1/17 *sh* for trac enhancement #2369 -- dynamic memory management 

        IMPLICIT NONE
        include 'tmap_dims.parm'
        include 'errmsg.parm'
	include	'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xtm_grid.cmn_text'   ! for line_delta
	
* calling argument declarations:
	INTEGER	axis,
     .		msrc, mdst, mtsrc, src_cx, dst_cx, tsrc_cx,
     .		ldst_min, ldst_max
        REAL    src ( m4lox:m4hix,m4loy:m4hiy,m4loz:m4hiz,
     .                m4lot:m4hit,m4loe:m4hie,m4lof:m4hif ),
     .          dst ( m5lox:m5hix,m5loy:m5hiy,m5loz:m5hiz,
     .                m5lot:m5hit,m5loe:m5hie,m5lof:m5hif ),
     .          tsrc( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .                m1lot:m1hit,m1loe:m1hie,m1lof:m1hif )


* internal variable declarations:
        INTEGER CX_DIM_LEN,
     .          idim,
     .          i,   j,   k,   l,   m,   n,
     .          is,  js,  ks,  ls,  ms,  ns,
     .          si0, sj0, sk0, sl0, sm0, sn0,
     .          dsi, dsj, dsk, dsl, dsm, dsn,
     .		ip,   jp,  kp,       mp
        INTEGER CGRID_AXIS,
     .		ndst_min, ndst_max, dgrid,
     .		lsrc_min, lsrc_max, lsrc_start, lsrc_end, ldst_start, ldst_end,
     .		nsrc_min, nsrc_max, nsrc0, lsrc0, f_axis, l_per_n, ldst0
        REAL    tsrc_min, tsrc_max, t_target, f_delta, t_delta
        REAL*8  TM_WORLD, depsilon
* internally declared work arrays
	REAL*8	tdst(ldst_min:ldst_max)

* equivalence conveniences
* "inc" is the increments for each axis of each component
* "lo"  is the starting subscript (minus 1) for each axis of each component
* "s" is the source data (src)
* "p" (tsrcition) is the time steps of the source data ==> the 2D array
* "d" indicates the delta increment
* "0" indicates the start (lo) index
        INTEGER srcinc(nferdims), srclo(nferdims)
        EQUIVALENCE
     .	    (srcinc(1),dsi), (srcinc(2),dsj), (srcinc(3),dsk),
     .	    (srcinc(4),dsl), (srcinc(5),dsm), (srcinc(6),dsn),
     .	    (srclo(1), si0), (srclo(2), sj0), (srclo(3), sk0),
     .	    (srclo(4), sl0), (srclo(5), sm0), (srclo(6), sn0)

*==========================

* initialize
* nicer names for key index limits
	dgrid   = cx_grid(dst_cx)
	ndst_min    = cx_lo_ss(dst_cx,f_dim)  ! lowest forecast axis index
	ndst_max    = cx_hi_ss(dst_cx,f_dim)  !  hiest forecast axis index
	lsrc_min = cx_lo_ss(src_cx,t_dim) ! l index min in source data
	lsrc_max = cx_hi_ss(src_cx,t_dim) ! l index max in source data
	nsrc_min = cx_lo_ss(src_cx,f_dim)
	nsrc_max = cx_hi_ss(src_cx,f_dim)

* auxiliary TIME field is 2D on T-F so set up static indices for other axes
	ip = cx_lo_ss(tsrc_cx,x_dim)
	jp = cx_lo_ss(tsrc_cx,y_dim)
	kp = cx_lo_ss(tsrc_cx,z_dim)
	mp = cx_lo_ss(tsrc_cx,e_dim)

* f_delta is the time lag between forecasts.
* It should be consistent in tsrc and should match the delta of the F lag axis
! 3/16 -- do not get it from the F axis, since the user may alter that
!	f_axis = CGRID_AXIS(f_dim, dst_cx)
!	f_delta = line_delta(f_axis)
	f_delta = (tsrc(ip,jp,kp,m1lot,mp,m1hif)
     .	         - tsrc(ip,jp,kp,m1lot,mp,m1lof))
     .		                   / (m1hif-m1lof+1)

* max insignificant time difference
        depsilon = (2.0**(-42)) * ABS(f_delta)

* extract the time step values of the destination
	DO l = ldst_min, ldst_max
	   tdst(l) = TM_WORLD(l, dgrid, t_dim, box_middle)
	ENDDO

* no source data overlapping with requested dest times?  Then quit here
       IF ( (tdst(ldst_min) - tsrc(ip,jp,kp,lsrc_max,mp,nsrc_max)) .GT. depsilon
     . .OR. (tsrc(ip,jp,kp,lsrc_min,mp,nsrc_min) - tdst(ldst_max)) .GT. depsilon )
     .								RETURN
* number of time steps before the start of the next forecast
	t_delta = (tsrc(ip,jp,kp,m1hit,mp,m1lof)
     .	         - tsrc(ip,jp,kp,m1lot,mp,m1lof))
     .		                   / (m1hit-m1lot+1)
* ... for irregular monthly time steps, t_delta is approximate
	l_per_n = INT(f_delta/t_delta + 0.5)

* compute the delta increment for each axis
* this allows "promotion" of degenerate axes
        DO 10 idim = 1, nferdims
           IF ( CX_DIM_LEN(idim,src_cx) .EQ. 1 ) THEN
              srcinc(idim) = 0
           ELSE
              srcinc(idim) = 1
           ENDIF
 10     CONTINUE

* compute the starting subscript for each axis of each component
* used below through equivalence relationship
* pre-decrement by 1 delta for looping ahead)
        DO idim = 1, nferdims
	   srclo(idim) = cx_lo_ss(src_cx,idim) - srcinc(idim)
	ENDDO

* the relationship between the time steps in the 2D aux time field (cx1)
* and the same times in the destination field looks something
* like this

*          **  2d aux times    **  ==>   ** cal-T x lag-F field **

*   12  1011(0)   1015(1)   1019(2)        1019(2) 1019(3) 1019(4)     20
*   11  1010(0)   1014(1)   1018(2)        1018(2) 1018(3) 1018(4)     19
*   10  1009(0)   1013(1)   1017(2)        1017(2) 1017(3) 1017(4)     18
*    9  1008(0)   1012(1)   1016(2)        1016(2) 1016(3) 1016(4)     17
*    8  1007(0)   1011(1)   1015(2)        1015(1) 1015(2) 1015(3)     16
*    7  1006(0)  >1010(1)   1014(2)        1014(1) 1014(2) 1014(3)     15
*    6  1005(0)   1009(1)   1013(2)        1013(1) 1013(2) 1013(3)     14
*    5  1004(0)   1008(1)   1012(2)        1012(1) 1012(2) 1012(3)     13
*    4  1003(0)   1007(1)   1011(2)        1011(0) 1011(1) 1011(2)     12
*    3  1002(0)   1006(1)   1010(2)        1010(0) 1010(1) 1010(2)     11
*    2  1001(0)  >1005(1)   1009(2)        1009(0) 1009(1) 1009(2)     10
*    1  1000(0)   1004(1)   1008(2)        1008(0) 1008(1) 1008(2)      9
*    ^                                                                  ^
*    |                                                                  |
* l in src_cx                                                     l in dst_cx 

* ">" above indicate a requested time range of T=1005:1010

* strategy for reorganizing the data:
*   - initialize by finding the last forecast (highest N index) which
*     contains the starting destination time requested.  Call this nsrc0
*   - loop over the destination time axis.
*     count when F-delta advances occur.  When they occur, advance to  
*     next nsrc0
*   - at each time, loop over the F axis,
*        start by copying nsrc0 source into n=1
*        advance to n=2,3, ... keeping T constant by incrementing L forward
*        at each consecutive forecast by an amount delta-F

* find the highest source N index at which lowest destination time can be found
	DO ldst0 = ldst_min, ldst_max
	   t_target = tdst(ldst0)
	   DO nsrc0 = cx_hi_ss(tsrc_cx,f_dim),cx_lo_ss(tsrc_cx,f_dim), -1
              IF ( (tsrc(ip,jp,kp,lsrc_min,mp,nsrc0) - t_target) .LE. depsilon ) THEN
	         DO lsrc0 = lsrc_min,lsrc_max
                    IF ( ABS(tsrc(ip,jp,kp,lsrc0,mp,nsrc0) - t_target) .LE. depsilon ) THEN
	               GOTO 50
	            ELSEIF  (tsrc(ip,jp,kp,lsrc0,mp,nsrc0) .GT. t_target) THEN
	               CALL WARN('1D time axis of FMRC contains time'//
     .			         ' not in forecast collection'//pCR//
     .				 'Results may not be correct.')
	               GOTO 50
	            ENDIF
	         ENDDO
	      ENDIF
	   ENDDO
* ... the time t_target does not exist in this forcast
	ENDDO
* can never get here: no overlap between source and destination time ranges
	STOP 'do_aux_ver_regrid_2d_tf'

* determine where we are starting on the l_per_n cycle
! 50	n = AMOD(t_target, f_delta) / t_delta + 1
 50	lsrc0 = lsrc0 - 1

******************************************************************
	DO l = ldst0, ldst_max         ! ***** T-cal loop  ******

* advance to the next forecast for pulling from the source data
* (do not do this on initial entry -- everything set properly initially)
	 IF (l.GT.ldst0 .AND. MOD(ls,l_per_n).EQ.0) THEN
	   nsrc0 = nsrc0 + 1
	   lsrc0 = lsrc_min - 1
	 ENDIF

	 lsrc0 = lsrc0 + 1
	 ls = lsrc0
	 ns    = nsrc0
	 n     = 1

	 DO WHILE (n<=ndst_max)          ! ***** N-lag loop *****

* this IF allows i) user N limits to exclude low n values
*           and ii) copying the ragged high end of the FMRC block
	   IF (n  .GE. ndst_min
     .   .AND. ns .LE. nsrc_max) THEN

* copy the src data to the destination array -- loop over its  X,Y,Z,E range
* the 's' variables are source array indices
	     is = si0
	     DO 1000 i = mr_lo_s1(mdst), mr_hi_s1(mdst)
	      is = is + dsi

	      js = sj0
	      DO 1000 j = mr_lo_s2(mdst), mr_hi_s2(mdst)
	       js = js + dsj

	       ks = sk0
	       DO 1000 k = mr_lo_s3(mdst), mr_hi_s3(mdst)
	        ks = ks + dsk

	         ms = sm0
	         DO 1000 m = mr_lo_s5(mdst), mr_hi_s5(mdst)
	          ms = ms + dsm

	          dst(i,j,k,l,m,n) = src(is,js,ks,ls,ms,ns)

 1000	     CONTINUE
	   ENDIF

* set up for same destination time taken from the previous forecast
	   n = n + 1
	   ns = ns - 1
	   ls = ls + l_per_n 
	   IF (ns.LT.nsrc_min .OR. ls.GT.lsrc_max) EXIT
	 ENDDO     ! N loop

	ENDDO     ! L loop

* successful completion.  Clean up.
        CALL RELEASE_DYN_WORK_SPACE    ! ?? needed ??
        RETURN

* error exit
 5000	RETURN
	END

c***********************************************************************
c...NOBS.....Based on gausswt, return only the # of obs in (x,y) gridbox
c............method is to call this sub for each data value
c............all calcs done in gridbox units
c............xx/x1/xf all in same units
c............yy/y1/yf all in same units

c  i	xx,yy,tt=x/y/t location of data pt (data units)
c  i	nx,ny,nt=size of grids
c  i	xaxlo,xaxyi, etc bounds of destination grid cells
c  o 	obs(nx,ny,nt) number of obs in each (x,y,t) gridbox
c--------------------------------------------------------------------------

	SUBROUTINE nobsxytv (obs_only, xx, yy, tt, vv, nx, ny, nt, 
     .             xaxlo,xaxhi, yaxlo,yaxhi, taxlo,taxhi, indx, obs)


* Argument declarations

        INTEGER nx, ny, nt, obs_only, indx(4,2)
	REAL xx, yy, tt, vv, xaxlo(*), xaxhi(*), 
     .       yaxlo(*), yaxhi(*), taxlo(*), taxhi(*), obs(nx,ny,2,nt)

* Local variable declarations

        INTEGER ig, jg, Lg

	lg = 1
	DO l = 1, nt
	   IF (tt.GE.taxlo(lg) .AND.
     .         tt.LT.taxhi(lg)) THEN
              jg = 1
	      DO j = 1, ny
		 IF (yy.GE.yaxlo(jg) .AND.
     .	             yy.LT.yaxhi(jg)) THEN
                    ig = 1
		    DO i = 1, nx
		       IF ( xx.GE.xaxlo(ig) .AND.
     .                      xx.LT.xaxhi(ig)) THEN

		          IF (obs_only .EQ. 0) THEN
		             obs(ig,jg,1,Lg) = obs(ig,jg,1,Lg) + vv
		             obs(ig,jg,2,Lg) = obs(ig,jg,2,Lg) + 1.
		          ELSE
		             obs(ig,jg,1,Lg) = obs(ig,jg,1,Lg) + 1.
		             ENDIF

* Store the min and max index used in this cruise
		             indx(1,1) = MIN(indx(1,1), ig)
		             indx(1,2) = MAX(indx(1,2), ig)
		             indx(2,1) = MIN(indx(2,1), jg)
		             indx(2,2) = MAX(indx(2,2), jg)
		             indx(4,1) = MIN(indx(4,1), Lg)
		             indx(4,2) = MAX(indx(4,2), Lg)
		       ENDIF !xx in grid box
		       ig = ig + 1
		    ENDDO  ! nx

		 ENDIF !yy in grid box
		 jg = jg + 1
	      ENDDO  ! ny

	   ENDIF !tt in grid box
	   lg = lg + 1
	ENDDO  ! nt

	RETURN
	END

	SUBROUTINE GET_PROT_CMND_DATA (  dflt_cx, dtype, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* "get protected command data"
* calculate grid(s) of data based on the expression given or implied.
* Expression(s) are in user-variable (uvar) structures.
* Implied expression is left from last command
* when done - return with the variables still "protected" (flagged as in use)

* a sample command may look like:
*	prompt> CONTOUR/Z=50 TEMP[X=160E:160W]
* the "Z=50"		is a "command  qualifier" or "command  context modifier"
* the "X=160E:160W"	is a "variable qualifier" or "variable context modifier"

* contexts are transferred, modified and used in the following manner:
*   i)	skeletal context ( without grid-related info.) is specified in the call
*	Usually it is based on SET REGION,DTA_SET,etc. ( cx_last )
*  ii)	this context is modified by the command qualifiers given to produce a 
*	new skeletal context to be used for the evaluation of the current 
*	command ( cx_cmnd )
*  iii)	as the expression is evaluated each variable, as it is encountered,
*	begins with cx_cmnd and modifies it by the variable
*	qualifiers to produce the context at which the variable is to be
*	evaluated.

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V230: 7/27/92 - new routine based on GET_CMND_DATA with the unprotecting
* of variables removed to a separate routine
*  (revision history for GET_CMND_DATA shown here)

*   rev 0.0 - 6/17/86
*   rev 1.0 - 1/5/87  - multiple variables in a single expression may be
*			   evaluated and pointers returned in COMMON/XCONTEXT
*   rev 2.0 - 1/5/87  - evaluations done on the INTERPRETATION STACK.  User-
*			   defined variables introduced
*   rev 2.1 - 9/16/87 - added get_cx_only to calling sequence
*			   and unknown_qual_ok moved to FERRET.PARM
*   rev 2.2 - 9/22/87 - shortened code using GET_NEW_cx
*   rev 2.3 - 9/30/87 - added mr_perm_prot
*   rev 2.4 - 7/26/88 - don't pass unstand_grid to last context
*   V200:  5/18/89 - don't pass context on to next command
*	  	   - initialize grid stack pointer
*          8/19/91 - explicit SAVE statement for last expression buffer
* V312: 5/94 - array "memory" as a calling argument
* 12/96 *kob* - Linux Port - had to move variable assignments off of
*               declaration line. used DATA statment rather than a
*	        PARAMETER statement because laslen was modified in code
*	      - Linux F90 doesn't allow SAVE statement, so put an ifdef
*		check around it 
* V500:  1/99 - allowing strings in quoble quotes requires fix to quote
*		handling as in LIST "hello"
*		Added call to ALL_1_ARG
* V530: *sh* 9/00 - added data type ad an argument
*		  - increased size of "last" stored command
* V540: *sh* 11/00 - "last" var init moved to DELETE_OLD_EXPR
* v552: *acm* 4/03   Increase length of variable names to 128 characters
* V600 *acm* 3/06  fixing bugs 439&1390, new arg to get_new_cx.
* V690 *sh* 12/13  manage auto-curvilinear mode
*	           aux vars returned on the ISP stack in frame above is_aux_ptr
* V693+ *sh* 2/15  eliminate inconsistent treatment of surrounding quotes
*                  as seen in err694_inconsistent_quotes.jnl
* V698 *acm*  3/16 Ticket 2278: add an attribute with time range when
*                  saving a modulo-regridded variable to netCDF
* V702 *acm* 11/16 Ticket 2489: Do not try to add the attribute when
*                  it's an expression instead of a user-defined variable
*		   - And trac enhancement #2369 -- dynamic memory management 
* V702 *sh*  3/17 Dynamic memory

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'interp_stack.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
	include 'xfr_grid.cmn'
        include 'xtra_compute_attr.cmn'
        include 'netcdf.inc'

* calling argument declarations
	INTEGER	dflt_cx, dtype, status

* local variable declarations
	LOGICAL		auto_auxvar_changed
	INTEGER		TM_LENSTR1, STR_SAME, nu, cx_expr, idim
	CHARACTER	EXPR_NAME*8, VAR_CODE*128, buff*128

	INTEGER		cat, var, dset, varid, attid, attype, attlen, attoutflag
	REAL		dummy
	CHARACTER SANITARY_VAR_CODE*128, varcode*128

* initialize grid stack pointer (pushes down from top)
	grd_stk_ptr = max_grids

* initialize aux stack frames at top of isp stack
	max_usable_intrp = max_intrp
	max_context = max_noframe_context  ! just to be clear (not needed)

* initialize memory usage diagnostic
	completed_args_mem = 0
	nsplits = 0

* determine if in auto-curvilinear mode
	CALL SET_AUTO_CURVI_MODES( auto_auxvar_changed )

* delete any memory left-overs from last command
	CALL DELETE_MRS_IN_PROGRESS

* * * * DETERMINE CONTEXT FOR COMMAND * * *
	CALL GET_NEW_CX( dflt_cx, cx_cmnd, .TRUE., status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* consolidate arguments broken up by command parser back into a single arg
* ... correct mis-handling of surrounding quotation marks
	CALL ALL_1_ARG_EXPR

* * * * BREAK FULL EXPRESSION INTO SUB_EXPRESSIONS * * *
* ... and store them in the uvar list names as "EX#n"
* ... eg. LIST U^2,V^2 breaks into "U^2" and "V^2"
* ... or re-use the last expression ?
	IF ( num_args .GT. 0 
     .  .OR. auto_auxvar_changed ) THEN
	   IF ( last_cmnd_buff(:len_last_cmnd)
     .     .NE.      cmnd_buff(arg_start(1):arg_end(1)) 
     .	   .OR. num_uvars_in_cmnd .EQ. cmnd_uvars_not_given
     .	   .OR. auto_auxvar_changed 		) THEN
	      CALL DELETE_OLD_EXPR
	      last_cmnd_buff = cmnd_buff(arg_start(1):arg_end(1))
	      len_last_cmnd  = arg_end(1) - arg_start(1) + 1
	      CALL BREAK_UP_EXPR( cmnd_buff(arg_start(1):arg_end(1)),
     .				  num_uvars_in_cmnd, status )
	      IF ( status .NE. ferr_ok ) THEN
	         num_uvars_in_cmnd = cmnd_uvars_not_given
	         GOTO 5000
	      ENDIF
	   ENDIF
	ENDIF

* * * * EVALUATE THE SUB-EXPRESSIONS * * *
	IF ( num_uvars_in_cmnd .EQ. cmnd_uvars_not_given )
     .		CALL ERRMSG
     .			(ferr_invalid_command,status,'no data specified',*5000)

	DO 300 nu = 1, num_uvars_in_cmnd

	   CALL RESET_CLIMAT_ATT

* ... a context slot to hold a fresh command context for each sub-expression
	   cx_stack_ptr = cx_stack_ptr + 1
	   cx_expr = cx_stack_ptr


! *sh* 1/17
! This block of code is experimental / untested from 2014.
! It is connected to  CALL SET_AUTO_CURVI_MODES above (also half-baked).
! For now I have commented it out, as it can eat up the context stack on
! commands where num_uvars_in_cmnd is large
! The logic here reserves a frame of nferdims slots at the top of the context
! stack as the place to stash the contexts needed to describe the auxiliary
! variables that are associated with each requested variable.
! e.g. SHADE my_curvi_var should automate a 3-arg curvilinear plot.
!  and LIST my_curvi_var should automatically list curvilinear coordinates
! The stack frames detected by ITS_AUTO_CURVI (also temporarily disabled)
! The code development only got as far as XEQ_LIST, (not SHADE, etc.) and
! the relevant code is never triggered as long as ITS_AUTO_CURVI returns FALSE
!* ... a frame of size nferdims to hold aux vars needed for plotting and listing
!	   max_usable_intrp = max_usable_intrp - nferdims
!	   max_context      = max_context      - nferdims
!	   DO idim = 1, nferdims
!	      is_mr(max_usable_intrp+idim) = unspecified_int4
!	      is_cx(max_usable_intrp+idim) = unspecified_int4  ! bookkeeping
!	   ENDDO

* ... initialize memory diagnostics
	   current_cmnd_uvar = nu
	   deferred_committed_mem = 0

* ... evaluate the next sub-expression
	   CALL TRANSFER_CONTEXT( cx_cmnd, cx_expr )
	   CALL INTERP_STACK(  nu, cx_expr,
     .			      EXPR_NAME(nu), status )
	   IF ( status .NE. ferr_ok ) GOTO 5000

* ... check for legal data type
	   IF ( dtype .NE. ptype_native ) THEN
	      IF (mr_type(is_mr(isp)) .NE. dtype ) GOTO 5100
	   ENDIF

* ... add memory occupied by this result to the on-hold total of arguments
	   completed_args_mem = completed_args_mem + mr_size(is_mr(isp))

* tag the result for what it is
* note that since aux vars may now be returned on the ISP stack, isp may be GT nu
	   is_act(isp) = isact_var_ready

* Ticket 2278
* When defining an extra attribute based on the computation, e.g. dates that 
* went intothe modulo calculation. Has an attribute name and value have been 
* stored. natt_computed_var and the attribute name and string have been set 
* e.g. in the modulo regridding routine. 

	   IF (natt_computed_var .GT. 0) THEN

	      IF (STR_SAME (attstr_computed_var(1:10), 'do not set') .EQ. 0)  GOTO 290
     
* get the variable - will put an attrib onto it
	      cat = cx_category(cx_expr)
	      var = cx_variable(cx_expr)
	      varcode = VAR_CODE( cat, var )

* Ticket 2489: Skip this if it is an expression such as EX#2; There is 
* no varid to attach the attribute to.

	      IF (INDEX(varcode, '#') .GT. 0) GOTO 290

	      dset = cx_data_set( cx_expr )
	      varcode = SANITARY_VAR_CODE( cat, var )

	      IF (dset .EQ. pdset_irrelevant) dset = pdset_uvars
	      IF (cat .EQ. cat_user_var .AND. dset .LE. pdset_irrelevant)  dset = pdset_uvars
	      CALL CD_GET_VAR_ID (dset, varcode, varid, status)
	      IF (status .NE. ferr_ok) THEN
	         IF (cat .EQ. cat_user_var .AND. dset.GE.pdset_irrelevant) THEN
	            dset = pdset_uvars
		    CALL CD_GET_VAR_ID (dset, varcode, varid, status)
	         ENDIF
	      ENDIF

	      IF (status .EQ. ferr_ok) THEN
                 CALL CD_GET_VAR_ATT_ID (dset, varid, attname_computed_var, 
     .                attid, status) 
                 IF (attid .GT. 0) THEN
                    CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, 
     .                attname_computed_var, attype, attlen, attoutflag, status )
                    attlen = TM_LENSTR1(attstr_computed_var)
                    CALL CD_REPLACE_ATTR (dset, varid, attname_computed_var, 
     .                attype, attlen, attstr_computed_var, dummy, status)
                 ELSE
                    attype = NCCHAR
                    attoutflag = 1
	            attlen = TM_LENSTR1(attstr_computed_var)
                    CALL CD_PUT_NEW_ATTR (dset, varid, attname_computed_var, 
     .                 attype, attlen, attoutflag, 
     .                 attstr_computed_var, 1., status) 
                    IF (status .NE. ferr_ok) status = ferr_ok  ! ignore
	         ENDIF
	      ENDIF

  290	      CONTINUE
	      CALL RESET_CLIMAT_ATT

	   ENDIF


! temp diagnostic
	   IF ( cx_stack_ptr .NE. cx_cmnd+nu ) CALL WARN( 'get_cmnd_???')
 300	CONTINUE

* turn off oversizing flag for next command
	cx_ovsiz(dflt_cx) = ovsiz_off
	RETURN

* error exit
 5000	RETURN
 5100	buff = VAR_CODE(mr_category(is_mr(nu)),mr_variable(is_mr(nu)))
* ... copied from INTERP_STACK error exit ... probably over-kill
	CALL RELEASE_DYN_WORK_SPACE
        CALL DELETE_MRS_IN_PROGRESS
        CALL UNPROTECT_ALL_MRS
        CALL DEALLO_ALL_GRIDS
        CALL CLEAN_STACK
	CALL ERRMSG( ferr_data_type, status,buff(:TM_LENSTR1(buff)), *5000 )
	END

	SUBROUTINE INIT_U_AGGREGATE_DSET (memb_dsetname_var,
     .	   nsets, have_expr, dname, dpath, dtitle, agg_dset, 
     .     agg_quiet, agg_hide, agg_dim, status )
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* initialize a new ensemble (E) or forecast (F) aggregated dataset
* Aggregation member variables may be a blend of file variables and LET/D vars
* Since the user may alter LET/D definitions after the aggregation has been
* defined, the following approach is taken to processing:
*  1) during DEFINE DATA/AGG the grids of all member variables are determined
*     This means that IS_UVAR_GRID is called for LET/D vars.
*     These grid numbers are stored in the aggregation LIST structures
*     The grids of the variables in the aggregated (parent) dataset are also
*     determined and stored in ds_grid_number as if they are file variables.
*     These grids are "static" as with file variables -- always valid. 
*  2) (TBD as of this writing!!!)==> the use counts of *all* member grids are
*     bumped, so that they cannot be deleted, even if LET/D definitions change
*  3) (TBD as of this writing!!!)==> at get_grid time all of the components
*     of the aggregation are checked to
*     ensure they have a grid (IS_UVAR_GRID) -- allowing for last-minute
*     LET/D var changes
*  4) during evaluation (in IS_STRIP and IS_AGGREGATE_GATHER) the variable
*     name and member dataset number are used to make a fresh determination of
*     the variable category and grid.  Error out if grid number has changed

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - SDIG
*
* V7   5/12 *acm* Union aggregations: DEFINE DATA/AGG/U
* V7.2 5/17 *acm* Ticket 2526 For SHOW DATA/MEMBERS of Union datasets need to 
*                 have called NCF_ADD_AGG_MEMBERto list the dataset members in 
*                 the linked-list structure for the union dataset

* arguments:
*	memb_dsetname_var - if have_expr, the variable of names (input)
*	nsets		- number of datasets in the aggregation (input)
*       have_expr	- flag if filenames were listed or in an expr (input)
*	dname		- dataset name to assign to the aggregation (input)
*	dpath		- dataset path name to assign to aggregation (input)
*	dtitle		- dataset title (input)
*	dset_num	- number assigned to this data set (output)
*       agg_quiet       - flag whether to report certain conditions (input)
*	agg_hide        - flag whether to hide the component datasets (input)
*	agg_dim		- axis of the aggregation (is irrelevant)
*	status		- return status (output)

      IMPLICIT NONE
	include 'netcdf.inc'
        include 'tmap_errors.parm'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xdset_info.cd_equiv'
	include 'xunits.cmn_text'
        include 'xprog_state.cmn'
	include 'xtm_grid.cmn_text'  
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xfr_grid.cmn'

* calling argument declarations:
	CHARACTER*(*)	dname, dpath, dtitle
	INTEGER		nsets, agg_dset, agg_dim, status
	LOGICAL		have_expr, agg_quiet, agg_hide
	REAL		memb_dsetname_var(*)

* parameter definitions
	INTEGER	pmaxvarsperset
	PARAMETER (pmaxvarsperset = 400)

* local variable declarations:
	LOGICAL match, itsa_uvar
	INTEGER	TM_LENSTR1, STR_SAME, NCF_ADD_AGG_MEMBER,
     .		iset, dset1, item, ii, max_str_len,member_sets(nsets), 
     .		nv, nvars, iline, slen, jlen, un_vars(pmaxvarsperset),
     .		num_indices, j, member, ignored_status
	REAL	sset
	CHARACTER TM_STRING*13
	CHARACTER*512 GET_STRING_ELEMENT_1D_X, memb_dsetname(nsets)
	CHARACTER*10 TM_FMT, strset
	CHARACTER*128 vname

* initialize
	max_str_len = 512
	nsets = nsets
	DO iset = 1, nsets
	   member_sets(iset) = pdset_dummy
	ENDDO

* check to see if this new dataset name matches an already-open dataset name.
* if so, thats an error
	DO iset = 1, maxdsets
           match = ds_name(iset) .EQ. dname
           IF ( match ) GOTO 5100
	ENDDO

* set up array of dataset identifier strings
*   these may be string dataset numers or names,  pre-init'ed or not
	IF (have_expr) THEN
*  ... dataset list passed through a string variable
	  DO iset = 1, nsets
	    memb_dsetname(iset) = GET_STRING_ELEMENT_1D_X(
     .			nsets,
     .                  memb_dsetname_var,iset,
     .			max_str_len,slen )
	  ENDDO
	ELSE
*  ... dataset names given by user on command line
	  DO iset = 1, nsets
	    memb_dsetname(iset) = cmnd_buff(item_start(iset):item_end(iset))
	  ENDDO
	ENDIF

* See if requested datasets are open and if not, try to open them.
	CALL CHECK_MEMBER_SETS (agg_dim, nsets, memb_dsetname,
     .				member_sets, status)
	IF (status .NE. ferr_ok) GOTO 9950

* Assign aggregate data set number, exiting if maximum number 
* of data sets are open
	DO iset = 1,maxdsets
	  IF (ds_name(iset) .EQ. char_init1024) THEN
	    agg_dset = iset
	    GOTO 220
	  ENDIF
	ENDDO
* ... too many data sets are open
	CALL TM_ERRMSG ( merr_dsetlim, status, 'INIT_U_AGGREGATE_DSET',
     .			 no_descfile, no_stepfile,
     .			 'MAX='//TM_STRING(DBLE(maxdsets)),
     .			 no_errstring, *9950)
 220	CONTINUE

* Create datset. Will delete it later if there are no aggregate variables found
* Note: the pattern will the first dataset given.  They may get reordered.
	iline = unspecified_int4
	agg_dim = unspecified_int4
	CALL CREATE_AGG_DSET (agg_dset, dname, dpath, dtitle,
     .			 nsets, member_sets(1), agg_dim, iline, status)  
	IF (status .NE. ferr_ok) GOTO 5300

* 1st member dset sets pattern for all to follow
	dset1 = member_sets(1)


*****
* find variables from the first dataset and register them in the aggregation.

	iset = dset1

	nvars = 0
!	DO nv = 1, max_uvar      ! brute-force equivalent loop
	CALL deleted_list_get_undel(uvar_num_items_head,
     .                              deleted_list_result(1),
     .                              max_uvar, num_indices )
	DO j = 1, num_indices
	   nv = deleted_list_result(j)
	   IF (uvar_dset(nv) .EQ. dset1) THEN
	      nvars = nvars + 1
	      un_vars(nvars) = nv
	      vname = uvar_name_code(nv)
	      itsa_uvar = .TRUE.
	      CALL DEFINE_U_AGGREGATE_VAR (agg_dset, iset, nvars, 
     .           vname, nv, itsa_uvar, nsets, status)
              IF (status .NE. ferr_ok) GOTO 5300
	   ENDIF
	ENDDO

* now find the file variables
        DO nv = 1, maxvars
	   IF (ds_var_setnum(nv) .EQ. dset1) THEN
* ... skip it if it duplicates a name already found as a LET/D variable
	      DO ii = 1, nvars
	         IF (STR_SAME(ds_var_code(un_vars(ii)),
     .			      ds_var_code(nv)           ) .EQ. 0) GOTO 300
	      ENDDO
	      nvars = nvars + 1
	      un_vars(nvars) = nv
	      vname = ds_var_code(nv)
	      itsa_uvar = .FALSE.
	      CALL DEFINE_U_AGGREGATE_VAR (agg_dset, iset, nvars, vname, nv, 
     .         itsa_uvar, nsets, status)
           IF (status .NE. ferr_ok) GOTO 5300
	   ENDIF
 300	   CONTINUE
	ENDDO
*****

* If no variables from the dataset, delete this dataset. 
	IF (nvars .EQ. 0) GOTO 5500

* *** loop over the member datasets ***
	DO iset = 2, nsets
	   member = member_sets(iset)
	   IF (member .EQ. pdset_dummy) CYCLE ! ignore dummy (missing) dataset

*****
* find variables from the other member datasets. Add new ones to the aggregation.

	   CALL deleted_list_get_undel(uvar_num_items_head,
     .                              deleted_list_result(1),
     .                              max_uvar, num_indices )
	   DO j = 1, num_indices
	      nv = deleted_list_result(j)
	      IF (uvar_dset(nv) .EQ. member) THEN
	         nvars = nvars + 1
	         un_vars(nvars) = nv
	         vname = uvar_name_code(nv)
	         itsa_uvar = .TRUE.
	         CALL DEFINE_U_AGGREGATE_VAR (agg_dset, member, nvars, 
     .               vname, nv, itsa_uvar, nsets, status)
	         IF (status .NE. ferr_ok) GOTO 5300
	      ENDIF
	   ENDDO

* now file variables
	   DO nv = 1, maxvars
	      IF (ds_var_setnum(nv) .EQ. member) THEN
* ... skip it if it duplicates a name already found as a LET/D variable
*     Issue a note unless they said /QUIET

	         DO ii = 1, nvars
	            IF (STR_SAME(ds_var_code(un_vars(ii)),
     .			      ds_var_code(nv)           ) .EQ. 0) THEN
                       sset = member
		       slen = TM_LENSTR1(ds_var_code(nv))
		       strset = TM_FMT(sset, 10, 10, jlen)
		       
                       IF (.NOT.agg_quiet) CALL WARN ('Skipping variable '//
     .			ds_var_code(nv)(:slen)//
     .			' from set '//strset(:jlen) //
     .			', already in the Union dataset.')
		       GOTO 400
	            ENDIF
	         ENDDO
	         nvars = nvars + 1
	         un_vars(nvars) = nv
	         vname = ds_var_code(nv)
	         itsa_uvar = .FALSE.
	         CALL DEFINE_U_AGGREGATE_VAR (agg_dset, member, nvars, 
     .            vname, nv, itsa_uvar, nsets, status)
	         IF (status .NE. ferr_ok) GOTO 5300
	      ENDIF
 400	   CONTINUE
  	   ENDDO


	ENDDO  ! 2, nsets

	IF (nvars .EQ. 0) GOTO 5500


* register member datasets to aggregate dataset
	DO iset = 1, nsets
	   status = NCF_ADD_AGG_MEMBER (agg_dset, iset, member_sets(iset)) 
	ENDDO

* If user requested /HIDE, then mark the member datasets for hidden status
	IF (agg_hide) THEN
 	   DO iset = 1, nsets
	      ds_hide (member_sets(iset)) = .TRUE. 
	   ENDDO
	ENDIF

* successful completion
	RETURN

* error bail out
* remove all hidden member datasets of the failed aggregation
* ... this is a little brute force in that it may cancel a previously opened
* ... dataset included using DEFINE DATA/AGG/HIDE (havnt checked carefully)
 5000	DO ii = 1, nsets
	   iset = member_sets(ii)
	   IF (iset .EQ. pdset_dummy
     .    .OR. iset .EQ. unspecified_int4) CYCLE
	   IF (ds_name(iset) .EQ. char_init1024) CYCLE ! already deleted
	   IF (ds_hide (iset)) CALL CANCEL_ONE_DATA_SET( iset, ignored_status )
	ENDDO
 6000	RETURN	

* Errors: too-many datasets open so aggregate dataset can't be opened,
* or error on a member dataset. 
* ?? If some member datasets were opened, close them??)
* Return no-dataset-number.

 9950	agg_dset = unspecified_int4
	status = ferr_TMAP_error
	GOTO 5000
* wipe out the partially-created aggregated dataset
 9960	CALL TM_PURGE_TMP_GRIDS(ignored_status)
	CALL TM_CLOSE_SET_COND_DEALLO( agg_dset, .FALSE., ignored_status )
	agg_dset = unspecified_int4
	GOTO 5000

 5100   CALL ERRMSG( ferr_invalid_command,status,
     .		'dataset name already in use: '
     .		//dname(:TM_LENSTR1(dname)), *5000 )
     
 5300	CALL ERRMSG( ferr_aggregate_error, status, ' ', *9950 )

 5500	CALL ERRMSG( ferr_aggregate_error, status,
     .		'No valid datasets ', 
     .		*9960 )

	END

	INTEGER FUNCTION GET_MAX_STRING_LEN(cx, mr, grid_data )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Return the length of the longest string in this context

* V530: 8/00 *sh*
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

	include	'tmap_dims.parm'
	include 'ferret.parm'
	include 'xvariables.cmn'

* calling argument declarations
	INTEGER  cx, mr
	REAL*8	grid_data(*)

* internal variable declarations
	INTEGER	smax

* pass in mr array dimensions
	CALL GET_MAX_STRING_LEN_SUB( cx, grid_data,
     .				     mr_lo_s1(mr), mr_hi_s1(mr),
     .				     mr_lo_s2(mr), mr_hi_s2(mr),
     .				     mr_lo_s3(mr), mr_hi_s3(mr),
     .				     mr_lo_s4(mr), mr_hi_s4(mr),
     .				     mr_lo_s5(mr), mr_hi_s5(mr),
     .				     mr_lo_s6(mr), mr_hi_s6(mr),
     .				     smax )

	GET_MAX_STRING_LEN = smax
	RETURN

	END
 

      SUBROUTINE ABPLT_makedot
                
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
****************************************************************
* revised for FERRET
* from PPLUS :
*	Directory PMEL:[PLOT5.LIBRARY.COMPLOT]
*	ABPLT.FOR;2               9   5-FEB-1985 11:33 

*  8/2001  acm  for PLOT/SYMBOL=DOT
*  Simplified version of ABPLT to be called by make_dot.  no need
*  to compute intercepts for points off-screen.  If off-screen do
*  not plot
*  10/2001 acm do buffering on GKS calls.  Also remove VMS includes.

****************************************************************
*     CALL ABPLT

*     THIS SUBROUTINE PERFORMS SCREEN CLIPPING AND THEN MOVES THE
*     PEN FROM THE CURRENT POSITION TO A NEW POINT.


      include 'pltcom_dat.decl'
      include 'PLTCOM.DAT'

C end of FERRET mod
******************************************************************

C     CALCULATE THE NEW OFF-SCREEN FLAG.

******************************************************************
C FERRET mod - bypass GKS clipping - 9-13-88
      IF ( ptype .LT. 3 ) THEN
          OSFLG = 0
          IF(ANEW - 0.001 .GT. AMAX)OSFLG = 1
          IF(ANEW + 0.001 .LT. AMIN)OSFLG = 2
          IF(BNEW - 0.001 .GT. BMAX)OSFLG = OSFLG + 4
          IF(BNEW + 0.001 .LT. BMIN)OSFLG = OSFLG + 8
       ELSE
          OSFLG = 0
          losflg = 0            ! reset by many PPLUS routines
       ENDIF
* end of FERRET mod
******************************************************************

C     CHECK THE PEN POSITION.

       IF(.NOT. PENF)GO TO 90

C     CHECK THE PLOTTING MODE.

C     CHECK THE NEW POINT TO SEE IF IT IS WITHIN THE BOUNDARY OF
C     THE SCREEN.  IF NOT, DO NOT PLOT IT.

  80  IF(OSFLG .NE. 0)GO TO 100

C     PLOT TO THE POINT WITH THE PEN UP AND THEN DRAW A DOT.

      A = ANEW - AMIN
      B = BNEW - BMIN
c      PEN = .FALSE.
c      CALL ABMV_makedot
      PEN = .TRUE.
      CALL ABMV_makedot
      GO TO 100

C     CHECK THE NEW POINT TO SEE IF IT IS WITHIN THE BOUNDARY OF
C     THE SCREEN.  IF NOT, DO NOT PLOT IT.

  90  IF(OSFLG .NE. 0)GO TO 100

C     PLOT TO THE POINT WITH THE PEN UP.

      A = ANEW - AMIN
      B = BNEW - BMIN
      PEN = .FALSE.
      CALL ABMV_makedot

C     MOVE THE COORDINATES OF THE NEW POINT TO THE OLD POINT.

 100  AOLD = ANEW
      BOLD = BNEW
      AOSOLD = A
      BOSOLD = B
      LOSFLG = OSFLG
      RETURN

      END

	SUBROUTINE SHOW_DATA_SET_ATTRS( lun, dset, full )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* describe the attributes in the named nc data set

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* - based on SHOW_DATA_SET_VARS 
* V600 6/05 *acm* Attribute control.
* V600 4/08 SHOW DATA/ATT only for nc data so far; var info not in 
*           the linked list structure.
* V62  4/09 List the data type of variables as they are in the input
*           dataset.
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
* V698  2/16 *acm* For ticket 2352: variables defined with LET/D are
*                  added to that dataset in the attribute structure, 
*                  and are shown with their dataset on SHOW DAT/ATT
* V698  3/16 *acm* Ticket 2371: Wrap the output of SHOW DAT/ATT to 
*                  the next line when the variable name or attribute 
*                  name is long
* 

	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'ez_lib.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xez_info.cmn_text'
	external xez_info_data
	include	'ferret.parm'
	include	'xvariables.cmn'
	include	'xtext_info.cmn'
	include	'xprog_state.cmn'
	include	'xrisc.cmn'
	include 'calendar.decl'
	include 'calendar.cmn'
#include "netcdf.inc"

* calling argument declarations:
	LOGICAL	full
	INTEGER	lun, dset
	
* local variable declarations:
        LOGICAL         NC_GET_ATTRIB, coordvar, got_it, first_time
	INTEGER 	TM_LENSTR1, STR_SAME, NCF_INQ_DS, varid, ndims,
     .                  nvars, ngatts, recdim, iatt, attype, attlen,
     .                  slen,  llen, vlen, vtype, nvdims,
     .                  vdims(8),  nvatts, status, blen, i, len_attbuff,
     .                  max_vals, attoutflag, all_outflag, attid, uvflag
        REAL            vals(1000)
	CHARACTER	TM_FMT*14, GET_UNIQUE_DSET_NAME*1024, varname*512, 
     .                  attname*128, buff*14, dsname*1024, attbuff*10240, oflag*1
        CHARACTER*6     typ(0:7)
        PARAMETER       (len_attbuff = 10240, max_vals=1000)
        
* See netcdf.h for the data types
	DATA typ/'NaN',          ! NAT = 'Not A Type' (c.f. NaN)
     .           'BYTE',         ! signed 1 byte integer
     .           'CHAR',         ! ISO/ASCII character
     .           'SHORT',        ! signed 2 byte integer
     .           'INT',          ! signed 4 byte integer
     .           'FLOAT',        ! single precision floating point number
     .           'DOUBLE',       ! double precision floating point number
     .           ' '/		 ! blank for the global attributes

* describe the variables in the set, only for datasets originating 
* as netcdf data.

        IF (dset .LE. 0) RETURN
        status = NCF_INQ_DS (dset, ndims, nvars, ngatts, recdim )

	risc_buff = ' '
	WRITE ( risc_buff, 3200 )
 3200	FORMAT(' Variable',T14,'VarType(in dset)',T34,'AttributeName',
     .         T50,'AttType',T62,'Size',T67,'OutFlag',T75,'AttValue')
 3201	FORMAT('---------------------------------------------',
     .         '---------------------------------------------')

 3300	FORMAT(' ',A,T24,A,T34,A,T50,A,T62,A,T67,A,T75,A)
 4300	FORMAT(' ',T50,A,T62,A,T67,A,T75,A)
 5300	FORMAT(' ',T24,A,T34,A,T50,A,T62,A,T67,A,T75,A)
 3301	FORMAT(' ',A,T24,A,T34,A,T50,A,T62,A,T67,A,T75)
 5301	FORMAT(' ',T24,A,T34,A,T50,A,T62,A,T67,A,T75)
 3302	FORMAT(' ',A)
 3304	FORMAT(' ',A,T34,A,T50,A,T62,A,T67,A,T75,A)
 4304	FORMAT(' ',T50,A,T62,A,T67,A,T75,A)
 5304	FORMAT(' ',T34,A,T50,A,T62,A,T67,A,T75,A)
 3400	FORMAT('(',A,')',T24,A,T34,A,T50,A,T62,A,T67,A,T75,A)
 4400	FORMAT(T50,A,T62,A,T67,A,T75,A)
 5400	FORMAT(T24,A,T34,A,T50,A,T62,A,T67,A,T75,A)
 3500	FORMAT(T34,A,T50,A,T62,A,T67,A,T75,A)
 4500	FORMAT(T50,A,T62,A,T67,A,T75,A)


	CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0) 
        WRITE (lun, 3201) 
        WRITE (lun, *) ' '

* Write global atttributes

        IF ( ngatts .GE. 1) THEN
   
	      varname = '.'
	      CALL CD_GET_VAR_ID (dset, varname, varid, status)
              IF (varid .EQ. 0) vtype = 7  ! 
              
	      vlen = TM_LENSTR1(varname)
	      DO 100 iatt = 1, ngatts
                 CALL CD_GET_VAR_ATT_NAME (dset, varid, iatt, attname, 
     .              status )
                 CALL CD_GET_VAR_ATT_INFO (dset, varid, iatt, attname, 
     .              attype, attlen, attoutflag, status )
                 CALL CD_GET_VAR_ATT_INFO (dset, varid, iatt, attname, 
     .              attype, attlen, attoutflag, status )

	         blen = len_attbuff
		 IF (attype .NE. NCCHAR) attlen = MIN(attlen, max_vals)
	         got_it = NC_GET_ATTRIB (dset, varid, attname, 
     .                                .TRUE., varname, blen, attlen, 
     .                                attoutflag, attbuff, vals)

	         IF (got_it) THEN
	            IF (attype .NE. NCCHAR) THEN
                       blen = 1
                       attbuff = ' '
                       DO 50 i = 1, attlen
                          buff = TM_FMT(vals(i), 7, 14, llen)
                          attbuff(blen:blen+llen+1) = buff//' '
                          blen = blen + llen + 1
  50                  CONTINUE
                    ELSE 
                       blen = TM_LENSTR1(attbuff)
                    ENDIF
                    oflag = 'F'
                    IF (attoutflag .EQ. 1) oflag = 'T'
                 ELSE
                    attbuff = ' '
                    blen = 1
                    oflag = ' '
                 ENDIF

                 slen = TM_LENSTR1(attname)
                 buff = TM_FMT (FLOAT(attlen),7,14,llen)
		 IF (slen .GT. 15) THEN

                    WRITE (risc_buff, 3300) varname(1:vlen), typ(vtype),
     .                 attname(1:slen)

                    CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0) 
                    WRITE (risc_buff, 4300) typ(attype), buff(1:llen), oflag,
     .                 attbuff(1:blen)

		 ELSE
		    IF (vlen+slen+llen+blen+20 .LE. len_attbuff) THEN
                       WRITE (risc_buff, 3300) varname(1:vlen), typ(vtype),
     .                    attname(1:slen), typ(attype), buff(1:llen), oflag,
     .                    attbuff(1:blen)

                    ELSE
                       WRITE (risc_buff, 3301) varname(1:vlen), typ(vtype),
     .                    attname(1:slen), typ(attype), buff(1:llen), oflag
     
                       CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0) 
                       WRITE (risc_buff, 3302) attbuff(1:len_attbuff-2)
                    ENDIF
                 ENDIF
                 CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0) 
                 risc_buff = ' '
                 varname = ' '
 100         CONTINUE
             WRITE (lun, *) ' '

        ENDIF

* Write attributes for all variables
        IF (nvars .GE. 1) THEN

	   first_time = .TRUE.
           DO 300 varid = 1, nvars
              CALL CD_GET_VAR_INFO (dset, varid, varname, vtype, nvdims,
     .           vdims, nvatts, coordvar, all_outflag, status)
              IF (varid .EQ. 0) vtype = 7  ! 
              vlen = TM_LENSTR1(varname)

* Special listing for user-defined variables added to this dataset
	      CALL CD_GET_VAR_UVFLAG (dset, varid, uvflag, status)
	      
	      IF ( uvflag .EQ. 1) THEN
	         IF (first_time ) CALL SPLIT_LIST(pttmode_explct, lun,
     .			' ------------------------------', 31) 
	         first_time = .FALSE.
		 IF (vtype .EQ. 0) vtype = 7             ! user-var data type not set
		 dsname = GET_UNIQUE_DSET_NAME( dset )
		 llen = TM_LENSTR1(dsname)
		 varname = varname(1:vlen)//'[D='//dsname(:llen)//']' 
		 vlen = TM_LENSTR1(varname)
	      ENDIF

              IF (nvatts .EQ. 0) THEN
                 IF (coordvar) THEN
                    WRITE (risc_buff, 3400) varname(1:vlen), typ(vtype)
                    IF (vlen .GT. 21) THEN
		       WRITE (risc_buff, 3400) varname(1:vlen)
		       CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0) 
		       WRITE (risc_buff, 5400) typ(vtype)
                    ENDIF
                 ELSE
                    WRITE (risc_buff, 3300) varname(1:vlen), typ(vtype)
                    IF (vlen .GT. 21) THEN
                       WRITE (risc_buff, 3300) varname(1:vlen)
		       CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0) 
		       WRITE (risc_buff, 5300) typ(vtype)
		    ENDIF
                 ENDIF
		 
		 CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0) 
              ENDIF

              DO 200 iatt = 1, nvatts
                 CALL CD_GET_VAR_ATT_INFO (dset, varid, iatt, attname, 
     .              attype, attlen, attoutflag, status )

                 blen = len_attbuff
                 got_it = NC_GET_ATTRIB (dset, varid, attname, 
     .                                .TRUE., varname, blen, attlen, 
     .                                attoutflag, attbuff, vals)

                 IF (got_it) THEN
                    IF (attype .NE. NCCHAR) THEN
                       blen = 1
                       attbuff = ' '
                       DO 150 i = 1, attlen
                          buff = TM_FMT(vals(i), 7, 14, llen)
                          attbuff(blen:blen+llen+1) = buff//' '
                          blen = blen + llen + 1
 150                   CONTINUE
                    ELSE 
                       blen = TM_LENSTR1(attbuff)
                    ENDIF
                    oflag = 'F'
                    IF (attoutflag .EQ. 1) oflag = 'T'
                 ELSE
                    attbuff = ' '
                    blen = 1
                    oflag = ' '
                 ENDIF

                 slen = TM_LENSTR1(attname)
                 buff = TM_FMT (FLOAT(attlen),7,14,llen) 
                
                 IF (iatt .EQ. 1) THEN
                    IF (uvflag.EQ.0) THEN
                    IF (coordvar) THEN
		       IF (slen .GT. 15) THEN
                          WRITE (risc_buff, 3400) varname(1:vlen), 
     .                       typ(vtype), attname(1:slen)
     
                          IF (vlen .GT. 21) THEN
                             WRITE (risc_buff, 3400) varname(1:vlen)
                             CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0) 
                             WRITE (risc_buff, 5400) typ(vtype), attname(1:slen)
                          ENDIF
                          CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0) 

                          WRITE (risc_buff, 4400) typ(attype), 
     .                       buff(1:llen), oflag, attbuff(1:blen)

		       ELSE
                          WRITE (risc_buff, 3400) varname(1:vlen), 
     .                       typ(vtype), attname(1:slen), typ(attype), 
     .                       buff(1:llen), oflag, attbuff(1:blen)
                          IF (vlen .GT. 21) THEN
                             WRITE (risc_buff, 3400) varname(1:vlen)
                             CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0) 
                             WRITE (risc_buff, 5400) typ(vtype), attname(1:slen), 
     .                          typ(attype), buff(1:llen), oflag, attbuff(1:blen)
                          ENDIF
		       ENDIF

		    ELSE
		       IF (slen .GT. 15) THEN
                          WRITE (risc_buff, 3300) varname(1:vlen), typ(vtype),
     .                    attname(1:slen)

                          IF (vlen .GT. 21) THEN
                             WRITE (risc_buff, 3300) varname(1:vlen)
                             CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0) 
                             WRITE (risc_buff, 5300) typ(vtype), attname(1:slen)
                          ENDIF
                          CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0) 

                          WRITE (risc_buff, 4300) typ(attype), buff(1:llen), oflag,
     .                    attbuff(1:blen)

		       ELSE

                          IF (vlen+slen+llen+blen+20 .LE. len_attbuff) THEN
                             WRITE (risc_buff, 3300) varname(1:vlen), typ(vtype),
     .                         attname(1:slen), typ(attype), buff(1:llen), oflag,
     .                         attbuff(1:blen)
     
                             IF (vlen .GT. 21) THEN
                                WRITE (risc_buff, 3300) varname(1:vlen)
                                CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0) 
                                WRITE (risc_buff, 5300) typ(vtype),
     .                            attname(1:slen), typ(attype), buff(1:llen), oflag,
     .                            attbuff(1:blen)
                             ENDIF

                          ELSE
                             WRITE (risc_buff, 3301) varname(1:vlen), typ(vtype),
     .                         attname(1:slen), typ(attype), buff(1:llen), oflag

                             IF (vlen .GT. 21) THEN
                                WRITE (risc_buff, 3301) varname(1:vlen)
                                CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0) 
                                WRITE (risc_buff, 5301) typ(vtype),
     .                             attname(1:slen), typ(attype), buff(1:llen), oflag
                             ENDIF

                             CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0) 
                             WRITE (risc_buff, 3302) attbuff(1:len_attbuff-2)
                          ENDIF

		       ENDIF
                    ENDIF  ! coordvar or not
                    ENDIF  ! not uvflag

                    IF (uvflag .EQ. 1) THEN
		       IF (slen .GT. 15) THEN
                          WRITE (risc_buff, 3304) varname(1:vlen), 
     .                       attname(1:slen)
                          IF (vlen .GT. 32) THEN
                             WRITE (risc_buff, 3304) varname(1:vlen)
			     CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
                             WRITE (risc_buff, 5304) attname(1:slen)
			  ENDIF

			  CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0) 
 
                          WRITE (risc_buff, 4304) typ(attype), buff(1:llen), oflag,
     .                       attbuff(1:blen)
     
		       ELSE
                          WRITE (risc_buff, 3304) varname(1:vlen), 
     .                       attname(1:slen), typ(attype), buff(1:llen), oflag,
     .                       attbuff(1:blen)
                          IF (vlen .GT. 32) THEN
                             WRITE (risc_buff, 3304) varname(1:vlen)
			     CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
			     WRITE (risc_buff, 5304) 
     .                       attname(1:slen), typ(attype), buff(1:llen), oflag,
     .                       attbuff(1:blen)
                          ENDIF

		       ENDIF

                    ENDIF

                 ELSE 
                    IF (slen .GT. 15) THEN
                       WRITE (risc_buff, 3500) attname(1:slen)
                       CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0) 
                       WRITE (risc_buff, 4500) typ(attype), buff(1:llen),
     .                   oflag, attbuff(1:blen)
                    ELSE
                       WRITE (risc_buff, 3500) 
     .                     attname(1:slen), typ(attype), buff(1:llen),
     .                     oflag, attbuff(1:blen)
                    ENDIF
                 ENDIF

                 CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0) 

                 risc_buff = ' '
 200          CONTINUE
              WRITE (lun, *) ' '
 300       CONTINUE
        ENDIF

5100    RETURN

	END

      SUBROUTINE HRADIATION ( sst, msst, rad, mrad )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute radiative heat flux into sea surface
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 4/30/86
* revision 1.0 - 4/4/88  - added SST and heat ramp calculations
* V200:  7/27/89 - 4D symmetrical version
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN

* capitalized code is lifted from the GFDL model
*
*	SW-LW (C5) is short wave down less long wave up

#ifdef unix
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl.parm'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xcontext.cmn'
	include 'xonedim.cmn'
	include 'xdset_parms.cmn'
#else
	INCLUDE 'FERRET_CMN:FERRET.PARM'
	INCLUDE 'FERRET_CMN:GFDL.PARM'
	INCLUDE 'TMAP_FORMAT:TMAP_DIMS.PARM'
	INCLUDE	'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE	'FERRET_CMN:XMEM_SUBSC.CMN'
	INCLUDE 'FERRET_CMN:XCONTEXT.CMN'
	INCLUDE 'FERRET_CMN:XONEDIM.CMN'
	INCLUDE 'FERRET_CMN:XDSET_PARMS.CMN'
#endif

* calling argument declarations:
	INTEGER	msst, mrad
	REAL    sst( m1lox:m1hix,m1loy:m1hiy,            m1lot:m1hit ),
     .		rad( m2lox:m2hix,m2loy:m2hiy,            m2lot:m2hit )

* internal variable declarations:
	INTEGER	i_lo, i_hi, j_lo, j_hi, i, j, l, dset
	REAL	qswd, qlwu, rday, c5, angl, bad_rad, bad_sst, factor

* --- end of introductory code ---

* limits for calculation
	i_lo = mr_lo_s1(mrad)
	i_hi = mr_hi_s1(mrad)
	j_lo = mr_lo_s2(mrad)
	j_hi = mr_hi_s2(mrad)

* flag for bad or missing values
	bad_sst = mr_bad_data ( msst )
	bad_rad = mr_bad_data ( mrad )

* data set needed to determine which calculation to use
	dset = mr_data_set( mrad)

* ... PHILANDER/SIEGEL CODE ...
      QSWD=500.			! cal/cm**2-day
      QLWU=115.			!      "
      RDAY=1./86400.		! 1 / seconds per day
      C5=(QSWD-QLWU)*RDAY

C									!  784
C     APPROX ANNUAL SHORT WAVE DOWN - LONG WAVE UP			!  785
C									!  786
	DO 2000 l = mr_lo_s4(mrad), mr_hi_s4(mrad)

      DO 30 i = i_lo, i_hi
      DO 30 j = j_lo, j_hi					!  787 mod
      ANGL=ACOS(CS(j))*57.29578		! degrees		!  788

* select appropriate calculation for data set
	IF ( dp_phil_qflux( dset ) ) THEN

* ... Philander/Siegel heat flux (doesn't depend on SST)
           rad(i,j,l)=(-ANGL*7.5+650.-QLWU)*RDAY		!  789
           IF(ANGL.LT.20.) rad(i,j,l)=C5			!  790

* ... calculations below depend on SST
	ELSEIF( sst(i,j,l) .EQ. bad_sst ) THEN
	   rad(i,j,l) = bad_rad

	ELSEIF( dp_ramp1_qflux( dset ) ) THEN
* ... single ramp heat flux - hot regions receive less radiation
	   IF ( sst(i,j,l) .GT. 27. ) THEN
	      factor = 1. - ( 82.65 * (sst(i,j,l)-27.) / (3.*500.) )
	   ELSE
	      factor = 1.
	   ENDIF
	   IF ( angl .GT. 20. ) THEN
	      rad(i,j,l) = ( (-angl*7.5+650.)*factor - qlwu ) * rday
	   ELSE
	      rad(i,j,l) = (             qswd*factor - qlwu ) * rday
	   ENDIF

	ELSEIF( dp_ramp2_qflux( dset ) ) THEN
* ... double ramp heat flux - hot regions receive less; cold regions, more
	   IF ( sst(i,j,l) .LT. 26. ) THEN
	      factor = 1. + ( 82.65 * (26.-sst(i,j,l)) / (2.*500.) )
	   ELSEIF ( sst(i,j,l) .GT. 27. ) THEN
	      factor = 1. - ( 82.65 * (sst(i,j,l)-27.) / (3.*500.) )
	   ELSE
	      factor = 1.
	   ENDIF
	   IF ( angl .GT. 20. ) THEN
	      rad(i,j,l) = ( (-angl*7.5+650.)*factor - qlwu ) * rday
	   ELSE
	      rad(i,j,l) = (             qswd*factor - qlwu ) * rday
	   ENDIF

	ELSE
* ... unknown heat flux parameterization
	   rad(i,j,l) = bad_rad
	ENDIF
* compute increment


30    CONTINUE								!  791

 2000	CONTINUE

      RETURN								!  833
      END								!  834

	SUBROUTINE GET_MEMORY ( num_words, mblk, num_blocks, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* find and reserve a section of contiguous memory sufficient to hold num_words 
* procedure:
* first check the list of free memory regions to see if there is one big enough
* if not then delete variables working from the tail of the priority chain
* when an adequate region is found pluck what it needed of it from the free list

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/31/86
* revision 0.1 - 7/21/88 - no special call to "CLAIM_MEMORY" since FIND_MEMORY
*			   claims it, too, now
* V200:  6/12/89 - delete priorities handled through linked lists
*		 - eliminated FIND_MEMORY
*	  4/5/90 - spruced up error message
* V230:  4/30/92 - added coaching to error message
* V500:  3.20.99 Make sure num_words >= 0 (absurdly large grids can overflow
*                integer) js
* V520: 6/00 *sh* - improved error message
* V522: 7/00 *sh* corrected typo in previous ... 
* V530: 5/01 - further improved error mesages (for 9999999 words)
* v553: 9/03 *kob* - need to update error calls to include alternate return
*                    label.  Bug showed up on IRIX with missing elements
*		     of error statement
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V685 *acm*  6/13 Increase nominal length of abstract axis

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'errmsg.parm'
	include	'ferret.parm'
	include 'xvariables.cmn'

* calling argument declarations:
	INTEGER	num_words, mblk, num_blocks, status

* internal variable declarations:
	INTEGER	mr, next, prev, size, new_mblk, num_slen
	CHARACTER  LEFINT*12, num_str*12

* Number of words reasonable?
	if (num_words .lt. 0) goto 5200
	   

* COMPUTE # BLOCKS NEEDED
	num_blocks = ( num_words + mem_blk_size - 1 ) / mem_blk_size

* LOOK FOR A MEMORY REGION ALREADY AVAILABLE
* ... use linked list into free memory regions
	mblk = mblk_flink( 0 )

* ... nothing more to check ?
 100	IF ( mblk .EQ. 0 ) GOTO 200

* ... another region to check out - is it big enough ?
	size = mblk_size ( mblk )
	IF ( size .LT. num_blocks ) THEN
	   mblk = mblk_flink( mblk )
	   GOTO 100
	ELSE
	   GOTO 500
	ENDIF
	   
* NOTHING BIG ENOUGH IS AVAILABLE AT PRESENT
* delete from tail of deletion priority chain looking for something big enough
 200	mr = mr_del_blink(0)
	IF ( mr .EQ. 0 ) GOTO 5100
	CALL DELETE_VARIABLE( mr )
	size = mr_del_last_size
	IF ( size .LT. num_blocks ) THEN
	   GOTO 200
	ELSE
	   mblk = mr_del_last_mblk
	ENDIF

* WE HAVE GOT A REGION AT LEAST BIG ENOUGH
 500	prev = mblk_blink( mblk )
	next = mblk_flink( mblk )

	IF ( size .EQ. num_blocks ) THEN
* ... perfect size - remove it from the free list
	   mblk_flink( prev ) = next
	   mblk_blink( next ) = prev

	ELSE
* ... unnecessarily big - bite off only what we need
	   new_mblk = mblk + num_blocks
	   mblk_flink( new_mblk ) = next
	   mblk_blink( new_mblk ) = prev
	   mblk_size ( new_mblk ) = size - num_blocks
	   mblk_flink( prev )     = new_mblk
	   mblk_blink( next )     = new_mblk
	ENDIF

* success - set up the requested region and give it to them
	mblk_size ( mblk ) = num_blocks
	status = ferr_ok

	mblk_flink( mblk ) = unspecified_int4	! temp diag
	mblk_blink( mblk ) = unspecified_int4	! temp diag

 5000	RETURN
 5100	CONTINUE
	IF ( num_words .EQ. 99999999 ) THEN
          num_str = LEFINT(num_words,num_slen)
	  CALL ERRMSG( ferr_dim_underspec, status,
     .	  num_str(:num_slen)//' words were requested. ', *5125)
 5125	  CALL WARN('Check for unspecified limits on an ABSTRACT axis')
          CALL WARN('Use the SHOW GRID command to see the axes')
	ELSE
          num_str = LEFINT(INT((num_words+0.99999E6)/1.0E6),num_slen)
	  CALL ERRMSG( ferr_insuff_memory,status,
     .	  num_str(:num_slen)//' Mwords were requested. ', *5130)
 5130	  CALL WARN('You can use SET MEMORY/SIZE=xxx to increase memory.')
          CALL WARN('The "Memory use" section of the FERRET '
     .              //'Users Guide has further tips.') 
	ENDIF
        GOTO 5000
 5200	CONTINUE
	CALL ERRMSG( ferr_insuff_memory,status,
     .	'A negative number of words were requested. ', *5210)
 5210	CALL WARN('The current grid is most likely too large')
	RETURN
	END

	SUBROUTINE SHOW_ABORTED_MEM_STATE(i8_rqst_size)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* This routine is called following a ferr_insuff_memory error to display
* diagnostic information about the state of memory at the time of the failure.
* Specifically, how much memory was tied up for what purposes

* V702 3/17 *sh*
* V751 *acm* 6/19 Issue 1903: memory set and reported in terms of bytes

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'
	include 'xvariables.cmn'
	include 'xinterrupt.cmn'

* calling argument declarations:
	INTEGER*8 i8_rqst_size

* local variable declarations:
	INTEGER UVAR_NUMBER, TM_LENSTR1, uvar, slen, slen2, slen3
	INTEGER*8 object_mem
	CHARACTER LEFINT*8, LEFINT8*16, EXPR_NAME*8, TM_FMT*48,
     .		arg_num*8, name_code*8, mem_str*16, mem_unit*2, percent*8
	REAL*8 rmax_mem

* initialize
	rmax_mem = max_mem_allowed  ! so percentages become floating point

* write introductory line
	CALL SPLIT_LIST(pttmode_explct, show_lun,
     .		'    At the moment that the memory limit was reached',0 )

* write "Argument 2 of the command was being evaluated:" expression
	IF (num_uvars_in_cmnd .GT. 1) THEN
	   arg_num = LEFINT(current_cmnd_uvar, slen)
	   name_code = EXPR_NAME(current_cmnd_uvar)
	   uvar = UVAR_NUMBER( name_code )
	   slen2 = TM_LENSTR1(uvar_text(uvar))
	   CALL SPLIT_LIST(pttmode_explct, show_lun,
     .		'    argument '//arg_num(:slen)//' was being evaluated: '//
     .		uvar_text(uvar)(:slen2), 0)
	ENDIF

* summarize how memory was allocated
	CALL SPLIT_LIST(pttmode_explct, show_lun,
     .		'    memory was committed as follows:',0 )

	IF (permanent_mem .GT. 0) THEN
	   mem_str = LEFINT8(permanent_mem, slen2)
	   percent = TM_FMT (permanent_mem/rmax_mem*100, 0, 8, slen3)
	   CALL SPLIT_LIST(pttmode_explct, show_lun,
     .		'        - to LOAD/PERM storage: '//
     .		mem_str(:slen2)//' ('//percent(:slen3)//'%)' ,0 )
	ENDIF

	IF (current_cmnd_uvar .GT. 1) THEN
	   arg_num = LEFINT(current_cmnd_uvar-1, slen)
	   mem_str = LEFINT8(completed_args_mem, slen2)
	   percent = TM_FMT (completed_args_mem/rmax_mem*100, 0, 8, slen3)
	   CALL SPLIT_LIST(pttmode_explct, show_lun,
     .		'        - to arguments 1-'//arg_num(:slen)//
     .		': '//mem_str(:slen2)//' ('//percent(:slen3)//'%)' ,0 )
	ENDIF

	object_mem = essential_mem-completed_args_mem
	mem_str = LEFINT8(object_mem, slen2)
	percent = TM_FMT (object_mem/rmax_mem*100, 0, 8, slen3)
	CALL SPLIT_LIST(pttmode_explct, show_lun,
     .		'        - to objects used in computation: '//
     .		mem_str(:slen2)//' ('//percent(:slen3)//'%)' ,0 )


* Report the size of the requested object
	mem_str = LEFINT8(i8_rqst_size, slen2)
	percent = TM_FMT (i8_rqst_size/rmax_mem*100, 0, 8, slen3)

	CALL MEM_TO_BYTES (i8_rqst_size, mem_str, slen2, mem_unit)
	IF (i8_rqst_size .EQ. 0) mem_unit = ' '

	CALL SPLIT_LIST(pttmode_explct, show_lun,
     .		'    The size of the requested object was: '//
     .		mem_str(:slen2)//' '//mem_unit//' ('//percent(:slen3)//'%)' ,0 )

* report the activity that was underway
* ... could optionally investigate the is_act states of isp and isp-1 to report
*  "reading dtaa while gathering for average" or whatever ...

	RETURN
	END

	SUBROUTINE SORT_FMRC_DSETS (nsets_in, member_sets, maxmembers,
     .				    nsets_out, nt_out, status)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* NOAA/PMEL, Seattle, WA - TMAP 

* sort the given list of datasets based upon the starting time steps
* and insert dummy dataset where the forecast sequence has gaps
*
* V698 *sh* 11/15 
*            2/16 -- allow missing datasets among nsets_in
*            3/16 -- bug fix in epsilon used to screen bad gaps

* calling arguments
*   nsets_in		- number of datasets given to be aggregated (input)
*   member_sets		- array of open dataset numbers (input-output)
*   maxmembers		- maximum number of members allowes (input)
*   nsets_out		- number of datasets including dummy fillers (output)
*   nt_out		- time ax len (in case inconsistent) (output)
*   status		- return staus (output)

        include 'tmap_errors.parm'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
        include 'xprog_state.cmn'
	include 'xtm_grid.cmn_text'  
	include 'errmsg.parm'
	include 'netcdf.inc'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xfr_grid.cmn'
	include 'xdiag_ctrl.cmn_text'

* calling argument declarations:
	INTEGER nsets_in, nsets_out, nt_out,
     .		maxmembers, member_sets(maxmembers)

* local variable declarations:
	LOGICAL alteredDelta
	INTEGER	ivar, grid, grid1, iset, dset, dset1, taxis, taxis1,
     .		status, nadded, ngap, i, nsets, itmp_memb(maxmembers),
     .		deltaFactor
	REAL TDEST_WORLD, TM_WORLD, d, epsilon, gap, deltaT, deltaT_0,
     .		start_time(maxmembers), rindices(maxmembers),
     .		d_ratio, d_ratio_int
	CHARACTER LEFINT*8

* initialize
	dset1  = member_sets(1)
	taxis1 = ds_time_axis(dset1)
	nt_out = line_dim(taxis1)
	status = ferr_ok
	IF (nsets_in .LE. 1) RETURN

* since forecast series must be regular, and the code below
* is able to detect gaps in the list of forecasts given,we
* will simply remove the user-specified gaps, knowing they
* will be re-inserted automatically
	ngap = 0
	iset = 1
	DO WHILE (iset+ngap .LT. nsets_in)
	   IF (member_sets(iset) .EQ. pdset_dummy) THEN
	      ngap = ngap + 1
	   ELSE
	      iset = iset + 1
	   ENDIF
	   member_sets(iset) = member_sets(iset+ngap)
	ENDDO
	nsets = nsets_in - ngap
	nsets_out = nsets

* locate a variable in the first dataset that uses this time axis
	DO ivar = 1, maxvars
           IF ( ds_var_setnum(ivar) .NE. dset1 ) CYCLE
	   grid1 = ds_grid_number(ivar)
	   IF (grid_line(t_dim,grid1) .EQ. taxis1) GOTO 100
	ENDDO
	GOTO 5100

* loop through the datasets extracting the start time from each one
* Apply the T0 encoding of the first dataset to all
 100	start_time(1) = TM_WORLD( 1, grid1, t_dim, box_middle )
	DO iset = 2, nsets
	   dset  = member_sets(iset)
	   taxis = ds_time_axis(dset)
           IF (line_name_orig(taxis) .NE. line_name_orig(taxis1)) GOTO 5100
	   
* ... length of T axis in the aggregation will be the MIN of all members
	   IF (line_dim(taxis) .LT. nt_out) nt_out = line_dim(taxis)

* ... locate a variable in the first dataset that uses this time axis
	   DO ivar = 1, maxvars
              IF ( ds_var_setnum(ivar) .NE. dset ) CYCLE
	      grid = ds_grid_number(ivar)
	      IF (grid_line(t_dim,grid) .EQ. taxis) GOTO 200
	   ENDDO
	   GOTO 5100

* ... save the start time of this dataset
 200	   CALL TDEST_WORLD_INIT (grid, grid1, t_dim, status)
	   IF (status .NE. ferr_ok) GOTO 5100 
	   start_time(iset) = TDEST_WORLD(1, grid, t_dim, box_middle)
	ENDDO

* sort the dates and the dataset list
* ... put indices into REAL array
	DO iset = 1, nsets
	   rindices(iset) = iset
	ENDDO
	CALL HEAP2(start_time, rindices, unspecified_val8, nsets)
* ... reorder the dataset numbers to match the sort
	DO iset = 1, nsets
	   itmp_memb(iset) = member_sets(INT(rindices(iset)))
	ENDDO
* ... copy the sorted list back into the input array
	DO iset = 1, nsets
	   member_sets(iset) = itmp_memb(iset)
	ENDDO

* determine the intended delta-T between the (ordered) forecasts
* ... first get the minimum delta-T
	deltaT_0 = start_time(2) - start_time(1)
	DO iset = 2, nsets
	   d = start_time(iset)-start_time(iset-1)
	   IF ( d .LT. deltaT_0) deltaT_0 = d
	ENDDO
	IF (deltaT_0 .EQ. 0.0) GOTO 5250

* for monthly data delta-T may vary from 28 to 31, so allow a margin of error
	epsilon = 1.0001 * (31.-28.)/28.

* now re-evaluate the deltas to find the lowest common denominator
* i.e. if we discover there is a gap of size 1.5*deltaT, that means that
* the correct delta is new_delta= 0.5*deltaT.  This re-interprets our two
* gaps as 2*new_delta and 3*new_delta
	deltaFactor = 1
	deltaT = deltaT_0
	alteredDelta = .TRUE.
	DO WHILE (alteredDelta)
	   alteredDelta = .FALSE.
	   DO iset = 2, nsets
	      d = start_time(iset)-start_time(iset-1)
	      d_ratio = d/deltaT
* delta ratio must be an integer within epsilon threshold
	      d_ratio_int = FLOAT(INT(d_ratio + 0.49))
	      IF (ABS(d_ratio-d_ratio_int)/d_ratio .GT. epsilon) THEN
* ... we have the wrong deltaT -- try an integer fraction of it
	         deltaFactor = deltaFactor + 1
	         IF (deltaFactor .GT. 4) GOTO 5200
	         deltaT = deltaT_0 / deltaFactor
	         alteredDelta = .TRUE.
	         EXIT    ! try again with smaller delta
	      ENDIF
	   ENDDO	
	ENDDO

* loop through the data set list inserting dummys where there are gaps
	ngap = 0    ! not needed?
	nadded = 0
	iset = 1
	DO WHILE (iset .LT. nsets_out)
	   iset = iset + 1
	   d = start_time(iset)-start_time(iset-1)
	   IF (ABS(d-deltaT)/deltaT .GT. epsilon) THEN
* ... we have a gap (or at least an irregularity)
	      gap = d/deltaT
	      ngap = INT(gap + 0.5)      ! here ngap=1 means nothing missing
	      ngap = ngap - 1		 ! now  ngap=0 means nothing missing
	      nsets_out = nsets_out + ngap
	      IF (nsets_out .GT. maxmembers) THEN
	         nsets_out = maxmembers   ! needed to clean up files after err
	         GOTO 5200
	      ENDIF
*     ... open the gap
	      DO i = nsets_out, iset+ngap, -1
	         member_sets(i) = member_sets(i-ngap)
	         start_time (i) = start_time (i-ngap)
	      ENDDO
*     ... fill the gap
	      DO i = iset, iset+ngap-1
	         member_sets(i) = pdset_dummy
	      ENDDO
	      iset = iset + ngap
	   ENDIF
	ENDDO

	RETURN

* error exits
 5000	RETURN
 5100	CALL WARN(
     .		'Unable to sort forecast datasets due to corrupted times.')
	GOTO 5000
 5200	CALL ERRMSG( ferr_aggregate_error, status,
     .		'forecast start times are irregular or too gappy', *5000 )
 5250	CALL ERRMSG( ferr_aggregate_error, status,
     .		'some files have duplicate forecast start times', *5000 )

	END

      REAL FUNCTION THETA_FOFF (S, TO, PO, PR)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
**************************

C TO COMPUTE LOCAL POTENTIAL TEMPERATURE AT PF 
C USING BRYDEN 1973 POLYNOMIAL FOR ADIABATIC LAPSE RATE
C AND RUNGE-KUTTA 4-TH ORDER INTEGRATION ALGORITHM.
C
C REFERENCES:	BRYDEN,H.,1973,DEEP-SEA RES.,20,401-408
C		FOFONOFF,N,M,1977,DEEP-SEA RES.,24,489-491
C
C UNITS:
C	PRESSURE	PO	DECIBARS
C	TEMPERATURE	TO	DEG CELSIUS (IPTS-68)
C	SALINITY	S	(PSS-78)
C	REFERENCE PRS	PR	DECIBARS
C	POTENTIAL TEMP	THETA	DEG CELSIUS
C
C CHECKVALUE: THETA=36.89073 DEG C:  S=40(PSS-78), TO=40 DEG C,
C		PO=10000 DECIBARS, PR=0 DECIBARS
C
C--FROM FOFONOFF,N.,AND R.C.MILLARD,1983,DRAFT. LJM

*************************

      IMPLICIT NONE

* calling argument declarations:
      REAL S, TO, PO, PR

* internal variable declarations:
      REAL ATG, T, p, h, xk, q

      P = PO
      T = TO
      H = PR - P
      XK = H*ATG(S,T,P) 
      T = T + 0.5*XK
      Q = XK
      P = P + 0.5*H 
      XK = H*ATG(S,T,P) 
      T = T + 0.29289322*(XK - Q) 
      Q = 0.58578644*XK + 0.121320344*Q 
      XK = H*ATG(S,T,P) 
      T = T + 1.707106781*(XK - Q)
      Q = 3.414213562*XK - 4.121320344*Q
      P = P + 0.5*H 
      XK = H*ATG(S,T,P) 
      THETA_FOFF = T + (XK - 2.0*Q)/6.0
      RETURN
      END 

* **************************************************
        REAL FUNCTION ATG (salinity, temperature, pressure) 

*    Reference:  Bryden, H., 1973, Deep Sea Res., 20, 401-408.
*
*    Units:
*
*    	Pressure:		P			decibars
*    	Temperature:		T			degrees Celcius
*    	Salinity:		S			psu (IPSS-78)
*    	Adiabatic:		ATG			deg. C/decibar
*
*
*    Check value:
*    		ATG = 3.255796E-4 C/dbar for S = 40 (psu), T = 40 deg. C, 
*    		P = 10000 decibars.

        IMPLICIT NONE

* calling argument declarations:
        REAL salinity, temperature, pressure

* internal variable declarations:
	REAL S, T, p

* initialize
	S = salinity - 35.
	T = temperature
	p = pressure

	ATG = (((-2.1687e-16 * T + 1.8676e-14) * T - 4.6206e-13) * p
     .	      + ((2.7759e-12 * T - 1.1351e-10) * S + ((-5.4481e-14 * T
     .	      + 8.733e-12) * T - 6.7795e-10) * T + 1.8741e-08)) * p
     .	      + (-4.2393e-08 * T + 1.8932e-06) * S
     .	      + ((6.6228e-10 * T - 6.836e-08) * T + 8.5258e-06) * T
     .	      + 3.5803e-05

        RETURN
        END

	SUBROUTINE CDF_LIST_GLOBAL_ATTS ( dset, cdfid, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP
* Write global attributes to netcdf file

* V600  4/06 *acm* - additional declarations found by Solaris compiler
* V600  6/06 *acm* - additional declarations found by Solaris compiler
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
* V720 *acm* 5/17 Implement specific calls in place of CD_GET_VAR_INFO

        IMPLICIT NONE
#include "netcdf.inc"
        include 'cd_lib.parm'
        include 'ferret.parm'


* calling argument declarations:
        INTEGER dset, cdfid, status
        
* internal variable declarations:
        LOGICAL MATCH_NAME, NC_GET_ATTRIB, do_warn, got_it
        INTEGER TM_LENSTR1, varid, nvatts, iatt, slen, attype, attlen, 
     .          attoutflag, bufflen
	REAL	vals(100)
        CHARACTER*128 varname, attname, aname
        CHARACTER*10240 buff

        bufflen = 10240
        varid = 0
        do_warn = .TRUE.

* Get global attributes from dset and if they have been marked for output,
* write to the file cdfid

        varname = '.'
        CALL CD_GET_VAR_NATTS (dset, varid, varname, nvatts, status) 

        DO 80 iatt = 1, nvatts
           CALL CD_GET_VAR_ATT_NAME( dset, varid, iatt, attname, status)
           slen = TM_LENSTR1(attname)

           IF ( MATCH_NAME (attname,  slen, 'HISTORY', 7 ) .OR. 
     .          MATCH_NAME (attname,  slen, 'TITLE', 5 ) .OR. 
     .          MATCH_NAME (attname,  slen, 'CONVENTIONS', 11 ) ) THEN
              slen = 0   ! done elsewhere
           ELSE
              CALL CD_GET_VAR_ATT_INFO (dset, varid, iatt, aname, 
     .                  attype, attlen, attoutflag, status )

              IF (attoutflag .EQ. 0) GOTO 80
              IF (attlen .GT. 100 .AND. attype .NE. NCCHAR) 
     .            attlen = 100
              got_it = NC_GET_ATTRIB ( dset, varid, aname, do_warn, 
     .           varname, bufflen, attlen, attoutflag, buff, vals)

              IF (attype .EQ. NCCHAR .AND. attoutflag.EQ.1) THEN
                 slen = TM_LENSTR1(buff)
                 CALL CD_WRITE_ATTRIB(cdfid, pcdf_global,
     .              aname, buff(:slen), .FALSE., status )
              ELSE IF (attoutflag.EQ.1) THEN
                 CALL CD_WRITE_ATTVAL(cdfid, pcdf_global,
     .              aname, vals, attlen, attype, status )

              ENDIF
           ENDIF

 80     CONTINUE

        RETURN
        END

	SUBROUTINE DISP_SET_UP( 
     .				vector, shade, use_cell, aspect, overlay, 
     .				transpz, no_labels, no_x_rng, valx1, 
     .				density, is_logx, is_logy, mr_list, nmv, 
     .				cx_list, uvar, s1_axis, s2_axis, pen, inc_grid,
     .				set_up, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* set up for contour and vector plots by loading data and title and 
* defining axis formats

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - based on CONTOUR_CMND_DATA rev 0.1
* revision 0.1 - 2/25/87 - changes for INTERPRETATION STACK
* revision 0.2 - 5/11/87 - use list of mrs - compound titles and colors
* revision 1.0 - 6/23/87 - separated initialization code into DISP_INIT
*			   incorporated SUBR. AXIS_INTERVALS and AXIS_FORMAT to
*			   make symmetric calculations for both x and y axes 
*			   in order to permit z-t plots.  Put key/label on 
*			   overlaid plots.  Added "/transposed" option.
* revision 1.1 - 7/8/87  - separated labels for normal dimensions and data set
*			   into DISP_LABELS.  general clean-up
* revision 1.2 - 7/21/87 - added calls to AXIS_ENDS to specify precise axis ends
* revision 1.3 -  8/7/87 - added XPPLUS.CMN to pass icode to LOAD_Y_VECTOR
* revision 1.4 - 3/18/88 - added grid number and limits to AXIS_FORMAT for taxis
* revision 2.0 - 4/14/88 - added do_labels argument for /NOLABELS option
*			 - loaded Y vector component from this routine
*			 - added aspect-ratio related vector rotations
* revision 2.1 - 4/28/88 - return valx1
* revision 2.2 -  9/8/88 - added relative position flag to PUT_LABEL calls
* revision 2.3 - 9/23/88 - decision to output labels now done in PUT_LABEL
*			 - time axis style determines possible "year" display
* revision 2.4 - 1/25/89 - for overlay labels /NOLABELS is acted on here (messy)
* revision 2.5 - 2/16/89 - kludge fix to improper # dimension check
* V200:  5/19/89 - 4D symmetrical
*		 - pass uvar: use exact axis limits if given as command
*		   mods or set region
*	  1/4/89 - major mods to incorporate keys on plots, pass axes to PLOT+
*	  5/7/90 - bug fix in vector length adjustment key (don't use PPL_BUFF)
* V230:  6/12/92 - trap PLOT+ nsize limitation before passing data
*                  (fixed bug in error trapping 11/27/92)
*       10/18/92 - bug fix: /NOLABELS prevented axis endpoints and styles
*                  from being set
*        1/28/93 - allow overlays on 0 and 1D promoted regions (plotify_grp_cx)
*                - and allow all values to be bad in contour, shade, etc.
* V301:	10/26/93 - added /XLIMITS and /YLIMITS axis range specifications
*	11/ 3/93 - added /TITLE
*	 1/13/94 - trap attempts to CONTOUR or SHADE 1D region as errors
*	 2/10/94 - added /PEN= to control color easily
* V320: 5/94 - array "memory" as a calling argument
* 	9/94: restrict to 99% of NSIZE buffer - kludge fix to PLOT+ bug
*      12/29/94 - use SPLIT_LIST to redirect tty output for GUI
* V401: 6/23/95 - tag the movable labels by passing ppl_movlab minus nnn
* V420: 11/95 - change to args in AXIS_FORMAT for better time axis control
*	 2/96 - /ASPECT needs to be sensitive to /XLIMITS and /YLIMITS
*		(moved data rotating and loading to a point AFTER axis set up)
*		/ASPECT needs to be similarly sensitive to /OVERLAY 
*		==> COMMON XWINDOW_STATE has been created **temporarily**
*		    with the intention that it will be expanded in future
*		    so overlays can be placed on **previously** drawn windows
* V430: 5/96 - fixed up error message text
* Linux Port *kob* 1/97 - include new cmn file xwindow_state.cmn because
*			  locally declared common blocks aren't allowed.
* V450: 3/97 - support for curvilinear coordinate plots
*       8/97 - added curvilinear check to make sure that args 2 and 3 lie in
*              compatible planes with the variable to be plotted
* V500  4/99 - *jd* Ensure PPL knows plot is overlay: set SOVER flag here
*       6/99 - save time axis info in XPLOT_STATE to enable line plot overlays
*		(with plot/vs and polygon)
* V510	12/99 - *sh* plot of all bad data no longer an error
*        3/00 - *sh* /NOLABELS to avoid xlab & ylab
*	 5/00 - added /HLIMITS and /VLIMITS (denigrating /xlimits/ylimits)
* V520   6/00 *sh* - bug fix: trap ndim>2 on overlays
* V530 *sh* 1/01 - change "denigrated" to "deprecated"
* V530 *acm* 1/01  cal_id for alternative calendar axes.
* V533 *acm* 6/01 for LOG plots add logicals is_logx, is_logy.  set to plot
*                   log of depth as inverse axis
*       ACM  8/2001 BUG FIX: save cal id if vertical time axis
*      *acm* 10/01  remove VMS includes
*      *acm* 12/01  Allocate PPLUS memory for the flag array used by
*                   flowline.
* V541 *acm*  4/02  for flowlines, more PPLUS memory was allocated than needed.
*      *acm*  4/02  If this is an overlay, and there is no valid data, add
*                   this information variable name in the key below the plot.
* v541 *acm*  8/02  For "No Valid Data" the test is: 
*                    IF (no_x_rng .AND. (valx1.EQ.bad_val4) )
* v5.5 *acm* 11/02  Set PPLUS memory for the cells array used by cellarray 
*                   in SHADE plots
*      *acm* 12/02  When setting has_time_axis flag, only do it if an
*                   axis being used IS a time axis
* v5.51*acm*  1/03  Comment out the cellarray implementation; xgks doesnt
*                      completely implement it & has a precision bug for 
*                      large plots.  see comment lines: c no_cellarray
* V552 *acm*  3/03  Send the key string to key_loc since it may be multi-line
*      *acm*  5/03  Send the flag irregular to AXIS_INTERVALS.  
* v5.52*acm*  6/03  Restore cellarray setup. uses its_gif flag so these are
*                   only done in -gif mode
* v5.53*acm*  6/03  send correct axis to AXIS_INTERVALS
* V580 *acm* 12/04 Fix bug 1129; formatting axis for small lon/lat ranges:
*                  send delta to routine AXIS_FORMAT
* V600 *acm* 10/05 Fix bug 1347; for very fine axes, set the flag irregular in
*                  AXIS_INTERVALS, and compute the delta coordinate. Then after
*                  the call to pplldc, reset the plot type to regular if the
*                  grid is in fact regular.
* V608 *acm* 09/07 Define symbols AX_HORIZ and AX_VERT with the x,y,z,t direction 
*                  of the axes as they will appear on the plot.
* V62  *acm* 03/09 Fix bug 1649: get the value of cal_id for this time axis
*                  BEFORE using it in evaluating arguments to /hlim or /vlim 
* V630 *acm*  9/09 Introduction of syntax for variance-based and histogram levels
* V663 *acm* 07/10 If openlevels computation fails (very-large value data fields)
*                  then issue a warning and do linear levels instead.
* v68  *acm* 4/08 Allow shade, vector plots of degenerate regions - world region 
*              within a grid cell
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus.
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction.
* V685  *acm* 9/13 Fixing ticket 2092. Check that the pplus internal storage
*                  for coordinate data will be enough for the grid and if not
*                  return an error message. 
* V686 *acm* 12/13 Symbols AX_HORIZ and AX_VERT may be x,y,z,t,e,f  
* V691  *acm*  5/14 Clean up temp memory used for computing histogram levels
* V694  *acm*  1/15 Changes to allow two time axes on plot (F-T)
* V695+ *sh*  3/15 if an FMRC dataset disambiguate T and F axes with labels
* V695  *acm* 9/15 send REAL*4 rbad to compare with lev_max, lev_min inside std
* V697  *acm* 2/16 Fix ticket 2360: overlays on time plots
* V697  *acm* 2/16 Fix ticket 2365: overlays with a single vector (or single-valued variable)
*                  returned a status flag of 0 from COMPUTE_MNSTD. Set status to ferr_ok
*                  after handling the condition.
* V701  *acm* 8/16 Fix ticket 2463: single-valued data with a /LEVELS setting
* V701  *acm* 8/16 Fix ticket 2468: Symbols AX_HORIZ and AX_VERT are not reset on an /OVERLAY plot
* V702  *acm* 10/16 Test the results of FIELD_MINMAX routine before use; if all data is 
*                   all-missing it returns arbitrary_large_val4.
* V710  *acm* 11/16 Ticket 2483: Fix the axis-end symbols that are defined 
*                   for time axis plots
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.
* V71  1/17 *acm* For ticket 2494: Single-cell SHADE plots allowed. 
*                 Handle degenerate region info.
* V72  3/17 *acm* Changes for ticket 2517, call to AXIS_ENDS changed.
* V73+ 1/18 *acm* Changes for Issue 1009; precsision in time info sent to pplus for 2D plots
*                 scaling for axis coords and box edges
* V740: 1/18 *acm* for issue 1854, protection status temporarily reset 
*                 for curvi-coord plot with /SET
* V740: 2/18 *acm* for issue 1860, change to call to Re-Orient; cos(lat) correction
*                  in vector planes such as XZ

C replace includes with those from plot_set_up, 
C plus those starting w/ xbox_bounds:

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
        include 'xunits.cmn_text'
	include 'ferret.parm'
	include 'plot_setup.parm'
	include 'errmsg.parm'
	include 'slash.parm'
	include 'xplot_setup.cmn'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'
	include 'xtext_info.cmn'
        include 'axis_inc.decl'    ! with axis lengths
        include 'AXIS.INC'         ! with axis lengths
	include 'PPLDAT.INC'
        include 'switch_inc.decl'
        include 'SWITCH.INC'

	include 'xbox_bounds.cmn'
	include 'xcurvilinear.cmn'
	include 'command.parm'
	include 'xcommand.cmn'
	include 'xpplus.cmn'

*kob 1/97
	include 'xwindow_state.cmn'


* calling argument declarations:
	LOGICAL		vector, overlay, transpz, no_labels, no_x_rng,
     .			is_logx, is_logy, flows, shade, inc_grid, set_up
	INTEGER		nmv, mr_list( nmv ), cx_list( nmv ), uvar,
     .			density, pen, status
	REAL 		aspect, valx1, s1_axis(*), s2_axis(*)

* internal variable declarations:
	CHARACTER*1020	COMPOUND_TITLE, COMPOUND_KEY, plot_title
	CHARACTER	TM_FMT*48, LEFINT*8, LEFT_REAL*16, INTERNAL_WHOI_DATE*14, 
     .                  xstyle*3, ystyle*3, cmnd_name*8, year*4, buff*8,
     .			letter*1, buff1*16, buff2*16, buff30*30,
     .                  TM_GET_CALENDAR_NAME*32, cal_name_1*32, 
     .                  cal_name_2*32, err_string*128,
     .			xtra_xlab*24, xtra_ylab*24, t1_date*14

        CHARACTER*1     axdir(6)

	LOGICAL		NO_GRID_RANGE, GEOG_LABEL, TM_FPEQ, ITS_FMRC, 
     .			ITSA_TRUEMONTH_AXIS,
     .			user_title, time_axis, time_axis_dim1, time_axis_dim2, 
     .			timeax_both, 
     .			regrid_1, regrid_2, no_y_rng, edges_ok,
     .			ITS_GIF_GRAPHICS, its_gif, REGULARLY_SPACED,
     .                  irregular, use_cell, valid, vflag

	INTEGER		TM_LENSTR1, CX_DIM_LEN, CGRID_SIZE,
     .			i, dim1, dim2, mvx, mvx_temp, mvy, mvy_temp,
     .			ctx, cty, plot_mem_used, nvars,
     .			lo1, lo2, hi1, hi2, size1, size2, size,
     .			n1_regrid, n2_regrid, grid, slen, pxlim, pylim,
     .			style, justify, ipen, ndim, dims(nferdims), ptitl,
     .			arg_xpos, cx_xpos, cx_ypos, mr_xpos, mr_ypos,
     .			phlim, pvlim, slen2, cal_id, tax,
     .			x_axtyp, y_axtyp, iscl, siz, nsiz, 
     .			TM_GET_CALENDAR_ID, mode_num, axis1, axis2,
     .                  mvh_temp, n_res, ndec, places
	REAL		s, w1_lo, w1_hi, w2_lo, w2_hi, valy1,
     .			d1_regrid, d2_regrid, bad_x, bad_y, rlo, rhi,
     .			xkeypos, ykeypos, xkeysize, ykeysize, lab_ht,
     .                  first, last, res_del
	REAL*8		xaxlo, xaxhi, yaxlo, yaxhi, delta
	REAL*4		rw1lo, rw2lo, rbad, dt_min, bounds(2)

        DATA axdir / 'X', 'Y', 'Z', 'T', 'E', 'F' /

* signal that plot set-up has begun
	IF ( mode_diagnostic ) CALL SPLIT_LIST(pttmode_explct, ttout_lun,
     .			'setting up 2D plot', 18 )

* initialize
	mvx	  = mr_list( 1 )
	ctx       = cx_list  ( 1 )
	grid	  = mr_grid( mvx )
	bad_x	  = mr_bad_data( mvx )
	cal_id    = 1
	x_axtyp   = 1
	y_axtyp   = 1
        plot_mem_used = 0
	mvx_temp  = 0
	adjust_time = .FALSE.
	vflag     = .FALSE.
	bb_x_fac  = 1.
	bb_x_off  = 0.
	bb_y_fac  = 1.
	bb_y_off  = 0.

	IF ( vector ) THEN
	   mvy	  = mr_list( 2 )
	   cty	  = cx_list  ( 2 )
	   bad_y  = mr_bad_data( mvy )
	ENDIF
	phlim = qual_given( slash_hlimits )
	pvlim = qual_given( slash_vlimits )
	IF ( transpz ) THEN
	  pxlim = qual_given( slash_ylimits )
	  pylim = qual_given( slash_xlimits )
	ELSE
	  pxlim = qual_given( slash_xlimits )
	  pylim = qual_given( slash_ylimits )
	ENDIF
	ptitl = qual_given( slash_title )
	user_title = ptitl .GT. 0

* get 4D shape of data region to load (already oversized)
	dim1 = plot_axis(1)
	dim2 = plot_axis(2)
	axis1 = grid_line(dim1, grid)
	axis2 = grid_line(dim2, grid)
	size1 = CX_DIM_LEN( dim1, ctx )
	size2 = CX_DIM_LEN( dim2, ctx )
	size  = size1 * size2


* determine PLOT+ memory required 

        plot_mem_used = CGRID_SIZE( cx_list(1) ) + size1 + size2
        IF ( vector ) 
     .        plot_mem_used = plot_mem_used * 2

	flows     = qual_given( slash_vect_flowline  ).GT.0

!  For flowlines, more PLOT+ memory needed; based on density parameter and
!  grid size.

        IF ( flows ) THEN
           nsiz = MAX(size1, size2)
           iscl = 200/nsiz
           iscl = iscl + density - 5
           IF (iscl .LT. 1) iscl = 1
           IF (iscl .GT. 10) iscl = 10

C   set up memory for the flag grid

           siz = (nsiz*nsiz*(iscl*iscl +2)) + nsiz*iscl   ! see flowline
           plot_mem_used = plot_mem_used + siz
        ENDIF

* set flag indicating a 2D plot is on the screen
	twodee_on = .TRUE.

* save axis pointers so PLOT+ can get box boundaries
	bb_grid = grid

* On a plot/set, the intervening commands may change the default grid.
* Increment the grid. It will be decremented at the end of xeq_pplus

	bb_grid_inccount = 0
	IF (inc_grid) THEN
	   bb_grid_inccount = 1
	   CALL TM_USE_DYN_GRID(grid)  ! see ticket 883
	ENDIF

	IF ( transpz ) THEN
	   bb_yaxis = dim1
	   bb_xaxis = dim2
	ELSE
	   bb_xaxis = dim1
	   bb_yaxis = dim2
	ENDIF

* check for valid data plane
	CALL GET_CX_DIMS( ctx, ndim, dims )
	IF ( ndim .GT. 2 ) GOTO 5160
	IF ( overlay ) THEN
* *sh* 1/93 - restrictions less: coords merely have to be valid in 2D plane
* acm  1/17 - Allow degenerate regions lo=hi 
           IF ( cx_lo_ss(ctx,dim1) .EQ. unspecified_int4
     .     .OR. cx_lo_ww(dim1,ctx) .GT. cx_hi_ww(dim1,ctx) ) GOTO 5150
           IF ( cx_lo_ss(ctx,dim2) .EQ. unspecified_int4
     .     .OR. cx_lo_ww(dim2,ctx) .GT. cx_hi_ww(dim2,ctx) ) GOTO 5150
	ELSEIF ( vector) THEN     ! 1/94
	   IF ( nplot_axis .GT. 2 ) GOTO 5160
	ENDIF

* check # of variables and consistency in X and Y component dimensions
	IF ( vector ) THEN
	   nvars = 2
	   IF ( num_uvars_in_cmnd .EQ. 4 ) THEN
	      curvilinear = .TRUE.
	      arg_xpos = 3		! 3rd cmd arg is X positions
	   ELSE
	      curvilinear = .FALSE.
	      IF ( num_uvars_in_cmnd .GT. 2 ) GOTO 5300
	   ENDIF
	   IF ( CX_DIM_LEN(dim1,ctx) .NE. CX_DIM_LEN(dim1,cty)
     .	  .OR.  CX_DIM_LEN(dim2,ctx) .NE. CX_DIM_LEN(dim2,cty) )
     .		CALL ERRMSG( ferr_inconsist_plane, status,
     .			'X and Y vector components', *5100 )
	ELSE
	   nvars = 1
	   IF ( num_uvars_in_cmnd .EQ. 3 ) THEN
	      curvilinear = .TRUE.
	      arg_xpos = 2
	   ELSE
	      curvilinear = .FALSE.
	      IF ( num_uvars_in_cmnd .GT. 1 ) GOTO 5300
	   ENDIF
	ENDIF

* If its a multi-argument curvilinear request check that the xpos, ypos
* fields are conformable with the field of values
	IF ( curvilinear ) THEN
	   IF (.NOT. overlay) use_keys = .FALSE.
	   edges_ok = cmnd_num.EQ.cmnd_shade
	   mr_xpos = mr_list(arg_xpos)
	   mr_ypos = mr_list(arg_xpos + 1)
	   cx_xpos = cx_list(arg_xpos)
	   cx_ypos = cx_list(arg_xpos + 1)
* Note that the plot axes have never been transposed by this point
	   IF ( CX_DIM_LEN(plot_axis(3),cx_xpos) .GT. 1
     .	   .OR. CX_DIM_LEN(plot_axis(4),cx_xpos) .GT. 1
     .	   .OR. CX_DIM_LEN(plot_axis(1),cx_xpos) .EQ. 1 ) THEN
	      letter = 'X'
	      GOTO 5400
	   ELSEIF ( CX_DIM_LEN(plot_axis(3),cx_ypos) .GT. 1
     .	   .OR. CX_DIM_LEN(plot_axis(4),cx_ypos) .GT. 1
     .	   .OR. CX_DIM_LEN(plot_axis(2),cx_ypos) .EQ. 1 ) THEN
	      letter = 'Y'
	      GOTO 5400
	   ENDIF
	ENDIF

* create temporary buffers to contain the plot data
	CALL CREATE_TEMP_MEM_VAR( ctx, mvx_temp, status )
	IF ( status .NE. ferr_ok ) RETURN
	IF ( vector ) THEN
	   CALL CREATE_TEMP_MEM_VAR( cty, mvy_temp, status )
	   IF ( status .NE. ferr_ok ) GOTO 5010
	ENDIF

* copy the plot data to the buffer(s) - possibly transposing
	IF ( transpz ) THEN
	   CALL COPY_GRID_TRANS( size1, size2,
     .				 memry(mvx)%ptr, mvx,
     .				 memry(mvx_temp)%ptr, mvx_temp )
	   IF ( vector )
     .		CALL COPY_GRID_TRANS(   size1, size2,
     .					memry(mvy)%ptr, mvy,
     .					memry(mvy_temp)%ptr, mvy_temp )
	ELSE
	   CALL COPY_GRID( memry(mvx)%ptr, mvx,
     .			   memry(mvx_temp)%ptr, mvx_temp )
	   IF ( vector )
     .		CALL COPY_GRID(	memry(mvy)%ptr, mvy,
     .				memry(mvy_temp)%ptr, mvy_temp )
	ENDIF
	
* determine plotting limits
	IF ( transpz ) THEN
	   dim2 = plot_axis(1)
	   dim1 = plot_axis(2)
	   axis1 = grid_line(dim1, grid)
	   axis2 = grid_line(dim2, grid)
	ENDIF
	lo1  = cx_lo_ss( ctx, dim1 )
	hi1  = cx_hi_ss( ctx, dim1 )
	lo2  = cx_lo_ss( ctx, dim2 )
	hi2  = cx_hi_ss( ctx, dim2 )
	size1 = hi1 - lo1 + 1
	size2 = hi2 - lo2 + 1

* define special axis labels to disambiguate T and F axes
	xtra_xlab = ' '
	xtra_ylab = ' '
        IF ( ITS_FMRC(grid) ) THEN
* ... add these labels only if the plot has two calendar axes
	   IF ( GEOG_LABEL(t_dim,grid)
     .	 .AND.  GEOG_LABEL(f_dim,grid)
     .	 .AND.  (dim1.EQ.t_dim .OR. dim1.EQ.f_dim)
     .	 .AND.  (dim2.EQ.t_dim .OR. dim2.EQ.f_dim) ) THEN
	      IF (dim1 .EQ. t_dim) THEN
	         xtra_xlab = 'Verification Time ==>'
	         xtra_ylab = 'Initialization Time ==>'
	      ELSE
	         xtra_xlab = 'Initialization Time ==>'
	         xtra_ylab = 'Verification Time ==>'
	      ENDIF
	   ENDIF
	ENDIF

* Define symbols AX_HORIZ and AX_VERT with the x,y,z,t direction 
* of the axes as they will appear on the plot.

	IF (.NOT.overlay) THEN
        buff1 = axdir(dim1)
	CALL PPLCMD ( from, line, 0, 'SET AX_HORIZ '//buff1, 1, 1 )

        buff1 = axdir(dim2)
        CALL PPLCMD ( from, line, 0, 'SET AX_VERT '//buff1, 1, 1 )
	ENDIF

* check that there is some valid data
	no_x_rng = NO_GRID_RANGE( memry(mvx_temp)%ptr, size, mvx_temp, valx1 )
	IF ( no_x_rng .AND. valx1 .EQ. bad_x ) valx1 = bad_val4
	IF ( vector ) THEN
	   no_y_rng = NO_GRID_RANGE( memry(mvy_temp)%ptr, size, mvy_temp, valy1 )
	   IF ( no_y_rng .AND. valy1 .EQ. bad_y  ) THEN
	      valx1 = bad_val4
	      no_x_rng = no_y_rng	! need both to have either
	   ENDIF
	ENDIF

* determine axis re-gridding needs 
* (for true-month axis we can treat axis as regular)

        irregular = .NOT. ( line_regular(axis1) )
	CALL AXIS_INTERVALS( 'X', mvx_temp, ctx, dim1, curvilinear, s1_axis,
     .			     mr_lo_ss(mvx_temp,dim1), mr_hi_ss(mvx_temp,dim1),
     .			     w1_lo, w1_hi, n1_regrid, d1_regrid, regrid_1,
     .                       irregular )
        IF (size1 .EQ. 1) THEN
	   w1_lo = (cx_hi_ww(dim1,ctx) + cx_lo_ww(dim1,ctx))/2.
	   w1_hi = w1_lo
	   d1_regrid = cx_hi_ww(dim1,ctx) - cx_lo_ww(dim1,ctx)
	ENDIF

        irregular = .NOT. ( line_regular(axis2) )
	CALL AXIS_INTERVALS( 'Y', mvx_temp, ctx, dim2, curvilinear, s2_axis,
     .			     mr_lo_ss(mvx_temp,dim2), mr_hi_ss(mvx_temp,dim2),
     .			     w2_lo, w2_hi, n2_regrid, d2_regrid, regrid_2,
     .                       irregular )
        IF (size2 .EQ. 1) THEN
	   w2_lo = (cx_hi_ww(dim2,ctx) + cx_lo_ww(dim2,ctx))/2.
	   w2_hi = w2_lo
	   d2_regrid = cx_hi_ww(dim2,ctx) - cx_lo_ww(dim2,ctx)
	ENDIF

	IF ( regrid_1 .OR. regrid_2 ) THEN
	   icode = 1
	ELSE
	   icode = 0
	ENDIF

!  For SHADE plots, more PLOT+ memory needed for the cells array
!  used in cellarray call.  (s1_axis and s2_axis have been set by now.)

        its_gif = ITS_GIF_GRAPHICS()

        irregular = .NOT. ( line_regular(axis1) )
        IF (.NOT. irregular)
     .      irregular = .NOT. ( line_regular(axis2) )

        use_cell  = .FALSE.

        IF ( shade  .AND. 
     .       (.NOT.overlay) .AND. 
     .       (its_gif) .AND. 
     .       (.NOT.mode_metafile) .AND.
     .       (.NOT.curvilinear) .AND. 
     .       (.NOT.irregular) ) use_cell = .TRUE.
        IF (use_cell) THEN
           nsiz = size1* size2
           plot_mem_used = plot_mem_used + nsiz
        ENDIF

* For 3-argument curvilinear plots, see if we want to 	 
* do modulo replications of the data.	 
 	 
         IF (curvilinear) xmodulo = qual_given(slash_shad_mod) .GT. 0	 
     .                        .OR. qual_given(slash_cont_mod) .GT. 0   
     .                        .OR. qual_given(slash_polygon_mod) .GT. 0  
     .                        .OR. qual_given(slash_vect_mod) .GT. 0  

* set up PLOT+ to ignore bad data flag
	ppl_buff = ' '
	WRITE ( ppl_buff, 3005 ) mr_bad_data( mvx )
 3005	FORMAT ( 'LIMITS ',G15.8,' ZEQ' )
	CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )

* assign a color for the data plotting

	IF ( pen .LT. 0 ) THEN    ! 2/94
	   ipen = nvect_on + ncont_on + 1
	ELSE
	   ipen = pen
	ENDIF
	WRITE ( ppl_buff, 3105) ipen
	CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
 3105	FORMAT('PEN 1,',I3)

* set up the axis formats (use exact limits, if given by /HLIMITS or /VLIMITS)

	time_axis = GEOG_LABEL( dim1, grid )  .AND. 
     .                 (dim1.EQ.t_dim .OR. dim1.EQ.f_dim) 

	IF ( .NOT.overlay ) has_time_axis = time_axis	! save for PLOT/VS/OVERLAY (6/99)
	IF (time_axis) THEN
           tax = grid_line(dim1, grid)
           cal_id = TM_GET_CALENDAR_ID ( line_cal_name(tax) )
           IF(overlay .AND. cal_id .NE. saved_calendar_id) GO TO 5660
           
	   IF ( .NOT.overlay ) THEN
	      saved_calendar_id = cal_id
	      ppl_buff = ' '
              WRITE ( ppl_buff, 3004 ) line_cal_name(tax)
              CALL PPLCMD (from, line, 0, ppl_buff, 1, 1)
 3004         FORMAT ('CALENDAR ', A7)
	   ENDIF

* Send the start time and time units for overlay to PPLUS
	   IF (overlay) THEN
	      t1_date =  INTERNAL_WHOI_DATE(grid, dim1, 1.0D0 )
	      dt_min = line_tunit( grid_line(dim1,grid) ) / 60.
	      IF (ITSA_TRUEMONTH_AXIS(grid_line(dim1,grid))) 
     .                dt_min = un_convert(pun_day)/60. 
	      CALL SET_T1_DATE (t1_date, dt_min)
	   ENDIF
        ELSE
	
* Time on the vertical axis?
	   IF (GEOG_LABEL( dim2, grid )  .AND. 
     .                  (dim2.EQ.t_dim .OR. dim2.EQ.f_dim)) THEN

* Send the start time and time units for overlay to PPLUS
	      IF (overlay) THEN
	         t1_date =  INTERNAL_WHOI_DATE(grid, dim2, 1.0D0 )
	         dt_min = line_tunit( grid_line(dim2,grid) ) / 60.
	         IF (ITSA_TRUEMONTH_AXIS(grid_line(dim2,grid))) 
     .                dt_min = un_convert(pun_day)/60. 
	         CALL SET_T1_DATE (t1_date, dt_min)
	      ENDIF
	   ENDIF

	ENDIF


	IF ( .NOT.overlay ) THEN

	   IF ( pxlim .GT. 0 ) THEN
	      IF (.NOT.denig_xylim_msg_done) THEN
	         CALL WARN( '/XLIMITS and /YLIMITS are deprecated.')
	         CALL WARN( 'Use /HLIMITS and /VLIMITS instead.')
	         denig_xylim_msg_done = .TRUE.
	      ENDIF
              tax = grid_line(f_dim, grid)
              IF (tax .EQ. 0) tax = grid_line(f_dim, grid)
              cal_id = TM_GET_CALENDAR_ID ( line_cal_name(tax) )
	      CALL EQUAL_RANGE_T( cmnd_buff(qual_start(pxlim):qual_end(pxlim)),
     .				dim1, grid, xaxlo, xaxhi, delta,
     .				cal_id, status )
	      IF ( status .NE. ferr_OK ) GOTO 5000
	   ELSEIF ( phlim.GT.0 ) THEN
	      CALL EQUAL_RANGE_T(cmnd_buff(qual_start(phlim):qual_end(phlim)),
     .				 bb_xaxis, grid, xaxlo, xaxhi, delta,
     .				 cal_id, status )
	      IF ( status .NE. ferr_OK ) GOTO 5000
	   ELSEIF ( curvilinear ) THEN
	      CALL FIELD_MINMAX( memry(mr_xpos)%ptr, 
     .				mr_xpos, cx_xpos, rlo, rhi )

	      IF (rlo .EQ. arbitrary_large_val4) THEN ! all missing
	         xaxlo = -1
	         xaxhi = 1
	      ElSE
	         xaxlo = rlo
	         xaxhi = rhi
	      ENDIF
	      IF (xaxlo .EQ. xaxhi) THEN
		 letter = 'X'
		 GOTO 5500
	      ENDIF
	      delta = unspecified_val8
	   ELSE
	      CALL CHOOSE_CX_WW( uvar, cx_cmnd, ctx, dim1, xaxlo, xaxhi, size1 )
	      IF (xaxlo .EQ. xaxhi) THEN
	         rw1lo = xaxlo
	         CALL BOX_BOUNDS( 'X', rw1lo, 1, bounds, valid )
		 xaxlo = bounds(1)
		 xaxhi = bounds(2)
	      ENDIF
              IF (shade_trim) CALL TRIM_AXIS_ENDS( uvar, cx_cmnd, ctx, 
     .                        dim1, xaxlo, xaxhi )
              IF (xaxlo .GE. xaxhi) GOTO 5160
	      delta = unspecified_val8
	   ENDIF

	   haxlo = xaxlo	! save limits so overlays
	   haxhi = xaxhi	! will know them

	   CALL AXIS_ENDS  ( 'X', dim1, grid, xaxlo, xaxhi, delta, is_logx,
     .			      x_axtyp, vflag, status )
	   IF ( status .NE. ferr_ok ) THEN
              first = xaxlo
              last  = xaxhi
              GOTO 5700
           ENDIF

	   timeax_both = .FALSE.
	   CALL AXIS_FORMAT( 'X', dim1, grid, xaxlo, xaxhi, delta,
     .                       curvilinear, cx_xpos,
     .                       time_axis,timeax_both,xstyle,
     .			     no_labels, xtra_xlab, bb_x_fac, bb_x_off)

           time_axis_dim1 = time_axis

* second axis

	   time_axis = GEOG_LABEL( dim2, grid )  .AND. 
     .                  (dim2.EQ.t_dim .OR. dim2.EQ.f_dim)
     
           time_axis_dim2 = time_axis

	   has_time_axis = has_time_axis .OR. time_axis ! 6/99

C ACM added 8/2001 save cal id if vertical time axis
           IF (time_axis) THEN
              tax = grid_line(dim2, grid)
              cal_id = TM_GET_CALENDAR_ID ( line_cal_name(tax) )
	      IF(overlay .AND. cal_id .NE. saved_calendar_id) GO TO 5660
	      ppl_buff = ' '
	      WRITE ( ppl_buff, 3004 ) line_cal_name(tax)
              CALL PPLCMD (from, line, 0, ppl_buff, 1, 1)
	      saved_calendar_id = cal_id
           ENDIF

	   IF ( pylim .GT. 0 ) THEN
	      IF (.NOT.denig_xylim_msg_done) THEN
	         CALL WARN( '/XLIMITS and /YLIMITS are deprecated.')
	         CALL WARN( 'Use /HLIMITS and /VLIMITS instead.')
	         denig_xylim_msg_done = .TRUE.
	      ENDIF
	      CALL EQUAL_RANGE_T( cmnd_buff(qual_start(pylim):qual_end(pylim)),
     .				dim2, grid, yaxlo, yaxhi, delta,
     .				cal_id, status )
	      IF ( status .NE. ferr_OK ) GOTO 5000
	   ELSEIF ( pvlim.GT.0 ) THEN 
	      CALL EQUAL_RANGE_T(cmnd_buff(qual_start(pvlim):qual_end(pvlim)),
     .				 bb_yaxis, grid, yaxlo, yaxhi, delta,
     .				 cal_id, status )
	      IF ( status .NE. ferr_OK ) GOTO 5000
	   ELSEIF ( curvilinear ) THEN
	      CALL FIELD_MINMAX( memry(mr_ypos)%ptr,
     .				mr_ypos, cx_ypos, rlo, rhi )
	      IF (rlo .EQ. arbitrary_large_val4) THEN ! all missing
	         yaxlo = -1
	         yaxhi = 1
	      ElSE
	         yaxlo = rlo
	         yaxhi = rhi
	      ENDIF

	      IF (yaxlo .EQ. yaxhi) THEN
		 letter = 'Y'
		 GOTO 5500
	      ENDIF
	      delta = unspecified_val8
	   ELSE
	      CALL CHOOSE_CX_WW( uvar, cx_cmnd, ctx, dim2, yaxlo, yaxhi, size2 )
	      IF (yaxlo .EQ. yaxhi) THEN
	         rw1lo = yaxlo
	         CALL BOX_BOUNDS( 'Y', rw1lo, 1, bounds, valid )
		 yaxlo = bounds(1)
		 yaxhi = bounds(2)
	      ENDIF
              IF (shade_trim) CALL TRIM_AXIS_ENDS( uvar, cx_cmnd, ctx, 
     .                        dim2, yaxlo, yaxhi )
              IF (yaxlo .GE. yaxhi) GOTO 5160
	      delta = unspecified_val8
	   ENDIF

	   vaxlo = yaxlo	! save limits so overlays
	   vaxhi = yaxhi	! will know them

	   CALL AXIS_ENDS  ( 'Y', dim2, grid, yaxlo, yaxhi, delta, is_logy,
     .			      y_axtyp, vflag, status )
	   IF ( status .NE. ferr_ok ) THEN
              first = xaxlo
              last  = xaxhi
              GOTO 5700
           ENDIF 
	   timeax_both = (time_axis .AND. time_axis_dim1) 
	   CALL AXIS_FORMAT( 'Y', dim2, grid, yaxlo, yaxhi, delta,
     .                       curvilinear, cx_ypos,
     .                       time_axis,timeax_both,ystyle,
     .			     no_labels, xtra_ylab, bb_y_fac, bb_y_off)

*   When not an overlay, set the axis type to log or reverse log
	   IF (is_logx .OR. is_logy) THEN
	      WRITE (buff2, 3006) x_axtyp, y_axtyp

 3006         FORMAT ('axtype,', I2, ',', I2)
	      CALL PPLCMD ( from, line, 0, buff2, 1, 1)
	   ENDIF

        ELSE   ! .NOT.overlay

* On an overlay, does a short high res time axis need rescaling?

	   n_res = 15
	   IF (time_axis_dim1) THEN 
	      res_del = ABS( w1_hi - w1_lo ) / n_res
	      CALL GET_PREC_DIGITS( w1_lo, w1_hi, res_del, places, ndec )

	      IF (places .GT. 7) THEN
	         dt_min = line_tunit( grid_line(dim1,grid) ) / 60.
	         IF (line_tunit( grid_line(dim1,grid) ) .EQ. 1) bb_x_fac = dt_min
	         bb_x_off = -1.*w1_lo
	      ENDIF
	   ENDIF
	
	   IF (time_axis_dim2) THEN 
	      res_del = ABS( w2_hi - w2_lo ) / n_res
	      CALL GET_PREC_DIGITS( w2_lo, w2_hi, res_del, places, ndec )
	   
	      IF (places .GT. 7) THEN
	         IF (line_tunit( grid_line(dim2,grid) ) .EQ. 1) bb_y_fac = 1/60.
	         bb_y_off = -1.*w2_lo
	      ENDIF
	   ENDIF
	   
        ENDIF

* rotate vectors to make axis scale ratio correction ?
	IF ( vector .AND. aspect.GT.0. ) CALL RE_ORIENT(
     .			haxlo, haxhi, vaxlo, vaxhi, dim1, dim2,
     .			size1, size2, transpz, aspect, ctx,
     .			memry(mvx_temp)%ptr, mvx_temp,
     .			memry(mvy_temp)%ptr, mvy_temp, s )
	if (overlay) SOVER = .true.


* The coordinates are loaded into PPLUS arrays. Check that the grid
* isn't too large.
	CALL CHECK_2D_SIZE (size1, size2, err_string, status)
	IF (status .NE. ferr_ok) GOTO 5720

* load contour data into PPLUS and (possibly) regrid to regular grid

	rw1lo = w1_lo
	rw2lo = w2_lo

* scale and offset to rescale time?

	IF (bb_x_off .NE. 0.0 .OR. bb_x_fac .NE. 1.0) THEN
	   rw1lo = (w1_lo + bb_x_off) * bb_x_fac
	   DO i = 1, size1
	      s1_axis(i) = (s1_axis(i) + bb_x_off) * bb_x_fac 
	   ENDDO
	   d1_regrid = s1_axis(2) - s1_axis(1)
	ENDIF
	IF (bb_y_off .NE. 0.0 .OR. bb_y_fac .NE. 1.0) THEN
	   rw2lo = (w2_lo + bb_y_off) * bb_y_fac
	   DO i = 1, size2
	      s2_axis(i) = (s2_axis(i) + bb_y_off) * bb_y_fac 
	   ENDDO
	   d2_regrid = s2_axis(2) - s2_axis(1)
	ENDIF

	CALL PPLLDC_envelope ( icode, memry(mvx_temp)%ptr, size1, size2,
     .		      1, size1, 1, size2, s1_axis, s2_axis, 
     .		      n1_regrid, n2_regrid, rw1lo, rw2lo,
     .		      d1_regrid, d2_regrid, plot_mem_used)

* load curvilinear pointers and sizes for later access from PLOT+
	IF ( curvilinear ) THEN
	   wwxmin = xaxlo
	   wwxmax = xaxhi
	   wwymin = yaxlo
	   wwymax = yaxhi
	   CALL LOAD_CURVILINEAR( memry(mr_xpos)%ptr,
     .				  memry(mr_ypos)%ptr,
     .				  dim1, dim2, arg_xpos,
     .				  edges_ok, mr_xpos, mr_ypos,
     .				  cx_xpos, cx_ypos, ctx, set_up,
     .				  status)
	   IF ( status .NE. ferr_ok) GOTO 5100
	ENDIF

* Compute data mean and if needed for the levels setting the std, store
* in common.  If the user set a std to use, store that.
* send 	REAL*4 rbad to compare with lev_max, lev_min inside compute_mnstd
* If the user set some /LEVELS then compute_mnstd just returns 

       nsiz = size1* size2
       rbad = bad_val4
       CALL COMPUTE_MNSTD (memry(mvx_temp)%ptr, bad_x, need_std, 
     .       nsiz, rbad, status)
       IF (need_std .AND. status.NE.ferr_ok) THEN
* ... set up for automatic levels
          CALL PPLCMD ( from, line, 0, 'LEV,()', 1, 1 )
          CALL USE_LINEAR_LEVELS
          status = ferr_ok
       ENDIF

* If histogram-based levels are requested, compute the 
* histogram bins.

       IF (need_histo) THEN
* create temporary buffer to contain workspace
	  CALL CREATE_TEMP_MEM_VAR( ctx, mvh_temp, status )
	  IF ( status .NE. ferr_ok ) RETURN
          plot_mem_used = plot_mem_used + nsiz

	  CALL compute_histo_bins (memry(mvx_temp)%ptr, memry(mvh_temp)%ptr, 
     .       bad_x, nsiz, status) 
     
* ... clean up temporary variable
	  CALL DELETE_VARIABLE( mvh_temp )
       ENDIF

* For cases where regrid was set in AXIS_INTERVALS not because of a 
* subspan modulo axis, but because the axis precsion is too small for 
* single precision representation, now we reset the plot type to regular 
* if the axes are in fact regular.

        IF (line_regular(axis1) .AND. line_regular(axis2)) 
     .      CALL SET_REGULAR_PLOT

	CALL DELETE_VARIABLE( mvx_temp )

	IF ( vector ) THEN
* load the Y vector component
	   CALL PPLLDV_envelope ( icode, memry(mvy_temp)%ptr, size1, size2,
     .		      1, size1, 1, size2)
	   CALL DELETE_VARIABLE( mvy_temp )
	ENDIF
	
	IF ( no_labels ) RETURN

! ====================== LABELS ========================

* if we are starting from a blank screen compose a title
* if we are overlaying on a plot put the new variable name on as a key
	IF ( user_title ) THEN
	   CALL EQUAL_STR_LC(
     .			cmnd_buff(qual_start(ptitl):qual_end(ptitl)),
     .                  plot_title, status )
           IF ( status .NE. ferr_ok ) GOTO 5000
	   slen = TM_LENSTR1( plot_title )
	ENDIF
	IF ( overlay ) THEN
* ... cook up a key label for this variable only (or pair for VECTOR)
*     If no valid data (no_x_rng) add this info to the label.
	   use_keys = .TRUE.
	   IF ( .NOT.user_title ) THEN
	      CALL OV_GRP_CX_DOC( cx_list, nmv, cx_xtra_doc )
	      plot_title = COMPOUND_KEY( cx_list, nvars, cx_xtra_doc, slen )
	   ENDIF
           IF (no_x_rng .AND. (valx1.EQ.bad_val4) ) THEN
              plot_title(slen+1:slen+14) = ' No Valid Data'
              slen = slen + 14
           ENDIF
	   CALL KEY_LOC( overlay, xkeypos, ykeypos, xkeysize, ykeysize,
     .			 lab_ht, style, justify, plot_title(:slen) )
	   CALL PUT_CMND_KEY( cmnd_num, plot_title(:slen),
     .			      xkeypos, ykeypos, xkeysize, ykeysize,
     .			      lab_ht )
	ELSE
	   IF ( .NOT. user_title ) THEN
	      IF ( use_keys ) THEN
	         plot_title = COMPOUND_KEY( cx_list, nvars, key_doc, slen )
	      ELSE
	         plot_title = COMPOUND_TITLE( cx_list, nvars, slen )
	      ENDIF
	   ENDIF
	   CALL BOX_LABEL( ppl_title,
     .			   plot_title(:slen),
     .			   0.0, 0.0, 0.75*xlen, letsize_title,
     .			   letsize_title, ppl_centered,
     .			   lab_loc_absolute, lab_loc_absolute )
* ... see if a "year" label is required
	   year = unspecified_name4
	   IF (dim1.EQ.t_dim.AND.(xstyle.EQ.'MON'.OR.xstyle.EQ.'DAY')) THEN
	      CALL TSTEP_TO_DATE( grid, t_dim, xaxlo, ptime_yr, ppl_buff )
	      year = ppl_buff(:4)
	   ELSEIF (dim1.EQ.f_dim.AND.(xstyle.EQ.'MON'.OR.xstyle.EQ.'DAY')) THEN
	      CALL TSTEP_TO_DATE( grid, f_dim, xaxlo, ptime_yr, ppl_buff )
	      year = ppl_buff(:4)
	   ELSEIF (dim2.EQ.t_dim.AND.
     .                  (ystyle.EQ.'MON'.OR.ystyle.EQ.'DAY')) THEN
	      CALL TSTEP_TO_DATE( grid, t_dim, yaxlo, ptime_yr, ppl_buff )
	      year = ppl_buff(:4)
	   ELSEIF (dim2.EQ.f_dim.AND.
     .                  (ystyle.EQ.'MON'.OR.ystyle.EQ.'DAY')) THEN
	      CALL TSTEP_TO_DATE( grid, f_dim, yaxlo, ptime_yr, ppl_buff )
	      year = ppl_buff(:4)
	   ENDIF
* ... put on the basic position and data set labels

* *ACM* if time axis, then cal_id is set to the calendar.  Label the
*       plot with the calendar name if there is non-standard calendar

	   CALL DISP_LABELS( cx_plot, year, cal_id )
	ENDIF

* special remarks for vector plots
* ... "scale ratio adjustment: nnn"
* note: "plot_title" is just used as a buffer
	IF ( vector ) THEN
	   IF ( aspect .GT. 0.0 ) THEN
	      plot_title = 'adjustment for differing X/Y scales: '//
     .			  TM_FMT(s,3,16,slen)
	      CALL PUT_LABEL( ppl_movlab-ppl_aspect, 0.0, +0.2,
     .			      ppl_left_just, 0.09, 
     .			      plot_title(:37+slen),
     .			      lab_loc_absolute, lab_loc_axlen_plus )
	   ENDIF
* ... offset components (staggered vectors)?
	   IF (   cx_lo_ww(dim1,ctx) .NE. cx_lo_ww(dim1,cty)
     .	     .OR. cx_hi_ww(dim1,ctx) .NE. cx_hi_ww(dim1,cty)
     .	     .OR. cx_lo_ww(dim2,ctx) .NE. cx_lo_ww(dim2,cty)
     .	     .OR. cx_hi_ww(dim2,ctx) .NE. cx_hi_ww(dim2,cty))THEN
	         CALL PUT_LABEL( ppl_movlab-ppl_offset, 8.0, +0.2,
     .			      ppl_right_just, 0.09, 
     .				'X and Y components are offset',
     .			      lab_loc_absolute, lab_loc_axlen_plus )
	   ENDIF
	ENDIF

	status = ferr_ok
	RETURN

* error exit
 5000	IF ( vector ) CALL DELETE_VARIABLE( mvy_temp )
 5010	CALL DELETE_VARIABLE( mvx_temp )
 5100	RETURN
 5150	CALL ERRMSG( ferr_dim_underspec, status, 
     .			'overlay not valid in plane of plot'//pCR//
     .					cmnd_buff(:len_cmnd), *5100 )
 5160	IF (mvx_temp .NE. 0) CALL DELETE_VARIABLE( mvx_temp )
        CALL ERRMSG( ferr_dim_underspec, status, 
     .			'must be a 2D region'//pCR//
     .					cmnd_buff(:len_cmnd), *5100 )

! 5200	CALL ERRMSG( ferr_no_range, status,
!     .				'data are all flagged as bad', *5000 )
 5300	CALL ERRMSG( ferr_invalid_command, status,
     .		     'can only '//commands(cmnd_num)//' single fields'//pCR//
     .		     'Use /OVERLAY for multiple variables', *5100 )
 5400	CALL ERRMSG( ferr_inconsist_plane, status,
     .		 letter//' coord field lies'//pCR//
     .		'in different plane from data to be plotted', *5100 )
 5500	CALL ERRMSG( ferr_no_range, status, letter//
     .				' coordinate field', *5000 )

 5660	cal_name_1 = TM_GET_CALENDAR_NAME(saved_calendar_id)
        cal_name_2 = TM_GET_CALENDAR_NAME(cal_id)
        slen = TM_LENSTR1 (cal_name_1)
        slen2 = TM_LENSTR1(cal_name_2)
	CALL ERRMSG( ferr_inconsist_grid, status,
     .          'Differing calendar axes: '//pCR//
     .		'first variable is on '//cal_name_1(:slen)//
     .          ' axis'//pCR//
     .		'subsequent variable is on '//cal_name_2(:slen2)//
     .		' axis', *5000 )

 5700	buff1 = LEFT_REAL (first, '(G15.3)', slen)
	buff2 = LEFT_REAL (last,  '(G15.3)', slen2)
	CALL ERRMSG( ferr_out_of_range, status,
     . 'Limits for log axis negative or too small: '//
     .  buff1(:slen)// ' : '// buff2(:slen2), *5000 )

 5710   CALL ERRMSG( ferr_out_of_range, status,
     .     'data too large to compute Std Dev'//pCR//
     .      cmnd_buff(:len_cmnd), *5100 )
 5720   CALL ERRMSG( ferr_out_of_range, status,
     .     err_string//pCR//cmnd_buff(:len_cmnd), *5100 )

	END

*  piecewise3.F
* 
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* Ansley Manke June 2013
* implements stl2, Piecewise linear approximations of fewest line segments
* described in http://www.computer.org/csdl/proceedings/afips/1972/5079/00/50790187.pdf
* and a somewhat later version of the code, found at
* http://www.netlib.org/toms/510
*
*
*  In this subroutine we provide information about
*  the function.  The user configurable information 
*  consists of the following:
* 
*  descr              Text description of the function
* 
*  num_args           Required number of arguments
* 
*  axis_inheritance   Type of axis for the result
*                        ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                        CUSTOM          - user defined axis
*                        IMPLIED_BY_ARGS - same axis as the incoming argument
*                        NORMAL          - the result is normal to this axis
*                        ABSTRACT        - an axis which only has index values
* 
*  piecemeal_ok       For memory optimization:
*                        axes where calculation may be performed piecemeal
*                        ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE piecewise3_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     . 'Return indices to sample from piecewise linear interpolation of 3 vars' )

      CALL ef_set_num_args(id, 7) 
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, ABSTRACT, NORMAL, 
     .                                              NORMAL,   NORMAL)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 7)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'V1')
      CALL ef_set_arg_desc(id, arg, '1st variable to sample')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'V2')
      CALL ef_set_arg_desc(id, arg, '2nd variable to sample')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'V3')
      CALL ef_set_arg_desc(id, arg, '3rd variable to sample')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'Control parameter')
      CALL ef_set_arg_desc(id, arg,
     .          'Control parameter (e.g. 6 for ntol=rest=cont=1)')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'Tol1')
      CALL ef_set_arg_desc(id, arg, 'Tolerance for V1')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 6
      CALL ef_set_arg_name(id, arg, 'Tol2')
      CALL ef_set_arg_desc(id, arg, 'Tolerance for V2')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 7
      CALL ef_set_arg_name(id, arg, 'Tol3')
      CALL ef_set_arg_desc(id, arg, 'Tolerance for V3')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)



*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE piecewise3_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER my_hi_i
      INTEGER arg_lo_ss(4,EF_MAX_ARGS),
     .        arg_hi_ss(4,EF_MAX_ARGS),
     .        arg_incr (4,EF_MAX_ARGS)

*
*     Use utility functions to get context information about the arguments.
*

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      my_hi_i = arg_hi_ss(X_AXIS,1) - arg_lo_ss(X_AXIS,1) + 1

      CALL ef_set_axis_limits(id, X_AXIS, 1, my_hi_i)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

      
*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE piecewise3_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
* 
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims(id, array #,
*                           xlo, ylo, zlo, tlo, 
*                           xhi, yhi, zhi, thi)
*

      INTEGER arg_lo_ss(4,EF_MAX_ARGS),
     .        arg_hi_ss(4,EF_MAX_ARGS),
     .        arg_incr (4,EF_MAX_ARGS)
      INTEGER npts, iwork

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      npts = 1 + arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1)
      npts = 2*npts

* input x-axis coordinates
      iwork = 1
      CALL ef_set_work_array_dims(id, iwork,
     .                                1, 1, 1, 1,
     .                             npts+10, 1, 1, 1)

* internal computation, u1 for y1
      iwork = 2
      CALL ef_set_work_array_dims(id, iwork,
     .                                1, 1, 1, 1,
     .                             npts+10, 1, 1, 1)

* internal computation, u2 for y2
      iwork = 3
      CALL ef_set_work_array_dims(id, iwork,
     .                                1, 1, 1, 1,
     .                             npts+10, 1, 1, 1)

* internal computation, u3 for y3
      iwork = 4
      CALL ef_set_work_array_dims(id, iwork,
     .                                1, 1, 1, 1,
     .                             npts+10, 1, 1, 1)

* internal computation, v
      iwork = 5
      CALL ef_set_work_array_dims(id, iwork,
     .                                1, 1, 1, 1,
     .                           2*npts+10, 1, 1, 1)

* internal computation, w
      iwork = 6
      CALL ef_set_work_array_dims(id, iwork,
     .                                1, 1, 1, 1,
     .                           2*npts+10, 1, 1, 1)

* data w/o gaps
      iwork = 7
      CALL ef_set_work_array_dims(id, iwork,
     .                                1, 1, 1, 1,
     .                           npts+10, 1, 1, 1)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*  In this subroutine we compute the result
* 
      SUBROUTINE piecewise3_compute(id, arg_1, arg_2, arg_3, arg_4, 
     .        arg_5, arg_6, arg_7, result, xpts, u1, u2, u3, v, w, yf)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz, 
     .           mem4lot:mem4hit)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz, 
     .           mem5lot:mem5hit)
      REAL arg_6(mem6lox:mem6hix, mem6loy:mem6hiy, mem6loz:mem6hiz, 
     .           mem6lot:mem6hit)
      REAL arg_7(mem7lox:mem7hix, mem7loy:mem7hiy, mem7loz:mem7hiz, 
     .           mem7lot:mem7hit)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit)

* Ignore the Y/Z/T/E/F dimensions in the work array since
* they are not used and Fortran is column major

      REAL xpts(wrk1lox:wrk1hix)

      REAL u1(wrk2lox:wrk2hix)
      REAL u2(wrk3lox:wrk3hix)
      REAL u3(wrk4lox:wrk4hix)
      REAL  v(wrk5lox:wrk5hix)
      REAL  w(wrk6lox:wrk6hix)
      REAL yf(wrk7lox:wrk7hix)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4),
     .        res_hi_ss(4),
     .        res_incr (4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS),
     .        arg_hi_ss(4,EF_MAX_ARGS),
     .        arg_incr (4,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l
      INTEGER nx, nout1, nout2, nout3, nmerge1, nmerge2, ip, icount
      REAL val, tol(3), bad_y
      CHARACTER*100 errtxt

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* Initialize
      nx = 0
      nout1 = 0
      nout2 = 0
      nout3 = 0
      nmerge1 = 0
      nmerge2 = 0

* Control parameter IP

      CALL ef_get_one_val(id, ARG4, val)
      IP = INT(val)

* Tolerances

      CALL ef_get_one_val(id, ARG5, tol(1))

      CALL ef_get_one_val(id, ARG6, tol(2))

      CALL ef_get_one_val(id, ARG7, tol(3))

*  Set x coordinate - abstract axis.

      nx = arg_hi_ss(X_AXIS, ARG1) - arg_lo_ss(X_AXIS, ARG1) + 1
      DO 50 i = 1, nx
         xpts(i) = i
  50  CONTINUE

      k = res_lo_ss(Z_AXIS)  ! index for unused dimensions

* Find piecewise fit for each array then merge the indices
* Set the work arrays to 0's so we arent using spurious data
* If the function returns too many points, just return all indices


* STL2 modified to truncate result to next lowest integer

      bad_y = bad_flag(ARG1)
      CALL STL2(xpts, arg_1, tol(1), nx, bad_y, bad_flag_result, 
     .   u1, v, w, nout1, IP)
      IF (nout1 .GT. res_hi_ss(X_AXIS)) THEN
         nout1 = nx
         DO 100 i = 1, nx
	    u1(i) = FLOAT(i)
 100     CONTINUE
      ENDIF
      
      DO 110 i = nout1+1, wrk2hix
         u1(i) = 0.
 110  CONTINUE

      bad_y = bad_flag(ARG2)
      CALL STL2(xpts, arg_2, tol(2), nx, bad_y, bad_flag_result, 
     .   u2, v, w, nout2, IP)
      IF (nout2 .GT. res_hi_ss(X_AXIS)) THEN
         nout2 = nx
         DO 200 i = 1, nx
	    u2(i) = FLOAT(i)
 200     CONTINUE
      ENDIF

      DO 210 i = nout2+1, wrk3hix
         u2(i) = 0.
 210  CONTINUE

      
* Skip over gaps in the data array, keeping good data and indices where
* good data lies. Decimate this instead.

      bad_y = bad_flag(ARG3)

      j = arg_lo_ss(Y_AXIS, ARG3)
      k = arg_lo_ss(Z_AXIS, ARG3)
      l = arg_lo_ss(T_AXIS, ARG3)

      icount = 0
      DO 220 i = 1, nx
         IF (arg_3(i,j,k,l) .NE. bad_y) THEN
	    icount = icount + 1
	    xpts(icount) = xpts(i)
	    yf(icount) = arg_3(i,j,k,l)
	 ENDIF
 220  CONTINUE

      CALL STL2(xpts, yf, tol(3), icount, bad_y, bad_flag_result, 
     .   u3, v, w, nout3, IP)
      IF (nout3 .GT. res_hi_ss(X_AXIS)) THEN
         nout3 = nx
         DO 300 i = 1, nx
	    u3(i) = FLOAT(i)
 300     CONTINUE
      ENDIF

      DO 310 i = nout3+1, wrk4hix
         u3(i) = 0.
 310  CONTINUE

* Truncate result(j=1) to next lowest integer - its going to be
* the set of coordinate values to sample at.

      DO 400 i = 1, wrk6hix
	 w(i) = 0.
 400  CONTINUE

      CALL merge (u1,nout1,u2,nout2,w,nmerge1,wrk6hix)
      IF (nmerge1 .GT. res_hi_ss(X_AXIS)) THEN
        write (errtxt,*) 'nmerge1 too large', nmerge1
	 GOTO 999
      ENDIF

      DO 500 i = 1, wrk5hix
	 v(i) = 0.
 500  CONTINUE
      DO 510 i = nmerge1+1, wrk6hix
	 w(i) = 0.
 510  CONTINUE

      CALL merge (w,nmerge1,u3,nout3,v,nmerge2,wrk5hix)
      IF ((nmerge2 .EQ. res_hi_ss(X_AXIS)) .OR. 
     .    (nmerge2 .EQ. res_hi_ss(X_AXIS)+1) ) THEN
        nmerge2 = res_hi_ss(X_AXIS)  ! Returning all the data
      ELSE IF (nmerge2 .GT. res_hi_ss(X_AXIS)) THEN
	 GOTO 999
      ENDIF

      DO 600 i = 1, nmerge2
        result(i,k,k,k) = v(i)
 600  CONTINUE

      DO 700 i = nmerge2+1, res_hi_ss(X_AXIS)
        result(i,k,k,k) = bad_flag_result
 700  CONTINUE

      RETURN
 999  CALL EF_BAIL_OUT(id, errtxt)
      RETURN

      END

	LOGICAL FUNCTION IS_AGG_MEMBER( dset, kth, parent, more )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* is the indicated dataset part of kth or more aggregated datasets
!**** NOTE:  THIS ROUTINE (and many others) SHOULD USE THE dset
!****      LIST STRUCTURE RATHER THAN BRUTE-FORCE LOOPS THROUGH ALL DATASETS

* calling arguments
*   dset    - the dataset to be checked to see if it is used in an agg (input)
*   kth     - if more than one parent this specifies whichone to return (input)
*   parent  - the kth agg that owns it (or unspecified_int4 if none) (output)
*   more    - logical to indicate if there are other parents beyond kth 

* programmer - steve hankin
* V695 *sh* 1/16
* V698  3/16 *acm* Remove unneeded xdset_parms.cmn
* V7   *acm*  6/12 Add Union aggregations: DEFINE DATA/AGG/U, ds_type 'UNI'

        IMPLICIT NONE
	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'tmap_errors.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xrisc.cmn'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data

* calling argument declarations:
	LOGICAL more
	INTEGER	dset, kth, parent

* local variable declarations:
	INTEGER	nmemb, imemb, membset, iset, kparent, status


* initialize -- default is "no parent found"
	kparent = 0
	IS_AGG_MEMBER = .FALSE.
	parent = unspecified_int4
	more = .FALSE.

* check all of the aggregations currently open
! note: extremely inefficient loop.  Should use List of aggs
	DO iset = 1, maxdsets
	   IF ( ds_name(iset) .EQ. char_init2048) CYCLE
	   IF (iset .EQ. dset) CYCLE
	   IF ( ds_type(iset).NE.'ENS' .AND. ds_type(iset).NE.'FCT' 
     .		.AND. ds_type(iset).NE.'UNI') CYCLE 

* Get number of agg members in this one
	   CALL CD_GET_AGG_DSET_INFO (iset, nmemb, status)
	   IF (status .NE. ferr_ok) CALL WARN('crptn: isit_agg_member')

* Look through the agg members to see if we are one of them
	   members: DO imemb = 1, nmemb
	      CALL CD_GET_AGG_DSET_MEMBER (iset, imemb, membset, status)
	      IF (status .NE. ferr_ok)  CALL WARN('crptn: isit_agg_member')
	      IF (membset .EQ. dset) THEN
	         kparent = kparent + 1
	         IF (kparent .EQ. kth) THEN
	            parent = iset ! return the kth one found
	            IS_AGG_MEMBER = .TRUE.
	         ELSEIF (kparent .GT. kth) THEN
	            more = .TRUE.
	            RETURN    ! nothing more worth learning
	         ENDIF
	         EXIT members
	      ENDIF
	   ENDDO members

	ENDDO

	RETURN
	END

	SUBROUTINE SEQUENCE_DSG( grid, com, res, com_cx, nfeatures,
     .		 bad_com, bad_res, nres)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Apply an XSEQUENCE-type operation for data on Distributed Sampling Geometries grids
* 
*
* Ansley Manke
* NOAA/PMEL, Seattle, WA - Science Data Integration Group
*  3/2019
*  5/2019  Correct the bad-flag handling

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include	'xdset_info.cmn_text'
	include 'xdyn_linemem.cmn_text'


* calling argument declarations
* Declare size of result so we can initialize it.
	INTEGER	grid, com_cx, nfeatures, nres
	REAL	com   ( * ),
     .          res   (nres), bad_com, bad_res

* internal variable declarations:
	LOGICAL fmask(nfeatures), process_obs(nres), obsvar
	INTEGER	TM_DSG_DSET_FROM_GRID, TM_DSG_NFEATURES, CX_DIM_LEN, 
     .		dset, idim, i, ndx, ifeature, iobs, flen, base, row_size_lm

* Initialize the result

	res = bad_res

* DSG-specific initialize

	dset = TM_DSG_DSET_FROM_GRID(grid)
	row_size_lm = dsg_loaded_lm(dsg_row_size_var(dset))

* Does the grid of com have a non-E axis?

	obsvar = .FALSE.
	DO idim = 1, nferdims 
	   IF (idim .EQ. e_dim) CYCLE
	   IF (CX_DIM_LEN(idim, com_cx) .GT. 1) obsvar = .TRUE.
	ENDDO

* get feature mask
        CALL MAKE_DSG_FEATURE_MASK(dset, com_cx, fmask, nfeatures)

* *** Flatten the data to a single list after applying the masks

	   IF (obsvar) THEN ! data along 'obs' axis

	      base = 0    ! obs index at end of preceding feature
	      ndx = 0

* ... loop over the features
	      DO ifeature = 1, nfeatures 

	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length

* ... have the user's constraints removed this feature?
	      IF (.NOT.fmask(ifeature)) THEN
                 base = base + flen
                 CYCLE
	      ENDIF

* ... loop over the observations within the feature

* ... apply observation-level mask for this feature
	      CALL MAKE_DSG_OBS_MASK(dset, com_cx, ifeature, base, process_obs, flen)

	     iobs = base
	      DO i = 1, flen
	         iobs = iobs + 1
	         IF (process_obs(i)) THEN
	            ndx = ndx + 1
		    IF (com(iobs) .EQ. bad_com) THEN
		       res(ndx) = bad_res
		    ELSE
	               res(ndx) = com(iobs)
		    ENDIF
	         ENDIF
	      ENDDO
	      base = base + flen
	   ENDDO

	
	ELSE

* *** a simple list of instances, return the data where feature not masked

	   ndx = 0
	   DO ifeature = 1, nfeatures 

* ... have the user's constraints removed this feature?
	      IF (fmask(ifeature)) THEN
	         ndx = ndx + 1
		 IF (com(ifeature) .EQ. bad_com) THEN
	            res(ndx) = com(ifeature)
		 ELSE
		    res(ndx) = bad_res
		 ENDIF
	      ENDIF
	   ENDDO

	ENDIF

	RETURN
	END

******************************************************************
*
*           rr_cross_spectrum.F
*
*             Rick Romea   Oct.8, 2000
*
*
* Cross-spectral program
*
* INPUT:
* arg_1  X1 (I, J, L=1:N) Real time series 1 		
* arg_2  X2 (I, J, L=1:N) Real time series 2	
* arg_3  Nf   Number of frequencies per band 	 
* arg_4  P    Percentage level for significance (90, 95 or 99)
*
*        handed along:  Number of data points N
*       		Sampling interval of data points
*
* OUTPUT:  ANSWER (I,J,K=1:11,L=1:Nb)
*
* ANSWER (I,J,K=1,L=Nb)	 Power in  band1	         
* ANSWER (I,J,K=2,L=Nb)	 Power in band2	                 
* ANSWER (I,J,K=3,L=Nb)	 Series 1: Upper confidence level	
* ANSWER (I,J,K=4,L=Nb)  Series 1: Lower confidence level	
* ANSWER (I,J,K=5,L=Nb)	 Series 2: Upper confidence level	
* ANSWER (I,J,K=6,L=Nb)	 Series 2: Lower confidence level	
* ANSWER (I,J,K=7,L=Nb)  Coherence-squared in each band	
* ANSWER (I,J,K=8,L=Nb)  Phase in each band 	
* ANSWER (I,J,K=9,L=Nb) Significant coherence squared
* ANSWER (I,J,K=10,L=Nb) Upper confidence level for phase
* ANSWER (I,J,K=11,L=Nb) Lower confidence level for phase
*
*       handed along: 	Number of bands	 Nb
*                       frequency axis
*
******************************************************************

      SUBROUTINE RR_cross_spectrum_init(id)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

      PRINT*,'START INIT'

      CALL ef_set_desc(id,'Computes auto and cross-spectrum')
      CALL ef_set_num_args(id,4)
 
      ! x and y unchanged
      ! on output:  z-axis is ABSTRACT:  has k=1:12
      ! on output:  t-axis is CUSTOM: converted to frequency axis

      CALL ef_set_axis_inheritance(id,
     .   IMPLIED_BY_ARGS,IMPLIED_BY_ARGS,CUSTOM,CUSTOM)   
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      !  Set a work array

      CALL ef_set_num_work_arrays  (id, 8)

      ! Describe the input arguments

      ! arg_1  X1 (I, J, L=1:N) Real time series 1 		

      CALL ef_set_arg_name         (id, ARG1, 'S1')
      CALL ef_set_arg_desc         (id, ARG1, 'Series 1')
      CALL ef_set_arg_unit         (id, ARG1, ' ')
      CALL ef_set_arg_type         (id, ARG1, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG1, YES,YES,NO,NO)

      ! arg_2  X2 (I, J, L=1:N) Real time series 2	

      CALL ef_set_arg_name         (id, ARG2, 'S2')
      CALL ef_set_arg_desc         (id, ARG2, 'Series 2')
      CALL ef_set_arg_unit         (id, ARG2, ' ')
      CALL ef_set_arg_type         (id, ARG2, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2, YES,YES,NO,NO)

      ! arg_3  Nf Number of frequencies per band 	 
      !  scalar
      
      CALL ef_set_arg_name         (id, ARG3, 'Nf')
      CALL ef_set_arg_desc         (id, ARG3, 
     .                  'Number of frequencies per band')
      CALL ef_set_arg_unit         (id, ARG3, ' ')
      CALL ef_set_arg_type         (id, ARG3, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG3, NO,NO,NO,NO)

      ! arg_4  P  Percentage level for significance (90, 95 or 99)
      !  scalar

      CALL ef_set_arg_name         (id, ARG4, 'P')
      CALL ef_set_arg_desc         (id, ARG4,
     .       'Percentage level for significance (90, 95 or 99)')
      CALL ef_set_arg_unit         (id, ARG4, ' ') 
      CALL ef_set_arg_type         (id, ARG4, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG4, NO,NO,NO,NO)

      PRINT*,'INIT DONE'
 
      END

C************************************************************************

      SUBROUTINE  RR_cross_spectrum_custom_axes(id)
      IMPLICIT NONE

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

      INTEGER arg_lo_ss(4,EF_MAX_ARGS)
      INTEGER arg_hi_ss(4,EF_MAX_ARGS)
      INTEGER  arg_incr(4,EF_MAX_ARGS)

      CHARACTER*16 ax_name(4)
      CHARACTER*16 ax_units(4)

      LOGICAL backward(4)
      LOGICAL modulo(4)
      LOGICAL regular(4)

      REAL          rNf, dt, T, df, f1, f2
      INTEGER       Nf, Nb, Npts
      CHARACTER*32  outunits

      WRITE(6,*)'START CUSTOM AXES, EF_MAX_ARGS', EF_MAX_ARGS
      CALL FLUSH(6) 
 
      PRINT*,'ef_get_arg_subscripts'
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      PRINT*,'arg_hi_ss',arg_hi_ss(T_AXIS,ARG1)  
      PRINT*,'arg_lo_ss',arg_lo_ss(T_AXIS,ARG1) 

      PRINT*,'ef_get_one_val'     
      CALL ef_get_one_val(id, ARG3, rNf)  
      PRINT*,'ef_get_axis_info'      
      CALL ef_get_axis_info(id, ARG1, ax_name, ax_units, backward,
     .     modulo, regular) ! Get the units for the time axis.
      PRINT*,'ef_get_box_size'      
      CALL ef_get_box_size(id, ARG1, T_AXIS, arg_lo_ss(T_AXIS,ARG1), 
     .               arg_lo_ss(T_AXIS,ARG1), dt)  ! sampling interval = dt
      PRINT*,'END EF CALLS'
      CALL FLUSH(6)

      ! Get the (integer) number of frequencies per band = Nf.

      Nf=NINT(rNf)

      ! Compute the number of points in the time series = Npts.

      Npts = arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1) + 1 

      ! Compute the number of bands

      Nb = Npts/(2*Nf)

      ! Compute the total time

      T = FLOAT(Npts-1)*dt  

      ! Frequency interval for each band

      df = FLOAT(Nf)/T

      ! First frequency (center of first band)

      f1 = df/2.

      ! Last frequency

      f2 = f1 + FLOAT(Nb-1)*df

      PRINT*,'NPTS = ',Npts
      PRINT*,'Nf   = ',Nf
      PRINT*,'dt   = ',dt
      PRINT*,'Nb   = ',Nb
      PRINT*,'T    = ',T
      PRINT*,'df   = ',df
      PRINT*,'f1   = ',f1
      PRINT*,'f2   = ',f2
      CALL FLUSH(6)

      ! ef_set_custom_axis(id, axis, lo, hi, delta, unit, modulo) 

      ! Set the label for the frequency axis =  1/units.

      outunits = '1/' // ax_units(T_AXIS)

      PRINT*,'outunits = ',outunits
      CALL FLUSH(6)

      CALL ef_set_custom_axis (id,T_AXIS,f1,f2,df,outunits,NO)

      ! Set the label for the abstract axis 

      outunits = 'ABSTRACT'

      PRINT*,'outunits = ',outunits
      CALL FLUSH(6)

      CALL ef_set_custom_axis (id,Z_AXIS,1,11,1,outunits,NO)

      PRINT*,'END CUSTOM AXES'
      CALL FLUSH(6)

      END

C************************************************************************

      SUBROUTINE  RR_cross_spectrum_work_size(id)
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'
      INTEGER id
      INTEGER Npts
      INTEGER arg_lo_ss(4,EF_MAX_ARGS),arg_hi_ss(4,EF_MAX_ARGS),
     .                                 arg_incr(4,EF_MAX_ARGS)


      PRINT*,'START WORK_SIZE'
       
      !  Get the number of points in the time series = Npts

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr) 
      Npts = arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1) + 1 

      PRINT*,'NPTS = ',Npts

      ! ef_set_work_array_dims(id,iarray,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi) 
      CALL ef_set_work_array_dims(id,1,1,1,1,1,1,1,1,4*Npts+1) 
      CALL ef_set_work_array_dims(id,2,1,1,1,1,1,1,1,Npts) 
      CALL ef_set_work_array_dims(id,3,1,1,1,1,1,1,1,Npts) 
      CALL ef_set_work_array_dims(id,4,1,1,1,1,1,1,1,Npts) 
      CALL ef_set_work_array_dims(id,5,1,1,1,1,1,1,1,Npts) 
      CALL ef_set_work_array_dims(id,6,1,1,1,1,1,1,1,Npts) 
      CALL ef_set_work_array_dims(id,7,1,1,1,1,1,1,1,Npts) 
      CALL ef_set_work_array_dims(id,8,1,1,1,1,1,1,1,2*Npts) 
      
      PRINT*,'END WORK_SIZE'
      END



C****************************************************************

      SUBROUTINE RR_cross_spectrum_result_limits(id)
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'
      INTEGER id

      INTEGER arg_lo_ss(4,EF_MAX_ARGS), 
     .        arg_hi_ss(4,EF_MAX_ARGS),
     .         arg_incr(4,EF_MAX_ARGS)

      INTEGER Nb,Npts,Nf
      REAL    rNf


      PRINT*,'START RESULT_LIMITS'

      ! TIME AXIS

         !  Get the (integer) number of frequencies per band = Nf.

         CALL ef_get_one_val(id, ARG3, rNf)  
         Nf=NINT(rNf)

      PRINT*,'Nf = ',Nf

         !  Get the number of points in the time series = Npts.

         CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr) 

         Npts = arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1) + 1 
     
      PRINT*,'NPTS = ',Npts


         ! Number of bands

         Nb = Npts/(2*Nf)

      PRINT*,'Nb = ',Nb

         CALL ef_set_axis_limits(id, T_AXIS, 1, Nb)

      ! ABSTRACT Z AXIS

         CALL ef_set_axis_limits(id, Z_AXIS, 1, 11)

      PRINT*,'END RESULT_LIMITS'

      END

C************************************************************

      SUBROUTINE RR_cross_spectrum_compute(id,S1,S2,rNf,P,ANSWER,
     .                                WSAVE,a1,a2,b1,b2,X1,X2,C)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'
      INTEGER id
      REAL S1  (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .          mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL S2  (mem2lox:mem2hix, mem2loy:mem1hiy, 
     .          mem2loz:mem2hiz, mem2lot:mem1hit)
      REAL rNf
      REAL P
      REAL ANSWER (memreslox:memreshix, memresloy:memreshiy, 
     .             memresloz:memreshiz, memreslot:memreshit)
      INTEGER  res_lo_ss (4)
      INTEGER  res_hi_ss (4)
      INTEGER  res_incr  (4)

      INTEGER  arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER  arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER  arg_incr  (4,EF_MAX_ARGS)

      INTEGER i,  j,  l
      INTEGER i1, j1, l1
      INTEGER i2, j2, l2

      REAL    WSAVE(wrk1lot:wrk1hit)
      REAL       a1(wrk2lot:wrk2hit)
      REAL       b1(wrk3lot:wrk3hit)
      REAL       a2(wrk4lot:wrk4hit)
      REAL       b2(wrk5lot:wrk5hit)
      REAL       X1(wrk6lot:wrk6hit)
      REAL       X2(wrk7lot:wrk7hit)
      COMPLEX     C(wrk8lot:wrk8hit)

      INTEGER Npts,Nf,Nb,kk
      REAL rNf,alpha,P,Coh2sig,lower,upper,PP,QQ,theta,GetStudentT  
      EXTERNAL GetStudentT

      PRINT*,'START COMPUTE'

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
         
      !  Get the number of points in the time series = Npts.

      Npts = arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1) + 1 


      PRINT*,'NPTS = ',Npts

      !  Get the (integer) number of frequencies per band = Nf.

      Nf=NINT(rNf)
         
      PRINT*,'Nf = ',Nf

      ! Number of bands

      Nb = Npts/(2*Nf)


      PRINT*,'Nb = ',Nb

      ! Set up the cosine matrix

      PRINT*,'START CFFTI'

      CALL CFFTI(Npts,WSAVE)

      PRINT*,'END CFFTI'

      !  Significance level for coherence at P% with 2*Nf degrees of freedom
      !  Ref: R.O.R.Y.Thompson, Coherence Significance Levels, AMS, 1979

      alpha = 1.-P/100.
      Coh2sig= 1.-alpha**(1./FLOAT(Nf-1))


      !  Confidence intervals for the power spectral estimates
      !
      !   IF Gxx is the 'true' autospectral value, based on the 
      !    band-averaged estimate <Gxx>, 
      !    then, for Nf number of frequencies in band, 
      !    we can say with P certainty that
      !
      !  lower * <Gxx>  <=  Gxx  <=  upper * <Gxx> 
      !
      !       (Bendat & Piersol, p.286)  

      PRINT*,'START Confindence Intervals'
      
      CALL SpectralConfidenceIntervals(Nf,NINT(P),lower,upper)

      PRINT*,'lower = ',lower
      PRINT*,'upper = ',upper

      ! START

      i1 = arg_lo_ss(X_AXIS,ARG1)
      i2 = arg_lo_ss(X_AXIS,ARG2)
      DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
        j1 = arg_lo_ss(Y_AXIS,ARG1)
        j2 = arg_lo_ss(Y_AXIS,ARG2)
        DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

           ! Copy the arrays
           
           l=1 
           DO l1=arg_lo_ss(T_AXIS,ARG1),arg_hi_ss(T_AXIS,ARG1)
              X1(l)=S1(i1,j1,1,l1)
              l=l+1
           ENDDO
            
           l=1 
           DO l2=arg_lo_ss(T_AXIS,ARG2),arg_hi_ss(T_AXIS,ARG2)
              X2(l)=S1(i2,j2,1,l2)
              l=l+1
           ENDDO

           ! Compute the raw spectral estimates

           PRINT*,'FFT - 1'

           CALL FFTreal(Npts,X1,a1,b1,WSAVE,C)

           PRINT*,'FFT - 2'

           CALL FFTreal(Npts,X2,a2,b2,WSAVE,C)

           ! Compute the auto-spectra, coherence-squared and the phase
          
           ! Band average


           PRINT*, 'START BAND AVERAGE'

           DO L=1,Nb
	      ANSWER(I,J,1,L)=0.  
	      ANSWER(I,J,2,L)=0.  
	      PP=0.  
	      QQ=0. 	
 
               DO kk=2+(L-1)*Nf,L*Nf+1
                   ANSWER(I,J,1,L) = ANSWER(I,J,1,L)
     .                        + a1(kk)*a1(kk) + b1(kk)*b1(kk)
	   	   ANSWER(I,J,2,L) = ANSWER(I,J,2,L)
     .                        + a2(kk)*a2(kk) + b2(kk)*b2(kk)
                   PP = PP + a1(kk)*a2(kk) + b1(kk)*b2(kk)
                   QQ = QQ + a2(kk)*b1(kk) - a1(kk)*b2(kk)

	       ENDDO

               !  Power spectrum for Series 1
   	      
               ANSWER(I,J,1,L) = 4.*ANSWER(I,J,1,L)/FLOAT(Nf)

               !  Power spectrum for Series 2	

               ANSWER(I,J,2,L) = 4.*ANSWER(I,J,2,L)/FLOAT(Nf)
   	      

               PP = 4.*PP/FLOAT(Nf)
   	       QQ = 4.*QQ/FLOAT(Nf)

               !  Coherence-squared in each band

	       ANSWER(I,J,7,L) = (PP*PP+QQ*QQ)
     .                     / (ANSWER(I,J,1,L)*ANSWER(I,J,2,L))

                !  Phase in each band 

	        IF(QQ.EQ.0..AND.PP.EQ.0.)THEN
	           ANSWER(I,J,8,L)=0.
	        ELSE
	           ANSWER(I,J,8,L)=ATAN2(-QQ,PP)
	        ENDIF

                ! Compute significant coherence in each band 
	        ! (currently constant for constant Nf)

                ANSWER(I,J,9,L)=Coh2sig 

                ! Compute Confidence limits for the phase
                ! theta = +- phase error (rad) at P significance 
	        !         with 2*Nf degrees of freedom
	        ! (P.285 Koopmans .The Spectral Analysis of Time Series)
                
                IF(ANSWER(I,J,7,L).EQ.0.)THEN
                  theta=3.14159              
                ELSE
                  theta = ASIN(  SQRT(  (1.-ANSWER(I,J,7,L)) / 
     .                                    ANSWER(I,J,7,L) / 
     .                                     FLOAT(2*Nf-2)   )
     .                * GetStudentT(NINT(P),Nf)   )  
                ENDIF
                ANSWER (I,J,10,L) = ANSWER(I,J,8,L)+theta ! Upper confidence level for phase
                ANSWER (I,J,11,L) = ANSWER(I,J,8,L)-theta ! Lower confidence level for phase

                ! Confidence levels on the autospectrum 

                ANSWER (I,J,3,L) = upper*ANSWER(I,J,1,L) ! Series 1: Upper confidence level	
                ANSWER (I,J,4,L) = lower*ANSWER(I,J,1,L) ! Series 1: Lower confidence level	
                ANSWER (I,J,5,L) = upper*ANSWER(I,J,2,L) ! Series 2: Upper confidence level	
                ANSWER (I,J,6,L) = lower*ANSWER(I,J,2,L) ! Series 2: Lower confidence level	

                PRINT*, 'END BAND AVERAGE'

	   ENDDO

           j1 = j1 + arg_incr(Y_AXIS,ARG1)
           j2 = j2 + arg_incr(Y_AXIS,ARG2) 
         ENDDO
         i1 = i1 + arg_incr(X_AXIS,ARG1)
         i2 = i2 + arg_incr(X_AXIS,ARG2)
      ENDDO
      END


	!******************************************
	!
	!  Confidence intervals for the power spectral estimates
	!
	!******************************************
	! 
        ! Nf = number of frequencys in band	(input)
	! P  = percent level for significance (eg 90,95 0r 99 ) INPUT
	! lower = lower bound (output)
	! upper = upper bound (output)
	!
        !   IF Gxx is the 'true' autospectral value, based on the 
	!    band-averaged estimate <Gxx>, 
	!    then, for Nf number of frequencys in band,
	!    we can say with 90% certainty that
	!
        !  lower * <Gxx>  <=  Gxx  <=  upper * <Gxx> 
	!
	!  lower = df/chi squared (df,alpha/2)
	!  upper = df/chi squared (df,1-alpha/2)
	!
        ! df = degrees of freedom = 2*number of frequencys in band
	!
	! chi squared (n,alpha/2) -->  P=100*(1-alpha)
	!
	!  P  	alpha	alpha/2	 1-alpha/2
	!  90    0.1     0.05	   0.95
	!  95    0.05	 0.025	   0.975
	!  99	 0.01	 0.005	   0.995
	!
	! Bendat & Piersol, p.286
	! Bendat & Piersol, p.524 (table)

      SUBROUTINE SpectralConfidenceIntervals(Nf,P,lower,upper)
      IMPLICIT NONE
      INTEGER Nf,P,df
      REAL lower,upper
	
	!   P  	alpha	alpha/2	 1-alpha/2
	!  90    0.1     0.05	   0.95
	!  95    0.05	 0.025	   0.975
	!  99	 0.01	 0.005	   0.995
      
      REAL chi_05(15) 
      REAL chi_025(15)	  
      REAL chi_005(15)
      REAL chi_95(15)	  
      REAL chi_975(15)  
      REAL chi_995(15)  
	
      DATA chi_005 /10.6,14.86,18.55,21.96,25.19,28.3,31.3,34.27,37.16,
     .               40.,42.8,45.56,48.29,50.99,53.67/		  
      DATA chi_025 /7.38,11.14,14.45,17.53,20.48,23.34,26.12,28.85,
     .               31.53,34.17,36.78,39.36,41.92,44.46,46.98/	  
      DATA chi_05 /5.99,9.49,12.59,15.51,18.31,21.03,23.68,26.30,28.87,
     .             31.41,33.92,36.42,38.88,41.34,43.77/
      DATA chi_95 /.103,.711,1.64,2.73,3.94,5.23,6.57,7.96,8.39,10.85,
     .             12.34,13.85,15.38,16.93,18.49/
      DATA chi_975 /.0506,.484,1.24,2.18,3.25,4.4,5.63,6.91,8.23,9.59,
     .              10.98,12.4,13.84,15.31,16.79/
      DATA chi_995 /.01,.207,.676,1.34,2.16,3.07,4.07,5.14,6.26,7.43,
     .              8.64,9.89,11.16,12.46,13.79/

       df=Nf*2

	IF(df.GT.100)THEN
	  IF(P.EQ.90)THEN 
	    lower=FLOAT(df)/146.57
          upper=FLOAT(df)/95.7
        ELSEIF(P.EQ.95)THEN
		lower=FLOAT(df)/152.21
          upper=FLOAT(df)/91.58
	  ELSE  !  P.EQ.99
	  	lower=FLOAT(df)/163.65
          upper=FLOAT(df)/83.85
	  ENDIF
	ELSEIF(df.GT.50)THEN
	  IF(P.EQ.90)THEN
        	lower=FLOAT(df)/79.08
          upper=FLOAT(df)/43.19
        ELSEIF(P.EQ.95)THEN
	   	lower=FLOAT(df)/83.8
          upper=FLOAT(df)/40.48
	  ELSE  !  P.EQ.99
	   	lower=FLOAT(df)/91.95
          upper=FLOAT(df)/35.53
	  ENDIF
	ELSEIF(df.GT.30)THEN
	  IF(P.EQ.90)THEN
	   	lower=FLOAT(df)/55.76
          upper=FLOAT(df)/26.51
        ELSEIF(P.EQ.95)THEN
	   	lower=FLOAT(df)/59.34
          upper=FLOAT(df)/24.43
	  ELSE  !  P.EQ.99
	   	lower=FLOAT(df)/66.77
          upper=FLOAT(df)/20.71
	  ENDIF
	ELSE ! df <= 30
	  IF(P.EQ.90)THEN
	   	lower=FLOAT(df)/chi_05(Nf)
          upper=FLOAT(df)/chi_95(Nf)
        ELSEIF(P.EQ.95)THEN
	   	lower=FLOAT(df)/chi_025(Nf)
          upper=FLOAT(df)/chi_975(Nf)
	  ELSE  !  P.EQ.99
	   	lower=FLOAT(df)/chi_005(Nf)
          upper=FLOAT(df)/chi_995(Nf)
	  ENDIF
	ENDIF
	END

	!******************************************
	! 
	! Get the upper cutoff point of the Student T distribution 
	! (P.341 Koopmans .The Spectral Analysis of Time Series)
	!
	!******************************************
	   
	REAL FUNCTION GetStudentT(P,Nf)
        IMPLICIT NONE
	INTEGER Nf,P,df  
	REAL ST_90(15)
	REAL ST_95(15)
	REAL ST_99(15)
	REAL T
	DATA ST_90/2.92,2.132,1.943,1.86,1.812,1.782,1.761,1.746,
     .           1.734,1.725,1.717,1.711,1.706,1.701,1.697/
	DATA ST_95/4.303,2.776,2.447,2.306,2.228,2.179,2.145,2.12,
     .           2.101,2.086,2.074,2.064,2.056,2.048,2.042/
  	DATA ST_99/9.925,4.604,3.707,3.355,3.169,3.055,2.977,2.921,
     .           2.878,2.845,2.819,2.797,2.779,2.763,2.75/

	IF(P.NE.90.AND.P.NE.95.AND.P.NE.99)THEN
           P=90 
	   WRITE(6,*)'WARNING::P must be 90,95 or 99' 
           WRITE(6,*)'         in SUBROUTINE PhaseConfidenceLimits'
           WRITE(6,*)'  '
           WRITE(6,*)'P set to 90%'
	ENDIF
 
        df=Nf*2

	IF(df.GT.120)THEN
     	  IF(P.EQ.90)THEN
		T=1.645
          ELSEIF(P.EQ.95)THEN
		T=1.96
	  ELSE  !  P.EQ.99
		T=2.576
	  ENDIF
	ELSEIF(df.GT.80)THEN
	  IF(P.EQ.90)THEN
		T=1.658
          ELSEIF(P.EQ.95)THEN
		T=1.98
	  ELSE  !  P.EQ.99
		T=2.617
	  ENDIF
	ELSEIF(df.GT.50)THEN
	  IF(P.EQ.90)THEN
		T=1.671
          ELSEIF(P.EQ.95)THEN
		T=2.
	  ELSE  !  P.EQ.99
		T=2.66
	  ENDIF
	ELSEIF(df.GT.30)THEN
	  IF(P.EQ.90)THEN
		T=1.684
          ELSEIF(P.EQ.95)THEN
		T=2.021
	  ELSE  !  P.EQ.99
		T=2.704
	  ENDIF
	ELSE ! df <= 30
	  IF(P.EQ.90)THEN
	    T=ST_90(Nf)
        ELSEIF(P.EQ.95)THEN
	    T=ST_95(Nf)
	  ELSE  !  P.EQ.99
	    T=ST_99(Nf)
	  ENDIF
	ENDIF
	GetStudentT=T
	END


        !******************************************
	!
	! FFT OF A REAL PERIODIC SEQUENCE
	! 
	!******************************************
     	!
        !   N         = number of data points (input)
	!   X(N)      = real input time series	(input)
	!   a(N),b(N) = normalized Fourier coefficients (output)
	!
	!  Spectral estimates are:  S(k) = a(k) + i b(k)
	!
	!                                     i = sqrt(-1)
	!
	!
	!            S(k)=THE SUM FROM n=1,...,N OF
	!  
        !                X(n)/N*EXP(-2*PI*i*k*n/N)
	!		   so:
	!                a(k) = (1/N) * THE SUM FROM n=1,...,N OF
	!		              X(n) * cos(2*PI*k*n/N) 
	!	
	!		 b(k) = (1/N) * THE SUM FROM n=1,...,N OF  
	!                           - X(n) * sin(2*PI*k*n/N)	
	!
	! T = N dt  is the fundamental period
	! 
        ! Frequencies are: f(k) = (k-1)/T  ;  k=1,..,N
	! 
	! Frequency interval between spectral estimates: 
	!
	!            df = 1/T  = 1/(N dt)
	!
	! Nyquist frequency is at: 
	!
	!            Nyquist = 1/(2dt) = N/(2T); k = N/2 + 1
	!
	!           So:  S[1] = mean of the time series
	!                S[2] = S[N]
	!                S[3] = S[N-1]
	!                S[k] = S[N-k+1]
	!
	!           Note: S[(N/2+1] is set = 0
	!               
	SUBROUTINE FFTreal(Nin,X,a,b,WSAVE,C)
	IMPLICIT NONE
	INTEGER Nin,N,i
	REAL X(1),a(1),b(1),WSAVE(1)
	COMPLEX C(1)

        ! Check if N is even

	IF(MOD(Nin,2).EQ.0)THEN
	  N=Nin
	ELSE
	  N=Nin-1
	ENDIF
	
	! load complex array

	DO i=1,N
	  C(i)=CMPLX(X(i),0.)
	ENDDO

	! Compute the transform

	CALL CFFTF(N,C,WSAVE)

	! load and normalize the a and b arrays

	DO i=1,N
	  a(i)=REAL(C(i))/FLOAT(N)
	  b(i)=AIMAG(C(i))/FLOAT(N)
	ENDDO
	  
	! Set values at the nyquist to zero 

	a(N/2+1)=0.
	b(N/2+1)=0.

	END

C *********************************************************************
C *********************************************************************
C *********************************************************************
C *********************************************************************
C *********************************************************************


	!******************************************
	!
	!  Canned FFT Routines
	!
	!******************************************

      subroutine cfftf (n,c,wsave)

C  FORWARD COMPLEX DISCRETE FFT OF A COMPLEX PERIODIC SEQUENCE
C
C     EQUIVALENTLY, CFFTF COMPUTES THE FOURIER COEFFICIENTS 
C     OF A COMPLEX PERIODIC SEQUENCE.
C
C     THE TRANSFORM IS NOT NORMALIZED. TO OBTAIN A NORMALIZED TRANSFORM
C     THE OUTPUT MUST BE DIVIDED BY N. OTHERWISE A CALL OF CFFTF
C     FOLLOWED BY A CALL OF CFFTB WILL MULTIPLY THE SEQUENCE BY N.
C
C     THE ARRAY WSAVE WHICH IS USED BY SUBROUTINE CFFTF MUST BE
C     INITIALIZED BY CALLING SUBROUTINE CFFTI(N,WSAVE).
C
C     INPUT PARAMETERS
C
C
C     N      THE LENGTH OF THE COMPLEX SEQUENCE C. THE METHOD IS
C            MORE EFFICIENT WHEN N IS THE PRODUCT OF SMALL PRIMES. N
C
C     C      A COMPLEX ARRAY OF LENGTH N WHICH CONTAINS THE SEQUENCE
C
C     WSAVE   A REAL WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 4N+1
C             IN THE PROGRAM THAT CALLS CFFTF. THE WSAVE ARRAY MUST BE
C             INITIALIZED BY CALLING SUBROUTINE CFFTI(N,WSAVE) AND A
C             DIFFERENT WSAVE ARRAY MUST BE USED FOR EACH DIFFERENT
C             VALUE OF N. THIS INITIALIZATION DOES NOT HAVE TO BE
C             REPEATED SO LONG AS N REMAINS UNCHANGED THUS SUBSEQUENT
C             TRANSFORMS CAN BE OBTAINED FASTER THAN THE FIRST.
C             THE SAME WSAVE ARRAY CAN BE USED BY CFFTF AND CFFTB.
C
C     OUTPUT PARAMETERS
C
C     C      FOR J=1,...,N
C
C                C(J)=THE SUM FROM K=1,...,N OF
C
C                      C(K)*EXP(-I*J*K*2*PI/N)
C
C                            WHERE I=SQRT(-1)
C
C     WSAVE   CONTAINS INITIALIZATION CALCULATIONS WHICH MUST NOT BE
C             DESTROYED BETWEEN CALLS OF SUBROUTINE CFFTF OR CFFTB
C

      dimension       c(1)       ,wsave(1)
      if (n .eq. 1) return
      iw1 = n+n+1
      iw2 = iw1+n+n
      call cfftf1 (n,c,wsave,wsave(iw1),wsave(iw2))
      end

      subroutine cfftf1 (n,c,ch,wa,ifac)

C***REFER TO CFFTF
C***ROUTINES CALLED  PASSF,PASSF5,PASSF3,PASSF2,PASSF4

      dimension       ch(1)      ,c(1)       ,wa(1)      ,ifac(1)
      nf = ifac(2)
      na = 0
      l1 = 1
      iw = 1
      do 116 k1=1,nf
         ip = ifac(k1+2)
         l2 = ip*l1
         ido = n/l2
         idot = ido+ido
         idl1 = idot*l1
         if (ip .ne. 4) go to 103
         ix2 = iw+idot
         ix3 = ix2+idot
         if (na .ne. 0) go to 101
         call passf4 (idot,l1,c,ch,wa(iw),wa(ix2),wa(ix3))
         go to 102
  101    call passf4 (idot,l1,ch,c,wa(iw),wa(ix2),wa(ix3))
  102    na = 1-na
         go to 115
  103    if (ip .ne. 2) go to 106
         if (na .ne. 0) go to 104
         call passf2 (idot,l1,c,ch,wa(iw))
         go to 105
  104    call passf2 (idot,l1,ch,c,wa(iw))
  105    na = 1-na
         go to 115
  106    if (ip .ne. 3) go to 109
         ix2 = iw+idot
         if (na .ne. 0) go to 107
         call passf3 (idot,l1,c,ch,wa(iw),wa(ix2))
         go to 108
  107    call passf3 (idot,l1,ch,c,wa(iw),wa(ix2))
  108    na = 1-na
         go to 115
  109    if (ip .ne. 5) go to 112
         ix2 = iw+idot
         ix3 = ix2+idot
         ix4 = ix3+idot
         if (na .ne. 0) go to 110
         call passf5 (idot,l1,c,ch,wa(iw),wa(ix2),wa(ix3),wa(ix4))
         go to 111
  110    call passf5 (idot,l1,ch,c,wa(iw),wa(ix2),wa(ix3),wa(ix4))
  111    na = 1-na
         go to 115
  112    if (na .ne. 0) go to 113
         call passf (nac,idot,ip,l1,idl1,c,c,c,ch,ch,wa(iw))
         go to 114
  113    call passf (nac,idot,ip,l1,idl1,ch,ch,ch,c,c,wa(iw))
  114    if (nac .ne. 0) na = 1-na
  115    l1 = l2
         iw = iw+(ip-1)*idot
  116 continue
      if (na .eq. 0) return
      n2 = n+n
      do 117 i=1,n2
         c(i) = ch(i)
  117 continue
      end

      subroutine cffti (n,wsave)

C   INITIALIZE FOR CFFTF AND CFFTB
C     *****************************************************************
C
C     SUBROUTINE CFFTI(N,WSAVE)
C
C     *****************************************************************
C
C     SUBROUTINE CFFTI INITIALIZES THE ARRAY WSAVE WHICH IS USED IN
C     BOTH CFFTF AND CFFTB. THE PRIME FACTORIZATION OF N TOGETHER WITH
C     A TABULATION OF THE TRIGONOMETRIC FUNCTIONS ARE COMPUTED AND
C     STORED IN WSAVE.
C
C     INPUT PARAMETER
C
C     N       THE LENGTH OF THE SEQUENCE TO BE TRANSFORMED
C
C     OUTPUT PARAMETER
C
C     WSAVE   A WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 4*N+15
C             THE SAME WORK ARRAY CAN BE USED FOR BOTH CFFTF AND CFFTB
C             AS LONG AS N REMAINS UNCHANGED. DIFFERENT WSAVE ARRAYS
C             ARE REQUIRED FOR DIFFERENT VALUES OF N. THE CONTENTS OF
C             WSAVE MUST NOT BE CHANGED BETWEEN CALLS OF CFFTF OR CFFTB
C

      dimension       wsave(1)
      if (n .eq. 1) return
      iw1 = n+n+1
      iw2 = iw1+n+n
      call cffti1 (n,wsave(iw1),wsave(iw2))
      end

      subroutine cffti1 (n,wa,ifac)
C***REFER TO CFFTI
C***ROUTINES CALLED  (NONE)

      dimension       wa(1)      ,ifac(1)    ,ntryh(4)
      data ntryh(1),ntryh(2),ntryh(3),ntryh(4)/3,4,2,5/
      nl = n
      nf = 0
      j = 0
  101 j = j+1
      if (j-4) 102,102,103
  102 ntry = ntryh(j)
      go to 104
  103 ntry = ntry+2
  104 nq = nl/ntry
      nr = nl-ntry*nq
      if (nr) 101,105,101
  105 nf = nf+1
      ifac(nf+2) = ntry
      nl = nq
      if (ntry .ne. 2) go to 107
      if (nf .eq. 1) go to 107
      do 106 i=2,nf
         ib = nf-i+2
         ifac(ib+2) = ifac(ib+1)
  106 continue
      ifac(3) = 2
  107 if (nl .ne. 1) go to 104
      ifac(1) = n
      ifac(2) = nf
      tpi = 6.28318530717959
      argh = tpi/float(n)
      i = 2
      l1 = 1
      do 110 k1=1,nf
         ip = ifac(k1+2)
         ld = 0
         l2 = l1*ip
         ido = n/l2
         idot = ido+ido+2
         ipm = ip-1
         wldc = 1.
         wlds = 0.
         arg = float(l1)*argh
         dl1c = cos(arg)
         dl1s = sin(arg)
         do 109 j=1,ipm
            i1 = i
            wa(i-1) = 1.
            wa(i) = 0.
            ld = ld+l1
            wldch = wldc
            wldc = dl1c*wldc-dl1s*wlds
            wlds = dl1s*wldch+dl1c*wlds
            dc = wldc
            ds = wlds
            do 108 ii=4,idot,2
               i = i+2
               wa(i-1) = dc*wa(i-3)-ds*wa(i-2)
               wa(i) = ds*wa(i-3)+dc*wa(i-2)
  108       continue
            if (ip .le. 5) go to 109
            wa(i1-1) = wa(i-1)
            wa(i1) = wa(i)
  109    continue
         l1 = l2
  110 continue
      end


      subroutine cfftb (n,c,wsave)

C INVERSE FFT OF A COMPLEX PERIODIC SEQUENCE
C     *****************************************************************
C
C     SUBROUTINE CFFTB(N,C,WSAVE)
C
C     *****************************************************************
C
C     SUBROUTINE CFFTB COMPUTES THE BACKWARD COMPLEX DISCRETE FOURIER
C     TRANSFORM (THE FOURIER SYNTHESIS). EQUIVALENTLY , CFFTB COMPUTES
C     A COMPLEX PERIODIC SEQUENCE FROM ITS FOURIER COEFFICIENTS.
C     THE TRANSFORM IS DEFINED BELOW AT OUTPUT PARAMETER C.
C
C     A CALL OF CFFTF FOLLOWED BY A CALL OF CFFTB WILL MULTIPLY THE
C     SEQUENCE BY N.
C
C     THE ARRAY WSAVE WHICH IS USED BY SUBROUTINE CFFTB MUST BE
C     INITIALIZED BY CALLING SUBROUTINE CFFTI(N,WSAVE).
C
C     INPUT PARAMETERS
C
C
C     N      THE LENGTH OF THE COMPLEX SEQUENCE C. THE METHOD IS
C            MORE EFFICIENT WHEN N IS THE PRODUCT OF SMALL PRIMES.
C
C     C      A COMPLEX ARRAY OF LENGTH N WHICH CONTAINS THE SEQUENCE
C
C     WSAVE   A REAL WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 4N+1
C             IN THE PROGRAM THAT CALLS CFFTB. THE WSAVE ARRAY MUST BE
C             INITIALIZED BY CALLING SUBROUTINE CFFTI(N,WSAVE) AND A
C             DIFFERENT WSAVE ARRAY MUST BE USED FOR EACH DIFFERENT
C             VALUE OF N. THIS INITIALIZATION DOES NOT HAVE TO BE
C             REPEATED SO LONG AS N REMAINS UNCHANGED THUS SUBSEQUENT
C             TRANSFORMS CAN BE OBTAINED FASTER THAN THE FIRST.
C             THE SAME WSAVE ARRAY CAN BE USED BY CFFTF AND CFFTB.
C
C     OUTPUT PARAMETERS
C
C     C      FOR J=1,...,N
C
C                C(J)=THE SUM FROM K=1,...,N OF
C
C                      C(K)*EXP(I*J*K*2*PI/N)
C
C                            WHERE I=SQRT(-1)
C
C     WSAVE   CONTAINS INITIALIZATION CALCULATIONS WHICH MUST NOT BE
C             DESTROYED BETWEEN CALLS OF SUBROUTINE CFFTF OR CFFTB

C***ROUTINES CALLED  CFFTB1

      dimension c(1), wsave(1)
      if (n .eq. 1) return
      iw1 = n+n+1
      iw2 = iw1+n+n
      call cfftb1 (n,c,wsave,wsave(iw1),wsave(iw2))
      return
      end

      subroutine cfftb1 (n,c,ch,wa,ifac)

C***REFER TO CFFTB
C***ROUTINES CALLED  PASSB,PASSB5,PASSB3,PASSB2,PASSB4

      dimension       ch(1)      ,c(1)       ,wa(1)      ,ifac(1)
      nf = ifac(2)
      na = 0
      l1 = 1
      iw = 1
      do 116 k1=1,nf
         ip = ifac(k1+2)
         l2 = ip*l1
         ido = n/l2
         idot = ido+ido
         idl1 = idot*l1
         if (ip .ne. 4) go to 103
         ix2 = iw+idot
         ix3 = ix2+idot
         if (na .ne. 0) go to 101
         call passb4 (idot,l1,c,ch,wa(iw),wa(ix2),wa(ix3))
         go to 102
  101    call passb4 (idot,l1,ch,c,wa(iw),wa(ix2),wa(ix3))
  102    na = 1-na
         go to 115
  103    if (ip .ne. 2) go to 106
         if (na .ne. 0) go to 104
         call passb2 (idot,l1,c,ch,wa(iw))
         go to 105
  104    call passb2 (idot,l1,ch,c,wa(iw))
  105    na = 1-na
         go to 115
  106    if (ip .ne. 3) go to 109
         ix2 = iw+idot
         if (na .ne. 0) go to 107
         call passb3 (idot,l1,c,ch,wa(iw),wa(ix2))
         go to 108
  107    call passb3 (idot,l1,ch,c,wa(iw),wa(ix2))
  108    na = 1-na
         go to 115
  109    if (ip .ne. 5) go to 112
         ix2 = iw+idot
         ix3 = ix2+idot
         ix4 = ix3+idot
         if (na .ne. 0) go to 110
         call passb5 (idot,l1,c,ch,wa(iw),wa(ix2),wa(ix3),wa(ix4))
         go to 111
  110    call passb5 (idot,l1,ch,c,wa(iw),wa(ix2),wa(ix3),wa(ix4))
  111    na = 1-na
         go to 115
  112    if (na .ne. 0) go to 113
         call passb (nac,idot,ip,l1,idl1,c,c,c,ch,ch,wa(iw))
         go to 114
  113    call passb (nac,idot,ip,l1,idl1,ch,ch,ch,c,c,wa(iw))
  114    if (nac .ne. 0) na = 1-na
  115    l1 = l2
         iw = iw+(ip-1)*idot
  116 continue
      if (na .eq. 0) return
      n2 = n+n
      do 117 i=1,n2
         c(i) = ch(i)
  117 continue
      end

      subroutine passb (nac,ido,ip,l1,idl1,cc,c1,c2,ch,ch2,wa)

C***REFER TO CFFTB
C***ROUTINES CALLED  (NONE)

      dimension       ch(ido,l1,ip)          ,cc(ido,ip,l1)          ,
     1                c1(ido,l1,ip)          ,wa(1)      ,c2(idl1,ip),
     2                ch2(idl1,ip)
      idot = ido/2
      nt = ip*idl1
      ipp2 = ip+2
      ipph = (ip+1)/2
      idp = ip*ido
C
      if (ido .lt. l1) go to 106
      do 103 j=2,ipph
         jc = ipp2-j
         do 102 k=1,l1
            do 101 i=1,ido
               ch(i,k,j) = cc(i,j,k)+cc(i,jc,k)
               ch(i,k,jc) = cc(i,j,k)-cc(i,jc,k)
  101       continue
  102    continue
  103 continue
      do 105 k=1,l1
         do 104 i=1,ido
            ch(i,k,1) = cc(i,1,k)
  104    continue
  105 continue
      go to 112
  106 do 109 j=2,ipph
         jc = ipp2-j
         do 108 i=1,ido
            do 107 k=1,l1
               ch(i,k,j) = cc(i,j,k)+cc(i,jc,k)
               ch(i,k,jc) = cc(i,j,k)-cc(i,jc,k)
  107       continue
  108    continue
  109 continue
      do 111 i=1,ido
         do 110 k=1,l1
            ch(i,k,1) = cc(i,1,k)
  110    continue
  111 continue
  112 idl = 2-ido
      inc = 0
      do 116 l=2,ipph
         lc = ipp2-l
         idl = idl+ido
         do 113 ik=1,idl1
            c2(ik,l) = ch2(ik,1)+wa(idl-1)*ch2(ik,2)
            c2(ik,lc) = wa(idl)*ch2(ik,ip)
  113    continue
         idlj = idl
         inc = inc+ido
         do 115 j=3,ipph
            jc = ipp2-j
            idlj = idlj+inc
            if (idlj .gt. idp) idlj = idlj-idp
            war = wa(idlj-1)
            wai = wa(idlj)
            do 114 ik=1,idl1
               c2(ik,l) = c2(ik,l)+war*ch2(ik,j)
               c2(ik,lc) = c2(ik,lc)+wai*ch2(ik,jc)
  114       continue
  115    continue
  116 continue
      do 118 j=2,ipph
         do 117 ik=1,idl1
            ch2(ik,1) = ch2(ik,1)+ch2(ik,j)
  117    continue
  118 continue
      do 120 j=2,ipph
         jc = ipp2-j
         do 119 ik=2,idl1,2
            ch2(ik-1,j) = c2(ik-1,j)-c2(ik,jc)
            ch2(ik-1,jc) = c2(ik-1,j)+c2(ik,jc)
            ch2(ik,j) = c2(ik,j)+c2(ik-1,jc)
            ch2(ik,jc) = c2(ik,j)-c2(ik-1,jc)
  119    continue
  120 continue
      nac = 1
      if (ido .eq. 2) return
      nac = 0
      do 121 ik=1,idl1
         c2(ik,1) = ch2(ik,1)
  121 continue
      do 123 j=2,ip
         do 122 k=1,l1
            c1(1,k,j) = ch(1,k,j)
            c1(2,k,j) = ch(2,k,j)
  122    continue
  123 continue
      if (idot .gt. l1) go to 127
      idij = 0
      do 126 j=2,ip
         idij = idij+2
         do 125 i=4,ido,2
            idij = idij+2
            do 124 k=1,l1
               c1(i-1,k,j) = wa(idij-1)*ch(i-1,k,j)-wa(idij)*ch(i,k,j)
               c1(i,k,j) = wa(idij-1)*ch(i,k,j)+wa(idij)*ch(i-1,k,j)
  124       continue
  125    continue
  126 continue
      return
  127 idj = 2-ido
      do 130 j=2,ip
         idj = idj+ido
         do 129 k=1,l1
            idij = idj
            do 128 i=4,ido,2
               idij = idij+2
               c1(i-1,k,j) = wa(idij-1)*ch(i-1,k,j)-wa(idij)*ch(i,k,j)
               c1(i,k,j) = wa(idij-1)*ch(i,k,j)+wa(idij)*ch(i-1,k,j)
  128       continue
  129    continue
  130 continue
      end

      subroutine passb2 (ido,l1,cc,ch,wa1)

C***REFER TO CFFTB
C***ROUTINES CALLED  (NONE)

      dimension       cc(ido,2,l1)           ,ch(ido,l1,2)           ,
     1                wa1(1)
      if (ido .gt. 2) go to 102
      do 101 k=1,l1
         ch(1,k,1) = cc(1,1,k)+cc(1,2,k)
         ch(1,k,2) = cc(1,1,k)-cc(1,2,k)
         ch(2,k,1) = cc(2,1,k)+cc(2,2,k)
         ch(2,k,2) = cc(2,1,k)-cc(2,2,k)
  101 continue
      return
  102 do 104 k=1,l1
         do 103 i=2,ido,2
            ch(i-1,k,1) = cc(i-1,1,k)+cc(i-1,2,k)
            tr2 = cc(i-1,1,k)-cc(i-1,2,k)
            ch(i,k,1) = cc(i,1,k)+cc(i,2,k)
            ti2 = cc(i,1,k)-cc(i,2,k)
            ch(i,k,2) = wa1(i-1)*ti2+wa1(i)*tr2
            ch(i-1,k,2) = wa1(i-1)*tr2-wa1(i)*ti2
  103    continue
  104 continue
      end

      subroutine passb3 (ido,l1,cc,ch,wa1,wa2)

C***REFER TO CFFTB
C***ROUTINES CALLED  (NONE)

      dimension       cc(ido,3,l1)           ,ch(ido,l1,3)           ,
     1                wa1(1)     ,wa2(1)
      data taur,taui /-.5,.866025403784439/
      if (ido .ne. 2) go to 102
      do 101 k=1,l1
         tr2 = cc(1,2,k)+cc(1,3,k)
         cr2 = cc(1,1,k)+taur*tr2
         ch(1,k,1) = cc(1,1,k)+tr2
         ti2 = cc(2,2,k)+cc(2,3,k)
         ci2 = cc(2,1,k)+taur*ti2
         ch(2,k,1) = cc(2,1,k)+ti2
         cr3 = taui*(cc(1,2,k)-cc(1,3,k))
         ci3 = taui*(cc(2,2,k)-cc(2,3,k))
         ch(1,k,2) = cr2-ci3
         ch(1,k,3) = cr2+ci3
         ch(2,k,2) = ci2+cr3
         ch(2,k,3) = ci2-cr3
  101 continue
      return
  102 do 104 k=1,l1
         do 103 i=2,ido,2
            tr2 = cc(i-1,2,k)+cc(i-1,3,k)
            cr2 = cc(i-1,1,k)+taur*tr2
            ch(i-1,k,1) = cc(i-1,1,k)+tr2
            ti2 = cc(i,2,k)+cc(i,3,k)
            ci2 = cc(i,1,k)+taur*ti2
            ch(i,k,1) = cc(i,1,k)+ti2
            cr3 = taui*(cc(i-1,2,k)-cc(i-1,3,k))
            ci3 = taui*(cc(i,2,k)-cc(i,3,k))
            dr2 = cr2-ci3
            dr3 = cr2+ci3
            di2 = ci2+cr3
            di3 = ci2-cr3
            ch(i,k,2) = wa1(i-1)*di2+wa1(i)*dr2
            ch(i-1,k,2) = wa1(i-1)*dr2-wa1(i)*di2
            ch(i,k,3) = wa2(i-1)*di3+wa2(i)*dr3
            ch(i-1,k,3) = wa2(i-1)*dr3-wa2(i)*di3
  103    continue
  104 continue
      end

      subroutine passb4 (ido,l1,cc,ch,wa1,wa2,wa3)

C***REFER TO CFFTB
C***ROUTINES CALLED (NONE)

      dimension       cc(ido,4,l1)           ,ch(ido,l1,4)           ,
     1                wa1(1)     ,wa2(1)     ,wa3(1)
      if (ido .ne. 2) go to 102
      do 101 k=1,l1
         ti1 = cc(2,1,k)-cc(2,3,k)
         ti2 = cc(2,1,k)+cc(2,3,k)
         tr4 = cc(2,4,k)-cc(2,2,k)
         ti3 = cc(2,2,k)+cc(2,4,k)
         tr1 = cc(1,1,k)-cc(1,3,k)
         tr2 = cc(1,1,k)+cc(1,3,k)
         ti4 = cc(1,2,k)-cc(1,4,k)
         tr3 = cc(1,2,k)+cc(1,4,k)
         ch(1,k,1) = tr2+tr3
         ch(1,k,3) = tr2-tr3
         ch(2,k,1) = ti2+ti3
         ch(2,k,3) = ti2-ti3
         ch(1,k,2) = tr1+tr4
         ch(1,k,4) = tr1-tr4
         ch(2,k,2) = ti1+ti4
         ch(2,k,4) = ti1-ti4
  101 continue
      return
  102 do 104 k=1,l1
         do 103 i=2,ido,2
            ti1 = cc(i,1,k)-cc(i,3,k)
            ti2 = cc(i,1,k)+cc(i,3,k)
            ti3 = cc(i,2,k)+cc(i,4,k)
            tr4 = cc(i,4,k)-cc(i,2,k)
            tr1 = cc(i-1,1,k)-cc(i-1,3,k)
            tr2 = cc(i-1,1,k)+cc(i-1,3,k)
            ti4 = cc(i-1,2,k)-cc(i-1,4,k)
            tr3 = cc(i-1,2,k)+cc(i-1,4,k)
            ch(i-1,k,1) = tr2+tr3
            cr3 = tr2-tr3
            ch(i,k,1) = ti2+ti3
            ci3 = ti2-ti3
            cr2 = tr1+tr4
            cr4 = tr1-tr4
            ci2 = ti1+ti4
            ci4 = ti1-ti4
            ch(i-1,k,2) = wa1(i-1)*cr2-wa1(i)*ci2
            ch(i,k,2) = wa1(i-1)*ci2+wa1(i)*cr2
            ch(i-1,k,3) = wa2(i-1)*cr3-wa2(i)*ci3
            ch(i,k,3) = wa2(i-1)*ci3+wa2(i)*cr3
            ch(i-1,k,4) = wa3(i-1)*cr4-wa3(i)*ci4
            ch(i,k,4) = wa3(i-1)*ci4+wa3(i)*cr4
  103    continue
  104 continue
      end

      subroutine passb5 (ido,l1,cc,ch,wa1,wa2,wa3,wa4)

C***REFER TO CFFTB
C***ROUTINES CALLED  (NONE)

      dimension       cc(ido,5,l1)           ,ch(ido,l1,5)           ,
     1                wa1(1)     ,wa2(1)     ,wa3(1)     ,wa4(1)
      data tr11,ti11,tr12,ti12 /.309016994374947,.951056516295154,
     1-.809016994374947,.587785252292473/
      if (ido .ne. 2) go to 102
      do 101 k=1,l1
         ti5 = cc(2,2,k)-cc(2,5,k)
         ti2 = cc(2,2,k)+cc(2,5,k)
         ti4 = cc(2,3,k)-cc(2,4,k)
         ti3 = cc(2,3,k)+cc(2,4,k)
         tr5 = cc(1,2,k)-cc(1,5,k)
         tr2 = cc(1,2,k)+cc(1,5,k)
         tr4 = cc(1,3,k)-cc(1,4,k)
         tr3 = cc(1,3,k)+cc(1,4,k)
         ch(1,k,1) = cc(1,1,k)+tr2+tr3
         ch(2,k,1) = cc(2,1,k)+ti2+ti3
         cr2 = cc(1,1,k)+tr11*tr2+tr12*tr3
         ci2 = cc(2,1,k)+tr11*ti2+tr12*ti3
         cr3 = cc(1,1,k)+tr12*tr2+tr11*tr3
         ci3 = cc(2,1,k)+tr12*ti2+tr11*ti3
         cr5 = ti11*tr5+ti12*tr4
         ci5 = ti11*ti5+ti12*ti4
         cr4 = ti12*tr5-ti11*tr4
         ci4 = ti12*ti5-ti11*ti4
         ch(1,k,2) = cr2-ci5
         ch(1,k,5) = cr2+ci5
         ch(2,k,2) = ci2+cr5
         ch(2,k,3) = ci3+cr4
         ch(1,k,3) = cr3-ci4
         ch(1,k,4) = cr3+ci4
         ch(2,k,4) = ci3-cr4
         ch(2,k,5) = ci2-cr5
  101 continue
      return
  102 do 104 k=1,l1
         do 103 i=2,ido,2
            ti5 = cc(i,2,k)-cc(i,5,k)
            ti2 = cc(i,2,k)+cc(i,5,k)
            ti4 = cc(i,3,k)-cc(i,4,k)
            ti3 = cc(i,3,k)+cc(i,4,k)
            tr5 = cc(i-1,2,k)-cc(i-1,5,k)
            tr2 = cc(i-1,2,k)+cc(i-1,5,k)
            tr4 = cc(i-1,3,k)-cc(i-1,4,k)
            tr3 = cc(i-1,3,k)+cc(i-1,4,k)
            ch(i-1,k,1) = cc(i-1,1,k)+tr2+tr3
            ch(i,k,1) = cc(i,1,k)+ti2+ti3
            cr2 = cc(i-1,1,k)+tr11*tr2+tr12*tr3
            ci2 = cc(i,1,k)+tr11*ti2+tr12*ti3
            cr3 = cc(i-1,1,k)+tr12*tr2+tr11*tr3
            ci3 = cc(i,1,k)+tr12*ti2+tr11*ti3
            cr5 = ti11*tr5+ti12*tr4
            ci5 = ti11*ti5+ti12*ti4
            cr4 = ti12*tr5-ti11*tr4
            ci4 = ti12*ti5-ti11*ti4
            dr3 = cr3-ci4
            dr4 = cr3+ci4
            di3 = ci3+cr4
            di4 = ci3-cr4
            dr5 = cr2+ci5
            dr2 = cr2-ci5
            di5 = ci2-cr5
            di2 = ci2+cr5
            ch(i-1,k,2) = wa1(i-1)*dr2-wa1(i)*di2
            ch(i,k,2) = wa1(i-1)*di2+wa1(i)*dr2
            ch(i-1,k,3) = wa2(i-1)*dr3-wa2(i)*di3
            ch(i,k,3) = wa2(i-1)*di3+wa2(i)*dr3
            ch(i-1,k,4) = wa3(i-1)*dr4-wa3(i)*di4
            ch(i,k,4) = wa3(i-1)*di4+wa3(i)*dr4
            ch(i-1,k,5) = wa4(i-1)*dr5-wa4(i)*di5
            ch(i,k,5) = wa4(i-1)*di5+wa4(i)*dr5
  103    continue
  104 continue
      end

      subroutine passf (nac,ido,ip,l1,idl1,cc,c1,c2,ch,ch2,wa)

C***REFER TO CFFTF
C***ROUTINES CALLED  (NONE)

      dimension       ch(ido,l1,ip)          ,cc(ido,ip,l1)          ,
     1                c1(ido,l1,ip)          ,wa(1)      ,c2(idl1,ip),
     2                ch2(idl1,ip)
      idot = ido/2
      nt = ip*idl1
      ipp2 = ip+2
      ipph = (ip+1)/2
      idp = ip*ido
C
      if (ido .lt. l1) go to 106
      do 103 j=2,ipph
         jc = ipp2-j
         do 102 k=1,l1
            do 101 i=1,ido
               ch(i,k,j) = cc(i,j,k)+cc(i,jc,k)
               ch(i,k,jc) = cc(i,j,k)-cc(i,jc,k)
  101       continue
  102    continue
  103 continue
      do 105 k=1,l1
         do 104 i=1,ido
            ch(i,k,1) = cc(i,1,k)
  104    continue
  105 continue
      go to 112
  106 do 109 j=2,ipph
         jc = ipp2-j
         do 108 i=1,ido
            do 107 k=1,l1
               ch(i,k,j) = cc(i,j,k)+cc(i,jc,k)
               ch(i,k,jc) = cc(i,j,k)-cc(i,jc,k)
  107       continue
  108    continue
  109 continue
      do 111 i=1,ido
         do 110 k=1,l1
            ch(i,k,1) = cc(i,1,k)
  110    continue
  111 continue
  112 idl = 2-ido
      inc = 0
      do 116 l=2,ipph
         lc = ipp2-l
         idl = idl+ido
         do 113 ik=1,idl1
            c2(ik,l) = ch2(ik,1)+wa(idl-1)*ch2(ik,2)
            c2(ik,lc) = -wa(idl)*ch2(ik,ip)
  113    continue
         idlj = idl
         inc = inc+ido
         do 115 j=3,ipph
            jc = ipp2-j
            idlj = idlj+inc
            if (idlj .gt. idp) idlj = idlj-idp
            war = wa(idlj-1)
            wai = wa(idlj)
            do 114 ik=1,idl1
               c2(ik,l) = c2(ik,l)+war*ch2(ik,j)
               c2(ik,lc) = c2(ik,lc)-wai*ch2(ik,jc)
  114       continue
  115    continue
  116 continue
      do 118 j=2,ipph
         do 117 ik=1,idl1
            ch2(ik,1) = ch2(ik,1)+ch2(ik,j)
  117    continue
  118 continue
      do 120 j=2,ipph
         jc = ipp2-j
         do 119 ik=2,idl1,2
            ch2(ik-1,j) = c2(ik-1,j)-c2(ik,jc)
            ch2(ik-1,jc) = c2(ik-1,j)+c2(ik,jc)
            ch2(ik,j) = c2(ik,j)+c2(ik-1,jc)
            ch2(ik,jc) = c2(ik,j)-c2(ik-1,jc)
  119    continue
  120 continue
      nac = 1
      if (ido .eq. 2) return
      nac = 0
      do 121 ik=1,idl1
         c2(ik,1) = ch2(ik,1)
  121 continue
      do 123 j=2,ip
         do 122 k=1,l1
            c1(1,k,j) = ch(1,k,j)
            c1(2,k,j) = ch(2,k,j)
  122    continue
  123 continue
      if (idot .gt. l1) go to 127
      idij = 0
      do 126 j=2,ip
         idij = idij+2
         do 125 i=4,ido,2
            idij = idij+2
            do 124 k=1,l1
               c1(i-1,k,j) = wa(idij-1)*ch(i-1,k,j)+wa(idij)*ch(i,k,j)
               c1(i,k,j) = wa(idij-1)*ch(i,k,j)-wa(idij)*ch(i-1,k,j)
  124       continue
  125    continue
  126 continue
      return
  127 idj = 2-ido
      do 130 j=2,ip
         idj = idj+ido
         do 129 k=1,l1
            idij = idj
            do 128 i=4,ido,2
               idij = idij+2
               c1(i-1,k,j) = wa(idij-1)*ch(i-1,k,j)+wa(idij)*ch(i,k,j)
               c1(i,k,j) = wa(idij-1)*ch(i,k,j)-wa(idij)*ch(i-1,k,j)
  128       continue
  129    continue
  130 continue
      end

      subroutine passf2 (ido,l1,cc,ch,wa1)

C***REFER TO CFFTF
C***ROUTINES CALLED  (NONE)

      dimension       cc(ido,2,l1)           ,ch(ido,l1,2)           ,
     1                wa1(1)
      if (ido .gt. 2) go to 102
      do 101 k=1,l1
         ch(1,k,1) = cc(1,1,k)+cc(1,2,k)
         ch(1,k,2) = cc(1,1,k)-cc(1,2,k)
         ch(2,k,1) = cc(2,1,k)+cc(2,2,k)
         ch(2,k,2) = cc(2,1,k)-cc(2,2,k)
  101 continue
      return
  102 do 104 k=1,l1
         do 103 i=2,ido,2
            ch(i-1,k,1) = cc(i-1,1,k)+cc(i-1,2,k)
            tr2 = cc(i-1,1,k)-cc(i-1,2,k)
            ch(i,k,1) = cc(i,1,k)+cc(i,2,k)
            ti2 = cc(i,1,k)-cc(i,2,k)
            ch(i,k,2) = wa1(i-1)*ti2-wa1(i)*tr2
            ch(i-1,k,2) = wa1(i-1)*tr2+wa1(i)*ti2
  103    continue
  104 continue
      end

      subroutine passf3 (ido,l1,cc,ch,wa1,wa2)

C***REFER TO CFFTF
C***ROUTINES CALLED  (NONE)

      dimension       cc(ido,3,l1)           ,ch(ido,l1,3)           ,
     1                wa1(1)     ,wa2(1)
      data taur,taui /-.5,-.866025403784439/
      if (ido .ne. 2) go to 102
      do 101 k=1,l1
         tr2 = cc(1,2,k)+cc(1,3,k)
         cr2 = cc(1,1,k)+taur*tr2
         ch(1,k,1) = cc(1,1,k)+tr2
         ti2 = cc(2,2,k)+cc(2,3,k)
         ci2 = cc(2,1,k)+taur*ti2
         ch(2,k,1) = cc(2,1,k)+ti2
         cr3 = taui*(cc(1,2,k)-cc(1,3,k))
         ci3 = taui*(cc(2,2,k)-cc(2,3,k))
         ch(1,k,2) = cr2-ci3
         ch(1,k,3) = cr2+ci3
         ch(2,k,2) = ci2+cr3
         ch(2,k,3) = ci2-cr3
  101 continue
      return
  102 do 104 k=1,l1
         do 103 i=2,ido,2
            tr2 = cc(i-1,2,k)+cc(i-1,3,k)
            cr2 = cc(i-1,1,k)+taur*tr2
            ch(i-1,k,1) = cc(i-1,1,k)+tr2
            ti2 = cc(i,2,k)+cc(i,3,k)
            ci2 = cc(i,1,k)+taur*ti2
            ch(i,k,1) = cc(i,1,k)+ti2
            cr3 = taui*(cc(i-1,2,k)-cc(i-1,3,k))
            ci3 = taui*(cc(i,2,k)-cc(i,3,k))
            dr2 = cr2-ci3
            dr3 = cr2+ci3
            di2 = ci2+cr3
            di3 = ci2-cr3
            ch(i,k,2) = wa1(i-1)*di2-wa1(i)*dr2
            ch(i-1,k,2) = wa1(i-1)*dr2+wa1(i)*di2
            ch(i,k,3) = wa2(i-1)*di3-wa2(i)*dr3
            ch(i-1,k,3) = wa2(i-1)*dr3+wa2(i)*di3
  103    continue
  104 continue
      end

      subroutine passf4 (ido,l1,cc,ch,wa1,wa2,wa3)

C***REFER TO CFFTF
C***ROUTINES CALLED  (NONE)

      dimension       cc(ido,4,l1)           ,ch(ido,l1,4)           ,
     1                wa1(1)     ,wa2(1)     ,wa3(1)
      if (ido .ne. 2) go to 102
      do 101 k=1,l1
         ti1 = cc(2,1,k)-cc(2,3,k)
         ti2 = cc(2,1,k)+cc(2,3,k)
         tr4 = cc(2,2,k)-cc(2,4,k)
         ti3 = cc(2,2,k)+cc(2,4,k)
         tr1 = cc(1,1,k)-cc(1,3,k)
         tr2 = cc(1,1,k)+cc(1,3,k)
         ti4 = cc(1,4,k)-cc(1,2,k)
         tr3 = cc(1,2,k)+cc(1,4,k)
         ch(1,k,1) = tr2+tr3
         ch(1,k,3) = tr2-tr3
         ch(2,k,1) = ti2+ti3
         ch(2,k,3) = ti2-ti3
         ch(1,k,2) = tr1+tr4
         ch(1,k,4) = tr1-tr4
         ch(2,k,2) = ti1+ti4
         ch(2,k,4) = ti1-ti4
  101 continue
      return
  102 do 104 k=1,l1
         do 103 i=2,ido,2
            ti1 = cc(i,1,k)-cc(i,3,k)
            ti2 = cc(i,1,k)+cc(i,3,k)
            ti3 = cc(i,2,k)+cc(i,4,k)
            tr4 = cc(i,2,k)-cc(i,4,k)
            tr1 = cc(i-1,1,k)-cc(i-1,3,k)
            tr2 = cc(i-1,1,k)+cc(i-1,3,k)
            ti4 = cc(i-1,4,k)-cc(i-1,2,k)
            tr3 = cc(i-1,2,k)+cc(i-1,4,k)
            ch(i-1,k,1) = tr2+tr3
            cr3 = tr2-tr3
            ch(i,k,1) = ti2+ti3
            ci3 = ti2-ti3
            cr2 = tr1+tr4
            cr4 = tr1-tr4
            ci2 = ti1+ti4
            ci4 = ti1-ti4
            ch(i-1,k,2) = wa1(i-1)*cr2+wa1(i)*ci2
            ch(i,k,2) = wa1(i-1)*ci2-wa1(i)*cr2
            ch(i-1,k,3) = wa2(i-1)*cr3+wa2(i)*ci3
            ch(i,k,3) = wa2(i-1)*ci3-wa2(i)*cr3
            ch(i-1,k,4) = wa3(i-1)*cr4+wa3(i)*ci4
            ch(i,k,4) = wa3(i-1)*ci4-wa3(i)*cr4
  103    continue
  104 continue
      end

      subroutine passf5 (ido,l1,cc,ch,wa1,wa2,wa3,wa4)

C***REFER TO CFFTF
C***ROUTINES CALLED  (NONE)

      dimension       cc(ido,5,l1)           ,ch(ido,l1,5)           ,
     1                wa1(1)     ,wa2(1)     ,wa3(1)     ,wa4(1)
      data tr11,ti11,tr12,ti12 /.309016994374947,-.951056516295154,
     1-.809016994374947,-.587785252292473/
      if (ido .ne. 2) go to 102
      do 101 k=1,l1
         ti5 = cc(2,2,k)-cc(2,5,k)
         ti2 = cc(2,2,k)+cc(2,5,k)
         ti4 = cc(2,3,k)-cc(2,4,k)
         ti3 = cc(2,3,k)+cc(2,4,k)
         tr5 = cc(1,2,k)-cc(1,5,k)
         tr2 = cc(1,2,k)+cc(1,5,k)
         tr4 = cc(1,3,k)-cc(1,4,k)
         tr3 = cc(1,3,k)+cc(1,4,k)
         ch(1,k,1) = cc(1,1,k)+tr2+tr3
         ch(2,k,1) = cc(2,1,k)+ti2+ti3
         cr2 = cc(1,1,k)+tr11*tr2+tr12*tr3
         ci2 = cc(2,1,k)+tr11*ti2+tr12*ti3
         cr3 = cc(1,1,k)+tr12*tr2+tr11*tr3
         ci3 = cc(2,1,k)+tr12*ti2+tr11*ti3
         cr5 = ti11*tr5+ti12*tr4
         ci5 = ti11*ti5+ti12*ti4
         cr4 = ti12*tr5-ti11*tr4
         ci4 = ti12*ti5-ti11*ti4
         ch(1,k,2) = cr2-ci5
         ch(1,k,5) = cr2+ci5
         ch(2,k,2) = ci2+cr5
         ch(2,k,3) = ci3+cr4
         ch(1,k,3) = cr3-ci4
         ch(1,k,4) = cr3+ci4
         ch(2,k,4) = ci3-cr4
         ch(2,k,5) = ci2-cr5
  101 continue
      return
  102 do 104 k=1,l1
         do 103 i=2,ido,2
            ti5 = cc(i,2,k)-cc(i,5,k)
            ti2 = cc(i,2,k)+cc(i,5,k)
            ti4 = cc(i,3,k)-cc(i,4,k)
            ti3 = cc(i,3,k)+cc(i,4,k)
            tr5 = cc(i-1,2,k)-cc(i-1,5,k)
            tr2 = cc(i-1,2,k)+cc(i-1,5,k)
            tr4 = cc(i-1,3,k)-cc(i-1,4,k)
            tr3 = cc(i-1,3,k)+cc(i-1,4,k)
            ch(i-1,k,1) = cc(i-1,1,k)+tr2+tr3
            ch(i,k,1) = cc(i,1,k)+ti2+ti3
            cr2 = cc(i-1,1,k)+tr11*tr2+tr12*tr3
            ci2 = cc(i,1,k)+tr11*ti2+tr12*ti3
            cr3 = cc(i-1,1,k)+tr12*tr2+tr11*tr3
            ci3 = cc(i,1,k)+tr12*ti2+tr11*ti3
            cr5 = ti11*tr5+ti12*tr4
            ci5 = ti11*ti5+ti12*ti4
            cr4 = ti12*tr5-ti11*tr4
            ci4 = ti12*ti5-ti11*ti4
            dr3 = cr3-ci4
            dr4 = cr3+ci4
            di3 = ci3+cr4
            di4 = ci3-cr4
            dr5 = cr2+ci5
            dr2 = cr2-ci5
            di5 = ci2-cr5
            di2 = ci2+cr5
            ch(i-1,k,2) = wa1(i-1)*dr2+wa1(i)*di2
            ch(i,k,2) = wa1(i-1)*di2-wa1(i)*dr2
            ch(i-1,k,3) = wa2(i-1)*dr3+wa2(i)*di3
            ch(i,k,3) = wa2(i-1)*di3-wa2(i)*dr3
            ch(i-1,k,4) = wa3(i-1)*dr4+wa3(i)*di4
            ch(i,k,4) = wa3(i-1)*di4-wa3(i)*dr4
            ch(i-1,k,5) = wa4(i-1)*dr5+wa4(i)*di5
            ch(i,k,5) = wa4(i-1)*di5-wa4(i)*dr5
  103    continue
  104 continue
      end 

*
* labwid.F
*
* Ansley Manke
* March 1, 2005
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
* 
* Get the width of a label in plot inches.
*
* This function calls the PPLUS routine SYMWID.  It is not an external 
* function, will be linked internally; but it is convenient to implement
* it as an external function.

* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
* V69+  5/14 *acm* Fix for ascii font in multi-line labels, ticket 2176

      SUBROUTINE labwid_init(id)

* Define arguments and result

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

      CALL ef_set_desc(id, 'Return string width in PLOT inches' )
      CALL ef_set_num_args(id, 2)
      CALL ef_set_axis_inheritance_6d(id,
     .                                ABSTRACT, NORMAL,
     .                                NORMAL,   NORMAL,
     .                                NORMAL,   NORMAL)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'STR')
      CALL ef_set_arg_desc(id, arg, 'strng, including font')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)
      CALL ef_set_arg_type(id, arg, string_arg)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'HT')
      CALL ef_set_arg_desc(id, arg, 'Size of character')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      RETURN 
      END


* Define abstract output axis: 1 value

      SUBROUTINE labwid_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id
      INTEGER ivalue

      ivalue = 1
      CALL ef_set_axis_limits(id, X_AXIS, ivalue, ivalue)

      RETURN 
      END


*
* Compute the result
*
      SUBROUTINE labwid_compute(id, arg_1, arg_2, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif

      INTEGER id

      REAL arg_1(strdf,
     .           mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      INTEGER arg, i, j, k, l, m, n
      REAL    LABEL_WIDTH, height
      CHARACTER*1024 strng

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)

      arg = 1
      CALL ef_get_arg_string(id, arg, strng)
      arg = 2
      CALL ef_get_one_val(id, arg, height)

* Compute the result.
      i = res_lo_ss(X_AXIS)
      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      l = res_lo_ss(T_AXIS)
      m = res_lo_ss(E_AXIS)
      n = res_lo_ss(F_AXIS)

      result(i,j,k,l,m,n) = LABEL_WIDTH(height, strng)

      RETURN 
      END


      REAL FUNCTION LABEL_WIDTH(height,strng)

      IMPLICIT NONE
      CHARACTER*(*) strng
      REAL height

      INCLUDE 'xrisc.cmn'

      INTEGER n, lnbeg(500), lnend(500), numlines,
     .        npen, nfont, npnew, nfnew, nchr
      REAL*4 SYMWID, ht, ss, xmn
      CHARACTER*3 fontprefix, penprefix, newfont, newpen

      CALL TM_BREAK_LINES (strng, lnbeg, lnend, numlines)
      nfont = 0
      npen = 0
      fontprefix = ""
      penprefix = ""

      ss = 0.
      ht = height

      DO 40 n = 1, numlines
         CALL getlabfonts (strng, lnbeg, lnend, n, fontprefix, 
     .           npnew, nfnew, newfont, newpen, nchr)

         risc_buff = strng(lnbeg(n):lnend(n))
         xmn = SYMWID(ht,nchr+npen+nfont,
     .           penprefix(1:npen)//fontprefix(1:nfont)//
     .           risc_buff)

         ss = MAX(xmn, ss)

C  Set up to use any font settings from this line on subsequent lines.

         IF (npnew.GT.0) THEN
            penprefix(1:npnew) = newpen(1:npnew)
            npen = npnew
         ENDIF
         IF (nfnew.GT.0) THEN
            fontprefix(1:npnew) = newfont(1:npnew)
            nfont = npnew
         ENDIF
  40  CONTINUE

      LABEL_WIDTH = ss

      RETURN
      END

*
* tax_jday1900.F
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Jing Y. Li 
* May 4th 2006
* 27-Feb-2013 ACM  Fix ticket 2043: remove old code for handling single-
*                  precision values coming in from argument 1
* v695  *acm 2/15  Time axis may be an F axis or a T axis.
* v75  *acm* 3/18  Issue 1856, changes to allow for timesteps in fractional seconds
*
* This function returns day of current year specified by the first argument 
* (variable containing time values) from the second argument (variable from 
* which time encoding will be inferred).
*

*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument''s axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*
*
* 2006-05-12 add code to handle years before 1900
* v75  *acm* 3/18  Issue 1856, changes to allow for timesteps in fractional seconds
* v745 *acm* 12/18  Issue 1909, option to write dates in ISO8601 format

      SUBROUTINE tax_jday1900_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .        'Returns days since 1900 of time axis coordinate values')
      CALL ef_set_num_args(id, 2)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'time steps to convert')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'B')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'variable with reference time axis')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE tax_jday1900_compute(id, arg_1, arg_2, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V


      LOGICAL default_datefmt, first
      INTEGER iyear, day_of_mon, day_since_1900, imon
      INTEGER L2, LL, dir, get_prec, dlen
      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1
      REAL*8 ddate
      CHARACTER*3 cmon
      CHARACTER*30 datebuf
      CHARACTER*255 err_msg

*  variables for checking axis characteristics (modulo axes)
      CHARACTER ax_name(6)*16, ax_units(6)*16
      LOGICAL backward(6), modulo(6), regular(6)

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*  Check to see if time axis of arg 2 is modulo
      CALL ef_get_axis_info_6d(id, ARG2, ax_name, ax_units,
     .                         backward, modulo, regular)


* return date string to precision of seconds
      get_prec = 6

* Get the direction of arg 2
      IF (arg_lo_ss(T_AXIS, ARG2) .NE. ef_unspecified_int4) THEN
         dir = T_AXIS
         IF ( modulo(T_AXIS) ) THEN
            WRITE (err_msg, *) 'Function not valid for modulo time axis'
            GO TO 999
         ENDIF
      ENDIF
      IF (arg_lo_ss(F_AXIS, ARG2) .NE. ef_unspecified_int4) THEN
         dir = F_AXIS
         IF ( modulo(T_AXIS) ) THEN
            WRITE (err_msg, *) 'Function not valid for modulo F axis'
            GO TO 999
         ENDIF
      ENDIF

      first = .TRUE.

      n1 = arg_lo_ss(F_AXIS,ARG1)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

      m1 = arg_lo_ss(E_AXIS,ARG1)
      DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

      l1 = arg_lo_ss(T_AXIS,ARG1)
      DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

      k1 = arg_lo_ss(Z_AXIS,ARG1)
      DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

      j1 = arg_lo_ss(Y_AXIS,ARG1)
      DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

      i1 = arg_lo_ss(X_AXIS,ARG1)
      DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         ddate = arg_1(i1,j1,k1,l1,m1,n1)
         IF ( ddate .NE. bad_flag(ARG1) ) THEN

*     Get the date string corresponding to time ddate for the variable ARG2
            CALL EF_GET_AXIS_DATES(id, ARG2, ddate, dir, 1, get_prec, dlen, datebuf)

* Are we using the default date format or ISO-8601 format? 
            IF (first) THEN
	       default_datefmt = (datebuf(3:3) .EQ. '-')
	       first = .FALSE.
            ENDIF

            IF (default_datefmt) THEN
*     datebuf is in form "DD-MON-YEAR HH:MM:SS". Read date.
               READ (datebuf, 420, err=900)  day_of_mon, cmon, iyear
 420           FORMAT (i2, 1x, a3, 1x, i4)
               imon = 0

            ELSE
	  
* Iso-8601 formatted dates 
* datebuf is in form "YYYY-MM-DD HH:MM:SS". If modulo, then yyyy is 0000.

               READ (datebuf,440,err=900) iyear, imon, day_of_mon
 440           FORMAT (i4, 2(1x,i2))
               cmon = 'XXX'

            ENDIF

	    CALL JULIAN_DAY_OF_YEAR1900(cmon, imon, day_of_mon, iyear, 
     .                                           day_since_1900)
            result(i,j,k,l,m,n) = day_since_1900 

         ELSE

            result(i,j,k,l,m,n) = bad_flag_result

         ENDIF

         i1 = i1 + arg_incr(X_AXIS,ARG1)
 100  CONTINUE

         j1 = j1 + arg_incr(Y_AXIS,ARG1)
 200  CONTINUE

         k1 = k1 + arg_incr(Z_AXIS,ARG1)
 300  CONTINUE

         l1 = l1 + arg_incr(T_AXIS,ARG1)
 400  CONTINUE

         m1 = m1 + arg_incr(E_AXIS,ARG1)
 500  CONTINUE

         n1 = n1 + arg_incr(F_AXIS,ARG1)
 600  CONTINUE

      RETURN 

 900  WRITE (err_msg,*)
     .  'Error assigning dates/times to timestamp for tax_jday1900',
     .  datebuf
 999  CALL ef_bail_out (id, err_msg)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END

	LOGICAL FUNCTION TM_LEGAL_NAME( name )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* determine whether a particular string is a "legal" variable name
*
* programmer - steve hankin (mods by M. Verschell)
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  07/07/89
* TM_:	 12/06/89
* IBM port 14apr94  *kob* : "Letter(c)=...." line to long for IBM compiler
* 6/95 *sh* - allow "$" as a legal symbol since it is used by PLOT+ symbols
* V600 6/05 *acm* Attribute control. Allow "." in a name, and allow ( ) for
*                 the syntax (coordname).attname

* calling argument declarations:
	CHARACTER*(*) name
*
* internal variable declarations:
	INTEGER	TM_LENSTR1, slen, i
	LOGICAL	LETTER, DIGIT, paren
	CHARACTER c*1
*
* statement functions
	LETTER( c ) = (c.GE.'A' .AND. c.LE.'Z') .OR. 
     .                      (c.GE.'a' .AND. c.LE.'z')
	DIGIT ( c ) = c.GE.'0' .AND. c.LE.'9'
*
* string length
	slen = TM_LENSTR1( name )
*
* first character must be a letter (also catches 0 length strings)
* First letter may be an opening parentheses for (coordname).attname

	IF ( .NOT.LETTER(name(1:1)) ) THEN
           IF ( name(1:1) .EQ. '(' ) THEN
              IF ( INDEX(name(2:slen), '.' ) .EQ. 0) GOTO 5000
              paren = .TRUE.
           ELSE
              GOTO 5000
           ENDIF
        ENDIF
*
* all other characters must be letters, digits, "_", or "$"
* "." and ")" for attribute specifiers.
	DO 100 i = 2, slen
	   c = name(i:i)
	   IF ( .NOT.(LETTER(c)
     .	         .OR. DIGIT(c)
     .	         .OR. c.EQ.'_'
     .	         .OR. c.EQ.'$'
     .	         .OR. c.EQ.')'
     .	         .OR. c.EQ.'.')    ) GOTO 5000
 100	CONTINUE

*  dot indicates an attribute. It cannot end the name.

        IF (c .EQ. '.') GOTO 5000

*
* it's ok
	TM_LEGAL_NAME = .TRUE.
	RETURN
*
* it's bad
 5000	TM_LEGAL_NAME = .FALSE.
	RETURN

	END

	SUBROUTINE GET_VP_FROM_FERRET(  xorg, yorg,
     .					size, scale, xclip, yclip, xll, yll )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* get viewport and window information from FERRET common
* (this routine to hide FERRET common from PPLUS)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 -  1/20/89
* V200:  3/13/90 - allow wsid.eq.0 for all windows cancelled (metafile open)
* V300:  3/20/93 - use ABS() to avoid negative size passed to PLOT+
* V540:  *sh* 9/01 - call VP_AXLIM2LIM to translate axis-relative VP limits
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus

	include 'ferret.parm'		! with unspecified_val4
	include 'xplot_state.cmn'		! viewport info
	include 'gkscm1_inc.decl'	! with wsid
	include 'GKSCM1.INC'	! with wsid

* calling argument declarations:
	REAL xorg, yorg, size, scale, xclip, yclip, xll, yll

* internal variable declarations:
	LOGICAL clip
	REAL  xoei,  yoei,  xcei,  ycei

	xorg  = vp_xorg(vp_num)
	yorg  = vp_yorg(vp_num)
	size  = ABS(vp_size(vp_num))    ! 3/93 mod *sh*
	IF ( wsid .NE. 0 ) THEN
	   scale = wn_scale(wsid)
	ELSE
	   scale = 1.0
	ENDIF

	clip    = vp_xclip(vp_num) .NE. unspecified_val4
	IF ( clip ) THEN
	   xclip = vp_xclip( vp_num )
	   yclip = vp_yclip( vp_num )
	ENDIF

	xll = xlowlef(1)
	yll = ylowlef(1)

* 9/01 additions
	IF (vp_by_axis( vp_num )) THEN
* ... adjust limits given as axis positions to limits of viewport
	   CALL VP_AXLIM2LIM( scale, xorg, yorg, xclip, yclip,
     .                               xorg, yorg, xclip, yclip,
     .                               xoei,  yoei,  xcei,  ycei )
    
	ENDIF

	RETURN
	END

	SUBROUTINE LINEAR(Z,NXSIZE,NYSIZE,NX,NY,X1,Y1,DX,DY,
     *	XP,YP,ZP,N,CAY,NRNG)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)linear.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C	This is a substitute routine for ZGRID, where the interpolation
C	used is linear rather than a fancy spline or lagrangian fit.
C	While the technique is crude the results are such that no
C	spurious minimums or maximums will be created.  This routine
C	expects the input data (XP,YP,ZP) to be ordered and complete.
C
C	The data may not have any interal gaps, but 1.0e35 is a valid
C	missing data value.  The only exception to the data being
C	complete is that the variable that varies fastest may end 
C	early, however, the data must start together.
C
C	This subroutine expects the data to be on a grid for which the
C	rows and columns can be unevenly spaced.  If the data is by
C	rows then a row may be short or if by columns a column can be
C	short.  (any other gaps will produce unpredictable results)
C
C	programmed by: D. W. Denbo    Mar 1986
C	modified by: D. W. Denbo   July 1986
C		added missing data types, and speeded it up
C
C
#ifdef unix
	INCLUDE 'MISS.INC'
#else
	INCLUDE 'pplinc:MISS.INC'
#endif
C
	DIMENSION Z(NXSIZE,NYSIZE),XP(N),YP(N),ZP(N)
	DIMENSION X(20000),Y(20000),IPNT(20000),IEND(20000)
	DIMENSION IPS(20000),ODX(20000),ODY(20000)
	LOGICAL XDIR,YDIR,XIN,YIN,XFAST,FLIP
	INTEGER I,J,K,L
C
C	Set up for missing data
C
	BIG=0.9E35
	ZP(N+1)=1.0E35
C
C	Scan the input series XP,YP to determine the structure
C
	NIX=1
	NIY=1
	X(1)=XP(1)
	Y(1)=YP(1)
	IPNT(1)=1
C
	XFAST=XP(1).NE.XP(2)
	IF(XFAST)THEN
	    DO 10 I=2,N
	    IF(XP(I).EQ.XP(1))GOTO 11
	    NIX=NIX+1
	    X(NIX)=XP(I)
10	    CONTINUE
11	    DO 12 I=1,N
C
C	TEST FOR MISSING DATA
C
	    IF(ZLE.AND.ZP(I).LE.CMZLE)ZP(I)=1.E35
	    IF(ZEQ.AND.ZP(I).EQ.CMZEQ)ZP(I)=1.E35
	    IF(ZGE.AND.ZP(I).GE.CMZGE)ZP(I)=1.E35
	    IF(YP(I).NE.Y(NIY))THEN
		NIY=NIY+1
		Y(NIY)=YP(I)
		IPNT(NIY)=I
	    ENDIF
12	    CONTINUE
	    IPNT(NIY+1)=N+1
	ELSE
	    DO 13 I=2,N
	    IF(YP(I).EQ.YP(1))GOTO 14
	    NIY=NIY+1
	    Y(NIY)=YP(I)
13	    CONTINUE
14	    DO 15 I=1,N
C
C	TEST FOR MISSING DATA
C
	    IF(ZLE.AND.ZP(I).LE.CMZLE)ZP(I)=1.E35
	    IF(ZEQ.AND.ZP(I).EQ.CMZEQ)ZP(I)=1.E35
	    IF(ZGE.AND.ZP(I).GE.CMZGE)ZP(I)=1.E35
	    IF(XP(I).NE.X(NIX))THEN
		NIX=NIX+1
		X(NIX)=XP(I)
		IPNT(NIX)=I
	    ENDIF
15	    CONTINUE
	    IPNT(NIX+1)=N+1
	ENDIF
C
	IF(XFAST)THEN
	    DO 420 I=1,NIY
420	    IEND(I)=IPNT(I+1)
	ELSE
	    DO 421 I=1,NIX
421	    IEND(I)=IPNT(I+1)
	ENDIF
C
	XDIR=X(2).GT.X(1)
	YDIR=Y(2).GT.Y(1)
C
C	Check for the beginning of the data being uneven
C
	IF(XFAST)THEN
	    XST=XP(1)
	    IF(XDIR)THEN
		DO 200 I=1,NIY
		IF(XST.LT.XP(IPNT(I)))XST=XP(IPNT(I))
200		CONTINUE
		DO 205 I=1,NIX-1
		IF(X(I).GT.X(I+1))GOTO 206
205		CONTINUE
		I=NIX
206		NIX=I
	    ELSE
		DO 210 I=1,NIY
		IF(XST.GT.XP(IPNT(I)))XST=XP(IPNT(I))
210		CONTINUE
		DO 215 I=1,NIX-1
		IF(X(I).LT.X(I+1))GOTO 216
215		CONTINUE
		I=NIX
216		NIX=I
	    ENDIF
C
C	    Fix the IX and X arrays if uneven
C
	    DO 220 I=1,NIX
	    IF(XST.EQ.X(I))GOTO 221
220	    CONTINUE
221	    IF(I.EQ.1)GOTO 226
	    DO 225 J=I,NIX
	    JJ=J-I+1
	    X(JJ)=X(J)
225	    CONTINUE
226	    CONTINUE
	    NIX=NIX-I+1
C
C	    Setup the IXS array
C
	    DO 230 I=1,NIY
	    DO 235 J=IPNT(I),IPNT(I+1)
	    IF(XST.EQ.XP(J))GOTO 236
235	    CONTINUE
236	    IPS(I)=J-IPNT(I)
230	    CONTINUE
	ELSE
	    YST=YP(1)
	    IF(YDIR)THEN
		DO 300 I=1,NIX
		IF(YST.LT.YP(IPNT(I)))YST=YP(IPNT(I))
300		CONTINUE
		DO 305 I=1,NIY-1
		IF(Y(I).GT.Y(I+1))GOTO 306
305		CONTINUE
		I=NIY
306		NIY=I
	    ELSE
		DO 310 I=1,NIX
		IF(YST.GT.YP(IPNT(I)))YST=YP(IPNT(I))
310		CONTINUE
		DO 315 I=1,NIY-1
		IF(Y(I).LT.Y(I+1))GOTO 316
315		CONTINUE
		I=NIY
316		NIY=I
	    ENDIF
C
C	    Fix the IY and Y arrays if uneven
C
	    DO 320 I=1,NIY
	    IF(YST.EQ.Y(I))GOTO 321
320	    CONTINUE
321	    IF(I.EQ.1)GOTO 326
	    DO 325 J=I,NIY
	    JJ=J-I+1
	    Y(JJ)=Y(J)
325	    CONTINUE
326	    CONTINUE
	    NIY=NIY-I+1
C
C	    Setup the IYS array
C
	    DO 330 I=1,NIX
	    DO 335 J=IPNT(I),IPNT(I+1)
	    IF(YST.EQ.YP(J))GOTO 336
335	    CONTINUE
336	    IPS(I)=J-IPNT(I)
330	    CONTINUE
	ENDIF
C
C	Sort the slowly varying index
C
	IF(XFAST)THEN
405	    FLIP=.FALSE.
	    DO 400 J=2,NIY
	    IF(Y(J-1).GT.Y(J))THEN
		FLIP=.TRUE.
		YT=Y(J-1)
		Y(J-1)=Y(J)
		Y(J)=YT
		I=IPNT(J-1)
		IPNT(J-1)=IPNT(J)
		IPNT(J)=I
		I=IEND(J-1)
		IEND(J-1)=IEND(J)
		IEND(J)=I
		I=IPS(J-1)
		IPS(J-1)=IPS(J)
		IPS(J)=I
	    ENDIF
400	    CONTINUE
	    IF(FLIP)GOTO 405
	    YDIR=.TRUE.
	ELSE
415	    FLIP=.FALSE.
	    DO 410 J=2,NIX
	    IF(X(J-1).GT.X(J))THEN
		FLIP=.TRUE.
		XT=X(J-1)
		X(J-1)=X(J)
		X(J)=XT
		I=IPNT(J-1)
		IPNT(J-1)=IPNT(J)
		IPNT(J)=I
		I=IEND(J-1)
		IEND(J-1)=IEND(J)
		IEND(J)=I
		I=IPS(J-1)
		IPS(J-1)=IPS(J)
		IPS(J)=I
	    ENDIF
410	    CONTINUE
	    IF(FLIP)GOTO 415
	    XDIR=.TRUE.
	ENDIF
C
C	Begin interpolation  (double linear)
C
C
C	Set up limits for close enough 
C
	XERR=DX*1.E-4
	YERR=DY*1.E-4
	IF(XDIR)THEN
	    X1E=X(1)-XERR
	    XNE=X(NIX)+XERR
	ELSE
	    X1E=X(1)+XERR
	    XNE=X(NIX)-XERR
	ENDIF
C
	IF(YDIR)THEN
	    Y1E=Y(1)-YERR
	    YNE=Y(NIY)+YERR
	ELSE
	    Y1E=Y(1)+YERR
	    YNE=Y(NIY)-YERR
	ENDIF
C
	DO 50 J=1,NIX-1
50	ODX(J)=1./(X(J+1)-X(J))
	DO 51 J=1,NIY-1
51	ODY(J)=1./(Y(J+1)-Y(J))
C
	DO 100 J=1,NX
	XJ=X1+DX*(J-1)
	DO 100 L=1,NY
	YL=Y1+DY*(L-1)
C
C	Find where Z(J,L) is located
C
	XIN=.FALSE.
	I=1
	IF(XDIR)THEN
	    IF(XJ.GE.X1E.AND.XJ.LE.XNE)THEN
		XIN=.TRUE.
		DO 110 I=2,NIX
 	IF(XJ-XERR.LE.X(I))GOTO 111
110		CONTINUE
111		I=I-1
	    ELSE
		IF(XJ.GT.X(NIX))I=NIX
	    ENDIF
	ELSE
	    IF(XJ.LE.X1E.AND.XJ.GE.XNE)THEN
		XIN=.TRUE.
		DO 120 I=2,NIX
		IF(XJ+XERR.GE.X(I))GOTO 121
120		CONTINUE
121		I=I-1
	    ELSE
		IF(XJ.LT.X(NIX))I=NIX
	    ENDIF
	ENDIF
C
	YIN=.FALSE.
	K=1
	IF(YDIR)THEN
	    IF(YL.GE.Y1E.AND.YL.LE.YNE)THEN
		YIN=.TRUE.
		DO 130 K=2,NIY
		IF(YL-YERR.LE.Y(K))GOTO 131
130		CONTINUE
131		K=K-1
	    ELSE
		IF(YL.GT.Y(NIY))K=NIY
	    ENDIF
	ELSE
	    IF(YL.LE.Y1E.AND.YL.GE.YNE)THEN
		YIN=.TRUE.
		DO 140 K=2,NIY
		IF(YL+YERR.GE.Y(K))GOTO 141
140		CONTINUE
141		K=K-1
	    ELSE
		IF(YL.LT.Y(NIY))K=NIY
	    ENDIF
	ENDIF
C
C	If inside then do the interpolation
C
	IF(XIN.AND.YIN)THEN
C
C	    Get the four corners
C
	    I00=IPOS(I  ,K  ,IPNT,IPS,IEND,XFAST,N)
	    I01=IPOS(I  ,K+1,IPNT,IPS,IEND,XFAST,N)
	    I10=IPOS(I+1,K  ,IPNT,IPS,IEND,XFAST,N)
	    I11=IPOS(I+1,K+1,IPNT,IPS,IEND,XFAST,N)
C
	    IF(ZP(I00).GE.BIG.OR.ZP(I10).GE.BIG.OR.
     *	    ZP(I01).GE.BIG.OR.ZP(I11).GE.BIG)THEN
		Z(J,L)=1.0E35
	    ELSE
		DXI=(XJ-X(I))*ODX(I)
		DYK=(YL-Y(K))*ODY(K)
C
C		Do it!
C
		Z(J,L)=ZP(I00)+(ZP(I10)-ZP(I00))*DXI
     *			      +(ZP(I01)-ZP(I00))*DYK
     *		+(ZP(I11)-ZP(I01)-ZP(I10)+ZP(I00))*DXI*DYK
	    ENDIF
	ELSE
	    Z(J,L)=1.0E35
C
	    IF(YIN.AND.ABS(DX).GT.ABS(XJ-X(I)))THEN
		I00=IPOS(I,K  ,IPNT,IPS,IEND,XFAST,N)
		I01=IPOS(I,K+1,IPNT,IPS,IEND,XFAST,N)
		IF(ZP(I00).LT.BIG.AND.ZP(I01).LT.BIG)THEN
		    A=(ZP(I01)-ZP(I00))*ODY(K)
		    B=ZP(I00)-A*Y(K)
		    Z(J,L)=A*YL+B
		ENDIF
	    ELSE IF(XIN.AND.ABS(DY).GT.ABS(YL-Y(K)))THEN
		I00=IPOS(I  ,K,IPNT,IPS,IEND,XFAST,N)
		I10=IPOS(I+1,K,IPNT,IPS,IEND,XFAST,N)
		IF(ZP(I00).LT.BIG.AND.ZP(I10).LT.BIG)THEN
		    A=(ZP(I10)-ZP(I00))*ODX(I)
		    B=ZP(I00)-A*X(I)
		    Z(J,L)=A*XJ+B
		ENDIF
	    ENDIF
	ENDIF
100	CONTINUE
	RETURN
	END
	FUNCTION IPOS(I,J,IPNT,IPS,IEND,FAST,N)
	LOGICAL FAST
	DIMENSION IPNT(20000),IPS(20000),IEND(20000)
	IF(FAST)THEN
	    IPOS=IPNT(J)+I-1+IPS(J)
	    IF(IPOS.GE.IEND(J))IPOS=N+1
	ELSE
	    IPOS=IPNT(I)+J-1+IPS(I)
	    IF(IPOS.GE.IEND(I))IPOS=N+1
	ENDIF
	RETURN
	END

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Return the array memory limits in the common blocks for those
* times when they cannot be retrieved directly.
*
      SUBROUTINE EF_GET_ARG_MEM_SUBSCRIPTS_6D(id, arg_memlo, arg_memhi)

      IMPLICIT NONE
      INCLUDE 'tmap_dims.parm'
      INCLUDE 'EF_Util.parm'
      INCLUDE 'EF_mem_subsc.cmn'

* argument declarations
      INTEGER id, arg_memlo(nferdims,EF_MAX_ARGS),
     .            arg_memhi(nferdims,EF_MAX_ARGS)

* this assumes nferdims .EQ. 6 and EF_MAX_ARGS .EQ. 9
      arg_memlo(1,1) = mem1lox
      arg_memlo(1,2) = mem2lox
      arg_memlo(1,3) = mem3lox
      arg_memlo(1,4) = mem4lox
      arg_memlo(1,5) = mem5lox
      arg_memlo(1,6) = mem6lox
      arg_memlo(1,7) = mem7lox
      arg_memlo(1,8) = mem8lox
      arg_memlo(1,9) = mem9lox

      arg_memlo(2,1) = mem1loy
      arg_memlo(2,2) = mem2loy
      arg_memlo(2,3) = mem3loy
      arg_memlo(2,4) = mem4loy
      arg_memlo(2,5) = mem5loy
      arg_memlo(2,6) = mem6loy
      arg_memlo(2,7) = mem7loy
      arg_memlo(2,8) = mem8loy
      arg_memlo(2,9) = mem9loy

      arg_memlo(3,1) = mem1loz
      arg_memlo(3,2) = mem2loz
      arg_memlo(3,3) = mem3loz
      arg_memlo(3,4) = mem4loz
      arg_memlo(3,5) = mem5loz
      arg_memlo(3,6) = mem6loz
      arg_memlo(3,7) = mem7loz
      arg_memlo(3,8) = mem8loz
      arg_memlo(3,9) = mem9loz

      arg_memlo(4,1) = mem1lot
      arg_memlo(4,2) = mem2lot
      arg_memlo(4,3) = mem3lot
      arg_memlo(4,4) = mem4lot
      arg_memlo(4,5) = mem5lot
      arg_memlo(4,6) = mem6lot
      arg_memlo(4,7) = mem7lot
      arg_memlo(4,8) = mem8lot
      arg_memlo(4,9) = mem9lot

      arg_memlo(5,1) = mem1loe
      arg_memlo(5,2) = mem2loe
      arg_memlo(5,3) = mem3loe
      arg_memlo(5,4) = mem4loe
      arg_memlo(5,5) = mem5loe
      arg_memlo(5,6) = mem6loe
      arg_memlo(5,7) = mem7loe
      arg_memlo(5,8) = mem8loe
      arg_memlo(5,9) = mem9loe

      arg_memlo(6,1) = mem1lof
      arg_memlo(6,2) = mem2lof
      arg_memlo(6,3) = mem3lof
      arg_memlo(6,4) = mem4lof
      arg_memlo(6,5) = mem5lof
      arg_memlo(6,6) = mem6lof
      arg_memlo(6,7) = mem7lof
      arg_memlo(6,8) = mem8lof
      arg_memlo(6,9) = mem9lof

      arg_memhi(1,1) = mem1hix
      arg_memhi(1,2) = mem2hix
      arg_memhi(1,3) = mem3hix
      arg_memhi(1,4) = mem4hix
      arg_memhi(1,5) = mem5hix
      arg_memhi(1,6) = mem6hix
      arg_memhi(1,7) = mem7hix
      arg_memhi(1,8) = mem8hix
      arg_memhi(1,9) = mem9hix

      arg_memhi(2,1) = mem1hiy
      arg_memhi(2,2) = mem2hiy
      arg_memhi(2,3) = mem3hiy
      arg_memhi(2,4) = mem4hiy
      arg_memhi(2,5) = mem5hiy
      arg_memhi(2,6) = mem6hiy
      arg_memhi(2,7) = mem7hiy
      arg_memhi(2,8) = mem8hiy
      arg_memhi(2,9) = mem9hiy

      arg_memhi(3,1) = mem1hiz
      arg_memhi(3,2) = mem2hiz
      arg_memhi(3,3) = mem3hiz
      arg_memhi(3,4) = mem4hiz
      arg_memhi(3,5) = mem5hiz
      arg_memhi(3,6) = mem6hiz
      arg_memhi(3,7) = mem7hiz
      arg_memhi(3,8) = mem8hiz
      arg_memhi(3,9) = mem9hiz

      arg_memhi(4,1) = mem1hit
      arg_memhi(4,2) = mem2hit
      arg_memhi(4,3) = mem3hit
      arg_memhi(4,4) = mem4hit
      arg_memhi(4,5) = mem5hit
      arg_memhi(4,6) = mem6hit
      arg_memhi(4,7) = mem7hit
      arg_memhi(4,8) = mem8hit
      arg_memhi(4,9) = mem9hit

      arg_memhi(5,1) = mem1hie
      arg_memhi(5,2) = mem2hie
      arg_memhi(5,3) = mem3hie
      arg_memhi(5,4) = mem4hie
      arg_memhi(5,5) = mem5hie
      arg_memhi(5,6) = mem6hie
      arg_memhi(5,7) = mem7hie
      arg_memhi(5,8) = mem8hie
      arg_memhi(5,9) = mem9hie

      arg_memhi(6,1) = mem1hif
      arg_memhi(6,2) = mem2hif
      arg_memhi(6,3) = mem3hif
      arg_memhi(6,4) = mem4hif
      arg_memhi(6,5) = mem5hif
      arg_memhi(6,6) = mem6hif
      arg_memhi(6,7) = mem7hif
      arg_memhi(6,8) = mem8hif
      arg_memhi(6,9) = mem9hif

      RETURN
      END

	SUBROUTINE ASN_REGRID_1_AXIS( cx_lims, axis, dst_lo, dst_hi,
     .				      src, msrc, dst, mdst )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* perform a regrid by "association"  (i.e. copy the data)

* 	programmer - Steve Hankin
* 	NOAA/PMEL,Seattle,WA - Tropical Modeling and Analysis Program

* V230:  8/22/92
* V570:  5/ 5/04  remove VMS includes
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xvariables.cmn'
	include 'xmem_subsc.cmn'
	include 'xcontext.cmn'

* Calling argument declarations:
	INTEGER cx_lims, axis, dst_lo, dst_hi, msrc, mdst
	REAL    src( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          dst( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif )

* Internal variable declarations:
	INTEGER i, j, k, l, m, n, idim,
     .          lo_lim(nferdims), hi_lim(nferdims)


* Initialize: limits for calculation
        DO 10 idim = 1, nferdims
           lo_lim(idim) = cx_lo_ss(cx_lims, idim)
           hi_lim(idim) = cx_hi_ss(cx_lims, idim)
 10     CONTINUE
        lo_lim(axis) = MAX( dst_lo, mr_lo_ss(msrc,axis) )
        hi_lim(axis) = MIN( dst_hi, mr_hi_ss(msrc,axis) )


* Copy the data to the destination grid
	DO 100 n = lo_lim(f_dim), hi_lim(f_dim)
	DO 100 m = lo_lim(e_dim), hi_lim(e_dim)
	DO 100 l = lo_lim(t_dim), hi_lim(t_dim)
	DO 100 k = lo_lim(z_dim), hi_lim(z_dim)
	DO 100 j = lo_lim(y_dim), hi_lim(y_dim)
	DO 100 i = lo_lim(x_dim), hi_lim(x_dim)
 100	dst(i,j,k,l,m,n) = src(i,j,k,l,m,n)

	RETURN
	END

	SUBROUTINE DO_INT_INDEF_SUB (idim, arg,
     .					   com_lo, com_hi,
     .					   com, com_mr, com_cx,
     .					   res, res_mr, res_cx,
     .					   box	)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* integrate the component along axis idim producing an "indefinite" integral

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:	10/11/89 - from old DO_INT_INDEF
*	  2/7/90 - eliminated diagnostic output - duplicated in calling routine
* V230: 5/6/92  - COS correction checks that J location is defined
*       8/10/92 - results were wrong for integration within a single box
* 9/09 - Apply fix to the cos factor (previous versions of the fix had not
*        been made), bug1348
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.
* v741 *acm*  5/18 remove old unused ifdef

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xprog_state.cmn'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xunits.cmn_text'
	external xunits_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data

* calling argument declarations:
	INTEGER	idim, com_lo, com_hi, com_mr, com_cx, res_mr, res_cx
	REAL	arg,
     .          com( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          res( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif ),
     .		box( com_lo:com_hi )

* internal variable declarations:
	LOGICAL	GEOG_COS_FACTOR, ITSA_TRUEMONTH_AXIS, 
     .          need_cos
	INTEGER i, j, k, l, m, n, grid, lo, hi, axis,
     .          ii, jj, kk, ll, mm, nn
	REAL	BOX_SIZE, unit, bad_com, bad_res, cos_factor,
     .          ybxlo, ybxhi, bx
	REAL*8	TM_WORLD, dsum

* initialize
	grid = mr_grid( com_mr )
	axis = grid_line( idim, grid )
	lo   = cx_lo_ss( com_cx, idim )
	hi   = cx_hi_ss( com_cx, idim )
	bad_com = mr_bad_data( com_mr )
	bad_res = mr_bad_data( res_mr )

* get and save grid box sizes (weights) just once for efficiency
* (end boxes may be only partially weighted)
        IF ( lo .EQ. hi ) THEN
           box(lo) = cx_hi_ww(idim,res_cx) - cx_lo_ww(idim,res_cx)
        ELSE
	   box(lo) = TM_WORLD(lo, grid, idim, box_hi_lim)
     .		   - cx_lo_ww(idim,res_cx)
	   DO 100 i = lo+1, hi-1
 100	   box(i)  = BOX_SIZE( i, grid, idim )
	   box(hi) = cx_hi_ww(idim,res_cx)
     .		   - TM_WORLD(hi, grid, idim, box_lo_lim)
        ENDIF

* perform integrations on standard units if possible
	unit = un_convert( line_unit_code(axis) )
	IF (ITSA_TRUEMONTH_AXIS(axis)) unit = un_convert(pun_day)
	DO 110 i = lo, hi
 110	box(i) = box(i) * unit

* INTEGRATE
* (is double precision summing necessary ? *sh* 6/89)
* ALONG X AXIS
* (note: X integration is a special case because it requires COSINE(lat) )
	IF ( idim .EQ. x_dim ) THEN
	   need_cos = GEOG_COS_FACTOR( idim, grid )
     .                .AND. cx_lo_s2(com_cx).NE.unspecified_int4
	   DO 210 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   IF ( need_cos ) THEN
	      cos_factor = COS( deg2rad *       
     .            TM_WORLD(j, grid, y_dim, box_middle) ) 
              ybxlo = deg2rad* 
     .            TM_WORLD(j,grid,y_dim,box_lo_lim)
              ybxhi = deg2rad* 
     .            TM_WORLD(j,grid,y_dim,box_hi_lim)
              bx = ABS(ybxhi - ybxlo)
	      cos_factor = ABS( SIN(ybxhi) - SIN(ybxlo) )/ bx
	   ENDIF
	   DO 210 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 210 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 210 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 210 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	      dsum = 0.0D0
	      DO 205 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_com ) THEN
* ... reject all data after a bad point
	            DO 200 ii = i, hi
 200	            res(ii,j,k,l,m,n) = bad_res
	            GOTO 210
	         ENDIF
	         dsum = dsum + box(i)*com(i,j,k,l,m,n)
	         IF ( need_cos ) THEN
	            res(i,j,k,l,m,n) = dsum * cos_factor
	         ELSE
	            res(i,j,k,l,m,n) = dsum
	         ENDIF
 205	      CONTINUE
 210	   CONTINUE

* ALONG Y AXIS
	ELSEIF ( idim .EQ. y_dim ) THEN
	   DO 310 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 310 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 310 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 310 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 310 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	      dsum = 0.0D0
	      DO 305 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_com ) THEN
* ... reject all data after a bad point
	            DO 300 jj = j, hi
 300	            res(i,jj,k,l,m,n) = bad_res
	            GOTO 310
	         ENDIF
	         dsum = dsum + box(j)*com(i,j,k,l,m,n)
	         res(i,j,k,l,m,n) = dsum
 305	      CONTINUE
 310	   CONTINUE

* ALONG Z AXIS
	ELSEIF ( idim .EQ. z_dim ) THEN
	   DO 410 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 410 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 410 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 410 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 410 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	      dsum = 0.0D0
	      DO 405 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_com ) THEN
* ... reject all data after a bad point
	            DO 400 kk = k, hi
 400	            res(i,j,kk,l,m,n) = bad_res
	            GOTO 410
	         ENDIF
	         dsum = dsum + box(k)*com(i,j,k,l,m,n)
	         res(i,j,k,l,m,n) = dsum
 405	      CONTINUE
 410	   CONTINUE

* ALONG T AXIS
	ELSEIF ( idim .EQ. t_dim ) THEN
	   DO 510 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 510 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 510 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 510 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 510 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	      dsum = 0.0D0
	      DO 505 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_com ) THEN
* ... reject all data after a bad point
	            DO 500 ll = l, hi
 500	            res(i,j,k,ll,m,n) = bad_res
	            GOTO 510
	         ENDIF
	         dsum = dsum + box(l)*com(i,j,k,l,m,n)
	         res(i,j,k,l,m,n) = dsum
 505	      CONTINUE
 510	   CONTINUE

* ALONG E AXIS
	ELSEIF ( idim .EQ. e_dim ) THEN
	   DO 610 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 610 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 610 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 610 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 610 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	      dsum = 0.0D0
	      DO 605 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_com ) THEN
* ... reject all data after a bad point
	            DO 600 mm = m, hi
 600	            res(i,j,k,l,mm,n) = bad_res
	            GOTO 610
	         ENDIF
	         dsum = dsum + box(m)*com(i,j,k,l,m,n)
	         res(i,j,k,l,m,n) = dsum
 605	      CONTINUE
 610	   CONTINUE

* ALONG F AXIS
	ELSEIF ( idim .EQ. f_dim ) THEN
	   DO 710 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 710 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 710 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 710 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 710 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	      dsum = 0.0D0
	      DO 705 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_com ) THEN
* ... reject all data after a bad point
	            DO 700 nn = n, hi
 700	            res(i,j,k,l,m,nn) = bad_res
	            GOTO 710
	         ENDIF
	         dsum = dsum + box(n)*com(i,j,k,l,m,n)
	         res(i,j,k,l,m,n) = dsum
 705	      CONTINUE
 710	   CONTINUE

	ENDIF

	RETURN
	END

	SUBROUTINE PARSEX(LINE,ILEN,X,INTIF,M,LABEL,N)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)parsex.F	1.2    5/26/88
C**
C**
C***********************************************************************
C**
C**		    PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C**	Subprogram called:
C**		CALL PARSEX(LINE,ILEN,X,IF,M,LABEL,N)
C**
C**	Parameters:
C**		LINE -- Line to be parsed   (char*2048)
C**		ILEN -- Length of LINE
C**		X -- Numerical array
C**		INTIF -- Flag array
C**			=0 X() not changed
C**			=1 X() replaced
C**		M -- Length of numerical and flag array
C**		LABEL -- Character portion of LINE  (char*2048)
C**		N -- Length of LABEL
C**
C**	Description:
C**		Parses the numerical values in LINE placing the results
C**		in X and sets the flag array IF appropriatly.  The
C**		character information starting after the last valid 
C**		number in placed in LABEL.
C**
C**	History:
C**	    Written: 
C**		30-MAY-85	by Donald W. Denbo
C**	    Modified:
C**
C*
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
C* v552 *acm* 3/03 Longer strings: changes for multi-line labels
* v580 *acm* 8/04 Change use of 256 to buflen+1, 
*                 where buflen is defined in cmndlen.inc
* V693+ *sh* 2/15 Allow _DQ_ to function like a double quote char

        INCLUDE 'cmndlen.inc'

	CHARACTER LABEL*(*),LINE*(*),FRMT*30
	DIMENSION X(*),INTIF(*)

*
*
*     *jd* variable IF renamed to INTIF for MAC 7.92
*     *jd* 11.94 -  modified for AIX port
*       Modification uses TM_NUMBER to determine if "value" is a number rather
*       than the ERR= branch of a READ which fails on AIX/xlf

        LOGICAL TM_NUMBER                ! ** TMAP mod 11/94 **
        INTEGER i                        ! ** TMAP mod 6/03 to init INTIF
C
	LOGICAL FIRST
C
C	Initialize output values
C
	LABEL = ' '
	N=0
        DO 90 I = 1, 20
	INTIF(I)=0
   90   CONTINUE
	M=1
	IF(ILEN.LE.0)THEN
	    M=0
	    RETURN
	ENDIF
	FIRST=.TRUE.
	I=1
C
C	Search for space or comma  (legal seperator)
C
100	IOLD=I
	ISPC=INDEX(LINE(I:),' ')+I-1
	IF(ISPC.EQ.I-1)ISPC=buflen+1
	ICMA=INDEX(LINE(I:),',')+I-1
	IF(ICMA.EQ.I-1) ICMA=buflen+1
	J=MIN0(ISPC,ICMA,ILEN+1)

* *acm 3/06 If i=j, see if what we have is a comma then space. 
*           Previously a space then comma was interpreted as
*           if it were two commas.  Check for just one comma
*           between elements, and can have any number of spaces.

        IF (i .EQ. j) THEN
           ICMA = INDEX(line(iold:i),',')
           IF (ICMA .NE. 0 .AND.
     .         INDEX(line(icma+1:i),',') .EQ. 0) THEN
              i = i + 1
              GOTO 100
           ENDIF
        ENDIF
C
C	Try to read a number,  if it fails put the rest into
C	LABEL if first is not true
C
	IF(I-J.EQ.0.OR.LINE(I:J-1).EQ.' ')THEN
	    INTIF(M)=0
	ELSE
C
C	Test for LINE(I:I) being +,-,., or 0-9.
C	That is a legal number
C
	    ITST=ICHAR(LINE(I:I))
	    IF(.NOT.(ITST.EQ.43.OR.ITST.EQ.45.OR.ITST.EQ.46
     *		.OR.(ITST.GE.48.AND.ITST.LE.57)))GOTO 1000
	    IWID=J-I
	    if(iwid.eq.1)then
#ifdef AIX_XLF
            IF ( .NOT.TM_NUMBER(LINE(I:J-1)) ) GOTO 1000  ! TMAP mod 11/94
#endif
		read(line(i:j-1),'(i1)',err=1000)jk
		x(m)=jk
	    else
	    WRITE(FRMT,999)IWID
999	    FORMAT('(F',I3.3,'.0)')
#ifdef AIX_XLF
            IF ( .NOT.TM_NUMBER(LINE(I:J-1)) ) GOTO 1000  ! TMAP mod 11/94
#endif
	    READ(LINE(I:J-1),FRMT,ERR=1000)X(M)
	    endif
	    INTIF(M)=1
	ENDIF
	FIRST=.FALSE.
	I=J
200	I=I+1
	IF(I.GT.ILEN)RETURN
	IF(LINE(I:I).EQ.' ')GOTO 200
	M=M+1
	GOTO 100
C
C	Error trying to read a number
C	clear the error and put the rest in LABEL
C
1000	continue
#ifndef unix
	CALL ERRTST(64,I)
#endif
	IF(FIRST)THEN
	    FIRST=.FALSE.
	    I=J
	    M=M-1
	    GOTO 200
	ENDIF
	M=M-1
	I=IOLD

	IF(LINE(I:I).EQ.'"')THEN
	   I=I+1
	ELSEIF (LINE(I:I).EQ.'_'
     .   .AND. I+3 .LE. ILEN    ) THEN
	   IF (LINE(I:I+3).EQ.'_DQ_') I=I+4
	ENDIF
C
C get the label (argument)
C
	LABEL=LINE(I:)
	N=ILEN-I+1
	IF(LABEL(N:N).EQ.'"')THEN
	    LABEL(N:N)=' '
	    N=N-1
	ELSEIF (LABEL(N:N).EQ.'_'
     .	  .AND. N-3 .GE.1      ) THEN
	    IF (LABEL(N-3:N).EQ.'_DQ_') THEN
	      LABEL(N-3:N) = ' '
	      N=N-4
	    ENDIF
	ENDIF
	RETURN
	END

	SUBROUTINE CD_WRITE_AXIS ( cdfid, dset, grid, idim, recdim,
     .                           loss, hiss, ax_type,  edges_flag, 
     .                           do_bounds, mode_upcase_output,  
     .                           keepax_flag, name_from_grid, dim_only, 
     .				 date_fmt_out, status )


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Write an axis definition out to the current output netCDF file
* May be a full "parent" definition, a sub_axis, or a "child" (a sub-axis
* which points to the full axis)

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 3/92
*   10/92: for performance reasons the "point_spacing" attribute will not be
*          maintained on the record axis (see cd_rec_synch)
*        - and CD_SET_MODE used to put into define mode before writing attribs
*   12/92: write axes in double precision (esp. for time axis issues) 
*    3/93: check error status after creating dimension
*    4/93: check "line_direction" in determining if time_origin is needed
*    1/95: change logical argument into integer "ax_type"
*    2/95: write NOAA COOP-compliant files: "days since 1992-02-28",
*	   "degrees_east", "degrees_north"
* 10/96 *kob* - Linux port - had to move variable assignments off of
*		declaration line.
* v4.91 *kob* 12/97 - added maxchildlen paramater for the max length of 
*                     a child axis
* v500 *kob*  3/99 - change lengths of CD_CHILDAX_NAME, CD_AXIS_NAME,
*                    name to 64 from 24 to match longer line_name
* V530 *sh* 12/00 - avoid performance problems of switching between netCDF
*	DEFINE and DATA mode by deferring actual coordinate writes until later
* v530 *acm* 1/01  calendar axes: write the calendar name if non-Gregorian
* v541 *sh* 2/02 - added support for line_modulo_len
* V550 *ACM* 12/02 Write AXIS attribute to output files.
* V570 *acm*  5/04 write bounds attribute and bounds 2xN coordinates to NetCDF files
* V581 *acm* 6/05 - Fix for bug 1271, add flag line_shift_origin
*            and restore original t0 on output
* V600 *acm* 2/06 - Fix for bug 1394, send do_err flag to TM_DATE_REFORMAT
* V600 *acm* 6/06 attribute control.
* V601 *acm* 9/06 Fix bug 1440: Remove stray "IF (attid .GT. 0) " before call to 
*                 CD_GET_VAR_ATT_INFO just after DO 200
* V602 *acm*11/06 Fix bug 1471; new routine CD_AXIS_OUTNAME
* V602 *acm*12/06 Correct the setting of got_calendar 
* V602  2/07 *acm* Fix bug 1492, changing attributes of coordinate variables 
* V61+  3/08 *acm* (After fixing bug 1534), check for attoutflag on bounds 
*                  attribute before writing bounds attribute and values.
* V61_ 5/08 *acm*  Fix bug1574: If the axis is a user-defined axis, get its
*                  information from the attribute structure; previously only
*                  did this for user variables.
* V62  *acm*  2/09 - Fix bug 1634: allow SAVE/KEEP_AXISNAMES so that child axis names
*                    arent written. They can get too long for OPeNDAP library calls
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V67  *acm* 3/11  Fix bug 1750. Revert to older behavior: if grid uses same axis
*                  name but different contents, write both to file with the name
*                  Ferret uses internally.
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing
* V683 9/12 *acm* Ticket 1968, If there is a _FillValue attributes on axes, refuse to write it.
* V685 5/13 *acm* When appending, if dimension of that name in the file but not a coord var,
*                 just check the length. See ticket 2075.
* V685 5/13 *acm* Allow specifying data type for axis
* V685 6/13 *acm* new qualifier SAVE/NOBOUNDS
* V685 6/13 *acm* Dont add SAVE/NOCOORDS
* V686 1/14 *acm* When appending to a file with a dimension but no coord var, to not write
*                 a NOTE. They just clutter things up.
* V687 3/14 *acm* Fix ticket 1750. Write Ferret-internal axis names to cdf files, unless
*                 the user has said /KEEP_AXISNAMES
* V69+ 4/14 *acm* After the above fix, need a tweak to be able to append to files having 
*                 dimensions that are not coordinate variables
* V69+ 7/14 *acm* Further fix to 1750. Ticket 2182: Keep case of axis name consistent when
*                 creating and writing axis bounds.
* V69+ 7/14 *acm* Ticket 1863: When output-flag was reset on an attribute, wasn't being applied
*                 if the variable wasn't associated with the dataset where that axis lives.
* v694 1/15 *acm* for ticket 2227: if a dimension from a nc file is not also a 
*                 1-D coordinate var, don't write the axis Ferret creates
* V697 12/15 *acm* Fix ticket 2336: consistent application of CAN MODE UPCASE
* V698  2/16 *acm* Check status of queries before continuing
* V698  4/16 *acm* Fix ticket 2241: If file has dimension but not a coordinate 
*                  variable, do not write the coordinate variable, ONLY IF writing 
*                  the full-span in that direction.
*  V698  4/16 *acm* When checking for dimension-only, this applies to file axes only.
*  V698  5/16 *acm* Fix ticket 2415: write attributes using the requested data type
*                   Routine CD_WRITE_ATTVAL_DP converts to the specified type.
* V698  4/16 *acm* Account for the calendar inside TM_UNIT_ID
* V701  7/16 *kms* Compare ds_name to char_init2048 instead of char_init1024
* V710  9/16 *acm* Ticket 2459: If axis is already in the file with a different
*                  direction write axis with a unique name for this direction.
*                  Use ww_dim_name from xtext_info.cmn
* V71  3/16 *acm* Ticket 2158: working with true monthly time axes. Write these axes
*                  as irregularly spaced daily axes.
* 1/26/2017 *acm* Ticket 1480. Do not write a modulo attribute if the requested 
*                 region is largerthan the length of the modulo axis.
* 10/6/2017 *acm* See fix in cd_get_line_direction.F, where axis or dim named 
*                 TIME but with no attributes was not marked in the T direction.
*                 An axis made from a dimension-only is not written out as the 
*                 record axis.
* V74  *acm*  7/2018 Issue # 1882, save/nobounds on monthly axis
* V7.44 11/18 *acm* Issue 1905: add int64 as a netcdf data type, recognize 
*                   other newer types 
* v745 *acm* 12/18 Issue 1909, option to write dates in ISO8601 format
* v75 *acm*   5/19 Issue 1933, recompute T0 datestring length after it
*                  possibly was reformatted
* v751 *acm*  6/19 Allow for longer strings as attribute values
* V751 *acm*  8/19 Issue 1947: If axis attr doesn't match grid direction, don't write it.
* V751 *acm* 11/19 *acm* new qualifier SAVE/NOCOORDS

* argument definitions:
*     dset    - dset (if netcdf file, for getting name and attribute 
*               info from linked-list structure  
*     cdfid   - netCDF id number for already opened CDF file
*     grid    - TMAP grid id
*     idim    - axis orientation (1-nferdims)
*     recdim  - is this to be the CDF record axis ? (input)
*     loss    - lo subscript (child axis, only)
*     hiss    - hi subscript (child axis, only)
*     status  - return status

* include files

        include 'netcdf.inc'
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
	include 'cdf_tmap.parm'
#include "gt_lib.parm"
        include 'cd_lib.parm'
        include 'xdset_info.cmn_text'
        external xdset_info_data
        include 'xtm_grid.cmn_text'
        external xgt_grid_data
        include 'xunits.cmn_text'
	include 'calendar.decl'
	include 'calendar.cmn'	
	include 'xio.cmn_text'
        external xio_data
	include 'xtext_info.cmn'  ! with ww_dim_name

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

* argument declarations
      LOGICAL recdim, mode_upcase_output, name_from_grid, dim_only
      INTEGER cdfid, dset, grid, idim, loss, hiss, ax_type, 
     .        edges_flag, keepax_flag, do_bounds, date_fmt_out, status

* local variable declarations:
* *kob* explicit definitions not allowed on decl line in linux...
*       moved it to parameter line 10/96
      LOGICAL TM_ABSTRACT_AXIS, TM_DATE_OK, MATCH_NAME, NC_GET_ATTRIB,
     .       ITSA_TRUEMONTH_AXIS,
     .       abstract, do_warn, got_modulo, got_calendar, got_units, 
     .       got_positive, got_spacing, got_axis, got_cartesian, got_it,
     .       coordvar, do_off, do_scale, true_month, is_regular,
     .       write_mod, dim_only_request
      PARAMETER (do_warn = .TRUE. )
      INTEGER TM_LENSTR1, CD_AXLEN, STR_SAME, STR_DNCASE, TM_LENSTR,
     .        dimid, iaxis, axid, cdfstat, lo, hi,
     .        nlen, elen, axlen, slen, edgid, bndid, npts, dim2d(2)
      INTEGER TM_GET_CALENDAR_ID, CD_WRITE_BNDSDIM, TM_UNIT_ID, TM_UNITS_CAL,
     .        cal_id, varid, llen, vartype, nvdims, nvatts, iatt, 
     .        attype, attlen,attoutflag, istat, maxlen, vdims(8), 
     .        newid, all_outflag, attid, dset_num, outtype, axis_packed, 
     .        dlen, vlen, iset, dim_status
      REAL vals(100)

!      LOGICAL condensed
!      REAL rlen
* *kob* 3/99 - change lengths of CD_CHILDAX_NAME, CD_AXIS_NAME,
*                    name to 64 from 24 to match longer line_name
* *acm* 6/06 - change axis name lengths to 128
      CHARACTER CD_CHILDAX_NAME*128, CD_AXIS_NAME*128, CD_AXIS_OUTNAME*128, 
     .       TM_FMT*48, name*128, name_in*128, units*48, datebuff*40, 
     .       buff*512, buff2*512, attname*128, dimstr*12, varstr*12, 
     .       name_bnds*140, axis_dir*1


!      REAL*8 val8_cdf, val8_tmap
* 12/97
      INTEGER maxchildlen
      PARAMETER (maxchildlen = 24)

* initialize
      iaxis = grid_line(idim, grid)
      dset_num = dset
      true_month = ITSA_TRUEMONTH_AXIS(iaxis)
      is_regular = line_regular(iaxis) .AND. .NOT.true_month 
      cal_id = 1

      dim_only_request = dim_only

      IF (true_month) THEN
         cal_id = TM_GET_CALENDAR_ID ( line_cal_name(iaxis) )
         IF (cal_id .NE. d360) THEN
            is_regular = .FALSE.
            IF (do_bounds .GE. 0) do_bounds = 1
         ENDIF
      ENDIF

      IF (.NOT.mode_upcase_output) keepax_flag = 1

      name = CD_AXIS_NAME( dset_num, grid, idim, nlen )
      IF (keepax_flag .EQ. 1) name = CD_AXIS_OUTNAME( dset_num, grid, idim, nlen )
      name_in = name
      
      name_from_grid = .FALSE.

* If the datset is user-variable or unknown, see if the axis is from a dataset. The
* OUTFLAG information for writing attributes is in the datset linked-list structure.

      IF (dset .LE. 0) THEN
         buff2  = name
         DO 50 iset = 1, maxdsets
	    IF (ds_name(iset) .NE. char_init2048) THEN
	       CALL CD_GET_VAR_ID (iset, buff2, varid, status)
	       IF (status .EQ. merr_ok) THEN
	          dset_num = iset
		  GOTO 60
	       ENDIF
	    ENDIF
   50 	CONTINUE
   60 	CONTINUE
      ENDIF

      buff2 = ' '

      npts = line_dim(iaxis)
      abstract = TM_ABSTRACT_AXIS( iaxis )

* If mode upcase_output is set, then upcase both name and name_in which is 
* being stored for later use.

      IF (mode_upcase_output) THEN
         CALL STR_UPCASE( name_in, name)
         CALL STR_UPCASE( name, name_in)

* If not mode upcase_output, then keep the incoming case. 
      ELSE 
         name = CD_AXIS_NAME( dset_num, grid, idim, nlen )
         IF (keepax_flag .EQ. 1) name = CD_AXIS_OUTNAME( dset_num, grid, idim, nlen )

         name_in = CD_AXIS_OUTNAME( dset_num, grid, idim, llen )

	 IF (STR_SAME(name, name_in) .EQ. 0) THEN 
	    name = name_in
	    nlen = llen
	 ENDIF
      ENDIF

* determine lo/hi limits of the axis to be written
      IF ( abstract ) THEN
         lo = loss
         hi = hiss
      ELSEIF ( ax_type .EQ. pcdf_full_span ) THEN
         lo = 1
         hi = line_dim(iaxis)
      ELSE
         lo = loss
         hi = hiss
      ENDIF

* dimension and size for this axis
      axlen = hi - lo + 1
      IF ( abstract .OR. ax_type.NE.pcdf_full_span ) THEN
         IF (keepax_flag .EQ. 0) 
     .       name = CD_CHILDAX_NAME( name, lo, hi, nlen )
* *kob* 12/9/97 - use new paramater maxchildlen in length check
         nlen = MIN(nlen,maxchildlen)
      ENDIF

* Is it just a dimension, not a coordinate variable

      buff = CD_AXIS_OUTNAME( dset_num, grid, idim, llen )

* Is it already in the file we're writing to?
* If it's there as a coordinate variable then dim_only is false.
* dim_status = 0 if dimension does not yet written
*            = 1 if dimension exists but there is not a coordinate variable
*            = 2 if dimension and coordinate variable are already in the file
      
      CALL CD_DIM_STATUS (cdfid, buff, llen, dim_status)
      IF (dim_only_request .AND. dim_status.LT.2) THEN
         dim_only = dim_only_request
      ELSE
         IF (dim_status .EQ. 2) dim_only = .FALSE.
      ENDIF
      
      cdfstat = NF_INQ_DIMID( cdfid, name(:nlen), dimid)

* ... check the axis attribute for direction. If the name has already
*     been used writing a different dimension, write this axis with a new name.

      IF ( cdfstat .EQ. NF_NOERR .AND. TM_LENSTR(name) .GT. 0) 
     .   CALL CD_AXNAME_TO_WRITE (cdfid, idim, name, nlen, cdfstat)

* already defined ? (limited consistency checking)
      IF ( cdfstat .EQ. NF_NOERR ) THEN

	 IF (.NOT. recdim) THEN 
            slen = CD_AXLEN( cdfid, dimid, status )
            IF ( status .NE. merr_ok ) GOTO 5900
            IF ( keepax_flag .NE. 1 .AND. .NOT.abstract) THEN

* ... check the length. 
               IF ( axlen .NE. slen ) THEN
	          IF ( cdfstat .NE. NF_NOERR ) GOTO 5300

* use the basic name straight from the grid
                  name = line_name(iaxis)
                  nlen = TM_LENSTR1( name )
                  name_in = name   ! ??

* If mode upcase_output is set, then upcase name

                  IF (mode_upcase_output) THEN
                     CALL STR_UPCASE( buff, name)
                  ENDIF

                  npts = line_dim(iaxis)
                  abstract = TM_ABSTRACT_AXIS( iaxis )

                  bndid = -1

* determine lo/hi limits of the axis to be written
                  IF ( abstract ) THEN
                     lo = loss
                     hi = hiss
                  ELSEIF ( ax_type .EQ. pcdf_full_span ) THEN
                     lo = 1
                     hi = line_dim(iaxis)
                  ELSE
                     lo = loss
                     hi = hiss
                  ENDIF

* dimension and size for this axis
                  axlen = hi - lo + 1

* Yes, use the basic name straight from the grid
	          name_from_grid = .TRUE.
                  
	       ENDIF
            ELSE 
               IF (axlen .NE. slen ) GOTO 5100
               GOTO 1000
            ENDIF
	 ENDIF
	 IF (.NOT. name_From_grid) GOTO 1000
      ENDIF

* Check that the axis type is set. User may have reset the type and then
* asked for SET AX/OUTTYPE=INTYPE.  If so need to re-get the orig type.
* If its a static line, set to double, and store that in line_dattype. If
* its an axis from a netcdf dataset, get the type from initializing the dataset.

      outtype = line_dattype(iaxis)

      CALL CD_GET_VAR_ID (dset_num, line_name(iaxis), varid, status)
      IF (varid .GT. 0) CALL CD_GET_VAR_INFO (dset_num, varid, buff, vartype, 
     .            nvdims, vdims, nvatts, coordvar, all_outflag, status)

      IF (outtype.LT.NF_BYTE .OR.  outtype.GT.NF_DOUBLE) THEN
         IF (iaxis .LE. max_lines) THEN
	    outtype = NF_DOUBLE  ! static lines - user-defined or Ferret internal
	    line_dattype(iaxis) = NF_DOUBLE
	 ELSE
	    outtype = vartype
         ENDIF
      ENDIF

* For now anyway write an axis that came in as INT64 using NF_DOUBLE instead.
* The NF_DEF_VAR below fails if the type is set to int64. 
* The unsigned integer types are defined but also not currently allowed by 
* NF_DEF_VAR, so switch to the signed versions.

      IF (outtype .EQ. NF_INT64 .OR. 
     .    outtype .EQ. NF_UINT64) outtype = NF_DOUBLE  
      IF (outtype .EQ. NF_USHORT) outtype = NF_SHORT  
      IF (outtype .EQ. NF_UINT) outtype = NF_INT  

* If axis came in packed we are not going to re-pack it on output (for now).
* write it as double and add a note.

      axis_packed = 0
      IF (varid .GT. 0) THEN
         attname = 'add_offset'
         CALL CD_GET_VAR_ATT_ID (dset_num, varid, attname, attid, status)
         IF (attid .GT. 0) axis_packed = 1
         attname = 'scale_factor'
         CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)
         IF (attid .GT. 0) axis_packed = 1

         IF (axis_packed .EQ. 1) THEN	    
            outtype = NF_DOUBLE
         ENDIF
      ENDIF

      npts = line_dim(iaxis)
      abstract = TM_ABSTRACT_AXIS( iaxis )

      bndid = -1


* put CDF into define mode so axis can be defined
      CALL CD_SET_MODE(cdfid, pcd_mode_define, status)
      IF ( status .NE. merr_ok ) RETURN

* define the dimension (if its just a dimension, will not write as a record axis)
      IF ( recdim .AND. .NOT.line_dim_only(iaxis) .AND. .NOT.dim_only) THEN
         cdfstat = NF_DEF_DIM( cdfid, name(:nlen), NF_UNLIMITED, dimid )
      ELSE
         cdfstat = NF_DEF_DIM( cdfid, name(:nlen), axlen, dimid )
      ENDIF
      
* checking. debugging.  npts should be 0, no records written yet.
         cdfstat = NF_INQ_DIM ( cdfid, dimid, buff, npts )

      IF ( cdfstat .NE. NF_NOERR ) GOTO 5200

* If the dimension was a dimension only (not a 1-D coordinate variable) in the 
* source datset, just create the dimension in the output file. Don't write out
* the basic axis that Ferret defined. (If Ferret synthesized the variable, do write
* the axis.)

** ticket 2241: if it's a subspan axis, write it out...

      IF (line_dim_only(iaxis) .AND. dset.GT.0 .AND.
     .    ax_type.EQ.pcdf_full_span) GOTO 1000

      IF (dim_only) GOTO 1000

* create the coordinate variable (12/92 -> double precision)
      cdfstat = NF_DEF_VAR(cdfid, name(:nlen), outtype, 1, dimid, axid)
      IF ( cdfstat .NE. NF_NOERR ) GOTO 5200

* check: can we get the coord var id back??
         cdfstat = NF_INQ_VARID( cdfid, name(:nlen), newid )

* assign its attributes
      IF (ax_type .EQ. pcdf_child_span) THEN
         cdfstat = NF_PUT_ATT_TEXT (cdfid, axid, 'child_axis', 1, ' ')
      ENDIF
!      IF ( condensed ) THEN
!         cdfstat = NF_PUT_ATT_DOUBLE (cdfid, axid, 'true_size',
!     .         1, npts)
!      ENDIF

      got_modulo = .FALSE.
      got_calendar = .FALSE.
      got_units = .FALSE.
      got_positive = .FALSE.
      got_spacing = .FALSE.
      got_axis = .FALSE.
      got_cartesian = .FALSE.
      
      write_mod = .TRUE.

! get whatever attributes are available in the linked-list structure.
! use the name of the parent axis.

      CALL CD_GET_VAR_ID (dset_num, name_in, varid, status)

* If the axis is a user-defined axis, we still dont have its info. Look in 
* the pseudo-dataset of user-defined coordinate variables.

      IF (varid .EQ. 0 .AND. .NOT.abstract) THEN
         dset_num = -2
         CALL CD_GET_VAR_ID (dset_num, name_in, varid, status)
      ENDIF
      
      IF (varid .GT. 0) THEN

* Get axis name into original upper/lowercase form, and get nvatts.

         CALL CD_GET_VAR_INFO (dset_num, varid, buff, vartype, 
     .                   nvdims, vdims, nvatts, coordvar, 
     .                   all_outflag, status) 

* If mode upcase_output is set, then upcase the name.

         name_in = buff
         IF (mode_upcase_output) CALL STR_UPCASE( name_in, buff)

         DO 200 iatt = 1, nvatts
            attoutflag = 0
            CALL CD_GET_VAR_ATT_INFO (dset_num, varid, 
     .               iatt, attname, attype, attlen, attoutflag, status )

            maxlen = 512
            got_it = NC_GET_ATTRIB ( dset_num, varid, attname, 
     .               do_warn, name_in, maxlen, attlen, attoutflag, 
     .               buff, vals)

* If the user has not asked for bounds and if its a regular axis then
*  do not write bounds attribute. (The bounds themselves arent written.)
            IF ( (STR_SAME(attname, 'bounds') .EQ. 0) .AND. 
     .           (is_regular .AND. do_bounds.LE.0) ) 
     .               attoutflag = 0

* If they asked for /NOBOUNDS, dont write bounds even if the axis is irregular.
            IF ( STR_SAME(attname, 'bounds') .EQ. 0) THEN
	       name_bnds = name(:nlen)//'_bnds'
               IF (name_bnds.NE.buff) buff = name_bnds
	       IF ( do_bounds.LT.0) attoutflag = 0
            ENDIF

* If there is a _FillValue attributes on axes, refuse to write it.

            IF (MATCH_NAME (attname,  TM_LENSTR1(attname), 
     .           '_FILLVALUE', 10) ) attoutflag = 0
		
* If there is an axis attribute check that it matches the direction in the grid
* and skip writing it if not.

            IF (attoutflag.EQ.1 .AND. MATCH_NAME (attname,  TM_LENSTR1(attname), 'axis', 4) ) THEN
	       IF ( .NOT. MATCH_NAME (buff, 1, ww_dim_name(idim), 1) ) THEN
	          attoutflag = 0
		  got_axis = .TRUE.
	       ENDIF
            ENDIF
 
* Write the attribute, but skip this for the point-spacing attr on record axis.

            IF ( MATCH_NAME (attname,  TM_LENSTR1(attname), 
     .           'MODULO', 6) ) THEN

* Ticket 1480. For a modulo axis, if the requested region is longer than the 
* axis length, do not write the modulo attribute. Issue a note.

	       IF (hiss - loss .GE. line_dim(iaxis)) THEN
                  CALL WARN ('Requested region on modulo axis '//name(:nlen)//
     .               ' is larger than modulo length. Modulo attribute not written.')
                  attoutflag = 0
		  write_mod = .FALSE.
	       ENDIF

               IF (attype .NE. NF_CHAR .AND. vals(1) .EQ. 0.) THEN
! Write line_modulo_len 
                  vals(1) = line_modulo_len(iaxis)
                  IF (attoutflag .EQ. 1) attype = NF_FLOAT
               ENDIF
            ENDIF

            IF ( recdim  .AND. 
     .           MATCH_NAME (attname,  TM_LENSTR1(attname), 
     .           'POINT_SPACING', 13) ) THEN
               got_spacing = .TRUE.
	       IF (true_month) buff = 'uneven' 
            ELSE
               IF (attype .EQ. NF_CHAR .AND. attoutflag .EQ. 1) THEN
		  IF (MATCH_NAME (attname,  5, 'UNITS', 5) ) THEN
                     buff2 = buff
                     status = STR_DNCASE(buff, buff2)

		  ENDIF
                  llen = TM_LENSTR1(buff)
                  CALL CD_WRITE_ATTRIB (cdfid, name(:nlen), attname,
     .                               buff(:llen), .FALSE., status )
	       ELSE IF (attoutflag .EQ. 1) THEN
                  CALL CD_WRITE_ATTVAL_DP(cdfid, name(:nlen), attname,
     .                                 vals, attlen, attype, status )
               ENDIF
            ENDIF

            slen = TM_LENSTR1(attname)
            IF (MATCH_NAME (attname,  slen, 'UNITS', 5 ) .AND. 
     .          attoutflag .EQ. 1)
     .                got_units = .TRUE.
            IF (MATCH_NAME (attname,  slen, 'CALENDAR', 8 ) .AND. 
     .          attoutflag .EQ. 1)
     .                got_calendar = .TRUE.
            IF (MATCH_NAME (attname,  slen, 'MODULO', 6 ) .AND. 
     .          attoutflag .EQ. 1)
     .                got_modulo = .TRUE.
            IF (MATCH_NAME (attname,  slen, 'POSITIVE', 8 ) .AND. 
     .          attoutflag .EQ. 1)
     .                got_positive = .TRUE.
            IF (MATCH_NAME (attname,  slen, 'POINT_SPACING', 13) .AND. 
     .          attoutflag .EQ. 1)
     .                got_spacing = .TRUE.
            IF (MATCH_NAME (attname,  slen, 'AXIS', 4 ) .AND. 
     .          attoutflag .EQ. 1)
     .                got_axis = .TRUE.
            IF (MATCH_NAME (attname,  slen, 'CARTESIAN_AXIS', 14 ) .AND. 
     .          attoutflag .EQ. 1)
     .                got_cartesian = .TRUE.

 200     CONTINUE
      ENDIF

* write modulo, t0, etc as attributes if they exist in Ferret 
* variables line_modulo etc. This is consistent with previous Ferret behavior.

      attoutflag = 1  

* May want to add since t0 

      IF ( line_direction(iaxis) .EQ. 'TI' ) THEN
         cal_id = TM_GET_CALENDAR_ID (line_cal_name(iaxis))
         IF (TM_DATE_OK( line_T0(iaxis),cal_id ) ) got_units = .FALSE.
      ENDIF

      IF ( line_units(iaxis) .NE. ' ' .AND. (.NOT.got_units) ) THEN
	 units = line_units(iaxis)	 

	 IF ( line_direction(iaxis) .EQ. 'WE'
     .	.AND. line_unit_code(iaxis) .EQ. pun_degrees ) THEN
	    units = 'degrees_east'
	 ELSEIF ( line_direction(iaxis) .EQ. 'SN'
     .	.AND. line_unit_code(iaxis) .EQ. pun_degrees ) THEN
	    units = 'degrees_north'
	ELSEIF ( line_direction(iaxis) .EQ. 'TI'
     . .AND. TM_DATE_OK( line_T0(iaxis),cal_id )    ) THEN
            buff = line_units(iaxis)
	    slen = TM_LENSTR1( buff )
	    units = buff(:slen)//' since '

* get original units. If a user-defined true-month axis, will write in units of days.
	    IF (true_month) THEN  
	       IF (buff2(1:8).EQ.'TRUMONTH' .OR. 
     .             TM_LENSTR1(buff2).LE.1) buff2 = 'days'
	       slen = INDEX(buff2, ' since') - 1
	       IF (slen .LE. 0) slen = TM_LENSTR1 (buff2)
	       units = buff2(:slen)//' since'
	    ENDIF

            IF (line_shift_origin(iaxis)) THEN
               datebuff = '01-JAN-0001 00:00:00'
            ELSE
 	       datebuff = line_T0(iaxis)
            ENDIF
            CALL TM_DATE_REFORMAT(datebuff,pdate_vax,cal_id,
     .				  units(slen+8:),pdate_numslashnum,
     .				  .TRUE., status )

            buff2 = units
            status = STR_DNCASE(units, buff2)

	ENDIF
        slen = TM_LENSTR1( units )

        attname = 'units' 
        IF (varid .GT. 0) THEN
           CALL CD_GET_VAR_ATT_ID (dset_num, varid, attname, attid, 
     .                 status)
           IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset_num, varid, 
     .         attid, attname,  attype, attlen, attoutflag, istat )
        ELSE
           attoutflag = 1
        ENDIF

        IF (attoutflag .EQ. 1) 
     .     cdfstat = NF_PUT_ATT_TEXT( cdfid, axid, attname,
     .        	       slen, units(:slen) )

      ENDIF
      IF ( idim .EQ. t_dim .AND. (.NOT.got_calendar) ) THEN                  ! 4/93 update
        cal_id = TM_GET_CALENDAR_ID (line_cal_name(iaxis))
	IF ( line_direction(iaxis) .EQ. 'TI'
     . .AND. TM_DATE_OK( line_T0(iaxis), cal_id )    ) THEN

            IF (line_shift_origin(iaxis)) THEN
               datebuff = '01-JAN-0001 00:00:00'
            ELSE
 	       datebuff = line_T0(iaxis)
            ENDIF

            slen = TM_LENSTR1( datebuff )
            
            attname = 'time_origin' 
            IF (varid .GT. 0) THEN
               CALL CD_GET_VAR_ATT_ID (dset_num, varid, attname, attid, 
     .                 status)
               IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset_num, varid, 
     .             attid, attname, attype, attlen, attoutflag, istat )
            ELSE 
               attoutflag = 1
            ENDIF

* If they have set MODE DATE_FORMAT:ISO then convert the date string
            CALL TM_DATE_REFORMAT(datebuff, pdate_vax, cal_id,
     .                            datebuff, date_fmt_out,
     .                            .TRUE., status )

            slen = TM_LENSTR1 (datebuff)
	    IF (attoutflag .EQ. 1) 
     .         cdfstat = NF_PUT_ATT_TEXT( cdfid, axid, attname,
     .        	       slen, datebuff(:slen) )
	ENDIF

*  Write the calendar name

        IF (cal_id .NE. 1) THEN
          slen = TM_LENSTR1( line_cal_name(iaxis) )

          attname = 'calendar' 
          IF (varid .GT. 0) THEN
             CALL CD_GET_VAR_ATT_ID (dset_num, varid, attname, attid, status)
             IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset_num, varid, 
     .                attid, attname, attype, attlen, attoutflag, istat )
          ELSE
             attoutflag = 1
          ENDIF

          IF (attoutflag .EQ. 1) 
     .      cdfstat = NF_PUT_ATT_TEXT( cdfid, axid, attname,
     .        	       slen, line_cal_name(iaxis)(:slen))
        ENDIF
      ENDIF

* Ticket 1480. For a modulo axis, if the requested region is longer than the 
* axis length, do not write the modulo attribute. 

      IF ( line_modulo(iaxis) .AND. (.NOT.got_modulo) ) THEN
	 IF (line_modulo_len(iaxis) .EQ. 0.0D0 ) THEN
           attname = 'modulo' 
           IF (varid .GT. 0) THEN
              CALL CD_GET_VAR_ATT_ID(dset_num, varid, attname, attid,status)
              IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset_num, varid, 
     .              attid, attname, attype, attlen, attoutflag, istat )
           ELSE
              attoutflag = 1
           ENDIF
           IF (attoutflag .EQ. 1 .AND. write_mod)
     .       cdfstat = NF_PUT_ATT_TEXT( cdfid, axid, attname,
     .        	       1, ' ' )
	 ELSE
           attname = 'modulo' 
           IF (varid .GT. 0) THEN
              CALL CD_GET_VAR_ATT_ID(dset_num, varid, attname, attid,status)
              IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset_num, varid, 
     .               attid, attname, attype, attlen, attoutflag, istat )
           ELSE
              attoutflag = 1
           ENDIF
           IF (attoutflag .EQ. 1 .AND. write_mod) 
     .      cdfstat = NF_PUT_ATT_DOUBLE( cdfid, axid, attname,
     .        	       outtype, 1, line_modulo_len(iaxis) )
	 ENDIF

* Check if user wants to write modulo=false to the file
      ELSE IF (got_modulo .AND. (varid .GT. 0) .AND.
     .         .NOT.line_modulo(iaxis)  ) THEN 
            attname = 'modulo'
            CALL CD_GET_VAR_ATT_ID (dset_num, varid, attname, attid, status)
            IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset_num, varid, 
     .              attid, attname, attype, attlen, attoutflag, istat )

            maxlen = 512
            got_it = NC_GET_ATTRIB ( dset_num, varid, attname, 
     .               do_warn, name_in, maxlen, attlen, attoutflag, 
     .               buff, vals)

            IF (attype .EQ. NF_CHAR .AND. attoutflag .EQ. 1) THEN
               llen = TM_LENSTR1(buff)
               CALL CD_WRITE_ATTRIB(cdfid, name(:nlen), attname,
     .                               'false', .FALSE., status )
            ELSE IF (attoutflag .EQ. 1) THEN
               CALL CD_WRITE_ATTVAL_DP(cdfid, name(:nlen), attname,
     .                              vals, attlen, attype, status )
            ENDIF


      ENDIF

      IF ( idim.EQ.z_dim .AND. line_direction(iaxis).EQ.'UD' .AND.
     .     (.NOT.got_positive) ) THEN
           attname = 'positive' 
           IF (varid .GT. 0) THEN
              CALL CD_GET_VAR_ATT_ID(dset_num, varid, attname, attid,status)
              IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset_num, varid, 
     .              attid, attname, attype, attlen, attoutflag, istat )
           ELSE
              attoutflag = 1
           ENDIF
           IF (attoutflag .EQ. 1) 
     .      cdfstat = NF_PUT_ATT_TEXT( cdfid, axid, attname,
     .        	       4, 'down' )
      ENDIF

* record axis (time, usually) doesn't get coordinate spacing or any
* coordinates inserted at creation time
      IF ( recdim ) THEN

         CONTINUE
      ELSE
        IF (.NOT. got_spacing) THEN
        IF ( is_regular ) THEN
           attname = 'point_spacing' 
           IF (varid .GT. 0) THEN
              CALL CD_GET_VAR_ATT_ID(dset_num, varid, attname, attid,status)
              IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset_num, varid, 
     .              attid, attname, attype, attlen, attoutflag, istat )
           ELSE
              attoutflag = 1
           ENDIF
           IF (attoutflag .EQ. 1) 
     .      cdfstat = NF_PUT_ATT_TEXT( cdfid, axid, attname,
     .        	       4, 'even' )
        ELSE
* sub-span axis may not have irregular spacing just cuz parent does
* 12/00 NO. ... regular appearing coordinates are not necessarily regular --
*       for example 2 points extracted from an irregular axis will always
*	appear to be regular, but their box limits are not necessarily so
           IF ( ax_type .EQ. pcdf_full_span
     .     .OR. ax_type .EQ. pcdf_sub_span ) THEN
              attname = 'point_spacing' 
              IF (varid .GT. 0) THEN
                 CALL CD_GET_VAR_ATT_ID (dset_num, varid, attname, 
     .                  attid, status)
                 IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset_num, varid, 
     .               attid, attname, attype, attlen, attoutflag, istat )
              ELSE 
                 attoutflag = 1
              ENDIF
              IF (attoutflag .EQ. 1)
     .      cdfstat = NF_PUT_ATT_TEXT( cdfid, axid, attname,
     .        	       6, 'uneven' )
           ENDIF
        ENDIF
        ENDIF  ! got_spacing

* set up for deferred writing of coordinate values (12/00)
	CALL CD_DEFER_COORD_WRITE(axid, grid, idim, lo, hi,
     .				  pcd_defer_points)

      ENDIF

* Write AXIS attribute

      IF (.NOT. got_axis) THEN

           attname = 'axis' 
           IF (varid .GT. 0) THEN
              CALL CD_GET_VAR_ATT_ID (dset_num, varid, attname, attid,
     .                  status)
              IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset_num, varid,
     .             attid, attname, attype, attlen, attoutflag, istat )
           ELSE
              attoutflag = 1
           ENDIF
            
          IF (attoutflag .EQ. 1) cdfstat = NF_PUT_ATT_TEXT
     .        	     ( cdfid, axid, attname, 1, ww_dim_name(idim) )
       ENDIF

* If the axis is a know geophysical direction write the standard name 
* attribute for it.

      attname = 'standard_name'
      IF ( line_direction(iaxis) .EQ. 'WE') THEN
         buff = 'longitude'
	 llen = TM_LENSTR1(buff)
         CALL CD_WRITE_ATTRIB (cdfid, name(:nlen), attname,
     .        buff(:llen), .FALSE., status )
      ENDIF
      IF ( line_direction(iaxis) .EQ. 'SN') THEN
         buff = 'latitude'
	 llen = TM_LENSTR1(buff)
         CALL CD_WRITE_ATTRIB (cdfid, name(:nlen), attname,
     .        buff(:llen), .FALSE., status )
      ENDIF
      IF ( line_direction(iaxis) .EQ. 'UD') THEN
         buff = 'depth'
	 llen = TM_LENSTR1(buff)
         CALL CD_WRITE_ATTRIB (cdfid, name(:nlen), attname,
     .        buff(:llen), .FALSE., status )
      ENDIF
      IF ( line_direction(iaxis) .EQ. 'DU') THEN
         buff = 'altitude'
	 llen = TM_LENSTR1(buff)
         CALL CD_WRITE_ATTRIB (cdfid, name(:nlen), attname,
     .        buff(:llen), .FALSE., status )
      ENDIF
      IF ( line_direction(iaxis) .EQ. 'TI') THEN
         buff = 'time'
	 llen = TM_LENSTR1(buff)
         CALL CD_WRITE_ATTRIB (cdfid, name(:nlen), attname,
     .        buff(:llen), .FALSE., status )
      ENDIF

* If the axis came in scaled, and the users asked for scaling on output
* then return a note.

       IF (varid .GT. 0) THEN
          do_scale = .FALSE.
	  do_off = .FALSE.
          attname = 'scale_factor' 
          CALL CD_GET_VAR_ATT_ID (dset_num, varid, attname, attid,
     .               status)
          IF (attid .GT. 0) THEN
	     CALL CD_GET_VAR_ATT_INFO (dset_num, varid,
     .          attid, attname, attype, attlen, attoutflag, istat )
             IF (attoutflag .EQ. 1) do_scale = .TRUE.
          ENDIF

          attname = 'add_offset' 
          CALL CD_GET_VAR_ATT_ID (dset_num, varid, attname, attid,
     .               status)
          IF (attid .GT. 0) THEN
             CALL CD_GET_VAR_ATT_INFO (dset_num, varid,
     .          attid, attname, attype, attlen, attoutflag, istat )
             IF (attoutflag .EQ. 1) do_off = .TRUE.
          ENDIF
 
          IF (do_scale .OR. do_off .OR. (axis_packed .EQ. 1) )  
     .    CALL WARN(name(1:nlen)//
     .      ': Writing scaled coordinates not implemented. Suggest '//
     .      'using nco operators on output file to pack coord values')
       ENDIF
            
* does it need axis bounds definitions ?

* Has the user explicitly asked not to write bounds attribute for the variable? 
* If so mark this with the value attoutflag = 2

      attname = 'bounds' 
      attoutflag = 0
      IF (varid .GT. 0) THEN
         CALL CD_GET_VAR_ATT_ID(dset_num, varid, attname, attid, status)
         IF (attid .GT. 0) THEN
            CALL CD_GET_VAR_ATT_INFO (dset_num, varid, 
     .      attid, attname, attype, attlen, attoutflag, istat )
            IF (attoutflag .EQ. 0) attoutflag = 2
         ENDIF
      ENDIF

* If they said /NOBOUNDS on the SAVE command, do not write bounds
* even if the axis is irregular.

      IF (do_bounds .EQ. -1) attoutflag = 2

      IF (  (ax_type.EQ.pcdf_full_span .OR. ax_type.EQ.pcdf_sub_span)
     .  .AND. ( .NOT.is_regular .OR. do_bounds.EQ.1) 
     .  .AND. ( edges_flag .EQ. 0) 
     .  .AND. ( attoutflag .NE. 2) ) THEN

* bounds attribute may already be set up.  If so use it, otherwise define bounds.
         got_it = NC_GET_ATTRIB ( dset_num, varid, attname, 
     .               do_warn, name_in, maxlen, attlen, attoutflag, 
     .               buff, vals)
         IF (got_it) THEN
            name = name_bnds
            elen = TM_LENSTR1(name)
	 ELSE
	    name = name(:nlen)//'_bnds'
	    elen = nlen + 5
	 ENDIF

* ... define the first dimension of bounds variable (what about record axis??)

         dim2d(2) = dimid    ! Dimension already defined above for coordinates

         IF ( cdfstat .NE. NF_NOERR ) GOTO 5200

* ... second dimension of bounds coordinate variable is 2
         dim2d(1) = CD_WRITE_BNDSDIM(cdfid, status)

* ... create the bounds variable, if it has not been created.
         IF (bndid .EQ. -1) cdfstat = NF_DEF_VAR(cdfid, 
     .    name(:elen), outtype, 2, dim2d, bndid)

         IF ( cdfstat .NE. NF_NOERR ) GOTO 5220

* ... point to it from axis coordinates definition

         attname = 'bounds' 
         IF (varid .GT. 0) THEN
            CALL CD_GET_VAR_ATT_ID (dset_num, varid, attname, attid, status)
            IF (attid .GT. 0) THEN
               CALL CD_GET_VAR_ATT_INFO (dset_num, varid, 
     .              attid, attname, attype, attlen, attoutflag, istat)
            ELSE
               attoutflag = 1
            ENDIF 
         ELSE
            attoutflag = 1
         ENDIF

         IF (attoutflag .EQ. 1) THEN
            cdfstat = NF_PUT_ATT_TEXT (cdfid, axid, attname,
     .                elen, name(:elen))

* set up for deferred writing of bounds coordinate values (12/00)
* Record axis and bounds are written when variable written.

           IF ( .NOT.recdim ) 
     .       CALL CD_DEFER_COORD_WRITE(bndid, grid, idim, lo, hi,
     .				  pcd_defer_bounds)
         ENDIF

      ENDIF

* does it need axis box edge definitions ?  
* edges_flag = 1 if requested with /EDGES qualifier
* edges_flag = 2 if requested with /RIGID qualifier

      IF (  (ax_type.EQ.pcdf_full_span .OR. ax_type.EQ.pcdf_sub_span)
     . .AND. ((edges_flag.EQ.1) .OR.
     .        (edges_flag.EQ.2 .AND.
     .         .NOT.is_regular .AND. 
     .         .NOT.recdim)) ) THEN

         name = name(:nlen)//'edges'
         elen = nlen + 5
         cdfstat = NF_DEF_DIM( cdfid, name(:elen), axlen+1, dimid )
         cdfstat = NF_DEF_VAR(cdfid, name(:elen), outtype, 1, 
     .           dimid, edgid)
         attname = 'edges' 
         IF (varid .GT. 0) THEN
            CALL CD_GET_VAR_ATT_ID (dset_num, varid, attname, attid, status)
            IF (attid .GT. 0) THEN
               CALL CD_GET_VAR_ATT_INFO (dset_num, varid, 
     .              attid, attname, attype, attlen, attoutflag, istat)
               IF (edges_flag .GT. 0) attoutflag = 1
            ELSE
               attoutflag = 1
            ENDIF 
         ELSE
            attoutflag = 1
         ENDIF
         IF (attoutflag .EQ. 1) THEN
            cdfstat = NF_PUT_ATT_TEXT( cdfid, edgid, attname, 1, ' ' )
* ... point to it from axis coordinates definition
            cdfstat = NF_PUT_ATT_TEXT( cdfid, axid, attname, elen,
     .                name(:elen) )

* set up for deferref writing of edge coordinate values (12/00)
	    CALL CD_DEFER_COORD_WRITE(edgid, grid, idim, lo, hi,
     .				  pcd_defer_edges)
         ENDIF

      ENDIF

* successful completion
 1000 status = merr_ok

      RETURN

* error messages
 5100 CONTINUE
      IF (keepax_flag .EQ. 1) THEN
         CALL WARN ("Writing a subset of data with original axis names")
         CALL WARN 
     . ("  Axis was already written with a different set of coordinates")
      ENDIF
      CALL TM_ERRMSG
     . ( merr_linepredef, status, 'CD_WRITE_AXIS', unspecified_int4,
     .   unspecified_int4,
     .  'axis '//name(:nlen)//' doesnt match CDF file',
     .  no_errstring, *5900 )

 5200 CALL TM_ERRMSG
     .     ( cdfstat+pcdferr, status, 'CD_WRITE_AXIS', cdfid,
     .       unspecified_int4, 'Failed creating coord variable '
     .       //name(:nlen), no_errstring, *5900 )

 5220 CALL TM_ERRMSG
     .     ( cdfstat+pcdferr, status, 'CD_WRITE_AXIS', cdfid,
     .       unspecified_int4, 
     .       'Failed creating bounds for coord variable '
     .       //name(:nlen), no_errstring, *5900 )

 5300 dimstr = TM_FMT(DBLE(slen), 0, 12, dlen)
      varstr = TM_FMT(DBLE(axlen), 0, 12, vlen)
      CALL TM_ERRMSG
     . ( merr_linepredef, status, 'CD_WRITE_AXIS', unspecified_int4,
     .   unspecified_int4,
     .  'Length of file dimension '//name(:nlen)//' is '//dimstr(:dlen)
     .  //'. Variable axis length '//varstr(:vlen)
     .  //' must match.',
     .  no_errstring, *5900 )

* error exit
 5900   RETURN
	END

*
* element_index.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* July 2005
*
*  Return index value in LIST for each grids point in V, or a
*  missing value wherever there is no match)
*
*   3/12 *kms* Give index into unraveled arg_2
*              instead of just I index of arg_2
*              (and add E and F dimensions)

*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE element_index_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CHARACTER*100 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT ('Return index value in ARG2 for each point in ARG1')
      CALL ef_set_desc(id, fcn_desc)

* Tell Ferret to run the following instead, if the arguments are strings.
      CALL ef_set_alt_fcn_name(id, 'ELEMENT_INDEX_STR')

      CALL ef_set_num_args(id, 2)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)


      arg = 1
      CALL ef_set_arg_name(id, arg, 'VAR')
      CALL ef_set_arg_desc(id, arg, 'Variable')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'VALUES')
      CALL ef_set_arg_desc(id, arg, 'list of indices')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE element_index_compute(id, arg_1, arg_2, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER ndx
      INTEGER i, j, k, l, m, n
      INTEGER i2, j2, k2, l2, m2, n2

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

C  Check for values matching arg2
C  Assumes result and arg_1 have same array dimension limits

      DO 300 n=res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
      DO 300 m=res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
      DO 300 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
      DO 300 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
      DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
      DO 300 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         ndx = 1
         DO 100 n2=arg_lo_ss(F_AXIS,ARG2), arg_hi_ss(F_AXIS,ARG2)
         DO 100 m2=arg_lo_ss(E_AXIS,ARG2), arg_hi_ss(E_AXIS,ARG2)
         DO 100 l2=arg_lo_ss(T_AXIS,ARG2), arg_hi_ss(T_AXIS,ARG2)
         DO 100 k2=arg_lo_ss(Z_AXIS,ARG2), arg_hi_ss(Z_AXIS,ARG2)
         DO 100 j2=arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS,ARG2)
         DO 100 i2=arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS,ARG2)
            IF ( arg_1(i,j,k,l,m,n) .NE. bad_flag(1) .AND.
     .           arg_2(i2,j2,k2,l2,m2,n2) .NE. bad_flag(2) .AND.
     .           arg_1(i,j,k,l,m,n) .EQ. arg_2(i2,j2,k2,l2,m2,n2) ) THEN
               result(i,j,k,l,m,n) = ndx
               GOTO 200
            ENDIF
            ndx = ndx + 1
 100     CONTINUE

C        If we got here it was not found
         result(i,j,k,l,m,n) = bad_flag_result

 200     CONTINUE

 300  CONTINUE

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN
      END

	SUBROUTINE CD_RD_STR_1(cdfid, varid, index, errstr, buff, slen, status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* read a single string value from a netCDF variable and return it as a double prec.
* The variable must be a simple array (e.g. an axis)

* written 8/18 (e.g. getting one value at a time from a feature-id variable in a DSG dataset.)

* argument definitions:
*	cdfid	 - netCDF id number for already opened CDF file
*       varid    - variable id in netCDF file
*       index    - subscript of array to return
*	dtype    - data type of variable
*       errstr   - identifying string to be printed with error messages
*       vname    - name of variable owning attribute (used in error msgs)
*       buff     - single character variable
*       status   - TMAP library return status

* argument declarations
      INTEGER cdfid, varid, index, dtype, slen, status
      CHARACTER*(*) errstr, buff

      include 'netcdf.inc'
      include 'tmap_errors.parm'

* internal variable declarations:
      INTEGER cdfstat, ndim, flen


      PARAMETER (flen=128)      ! size of string
      INTEGER*1 fhol(flen)
 
* read the string

      ndim = 1

      CALL CD_RD_STR_1_SUB (cdfid, varid, index, fhol, slen, cdfstat)

      IF ( cdfstat .NE. NF_NOERR ) CALL TM_ERRMSG
     .     ( cdfstat+pcdferr, status, 'CD_RD_R8_1', cdfid, varid,
     .       errstr, no_errstring, *5000 )

      CALL TM_CTOF_STRNG (fhol, buff, slen)


      status = merr_ok

 5000 RETURN

      END

      SUBROUTINE ALPHAS
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)alphas.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     CALL ALPHAS
C
C     IN CASE IT IS NECESSARY TO INPUT OR OUTPUT CHARACTER INFOR-
C     MATION WHILE IN THE PROCESS OF CREATING A DISPLAY, COMPLOT
C     MUST BE INFORMED.  A CALL TO THIS SUBROUTINE INDICATES THAT
C     ALPHANUMERIC INFORMATION IS TO FOLLOW.  ON THE HP PLOTTER,
C     ALPHAS TERMINATES THE CURRENT PLOT AND SENDS FURTHER OUTPUT
C     TO THE TERMINAL.  ALPHAS HAS NO EFFECT ON THE ZETA AND GER-
C     BER PLOTTERS.
C
C
#ifdef unix
	include 'PLTCOM.DAT'
#else
	include 'pplinc:PLTCOM.DAT'
#endif
C
C     SET THE PLOTTING MODE.
C
      PMODE = ALPHA
C
C     IF THE LAST POINT WAS NOT PLOTTED BECAUSE THE PEN WAS UP,
C     PLOT THE POINT NOW.
C
      IF(SAVEF)CALL XYZPLT
C
C     CHECK THE PLOT TYPE.
C
      IF(PTYPE .EQ. 0.OR.PTYPE.EQ.-1.OR.PTYPE.GT.2)RETURN
C
C     CHECK THE TEKTERMINAL TYPE.
C
      IF(TTYPE .EQ. -4662 .OR. TTYPE .EQ. -4663)GO TO 10
C
C     SELECT ALPHANUMERIC MODE ON THE TEKTERMINAL.
C
      CALL CHOUT(US,1)
      GO TO 30
C
C     CHECK THE GRAPHICS FLAG.
C
   10 IF(GRAPHF)THEN
C
C     SELECT ALPHANUMERIC MODE ON THE TEKTRONIX PLOTTER.
C
        CALL CHOUT(US,1)
C
C     TRANSMIT THE "PLOTTER OFF" COMMAND TO THE TEKTRONIX PLOTTER.
C
        CALL CHOUT(TEKOFF,5)
      ENDIF
C
C     WRITE OUT THE CHARACTER BUFFER.
C
   30 CALL CHDMP
C
C     RESET THE GRAPHICS FLAG.
C
      GRAPHF = .FALSE.
      RETURN
C
      END

*
* lon_lat_time_string.F
*
*
*  In this subroutine we provide information about
*  the function.  The user configurable information
*  consists of the following:
*
*  descr              Text description of the function
*
*  num_args           Required number of arguments
*
*  axis_inheritance   Type of axis for the result
*                        ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                        CUSTOM          - user defined axis
*                        IMPLIED_BY_ARGS - same axis as the incoming argument
*                        NORMAL          - the result is normal to this axis
*                        ABSTRACT        - an axis which only has index values
*
*  piecemeal_ok       For memory optimization:
*                        axes where calculation may be performed piecemeal
*                        ( YES, NO )
*
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result
*


      SUBROUTINE lon_lat_time_string_init(id)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .        'Generate names based on longitude,latitude,time,and a string')
      CALL ef_set_num_args(id, 5)
      CALL ef_set_axis_inheritance(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_result_type(id, STRING_RETURN)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'longitude')
      CALL ef_set_arg_desc(id, arg, 'Station longitude')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'latitude')
      CALL ef_set_arg_desc(id, arg, 'Station latitude')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'time')
      CALL ef_set_arg_desc(id, arg, 'numeric times')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'time_axis')
      CALL ef_set_arg_desc(id, arg, 
     .     'Varible with a time axis to use to convert time to time strings')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'string to prepend')
      CALL ef_set_arg_type (id, arg, STRING_ARG)
      CALL ef_set_arg_desc(id, arg, 'A label to start the names with')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE lon_lat_time_string_compute(id, arg_1, arg_2, arg_3, arg_4, 
     .          arg_5, result)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .           mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .           mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz,
     .           mem3lot:mem3hit)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz,
     .           mem4lot:mem4hit)
      REAL arg_5(1,mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz,
     .           mem5lot:mem5hit)

      REAL result(1,memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable's axes.

      INTEGER res_lo_ss(4),
     .        res_hi_ss(4),
     .        res_incr (4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS),
     .        arg_hi_ss(4,EF_MAX_ARGS),
     .        arg_incr (4,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      INTEGER TM_LENSTR
      INTEGER i,  j,  k,  l
      INTEGER i1, j1, k1, l1
      INTEGER slen,len1,len2,outlen,llen,prec,dlen

      CHARACTER*48  TM_FMT, datestring, lonstr, latstr, ilab
      CHARACTER*256 lab, outstring
      REAL ddate

*     'dd-MMM-yyyy' or 'yyyy-MM-dd' date format
      prec = 3

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      IF (arg_hi_ss(X_AXIS,ARG1) .GE. 1000)  
     .  CALL ef_bail_out(id,'Function for making lists size 999 or smaller')

      CALL ef_get_arg_string(id, ARG5, lab)
      slen = TM_LENSTR(lab)

      l1 = arg_lo_ss(T_AXIS,ARG1)
        DO 400 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         k1 = arg_lo_ss(Z_AXIS,ARG1)
         DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

          j1 = arg_lo_ss(Y_AXIS,ARG1)
          DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

           i1 = arg_lo_ss(X_AXIS,ARG1)
           DO 100 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

            IF ( arg_1(i1,j1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .           arg_2(i1,j1,k1,l1) .EQ. bad_flag(ARG2) .OR.
     .           arg_3(i1,j1,k1,l1) .EQ. bad_flag(ARG3) ) THEN

C     Get the string value of dates and put them in the result.

               outstring = '***'
	       CALL EF_PUT_STRING (outstring, 3, result(1,i,j,k,l))

            ELSE

	       lonstr = TM_FMT(arg_1(i1,j1,k1,l1), 4, 5, len1)
	       latstr = TM_FMT(arg_2(i1,j1,k1,l1), 4, 5, len2)
	          
               ddate = arg_3(i1,j1,k1,l1)
               CALL EF_GET_AXIS_DATES (id, ARG4, ddate, 1, prec, dlen, datestring)
               outstring = lab(:slen)//'_'//lonstr(:len1)//
     .           'E_'//latstr(:len2) //'N_'//datestring(:dlen)

	       outlen = TM_LENSTR(outstring)
	       CALL EF_PUT_STRING (outstring, outlen, result(1,i,j,k,l))

            ENDIF

            i1 = i1 + arg_incr(X_AXIS,ARG1)
 100       CONTINUE

           j1 = j1 + arg_incr(Y_AXIS,ARG1)
 200      CONTINUE

          k1 = k1 + arg_incr(Z_AXIS,ARG1)
 300     CONTINUE

         l1 = l1 + arg_incr(T_AXIS,ARG1)
 400    CONTINUE


      RETURN

 999  CALL EF_BAIL_OUT(id, 'Argument 2 is not a numeric string')

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END

	SUBROUTINE SHOW_DATA(dset, status) 
	
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* 4/2012 *acm*
* taken out of xeq_show.F, execute SHOW DATA
* v675  *acm  4/12 Fix ticket 1934, simpler SHOW ATTRIBUTE syntax.
* V6.8  acm  6/12 Implement mode_6d_lab, set by default. If canceled, the 
*                 various SHOW commnands will not list info for E,F dimensions.
* V685 4/13 *acm* Ability to define ensemble with /HIDDEN
* V691+ 8/14 *acm* Fix ticket 2194: SHOW with /OUTFILE
* V695 *acm*  2/15 For Forecast aggregations, call the ds_type 'FCT'
* V695 *acm*  9/15 Fix #2317: length of name sent to FIND_DSET_NUMBER
* V698 *sh* 1/16 Removed "Ferret-defined" annotation
* V7   *acm*  6/12 Add Union aggregations: DEFINE DATA/AGG/U, ds_type 'UNI'

	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'ferret.parm'
	include	'slash.parm'
	include 'errmsg.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xcontext.cmn'
	include 'xinterrupt.cmn'
	include 'xprog_state.cmn'
	include 'xrisc.cmn' 

	INTEGER dset, status

	LOGICAL TM_HAS_STRING, 
     .          sbrief, sfull, svars, sfile, sattr, sxml, clobber, 
     .          append, only_1, un_hide
	INTEGER TM_LENSTR1, TM_LENSTR, FIND_DSET_NUMBER, 
     .		    sho_file, iset, len, len0,
     .		    slash_brief,
     .		    slash_full,
     .		    slash_vars,
     .		    slash_file,
     .		    slash_attr,
     .		    slash_xml,
     .		    slash_memb
	CHARACTER default*60, outstring*2048

	PARAMETER ( slash_brief    = 1 + 1,
     .		    slash_full     = 1 + 2,
     .		    slash_vars     = 1 + 3,
     .		    slash_file     = 1 + 4,
     .		    slash_attr     = 1 + 6,
     .		    slash_xml      = 1 + 5,
     .              slash_memb     = 1 + 11 )

* initialize
	show_lun = ttout_lun
	sxml = .FALSE.
	status = ferr_ok

   	sbrief = qual_given( slash_brief ) .GT. 0 
	sfull  = qual_given( slash_full  ) .GT. 0
	svars  = qual_given( slash_vars  ) .GT. 0   .OR. sfull
 	sfile  = qual_given( slash_memb  ) .GT. 0
     .	    .OR. qual_given( slash_file  ) .GT. 0   .OR. sfull
 	sattr  = qual_given( slash_attr  ) .GT. 0  
        IF (sattr) sbrief = .TRUE.
 	sxml  = qual_given( slash_xml  ) .GT. 0 

	IF (qual_given( slash_file  ) .GT. 0)  CALL WARN
     .		( '/FILES is deprecated.  Use /MEMBERS')

* 	SHOW DATA/FILE=[/APPEND][/CLOBBER][/HIDDEN]
        sho_file = qual_given( slash_show_data_file )
	clobber = qual_given( slash_show_data_clobber ) .GT. 0
	append = qual_given( slash_show_data_append ) .GT. 0

* SHOW DATA/HIDDEN  if ensembles are defined with /HIDE, then
*             SHOW DAT/HIDDEN will show the member datasets.

	un_hide = qual_given( slash_show_data_hidden ) .GT. 0

	IF (sho_file .GT. 0) THEN
	   CALL OPEN_SHOW_FILE (show_lun, sho_file,  
     .                          clobber, append, status)
	   IF (status .NE. ferr_ok ) GOTO 5000
	ENDIF

	only_1 = num_args .GT. 0
	IF ( only_1 ) THEN
	   dset = FIND_DSET_NUMBER( cmnd_buff(arg_start(1):arg_end(1)) )
	   IF ( dset .EQ. unspecified_int4 ) GOTO 5000
	   un_hide = .TRUE.
	ENDIF

        IF (.NOT. sxml) THEN
           WRITE ( risc_buff, 3700 )	! heading line
           CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
        ELSE
           risc_buff = '<datasets>'
           CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
        ENDIF

	risc_buff = ' '

	DO 790 iset = 1, maxdsets
	   IF ( interrupted ) CALL ERRMSG
     .			( ferr_interrupt, status, ' ', *5000 )

	   IF ( ds_name(iset) .EQ. char_init1024
     .	   .OR. (only_1 .AND. iset .NE. dset) ) GOTO 790

           IF ( ds_hide(iset) .AND. .NOT.un_hide) GOTO 790
           dset = iset

* ... is it the default data set?
	   IF ( iset .EQ. cx_data_set(cx_last) ) THEN
	      default = '(default)'
	      len0 = 9
	   ELSE
	      default = ' '
	      len0 = 1
	   ENDIF
	   IF (dset.NE.unspecified_int4 .AND. dset.NE.pdset_irrelevant) THEN
	   IF ( TM_HAS_STRING(ds_type(iset), 'ENS') ) THEN
	      default = default(:len0)//'  Ensemble aggregation'
	      len0 = TM_LENSTR1( default )
	   ENDIF
	   IF ( TM_HAS_STRING(ds_type(iset), 'FCT') ) THEN
	      default = default(:len0)//'  Forecast aggregation'
	      len0 = TM_LENSTR1( default )
	   ENDIF
	   IF ( TM_HAS_STRING(ds_type(iset), 'UNI') ) THEN
	      default = default(:len0)//'  Union aggregation'
	      len0 = TM_LENSTR1( default )
	   ENDIF
	   ENDIF

	   len = TM_LENSTR1( ds_des_name( iset ) )
           IF (sxml) THEN

* Write data set name
              IF (len0 .EQ. 1) THEN
                 CALL ESCAPE_FOR_XML (ds_des_name(iset), outstring, len)
                 WRITE (risc_buff,3711) outstring(:len)
	      ENDIF
              IF (len0 .EQ. 9) THEN
                 CALL ESCAPE_FOR_XML (ds_des_name(iset), outstring, len)
                 WRITE (risc_buff,3712) outstring(:len)
              ENDIF
	      CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
* Write data set title
              CALL ESCAPE_FOR_XML (ds_title(iset), outstring, len)
	      WRITE ( risc_buff, 2020 ) outstring(1:len)
	      CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)

	      len = TM_LENSTR(ds_mod_title(iset))
	      IF (len .GT. 0) THEN
                 CALL ESCAPE_FOR_XML (ds_mod_title(iset), outstring, len)
	         WRITE ( risc_buff, 2030 ) outstring(1:len)
	         CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
              ENDIF

           ELSE
	      WRITE (risc_buff,3710) iset,ds_des_name(iset)(:len),default(:len0)
	      CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
           ENDIF

	   risc_buff = ' '
* ... by default only name and variables are shown
           IF ( sxml) THEN
              IF (svars) THEN
                 CALL SHOW_DATA_SET_VARS_XML (show_lun, iset)
              ELSE
                 CALL SHOW_DATA_SET_XML (show_lun, iset)
              ENDIF
           ELSE
	      IF ( svars       ) CALL SHOW_DATA_SET_PARAMS 
     .                             (show_lun, iset)
	      IF ( .NOT.sbrief ) CALL SHOW_DATA_SET_VARS
     .                             (show_lun, iset, svars, status)
	      IF ( sfile       ) CALL SHOW_DATA_FILES      
     .                             (show_lun, iset)
	      IF ( sattr       ) CALL SHOW_DATA_SET_ATTRS      
     .                             (show_lun, iset)
           ENDIF
           IF (sxml .AND. (.NOT.svars)) THEN
              risc_buff = '</dataset>'
              CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
           ENDIF
	   IF (status .NE. ferr_ok) GOTO 5000
 790	CONTINUE

        IF (sxml .AND. (.NOT.svars)) THEN
           risc_buff = '</datasets>'
           CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
        ENDIF

	IF (sho_file .GT. 0) CLOSE (UNIT = show_lun)


 2020   FORMAT( '<title>', A, '</title>' )
 2030   FORMAT( '<title_mod>', A, '</title_mod>' )
 3700	FORMAT (T6,'currently SET data sets:')
 3710	FORMAT (T2,I4,'> ',A,2X,A)
 3711	FORMAT ('<dataset name="',A,'" default="false">')
 3712	FORMAT ('<dataset name="',A,'" default="true">')

 5000	RETURN
        END

	SUBROUTINE CD_NCOPEN ( urlstring, dset, status )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Just do an nc_close on the ncid for the dataset. We're going to 
* re-open it with F-TDS variable definitions, so leave all the
* dataset initialization information in place.
*
* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Thermal Modeling and Analysis Program
* 2/2013  Ferret v6.85
*
* arguments:
*	dset	- data set number 

        include 'netcdf.inc'
        include 'tmap_errors.parm'
	include 'tmap_dims.parm'
	include 'xstep_files.cmn_text'
	external xstep_files_data

* Argument variable declarations
	INTEGER   dset, status
	CHARACTER*(*) urlstring

* Local variable declarations
	INTEGER cdfid
	CHARACTER*500 errbuff


#ifdef usingDODSf2cUnderscore 
	status = NF_OPEN_(urlstring, NF_NOWRITE, cdfid) 
#else
	status = NF_OPEN(urlstring, NF_NOWRITE, cdfid) 
#endif
	
	IF ( status .NE. NF_NOERR ) GOTO 5100
	sf_lunit(dset) = cdfid

* successful completion
        status = merr_ok
 5000	RETURN

* error messages
 5100   CONTINUE

        errbuff = 
     .    'Unable to open URL with REMOTE variable definitions: '

        CALL TM_ERRMSG
     .     ( merr_nc_open, status, 'CD_NCOPEN', dset,
     .        no_stepfile, errbuff, no_errstring, *5000 )


	END

	SUBROUTINE DEFINE_T_AGG_MC_DSET
     .		(dset_name, dset_path, dset_title, nagfiles,
     .		 memb_filename,
     .		 memb_tstep_start, memb_tstep_end, memb_nstep,
     .		 t_regular, use_strict, dset_num, status)

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Define and initialize a MC (T-aggregated netCDF) dataset from a list
* of member filenames and metadata about the times they contain
* Since this code is derived from the old MC descriptor file logic, its
* internals simulate the reading of a descriptor file
* The first netCDF file in the list will be opened and inspected
* in the process of creating the aggregation.

* V695+ *sh* 10/15 new routine -- built as hack on tm_init_dset.F
* V698 *sh* 1/16  pass explicit path name (for "USE file.agg" compatibility)
*                 date-sort the file list in BUILD_T_AGG_AXIS

* arguments:

*	dset_name	- dataset name to assign to the aggregation (input)
*	dset_path	- dataset path to assign to the aggregation (input)
*	dset_title	- dataset title (input)
*	nagfiles	- number of files in the aggregation (input)
*	memb_filename	- array of filenames (input)
*	memb_tstep_start- array of first timestep in each file (input)
*	memb_tstep_end	- array of last  timestep in each file (input)
*	memb_nstep	- array of N timesteps in each file (input)
*			  (unspecified_int4 signals no metadata provided)
*	t_regular	- flag to signal promise of regular timesteps (input)
*	use_strict	- flag to allow micro-adjustments of T axis (input)
*	dset_num	- number assigned to this data set (output)
*	status		- return status (output)
*

* Argument definitions
	LOGICAL		t_regular, use_strict
	INTEGER		nagfiles, dset_num, status
	INTEGER		memb_nstep(nagfiles), member_order(nagfiles)
	REAL*8		memb_tstep_start(nagfiles), memb_tstep_end(nagfiles)
	CHARACTER*(*)	dset_name, dset_path, dset_title
	CHARACTER*512	memb_filename(nagfiles)

* Parameter and common files
        include 'ferret.parm'
        include 'errmsg.parm'
        include 'tmap_errors.parm'              ! error codes
#include "tmap_dset.parm"
        include 'tmap_dims.parm'                ! data set dimensions
	include 'xtm_grid.cmn_text'
	include 'xio.cmn_text'
        external xio_data
        include 'xdset_info.cmn_text'   ! data set common
        external xdset_info_data
        include 'xsys_names.cmn_text'
        external xsys_names_data
        include 'xdiag_ctrl.cmn_text'
        external xdiag_ctrl_data
        include 'xrisc_buff.cmn'

* Internal declarations
	LOGICAL	match
	INTEGER	TM_LENSTR1, tmap_status
	INTEGER	dlen, slen, iset, idim
	INTEGER	perm(nferdims), memb_order(nagfiles)
	CHARACTER LEFINT*16, buff*16

* local parameter definitions
	LOGICAL dont_re_use_existing
	PARAMETER (dont_re_use_existing = .FALSE.)

* initialize
	dlen = TM_LENSTR1( dset_name )
	DO idim = 1, nferdims
 	   perm(idim) = unspecified_int4 ! dummy USE/ORDER= qualifier
	ENDDO

* check to see if the aggregation name is already in use
	DO iset = 1, maxdsets
           match = ds_name(iset) .EQ. dset_name
           IF ( match ) GOTO 5100
!           match = ds_name(iset) .EQ. memb_filename(1)
!           IF ( match ) GOTO 5200
  	ENDDO

* initialize the first file in the aggregation
* ... it will serve as a pattern of the time-dependent variables that will
*     be presumed to exist in all opther files of the aggregation
!!!! ToDo:  add "ptax_share_no" argument to avoid sharing of time axis
	CALL TM_INIT_DSET(memb_filename(1), dont_re_use_existing,
     .			  perm, dset_num,t_regular, use_strict, tmap_status)

	IF (tmap_status.NE.merr_ok) GOTO 5010
	CALL CD_NCCLOSE ( dset_num, status)
	IF ( status .NE. merr_ok ) GOTO 5010

* build the aggregated time axis -- either from matedata the caller provided
* (from python) or by reading the coord from the netCDF files
	CALL BUILD_T_AGG_AXIS (dset_num, nagfiles, memb_order, memb_filename,
     .			memb_tstep_start, memb_tstep_end,
     .			memb_nstep, t_regular, use_strict, status)
	IF (status .NE. ferr_ok) GOTO 9900

* use individual file metadata to simulate an MC descriptor ("Multifile Cdf")
	CALL INIT_T_AGG_MC_DSET(dset_num, nagfiles, memb_order, memb_filename,
     .		 memb_tstep_start, memb_tstep_end, memb_nstep,
     .		 use_strict, status)
	IF (status .NE. merr_ok) GOTO 9900

* change the dataset metadata to make this into an aggregation
	ds_type(dset_num) = '  MC'
	ds_name(dset_num) = dset_name
	ds_des_name(dset_num) = dset_path 
	IF (dset_title .NE. char_init) ds_title(dset_num) = dset_title
	buff = LEFINT(nagfiles, slen)
	ds_mod_title(dset_num)      = 'T-aggregation of '
     .				// buff(:slen)//' netCDF files'
	ds_regsteps(dset_num) = line_regular(ds_time_axis(dset_num))

! stuff done in MC descriptors.  Needed here ??
!	CALL TM_MAKE_4D_GRIDS(dset_num,status)
!* ?? need to do this for remote mc aggregations ??
!	CALL TM_DSET_USE_GRIDS( dset_num )

* success
	RETURN

* errors
 5010	CALL ERRMSG( ferr_TMAP_error, status, ' ', *5000 )

 5100   CALL ERRMSG( ferr_invalid_command,status,
     .		'given aggregation dataset name already in use: '
     .		//dset_name(:dlen), *5000 )
      
! 5200	CALL ERRMSG( ferr_invalid_command,status,
!     .		'the first file to be aggregated is already USEed: '
!     .		//memb_filename(1), *5000 )

* get out from error
 9900	CALL TM_PURGE_TMP_GRIDS(TMAP_status)
	CALL TM_CLOSE_SET ( dset_num, TMAP_status )
 9950	dset_num = unspecified_int4
 5000	RETURN
	END

      SUBROUTINE SHELL(SDAT, IDAT,N)


*from http://www.cs.mcgill.ca/~ratzer/progs15_6.html  23-APR-1998
* Changed data to REAL. Added IDAT, to sort along with SDAT.  
* Removed NCOUNTS, NCOMP, NSWAP.

      REAL     SDAT(*)
      INTEGER  IDAT(*), N, M
      INTEGER  I, J
      M=N
      DO WHILE (M .gt. 1)
         M=(M+2)/3
         DO I=M+1,N
            DO J=I,M+1,-M
               IF(SDAT(J-M) .ge. SDAT(J)) then
                 CALL SWAPR(SDAT,J,J-M)
                 CALL SWAPI(IDAT,J,J-M)
               endif
            END DO 
         END DO 
      END DO
      RETURN
      END !SUBROUTINE SHELL
!

      SUBROUTINE SWAPI(IDAT,K,L)
      INTEGER IDAT(*),K,L
      INTEGER M
      M=IDAT(K)
      IDAT(K)=IDAT(L)
      IDAT(L)=M
      RETURN
      END !SUROUTINE SWAPI

      SUBROUTINE SWAPR(SDAT,K,L)
      REAL SDAT(*), S
      INTEGER K,L
      S=SDAT(K)
      SDAT(K)=SDAT(L)
      SDAT(L)=S
      RETURN
      END !SUROUTINE SWAP

	SUBROUTINE EZ_INIT_DSET (filename,ezform,variables,types,
     .				 delims,skip,columns,dset,status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Subroutine takes arguments from call and turns it into an entry in the dataset
* and stepfile subroutines. This will allow access to ASCII and unformatted non-
* TMAP data files. This sets up a bare bones entry. All other initialization
* occurs with EZ_MOD_DSET and EZ_READ.
*
* revision 0.00 - 08/03/89
* revision 1.00 - 08/11/89 - Removed calculations involving items that are not
*			     included on SET DATA command to EZ_READ command.
* revision 1.10 - 10/27/89 - *sh* added columns
* revision 1.11 - 01/25/90 - *sh* changed the default format to "FREE"
* Unix/RISC port 3/11/91 *sh*: filename parsing changed (and longer names)
* note: also changed VMS version to save filename extension as well as name
*       (to differentiate snoopy.lis from snoopy.dat)
* rev 1.2 *sh* 7/92 - check for valid, non-duplicated variable names
* rev 1.3 *sh* 11/92 - allow 24 character variable names
* 3/12/93(4?) - lifted restriction on max number of columns
* 12/94 - lifted restriction that # columns must be multiple of # variables
*	  to accomodate /FORMAT=STREAM
* *sh* 3/2/95 - informative messages issued through TM_NOTE (for GUI)
* 10/96 *kob* - Linux port - had to move variable assignments off of
*		declaration line.
* V530 10/00 *sh* - added delimited reads
* V540 10/01 *sh* - auto-analysis of delimited files to tag MISSING fields
*		    as FLOAT -- makes the file more intelligible to the user
*		  - auto-analysis sets units and titles
*	          - bug fix: if vars_gvn that determines analyzed num_types
*      *acm* 10/01 increase length of ds_name
*      *acm* 10/01  remove VMS include statements
* 1/03 *kob* - g77 port - g77 won't allow intrinsic functions in PARAMETER
*                         statements.  use an character constant instead
* V552 5/03 *acm*: increase size of var_name to 128 chars
* V602  2/07 *acm* Fix bug 1492, changing attributes of coordinate variables 
* v604 *acm* 7/07 increase length of ds_name, ds_des_name
* V608 *acm* 10/07 Fixes for memory leak; when initializing dataset this
*                  routine was putting vars from other datasets into the
*                  linked-list structure.
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 2/10- all warnings and notes to std error not std out

* *kob* explicit definitions not allowed on decl line in linux...
*       moved it to parameter line 10/96
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing
* V694 1/15 *acm* variable coordvar should be a logical not an integer
* V701 7/16 *acm* ticket 2450. add date-time and euro-date-time field types
* V701  7/16 *kms* Compare ds_name to char_init2048 instead of char_init1024
* V701  7/16 *acm* Ticket 2454. If the user gives lower-case names when opening
*                  an EZ dataset, keep those names on output, etc.
* V72   6/17 *acm* Ticket 2540, inconsistencies in skipping over variables defined
*                  in a Delimited-file read as name and type "-".

	CHARACTER*4	ez_rev
	CHARACTER*1	tab
	PARAMETER 	(ez_rev = '1.11')
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
#else
	PARAMETER     ( tab = CHAR(9))
#endif

*
* Arguments:
*	filename	- name of data file
*	variables	- names of variables (and "-" for skipped variables)
*	columns		- number of columns to read (or int4_init)
*	dset		- (output) data set number
*	status		- (output)
*
	CHARACTER*(*)	filename, ezform, variables, types, delims
	INTEGER*4	skip, columns, dset, status
*
* Include files
	include 'xio.cmn_text'
        external xio_data
	include 'ez_lib.parm'
	include 'tmap_dims.parm'
	include 'tmap_dtypes.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'tmap_errors.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
        include 'xdset_info.cd_equiv'
	include 'xstep_files.cmn_text'
        external xstep_files_data
        include 'xez_info.cmn_text'
	external xez_info_data
        include 'netcdf.inc'

*
* Local definitions
        LOGICAL         TM_LEGAL_NAME, vars_gvn, its_delimited, coordvar
	CHARACTER*24	type_names(maxezvars)
	CHARACTER*128	var_names(maxezvars)
	INTEGER*4	TM_LENSTR1, STR_SAME, STR_CASE_BLIND_COMPARE,
     .			set_cnt, bpos, epos, ncnt, var_pos, num_names,
     .			nvar, jcnt, stp_cnt, nstp, field_type(maxezvars),
     .			num_types, i, j, name_limit, idummy(maxezvars),
     .			l1, l2, ivar, vartype, varid, tlen
	CHARACTER	TM_STRING*13, TM_LEFINT*4, buff*48, 
     .			line_buff*2048

*
* Assign data set number, exiting if maximum number of data sets are open
	DO 100 set_cnt = 1,maxdsets
	  IF (ds_name(set_cnt) .EQ. char_init2048) THEN
	    dset = set_cnt
	    ds_des_name(dset) = filename
* Parse input line to obtain just filename without directory or extension
            epos = LEN(filename)
#ifdef unix
* Unix: find final pathname slash
            DO 77 bpos = epos, 1, -1
 77         IF ( filename(bpos:bpos) .EQ. PathSeparator ) GOTO 78
            bpos = 0    ! no slash
 78         bpos = bpos + 1
#else
* VMS: find the "]" separating the directory from the filename
	    bpos = INDEX(filename,']') + 1
! changed 3/11/91	    epos = bpos + INDEX(filename(bpos:),'.') - 2
#endif
	    ds_name(dset) = filename(bpos:epos)
	    GOTO 110
	  ENDIF
  100	CONTINUE
* Too many data sets are open
	GOTO 9000
*
* Load Format record
  110   ds_type(dset)		= '  EZ'
	ds_format(dset)		= '  1A'
	ds_source_class(dset)	= ' '
	ds_source(dset)		= ' '
	ds_subsource(dset)	= ' '
	ds_prog_rev(dset)	= ez_rev
*
* Load Background record
	WRITE (ds_expnum(dset),'(A2,I2.2)') 'EZ',dset
	ds_modnum(dset)		= ' '
	ds_title(dset)		= ' '
	ds_mod_title(dset)	= ' '
	ds_forcing_set(dset)	= ' '
	ds_t0time(dset)		= ' '
	ds_ntegrate_tstep(dset)	= 1
	ds_time_run(dset)	= ' '
	DO 120 ncnt = 1,num_aux
  120	ds_aux_modnum(ncnt,dset)= ' '
	ds_parm_name(1,dset)	= 'FORMAT'
	ds_parm_text(1,dset)	= 'FREE'
	DO 130 ncnt = 2,num_parm
	  ds_parm_name(ncnt,dset)	= ' '
	  ds_parm_text(ncnt,dset)	= ' '
  130	CONTINUE
*
* time axis
	ds_time_axis(dset) = unspecified_int4
*
* Load message record
	ds_alert_on_open(dset) 	= .FALSE.
	ds_alert_on_output(dset)= .FALSE.
	ds_message(dset)	= ' '

* much needed flag for delimited files
	its_delimited = ezform(1:4) .EQ. 'DELI'
	IF (its_delimited) THEN
	   name_limit = maxezvars
	ELSE
	   name_limit = maxezfreefmtvars
	ENDIF
*
* parse the supplied list of variable names
	num_names = int4_init
	vars_gvn = variables .NE. ' '
	IF (vars_gvn) THEN
	  CALL TM_Parse_string(variables,maxezvars,var_names,num_names)
	  IF (num_names .GT. name_limit) THEN
	    buff = ' '
	    WRITE (buff,1000) num_names
	    CALL WARN( buff ) 
	    buff = ' '
	    WRITE (buff,1002) name_limit
	    CALL WARN( buff ) 
 1000	    FORMAT( 'attempt to initalize',I3,' variables')
 1002	    FORMAT( 'maximum allowed is',I3,' variables')
	    num_names = name_limit
	  ENDIF
*         ... check for illegal and duplicate names (*sh* 7/92)
          DO 510 ncnt = 1,num_names
            IF ( var_names(ncnt) .EQ. '-' ) GOTO 510
            IF ( .NOT.TM_LEGAL_NAME(var_names(ncnt)) ) GOTO 9400
            DO 500 jcnt = 1, ncnt-1
              IF ( var_names(jcnt) .EQ. '-' ) GOTO 500
              IF ( var_names(jcnt) .EQ. var_names(ncnt) ) GOTO 9400
 500        CONTINUE
 510      CONTINUE
	ENDIF

* information needed for delimited file reads: nfields, types
	IF (its_delimited) THEN
	   IF (types  .NE. ' ') THEN
*          ... parse users list of field types
	     CALL TM_Parse_string(types,maxezvars,type_names,num_types)
	     DO 530 i = 1, num_types
	       tlen = MIN(TM_LENSTR1(type_names(i)), 4)
	       DO 520 j = 1, FTYP_NUM_TYPES
	         IF (type_names(i)(1:tlen) .EQ. ftyp_name(j)(1:tlen)) THEN
	            l1 = TM_LENSTR1(type_names(i))
	            l2 = TM_LENSTR1(ftyp_name (j))
	            IF (l1.GT.l2 ) GOTO 9300  ! ilegal type name
	            IF (type_names(i)(:l1) .NE. ftyp_name(j)(:l1)) GOTO 9300
	            field_type(i) = j
	            GOTO 530
	         ENDIF	       
 520	       CONTINUE
*              ... name not recognized
	       GOTO 9300
 530	     CONTINUE
*            ... if only a single type was given use that type for all vars
	     IF (num_types .EQ. 1) THEN
	       IF (vars_gvn) THEN
	         DO 535 i = 2, num_names
 535	         field_type(i) = field_type(1)
	         num_types = num_names
	       ELSE
*                ... analyze file for just to get number of fields
*	         ... pass null terminated file name string in line_buff
	         CALL TM_FTOC_STRNG( ds_des_name(dset)
     .		     (:TM_LENSTR1(ds_des_name(dset))), line_buff, 2048 )
	         CALL ANAL_FILE(line_buff, line_buff, delims, skip,
     .	                       2000, 2048, num_types, idummy,
     .			       maxezvars)
	         DO i = 2, num_types
	            field_type(i) = field_type(1)
	         ENDDO
	       ENDIF
	     ENDIF
	   ELSE
*            ... analyze file for list of field types
*	     ... pass null terminated file name string in line_buff
	     CALL TM_FTOC_STRNG( ds_des_name(dset)
     .		     (:TM_LENSTR1(ds_des_name(dset))), line_buff, 2048 )
	     CALL ANAL_FILE(line_buff, line_buff, delims, skip,
     .	                       2000, 2048, num_types, field_type,
     .			       maxezvars)
	     IF (vars_gvn) THEN
	       IF (num_names .GT. num_types) THEN
	         GOTO 9330
	       ELSE
	          num_types = num_names  ! use only fields requested by user
	       ENDIF
	     ENDIF
*	     ... reset missing fields to ANAL_MISSING as flag for later treatment
	     DO i = 1, num_types
	       IF (field_type(i) .EQ. FTYP_MISSING)
     .			field_type(i) = FTYP_ANAL_MISSING
	     ENDDO
	   ENDIF
	   IF (vars_gvn) THEN
	      DO 540 i = 1, num_names
 540	      IF (var_names(i).EQ.'-') field_type(i) = FTYP_MISSING
	      IF (num_names .GT. num_types) THEN
	        DO 545 i = num_types+1, num_names
 545		field_type(i) = FTYP_MISSING
	      ENDIF
	   ELSE
*             ... synthesize names for fields
	      num_names = num_types
	      DO 550 i = 1, num_names
	         IF (field_type(i) .EQ. FTYP_MISSING ) THEN
	           var_names(i) = '-'
	         ELSE
	           var_names(i) = 'V'//TM_LEFINT(i,j)
	         ENDIF
 550	      CONTINUE
	   ENDIF
	ELSE
*       ... not a delimited read
	   IF (.NOT.vars_gvn) THEN
*             ... synthesize name for the one variable
	      num_names = 1
	      var_names(1) = 'V1'
	   ENDIF
	   DO 560 i = 1, num_names
 560	   field_type(i) = int4_init
	ENDIF

* Loop through all variable names
	var_pos  = 1
	DO 170 ncnt = 1,num_names
*
* Find the next storage position
	  DO 140 nvar = var_pos,maxvars
	    IF (ds_var_setnum(nvar) .EQ. set_not_open) GOTO 150
  140     CONTINUE
* No room left for new variables
	  GOTO 9100

*
* Load variable record now
  150     var_pos = nvar
          CALL string_array_modify_upcase (ds_var_code_head,
     .                             nvar,
     .                             var_names(ncnt),
     .                             LEN(var_names(ncnt)) )
	  ds_var_title(nvar)	= var_names(ncnt)
	  ds_var_titl_mod(nvar)	= ' '
	  ds_var_units(nvar)	= ' '
	  ds_missing_flag(nvar)	= -1.E34
	  ds_bad_flag(nvar)	= -1.E34
	  DO 160 jcnt = 1,nferdims
  160	  ds_ordering(jcnt,nvar)     = jcnt
	  ds_precision(nvar)	= 'SINGLE'
	  ds_aux_set_num(nvar)	= 0
* Other calculated or derived data pertaining to variables
	  ds_ndataperrec(nvar)	= int4_init
	  ds_nrecpervar(nvar)	= int4_init
	  ds_nrecb4var(nvar)	= int4_init
	  ds_var_setnum(nvar)	= dset
	  ds_npospervar(nvar)	= 0
* Delimited read field information
	  IF (field_type(ncnt) .EQ. FTYP_CHARACTER) THEN
	    ds_var_type(nvar) = ptype_string
	  ELSE
	    ds_var_type(nvar) = ptype_float
	  ENDIF
	  IF (its_delimited) THEN
	    IF (field_type(ncnt) .EQ. FTYP_ANAL_MISSING) THEN
	       ds_var_titl_mod(nvar) = 'all values missing'
	       field_type(ncnt) = FTYP_NUMERIC
	    ELSEIF (field_type(ncnt) .EQ. FTYP_EURODATE
     .	       .OR. field_type(ncnt) .EQ. FTYP_DATE
     .	       .OR. field_type(ncnt) .EQ. FTYP_DATIME
     .	       .OR. field_type(ncnt) .EQ. FTYP_EDATIME) THEN
	       ds_var_titl_mod(nvar) = 'Julian days since 1-Jan-1900'
	       ds_var_units(nvar) = 'days'
	    ELSEIF (field_type(ncnt) .EQ. FTYP_TIME) THEN
	       ds_var_titl_mod(nvar) = 'Time of day'
	       ds_var_units(nvar) = 'hours'
	    ELSEIF (field_type(ncnt) .EQ. FTYP_LAT) THEN
	       ds_var_titl_mod(nvar) = 'Latitude'
	       ds_var_units(nvar) = 'degrees_north'
	    ELSEIF (field_type(ncnt) .EQ. FTYP_LON) THEN
	       ds_var_titl_mod(nvar) = 'Longitude'
	       ds_var_units(nvar) = 'degrees_east'
	    ENDIF
	  ENDIF

  170	CONTINUE
*
* Save number of variable names (including "-") in data set
	ds_basic_axes(1,dset)	= num_names

* other available storage for later data set mods ...
	ds_basic_axes(2,dset)	= int4_init
	ds_basic_axes(3,dset)	= int4_init
	ds_basic_axes(4,dset)	= int4_init
	ds_basic_axes(5,dset)	= int4_init
	ds_basic_axes(6,dset)	= int4_init

* store number of columns to read
	IF ( columns .EQ. int4_init ) THEN
	   ds_ntuple(dset) 	= num_names
	ELSE
!	   IF ( MOD(columns,num_names).NE.0 ) GOTO 9300    ! removed 12/94
	   ds_ntuple(dset) 	= columns
	ENDIF
*
* Find the next storage position for stepfiles in common
	DO 180 stp_cnt = 1,maxstepfiles
	  IF (sf_setnum(stp_cnt) .EQ. set_not_open) THEN
	    nstp = stp_cnt
	    GOTO 190
	  ENDIF
  180	CONTINUE
* No room left for new stepfiles
	GOTO 9200
*
* Load stepfile record
  190	sf_name(nstp)		= filename
	sf_setnum(nstp)		= dset
	sf_aux_set_num(nstp)	= 0
	sf_nrecperstep(nstp)	= 1
	sf_skip(nstp)		= 0
	sf_regvars(nstp)	= .TRUE.

*
* save special info for delimited read files - struct ptr into ds_file_info_ptr
	IF (its_delimited) THEN
	  CALL SAVE_DELIMITED_INFO( num_names, field_type, delims,
     .				    ds_file_info_ptr(dset)   )
	ENDIF


* Put the information into the linked-list strucure for the dataset
* and its variables. Use the original non-upcased version of the variable name.

        CALL CD_STORE_DSET (dset, status)
        coordvar = .FALSE.
        varid = 0

        DO 200 ivar = 1, maxvars
           IF (ds_var_setnum(ivar) .EQ. set_not_open) GOTO 210
           IF (ds_var_setnum(ivar) .EQ. dset .AND.
     .         STR_SAME(ds_var_code(ivar) , '-' ) .NE. 0) THEN

              varid = varid + 1
	      IF (ds_var_type(ivar) .EQ. ptype_float) THEN
	         vartype = NF_DOUBLE
	      ELSEIF  (ds_var_type(ivar) .EQ. ptype_string) THEN
	         vartype = NF_CHAR
	      ELSE
	         vartype = NF_DOUBLE
              ENDIF

	      line_buff = ds_var_code(ivar)
	      DO ncnt = 1, num_names
	         IF (STR_CASE_BLIND_COMPARE(ds_var_code(ivar), var_names(ncnt)) .EQ. 0) THEN
	            line_buff = var_names(ncnt)
		    EXIT ! from loop
		 ENDIF
	      ENDDO

	      CALL CD_ADD_VAR( dset, line_buff, varid, 
     .          ds_var_title(ivar), ds_var_units(ivar), vartype,
     .          coordvar, ds_bad_flag(ivar), status)
           ENDIF
  200   CONTINUE

* All done
  210   status = merr_ok
	GOTO 9999
*
* ERROR MESSAGES
 9000	CALL TM_ERRMSG ( merr_dsetlim, status, 'EZ_INIT_DSET',
     .			 no_descfile, no_stepfile,
     .			 'MAX='//TM_STRING(DBLE(maxdsets)),
     .			 no_errstring, *9950)

 9100	CALL TM_ERRMSG ( merr_varlim, status, 'EZ_INIT_DSET',
     .			 dset, no_stepfile,
     .			 'MAX='//TM_STRING(DBLE(maxvars)),
     .			 no_errstring, *9950)

 9200	CALL TM_ERRMSG ( merr_filim, status, 'EZ_INIT_DSET',
     .			 dset, no_stepfile,
     .			 'MAX='//TM_STRING(DBLE(maxstepfiles)),
     .			 no_errstring, *9950)

 9300	CALL TM_ERRMSG ( merr_syntax, status, 'EZ_INIT_DSET',
     .			 dset, no_stepfile,
     .			 'Unrecognized field type: '//type_names(i),
     .			 no_errstring, *9310)
 9310	line_buff = ftyp_name(1)
	jcnt = 1   ! string length of list of field types
	DO 9320 i = 2, FTYP_NUM_TYPES
	   line_buff(jcnt+1:) = ','//ftyp_name(i)
	   jcnt = jcnt + 1 + TM_LENSTR1(ftyp_name(i))
 9320	CONTINUE
	CALL WARN('Valid types are: '//line_buff(:jcnt))
	GOTO 9950

 9330	WRITE (line_buff,3100) num_names, num_types
 3100	FORMAT(I4,' var names but only',I3,' fields found in file scan')
	i = TM_LENSTR1(line_buff)
	CALL TM_ERRMSG ( merr_varlim, status, 'EZ_INIT_DSET',
     .			 dset, no_stepfile,
     .			 line_buff(:i),
     .			 no_errstring, *9950)

 9400	CALL TM_ERRMSG ( merr_syntax, status, 'EZ_INIT_DSET',
     .			 dset, no_stepfile,
     .			 'illegal or duplicate variable name '
     .                   //var_names(ncnt),
     .			 no_errstring, *9950)

 9950	dset = unspecified_int4

* get out
 9999	RETURN
	END

* 
*  earth_distance.F
* 
*  Ansley manke
*  9/2017
* 
*  Compute the running sum of distance along a path
*  using the law of cosines as in billy's earth_distance.jnl scriopt

      SUBROUTINE earth_distance_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

      CALL ef_set_desc(id, 'Return the delta-distance in Km along the path' )

      CALL ef_set_num_args(id, 2)
      CALL EF_SET_HAS_VARI_ARGS(id, NO)
      CALL EF_SET_AXIS_INHERITANCE_6D(id, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL EF_SET_PIECEMEAL_OK_6D(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'longitude')
      CALL EF_SET_ARG_DESC(id, arg,
     .          'List of longitudes in degrees East along the path')
      CALL EF_SET_AXIS_INFLUENCE_6D(id, arg, YES, YES, YES, YES, YES, YES)

      arg = 2
      CALL EF_SET_ARG_NAME(id, arg, 'latitude')
      CALL EF_SET_ARG_DESC(id, arg,
     .          'List of latitudes in degrees North along the path')
      CALL EF_SET_AXIS_INFLUENCE_6D(id, arg, YES, YES, YES, YES, YES, YES)


      RETURN 
      END

* 
*  Compute the result
* 
      SUBROUTINE earth_distance_compute(id, lons, lats, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL lons(mem1lox:mem1hix, mem1loy:mem1hiy,
     .	   mem1loz:mem1hiz, mem1lot:mem1hit,
     .	   mem1loe:mem1hie, mem1lof:mem1hif)
      REAL lats(mem2lox:mem2hix, mem2loy:mem2hiy,
     .     mem2loz:mem2hiz, mem2lot:mem2hit,
     .     mem2loe:mem2hie, mem2lof:mem2hif)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .     memresloz:memreshiz, memreslot:memreshit,
     .     memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(6), res_hi_ss(6), res_incr(6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS), arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr(6,EF_MAX_ARGS)


      INTEGER i,j,k,l,m,n
      REAL dlo, dhi, ed_pd, ed_rearth, ed_lat1, ed_lat2, ed_lon1, ed_lon2, 
     .	   ed_x1, ed_x2, ed_y1, ed_y2, ed_z1, ed_z2, ed_d1, ed_angle

      
      ed_pd = 4.*atan(1.)/180.
      ed_rearth = 6371.2 

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* pre-check that the lons array has no missing values
      DO 10 n = arg_lo_ss(F_AXIS,ARG1), arg_hi_ss(F_AXIS,ARG1)
      DO 10 m = arg_lo_ss(E_AXIS,ARG1), arg_hi_ss(E_AXIS,ARG1)
      DO 10 l = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)
      DO 10 k = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)
      DO 10 j = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)
      DO 10 i = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)
        IF (lons(i,j,k,l,m,n) .EQ. bad_flag(1)) CALL
     .             EF_BAIL_OUT(id, 'Missing value found in lats')
 10   CONTINUE

* pre-check that the lats array has no missing values
      DO 20 n = arg_lo_ss(F_AXIS,ARG2), arg_hi_ss(F_AXIS,ARG2)
      DO 20 m = arg_lo_ss(E_AXIS,ARG2), arg_hi_ss(E_AXIS,ARG2)
      DO 20 l = arg_lo_ss(T_AXIS,ARG2), arg_hi_ss(T_AXIS,ARG2)
      DO 20 k = arg_lo_ss(Z_AXIS,ARG2), arg_hi_ss(Z_AXIS,ARG2)
      DO 20 j = arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS,ARG2)
      DO 20 i = arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS,ARG2)
        IF (lats(i,j,k,l,m,n) .EQ. bad_flag(2)) CALL
     .             EF_BAIL_OUT(id, 'Missing value found in lats')
 20   CONTINUE

* Need to skip the i=1st data

      DO 200 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
      DO 200 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
      DO 200 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
      DO 200 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
      DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
        DO i = res_lo_ss(X_AXIS)+1, res_hi_ss(X_AXIS)  ! faking it, skip

              ed_lat1 = 90 - lats(i-1,j,k,l,m,n)
              ed_lat2 = 90 - lats(i,j,k,l,m,n)
              ed_lon1 = lons(i-1,j,k,l,m,n)
              ed_lon2 = lons(i,j,k,l,m,n)
	      
              ed_x1 = sin( ed_pd*ed_lat1 )* cos( ed_pd* ed_lon1 )
              ed_y1 = sin( ed_pd*ed_lat1 )* sin( ed_pd* ed_lon1 )
              ed_z1 = cos( ed_pd*ed_lat1 )
              ed_x2 = sin( ed_pd*ed_lat2 )* cos( ed_pd* ed_lon2 )
              ed_y2 = sin( ed_pd*ed_lat2 )* sin( ed_pd* ed_lon2 )
              ed_z2 = cos( ed_pd*ed_lat2 )

              ed_d1 = (ed_x1 - ed_x2)**2 + (ed_y1 - ed_y2)**2  +  (ed_z1 - ed_z2)**2
              ed_angle = acos(1 - ed_d1/2)		! angular distance between the points

              result(i,j,k,l,m,n) = ed_rearth* ed_angle
        ENDDO

 200  CONTINUE

      RETURN 
      END

      SUBROUTINE CD_SET_COMPRESS (cdfid, varid, deflate,chunks, shuffle,
     .                            endian_code, status)

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Set the netCDF compression for a variable

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - Thermal Modeling and Analysis Program
* Netcdf-4 with HDF chunking and compression
* revision 0.0 - 12/09
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing
* V698 2/16 *acm* for ticket 2363, don't call NF_DEF_VAR_FLETCHER32.

* argument definitions:
*   cdfid   - returned pointer to open CDF file
*   varid   - variable id
*   deflate - deflate level (level 1 is recommended)
*   chunks  - chunking corrresponding to each dimension (if all 0 then no set chunking)
*   shuffle - 0 or 1 to turn on shuffle in NF_DEF_VAR_DEFLATE
*   endian_code - native=0, little=1, big=0 Values match nf_endian_*
*   status  - return status

* argument declarations:
	INTEGER cdfid, varid, deflate, chunks(*), 
     .          shuffle, endian_code, status

* include files
        include 'netcdf.inc'
	include 'tmap_dims.parm'
        include 'cdf_tmap.parm'
        include 'tmap_errors.parm'

* Declare netcdf function names. 
* The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"


* local variable declarations:

      INTEGER cdfstat, idim, vlen
      INTEGER do_deflate, do_chunk, cdfformat, contiguous

      CHARACTER*1     ww_dim_nam(nferdims)
      DATA ww_dim_nam/'X', 'Y', 'Z', 'T', 'E', 'F'/

* Called from CD_MAKE_VAR. We are in define mode

      IF (deflate .GT. 0) do_deflate = 1

* Dataset needs to have been opened with netcdf4 mode, e.g.
* see cd_open_out NF_CREATE(cdfname, NF_NETCDF4, cdfid)
* Check this via a call to NF_INQ_FORMAT

#ifdef usingDODSf2cUnderscore 
           cdfstat = NF_INQ_FORMAT_(cdfid, cdfformat)
#else
           cdfstat = NF_INQ_FORMAT (cdfid, cdfformat) 
#endif

      IF (cdfformat .NE. NF_FORMAT_NETCDF4) GOTO 5200

* Has the user set chunking values?

      do_chunk = 0
      DO 100 idim = 1, nferdims
         do_chunk = MAX(do_chunk, chunks(idim) ) 
  100 CONTINUE

      contiguous = NF_CHUNKED
      IF (do_chunk .GT. 0) THEN
         cdfstat = NF_DEF_VAR_CHUNKING(cdfid, varid, contiguous, chunks)
         IF (cdfstat .NE. NF_NOERR) GOTO 5100
      ENDIF

* Set output endian-ness. (default is whatever is native to
* writing machine, NF_ENDIAN_NATIVE).
      cdfstat = NF_DEF_VAR_ENDIAN(cdfid, varid, endian_code)
      IF (cdfstat .NE. NF_NOERR) GOTO 5100

      cdfstat = NF_DEF_VAR_DEFLATE(cdfid, varid, shuffle, 
     .          deflate, do_deflate)
      IF (cdfstat .NE. NF_NOERR) GOTO 5100

* successful completion
      status = merr_ok
      RETURN

* error messages
 5100 CONTINUE
      CALL TM_ERRMSG
     .     ( status+pcdferr, status, 'CD_SET_COMPRESS', cdfid,
     .     no_varid, 'could not set compression', ' ', *5000 )

 5200 CONTINUE
      CALL TM_ERRMSG
     .     ( merr_syntax, status, 'CD_SET_COMPRESS', cdfid,no_varid, 
     .     'Cannot compress variable: dataset not netcdf4 format', 
     .     ' ', *5000 )

* error exit
 5000 RETURN
	END

      SUBROUTINE SMY1(X,XFACT,YFACT,Y,YHI,YTIC,NSMTCY,
     .       xacross,hgrat,hcolor,hline) 
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)smy1.f	1.1    3/10/88
* v554: *acm* 2/04 add /HGRAT /VGRAT to draw optional graticule lines at tic marks:
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C 
C     THIS SUBROUTINE PLOTS THE SMALL YTICS ON THE Y AXIS. 
C     THIS DIFERS FROM SMY IN THAT THE TICS ARE LARGER. 
C 

c arguments for making lines across the plot at tic marks.

        REAL xacross, dash1, dash2, dash3, dash4  ! for drawing the tic all the way across the plot
        REAL hgrat(4,2)        ! line type: 0=tics only, <0=line, >0=dash lengths 
        INTEGER hcolor(*)      ! pen number 
        LOGICAL hline          ! If true, do the lines across.
        LOGICAL solid          ! solid lines across at tics
        LOGICAL dashed         ! dashed lines across at tics

        solid = (hgrat(1,2).LT.0 .AND. hgrat(2,2).LT.0 .AND.  
     .            hgrat(3,2).LT.0 .AND.  hgrat(4,2).LT.0 )
        dashed = (hgrat(1,2).GT.0 .OR. hgrat(2,2).GT.0 .OR.  
     .            hgrat(3,2).GT.0 .OR.  hgrat(4,2).GT.0 )
        IF (dashed) THEN
           dash1 = hgrat(1,2)
           dash2 = hgrat(2,2)
           dash3 = hgrat(3,2)
           dash4 = hgrat(4,2)
        ENDIF

      IF(NSMTCY.LT.1) RETURN 
      SMTIC=YTIC/FLOAT(NSMTCY+1) 
      DO 10 I=1,NSMTCY 
          YTEMP=Y+FLOAT(I)*SMTIC 
          IF((YHI-YTEMP)/YTIC.GE.0) THEN
             CALL PLOTT7(X,YTEMP,XFACT, YFACT,1,-5) 
     
             IF ((solid.OR.dashed) .AND. hline) THEN ! make line across
                CALL COLOR(hcolor(2))
                IF (dashed) THEN
                   CALL DASHSZ(dash1,dash2,dash3,dash4)
                   CALL DASHES
                ENDIF
                CALL PLOT(X,ytemp,0,0) 
                CALL PLOT(xacross,ytemp,1,0)
                CALL PLOT(X,ytemp,0,0) 
                CALL COLOR(1)
                CALL VECTRS
             ENDIF
          ENDIF

   10     CONTINUE 
      RETURN 
C**  THIS PROGRAM VALID ON FTN4 AND FTN5 ** 
      END 

      SUBROUTINE STRING_OPERATE (operation, com_cx,
     .				 com1, mr1,
     .				 com2, mr2,
     .				 res, mres )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* perform a logical string operation

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V533 *sh* 7/01 - based upon OPERATE.F
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include 'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xcontext.cmn'

* calling argument declarations:
	INTEGER	operation, com_cx(4), mr1, mr2, mres, m, n
	REAL*8  com1( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .		com2( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,m2lot:m2hit,m2loe:m2hie,m2lof:m2hif )
        REAL    res( m5lox:m5hix,m5loy:m5hiy,m5loz:m5hiz,m5lot:m5hit,m5loe:m5hie,m5lof:m5hif )

* internal variable declarations:
	INTEGER CX_DIM_LEN, COMPARE_C_STRINGS,
     .          i, j, k, l, icom, idim, comp, op,
     .		i1, j1, k1, l1, m1, n1, i2, j2, k2, l2, m2, n2,
     .		di1, dj1, dk1, dl1, dm1, dn1, 
     .		di2, dj2, dk2, dl2, dm2, dn2,
     .		si1, sj1, sk1, sl1, sm1, sn1, 
     .		si2, sj2, sk2, sl2, sm2, sn2

* internal parameter declaration
        INTEGER num_com
        PARAMETER (num_com = 2)

* equivalence conveniences. Arrays are (idim, icom)
* "inc" is the increments for each axis of each component
* "lo"  is the starting subscript (minus 1) for each axis of each component
	INTEGER	inc(nferdims,4), lo(nferdims,4)
	EQUIVALENCE
     .	(lo(1,1),si1), (lo(2,1),sj1), (lo(3,1),sk1), (lo(4,1),sl1), (lo(5,1),sm1), (lo(6,1),sn1), 
     .	(lo(1,2),si2), (lo(2,2),sj2), (lo(3,2),sk2), (lo(4,2),sl2), (lo(5,2),sm2), (lo(6,2),sn2), 
     .	(inc(1,1),di1),(inc(2,1),dj1),(inc(3,1),dk1),(inc(4,1),dl1),(inc(5,1),dm1),(inc(6,1),dn1), 
     .  (inc(1,2),di2),(inc(2,2),dj2),(inc(3,2),dk2),(inc(4,2),dl2),(inc(5,2),dm2),(inc(6,2),dn2)

* compute the delta increment for each axis of) each component
	DO 2 icom = 1, num_com
	DO 2 idim = 1, nferdims
	   IF ( CX_DIM_LEN(idim,com_cx(icom)) .EQ. 1 ) THEN
	      inc(idim,icom) = 0
	   ELSE
	      inc(idim,icom) = 1
	   ENDIF
 2	CONTINUE

* compute the starting subscript for each axis of each component
* (pre-decrement by 1 delta for looping ahead)
	DO 4 icom = 1, num_com
	DO 4 idim = 1, nferdims
 4	lo(idim,icom) = cx_lo_ss(com_cx(icom),idim) - inc(idim,icom)

* operator number (8 thru 13 OK)
        op = operation - 7
        IF (op.LT.1 .OR. op.GT.6) STOP 'STR OP?'

	n1 = sn1
	n2 = sn2
	DO 200 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	  DO 200 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 200 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  k1 = sk1
	  k2 = sk2
	   DO 200 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   j1 = sj1
	   j2 = sj2
	    DO 200 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    i1 = si1
	    i2 = si2
	     DO 200 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2

             comp = COMPARE_C_STRINGS(com1(i1,j1,k1,l1,m1,n1),
     .                                com2(i2,j2,k2,l2,m2,n2) )

             GOTO (10,20,30,40,50,60) op

* op = 1 "GT"
 10          IF ( comp .GT. 0 ) THEN
		 res(i,j,k,l,m,n) = 1.0
	      ELSE
		 res(i,j,k,l,m,n) = 0.0
	      ENDIF
              GOTO 200

* op = 2 "GE"
 20          IF ( comp .GE. 0 ) THEN
		 res(i,j,k,l,m,n) = 1.0
	      ELSE
		 res(i,j,k,l,m,n) = 0.0
	      ENDIF
              GOTO 200

* op = 3 "LT"
 30          IF ( comp .LT. 0 ) THEN
		 res(i,j,k,l,m,n) = 1.0
	      ELSE
		 res(i,j,k,l,m,n) = 0.0
	      ENDIF
              GOTO 200

* op = 4 "LE"
 40          IF ( comp .LE. 0 ) THEN
		 res(i,j,k,l,m,n) = 1.0
	      ELSE
		 res(i,j,k,l,m,n) = 0.0
	      ENDIF
              GOTO 200

* op = 5 "EQ"
 50          IF ( comp .EQ. 0 ) THEN
		 res(i,j,k,l,m,n) = 1.0
	      ELSE
		 res(i,j,k,l,m,n) = 0.0
	      ENDIF
              GOTO 200

* op = 6 "NE"
 60          IF ( comp .NE. 0 ) THEN
		 res(i,j,k,l,m,n) = 1.0
	      ELSE
		 res(i,j,k,l,m,n) = 0.0
	      ENDIF

 200	CONTINUE

	RETURN
        END

	SUBROUTINE GET_WS_DYNMEM( i8_rqst_size, ws, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* allocate the requested amount of dynamic memory (using c or python malloc)
* malloc is done in c (or python), but has to call back into F90 to set pointer
* the hierarchy of calls is as follows
*   get_ws_dynmem.F ==> get_ws_mem.c ==> store_ws_ptr.F

* programmer - steve hankin
* V702 *sh*  1/17 trac enhancement ticket #2369 - dynamic memory
* v74   *acm* 3/18 Introduce parameter abstractax_len replacing 99999999

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'errmsg.parm'
	include	'ferret.parm'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'

* calling argument declarations:
	INTEGER	ws, status
	INTEGER*8 i8_rqst_size

* internal variable declarations:
	INTEGER	mr_del, num_slen
	CHARACTER  LEFINT8*20, num_str*20

* Check for unspecified limits on abstract axis
	IF ( i8_rqst_size .EQ. abstractax_len ) GOTO 5100

* allocate the dynamic memory
 200	CALL GET_WS_MEM(ws, i8_rqst_size, status)
        IF (status .NE. ferr_ok) GOTO 5300

* bookkeeping
        ws_size(ws) = i8_rqst_size
	RETURN

***********************
* error exits
 5000	RETURN
 5100	num_str = LEFINT8(i8_rqst_size,num_slen)
	CALL ERRMSG( ferr_dim_underspec, status,
     .    num_str(:num_slen)//' words were requested. ', *5110)
 5110	CALL WARN('Check for unspecified limits on an ABSTRACT axis')
	CALL WARN('Use the SHOW GRID command to see the axes')
	GOTO 5000

 5300	num_str = LEFINT8(i8_rqst_size,num_slen)
	CALL ERRMSG( ferr_insuff_memory,status,
     .	  num_str(:num_slen)//' words were requested. ', *5310)
 5310	CALL WARN('The system is refusing to supply this much memory')
        GOTO 5000

	END

*
*  ann_trend.f
*
* ansley manke
* oct 1998
*
* Remove annual variation and trend from  a 2-d field.  Uses Jimmy Larsen's 
* time series code.
*


*
* in this subroutine we provide information about
* the function.  the user configurable information 
* consists of the following:
*
* descr              text description of the function
*
* num_args           required number of arguments
*
* axis_inheritance   type of axis for the result
*                       ( custom, implied_by_args, normal, abstract )
*                       custom          - user defined axis
*                       implied_by_args - same axis as the incoming argument
*                       normal          - the result is normal to this axis
*                       abstract        - an axis which only has index values
*
* piecemeal_ok       for memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( yes, no )
* 
*
* for each argument we provide the following information:
*
* name               text name for an argument
*
* unit               text units for an argument
*
* desc               text description of an argument
*
* axis_influence     are this argument's axes the same as the result grid?
*                       ( yes, no )
*
* axis_extend       how much does ferret need to extend arg limits relative to result 
*


      SUBROUTINEann_trend_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

************************************************************************
*                                            user configurable portion |
*                                                                      |
*                                                                      v

      CALL ef_set_desc(id,
     .  'compute eofs and time functions for x-y field w/gaps' )

      CALL ef_set_num_args(id, 1)

      CALL ef_set_axis_inheritance(id, implied_by_args, 
     .      implied_by_args, implied_by_args, implied_by_args)

      CALL ef_set_piecemeal_ok(id, no, no, no, no)
 
      arg = 1
      CALL ef_set_arg_name(id, arg, 'a')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'variable in x,y,t')
      CALL ef_set_axis_influence(ID, ARG, YES, YES, YES, YES)

*                                                                      ^
*                                                                      |
*                                            user configurable portion |
************************************************************************

      RETURN 
      END



*
* in this subroutine we compute the result
*

      SUBROUTINE ann_trend_compute(id, arg_1, result)

*  arg_1  variable, function of (x,y,t)
*  result is the same variable with trend and annual variation removed

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id
      real bad_flag(ef_max_args), bad_flag_result
      real arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .     mem1lot:mem1hit)

      real result(memreslox:memreshix, memresloy:memreshiy, 
     .     memresloz:memreshiz, memreslot:memreshit)

* after initialization, the 'res_' arrays contain indexing information 
* for the result axes.  the 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,ef_max_args), arg_hi_ss(4,ef_max_args),
     .     arg_incr(4,ef_max_args)


      INTEGER nwrk, nt
      INTEGER i, j, k, l, i1, j1, k1, l1
      REAL t_inc
      PARAMETER (nwrk=1000)
      REAL r(nwrk), gap(nwrk), fq, ssttmp(nwrk)
      REAL w(50)
      INTEGER nf, nyr
      PARAMETER (nf=5, nyr=24)

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      t_inc = res_incr(t_axis)
      IF (t_inc .eq. 0) t_inc = 1

      nt = (res_hi_ss(t_axis) - res_lo_ss(t_axis) + 1)/ t_inc
      IF (nt .gt. nwrk) THEN
         PRINT *, ' ann_trend.F: set dimension for work arrays >=', nt
         GO TO 999
      ENDIF

      fq = 1.0 / (7200.0*24.*365.25/12.0)

      CALL prolate(w, nyr, 1)

      j1 = arg_lo_ss(Y_AXIS,ARG1)
      DO 500 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS), 
     .               res_incr(Y_AXIS)

         i1 = arg_lo_ss(X_AXIS, ARG1)
         DO 400 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS), 
     .               res_incr(X_AXIS)
 
            k1 = arg_lo_ss(Z_AXIS,ARG1)
            k = res_lo_ss(Z_AXIS)
            nt = 1

            l1 = arg_lo_ss(T_AXIS, ARG1)
            DO 100 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS), 
     .               res_incr(T_AXIS)

               ssttmp(nt) = arg_1(i1,j1,k1,l1) 
               IF (ssttmp(nt) .eq. bad_flag(ARG1)) THEN
                   ssttmp(nt) = bad_flag_result
               ELSE 
                   ssttmp(nt) = arg_1(i1,j1,k1,l1) 
               ENDIF

               nt = nt + 1

               l1 = l1 + arg_incr(T_AXIS,ARG1)
  100       CONTINUE

            nt = nt - 1
            CALL annualdai (fq, nt, ssttmp, r, gap, nf, 
     .             bad_flag_result)
            CALL trendflag2 (nt, ssttmp, bad_flag_result)
            CALL piw (ssttmp, r, w, nt, bad_flag_result)

            nt = 1
            DO 200 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
               result(i,j,k,l) = ssttmp(nt)
               nt = nt + 1
  200       CONTINUE


            i1 = i1 + arg_incr(X_AXIS,ARG1)
  400    CONTINUE

         j1 = j1 + arg_incr(Y_AXIS,ARG1)
  500 CONTINUE

      return

  999 continue
      return

      end

      
*                                                                      ^
*                                                                      |
*                                            user configurable portion |
************************************************************************

*
* tax_datestring.F
*
* Jing Y. Li 
* May 2006
* 18-may-2006 ACM change to compare only the first 3 characters of the precision string.
*
* Returns string of dates 
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, tax_datestring )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )


      SUBROUTINE tax_datestring_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     . 'Returns date string for time axis coordinate values' )

      CALL ef_set_num_args(id, 3)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_result_type(id, STRING_RETURN)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 'time steps to convert')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)


      arg = 2
      CALL ef_set_arg_name(id, arg, 'B')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 'variable with reference time axis')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

*     Set data type as string
      arg = 3
      CALL ef_set_arg_type (id, arg, STRING_ARG)

      CALL ef_set_arg_name(id, arg, 'C')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 'output precision')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

* In this subroutine we compute the result
*
      SUBROUTINE tax_datestring_compute(id, arg_1, arg_2, arg_3, 
     .           result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy,
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy,
     .           mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3(2,mem3lox:mem3hix, mem3loy:mem3hiy, 
     .     mem3loz:mem3hiz, mem3lot:mem3hit)

      REAL result(2,memreslox:memreshix, memresloy:memreshiy, 
     .     memresloz:memreshiz, memreslot:memreshit)


* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l
      INTEGER i1, j1, k1, l1
      INTEGER i3, j3, k3, l3
      INTEGER rtype, slen
      CHARACTER*20 datestring
      CHARACTER*3 precistring
      REAL*8 ddate

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_result_type(id, rtype)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*     Get the precision for output
      i3=arg_lo_ss(X_AXIS, ARG3)
      j3=arg_lo_ss(Y_AXIS, ARG3)
      k3=arg_lo_ss(Z_AXIS, ARG3)
      l3=arg_lo_ss(T_AXIS, ARG3)

*     Get the output presicion (string)
      CALL ef_get_string_arg_element(id, ARG3, arg_3,
     .     i3,j3,k3,l3,slen,precistring)

      CALL LOWER(precistring)

      i1 = arg_lo_ss(X_AXIS,ARG1)
      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)


         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               l1 = arg_lo_ss(T_AXIS,ARG1)
               DO 100 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

                 ddate =  arg_1(i1,j1,k1,l1)

C     Get the string value of dates and put them in the result.
                 CALL EF_GET_AXIS_DATES 
     .                (id, ARG2, ddate, 1, datestring)

                 If(precistring .EQ. 'sec') THEN
                     slen = 20
                     CALL EF_PUT_STRING (datestring, slen,
     .                    result(1,i,j,k,l))
                 
                 ELSE If(precistring .EQ. 'min') THEN
                     slen = 17
                     CALL EF_PUT_STRING (datestring(1:17), slen,
     .                    result(1,i,j,k,l))

                 ELSE If(precistring .EQ. 'hou') THEN
                     slen = 14
                     CALL EF_PUT_STRING (datestring(1:14), slen,
     .                    result(1,i,j,k,l))

                 ELSE If(precistring .EQ. 'day') THEN
                     slen = 11
                     CALL EF_PUT_STRING (datestring(1:11), slen, 
     .                    result(1,i,j,k,l))

                 ELSE IF(precistring .EQ. 'mon') THEN
                     slen = 8
                     CALL EF_PUT_STRING (datestring(4:11), slen,
     .                    result(1,i,j,k,l))

                 ELSE IF(precistring .EQ. 'yea') THEN
                     slen = 4
                     CALL EF_PUT_STRING (datestring(8:11), slen,
     .                    result(1,i,j,k,l))

                 ELSE
                     slen = 20
                     CALL EF_PUT_STRING (datestring, slen,
     .                    result(1,i,j,k,l))

                 ENDIF
                 
                  l1 = l1 + arg_incr(T_AXIS,ARG1)
 100           CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 300     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
 400  CONTINUE
     
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END
****************************************************************
*
      SUBROUTINE LOWER(TEXT)
      CHARACTER*(*) TEXT
*
*     Converts a string to lowercase.
*
      EXTERNAL LENGTH
      INTEGER  LENGTH
      CHARACTER*1 LETTER
      INTEGER ISHIFT,I
      ISHIFT=ICHAR('a')-ICHAR('A')
      DO 10 I=1,LENGTH(TEXT)
        LETTER=TEXT(I:I)
        IF('A'.LE.LETTER.AND.LETTER.LE.'Z') THEN
          TEXT(I:I)=CHAR(ICHAR(LETTER)+ISHIFT)
        END IF
   10 CONTINUE
      RETURN
      END

***************************************************************
*
      INTEGER FUNCTION LENGTH(TEXT)
      CHARACTER*(*) TEXT
*
*     Computes the length of a string without trailing blanks.
*
      INTEGER I

      DO 1 I=LEN(TEXT),1,-1
        IF(TEXT(I:I).NE.' ') THEN
          GO TO 2
        END IF
    1 CONTINUE
      I=1
    2 CONTINUE
      LENGTH=I

      RETURN
      END

	SUBROUTINE TM_GET_LIKE_DYN_LINE(idim, lo, hi, del, like, class,
     .					outline, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Returns a line matching the input description.
* Will create a line description based on the input arguments and
* compare it to other line definitions in common. Unlike
* tm_get_like_line (and unlike TM_GET_LIKE_DYN_GRID) this will check
* dynamic lines (only).
* If there is a match then "outline" returns with the number of the match.
* If there is no match, then a new dynamic line is created.
* "outline" returns with the number of the new dynamic line and its_dyn
* is .TRUE..

* created 9/95 *sh*
* Linux Port 5/96 *kob* - Had to add NINT to calculation of line_dim
*			  because the last value was sometimes getting
*			  truncated on linux, ie x[.1:1:.1] only listed
*			  nine rather than ten points.
* V533 *sh* 6/01 - save line_parent for regular stride axes, too
*		   else the stride and delta cannot be recovered 
* V541 *sh* 2/02 - added support for parent modulo length less than axis length
* V581*acm*  6/05 - For fix to bug 1271, add flag line_shift_origin
* v694 1/15 *acm* (see ticket 2227) handle the line_dim_only flag
* V71 12/16 *acm* Ticket 2158: working with true monthly time axes, the def 
*                  for line_start behaves as for irregular axes

* Arguments
	INTEGER		idim, like, class, outline, status
	REAL*8		lo, hi, del

* argument description:
* in	idim	  - axis orientation: 1-4
* in	like	  - template line for creating the new one
* in	class	  - line class
* out	outline	  - returned line
* in	lo,hi,del - description of line

* INCLUDE FILES
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'implicit.parm'
	include 'tmap_errors.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xunits.cmn_text'
	external xunits_data
*
* Local definitions
	LOGICAL		TM_ITS_SUBSPAN_MODULO, true_month
	INTEGER		inline
	INTEGER		TM_FIND_LIKE_DYN_LINE

*kob 5/97
	REAL*8 		dp_epsilon
	PARAMETER 	( dp_epsilon = 1.D-10)

* allocate a scratch line 
	CALL TM_ALLO_DYN_LINE( inline, status )
	IF ( status .NE. merr_ok ) RETURN

* create a scratch line matching the request
	IF ( like .NE. unspecified_int4 ) THEN
* ... copy the template
* ... a child axis is usually regular if the parent is regular
*     but for sub-span modulo only if the child doesnt cause modulo-ing
	   CALL TM_COPY_LINE( like, inline )
	   line_regular(inline) = line_regular(like) .AND.
     .	        ( (.NOT.TM_ITS_SUBSPAN_MODULO(like)  )
     .	     .OR. (lo.GE.1 .AND. hi.LE.line_dim(like)) )
	ELSE
* ... or initialize to defaults
	   line_regular(inline)    = .TRUE.
	   line_direction(inline) = axis_orients(idim)
	   line_t0(inline)        = char_init20
	   line_shift_origin(inline) = .FALSE.
	   line_tunit(inline)     = 0
	   line_units(inline)     = ' '
	   line_unit_code(inline) = 0
	ENDIF
	line_name(inline) = 'scratch'
	line_class(inline) = class
	line_modulo(inline)     = .FALSE.	! modulo subset doesn't cut it
	line_modulo_len(inline) = 0.0D0
	line_dim_only(inline)   = .FALSE.

* set up the scratch line as per its class
* Note: for computational efficiency axes with regularly-spaced points will
*	be set up as "basic" axes wherever possible.  This will allow TM_WORLD
* 	to access their coordinate information without recursively descending
*	to the parent axis.  (Making potentially significant improvements
*	to commonly used routines such as ISUBSCRIPT)

	IF ( class .EQ. pline_class_basic ) THEN
	   line_parent(inline)	  = 0
	   line_regular(inline)   = .TRUE.
	   line_start(inline)     = lo
	   line_delta(inline)     = del 
	   IF ( hi .GT. 0.0D0) THEN
	     line_dim(inline)       = INT((hi-lo)/del +dp_epsilon) + 1
	   ELSE
   	     line_dim(inline)       = INT((hi-lo)/del +dp_epsilon) + 1
	   ENDIF
* ... every nth index of parent line
	ELSEIF ( class .EQ. pline_class_stride ) THEN

	   true_month = line_unit_code(inline) .LE. pun_trumonths
	   IF ( line_regular(inline) .AND. .NOT.true_month) THEN
	      line_parent(inline)    = like
	      line_start(inline)     = line_start(like)
     .				     + (lo-1)*line_delta(like)
	      line_delta(inline)     = del * line_delta(like)
	      IF ( hi .GT. 0.0D0) THEN
	        line_dim(inline)       = INT((hi-lo)/del +dp_epsilon) + 1
	      ELSE
   	        line_dim(inline)       = INT((hi-lo)/del +dp_epsilon) + 1
	      ENDIF
	   ELSE
	      line_parent(inline)    = like
	      line_start(inline)     = lo			! integer
	      line_delta(inline)     = del			! integer
	      IF ( hi .GT. 0.0D0) THEN
	        line_dim(inline)       = INT((hi-lo)/del +dp_epsilon) + 1
	      ELSE
   	        line_dim(inline)       = INT((hi-lo)/del +dp_epsilon) + 1
	      ENDIF
	   ENDIF

* ... midpoints from parent (entire) line
	ELSEIF ( class .EQ. pline_class_midpt ) THEN	! midpoints
	   line_dim(inline)       = line_dim(like)-1
	   IF ( line_regular(like) ) THEN
	      line_parent(inline)    = like
	      line_start(inline)     = line_start(like)
     .				     + 0.5*line_delta(like)
	      line_delta(inline)     = line_delta(like)
	   ELSE
	      line_parent(inline)    = like
	      line_start(inline)     = 1			! integer
	      line_delta(inline)     = 1			! integer
	   ENDIF

	ELSE
	   STOP 'LINE CLASS NOT IMPLEMENTED'
	ENDIF

* search for this line among the existing, dynamic lines
	outline =  TM_FIND_LIKE_DYN_LINE( inline )

	IF (outline .EQ. unspecified_int4) THEN
* ... doesn't exist yet - make a new dynamic line  "(AXnnn)"
	   CALL TM_ALLO_DYN_LINE( outline, status )
	   IF (status .NE. merr_ok) GOTO 9000
	   CALL TM_COPY_LINE( inline, outline )

* ... make sure the parent line doesn't get deallocated while still in use
	   IF ( line_parent(inline) .NE. 0 ) CALL TM_USE_LINE(like)

* ... name it "(AXnnn)"
	   WRITE ( line_name(outline), 3000 ) outline - max_lines
 3000	   FORMAT('(AX',I3.3,')')		! restricted to 3 digits

	ENDIF


! this block would apply if use count started at 1 at time of creation
!	IF (outline .NE. unspecified_int4) THEN
!* ... yes - it matches an existing dynamic line - inc its use count
!	   CALL TM_USE_LINE( outline )
!	ELSE
!
!* ... no - it shall be a new dynamic line  "(AXnnn)"
!	   CALL TM_ALLO_DYN_LINE( outline, status )
!	   IF (status .NE. merr_ok) GOTO 9000
!	   CALL TM_COPY_LINE( inline, outline )
!
!* name it "(AXnnn)"
!	   WRITE ( line_name(outline), 3000 ) outline
! 3000	   FORMAT('(AX',I3.3,')')		! restricted to 3 digits
!
!	ENDIF

* successful completion
	status = merr_ok

* error and normal exits
 9000   line_parent(inline) = 0		! avoid deallocating parent of scratch
	CALL TM_DEALLO_DYN_LINE(inline)
	RETURN
	END

c*
c* ef_get_arg_info.F
c*
c* Jonathan Callahan
c* Sep 28th 1998
c*
c*
   
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
c*
c* This returns the name, title and dataset associated 
c* with an argument.
c*
* V552 *acm* 4/03- up VAR_CODE decl from 64 to 128 chars

      SUBROUTINE EF_GET_ARG_INFO(id, iarg, name, title, units )

      IMPLICIT NONE
      INCLUDE 'tmap_dims.parm'
      INCLUDE 'ferret.parm'
      INCLUDE 'xcontext.cmn'
      INCLUDE 'EF_Util.parm'

      INTEGER id, iarg
      INTEGER cat, var

      CHARACTER*(*) name, title, units
      CHARACTER var_code*128, var_title*128, var_units*32

      INTEGER cx_list(EF_MAX_ARGS)

c* The context list was cached by Ferret and must be retrieved
c* to be accessible to the external function.

      CALL EF_GET_CX_LIST(cx_list)

      cat = cx_category(cx_list(iarg))
      var = cx_variable(cx_list(iarg)) 

      name  = var_code(cat,var)
      title = var_title(cx_list(iarg))
      units = var_units(cx_list(iarg))

      RETURN 
      END

	SUBROUTINE SHOW_1_UVAR( lun, uvar, line, lead_in, full )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* output some lines describing a user variable

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V402: 7/95 - extracted from XEQ_SHOW with additions for LET/D=
* V510: 5/00 *sh* - show bad data flag if manually set
* v552: 4/03 *acm*  Increase length of variable names to 128 characters
*                   (variables are up to 128, so FULL_UVAR_NAME needs extra 
*                   space i.e. for a transformation specifier)

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include	'ferret.parm'
	include	'xvariables.cmn'
	include	'xrisc.cmn'

* calling argument declarations:
	LOGICAL	full
	INTEGER	lun, uvar
	CHARACTER*(*) lead_in	! characters at margin - at least 1 character
	CHARACTER*(*) line	! line buffer -- 255 char
	
* local variable declarations:
	INTEGER TM_LENSTR1, slen, llen
	CHARACTER FULL_UVAR_NAME*150, TM_FMT*48

* initialize
	IF (uvar_num_items(uvar) .EQ. uvar_deleted  ) RETURN
	llen = LEN(lead_in)

* variable name and definition
	risc_buff = lead_in//FULL_UVAR_NAME(uvar,slen)
	slen = slen + llen
	risc_buff = risc_buff(:slen)//' = '//uvar_text(uvar)		
	CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
	risc_buff = ' '

* extra information for "full" output
	IF ( full ) THEN
* ... title and units as "...title...(units)"
	   line = uvar_title(uvar)
	   IF ( line .EQ. ' ' ) THEN
	      slen = 3
	   ELSE
	      slen = 1
	   ENDIF
	   IF ( uvar_units(uvar) .NE. ' ' ) THEN
	      line = line(:TM_LENSTR1(line))//
     .                      ' ('//uvar_units(uvar)
	      line = line(:TM_LENSTR1(line))//')'
	   ENDIF
	   IF ( line .NE. ' ' ) THEN
	      WRITE (risc_buff,4020)
     .                       line(slen:TM_LENSTR1(line))
	      CALL SPLIT_LIST(pttmode_explct, lun,
     .                       risc_buff, 0)
	      risc_buff = ' '
	   ENDIF
* ... bad data flag if was manually set
	   IF ( uvar_bad_data(uvar) .NE. bad_val4 ) THEN
	      line = '          bad value flag = '//
     .			TM_FMT(uvar_bad_data(uvar),7,12,slen)
	      CALL SPLIT_LIST(pttmode_explct, lun,
     .                       line, 0)
	      risc_buff = ' '
	   ENDIF
	ENDIF

 4020   FORMAT (T10,'"',A,'"')

	RETURN
	END

	SUBROUTINE GET_CX_DIMS( cx, ndim, dim )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine the "shape" of the region specified in context cx by returning
* array, dim, which contains a permutation of the 4 defining axes 1,2,3,4
* and, ndim, the number of axes for which there is a range of data.
* The permutation is first those axes which contain a range of data
* (subsampled from the ordering 1,2,3,4) followed by the axes for which the
* context specifies only a single point

* e.g. for the expression SST[X=130e:70w,t="1-jan-1982":"31-dec-1983",Y=0]
* ndim = 2
* dim = 1,4,2,3		(the Z axis is normal for SST)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V200:  5/18/89 - complete re-write from GET_CONTEXT_PLANE
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

	include	'tmap_dims.parm'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xprog_state.cmn'
	include	'xcontext.cmn'
	include	'xtext_info.cmn'

* calling argument declarations:
	INTEGER cx, ndim, dim(nferdims)

* local variable declarations:
	INTEGER	CX_DIM_LEN, idim, ii, clen(nferdims)

* initialize
	ndim = 0
	DO 10 idim = 1, nferdims
 10	clen(idim) = CX_DIM_LEN( idim, cx )

* find the axes with a range of values
	DO 100 idim = 1, nferdims
	   IF ( clen(idim) .GT. 1 ) THEN
	      ndim = ndim + 1
	      dim(ndim) = idim
	   ENDIF
 100	CONTINUE

* find the axes where the context is a single point
	ii = ndim
	DO 200 idim = 1, nferdims
	   IF ( clen(idim) .EQ. 1 ) THEN
	      ii = ii + 1
	      dim(ii) = idim
	   ENDIF
 200	CONTINUE

	RETURN	   
	END

	SUBROUTINE XEQ_POLYGON

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute the POLYGON command

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V500:  *sh* and *jd*
*        *jd  fix for v5.01 for fill if /patt or /pal given 6.7.99
*        *sh* 6/99 -- suppress color key for 2-argument version of command
* V510:  *sh* 3/00 -- change to how line specifications are passed

* V533 *acm*6/01 - add arguments is_logh, is_logv to PLOT_SET_UP call, 
*                  set log axes, inverse log axes and log depth axes with
*                  PLOT/VLOG or PLOT/HLOG
* V541 *acm*  3/02  Make PPL AXSET settings persist, but not settings
*                   done with qualifiers /AXES= or /NOAXES.
* v541 *acm*  5/02 add option to control outline on the shade key boxes 
*                   /KEY=continuous
* v554 *acm* 2/04 add /HGRAT /VGRAT to draw optional graticule lines at tic marks
* v580 *acm* 6/15/04 In the workaround which does a PPL LEV command for data with
*                    a single value, need to give the PPL command the value with  
*                    more precision.
* V581 *acm* 5/05  fix bug 1249: /KEY=CONT. Need to use EQUAL_STR to get the
*                  argument to /KEY, then compare to see if it equals uppercase 'CON'
* V600 *acm* 5/06  with MODE LINECOLORS, number of lines not limited to num_fancy_lines
* V602 *acm* 11/06 Fix bug 1472: Where single-level color plot is requested, use levels (1) 
*                  setting rather than sending the data value; avoids precision problems.
* V6.11 4/08 *acm* Fixes for bug 1571; call to PPL_AXES_RESTORE moved to DISP_INIT
* V6.2  *acm* 11/08Fix bug 1609: If the plot is an overlay then do not process /AXES=
*                  or /NOAXES. Axes are never drawn for overlays anyway.
* V6.2  *acm* 2/09 Fix choice of color settings with /PEN and /THICK when we have 
*                  increased the num of colors with MODE linecolors
* V6.83 *acm*12/12 Add POLYGON/MODULO qualifier, for curvilienar coordinate plots, 
*                  as is done for SHADE and CONTOUR plots
* V6.92 *acm* 6/14 New color /key options: any of /key=horizontal,centerlabel
* V697 *acm* 12/15 Fixes for bug 2327 move call of PPL_AXES_RESTORE back to end of plot routines
* v697 *acm* 12/15 Ticket 2331, add flag changed_key to common, to restore the color key
*                  style after a color plot and also after SHADE/SET; SHADE.
* V702 1/17 *sh* for trac enhancement #2369 -- dynamic memory management 

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'plot_setup.parm'
	include 'slash.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'
	include 'xplot_setup.cmn'
        include 'switch_inc.decl'
        include 'SWITCH.INC'
        include 'data_inc.decl'
        include 'DATA.INC'
        include 'PPLDAT.INC'
        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'lines_inc.decl'
        include 'LINES.INC'
        include 'cont_inc.decl' ! with iautoc and nlev
        include 'CONT.INC'

	
* calling argument declarations:

* internal variable declarations:
        LOGICAL         TM_HAS_STRING, no_range, do_key, spectrum, pattern,
     .			use_line, overlay, transpz, no_labels, set_up, 
     .			noaxes, axes, line_it, fill_it, is_logh, is_logv, 
     .			no_data, is_modx, do_mod_minus, do_mod_plus
	INTEGER         sp, patt, TM_LENSTR1, TM_LENSTR, STR_UPCASE
	INTEGER		symbol, color, status,
     .			loc, limit, slen, coord_ax, thick,
     .			ax1_work, ax2_work,
     .			s1, s2, it_start(4), it_end(4),
     .			nparm,  num_it, i, iax(4), i1, loch, locv
	REAL		val, only_val, sym_size, add_lon
	CHARACTER	LEFINT*4, TM_FMT*20, fname*128, poly_opt*10,
     .                  buff*25

* internal parameter declarations
	INTEGER ncolors
        LOGICAL continuous_key

* set up the graphics environment and get the data
	CALL START_PPLUS

	CALL DISP_DATA_SET_UP(  ax1_work, ax2_work, status )
	IF ( status .NE. ferr_ok ) GOTO 5100

* Initialize the lines buffer in PPL before setting up
	overlay   = qual_given( slash_shad_over_plot ).GT.0
	if (overlay) SOVER = .true.

	if (sover) then
CC      *jd* NLINES initializes SOVER, and resets MIN/MAX. Don't execute. 
CC       => Set values here instead.
	   LINEN=0
	   IBASE=1
	   PBUF=0
	   LNUM=1
	else
	   CALL PPLCMD ( from, line, 0, 'NLINES', 1, 1 )
	endif

* initialize
	transpz   = qual_given( slash_shad_transpz   ).GT.0
	no_labels = qual_given( slash_shad_nolabels  ).GT.0
	set_up	  = qual_given( slash_shad_set_up    ).GT.0
	noaxes    = qual_given( slash_noaxes         ).GT.0
	axes      = qual_given( slash_polygon_axes   ).GT.0
        IF (overlay) THEN
	   noaxes = .FALSE.
	   axes = .FALSE.
	ENDIF
	coord_ax  = qual_given( slash_polygon_coord  )		! integer
	is_logh   = qual_given( slash_is_logh        ).GT.0
	is_logv   = qual_given( slash_is_logv        ).GT.0 

	symbol	  = qual_off	! or ??unspecified_int4??
	sym_size  = 0.08	! default plot mark size
	thick	  = 1		! default thickness
	color	  = unspecified_int4
	use_line = .FALSE.
        sp        = qual_given( slash_cont_spectrum  )

        spectrum  = sp .GT. 0 
        patt      = qual_given( slash_shad_pattern   )
        pattern   = patt .GT. 0
	add_lon	  = 0.

        ncolors = mode_arg(pmode_linecolors,1)

	IF ( .NOT.overlay ) CALL DISP_INIT(no_labels,is_cx,num_uvars_in_cmnd)
	CALL DISP_PREP( status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* decode qualifiers
* ... POLYGON/COLOR=n
	loc = qual_given( slash_polygon_color )
	IF ( loc .GT. 0  ) THEN
	   CALL EQUAL_COLOR( cmnd_buff(qual_start(loc):qual_end(loc)),
     .                           color, status )
           IF ( status .NE. ferr_ok ) GOTO 5000
	   use_line = .TRUE.
	ENDIF
* ... POLYGON/THICKNESS=n

 200	loc = qual_given( slash_polygon_thick )
	IF ( loc .GT. 0  ) THEN
	   use_line = .TRUE.
	   IF ( color .EQ. unspecified_int4 ) color = 1  ! /THICK -> "BLACK"
	   color = MOD(color-1,ncolors)+1  ! eliminate thickness
	   CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			   val, status )	! syntax check
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   IF ( val .NE. unspecified_val4 ) THEN
	      IF ( val.LE.0.0 .OR. val.GT.3 ) GOTO 5400
	      thick = NINT( val )	! user-specified line style
	   ELSE
	      thick = 2  ! default if no value is specified
	   ENDIF
	   color = ncolors*(thick-1) + color
	ENDIF
* ... POLYGON/LINE_STYLE=n
	loc = qual_given( slash_polygon_line )
	IF ( loc .GT. 0  ) THEN
	   use_line = .TRUE.
	   CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      val, status )	! syntax check
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   IF ( val .NE. unspecified_val4 ) THEN
c	      limit = num_fancy_lines 			!was num_plain 1/94
              limit = 3*mode_arg(pmode_linecolors,1)
	      IF ( val.LE. 0.0 .OR. val.GT.limit ) GOTO 5200
	      color = NINT( val )	! user-specified line style
	   ELSEIF ( color .EQ. unspecified_int4 ) THEN
	      color = qual_on		! auto selection of line style
	   ENDIF
	ENDIF


* decide on line or fill or both
	line_it   = use_line 

	if (line_it) then
	   fill_it = qual_given(slash_polygon_fill) .gt. 0 
     .               .or. spectrum .or. pattern
	else
	   fill_it   = .true.
	end if

	if (line_it .and. fill_it) then
	   poly_opt = '/LINE/FILL'
	else if (line_it .and. .not. fill_it) then
	   poly_opt = '/LINE'
	else
	   poly_opt = ' '
	end if

* ... POLYGON/hgrat[=dash or line] default is dash
*     hgrat line type: 0=tics only, 1=dash 2=line

	loch = qual_given(slash_polygon_hgrat)

* ... POLYGON/vgrat[=dash or line] default is dash
*     vgrat line type: 0=tics only, 1=dash 2=line

	locv = qual_given(slash_polygon_vgrat)
        
        IF (loch .EQ. 0  .AND. locv .EQ. 0) THEN
           loch = qual_given(slash_polygon_grat)
           locv = qual_given(slash_polygon_grat)
        ENDIF

        CALL set_graticules(loch, locv, status)

	
* default key

	do_key =  (qual_given(slash_polygon_key)  .GT. 0)
     .          .OR. (fill_it
     .		     .AND. .NOT.overlay
     .		     .AND. num_uvars_in_cmnd.GT.2)
	IF (qual_given(slash_polygon_nokey) .gt. 0) do_key = .FALSE.
	

* Double check: is there no valid input data?
	IF ( no_data ) do_key = .FALSE.
	IF ( do_key ) THEN
	   CALL PPLCMD ( from, line, 0, 'SHAKEY 1,1', 1, 1 )

* ... /KEY[=continuous,horizontal,centerlabel ?
	      
	      loc = qual_given(slash_polygon_key )
	      changed_key = .FALSE.

              IF ( loc .GT. 0) THEN
		 CALL EQUAL_STRING( cmnd_buff(qual_start(loc):qual_end(loc)),
     .                        buff, status )
                 IF ( status .NE. ferr_ok ) GOTO 5000
		 IF (TM_LENSTR(buff) .GT. 0) THEN
	         changed_key = .FALSE.
	         IF ( TM_HAS_STRING(buff, 'CON') ) THEN
                    changed_key = .TRUE.
                    CALL PPLCMD (from, line, 0, 'S_KEY 1', 1, 1 )
                 ENDIF
	         IF ( TM_HAS_STRING(buff, 'CEN') ) THEN
                    changed_key = .TRUE.
                    CALL PPLCMD (from, line, 0, 'S_KEY 2', 1, 1 )
                 ENDIF
	         IF ( TM_HAS_STRING(buff, 'HOR') ) THEN
                    changed_key = .TRUE.
                    CALL PPLCMD (from, line, 0, 'S_KEY 3', 1, 1 )
                 ENDIF
                 IF (.NOT. changed_key) GOTO 5460
		 ENDIF

              ENDIF

	ELSE
	   CALL PPLCMD ( from, line, 0, 'SHAKEY 0,1', 1, 1 )
	ENDIF

* Do a /MODULO operation for curvilinear coordinates?

	is_modx = qual_given(slash_polygon_mod) .GT. 0

	if (overlay) sover = .true.
* set up the axes and title and load the data into PPLUS

 220	CONTINUE 
	CALL POLYGON_SET_UP   ( 
     .				overlay,
     .				transpz,
     .				coord_ax,
     .				no_labels,
     .				no_range,
     .				only_val,
     .				symbol,
     .				color,
     .				use_line,
     .				is_logh, 
     .				is_logv,
     .				is_mr,
     .				is_cx,
     .				num_uvars_in_cmnd,
     .				is_modx,
     .				do_mod_minus, 
     .				do_mod_plus,
     .				add_lon,
     .				workmem(ax1_work)%ptr,
     .				workmem(ax2_work)%ptr,
     .				status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* is there no valid input data?
	no_data =  no_range .AND. only_val.EQ.bad_val4

* PPLUS blows up setting auto contour levels if all data have same value
* But, do not let this be rounded off, or we cannot find the color when matching 
* this value in get_ndx, called by fillpol

* The initial fix below had precision problems when the value in only_val was
* of high precision, sometimes causing polygons to go unfilled (bug 1472).  
* Instead, make a ppl lev 1 setting, as is done in disp_prep.F

c     IF ( no_range .AND. qual_given( slash_shad_lev_same ) .EQ. 0 )
c    .          CALL PPLCMD ( from, line, 0, 
c    .          'LEV () ('//TM_FMT(only_val, 8, 20, slen)//')' , 1, 1 )

      IF ( no_range .AND. qual_given( slash_shad_lev_same ) .EQ. 0 ) THEN
           iautoc = 1  
c           nlev = 1   
      ENDIF

* protect colors already on-screen before a color overlay
	IF ( overlay ) CALL PPL_SHASET( 'PROTECT' )

* save old and reset to new color spectrum if requested
	IF ( spectrum ) THEN
	   CALL EQUAL_STR_LC( cmnd_buff(qual_start(sp):qual_end(sp)),
     .             fname, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   IF ( fname .EQ. ' ' ) fname = 'default'
	   CALL PPL_SHASET( 'SAVE' )
	   CALL PPL_SHASET( 'SPECTRUM='//fname(1:TM_LENSTR1(fname)) )
	ENDIF

* save old and set to new pattern if requested (a la spectrum)
	IF ( pattern ) THEN
	   CALL EQUAL_STR_LC( 
     .             cmnd_buff(qual_start(patt):qual_end(patt)),
     .             fname, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   IF ( fname .EQ. ' ' ) fname = 'default'
	   CALL PPL_PATSET( 'SAVE' )
	   CALL PPL_PATSET( 'PATTERN='//fname(1:TM_LENSTR1(fname)) )
	ENDIF

* turn off axes? 
	IF ( noaxes ) THEN 
           DO 300 i = 1, 4
              iax(i) = 0
 300       ENDDO
        ENDIF

* turn on (one or more) axes? (7/11/01)

* ... PLOT/AXES=(TOP,BOTTOM,LEFT,RIGHT)
	IF ( axes ) THEN
           loc = qual_given( slash_polygon_axes )
	   CALL EQUAL_STR_LC( cmnd_buff(qual_start(loc):qual_end(loc)),
     .                        buff, status )
           IF ( status .NE. ferr_ok ) GOTO 5000

	   IF ( buff .NE. ' ' ) THEN

* Get arguments, if any.  Otherwise turn on all axes
              slen = TM_LENSTR1(buff)
              s1 = 1
              s2 = slen
              IF (buff(1:1) .EQ. '(' )THEN
                  s1 = 2
                  s2 = slen-1
                  IF ( buff(slen:slen) .NE. ')' ) GOTO 5440
              ENDIF

              nparm = 4
              CALL parse_comma_list ( buff, s1, s2, nparm, 
     .             num_it, it_start, it_end, status)
              IF (status .EQ. ferr_ok .AND. it_start(1) .GT. it_end(1)) THEN	! /AXES=()
                 DO 400 i = 1, 4
                    iax(i) = 0
 400             ENDDO
              ELSE IF (status .NE. ferr_ok .OR. num_it .LT. nparm) THEN
                 GOTO 5440
              ELSE
                 DO 500 i = 1, nparm
                    READ (buff(it_start(i):it_end(i)), *) iax(i)
                    IF (iax(i) .LT. 0  .OR.  iax(i) .GT. 1) GOTO 5450
 500             CONTINUE
              ENDIF
           ELSE		! turn on all axes
	      DO 600 i = 1, 4
		 iax(i) = 1
 600	      CONTINUE
           ENDIF
              
	ENDIF

*  Turn off or on axes, including time axes.
        IF (axes .OR. noaxes) CALL ax_on_off (iax)

* /set_up only requested ?
	IF ( set_up ) GOTO 1000

* polygon it 
	   IF ( overlay ) THEN
	      CALL PPLCMD ( ' ', ' ', 0,
     .          'FILLPOL/OVER/'//ppl_wait//poly_opt//' ' , 1, 1 )
	   ELSE
	      CALL PPLCMD ( ' ', ' ', 0,
     .		'FILLPOL/'//ppl_wait//poly_opt//' ', 1, 1 )
	   ENDIF

* Is a modulo replication set up?  If so go do it, no labels, no axes, no key,
* same levels (which were computed with all the data, just not shown on orig. plot)
	   IF (is_modx) THEN
	      add_lon = 0.
	      IF (do_mod_minus) THEN
	         add_lon = -360.
		 do_mod_minus = .FALSE.
	      ELSEIF (do_mod_plus) THEN
	         add_lon = 360.
		 do_mod_plus = .FALSE.
	      ENDIF
	      IF (add_lon .NE. 0) THEN
		 sover = .TRUE.
		 overlay = .TRUE.
		 noaxes = .TRUE.
		 no_labels = .TRUE.
		 do_key = .FALSE.
		 iautoc = 1 ! Mark the levels as set
C Reset pplus lines
		 LINEN=0
		 IBASE=1
		 PBUF=0
		 LNUM=1

		 GOTO 220
	      ENDIF
	   ENDIF

* protect the new colors and restore the original color spectrum
           IF ( spectrum ) THEN
              CALL PPL_SHASET( 'PROTECT' )
              CALL PPL_SHASET( 'SPECTRUM' )
           ENDIF

* restore the original pattern
           IF ( pattern ) THEN
              CALL PPL_PATSET( 'PATTERN' )
           ENDIF

* Mark the levels as set; if we used histogram levels it is 0

          IF (need_histo) iautoc = 1

* restore axes? (5/29/97) revised 3/02
	IF ( axes .or. noaxes ) CALL PPL_AXES_RESTORE

* restore default (non-continuous) key style?
        IF (continuous_key ) CALL PPLCMD (from, line, 0, 'S_KEY 0', 1, 1 )

* interrupt occurred during plot ?
	IF ( ppl_interrupted ) GOTO 1000

* capture the bit map ?
	IF ( qual_given( slash_shad_frame ) .GT. 0 ) THEN
	   CALL SAVE_FRAME( frame_file, "HDF", status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	ENDIF

*  Save log axis state

	IF (overlay) THEN
	   is_logh = h_logaxis
	   is_logv = v_logaxis
	ELSE
	   h_logaxis= is_logh
	   v_logaxis = is_logv 
	ENDIF

* release the memory used for axis buffers
 1000 	CALL FREE_WS_DYNMEM( ax1_work )
	CALL FREE_WS_DYNMEM( ax2_work )
	CALL UNPROTECT_CMND_DATA			! 1/94
 5100	RETURN

* error exits
 5000	GOTO 1000
 5200	CALL ERRMSG( ferr_out_of_range, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .		'Legal range is 1 to '//LEFINT(limit,slen), *1000 )
 5400	CALL ERRMSG( ferr_out_of_range, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .		'Legal range is 1 to 3', *1000 )
 5440	CALL ERRMSG( ferr_syntax, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .'AXES[=(TOP,BOTTOM,LEFT,RIGHT)] takes 4 arguments or no argument', 
     .		*1000 )
 5450	CALL ERRMSG( ferr_out_of_range, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .		'AXES arguments must be 0 or 1', *1000 )
 5460	CALL ERRMSG( ferr_syntax, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .		'Unrecognized argument to KEY command', *1000 )
	END

	SUBROUTINE DO_AUX_REGRID_LINE_AVE ( axis,
     .					 src_line, pos_line,
     .					 kmin_src, kmax_src,
     .					 ndx_dst, coef_dst,
     .					 kmin_dst, kmax_dst,
     .					 kdlo_ok,  kdhi_ok,
     .					 bad_src,  bad_dst, ascending,
     .					 dst_line    )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* regrid a single line along the regrided axis.  For each destination point
* regrid using the weighted average of values lying entirely or partly
* in the cell

* the algorithm will weight the input values based upon viewing the
* coordinates found in the auxiliary coordinate variable as a piecewise-linear
* function.  For each destination grid cell the algorithm will compute the
* integral, and divide by its length.

* Thus that calculation is one of adding up the areas of a
* series of trapezoids from the source data over a coordinate length defined
* by the limits of each target grid cell.

* For any given cell the trapezopids at the edges of the cell may be truncated,
* as the destination cell boundaries may not lie directly on the coordinate
* values given in the auxiliary variable.

* sample expression:  temp[gz(depth)=zax]
* variable naming convention:
*     pos_line - position (coordinate) values (e.g. depth)
*     src_line - values on their original grid (e.g. temp)
*     dst_line - values regridded to target grid

*  The incoming index pointers tell us the source data indices that lie
*  at or immediatly below each target grid cell boundary.
*  If there are N destination grid points there will be N+1
*  cell boundaries and N+1 incoming indices, positions and coefficients. The
*  coefficient values are non-unity, when the target cell boundary coordinate
*  lies in between the coordinate values from the auxiliary coordinate array
*  The sense of the coefficient is that the value at this destination location
*  should be computed as 
*                  interp_val = coef*src(k) + (1-coef)*src(k+1)
* 
* v690 11/13 *sh* - based upon DO_AUX_VAR_REGRID_LIN

        IMPLICIT NONE
        include 'tmap_dims.parm'
        include 'errmsg.parm'
	include	'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'

* calling argument declarations:
	LOGICAL	ascending
	INTEGER	axis, kmin_src,kmax_src, kmin_dst, kmax_dst, kdlo_ok, kdhi_ok,
     .		ndx_dst (kmin_dst:kmax_dst+1)
        REAL    src_line(kmin_src:kmax_src),
     .		pos_line(kmin_src:kmax_src),
     .		coef_dst(kmin_dst:kmax_dst+1),
     .		dst_line(kmin_dst:kmax_dst),
     .		bad_src, bad_dst

* internal variable declarations:
	LOGICAL	trunc
        INTEGER ndx_lo, ksrc, kdst, kend, kstart, kinc1
        REAL    area, span, width, frac, pos_lo, pos_hi, src_lo, src_hi

* initialize
	IF (ascending) THEN
	   kinc1 = 1
	ELSE
	   kinc1 = -1
	ENDIF

* set up the lower bound of the first trapezoid (possibly truncated)
 110	ksrc   = ndx_dst (kdlo_ok)
	pos_hi = pos_line(ksrc)
	src_hi = src_line(ksrc)
	frac   = coef_dst(kdlo_ok)
	trunc  = frac .NE. 1.0
	IF (trunc) THEN
* make the initial truncated trapezoid behave like a full trapezoid by  
* replacing its lower limit with the proper linear interpolation
	   src_hi = frac*src_hi + (1-frac)*src_line(ksrc+kinc1)
	   pos_hi = frac*pos_hi + (1-frac)*pos_line(ksrc+kinc1)
	   trunc  = .FALSE.
	ENDIF
	kstart = ksrc + kinc1   ! ksrc always points to the upper index

* loop over destination cells
* each dst cell is represented by two points in the dst arrays
*    the k   point is the index below or at the start of the cell
*    the k+1 point is the index below or at the end   of the cell
	DO 1000 kdst = kdlo_ok, kdhi_ok

	   area = 0.0
	   span = 0.0

* set up low lim of next dest cell from high lim of preceding
	   pos_lo = pos_hi
	   src_lo = src_hi

* loop over the full src trapezoids that contribute to current dst cell
	   kend = ndx_dst(kdst+1)
	   DO 500 ksrc = kstart, kend, kinc1

* upper end of trapezoid in the src line
	      pos_hi  = pos_line(ksrc)
	      src_hi  = src_line(ksrc)

* add a full trapezoid 
	      width = pos_hi - pos_lo
	      span  = span + width
	      area  = area + width * 0.5*(src_hi+src_lo)

* prepare for next trapezoid in the src line
	      pos_lo = pos_hi
	      src_lo = src_hi	    
 500	   CONTINUE

* handle partial trapezoid at upper bound of destination cell
	   frac = coef_dst(kdst+1)
	   trunc = frac .NE. 1.0
	   IF (trunc) THEN
* add the lower part of the truncated trapezoid.
* the upper part is handled as part of the next destination cell
	      pos_hi = frac*pos_line(kend) + (1-frac)*pos_line(kend+kinc1)
	      src_hi = frac*src_line(kend) + (1-frac)*src_line(kend+kinc1)
	      width = pos_hi - pos_lo
	      span  = span + width
	      area  = area + width * 0.5*(src_hi+src_lo)
	   ENDIF

* store the weighted average of trapezoids contributing to dst cell
	   dst_line(kdst) = area/span

* prepare for next src trapezoid contributing to this dst
	   kstart = kend + kinc1

 1000	CONTINUE

	RETURN
	END

	LOGICAL FUNCTION GEOG_COS_FACTOR( idim, grid )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine whether a particular axis of a grid represents geographical
* locations (lat.,long., etc.) requiring COS corrections

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 8/25/88
* V230:  7/23/92 - TRUE only if grid has a valid latitude axis (major rewrite)
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
        include 'xunits.cmn_text'
        external xunits_data
	include 'ferret.parm'
	include 'xtext_info.cmn'

* calling argument declarations:
	INTEGER		idim, grid

* internal variable declarations:
	INTEGER		xaxis, yaxis

* check for program bug	! temp
	IF ( grid .EQ. unspecified_int4 ) STOP 'no_grd_orient'

* initialize
	xaxis = grid_line( x_dim, grid )
	yaxis = grid_line( y_dim, grid )

* check that the X and Y axes of this grid are both degrees
* assume the calling routine calls this only for lat or long
*     (so the orientation of idim is not checked here)

	IF ( xaxis .EQ. mnormal .OR. xaxis .EQ. munknown
     .  .OR. yaxis .EQ. mnormal .OR. yaxis .EQ. munknown ) THEN
	   GEOG_COS_FACTOR = .FALSE.
	ELSE
           GEOG_COS_FACTOR = line_unit_code(xaxis) .EQ. pun_degrees
     .                 .AND. line_unit_code(yaxis) .EQ. pun_degrees
	ENDIF

	RETURN
	END

*  piecewise.F
* 
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* Ansley Manke June 2013
* implements stl2, Piecewise linear approximations of fewest line segments
* described in http://www.computer.org/csdl/proceedings/afips/1972/5079/00/50790187.pdf
* and a somewhat later version of the code, found at
* http://www.netlib.org/toms/510
*
*
*  In this subroutine we provide information about
*  the function.  The user configurable information 
*  consists of the following:
* 
*  descr              Text description of the function
* 
*  num_args           Required number of arguments
* 
*  axis_inheritance   Type of axis for the result
*                        ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                        CUSTOM          - user defined axis
*                        IMPLIED_BY_ARGS - same axis as the incoming argument
*                        NORMAL          - the result is normal to this axis
*                        ABSTRACT        - an axis which only has index values
* 
*  piecemeal_ok       For memory optimization:
*                        axes where calculation may be performed piecemeal
*                        ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE piecewise_init(id)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     . 'Return indices to sample from piecewise linear interpolation' )

      CALL ef_set_num_args(id, 5) !Y, E, IP as 3 args
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id, ABSTRACT, ABSTRACT, NORMAL, 
     .                                      NORMAL, NORMAL,   NORMAL)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 1)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_desc(id, arg, 'variable to sample on I axis')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'Tolerances')
      CALL ef_set_arg_desc(id, arg,
     .          'array or single value containing tolerances to use')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, NO, NO)

C THE CONTROL PARAMETER IP IS THE PRODUCT
C  OF THREE INDICATORS I1,I2 AND I3.
C  I1 INDICATES WHETHER OR NOT E IS AN
C     ARRAY OF TOLERANCES.
C     I1 = -1 INDICATES E IS AN ARRAY
C     I1 = +1 INDICATES E IS A SINGLE NUMBER.

      arg = 3
      CALL ef_set_arg_name(id, arg, 'Num Tolerances')
      CALL ef_set_arg_desc(id, arg,
     .          '1 if single tolerance, -1 if tolerance array')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, NO, NO)

C  I2 INDICATES WHETHER OR NOT THE
C     APPROXIMATION IS TO BE RESTRICTED TO
C     THE 'TOLERANCE BAND' ABOUT THE DATA.
C     I2 = 1 INDICATES NO BAND RESTRICTION
C     I2 = 2 INDICATES APPLY THIS RESTRICTION
C     (THE 'TOLERANCE BAND' IS A PIECEWISE
C     LINEAR BAND CENTERED AT THE DATA WHOSE
C     WIDTH IS DETERMINED BY THE TOLERANCES
C     AT THE DATA POINTS.)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'Restrict')
      CALL ef_set_arg_desc(id, arg,
     .          '1 if restricting to tolerance band, 0 if not')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, NO, NO)

C  I3 INDICATES WHETHER OR NOT THE
C     APPROXIMATION MUST BE CONTINUOUS.
C     I3 = 1 INDICATES CONTINUITY NOT REQUIRED
C     I3 = 3 INDICATES CONTINUITY IS REQUIRED

      arg = 5
      CALL ef_set_arg_name(id, arg, 'Continuous')
      CALL ef_set_arg_desc(id, arg,
     .          '1 if result is to be continuous, 0 if not')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, NO, NO)
      

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE piecewise_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER my_hi_i
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

*
*     Use utility functions to get context information about the arguments.
*

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      my_hi_i = arg_hi_ss(X_AXIS,1) - arg_lo_ss(X_AXIS,1) + 1

      CALL ef_set_axis_limits(id, X_AXIS, 1, my_hi_i)
      CALL ef_set_axis_limits(id, Y_AXIS, 1, 3)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

      
*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE piecewise_work_size(id)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
* 
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER npts, iwork

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      npts = 1 + arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1)
  
* input x-axis coordinates
      iwork = 1
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                             npts, 1, 1, 1, 1, 1)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*  In this subroutine we compute the result
* 
      SUBROUTINE piecewise_compute(id, arg_1, arg_2, arg_3, arg_4, 
     .                             arg_5, result, xpts)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz, 
     .           mem4lot:mem4hit, mem4loe:mem4hie, mem4lof:mem4hif)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz, 
     .           mem5lot:mem5hit, mem5loe:mem5hie, mem5lof:mem5hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* Ignore the Y/Z/T/E/F dimensions in the work array since
* they are not used and Fortran is column major

      REAL xpts(wrk1lox:wrk1hix)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,  j,  k,  l,  m,  n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2
      INTEGER nx, nout, ilo, ip
      REAL a3, a4, a5, bad_y
      CHARACTER*100 errtxt

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)


* Compute the parameter IP

      CALL ef_get_one_val(id, ARG3, a3)
      CALL ef_get_one_val(id, ARG4, a4)
      CALL ef_get_one_val(id, ARG5, a5)

      IF (ABS(a3) .NE. 1) THEN
         errtxt = 'Argument 3 must be -1 or 1'
	 GOTO 999
      ENDIF
      IP = INT(a3)

      IF (a4 .EQ. 1) THEN
         IP = IP* 2
      ELSE IF (a4 .EQ. 0) THEN
         a4 = IP* 1
      ELSE
         errtxt = 'Argument 4 must be 0 or 1'
	 GOTO 999
      ENDIF

      IF (a5 .EQ. 1) THEN
         IP = IP* 3
      ELSE IF (a4 .EQ. 0) THEN
         IP = IP* 1
      ELSE
         errtxt = 'Argument 5 must be 0 or 1'
	 GOTO 999
      ENDIF

	print *, ' ip = ', ip

*  Set x coordinate - abstract axis.

      nx = arg_hi_ss(X_AXIS, ARG1) - arg_lo_ss(X_AXIS, ARG1) + 1
      DO 50 i = 1, nx
         xpts(i) = i
  50  CONTINUE

* Initialize result

      k = res_lo_ss(Z_AXIS)  ! index for unused dimensions

      DO 150 j = 1, 3
         DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
	    result(i,j,k,k,k,k) = bad_flag_result
 100     CONTINUE
 150  CONTINUE

      bad_y = bad_flag(ARG1)
      CALL STL2(xpts, arg_1, arg_2, nx, bad_y, result(1,1,k,k,k,k), 
     .   result(1,2,k,k,k,k), result(1,3,k,k,k,k), nout, IP)

* Truncate result(j=1) to next lowest integer - its going to be
* the set of coordinate values to sample at.

      j = 1
      DO 200 i = res_lo_ss(X_AXIS), nout
	 result(i,j,k,k,k,k) = INT( result(i,j,k,k,k,k) )
 200  CONTINUE

      RETURN
 999  CALL EF_BAIL_OUT(id, errtxt)
      RETURN

      END

      SUBROUTINE STL2(X, Y, E, M, bad_y, U, V, W, K, IP)

C PIECEWISE LINEAR APPROXIMATIONS OF FEWEST
C LINE SEGMENTS WITHIN GIVEN TOLERANCES.

C X,Y,E AND M CONTAIN INPUT DATA.
C U,V,K AND POSSIBLY W CONTAIN OUTPUT.

C IP IS A PARAMETER DETERMINING THE OPERATION
C  OF THE PROGRAM.

C X AND Y ARE INPUT DATA ARRAYS OF M ELEMENTS
C  X(I),Y(I) CONTAINS THE ITH DATA POINT.

C E MAY BE A SINGLE TOLERANCE OR A TABLE OF
C  TOLERANCES DEPENDING ON THE VALUE OF IP.
C IF E IS AN ARRAY, THEN E(I) IS THE TOLERANCE
C  ASSOCIATED WITH X(I),Y(I) AND E MUST CONTAIN
C  M NONNEGATIVE ELEMENTS.

C U AND V ARE OUTPUT ARRAYS OF K+1 ELEMENTS.
C  U IS A PARTITION OF THE INTERVAL (X(1),X(N))
C  WITH U(1)=X(1) AND U(K+1)=X(N).
C  V(I) IS AN ORDINATE TO BE ASSOCIATED WITH
C  U(I) IN THE APPROXIMATION.  (IF A CONTINUOUS
C  APPROXIMATION IS REQUESTED, THEN V(I) IS
C  'THE' ORDINATE TO BE ASSOCIATED WITH U(I).)

C IF A CONTINUOUS APPROXIMATION IS REQUESTED,
C  THEN W IS NOT USED.  IN THIS CASE THE ITH
C  APPROXIMATING SEGMENT IS THE STRAIGHT LINE
C  FROM U(I),V(I) TO U(I+1),V(I+1).

C IF A CONTINUOUS APPROXIMATION IS NOT
C  REQUESTED, THEN W IS A K-ELEMENT OUTPUT
C  ARRAY.  IN THIS CASE THE ITH APPROXIMATING
C  SEGMENT IS THE STRAIGHT LINE FROM
C  U(I),W(I) TO U(I+1),V(I+1), AND V(1) IS
C  SET EQUAL TO W(1).

C K IS THE NUMBER OF SEGMENTS IN THE PIECE-
C  WISE LINEAR APPROXIMATION GENERATED.  IN
C  CASE OF AN ERROR RETURN, K WILL BE SET TO
C  ZERO.

C THE CONTROL PARAMETER IP IS THE PRODUCT
C  OF THREE INDICATORS I1,I2 AND I3.
C  I1 INDICATES WHETHER OR NOT E IS AN
C     ARRAY OF TOLERANCES.
C     I1 = -1 INDICATES E IS AN ARRAY
C     I1 = +1 INDICATES E IS A SINGLE NUMBER.
C  I2 INDICATES WHETHER OR NOT THE
C     APPROXIMATION IS TO BE RESTRICTED TO
C     THE 'TOLERANCE BAND' ABOUT THE DATA.
C     I2 = 1 INDICATES NO BAND RESTRICTION
C     I2 = 2 INDICATES APPLY THIS RESTRICTION
C     (THE 'TOLERANCE BAND' IS A PIECEWISE
C     LINEAR BAND CENTERED AT THE DATA WHOSE
C     WIDTH IS DETERMINED BY THE TOLERANCES
C     AT THE DATA POINTS.)
C  I3 INDICATES WHETHER OR NOT THE
C     APPROXIMATION MUST BE CONTINUOUS.
C     I3 = 1 INDICATES CONTINUITY NOT REQUIRED
C     I3 = 3 INDICATES CONTINUITY IS REQUIRED

C CALL STL2 (X,Y,E,M,X,Y,E,M,IP) WILL NOT
C  CAUSE PROBLEMS PROVIDED THAT
C  EITHER A CONTINUOUS APPROXIMATION IS
C  REQUESTED, OR E IS A SUFFICIENTLY LARGE
C  ARRAY.

C THE PROGRAM PERFORMS THE FOLLOWING DATA
C  CHECKS.  ARE THE X-VALUES IN INCREASING
C  ORDER.  ARE THE TOLERANCE(S) NONNEGATIVE.
C  IS THE NUMBER OF DATA POINTS GREATER THAN
C  ONE.  IF ANY CHECK FAILS, THE PROGRAM
C  RETURNS WITH K SET EQUAL TO 0.  IN THIS
C  CASE NO FURTHER PROCESSING IS ATTEMPTED.

      IMPLICIT NONE
* Calling arguments
      REAL X(*), Y(*), E(*), U(*), V(*), W(*), bad_y
      INTEGER M, K, IP

* Local declarations
      INTEGER N, ITCH, I, J, L, KEEP, INIT, INDC, IGRAZE,
     .        IDIOT, IT, IPIV, KP
      REAL EPSLN, SGN, XEYE, YEYE, TEMP1, SMIN, DX, 
     .     SVX, SVY, SVMN, TEMP2, XINIT, YINIT, SLOPE, SMAX, 
     .     SVMX, TEST

      integer nothing, istop

	istop = 34566

      N = M
      ITCH = IP
      J = 1
C ERROR CHECKS
      IF (N.LE.1) GO TO 400
      IF (E(1).LT.0.0) GO TO 400
      DO 10 L=2,N
        IF (X(L-1).GE.X(L)) GO TO 400
        IF (ITCH.GE.0) GO TO 10
        IF (E(L).LT.0.0) GO TO 400
   10 CONTINUE
C INITIALIZATION FOR ENTIRE PROGRAM
      EPSLN = E(1)
      SGN = 1.0
      KEEP = 1
      I = 1
      
      if (y(i) .eq. bad_y) THEN
         do while (y(i) .eq. bad_y)
            i = i + 1
         enddo
         i = i - 1
      endif
      if (i.eq.istop) then
         nothing = 0
      endif

      U(i) = X(i)
      J = 2
      INIT = 1
      INDC = 0
      GO TO 30
C INITIALIZATION FOR EACH SEGMENT
   20 CONTINUE
      J = J + 1
      INIT = I
      INDC = 0
      IF (IABS(ITCH).LT.3) KEEP = I
      IF (IABS(IABS(ITCH)-4).NE.2) GO TO 30
C RESTRICTED TO TOLERANCE BAND
      XEYE = U(J-1)
      YEYE = V(J-1)
      TEMP1 = EPSLN
      IF (ITCH.LT.0) TEMP1 = TEMP1 + (SGN*E(I-1)-EPSLN)*(X(I)-U(J-1)
     * )/(X(I)-X(I-1))
      YINIT = YEYE - TEMP1 - TEMP1
      GO TO 40
   30 CONTINUE
C NOT RESTRICTED TO TOLERANCE BAND
      XEYE = X(I)
      YEYE = Y(I) + EPSLN
      YINIT = Y(I) - EPSLN
      IF (IABS(ITCH).EQ.1 .OR. I.EQ.1) GO TO 40
      TEMP1 = EPSLN
      IF (ITCH.LT.0) TEMP1 = SGN*E(I+1)
      SMIN = (Y(I+1)-YEYE-TEMP1)/(X(I+1)-XEYE)
      IF (ITCH.LT.0) TEMP1 = SGN*E(I-1)
      SMAX = (YEYE-Y(I-1)+TEMP1)/(XEYE-X(I-1))
      IF (KEEP.EQ.I-1) GO TO 50
      IT = I - 2
      XINIT = XEYE
      IPIV = I
      IGRAZE = I
      I = I + 1
      if (i.eq.istop) then
         nothing = 0
      endif

      if (y(i) .eq. bad_y) THEN
         do while (y(i) .eq. bad_y)
            i = i + 1
         enddo
         i = i - 1
      endif

      GO TO 150
   40 CONTINUE
      IF (XEYE.GE.X(I)) I = I + 1
      IF (ITCH.LT.0) EPSLN = SGN*E(I)
      DX = X(I) - XEYE
      SMAX = (Y(I)+EPSLN-YEYE)/DX
      SMIN = (Y(I)-EPSLN-YEYE)/DX
   50 CONTINUE
      XINIT = XEYE
      IPIV = I
      IGRAZE = I
C DETERMINATION OF INDIVIDUAL SEGMENT
   60 CONTINUE
      IF (I.EQ.N) GO TO 260
      I = I + 1
      if (i.eq.istop) then
         nothing = 0
      endif
   70 CONTINUE
C TEST FOR NEW *MAX* SLOPE
      DX = X(I) - XEYE
      IF (ITCH.LT.0) EPSLN = SGN*E(I)
      TEMP1 = (Y(I)+EPSLN-YEYE)/DX
      TEST = TEMP1 - SMAX
      IF (SGN.LE.0.0) TEST = -TEST
      IF (TEST) 80, 90, 100
   80 CONTINUE
C TEST FOR END OF CANDIDATE SEGMENT
      TEST = TEMP1 - SMIN
      IF (SGN.LE.0.0) TEST = -TEST
      IF (TEST.LT.0.0) GO TO 210
      SMAX = TEMP1
   90 CONTINUE
C TEST FOR NEW *MIN* SLOPE
      IPIV = I
  100 CONTINUE
      TEMP2 = (Y(I)-EPSLN-YEYE)/DX
      TEST = TEMP2 - SMAX
      IF (SGN.LE.0.0) TEST = -TEST
      IF (TEST) 110, 120, 140
  110 CONTINUE
      TEST = SMIN - TEMP2
      IF (SGN.LE.0.0) TEST = -TEST
      IF (TEST) 120, 130, 60
  120 CONTINUE
      SMIN = TEMP2
  130 CONTINUE
      IGRAZE = I
      GO TO 60
C CHECK FOR PIVOT AT NEW EYE POINT
  140 CONTINUE
      IF (XEYE.EQ.X(IPIV)) GO TO 220
      IF (ITCH.LT.0) EPSLN = SGN*E(IPIV)
      INDC = 1
      SVX = XEYE
      SVY = YEYE
      SVMN = SMIN
      SVMX = SMAX
      XEYE = X(IPIV)
      YEYE = Y(IPIV) + EPSLN
      SMIN = SMAX
      SMAX = (YINIT-YEYE)/(XINIT-XEYE)
      IF (KEEP.GE.IPIV) GO TO 170
      IT = IPIV - 1
  150 CONTINUE
      TEMP2 = YEYE + EPSLN
      DO 160 L=KEEP,IT
        IF (ITCH.LT.0) TEMP2 = YEYE + SGN*E(L)
        TEMP1 = (Y(L)-TEMP2)/(X(L)-XEYE)
        TEST = TEMP1 - SMAX
        IF (SGN.LE.0.0) TEST = -TEST
        IF (TEST.LT.0.0) SMAX = TEMP1
  160 CONTINUE
  170 CONTINUE
      IF (IPIV.GE.I-1) GO TO 70
      IT = I - 2
      TEMP2 = YEYE - EPSLN
      IDIOT = IPIV
      DO 200 L=IDIOT,IT
        DX = X(L+1) - XEYE
        IF (ITCH.LT.0) TEMP2 = YEYE - SGN*E(L+1)
        TEMP1 = (Y(L+1)-TEMP2)/DX
        TEST = TEMP1 - SMAX
        IF (SGN.LE.0.0) TEST = -TEST
        IF (TEST) 180, 190, 200
  180   CONTINUE
        SMAX = TEMP1
  190   CONTINUE
        IPIV = L + 1
  200 CONTINUE
      GO TO 70
C END OF CURRENT SEGMENT
  210 CONTINUE
      TEMP2 = SMIN
      IF (I.EQ.N) GO TO 240
      KEEP = IGRAZE
      GO TO 250
  220 CONTINUE
      TEMP2 = SMAX
      IF (I.EQ.N) GO TO 230
      SGN = -SGN
      EPSLN = -EPSLN
      KEEP = IPIV
      GO TO 250
  230 CONTINUE
      IF (INDC.EQ.0 .OR. XEYE.NE.X(N-1)) GO TO 240
      XEYE = SVX
      YEYE = SVY
      SMIN = SVMN
      SMAX = SVMX
  240 CONTINUE
      U(J) = X(N-1)
      YINIT = Y(N-1)
      GO TO 270
  250 CONTINUE
      IF (IABS(IABS(ITCH)-4).NE.2) GO TO 300
C DETERMINE KNOT ON EDGE OF TOLERANCE BAND
      TEMP1 = 0.0
      if (i.eq.istop) then
         nothing = 0
      endif
      IF (ITCH.LT.0) TEMP1 = EPSLN - SGN*E(I-1)
      TEMP1 = (Y(I)-Y(I-1)+TEMP1)/(X(I)-X(I-1))
      U(J) = (Y(I)+EPSLN-YEYE-TEMP1*X(I)+TEMP2*XEYE)/(TEMP2-TEMP1)
      GO TO 310
  260 CONTINUE
      U(J) = X(N)
      YINIT = Y(N)
  270 CONTINUE
C CONTINUITY CHECK FOR LAST SEGMENT
      IF (IABS(ITCH).GE.3 .OR. INIT.EQ.1) GO TO 290
      IT = INIT - 1
      SVMX = SMAX + SGN
      TEMP2 = YEYE + EPSLN
      DO 280 L=KP,IT
        IF (ITCH.LT.0) TEMP2 = YEYE + SGN*E(L)
        TEMP1 = (Y(L)-TEMP2)/(X(L)-XEYE)
        TEST = TEMP1 - SVMX
        IF (SGN.LE.0.0) TEST = -TEST
        IF (TEST.LT.0.0) SVMX = TEMP1
  280 CONTINUE
      IF (ABS(SVMX-SMAX+SVMX-SMIN).LE.ABS(SMAX-SMIN)) SMAX = SVMX
  290 CONTINUE
C NEARNESS CHECK FOR LAST SEGMENT
      TEMP2 = SMAX
      TEMP1 = YEYE + SMAX*(U(J)-XEYE)
      TEST = YINIT - TEMP1
      IF (SGN.LT.0.0) TEST = -TEST
      IF (TEST.GT.0.0) GO TO 310
      TEMP2 = SMIN
      TEMP1 = YEYE + SMIN*(U(J)-XEYE)
      TEST = YINIT - TEMP1
      IF (SGN.LT.0.0) TEST = -TEST
      IF (TEST.LT.0.0) GO TO 310
      TEMP2 = (YINIT-YEYE)/(U(J)-XEYE)
      V(J) = YINIT
      GO TO 320
  300 CONTINUE
      IF (IABS(ITCH).GE.3) GO TO 330
      U(J) = 0.5*(X(I)+X(I-1))
  310 CONTINUE
      V(J) = YEYE + TEMP2*(U(J)-XEYE)
  320 CONTINUE
      IF (XEYE.NE.XINIT) GO TO 330
      IF (IABS(ITCH).EQ.2) GO TO 360
      IF (IABS(ITCH).NE.6) GO TO 330
      IF (J.LE.2) GO TO 380
      GO TO 390
  330 CONTINUE
C RECOMPUTATION OF KNOT FOR CONTINUITY
      IF (J.LE.2) GO TO 370
      IF (SLOPE.EQ.TEMP2) GO TO 360
      YINIT = V(J-2)
      IF (IABS(ITCH).LT.3) YINIT = W(J-2)
      TEMP1 = (XEYE*TEMP2-U(J-2)*SLOPE+YINIT-YEYE)/(TEMP2-SLOPE)
      IF (IABS(ITCH).GE.3) GO TO 350
      IF (TEMP1.GT.XINIT) GO TO 360
      TEST = ABS(EPSLN)
      IDIOT = INIT - KP
      DO 340 L=1,IDIOT
        IT = INIT - L
        IF (TEMP1.GE.X(IT)) GO TO 350
        DX = Y(IT) - YEYE - TEMP2*(X(IT)-XEYE)
        IF (ITCH.LT.0) TEST = E(IT)
        IF (ABS(DX).GT.TEST) GO TO 360
  340 CONTINUE
  350 CONTINUE
      U(J-1) = TEMP1
      V(J-1) = YEYE + TEMP2*(U(J-1)-XEYE)
      IF (IABS(ITCH).LT.3) W(J-1) = V(J-1)
      GO TO 390
  360 CONTINUE
      W(J-1) = YEYE + TEMP2*(U(J-1)-XEYE)
      GO TO 390
  370 CONTINUE
      IF (IABS(ITCH).LT.3) GO TO 360
  380 CONTINUE
      V(1) = YEYE + TEMP2*(U(1)-XEYE)
  390 CONTINUE
      SLOPE = TEMP2
      KP = KEEP
      IF (I.LT.N) GO TO 20
      IF (X(N).EQ.U(J)) GO TO 400
      IF (IABS(ITCH).LT.3) W(J) = V(J)
      J = J + 1
      U(J) = X(N)
      V(J) = Y(N)
  400 CONTINUE
      IF (J.GE.2 .AND. IABS(ITCH).LT.3) V(1) = W(1)
      K = J - 1
      RETURN
      END

	SUBROUTINE DO_XACT_REGRID( cx_lims, axis, src, msrc, dst, mdst,
     .				   work, icoef, itot )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* call the regridding routine with appropriate work arrays

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* revision 0.0 - 10/97
* V533 *sh* 6/01 - added string regridding support
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* v744 *acm* 11/18 Issue 1238: For XACT regridding call customized routine 
*                  to compute regridding subscripts, coefficients
        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'xcontext.cmn'

* calling argument declarations:
	INTEGER	cx_lims, axis, msrc, mdst, icoef, itot
	REAL	src(*), dst(*), work(itot)

	IF (cx_type(cx_lims) .EQ. ptype_string ) THEN
	   CALL XACT_PTR_REGRID_1_AXIS( cx_lims, axis,
     .			    cx_lo_ss(cx_lims,axis), cx_hi_ss(cx_lims,axis),
     .			    src, msrc, dst, mdst, 
     .			    work(1), work(icoef) )
	ELSE
	   CALL XACT_REGRID_1_AXIS( cx_lims, axis,
     .			    cx_lo_ss(cx_lims,axis), cx_hi_ss(cx_lims,axis),
     .			    src, msrc, dst, mdst, 
     .			    work(1), work(icoef) )
	ENDIF

	RETURN
	END

	SUBROUTINE ALL_1_ARG_EXPR

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* treat all the arguments identified by PARSE_COMMAND as a single argument

* This routine is a clone of ALL_1_ARG, but altered so that if there are
* overall surrounding quotation marks, they *are* passed on, so
*	yes? LIST "myvar"
* is seen as the string "myvar", rather than the value of the variable myvar

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V694: 2/2/2015

* calling argument declarations:

        IMPLICIT NONE
* internal variable declarations:
	INTEGER i

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xprog_state.cmn'

* reset the command common to look like a single big argument
* unlike ALL_1_ARG, do this even if there is only a single arg
	IF (num_args .EQ. 0) RETURN

	arg_end(1) = arg_end(num_args)
	num_args = 1

* protect against lost " from start 
	i = arg_start(1) - 1
	IF ( cmnd_buff(i:i) .EQ. '"' ) arg_start(1) = i

* protect against lost " from end
	i = arg_end(1) + 1
	IF ( i .LE. len_cmnd ) THEN
	   IF ( cmnd_buff(i:i) .EQ. '"' ) arg_end(1) = i
	ENDIF

* protect against lost _DQ_ from start
	i = arg_start(1) - 4
	IF (i .GE. 1) THEN
	   IF ( cmnd_buff(i:i+3) .EQ. '_DQ_' ) arg_start(1) = i
	ENDIF

* protect against lost _DQ_ from end
	i = arg_end(1) + 4
	IF ( i .LE. len_cmnd ) THEN
	   IF ( cmnd_buff(i-3:i) .EQ. '_DQ_' ) arg_end(1) = i
	ENDIF

	RETURN
	END

	SUBROUTINE GCF_GET_ARG_LIMS (gcfcn, arg, cx_arg, res_grd,
     .				     lo_off,  hi_off, action, status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Return guidance for the passing of context information between 
* argument "arg" and the result (downstream) or default (upstream) context.
* This guidance is determined primarily from the user-specified parameters of
* the GC function (as returned by GCF_GET_ARG_PARMS), but we also watch
* here for the possibility that a dynamically imposed
* axis of the result might happen to match the axis of argument "arg".
* If so, we do pass the context information (normally no context information
* is passed for imposed axes).

* For example, in
*	LET a = RESHAPE( temp4d, out_grid )
* the result grid may share no axes in common with temp4d or (as is commonly
* the case) the result grid may differ in T and Z but match in X and Y. If
* this is the case then we do want to pass context information both upstream
* and down between the result and temp4d (just as if the axis parameter of
* the GC function  had been pgc_axis_implied_by_args and the "arg" had been
* gfcn_axis_implied_from = .TRUE. Concrete examples are
*	LIST a[x=180:160w,y=0:10n,l=1:100]
* which should pass the XY limits upstream from "a" to "temp4d" when component
* data is requested by IS_ALGEBRA. And
*	LET a2 = RESHAPE( temp4d[x=180:160w,y=0:10n], out_grid )
*	LIST a2[l=1:100]
* which should pass the XY limits of "temp4d" downstream to the result "a".

* V450: 2/97
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'grid_chg_fcns.parm'
	include 'xgrid_chg_fcns.cmn'
	include 'xfr_grid.cmn'       ! w/ mgrid_abstract
	include 'xtext_info.cmn'

* calling argument declarations
	INTEGER	gcfcn, arg, cx_arg, res_grd,
     .		lo_off(*),  hi_off(*), action(*), status

* internal variable declarations
	LOGICAL implied_lims(nferdims)
	INTEGER	CGRID_AXIS, TM_LENSTR1,
     .		idim, res_ax, axis_source(nferdims), nlen, mabstract
	CHARACTER GCF_NAME*40, name*40

* get the axis number for the abstract axis
	mabstract = grid_line( x_dim, mgrid_abstract )

* get the constant parameters for the GC function

c	CALL GCF_GET_AXIS_SRCS( gcfcn, 1, axis_source )
	CALL GCF_GET_AXIS_SRCS( gcfcn, arg, axis_source )

* get the constant parameters for this argument of the function
	CALL GCF_GET_ARG_PARMS
     .			(gcfcn, arg, lo_off,  hi_off, implied_lims)

* loop through the axes
	DO 500 idim = 1,nferdims

	   res_ax  = grid_line(idim,res_grd)

	   IF (    axis_source(idim).EQ.pgc_ignore_axis) THEN
	      action(idim) = pset_to_unspec
	   ELSEIF (axis_source(idim).EQ.pgc_impose_axis) THEN

	      IF ( res_ax.EQ.mnormal
     .	      .OR. res_ax.EQ.mabstract ) THEN
	         action(idim) = pset_to_unspec

* ... We have a pgc_axis_supplied_herein axis (special axis imposed by the fcn)
	      ELSE

*     If the axis of the arg and the result don't match, don't pass context
	         IF ( res_ax .NE. CGRID_AXIS(idim,cx_arg) ) THEN
	            action(idim) = pset_to_unspec

	         ELSEIF ( implied_lims(idim) ) THEN
	            action(idim) = ppass_along

	         ELSE
	            action(idim) = pset_to_unspec

	         ENDIF
	      ENDIF

	   ELSEIF ( axis_source(idim).EQ.pgc_merge_axis) THEN
	      action(idim) = ppass_along

	   ELSE
	      name = GCF_NAME( gcfcn )
	      nlen = TM_LENSTR1( name )
	      CALL ERRMSG( ferr_internal, status,
     .			'function '//name(:nlen)
     .			//' has corrupted specs on axis '
     .			//ww_dim_name(idim), *5000 )
	   ENDIF

 500	CONTINUE

	RETURN

* error exits
 5000	RETURN
	END

	SUBROUTINE SHOW_DATA_SET_PARAMS( lun, dset )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* describe the diagnostic parameters of the given data set

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 -  1/10/89 - based on SHOW_DATA_SET 0.2
* Unix/RISC port 3/91 *sh* - cannot use function in WRITE list
* V320: 12/29/94 - use SPLIT_LIST to redirect tty output for GUI
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
* V698  3/16 *acm* Removed Philander-Seigel code including diagnostic variables, 
*                  pre-defined axes and grids, cat_calc_var. 
*                  All that's left here is a possible dset title.

	include 'tmap_dims.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include	'ferret.parm'
	include	'xrisc.cmn'

* calling argument declarations:
	INTEGER	lun, dset

* local variable declarations:
	INTEGER 	TM_LENSTR1

* data set title (and possible modifier)
	CALL SPLIT_LIST(pttmode_explct, lun,
     .		'     '//ds_title(dset)(:TM_LENSTR1(ds_title(dset)))
     .								,0)
	IF ( ds_mod_title(dset) .NE. ' ' ) CALL SPLIT_LIST
     .		(pttmode_explct, lun,
     .	'     '//ds_mod_title(dset)(:TM_LENSTR1(ds_mod_title(dset)))
     .								,0)

	RETURN
	END

*
* appende.F
*
* This function creates a new variable which is the first variable
* with the second variable appended on the ensemble axis.
*


*
* In this subroutine we provide information about
* the function.  The user configurable information
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
*
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result
*


      SUBROUTINE appende_init(id)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg



* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .        'appends VAR to ENS along the ensemble axis')
      CALL ef_set_num_args(id, 2)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                CUSTOM,          IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'ENS')
      CALL ef_set_arg_desc(id, arg, 'Initial variable')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, NO, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'VAR')
      CALL ef_set_arg_desc(id, arg, 'Variable to append')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, NO, YES)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we provide information about the custom axis.
*

      SUBROUTINE appende_custom_axes(id)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      REAL my_lo, my_hi, my_delta
      CHARACTER*20 my_units

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      IF ( (arg_lo_ss(E_AXIS,ARG1) .EQ. ef_unspecified_int4) .AND.
     .     (arg_hi_ss(E_AXIS,ARG1) .EQ. ef_unspecified_int4) ) THEN
         my_lo = 1.0
         my_hi = 1.0
      ELSE
         my_lo = arg_lo_ss(E_AXIS,ARG1)
         my_hi = arg_hi_ss(E_AXIS,ARG1)
      ENDIF
      my_hi = my_hi + 
     .        arg_hi_ss(E_AXIS,ARG2) - arg_lo_ss(E_AXIS,ARG2) + 1.0
      my_delta = 1.0
      my_units = ' '

      CALL ef_set_custom_axis(id, E_AXIS, my_lo, my_hi,
     .                        my_delta, my_units, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE appende_compute(id, arg_1, arg_2, result)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable's axes.

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,  j,  k,  l,  m,  n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*     Initialize everything to undefined so nothing is missed
      DO 10 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
      DO 10 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
      DO 10 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
      DO 10 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
      DO 10 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
      DO 10 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
         result(i,j,k,l,m,n) = bad_flag_result
  10  CONTINUE

*     Start by copying the first variable
*     (Ensemble axis must be outer-most loop)
      m = res_lo_ss(E_AXIS)
      DO 510 m1 = arg_lo_ss(E_AXIS,ARG1), arg_hi_ss(E_AXIS,ARG1)

         n1 = arg_lo_ss(F_AXIS,ARG1)
         DO 610 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

         l1 = arg_lo_ss(T_AXIS,ARG1)
         DO 410 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         k1 = arg_lo_ss(Z_AXIS,ARG1)
         DO 310 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 210 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

         i1 = arg_lo_ss(X_AXIS,ARG1)
         DO 110 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

            IF ( arg_1(i1,j1,k1,l1,m1,n1) .NE. bad_flag(ARG1) ) THEN

               result(i,j,k,l,m,n) = arg_1(i1,j1,k1,l1,m1,n1)

            END IF

            i1 = i1 + arg_incr(X_AXIS,ARG1)
 110     CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 210     CONTINUE

            k1 = k1 + arg_incr(Z_AXIS,ARG1)
 310     CONTINUE

            l1 = l1 + arg_incr(T_AXIS,ARG1)
 410     CONTINUE

            n1 = n1 + arg_incr(F_AXIS,ARG1)
 610     CONTINUE

         m = m + 1
 510  CONTINUE

*     Now copy the second variable starting on the ensemble axis
*     where the first variable left off (value of m not reset)

      DO 520 m2 = arg_lo_ss(E_AXIS,ARG2), arg_hi_ss(E_AXIS,ARG2)

         n2 = arg_lo_ss(F_AXIS,ARG2)
         DO 620 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

         l2 = arg_lo_ss(T_AXIS,ARG2)
         DO 420 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         k2 = arg_lo_ss(Z_AXIS,ARG2)
         DO 320 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

         j2 = arg_lo_ss(Y_AXIS,ARG2)
         DO 220 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

         i2 = arg_lo_ss(X_AXIS,ARG2)
         DO 120 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

            IF ( arg_2(i2,j2,k2,l2,m2,n2) .NE. bad_flag(ARG2) ) THEN

               result(i,j,k,l,m,n) = arg_2(i2,j2,k2,l2,m2,n2)

            END IF

            i2 = i2 + arg_incr(X_AXIS,ARG2)
 120     CONTINUE

            j2 = j2 + arg_incr(Y_AXIS,ARG2)
 220     CONTINUE

            k2 = k2 + arg_incr(Z_AXIS,ARG2)
 320     CONTINUE

            l2 = l2 + arg_incr(T_AXIS,ARG2)
 420     CONTINUE

            n2 = n2 + arg_incr(F_AXIS,ARG2)
 620     CONTINUE

         m = m + 1
 520  CONTINUE

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END

        SUBROUTINE CD_DSG_SETUP_PTDATA(dset, npts, stored_lm, stored_lm1, status)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*.
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Set up a synthesized DSG rowsize variable from a Point netCDF dataset
* RowSize of length npts with all values 1

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - SDIG
* V76  *acm* 3/20 obs-axis for DSG point data does not need memory allocation

* argument definitions:
*       npts      - number of values to put into variable
*       idim      - orientation of the coordinate (pdsg_row_size for rowSize)
*       stored_lm - dynamic memory line number of the instance variable created 
*       status    - return status

* include files
        include 'tmap_errors.parm'
        include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
        include 'xdset_info.cmn_text'
        external xdset_info_data
        include 'xdyn_linemem.cmn_text'
        include 'xtm_grid.cmn_text'
        include 'xunits.cmn_text'

* argument declarations
        INTEGER  dset, ivcd, npts, stored_lm, stored_lm1, status

* local variable declarations:
        INTEGER iaxis
        REAL    coord

* local parameter declaration
        INTEGER		i
        INTEGER*8	rqst_n
	CHARACTER	axname*9

* allocate memory for the synthesized Rowsize variable
        rqst_n = npts
        CALL TM_GET_LM_DYNMEM(rqst_n, stored_lm, status)
        IF (status .NE. merr_ok) GOTO 5000

        coord = 1.
	DO i = 1, npts
           CALL PUT_LINE_COORD ( dsg_linemem(stored_lm)%ptr, i, coord )   
	ENDDO

* *** create the instance (E) axis for the dataset
        axname = "features"
        iaxis = 0
        CALL TM_MAKE_BASIC_AXIS( axname, 1.0D0, 1.0D0, npts,
     .				    iaxis, status )
        IF ( status .NE. merr_ok ) GOTO 5000
        line_direction(iaxis) = axis_orients(E_dim)
        line_units(iaxis)    = un_name(pun_instance)
* ... save this axis to be used during grid creation
        dsg_instance_axis = iaxis

* flag that this is a DSG axis
	line_dsg_dset(iaxis) = dset

* *** create the nominal obs (X) axis for the dataset
        axname = "ferObs"
        iaxis = 0
        CALL TM_MAKE_BASIC_AXIS( axname, 1.0D0, 1.0D0, npts,
     .				    iaxis, status )
        IF ( status .NE. merr_ok ) GOTO 5000
        line_direction(iaxis) = axis_orients(X_dim)
        line_units(iaxis)    = 'count'
* ... save this axis to be used during grid creation
        dsg_obs_axis = iaxis

* flag that this is a DSG axis
	line_dsg_dset(iaxis) = dset


* successful completion
        RETURN

* error exit
 5000   RETURN

        END

	SUBROUTINE XY_HDIFFUS ( tk, mtk, xy_qdiffus, mxy_qdiffus )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute diffussion of heat in horizontal plane at the specified depth
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/7/86	extracted from SUBROUTINE qdiffus
*			with major modifications to convert i-k oriented
*			calculations to i-j oriented calculations
* V200:  7/26/89 - 4D symmetrical version
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN

#ifdef unix
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl.parm'		! parameter definitions
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xonedim.cmn'	! geometric constants
	include 'xcontext.cmn'
#else
	INCLUDE 'FERRET_CMN:FERRET.PARM'
	INCLUDE 'FERRET_CMN:GFDL.PARM'		! parameter definitions
	INCLUDE	'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE	'FERRET_CMN:XMEM_SUBSC.CMN'
	INCLUDE 'FERRET_CMN:XONEDIM.CMN'	! geometric constants
	INCLUDE 'FERRET_CMN:XCONTEXT.CMN'
#endif

* calling argument declarations:
	INTEGER	mtk, mxy_qdiffus
* subscript ranges from memory variable table ...
	REAL            tk( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit ),
     .		xy_qdiffus( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,m2lot:m2hit )

* internal variable declarations:
	LOGICAL HOURLY_DATA
	INTEGER	i, j, k, l, dl, lp1
	REAL	bad_tk, bad_qdiffus, cctj, ddtj, ew_qdiffus, sn_qdiffus

* --- end of introductory code ---
* use 1 hour separation for exact results on hourly data
	IF ( HOURLY_DATA(mr_grid(mxy_qdiffus)) ) THEN
	   dl = 1
	ELSE
	   dl = 0
	ENDIF

* flag for bad/missing data
	bad_tk      = mr_bad_data( mtk )
	bad_qdiffus = mr_bad_data( mxy_qdiffus )

	DO 2000 l = mr_lo_s4(mxy_qdiffus)-dl, mr_hi_s4(mxy_qdiffus)-dl
	   lp1 = l + dl
	DO 2000 k = mr_lo_s3(mxy_qdiffus), mr_hi_s3(mxy_qdiffus)

	DO 1000 j = mr_lo_s2(mxy_qdiffus), mr_hi_s2(mxy_qdiffus)

	IF ( j .EQ. 1  .OR.  j .EQ. jmt ) THEN
	   DO 100 i = mr_lo_s1(mxy_qdiffus), mr_hi_s1(mxy_qdiffus)
 100	   xy_qdiffus( i,j,k,lp1 ) = bad_qdiffus
	   GOTO 1000
	ENDIF

C   FORM LATERAL DIFFUSION COEFFICIENTS					! 3045
C     VARIABLE HORIZONTAL DIFFUSION					! 3047
      CCTJ=AH*CS(j)*DYUR(j)*DYTR(j)*CSTR(j)*XJV(j)		! 3049 mod (j)
      DDTJ=AH*CS(j-1)*DYUR(j-1)*DYTR(j)*CSTR(j)*XJV(j-1)	! 3050 mod (j)

	DO 900 i = mr_lo_s1(mxy_qdiffus), mr_hi_s1(mxy_qdiffus)	! 3051 mod

	IF ( i .EQ. 1  .OR.  i .EQ. imt ) THEN
	   xy_qdiffus( i,j,k,lp1 ) = bad_qdiffus
	   GOTO 900
	ENDIF

	IF (	tk( i  ,j   ,k,l ) .EQ. bad_tk
     .	   .OR. tk( i+1,j   ,k,l ) .EQ. bad_tk
     .	   .OR. tk( i-1,j   ,k,l ) .EQ. bad_tk
     .	   .OR. tk( i  ,j+1 ,k,l ) .EQ. bad_tk
     .	   .OR. tk( i  ,j-1 ,k,l ) .EQ. bad_tk ) THEN
	   xy_qdiffus( i,j,k,lp1 ) = bad_qdiffus
	   GOTO 900
	ENDIF

      AATJ(I)=AH*DXUR(I)*DXTR(I)*CSTR(j)*CSTR(j)*XIV(I)*XJT(j)	  ! 3052 mod (j)
      BBTJ(I)=AH*DXUR(I-1)*DXTR(I)*CSTR(j)*CSTR(j)*XIV(I-1)*XJT(j)! 3053 mod (j)
  731 CONTINUE								! 3056

C   ADD IN DIFFUSION TERMS						! 3086
C									! 3087
* compute east-west diffussion
	ew_qdiffus = cmonthly * (
     * aatj(I)*(tk(I+1,j,k,l)-tk(i,j,k,l))			! 3092 mod
     *+bbtj(I)*(tk(I-1,j,k,l)-tk(i,j,k,l)) )			! 3093 mod
	xy_qdiffus(i,j,k,lp1) = ew_qdiffus

* compute south-north diffussion
	sn_qdiffus = cmonthly * (
     * cctj*xit(i)*(tk(i,j+1,k,l)-tk(i,j,k,l))				! 3102 mod
     *+ddtj*xit(i)*(tk(i,j-1,k,l)-tk(i,j,k,l))	)			! 3103 mod
	 xy_qdiffus(i,j,k,lp1) = xy_qdiffus(i,j,k,lp1) + sn_qdiffus

 900	CONTINUE
 1000	CONTINUE
 2000	CONTINUE

	RETURN
	END

	SUBROUTINE TM_re_allo_tmp_grid( grid )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* The input grid is currently stored in the tmp linked list.
*This routine shifts it to the dynamic grid list.

* Steve Hankin  NOAA/PMEL/TMAP

* V510 *sh* 3/00
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* Include files
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'tmap_errors.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xio.cmn_text'

* Argument definitions
	INTEGER grid

* Local definitions
	INTEGER next_used_grid,  next_free_grid 

* it is not necessary to do this in 2 stages, but it was simpler --
* just hacked from well-tested code

* take this grid from the "tmp" list and put it on the "free" list
* ... hook onto free list
	   next_used_grid   = grid_flink(grid)
	   grid_flink(grid) = grid_free_ptr  
	   grid_free_ptr    = grid
	   
* ... unhook from used list
	   grid_flink(grid_blink(grid)) = next_used_grid
	   grid_blink(next_used_grid)   = grid_blink(grid)

* take off the "free" list and put it at the start of the "used" list
* ... unhook from free list
	   next_free_grid  	= grid_flink(grid)
	   grid_free_ptr	= next_free_grid
* ... hook onto front of used list
	   grid_flink(grid)	 = grid_flink(max_grids)
	   grid_blink(grid)	 = max_grids
	   grid_flink(max_grids) = grid
	   grid_blink(grid_flink(grid))	= grid

	RETURN
	END

	INTEGER FUNCTION DO_INTERPOLATE( axis, arg,
     .					 com, com_mr, com_cx,
     .					 res, res_mr, res_cx,
     .					 work	)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* interpolate the component grid along the given axis
* note: if requested interpolation lies beyond the first or last grid point
*	(but within the edge grid box) then the component context will be
*	only that single edge point (ss_lo=ss_hi).  The code below will
*	extrapolate the end value to the box edge.

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  6/1/89
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include	'xprog_state.cmn'

* calling argument declarations:
	INTEGER	axis, com_mr, com_cx, res_mr, res_cx
	REAL	arg, work(*),
     .          com( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          res( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif )

* internal variable declarations:
	INTEGER i, j, k, l, m, n, ss, ss_lo, ss_hi
	REAL	bad, delta, c_lo, c_hi, z_lo, z_hi
	REAL*8	TM_WORLD, ww, ww_lo, ww_hi

* diagnostic mode output: " doing --> VAR_NAME[x=lo:hi@TRN:n,D=#]"
	IF ( mode_diagnostic ) 	CALL DIAG_OP
     .				( 'doing', isact_class_trans, res_cx, axis )

* flags for bad/missing data
        bad = mr_bad_data(res_mr)

* bits and pieces for interpolation
	ss    = cx_lo_ss(res_cx,axis)
	ww    = cx_lo_ww(axis,res_cx)
	ss_lo = cx_lo_ss(com_cx,axis)
	ss_hi = cx_hi_ss(com_cx,axis)
	ww_lo = TM_WORLD( ss_lo, cx_grid(com_cx), axis, box_middle )
	ww_hi = TM_WORLD( ss_hi, cx_grid(com_cx), axis, box_middle )
	delta = ww_hi - ww_lo
	IF ( delta .EQ. 0.0 ) THEN
* ... extrapolate last grid point towards end box edge
	   c_lo = 1.0
	   c_hi = 0.0
	ELSE
* ... normal interpolation
	   c_lo    = REAL(ww_hi - ww) / delta
	   c_hi    = 1.0 - c_lo
	ENDIF

*       I N T E R P O L A T E
* ( separate loops for each axis )
	IF ( axis .EQ. x_dim ) THEN

	   DO 100 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 100 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 100 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 100 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 100 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)

* source data points
	      z_lo = com(ss_lo,j,k,l,m,n)
	      z_hi = com(ss_hi,j,k,l,m,n)

* interpolate
	      IF (z_lo .EQ. bad .OR. z_hi .EQ. bad ) THEN
	         res(ss,j,k,l,m,n) = bad
	      ELSE
	         res(ss,j,k,l,m,n) = c_lo*z_lo + c_hi*z_hi
	      ENDIF

 100	   CONTINUE

	ELSEIF ( axis .EQ. y_dim ) THEN

	   DO 200 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 200 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 200 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 200 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 200 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)

* source data points
	      z_lo = com(i,ss_lo,k,l,m,n)
	      z_hi = com(i,ss_hi,k,l,m,n)

* interpolate
	      IF (z_lo .EQ. bad .OR. z_hi .EQ. bad ) THEN
	         res(i,ss,k,l,m,n) = bad
	      ELSE
	         res(i,ss,k,l,m,n) = c_lo*z_lo + c_hi*z_hi
	      ENDIF

 200	   CONTINUE

	ELSEIF ( axis .EQ. z_dim ) THEN

	   DO 300 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 300 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 300 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 300 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 300 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)

* source data points
	      z_lo = com(i,j,ss_lo,l,m,n)
	      z_hi = com(i,j,ss_hi,l,m,n)

* interpolate
	      IF (z_lo .EQ. bad .OR. z_hi .EQ. bad ) THEN
	         res(i,j,ss,l,m,n) = bad
	      ELSE
	         res(i,j,ss,l,m,n) = c_lo*z_lo + c_hi*z_hi
	      ENDIF

 300	   CONTINUE

	ELSEIF ( axis .EQ. t_dim ) THEN

	   DO 400 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 400 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 400 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 400 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 400 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)

* source data points
	      z_lo = com(i,j,k,ss_lo,m,n)
	      z_hi = com(i,j,k,ss_hi,m,n)

* interpolate
	      IF (z_lo .EQ. bad .OR. z_hi .EQ. bad ) THEN
	         res(i,j,k,ss,m,n) = bad
	      ELSE
	         res(i,j,k,ss,m,n) = c_lo*z_lo + c_hi*z_hi
	      ENDIF

 400	   CONTINUE

	ELSEIF ( axis .EQ. e_dim ) THEN

	   DO 500 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 500 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 500 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 500 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 500 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)

* source data points
	      z_lo = com(i,j,k,l,ss_lo,n)
	      z_hi = com(i,j,k,l,ss_hi,n)

* interpolate
	      IF (z_lo .EQ. bad .OR. z_hi .EQ. bad ) THEN
	         res(i,j,k,l,ss,n) = bad
	      ELSE
	         res(i,j,k,l,ss,n) = c_lo*z_lo + c_hi*z_hi
	      ENDIF

 500	   CONTINUE

	ELSEIF ( axis .EQ. f_dim ) THEN

	   DO 600 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 600 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 600 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 600 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 600 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)

* source data points
	      z_lo = com(i,j,k,l,m,ss_lo)
	      z_hi = com(i,j,k,l,m,ss_hi)

* interpolate
	      IF (z_lo .EQ. bad .OR. z_hi .EQ. bad ) THEN
	         res(i,j,k,l,m,ss) = bad
	      ELSE
	         res(i,j,k,l,m,ss) = c_lo*z_lo + c_hi*z_hi
	      ENDIF

 600	   CONTINUE

	ENDIF

	DO_INTERPOLATE = ferr_ok

	RETURN
	END

	SUBROUTINE XACT_REGRID_1_AXIS(	cx_lims, axis, dst_lo, dst_hi,
     .					src, msrc, dst, mdst,
     .					ss12, coef )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*       Regrid from the source to the destination grid using an algorithm
*       of inserting values into the result ONLY when the source grid has
*       a value at exactly the same coordinate on this axis.

* 	msrc and mdst point to data structures in COMMON/XVARIABLES/ which
* 	specify the subscript bounds of src and dst within their respective
* 	grids.

* 	Both src and dst are assumed to be 4 dimensional structures
*	with regridding needed along axis "axis"

*	ss12 holds the indices of grid nodes on src_grd for which there 
*       is an exact match on dst_grd ... or unspecified_int4 if no match

* note that (for convenience) this routine reuses code from LIN_REGRID_1_AXIS
* using the values of the linear coefficients computed as the test of whether
* the source and destination grids have an exact match

* NOAA/PMEL,Seattle,WA - Tropical Modeling and Analysis Program

* V500: 10/97

* v570 *acm* 5/04 Range of subscripts might be negative, and contain 
*                 -111 among them. Allow regridding, using the flag 
*                 ok_neg111 to distinguish this case from the flag 
*                 unspecified_int4.
* v580 *acm* 11/04 Fix the definition of ok_neg111; if -111 is at
*                  either end of the interval we cannot distinguish
*                  it as a valid index from its use as the bad flag.
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xcontext.cmn'


* CALLING ARGUMENT DECLARATIONS:
	INTEGER	cx_lims, axis, dst_lo, dst_hi, msrc, mdst
	INTEGER ss12( dst_lo:dst_hi )
	REAL    src( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          dst( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif ),
     .          coef( dst_lo:dst_hi )

* INTERNAL VARIABLE DECLARATIONS:
	LOGICAL	TM_FPEQ_SNGL, TM_DFPEQ_TOL, ok_neg111
	INTEGER i, j, k, l, m, n,
     .		ss, src_lo, src_hi, src_grd, dst_grd, was
	REAL	bad_src, bad_dst
	REAL*4  singlec, singlez, single1

******************************************************************************

* LIMITS FOR CALCULATION
        src_lo = mr_lo_ss(msrc,axis)
        src_hi = mr_hi_ss(msrc,axis)

* FLAG FOR BAD/MISSING DATA
        bad_src = mr_bad_data(msrc)
        bad_dst = mr_bad_data(mdst)

* source and destination grids
	src_grd = mr_grid( msrc )
	dst_grd = mr_grid( mdst )

* single-precision comparison with zero and 1.
	singlez = 0.0  
	single1 = 1.0  

* DETERMINE src_grd INDEX OF exact matches on the dst_grd axis
	CALL GET_LINEAR_COEF(	src_lo, src_hi, src_grd,
     .				dst_lo, dst_hi, dst_grd,
     .				axis, ss12, coef )
	DO 10 i = dst_lo, dst_hi
	   singlec = coef(i)
	   was = ss12(i)
	   IF ( .NOT.TM_FPEQ_SNGL(singlec,singlez) ) 
     .				ss12(i) = unspecified_int4
	   IF (  TM_FPEQ_SNGL(singlec,single1) ) 
     .				ss12(i) = was
 10	CONTINUE

* Range of subscripts might be negative, and contain -111 among them.
* ok_neg111 distinguishes between this and the flag unspecified_int4.

        ok_neg111 = (ss12(dst_lo) .LT. unspecified_int4 .AND.
     .               ss12(dst_hi) .GT. unspecified_int4) .OR.
     .              (ss12(dst_lo) .GT. unspecified_int4 .AND.
     .               ss12(dst_hi) .LT. unspecified_int4) 

* transfer THE map-able DATA TO dst_grd
	IF ( axis .EQ. x_dim ) THEN
	   DO 110 i = dst_lo, dst_hi

	      ss = ss12(i)

	      IF ( ss .NE. unspecified_int4 .OR. 
     .             ss .EQ. unspecified_int4 .AND. ok_neg111) THEN
	         DO 100 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	         DO 100 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	         DO 100 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	         DO 100 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	         DO 100 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
 100	         dst(i,j,k,l,m,n) = src(ss,j,k,l,m,n)
	      ELSE
	         DO 102 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	         DO 102 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	         DO 102 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	         DO 102 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	         DO 102 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
 102		 dst(i,j,k,l,m,n) = bad_dst
	      ENDIF

 110	   CONTINUE

	ELSEIF ( axis .EQ. y_dim ) THEN
	   DO 210 j = dst_lo, dst_hi

	      ss = ss12(j)

	      IF ( ss .NE. unspecified_int4 .OR. 
     .             ss .EQ. unspecified_int4 .AND. ok_neg111) THEN
	         DO 200 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	         DO 200 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	         DO 200 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	         DO 200 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	         DO 200 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
 200	         dst(i,j,k,l,m,n) = src(i,ss,k,l,m,n)
	      ELSE
	         DO 202 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	         DO 202 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	         DO 202 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	         DO 202 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	         DO 202 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
 202		 dst(i,j,k,l,m,n) = bad_dst
	      ENDIF

 210	   CONTINUE

	ELSEIF ( axis .EQ. z_dim ) THEN
	   DO 310 k = dst_lo, dst_hi

	      ss = ss12(k)

	      IF ( ss .NE. unspecified_int4 .OR. 
     .             ss .EQ. unspecified_int4 .AND. ok_neg111) THEN
	         DO 300 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	         DO 300 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	         DO 300 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	         DO 300 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
	         DO 300 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
 300	         dst(i,j,k,l,m,n) = src(i,j,ss,l,m,n)
	      ELSE
	         DO 302 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	         DO 302 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	         DO 302 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	         DO 302 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
	         DO 302 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
 302		 dst(i,j,k,l,m,n) = bad_dst
	      ENDIF

 310	   CONTINUE

	ELSEIF ( axis .EQ. t_dim ) THEN
	   DO 410 l = dst_lo, dst_hi

	      ss = ss12(l)

	      IF ( ss .NE. unspecified_int4 .OR. 
     .             ss .EQ. unspecified_int4 .AND. ok_neg111) THEN
	         DO 400 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	         DO 400 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	         DO 400 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	         DO 400 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
	         DO 400 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
 400	         dst(i,j,k,l,m,n) = src(i,j,k,ss,m,n)
	      ELSE
	         DO 402 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	         DO 402 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	         DO 402 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	         DO 402 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
	         DO 402 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
 402		 dst(i,j,k,l,m,n) = bad_dst
	      ENDIF

 410	   CONTINUE


	ELSEIF ( axis .EQ. e_dim ) THEN
	   DO 510 m = dst_lo, dst_hi

	      ss = ss12(m)

	      IF ( ss .NE. unspecified_int4 .OR. 
     .             ss .EQ. unspecified_int4 .AND. ok_neg111) THEN
	         DO 500 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	         DO 500 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	         DO 500 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	         DO 500 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
	         DO 500 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
 500	         dst(i,j,k,l,m,n) = src(i,j,k,l,ss,n)
	      ELSE
	         DO 502 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	         DO 502 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	         DO 502 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	         DO 502 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
	         DO 502 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
 502		 dst(i,j,k,l,m,n) = bad_dst
	      ENDIF

 510	   CONTINUE


	ELSEIF ( axis .EQ. f_dim ) THEN
	   DO 610 n = dst_lo, dst_hi

	      ss = ss12(n)

	      IF ( ss .NE. unspecified_int4 .OR. 
     .             ss .EQ. unspecified_int4 .AND. ok_neg111) THEN
	         DO 600 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	         DO 600 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	         DO 600 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	         DO 600 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
	         DO 600 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
 600	         dst(i,j,k,l,m,n) = src(i,j,k,l,m,ss)
	      ELSE
	         DO 602 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	         DO 602 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	         DO 602 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
	         DO 602 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
	         DO 602 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)
 602		 dst(i,j,k,l,m,n) = bad_dst
	      ENDIF

 610	   CONTINUE

	ENDIF

	RETURN
	END

	SUBROUTINE PPL_DASH_RESTORE

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* restore the PLOT+ dash lenghts after they have been changed by PLOT/DASH=

* V541: 3/25  *acm*

        IMPLICIT NONE
	! variables DN1,DN2,UP1,UP2
        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'lines_inc.decl'
        include 'LINES.INC'
        include 'ppl_dash_save.cmn'

* calling argument declarations

* local variable declarations:
	INTEGER line_number

* For dash lines set up by /DASH=  reset to previous settings which
* may be from a PPL LINE command and so should persist.

      IF (linenum_save .GT. 0) THEN
         DO 100 line_number = 1, linenum_save

            dash_changed(line_number) = .FALSE.
            dn1(line_number) = dashsave(line_number,1)
            up1(line_number) = dashsave(line_number,2)
            dn2(line_number) = dashsave(line_number,3)
            up2(line_number) = dashsave(line_number,4) 
  100    CONTINUE

         dashsave(line_number,1) = 0.
         dashsave(line_number,2) = 0.
         dashsave(line_number,3) = 0.
         dashsave(line_number,4) = 0.

      linenum_save = 0
      ENDIF

      RETURN
      END

	SUBROUTINE GETCMD(LINE,ILEN,COM,X,IF,M,LABEL,N,LBSTRT)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)getcmd.F	1.2    5/26/88
C**
C**
C***********************************************************************
C**
C**		    PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C**	Subprogram called:
C**		CALL GETCMD(LINE,ILEN,COM,X,IF,M,LABEL,N,LBSTRT)
C**
C**	Parameters:
C**		LINE -- Line from command input file (char*2048)
C**		ILEN -- Length of LINE
C**		COM -- Command value parsed  (char*120)
C**		X -- Numerical array
C**		IF -- Flag array
C**		M -- Length of numerical and flag array
C**		LABEL -- Label part of the command line  (char*2048)
C**		N -- Length of LABEL
C**		LBSTRT -- Start position of LABEL
C**
C**	Description:
C**		Gets the next command from the command input, echos the
C**		input line.  Substitutes the symbols found and parses
C**		the resultant string.  Some of the system commands are
C**		also executed within this routine.  They are SET, SHOW,
C**		LIST, IF, ELSE, ENDIF, WHILE, ENDW, @.  Any other
C**		commands are parsed further and the values of X and
C**		LABEL to the calling routine.
C**
C**	History:
C**	    Written: 
C**		22-DEC-85	by Donald W. Denbo
C**	    Modified:
C**		30-MAY-86	by Donald W. Denbo
C**		  Adds the call to PARSEX, thus enabling the parsing
C**		  of numerical values.  LIST command changed to LISTSYM.
C**		15-JUN-86	by Donald W. Denbo
C**		  Changes made to support memory buffer added
C**		 6-SEP-86	by Donald W. Denbo
C**		  Changes made to support IF ... ELSE ... ENDIF
C**		      and made to support WHILE ... ENDW
C**
C**
C     *JD* 8.2.91 Mod to support brain dead PPL -- no @ usage
* v552 *acm* 3/03 Longer strings: changes for multi-line labels

* v580 *acm* 8/04 Change use of 256 to buflen+1, 
*                 where buflen is defined in cmndlen.inc
* v685 *acm* 1/13 Fix ticket 1298. If a label comes in containing single
*                 quotes, just pass that on. It's not a symbol translation.
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long

        logical         tmapdebug
        common/tmdebug/ tmapdebug

	INCLUDE 'CMDCOM.INC'
	INCLUDE 'SYSTEM.INC'
	INCLUDE 'SWITCH.INC'
	INCLUDE 'LUNITS.INC'
        INCLUDE 'cmndlen.inc'

	CHARACTER COM*(*),LABEL*(*),LINE*(*),SYM*120,VALUE*2048,FILE*80
	CHARACTER ICOM*2048
	LOGICAL RESULT,NUM,islab
	DIMENSION X(*),IF(*)
	INTEGER LBSTRT,WHCNT
	integer*4 status,iflag

C
C	GET NEXT COMMAND LINE
C
	DONEF=.FALSE.
1000	IF(MEMBUF)THEN
	    IF(MBUFF.GT.BUFSZE)THEN
		DONEF=.TRUE.
		RETURN
	    ENDIF
	    LINE=CMDBUF(MBUFF)
	    MBUFF=MBUFF+1
	    ILEN=LNBLK(LINE,2048)
	ELSE
	    CALL GETLIN(LINE,ILEN)
	ENDIF
	IF(.NOT.TERMF.AND.LOGCMF)WRITE(LTTOUT,999)LINE(:ILEN)
999	FORMAT(1X,A)
	IF(DONEF)RETURN
	IF(ECHOF.AND..NOT.DEBUGF)CALL ECHO(LINE,ILEN)

	CALL SYMSUB(LINE,ILEN,IER,SYM,IPOS)
	IF(DEBUGF)CALL ECHO(LINE,ILEN)
	CALL CMLJST(LINE,ILEN)
	CALL PARSE(LINE,ILEN,ICOM,LABEL,N,LBSTRT)
	islab = (ICOM.EQ.'%LABEL') .OR. (icom.EQ.'TITLE') .OR.
     .          (ICOM.EQ.'XLAB') .OR. (icom.EQ.'YLAB')
	IF((IER.NE.0).AND..NOT.(SKIPIF.OR.SKIPWH.OR.islab))THEN
	    CALL CMDERR(IER,LINE,ILEN,IPOS)
	    GOTO 1000
	ENDIF
C
C	CHECK FOR ELSE AND ENDIF // IF SKIPIF IS TRUE
C
	IF(SKIPIF)THEN
	    IF(ICOM.EQ.'IF')THEN
		IFCNT=IFCNT+1
	    ELSE IF(ICOM.EQ.'ELSE'.AND.IFCNT.EQ.0)THEN
		SKIPIF=.FALSE.
	    ELSE IF(ICOM.EQ.'ENDIF')THEN
		IF(IFCNT.EQ.0)THEN
		    SKIPIF=.FALSE.
		    IFLEV=IFLEV-1
		ELSE
		    IFCNT=IFCNT-1
		ENDIF
	    ENDIF
	    GOTO 1000
	ENDIF
	IF(SKIPWH)THEN
	    IF(ICOM.EQ.'WHILE')THEN
		WHCNT = WHCNT + 1
	    ELSE IF(ICOM.EQ.'ENDW')THEN
		IF(WHCNT.EQ.0)THEN
		    SKIPWH=.FALSE.
		    WHLEV=WHLEV-1
		ELSE
		    WHCNT=WHCNT-1
		ENDIF
	    ENDIF
	    GOTO 1000
	ENDIF
C
C	CHECK FOR QUALIFIERS AND OPTIONALLY LATCH NEW DEFAULTS
C
	CALL GTQUAL(ICOM,ICLEN,IER,IPOS)
	IF(IER.NE.0)THEN
	    CALL CMDERR(IER,LINE,ILEN,IPOS)
	    GOTO 1000
	ENDIF
	IF(SLATCH)THEN
	    SLATCH=.FALSE.
	    DO 200 I=1,NFLAGS
200	    DEFLTS(I)=FLAG(I)
	ENDIF
	COM=ICOM(1:ICLEN)
C
C	TEST FOR LOCAL COMMANDS
C
	IF(COM.EQ.'SHOW')THEN
	    SYM=LABEL(:N)
	    CALL GETSYM(SYM,VALUE,NC,IER)
	    IF(IER.EQ.0)THEN
		IF(.NOT.QUIETF)WRITE(LTTOUT,997)SYM,VALUE(1:NC)
997		FORMAT(1X,A30,' = ',A)
	    ELSE
		CALL CMDERR(IER,LINE,ILEN,LBSTRT)
	    ENDIF
	ELSE IF(COM.EQ.'SET')THEN
	    CALL SETSYM(LABEL,N,IER,IST2)
	    IF(IER.NE.0)THEN
		CALL CMDERR(IER,LINE,ILEN,LBSTRT+IST2)
	    ENDIF
	ELSE IF(COM.EQ.'LISTSYM')THEN
	    ILST=0
100	    CALL LSTSYM(SYM,VALUE,NC,ILST,IER)
	    IF(IER.EQ.0)THEN
		IF(.NOT.QUIETF)WRITE(LTTOUT,986)ILST,SYM,VALUE(1:NC)
986		FORMAT(I5,2X,A30,3X,A)
		GOTO 100
	    ENDIF
	ELSE IF(COM.EQ.'DELETE')THEN
	    SYM=LABEL(:N)
	    CALL DELSYM(SYM,IER)
	    IF(IER.NE.0)THEN
		CALL CMDERR(IER,LINE,ILEN,LBSTRT+IST2)
	    ENDIF
	ELSE IF(COM(1:1).EQ.'@')THEN
C     Brain dead exclusion of @ mod
            if (.not.tmapdebug) then
	       IF(.NOT.QUIETF)WRITE(LTTOUT,'(1X,A)')
     .             'COMMAND NOT SUPPORTED IN THIS VERSION OF PPLUS: @'
               COM = ' '
               RETURN 
            end if
	    ISPC=INDEX(LINE,' ')-1
	    ICMA=INDEX(LINE,',')-1
#ifdef unix
	    ISLSH=INDEX(LINE,':')-1
#else
	    islsh=index(line,'/')-1
#endif
	    IF(ISPC.LE.0)ISPC=buflen+1
	    IF(ICMA.LE.0)ICMA=buflen+1
	    IF(ISLSH.LE.0)ISLSH=buflen+1
	    I=MIN0(ISPC,ICMA,ISLSH,ILEN)
	    FILE=LINE(2:I)
	    IF(ILEN.LT.I+2)THEN
		LABEL=' '
		I=0
	    ELSE
		I=MIN0(ISPC,ICMA,ILEN)
		LABEL=LINE(I+2:ILEN)
		I=ILEN-I-1
	    ENDIF
	    VALUE=FILE
	    ivlen=lnblk(value,2048)
#ifdef unix
	    file=value
#else
	    CALL WLDFLE('SY:.PPC',VALUE(1:ivlen),FILE,STATUS,IFLAG)
#endif
	    CALL ATSTRT(FILE,LABEL,I,IER)
	ELSE IF(COM.EQ.'RETURN')THEN
	    CALL ATEND
	    IF(DONEF)RETURN
	ELSE IF(COM.EQ.'IF')THEN
	    VALUE=LINE(4:ILEN)
	    LABEL=VALUE
	    CALL UPPER(VALUE,2048)
	    ITHEN=INDEX(VALUE,'THEN')
	    IF(ITHEN.LE.0)THEN
		CALL CMDERR(4,LINE,ILEN,LBSTRT)
		GOTO 1000
	    ENDIF
C
C	CALL IF PARSING ROUTINE
C
	    CALL PARSEV(LABEL,VALUE,ITHEN-1,RESULT,IER,IPOS)
	    IF(IER.NE.0)THEN
		CALL CMDERR(IER,LINE,ILEN,LBSTRT+IPOS)
		GOTO 1000
	    ENDIF
	    IFLEV=IFLEV+1
	    IFCNT=0
	    SKIPIF=.NOT.RESULT
	ELSE IF(COM.EQ.'INC')THEN
	    NN=N
	    VALUE=LABEL
	    CALL EXPEVL(VALUE,N,XX,NUM,IER)
	    IF(NUM)THEN
		XX=XX+1.0
	    ELSE
		XX=1.0
	    ENDIF
	    WRITE(VALUE,998)XX
998	    FORMAT(1PE13.5)
	    LABEL(NN+1:)=VALUE
	    CALL SETSYM(LABEL,NN+13,IER,IST2)
	ELSE IF(COM.EQ.'DEC')THEN
	    NN=N
	    VALUE=LABEL
	    CALL EXPEVL(VALUE,N,XX,NUM,IER)
	    IF(NUM)THEN
		XX=XX-1.0
	    ELSE
		XX=0.0
	    ENDIF
	    WRITE(VALUE,998)XX
	    LABEL(NN+1:)=VALUE
	    CALL SETSYM(LABEL,NN+13,IER,IST2)
	ELSE IF(COM.EQ.'ELSE')THEN
	    IF(IFLEV.GT.0)THEN
		SKIPIF=.TRUE.
	    ELSE
		CALL CMDERR(5,LINE,ILEN,1)
	    ENDIF
	ELSE IF(COM.EQ.'ENDIF')THEN
	    IF(IFLEV.GT.0)THEN
		SKIPIF=.FALSE.
		IFLEV=IFLEV-1
	    ELSE
		CALL CMDERR(5,LINE,ILEN,1)
	    ENDIF
	ELSE IF(COM.EQ.'WHILE')THEN
	    VALUE=LINE(7:ILEN)
	    LABEL=VALUE
	    CALL UPPER(VALUE,2048)
	    ITHEN=INDEX(VALUE,'THEN')
	    IF(ITHEN.LE.0)THEN
		CALL CMDERR(4,LINE,ILEN,LBSTRT)
		GOTO 1000
	    ENDIF
C
C	CALL IF PARSING ROUTINE
C
	    CALL PARSEV(LABEL,VALUE,ITHEN-1,RESULT,IER,IPOS)
	    IF(IER.NE.0)THEN
		CALL CMDERR(IER,LINE,ILEN,LBSTRT+IPOS)
		GOTO 1000
	    ENDIF
	    WHLEV=WHLEV+1
	    WHCNT=0
	    SKIPWH=.NOT.RESULT
	    WHLINE(WHLEV)=LINCNT-1
	ELSE IF(COM.EQ.'ENDW')THEN
	    IF(WHLEV.LT.1)THEN
		CALL CMDERR(8,LINE,ILEN,1)
		GOTO 1000
	    ENDIF
	    REWIND(CMDLUN)
	    DO 300 I=1,WHLINE(WHLEV)
	    READ(CMDLUN,996)
996	    FORMAT(1X)
300	    CONTINUE
	    LINCNT=WHLINE(WHLEV)
	    WHLEV=WHLEV-1
	ELSE
	    CALL PARSEX(LINE,ILEN,X,IF,M,LABEL,N)
	    LABEL(N+1:)=' '
	    RETURN
	ENDIF
	GOTO 1000
	END

	INTEGER FUNCTION ALG_CLASS( ctr )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* subroutine for lexical analyzer
* determine chatacter class of character
* note: the routine could be made simpler and faster by simply providing a
*	DATA statement associating each character number (ICHAR('C')) with a
*	class.   ... hurried development ...

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V200: 11/24/89
* V495: 7/7/98 - add single quotes as another character class (11) (old 11->12)
*     : 9/30/98 - NAG F90 (linux) received error on above change.  
*                 need to put single  tick between double quotes  *kob*
* V500: 12/98 - add "{" and "}" to support "{1,3,5}" notation
*	 1/99 - allow strings in quoble quotes (as fcn args)
* 2/03 *kob* - g77 port - g77 won't allow intrinsic functions in PARAMETER
*                         statements.  use an octal constant instead 
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
* 12/14 *sh* "_" is a separate character class needed for _DQ_ and _SQ_

	include	'ferret.parm'

* calling argument declaration:
	CHARACTER*1	ctr

* internal parameter declarations:
	CHARACTER*1     tab
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
#else
	PARAMETER     ( tab = CHAR(9))
#endif

* classes of characters
*	C1 - + -
*	C2 - digits
*	C3 - letters
*	C4 - [
*	C5 - ]
*	C6 - * / ^ , (
*	C7 - )
*	C8 - blank tab
*	C9 - E e
*	C10- .
*       C11- '
*	C12- {
*	C13- }
*	C14- "
*	C15- _
*	C15- all others

	IF     ( ctr.EQ.'+' .OR.  ctr.EQ.'-' ) THEN
	   ALG_CLASS = 1
	ELSEIF ( ctr.GE.'0' .AND. ctr.LE.'9' ) THEN
	   ALG_CLASS = 2
	ELSEIF ( ctr.EQ.'E' .OR.  ctr.EQ.'e' ) THEN
	   ALG_CLASS = 9
	ELSEIF ( ( ctr.GE.'A' .AND. ctr.LE.'Z' )
     .	    .OR. ( ctr.GE.'a' .AND. ctr.LE.'z' ) ) THEN
	   ALG_CLASS = 3
	ELSEIF ( ctr.EQ.'[' ) THEN
	   ALG_CLASS = 4
	ELSEIF ( ctr.EQ.']' ) THEN
	   ALG_CLASS = 5
	ELSEIF ( ctr.EQ.'*' .OR. ctr.EQ.'/' .OR. ctr.EQ.'^'
     .	    .OR. ctr.EQ.',' .OR. ctr.EQ.'('		) THEN
	   ALG_CLASS = 6
	ELSEIF ( ctr.EQ.')' ) THEN
	   ALG_CLASS = 7
	ELSEIF ( ctr.EQ.' ' .OR. ctr.EQ.tab ) THEN
	   ALG_CLASS = 8
	ELSEIF ( ctr.EQ.'.' ) THEN
	   ALG_CLASS = 10
	ELSEIF ( ctr.EQ. "'" ) THEN
	   ALG_CLASS = 11
	ELSEIF ( ctr.EQ.'{' ) THEN
	   ALG_CLASS = 12
	ELSEIF ( ctr.EQ.'}' ) THEN
	   ALG_CLASS = 13
	ELSEIF ( ctr.EQ.'"' ) THEN
	   ALG_CLASS = 14
	ELSEIF ( ctr.EQ.'_' ) THEN
	   ALG_CLASS = 15
	ELSE
	   ALG_CLASS = 16
	ENDIF

	RETURN
	END

	SUBROUTINE CD_RD_YMD_1(cdfid,t1id,t0,tunit,index,dval,status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* read a single time value from a "yymmddhhmmss" time axis
* if T0 is not yet known determine an appropriate value
* return time value as a double precision time relative to t0

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 2/95  -- specifically for accessing CDC files
* V530 *acm* 1/01 add calendar ID in TM_BREAK_DATE, TM_SECS_FROM_BC
*	    	  calendar is assumed Gregorian
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* argument definitions:
*	cdfid	 - netCDF id number for already opened CDF file
*       t1id     - netCDF variable id of "time"
*       t0       - T0 string for the time axis
*       tunit    - number of seconds per axis time unit
*       index    - subscript of time axis to return
*       dval     - double precision value returned
*       status   - TMAP library return status

* argument declarations
      INTEGER cdfid, t1id, index, status
      REAL tunit
      REAL*8  dval
      CHARACTER*(*) t0

      include 'netcdf.inc'
      include 'tmap_errors.parm'

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

* internal variable declarations:
      INTEGER cdfstat, mon, day, yr, hour, min, sec,
     .        t0year, t0mon, t0day, t0hour, t0min, t0sec

      INTEGER cal_id
      REAL*8  TM_SECS_FROM_BC
      REAL*8  yymmdd, date_secs, start_secs, offset_secs

* internal parameter declarations
      REAL*8      p1900, p0010
      PARAMETER ( p1900 = 693961. * 24 * 60 * 60,
     .		  p0010 = 3653.   * 24 * 60 * 60 )

* read the yymmdd value
      cdfstat = NF_GET_VAR1_DOUBLE(cdfid, t1id, index, yymmdd)
      IF ( cdfstat .NE. NF_NOERR ) CALL TM_ERRMSG
     .     ( cdfstat+pcdferr, status, 'CD_RD_YMD_1', cdfid, t1id,
     .       'yymmdd time', no_errstring, *5000 )

* convert the 2 EPIC integers to a date
      CALL TM_YMD_TIME_CONVRT( yymmdd,
     .                         mon, day, yr, hour, min, sec)

* determine seconds from BC. 
* For this routine set the calendar ID to gregorian always...

      cal_id = 1
      date_secs  = TM_SECS_FROM_BC (cal_id, yr  , mon, day,
     .                              hour, min, sec, status)
      IF (status .ne. merr_ok) GO TO 5000

* determine the T0 value to use
      IF ( t0 .EQ. ' ' ) THEN 
         IF ( date_secs .GT. p1900 ) THEN
            t0 = '1-JAN-1900'
         ELSEIF ( date_secs .LT. p0010 ) THEN
            t0 = '1-JAN-0000'
         ELSE
	    t0 = '1-JAN-1700'
         ENDIF
      ENDIF

* break apart the T0 offset date 
      CALL TM_BREAK_DATE (t0, cal_id, t0year, t0mon,
     .                    t0day, t0hour, t0min, t0sec, status)
      IF (status .ne. merr_ok) GO TO 5000

      start_secs = TM_SECS_FROM_BC (cal_id, t0year, t0mon, t0day,
     .                              t0hour, t0min, t0sec, status)
      IF (status .ne. merr_ok) GO TO 5000

* Find the number of seconds since T0
      offset_secs = date_secs - start_secs

* Divide by time step increment to get # of time step
      dval = offset_secs/tunit

      status = merr_ok
      RETURN

* error exit
 5000 RETURN

      END

	SUBROUTINE GCF_SET_ALT_FCN_FOR_DIR( gcfcn, idirs, num_dirs)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Find the correct function name and update to the right function number
* for direction-changing functions which have arguments that specifies the
* direction of operation.

* V7.20 *acm* 4/2017

        IMPLICIT NONE
        include 'tmap_dims.parm'
        include 'ferret.parm'
	include 'grid_chg_fcns.parm' 
	include 'xgrid_chg_fcns.cmn'


* calling argument declarations
	INTEGER		gcfcn, idirs(*), num_dirs

* Local declarations
	INTEGER	TM_LENSTR1, GCF_FIND_FCN, nlen, isubst, idim
	CHARACTER name*40, buff*40, axdir(nferdims)*1
        DATA axdir / 'X', 'Y', 'Z', 'T', 'E', 'F' /

	IF (num_dirs .EQ. 0)  GOTO 5100

	name = gfcn_alt_name_base(gcfcn)
	nlen = TM_LENSTR1( name )
	isubst = INDEX(name, '%')
	IF (isubst .EQ. 0) GOTO 5100

* substitute axis direction names to get the new function

	DO idim = 1, nferdims
	   IF (idirs(idim) .NE. 0) THEN
	      buff = name
	      nlen = TM_LENSTR1( buff )
	      isubst = INDEX(buff, '%')
	      IF (isubst .EQ. 0) GOTO 5100
	      buff = buff(:isubst-1)//axdir(idirs(idim))//
     .          buff(isubst+1:nlen)
              name = buff
	   ENDIF
        ENDDO
	   
	nlen = TM_LENSTR1( name )
	gcfcn = GCF_FIND_FCN( name )

	RETURN
5100    gcfcn = unspecified_int4
	RETURN
	END

      CHARACTER*48 FUNCTION TM_FMT(val, ndigits, max_len, str_len)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY
*  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE.
*
*
* convert the value val to a formatted string, left justified, not exceeding
* max_len in length and with the shortest possible format( unnecerssary zeros
* eliminated )

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Thermal Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.00 - 08/31/88
*          0.10 -  7/21/89 - check if NINT increases digits
*    1/27/95 - corrected tendency to put out tons of zeros to the right
*    3/20/95 - the 1/27/95 correction causes this routine to blow up on
*              OSF f77 **only** when compiled with -g
* *sh* 9/95  - precision output bug for large values
*     10/95  - fix missing leading zero on fixed point for some compilers (HP)
*     12/95  - fix bug with 9.9995 displayed as 4 digits: one_m_eps made
*              system dependent
* *kob* 8/96 - check for a negative w/out a leading zero to prevent output
*              looking like "0-.xxx" - for ibm and hp
* *acm* 11/04  incoming value may be NaN (e.g. in a SHOW DATA/FULL if missing
*              flag is NaN)
* *acm* 11/05  incoming value may be Inf (e.g. in a STAT, if data contains Inf)
* *acm*  1/06  When val is 0, log10(aval) is infinite.  Causes crash on IRIX;
*              take care of val=0 case individually.
* *acm*  V6.1 3/08 further corrections to last fix when writing a value with
*                  negative exponent
* *acm*  V6.5 1/10 Fix bug 1717: If the format is going to be (I0) make it (I1)
* *acm*  V7.2 3/17 Floating-point formatted output could still have trailing zeros
*                  after the decimal point. Remove them.
* *kms*  v7.5 5/19 Use DNINT instead of NINT when assigned to REAL to avoid integer
*                  overflow issues.  Change full and full10 to REAL*8.
*                  Write integer initially as Fn.0 values, then remove the '.'
*                  Return CHARACTER*64 to simplify life since 64 is max size that
*                  can be handled here. Remove the one_m_eps stuff for the VAX bug.
* *kms*  v7.5 5/19 For negative values of ndigit (previously called digit), exactly
*                  that many (as a positive number) digits after the decimal point
*                  are returned.  Revised checks for zero values.
*                  Use and return CHARACTER*48 - more than enough for even REAL*16
* *acm*  v7.5 6/19 Check for fewer digits returned with same accuracy 

* calling arguments:
* val      - REAL*8 value to be converted
* ndigits  - IF positive, maximum number of significant digits desired
*            IF zero, nearest integer value (no decimal point, no exponential)
*            IF negative, exact number of digits after the decimal point (no exponential)
* max_len  - longest allowable length for string to be returned
* str_len  - (returned) actual length of the string generated

        IMPLICIT NONE

* calling argument declarations:
        INTEGER ndigits, max_len, str_len
        REAL*8  val

* functions:
        INTEGER TM_CHECK_NAN, TM_CHECK_INF, TM_LENSTR1

* local parameters:
        INTEGER     sig_min, max_str_len
        PARAMETER ( sig_min = 1, max_str_len = 48 )

* internal variable declarations:
        LOGICAL   TM_FPEQ, negative
        INTEGER   slen, sig_max, pow10p, pow10p_save, sig_left, nleft,
     .            sig_needed, nright, xtra, idx, digits
        REAL*8    aval, l10, full, full10
        CHARACTER frmt*10, outstring*(max_str_len), strend*(max_str_len)

* initialize
        negative     = val .LT. 0.0
        aval         = ABS( val )
        outstring    = ' '
	digits       = ndigits

* maximum length of output string
* (at least 1 character long but not longer than outstring or user-specified max)
        slen = MAX( 1, MIN( max_str_len, max_len ) )

* If the value is NaN, set the string here
        IF ( TM_CHECK_NAN(val) .EQ. 1   ) THEN
           IF (slen .LT. 3) GOTO 5000
           outstring  = 'NaN'
           str_len = 3
           TM_FMT = outstring
           RETURN
        ENDIF

* If the value is Inf, set the string here
        IF ( TM_CHECK_INF(val)  .EQ. 1   ) THEN
           IF (slen .LT. 3) GOTO 5000
           outstring  = 'Inf'
           str_len = 3
           TM_FMT = outstring
           RETURN
        ENDIF

* Easy case where the exact number of fractional digits is specified
* However for very large numbers go on and use scientific notation, 
* arbitrarily returning the max amount of precision

        l10 = LOG10(aval)
        IF (digits.LE.0 .AND. INT(l10).GT.16-ABS(ndigits) ) digits = 16
	
	IF ( digits .LE. 0 ) THEN
*          Just write the value in all space provided with the indicated
*          number of fractional digits, then clean up.
           WRITE ( frmt, 20 ) slen, ABS(digits)
   20      FORMAT ( '(F',I2,'.',I2,')' )
           WRITE ( outstring, frmt ) val
           IF ( outstring(1:1) .EQ. '*' ) GOTO 5000
           GOTO 400
        ENDIF

        aval         = ABS( val )
        outstring    = ' '

* The number of significant digits was specified - need to decide how to represent it

*       Take care of exactly zero values
        IF ( aval .EQ. 0.0 ) THEN
           outstring = '0'
           str_len = 1
           TM_FMT = outstring
           RETURN
        ENDIF

        sig_max = digits

* location of leftmost digit (.01-->-1, 0.1-->0, 1.0-->1, etc.)
        l10 = LOG10(aval)
        IF ( l10 .GE. 0.0 ) THEN
           pow10p = INT(l10) + 1
        ELSE
           pow10p = INT(l10)
        ENDIF
   50   pow10p_save = pow10p

* significant digits to left of the decimal point
        sig_left = MAX(pow10p, 0)

* actual characters to the left of the decimal point
        nleft = MAX(sig_left, 1)           ! at least a zero
        IF ( negative ) nleft = nleft + 1  ! minus sign

* create the nearest integer with all the possible digits
        full = DNINT(aval * (10.0**(sig_max-pow10p)))
* special check: eg. 99.9 --> 100.0 , changing leftmost digit count
        IF ( ABS(full - 10.0**sig_max) .LT. 1.0E-7 ) THEN
           pow10p = pow10p + 1
           GOTO 50
        ENDIF
* get number of digits remaining after trimming off right hand zeros
        full10 = 10.0**(sig_max-sig_min)
        DO sig_needed = sig_min, sig_max
           IF ( ABS(DMOD(full, full10)) .LT. 1.0E-7 ) GOTO 200
           full10 = full10 / 10.0
        ENDDO
        sig_needed = sig_max
  200   nright = sig_needed - sig_left
        IF ( pow10p .LT. 0 ) nright = nright + ABS(pow10p)  ! leading zeros
        IF ( nright .LT. 0 ) nright = 0

* * * * CREATE A FORMAT STRING AND WRITE THE RESULT * * *

* compute the length if written as fixed point with unlimited string length
        str_len = nleft + 1 + nright

* EXPONENTIAL STRING
* numbers that are:
*    too big for the string length  (eg. 150000 can't fit into 4 spaces),
*    too small for fixed point (eg. 0.0000025 with 2 sig. digits), or
*    whose integer form gives too many sig. digits (eg. 555555 with 3 sig. digits)
* must be written in exponential format.
* Values in (10.0,0.1] should never be using exponential format.
* Values in (1000.0,0.001] should not use exponential format unless the
* fixed point form would give too many significant digits.
        IF ( ( (ABS(l10) .GE. 3.0) .OR. 
     .         (ABS(l10) .GE. 1.0) .AND. (digits .LT.3) ) .AND.
     .       ( (str_len .GT. slen) .OR.
     .         (nright .GT. sig_max) .OR.
     .         (sig_left .GT. sig_max) ) ) THEN
*          Absolute minimum needed: <n>.E+<n>, <n>.E-<n>
           IF ( negative ) THEN
              xtra = 6
           ELSE
              xtra = 5
           ENDIF
           IF ( slen .LE. xtra ) GOTO 5000
           str_len = MIN(slen, sig_needed+xtra)
           IF (pow10p .LT. 0) str_len = str_len + sig_max
           IF (str_len .GT. slen) str_len = slen
           nright = MAX(0, digits - 1)
           IF (str_len-(xtra+1) .LT. 0) xtra = 1
           nright = MIN(nright, str_len-(xtra+1))
*          Write out the exponential form
           WRITE ( frmt, 300 ) str_len, nright
  300      FORMAT( '(1PG',I2,'.',I2,')' )
           WRITE ( outstring, frmt ) val
           IF ( outstring(1:1) .EQ. '*' ) GOTO 5000

* INTEGER STRING
* numbers whose needed digits are all on the left (eg. -2.0001 in 4 characters)
* or whose length is too long to add a decimal point (eg. 25.5 in 3 characters)
* must be represented as integers
        ELSEIF ( (sig_left .GE. sig_needed) .OR.
     .           (nleft .GE. slen-1) ) THEN

*          get the nearest integer as a REAL*8
           aval = DNINT(aval)
           IF ( aval .EQ. 0.0 ) THEN
              outstring = '0'
              str_len = 1
              TM_FMT = outstring
              RETURN
           ENDIF
*          check if this integer value will alter formatting (e.g. 99.6-->100)
           l10  = LOG10(aval)
           IF ( l10 .GE. 0.0 ) THEN
              pow10p = INT(l10) + 1
           ELSE
              pow10p = INT(l10)
           ENDIF
           IF ( pow10p .NE. pow10p_save ) GOTO 50

           str_len = nleft
*          increment the length for the decimal point that will be removed
           IF ( str_len .LT. max_str_len ) str_len = str_len + 1
           WRITE ( frmt, 310 ) str_len
*          Write the integer form as floating point with no fraction (eg, 25.) to
*          avoid integer overflow.  The end decimal point will be removed later
  310      FORMAT ( '(F',I2,'.0)' )
           WRITE ( outstring, frmt ) DNINT(val)
           IF ( outstring(1:1) .EQ. '*' ) GOTO 5000

* FIXED POINT STRING
        ELSE
           WRITE ( frmt, 320 ) str_len, nright
  320      FORMAT ( '(F',I2,'.',I2,')' )
           WRITE ( outstring, frmt ) val
           IF ( outstring(1:1) .EQ. '*' ) GOTO 5000
        ENDIF

* Clean up the string

  400   str_len = TM_LENSTR1( outstring )

* Remove fractional zeros just before the exponent
* (but leave a trailing decimal point)
        idx = INDEX(outstring, '0E')
        DO WHILE (idx .GT. 1)
           strend = outstring(idx+1:str_len)
           outstring = outstring(1:idx-1)//strend
           str_len = str_len - 1
           idx = INDEX(outstring, '0E')
        ENDDO

* Remove fractional zeros (if not required) and
* trailing decimal point from non-exponentials
        IF ( (digits .GE. 0) ) CALL TM_CLEANUP_NUM_STRING (outstring, str_len)

* Add a zero before a floating point value with no integer part
        IF ( outstring(1:3) .EQ. ' -.' ) THEN
           outstring(1:3) = '-0.'
        ELSEIF ( outstring(1:2) .EQ. ' .' ) THEN
           outstring(1:2) = '0.'
        ELSEIF ( (str_len .LT. slen) .AND. (outstring(1:2) .EQ. '-.') ) THEN
*          Appending space just to get rid of a nonsense compiler warning
           strend = outstring(2:str_len)//' '
           outstring = '-0'//strend
           str_len = str_len + 1
        ELSEIF ( (str_len .LT. slen) .AND. (outstring(1:1) .EQ. '.') ) THEN
           strend = outstring(1:str_len)
           outstring = '0'//strend
           str_len = str_len + 1
        ENDIF

* Remove any initial spaces
        DO WHILE ( (str_len .GT. 1) .AND. (outstring(1:1) .EQ. ' ') )
*          Appending space just to get rid of a nonsense compiler warning
           strend = outstring(2:str_len)//' '
           outstring = strend
           str_len = str_len - 1
        ENDDO

        TM_FMT = outstring
        RETURN

* Error return of '******' (trimmed down to slen length)
 5000   str_len = 0
        DO WHILE ( (str_len .LT. 6) .AND. (str_len .LT. slen) )
           str_len = str_len + 1
           outstring(str_len:str_len) = '*'
        ENDDO
        TM_FMT = outstring
        RETURN

      END

	SUBROUTINE IIN_REGRID_1_AXIS( cx_lims, idim, src, msrc, 
     .				 dst, mdst, ss21, src_cx, dst_cx, 
     .				 wksize, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* 	Using data values from src organized on grid src_grid, regrid to
* 	grid dst_grid by integrating within boxes along one axis
*
* 	msrc and mdst point to data structures in COMMON/XVARIABLES/ which
*
* 	specify the subscript bounds of src and dst within their 
* 	respective grids.
*
*	ss21 holds the indices of source grid boxes (on src_grid) for box
*	limits on dst_grid.
*
*	Return results in world-coordinate units

* 	programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Science Data Integration Group
* revision 0.0 - 5/2018  from ave_regrid_1_axis

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'
	include 'xmem_subsc.cmn'
	include 'xvariables.cmn'
	include 'errmsg.parm'
	include 'xunits.cmn_text'
	include 'xtm_grid.cmn_text'

* calling argument declarations:
	INTEGER cx_lims, idim, msrc, mdst, wksize,
     .                  src_cx, dst_cx, status
	INTEGER ss21(wksize)

	REAL    src( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .	             m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .	        dst( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .	             m2lot:m2hit,m2loe:m2hie,m2lof:m2hif )

* local variable declarations:

        LOGICAL         IS_SELF_REGRID, GEOG_COS_FACTOR, 
     .			ok_neg111, src_encloses, need_cos, bad, lmod
        INTEGER		dstss,srcss,src_grid,dst_grid,i,j,k,l,m,n
	INTEGER	     	srcss_lo,srcss_hi, dstss_lo,dstss_hi, ncontrib, 
     .			usrc, udst

	REAL		TM_WORLD, TDEST_WORLD, sum,
     .			xsrc_min, xsrc_max, xsrc_lo, xsrc_hi,
     .			xdst_lo, xdst_hi, ddist, bad_src, bad_dst,
     .			unit_src, unit_dst, bx, ybxlo, ybxhi, cos_factor
******************************************************************************

* initialize
	src_grid = mr_grid( msrc )
	dst_grid = mr_grid( mdst )

* limits for calculation
        srcss_lo = mr_lo_ss(msrc,idim)
        srcss_hi = mr_hi_ss(msrc,idim)

* Handle the axis as non-modulo, so that we start the integration correctly
* and not reaching into the next grid cell below the start.

	lmod = line_modulo( grid_line(idim,src_grid) ) 
	IF (lmod) line_modulo( grid_line(idim,src_grid) ) = .FALSE.

* Range of subscripts might be negative, and contain the value of unspecified_int4 
* among them.  ok_neg111 distinguishes between this and the flag unspecified_int4.

        ok_neg111 = srcss_lo .LT. unspecified_int4 .AND.
     .              srcss_hi .GT. unspecified_int4

        dstss_lo = cx_lo_ss(cx_lims,idim)
        dstss_hi = cx_hi_ss(cx_lims,idim)

	
* perform integrations on standard units if possible
	usrc = line_unit_code(grid_line(idim,src_grid))
	udst = line_unit_code(grid_line(idim,dst_grid))
	unit_src = un_convert( usrc )
	unit_dst = un_convert( udst )

* Check: Same or compatible units?
        bad = usrc* udst .LT. 0  ! one is time and one is not

* Can convert time, but not converting e.g. between km and mile
	IF (.NOT.bad .AND. udst.GE.0)  bad = (unit_src .NE. unit_dst) 

	IF (bad) GOTO 5100

* flag for bad/missing data
        bad_src = mr_bad_data(msrc)
        bad_dst = mr_bad_data(mdst)

* determine the source grid boxes containing the destination box edges
	CALL GET_IIN_LIMS( srcss_lo, srcss_hi, src_grid,
     .			   dstss_lo, dstss_hi, dst_grid,
     .			   idim, ss21 )

* along X axis
        IF ( idim .EQ. x_dim ) THEN

           cos_factor = 1.
           need_cos = GEOG_COS_FACTOR( idim, src_grid )
     .                .AND. cx_lo_s2(cx_lims).NE.unspecified_int4

           DO 190 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
           DO 190 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
           DO 190 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
           DO 190 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
           DO 190 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)

           IF ( need_cos ) THEN
              ybxlo = deg2rad* 
     .              TM_WORLD(j,src_grid,y_dim,box_lo_lim)
              ybxhi = deg2rad* 
     .              TM_WORLD(j,src_grid,y_dim,box_hi_lim)
              bx = ABS(ybxhi - ybxlo)
              cos_factor = ABS( SIN(ybxhi) - SIN(ybxlo) )/ bx
           ENDIF 

* loop through the each destination grid box
	   sum = 0.0D0
	   dst(dstss_lo, j, k, l, m, n) = sum
	   DO 160 dstss = dstss_lo,dstss_hi
	      srcss_lo = ss21(dstss-dstss_lo+1)
	      srcss_hi = ss21(dstss-dstss_lo+2)

*  check if requested region is out of source range
              IF ( (srcss_lo .EQ. unspecified_int4
     .	     .OR.  srcss_hi .EQ. unspecified_int4)
     .       .AND. .NOT.(ok_neg111) ) THEN
	         dst(dstss,j,k,l,m,n) = bad_dst
	         goto 160
	      ENDIF

* Get destination edges to use

	      IF (dstss .EQ. dstss_lo) THEN
 	         xdst_lo = unit_dst* TM_WORLD(dstss, dst_grid, idim, box_lo_lim )
		 xdst_hi = unit_dst* TM_WORLD(dstss, dst_grid, idim, box_middle )
	      ELSE
	         xdst_lo =  unit_dst* TM_WORLD(dstss-1, dst_grid, idim, box_middle )
	         xdst_hi = unit_dst* TM_WORLD(dstss, dst_grid, idim, box_middle )
	      ENDIF

* add all partial or complete boxes of data from the source grid

* IF source box completely encloses the dest box, then srcss_lo=srcss_hi
* and we can just add the source point into the sum
	      DO 110 srcss = srcss_lo, srcss_hi

* ... ignore missing source data
	         IF ( src(srcss, j, k, l, m, n) .EQ. bad_src ) GOTO 110

	         xsrc_min = unit_src* TM_WORLD(srcss,src_grid,idim,box_lo_lim)
	         xsrc_max = unit_src* TM_WORLD(srcss,src_grid,idim,box_hi_lim)

	        src_encloses = 
     .               (xdst_lo.GT.xsrc_min .AND. xdst_hi.LT.xsrc_max) 

	         xsrc_lo = MAX(xsrc_min,xdst_lo)
	         xsrc_hi = MIN(xsrc_max,xdst_hi )

	         ddist   = xsrc_hi-xsrc_lo

* ... contribution from this source box
                 IF (ddist .GT. 0.) THEN
	            sum   = sum  + cos_factor* ddist * src(srcss, j, k, l, m, n)
                 ENDIF

 110	      CONTINUE
              dst(dstss, j, k, l, m, n) = sum

 160	   CONTINUE
 190	   CONTINUE

* along Y axis
        ELSEIF ( idim .EQ. Y_dim ) THEN

           DO 290 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
           DO 290 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
           DO 290 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
           DO 290 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
           DO 290 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* loop through the each destination grid box
	   sum = 0.0D0
           dst(i, dstss_lo, k, l, m, n) = sum
	   DO 260 dstss = dstss_lo,dstss_hi
	      srcss_lo = ss21(dstss-dstss_lo+1)
	      srcss_hi = ss21(dstss-dstss_lo+2)

*  check if requested region is out of source range
              IF ( (srcss_lo .EQ. unspecified_int4
     .	     .OR.  srcss_hi .EQ. unspecified_int4)
     .       .AND. .NOT.(ok_neg111) ) THEN
	         dst(i,dstss,k,l,m,n) = bad_dst
	         goto 260
	      ENDIF

* Get destination edges to use

	      IF (dstss .EQ. dstss_lo) THEN
 	         xdst_lo = unit_dst* TM_WORLD(dstss, dst_grid, idim, box_lo_lim )
		 xdst_hi = unit_dst* TM_WORLD(dstss, dst_grid, idim, box_middle )
	      ELSE
	         xdst_lo = unit_dst* TM_WORLD(dstss-1, dst_grid, idim, box_middle )
	         xdst_hi = unit_dst* TM_WORLD(dstss, dst_grid, idim, box_middle )
	      ENDIF

* add all partial or complete boxes of data from the source grid

* IF source box completely encloses the dest box, then srcss_lo=srcss_hi
* and we can just add the source point into the sum
	      DO 210 srcss = srcss_lo, srcss_hi

* ... ignore missing source data
	         IF ( src(i, srcss, k, l, m, n) .EQ. bad_src ) GOTO 210

	         xsrc_min = unit_src* TM_WORLD(srcss,src_grid,idim,box_lo_lim)
	         xsrc_max = unit_src* TM_WORLD(srcss,src_grid,idim,box_hi_lim)

	        src_encloses = 
     .               (xdst_lo.GT.xsrc_min .AND. xdst_hi.LT.xsrc_max) 

	         xsrc_lo = MAX(xsrc_min,xdst_lo)
	         xsrc_hi = MIN(xsrc_max,xdst_hi)

	         ddist   = xsrc_hi-xsrc_lo

* ... contribution from this source box
                 IF (ddist .GT. 0.) THEN
	            sum = sum + ddist*  src(i, srcss, k, l, m, n)
                 ENDIF

 210	      CONTINUE
              dst(i, dstss, k, l, m, n) = sum

 260	   CONTINUE
 290	   CONTINUE

* along Z axis
        ELSEIF ( idim .EQ. z_dim ) THEN

           DO 390 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
           DO 390 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
           DO 390 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
           DO 390 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
           DO 390 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* loop through the each destination grid box
	   sum = 0.0D0
           dst(i, j, dstss_lo, l, m, n) = sum
	   DO 360 dstss = dstss_lo,dstss_hi
	      srcss_lo = ss21(dstss-dstss_lo+1)
	      srcss_hi = ss21(dstss-dstss_lo+2)

*  check if requested region is out of source range
              IF ( (srcss_lo .EQ. unspecified_int4
     .	     .OR.  srcss_hi .EQ. unspecified_int4)
     .       .AND. .NOT.(ok_neg111) ) THEN
	         dst(i,j,dstss,k,m,n) = bad_dst
	         goto 360
	      ENDIF

* Get destination edges to use

	      IF (dstss .EQ. dstss_lo) THEN
 	         xdst_lo = unit_dst* TM_WORLD(dstss, dst_grid, idim, box_lo_lim )
		 xdst_hi = unit_dst* TM_WORLD(dstss, dst_grid, idim, box_middle )
	      ELSE
	         xdst_lo = unit_dst* TM_WORLD(dstss-1, dst_grid, idim, box_middle )
	         xdst_hi = unit_dst* TM_WORLD(dstss, dst_grid, idim, box_middle )
	      ENDIF

* add all partial or complete boxes of data from the source grid

* IF source box completely encloses the dest box, then srcss_lo=srcss_hi
* and we can just add the source point into the sum
	      DO 310 srcss = srcss_lo, srcss_hi

* ... ignore missing source data
	         IF ( src(i, j, srcss, l, m, n) .EQ. bad_src ) GOTO 310

	         xsrc_min = unit_src* TM_WORLD(srcss,src_grid,idim,box_lo_lim)
	         xsrc_max = unit_src* TM_WORLD(srcss,src_grid,idim,box_hi_lim)

	        src_encloses = 
     .               (xdst_lo.GT.xsrc_min .AND. xdst_hi.LT.xsrc_max) 

	         xsrc_lo = MAX(xsrc_min,xdst_lo)
	         xsrc_hi = MIN(xsrc_max,xdst_hi )

	         ddist   = xsrc_hi-xsrc_lo

* ... contribution from this source box
                 IF (ddist .GT. 0.) THEN
	            sum = sum + ddist*  src(i, j, srcss, l, m, n)
                 ENDIF

 310	      CONTINUE
              dst(i, j, dstss, l, m, n) = sum


 360	   CONTINUE
 390	   CONTINUE

* along T axis
        ELSEIF ( idim .EQ. T_dim ) THEN

           DO 490 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
           DO 490 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
           DO 490 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
           DO 490 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
           DO 490 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* loop through the each destination grid box
	   sum = 0.0D0
           dst(i, j, k, dstss_lo, m, n) = sum
	   DO 460 dstss = dstss_lo,dstss_hi
	      srcss_lo = ss21(dstss-dstss_lo+1)
	      srcss_hi = ss21(dstss-dstss_lo+2)

*  check if requested region is out of source range
              IF ( (srcss_lo .EQ. unspecified_int4
     .	     .OR.  srcss_hi .EQ. unspecified_int4)
     .       .AND. .NOT.(ok_neg111) ) THEN
	         dst(i,j,k,dstss,m,n) = bad_dst
	         goto 460
	      ENDIF

* Get destination edges to use

* Get destination edges to use

	      IF (dstss .EQ. dstss_lo) THEN
 	         xdst_lo = unit_dst* TM_WORLD(dstss, dst_grid, idim, box_lo_lim )
		 xdst_hi = unit_dst* TM_WORLD(dstss, dst_grid, idim, box_middle )
	      ELSE
	         xdst_lo = unit_dst* TM_WORLD(dstss-1, dst_grid, idim, box_middle )
	         xdst_hi = unit_dst* TM_WORLD(dstss, dst_grid, idim, box_middle )
	      ENDIF

* add all partial or complete boxes of data from the source grid

* IF source box completely encloses the dest box, then srcss_lo=srcss_hi
* and we can just add the source point into the sum
	      DO 410 srcss = srcss_lo, srcss_hi

* ... ignore missing source data
	         IF ( src(i, j, k, srcss, m, n) .EQ. bad_src ) GOTO 410

	         xsrc_min = unit_src* TM_WORLD(srcss,src_grid,idim,box_lo_lim)
	         xsrc_max = unit_src* TM_WORLD(srcss,src_grid,idim,box_hi_lim)

	        src_encloses = 
     .               (xdst_lo.GT.xsrc_min .AND. xdst_hi.LT.xsrc_max) 

	         xsrc_lo = MAX(xsrc_min,xdst_lo)
	         xsrc_hi = MIN(xsrc_max,xdst_hi)

	         ddist   = xsrc_hi - xsrc_lo

* ... contribution from this source box
                 IF (ddist .GT. 0.) THEN
	            sum = sum + ddist*  src(i, j, k, srcss, m, n)
	         ENDIF 

 410	      CONTINUE
              dst(i, j, k, dstss, m, n) = sum

 460	   CONTINUE
 490	   CONTINUE

* along E axis
        ELSEIF ( idim .EQ. e_dim ) THEN

           DO 590 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
           DO 590 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
           DO 590 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
           DO 590 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
           DO 590 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* loop through the each destination grid box
	   sum = 0.0D0
           dst(i, j, k, l, dstss_lo, n) = sum
	   DO 560 dstss = dstss_lo,dstss_hi
	      srcss_lo = ss21(dstss-dstss_lo+1)
	      srcss_hi = ss21(dstss-dstss_lo+2)

*  check if requested region is out of source range
              IF ( (srcss_lo .EQ. unspecified_int4
     .	     .OR.  srcss_hi .EQ. unspecified_int4)
     .       .AND. .NOT.(ok_neg111) ) THEN
	         dst(i,j,k,l,dstss,n) = bad_dst
	         goto 560
	      ENDIF

* Get destination edges to use

* Get destination edges to use

	      IF (dstss .EQ. dstss_lo) THEN
 	         xdst_lo = unit_dst* TM_WORLD(dstss, dst_grid, idim, box_lo_lim )
		 xdst_hi = unit_dst* TM_WORLD(dstss, dst_grid, idim, box_middle )
	      ELSE
	         xdst_lo = unit_dst* TM_WORLD(dstss-1, dst_grid, idim, box_middle )
	         xdst_hi = unit_dst* TM_WORLD(dstss, dst_grid, idim, box_middle )
	      ENDIF

* add all partial or complete boxes of data from the source grid

* IF source box completely encloses the dest box, then srcss_lo=srcss_hi
* and we can just add the source point into the sum
	      DO 510 srcss = srcss_lo, srcss_hi

* ... ignore missing source data
	         IF ( src(i, j, k, l, srcss, n) .EQ. bad_src ) GOTO 510

	         xsrc_min = unit_src* TM_WORLD(srcss,src_grid,idim,box_lo_lim)
	         xsrc_max = unit_src* TM_WORLD(srcss,src_grid,idim,box_hi_lim)

	        src_encloses = 
     .               (xdst_lo.GT.xsrc_min .AND. xdst_hi.LT.xsrc_max) 

	         xsrc_lo = MAX(xsrc_min,xdst_lo)
	         xsrc_hi = MIN(xsrc_max,xdst_hi)

	         ddist   = xsrc_hi - xsrc_lo

* ... contribution from this source box
                 IF (ddist .GT. 0.) THEN
	            sum = sum + ddist*  src(i, j, k, l, srcss, n)
	         ENDIF
 510	      CONTINUE
              dst(i, j, k, l, dstss, n) = sum

 560	   CONTINUE
 590	   CONTINUE

* along F axis
        ELSEIF ( idim .EQ. f_dim ) THEN

           DO 690 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
           DO 690 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
           DO 690 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
           DO 690 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
           DO 690 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* loop through the each destination grid box
	   sum = 0.0D0
           dst(i, j, k, l, m, dstss_lo) = sum
	   DO 660 dstss = dstss_lo,dstss_hi
	      srcss_lo = ss21(dstss-dstss_lo+1)
	      srcss_hi = ss21(dstss-dstss_lo+2)

*  check if requested region is out of source range
              IF ( (srcss_lo .EQ. unspecified_int4
     .	     .OR.  srcss_hi .EQ. unspecified_int4)
     .       .AND. .NOT.(ok_neg111) ) THEN
	         dst(i,j,k,l,m,dstss) = bad_dst
	         goto 660
	      ENDIF

* Get destination edges to use

* Get destination edges to use

	      IF (dstss .EQ. dstss_lo) THEN
 	         xdst_lo = unit_dst* TM_WORLD(dstss, dst_grid, idim, box_lo_lim )
		 xdst_hi = unit_dst* TM_WORLD(dstss, dst_grid, idim, box_middle )
	      ELSE
	         xdst_lo = unit_dst* TM_WORLD(dstss-1, dst_grid, idim, box_middle )
	         xdst_hi = unit_dst* TM_WORLD(dstss, dst_grid, idim, box_middle )
	      ENDIF

* add all partial or complete boxes of data from the source grid

* IF source box completely encloses the dest box, then srcss_lo=srcss_hi
* and we can just add the source point into the sum
	      DO 610 srcss = srcss_lo, srcss_hi

* ... ignore missing source data
	         IF ( src(i, j, k, l, m, srcss) .EQ. bad_src ) GOTO 610

	         xsrc_min = unit_src* TM_WORLD(srcss,src_grid,idim,box_lo_lim)
	         xsrc_max = unit_src* TM_WORLD(srcss,src_grid,idim,box_hi_lim)

	        src_encloses = 
     .               (xdst_lo.GT.xsrc_min .AND. xdst_hi.LT.xsrc_max) 

	         xsrc_lo = MAX(xsrc_min,xdst_lo)
	         xsrc_hi = MIN(xsrc_max,xdst_hi)

	         ddist   = xsrc_hi - xsrc_lo

* ... contribution from this source box
                 IF (ddist .GT. 0.) THEN
	            sum = sum + ddist*  src(i, j, k, l, m, srcss)
	         ENDIF
 610	      CONTINUE
              dst(i, j, k, l, m, dstss) = sum

 660	   CONTINUE
 690	   CONTINUE

        ENDIF

 5000	CONTINUE
	line_modulo( grid_line(idim,src_grid) ) = lmod
	RETURN

 5100   status = ferr_invalid_command
	GOTO 5000
	END

	INTEGER FUNCTION GET_NDX (datum,ndx)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Gets bundle index for fill area calls
*	J Davison 5.17.90
*	Mod *jd* 10.1.92 to use 1 fill index                    

* 	Mod *sh* 4/97 -- removed checks on valid coordinates from this routine
*		to a separate new routine, BAD_XY_COORD

* 	Mod *sh* 11/97 -- changed calling args by eliminating "i,j" so this
*		routine can be used for 1D (polygon fill) as well as 2D
*		Also: bug in this code: if there is no valid
*	        index for datum then "bad_val" was returned. But bad_val is
*		a REAL!!   Now return -999 instead (quick hack).
*		Also had to add explicit range checks since whatever logic
*		made rng chks mysteriously unnecessary using REAL bad_flag has
*		changed
*  V5.71 *acm*  6/15/04 Use TM_FPEQ_SNGL when checking whether a single-level zlev is
*               the same as datum.
*  v581 *acm* 3/05 open levels (-INF) (INF)
*  V62+ *acm* 6/09 fix bug 1671: data level exactly matching top of upper level 
*                  wasnt plotted on SHADE and POLY plots
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus
* V697 *acm* 12/15 Fix ticket 2326: single level plus (inf) and/or (-inf)

	include		'parampl5_dat.decl'
	include		'PARAMPL5.DAT'
	include		'miss_inc.decl'
	include		'MISS.INC'
        include         'hd_inc.decl'
        include         'HD.INC'
	include		'cont_inc.decl'
	include		'CONT.INC'
	include		'shade_vars.cmn'

* Calling argument declarations
	integer		ndx
        real            datum

* Local variable declarations
	real	        test
	integer		lev1, levn
        logical         TM_FPEQ_SNGL

********************************************************************************

*	      CHECK AGAINST 'LIMITS' VALUES AND FIND COLOR INDEX

              lev1 = 1
              levn = nlev2
              IF (neginf) lev1 = 2
              IF (posinf) levn = MAX(2,nlev2-1)

	      if(
     .		 (zle.and.datum.le.cmzle) 	.or.
     .		 (zeq.and.datum.eq.cmzeq) 	.or.
     .		 (zge.and.datum.ge.cmzge)) then

	         get_ndx = -999
* ... 12/4/97 added range checks

	      else if (datum .lt. zlev(lev1) .AND. (.NOT.neginf) ) then
	         get_ndx = -999
	      else if (datum .gt. zlev(levn) .AND. (.NOT.posinf) ) then
	         get_ndx = -999
* ... 12/4/97

c	      else if (levn - lev1 .LE. 1) then
	      else if (levn .LE. 1) then
		 if ( TM_FPEQ_SNGL(datum, zlev(lev1)) ) then
		    get_ndx = 2
		 else
		    get_ndx = -999
		 endif
	      else   
                 IF (( datum .LT. zlev(lev1) ) .AND. neginf ) THEN
                    get_ndx = 2
                 ELSE IF ( (datum .GT. zlev(levn) ) .AND. posinf) THEN
                    get_ndx = nlev2
                 ELSE
	            call locator (zlev(lev1),lev1,levn,datum,ndx)

	            if (ndx .eq. levn) THEN
		       IF (datum .eq. zlev(levn)) then 
		          get_ndx = levn
		       else
                          IF (posinf) then
	                     get_ndx = nlev2
	                  else
                             get_ndx = -999
			  endif
                       endif
	            else
	               get_ndx = ndx + 1
	            end if
                 ENDIF
	      end if

	return
	end

      SUBROUTINE RANGEL(UAMIN,UAMAX,UMINR,UMAXR)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)rangel.f	1.1    3/10/88
C** V600:  1/06 *acm*  prevent values of LOG10(0.0)
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     CALL RANGEL(UMIN,UMAX,UMINR,UMAXR)
C
C     THIS SUBROUTINE FINDS TWO VALUES FOR A VARIABLE SUCH THAT
C     EACH IS AN INTEGER POWER OF TEN AND THE RANGE BETWEEN THEM
C     CONTAINS THE MINIMUM AND MAXIMUM VALUES OF THE VARIABLE.
C
C     THE VARIOUS PARAMETERS AND THEIR DEFINITIONS ARE LISTED
C     BELOW:
C        UMIN   - MINIMUM VALUE OF THE VARIABLE.
C        UMAX   - MAXIMUM VALUE OF THE VARIABLE.
C        UMINR  - MINIMUM VALUE OF THE RANGE.
C        UMAXR  - MAXIMUM VALUE OF THE RANGE.
C
C
C     TRANSFER THE PARAMETERS TO NEW VARIABLES.
C
      UMIN = ABS(UAMIN)
      UMAX = ABS(UAMAX)

C
C     CHECK THE PARAMETERS TO MAKE SURE THAT THEY ARE VALID.
C
      IF(UMIN .GT. UMAX)THEN
        TEMP = UMIN
        UMIN = UMAX
        UMAX = TEMP
      ENDIF
C
C     CALCULATE THE MINIMUM VALUE OF THE RANGE.
C
      IF (UMIN .EQ. 0.) THEN
         FM = 0.
      ELSE
         FM = ALOG10(UMIN)
      ENDIF
      M = IFIX(FM)
      IF(FM .LT. 0.0)M = M - 1
      UMINR = 10.0 ** M
C
C     CALCULATE THE MAXIMUM VALUE OF THE RANGE.
C
      IF (UMAX .EQ. 0.) THEN
         FM = 0.
      ELSE
         FM = ALOG10(UMAX)
      ENDIF
      M = IFIX(FM)
      IF(FM .GT. 0.0)M = M + 1
      UMAXR = 10.0 ** M
      RETURN
C
      END

 	SUBROUTINE INIT_COUNTER_VAR ( name, text, txstart, txend, 
     .                 xlo, xhi, del, cvar, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Compile a variable structure into a counter variable.
* Expression is of the form LO:HI or LO:HI:DEL
* 1/21/04 *acm* from init_user_var.F
* V554 1/04 *acm* - additions for /RANGE repeat loop control

* V554 3/04 *acm* - fix error messages
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'	
	include 'errmsg.parm'	
	include 'rpn.parm'
	include 'xvariables.cmn'
	include 'xrisc_buff.cmn'
        include 'xalgebra.cmn'
	include	'xcontext.cmn'
	include 'xfr_grid.cmn'

* calling argument declarations:
	CHARACTER*(*)	name, text
	INTEGER		txstart, txend, xlo, xhi, del,  cvar, status

* internal variable declarations:

        INTEGER		TM_LENSTR, ATOM_POS, STR_UPCASE, iflag, 
     .                  slen, colon_pos, colon2_pos, lo_start, lo_end, 
     .                  hi_start, hi_end, del_start, del_end, dum
        LOGICAL         colon, colon2, fmat, logical_dummy, by_ss
        REAL*8          answer		
        CHARACTER*50    err_msg

* find an unused counter var slot for the variable
	DO 100 cvar = 1, num_counter_vars
	   IF ( alg_cvar( cvar ) .EQ. unspecified_name4 ) GOTO 1000
 100	CONTINUE
	GOTO 5100

* initialize the counter variable, "cvar"
* algebraic expression too long ?

1000	IF ( txend-txstart .GE. cvar_text_len ) CALL ERRMSG
     .  ( ferr_line_too_long, status, text(txend-14:txend), *5000 )

* copy name code and text into slot and change as needed to upper case
* Should not have any text: these variables are LO:HI:DEL


* copy name code and text into slot and change as needed to upper case
*	iflag = STR_UPCASE( countervar_name( cvar ), name )
        CALL string_array_modify_upcase(countervar_name_head,
     .                           cvar,
     .                           name,
     .                           LEN(name))

        iflag = STR_UPCASE( alg_cvar( cvar ), text(txstart:txend) )

* get the X range

        slen = TM_LENSTR(text)
        IF (slen .LT. 3) CALL ERRMSG
     .	 ( ferr_invalid_command, status, 
     .     'REPEAT/RANGE without range ?', *5000 )

* ... ":"
        lo_start = 1
        colon = .FALSE.
	colon_pos = ATOM_POS( text, ':' )
	IF ( colon_pos .EQ. atom_illegal_pos ) GOTO 5200
	colon  = colon_pos .NE. atom_not_found
	IF ( colon ) THEN
	   lo_end	 = colon_pos - 1
	ELSE
	   colon2	 = .FALSE.
	   lo_end	 = slen
	ENDIF
        IF (.NOT. colon) GOTO 5200

*  ... second ":"

        colon2 = .FALSE.
	IF ( colon ) THEN
	   colon2_pos = ATOM_POS(text( colon_pos+1:slen ), ':' )
	   IF ( colon2_pos .EQ. atom_illegal_pos
     .	   .OR. colon2_pos .EQ. 1 ) GOTO 5200
	   colon2 = colon2_pos .NE. atom_not_found
	   IF ( colon2 ) THEN
	      colon2_pos = colon2_pos + colon_pos
	      hi_end     = colon2_pos - 1
	      IF (INDEX(text(colon2_pos+1:slen),':').GT.0) GOTO 5200
	   ELSE
	      hi_end     = slen
	   ENDIF
	   hi_start	 = colon_pos + 1
	   del_start	 = colon2_pos + 1
           del_end       = slen
	ENDIF

* Call translate_limit to check syntax and set ss limits

        by_ss = .TRUE.
        dum = 1

	CALL TRANSLATE_LIMIT
     .		      (  text(lo_start:lo_end), x_dim,
     .			by_ss, answer, fmat, dum, status )
        xlo = INT(answer)

	CALL TRANSLATE_LIMIT
     .		      (  text(hi_start:hi_end), x_dim,
     .			by_ss, answer, fmat, dum, status )
        xhi = INT(answer)

	del = 1
        IF (colon2) THEN
           CALL TRANSLATE_LIMIT
     .		      ( text(del_start:del_end), x_dim,
     .			by_ss, answer, logical_dummy, dum, status )
           del = INT(answer)
        ENDIF

* successful completion
	status = ferr_ok
	RETURN	

* error exit
 5000	RETURN

 5100	WRITE (err_msg, 4000) num_counter_vars
        CALL ERRMSG( ferr_prog_limit, status,
     .		'too many counter variables'//pCR//
     .		err_msg, *5000 ) 
 4000   FORMAT ('maximum number is ', i3)
 5200   CALL ERRMSG( ferr_syntax, status, 
     .	          risc_buff(:slen)//pCR//
     .'":" used incorrectly. A correct example is "RANGE=1:100:10".',
     .	          *5000)
        END

	SUBROUTINE IS_READ (  *, *, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* read a grid of data from a system file
* this routine merely looks at the class of data set to decide on the
* appropriate underlying routine to actually get the data

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/19/87
* revision 0.1 - 9/11/87 - changed check of ds_format to ds_type 
*			   and 'GT' --> '  GT' for new TMAP library
* revision 0.2 - 11/2/88 - IS_READ_GT --> IS_READ_TM (ss-symmetrical)
* V200: 10/25/89 - EZ data type added
* 	 2/27/90 - unspecified limits are set with FLESH_OUT_AXIS
* V230:  3/2/92 - added netCDF support
* V312: 5/94 - array "memory" as a calling argument
* V320: 2/95 - allow for category cat_file_rev (a file variable with
*		reversed axes)
* 12/96 *kob* - Linux Port - had to move variable assignments off of
*               declaration line. used DATA statment rather than a
*	        PARAMETER statement because variable was modified in code
* 	      - Added a preprocessor include for tmap_dset.parm
*	        because it needed a preprocessor.
*  7/98 *js*  - Hacked to add support for permuted binary file reads
* V530: *sh* 11/00 - delimited file reading added
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

* calling argument declarations:
	INTEGER	status
* normal exit is for error conditions
* exit #1 is to request another grid ( stack has been pushed )
* exit #2 is to signal completion of the activity at this stack level

* internal variable declarations:
	LOGICAL		reprimand
	DATA       	reprimand/.TRUE./
	INTEGER 	CGRID_AXIS, cx, dset_num, idim, cat

	include	'tmap_dims.parm'
#	include	"tmap_dset.parm"
	include	'xdset_info.cmn_text'
	external xdset_info_data
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xtext_info.cmn'

* --- end of introductory code ---

* initialize
	cx = is_cx( isp )
	dset_num = cx_data_set( cx )

* for the duration of this routine replace cat_revfile_var with cat_file_var
* (since most routines cannot cope with cat_revfile_var)
	cat = cx_category(cx)
	cx_category(cx) = cat_file_var

* ensure that all needed limits are known
	DO 100 idim = 1, nferdims
	   IF ( cx_lo_ss( cx, idim ) .NE. unspecified_int4 ) GOTO 100
	   IF ( CGRID_AXIS( idim, cx ) .EQ. mnormal ) GOTO 100
	   IF ( reprimand ) THEN
	      CALL WARN
     .		('FERRET is more efficient if regions are fully specified' )
	      CALL WARN( ww_dim_name(idim)//
     .		' axis limits are unspecified - possibly others, too' )
	      reprimand = .FALSE.		! only remind them once
	   ENDIF
	   CALL FLESH_OUT_AXIS( idim, cx, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000		! should never happen
!	   CALL ERRMSG( ferr_limits, status,
!     .			ww_dim_name(idim)//' axis limits are unknown for '//
!     .			VAR_CODE( cat_file_var, cx_variable(cx) ), *5000 )
 100	CONTINUE

* choose the appropriate routine to read the data
	IF ( ds_type( dset_num ) .EQ. pds_type_ez ) THEN
* all stream formatted files now read with new fast binary reads
	   IF ( ds_parm_text(1,dset_num)(:3) .eq. 'STR') THEN
	      CALL READ_BINARY(  cx, is_mr(isp), status)
	   ELSEIF ( ds_parm_text(1,dset_num)(:4) .eq. 'DELI') THEN
	      CALL READ_DELIMITED(  cx, is_mr(isp), status)
	   ELSEIF ( ds_parm_text(1,dset_num)(:4) .eq. 'PERL') THEN
	      CALL READ_PERL(  cx, is_mr(isp), status)
	   ELSE
	      CALL READ_EZ(  cx, is_mr(isp), status )
	   ENDIF
	   IF ( status .EQ. ferr_ok ) GOTO 2
	ELSE
	   CALL READ_TM(  cx, is_mr(isp), status )
	   IF ( status .EQ. ferr_ok ) GOTO 2
	ENDIF

* error exit
 5000	cx_category(cx) = cat
 	RETURN

* never need components since TM IO library handles 4D accesses as of 11/88
! 1	cx_category(cx) = cat
!	RETURN 1

* done - we got what was asked for
 2	cx_category(cx) = cat
	RETURN 2
	END	

* support code for Ferret EF taken from "program ocn_obs"
* *sh* 12/00

* original documentation follows
* for the Ferret EF application the code has been reduced to two subroutines
*   INTEGER FUNCTION OPEN_OCN_OBS(filename,errmsg)
*   SUBROUTINE READ_OCN_OBS(result, nvars, nobs, errmsg)

*** START OF ORIGINAL DOCUMENTATION ***
c
c.............................START PROLOGUE............................
c
c SCCS IDENTIFICATION:  %W% %G%
c
c MODULE NAME:  ocn_obs
c
c DESCRIPTION:  simple driver for processing FNMOC ocean obs files
c                  altim - TOPEX and ERS altimeter SSHA
c                  mcsst - AVHRR SST retrievals
c                profile - subsurface measures of in situ T and S
c                   ship - in situ surface measures of T
c                   ssmi - DMSP sea ice concentration retrievals
c
c               documentation of the variables for each ocean obs
c               file is contained within the respective "rd" routines:
c                  rd_altim, rd_mcssst, rd_prof, rd_ship, rd_ssmi
c
c               the first record in all of the FNMOC ocean obs files
c               contains the number the observations in that file
c               and the maximum number of observation levels (can be
c               greater than 1 for the {dtg}.profile files).  as in
c               this simple driver routine, these variables can be
c               read and passed as automatic array dimensions to a
c               subroutine.
c
c               the code assumes that the ocean obs data files are
c               in a directory structure given by
c                  $data_dir/altim
c                           /mcsst
c                           /profile
c                           /ship
c                           /ssmi
c               where $data_dir is an environmental variable
c               defined by "OCEAN_OBS_DIR" that describes the
c               directory path to the top of ocean obs tree
c
c               all of the code required is concatentated in
c               the ocn_obs.f file.  a compilation can be
c               done using the following (for SGI)
c                  f90 -r4 -i4 -o ocn_obs obs_obs.f
c
c               the GETARG and GETENV routines may be different
c               on SUN SPARC workstations
c
c               to see what command line arguments are required,
c               execute ocn_obs with no command line arguments
c
c               temperature units are deg C, salinity units are
c               PSU, sea surface height units are meters, and
c               sea ice concentration units are per cent.
c
c               unless otherwise specified, missing values are
c               set to -999 in all of the ocean obs data files
c
c....................MAINTENANCE SECTION................................
c
c MODULES CALLED:
c        Name                    Description
c   --------------     -------------------------------------
c   error_exit         standard error processing
c   GETARG             retrieve command line argument
c   GETENV             retrieve environmental variable
c   rd_altim           read satellite altimeter SSHA observations
c   rd_mcsst           read AVHRR satellite SST retrievals
c   rd_prof            read profile temperatures and salinities
c   rd_ship            read surface temperature observations
c   rd_ssmi            read ssmi sea ice retrievals
c
c..............................END PROLOGUE.............................
c

*** END OF ORIGINAL DOCUMENTATION ***


      SUBROUTINE READ_OCN_OBS(file_dtg, result, nvars, nobs, errmsg)

      INTEGER nvars, nobs
      REAL*4 result(nobs, nvars)
      character file_dtg * 10
      CHARACTER*(*) errmsg

      integer    UNIT
      parameter (UNIT = 60)

      call rd_ship (UNIT, file_dtg, result, nvars, nobs)
      close (UNIT)
      errmsg = ' '
      RETURN
      END
  
*
**********************
*

      INTEGER FUNCTION OPEN_OCN_OBS(file_dtg,err_msg)


      implicit  none
c
c     ..set local data file fortran unit number
c
      integer    UNIT
      parameter (UNIT = 60)
c
      character*(*) err_msg
      character file_dtg * 10

      character arg * 80
      character data_dir * 256
      logical   exist
      character file_name * 256
      integer   len
      integer   n_arg
      integer*4 n_lvl
      integer*4 n_obs
      character obs_typ * 5

        INTEGER TM_LENSTR
c
c...............................executable..............................
c

c
c     ..retrieve file root directory
c
        obs_typ = 'ship'

c
c     ..retrieve file root directory
c
      call GETENV ('OCN_OBS_DIR', data_dir)
      len = TM_LENSTR (data_dir)
      if (len .eq. 0) then
         data_dir = '.'
         len = TM_LENSTR (data_dir)
      endif
c
c-----------------------------------------------------------------------
c
c     ..profile observations
c
#if 0
      if (obs_typ(1:4) .eq. 'prof') then
         open (45, file='report.profile', status='unknown',
     *             form='formatted')
         write (45, '(''   ****** Reading PROFILE Data ******'')')
         write (45, '(''   file date time group: '', a)') file_dtg
         write (45, '(''    data directory path: '', a)')
     *          data_dir(1:len)
         file_name = data_dir(1:len) // '/profile/' //
     *               file_dtg // '.profile'
         len = TM_LENSTR (file_name)
         inquire (file=file_name(1:len), exist=exist)
         if (exist) then
            open (UNIT, file=file_name(1:len), status='old',
     *                  form='unformatted')
            read (UNIT) n_obs, n_lvl
            write (45, '(''        number profiles: '', i10)') n_obs
            write (45, '(''      max number levels: '', i10)') n_lvl
            if (n_obs .gt. 0) then
               call rd_prof (UNIT, n_obs, n_lvl)
            endif
            close (UNIT)
         else
            write (err_msg, '(''file "'', a, ''" does not exist'')')
     *             file_name(1:len)
            call error_exit ('OCN_OBS', err_msg)
         endif
# endif
c
c-----------------------------------------------------------------------
c
c     ..surface ship/buoy observations
c
!      else if (obs_typ(1:4) .eq. 'ship') then
      if (obs_typ(1:4) .eq. 'ship') then
         open (45, file='report.ship', status='unknown',
     *             form='formatted')
         write (45, '(''   ****** Reading SHIP Data ******'')')
         write (45, '(''   file date time group: '', a)') file_dtg
         write (45, '(''    data directory path: '', a)')
     *          data_dir(1:len)
         file_name = data_dir(1:len) // '/ship/' //
     *               file_dtg // '.ship'
         len = TM_LENSTR (file_name)
         inquire (file=file_name(1:len), exist=exist)
         if (exist) then
            open (UNIT, file=file_name(1:len), status='old',
     *                  form='unformatted')
            read (UNIT) n_obs
            write (45, '(''        number ship obs: '', i10)') n_obs

c
c   successfully opened the file
c
            err_msg = ' '
            OPEN_OCN_OBS = n_obs
            RETURN
         else
            err_msg = 'file "'//file_name(:len)//'" does not exist'
            OPEN_OCN_OBS = 0
         endif
c
c-----------------------------------------------------------------------
c
c     ..mcsst observations
c
#if 0
      else if (obs_typ(1:5) .eq. 'mcsst') then
         open (45, file='report.mcsst', status='unknown',
     *             form='formatted')
         write (45, '(''   ****** Reading MCSST Data ******'')')
         write (45, '(''   file date time group: '', a)') file_dtg
         write (45, '(''    data directory path: '', a)')
     *          data_dir(1:len)
         file_name = data_dir(1:len) // '/mcsst/' //
     *               file_dtg // '.mcsst'
         len = TM_LENSTR (file_name)
         inquire (file=file_name(1:len), exist=exist)
         if (exist) then
            open (UNIT, file=file_name(1:len), status='old',
     *                  form='unformatted')
            read (UNIT) n_obs
            write (45, '(''       number mcsst obs: '', i10)') n_obs
            if (n_obs .gt. 0) then
               call rd_mcsst (UNIT, n_obs)
            endif
            close (UNIT)
         else
            write (err_msg, '(''file "'', a, ''" does not exist'')')
     *             file_name(1:len)
            call error_exit ('OCN_OBS', err_msg)
         endif
# endif
c
c-----------------------------------------------------------------------
c
c     ..altimeter observations
c
#if 0
      else if (obs_typ(1:5) .eq. 'altim') then
         open (45, file='report.altim', status='unknown',
     *             form='formatted')
         write (45, '(''   ****** Reading ALTIM Data ******'')')
         write (45, '(''   file date time group: '', a)') file_dtg
         write (45, '(''    data directory path: '', a)')
     *          data_dir(1:len)
         file_name = data_dir(1:len) // '/altim/' //
     *               file_dtg // '.altim'
         len = TM_LENSTR (file_name)
         inquire (file=file_name(1:len), exist=exist)
         if (exist) then
            open (UNIT, file=file_name(1:len), status='old',
     *                  form='unformatted')
            read (UNIT) n_obs
            write (45, '(''       number altim obs: '', i10)') n_obs
            if (n_obs .gt. 0) then
               call rd_altim (UNIT, n_obs)
            endif
            close (UNIT)
         else
            write (err_msg, '(''file "'', a, ''" does not exist'')')
     *             file_name(1:len)
            call error_exit ('OCN_OBS', err_msg)
         endif
# endif
c
c-----------------------------------------------------------------------
c
c     ..SSM/I sea ice observations
c
#if 0
      else if (obs_typ(1:4) .eq. 'ssmi') then
         open (45, file='report.ssmi', status='unknown',
     *             form='formatted')
         write (45, '(''   ****** Reading SSMI Data ******'')')
         write (45, '(''   file date time group: '', a)') file_dtg
         write (45, '(''    data directory path: '', a)')
     *          data_dir(1:len)
         file_name = data_dir(1:len) // '/ssmi/' //
     *               file_dtg // '.ssmi'
         len = TM_LENSTR (file_name)
         inquire (file=file_name(1:len), exist=exist)
         if (exist) then
            open (UNIT, file=file_name(1:len), status='old',
     *                  form='unformatted')
            read (UNIT) n_obs
            write (45, '(''        number ssmi obs: '', i10)') n_obs
            if (n_obs .gt. 0) then
               call rd_ssmi (UNIT, n_obs)
            endif
            close (UNIT)
         else
            write (err_msg, '(''file "'', a, ''" does not exist'')')
     *             file_name(1:len)
            call error_exit ('OCN_OBS', err_msg)
         endif
# endif
c
c-----------------------------------------------------------------------
c
c     ..unknown obs data type 
c
      else
        err_msg = 'unknown obs TYPE'
        OPEN_OCN_OBS = 0
      endif
c
      stop
      end


      subroutine rd_altim (UNIT, n_obs)
c
c.............................START PROLOGUE............................
c
c SCCS IDENTIFICATION:  %W% %G%
c
c MODULE NAME:  rd_altim
c
c DESCRIPTION:  reads the ALTIM ocean obs files and produces a report
c
c PARAMETERS:
c      Name          Type        Usage            Description
c   ----------     ---------     ------    ---------------------------
c   n_obs           integer      input     number altim obs
c   unit            integer      input     FORTRAN unit number
c
c ALTIMETER VARIABLES:
c     ame       Type                     Description
c   --------  --------    ----------------------------------------------
c   ob_age     real       age of the observation in hours since
c                         January 1, 1992.  provides a continuous
c                         time variable
c   ob_clim    real       SSHA climatological estimate at obs
c                         location and sampling time
c   ob_cycle   integer    satellite cycle number
c   ob_dtg     character  SSHA obs date time group in the form
c                         year, month, day, hour, minute,
c                         second (YYYYMMDDHHMMSS)
c   ob_glbl    real       SSHA global analysis estimate at obs
c                         location and receipt time at FNMOC
c   ob_lat     real       SSHA obs latitude (south negative)
c   ob_lon     real       SSHA obs longitude (west negative)
c   ob_qc      real       SSHA obs probability of a gross error
c                         (assumes normal pdf of SSHA errors)
c   ob_regn    real       SSHA regional analysis estimate at obs
c                         location and receipt time at FNMOC
c   ob_sat     integer    satellite ID (TOPEX, ERS, GFO) - see
c                         ocn_types.h for codes
c   ob_sgma    real       climatological variability of SSHA at
c                         obs location and time of year
c   ob_smpl    integer    sequential sample number along a
c                         satellite track
c   ob_ssh     real       SSHA observation (meters) in terms of
c                         deviation from a long term TOPEX mean
c   ob_track   integer    satellite track number for cycle
c
c..............................END PROLOGUE.............................
c
      implicit none
c
      include 'ocn_types.h'
c
c     ..local array dimensions
c
      integer*4 n_obs
c
      integer   i, k
      real*4    ob_age (n_obs)
      real*4    ob_clim (n_obs)
      integer*4 ob_cycle (n_obs)
      character ob_dtg (n_obs) * 14
      real*4    ob_glbl (n_obs)
      real*4    ob_lat (n_obs)
      real*4    ob_lon (n_obs)
      real*4    ob_qc (n_obs)
      real*4    ob_regn (n_obs)
      integer*4 ob_smpl (n_obs)
      integer*4 ob_sat (n_obs)
      real*4    ob_sgma (n_obs)
      real*4    ob_ssh (n_obs)
      integer*4 ob_track (n_obs)
      integer   UNIT
c
c...............................executable..............................
c
c     ..read altimeter variables
c
      read (UNIT) (ob_age(i), i = 1, n_obs)
      read (UNIT) (ob_clim(i), i = 1, n_obs)
      read (UNIT) (ob_cycle(i), i = 1, n_obs)
      read (UNIT) (ob_glbl(i), i = 1, n_obs)
      read (UNIT) (ob_lat(i), i = 1, n_obs)
      read (UNIT) (ob_lon(i), i = 1, n_obs)
      read (UNIT) (ob_qc(i), i = 1, n_obs)
      read (UNIT) (ob_regn(i), i = 1, n_obs)
      read (UNIT) (ob_smpl(i), i = 1, n_obs)
      read (UNIT) (ob_sat(i), i = 1, n_obs)
      read (UNIT) (ob_sgma(i), i = 1, n_obs)
      read (UNIT) (ob_ssh(i), i = 1, n_obs)
      read (UNIT) (ob_track(i), i = 1, n_obs)
      read (UNIT) (ob_dtg(i), i = 1, n_obs)
c
c     ..produce altimeter report
c
      k = 100
      write (45, '(''  reporting skip factor: '', i10)') k
      write (45, '(11x,''dtg'', 5x,''lat'', 5x,''lon'', 5x,''sat'',
     *             5x,''ssh'', 4x,''clim'', 4x,''glbl'', 4x,''regn'',
     *             6x,''qc'',  3x,''cycle'', 4x,''trak'', 4x,''smpl'',
     *             4x,''sgma'')')
      do i = 1, n_obs, k
         write (45, '(a,2f8.2,i8,f8.4,3f8.3,f8.4,3i8,f8.4,2x,a)')
     *          ob_dtg(i), ob_lat(i), ob_lon(i), ob_sat(i),
     *          ob_ssh(i), ob_clim(i), ob_glbl(i), ob_regn(i),
     *          ob_qc(i), ob_cycle(i), ob_track(i), ob_smpl(i),
     *          ob_sgma(i), data_lbl(ob_sat(i))
      enddo
c
      return
      end


      subroutine rd_mcsst (UNIT, n_obs)
c
c.............................START PROLOGUE............................
c
c SCCS IDENTIFICATION:  %W% %G%
c
c MODULE NAME:  rd_mcsst
c
c DESCRIPTION:  reads the MCSST ocean obs files and produces a report
c
c PARAMETERS:
c      Name          Type        Usage            Description
c   ----------     ---------     ------    ---------------------------
c   n_obs           integer      input     number mcsst obs
c   unit            integer      input     FORTRAN unit number
c
c MCSST VARIABLES:
c      Name      Type                      Description
c   ----------  -------     --------------------------------------------
c   ob_age      real        age of the observation in hours since
c                           January 1, 1992.  provides a continuous
c                           time variable
c   ob_aod      real        NESDIS aeorosol optical depth at SST 
c                           obs and sampling time (to within +/- 
c                           24 hrs).  missing AODs are set to -1.
c   ob_clim     real        NCEP SST climatological estimate at obs
c                           location and sampling time
c   ob_csgm     real        NCEP SST climatology variability estimate 
c                           at obs location and receipt time at FNMOC
c                           (not implemented yet)
c   ob_dtg      character   SST obs date time group in the form year,
c                           month, day, hour, minute (YYYYMMDDHHMM)
c   ob_glbl     real        SST global analysis estimate at obs
c                           location and receipt time at FNMOC
c   ob_gsgm     real        global SST analysis variability estimate at
c                           obs location and receipt time at FNMOC
c                           (not implemented yet)
c   ob_lat      real        SST obs latitude (south negative)
c   ob_lon      real        SST obs longitude (west negative)
c   ob_qc       real        SST obs probability of a gross error
c                           (assumes normal pdf of SST errors)
c   ob_regn                 SST regional analysis estimate at obs
c                           location and receipt time at FNMOC
c   ob_rsgm     real        regional SST analysis variability estimate
c                           at obs location and receipt time at
c                           FNMOC (not implemented yet)
c   ob_sst      real        SST observation
c   ob_type     integer     SST obseration data type; NOAA14 or NOAA15
c                           day, night, relaxed day retrievals (see 
c                           ocn_types.h for codes)
c   ob_wm       integer     SST water mass indicator from Bayesian
c                           classification scheme.  only valid in
c                           western North Pacific, western North
c                           Atlantic or GIN-Seas regions.  used to
c                           prevent averaging of SST observations
c                           from different water mass during the
c                           computation of SST super-obs; helps
c                           maintain SST fronts and eddies in the
c                           analysis of western boundary currents
c
c..............................END PROLOGUE.............................
c
      implicit none
c
      include 'ocn_types.h'
c
c     ..local array dimensions
c
      integer*4 n_obs
c
      integer   i, k
      real*4    ob_age (n_obs)
      real*4    ob_aod (n_obs)
      real*4    ob_clim (n_obs)
      real*4    ob_csgm (n_obs)
      character ob_dtg (n_obs) * 12
      real*4    ob_glbl (n_obs)
      real*4    ob_gsgm (n_obs)
      real*4    ob_lat (n_obs)
      real*4    ob_lon (n_obs)
      real*4    ob_qc (n_obs)
      real*4    ob_regn (n_obs)
      real*4    ob_rsgm (n_obs)
      real*4    ob_sst (n_obs)
      integer*4 ob_type (n_obs)
      integer*4 ob_wm (n_obs)
      integer   UNIT
c
c...............................executable..............................
c
c     ..read mcsst variables
c
      read (UNIT) (ob_wm(i), i = 1, n_obs)
      read (UNIT) (ob_glbl(i), i = 1, n_obs)
      read (UNIT) (ob_lat(i), i = 1, n_obs)
      read (UNIT) (ob_lon(i), i = 1, n_obs)
      read (UNIT) (ob_age(i), i = 1, n_obs)
      read (UNIT) (ob_clim(i), i = 1, n_obs)
      read (UNIT) (ob_qc(i), i = 1, n_obs)
      read (UNIT) (ob_type(i), i = 1, n_obs)
      read (UNIT) (ob_regn(i), i = 1, n_obs)
      read (UNIT) (ob_sst(i), i = 1, n_obs)
      read (UNIT) (ob_aod(i), i = 1, n_obs)
      read (UNIT) (ob_dtg(i), i = 1, n_obs)
c     read (UNIT) (ob_csgm(i), i = 1, n_obs)
c     read (UNIT) (ob_gsgm(i), i = 1, n_obs)
c     read (UNIT) (ob_rsgm(i), i = 1, n_obs)
      do i = 1, n_obs
         ob_csgm(i) = -999.
         ob_gsgm(i) = -999.
         ob_rsgm(i) = -999.
      enddo
c
c     ..produce mcsst report
c
      k = 100
      write (45, '(''  reporting skip factor: '', i10)') k
      write (45, '(9x,''dtg'', 5x,''lat'', 5x,''lon'', 4x,''type'',
     *             5x,''sst'', 4x,''clim'', 4x,''glbl'', 4x,''regn'',
     *             6x,''qc'',  5x,''aod'', 4x,''csgm'', 4x,''gsgm'',
     *             4x,''rsgm'', 2x,''wm'')')
      do i = 1, n_obs, k
         write (45, '(a,2f8.2,i8,4f8.2,2f8.4,3f8.2,i4,2x,a)')
     *          ob_dtg(i), ob_lat(i), ob_lon(i), ob_type(i),
     *          ob_sst(i), ob_clim(i), ob_glbl(i), ob_regn(i),
     *          ob_qc(i), ob_aod(i), ob_csgm(i), ob_gsgm(i),
     *          ob_rsgm(i), ob_wm(i), data_lbl(ob_type(i))
      enddo
c
      return
      end


      subroutine rd_prof (UNIT, n_obs, n_lvl)
c
c.............................START PROLOGUE............................
c
c SCCS IDENTIFICATION:  %W% %G%
c
c MODULE NAME:  rd_prof
c
c DESCRIPTION:  reads the PROFILE ocean obs files and produces a report
c
c PARAMETERS:
c      Name          Type        Usage            Description
c   ----------     ---------     ------    ---------------------------
c   n_obs           integer      input     number profile obs 
c   n_lvl           integer      input     number profile levels
c   unit            integer      input     FORTRAN unit number
c
c PROFILE VARIABLES:
c     ame       Type                     Description
c   --------  --------    ----------------------------------------------
c   ob_btm     real       bottom depth in meters from DBDB5 data base
c                         at profile lat,lon
c   ob_clim    real       MODAS temperature climatology estimate at
c                         profile location, levels and sampling time
c   ob_dtg     character  profile observation sampling date time group
c                         in the form  year, month, day, hour, minute,
c                         second (YYYYMMDDHHMMSS)
c   ob_glbl    real       global analysis estimate of profile
c                         temperatures at profile obs location,
c                         levels, and sampling time
c   ob_lat     real       profile observation latitude (south negative)
c   ob_lon     real       profile observation longitude (west negative)
c   ob_ls      integer    number of observed profile salinity levels
c                         (a zero indicates temperature-only profile)
c   ob_lt      integer    number of observed profile temperature levels
c   ob_lvl     real       observed (and extended) profile levels
c   ob_modas   real       modas synthetic profile estimate at profile
c                         location, levels, and sampling time.  the
c                         predictor variables used in the generation
c                         of the modas synthetic profile are the
c                         ob_sst (SST) and ob_ssh (SSHA) variables.
c   ob_nd      integer    total number of levels for profile observation
c                         includes observed levels (ob_lt) plus levels
c                         to vertically extend the profile to the bottom
c   ob_rcpt    character  profile observation receipt time at FNMOC in
c                         the form year, month, day, hour, minute
c                         (YYYYMMDDHHMM); the difference between
c                         ob_rcpt and ob_dtg gives the timeliness 
c                         of the observation at FNMOC
c   ob_regn    real       regional analysis estimate of profile
c                         temperatures at profile obs location,
c                         levels, and sampling time
c   ob_sal     real       observed (and extended) profile salinities,
c                         if salinity has not been observed it has been
c                         estimated from climatological T/S regressions
c   ob_scr     character  profile obs security classification code; "U"
c                         for unclassified
c   ob_sign    character  profile observation call sign
c   ob_sprb    real       salinity profile level-by-level probability
c                         of a gross error
c   ob_sqc     real       salinity profile overall probability of gross
c                         error (integrates level-by-level errors taking
c                         into account layer thcknesses)
c   ob_ssh     real       SSHA of profile dynamic height from long-term
c                         hydrographic mean.  dynamic height has been
c                         calculated relative to 2000 m or the bottom
c                         whichever is shallower.  profile SSHA is
c                         directly comparable to satellite altimeter
c                         SSHA.  vertically extended levels may have
c                         been used in the dynamic height computation,
c                         so the profile SSHA values must be used with
c                         care for shallow observed profiles (ob_lt)
c   ob_sst     real       SST estimate (in order of high resoloution
c                         regional analysis if available, global
c                         analysis if available, profile SST if
c                         observed shallow enough or SST climatology
c                         (MODAS or GDEM)) valid at profile observation
c                         location and sampling time
c   ob_sstd    real       climatolgical estimates of variability of
c                         salinity at profile location, levels and
c                         sampling time (one standard deviation)
c   ob_tmp     real       observed (and extended) profile temperatures
c   ob_tqc     real       temperature profile overall probability of
c                         gross error (integrates level-by-level errors
c                         taking into account layer thcknesses)
c   ob_tprb    real       temperature profile level-by-level probability
c                         of a gross error
c   ob_tstd    real       climatolgical estimates of variability of
c                         temperature at profile location, levels and
c                         sampling time (one standard deviation)
c   ob_typ     integer    profile data type (see ocean_types.h for
c                         codes)
c 
c..............................END PROLOGUE.............................
c
      implicit none         
c
      include 'ocn_types.h'
c
c     ..local array dimensions
c
      integer*4 n_obs
      integer*4 n_lvl
c
      integer   i, j
      real*4    ob_btm (n_obs)
      real*4    ob_clim (n_lvl, n_obs)
      character ob_dtg (n_obs) * 12
      real*4    ob_glbl (n_lvl, n_obs)
      real*4    ob_lat (n_obs)
      real*4    ob_lon (n_obs)
      real*4    ob_lvl (n_lvl, n_obs)
      integer*4 ob_ls (n_obs)
      integer*4 ob_lt (n_obs)
      real*4    ob_modas (n_lvl, n_obs)
      integer*4 ob_nd (n_obs)
      real*4    ob_sprb (n_lvl, n_obs)
      real*4    ob_sqc (n_obs)
      real*4    ob_tprb (n_lvl, n_obs)
      real*4    ob_tqc (n_obs)
      character ob_rcpt (n_obs) * 12
      real*4    ob_regn (n_lvl, n_obs)
      character ob_scr (n_obs) * 1
      character ob_sign (n_obs) * 7
      real*4    ob_sal (n_lvl, n_obs)
      real*4    ob_ssh (n_obs)
      real*4    ob_sst (n_obs)
      real*4    ob_sstd (n_lvl, n_obs)
      real*4    ob_tmp (n_lvl, n_obs)
      real*4    ob_tstd (n_lvl, n_obs)
      integer*4 ob_typ (n_obs)
      integer   UNIT
c
c...............................executable..............................
c
c     ..read profile variables
c
      read (UNIT) (ob_lt(i),  i = 1, n_obs)
      read (UNIT) (ob_ssh(i), i = 1, n_obs)
      read (UNIT) (ob_btm(i), i = 1, n_obs)
      read (UNIT) (ob_lat(i), i = 1, n_obs)
      read (UNIT) (ob_lon(i), i = 1, n_obs)
      read (UNIT) (ob_nd(i),  i = 1, n_obs)
      read (UNIT) (ob_sqc(i), i = 1, n_obs)
      read (UNIT) (ob_tqc(i), i = 1, n_obs)
      read (UNIT) (ob_typ(i), i = 1, n_obs)
      do i = 1, n_obs
         read (UNIT) (ob_lvl(j,i), j = 1, ob_nd(i))
         read (UNIT) (ob_modas(j,i), j = 1, ob_nd(i))
         read (UNIT) (ob_clim(j,i), j = 1, ob_nd(i))
         read (UNIT) (ob_glbl(j,i), j = 1, ob_nd(i))
         read (UNIT) (ob_regn(j,i), j = 1, ob_nd(i))
         read (UNIT) (ob_sprb(j,i), j = 1, ob_nd(i))
         read (UNIT) (ob_tprb(j,i), j = 1, ob_nd(i))
         read (UNIT) (ob_sal(j,i), j = 1, ob_nd(i))
         read (UNIT) (ob_tmp(j,i), j = 1, ob_nd(i))
      enddo
      read (UNIT) (ob_dtg(i), i = 1, n_obs)
      read (UNIT) (ob_rcpt(i), i = 1, n_obs)
      read (UNIT) (ob_scr(i), i = 1, n_obs)
      read (UNIT) (ob_sign(i), i = 1, n_obs)
      read (UNIT) (ob_ls(i), i = 1, n_obs)
      read (UNIT) (ob_sst(i), i = 1, n_obs)
      do i = 1, n_obs
         read (UNIT) (ob_sstd(j,i), j = 1, ob_nd(i))
         read (UNIT) (ob_tstd(j,i), j = 1, ob_nd(i))
      enddo
c
c     ..produce profile report
c
      do i = 1, n_obs
         write (45, '(110(''-''))')
         write (45, '(''profile call sign           : "'', a, ''"'')')
     *          ob_sign(i)
         write (45, '(''profile latitude            : '', f12.2)')
     *          ob_lat(i)
         write (45, '(''profile longitude           : '', f12.2)')
     *          ob_lon(i)
         write (45, '(''profile observed DTG        : "'', a, ''"'')')
     *          ob_dtg(i)
         write (45, '(''profile received DTG        : "'', a, ''"'')')
     *          ob_rcpt(i)
         write (45, '(''DBDB5 bottom depth          : '', f12.1)')
     *          ob_btm(i)
         write (45, '(''profile data type code      : '', i12)')
     *          ob_typ(i)
         write (45, '(''profile data type           : "'', a, ''"'')')
     *          data_lbl(ob_typ(i))
         write (45, '(''total number levels         : '', i12)')
     *          ob_nd(i)
         write (45, '(''observed temperature levels : '', i12)')
     *          ob_lt(i)
         write (45, '(''observed salinity levels    : '', i12)')
     *          ob_ls(i)
         write (45, '(''temperature gross error     : '', f12.4)')
     *          ob_tqc(i)
         write (45, '(''salinity gross error        : '', f12.4)')
     *          ob_sqc(i)
         write (45, '(''sea surface height anomaly  : '', f12.4)')
     *          ob_ssh(i)
         write (45, '(''sea surface temperature     : '', f12.2)')
     *          ob_sst(i)
         write (45, '(''security classification     : '', 9x,
     *          ''"'', a, ''"'')') ob_scr(i)
         write (45, '(5x,''depth'', 6x,''temp'', 6x,''salt'',
     *               3x,''tmp_std'', 3x,''sal_std'',
     *               2x,''tmp_prob'', 2x,''sal_prob'',
     *               6x,''clim'', 5x,''modas'',
     *               6x,''glbl'', 6x,''regn'')')
         do j = 1, ob_nd(i)
            write (45, '(f10.1, 4f10.2, 2f10.4, 4f10.2)')
     *             ob_lvl(j,i), ob_tmp(j,i), ob_sal(j,i),
     *             ob_tstd(j,i), ob_sstd(j,i), ob_tprb(j,i),
     *             ob_sprb(j,i), ob_clim(j,i), ob_modas(j,i),
     *             ob_glbl(j,i), ob_regn(j,i)
            if (ob_nd(i) .gt. ob_lt(i)) then
               if (j .eq. ob_lt(i)) then
                  write (45, '(10x, 100(''-''))') 
               endif
            endif
         enddo
      enddo
c
      return
      end


      subroutine rd_ship (UNIT, file_dtg, result, nvars, n_obs)
c
c.............................START PROLOGUE............................
c
c SCCS IDENTIFICATION:  %W% %G%
c
c MODULE NAME:  rd_ship
c
c DESCRIPTION:  reads the SHIP ocean obs files and produces a report
c
c PARAMETERS:
c      Name          Type        Usage            Description
c   ----------     ---------     ------    ---------------------------
c   n_obs           integer      input     number ship obs
c   unit            integer      input     FORTRAN unit number
c
c MCSST VARIABLES:
c      Name      Type                     Description
c   ----------  -------     -------------------------------------------
c   ob_age      real        age of the observation in hours since
c                           January 1, 1992.  provides a continuous
c                           time variable
c   ob_clim     real        NCEP SST climatological estimate at obs
c                           location and sampling time
c   ob_csgm     real        NCEP SST climatology variability estimate
c                           at obs location and receipt time at FNMOC
c                           (not implemented yet)
c   ob_dtg      character   SST obs date time group in the form year,
c                           month, day, hour, minute (YYYYMMDDHHMM)
c   ob_glbl     real        SST global analysis estimate at obs
c                           location and receipt time at FNMOC
c   ob_gsgm     real        global SST analysis variability estimate
c                           at obs location and receipt time at FNMOC
c                           (not implemented yet)
c   ob_lat      real        SST obs latitude (south negative)
c   ob_lon      real        SST obs longitude (west negative)
c   ob_qc       real        SST obs probability of a gross error
c                           (assumes normal pdf of SST errors)
c   ob_rcpt     character   SST observation receipt time at FNMOC in
c                           the form year, month, day, hour, minute
c                           (YYYYMMDDHHMM); the difference between
c                           ob_rcpt and ob_dtg gives the timeliness 
c                           of the observation and the validity of
c                           ob_glbl and ob_regn background estimates 
c   ob_regn                 SST regional analysis estimate at obs
c                           location and receipt time at FNMOC
c   ob_rsgm     real        regional SST analysis variability estimate
c                           at obs location and receipt time at FNMOC
c                           (not implemented yet)
c   ob_scr      character   SST obs security classification code; "U"
c                           for unclassified
c   ob_sign     character   SST observation call sign
c   ob_sst      real        SST observation
c   ob_type     integer     SST obseration data type; ship (ERI, bucket,
c                           hull contact), buoy (fixed, drifting), CMAN
c                           (see ocn_types.h for codes)
c   ob_wm       integer     SST water mass indicator from Bayesian
c                           classification scheme.  only valid in
c                           western North Pacific, western North
c                           Atlantic or GIN-Seas regions.  used to
c                           prevent averaging of SST observations
c                           from different water mass during the
c                           computation of SST super-obs; helps
c                           maintain SST fronts and eddies in the
c                           analysis of western boundary currents
c
c..............................END PROLOGUE.............................
c
      implicit none
c
      include 'ocn_types.h'
c
c     ..local array dimensions
c
      integer*4 n_obs
      integer*4 nvars
      character file_dtg * 10
      REAL*4 result(n_obs, nvars)
c
      integer   i
      real*4    ob_age (n_obs)
      real*4    ob_clim (n_obs)
      real*4    ob_csgm (n_obs)
      character ob_dtg (n_obs) * 12
      real*4    ob_glbl (n_obs)
      real*4    ob_gsgm (n_obs)
      real*4    ob_lat (n_obs)
      real*4    ob_lon (n_obs)
      real*4    ob_qc (n_obs)
      character ob_rcpt (n_obs) * 12
      real*4    ob_regn (n_obs)
      real*4    ob_rsgm (n_obs)
      character ob_scr (n_obs) * 1
      character ob_sign (n_obs) * 6
      real*4    ob_sst (n_obs)
      integer*4 ob_type (n_obs)
      integer*4 ob_wm (n_obs)
      integer   UNIT

      integer iyr ,imo ,idy ,ihr ,imn,
     .        iyr0,imo0,idy0,ihr0,imn0
      REAL*8          TM_SECS_FROM_BC

      integer
     .  POB_WM,
     .  POB_GLBL,
     .  POB_LAT,
     .  POB_LON,
     .  POB_AGE,
     .  POB_CLIM,
     .  POB_QC,
     .  POB_REGN,
     .  POB_SST,
     .  POB_TYPE,
     .  POB_DTG,
     .  POB_RCPT,
     .  POB_SCR,
     .  POB_SIGN

      PARAMETER (
     .  POB_WM = 2,
     .  POB_GLBL = 3,
     .  POB_LAT = 4,
     .  POB_LON = 5,
     .  POB_AGE = 6,
     .  POB_CLIM = 7,
     .  POB_QC = 8,
     .  POB_REGN = 9,
     .  POB_SST = 10,
     .  POB_TYPE = 11,
     .  POB_DTG = 12,
     .  POB_RCPT = 13,
     .  POB_SCR = 14,
     .  POB_SIGN = 15 )

c
c...............................executable..............................
c
c     ..read ship variables
c
      read (UNIT) (ob_wm(i), i = 1, n_obs)
      read (UNIT) (ob_glbl(i), i = 1, n_obs)
      read (UNIT) (ob_lat(i), i = 1, n_obs)
      read (UNIT) (ob_lon(i), i = 1, n_obs)
      read (UNIT) (ob_age(i), i = 1, n_obs)
      read (UNIT) (ob_clim(i), i = 1, n_obs)
      read (UNIT) (ob_qc(i), i = 1, n_obs)
      read (UNIT) (ob_regn(i), i = 1, n_obs)
      read (UNIT) (ob_sst(i), i = 1, n_obs)
      read (UNIT) (ob_type(i), i = 1, n_obs)
      read (UNIT) (ob_dtg(i), i = 1, n_obs)
      read (UNIT) (ob_rcpt(i), i = 1, n_obs)
      read (UNIT) (ob_scr(i), i = 1, n_obs)
      read (UNIT) (ob_sign(i), i = 1, n_obs)
c     read (UNIT) (ob_csgm(i), i = 1, n_obs)
c     read (UNIT) (ob_gsgm(i), i = 1, n_obs)
c     read (UNIT) (ob_rsgm(i), i = 1, n_obs)
      do i = 1, n_obs
         ob_csgm(i) = -999.
         ob_gsgm(i) = -999.
         ob_rsgm(i) = -999.
      enddo

* RETURN THE RESULTS TO FERRET
      do  i = 1, n_obs
        result(i,1) = -999.
        result(i,POB_WM)   = ob_wm(i)
        result(i,POB_GLBL) = ob_glbl(i)
        result(i,POB_LAT)  = ob_lat(i)
        result(i,POB_LON)  = ob_lon(i)
        result(i,POB_AGE)  = ob_age(i)
        result(i,POB_CLIM) = ob_clim(i)
        result(i,POB_QC)   = ob_qc(i)
        result(i,POB_REGN) = ob_regn(i)
        result(i,POB_SST)  = ob_sst(i)
        result(i,POB_TYPE) = ob_type(i)
* compute lag from observation to receipt of observation
        READ ( ob_rcpt(i),'(I4,4I2)') iyr ,imo ,idy ,ihr ,imn
        READ ( ob_dtg (i),'(I4,4I2)') iyr0,imo0,idy0,ihr0,imn0
        result(i,POB_DTG)  =
     .          (TM_SECS_FROM_BC(iyr,imo,idy,ihr,imn,0)
     .        -  TM_SECS_FROM_BC(iyr0,imo0,idy0,ihr0,imn0,0)) / 3600.

        result(i,POB_RCPT) = -999.   ! not needed
        result(i,POB_SCR)  = -999.   ! ob_scr(i)
        result(i,POB_SIGN) = -999.   ! ob_sign(i) -- useful?
      enddo

* return the number of obs in result(1,1)
      result(1,1) = n_obs

* return the numerical-encoded filename in result(2,1)
      READ (file_dtg,'(I4,4I2)') iyr,imo,idy,ihr,imn
      result(2,1) = (TM_SECS_FROM_BC(iyr,imo,idy,ihr,imn,0)
     .            -  TM_SECS_FROM_BC(1992,1,1,0,0,0)) / 3600.

c
c     ..produce ship report
c
#ifdef DEBUG
      write (45, '(9x,''dtg'', 3x,''sign '', 5x,''lat'', 5x,''lon'',
     *             4x,''type'', 5x,''sst'', 4x,''clim'', 4x,''glbl'',
     *             4x,''regn'', 6x,''qc'', 4x,''csgm'', 4x,''gsgm'',
     *             4x,''rsgm'', 2x,''wm'', 2x,''sc'')')
      do i = 1, n_obs
         write (45, '(a,2x,a,2f8.2,i8,4f8.2,f8.4,3f8.2,i4,3x,a,2x,a)')
     *          ob_dtg(i), ob_sign(i), ob_lat(i), ob_lon(i),
     *          ob_type(i), ob_sst(i), ob_clim(i), ob_glbl(i),
     *          ob_regn(i), ob_qc(i), ob_csgm(i), ob_gsgm(i),
     *          ob_rsgm(i), ob_wm(i), ob_scr(i), data_lbl(ob_type(i))
      enddo
#endif
c
      return
      end


      subroutine rd_ssmi (UNIT, n_obs)
c
c.............................START PROLOGUE............................
c
c SCCS IDENTIFICATION:  %W% %G%
c
c MODULE NAME:  rd_ssmi
c
c DESCRIPTION:  reads the SSMI sea ice ocean obs files and produces a
c               report whether you want one or not
c
c PARAMETERS:
c      Name          Type        Usage            Description
c   ----------     ---------     ------    ---------------------------
c   n_obs           integer      input     number ssmi obs
c   unit            integer      input     FORTRAN unit number
c
c SSMI VARIABLES:
c     ame       Type                     Description
c   --------  --------    ----------------------------------------------
c   ob_age     real       age of the observation in hours since
c                         January 1, 1992.  provides a continuous
c                         time variable
c   ob_clim    real       ECMWF sea ice climatological estimate at
c                         SSM/I sea ice location and sampling time
c   ob_dtg     character  SSM/I sea ice retrieval date time group in
c                         the form  year, month, day, hour, minute,
c                         second (YYYYMMDDHHMMSS)
c   ob_glbl    real       SSM/I sea ice global analysis estimate at
c                         obs location and receipt time at FNMOC
c   ob_ice     real       SSM/I sea ice concentration (per cent) 
c   ob_lat     real       SSM/I sea ice latitude (south negative)
c   ob_lon     real       SSM/I sea ice longitude (west negative)
c   ob_mean    real       SSM/I 30 day mean sea ice concentration at
c                         obs location and samping time
c   ob_qc      real       SSM/I sea ice probability of a gross error
c                         (assumes normal pdf of sea ice retrieval
c                         errors)
c   ob_regn    real       SSM/I sea ice regional analysis estimate at
c                         obs location and receipt time at FNMOC
c   ob_sat     integer    satellite ID (DMSP F11, F13, F14, F15);
c                         see ocn_types.h for codes
c
c..............................END PROLOGUE.............................
c
      implicit none
c
      include 'ocn_types.h'
c
c     ..local array dimensions
c
      integer*4 n_obs
c
      integer   i, k
      real*4    ob_age (n_obs)
      real*4    ob_clim (n_obs)
      character ob_dtg (n_obs) * 12
      real*4    ob_glbl (n_obs)
      real*4    ob_ice (n_obs)
      real*4    ob_lat (n_obs)
      real*4    ob_lon (n_obs)
      real*4    ob_qc (n_obs)
      real*4    ob_regn (n_obs)
      integer*4 ob_sat (n_obs)
      real*4    ob_mean (n_obs)
      integer   UNIT
c
c...............................executable..............................
c
c     ..read ssmi variables
c
      read (UNIT) (ob_glbl(i), i = 1, n_obs)
      read (UNIT) (ob_ice(i), i = 1, n_obs)
      read (UNIT) (ob_lat(i), i = 1, n_obs)
      read (UNIT) (ob_lon(i), i = 1, n_obs)
      read (UNIT) (ob_qc(i), i = 1, n_obs)
      read (UNIT) (ob_age(i), i = 1, n_obs)
      read (UNIT) (ob_regn(i), i = 1, n_obs)
      read (UNIT) (ob_sat(i), i = 1, n_obs)
      read (UNIT) (ob_clim(i), i = 1, n_obs)
      read (UNIT) (ob_mean(i), i = 1, n_obs)
      read (UNIT) (ob_dtg(i), i = 1, n_obs)
c
c     ..produce ssmi report
c
      k = 1000
      write (45, '(''  reporting skip factor: '', i10)') k
      write (45, '(9x,''dtg'', 5x,''lat'', 5x,''lon'', 5x,''sat'',
     *             5x,''ice'', 4x,''clim'', 4x,''glbl'', 4x,''regn'',
     *             4x,''mean'', 6x,''qc'')')
      do i = 1, n_obs, k
         write (45, '(a,2f8.2,i8,5f8.2,f8.4,2x,a)')
     *          ob_dtg(i), ob_lat(i), ob_lon(i), ob_sat(i),
     *          ob_ice(i), ob_clim(i), ob_glbl(i), ob_regn(i),
     *          ob_mean(i), ob_qc(i), data_lbl(ob_sat(i))
      enddo
c
      return
      end


      subroutine error_exit (routine, message)
c
c.............................START PROLOGUE............................
c
c SCCS IDENTIFICATION:  %W% %G%
c
c MODULE NAME:  error_exit
c
c DESCRIPTION:  prints a fatal error message and terminates the program.
c
c PARAMETERS:
c    Name          Type       Usage            Description
c   -------     ----------    ------    ---------------------------
c   routine     char * (*)    input     name of routine
c   message     char * (*)    input     user supplied error message
c
c..............................END PROLOGUE.............................
c
      implicit  none
c
      integer   ln
      character message * (*)
      character routine * (*)

        INTEGER TM_LENSTR1

c
c..............................executable...............................
c
c     ..determine message string length
c
      ln = TM_LENSTR1 (message)
c
      write (*, '(//, ''*** FATAL ERROR ('', a, '') ***'')') routine
      write (*, '(/, a)') message(1:ln)
      write (*, '(/, ''*** PROGRAM TERMINATED ***'', /)')
c
c     ..exit with non zero completion code
c
      stop 15
      end

	SUBROUTINE XEQ_LOAD

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute the LOAD command

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 9/4/87
* revision 0.1 - 9/16/87 - added want_cmnd_data to GET_CMND_DATA call
* revision 2.0 - 3/10/88 - added LOAD/NAME=
* revision 2.1 - 3/23/88 - enlarged cx_DIM_STR to accomodate date/time strings
* revision 2.2 - 8/15/88 - changed /NAME= re-cataloging procedure for new
*			   memory management routines
* revision 2.3 - 10/7/88 - remove in-plane transforms, too and re-catalog
* revision 2.4 -11/21/88 - new TM IO library GET_LIKE_GRID --> TM_GET_LIKE_GRID
*					     TRANSFER_GRID --> TM_COPY_GRID
* V200:  6/9/89 - deleted variables flagged in mr_protected
*		- /NAME= eliminated
*	12/15/89- fixed error check for LOAD/PERM expression
*	  5/1/90- added code so LOAD/TEMP works
*		  still flawed: doesn't detect region gt requested
*		- and bixed del_flink/blink bug in LOAD/PERM
* V230: 8/11/92 - double load of /PERMANENT got subscript error
* V312: 5/94 - array "memory" as a calling argument
* V530: *sh* 9/00 - added initial data type support in get_cmnd_data 
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V702 2/17 *sh* keep track of LOAD/PERM memory usage

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'

* local parameter definitions:
	INTEGER	slash_perm, slash_temp, slash_name
	PARAMETER     ( slash_temp = 1,		! (default)
     .			slash_perm = 2,
     .			slash_name = 16 )

* calling argument declarations:

* local variable declarations:
	LOGICAL		EXPLICIT_UVAR, permanent, named, temp
	INTEGER		status, iload, mr, next, prev, last_head

* initialize
	named	  = qual_given( slash_name ) .GT. 0
	permanent = qual_given( slash_perm ) .GT. 0
	temp	  = qual_given( slash_temp ) .GT. 0

* save the data under a given name
	IF ( named ) CALL ERRMSG( ferr_invalid_command, status,
     .		'/NAME= no longer supported - use DEFINE VARIABLE', *5000 )
	
* get the requested data somehow
	CALL GET_CMND_DATA (  cx_last, ptype_native, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* set protections as indicated (check for already protected 8/92)
	IF ( permanent ) THEN
	   DO 400 iload = 1, num_uvars_in_cmnd
	      mr = is_mr( iload )
	      IF ( mr_category( mr ) .EQ. cat_user_var ) THEN
	         IF ( .NOT.EXPLICIT_UVAR(mr_variable(mr)) ) CALL ERRMSG
     .			( ferr_invalid_command, status,
     .			'Cannot LOAD/PERM "expression".  Use DEFINE VARIABLE',
     .			 *5000 )
	      ENDIF
              IF ( mr_protected(mr) .NE. mr_perm_protected ) THEN  ! 8/92
	         mr_protected( mr ) = mr_perm_protected
* ... remove from deletion priority chain
	         prev = mr_del_blink(mr)
	         next = mr_del_flink(mr)
	         mr_del_flink(prev) = next
	         mr_del_blink(next) = prev
	         mr_del_flink( mr ) = unspecified_int4	! important 12/16
	         mr_del_blink( mr ) = unspecified_int4	! important 12/16
	         permanent_mem = permanent_mem + mr_size(mr)
              ENDIF
 400	   CONTINUE

	ELSEIF ( temp ) THEN
	   DO 500 iload = 1, num_uvars_in_cmnd
	      mr = is_mr( iload )
	      IF ( mr_protected( mr ) .EQ. mr_perm_protected ) THEN
	         mr_protected( mr ) = mr_not_protected
* ... restore at head of deletion priority chain
	         last_head = mr_del_flink(0)
	         mr_del_blink(mr) = 0
	         mr_del_flink(mr) = last_head
	         mr_del_flink(0)  = mr
	         mr_del_blink(last_head) = mr
	         permanent_mem = permanent_mem - mr_size(mr)
	      ENDIF
	      
 500	   CONTINUE

	ENDIF

	RETURN

* error exit(s)
 5000	RETURN
	END

	SUBROUTINE EQUAL_STRING( string, val, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* from a string of the form "name=value", return the "value" string
* if the string is simply "name" then return ' ' (blank)
* change the string to upper case

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 6/27/88 - based on EQUAL_VAL
* V200:   7/7/89 -  remove leading blanks, process quotation marks
*	  9/22/89 - fixed bug for NAME="" (close quotes)
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
* V693+ *sh* 2/15 - added support for _DQ_ quotations

        IMPLICIT NONE
* calling argument declarations
	INTEGER		status
	CHARACTER*(*)	string, val

* internal variable declarations
	INTEGER	TM_LENSTR1, STR_UPCASE, equal_pos, slen, strt, vax_code

	include 'ferret.parm'
	include 'errmsg.parm'

* initialize
	slen	  = TM_LENSTR1( string )
	equal_pos = INDEX( string, '=' )

	IF ( equal_pos .EQ. 0 ) THEN
	   val = ' '				! "name", alone

	ELSEIF ( equal_pos .EQ. slen ) THEN	
	   GOTO 5000				! "name ="

	ELSE

* find first non-blank
	   DO 100 strt = equal_pos+1, slen
 100	   IF ( string(strt:strt) .NE. ' ' ) GOTO 110
	   STOP '=_str'		! cannot occur

* remove quotation marks
 110	   IF ( string(strt:strt) .EQ. '"'
     .	  .AND. string(slen:slen) .EQ. '"' ) THEN
	      strt = strt + 1
	      slen = slen - 1
	   ELSEIF (string(strt:strt) .EQ. '_'
     .	     .AND. string(slen:slen) .EQ. '_' 
     .	     .AND. slen-strt.GE.8            ) THEN
	      IF (string(strt:strt+3) .EQ. '_DQ_'
     .	    .AND. string(slen-3:slen) .EQ. '_DQ_' ) THEN
	         strt = strt + 4
	         slen = slen - 4
	      ENDIF
	   ENDIF

	   IF ( strt .GT. slen ) THEN
	      val = ' '
	   ELSE
	     vax_code = STR_UPCASE( val, string(strt:slen) )
	   ENDIF

	ENDIF

* success
	status = ferr_ok
 1000	RETURN

* syntax error
 5000	CALL ERRMSG( ferr_syntax, status, string, *1000 )
	END

        SUBROUTINE PLOT_SET_UP( 
     .				overlay, transpz, versus, no_labels,
     .				symbol, sym_size, color, color1, use_line,
     .				step_inc, do_dash, dashstyle,
     .                          is_logx, is_logy, nokey, addgaps,
     .				all_1_dep, only_val, skipsym, mv_list, 
     .				cx_list, nmv, indep_dat, dep_dat, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* set up for line plot by loading data and title and defining axis formats
* (the routine is confusing as a result of simultaneously coping with the needs
* of single variables, multiple variables, /VS, /TRANSPOSE and /OVERLAY)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 7/8/87  - based on DISP_SET_UP rev 1.1
* revision 0.1 - 7/21/87 - added transpose option and 
* revision 0.2 - 8/26/87 - added TAXIS ON for time axis plots
* revision 0.3 - 2/29/88 - allowed for non-geometric axes, time axis formats,
*			   non-inverted Z data,
*			   and check to keep PLOT+ from screwing up when data 
*			   are all a single value
* revision 0.4 - 4/12/88 - added do_labels argument for "/NOLABELS" option
*			   and units labeled on dependent axis
* revision 0.5 - 4/28/88 - force-scale axes if data is all 1 value
* revision 0.6 -  9/8/88 - added relative flags to PUT_LABEL calls
* revision 1.0 - 9/23/88 - allow lines of different lengths - bypass time axis
*			   limits as computed by PPLLDX because of bugs in that
*			   code.  Move /no_labels to PUT_LABEL.
*			 - put "year" label on if time axis doesn't
* V200:  5/19/89 - reordered lo/hi_ss arguments
*         1/8/89 - major rewrite using keys
*	  5/8/90 - allow PLOT/VS to overlay 2D fields
*		 - PLOT/VS needn't be given a line - it can be a higher dim reg.
*		 - improved error message for plot not of a line
*	 5/17/90 - aded PLOT/SYMBOL and PLOT/LINE
*  Unix/RISC port 3/91 *sh* : bug: TSTEP_TO_SECS requires REAL*8 arg
*                 8/23/91 ; bug when time axis is normal cannot find dt_min
* V230:   6/8/92 - corrected bug when line_t0 and line_units may be undefined
*        6/12/92 - trap PLOT+ nsize limitation before passing data
*        6/26/92 - time_axis variable not properly init'ed for /vs plot
*        11/4/92 - expanded variable name length
*                - corrected small bug in size of dependent axis label
*       11/27/92 - symptomatic bug fix of mis-scaled TAXIS0 (hours) axis
*                - see err230_ppl_taxis.jnl
* V300: 3/11/93  - allow free-er overlay of plot on top of 2D display
* V301:	10/22/93 - added /XLIMITS and /YLIMITS  (variables dep_min &_max
*		   commandeered as not really used earlier)
*	 11/3/93 - added /TITLE
*	  1/7/94 - screen bad data flag on independent axis only for /VS
* V320: 5/94 - array "memory" as a calling argument
* 	9/94: restrict to 99% of NSIZE buffer - kludge fix to PLOT+ bug
*       12/29/94 - use SPLIT_LIST to redirect tty output for GUI
* V420: 11/27/95 - 4-digit PLOT+ YEARS!!
*	11/28/95 - changes to TAXIS_STYLE to support y-oriented calendar axes
*	 3/26/96 - number of expressions to be merged was incorrect in call to
*			MERGE_WHOI_CONTEXT
* V450: 3/97 - modified AXIS_FORMAT args for curvilinear coordinate plots
* V500 *kob* 3/99- up VAR_CODE  and VAR_UNITS to 64 chars
*       4/99 - *jd* Ensure PPL knows plot is overlay: set SOVER flag here
*       6/99 - *sh* added logic to permit a PLOT/VS over a time series plot
* V510 10/99 - *sh* plot/i=1:10 i/0 is not an error -- scale axis to -1:1
*       1/00 - *kob* - check the variable time_axis before looking at
*                      any time-relevant variables.
*       3/00 - *sh* added use_line and sym_size args for PLOT/COLOR=/SIZE=
*	     - pass no_labels to AXIS_FORMAT 
*	5/00 - added /HLIMITS and /VLIMITS (denigrating /xlimits/ylimits)
* V521	7/00 - *sh* bug fix to /TRANS/VLIMITS=... 
*	7/00 - *sh* new argument range_rqd needed on EQUAL_RANGE
* V530 *sh* 1/01 - change "denigrated" to "deprecated"
* V530 *ACM* 1/01  cal_id for alternative calendar axes.
*      *sh* 1/01 - added argument step_inc for PLOT/STEP
*	         - bug fix: PLOT+ mem limit check off by x2 --  X&Y components
*      *acm* 5/01 - added  PLOT/DASH  (do_dash, dashstyle)
*      *acm* 5/01 - correct STEP bug: send NLOAD rather than NPTS2 to PPLLDX 
* V533 *acm* 6/01 - for LOG plots add logicals is_logx, is_logy.  set to plot
*                   log of depth as inverse axis
* V533 *acm* 9/01 - changes for dynamic pplus buffer.  Rename NSIZE to pplmem_nsize.
*                   call PPLLDX via pplldx_envelope.c which checks pplmem_nsize 
*                   and allocates more memory if needed.
*      *acm* 10/01  remove VMS includes
* V552 *acm*  3/03  Send the key string to key_loc since it may be multi-line
*                   also, make strings longer
* V580 *acm*11/04  Allow thickness to be set when cycling through colors automatically.
*                  In call to line_style, when color = -11  then thin line, color=-21 
*                  then thick=2, when color=-31 then thick=3
* V580 *acm*11/04  For /VS plots turn on lon/lat axis formatting, if lon/lat units
*                  (as in polygon_set_up).
* V580 *acm* 12/04 Fix bug 1129; formatting axis for small lon/lat ranges:
*                  send delta to routine AXIS_FORMAT
* V580 *acm* 10/05 Fix for bug 1349, longitude/latitude axis formatting. Need 
*                  to set the format to use as well as the label.
* V610 *acm*  2/08 Fix bug 1560. In the lon/lat axis formatting, check whether 
*                  the unit is longitude or latitude. PLOT/VS plots may have 
*                  either one of these on either axis.
* V612 *acm*  7/08 Prev. fix was that variables with units of "degrees_e" and 
*                  "degrees_n" get longitude/latitude units on a PLOT/VS plot. 
*                  Also allow units of "longitude" or "latitude" to trigger 
*                  lon/lat labels.
* V612 *acm*  8/08 Fixing bug 1038. No Valid Data labeled as on 2D plots. If 
*                  there is no valid data, send that information back, so a
*                  label can be added to the plot. If this is an overlay, add
*                  No Valid Data to the label.
* V614  *acm* 10/08 - add new MODE NODATA_LAB to control the NO VALID DATA label.
*                  Put it on plots only when this mode is set.
* V62   *acm*  2/09 Fix bug 1636, on PLOT/VS when setting up dependent axis,
*                  need to reinitialize delta=unspecified_val8 so that delta is
*                  computed from the dependent data.
* V662 *acm*  5/10 Set AX_VERT or AX_HORIZ symbol with the direction of the independent axis: X, Y, Z, T" plot_set_up.F
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus.
*       *acm* 3/12 6D Ferret: Add E and F dimensions 
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction. The time 
*                  dimension is now an arg to SECS_TO_TSTEP.
* V6.85 *acm* 9/13 New PLOT/COLOR w/o argument for all-color line plot
* V685+ *acm  12/13 In dependent axis setup, make sure variable the_taxis is set.
* V691  *acm*  5/14 For ribbon line plots, set up for histogram levels
* V691  *acm*  7/14 Fix ticket 2187: axis labels for PLOT/VS plots.
* V693  *acm* 10/14 Fix 2212: Check for a valid axis if they've asked for a 
*                   log axis before proceeding with vlimits or hlimits
* V694  *acm*  1/15 Changes to allow two time axes on plot (F-T)
* V695+ *sh*  3/15 if an FMRC dataset disambiguate T and F axes with labels
* V694  *acm*  5/15 Fix ticket 2282: setting up axis for ribbon plots
* v696  *acm*  6/15 PLOT/VS/GAPLOC to define seperate line segments on
*                   PLOT/VS plots (LAS ticket 1597 and others)
* V695  *acm* 9/15 send REAL*4 rbad to compare with lev_max, lev_min inside compute_mnstd
* V695  *acm* 9/15 Changes for HH:MM labeling when plotting short time range.
*                  For these axes reset the start time by only a day.
* V695  *acm* 9/15 Tweak to above - dont reset tref for overlay plots.
* V697  *acm* 1/16 Further fix ticket Fix 2122. Make sure the dependent axis
*                  data min and max are set.
* V698 *sh* 3/16 - limit max number of plot keys generated
* V698  4/16 *acm* New PLOT/SKIP=
* V7    *acm* 6/16 Ticket 2434: command qualifiers /DEGMINSEC= /HALFSPAC
*                  DEGMINSEC=1 for Deg-Min axis labels, =2 for Deg-Min-Sec. Default = 1
*                  /HALFSPAC adds a half space between the degree sign and E/W or N/S
* V701  *acm* 8/16 Fix ticket 2463: single-valued data with a /LEVELS setting
* V701  *acm* 8/16 Fix ticket 2468: Symbols AX_HORIZ and AX_VERT are not reset on an /OVERLAY plot
* V702  *acm* 10/16 Test the results of MINMAX routine before use; if all data is 
*                   all-missing it returns arbitrary_large_val4.
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.
* V710  *acm* 11/16 Ticket 2483: Fix the axis-end symbols that are defined 
*                   for time axis plots
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.
* V702 *sh* 1/17 bug fix - ensure only 1D data goes to EXTRACT_LINE if not a
*                      PLOT/VERSUS
* V71  *acm* 2/17  More on ticket 2231. New argument to FULL_VAR_TITLE to control units labels
* V720 *acm* 3/2017 Ticket 2517: Bugs in PLOT/VS when the units are degrees. Axis formatting
*                   needs to be consistent and controlled by modes long_label and latit_label
* v7.2 *acm* 2/2017 ticket 2446 Drawing formatted time axes on a PLOT/VS when a variable has
*                   units of e.g. "days since datestring". The datestring can be in a recognized
*                   format: 01-jan-2011, or 2011-01-01. MM:HH:SS if present can be written
*                   separated by a space, or a colon, or Z.
* V7.2 *acm* 4/2017 Ticket 2318: for constant-value data on a line plot, make the axis
*                   range +/- 10% of the value instead of +/- 1. For very large or small
*                   values the +/- 1 corrupted the labels or the location of the plot.
* V7.2 *acm* 4/2017 In fix for 2212, make sure ind_min,ind_max are defined before using them 
*                   to check log limits on log axis.  Make sure the limits are actually applied.
* V7.2 *acm* 5/2017 restore correct longitude moduloing for PLOT/VS overlay plots
* V7.22 *acm* 10/2017 Fix ticket 2565, duplicate and sometimes shifted labels on PLOT/over time plots
* V73+ 1/18 *acm* Changes for Issue 1009; precsision in time info sent to pplus for 2D plots
*                 handle line plots over scaled 2D plot
*                 On time plots overlaid on a 2D plot, set up time-axis information even when
*                 not labeling the plot.
* V7434 10/18 *acm* minor cleanup: initialize variable the_taxis
* V74+ *acm*  4/18 additions for plotting trajectories from a dsg dataset
* V74+ 4/18 *acm*  Automatically do a colored trajectory plot for the command 
*                  "PLOT var" if it's a DSG trajectory set. 
* V74+ 4/18 *acm*  Updates to DSG plotting: trajectories or sets of timeseries etc
* V74+ 7/18 *acm*  Updates to DSG plotting: 
*                   - Fixes for modulo longitude ranges in the context
*                   - Upper-left labels with plot range in world coordinates
* V7.4+ *acm*  8/18 DSG-enabled Ferret: line-key labels may be strings from the IDs
* V7.4+ *acm* 10/18 Handle single-point plots: plot a symbol
* V7.5+ *acm*  4/18 PLOT/VS plots from DSG data that are not native-trajectory plots
* V75   10/18 *acm* ticket 1926 F-axis line plots were trying to get time-origin from t-axis
*                   of the grid.
* V75    4/19 *acm* For data in profile DSG dataset, 2- or 3-argument ribbon plot
*                   may need an argument expanded to the obs length, e.g ribbon/vs time, depth, var
* V7.5+ *acm*  6/19 changes to the call of PLOT_DSG_CHECK_LON360
* V751   6/19 *acm* Issue 1940, dependent variable on a time axis with /vlimits.  The call to
*                   EQUAL_RANGE specified that the dependent-axis limits be translated as dates 
*                   on the independent time axis.
* V751   6/19 *acm* For DSG data update calls to PLOT_DSG_APPLY_OBS_MASK
* V751   7/19 *acm* For DSG data, set a flag controling a PLOT/VS plot with station locations as
*                   opposed to exanding variables to the obs axis.
* V751 7/19 *acm*  DSG-enabled Ferret: plotting user-defined variables
* V7.6  *acm*  1/20 Set up for plotting Points-type datasets as ribbon plots
*                   with symbols. 
* V76   1/20 *acm* Orientation of Point-type data set to e_dim
* V760 *acm* 3/20 Customize plot for case when constraints result in no features
* V760 *acm* 4/20 PLOT_DSG_CHECK_LON360 now applies a lon-360 conversion of the 
*                 longitudes if it'll be better and /HLIM not given
* V760 *acm* 4/20 Issue 1973: For PLOT/VS when the units are degrees lon or lat, 
*		  mark the axis direction info in plot_axes( ) so that overlays 
*                 such as"go fland" will work. (DSG and non-DSG data.)
* V760 *acm* 4/20 Similarly, if PLOT/VS and a depth coord var is on the vertical
*                 axis, reverse the axis to run DEEP:SHALLOW


        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
        include 'xunits.cmn_text'
	include 'ferret.parm'
	include 'plot_setup.parm'
	include 'errmsg.parm'
	include 'slash.parm'
	include 'xplot_setup.cmn'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'
	include 'xtext_info.cmn'
        include 'axis_inc.decl'    ! with axis lengths
        include 'AXIS.INC'         ! with axis lengths	
	include 'taxis_inc.decl'
	include 'TAXIS.INC'
	include 'PPLDAT.INC'
        include 'switch_inc.decl'
        include 'SWITCH.INC'
	include 'xdset_info.cmn_text'
	include 'xdsg_context.cmn'

#include "tmap_dset.parm"

* calling argument declarations:
	LOGICAL		overlay, transpz, versus, no_labels, use_line,
     .			is_logx, is_logy, nokey, all_1_dep, addgaps
	INTEGER		symbol, color, color1, step_inc, do_dash, skipsym,
     .			nmv, mv_list( * ), cx_list( * ), status
	REAL		 sym_size,
     .                  dashstyle(*), only_val
	REAL		indep_dat(*), dep_dat(*)     ! dynamic space allocation
 
* V500 *kob* 3/99- up VAR_CODE and VAR_UNITS to 64 chars
* internal variable declarations:

	LOGICAL		NO_LINE_RANGE, GEOG_LABEL, ITS_FMRC,
     .                  ITSA_TRUEMONTH_AXIS, TM_HAS_STRING, TM_ITSA_DSG,
     .			flip, time_axis,
     .			all_1_ind, formatted,
     .			indep_is_log, dep_is_log, use_nice,
     .                  this_no_range(max_line_on_plot), set_axis,
     .                  timeax_both, do_units, doing_ribbon_color,
     .                  x_is_time, y_is_time, its_traj, its_dsg, 
     .                  expand_dsg_ok, color_dsg_id, user_hlim
	CHARACTER*2040	FULL_VAR_TITLE, KEY_STRING, plot_title
	CHARACTER	INTERNAL_WHOI_DATE*14, VAR_UNITS*64,
     .			SECS_TO_DATE*20, LEFINT*8, MERGED_WHOI_DATE*14, 
     .			LEFT_REAL*16, TM_GET_CALENDAR_NAME*32, 
     .			indep_ax*1, dep_ax*1, tstyle*3, xtra_lab*24,
     .			buff1*40, buff2*16, buff3*8, t1_date*14, tref*14,
     .                  cal_name*32, cal_name_new*32, val_buff*45, fmt*4,
     .			whoimin*14, whoimax*14, 
     .			whoimin_axlo*14, whoimax_axhi*14
	INTEGER		TM_LENSTR1, CX_DIM_LEN, CGRID_SIZE, CGRID_AXIS, 
     .			TM_DSG_DSET_FROM_GRID, TM_DSG_NFEATURES,
     .			mv, cx, slen, ito, indep_lab, dep_lab, nline_in_mem,
     .			indep_dim, npts, dep_dim, npts2, ndv, var1,
     .			grid, grid1, ipl, ndim, dims(6),
     .			slen2, slen3, tax, plot_mem_used, nload, i,
     .			pxlim, pylim, phlim, pvlim,pindeplim, pdeplim,
     .			dep_axtyp, indep_axtyp, the_taxis, ribbon_var, 
     .			gap_var, iiunits, iaxis, hblk1, mvh_temp, 
     .			nkey_entries, t_axtyp, since_T0, itmp, igrd_save, 
     .			icode, dset, nfeatures, obsdimlen, fline, orientation, 
     .			dtype, fvar, nload_all, numv, nok, line_symbol, 
     .			dsg_fmt_grid, dep_dir, nmasked, dset_dsg, dum1, dum2

	INTEGER         TM_GET_CALENDAR_ID, cal_id_1, cal_id_2,
     .			cal_id_old, cal_id_new
        INTEGER         TM_UNIT_ID, cx_x , cx_y, iunits, junits, axis_x_dir, axis_y_dir
	CHARACTER*1     axdir(6), ax1

	REAL		val1, dt_min, lo, hi, dep_len, 
     .			ind_len, first, last, hlen, hrs, 
     .			bc_min, bc_max, step_lo, step_hi, ascale, aoff
	REAL		TSTEP_TO_SECS, SECS_TO_TSTEP, DATE_TO_TSTEP, 
     .			WHOI2BC, GET_LINE_COORD, ind_min, ind_max, dep_min, dep_max, 
     .			delta, tmp, dum, ww_save, cen, yr
	REAL*4 rbad

* local parameter declarations:
	LOGICAL		main, norm_labs, pnot_curv, range_rqd
	PARAMETER     ( main = .TRUE.,
     .			norm_labs = .FALSE.,
     .			pnot_curv = .FALSE.,
     .			range_rqd = .TRUE. )
	DATA axdir / 'X', 'Y', 'Z', 'T', 'E', 'F' /

* signal that plot set-up has begun
	IF ( mode_diagnostic ) CALL SPLIT_LIST(pttmode_ops, ttout_lun,
     .				'setting up plot', 15)

* limits error check
        IF (nmv .GT. max_line_on_plot) GOTO 5050
	
* initialize

	ind_max = arbitrary_small_val8
	ind_min = arbitrary_large_val8
	cx   = cx_list( 1 )
	mv   = mv_list( 1 )
	grid1 = cx_grid( cx )
	grid = cx_grid(is_cx(1))
	dset = cx_data_set(cx)
	indep_dim = plot_axis(1)
	IF (versus) twodee_on = .TRUE.

	numv = nmv  ! local copy
	line_symbol = symbol
	IF (cxdsg_empty_set) THEN
	   sym_size = 0.001
	   line_symbol = 1        ! doesn't matter what
	   use_line = .FALSE.
	ENDIF


* ragged DSG data?  Get number of features and obsdimlen. If it's a 
* Trajectory or Point dataset and they did "PLOT var", set that up.

	 nfeatures = 0
	 its_dsg = .FALSE.
	 IF (dset .EQ. pdset_irrelevant) THEN
	     cx = is_cx(nmv)
	    grid1 = cx_grid( cx )
	    dset = cx_data_set(cx)
	 ENDIF

* a user-var or expression where the grid is dsg?

	 IF (dset .GT. pdset_irrelevant) its_dsg = dsg_ragged(dset)

	 dset_dsg = TM_DSG_DSET_FROM_GRID( grid )
	 IF (dset_dsg .GT. pdset_irrelevant) THEN
	    IF (.NOT. its_dsg) dset = dset_dsg
	    its_dsg = dsg_ragged(dset_dsg)
	 ENDIF
	 
	 IF (its_dsg ) THEN
	    
	    IF (  qual_given(slash_plot_along) .GT. 0.AND. .NOT.versus )  
     .	       CALL WARN ('PLOT/ALONG is ignored for discrete DSG data')

	    grid = cx_grid(is_cx(nmv))
	    dset = TM_DSG_DSET_FROM_GRID( grid )
	    nfeatures = TM_DSG_NFEATURES( grid )	    
	    its_dsg = .TRUE.
	    CALL TM_DSG_FACTS( grid, orientation, obsdimlen, fline, its_dsg )
	    IF (its_dsg) THEN

	       its_traj = dsg_feature_type(dset).EQ.pfeatureType_Trajectory .OR.  
     .	                  dsg_feature_type(dset).EQ.pfeatureType_Point
	       IF (its_traj) ribbon_plot = .TRUE.
	    
* Is this just a regular ribon plot with 3 variables (not a lon/lat traj plot)? 
* OR a PLOT/VS var1,var2 from a DSG dataset for var1,var2 not lon/lat?
* This may turn off ribbon_plot

	       CALL CHECK_PLOT_TRAJ (versus, numv, grid, its_traj)

*  numv = 1 if we're doing the trajectory ribbon plot automatically with PLOT var
*  Still allow doing it the old fashioned way numv = 2  for plot/vs lon, lat
*  If it's a trajectory dataset we still might send in say, lon,lat with a map projection
*  specified, so allow for that too.

	       IF ( (numv.EQ.1 .OR. nmv.EQ.3) .AND. its_traj) THEN 
	          ul_dolab(x_dim) = .FALSE.
	          ul_dolab(y_dim) = .FALSE.
	          ul_dolab(t_dim) = .TRUE.
	          ul_dolab(e_dim) = .TRUE.
	          ul_nlabs = 2

		  IF (dsg_feature_type(dset).EQ.pfeatureType_Point) THEN
		     use_line = .FALSE. 
		     IF (symbol .EQ. unspecified_int4) symbol = 20
		  ENDIF

	          its_traj = dsg_feature_type(dset) .EQ. pfeatureType_Trajectory
		  CALL DSG_TRAJ_PLOT_SET_UP ( 
     .              overlay, no_labels, symbol, sym_size, color, color1, 
     .              use_line, do_dash, dashstyle, nokey, its_traj, only_val, 
     .              skipsym, mv_list, cx_list, numv, indep_dat, dep_dat, status )
		  GOTO 1000
	       ENDIF

	    ENDIF ! its_dsg

* Plot a variable e.g. as a set of timeseries per feature

	 ENDIF ! dsg_ragged

* initialize

	dep_max = arbitrary_small_val8
	dep_min = arbitrary_large_val8
	ind_max = arbitrary_small_val8
	ind_min = arbitrary_large_val8
	cx   = cx_list( 1 )
	mv   = mv_list( 1 )
	grid1 = cx_grid( cx )
	indep_dim = plot_axis(1)
	nline_in_mem = 0
	phlim = qual_given( slash_hlimits )
	pvlim = qual_given( slash_vlimits )
	pxlim = qual_given( slash_xlimits )	! deprecated
	pylim = qual_given( slash_ylimits )	! deprecated
	cal_id_1 = 0
	cal_id_2 = 0
	cal_name = ' '
	dep_axtyp = 1
	indep_axtyp = 1
	mod_vs_x = .FALSE.
	mod_vs_y = .FALSE.
	axis_x_dir = no_dim
	axis_y_dir = no_dim
	adjust_time = .FALSE.
        cx_x = cx_list(1)
	xtra_lab = ' '
        nkey_entries = numv
	itmp = mnormal
	do_units = .TRUE.
	x_is_time = .FALSE.
	y_is_time = .FALSE.
	tstyle = ' '
	the_taxis = no_dim
	icode = 0
	ribbon_var = 0
	gap_var = 0
	t1_date = ' '
	tref = ' '

* set limit on the number of plot keys
        IF (.NOT.nokey  .AND.  numv.GT.max_key_entries) THEN
           buff1 = LEFINT( max_key_entries, slen  )
           CALL WARN('Too many lines to label. Labeling initial '
     .                          //buff1(:slen) )
           nkey_entries = max_key_entries
        ENDIF

* determine PLOT+ memory required
        plot_mem_used = 0
        DO 10 ipl = 1, numv
 10     plot_mem_used = plot_mem_used
     .		      + 2*step_inc*CGRID_SIZE( cx_list(ipl) )

* check for improper data supplied
	IF ( versus ) THEN
	   IF ( num_uvars_in_cmnd .LT. 2 ) GOTO 5100
	ELSEIF ( overlay ) THEN
	   CALL GET_CX_DIMS( cx, ndim, dims )
           IF ( twodee_on ) indep_dim = dims(1)       ! 3/93
	   IF ( ndim.NE.1 .OR. dims(1).NE.indep_dim ) GOTO 5120
	ELSE
	   ndim = nplot_axis
	   IF ( ndim .GT. 1 ) GOTO 5110
	ENDIF

* length of plot array
	IF ( versus ) THEN
	   npts = CGRID_SIZE( cx )	! (redundantly calc'd below) 5/90
	ELSE
	   npts = CX_DIM_LEN ( indep_dim, cx )
	ENDIF

* Overlay plots, keep the setting of IAUTOT that was set on the underlay plot.

	IF (overlay) THEN
	   iautot_save = iautot
	   iautot = 0
	ENDIF

* Mark the gap-variable, for PLOT/VS only

	IF (grid_is_dsg .AND. versus .AND. .NOT.its_traj) addgaps = .TRUE.

	IF (versus .AND. addgaps) THEN
	   IF (ribbon_plot) THEN
	      gap_var = 4
	   ELSE
	      IF (num_uvars_in_cmnd .GT. 3) GOTO 5190
	      gap_var = 3
	   ENDIF
	ENDIF

* set flag indicating a 1D plot is on the screen
	IF (.NOT.overlay) onedee_on = .TRUE.

	IF (ribbon_plot) THEN
	   ribbon_var = 3
	   IF (.NOT.versus) ribbon_var = 2
	ENDIF

* decide if the picture should be rotated 90 degrees
	IF ( .NOT.versus .AND. indep_dim .EQ. z_dim  ) THEN
* ... flip depth plots by default
	   flip = .NOT.transpz
	ELSE
	   flip = transpz
	ENDIF
	IF ( flip ) THEN
	   dep_ax    = 'X'
	   indep_ax  = 'Y'
	   dep_lab   = ppl_xlab
	   indep_lab = ppl_ylab
	   dep_len   = xlen
	   ind_len   = ylen
	   indep_is_log = is_logy
           dep_is_log   = is_logx

	   IF ( pxlim.GT.0 ) THEN
	      pindeplim = pxlim
	   ELSE
	      pindeplim = pvlim
	   ENDIF 
	   IF ( pylim.GT.0 ) THEN
	      pdeplim = pylim
	   ELSE
	      pdeplim = phlim
	   ENDIF 
	ELSE
	   dep_ax    = 'Y'
	   indep_ax  = 'X'
	   dep_lab   = ppl_ylab
	   indep_lab = ppl_xlab
	   ind_len   = xlen
	   dep_len   = ylen
	   indep_is_log = is_logx
           dep_is_log   = is_logy
	   IF ( pxlim.GT.0 ) THEN
	      pindeplim = pxlim
	   ELSE
	      pindeplim = phlim
	   ENDIF 
	   IF ( pylim.GT.0 ) THEN
	      pdeplim = pylim
	   ELSE
	      pdeplim = pvlim
	   ENDIF 
	ENDIF	   

* do not re-draw the main label, logo, other labels from the underlay plot
	IF (overlay) THEN
	   nlabs_on = 0  
	   CALL PPLCMD ( from, line, 0, 'LABS ', 1, 1 )	
	ENDIF

	IF ( no_labels ) CALL PPLCMD ( from, line, 0, 'LABS ', 1, 1 )

* * * * * * *    - - - INDEPENDENT AXIS DATA - - - * * * * * * * * *
	IF ( versus ) THEN
	   time_axis =	.FALSE.
	   adjust_time = .TRUE.  ! (Says, do not try to further adjust time...)
	   CALL EXTRACT_LINE ( cx,
     .			    memry(mv)%ptr,
     .			    mv,
     .			    indep_dat,
     .			    indep_dim,
     .			    ndim,
     .			    npts,
     .			    status	)
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   var1 = 2		! since first var is independent axis
	   ndv  = numv - 1	! # of dependent variables
	   use_keys = .FALSE.
	   plot_title = FULL_VAR_TITLE( cx_list(1), .TRUE., slen )

* ... Is this a dsg Profile dataset? Are we doing a vs plot? If so we may need to expand the 
*     first or second variable to the OBS axis.

	   expand_dsg_ok = .TRUE.
	   IF (its_dsg) THEN  ! Get the size of the second variable and decide whether to expand to obs axis.

	      npts2 = CGRID_SIZE( cx_list(var1) )

	      expand_dsg_ok = (npts.NE.nfeatures .OR. npts2.NE.nfeatures)
	      dsg_fmt_grid = 0

	      IF ( orientation.EQ.pfeatureType_Profile .AND. 
     .	           versus .AND. expand_dsg_ok) THEN

	         IF (npts .EQ. nfeatures) CALL DSG_OBS_BY_FEATURE_VAR 
     .	             (dset, cx, nfeatures, obsdimlen, indep_dat)
	         npts = obsdimlen
	         dsg_fmt_grid = dsg_xlate_grid(dset)
	      ENDIF
	      IF (dsg_feature_type(dset).EQ.pfeatureType_Point) expand_dsg_ok = .TRUE.
	   ENDIF


* ... Is this a dsg dataset and we're doing a DSG plot (not a native trajectory plot)  then 
*     apply an obs mask. Resets npts.

	   IF (grid_is_dsg .AND. .NOT.its_traj .AND.expand_dsg_ok) 
     .            CALL PLOT_DSG_APPLY_OBS_MASK (dset, cx, nfeatures, obsdimlen, 
     .             indep_dat, npts)

* ... label the independent axis as the first var given
c	   IF ( .NOT.no_labels) THEN
	      buff1 = VAR_UNITS(cx_x)
	      iunits = TM_UNIT_ID(buff1)

* Does it have time units? If so draw a formatted time axis
	      x_is_time = .FALSE.
	      since_T0 = MAX( INDEX(buff1,'since'), INDEX(buff1,'SINCE') )
	      slen = TM_LENSTR1(buff1)
	      IF (since_T0.GT.0 .AND. slen.GT.since_T0+5) THEN
	         cal_id_1 = 1
	         CALL TM_ALLO_DYN_LINE( itmp, status )	
	         CALL CD_GET_TIME_UNITS ( buff1, cal_id_1, line_units(itmp), 
     .			                   line_t0(itmp), dum, status )
		 IF (status .EQ. ferr_ok) THEN
		    x_is_time = .TRUE.
		    the_taxis = indep_dim
		    iunits = TM_UNIT_ID( line_units(itmp) )
		    line_unit_code(itmp) = TM_UNIT_ID( line_units(itmp) )
		    line_tunit(itmp) = un_convert(line_unit_code(itmp))
		    line_cal_name(itmp) = 'GREGORIAN'
		    line_direction( itmp ) = 'TI'

		    CALL MINMAX( indep_dat, npts, mr_bad_data(mv), lo, hi, nok )
		    grid_line(the_taxis, mgrid_buff) = itmp
		 
		    igrd_save =  cx_grid(cx_list(1))
		    cx_grid(cx_list(1)) = mgrid_buff
		    ww_save = cx_lo_ww(the_taxis,cx_list(1) ) 
		    cx_lo_ww(the_taxis,cx_list(1)) = lo

		    ind_min = TSTEP_TO_SECS (mgrid_buff, the_taxis, lo)
		    ind_max = TSTEP_TO_SECS (mgrid_buff, the_taxis, hi)

		    IF (dsg_fmt_grid .GT. 0) THEN
		       ind_min = TSTEP_TO_SECS (dsg_fmt_grid, t_dim, lo)
		       ind_max = TSTEP_TO_SECS (dsg_fmt_grid, t_dim, hi)
		    ENDIF

* Plotting short time range? If so recompute tref     
* axis length in hours from time since BC in seconds
		    IF (.NOT.overlay) THEN
                       hrs = ( ind_max - ind_min ) / 3600.
                       IF (hrs.LT.24) tref = 
     .                  MERGED_WHOI_DATE( cx_list(var1), the_taxis, numv, .TRUE. )

                       all_1_ind = ind_min .EQ. ind_max
                       IF ( all_1_ind ) THEN
                          ind_min = ind_min - 1.
                          ind_max = ind_max + 1.
                       ENDIF
		    
                       CALL TAXIS_STYLE( indep_ax, ind_min, ind_max, tstyle, xtra_lab )
* 11/16 Get the min and max as used by PPLUS.  That function uses WHOI formatted time
                      CALL TPLOT_AXIS_ENDS (ind_min, ind_max, cal_id_1, tstyle)
 
                      IF (.NOT.overlay) CALL AXIS_END_SYMS( indep_ax,
     .                          SECS_TO_TSTEP( mgrid_buff, the_taxis, ind_min ),
     .                          SECS_TO_TSTEP( mgrid_buff, the_taxis, ind_max ) )

		    ENDIF

	         ELSE
		    IF (itmp .NE. mnormal) CALL TM_DEALLO_DYN_LINE( itmp )
		    itmp = mnormal
	         ENDIF
	      ELSE  ! not time axis
	      
	         CALL MINMAX( indep_dat, npts, mr_bad_data(mv), lo, hi, nok )
	         ind_min = MIN(ind_min, lo)
	         ind_max = MAX(ind_max, hi)
	      ENDIF

	      slen = TM_LENSTR1(plot_title)

*  Check for lon-360 issues? Crossing the dateline within features, 
*  when longitude is in the obs direction.

              CALL GEOG_LABEL_VS (buff1, iunits, x_dim, axis_x_dir)

              IF (iunits .EQ. 4) THEN
		 delta = MAX(1., (ind_max-ind_min)/10.)  ! just a rough guess, will be set later
		 CALL GET_AXIS_FORMAT( ind_min, ind_max, delta, fmt, use_nice )

		 IF (grid_is_dsg .AND. versus .AND. use_nice .AND.
     .               axis_x_dir.EQ.x_dim .AND. npts.NE.nfeatures) THEN
		    
		    user_hlim = pindeplim .GT. 0
		    CALL PLOT_DSG_CHECK_LON360 (dset, cx, indep_dat, mr_bad_data(mv), 
     .                    npts, nfeatures, dum1, dum2, .TRUE.)

                 ENDIF
              ENDIF

	      IF (.NOT.no_labels .AND. iunits .NE. 4) 
     .           CALL BOX_LABEL( indep_lab,
     .			   plot_title(:slen),
     .			   0.0, 0.0, 0.6*ind_len, letsize_label,
     .			   letsize_label, ppl_centered,
     .			   lab_loc_absolute, lab_loc_absolute )
c	   ENDIF

* ... force axis scaling if the data has no range
	   all_1_ind = NO_LINE_RANGE( indep_dat,npts,mr_bad_data(mv),val1 )
	   delta = unspecified_val8

	   IF ( pindeplim .GT. 0 ) THEN
	      IF ( pxlim.GT.0 .AND. .NOT.denig_xylim_msg_done ) THEN
	         CALL WARN( '/XLIMITS and /YLIMITS are deprecated.')
	         CALL WARN( 'Use /HLIMITS and /VLIMITS instead.')
	         denig_xylim_msg_done = .TRUE.
	      ENDIF
* Get calendar name for equal_range (even if not time axis)
	      tax = grid_line(f_dim,cx_grid(cx_list(var1)) )
              IF (tax .EQ. 0) tax = grid_line(t_dim,cx_grid(cx_list(var1)) )
              cal_name = line_cal_name(tax)
              cal_id_1 = TM_GET_CALENDAR_ID ( cal_name )

	      CALL EQUAL_RANGE(
     .			cmnd_buff(qual_start(pindeplim):qual_end(pindeplim)),
     .			indep_dim, ind_min, ind_max, delta,
     .			formatted, range_rqd, cal_id_1, status )

* Check for a valid axis if they've asked for a log axis before proceeding

	      IF (indep_is_log) THEN
	         CALL AXIS_ENDS(indep_ax,indep_dim,grid1,ind_min,ind_max,
     .                       delta, indep_is_log, indep_axtyp, versus, status)
	         IF ( status .NE. ferr_OK ) THEN
                    first = ind_min
                    last  = ind_max
                    GOTO 5170
                 ENDIF

* Get requested ends in data units again
	         IF (versus) CALL EQUAL_RANGE(
     .			cmnd_buff(qual_start(pindeplim):qual_end(pindeplim)),
     .			indep_dim, ind_min, ind_max, delta,
     .			formatted, range_rqd, cal_id_1, status )

	      ENDIF

	      IF ( status .NE. ferr_OK ) GOTO 5000
	   ELSEIF ( all_1_ind .AND. .NOT.overlay ) THEN
	      IF ( val1 .EQ. mr_bad_data(mv) ) THEN
		 delta = 1.
	         ind_min = 0.D0
	         ind_max = 1.D0
	      ELSE
	         delta = 0.1* val1
	         ind_min = val1 - delta
	         ind_max = val1 + delta
	      ENDIF
	   ELSE
	      CALL MINMAX( indep_dat, npts, mr_bad_data(mv), lo, hi, nok )
	      IF (nok .EQ. 0) THEN ! all missing
	         ind_min = -1.
	         ind_max =  1.
	      ElSE
	         ind_min = lo
	         ind_max = hi
	      ENDIF
	   ENDIF

* Set up modulo longitude handling if /vs and variable has units
* of longitude

	   cx_x = cx_list(1)	 
	   cx_y = cx_list(2)
	   buff1 = VAR_UNITS(cx_x)
	   IF (iunits .GE. 0) iunits = TM_UNIT_ID(buff1)


	   IF (.NOT.overlay) THEN

	      CALL AXIS_ENDS(indep_ax,indep_dim,grid1,ind_min,ind_max,
     .                       delta, indep_is_log, indep_axtyp, versus, status)
	      IF ( status .NE. ferr_ok ) THEN
                 first = ind_min
                 last  = ind_max
                 GOTO 5170
              ENDIF

* This routine checks the units and the setting for formatted lon/lat (time?) axes
* If the formatting has been turned off, resets iunits and flag mod_vs_x.
* If the axes are labeled with longitude, latitude, or time, then set ul_dolab to not
* put upper-left labels on the plot with the ranges.

              CALL GEOG_LABEL_VS (buff1, iunits, x_dim, axis_x_dir)

              IF (iunits .EQ. 4) THEN
                 CALL GET_AXIS_FORMAT( ind_min, ind_max, delta, 
     .                  fmt, use_nice )
                 IF (use_nice) THEN
                    plot_axis(1) = 1
		    IF (axis_x_dir .EQ. x_dim) THEN
                       ppl_buff = 'XFOR,('//fmt(:TM_LENSTR1(fmt))//
     .                  ',''''LONE'''')'
                       CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
                       CALL LON_LAT_FMT (x_dim, 'X')
                       mod_vs_x = .TRUE.
                       ul_dolab(x_dim) = .FALSE.

                    ELSEIF (axis_x_dir .EQ. y_dim) THEN
                       ppl_buff = 'XFOR,('//fmt(:TM_LENSTR1(fmt))//
     .                  ',''''LAT'''')'
                       CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
                       CALL LON_LAT_FMT (y_dim, 'Y')
                       ul_dolab(y_dim) = .FALSE.
		       plot_axis(1) = 2
                    ELSE
                       ppl_buff = 'XFOR,('//fmt(:TM_LENSTR1(fmt))//
     .                  ',''''LONE'''')' 
                       CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
                       CALL LON_LAT_FMT (x_dim, 'X')
                       ul_dolab(x_dim) = .FALSE.
                    ENDIF
                 ENDIF
              ELSEIF (iunits .LT. 0) THEN ! time axis formatting
                 CALL PPLCMD ( from, line, 0, 'TIME', 1, 1 )
                 CALL PPLCMD ( from, line, 0, 'TAXIS 60,ON', 1, 1 )
                 ppl_buff = ' '
                 WRITE ( ppl_buff, 3004 ) 'GREGORIAN'
                 CALL PPLCMD (from, line, 0, ppl_buff, 1, 1)
                 ul_dolab(t_dim) = .FALSE.
		 plot_axis(1) = 4
	      ELSE
                 CALL PPLCMD ( from, line, 0, 'XFOR 0', 1, 1 )	 
              ENDIF	 
		  
              CALL PPLCMD ( from, line, 0, 'YFOR 0', 1, 1 ) ! for now, anyway	
	      
           ELSE ! overlay
              CALL PPLCMD ( from, line, 0, indep_ax//'FOR 0', 1, 1 )

              IF (iunits .EQ. 4) THEN
	         mod_vs_x = (TM_HAS_STRING(buff1, '_e') .OR.
     .                   TM_HAS_STRING(buff1, 'lon') )
	         
              ENDIF

              buff1 = VAR_UNITS(cx_y)	 
              junits = TM_UNIT_ID(buff1)
              IF (junits .EQ. 4) THEN
                  mod_vs_y = (TM_HAS_STRING(buff1, '_e') .OR.
     .                        TM_HAS_STRING(buff1, 'lon') ) 
              ENDIF

	   ENDIF

	ELSE	! (not VERSUS)

* define special axis labels to disambiguate T and F calendar axes
           IF ( ITS_FMRC(grid1) ) THEN
	      IF (GEOG_LABEL(indep_dim,grid1)) THEN
	         IF     (indep_dim .EQ. t_dim) THEN
	            xtra_lab = 'Verification Time ==>'
	         ELSEIF (indep_dim .EQ. f_dim) THEN
	            xtra_lab = 'Initialization Time ==>'
	         ENDIF
	      ENDIF
	   ENDIF

	   var1 = 1
	   ndv  = numv
	   ito  = 0
	   time_axis =	indep_dim.EQ.t_dim .OR. indep_dim.EQ.f_dim
	   IF ( time_axis ) THEN	! 11/95: are ALL vars time vars?

	      the_taxis = indep_dim

* and are all the calendar types the same?

              tax = grid_line(the_taxis,cx_grid(cx_list(var1)) )
              cal_name = line_cal_name(tax)
              cal_id_1 = TM_GET_CALENDAR_ID ( cal_name )

	      DO 100 ipl = var1, numv
	         time_axis = time_axis
     .			.AND. GEOG_LABEL( the_taxis, cx_grid(cx_list(ipl)) )
                 tax = grid_line(the_taxis,cx_grid(cx_list(ipl)) )
                 cal_id_2 = TM_GET_CALENDAR_ID ( line_cal_name(tax) )
                 IF (cal_id_2 .NE. cal_id_1) THEN
                    cal_id_old = cal_id_1
                    cal_id_new = cal_id_2
                    GO TO 5160
                 ENDIF
 100	      CONTINUE

	   ENDIF

* ... (PLOT+ needs TAXIS,ON prior to PPLLDX calls)
* ... PPLLDX computes axis endpoints if TIME is set to auto (no args given)

	   IF ( time_axis ) THEN
! *sh* 11/92 added numerical dt_min argument to TAXIS call in PLOT+
! this fixes err230_ppl_taxis.jnl symptomatically but probably leaves an
! unresolved scaling problem - especially with multiple time series w/ diff
! units so that the dt_min argument is not approproate to subsequent lines
! problem seems to go away if DT=60.0
	      CALL PPLCMD ( from, line, 0, 'TIME', 1, 1 )
	      IF ( indep_ax .EQ. 'X' ) THEN
	         CALL PPLCMD ( from, line, 0, 'TAXIS 60,ON', 1, 1 )
	      ELSE
	         CALL PPLCMD ( from, line, 0, 'TAXIS/YAXIS 60,ON', 1, 1 )
	      ENDIF

	      ppl_buff = ' '
	      WRITE ( ppl_buff, 3004 ) cal_name
              CALL PPLCMD (from, line, 0, ppl_buff, 1, 1)

c	      ul_dolab(t_dim) = .FALSE.  ! why was this added?
	   ENDIF
	ENDIF  ! end of  IF (versus)
 3004   FORMAT ('CALENDAR ', A7)

* set up PLOT5 to ignore bad data flag
	IF ( versus ) THEN               ! 1/94
	   ppl_buff = ' '
	   WRITE ( ppl_buff, 3005 ) mr_bad_data( mv ), indep_ax
	   CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1)
	ENDIF
 3005	FORMAT ( 'LIMITS ',G15.8,1X,A1,'EQ' )

* Send info about gap var for PLOT/VS/GAPLOC

	CALL PPLCMD ( from, line, 0, 'GAPLOC 0', 1, 1)
	IF (addgaps) THEN
	   ppl_buff = ' '
	   WRITE ( ppl_buff, 3007 ) gap_var
	   CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1)
	ENDIF
 3007	FORMAT ( 'GAPLOC ',I5 )

* * * * * * *    - - - LOAD DATA - - - * * * * * * * * *
* 11/95: determine T0 reference time for time axis
	IF ( time_axis .AND. .NOT.overlay ) THEN
	   tref = MERGED_WHOI_DATE( cx_list(var1), the_taxis, numv, .FALSE. )
	ELSE
	   tref = ' '		! overlays reuse previous tref
	ENDIF

* loop through all the dependent variables loading them into PPLUS

	all_1_dep = .TRUE.
	set_axis = .TRUE.
	only_val  = bad_val4
	nload_all = 0

	IF (grid_is_dsg .AND. versus .AND. .NOT.its_traj ) numv = numv + 1 ! fake a gap-var


	DO 200 ipl = var1, numv
	   IF (grid_is_dsg .AND. versus .AND. .NOT.its_traj .AND. ipl.EQ.gap_var) THEN

*  create the gaps-var.  IF npts2 = nfeatures (e.g. a plot of lon vs lat for timeseries stations)
*  then the gap-var will be all 0's, e.g. no gaps.
	      cx = cx_list( 1 )
	      IF (npts2 .NE. nfeatures) npts2 = obsdimlen
	      CALL DSG_OBS_MARK_GAPS (dset, cx, nfeatures, npts2, dep_dat)
	      status = ferr_ok
	   
	   ELSE
	      mv   = mv_list( ipl )
	      cx   = cx_list( ipl )
	      grid = cx_grid( cx )
	      dset = cx_data_set(cx)
              IF (.NOT.versus) THEN 
                 CALL GET_CX_DIMS( cx, ndim, dims )
                 IF (ndim .GT. 1) GOTO 5110
              ENDIF

* set up a dependent variable.

	      CALL EXTRACT_LINE (	cx,
     .				memry(mv)%ptr,
     .				mv,
     .				dep_dat,
     .				dep_dim,
     .				ndim,
     .				npts2,
     .				status	)
           ENDIF
           iaxis = CGRID_AXIS(dep_dim,cx)
 
	   IF ( status .NE. ferr_ok ) GOTO 5000

	   IF (cxdsg_empty_set) THEN
	      dep_dat(1) = -1.
	      dep_dat(2) =  1.
	   ENDIF
	      

* ... If this is a profile or timeseries collection maybe we are just makinga map with 
*     the stations so dep_dat and indep dat are the longitudes and latitudes. The flag
*     expand_dsg_ok false, says just plot the instance variables
	   
* ... Or, is this a dsg Profile dataset? Are we doing a vs plot? If so we may need to expand the 
*     first or second variable to the OBS axis.

	   IF (its_dsg .AND. 
     .	       orientation.EQ.pfeatureType_Profile .AND. 
     .	       versus .AND. npts2.EQ.nfeatures .AND. expand_dsg_ok) THEN
	      IF (npts2 .EQ. nfeatures) CALL DSG_OBS_BY_FEATURE_VAR 
     .	           (dset, cx, nfeatures, obsdimlen, dep_dat)
	      npts2 = obsdimlen
	      dsg_fmt_grid = dsg_xlate_grid(dset)
	   ENDIF

* ... For a dsg dataset, can ask to color by a feature-level variable
*     such as an ID or a string-valued feature variable. 

	   doing_ribbon_color = ribbon_plot .AND. ipl.EQ.ribbon_var

	   IF (its_dsg .AND. doing_ribbon_color .AND. versus) THEN

	      color_dsg_id = (cx_variable(cx).EQ.dsg_feature_var(dset) )  .OR. 
     .		             (npts2.LT.obsdimlen .AND. cx_type(cx).EQ.ptype_string)
	      IF (color_dsg_id ) CALL SET_DSG_ID_LEV
     .		      (dset, cx, nfeatures, dep_dat, mr_type(mv), changed_key)

	      IF (npts2 .EQ. nfeatures) THEN
		 IF (color_dsg_id) THEN
		    DO i = 1, npts2
		       dep_dat(i) = i
		    ENDDO
		 ENDIF
		 IF (expand_dsg_ok) THEN
		    CALL DSG_OBS_BY_FEATURE_VAR (dset, cx, nfeatures, obsdimlen, dep_dat)
		    npts2 = obsdimlen
	         ENDIF
	      ENDIF

	   ENDIF

* ... Is this a dsg dataset?  if so apply an obs mask. Resets npts2

	   IF (grid_is_dsg .AND. .NOT.its_traj .AND. versus .AND. 
     .		expand_dsg_ok .AND. .NOT.cxdsg_empty_set) 
     .       CALL PLOT_DSG_APPLY_OBS_MASK (dset, cx, nfeatures, 
     .       obsdimlen, dep_dat, npts2)

* ... replicate points to create a "step" plot if requested  (1/01)
	   nload = npts2 * step_inc
           IF (step_inc .EQ. 2) THEN
	      DO i = npts2, 1, -1
	         dep_dat(2*i)   = dep_dat(i)
	         dep_dat(2*i-1) = dep_dat(i)
	      END DO
           ELSEIF (step_inc .EQ. 3) THEN
	      DO i = npts2, 1, -1
	         dep_dat(3*i)   = mr_bad_data(mv)
	         dep_dat(3*i-1) = dep_dat(i)
	         dep_dat(3*i-2) = dep_dat(i)
	      END DO
	   ENDIF

* set up corresponding independent axis
* ( note - each variable may have different points on the indep. axis )

	   IF ( versus ) THEN
* ... number of values must be equal in independ. and depend. for ordered pairs
	      IF ( npts2 .NE. npts ) GOTO 5130

* Set up the dependent axis.

	      set_axis = .TRUE.
	      IF (ribbon_plot .OR. addgaps) set_axis = (ipl .EQ. var1)
              IF (set_axis) THEN
	         IF (.NOT.overlay) THEN
	            CALL MINMAX( dep_dat, npts, mr_bad_data(mv), lo, hi, nok )
 	            IF (nok .EQ. 0) THEN ! all missing
 	               dep_min = -1
 	               dep_max =  1
 	            ELSE
 	               dep_min = MIN(dep_min, lo)
 	               dep_max = MAX(dep_max, hi)
 	            ENDIF
		 ENDIF

                 cx_y = cx_list(2) 	
                 buff1 = VAR_UNITS(cx_y)
		 IF (doing_ribbon_color) buff1 = ' '
		 
		 iunits = TM_UNIT_ID(buff1)

	         IF (.NOT.overlay) THEN

* Does it have time units? If so draw a formatted time axis
                 y_is_time = .FALSE.
                 since_T0 = MAX( INDEX(buff1,'since'), INDEX(buff1,'SINCE') )
                 slen = TM_LENSTR1(buff1)
                 IF (.NOT.x_is_time .AND. since_T0.GT.0 .AND. slen.GT.since_T0+5) THEN
	            cal_id_1 = 1
	            CALL TM_ALLO_DYN_LINE( itmp, status )	
	            CALL CD_GET_TIME_UNITS ( buff1, cal_id_1, line_units(itmp), 
     .			                   line_t0(itmp), dum, status )
		    IF (status .EQ. ferr_ok) THEN
		       y_is_time = .TRUE.
		       time_axis = .TRUE.
		       the_taxis = dep_dim
		       has_time_axis = .TRUE.
		       iunits = TM_UNIT_ID( line_units(itmp) )
		       line_unit_code(itmp) = TM_UNIT_ID( line_units(itmp) )
		       line_tunit(itmp) = un_convert(line_unit_code(itmp))
		       line_cal_name(itmp) = 'GREGORIAN'
		       line_direction( itmp ) = 'TI'

		       grid_line(the_taxis, mgrid_buff) = itmp
		 
		       igrd_save =  cx_grid(cx_list(1))
		       cx_grid(cx_list(1)) = mgrid_buff
		       ww_save = cx_lo_ww(the_taxis,cx_list(1) ) 
		       cx_lo_ww(the_taxis,cx_list(1)) = lo

		       dep_min = MIN(dep_min, TSTEP_TO_SECS (mgrid_buff, the_taxis, lo))
		       dep_max = MAX(dep_max, TSTEP_TO_SECS (mgrid_buff, the_taxis, hi))
		    
		       CALL TAXIS_STYLE( dep_ax, dep_min, dep_max, tstyle, xtra_lab )
* 11/16 Get the min and max as used by PPLUS.  That function uses WHOI formatted time
		       CALL TPLOT_AXIS_ENDS (dep_min, dep_max, cal_id_1, tstyle)
 
		       CALL AXIS_END_SYMS( dep_ax,
     .                          SECS_TO_TSTEP( mgrid_buff, the_taxis, dep_min ),
     .                          SECS_TO_TSTEP( mgrid_buff, the_taxis, dep_max ) )


		    ENDIF

		 ENDIF

* This routine checks the units and the setting for formatted lon/lat (time?) axes
* If the formatting has been turned off, resets iunits and flag mod_vs_x.

		 CALL GEOG_LABEL_VS (buff1, iunits, y_dim, axis_y_dir)

                 IF (iunits .EQ. 4) THEN
	            delta = unspecified_val8
		    
	            CALL AXIS_ENDS(dep_ax,dep_dim,grid1,dep_min,dep_max,
     .                      delta, dep_is_log, dep_axtyp, versus, status)

	            CALL GET_AXIS_FORMAT( dep_min, dep_max, delta, 
     .                 fmt, use_nice )

                    IF (use_nice) THEN

* Make sure if we are using lon/lat labeling that we have just one of each direction.
* e.g. if they said just degrees_n for the x dir, but just "degrees" for the y var, 
* use east for the vert. If they said degrees_e for the y var but just degrees for the x,
* use lon for the y axis.
* If the axes are labeled with longitude, latitude, or time, then set ul_dolab to not
* put upper-left labels on the plot with the ranges.

                       IF (axis_x_dir.EQ.y_dim .AND. axis_y_dir.EQ.no_dim) THEN
		          IF (iunits .EQ. 4) THEN
		             ppl_buff = 'YFOR,('//fmt(:TM_LENSTR1(fmt))//
     .                       ',''''LONE'''')' 
		             ul_dolab(x_dim) = .FALSE.
		             plot_axis(1) = 1
		          ENDIF

                       ELSEIF (axis_y_dir .EQ. x_dim) THEN
		          ppl_buff = 'YFOR,('//fmt(:TM_LENSTR1(fmt))//
     .                       ',''''LONE'''')' 
		          mod_vs_y = .TRUE.
		          ul_dolab(x_dim) = .FALSE.
		          plot_axis(1) = 1

		          IF (axis_x_dir .EQ. no_dim) THEN
		             buff1 = VAR_UNITS(cx_x)
		             iiunits = TM_UNIT_ID(buff1)
		             CALL GEOG_LABEL_VS (buff1, iiunits, x_dim, axis_x_dir)
		             IF (iiunits .EQ. 4) THEN
		                ppl_buff = 'XFOR,('//fmt(:TM_LENSTR1(fmt))//
     .                           ',''''LAT'''')'
		                ul_dolab(y_dim) = .FALSE.
		                plot_axis(1) = 2
		             ENDIF
		          ENDIF
                       ELSEIF (axis_y_dir .EQ. y_dim) THEN
                           ppl_buff = 'YFOR,('//fmt(:TM_LENSTR1(fmt))//
     .                       ',''''LAT'''')'
                           ul_dolab(y_dim) = .FALSE.
		           plot_axis(2) = 2
                       ELSE
                           ppl_buff = 'YFOR,('//fmt(:TM_LENSTR1(fmt))//
     .                       ',''''LAT'''')' 
                           ul_dolab(y_dim) = .FALSE.
		           plot_axis(2) = 2
                       ENDIF

                       CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
                    ENDIF

                 ELSEIF (iunits .LT. 0) THEN ! time axis formatting
                    CALL PPLCMD ( from, line, 0, 'TIME', 1, 1 )
                    CALL PPLCMD ( from, line, 0, 'TAXIS/YAXIS 60,ON', 1, 1 )
                    ppl_buff = ' '
                    WRITE ( ppl_buff, 3004 ) 'GREGORIAN'
                    CALL PPLCMD (from, line, 0, ppl_buff, 1, 1)
                    ul_dolab(t_dim) = .FALSE.
		    plot_axis(2) = 4

	         ELSE
                   CALL PPLCMD ( from, line, 0, 'YFOR 0', 1, 1 )	 
                 ENDIF	
	         ENDIF  ! not overlay
              ENDIF  ! set_axis

	   ELSE  ! versus

* ... in PLOT TEMP , SALT , U all vars must be along same ww dimension

	      IF ( ndim .GT. 1 ) GOTO 5110
	      IF ( dep_dim .NE. indep_dim ) GOTO 5140
	      CALL MAKE_STEP_AXIS( grid, dep_dim, step_inc,
     .			cx_lo_ss(cx,dep_dim), cx_hi_ss(cx,dep_dim),
     .			indep_dat )
	      IF ( time_axis ) THEN
	         ind_min = MIN( ind_min,
     .                     TSTEP_TO_SECS(grid, the_taxis, DBLE(indep_dat(1)) ))
	         ind_max = MAX( ind_max,
     .                     TSTEP_TO_SECS(grid, the_taxis, DBLE(indep_dat(nload)) ))

* Plotting short time range? If so recompute tref     
* axis length in hours from time since BC in seconds
	         IF (.NOT.overlay) THEN
	            hrs = ( ind_max - ind_min ) / 3600.
		    IF (hrs.LT.24)
     . 	            tref = MERGED_WHOI_DATE( cx_list(var1), the_taxis, numv, .TRUE. )
		 ENDIF
	      ELSE
	         
	         CALL MINMAX( indep_dat, npts, mr_bad_data(mv), lo, hi, nok )
	         ind_min = MIN(ind_min, lo)
	         ind_max = MAX(ind_max, hi)

	      ENDIF
	      all_1_ind = ind_min .EQ. ind_max
	      IF ( all_1_ind ) THEN
	         delta = 1.0
		 IF (ind_min .NE. 0) delta = 0.1* ind_min
		 IF (indep_dim .EQ. the_taxis) delta = 240*3600
	         ind_min = ind_min - delta
	         ind_max = ind_max + delta
	      ENDIF
	   ENDIF

* Compute the mean and standard dev for ribbon-color variable, 
* needed for computing color levels. Results stored in PPLUS common.
* If histogram-based levels are requested, compute the 
* histogram bins.
* send REAL*4 rbad to compare with lev_max, lev_min inside compute_mnstd
* If the user set some /LEVELS then compute_mnstd just returns 

	   IF (doing_ribbon_color) THEN

              IF (need_histo) THEN
* create temporary buffer to contain workspace
                 CALL CREATE_TEMP_MEM_VAR( cx, mvh_temp, status )
                 IF ( status .NE. ferr_ok ) RETURN
                 plot_mem_used = plot_mem_used + npts
                 CALL COMPUTE_HISTO_BINS (dep_dat, memry(mvh_temp)%ptr, 
     .            mr_bad_data(mv), npts, status) 
     
* ... clean up temporary variable
                 CALL DELETE_VARIABLE( mvh_temp )
              ELSE 
		 rbad = bad_val4
                 CALL COMPUTE_MNSTD (dep_dat, mr_bad_data(mv), need_std, npts, rbad, status)
                 IF (need_std .AND. status.NE.ferr_ok) THEN
* ... set up for automatic levels
                    CALL PPLCMD ( from, line, 0, 'LEV,()', 1, 1 )
                    CALL USE_LINEAR_LEVELS
                    status = ferr_ok
                 ENDIF

              ENDIF

	   ENDIF

* ... check that there is a range of dependent data for PLOT+ auto-scaling
* ... when all the variables are considered together (but not the ribbon var)

	   IF (addgaps .AND. ipl.EQ.gap_var) GOTO 199

	   IF (.NOT.ribbon_plot .OR. (ribbon_plot .AND. ipl.LT.ribbon_var)) THEN
	      this_no_range(ipl) = .FALSE.
              IF (set_axis) this_no_range(ipl) = NO_LINE_RANGE( 
     .          dep_dat, nload, mr_bad_data(mv), val1 )
	      all_1_dep = all_1_dep .AND. this_no_range(ipl)
              IF (this_no_range(ipl) .AND. val1.NE.mr_bad_data(mv) )
     .           this_no_range(ipl) = .FALSE. ! Keep the value for putting NO VALID on labels

	      IF ( all_1_dep ) THEN
	         IF ( only_val .EQ. bad_val4 ) THEN
	            IF ( val1 .NE. mr_bad_data(mv) ) only_val = val1
	         ELSE
	           all_1_dep = all_1_dep .AND. only_val .EQ. val1
	         ENDIF

	      ENDIF
	   ENDIF  ! checking range when not ribbon variable

  199	   CONTINUE  ! checking range when not gap variable

* pass the data to PLOT+

	   WRITE ( ppl_buff, 3005 ) mr_bad_data( mv ), dep_ax
	   CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
	   IF ( time_axis ) THEN
              IF ( tax .EQ. mnormal .OR. tax .EQ. munknown ) THEN  ! 8/91 bug
                 dt_min = 1.0
              ELSE
	         dt_min = line_tunit( grid_line(the_taxis,grid) ) / 60.! sec-->min
	         IF ( ITSA_TRUEMONTH_AXIS(grid_line(the_taxis,grid)) ) 
     .                dt_min = un_convert(pun_day)/60. 

*  Check for calendar mismatch for time- overlay plots
	         IF (overlay) THEN
                    IF (cal_id_1 .NE. saved_calendar_id) THEN
                       cal_id_old = saved_calendar_id
                       cal_id_new = cal_id_1
                       GO TO 5160
	            ENDIF
                 ENDIF
              ENDIF
              t1_date = INTERNAL_WHOI_DATE( grid, the_taxis, 1.0D0 )
           ELSE
	      IF (overlay .AND. has_time_axis) THEN
	         dt_min  = saved_dt_min
	         t1_date = saved_t1_date
	      ELSEIF (.NOT.ribbon_plot) THEN
                 dt_min  = 1.0
                 t1_date = ' '
	      ENDIF
           ENDIF

	   IF (overlay) THEN
	      SOVER = .true.
	   ELSE
	      has_time_axis = time_axis
 	      IF (has_time_axis) THEN
	         saved_dt_min  = dt_min		! to re-use on PLOT/VS or POLYGON
	         saved_t1_date = t1_date
	         saved_calendar_id = cal_id_1
	      ENDIF
	   ENDIF

* put colorvar in the right place
	   IF (doing_ribbon_color) THEN   !!! .AND. .NOT.add_ribbon
	      flip = .FALSE.
	      IF (indep_dim .EQ. z_dim) THEN
	         WRITE ( ppl_buff, 3005 ) mr_bad_data( mv ), indep_ax
	         CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
	      ENDIF
	   ENDIF

! put gap-var in the right place
	   IF (ipl .EQ. gap_var) THEN
	      flip = .FALSE.
	      IF (indep_dim .EQ. z_dim) THEN
	         WRITE ( ppl_buff, 3005 ) mr_bad_data( mv ), indep_ax
	         CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
	      ENDIF
	   ENDIF

* If a /vs plot has a variable with units of time, put the itmp line into 
* the scratch grid mgrid_buff, so the WHOI_DATE functions can get at the 
* line_* information stored above after calls to CD_GET_TIME_UNITS. 

	   IF (versus) THEN

	      IF (x_is_time) THEN
		 dt_min = line_tunit(itmp)/ 60.
		 
		 adjust_time = .FALSE.
		 CALL AXIS_ENDS(indep_ax,the_taxis,mgrid_buff,ind_min,ind_max,
     .                       delta, indep_is_log, indep_axtyp, versus, status)

                 tref = MERGED_WHOI_DATE( cx_list(1), the_taxis, 1, .FALSE. )
                 t1_date = INTERNAL_WHOI_DATE( mgrid_buff, the_taxis, 1.0D0 )

		 cx_grid(cx_list(1)) = igrd_save
		 cx_lo_ww(the_taxis,cx_list(1) ) = ww_save 
		 IF (ipl .EQ. numv) THEN
		    IF (itmp .NE. mnormal) CALL TM_DEALLO_DYN_LINE( itmp )
		    itmp = mnormal
		 ENDIF

	      ENDIF
	      
	      IF (y_is_time .AND. .NOT.doing_ribbon_color) THEN
	      
		 dt_min = line_tunit(itmp)/ 60.
		 
		 adjust_time = .FALSE.
		 CALL AXIS_ENDS(dep_ax,the_taxis,mgrid_buff,dep_min,dep_max,
     .                       delta, indep_is_log, indep_axtyp, versus, status)

                 tref = MERGED_WHOI_DATE( cx_list(1), the_taxis, 1, .FALSE. )
                 t1_date = INTERNAL_WHOI_DATE( mgrid_buff, the_taxis, 1.0D0 )

		 cx_grid(cx_list(1)) = igrd_save
		 cx_lo_ww(the_taxis,cx_list(1) ) = ww_save 
		 IF (ipl .EQ. numv) THEN
		    IF (itmp .NE. mnormal) CALL TM_DEALLO_DYN_LINE( itmp )
		    itmp = mnormal
		 ENDIF


		 IF (.NOT.overlay) THEN
	            saved_dt_min  = dt_min		! to re-use on PLOT/VS or POLYGON
	            saved_t1_date = t1_date
	            saved_calendar_id = cal_id_1
	         ENDIF

		 IF (iunits .LT. 0) THEN
	            dt_min = saved_dt_min
	            t1_date = saved_t1_date
	            cal_id_1 = saved_calendar_id
		 ENDIF 
		         
	      ENDIF

	   ENDIF

* See pplldx comments. When loading the color-by variable lon vertical time axis
* this forces the right combination of settings.

	   IF (doing_ribbon_color) icode = 2
	   IF (y_is_time .AND. doing_ribbon_color) icode = 7

	   IF ( flip ) THEN
	      CALL PPLLDX_envelope(icode,dep_dat,indep_dat,nload,
     .                             t1_date, tref, dt_min, plot_mem_used)
	   ELSE
	      CALL PPLLDX_envelope(icode,indep_dat,dep_dat,nload,
     .                             t1_date, tref, dt_min, plot_mem_used)
	   ENDIF
* ... increment number of lines on plot
	   nline_on     = nline_on     + 1
	   nline_in_mem = nline_in_mem + 1
* ... assign line style for the data plotting:
	   CALL LINE_STYLE(line_symbol, sym_size, skipsym, color, color1, use_line,
     .			   do_dash, dashstyle, nline_in_mem, nline_on)

	   nload_all = MAX(nload, nload_all)
 200	CONTINUE

        nline_on = nline_on + color1 - 1

* axis scaling and formatting
* ... independent axis

	IF ( .NOT.overlay ) THEN
	   IF ( .NOT. versus ) THEN
	      
	      delta = unspecified_val8

	      IF ( pindeplim .GT. 0 ) THEN
	         IF (pxlim.GT.0 .AND. .NOT.denig_xylim_msg_done) THEN
	            CALL WARN( '/XLIMITS and /YLIMITS are deprecated.')
	            CALL WARN( 'Use /HLIMITS and /VLIMITS instead.')
	            denig_xylim_msg_done = .TRUE.
	         ENDIF
	         CALL EQUAL_RANGE(
     .			cmnd_buff(qual_start(pindeplim):qual_end(pindeplim)),
     .			indep_dim, ind_min, ind_max, delta,
     .			formatted, range_rqd, cal_id_1, status )
	         IF ( status .NE. ferr_OK ) GOTO 5000
		 
*  Check for valid log axis before proceeding
	         IF (indep_is_log) THEN
	            CALL AXIS_ENDS  ( indep_ax, indep_dim, grid1,
     .				   ind_min, ind_max, delta, 
     .				   indep_is_log, indep_axtyp, versus, status )
	            IF ( status .NE. ferr_OK ) THEN
                       first = ind_min
                       last  = ind_max
                       GOTO 5170
                    ENDIF

* Get requested ends in data units again    
	            CALL EQUAL_RANGE(
     .			cmnd_buff(qual_start(pindeplim):qual_end(pindeplim)),
     .			indep_dim, ind_min, ind_max, delta,
     .			formatted, range_rqd, cal_id_1, status )

	         ENDIF

* convert time given in time steps to absolute units	   
	         IF ( time_axis .AND. .NOT.formatted ) THEN
* time limits given as tstep range although mode calendar is true
	            IF ( ind_min .GT. ind_max ) THEN  ! no reversed calendar
	               tmp = ind_min
	               ind_min = ind_max
	               ind_max = tmp
	            ENDIF
	            ind_min = TSTEP_TO_SECS( grid1, the_taxis, ind_min )
	            ind_max = TSTEP_TO_SECS( grid1, the_taxis, ind_max )
	         ELSEIF ( indep_dim .EQ. the_taxis
     .		   .AND. .NOT.time_axis
     .	           .AND.  formatted ) THEN
* time limits given as dates although mode calendar is false
	            ind_min = SECS_TO_TSTEP( grid1, the_taxis, ind_min )
	            ind_max = SECS_TO_TSTEP( grid1, the_taxis, ind_max )
	         ENDIF
              ELSE   ! /HLIM or /VLIM not used; check for range in indep direction

c one-point on the independent axis, still make a nominal plot?
c                 IF (nload_all .EQ. 1) GOTO 5180

                 IF (nload_all .EQ. 1) THEN
		    IF ( indep_dim .EQ. the_taxis) THEN  ! nominally +/- 10 day
c		       ind_min = indep_dat(1) - 240*3600
c		       ind_max = indep_dat(1) + 240*3600
		       pindeplim = ind_max - ind_min
		    ELSE
		       ind_min = ind_min - 1.
		       ind_max = ind_max + 1.
		       pindeplim = 2.
		    ENDIF
		    IF (line_symbol.EQ.qual_off .OR. 
     .               line_symbol.EQ.unspecified_int4) 
     .               line_symbol = qual_on  ! draw point with a symbol
		    CALL LINE_STYLE(line_symbol, sym_size, skipsym, color, color1, use_line,
     .			   do_dash, dashstyle, nline_in_mem, 1)
		    
                 ENDIF

	      ENDIF
	      IF ( time_axis ) THEN
	         IF ( pindeplim .GT. 0 ) CALL PPL_TIME( ind_min,ind_max,
     .                                    cal_id_1)
	         CALL TAXIS_STYLE( indep_ax, ind_min, ind_max, tstyle, xtra_lab )
* (6/99) Note: The time axis extrema symbols are only approximately correct
*		since PLOT+ rounds out the time ranges ...

* 11/16 Get the min and max as used by PPLUS.  That function uses WHOI formatted time
	         CALL TPLOT_AXIS_ENDS (ind_min, ind_max, cal_id_1, tstyle)

	         CALL AXIS_END_SYMS( indep_ax,
     .				SECS_TO_TSTEP( grid1, the_taxis, ind_min ),
     .				SECS_TO_TSTEP( grid1, the_taxis, ind_max ) )
	      ELSE
	         CALL AXIS_ENDS  ( indep_ax, indep_dim, grid1,
     .				   ind_min, ind_max, delta, 
     .				   indep_is_log, indep_axtyp, versus, status )
	         IF ( status .NE. ferr_OK ) THEN
                    first = ind_min
                    last  = ind_max
                    GOTO 5170
                 ENDIF
	
	         timeax_both = .FALSE.
	         CALL AXIS_FORMAT( indep_ax, indep_dim, grid1,
     .				   ind_min, ind_max, delta,
     .				   pnot_curv, 0,
     .				   time_axis, timeax_both, tstyle,
     .                             no_labels, xtra_lab, ascale, aoff )
	      ENDIF
	   ENDIF

* ... dependent axis scaling
*  force axis scaling if the data has no range

           IF (the_taxis .EQ. 0) the_taxis = dep_dim

	   IF ( pdeplim .GT. 0 ) THEN
	      IF (pylim.GT.0 .AND. .NOT.denig_xylim_msg_done) THEN
	         CALL WARN( '/XLIMITS and /YLIMITS are deprecated.')
	         CALL WARN( 'Use /HLIMITS and /VLIMITS instead.')
	         denig_xylim_msg_done = .TRUE.
	      ENDIF
*  Check for valid log axis before proceeding
*  First make sure the min and max are set.
	      IF (dep_is_log) THEN
	      
	         CALL MINMAX( dep_dat, npts, mr_bad_data(mv), lo, hi, nok )
		 IF (nok .EQ. 0) GOTO 5171
	         dep_min = lo
	         dep_max = hi
	         
	         CALL AXIS_ENDS( dep_ax, the_taxis, grid, dep_min, dep_max, 
     .                        delta, dep_is_log, dep_axtyp, versus, status )

	      ENDIF

* Do the dependent variable(s) have units of time? If not then don't send 
* dep_dim = t_dim to EQUAL_RANGE.  When the dependent data is on a time 
* axis, then the_taxis is set, but we don't want to be translating limits 
* for the dependent axis as time units.

	      dep_dir = dep_dim
	      IF (dep_dim .EQ. t_dim) THEN

	         DO ipl = 1, nmv
		    buff1 = VAR_UNITS( cx_list(ipl) )
		    iunits = TM_UNIT_ID(buff1)
		    IF ( iunits .GT. pun_last_time ) dep_dir = 0
		 ENDDO
		 
	      ENDIF

	      CALL EQUAL_RANGE(
     .			cmnd_buff(qual_start(pdeplim):qual_end(pdeplim)),
     .			dep_dir, dep_min, dep_max, delta,
     .			formatted, range_rqd, cal_id_1, status )
	      IF ( status .NE. ferr_OK ) GOTO 5000

	      CALL AXIS_ENDS( dep_ax, the_taxis, grid, dep_min, dep_max, 
     .                        delta, dep_is_log, dep_axtyp, versus, status )

	   ELSEIF ( all_1_dep ) THEN
	      IF (only_val .EQ. bad_val4) val1 = 0.0	! 10/99
	      delta = 1.
	      IF (val1 .NE. 0) delta = 0.1* val1
	      
	      CALL AXIS_ENDS( dep_ax, the_taxis, grid,val1-delta,val1+delta,delta,
     .                        dep_is_log, dep_axtyp, versus, status )   

	   ELSEIF (dep_is_log) THEN	! get dependent var scaling and set up log axis
	      CALL MINMAX( dep_dat, npts, mr_bad_data(mv), lo, hi, nok )
	      IF (nok .EQ. 0) GOTO 5171  ! all missing
	      dep_min = lo
	      dep_max = hi
	      
	      CALL AXIS_ENDS( dep_ax, the_taxis, grid, dep_min, dep_max, 
     .                        delta, dep_is_log, dep_axtyp, versus, status )

	   ELSE 
       
	      IF (its_dsg .AND. versus) THEN  ! /vs plot with depth as an axis?
	         dsg_fmt_grid = dsg_xlate_grid(dset)
	         cx = cx_list( 2 )
	         iaxis = grid_line(z_dim,dsg_fmt_grid)
	         IF (cx_variable(cx) .EQ. dsg_coord_var(z_dim,dset) .AND. 
     .       	     line_direction(iaxis) .EQ. "UD") THEN
	            tmp = dep_min
	            dep_min = dep_max
	            dep_max = tmp
	         ENDIF

	         delta = unspecified_val8
	         CALL AXIS_ENDS( dep_ax, the_taxis, grid, dep_min, dep_max, 
     .                        delta, dep_is_log, dep_axtyp, versus, status )
	      ENDIF

     
	   ENDIF
	   IF ( status .NE. ferr_OK ) THEN
	      first = dep_min
	      last  = dep_max
	      GOTO 5170
	   ENDIF

*   When not an overlay, set the axis type to log or reverse log

	   IF (dep_is_log  .OR.  indep_is_log) THEN
	      IF (flip) THEN
		 WRITE (val_buff, 3006) dep_axtyp, indep_axtyp
	      ELSE
 	         WRITE (val_buff, 3006) indep_axtyp, dep_axtyp
	      ENDIF

 3006         FORMAT ('axtype,', I2, ',', I2)
              CALL PPLCMD ( from, line, 0, val_buff, 1, 1)
	   ENDIF

	   IF (cxdsg_empty_set) THEN
	      WRITE ( val_buff, '(3(E14.7,1X))' ) dep_dat(1), dep_dat(2), dep_dat(2)
	      CALL PPLCMD ( from, line, 0, 
     .				dep_ax//'AXIS '//val_buff , 1, 1 )
              WRITE (cxdsg_axlabp_save, "(I2, ',', I2)") LABELX, LABELY
	      IF (flip) THEN
	         CALL PPLCMD (from, line, 0,'AXLABP,0,-1',1,1)
              ELSE
	         CALL PPLCMD (from, line, 0,'AXLABP,-1,0',1,1)
	      ENDIF
	   ENDIF

           ax1 = axdir(indep_dim)
  	   IF (flip) THEN
              CALL PPLCMD ( from, line, 0, 'SET AX_VERT '//ax1, 1, 1 )
	   ELSE
	      CALL PPLCMD ( from, line, 0, 'SET AX_HORIZ '//ax1, 1, 1 )
           ENDIf
	ENDIF

*  TITLES
* Main plot title. Add labels for multi-lines as a key, 
* or a "Colored by var2" label for the ribbon color variable
*
	hlen = xlen ! single-precision xlen from PPLUS common -> double prec. var

        IF (x_is_time .OR. y_is_time) THEN
           ul_dolab(t_dim) = .FALSE.
           READ (t1_date(13:14), *) cen
           READ (t1_date(1:2), *) yr
           ind_min = 100*cen + yr 
        ENDIF

* Line-key labels

	fvar = 0
	IF (dset .GT. pdset_irrelevant) fvar = dsg_feature_var(dset)
	IF ( .NOT.no_labels ) 
     .          CALL LINE_PLOT_LABELS (var1, nkey_entries, ndv, cx_list, 
     .		this_no_range, overlay, versus, nokey, time_axis, 
     .		tstyle, cal_id_1, ribbon_var, indep_lab, dep_lab, 
     .		ind_min, dep_len, hlen, nfeatures, dset, fvar)

* successful completion
 1000	CONTINUE
	status = ferr_ok
	IF (overlay) iautot = iautot_save
	RETURN

* error exit
 5000	CALL PPLCMD ( from, line, 0, 'NLINES', 1, 1 )	! wipe buffers clean
 	IF (itmp .NE. mnormal) CALL TM_DEALLO_DYN_LINE( itmp )
	RETURN
 5050	buff1 = LEFINT( max_line_on_plot, slen  )
	CALL ERRMSG( ferr_invalid_command, status, 'cannot plot more than '
     .                  //buff1(:slen)//' lines with a single PLOT', *5000)
 5100	CALL ERRMSG( ferr_invalid_command, status, 
     .		     cmnd_buff(:len_cmnd)//' : vs what ?', *5000 )
 5110	dep_ax = LEFINT( ndim, slen )
	CALL ERRMSG( ferr_dim_underspec, status, 
     .			'specified data is not a line'//pCR//
     .			' - its a '//dep_ax(:slen)//'D region: "'//
     .			cmnd_buff(:len_cmnd)//'"', *5000 )
 5120	CALL ERRMSG( ferr_dim_underspec, status, 
     .			'overlay is on a different axis'//pCR//
     .			'"'//cmnd_buff(:len_cmnd)//'"', *5000 )
 5130	buff1 = LEFINT( npts, slen  )
	buff2 = LEFINT( npts2, slen2 )
	buff3 = LEFINT( ipl, slen3 )
	CALL ERRMSG( ferr_dim_underspec, status,
     .		 'unequal line lengths: '//pCR//
     .		'First expression has '//buff1(:slen)//' points.'//pCR//
     .		'Expression '//buff3(:slen3)//' has '//buff2(:slen2)//
     .						' points:'//
     .		pCR//'"'//cmnd_buff(:len_cmnd)//'"', *5000 )

 5140	buff3 = LEFINT( ipl, slen3 )
	CALL ERRMSG( ferr_dim_underspec, status,
     .		'differing axes: '//pCR//
     .		'first line is on '//ww_dim_name(indep_dim)//' axis'//pCR//
     .		'line '//buff3(:slen3)//' is on '//ww_dim_name(dep_dim)//
     .		' axis', *5000 )
        
! 5150	buff3 = LEFINT( INT(0.999*pplmem_nsize), slen3 )
!	buff2 = LEFINT( plot_mem_used, slen2 )
!	CALL ERRMSG( ferr_prog_limit, status,
!     .          'Requested '//buff2(:slen2)//' words to plot'//pCR//
!     .		'Plot buffer size is: '//buff3(:slen3), *5000 )

 5160	cal_name = TM_GET_CALENDAR_NAME(cal_id_old)
        cal_name_new = TM_GET_CALENDAR_NAME(cal_id_new)
        slen = TM_LENSTR1 (cal_name)
        slen2 = TM_LENSTR1(cal_name_new)
	CALL ERRMSG( ferr_inconsist_grid, status,
     .          'Differing calendar axes: '//pCR//
     .		'first variable is on '//cal_name(:slen)//
     .          ' axis'//pCR//
     .		'subsequent variable is on '//cal_name_new(:slen2)//
     .		' axis', *5000 )

 5170	buff1 = LEFT_REAL (first, '(G15.3)', slen)
	buff2 = LEFT_REAL (last, '(G15.3)', slen2)
	CALL ERRMSG( ferr_out_of_range, status,
     . 'Limits for log axis negative or too small: '//
     .  buff1(:slen)// ' : '//  buff2(:slen2), *5000 )

 5171	CALL ERRMSG( ferr_out_of_range, status,
     . 'Data all-missing. Cannot define log axis for plotting',
     .  *5000 )


 5180	CALL ERRMSG( ferr_limits, status,
     . 'One-point independent axis: Requires a '//
     .  '/HLIMIT or /VLIMIT specification', *5000 )

 5190	CALL ERRMSG( ferr_syntax, status,
     . 'PLOT/VS/GAPLOC only for a single dependent variable', *5000 )

 5200	CALL ERRMSG( ferr_grid_definition, status,
     .		'Data grid is not a DSG grid ',
     .		*5000 )
	END

*
* pass_thru.F
*
* Jonathan Callahan
* Feb 19th 1998
*
* This function sets the second argument to be equal
* to the first one.
*


*
* In this subroutine we provide information about
* the function.  The user configurable information
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
*
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result
*


      SUBROUTINE pass_thru_init(id)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

      CALL ef_version_test(ef_version)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .        '(demonstration function) sets result equal to input' )
      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, YES, YES, YES, YES, YES, YES)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_desc(id, arg, 'this arg is passed through')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE pass_thru_compute(id, arg_1, result)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable's axes.

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,  j,  k,  l,  m,  n
      INTEGER i1, j1, k1, l1, m1, n1

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      n1 = arg_lo_ss(F_AXIS,ARG1)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

       m1 = arg_lo_ss(E_AXIS,ARG1)
       DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

        l1 = arg_lo_ss(T_AXIS,ARG1)
        DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         k1 = arg_lo_ss(Z_AXIS,ARG1)
         DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

          j1 = arg_lo_ss(Y_AXIS,ARG1)
          DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

           i1 = arg_lo_ss(X_AXIS,ARG1)
           DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

            IF ( arg_1(i1,j1,k1,l1,m1,n1) .EQ. bad_flag(ARG1) ) THEN

               result(i,j,k,l,m,n) = bad_flag_result
*
*              Or you could bail out if there is bad data
*
*              CALL EF_BAIL_OUT(id, 'I refuse to work with bad data.')
*

            ELSE

               result(i,j,k,l,m,n) = arg_1(i1,j1,k1,l1,m1,n1)

            END IF

            i1 = i1 + arg_incr(X_AXIS,ARG1)
 100       CONTINUE

           j1 = j1 + arg_incr(Y_AXIS,ARG1)
 200      CONTINUE

          k1 = k1 + arg_incr(Z_AXIS,ARG1)
 300     CONTINUE

         l1 = l1 + arg_incr(T_AXIS,ARG1)
 400    CONTINUE

        m1 = m1 + arg_incr(E_AXIS,ARG1)
 500   CONTINUE

       n1 = n1 + arg_incr(F_AXIS,ARG1)
 600  CONTINUE

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END

	subroutine inside(x,y,xb,yb,nb,ind) 
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)inside.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
c     given a point x,y and the series xb(k),yb(k) (k=1...nb) defining 
c     vertices of a closed polygon.  ind is set to 1 if the point is in 
c     the polygon and 0 if outside.  each time a new set of bound points 
c     is introduced ind should be set to 999 on input. 
c     it is best to do a series of y for a single fixed x. 
c     method ... a count is made of the no. of times the boundary cuts 
c     the meridian thru (x,y) south of (x,y).   an odd count indicates 
c     the point is inside , even indicates outside. 
c     see a long way from euclid by constance reid  p 174 . 
c     oceanography emr   oct/69 
c 
	dimension xb(2),yb(2),yc(20) 
	if(nb)10,10,20 
10	ind=1 
	return 
20	if(ind-999)30,40,30 
30	if(x-xprev)40,300,40 
c 
40	xprev=x 
	nc=0 
	do 200 k=1,nb 
	kp1=k+1-k*(k/nb) 
	kw=k 
	if(xb(k)-xb(kp1))60,200,50 
50	kw=kp1 
60	ke=k+kp1-kw 
	if(x-xb(ke))80,90,200 
80	if(x-xb(kw))200,200,90 
90	nc=nc+1 
	slope=(yb(ke)-yb(kw))/(xb(ke)-xb(kw)) 
	yc(nc)=yb(kw)+(x-xb(kw))*slope 
200	continue 
c 
300	ind=0 
	if(nc)340,340,310 
310	do 330 k=1,nc 
	if(yc(k)-y)320,330,330 
320	ind=1-ind 
330	continue 
340	return 
	end 

	SUBROUTINE MAKE_DSG_OBS_MASK(dset, cx, ifeature, iobs0,
     .				     use_obs, nobs)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Create an observation-level mask for a single feature of a DSG based upon
* world coordinate limits in the given context

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V720 4/17 *sh*
* V741 6/18 *acm* Handle modulo longitudes
* TODO:  Should return the count of .TRUE. in the mask so the calling routine 
*        could skip applying the mask if count=nobs

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xtm_grid.cmn_text'
	include 'xdset_info.cmn_text'
	include 'xdyn_linemem.cmn_text'
	include 'xcontext.cmn'
	include 'xdsg_context.cmn'
	include 'xprog_state.cmn'
	include 'xvariables.cmn'
#include "tmap_dset.parm"

* calling argument declarations:
	INTEGER dset, cx, ifeature, iobs0, nobs
	LOGICAL use_obs(nobs)

* internal variable declarations:
        INTEGER i, idim, lm, iptr
	REAL    coord, axmod, bad

	axmod = 360.0 

! DSGTBD: presently the same constraints mask gets re-computed many times:
! (may want to rethink since obs mask is now computed separately per feature)
! ... during each IS_DO_OP, during regridding, and for final LIST, PLOT, etc.
! It would be desirable to avoid this. A way to do this would be
!  1. compute a unique hash based upon the XYZTE context constraints
!  2. save the masks that computed here in lm line memory
!  3. use the hash value and dataset number to recover the saved masks
!  4. clean out the stored masks (say?) when the dataset gets closed

* initialize
	DO i = 1, nobs
	   use_obs(i) = .TRUE.
	ENDDO

* mask at the individual obs level based upon obs cordinates
	DO idim = 1, 4
	   IF (.NOT.cxdsg_constrain (idim))    CYCLE
	   IF (.NOT.cxdsg_has_coord(idim))     CYCLE
	   IF (.NOT.cxdsg_is_obs_coord(idim) ) CYCLE
	   
	   bad = cxdsg_bad_val(idim)
	   lm = cxdsg_coord_lm(idim)
	   DO i = 1, nobs
	      iptr = iobs0+i
	      coord = dsg_linemem(lm)%ptr(iptr)
	      IF (coord .EQ. bad) CYCLE

	      IF (idim .EQ. x_dim) CALL MODSCAT  (
     .		       cxdsg_constrain_lo(idim), 
     .		       cxdsg_constrain_hi(idim), axmod, 1, coord)

	      use_obs(i) = use_obs(i)
     .		.AND. coord .LE. cxdsg_constrain_hi(idim) 
     .		.AND. coord .GE. cxdsg_constrain_lo(idim)
	   ENDDO
	ENDDO

	RETURN
	END

	SUBROUTINE CREATE_PERMUTATION( cx, msrc, perm, mdst, do_shrink,
     .				       status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* create a memory-resident variable from input data, msrc, using region limits
* from context cx permuted into the order specified by array perm
* To optimize speed pre-test to see if the input data is already suitably
* organized
* -- flag the result as temporary

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  9/1/89
* V312: 5/94 - array "memory" as a calling argument
* V530:  8/00 *sh* - partial implementation of permuting string arrays
*		("table only")
*v580  *acm* 11/04 transfer cx_cal_id, the calendar ID used when  
*                  computing world coordinates
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V702 1/17 *sh* for trac enhancement #2369 -- dynamic memory management 

* ... Ticket 1480: When writing to netCDF, check whether the region 
*     on modulo axes is just one grid-cell longer than the axis length,
*     e.g. if they give a region of /X=0:360.  If so, write one grid-cell 
*     less data.so the axis can still be a valid modulo axis.

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'

* calling argument declarations:
	LOGICAL do_shrink
	INTEGER	cx, msrc, perm(nferdims), mdst, status

* internal variable declarations:
	LOGICAL	table_entry_only
	INTEGER nsrc, ndst, idim, dim, prm, 
     .		src_len(nferdims), dst_len(nferdims),
     .          src_ax(nferdims),  dst_ax(nferdims)

* initialize
	table_entry_only = .FALSE.

* test if any action is necessary
* ... it is unnecessary if all dimensions with length greater than 1 are
* the same length and in the same order in the source data as in the requested
* permutation, or if there is more than one dimension in the grid and a dimension
* is shrunk.
* (Note: msrc regions always span cx regions)
* Compute src_len and dst_len - the non-unity axis lengths in the source and
* destination data
	nsrc = 0
	DO 200 idim = 1, nferdims
	   dim = mr_hi_ss(msrc,idim) - mr_lo_ss(msrc,idim)
	   IF ( dim .GT. 0 ) THEN
	      nsrc = nsrc + 1
	      src_ax (nsrc) = idim
	      src_len(nsrc) = dim
	   ENDIF
 200	CONTINUE
	ndst = 0
	DO 210 idim = 1, nferdims
	   prm = perm(idim)
	   dim = cx_hi_ss(cx,prm) - cx_lo_ss(cx,prm)
	   IF ( dim .GT. 0 ) THEN
	      ndst = ndst + 1
	      dst_ax (ndst) = prm
	      dst_len(ndst) = dim
	   ENDIF
 210	CONTINUE

* must "extract" data if the source data is a larger object than the request
* must permute if the axis ordering is different
	IF ( nsrc .NE. ndst ) GOTO 500
	DO 250 idim = 1, nsrc
	   IF ( dst_len(idim) .NE. src_len(idim)
     .	  .OR.  dst_ax (idim) .NE. src_ax (idim) ) GOTO 500
 250	CONTINUE

* no actual permutation of values is necessary
* see if a dummy mr table entry is needed to represent the permutation
	DO 300 idim = 1, nferdims
	   IF ( perm(idim) .NE. idim ) THEN
	      table_entry_only = .TRUE.
	      GOTO 500
	   ENDIF
 300	CONTINUE

	IF (do_shrink) GOTO 500

* dimensions have not been permuted nor are context region sizes < stored data
	status = ferr_ok
	mdst = msrc
	RETURN

* need a dummy entry

* create a permuted context
 500	CONTINUE
	
	DO 510 idim = 1,nferdims
	   prm = perm(idim)
	   cx_lo_ss ( cx_buff, idim )   = cx_lo_ss ( cx, prm )
	   cx_hi_ss ( cx_buff, idim )   = cx_hi_ss ( cx, prm )
	   cx_lo_ww ( idim, cx_buff )   = cx_lo_ww ( prm, cx )
	   cx_hi_ww ( idim, cx_buff )   = cx_hi_ww ( prm, cx )
	   cx_trans ( idim, cx_buff )   = cx_trans ( prm, cx )
	   cx_by_ss ( idim, cx_buff )   = cx_by_ss ( prm, cx )
	   cx_given ( idim, cx_buff )   = cx_given ( prm, cx )
	   cx_delta ( idim, cx_buff )   = cx_delta ( prm, cx )
	   cx_trans_arg(idim, cx_buff)  = cx_trans_arg(prm, cx)
	   cx_regrid_trans(idim,cx_buff)=cx_regrid_trans(prm,cx)
 510	CONTINUE

	cx_data_set( cx_buff ) = cx_data_set( cx )
	cx_dset_gvn( cx_buff ) = cx_dset_gvn( cx )
	cx_category( cx_buff ) = cx_category( cx )
	cx_variable( cx_buff ) = cx_variable( cx )
	cx_grid    ( cx_buff ) = cx_grid    ( cx )
	cx_type    ( cx_buff ) = cx_type    ( cx )
	cx_ovsiz   ( cx_buff ) = cx_ovsiz   ( cx )
	cx_bad_data( cx_buff ) = cx_bad_data( cx )
        cx_cal_id  ( cx_buff ) = cx_cal_id  ( cx )

	cx_unstand_grid( cx_buff ) = cx_unstand_grid( cx )

* create a memory space for the result
	CALL CREATE_TEMP_MEM_VAR( cx_buff, mdst, status )
	IF ( status .NE. ferr_ok ) RETURN

* permute or kludge around permuting the data
	IF ( table_entry_only .AND. .NOT.do_shrink) THEN
* ... point to the original data using permuted limits
* ... a duplicated pointer, only 
*     mr_size of the table-entry-only mr will be zero
*     total_mem need not be adjusted cuz no actual new memory is involved
	   essential_mem = essential_mem - mr_size(mdst)
	   CALL FREE_MR_DYNMEM( mdst )
	   memry(mdst)%ptr => memry(msrc)%ptr

	   mr_c_pointer(mdst) = mr_c_pointer(msrc)
	   mr_protected(mdst) = mr_table_entry_only
	ELSE
* ... permute the data
	   CALL PERMUTE( cx, memry(msrc)%ptr, msrc,
     .			     memry(mdst)%ptr, mdst, perm )
	ENDIF

	RETURN
	END

	SUBROUTINE RESET_DSG (nvars, cx_list)

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Clean up after a DSG plot; extra lines and grids were alloocated.
* Reset cx_feature, the number of variables plotted, cx_grid
* If a mask variable was used the number of variables and variable-
* memory pointer needs restoring
* V760 *acm* 3/20 Flag for case when constraints result in no features
*                 Store plot state for axlab position.


	include	'tmap_dims.parm'
	include 'ferret.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xtm_grid.cmn_text'
	include 'xprog_state.cmn'
	include 'xdsg_context.cmn'

	INTEGER nvars, cx_list(*)

	LOGICAL its_dsg
	INTEGER TM_DSG_DSET_FROM_GRID, cx, grid, dset, i, 
     .		the_cx, iaxis, orientation, obsdimlen, fline, nv
	CHARACTER buff*32, TM_FMT*48, fmt*6

* Get the DSG dataset, grid, and the orientation of the feature
* so we can get the axes that were allocated.

	cx = is_cx(1)
	grid = cx_grid(cx)
	dset = TM_DSG_DSET_FROM_GRID( grid )

	nv = nvars
	
	its_dsg = .TRUE.
	CALL TM_DSG_FACTS( grid, orientation, obsdimlen, fline, its_dsg )

	IF (nv .GT. 1) THEN

* Was this a single-feature, multi-variable plot?  If so we defined one
* temporary grid.
	   IF (cx_variable(cx) .NE. cx_variable(cx+1) ) THEN 
	       nv = 1
	   ELSE

* Restore number of variables - num_uvars_in_cmnd is reset for multi-
* feature plot or for mask-variable.
	      nvars = 1

	   ENDIF
	ENDIF

* Deallocate the temporary grid and axis used.  Reset cx_feature.
	
	the_cx = cx - 1
	DO i = 1, nv
	   the_cx = the_cx + 1
	   grid = cx_grid(the_cx)
	   iaxis = grid_line(orientation, grid)

	   CALL TM_deallo_dyn_grid( grid )
	   CALL FREE_LINE_DYNMEM ( iaxis )

           cx_feature(cx_list(i)) = pdsg_not_dsg  ! zero
	ENDDO

	grid_is_dsg = .FALSE.
	cx_grid(cx) = cx_grid(cx_buff)

* Flag for dsg context that resulted in no data.
* Restore plot state for axlab position to previous setting.

	IF (cxdsg_empty_set) THEN
	   CALL PPLCMD ( ' ', ' ', 0, 'YAXIS', 1, 1 )
	   CALL PPLCMD ( ' ', ' ', 0, 'AXLABP,'//cxdsg_axlabp_save, 1, 1) 
	ENDIF

	cxdsg_empty_set = .FALSE.

	RETURN
	END

	SUBROUTINE ALIAS_COMMAND( buffer, clen, * )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* check to see if an alias was used to abbreviate the command and replace with
* the full string if so

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V200:  2/8/90
* V230:  1/27/92 - added QUIT, DATA, and REGION
*           2/92 - improved logic to permit aliases of less than 4 chars
*         6/8/92 - upper bound of aliases changed to reflext DEFINE ALIAS
*        6/19/92 - alias names 8 characters
*        7/29/92 - uses ALIAS_ID
* V300: take abnormal return if alias substitution occurs
* V313: *sh* AIX port.  logic for replacing buffer doesn't work
* v4.5: 8/97 *kob* AIX bug fix - added check for cpos to locate tabs in
*                           command line
*     :10/97 *kob* Check to see if alen = clen. if so set buffer to the 
*                  alias.  new version of DEC fortran caught the error in
*                  the string concatenation.
* 2/03 *kob* - g77 port - g77 won't allow intrinsic functions in PARAMETER
*                         statements.  use an octal constant instead
* *sh* 11/2013 - allow an "=" as the end of an alias, soo "vtree=all" becomes legal
 
        IMPLICIT NONE
* calling argument declarations:
	INTEGER	  clen
	CHARACTER buffer*(*)

* internal variable declarations:
	INTEGER	TM_LENSTR1, ALIAS_ID, 
     .          alen, true_len, i, spos, bpos, cpos, epos

        CHARACTER*1     tab
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
#else
	PARAMETER     ( tab = CHAR(9))
#endif

	include 'ferret.parm'
	include 'xcommand.cmn'

#ifdef AIX_XLF
	include 'xrisc.cmn'
#endif

* what is the alias command name length - terminated by "/" or " " (or tab or "=")
        alen = 8
        spos = INDEX(buffer(:alen),'/')
        bpos = INDEX(buffer(:alen),' ') 
* 8/97 check for tab - it can be end of alias
	cpos = INDEX(buffer(:alen),tab)
	IF ( cpos .EQ. 0 ) cpos = clen + 1
	IF ( bpos .EQ. 0 ) bpos = clen + 1
	bpos = MIN( cpos, bpos )
* 11/13 similar check for "="
	epos = INDEX(buffer(:alen),'=')
	IF ( epos .EQ. 0 ) epos = clen + 1
	bpos = MIN( epos, bpos )
        IF ( spos .NE. 0 ) alen = spos - 1
        alen = MIN( alen, bpos - 1 )
        
* identify the alias
        i = ALIAS_ID( buffer(:alen) ) 

* substitute alias text if appropriate
        IF ( i .NE. unspecified_int4 ) THEN
	   true_len = TM_LENSTR1( alias(i) )
* 10/97 *kob* added check to see if passed in length is same as alias lenght
	   IF (alen .EQ. clen) THEN
	      buffer = alias(i)
	   ELSE
#ifdef AIX_XLF
	      risc_buff = buffer(alen+1:clen)
	      buffer = alias(i)(:true_len)//risc_buff(:clen-alen)
#else
	      buffer = alias(i)(:true_len)//buffer(alen+1:clen)
#endif
	   ENDIF
	   clen = clen + ( true_len - alen )	   
	   RETURN 1    ! abnormal return if substitution
	ENDIF

* no substitution
	RETURN
	END

	SUBROUTINE SET_ANNOTATION (user, nouser, norm, xloc, yloc,
     .        halign, angle, size, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Parse qualifiers for ANNOTATE and DEFINE ANNOTATION command, converting
* locations to the correct ones for /USER, /NOUSER, or /NORMalized specification.
*
* 3/26/2020 *acm* Once the qualifiers have been parsed, put the step creating
*     the ppl command in a separate subroutine setup_annotation, that can be 
*     called internally to conveniently add a label. For example see calls
*     in dsg_label_nofeatures to SETUP_ANNOTATION and PUT_ANNOTATION.

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'slash.parm'
	include 'xplot_state.cmn'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
	include 'plot_setup.parm'
	include 'xplot_setup.cmn'

	LOGICAL user, norm, nouser
	INTEGER	status
	REAL	xloc, yloc, halign, angle, size

* local variable declarations:

	INTEGER	TM_LENSTR1,
     .		loc, rlen, item, itype, nchar, ierr
	REAL	val, xpos, ypos, valign, deg_to_rad, cos_ang, sin_ang, 
     .		a_dx, a_dy, hloc, xaxlen, yaxlen, rev, xrev, yrev, 
     .		xaxmin, xaxmax, yaxmin, yaxmax, xscale, yscale

	CHARACTER buff*20, symbuff*30

* plotting must already be turned on

	IF ( .NOT.pplus_started ) GOTO 5100

* initialize (size initialized in the calling routine)

	xpos = 0.
	ypos = 0.
	valign = -1.
	halign = -1.
	angle = 0.
	status = ferr_ok

* Get settings

* /USER /NOUSER or /NORM. Default is /USER
	user   = qual_given( slash_annotate_user )  .GT. 0
	nouser = qual_given( slash_annotate_nouser) .GT. 0
	norm   = qual_given( slash_annotate_norm  ) .GT. 0

	itype = 0
	IF (user) itype = itype+1
	IF (nouser) itype = itype+1
	IF (norm) itype = itype+1
	IF (itype .EQ. 0) user = .TRUE.
	IF (itype .GT. 1) GOTO 5200

* ... ANNOTATE/HALIGN=float
	loc = qual_given( slash_annotate_halign )
	IF ( loc .GT. 0  ) THEN
	   CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      val, status )
	   buff = 'HALIGN'
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   IF ( val .NE. unspecified_val4 ) halign = val
	ENDIF

* valign and halign will modify the location settings if /NORM
* ... ANNOTATE/VALIGN=float

	loc = qual_given( slash_annotate_valign )
	IF ( loc .GT. 0  ) THEN
	   CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      val, status )
	   buff = 'VALIGN'
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   IF ( val .NE. unspecified_val4 ) valign = val
	ENDIF

* ... ANNOTATE/XPOS=float
	
	loc = qual_given( slash_annotate_xpos )
	IF ( loc .GT. 0  ) THEN
	   CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      val, status )
	   buff = 'XPOS'
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   IF ( val .NE. unspecified_val4 ) xpos = val
	ELSE
	   GOTO 5300
	ENDIF

* ... ANNOTATE/YPOS=float
	loc = qual_given( slash_annotate_ypos )
	IF ( loc .GT. 0  ) THEN
	   CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      val, status )
	   buff = 'YPOS'
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   IF ( val .NE. unspecified_val4 ) ypos = val
	ELSE
	   GOTO 5300
	ENDIF

* ... ANNOTATE/ANGLE=float

	angle = 0.
	loc = qual_given( slash_annotate_angle )
	IF ( loc .GT. 0  ) THEN
	   CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      val, status )
	   buff = 'ANGLE'
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   IF ( val .NE. unspecified_val4 ) angle = val
	ENDIF

* ... ANNOTATE/SIZE=float
	loc = qual_given( slash_annotate_size )
	IF ( loc .GT. 0  ) THEN
	   CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      val, status )
	   buff = 'SIZE'
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   IF ( val .NE. unspecified_val4 ) size = val
	ENDIF

	xloc = xpos
	yloc = ypos
	CALL SETUP_ANNOTATION ( user, nouser, norm, xloc, yloc,
     .        halign, valign, angle, size, status)

 5000	RETURN
	
 5100   CALL ERRMSG (ferr_invalid_command, status, 
     .          'ANNOTATE: Plotting has not been started', *5000)
     
 5200   CALL ERRMSG( ferr_invalid_command, status,
     .          'Specify only one of /USER /NOUSER /NORM', *5000 )

 5300   CALL ERRMSG( ferr_invalid_command, status,
     .          '/XPOS and /YPOS are required for ANNOTATE', *5000 )

	END

*
* samplexy_nrst.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without anx fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and anx derivative works thereof, and
*  its supporting documentation for anx purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in anx publications that result from
*  the use of this software or in anx product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in anx advertising or publicity to endorse or promote anx products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with anx support, consulting,
*  training or assistance of anx kind with regard to the use, operation
*  and performance of this software nor to provide the user with anx
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND Anx EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR Anx SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR Anx DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
*
*   Version of samplexy to get data at the nearest grid point rather
*   than doing interpolation.
*
* This function samples 4-d data on the x and y axes indicated by args 2 and 3
* 9/10/99  Ansley Manke 
*         Result is abstract on the x axis, normal on the y axis,
*         and keeps the z and t axes of the input 4-d data.
*
* 1/13/2000 acm -- fix so that xpts and/or ypts can be on any axis.
* 3/ 1/2000 ACM -- fix bug in the definition of the work arrays
* 6/ 8/2000 ACM -- fix bug in incrementing k2, k3, l2, l3
*
* 7/2000  acm -- merge Bernadettes and increment fix into this version
* 5/2001  acm -- allow modulo axes
* 10/2001 acm -- check that jtop (box top) is within range of ARG1 y axis.
* 10/2001 acm -- check that jtop (box top) is within range of ARG1 y axis.
*  2/2001 acm -- check that modulo axes are also regular, and fix delmodx, delmody
*  2/2002 acm -- check xpt and ypt (x and y points to sample) that values arent missing.
*

* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE samplexy_nrst_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CHARACTER*100 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns data sampled at a set of (X,Y) points, ',
     .        'using nearest grid intersection')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                ABSTRACT, NORMAL,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 6)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'DAT_TO_SAMPLE')
      CALL ef_set_arg_desc(id, arg, 'variable (x,y,z,t,e,f) to sample')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'XPTS')
      CALL ef_set_arg_desc(id, arg, 'X values of sample points')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'YPTS')
      CALL ef_set_arg_desc(id, arg, 'Y values of sample points')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* loss               lo subscript for an axis
*
* hiss               hi subscript for an axis
*

      SUBROUTINE samplexy_nrst_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER my_lo, my_hi
      INTEGER nx, ny, nz, nt, ne, nf

*     Use utility functions to get context information about the 
*     2nd argument, to set the abstract axis lo and hi indices.

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nx = arg_hi_ss(X_AXIS, ARG2) - arg_lo_ss(X_AXIS, ARG2) + 1
      ny = arg_hi_ss(Y_AXIS, ARG2) - arg_lo_ss(Y_AXIS, ARG2) + 1
      nz = arg_hi_ss(Z_AXIS, ARG2) - arg_lo_ss(Z_AXIS, ARG2) + 1
      nt = arg_hi_ss(T_AXIS, ARG2) - arg_lo_ss(T_AXIS, ARG2) + 1
      ne = arg_hi_ss(E_AXIS, ARG2) - arg_lo_ss(E_AXIS, ARG2) + 1
      nf = arg_hi_ss(F_AXIS, ARG2) - arg_lo_ss(F_AXIS, ARG2) + 1

      my_lo = 1
      my_hi = max(nx,ny,nz,nt,ne,nf)

      CALL ef_set_axis_limits(id, X_AXIS, my_lo, my_hi)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END
*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE samplexy_nrst_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*
      INTEGER mxh, myh, mxl, myl
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

*  Allocate the length of the axes for REAL*8 work arrays. Use the argument
*  subscript limits, so subsets are handled correctly.

*  xaxdat
      CALL ef_set_work_array_dims_6d(id, 1,
     .                              arg_lo_ss(X_AXIS,ARG1), 1, 1, 1, 1, 1,
     .                              arg_hi_ss(X_AXIS,ARG1), 1, 1, 1, 1, 1)

*  yaxdat
      CALL ef_set_work_array_dims_6d(id, 2,
     .                              arg_lo_ss(Y_AXIS,ARG1), 1, 1, 1, 1, 1,
     .                              arg_hi_ss(Y_AXIS,ARG1), 1, 1, 1, 1, 1)

*  xboxlo
      CALL ef_set_work_array_dims_6d(id, 3,
     .                              arg_lo_ss(X_AXIS,ARG1), 1, 1, 1, 1, 1,
     .                              arg_hi_ss(X_AXIS,ARG1), 1, 1, 1, 1, 1)

*  xboxhi
      CALL ef_set_work_array_dims_6d(id, 4,
     .                              arg_lo_ss(X_AXIS,ARG1), 1, 1, 1, 1, 1,
     .                              arg_hi_ss(X_AXIS,ARG1), 1, 1, 1, 1, 1)

*  yboxlo
      CALL ef_set_work_array_dims_6d(id, 5,
     .                              arg_lo_ss(Y_AXIS,ARG1), 1, 1, 1, 1, 1,
     .                              arg_hi_ss(Y_AXIS,ARG1), 1, 1, 1, 1, 1)

*  yboxhi
      CALL ef_set_work_array_dims_6d(id, 6,
     .                              arg_lo_ss(Y_AXIS,ARG1), 1, 1, 1, 1, 1,
     .                              arg_hi_ss(Y_AXIS,ARG1), 1, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END
*
* In this subroutine we compute the result
*
      SUBROUTINE samplexy_nrst_compute(id, arg_1, arg_2, arg_3,
     .        result, xaxdat, yaxdat, xboxlo, xboxhi, yboxlo, yboxhi)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

      REAL*8 xaxdat(wrk1lox:wrk1hix,wrk1loy:wrk1hiy,
     .              wrk1loz:wrk1hiz, wrk1lot:wrk1hit,
     .              wrk1loe:wrk1hie, wrk1lof:wrk1hif)
      REAL*8 yaxdat(wrk2lox:wrk2hix,wrk2loy:wrk2hiy,
     .              wrk2loz:wrk2hiz, wrk2lot:wrk2hit,
     .              wrk2loe:wrk2hie, wrk2lof:wrk2hif)
      REAL*8 xboxlo(wrk3lox:wrk3hix,wrk3loy:wrk3hiy,
     .              wrk3loz:wrk3hiz, wrk3lot:wrk3hit,
     .              wrk3loe:wrk3hie, wrk3lof:wrk3hif)
      REAL*8 xboxhi(wrk4lox:wrk4hix,wrk4loy:wrk4hiy,
     .              wrk4loz:wrk4hiz, wrk4lot:wrk4hit,
     .              wrk4loe:wrk4hie, wrk4lof:wrk4hif)
      REAL*8 yboxlo(wrk5lox:wrk5hix,wrk5loy:wrk5hiy,
     .              wrk5loz:wrk5hiz, wrk5lot:wrk5hit,
     .              wrk5loe:wrk5hie, wrk5lof:wrk5hif)
      REAL*8 yboxhi(wrk6lox:wrk6hix,wrk6loy:wrk6hiy,
     .              wrk6loz:wrk6hiz, wrk6lot:wrk6hit,
     .              wrk6loe:wrk6hie, wrk6lof:wrk6hif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      LOGICAL TM_FPEQ, full_span, ok
      INTEGER STR_UPCASE

      INTEGER nx, nxx, nxy, nxz, nxt, nxe, nxf
      INTEGER ny, nyx, nyy, nyz, nyt, nye, nyf
      INTEGER ndimx, ndimy
      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2
      INTEGER i3, j3, k3, l3, m3, n3
      INTEGER ic, imatch, jmatch
      INTEGER ibot, jbot, itop, jtop, ihi, ilo, jhi, jlo, xflag
      REAL xbot, xtop, ybot, ytop
      REAL x_to_xbot, x_to_xtop, y_to_ybot, y_to_ytop
      REAL dx, dxlo, dxhi, dy, dylo, dyhi, delmodx, xpt, ypt
      CHARACTER err_msg*255, test_str*16

C  variables for checking axis characteristics (modulo axes)

      CHARACTER ax_name(6)*16, ax_units(6)*16
      LOGICAL backward(6), modulo(6), regular(6)
      INTEGER xlo, xhi, ylo, yhi

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      nxx = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1
      nxy = arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) + 1
      nxz = arg_hi_ss(Z_AXIS,ARG2) - arg_lo_ss(Z_AXIS,ARG2) + 1
      nxt = arg_hi_ss(T_AXIS,ARG2) - arg_lo_ss(T_AXIS,ARG2) + 1
      nxe = arg_hi_ss(E_AXIS,ARG2) - arg_lo_ss(E_AXIS,ARG2) + 1
      nxf = arg_hi_ss(F_AXIS,ARG2) - arg_lo_ss(F_AXIS,ARG2) + 1
      nx = max(nxx, nxy, nxz, nxt, nxe, nxf)

      nyx = arg_hi_ss(X_AXIS,ARG3) - arg_lo_ss(X_AXIS,ARG3) + 1
      nyy = arg_hi_ss(Y_AXIS,ARG3) - arg_lo_ss(Y_AXIS,ARG3) + 1
      nyz = arg_hi_ss(Z_AXIS,ARG3) - arg_lo_ss(Z_AXIS,ARG3) + 1
      nyt = arg_hi_ss(T_AXIS,ARG3) - arg_lo_ss(T_AXIS,ARG3) + 1
      nye = arg_hi_ss(E_AXIS,ARG3) - arg_lo_ss(E_AXIS,ARG3) + 1
      nyf = arg_hi_ss(F_AXIS,ARG3) - arg_lo_ss(F_AXIS,ARG3) + 1
      ny = max(nyx, nyy, nyz, nyt, nye, nyf)

      ndimx = 0
      ndimy = 0
      DO 10 i = X_AXIS,F_AXIS
         IF ( arg_hi_ss(i,ARG2) .GT. arg_lo_ss(i,ARG2) )
     .      ndimx = ndimx + 1
         IF ( arg_hi_ss(i,ARG3) .GT. arg_lo_ss(i,ARG3) ) 
     .      ndimy = ndimy + 1
   10 CONTINUE

      IF ( (nx .NE. ny) .OR. (ndimx .GT. 1) .OR. (ndimy .GT. 1) ) THEN
         err_msg =
     .  'Arguments 2 and 3 must be 1-dimensional lists of equal length'
         GO TO 999
      ENDIF

*  Get x and y coordinates of the data to be sampled.

      ilo = arg_lo_ss(X_AXIS,ARG1)
      ihi = arg_hi_ss(X_AXIS,ARG1)
      jlo = arg_lo_ss(Y_AXIS,ARG1)
      jhi = arg_hi_ss(Y_AXIS,ARG1)

      CALL ef_get_coordinates(id, ARG1, X_AXIS, ilo, ihi, xaxdat)
      CALL ef_get_coordinates(id, ARG1, Y_AXIS, jlo, jhi, yaxdat)

*  Check to see if input x axis is modulo, and if axes are regular.

      CALL ef_get_axis_info_6d(id, ARG1, ax_name, ax_units,
     .                         backward, modulo, regular)
      IF ( regular(1) ) THEN
         dx = xaxdat(ilo+1,1,1,1,1,1) - xaxdat(ilo,1,1,1,1,1)
         dxlo = dx/2.
         dxhi = dx/2.
      ELSE
         CALL ef_get_box_limits(id, ARG1, X_AXIS, ilo, ihi,
     .                          xboxlo, xboxhi)
         dxlo = (xboxlo(ilo+1,1,1,1,1,1) - xboxlo(ilo,1,1,1,1,1) ) / 2.
         dxhi = (xboxhi(ihi,1,1,1,1,1) - xboxhi(ihi-1,1,1,1,1,1) ) / 2.
      ENDIF

      IF ( regular(2) ) THEN
         dy = yaxdat(jlo+1,1,1,1,1,1) - yaxdat(jlo,1,1,1,1,1)
         dylo = dy/2.
         dyhi = dy/2.
      ELSE
         CALL ef_get_box_limits(id, ARG1, Y_AXIS, jlo, jhi,
     .                          yboxlo, yboxhi)
         dylo = (yboxlo(jlo+1,1,1,1,1,1) - yboxlo(jlo,1,1,1,1,1) )/ 2.
         dyhi = (yboxhi(jhi,1,1,1,1,1) - yboxlo(jhi-1,1,1,1,1,1) )/ 2.
      ENDIF

* Check to see if input x,y axis is modulo. If its a longitude 
* axis, check for full-span

      IF ( modulo(1) ) THEN
         ic = STR_UPCASE (test_str, ax_units(1))
         ok = (test_str(1:3) .EQ. 'DEG') 
         dx = xaxdat(ilo+1,1,1,1,1,1) - xaxdat(ilo,1,1,1,1,1)
         delmodx = (xaxdat(ihi,1,1,1,1,1) + dxhi) -
     .             (xaxdat(ilo,1,1,1,1,1) - dxlo)
         IF ( .NOT. regular(1) )
     .      delmodx = xboxhi(ihi,1,1,1,1,1) - xboxlo(ilo,1,1,1,1,1)
         IF ( ok ) THEN 
            full_span = (delmodx .GT. 360.-dx)
            delmodx = 360.
         ELSE
            full_span = .TRUE.
         ENDIF
      ENDIF

*  For each (xpt,ypt) pair, search the data array 
*   arg_1 for the nearest higher (x,y) grid coordinates.  Find the 
*   nearest in 2 directions for the result.


      i2 = arg_lo_ss(X_AXIS,ARG2)
      j2 = arg_lo_ss(Y_AXIS,ARG2)
      k2 = arg_lo_ss(Z_AXIS,ARG2)
      l2 = arg_lo_ss(T_AXIS,ARG2)
      m2 = arg_lo_ss(E_AXIS,ARG2)
      n2 = arg_lo_ss(F_AXIS,ARG2)

      i3 = arg_lo_ss(X_AXIS,ARG3)
      j3 = arg_lo_ss(Y_AXIS,ARG3)
      k3 = arg_lo_ss(Z_AXIS,ARG3)
      l3 = arg_lo_ss(T_AXIS,ARG3)
      m3 = arg_lo_ss(E_AXIS,ARG3)
      n3 = arg_lo_ss(F_AXIS,ARG3)

* Y-axis is normal to the result
      j = res_lo_ss(Y_AXIS)

      DO 700 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         xpt = arg_2(i2,j2,k2,l2,m2,n2)
         ypt = arg_3(i3,j3,k3,l3,m3,n3)
         IF (xpt .EQ. bad_flag(ARG2) .OR. ypt .EQ. bad_flag(ARG3)) THEN
            DO 80 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
            DO 80 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
            DO 80 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
            DO 80 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
               result(i,j,k,l,m,n) = bad_flag_result
   80       CONTINUE
*           Go to the next pair of coordinates
            GOTO 690
         ENDIF

* Flag for outside of a modulo axis
         xflag = 0

* Check if xpt is in the x-axis range.
         ibot = ef_unspecified_int4
         itop = ef_unspecified_int4
         imatch = ef_unspecified_int4
*  Locate the X point within the range of modulo X axis 
*  If we have the whole span, then use the point at the other
*  end to handle points within a half-grid cell of the edge.

         IF ( modulo(1) .AND. full_span ) THEN
            IF ( xpt .GE. xaxdat(ihi,1,1,1,1,1) .AND.
     .           xpt .LE. xaxdat(ihi,1,1,1,1,1) + dxhi ) THEN
               ibot = ihi
               xflag = 1
            ELSE IF ( xpt .GE. xaxdat(ihi,1,1,1,1,1) ) THEN
               DO WHILE ( xpt .GE. xaxdat(ihi,1,1,1,1,1) ) 
                  xpt = xpt - delmodx
               ENDDO
            ENDIF

            IF ( xpt .LT. xaxdat(ilo,1,1,1,1,1) .AND.
     .           xpt .GE. xaxdat(ilo,1,1,1,1,1) - dxlo ) THEN
               itop = ilo
               xflag = -1
            ELSE IF ( xpt .LT. xaxdat(ilo,1,1,1,1,1) ) THEN
               DO WHILE (xpt .LT. xaxdat(ilo,1,1,1,1,1) )
                  xpt = xpt + delmodx
               ENDDO
            ENDIF
	 ENDIF

* Source variable has subspan-modulo axis 

         IF ( modulo(1) .AND. .NOT.full_span ) THEN
            IF (modulo(1) .AND. xpt .GE. xaxdat(ihi,1,1,1,1,1) ) THEN
               DO WHILE ( xpt .GE. xaxdat(ihi,1,1,1,1,1) ) 
               xpt = xpt - delmodx
               ENDDO
            ENDIF

	    IF (modulo(1) .AND. xpt .LT. xaxdat(ilo,1,1,1,1,1) ) THEN
               DO WHILE (xpt .LT. xaxdat(ilo,1,1,1,1,1) )
                  xpt = xpt + delmodx
               ENDDO
            ENDIF
         ENDIF

         DO 120 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)
            IF ( TM_FPEQ(xpt, xaxdat(i1,1,1,1,1,1)) ) THEN
               imatch = i1
               GOTO 130
            ELSE IF ( i1  .EQ. arg_lo_ss(X_AXIS,ARG1)     .AND.
     .                xpt .LT. xaxdat(i1,1,1,1,1,1)       .AND.
     .                xpt .GT. xaxdat(i1,1,1,1,1,1)-dxhi  .AND.
     .               .NOT. modulo(1) ) THEN
               ibot = i1
            ELSE IF ( xpt .GE. xaxdat(i1,1,1,1,1,1) ) THEN
               ibot = i1
            ENDIF
 120     CONTINUE

         IF ( .NOT. modulo(1) .OR. (modulo(1) .AND..NOT.full_span )) THEN
            IF ( xpt .GT. xaxdat(ihi,1,1,1,1,1) .AND.
     .           xpt .LT. xaxdat(ihi,1,1,1,1,1) + dxhi ) THEN
               ibot = ihi
            ELSE IF ( xpt .GT. xaxdat(ihi,1,1,1,1,1) ) THEN
               ibot = ef_unspecified_int4   ! ARG_2 XPT outside of range 
            ENDIF
         ENDIF

  130    IF ( imatch .NE. ef_unspecified_int4 ) THEN
            ibot = imatch
            itop = imatch
         ELSE IF ( ibot .NE. ef_unspecified_int4 ) THEN
            itop = ibot + 1
            IF ( itop .GT. ihi ) itop = ihi
         ENDIF

* If the data is at the very top or bottom of a full-span modulo x axis, get the
* point from the other end.

         IF ( xflag .EQ. 1 ) THEN
            ibot = ihi
            itop = ilo
         ENDIF
         IF ( xflag .EQ. -1 ) THEN
            itop = ilo
            ibot = ihi
         ENDIF

         IF ( ibot .EQ. ef_unspecified_int4 ) THEN
*           Coordinate outside the grid
            DO 140 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
            DO 140 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
            DO 140 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
            DO 140 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
               result(i,j,k,l,m,n) = bad_flag_result
  140       CONTINUE
*           Go to the next pair of coordinates
            GOTO 690
         ENDIF

	 IF ( imatch .NE. ef_unspecified_int4 ) THEN
cbf         matching the next neighbour is not of interest
            i1 = imatch
         ELSE IF ( ibot .EQ. ef_unspecified_int4 ) THEN
* xpt not in the the X-axis range
            i1 = ef_unspecified_int4
         ELSE
* ibot will be less than arg_hi_ss(X_AXIS,ARG1) because of earlier check
            xbot = xaxdat(ibot,  1,1,1,1,1)
            xtop = xaxdat(ibot+1,1,1,1,1,1)
            x_to_xbot = ABS(xpt - xbot)
            x_to_xtop = ABS(xpt - xtop)
            IF (x_to_xbot .LE. x_to_xtop) THEN
               i1 = ibot
            ELSE
               i1 = ibot+1
            ENDIF
         ENDIF

cbf      analogously in y direction

         jbot = ef_unspecified_int4
         jmatch = ef_unspecified_int4

* Check if ypt exceeds the Y-axis range.
         j1 = arg_hi_ss(Y_AXIS,ARG1)
         IF ( TM_FPEQ(yaxdat(j1,1,1,1,1,1), ypt) ) THEN
            jmatch = j1
            GOTO 220
         ELSE IF ( ypt .GT. yaxdat(j1,1,1,1,1,1) ) THEN
            GOTO 220
         ENDIF

* Find ypt in the Y-axis range.
         DO 210 j1 = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)
            IF ( TM_FPEQ(yaxdat(j1,1,1,1,1,1), ypt) ) THEN
               jmatch = j1
               GOTO 220
            ELSE IF ( ypt .GT. yaxdat(j1,1,1,1,1,1) ) THEN
               jbot = j1
            ENDIF
  210    CONTINUE

  220    IF ( jmatch .NE. ef_unspecified_int4 ) THEN
cbf         matching the next neighbour is not of interest
            j1 = jmatch
         ELSE IF ( jbot .EQ. ef_unspecified_int4 ) THEN
* ypt not in the the Y-axis range
            j1 = ef_unspecified_int4
         ELSE
* jbot will be less than arg_hi_ss(Y_AXIS,ARG1) because of earlier check
            ybot = yaxdat(jbot,  1,1,1,1,1)
            ytop = yaxdat(jbot+1,1,1,1,1,1)
            y_to_ybot = abs(ypt - ybot)
            y_to_ytop = abs(ypt - ytop)
            IF (y_to_ybot .LE. y_to_ytop) THEN
               j1 = jbot
            ELSE
               j1 = jbot+1
            ENDIF
         ENDIF

* Loop through the Z/T/E/F axes, assigning results for this coordinate pair
         n1 = arg_lo_ss(F_AXIS,ARG1)
         DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

         m1 = arg_lo_ss(E_AXIS,ARG1)
         DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

         l1 = arg_lo_ss(T_AXIS,ARG1)
         DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               IF ( i1 .EQ. ef_unspecified_int4  .OR.  
     .              j1 .EQ. ef_unspecified_int4 ) THEN
*                 coordinates specified are outside the grid
                  result(i,j,k,l,m,n) = bad_flag_result
               ELSE IF ( arg_1(i1,j1,k1,l1,m1,n1) 
     .                         .EQ. bad_flag(ARG1) ) THEN
*                 closest grid point has an undefined value
                  result(i,j,k,l,m,n) = bad_flag_result
               ELSE
                  result(i,j,k,l,m,n) = arg_1(i1,j1,k1,l1,m1,n1)
               ENDIF

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
 300        CONTINUE

            l1 = l1 + arg_incr(T_AXIS,ARG1)
 400     CONTINUE

            m1 = m1 + arg_incr(E_AXIS,ARG1)
 500     CONTINUE

            n1 = n1 + arg_incr(F_AXIS,ARG1)
 600     CONTINUE

* Only one of the ARG2 and one of the ARG3 actually increments
 690     i2 = i2 + arg_incr(X_AXIS,ARG2)
         j2 = j2 + arg_incr(Y_AXIS,ARG2)
         k2 = k2 + arg_incr(Z_AXIS,ARG2)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
         m2 = m2 + arg_incr(E_AXIS,ARG2)
         n2 = n2 + arg_incr(F_AXIS,ARG2)

         i3 = i3 + arg_incr(X_AXIS,ARG3)
         j3 = j3 + arg_incr(Y_AXIS,ARG3)
         k3 = k3 + arg_incr(Z_AXIS,ARG3)
         l3 = l3 + arg_incr(T_AXIS,ARG3)
         m3 = m3 + arg_incr(E_AXIS,ARG3)
         n3 = n3 + arg_incr(F_AXIS,ARG3)
 700  CONTINUE

      RETURN

 999  CALL ef_bail_out (id, err_msg)

      END

	CHARACTER*(*) FUNCTION VAR_TITLE ( cx )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* return title for variable

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 6/4/86
* revision 1.0 - 1/6/87 - expression text found between commas for cat_expr_var
* revision 1.1 - 3/4/87 - semi-user vars added, expr disabled
* revision 1.2 - 3/23/87 - added new TMAP library: time axes, file var. names
* revision 2.0 - 5/11/87 - called with mr, only
* revision 2.1 - 3/10/88 - allowed for blank file variable titles,
*			   added cat_named_var
* V200:  6/20/89 - eliminated "named" variables
*		 - added user-defined variable titles
*	  1/3/90 - mr --> cx
*	 1/12/90 - allow unit changes by transforms
* V230:  3/3/92  - replace "D=#" with "D=name" in title
*       11/4/92 - expanded user variable name length
* V420: variable units may be modified by regrid transforms of the variable
* V500: 12/98 *sh* - added cat_const_var ... of the form "{1,3,5}"
* V500 *kob* 3/99- up VAR_CODE to 64 chars
* V530  8/00 *sh8 - added support for cat_string
* V552 *acm* 4/03- up VAR_CODE decl from 64 to 128 chars
* v553 *kob* 9/03- need to add buff, slen for assignment of VAR_TITLE - 
*                  g77 bug would cause crash when trying to prepend chars
*                  onto CHAR function variable 
* v554 *acm* 1/04 - add variable category cat_counter_var
* V600 8/05 *acm* - Add variable type attrib_val for definitions of the form
*                   varname.attname
* V600  4/06 *acm* - additional declarations found by Solaris compiler
* V601 10/06 *acm* fix bug 1442. plot and listing titles should show the 
*                  variable title, or if no title, the variable name.
* V698  3/16 *acm* Removed Philander-Seigel code including diagnostic 
*                  variables, pre-defined axes and grids, cat_calc_var.
* V698 3/16  *sh* added logic for cat_ef_time2d (ACTS_LIKE_FVAR)

        IMPLICIT NONE
        include	'tmap_dims.parm'
	include	'xdset_info.cmn_text'
	external xdset_info_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'xvariables.cmn'
	include	'xcontext.cmn'
	include	'xalgebra.cmn'
        include 'errmsg.parm'

* calling argument declarations
	INTEGER	cx

* internal variable declarations
	LOGICAL 	UNIT_CHG_AX, NC_GET_ATTRIB, ACTS_LIKE_FVAR, got_it
	INTEGER 	TM_LENSTR1, cat, var, idim, tlen, llen, trans,
     .			uvar, item, start, end, slen, dset, varid,
     .                  attlen, attoutflag, status
        REAL            vals
	CHARACTER	AX_TITLE*32, VAR_CODE*128, SANITARY_VAR_CODE*128, 
     .                  TM_FMT*48, REPLACE_DEQ*180,   ! .GT. uvar_text_len
     .                  buff1*32, buff2*10, buff*2048, varname*128

* initialize
	var = cx_variable( cx )
	cat = cx_category( cx )

	IF     ( ACTS_LIKE_FVAR(cat) ) THEN
	   IF ( ds_var_title( var )(1:1) .NE. ' ' ) THEN
	      var_title = ds_var_title( var )
	   ELSE
              dset = cx_data_set(cx)
              IF (dset .NE. pdset_irrelevant .AND. 
     .            dset .NE. unspecified_int4) THEN
! is it in the linked-list for dset. If so get attr info, including original 
                 varname = SANITARY_VAR_CODE( cat, var )
                 CALL CD_GET_VAR_ID (dset, varname, varid, status)
                 got_it = status .EQ. ferr_ok .AND.
     .              NC_GET_ATTRIB (dset, varid, 'long_name',
     .             .TRUE., varname, 2048, attlen, attoutflag,
     .             buff, vals)
                 var_title = buff
                 IF (var_title .EQ. ' ') var_title = varname
              ELSE
                 var_title = VAR_CODE( cat, var )
!	         var_title = '"'//var_title(:TM_LENSTR1(var_title))//'"'
              ENDIF
	   ENDIF

	ELSEIF ( cat .EQ. cat_user_var  ) THEN

	   IF ( uvar_title( var ) .EQ. ' ' ) THEN
	      var_title = REPLACE_DEQ(
     .             uvar_text(var)(:TM_LENSTR1(uvar_text(var)) ))
	   ELSE
	      var_title = uvar_title( var )
	   ENDIF


	ELSEIF ( cat .EQ. cat_attrib_val  ) THEN

	   uvar = cx_variable(cx)
	   var_title = uvar_text(uvar)

	   IF ( uvar_title( uvar ) .EQ. ' ' ) THEN
	      var_title = REPLACE_DEQ(
     .             uvar_text(uvar)(:TM_LENSTR1(uvar_text(uvar)) ))
	   ENDIF

	ELSEIF ( cat .EQ. cat_pseudo_var ) THEN

	   var_title = alg_pvar(var)

	ELSEIF ( cat .EQ. cat_dummy_var ) THEN

	   var_title = 'dummy'

	ELSEIF ( cat .EQ. cat_temp_var ) THEN

	   var_title = 'temp var'

	ELSEIF ( cat .EQ. cat_constant ) THEN

	   var_title = 'constant'

	ELSEIF ( cat .EQ. cat_const_var ) THEN

	   uvar = cx_variable(cx)/1000
           item = cx_variable(cx) - 1000*uvar
           start = uvar_item_start( item, uvar )
           end   = uvar_item_end  ( item, uvar )
	   var_title = uvar_text(uvar)(start:end)

	ELSEIF ( cat .EQ. cat_string ) THEN

* determine the string to be stored
           uvar = cx_variable(cx)/1000
           item = cx_variable(cx) - 1000*uvar
           start = uvar_item_start( item, uvar )
           end   = uvar_item_end  ( item, uvar )
	   var_title = uvar_text(uvar)(start:end)

	ELSEIF ( cat .EQ. cat_counter_var ) THEN

	   var_title = 'counter'

	ELSE

	   var_title = 'bad_cat'

	ENDIF

* some transformations change the title
	IF ( UNIT_CHG_AX(cx,idim, trans) ) THEN
	   IF ( trans .EQ. punit_mod_loc ) THEN
	      buff1 = AX_TITLE( idim, cx_grid(cx), tlen )
	      buff2 = TM_FMT( cx_trans_arg(idim,cx), 4, 10, llen )
	      VAR_TITLE = buff1(:tlen)//' of '//buff2(:llen)//' in '//
     .		          VAR_TITLE
	   ELSEIF ( trans .EQ. punit_mod_variance ) THEN
	      buff = VAR_TITLE
	      slen = TM_LENSTR1(buff)		
	      VAR_TITLE = 'Variance of '//buff(:slen)
	   ELSEIF ( trans .EQ. punit_mod_npoints ) THEN
	      CONTINUE		! units take care of this
	   ENDIF	      
	ENDIF

	RETURN
	END

	SUBROUTINE LON_LAT_FMT (idim, x_or_y)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* V7    *acm* 6/16 Ticket 2434: command qualifiers /DEGMINSEC= /HALFSPAC
*                  DEGMINSEC=1 for Deg-Min axis labels, =2 for Deg-Min-Sec. Default = 1
*                  /HALFSPAC adds a half space between the degree sign and E/W or N/S


* Set up PPLUS with info on longitude formatting with Deg-Min-Sec, and/or 
* adjusting spacing on labels with E,W,N, or S.

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'plot_setup.parm'
	include 'xplot_setup.cmn'
	include 'xplot_state.cmn'

	INTEGER idim
	CHARACTER*(*) x_or_y

	INTEGER slen
	REAL	val
	CHARACTER TM_FMT*48, str*10

* longitude or latitude formatting
	IF ( idim .EQ. x_dim .OR. idim .EQ. y_dim) THEN

	   ppl_buff = x_or_y//'FOR (dd)'
	   IF (dms .NE. 0) THEN
	      IF (dms .EQ. 1) ppl_buff = x_or_y//'FOR (dm)' 
	      IF (dms .EQ. 2) ppl_buff = x_or_y//'FOR (dms)'
	   ENDIF
	   CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )

	   ppl_buff = x_or_y//'FOR (SPC0)'
	   IF (lonlatspace .NE. 0) THEN
	     val = lonlatspace
	     str = TM_FMT(val, 4, 10, slen)
	     ppl_buff = x_or_y//'FOR (SPC'//str(:slen)//')'
	   ENDIF
	   CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
	ENDIF

	RETURN
	END

	SUBROUTINE INIT_CXDSG(dset, cx, nfeatures)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Summarize useful information about the given DSG context in COMMON CXDSG

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V720 5/17 *sh*
* V73+ *acm* 12/17 INIT_CXDSG needs nfeatures as argument
* V741 6/18 *acm* Setting up to handle modulo longitudes

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xtm_grid.cmn_text'
	include 'xdset_info.cmn_text'
	include 'xdyn_linemem.cmn_text'
	include 'xcontext.cmn'
	include 'xdsg_context.cmn'
	include 'xprog_state.cmn'
	include 'xvariables.cmn'
#include "tmap_dset.parm"

* calling argument declarations:
	INTEGER dset, cx, nfeatures

* internal variable declarations:
        INTEGER i, idim, var, inst_grid, lm
	REAL min_ww, max_ww

* initialize
	var = dsg_row_size_var(dset)
	inst_grid = ds_grid_number(var)

* get the E axis limits as integers
	cxdsg_lo_e = cx_lo_ww(e_dim,cx) + .5   ! +.5 cuz ww lims
	cxdsg_hi_e = cx_hi_ww(e_dim,cx)
	cxdsg_constrain_e = cxdsg_lo_e.GT.1 .OR. cxdsg_hi_e.LT.nfeatures

* has the user constrained beyond the default WW limits of the dataset?
	cxdsg_no_coord_constraints = .TRUE.
	DO idim = 1, t_dim
	   
	   CALL DSG_COORD_LIMS(dset, idim, min_ww, max_ww)
	   IF (cx_lo_ww(idim,cx) .EQ. unspecified_val8) THEN
	      cx_lo_ww(idim,cx) = min_ww
	      cx_hi_ww(idim,cx) = max_ww
	   ENDIF
	   cxdsg_constrain(idim) = cx_lo_ww(idim,cx) .NE. min_ww
     .			      .OR. cx_hi_ww(idim,cx) .NE. max_ww
	   IF (cxdsg_constrain(idim)) cxdsg_no_coord_constraints = .FALSE.

* apply constraints, but longitude modulo in constraints handled later
	   var = dsg_coord_var(idim,dset)
	   IF (var.NE.int4_init .AND. idim.EQ.x_dim .AND. cx_lo_ww(idim,cx_cmnd).NE.unspecified_val8) THEN 
	      cxdsg_constrain_lo(idim) = MIN(cx_lo_ww(idim,cx), cx_lo_ww(idim,cx_cmnd) )
	      cxdsg_constrain_hi(idim) = MAX(cx_hi_ww(idim,cx), cx_hi_ww(idim,cx_cmnd) )
	   ELSE
	      cxdsg_constrain_lo(idim) = cx_lo_ww(idim,cx)
	      cxdsg_constrain_hi(idim) = cx_hi_ww(idim,cx)
	   ENDIF

	ENDDO

* which coordinates does this DSG provide?
	DO idim = 1, t_dim
	   var = dsg_coord_var(idim,dset)
	   cxdsg_has_coord(idim) =  var .NE. int4_init
	   IF (cxdsg_has_coord(idim)) THEN
	      cxdsg_bad_val(idim) = ds_bad_flag(var)
	      lm = dsg_loaded_lm(var)
	      cxdsg_coord_lm(idim) = lm
* ... all DSG vars are one of 2 grids: obs or instance
	      cxdsg_is_obs_coord(idim) = ds_grid_number(var) .NE. inst_grid
	   ENDIF
	ENDDO

	RETURN
	END

*
* tauto_cor.F
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* July 1999
*  Update to use abstract axis 1-feb-2000
*  acm 11/2001 bug fix: check both arg_1(...l1+lm) and arg_1(...l1) for bad flag
*
* This function computes the autocorrelation for a x series.  
*  Autocorelation formula computed directly for lags of 0, 1, ..., N-1
*  Return on an abstract T axis.

*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*

      SUBROUTINE tauto_cor_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .        'Compute autocorrelation of series, lags of 0, ..., N-1')
      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, ABSTRACT,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 3)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_desc(id, arg, 'T-series variable')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, NO, YES, YES)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END


*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE tauto_cor_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER lo_ss, hi_ss

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

C  Autocorrelation returns correlations for lags of 0 to N-1.
      lo_ss = 1
      hi_ss = arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1) + 1

      CALL ef_set_axis_limits(id, T_AXIS, lo_ss, hi_ss)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************
      RETURN
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE tauto_cor_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
* 
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER npts, irr

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      npts = 1 + arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1)

* partial means  pmean
      irr = 1
      CALL ef_set_work_array_dims_6d(id, irr,
     .                                1, 1, 1, 1, 1, 1,
     .                             npts, 1, 1, 1, 1, 1)

* partial variances  pvar
      irr = 2
      CALL ef_set_work_array_dims_6d(id, irr,
     .                                1, 1, 1, 1, 1, 1,
     .                             npts, 1, 1, 1, 1, 1)

* box sizes BOX
      irr = 3
      CALL ef_set_work_array_dims_6d(id, irr,
     .                                1, 1, 1, 1, 1, 1,
     .                             npts, 1, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE tauto_cor_compute(id, arg_1, result,
     .                             pmean, pvar, box)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* Ignore the Y/Z/T/E/F dimensions in the work arrays since
* they are not used and Fortran is column major
      REAL pmean(wrk1lox:wrk1hix)
      REAL pvar (wrk2lox:wrk2hix)
      REAL box  (wrk3lox:wrk3hix)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      REAL psum, diff, diff2
      REAL dsum, bsize
      INTEGER lr, lm, ls
      INTEGER nd, arg
      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      arg = 1
      CALL ef_get_box_size(id, arg, T_AXIS, arg_lo_ss(T_AXIS,arg), 
     .                     arg_hi_ss(T_AXIS,arg), box)

      nd = arg_hi_ss(T_AXIS,arg) - arg_lo_ss(T_AXIS,arg) + 1

      n1 = arg_lo_ss(F_AXIS,ARG1)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

      m1 = arg_lo_ss(E_AXIS,ARG1)
      DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

      k1 = arg_lo_ss(Z_AXIS,ARG1)
      DO 300 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 200 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            i1 = arg_lo_ss(X_AXIS,ARG1)
            DO 100 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

*
* Calculate the autocorrelation 
*  First step is to compute the partial means [1/(n-i)]* sum[m=1,n-i]dat(m+i)

               DO 420 l = 1, nd
                  psum = 0.
                  dsum = 0.
                  lm = l-1
                  l1 = arg_lo_ss(T_AXIS,ARG1)
                  DO 410 ls = 1, nd-lm 
                     IF ( arg_1(i1,j1,k1,l1+lm,m1,n1)
     .                    .NE. bad_flag(ARG1) ) THEN
                        bsize = box(ls+lm)
                        psum = psum + bsize*arg_1(i1,j1,k1,l1+lm,m1,n1)
                        dsum = dsum + bsize
                     ENDIF
                     l1 = l1 + arg_incr(T_AXIS,ARG1)
 410              CONTINUE
                  IF ( dsum .GT. 0. ) pmean(l) = psum / dsum
 420           CONTINUE

*  Compute the partial variances RMS[dat(m+l) - pmean(l)]
*  Don't divide by dsum; the denominators cancel when the autocorrelation
*  is computed below.

               DO 460 l = 1, nd
                  psum = 0.
                  dsum = 0.
                  lm = l-1
                  l1 = arg_lo_ss(T_AXIS,ARG1)
                  DO 450 ls = 1, nd-lm 
                     IF ( arg_1(i1,j1,k1,l1+lm,m1,n1)
     .                    .NE. bad_flag(ARG1) ) THEN
                        bsize = box(ls+lm)
                        diff = arg_1(i1,j1,k1,l1+lm,m1,n1) - pmean(l)
                        psum = psum + bsize * diff * diff
                        dsum = dsum + bsize
                     ENDIF
                     l1 = l1 + arg_incr(T_AXIS,ARG1)
 450              CONTINUE
                  IF ( dsum .GT. 0. ) THEN
                     pvar(l) = sqrt(psum)
                  ELSE
                     pvar(l) = 0.
                  ENDIF
 460           CONTINUE

*  Compute the autocorrelation for lag l=0,1,2,...,ND-1

               l1 = arg_lo_ss(T_AXIS,ARG1)
               lr = res_lo_ss(T_AXIS)
               DO 480 l = 1, nd

                  psum = 0.
                  dsum = 0.
                  lm = l-1
                  l1 = arg_lo_ss(T_AXIS,ARG1)
                  DO 470 ls = 1, nd-lm 
                     IF ( arg_1(i1,j1,k1,l1+lm,m1,n1)
     .                    .NE. bad_flag(ARG1) .AND.
     .                    arg_1(i1,j1,k1,l1,   m1,n1)
     .                    .NE. bad_flag(ARG1) ) THEN
                        bsize = (box(ls+lm) + box(ls)) / 2.
                        diff  = arg_1(i1,j1,k1,l1+lm,m1,n1) - pmean(l)
                        diff2 = arg_1(i1,j1,k1,l1,   m1,n1) - pmean(1) ! one, not ell
                        psum = psum + bsize * diff * diff2
                        dsum = dsum + box(ls+lm) * box(ls)
                     ENDIF
                     l1 = l1 + arg_incr(T_AXIS,ARG1)
 470              CONTINUE

                  IF ( pvar(1) .NE. 0.   .AND.  
     .                 pvar(l) .NE. 0.   .AND. 
     .                 psum    .NE. 0. ) THEN
                     result(i,j,k,lr,m,n) = psum / (pvar(1) * pvar(l))
                  ELSE
                     result(i,j,k,lr,m,n) = bad_flag_result
                  ENDIF

                  l1 = l1 + arg_incr(T_AXIS,ARG1)
                  lr = lr + res_incr(T_AXIS)
 480           CONTINUE

               i1 = i1 + arg_incr(X_AXIS,ARG1)
 100        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 200     CONTINUE

         k1 = k1 + arg_incr(Z_AXIS,ARG1)
 300  CONTINUE

         m1 = m1 + arg_incr(E_AXIS,ARG1)
 500  CONTINUE

         n1 = n1 + arg_incr(F_AXIS,ARG1)
 600  CONTINUE

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

c     
c     efcn_get_custom_axis.F
c     
c     Jonathan Callahan
c     Feb 19th 1998
c     
c     

c     
c     This subroutine allows an external function to create
c     a custom axis.
c     

      SUBROUTINE EFCN_GET_CUSTOM_AXIS(id, axis, dlo, dhi, ddel,
     .     unit, modulo_logical)
 
      IMPLICIT NONE
      INCLUDE 'ferret.parm'
      INCLUDE 'errmsg.parm'
      INCLUDE 'EF_Util.cmn'

      INTEGER id, axis, modulo
cc      REAL    lo, hi, del
      REAL*8  dlo, dhi, ddel
      CHARACTER*(*) unit
      LOGICAL modulo_logical

c     internal parameter declarations:
      INTEGER      slen
      PARAMETER  ( slen = ef_max_name_length )

#ifdef sun
      BYTE      fhol(slen)      ! c-type Hollerith string buffer
#else 
      INTEGER*1 fhol(slen)      ! c-type Hollerith string buffer
#endif
      
c     call the external functions library to get the value
      
      call efcn_get_custom_axis_sub( id, axis, dlo, dhi, ddel, 
     .     fhol, modulo )
      
      modulo_logical = .FALSE.
      IF ( modulo .EQ. 1 ) THEN
         modulo_logical = .TRUE.
      ENDIF

c     convert to a Fortran string
      call TM_CTOF_STRNG( fhol, unit, slen)

c     convert to double
cc      dlo = lo
cc      dhi = hi
cc      ddel = del
      
      RETURN 
      END

	INTEGER FUNCTION DO_FILL_INTERP(idim, arg,
     .					com, com_mr, com_cx,
     .					res, res_mr, res_cx,
     .					coords	)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* fill along axis idim by interpolating from the closest available valid pt

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V230:  3/23/92 - based on DO_FILL_AVE
* V301:  2/15/94 - upgrade to accomodate modulo axes
* V402:   8/9/95 - bug fix: T=@FLN had "lo_coord = coords(k-pos0)"
* V550 *sh* 8/2/02 - support for modulo lengths. ensure that filling 
*		    does not operate acros the subspan modulo void point
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V698 *acm* 5/16 Fix ticket 2366, the logic that tests for crossing the 
*                  modulo subspan void point was incorrect

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include	'xprog_state.cmn'
	include	'xdset_info.cmn_text'

* calling argument declarations:
	INTEGER	idim, com_mr, com_cx, res_mr, res_cx
	REAL	arg, coords(*),
     .          com( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          res( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif )

* internal variable declarations:
	LOGICAL	TM_ITS_SUBSPAN_MODULO, TM_ITSA_DSG,
     .		modulo_axis, modulo, no_lo_val, has_mod_void
	INTEGER TM_MODULO_LINE_DIM, CGRID_AXIS, 
     .          TM_DSG_DSET_FROM_GRID, TM_DSG_NFEATURES, 
     .          DO_FILL_INTERP_DSG,
     .		i, j, k, l, m, n, ii, jj, kk, ll, mm, nn,
     .          lo_sub(nferdims), hi_sub(nferdims),
     .		lo_edge, hi_edge, pos0, edge, lo_index, hi_index,
     .		lo_com, hi_com, line, axdim, look,
     .		coord_lo_ss, coord_hi_ss, next_hi_ss, 
     .		dset, grid, nfeatures, maxobs, mr_list(2)
	REAL	bad_res, lo_coord, hi_coord, coord, lo_val, hi_val,
     .		axlen, little_val, big_val
	REAL*8	TM_MODULO_AXLEN


* internal (convenience) equivalences
	INTEGER	lo_s1, lo_s2, lo_s3, lo_s4, lo_s5, lo_s6,
     .          hi_s1, hi_s2, hi_s3, hi_s4, hi_s5, hi_s6
	EQUIVALENCE (lo_s1, lo_sub(1)) , (lo_s2, lo_sub(2)),
     .		    (lo_s3, lo_sub(3)) , (lo_s4, lo_sub(4)),
     .		    (lo_s5, lo_sub(5)) , (lo_s6, lo_sub(6)),
     .		    (hi_s1, hi_sub(1)) , (hi_s2, hi_sub(2)),
     .		    (hi_s3, hi_sub(3)) , (hi_s4, hi_sub(4)),
     .		    (hi_s5, hi_sub(5)) , (hi_s6, hi_sub(6))

* local parameter declarations
	INTEGER     no_point
	PARAMETER ( no_point = -99999 )

* diagnostic mode output: " doing --> VAR_NAME[x=lo:hi@TRN:n,D=#]"
	IF ( mode_diagnostic ) 	CALL DIAG_OP
     .				( 'doing', isact_class_trans, res_cx, idim )

* initialize
	bad_res = mr_bad_data( com_mr )
	edge = arg

* DSG-specific initialize

	grid = mr_grid( com_mr )
	IF (TM_ITSA_DSG(grid)) THEN 
* DSG ragged array
	   dset = TM_DSG_DSET_FROM_GRID(grid)
	   nfeatures = TM_DSG_NFEATURES(grid)
* ... get the length of the longest feature
	   CALL DSG_COORD_LIMS(dset, pdsg_row_size, little_val, big_val)
	   maxobs = big_val

	   mr_list(1) = com_mr
	   mr_list(2) = res_mr
	   CALL NON_ARRAY_SUBSC( mr_list, 2 )
	   CALL DSG_ARRAY_SUBSC( mr_list, 2, dsg_orientation(dset) )

	   DO_FILL_INTERP = DO_FILL_INTERP_DSG( idim, dset, nfeatures, maxobs,
     .				com, com_mr, com_cx,
     .				res, res_mr, res_cx,
     .				coords )

	ELSE  !! not dsg

* limits of the component data provided
	lo_com = cx_lo_ss(com_cx, idim)
	hi_com = cx_hi_ss(com_cx, idim)


* is it a modulo axis with sufficient component span provided to wrap around
	line = CGRID_AXIS(idim, com_cx)
	axdim = 1
	IF ( line .EQ. mnormal .OR. line .EQ. munknown ) THEN
	   modulo_axis = .FALSE.
	ELSE
	   axdim = TM_MODULO_LINE_DIM(line)   ! 2/02
	   modulo_axis = line_modulo(line)
     .		    .AND. hi_com-lo_com+1 .GE. axdim
	ENDIF
	IF ( modulo_axis ) axlen = TM_MODULO_AXLEN(line)

* it this a subspan modulo axis?
	has_mod_void = TM_ITS_SUBSPAN_MODULO(line)
	IF (has_mod_void) THEN
	   has_mod_void = lo_com.LE.0 .OR. hi_com.GE.axdim
	ENDIF

* save the desired result region
	DO 10 ii = 1, nferdims
	   lo_sub(ii) = cx_lo_ss(res_cx,ii)
	   hi_sub(ii) = cx_hi_ss(res_cx,ii)
 10	CONTINUE

* get and save grid box coordinates just once for efficiency
	coord_lo_ss = MAX( lo_sub(idim)-edge, lo_com )
	coord_hi_ss = MIN( hi_sub(idim)+edge, hi_com )
        CALL MAKE_AXIS( mr_grid(com_mr), idim,
     .			coord_lo_ss, coord_hi_ss, coords )
        pos0    = coord_lo_ss - 1

* on action axis compute limits within which source data is accessible
	IF ( modulo_axis ) THEN
	   lo_edge = lo_sub(idim) - axdim	! complete axis wrap-around
	   hi_edge = hi_sub(idim) + axdim	! complete axis wrap-around
	ELSE
	   lo_edge = coord_lo_ss
	   hi_edge = coord_hi_ss
	ENDIF

* FILL ALONG X AXIS
	IF ( idim .EQ. x_dim ) THEN
	   DO 110 n = lo_s6, hi_s6
	   DO 110 m = lo_s5, hi_s5
	   DO 110 l = lo_s4, hi_s4
	   DO 110 k = lo_s3, hi_s3
	   DO 110 j = lo_s2, hi_s2
           no_lo_val = .TRUE.
           next_hi_ss = no_point
* ... find the closest off-scale low interpolation point in case we need it
           DO 101 i = lo_s1, lo_edge, -1
	      modulo = modulo_axis .AND. i.LT.coord_lo_ss
	      IF ( modulo ) THEN
	         look = MOD(i+axdim-coord_lo_ss,axdim) + coord_lo_ss
	      ELSE
	         look = i
	      ENDIF
              IF ( com(look,j,k,l,m,n) .NE. bad_res ) THEN
                 lo_val = com(look,j,k,l,m,n)
	         lo_index = look
	         lo_coord = coords(look-pos0)
	         IF ( modulo ) THEN
	            lo_index = lo_index - axdim
	            lo_coord = lo_coord - axlen
	         ENDIF
                 no_lo_val = .FALSE.
	         GOTO 102
              ENDIF
 101       CONTINUE
* ... process the requested line in X
 102	   DO 110 i = lo_s1, hi_s1
	      IF ( com(i,j,k,l,m,n) .NE. bad_res ) THEN
	         res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
                 lo_val = com(i,j,k,l,m,n)
	         lo_index = i
	         lo_coord = coords(i-pos0)
                 no_lo_val = .FALSE.
	         GOTO 110
	      ENDIF
* ... need to fill a point
              IF (no_lo_val) THEN
* ... no lower valid point
                 res(i,j,k,l,m,n) = bad_res
	         GOTO 110
              ELSEIF ( next_hi_ss .LT. i ) THEN
* ... look forward from current position for next valid point
                 DO 104 ii = i+1, hi_edge
	            modulo = modulo_axis .AND. ii.GT.coord_hi_ss
	            IF ( modulo ) THEN
	               look = MOD(ii+axdim-coord_lo_ss,axdim) + coord_lo_ss
	            ELSE
	               look = ii
	            ENDIF
                    IF ( com(look,j,k,l,m,n) .NE. bad_res ) THEN
                       next_hi_ss = look
                       hi_val = com(look,j,k,l,m,n)
	               hi_index = look
	               hi_coord = coords(next_hi_ss-pos0)
		       IF ( modulo ) THEN
	                  hi_index = hi_index + (ii/axdim)*axdim
	                  hi_coord = hi_coord + (ii/axdim)*axlen
	               ENDIF
                       GOTO 108
                    ENDIF
 104             CONTINUE
* ... no higher valid point
                 res(i,j,k,l,m,n) = bad_res
                 GOTO 110
              ENDIF
* ... fill in interpolating value
 108	      coord    = coords(i-pos0)
              res(i,j,k,l,m,n) = ( hi_val*(coord-lo_coord)
     .                         +   lo_val*(hi_coord-coord) )
     .                         / (hi_coord - lo_coord)
* ... bad if this interp crosses or lands on the void of a subspan modulo axis 
*     The multiply tests whether the low and high indices are on the same branch 

	      IF (has_mod_void) THEN
	        IF ( MOD(lo_index, axdim)*MOD(hi_index, axdim) .LT.0
     .	             .OR. (MOD(i,axdim) .EQ. 0) ) THEN
                    res(i,j,k,l,m,n) = bad_res
	         ENDIF
	      ENDIF
 110	   CONTINUE

* FILL ALONG Y AXIS
	ELSEIF ( idim .EQ. y_dim ) THEN
	   DO 210 n = lo_s6, hi_s6
	   DO 210 m = lo_s5, hi_s5
	   DO 210 l = lo_s4, hi_s4
	   DO 210 k = lo_s3, hi_s3
	   DO 210 i = lo_s1, hi_s1
           no_lo_val = .TRUE.
           next_hi_ss = no_point
* ... find the closest off-scale low interpolation point in case we need it
           DO 201 j = lo_s2, lo_edge, -1
	      modulo = modulo_axis .AND. j.LT.coord_lo_ss
              IF ( modulo ) THEN
                 look = MOD(j+axdim-coord_lo_ss,axdim) + coord_lo_ss
              ELSE
                 look = j
              ENDIF
              IF ( com(i,look,k,l,m,n) .NE. bad_res ) THEN
                 lo_val = com(i,look,k,l,m,n)
	         lo_index = look
	         lo_coord = coords(look-pos0)
	         IF ( modulo ) THEN
	            lo_index = lo_index - axdim
	            lo_coord = lo_coord - axlen
	         ENDIF
                 no_lo_val = .FALSE.
                 GOTO 202
              ENDIF
 201       CONTINUE
* ... process the requested line in Y
 202	   DO 210 j = lo_s2, hi_s2
	      IF ( com(i,j,k,l,m,n) .NE. bad_res ) THEN
	         res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
                 lo_val = com(i,j,k,l,m,n)
	         lo_index = j
                 lo_coord = coords(j-pos0)
                 no_lo_val = .FALSE.
	         GOTO 210
	      ENDIF
* ... need to fill a point
              IF (no_lo_val) THEN
* ... no lower valid point
                 res(i,j,k,l,m,n) = bad_res
                 GOTO 210
              ELSEIF ( next_hi_ss .LT. j ) THEN
* ... look forward from current position for next valid point
                 DO 204 jj = j+1, hi_edge
                    modulo = modulo_axis .AND. jj.GT.coord_hi_ss
                    IF ( modulo ) THEN
		       look = MOD(jj+axdim-coord_lo_ss,axdim)+coord_lo_ss
                    ELSE
                       look = jj
                    ENDIF
                    IF ( com(i,look,k,l,m,n) .NE. bad_res ) THEN
                       next_hi_ss = look
                       hi_val = com(i,look,k,l,m,n)
	               hi_index = look
		       hi_coord = coords(next_hi_ss-pos0)
		       IF ( modulo ) THEN
	                  hi_index = hi_index + (jj/axdim)*axdim
	                  hi_coord = hi_coord + (jj/axdim)*axlen
	               ENDIF
                       GOTO 208
                    ENDIF
 204             CONTINUE
* ... no higher valid point
                 res(i,j,k,l,m,n) = bad_res
                 GOTO 210
              ENDIF
* ... fill in interpolating value
 208          coord    = coords(j-pos0)
              res(i,j,k,l,m,n) = ( hi_val*(coord-lo_coord)
     .                         +   lo_val*(hi_coord-coord) )
     .                         / (hi_coord - lo_coord)
* ... bad if this interp crosses or lands on the void of a subspan modulo axis 
	      IF (has_mod_void) THEN
	        IF ( (lo_index/axdim .NE. hi_index/axdim)
     .	             .OR. (MOD(j,axdim) .EQ. 0) )
     .            res(i,j,k,l,m,n) = bad_res
	      ENDIF
 210	   CONTINUE

* FILL ALONG Z AXIS
	ELSEIF ( idim .EQ. z_dim ) THEN
	   DO 310 n = lo_s6, hi_s6
	   DO 310 m = lo_s5, hi_s5
	   DO 310 l = lo_s4, hi_s4
	   DO 310 j = lo_s2, hi_s2
	   DO 310 i = lo_s1, hi_s1
           no_lo_val = .TRUE.
           next_hi_ss = no_point
* ... find the closest off-scale low interpolation point in case we need it
           DO 301 k = lo_s3, lo_edge, -1
              modulo = modulo_axis .AND. k.LT.coord_lo_ss
              IF ( modulo ) THEN
                 look = MOD(k+axdim-coord_lo_ss,axdim) + coord_lo_ss
              ELSE
                 look = k
              ENDIF
              IF ( com(i,j,look,l,m,n) .NE. bad_res ) THEN
                 lo_val = com(i,j,look,l,m,n)
	         lo_index = look
	         lo_coord = coords(look-pos0)
	         IF ( modulo ) THEN
	            lo_index = lo_index - axdim
	            lo_coord = lo_coord - axlen
	         ENDIF
                 no_lo_val = .FALSE.
	         GOTO 302
              ENDIF
 301       CONTINUE
* ... process the requested line in Z
 302	   DO 310 k = lo_s3, hi_s3
	      IF ( com(i,j,k,l,m,n) .NE. bad_res ) THEN
	         res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
                 lo_val = com(i,j,k,l,m,n)
	         lo_index = k
                 lo_coord = coords(k-pos0)
                 no_lo_val = .FALSE.
	         GOTO 310
              ENDIF
* ... need to fill a point
              IF (no_lo_val) THEN
* ... no lower valid point
                 res(i,j,k,l,m,n) = bad_res
                 GOTO 310
              ELSEIF ( next_hi_ss .LT. k ) THEN
* ... look forward from current position for next valid point
                 DO 304 kk = k+1, hi_edge
                    modulo = modulo_axis .AND. kk.GT.coord_hi_ss
                    IF ( modulo ) THEN
		       look = MOD(kk+axdim-coord_lo_ss,axdim) + coord_lo_ss
                    ELSE
                       look = kk
                    ENDIF
                    IF ( com(i,j,look,l,m,n) .NE. bad_res ) THEN
                       next_hi_ss = kk
                       hi_val = com(i,j,look,l,m,n)
	               hi_index = look
                       hi_coord = coords(next_hi_ss-pos0)
		       IF ( modulo ) THEN
	                  hi_index = hi_index + (kk/axdim)*axdim
	                  hi_coord = hi_coord + (kk/axdim)*axlen
	               ENDIF
                       GOTO 308
                    ENDIF
 304             CONTINUE
* ... no higher valid point
                 res(i,j,k,l,m,n) = bad_res
                 GOTO 310
              ENDIF
* ... fill in interpolating value
 308          coord    = coords(k-pos0)
              res(i,j,k,l,m,n) = ( hi_val*(coord-lo_coord)
     .                         +   lo_val*(hi_coord-coord) )
     .                         / (hi_coord - lo_coord)
* ... bad if this interp crosses or lands on the void of a subspan modulo axis 
	      IF (has_mod_void) THEN
	        IF ( (lo_index/axdim .NE. hi_index/axdim)
     .	             .OR. (MOD(k,axdim) .EQ. 0) )
     .            res(i,j,k,l,m,n) = bad_res
	      ENDIF
 310	   CONTINUE

* FILL ALONG T AXIS
	ELSEIF ( idim .EQ. t_dim ) THEN
	   DO 410 n = lo_s6, hi_s6
	   DO 410 m = lo_s5, hi_s5
	   DO 410 k = lo_s3, hi_s3
	   DO 410 j = lo_s2, hi_s2
	   DO 410 i = lo_s1, hi_s1
           no_lo_val = .TRUE.
           next_hi_ss = no_point
* ... find the closest off-scale low interpolation point in case we need it
           DO 401 l = lo_s4, lo_edge, -1
              modulo = modulo_axis .AND. l.LT.coord_lo_ss
              IF ( modulo ) THEN
                 look = MOD(l+axdim-coord_lo_ss,axdim) + coord_lo_ss
              ELSE
                 look = l
              ENDIF
              IF ( com(i,j,k,look,m,n) .NE. bad_res ) THEN
                 lo_val = com(i,j,k,look,m,n)
	         lo_index = look
	         lo_coord = coords(look-pos0)
	         IF ( modulo ) THEN
	            lo_index = lo_index - axdim
	            lo_coord = lo_coord - axlen
	         ENDIF
                 no_lo_val = .FALSE.
	         GOTO 402
              ENDIF
 401       CONTINUE
* ... process the requested line in T
 402	   DO 410 l = lo_s4, hi_s4
	      IF ( com(i,j,k,l,m,n) .NE. bad_res ) THEN
	         res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
                 lo_val = com(i,j,k,l,m,n)
	         lo_index = l
                 lo_coord = coords(l-pos0)	! fixed 8/95
                 no_lo_val = .FALSE.
	         GOTO 410
	      ENDIF
* ... need to fill a point
              IF (no_lo_val) THEN
* ... no lower valid point
                 res(i,j,k,l,m,n) = bad_res
                 GOTO 410
              ELSEIF ( next_hi_ss .LT. l ) THEN
* ... look forward from current position for next valid point
                 DO 404 ll = l+1, hi_edge
                    modulo = modulo_axis .AND. ll.GT.coord_hi_ss
                    IF ( modulo ) THEN
		       look = MOD(ll+axdim-coord_lo_ss,axdim) + coord_lo_ss
                    ELSE
                       look = ll
                    ENDIF
                    IF ( com(i,j,k,look,m,n) .NE. bad_res ) THEN
                       next_hi_ss = look
                       hi_val = com(i,j,k,look,m,n)
	               hi_index = look
                       hi_coord = coords(next_hi_ss-pos0)
		       IF ( modulo ) THEN
	                  hi_index = hi_index + (ll/axdim)*axdim
	                  hi_coord = hi_coord + (ll/axdim)*axlen
	               ENDIF
                       GOTO 408
                    ENDIF
 404             CONTINUE
* ... no higher valid point
                 res(i,j,k,l,m,n) = bad_res
                 GOTO 410
              ENDIF
* ... fill in interpolating value
 408          coord    = coords(l-pos0)
              res(i,j,k,l,m,n) = ( hi_val*(coord-lo_coord)
     .                         +   lo_val*(hi_coord-coord) )
     .                         / (hi_coord - lo_coord)
* ... bad if this interp crosses or lands on the void of a subspan modulo axis 
	      IF (has_mod_void) THEN
	        IF ( (lo_index/axdim .NE. hi_index/axdim)
     .	             .OR. (MOD(l,axdim) .EQ. 0) )
     .            res(i,j,k,l,m,n) = bad_res
	      ENDIF
 410	   CONTINUE

* FILL ALONG E AXIS
	ELSEIF ( idim .EQ. e_dim ) THEN
	   DO 510 n = lo_s6, hi_s6
	   DO 510 l = lo_s4, hi_s4
	   DO 510 k = lo_s3, hi_s3
	   DO 510 j = lo_s2, hi_s2
	   DO 510 i = lo_s1, hi_s1
           no_lo_val = .TRUE.
           next_hi_ss = no_point
* ... find the closest off-scale low interpolation point in case we need it
           DO 501 m = lo_s5, lo_edge, -1
              modulo = modulo_axis .AND. n.LT.coord_lo_ss
              IF ( modulo ) THEN
                 look = MOD(m+axdim-coord_lo_ss,axdim) + coord_lo_ss
              ELSE
                 look = m
              ENDIF
              IF ( com(i,j,k,l,look,n) .NE. bad_res ) THEN
                 lo_val = com(i,j,k,l,look,n)
	         lo_index = look
	         lo_coord = coords(look-pos0)
	         IF ( modulo ) THEN
	            lo_index = lo_index - axdim
	            lo_coord = lo_coord - axlen
	         ENDIF
                 no_lo_val = .FALSE.
	         GOTO 502
              ENDIF
 501       CONTINUE
* ... process the requested line in E
 502	   DO 510 m = lo_s5, hi_s5
	      IF ( com(i,j,k,l,m,n) .NE. bad_res ) THEN
	         res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
                 lo_val = com(i,j,k,l,m,n)
	         lo_index = m
                 lo_coord = coords(m-pos0)	! fixed 8/95
                 no_lo_val = .FALSE.
	         GOTO 510
	      ENDIF
* ... need to fill a point
              IF (no_lo_val) THEN
* ... no lower valid point
                 res(i,j,k,l,m,n) = bad_res
                 GOTO 510
              ELSEIF ( next_hi_ss .LT. m ) THEN
* ... look forward from current position for next valid point
                 DO 504 mm = m+1, hi_edge
                    modulo = modulo_axis .AND. mm.GT.coord_hi_ss
                    IF ( modulo ) THEN
		       look = MOD(mm+axdim-coord_lo_ss,axdim) + coord_lo_ss
                    ELSE
                       look = mm
                    ENDIF
                    IF ( com(i,j,k,l,look,n) .NE. bad_res ) THEN
                       next_hi_ss = look
                       hi_val = com(i,j,k,l,look,n)
	               hi_index = look
                       hi_coord = coords(next_hi_ss-pos0)
		       IF ( modulo ) THEN
	                  hi_index = hi_index + (mm/axdim)*axdim
	                  hi_coord = hi_coord + (mm/axdim)*axlen
	               ENDIF
                       GOTO 508
                    ENDIF
 504             CONTINUE
* ... no higher valid point
                 res(i,j,k,l,m,n) = bad_res
                 GOTO 510
              ENDIF
* ... fill in interpolating value
 508          coord    = coords(m-pos0)
              res(i,j,k,l,m,n) = ( hi_val*(coord-lo_coord)
     .                         +   lo_val*(hi_coord-coord) )
     .                         / (hi_coord - lo_coord)
* ... bad if this interp crosses or lands on the void of a subspan modulo axis 
	      IF (has_mod_void) THEN
	        IF ( (lo_index/axdim .NE. hi_index/axdim)
     .	             .OR. (MOD(m,axdim) .EQ. 0) )
     .            res(i,j,k,l,m,n) = bad_res
	      ENDIF
 510	   CONTINUE

* FILL ALONG F AXIS
	ELSEIF ( idim .EQ. f_dim ) THEN
	   DO 610 m = lo_s5, hi_s5
	   DO 610 l = lo_s4, hi_s4
	   DO 610 k = lo_s3, hi_s3
	   DO 610 j = lo_s2, hi_s2
	   DO 610 i = lo_s1, hi_s1
           no_lo_val = .TRUE.
           next_hi_ss = no_point
* ... find the closest off-scale low interpolation point in case we need it
           DO 601 n = lo_s6, lo_edge, -1
              modulo = modulo_axis .AND. n.LT.coord_lo_ss
              IF ( modulo ) THEN
                 look = MOD(n+axdim-coord_lo_ss,axdim) + coord_lo_ss
              ELSE
                 look = n
              ENDIF
              IF ( com(i,j,k,l,m,look) .NE. bad_res ) THEN
                 lo_val = com(i,j,k,l,m,look)
	         lo_index = look
	         lo_coord = coords(look-pos0)
	         IF ( modulo ) THEN
	            lo_index = lo_index - axdim
	            lo_coord = lo_coord - axlen
	         ENDIF
                 no_lo_val = .FALSE.
	         GOTO 602
              ENDIF
 601       CONTINUE
* ... process the requested line in E
 602	   DO 610 n = lo_s6, hi_s6
	      IF ( com(i,j,k,l,m,n) .NE. bad_res ) THEN
	         res(i,j,k,l,m,n) = com(i,j,k,l,m,n)
                 lo_val = com(i,j,k,l,m,n)
	         lo_index = n
                 lo_coord = coords(n-pos0)	! fixed 8/95
                 no_lo_val = .FALSE.
	         GOTO 610
	      ENDIF
* ... need to fill a point
              IF (no_lo_val) THEN
* ... no lower valid point
                 res(i,j,k,l,m,n) = bad_res
                 GOTO 610
              ELSEIF ( next_hi_ss .LT. n ) THEN
* ... look forward from current position for next valid point
                 DO 604 nn = n+1, hi_edge
                    modulo = modulo_axis .AND. nn.GT.coord_hi_ss
                    IF ( modulo ) THEN
		       look = MOD(nn+axdim-coord_lo_ss,axdim) + coord_lo_ss
                    ELSE
                       look = nn
                    ENDIF
                    IF ( com(i,j,k,l,m,look) .NE. bad_res ) THEN
                       next_hi_ss = look
                       hi_val = com(i,j,k,l,m,look)
	               hi_index = look
                       hi_coord = coords(next_hi_ss-pos0)
		       IF ( modulo ) THEN
	                  hi_index = hi_index + (nn/axdim)*axdim
	                  hi_coord = hi_coord + (nn/axdim)*axlen
	               ENDIF
                       GOTO 608
                    ENDIF
 604             CONTINUE
* ... no higher valid point
                 res(i,j,k,l,m,n) = bad_res
                 GOTO 610
              ENDIF
* ... fill in interpolating value
 608          coord    = coords(n-pos0)
              res(i,j,k,l,m,n) = ( hi_val*(coord-lo_coord)
     .                         +   lo_val*(hi_coord-coord) )
     .                         / (hi_coord - lo_coord)
* ... bad if this interp crosses or lands on the void of a subspan modulo axis 
	      IF (has_mod_void) THEN
	        IF ( (lo_index/axdim .NE. hi_index/axdim)
     .	             .OR. (MOD(n,axdim) .EQ. 0) )
     .            res(i,j,k,l,m,n) = bad_res
	      ENDIF
 610	   CONTINUE



        ENDIF  ! 

        ENDIF  !!  IF (TM_ITSA_DSG(grid))

* always success
	DO_FILL_INTERP = ferr_ok
	RETURN

	END

	SUBROUTINE CLSPPL

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Modified 9.27.88 J Davison TMAP/JISAO/PMEL
*	to close GKS properly if it is opened.
*	J Davison 11.28.88 modified for compatibility to v1.1 PPL
*	k obrien 3.11.97 added ifdef for linux port to ignore "unlink"
* V602: *acm* 1/07 Changes for metafile-batch mode

	include 'symkey_inc.decl'
	include 'SYMKEY.INC'
	include 'cmdcom_inc.decl'
	include 'CMDCOM.INC'
	include 'lunits_inc.decl'
	include 'LUNITS.INC'
	include 'pltcom_dat.decl'
	include 'PLTCOM.DAT'


#ifdef core
        include 'CORECM.INC'
#endif
C
C	CLOSES FILES USED BY PLOT5+
C
	CALL ATFLSH
#ifdef unix
        call dbmclose(keyln1)
#ifndef F90_NO_UNLINK
        call unlink('PPL$KEY.001.pag')
        call unlink('PPL$KEY.001.dir')
#endif
        call close_gks !See bottom of this file. J Davison 9.27.88
#else
        call close_gks !See bottom of this file. J Davison 9.27.88
	CLOSE(KEYLN1,DISP='DELETE')
#endif
#ifdef core
        if(gksopn)then
            call closeretainseg()
            call deselectvwsurf(vsurf)
            call terminatecore()
        endif
#endif
 
	IF(PLTFLG)THEN
	    PEN = .FALSE.
	    CALL ZABMV
	    CALL BINFSH
	    PLTFLG = .FALSE.
	ENDIF
	RETURN
	END

        SUBROUTINE CLOSE_GKS

*       Written to close GKS if it is open, deactivate and close workstations
*       J Davison 9.27.88

        include         'pltcom_dat.decl'
        include         'PLTCOM.DAT'
	include         'plt_inc.decl'
        include         'PLT.INC'

        integer         member,er_status,num_active,rmember,i,j,
     .                  num_open, istate

********************************************************************************


        CALL GQOPS (istate)  ! In batch mode the graphics may not be active now. 

        if (gksopn) then 
           if ( istate .GE. 2 ) then
	      member = 1
              call gqacwk (member,er_status,num_active,rmember)
              if (num_active .lt. 1) goto 20

              do 10 i = 1,num_active
                 call gqacwk (1,er_status,j,rmember)
                 call gdawk (rmember)
10            continue

20            call gqopwk (member,er_status,num_open,rmember)
              if (num_open .lt. 1) goto 40

              do 30 i = 1,num_open
                 call gqopwk (1,er_status,j,rmember)
                 call gclwk (rmember, batmode)
30            continue

           endif    ! istate
40         call gclks ()
        end if

        return
        end

* 
*  expndi_by_m_counts.F
* 
*  Ansley Manke (from expndi_by_z_counts)
*  4/2014
* 
* Expand argument 1 by creating a 2D XE structure from it with the 
* separation between X rows given by the lengths specified in 
* argument 2. Argument 2 is a list of length N, where N is the number of 
* X rows to create, and each item in the list is the length of that 
* column (the length of the cruise or profile). Thus the X rows created 
* are "ragged" Typical use is that arg 1 is a collection of vertical casts 
* appended end-to-end and that arg 2 is the number of values in each cast.
* The sum of the values in arg 2 is the length of argument 1. 

*  Args 3 and 4 are constants -- the size of the X and E axes, respectively
 
*  In this subroutine we provide information about
*  the function.  The user configurable information 
*  consists of the following:
* 
*  descr              Text description of the function
* 
*  num_args           Required number of arguments
* 
*  axis_inheritance   Type of axis for the result
*                        ( CUSTOM, IMPLIED_BY_Z_ARGS, q, ABSTRACT )
*                        CUSTOM          - user defined axis
*                        IMPLIED_BY_Z_ARGS - same axis as the incoming argument
*                        NORMAL          - the result is normal to this axis
*                        ABSTRACT        - an axis which only has index values
* 
*  piecemeal_ok       For memory optimization:
*                        axes where calculation may be performed piecemeal
*                        ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE expndi_by_m_counts_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .  'Expand arg1 into an XE grid. (Split I variable into E-Rows)' )

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id, IMPLIED_BY_ARGS, NORMAL, 
     .     NORMAL, NORMAL, IMPLIED_BY_ARGS, NORMAL)

* Tell Ferret to run the following instead, if the arguments are strings.
      CALL ef_set_alt_fcn_name(id, 'EXPNDI_BY_M_COUNTS_STR')

      arg = 1
      CALL ef_set_arg_name(id, arg, 'Data')
      CALL ef_set_arg_desc(id, arg, '1-D variable to expand')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'Row Sizes')
      CALL ef_set_arg_desc(id, arg,
     .          '1-D list on E axis: count of values in each feature')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, YES, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'Result X axis')
      CALL ef_set_arg_desc(id, arg,
     .          'Variable on a 1-D grid, axis of length max_row_len')
      CALL ef_set_axis_influence_6d(id, arg, YES, NO, NO, NO, NO, NO)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

* 
*  In this subroutine we compute the result
* 
      SUBROUTINE expndi_by_m_counts_compute(id, arg_1, arg_2, arg_3, 
     .                               result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy,
     .	   mem1loz:mem1hiz, mem1lot:mem1hit,
     .	   mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy,
     .     mem2loz:mem2hiz, mem2lot:mem2hit,
     .	   mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy,
     .     mem3loz:mem3hiz, mem3lot:mem3hit,
     .	   mem3loe:mem3hie, mem3lof:mem3hif)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .     memresloz:memreshiz, memreslot:memreshit,
     .     memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(6), res_hi_ss(6), res_incr(6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS), arg_hi_ss(6,EF_MAX_ARGS),
     .     arg_incr(6,EF_MAX_ARGS)


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l,m,n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2
      INTEGER imax, iout, isum, mmax, mrow, mout

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* limits on output arrays
        imax = res_hi_ss(X_AXIS)
        mmax = res_hi_ss(E_AXIS)

* sum of counts in arg 2 must be length of x-dimension of arg1

      do 20 i2 = arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS,ARG2)
      do 20 j2 = arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS,ARG2)
      do 20 k2 = arg_lo_ss(Z_AXIS,ARG2), arg_hi_ss(Z_AXIS,ARG2)
      do 20 L2 = arg_lo_ss(T_AXIS,ARG2), arg_hi_ss(T_AXIS,ARG2)
      do 20 n2 = arg_lo_ss(F_AXIS,ARG2), arg_hi_ss(F_AXIS,ARG2)
         isum = 0
         DO 10 m2 = arg_lo_ss(E_AXIS,ARG2), arg_hi_ss(E_AXIS,ARG2)
            IF  (arg_2(i2,j2,k2,l2,m2,n2) .EQ. bad_flag(ARG2) .OR. 
     .           INT(arg_2(i2,j2,k2,l2,m2,n2)) .LT. 0)
     .          CALL EF_BAIL_OUT(id, 'arg 2 must be non-missing counts GE zero')
            isum = isum + INT(arg_2(i2,j2,k2,l2,m2,n2))
 10   CONTINUE
         IF (isum .NE. (arg_hi_ss(X_AXIS,ARG1)-arg_lo_ss(X_AXIS,ARG1)+1) )
     .       CALL EF_BAIL_OUT(id, 
     .         'arg 2 values (counts) must sum to x-dimension length of of arg1 ')
 20   CONTINUE

* pre-fill the entire output result with missing value flags
*  (since length of each profile may have different number of pts)
      DO 50 n=res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
      DO 50 m=res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
      DO 50 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
      DO 50 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
      DO 50 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
      DO 50 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
         result(i,j,k,l,m,n) = bad_flag_result
 50   CONTINUE

* fill in the points as specified by the counts

      n1 = arg_lo_ss(F_AXIS,ARG1)
      n2 = arg_lo_ss(F_AXIS,ARG2)
      DO 400 n=res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

      l1 = arg_lo_ss(T_AXIS,ARG1)
      l2 = arg_lo_ss(T_AXIS,ARG2)
      DO 400 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

      k1 = arg_lo_ss(Z_AXIS,ARG1)
      k2 = arg_lo_ss(Z_AXIS,ARG2)
      DO 400 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

      j1 = arg_lo_ss(Y_AXIS,ARG1)
      j2 = arg_lo_ss(Y_AXIS,ARG2)
      DO 400 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

         i1 = arg_lo_ss(X_AXIS,ARG1)
         i2 = arg_lo_ss(X_AXIS,ARG2)

         m1 = arg_lo_ss(E_AXIS,ARG1)
         m2 = arg_lo_ss(E_AXIS,ARG2)
 
            i1 = 1
            DO 200 mout=arg_lo_ss(E_AXIS,ARG2),arg_hi_ss(E_AXIS,ARG2)
               DO 100 iout = 1, NINT(arg_2(i2,j2,k2,l2,mout,n1))
                 IF ( arg_1(i1,j1,k1,l1,m1,n1) .NE. bad_flag(1) )
     .             result(iout,j,k,l,mout,n) = arg_1(i1,j1,k1,l1,m1,n1)

                  i1 = i1 + 1
 100           CONTINUE
 200        CONTINUE

         j1 = j1 + arg_incr(Y_AXIS,ARG1)
         j2 = j2 + arg_incr(Y_AXIS,ARG2)
         k1 = k1 + arg_incr(Z_AXIS,ARG1)
         k2 = k2 + arg_incr(Z_AXIS,ARG2)
         l1 = l1 + arg_incr(T_AXIS,ARG1)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
         n1 = n1 + arg_incr(F_AXIS,ARG1)
         n2 = n2 + arg_incr(F_AXIS,ARG2)
 400  CONTINUE
      
         
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	SUBROUTINE CD_CLEAN_GRIDS ( dset, cdfid, temp_axnams,
     .				    ok_share_taxis, native_tax, status )


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* check for errors and eliminate duplication from newly defined grids and axes
* When the routine exits there will be no duplicate axis names although there
* will be holes in line_memory from deleted axes.
* When the routine exits there will still be duplicate grid names among the
* newly defined grids.  These may be eliminated after variables are associated.
* Finally, determine the "record" axis of this data set,

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 2/92
* v500 - 3/99 *kob* - up length of variable vname to correspond w/ increased
*                     size of line_name
*      - 4/99 *kob* - need to increase size of temp_axnams as well
*      - 7/99 *sh* - bug fix: need conosotent use of char_init16 on line_name
* V510 *sh* 3/00 - convert to use of dynamic grids and axes
*		 - use TM_GET_LINEMATCH to ensure that renamed axes also match
* V552 *acm* 5/03   increase vname and buff to 128 chars 
* V600 *ACM* attribute control. 
*             Replace NCDINQ with CD_GET_DS_DIMS
* V601 *acm* 11/06 If there is a new axis name, save the original axis name of 
*                  the axis as an attribute of the coordinate variable in the 
*                  linked-list attribute structure, and change the axis name itself
*                  in the attribute structure.
* V602 *acm* 12/06 When replacing or resetting an axis, test for the existence of
*                  the attribute orig_file_axname. If it already exists, call the
*                  routine to replace the attribute rather than trying to add a new
*                  attribute.
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing
* v694 1/15 *acm* for ticket 2227: if a dimension from a nc file is not also a 
*                 1-D coordinate var, don't write the axis Ferret creates
* V698 11/15 *sh* new args control whether sharing of T axis is allowed

* argument definitions:
*       dset    - pointer to TMAP data set
*	cdfid	- netCDF id number for already opened CDF file
*       temp_axnams - temporary storage of axis names to construct grids
*       ok_share_taxis - (input) is it ok to reuse T axis of another dataset
*       native_tax - (input) the native time axis of this dataset
*	status	- return status

* include files
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
        include 'xbuild_grids.cmn'
	include 'xtm_grid.cmn_text'
	include 'xdset_info.cmn_text'
        include 'netcdf.inc'


* argument declarations
	LOGICAL ok_share_taxis
	INTEGER	 dset, cdfid, native_tax, status
*4/99 *kob*
        CHARACTER*128 temp_axnams(nferdims,max_temp_grid)

* local parameter definitions:
      INTEGER     max_grd_per_cdf
      PARAMETER ( max_grd_per_cdf = 40 )

* local variable declarations:
      LOGICAL TM_SAME_GRID_DEF, 
     .        dup_name, dup_guts, coordvar
      INTEGER TM_GET_LINEMATCH,  TM_GET_LINENUM, TM_GET_GRIDNUM, 
     .        TM_LENSTR1, STR_SAME,
     .        igrid, iaxis, count, idim, i_dup, ivar,
     .        npts, istat,  reused(max_lines:line_ceiling),
     .        varid, attid, attype, attlen, attoutflag, len,
     .        vartype, nvdims, nvatts, outflag, dimid
* upped vname to 64 - also removed the *24 from the CHARACTER
* upped vname to 128 
      CHARACTER vname*128, buff*128, attname*128
      REAL dummy, vdims(8)
	

***** AXES ******
* check for duplicate name / guts of axes
* if completely identical (name and guts) then eliminate the new one
* if new definition with already used name then flag this
	iaxis = 0	! to get start of linked list
 100	CALL TM_NEXT_TMP_LINE( iaxis, *110)
	  reused(iaxis) = TM_GET_LINEMATCH( iaxis, dup_name, dup_guts )
* ... hack: multi-file T-aggregated dset must not share any existing taxis at
*     this stage, because more time steps will be appended to it
	  IF (   .NOT.ok_share_taxis
     .	   .AND. iaxis.EQ.native_tax
     .     .AND. reused(iaxis).NE.unspecified_int4 ) THEN
	      reused(iaxis) = unspecified_int4
	      dup_guts = .FALSE.
	  ENDIF 
	  IF ( dup_name .AND. .NOT.dup_guts ) THEN
	     line_fixname(iaxis) = .TRUE.  ! new definition reuses old name
	  ELSE
	     line_fixname(iaxis) = .FALSE.
	  ENDIF
	GOTO 100  ! like  100   CONTINUE

* check that all the grids point to real axes
 110	igrid = 0		! to get start of linked list
 250	CALL TM_NEXT_TMP_GRID( igrid, *260)
	   count = tmp_nam_ptr(igrid)
           DO 240 idim = 1, nferdims 
              vname = temp_axnams(idim, count)
!              IF ( vname .EQ. 'RECORD' ) THEN
!* ... the CDF term "RECORD" is the last dim'ed axis (like "UNKNOWN" for GT)
!                 grid_line(idim, igrid) = mpsunkn
              IF ( vname .EQ. 'NORMAL' ) THEN
                 grid_line(idim, igrid) = mpsnorm
              ELSE
* ... first choose from the axis names just defined
	         iaxis = 0	! to get start of linked list
 200	         CALL TM_NEXT_TMP_LINE( iaxis, *202)
                    IF ( vname .EQ. line_name(iaxis) ) THEN
	               IF (reused(iaxis) .EQ. unspecified_int4 ) THEN
                          grid_line(idim, igrid) = iaxis
	               ELSE
                          grid_line(idim, igrid) = reused(iaxis)
	               ENDIF
                       GOTO 240
                    ENDIF
	         GOTO 200
* ... not found? then this name was a duplicate definition. Reuse older defn
 202		 grid_line(idim, igrid) = reused(iaxis)
	         IF (reused(iaxis) .EQ. unspecified_int4)
     .						STOP 'cd_clean_crptn'
              ENDIF
 240       CONTINUE
	GOTO 250
                 
* check for duplicate grid name / guts
 260	igrid = 0		! to get start of linked list
 300	CALL TM_NEXT_TMP_GRID( igrid, *301)

* ... eliminate this grid name to look for duplicates
           vname = grid_name(igrid)   ! temporary storage
           grid_name(igrid) = char_init
           i_dup = TM_GET_GRIDNUM( vname )
           dup_name = i_dup .NE. unspecified_int4

           IF ( dup_name ) THEN
              dup_guts = TM_SAME_GRID_DEF( i_dup, igrid )
           ELSE
              dup_guts = .FALSE. ! ... well not necessarily but who cares ?
           ENDIF

* Save the grid if it's unique
          IF ( .NOT.dup_name ) THEN
             grid_name(igrid) = vname

* Throw away this duplicate but make sure variables point to the original
          ELSEIF ( dup_guts ) THEN
             grid_name(igrid) = char_init   ! throw it away
             DO 290 ivar = 1, maxvars
 290         IF ( ds_grid_number(ivar) .EQ. igrid )
     .               ds_grid_number(ivar) = i_dup

* Duplicate name - differing guts / make the grid name unique
          ELSE
             grid_name(igrid) = vname
             CALL TM_NEW_GRID_NAME( grid_name(igrid), vname )
             grid_name(igrid) = vname
          ENDIF

	GOTO 300	! like 300    CONTINUE

* destroy any axis names that are duplicates both in name and defn
* make unique any axis names that are duplicates but with new guts

* If there is a new name, save the original axis name of the axis as an
* attribute of the coordinate variable in the linked-list attribute structure,
* and change the axis name itself.

*** Here if the name is a dimension not a coordinate variable in the original
*** dataset, we want to do a CD_RENAME_DIM, so that we rename in the dset structure 
*** the dimension but not (for example) the 2-D variable with the same name.

 301	iaxis = 0		! to get start of linked list
 400	CALL TM_NEXT_TMP_LINE( iaxis, *402)
          vname = line_name(iaxis)
          len = TM_LENSTR1(vname)
          CALL CD_GET_VAR_ID (dset, vname, varid, status)
          CALL CD_GET_VAR_INFO (dset, varid, vname, vartype, 
     .            nvdims, vdims, nvatts, coordvar, outflag, status)

	  IF ( reused(iaxis) .NE. unspecified_int4 ) THEN
	    line_name(iaxis) = char_init16   ! destroy new duplicate defn
	    line_fixname(iaxis) = .FALSE.  
            
            buff = line_name(reused(iaxis))

            IF (status .EQ. merr_ok .AND. 
     .          STR_SAME(vname, buff) .NE. 0) THEN

               CALL CD_GET_DIM_ID (dset, vname, dimid)
               CALL CD_RENAME_DIM (dset, dimid, buff, status)
               IF (nvdims.EQ.1) CALL CD_RENAME_VAR (dset, varid, buff, status)
               
* Replace or add the orig_file_axname attribute
               attname = 'orig_file_axname'
               CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, 
     .              status)
               IF (attid .GT. 0) THEN 
                  CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, attname,
     .               attype, attlen, attoutflag, status)
                  CALL CD_REPLACE_ATTR (dset, varid, attname, NF_CHAR, 
     .               len, vname, dummy, status)
               ELSE
                  CALL CD_PUT_NEW_ATTR (dset, varid, 'orig_file_axname',
     .               NF_CHAR, len, -1, vname, dummy, status)
               ENDIF
            ENDIF

          ELSEIF ( line_fixname(iaxis) ) THEN
            CALL TM_NEW_LINE_NAME( line_name(iaxis), buff )
            line_name(iaxis) = buff

            IF (status .EQ. merr_ok .AND. 
     .          STR_SAME(vname, buff) .NE. 0) THEN

               CALL CD_GET_DIM_ID (dset, vname, dimid)
               CALL CD_RENAME_DIM (dset, dimid, buff, status)
               IF (nvdims.EQ.1) CALL CD_RENAME_VAR (dset, varid, buff, status)

* Replace or add the orig_file_axname attribute
               attname = 'orig_file_axname'
               CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, 
     .              status)
               IF (attid .GT. 0) THEN 
                  CALL CD_GET_VAR_ATT_INFO (dset, varid, attid, attname,
     .               attype, attlen, attoutflag, status)
                  CALL CD_REPLACE_ATTR (dset, varid, attname, NF_CHAR, 
     .               len, vname, dummy, status)
               ELSE
                  CALL CD_PUT_NEW_ATTR (dset, varid, 'orig_file_axname',
     .                NF_CHAR, len, -1, vname, dummy, status)
               ENDIF
            ENDIF

          ENDIF
	GOTO 400	! like  400    CONTINUE

* determine the "record" axis
 402	IF ( ds_time_axis(dset) .LT. 1 ) THEN
             ds_time_axis(dset) = unspecified_int4
        ELSE
           CALL CD_GET_DS_DIMS( dset, ds_time_axis(dset), vname, 
     .                          npts, istat )
           ds_time_axis(dset) = TM_GET_LINENUM( vname )
        ENDIF

* successful completion
 	status = merr_ok
        RETURN

* error messages
 5100	buff = 'axis: '//vname//' grid: '//grid_name(igrid)
 	CALL TM_ERRMSG (merr_lineundef, status, 'CD_CLEAN_GRIDS',
     .			no_descfile, no_stepfile,
     .			buff, no_errstring, *5900)

* error exit
 5900   RETURN
	END

	CHARACTER*6 FUNCTION TM_EXP_CODE ( ds_num )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
*  Returns a unique exp_code for use in looking at experiment documentation
*  files. This code is based on ds_type and ds_expnum. This is 12222, where
*  1 and 2 indicate one character of ds_type and ds_expnum respectively.
*  E.g. "G0023". Special cases exist for GTBA011, GTMA011, and GTPA011.
*  These will have B,M, or P appended as appropriate.
*
*  Arguments:
*	ds_num - dataset number
*
*  Written 04/88 by M. Verschell for PMEL/TMAP (for VAX/VMS)
*
* revision 0.00 - 04/28/88 - 
* revision 0.10 - 01/24/89 - Added patch so that TS data sets give G prefix
* revision 0.11 - 02/15/89 - removed ds_open
* Unix/RISC port 4/24/91 *sh*: increased ds_name size
* MOM change - 4/92- *kob* : Allowed for M**** to be an acceptable exp num.
* bug fix - 7/92- Check d_source instead of d_title for MOM data - oops*kob*
* efficiency addition - 7/92-added a check for a modnum of BC which - *kob* 
* 7/95 *sh* have "CDF" map into "M"
* 9/95 *sh* - remove special "BURST" kludge of Ben Giese's - some of the recent
*		runs contain the word "Burst" in their titles, too
* v540 *acm* 10/01 increase length of ds_name
* v540 *acm* 10/01  remove VMS include statements
* v604 *acm* 7/07 increase length of ds_name, ds_des_name
* V65  *acm* 2/10- all warnings and notes to std error not std out
* V701  7/16 *kms* Compare ds_name to char_init2048 instead of char_init1024

*  Argument definitions
	INTEGER*4	ds_num

*  Include files
	include	'tmap_errors.parm'
	include 'xio.cmn_text'
        external xio_data
#include "tmap_dset.parm"
	include 'tmap_dims.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data

*  Local definitions
	CHARACTER*6	temp_code
	CHARACTER*80	string
	INTEGER*4	STR_UPCASE, TM_LENSTR1, lenb 
	INTEGER*4	i, istat
	LOGICAL		TM_HAS_STRING

	temp_code(1:6) = ' '

*  Is the requested data set initialized?
	IF (ds_name(ds_num) .EQ. char_init2048) GOTO 9000

*  If data set type is 'GT' then check for burst experiment
* add a check for model runs using MOM (new, vibrant cray code) 4/92 kob
	IF (TM_HAS_STRING(ds_type(ds_num),'GT')
     .  .OR.TM_HAS_STRING(ds_type(ds_num),'CDF')) THEN		! 7/95
!	  IF (TM_HAS_STRING(ds_title(ds_num),'BURST')) THEN
!	     temp_code(1:1) = 'B'
	  IF (TM_HAS_STRING(ds_source(ds_num),'MOM')) THEN
             temp_code(1:1) = 'M'
          ELSE
	     temp_code(1:1) = 'G'
	  ENDIF
	ELSE
	  DO i = 1,4
	    IF (ds_type(ds_num)(i:i) .NE. ' ') THEN
	      istat = STR_UPCASE(TEMP_CODE(1:1),ds_type(ds_num)(i:i))
	      GOTO 100
	    ENDIF
	  ENDDO
	ENDIF

  100	istat = STR_UPCASE(temp_code(2:5),ds_expnum(ds_num))

*  Special cases
	IF (TM_HAS_STRING(ds_expnum(ds_num),'11')) THEN
	  IF (TM_HAS_STRING(ds_modnum(ds_num),'BA')) temp_code(6:6)='B'
	  IF (TM_HAS_STRING(ds_modnum(ds_num),'MA')) temp_code(6:6)='M'
	  IF (TM_HAS_STRING(ds_modnum(ds_num),'PA')) temp_code(6:6)='P'
	  IF (TM_HAS_STRING(ds_modnum(ds_num),'BC')) temp_code(6:6)='P'
	ENDIF

*  Time Series fix
	IF (TM_HAS_STRING(ds_type(ds_num),'TS')) temp_code(1:1) = 'G'

	TM_Exp_code = temp_code
	GOTO 9999

 9000	CONTINUE
 
	WRITE (string, *) 'Unknown data set ',ds_num
	lenb = TM_LENSTR1( string )
	CALL WARN( string(:lenb) )
	TM_Exp_code = ' '
	GOTO 9999

 9999	RETURN
	END

    	SUBROUTINE FERRET_QUERY_F( query, flags, nflags, ctext, ntext,
     .				   num_strings, num_vals, nums, nnums,
     .				   arg1, arg2, arg3, arg4, arg5, qstatus )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* respond to the GUI query API call

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* for FERRET V400: 8/94
*   3/15/95 - fixed error in "strides" for query GCOORDS
* V402: "temporary ferret_query.inc" changed to ferret_cmn/ferret_query.parm
* V420: bug fix: query would crash if grid was unknown
*Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
*	    4/97 *kob* - added ifdef for MANDATORY_FORMAT_WIDTHS on internal
*			 read because linux/nag f90 needed a format width.
*           12/00*acm* - cleanup: TM_DATE_OK declared but never called
* V533      8/01 *acm* - calendar axis additions: SECS_FROM_BC needs cal_id
* v540 *acm* 10/01 increase length of ds_name
* v540 *acm* 10/01  remove VMS include statements
* v604 *acm* 7/07 increase length of ds_name
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction.

        include 'tmap_dims.parm'
#       include "tmap_dset.parm"
        include 'xdset_info.cmn_text'
        external xdset_info_data
        include 'xtm_grid.cmn_text'
        external xgt_grid_data
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'gfdl_vms.parm'
	include 'ferret_query.parm'
	include 'xprog_state.cmn'
	include 'xcommand.cmn'
	include 'xtext_info.cmn'
	include 'xcontext.cmn'
	include 'xalgebra.cmn'
	include 'xgui.cmn'
	include 'xvariables.cmn' ! JC_ADDITION


* calling argument declarations
	INTEGER query, nflags, flags(nflags), num_strings, num_vals, ntext,
     .		nnums, qstatus
* ... c-type Hollerith string buffers
#ifdef NEED_BYTE
        BYTE      ctext(ntext), arg1(*), arg2(*), arg3(*), arg4(*), arg5(*)
#else
        INTEGER*1 ctext(ntext), arg1(*), arg2(*), arg3(*), arg4(*), arg5(*)
#endif
	REAL*8	nums(nnums)

* local variable declarations:
	LOGICAL GEOG_LABEL
	INTEGER	TM_LENSTR1, FIND_DSET_NUMBER, IGRID, TM_GET_LINENUM,
     .		TM_GET_GRIDNUM, TM_GET_CALENDAR_ID,
     .		i, i2, n, dim, dset, cat, var, axis, grid,
     .		slen, insert_pt, stride, status, cal_id,
     .          j, num_indices
	REAL*8	TWORLD, TM_WORLD, SECS_FROM_BC, lo, hi, delta
	CHARACTER AX_TITLE*32, TM_FMT*16, buff1*32,
     .		  farg1*80, farg2*80, farg3*80, farg4*80, farg5*80

* local parameter declarations:
	CHARACTER*4 notext
	PARAMETER ( notext = '****')

* legal query ?
	IF ( query .GT. max_queries ) THEN
	   qstatus = QSTAT_UNKNOWN_QUERY
	   RETURN
	ENDIF

* initialize
	qstatus = QSTAT_OK
	insert_pt = 1
	num_strings = 0
	num_vals = 0
	DO 10 i = 1, nflags
 10	flags(i) = 0
	ctext(1) = 0

* convert arguments to FORTRAN character arrays
	CALL TM_CTOF_STRNG(arg1, farg1, 80) 
	CALL TM_CTOF_STRNG(arg2, farg2, 80) 
	CALL TM_CTOF_STRNG(arg3, farg3, 80) 
	CALL TM_CTOF_STRNG(arg4, farg4, 80) 
	CALL TM_CTOF_STRNG(arg5, farg5, 80) 

* respond to the appropriate query
	GOTO ( 100, 200, 300, 400, 500, 600, 700, 800, 900,1000,
     .	      1100,1200,1300,1400,1500,1600,1700,1800,1900,2000,
     .	      2100,2200,2300,2400,2500,2600,2700,2800,2900,3000 ) query
	
* STATUS
* error status of last command
 100	CONTINUE
	qstatus = QSTAT_UNKNOWN_QUERY
	RETURN

* MESSAGE
* messages from last command
 200	CONTINUE
	qstatus = QSTAT_UNKNOWN_QUERY
	RETURN

* DSET
* list of open data sets
 300	DO 310 i = 1,  maxdsets
	   IF ( ds_name(i) .NE. char_init1024) THEN
	      slen = TM_LENSTR1(ds_name(i))
	      CALL CSTRING_INSERT( ds_name(i),
     .				slen, ctext, ntext, insert_pt)
	      IF ( insert_pt .GT. ntext ) THEN
	         qstatus = QSTAT_BUFF_OVFLOW
	         RETURN
	      ENDIF
	      num_strings = num_strings + 1
	   ENDIF
 310	CONTINUE
	RETURN

* VARIABLE dset
* return the variables in a data set
* ... identify the data set
 400	dset = FIND_DSET_NUMBER(farg1)
	IF ( dset .EQ. unspecified_int4 ) THEN
	   qstatus = QSTAT_INVALID_ARG
	   RETURN
	ENDIF
	DO 410 var = 1, maxvars
	   IF ( ds_var_setnum(var) .NE. dset ) GOTO 410
	   IF ( ds_var_code(var) .EQ. '-' ) GOTO 410
*	   slen = TM_LENSTR1(ds_var_code(var))
           CALL string_array_get_strlen1(ds_var_code_head,
     .                                    var,  slen)
	   CALL CSTRING_INSERT( ds_var_code(var),
     .				slen, ctext, ntext, insert_pt)
	   IF ( insert_pt .GT. ntext ) THEN
	      qstatus = QSTAT_BUFF_OVFLOW
	      RETURN
	   ENDIF
	   num_strings = num_strings + 1
 410	CONTINUE
	RETURN

* GRID dset variable
* 4-axis description of grid for given variable
* ... identify the data set, then variable, then its grid
 500	dset = FIND_DSET_NUMBER(farg1)
	IF ( dset .EQ. unspecified_int4 ) THEN
	   qstatus = QSTAT_INVALID_ARG
	   RETURN
	ENDIF
	CALL FIND_VAR_NAME( dset, farg2, cat, var )
	IF ( dset .EQ. unspecified_int4 ) THEN
	   qstatus = QSTAT_INVALID_ARG
	   RETURN
	ENDIF
	grid = IGRID ( dset, cat, var, status )
	IF ( grid.EQ.unspecified_int4 .OR. status.NE.ferr_ok) THEN
	   qstatus = -1 * status
	   RETURN
	ENDIF
* ... first return the grid name
	slen = TM_LENSTR1(grid_name(grid))
	CALL CSTRING_INSERT( grid_name(grid),
     .			     slen, ctext, ntext, insert_pt)
* ... then the 4 axis names
	DO 510 dim = 1, nferdims
	   axis = grid_line( dim, grid )
	   IF ( axis .EQ. munknown ) THEN
	      CALL CSTRING_INSERT( 'UNKNOWN',
     .				   7, ctext, ntext, insert_pt)
	   ELSEIF( axis .EQ. mnormal ) THEN
	      CALL CSTRING_INSERT( 'NORMAL',
     .				   6, ctext, ntext, insert_pt)
	   ELSE
	      slen = TM_LENSTR1(line_name(axis))
	      CALL CSTRING_INSERT( line_name(axis),
     .				   slen, ctext, ntext, insert_pt)
	   ENDIF
	   IF ( insert_pt .GT. ntext ) THEN
	      qstatus = QSTAT_BUFF_OVFLOW
	      RETURN
	   ENDIF
 510    CONTINUE
* ... then the 4 axis orientation codes
	DO 520 dim = 1, nferdims
	   axis = grid_line( dim, grid )
	   IF ( axis .EQ. munknown .OR. axis .EQ. mnormal ) THEN
	      CALL CSTRING_INSERT( '**',
     .				   2, ctext, ntext, insert_pt)
	   ELSE
	      CALL CSTRING_INSERT( line_direction(axis),
     .				   2, ctext, ntext, insert_pt)
	   ENDIF
	   IF ( insert_pt .GT. ntext ) THEN
	      qstatus = QSTAT_BUFF_OVFLOW
	      RETURN
	   ENDIF
 520    CONTINUE
	num_strings = 9	! 1 + 4 + 4
	RETURN

* AXIS  (args?)
 600	qstatus = QSTAT_UNKNOWN_QUERY
	RETURN

* COORDS axis
* coordinates of (irregular) axis
 700	CONTINUE

* TRANS  *************
* list of transforms
 800	CONTINUE
	qstatus = QSTAT_UNKNOWN_QUERY
	RETURN

* TRNARG (trans) ****will not be used!!*************
* argument description for given transform
 900	CONTINUE
* LVARS  *************
* list of LET-defined variables
 1000	CONTINUE

* DVARS (dset) *************
* list of LET-defined variables defined for data set
* ... identify the data set
*
* first attempt at an upgrade by JC (3/1/96)
*
 1100	dset = FIND_DSET_NUMBER(farg1)
	IF ( dset .EQ. unspecified_int4 ) THEN
	   qstatus = QSTAT_INVALID_ARG
	   RETURN
	ENDIF
*	DO 1110 var = 1, max_uvar
*           IF (uvar_num_items(var) .EQ. uvar_deleted  ) GOTO 1110
        CALL deleted_list_get_undel(uvar_num_items_head,
     .                              deleted_list_result(1),
     .                              max_uvar, num_indices )
        DO 1110 j = 1, num_indices
           var = deleted_list_result(j)
           IF (uvar_name_code(var)(1:3) .EQ. 'EX#'    ) GOTO 1110
           IF ( dset .NE. uvar_dset(var)         ) GOTO 1110
*           slen = TM_LENSTR1(uvar_name_code(var))
           CALL string_array_get_strlen1(uvar_name_code_head, var, slen)
	   CALL CSTRING_INSERT( uvar_name_code(var),
     .				slen, ctext, ntext, insert_pt)

	   IF ( insert_pt .GT. ntext ) THEN
	      qstatus = QSTAT_BUFF_OVFLOW
	      RETURN
	   ENDIF
	   num_strings = num_strings + 1
 1110	CONTINUE
	RETURN

* VBACKGROUND  (dset variable) *************
* background info about this variable
 1200	CONTINUE
* DBACKGROUND (dset) *************
* background info about this data set
 1300	CONTINUE
* WINDOWS  *************
* list of open windows
 1400	CONTINUE
* WCURRENT  *************
* name of current window
 1500	CONTINUE
* VPORTS  *************
* list of defined viewports
 1600	CONTINUE
* VCURRENT  *************o
* name of current viewport
 1700	CONTINUE
* VIEW  (vport) *************
* definition of indicated viewport
 1800	CONTINUE
	qstatus = QSTAT_UNKNOWN_QUERY
	RETURN

* DCURRENT
* name of current data set
 1900	DO 1910 dset = 1, maxdsets
           IF ( ds_name(dset) .EQ. char_init1024) GOTO 1910
	   IF ( dset .EQ. cx_data_set(cx_last) ) THEN
	      slen = TM_LENSTR1(ds_name(dset))
	      CALL CSTRING_INSERT( ds_name(dset),
     .				   slen, ctext, ntext, insert_pt)
	      num_strings = 1
	      RETURN
	   ENDIF
 1910	CONTINUE
* ... there is no current data set
	CALL CSTRING_INSERT( '*', 1, ctext, ntext, insert_pt)
	num_strings = 1
	RETURN

* SPAN  dset variable
* grid name and axis limits for a variable
 2000	dset = FIND_DSET_NUMBER(farg1)
	IF ( dset .EQ. unspecified_int4 ) THEN
	   qstatus = QSTAT_INVALID_ARG
	   RETURN
	ENDIF
	CALL FIND_VAR_NAME( dset, farg2, cat, var )
	IF ( dset .EQ. unspecified_int4 ) THEN
	   qstatus = QSTAT_INVALID_ARG
	   RETURN
	ENDIF
	grid = IGRID ( dset, cat, var, status )
	IF ( status .NE. ferr_ok ) THEN
	   qstatus = -1 * status
	   RETURN
	ENDIF
* ... first return the grid name
	slen = TM_LENSTR1(grid_name(grid))
	CALL CSTRING_INSERT( grid_name(grid),
     .			     slen, ctext, ntext, insert_pt)
* ... then the 4 axis spans
* ... loss,hiss,loww,hiww (all presented as floating point)
	DO 2010 dim = 1, nferdims
	   axis = grid_line( dim, grid )
	   i = (dim-1) * 4
	   IF ( axis .EQ. munknown
     .	   .OR. axis .EQ. mnormal  ) THEN
	      nums(i+1) = DBLE( unspecified_int4 ) 
	      nums(i+2) = DBLE( unspecified_int4 ) 
	      nums(i+3) = DBLE(bad_val4)
	      nums(i+4) = DBLE(bad_val4)
	   ELSE
! 4/4/96 - return grid limits rather than span limits (which are meaningful
!               only for file variables)
              nums(i+1) = 1.0D0
              nums(i+2) = DBLE(line_dim(axis))
              nums(i+3) = TM_WORLD( 1,
     .                              grid, dim, box_middle)
              nums(i+4) = TM_WORLD( line_dim(axis),
     .                              grid, dim, box_middle)
	   ENDIF
 2010    CONTINUE
	num_strings = 1
	num_vals = 16
	RETURN

* GAXIS grid orientation(1-4)
 2100	grid = TM_GET_GRIDNUM( farg1 )
	IF ( grid .EQ. unspecified_int4 ) THEN
	   qstatus = QSTAT_INVALID_ARG
	   RETURN
	ENDIF
* *kob* 4/97
#ifdef MANDATORY_FORMAT_WIDTHS
	READ( farg2,* ) dim
#else
	READ( farg2,'(I)' ) dim
#endif
	axis = grid_line(dim, grid)
* ... first return the axis title (units are appended already ...)
	IF ( axis .NE. mnormal ) THEN
	   buff1 = AX_TITLE(dim, grid, slen)
	ELSE
	   buff1 = notext
	   slen = 4
	ENDIF
	CALL CSTRING_INSERT( buff1,
     .			     slen, ctext, ntext, insert_pt)
* ... then the axis units
	IF ( axis .NE. mnormal ) THEN
	   buff1 = line_units(axis)
	   slen = TM_LENSTR1(buff1)
	ELSE
	   buff1 = notext
	   slen = 4
	ENDIF
	CALL CSTRING_INSERT( buff1,
     .			     slen, ctext, ntext, insert_pt)
* ... now return some flags:
	IF ( line_modulo(axis) ) THEN		! modulo ?
	   flags(1) = 1
	ELSE
	   flags(1) = 0
	ENDIF
	IF ( GEOG_LABEL( dim, grid ) ) THEN	! fancy labeling ?
	   flags(2) = 1
	ELSE
	   flags(2) = 0
	ENDIF
	IF ( line_regular(axis) ) THEN		! regular spacing ?
	   flags(3) = 1
	ELSE
	   flags(3) = 0
	ENDIF
	flags(4) = line_unit_code(axis)		! unit code
* ... some low:high:delta information
	nums(1) = DBLE( line_dim(axis) )
	nums(2) = line_start(axis)
	nums(3) = line_delta(axis)
	num_strings = 2
	num_vals = 3
* ... and finially special stuff for calendar axis formatting
	IF ( (dim.EQ.t_dim .OR. dim.EQ.f_dim) .AND. flags(2).EQ.1 ) THEN

*  See if we can find out the calendar, if grid/axis is known
	IF (grid .EQ. unspecified_int4  .AND.  
     .	    axis .EQ. unspecified_int4)  THEN 
	   cal_id = 1
	ELSE
	   IF (axis .EQ. unspecified_int4) axis = grid_line(dim, grid)
	   cal_id = TM_GET_CALENDAR_ID ( line_cal_name(axis) )
	ENDIF

	   nums(4) = SECS_FROM_BC( line_t0(axis), cal_id, status )
	   nums(5) = line_tunit(axis)
	ENDIF
	RETURN

* GCOORDS grid orientation(1-4)   offset   stride
* ... the variable num_valstoj will tell the number of values returned
 2200	grid = TM_GET_GRIDNUM( farg1 )
	IF ( grid .EQ. unspecified_int4 ) THEN
	   qstatus = QSTAT_INVALID_ARG
	   RETURN
	ENDIF
* *kob* 4/97 include axis...line in below ifdef just for simplicity
#ifdef MANDATORY_FORMAT_WIDTHS
	READ( farg2,* ) dim
	axis = grid_line(dim, grid)
	READ( farg3,* ) i2       ! offset
	READ( farg4,* ) stride
#else
	READ( farg2,'(I)' ) dim
	axis = grid_line(dim, grid)
	READ( farg3,'(I)' ) i2       ! offset
	READ( farg4,'(I)' ) stride
#endif
	i2 = i2 + 1
	num_strings = 0
	DO 2210 i = 1, nnums
	   IF ( i2 .GT. line_dim(axis) ) RETURN
	   nums( i ) = TM_WORLD( i2, grid, dim, box_middle)
	   num_vals = i
	   i2 = i2 + stride
 2210	CONTINUE
	RETURN

* SSPOINT grid orientation delta_index index
 2300	CONTINUE

* WWPOINT grid orientation delta_index coordinate
 2400	CONTINUE

* UVAR_DEFINITION dset variable
* text of the algebraic expression defining the variable
 2500	dset = FIND_DSET_NUMBER(farg1)
	IF ( dset .EQ. unspecified_int4 ) THEN
	   qstatus = QSTAT_INVALID_ARG
	   RETURN
	ENDIF
	CALL FIND_VAR_NAME( dset, farg2, cat, var )
	IF ( dset .EQ. unspecified_int4 ) THEN
	   qstatus = QSTAT_INVALID_ARG
	   RETURN
	ENDIF

* ... return the definition
	slen = TM_LENSTR1(uvar_text(var))
	CALL CSTRING_INSERT( uvar_text(var),
     .			     slen, ctext, ntext, insert_pt)
* ... the title
	slen = TM_LENSTR1(uvar_title(var))
	CALL CSTRING_INSERT( uvar_title(var),
     .			     slen, ctext, ntext, insert_pt)
* ... and the units
	slen = TM_LENSTR1(uvar_units(var))
	CALL CSTRING_INSERT( uvar_units(var),
     .			     slen, ctext, ntext, insert_pt)
	num_strings = 3
	RETURN


* ****  *************
 2600	CONTINUE
* ****  *************
 2700	CONTINUE
* ****  *************
 2800	CONTINUE
* ****  *************
 2900	CONTINUE
* ****  *************
 3000	CONTINUE
	qstatus = QSTAT_UNKNOWN_QUERY
	RETURN

	END

	SUBROUTINE XEQ_SET

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute the SET command

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 4/3/86
* revision 0.1 - 12/15/86 - implemented SET OUTPUT/FORMAT
* revision 0.2 - 3/20/87  - changes for new TMAP library
* revision 0.3 - 5/1/87   - added SET LIST/OUT/APPEND,
*			    SET MOVIE/OUT=file/APPEND title,
*			    SET REGION, SET EXPRESSION and 'SET what?' error
* revision 0.4 - 8/29/87  - added SET LIST/FORM=UNFORMATTED
* revision 0.5 - 9/9/87   - added SET LIST/FORM=BIBO
* revision 0.6 - 9/16/87  - added SET GRID (not implemented)
*			    moved unknown_qual_bad to FERRET.PARM
* revision 0.7 - 9/23/87  - condensed SET REGION via GET_NEW_cx
*			    and added SET LIST/HEAD
* revision 0.8 - 10/5/87  - revamped SET LIST logicals
* revision 0.9 - 10/22/87 - allowed SET DATA n
* revision 1.0 - 2/15/88  - parameters read from .DES files in SET DATA
* revision 1.1 - 3/18/88   - added list_tmap and SET MODE arguments
* revision 1.2 - 4/15/88   - added SET MODE/LAST
* revision 1.3 - 6/29/88 - allow SET LIST/FORMAT=GT equiv. to =TMAP
*			 - corrected READ (lun,*) bug in SET DATA Tname
*			 - added SET WINDOW
* revision 1.4 - 8/2/88  - added SET MODE WAIT
* revision 1.5 - 9/1/88  - added SET VIEWPORT
* revision 2.0 -11/17/88 - incorporated new TMAP library (handling time series)
* revision 2.1 - 1/10/89 - added SET MODE REJECT, corrected last_mode
* revision 2.2 - 2/16/89 - ds_open --> ds_name.EQ.char_init30 to test open-ness
* revision 2.3 - 2/17/89 - GT_CLOSE_SET --> TM_CLOSE_SET
* revision 2.4 - 4/1/89  - MODE WAIT directly sets PPLUS variable deflts
* V200:   9/1/89 - /FORMAT= code removed to EQUAL_FORMAT
*	10/13/89 - added /LASER option to movie stuff
*	10/23/89 - added SET DATA/EZ and SET VARIABLE
*	11/30/89 - added SET GRID (default for abstract variables)
*	 12/8/89 - added SET DATA/SAVE and /RESTORE
*	12/20/89 - added SET MODE Xwindows
*	  1/5/89 - added SET MODE metafile
*	  5/2/89 - changed code for SET REGION/DX = (bug in DEFINE REGION)
*	 6/11/90 - added CHECK_NEG_TAXIS to check for tstep<0
*	 8/31/90 - added SET MOVIE/START=#
* Unix/RISC port 4/25/91 *sh*: increased ds_name size
*                            : bug fix in SET MODE: mode_GKS --> pmode_GKS
* V230:  5/14/92 - REMOTE_X mode was replaced by the REFRESH mode
*         6/9/92 - MODE DIAGNOSTIC turns on TMAP diagnostics
*         6/?/92 - use list_fmt_type instead of list_unformatted
*        6/12/92 - added SET DATA/FORM=CDF
*        7/21/92 - /EZ optional if /FORMAT=unf or /FORMAT="()" given
*        7/23/92 - SET LIST to be case sensitive
*        8/25/92 - added SET AXIS/MODULO
*        1/14/93 - HDF movies: SET MOVIE/APPEND --> SET MOVIE/COMPRESS
* V300:  5/12/93 - file name args to SET MODE JOURNAL and SET MODE PPLLIST
*	 6/16/93 - mode GUI to open reply channel
* V301:  11/1/94 - bug: must open PLOT+ before MODE PPLLIST file is opened
*		   bug: buff2 enlarged (was 24) cuz ppllist name was truncated
*	 1/12/94 - SET MODE xxx pathname no longer requires quotes->"pathname"
*		   but SET MODE accepts only a single MODE at a time
*		   set mode meta will open PLOT+
*	 1/24/94 - turn on metafiles in DISP_INIT instead of here
*	           (resolve problem of metafiles created with wrong name)
*	 2/14/94 - fixed bug introduced 1/12/94 for SET MODE CAL:DAYS
*	 2/24/94 - incorporate a stack of past mode states
* V312: 5/94 - array "memory" as a calling argument
*	       added SET MEMORY mwords (and calling arg reconfig)
* V314: 8/26/94 *kob* IBM port : Logicalv var mode_state needs to be compared
*				 with NEQV instead of NE
* V320: 12/29/94 - use SPLIT_LIST to redirect tty output for GUI
*	 1/18/94 - added SET MODE VERIFY:ALWAYS
*	 1/29/95 - corrected error message about SET MEMORY/SIZE=
*	 2/28/95 - update TMAP COMMON alt_messages when mode_gui is SET
* V420:  9/27/95 - (for IBM/AIX compiler) eliminate READ(xxx,*) in SET DATA 
*Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
*	    4/97 *kob* - added ifdef for MANDATORY_FORMAT_WIDTHS on internal
*			 read because linux/nag f90 needed a format width.
*          12/98 *js* - Disallow set mem command is in secure mode
* V500:  4/28/99 *sh* - added SET AXIS/DEPTH 
*	    5/99 *sh* - implemented SET DATA/ORDER=
*	    8/99 *sh* - bug fix: adjust grid_use_count
* V510: 3/00 *sh* - remove check for negative values on time axis
*		  - add qualifier /TREGULAR to SET DATA for netCDF data sets
*	4/00 *sh* - documentation enhancement, only
* V530:10/00 *sh* - added FILE/FORMAT=delimited/TYPE=/DELIMITERS=
* V533 6/01 *sh* - bug fix "SET GRID" w/out arg didn't check for -111
* v540 *acm* 10/01 increase length of ds_name
* V542: *sh* 7/02 - added support for sub-span modulo axes
* V550: *acm*10/02- Change arg to char*24, to match longer region names (cx_name)
* v553: *kob* 8/03 - need to increase size of buff1 for long numeric dataset names
*       *kob* 9/03 - add ich for character indicies for the internal_read_format_bug
* V570: *acm* 5/04 - add MODE GRATICULE[:argument] 
*       *acm* 6/05 - add SET AXIS/CALENDAR /T0 /UNITS
* V581: *acm*/3/05 - increase length of strings for datset title to 1024 (leave settings alone for MOVIE)
* V600 *acm*  8/05 - Allow more digits in xrevision number
* V600 *acm* 3/06  fixing bugs 439&1390, new arg to get_new_cx.
* V600 *acm* 5/2006 MODE LINECOLORS User can change the number of line colors.
*      *jli* 7/2006 added 'implicit.parm' for pline_class_stride
*      *jli* added SET AXIS/STRIDE/OFFSET/
* V601 *acm*11/06 Fix bug 1470: on a SET AXIS command which redefines attributes of an axis, change
*                 values in the attribute structure for the axis.
* V601 *acm*11/06 Fix bug 1438: A request for rediculously large memory results in an
*                 overflow in setting reconfig, so it looks like a negative number of words 
*                 requested. This should result in an error message.
* V602: *acm* 1/07 Changes for metafile-batch mode: When in gif mode or batch mode, 
*                  ignore CANCEL MODE META
* V602  2/07 *acm* Fix bug 1492, changing attributes of coordinate variables
*                  including changes to an attributes values and settings at the
*                  same time, e.g. set att/output var.modulo = 300
* V603  5/07 *acm* Fix bug 1511: if DEFINE AXIS or DEFINE ATT change a time
*                  origin, include the origin in the units attribute as "since t0"
*                  If units attribute is changed for a time axis, get the time
*                  origin if it exists and append it to the units string.
* v604 *acm* 7/07 increase length of ds_name
* V606  8/07 *acm* Send informational and error messages that are returned from 
*                  commands via SPLIT_LIST to std error rather than std out.
* V610  *acm* 3/08 - add new MODE NLEVELS
* V610  *acm* 3/08 Fixes for metafile batch mode
* V613  *acm* 9/08 Correct for bug 1598: in SET ATTRIBUTE, initialize dataset number so a 
*                  SET ATT command always computes the dataset number.
* V63   *acm* 9/09 Fix bug 1689: definition of the offset in SET AXIS/STRIDE=/OFFSET
*                  changes so that /OFF=0 implies 1st index=1; /OFF=1 implies 
*                  1st index=2. Also check for and give err msg for illegal 
*                  values STRIDE < 1 and OFFSET < 0.
* V65   *acm* 2/10 Fix bug 1724: in metafile batch mode only, if some command
*                  has opened the metafile but nothing plotted yet, and if
*                  a SET MODE META:newname.plt is issued, just rename the metafile
*                  that was opened.
* V66   *acm* 3/10 Read qualifiers for netcdf4 SET LIST/NCFORMAT etc in call to
*                  netcdf4_set_list_settings
*       *kms* 5/10 add SET AXIS/REGULAR to force interpreting the axis as regular
*       *kms* 5/10 add SET REDIRECT /TEE /JOURNAL /FILE /APPEND /CLOBBER
*                  for stdout/stderr redirection
* V66   *kms* 5/10 LIB_GET_LUN is a subroutine, not a function
*       *kms* 2/11 return "mem_blk_size" instead of "mem_size" in reconfig
* V68   *acm* 1/12 Implement micro-adjusting of repeated coordinates (ticket 1910).
*                  To keep the previous behavior the user may specify USE/STRICT.
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction. 
*       *acm* 4/12 Add new MODE FOURDEE to allow E,F,M,N,etc as user-vars
*       *acm* 4/12 Remove MODE FOURDEE, using _E, _F, _M, _N instead, throughout.
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V6.8 *acm* 7/9/2012 For batch graphics on RHEL6, change ITS_BATCH_GRAPHICS
*                     from logical to integer, then batch = ITS_BATCH_GRAPHICS().NE.0
* V683 *acm*  8/12 add new SET LIST/OUTTYPE=  
* V685 *acm*  3/13 For Ensemble aggregations, call the ds_type 'ENS'
* V685 *acm*  7/13 Added FILE/FORMAT=descriptor
* V686 *acm*  1/14 Fix ticket 2126: set axis was messing up line_name storage
* V687 *acm*  3/14 New SET AXIS/NAME=
* V694 11/14 *acm* Ticket 2217: permuted ASCII reading in 6D (fix to an error message)
* V694 *acm*  2/15 ticket 2050: preserve case on var names for SET ATT/LIKE=var1 var2
* V698+ *sh*  11/15 to support TSERIES
*	      ok_re_use_existing into TM_INIT_DSET call
*	      SET DATA tseries_cmnds.agg gets passed to the GO command (a hack)
* V698  2/16 *acm* For ticket 2352: variables defined with LET/D are
*                  added to that dataset in the attribute structure.
* V698  4/16 *acm* For ticket 2399: Apply MODE CALENDAR settings to F axes too
* V7    5/16 *acm* See ticket 2352. For LET/D variables look for info under that dataset
* V7   *acm*  6/12 Add Union aggregations: DEFINE DATA/AGG/U, ds_type 'UNI'
* V701 *acm*  7/12 Ticket 2455: On a SET AXIS/NAME=, save the original spelling and 
*                  an up-cased spelling of the axis name, as is done with DEFINE AXIS.
* V710  4/16 *acm* new TM_UNITS_CAL to account for calendar in units id
* V702  3/17 *sh* added MODE FRUGAL
*		  Fixed bug in error message for invalid SET LIST/OUT
* V720 3/17 *acm* Fix ticket 2521; do not call TM_LEGAL_UNIX_NAME for path and 
*                file name on SET REDIRECT.
* V722 *kms* 10/17 Remove threddsBrowser (too big, outdated, and unused)
* V740 *acm* 2/18 Issue 966: LET/LIKE= requires changes to the call to INHERIT_ATTRS
* V74+ *acm* 5/18 Don't upcase the title given on a SET DATA/TITLE
* v741 5/18 *acm* Issue 1651 - "use my" will look for my.agg and run it as a script to
*                 initialize an aggregation. If given w/o .agg, a hack will look for it.
* v743  7/18 *acm Issue 1887, numeric dataset names w/o extension, better test 
*                 for whether it's just a digit, "use n".
* V74+ 6/18 *acm* Changes to the handling of USE/FEATURE=  
* v743  12/18 *acm* Issue 1803, New command-line switch -verify for set mode ver:always behavior
* v745 *acm* 12/18 Issue 1909, option to write dates in ISO8601 format
*                  new mode datefmt for formatted date output
* v7441*acm* 12/18 Issue 1910: Allow dates in commands to be in ISO 8601 form, yyyy-mm-dd-
* v751 *acm*  6/19 cleanup: remove code related to SET MOVIE 
* V751 *acm* 6/19 Issue 1903: memory set and reported in terms of bytes
* V751 *acm* 6/19  When setting a new DSG fmask, clear variables from memory
* v76  *acm* 11/19  Issue 1959: Change SET MEMORY/SIZE= to SET MEMORY/MAX= 
*                               (keep /SIZE for bkwds compatibility)
* V745 *acm*  5/20  added mode_dsg to control turning off all DSG ops

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'tmap_errors.parm'
        include 'implicit.parm'
#	include "tmap_dset.parm"
	include 'xdset_info.cmn_text'
	external xdset_info_data
        include 'xdiag_ctrl.cmn_text'
        include 'xtm_grid.cmn_text'
        external xgt_grid_data
        include 'xalt_messages.cmn_text'
	include	'ferret.parm'
	include	'slash.parm'
	include 'errmsg.parm'
	include 'gfdl_vms.parm'
	include 'plot_setup.parm'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xtext_info.cmn'
	include 'xrevision.cmn'
	include 'xtoday.cmn'
	include 'xvideo.cmn'
	include	'xfr_grid.cmn'
	include	'xcontrol.cmn'
	include	'pltcom_dat.decl'	! with gksopn
	include	'PLTCOM.DAT'		! with gksopn
	include 'gkscm2.cmn'		! with first_meta
	include	'switch_inc.decl'	! with deflts
	include	'SWITCH.INC'	! with deflts
        include 'LUNITS.INC'          ! with lttout
        include 'lunits_inc.decl'
	include 'xunits.cmn_text'
        include 'calendar.decl'
        include 'calendar.cmn'
        include 'netcdf.inc'    ! with NCCHAR
      
* calling argument declarations:
!	INTEGER	reconfig   ! removed for dynamic memory management 2/2017

* local variable declarations:
	LOGICAL		TM_DATE_OK, is_ok, set_dsg, reload
	INTEGER		REGION_NUMBER, VIEWPORT_NUMBER, GRID_FROM_NAME,
     .                  TM_GET_LINENUM, TM_LENSTR, TM_LENSTR1, 
     .                  TM_UNIT_ID, TM_UNITS_CAL, TM_GET_CALENDAR_ID,
     .			FIND_DSET_NUMBER, STR_UPCASE, STR_SAME, 
     .                  ITS_GIF_GRAPHICS, ITS_BATCH_GRAPHICS, ITS_BATCH_MODE, 
     .                  equal_pos, colon_pos, dset_num, ich, status,
     .			tmap_status, mode, idim, iarg, item, lp, iv, 
     .			cx, i, grid, axis, loc, perm(nferdims), buff_len, 
     .                  cal_id, day, month, year, hour, minute, second,
     .                  units, since_t0, len_test, len_mchars, slen, 
     .                  len, attype_spec, pos, mr, varid, uvar, cat, 
     .                  iflag, isetout, ivar, dot, strided_axis, igrd, 
     .                  offset, attid, attype, attoutflag, attlen, i1, 
     .                  dset, istat, cache_size, cache_nelems, 
     .                  cache_preemption, numpts, redir_file_lun, 
     .                  iline, iset, n, nopen
	INTEGER*8	i8_val
        REAL*8          TM_WW_AXLEN, GET_LINE_COORD, axwwlen, new_att_modulo_len
        REAL*8          delta, dlo, dhi, firstval, lastval
	REAL		val_buf, cache_size_mb
	CHARACTER	TM_FMT_TRIM*48, title*1024, subtitle*64, arg*24,
     .			buff1*512, buff2*512, data_form*3, show_str*12,
     .                  varname*512, attname*128, new_att_calendar*10, 
     .                  new_att_t0*128, new_att_units*128, buff3*512,
     .                  t0string*128, ustring*128, faccess*16, 
     .                  fposition*16, fstatus*16, c1*1, typflag*10, 
     .                  fmask_var*128
	LOGICAL		TM_LEGAL_UNIX_NAME, MATCH4, TM_DIGIT, 
     .                  TM_DIGIT_ONLY,
     .                  TM_HAS_STRING, TM_LEGAL_NAME, MATCH_NAME, TM_FPEQ,
     .                  NC_GET_ATTRIB, set_last, any_delta, dset_cdf,
     .                  do_ez, tregular, its_changed, ok_cal,
     .                  coordvar, new_att_modulo, batch, its_gif, 
     .                  got_it, redir_stdout, redir_stderr, redir_tee,
     .                  redir_journal, redir_append, redir_clobber, 
     .                  fexist, use_strict, is_nc, have_outtype, set_att_quiet

* local parameter declarations:
	INTEGER		slash_set_last
	PARAMETER     ( slash_set_last = 1 )
	LOGICAL		ok_re_use_existing
	PARAMETER     ( ok_re_use_existing = .TRUE.)

* functions
	LOGICAL is_secure

* initialize
!	reconfig = 0   	! zero signals NO memory reconfigure

* select subcommand
	GOTO ( 100,200,300,400,500,600,700,800,900,1000,
     .        1100,1200,1300,1400,1500,1600,1700 ) subcmnd_num

* SET '    ' 
* arrival at this point usually means an illegal subcommand was given
* and was assumed to be an argument by the command parser
 100	IF ( num_args .GE. 1 ) THEN
	   CALL ERRMSG( ferr_invalid_subcmnd,status,
     .				cmnd_buff( arg_start(1):arg_end(1) ), *5000 )
	ELSE
	   GOTO 5100
	ENDIF
	RETURN

* SET WINDOW
 200	IF ( interactive ) CALL SET_WINDOW( status )
	RETURN

* SET REGION/I=ilow:ihigh/J=..., ... [reg_name]
* completely replace "last" context if requested
 300	IF ( num_args .EQ. 1 ) THEN
	   arg = cmnd_buff(arg_start(1):arg_end(1))
	   cx = REGION_NUMBER( arg )
	   IF ( cx .EQ. unspecified_int4 ) CALL ERRMSG
     .					( ferr_unknown_arg, status, arg, *5000 )
	   CALL TRANSFER_CONTEXT( cx, cx_last )
	ENDIF

* start with the default context from the last command
	CALL GET_NEW_CX( cx_last, cx_buff, .TRUE., status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* apply delta context specifiers (DX=,DY=, etc) if any
	CALL GET_DELTA_CONTEXT( 14, any_delta, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	IF ( any_delta ) THEN
	   CALL APPLY_DELTA_CONTEXT( cx_buff, 'DEFAULT', status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	ENDIF

* illegal delta given ?
	DO 310 idim = 1, nferdims
 310	IF ( cx_given(idim,cx_buff)
     . .AND. cx_delta(idim,cx_buff) .NE. unspecified_val8 ) GOTO 5320

* wipe clean the history of the command defaults
	CALL FORGET_PAST_CONTEXT_MODS ( cx_buff )

* and since we completed with no errors - make it count
	CALL TRANSFER_CONTEXT ( cx_buff, cx_last )

	RETURN

* SET VIEWPORT
 400	IF ( num_args .EQ. 0 ) GOTO 5100
	item = 1
	iv = VIEWPORT_NUMBER( cmnd_buff(item_start(1):item_end(1)) )
	IF ( iv .EQ. unspecified_int4 ) GOTO 5020
	CALL SET_VIEWPORT( iv )
	RETURN

* SET EXPRESSION var_name1, var_name2, ...
 500	IF ( num_args .EQ. 0 ) GOTO 5100
	CALL DELETE_OLD_EXPR
	CALL BREAK_UP_EXPR( cmnd_buff( arg_start(1):len_cmnd ),
     .			    num_uvars_in_cmnd,
     .			    status )
	RETURN

* SET LIST
* ... SET LIST/PRECISION=#digits
 600	IF ( qual_given( slash_set_list_prec ) .GT. 0) THEN
	   lp = qual_given( slash_set_list_prec )	! list pos.
	   equal_pos = INDEX( cmnd_buff( qual_start(lp):qual_end(lp) ), '=' )
	   IF ( equal_pos .EQ. 0 ) THEN
	      list_digits = default_output_precision
	   ELSE
* syntax change 9/95 for IBM/AIX compatibility
	      buff1 = cmnd_buff( equal_pos+qual_start(lp):qual_end(lp) )
c *kob* 4/97
#ifdef MANDATORY_FORMAT_WIDTHS
	      READ ( buff1,*,ERR=5030 ) iv
#else
	      READ ( buff1,'(I)',ERR=5030 ) iv
#endif
	      list_digits = iv
	   ENDIF
	ENDIF
* ... SET LIST/HEADING
	IF ( qual_given( slash_set_list_heading ) .GT. 0 ) THEN
	   list_heading = .TRUE.
	ENDIF
* ... SET LIST/FILE=filename
        lp = qual_given( slash_set_list_out )
	IF ( lp .GT. 0 ) THEN
           CALL EQUAL_STR_LC( cmnd_buff(qual_start(lp):qual_end(lp)),
     .			      list_file, status )
           IF ( status .NE. ferr_ok ) RETURN
	   IF ( list_file .EQ. ' ' ) list_file = 'AUTO'
	ENDIF
* ... SET LIST/APPEND
	IF ( qual_given( slash_set_list_append ) .GT. 0 ) THEN
	   list_append = .TRUE.
	ENDIF
*  ... SET LIST/FORMAT=(FORTRAN_FORMAT), 'UNFORMATTED', 'BIBO', 'TMAP', 'GT'
	lp = qual_given( slash_set_list_form )
	IF ( lp .GT. 0 ) THEN
	   CALL EQUAL_FORMAT( cmnd_buff(qual_start(lp):qual_end(lp)), status )
	ENDIF

*  ... SET LIST/OUTTYPE=(netcdf type), 'DOUBLE', 'FLOAT', 'INT', 'SHORT', 'BYTE'
	lp = qual_given( slash_set_list_outtype )
	IF ( lp .GT. 0 ) THEN
	   CALL EQUAL_STRING(
     .                  cmnd_buff(qual_start(lp):qual_end(lp)),
     .                  list_outtype, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   have_outtype = ( INDEX(list_outtype,"DOU") .GT. 0 .OR.
     .                    INDEX(list_outtype,"FLO") .GT. 0 .OR. 
     .                    INDEX(list_outtype,"INT") .GT. 0 .OR.
     .                    INDEX(list_outtype,"SHO") .GT. 0 .OR.
     .                    INDEX(list_outtype,"BYT") .GT. 0 )
	   IF (.NOT. have_outtype) GOTO 6810
	ENDIF

* Get and save any settings for netcdf-4 output

        CALL NETCDF4_SET_LIST_SETTINGS (status)
        IF ( status .NE. ferr_ok ) GOTO 5000

	RETURN

* SET DATA_SET data_set1, data_set2, ...
 700    ds_dset_type = ' '

 	IF ( qual_given(slash_set_data_save) .GT. 0
     .	.OR. qual_given(slash_set_data_restore) .GT. 0 ) THEN
	   IF ( num_items.GT.0 .OR. num_qualifiers.GT.1 ) GOTO 5710
	   IF ( qual_given(slash_set_data_save) .GT. 0 )
     .					saved_dset = cx_data_set(cx_last)
	   IF ( qual_given(slash_set_data_restore) .GT. 0 ) 
     .					cx_data_set(cx_last) = saved_dset
	   RETURN
	ENDIF

* (hack) if the argument has a ".agg" extension, then pass it to the GO
* command, allowing "USE myAgg.agg" to initialize an aggregation

	IF (num_items .GT. 0 ) THEN
*   ... make sure that only a single .agg file is specified
           n = 0  ! number of arguments with .agg extension
	   DO item = 1, num_items
	      IF ((item_end(item)-item_start(item)) .GT. 3) THEN
	         IF (cmnd_buff(item_end(item)-3:item_end(item))
     .			.EQ. '.agg')  n = n + 1
	      ENDIF
	   ENDDO
	ENDIF
	IF (n .GT. 0) THEN		! at least 1 ".agg" file was given
	   IF (n.GT.1 .OR. num_items.GT.1) GOTO 5130
	   CALL XEQ_GO
	   RETURN
	ENDIF

* initialize an EZ data set
* ... EZ may be implicit in /FORMAT="unformatted" or "(f77 format)"
        loc = qual_given(slash_set_data_form )
        IF ( loc .GT. 0 ) THEN
           CALL EQUAL_STRING(
     .                   cmnd_buff(qual_start(loc):qual_end(loc)),
     .                   data_form, status )              
           IF ( status .NE. ferr_ok ) GOTO 5000
           do_ez = data_form(:3) .EQ. 'UNF'
     .       .OR.  data_form(:3) .EQ. 'FRE'
     .       .OR.  data_form(:3) .EQ. 'DEL'
     .       .OR.  ( INDEX( data_form, '(' ) .GT. 0 )
        ELSE
           do_ez = .FALSE.
        ENDIF
        do_ez = do_ez .OR. ( qual_given(slash_set_data_ez) .GT. 0 )
	IF ( do_ez ) THEN
	   IF ( num_items .EQ. 0 ) THEN
	      CALL INIT_EZ_DSET( ' ', dset_num, status )
	      IF ( status .NE. ferr_ok ) RETURN
	   ELSE
	     DO 710 item = 1, num_items
	      CALL INIT_EZ_DSET( cmnd_buff(item_start(item):item_end(item)), 
     .				 dset_num, status )
	      IF ( status .NE. ferr_ok ) RETURN
* ... dummy calls to make EZ sets act like other sets
	      CALL GET_AXIS_SPEED( dset_num )
 710	     CONTINUE
	   ENDIF
* ... make this data set current
	   cx_data_set( cx_last )	=  dset_num
	   RETURN
	ENDIF

* initialize all non-EZ data sets	
	IF ( num_items .EQ. 0 ) GOTO 5100
	IF ( qual_given(slash_set_data_var  ) .GT. 0 
     .  .OR. qual_given(slash_set_data_grid ) .GT. 0 
     .  .OR. qual_given(slash_set_data_skip ) .GT. 0 ) GOTO 5700

* interpret the /TREGULAR qualifier (force reg T axis) for netCDF data sets
        loc = qual_given(slash_set_data_tregular )
	tregular = loc .GT. 0

* interpret the /STRICT qualifier (do not micro-adjust axes with repeated 
* coordinates) for netCDF data sets
	use_strict = .FALSE.
        loc = qual_given(slash_set_data_strict )
	use_strict = loc .GT. 0


* SET DATA/FEATURE=  Set the DSG feature type
* Options are 
*   /feature=trajectory  must have lon, lat in the obs direction
*   /feature=profile     must have depth/height in the obs direction
*   /feature=timeseries  must have time in the obs direction
*   /feature=none        to ignore feature attributes and treat it as a regular gridded file.
* Code checks to see if it can be handled with the requested feature type.

* Initialize- set this flag only if this SET DATA is a SET DATA/FEATURE (If the set's already
* open, leave the setting as-is, we're just making this set the default.)

	dsg_user_direction = int4_init

	set_dsg = qual_given(slash_set_data_feature) .GT. 0
	IF (set_dsg) THEN
	   loc = qual_given(slash_set_data_feature)
	   CALL EQUAL_STRING(
     .          cmnd_buff(qual_start(loc):qual_end(loc)),
     .                    ustring, status )
	   IF (STR_SAME(ustring(1:3), 'tra') .EQ. 0) THEN
	      dsg_user_direction = x_dim ! arbitrarily
	   ELSE IF (STR_SAME(ustring(1:3), 'pro') .EQ. 0) THEN
	      dsg_user_direction = z_dim
	   ELSE IF (STR_SAME(ustring(1:3), 'tim') .EQ. 0) THEN
	      dsg_user_direction = t_dim
	   ELSE IF  (STR_SAME(ustring(1:3), 'non') .EQ. 0) THEN
	      dsg_user_direction = no_dim
	   ELSE
	      GOTO 6910
	   ENDIF
	ENDIF

	IF (set_dsg .AND. .NOT.mode_dsg) THEN
	   CALL WARN ('MODE DSG is turned off. Ingoring SET DATA/FEATURE=') 
	ENDIF

* interpret the /ORDER permutation qualifier for a non-EZ data set
	DO 720 idim = 1, nferdims
 720	perm(idim) = unspecified_int4 ! set default
        loc = qual_given(slash_set_data_order )
        IF ( loc .GT. 0 ) THEN
           CALL EQUAL_PERMUTE(
     .                   cmnd_buff(qual_start(loc):qual_end(loc)),
     .                   .FALSE., .FALSE., .TRUE., perm, status )
           IF ( status .NE. ferr_ok ) GOTO 5000
	ENDIF

	DO 750 item = 1, num_items

* check to see if data set was referred to by number
* 9/95 - replaced "*" with "(I)" read from separate buffer
* Just check the first character for a digit (ticket 1974)
	   c1 = cmnd_buff(item_start(item):item_start(item))
	   buff1 = cmnd_buff(item_start(item):item_end(item))
	   IF ( c1 .GE. '0' .AND. c1 .LE. '9' ) THEN
	      buff1 = cmnd_buff(item_start(item):item_end(item))
* *kob* 4/97
#ifdef INTERNAL_READ_FORMAT_BUG
* *kob* 9/03 kludge due to g77 internal read bug which does not correctly identify
*            a character and signal an error when doing an internal read into an
*            integer variable - e.g. 11111112_3.nc was being read as an integer so Ferret
*            was trying to find dataset 11111112 and reporting an error
* *acm* 7/18 Previous test using TM_DIGIT on each individual char, which decided
*            that 1979-2010 is a number, causing a crash just below on the READ. 

	      buff_len = TM_LENSTR(buff1)
              DO 730 ich = 1, buff_len
		c1 = buff1(ich:ich)
		IF ( ( c1.GE.'0' .AND. c1.LE.'9' )) THEN
		   CONTINUE
		ELSE
		   GOTO 740
		ENDIF
 730	      CONTINUE
	      READ (buff1,*) dset_num
#elif MANDATORY_FORMAT_WIDTHS
	      READ (buff1,*,ERR=740) dset_num
#else
	      READ (buff1,'(I)',ERR=740) dset_num
#endif
* ... check for valid number given 

	      IF   ( dset_num .LT. 1
     .	      .OR.   dset_num .GT. maxdsets
     .	      .OR.   dset_num .GT. max_gfdl_dsets )	        GOTO 5110
	      IF ( ds_name( dset_num ) .EQ. char_init2048) 	GOTO 5110
	      IF (dsg_user_direction .NE. int4_init) THEN
	         buff1 = ds_des_name(dset_num)
	         GOTO 740
	      ENDIF
	      GOTO 745
	   ENDIF

* no! it wasn't given by number so open the data set
* is this a designated special format?
 740       loc = qual_given(slash_set_data_form )
           IF ( loc .GT. 0 ) THEN
              
	      CALL EQUAL_STRING(
     .                   cmnd_buff(qual_start(loc):qual_end(loc)),
     .                   data_form, status )              
              IF ( status .NE. ferr_ok ) GOTO 5000
              dset_cdf = data_form .EQ. 'CDF'
              IF ( dset_cdf ) THEN
                 ds_dset_type = 'CDF'   ! used and cleared in tm_init_dset
              ELSEIF (data_form .EQ. 'DES') THEN
	         ds_dset_type = ' MC'
	      ELSE
	         GOTO 5710
	      ENDIF
           ENDIF

* initialize a TMAP-supported data set
           CALL TM_INIT_DSET( buff1,
     .			      ok_re_use_existing,
     .			      perm, dset_num, tregular, use_strict, 
     .			      mode_dsg, tmap_status )

* (hack, continued) If the argument is a file which has a ".agg" extension,
* merr_use_agg indicates we have found it even though they gave the 
* "use my_agg_script" without the .agg.

	   IF (tmap_status .EQ. merr_use_agg) THEN  ! .agg file
	      IF (num_items.GT.1) GOTO 5130

	      cmnd_buff(item_end(item)+1:) = '.agg'
	      item_end(item) = item_end(item) + 4
	      arg_end(item) = arg_end(item) + 4
	      CALL XEQ_GO
	      RETURN
	   ENDIF

	   IF ( tmap_status .EQ. merr_no_action ) THEN
	      GOTO 745					! already init'ed
	   ELSEIF ( tmap_status .NE. merr_ok )	  THEN
	      status = tmap_status
	      GOTO 5090					! error in .DES file
	   ENDIF

* determine relative access speeds along each axis
	   CALL GET_AXIS_SPEED( dset_num )

* check for negative time step values (warning, only)
! 3/00	   CALL CHECK_NEG_TAXIS( dset_num )

* make this data set current
 745	   cx_data_set( cx_last )	=  dset_num

* 10/01 allow /TITLE for NetCDF or DODS datasets.
*  5/18 Don't upcase the title given.
           IF (qual_given(slash_set_data_title) .GT. 0) THEN
              loc = qual_given(slash_set_data_title )
              CALL EQUAL_STR_LC(
     .                   cmnd_buff(qual_start(loc):qual_end(loc)),
     .                   title, status )
              IF ( status .NE. ferr_ok ) GOTO 5000
              ds_title(dset_num) = title
           ENDIF

* SET DATA/FMASK= for a dataset that's already open  
           IF (qual_given(slash_set_data_fmask) .GT. 0) THEN
	      loc = qual_given(slash_set_data_fmask)
	      CALL EQUAL_STRING (cmnd_buff(qual_start(loc):qual_end(loc)),
     .                        fmask_var, status)
	      IF (status .NE. ferr_ok) GOTO 5000

* ... eliminate all memory-resident user-defined vars and their uvar_grid 's
	      CALL PURGE_ALL_UVARS

	      DO mr = 1,max_mr_avail
	         IF ( mr_protected( mr ) .EQ. mr_deleted ) CYCLE
	         IF (mr_category(mr) .EQ. cat_user_var) CALL PURGE_ALL_UVARS_SUB( mr_variable(mr) )
	         CALL DELETE_VARIABLE( mr )
	      ENDDO

	      reload = .FALSE.
	      CALL LOAD_DSG_MASKVAR (dset_num, fmask_var, reload, status)
	      

           ENDIF

 750	CONTINUE

	RETURN
                

* error in descriptor not detected by GT_INIT_DSET
 790	CALL TM_CLOSE_SET( dset_num, tmap_status )
	RETURN

* SET MODE mode_name argument  (or mode_name:argument)
 800	set_last = qual_given( slash_set_last ) .GT. 0
	IF ( num_items .EQ. 0 ) GOTO 5100

* identify the specified mode to SET
* ... syntax can be SET MODE mode  or  SET MODE mode:arg  or  SET MODE mode arg
* ... since "arg" may contain "/" for a path name treat all text after the end
*     of the named mode as the argument  (modified this block 1/94)
	item = 1

	colon_pos = INDEX( cmnd_buff(item_start(1):item_end(1)), ':' )
	IF ( colon_pos .GT. 0 ) THEN
	   IF ( colon_pos .EQ. 1 ) GOTO 5010   ! colon as 1st character ???
	   buff1 = cmnd_buff( item_start(1):item_start(1)+colon_pos-2)
	   buff2 = cmnd_buff( item_start(1)+colon_pos:len_cmnd )
	ELSEIF ( arg_end(1) .EQ. len_cmnd ) THEN     ! no argument given
	   buff1 = cmnd_buff( item_start(1):item_end(1) )
	   buff2 = ' '
	ELSE
	   buff1 = cmnd_buff( item_start(1):item_end(1) )
	   buff2 = cmnd_buff( arg_end(1)+1:len_cmnd )
	ENDIF
	CALL LEFT_JUST( buff2, buff2, loc )
* ... remove surrounding quotation marks on argument, if any
	IF ( buff2(1:1) .EQ. '"' .AND. buff2(loc:loc) .EQ. '"'
     .	.AND. loc .GT.2 ) THEN
           buff2(loc:) = ' '
           buff2 = buff2(2:)
        ENDIF
* ... identify the mode name
        len_test = TM_LENSTR(buff1)
	DO 810 mode = 1, max_modes
           len_mchars = TM_LENSTR(mode_name(mode)(:4))
	   IF ( MATCH4( buff1, len_test,
     .               mode_name( mode ),len_mchars )) THEN
	      IF ( mode.EQ.pmode_GKS .AND. gksopn ) GOTO 5820
* ... ignore MODE VERIFY from a GO file if MODE VERIFY:ALWAYS is set
	      IF ( mode.EQ.pmode_verify
     .	     .AND. mode_arg(mode,1).EQ.mode_set_always
     .	     .AND. csp .GT. 0 ) GOTO 820
	      iarg = unspecified_int4
	      CALL GET_MODE_ARG( mode, buff2, iarg, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
* ... MODE DESPERATE is ignored as of V7.2
	      IF ( mode .EQ. pmode_desperate ) THEN	      
		 CALL WARN ('MODE DESPERATE is deprecated. Use MODE FRUGAL')
		 GOTO 820
	      ENDIF
	      IF ( set_last ) THEN
* ... pop the mode stack
	         DO 804 i = 2, mode_stack_size
	            mode_state(mode,i-1) = mode_state(mode,i) 
		    mode_arg  (mode,i-1) = mode_arg  (mode,i)
		    IF (mode .EQ. pmode_time_lab) 
     .		      mode_state(pmode_f_lab,i-1) = mode_state(pmode_time_lab,i)
 804	         CONTINUE
	      ELSE
* ... push the mode stack adding on a TRUE (because it's SET)
	         DO 806 i = mode_stack_size, 2, -1
	            mode_state(mode,i) = mode_state(mode,i-1) 
		    mode_arg  (mode,i) = mode_arg  (mode,i-1)
		    IF (mode .EQ. pmode_time_lab) 
     .		      mode_state(pmode_f_lab,i-1) = mode_state(pmode_time_lab,i)
 806	         CONTINUE
	         mode_state( mode, 1 ) = .TRUE.
	         IF ( iarg .NE. unspecified_int4 ) 
     .					mode_arg( mode,1 ) = iarg
	      ENDIF
* ... WAIT requires a string to communicate with PPLUS
	      IF ( mode .EQ. pmode_wait ) THEN
		 deflts(5) = mode_wait	! set PPLUS wait state
	         IF ( mode_wait ) THEN
	            ppl_wait = 'WAIT'
	         ELSE
	            ppl_wait = 'NOWAIT'
	         ENDIF
* ... when REJECT is changed transformed and regridded variables may be wrong
* *kob* mode_state needs to compared using NEQV because it is a logical 8/94
	      ELSEIF ( mode .EQ. pmode_reject
     .		    .AND. (mode_state(mode,1) .NEQV. mode_state(mode,2)) ) THEN
	         CALL DELETE_TRANSFORMED_VARS( status )
	         IF ( status .NE. ferr_ok ) RETURN
* ... mode REFRESH send a message to the gnu readline routine
	      ELSEIF ( mode .EQ. pmode_Xwindows ) THEN
	         CALL TM_SET_FREE_EVENT(1)
* ... mode metafile may require immediate communication with PPLUS
	      ELSEIF ( mode .EQ. pmode_metafile ) THEN
*     When in gif mode or batch mode, ignore SET MODE META
	         its_gif = ITS_GIF_GRAPHICS() .NE. 0
	         batch = ITS_BATCH_GRAPHICS() .NE. 0
                 IF ( its_gif ) THEN
                    CALL WARN ('in GIF mode: ignoring SET MODE METAFILE')
                    mode_metafile = .FALSE.
                 ELSE IF ( batch ) THEN
                    CALL GET_METAFILE_NAME(buff1)

                    CALL ECHOF_OFF
	  	    IF ( buff2 .NE. ' ' ) THEN
                       CALL PPLCMD
     .			( from, line, 0, 'PLTNME '//buff2, 1, 1 )
                    ELSE
                       CALL GET_METAFILE_NAME(ustring)
                       IF (STR_SAME(ustring,'dummy.plt') .EQ. 0) CALL PPLCMD
     .			( from, line, 0, 'PLTNME metafile.plt', 1, 1 )
                    ENDIF

                    IF ( gksopn .AND. first_meta) THEN
                       CALL PPLCMD ( from, line, 0, 'RENAMPL '//buff1, 1, 1 )
                    ENDIF

                    mode_metafile = .FALSE.

                 ELSE
 	            IF ( .NOT.pplus_started ) CALL START_PPLUS     ! 1/94
	  	    IF ( buff2 .NE. ' ' ) CALL PPLCMD
     .			( from, line, 0, 'PLTNME '//buff2, 1, 1 )
!	            CALL SEND_PLTYPE( mode_metafile )    ! done in DISP_INIT
                 ENDIF
* ... mode diagnostic sends message to TMAP library
	      ELSEIF ( mode .EQ. pmode_diagnostic ) THEN
	         tmap_diag_on = .TRUE.
* ... mode journal opens a journal file
	      ELSEIF ( mode .EQ. pmode_journal ) THEN
                 IF ( jrnl_lun .NE. unspecified_int4 )
     .                  CLOSE( UNIT=jrnl_lun, ERR = 5830 )
	         CALL INIT_JOURNAL( status )
                 IF ( status .NE. ferr_ok ) THEN
                    mode_journal = .FALSE.
		    GOTO 5840
	         ENDIF
* ... mode ppllist directs PLOT+ listings to a file
	      ELSEIF ( mode .EQ. pmode_ppllist ) THEN
	         IF ( .NOT.pplus_started ) CALL START_PPLUS
                 IF ( lttout .NE. 6 )
     .              CLOSE( UNIT=lttout, ERR = 5830 )
                 CALL LIB_GET_LUN( lttout )
                 OPEN ( FILE=ppllist_file,
     .                  UNIT=lttout,
     .                  STATUS='UNKNOWN',
     .                  ERR = 5850 )
* ... mode grat sets graticules on, and saves argument
              ELSEIF ( mode .EQ. pmode_grat ) THEN
	         grat_on = .TRUE.
                 mode_grat_buff = buff2

* ... mode linecolors sets the number of line colors on the next new window
* If there is no plot drawn yet, go ahead reset the number of colors now.
              ELSEIF ( mode .EQ. pmode_linecolors ) THEN

                 WRITE (show_str, 2000) mode_arg(pmode_linecolors, 1)
 2000            FORMAT (I3)
                 IF (no_plot_yet) THEN
                    CALL START_PPLUS
                    CALL PPLCMD (from, line, 0, 
     .                'LINECOLORS '//show_str(1:3)//' 1', 1, 1)
                    CALL DISP_RESET
                 ELSE
                    CALL PPLCMD (from, line, 0, 
     .                'LINECOLORS '//show_str(1:3)//' 0', 1, 1)
                    CALL WARN ('New # of line colors will take '//
     .                'effect on next new window: SET WIN/NEW then '//
     .                'define pen colors')
                 ENDIF

* ... mode nlevels sets the default number of contour intervals.
              ELSEIF ( mode .EQ. pmode_nlevels ) THEN
                 CALL SET_DEFAULT_NLEVELS( mode_arg(pmode_nlevels, 1) )

* ... mode shrink_ylab allows the y-axis label to automatically shrink
*     so it doesn't run off the page.
              ELSEIF ( mode .EQ. pmode_shrink_ylab ) THEN
	         CALL PPLCMD ( from, line, 0, 'SHRINKY 1', 1, 1 )

* ... Changes to mode calendar apply to F-direction as well as T.
              ELSEIF ( mode .EQ. pmode_time_lab ) THEN
	         ax_dec_pt(f_dim) = ax_dec_pt(t_dim)  
	         ax_fmt(f_dim) = ax_fmt(t_dim) 

* ... mode mode_datefmt sets the default output format for dates
              ELSEIF ( mode .EQ. pmode_datefmt ) THEN
                 date_fmt_out = mode_arg(pmode_datefmt, 1)

* ... mode dsg toggles use of DSG-specific enhancements
*     If mode_dsg was false, and datasets are open, all datasets must be
*     reinitialized.

              ELSEIF ( mode.EQ.pmode_dsg .AND. .NOT.mode_state(mode,2) ) THEN

* ... are any datasets open? They'll need to close them and reinitialize.
		 nopen = 0
		 DO iset = 1, maxdsets
		    IF ( ds_name(iset) .NE. char_init2048) nopen = nopen+1
		 ENDDO
		 IF (nopen.GT.0) GOTO 6920

		 mode_dsg = .TRUE.

	      ENDIF
	      GOTO 820
	   ENDIF
 810	CONTINUE
	   GOTO 5020
 820	RETURN

* SET MOVIE[/FILE=filename] [title]
* Movies are discontinued with Ferret v6.6: NetCDF-4 / HDF5

 900	GOTO 5086

* SET VARIABLE
 1000	IF ( num_items .NE. 1 ) GOTO 5100
	CALL SET_VAR( cmnd_buff(item_start(1):item_end(1)), status )
	RETURN

* SET GRID
* NOTE: for historical reasons mgrid_abstract is the name of the SET GRID
 1100	IF ( qual_given(slash_set_grid_save) .GT. 0 ) THEN
	   saved_abstract_grid = mgrid_abstract
	   RETURN
	ENDIF
	IF ( num_items .GT. 1 ) THEN
	   GOTO 5100
	ELSEIF ( num_items .EQ. 1 ) THEN
	   grid = GRID_FROM_NAME( cmnd_buff(item_start(1):item_end(1)),
     .			          cx_last, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	ELSEIF ( qual_given(slash_set_grid_restore) .GT. 0 ) THEN
	   IF ( saved_abstract_grid.EQ.unspecified_int4) GOTO 6110
	   grid = saved_abstract_grid
	ELSE
* ... set the grid from last command
	   cx = is_cx( 1 )
	   IF ( cx.EQ.0 .OR. cx.EQ.unspecified_int4 )	GOTO 5120
	   grid = cx_grid( cx )
	   IF ( grid .EQ. unspecified_int4 )	GOTO 5120
	ENDIF
* ... adjust the use count
	CALL TM_USE_DYN_GRID(grid)
	CALL TM_DEALLO_DYN_GRID(mgrid_abstract)
* ... eliminate all memory-resident user-defined vars and their uvar_grid 's
	CALL PURGE_ALL_UVARS
	mgrid_abstract = grid
	RETURN

* SET AXIS  /MODULO /DEPTH /CALENDAR /REGULAR /T0 /UNITS /OUTTYPE
 1200	axis = TM_GET_LINENUM( cmnd_buff(item_start(1):item_end(1)) )
        IF ( axis .EQ. unspecified_int4 ) GOTO 6210
* /MODULO
        new_att_modulo = .FALSE.
        new_att_modulo_len = 0.D0
	lp = qual_given(slash_set_axis_modulo)
	IF ( lp .GT. 0 ) THEN
	   CALL EQUAL_VAL( cmnd_buff(qual_start(lp):qual_end(lp)),
     .			      val_buf, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   IF (val_buf .EQ. unspecified_val4) THEN
	      val_buf = 0.0
	   ELSE
	      val_buf = ABS(val_buf)  ! ABS to tolerate negatives
	   ENDIF
	   
* Don't allow the modulo length be set longer than the axis length.

	   IF (val_buf .NE. 0.0) THEN
	      axwwlen = TM_WW_AXLEN(axis)

	      IF (.NOT.TM_FPEQ(axwwlen, val_buf) .AND. 
     .			   axwwlen .GT. val_buf) THEN
                 arg = TM_FMT_TRIM(val_buf, -2, 12, len)
                 show_str = TM_FMT_TRIM(axwwlen, -2, 12, slen)
                 buff1 = 'illegal modulo value '//arg(:len) //
     .             ' is less than axis length '//show_str(:slen)
		 buff_len = TM_LENSTR1(buff1)
	         GOTO 6220
	      ENDIF
	   ENDIF

	   its_changed = .NOT.line_modulo(axis)
     .		    .OR.  val_buf .NE. line_modulo_len(axis)
           line_modulo( axis ) = .TRUE.
	   line_modulo_len( axis ) = val_buf

           new_att_modulo = .TRUE.
           new_att_modulo_len = val_buf

* ... wipe memory clear of stored variables - this could change all definitions
*      ( could be more selective for efficiency by checking to see where this
*      axis gets used )
	   IF ( its_changed ) THEN
              DO 1210 i = 1,max_mr_avail
 1210         IF ( mr_protected( i ) .NE. mr_deleted ) 
     .                                CALL DELETE_VARIABLE( i )
           ENDIF
        ENDIF
* /DEPTH
	IF ( qual_given(slash_set_axis_depth) .GT. 0 ) THEN
           IF ( line_direction(axis) .EQ. 'DU' ) THEN
	      line_direction(axis) = 'UD'
           ENDIF
        ENDIF

* /OUTTYPE= INTYPE, DOUBLE, FLOAT, INT, SHORT, or NONE
	loc = qual_given(slash_set_axis_outtype )
	IF ( loc .GT. 0 ) THEN
           CALL EQUAL_STR_LC( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      buff1, status )
           IF ( status .NE. ferr_ok ) RETURN
           i = STR_UPCASE (typflag, buff1)

           IF (typflag(1:5) .EQ. 'INPUT'  ) THEN   ! input type
              line_dattype(axis) = 99  ! do not change from incoming type
           ELSE IF (typflag(1:3) .EQ. 'BYT' .OR. typflag(1:4) .EQ. 'INT1') THEN
              line_dattype(axis) = 1   ! NC_BYTE
           ELSE IF (typflag(1:3) .EQ. 'SHO' .OR. typflag(1:4) .EQ. 'INT2') THEN
              line_dattype(axis) = 3   ! NC_SHORT
           ELSE IF (typflag(1:3) .EQ. 'INT' .OR. typflag(1:4) .EQ. 'INT4') THEN
              line_dattype(axis) = 4   ! NC_INT (4-byte integer)
           ELSE IF (typflag(1:3) .EQ. 'FLO' .OR. typflag(1:3) .EQ. 'REA') THEN
              line_dattype(axis) = 5   ! NC_FLOAT
           ELSE IF (typflag(1:3) .EQ. 'DOU') THEN
              line_dattype(axis) = 6   ! NC_DOUBLE
           ELSE IF (typflag(1:3) .EQ. 'NON') THEN
              line_dattype(axis) = -1  ! Flag for no-write
           ELSE
              GOTO 6900
           ENDIF
	ENDIF

*/CALENDAR 
        new_att_calendar = ' '
	loc = qual_given(slash_set_axis_calendar) 
        IF (loc .GT. 0) THEN
           IF ( line_direction(axis) .EQ. 'TI' .OR. 
     .          line_direction(axis) .EQ. 'FI' ) THEN

	      CALL EQUAL_STRING(
     .                   cmnd_buff(qual_start(loc):qual_end(loc)),
     .                   buff1, status )
              IF ( status .NE. ferr_ok ) GOTO 6310

              ok_cal = .FALSE.

              IF (buff1(1:3) .EQ. '360') buff1 = '360_DAY' 
              IF (buff1(1:3) .EQ. 'STA') buff1 = 'GREGORIAN' 
              IF (buff1(1:3) .EQ. 'PRO') buff1 = 'GREGORIAN' 
              IF (buff1(1:3) .EQ. 'COM') buff1 = 'NOLEAP' 
              IF (buff1(1:3) .EQ. '365') buff1 = 'NOLEAP' 
              IF (buff1(1:3) .EQ. '366') buff1 = 'ALL_LEAP' 

              DO 1220 i = 1, mxcals
                 IF (buff1(1:3) .EQ. allowed_calendars(i)(1:3) ) THEN
                    ok_cal = .TRUE.
                    line_cal_name(axis) = allowed_calendars(i)
                 ENDIF
 1220         CONTINUE

              IF (.NOT. ok_cal) GOTO 6320
              new_att_calendar = line_cal_name(axis)

           ENDIF

        ENDIF

*  /REGULAR
        IF ( qual_given(slash_set_axis_regular) .GT. 0 ) THEN
           IF ( .NOT. line_regular(axis) ) THEN
*             ** Get first and last axis values (assumed to be valid)
*                and number of points **
              numpts = line_dim(axis)
              firstval = GET_LINE_COORD (linemem(axis)%ptr, 1)
              lastval = GET_LINE_COORD (linemem(axis)%ptr, numpts)
*             ** Free up memory used by the array of axis values **
              CALL FREE_DYN_MEM(linemem(axis)%ptr)
              CALL FREE_DYN_MEM(lineedg(axis)%ptr)
*             ** Assign values for a regular axis **
              line_start(axis) = firstval
              line_delta(axis) = (lastval - firstval) / (numpts - 1.0)
              line_regular(axis) = .TRUE.
              CALL WARN('Axis reset to be regular (evenly-spaced): '
     .                  //line_name(axis))
           ELSE
              CALL WARN('Axis is already regular: '//line_name(axis))
           ENDIF
        ENDIF

*  /T0 
        new_att_t0 = ' '
	loc = qual_given(slash_set_axis_t0) 
        IF (loc .GT. 0 ) THEN
           IF ( line_direction(axis)(1:1) .EQ. 'T' .OR.
     .          line_direction(axis)(1:1) .EQ. 'F' ) THEN

	      CALL EQUAL_STRING(
     .                cmnd_buff(qual_start(loc):qual_end(loc)),
     .                buff1, status )
              IF ( status .NE. ferr_ok ) GOTO 6410

              status = ferr_grid_definition       ! status setting if tm_date_ok false
              is_ok = TM_DATE_OK ( buff1 , 1) 
 
              IF ( is_ok  ) CALL TM_BREAK_DATE (buff1, 1, year, month, day,
     .				  hour, minute, second, status)

              IF ( status .NE. ferr_ok ) GOTO 6420
              line_t0(axis) = buff1
              new_att_t0 = buff1
              IF (line_direction(axis)(1:1) .EQ. 'T') 
     .          line_direction(axis) = 'TI'
              IF (line_direction(axis)(1:1) .EQ. 'F') 
     .          line_direction(axis) = 'FI'

           ENDIF

        ENDIF

* /NAME

	loc = qual_given(slash_set_axis_name) 
	IF (loc .GT. 0 ) THEN
	   IF ( num_args .EQ. 0 ) GOTO 6680

	   CALL EQUAL_STR_LC(
     .                   cmnd_buff(qual_start(loc):qual_end(loc)),
     .                   buff1, status )
	   IF ( status .NE. ferr_ok ) GOTO 6680

* check that the name isnt an already-defined axis

	   iline = TM_GET_LINENUM (buff1)
	   IF (iline .NE. unspecified_int4) GOTO 6690

	   IF ( .NOT.TM_LEGAL_NAME(buff1) ) GOTO 6692

* Replace the name in the linked-list structure.

          iset = pdset_coordvars  ! stored info on user-defined axes
          CALL CD_GET_VAR_ID (iset, cmnd_buff(item_start(1):item_end(1)), varid, status )
	  IF (varid .GT. 0) CALL CD_RENAME_VAR(iset, varid, buff1, status)

	   DO 1240 iset = 1, maxdsets
	      IF ( ds_name(iset) .EQ. char_init2048) GOTO 1240
	      CALL CD_GET_VAR_ID (iset, line_name(axis), varid, status )
              IF (varid .GT. 0) CALL CD_RENAME_VAR(iset, varid, buff1, status)
 1240	   CONTINUE

* Replace the name in Ferret's line storage.
	   line_name_orig(axis) = buff1
	   istat =  STR_UPCASE (buff1, buff1)
	   line_name(axis) = buff1

        ENDIF

*  /UNITS
* Note we do not change line direction with a resetting of units; line
* direction UD, DU, WE, SN stay as they were when they were input.

        new_att_units = ' '
	loc = qual_given(slash_set_axis_units) 
        IF (loc .GT. 0 ) THEN
           IF ( num_args .EQ. 0 ) GOTO 6410

	   CALL EQUAL_STR_LC(
     .                   cmnd_buff(qual_start(loc):qual_end(loc)),
     .                   buff1, status )
           IF ( status .NE. ferr_ok ) GOTO 6510

           since_T0 = MAX( INDEX(buff1,'since'), INDEX(buff1,'SINCE') )
           IF (since_T0 .GT. 0) GOTO 6520

           line_units(axis) = buff1
           new_att_units = buff1

* ... decode the units (code lifted from cd_get_1_axis)

           units = TM_UNIT_ID( line_units(axis) )

* Named calendar with unit=month or year gets length according to calendar's year length.

           cal_id = TM_GET_CALENDAR_ID (line_cal_name(axis))
           units = TM_UNITS_CAL( units, cal_id, .FALSE. )

           line_unit_code(axis) = units
           IF  ( units.EQ.0 .AND. line_units(axis) .NE. ' ' ) THEN
              CALL WARN ('Units  not recognized: '//line_units(axis))
              CALL WARN ('They will not be convertible:')
           ENDIF
           IF ( units .GE. 0 ) THEN
              line_tunit(axis) = real4_init
           ELSE
              line_tunit(axis) = un_convert(line_unit_code(axis))
           ENDIF

* See if we are resetting from a generic XX or YY axis to a geographic one.

           IF (line_direction(axis) .EQ. 'XX') THEN
              IF ( units .EQ. 4 .AND. 
     .              TM_HAS_STRING(line_units(axis), 'deg')
     .             .OR. TM_HAS_STRING(line_units(axis), 'lon') ) THEN 
                 line_direction(axis) = 'WE'

* Should we set axis to modulo?
                 axwwlen = TM_WW_AXLEN(axis)
                 IF ( axwwlen .LE. 360.D0 ) THEN
                    line_modulo(axis) = .TRUE.
                    IF (line_modulo_len(axis) .EQ. 0.0D0)
     .                    line_modulo_len(axis) = 360.D0
                 ENDIF

              ENDIF
           ENDIF

           IF (line_direction(axis) .EQ. 'YY') THEN
              IF ( units .EQ. 4 .AND. 
     .                  TM_HAS_STRING(line_units(axis), 'deg')
     .             .OR. TM_HAS_STRING(line_units(axis), 'lat') ) THEN 
                    line_direction(axis) = 'SN'
              ENDIF
           ENDIF

* recheck units and see if we are resetting from a geographic axis to a 
* non-geographic one or a calendar to non-calendar.

           IF (line_direction(axis) .EQ. 'WE' .OR. 
     .         line_direction(axis) .EQ. 'XX' ) THEN
              IF ( units .NE. 4 ) THEN 
                 line_direction(axis) = 'XX'
                 IF (units .LT. 0) THEN
                    CALL WARN ('Units  not recognized for X axis: '
     .                 //line_units(axis))
                    CALL WARN ('They will not be convertible')
                 ENDIF
              ENDIF
           ENDIF

           IF (line_direction(axis) .EQ. 'SN' .OR. 
     .         line_direction(axis) .EQ. 'YY' ) THEN
              IF ( units .NE. 4 ) THEN 
                 line_direction(axis) = 'YY'
                 IF (units .LT. 0) THEN
                    CALL WARN ('Units  not recognized for Y axis: '
     .                 //line_units(axis))
                    CALL WARN ('They will not be convertible')
                 ENDIF
              ENDIF
           ENDIF

           IF (line_direction(axis) .EQ. 'DU' .OR. 
     .         line_direction(axis) .EQ. 'UD' ) THEN
               IF (units .LT. 0) THEN
                 CALL WARN ('Units  not recognized for Z axis: '
     .                 //line_units(axis))
                 CALL WARN ('They will not be convertible')
              ENDIF
           ENDIF

           IF (line_direction(axis) .EQ. 'TI' .OR. 
     .         line_direction(axis) .EQ. 'TT' ) THEN
              IF ( units .GE. 0 ) THEN 
                 line_direction(axis) = 'TT'
                 CALL WARN ('Units  not recognized for T axis: '
     .                 //line_units(axis))
                 CALL WARN ('They will not be convertible')
              ENDIF
           ENDIF
           IF (line_direction(axis) .EQ. 'FI' .OR. 
     .         line_direction(axis) .EQ. 'FF' ) THEN
              IF ( units .GE. 0 ) THEN 
                 line_direction(axis) = 'FF'
                 CALL WARN ('Units  not recognized for F axis: '
     .                 //line_units(axis))
                 CALL WARN ('They will not be convertible')
              ENDIF
           ENDIF

        ENDIF  ! set axis/units

* Combine new attribute units and/or time origin to express the units
* attribute as units since time-origin

           IF (line_direction(axis)(1:1) .EQ. 'T' .OR. 
     .         line_direction(axis)(1:1) .EQ. 'F' ) THEN
              IF (new_att_units .NE. ' ') THEN
              i1 = TM_LENSTR1(new_att_units)
              new_att_units = new_att_units(1:i1)//' since ' 
     .            // new_att_t0
              IF (new_att_t0 .EQ. ' ') 
     .            new_att_units = new_att_units(1:i1)//' since ' 
     .            // line_t0(axis)
           ELSE
              IF (new_att_t0 .NE. ' ') THEN
                 i1 = TM_LENSTR1(line_units(axis))
                 new_att_units = line_units(axis)(1:i1)//' since ' 
     .            // new_att_t0
              ENDIF
           ENDIF
        ENDIF

*  /STRIDE and /OFFSET

        loc = qual_given(slash_set_axis_stride)
        IF (loc .GT. 0 ) THEN

*       Get the stride value
           IF ( loc .GT. 0 ) THEN
              CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .                     val_buf, status )
              IF ( status .NE. ferr_ok ) RETURN
           ELSE
              val_buf = 0
           ENDIF

* ...   STRIDE value must be positive
           delta = val_buf
           IF (delta .LT. 0) GOTO 6670  

* ...   If STRIDE value is 1 -- ignore the command.                    (II.2.c)
           IF( delta .EQ. 1) RETURN 

* ...   Elimate all cached memory                                     (II.1)
           CALL PURGE_ALL_MEMORY

* ...   Eliminate all memory-resident user-defined vars and their 
*       uvar_grid 's (II.1)
           CALL PURGE_ALL_UVARS
 
* ...   Check that it's legal to issue SET AXIS/STRIDE for this axis  (II.2.a)

*       not legal if this is a non-dynamic axis
           IF(axis .LE. max_lines) GOTO 6620           

*       not legal if it is a child axis already
           IF(line_parent(axis) .NE. 0) GOTO 6630

* ...   Check that the /stride and /offset values given are legal      (II.2.b)
           loc = qual_given(slash_set_axis_offset)
           IF (loc .GT. 0) THEN
              CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .                     val_buf, status )
              IF ( status .NE. ferr_ok ) RETURN
              offset = INT(val_buf)
           ELSE
              offset = 0
           ENDIF

* ...   offset must be less than the stride value
           IF(offset .GE. delta) GOTO 6640 
           IF(offset .LT. 0) GOTO 6660 

* ... Add 1 to the offset given by the user: SET AXIS/STRIDE= /OFFSET=0
* ... now means start with index=1; etc. Different from orig. implementaion
* ... which had /OFF=1 implies start with index=1.
           offset = offset + 1

* jli: is there a function to get the line orientation idim ?

           igrd=0
	   idim = 0
 6300      CALL TM_NEXT_DYN_GRID( igrd, *6399)
              DO 6301 i=1, nferdims
                 IF ( grid_line(i, igrd) .EQ. axis ) THEN
                    idim=i
                 ENDIF
 6301         CONTINUE
           GOTO 6300
 6399      CONTINUE

           IF (idim .EQ. 0) THEN
	      CALL WARN(
     .       'Axis not found in defined grids. Stride not applied')
              RETURN
           ENDIF

* ...   Check that this native axis is used only for variables from 
*       netCDF datasets                                                (II.3)  

*       loop through all dynamic grids

           igrd = 0
 6000      CALL TM_NEXT_DYN_GRID( igrd, *6099)
              IF ( grid_line(idim, igrd) .EQ. axis ) THEN
*       loop through all of the file variables
                 DO 6010 i = 1, maxvars
                    IF (ds_grid_number(i) .EQ. igrd) THEN 
		       is_nc = (ds_type(ds_var_setnum(i)).EQ.'CDF') .OR.
     .                         (ds_type(ds_var_setnum(i)).EQ.'ENS') .OR.
     .                         (ds_type(ds_var_setnum(i)).EQ.'FCT') .OR.
     .                         (ds_type(ds_var_setnum(i)).EQ.'UNI')
                       IF (.NOT. is_nc)  
     .                   GOTO 6088
                    ENDIF
 6010            CONTINUE
              ENDIF
           GOTO 6000
 6099      CONTINUE

* ...   Define the new strided axis                                    (II.4)

           dlo = offset      
           dhi = line_dim(axis)
 
           CALL TM_GET_LIKE_DYN_LINE( idim,
     .                                 dlo,
     .                                 dhi,
     .                                 delta,
     .                                 axis,   ! original axis
     .                                 pline_class_stride,
     .                                 strided_axis,  ! your new native-stride axis 
     .                                 status)
            IF ( status .NE. ferr_ok ) GOTO 6650

        line_offset(strided_axis) = offset

        line_reversed(strided_axis) = .FALSE.

*       Check if the native axis is reversed
        IF( (perm(idim) .LT. 0) .AND. 
     .      (perm(idim) .NE. unspecified_int4) ) THEN
            line_reversed(strided_axis) = .TRUE. 
        ENDIF

*       set modulo property
        IF(line_modulo(axis)) THEN
           IF(MOD(dhi,delta) .EQ. 0) THEN
              line_modulo(strided_axis) = .TRUE.
              line_modulo_len(strided_axis) = line_modulo_len(axis) 
           ELSE

              CALL WARN(
     . 'Stride value not an integer factor of axis length: '//
     . 'Axis loses modulo property')
           ENDIF
        ENDIF

* ...   Replace the original axis with the new dynamic axis in 
*       all grids where it is used                                      (II.5)

*       loop through all dynamic grids  

           igrd = 0

 6001      CALL TM_NEXT_DYN_GRID( igrd, *6199)
               IF ( grid_line(idim, igrd) .EQ. axis ) THEN
                  grid_line(idim,igrd) = strided_axis
                  CALL TM_USE_LINE(strided_axis)
*                   DO 6011 i = 1, maxvars
*                    IF(ds_grid_number(i) .EQ. igrd) THEN
*                        ds_grid_end(idim,i) = 18
*                    ENDIF
* 6011              CONTINUE
               ENDIF
           GOTO 6001        
 6199      CONTINUE
       ENDIF

* ... Check the attribute structure for this axis name and change 
*     attribute values as needed.

       buff2 = line_name(axis)
       CALL RESET_AX_ATT (buff2, new_att_units, 
     .           new_att_t0, new_att_calendar, new_att_modulo,
     .           new_att_modulo_len, line_direction(axis), 
     .           line_regular(axis) )

	RETURN

* SET MEMORY/MAX=megawords (Or equivalently the older SET MEMORY/SIZE=megawords)
* Optional units given as /MAX=xxKb /MAX=xxMb /MAX=xxGb, looking only at the first letter.

 1300	IF ( num_args .GT. 0 ) GOTO 5800
	if (is_secure()) then
	   CALL SPLIT_LIST(pttmode_help, err_lun,
     1	        'This command is not allowed in secure mode.', 0)
	   RETURN
	ENDIF

        lp = qual_given( slash_set_memory_max )
        IF (lp.EQ.0) lp = qual_given( slash_set_memory_words )
	IF ( lp .GT. 0 ) THEN
           CALL EQUAL_STRING( cmnd_buff(qual_start(lp):qual_end(lp)),
     .			      buff2, status )

           IF ( status .NE. ferr_ok ) RETURN
	ELSE
	   val_buf = max_mem_allowed / 1E6    ! retain current max
	   RETURN
	ENDIF

* Max size may be given in Kb, Mb, Gb, or if no units, in double=words

	IF (TM_LENSTR(buff2) .EQ. 0) GOTO 5803
	
	IF (INDEX(buff2, 'K') .GT. 0) THEN
	   slen = INDEX(buff2, 'K')
	   READ (buff2(:slen-1), *, err=5803) val_buf
	   val_buf = val_buf* 1.E3/ 8
	   i8_val = (val_buf*1.0000000001D0) 

	ELSE IF (INDEX(buff2, 'M') .GT. 0) THEN
	   slen = INDEX(buff2, 'M')
	   READ (buff2(:slen-1), *, err=5803) val_buf
	   val_buf = val_buf* 1.E6/ 8
	   i8_val = (val_buf*1.0000000001D0) 

	ELSE IF (INDEX(buff2, 'G') .GT. 0) THEN
	   slen = INDEX(buff2, 'G')
	   READ (buff2(:slen-1), *, err=5803) val_buf
	   val_buf = val_buf* 1.E9/ 8
	   i8_val = (val_buf*1.0000000001D0) 

	ELSE
	   READ (buff2, *, err=5803) val_buf
	   i8_val = (val_buf*1.0000000001D0) * 1000000  !  int tuncation issues ...
	ENDIF

	IF ( val_buf .LE. 0.0 ) GOTO 5805

* reset the memory max

	max_mem_allowed = i8_val 
	peak_mem = 0
	peak_essential_mem = 0

        RETURN

* SET ATTRIBUTE/TYPE= /DATASET= /OUTPUT[=] /LIKE= /QUIET
 1400 IF ( num_args .LT. 1 ) GOTO 5900
      CALL NAME_EQUAL_STRING_VATT ( buff1, pos, status )
      IF ( status .NE. ferr_ok )  GOTO 5000

* Initialize
      dset_num = unspecified_int4
      varname = ' '
      attname = ' '

      loc = qual_given( slash_set_attr_like ) 

*     Inherit all attributes from another variable (except missing flags and
*     scale and offset attributes).
*     Send dummy blank strings to inherit_attrs (needed for LET/LIKE= but not here).
* ... SET ATT/LIKE=var1 var2

      loc = qual_given( slash_set_attr_like ) 
      IF ( loc .GT. 0 ) THEN
	 CALL EQUAL_STR_LC ( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      buff2, status )
         new_att_units = ' '
         new_att_units = ' '
         CALL INHERIT_ATTRS (buff2, buff1, new_att_units, new_att_units, status)

         RETURN
      ENDIF


* ... SET ATT/OUTPUT varname.attname
* ... SET ATT/OUTPUT=all varname
* ... SET ATT/OUTPUT=default varname
* ... SET ATT/OUTPUT=none varname

      buff2 = ' '
      loc = qual_given( slash_set_attr_output ) 
      IF ( loc .GT. 0 ) THEN
	 CALL EQUAL_STRING( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      buff2, status )
         GOTO 1410
      ENDIF

      IF ( pos.EQ.0) GOTO 5100
      IF ( INDEX(buff1,'..') .EQ. 1 ) THEN
         ivar = 0  ! global attr.
	 varname = '.'
      ELSE
         IF ( .NOT.TM_LEGAL_NAME(buff1) ) GOTO 5100
      ENDIF

      set_att_quiet = qual_given( slash_set_attr_quiet ) .GT. 0

* SET ATRIBUTE/TYPE=  varname.attname
* types are: BYTE, CHAR or STRING, SHORT or INT2, INT or INT4, FLOAT, DOUBLE
* From netcdf.inc:
*   typedef enum {
*   	NC_NAT =	0,	/* NAT = 'Not A Type' (c.f. NaN) */
*   	NC_BYTE =	1,	/* signed 1 byte integer */
*   	NC_CHAR =	2,	/* ISO/ASCII character */
*   	NC_SHORT =	3,	/* signed 2 byte integer */
*   	NC_INT =	4,	/* signed 4 byte integer */
*   	NC_FLOAT =	5,	/* single precision floating point number */
*   	NC_DOUBLE =	6	/* double precision floating point number */
*   } nc_type;

      attype_spec = ptype_unknown
      loc = qual_given(slash_set_attr_type)
      IF ( loc .GT. 0 ) THEN
         CALL EQUAL_STRING(
     .      cmnd_buff(qual_start(loc):qual_end(loc)),
     .             buff2, status )
         IF ( status .NE. ferr_ok ) RETURN

         IF (buff2(1:4) .EQ. 'BYTE'  .OR.  
     .       buff2(1:4) .EQ. 'INT1') THEN
            attype_spec = ptype_int1
         ELSE IF (buff2(1:4) .EQ. 'SHOR' .OR. 
     .            buff2(1:4) .EQ. 'INT2') THEN
            attype_spec = ptype_int2
         ELSE IF (buff2(1:4) .EQ. 'INT4' .OR.
     .       (buff2(1:3) .EQ. 'INT' .AND. 
     .        TM_LENSTR(buff2) .EQ. 3) ) THEN
            attype_spec = ptype_int4
         ELSE IF (buff2(1:4) .EQ. 'FLOA') THEN
            attype_spec = ptype_float
         ELSE IF (buff2(1:4) .EQ. 'DOUB') THEN
            attype_spec = ptype_double
         ELSE IF (buff2(1:4) .EQ. 'STRI' .OR.  
     .            buff2(1:4) .EQ. 'CHAR') THEN
             attype_spec = ptype_string
         ENDIF
      ENDIF

* ... get dset number if present:  SET ATT/D=dset varname.attname
        dset_num = pdset_irrelevant
	loc = qual_given( slash_set_attr_dset ) 
        IF ( loc .GT. 0 ) THEN
	   CALL EQUAL_STRING( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      buff2, status )  
	   IF ( status .NE. ferr_ok ) RETURN
	   IF ( buff2 .NE. ' ' ) THEN
	      dset_num = FIND_DSET_NUMBER( buff2 )
	      IF ( dset_num .EQ. unspecified_int4) THEN
	         CALL WARN('Unknown data set: '
     .		 //buff2(:TM_LENSTR(buff2)))
	         RETURN
	      ENDIF
	   ENDIF
	ENDIF

* get dataset from varname.attname
* evaluate the context without computing the expression to get the dataset

 1410   CALL GET_NEW_CX( cx_last, cx_cmnd, .TRUE., status )
        IF ( status .NE. ferr_ok ) GOTO 5000
 
        IF (buff1(1:1) .EQ. '(') THEN
           dset_num = cx_data_set(cx_cmnd)   ! initial value to try; will return dset
           CALL ISIT_COORD_VAR ( buff1, dset_num, 
     .            varname, coordvar, status )
     
           IF ( status .NE. ferr_ok ) THEN 
              dset_num = pdset_coordvars  ! a user-defined axis (coordinate variable)
              CALL ISIT_COORD_VAR ( buff1, dset_num, varname, 
     .              coordvar, status )
              IF ( status .NE. ferr_ok ) THEN
                 dset = cx_data_set(cx_cmnd)
                 GOTO 5910
              ENDIF
           ENDIF

        ELSEIF (buff1(1:1) .EQ. '.') THEN
           dset_num = cx_data_set(cx_cmnd)   ! initial value to try; will return dset

        ELSE
* See if the variable is a user-defined variable.

           varname = buff1
           dot = INDEX(buff1,'.')
           IF (dot .GT. 0) varname = buff1(1:dot-1)
           CALL FIND_VAR_NAME(pdset_irrelevant, varname, cat, ivar)
           IF (  ivar .NE. munknown_var_name .AND.
     .           cat .EQ. cat_user_var) THEN
              dset_num = pdset_uvars

* It may be a let/d variable
              CALL CD_GET_VAR_ID (dset_num, varname, varid, status)
              IF (status.NE.ferr_ok) dset_num = unspecified_int4
           ENDIF
    
           IF (dset_num .EQ. pdset_irrelevant .OR. 
     .         dset_num .EQ. unspecified_int4) THEN
              CALL EVAL_CONTEXT ( cx_cmnd, buff1, status )
              IF ( status .NE. ferr_ok ) GOTO 5000
              cx = is_cx( 1 )
              dset_num = cx_data_set(cx) 
           ENDIF

	ENDIF

        IF (buff1(1:1) .EQ. '.') dset_num = cx_data_set(cx_cmnd)

        IF (dset_num .EQ. pdset_irrelevant) THEN
           dset_num = cx_data_set(cx_last) 
           cx = cx_last
        ENDIF

        IF (dset_num .EQ. unspecified_int4) dset_num = pdset_uvars ! user variables

* change an existing attribute output flag and/or value of the attr

        iflag = 0
        isetout = 0
        IF (qual_given( slash_set_attr_output ) .GT. 0) THEN
           iflag = 1
           isetout = 1
        ENDIF

* get the data for the new value
        
        IF (arg_start(1) .LT. pos) arg_start(1) = pos
        IF ( (iflag .EQ. 1 .AND. arg_end(1) .LT. len_cmnd) .OR. 
     .       (isetout .EQ. 0) ) THEN
           CALL GET_PROT_CMND_DATA (  cx_last, ptype_native, 
     .              status )
           IF ( status .NE. ferr_ok ) THEN      ! 8/6/92
              list_fmt_type = plist_default ! restore for next command
              list_format_given = .FALSE.
              RETURN
           ENDIF
        ENDIF

* Process SET ATT/OUTPUT=all varname, SET ATT/OUTPUT=default varname, SET ATT/OUTPUT=none varname
* flag = 0 output no attributes, 
*        1 check individual attribute output flags (default)
*        2 write all attributes
*        3 reset attr flags to Ferret netcdf defaults

        slen = TM_LENSTR(buff2)
        IF (slen .GT. 0) THEN
           iflag = 1
           IF (buff2(1:3) .EQ. 'NON') iflag = 0
           IF (buff2(1:3) .EQ. 'ALL') iflag = 2
           IF (buff2(1:3) .EQ. 'DEF') iflag = 3 
           IF (INDEX(varname,'.') .NE. 0) THEN 
              IF (iflag.EQ.0 .OR.iflag.EQ.2) GOTO 5930
           ENDIF
        ELSE
           iflag = 1  
        ENDIF

* break up varname.attname.  Check that varname is in the dset

        varid = 0

        CALL BREAK_VARNAME( buff1, dset_num, varname, attname, 
     .                         varid,  status )
        IF (status .NE. ferr_ok) goto 5910

        IF (varid .EQ. 0) CALL CD_GET_VAR_ID (dset_num, varname, varid,
     .       status )
        IF (status .NE. ferr_ok) goto 5910

* Changing the attribute output flag

        IF (qual_given( slash_set_attr_output ) .GT. 0) THEN

           CALL CD_SET_ATT_FLAG(dset_num, varid, attname, iflag, status)

* If it is the offset or scale attribute, set the output flag for both

           slen = TM_LENSTR1(attname)
           IF (MATCH_NAME (attname,  slen, 'ADD_OFFSET', 10) ) THEN
              CALL CD_SET_ATT_FLAG(dset_num, varid, 'ADD_OFFSET', 
     .               iflag, status)
              CALL CD_SET_ATT_FLAG(dset_num, varid, 'SCALE_FACTOR', 
     .               iflag, status)
           ENDIF

           IF (MATCH_NAME (attname,  slen, 'SCALE_FACTOR', 10) ) THEN
              CALL CD_SET_ATT_FLAG(dset_num, varid, 'ADD_OFFSET', 
     .               iflag, status)
              CALL CD_SET_ATT_FLAG(dset_num, varid, 'SCALE_FACTOR', 
     .               iflag, status)
           ENDIF

        ENDIF

* Change attribute value

        IF ( (iflag .EQ. 1 .AND. arg_end(1) .LT. len_cmnd) .OR.
     .       (isetout .EQ. 0) ) THEN 
           mr = is_mr( 1 )
           CALL EDIT_ATTRIBUTE(  memry(mr)%ptr, mr, 
     .               buff1, dset_num, attype_spec, set_att_quiet, status )
  
! errmsg already called in edit_attribute so just exit
           IF (status .NE. ferr_ok) GOTO 5000

* If the time origin was changed, also change units to say
* "units since time origin" using the new time origin info.
           
           axis = TM_GET_LINENUM( varname )
           IF (axis .NE. unspecified_int4) THEN
              slen = TM_LENSTR1(attname)
              IF ( MATCH_NAME (attname,  slen, 'TIME_ORIGIN', 11) .AND.
     .            ( line_direction(axis)(1:1) .EQ. 'T' .OR.
     .              line_direction(axis)(1:1) .EQ. 'F' ) ) THEN
                 CALL CD_GET_VAR_ATT_ID (dset_num, varid, 'UNITS', attid, status)
                 IF (status .NE. ferr_ok) GOTO 5950
   
                  got_it = NC_GET_ATTRIB ( dset_num, varid, 'time_origin',
     .                                      .TRUE., varname, 128,
     .                                         attlen, attoutflag, t0string, 
     .                                   val_buf )
                  got_it = NC_GET_ATTRIB ( dset_num, varid, 'units',
     .                                      .TRUE., varname, 128,
     .                                      attlen, attoutflag, ustring, 
     .                                      val_buf )
                  istat =  STR_UPCASE (buff2, ustring)
                  slen = INDEX(buff2, 'SINCE')
                  IF (slen .GT. 0) THEN
                     slen = slen - 2
                  ELSE
                     slen = TM_LENSTR1(ustring)
                  ENDIF
                  buff3 = ustring(1:slen) // ' since ' // t0string
                  attlen = TM_LENSTR1(buff3)
   
                  ustring = 'units'
                  CALL CD_REPLACE_ATTR (dset_num, varid, ustring, 
     .               NCCHAR, attlen, buff3, val_buf, status)
                  IF (status .NE. ferr_ok) GOTO 5000
               ENDIF

* If the units were changed on a time axis, add "since time origin"
           
              slen = TM_LENSTR1(attname)
              IF (MATCH_NAME (attname,  slen, 'units', 5)  .AND.
     .            ( line_direction(axis)(1:1) .EQ. 'T' .OR.
     .              line_direction(axis)(1:1) .EQ. 'F' ) ) THEN
                 CALL CD_GET_VAR_ATT_ID (dset_num, varid, 'time_origin', 
     .                 attid, status)
                 IF (status .EQ. ferr_ok) THEN 

                    got_it = NC_GET_ATTRIB ( dset_num, varid, 'time_origin',
     .                                      .TRUE., varname, 128,
     .                                      attlen, attoutflag, t0string, 
     .                                      val_buf )
                    got_it = NC_GET_ATTRIB ( dset_num, varid, 'units',
     .                                      .TRUE., varname, 128,
     .                                      attlen, attoutflag, ustring, 
     .                                      val_buf )
                    istat = STR_UPCASE (buff2, ustring)
                    slen = INDEX(buff2, 'SINCE')
                    IF (slen .GT. 0) THEN
                       slen = slen - 2
                    ELSE
                       slen = TM_LENSTR1(ustring)
                    ENDIF
                    buff3 = ustring(1:slen) // ' since ' // t0string
                    attlen = TM_LENSTR1(buff3)
   
                    CALL CD_REPLACE_ATTR (dset_num, varid, attname, 
     .                  NCCHAR, attlen, buff3, val_buf, status)
                    IF (status .NE. ferr_ok) GOTO 5000
                  ENDIF
               ENDIF
            ENDIF ! (axis .NE. unspecified_int4)

* Update attribute information used by plotting etc (ds_units, ...)
            CALL FIND_VAR_NAME (dset_num, varname, cat, uvar)
            IF (cat .EQ. cat_user_var .OR. cat .EQ. cat_file_var)
     .           CALL UPDATE_ATTRIBUTES (dset_num, varname, uvar, status)
            IF (status .NE. ferr_ok) GOTO 5940

        ENDIF
	RETURN

* SET NCCACHE/SIZE=bytes/cache_nelems/cache_preemption
 1500	IF ( num_args .GT. 0 ) GOTO 5200
        cache_size = -1
        cache_nelems = -1
        cache_preemption = -1

        lp = qual_given( slash_set_nccache_size )
	IF ( lp .GT. 0 ) THEN
           CALL EQUAL_VAL( cmnd_buff(qual_start(lp):qual_end(lp)),
     .			   cache_size_mb, status )
           IF ( status .NE. ferr_ok ) RETURN 
	   IF (cache_size_mb .LT. 0) GOTO 6700
	   cache_size = INT(cache_size_mb* 1.e6)  ! Mbytes to bytes

	ENDIF

        lp = qual_given( slash_set_nccache_nelem )
	IF ( lp .GT. 0 ) THEN
           CALL EQUAL_VAL_INT( cmnd_buff(qual_start(lp):qual_end(lp)),
     .			   cache_nelems, status )
           IF ( status .NE. ferr_ok ) RETURN 
	   IF (cache_nelems .LT. 0) GOTO 6710
	ENDIF

        lp = qual_given( slash_set_nccache_preemp )
	IF ( lp .GT. 0 ) THEN
           CALL EQUAL_VAL_INT( cmnd_buff(qual_start(lp):qual_end(lp)),
     .			   cache_preemption, status )
           IF ( status .NE. ferr_ok ) RETURN 
	   IF (cache_preemption.LT.0 .OR. 
     .         cache_preemption.GT.1) GOTO 6720
	ENDIF

        CALL CD_SET_CHUNK_CACHE (cache_size, cache_nelems, 
     .     cache_preemption, status)

	RETURN

* SET REDIRECT /TEE /JOURNAL /FILE= /APPEND /CLOBBER [stdout] [stderr]
 1600   redir_stdout = .FALSE.
        redir_stderr = .FALSE.
*
*       Determine all the sources to redirect
        IF ( num_args .GT. 0 ) THEN
           DO 1610 i = 1,num_args
              IF ( MATCH4( cmnd_buff(arg_start(i):arg_end(i) ), 
     .              arg_end(i) - arg_start(i) + 1, 'STDOUT', 6) ) THEN
*                Redirect stdout with these settings
                 redir_stdout = .TRUE.
              ELSE IF ( MATCH4( cmnd_buff(arg_start(i):arg_end(i) ), 
     .              arg_end(i) - arg_start(i) + 1, 'STDERR', 6) ) THEN
*                Redirect stderr with these settings
                 redir_stderr = .TRUE.
              ELSE
*                Unknown source to redirect
                 CALL ERRMSG( ferr_invalid_command, status, 
     .                   'unknown redirect source: ' //
     .                   cmnd_buff( arg_start(i):arg_end(i) ), *5000 )
              ENDIF
 1610      CONTINUE
        ELSE
*          Default: redirect stdout, but not stderr, with these settings
           redir_stdout = .TRUE.
        ENDIF
*
*       Make sure any the specified redirect sources are not already redirected
        IF ( redir_stdout .AND. 
     .       (redirect_stdout_flags .NE. redirect_none) ) THEN
           CALL ERRMSG( ferr_invalid_command, status, 
     .                  'stdout is already redirected', *5000)
        ENDIF
        IF ( redir_stderr .AND. 
     .       (redirect_stderr_flags .NE. redirect_none) ) THEN
           CALL ERRMSG( ferr_invalid_command, status, 
     .                  'stderr is already redirected', *5000)
        ENDIF
*
*       Process the qualifiers
        redir_tee = .FALSE.
        redir_journal = .FALSE.
        redir_append = .FALSE.
        redir_clobber = .FALSE.
*
*       /TEE
        lp = qual_given( slash_set_redirect_tee )
        IF ( lp .GT. 0 ) redir_tee = .TRUE.
*
*       /JOURNAL
        lp = qual_given( slash_set_redirect_journal )
        IF ( lp .GT. 0 ) redir_journal = .TRUE.
*
*       /APPEND
        lp = qual_given( slash_set_redirect_append )
        IF ( lp .GT. 0 ) redir_append = .TRUE.
*
*       /CLOBBER
        lp = qual_given( slash_set_redirect_clobber )
        IF ( lp .GT. 0 ) redir_clobber = .TRUE.
        IF ( redir_journal .AND. redir_clobber ) THEN
           CALL ERRMSG( ferr_invalid_command, status, 
     .             '/CLOBBER cannot be used with /JOURNAL', *5000 )
        ENDIF
*
*       /FILE=
        lp = qual_given( slash_set_redirect_file )
        IF ( lp .GT. 0 ) THEN
           IF ( redir_journal ) THEN
              CALL ERRMSG( ferr_invalid_command, status,
     .           'Only one of /JOURNAL or /FILE= can be given', *5000 )
           ENDIF
*
*          /FILE= was given; get the filename
           CALL EQUAL_STR_LC( cmnd_buff(qual_start(lp):qual_end(lp)),
     .                        title, status )
           IF ( status .NE. ferr_ok ) RETURN
           IF ( title .EQ. ' ' ) THEN
              CALL ERRMSG( ferr_invalid_command, status,
     .                     'SET REDIRECT /FILE= what name?', *5000 )
           ENDIF

c This check is not made for other file specifications e.g. writing data or graphics
c files, or opening datasets. (ticket 2521).
c           IF ( .NOT. TM_LEGAL_UNIX_NAME(title) ) THEN
c              CALL ERRMSG( ferr_invalid_command, status, 
c     .            'Illegal file name: ' // title, *5000 )
c           ENDIF
*
*          Open or create the file
           INQUIRE( FILE = title, EXIST = fexist )
           IF ( fexist ) THEN    
              IF ( redir_append ) THEN
#ifdef NO_ACCESS_APPEND
                 faccess = 'SEQUENTIAL'
#else
                 faccess = 'APPEND'
                 fposition = 'APPEND'
#endif
                 fstatus = 'OLD'
              ELSE IF ( redir_clobber ) THEN
                 faccess = 'SEQUENTIAL'
                 fstatus = 'REPLACE'
#ifdef F90_OPEN_FILE_CLOBBER
                 fposition = 'ASIS'
#endif
              ELSE
                 CALL ERRMSG( ferr_invalid_command, status,
     .                   'neither /CLOBBER nor /APPEND specified ' //
     .                   'and file exists: ' // title, *5000 )
              ENDIF
           ELSE
*             new file
              faccess = 'SEQUENTIAL'
              fstatus = 'NEW'
              fposition = 'ASIS'
           ENDIF
           CALL LIB_GET_LUN( redir_file_lun )
           OPEN( UNIT = redir_file_lun,
     .           FILE = title,
     .           FORM = 'FORMATTED',
#ifdef F90_OPEN_FILE_APPEND
     .           POSITION = fposition,
#else
     .           ACCESS = faccess,
#endif
     .           STATUS = fstatus,
     .           ERR    = 6800 )
*
*          Assign the file redirection variables
           IF ( redir_stdout ) THEN
              IF ( redir_tee ) THEN
                 redirect_stdout_flags = redirect_file_tee
              ELSE
                 redirect_stdout_flags = redirect_file
              ENDIF
              redirect_stdout_lun = redir_file_lun
           ENDIF
           IF ( redir_stderr ) THEN
              IF ( redir_tee ) THEN
                 redirect_stderr_flags = redirect_file_tee
              ELSE
                 redirect_stderr_flags = redirect_file
              ENDIF
              redirect_stderr_lun = redir_file_lun
           ENDIF
*
        ELSE IF ( redir_journal ) THEN
*
*          /JOURNAL was given - redirect to the journal
           IF ( redir_stdout ) THEN
              IF ( redir_tee ) THEN
                 redirect_stdout_flags = redirect_journal_tee
              ELSE
                 redirect_stdout_flags = redirect_journal
              ENDIF
*             Use the current jrnl_lun (in case it changes) when writing
              redirect_stdout_lun = -1
           ENDIF
           IF ( redir_stderr ) THEN
              IF ( redir_tee ) THEN
                 redirect_stderr_flags = redirect_journal_tee
              ELSE
                 redirect_stderr_flags = redirect_journal
              ENDIF
*             Use the current jrnl_lun (in case it changes) when writing
              redirect_stderr_lun = -1
           ENDIF
*
        ELSE
*
*          Neither /JOURNAL nor /FILE was given
           CALL ERRMSG( ferr_invalid_command, status, 
     .             'Either /JOURNAL or /FILE= must be given', *5000 )
        ENDIF
        RETURN
	
* SET GIFFILE
 1700	IF ( num_args .EQ. 0 ) GOTO 5100

* When not in gif mode, ignore SET GIFFILE
        its_gif = ITS_GIF_GRAPHICS() .NE. 0 
        IF ( .NOT. its_gif ) THEN
	   CALL WARN ('Not in GIF mode: ignoring SET GIFFILE')
        ELSE
	   slen = item_end(1) - item_start(1) + 1
	   i1 = ITS_BATCH_MODE()   ! batmode flag, zero because we are in gif mode.
	   CALL SAVE_METAFILE_NAME (cmnd_buff(item_start(1):item_end(1)),
     .              slen, i1)
	   CALL SAVE_FRAME_NAME (cmnd_buff(item_start(1):item_end(1)), slen)
        ENDIF
	RETURN

* error exits
 5000	RETURN
 5010	CALL ERRMSG( ferr_syntax, status,
     .			cmnd_buff( item_start(item):item_end(item) ), *5000 )
 5020	CALL ERRMSG( ferr_invalid_command, status,
     .			'Unknown argument:'//
     .			cmnd_buff( item_start(item):item_end(item) ), *5000 )
 5030	CALL ERRMSG( ferr_syntax, status,
     .			cmnd_buff( qual_start(lp):qual_end(lp) ), *5000 )
 5086	CALL ERRMSG( ferr_invalid_command, status, 
     .     'Movies are discontinued as of Ferret v6.6', *5000 )
 5090	CALL ERRMSG( ferr_TMAP_error, status, ' ', *5000 )
 5100	CALL ERRMSG( ferr_invalid_command, status, 
     .			'SET what?', *5000 )
 5110	CALL ERRMSG( ferr_unknown_data_set, status,
     .			cmnd_buff( item_start(item):item_end(item) ), *5000 )
 5120	CALL ERRMSG( ferr_unknown_grid, status, 
     .			'nothing saved from past commands', *5000 )
 5130	CALL ERRMSG( ferr_syntax, status,
     .		     'Only a single .agg file can be opened in a command'
     .		     //pCR//cmnd_buff(:len_cmnd), *5000 )
 5200	CALL ERRMSG( ferr_syntax, status,
     .		     'To set CACHE CHUNK size use SET CCACHE/SIZE=megabytes'
     .		     //pCR//cmnd_buff(:len_cmnd), *5000 )
 5210	CALL ERRMSG( ferr_syntax, status,
     .		     'To set CACHE CHUNK size use SET CCACHE/SIZE=megabytes'
     .		     //pCR//cmnd_buff(:len_cmnd), *5000 )
 5320	CALL ERRMSG( ferr_invalid_command, status,
     .			'delta value not permitted on SET REGION'//
     .			pCR//'check '//ww_dim_name(idim)//' axis', *5000 )
 5700	CALL ERRMSG( ferr_invalid_command, status,
     .			'qualifier(s) valid only with SET DATA/EZ command',
     .			*5000 )
 5710	CALL ERRMSG( ferr_invalid_command, status,
     .		     'illegal qualifier or argument'//pCR//cmnd_buff(:len_cmnd),
     .			*5000 )
 5720	CALL ERRMSG( ferr_invalid_command, status,
     .		     '/ORDER must be permutation of XYZTEF (with minus signs)'//
     .			pCR//cmnd_buff(:len_cmnd), *5000 )
 5800	CALL ERRMSG( ferr_syntax, status,
     .	 'To reconfigure use SET MEMORY/MAX=xxMb or /MAX=xxGb. If no units, Mb assumed'
     .		     //pCR//cmnd_buff(:len_cmnd), *5000 )
 5803	CALL ERRMSG( ferr_invalid_command, status,
     .		     'Unspecified or invalid SET MEMORY/MAX= value: '
     .		     //pCR//cmnd_buff(:len_cmnd), *5000)
 5805	CALL ERRMSG( ferr_invalid_command, status,
     .		     'Negative SET MEMORY/MAX= value: '
     .		     //pCR//cmnd_buff(:len_cmnd), *5000)
 5810	CALL ERRMSG( ferr_invalid_command, status,
     .		     'SET MODE REMOTE_X requires a node name argument',
     .			*5000 )
 5820	CALL ERRMSG( ferr_invalid_command, status,
     .		     'MODE GKS cannot be modified after the first GKS plot',
     .			*5000 )
 5830	CALL ERRMSG( ferr_erreq, status, 'Unable to close file', *5000 )
 5840	CALL ERRMSG( ferr_invalid_command, status,
     .		     'Unable to open journal file: '//journal_file,
     .			*5000 )
 5850	CALL ERRMSG( ferr_erreq, status, 
     .               'Unable to open '//ppllist_file,
     .			*5000 )
 6088   CALL ERRMSG( ferr_invalid_command, status,
     .           'it is not a netcdf dataset',
     .               *5000 )
 6110	CALL ERRMSG( ferr_invalid_command, status,
     .		     'no grid has been saved', *5000 )
 6210	CALL ERRMSG( ferr_invalid_command, status,
     .		 'unknown axis: '//cmnd_buff(item_start(1):item_end(1)),
     .               *5000 )
 6220	CALL ERRMSG( ferr_invalid_command, status,
     .		     buff1(:buff_len)//pCR//cmnd_buff(:len_cmnd),
     .               *5000 )
 6310	CALL ERRMSG( ferr_invalid_command, status,
     .	         'SET AXIS/CALENDAR=what? ', 
     .               *5000 )
 6320	CALL ERRMSG( ferr_invalid_command, status,
     .	         'invalid calendar name: '
     .           //cmnd_buff(item_start(1):item_end(1)), 
     .               *5000 )
 6410	CALL ERRMSG( ferr_invalid_command, status,
     .	         'SET AXIS/t0= what? ', 
     .               *5000 )
 6420	CALL ERRMSG( ferr_syntax, status,
     .	         'invalid date string: '//buff1, 
     .               *5000 )
 6510	CALL ERRMSG( ferr_invalid_command, status,
     .	         'SET AXIS/UNITS= what? ', 
     .               *5000 )
 6520	CALL ERRMSG( ferr_syntax, status,
     .	         'specify SET AXIS/T0 separately from /UNITS ',
     .               *5000 )
 6610   CALL ERRMSG( ferr_invalid_command, status,
     .           'SET AXIS/stride= what? ',
     .               *5000 )
 6620   CALL ERRMSG( ferr_invalid_command, status,
     .           'illegal operation for a non-dynamic axis',
     .               *5000 )
 6630   CALL ERRMSG( ferr_invalid_command, status,
     .           'it is a child axis already',
     .               *5000 )
 6640   CALL ERRMSG( ferr_invalid_command, status,
     .           'offset must be less than stride value',
     .               *5000 )
 6650   CALL ERRMSG( ferr_invalid_command, status,
     .           'fail to create a strided axis',
     .               *5000 )
 6660   CALL ERRMSG( ferr_invalid_command, status,
     .           'offset must be greater than or equal to zero',
     .               *5000 )
 6670   CALL ERRMSG( ferr_invalid_command, status,
     .           'stride must be greater than zero',
     .               *5000 )
     
 
 6680	CALL ERRMSG( ferr_invalid_command, status,
     .	         'SET AXIS/NAME= what? ', 
     .               *5000 )

 6690	CALL ERRMSG( ferr_invalid_command, status,
     .               'illegal new name. Axis '
     .			//buff1(:TM_LENSTR1(buff1))//' is already defined ',
     .                                                          *5000 )
 6692	CALL ERRMSG( ferr_invalid_command, status,
     .               'illegal new name given for axis '
     .			//buff1(:TM_LENSTR1(buff1)),
     .               						*5000 )
 
 
 5900 CALL ERRMSG( ferr_invalid_command, status,
     .		'SET what name.attribute?', *5000 )
 5910 slen = TM_LENSTR(buff1)
      CALL ERRMSG( ferr_invalid_command, status,
     .   'variable, axis, or attribute does not exist '//
     .    buff1(:slen), *5000 )
 5920 slen = TM_LENSTR(buff1)
      CALL ERRMSG( ferr_invalid_command, status,
     .   'attribute name missing. SET ATT varname.attname '//
     .    buff1(:slen), *5000 )
 5930 slen = TM_LENSTR(buff1)
      CALL ERRMSG( ferr_invalid_command, status,
     .   'SET ATT/OUT=[all or none] varname should NOT '//
     .   'include attribute. '//
     .    buff1(:slen), *5000 )
 5940 slen = TM_LENSTR(varname)
      CALL ERRMSG( ferr_invalid_command, status,
     .   'error editing attribute for'//
     .    varname(:slen), *5000 )
 5950 slen = TM_LENSTR(buff1)
      CALL ERRMSG( ferr_invalid_command, status,
     .   'cannot set T0 unless Units are also set'//
     .    buff1(:slen), *5000 )
 6700   CALL ERRMSG( ferr_invalid_command, status,
     .           'cache chunk size must be greater than zero',
     .               *5000 )
 6710   CALL ERRMSG( ferr_invalid_command, status,
     .           'cache nelems must be greater than zero',
     .               *5000 )
 6720   CALL ERRMSG( ferr_invalid_command, status,
     .           'cache preemption must be 0 or 1',
     .               *5000 )
 6800   CALL ERRMSG( ferr_erreq, status, title, *5000 )
 6810	CALL ERRMSG( ferr_invalid_command, status,
     .		'Unrecognized option/'//
     .          cmnd_buff(qual_start(lp):qual_end(lp)) //pCR//
     .	' Valid options are /OUTTYPE=DOUBLE,FLOAT,INT,SHORT,or BYTE', *5000 )
     
 6900	CALL ERRMSG( ferr_unknown_arg, status,
     .'Can SET AXIS/OUTTYPE=INPUT, DOUBLE, FLOAT, INT, SHORT, BYTE, or NONE',
     .               						*5000 )
     
 6910	CALL ERRMSG( ferr_unknown_arg, status,
     . 'Can SET DATA/FEATIRE=trajectory, profile, timeseries, or none',
     .               						*5000 )
     
 6920	CALL ERRMSG( ferr_invalid_command, status,
     .  'SET MODE DSG when datasets are open. '//
     .  'Must first CANCEL DATA/ALL.', *5000 )

	END

*
* status.F
*
* Jonathan Callahan
* Feb 19th 1998
*
* This function checks the input variable for bad data
* and returns 0 (no bad flags) or 1 (bad flags found)
*
* NB_ External functions need to have regions defined on
*     the arguments to have those regions used in the
*     external function calculation.  Regions defined
*     with SET REGION will not have the desired effect.
*
*     Use a command like:
*
*     let a = status(sst[x=180:160w,y=0:20n,l=1])
*


*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE status_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg



* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,'test for bad flags in data' )

      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance(id, NORMAL, 
     .     NORMAL, NORMAL, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, 'none')
      CALL ef_set_arg_desc(id, arg, 'data to be checked')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, YES)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE status_compute(id, arg_1, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

	  INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      print *, ' result lo limits', res_lo_ss
      print *, ' result hi limits', res_hi_ss

* We'll give the data the benefit of the doubt and assume that
* it's good unless we find out otherwise.

      DO 40 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
         DO 30 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            DO 20 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
               DO 10 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

                  result(i,j,k,l) = 0

 10            CONTINUE
 20         CONTINUE
 30      CONTINUE
 40   CONTINUE

*
* Note that we are looping on the argument subscripts rather than
* the result subscripts (the normal way).  That's because the result
* has axes which are normal and the loop count on those normal axes 
* will be one.
*
      i = res_lo_ss(X_AXIS)
      DO 400 i1=arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)

         j = res_lo_ss(Y_AXIS)
         DO 300 j1=arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)

            k = res_lo_ss(Z_AXIS)
            DO 200 k1=arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)

               l = res_lo_ss(T_AXIS)
               DO 100 l1=arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)

                  IF ( arg_1(i1,j1,k1,l1) .EQ. bad_flag(1) ) THEN

                     result(i,j,k,l) = 1

                  END IF

                  l = l + res_incr(T_AXIS)
                  
 100           CONTINUE

               k = k + res_incr(Z_AXIS)
 200        CONTINUE

            j = j + res_incr(Y_AXIS)
 300     CONTINUE

         i = i + res_incr(X_AXIS)
 400  CONTINUE
      
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	SUBROUTINE DEFINE_U_AGGREGATE_VAR (agg_dset, iset, nvars, vname, 
     .         fvar, itsa_uvar, nsets, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Save variable in the Union aggregation.  Check that the variable name
* is not already in the aggregation.

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - SDIG

* V7   5/12 *acm* Union aggregations: DEFINE DATA/AGG/U
* V710 *acm* 10/16 Ticket 2422: variables uvar_grid, uvar_data_type, uvar_aux_cat, 
*                  uvar_aux_var to be replaced with calls to LIST routines in NCF_Util.c 

      IMPLICIT NONE
        include 'tmap_errors.parm'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xdset_info.cd_equiv'
        include 'xprog_state.cmn'
	include 'xtm_grid.cmn_text'  
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xfr_grid.cmn'
	include 'interp_stack.parm'
	include 'netcdf.inc'

* calling argument declarations:
	LOGICAL itsa_uvar
	INTEGER agg_dset, iset, nvars, fvar, nsets, status
	CHARACTER*(*) vname

* local variable declarations:
	INTEGER STR_SAME, TM_LENSTR1, DIR_LINE,
     .		big_cx, idim, nv, nu, type, slen, igrid, vtype, 
     .		i, num_indices, varid, iline, imemb, itype
	INTEGER igrid_test
	CHARACTER*8 TM_FMT, fset

* Is this variable already in the union aggregation? If so, do not add it.

      CALL CD_GET_VAR_ID (agg_dset, vname, varid, status)
      IF (varid .GT. 0) GOTO 5100

* ds_var slot, fill with next variable in Union dataset.
      IF (.NOT. itsa_uvar) THEN
	DO 720 nv = 1, maxvars
	      IF ( STR_SAME(ds_var_code(nv),char_init) .EQ. 0 ) GOTO 725
 720	CONTINUE
 725	ds_var_setnum(nv)   = agg_dset
	CALL string_array_modify(ds_var_code_head, nv, 
     .         ds_var_code(fvar), LEN(ds_var_code(fvar)))
! ?? better: inherit these attibutes from members in SET_AGG_VAR_ATTS
	ds_var_title(nv)    = ds_var_title(fvar)
	IF ( ds_var_title(nv) .EQ. char_init128) 
     .       ds_var_title(nv)  = ds_var_code(fvar)
	ds_var_titl_mod(nv) = ds_var_titl_mod(fvar)
	ds_var_units(nv)    = ds_var_units(fvar)
	ds_missing_flag(nv) = ds_missing_flag(fvar)	! was bad_val4
	ds_bad_flag(nv)     = ds_bad_flag(fvar)		! was bad_val4
	ds_var_type(nv)     = ds_var_type(fvar)
	cd_scale_factor(nv) = 1.
	cd_add_offset(nv)   = 0.
	cd_scaled(nv)       = .FALSE.

	DO 730 idim = 1, nferdims
	   ds_grid_start(idim,nv)= ds_grid_start(idim,fvar)
	   ds_grid_end(idim,nv)  = ds_grid_end(idim,fvar)
	   ds_ordering(idim,nv)  = ds_ordering(idim,fvar)
 730	CONTINUE
	ds_grid_number(nv)       = ds_grid_number(fvar)
	
* Type should be NCFLOAT or NCCHAR
	IF (ds_var_type(nv) .EQ. ptype_string) THEN
	   type = NCCHAR
	ELSE
	   type = NCFLOAT
	ENDIF

* Add the aggregated variable to the linked list structure
	CALL CD_ADD_VAR( agg_dset, vname, nvars, ds_var_title(nv), 
     .         ds_var_units(nv), type, .FALSE., ds_bad_flag(nv), status)

* Store the dataset number of this variable.

	   igrid = ds_grid_number(nv)
	   vtype = cat_file_var
	   imemb = nvars
	   iline = unspecified_int4
	   
	   CALL CD_GET_VAR_ID (iset, vname, varid, status)
	   CALL CD_ADD_AGG_VAR_INFO (agg_dset, vname, imemb, 
     .          vtype, iset, igrid, iline, fvar, status)

      ELSE ! done with file vars

* User Variables
* ... optimize search using deleted_list_get_undel

	CALL deleted_list_get_undel(uvar_num_items_head,
     .                              deleted_list_result(1),
     .                              max_uvar, num_indices )
	DO i = 1, num_indices
	   nu = deleted_list_result(i)
	   IF ( uvar_num_items(nu) .EQ. uvar_deleted) CYCLE
	   IF ( (uvar_dset(nu) .EQ. iset) .AND. 
     .         (STR_SAME(uvar_name_code(nu), vname) .EQ. 0) ) THEN
	      vtype = cat_user_var
	      
	      DO 740 nv = 1, maxvars
	      IF ( STR_SAME(ds_var_code(nv),char_init) .EQ. 0 ) EXIT ! from loop
 740	      CONTINUE
	      ds_var_setnum(nv)   = agg_dset
c	      ds_var_code(nv)     = uvar_name_code(nu)
	      CALL string_array_modify(ds_var_code_head, nv, 
     .                            uvar_name_code(nu), LEN(uvar_name_code(nu)))
	      ds_var_title(nv)    = uvar_title(nu)
	      IF ( ds_var_title(nv) .EQ. char_init128) 
     .            ds_var_title(nv)  = uvar_text(nu)    
	      IF ( ds_var_title(nv) .EQ. ' ') 
     .            ds_var_title(nv)  = uvar_text(nu)     
	      ds_var_titl_mod(nv) = ' '
	      ds_var_units(nv)    = uvar_units(nu)
	      ds_missing_flag(nv) = uvar_bad_data(nu)
	      ds_bad_flag(nv)     = uvar_bad_data(nu)

	      cd_scale_factor(nv) = 1.
	      cd_add_offset(nv)   = 0.
	      cd_scaled(nv)       = .FALSE.

	      CALL GET_UVAR_GRID( nu, iset, status )
	      CALL GET_SAVED_UVAR_GRID(nu, iset, igrid)

	      ds_grid_number(nv) = igrid
	      DO idim = 1, nferdims
	         iline = grid_line( idim, igrid )
	         ds_grid_start(idim,nv)= 1
	         ds_grid_end(idim,nv)  = line_dim(iline)
	         ds_ordering(idim,nv)  = DIR_LINE(line_direction(iline))
	      ENDDO
* Type  ??
	      
	      CALL GET_SAVED_UVAR_DTYPE(nu, iset, itype)
	      IF (itype .EQ. unspecified_int4) itype = ptype_unknown
	      ds_var_type(nv)  = itype

	      IF (ds_var_type(nv) .EQ. ptype_string) THEN
	         type = NCCHAR
	      ELSE
	         type = NCFLOAT
	      ENDIF

* Hook the aggregated variable into the linked list structures
	      CALL CD_ADD_VAR( agg_dset, vname, nvars, uvar_title(nu), 
     .         uvar_units(nu), type, .FALSE., uvar_bad_data(nu), status)

* Store the info of this variable. The member dataset stored is the 
* LET/D= datset where it was defined.

	      CALL GET_UVAR_GRID( nu, iset, status )
	      CALL GET_SAVED_UVAR_GRID(nu, iset, igrid)
	      vtype = cat_user_var
	      imemb = nvars
	      iline = unspecified_int4
	      
	      CALL CD_ADD_AGG_VAR_INFO (agg_dset, vname, imemb, 
     .          vtype, iset, igrid, iline, nu, status)

* ... bump the use count for this grid to protect it from being deleted if
*     the user changes the LET/D definition -- grid is needed during the
*     gather process (IS_STRIP & IS_AGGREGATE_GATHER).
*  ==> be sure to un-use (deallo) it when the aggregation gets canceled
*  ==> or if an error occurs prior to the complete initialization of this agg
	      CALL TM_USE_DYN_GRID(igrid)
	      EXIT
	   ENDIF
	ENDDO

	ENDIF  ! itsa_uvar 

 5000	RETURN
 5100	fset = TM_FMT(FLOAT(iset), 5, 8, slen)
	CALL WARN('Variable '//vname(:TM_LENSTR1(vname))//
     .		' from dataset '//fset(:slen)//
     .		' is already in the union dataset. Skipping it')
	nvars = nvars - 1
	status = ferr_ok
	RETURN
	END

*
* str_mask.F
*
* Ansley Manke 08/2013
*
* This function takes a string variable and mask on the same axis.
* and returns the variable containing the strings where the mask is
* a valid value and a null string where the mask is bad-value
*

*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE str_mask_init(id)

      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

      CALL ef_version_test(ef_version)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id, 
     . 'Returns a variable expanded by the lengths given in arg 2' )
      CALL ef_set_num_args(id, 3)
      CALL ef_set_axis_inheritance_6d(id, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_result_type(id, STRING_RETURN)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'STRING')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg,'string variable to mask')
      CALL ef_set_axis_influence_6d(id, arg, YES, YES, YES, YES, YES, YES)
      CALL ef_set_arg_type (id, arg, STRING_ARG)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'MASK')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 
     .     'valid value where string is to be returned')
      CALL ef_set_axis_influence_6d(id, arg, YES, YES, YES, YES, YES, YES)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE str_mask_compute(id, arg_1, arg_2, result)

      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif


      INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(strdf,
     .           mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit, 
     .           mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, 
     .           mem2loz:mem2hiz, mem2lot:mem2hit, 
     .           mem2loe:mem2hie, mem2lof:mem2hif)
      REAL result(strdf, 
     .            memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshiz, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(6), res_hi_ss(6), res_incr(6)
      INTEGER arg_lo_ss(6,1:EF_MAX_ARGS), arg_hi_ss(6,1:EF_MAX_ARGS),
     .     arg_incr(6,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l,m,n
      INTEGER slen
      CHARACTER*100 errtxt
      CHARACTER*2048 buff
      CHARACTER*1  null
      REAL str_mask

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)
      
      null = ''

* Put the requested features into the result

      DO 200 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
      DO 200 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
      DO 200 l = res_lo_ss(Z_AXIS), res_hi_ss(T_AXIS)
      DO 200 k = res_lo_ss(T_AXIS), res_hi_ss(Z_AXIS)
      DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
      DO 200 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

	 IF ( arg_2(i,j,k,l,m,n) .NE. bad_flag(2) ) THEN
            CALL ef_get_string_arg_element_6d(id, ARG1, arg_1, 
     .                      i,j,k,l,m,n, slen, buff)
            CALL EF_PUT_STRING(buff, slen, result(1,i,j,k,l,m,n))
	 ELSE
            CALL EF_PUT_STRING(null, 1, result(1,i,j,k,l,m,n))
         ENDIF  ! arg_2 good

 200  CONTINUE

 300  CONTINUE
      
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
 9000 CALL EF_BAIL_OUT(id, errtxt)
      END

	LOGICAL FUNCTION ITS_FMRC_2DTIME (dset, fvar)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Return boolean indicating whether the passed variable is in fact
* the 2D FMRC time matrix of the dataset

* V698 2/16 *sh*

      IMPLICIT NONE
#include "tmap_dset.parm"
!#include "gt_lib.parm"     ! str_match
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'xdset_info.cmn_text'
	include 'xdset_info.cd_equiv'
	include 'xtm_grid.cmn_text'

* calling argument declarations:
	INTEGER dset, fvar

* local variable declarations:
	LOGICAL NC_GET_ATTRIB, got_it
	INTEGER STR_CASE_BLIND_COMPARE, grid, vid, istat, status

	INTEGER str_match
        PARAMETER (str_match = 0)

* Getting info back from the attribute-handling structure
        INTEGER maxlen
        PARAMETER (maxlen = 128)
	CHARACTER*(maxlen) buff
	INTEGER varid, t2did, tline, g2d, globalid, ref_id, attlen,
     .		attype, attoutflag
        REAL    attvals(10)

* initialize
	grid = ds_grid_number(fvar)
* just in case this gets called with an inappropriate variable
        IF ( grid .EQ. int4_init ) GOTO 2000

* it must be 2D in the TF plane
	IF (grid_line(x_dim,grid) .NE. mnormal
     . .OR. grid_line(y_dim,grid) .NE. mnormal
     . .OR. grid_line(z_dim,grid) .NE. mnormal
     . .OR. grid_line(e_dim,grid) .NE. mnormal ) GOTO 2000
	IF (grid_line(t_dim,grid) .EQ. mnormal
     . .OR. grid_line(f_dim,grid) .EQ. mnormal ) GOTO 2000

* it must have a _CoordinateAxisType='Time' attribute
* ... get the List id of the variable
        CALL CD_GET_VAR_ID (dset, ds_var_code(fvar), vid, status)
        IF (status .NE. ferr_ok) GOTO 5100
* ... get the attribute val
        got_it = NC_GET_ATTRIB ( dset, vid, '_CoordinateAxisType',
     .                              .TRUE., ds_var_code(fvar), maxlen,
     .                              attlen, attoutflag, buff, attvals )
	IF (.NOT.got_it) GOTO 2000
	istat = STR_CASE_BLIND_COMPARE(buff, 'time')

* final test
        ITS_FMRC_2DTIME = istat .EQ. str_match
	RETURN

* nope - this aint it
 2000	ITS_FMRC_2DTIME = .FALSE.
	RETURN

* error bail out
 5000	RETURN
 5100	CALL ERRMSG(ferr_internal, status, 'its_fmrc_2dtime!',
     .		 *5000)     ! error not trapped
	END

	SUBROUTINE XEQ_FRAME

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute the FRAME command
* make a movie frame of the current output graphics

* FRAME/FILM	- to trigger actual movie frame
* FRAME/BITMAP	- to store the current workstation screen contents

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 5/7/87
* V200:  11/14/89 - guts moved to SAVE_FRAME - laser output, too
* V320: 5/94 - array "memory" as a calling argument
* 	8/94 - added qualifiers /FORMAT and /FRAME to permit direct capture
*		of GIF images
* V320: 1/95 - use gif_frame routine for both HDF and GIF
*	call TM_PARK_LAST_VERSION for names
* V500: 4/99 *sh* increased filename string length from 128 to 255
* V602: *acm* 1/07 Changes for metafile-batch mode: Ignore FRAME in 
*                  batch mode, except when in batch GIF mode.
* V6.2  *acm* 5/08 new qualifier FRAME/TRANSPARENT[=color]
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V6.8 *acm* 7/9/2012 For batch graphics on RHEL6, change ITS_BATCH_GRAPHICS
*                     from logical to integer, then batch = ITS_BATCH_GRAPHICS().NE.0
* V6.95 *acm* 4/15 Haven't used HDF images for a long time: require GIF only.

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'slash.parm'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'
	include 'xplot_setup.cmn'

* internal variable declarations:
	LOGICAL		is_format, is_file, its_gif, batch
	INTEGER		TM_LENSTR1, STR_SAME, ITS_GIF_GRAPHICS, 
     .                  ITS_BATCH_GRAPHICS, status, loc, flen, qp
	CHARACTER	format*3, filename*1028

* initialize
	is_format = qual_given( slash_frame_format ).GT.0
	is_file   = qual_given( slash_frame_file   ).GT.0
	format    = ' '

* Ignore FRAME in batch mode, except when in batch GIF mode.

	its_gif = ITS_GIF_GRAPHICS() .NE. 0
	batch = ITS_BATCH_GRAPHICS() .NE. 0

        IF (batch .AND. .NOT.its_gif) RETURN

* decode the qualifiers, if any

* FRAME/TRANSPARENT[=color]

	transparent = 0
	qp = qual_given( slash_frame_transp )
	IF (qp .GT. 0 .AND. .NOT. animate) THEN
	   IF ( .NOT. batch ) CALL WARN 
     . ('ignoring FRAME/TRANSPARENT. It takes effect only in GIF mode')
           transparent = 1
           CALL EQUAL_STR_LC( cmnd_buff(qual_start(qp):qual_end(qp)),
     .                transparent_color, status )
           IF (STR_SAME(transparent_color, ' ') .EQ. 0)
     .                transparent_color = 'white'
        ENDIF

* FRAME/FORMAT="HDF" or "GIF"
* HDF not currently supported

	IF ( is_format ) THEN
	   loc = qual_given( slash_frame_format )
	   CALL EQUAL_STRING(
     .          cmnd_buff(qual_start(loc):qual_end(loc)),
     .                    format, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   IF ( format .NE. 'GIF') GOTO 5100
	ENDIF

* FRAME/FILE=filename
	IF ( is_file ) THEN
	   loc = qual_given( slash_frame_file )
	   CALL EQUAL_STR_LC(
     .          cmnd_buff(qual_start(loc):qual_end(loc)),
     .                    filename, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	ELSEIF ( format .EQ. 'GIF' ) THEN
	   CALL GET_METAFILE_NAME(filename)
	   IF (STR_SAME(filename, '.gif') .EQ. 0)
     .                filename = 'ferret.gif'
	ELSE
	   filename = frame_file	! saved SET MOVIE/FILE name
	ENDIF
	flen = TM_LENSTR1(filename)

* a format of "GIF" can be implied by a filename ending in .gif or .GIF

	IF ( .NOT.is_format .AND. flen .GT. 4) THEN
	   IF ( filename(flen-3:flen) .EQ. '.gif'
     .     .OR. filename(flen-3:flen) .EQ. '.GIF' )  format = 'GIF'
	   IF ( format .NE. 'GIF') GOTO 5100
	ENDIF

* rename previous versions of this file using a version number scheme
        
	CALL TM_PARK_LAST_VERSION
     .			( filename(:flen), status )

* save that baby
        CALL SAVE_FRAME(filename(:flen), format, status)

	RETURN

* error exits
 5000	RETURN
 5100	CALL ERRMSG( ferr_invalid_command, status,
     .               'illegal format type - must be "GIF"'
     .		     //pCR//cmnd_buff(:len_cmnd), *5000 )
	END

	SUBROUTINE PASS_AMBIG_LIMS( cx, mr, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* for axes in which limits are fully contained in the definition the
* requesting context limits are not necessarily complete or correct
* when the variable is computed (via IS_ALGEBRA) the limits are
* corrected and stored with the memory resident variable.
* This routine functions to pass those corrected limits back to the
* requesting context when that memory resident data is re-accessed.

* In one case the limits are not restrictive (e.g. DEFINE VAR NEW=U[K=1:5]
* which may be used via LOAD NEW[K=2:3] or LOAD NEW )
* and the requesting context limits should be used if they are given explicitly
* otherwise the full limits of the variable will be passed back.
* This is the case of uvlim_gvn_gnl (a non-restrictive range given in def'n)

* In a second case limits are restrictive (e.g. DEFINE VAR NEW=U[K=1:3@AVE])
* and the requesting context must be an exact hit if given explicitly.
* This is the case of uvlim_gvn_xact (an exact range given in the def'n)

* (uvlim_need_xact): Also, if a compressing transformation is specified
* within user-defined variables but limits are not given.  For example,
*	yes? DEFINE VAR KAVE = U[K=@AVE]
*	yes? LIST/K=1:3 KAVE
* The computed and stored context will have the correct Z world coord limits
* but will have K=-9999:-9999 (since it has been reduced to a point)
* The context used in searching will have K=1:3, incorrectly.
* Thus, unpecified_int4 subscript values must be passed back.

* Also, since data may be grabbed with limits completely unspecified
* (determined automatically from the file limits) the context limits may
* be unspecified although the mr variable limits are known.
* Pass back the mr limits.

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  6/22/89
*	10/25/89 - allow unspecified context limits
*	 5/16/90 - allow file data to come back with smaller limits than
*		   requested --> context limits .GT. memory var. size
* Unix/RISC port - 8/12/91 *sh*
*     bug fix that needs to be applied to VMS version, too
*     see "8/12/91" below
*     8/28/91 - fix the 5/90 "kludge" so it cant result in lo>hi
* V230:  6/10/92 - bug fix for err220_unspec_limits.jnl
*                  CANCEL REGION;SET REG/K=1/L=1;STAT TEMP-TEMP[I=@AVE]
*                  results in unspecified world coord limits on I axis
*        11/4/92 - expanded variable name length
* V420:  11/95 - error conditions loosened to match the documentation
* V450:   1/97   - fix to never-observed bug: the check
*		        "uvar_given(idim,var) .LE. uvlim_gvn_xact"
*		   ignores the possibility of uvlim_irrelevant
* V500 *kob* 3/99- up VAR_CODE  to 64 chars 
* V510: *sh* 12/99 - support for uvlim_hiddef (EF caching)
* V530:  8/00 *sh* - added cx_type support
* V552 *acm* 4/03- up VAR_CODE  to 128 chars 
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction.
* V683  *acm*10/12 Improve handling of F axes and info about the calendar of the grid.
* V695  *acm* 2/15 cx_calendar stores info about calendar formatting of T and F axes
* V720 *sh* 5/17 add support for DSG grids
* V720: 4/17 *acm* Add direction-changing functions as a subset of grid-changing ones

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xtext_info.cmn'

* calling argument declarations
	INTEGER	cx, mr, status

* local variable declarations
	LOGICAL		TM_ITSA_DSG, itsa_dsg
	INTEGER		idim, uvar
	CHARACTER	VAR_CODE*128

* initialize
	uvar = mr_variable( mr )
	itsa_dsg = TM_ITSA_DSG(cx_grid(cx))


* data set:
* uvar data set is not necessarily the same as the searching context
	IF ( .NOT.uvar_need_dset(uvar) ) cx_data_set(cx)=mr_data_set(mr)

* take bad data flag from the memory resident result
	cx_bad_data( cx ) = mr_bad_data( mr )
	
* take data type from the memory resident result
	cx_type( cx ) = mr_type( mr )

* axis limits and subscripts:
	DO 100 idim = 1, nferdims

* in a DSG only the F axis is treated as "gridded
	   IF (itsa_dsg .AND. idim.NE.f_dim) CYCLE

* error checks:
	   IF ( cx_given(idim,cx) ) THEN
	      IF ( uvar_given(idim,uvar) .EQ. uvlim_gvn_gnl
     .	      .OR. uvar_given(idim,uvar) .EQ. uvlim_hidden ) THEN
* ... suppose DEFINE VARIABLE NEW=TEMP[K=1:3]
* ... then    LIST NEW[K=5] doesn't make sense
	         IF ( mr_lo_ww(idim,mr).GT.cx_hi_ww(idim,cx)
     .           .OR. mr_hi_ww(idim,mr).LT.cx_lo_ww(idim,cx) ) GOTO 5100
!pre 11/95            IF ( mr_lo_ww(idim,mr).GT.cx_lo_ww(idim,cx)
!pre 11/95 .           .OR. mr_hi_ww(idim,mr).LT.cx_hi_ww(idim,cx) ) GOTO 5100
	      ELSEIF ( uvar_given(idim,uvar) .EQ. uvlim_gvn_xact ) THEN
* ... suppose DEFINE VARIABLE NEW=TEMP[K=1:3@AVE]
* ... then    LIST NEW[K=1:2] doesn't make sense
* 11/95 - not an error - just ignore the K=1:2 limits in the example
	         IF ( mr_lo_ww(idim,mr).NE.cx_lo_ww(idim,cx)
     .           .OR. mr_hi_ww(idim,mr).NE.cx_hi_ww(idim,cx) ) THEN
	            cx_lo_ss(cx,idim) = mr_lo_ss(mr,idim)
	            cx_hi_ss(cx,idim) = mr_hi_ss(mr,idim)
	            cx_lo_ww(idim,cx) = mr_lo_ww(idim,mr)
	            cx_hi_ww(idim,cx) = mr_hi_ww(idim,mr)
	         ENDIF
!pre 11/95      IF ( mr_lo_ww(idim,mr).NE.cx_lo_ww(idim,cx)
!pre 11/95.    .OR. mr_hi_ww(idim,mr).NE.cx_hi_ww(idim,cx) ) GOTO 5100
	      ENDIF
	   ENDIF

* pass limits back
	   IF (   uvar_given(idim,uvar) .EQ. uvlim_gvn_xact
     .	   .OR. ( ( uvar_given(idim,uvar) .EQ. uvlim_gvn_gnl
     .	   .OR.     uvar_given(idim,uvar) .EQ. uvlim_hidden )
     .		  .AND. .NOT.cx_given(idim,cx) )	    ) THEN

	         cx_lo_ss(cx,idim) = mr_lo_ss(mr,idim)
	         cx_hi_ss(cx,idim) = mr_hi_ss(mr,idim)
	         cx_lo_ww(idim,cx) = mr_lo_ww(idim,mr)
	         cx_hi_ww(idim,cx) = mr_hi_ww(idim,mr)

	   ELSEIF ( uvar_given(idim,uvar) .EQ. uvlim_need_xact ) THEN
	      cx_lo_ss(cx,idim) = mr_lo_ss(mr,idim)
	      cx_hi_ss(cx,idim) = mr_hi_ss(mr,idim)
! 6/92 bug fix: (possibly the IF test isn't needed - it's here to minimize
!                impacts of this fix)
              IF ( cx_lo_ww(idim,cx) .EQ. unspecified_val8
     .       .AND. mr_lo_ww(idim,mr) .NE. unspecified_val8 ) THEN
	         cx_lo_ww(idim,cx) = mr_lo_ww(idim,mr)
	         cx_hi_ww(idim,cx) = mr_hi_ww(idim,mr)
              ENDIF

* all abstract variables live on grid ABSTRACT, however,
* an expression like X+Y is normal to Z and T so they are flagged as irrelevant
	   ELSEIF ( uvar_given(idim,uvar) .EQ. uvlim_irrelevant ) THEN
	      cx_lo_ss(cx,idim) = unspecified_int4
	      cx_hi_ss(cx,idim) = unspecified_int4
	      cx_lo_ww(idim,cx) = unspecified_val8
	      cx_hi_ww(idim,cx) = unspecified_val8
* 9/97 *kob* cx_calendar must reflect these changes as well	  
	      IF (idim .EQ. t_dim .OR. idim .EQ. f_dim) 
     .                cx_calendar(idim,cx) = .FALSE.

* context limits unspecified but untransformed data limits available anyway
	   ELSEIF ( cx_lo_ss(cx,idim) .EQ. unspecified_int4 ) THEN
	      cx_lo_ss(cx,idim) = mr_lo_ss(mr,idim)
	      cx_hi_ss(cx,idim) = mr_hi_ss(mr,idim)
	      cx_lo_ww(idim,cx) = mr_lo_ww(idim,mr)
	      cx_hi_ww(idim,cx) = mr_hi_ww(idim,mr)

* If the computation has a grid-changing fcn chosen at run-time, we still need
* to use the limits as loaded
	   ELSEIF (has_uvar_dc .AND. uvar_given(idim,uvar) .EQ. uvlim_needed
     .		  .AND. .NOT.cx_given(idim,cx) 	    ) THEN

	         cx_lo_ss(cx,idim) = mr_lo_ss(mr,idim)
	         cx_hi_ss(cx,idim) = mr_hi_ss(mr,idim)
	         cx_lo_ww(idim,cx) = mr_lo_ww(idim,mr)
	         cx_hi_ww(idim,cx) = mr_hi_ww(idim,mr)

	   ENDIF
 

* 8/12/91 bug fix during Unix port
* this is not known to be the perfect fix (kludge)...
* User-defined variables that have explicit limits given in their definitions
* need to pass that information to the context that is requesting them
* in, for example:  LET MASK=TEMP[L=1]
*                   STAT/L=2 MASK*TEMP
* the expression needs to be evaluated as if it were MASK[L=1]*TEMP
! 1/97 - check against uvlim_irrelevant just to be thorough
           IF ( uvar_given(idim,uvar) .LE. uvlim_gvn_xact
     .    .OR.  uvar_given(idim,uvar) .EQ. uvlim_irrelevant  )
     .                               cx_given(idim,cx) = .TRUE.

* a bit of a kludge ... for some expressions with @AVE, etc. the cx subscript
* limits don't get set to unspecified.  Too lazy to find the "right" sol'n.
	   IF ( mr_lo_ss(mr,idim) .EQ. unspecified_int4 ) THEN
	      cx_lo_ss(cx,idim) = unspecified_int4
	      cx_hi_ss(cx,idim) = unspecified_int4
	   ENDIF

* another kludge (5/90) file data may come back smaller than
* requested --> calculated results from it will be smaller, too
	   IF ( cx_lo_ss(cx,idim) .LT. mr_lo_ss(mr,idim) ) THEN
	      cx_lo_ss(cx,idim) = mr_lo_ss(mr,idim)
	      cx_lo_ww(idim,cx) = mr_lo_ww(idim,mr)
*     8/28/91 - don't allow limits to be reversed: kludge patch
              IF ( cx_lo_ss(cx,idim) .GT.cx_hi_ss(cx,idim) ) THEN
                 cx_hi_ss(cx,idim) = mr_hi_ss(mr,idim)
                 cx_hi_ww(idim,cx) = mr_hi_ww(idim,mr)
              ENDIF
	   ENDIF
	   IF ( cx_hi_ss(cx,idim) .GT. mr_hi_ss(mr,idim) ) THEN
	      cx_hi_ss(cx,idim) = mr_hi_ss(mr,idim)
	      cx_hi_ww(idim,cx) = mr_hi_ww(idim,mr)
*     8/28/91 - don't allow limits to be reversed: kludge patch
              IF ( cx_lo_ss(cx,idim) .GT.cx_hi_ss(cx,idim) ) THEN
                 cx_lo_ss(cx,idim) = mr_lo_ss(mr,idim)
                 cx_lo_ww(idim,cx) = mr_lo_ww(idim,mr)
              ENDIF
	   ENDIF

 100	CONTINUE

* success
	status = ferr_ok
	RETURN

* error
 5000	RETURN
 5100	CALL ERRMSG( ferr_limits, status,
     .		ww_dim_name(idim)//
     .		' axis limits don''t match variable def''n: '//
     .		VAR_CODE( cat_user_var, uvar )//pCR//
     .	'Are you giving explicit limits when SET REGION would suffice ?',
     .	*5000 )
	END

        PROGRAM DRWSYM
        CHARACTER FONT(20:30)*2,NUM*6,STR*5,NAME(20:30)*30,NME*30
	DIMENSION ILEN(20:30)
	DATA ILEN/27,32,39,19,78,43,42,12,15,69,26/
        DATA FONT/'ZO','MU','EL','WE','MA','SM','MP',
     *  'LM','IZ','IM','CA'/
        DATA NAME/'Zodiac','Music','Electrical','Weather',
     *	'Math','Simplex Math','Map','Large Math','Indexical Zodiac',
     *	'Indexical Math','Cartographic'/
        OPEN(5,FILE='TI:',STATUS='UNKNOWN')
        CALL PLTYPE(0)
        CALL SIZE(10.5,8.2)
        SZE=0.21
        CALL ERASE
C
C       DRAW BOX
C
        X=0.25
        Y1=0.25
        Y2=9.00
        DO 110 I=1,9
        CALL PLOT(Y1,X,0,0)
        CALL PLOT(Y2,X,1,0)
        X=X+0.875
        IF(Y1.EQ.0.25)THEN
                Y2=Y1
                Y1=9.00
        ELSE
                Y2=Y1
                Y1=0.25
        ENDIF
110     CONTINUE
        Y=0.25
        X1=0.25
        X2=7.25
        DO 120 I=1,11
        CALL PLOT(Y,X1,0,0)
        CALL PLOT(Y,X2,1,0)
        Y=Y+0.875
        IF(X1.EQ.0.25)THEN
                X2=X1
                X1=7.25
        ELSE
                X2=X1
                X1=0.25
        ENDIF
120     CONTINUE
C
C       DRAW CHARACTERS
C
        WRITE(NME,997)NAME(20)
997     FORMAT('@SR',A25)
        CALL SYMBEL(0.15,0.25,90.0,.14,28,NME)
	ICH=1
        DO 130 I=1,8
        DO 130 J=1,10
        X=0.25+(I-1)*0.875
        Y=0.25+J*0.875
        WRITE(NUM,998)ICH
998     FORMAT('@SR',I2.2)
        STR='@20'//NUM(4:5)
        CALL SYMBEL(Y-0.775,X+0.02,90.,0.07,6,NUM)
        S=X+0.4375-SYMWID(SZE,5,STR)*0.5
        CALL SYMBEL(Y-0.3325,S,90.,SZE,5,STR)
	ICH=ICH+1
	IF(ICH.GT.ILEN(20))GOTO 140
130     CONTINUE
140     CALL PLTEND
100     CONTINUE
        CALL EXIT
        END

	SUBROUTINE RELOAD_DSG_MASKVAR (varname, slen) 

        IMPLICIT NONE
#	include	"tmap_dset.parm"
	include	'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'xdset_info.cmn_text'
	include 'xprog_state.cmn'

* 6/3/2020 *acm*
* If a variable that is a feature-mask for a DSG Dataset is redefined,
* the previous feature mask info is cleared out.  Here, load the new
* definition as the feature mask.

	INTEGER	slen
	CHARACTER*(*) varname

	LOGICAL NC_GET_ATTRIB, got_it, reload
	INTEGER STR_SAME, iset, varid, attid, attlen, 
     .		attoutflag, maxlen, alen, status
	REAL	attval
	CHARACTER*32 attname, attstring, dummy
	CHARACTER*48 TM_FMT

* ... loop over datasets. See if the variable is listed as a feature-mask
*     for the dataset.  If so re-load the mask.

	maxlen = 32
	varid = 0

	DO iset = pdset_irrelevant+1, maxdsets
      
	   IF ( ds_name(iset) .EQ. char_init2048) CYCLE

	   varid = 0  ! look in global attributes for '__feature_mask_var'
	   attname = '__feature_mask_var'

	   CALL  CD_GET_VAR_ATT_ID (iset, varid, attname, attid, status)
	
	   IF (status .NE. ferr_ok) CYCLE
	   got_it = NC_GET_ATTRIB ( iset, varid, attname,.FALSE., dummy, 
     .                               maxlen, attlen, attoutflag, attstring,
     .                               attval )

	   IF (.NOT. got_it) CYCLE
	   IF (STR_SAME(varname(:slen), attstring(:attlen)) .EQ. 0) THEN 

* The mask has the same name as this dataset's current mask.  The LOAD
* routine also tests the length of the new mask. If it's the right 
* length for this dataset, will replace its FMASK, otherwise the 
* FMASK is canceled. 

* These attributes will get restored using the new definition for 
* the mask variable in the load routine	

	      CALL CD_DELETE_ATTRIBUTE (iset, varid, attname, status ) 
	      attname = '__feature_mask_'
	      CALL  CD_GET_VAR_ATT_ID (iset, varid, attname, attid, status)
	      CALL CD_DELETE_ATTRIBUTE (iset, varid, attname, status )  

	      cmnd_buff = 'load '//varname(:slen)

	      arg_start(1) = 6
	      arg_end(1) = 5+slen

	      reload = .TRUE.
	      CALL LOAD_DSG_MASKVAR (iset, varname, reload, status)
	   ENDIF

	ENDDO

	RETURN
	END

	SUBROUTINE CD_WRITE_ATTVAL ( cdfid, vname, att, val, nval,
     .                               type, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Write a numerical attribute to a netCDF file
* If the variable is equal to the parameter pcdf_global then make it a
* global attribute.

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 3/92
*               10/92: set into define mode
* 10/2005 NOTE: do not change this for the attribute-access changes. 
*               This routine accesses the newly-created file using 
*               netcdf calls as always. The values sent in come from
*               the linked-list structure but output is all the same.
* V600  4/06 *acm* - additional declarations found by Solaris compiler
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* argument definitions:
*     cdfid   - netCDF id number for already opened CDF file
*     vname   - name of previously created netCDF variable
*     att     - name of attribute
*     val     - value(s) for the attribute
*     nval    - number of attribute values
*     type    - data type of the attribute
*     status  - return status

* include files

        include 'netcdf.inc'
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
        include 'cdf_tmap.parm'
#include "gt_lib.parm"
	include 'cd_lib.parm'

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

* argument declarations
      INTEGER cdfid, nval, type, i4(10), i, status
      INTEGER*2 i2(10)
      BYTE i1
      CHARACTER*(*) vname, att
      REAL val(*)

* local variable declarations:
      INTEGER TM_LENSTR1,
     .        vlen, alen, cdfstat, varid, attype, attlen, flen      
      CHARACTER*128 abuff     ! needed because of fussy compilers and // concatenation

      PARAMETER (flen=512)      ! size of variable name string

#ifdef sun
      BYTE      fhol(flen)      ! c-type Hollerith string buffer
#else
      INTEGER*1 fhol(flen)      ! c-type Hollerith string buffer
#endif 

* For error message
      CHARACTER*9 typnam(12)
      DATA typnam/'NC_BYTE', 'NC_CHAR', 'NC_SHORT', 'NC_INT', 
     .            'NC_FLOAT', 'NC_DOUBLE', 'NC_UBYTE', 'NC_USHORT',
     .            'NC_UINT', 'NC_INT64', 'NC_UINT64', 'NC_STRING'/

* initialize
      vlen = TM_LENSTR1( vname )
      alen = TM_LENSTR1( att )
      
* locate the variable id
      IF ( vname .EQ. pcdf_global ) THEN
         varid = NF_GLOBAL
      ELSE
	 cdfstat = NF_INQ_VARID(cdfid, vname(:vlen), varid)
         IF ( cdfstat .NE. NF_NOERR ) GOTO 5100
      ENDIF

* does the attribute already exist ?
      cdfstat = NF_INQ_ATT (cdfid, varid, att(:alen), attype, attlen)
      IF ( cdfstat.EQ.NF_NOERR .AND. attype.NE.type ) GOTO 5200

* put CDF into define mode so attributes can be written
      CALL CD_SET_MODE(cdfid, pcd_mode_define, status)
      IF ( status .NE. merr_ok ) RETURN

* Convert to the requested type and write the attribute

      CALL TM_FTOC_STRNG( att(1:alen), fhol, flen )

      status = merr_ok
      CALL CD_WRITE_ATT_SUB(cdfid, varid, fhol, type, nval, val, status)

      IF ( status .EQ. -60) GOTO 5300

* successful completion
 1000 status = merr_ok
      RETURN

 5100 CALL TM_ERRMSG
     . ( merr_unkvar, status, 'CD_WRITE_ATTRIB', unspecified_int4,
     .   unspecified_int4,
     .  'variable doesnt exist in CDF file',
     .  vname(:vlen), *5900 )

 5200 CALL TM_ERRMSG
     . ( merr_gridpredef, status, 'CD_WRITE_ATTRIB', unspecified_int4,
     .   unspecified_int4,
     .  'incompatible data type of CDF attribute',
     .  att(:alen), *5900 )

 5300  abuff = att
       CALL TM_ERRMSG (status+pcdferr, status, 'CD_WRITE_ATTVAL',
     .     no_descfile, no_stepfile, 
     .    'data in attribute '//abuff(:alen)//
     .    ' not representable in output type '//typnam(type),
     .     no_errstring, *5900 )

* error exit
 5900   RETURN
	END

    	SUBROUTINE SET_AGG_VAR_ATTS(agg_dset, vname, aggv_slot, nsets,
     .                              ref_fvar, memb_set, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* assign attributes to an aggregated variable if the same, identical attributes
* are found on all member variables
* (units, title, and bad_flag are taken care of elsewhere)


* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V698 *sh* 2/16 
* V698 *acm* 2/16 LET/D variables are now stored with their associated datset
*                 in the List structure so can get their attribute info
* V720 *acm* 5/17 Implement specific calls in place of CD_GET_VAR_INFO

        IMPLICIT NONE
        INCLUDE 'tmap_dims.parm'
        INCLUDE 'ferret.parm'
        INCLUDE 'errmsg.parm'      
        INCLUDE 'xprog_state.cmn'
        INCLUDE 'xvariables.cmn'
        INCLUDE 'xcontext.cmn'
        INCLUDE 'xdset_info.cmn_text'
        INCLUDE 'netcdf.inc'

* calling arguments
*  agg_dset     - dset no of the aggregation (input)
*  vname        - name of the aggregated variable (input)
*  aggv_slot    - index of agg var in ds_ common (input)
*  nsets        - number of member datasets in aggregation (input)
*  ref_fvar     - reference file variable serving as the pattern (input)
*  memb_set     - list of member dataset numbers (input)
*  status       - return status (output)

* calling argument declarations
    	INTEGER agg_dset, aggv_slot, nsets, 
     .          ref_fvar, memb_set(*), status
        CHARACTER*128 vname

* Local variable declarations
        INTEGER maxlen
        PARAMETER (maxlen = 2048)

        LOGICAL NC_GET_ATTRIB, got_it
        INTEGER TM_LENSTR1, vlen, ref_dset, ref_id, var_id,
     .          nvatts, att, imemb, attype, attlen, attoutflag,
     .          m_attid, m_attype, m_attlen, m_attoutflag,
     .          m_dset, m_cat, m_grid, m_var, m_ens_ax,
     .          all_outflag, memb_id(nsets), i, iatt
        REAL    attvals(50), m_attvals(50)
        CHARACTER attname*128
        CHARACTER*(maxlen) attstr, m_attstr


* initialize
        vlen = TM_LENSTR1(vname)
        ref_dset = ds_var_setnum(ref_fvar)

* Get var id for reference variable
        CALL CD_GET_VAR_ID (ref_dset, vname(:vlen), ref_id, status)
        IF (status .NE. ferr_ok) GOTO 5200

* Get var id for aggregated variable
        CALL CD_GET_VAR_ID (agg_dset, vname(:vlen), var_id, status)
        IF (status .NE. ferr_ok) GOTO 5200

* Get var ids for member variables
        imemb = 1
        DO imemb = 1, nsets

* skip dummy datasets
           IF (memb_set(imemb) .EQ. pdset_dummy) THEN
              memb_id(imemb) = unspecified_int4
              CYCLE
           ENDIF

* LET/D vars are represented in the List structure of their assigned
* dataset. Treat as for any file variable
	   CALL CD_GET_AGG_VAR_INFO (agg_dset, vname(:vlen), imemb, 
     .         m_cat, m_dset, m_grid, m_ens_ax, m_var, status)
           IF (status .NE. ferr_ok) GOTO 5200
           CALL CD_GET_VAR_ID (memb_set(imemb), vname(:vlen),
     .                         memb_id(imemb), status)
           IF (status .NE. ferr_ok) GOTO 5200

        ENDDO

* Get number of attributes from the reference variable
        CALL CD_GET_VAR_NATTS (ref_dset, ref_id, vname(:vlen),
     .                         nvatts, status)

**** loop through the attribute list from the reference variable
        attloop: DO iatt = 1, nvatts
           CALL CD_GET_VAR_ATT_NAME (ref_dset, ref_id, iatt, attname, status)

* Ignore basic attributes. These are already defined.
*?? Check the attribute values from each member?
           IF (attname .EQ. 'units'
     .    .OR. attname .EQ. 'long_name'
     .    .OR. attname .EQ. '_FillValue'
     .    .OR. attname .EQ. 'missing_value') CYCLE

* get the reference attribute info
           CALL CD_GET_VAR_ATT_INFO (ref_dset, ref_id, iatt, attname, 
     .               attype, attlen, attoutflag, status )
           IF (status .NE. ferr_ok) GOTO 5200

* get the reference attribute value and info
           got_it = NC_GET_ATTRIB ( ref_dset, ref_id, attname,
     .                              .TRUE., vname(:vlen), maxlen,
     .                              attlen, attoutflag,
     .                              attstr, attvals )
           IF (.NOT.got_it) GOTO 5200
	   
* ensure that the attribute is identical in all member variables

           DO imemb = 1, nsets

* ... skip over dummy members
              IF (memb_set(imemb) .EQ. pdset_dummy) CYCLE

! ... skip over user variables
              IF (memb_id(imemb)  .EQ. unspecified_int4) CYCLE

* ... get the attribute id in the member
              CALL CD_GET_VAR_ATT_ID (memb_set(imemb), memb_id(imemb),
     .                                attname, m_attid, status)
              IF (status.EQ.atom_not_found) CYCLE attloop

* ... get the attribute info for the member
              CALL CD_GET_VAR_ATT_INFO (memb_set(imemb), memb_id(imemb),
     .                                  m_attid, attname, m_attype, 
     .                                  m_attlen, m_attoutflag, status )
              IF (status .NE. ferr_ok) GOTO 5200
              IF (m_attype .NE. attype
     .       .OR. m_attlen .NE. attlen ) CYCLE attloop

* get the attribute value for the member
              got_it = NC_GET_ATTRIB (memb_set(imemb), memb_id(imemb),
     .                              attname,
     .                              .TRUE., vname(:vlen), maxlen,
     .                              m_attlen, m_attoutflag,
     .                              m_attstr, m_attvals )
              IF (.NOT.got_it) GOTO 5200

* check that the value matches the reference
              IF (attype .EQ. NCCHAR) THEN
* ... check that string values are identical
                 IF (m_attstr .NE. attstr)  CYCLE attloop
              ELSE
* ... check that numeric values are identical
                 DO i = 1, attlen
                    IF (attvals(i) .NE. m_attvals(i)) CYCLE attloop
                 ENDDO
              ENDIF

           ENDDO   ! done cmparing with member attributes

* transfer this attribute from the reference variable to the aggregate variable
	   CALL CD_PUT_NEW_ATTR (agg_dset, var_id, attname, attype, 
     .                  attlen, attoutflag, attstr, attvals, status )

        ENDDO attloop

* Do not call UPDATE_ATTRIBUTES. The title, units, missing etc were
* already set in defining the variable in the aggregation.
cc        CALL UPDATE_ATTRIBUTES (agg_dset, vname, aggv_slot, status)
cc        IF (status .NE. ferr_ok) GOTO 5200

* success
* (status may have been set to atom_not_found on a missing attribute.
*  Set to ferr_ok.)

	status = ferr_ok
        RETURN

* error exits
 5000   RETURN

! 5100   CALL ERRMSG (ferr_var_not_in_set, status, vname(:vlen),*5000)
!
 5200   CALL ERRMSG (ferr_internal, status,
     .               'attListCrptn: '//vname(:vlen),*5000)
	END

      SUBROUTINE TM_LOAD_CALENDAR (cal_name, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
C     Loads data for the calendar given  into common.  These values are
C     accessed by the date/time functions for all calendar-using plots.
C     Returns status = merr_ok success, merr_varlim failure
C
C     NOTE the current calendar name and id are NOT changed: for that see
C     tm_set_current_calendar().  This permits Ferret queries of a particular
C     calendar without losing knowledge of the calendar in use.
C
C     J Davison 10.99
C     V 1.0
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files, add disclaimer

C     0.00000000000000000000000000000000000000000000000000000000000000001

      include 'calendar.decl'
      include 'calendar.cmn'
      include 'tmap_errors.parm'

      integer         TM_GET_CALENDAR_ID, cal_id,status,i,j,k
      character*(*)   cal_name

*************************************************************************

      cal_id = TM_GET_CALENDAR_ID (cal_name)

C     OK CALENDAR ID?
      if (cal_id .lt. 1 .or. 
     .    cal_id .gt. max_calendars) then 
         status = merr_varlim
         goto 1000
      end if

C     SET NUM_MONTHS AND NUM_DAYS IN CALENDAR
      num_months = cals_num_months(cal_id)
      num_days = cals_num_days(cal_id)

C     SET MONTH NAMES
      do 110 i = 1, num_months
         month_names(i) = cals_month_names(i,cal_id)
 110  end do

C     SET DAYS_IN_MONTH
      do 120 i = 1, num_months
         days_in_month(i) = cals_days_in_month(i,cal_id)
 120  end do

C     SET DAYS_BEFORE_MONTH
      days_before_month(1) = 0
      do 130 i = 2, num_months
         days_before_month(i) = days_before_month(i-1) 
     .                            + days_in_month(i-1)
 130  end do

C     SET MONTH_BY_DAY
      k = 0
      do 150 j = 1, num_months
         do 140 i = 1, days_in_month(j)
            k = k + 1
            month_by_day(k) = j
 140     end do
 150  end do

C  IDENTIFY LOADED CALENDAR
      calendar_id = cal_id

      status = merr_ok

 1000 return

      end

c*
c* ef_get_one_val_sub.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
c*
c* Jonathan Callahan
c* Dec 17th 1997
c*
c* Revisions:
c* *sh* 10/00 - if mr_list isn't defined (as during grid creation) then
c* check to see if we can still return the value of a constant arg

c* This subroutine is called by an external function which wishes
c* to get the value of a 1x1x1x1 variable.

c* Note that grabbing a constant array during grid creation time is more
c* difficult (though not impossible). The EVAL_EXPR routine cannot safely be
c* called since the stacks would get re-initialized and the {,,,} would need
c* to be parsed


      SUBROUTINE EF_GET_ONE_VAL_SUB(id,  iarg, value)

      IMPLICIT NONE
      INCLUDE 'tmap_dims.parm'
      INCLUDE 'ferret.parm'
      INCLUDE 'errmsg.parm'
      INCLUDE 'xvariables.cmn'
      INCLUDE 'xcontext.cmn'
      INCLUDE 'xmem_subsc.cmn'
      INCLUDE 'EF_Util.parm'

* calling argument declarations
      REAL    value
      INTEGER id, iarg

* internal variable declarations
      INTEGER mr, cx, uv, status
      INTEGER mr_list(EF_MAX_ARGS)
      CHARACTER*64 buff

c* The following variables were cached by Ferret and must be retrieved
c* to be accessible to the external function.
      CALL EF_GET_MR_LIST(mr_list)

      IF (mr_list(1) .GT. 0 ) THEN
        mr = mr_list(iarg)
        CALL EF_GET_ONE_VAL_SUB_SUB(memry(mr)%ptr, 
     .                              lo_ss(iarg,1), hi_ss(iarg, 1),
     .                              lo_ss(iarg,2), hi_ss(iarg, 2),
     .                              lo_ss(iarg,3), hi_ss(iarg, 3),
     .                              lo_ss(iarg,4), hi_ss(iarg, 4),
     .                              lo_ss(iarg,5), hi_ss(iarg, 5),
     .                              lo_ss(iarg,6), hi_ss(iarg, 6),
     .     value, status)   ! note that status is not valid as returned 10/00
!        IF  (status .NE. ferr_ok) GOTO 5000

      ELSE
c* memory vars havnt yet been defined -- can still try to evaluate a constant
c* Constants appear here inside a child variable
        CALL EF_GET_CX_LIST(mr_list) ! get contexts
        cx = mr_list(iarg)
        IF (cx_category(cx) .NE. cat_user_var) GOTO 5000
        uv = cx_variable(cx)
        IF (uvar_num_items(uv)   .NE. 1
     . .OR. uvar_item_type(1,uv) .NE. alg_constant ) GOTO 5000
        buff = uvar_text(uv)
        READ (buff, *, ERR=5000 ) value

      ENDIF

      RETURN

c* return a ststus word to the calling C program      
!5000 CALL ERRMSG(ferr_ef_error, status, ' ', *5100)
 5000 WRITE (buff, 3000) iarg
 3000 FORMAT ('Argument',I3,' must be a constant')
      CALL EF_BAIL_OUT(id, buff)
      STOP 'EF_BAIL_OUT returned in EF_GET_ONE_VAL_SUB'

      RETURN 
      END

*
*  eof_space_tgap.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* Sep 1998
* Aug 2000 change fcn description; argument can be fcn of Z as well as x,y,t
* May 2001 Use simpler solver EOFIN when frac_timeser = 1.
*
* Jul 2001 Move to statically linked code in fer/efi. 
* Jul 2001 Move count_eof and pack_eof to file eofsubs.f, rename solve_eof
*          to solve_eof_space_tgap.
*          Make the function work w/ data having multiple depths: compute
*          EOF solution for each depth.
* Aug 2001 move to fer/efi directory, to be statically linked to Ferret.  
*	   Change INCLUDE statements to remove directory spec.  
* Feb 2003 Add a test that NEOF <= max_neof, which is dictated by work
*          arrays in the solvers in TRIDIN in eofsubs.F
* Jun 2003 Workspace arrays need to be initialized for each vertical level.
* Sep 2005 Remove the max_eof test; make all workspace be allocated as 
*          external function work arrays.
*
* Compute EOF/s and time amplitude funcions from a 2-d field, or for each level 
* of a 3-D field.  Based on programs (coadseof.f, etc.) by Dai McClurg and 
* Ansley Manke and calls Billy Kessler's method for finding EOFs  of NON-gappy 
* time series EOFIN, or optionally his implementation of Chelton's '82 method 
* for finding EOFs of gappy time series.
*
* Return Spatial EOF's
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE eof_space_tgap_init(id)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      CALL ef_set_desc(id, 
     . 'Compute EOF spacial fields from XYT field with gappy time series')

      CALL ef_set_num_args(id, 2)

      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, ABSTRACT,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 9)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg,
     .                     'Variable in x,y,t; may be fcn of z,e,f')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, NO, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'frac_timeser')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg,
     . 'Use only those time series with this fraction valid data')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* loss               lo subscript for an axis
*
* hiss               hi subscript for an axis
*

      SUBROUTINE eof_space_tgap_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER my_lo_l, my_hi_l

      INTEGER nx, ny

*     Use utility functions to get context information about the 
*     1st argument, to set the abstract axis lo and hi indices.

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nx = arg_hi_ss(X_AXIS, ARG1) - arg_lo_ss(X_AXIS, ARG1) + 1
      ny = arg_hi_ss(Y_AXIS, ARG1) - arg_lo_ss(Y_AXIS, ARG1) + 1

      my_lo_l = 1
      my_hi_l = nx * ny

      CALL ef_set_axis_limits(id, T_AXIS, my_lo_l, my_hi_l)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE eof_space_tgap_work_size(id)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*
      COMMON /EOFXYSTOR/ mx
      INTEGER mx1, my1, mt1, mx, mxmt, mxmx

      INTEGER iwork
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      mx1 = 1 + arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1)
      my1 = 1 + arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1)
      mt1 = 1 + arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1)

      mx = mx1 * my1 + 10
      mxmt = mx * mt1 + 10
      mxmx = mx * mx + 10

*  val
      iwork = 1
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                               mx, 1, 1, 1, 1, 1)

*  taf
      iwork = 2
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                             mxmt, 1, 1, 1, 1, 1)

*  pct
      iwork = 3
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                               mx, 1, 1, 1, 1, 1)

*  vec
      iwork = 4
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                             mxmx, 1, 1, 1, 1, 1)

*  c
      iwork = 5
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                             mxmx, 1, 1, 1, 1, 1)

*  ddat_1d
      iwork = 6
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                             mxmt, 1, 1, 1, 1, 1)

*  isave_jsave
      iwork = 7
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                               mx, 2, 1, 1, 1, 1)

*  ok
      iwork = 8
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1,   1, 1, 1, 1, 1,
     .                              mx1, my1, 1, 1, 1, 1)

*  eofwork
      iwork = 9
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1,  1, 1, 1, 1, 1,
     .                               mx, 10, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this SUBROUTINE we compute the result
*

      SUBROUTINE  eof_space_tgap_compute(id, arg_1, arg_2, result, 
     .       val, taf, pct, vec, c, ddat_1d, isave_jsave, ok, eofwork)

*  arg_1  variable, function of (x,y,t)
*  result NX*NY eigenvectors

*  Work arrays:
*  val, taf, pct, vec, c, ddat_1d, isave_jsave, ok

*  val(neof)	eigenvalues (Lambda)
*  result == vec(neof,neof) eigenvectors (Lambda*U). Same units as data.
*  taf(neof,nt)	time amplitude functions (V). Dimensionless.
*  pct(neof)	% variance represented by each EOF.
*  c(neof,neof)	work space for cov matrix (garbage output)
*  isave_jsave  save the locations of the data in the x-y plane
*  eofwork	used by QRSYM and other solver routines; replaces
*		original ALPHA, BETA, BB, and P arrays.

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      COMMON /EOFXYSTOR/ mx
      INTEGER mx

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

*  Dimension the work arrays.

      REAL val(wrk1lox:wrk1hix, wrk1loy:wrk1hiy,
     .         wrk1loz:wrk1hiz, wrk1lot:wrk1hit,
     .         wrk1loe:wrk1hie, wrk1lof:wrk1hif)
      REAL taf(wrk2lox:wrk2hix, wrk2loy:wrk2hiy,
     .         wrk2loz:wrk2hiz, wrk2lot:wrk2hit,
     .         wrk2loe:wrk2hie, wrk2lof:wrk2hif)
      REAL pct(wrk3lox:wrk3hix, wrk3loy:wrk3hiy,
     .         wrk3loz:wrk3hiz, wrk3lot:wrk3hit,
     .         wrk3loe:wrk3hie, wrk3lof:wrk3hif)
      REAL vec(wrk4lox:wrk4hix, wrk4loy:wrk4hiy,
     .         wrk4loz:wrk4hiz, wrk4lot:wrk4hit,
     .         wrk4loe:wrk4hie, wrk4lof:wrk4hif)
      REAL c(wrk5lox:wrk5hix, wrk5loy:wrk5hiy,
     .       wrk5loz:wrk5hiz, wrk5lot:wrk5hit,
     .       wrk5loe:wrk5hie, wrk5lof:wrk5hif)
      REAL ddat_1d(wrk6lox:wrk6hix, wrk6loy:wrk6hiy,
     .             wrk6loz:wrk6hiz, wrk6lot:wrk6hit,
     .             wrk6loe:wrk6hie, wrk6lof:wrk6hif)
      REAL isave_jsave(wrk7lox:wrk7hix, wrk7loy:wrk7hiy,
     .                 wrk7loz:wrk7hiz, wrk7lot:wrk7hit,
     .                 wrk7loe:wrk7hie, wrk7lof:wrk7hif)
      REAL ok(wrk8lox:wrk8hix, wrk8loy:wrk8hiy,
     .        wrk8loz:wrk8hiz, wrk8lot:wrk8hit,
     .        wrk8loe:wrk8hie, wrk8lof:wrk8hif)
      REAL eofwork(wrk9lox:wrk9hix, wrk9loy:wrk9hiy,
     .             wrk9loz:wrk9hiz, wrk9lot:wrk9hit,
     .             wrk9loe:wrk9hie, wrk9lof:wrk9hif)


* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER neof, ier
      CHARACTER*255 err_msg, err_out

      INTEGER nx, ny, nt, k, m, n, k1, m1, n1,
     .        iw, jw, kw, lw, mw, nw
      REAL frac_timeser

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*  get array sizes

      nx = 1 + arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1)
      ny = 1 + arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1)
      nt = 1 + arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1)

*  Get time percent parameter.

      frac_timeser = arg_2(arg_lo_ss(X_AXIS,ARG2), 
     .                     arg_lo_ss(Y_AXIS,ARG2),
     .                     arg_lo_ss(Z_AXIS,ARG2), 
     .                     arg_lo_ss(T_AXIS,ARG2),
     .                     arg_lo_ss(E_AXIS,ARG2),
     .                     arg_lo_ss(F_AXIS,ARG2))

*  Compute EOF for each depth, ensemble, forecast

      n1 = arg_lo_ss(F_AXIS,ARG1)
      DO 300 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

      m1 = arg_lo_ss(E_AXIS,ARG1)
      DO 200 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

      k1 = arg_lo_ss(Z_AXIS,ARG1)
      DO 100 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

*  Initialize work arrays.

         DO 701 nw = wrk1lof,wrk1hif
         DO 701 mw = wrk1loe,wrk1hie
         DO 701 lw = wrk1lot,wrk1hit
         DO 701 kw = wrk1loz,wrk1hiz 
         DO 701 jw = wrk1loy,wrk1hiy
         DO 701 iw = wrk1lox,wrk1hix
            val(iw,jw,kw,lw,mw,nw) = 0.
  701    CONTINUE

         DO 702 nw = wrk2lof,wrk2hif
         DO 702 mw = wrk2loe,wrk2hie
         DO 702 lw = wrk2lot,wrk2hit
         DO 702 kw = wrk2loz,wrk2hiz 
         DO 702 jw = wrk2loy,wrk2hiy
         DO 702 iw = wrk2lox,wrk2hix
            taf(iw,jw,kw,lw,mw,nw) = 0.
  702    CONTINUE

         DO 703 nw = wrk3lof,wrk3hif
         DO 703 mw = wrk3loe,wrk3hie
         DO 703 lw = wrk3lot,wrk3hit
         DO 703 kw = wrk3loz,wrk3hiz 
         DO 703 jw = wrk3loy,wrk3hiy
         DO 703 iw = wrk3lox,wrk3hix
            pct(iw,jw,kw,lw,mw,nw) = 0.
  703    CONTINUE

         DO 704 nw = wrk4lof,wrk4hif
         DO 704 mw = wrk4loe,wrk4hie
         DO 704 lw = wrk4lot,wrk4hit
         DO 704 kw = wrk4loz,wrk4hiz 
         DO 704 jw = wrk4loy,wrk4hiy
         DO 704 iw = wrk4lox,wrk4hix
            vec(iw,jw,kw,lw,mw,nw) = 0.
  704    CONTINUE

         DO 705 nw = wrk5lof,wrk5hif
         DO 705 mw = wrk5loe,wrk5hie
         DO 705 lw = wrk5lot,wrk5hit
         DO 705 kw = wrk5loz,wrk5hiz 
         DO 705 jw = wrk5loy,wrk5hiy
         DO 705 iw = wrk5lox,wrk5hix
            c(iw,jw,kw,lw,mw,nw) = 0.
  705    CONTINUE

         DO 706 nw = wrk6lof,wrk6hif
         DO 706 mw = wrk6loe,wrk6hie
         DO 706 lw = wrk6lot,wrk6hit
         DO 706 kw = wrk6loz,wrk6hiz 
         DO 706 jw = wrk6loy,wrk6hiy
         DO 706 iw = wrk6lox,wrk6hix
            ddat_1d(iw,jw,kw,lw,mw,nw) = 0.
  706    CONTINUE

         DO 707 nw = wrk7lof,wrk7hif
         DO 707 mw = wrk7loe,wrk7hie
         DO 707 lw = wrk7lot,wrk7hit
         DO 707 kw = wrk7loz,wrk7hiz 
         DO 707 jw = wrk7loy,wrk7hiy
         DO 707 iw = wrk7lox,wrk7hix
            isave_jsave(iw,jw,kw,lw,mw,nw) = 0.
  707    CONTINUE

         DO 708 nw = wrk8lof,wrk8hif
         DO 708 mw = wrk8loe,wrk8hie
         DO 708 lw = wrk8lot,wrk8hit
         DO 708 kw = wrk8loz,wrk8hiz 
         DO 708 jw = wrk8loy,wrk8hiy
         DO 708 iw = wrk8lox,wrk8hix
            ok(iw,jw,kw,lw,mw,nw) = 0.
  708    CONTINUE

         DO 709 nw = wrk9lof,wrk9hif
         DO 709 mw = wrk9loe,wrk9hie
         DO 709 lw = wrk9lot,wrk9hit
         DO 709 kw = wrk9loz,wrk9hiz 
         DO 709 jw = wrk9loy,wrk9hiy
         DO 709 iw = wrk9lox,wrk9hix
            eofwork(iw,jw,kw,lw,mw,nw) = 0.
  709    CONTINUE


*  Find the number of eofs to solve for.
*  neof = number of (x,y) points with frac_timeser good data.  
*  Set OK to mark where they are.   (note this also allows for 
*  working around continental boundaries or other areas where 
*  entire time series are missing)

         CALL count_neof (arg_1, neof, ok, nx, ny, nt, k1, m1, n1,
     .                    arg_lo_ss, arg_hi_ss, arg_incr, mx,
     .                    bad_flag(ARG1), frac_timeser, err_msg, ier)
         IF (ier .NE. 0) then
            GOTO 5010
         ENDIF

*  Put the data into the array ddat_1d(neof,nt) 

         CALL pack_ef (arg_1, ddat_1d, isave_jsave, neof,  
     .                 ok, frac_timeser, nx, ny, nt, k1, m1, n1,
     .                 arg_lo_ss, arg_hi_ss, arg_incr)

*  Solve for the EOF's: eigenvectors, time functions, percent variance explained.

         CALL solve_eof_space_tgap (ddat_1d, neof, nt, k, m, n, val, vec, 
     .            taf, pct, c, result, isave_jsave, eofwork, res_lo_ss,
     .            res_hi_ss, res_incr, bad_flag(ARG1), bad_flag_result,
     .            frac_timeser, err_msg, ier)
         IF (ier .NE. 0) GOTO 5020

         k1 = k1 + arg_incr(Z_AXIS,ARG1)
  100 CONTINUE
         m1 = m1 + arg_incr(E_AXIS,ARG1)
  200 CONTINUE
         n1 = n1 + arg_incr(F_AXIS,ARG1)
  300 CONTINUE

      RETURN

 5010 CALL ef_bail_out (id, err_msg)
      RETURN

 5020 WRITE (err_out, 5500) k, m, n, err_msg 
 5500 FORMAT ('k,m,n=', 3I3, A250)
      CALL ef_bail_out (id, err_out)
      RETURN

      END

***********************************************************************

      SUBROUTINE solve_eof_space_tgap (ddat_1d, neof, nt, k, m, n, val, vec, 
     .            taf, pct, c, result, isave_jsave, eofwork, res_lo_ss,
     .            res_hi_ss, res_incr, bad_flag_dat, bad_flag_result, 
     .            frac_timeser, err_msg, ier)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

* arguments
      INTEGER neof, nt, k, m, n
      REAL ddat_1d(neof,nt)
      REAL val(*)
      REAL vec(neof, neof)
      REAL taf(neof, nt)
      REAL pct(*)
      REAL c(neof, neof)
      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)
      REAL isave_jsave(wrk7lox:wrk7hix, wrk7loy:wrk7hiy,
     .                 wrk7loz:wrk7hiz, wrk7lot:wrk7hit,
     .                 wrk7loe:wrk7hie, wrk7lof:wrk7hif)
      REAL eofwork(wrk9lox:wrk9hix, wrk9loy:wrk9hiy,
     .             wrk9loz:wrk9hiz, wrk9lot:wrk9hit,
     .             wrk9loe:wrk9hie, wrk9lof:wrk9hif)
      INTEGER res_lo_ss(6), res_hi_ss(6), res_incr(6)
      REAL bad_flag_dat, bad_flag_result, frac_timeser
      CHARACTER*(*) err_msg
      INTEGER ier

* local variables
      INTEGER i, j, l, mm, nn, is, js

      IF (frac_timeser .LT. 1.) THEN
         CALL EOFIN_CHEL_GAP (ddat_1d, neof, nt, val, vec, taf, pct, c, 
     .            eofwork, bad_flag_dat, bad_flag_result, err_msg, ier)
         IF (ier .NE. 0) RETURN
      ELSE
         CALL EOFIN(ddat_1d, neof, nt, val, vec, taf, pct, c, eofwork)
      ENDIF

*  Result is the eigenvectors.

      DO 130 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         DO 120 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            DO 110 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
               result(i,j,k,l,m,n) = bad_flag_result
  110       CONTINUE
  120    CONTINUE
  130 CONTINUE

      DO 220 nn = 1, neof
         DO 210 mm = 1, neof
            IF (res_lo_ss(X_AXIS) .EQ. ef_unspecified_int4) THEN
               is = ef_unspecified_int4
            ELSE
               is = res_lo_ss(X_AXIS) + isave_jsave(mm,1,1,1,1,1) - 1
            ENDIF

            IF (res_lo_ss(Y_AXIS) .EQ. ef_unspecified_int4) THEN
               js = ef_unspecified_int4
            ELSE
               js = res_lo_ss(Y_AXIS) + isave_jsave(mm,2,1,1,1,1) - 1
            ENDIF

            result(is,js,k,nn,m,n) = vec(mm,nn)

  210    CONTINUE
  220 CONTINUE

      RETURN
      END

      SUBROUTINE CD_GET_MISSING_FLAG (cdfid, varid, vname, do_warn, 
     .        flag, cdfstat)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing

* include files

        include 'netcdf.inc'
	include 'tmap_errors.parm'

* Argument declarations
      LOGICAL do_warn
      INTEGER cdfid, varid, cdfstat
      REAL*8 flag
      CHARACTER*(*) vname

* Local declarations
      LOGICAL CD_GET_ATTVAL, got_bad, got_missing, scaled, got_it, tf2
      INTEGER TM_LENSTR1, vartyp, nvdim, vdims(8), nvatts, vlen, i,
     .        attype
     
      REAL missing_flag, bad_flag, scale_factor, add_offset

      cdfstat = merr_ok

* get the vital statistics for this variable
#ifdef usingDODSf2cUnderscore
      cdfstat = NF_INQ_VAR_(cdfid, varid, vname, vartyp, nvdim, vdims,
     .                 nvatts)
#else
      cdfstat = NF_INQ_VAR (cdfid, varid, vname, vartyp, nvdim, vdims,
     .                 nvatts)
#endif

      vlen = TM_LENSTR1(vname)

      got_it = CD_GET_ATTVAL( cdfid, varid, 'scale_factor',
     .             do_warn,vname(:vlen), scale_factor, 1, cdfstat )
      tf2    = CD_GET_ATTVAL( cdfid, varid, 'add_offset',
     .             do_warn,vname(:vlen), add_offset, 1, cdfstat )
      scaled = got_it .OR. tf2

* netCDF files may use "standard" attributes missing_value and/or
* _FillValue to flag bad data
* For the NOAA COOP standard the missing_value flag must be stored in the
* packed data type.  If so it must be unpacked. 

      got_bad = CD_GET_ATTVAL( cdfid, varid, 'missing_value',
     .         do_warn, vname(:vlen), bad_flag, 1, cdfstat )
      got_missing = CD_GET_ATTVAL( cdfid, varid, '_FillValue',
     .         do_warn, vname(:vlen), missing_flag, 1, cdfstat)

* ... need to unpack the missing_value flag?
*     (note that the netCDF library insists on _FillValue's data type)

      IF ( vartyp.LE.NF_INT .AND. scaled ) THEN
         IF ( got_bad ) THEN
#ifdef usingDODSf2cUnderscore
	     cdfstat = NF_INQ_ATT_(cdfid, varid, 'missing_value', 
     .             attype, i )
#else
	     cdfstat = NF_INQ_ATT (cdfid, varid, 'missing_value', 
     .             attype, i )
#endif
		IF ( attype .EQ. vartyp ) bad_flag =
     .			bad_flag*scale_factor+ add_offset
	     ENDIF

* ... *kob* Also need to see about unpacking _FillValue

         IF ( got_missing ) THEN
#ifdef usingDODSf2cUnderscore
	        cdfstat = NF_INQ_ATT_(cdfid, varid, '_FillValue',
     .             attype, i )
#else
	        cdfstat = NF_INQ_ATT(cdfid, varid, '_FillValue',
     .             attype, i )
#endif
	        IF ( attype .EQ. vartyp ) missing_flag =
     .			missing_flag*scale_factor+ add_offset
	     ENDIF
      ENDIF

*  Return missing flag if it exists, else bad_flag

      IF (got_missing) THEN
         flag =  missing_flag
      ELSE 
         IF ( got_bad ) THEN
            flag =  bad_flag
         ELSE
            flag = 0.
            cdfstat = 0
         ENDIF
      ENDIF

      RETURN
      END

	SUBROUTINE TM_FP_CONVERT(buffer,ncnt,author_cpu)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* convert VAX or IEEE big/little endian into the currently active CPU
* representation

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX/VMS, DEC Ultrix, and SUN
*
* revision 0.0 - 2/11/92 - based on code from Dave Borg-Breen
*  (ref. VAX Professional, August '91)
* bug fix *sh* 3/92 - need special check for exact zero
* replaced "elif" syntax with
*	else
*	   if
*  for SGI port	 - kob 4/8/92
* *kob* 10/96 	- Linux port.  Linux didnt like tabs 
*		  between "include"
*	          and what was being included.  removed them

* calling argument declarations:
	INTEGER ncnt, author_cpu
	REAL    buffer(ncnt)

* internal variable declarations:
        REAL*4    dum
        INTEGER*4 idum, k

#ifdef sun
      include 'xmachine_byte.cmn'
      BYTE bb(4),bdum
#else
                include 'xmachine_int1.cmn'
      		INTEGER*1 bb(4),bdum
#endif

	EQUIVALENCE (bb(1),dum), (idum,dum)


***********   CONVERT between machine types   **************
*** use the pre-processor to select the target word type ***
#ifdef sun
* SUN is the platform in use
      IF     ( author_cpu .EQ. cptype_vax ) THEN   ! VAX -> SUN
	 DO 100 k = 1, ncnt
	    dum = buffer(k)
            IF ( idum .EQ. 0 ) GOTO 100 ! check for exact zero
	    bdum = bb(1)
	    bb(1) = bb(2)-1
	    bb(2) = bdum
	    bdum = bb(4)
	    bb(4) = bb(3)
	    bb(3) = bdum
	    buffer(k) = dum
 100     CONTINUE
      ELSEIF ( author_cpu .EQ. cptype_dec ) THEN   ! SUN <-> DECstation
         DO 200 k = 1, ncnt
	    dum = buffer(k)
            IF ( idum .EQ. 0 ) GOTO 200 ! check for exact zero
	    bdum = bb(1)
	    bb(1) = bb(4)
	    bb(4) = bdum
	    bdum = bb(2)
	    bb(2) = bb(3)
	    bb(3) = bdum
	    buffer(k) = dum
 200     CONTINUE
      ENDIF

#else
#if unix
* DECstation is the platform in use

      IF     ( author_cpu .EQ. cptype_vax ) THEN  ! VAX -> DECstation
	 DO 100 k = 1, ncnt
	    dum = buffer(k)
            IF ( idum .EQ. 0 ) GOTO 100 ! check for exact zero
	    bdum = bb(1)
	    bb(1) = bb(3)
	    bb(3) = bdum
	    bdum = bb(2)
	    bb(2) = bb(4)
	    bb(4) = bdum-1
	    buffer(k) = dum
 100     CONTINUE
      ELSEIF ( author_cpu .EQ. cptype_sun ) THEN  ! SUN <-> DECstation
	 DO 200 k = 1, ncnt
	    dum = buffer(k)
            IF ( idum .EQ. 0 ) GOTO 200 ! check for exact zero
	    bdum = bb(1)
	    bb(1) = bb(4)
	    bb(4) = bdum
	    bdum = bb(2)
	    bb(2) = bb(3)
	    bb(3) = bdum
	    buffer(k) = dum
 200     CONTINUE
      ENDIF

#else
* VAX is the platform in use
      IF     ( author_cpu .EQ. cptype_dec ) THEN    ! DECstation -> VAX
	 DO 100 k = 1, ncnt
	    dum = buffer(k)
            IF ( idum .EQ. 0 ) GOTO 100 ! check for exact zero
	    bdum = bb(1)
	    bb(1) = bb(3)
	    bb(3) = bdum
	    bdum = bb(4)
	    bb(4) = bb(2)
	    bb(2) = bdum+1
	    buffer(k) = dum
 100     CONTINUE
      ELSEIF ( author_cpu .EQ. cptype_sun ) THEN    ! SUN -> VAX
	 DO 200 k = 1, ncnt
	    dum = buffer(k)
            IF ( idum .EQ. 0 ) GOTO 200 ! check for exact zero
	    bdum = bb(2)
	    bb(2) = bb(1)+1
	    bb(1) = bdum
	    bdum = bb(4)
	    bb(4) = bb(3)
	    bb(3) = bdum
	    buffer(k) = dum
 200     CONTINUE
      ENDIF
#endif
#endif

      RETURN
      END

	CHARACTER*(*) FUNCTION VAR_UNITS( cx )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* return units text string for variable

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 4/4/88
* V200:  6/20/89 - eliminated "named" variables
*	  1/3/90 - mr --> cx
*	 1/12/90 - allow unit changes by transforms
*       10/22/92 - added units on uvars
* V420: variable units may be modified by regrid transforms of the variable
* V500: 12/98 *sh* - added cat_const_var ... of the form "{1,3,5}"
* V530  8/00 *sh* - added support for cat_string
* v553 *kob* 9/03- need to add buff, slen for assignment of VAR_UNITS - 
*                  g77 bug would cause crash when trying to prepend chars
*                  onto CHAR function variable 
* v554 *acm* 1/04 - add variable category cat_counter_var
* V600 *acm* 3/06 - add variable category cat_attrib_val
* V698  3/16 *acm* Removed Philander-Seigel code including diagnostic 
*                  variables, pre-defined axes and grids, cat_calc_var.
* V698  3/16 *sh* added logic for cat_ef_time2d (ACTS_LIKE_FVAR)

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include	'xdset_info.cmn_text'
	external xdset_info_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'xtext_info.cmn'
	include	'xcontext.cmn'
	include	'xvariables.cmn'

* calling argument declarations
	INTEGER	cx

* internal variable declarations
	LOGICAL UNIT_CHG_AX, ACTS_LIKE_FVAR
	INTEGER	TM_LENSTR1, slen, category, variable, idim, axis, trans
	CHARACTER*2048 buff

* initialize
	category = cx_category( cx )
	variable = cx_variable( cx )

* select units by category of variable
	IF     ( ACTS_LIKE_FVAR(category) ) THEN

	   VAR_UNITS = ds_var_units( variable )

	ELSEIF ( category .EQ. cat_user_var ) THEN

	   VAR_UNITS = uvar_units( variable )

	ELSEIF ( category .EQ. cat_pseudo_var 
     .	   .OR.  category .EQ. cat_constant
     .	   .OR.  category .EQ. cat_string
     .	   .OR.  category .EQ. cat_const_var
     .	   .OR.  category .EQ. cat_counter_var
     .	   .OR.  category .EQ. cat_attrib_val ) THEN

	   VAR_UNITS = ' '

	ELSE

	   VAR_UNITS = 'unit_err'

	ENDIF

* certain transformations change the units
	IF ( UNIT_CHG_AX( cx, idim, trans ) ) THEN
	   IF ( trans .EQ. punit_mod_loc ) THEN
	      axis = grid_line( idim, cx_grid(cx) )
	      VAR_UNITS = line_units( axis )
	   ELSEIF ( trans .EQ. punit_mod_variance ) THEN
	      IF ( VAR_UNITS .NE. ' ' ) THEN
	         slen = TM_LENSTR1(VAR_UNITS)
		 buff = VAR_UNITS
	         VAR_UNITS = '('//buff(:slen) // ')^2'
	      ENDIF
	   ELSEIF ( trans .EQ. punit_mod_npoints ) THEN
	      VAR_UNITS = '# of points'
	   ENDIF	      

	ENDIF

	RETURN
	END

	SUBROUTINE GET_CONTEXT_GRID ( cx, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine the grid to use for a single variable evaluation
* the given context must have the logical cx_unstand_grid set and
* if .TRUE. it must have a cx_grid value

* (9/95) if cx_has_impl_grid is set then we must reconcile the grid that
* is implied (cx_impl_grid) with a grid that may or may not have been
* explicitly mentioned (cx_grid).
*	If they match -- return the explicit grid
*	If they don't -- complete the implicit grid definition
* If an implicit grid matches an existing non-implicit grid return that,
* else "allocate" an implicit grid (either by creating one or by incrementing
* the usage count for that grid)
* Also, if delta specifications were used (e.g. var[i=1:100:10]) then an
* implicit axis AND grid must be created.


* FERRET DOCUMENTATION: MANAGING DYNAMIC GRIDS AND AXES:  OVERVIEW

*************************************
* *** MANAGING DYNAMIC GRIDS AND AXES:  OVERVIEW  ***

* see also explanations of TMAP library grid and axis allocation schemes
* in routines TM_ALLO_DYN_GRID and TM_ALLO_DYN_LINE

* Implicit (dynamic) grids and axes must be tracked so that 1) they
* are deleted when no longer needed and 2) they are never deleted
* while still in use.  Deletion makes the "slot" available for re-use.
* The information indicating when a dynamic grid or line is needed is
* contained in its "use count" (use_cnt).  At various points the terms
* "incrementing", "allocating" and "using" may be used synonymously.
* These refer to TM_ALLO_DYN_... and TM_USE_.... Similarly,
* "decrementing" is the same as TM_DEALLOC_DYN_...  Deallocation may
* or may not be the same as "deletion" of a grid or line -- it will be
* deleted only if its usage count falls to zero.

* Grids have their use count incremented for each user variable (or
* intermediate result) that depends on the grid.  The "intermediate
* result" refers to entities that come into existence only briefly
* during the evaluation of an expression.  Take, for example, the
* expression "VAR[gx=var2] + 5":  during the "get_grid" phase a
* dynamic grid is determined for this expression and pointed to by
* uvar_grid.  As a result of this "usage" the grids use-cnt is
* incremented (from 0 to 1 if it is newly created).  Now during the
* evaluation of the expression the intermediate result "VAR[gx=var2]"
* will be passed to to GET_VAR_CONTEXT.  The routines GET_CONTEXT_MODS
* and GET_CONTEXT_GRID will determine a grid for this sub-expression.
* Since this grid happens to be the same as the grid of the full
* expression (which differs only in the addition "+5") the use count
* will be momentarily incremented (from 1 to 2) while this
* intermediate result exists on the stack.

* Usage of dynamic grids by intermediate results is tracked with the
* boolean cx_has_impl_grid -- i.e. responsibility for incrementing and
* decrementing lies with the **context**.  This responsibility may be
* passed from one intermediate result to another.

* A lines (axis) has its use count incremented whenever a grid uses
* the line or whenever another (dynamic) line is created as a child of
* this line.  Correspondingly the use count is decremented (resulting
* in deletion if it falls to zero) whenever the corresponding grid or
* child axis is deleted.  The responsibility in the grids is indicated
* by grid_line(idim,grid) > max_lines.  The responsibility in child
* lines is indicated in line_parent.  The responsibility for the line
* may be transferred from one grid to another (see calls to
* TM_COPY_GRID_W_LINE_USE)
* Note: as of 4/00 ALL grids and axes maintain use counts

*************************************


* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* revision 0.0 - 10/14/86
* revision 0.1 - 2/18/88 - checks for unspecified grid ( used to flag computed
*			   variables that are non-GFDL/205 output )
* revision 0.2 -  4/7/88 - improved error message for calculated vars
* revision 0.3 -  4/1/89 - determine regridding transformations

* V230: 8/23/92 - impose xyave regrid if appropriate (was in GET_CONTEXT_MODS)
* V420: 9/95	- Support for implicit grid: flesh out the grid here
*	10/95	- support for implicit axes: create axes here and insert
*		  into implicit grid
*	 1/96	- idim subscripting bug fixed 1/96 ... how did it escape?

* $Id: get_context_grid.F 21539 2016-03-29 00:35:18Z hankin $ 
*       - add check on cx_calendar rather than cx_lo/hi_ww to indicate whether time
*         is date or timesteps
* V500 *kob* 3/99- up VAR_CODE decl from 8 to 64 chars
* V510: *sh* 9/99 - bug revealed while implementing SAMPLE* functions
*		if cx_unstand_grid is FALSE on coming into this routine
*		then the basic grid for the result shoud be std_grid. The
*		value of use_grid upon entry cannot be trusted to be correct
*	*sh* 4/00 - since netCDF dsets use dynamic grids now, all grids and
*		  lines maintain a use count
* V520: 6/00 *sh* - bug fix - if the quick exit is taken here because
*		std_grid is not yet known the axes within the implicit grid
*		were never allocated so dont deallocate them
* V532: *sh* 6/01 - bug fix: err522_impl_ax_ignored.jnl -- the variable
*		impl_grid wasn't initialized if cx_impl_grid was set
*		in get_context_mods by gx=name
* V533: *sh* 6/01 - set regrid transform for strides to prgrd_xact_pts
* V552 *acm* 4/03- up VAR_CODE decl from 64 to 128 chars
* V671  6/11 *acm*  New 2D linear xy regridding, fixing ticket 1862
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction. The time 
*                  dimension is now an arg to SECS_TO_TSTEP.
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V690 12/13 *sh* set default regrid transforms for aux var regridding transform
*	          set up dynamic axis if cx_delta=pauto_1pt_ax
*      4/14  *sh* return standard grid if "false regridding" - 1 pt curvi
* V695  *acm* 2/15 cx_calendar stores info about formatting of T and F axes
* V695+  *sh* 3/15 assign regrid transform for T-F plane FMRC regridding
* V698+  *sh* 5/15 ax units for gz(density)=lo:hi:del should come from aux var
*		   only partially fixed here: T0 not parsed from auxvar units
* V698  3/16 *acm* Removed Philander-Seigel code including diagnostic 
*                  variables, pre-defined axes and grids, cat_calc_var.
* V698  3/16 *sh* added logic for cat_ef_time2d (ACTS_LIKE_FVAR)
*                 more sophisticated logic to determine an implied "@FMRC"

	include 'errmsg.parm'
	include 'ferret.parm'
	include 'interp_stack.parm'
	include 'tmap_dims.parm'
	include 'xcontext.cmn'
	include 'xalgebra.cmn'
	include 'xtext_info.cmn'
	include 'xprog_state.cmn'
	include 'implicit.parm'
	include 'tmap_errors.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xfr_grid.cmn'   ! stack ptr should be in TMAP lib
	include 'xunits.cmn_text'

* calling argument declarations:
	INTEGER	cx, status

* internal variable declarations:
        LOGICAL   GEOG_COS_FACTOR, GEOG_LABEL, ACTS_LIKE_FVAR,
     .		  ITS_FMRC_2DTIME,
     .		  its_dyn, has_impl_axis, explicit_unstd, use_std_grid,
     .		  made_aux_line_dummy, at_fmrc
	INTEGER	  KNOWN_GRID, TM_UNIT_ID,
     .		  use_grid, ilo, ihi,
     .		  cat, var, dset, std_grid, std_axis, use_axis, idim,
     .		  base_grid, impl_grid, src_line
	REAL*8	  SECS_TO_TSTEP, dlo, dhi, delta
	CHARACTER VAR_CODE*128, AUX_VAR_UNITS*64

* initialize
	made_aux_line_dummy = .FALSE.
	cat  = cx_category( cx )
	var  = cx_variable( cx )
	dset = cx_data_set( cx )
        use_grid = cx_grid( cx )
	explicit_unstd = cx_unstand_grid( cx ) ! 9/99

* by this point the variable and data set must be known
	IF ( var .EQ. unspecified_int4 )	CALL ERRMSG
     .			( ferr_syntax,status,'no variable specified',*5000 )
	IF (  ACTS_LIKE_FVAR(cat) .AND. dset.EQ.unspecified_int4 )
     .	  CALL ERRMSG( ferr_state_not_set,status,'SET DATA_SET',*5000 )

* determine the standard grid for this variable
	std_grid = KNOWN_GRID( dset, cat, var )

* if the standard grid isn't known then return to the stack to get it
	IF ( std_grid .EQ. unspecified_int4 ) THEN
	   IF ( cx_has_impl_grid(cx) ) THEN
#ifdef debug_dyn_grids
	      IF ( mode_diagnostic )  CALL DIAG_OP
     .	     ('dealloc ',isact_class_impl_grid,cx_impl_grid(cx),0)
#endif
* ... grid was barely started by GET_CONTEXT_MODS. Axes were never allocated
	      CALL DEALLO_UNFORMED_GRID(status)
	   ENDIF
	   RETURN
	ENDIF

* regridding implied through delta values or special transformations?
	has_impl_axis = .FALSE.
	DO 10 idim = 1, nferdims
	   IF (cx_delta(idim,cx) .NE. unspecified_val8) THEN
* ... make sure the specified delta makes sense (this test moved 1/96)
	      IF ( cx_delta(idim,cx) .NE. unspecified_val8
     .	     .AND. cx_delta(idim,cx) .NE. pauto_1pt_ax
     .	     .AND. cx_delta(idim,cx) .LE. 0.0D0		) GOTO 5200
	      has_impl_axis = .TRUE.
	   ENDIF
 10	CONTINUE
	IF ( has_impl_axis ) THEN

* ... we need an implicit grid to hold the axes so make it if we don't have one
	   IF ( .NOT.cx_has_impl_grid(cx) ) THEN
	      CALL ALLO_GRID_TO_CX( cx, impl_grid, status )
	      IF (status .NE. ferr_ok) GOTO 5000
	      cx_unstand_grid(cx) = .TRUE.
	   ELSE
	      impl_grid = cx_impl_grid(cx)  ! allo'd in get_context_mods 
	   ENDIF
* ... make the implicit axes and save them in the implicit grid
	   DO 20 idim = 1, nferdims
	      IF (cx_delta(idim,cx) .NE. unspecified_val8) THEN
! ... trap for twice-defined axis of implicit grid is removed because
!	var[g=var2,gx=lo:hi:del] needs to be a legal expression
!	         IF ( grid_line(idim,impl_grid).NE.unspecified_int4 )
!     .							GOTO 5100
	         IF ( cx_by_ss(idim,cx) ) THEN
* ... clip to axis ss limits
	            CALL GRID_SUBSCRIPT_EXTREMES(ilo, ihi, std_grid, idim)
		    IF (cx_lo_ss(cx,idim) .LT. ilo ) THEN	! ilo is 1
! unused code: "modulo clip" -> ss #1 to be a multiple of delta from users strt
!	               n = 1 - INT(cx_lo_ss(cx,idim)/cx_delta(idim,cx))
!	               dlo = cx_lo_ss(cx,idim) + n * cx_delta(idim,cx)
	               dlo = 1
	            ELSE
	               dlo = cx_lo_ss(cx,idim)
	            ENDIF
	            dlo = MAX(ilo, cx_lo_ss(cx,idim))
	            dhi = MIN(ihi, cx_hi_ss(cx,idim))
	            IF ( dlo .GT. dhi ) GOTO 5300
	            CALL TM_GET_LIKE_DYN_LINE(	idim,
     .						dlo,
     .						dhi,
     .						cx_delta(idim,cx),
     .						grid_line(idim,std_grid),
     .						pline_class_stride,
     .						grid_line(idim,impl_grid),
     .						status)
	            cx_lo_ss(cx,idim) = 1
	            cx_hi_ss(cx,idim) = line_dim(grid_line(idim,impl_grid))
	            IF (cx_regrid_trans(idim,cx) .EQ. unspecified_int4 )
     .			 cx_regrid_trans(idim,cx) = prgrd_xact_pts
	         ELSE
* ... dont clip to axis world limits
* Note: It would be nicer not to clip but instead to allow any new size of
*	dynamic axis.  Some time spent on this produced "explicit limit"
*	errors from PASS_AMBIG_LIMS -- but only for irregular axis.  See
*	try_impl_line_{ok,bad}.jnl in $fsrc/errors
* ... copy into buffers because dates need to be modified to time steps
	            dlo = cx_lo_ww(idim,cx)
	            dhi = cx_hi_ww(idim,cx)
	            delta = cx_delta(idim,cx)
	            IF (delta .EQ. pauto_1pt_ax) THEN
	               IF (dlo .EQ. dhi) THEN
* generate a single point axis.  The delta of such a line is arbitrary.
	                  IF (dlo .EQ. 0.0) THEN
	                     delta = 0.00001
	                  ELSE
	                     delta = dlo * 0.00001
	                  ENDIF
	               ELSE
	                  delta = dhi - dlo
	                  dlo   = (dlo + dhi)/2
	                  dhi   = dlo 
	               ENDIF
	            ENDIF
	            IF (idim.EQ.t_dim .OR. idim.EQ.f_dim) THEN
* 8/97 *kob* use cx_calender to check if time is date rather than time step
	               IF ( cx_calendar(idim,cx) ) THEN
	                  IF (.NOT.GEOG_LABEL(idim,std_grid)) GOTO 5400
	                  dlo = SECS_TO_TSTEP(std_grid,idim,-1.*cx_lo_ww(idim,cx))
	                  dhi = SECS_TO_TSTEP(std_grid,idim,-1.*cx_hi_ww(idim,cx))
			  delta = delta * 3600
     .				/ line_tunit(grid_line(idim,std_grid)) !was hrs
	               ENDIF
	            ENDIF
* 5/15 ax units for gz(density)=lo:hi:del come from aux var
	            IF ( cx_naux(cx) .GT.0
     .		   .AND. cx_aux_var(idim,cx) .NE. unspecified_int4 ) THEN
* ... set up specimen line using units information from the auxiliary variable
	               CALL TM_MAKE_BASIC_AXIS('tmp_aux_line_dummy',0.,1.,1,
     .		       src_line, status)
	               made_aux_line_dummy = .TRUE.
	               line_units(src_line) = AUX_VAR_UNITS(cx,idim)
	               line_unit_code(src_line) = TM_UNIT_ID(line_units(src_line))
	               line_tunit(src_line) = un_convert(line_unit_code(src_line))
* ** MORE TO BE DONE:  line_t0 and calendar need to be set as in cd_get_1_axis.F
	            ELSE
	               src_line = grid_line(idim,std_grid)
	            ENDIF
	            CALL TM_GET_LIKE_DYN_LINE(	idim,
     .						dlo,
     .						dhi,
     .						delta,
     .						src_line,
     .						pline_class_basic,
     .						grid_line(idim,impl_grid),
     .						status)
	         ENDIF
	         IF ( status .NE. ferr_ok ) GOTO 5000
!! this commented out block didn't work because an unspecified region
!!   lead to the SET REGION default being imposed with ss limits in conflict
!!   with the dynamic axis dimension
!! Set up to look like regridding was requested without the limits specified
!! This is so there is no conflict of explicit limits in cases like
!!     LET a = var[i=lo1:hi1:del];   LIST a[i=lo2:hi2]
!	         cx_lo_ss(cx,idim) = unspecified_int4
!	         cx_hi_ss(cx,idim) = unspecified_int4
!	         cx_lo_ww(idim,cx) = unspecified_val8
!	         cx_hi_ww(idim,cx) = unspecified_val8
!	         cx_given(idim,cx) = .FALSE.
	         cx_delta(idim,cx) =  unspecified_val8
	      ENDIF
 20	   CONTINUE
	ENDIF

* use the standard grid ?
* 4/14 cx_unstand_grid may indicate a "false regrid" used for single point curvi results
* note that false regridding may not have been checked in all possible combos of
* delta values on other axes, etc.
	use_std_grid = .NOT. cx_unstand_grid( cx )
	DO idim = 1, nferdims
	   IF (cx_aux_stat(idim,cx) .EQ. paux_stat_false_1pt_regrid)
     .			use_std_grid = .TRUE.
	ENDDO
	IF ( use_std_grid ) THEN
	   cx_grid( cx ) = std_grid
	   RETURN
	ENDIF

* handle implicit (dynamic) grid creation
	IF ( cx_has_impl_grid(cx) ) THEN
* ... build a (temporary) implicit grid (9/99 logic mod)
	   IF ( explicit_unstd
     .	  .AND. use_grid .NE. unspecified_int4 ) THEN
	      base_grid = use_grid
	   ELSE
	      base_grid = std_grid
	   ENDIF
	   impl_grid = cx_impl_grid(cx)
* ... any axis that wasn't given by the user comes from the source grid
	   DO 50 idim = 1, nferdims
	      IF ( grid_line(idim,impl_grid).EQ.unspecified_int4 )
     .		   grid_line(idim,impl_grid) = grid_line(idim,base_grid)
 50	   CONTINUE
	   use_grid = impl_grid

* increment the use count of dynamic axes that are in-use by the temporary grid
	   DO 60 idim = 1, nferdims
 60	   CALL TM_USE_LINE(grid_line(idim,impl_grid))
	ENDIF

* 9/95 check for incompatibilities in grid geometry -- requiring implicit grid
* (i.e. chk for a normal axis in one grid without same in other)
	DO 70 idim = 1, nferdims
	   IF (  (grid_line(idim,std_grid).EQ.mnormal)
     .    .NEQV. (grid_line(idim,use_grid).EQ.mnormal) )   THEN
* ... allocate and initialize some work space if we don't already have it
	      IF (.NOT.cx_has_impl_grid(cx)) THEN 
	         CALL ALLO_GRID( impl_grid,status )
	         IF (status .NE. ferr_ok) GOTO 5000
	         CALL TM_COPY_GRID_W_LINE_USE(use_grid, impl_grid)
	         grid_name(impl_grid) = '(conformable)'
	         cx_has_impl_grid(cx) = .TRUE.
!	         cx_impl_grid(cx) = impl_grid
#ifdef debug_dyn_grids
                 IF ( mode_diagnostic )  CALL DIAG_OP
     .              ('allocate', isact_class_impl_grid, impl_grid, 0)
#endif
	      ENDIF
	      CALL TM_DEALLO_DYN_LINE(grid_line(idim,impl_grid))
	      grid_line(idim,impl_grid) = grid_line(idim,std_grid)
	      CALL TM_USE_LINE(grid_line(idim,impl_grid))
	   ENDIF
 70	CONTINUE

* catalog implicit definition (which is temporarily stored on the grid
* stack) as a dynamic grid -- checking for existing matching grids
	IF ( cx_has_impl_grid(cx) ) THEN
	   CALL TM_GET_LIKE_DYN_GRID(impl_grid,its_dyn,use_grid,
     .			grd_stk_ptr, status)
	   IF (status .NE. merr_ok) GOTO 5000
	   IF ( its_dyn ) THEN
	      IF ( mode_diagnostic )  CALL DIAG_OP
     .	     ('allocate', isact_class_impl_grid, use_grid, 0)
	   ELSE
	      cx_has_impl_grid(cx) = .FALSE.
	   ENDIF

* ... deallocate the (now unnecessary) implicit stack-based grid
#ifdef debug_dyn_grids
	   IF ( mode_diagnostic )  CALL DIAG_OP
     .	  ('dealloc ', isact_class_impl_grid, impl_grid, 0)
#endif
	   CALL DEALLO_GRID(status)

	   cx_grid(cx) = use_grid
	ENDIF

* flesh out regridding transformations
	DO 100 idim = 1, nferdims
	   use_axis = grid_line( idim, use_grid )
	   std_axis = grid_line( idim, std_grid )

* ... this only means that it *may be* an implied "@FMRC"
	   at_fmrc = (idim.EQ.t_dim .OR. idim.EQ.f_dim)
     .             .AND. cx_aux_var(idim,cx) .NE. unspecified_int4

	   IF ( use_axis .EQ. std_axis ) THEN
	      cx_regrid_trans( idim, cx ) = prgrd_exact
	   ELSEIF ( cx_regrid_trans(idim,cx) .EQ. unspecified_int4 ) THEN
	      IF (cx_naux(cx) .EQ. 0) THEN
	         cx_regrid_trans( idim, cx ) = prgrd_linear_interp
	      ELSEIF ( at_fmrc 
     .		.AND. cx_aux_var(t_dim,cx) .EQ. cx_aux_var(f_dim,cx) ) THEN
	         cx_regrid_trans( idim, cx ) = pauxrgrd_fmrc ! T-F plane 
	      ELSE
! 3/2016 - "@FMRC" is implied whenever aux T or F regrid with 2dtime as aux var
	         IF (at_fmrc) THEN
	            at_fmrc = (cx_aux_cat(idim,cx) .EQ. cat_file_var
     .                    .OR. cx_aux_cat(idim,cx) .EQ. cat_agg_f_var)
     .             .AND.      ITS_FMRC_2DTIME(dset, cx_aux_var(idim,cx))
	         ENDIF
	         IF (at_fmrc) THEN
	            cx_regrid_trans( idim, cx ) = pauxrgrd_fmrc
	         ELSE
	            cx_regrid_trans( idim, cx ) = pauxrgrd_linear
	         ENDIF
	      ENDIF
	   ENDIF
 100	CONTINUE

* change X and Y linear average to area average if appropriate  ! 8/92
        IF ( cx_regrid_trans(x_dim,cx) .EQ. prgrd_average
     . .AND. cx_regrid_trans(y_dim,cx) .EQ. prgrd_average ) THEN
           IF ( GEOG_COS_FACTOR(y_dim,std_grid)
     .    .AND. GEOG_COS_FACTOR(y_dim,use_grid) ) THEN
              cx_regrid_trans(x_dim,cx) = prgrd_xy_ave
              cx_regrid_trans(y_dim,cx) = prgrd_xy_ave
           ENDIF
        ENDIF

* change X and Y linear interpolation to call do_xylin_regrid if appropriate  ! 6/11
        IF ( cx_regrid_trans(x_dim,cx) .EQ. prgrd_linear_interp
     . .AND. cx_regrid_trans(y_dim,cx) .EQ. prgrd_linear_interp ) THEN
           IF ( GEOG_COS_FACTOR(y_dim,std_grid)
     .    .AND. GEOG_COS_FACTOR(y_dim,use_grid) ) THEN
              cx_regrid_trans(x_dim,cx) = prgrd_xy_lin
              cx_regrid_trans(y_dim,cx) = prgrd_xy_lin
           ENDIF
        ENDIF

 5000	IF (made_aux_line_dummy) CALL TM_DEALLO_DYN_LINE(src_line) ! is this needed?
	RETURN

* error exits
! 5100	CALL ERRMSG( ferr_invalid_command, status,
!     .		'mixed regridding and delta limits on '//ww_dim_name(idim)
!     .		//' axis of '//VAR_CODE(cx_category(cx),cx_variable(cx)),
!     .								*5000)
 5200	CALL ERRMSG( ferr_invalid_command, status,
     .		'delta non-positive on '//ww_dim_name(idim)
     .		//' axis of '//VAR_CODE(cx_category(cx),cx_variable(cx)),
     .								*5000)
 5300	CALL ERRMSG( ferr_invalid_command, status,
     .		'outside limits: '//ww_dim_name(idim)
     .		//' axis of '//VAR_CODE(cx_category(cx),cx_variable(cx)),
     .								*5000)
 5400	CALL ERRMSG( ferr_invalid_command, status,
     .		'Cannot use dates - not a calendar axis: '//
     .		VAR_CODE(cx_category(cx),cx_variable(cx)),
     .								*5000)
	END

	SUBROUTINE COPY_2D_TO_3D_SUB (
     .		src, slox, shix, sloy, shiy,             slot, shit,
     .		dst, dlox, dhix, dloy, dhiy, dloz, dhiz, dlot, dhit )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* support routine for COPY_2D_TO_3D with unsubscripted limits

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200: 10/12/89
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
* TODO: what changes to make for 6D Ferret?

	include 'tmap_dims.parm'
	include 'ferret.parm'

* calling argument declarations:
	INTEGER slox, shix, sloy, shiy,             slot, shit,
     .		dlox, dhix, dloy, dhiy, dloz, dhiz, dlot, dhit
	REAL    src( slox:shix,sloy:shiy,          slot:shit ),
     .		dst( dlox:dhix,dloy:dhiy,dloz:dhiz,dlot:dhit )

* internal variable declarations:
	INTEGER	i, j, k, l, k1

* --- end of introductory code ---

* copy one XY plane to the dstination grid
	k1 = dloz

	DO 100 l = dlot, dhit
	DO 100 j = dloy, dhiy
	DO 100 i = dlox, dhix

	   dst(i,j,k1,l) = src(i,j,l)

 100	CONTINUE

* (no check for bad data - same flag assumed on source and destination)

* now replicate along the Z axis
	DO 210 k = k1+1, dhiz

	   DO 200 l = dlot, dhit
	   DO 200 j = dloy, dhiy
	   DO 200 i = dlox, dhix
 200	   dst(i,j,k,l) = dst(i,j,k1,l)

 210	CONTINUE

	RETURN
	END 

	SUBROUTINE XYAVE_REGRID( cx_lims,
     .				 dst_lox, dst_hix, dst_loy, dst_hiy,
     .				 src, msrc, dst, mdst,
     .			         src_cx, dst_cx, i21,j21)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* 	Using data values from src organized on grid src_grid, regrid to
* 	grid dst_grid by averaging withing boxes

* 	msrc and mdst point to data structures in COMMON/XVARIABLES/ which

* 	specify the subscript bounds of src and dst within their 
* 	respective grids.

* 	Both src and dst are assumed to be 2 dimensional structures
* 	lying in the same plane - given by mr_DIM1 and mr_DIM2.

*	I21 and J21 hold the indices of source grid boxes (on src_grid) for box
*	limits on dst_grid.

* 	programmer - Steve Hankin
* 	NOAA/PMEL,Seattle,WA - Tropical Modeling and Analysis Program
* 	written for VAX computer under VMS operating system

* 	revision 0.0 -  1/9/89 
* V200: 12/1/89 - 4D symmetrical version
* note: the conversion to 4D is of the Q&D variety.  Optimization is possible
*	by providing additional work space and pre-computing the box sizes
*	along the X and Y axes
* V314&V400: 9/94 - bug fix: GOTO 50 ==> GOTO 60 for missing source value

* v552: *acm* 4/03 In some cases the source indices include a range
*                  outside the destination indices, so xdist or ydist < 0. 
*                  Test for this and only have a contribution to the avg from 
*                  portions of the source axis that overlap the dest box.
*                  Also, use src_lo_ss and src_hi_ss for the range on the src
*                  axis rather than mr_lo_ss and mr_hi_ss
* v570 *acm* 5/04 Range of subscripts might be negative, and contain 
*                 -111 among them. Allow regridding, using the flags 
*                 ok_negi111, ok_negj111 to distinguish this case from 
*                 the flag unspecified_int4.
* V600  4/06 *acm* - make refinement to cos(lat) factor as suggested by A. Wittenberg
* V600  4/06 *acm* - additional declarations found by Solaris compiler
* 6/06 - Fix to Andrew*s correction for XY integ., bug1348
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'
	include	'xmem_subsc.cmn'
	include 'xvariables.cmn'

* calling argument declarations:
	INTEGER	cx_lims, msrc, mdst, dst_lox, dst_hix,
     .          dst_loy, dst_hiy, src_cx, dst_cx 
	INTEGER	i21(dst_lox:dst_hix+1),
     .		j21(dst_loy:dst_hiy+1)

	REAL    src( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          dst( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif )

* local variable declarations:
	LOGICAL GEOG_COS_FACTOR,
     .          need_cos, ok_negi111, ok_negj111

	INTEGER idst, isrc, jdst, jsrc, dim1, dim2,
     .          src_grid, dst_grid, k, l, m, n,
     .          isrc_lo, isrc_hi, jsrc_lo, jsrc_hi,
     .          idst_lo, idst_hi, jdst_lo, jdst_hi

	REAL	AXIS_DISTANCE, BOX_SIZE,
     .          xdist, ydist, area, sum, darea, bad_src, bad_dst,
     .          cos_fact, area_earth, ybxlo, ybxhi, yh 

        REAL*8	TWORLD,
     .          xsrc_lo, xsrc_hi, ysrc_lo, ysrc_hi,
     .          xdst_lo, xdst_hi, ydst_lo, ydst_hi
********************************************************************************

* initialize

	src_grid = mr_grid( msrc )
	dst_grid = mr_grid( mdst )
	dim1     = x_dim
	dim2     = y_dim

* need to include COSINE factor ?
	need_cos = GEOG_COS_FACTOR( dim2, dst_grid )

* limits for calculation
        isrc_lo = cx_lo_ss(src_cx,dim1)
        isrc_hi = cx_hi_ss(src_cx,dim1)
        jsrc_lo = cx_lo_ss(src_cx,dim2)
        jsrc_hi = cx_hi_ss(src_cx,dim2)

        idst_lo = cx_lo_s1(cx_lims)
        idst_hi = cx_hi_s1(cx_lims)
        jdst_lo = cx_lo_s2(cx_lims)
        jdst_hi = cx_hi_s2(cx_lims)

* flag for bad/missing data
        bad_src = mr_bad_data(msrc)
        bad_dst = mr_bad_data(mdst)

* determine the source grid boxes containing the destination box edges

	CALL GET_AVE_LIMS( isrc_lo, isrc_hi, src_grid,
     .			   idst_lo, idst_hi, dst_grid,
     .			   dim1, i21 )
	CALL GET_AVE_LIMS( jsrc_lo, jsrc_hi, src_grid,
     .			   jdst_lo, jdst_hi, dst_grid,
     .			   dim2, j21 )

    
* Range of subscripts might be negative, and contain -111 among them.
* ok_negi111, ok_negj111 distinguish between this and the flag unspecified_int4.

        ok_negi111 = ( i21(idst_lo) .LT. unspecified_int4 .AND.
     .                 i21(idst_hi) .GT. unspecified_int4 )

        ok_negj111 = ( j21(jdst_lo) .LT. unspecified_int4 .AND.
     .                 j21(jdst_hi) .GT. unspecified_int4 )


* loop over Z, T, E, and F ranges of 6-D data
	DO 100 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	DO 100 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	DO 100 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	DO 100 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)

* loop through the each destination grid box
	DO 60 jdst = jdst_lo,jdst_hi
	jsrc_lo = j21(jdst)
	jsrc_hi = j21(jdst+1)
	ydst_lo = TWORLD(jdst, dst_grid, dim2, box_lo_lim )
	ydst_hi = TWORLD(jdst, dst_grid, dim2, box_hi_lim )
	DO 60 idst = idst_lo,idst_hi
	   isrc_lo = i21(idst)
	   isrc_hi = i21(idst+1)

*  check if requested region is out of source range
           IF ( ( (isrc_lo .EQ. unspecified_int4
     .    .OR.     isrc_hi .EQ. unspecified_int4)
     .            .AND. .NOT. ok_negi111 )
     .    .OR.  ( (jsrc_lo .EQ. unspecified_int4
     .    .OR.     jsrc_hi .EQ. unspecified_int4)
     .            .AND. .NOT. ok_negj111 ) ) THEN
	      dst(idst,jdst,k,l,m,n) = bad_dst
	      goto 60
	   ENDIF

	   xdst_lo = TWORLD(idst, dst_grid, dim1, box_lo_lim )
	   xdst_hi = TWORLD(idst, dst_grid, dim1, box_hi_lim )

! m_radius in ferret.parm
! area_earth used as a scaling factor that gets cancelled out; is it really needed?
           area_earth = 4. * 3.141592653 * m_radius**2

* add all partial or complete boxes of data from the source grid
* 3/06 - apply Andrew*s suggested correction, bug1348

	   sum  = 0.0
	   area = 0.0
	   DO 51 jsrc = jsrc_lo, jsrc_hi
	   cos_fact = 1.0
	   IF ( need_cos ) THEN

C See this thread:
C http://www.pmel.noaa.gov/maillists/tmap/ferret_users/fu_2009/msg00506.html
C And also ticket 1348.

              ybxlo = deg2rad* TWORLD(jsrc,src_grid,dim2,box_lo_lim)
              ybxhi = deg2rad* TWORLD(jsrc,src_grid,dim2,box_hi_lim)
	      
	      yh = ybxhi-ybxlo  
              cos_fact = ABS( SIN(ybxhi) - SIN(ybxlo) )/ yh

	   ENDIF

	   ysrc_lo = MAX( TWORLD(jsrc,src_grid,dim2,box_lo_lim), ydst_lo)
	   ysrc_hi = MIN( TWORLD(jsrc,src_grid,dim2,box_hi_lim), ydst_hi)
	   ydist   = AXIS_DISTANCE( ysrc_lo, ysrc_hi, dim2, src_grid )

	   DO 50 isrc = isrc_lo, isrc_hi

* ... ignore missing source data
	      IF ( src(isrc,jsrc,k,l,m,n) .EQ. bad_src ) GOTO 50

	      xsrc_lo = MAX( TWORLD(isrc,src_grid,dim1,box_lo_lim), xdst_lo )
	      xsrc_hi = MIN( TWORLD(isrc,src_grid,dim1,box_hi_lim), xdst_hi )
	      xdist   = AXIS_DISTANCE( xsrc_lo, xsrc_hi, dim1, src_grid )

* ... contribution from this source box
*     1/area_earth factor cancels out in result average
              IF (xdist .gt. 0.  .AND.  ydist .GT. 0) THEN
	         darea = ydist*(cos_fact*xdist) / area_earth
	         area  = area + darea
	         sum   = sum  + darea * src(isrc,jsrc,k,l,m,n)
              ENDIF

 50	      CONTINUE
 51	   CONTINUE
* ... divide by area to get average
	   IF ( area .GT. 0.0 ) THEN
	      dst(idst,jdst,k,l,m,n) = sum / area
	   ELSE
	      dst(idst,jdst,k,l,m,n) = bad_dst
	   ENDIF

 60	CONTINUE

 100	CONTINUE

	RETURN
	END

	REAL*8 FUNCTION TM_DATE_TO_STEP ( dset_num, date, status )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* This function will return a REAL*8 number giving the time step for a given
* date for a particular data set. This is done by figuring the offset from
* 01-JAN-0000 00:00:00 in seconds, and then calculating the timestep.
*
* written 06/17/87 by Mark Verschell for PMEL/TMAP
*
* revision 0.00	- 06/17/87 - initial incarnation
* revision 0.01 - 07/08/88 - Returns status code, handles errors from
*			     TM_BREAK_DATE
* V5.3 *acm* 1/01  add cal_id for TM_BREAK_DATE
** V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* Arguments:
*	dset_num - data set number
*	date	 - date of interest
*	status   - returning status
*
	CHARACTER*20	date
	INTEGER		dset_num, status
*
* Inclusions
*

	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
	include 'xdset_info.cmn_text'
	external xdset_info_data

*
* Local definitions
*
	INTEGER		year, month, day, hour, minute, second, istat,
     .			t0year, t0mon, t0day, t0hour, t0min, t0sec

	INTEGER		TM_GET_CALENDAR_ID, cal_id
	REAL*8		date_secs, start_secs, offset_secs
	REAL*8		TM_SECS_FROM_BC

* Break up the date string to it's various components

        cal_id = TM_GET_CALENDAR_ID (ds_cal_name(dset_num) )
	CALL TM_BREAK_DATE ( date, cal_id, year, month, day, 
     .	                     hour, minute, second, istat)
	IF ( istat .NE. merr_ok ) GOTO 9000

* Find the offset from 01-JAN-0000 00:00:00 for this date
	date_secs = TM_SECS_FROM_BC (cal_id, year, month, day,
     .				     hour, minute, second, status)
	IF ( status .NE. merr_ok ) GOTO 9990

* First find the offset from 01-JAN-0000 00:00:00 from the descriptor file
	CALL TM_BREAK_DATE (ds_t0time(dset_num), cal_id, t0year, 
     .			    t0mon, t0day, t0hour, t0min, t0sec, istat)
	IF ( istat .NE. merr_ok ) GOTO 9100
	start_secs = TM_SECS_FROM_BC (cal_id, t0year, t0mon, t0day,
     .				      t0hour, t0min, t0sec, status)
	IF ( status .NE. merr_ok ) GOTO 9990

* Find the number of seconds since start of data set for this date
	offset_secs = date_secs - start_secs

* Divide by time step increment to get # of time step
	TM_DATE_TO_STEP = offset_secs/ds_time_unit(dset_num)

* Finished
	status = merr_ok
	GOTO 9990

* Errors
 9000	CALL TM_ERRMSG ( istat, status, 'TM_DATE_TO_STEP',
     .	                 dset_num, no_stepfile,
     .			 'DD-MMM-YYYY HH:MM:SS', date, *9990 )
 9100	CALL TM_ERRMSG ( istat, status, 'TM_DATE_TO_STEP',
     .	                 dset_num, no_stepfile,
     .			 'DD-MMM-YYYY HH:MM:SS',ds_t0time(dset_num),
     .	                 *9990 )

 9990	RETURN
	END

	SUBROUTINE U_FROM_PSI (	psi , mpsi ,
     .				uavz, muavz,
     .				vavz, mvavz )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute vertically averaged components of velocity from transport stream fcn

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 -1/20/87 extracted from SUBROUTINE CLINIC
*			with major modifications to convert i-k oriented
*			calculations to i-j oriented calculations
* V200:  7/27/89 - 4D symmetrical version
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN

#ifdef unix
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl.parm'		! parameter definitions
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xonedim.cmn'	! geometric constants
	include 'xcontext.cmn'
#else
	INCLUDE 'FERRET_CMN:FERRET.PARM'
	INCLUDE 'FERRET_CMN:GFDL.PARM'		! parameter definitions
	INCLUDE	'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE	'FERRET_CMN:XMEM_SUBSC.CMN'
	INCLUDE 'FERRET_CMN:XONEDIM.CMN'	! geometric constants
	INCLUDE 'FERRET_CMN:XCONTEXT.CMN'
#endif

* calling argument declarations:
	INTEGER	mpsi, muavz, mvavz

* subscript ranges from memory variable table ...
	REAL     psi( m1lox:m1hix,m1loy:m1hiy,            m1lot:m1hit ),
     .		uavz( m2lox:m2hix,m2loy:m2hiy,            m2lot:m2hit ),
     .		vavz( m3lox:m3hix,m3loy:m3hiy,            m3lot:m3hit )

* internal variable declarations:
	INTEGER	i_lo, i_hi, j_lo, j_hi, i, j, l
	REAL	bad_psi, bad_uavz, bad_vavz,
     .		diag1, diag2

* --- end of introductory code ---

* limits for calculation
	i_lo = mr_lo_s1(muavz)
	i_hi = mr_hi_s1(muavz)
	j_lo = mr_lo_s2(muavz)
	j_hi = mr_hi_s2(muavz)

* flag for bad/missing data
	bad_psi  = mr_bad_data( mpsi  )
	bad_uavz = mr_bad_data( muavz )
	bad_vavz = mr_bad_data( mvavz )

* ***************************************************************
* ORIGINAL GFDL 205 CODE UPON WHICH CALCULATION IS BASED
*
*  129       C   COMPUTE EXTERNAL MODE VELOCITIES FOR ROW J+1 AND TWO TIME LEVELS
*  137             DO 155 I=1,IMTM1
*  138             DIAG1=P (I+1,J+2)-P (I,J+1)
*  139             DIAG2=P (I,J+2)-P (I+1,J+1)
*  140             SFU (I)=-(DIAG1+DIAG2)*DYU2R(J+1)*HR(I,J+1)
*  141             SFV(I)=(DIAG1-DIAG2)*DXU2R(I)*HR(I,J+1)*CSR(J+1)
*  142        155  CONTINUE
* ******************************************************************
	DO 2000 l = mr_lo_s4(muavz), mr_hi_s4(muavz)

	DO 155 j = j_lo, j_hi
	DO 155 i = i_lo, i_hi
* ... cant compute derivatives at fringes of full grid
	   IF ( i .EQ. im .OR. j .EQ. jm ) THEN
	      uavz(i,j,l) = bad_uavz
	      vavz(i,j,l) = bad_vavz
	      GOTO 155
	   ENDIF

	   IF ( psi(i  ,j  ,l) .EQ. bad_psi
     .	    .OR.psi(i+1,j  ,l) .EQ. bad_psi
     .	    .OR.psi(i+1,j+1,l) .EQ. bad_psi
     .	    .OR.psi(i  ,j+1,l) .EQ. bad_psi) THEN
	      uavz(i,j,l) = bad_uavz
	      vavz(i,j,l) = bad_vavz
	   ELSE
	      diag1=psi(i+1,j+1,l) - psi(i  ,j,l)
	      diag2=psi(i  ,j+1,l) - psi(i+1,j,l)
	      uavz(i,j,l) = -(diag1+diag2) * dyu2r(j) * hr
	      vavz(i,j,l) =  (diag1-diag2) * dxu2r(i) * hr * csr(j)
	   ENDIF
 155	CONTINUE

 2000	CONTINUE
	RETURN
	END

      SUBROUTINE MPLOT(X,NSIZE) 
	DIMENSION X(NSIZE)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 


* V54: *acm* 9/01 changes for dynamic allocation of PPLUS memory.
*                 Pass array X to SAVEZ
*      *acm* 10/01  remove VMS includes
*
C**    @(#)mplot.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
	INCLUDE 'PARAMPL5.DAT'
	INCLUDE 'ZGRID.INC'
	INCLUDE 'PLT.INC'
	INCLUDE 'AXIS.INC'
	INCLUDE 'LABELS.INC'
	INCLUDE 'HD.INC'
	INCLUDE 'MPLOT.INC'
	INCLUDE 'MPLOTX.INC'
	INCLUDE 'MPLOTS.INC'
	INCLUDE 'TAXIS.INC'
	INCLUDE 'XYLABP.INC'
	INCLUDE 'FILNAM.INC'
	INCLUDE 'LUNITS.INC'

C     SAVE ORGS AND HEIGHTS 
	IF(IMCNT.EQ.0)THEN 
	    XORGT=XORG 
	    YORGT=YORG 
	    XLENT=XLEN 
	    YLENT=YLEN 
	END IF 
	IMCNT=IMCNT+1 
	IXM=IXM+1 
	IF(IXM.GT.MNX)THEN 
	    IXM=1 
	    IYM=IYM+1 
	END IF 
C     CALC XORG AND YORG 
	XORG=DXM(1) 
	DO 10 I=2,IXM 
10	XORG=XORG+XLENM(I-1)+DXM(I) 
	YORG=DYM(IYM) 
	DO 20 I=IYM+1,MNY 
20	YORG=YORG+DYM(I)+YLENM(I) 
	XLEN=XLENM(IXM) 
	YLEN=YLENM(IYM) 
	LABYT=LABELY 
	LABXT=LABELX 
	LABT=LAB1 
	XLABT=XLAB 
	YLABT=YLAB 
C     SET AXIS LABELLING 
	IF(DXM(IXM).EQ.0)THEN 
	    MYLEF=1 
	    IF(LABELY.NE.0)THEN 
		IF(DXM(IXM+1).EQ.0.)THEN 
		    LABELY=0 
		    YLAB=' ' 
		ELSE 
		    LABELY=1 
		END IF 
	    END IF 
	END IF 
	IF(DYM(IYM).EQ.0)THEN 
	    LAB1=' ' 
	    MXBOT=1 
	    IF(LABELX.NE.0)THEN 
		LAB1=' ' 
		IF(IYM.EQ.1)THEN 
		    LABELX=1 
		ELSE IF(DYM(IYM-1).EQ.0.)THEN 
		    LABELX=0 
		    XLAB=' ' 
		ELSE 
		LABELX=1 
		END IF 
	    END IF 
	END IF 
C     SAVE PLOT ON FILE 
#ifndef unix
	OPEN(LMULT,FILE=MULTFL,STATUS='OLD',
     *	ACCESS='APPEND',FORM='UNFORMATTED')
#endif
	WRITE(LMULT)IPTS,MXBOT,MYLEF
	WRITE(LMULT)XLABS,YLABS,RLABS,LTYPE,XLLABS,YLLABS,LLTYPE,
     *	RHLABS,USRLBS
	CALL SAVE(LMULT)
C
	IF(IPTS(11).EQ.1)THEN
	CALL SAVEXY(LMULT,X,NSIZE)
	ELSE
C
	CALL SAVEZ(LMULT,X,IPTS(7),IPTS(10),X)
	ENDIF
	IF(IZTYP.NE.0)CALL SAVEZG(LMULT)
C
#ifndef unix
	CLOSE(LMULT)
#endif
	IVFLG=0
	LAB1=LABT
      XLAB=XLABT 
      YLAB=YLABT 
      LABELX=LABXT 
      LABELY=LABYT 
      MXBOT=0 
      MYLEF=0 
      RETURN 
      ENTRY MPLOT2(X,NSIZE)
      IMULT=0 
      IMCNT=0 
      MNX=0 
      MNY=1 
      XORG=XORGT 
      YORG=YORGT 
      HEIGHT=HTM 
      WIDTH=WDM 
      XLEN=XLENT 
      YLEN=YLENT 
      MXBOT=0 
      MYLEF=0 
      LAB1=LABT 
      XLAB=XLABT 
      YLAB=YLABT 
      LABELX=LABXT 
      LABELY=LABYT 
      RETURN 
      END 
	SUBROUTINE SAVEZ(LN,Z,NXS,NYS,X)
	DIMENSION Z(NXS,NYS),X(*)

	include 'PARAMPL5.DAT'
	include 'HD.INC'
	include 'PPLDAT.INC'

        IF(JTYPE.EQ.0)THEN
            WRITE(LN)Z
        ELSE IF(JTYPE.EQ.-1)THEN
            WRITE(LN)(X(K),K=1,2*NXS*NYS)
        ELSE IF(JTYPE.EQ.2)THEN
            WRITE(LN)(X(K),K=1,NXS*NYS+NXS+NYS)
        ELSE
            NXNY2=2*(NXS*NYS+NXS+NYS)
            WRITE(LN)(X(K),K=1,NXNY2)
        ENDIF
        RETURN
        ENTRY GETZ(LN,Z,NXS,NYS)
        IF(JTYPE.EQ.0)THEN
            READ(LN,END=200)Z
        ELSE IF(JTYPE.EQ.-1)THEN
            READ(LN,END=200)(X(K),K=1,2*NXS*NYS)
        ELSE IF(JTYPE.EQ.2)THEN
            READ(LN,END=200)(X(K),K=1,NXS*NYS+NXS+NYS)
        ELSE
            NXNY2=2*(NXS*NYS+NXS+NYS)
            READ(LN,END=200)(X(K),K=1,NXNY2)
        ENDIF
200     RETURN
	END
	SUBROUTINE SAVEXY(LN,X,NSIZE)
#ifdef unix
	INCLUDE 'PARAMPL5.DAT'
	INCLUDE 'LINES.INC'
#else
        INCLUDE 'pplinc:PARAMPL5.DAT'
        INCLUDE 'pplinc:LINES.INC'
#endif
	DIMENSION X(NSIZE)
	IBASE=0
	IYB=NSIZE/2
	DO 6002 I=1,LNUM
	WRITE(LN)(X(IBASE+J),X(IYB+J),J=1,LLENG(I))
	IBASE=IBASE+LLENG(I)
6002	IYB=IYB+LLENG(I)
	RETURN
	ENTRY GETXY(LN,X,NSIZE)
	IBASE=0
	IYB=NSIZE/2
	DO 6001 I=1,LNUM
	READ(LN,END=200)(X(IBASE+J),X(IYB+J),J=1,LLENG(I))
	IBASE=IBASE+LLENG(I)
6001	IYB=IYB+LLENG(I)
200	RETURN
	END

	SUBROUTINE SS_NEIGHBORS ( world_coord, grid, idim,
     .				  extrapolate, sslo, sshi, factor )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* locate the subscript values immediately surrounding the given world
* coordinate on the indicated axis.
* Return also the linear interpolation factor with respect to the first
* subscript.
* When the value is out of range unspecified_int4 is returned.
* If the value is before the beginning or after the end of the axis but
* still inside the limits of the end grid box then both high and low
* subscripts will be set to this subscript and "extrapolate" will
* be set to true indicating that this is a questionable value.
* The values sslo and sshi are both input and output values.  On input they
* are used to optimize the search on the assumption that the next point
* is likely to be close to the last.
* If the indicated axis is modulo then the subscript value on the "root"
* axis is returned.

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V301 - 2/94 - based on ISUBSCRIPT
* V420 - 10/95 - allow line defs to be recursive (dynamic lines) by avoiding
*		 direct use of line_mem
* V541 - *sh* 2/02 - added support for subspan modulo axes
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'

* calling argument declarations:
	LOGICAL extrapolate
	INTEGER	grid, idim, sslo, sshi
	REAL	world_coord, factor

* internal variable declarations:
	LOGICAL	TM_ITS_SUBSPAN_MODULO, ITSA_TRUEMONTH_AXIS, regular
	INTEGER	lo_look, hi_look, axis, ibot, itop, look,
     .		isub0, line_len, isubsc, num_mod, point
	REAL 	subsc
	REAL*8	TM_WORLD,  TM_WW_AXLEN, 
     .		wcoord, start, aend, span, first, last, wwindex

* initialize 
	wcoord = world_coord	! switch to REAL*8
	extrapolate = .FALSE.

* which axis are we on ?
	axis    = grid_line ( idim, grid )
	line_len = line_dim( axis )

* check for peculiar calls
	IF (  axis .EQ. mnormal
     .	 .OR. axis .EQ. munknown ) THEN
	   sslo = unspecified_int4
	   RETURN
	ENDIF

* special consideration for sub-span modulo axis outside its core range
	CALL TM_WW_AX_1_N(axis, first, last)
	IF (TM_ITS_SUBSPAN_MODULO(axis) ) THEN
	   IF ( wcoord.LT.first .OR. wcoord.GT.last ) THEN
	      line_len = line_len + 1
	      last = TM_WORLD(line_len, grid, idim, box_middle)
	      regular = .FALSE.
	   ELSE
	      regular = line_regular(axis) .AND. .NOT.ITSA_TRUEMONTH_AXIS(axis)
	   ENDIF
	ELSE
	   regular = line_regular(axis) .AND. .NOT.ITSA_TRUEMONTH_AXIS(axis)
	ENDIF

* initialize pointers for axes with irregularly spaced points
	IF ( .NOT.regular ) THEN
	   isub0 = 0
	   ibot  = 1
	   itop  = line_len
	ENDIF

* ***** SOLUTIONS WHEN GIVEN POINT BEYOND AXIS ENDS
	IF ( wcoord .LT. first .OR. wcoord .GT. last ) THEN
* ... begin by computing axis limits as outer edges of end boxes
	   span = TM_WW_AXLEN(axis)
	   CALL TM_WW_AXLIMS(axis, start, aend)
	   IF (TM_ITS_SUBSPAN_MODULO(axis)) THEN
	      span = line_modulo_len(axis)
	      aend = start + span
	   ENDIF

* Modulo axis: translate world coord to within axis range
	   IF ( regular ) THEN
* ... now translate to within axis limits saving modulo number
	      IF     ( wcoord .GT. aend  ) THEN
	         num_mod = ( wcoord - start ) / span
! 10/92 bug fix: if wcoord is an exact multiple of length (e.g. wccord=24.
!       start=0., span=12.) then modulo remap to top of ax rather than bottom
                 IF ( wcoord .EQ. start+num_mod*span )
     .                          num_mod = num_mod - 1
	      ELSEIF ( wcoord .LT. start ) THEN
	         num_mod = ( wcoord - aend  ) / span		! (negative)
	      ELSE
	         num_mod = 0
	      ENDIF
	      wcoord = wcoord - num_mod*span
	   ENDIF

* ... three cases: modulo (always solution), exrapolate(maybe sol'n), or
*     not extrap. (nexer solution)
	   IF ( wcoord .LT. first ) THEN
	      IF ( line_modulo(axis) ) THEN
	         sslo = 1
	         sshi = line_len
	         factor = 1. - (first-wcoord)/(first+span-last)
	         RETURN
	      ELSEIF ( wcoord .GE. start ) THEN
	         point = 1
	         extrapolate = .TRUE.
	         GOTO 1100
	      ELSE
	         GOTO 1000		! no solution
	      ENDIF
	   ELSEIF ( wcoord .GT. last ) THEN
	      IF ( line_modulo(axis) ) THEN
	         sslo = 1
	         sshi = line_len
	         factor = (wcoord-last)/(first+span-last)
	         RETURN

	      ELSEIF ( wcoord .LE. aend ) THEN
	         point = line_len
	         extrapolate = .TRUE.
	         GOTO 1100
	      ELSE
	         GOTO 1000		! no solution
	      ENDIF
	   ELSEIF ( wcoord .EQ. first ) THEN	! possibly unnecessary test
	      point = 1
	      GOTO 1100		! exact point   
	   ELSEIF ( wcoord .EQ. last ) THEN	! possibly unnecessary test
	      point = line_len
	      GOTO 1100
	   ENDIF
	ENDIF
* ***** END OF SOLUTIONS BEYOND AXIS ENDS

* ***** AXIS POINTS ARE REGULARLY SPACED --> QUICK CALCULATION!
	IF ( regular ) THEN
	   subsc = (wcoord-first)/line_delta(axis)
	   isubsc = INT( subsc )
	   IF ( subsc .EQ. FLOAT(isubsc) ) THEN
	      point = isubsc + 1
	      GOTO 1100
	   ELSE
	      sslo = isubsc + 1
	      sshi = isubsc + 2
	      factor = 1. - (subsc - FLOAT(isubsc))	      
	   ENDIF
	   RETURN
* ***** END OF REGULARLY SPACED SOLUTIONS

	ELSE			! AXIS POINTS ARE IRREGULAR !!!!

* ***** END OF PRE-SCAN NEIGHBORING POINTS

* binary search if axis points are irregularly spaced
* initialize search
	   lo_look  = ibot - 1
	   hi_look  = itop + 1	
	   look     = ( lo_look + hi_look ) / 2

* top of search loop
 100	   wwindex = TM_WORLD(look-isub0, grid, idim, box_middle)
	   IF ( wcoord .GT. wwindex ) THEN

* answer is somewhere above current "look" position
* keep looking at higher values setting this as new low limit for search
	      lo_look = look
	      look = ( look + hi_look + 1 ) / 2

* answer is identically equal to the current "look" position
	   ELSEIF ( wcoord .EQ. wwindex ) THEN
	      point = look - isub0
	      GOTO 1100

	   ELSE
* answer is somewhere below current "look" position
* keep looking at lower values setting this as new high limit for search
	      hi_look = look
	      look = ( look + lo_look ) / 2

	   ENDIF

* have we narrowed it to a 1 point range ?
	   IF ( hi_look - lo_look .LE. 1 ) THEN

* yes - we found it
	      sslo = lo_look - isub0
	      sshi = hi_look - isub0
	      IF ( sslo .EQ. sshi ) THEN
	         factor = 0.0
	      ELSE
	         wwindex = TM_WORLD(hi_look-isub0,grid, idim, box_middle)
#ifdef double_p
		 factor = (wwindex - wcoord)
     .			/ (wwindex-
     .			  TM_WORLD(lo_look-isub0,grid, idim, box_middle))
#else
	         factor = SNGL(wwindex - wcoord)
     .			/ SNGL(wwindex-
     .			  TM_WORLD(lo_look-isub0,grid, idim, box_middle))
#endif
	      ENDIF
	      RETURN
	   ELSE

* no - keep looking
	      GOTO 100
	   ENDIF
	ENDIF

* special conclusions
* ... NO SOLUTION
 1000	sslo = unspecified_int4
	sshi = unspecified_int4
	RETURN

* ... SOLUTION IS SINGLE POINT
 1100	sslo = point
	sshi = point
	factor = 0.0
	RETURN

	END

	SUBROUTINE TM_TCOORD_TRUMONTH (iaxis, monthval, where_in_box, 
     .		                       tempwld)
 
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* For a true-month axis, return the exact coordinate value for irregular months 
* corresponding to the calendar, so that the grid cells lie exactly one month apart.
* Input and output are in units of months.
*
* V71 12/16 *acm* Ticket 2158: working with true monthly time axes.

* Arguments
*  iaxis	axis number
*  monthval	coordinate value (on regularly spaced axis)
*  where_in_box	flag for location to return
*  tempwld	On output, return correct coordinate value on true 
*               monthly axis for lo, mid, or hi box location.

* Include files
        include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
        include 'xtm_grid.cmn_text'
        external xgt_grid_data
	include 'xunits.cmn_text'
	external xunits_data
        include 'calendar.decl'
        include 'calendar.cmn'
 
* calling argument declarations:
	INTEGER iaxis, where_in_box
	REAL	monthval, tempwld

* internal variable declarations:
	LOGICAL	TM_DIGIT_TEST
	INTEGER TM_GET_CALENDAR_ID, STR_SAME, TM_LENSTR1, TM_UNIT_ID,
     .		i, i1, i2, idim, cal_id, ndec, status, 
     .		yrt0, mot0, dat0, ht0, mit0, set0,
     .		yr1, mo1, da1, hr1, mi1, se1, 
     .		yr2, mo2, da2, hr2, mi2, se2
	REAL	TM_SECS_FROM_BC, SECS_FROM_BC, secpday, edge_lo, edge_hi,   
     .		secs0,secs1, secs2, days_t0, days_yrs, days_this_year, 
     .		days_all_to_lo, days_cell, tcoord,
     .		num_secs, start_secs, offset_secs

	!print *, 'TM_TCOORD_TRUMONTH faster version'

* Initialize.

	edge_lo = 0.
	edge_hi = 0.
	secs0 = 0.
	secs1 = 0.
	secs2 = 0.
	days_t0 = 0.
	days_all_to_lo = 0.
	days_cell = 0.

	IF (line_t0(iaxis) .EQ. char_init) GOTO 5000  ! unformatted dataset

        idim = t_dim
	secpday = 24*3600

	cal_id = TM_GET_CALENDAR_ID ( line_cal_name(iaxis) )
        CALL TM_BREAK_DATE (line_t0(iaxis), cal_id, yrt0, mot0, dat0,
     .                      ht0, mit0, set0, status)

* dgrid_buff is a fake grid to use, defined in tmap_dims.parm

        grid_line(idim, dgrid_buff) = iaxis

* first coordinate value on the axis start with days, get date

	tcoord = line_start(iaxis) * line_tunit(iaxis)/ un_convert(pun_day)

* Find the number of seconds since start of data set for this time step

	start_secs = SECS_FROM_BC( line_t0(iaxis), cal_id, status )
        offset_secs = tcoord* un_convert(pun_day) 
	num_secs = start_secs + offset_secs

	CALL TM_SECS_TO_YMDHMS(num_secs, cal_id, yr1, mo1, da1,
     .                      hr1, mi1, se1, status)

!        print *, 'line start info yr1 etc', yr1, mo1, da1,
!    .                      hr1, mi1, se1

* Monthval is in months. Translate to days and get date string

	tcoord = monthval * line_tunit(iaxis)/ un_convert(pun_day)

* First find the offset from 01-JAN-0000 00:00:00 from the descriptor file
	start_secs = TM_SECS_FROM_BC (cal_id, yrt0, mot0, dat0,
     .                      ht0, mit0, set0, status)

* Find the number of seconds since start of data set for this time step
        offset_secs = tcoord* un_convert(pun_day) 
	num_secs = start_secs + offset_secs

	CALL TM_SECS_TO_YMDHMS(num_secs, cal_id, yr2, mo2, da2,
     .                      hr2, mi2, se2, status)
!	print *, 'coord info yr2 etc', yr2, mo2, da2,
!     .                      hr2, mi2, se2

* Time corresponding to the lower edge of cell, year-month with 
* day 1 and zero for hr,min,sec

	da2 = 1
	hr2 = 0
	edge_lo = TM_SECS_FROM_BC (cal_id, yr2, mo2, da2, hr2, hr2, hr2, status)
        !print *, 'edge_lo', edge_lo

* Correct days from T0 to end-of-year in which T0 lies

* seconds since 1-jan-0000 to t0

	days_t0 = 0
	IF (yr2 .GT. yrt0) THEN
           secs1 = start_secs

* seconds since 1-jan-0000 to end of year of t0
           secs2 = TM_SECS_FROM_BC (cal_id, yrt0+1, 1, 1, 0, 0, 0, status)

* ... convert to days
	   days_t0 = (secs2-secs1)/ secpday
	   !print *, 'secs1, secs2, days_t0', secs1, secs2, days_t0
	ENDIF

* ... days in full years between the end of t0 year and start of coord year

	days_yrs = 0
	secs1 = 0
        IF (yr2 .GT. yrt0+1) THEN

	   secs0 = TM_SECS_FROM_BC (cal_id, yrt0+1, 1, 1, 0, 0, 0, status)

	   secs1 = TM_SECS_FROM_BC (cal_id, yr2, 1, 1, 0, 0, 0, status)
	
* ... convert to days
	   days_yrs = (secs1 - secs0)/ secpday
	   !print *, 'secs1, secs0, days_yrs', secs1, secs0, days_yrs

	ENDIF

* ... days from start of coordinate year to lower limit of box

	IF (secs1 .EQ. 0) secs1 = TM_SECS_FROM_BC (cal_id, yr2, 1, 1, 0, 0, 0, status)

	days_this_year = (edge_lo-secs1)/ secpday

	days_all_to_lo = days_t0 + days_yrs + days_this_year
!	print *, 'days_this_year, days_all_to_lo', 
!     .    days_this_year, days_all_to_lo

        IF (where_in_box .EQ. box_lo_lim) THEN  ! we are done

           tempwld = days_all_to_lo

        ELSE

* Get the correct time coordinate at the upper limit of the box.

           IF (mo2 .LT. 12) THEN
	      edge_hi = TM_SECS_FROM_BC (cal_id, yr2, mo2+1, 1, 0, 0, 0, status)
	   ELSE
	      edge_hi = TM_SECS_FROM_BC (cal_id, yr2+1, 1, 1, 0, 0, 0, status)
	   ENDIF
cc	   edge_hi = edge_hi - 1  ! the top of the box, not the bottom of the next one.

	   days_cell = (edge_hi - edge_lo)/ secpday

* Put the result halfway between the corrected high and low
           IF (where_in_box .EQ. box_middle) THEN

	      tempwld = (days_all_to_lo + days_cell/2.)

* Or return the high coordinate
	   ELSE IF (where_in_box .EQ. box_hi_lim) THEN

	      tempwld = (days_all_to_lo + days_cell)

	   ENDIF

	ENDIF

* We have the coordinate in days, return it in months.

        secs0 = un_convert( line_unit_code(iaxis) ) 
!	print *, 'tempwld = tempwld* secpday/ secs0',
!     .    tempwld, secpday, secs0, tempwld* secpday/ secs0
        tempwld = tempwld* secpday/ secs0

5000    RETURN
	END

*
*  neutral.F
*
*  John Donners
*  Jun 19th 2002
*
*  Returns neutral density
*
* On a SUN Solaris system compile with:
*
* f77 -PIC -G -z text -z muldefs neutral.F gamma.a /opt/SUNWspro/lib/libM77.so
* /opt/SUNWspro/lib/lib{f77compat,fsu}.so -o neutral.so
*
* The gamma library (gamma.a) should be compiled with the -KPIC option.
* Make sure all libraries are 32 bits compiled (without the -xarch=v9 flag)
* Make sure the file gamma.nc is with the exact path in read-nc.F
* Changed code in gamma-n.f. Now also complains about out of oceanographic
* range, but doesn't quit anymore. Instead now returns -99.2, and jumps to
* the end of the subroutine
* The gamma library can be found at:
* ftp://ftp.marine.csiro.au/pub/jackett/gamma.tar.Z
*
*  In this subroutine we provide information about
*  the function.  The user configurable information
*  consists of the following:
*
*  descr              Text description of the function
*
*  num_args           Required number of arguments
*
*  axis_inheritance   Type of axis for the result
*                        ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                        CUSTOM          - user defined axis
*                        IMPLIED_BY_ARGS - same axis as the incoming argument
*                        NORMAL          - the result is normal to this axis
*                        ABSTRACT        - an axis which only has index values
*
*  piecemeal_ok       For memory optimization:
*                        axes where calculation may be performed piecemeal
*                        ( YES, NO )
*
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result
*


      SUBROUTINE neutral_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,' neutral(salinity,temperature) returns'//
     .  ' neutral density' )

      CALL ef_set_num_args(id, 2)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS,
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'S')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'T')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)

      CALL ef_set_num_work_arrays(id,3)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END

      SUBROUTINE neutral_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_dims(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER mz1, mz2, mz3

      INTEGER iwork
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

*  Allocate double the dimension of the input arguments for work arrays
*  which will be REAL*8

      mz1 = 1 + ABS(arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1))
      mz2 = 1 + ABS(arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1))
      mz3 = 1 + ABS(arg_hi_ss(Z_AXIS,ARG1) - arg_lo_ss(Z_AXIS,ARG1))


*  lon
      iwork = 1
      CALL ef_set_work_array_dims (id, iwork, 1, 1, 1, 1,
     .   2*mz1, 1, 1, 1)

*  lat
      iwork = 2
      CALL ef_set_work_array_dims (id, iwork, 1, 1, 1, 1,
     .   1, 2*mz2, 1, 1)

*  z
      iwork = 3
      CALL ef_set_work_array_dims (id, iwork, 1, 1, 1, 1,
     .   1, 1, 2*mz3, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
*  In this subroutine we compute the result
*
      SUBROUTINE neutral_compute(id, arg_1, arg_2, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy,
     .     mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy,
     .     mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .     memresloz:memreshiz, memreslot:memreshit)

      REAL*8 lon(wrk1lox:wrk1hix/2,wrk1loy:wrk1hiy,wrk1loz:wrk1hiz,
     .  wrk1lot:wrk1hit)
      REAL*8 lat(wrk2lox:wrk2hix,wrk2loy:wrk2hiy/2,wrk2loz:wrk2hiz,
     .  wrk2lot:wrk2hit)
      REAL*8 depth(wrk3lox:wrk3hix,wrk3loy:wrk3hiy,wrk3loz:wrk3hiz/2,
     .  wrk3lot:wrk3hit)

* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable's axes.

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1
      INTEGER i2, j2, k2, l2
      INTEGER ilon, jlat, kdepth
      REAL*8 dum1,dum2, res

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      CALL ef_get_coordinates(id, ARG1, X_AXIS,
     .   arg_lo_ss(X_AXIS, ARG1), arg_hi_ss(X_AXIS, ARG1), lon)
      CALL ef_get_coordinates(id, ARG1, Y_AXIS,
     .   arg_lo_ss(Y_AXIS, ARG1), arg_hi_ss(Y_AXIS, ARG1), lat)
      CALL ef_get_coordinates(id, ARG1, Z_AXIS,
     .   arg_lo_ss(Z_AXIS, ARG1), arg_hi_ss(Z_AXIS, ARG1), depth)

      i1 = arg_lo_ss(X_AXIS,ARG1)
      i2 = arg_lo_ss(X_AXIS,ARG2)
      ilon = 1
      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         j2 = arg_lo_ss(Y_AXIS,ARG2)
         jlat = 1
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            k2 = arg_lo_ss(Z_AXIS,ARG2)
            kdepth = 1
            DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

            l1 = arg_lo_ss(T_AXIS,ARG1)
            l2 = arg_lo_ss(T_AXIS,ARG2)
            DO 100 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)


                  IF ( arg_1(i1,j1,k1,l1) .EQ. bad_flag(1) .OR.
     .                 arg_2(i2,j2,k2,l2) .EQ. bad_flag(2) ) THEN

                     result(i,j,k,l) = bad_flag_result

                  ELSE

                     call gamma_n(dble(arg_1(i1,j1,k1,l1)),
     .                 dble(arg_2(i2,j2,k2,l2)),depth(1,1,kdepth,1),1,
     .                 lon(ilon,1,1,1),lat(1,jlat,1,1),res,dum1,dum2)
c                     print*,'s,t,p,lon,lat,res=',
c     .                 dble(arg_1(i1,j1,k1,l1)),
c     .                 dble(arg_2(i2,j2,k2,l2)),depth(1,1,kdepth,1),
c     .                 lon(ilon,1,1,1),lat(1,jlat,1,1),res
                     result(i,j,k,l)=real(res)
                  END IF


                  l1 = l1 + arg_incr(T_AXIS,ARG1)
                  l2 = l2 + arg_incr(T_AXIS,ARG2)
 100           CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
               k2 = k2 + arg_incr(Z_AXIS,ARG2)
               kdepth = kdepth + 1
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
            j2 = j2 + arg_incr(Y_AXIS,ARG2)
            jlat = jlat + 1
 300     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
         i2 = i2 + arg_incr(X_AXIS,ARG2)
         ilon = ilon + 1
 400  CONTINUE


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END

	BLOCK DATA XDSET_INFO_DATA

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* various pre-defined variables for COMMON/XDSET_INFO
* programmer - mark verschell
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.00 - 07/29/86
* revision 0.10 - 05/07/87 - initializes new integration_tstep variable
* revision 0.11 - 07/07/87 - removed revision and increased size of type/format
* revision 0.20 - 08/30/87 - changed to reflect new layout of common
* revision 0.21 - 10/30/87 - eliminated ds_make_dscrp_rev
* revision 0.30 - 07/27/88 - added variables from TS descriptor type
* revision 0.31 - 08/10/88 - made number of aux_parms a parameter, aux_parm now
*			     2 vars ds_aux_name, ds_aux_text
* revision 0.40 - 10/25/88 - Added modulo variables
* revision 0.41 - 11/21/88 - variable initialization changed to char_initXX
* revision 0.42 - 02/08/89 - removed ds_var_modline
* revision 0.43 - 02/15/89 - removed ds_open
* Unix/RISC port - 4/25/91 *sh*: increased ds_name and ds_des_name size
* Linux port -kob - 3/97 - Modify include for tmap_dset.parm to be a
*			   preprocessor include for F90 - needed because
*			   tmap_dset.parm contains an ifdef
* v500 - *kob* 3/99 -  initialize ds_var_code, ds_var_units, ds_var_title
*                      and ds_var_titl_mod w/ char_inits of proper new value
* v500 - *kob* 4/99 - initialize ds_des_name with char_init256	
* v530 - *acm* 1/01 - add ds_cal_name
* v540 *acm* 10/01 increase length of ds_name
* v540 *acm* 10/01  remove VMS include statements
* v552 *acm*  4/03 Initialize ds_var_off, ds_var_scale, ds_var_scaleit
* v552 *acm*  5/03 change ds_var_code length to 128
* v604 *acm* 7/07 increase length of ds_name, ds_des_name
* v695+ *sh* 5/15 initialize new ds_var_c_cache_ptr
* v698 *sh* 12/15 declare larger dset arrays: maxdsets ==> pdsetalloc
* V701  7/16 *kms* Initialize ds_name and ds_des_name to pdsetalloc*char_init2048 
*                  instead of pdsetalloc*char_init1024

#include "tmap_dset.parm"		
	include 'tmap_dims.parm'		! parameter definitions
	include 'xdset_info.cmn_text'

* local parameters
	INTEGER		max6axes, maxnvars, maxdsets_aux, maxdsets_parm
	PARAMETER	(max6axes = 6*pdsetalloc)
	PARAMETER	(maxnvars = nferdims*maxvars)
	PARAMETER	(maxdsets_aux = pdsetalloc*num_aux)
	PARAMETER	(maxdsets_parm = pdsetalloc*num_parm)

* Initialize variables associated with data set
	DATA	ds_type			/pdsetalloc*char_init04/
	DATA	ds_format		/pdsetalloc*char_init04/
	DATA	ds_source_class		/pdsetalloc*char_init16/
	DATA	ds_source		/pdsetalloc*char_init16/
	DATA	ds_subsource		/pdsetalloc*char_init16/
	DATA	ds_prog_rev		/pdsetalloc*char_init04/
********************************************************************************
	DATA	ds_expnum		/pdsetalloc*char_init04/
	DATA	ds_modnum		/pdsetalloc*char_init04/
	DATA	ds_title		/pdsetalloc*char_init80/
	DATA	ds_mod_title		/pdsetalloc*char_init80/
	DATA	ds_forcing_set		/pdsetalloc*char_init16/
	DATA	ds_t0time		/pdsetalloc*char_init20/
	DATA	ds_time_unit		/pdsetalloc*real4_init/
	DATA	ds_time_modulo		/pdsetalloc*.FALSE./
	DATA	ds_ntegrate_tstep	/pdsetalloc*real4_init/
	DATA	ds_ntuple		/pdsetalloc*int4_init/
	DATA	ds_time_run		/pdsetalloc*char_init20/
	DATA	ds_aux_modnum		/maxdsets_aux*char_init04/
	DATA	ds_parm_name		/maxdsets_parm*char_init20/
	DATA	ds_parm_text		/maxdsets_parm*char_init80/
	DATA	ds_cal_name		/pdsetalloc*'GREGORIAN'/
********************************************************************************
	DATA	ds_alert_on_open	/pdsetalloc*.FALSE./
	DATA	ds_alert_on_output	/pdsetalloc*.FALSE./
	DATA	ds_message		/pdsetalloc*char_init80/
********************************************************************************
	DATA	ds_des_name		/pdsetalloc*char_init2048/
	DATA	ds_name			/pdsetalloc*char_init2048/
	DATA	ds_1step		/pdsetalloc*real8_init/
	DATA	ds_lastep		/pdsetalloc*real8_init/
	DATA	ds_delstep		/pdsetalloc*real8_init/
	DATA	ds_regsteps		/pdsetalloc*.TRUE./
	DATA	ds_accepts_remote	/pdsetalloc*.FALSE./
	DATA	ds_hide			/pdsetalloc*.FALSE./
	DATA	ds_basic_axes		/max6axes*int4_init/
	DATA	ds_time_axis		/pdsetalloc*int4_init/

* Next clear variables associated with variable in that data set.
        DATA    ds_var_code_head        / 0 /
        DATA    ds_var_code_padding     / 0 /
	DATA	ds_var_code		/maxvars*char_init128/
	DATA	ds_var_title		/maxvars*char_init128/
	DATA	ds_var_titl_mod		/maxvars*char_init128/
	DATA	ds_var_units		/maxvars*char_init64/
	DATA	ds_grid_number		/maxvars*int4_init/
	DATA	ds_missing_flag		/maxvars*real4_init/
	DATA	ds_bad_flag		/maxvars*real4_init/
	DATA	ds_ordering		/maxnvars*int4_init/
	DATA	ds_grid_start		/maxnvars*int4_init/
	DATA	ds_grid_end		/maxnvars*int4_init/
	DATA	ds_precision		/maxvars*char_init01/
	DATA	ds_aux_set_num		/maxvars*int4_init/
********************************************************************************
	DATA	ds_ndataperrec		/maxvars*int4_init/
	DATA	ds_nrecpervar		/maxvar2*int4_init/
	DATA	ds_npospervar		/maxvars*int4_init/
	DATA	ds_nrecb4var		/maxvar2*int4_init/
	DATA	ds_var_setnum		/maxvars*set_not_open/
********************************************************************************
	DATA	min_ds_tstart		/int4_init/
	DATA	max_ds_tend		/int4_init/
	DATA	ds_tdelta		/int4_init/
	DATA	ds_var_off		/maxvars*0.0/
	DATA	ds_var_scale		/maxvars*1.0/
	DATA	ds_var_scaleit		/maxvars*.FALSE./
	DATA	ds_var_c_cache_ptr	/maxvars*0.0/

	END

	SUBROUTINE DSG_ONE_FEATURE_LIMS(dset, base, flen, ifeature,
     .					lolims, hilims)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Compute the lo/hi coordinate limits of the given feature of this dsg dataset
* For its "obs" coordinate axes.  (e.g. for a time series collection time
* is an obs axis, whereas lon and lat are instance axes

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V720 4/17 *sh*

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xtm_grid.cmn_text'
	include 'xdset_info.cmn_text'
	include 'xdyn_linemem.cmn_text'
	include 'xcontext.cmn'
	include 'xdsg_context.cmn'
	include 'xprog_state.cmn'
	include 'xvariables.cmn'

* calling argument declarations:
	INTEGER dset, base, flen,ifeature
	REAL lolims(4), hilims(4)

* internal variable declarations:
        INTEGER i, lm, idim, var
	REAL cmin, cmax, coord

! DSGTBD: It is inefficient to re-compute the extremes time after time
! see discussion in dsg_feature_lims

* get the coordinate extremes of this feature
	DO idim = 1, 4
	   IF (cxdsg_has_coord(idim)) THEN
	      lm = cxdsg_coord_lm(idim)
	      IF (cxdsg_is_obs_coord(idim)) THEN
	         cmin = arbitrary_large_val8
	         cmax = arbitrary_small_val8
	         DO i = base+1, base+flen
	            coord = dsg_linemem(lm)%ptr(i)
	            IF (coord .LT. cmin) cmin = coord
	            IF (coord .GT. cmax) cmax = coord
	         ENDDO
	         lolims(idim) = cmin
	         hilims(idim) = cmax
	      ELSE
	         coord = dsg_linemem(lm)%ptr(ifeature)
	         lolims(idim) = coord
	         hilims(idim) = coord
	      ENDIF
	   ELSE
	      lolims(idim) = unspecified_val8
	      hilims(idim) = unspecified_val8
	   ENDIF
	ENDDO

	RETURN
	END

	INTEGER*4 FUNCTION ALLO_MANAGED_GRID ( islot )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Locates an unused grid slot and returns it.
* This routine parallels TM_FIND_GRID_SLOT in function but whereas that
* routine allocates from lower memory in grid common and leaves gaps
* as grids are deleted this routine allocates from upper memory and uses
* linked lists to maintain integrity.
* If no grid slot is available this returns returns error.

* This code is a temporary version that does NOT use linked lists.  Instead
* it simply locates the first available grid slot starting from position one.
* By contrast TM_FIND_GRID_SLOT locates the beginning of the upper contiguous
* grid storage space

* This routine functions as a part of the TMAP library

* for FERRET version 4.00 8/94  *sh*
*Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

        IMPLICIT NONE
* Arguments
	INTEGER*4	islot
*
* Parameters and commons
	include	'tmap_dims.parm'
#	include	"tmap_dset.parm"
	include	'tmap_errors.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'xfr_grid.cmn'			! fr200
*
* Local declarations
	CHARACTER*13	TM_STRING
	INTEGER status

	DO 100 islot = 1, grd_stk_ptr-1
	  IF (grid_name(islot) .EQ. char_init16) THEN
	     ALLO_MANAGED_GRID = merr_ok
	     RETURN
	  ENDIF
  100	CONTINUE


* No slot available
 9000	CALL TM_ERRMSG (merr_gridlim, status,
     .	                'ALLO_MANAGED_GRID', no_descfile, no_stepfile,
     .	                'MAX='//TM_STRING(DBLE(max_grids)), no_errstring,
     .	                *9999)


 9999	ALLO_MANAGED_GRID = status
	RETURN
	END

*           rr_diff_ty.F
*
*           Rick Romea
*           Jan. 24, 2000
*
*     Computes the meridional diffusive term: A T_yy
*     Units :     oC/s
*     MOM2 Grid:  T  
*
*******************************************************************

      SUBROUTINE RR_diff_ty_init(id)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

      CALL ef_set_desc             (id,
     .'Ah(d^2T/dy^2) diffusive term (oC/s);MOM2 T Grid')
      CALL ef_set_num_args         (id, 2)
      CALL ef_set_axis_inheritance (id, IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok     (id, NO, NO, NO, NO)

      CALL ef_set_arg_name         (id, ARG1, 'U')
      CALL ef_set_arg_desc         (id, ARG1,
     . 'Zonal velocity, required to access the MOM2 U Grid. ')
      CALL ef_set_arg_unit         (id, ARG1, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG1, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG1, YES, YES, YES, YES)
      CALL ef_set_axis_extend      (id, ARG1, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG1, Y_AXIS,-1,+1)

      CALL ef_set_arg_name         (id, ARG2, 'TEMP')
      CALL ef_set_arg_desc         (id, ARG2,
     .     'Potential temperature, on MOM2 T Grid.')
      CALL ef_set_arg_unit         (id, ARG2,  '(oC')
      CALL ef_set_arg_type         (id, ARG2, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2, NO, NO,YES,YES)
      CALL ef_set_axis_extend      (id, ARG2, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG2, Y_AXIS,-1,+1)
      END


      SUBROUTINE RR_diff_ty_compute(id, arg_1, arg_2, result)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER        id

      REAL           bad_flag(EF_MAX_ARGS)
      REAL           bad_flag_result

      REAL           arg_1 (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .                      mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL           arg_2 (mem2lox:mem2hix, mem2loy:mem2hiy, 
     .                      mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL           result (memreslox:memreshix,memresloy:memreshiy,
     .                       memresloz:memreshiz,memreslot:memreshit)

      INTEGER        res_lo_ss (4)
      INTEGER        res_hi_ss (4)
      INTEGER        res_incr  (4)

      INTEGER        arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER        arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER        arg_incr  (4,EF_MAX_ARGS)

      INTEGER        i,  j,  k,  l
      INTEGER        i2, j2, k2, l2

      REAL*8         yU(1024)
      REAL*8         yT(1024)
      INTEGER        ilat
      CHARACTER *16  ax_name(4)
      CHARACTER *16  ax_units(4)
      LOGICAL        backward(4)
      LOGICAL        modulo(4)
      LOGICAL        regular(4)

      REAL dyt,dyu,xjt
      REAL cst,csu,diff_cnt,ahc_south,ahc_north
     .               
      INCLUDE 'rr_parameters.h'

C*********************************************************************
c  MOM2 Code:
c      DIFF_Ty(i,k,j) = ahc_north(j)*(t(i,k,j+1,n) - t(i,k,j,  n))
c     &               - ahc_south(j)*(t(i,k,j  ,n) - t(i,k,j-1,n))
c          ahc_north(j) = diff_cnt(j)*csu(j)*dyur(j)
c     &                            *cstr(j)*dytr(j)
c          ahc_south(j) = diff_cnt(j)*csu(j-1)*dyur(j-1)
c     &                            *cstr(j)*dytr(j)
c          diff_cnt(j)  = ah*xjt(j)
c          xjt(j) = 3.166*dyt(j)*dytr(50)-2.166
c     dyt     = latitudinal height of "t" grid box (in cm)
c     dytr   = reciprocal of "dyt"
c     dyu     = latitudinal height of "u,v" grid box (cm)
c     dyur    = reciprocal of "dyu"
c
c     ah     = constant lateral diffusion coeff for tracers(cm**2/sec) 
c               ah = 2.e7
c     csu     = cosine of "u,v" grid point latitude
c               csu(j)  = cos(phiu(j))
c     cst     = cosine of "t" grid point latitude
c               cst(j)  = cos(phit(j))
c     cstr    = reciprocal of "cst"
c     n = 1 => temperature
c     n = 2 => salinity
c*********************************************************************

      !  Statement functions

      dyt(iLat) = SNGL(yU(iLat)-yU(iLat-1))*Latitude_to_cm
      dyu(iLat) = SNGL(yT(iLat+1)-yT(iLat))*Latitude_to_cm
      xjt(iLat) = 3.166*dyt(iLat)/dyt_ref-2.166
      diff_cnt(iLat) = ah*xjt(iLat)
      cst(iLat) = cos(SNGL(yT(iLat))*Degrees_to_radians) 
      csu(iLat) = cos(SNGL(yU(iLat))*Degrees_to_radians) 
      ahc_south(iLat) = diff_cnt(iLat)*csu(iLat-1)
     .                         /cst(iLat)/dyu(iLat)/dyt(iLat)
      ahc_north(iLat) = diff_cnt(iLat)*csu(iLat)
     .                         /cst(iLat)/dyu(iLat)/dyt(iLat)
      ! Get axis data

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags      (id, bad_flag,  bad_flag_result)
      CALL ef_get_coordinates    (id, ARG1, Y_AXIS, 
     .                            arg_lo_ss(Y_AXIS,ARG1),
     .                            arg_hi_ss(Y_AXIS,ARG1), yU)
      CALL ef_get_coordinates    (id, ARG2, Y_AXIS, 
     .                            arg_lo_ss(Y_AXIS,ARG2),
     .                            arg_hi_ss(Y_AXIS,ARG2), yT)

      ! Check axis units:  bail out if not lat and lon.

      CALL ef_get_axis_info      (id, ARG1, ax_name, ax_units, 
     .                                backward, modulo, regular) 
      IF     ( ax_units(1) .NE. 'deg'       .AND.
     .         ax_units(1) .NE. 'degrees_E'       .AND.
     .         ax_units(1) .NE. 'longitude' .AND.
     .         ax_units(1) .NE. 'Longitude' .AND. 
     .         ax_units(1) .NE. 'LONGITUDE' ) THEN
        WRITE (6,*)'Longitude axis units =', ax_units(1) 
        !CALL ef_bail_out(id,'Longitude axis must be in degrees')
      ENDIF

      IF     ( ax_units(2) .NE. 'deg'       .AND.
     .         ax_units(2) .NE. 'degrees_N'       .AND.
     .         ax_units(2) .NE. 'latitude'  .AND.
     .         ax_units(2) .NE. 'Latitude'  .AND. 
     .         ax_units(2) .NE. 'LATITUDE' ) THEN
        WRITE (6,*)'Latitude axis units =', ax_units(2) 
        !CALL ef_bail_out(id,'Latitude axis must be in degrees')
      ENDIF

      l2 = arg_lo_ss(T_AXIS,ARG2) 
      DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
       
         k2 = arg_lo_ss(Z_AXIS,ARG2)
         DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

            ilat = 2
            j2 = arg_lo_ss(Y_AXIS,ARG2) + 1 
            DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

               i2 = arg_lo_ss(X_AXIS,ARG2) + 1
               DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

                  IF (arg_2(i2,  j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2,  j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2,  j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2-1,k2,l2) .EQ. bad_flag(ARG2) )THEN
                     result(i,j,k,l) = bad_flag_result
                  ELSE
                     result(i,j,k,l) = (
     .                  ahc_north(iLat)*
     .                    (  arg_2(i2,j2+1,k2,l2)
     .                     - arg_2(i2,j2  ,k2,l2))
     .                - ahc_south(iLat)*
     .                    (  arg_2(i2,j2  ,k2,l2) 
     .                     - arg_2(i2,j2-1,k2,l2))
     .                             )*sec_per_month
                  ENDIF
                  i2 = i2 + arg_incr(X_AXIS,ARG2)
               ENDDO
               iLat = iLat + 1
               j2 = j2 + arg_incr(Y_AXIS,ARG2)
            ENDDO               
            k2 = k2 + arg_incr(Z_AXIS,ARG2)
         ENDDO
         l2 = l2 + arg_incr(T_AXIS,ARG2)
      ENDDO
      END

	INTEGER FUNCTION TM_DSET_NUMBER( path_name )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Find the data set number of the given name
* If the name does not match any initialized data sets return unspecified_int4
*
* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX/VMS
*
* revision 0.00 - 10/23/89 - code lifted from TM_INIT_DSET by Mark Verschell
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* arguments:
*	path_name	- full path name of descriptor file

* Argument definitions
	CHARACTER*(*)	path_name

* Parameter and common files
	include 'tmap_errors.parm'		! error codes
	include 'tmap_dims.parm'		! data set dimensions
#include "gt_lib.parm"
	include 'xdset_info.cmn_text'		! data set common
	external xdset_info_data

* Internal declarations
	INTEGER		set_cnt

* check to see if this descriptor has already been initialized
	DO 100 set_cnt = 1, maxdsets
	    IF (ds_des_name(set_cnt) .EQ. path_name) THEN
* ... found a match
	      TM_DSET_NUMBER = set_cnt
	      RETURN
	    ENDIF
  100	CONTINUE

* no match (but no serious error)
	TM_DSET_NUMBER = unspecified_int4
	RETURN
	END

	SUBROUTINE DO_REGRID_FROM_DSG( dsg_cx, grd_cx, dset, nfeatures, nobs,
     .				       dsg, grd, grd_lo, grd_hi, status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* regrid the DSG features along their feature-orientation axis onto a single,
* shared target grid axis

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V720:  *sh* 5/17
* V751: *acm* 8/19 Handle profile regrid to a single axis, checking for 
*                  ascending or descending z-coordinate data in the DSG profiles
* V751: *acm* 8/19 Initialize the result, needed when mask applied to DSG grid
* V76  1/20 *acm* working with Point-type dsg data 

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xtm_grid.cmn_text'
	include 'xdset_info.cmn_text'
	include 'xdyn_linemem.cmn_text'
	include 'xcontext.cmn'
	include 'xdsg_context.cmn'
	include 'xprog_state.cmn'
	include 'xvariables.cmn'
	include 'xmem_subsc.cmn'

* calling argument declarations:
* "dsg" - the source data - features
* "grd" - the target data - a grid
	INTEGER	dsg_cx, grd_cx, dset, nfeatures, nobs, grd_lo, grd_hi, maxobs
        REAL    grd( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif ),
     .		dsg(nobs)

* local variable declarations:
	LOGICAL fmask(nfeatures), repeat_of_same_coords, has_valid, xact
	INTEGER TM_DSG_DSET_FROM_GRID,
     .		dsg_grid, grd_grid, dsg_fmt_grid,
     .		row_size_lm, orient, dsg_coord_lm,
     .		i, idim, ifeature, base, lastbase, flen,
     .		ss(nferdims), status, igrd, idsg, ss12(grd_lo:grd_hi),
     .		del
	REAL	TM_WORLD, TDEST_CONVERT,
     .          coef(grd_lo:grd_hi), c1, c2, v1, v2,
     .		grd_coord(grd_lo:grd_hi), bad_dsg, bad_grd

* local parameters
	INTEGER   pnolastyet
	PARAMETER (pnolastyet = -9)
	LOGICAL   ascending

! DSGTBD only linear interpolation is offered as of 5/2017
!      that may be sufficient, but need to have error traps in case the user
!      tries to request a different regridding algorithm

* initialize
	lastbase = pnolastyet
	dsg_grid = cx_grid(dsg_cx)
	grd_grid = cx_grid(grd_cx)
	bad_dsg  = cx_bad_data(dsg_cx)
	bad_grd  = cx_bad_data(grd_cx)

	grd = bad_grd

* DSG-specific initialize
	dset = TM_DSG_DSET_FROM_GRID(dsg_grid)
	orient       = dsg_orientation(dset)

* Refuse to regrid to point-data type, sample at x,y,z,t of xlate grid...
        IF (orient .EQ. e_dim) GOTO 5100

        CALL MAKE_DSG_FEATURE_MASK(dset, dsg_cx, fmask, nfeatures)
	row_size_lm  = dsg_loaded_lm(dsg_row_size_var(dset))
	dsg_fmt_grid = dsg_xlate_grid(dset)
	dsg_coord_lm = cxdsg_coord_lm(orient)

* initialize for conversion of the gridded time axis onto DSG times
* -for regridding to grid with time. 
* ( we never return a msg on status out of TDEST_WORLD_INIT)

	IF (grid_line(t_dim, grd_grid) .NE. mnormal) THEN
	   CALL TDEST_WORLD_INIT(grd_grid, dsg_fmt_grid, t_dim, status)
	   IF (status .NE. ferr_ok) GOTO 5000  
	ENDIF

* set the indices on the fixed, unvarying coordinate axes of the grid
* only the E and orient axes will be over-ridden later
	DO idim = 1, nferdims
	   ss(idim) = cx_lo_ss(grd_cx,idim)
	ENDDO
! DSGTBD eventually F axis should become an outer DO LOOP around all the logic

* copy the gridded (destination) axis coordinates into a buffer
	DO i = grd_lo, grd_hi
	   grd_coord(i) = TM_WORLD(i,grd_grid,orient,box_middle)
	ENDDO
* ... convert gridded coordinate buffer into the DSG time encoding
	IF (orient .EQ. t_dim) THEN
	   DO i = grd_lo, grd_hi
	      grd_coord(i) = TDEST_CONVERT(grd_coord(i))
	   ENDDO
	ENDIF

* get feature mask

	ascending = .TRUE.  ! may change for profiles


* ****** PERFORM THE REGRIDDING *****
	base = 0    ! obs index at end of preceding feature
* Loop over the features
	DO ifeature = 1, nfeatures 
	   flen = dsg_linemem(row_size_lm)%ptr(ifeature)

* ... have the user's constraints removed this feature?
	   IF (.NOT.fmask(ifeature)) GOTO 500

* ... set the gridded target E axis subscript 
	   ss(e_dim) = ifeature

* ... see if the current feature axis is identical to the last
	   IF (lastbase .NE. pnolastyet) THEN 
!xxxx	      if ifeature GT 1 Loop 1 to flen comparing ifeature to ifeature-1
!   dsg_linemem(dsg_coord_lm)%ptr(base+1)  and "lastbase + 1"
	      repeat_of_same_coords = .FALSE.  ! for debugging purposes
	   ENDIF

* ... If a profile regrid, see if the dsg coordinates are ascending
	   IF (orient .EQ. z_dim) THEN
	      CALL DSG_COORDS_UPDN (flen, dsg_linemem(dsg_coord_lm)%ptr(base+1), 
     .           bad_dsg, ascending, status)
	      IF (status .NE. ferr_ok) GOTO 5000
	   ENDIF
	      

* ... analyze the feature coordinates against the target axis coordinates
*     to find neighboring subscripts and interpolation coefficients
	  IF (.NOT. repeat_of_same_coords) THEN
!	     CALL GET_LINEAR_DSG_COEF(flen, dsg_linemem(dsg_coord_lm)%ptr(base+1),
!     .				      ngrd, grd_coord,
!     .				        ss, coef )
! partially developed a new routine, then changed my mind and 
! decided to reuse a routine developed for auxiliary coordinate regridding
             CALL FULL_SCAN_INDICES( dsg_linemem(dsg_coord_lm)%ptr(base+1),
     .				     1, flen,
     .                               1, flen,
     .                               bad_dsg, grd_coord,
     .                               ss12, coef, grd_lo, grd_hi,
     .                               ascending, has_valid )
	  ENDIF

! *sh* Not doing obs-level masking, as it can interfere with interpolation
!      May need to return to this with more experience later.
!* ... get observation-level mask for this feature
!	   CALL MAKE_DSG_OBS_MASK(dset, cx, ifeature, base,
!     .				  process_obs, flen)

	   del = 1
	   IF (.NOT.ascending) del = -1

* Loop over the target gridded axis points
	   DO igrd = grd_lo, grd_hi

* ... set the gridded target orient axis subscript 
	      ss(orient) = igrd

* ... are interpolants available for this DSG coordinate?
	      IF (coef(igrd) .EQ. bad_val4) THEN
                 grd(ss(1),ss(2),ss(3),ss(4),ss(5),ss(6)) = bad_grd
	         CYCLE
	      ENDIF

* ... interpolation coefficients into the ragged array data
              idsg = base + ss12(igrd)
              c1 = coef(igrd)
              c2 = 1.0 - c1
	      xact  = c1 .EQ. 1.0

* ... surrounding dsg (ragged array source) data points
              v1 = dsg(idsg)
	      IF (.NOT.xact) v2 = dsg(idsg+del)  ! avoid index out of bounds

* ... interpolate
              IF (v1.EQ.bad_dsg .OR. v2.EQ.bad_dsg ) THEN
                 grd(ss(1),ss(2),ss(3),ss(4),ss(5),ss(6)) = bad_grd
              ELSEIF (xact) THEN 
                 grd(ss(1),ss(2),ss(3),ss(4),ss(5),ss(6)) = v1
              ELSE
                 grd(ss(1),ss(2),ss(3),ss(4),ss(5),ss(6)) = c1*v1 + c2*v2
              ENDIF

! DSGTBD: creating equivalences to ss() will slightly shorten code
!         I didn't do this because equivs are invisible in Totalview

	   ENDDO ! obs loop
	   lastbase = base
 500	   base = base + flen
	ENDDO    ! feature loop

 5000	RETURN
 5100   CALL ERRMSG( ferr_invalid_command, status, 
     .   'Regrid from point data not allowed. Instead try USE/FEATURE=NONE ', *5000)
        END

	SUBROUTINE NUMCDE(XZ,STR,LETTER,NC,FRMTZ,DMS)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* revised for TMAP
* from PPLUS :
*	Directory PMEL:[PLOT5.PPLV11.PLOTLIB]NUMCDE.FOR

* search for "TMAP" to find all revisions
* *sh*  - 2/13/89 - added MOD 360. to LONE formatting
*		  ... no explicit declarations (too much trouble !) so it must
*		      be compiled with /WARNINGS=NODECLARATIONS
* *acm* - 1/ 6/04 - For longitude axes, do not label 0 degrees with E
*            (so they are now consistent with latitude axes)
* V600: *acm* 11/05 add xdms,ydms for deg/min labels
* V600: *acm* 5/06 Allow seconds in DMS axis labelling; had removed this.
* V63  *acm* 10/09 Changes for gfortran build
* V7    *acm* 6/16 Ticket 2434: command qualifiers /DEGMINSEC= /HALFSPAC
*                  DEGMINSEC=1 for Deg-Min axis labels, =2 for Deg-Min-Sec. Default = 1
*                  /HALFSPAC adds a half space between the degree sign and E/W or N/S


C**
C**    @(#)numcde.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C     ROUTINE ADDS LEADING ZEROS TO A NUMBER IF
C     LESS THAN ONE AND IFRMT=('0'....
C
c  Modified so that if FRMTZ has ",'LAT')" or ",'LON')" as last non-blank
c  characters, XZ will be assumed to be either latitude (+ for N, - for S)
c  or longitude (+0 to +180 for W, +180 to +360 for E, ie, continuous across
c  dateline) in EPIC format. FRMT and X will be modified so that axis labels
c  will be of the form 165 E or 6 S, etc.
c  NNS, Jun 85.
c
	CHARACTER*(*) FRMTZ
	CHARACTER*20 FRMT,STR,TEMP,STR_DMS
	CHARACTER*1  LETTER
        INTEGER TM_LENSTR1, dms, imin, isec, dot, deg
        REAL val, frac, minutes, seconds
C
	FRMT=FRMTZ
	TEMP=FRMTZ
	CALL UPPER(TEMP,20)
	X=XZ
	ILAT = INDEX (TEMP, ',''LAT'')')
	IF (ILAT .NE. 0) THEN
	  FRMT (ILAT+1:) = '''#'')'
	  IF (X .LT. 0) THEN
	    X=-X
	    LETTER = 'S'
	  ELSE IF (X .EQ. 0.) THEN
	    LETTER = ' '
	  ELSE
	    LETTER = 'N'
	  ENDIF
	ELSE
	  ILON = INDEX (TEMP, ',''LON'')') + INDEX (TEMP, ',''LONW'')')
	  ILONE = INDEX (TEMP, ',''LONE'')')
	  IF (ILON .NE. 0) THEN
	    FRMT (ILON+1:) = '''#'')'
	    IF (X .GT. 180.) THEN
	      X=360.-X
	      LETTER = 'E'
	    ELSE IF (X .EQ. 180.) THEN
	      LETTER = ' '
	    ELSE IF (X .LT. 0.) THEN
	      LETTER = 'E'
	      X = -X
	    ELSE
	      LETTER = 'W'
	    ENDIF
	  ELSE IF (ILONE .NE. 0)THEN
* TMAP insert 2/13/89
* Further fixes for X LE -180  1/18/2013

	    X = MOD( X, 360. )
* ... end of TMAP insert
	    FRMT (ILONE+1:) = '''#'')'
	    IF (X .GT.180.) THEN
	      X=360.-X
	      LETTER = 'W'
	    ELSE IF (ABS(X) .EQ. 180.) THEN
	      LETTER = ' '
	      X = ABS(X)
	    ELSE IF (X .LT. -180.) THEN
	      LETTER = 'E'
	      X = 360.+X
	    ELSE IF (X .LT. 0.) THEN
	      LETTER = 'W'
	      X = -X
	    ELSE IF (X .NE. 0.) THEN
	      LETTER = 'E'
            ELSE
	      LETTER = ' '
	    ENDIF
	  ENDIF
	ENDIF
C
	FLAG=0
	IF(FRMT(1:2).EQ.'(I'.OR.FRMT(1:2).EQ.'(i')THEN
	    WRITE(STR,FRMT)IFIX(X+SIGN(.5,X))
	ELSE
	    WRITE(STR,FRMT)X
	END IF
C     STRIP OFF LEADING ZERO AND SET FLAG
	IF(FRMT(1:4).EQ.'(''0''')THEN
	    TEMP=STR(2:20)
	    STR=TEMP
	    FLAG=1
	END IF
C     LEFT JUSTIFY STRING
	NC=0
100	IF(STR(1:1).EQ.' ')THEN
	    TEMP=STR(2:20)
	    STR=TEMP
	    NC=NC+1
	    IF(NC.LE.20)GOTO 100
	END IF
C     ADD LEADING ZERO
	IF(FLAG.EQ.1.AND.ABS(X).LT.1.1)THEN
	    IF(STR(1:1).EQ.'.')THEN
		TEMP='0'
		TEMP(2:)=STR(1:19)
	    ENDIF
	    IF(STR(1:2).EQ.'+.'.OR.STR(1:2).EQ.'-.')THEN
		TEMP=STR(1:1)
		TEMP(2:2)='0'
		TEMP(3:)=STR(2:18)
	    ENDIF
	    STR=TEMP
	END IF
	NC=LNBLK(STR,20)

* Reformat the value into deg,min,sec if requested.
* This means moving the degree symbol after the degrees
* and putting the direction (N,S,E,W) at the end
* For longitudes larger than 180, format them as is and
* translate to west longitude afterwards.
 
        STR_DMS = ' '
        IF (dms .GE. 1) THEN
            
           dot = INDEX(str,'.')
           deg = INDEX(str,'#')
           IF (dot .EQ. 0) dot = TM_LENSTR1(str) +1
           val = xz
           IF (xz .LT. 0) val = x

           ideg = INT(val)
           frac = val - FLOAT(ideg)
           minutes = 60.*frac
           imin = INT(minutes+0.1)  ! sun at least, turns 40 into 39 sometimes...
           frac = minutes - FLOAT(imin)
           seconds = 60.* frac
           isec = INT(seconds+0.1)

           IF (xz .GT. 180.) THEN
              ideg = 360-ideg
              imin = 60-imin
           ENDIF

           IF (dms .EQ. 2) THEN  ! write as deg,min,sec
              IF (ideg .LT. 100) THEN
                 WRITE (STR_DMS, 1100) ideg, imin, isec
              ELSE
                 WRITE (STR_DMS, 1101) ideg, imin, isec
              ENDIF
1100          FORMAT (I2.2, '#', I2.2, '''', I2.2, '''', '''')
1101          FORMAT (I3.3, '#', I2.2, '''', I2.2, '''', '''')

           ELSE IF (dms .EQ. 1) THEN  ! break into deg,min
              IF (ideg .LT. 100) THEN
                 WRITE (STR_DMS, 1200) ideg, imin
              ELSE
                 WRITE (STR_DMS, 1201) ideg, imin
              ENDIF
1200          FORMAT (I2.2, '#', I2.2, '''')
1201          FORMAT (I3.3, '#', I2.2, '''')

           ELSE IF (dms .EQ. 3) THEN  ! write as deg,min.frac

* get number of digits from the format given by the format that came into this routine.
* seeing if it is Fn.m.  If M=0, use minutes only. If M=1, then use one digit for the 
* fractional part of the mintues, otherwise write two digits. Round rather than truncating
* for degrees and fractions.

              dot = INDEX(frmtz,'.')
              READ (frmtz(dot+1:dot+1), *) digits
              IF (digits .EQ. 0) THEN   ! degrees, minutes only
                 imin = INT(minutes+0.5)
                 IF (ideg .LT. 100) THEN
                    WRITE (STR_DMS, 1300) ideg, imin
                 ELSE
                    WRITE (STR_DMS, 1301) ideg, imin
                 ENDIF
1300             FORMAT (I2.2, '#', I2.2, '''')
1301             FORMAT (I3.3, '#', I2.2, '''')
              ELSE IF (digits .EQ. 1) THEN  ! degrees,min.f

                 IF (ideg .LT. 100) THEN
                    WRITE (STR_DMS, 1400) ideg, minutes
                 ELSE
                    WRITE (STR_DMS, 1401) ideg, minutes
                 ENDIF
1400             FORMAT (I2.2, '#', F4.1, '''')
1401             FORMAT (I3.3, '#', F4.1, '''')
              ELSE                          ! degrees,min.ff
                 IF (ideg .LT. 100) THEN
                    WRITE (STR_DMS, 1500) ideg, minutes
                 ELSE
                    WRITE (STR_DMS, 1501) ideg, minutes
                 ENDIF
1500             FORMAT (I2.2, '#', F5.2, '''')
1501             FORMAT (I3.3, '#', F5.2, '''')
              ENDIF

           ELSE 
              STR_DMS = str
           ENDIF
           str = STR_DMS
           NC=LNBLK(STR,20)

        ENDIF

	RETURN
	END

*
* is_element_of.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* March 2003
*
*  Return logical value (integer 1 or 0); If argument 1 takes on any of 
*  the values of the second argument, return 1, else 0.

*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE is_element_of_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CHARACTER*100 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns 1 if first argument contains any of the ',
     .        'values in argument 2, else 0')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 2)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                ABSTRACT, NORMAL,
     .                                NORMAL,   NORMAL,
     .                                NORMAL,   NORMAL)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'VAR')
      CALL ef_set_arg_desc(id, arg, 'data to test')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'VALUES')
      CALL ef_set_arg_desc(id, arg, 'values to search for')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE is_element_of_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
*

      INTEGER ivalue

      ivalue = 1
      CALL ef_set_axis_limits(id, X_AXIS, ivalue, ivalue)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE is_element_of_compute(id, arg_1, arg_2, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

C  Check for values matching arg2

C  Returns a single value, so no incrementing result indices
      i = res_lo_ss(X_AXIS)
      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      l = res_lo_ss(T_AXIS)
      m = res_lo_ss(E_AXIS)
      n = res_lo_ss(F_AXIS)

      DO 100 n1=arg_lo_ss(F_AXIS,ARG1), arg_hi_ss(F_AXIS, ARG1)
      DO 100 m1=arg_lo_ss(E_AXIS,ARG1), arg_hi_ss(E_AXIS, ARG1)
      DO 100 l1=arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS, ARG1)
      DO 100 k1=arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS, ARG1)
      DO 100 j1=arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS, ARG1)
      DO 100 i1=arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS, ARG1)

         IF ( arg_1(i1,j1,k1,l1,m1,n1) .NE. bad_flag(1) ) THEN

            DO 200 n2=arg_lo_ss(F_AXIS,ARG2), arg_hi_ss(F_AXIS, ARG2)
            DO 200 m2=arg_lo_ss(E_AXIS,ARG2), arg_hi_ss(E_AXIS, ARG2)
            DO 200 l2=arg_lo_ss(T_AXIS,ARG2), arg_hi_ss(T_AXIS, ARG2)
            DO 200 k2=arg_lo_ss(Z_AXIS,ARG2), arg_hi_ss(Z_AXIS, ARG2)
            DO 200 j2=arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS, ARG2)
            DO 200 i2=arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS, ARG2)

               IF ( arg_2(i2,j2,k2,l2,m2,n1) .NE. bad_flag(2) ) THEN

                  IF ( arg_1(i1,j1,k1,l1,m1,n1) .EQ.
     .                 arg_2(i2,j2,k2,l2,m2,n2) ) THEN
C A match was found; done
                     result(i,j,k,l,m,n) = 1.
                     RETURN
                  ENDIF

               ENDIF

 200        CONTINUE

         ENDIF

 100  CONTINUE

C No match found
      result(i,j,k,l,m,n) = 0.
      RETURN

      END

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

*
*  scat2grid_nobs_xyt
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE.
*
* Ansley Manke
* July 2008  from scat2grid_nobs_xy

* Returns # observations in each grid cell when a variable is interpolated
* onto an equally-spaced X-Y-T grid.  Input is scattered locations xpts, ypts, tpts
* and the desired result grid.  Output is # observations in each grid cell
* when data is gridded in x and y. The time axis must have the same units and origin
* as the scattered time points. Calls routine "nobs" based on Billy
* Kessler's gaussmap-subs.
*
*
* In this subroutine we provide information about
* the function.  The user configurable information
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
*
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result
*


      SUBROUTINE  scat2grid_nobs_xyt_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .        'Count observations when gridding scattered ' //
     .        'data to XYT grid using Gaussian function')
      CALL ef_set_num_args(id, 6)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                NORMAL,          IMPLIED_BY_ARGS,
     .                                NORMAL,          NORMAL)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 4)

* Output grid is determined by arguments 4, 5, 6, the result's x, y, t axes.

      arg = 1
      CALL ef_set_arg_name(id, arg, 'XPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'X coordinates of scattered XYT locations')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'YPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'Y coordinates of scattered XYT locations')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'TPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'T coordinates of scattered XYT locations')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'XAXPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'X axis coordinates of a regular output grid')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, NO, NO, NO, NO, NO)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'YAXPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'Y axis coordinates of a regular output grid')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, YES, NO, NO, NO, NO)

      arg = 6
      CALL ef_set_arg_name(id, arg, 'TAXPTS')
      CALL ef_set_arg_desc(id, arg,
     .        'T axis coordinates of a regular output grid, ' //
     .        'with same units and origin as TPTS')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, YES, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE scat2grid_nobs_xyt_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER nxout, nyout, ntout, nx2, ny2, nt2

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nxout = 1 + arg_hi_ss(X_AXIS,ARG4) - arg_lo_ss(X_AXIS,ARG4)
      nyout = 1 + arg_hi_ss(Y_AXIS,ARG5) - arg_lo_ss(Y_AXIS,ARG5)
      ntout = 1 + arg_hi_ss(T_AXIS,ARG6) - arg_lo_ss(T_AXIS,ARG6)

      nx2 = nxout * 2
      ny2 = nyout * 2
      nt2 = ntout * 2

* xax  output x axis
      CALL ef_set_work_array_dims_6d(id, 1,
     .                                1, 1, 1, 1, 1, 1,
     .                              nx2, 1, 1, 1, 1, 1)

* yax  output y axis
      CALL ef_set_work_array_dims_6d(id, 2,
     .                                1, 1, 1, 1, 1, 1,
     .                              ny2, 1, 1, 1, 1, 1)

* tax  output t axis
      CALL ef_set_work_array_dims_6d(id, 3,
     .                                1, 1, 1, 1, 1, 1,
     .                              nt2, 1, 1, 1, 1, 1)

* obs  work array - counts of observations
      CALL ef_set_work_array_dims_6d(id, 4,
     .                                1,     1,     1, 1, 1, 1,
     .                            nxout, nyout, ntout, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*

      SUBROUTINE  scat2grid_nobs_xyt_compute(id, arg_1, arg_2, arg_3,
     .                                    arg_4, arg_5, arg_6, result,
     .                                    xax, yax, tax, obs)

*  arg_1  xpts  \
*  arg_2  ypts   | Scattered x,y,t triplets to be gridded.
*  arg_2  tpts  /
*  arg_4  xaxis of new grid
*  arg_5  yaxis of new grid
*  arg_6  taxis of new grid

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz,
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz,
     .           mem4lot:mem4hit, mem4loe:mem4hie, mem4lof:mem4hif)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz,
     .           mem5lot:mem5hit, mem5loe:mem5hie, mem5lof:mem5hif)
      REAL arg_6(mem6lox:mem6hix, mem6loy:mem6hiy, mem6loz:mem6hiz,
     .           mem6lot:mem6hit, mem6loe:mem6hie, mem6lof:mem6hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* Ignore the unused final dimensions in the work arrays since
* Fortran is column major
      REAL*8 xax(wrk1lox:wrk1hix/2)
      REAL*8 yax(wrk2lox:wrk2hix/2)
      REAL*8 tax(wrk3lox:wrk3hix/2)
      REAL obs(wrk4lox:wrk4hix, wrk4loy:wrk4hiy, wrk4loz:wrk4hiz)

* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable''s axes.

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l, m, n
      INTEGER idx, lo_ss, hi_ss
      INTEGER nxpts, nypts, ntpts, nscat
      INTEGER nx, ny, nt
      INTEGER i1, j1, l1
      REAL x1, y1, t1, xf, yf, tf
      REAL xx, yy, tt
      REAL dx, dy, dt, xxbeg, xxend, yybeg, yyend, ttbeg, ttend
      CHARACTER*250 errtxt

C  variables for checking axis characteristics (modulo axes)
      CHARACTER ax_name(6)*16, ax_units(6)*16
      LOGICAL backward(6), mdulo(6), regular(6)
      LOGICAL modulox, moduloy, modulot
      REAL*8 modxlen, modylen, modtlen

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*  Check to see if output axes are regular, and get modulo characteristics
      CALL ef_get_axis_info_6d(id, ARG4, ax_name, ax_units,
     .                         backward, mdulo, regular)
      IF ( .NOT. regular(X_AXIS) ) THEN
         errtxt = 'Output axes must be REGULARLY spaced'
         GOTO 999
      ENDIF
      modulox = mdulo(X_AXIS)
      IF ( modulox ) THEN
         CALL ef_get_axis_modulo_len(id, ARG4, X_AXIS, modxlen)
      ENDIF

      CALL ef_get_axis_info_6d(id, ARG5, ax_name, ax_units,
     .                         backward, mdulo, regular)
      IF ( .NOT. regular(Y_AXIS) ) THEN
         errtxt = 'Output axes must be REGULARLY spaced'
         GOTO 999
      ENDIF
      moduloy = mdulo(Y_AXIS)
      IF ( moduloy ) THEN
         CALL ef_get_axis_modulo_len(id, ARG5, Y_AXIS, modylen)
      ENDIF

      CALL ef_get_axis_info_6d(id, ARG6, ax_name, ax_units,
     .                         backward, mdulo, regular)
      IF ( .NOT. regular(T_AXIS) ) THEN
         errtxt = 'Output axes must be REGULARLY spaced'
         GOTO 999
      ENDIF
      modulot = mdulo(T_AXIS)
      IF ( modulot ) THEN
         CALL ef_get_axis_modulo_len(id, ARG6, T_AXIS, modtlen)
      ENDIF

*  Find number of points in scattered input points.  1-D arrays defining the
*  scattered data points may lie on the X, Y, Z, T, E, or F axis of the input
*  arguments.
*  Using as flattened arrays, so consider all axes.

      nxpts = 0
      DO 10 idx = X_AXIS, F_AXIS
         lo_ss = arg_lo_ss(idx,ARG1)
         hi_ss = arg_hi_ss(idx,ARG1)
         IF ( lo_ss .NE. ef_unspecified_int4 ) THEN
            IF ( nxpts .NE. 0 ) THEN
               nxpts = nxpts * (hi_ss - lo_ss + 1)
            ELSE
               nxpts = hi_ss - lo_ss + 1
            ENDIF
         ENDIF
  10  CONTINUE

      nypts = 0
      DO 20 idx = X_AXIS, F_AXIS
         lo_ss = arg_lo_ss(idx,ARG2)
         hi_ss = arg_hi_ss(idx,ARG2)
         IF ( lo_ss .NE. ef_unspecified_int4 ) THEN
            IF ( nypts .NE. 0 ) THEN
               nypts = nypts * (hi_ss - lo_ss + 1)
            ELSE
               nypts = hi_ss - lo_ss + 1
            ENDIF
         ENDIF
  20  CONTINUE

      ntpts = 0
      DO 40 idx = X_AXIS, F_AXIS
         lo_ss = arg_lo_ss(idx,ARG3)
         hi_ss = arg_hi_ss(idx,ARG3)
         IF ( lo_ss .NE. ef_unspecified_int4 ) THEN
            IF ( ntpts .NE. 0 ) THEN
               ntpts = ntpts * (hi_ss - lo_ss + 1)
            ELSE
               ntpts = hi_ss - lo_ss + 1
            ENDIF
         ENDIF
  40  CONTINUE

      IF ( nxpts .NE. nypts ) THEN
         WRITE (errtxt,90) ' XPTS,', ' YPTS ', nxpts, nypts
         GOTO 999
      ENDIF
      IF ( nxpts .NE. ntpts ) THEN
         WRITE (errtxt,90) ' XPTS,', ' TPTS ', nxpts, ntpts
         GOTO 999
      ENDIF
  90  FORMAT('Input scattered', 2A6, 'have different # of points', 2I8)

      IF ( nxpts .LE. 0 ) THEN
         errtxt = 'No data in scattered x, y, t points'
         GOTO 999
      ENDIF

      nscat = nxpts

*  Compute number of points in output axes.

      lo_ss = arg_lo_ss(X_AXIS,ARG4)
      hi_ss = arg_hi_ss(X_AXIS,ARG4)
*  Check that xax is an X axis
      IF ( lo_ss .EQ. ef_unspecified_int4 ) THEN
         errtxt = 'Fourth argument must be an X axis'
         GO TO 999
      ENDIF
      nx = hi_ss - lo_ss + 1

      lo_ss = arg_lo_ss(Y_AXIS,ARG5)
      hi_ss = arg_hi_ss(Y_AXIS,ARG5)
*  Check that yax a Y axis
      IF ( lo_ss .EQ. ef_unspecified_int4 ) THEN
         errtxt = 'Fifth argument must be a Y axis'
         GO TO 999
      ENDIF
      ny = hi_ss - lo_ss + 1

      lo_ss = arg_lo_ss(T_AXIS,ARG6)
      hi_ss = arg_hi_ss(T_AXIS,ARG6)
*  Check that tax a T axis
      IF ( lo_ss .EQ. ef_unspecified_int4 ) THEN
         errtxt = 'Sixth argument must be a T axis'
         GO TO 999
      ENDIF
      nt = hi_ss - lo_ss + 1

C  Get coordinates of output axes.

      CALL ef_get_coordinates(id, ARG4, X_AXIS, arg_lo_ss(X_AXIS, ARG4),
     .                        arg_hi_ss(X_AXIS, ARG4), xax)

      CALL ef_get_coordinates(id, ARG5, Y_AXIS, arg_lo_ss(Y_AXIS, ARG5),
     .                        arg_hi_ss(Y_AXIS, ARG5), yax)

      CALL ef_get_coordinates(id, ARG6, T_AXIS, arg_lo_ss(T_AXIS, ARG6),
     .                        arg_hi_ss(T_AXIS, ARG6), tax)

*  Set start, end, and delta for output axes.

      x1 = xax(1)
      y1 = yax(1)
      t1 = tax(1)

      xf = xax(nx)
      yf = yax(ny)
      tf = tax(nt)

*  Gridbox sizes in data units
      dx = xf - x1
      IF ( nx .GT. 1 ) dx = (xf-x1) / REAL(nx-1)
      dy = yf - y1
      IF ( ny .GT. 1 ) dy = (yf-y1) / REAL(ny-1)
      dt = tf - t1
      IF ( nt .GT. 1 ) dt = (tf-t1) / REAL(nt-1)

*  Compute result

*  Initialize counts.

      DO l = 1, nt
         DO j = 1, ny
            DO i = 1, nx
               obs(i,j,l) = 0.
            ENDDO
         ENDDO
      ENDDO

*  Loop over x, y, and t, compute the number of observations for the gaussian-
*  weighted mapping onto the grid.  Lat, lon, and time may be on the X,Y,Z,T,E,
*  or F axis of ARG1 and ARG2, sending them to a subroutine collapses the extra
*  dimensions so the value can be found.

      DO 700 idx = 1, nscat

         CALL pickout3(arg_1, arg_2, arg_3, idx, xx, yy, tt)
         IF ( xx .EQ. bad_flag(ARG1) .OR.
     .        yy .EQ. bad_flag(ARG2) .OR.
     .        tt .EQ. bad_flag(ARG3) ) GOTO 700

*  If an output axis is modulo, apply modulo adjustment to that coordinate
*  of the scattered point.
         IF ( modulox ) THEN
            CALL modscat(xax(1), xax(nx), modxlen, 1, xx)
         ENDIF
         IF ( moduloy ) THEN
            CALL modscat(yax(1), yax(ny), modylen, 1, yy)
         ENDIF
         IF ( modulot ) THEN
            CALL modscat(tax(1), tax(nt), modtlen, 1, tt)
         ENDIF

         CALL nobsxyt(xx, yy, tt, nx, ny, nt, x1, y1, t1,
     .                dx, dy, dt, xf, yf, tf, obs)

*  Put points within dx or dy  or dt of the end just beyond the
*  other end, and use in the gridding computation.

         IF ( modulox ) THEN
            IF ( (xx-x1 .GE. 0.) .AND. (xx-x1 .LT. dx) ) THEN
               xxend = xf + (xx-x1)
               CALL nobsxyt(xxend, yy, tt, nx, ny, nt, x1, y1, t1,
     .                      dx, dy, dt, xf, yf, tf, obs)
            ENDIF

            IF ( (xf-xx .GE. 0.) .AND. (xf-xx .LT. dx) ) THEN
               xxbeg = x1 - (xf-xx)
               CALL nobsxyt(xxbeg, yy, tt, nx, ny, nt, x1, y1, t1,
     .                      dx, dy, dt, xf, yf, tf, obs)
            ENDIF
         ENDIF

         IF ( moduloy ) THEN
            IF ( (yy-y1 .GE. 0.) .AND. (yy-y1 .LT. dy) ) THEN
               yyend = yf + (yy-y1)
               CALL nobsxyt(xx, yyend, tt, nx, ny, nt, x1, y1, t1,
     .                      dx, dy, dt, xf, yf, tf, obs)
            ENDIF

            IF ( (yf-yy .LT. 0.) .AND. (yf-yy .LT. dy) ) THEN
               yybeg = y1 - (yf-yy)
               CALL nobsxyt(xx, yybeg, tt, nx, ny, nt, x1, y1, t1,
     .                      dx, dy, dt, xf, yf, tf, obs)
            ENDIF
         ENDIF

         IF ( modulot ) THEN
            IF ( (tt-t1 .GE. 0.) .AND. (tt-t1 .LT. dt) ) THEN
               ttend = tf + (tt-t1)
               CALL nobsxyt(xx, yy, ttend, nx, ny, nt, x1, y1, t1,
     .                      dx, dy, dt, xf, yf, tf, obs)
            ENDIF

            IF ( (tf-tt .LT. 0.) .AND. (tf-tt .LT. dt) ) THEN
               ttbeg = t1 - (tf-tt)
               CALL nobsxyt(xx, yy, ttbeg, nx, ny, nt, x1, y1, t1,
     .                      dx, dy, dt, xf, yf, tf, obs)
            ENDIF
         ENDIF

 700  CONTINUE

*  Put gridded fcn into result variable.
*  The result is normal to the Z, E, and F axes
      k = res_lo_ss(Z_AXIS)
      m = res_lo_ss(E_AXIS)
      n = res_lo_ss(F_AXIS)

      l1 = 1
      DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         j1 = 1
         DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            i1 = 1
            DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

               result(i,j,k,l,m,n) = obs(i1,j1,l1)

               i1 = i1 + 1
 100        CONTINUE

            j1 = j1 + 1
 200     CONTINUE

         l1 = l1 + 1
 400  CONTINUE

      RETURN

 999  CALL EF_BAIL_OUT(id, errtxt)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Linux replacement for fdate/date routines.  
*
* kob 3.11.97

	SUBROUTINE FDATE(date)

        IMPLICIT NONE
	CHARACTER*(*) date

	CHARACTER*9 linux_date
	CHARACTER*2 month
	character*3 mmm
#ifndef solaris
	CALL DATE_AND_TIME(linux_date)
#endif
	month = linux_date(5:6)
	if (month .eq. '01') then
		mmm = "Jan"
	else if (month .eq. '02') then
		mmm = "Feb"
	else if (month .eq. '03') then
		mmm = "Mar"
	else if (month .eq. '04') then
		mmm = "Apr"
	else if (month .eq. '05') then
		mmm = "May"
	else if (month .eq. '06') then
		mmm = "Jun"
	else if (month .eq. '07') then
		mmm = "Jul"
	else if (month .eq. '08') then
		mmm = "Aug"
	else if (month .eq. '09') then
		mmm = "Sep"
	else if (month .eq. '10') then
		mmm = "Oct"
	else if (month .eq. '11') then
		mmm = "Nov"
	else if (month .eq. '12') then
		mmm = "Dec"
	endif

	date = linux_date(7:8)//'-'//mmm//'-'//linux_date(3:4)

	return
	end

************************TODAY'S TIME******************************

	SUBROUTINE FTIME(time)
        IMPLICIT NONE

	CHARACTER*(*) time

	character*9 linux_date
	character*10 linux_time

#ifndef solaris	
	call DATE_AND_TIME(linux_date, linux_time)
#endif
	time = linux_time(1:2)//':'//linux_time(3:4)//':'//linux_time(5:6)

	return
	end

c*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
c*
c* Initialize the context limits the EF will use.  
c*
* 4D subroutine version which calls the 6D subroutine version and
* checks the E and F dimensions are unused
*

      SUBROUTINE EF_GET_ARG_SUBSCRIPTS(id, arg_lo_ss, arg_hi_ss, 
     .                                 arg_incr)

      IMPLICIT NONE
      INCLUDE 'tmap_dims.parm'
      INCLUDE 'EF_Util.parm'

* argument declarations - 4D
      INTEGER id,
     .        arg_lo_ss(4,EF_MAX_ARGS+1), 
     .        arg_hi_ss(4,EF_MAX_ARGS+1),
     .        arg_incr (4,EF_MAX_ARGS+1)

* local variables
      INTEGER ndx, adx,
     .        arg_lo_ss_6d(nferdims,EF_MAX_ARGS+1), 
     .        arg_hi_ss_6d(nferdims,EF_MAX_ARGS+1),
     .        arg_incr_6d (nferdims,EF_MAX_ARGS+1)
      CHARACTER*128 buf

* call the 6D version
      CALL EF_GET_ARG_SUBSCRIPTS_6D(id, arg_lo_ss_6d, arg_hi_ss_6d,
     .                              arg_incr_6d)

* check E and F are unused
      DO 110 adx = 1, EF_MAX_ARGS
         DO 100 ndx = 5, nferdims
            IF ( arg_lo_ss_6d(ndx, adx) .NE.
     .           arg_hi_ss_6d(ndx, adx) ) THEN
               WRITE (buf,50) ndx, adx
 50            FORMAT ('Dimension ', I1, ' of argument ', I2,
     .            ' is used; use EF_GET_ARG_SUBSCRIPTS_6D instead')
               CALL EF_BAIL_OUT(id, buf)
               STOP 'EF_BAIL_OUT returned in EF_GET_ARG_SUBSCRIPTS'
            ENDIF
 100     CONTINUE
 110  CONTINUE

* copy to the 4D arrays
      DO 210 adx = 1, EF_MAX_ARGS
         DO 200 ndx = 1, 4
            arg_lo_ss(ndx, adx) = arg_lo_ss_6d(ndx, adx)
            arg_hi_ss(ndx, adx) = arg_hi_ss_6d(ndx, adx)
            arg_incr (ndx, adx) = arg_incr_6d (ndx, adx)
 200     CONTINUE
 210  CONTINUE

      RETURN 
      END

	SUBROUTINE XEQ_ELSE

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Process the ELSE in a multi-line IF compound statement

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V420:  4/96
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V693+ *sh* 12/14 Simplified blocks skipped by IF using ifstk_skipping

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'

* local variable declarations
	INTEGER	status

* initial sanity checks
	IF ( .NOT.if_conditional ) GOTO 5010

* check that something was given to "if" on
	IF ( num_args .GE. 1 ) GOTO 5100

* is this the end of the clause that has been executing?
	IF ( if_doing(ifstk) .EQ. pif_doing_clause ) THEN
	   if_doing(ifstk) = pif_skip_to_endif
	   ifstk_skipping = 0   ! skipping is controlled by this IF-nest level

* or the start of the clause to execute
	ELSEIF ( if_doing(ifstk) .EQ. pif_skip_to_clause ) THEN
	   if_doing(ifstk) = pif_doing_clause

* anything else is an internal error
	ELSE
	   GOTO 5200
	ENDIF

	RETURN
	
* error exit
* ... control stack pointer, CSP, corrected in GFD_ERROR_HANDLER
 5000	RETURN
 5010	CALL ERRMSG( ferr_invalid_command, status,
     .		'ELSE can only be used between IF and ENDIF', *5000)
 5100	CALL ERRMSG( ferr_syntax, status,
     .		'ELSE statement stands alone. Continue on next line"'//
     .			pCR//cmnd_buff(:len_cmnd), *5000 )
 5200	CALL ERRMSG( ferr_internal, status, 'IF-ELSE', *5000)
	END

c*
c* ef_get_box_limits.F
c*
c* Ansley Manke
c* Jan 12th 1999
c*Based on ef_get_coordinates.F
c*
   
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
c*
c* This fills in the box_limits of an axis in a grid.  
c*
c* JC_TODO: What about REAL*8 values being passed back to C
c*

      SUBROUTINE EF_GET_BOX_LIMITS(id, iarg, idim,
     .     ss_lo_lim, ss_hi_lim, values_lo, values_hi )

      IMPLICIT NONE
      INCLUDE 'tmap_dims.parm'
      INCLUDE 'ferret.parm'
      INCLUDE 'xvariables.cmn'
      INCLUDE 'xcontext.cmn'
      INCLUDE 'EF_Util.parm'

      INTEGER id, iarg, idim
      INTEGER ss_lo_lim, ss_hi_lim
      INTEGER grid, i

      REAL*8  values_lo( ss_lo_lim:ss_hi_lim )
      REAL*8  values_hi( ss_lo_lim:ss_hi_lim )
      REAL*8  TM_WORLD

      INTEGER cx_list(EF_MAX_ARGS)

c* The context list was cached by Ferret and must be retrieved
c* to be accessible to the external function.

      CALL EF_GET_CX_LIST(cx_list)

*     defining grid for output data
      grid = cx_grid( cx_list(iarg) )

      DO 100 i = ss_lo_lim, ss_hi_lim
         values_lo( i ) = TM_WORLD( i,grid,idim,box_lo_lim )
 100  continue

      DO 200 i = ss_lo_lim, ss_hi_lim
         values_hi( i ) = TM_WORLD( i,grid,idim,box_hi_lim )
 200  continue

      RETURN 
      END

	SUBROUTINE WS_FILL_REP (zwsid,zwstype)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Setup the fill area indices for patterns or colors for generic WS

*	J Davison JISAO/PMEL/TMAP
*	9.2.88/3.15.89
*	*jd* 2.19.92 mods to support atc gks -- use/not use area bundles
*	*jd* 10.1.92 mod to support protected color indices
*	*jd* 12.3.93 mod to set color reps in metafiles as well as window ws
* 	*jd* 7.21.95 bug fix where if meta_clsplt has been invoked to close
*			the metafile, error messages are emitted when trying
*			to setup the color table for the closed ws
*       *js* 7.31.97 mod to change call to gqlwk to query_xgks_wkstn
* V600 *acm* 5/06  num_line_colors for MODE LINECOLORS. Number of line colors 
*                  no longer fixed at 6.

        include         'shade_vars.cmn'
        include         'gkscm1_inc.decl'
        include         'gkscm2.cmn'
        include         'GKSCM1.INC'
	include         'gkspar.inc'
        include         'parampl5_dat.decl'
        include         'PARAMPL5.DAT'
        include         'plt_inc.decl'
        include         'PLT.INC'
	include		'pen_inc.decl'
        include         'PEN.INC'  ! with num_linecolors

	integer		zwsid,zwstype,error
	integer		patt,ndx
	integer		max_pline,max_pmark,max_text,max_fill_area
	integer		max_pattern,max_color,usable_colors

	integer		wsmgr_reserve,line_color_reserve
C	data		wsmgr_reserve/6/,line_color_reserve/6/

C	data stmt added for linux *jd* 12.96


*******************************************************************************

        line_color_reserve = num_line_colors
        wsmgr_reserve = num_line_colors

*	WHAT IS AVAILABLE ON THIS WORKSTATION?
	call query_xgks_wkstn (zwstype,error,max_pline,max_pmark,
     .	            max_text,max_fill_area,max_pattern,max_color)
	if (error .ne. 0) goto 1000

	if (max_color .eq. 2) then
*	   USE PATTERNS -- NOT ENOUGH COLORS AVAILABLE
	   if (area_bundles) then
*	      MISSING VALUE PATTERN
	      call gsfar (zwsid,1,gpattr,2,1)

*	      LOWEST DATA PATTERN IS BLACK
	      call gsfar (zwsid,2,gsolid,1,1)

	      if (shd_levels .eq. 1) goto 30
*	      GO THRU AVAILABLE PATTERNS
	      do 10 ndx = 1,shd_levels - 1
#ifdef atc_gks
	         call gspa (1.0,1.0)
	         call gsparf (0.0,0.0)
	         patt = 1 + ndx*9/(shd_levels-1)
#else
	         patt = 28 - ndx*14/(shd_levels-1)
#endif
	         call gsfar (zwsid,ndx+2,gpattr,patt,1)
10	      continue
	   else
	      call hatch_fill_rep (zwsid)
	   endif
	else

*	   USE COLORS
*	   type *, 'protect_used_colors', protect_used_colors
	   if (protect_used_colors) then
	      lo_color_ndx(zwsid) = max(hi_color_ndx(zwsid) + 1,
     .						line_color_reserve + 1)
	      protect_used_colors = .false.
	   else
	      lo_color_ndx(zwsid) = max(line_color_reserve + 1,
     .						lo_color_ndx(zwsid))
	   endif

	   usable_colors = max_color - wsmgr_reserve - lo_color_ndx(zwsid)

	   if (usable_colors .lt. shd_levels) then
c	      write (6,'(/a)') ' PPL+ error: You''re attempting to use '//
	      write (6,'(/a)') ' PPL warning: You''re attempting to use '//
     .           'more colors than are available.'
	      write (6,'(a/)') '             Using PPL SHASET RESET to re-use'//
     .		 ' protected colors may help.'
	      lo_color_ndx(zwsid) = max (line_color_reserve + 1,
     .				  max_color - wsmgr_reserve - shd_levels)
	   endif
	   hi_color_ndx(zwsid) = lo_color_ndx(zwsid) + shd_levels - 1

*	   type *, 'max_color, usable_colors, lo_color_ndx(zwsid),'// 
*     .						' hi_color_ndx(zwsid)'
*	   type *,  max_color, usable_colors, lo_color_ndx(zwsid), 
*     .						  hi_color_ndx(zwsid)

*	CHOOSE CUSTOM COLORS OR THE DEFAULT SELECTION
	   if (custom_colors) then
	      call setup_color_table (zwsid,lo_color_ndx(zwsid),shd_levels)
#ifdef xgks
	      if (meta_actv .and. .not. meta_clsplt) call setup_color_table 
     .			(meta_wsid,lo_color_ndx(zwsid),shd_levels)
#endif
	   else
	      call set_default_colors (zwsid,zwstype,lo_color_ndx(zwsid),
     .							shd_levels)
	   end if

	   if (.not. area_bundles) goto 30

*	   NOW SET THE FILL REP
	   do 20 ndx = 1,shd_levels
	      call gsfar (zwsid,ndx+lo_color_ndx(zwsid)+1,gsolid,1,
     .						lo_color_ndx(zwsid)-1+ndx)
20	   continue
	end if

30	return

*	FATAL ERROR
1000	return

	end

*
* tax_index_datestring.F
*
*
* Returns string of dates 
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, tax_index_datestring )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )


      SUBROUTINE tax_index_datestring_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     . 'Returns date string for time axis coordinate values' )

      CALL ef_set_num_args(id, 3)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_result_type(id, STRING_RETURN)

      CALL ef_set_num_work_arrays(id, 1)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 'indices of time steps to convert')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)


      arg = 2
      CALL ef_set_arg_name(id, arg, 'B')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 'variable with reference time axis')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

*     Set data type as string
      arg = 3
      CALL ef_set_arg_type (id, arg, STRING_ARG)

      CALL ef_set_arg_name(id, arg, 'C')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 'output precision')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE tax_index_datestring_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
* 
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_dims(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER ntout, nt2
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      ntout = 1 + arg_hi_ss(T_AXIS,ARG2) - arg_lo_ss(T_AXIS,ARG2)

      nt2 = (ntout+1)* 2

* tax  output t axis
      CALL ef_set_work_array_dims (id, 1, 1, 1, 1, 1, nt2, 1, 1, 1)

      RETURN
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE tax_index_datestring_compute(id, arg_1, arg_2, arg_3, 
     .           result, tax)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy,
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy,
     .           mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3(2,mem3lox:mem3hix, mem3loy:mem3hiy, 
     .     mem3loz:mem3hiz, mem3lot:mem3hit)

      REAL result(2,memreslox:memreshix, memresloy:memreshiy, 
     .     memresloz:memreshiz, memreslot:memreshit)


* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l
      INTEGER i1, j1, k1, l1
      INTEGER i3, j3, k3, l3
      INTEGER rtype, iindex, prec, dlen
      CHARACTER*32 datestring
      CHARACTER*3 precistring
      REAL*8 ddate

*  Dimension the work arrays

      REAL*8 tax(wrk1lox:wrk1hix/2, wrk1loy:wrk1hiy,
     .               wrk1loz:wrk1hiz, wrk1lot:wrk1hit)

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_result_type(id, rtype)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*     Get the precision for output
      i3=arg_lo_ss(X_AXIS, ARG3)
      j3=arg_lo_ss(Y_AXIS, ARG3)
      k3=arg_lo_ss(Z_AXIS, ARG3)
      l3=arg_lo_ss(T_AXIS, ARG3)

*     Get the output presicion (string)
      CALL ef_get_string_arg_element(id, ARG3, arg_3,
     .     i3,j3,k3,l3,dlen,precistring)

      CALL LOWER(precistring)
      IF (precistring .EQ. 'sec') THEN
*         'dd-MMM-yyyy HH:mm:ss' or 'yyyy-MM-dd HH:mm:ss' date format
          prec = 6
      ELSE IF (precistring .EQ. 'min') THEN
*         'dd-MMM-yyyy HH:mm' or 'yyyy-MM-dd HH:mm' date format
          prec = 5
      ELSE IF (precistring .EQ. 'hou') THEN
*         'dd-MMM-yyyy HH' or 'yyyy-MM-dd HH' date format
          prec = 4
      ELSE IF (precistring .EQ. 'day') THEN
*         'dd-MMM-yyyy' or 'yyyy-MM-dd' date format
          prec = 3
      ELSE IF (precistring .EQ. 'mon') THEN
*         'MMM-yyyy' or 'yyyy-MM' date format
          prec = 2
      ELSE IF (precistring .EQ. 'yea') THEN
*         'yyyy' date format
          prec = 1
      ELSE
*         'dd-MMM-yyyy HH:mm:ss' or 'yyyy-MM-dd HH:mm:ss' date format
          prec = 6
      ENDIF

* Get coordinates of time axis

      call ef_get_coordinates(id, ARG2, T_AXIS, 
     .   arg_lo_ss(T_AXIS, ARG2), arg_hi_ss(T_AXIS, ARG2), tax)

      i1 = arg_lo_ss(X_AXIS,ARG1)
      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               l1 = arg_lo_ss(T_AXIS,ARG1)
               DO 100 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

                 iindex = arg_1(i1,j1,k1,l1)
                 ddate =  tax(iindex,1,1,1)

C     Get the string value of dates and put them in the result.
                 CALL EF_GET_AXIS_DATES (id, ARG2, ddate, 1, prec, dlen, datestring)
                 CALL EF_PUT_STRING (datestring, dlen, result(1,i,j,k,l))

                  l1 = l1 + arg_incr(T_AXIS,ARG1)
 100           CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 300     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
 400  CONTINUE
     
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END
****************************************************************
*
      SUBROUTINE LOWER(TEXT)
      CHARACTER*(*) TEXT
*
*     Converts a string to lowercase.
*
      EXTERNAL LENGTH
      INTEGER  LENGTH
      CHARACTER*1 LETTER
      INTEGER ISHIFT,I
      ISHIFT=ICHAR('a')-ICHAR('A')
      DO 10 I=1,LENGTH(TEXT)
        LETTER=TEXT(I:I)
        IF('A'.LE.LETTER.AND.LETTER.LE.'Z') THEN
          TEXT(I:I)=CHAR(ICHAR(LETTER)+ISHIFT)
        END IF
   10 CONTINUE
      RETURN
      END

***************************************************************
*
      INTEGER FUNCTION LENGTH(TEXT)
      CHARACTER*(*) TEXT
*
*     Computes the length of a string without trailing blanks.
*
      INTEGER I

      DO 1 I=LEN(TEXT),1,-1
        IF(TEXT(I:I).NE.' ') THEN
          GO TO 2
        END IF
    1 CONTINUE
      I=1
    2 CONTINUE
      LENGTH=I

      RETURN
      END

	SUBROUTINE FERRET_DISPATCH(  command, rtn_flags, nflags,
     .					rtn_chars, nchars, nerrlines )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Execute a FERRET command
* WHILE MODE GUI is "CANCELLED" control will remain inside this routine
* If "command" contains text that command will be executed immediately
* (formatted as a c-style, null-terminated string)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program


* FERRET program history:
* initially tailored to output format and content of the Philander/Seigel 
* model from GFDL
* revision 0.0  - 4/3/86
* revision 1.0 - 11/17/86 - first "official" release
* revision 2.0 - 10/23/87 - "official" release
* revision 2.01(temporary) - 10/23/87 - smaller memory size, bug fixes,
*			2 typos in XVARIABLES_DATA, ^C added, ZT planes added
* revision 2.02 - ?????
* revision 2.10 - 5/6/88 - "final" release - /NODEBUG version
* FERRET 1.00     - 6/10/88 - rename of GFDL 2.10
* FERRET 1.10     -  8/2/88 - numerous bug fixes and enhancements
* FERRET 1.20     - 2/17/89 - numerous bug fixes and enhancements
* FERRET 1.21     - 4/19/89 - minor bug fixes
* FERRET 2.00	  - 5/??/89 - internal re-write: 4D grids and "object oriented"
*			      transformations
* FERRET 3.00     - 1/29/93 - revision 2.2-->2.3 changes became so extensive
*                             and prolonged it made sense to rename to V3.0
* FERRET 3.10     - 4/94 - official release using XGKS
* FERRET 3.11     - 5/94 - added FILE/ORDER=/FORMAT=STREAM
* FERRET 3.12     - 5/94 - restructured to be "dynamic memory" (C main routine)
*			   former MAIN became FERRET_DISPATCH routine

* FERRET_DISPATCH routine history
* as MAIN program unit:
* revision 1.1 - 4/29/87 - added FRAME and REPEAT commands
* revision 1.2 - 7/7/87  - added PLOT command for line plots
* revision 1.3 - 9/9/87  - added LOAD command
* revision 1.4 - 9/23/87  - added DEFINE command
* revision 2.0 - 10/23/87 - changed DATA stmt rev. level to 2.00
*			    and added EXTERNAL statement
* revision 2.1 - 3/25/88 - added STATISTICS command
* revision 2.2 - 4/20/88 - ADDED &UNITS AND &DSET_PARMS TO EXTERNALS 2.02-->2.10
* revision 2.3 - 6/10/88 - renamed to Program FERRET
* revision 2.4 -  8/2/88 - for FERRET 1.10 - added SHADE and SPAWN commands
* revision 2.5 - 12/12/88- eliminated XGRID_DATA to new TMAP library
* V200:  1/21/90 - added user-definable command USER
*	  5/2/90 - added externals for BOX_BOUNDS and CK_GKS_ACTIVE which are
*		   called from PLOT+ routines
* Unix/RISC port:  pulled xrevision information fully into main program
*        7/12/91 - added note not to distribute
*       10/17/91 - added external for viewport sizing
* V230:   6/8/92 - added WIRE command
* V300      1/93 - new version (includes animations, etc.)
*                  added xgt_grid_data - forced from xcalc_vars_data.F by
*                  DEC f77 3.2
*           6/93 - added QUERY command, and EXTERNAL XGUI_DATA
* These changes happened concurrent to the restructure for V320:
* V311: 5/17/94 added FILE/ORDER and FILE/FORMAT=STREAM
* V312: 6/17/94 metafile bug fix in XGKS (hangs and crashes with color plots)

* as FERRET_DISPATCH routine (formerly MAIN routine ferret.F):
* V320: 5/19/94  (also removed xrevision.cmn DATA stmts to xrevision_data.F
*		  for AIX compatibility)
* 	2/28/95 - error message buffer for GUI moved to TMAP COMMON
*		- send "synch" message to GUI if new window is created
* V400: 3/20/95 - pass "memory" to get_command for preliminary pass in which
*		  grave accent expressions are evaluated
*	6/20/95 - send "synch" for window destruction, too
* V411: 9/13/95 - Ultrix port:  CHAR(integer*1) is illegal although CHAR(byte)
*		  is allowed ... go figger
* V420: 4/23/96 - added new commands IF, ELSE, ELIF, ENDIF
* Linux Port *kob* 1/97 - Added external for XWINDOW_STATE_DATA block data
* V450: 7/7/97 - added external for XGRID_CHG_FCNS block data
* V500: 2/99 *sh* - added POLYGON command
* V530: 10/00 *sh* - added external declaration for new xez_info_data
* V553:  9/03 *acm*- Loop 2 ran to 200; change to cmnd_buff_len 
*                    (came up when implementing the -script command-line option)
* V63  *acm* 10/09 Changes for gfortran build
* V664 *kms* 8/10 Add second alternate return from XEQ_EXIT to exit the dispatch
*                 loop but just re-enter the loop if not under pfyrret
*       *acm* 3/12 removing use USER command
* V685 *acm* 11/13 Issue an ERROR not a NOTE if USER command is tried.
* V695 *acm*  6/16 New ANNOTATE command.
* V702 *sh*   2/17 dynamic memory management - no return for SET MEMORY

	include 'tmap_dims.parm'
	include 'xalt_messages.cmn_text'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'gui.parm'
	include 'command.parm'
	include 'xprog_state.cmn'
	include 'xvariables.cmn'
	include 'xgui.cmn'
	include 'xplot_state.cmn'

* EXTERNAL references to force the LINKER to look for BLOCK DATA SUBROUTINES
	EXTERNAL
     .		XALGEBRA_DATA,
     .		XCOMMAND_DATA,
     .		XCONTEXT_DATA,
     .		XCONTROL_DATA,
     .		XERRMSG_TEXT_DATA,
     .		XGFDL_MASKS_DATA,
     .		XONEDIM_DATA,
     .		XPLOT_SETUP_DATA,
     .		XPLOT_STATE_DATA,
     .		XPROG_STATE_DATA,
     .		XTEXT_INFO_DATA,
     .		XVARIABLES_DATA,
     .		XFR_GRID_DATA,
     .		XGKS_DEVICES_DATA,
     .		XGUI_DATA,
     .		XREVISION_DATA

        EXTERNAL XGT_GRID_DATA      ! 2/93

	EXTERNAL BOX_BOUNDS, CK_GKS_ACTIVE, GET_VIEW_SIZE,
     .           FERRET_PLOT_COMPLETE

* kob 1/97
	EXTERNAL XWINDOW_STATE_DATA
* sh 7/97
	EXTERNAL XGRID_CHG_FCNS_DATA,
     .		 XEZ_INFO_DATA

* temporarily we simply declare the "memory" array right here
* calling argument declarations
	INTEGER nflags, nchars, rtn_flags(nflags), nerrlines
#ifdef NEED_BYTE
        BYTE       command(*), rtn_chars(nchars)
#else
#   ifdef ultrix
        BYTE       command(*), rtn_chars(nchars)	! 9/95 Ultrix, only
#   else
        INTEGER*1  command(*), rtn_chars(nchars)
#   endif
#endif

* local variable declarations:
	INTEGER	TM_LENSTR1,
     .		cmnd_stack_level, reconfig, status, i, gui_action,
     .		insert_pt

* local parameter declarations
	INTEGER		slash_msg_continue
	PARAMETER     (	slash_msg_continue	  = 1)

* transfer the c-style string into a FORTRAN string
	cmnd_buff = ' '
c	DO 2 i = 1, 200
	DO 2 i = 1, cmnd_buff_len
	   IF ( command(i) .EQ. 0 ) GOTO 5
 2	cmnd_buff(i:i) = CHAR( command(i) )

 5	CALL GET_FER_COMMAND(  cmnd_buff, status, *300 )

	GOTO (	 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     .		110,120,130,140,150,160,170,180,190,200,
     .          210,220,230,240,250,260,270,280 ) cmnd_num

 10	CALL XEQ_SET
	GOTO 300
 20	CALL XEQ_SHOW
	GOTO 300
 30	CALL XEQ_CANCEL
	GOTO 300
 40	CALL XEQ_CONTOUR	! after rev 1.00 1/5/87
	GOTO 300
 50	CALL XEQ_LIST
	GOTO 300
 60	CALL XEQ_PLOT
	GOTO 300
 70	CALL XEQ_GO
	GOTO 300
 80	CALL XEQ_HELP
	GOTO 300
 90	CALL XEQ_LOAD
	GOTO 300
 100	CALL XEQ_DEFINE
	GOTO 300
 110	CALL XEQ_EXIT( *500, *450 )
	GOTO 300			! command file xit or error
 120	CALL XEQ_MESSAGE
	GOTO 300
 130	CALL XEQ_VECTOR
	GOTO 300
 140	CALL XEQ_PPLUS
	GOTO 300
 150	CALL XEQ_FRAME
	GOTO 300
 160	CALL XEQ_REPEAT
	GOTO 300
 170	CALL XEQ_STAT
	GOTO 300
 180	CALL XEQ_SHADE
	GOTO 300
 190	CALL XEQ_SPAWN
	GOTO 300
 200	CONTINUE! CALL XEQ_USER_COMMAND
        CALL ERRMSG(ferr_syntax, status, 
     .    'USER command not available in this Ferret version ', *300)
 210	CALL XEQ_WIRE
	GOTO 300
 220	CALL XEQ_QUERY
	GOTO 300
 230	CALL XEQ_IF
	GOTO 300
 240	CALL XEQ_ELSE
	GOTO 300
 250	CALL XEQ_ELIF
	GOTO 300
 260	CALL XEQ_ENDIF
	GOTO 300
 270	CALL XEQ_POLYGON
	GOTO 300
 280	CALL XEQ_ANNOTATE
	GOTO 300

* finished a single command
 300	gui_action = factn_no_action	! default
	IF (    (cmnd_num    .EQ. cmnd_set
     .	   .AND. subcmnd_num .EQ. subcmnd_set_data)
     . .OR.     (cmnd_num    .EQ. cmnd_cancel
     .	   .AND. subcmnd_num .EQ. subcmnd_canc_data) ) THEN
* ... need to synchronize data sets with GUI
	   gui_action = factn_synch_set_data
	ELSEIF ( cmnd_num    .EQ. cmnd_message
     .	   .AND. qual_given(slash_msg_continue) .EQ. 0 ) THEN
	   gui_action = factn_pause
	ELSE
* ... need to synchronize output window creation/destruction with GUI
* ... creation may be from any (initial) plot command or from SET WINDOW
	   DO 302 i = 1, max_windows
	      IF ( wn_open(i) .NEQV. gui_window_reported(i) ) THEN
	         gui_action = factn_synch_window
	         rtn_flags(frtn_idata1)  = i
	         IF (wn_open(i)) THEN 
	            rtn_flags(frtn_idata2)  = 1   ! 1 means "creation"
	            gui_window_reported(i) = .TRUE.
	         ELSE
	            rtn_flags(frtn_idata2)  = -1  ! -1 means "destruction"
	            gui_window_reported(i) = .FALSE.
	         ENDIF
	      ENDIF	         
 302	   CONTINUE
	ENDIF

* ... prepare error buffer to pass back to calling (GUI?) program
	IF ( mode_gui .AND. gui_status .NE. ferr_ok ) THEN
	   gui_action = factn_display_error
	   insert_pt = 1
	   DO 310 i = 1, alt_nlines
	      nerrlines = i
	      CALL CSTRING_INSERT(alt_text(i), TM_LENSTR1(alt_text(i)),
     .				  rtn_chars, nchars, insert_pt )
	      IF ( insert_pt .GT. nchars ) GOTO 320
 310	   CONTINUE
	ELSE
	   nerrlines = 0
	ENDIF
 320	alt_nlines = 0
	CALL CLEANUP_LAST_CMND( cmnd_stack_level )
	IF ( .NOT.mode_gui ) THEN
           IF ( one_cmnd_mode .AND. (cmnd_stack_level .EQ. 0) ) THEN
              RETURN
           ENDIF
	   GOTO 5
	ELSEIF ( cmnd_stack_level .GT. 0 ) THEN
	   rtn_flags(frtn_control) = fctrl_in_ferret  ! command not yet finished
	   rtn_flags(frtn_status)  = gui_status
	   rtn_flags(frtn_action)  = gui_action
	   RETURN
	ELSE
	   rtn_flags(frtn_control) = fctrl_back_to_gui
	   rtn_flags(frtn_status)  = gui_status
	   rtn_flags(frtn_action)  = gui_action
	   RETURN
	ENDIF
	   
* exit the dispatch loop - if from pfyrret, to return control to python
*                          if from ferret_c, just re-enter the dispatch loop
 450    rtn_flags(frtn_control) = fctrl_in_ferret
        rtn_flags(frtn_status) = gui_status
        rtn_flags(frtn_action) = factn_no_action
        RETURN

* exit the program
 500	rtn_flags(frtn_control) = fctrl_back_to_gui
	rtn_flags(frtn_status)  = gui_status
	rtn_flags(frtn_action)  = factn_exit
	RETURN

	END

*
* Routine to set the one_cmnd_mode in FERRET_DISPATCH 
* The following only applies if gui_mode is .FALSE.
* If new_mode_int is zero, FERRET_DISPATCH will return only 
*     on memory resizes and exit (original behavior)
* If new_mode_int is non-zero, FERRET_DISPATCH will return 
*     after each submitted command is complete
*
        SUBROUTINE SET_ONE_CMND_MODE(new_mode_int)

	include 'tmap_dims.parm'
        INCLUDE 'xprog_state.cmn'

        INTEGER new_mode_int

        one_cmnd_mode = (new_mode_int .NE. 0)
        RETURN

        END

      SUBROUTINE RR_flux_tz_init(id)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id
      CALL ef_set_desc             (id,
     .'-d(wT)/dz advective momentum: flux-form (oC/s);MOM2 T Grid')
      CALL ef_set_num_args         (id, 3)
      CALL ef_set_axis_inheritance (id, IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok     (id, NO, NO, NO, NO)

      CALL ef_set_arg_name         (id, ARG1, 'U')
      CALL ef_set_arg_desc         (id, ARG1,
     . 'Zonal velocity, on the MOM2 U Grid. ')
      CALL ef_set_arg_unit         (id, ARG1, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG1, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG1, YES, YES, YES, YES)
      CALL ef_set_axis_extend      (id, ARG1, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG1, Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG1, Z_AXIS,0,+1)

      CALL ef_set_arg_name         (id, ARG2, 'W')
      CALL ef_set_arg_desc         (id, ARG2,
     . 'Vertical velocity, at T cell bottom on the MOM2 Grid. ')
      CALL ef_set_arg_unit         (id, ARG2, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG2, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2, NO, NO, NO,YES)
      CALL ef_set_axis_extend      (id, ARG2, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG2, Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG2, Z_AXIS,0,+1)

      CALL ef_set_arg_name         (id, ARG3, 'TEMP')
      CALL ef_set_arg_desc         (id, ARG3,
     . 'Potential temperature on the MOM2 T Grid. ')
      CALL ef_set_arg_unit         (id, ARG3, 'deg-C')
      CALL ef_set_arg_type         (id, ARG3, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG3, NO, NO,YES,YES)
      CALL ef_set_axis_extend      (id, ARG3, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG3, Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG3, Z_AXIS,0,+1)
      END


      SUBROUTINE RR_flux_tz_compute(id, arg_1, arg_2, arg_3, result)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'
      INTEGER        id
      REAL           arg_1 (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .                      mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL           arg_2 (mem2lox:mem2hix, mem2loy:mem2hiy, 
     .                      mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL           arg_3 (mem3lox:mem3hix, mem3loy:mem3hiy, 
     .                      mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL           result (memreslox:memreshix,memresloy:memreshiy,
     .                       memresloz:memreshiz,memreslot:memreshit)
      INTEGER        res_lo_ss (4)
      INTEGER        res_hi_ss (4)
      INTEGER        res_incr  (4)
      INTEGER        arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER        arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER        arg_incr  (4,EF_MAX_ARGS)
      INTEGER        i,  j,  k,  l
      INTEGER        i2, j2, k2, l2
      INTEGER        i3, j3, k3, l3
      REAL*8         zW(1024)
      INTEGER        iZ
      REAL           adv_fb         
      INCLUDE 'rr_parameters.h'
      adv_fb(i2,j2,k2,l2,i3,j3,k3,l3)=arg_2(i2,j2,k2,l2)
     .                  *(arg_3(i3,j3,k3,l3)+arg_3(i3,j3,k3+1,l3))
      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_coordinates    (id, ARG2, Z_AXIS, 
     .                            arg_lo_ss(Z_AXIS,ARG2),
     .                            arg_hi_ss(Z_AXIS,ARG2), zW)
      l2 = arg_lo_ss(T_AXIS,ARG2) 
      l3 = arg_lo_ss(T_AXIS,ARG3) 
      DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         j2 = arg_lo_ss(Y_AXIS,ARG2) + 1
         j3 = arg_lo_ss(Y_AXIS,ARG3) + 1
         DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            i2 = arg_lo_ss(X_AXIS,ARG2) + 1
            i3 = arg_lo_ss(X_AXIS,ARG3) + 1
            DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
 	       iZ = 1
               k2 = arg_lo_ss(Z_AXIS,ARG2)
               k3 = arg_lo_ss(Z_AXIS,ARG3)
               DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
                 IF (iZ .EQ. 1) THEN
                     result(i,j,k,l) =  
     .                           adv_fb(i2,j2,k2,l2,i3,j3,k3,l3)
     .                             /2./zW(iZ)/Meters_to_cm 
                 ELSE
                       result(i,j,k,l) = - ( 
     .      	                adv_fb(i2,j2,k2-1,l2,i3,j3,k3-1,l3)
     .                       - adv_fb(i2,j2,k2,  l2,i3,j3,k3,  l3))
     .                         / 2. /(zW(iZ-1)-zW(iZ))/Meters_to_cm 
                  ENDIF
                  iZ = iZ + 1
                  k2 = k2 + arg_incr(Z_AXIS,ARG2)
                  k3 = k3 + arg_incr(Z_AXIS,ARG3)
               ENDDO
               i2 = i2 + arg_incr(X_AXIS,ARG2)
               i3 = i3 + arg_incr(X_AXIS,ARG3)
            ENDDO
            j2 = j2 + arg_incr(Y_AXIS,ARG2)
            j3 = j3 + arg_incr(Y_AXIS,ARG3)
         ENDDO
         l2 = l2 + arg_incr(T_AXIS,ARG2)
         l3 = l3 + arg_incr(T_AXIS,ARG3)
      ENDDO               
      END

	SUBROUTINE XEQ_USER_COMMAND( memory )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute the USER_COMMAND command
* this is a template routine that can be modified to include any code of
* a user's choice, thereby customizing the FERRET program

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  1/21/90
* V301:  11/93 - bug fix:  was passing element 2 of var 2 element 3 of 3, etc.
*			: command string decoded by user routines
*         1/94 - need to pass at least 5 arguments for COMMAND=SAMPLE
* V312: 5/94 - array "memory" as a calling argument
*	(and passed to USER_SUB - fixed 6/1/94)
* V530: *sh* 9/00 - added initial data type support in get_cmnd_data 

#ifdef unix
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
#else
	INCLUDE	'FERRET_CMN:FERRET.PARM'
	INCLUDE 'FERRET_CMN:ERRMSG.PARM'
	INCLUDE 'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE 'FERRET_CMN:XPROG_STATE.CMN'
#endif

* calling argument declarations:
	REAL	memory( mem_blk_size, max_mem_blks )

* local variable declarations:
	INTEGER	ivar, mr_list(6), cx_list(6), status
	
* get the requested data somehow - possibly several grids of data
	CALL GET_CMND_DATA ( memory, cx_last, ptype_float, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* set up dummies if fewer than 4 components
	DO 100 ivar = 1, num_uvars_in_cmnd
	  mr_list(ivar) = is_mr(ivar)
	  cx_list(ivar) = is_cx(ivar)
 100	CONTINUE
	DO 110 ivar = num_uvars_in_cmnd+1, 6    ! 4->6 2/25 bug found on SUN
	  mr_list(ivar) = dummy_mr
	  cx_list(ivar) = cx_buff
 110	CONTINUE

* compute and display the results
	CALL NON_ARRAY_SUBSC( mr_list, num_uvars_in_cmnd )

* pass control to the user's routine
	CALL USER_SUB(    memory,
     .			  memory(1, mr_blk1(mr_list(1))), 
     .			  memory(1, mr_blk1(mr_list(2))), 
     .			  memory(1, mr_blk1(mr_list(3))), 
     .			  memory(1, mr_blk1(mr_list(4))), 
     .			  memory(1, mr_blk1(mr_list(5))), 
     .			  memory(1, mr_blk1(mr_list(6))), 
     .			  mr_list, cx_list, num_uvars_in_cmnd,
     .			  ttout_lun, status )
	RETURN

* error exit(s)
 5000	RETURN
	END

	SUBROUTINE INIT_T_AGGREGATE_DSET(mem_filename_list,
     .			nagfiles, have_expr,
     .			dset_name, dset_path, dset_title,
     .			dset_num, tline, tmatch, toverlap, status)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE.
*
*
* Assemble the needed arguments and call DEFINE_T_AGG_MC_DSET
* The time axis, if not provided, is generated from the time axis metadata
* read from each file to be aggregated.

* the incoming command syntax may be
*    DEFINE DATA/AGGREGATE/<dim>  agname = file1, file2, file3, ...
*  or
*    DEFINE DATA/AGGREGATE/<dim>  agname = <string_expression>


* admittedly, the hierarchy of calling names is not self-evident.  They are:
* top level: INIT_T_AGGREGATE_DSET
*            ==> DEFINE_T_AGG_MC_DSET
*                ==> BUILD_T_AGG_AXIS
*                ==> INIT_T_AGG_MC_DSET

* V695+ *sh* 11/15 new routine
* V698 *sh* 1/16  pass explicit path name (for "USE file.agg" compatibility)
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.

* arguments:
*	mem_filename_list - if have_expr, the variable of names (input)
*	nagfiles	- number of files in the aggregation (input)
*       have_expr	- flag if filenames were listed or in an expr (input)
*	dset_name	- dataset name to assign to the aggregation (input)
*	dset_path	- path name to assign to the aggregation (input)
*	dset_title	- dataset title (input)
*       tline           - user-provided time axis to use (input, can be unspecified)
*       tmatch          - method of matching times to tline (input, can be empty);
*                         eg, '@ASN', '@BIN', '@XACT', '@XACT:0.001'
*       toverlap        - allowed number of overlapping time values per datset (input);
*                         negative (such as unspecified_int4) == unlimited
*	dset_num	- number assigned to this data set (output)
*	status		- return status (output)
*

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
        include 'errmsg.parm'
	include 'xprog_state.cmn'
	include 'xvariables.cmn'   ! for is_mr

* Argument definitions
	LOGICAL		have_expr
	INTEGER		nagfiles, dset_num, tline, toverlap, status
	CHARACTER*(*)	dset_name, dset_path, dset_title, tmatch
	REAL		mem_filename_list(*)

* Internal declarations
	INTEGER	iset, slen, max_str_len
	CHARACTER*512 GET_STRING_ELEMENT_1D_X
        CHARACTER*512 memb_filename(nagfiles)

* initialize
	status = ferr_ok
	max_str_len = 512

* set up array of filenames
	IF (have_expr) THEN
*  ... filenames passed through a string variable
	  DO iset = 1, nagfiles
            memb_filename(iset) = GET_STRING_ELEMENT_1D_X(nagfiles,
     .                   mem_filename_list, iset, max_str_len, slen)
	  ENDDO
	ELSE
*  ... filenames given by user on command line
	  DO iset = 1, nagfiles
	    memb_filename(iset) = cmnd_buff(item_start(iset):item_end(iset))
	  ENDDO
	ENDIF

* now call the "real" routine
        CALL DEFINE_T_AGG_MC_DSET(dset_name, dset_path, dset_title,
     .            nagfiles, memb_filename, tline, tmatch, toverlap, 
     .            dset_num, status)

* done
	RETURN
	END

	SUBROUTINE WARN_OCCASIONALLY ( string, ncycle, cookie )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* display a warning message to the operator, but do not display it again
* until it has been requested at least ncycle times.
* each message must be associated with a unique, arbitrary cookie.

* V690 12/13 *sh*

!#ifdef NO_PASSED_CONCAT
!	include 'xrisc.cmn'
!#endif
	include 'tmap_dims.parm'
	include 'ferret.parm'
!        include 'gui.parm'
	include 'xprog_state.cmn'
!        include 'xgui.cmn'

* calling argument declarations:
	INTEGER		ncycle, cookie
	CHARACTER*(*)	string

* internal variable declarations:
	INTEGER i

* private COMMON storage used only by this routine
	INTEGER	pn_uniq_msgs
	PARAMETER (pn_uniq_msgs = 10)
	INTEGER	nused, counter(pn_uniq_msgs), cookies(pn_uniq_msgs)
	COMMON / XWARN_OCCASIONALLY / counter
	DATA nused / 0 /
	DATA counter /	pn_uniq_msgs*0 /

* have we seen this cookie before?
	DO 100 i = 1, nused
	   IF (cookies(i) .EQ. cookie) THEN
* ... a repeat request for this message
	      IF (MOD(counter(i),ncycle) .EQ. 0) THEN
	         GOTO 500
	      ELSE
	         counter(i) = counter(i) + 1
	      ENDIF
	      RETURN
	   ENDIF
 100	CONTINUE

* this is a first time request -- cllaim a spot
	nused = nused + 1
	IF (nused .GT. pn_uniq_msgs) THEN
	   CALL WARN('crptn: warn_occasionally ovfl')	
	   RETURN
	ENDIF
	cookies(nused) = cookie

* issue the warning and start the count-up cycle
 500	CALL WARN(string)
	CALL WRITE_MULTI(err_lun,
     .	   "           (This note will be repeated occasionally.)")
	counter(i) = 1
	RETURN
	END

	SUBROUTINE OPEN_SHOW_FILE ( lun, sho_file,  
     .                             clobber, append, status)


	
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* OPEN the output file for SHOW xx/OUTFILE=  or MESSAGE/OUTFILE= 

* programmer - Ansley Manke TMAP
* 3/2010
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include	'tmap_dims.parm'
	include	'ferret.parm'
	include	'slash.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'

* Argument declarations:
	LOGICAL clobber, append
	INTEGER sho_file, lun, status

* local parameter declarations:
	LOGICAL fexist
	INTEGER TM_LENSTR1, slen, flen
	CHARACTER filename*2048, raw_name*2048, fformatted*12,
     .            fstatus*8, faccess*12, fposition*12

* set up the output device

	fformatted = 'FORMATTED'
* ... get full file name - from SHOW/OUTFILE= or from SET SHOW/OUTFILE
	raw_name = ' '

* ... sho_file is from qual_given(slash_show_axis_file) or
*     qual_given(slash_show_data_file) etc.

* preserve case of filename

	CALL EQUAL_STR_LC(
     .			cmnd_buff(qual_start(sho_file):qual_end(sho_file)),
     .                  raw_name, status )

	IF ( status .NE. ferr_ok ) GOTO 5000
	IF ( raw_name .EQ. ' ') THEN

* ... use default from SET SHOW/outfile= command
	   raw_name = show_file
	   IF ( raw_name .EQ. ' ') GOTO 5100
	ENDIF

	slen = TM_LENSTR1(raw_name)
	IF (slen .GT. 256 ) GOTO 5200
	INQUIRE( FILE = raw_name, NAME = filename, EXIST = fexist )

	flen = TM_LENSTR1( filename )

	IF ( fexist ) THEN    
	   IF ( append ) THEN

#ifdef NO_ACCESS_APPEND
	      faccess = 'SEQUENTIAL'
#else
	      faccess = 'APPEND'
	      fposition = 'APPEND'
#endif
	      fstatus = 'OLD'
	   ELSEIF ( clobber ) THEN
	      faccess = 'SEQUENTIAL'
	      fstatus = 'REPLACE'
#ifdef F90_OPEN_FILE_CLOBBER
	      fposition = 'ASIS'
#endif
	   ELSE
	      GOTO 5050	 !attempt to clobber a file
	   ENDIF
	ELSE
	   faccess = 'SEQUENTIAL'
	   fstatus = 'NEW'
	   fposition = 'asis'
	ENDIF
* ... open or create it

	OPEN( UNIT	= default_list_lun,
     .	      FILE	= raw_name,
     .	      FORM	= fformatted,
#ifdef F90_OPEN_FILE_APPEND
     .	      POSITION    = fposition,
#else
     .	      ACCESS	= faccess,
#endif
     .	      STATUS	= fstatus,
     .	      ERR		= 5010 )

	lun = default_list_lun

* error exit
 5000	RETURN
 
 5010	CALL ERRMSG( ferr_erreq,status,filename(:flen),*5000 )
 5100	CALL ERRMSG( ferr_invalid_command, status,
     .		'SHOW /FILE= what name?', *5000 )
 5050	CALL ERRMSG( ferr_invalid_command, status,
     .			'/CLOBBER not specified and file exists: '
     .			//raw_name, *5000 )
 5200	CALL ERRMSG( ferr_prog_limit, status,
     .  'Cannot write to file w/ name longer than 256 characters: '//pCR//
     .  'Limitation of Fortran INQUIRE and OPEN calls '	
     .			, *5000 )

	END

      SUBROUTINE TM_GET_CALENDAR_ATTRIBUTES (cal_id, nmonths, 
     .                 ndays, yeardays, mon_names, d_in_mon, 
     .                 d_before_mon, mon_by_d)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
C     Loads data for the calendar given  into common.  These values are
C     accessed by the date/time functions for all calendar-using plots.
C     Returns status = merr_ok success, merr_varlim failure
C
C     NOTE the current calendar name and id are NOT changed: for that see
C     tm_set_current_calendar().  This permits Ferret queries of a particular
C     calendar without losing knowledge of the calendar in use.
C
C  12/14/00  ACM  (from Jerry's tm_load_calendar)
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files, add disclaimer
* 5/2020 Issue 1906: treat Proleptic-Gregorian identically to Gregorian

C     0.00000000000000000000000000000000000000000000000000000000000000001

      include 'calendar.decl'
      include 'calendar.cmn'
      include 'tmap_errors.parm'
      include 'tmap_dims.parm'
      include 'xtm_grid.cmn_text'

* Argument declarations
      INTEGER cal_id
      INTEGER nmonths, ndays, d_before_mon(*), mon_by_d(*), d_in_mon(*)
      REAL    yeardays
      CHARACTER*3 mon_names(*)

* Local variable declarations
      INTEGER status, i, j, k, nline
      CHARACTER*20  new_t0
 
C     OK CALENDAR ID?
      if (cal_id .lt. 1 .or. 
     .    cal_id .gt. max_calendars) then 
         status = merr_varlim
         goto 1000
      end if

C     SET NMONTHS AND NDAYS IN CALENDAR

      nmonths = cals_num_months(cal_id)

      ndays = cals_num_days(cal_id)

      yeardays = cals_yeardays(cal_id)

C     SET MONTH NAMES

      do 110 i = 1, nmonths
         mon_names(i) = cals_month_names(i,cal_id)
 110  end do

C     SET D_IN_MON

      do 120 i = 1, nmonths
         d_in_mon(i) = cals_days_in_month(i,cal_id)
 120  end do

C     SET D_BEFORE_MON

      d_before_mon(1) = 0
      do 130 i = 2, nmonths
         d_before_mon(i) = d_before_mon(i-1) 
     .                            + d_in_mon(i-1)
 130  end do

C     SET MON_BY_D
      k = 0
      do 150 j = 1, nmonths
         do 140 i = 1, d_in_mon(j)
            k = k + 1
            mon_by_d(k) = j
 140     end do
 150  end do
      if (cal_id .EQ. julian) mon_by_d(k+1) = mon_by_d(k)
 
      status = merr_ok

 1000 return

      end

	SUBROUTINE XEQ_EXIT( * , * )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute the EXIT command
* if program is not under interactive control the /COMMAND_FILE qualifier is
* required

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 4/3/86
* revision 1.0 - 4/30/87 - EXIT in middle of command file will work
* revision 1.1 - 4/23/87 - flag arguments given as errors
* V312: 5/94 - use abnormal return for final program exit
* V314: 8/24/94 *kob* IBM port: slash_command_file should be declared as 
*				logical
* V510: *sh* 12/99 - close TMAP data sets when exiting
* V533: *kob* 8/01 - add checks for new EXIT qualifiers:
*	                 exit/loop
*			 exit/script
*                        exit/prompt
*			 exit/program
*                     With these new qualifiers, the routine has been
*                     reworked as well.
* V540: *sh* 11/01 - bug fix to logic in V5.33 change:
*	  "quit" in a command file was ignored
* V542: *kob* 11/02 - bug fix - check to make sure an exit w/ no qualifiers
*                               wasn't being called from a command file before
*                               completely exiting out of Ferret
* V581: *acm*  5/05 - fix bug 1233: exit/script needs to check whether there is
*                     an IF or REPEAT in the command stack
* V581: *acm*  5/05 - add EXIT/CYCLE to skip remaining commands in current 
*                     repetition of the loop
* V602: *acm*  3/07 - Fix bug 1304. If a script is executed with a loop, and
*                     exit/script is called, then exit just out of the script,
*                     not all the way back up out of the loop.
* V6.11 *acm*  4/08 - Fis bug 1566; EXIT/SCRIPT and IF blocks.
* V664  *kms*  8/10 - Add EXIT/TOPYTHON and second alternate return to exit the 
*                     ferret_dispatch loop but just re-enter the loop if not under pfyrret
* V685+ 12/13    - *acm*  bounds checking; dont refer to cs_cmnd_num(csp) if csp = 0
* V694 *acm*  12/14   Fix ticket 2221. When in -script mode exit/prompt should just exit
*                     all the way out of Ferret.

        include 'tmap_dims.parm'
	include 'command.parm'
	include 'errmsg.parm'
	include 'slash.parm'
	include 'xcontrol.cmn'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'

	INTEGER status
	INTEGER i, pop, ifloop
	LOGICAL GO_FILE_INPUT

* make sure no arguments were given
	IF ( num_args .GT. 0 ) CALL ERRMSG( ferr_invalid_subcmnd, 
     .			status, cmnd_buff(arg_start(1):len_cmnd), *5000 )

* When in -script mode exit-to-prompt should just exit. (ticket 2221).

	IF ( qual_given(slash_exit_prompt) .GT. 0) THEN
	   IF (its_script) THEN
	      qual_given(slash_exit_prompt) = 0
  	      qual_given(slash_exit_program) = 1
	   ENDIF
	ENDIF

	IF (qual_given(slash_exit_cycle) .GT. 0) THEN
* Skip to end of current repeat loop
	   pop=0
	   DO 100 i = csp,1,-1
	      IF ( cs_cmnd_num(i) .EQ. cmnd_repeat) GOTO 400
	      pop = pop + 1 
 100	   CONTINUE
	   RETURN        ! not in repeat loop, no need to move down stack

	ELSE IF (qual_given(slash_exit_loop) .GT. 0) THEN
* Exit from current repeat loop
	   pop=1
	   DO 200 i = csp,1,-1
	      IF ( cs_cmnd_num(i) .EQ. cmnd_repeat) GOTO 400
	      pop = pop + 1 
 200	   CONTINUE
	   RETURN        ! not in repeat loop, no need to move down stack
	ELSE IF (qual_given(slash_exit_script) .GT. 0) THEN

* Exit from current script.  Need to do check to make sure this
* wasn't executed from waiting Ferret prompt, ie not in a script
* Fix bug 1304 here; count pop up to the *GO current script*
* Fix bug 1566 here; multi-linen IFs are not listed in cs_cmnd_num()
* instead we need to check if_cs

	   IF (csp .GT. 0) THEN
              pop = 1
              DO 300 i = csp, 1, -1
                 IF (cs_cmnd_num(i) .EQ. cmnd_repeat) pop = pop + 1
                 IF (cs_cmnd_num(i) .EQ. cmnd_if) pop = pop + 1
                 
! Pop out of possibly nested if in current script (fixes bug 1566)
                 IF (ifstk .GT. 0) THEN 
                 IF (if_cs(ifstk) .EQ. i) THEN 
                    DO WHILE (if_cs(ifstk) .EQ. i .AND. ifstk.GT.1)
                       ifstk = ifstk - 1
                    ENDDO
!!!                    ifstk = ifstk + 1  ! ifstk will be popped once by POP_CS 
                 ENDIF
                 ENDIF

                 IF (cs_cmnd_num(i) .EQ. cmnd_semicolon) pop = pop + 1
                 IF (cs_cmnd_num(i) .EQ. cmnd_go) GOTO 400  ! Reached the next GO level(fixes bug 1566)
 300	      CONTINUE
              GOTO 400
	   ENDIF
        ELSE IF ( (qual_given(slash_exit_prompt) .GT. 0) .OR.
     .            (qual_given(slash_exit_topython) .GT. 0) ) THEN
* Exit to Ferret prompt or out of the ferret_dispatch loop
	   pop = csp
	   GOTO 400
	ELSE IF (qual_given(slash_exit_topython) .GT. 0) THEN
* Exit to the dispatch loop
	   pop = csp
	   GOTO 400
	ELSE IF (qual_given(slash_exit_program) .GT. 0    .OR.
     .  	  (qual_given(slash_exit_command) .GT. 0) .OR. 
     .            .NOT. GO_FILE_INPUT()) THEN
* Exit program completely 
* *kob* new call to GO_FILE_INPUT to make sure were not in command file
	   CALL CLSPPL		! close PLOT5
           pplus_started = .FALSE.
	   CALL TM_EXIT		! close TMAP data sets
	   RETURN 1
!	   IF ( frame_on ) CALL MOVIE_CLOSE( frame_lun, status )! end movie
	ELSE
* no qualifier supplied on a "quit" in a command file: Exit current script
	   CALL POP_CS
	   IF (csp .EQ. 0) RETURN
	   IF (cs_cmnd_num(csp+1) .EQ. cmnd_if .AND. cs_cmnd_num(csp) .EQ. cmnd_go) CALL POP_CS 
	   RETURN
	ENDIF

* Here is where we'll pop the stack once for each level we need to move down
 400	IF (pop .GT. 0) then
	   DO 500 i = 1,pop
	      CALL POP_CS
 500	   CONTINUE
	ENDIF

* Use the second alternate return to exit out of the ferret_dispatch loop
* but just re-enter the loop if not under pfyrret
        IF ( qual_given(slash_exit_topython) .GT. 0 ) RETURN 2

* error exit
 5000	RETURN

	END

	SUBROUTINE ALG_ID( text, natom, at_start, at_end,
     .			   at_type, at_id, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* identify the atoms from the text

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V200: 12/21/89
* Unix/RISC port - 1/91 - cannot "//" with CHAR*(*) variables
* V450: 12/2/96 - check that functions are followed by left parens.
*		  Else, they are variable names.
*		- Also, id grid-changing fcns as category alg_grid_chg_fcn
*		- and check for negative constants 
*		==> Note that this may modify natom
* V495: 7/7/98 - allow variable names in single quotes - bypass name check
*     : 9/30/98 - NAG F90 (linux) received error on above change.  
*                 need to put single  tick between double quotes  *kob*
* V500: 12/98 - allow "{1,3,5}" notation
*	 1/99 - allow strings in double quotes (as args to function)
* V553:1/04   - check variable to see if its a counter_var.
* V554 1/04 *acm* - add counter variables for named REPEAT/RANGE control
*      6/04 ywei - change MATCH_NAME function
* V600 8/05 *acm* - Add variable type attrib_val for definitions of the form
*                   varname.attname
* V600  4/06 *acm* - additional declarations found by Solaris compiler
* V600 *acm* 6/06 - fix declarations, found by solaris compiler
* V671 7/11  *acm* Ticket 1868 IFV - masking expressions with ifValid, treating 
*		   zero as valid. 
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V685+ 12/13 *acm*  bounds checking: tm_digit needs more care in the argument sent in.
* V693+ 12/14 *sh* allow _QD_ and _SQ_ for quotation alternatives 
* V720: 4/17 *acm* Add direction-changing functions as a subset of grid-changing ones

        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'rpn.parm'
	include 'xalgebra.cmn'
	include 'xrisc.cmn'
        include 'xvariables.cmn'

* calling argument declarations:
	INTEGER		natom, at_start(maxatoms), at_end(maxatoms),
     .			at_type(maxatoms), at_id(maxatoms), status
	CHARACTER*(*)	text

* internal variable declarations:
	LOGICAL		TM_DIGIT, TM_LEGAL_NAME, ITSA_DIRC_FCN, 
     .			is_digit, single_quoted
	INTEGER		STR_MATCH, GCF_FIND_FCN, TM_LENSTR1,
     .			imatch, i, i2, j, brac_pos, aend,
     .			num_indices, dot, new_nat, first, second, slen
        CHARACTER*512   varname
        
        new_nat = 0

	DO 100 i = 1, natom

* operator ?
	   imatch = STR_MATCH (	text(at_start(i):at_end(i)),
     .				alg_op, num_operators )
	   IF ( imatch .NE. atom_not_found ) THEN
	      at_type(i) = alg_operator
	      at_id(i)   = imatch
	      GOTO 100
	   ENDIF

* punctuation?
	   imatch = STR_MATCH (	text(at_start(i):at_end(i)),
     .				alg_punct, num_punctuations )
	   IF ( imatch .NE. atom_not_found ) THEN
	      at_type(i) = alg_punctuation
	      at_id(i)   = imatch
	      GOTO 100
	   ENDIF

* function ?
	   imatch = STR_MATCH (	text(at_start(i):at_end(i)),
     .				alg_fcn, num_functions )
	   IF ( imatch .NE. atom_not_found ) THEN
	      at_type(i) = alg_function
	      at_id(i)   = imatch
	      GOTO 100
	   ENDIF

* grid-changing function ?
	   imatch = GCF_FIND_FCN( text(at_start(i):at_end(i)) )
	   IF ( imatch .NE. unspecified_int4 ) THEN
	      at_type(i) = alg_grid_chg_fcn
	      IF (ITSA_DIRC_FCN(imatch) ) at_type(i) = alg_dir_chg_fcn
	      at_id(i)   = imatch
	      GOTO 100
	   ENDIF

* logic structure ?
	   imatch = STR_MATCH (	text(at_start(i):at_end(i)),
     .				alg_struct, num_log_structs )
	   IF ( imatch .NE. atom_not_found ) THEN
	      at_type(i) = alg_log_struct
	      at_id(i)   = imatch
	      GOTO 100
	   ENDIF

* logic structure with IFV?
	   imatch = STR_MATCH (	text(at_start(i):at_end(i)),
     .				alg_vstruct, num_log_structs )
	   IF ( imatch .NE. atom_not_found ) THEN
	      at_type(i) = alg_log_vstruct
	      at_id(i)   = imatch
	      GOTO 100
	   ENDIF

* constant ?
          is_digit = TM_DIGIT( text(at_start(i):at_start(i)) )
	  IF ( is_digit ) THEN
	      IF (at_end(i).GT.at_start(i) .AND. text(at_start(i):at_start(i)).EQ.'.') THEN
	         IF (text(at_start(i)+1:at_start(i)+1) .EQ. '.') is_digit = .FALSE.
	      ENDIF
	      IF (is_digit) THEN
 	         at_type(i) = alg_constant
	         at_id(i)   = unspecified_int4
 
	         GOTO 100
	      ENDIF
	   ENDIF


* pseudo-variable ?
* (look for "[" as name end first)
	   brac_pos = INDEX( text(at_start(i):at_end(i)), '[' )
	   IF ( brac_pos .GT. 0 ) THEN
	      aend = at_start(i) + brac_pos - 2
	   ELSE
	      aend = at_end(i)
	   ENDIF
*	   imatch = STR_MATCH (	text(at_start(i):aend),
*     .				alg_pvar, num_pseudo_vars )
*	   IF ( imatch .NE. atom_not_found ) THEN
*	      at_type(i) = alg_pseudo_var
*	      at_id(i)   = imatch
*	      GOTO 100
*	   ENDIF

           CALL string_array_find_caseblind(alg_pvar_head,
     .                         text(at_start(i):aend),
     .                         LEN(text(at_start(i):aend)),
     .                         string_array_result(1),
     .                         max_uvar,
     .                         num_indices)
          IF(num_indices.GT.0) THEN
	      at_type(i) = alg_pseudo_var
	      at_id(i)   = string_array_result(1)
              GOTO 100              
          ENDIF

* constant array of the form "{1,3,5}" ?
	  IF ( text(at_start(i):at_start(i)).EQ."{"
     .	 .AND. text(at_end  (i):at_end  (i)).EQ."}" ) THEN
	      at_type(i) = alg_const_var
	      at_id(i)   = unspecified_int4
	      GOTO 100
	   ENDIF

* string in double quotes? (1/99)
	  IF ( text(at_start(i):at_start(i)).EQ.'"'
     .	 .AND. text(at_end  (i):at_end  (i)).EQ.'"' ) THEN
	      at_type(i) = alg_string
	      at_id(i)   = unspecified_int4
	      GOTO 100
	   ENDIF

* string in _DQ_ style double quotes? 
	  IF (at_end(i)-at_start(i)+1 .GE. 8) THEN
	     IF ( text(at_start(i):at_start(i)+3).EQ.p_DQ_quote
     .	    .AND. text(at_end(i)-3:at_end  (i)  ).EQ.p_DQ_quote ) THEN
	         at_type(i) = alg_string
!*   ... trim string to have only a simple enclosing "_"
!	         at_start(i) = at_start(i) + 3  
!	         at_end  (i) = at_end  (i) - 3
	         at_id(i)   = unspecified_int4
	         GOTO 100
	      ENDIF
	   ENDIF

* attribute value variable.attname (will check later whether the
* variable is in a netCDF dataset and whether the attribute exists)

c           IF (INDEX(text(at_start(i):at_end(i)), '.') .GT. 0 
c     .          .AND. INDEX(text(at_start(i):at_end(i)), '.') .LT.
c     .          at_end(i) - at_start(i)+1 ) THEN

           IF (INDEX(text(at_start(i):at_end(i)), '.') .GT. 0 ) THEN
              
* Is the dot a decimal point within an expression, as in LIST a[y=0.5:9.5]
* or LIST a[gx=sst[d=1],y=1.5]. Look for opening bracket before the dot and 
* closing bracket after the dot. Use varname as a temporary buffer to avoid
* confusion between indices within the whole buffer -text- and indices within 
* the atom we are now looking at.

              varname = text(at_start(i):at_end(i))
              slen = TM_LENSTR1(varname)
              dot = INDEX(varname, '.')

              IF ((INDEX(varname(1:dot-1),'[') .GT. 0) .AND. 
     .            (INDEX(varname(dot+1:slen),']') .GT. 0) ) GOTO 99

* Is this just a number in parentheses?
              IF ( (INDEX(varname(1:1),'(') .GT. 0)  .AND. 
     .             TM_DIGIT(varname(2:slen)) ) GOTO 99

              IF ( (INDEX(varname(1:1),'(') .GT. 0)   .AND. 
     .             (INDEX(varname(slen:slen),')') .GT. 0) .AND. 
     .             TM_DIGIT(varname(2:slen-1)) ) GOTO 99

* is the name in quotations? If so then it may contain a dot and not
* be varname.attname. See if its all within quotes, if so this is a 
* variable name containg a dot.

              first = INDEX(varname, "'" )
              second = 0
              IF (slen .GT. 1) second = INDEX(varname(2:at_end(i)), "'" )
              
              IF (first .GT. 0 .AND. second .GT. 0 .AND. 
     .            dot .GT. first .AND. dot .LT. second) GOTO 99

* identical logic to the previous check, but now looking for _SQ_-enclosed name
              first = INDEX(varname, p_SQ_quote)
              second = 0
              IF (slen .GT. 4) second = INDEX(varname(5:at_end(i)), p_SQ_quote )
              
              IF (first .GT. 0 .AND. second .GT. 0 .AND. 
     .            dot .GT. first .AND. dot .LT. second) GOTO 99

* Otherwise this is a varname.attname  
              at_type(i) = alg_attrib_val
	      at_id(i)   = unspecified_int4

* Is the end of varname a parentheses? Then is this part of (axisname).attname
              IF ( INDEX(text(at_start(i):at_end(i)), ")" ) .GT. 0) THEN
                 j = i - 1
                 new_nat = 0
                 DO WHILE (j .GT. 0 .AND. new_nat .EQ. 0 ) 
                    IF (INDEX(text(at_start(j):at_end(j)), "(" ) .GT. 0) THEN
                       at_type(j) = at_type(i)
                       at_end(j) = at_end(i)
                       at_id(j) = at_id(i)
                       new_nat = j
                    ENDIF
                    j = j - 1
                 ENDDO
              ENDIF

* Is the dot at the end of varname? if so then merge the next atom with this one.

              IF ( text(at_end(i):at_end(i)) .EQ. "." ) THEN
                 new_nat = natom-1
                 at_end(i) = at_end(i+1)
                 DO 110 j = i+1, natom
                    at_start(j) = at_start(j-1)
                    at_end(j) = at_end(j-1)
  110            CONTINUE
              ENDIF

              GOTO 100
	   ENDIF

* cant identify it - we will call it an variable for now
* check for legal name not enclosed in quotation marks or _SQ_
 99	   single_quoted = text(at_start(i):at_start(i)) .EQ. "'"
	   IF (.NOT.single_quoted .AND. at_end(i)-at_start(i).GE.7)
     .         single_quoted = text(at_start(i):at_start(i)+3) .EQ. p_SQ_quote
	   IF (.NOT.single_quoted) THEN
	     IF ( .NOT.TM_LEGAL_NAME(text(at_start(i):aend)) ) GOTO 5100
	   ENDIF
	   at_type(i) = alg_variable
	   at_id(i)   = unspecified_int4

 100	CONTINUE

        IF (new_nat .NE. 0) natom = new_nat

* A function name not followed by a left paren is actually a variable (12/96)
	DO 200  i = 1, natom
	   IF ( at_type(i) .EQ. alg_function
     .	   .OR. at_type(i) .EQ. alg_grid_chg_fcn ) THEN
	      IF (i .EQ. natom) THEN
	          at_type(i) = alg_variable
	          at_id(i)   = unspecified_int4
	      ELSEIF ( at_type(i+1) .NE. alg_punctuation
     .		  .OR. at_id  (i+1) .NE. left_paren ) THEN
	          at_type(i) = alg_variable
	          at_id(i)   = unspecified_int4
	      ENDIF
	   ENDIF
 200	CONTINUE

* Just see if it is in the list of counter variables.  These need to be
* treated as a constant at the start of interp_stack (in is_uvar_grid and so on)

* start by checking counter variable names
	DO 240 i = 1, natom
*           len_test = TM_LENSTR(text(at_start(i):at_end(i)))
*           DO 220 j = 1, num_counter_vars
*              len_mchars = TM_LENSTR(countervar_name(j))
*              IF ( MATCH_NAME(text(at_start(i):at_end(i)),len_test, 
*     .             countervar_name(j),len_mchars ) ) THEN
*	         at_type(i) = alg_counter_var
*	         at_id(i)   = unspecified_int4
*	      ENDIF
* 220	   CONTINUE
 	CALL string_array_find(countervar_name_head,
     .                         text(at_start(i):at_end(i)),
     .                         LEN(text(at_start(i):at_end(i))),
     .                         string_array_result(1),
     .                         max_uvar,
     .                         num_indices)
        IF(num_indices.GT.0) THEN
	   at_type(i) = alg_counter_var
	   at_id(i)   = unspecified_int4
        ENDIF
 240	CONTINUE

* 12/96 kludge ...
* In ALG_BREAK_UP the operators EQ, LT, GT, ... are just names so that routine
* misinterprets the negative in  "a EQ -1". Correct that here.
 290	DO 310 i = 3, natom
	   IF ( at_type(i) .EQ. alg_constant ) THEN
	      IF ( at_type(i-1) .EQ. alg_operator
     .	     .AND. at_id  (i-1) .EQ. 2
     .	     .AND. at_type(i-2) .EQ. alg_operator
     .	     .AND. at_end (i-1) .EQ. at_start(i)-1    ) THEN
* ... this minus sign actually belongs to the constant
	         at_start(i) = at_start(i-1)
	         DO 300 i2 = i, natom 	   
	            at_start(i2-1) = at_start(i2)
	            at_end  (i2-1) = at_end  (i2)
	            at_type (i2-1) = at_type (i2)
	            at_id   (i2-1) = at_id   (i2)
 300	         CONTINUE
	         natom = natom - 1
	         GOTO 290
	      ENDIF
	   ENDIF
 310	CONTINUE

* insert flag indicating end of atom list
	at_type(natom+1)  = alg_finished
	at_start(natom+1) = 1
	at_end(natom+1)   = 1

* successful completion
	status = ferr_ok
	RETURN

* error exits
 5000	RETURN
 5100	risc_buff = text(at_start(i):aend)
	CALL ERRMSG( ferr_syntax, status,
     .		     'illegal name: '//risc_buff(:at_start(i)-aend+1), *5000 )
	END

*
* lon_lat_time_string.F
*

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without anx fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and anx derivative works thereof, and
*  its supporting documentation for anx purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in anx publications that result from
*  the use of this software or in anx product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in anx advertising or publicity to endorse or promote anx products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with anx support, consulting,
*  training or assistance of anx kind with regard to the use, operation
*  and performance of this software nor to provide the user with anx
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND Anx EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR Anx SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR Anx DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* Jan 2015
* 6-D function
* v75  *acm* 3/18  Issue 1856, changes to allow for timesteps in fractional seconds
*
*  In this subroutine we provide information about
*  the function.  The user configurable information
*  consists of the following:
*
*  descr              Text description of the function
*
*  num_args           Required number of arguments
*
*  axis_inheritance   Type of axis for the result
*                        ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                        CUSTO   - user defined axis
*                        IMPLIED_BY_ARGS - same axis as the incoming argument
*                        NORMAL          - the result is normal to this axis
*                        ABSTRACT        - an axis which only has index values
*
*  piecemeal_ok       For memory optimization:
*                        axes where calculation may be performed piecemeal
*                        ( YES, NO )
*
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result
*


      SUBROUTINE lon_lat_time_string_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

      CALL ef_version_test(ef_version)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .        'Generate strings from longitude,latitude,time')
      CALL ef_set_num_args(id, 5)

      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_result_type(id, STRING_RETURN)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'longitude')
      CALL ef_set_arg_desc(id, arg, 'Station longitude')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'latitude')
      CALL ef_set_arg_desc(id, arg, 'Station latitude')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'time')
      CALL ef_set_arg_desc(id, arg, 'numeric times')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'time_axis')
      CALL ef_set_arg_desc(id, arg, 
     .     'Varible with a time axis to use to convert time to time strings')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, NO, NO)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'string to prepend')
      CALL ef_set_arg_type (id, arg, STRING_ARG)
      CALL ef_set_arg_desc(id, arg, 'A label to start the strings')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE lon_lat_time_string_compute(id, arg_1, arg_2, arg_3, arg_4, 
     .          arg_5, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif

      INTEGER id
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz,
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz,
     .           mem4lot:mem4hit, mem4loe:mem4hie, mem4lof:mem4hif)
      REAL arg_5(strdf,mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz,
     .           mem5lot:mem5hit, mem5loe:mem5hie, mem5lof:mem5hif)
      REAL result(strdf,memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)


* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable's axes.

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      INTEGER TM_LENSTR
      INTEGER i,  j,  k,  l,  m,  n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER slen, len1, len2, outlen, llen, get_prec, dlen
      
      CHARACTER*2   ns
      CHARACTER*48  TM_FMT, datestring, lonstr, latstr, ilab
      CHARACTER*256 lab, outstring
      REAL ddate, alon, alat

 1100  FORMAT(i1)
 1200  FORMAT(i2.2)
 1300  FORMAT(i3.3)

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* return date string to precision of seconds
      get_prec = 6

      CALL ef_get_arg_string(id, ARG5, lab)
      slen = TM_LENSTR(lab)

      n1 = arg_lo_ss(F_AXIS,ARG1)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
      m1 = arg_lo_ss(E_AXIS,ARG1)
      DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
      l1 = arg_lo_ss(T_AXIS,ARG1)
      DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         k1 = arg_lo_ss(Z_AXIS,ARG1)
         DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

          j1 = arg_lo_ss(Y_AXIS,ARG1)
          DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

           i1 = arg_lo_ss(X_AXIS,ARG1)
           DO 100 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

            IF ( arg_1(i1,j1,k1,l1,m1,n1) .EQ. bad_flag(ARG1) .OR.
     .           arg_2(i1,j1,k1,l1,m1,n1) .EQ. bad_flag(ARG2) .OR.
     .           arg_3(i1,j1,k1,l1,m1,n1) .EQ. bad_flag(ARG3) ) THEN

C     Get the string value of dates and put them in the result.

               outstring = '***'
	       CALL EF_PUT_STRING (outstring, 3, result(1,i,j,k,l,m,n))

            ELSE

	       alon = arg_1(i1,j1,k1,l1,m1,n1)
	       IF (alon .LT. 0) alon = 360 + alon
	       lonstr = TM_FMT(alon, 4, 5, len1)

	       ns = 'N_'
	       alat = arg_2(i1,j1,k1,l1,m1,n1)
	       IF (alat .LT. 0) THEN
	          alat = ABS(alat)
		  ns = 'S_'
	       ENDIF
	       latstr = TM_FMT(alat, 4, 5, len2)
	          
               ddate = arg_3(i1,j1,k1,l1,m1,n1)
               CALL EF_GET_AXIS_DATES (id, ARG4, ddate, T_AXIS, 1, get_prec, dlen, datestring)
               outstring = lab(:slen)//'_'//lonstr(:len1)//
     .           'E_'//latstr(:len2) //ns//datestring(1:11)

cc Just use a sequence number...
cc
cc	       IF (arg_hi_ss(X_AXIS,ARG1) .LT. 10) THEN
cc	          WRITE (ilab, 1100) i1
cc		  llen = 1
cc	       ELSEIF (arg_hi_ss(X_AXIS,ARG1) .LT. 100) THEN
cc	          WRITE (ilab, 1200) i1
cc		  llen = 2
cc	       ELSEIF (arg_hi_ss(X_AXIS,ARG1) .LT. 1000) THEN
cc	          WRITE (ilab, 1300) i1
cc		  llen = 3
cc	       ENDIF
cc               outstring = lab(:slen)//'_'//ilab(:llen)
     
	       outlen = TM_LENSTR(outstring)
	       CALL EF_PUT_STRING (outstring, outlen, result(1,i,j,k,l,m,n))

            ENDIF

            i1 = i1 + arg_incr(X_AXIS,ARG1)
 100       CONTINUE

           j1 = j1 + arg_incr(Y_AXIS,ARG1)
 200      CONTINUE

          k1 = k1 + arg_incr(Z_AXIS,ARG1)
 300     CONTINUE

         l1 = l1 + arg_incr(T_AXIS,ARG1)
 400    CONTINUE
         m1 = m1 + arg_incr(E_AXIS,ARG1)
 500    CONTINUE
         n1 = n1 + arg_incr(F_AXIS,ARG1)
 600    CONTINUE


      RETURN

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END

	SUBROUTINE GCF_IMPOSE_ARG_LIM_DFLTS( vname, arg,
     .					     cx_in, cx_out, uvar, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* This routine is used in setting the context used for **obtaining**
* the component arguments to a grid changing function.
* This is the so-called "upstream" passing of context.

* The input context, cx_in, is the limits requested for the result.
* For example, in
*	LET a = GCFCN( b )
*	LIST/I=1:5 a[J=5:10]
* the input context would contain I=1:5 and J=5:10.
* The decision of what defaults to set when requesting the argument ("b")
* is the business of this routine.

* V450: 1/97
* V500: 10/98 - *jc* We need to remove the @RDC transform from
*       contexts when the parent is also a grid changing variable.
* V490: 11/97 - bug fix: when wiping out context axis wipe ww lims, too
* V491:  3/98 - bug fix: crashed because pseudo-variables did not have
*		valid grids when this routine was called. Changed to use
*		**result** grid to convert world coords to subscripts when
*		offsets need to be applied -- argument grid not needed.
*		Hugely simplified this routine!
* v580 *acm* 11/04 Reset cx_cal_id, the calendar ID used when  
*                  computing world coordinates
* v581 *acm*  2/05 for axis_expand, if the requested offset is given as 
*                  unspecified_int4 then use the full axis range, or if 
*                  the axis is modulo, then one full modulo repetition
* V600  4/06 *acm* - additional declarations found by Solaris compiler
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction.
* V683  *acm*10/12 Improve handling of F axes and info about the calendar of the grid.

*	Note: the "offset" code in this routine is largely untested!

	include 'tmap_dims.parm'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'grid_chg_fcns.parm'
	include	'xcontext.cmn'


* calling argument declarations
	INTEGER		arg, cx_in, cx_out, uvar, status
	CHARACTER*(*)	vname		! unused after 3/98

* local variable declarations
	INTEGER	TM_LENSTR1, ISUBSCRIPT, KNOWN_GRID,
     .		gcfcn, idim, arg_grd, mods_cx, tmp_var_cx,
     .		lo_off(nferdims), hi_off(nferdims), action(nferdims), uvgrid,
     .          WHICH_GCFCN, lo, hi, ss_mid, cx_mid
       LOGICAL ss_fix

* initialize
	CALL TRANSFER_CONTEXT ( cx_in, cx_out )

* 10/98 fix
	DO 10 idim = 1, nferdims
           IF ( cx_trans(idim, cx_out) .EQ. trans_reduced ) THEN
              cx_trans(idim, cx_out) = trans_no_transform
           ENDIF
 10     CONTINUE

* which grid changing function does this uvar have?
	gcfcn = WHICH_GCFCN(uvar)

* get the grid of the result of this function (user variable)
	uvgrid = KNOWN_GRID(cx_data_set(cx_in), cat_user_var, uvar)

* What did the function creator specify about this argument?
	CALL GCF_GET_ARG_LIMS( gcfcn, arg, cx_out, uvgrid,
     .				lo_off, hi_off, action, status)
	IF ( status .NE. ferr_ok ) RETURN

* loop through the axes
	DO 500 idim = 1,nferdims

	   IF ( action(idim) .EQ. pset_to_unspec ) THEN
* set the axis limits to unspecified
	      cx_lo_ss(cx_out,idim)      = unspecified_int4
	      cx_hi_ss(cx_out,idim)      = unspecified_int4
	      cx_by_ss(idim,cx_out)      = .TRUE.
	      cx_given(idim,cx_out)      = .FALSE.	! needed ?
	      cx_lo_ww(idim,cx_out)      = unspecified_val8	! 11/97
	      cx_hi_ww(idim,cx_out)      = unspecified_val8	! 11/97
	      cx_cal_id(cx_out)          = unspecified_int4
!	      cx_trans (idim,cx_out)     = trans_no_transform
!	      cx_trans_arg(idim,cx_out)  = bad_val4  
	      IF (idim .EQ. t_dim .OR. idim .EQ. f_dim) 
     .                cx_calendar(idim,cx_out) = .FALSE.

	   ELSEIF (lo_off(idim).NE.0 .OR. hi_off(idim).NE.0) THEN
* pass along the axis limits 
                 
              IF (lo_off(idim) .EQ. unspecified_int4 .OR.
     .            hi_off(idim) .EQ. unspecified_int4)  
     .           CALL GRID_SUBSCRIPT_EXTREMES_NO_MOD
     .                             (lo, hi, uvgrid, idim)
                 ss_mid = (hi - lo + 1)/ 2.


	      IF ( cx_by_ss(idim,cx_out) ) THEN
* ... expand the subscript range by the offsets requested. If the
*     requested offset is unspecified_int4 then use the full axis range,
*     or if modulo, then use either 
*    1) one full modulo repitition, centered on the output range, or
*    2) the requested range, if it is larger than one modulo repetitionpetition

	         IF ( cx_hi_ss(cx_out,idim).NE.unspecified_int4 ) THEN

* special fix for modulo axes.
                    ss_fix = ( cx_lo_ss(cx_out,idim) .LT. lo .OR.
     .                      cx_hi_ss(cx_out,idim) .GT. hi )  ! special fix for modulo axes

                    cx_mid = (1 + cx_hi_ss(cx_out,idim) +
     .                            cx_lo_ss(cx_out,idim))/2.
                    IF (lo_off(idim) .EQ. unspecified_int4 )  THEN
                       IF (ss_fix) THEN
                          cx_lo_ss(cx_out,idim) =  MIN(cx_mid - ss_mid,
     .                                cx_lo_ss(cx_out,idim))
                       ELSE
                          cx_lo_ss(cx_out,idim) = lo
                       ENDIF
                    ELSE
	               cx_lo_ss(cx_out,idim) = cx_lo_ss(cx_out,idim)
     .					  + lo_off(idim)
                    ENDIF
                    IF (hi_off(idim) .EQ. unspecified_int4 )  THEN
                       IF (ss_fix) THEN
                          cx_hi_ss(cx_out,idim) = MAX(cx_mid + ss_mid, 
     .                                cx_hi_ss(cx_out,idim) )
                       ELSE
                          cx_hi_ss(cx_out,idim) = hi
                       ENDIF
                    ELSE
 	               cx_hi_ss(cx_out,idim) = cx_hi_ss(cx_out,idim)
     .					  + hi_off(idim)
                    ENDIF
		 ENDIF
	      ELSE
* ... convert the world coordinate range to subscript limits. Then
* ... expand the subscript range by the offsets requested
	         IF ( cx_hi_ww(idim,cx_out).NE.unspecified_val8 ) THEN
                 
	            cx_lo_ss(cx_out,idim) =
     .				ISUBSCRIPT(cx_lo_ww(idim,cx_out),
     .		 			   uvgrid, idim, round_up)
                    cx_hi_ss(cx_out,idim) = 
     .				ISUBSCRIPT(cx_hi_ww(idim,cx_out),
     .					   uvgrid, idim, round_dn)

* special fix for modulo axes. 
                    ss_fix = ( cx_lo_ss(cx_out,idim) .LT. lo .OR.
     .                      cx_hi_ss(cx_out,idim) .GT. hi )  
                    cx_mid = (1 + cx_hi_ss(cx_out,idim) +
     .                            cx_lo_ss(cx_out,idim))/2.

                    IF (lo_off(idim) .EQ. unspecified_int4 )  THEN
                       IF (ss_fix) THEN
                          cx_lo_ss(cx_out,idim) = MIN(cx_mid - ss_mid,
     .                                cx_lo_ss(cx_out,idim))
                       ELSE
                          cx_lo_ss(cx_out,idim) = lo
                       ENDIF
                    ELSE
	               cx_lo_ss(cx_out,idim) = cx_lo_ss(cx_out,idim)
     .					  + lo_off(idim)
                    ENDIF

                    IF (hi_off(idim) .EQ. unspecified_int4 )  THEN
                       IF (ss_fix) THEN
                          cx_hi_ss(cx_out,idim) = MAX(cx_mid + ss_mid, 
     .                                cx_hi_ss(cx_out,idim) )
                       ELSE
                          cx_hi_ss(cx_out,idim) = hi
                       ENDIF
                    ELSE
	               cx_hi_ss(cx_out,idim) = cx_hi_ss(cx_out,idim)
     .					  + hi_off(idim)
                    ENDIF

		 ENDIF
	         cx_by_ss(idim,cx_out) = .TRUE.
	      ENDIF
	   ENDIF

 500	CONTINUE

* successfully merged
	status = ferr_ok
	RETURN

* error exit
! 5000	RETURN
	END

	SUBROUTINE CHOOSE_CX_WW( uvar, exp_cx, imp_cx, idim, ww_lo, ww_hi, np)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* given an explicit context which may or may not contain data and an
* implicit context which is always fleshed out determine the proper
* world coordinate limits for the specified axis

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  5/19/89-8/6/89 (time representations)
* 	 3/2/90 - bug fix: variable, grid, not defined correctly
* V320:  3/2/95 - trim the 1/2 grid box fringe around CONTOUR and FILL plots
*               This is OK to do because /xlimits and /ylimits offer explicit
*               over-ride options
*       8/97 - *kob*  - check cx_calender rather than ww_low to see if time entered is a
*                       date string or a time step
* v68  *acm* 4/08 Allow shade, vector plots of degenerate regions - world region 
*              within a grid cell
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction. The time 
*                  dimension is now an arg to SECS_TO_TSTEP.
* V695  *acm* 2/15 cx_calendar stores info about calendar formatting of T and F axes
* V698  *acm* 5/16 Ticket 1845 fix; adjusting plot-axis ends for subspan modulo axes.

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'command.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'

* calling argument declarations:
	INTEGER uvar, exp_cx, imp_cx, idim, np
	REAL*8	ww_lo, ww_hi

* internal variable declarations:
	LOGICAL TM_ITS_SUBSPAN_MODULO, is_subspan, void_at_start, void_at_end
	INTEGER CGRID_AXIS, CAXIS_LEN, iaxis, lo_ss, hi_ss
	INTEGER	imp_ndim, exp_ndim, imp_dim(4), exp_dim(4), grid,
     .		lo_edge, hi_edge
	REAL*8	TM_WORLD, SECS_TO_TSTEP, ww_low, ww_hiw

* initialize
* always use the grid carried with the data itself for ww/ss translations
	grid = cx_grid( imp_cx )

* default is to use the limits associated with the data itself
	   ww_lo = cx_lo_ww(idim,imp_cx)
	   ww_hi = cx_hi_ww(idim,imp_cx)
	   lo_edge =  box_lo_lim
	   hi_edge =  box_hi_lim

* Is the start or end in the subspan modulo void cell? If so bring in the region spec.
	   iaxis = CGRID_AXIS(idim,imp_cx)
	   lo_ss = cx_lo_ss(imp_cx,idim)
	   hi_ss = cx_hi_ss(imp_cx,idim)
	   is_subspan = TM_ITS_SUBSPAN_MODULO( iaxis  )
	   void_at_start = is_subspan .AND. (lo_ss .EQ.0)
	   void_at_end   = is_subspan .AND. (hi_ss .EQ. CAXIS_LEN(idim,imp_cx)+1 )

	   IF (is_subspan) THEN
              IF (void_at_start) THEN 
	         lo_ss = lo_ss + 1
	         ww_lo = TM_WORLD( lo_ss, grid, idim, box_lo_lim )
              ENDIF
              IF (void_at_end  )  THEN 
	         hi_ss = hi_ss - 1
	         ww_hi = TM_WORLD( hi_ss, grid, idim, box_hi_lim )
              ENDIF
	   ENDIF

* 3/95 but for contour (and filled contour) plots we can only plot the edges
* up to the actual location of the point
        IF ( cmnd_num .EQ. cmnd_contour ) THEN
           ww_lo = MAX( ww_lo,
     .                  TM_WORLD(lo_ss,grid,idim,box_middle)                    )
           ww_hi = MIN( ww_hi,
     .                  TM_WORLD(hi_ss,grid,idim,box_middle)                    )
        ENDIF

* contour expression has its own limits embedded ?
	IF ( uvar_given(idim,uvar) .LT. uvlim_needed ) RETURN

* contour expression depends on command limits - use 'em
* (test for unspecified in case limits came from file information)
	IF ( cx_by_ss(idim,exp_cx) ) THEN
	   IF ( cx_lo_ss(exp_cx,idim).EQ.unspecified_int4 ) THEN
	      RETURN
	   ELSE
	      ww_lo = MAX(TM_WORLD(cx_lo_ss(exp_cx,idim),grid,idim,
     .                    lo_edge),
     .			  cx_lo_ww(idim,imp_cx) )
	      ww_hi = MIN(TM_WORLD(cx_hi_ss(exp_cx,idim),grid,idim,
     .                    hi_edge),
     .			  cx_hi_ww(idim,imp_cx) )
	   ENDIF
	ELSE
	   IF ( cx_lo_ww(idim,exp_cx).EQ.unspecified_val8 ) THEN
	      RETURN
	   ELSE
* ... explicit limits can further restrict, but not expand
* 8/97 *kob* - check cx_calender for a date time rather than ww_low
	      ww_low = cx_lo_ww( idim, exp_cx )
	      ww_hiw = cx_hi_ww( idim, exp_cx )
	      IF ( (idim.EQ.t_dim .OR. idim.EQ.f_dim) .AND. 
     .             cx_calendar(idim,exp_cx) ) THEN
	         ww_low = SECS_TO_TSTEP( grid, idim, -ww_low )  
	         ww_hiw = SECS_TO_TSTEP( grid, idim, -ww_hiw )  
	      ENDIF                                     
	      ww_lo = MAX( ww_low, ww_lo )
	      ww_hi = MIN( ww_hiw, ww_hi )
	   ENDIF
	ENDIF


* For a one-point axis and contour plot, return the lo and hi ww requested
        IF (np .EQ. 1) THEN
	   ww_lo = cx_lo_ww(idim,imp_cx)
	   ww_hi = cx_hi_ww(idim,imp_cx)
        ENDIF

	RETURN
	END

	INTEGER FUNCTION TM_AXES_REVERSED( var, axes )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* return an array of length nferdims indicating containing the axes that are reversed
* and the value of the function is the number that are reversed

* ... to hide TMAP COMMON from FERRET

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V320: 2/16/94
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing

	include 'tmap_dims.parm'
#include "tmap_dset.parm"
	include 'xdset_info.cmn_text'

* calling argument declarations:
* *kob* 8/95 - changed decl. of axes from LOGICAL to INTEGER
	INTEGER	axes(nferdims)
	INTEGER	var

* internal variable declarations
	INTEGER	i, number

* initialze
	number = 0

* check all the axes
* note that for netCDF files the array ds_ordering contains a list of only
* those dimensions that are relevant to the variable.  For example, the
* variable SST, which contains axes X (1), Y (2), and T (3) would have
* ds_ordering(1-nferdims,SST_var) = 1,2,4,0
	DO 100 i = 1, nferdims
	   IF ( ds_ordering(i,var) .LT. 0 ) THEN
	      number = number + 1
	      axes(number) = ABS(ds_ordering(i,var))
	   ENDIF
 100	CONTINUE	   

	TM_AXES_REVERSED = number

	RETURN
	END

* 
*  expndi_by_z_counts.F
* 
*  Ansley Manke (from expndi_by_z)
*  8/24/2011
* 
* Expand argument 1 by creating a 2D XZ structure from it with the 
* separation between Z columns given by the lengths specified in 
* argument 2. Argument 2 is a list of length N, where N is the number of 
* Z columns to create, and each item in the list is the length of that 
* column (the length of the cruise or profile). Thus the Z columns created 
* are "ragged" Typical use is that arg 1 is a collection of vertical casts 
* appended end-to-end and that arg 2 is the number of values in each cast.
* The sum of the values in arg 2 is the length of argument 1. 

*  Args 3 and 4 are constants -- the size of the X and Z axes, respectively
 
*  In this subroutine we provide information about
*  the function.  The user configurable information 
*  consists of the following:
* 
*  descr              Text description of the function
* 
*  num_args           Required number of arguments
* 
*  axis_inheritance   Type of axis for the result
*                        ( CUSTOM, IMPLIED_BY_Z_ARGS, NORMAL, ABSTRACT )
*                        CUSTOM          - user defined axis
*                        IMPLIED_BY_Z_ARGS - same axis as the incoming argument
*                        NORMAL          - the result is normal to this axis
*                        ABSTRACT        - an axis which only has index values
* 
*  piecemeal_ok       For memory optimization:
*                        axes where calculation may be performed piecemeal
*                        ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE expndi_by_z_counts_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .  'Expand arg1 on I into an XZ grid. (Typ. to split Z-profiles)' )

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, ABSTRACT, 
     .     IMPLIED_BY_ARGS, ABSTRACT, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'dat')
      CALL ef_set_arg_desc(id, arg, 'variable to expand on I axis')
      CALL ef_set_axis_influence(id, arg, NO, YES, NO, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'counts')
      CALL ef_set_arg_desc(id, arg,
     .          'count of values in each profile')
      CALL ef_set_axis_influence(id, arg, NO, YES, NO, YES)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'max_profile_len')
      CALL ef_set_arg_desc(id, arg,
     .          'K size of result (constant)')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END






*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE expndi_by_z_counts_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      REAL size
      integer nx, arg
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

*
*     Use utility functions to get context information about the arguments.
*
* output X axis size
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      arg = 2
      nx = arg_hi_ss(X_AXIS,arg) - arg_lo_ss(X_AXIS,arg) + 1
      CALL ef_set_axis_limits(id, X_AXIS, 1, nx)

* output Z axis size
      CALL ef_get_one_val(id, ARG3, size)
      CALL ef_set_axis_limits(id, Z_AXIS, 1, INT(ABS(size)))
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END



* 
*  In this subroutine we compute the result
* 
      SUBROUTINE expndi_by_z_counts_compute(id, arg_1, arg_2, arg_3, 
     .                               result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy,
     .	   mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy,
     .     mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy,
     .     mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1
      INTEGER i2, j2, k2, l2
      INTEGER imax,kmax, iout, kout, isum

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* limits on output arrays
        imax = res_hi_ss(X_AXIS)
        kmax = res_hi_ss(Z_AXIS)

* make sure input 2 is a list of length nprofile
      IF (arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1 .NE. imax)
     .       CALL EF_BAIL_OUT(id, 'Arg 2 must be of length given in arg3')

* args 1 and 2 must not depend on z
      IF ( (arg_lo_ss(Z_AXIS,ARG1) .NE. arg_hi_ss(Z_AXIS,ARG1))
     . .OR.(arg_lo_ss(Z_AXIS,ARG2) .NE. arg_hi_ss(Z_AXIS,ARG2)) ) CALL
     .           EF_BAIL_OUT(id, 'Z size of args 1 and 2 must be 1')

* sum of counts in arg 2 must be length of x-dimension of arg1

      k2 = arg_lo_ss(Z_AXIS,ARG2)
      L2 = arg_lo_ss(T_AXIS,ARG2)
      do 20 j2 = arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS,ARG2)
      do 20 L2 = arg_lo_ss(T_AXIS,ARG2), arg_hi_ss(T_AXIS,ARG2)
         isum = 0
         DO 10 i2 = arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS,ARG2)
            IF  (arg_2(i2,j2,k2,l2) .EQ. bad_flag(ARG2) .OR. 
     .           INT(arg_2(i2,j2,k2,l2)) .LT. 0)
     .          CALL EF_BAIL_OUT(id, 'elements of arg 2 are counts GE zero')
            isum = isum + INT(arg_2(i2,j2,k2,l2))
 10   CONTINUE
         IF (isum .NE. (arg_hi_ss(X_AXIS,ARG1)-arg_lo_ss(X_AXIS,ARG1)+1) )
     .       CALL EF_BAIL_OUT(id, 
     .         'arg 2 values must sum to x-dimension length of of arg1 ')
 20   CONTINUE

* pre-fill the entire output result with missing value flags
*  (since length of each profile may have different number of pts)
      DO 60 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         DO 50 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            DO 40 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
               DO 30 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
 30            result(i,j,k,l) = bad_flag_result
 40         CONTINUE
 50      CONTINUE
 60   CONTINUE

* fill in the points as specified by the counts
      k1 = arg_lo_ss(Z_AXIS,ARG1)
      k2 = arg_lo_ss(Z_AXIS,ARG2)

      l1 = arg_lo_ss(T_AXIS,ARG1)
      l2 = arg_lo_ss(T_AXIS,ARG2)
      DO 400 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         j2 = arg_lo_ss(Y_AXIS,ARG2)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            i1 = 1
            DO 200 iout=arg_lo_ss(X_AXIS,ARG2),arg_hi_ss(X_AXIS,ARG2)
               DO 100 kout = 1, NINT(arg_2(iout,j2,k2,l2))
                 IF ( arg_1(i1,j1,k1,l1) .NE. bad_flag(1) )
     .             result(iout,j,kout,l) = arg_1(i1,j1,k1,l1)
                  i1 = i1 + 1
 100           CONTINUE
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
            j2 = j2 + arg_incr(Y_AXIS,ARG2)
 300     CONTINUE

         l1 = l1 + arg_incr(T_AXIS,ARG1)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
 400  CONTINUE
      
         
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	SUBROUTINE CVAR_CONTEXT( def_cx, cx, com, k_eq1, status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* create a new variable context by combining the information pointed to by the
* cvar table component pointer, com, with the default context, def_cx

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V200:  7/25/89 - based on INST_IJKL_CONTEXT
* 	 2/27/90 - incorporate CAIR as a regrid on the main stack
* 		 - and allow unspecified limits to pass through
*Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
#ifdef unix
	include	'tmap_dims.parm'
#	include	"tmap_dset.parm"
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'instance_table.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xcalc_vars.cmn'
	include	'xtext_info.cmn'
	include	'xdset_parms.cmn'
#else
	INCLUDE	'TMAP_FORMAT:TMAP_DIMS.PARM'
	INCLUDE	'TMAP_FORMAT:TMAP_DSET.PARM'
	INCLUDE	'FERRET_CMN:FERRET.PARM'
	INCLUDE	'FERRET_CMN:ERRMSG.PARM'
	INCLUDE	'FERRET_CMN:INTERP_STACK.PARM'
	INCLUDE	'FERRET_CMN:INSTANCE_TABLE.PARM'
	INCLUDE	'FERRET_CMN:XCONTEXT.CMN'
	INCLUDE	'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE	'FERRET_CMN:XCALC_VARS.CMN'
	INCLUDE	'FERRET_CMN:XTEXT_INFO.CMN'
	INCLUDE	'FERRET_CMN:XDSET_PARMS.CMN'
#endif

* calling argument declarations:
	LOGICAL k_eq1
	INTEGER	def_cx, cx, com, status

* internal variable declarations:
	LOGICAL	HOURLY_DATA, special_var, re_flesh
	INTEGER KNOWN_GRID, CGRID_AXIS, FVAR_NUMBER, ISUBSCRIPT,
     .		l_step, var, l_lo, idim, def_ax, com_ax,
     .		grid, dset, cat, fvar, cairt, cairt_dset
	REAL*8	TM_WORLD, tptinc, t, hours, tmod, t0cairt,
     .          tclim0, tfrombc
	CHARACTER*20	date

* internal parameters:
	REAL*8		secsperhr, hrsperyr
	PARAMETER     ( secsperhr = 3600.D0,
     .			hrsperyr  = 365.D0*24.D0 )

* initialize with context of variable to be computed
	CALL TRANSFER_CONTEXT( def_cx, cx )

* unravel the variable internal number coding
* (this is the fixed var # - 1=TEMP, 2=SALT, etc.)
	var = cv_variable( com )
	special_var = var .GT. pcv_spec_flg
	IF ( special_var ) var = var - pcv_spec_flg

* determine the data set
	IF ( special_var .AND. var .EQ. pairt ) THEN
	   dset = cx_data_set( def_cx )
	   cairt      = dp_clim_air_sst( dset )		! cairt needed for calcs
	   cairt_dset = dp_airt_dset( cairt )		! dset containing cairt
	   IF ( cairt_dset .EQ. unspecified_int4 ) THEN
	      GOTO 5100					! needed dset not SET
	   ELSE
	      dset = cairt_dset
	   ENDIF
	ELSE
	   dset = cx_data_set( cx )
	ENDIF
	cx_data_set( cx ) = dset

* find the variable number as stored in the data set, if relevant
	IF ( cv_category( com ) .EQ. cat_calc_var ) THEN
	   fvar = var
	ELSE
	   fvar = FVAR_NUMBER( dset, fvar_name_code(var) )
	   IF ( fvar .EQ. var_name_nonexist ) GOTO 5100
	ENDIF
	cx_variable( cx ) = fvar

* determine the variable category and defining grid for the data
	cat = cv_category( com )
	cx_category( cx ) = cat
	grid = KNOWN_GRID( dset, cat, fvar )
	cx_grid( cx ) = grid

* SPACIAL AXES: X,Y,Z
* component may be wider (or narrower) than result
	DO 100 idim = 1, 3
	   def_ax = CGRID_AXIS(idim,def_cx)
	   com_ax = CGRID_AXIS(idim,cx)
	   re_flesh = def_ax .NE. com_ax
	   IF ( def_ax.EQ.mnormal .OR. com_ax.EQ.mnormal ) THEN
	      IF ( def_ax .EQ. com_ax ) GOTO 100
	      re_flesh = .TRUE.
	      IF ( def_ax .EQ. mnormal ) THEN
* ... 3D component of 2D var: e.g. TEMP as comp. of QEVA ... needs SST
	         cx_lo_ss(cx,idim) = 1
	         cx_hi_ss(cx,idim) = 1
	      ENDIF
* ... for 2D component of 3D var FLESH_OUT_AXIS will set limits unspecified
* ... e.g. QFLX as comp. of QDFZ
	   ELSEIF ( cx_lo_ss(cx,idim) .EQ. unspecified_int4 ) THEN
* ... allow unspecified regions to pass through still unspecified 2/90
	      re_flesh = .FALSE.
	   ELSE
	      IF ( cv_lo_ds( com,idim ) .NE. 0 ) THEN
	         cx_lo_ss(cx,idim) = cx_lo_ss(cx,idim) + cv_lo_ds( com,idim )
	         re_flesh = .TRUE.
	      ENDIF
	      IF ( cv_hi_ds( com,idim ) .NE. 0 ) THEN
	         cx_hi_ss(cx,idim) = cx_hi_ss(cx,idim) + cv_hi_ds( com,idim )
	         re_flesh = .TRUE.
	      ENDIF
	      IF ( idim.EQ.3 .AND. k_eq1 ) THEN
	         IF ( cx_lo_ss(cx,idim) .NE. 1 ) THEN
	            cx_lo_ss(cx,idim) = 1
	            re_flesh = .TRUE.
	         ENDIF
	      ENDIF
	   ENDIF
	   IF ( re_flesh ) THEN
	      cx_by_ss( idim,cx ) = .TRUE.
	      CALL CONFINE_AXIS( idim, cx, status )
	      IF ( status .NE. ferr_ok ) RETURN
	      CALL FLESH_OUT_AXIS( idim, cx, status )
	      IF ( status .NE. ferr_ok ) RETURN
	   ENDIF
 100	CONTINUE

* TIME AXIS:
* remark on "hourly_needed" below:
* the time axes of the data sets are not in general the same as the underlying
* time axis of the model (model integration is typically hourly, whereas data
* sets will normally be 24 hour or 73 hour snapshots).  Some calculations, such
* as d/dt(U) simply use the best data available - whatever is in the data set.
* Other calculations require the exact 1 hour data to be exact.  If that data
* is not available then the current time step (dt=0) is used as the best est.

* get subscript for time step
	re_flesh = .FALSE.
	IF ( special_var .AND. var .EQ. pairt ) THEN
* ... climatological air temp is just a variable in another file that
*     needs to be regridded from its monthly axis to the time axis of this
*     data set ( MOD(1 yr) )
	   cx_grid(cx) = cvar_grid( pcair, cx_data_set(def_cx) )
	   cx_unstand_grid(cx) = .TRUE.
	   cx_regrid_trans( x_dim, cx ) = prgrd_exact
	   cx_regrid_trans( y_dim, cx ) = prgrd_exact
	   cx_regrid_trans( z_dim, cx ) = prgrd_exact
	   cx_regrid_trans( t_dim, cx ) = prgrd_linear_interp

* ... subscript on same axis as calling variable for all below
	ELSEIF ( cv_lo_d4(com) .GT. pcv_hourly_flg ) THEN
* ... special treatment of "hourly_needed" diagnostic data
	   IF ( HOURLY_DATA( grid ) ) THEN
* ... use 1 hr earlier for exact match of Philander/Cox code
	      cx_lo_ss(cx,t_dim) = cx_lo_ss(cx,t_dim) - 1
	      re_flesh = .TRUE.
	   ENDIF
	ELSEIF ( cx_lo_ss(cx,idim) .EQ. unspecified_int4 ) THEN
* ... allow unspecified regions to pass through still unspecified 2/90
	   re_flesh = .FALSE.
	ELSE
	   IF ( cv_lo_ds( com,t_dim ) .NE. 0 ) THEN
	      cx_lo_ss(cx,t_dim) = cx_lo_ss(cx,t_dim) + cv_lo_d4( com )
	      re_flesh = .TRUE.
	   ENDIF
	   IF ( cv_hi_ds( com,t_dim ) .NE. 0 ) THEN
	      cx_hi_ss(cx,t_dim) = cx_hi_ss(cx,t_dim) + cv_hi_d4( com )
	      re_flesh = .TRUE.
	   ENDIF
	ENDIF
* finalize the time axis
	IF ( re_flesh ) THEN
	   cx_by_ss( t_dim, cx ) = .TRUE.
	   CALL CONFINE_AXIS( t_dim, cx, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   CALL FLESH_OUT_AXIS( t_dim, cx, status )
	   IF ( status .NE. ferr_ok ) RETURN
	ENDIF

* success
	status = ferr_ok
	RETURN

* error exit
 5000	RETURN
 5100	IF ( special_var .AND. var .EQ. pairt ) THEN
	   CALL ERRMSG( ferr_var_not_in_set, status,
     .			'need to SET DATA CLIM_AIRT_'//dp_airt_name(cairt),
     .			*5000 )
	ELSE
	   CALL ERRMSG( ferr_var_not_in_set, status,
     .						 fvar_name_code(var), *5000 )
	ENDIF
	END

	SUBROUTINE TM_INIT_DSET(dset_name,ok_re_use_existing,
     .				perm,dset_num,tregular, use_strict,status)

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Initialize a TMAP data set:  GT, TS, or CDF
* For GT and TS: opens dataset DESCRIPTOR/SET file,reads the FORMAT_RECORD and
* BACKGROUND_RECORD, reads in any GRID files given, then determines correct
* reading routine to load common blocks XDOtSET_INFO and XSTEP_FILES with vital
* system and background information
* For netCDF file allocates a data set slot and proceded to CD_ routines

* Programmer Mark Verschell (from programs by Steve Hankin)
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX/VMS
*
* revision 0.00 - 06/23/88 - From GT_INIT_DSET version 1.20
* revision 0.01 - 11/21/88 - variable not_used removed (wasn't used)
* revision 0.02 - 12/12/88 - removed arguement dset_num from TM_READ_GRIDFILE
* revision 0.03 - 02/15/89 - changed GT_CLOSE_SET to TM_CLOSE_SET, eliminated
* revision 0.04 - 02/17/89 - Added initialization of D_TIME_MODULO
* revision 0.05 - 04/17/89 - Added message in case file not descriptor file
* revision 0.06 - 01/10/91 - added ifdef unix for default file *sh*
* Unix/RISC port *sh* 3/91 - found bug: CLOSE called on error when lunit wasn't
*                          - opened.  Added logical "opened" and "got_lun"
*                          - use TM_INQ_PATH for (nearly) OS-independent access
* SUN port   - 1/20/92 kob --- moved all NAMELIST definitions to immediately
*                             after declarations.  SUN Fortran didn't like them
*                             embedded in executable code
* netCDF support *sh* 2/92 - added new calling argument dset_type
*                          - added TM_CLEAN_FILENAME
* 12/93 *sh* - bug fix: check for filename ending ".cdf" BEFORE determining
*			    which path list to use
*  4/94 *sh* - ... and if no match try the other choice (.des v.s..cdf) 
*  5/94 *sh* - recognize URL-style names as netCDF names (DODS networking)
*
* 6/2/94 *kob* - IBM Port
*		  Need to initialize d_time_modulo with .FALSE. instead of 0
*		  Need ifdef READONLY_ALLOWED around readonly in open statemnt
* *sh* 3/2/95 - informative messages issued through TM_NOTE (for GUI)
* *sh* 11/96 - recognize .nc as a NetCDF file and ignore "(no cache)"
* Linux port -kob - 3/97 - Modify include for tmap_dset.parm to be a
*			   preprocessor include for F90 - needed because
*			   tmap_dset.parm contains an ifdef
* *kob* 7/97 - modification to eliminate unnecessary error messages when
*              searching for files w/out extensions (ie ".cdf")
* *kob* 4/99 - increase size of TM_INQ_PATH and des_name
*              to accomodate lenghty DODS dataset names
* *sh*  6/99 - added "perm" (permutation) argument
* V510 *sh* 3/00 - added tregular argumant
*	    4/00 - converted to dynamic grids -- bump use counts here
* v530 *kob* 1/00 - minor mods for remote mc aggregations
* v530 *acm* 1/01 - initialize ds_cal_name  calendar name
* v540 *acm* 10/01 increase length of ds_name
* v540 *acm* 10/01  remove VMS include statements
* v541 *acm*  4/02  New descriptor d_caltype for nonstandard calendar types.
*                   **also changes to descript.def**
*      *acm*  5/02  When extension not specified, try .nc as well as .des, .cdf
* 1/03 - *kob* g77 port - Need to use risc_buff for arbitrary concatenations
* 4/03 *acm* - Use STR_SAME to compare strings
* 5/03 *acm* - Compare ds_name to char_init256 as that is its length...
* V581 *acm* 3/05 allow "USE myfile.des"  previously this only worked if
*                  the file extension was left off.
* V581: *acm*/3/05 - increase length of strings for dataset title to 1024
* V604: *acm*/7/07 - increase length of dataset names to 1024
* V62 : *acm* 5/09 - Check for alternative allowed calendar names as in cd_get_1_axis
*                    (e.g. standard, which is equivalent to Gregorian.)
* V65  *acm* 2/10- all warnings and notes to std error not std out
* V68  *acm* 1/12- added use_strict argument for ticket 1910: micro-adjusting on 
*                  repeated coordinates in netCDF/OPeDNAP datasets
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing
* V683 9/12 *acm* Fix ticket 1531: nc is the default dataset type if not given 
*                 with the command qualifier or the extension is not recognized.
* V686 1/14 *acm* Fix ticket 2128: If USE is given without a file extension, check
*                 for descriptor file too, after .nc and .cdf.
* V686 1/14 *acm* Fix ticket 2129: A bug in the fix to 2128.
* V686 1/27/14 *acm* further fix for 2129: make sure a search for a .nc or .cdf file is
*                 done in path FER_DATA.
* V693+ *sh* 12/14 added blank separator into error message 5600
* V695+ *sh* 11/15 for DEF DATA/AGG/T added argument ok_re_use_existing
*	           and check for existence of dataset from the get-go
* V701  7/16 *kms* Compare ds_name to char_init2048 instead of char_init1024
* V702 11/16 *acm* Ticket 2490, add coaching to error on tseries aggregations

* arguments:
*	dset_name	- filename of DESCRIPTOR file (input)
*	ok_re_use_existing - if dataset already open, return it? (input)
*	dset_num	- number assigned to this data set (output)
*			  ( 1 <= dset_num <= maxdsets - see COMMON XDSET_INFO)
*	dset_type	- coaching for data set type (GT,TS, or CDF)
*                       - blank to determine based on filename extension
*	status		- return status
*

* Argument definitions
	LOGICAL		ok_re_use_existing, tregular, use_strict
	INTEGER		perm(*), dset_num, status
	CHARACTER*(*)	dset_name

* Parameter and common files
        include 'tmap_errors.parm'              ! error codes
#include "tmap_dset.parm"
        include 'tmap_dims.parm'                ! data set dimensions
#include "gt_lib.parm"
	include 'xio.cmn_text'
        external xio_data
        include 'xdset_info.cmn_text'   ! data set common
        external xdset_info_data
        include 'xsys_names.cmn_text'
        external xsys_names_data
        include 'xdiag_ctrl.cmn_text'
        external xdiag_ctrl_data
        include 'xrisc_buff.cmn'

* Define variables from Set File namelist records
	include 'descript.def'

* Parameter for number of known types and number of format_revs
	INTEGER*4	num_known, num_revs
	PARAMETER	(num_known = 5)
	PARAMETER	(num_revs  = 1)

* Internal declarations
	CHARACTER*4	known_type(num_known)
	CHARACTER*4	format_rev(num_revs,num_known)
	CHARACTER*13	TM_STRING
	CHARACTER	def_ext*4, def_cdf*4, def_nc*3, def_des*4, ext*4, 
     .                  cdf_path*12, path*12
        CHARACTER*2048   TM_CLEAN_FILENAME
	CHARACTER*42	reading_nml
	CHARACTER*512   TM_INQ_PATH
	CHARACTER*2048  des_name
	INTEGER*4	set_cnt, lunit, cnt, aux_cnt, tcnt, dlen, dlen2,
     .			rcnt, parm_cnt, grd_cnt, equal_pos, istat
	INTEGER*4	TM_LENSTR, TM_LENSTR1, STR_SAME, STR_UPCASE, ic
	LOGICAL		TM_HAS_STRING, match, ok_share_taxis,
     .			opened, got_lun, dods_url, nocache,
     .                  explicit_ext                 ! 7/97
	DATA		known_type/'  GT','  TS','  MC','  MG','  MT'/
	DATA		format_rev/'  1C',
     .				   '  1A',
     .				   '    ',
     .				   '    ',
     .				   '    '/
	DATA		def_ext  /'.nc'/, def_cdf/'.cdf'/
        DATA            def_nc/'.nc'/, def_des/'.des'/

        DATA            cdf_path/'FER_DATA'/

* namelist declarations
* record 1 - descriptor format record
	NAMELIST /FORMAT_RECORD/d_type,d_format,d_source_class,
     .				d_source,d_subsource,d_prog_rev
* record 2 - file background record
	NAMELIST /BACKGROUND_RECORD/d_expnum,d_modnum,d_title,
     .				   d_mod_title,d_forcing_set,d_t0time,
     .				   d_time_unit,d_time_modulo,
     .				   d_ntegrate_tstep,d_ntuple,d_time_run,
     .				   d_who_ranit,d_time_made,d_who_madeit,
     .				   d_aux_modnum,d_add_parm,
     .				   d_grid_filename,d_caltype

* initialize
        got_lun = .FALSE.    ! controls error clean-up
        opened = .FALSE.     ! controls error clean-up
	explicit_ext = .FALSE.  !controls missing file error reporting 7/97

* (11/15) ok_re-use_existing as (as of today) used only for DEFINE DATA/AGG/T
* ok_re_use_existing==FALSE indicates that we are initializing a T agg by
* opening the first file in the list.  The time axis of this file will be
* modified to become the time axis of the full aggregation.  So it is not ok
* to share (and then modify) the time axis of some previously opened dataset
	ok_share_taxis = ok_re_use_existing

* (11/15) pre-check to see if the dset name that has been provided is an exact 
* match to ds_des_name.  This allows user-defined names to be found (as in
* DEFINE DATA/AG/T myname = file1, file, file3) and as a side benefit it
* bypasses directory inquiries when the user gives the full, exact path on the
* SET DATA command
	IF (ok_re_use_existing) THEN
	   DO set_cnt = 1, maxdsets
	      IF ( ds_des_name(set_cnt) .EQ. dset_name ) THEN
	         dset_num = set_cnt
	         status = merr_no_action
	         GOTO 9999
	      ENDIF
	   ENDDO
	ENDIF

* is this a network data request based on a DODS URL?
	dods_url = INDEX(dset_name,'://') .GT. 0
	IF ( dods_url ) THEN
	   nocache = TM_HAS_STRING( dset_name, 'no cache' )
	ELSE
	   nocache = .FALSE.
	ENDIF
	IF ( nocache ) THEN
	   dlen = INDEX(dset_name,'(') - 1
	   IF (dlen .LE. 0 ) GOTO 5300
	   dlen = TM_LENSTR1( dset_name(:dlen) )	  ! length up to "(no cache)"
	ELSE
	   dlen = TM_LENSTR1( dset_name )
	ENDIF

* search for TMAP-formatted data set or NetCDF ?
* (ds_dset_type may have been set externally to 'CDF' already)
* 5/94: also recognize (e.g.) dods://dcz.gso.uri.edu/usr/data/gsc.nc
* 11/96: also recognize ".nc" (and insist that "cdf" be at the name end
* 7/97: Set explict_ext if there is an extension, and also check for
*       a .des extension.  
	IF ( dods_url ) ds_dset_type = 'CDF'
	IF ( dlen .GT. 2 ) THEN
	   IF (TM_HAS_STRING(dset_name(dlen-2:dlen), '.nc')) THEN
     		ds_dset_type = 'CDF'
	        explicit_ext = .TRUE.
	   ENDIF
	ENDIF
	IF ( dlen .GT. 3 ) THEN
	   IF (TM_HAS_STRING(dset_name(dlen-3:dlen), '.cdf')) THEN
     		ds_dset_type = 'CDF'
	        explicit_ext = .TRUE.
	   ENDIF
	   IF (TM_HAS_STRING(dset_name(dlen-3:dlen), '.des')) THEN
     		ds_dset_type = ' MC'
	        explicit_ext = .TRUE.
	   ENDIF
	   IF (TM_HAS_STRING(dset_name(dlen-2:dlen), '.mc')) THEN
     		ds_dset_type = ' MC'
	        explicit_ext = .TRUE.
	   ENDIF
	ENDIF
        IF ( ds_dset_type .EQ. 'CDF' ) THEN
           ext  = def_ext       ! default netCDF file extension
           path = cdf_path
        ELSE
           ext  = def_ext       ! default TMAP file extension
           path = cdf_path
        ENDIF
* if there is an explicit extension, we don't want to pass the default
* extension on, because the error messages are misleading *kob*
	IF ( explicit_ext ) ext = ' '    ! 7/97

* Find full file specification using INQUIRE with dset_name
* OS-independent path search
	IF ( dods_url ) THEN
	   des_name = dset_name
	   status = merr_OK
	ELSE
* 7/97 *kob* pass explicit_ext into tm_inq_path to indicate whether
*            or not an error message should be output in tm_path_list
           des_name = TM_INQ_PATH(dset_name,path,ext,explicit_ext,
     .                    status)
	ENDIF
	IF ( status .NE. merr_ok .AND. explicit_ext ) GOTO 9950
	IF ( status .NE. merr_ok) THEN
* interchange and try the other (.nc) extension
	   IF ( ext .EQ. def_ext ) THEN
	      ext  = def_cdf	! was .des
	      path = cdf_path
	      ds_dset_type = 'CDF'
	   ELSE
	      ext  = def_ext	! was .cdf
	      path = cdf_path
	      ds_dset_type = ' '
	   ENDIF
	   des_name = TM_INQ_PATH(dset_name,path,ext,.FALSE.,status)

* 4/02 *acm* try .des extension
	   IF ( status .NE. merr_ok ) THEN
	      ext  = def_des
	      path = tmap_sets
	      ds_dset_type = ' MC'
           ENDIF
	   des_name = TM_INQ_PATH(dset_name,path,ext,.FALSE.,status)

	   IF ( status .NE. merr_ok ) THEN
	      ext  = def_nc
	      path = tmap_sets
	      ds_dset_type = 'CDF'
           ENDIF
	   des_name = TM_INQ_PATH(dset_name,path,ext,.FALSE.,status)



* 7/97 *kob* check to see which error message should be output - don't
*            want to output same error message twice.
	   IF ( status .NE. merr_ok ) THEN

	      IF (status .EQ. merr_syntax .OR. status .EQ. merr_erreq) THEN
		 GOTO 9950
	      ELSE 
* 7/97 *kob* if file contains a path, only that path was searched, not all 
*            default paths
		 IF ( INDEX(dset_name,PathSeparator) .GT. 0 ) THEN
		    GOTO 5500
		 ELSE
		    GOTO 5400
		 ENDIF
	      ENDIF
	   ENDIF
	ENDIF

	IF (ds_dset_type .EQ. '  ') ds_dset_type = 'CDF'

* check to see if this descriptor has already been initialized
	IF (ok_re_use_existing) THEN
	   DO 100 set_cnt = 1, maxdsets
	      IF (nocache) THEN
* ... imperfect logic: "abcd(no cache)" will match "abc"
	         dlen2 = TM_LENSTR1(ds_des_name(set_cnt))
	         match = dlen2 .EQ. dlen
     .	           .AND. ds_des_name(set_cnt) .EQ. des_name(:dlen)
	      ELSE
	         match = ds_des_name(set_cnt) .EQ. des_name
	      ENDIF
	      IF ( match ) THEN
	         dset_num = set_cnt
	         status = merr_no_action
	         GOTO 9999
	       ENDIF
  100	   CONTINUE
	ENDIF

* Assign data set number, exiting if maximum number of data sets are open
	DO 110 set_cnt = 1,maxdsets
	  IF (ds_name(set_cnt) .EQ. char_init2048) THEN
	    dset_num = set_cnt
	    ds_des_name(dset_num) = des_name
            ds_name(dset_num) = TM_CLEAN_FILENAME( dset_name )
	    GOTO 120
	  ENDIF
  110	CONTINUE
* Too many data sets are open
	CALL TM_ERRMSG ( merr_dsetlim, status, 'TM_INIT_DSET',
     .			 no_descfile, no_stepfile,
     .			 'MAX='//TM_STRING(DBLE(maxdsets)),
     .			 no_errstring, *9950)

* netCDF file ?
 120    IF ( ds_dset_type .EQ. 'CDF' ) THEN
           ds_dset_type = ' '     ! reset the coaching shared by outside world
           CALL CD_INIT_DSET( dset_num, perm, tregular, use_strict,
     .				ok_share_taxis, status )
           IF ( status .NE. merr_ok ) GOTO 9900
           RETURN
        ENDIF

* Get free VMS logical unit # for temporary open
 	CALL LIB_GET_LUN (lunit)
        got_lun = .TRUE.

* Open descriptor file for reading
	OPEN   (UNIT		= lunit,
     .		FILE		= des_name,
#ifdef READONLY_ALLOWED
     .		READONLY,
#endif
     .		STATUS		= 'OLD',
     .		ERR 		= 5000)
        opened = .TRUE.
* record 1 - descriptor format record


	reading_nml = 'FORMAT_RECORD; or file not descriptor file'
	READ  (lunit, NML=FORMAT_RECORD, END=5100, ERR=5200)

* check to see if we know how to handle this data descriptor
	DO 130 tcnt = 1,num_known
          ic = STR_SAME(d_type, known_type(tcnt))
	  IF (ic .EQ. 0) THEN
             d_type = known_type(tcnt)
             GOTO 140
          ENDIF
  130	CONTINUE
	CALL TM_ERRMSG (merr_unktype, status, 'TM_INIT_DSET',
     .			dset_num, no_stepfile,
     .			'Type declared '//d_type,
     .			no_errstring, *9900)

  140	DO 150 rcnt = 1,num_revs
	DO 155 tcnt = 1,num_known
          ic = STR_SAME(d_format, format_rev(rcnt,tcnt))
	  IF (ic .EQ. 0 ) THEN
             d_format = format_rev(rcnt,tcnt)
             GOTO 160
          ENDIF
  155	CONTINUE
  150	CONTINUE
* ... des_name used as a buffer ...
	CALL TM_NOTE( 'BEWARE: Unrecognized descriptor format '//
     .		   d_format, lunit_errors ) 
!	WRITE (lunit_errors,1000) d_format, format_rev(1,tcnt)
! 1000	FORMAT(' Unrecognized descriptor format ',A4,'.'/
!     .	       ' Should be at least ',A4,'.'/
!     .	       ' Routines may not work correctly')

  160	ds_type(dset_num)         = d_type
	ds_format(dset_num)       = d_format
	ds_source_class(dset_num) = d_source_class
	ds_source(dset_num)       = d_source
	ds_subsource(dset_num)    = d_subsource
	ds_prog_rev(dset_num)     = d_prog_rev



* Initialize some BACKROUND variables
	d_mod_title = ' '
	d_ntuple    = 1
* 6/94 initialize d_time_modulo with .FALSE instead of 0 for IBM *kob*
	d_time_modulo = .FALSE.
	DO 170 cnt = 1,num_aux
  170	d_aux_modnum(cnt)    = ' '
	DO 180 cnt = 1,num_parm
  180	d_add_parm(cnt)      = ' '
	DO 190 cnt = 1,num_gridfiles
  190	d_grid_filename(cnt) = ' '


        d_caltype       = 'GREGORIAN'

	reading_nml = 'BACKGROUND_RECORD'
	READ  (lunit, NML=BACKGROUND_RECORD, END=5100, ERR=5200)

* Check for unsupported features
	IF (d_ntuple .NE. 1.) CALL TM_ERRMSG
     .		(merr_notsupport, status, 'TM_INIT_DSET',
     .		 dset_num, no_stepfile,
     .		 'D_NTUPLE in descriptor file must = 1',
     .		 no_errstring, *9900)

* Check for alternative allowed calendar names
         status = STR_UPCASE( risc_buff, d_caltype )
         IF (risc_buff(1:3) .EQ. '360') risc_buff = '360_DAY' 
         IF (risc_buff .EQ. 'STANDARD') risc_buff = 'GREGORIAN' 
         IF (risc_buff .EQ. 'PROLEPTIC_GREGORIAN') risc_buff = 'GREGORIAN' 
         IF (risc_buff(1:6) .EQ. 'COMMON') risc_buff = 'NOLEAP' 
         IF (risc_buff(1:3) .EQ. '365') risc_buff = 'NOLEAP' 
         IF (risc_buff(1:3) .EQ. '366') risc_buff = 'ALL_LEAP' 
	 d_caltype = risc_buff

	ds_expnum(dset_num)         = d_expnum
	ds_modnum(dset_num)         = d_modnum
	ds_title(dset_num)          = d_title
	ds_mod_title(dset_num)      = d_mod_title
	ds_forcing_set(dset_num)    = d_forcing_set
	ds_t0time(dset_num)         = d_t0time
	ds_time_unit(dset_num)      = d_time_unit
	ds_time_modulo(dset_num)    = d_time_modulo
	ds_ntegrate_tstep(dset_num) = d_ntegrate_tstep
	ds_ntuple(dset_num)         = d_ntuple
	ds_time_run(dset_num)       = d_time_run
        ds_cal_name(dset_num)       = d_caltype

	DO 200 aux_cnt = 1,num_aux
	  ds_aux_modnum(aux_cnt,dset_num)    = d_aux_modnum(aux_cnt)
  200	CONTINUE

* Break add_parm into parm_name and parm_text
	DO 210 parm_cnt = 1, num_parm
	  equal_pos = INDEX(d_add_parm(parm_cnt),'=')
	  IF (equal_pos .EQ. 0) THEN
	    IF (TM_LENSTR(d_add_parm(parm_cnt)) .GT. 0) THEN
	      ds_parm_name(parm_cnt,dset_num) = d_add_parm(parm_cnt)
	      ds_parm_text(parm_cnt,dset_num) = ' '
	    ELSE
	      ds_parm_name(parm_cnt,dset_num) = ' '
	      ds_parm_text(parm_cnt,dset_num) = ' '
	    ENDIF
	  ELSE
	    ds_parm_name(parm_cnt,dset_num) = 
     .			d_add_parm(parm_cnt)(1:equal_pos-1)
	    ds_parm_text(parm_cnt,dset_num) =
     .			d_add_parm(parm_cnt)(equal_pos+1:)
	  ENDIF
  210	CONTINUE

* Read in any gridfiles associated with data set
	DO 220 grd_cnt = 1,num_gridfiles
	  IF (d_grid_filename(grd_cnt) .NE. ' ') THEN
	    CALL TM_READ_GRIDFILE(d_grid_filename(grd_cnt),status)
	    IF ( status .EQ. merr_no_action ) GOTO 220
	    IF ( status .NE. merr_ok) GOTO 9900
	  ENDIF
  220	CONTINUE

* Call specific _INIT_DSET's now
	IF (d_type .EQ. '  GT') THEN

#ifdef double_p
	GOTO 5600
#endif
	  CALL GT_INIT_DSET(dset_num, lunit, status)
	  IF (status .NE. merr_ok) GOTO 9900
	  CALL TM_MAKE_4D_GRIDS(dset_num, status)
* ... bump the use counts on grids and axes used by variables in this data set
	  CALL TM_DSET_USE_GRIDS( dset_num )
	ELSE IF (d_type .EQ. '  TS') THEN

#ifdef double_p
	GOTO 5600
#endif
	  CALL TS_INIT_DSET(dset_num, lunit, status)
	  IF (status .NE. merr_ok) GOTO 9900
	  CALL TM_MAKE_4D_GRIDS(dset_num, status)
* ... bump the use counts on grids and axes used by variables in this data set
	  CALL TM_DSET_USE_GRIDS( dset_num )
!*kob*
	ELSE IF (d_type .EQ. '  MC') THEN
	  CALL MC_INIT_DSET(dset_num, lunit, perm, tregular, 
     .      use_strict, status)
	  IF (status .NE. merr_ok) GOTO 9900
	  CALL TM_MAKE_4D_GRIDS(dset_num,status)
* 1/00 - need to do this for remote mc aggregations
	  CALL TM_DSET_USE_GRIDS( dset_num )
	ENDIF
!	IF (d_type .EQ. '  MG') CALL MG_INIT_DSET(dset_num, lunit, status)
!	IF (d_type .EQ. '  MT') CALL MT_INIT_DSET(dset_num, lunit, status)
	IF (status .NE. merr_ok) GOTO 9900

* success
	GOTO 9990

* errors
 5000	CALL TM_ERRMSG (merr_erreq, status, 'TM_INIT_DSET',
     .			dset_num, no_stepfile,
     .			no_errstring, no_errstring, *9900)

 5100	CALL TM_ERRMSG (merr_nmlerr, status, 'TM_INIT_DSET',
     .			dset_num, no_stepfile,
     .			'Didn''t find: '//reading_nml,
     .			no_errstring, *9900)

 5200	CALL TM_ERRMSG (merr_nmlerr, status, 'TM_INIT_DSET',
     .			dset_num, no_stepfile,
     .			'Error in: '//reading_nml,
     .			no_errstring, *9900)

 5300	CALL TM_ERRMSG (merr_syntax, status, 'TM_INIT_DSET',
     .			dset_num, no_stepfile,
     .			dset_name,
     .			no_errstring, *9900)

 5400	risc_buff = dset_name
        IF (ok_re_use_existing) THEN
 	   CALL TM_ERRMSG (merr_notmounted, status, 'TM_INIT_DSET',
     .			unspecified_int4, no_stepfile,
     .			'Searched $FER_DESCR and $FER_DATA for '
     .                  //risc_buff(:TM_LENSTR1(risc_buff))//
     .                  '('//def_ext//','//def_cdf//','//def_des//')',
     .			no_errstring, *9950)
        ELSE
 	   CALL TM_ERRMSG (merr_notmounted, status, 'TM_INIT_DSET',
     .			unspecified_int4, no_stepfile,
     .			'Searched $FER_DESCR and $FER_DATA for '
     .                  //risc_buff(:TM_LENSTR1(risc_buff))//
     .                  '('//def_ext//','//def_cdf//','//def_des//
     .                  '). For a Timeseries aggregation, specify the '//
     .                  'NetCDF file/path names or OPeNDAP dataset names.',
     .			no_errstring, *9950)
        ENDIF

 5500	risc_buff = dset_name
	CALL TM_ERRMSG (merr_notmounted, status, 'TM_INIT_DSET',
     .			unspecified_int4, no_stepfile,
     .			risc_buff(:TM_LENSTR1(risc_buff))
     .                  //'('//def_ext//','//def_cdf//',.nc)',
     .			no_errstring, *9950)

 5600	CALL TM_ERRMSG (merr_notsupport, status, 'TM_INIT_DSET',
     .			dset_num, no_stepfile,
     .		'Dataset type not supported for double-precision Ferret '
     .			//dset_name,
     .			no_errstring, *9900)

* get out from error
 9900	CALL TM_CLOSE_SET ( dset_num, istat )
 9950	dset_num = unspecified_int4

* get out
 9990	IF ( opened ) CLOSE (UNIT = lunit)
	IF ( got_lun) CALL LIB_FREE_LUN (lunit)
 9999	RETURN
	END

	SUBROUTINE LEV
C** 
C**    @(#)lev.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
	INCLUDE 'CMRDL.INC'
	INCLUDE 'parampl5_dat.decl'
	INCLUDE 'PARAMPL5.DAT'
	INCLUDE 'cont_inc.decl'
	INCLUDE 'CONT.INC'
	INCLUDE 'shade_vars.cmn'


	CHARACTER PRSE*2048

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*       *jd* rename variable IF to INTIF for MAC 7.92
* 	*jd* 5.6.96 Add code to fix bug in specification of levels
*	where level should be zero but round off error results in near but
*	non zero value.
* v552 *acm* 3/03 Longer strings: changes for multi-line labels.
* v581 *acm* 3/05 open levels (-INF) (INF)
* V600 *acm* 8/05 Fix bug 1335: move the initialization of LWGT(j) = 2 to 
*                 before the possible resetting of zlev if posinf true.
* V603 *acm* 7/07 As done in plotz.F, use TM_FPEQ to compare zlev(i) to 0.,
*                 within machine accuracy.
* V608 *acm*10/07 The above fix refered to TM_FPEQ( ABS(ZLEV(I)) ,0.) ) 
*                 It should be ZLEV(I). Fixes bug 1546.
* V610 *acm* 3/08 - add new MODE NLEVELS; default number of levels is now 40
* V630  *acm* 9/09 Introduction of syntax for variance-based and histogram levels
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus
* V685 *acm* 7/13 Ticket 1990: fixes for number of digits. More precision needed 
*                 (Lavelle examples) 
* v686 *acm* 1/14 Fix ticket 2123: labeling color bar when there is just one level
* v686 *acm* 2/14 Fix ticket 2124: Do the above fix only in the subroutine KEY.
* v692 *acm* 7/14 For centered key labels add a level to corresp to the upper bound
*                 of the top color on thecolorbar, excluding the inf triangle.
* V697 *acm* 12/15 Fix ticket 2326: single level plus (inf) and/or (-inf)

	parameter	(epsilon = 1e-6)


	DIMENSION VAL(4),INTIF(4)
        INTEGER ntop
        LOGICAL   TM_FPEQ_SNGL

C Initialize

	DO i = 1, ICNLEV
	   ZLEV(i) = 0
	   LDIG(i) = 0
	   LWGT(i) = 0
	   LCLR(i) = 0
	ENDDO

	IF(LABEL.EQ.' ')THEN
	    NLEV=NLEV_DFLT
	    IAUTOC=1
	    GOTO 10
	ENDIF
	CALL UPPER(LABEL,2048)
C
C	BEGIN PARSE
C
        posinf = .FALSE.
        neginf = .FALSE.

        ISTP=-1
	IREL=0
200	LABEL=LABEL(ISTP+2:)
	IST=INDEX(LABEL,'(')+1
	ISTP=INDEX(LABEL,')')-1
	IF(IST.EQ.1)GOTO 10
	IF(ISTP.EQ.-1)THEN
	    CALL CMDERR(10,STRING,ISLEN,LBSTRT+IREL+IST-2)
	    GOTO 10
	ENDIF
	PRSE=LABEL(IST:ISTP)
	DO 11 I=1,4
	VAL(I)=0.0
11	INTIF(I)=0
	CALL LEVPRS(PRSE,VAL,INTIF,IER,IPOS)
	IERR=LBSTRT+IREL+IST+IPOS-2
	IF(IER.NE.0)THEN
	    CALL CMDERR(IER,STRING,ISLEN,IERR)
	    RETURN
	ENDIF
	IREL=IREL+ISTP+1
	CALL LEVSET(IST,VAL,INTIF,LWGH,NL)
C
C	TEST
C
	IF(LWGH.EQ.0)THEN
	    IF(IAUTOC.EQ.1)NLEV=0
	    IAUTOC=0
C
C	SET CONTOUR LEVELS
C
	    IF(INTIF(1).EQ.0)THEN
		IAUTOC=1
		NLEV=NLEV_DFLT
		GOTO 200
	    ENDIF
	    IF(INTIF(3).EQ.1.AND.VAL(3).EQ.0.)THEN
		DZ=(ZLEV(NLEV)-ZLEV(1))*0.00001
		DO 500 I=1,NL
		Z=VAL(1)+(VAL(2)-VAL(1))*(I-1)
		DO 510 J=1,NLEV
		IF(ABS(Z-ZLEV(J)).LE.DZ)THEN
		    CALL DELLEV(J)
		    GOTO 500
		ENDIF
510		CONTINUE
500		CONTINUE
	    ELSE
C
C	CREATE NEW LEVELS
C
		IF(NLEV+NL.GT.ICNLEV)THEN
		    CALL CMDERR(11,STRING,ISLEN,IERR)
		    RETURN
		ENDIF
		
		DO 100 I=1,NL
		J=NLEV+I

                LWGT(J)=2

                IF (J.GT.1 .AND. posinf) THEN
                   zlev(j) = zlev(j-1) + 1.
                ELSE 
                   ZLEV(J)=VAL(1)+VAL(3)*(I-1)
CC		Bug fix for non zero levels that ought to be zero *jd*
		   IF (ABS(ZLEV(J)) .LT. EPSILON*ABS(VAL(1))) ZLEV(J)=0.0	
                   IF ( TM_FPEQ_SNGL( ABS(ZLEV(J)) ,0.) ) GOTO 100
                ENDIF

		IF(ZLEV(J).GT.0)THEN
		   LWGT(J)=1
	        ELSE
		   LWGT(J)=3
		ENDIF

100		CONTINUE

C
C	FIND MIN AND MAX
C
		ZMIN=ZLEV(1)
                IF (neginf) ZMIN = ZLEV(2)
		ZMAX=ZMIN
                ntop = nlev+nl
                IF (posinf) ntop = ntop - 1
		DO 110 I=2,ntop
		IF(ZLEV(I).GT.ZMAX)ZMAX=ZLEV(I)
		IF(ZLEV(I).LT.ZMIN)ZMIN=ZLEV(I)
110		CONTINUE

                IF (neginf) zlev(1) = zmin - 1.

		DZ=ZMAX-ZMIN
		IF(DZ.EQ.0.)DZ=ABS(ZMAX)
		IF(DZ.EQ.0.)DZ=10000.0
		JJ=NSIGC-IFIX(ALOG10(DZ)+0.5)
		IF(JJ.LE.0) THEN
		   IF (NSIGC .LT. 0) THEN
		     JJ=nsigc+1
		   ELSE
		     JJ = -1
		   ENDIF
		ENDIF
		DO 120 I=1,NL
		J=NLEV+I
		LCLR(J)=0
		IF(INTIF(4).EQ.1)THEN
		    LDIG(J)=VAL(4)
		ELSE
		    IF(ZLEV(J).EQ.0)THEN
			LDIG(J)=-1
		    ELSE
			LDIG(J)=JJ
		    ENDIF
		ENDIF
120		CONTINUE
		NLEV=NLEV+NL
C
C	SORT
C
		CALL LEVSRT
C
C	CHECK FOR DUPLICATE LEVELS?
C
		DZ=DZ*0.00001
		I=1
		IF(NLEV.LE.1)GOTO 330
320		J=I+1
325		IF(ABS(ZLEV(I)-ZLEV(J)).LE.DZ)THEN
		    CALL DELLEV(I)
		ENDIF
		J=J+1
		IF(J.LE.NLEV)GOTO 325
330		I=I+1
		IF(I.LT.NLEV)GOTO 320
	    ENDIF
	ELSE IF(LWGH.EQ.5)THEN  ! DELETE a level
	    DZ=(ZLEV(NLEV)-ZLEV(1))*0.00001
	    DO 600 I=1,NL
	    Z=VAL(1)+VAL(3)*(I-1)
	    DO 610 J=1,NLEV
	    IF(ABS(Z-ZLEV(J)).LE.DZ)THEN
		CALL DELLEV(J)
		GOTO 600
	    ENDIF
610	    CONTINUE
600	    CONTINUE
	ELSE
	    IF(IAUTOC.EQ.1)GOTO 10
C
C	SET WEIGHTS
C
	    DZ=(ZLEV(NLEV)-ZLEV(1))*0.00001
	    DO 400 I=1,NL
	    Z=VAL(1)+VAL(3)*(I-1)
	    DO 410 J=1,NLEV
	    IF(ABS(Z-ZLEV(J)).LE.DZ)THEN
		IF(LWGH.EQ.4)THEN
		    LCLR(J)=VAL(4)
		ELSE
		    LWGT(J)=LWGH
		ENDIF
		GO TO 400
	    ENDIF
410	    CONTINUE
400	    CONTINUE
	ENDIF
	GOTO 200
10	CONTINUE

	RETURN
	END

*
* matlab.F
*
* Joe Sirott
*
*


*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )


      SUBROUTINE matlab_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,'test of MATLAB (3D Surface visualization)')

      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance(id, ABSTRACT, 
     .     NORMAL, NORMAL, NORMAL)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'X')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'Variable to plot')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END



      SUBROUTINE matlab_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*     You could use utility functions at this point to get 
*     context information about the other arguments.  This info 
*     could be used to update the custom or abstract axis lo and hi
*     indices.

      call ef_set_axis_limits(id, X_AXIS, 1, 1)


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END



* In this subroutine we compute the result
*
      SUBROUTINE matlab_compute(id, arg_1, result)

C ACM  xmem_subsc.cmn change to EF_mem_subsc.cmn'

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'
      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

C ACM  change m1lox to mem1lox, etc.

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .     mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL result(mem10lox:mem10hix, mem10loy:mem10hiy, 
     .     mem10loz:mem10hiz, mem10lot:mem10hit)

* TODO -- what if coord length is greater than these values??

C ACM  call ef_get_coordinates with REAL*8 arrays to get coord values

      REAL*8 xcoords(8192), ycoords(8192)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l
      INTEGER i1, j1, k1, l1, xsize,  ysize

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      CALL ef_get_coordinates(id, ARG1, X_AXIS, 
     1       arg_lo_ss(X_AXIS, ARG1), arg_hi_ss(X_AXIS, ARG1), xcoords ) 

      CALL ef_get_coordinates(id, ARG1, Y_AXIS, arg_lo_ss(Y_AXIS, ARG1),
     1        arg_hi_ss(Y_AXIS, ARG1), ycoords ) 

      xsize = arg_hi_ss(X_AXIS, ARG1) - arg_lo_ss(X_AXIS, ARG1) + 1
      ysize = arg_hi_ss(Y_AXIS, ARG1) - arg_lo_ss(Y_AXIS, ARG1) + 1

      i1 = arg_lo_ss(X_AXIS,ARG1)
      DO i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            DO k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               l1 = arg_lo_ss(T_AXIS,ARG1)
               DO l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
                  result(i,j,k,l) = 0
                  l1 = l1 + arg_incr(T_AXIS,ARG1)
               END DO
               k1 = k1 + arg_incr(Z_AXIS,ARG1)
            END DO
            j1 = j1 + arg_incr(Y_AXIS,ARG1)
         END DO
         i1 = i1 + arg_incr(X_AXIS,ARG1)
      END DO
      call matlab_demo(arg_1, xcoords, xsize, ycoords, ysize, 
     1      bad_flag(1))
     
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	subroutine datapt(xlow,ylow,xhigh,yhigh,xlplot,ylplot, 
     1	xhplot,yhplot,xp,yp,zp,npts,imark,forml,hgtlab) 
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)datpt.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
c 
c     this routine posts data points xp(k),yp(k),zp(k),k=1,npts 
c     on a plot.  complot routines size,scale,tktype etc. should 
c     have already been called. 
c 
c     xlow,ylow:   the lower left corner of the plot in user units 
c     xhigh,yhigh: upper right corner in user units 
c     xlplot,ylplot:lower left corner of plot in inches. 
c     xhplot,yhplot:upper right corner of plot in inches. 
c     xp:          array containing x coordinates of data pts. 
c     yp:          array containing y coordinates. 
c     zp:          array containing z coordinates (this value is posted) 
c     npts:        number of data points to be posted. 
c     imark:       mark type. see complot documentation. 
c     forml:       format to be used for the data pt label. 
c                  example: (f10.3). label can be up to 30 chars long. 
c     hgtlab:      height of the label in inches. use 0.0 for no label. 
c 
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 

	dimension xp(npts),yp(npts),zp(npts)
	character label*81,forml*(*) 
 
c     statement functions: 
	xloc(a)=(a-xlow)*xfact+xlplot 
	yloc(a)=(a-ylow)*yfact+ylplot 
 
	xfact=(xhplot-xlplot)/(xhigh-xlow) 
	yfact=(yhplot-ylplot)/(yhigh-ylow) 
 
	do 500 jpt=1,npts 
	xinch=xloc(xp(jpt)) 
	yinch=yloc(yp(jpt)) 
 
	if(imark.le.0)go to 100 
	call plot(xinch,yinch,0,0) 
	call mark(imark) 
 
100	if(hgtlab.le.0.0)go to 500 
	read(label,forml)zp(jpt)
	nchar=lnblk(label,81)
	width=symwid(hgtlab,nchar,label) 
 
	ybias=0.08 
c        if no mark is specified then center the label 
c        on the data point: 
	if(imark.le.0)ybias=-0.5*hgtlab 
	if(yinch+ybias.le.ylplot)ybias=ylplot-yinch+0.08 
	if(yinch+ybias+hgtlab.ge.yhplot)ybias=-hgtlab-0.08 
 
	xbias=-0.5*width 
	if(xinch+xbias.le.xlplot)xbias=xlplot-xinch+0.08 
	if(xinch+xbias+width.ge.xhplot)xbias=xhplot-xinch-width-0.08 
 
	call symbel(xinch+xbias,yinch+ybias,0.0,hgtlab,nchar,label) 
 
500	continue 
 
	return 
	end 

	SUBROUTINE INIT_EF_AGGREGATE_DSET (memb_dsetname_var,
     .	   nsets, have_expr, dname, dpath, dtitle, agg_dset, 
     .     agg_quiet, agg_hide, agg_dim, status )
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* initialize a new ensemble (E) or forecast (F) aggregated dataset
* Aggregation member variables may be a blend of file variables and LET/D vars
* Since the user may alter LET/D definitions after the aggregation has been
* defined, the following approach is taken to processing:
*  1) during DEFINE DATA/AGG the grids of all member variables are determined
*     This means that IS_UVAR_GRID is called for LET/D vars.
*     These grid numbers are stored in the aggregation LIST structures
*     The grids of the variables in the aggregated (parent) dataset are also
*     determined and stored in ds_grid_number as if they are file variables.
*     These grids are "static" as with file variables -- always valid. 
*  2) (TBD as of this writing!!!)==> the use counts of *all* member grids are
*     bumped, so that they cannot be deleted, even if LET/D definitions change
*  3) (TBD as of this writing!!!)==> at get_grid time all of the components
*     of the aggregation are checked to
*     ensure they have a grid (IS_UVAR_GRID) -- allowing for last-minute
*     LET/D var changes
*  4) during evaluation (in IS_STRIP and IS_AGGREGATE_GATHER) the variable
*     name and member dataset number are used to make a fresh determination of
*     the variable category and grid.  Error out if grid number has changed

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP 
*
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V685 4/13 *acm* Ability to define ensemble with /HIDDEN
*                 Get grid of user-vars, allow more combinations with user vars
*                 better error handling.
* V695 2/15 *acm* Aggregation in either E or F direction, as defined by agg_dim
* V695+ 5/15 *sh* Call GET_AXIS_SPEEDS (pulled out of CHECK_MEMBER_DSETS)
* V695+ 10/15 *sh* rename this routine to INIT_EF_AGGREGATE_DSET
* V698 12/15 *sh* reorganization of code in order to accommodate:
*		  checks of uvar grids delayed until eval
*	          allow for LET/D def changes after DEFINE/AGG (hopefully)
*		  allow dataset list passed as a Ferret string variable
*                 allow forecast datasets out of order (sort em)
*		  allow gaps in the forecast series (insert dummy datasets)
* V698 1/16  *sh* pass explicit path name (for "USE file.agg" compatibility)
*      2/16  *sh* automatically xfer attributes from member vars to agg vars
*      3/16  *sh* trap simple invalid commands
*                 start TBOXLO[L=1], not TBOX[L=1], of tf_lag_t axis at 0.0 
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.

* arguments:
*	memb_dsetname_var - if have_expr, the variable of names (input)
*	nsets		- number of datasets in the aggregation (input)
*       have_expr	- flag if filenames were listed or in an expr (input)
*	dname		- dataset name to assign to the aggregation (input)
*	dpath		- dataset path name to assign to aggregation (input)
*	dtitle		- dataset title (input)
*	dset_num	- number assigned to this data set (output)
*       agg_quiet       - flag whether to report certain conditions (input)
*	agg_hide        - flag whether to hide the component datasets (input)
*	agg_dim		- axis of the aggregation (E or F) (input)
*	status		- return status (output)

      IMPLICIT NONE
	include 'netcdf.inc'
        include 'tmap_errors.parm'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xdset_info.cd_equiv'
	include 'xunits.cmn_text'
        include 'xprog_state.cmn'
	include 'xtm_grid.cmn_text'  
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xfr_grid.cmn'

* calling argument declarations:
	CHARACTER*(*)	dname, dpath, dtitle
	INTEGER		nsets, agg_dset, agg_dim, status
	LOGICAL		have_expr, agg_quiet, agg_hide
	REAL		memb_dsetname_var(*)

* parameter definitions
	INTEGER	pmaxgaps, pmaxvarsperset
	PARAMETER (pmaxgaps = 10,
     .		   pmaxvarsperset = 400)

* local variable declarations:
	LOGICAL	OK_AS_AGG_VAR, ITSA_TRUEMONTH_AXIS, match, has_uvars
	INTEGER	TM_LENSTR, TM_LENSTR1, STR_SAME,
     .		NCF_ADD_AGG_MEMBER, KNOWN_GRID,
     .		iset, dset1, item, ii, nT, max_str_len,
     .		perm(nferdims), member_sets(nsets+pmaxgaps),
     .		imatch, nv, grid, igrid, idim, ivar, nvars, nuvars, iline, 
     .		slen, memb_var, memb_dset, memb_grid, ugrid, nsets_wgaps,
     .		type, fvar, ndims, ngatts, recdim, varid, attoutflag,
     .          tf_lag_t, memb_tax,
     .		ref_grid, ref_fvar, ref_fvars(pmaxvarsperset),
     .		num_indices, j, jj, ignored_status
	CHARACTER buff*64, tcoordname*16
	CHARACTER TM_STRING*13
	CHARACTER*512 GET_STRING_ELEMENT_1D_X, memb_dsetname(nsets)
	CHARACTER*128 vname
	REAL*8  TM_WORLD, avg_lag

* initialize
	tf_lag_t = unspecified_int4  ! lag time axis if FMRC
	max_str_len = 512
	nsets_wgaps = nsets
	DO iset = 1, nsets+pmaxgaps
	   member_sets(iset) = pdset_dummy
	ENDDO

* must have at least two datasets for an F aggregation
	IF (agg_dim.EQ.F_dim .AND. nsets.LT.2) GOTO 5050

* check to see if this new dataset name matches an already-open dataset name.
* if so, thats an error
	DO iset = 1, maxdsets
           match = ds_name(iset) .EQ. dname
           IF ( match ) GOTO 5100
	ENDDO

* set up array of dataset identifier strings
*   these may be string dataset numers or names,  pre-init'ed or not
	IF (have_expr) THEN
*  ... dataset list passed through a string variable
	  DO iset = 1, nsets
	    memb_dsetname(iset) = GET_STRING_ELEMENT_1D_X(
     .			nsets,
     .                  memb_dsetname_var,iset,
     .			max_str_len,slen )
	  ENDDO
	ELSE
*  ... dataset names given by user on command line
	  DO iset = 1, nsets
	    memb_dsetname(iset) = cmnd_buff(item_start(iset):item_end(iset))
	  ENDDO
	ENDIF

* See if requested datasets are open and if not, try to open them.
	CALL CHECK_MEMBER_SETS (agg_dim, nsets, memb_dsetname,
     .				member_sets, status)
	IF (status .NE. ferr_ok) GOTO 9950

* forecast aggregation datasets may need to be sorted and gaps detected
	IF (agg_dim .EQ. f_dim) THEN
	   CALL SORT_FMRC_DSETS (nsets, member_sets, nsets+pmaxgaps,
     .				 nsets_wgaps, nT, status)
	   IF (status .NE. ferr_ok) GOTO 5000
	ENDIF

* Assign aggregate data set number, exiting if maximum number 
* of data sets are open
	DO iset = 1,maxdsets
	  IF (ds_name(iset) .EQ. char_init1024) THEN
	    agg_dset = iset
	    GOTO 220
	  ENDIF
	ENDDO
* ... too many data sets are open
	CALL TM_ERRMSG ( merr_dsetlim, status, 'INIT_EF_AGGREGATE_DSET',
     .			 no_descfile, no_stepfile,
     .			 'MAX='//TM_STRING(DBLE(maxdsets)),
     .			 no_errstring, *9950)
 220	CONTINUE

* Create datset. Will delete it later if there are no aggregate variables found
* Note: the pattern will the first dataset given.  They may get reordered.
	CALL CREATE_AGG_DSET (agg_dset, dname, dpath, dtitle,
     .			 nsets_wgaps, member_sets(1), agg_dim, iline, status)  
	IF (status .NE. ferr_ok) GOTO 5300

* perform initializations needed on a new dataset
* determine relative access speeds along each axis
	CALL GET_AXIS_SPEED( agg_dset )

* 1st member dset sets pattern for all to follow
	dset1 = member_sets(1)

* If this is a Forecast aggregation create name for the 2D time array
* Make it unique as necessary by adding trailing "_" chars
	IF (agg_dim.EQ.f_dim) THEN
	   tcoordname = 'TF_TIMES'
	   slen = 8
 250	   CONTINUE
	   DO ivar = 1, maxvars
	      IF (ds_var_setnum(ivar) .EQ. dset1) THEN
	         IF ( STR_SAME(tcoordname,ds_var_code(ivar)) .EQ. 0 ) THEN
	            tcoordname = tcoordname(:slen)//'_'
	            slen = slen + 1
	            GOTO 250
	         ENDIF
	      ENDIF
	   ENDDO
	ELSE
	   tcoordname = ' '
	ENDIF

*****
* find variables that are acceptable for aggregation using dset1 as the basis
* an aggregatable var must have at least member dset that is an fvar - ref_fvar
* note LET/D names that duplicate file variable names take precedence, so
*     check them first
	nuvars = 0
!	DO nv = 1, max_uvar      ! brute-force equivalent loop
	CALL deleted_list_get_undel(uvar_num_items_head,
     .                              deleted_list_result(1),
     .                              max_uvar, num_indices )
	DO j = 1, num_indices
	   nv = deleted_list_result(j)
	   IF (uvar_dset(nv) .EQ. dset1) THEN
	      IF (OK_AS_AGG_VAR(nv, cat_user_var, dset1, member_sets,
     .		  nsets_wgaps, agg_dim, agg_quiet, ref_fvar, status)  ) THEN
	         nuvars = nuvars + 1
	         ref_fvars(nuvars) = ref_fvar
	      ELSE
	         IF (status .NE. ferr_ok) GOTO 5000
	      ENDIF
	   ENDIF
	ENDDO
	nvars = nuvars

* now find the file variables
	ref_grid = unspecified_int4
        DO nv = 1, maxvars
	   IF (ds_var_setnum(nv) .EQ. dset1) THEN
* ... skip it if it duplicates a name already found as a LET/D variable
	      DO ii = 1, nuvars
	         IF (STR_SAME(ds_var_code(ref_fvars(ii)),
     .			      ds_var_code(nv)           ) .EQ. 0) GOTO 300
	      ENDDO
	      IF (OK_AS_AGG_VAR(nv, cat_file_var, dset1, member_sets,
     .		  nsets_wgaps, agg_dim, agg_quiet, ref_fvar, status)  ) THEN
	         nvars = nvars + 1
	         ref_fvars(nvars) = ref_fvar
	      ELSE
	         IF (status .NE. ferr_ok) GOTO 5000
	      ENDIF
	   ENDIF
 300	   CONTINUE
	ENDDO
*****

* If no variables from the datasets match, delete this dataset. 
	IF (nvars .EQ. 0) GOTO 5500

* For forecast aggregations, the time axis of the aggregation 
* is not taken directly from the ensemble members.  Instead it
* is merely a lag axis -- number of time steps and lag per step
	IF (agg_dim .EQ. f_dim) THEN
	   ref_grid = ds_grid_number(ref_fvars(1))
	   IF (ref_grid .EQ. unspecified_int4) GOTO 5400
	   memb_tax = grid_line(t_dim, ref_grid)
	   avg_lag = ( TM_WORLD(nT, ref_grid, t_dim, box_middle )
     .	             - TM_WORLD(1,  ref_grid, t_dim, box_middle ) )
     .			/(nT-1)
	   CALL TM_NEW_LINE_NAME ( 'TF_LAG_T', buff )
! pre 3/16	   CALL TM_MAKE_BASIC_AXIS( buff, 0.0D0, avg_lag, nT,
* note that if the FMRC gets aggregated by the THREDDS Data Server this
* code never gets called.  See CD_SCAN_AUX_COORDS for that case.
* If the member axes are true-month axes, make the time axis of the 
* aggregation a daily axis, not true-month.
	   CALL TM_MAKE_BASIC_AXIS( buff, avg_lag/2., avg_lag, nT,
     .				    tf_lag_t, status )
	   line_unit_code(tf_lag_t) = line_unit_code(memb_tax)
	   IF (ITSA_TRUEMONTH_AXIS(memb_tax)) line_unit_code(tf_lag_t) = pun_day
	   line_units(tf_lag_t) = un_name(line_unit_code(tf_lag_t))
	   line_direction(tf_lag_t) = 'TT'
	   line_dattype  (tf_lag_t) = nf_double
	   line_dim_only (tf_lag_t) = .FALSE.  ! indicates netCDF dim w/out var
	ENDIF


* register the list of variables found suitable for this aggregation
	ii = 0
	nv = 0
	DO WHILE (ii .LT. nvars)
	   ii = ii + 1
	   nv = nv + 1! kludgy: incremented just below when TF_TIMES is added
	   ref_fvar = ref_fvars(ii)
	   vname = ds_var_code(ref_fvar)
	   grid = ds_grid_number(ref_fvar)
	   CALL DEFINE_EF_AGGREGATE_GRID (agg_dset, tcoordname, nv, vname,
     .					  ref_fvar, iline, tf_lag_t, grid,
     .					  agg_dim, member_sets, nsets_wgaps)
	   IF (status .NE. ferr_ok) GOTO 5000

* transfer to the aggregated variable whatever special attributes it inherits
	   CALL SET_AGG_VAR_ATTS(agg_dset, vname, nv, nsets_wgaps, 
     .			         ref_fvar, member_sets, status)
	   IF (status .NE. ferr_ok) GOTO 9960
	ENDDO

* register member datasets to aggregate dataset
	DO iset = 1, nsets_wgaps
	   status = NCF_ADD_AGG_MEMBER (agg_dset, iset, member_sets(iset)) 
	ENDDO
 
* remove duplicate temp grid definitions amd makegrid names unique
	CALL AGG_CLEAN_GRIDS(agg_dset, agg_dim, iline, tf_lag_t)

* set use counts and remove temp status of agg grids and axes
	CALL TM_GARB_COL_GRIDS(agg_dset)

* set the official time axis of the dataset
	CALL CD_GET_TIME_AXIS( agg_dset, t_dim, ignored_status )
	IF (ignored_status .NE. merr_ok) CALL WARN
     .					  ('INIT_EF_GET_TIME_AX crptn')

* If user requested /HIDE, then mark the member datasets for hidden status
	IF (agg_hide) THEN
 	   DO iset = 1, nsets_wgaps
	      ds_hide (member_sets(iset)) = .TRUE. 
	   ENDDO
	ENDIF

* successful completion
	RETURN

* error bail out
* remove all hidden member datasets of the failed aggregation
* ... this is a little brute force in that it may cancel a previously opened
* ... dataset included using DEFINE DATA/AGG/HIDE (havnt checked carefully)
 5000	DO ii = 1, nsets_wgaps
	   iset = member_sets(ii)
	   IF (iset .EQ. pdset_dummy
     .    .OR. iset .EQ. unspecified_int4) CYCLE
	   IF (ds_name(iset) .EQ. char_init1024) CYCLE ! already deleted
	   IF (ds_hide (iset)) CALL CANCEL_ONE_DATA_SET( iset, ignored_status )
	ENDDO
 6000	RETURN	

* Errors: too-many datasets open so aggregate dataset can't be opened,
* or error on a member dataset. 
* ?? If some member datasets were opened, close them??)
* Return no-dataset-number.

 9950	agg_dset = unspecified_int4
	status = ferr_TMAP_error
	GOTO 5000
* wipe out the partially-created aggregated dataset
 9960	CALL TM_PURGE_TMP_GRIDS(ignored_status)
	CALL TM_CLOSE_SET_COND_DEALLO( agg_dset, .FALSE., ignored_status )
	agg_dset = unspecified_int4
	GOTO 5000

 5050	CALL ERRMSG( ferr_invalid_command,status,
     .		'cannot F-aggregate a single member dataset', *6000 )

 5100   CALL ERRMSG( ferr_invalid_command,status,
     .		'dataset name already in use: '
     .		//dname(:TM_LENSTR1(dname)), *5000 )
     
 5300	CALL ERRMSG( ferr_aggregate_error, status, ' ', *9950 )


 5400	CALL ERRMSG( ferr_aggregate_error, status,
     .		'No time axis for aggregation',          *9960 )

 5500	CALL ERRMSG( ferr_aggregate_error, status,
     .		'No valid datasets or datasets share no variables. ', 
     .		*9960 )

	END

	SUBROUTINE GET_MAX_STRING_LEN_SUB(cx, grid_data, 
     .		lox, hix, loy, hiy, loz, hiz, lot, hit, 
     .		loe, hie, lof, hif, smax )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Return the length of the longest string in this context

* V530: 8/00 *sh*
* v554: 12/04 *acm* Get the shape of the region for the context of the data;
*                   these are the indices to use in looping through grid_data.
*                   (fixes bug 617, listing string and numeric data together)
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include 'tmap_dims.parm'
        include 'ferret.parm'
	include 'xcontext.cmn'

* calling argument declarations
	INTEGER  cx, smax, lox, hix, loy, hiy, loz, hiz, 
     .		 lot, hit, loe, hie, lof, hif
	REAL*8 grid_data( lox:hix,loy:hiy,loz:hiz,lot:hit,loe:hie,lof:hif )

* internal variable declarations:
	INTEGER  GET_C_STRING_LEN, GET_ONED_STRING_LEN_SUB, 
     .         i, j, k, l, m, n, ii, slen, 
     .         sslo(nferdims), sshi(nferdims),
     .         ndim, odim, lo, hi, cxperm(nferdims)

* initialize
	smax = 1

        CALL get_cx_dims (cx,ndim,cxperm)

        sslo(1) = cx_lo_s1(cx)
        sslo(2) = cx_lo_s2(cx)
        sslo(3) = cx_lo_s3(cx)
        sslo(4) = cx_lo_s4(cx)
        sslo(5) = cx_lo_s5(cx)
        sslo(6) = cx_lo_s6(cx)

        sshi(1) = cx_hi_s1(cx)
        sshi(2) = cx_hi_s2(cx)
        sshi(3) = cx_hi_s3(cx)
        sshi(4) = cx_hi_s4(cx)
        sshi(5) = cx_hi_s5(cx)
        sshi(6) = cx_hi_s6(cx)


* If it's 1-D the data may not have been permuted.  Just treat the 
* data as a true 1-D set of strings

	IF (ndim .EQ. 1) THEN
	ii = unspecified_int4
	   DO i = 1, 6
	      IF (sshi(i)-sslo(i) .GT. 0) THEN
	         lo = sslo(i)
	         hi = sshi(i)
	         ii = lo
	      ENDIF
	   ENDDO
	   IF (ii .EQ. unspecified_int4) THEN
	   DO i = 1, 6
	      IF (sshi(i) .NE. unspecified_int4) THEN
	         lo = sslo(i)
	         hi = sshi(i)
	         ii = lo
	      ENDIF
	   ENDDO
	   ENDIF
	ENDIF

	DO 100 n = sslo(cxperm(6)), sshi(cxperm(6))
	DO 100 m = sslo(cxperm(5)), sshi(cxperm(5))
	DO 100 l = sslo(cxperm(4)), sshi(cxperm(4))
	DO 100 k = sslo(cxperm(3)), sshi(cxperm(3))
	DO 100 j = sslo(cxperm(2)), sshi(cxperm(2))
	DO 100 i = sslo(cxperm(1)), sshi(cxperm(1))

	   IF (ndim.EQ.1) THEN
	      slen = GET_ONED_STRING_LEN_SUB( grid_data, lo,hi, ii )
	      ii = ii+1
	   ELSE
	      slen = GET_C_STRING_LEN( grid_data(i,j,k,l,m,n) )
	   ENDIF
	   IF ( slen .GT. smax ) smax = slen
           
 100	CONTINUE

	RETURN
	END
 

	REAL*8 FUNCTION SECS_FROM_BC( date, cal_id, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* return a REAL*8 number giving the number of seconds since 1-JAN-0000:00:00

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 4/7/88
* revision 0.1 1/18/89 - BREAK_DATE --> TM_BREAK_DATE
* V300: 2/93 - return **something** even if error exit (caught by f77 3.2)
* V530: *acm* 12/00 add calendar types; cal_id
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

        IMPLICIT NONE
* Calling argument declarations:
	INTEGER		cal_id, status
	CHARACTER*(*)	date

* Local variable declarations:
	INTEGER		year, month, day, hour, minute, second
	REAL*8		TM_SECS_FROM_BC

	include	'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'

* Break up the date string to it's various components

	CALL TM_BREAK_DATE ( date, cal_id,
     .			  year, month, day, hour, minute, second,
     .			  status )
	IF ( status .NE. ferr_ok ) THEN
           SECS_FROM_BC = -999
           RETURN               ! err not reported
        ENDIF

* Find the offset from 01-JAN-0000 00:00:00 for this date and calendar
	SECS_FROM_BC = TM_SECS_FROM_BC (cal_id, year, month, day,
     .				     hour, minute, second, status)

	IF ( status .NE. ferr_ok ) THEN
           SECS_FROM_BC = -999
           RETURN               ! err not reported
        ENDIF

	RETURN
	END

	SUBROUTINE PURGE_USER_VAR( uvar )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* eliminate all stored mrs for the given user defined variable

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 2/23/87
* revision 0.1 - 9/30/87 - added mr_perm_prot
* V200:  6/9/89 - deleted variables flagged in mr_protected
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V740: 1/18 *acm* for issue 1854, protection status temporarily reset 
*             for curvi-coord plot with /SET

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xvariables.cmn'

* calling argument declaration:
	INTEGER	uvar

* internal variable declarations:
	INTEGER	mr

	DO 100 mr = 1, max_mrs
	   IF ( mr_protected( mr ) .EQ. mr_deleted ) GOTO 100
	   IF ( mr_protected( mr ) .LT. mr_keep_flag ) GOTO 100

	   IF ( mr_variable ( mr ) .NE. uvar
     .	   .OR. mr_category ( mr ) .NE. cat_user_var ) GOTO 100

	   IF (  mr_protected( mr ) .NE. mr_not_protected
     .	   .AND. mr_protected( mr ) .NE. mr_perm_protected )
     .		STOP 'var prot err --> UVAR'

	   CALL DELETE_VARIABLE( mr )

 100	CONTINUE

	RETURN
	END

        SUBROUTINE TM_CHECK_BNDS_ATTRIB (dset, iaxis, vname, vlen, 
     .                                   bname, bndid, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* V570 5/2004 *acm*
* Check the bounds attribute, issue any warnings
* V600 *acm* 10/05 should not have npts as an argument; npts from cd_get_1_axis
*                  was being reset  as npts bounds or edges, which is npts+1
* V600 *ACM* attribute control. 
*             Replace NCVID with CD_GET_VAR_ID
*             Replace NCVINQ for variables, with CD_GET_VAR_INFO
*             Replace NCDINQ with CD_GET_DS_DIMS


	INCLUDE 'tmap_dims.parm'
        INCLUDE 'xtm_grid.cmn_text'
        INCLUDE 'xio.cmn_text'
        INCLUDE 'tmap_errors.parm'
        INCLUDE 'errmsg.parm'

* argument declarations

      INTEGER dset, iaxis, vlen, bndid, status
      CHARACTER*(*) bname, vname

* Local variable declarations
      LOGICAL coordvar
      INTEGER TM_LENSTR1
      INTEGER blen, soft_err, vartype, ivar, npts, 
     .        nvdims, vdims(8), nvatts, all_outflag
      CHARACTER*132 buff, vbuff

* does the bounds variable pointed to really exist ?
        blen = TM_LENSTR1(bname)
        CALL CD_GET_VAR_ID (dset, bname, bndid, status)

        IF (bndid .LE. 0) THEN
           soft_err = 21
           GOTO 6000
        ENDIF

* get the vital statistics of the bounds variable

        CALL CD_GET_VAR_INFO (dset, bndid, bname, vartype, 
     .            nvdims, vdims, nvatts, coordvar, all_outflag, status)

        IF ( nvdims .NE. 2 ) THEN
           soft_err = 22
           GOTO 6000
        ENDIF

* get axis length: 
        
        CALL CD_GET_DS_DIMS (dset, vdims(1), buff, npts, status)
        IF (status.NE.ferr_ok) GOTO 5100   ! should never happen

* check for error conditions: bounds is 2 by N
        IF ( npts .NE. 2 ) THEN
           soft_err = 23
           GOTO 6000
        ENDIF
        CALL CD_GET_DS_DIMS (dset, vdims(2), buff, npts, status)
        IF (status.NE.ferr_ok) GOTO 5100   ! should never happen

* check for error conditions: 2nd dimension of bounds is N
        IF ( npts .NE. line_dim(iaxis) ) THEN
           soft_err = 23
           GOTO 6000
        ENDIF

        status = merr_ok
        RETURN

* error messages

 6000   CALL TM_NOTE( 'netCDF bounds variable definition error', lunit_errors )
        buff = bname
        vbuff = vname
        IF ( soft_err .EQ. 21 ) THEN
           CALL TM_NOTE('Bounds definition "'//buff(:blen)//
     .                   '" points to no existing axis', lunit_errors )
        ELSEIF ( soft_err .EQ. 22 ) THEN
           CALL TM_NOTE('Bounds definition "'//buff(:blen)//
     .                   '" is not 2D', lunit_errors )
        ELSEIF ( soft_err .EQ. 23 ) THEN
           CALL TM_NOTE('Bounds "'//buff(:blen)//
     .          '" must be 2x dimension of '//vbuff(:vlen), lunit_errors )
        ENDIF
        CALL TM_NOTE( 'Ignoring BOUNDS attribute', lunit_errors )

        status = merr_ok + 1
        RETURN

 5100   status = pcdferr
        RETURN

        END

*
* samplem_multi.F
*
* Ansley Manke
* Dec 1998
*
* This function samples data along the L axis using a set of indices
* 4/5/99  Ansley Manke 
*         Indices may be oriented along any axis; 
*         Result is abstract on the sampled axis.
*
* 5/17  Make these functions 6-D.  Add E and F direction functions.
*       Reverse the order of argumnets to beconsistent with the
*       SAMPLEL etc functions. Fix the test for sample argument on 
*       different axis than the sample direction.
*

      SUBROUTINE samplem_multi_init(id)

      INCLUDE 'EF_Util.cmn'

     
* Local variable declarations
      INTEGER id, arg

      CHARACTER*100 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns data sampled according to M indices which ',
     . 'may be function of IJKLN')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 2)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, 
     .     ABSTRACT, IMPLIED_BY_ARGS)

      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'DAT_TO_SAMPLE')
      CALL ef_set_arg_desc(id, arg, 'data to sample using L indices')
      CALL ef_set_axis_influence_6d(id, arg, YES, YES, YES, YES, NO, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'M_INDICES')
      CALL ef_set_arg_desc(id, arg, 'ordered indices')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, NO, NO)

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.  
*

      SUBROUTINE samplem_multi_result_limits(id)

      INCLUDE 'EF_Util.cmn'
* Declarations
      INTEGER id
      INTEGER arg_lo_ss(6,EF_MAX_ARGS), arg_hi_ss(6,EF_MAX_ARGS),
     .     arg_incr(6,EF_MAX_ARGS)

* Local variable declarations
      INTEGER npts, idir, ndim
      CHARACTER*100 errtxt

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      npts = arg_hi_ss(E_AXIS, ARG2) - arg_lo_ss(E_AXIS, ARG2) + 1

* Count the dimensions in argument 2
      ndim = 0
      DO idir = X_AXIS, F_AXIS
         IF (arg_lo_ss(idir, ARG2) .NE. ef_unspecified_int4) THEN
	    ndim = ndim + 1
         ENDIF
      ENDDO

* If they sent in a simple list as the 2nd argument, it might not be 
* on the X axis. Allow that.

      IF (arg_lo_ss(E_AXIS, ARG2) .EQ. ef_unspecified_int4) THEN
         DO idir = X_AXIS, F_AXIS
	    IF (arg_lo_ss(idir, ARG2) .NE. ef_unspecified_int4) THEN
	       npts = arg_hi_ss(idir, ARG2) - arg_lo_ss(idir, ARG2) + 1
	    ENDIF
         ENDDO
	 IF (ndim .NE. 1) THEN
	    errtxt = 'Argument 2 has no E axis. When it has more than '//
     .               '1 dimension, E axis is the sample dimension.' 
	    GOTO 999
	 ENDIF

* If argument 2 is a multi-dimensioned variable, all but the sample dimension
* must match the grid of argument 1
      ELSE
         IF (ndim .GT. 1) THEN
         DO idir = X_AXIS, F_AXIS
	   IF (idir .EQ. E_AXIS) cycle
	   IF (arg_hi_ss(idir,ARG1)-arg_lo_ss(idir,ARG1) .NE. 
     .         arg_hi_ss(idir,ARG2)-arg_lo_ss(idir,ARG2) ) THEN
	      errtxt = 'Grid mismatch. Non-E dimensions of Arg 2 must be '//
     .               'conformable with grid of Arg 1' 
	      GOTO 999
	   ENDIF
         ENDDO
	 ENDIF
      ENDIF

      CALL ef_set_axis_limits(id, E_AXIS, 1, npts)
      RETURN
  999 CONTINUE

      CALL ef_bail_out(id, 'Argument 2 has no E axis. '//
     .  'If it has >1 dimension, E axis is the sample dimension.' )
 
      END
*
* In this subroutine we compute the result
*
      SUBROUTINE samplem_multi_compute(id, arg_1, arg_2, result)

      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

* Declarations
     
      INTEGER id
      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .      mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .     mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .     memresloz:memreshiz, memreslot:memreshit,
     .      memresloe:memreshie, memreslof:memreshif)


      INTEGER res_lo_ss(6), res_hi_ss(6), res_incr(6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS), arg_hi_ss(6,EF_MAX_ARGS),
     .     arg_incr(6,EF_MAX_ARGS)

     
* Local variable declarations
      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2
      INTEGER morder
      REAL aorder

      INTEGER nlen(3)
      CHARACTER*8 lefint, aindex(3)
      CHARACTER*100 errtxt

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)


      n1 = arg_lo_ss(F_AXIS, ARG1)
      n2 = arg_lo_ss(F_AXIS, ARG2)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS) 

      l1 = arg_lo_ss(T_AXIS, ARG1)
      l2 = arg_lo_ss(T_AXIS, ARG2)
      DO 500 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS) 

      k1 = arg_lo_ss(Z_AXIS, ARG1)
      k2 = arg_lo_ss(Z_AXIS, ARG2)
      DO 400 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS) 

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         j2 = arg_lo_ss(Y_AXIS,ARG2)
         DO 300 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            i1 = arg_lo_ss(X_AXIS,ARG1)
            i2 = arg_lo_ss(X_AXIS,ARG2)
            DO 200 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

               m2 = arg_lo_ss(E_AXIS,ARG2)
               DO 100 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

*  Get the index to sample, whichever axis of arg_2 it is on.

                  aorder = arg_2(i2,j2,k2,l2,m2,n2)
                  IF (m2 .EQ. ef_unspecified_int4) 
     .                  CALL pickindex(arg_2, m, aorder)
                  morder = aorder

*  Check that we do have an index of ARG_1; set the result

                  IF (aorder .EQ. bad_flag(ARG2)) THEN
                     result(i,j,k,l,m,n) = bad_flag_result
                  ELSE

                     IF (morder .LT. arg_lo_ss(E_AXIS,ARG1)  .OR.
     .                   morder .GT. arg_hi_ss(E_AXIS,ARG1) ) THEN
                        GO TO 999
                     ELSE

                        IF (arg_1(i1,j1,k1,l1,morder,n1) .EQ. bad_flag(ARG1)) THEN
                           result(i,j,k,l,m,n) = bad_flag_result
                        ELSE
                           result(i,j,k,l,m,n) = arg_1(i1,j1,k1,l1,morder,n1)
 
                        END IF
                     END IF
                  END IF

                  m2 = m2 + arg_incr(E_AXIS,ARG2)
 100           CONTINUE

               i1 = i1 + arg_incr(X_AXIS,ARG1)
               i2 = i2 + arg_incr(X_AXIS,ARG2)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
            j2 = j2 + arg_incr(Y_AXIS,ARG2)
 300     CONTINUE

         k1 = k1 + arg_incr(Z_AXIS,ARG1)
         k2 = k2 + arg_incr(Z_AXIS,ARG2)
 400  CONTINUE


         l1 = l1 + arg_incr(T_AXIS,ARG1)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
 500  CONTINUE


         n1 = n1 + arg_incr(F_AXIS,ARG1)
         n2 = n2 + arg_incr(F_AXIS,ARG2)
 600  CONTINUE

      RETURN 

999   CONTINUE

      aindex(1) = LEFINT(morder,nlen(1))
      aindex(2) = LEFINT(arg_lo_ss(T_AXIS,ARG2),nlen(2))
      aindex(3) = LEFINT(arg_hi_ss(T_AXIS,ARG2),nlen(3))

      WRITE (errtxt,*) 'Sampling index ', aindex(1)(1:nlen(1)), 
     . ' in ARG1 is outside the range of L indices for ARG2 (', 
     .  aindex(2)(1:nlen(2)), ':', aindex(3)(1:nlen(3)), ')'

      CALL EF_BAIL_OUT(id, errtxt)

      RETURN
      END

	BLOCK DATA XCOMMAND_DATA

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* command names, subcommands and qualifiers
* numbers of subcommands and qualifiers is determined by COMMON/XCOMMAND/
* see XCOMMAND.CMN for instructions on adding new options

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* !!!!!!!!!!
* Use caution when defining new commands:
* 1- Ferret commands are matched to the first 4 characters only. Make sure
*    new commands are unique to the first 4 characters.
* 2- If you are tempted to reorder the lists of commands or subcommands, know 
*    that users areprone to even more abbreviation. E.g. "can v" is used for 
*    "cancel viewport" all over the place, and that happens ONLY because "VIEWPORT" 
*    comes before "VARIABLE" in the subcommands for CANCEL.
* !!!!!!!!!!
*
* revision 0.0 - 3/20/86
* V200:   7/5/89 - added CANCEL VARIABLE
*	  9/1/89 - added CANC DATA/ALL,SET VAR and SET DATA/many_options
*	 1/22/90 - added USER command
*	  1/8/90 - added command aliases (LET and FILE)
*	 5/17/90 - added PLOT/SYMBOL and PLOT/LINE
*	  7/6/90 - added LIST/SINGLY
*	 8/29/90 - added LIST/EPKEY=EPIC_key_number
*	 8/31/90 - added SET MOVIE/START=
* Unix/RISC port - 2/91 - cant use "/star" in documentation
*		 - also fixed two doubly defined cells qualifiers()
*		   at nqual_at2o+1 and nqual_at10d+4
* V230: 1/3/92  - added SHOW TRANSFORMS
*       1/27/92 - added aliases QUIT, DATA, and REGION
*        6/8/92 - added CONTOUR/FILL/KEY/NOKEY/LINE
*                       WIRE
*                       DEFINE-SHOW-CANCEL ALIAS
*       6/19/92 - made alias names 8 characters
*       6/26/92 - added /RIGID to SET DATA/FORM=CDF
*        7/6/92 - added /DEPTH to DEFINE AXIS
*       8/25/92 - added /MODULO to DEFINE AXIS
*       11/4/92 - added /UNITS to DEFINE VARIABLE
*               - changed DEFINE VIEW/SIZE/ORIGIN/CLIP to /TEXT/XLIMITS/YLIMITS
*       12/2/92 - added /ZSCALE to the WIRE command
*       12/4/92 - restored /SIZE, /ORIGIN, and /CLIP to DEFINE VIEW
*       1/14/93 - changed SET MOVIE/APPEND to /COMPRESS
*        2/1/93 - added alias ANIMATE
* V300  3/11/93 - added alias SPECTRUM
*       5/24/93 - added qualifier CANC DATA/NOERROR
*       6/16/93 - added QUERY command and 2 new blank commands
* V301  10/22/93 - added /XLIMITS and /YLIMITS to PLOT command
*	11/03/93 - added DEFINE AXIS/NPOINTS
*	11/05/93 - changed QUERY/PIPE to QUERY/IGNORE (a NO-OP)
*	11/23/93 - added USER/FILE
*	12/8/93  - added VECTOR/XSKIP/YSKIP
*	 1/19/94 - added alias LABEL
*		 - and USER/FORMAT
*	 2/10/94 - added CONTOTUR/PEN, VECTOR/PEN, and LET/QUIET
* V310   4/11/94 - eliminated qualifier LIST/EPKEY -- use SAVE instead
*	    5/94 - added SET DATA/ORDER
* V320   4/11/94 - added SET MEMORY/SIZE=
*	 8/03/94 - added FRAME/FORMAT= and FRAME/FILE=
*	 8/05/94 - added SAVE/{XYZTIJKL}LIMITS=lo:hi
*	10/28/94 - added GO/HELP
*	 1/25/94 - added SAVE/TITLE="my title"
* V400	  2/6/95 - added SHOW SYMBOL
* V402	    7/95 - added DEFINE VAR/D, SHOW VAR/D, CANC VAR/D, SET VAR/D
* V420	 9/22/95 - added SHOW MEMORY/GRIDS
*	 9/29/95 - added LIST/precision=
*	 2/7/96  - added STAT/BRIEF
*	 4/23/96 - increased number of aliases from 30 to 150
* V450	11/14/96 - added LIST/CLOBBER
*	5/97	 - added /NOAXES to SHADE, PLOT, CONTOUR, and VECTOR
*       7/97     - added SHOW FUNCTIONS
*  *js* 7/98     - added SET DATA/TYPE and SET DATA/SWAP
* v491  12.98    - added PATTERN support *jd*
* v491  12.98    - added PATTERN alias *jd*
* V500  2/99 - *kob* - add /QUIET to LIST command
*       2/99 *sh* - added POLYGON command
*       3/99 *jd* - more qualifs for POLYGON and fixed num_qualifs bug for it
*       3/99 *jc* - added /INTERNAL to SHOW FUNCTION command
*       4/99 *sh* - added PAUSE alias
*	     *sh* - added DEFINE AXIS/EDGES and SHOW AXIS/X/Y/Z/T/E/F/IJ/K/L 
*	     *sh* - added SET AXIS/DEPTH
*	6/99 *sh* - added WHERE alias
* V510  3/00 *sh* - added SET DATA/REGULAR_T
*		  - added PLOT/COLOR=/THICKNESS=/SIZE=
*		  - added POLYGON/COLOR=/THICKNESS=
*		  - changed /PEN to /COLOR on CONTOUR and VECTOR
*		  - added VECTOR/THICK
*	5/00 *sh* - added DEFINE VARIABLE/BAD=
*	5/00 *sh* - added CANCEL GRID
*	5/00 *sh* - added /HLIMITS and /VLIMITS to graphics commands
*		  - added /DETAILED to SHOW FUNCTIONS and to MESSAGE
*	5/00 *sh* - restored /PEN as a "denigrated" command
* V520: 6/00 *sh* - added MESSAGE/ERROR
* V530: 10/00 *sh* - added added SET DATA/EZ  /TYPE=/DELIMITERS=
*      10/00 *acm* - added VECTOR/FLOWLINE (alias FLOWLINE)
*      1 /01 *sh* - added PLOT/STEP[=connected]
*       1/01 *acm* - added DEFINE AXIS/CALENDAR qualifier
*       5/01 *acm* - added PLOT/DASH[=(dn1,up1,dn2,up2) qualifier
*       1/01 *acm* - added /CALENDAR qualifier
* V531: 5/01 *kob* - replace old ANIMATE alias which spawned a call
*	             to what must be the now-defunct xds with new 
*		     animate alias which uses internal double buffering
* V533: 6/01 *sh* - added SET VARIABLE/NAME=
*            *acm* - added PLOT/VLOG, PLOT/HLOG: plot qualifiers to set log,
*                    inverse log axes and log depth axes.
*       7/01 *acm* - added /AXES[=TOP,BOTTOM,LEFT,RIGHT]  for 
*		     PLOT, CONTOUR, POLYGON, SHADE, VECTOR.
*       8/01 *kob* - add LOOP, PROMPT, SCRIPT, PROGRAM qualifiers 
*                    to EXIT command
* V540: 9/01 *sh* - added DEFINE VIEWPORT/AXES
*	10/01 *sh* - added alias COLUMNS for SET DATA/FORMAT=Delimited
*	11/01 *sh* - added list/width=
* V541: 4/02 *acm* - remove CONTOUR/HLOG/VLOG; mistakenly put in here!!
*                    note they were not used by xeq_contour...
* V541: 5/02 *acm* - add VECTOR/NOKEY
*       6/02 *acm* - add CANCEL AXIS/ALL
* V552: 4/02 *acm* - add SET VARIABLE/SCALEFAC/OFFSET
* V553: 7/03 *acm* - add SHOW DATA/XML for DAS, DDS output
* V553: 7/03 *acm* - add SHOW AXIS/XML 
* V553: 9/03 *acm* - add SHOW AXIS/DODS for binary output of axis coordinates
*                       also needs /FILE=  and /APPEND
* V554: 10/03 *acm* - add SHOW AXIS/EDGES/DODS for binary output of axis coordinates
* V554:  1/04 *acm* - add REPEAT/RANGE=/NAME= qualifiers
* V554:  2/04 *acm* - add /HGRAT=/VGRAT qualifiers to plot commands, setting 
*                     GRATICULE lines at tic marks
* V570:  5/04 *acm* - Add DEFINE AXIS/BOUNDS 
*                     and LIST/EDGES, LIST/BOUNDS (for NetCDF output only)
*       *acm* 6/05 - add SET AXIS/CALENDAR /T0 /UNITS
*       *acm* 6/05 - add CANCEL AXIS/DEPTH
* V580: 10/04 *acm* - add SHOW VARIABLES/XML
* V580: 11/04 *acm* - add PLOT/NOKEY
* V581:  2/05 *acm* - SHADE/MODULO for curvilinear plots
* V581:  4/05 *acm* - CONTOUR/MODULO for curvilinear plots
* V581:  5/05 *acm* - add EXIT/CYCLE
* V590:  8/05 *acm* - add LIST/NOROWLAB

* V600:  8/05 *acm* - add LIST/NOROWLAB
* V600:  9/05 *acm* - add SET WINDOW/TITLE
* V600:  3/07 *acm* - fixing bug 439&1390. Add logical variable its_action_command 
* V600   6/05 *acm* - SHOW ATTRIBUTE[/ALL][/DATA=] var 
*                   - SHOW DATA/ATTR output all attributes for nc files
* V600:  8/05 *acm* - add LIST/NOROWLAB
*       *acm* 8/05 - add DEFINE ATTRIBUTE
*       *acm* 9/05 - add SET ATTRIBUTE
*       *acm*10/05 - add CANCEL ATTRIBUTE
* V600: 2/06 *acm* - add SET VARIABLE/OUTTYPE for attribute-handling additions
*       7/06 *jli* - add SET AXIS/STRIDE /OFFSET for grid striding
*       7/06 *jli* - add CANCEL AXIS/STRIDES
*       *acm* 7/06 -     CANCEL ATTRIBUTE /OUTPUT /DATA
* V603: 5/07 *acm* - Fix bug found by Andy Jacobson, in line 1465 index should be 30 not 29.
* V606  8/07 *acm* - DEFINE AXIS/QUIET
* V6.2  *acm* 5/08 new qualifier FRAME/TRANSPARENT
* V6.2  *acm* 2/09 new qualifier LIST/KEEP_AXISNAMES
* V6.2  *acm* 5/09 new alias KEYMARK
* V6.6  *acm* 1/10 new qualifiers for LIST netCDF4: NCFORMAT,
*                  XCHUNK,YCHUNK,ZCHUNK,TCHUNK,DEFLATE,SHUFFLE,ENDIAN
* V6.5  *acm* 3/10 new qualifiers on (some) SHOW commands and on MESSAGE: 
*                  /OUTFILE= /APPEND /CLOBBER
* V6.6  *acm* 2/10 new qualifiers for SET LIST netCDF4: NCFORMAT,
*                  XCHUNK,YCHUNK,ZCHUNK,TCHUNK,DEFLATE,SHUFFLE,ENDIAN
*       *kms* 5/10 add SET AXIS/REGULAR to force interpreting the axis as regular
*       *kms* 5/10 add SET REDIRECT /TEE /JOURNAL /FILE /APPEND /CLOBBER 
*                  and CANCEL REDIRECT for stdout/stderr redirection
*       *kms* 7/10 add SET DATA /BROWSE to browse for the dataset
* V6.63 *acm* 7/10 Add VECTOR/KEY to force key even if /NOLAB
*       *kms* 7/10 add SET DATA /BROWSE to browse for the dataset
* V664  8.10 *kms* Add EXIT/TOPYTHON to exit the ferret_dispatch loop 
*                  but just re-enter the loop if not under pyferret
*                  Add DEFINE PYFUNC /NAME=<alias> python.module.name
* V68 *acm* 1/12   Add USE/STRICT; see ticket 1910.
* V68 *acm* 5/12   Add DEFINE DATA /AGGREGATE /NAME= /QUIET
* V683*acm* 8/12   New SET LIST/OUTTYPE, CANCEL LIST/OUTTYPE and SAVE/OUTTYPE 
* V683*acm 10/12   NEW SET AXIS/OUTTYPE to change default coordinate axis output type
* V684 *acm* 12/12 Changes for POLY/MODULO and  VECTOR/MODULO on curvilinear plots.
* V685 *acm*  1/13 DEFINE VARIABLE/REMOTE
* V685 *acm*  6/13 new qualifier SAVE/NOBOUNDS
* V685 *acm*  6/13 Dont add SAVE/NOCOORDS
* V685 *acm*  4/13 Add /HIDE on DEF DATA/AGG and SHOW DATA/HIDDEN
* V685 *sh*  9/13  Add SHOW VARIABLE/TREE and alias VTREE
* V685 *acm* 11/13 Add /QUIET for DEFINE ATTRIBUTE
* V690 *sh* 12/13 Add /CURVILINEAR and /LAYERZ to action commands (formerly /SIGMA)
*		  Add SET,CANCEL,SHOW VARIABLE/LAYERZ/CURVI  	  (formerly /SIGMA)
* V687  3/14 *acm* add SET AXIS/NAME
* V693+ 11/14 *sh* renaming 'sigma' as 'layerz' throughout
* V695 *acm*  2/15 Add DEFINE AGGREGATE/F alias, FMRC
* V695 *acm*  6/16 New ANNOTATE command.
* V695 *acm*  6/16 New subcommand DEFINE ANNOTATION
* v696 *acm*  6/15 PLOT/VS/GAPLOC to define seperate line segments on
*                  PLOT/VS plots (LAS ticket 1597 and others)
* v696 *acm* 11/15 SET VAR/UNITS instead of /UNIT, just for consistency
* V697 *acm* 12/15 Correct typo: LIST/SINGLY was shown as /SINGLE
* V698+ *acm* 2/16 Ticket 2362: Change /D= qualifier to /DATASET=
* V698  3/16 *acm* Removed Philander-Seigel code including diagnostic 
*                  variables, pre-defined axes and grids, cat_calc_var.
*       3/16 *sh*  added PLOT/ALONG=axis
* V698  4/16 *acm* New PLOT/SKIP= (and leave space for PyFerret PLOT/OPACITY=)
* V698  4/16 *acm* Change it to PLOT/SKIPSYM= 
* V7    *acm* 6/16 Ticket 2434: command qualifiers /DEGMINSEC= /HALFSPAC
*                  DEGMINSEC=1 for Deg-Min axis labels, =2 for Deg-Min-Sec. Default = 1
*                  /HALFSPAC adds a half space between the degree sign and E/W or N/S
* V7    6/16 *kms* Add reserved slots for PyFerret commands and qualifiers
*                  to simplify future merges of Ferret into PyFerret
* V710 *acm*  3/16 Added DEFINE AXIS /LIKE=
* V710 *acm*  3/16 Ticket 2158: Add DEFINE AXIS /MONTHLY 
* V702 *sh*   1/17 Removed the USER command
*	      3/17 Added SHOW MEMORY/DIAGNOSTIC
* V720 *acm*  3/17 Ticket 2512: Add STAT/PRECISION=
* V720 *acm*  5/17 Ticket 2530 add WIRE/COLOR= 
* V722 *kms* 10/17 Remove threddsBrowser (too big, outdated, and unused)
* V723 *acm* 11/17 New SAVE/ASGLOBAL option to write global attribute to netCDF file
* V74  *acm*  2/17 New DEFINE AXIS/LIKE and DEFINE VARIABLE/LIKE
* V740 *kms*  3/18 Add space for PyFerret PLOT/HIGHLIGHT=
* V7.4+ *acm* 9/18 DSG-enabled Ferret: SET DATA/FMASK= specifies a feature mask
* V74+ *acm*  9/18 Add aliases FMASK for SET DATA/FMASK and CLEARMASK for CANCEL DATA/FMASK
* v751 *acm*  8/19 Issue 1946, allow for user-set string dimension length, SAVE/STRLEN
* v751 *acm*  8/19 New LIST/NOCOORDS to write dimensions only not coord vars. 
* v76  *acm* 11/19  Issue 1959: 
*                  SET MEMORY/SIZE= to SET MEMORY/MAX= (keep /SIZE for bkwds compatibility)
*
* !!!!!!!!!!
* Use caution when defining new commands, qualifiers, or changing these data structures:
* 1- Ferret commands are matched to the first 4 characters only. Make sure
*    new commands are unique to the first 4 characters.
* 2- If you are tempted to reorder the lists of commands or subcommands, know 
*    that users often use even more abbreviation. E.g. "can v" is used for 
*    "cancel viewport" in many scripts, and that works ONLY because "VIEWPORT" 
*    comes before "VARIABLE" in the subcommands for CANCEL.
* !!!!!!!!!!
 


        IMPLICIT NONE
	include 'ferret.parm'
	include 'xcommand.cmn'

* local variable declarations:
        INTEGER i

* SET	 - command # 1
	DATA commands(1)			/ 'SET '	/
        DATA its_action_command(1)              / .FALSE.       /
	DATA num_subcommands(1)			/ nsub1		/
	DATA subcommand_pointer(1)		/ nsub_at1	/
* SET '    '
	   DATA subcommands      (nsub_at1 + 0)	/ '    '	/
	   DATA num_qualifs      (nsub_at1 + 0)	/ nqual1a	/
	   DATA qualifier_pointer(nsub_at1 + 0)	/ nqual_at1a	/
* SET WINDOW
	   DATA subcommands      (nsub_at1 + 1)	/ 'WINDOW'	/
	   DATA num_qualifs      (nsub_at1 + 1)	/ nqual1b	/
	   DATA qualifier_pointer(nsub_at1 + 1)	/ nqual_at1b	/
* SET WINDOW/SIZE...
		DATA qualifiers  (nqual_at1b+0)	/ 'SIZE'	/
		DATA qualifiers  (nqual_at1b+1)	/ 'NEW' 	/
		DATA qualifiers  (nqual_at1b+2)	/ 'LOCATION'	/
		DATA qualifiers  (nqual_at1b+3)	/ 'ASPECT'	/
		DATA qualifiers  (nqual_at1b+4)	/ 'CLEAR'	/
		DATA qualifiers  (nqual_at1b+5)	/ 'TITLE'	/
		DATA qualifiers  (nqual_at1b+6)	/ '****'	/	! QUALITY in PyFerret
		DATA qualifiers  (nqual_at1b+7)	/ '****'	/	! ANTIALIAS for PyFerret
		DATA qualifiers  (nqual_at1b+8)	/ '****'	/	! NOANTIALIAS in PyFerret
		DATA qualifiers  (nqual_at1b+9)	/ '****'	/	! ENGINE in PyFerret
		DATA qualifiers  (nqual_at1b+10)/ '****'	/	! COLOR in PyFerret
		DATA qualifiers  (nqual_at1b+11)/ '****'	/	! OPACITY in PyFerret
		DATA qualifiers  (nqual_at1b+12)/ '****'	/	! THICKEN in PyFerret
		DATA qualifiers  (nqual_at1b+13)/ '****'	/	! XPIXELS in PyFerret
		DATA qualifiers  (nqual_at1b+14)/ '****'	/	! YPIXELS in PyFerret
		DATA qualifiers  (nqual_at1b+15)/ '****'	/	! XINCHES in PyFerret
		DATA qualifiers  (nqual_at1b+16)/ '****'	/	! YINCHES in PyFerret
		DATA qualifiers  (nqual_at1b+17)/ '****'	/	! TEXTPROM in PyFerret
		DATA qualifiers  (nqual_at1b+18)/ '****'	/	! OUTLINE in PyFerret
		DATA qualifiers  (nqual_at1b+19)/ '****'	/
* SET REGION
	   DATA subcommands      (nsub_at1 + 2)	/ 'REGION'	/
	   DATA num_qualifs      (nsub_at1 + 2)	/ nqual1c	/
	   DATA qualifier_pointer(nsub_at1 + 2)	/ nqual_at1c	/
* SET REGION/I/J/K/L/M/N/X/Y/Z/T/E/F/DX/DY/DZ/DT/DE/DF/DI/DJ/DK/DL/DM/DN
		DATA qualifiers  (nqual_at1c+0)	/ 'I'	/
		DATA qualifiers  (nqual_at1c+1)	/ 'J'	/
		DATA qualifiers  (nqual_at1c+2)	/ 'K'	/
		DATA qualifiers  (nqual_at1c+3)	/ 'L'	/
		DATA qualifiers  (nqual_at1c+4)	/ 'M'	/
		DATA qualifiers  (nqual_at1c+5)	/ 'N'	/
		DATA qualifiers  (nqual_at1c+6)	/ 'X'	/
		DATA qualifiers  (nqual_at1c+7)	/ 'Y'	/
		DATA qualifiers  (nqual_at1c+8)	/ 'Z'	/
		DATA qualifiers  (nqual_at1c+9)	/ 'T'	/
		DATA qualifiers  (nqual_at1c+10)/ 'E'/
		DATA qualifiers  (nqual_at1c+11)/ 'F'/
		DATA qualifiers  (nqual_at1c+12)/ '****'/   ! need this for alignment
		DATA qualifiers  (nqual_at1c+13)/ '****'/   ! in get_delta_context
		DATA qualifiers  (nqual_at1c+14)/ 'DX'/
		DATA qualifiers  (nqual_at1c+15)/ 'DY'/
		DATA qualifiers  (nqual_at1c+16)/ 'DZ'/
		DATA qualifiers  (nqual_at1c+17)/ 'DT'/
		DATA qualifiers  (nqual_at1c+18)/ 'DE'/
		DATA qualifiers  (nqual_at1c+19)/ 'DF'/
		DATA qualifiers  (nqual_at1c+20)/ 'DI'/
		DATA qualifiers  (nqual_at1c+21)/ 'DJ'/
		DATA qualifiers  (nqual_at1c+22)/ 'DK'/
		DATA qualifiers  (nqual_at1c+23)/ 'DL'/
		DATA qualifiers  (nqual_at1c+24)/ 'DM'/
		DATA qualifiers  (nqual_at1c+25)/ 'DN'/
		DATA qualifiers  (nqual_at1c+26)/ '****'/
* SET VIEWPORT
	   DATA subcommands      (nsub_at1 + 3)	/ 'VIEWPORT'	/
	   DATA num_qualifs      (nsub_at1 + 3)	/ nqual1d	/
	   DATA qualifier_pointer(nsub_at1 + 3)	/ nqual_at1d	/
* SET VIEWPORT/SIZE/ORIGIN/CLIP
		DATA qualifiers  (nqual_at1d+0)	/ '****'	/
* SET EXPRSION
	   DATA subcommands      (nsub_at1 + 4)	/ 'EXPRSION'	/
	   DATA num_qualifs      (nsub_at1 + 4)	/ nqual1e	/
	   DATA qualifier_pointer(nsub_at1 + 4)	/ nqual_at1e	/
* SET LIST
	   DATA subcommands      (nsub_at1 + 5)	/ 'LIST'	/
	   DATA num_qualifs      (nsub_at1 + 5)	/ nqual1f	/
	   DATA qualifier_pointer(nsub_at1 + 5)	/ nqual_at1f	/
* SET LIST/PRECISION=#digits, /FILE=filename, /FORMAT=list_format, /APPEND, 
* (for netcdf4 /NCFORMAT= /ENDIAN=, /DEFLATE=, /SHUFFLE=,  /XCHUNK...
		DATA qualifiers  (nqual_at1f+0)	/ 'PRECISION'	/
		DATA qualifiers  (nqual_at1f+1)	/ 'FILE'	/
		DATA qualifiers  (nqual_at1f+2)	/ 'FORMAT'	/
		DATA qualifiers  (nqual_at1f+3)	/ 'APPEND'	/
		DATA qualifiers  (nqual_at1f+4)	/ 'HEADING'	/
		DATA qualifiers  (nqual_at1f+5)	/ 'NCFORMAT'	/
		DATA qualifiers  (nqual_at1f+6)	/ 'ENDIAN'	/
		DATA qualifiers  (nqual_at1f+7)	/ 'DEFLATE'	/
		DATA qualifiers  (nqual_at1f+8)	/ 'SHUFFLE'	/
		DATA qualifiers  (nqual_at1f+9)	/ 'XCHUNK'	/
		DATA qualifiers  (nqual_at1f+10)/ 'YCHUNK'	/
		DATA qualifiers  (nqual_at1f+11)/ 'ZCHUNK'	/
		DATA qualifiers  (nqual_at1f+12)/ 'TCHUNK'	/
		DATA qualifiers  (nqual_at1f+13)/ 'ECHUNK'	/
		DATA qualifiers  (nqual_at1f+14)/ 'FCHUNK'	/
		DATA qualifiers  (nqual_at1f+15)/ 'OUTTYPE'	/
* SET DATA_SET
	   DATA subcommands      (nsub_at1 + 6)	/ 'DATA'	/
	   DATA num_qualifs      (nsub_at1 + 6)	/ nqual1g	/
	   DATA qualifier_pointer(nsub_at1 + 6)	/ nqual_at1g	/
* SET DATA/FORM/GRID/TITL/SIZE/TYPE
		DATA qualifiers  (nqual_at1g+0)	/ 'EZ'  	/
		DATA qualifiers  (nqual_at1g+1)	/ 'VARIABLE'	/
		DATA qualifiers  (nqual_at1g+2)	/ 'TITLE'	/
		DATA qualifiers  (nqual_at1g+3)	/ 'FORMAT'	/
		DATA qualifiers  (nqual_at1g+4)	/ 'GRID'	/
		DATA qualifiers  (nqual_at1g+5)	/ 'SKIP'	/
		DATA qualifiers  (nqual_at1g+6)	/ 'COLUMNS'	/
		DATA qualifiers  (nqual_at1g+7)	/ 'SAVE'	/
		DATA qualifiers  (nqual_at1g+8)	/ 'RESTORE'	/
		DATA qualifiers  (nqual_at1g+9)	/ 'ORDER'	/   !5/94
		DATA qualifiers  (nqual_at1g+10) / 'TYPE'       / 
		DATA qualifiers  (nqual_at1g+11) / 'SWAP'       / 
		DATA qualifiers  (nqual_at1g+12) / 'REGULART'   /
		DATA qualifiers  (nqual_at1g+13) / 'DELIMITE'   /
		DATA qualifiers  (nqual_at1g+14) / 'STRICT'     /
		DATA qualifiers  (nqual_at1g+15) / 'FEATURE'    /
		DATA qualifiers  (nqual_at1g+16) / 'FMASK'      /
		DATA qualifiers  (nqual_at1g+17) / '****'       /
		DATA qualifiers  (nqual_at1g+18) / '****'       /
		DATA qualifiers  (nqual_at1g+19) / '****'       /
* SET MODE
	   DATA subcommands      (nsub_at1 + 7)	/ 'MODE'	/
	   DATA num_qualifs      (nsub_at1 + 7)	/ nqual1h	/
	   DATA qualifier_pointer(nsub_at1 + 7)	/ nqual_at1h	/
* SET MODE/LAST
		DATA qualifiers  (nqual_at1h+0)	/ 'LAST'	/
* SET MOVIE
	   DATA subcommands      (nsub_at1 + 8)	/ 'MOVI'	/
	   DATA num_qualifs      (nsub_at1 + 8)	/ nqual1i	/
	   DATA qualifier_pointer(nsub_at1 + 8)	/ nqual_at1i	/
* SET MOVIE/FILE=filename/COMPRESS/LASER
		DATA qualifiers  (nqual_at1i+0)	/ 'FILE'	/
		DATA qualifiers  (nqual_at1i+1)	/ 'COMPRESS'	/
		DATA qualifiers  (nqual_at1i+2)	/ 'LASER'	/
		DATA qualifiers  (nqual_at1i+3)	/ 'START'	/
		DATA qualifiers  (nqual_at1i+4)	/ '****'	/
* SET VARIABLE
	   DATA subcommands      (nsub_at1 + 9)	/ 'VARIABLE'	/
	   DATA num_qualifs      (nsub_at1 + 9)	/ nqual1j	/
	   DATA qualifier_pointer(nsub_at1 + 9)	/ nqual_at1j	/
* SET VARIABLE/TITLE/UNITS/GRID/BAD/DATASET/NAME/SCALEFAC/OFFSET/OUTTYPE
		DATA qualifiers  (nqual_at1j+0)	/ 'TITLE'	/
		DATA qualifiers  (nqual_at1j+1)	/ 'UNITS'	/
		DATA qualifiers  (nqual_at1j+2)	/ 'GRID'	/
		DATA qualifiers  (nqual_at1j+3)	/ 'BAD'	/
		DATA qualifiers  (nqual_at1j+4)	/ 'DATASET'	/
		DATA qualifiers  (nqual_at1j+5)	/ 'NAME'	/
		DATA qualifiers  (nqual_at1j+6)	/ 'SCALEFAC'	/
		DATA qualifiers  (nqual_at1j+7)	/ 'OFFSET'	/
		DATA qualifiers  (nqual_at1j+8)	/ 'OUTTYPE'	/
		DATA qualifiers  (nqual_at1j+9)	/ 'LAYERZ'	/
		DATA qualifiers  (nqual_at1j+10)/ 'CURVILINEAR'	/
		DATA qualifiers  (nqual_at1j+11)/ '****'	/
		DATA qualifiers  (nqual_at1j+12)/ '****'	/
* SET GRID
	   DATA subcommands      (nsub_at1 +10)	/ 'GRID'	/
	   DATA num_qualifs      (nsub_at1 +10)	/ nqual1k	/
	   DATA qualifier_pointer(nsub_at1 +10)	/ nqual_at1k	/
* SET GRID
		DATA qualifiers  (nqual_at1k+0)	/ 'SAVE'	/
		DATA qualifiers  (nqual_at1k+1)	/ 'RESTORE'	/
* SET AXIS
	   DATA subcommands      (nsub_at1 +11)	/ 'AXIS'	/
	   DATA num_qualifs      (nsub_at1 +11)	/ nqual1l	/
	   DATA qualifier_pointer(nsub_at1 +11)	/ nqual_at1l	/
* SET AXIS / MODULO /DEPTH /CALENDAR /UNITS /T0 /STRIDE /OFFSET /REGULAR /OUTTYPE /NAME
		DATA qualifiers  (nqual_at1l+0)	/ 'MODULO'	/
		DATA qualifiers  (nqual_at1l+1)	/ 'DEPTH'	/
		DATA qualifiers  (nqual_at1l+2)	/ 'CALENDAR'	/
		DATA qualifiers  (nqual_at1l+3)	/ 'T0'	/
		DATA qualifiers  (nqual_at1l+4)	/ 'UNITS'	/
		DATA qualifiers  (nqual_at1l+5)	/ 'STRIDE'	/
		DATA qualifiers  (nqual_at1l+6)	/ 'OFFSET'	/
		DATA qualifiers  (nqual_at1l+7)	/ 'REGULAR'	/
		DATA qualifiers  (nqual_at1l+8)	/ 'OUTTYPE'	/
		DATA qualifiers  (nqual_at1l+9)	/ 'NAME'	/
* SET MEMORY
	   DATA subcommands      (nsub_at1 +12)	/ 'MEMORY'	/
	   DATA num_qualifs      (nsub_at1 +12)	/ nqual1m	/
	   DATA qualifier_pointer(nsub_at1 +12)	/ nqual_at1m	/
* SET MEMO / MWORDS
		DATA qualifiers  (nqual_at1m+0)	/ 'MAX'	/
		DATA qualifiers  (nqual_at1m+1)	/ 'SIZE'	/
* SET ATTRIBUTE
	   DATA subcommands      (nsub_at1 +13)	/ 'ATTRIBUT'	/
	   DATA num_qualifs      (nsub_at1 +13)	/ nqual1n	/
	   DATA qualifier_pointer(nsub_at1 +13)	/ nqual_at1n	/
* SET ATRR /TYPE /DATASET /OUTPUT /LIKE 
		DATA qualifiers  (nqual_at1n+0)	/ 'TYPE'	/
		DATA qualifiers  (nqual_at1n+1)	/ 'DATASET'	/
		DATA qualifiers  (nqual_at1n+2)	/ 'OUTPUT'	/
		DATA qualifiers  (nqual_at1n+3)	/ 'LIKE'	/
		DATA qualifiers  (nqual_at1n+4)	/ 'QUIET'	/
		DATA qualifiers  (nqual_at1n+5)	/ '****'	/
		DATA qualifiers  (nqual_at1n+6)	/ '****'	/
		DATA qualifiers  (nqual_at1n+7)	/ '****'	/
* SET NCCACHE							  ! cache chunk for reading
	   DATA subcommands      (nsub_at1 +14)	/ 'NCCACHE'	/
	   DATA num_qualifs      (nsub_at1 +14)	/ nqual1o	/
	   DATA qualifier_pointer(nsub_at1 +14)	/ nqual_at1o	/
* SET NCCACHE /SIZE/NELEMS/PREEMPT
		DATA qualifiers  (nqual_at1o+0)	/ 'SIZE'	/
		DATA qualifiers  (nqual_at1o+1)	/ 'NELEMS'	/
		DATA qualifiers  (nqual_at1o+2)	/ 'PREEMPT'	/
* SET REDIRECT							  ! redirecting stdout and/or stderr
	   DATA subcommands      (nsub_at1 +15)	/ 'REDIRECT'	/
	   DATA num_qualifs      (nsub_at1 +15)	/ nqual1p	/
	   DATA qualifier_pointer(nsub_at1 +15)	/ nqual_at1p	/
* SET REDIRECT /TEE /JOURNAL /FILE /APPEND /CLOBBER
		DATA qualifiers  (nqual_at1p+0)	/ 'TEE'		/
		DATA qualifiers  (nqual_at1p+1)	/ 'JOURNAL'	/
		DATA qualifiers  (nqual_at1p+2)	/ 'FILE'	/
		DATA qualifiers  (nqual_at1p+3)	/ 'APPEND'	/
		DATA qualifiers  (nqual_at1p+4)	/ 'CLOBBER'	/
		DATA qualifiers  (nqual_at1p+5)	/ '****'	/
		DATA qualifiers  (nqual_at1p+6)	/ '****'	/
		DATA qualifiers  (nqual_at1p+7)	/ '****'	/
* SET GIFFILE							  ! set default gif filename and the pointer used in gif mode
	   DATA subcommands      (nsub_at1 +16)	/ 'GIFFILE'	/
	   DATA num_qualifs      (nsub_at1 +16)	/ nqual1q	/
	   DATA qualifier_pointer(nsub_at1 +16)	/ nqual_at1q	/
* SET TEXT							  ! set text properties for PyFerret fonts
           DATA subcommands      (nsub_at1 +17)	/ '****'	/	! TEXT in PyFerret
           DATA num_qualifs      (nsub_at1 +17)	/ nqual1r	/
           DATA qualifier_pointer(nsub_at1 +17)	/ nqual_at1r	/
* SET TEXT /FONT /COLOR /ITALIC /BOLD ! in PyFerret
                DATA qualifiers  (nqual_at1r+0)	/ '****'	/	! FONT in PyFerret
                DATA qualifiers  (nqual_at1r+1)	/ '****'	/	! COLOR in PyFerret
                DATA qualifiers  (nqual_at1r+2)	/ '****'	/	! ITALIC in PyFerret
                DATA qualifiers  (nqual_at1r+3)	/ '****'	/	! BOLD in PyFerret
                DATA qualifiers  (nqual_at1r+4)	/ '****'	/	! ISIZ in PyFerret
                DATA qualifiers  (nqual_at1r+5)	/ '****'	/
* SET ****							  ! unused (s)
	   DATA subcommands      (nsub_at1 +18)	/ '****'	/
	   DATA num_qualifs      (nsub_at1 +18)	/ nqual1s	/
	   DATA qualifier_pointer(nsub_at1 +18)	/ nqual_at1s	/
* SET **** / ****
		DATA qualifiers  (nqual_at1s+0)	/ '****'	/
		DATA qualifiers  (nqual_at1s+1)	/ '****'	/
		DATA qualifiers  (nqual_at1s+2)	/ '****'	/
		DATA qualifiers  (nqual_at1s+3)	/ '****'	/
* SET ****							  ! unused (t)
	   DATA subcommands      (nsub_at1 +19)	/ '****'	/
	   DATA num_qualifs      (nsub_at1 +19)	/ nqual1t	/
	   DATA qualifier_pointer(nsub_at1 +19)	/ nqual_at1t	/
* SET **** / ****
		DATA qualifiers  (nqual_at1t+0)	/ '****'	/
		DATA qualifiers  (nqual_at1t+1)	/ '****'	/
		DATA qualifiers  (nqual_at1t+2)	/ '****'	/
		DATA qualifiers  (nqual_at1t+3)	/ '****'	/

* SHOW	 - command # 2
	DATA commands(2)			/ 'SHOW '	/
        DATA its_action_command(2)              / .FALSE.       /
	DATA num_subcommands(2)			/ nsub2		/
	DATA subcommand_pointer(2)		/ nsub_at2	/
* SHOW '    '
	   DATA subcommands      (nsub_at2 + 0)	/ '    '	/
	   DATA num_qualifs      (nsub_at2 + 0)	/ nqual2a	/
	   DATA qualifier_pointer(nsub_at2 + 0)	/ nqual_at2a	/
* SHOW /ALL
		DATA qualifiers  (nqual_at2a+0)	/ 'ALL '	/
* SHOW WINDOWS
	   DATA subcommands      (nsub_at2 + 1)	/ 'WINDOW'	/
	   DATA num_qualifs      (nsub_at2 + 1)	/ nqual2b	/
	   DATA qualifier_pointer(nsub_at2 + 1)	/ nqual_at2b	/
* SHOW WINDOWS /ALL
		DATA qualifiers  (nqual_at2b+0)	/ 'ALL '	/
* SHOW REGION
	   DATA subcommands      (nsub_at2 + 2)	/ 'REGION'	/
	   DATA num_qualifs      (nsub_at2 + 2)	/ nqual2c	/
	   DATA qualifier_pointer(nsub_at2 + 2)	/ nqual_at2c	/
* SHOW REGIONS /ALL
		DATA qualifiers  (nqual_at2c+0)	/ 'ALL '	/
* SHOW AXIS
	   DATA subcommands      (nsub_at2 + 3)	/ 'AXIS'	/
	   DATA num_qualifs      (nsub_at2 + 3)	/ nqual2d	/
	   DATA qualifier_pointer(nsub_at2 + 3)	/ nqual_at2d	/
* SHOW AXIS /ALL/I/J/K/L/M/N/X/Y/Z/T/E/F/XML/OUTFILE/APPEND/CLOBBER
		DATA qualifiers  (nqual_at2d+0)	/ 'ALL '	/
		DATA qualifiers  (nqual_at2d+1)	/ 'I'	/
		DATA qualifiers  (nqual_at2d+2)	/ 'J'	/
		DATA qualifiers  (nqual_at2d+3)	/ 'K'	/
		DATA qualifiers  (nqual_at2d+4)	/ 'L'	/
		DATA qualifiers  (nqual_at2d+5)	/ 'M'	/
		DATA qualifiers  (nqual_at2d+6)	/ 'N'	/
		DATA qualifiers  (nqual_at2d+7)	/ 'X'	/
		DATA qualifiers  (nqual_at2d+8)	/ 'Y'	/
		DATA qualifiers  (nqual_at2d+9)	/ 'Z'	/
		DATA qualifiers  (nqual_at2d+10)/ 'T'	/
		DATA qualifiers  (nqual_at2d+11)/ 'E'	/
		DATA qualifiers  (nqual_at2d+12)/ 'F'	/
		DATA qualifiers  (nqual_at2d+13)/ 'XML'/
		DATA qualifiers  (nqual_at2d+14)/ 'OUTFILE'/
		DATA qualifiers  (nqual_at2d+15)/ 'APPEND'/
		DATA qualifiers  (nqual_at2d+16)/ 'CLOBBER'/
		DATA qualifiers  (nqual_at2d+17)/ '****'/
		DATA qualifiers  (nqual_at2d+18)/ '****'/
		DATA qualifiers  (nqual_at2d+19)/ '****'/

* SHOW EXPRSIONION
	   DATA subcommands      (nsub_at2 + 4)	/ 'EXPRSION'	/
	   DATA num_qualifs      (nsub_at2 + 4)	/ nqual2e	/
	   DATA qualifier_pointer(nsub_at2 + 4)	/ nqual_at2e	/
* SHOW EXPRSIONION /ALL
		DATA qualifiers  (nqual_at2e+0)	/ 'ALL '	/
* SHOW LIST
	   DATA subcommands      (nsub_at2 + 5)	/ 'LIST'	/
	   DATA num_qualifs      (nsub_at2 + 5)	/ nqual2f	/
	   DATA qualifier_pointer(nsub_at2 + 5)	/ nqual_at2f	/
* SHOW LIST /ALL
		DATA qualifiers  (nqual_at2f+0)	/ 'ALL '	/
* SHOW DATA_SET
	   DATA subcommands      (nsub_at2 + 6)	/ 'DATA'	/
	   DATA num_qualifs      (nsub_at2 + 6)	/ nqual2g	/
	   DATA qualifier_pointer(nsub_at2 + 6)	/ nqual_at2g	/
* SHOW DATA_SET /ALL/BRIEF/FULL/VAR/FILE/XML/ATTR/OUTFILE/APPEND/CLOBBER/HIDDEN
		DATA qualifiers  (nqual_at2g+0)	/ 'ALL '	/
		DATA qualifiers  (nqual_at2g+1)	/ 'BRIEF'	/
		DATA qualifiers  (nqual_at2g+2)	/ 'FULL'	/
		DATA qualifiers  (nqual_at2g+3)	/ 'VARIABLE'	/
		DATA qualifiers  (nqual_at2g+4)	/ 'FILES'	/ ! deprecated
		DATA qualifiers  (nqual_at2g+5)	/ 'XML'		/
		DATA qualifiers  (nqual_at2g+6)	/ 'ATTR'	/
		DATA qualifiers  (nqual_at2g+7)	/ 'OUTFILE'	/
		DATA qualifiers  (nqual_at2g+8)	/ 'APPEND'	/
		DATA qualifiers  (nqual_at2g+9)	/ 'CLOBBER'	/
		DATA qualifiers  (nqual_at2g+10)/ 'HIDDEN'	/
		DATA qualifiers  (nqual_at2g+11)/ 'MEMBERS'	/
		DATA qualifiers  (nqual_at2g+12)/ '****'	/
		DATA qualifiers  (nqual_at2g+13)/ '****'	/
		DATA qualifiers  (nqual_at2g+14)/ '****'	/
* SHOW MODE
	   DATA subcommands      (nsub_at2 + 7)	/ 'MODE'	/
	   DATA num_qualifs      (nsub_at2 + 7)	/ nqual2h	/
	   DATA qualifier_pointer(nsub_at2 + 7)	/ nqual_at2h	/
* SHOW MODE /ALL
		DATA qualifiers  (nqual_at2h+0)	/ 'ALL '	/
* SHOW MOVIE
	   DATA subcommands      (nsub_at2 + 8)	/ 'MOVIE'	/
	   DATA num_qualifs      (nsub_at2 + 8)	/ nqual2i	/
	   DATA qualifier_pointer(nsub_at2 + 8)	/ nqual_at2i	/
* SHOW MOVIE /ALL
		DATA qualifiers  (nqual_at2i+0)	/ 'ALL '	/
* SHOW VARIABLES
	   DATA subcommands      (nsub_at2 + 9)	/ 'VARIABLE'	/
	   DATA num_qualifs      (nsub_at2 + 9)	/ nqual2j	/
	   DATA qualifier_pointer(nsub_at2 + 9)	/ nqual_at2j	/
* SHOW VARIABLES /ALL /DATASET  /USER /OUTFILE/APPEND/CLOBBER
* /DIAGNOSTI removed 3/2016
		DATA qualifiers  (nqual_at2j+0)	/ 'ALL '	/
		DATA qualifiers  (nqual_at2j+1)	/ 'DATASET'	/
		DATA qualifiers  (nqual_at2j+2)	/ '****'	/
		DATA qualifiers  (nqual_at2j+3)	/ 'USER'	/
		DATA qualifiers  (nqual_at2j+4)	/ 'XML'		/
		DATA qualifiers  (nqual_at2j+5)	/ 'OUTFILE'	/
		DATA qualifiers  (nqual_at2j+6)	/ 'APPEND'	/
		DATA qualifiers  (nqual_at2j+7)	/ 'CLOBBER'	/
		DATA qualifiers  (nqual_at2j+8)	/ 'TREE'	/ ! was /DEPENDENCY
		DATA qualifiers  (nqual_at2j+9)	/ 'LAYERZ'	/
		DATA qualifiers  (nqual_at2j+10)/ 'CURVILINEAR'	/
		DATA qualifiers  (nqual_at2j+11)/ '****'	/
		DATA qualifiers  (nqual_at2j+12)/ '****'	/
* SHOW COMMANDS
	   DATA subcommands      (nsub_at2 +10)	/ 'COMMANDS'	/
	   DATA num_qualifs      (nsub_at2 +10)	/ nqual2k	/
	   DATA qualifier_pointer(nsub_at2 +10)	/ nqual_at2k	/
* SHOW COMMANDS /ALL /BRIEF
		DATA qualifiers  (nqual_at2k+0)	/ 'ALL '	/
		DATA qualifiers  (nqual_at2k+1)	/ 'BRIEF'	/
* SHOW MEMORY
	   DATA subcommands      (nsub_at2 +11)	/ 'MEMORY'	/
	   DATA num_qualifs      (nsub_at2 +11)	/ nqual2l	/
	   DATA qualifier_pointer(nsub_at2 +11)	/ nqual_at2l	/
* SHOW MEMORY /ALL /TEMP /PERM /FREE
		DATA qualifiers  (nqual_at2l+0)	/ 'ALL '	/
		DATA qualifiers  (nqual_at2l+1)	/ 'DIAGNOSTIC'	/
		DATA qualifiers  (nqual_at2l+2)	/ 'TEMPORY'	/
		DATA qualifiers  (nqual_at2l+3)	/ 'PERMANT'	/
		DATA qualifiers  (nqual_at2l+4)	/ 'FREE'	/
* SHOW GRID
	   DATA subcommands      (nsub_at2 +12)	/ 'GRID'	/
	   DATA num_qualifs      (nsub_at2 +12)	/ nqual2m	/
	   DATA qualifier_pointer(nsub_at2 +12)	/ nqual_at2m	/
* SHOW GRID /ALL/I/J/K/L/M/N/X/Y/Z/T/E/F/DATASET/XML/OUTFILE/APPEND/CLOBBER 
		DATA qualifiers  (nqual_at2m+0)	/ 'ALL '	/
		DATA qualifiers  (nqual_at2m+1)	/ 'I   '	/
		DATA qualifiers  (nqual_at2m+2)	/ 'J   '	/
		DATA qualifiers  (nqual_at2m+3)	/ 'K   '	/
		DATA qualifiers  (nqual_at2m+4)	/ 'L   '	/
		DATA qualifiers  (nqual_at2m+5)	/ 'M   '	/
		DATA qualifiers  (nqual_at2m+6)	/ 'N   '	/
		DATA qualifiers  (nqual_at2m+7)	/ 'X   '	/
		DATA qualifiers  (nqual_at2m+8)	/ 'Y   '	/
		DATA qualifiers  (nqual_at2m+9)	/ 'Z   '	/
		DATA qualifiers  (nqual_at2m+10)/ 'T   '	/
		DATA qualifiers  (nqual_at2m+11)/ 'E   '	/
		DATA qualifiers  (nqual_at2m+12)/ 'F   '	/
		DATA qualifiers  (nqual_at2m+13)/ 'DYNAMIC'	/
		DATA qualifiers  (nqual_at2m+14)/ 'XML'	/
		DATA qualifiers  (nqual_at2m+15)/ 'OUTFILE'	/
		DATA qualifiers  (nqual_at2m+16)/ 'APPEND'	/
		DATA qualifiers  (nqual_at2m+17)/ 'CLOBBER'	/
		DATA qualifiers  (nqual_at2m+18)/ '****'	/
		DATA qualifiers  (nqual_at2m+19)/ '****'	/
* SHOW VIEW
	   DATA subcommands      (nsub_at2 +13)	/ 'VIEWPORT'	/
	   DATA num_qualifs      (nsub_at2 +13)	/ nqual2n	/
	   DATA qualifier_pointer(nsub_at2 +13)	/ nqual_at2n	/
* SHOW VIEW /ALL/ ****
		DATA qualifiers  (nqual_at2n+0)	/ 'ALL'		/
		DATA qualifiers  (nqual_at2n+1)	/ '****'	/
		DATA qualifiers  (nqual_at2n+2)	/ '****'	/

* SHOW TRANSFORMS
	   DATA subcommands      (nsub_at2 +14)	/ 'TRANFORM'	/
	   DATA num_qualifs      (nsub_at2 +14)	/ nqual2o	/
	   DATA qualifier_pointer(nsub_at2 +14)	/ nqual_at2o	/
* SHOW TRANS / ALL
		DATA qualifiers  (nqual_at2o+0)	/ 'ALL'		/
* SHOW ALIAS
	   DATA subcommands      (nsub_at2 +15)	/ 'ALIAS'	/
	   DATA num_qualifs      (nsub_at2 +15)	/ nqual2p	/
	   DATA qualifier_pointer(nsub_at2 +15)	/ nqual_at2p	/
* SHOW ALIAS / ****
		DATA qualifiers  (nqual_at2p+0)	/ 'ALL'		/
* SHOW SYMBOL
	   DATA subcommands      (nsub_at2 +16)	/ 'SYMBOL'	/
	   DATA num_qualifs      (nsub_at2 +16)	/ nqual2q	/
	   DATA qualifier_pointer(nsub_at2 +16)	/ nqual_at2q	/
* SHOW SYMBOL / ALL
		DATA qualifiers  (nqual_at2q+0)	/ 'ALL'		/
* SHOW ATTRIBUTE
	   DATA subcommands      (nsub_at2 +17)	/ 'ATTRIBUT'	/
	   DATA num_qualifs      (nsub_at2 +17)	/ nqual2r	/
	   DATA qualifier_pointer(nsub_at2 +17)	/ nqual_at2r	/
* SHOW ATTRIBUTE / ALL /DATASET /OUTPUT
		DATA qualifiers  (nqual_at2r+0)	/ 'ALL'		/
		DATA qualifiers  (nqual_at2r+1)	/ 'DATASET'	/
		DATA qualifiers  (nqual_at2r+2)	/ 'OUTPUT'	/
* SHOW NCCACHE
	   DATA subcommands      (nsub_at2 +18)	/ 'NCCACHE'	/
	   DATA num_qualifs      (nsub_at2 +18)	/ nqual2s	/
	   DATA qualifier_pointer(nsub_at2 +18)	/ nqual_at2s	/
* SHOW NCCACHE/ ****
		DATA qualifiers  (nqual_at2s+0)	/ '****'	/
* SHOW GIFFILE
	   DATA subcommands      (nsub_at2 +19)	/ 'GIFFILE'	/
	   DATA num_qualifs      (nsub_at2 +19)	/ nqual2t	/
	   DATA qualifier_pointer(nsub_at2 +19)	/ nqual_at2t	/
* SHOW GIFFILE/ ****
		DATA qualifiers  (nqual_at2t+0)	/ '****'	/
* SHOW FUNCTION
	   DATA subcommands      (nsub_at2 +20)	/ 'FUNCTION'	/
	   DATA num_qualifs      (nsub_at2 +20)	/ nqual2u	/
	   DATA qualifier_pointer(nsub_at2 +20)	/ nqual_at2u	/
* SHOW FUNCTION / ALL / BRIEF / EXTERNAL / INTERNAL
		DATA qualifiers  (nqual_at2u+0)	/ 'ALL'		/
		DATA qualifiers  (nqual_at2u+1)	/ 'BRIEF'	/
		DATA qualifiers  (nqual_at2u+2)	/ 'EXTERNAL'	/
		DATA qualifiers  (nqual_at2u+3)	/ 'INTERNAL'	/
		DATA qualifiers  (nqual_at2u+4)	/ 'DETAILS'	/
		DATA qualifiers  (nqual_at2u+5)	/ '****'	/
		DATA qualifiers  (nqual_at2u+6)	/ '****'	/

* SHOW TEXT         ! view text properties for PyFerret fonts
           DATA subcommands      (nsub_at2 +21)/ '****'	/	! TEXT in PyFerret
           DATA num_qualifs      (nsub_at2 +21)	/ nqual2v	/
           DATA qualifier_pointer(nsub_at2 +21)	/ nqual_at2v	/
* SHOW TEXT  / **** ! in PyFerret
                DATA qualifiers  (nqual_at2v+0)	/ '****'	/
                DATA qualifiers  (nqual_at2v+1)	/ '****'	/

* SHOW QUERIES
	   DATA subcommands      (nsub_at2 +22)	/ 'QUERIES'	/
	   DATA num_qualifs      (nsub_at2 +22)	/ nqual2w	/
	   DATA qualifier_pointer(nsub_at2 +22)	/ nqual_at2w	/
* SHOW QUERIES / ALL
		DATA qualifiers  (nqual_at2w+0)	/ 'ALL'		/
		DATA qualifiers  (nqual_at2w+1)	/ '****'	/
		DATA qualifiers  (nqual_at2w+2)	/ '****'	/

* CANCEL	 - command # 3
	DATA commands(3)			/ 'CANCEL'	/
        DATA its_action_command(3)              / .FALSE.       /
	DATA num_subcommands(3)			/ nsub3		/
	DATA subcommand_pointer(3)		/ nsub_at3	/
* CANCEL '    '
	   DATA subcommands      (nsub_at3 + 0)	/ '    '	/
	   DATA num_qualifs      (nsub_at3 + 0)	/ nqual3a	/
	   DATA qualifier_pointer(nsub_at3 + 0)	/ nqual_at3a	/
* CANCEL WINDOW
	   DATA subcommands      (nsub_at3 + 1)	/ 'WIND'	/
	   DATA num_qualifs      (nsub_at3 + 1)	/ nqual3b	/
	   DATA qualifier_pointer(nsub_at3 + 1)	/ nqual_at3b	/
* CANCEL WINDOW /ALL
		DATA qualifiers  (nqual_at3b+0)	/ 'ALL '	/
* CANCEL REGION
	   DATA subcommands      (nsub_at3 + 2)	/ 'REGION'	/
	   DATA num_qualifs      (nsub_at3 + 2)	/ nqual3c	/
	   DATA qualifier_pointer(nsub_at3 + 2)	/ nqual_at3c	/
* CANCEL REGIONS /ALL/I/J/K/L/M/N/X/Y/Z/T/E/F
		DATA qualifiers  (nqual_at3c+0)	/ 'ALL '	/
		DATA qualifiers  (nqual_at3c+1)	/ 'I   '	/
		DATA qualifiers  (nqual_at3c+2)	/ 'J   '	/
		DATA qualifiers  (nqual_at3c+3)	/ 'K   '	/
		DATA qualifiers  (nqual_at3c+4)	/ 'L   '	/
		DATA qualifiers  (nqual_at3c+5)	/ 'M   '	/
		DATA qualifiers  (nqual_at3c+6)	/ 'N   '	/
		DATA qualifiers  (nqual_at3c+7)	/ 'X   '	/
		DATA qualifiers  (nqual_at3c+8)	/ 'Y   '	/
		DATA qualifiers  (nqual_at3c+9)	/ 'Z   '	/
		DATA qualifiers  (nqual_at3c+10)/ 'T   '	/
		DATA qualifiers  (nqual_at3c+11)/ 'E   '	/
		DATA qualifiers  (nqual_at3c+12)/ 'F   '	/
* CANCEL MEMORY
	   DATA subcommands      (nsub_at3 + 3)	/ 'MEMORY'	/
	   DATA num_qualifs      (nsub_at3 + 3)	/ nqual3d	/
	   DATA qualifier_pointer(nsub_at3 + 3)	/ nqual_at3d	/
* CANCEL MEMORY /ALL
		DATA qualifiers  (nqual_at3d+0)	/ 'ALL '	/
		DATA qualifiers  (nqual_at3d+1)	/ 'TEMPORY'	/
		DATA qualifiers  (nqual_at3d+2)	/ 'PERMANT'	/
* CANCEL EXPRSIONION
	   DATA subcommands      (nsub_at3 + 4)	/ 'EXPRSION'	/
	   DATA num_qualifs      (nsub_at3 + 4)	/ nqual3e	/
	   DATA qualifier_pointer(nsub_at3 + 4)	/ nqual_at3e	/
* CANCEL EXPRSION /ALL
		DATA qualifiers  (nqual_at3e+0)	/ 'ALL '	/
* CANCEL LIST
	   DATA subcommands      (nsub_at3 + 5)	/ 'LIST'	/
	   DATA num_qualifs      (nsub_at3 + 5)	/ nqual3f	/
	   DATA qualifier_pointer(nsub_at3 + 5)	/ nqual_at3f	/
* CANCEL LIST /ALL, /PRECISION, /FILE, /FORMAT
		DATA qualifiers  (nqual_at3f+0)	/ 'ALL '	/
		DATA qualifiers  (nqual_at3f+1)	/ 'PRECISION'	/
		DATA qualifiers  (nqual_at3f+2)	/ 'FILE'	/
		DATA qualifiers  (nqual_at3f+3)	/ 'FORMAT'	/
		DATA qualifiers  (nqual_at3f+4)	/ 'HEADING'	/
		DATA qualifiers  (nqual_at3f+5)	/ 'APPEND'	/
		DATA qualifiers  (nqual_at3f+6)	/ 'OUTTYPE'	/
* CANCEL DATA_SET
	   DATA subcommands      (nsub_at3 + 6)	/ 'DATA'	/
	   DATA num_qualifs      (nsub_at3 + 6)	/ nqual3g	/
	   DATA qualifier_pointer(nsub_at3 + 6)	/ nqual_at3g	/
* CANCEL DATA /ALL
		DATA qualifiers  (nqual_at3g+0)	/ 'ALL '	/
		DATA qualifiers  (nqual_at3g+1)	/ 'NOERROR'	/
		DATA qualifiers  (nqual_at3g+2)	/ 'FMASK'	/
* CANCEL MODE
	   DATA subcommands      (nsub_at3 + 7)	/ 'MODE'	/
	   DATA num_qualifs      (nsub_at3 + 7)	/ nqual3h	/
	   DATA qualifier_pointer(nsub_at3 + 7)	/ nqual_at3h	/
* CANCEL MODE / ****
		DATA qualifiers  (nqual_at3h+0)	/ '****'	/
* CANCEL MOVIE
	   DATA subcommands      (nsub_at3 + 8)	/ 'MOVIE'	/
	   DATA num_qualifs      (nsub_at3 + 8)	/ nqual3i	/
	   DATA qualifier_pointer(nsub_at3 + 8)	/ nqual_at3i	/
* CANCEL MOVIE /ALL
		DATA qualifiers  (nqual_at3i+0)	/ 'ALL '	/
* CANCEL VIEWPORT
	   DATA subcommands      (nsub_at3 + 9)	/ 'VIEWPORT'	/
	   DATA num_qualifs      (nsub_at3 + 9)	/ nqual3j	/
	   DATA qualifier_pointer(nsub_at3 + 9)	/ nqual_at3j	/
		DATA qualifiers  (nqual_at3j+0)	/ '****' /
* CANCEL VARIABLE
	   DATA subcommands      (nsub_at3 +10)	/ 'VARIABLE'	/
	   DATA num_qualifs      (nsub_at3 +10)	/ nqual3k	/
	   DATA qualifier_pointer(nsub_at3 +10)	/ nqual_at3k	/
		DATA qualifiers  (nqual_at3k+0)	/ 'ALL '	/
		DATA qualifiers  (nqual_at3k+1)	/ 'DATASET'	/
		DATA qualifiers  (nqual_at3k+2)	/ 'LAYERZ'	/
		DATA qualifiers  (nqual_at3k+3)	/ 'CURVILINEAR'	/
		DATA qualifiers  (nqual_at3k+4)	/ 'NOERROR'	/
		DATA qualifiers  (nqual_at3k+5)	/ '****'	/
* CANCEL AXIS
	   DATA subcommands      (nsub_at3 +11)	/ 'AXIS'	/
	   DATA num_qualifs      (nsub_at3 +11)	/ nqual3l	/
	   DATA qualifier_pointer(nsub_at3 +11)	/ nqual_at3l	/
		DATA qualifiers  (nqual_at3l+0)	/ 'MODULO'	/
		DATA qualifiers  (nqual_at3l+1)	/ 'ALL'         /
		DATA qualifiers  (nqual_at3l+2)	/ 'DEPTH'       /
		DATA qualifiers  (nqual_at3l+3) / 'STRIDE'      /
		DATA qualifiers  (nqual_at3l+4) / '****'        /
		DATA qualifiers  (nqual_at3l+5) / '****'        /
* CANCEL GRID
	   DATA subcommands      (nsub_at3 +12)	/ 'GRID'	/
	   DATA num_qualifs      (nsub_at3 +12)	/ nqual3m	/
	   DATA qualifier_pointer(nsub_at3 +12)	/ nqual_at3m	/
		DATA qualifiers  (nqual_at3m+0)	/ '****'	/
* CANCEL ATTRIBUTE /OUTPUT /DATASET
	   DATA subcommands      (nsub_at3 +13)	/ 'ATTRIBUT'	/
	   DATA num_qualifs      (nsub_at3 +13)	/ nqual3n	/
	   DATA qualifier_pointer(nsub_at3 +13)	/ nqual_at3n	/
		DATA qualifiers  (nqual_at3n+0)	/ 'OUTPUT'	/
		DATA qualifiers  (nqual_at3n+1)	/ 'DATASET'	/
* CANCEL REDIRECT
	   DATA subcommands      (nsub_at3 +14)	/ 'REDIRECT'	/
	   DATA num_qualifs      (nsub_at3 +14)	/ nqual3o	/
	   DATA qualifier_pointer(nsub_at3 +14)	/ nqual_at3o	/
		DATA qualifiers  (nqual_at3o+0)	/ '****'	/
* CANCEL ALIAS
	   DATA subcommands      (nsub_at3 +15)	/ 'ALIAS'	/
	   DATA num_qualifs      (nsub_at3 +15)	/ nqual3p	/
	   DATA qualifier_pointer(nsub_at3 +15)	/ nqual_at3p	/
		DATA qualifiers  (nqual_at3p+0)	/ 'ALL'	/
* CANCEL SYMBOL							  
	   DATA subcommands      (nsub_at3 +16)	/ 'SYMBOL'	/
	   DATA num_qualifs      (nsub_at3 +16)	/ nqual3q	/
	   DATA qualifier_pointer(nsub_at3 +16)	/ nqual_at3q	/
		DATA qualifiers  (nqual_at3q+0)	/ 'ALL'	/
* CANCEL NCCACHE
	   DATA subcommands      (nsub_at3 +17)	/ 'NCCACHE'	/
	   DATA num_qualifs      (nsub_at3 +17)	/ nqual3r	/
	   DATA qualifier_pointer(nsub_at3 +17)	/ nqual_at3r	/
		DATA qualifiers  (nqual_at3r+0)	/ '****'	/
* CANCEL PYVAR                  ! in PyFerret
	   DATA subcommands      (nsub_at3 +18)	/ '****'	/	! PYVAR in PyFerret
	   DATA num_qualifs      (nsub_at3 +18)	/ nqual3s	/
	   DATA qualifier_pointer(nsub_at3 +18)	/ nqual_at3s	/
		DATA qualifiers  (nqual_at3s+0)	/ '****'	/	! ALL in PyFerret
		DATA qualifiers  (nqual_at3s+1)	/ '****'	/	! DATASET in PyFerret
		DATA qualifiers  (nqual_at3s+2)	/ '****'	/
* CANCEL TEXT				    ! in PyFerret
	   DATA subcommands      (nsub_at3 +19)	/ '****'	/	! TEXT in PyFeret
	   DATA num_qualifs      (nsub_at3 +19)	/ nqual3t	/
	   DATA qualifier_pointer(nsub_at3 +19)	/ nqual_at3t	/
		DATA qualifiers  (nqual_at3t+0)	/ '****'	/	! FONT in PyFerret
		DATA qualifiers  (nqual_at3t+1)	/ '****'	/	! COLOR in PyFerret
		DATA qualifiers  (nqual_at3t+2)	/ '****'	/	! ITALIC in PyFerret
		DATA qualifiers  (nqual_at3t+3)	/ '****'	/	! BOLD in PyFerret
		DATA qualifiers  (nqual_at3t+4)	/ '****'	/	! ISIZ in PyFerret
		DATA qualifiers  (nqual_at3t+5)	/ '****'	/	! ALL in PyFerret
		DATA qualifiers  (nqual_at3t+6)	/ '****'	/

* CONTOUR - command # 4
	DATA commands(4)			/ 'CONTOUR'	/
        DATA its_action_command(4)              / .TRUE.        /
	DATA num_subcommands(4)			/ nsub4		/
	DATA subcommand_pointer(4)		/ nsub_at4	/
* CONTOUR '    '
	   DATA subcommands      (nsub_at4 + 0)	/ '    '	/
	   DATA num_qualifs      (nsub_at4 + 0)	/ nqual4a	/
	   DATA qualifier_pointer(nsub_at4 + 0)	/ nqual_at4a	/
* CONTOUR/I/J/K/L/M/N/X/Y/Z/T/E/F/DATASET/OVERLAY/SET_UP/FRAME/TRANSPOSE
		DATA qualifiers  (nqual_at4a+0)	/ 'I'	/
		DATA qualifiers  (nqual_at4a+1)	/ 'J'	/
		DATA qualifiers  (nqual_at4a+2)	/ 'K'	/
		DATA qualifiers  (nqual_at4a+3)	/ 'L'	/
		DATA qualifiers  (nqual_at4a+4)	/ 'M'	/
		DATA qualifiers  (nqual_at4a+5)	/ 'N'	/
		DATA qualifiers  (nqual_at4a+6)	/ 'X'	/
		DATA qualifiers  (nqual_at4a+7)	/ 'Y'	/
		DATA qualifiers  (nqual_at4a+8)	/ 'Z'	/
		DATA qualifiers  (nqual_at4a+9)	/ 'T'	/
		DATA qualifiers  (nqual_at4a+10)/ 'E'	/
		DATA qualifiers  (nqual_at4a+11)/ 'F'	/
		DATA qualifiers  (nqual_at4a+12)/ 'OVERLAY'/	!/overlays
		DATA qualifiers  (nqual_at4a+13)/ 'SET_UP'/	!/set_up
		DATA qualifiers  (nqual_at4a+14)/ 'FRAME'/	!/frame
		DATA qualifiers  (nqual_at4a+15)/ 'DATASET'   /	!/data_set
		DATA qualifiers  (nqual_at4a+16)/ 'TRANPOSE'/	!/transpose
		DATA qualifiers  (nqual_at4a+17)/ 'FILL'/	!
		DATA qualifiers  (nqual_at4a+18)/ 'LINE'/	!
		DATA qualifiers  (nqual_at4a+19)/ 'NOLABEL'/	!/nolabel
		DATA qualifiers  (nqual_at4a+20)/ 'LEVELS'/	!/levels_same
		DATA qualifiers  (nqual_at4a+21)/ 'KEY' /	!
		DATA qualifiers  (nqual_at4a+22)/ 'NOKEY'/	!
		DATA qualifiers  (nqual_at4a+23)/ 'PALETTE'/	!
		DATA qualifiers  (nqual_at4a+24)/ 'XLIMITS'/	!/xlimits
		DATA qualifiers  (nqual_at4a+25)/ 'YLIMITS'/	!/ylimits
		DATA qualifiers  (nqual_at4a+26)/ 'TITLE'/	!/title
		DATA qualifiers  (nqual_at4a+27)/ 'COLOR'/	!/color
		DATA qualifiers  (nqual_at4a+28)/ 'NOAXES'/	!/noaxes
		DATA qualifiers  (nqual_at4a+29)/ 'PATTERN'/	!/pattern=
		DATA qualifiers  (nqual_at4a+30)/ 'SIZE'/	!/size
		DATA qualifiers  (nqual_at4a+31)/ 'SPACING'/	!/spacing
		DATA qualifiers  (nqual_at4a+32)/ 'SIGDIG'/	!/sigdig
		DATA qualifiers  (nqual_at4a+33)/ 'PEN'/	!/pen (denig!!)
		DATA qualifiers  (nqual_at4a+34)/ 'HLIMITS'/	! horiz
		DATA qualifiers  (nqual_at4a+35)/ 'VLIMITS'/	! vertical
		DATA qualifiers  (nqual_at4a+36)/ '****'/	! HLOG (place holder, not implemented for contuor) 
		DATA qualifiers  (nqual_at4a+37)/ '****'/	! VLOG (place holder)
		DATA qualifiers  (nqual_at4a+38)/ 'AXES'/	! /axes[=...]
		DATA qualifiers  (nqual_at4a+39)/ 'HGRATICU'/	! tic liness, dash or line
		DATA qualifiers  (nqual_at4a+40)/ 'VGRATICU'/	! tic liness, color or pen#
		DATA qualifiers  (nqual_at4a+41)/ 'GRATICUL'/	! 
		DATA qualifiers  (nqual_at4a+42)/ 'MODULO'/	! modulo for curvilinear plots
		DATA qualifiers  (nqual_at4a+43)/ '****'/	! THICKNESS in PyFerret
		DATA qualifiers  (nqual_at4a+44)/ '****'/	! OPACITY in PyFerret
		DATA qualifiers  (nqual_at4a+45)/ 'DEGMINSEC'/	! Request deg/min or deg/min/sec axis labels
		DATA qualifiers  (nqual_at4a+46)/ 'HALFSPAC'/	! Request a space before the E/W or N/S on axis labels
		DATA qualifiers  (nqual_at4a+47)/ '****'/	! 

* LIST	 - command # 5
	DATA commands(5)			/ 'LIST'	/
        DATA its_action_command(5)              / .TRUE.        /
	DATA num_subcommands(5)			/ nsub5		/
	DATA subcommand_pointer(5)		/ nsub_at5	/
* LIST '    '
	   DATA subcommands      (nsub_at5 + 0)	/ '    '	/
	   DATA num_qualifs      (nsub_at5 + 0)	/ nqual5a	/
	   DATA qualifier_pointer(nsub_at5 + 0)	/ nqual_at5a	/
* LIST/I/J/K/L/M/N/X/Y/Z/T/E/F/D /HEAD /NOHEAD /G /FILE /APPEND /ORDER /FORMAT /QUIET 
		DATA qualifiers  (nqual_at5a+0)	/ 'I'	/
		DATA qualifiers  (nqual_at5a+1)	/ 'J'	/
		DATA qualifiers  (nqual_at5a+2)	/ 'K'	/
		DATA qualifiers  (nqual_at5a+3)	/ 'L'	/
		DATA qualifiers  (nqual_at5a+4)	/ 'M'	/
		DATA qualifiers  (nqual_at5a+5)	/ 'N'	/
		DATA qualifiers  (nqual_at5a+6)	/ 'X'	/
		DATA qualifiers  (nqual_at5a+7)	/ 'Y'	/
		DATA qualifiers  (nqual_at5a+8)	/ 'Z'	/
		DATA qualifiers  (nqual_at5a+9)	/ 'T'	/
		DATA qualifiers  (nqual_at5a+10)/ 'E'	/
		DATA qualifiers  (nqual_at5a+11)/ 'F'	/
		DATA qualifiers  (nqual_at5a+12)/ 'DATASET'	/
		DATA qualifiers  (nqual_at5a+13)/ 'HEADING'/
		DATA qualifiers  (nqual_at5a+14)/ 'NOHEAD'/
		DATA qualifiers  (nqual_at5a+15)/ 'SINGLY'/
		DATA qualifiers  (nqual_at5a+16)/ 'FILE'/
		DATA qualifiers  (nqual_at5a+17)/ 'APPEND'/
		DATA qualifiers  (nqual_at5a+18)/ 'ORDER'/
		DATA qualifiers  (nqual_at5a+19)/ 'FORMAT'/
		DATA qualifiers  (nqual_at5a+20)/ 'TITLE'/
		DATA qualifiers  (nqual_at5a+21)/ 'PRECISION'/ !used to be EPKEY 
		DATA qualifiers  (nqual_at5a+22)/ 'RIGID'/ ! /RIGID (CDF)
		DATA qualifiers  (nqual_at5a+23)/ 'ILIMITS'/ 
		DATA qualifiers  (nqual_at5a+24)/ 'JLIMITS'/
		DATA qualifiers  (nqual_at5a+25)/ 'KLIMITS'/
		DATA qualifiers  (nqual_at5a+26)/ 'LLIMITS'/
		DATA qualifiers  (nqual_at5a+27)/ 'MLIMITS'/
		DATA qualifiers  (nqual_at5a+28)/ 'NLIMITS'/
		DATA qualifiers  (nqual_at5a+29)/ 'XLIMITS'/
		DATA qualifiers  (nqual_at5a+30)/ 'YLIMITS'/
		DATA qualifiers  (nqual_at5a+31)/ 'ZLIMITS'/
		DATA qualifiers  (nqual_at5a+32)/ 'TLIMITS'/
		DATA qualifiers  (nqual_at5a+33)/ 'ELIMITS'/
		DATA qualifiers  (nqual_at5a+34)/ 'FLIMITS'/
		DATA qualifiers  (nqual_at5a+35)/ 'CLOBBER'/
		DATA qualifiers  (nqual_at5a+36)/ 'QUIET'/
		DATA qualifiers  (nqual_at5a+37)/ 'WIDTH'/
		DATA qualifiers  (nqual_at5a+38)/ 'EDGES'/
		DATA qualifiers  (nqual_at5a+39)/ 'BOUNDS'/
		DATA qualifiers  (nqual_at5a+40)/ 'NOBOUNDS'/
		DATA qualifiers  (nqual_at5a+41)/ 'NOROWLAB'/
		DATA qualifiers  (nqual_at5a+42)/ 'KEEP_AXI'/
		DATA qualifiers  (nqual_at5a+43)/ 'NCFORMAT'/
		DATA qualifiers  (nqual_at5a+44)/ 'XCHUNK'/
		DATA qualifiers  (nqual_at5a+45)/ 'YCHUNK'/
		DATA qualifiers  (nqual_at5a+46)/ 'ZCHUNK'/
		DATA qualifiers  (nqual_at5a+47)/ 'TCHUNK'/
		DATA qualifiers  (nqual_at5a+48)/ 'ECHUNK'/
		DATA qualifiers  (nqual_at5a+49)/ 'FCHUNK'/
		DATA qualifiers  (nqual_at5a+50)/ 'DEFLATE'/
		DATA qualifiers  (nqual_at5a+51)/ 'SHUFFLE'/
		DATA qualifiers  (nqual_at5a+52)/ 'ENDIAN'/
		DATA qualifiers  (nqual_at5a+53)/ 'OUTTYPE'/
		DATA qualifiers  (nqual_at5a+54)/ 'CURVILIN'/
		DATA qualifiers  (nqual_at5a+55)/ 'LAYERZ'/
		DATA qualifiers  (nqual_at5a+56)/ 'ASGLOBAL'/
		DATA qualifiers  (nqual_at5a+57)/ 'STRLEN'/   ! user-set length of string-dimension
		DATA qualifiers  (nqual_at5a+58)/ 'NOCOORDS'/ ! write dimensions only not coord vars. 
		DATA qualifiers  (nqual_at5a+59)/ '****'/

* PLOT - command # 6
	DATA commands(6)			/ 'PLOT'	/
        DATA its_action_command(6)              / .TRUE.        /
	DATA num_subcommands(6)			/ nsub6		/
	DATA subcommand_pointer(6)		/ nsub_at6	/
* PLOT '    '
	   DATA subcommands      (nsub_at6 + 0)	/ '    '	/
	   DATA num_qualifs      (nsub_at6 + 0)	/ nqual6a	/
	   DATA qualifier_pointer(nsub_at6 + 0)	/ nqual_at6a	/
* PLOT/I/J/K/L/M/N/X/Y/Z/T/E/F/DATASET/OVERLAY/SET_UP/FRAME/TRANSPOSE/VS
		DATA qualifiers  (nqual_at6a+0)	/ 'I'	/
		DATA qualifiers  (nqual_at6a+1)	/ 'J'	/
		DATA qualifiers  (nqual_at6a+2)	/ 'K'	/
		DATA qualifiers  (nqual_at6a+3)	/ 'L'	/
		DATA qualifiers  (nqual_at6a+4)	/ 'M'	/
		DATA qualifiers  (nqual_at6a+5)	/ 'N'	/
		DATA qualifiers  (nqual_at6a+6)	/ 'X'	/
		DATA qualifiers  (nqual_at6a+7)	/ 'Y'	/
		DATA qualifiers  (nqual_at6a+8)	/ 'Z'	/
		DATA qualifiers  (nqual_at6a+9) / 'T'	/
		DATA qualifiers  (nqual_at6a+10)/ 'E'	/
		DATA qualifiers  (nqual_at6a+11)/ 'F'	/
		DATA qualifiers  (nqual_at6a+12)/ 'ALONG'/	!/along
		DATA qualifiers  (nqual_at6a+13)/ 'OVERLAY'/	!/overlays
		DATA qualifiers  (nqual_at6a+14)/ 'SET_UP'/	!/set_up
		DATA qualifiers  (nqual_at6a+15)/ 'FRAME'/	!/frame
		DATA qualifiers  (nqual_at6a+16)/ 'DATASET'   /	!/data_set
		DATA qualifiers  (nqual_at6a+17)/ 'TRANPOSE'/	!/transpose
		DATA qualifiers  (nqual_at6a+18)/ 'VS  '/	!/versus
		DATA qualifiers  (nqual_at6a+19)/ 'SYMBOL'/	!/symbol
		DATA qualifiers  (nqual_at6a+20)/ 'NOLABEL'/	!/nolabel
		DATA qualifiers  (nqual_at6a+21)/ 'LINE'/	!/line
		DATA qualifiers  (nqual_at6a+22)/ 'COLOR'/	!/color
		DATA qualifiers  (nqual_at6a+23)/ 'THICKNES'/	!/thickness
		DATA qualifiers  (nqual_at6a+24)/ 'XLIMITS'/	!/xlimits
		DATA qualifiers  (nqual_at6a+25)/ 'YLIMITS'/	!/ylimits
		DATA qualifiers  (nqual_at6a+26)/ 'TITLE'/	!/title
		DATA qualifiers  (nqual_at6a+27)/ 'SIZE'/	!/size
		DATA qualifiers  (nqual_at6a+28)/ 'NOAXES'/	!/noaxes
		DATA qualifiers  (nqual_at6a+29)/ 'STEP'/	!/step
		DATA qualifiers  (nqual_at6a+30)/ 'DASH'/	!/dash
		DATA qualifiers  (nqual_at6a+31)/ 'AXES'/	!/axes[=]
		DATA qualifiers  (nqual_at6a+32)/ 'HGRATICU'/	!horiz tic lines
		DATA qualifiers  (nqual_at6a+33)/ 'VGRATICU'/	!vert tic lines
		DATA qualifiers  (nqual_at6a+34)/ 'HLIMITS'/	! horiz
		DATA qualifiers  (nqual_at6a+35)/ 'VLIMITS'/	! vertical
		DATA qualifiers  (nqual_at6a+36)/ 'HLOG'/	! log axis horiz
		DATA qualifiers  (nqual_at6a+37)/ 'VLOG'/	! log axis vert
		DATA qualifiers  (nqual_at6a+38)/ 'GRATICUL'/	! tic lines
		DATA qualifiers  (nqual_at6a+39)/ 'NOKEY'/	! nokey
		DATA qualifiers  (nqual_at6a+40)/ 'NOYADJUS'/	! noyadjust
		DATA qualifiers  (nqual_at6a+41)/ 'KEY'/	! [=cont] for Ribbon plot
		DATA qualifiers  (nqual_at6a+42)/ 'RIBBON'/	! for Ribbon plot
		DATA qualifiers  (nqual_at6a+43)/ 'LEVELS'/	! 
		DATA qualifiers  (nqual_at6a+44)/ 'PALETTE'/	! 
		DATA qualifiers  (nqual_at6a+45)/ 'FAST'/	! style for Ribbon plot
		DATA qualifiers  (nqual_at6a+46)/ 'MISSING'/	! For missing-dat in ribbon plot
		DATA qualifiers  (nqual_at6a+47)/ '****'/	! OPACITY in PyFerret
		DATA qualifiers  (nqual_at6a+48)/ 'GAPLOC'/     ! A variable marking gaps to insert in PLOT/VS
		DATA qualifiers  (nqual_at6a+49)/ 'SKIPSYM'/	! Control for symbol decimation
		DATA qualifiers  (nqual_at6a+50)/ 'DEGMINSEC'/	! Request deg/min or deg/min/sec axis labels
		DATA qualifiers  (nqual_at6a+51)/ 'HALFSPAC'/	! Request a space before the E/W or N/S on axis labels
		DATA qualifiers  (nqual_at6a+52)/ '****'/	! HIGHLIGHT in PyFerret
		DATA qualifiers  (nqual_at6a+53)/ '****'/	! unused
		DATA qualifiers  (nqual_at6a+54)/ '****'/	! unused
		DATA qualifiers  (nqual_at6a+55)/ '****'/	! unused

* GO	 - command # 7
	DATA commands(7)			/ 'GO  '	/
        DATA its_action_command(7)              / .FALSE.       /
	DATA num_subcommands(7)			/ nsub7		/
	DATA subcommand_pointer(7)		/ nsub_at7	/
* GO '    '
	   DATA subcommands      (nsub_at7 + 0)	/ '    '	/
	   DATA num_qualifs      (nsub_at7 + 0)	/ nqual7a	/
	   DATA qualifier_pointer(nsub_at7 + 0)	/ nqual_at7a	/
* GO (8 unused qualifiers)
		DATA qualifiers  (nqual_at7a+0)	/ 'HELP'	/
		DATA qualifiers  (nqual_at7a+1)	/ '****'	/
		DATA qualifiers  (nqual_at7a+2)	/ '****'	/
		DATA qualifiers  (nqual_at7a+3)	/ '****'	/
		DATA qualifiers  (nqual_at7a+4)	/ '****'	/
		DATA qualifiers  (nqual_at7a+5)	/ '****'	/
		DATA qualifiers  (nqual_at7a+6)	/ '****'	/
		DATA qualifiers  (nqual_at7a+7)	/ '****'	/
		DATA qualifiers  (nqual_at7a+8)	/ '****'	/

* HELP	 - command # 8
	DATA commands(8)			/ 'HELP'	/
        DATA its_action_command(8)              / .FALSE.       /
	DATA num_subcommands(8)			/ nsub8		/
	DATA subcommand_pointer(8)		/ nsub_at8	/
* HELP '    '
	   DATA subcommands      (nsub_at8 + 0)	/ '    '	/
	   DATA num_qualifs      (nsub_at8 + 0)	/ nqual8a	/
	   DATA qualifier_pointer(nsub_at8 + 0)	/ nqual_at8a	/

* LOAD - command # 9
	DATA commands(9)			/ 'LOAD'	/
        DATA its_action_command(9)              / .TRUE.        /
	DATA num_subcommands(9)			/ nsub9		/
	DATA subcommand_pointer(9)		/ nsub_at9	/
* LOAD '    '
	   DATA subcommands      (nsub_at9 + 0)	/ '    '	/
	   DATA num_qualifs      (nsub_at9 + 0)	/ nqual9a	/
	   DATA qualifier_pointer(nsub_at9 + 0)	/ nqual_at9a	/
* LOAD /TEMPORARY /PERMANENT /I/J/K/L/M/N/X/Y/Z/T/E/F/D /NAME
		DATA qualifiers  (nqual_at9a+0)	/ 'TEMPORY'/
		DATA qualifiers  (nqual_at9a+1)	/ 'PERMANT'/
		DATA qualifiers  (nqual_at9a+2)	/ 'I'	/
		DATA qualifiers  (nqual_at9a+3)	/ 'J'	/
		DATA qualifiers  (nqual_at9a+4)	/ 'K'	/
		DATA qualifiers  (nqual_at9a+5)	/ 'L'	/
		DATA qualifiers  (nqual_at9a+6)	/ 'M'	/
		DATA qualifiers  (nqual_at9a+7)	/ 'N'	/
		DATA qualifiers  (nqual_at9a+8)	/ 'X'	/
		DATA qualifiers  (nqual_at9a+9)	/ 'Y'	/
		DATA qualifiers  (nqual_at9a+10)/ 'Z'	/
		DATA qualifiers  (nqual_at9a+11)/ 'T'	/
		DATA qualifiers  (nqual_at9a+12)/ 'E'	/
		DATA qualifiers  (nqual_at9a+13)/ 'F'	/
		DATA qualifiers  (nqual_at9a+14)/ 'DATASET'	/
		DATA qualifiers  (nqual_at9a+15)/ 'NAME'/

* DEFINE - command # 10
	DATA commands(10)			/ 'DEFINE'	/
        DATA its_action_command(10)             / .FALSE.       /
	DATA num_subcommands(10)		/ nsub10	/
	DATA subcommand_pointer(10)		/ nsub_at10	/
* DEFINE '    '
	   DATA subcommands      (nsub_at10 + 0)/ '    '	/
	   DATA num_qualifs      (nsub_at10 + 0)/ nqual10a	/
	   DATA qualifier_pointer(nsub_at10 + 0)/ nqual_at10a	/
* DEFINE REGION
	   DATA subcommands      (nsub_at10 + 1)/ 'REGION'	/
	   DATA num_qualifs      (nsub_at10 + 1)/ nqual10b	/
	   DATA qualifier_pointer(nsub_at10 + 1)/ nqual_at10b	/
* DEFINE REGION /I/J/K/L/M/N/X/Y/Z/T/E/F /DEFAULT / ****
		DATA qualifiers  (nqual_at10b+0)/ 'I'	/
		DATA qualifiers  (nqual_at10b+1)/ 'J'	/
		DATA qualifiers  (nqual_at10b+2)/ 'K'	/
		DATA qualifiers  (nqual_at10b+3)/ 'L'	/
		DATA qualifiers  (nqual_at10b+4)/ 'M'	/
		DATA qualifiers  (nqual_at10b+5)/ 'N'	/
		DATA qualifiers  (nqual_at10b+6)/ 'X'	/
		DATA qualifiers  (nqual_at10b+7)/ 'Y'	/
		DATA qualifiers  (nqual_at10b+8)/ 'Z'	/
		DATA qualifiers  (nqual_at10b+9)/ 'T'	/
		DATA qualifiers  (nqual_at10b+10)/ 'E'	/
		DATA qualifiers  (nqual_at10b+11)/ 'F'	/
		DATA qualifiers  (nqual_at10b+12)/ 'DEFAULT'/
		DATA qualifiers  (nqual_at10b+13)/ '****'/
		DATA qualifiers  (nqual_at10b+14)/ 'DX'/
		DATA qualifiers  (nqual_at10b+15)/ 'DY'/
		DATA qualifiers  (nqual_at10b+16)/ 'DZ'/
		DATA qualifiers  (nqual_at10b+17)/ 'DT'/
		DATA qualifiers  (nqual_at10b+18)/ 'DE'/
		DATA qualifiers  (nqual_at10b+19)/ 'DF'/
		DATA qualifiers  (nqual_at10b+20)/ 'DI'/
		DATA qualifiers  (nqual_at10b+21)/ 'DJ'/
		DATA qualifiers  (nqual_at10b+22)/ 'DK'/
		DATA qualifiers  (nqual_at10b+23)/ 'DL'/
		DATA qualifiers  (nqual_at10b+24)/ 'DM'/
		DATA qualifiers  (nqual_at10b+25)/ 'DN'/
* DEFINE GRID
	   DATA subcommands      (nsub_at10 + 2)/ 'GRID'	/
	   DATA num_qualifs      (nsub_at10 + 2)/ nqual10c	/
	   DATA qualifier_pointer(nsub_at10 + 2)/ nqual_at10c	/
* DEFINE GRID /X/Y/Z/T/E/F /FILE /LIKE
		DATA qualifiers  (nqual_at10c+ 0)/ 'X'	  /
		DATA qualifiers  (nqual_at10c+ 1)/ 'Y'	  /
		DATA qualifiers  (nqual_at10c+ 2)/ 'Z'	  /
		DATA qualifiers  (nqual_at10c+ 3)/ 'T'	  /
		DATA qualifiers  (nqual_at10c+ 4)/ 'E'	  /
		DATA qualifiers  (nqual_at10c+ 5)/ 'F'	  /
		DATA qualifiers  (nqual_at10c+ 6)/ 'FILE' /
		DATA qualifiers  (nqual_at10c+ 7)/ 'LIKE' /
		DATA qualifiers  (nqual_at10c+ 8)/ '****' /
		DATA qualifiers  (nqual_at10c+ 9)/ '****' /
		DATA qualifiers  (nqual_at10c+10)/ '****' /
* DEFINE VARIABLE
	   DATA subcommands      (nsub_at10 + 3)/ 'VARIABLE'	/
	   DATA num_qualifs      (nsub_at10 + 3)/ nqual10d	/
	   DATA qualifier_pointer(nsub_at10 + 3)/ nqual_at10d	/
* DEFINE VARIABLE /TITLE /UNITS /QUIET /DATASET /BAD /REMOTE /LIKE
		DATA qualifiers  (nqual_at10d+ 0)/ 'TITLE' /
		DATA qualifiers  (nqual_at10d+ 1)/ 'UNITS' /
		DATA qualifiers  (nqual_at10d+ 2)/ 'QUIET' /
		DATA qualifiers  (nqual_at10d+ 3)/ 'DATASET' /
		DATA qualifiers  (nqual_at10d+ 4)/ 'BAD' /
		DATA qualifiers  (nqual_at10d+ 5)/ 'REMOTE' /
		DATA qualifiers  (nqual_at10d+ 6)/ 'LIKE' /
		DATA qualifiers  (nqual_at10d+ 7)/ '****' /
		DATA qualifiers  (nqual_at10d+ 8)/ '****' /
		DATA qualifiers  (nqual_at10d+ 9)/ '****' /
* DEFINE AXIS
	   DATA subcommands      (nsub_at10 + 4)/ 'AXIS'	/
	   DATA num_qualifs      (nsub_at10 + 4)/ nqual10e	/
	   DATA qualifier_pointer(nsub_at10 + 4)/ nqual_at10e	/
* DEFINE AXIS /X/Y/Z/T/E/F /FILE /UNITS /QUIET /MONTHLY /LIKE ...
		DATA qualifiers  (nqual_at10e+ 0)/ 'X'	  /
		DATA qualifiers  (nqual_at10e+ 1)/ 'Y'	  /
		DATA qualifiers  (nqual_at10e+ 2)/ 'Z'	  /
		DATA qualifiers  (nqual_at10e+ 3)/ 'T'	  /
		DATA qualifiers  (nqual_at10e+ 4)/ 'E'	  /
		DATA qualifiers  (nqual_at10e+ 5)/ 'F'	  /
		DATA qualifiers  (nqual_at10e+ 6)/ 'FILE' /
		DATA qualifiers  (nqual_at10e+ 7)/ 'UNITS' /
		DATA qualifiers  (nqual_at10e+ 8)/ 'T0' /
		DATA qualifiers  (nqual_at10e+ 9)/ 'NAME' /
		DATA qualifiers  (nqual_at10e+ 10)/ 'FROMDATA' /
		DATA qualifiers  (nqual_at10e+ 11)/ 'DEPTH' /
		DATA qualifiers  (nqual_at10e+ 12)/ 'MODULO' /
		DATA qualifiers  (nqual_at10e+ 13)/ 'NPOINTS' /
		DATA qualifiers  (nqual_at10e+ 14)/ 'EDGES' /
		DATA qualifiers  (nqual_at10e+ 15)/ 'CALENDAR' /
		DATA qualifiers  (nqual_at10e+ 16)/ 'BOUNDS' /
		DATA qualifiers  (nqual_at10e+ 17)/ 'QUIET' /
		DATA qualifiers  (nqual_at10e+ 18)/ 'MONTHLY' /
		DATA qualifiers  (nqual_at10e+ 19)/ 'LIKE' /
* DEFINE VIEW
	   DATA subcommands      (nsub_at10 + 5)/ 'VIEWPORT'	/
	   DATA num_qualifs      (nsub_at10 + 5)/ nqual10f	/
	   DATA qualifier_pointer(nsub_at10 + 5)/ nqual_at10f	/
* DEFINE VIEW /SIZE/TEXT/XLIMITS/YLIMITS/AXES ****
		DATA qualifiers  (nqual_at10f+ 0)/ 'TEXT' /
		DATA qualifiers  (nqual_at10f+ 1)/ 'XLIMITS' /
		DATA qualifiers  (nqual_at10f+ 2)/ 'YLIMITS' /
		DATA qualifiers  (nqual_at10f+ 3)/ 'SIZE' /
		DATA qualifiers  (nqual_at10f+ 4)/ 'ORIGIN' /
		DATA qualifiers  (nqual_at10f+ 5)/ 'CLIP' /
		DATA qualifiers  (nqual_at10f+ 6)/ 'AXES' /
		DATA qualifiers  (nqual_at10f+ 7)/ '****' /
* DEFINE ALIAS
	   DATA subcommands      (nsub_at10 + 6)/ 'ALIAS'	/
	   DATA num_qualifs      (nsub_at10 + 6)/ nqual10g	/
	   DATA qualifier_pointer(nsub_at10 + 6)/ nqual_at10g	/
* DEFINE ALIAS / ****
		DATA qualifiers  (nqual_at10g+ 0)/ '****' /
		DATA qualifiers  (nqual_at10g+ 1)/ '****' /
* DEFINE SYMBOL
	   DATA subcommands      (nsub_at10 + 7)/ 'SYMBOL'	/
	   DATA num_qualifs      (nsub_at10 + 7)/ nqual10h	/
	   DATA qualifier_pointer(nsub_at10 + 7)/ nqual_at10h	/
* DEFINE SYMBOL / ****
		DATA qualifiers  (nqual_at10h+ 0)/ '****' /
		DATA qualifiers  (nqual_at10h+ 1)/ '****' /
* DEFINE ATTRIBUTE
	   DATA subcommands      (nsub_at10 + 8)/ 'ATTRIBUT'	/
	   DATA num_qualifs      (nsub_at10 + 8)/ nqual10i	/
	   DATA qualifier_pointer(nsub_at10 + 8)/ nqual_at10i	/
* DEFINE ATTRIBUTE /DATASET /TYPE /OUTPUT /QUIET 
		DATA qualifiers  (nqual_at10i+ 0)/ 'DATASET' /
		DATA qualifiers  (nqual_at10i+ 1)/ 'TYPE' /
		DATA qualifiers  (nqual_at10i+ 2)/ 'OUTPUT' /
		DATA qualifiers  (nqual_at10i+ 3)/ 'QUIET' /
* DEFINE PYFUNC
	   DATA subcommands      (nsub_at10 + 9)/ 'PYFUNC'	/
	   DATA num_qualifs      (nsub_at10 + 9)/ nqual10j	/
	   DATA qualifier_pointer(nsub_at10 + 9)/ nqual_at10j	/
* DEFINE PYFUNC /NAME ****
		DATA qualifiers  (nqual_at10j+ 0)/ 'NAME' /
		DATA qualifiers  (nqual_at10j+ 1)/ '****' /
* DEFINE DATA
	   DATA subcommands      (nsub_at10 + 10)/ 'DATA'	/
	   DATA num_qualifs      (nsub_at10 + 10)/ nqual10k	/
	   DATA qualifier_pointer(nsub_at10 + 10)/ nqual_at10k	/
* DEFINE DATA / AGGREGATE /TITLE /QUIET /HIDE /T /E /F /U /TAXIS /FAXIS /TOVERLAP
		DATA qualifiers  (nqual_at10k+ 0)/ 'AGGREGATE' /
		DATA qualifiers  (nqual_at10k+ 1)/ '****' / ! reserved for x
		DATA qualifiers  (nqual_at10k+ 2)/ '****' / ! y
		DATA qualifiers  (nqual_at10k+ 3)/ '****' / ! z
		DATA qualifiers  (nqual_at10k+ 4)/ 'T'    / ! t
		DATA qualifiers  (nqual_at10k+ 5)/ 'E'    / ! e
		DATA qualifiers  (nqual_at10k+ 6)/ 'F'    / ! f
		DATA qualifiers  (nqual_at10k+ 7)/ 'TITLE' /
		DATA qualifiers  (nqual_at10k+ 8)/ 'QUIET' /
		DATA qualifiers  (nqual_at10k+ 9)/ 'HIDE' /
		DATA qualifiers  (nqual_at10k+ 10)/ 'U' /
		DATA qualifiers  (nqual_at10k+ 11)/ 'TAXIS' /
		DATA qualifiers  (nqual_at10k+ 12)/ 'FAXIS' /
		DATA qualifiers  (nqual_at10k+ 13)/ 'TOVERLAP' /
* DEFINE ANNOTATION
	   DATA subcommands      (nsub_at10 + 11)/ 'ANNOTATION'	/
	   DATA num_qualifs      (nsub_at10 + 11)/ nqual10l	/
	   DATA qualifier_pointer(nsub_at10 + 11)/ nqual_at10l	/
* DEFINE ANNOTATION /USER/NORM/NOUSER/XPOS/YPOS/HALIGN/VALIGN/ANGLE/SIZE/NLAB
		DATA qualifiers  (nqual_at10l+ 0)/ 'USER' /
		DATA qualifiers  (nqual_at10l+ 1)/ 'NORM' /
		DATA qualifiers  (nqual_at10l+ 2)/ 'NOUSER' /
		DATA qualifiers  (nqual_at10l+ 3)/ 'XPOS' /
		DATA qualifiers  (nqual_at10l+ 4)/ 'YPOS' /
		DATA qualifiers  (nqual_at10l+ 5)/ 'HALIGN' /
		DATA qualifiers  (nqual_at10l+ 6)/ 'VALIGN' /
		DATA qualifiers  (nqual_at10l+ 7)/ 'ANGLE' /
		DATA qualifiers  (nqual_at10l+ 8)/ 'SIZE' /
		DATA qualifiers  (nqual_at10l+ 9)/ 'NLAB' /
* EXIT	 - command # 11
	DATA commands(11)			/ 'EXIT'	/
        DATA its_action_command(11)             / .FALSE.       /
	DATA num_subcommands(11)		/ nsub11	/
	DATA subcommand_pointer(11)		/ nsub_at11	/
* EXIT '    '
	   DATA subcommands      (nsub_at11 + 0)/ '    '	/
	   DATA num_qualifs      (nsub_at11 + 0)/ nqual11a	/
	   DATA qualifier_pointer(nsub_at11 + 0)/ nqual_at11a	/
* EXIT/COMMAND_FILE etc
		DATA qualifiers  (nqual_at11a+0)/ 'COMMAND'	/
		DATA qualifiers  (nqual_at11a+1)/ 'LOOP'	/
		DATA qualifiers  (nqual_at11a+2)/ 'SCRIPT'	/
		DATA qualifiers  (nqual_at11a+3)/ 'PROMPT'	/
		DATA qualifiers  (nqual_at11a+4)/ 'PROGRAM'	/
		DATA qualifiers  (nqual_at11a+5)/ 'CYCLE'	/
		DATA qualifiers  (nqual_at11a+6)/ 'TOPYTHON'	/
		DATA qualifiers  (nqual_at11a+7)/ '****'	/

* MESSAGE	 - command # 12
	DATA commands(12)			/ 'MESSAGE'	/
        DATA its_action_command(12)             / .FALSE.       /
	DATA num_subcommands(12)		/ nsub12	/
	DATA subcommand_pointer(12)		/ nsub_at12	/
* MESSAGE '    '
	   DATA subcommands      (nsub_at12 + 0)/ '    '	/
	   DATA num_qualifs      (nsub_at12 + 0)/ nqual12a	/
	   DATA qualifier_pointer(nsub_at12 + 0)/ nqual_at12a	/
* MESSAGE/CONTINUE
		DATA qualifiers  (nqual_at12a+0)/ 'CONTINUE'	/
* MESSAGE/QUIET/JOURNAL/ERROR/OUTFILE/APPEND/CLOBBER
		DATA qualifiers  (nqual_at12a+1)/ 'QUIET'	/
		DATA qualifiers  (nqual_at12a+2)/ 'JOURNAL'	/
		DATA qualifiers  (nqual_at12a+3)/ 'ERROR'	/
		DATA qualifiers  (nqual_at12a+4)/ 'OUTFILE'	/
		DATA qualifiers  (nqual_at12a+5)/ 'APPEND'	/
		DATA qualifiers  (nqual_at12a+6)/ 'CLOBBER'	/

* VECTOR - command # 13
	DATA commands(13)			/ 'VECTOR'	/
        DATA its_action_command(13)             / .TRUE.        /
	DATA num_subcommands(13)		/ nsub13	/
	DATA subcommand_pointer(13)		/ nsub_at13	/
* VECTOR '    '
	   DATA subcommands      (nsub_at13 + 0)/ '    '	/
	   DATA num_qualifs      (nsub_at13 + 0)/ nqual13a	/
	   DATA qualifier_pointer(nsub_at13 + 0)/ nqual_at13a	/
* VECTOR/I/J/K/L/M/N/X/Y/Z/T/E/F/DATASET/OVERLAY/SET_UP/FRAME/TRANSPOSE
		DATA qualifiers  (nqual_at13a+0)/ 'I'	/
		DATA qualifiers  (nqual_at13a+1)/ 'J'	/
		DATA qualifiers  (nqual_at13a+2)/ 'K'	/
		DATA qualifiers  (nqual_at13a+3)/ 'L'	/
		DATA qualifiers  (nqual_at13a+4)/ 'M'	/
		DATA qualifiers  (nqual_at13a+5)/ 'N'	/
		DATA qualifiers  (nqual_at13a+6)/ 'X'	/
		DATA qualifiers  (nqual_at13a+7)/ 'Y'	/
		DATA qualifiers  (nqual_at13a+8)/ 'Z'	/
		DATA qualifiers  (nqual_at13a+9)/ 'T'	/
		DATA qualifiers  (nqual_at13a+10)/ 'E'	/
		DATA qualifiers  (nqual_at13a+11)/ 'F'	/
		DATA qualifiers  (nqual_at13a+12)/ 'OVERLAY'/	!/overlays
		DATA qualifiers  (nqual_at13a+13)/ 'SET_UP'/	!/set_up
		DATA qualifiers  (nqual_at13a+14)/ 'FRAME'/	!/frame
		DATA qualifiers  (nqual_at13a+15)/ 'DATASET' /	!/data_set
		DATA qualifiers  (nqual_at13a+16)/ 'TRANPOSE'/	!/transpose
		DATA qualifiers  (nqual_at13a+17)/ '****'/	!
		DATA qualifiers  (nqual_at13a+18)/ 'ASPECT'/	!/aspect
		DATA qualifiers  (nqual_at13a+19)/ 'NOLABEL'/	!/nolabel
		DATA qualifiers  (nqual_at13a+20)/ 'LENGTH'/	!/length_same
		DATA qualifiers  (nqual_at13a+21)/ 'XSKIP'/	!/xskip
		DATA qualifiers  (nqual_at13a+22)/ 'YSKIP'/	!/yskip
		DATA qualifiers  (nqual_at13a+23)/ 'THICK'/	!/thick
		DATA qualifiers  (nqual_at13a+24)/ 'XLIMITS'/	!/xlimits
		DATA qualifiers  (nqual_at13a+25)/ 'YLIMITS'/	!/ylimits
		DATA qualifiers  (nqual_at13a+26)/ 'TITLE'/	!/title
		DATA qualifiers  (nqual_at13a+27)/ 'COLOR'/	!/color
		DATA qualifiers  (nqual_at13a+28)/ 'NOAXES'/	!/noaxes
		DATA qualifiers  (nqual_at13a+29)/ 'NOKEY'/	!/nokey
		DATA qualifiers  (nqual_at13a+30)/ 'FLOWLINE'/	!/flowline
		DATA qualifiers  (nqual_at13a+31)/ 'DENSITY'/	!/density=
		DATA qualifiers  (nqual_at13a+32)/ 'AXES'/	!/axes[=]
		DATA qualifiers  (nqual_at13a+33)/ 'PEN'/	! pen (denigr!)
		DATA qualifiers  (nqual_at13a+34)/ 'HLIMITS'/	! horiz
		DATA qualifiers  (nqual_at13a+35)/ 'VLIMITS'/	! vertical
		DATA qualifiers  (nqual_at13a+36)/ 'HGRATICU'/	! horiz tic lines
		DATA qualifiers  (nqual_at13a+37)/ 'VGRATICU'/	! vert tic lines
		DATA qualifiers  (nqual_at13a+38)/ 'GRATICUL'/
		DATA qualifiers  (nqual_at13a+39)/ 'KEY'/	!KEY 
		DATA qualifiers  (nqual_at13a+40)/ 'MODULO'/
		DATA qualifiers  (nqual_at13a+41)/ '****'/	! OPACITY in PyFerret
		DATA qualifiers  (nqual_at13a+42)/ '****'/
		DATA qualifiers  (nqual_at13a+43)/ '****'/
		DATA qualifiers  (nqual_at13a+44)/ '****'/

* PPLUS	 - command # 14
	DATA commands(14)			/ 'PPLUS'	/
        DATA its_action_command(14)             / .FALSE.       /
	DATA num_subcommands(14)		/ nsub14	/
	DATA subcommand_pointer(14)		/ nsub_at14	/
* PPLUS '    '
	   DATA subcommands      (nsub_at14 + 0)/ '    '	/
	   DATA num_qualifs      (nsub_at14 + 0)/ nqual14a	/
	   DATA qualifier_pointer(nsub_at14 + 0)/ nqual_at14a	/
* PPLUS/RESET
		DATA qualifiers  (nqual_at14a+0)/ 'RESET' /
		DATA qualifiers  (nqual_at14a+1)/ '****' /

* FRAME	 - command # 15
	DATA commands(15)			/ 'FRAME'	/
        DATA its_action_command(15)             / .FALSE.       /
	DATA num_subcommands(15)		/ nsub15	/
	DATA subcommand_pointer(15)		/ nsub_at15	/
* FRAME '    '
	   DATA subcommands      (nsub_at15 + 0)/ '    '	/
	   DATA num_qualifs      (nsub_at15 + 0)/ nqual15a	/
	   DATA qualifier_pointer(nsub_at15 + 0)/ nqual_at15a	/
* FRAME/FORMAT=GIF_or_HDF/FILE=filename/TRANSPARENT[=color]
		DATA qualifiers  (nqual_at15a+0)/ 'FORMAT'	/
		DATA qualifiers  (nqual_at15a+1)/ 'FILE'	/
		DATA qualifiers  (nqual_at15a+2)/ 'TRANSPAR'	/
		DATA qualifiers  (nqual_at15a+3)/ '****'	/ ! XINCHES in PyFerret
		DATA qualifiers  (nqual_at15a+4)/ '****'	/ ! YINCHES in PyFerret
		DATA qualifiers  (nqual_at15a+5)/ '****'	/ ! XPIXELS in PyFerret
		DATA qualifiers  (nqual_at15a+6)/ '****'	/ ! YPIXELS in PyFerret
		DATA qualifiers  (nqual_at15a+7)/ '****'	/ ! ANNOTATE in PyFerret

* REPEAT - command # 16
	DATA commands(16)			/ 'REPEAT'	/
        DATA its_action_command(16)             / .FALSE.       /
	DATA num_subcommands(16)		/ nsub16	/
	DATA subcommand_pointer(16)		/ nsub_at16	/
* REPEAT '    '
	   DATA subcommands      (nsub_at16 + 0)/ '    '	/
	   DATA num_qualifs      (nsub_at16 + 0)/ nqual16a	/
	   DATA qualifier_pointer(nsub_at16 + 0)/ nqual_at16a	/
* REPEAT/I/J/K/L/M/N/X/Y/Z/T/E/F/ANIMATE/LOOP=[N]
		DATA qualifiers  (nqual_at16a+0)/ 'I'	/
		DATA qualifiers  (nqual_at16a+1)/ 'J'	/
		DATA qualifiers  (nqual_at16a+2)/ 'K'	/
		DATA qualifiers  (nqual_at16a+3)/ 'L'	/
		DATA qualifiers  (nqual_at16a+4)/ 'M'	/
		DATA qualifiers  (nqual_at16a+5)/ 'N'	/
		DATA qualifiers  (nqual_at16a+6)/ 'X'	/
		DATA qualifiers  (nqual_at16a+7)/ 'Y'	/
		DATA qualifiers  (nqual_at16a+8)/ 'Z'	/
		DATA qualifiers  (nqual_at16a+9)/ 'T'	/
		DATA qualifiers  (nqual_at16a+10)/ 'E'	/
		DATA qualifiers  (nqual_at16a+11)/ 'F'	/
		DATA qualifiers  (nqual_at16a+12)/ 'ANIMATE' /
		DATA qualifiers  (nqual_at16a+13)/ 'LOOP'  /
		DATA qualifiers  (nqual_at16a+14)/ 'RANGE' /   
		DATA qualifiers  (nqual_at16a+15)/ 'NAME' /   
		DATA qualifiers  (nqual_at16a+16)/ '****' /  

* STATISTICS - command # 17
	DATA commands(17)			/ 'STAT'	/
        DATA its_action_command(17)             / .TRUE.        /
	DATA num_subcommands(17)		/ nsub17	/
	DATA subcommand_pointer(17)		/ nsub_at17	/
* STAT '    '
	   DATA subcommands      (nsub_at17 + 0)	/ '    '	/
	   DATA num_qualifs      (nsub_at17 + 0)	/ nqual17a	/
	   DATA qualifier_pointer(nsub_at17 + 0)	/ nqual_at17a	/
* STAT /BRIEF/PRECISION/I/J/K/L/M/N/X/Y/Z/T/E/F/DATASET/G
		DATA qualifiers  (nqual_at17a+0)	/ 'BRIEF'/
		DATA qualifiers  (nqual_at17a+1)	/ 'PRECISION'/
		DATA qualifiers  (nqual_at17a+2)	/ 'I'	/
		DATA qualifiers  (nqual_at17a+3)	/ 'J'	/
		DATA qualifiers  (nqual_at17a+4)	/ 'K'	/
		DATA qualifiers  (nqual_at17a+5)	/ 'L'	/
		DATA qualifiers  (nqual_at17a+6)	/ 'M'	/
		DATA qualifiers  (nqual_at17a+7)	/ 'N'	/
		DATA qualifiers  (nqual_at17a+8)	/ 'X'	/
		DATA qualifiers  (nqual_at17a+9)	/ 'Y'	/
		DATA qualifiers  (nqual_at17a+10)	/ 'Z'	/
		DATA qualifiers  (nqual_at17a+11)	/ 'T'	/
		DATA qualifiers  (nqual_at17a+12)	/ 'E'	/
		DATA qualifiers  (nqual_at17a+13)	/ 'F'	/
		DATA qualifiers  (nqual_at17a+14)	/ 'DATASET'	/
		DATA qualifiers  (nqual_at17a+15)	/ '****'/

* SHADE - command # 18
	DATA commands(18)			/ 'SHADE'	/
        DATA its_action_command(18)             / .TRUE.        /
	DATA num_subcommands(18)		/ nsub18	/
	DATA subcommand_pointer(18)		/ nsub_at18	/
* SHADE '    '
	   DATA subcommands      (nsub_at18 + 0)	/ '    '	/
	   DATA num_qualifs      (nsub_at18 + 0)	/ nqual18a	/
	   DATA qualifier_pointer(nsub_at18 + 0)	/ nqual_at18a	/
* SHADE/I/J/K/L/M/N/X/Y/Z/T/E/F/DATASET/OVERLAY/SET_UP/FRAME/TRANSPOSE/TRIM
		DATA qualifiers  (nqual_at18a+0)/ 'I'	/
		DATA qualifiers  (nqual_at18a+1)/ 'J'	/
		DATA qualifiers  (nqual_at18a+2)/ 'K'	/
		DATA qualifiers  (nqual_at18a+3)/ 'L'	/
		DATA qualifiers  (nqual_at18a+4)/ 'M'	/
		DATA qualifiers  (nqual_at18a+5)/ 'N'	/
		DATA qualifiers  (nqual_at18a+6)/ 'X'	/
		DATA qualifiers  (nqual_at18a+7)/ 'Y'	/
		DATA qualifiers  (nqual_at18a+8)/ 'Z'	/
		DATA qualifiers  (nqual_at18a+9)/ 'T'	/
		DATA qualifiers  (nqual_at18a+10)/ 'E'	/
		DATA qualifiers  (nqual_at18a+11)/ 'F'	/
		DATA qualifiers  (nqual_at18a+12)/ 'OVERLAY'/	!/overlays
		DATA qualifiers  (nqual_at18a+13)/ 'SET_UP'/	!/set_up
		DATA qualifiers  (nqual_at18a+14)/ 'FRAME'/	!/frame
		DATA qualifiers  (nqual_at18a+15)/ 'DATASET'   /	!/data_set
		DATA qualifiers  (nqual_at18a+16)/ 'TRANPOSE'/	!/transpose
		DATA qualifiers  (nqual_at18a+17)/ 'TRIM'/	!/trim
		DATA qualifiers  (nqual_at18a+18)/ 'LINE'/	!/lines
		DATA qualifiers  (nqual_at18a+19)/ 'NOLABEL'/	!/nolabel
		DATA qualifiers  (nqual_at18a+20)/ 'LEVELS'/	!/levels_same
		DATA qualifiers  (nqual_at18a+21)/ 'KEY' /	!/key
		DATA qualifiers  (nqual_at18a+22)/ 'NOKEY'/	!/nokey
		DATA qualifiers  (nqual_at18a+23)/ 'PALETTE'/	!/palette=
		DATA qualifiers  (nqual_at18a+24)/ 'XLIMITS'/	!/xlimits
		DATA qualifiers  (nqual_at18a+25)/ 'YLIMITS'/	!/ylimits
		DATA qualifiers  (nqual_at18a+26)/ 'TITLE'/	!/title
		DATA qualifiers  (nqual_at18a+27)/ 'AXES'/	!/axes[=]
		DATA qualifiers  (nqual_at18a+28)/ 'NOAXES'/	!/noaxes
		DATA qualifiers  (nqual_at18a+29)/ 'PATTERN'/   !/pattern=
		DATA qualifiers  (nqual_at18a+30)/ 'HGRATICU'/!tic lines, dash or line
		DATA qualifiers  (nqual_at18a+31)/ 'VGRATICU'/!vert tic lines
		DATA qualifiers  (nqual_at18a+32)/ 'GRATICUL'/	!
		DATA qualifiers  (nqual_at18a+33)/ 'MODULO'/	! modulo for curvilinear plots
		DATA qualifiers  (nqual_at18a+34)/ 'HLIMITS'/	! horiz
		DATA qualifiers  (nqual_at18a+35)/ 'VLIMITS'/	! vertical
		DATA qualifiers  (nqual_at18a+36)/ '****'/		! OPACITY in PyFerret
		DATA qualifiers  (nqual_at18a+37)/ 'DEGMINSEC'/	! Request deg/min or deg/min/sec axis labels
		DATA qualifiers  (nqual_at18a+38)/ 'HALFSPAC'/	! Request a space before the E/W or N/S on axis

* SPAWN - command # 19
	DATA commands(19)			/ 'SPAWN'	/
        DATA its_action_command(19)             / .FALSE.       /
	DATA num_subcommands(19)		/ nsub19	/
	DATA subcommand_pointer(19)		/ nsub_at19	/
* SPAWN '    '
	   DATA subcommands      (nsub_at19 + 0)	/ '    '	/
	   DATA num_qualifs      (nsub_at19 + 0)	/ nqual19a	/
	   DATA qualifier_pointer(nsub_at19 + 0)	/ nqual_at19a	/

* **** formerly USER - command # 20
	DATA commands(20)			/ '****'	/
        DATA its_action_command(20)             / .TRUE.        /
	DATA num_subcommands(20)		/ nsub20	/
	DATA subcommand_pointer(20)		/ nsub_at20	/
* USER '    '
	   DATA subcommands      (nsub_at20 + 0)	/ '    '	/
	   DATA num_qualifs      (nsub_at20 + 0)	/ nqual20a	/
	   DATA qualifier_pointer(nsub_at20 + 0)	/ nqual_at20a	/
* USER/OPT1/OPT2
		DATA qualifiers  (nqual_at20a+0)/ 'OPT1'	/
		DATA qualifiers  (nqual_at20a+1)/ 'OPT2'	/
		DATA qualifiers  (nqual_at20a+2)/ 'COMMAND'	/
		DATA qualifiers  (nqual_at20a+3)/ 'I'		/
		DATA qualifiers  (nqual_at20a+4)/ 'J'		/
		DATA qualifiers  (nqual_at20a+5)/ 'K'		/
		DATA qualifiers  (nqual_at20a+6)/ 'L'		/
		DATA qualifiers  (nqual_at20a+7)/ 'X'		/
		DATA qualifiers  (nqual_at20a+8)/ 'Y'		/
		DATA qualifiers  (nqual_at20a+9)/ 'Z'		/
		DATA qualifiers  (nqual_at20a+10)/ 'T'		/
		DATA qualifiers  (nqual_at20a+11)/ 'DATASET'		/
		DATA qualifiers  (nqual_at20a+12)/ 'FILE'	/
		DATA qualifiers  (nqual_at20a+13)/ 'FORMAT'	/

* WIRE - command # 21
	DATA commands(21)			/ 'WIRE'	/
        DATA its_action_command(21)             / .TRUE.       /
	DATA num_subcommands(21)		/ nsub21	/
	DATA subcommand_pointer(21)		/ nsub_at21	/
* WIRE '    '
	   DATA subcommands      (nsub_at21 + 0)	/ '    '	/
	   DATA num_qualifs      (nsub_at21 + 0)	/ nqual21a	/
	   DATA qualifier_pointer(nsub_at21 + 0)	/ nqual_at21a	/
* WIRE/I/J/K/L/M/N/X/Y/Z/T/E/F/DATASET/OVERLAY/SET_UP/FRAME/TRANSPOSE
		DATA qualifiers  (nqual_at21a+0) / 'I'	/
		DATA qualifiers  (nqual_at21a+1) / 'J'	/
		DATA qualifiers  (nqual_at21a+2) / 'K'	/
		DATA qualifiers  (nqual_at21a+3) / 'L'	/
		DATA qualifiers  (nqual_at21a+4) / 'M'	/
		DATA qualifiers  (nqual_at21a+5) / 'N'	/
		DATA qualifiers  (nqual_at21a+6) / 'X'	/
		DATA qualifiers  (nqual_at21a+7) / 'Y'	/
		DATA qualifiers  (nqual_at21a+8) / 'Z'	/
		DATA qualifiers  (nqual_at21a+9) / 'T'	/
		DATA qualifiers  (nqual_at21a+10) / 'E'	/
		DATA qualifiers  (nqual_at21a+11) / 'F'	/
		DATA qualifiers  (nqual_at21a+12) / 'OVERLAY'/ 
		DATA qualifiers  (nqual_at21a+13) / 'SET_UP'/  
		DATA qualifiers  (nqual_at21a+14)/ 'FRAME'/
		DATA qualifiers  (nqual_at21a+15)/ 'DATASET'   /
		DATA qualifiers  (nqual_at21a+16)/ 'VIEWPOIN'/
		DATA qualifiers  (nqual_at21a+17)/ 'ZLIMITS'/
		DATA qualifiers  (nqual_at21a+18)/ 'TRANPOSE'/  
		DATA qualifiers  (nqual_at21a+19)/ 'NOLABEL'/   
		DATA qualifiers  (nqual_at21a+20)/ 'ZSCALE'/
		DATA qualifiers  (nqual_at21a+21)/ 'COLOR'/
		DATA qualifiers  (nqual_at21a+22)/ '****'/
		DATA qualifiers  (nqual_at21a+23)/ '****'/
		DATA qualifiers  (nqual_at21a+24)/ '****'/
		DATA qualifiers  (nqual_at21a+25)/ '****'/
		DATA qualifiers  (nqual_at21a+26)/ 'TITLE'/

* QUERY - command # 22
	DATA commands(22)			/ 'QUERY'	/
        DATA its_action_command(22)             / .FALSE.       /
	DATA num_subcommands(22)		/ nsub22	/
	DATA subcommand_pointer(22)		/ nsub_at22	/
* QUERY '    '
	   DATA subcommands      (nsub_at22 + 0)	/ '    '	/
	   DATA num_qualifs      (nsub_at22 + 0)	/ nqual22a	/
	   DATA qualifier_pointer(nsub_at22 + 0)	/ nqual_at22a	/
* QUERY /FILE
		DATA qualifiers  (nqual_at22a+0)/ 'ALL'	/
		DATA qualifiers  (nqual_at22a+1)/ 'FILE'	/
		DATA qualifiers  (nqual_at22a+2)/ 'IGNORE'	/

* IF - command # 23
	DATA commands(23)			/ 'IF  '	/
        DATA its_action_command(23)             / .FALSE.       /
	DATA num_subcommands(23)		/ nsub23	/
	DATA subcommand_pointer(23)		/ nsub_at23	/
* IF '    '
	   DATA subcommands      (nsub_at23 + 0)	/ '    '	/
	   DATA num_qualifs      (nsub_at23 + 0)	/ nqual23a	/
	   DATA qualifier_pointer(nsub_at23 + 0)	/ nqual_at23a	/
* IF / ****
		DATA qualifiers  (nqual_at23a+0)/ '****'	/
		DATA qualifiers  (nqual_at23a+1)/ '****'	/

* ELSE - command # 24
	DATA commands(24)			/ 'ELSE'	/
        DATA its_action_command(24)             / .FALSE.       /
	DATA num_subcommands(24)		/ nsub24	/
	DATA subcommand_pointer(24)		/ nsub_at24	/
* ELSE '    '
	   DATA subcommands      (nsub_at24 + 0)	/ '    '	/
	   DATA num_qualifs      (nsub_at24 + 0)	/ nqual24a	/
	   DATA qualifier_pointer(nsub_at24 + 0)	/ nqual_at24a	/
* ELSE / ****
		DATA qualifiers  (nqual_at24a+0)/ '****'	/
		DATA qualifiers  (nqual_at24a+1)/ '****'	/

* ELIF - command # 25
	DATA commands(25)			/ 'ELIF'	/
        DATA its_action_command(25)             / .FALSE.       /
	DATA num_subcommands(25)		/ nsub25	/
	DATA subcommand_pointer(25)		/ nsub_at25	/
* ELIF '    '
	   DATA subcommands      (nsub_at25 + 0)	/ '    '	/
	   DATA num_qualifs      (nsub_at25 + 0)	/ nqual25a	/
	   DATA qualifier_pointer(nsub_at25 + 0)	/ nqual_at25a	/
* ELIF / ****
		DATA qualifiers  (nqual_at25a+0)/ '****'	/
		DATA qualifiers  (nqual_at25a+1)/ '****'	/

* ENDIF - command # 26
	DATA commands(26)			/ 'ENDIF'	/
        DATA its_action_command(26)             / .FALSE.       /
	DATA num_subcommands(26)		/ nsub26	/
	DATA subcommand_pointer(26)		/ nsub_at26	/
* ENDIF '    '
	   DATA subcommands      (nsub_at26 + 0)	/ '    '	/
	   DATA num_qualifs      (nsub_at26 + 0)	/ nqual26a	/
	   DATA qualifier_pointer(nsub_at26 + 0)	/ nqual_at26a	/
* ENDIF / ****
		DATA qualifiers  (nqual_at26a+0)/ '****'	/
		DATA qualifiers  (nqual_at26a+1)/ '****'	/

* POLYGON - command # 27
	DATA commands(27)			/ 'POLYGON'	/
        DATA its_action_command(27)             / .TRUE.        /
	DATA num_subcommands(27)		/ nsub6		/
	DATA subcommand_pointer(27)		/ nsub_at27	/
* POLYGON '    '
	   DATA subcommands      (nsub_at27 + 0)/ '    '	/
	   DATA num_qualifs      (nsub_at27 + 0)/ nqual27a	/
	   DATA qualifier_pointer(nsub_at27 + 0)/ nqual_at27a	/
* POLYGON/I/J/K/L/M/N/X/Y/Z/T/E/F/DATASET/OVERLAY/SET_UP/FRAME/TRANSPOSE/COORD_AX
		DATA qualifiers  (nqual_at27a+0)/ 'I'	/
		DATA qualifiers  (nqual_at27a+1)/ 'J'	/
		DATA qualifiers  (nqual_at27a+2)/ 'K'	/
		DATA qualifiers  (nqual_at27a+3)/ 'L'	/
		DATA qualifiers  (nqual_at27a+4)/ 'M'	/
		DATA qualifiers  (nqual_at27a+5)/ 'N'	/
		DATA qualifiers  (nqual_at27a+6)/ 'X'	/
		DATA qualifiers  (nqual_at27a+7)/ 'Y'	/
		DATA qualifiers  (nqual_at27a+8)/ 'Z'	/
		DATA qualifiers  (nqual_at27a+9)/ 'T'	/
		DATA qualifiers  (nqual_at27a+10)/ 'E'	/
		DATA qualifiers  (nqual_at27a+11)/ 'F'	/
		DATA qualifiers  (nqual_at27a+12)/ 'OVERLAY'/	!/overlays
		DATA qualifiers  (nqual_at27a+13)/ 'SET_UP'/	!/set_up
		DATA qualifiers  (nqual_at27a+14)/ 'FRAME'/	!/frame
		DATA qualifiers  (nqual_at27a+15)/ 'DATASET' /	!/data_set
		DATA qualifiers  (nqual_at27a+16)/ 'TRANPOSE'/	!/transpose
		DATA qualifiers  (nqual_at27a+17)/ 'COORD_AX'/	!/coord_ax
		DATA qualifiers  (nqual_at27a+18)/ '****'/	!/unused
		DATA qualifiers  (nqual_at27a+19)/ 'NOLABEL'/	!/nolabel
		DATA qualifiers  (nqual_at27a+20)/ 'LEVELS'/	!/levels_same
		DATA qualifiers  (nqual_at27a+21)/ 'LINE'/	!/line
		DATA qualifiers  (nqual_at27a+22)/ 'COLOR'/	!/color
		DATA qualifiers  (nqual_at27a+23)/ 'PALETTE'/	!/palette=
		DATA qualifiers  (nqual_at27a+24)/ 'XLIMITS'/	!/xlimits
		DATA qualifiers  (nqual_at27a+25)/ 'YLIMITS'/	!/ylimits
		DATA qualifiers  (nqual_at27a+26)/ 'TITLE'/	!/title
		DATA qualifiers  (nqual_at27a+27)/ 'THICKNES'/	!/thickness
		DATA qualifiers  (nqual_at27a+28)/ 'NOAXES'/	!/noaxes
	        DATA qualifiers  (nqual_at27a+29)/ 'PATTERN'/   !/pattern=
		DATA qualifiers  (nqual_at27a+30)/ 'FILL'/	!/fill
		DATA qualifiers  (nqual_at27a+31)/ 'KEY'/	!/key
		DATA qualifiers  (nqual_at27a+32)/ 'NOKEY'/	!/nokey
		DATA qualifiers  (nqual_at27a+33)/ 'AXES'/	!/axes[=]
		DATA qualifiers  (nqual_at27a+34)/ 'HLIMITS'/	! horizontal
		DATA qualifiers  (nqual_at27a+35)/ 'VLIMITS'/	! vertical
		DATA qualifiers  (nqual_at27a+36)/ 'HLOG'/	!log axis horiz
		DATA qualifiers  (nqual_at27a+37)/ 'VLOG'/	!log axis vert
		DATA qualifiers  (nqual_at27a+38)/ 'HGRATICU'/	!tic lines, dash or line
		DATA qualifiers  (nqual_at27a+39)/ 'VGRATICU'/	!vert tic lines
		DATA qualifiers  (nqual_at27a+40)/ 'GRATICUL'/
		DATA qualifiers  (nqual_at27a+41)/ 'MODULO'/
		DATA qualifiers  (nqual_at27a+42)/ '****'/	! OPACITY in PyFerret
		DATA qualifiers  (nqual_at27a+43)/ '****'/

* ANNOTATE - command # 28
	DATA commands(28)			/ 'ANNOTATE'	/
        DATA its_action_command(28)             / .FALSE.       /
	DATA num_subcommands(28)		/ nsub28	/
	DATA subcommand_pointer(28)		/ nsub_at28	/
* ANNOTATE '    '
	   DATA subcommands      (nsub_at28 + 0)	/ '    '	/
	   DATA num_qualifs      (nsub_at28 + 0)	/ nqual28a	/
	   DATA qualifier_pointer(nsub_at28 + 0)	/ nqual_at28a	/
* ANNOTATE /USER/NORM/NOUSER/XPOS/YPOS/HALIGN/VALIGN/ANGLE/SIZE
		DATA qualifiers  (nqual_at28a+0)/ 'USER'	/
		DATA qualifiers  (nqual_at28a+1)/ 'NORM'	/
		DATA qualifiers  (nqual_at28a+2)/ 'NOUSER'	/
		DATA qualifiers  (nqual_at28a+3)/ 'XPOS'	/
		DATA qualifiers  (nqual_at28a+4)/ 'YPOS'	/
		DATA qualifiers  (nqual_at28a+5)/ 'HALIGN'	/
		DATA qualifiers  (nqual_at28a+6)/ 'VALIGN'	/
		DATA qualifiers  (nqual_at28a+7)/ 'ANGLE'	/
		DATA qualifiers  (nqual_at28a+8)/ 'SIZE'	/
		DATA qualifiers  (nqual_at28a+9)/ '****'	/
		DATA qualifiers  (nqual_at28a+10)/ '****'	/
		DATA qualifiers  (nqual_at28a+11)/ '****'	/

* **** - command # 29
	DATA commands(29)			/ '****'	/
        DATA its_action_command(29)             / .FALSE.       /
	DATA num_subcommands(29)		/ nsub29	/
	DATA subcommand_pointer(29)		/ nsub_at29	/
* **** '    '
	   DATA subcommands      (nsub_at29 + 0)	/ '    '	/
	   DATA num_qualifs      (nsub_at29 + 0)	/ nqual29a	/
	   DATA qualifier_pointer(nsub_at29 + 0)	/ nqual_at29a	/
* **** / ****
		DATA qualifiers  (nqual_at29a+0)/ '****'	/
		DATA qualifiers  (nqual_at29a+1)/ '****'	/

* **** - command # 30
	DATA commands(30)			/ '****'	/
        DATA its_action_command(30)             / .FALSE.       /
	DATA num_subcommands(30)		/ nsub30	/
	DATA subcommand_pointer(30)		/ nsub_at30	/
* **** '    '
	   DATA subcommands      (nsub_at30 + 0)	/ '    '	/
	   DATA num_qualifs      (nsub_at30 + 0)	/ nqual30a	/
	   DATA qualifier_pointer(nsub_at30 + 0)	/ nqual_at30a	/
* **** / ****
		DATA qualifiers  (nqual_at30a+0)/ '****'	/
		DATA qualifiers  (nqual_at30a+1)/ '****'	/

* ******* ALIASES *********
	DATA	alias_name(1)	/ 'LET'/,
     .		alias_len(1)	/ 3 /,
     .		alias(1)	/ 'DEFINE VARIABLE'/,
     .		alias_name(2)	/ 'FILE'/,
     .		alias_len(2)	/ 4 /,
     .		alias(2)	/ 'SET DATA/EZ'/,
     .		alias_name(3)	/ 'QUIT' /,  ! or "q" for happy Unix users
     .		alias_len(3)	/ 4 /,
     .		alias(3)	/ 'EXIT' /,
     .		alias_name(4)	/ 'REGION' /,
     .		alias_len(4)	/ 4 /,
     .		alias(4)	/ 'SET REGION' /,
     .		alias_name(5)	/ 'SAY' /,
     .		alias_len(5)	/ 16 /,
     .		alias(5)	/ 'MESSAGE/CONTINUE' /
     .		alias_name(6)	/ 'FILL' /,
     .		alias_len(6)	/ 12 /,
     .		alias(6)	/ 'CONTOUR/FILL' /
     .		alias_name(7)	/ 'ALIAS' /,
     .		alias_len(7)	/ 12 /,
     .		alias(7)	/ 'DEFINE ALIAS' /
     .		alias_name(8)	/ 'UNALIAS' /,
     .		alias_len(8)	/ 12 /,
     .		alias(8)	/ 'CANCEL ALIAS' /
     .		alias_name(9)	/ 'USE' /,
     .		alias_len(9)	/ 16 /,
     .		alias(9)	/ 'SET DAT/FORM=CDF' /
     .		alias_name(10)	/ 'SAVE' /,
     .		alias_len(10)	/ 15 /,
     .		alias(10)	/ 'LIST/FORMAT=CDF' /,
     .		alias_name(11)	/ 'PALETTE' /,
     .		alias_len(11)	/ 20 /,
     .		alias(11)	/ 'PPL SHASET SPECTRUM=' /,
     .		alias_name(12)	/ 'LABEL' /,
     .		alias_len(12)	/ 10 /,
     .		alias(12)	/ 'PPL %LABEL' /,
     .		alias_name(13)	/ 'ANIMATE' /,
     .		alias_len(13)	/ 14 /,
     .		alias(13)	/ 'REPEAT/ANIMATE' /,
     .		alias_name(14)	/ 'PATTERN' /,
     .		alias_len(14)	/ 19 /,
     .		alias(14)	/ 'PPL PATSET PATTERN=' /
     .		alias_name(15)	/ 'PAUSE' /,
     .		alias_len(15)	/ 7 /,
     .		alias(15)	/ 'MESSAGE' /,
     .		alias_name(16)	/ 'WHERE' /,
     .		alias_len(16)	/ 10 /,
     .		alias(16)	/ 'PPL %WHERE' /
     .		alias_name(17)	/ 'FLOWLINE' /,
     .		alias_len(17)	/ 17 /,
     .		alias(17)	/ 'VECTOR/FLOWLINE' /
     .		alias_name(18)	/ 'COLUMNS' /,
     .		alias_len(18)	/ 23 /,
     .		alias(18)	/ 'SET DATA/FORM=delimited' /
     .		alias_name(19)	/ 'KEYMARK' /,
     .		alias_len(19)	/ 23 /,
     .		alias(19)	/ 'PPL SHAKEY 1,,,,,,,,,,' /
     .		alias_name(20)	/ 'RIBBON' /,
     .		alias_len(20)	/ 11 /,
     .		alias(20)	/ 'PLOT/RIBBON' /
     .		alias_name(21)	/ 'ENSEMBLE' /,
     .		alias_len(21)	/ 22 /,
     .		alias(21)	/ 'DEFINE DATA/AGGREGAT/E' /
     .		alias_name(22)	/ 'FMRC' /,
     .		alias_len(22)	/ 22 /,
     .		alias(22)	/ 'DEFINE DATA/AGGREGAT/F' /
     .		alias_name(23)	/ 'VTREE' /,
     .		alias_len(23)	/ 13 /,
     .		alias(23)	/ 'SHOW VAR/TREE' /,
     .		alias_name(24)	/ 'TSERIES' /,
     .		alias_len(24)	/ 22 /,
     .		alias(24)	/ 'DEFINE DATA/AGGREGAT/T' /
     .		alias_name(25)	/ 'UNION' /,
     .		alias_len(25)	/ 22 /,
     .		alias(25)	/ 'DEFINE DATA/AGGREGAT/U' /
     .		alias_name(26)	/ 'FMASK' /,
     .		alias_len(26)	/ 14 /,
     .		alias(26)	/ 'SET DATA/FMASK' /
     .		alias_name(27)	/ 'CLEARMASK' /,
     .		alias_len(27)	/ 17 /,
     .		alias(27)	/ 'CANCEL DATA/FMASK' /

        DATA
     .		(alias_name(i),i=num_predefined_alias+1,150)
     .                   / 123*unspecified_name4 /,
     .		(alias_len(i),i=num_predefined_alias+1,150) / 123*4 /,
     .		(alias(i),i=num_predefined_alias+1,150)
     .                   / 123*unspecified_name4 /


	DATA queries(1) / 'STATUS' /,
     .	     queries(2) / 'MESSAGE' /,
     .	     queries(3) / 'DSET' /,
     .	     queries(4) / 'VARIABLE' /,
     .	     queries(5) / 'GRID' /,
     .	     queries(6) / 'AXIS' /,
     .	     queries(7) / 'COORDS' /,
     .	     queries(8) / 'TRANS' /,
     .	     queries(9) / 'TRNARG' /,
     .	     queries(10) / 'LVARS' /,
     .	     queries(11) / 'DVARS' /,
     .	     queries(12) / 'VBACK' /,
     .	     queries(13) / 'DBACK' /,
     .	     queries(14) / 'WINDOWS' /,
     .	     queries(15) / 'WCURRENT' /,
     .	     queries(16) / 'VPORTS' /,
     .	     queries(17) / 'VCURRENT' /,
     .	     queries(18) / 'VIEW' /,
     .	     queries(19) / 'DCURRENT' /,
     .	     queries(20) / 'SPAN' /,
     .	     queries(21) / 'GAXIS' /,
     .	     queries(22) / 'GCOORDS' /,
     .	     queries(23) / 'SSPOINT' /,
     .	     queries(24) / 'WWPOINT' /,
     .	     queries(25) / ' ' /
	DATA (queries(i),i=26,max_queries) / 25*unspecified_name4 /
	DATA num_queries /0/   ! unused

	END

	SUBROUTINE GKSMV
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
*	Mod 1.9.90 J Davison to reduce the maximum #pts in any one call to 
*	polyline to 100 as GKS 4.0 under VMS 5.2, i.e., DECWindows, blows up
*	with too many points
*
C
C	CALL GKSMV
C
C	This routine creates a binary file that can be used to
c	construct device dependent plotting code
c
c v6.61 ACM 4/2010 Fix bug 1396 - dots between dashes on some displays.
c                  Do not make a call to GPL on "move with the pen up".      
C
C v6.93 KMS 11/2014 Rename IPT, X, and Y in GKPLOT to ipline, xpline, 
C                   and ypline, and move to a common block so that it 
C                   does not depend on local variables being static 
C                   (similar to what was done in gksmv_makedot.F).  
C                   Increase the maximum back up to 10000.

	include 'pltcom_dat.decl'
	include 'PLTCOM.DAT'
	include 'gkscm1_inc.decl'
	include 'GKSCM1.INC'
	IF(.NOT.GKSOPN)THEN
#ifdef core
            call crinit
#else
	    call gkinit
C
	    CALL GCLRWK(WSID,0)
#endif
	    GKSOPN=.TRUE.
	    LPEN=.NOT.PEN
	ENDIF
	IF(PEN)THEN
	CALL GKPLOT(A,B,1)
	ELSE
	CALL GKPLOT(A,B,0)
	ENDIF
	RETURN
	END
*jd*	SUBROUTINE GKPLOT(XN,YN,IP,II) Number of args reduced to 3 for MAC 7.92
	SUBROUTINE GKPLOT(XN,YN,IP)
#ifdef core
        if(ip.ne.0)then
            call lineabs2(xn,yn)
        else
            call moveabs2(xn,yn)
        endif
#else
       INCLUDE 'gkplot.cmn'
       DATA ipline/0/

       IF ( IP .EQ. 0 ) THEN
           CALL DOIT(ipline,xpline,ypline)
           ipline=1
       ELSE
           ipline=ipline+1
           IF ( ipline .GT. maxpline ) THEN
              CALL DOIT(maxpline,xpline,ypline)
              ipline=2
              xpline(1) = xpline(maxpline)
              ypline(1) = ypline(maxpline)
           ENDIF
       ENDIF
       xpline(ipline) = XN
       ypline(ipline) = YN
#endif
	RETURN
	ENTRY PPLGFLUSH
#ifdef core
        return
        end
#else
	CALL DOIT(ipline,xpline,ypline)
	ipline=0
	RETURN
	END
	SUBROUTINE DOIT(IPT,X,Y)
	DIMENSION X(*),Y(*)
	IF(IPT.LE.0)RETURN
	IF(IPT.EQ.1)THEN
	    X(2)=X(1)
	    Y(2)=Y(1)
	    IPT=2
	ELSE
	    CALL GPL(IPT,X,Y)
	ENDIF
	RETURN
	END
#endif

*
* storage.F
*
* Ansley Manke  (from Jonathan Callahan's storage)
* Dec 10 1998
*
* This function allocates working storage which is
* the size of the first argument and then uses that
* storage in calculation of the result.
*


*
* In this subroutine we provide information about
* the function.  The user configurable information
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
*
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result
*


      SUBROUTINE storage_init(id)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

      CALL ef_version_test(ef_version)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id, 'sets result equal to input/10')
      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 1)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_desc(id, arg, 'input')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE storage_work_size(id)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work array X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER ilo, jlo, klo, llo, mlo, nlo
      INTEGER ihi, jhi, khi, lhi, mhi, nhi
      INTEGER array_num

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      ilo = arg_lo_ss(X_AXIS,ARG1)
      jlo = arg_lo_ss(Y_AXIS,ARG1)
      klo = arg_lo_ss(Z_AXIS,ARG1)
      llo = arg_lo_ss(T_AXIS,ARG1)
      mlo = arg_lo_ss(E_AXIS,ARG1)
      nlo = arg_lo_ss(F_AXIS,ARG1)

      ihi = arg_hi_ss(X_AXIS,ARG1)
      jhi = arg_hi_ss(Y_AXIS,ARG1)
      khi = arg_hi_ss(Z_AXIS,ARG1)
      lhi = arg_hi_ss(T_AXIS,ARG1)
      mhi = arg_hi_ss(E_AXIS,ARG1)
      nhi = arg_hi_ss(F_AXIS,ARG1)

      array_num = 1
      CALL ef_set_work_array_dims_6d(id, array_num,
     .                              ilo, jlo, klo, llo, mlo, nlo,
     .                              ihi, jhi, khi, lhi, mhi, nhi)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE storage_compute(id, arg_1, result, workspace)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz,
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

      REAL workspace(wrk1lox:wrk1hix, wrk1loy:wrk1hiy,
     .               wrk1loz:wrk1hiz, wrk1lot:wrk1hit,
     .               wrk1loe:wrk1hie, wrk1lof:wrk1hif)

* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable's axes.

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,  j,  k,  l,  m,  n
      INTEGER i1, j1, k1, l1, m1, n1

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      n1 = arg_lo_ss(F_AXIS,ARG1)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

       m1 = arg_lo_ss(E_AXIS,ARG1)
       DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

        l1 = arg_lo_ss(T_AXIS,ARG1)
        DO 400 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         k1 = arg_lo_ss(Z_AXIS,ARG1)
         DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

          j1 = arg_lo_ss(Y_AXIS,ARG1)
          DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

           i1 = arg_lo_ss(X_AXIS,ARG1)
           DO 100 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

            IF ( arg_1(i1,j1,k1,l1,m1,n1) .EQ. bad_flag(ARG1) ) THEN

               result(i,j,k,l,m,n) = bad_flag_result

            ELSE

               workspace(i1,j1,k1,l1,m1,n1) =
     .               arg_1(i1,j1,k1,l1,m1,n1) / 10.0
               result(i,j,k,l,m,n) = workspace(i1,j1,k1,l1,m1,n1)

            END IF

            i1 = i1 + arg_incr(X_AXIS,ARG1)
 100       CONTINUE

           j1 = j1 + arg_incr(Y_AXIS,ARG1)
 200      CONTINUE

          k1 = k1 + arg_incr(Z_AXIS,ARG1)
 300     CONTINUE

         l1 = l1 + arg_incr(T_AXIS,ARG1)
 400    CONTINUE

        m1 = m1 + arg_incr(E_AXIS,ARG1)
 500   CONTINUE

       n1 = n1 + arg_incr(F_AXIS,ARG1)
 600  CONTINUE

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END

	SUBROUTINE MULT
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)mult.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
#ifdef unix
        include 'axis_inc.decl'
        include 'AXIS.INC'
        include 'mplot_inc.decl'
        include 'MPLOT.INC'
        include 'cmrd_inc.decl'
        include 'CMRD.INC'
        include 'cmrdl_inc.decl'
        include 'CMRDL.INC'
        include 'plt_inc.decl'
        include 'PLT.INC'
        include 'filnam_inc.decl'
        include 'FILNAM.INC'
        include 'lunits_inc.decl'
        include 'LUNITS.INC'
        include 'system_inc.decl'
        include 'SYSTEM.INC'
#else
        INCLUDE 'tmap_pplv11inc:tmap_AXIS.INC'
        INCLUDE 'tmap_pplv11inc:tmap_MPLOT.INC'
        INCLUDE 'tmap_pplv11inc:tmap_CMRD.INC'
        INCLUDE 'tmap_pplv11inc:tmap_CMRDL.INC'
        INCLUDE 'tmap_pplv11inc:tmap_PLT.INC'
        INCLUDE 'tmap_pplv11inc:tmap_FILNAM.INC'
        INCLUDE 'tmap_pplv11inc:tmap_LUNITS.INC'
        INCLUDE 'TMAP_PPLV11INC:SYSTEM_INC.DECL'
        INCLUDE 'PPLV11INC:SYSTEM.INC'
#endif
	IF(IFLG(1).EQ.1)THEN
	    MNX=P(1)
	ELSE
	   MNX=1
	END IF
	IF(IFLG(2).EQ.1.AND.M.GE.2)THEN
	    MNY=P(2)
	ELSE
	    MNY=1
	END IF
	CALL STPRMP('multplt>',8)
	IF(.NOT.QUIETF)WRITE(LTTOUT,
     *	'('' ENTER XLEN FOR COLS 1,2,...,NX'')')
	CALL GETCMD(STRING,ISLEN,ICOM,P,IFLG,M,LABEL,N,LBSTRT)
	DO 4901 I=1,MNX
	IF(M.GE.I.AND.IFLG(I).EQ.1)THEN
	    XLENM(I)=P(I)
	ELSE
	    XLENM(I)=XLEN
	END IF
4901	CONTINUE
	IF(.NOT.QUIETF)WRITE(LTTOUT,
     *	'('' ENTER YLEN FOR ROWS 1,2,...,NY'')')
	CALL GETCMD(STRING,ISLEN,ICOM,P,IFLG,M,LABEL,N,LBSTRT)
	DO 4902 I=1,MNY
	IF(M.GE.I.AND.IFLG(I).EQ.1)THEN
	    YLENM(I)=P(I)
	ELSE
	    YLENM(I)=YLEN
	END IF
4902	CONTINUE
	IF(.NOT.QUIETF)WRITE(LTTOUT,'('' ENTER PLOT SPACINGS'')')
	IF(.NOT.QUIETF)WRITE(LTTOUT,
     *	'('' LEFT BNDRY TO COL 1,COL1 TO COL2,ETC...'')')
	CALL GETCMD(STRING,ISLEN,ICOM,P,IFLG,M,LABEL,N,LBSTRT)
	DO 4903 I=1,MNX
	IF(M.GE.I.AND.IFLG(I).EQ.1)THEN
	    DXM(I)=P(I)
	ELSE IF(I.EQ.1)THEN
	    DXM(1)=1.4
	ELSE
	    DXM(I)=DXM(1)
	END IF
4903	CONTINUE
	IF(.NOT.QUIETF)WRITE(LTTOUT,
     *	'('' ROW1 TO ROW2,...,ROW NY TO BOTTOM'')')
	CALL GETCMD(STRING,ISLEN,ICOM,P,IFLG,M,LABEL,N,LBSTRT)
	CALL STPRMP('ppl+>',5)
	DO 4904 I=1,MNY
	IF(M.GE.I.AND.IFLG(I).EQ.1)THEN
	    DYM(I)=P(I)
	ELSE IF (I.EQ.1) THEN
	    DYM(1)=1.2
	ELSE
	    DYM(I)=DYM(1)
	END IF
4904	CONTINUE
	HTM=HEIGHT
	WDM=WIDTH
	WIDTH=DXM(1)
	DO 4905 I=1,MNX
4905	WIDTH=WIDTH+XLENM(I)+DXM(I)
	HEIGHT=DYM(MNY)
	DO 4906 I=1,MNY
4906	HEIGHT=HEIGHT+YLENM(I)+DYM(I)
	IF(.NOT.QUIETF)WRITE(LTTOUT,9987) WIDTH,HEIGHT
9987	FORMAT(' PLOT IS',F6.2,' IN. WIDE AND',F6.2,' IN.HIGH')
	IMCNT=0
	IMULT=1
	IXM=0
	IYM=1
#ifdef unix
        open(lmult,status='scratch',form='unformatted')
#else
	OPEN(LMULT,FILE='MULTZZZ.DAT',STATUS='NEW',
     *	FORM='UNFORMATTED')
	INQUIRE(UNIT=LMULT,NAME=MULTFL)
	CLOSE(LMULT)
#endif
10	RETURN
	END

	INTEGER FUNCTION DENSE_CONTIG_REGION(index_list, 
     .				istart, n,
     .				bad_flag, lo_cx_lim, hi_cx_lim )

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Given a *sorted* list of indices, select the largest slug (starting at i=1)
* that should be read as a contiguous region (a value between 1 and n)
* For example 1,2,3,5 could be read efficiently as 1:5 (only 20% "waste")
* but 1,5 should probably be read in 2 separate reads (60% "waste")

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V510 *sh* 8/99
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

        IMPLICIT NONE
	include 'errmsg.parm'

* calling argument declarations:
	INTEGER n, istart, lo_cx_lim, hi_cx_lim
	REAL index_list(n), bad_flag

* internal variable declarations:
	INTEGER i

* interpal parameter declarations
	REAL useful_fraction
	PARAMETER (useful_fraction  = .6) !  1,3,5 ok, but 1,3,5,7 not


* is there anything left in the index buffer?
 50	IF (istart .GT. n) THEN
	   DENSE_CONTIG_REGION = 0
	   RETURN
	ENDIF

* work from the back forward to get the largest possible region
	DO 100 i = n, istart, -1
	  IF ( ((i-istart+1) / (index_list(i)-index_list(istart)+1))
     .		.GE. useful_fraction ) GOTO 1000
 100	CONTINUE

* done
* return the lo:hi limits of the region to be read
 1000	lo_cx_lim = index_list(istart)
	hi_cx_lim = index_list(i)

* return the pointer to the hi index of the region to be read
	DENSE_CONTIG_REGION = i
	RETURN

	END

	SUBROUTINE UNSET_FEATURE_MASKS (fmask_var, slen, is_fmask)


* 6/3/2020 *acm*
* If a variable that is a feature-mask for a DSG Dataset is redefined,
* clear out the existing feature mask info, keeping the variable attributes
* that point to the feature-mask variable.  They'll be updated when the new
* mask variable is applied.

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'xdset_info.cmn_text'

	CHARACTER*(*) fmask_var
	LOGICAL is_fmask
	INTEGER slen

	LOGICAL NC_GET_ATTRIB, got_it
	INTEGER STR_SAME, iset, varid, 
     .		attid, attlen, attoutflag, maxlen, status
	REAL	attval
	CHARACTER*32 attname, attstring, dummy

* initialize

	is_fmask = .FALSE.

*... loop over datasets. See if the variable is listed as a feature-mask.
*    If redefining a feature-mask variable, keep the feature-mask attribute
*    to be used later to load the new mask on the right set(s).

	maxlen = 32

	DO iset = pdset_irrelevant+1, maxdsets
         
	   varid = 0
	   IF (dsg_msk_lm(iset) .GT. 0) THEN

	      varid = 0  ! look in global attributes for '__feature_mask_var'
	      attname = '__feature_mask_var'

	      CALL  CD_GET_VAR_ATT_ID (iset, varid, attname, attid, status)
	    
	      IF (status .NE. ferr_ok) CYCLE
	      got_it = NC_GET_ATTRIB ( iset, varid, attname, .FALSE., dummy, 
     .                               maxlen, attlen, attoutflag, attstring,
     .                               attval )

	      IF ( STR_SAME(fmask_var(:slen), attstring(:attlen)) .EQ. 0) THEN 

		 CALL FREE_LINE_DYNMEM( dsg_msk_lm(iset) )
		 CALL TM_DEALLO_DYN_LINE( dsg_msk_lm(iset) )
		 dsg_msk_lm(iset) = unspecified_int4

		 is_fmask = .TRUE.
	      ENDIF  ! this var was the mask

	   ENDIF ! mask was set on this dset
	ENDDO

	RETURN
	END
		     
		    

	CHARACTER*132 FUNCTION TM_CMPRSS( instring )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Takes multiple blanks and tabs in a string and replaces them with a
* single blank.
*
*	written by M. Verschell  04/03/87 for PMEL/TMAP
*
* revision 0.00 - 04/03/87
*
* argument
	CHARACTER*(*)	instring

* local definitions
	CHARACTER*1	tab
	INTEGER		inlen, i, pos, nblnk, blnk

	tab = CHAR(09)

	TM_CMPRSS =  ' '
	inlen = LEN(instring)
	pos = 0
	blnk = 1

* Find next non-blank or non-tab character
 100	DO i = blnk,inlen
	  IF (instring(i:i) .NE. ' ' .AND. instring(i:i) .NE. tab) THEN
* Store postion of non-blank character in input string
	    nblnk = i
* Pos is where that character goes in output string
	    pos = pos + 1
	    GOTO 200
	  ENDIF
	ENDDO
* If we get this far all that's left is trailing blanks (tabs)
	GOTO 9990

* transfer non-blank characters to output one-at-a-time until blank/tab
 200	DO i = nblnk,inlen
	  IF (instring(i:i) .NE. ' ' .AND. instring(i:i) .NE. tab) THEN
	    TM_CMPRSS(pos:pos) = instring(i:i)
	    pos = pos + 1
	  ELSE
* first blank character
	    TM_CMPRSS(pos:pos) = ' '
	    blnk = i
	    GOTO 100
	  ENDIF
	ENDDO
* done with string
9990	RETURN
	END	    

	SUBROUTINE VAR_STAT( dat, mv, cx, lun, full, stat_digits, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* report basic statistics about the data passed

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* revision 0.0 - 3/25/88
* V200:	10/11/89 - modified array declarations using XMEM_SUBSC.CMN
*	12/19/89 - eliminated the possibility of multiple data set variables
*		 - corrected serious error in standard deviation calculation
* Unix/RISC port - 3/12/91 - "formatted internal IO" bugs with
*                            FUNCTIONS in WRITE list
* V230: 7/29/92 - fixed precision problems when the variance is very small
*                 compared to the mean - sumsq_dev could be negative.
*                 Switched to a 2-pass computation
*       8/28/92 - document shape of regions, too  (e.g. 160*100*27*12)
*               - avoid overflows with "**too big**"
* V300: 10/20/93 - changed **0.5 to SQRT to work-around Macintosh Lang. Sys.
*		   FORTRAN bug
* V320: 10/26/94 - changed routine name "STAT" to VAR_STAT for IBM/AIX
*			compatibility
*       12/29/94 - use SPLIT_LIST to redirect tty output for GUI
* V420	 2/7/96  - added STAT/BRIEF
* 12/96 *kob* - Linux Port - had to move variable assignments off of
*               declaration line.
* V530: 9/00 *sh* - increase rbuff size to allow longer "(isiz*jsiz*ksiz*lsiz)"
*		  - added support for string variables
* V532: 5/01 *sh* - minor bug fix: "small" and "large" init'ed to wrong dtype
* V606: 7/07 *acm*- define symbols with the latest results of a call to STAT
*                   STAT_MIN, STAT_MAX, STAT_MEAN, STAT_STD
* V608:10/07 *acm*- If all missing then set these symbols to 'bad'. Also set
*                   symbols STAT_NGOOD, STAT_NBAD
* V664:  8/10 - implement robust method for computing variances
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
*                  Rename the file to match the function name var_stat.F
* V6.8  acm  6/12 Implement mode_6d_lab, set by default. If canceled, the 
*                 various SHOW commnands will not list info for E,F dimensions.
* V6.68  acm 3/14 ticket 2148: fix truncated ntot or nbad in stat listing
* v6.931 acm 11/14 Delete ALL the stat* symbols that may be left over from 
*                  a previous evaluation. STAT/BRIEF does not reset them all.
* V720 *acm*  3/17 Ticket 2512: Add STAT/PRECICISION=

	include 'tmap_dims.parm'
	include 'errmsg.parm'
	include 'ferret.parm'
	include 'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xcontext.cmn'
        include 'xrisc.cmn'           ! for Unix/RISC bugs (&12/94)
	include 'xprog_state.cmn'

* special equivalence needed only with risc compiler: bug fix
        CHARACTER rbuff(4)*24
        EQUIVALENCE ( rbuff, risc_buff )

* calling argument declarations:
	LOGICAL	full
	INTEGER	mv, cx, lun, stat_digits, status
	REAL    dat( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit,m1loe:m1hie,m1lof:m1hif )

* internal variable declarations:
	INTEGER	TM_LENSTR1, CGRID_SIZE, GET_MAX_STRING_LEN,
     .		i, j, k, l, m, n, nbad, ngood, ntot, idim,
     .		len_line, len_set_name, grid, slen, i1, i2, nok, 
     .		listdims, nfig, max_dig
	REAL	datum, bad, std_dev, large, small, mean, sumsq_dev, dev
	REAL*8	sum, sum2, xmean, zmean, x, xdelta, variance_c, diff

	CHARACTER*255	VAR_TITLE, VAR_TITLE_MOD, vname_buff
	CHARACTER	TM_FMT*20, LEFINT*20, AX_TITLE*32, CX_SIZE_STR*24,
     .			line_buff*130, title*32, bl13*13, symbuff*30
	PARAMETER (bl13 = '             ' )

* local parameter declarations:
	INTEGER		sig_fig
	PARAMETER     ( sig_fig = 5 )

* initialize
	grid  = mr_grid( mv )
	bad   = mr_bad_data( mv )
	nbad  = 0
	ngood = 0
	small = arbitrary_large_val4
	large = arbitrary_small_val4
	sum   = 0.0D0
        sumsq_dev = 0.0

	max_dig = 0
	IF (stat_digits .NE. 0) THEN
	   max_dig = stat_digits
	ELSE
	   stat_digits = sig_fig
	ENDIF

	listdims = nferdims
	IF ( .NOT. mode_6d_lab) listdims = 4

	IF ( full ) THEN
* give background on the data
* ... first the variable name
	   vname_buff   = VAR_TITLE( cx )
	   CALL SPLIT_LIST(pttmode_explct, lun, ' ', 1)
	   CALL SPLIT_LIST(pttmode_explct, lun,
     .		bl13//vname_buff( 1:TM_LENSTR1(vname_buff)), 0)
 3010	   FORMAT (13X,A)

* ... qualify title with modification line ?
	   vname_buff = VAR_TITLE_MOD( cx )
	   IF ( vname_buff .NE. ' ' ) THEN
	      len_line   = TM_LENSTR1( vname_buff )
	      CALL SPLIT_LIST(pttmode_explct, lun, 
     .			bl13//vname_buff(1:len_line), len_line+13)
	   ENDIF

* ... then location information normal to grid
	   DO 60 idim = 1, listdims
	      CALL ASCII_LIMITS( cx, idim, line_buff, len_line )
	      title = AX_TITLE( idim, grid, slen )
	      CALL SPLIT_LIST(pttmode_explct, lun, 
     .		bl13//title( :slen )//': '//line_buff(:len_line), 0)
 60	   CONTINUE

* ... then data set name or names
	   CALL GET_DSET_NAME( cx_data_set(cx), line_buff, len_set_name )
	   CALL SPLIT_LIST(pttmode_explct, lun,
     .		bl13//'DATA SET: '//line_buff(:len_set_name), 0)

	ENDIF

* string variables
	IF ( mr_type(mv) .EQ. ptype_string ) THEN
	   rbuff(1) = LEFINT(GET_MAX_STRING_LEN(cx,mv,dat), slen) 
	   rbuff(2) = LEFINT(CGRID_SIZE(cx), slen)
	   rbuff(3) = CX_SIZE_STR(cx,listdims,len_line)
	   CALL SPLIT_LIST(pttmode_explct, lun,
     .			' Total # of strings: '//
     .			 rbuff(2)(:slen)//' ('//rbuff(3)(:len_line)//')',0)
	   CALL SPLIT_LIST(pttmode_explct, lun,
     .			' Maximum string length: '//rbuff(1),0)
	   RETURN
	ENDIF

* pass 1: compute mean 
        IF (mode_6d_lab) THEN
	   DO 200 n = cx_lo_s6(cx), cx_hi_s6(cx)
	   DO 200 m = cx_lo_s5(cx), cx_hi_s5(cx)
	   DO 200 l = cx_lo_s4(cx), cx_hi_s4(cx)
	   DO 200 k = cx_lo_s3(cx), cx_hi_s3(cx)
	   DO 200 j = cx_lo_s2(cx), cx_hi_s2(cx)
	   DO 200 i = cx_lo_s1(cx), cx_hi_s1(cx)

	      datum = dat(i,j,k,l,m,n)

	      IF ( datum .EQ. bad ) THEN
	         nbad = nbad + 1

	      ELSE
	         ngood = ngood + 1
	         small = MIN( small, datum )
	         large = MAX( large, datum )
                 sum   = sum + datum
	      ENDIF
 200	   CONTINUE
	ELSE 
* If the data is 4D, and the user has canceled mode_6d_lab, just 
* compute and list the 4D result.

	   IF (cx_lo_s6(cx) .NE. unspecified_int4 .OR.
     .	       cx_lo_s5(cx) .NE. unspecified_int4) GOTO 5100
	   m = unspecified_int4
	   n = unspecified_int4
	   DO 210 m = cx_lo_s5(cx), cx_hi_s5(cx)
	   DO 210 l = cx_lo_s4(cx), cx_hi_s4(cx)
	   DO 210 k = cx_lo_s3(cx), cx_hi_s3(cx)
	   DO 210 j = cx_lo_s2(cx), cx_hi_s2(cx)
	   DO 210 i = cx_lo_s1(cx), cx_hi_s1(cx)

	      datum = dat(i,j,k,l,m,n)

	      IF ( datum .EQ. bad ) THEN
	         nbad = nbad + 1

	      ELSE
	         ngood = ngood + 1
	         small = MIN( small, datum )
	         large = MAX( large, datum )
                 sum   = sum + datum
	      ENDIF
 210	   CONTINUE
	ENDIF

        IF ( ngood .GT. 0 ) mean = sum / FLOAT(ngood)
        IF ( ABS(sum) .GE. 3.D35 ) sumsq_dev = 3.E35  ! flag for next pass

	IF ( full .AND. (ngood .GT. 1)) THEN
* pass 2: compute variance 

* Compute variance. See http://en.wikipedia.org/wiki/Algorithms_for_calculating_variance

* On-line algorithm with mean subtracted first. Noted as the most robust.
* Since we always compute the mean first anyway, use it.

	   nok = 0
	   xmean = 0.D0
	   sum2 = 0.D0
           zmean = mean

           IF (mode_6d_lab) THEN
	      DO 300 n = cx_lo_s6(cx), cx_hi_s6(cx)
	      DO 300 m = cx_lo_s5(cx), cx_hi_s5(cx)
	      DO 300 l = cx_lo_s4(cx), cx_hi_s4(cx)
	      DO 300 k = cx_lo_s3(cx), cx_hi_s3(cx)
	      DO 300 j = cx_lo_s2(cx), cx_hi_s2(cx)
	      DO 300 i = cx_lo_s1(cx), cx_hi_s1(cx)

	         x = dat(i,j,k,l,m,n)
	         IF ( x .NE. bad ) THEN
                    nok = nok + 1
		    x = x - zmean
                    xdelta = x - xmean
                    xmean = xmean + xdelta/FLOAT(nok)
                    sum2 = sum2 + xdelta*(x - xmean)  ! This expression uses the new value of mean
 	         ENDIF

 300	      CONTINUE
           ELSE  ! 4D result
	      DO 310 n = cx_lo_s6(cx), cx_hi_s6(cx)
	      DO 310 m = cx_lo_s5(cx), cx_hi_s5(cx)
	      DO 310 l = cx_lo_s4(cx), cx_hi_s4(cx)
	      DO 310 k = cx_lo_s3(cx), cx_hi_s3(cx)
	      DO 310 j = cx_lo_s2(cx), cx_hi_s2(cx)
	      DO 310 i = cx_lo_s1(cx), cx_hi_s1(cx)

	         x = dat(i,j,k,l,m,n)
	         IF ( x .NE. bad ) THEN
                    nok = nok + 1
		    x = x - zmean
                    xdelta = x - xmean
                    xmean = xmean + xdelta/FLOAT(nok)
                    sum2 = sum2 + xdelta*(x - xmean)  ! This expression uses the new value of mean
 	         ENDIF

 310	      CONTINUE 
           ENDIF

           variance_c = sum2/FLOAT(nok - 1)
	   std_dev = SQRT(variance_c)
 
	ENDIF

* compute and display results
	ntot = nbad + ngood

        rbuff(1) = LEFINT(nbad, slen)
        rbuff(2) = LEFINT(ntot, slen)
        rbuff(3) = CX_SIZE_STR(cx,listdims,len_line)
	CALL SPLIT_LIST(pttmode_explct, lun,' ',1)
	CALL SPLIT_LIST(pttmode_explct, lun,
     .			' Total # of data points: '//
     .			rbuff(2)(:slen)//' ('//rbuff(3)(:len_line)//')',0)
	CALL SPLIT_LIST(pttmode_explct, lun,
     .			' # flagged as bad  data: '//rbuff(1),0)
	IF ( ngood .GT. 0 ) THEN
	   nfig = 0
           rbuff(1) = TM_FMT(small, stat_digits, 16, slen)
           rbuff(2) = TM_FMT(large, stat_digits, 16, slen)
	   diff = (large-small)/MAX( ABS(large), ABS(small) )
	   IF (diff.LT.0.01 .AND. ngood.GT.1) THEN
	      IF (max_dig .EQ. 0) nfig = 4
              rbuff(1) = TM_FMT(small, stat_digits+nfig, 20, slen)
              rbuff(2) = TM_FMT(large, stat_digits+nfig, 20, slen)
	      diff = (large-small)/MAX( ABS(large), ABS(small) )
	      IF (diff .LT. 1.e-7) THEN
	       IF (max_dig .EQ. 0) nfig = 16-stat_digits
	        rbuff(1) = TM_FMT(small, stat_digits+nfig, 20, slen)
	        rbuff(2) = TM_FMT(large, stat_digits+nfig, 20, slen)
	      ENDIF
	   ENDIF

           IF ( ABS(sum) .GE. 3.D35 ) THEN
              rbuff(3) = '**too big**'
	      slen = 11
           ELSE
              rbuff(3) = TM_FMT(mean , stat_digits+nfig, 20, slen)
           ENDIF
	   CALL SPLIT_LIST(pttmode_explct, lun,
     .			' Minimum value: '//rbuff(1), 0)
	   CALL SPLIT_LIST(pttmode_explct, lun,
     .			' Maximum value: '//rbuff(2), 0)
	   CALL SPLIT_LIST(pttmode_explct, lun,
     .			' Mean    value: '//rbuff(3)(:slen)//
     .					' (unweighted average)', 0)
	ENDIF

! Define Ferret symbols with min, max, mean
        IF (ngood .EQ. 0) THEN 
           rbuff(1) = 'bad'
           rbuff(2) = 'bad'
           rbuff(3) = 'bad'
        ENDIF

! First delete all the STAT* symbols that may be set
! Leave none left over from a previous evaluation

	symbuff = 'STAT_MIN'
	CALL GETSYM( symbuff, title, i2, i1 )
	IF ( i1 .EQ. 0 ) CALL DELSYM(symbuff,i1)

	symbuff = 'STAT_MAX'
	CALL GETSYM( symbuff, title, i2, i1 )
	IF ( i1 .EQ. 0 ) CALL DELSYM(symbuff,i1)

	symbuff = 'STAT_MEAN'
	CALL GETSYM( symbuff, title, i2, i1 )
	IF ( i1 .EQ. 0 ) CALL DELSYM(symbuff,i1)

	symbuff = 'STAT_STD'
	CALL GETSYM( symbuff, title, i2, i1 )
	IF ( i1 .EQ. 0 ) CALL DELSYM(symbuff,i1)

	symbuff = 'STAT_NGOOD'
	CALL GETSYM( symbuff, title, i2, i1 )
	IF ( i1 .EQ. 0 ) CALL DELSYM(symbuff,i1)

	symbuff = 'STAT_NBAD'
	CALL GETSYM( symbuff, title, i2, i1 )
	IF ( i1 .EQ. 0 ) CALL DELSYM(symbuff,i1)


	IF ( mr_type(mv) .NE. ptype_string ) THEN
           symbuff = 'STAT_MIN'
           slen = TM_LENSTR1(rbuff(1))
      	   CALL PUTSYM( symbuff, rbuff(1), slen, i2)
           symbuff = 'STAT_MAX'
           slen = TM_LENSTR1(rbuff(2))
      	   CALL PUTSYM( symbuff, rbuff(2), slen, i2)
           symbuff = 'STAT_MEAN'
           slen = TM_LENSTR1(rbuff(3))
      	   CALL PUTSYM( symbuff, rbuff(3), slen, i2)
        ENDIF


	IF ( full .AND. ngood.GT.1 ) THEN
           IF ( sumsq_dev .GE. 3.E35 ) THEN
              rbuff(1) = ' **too big**' 
           ELSE
              rbuff(1) = TM_FMT(std_dev, stat_digits, 16, slen)
           ENDIF
	   CALL SPLIT_LIST(pttmode_explct, lun,
     .			' Standard deviation: '//rbuff(1), 0)

! Define Ferret symbols with std 
	   IF ( mr_type(mv) .NE. ptype_string ) THEN
              symbuff = 'STAT_STD'
              slen = TM_LENSTR1(rbuff(1))
      	      CALL PUTSYM( symbuff, rbuff(1), slen, i2)

           ENDIF
	ENDIF

	IF ( full .AND. ngood.LE.1 .AND.
     .        mr_type(mv) .NE. ptype_string) THEN
           symbuff = 'STAT_STD'
           slen = 3
           CALL PUTSYM( symbuff, 'bad', slen, i2)
	ENDIF

! Define Ferret symbols with ngood and nbad
	IF ( full .AND. mr_type(mv) .NE. ptype_string ) THEN
           symbuff = 'STAT_NGOOD'
           rbuff(1) = LEFINT(ngood, slen)
           slen = TM_LENSTR1(rbuff(1))
           CALL PUTSYM( symbuff, rbuff(1), slen, i2)

           symbuff = 'STAT_NBAD'
           rbuff(1) = LEFINT(nbad, slen)
           slen = TM_LENSTR1(rbuff(1))
           CALL PUTSYM( symbuff, rbuff(1), slen, i2)
        ENDIF

5000    RETURN
5100	CALL ERRMSG( ferr_invalid_command, status,
     .		     'variable has more than 4 dimensions. Set mode 6D_LAB'
     .		     //pCR//cmnd_buff(:len_cmnd),
     .			*5000 )
	END

	SUBROUTINE ATTRIB_STRING (cx, mr, dset, varid, varname, attname,
     .			          status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*

* get string attribute values

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP

* V600 8/18/05
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
*       *acm* 6/19 change to a comment

        IMPLICIT NONE
* calling argument declarations
	INTEGER		cx, mr, status
	INTEGER		dset, varid
	CHARACTER*(*)	varname, attname

* internal variable declarations
	LOGICAL		NC_GET_ATTRIB, got_em, do_warn
	INTEGER 	TM_LENSTR1, attlen, n, vlen, alen, aflag
	CHARACTER	buff*2048
        REAL            vals

* internal parameter declarations
        INTEGER       maxlen  ! length of buff to store string value
        PARAMETER     ( maxlen = 2048)


	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'gfdl_vms.parm'
	include 'xvariables.cmn'

* initialize
	n      = 1
        do_warn = .FALSE.

* Get string 
	got_em = NC_GET_ATTRIB ( dset, varid, attname,
     .                           do_warn, varname, maxlen,
     .                           attlen, aflag, buff, vals )
        IF (.NOT. got_em) GOTO 5000

c store in string variable
	CALL STORE_STRING(buff(1:attlen), mr, n-1, status)

* success
 1000	status = ferr_ok
	RETURN

* syntax error
 4999	RETURN

 5000	vlen = TM_LENSTR1(varname)
        alen = TM_LENSTR1(attname)
        buff = varname(:vlen)//"."//attname(:alen)
        vlen = vlen + alen + 1
        CALL ERRMSG( ferr_unknown_attribute, status, 
     .  'attribute not found:  '//buff(:vlen), *4999 )

	END

	SUBROUTINE WS_LINE_SPECTRUM (zwsid,zwstype, low_index)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that INCLUDEs this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Routine to set up the line bundles for color-line plots
* V691 *acm* 5/14 Fix when defining line bundles for a by-levels palette
* V694 *acm* 5/15 Fix ticket 2292 line plot thickness and ribbon plots

	include 'pltcom_dat.decl'
	include 'PLTCOM.DAT'
	include 'gkscm1_inc.decl'
	include 'GKSCM1.INC'
	include 'gkscm2.cmn'
	include 'ppl_in_ferret.cmn'
        include 'ws_types.cmn'
        include 'shade_vars.cmn'
	include 'tmap_dims.parm'
        include 'xplot_setup.cmn'
        INCLUDE 'gkspar.inc'
        INCLUDE 'parampl5_dat.decl'
        INCLUDE 'PARAMPL5.DAT'
        INCLUDE 'plt_inc.decl'
        INCLUDE 'PLT.INC'
        INCLUDE 'pen_inc.decl'  ! with num_line_colors
        INCLUDE 'PEN.INC'
	INCLUDE 'save_colors.cmn'
	INCLUDE 'errmsg.parm'

	integer		zwsid,zwstype,i,j, low_index

#ifdef atc_gks
	integer 	ltype(6)
	data	 	ltype/1,2,3,4,-1001,-1004/
#else
	integer 	ltype(6)
	data		ltype/1,2,3,4,-3,-4/
#endif

	integer		max_pline,max_pmark,max_text,max_fill_area
	integer		max_pattern,max_color,error
	integer		fktr, marktype, index, line_color_reserve,
     .			icolr, ndx, n1, n2, n3, slen
                                       
	real		thickness, dotsize, frac, r_val, g_val, b_val
	CHARACTER*100   err_msg
	CHARACTER*12	TM_FMT_SNGL, note

	integer		max_bundles
	parameter	(max_bundles = 250)  ! matches MAX_BUNDL_TBL in xgks

*******************************************************************************
*	WHAT IS AVAILABLE ON THIS WORKSTATION?
	call query_xgks_wkstn (zwstype,error,max_pline,max_pmark,
     .	            max_text,max_fill_area,max_pattern,max_color)
	if (error .ne. 0) goto 1000

        marktype = 1    ! polymarker type 1=dot
        dotsize = 1

*	COLOR OR MONOCHROME?
	if (max_color .le. 2) goto 100

*	COLOR WORKSTATIONS:

* Set up a color spectrum in the remaining space.

	IF ((max_color - num_line_colors) .LT. 0) GOTO 200

	line_color_reserve = num_line_colors
	
*   USE COLORS
        if (protect_used_colors) then
           lo_color_ndx(zwsid) = MAX(hi_color_ndx(zwsid) + 1, line_color_reserve + 1)
           protect_used_colors = .false.
        else
           lo_color_ndx(zwsid) = MAX(line_color_reserve + 1, lo_color_ndx(zwsid))
        endif

        usable_colors = max_color - line_color_reserve - lo_color_ndx(zwsid)

        if (usable_colors .lt. shd_levels+1) then
           write (6,'(/a)') ' PPL warning: You''re attempting to use '//
     .           'more colors than are available.'
           write (6,'(a/)') '             Using PPL SHASET RESET to re-use'//
     .		 ' protected colors may help.'
           lo_color_ndx(zwsid) = max (line_color_reserve + 1,
     .       max_color - line_color_reserve - (shd_levels+1))
        endif
        hi_color_ndx(zwsid) = lo_color_ndx(zwsid) + (shd_levels+1) - 1

* Plus one more for the bad-value color (e.g. missing data drawn as gray)

        hi_color_ndx(zwsid) = hi_color_ndx(zwsid) + 1
	bad_ribbon_ndx = (shd_levels+1) + 1

*	CHOOSE CUSTOM COLORS OR THE DEFAULT SELECTION
        if (custom_colors) then
           call setup_color_table (zwsid,lo_color_ndx(zwsid),shd_levels)
           if (meta_actv .and. .not. meta_clsplt) call setup_color_table 
     .			(meta_wsid,lo_color_ndx(zwsid),shd_levels)
        else
           call set_default_colors (zwsid,zwstype,lo_color_ndx(zwsid),
     .							shd_levels)
        end if


* Set line bundles
* The low-index preserves line and thickness defintions for the standard line-plot colors.

	nthick = 3
	low_index = MAX(num_line_colors* nthick + 2, lo_color_ndx(zwsid)) 

* GKS has a hard-wired MAX_BUNDL_TBL set at 250. This means we are
* limited on number of colors drawn with thick lines.

        ncolors = shd_levels
	IF ((low_index+(nthick-1)*(ncolors+1)+ncolors) .GT. max_bundles) THEN

	    n3 = (low_index+(nthick-1)*(ncolors+1)+ncolors)
	    n2 = (low_index+(nthick-2)*(ncolors+1)+ncolors)
	    n1 = (low_index+(nthick-3)*(ncolors+1)+ncolors)

	    note = TM_FMT_SNGL (REAL(max_bundles), 12, 12, slen)

	    IF (n1. GT. max_bundles) THEN
	       CALL WARN ('Graphics limits settings to '//note(:slen)//
     .	       ' line/thickness combinations plus existing spectrum colors')
	       note = TM_FMT_SNGL (REAL(ncolors), 12, 12, slen)
	       CALL WARN ('Cannot draw /THICK=1 lines with current number '//
     .	       'of color levels = '//note(:slen) )
     
	    ELSE IF (n2. GT. max_bundles) THEN
	       CALL WARN ('Graphics limits settings to '//note(:slen)//
     .	       ' line/thickness combinations plus existing spectrum colors')
	       note = TM_FMT_SNGL (REAL(ncolors), 12, 12, slen)
	       CALL WARN ('Cannot draw /THICK=2 lines with current number '//
     .	       'of color levels = '//note(:slen)//'; THICK=1 will be ok' )

	    ELSE IF (n3. GT. max_bundles) THEN
	       CALL WARN ('Graphics limits settings to '//note(:slen)//
     .	       ' line/thickness combinations plus existing spectrum colors')
	       note = TM_FMT_SNGL (REAL(ncolors), 12, 12, slen)
	       CALL WARN ('Cannot draw /THICK=3 lines with current number '//
     .	       'of color levels = '//note(:slen) //'; THICK=1 or 2 will be ok' )
	    ENDIF

        ENDIF

        if (rgb_mapping .eq. by_level) ncolors = ncl
	do 20 j = 1, ncolors
	    
	   do 10 fktr = 1,nthick     ! thickness
              thickness = REAL(fktr)
	      icolr = j + lo_color_ndx(zwsid) - 1
              index = low_index + (fktr-1)* (ncolors+1) + j

	      call gspmr (zwsid,index,marktype,dotsize,icolr)
	      call gsplr (zwsid,index,1,thickness,icolr)

10	   continue
20	continue

* Initialize the color for bad-data asc

        r_val = 0.75
        g_val = 0.75
        b_val = 0.75

* What is ribbon_miss?  If user asked for a palette with /missing= 
* then set that color.

	IF (ribbon_miss(1) .GE. 0.) THEN
           r_val = ribbon_miss(1)/100.
           g_val = ribbon_miss(2)/100.
           b_val = ribbon_miss(3)/100.
	ENDIF
	ndx = lo_color_ndx(zwsid)+ncolors
	call gscr (zwsid,ndx,r_val,g_val,b_val)

	do 40 j = ncolors + 1, ncolors + 1
	    
	   do 30 fktr = 1,nthick     ! thickness
              thickness = REAL(fktr)
	      icolr = j + lo_color_ndx(zwsid) - 1
              index = low_index + (fktr-1)* (shd_levels+1) + j

	      call gspmr (zwsid,index,marktype,dotsize,icolr)
	      call gsplr (zwsid,index,1,thickness,icolr)
       
30	   continue
40	continue

* ERROR
1000	return

 100    err_msg = 'Not a color worksatation, cannot set spectrum for color lines'
        CALL errmsg (ferr_out_of_range, status, err_msg, *1000)

 200    err_msg = 'Too many colors in color spectrum for ribbon plot'
        CALL errmsg (ferr_out_of_range, status, err_msg, *1000)
	end

	SUBROUTINE BREAK_UP_EXPR( text, num_parts, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* text may have more than one algebraic expression separated by commas
* this routine will delimit the expressions and store them in reverse Polish
* order in the user-var structure

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 2/23/87
* V200:  6/20/89 - pass "implct_defn" to initialize user vars from here
*       11/27/89 - perform Reverse Polish translation
*        2/29 90 - don't double-report INIT_UVAR errors
* Unix/RISC port - 1/91 - cant use "//" with CHAR*(*) variable
*       10/22/92 - added units on uvars
* V402:  7/95 - Added "dset" argument to INIT_UVAR for  LET/D=dset var = ... 
* V450:  11/96 - Using reformulated version of INIT_UVAR (RPN called
*		 from there). Part of changes to support external function.
* V510: 5/00 *sh* - added "bad" (missing value flag) to INIT_UVAR arguments
* V540:12/01 *acm*- for parsing expr like def axis/x x1={ 1, 2 } dont include
*                   the brackets in risc_buff
* 1/03 *kob* g77 port - requires use of risc_buff for concats
* V611 5/08 *acm* Fix bug 1578; dataset specifiers applied correctly var[d=1].attname
* V62   2/09 *acm* init_uvar has an extra argument, for keeping upper/lowrercase 
*                  spelling of user-var names (no other changes in this routine).
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V685+ 12/13    - *acm*  bounds checking; dont refer to parts of the string outside its bounds.
* V710 9/16  *acm* ticket 2465: Parsing expressions including attribute references.

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'	
	include 'rpn.parm'
	include 'xprog_state.cmn'
	include 'xrisc.cmn'

* calling argument declaration:
	INTEGER		num_parts, status
	CHARACTER*(*)	text

* internal parameter declarations:
	LOGICAL		implct_defn
	PARAMETER     ( implct_defn = .TRUE. )

* internal variable declarations:
	LOGICAL its_remote
	INTEGER	TM_LENSTR1,
     .		tlen, uvar, natom, i, paren_level, at1,
     .		at_type  (maxatoms), at_id  (maxatoms),
     .		at_start (maxatoms), at_end (maxatoms),
     .		exp_start(max_exp), exp_end(max_exp),
     .		atom_1   (max_exp), atom_n (max_exp),
     .          paren, startparen
	CHARACTER	EXPR_NAME*8, err_string*128, t2*2

        INTEGER ii

* initialize fixed length string for RISC
* If curly-brackets, dont count them.

        risc_buff = text
c        tlen = MIN( size_rbuff, LEN(text) )

        IF (text(1:1) .EQ. '{') THEN
            DO ii = 2, LEN(risc_buff)
               risc_buff(ii:ii) = text(ii:ii)
               IF (text(ii:ii) .EQ. '}') THEN
                  go to 499 
               ENDIF
             ENDDO
  499        CONTINUE
        ENDIF
        tlen = MIN( size_rbuff, LEN(text) )

* break the expression into atoms

* ----
* When there is a .. in the expression, this will later be translated
* as an attribute of the dataset.  Here just gloss over this by
* temporarily replacing the two dots with a string.

	IF (LEN(text) .GT. 1 .AND. INDEX(text,'..') .GT. 0) THEN
           DO ii = 1, TM_LENSTR1(risc_buff)-1
              IF (text(ii:ii+1) .EQ. '..') text(ii:ii+1) = 'aa'
	   ENDDO
	ENDIF

* a similar hack when the expression is (coordvar).attname 
* ALG_BREAK_UP can parse this, but doesnt like more complicated expressions
* like (coordvar).attname[d=2] Could make more cases in alg_break_up, but
* instead avoid the confusion about the meaning of the parentheses by 
* temporarily removing them.

        paren = 0
        IF ( INDEX(text, ').' )  .NE. 0) THEN
           paren = INDEX(text, ').' )
           DO 80 i = paren-1,1,-1
              startparen = INDEX(text(i:paren), '(' )
   80      CONTINUE
           IF (startparen .EQ. 0) GOTO 5400
           text(startparen:startparen) = 'A'
           TEXT(paren:paren) = 'A'
        ENDIF

* a similar hack when the expression is (coordvar)[spec].attname 
* ALG_BREAK_UP can parse this, but doesnt like more complicated expressions
* like (coordvar).attname[d=2] Could make more cases in alg_break_up, but
* instead avoid the confusion about the meaning of the parentheses by 
* temporarily removing them.

        IF ( INDEX(text, ')[' )  .NE. 0 .AND. 
     .       INDEX(text, '].' )  .NE. 0) THEN
           paren = INDEX(text, ')[' )
           DO 90 i = paren-1,1,-1
              startparen = INDEX(text(i:paren), '(' )
   90      CONTINUE
           IF (startparen .EQ. 0) GOTO 5400
           text(startparen:startparen) = 'A'
           TEXT(paren:paren) = 'A'
        ENDIF

	CALL ALG_BREAK_UP( text,at_start,at_end,natom,err_string,status )

* ----
* Restore text before the hack

	text = risc_buff

	IF ( status .NE. ferr_ok ) GOTO 5100

* identify the atoms
	CALL ALG_ID( text, natom, at_start, at_end, at_type, at_id, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* locate the sub-expressions by looking for commas that are outside of
* enclosing parentheses
	num_parts    = 1
	exp_start(1) = 1
	atom_1(1)    = 1
	paren_level  = 0
	DO 100 i = 1, natom
	   IF ( at_type(i) .EQ. alg_punctuation ) THEN
	      IF ( at_id(i) .EQ. left_paren ) THEN
	         paren_level = paren_level + 1
	      ELSEIF (at_id(i) .EQ. right_paren ) THEN
	         paren_level = paren_level - 1
	      ELSEIF  (at_id(i) .EQ. comma ) THEN
	         IF ( paren_level .EQ. 0 ) THEN
	            IF ( i.EQ.1 .OR.  i.EQ.natom ) GOTO 5200
	            IF ( num_parts .GE. max_exp  ) GOTO 5300
	            IF ( at_type(i+1) .EQ. alg_punctuation
     .		   .AND. at_id(i+1)   .EQ. comma ) GOTO 5200
	            atom_n (num_parts) = i - 1
	            exp_end(num_parts) = at_end(i-1)
	            num_parts = num_parts + 1
	            exp_start(num_parts) = at_start(i+1)
	            atom_1(num_parts) = i + 1
	         ENDIF
	      ENDIF
	   ENDIF
 100	CONTINUE
	atom_n (num_parts) = natom
	exp_end(num_parts) = at_end(natom)

* now file the expression in the user-defined variable area
        its_remote = .FALSE.  ! LET/REMOTE only with LET itself.

	DO 200 i = 1, num_parts
	   at1 = atom_1(i)
	   CALL INIT_UVAR( EXPR_NAME(i),text,' ', ' ', unspecified_int4,
     .			   bad_val4, implct_defn, uvar,
     .			   at_type(at1),  at_id(at1),
     .			   at_start(at1), at_end(at1),
     .			   atom_n(i)-at1+1,
     .			   exp_start(i), exp_end(i), 
     .			   EXPR_NAME(i), its_remote, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
 200	CONTINUE

* successful completion
 1000	status = ferr_ok
	RETURN

* error exits
 5000	num_parts = cmnd_uvars_not_given
	RETURN
 5100	CALL ERRMSG( status, status,
     .			risc_buff(:tlen)//pCR//err_string, *5000 )
 5200	risc_buff = text(:tlen)
	CALL ERRMSG( ferr_syntax, status,
     .		'comma does not separate any expressions: '
     .			//risc_buff, *5000 )
 5300   write ( err_string, '(I4)' ) max_exp
	CALL ERRMSG( ferr_invalid_command, status,
     .		'Number of expressions in line must be less than'
     .		//err_string(:4), *5000 )
 5400   CALL ERRMSG( ferr_invalid_command, status,
     .		'Mismatched parentheses'
     .		//text(1:paren), *5000 )
	END

*
* zaxreplace_lin.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* august 2004
*
* V580:10/04 *acm* Fix for bug 1037. Before the loop calling hunt_r4,
*                  set the initial guess for nsrc_lo to 1 not 0.  
*
* Replace Z axis, using linear interpolation 
* (same as zaxreplace, as first step towards zaxreplace_zlev)
*

*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE zaxreplace_lin_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      CHARACTER*100 descr

      CALL ef_set_desc(id, 
     . 'regrid V onto Z axis of ZAX based on layer thickness ')

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)

      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, YES, YES, YES, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'V')
      CALL ef_set_arg_desc(id, arg, 
     .        'Variable on native z axis')
      CALL ef_set_axis_influence(id, arg, YES, YES, NO, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'THICKNESS')
      WRITE (descr, 20)
   20 FORMAT ('Thickness corresponding to input Z axis values ',
     .        'in units of output Z axis')

      CALL ef_set_arg_desc(id, arg, descr)
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'ZAX')
      CALL ef_set_arg_desc(id, arg, 
     .'Variable with desired z (depth) axis points')
      CALL ef_set_axis_influence(id, arg, NO, NO, YES, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE zaxreplace_lin_compute(id, arg_1, arg_2, arg_3, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .     mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .     mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .     mem3lot:mem3hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER i, j, k, l
      INTEGER i1, j1, l1, i2, j2, l2, i3, j3, l3
      INTEGER nsrc_lo, klo, khi
      REAL frac, zval

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* 
*  Loop over x,y,t of the input fields
*

      klo = arg_lo_ss(Z_AXIS, ARG2)
      khi = arg_hi_ss(Z_AXIS, ARG2)

      i1 = arg_lo_ss(X_AXIS,ARG1)
      i2 = arg_lo_ss(X_AXIS,ARG2)
      i3 = arg_lo_ss(X_AXIS,ARG3)
      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         j2 = arg_lo_ss(Y_AXIS,ARG2)
         j3 = arg_lo_ss(Y_AXIS,ARG3)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            l1 = arg_lo_ss(T_AXIS,ARG1)
            l2 = arg_lo_ss(T_AXIS,ARG2)
            l3 = arg_lo_ss(T_AXIS,ARG3)
            DO 200 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

* --- first set this to do regular linear interpolation, as in zaxreplace,
*     and check that it replicates the behavior of zaxreplace.  Then
*     deal with layer thicknesses.

* For each z line interpolate. 

               nsrc_lo = 0

               nsrc_lo = 1    ! fixes bug where if zval equals 1st point in axis
                              ! we got no match.

               DO 100 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

* ... next Z axis value (arg3) to locate

                  zval = arg_3(i3,j3,k,l3)

* ... search the Z field (arg_2) for the index just below this value
* ... note that nsrc_lo is always referenced to a starting index of 1

	          CALL HUNT_R4(arg_2, 1, khi, zval, nsrc_lo, frac)

* ... interpolate data arg_1 field to get result

                  IF ( frac .LT. 0.0 ) THEN
* ... no luck -- the Z axis value we seek is outside the range in com2
                     result(i,j,k,l) = bad_flag_result
                  ELSEIF ( arg_1(i1,j1,nsrc_lo,l1) .EQ. 
     .                            bad_flag(ARG1) ) THEN
                     result(i,j,k,l) = bad_flag_result
                  ELSEIF ( frac .EQ. 1.0 ) THEN                  ! exactly on point
	             result(i,j,k,l) = arg_1(i1,j1,nsrc_lo,l1)
                  ELSE
	             result(i,j,k,l) =  frac* arg_1(i1,j1,nsrc_lo,l1)
     .			     + (1-frac)* arg_1(i1,j1,nsrc_lo+1,l1)
               ENDIF
 100        CONTINUE


               l1 = l1 + arg_incr(T_AXIS,ARG1)
               l2 = l2 + arg_incr(T_AXIS,ARG2)
               l3 = l3 + arg_incr(T_AXIS,ARG3)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
            j2 = j2 + arg_incr(Y_AXIS,ARG2)
            j3 = j3 + arg_incr(Y_AXIS,ARG3)
 300     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
         i2 = i2 + arg_incr(X_AXIS,ARG2)
         i3 = i3 + arg_incr(X_AXIS,ARG3)
 400  CONTINUE

      
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END


	SUBROUTINE HUNT_R4 (x1,lo_dim,hi_dim,x2,ndx_lo, frac)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Routine to determine nearest neighbor index (lower index)
*	on GRID1 for points on GRID2.

*	Taken from Numerical Recipes, Chapter 3, Section "Search With
*	Correlated Values"

* V450:  7/97 - new, cloned from double prec. version hunt.F
*             - also return "frac" - the interpolation factor for ndx_lo 

	integer		lo_dim,hi_dim,ndx_lo,ndx_mid,ndx_hi,inc

	real		x1(lo_dim:hi_dim),x2, frac

	logical		ascnd

********************************************************************************

*	TRUE IF ASCENDING GRID COORDINATES, FALSE OTHERWISE
	ascnd = x1(hi_dim) .gt. x1(lo_dim)
	
*	IF INITIAL GUESS IS NO GOOD, GO IMMEDIATELY TO BISECTION
	if (ndx_lo .lt. lo_dim .or. ndx_lo .gt. hi_dim) then
	   ndx_lo = lo_dim - 1
	   ndx_hi = hi_dim + 1
	   goto 3
	end if

	inc = 1

*	QUICKLY GET A GOOD ESTIMATE FOR LOCATION IN GRID1
	if (x2 .ge. x1(ndx_lo) .eqv. ascnd) then
*	   HUNT UP FOR PLACEMENT IN GRID
1	   ndx_hi = ndx_lo + inc
	   
	   if (ndx_hi .gt. hi_dim) then 
*	      HUNT OVER -- OFF HIGH END OF GRID
	      ndx_hi = hi_dim + 1
!	   else if (x2 .ge. x1(ndx_hi) .eqv. ascnd) then (ORIGINAL CODE)
	   else if (x2 .gt. x1(ndx_hi) .eqv. ascnd) then
	      ndx_lo = ndx_hi
	      inc    = inc + inc
	      goto 1
	   end if
	else
*	   HUNT DOWN FOR PLACEMENT
	   ndx_hi = ndx_lo
2	   ndx_lo = ndx_hi - inc

	   if (ndx_lo .lt. lo_dim) then
*	      FALL OFF LOW END OF GRID -- HUNT IS OVER
	      ndx_lo = lo_dim - 1
	   else if (x2 .lt. x1(ndx_lo) .eqv. ascnd) then
	      ndx_hi = ndx_lo
	      inc = inc + inc
	      goto 2
	   end if	
	end if

*	USE BISECTION TO DETERMINE EXACT LOCATION IN GRID
3	IF (ndx_hi - ndx_lo .eq. 1) THEN

* return result -- including interpolation fraction

	   IF (ndx_lo.GE.lo_dim .AND. ndx_lo.LT.hi_dim) THEN
	      IF (x2 .EQ. x1(ndx_lo)) THEN
	         frac = 1.0
	      ELSE
	         frac = (x1(ndx_hi)-x2) / (x1(ndx_hi)-x1(ndx_lo))
	      ENDIF
	   ELSE    
	      frac = -999.0
	   ENDIF
	   return
	ENDIF

	ndx_mid = (ndx_hi + ndx_lo)/2
	if (x2 .gt. x1(ndx_mid) .eqv. ascnd) then
	   ndx_lo = ndx_mid
	else
	   ndx_hi = ndx_mid
	end if

	goto 3


	end

	SUBROUTINE Z_HADVEC ( tk, mtk,
     .			      wk, mwk,
     .			      advec, madvec   )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute vertical  component of heat advection

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/17/86	extracted from SUBROUTINE HDIFFUS
*			with major modifications to convert i-k oriented
*			calculations to i-j oriented calculations
* V200:  7/27/89 - 4D symmetrical version
*	10/11/89 - array declarations using XMEM_SUBSC.CMN (reordered args)
* Linux Port 1/97 *kob* - Added a preprocessor include for xgfdl_masks.cmn
*			  because it needed a preprocessor.
* V450 - 7/22/97 - minor reordering of "#includes" for Solaris compiler bug

#ifdef unix
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl.parm'		! parameter definitions

! land/water masks
#	include "xgfdl_masks.cmn"	

	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xonedim.cmn'	! geometric constants
	include 'xcontext.cmn'
#else
	INCLUDE 'FERRET_CMN:FERRET.PARM'
	INCLUDE 'FERRET_CMN:GFDL.PARM'		! parameter definitions
	INCLUDE	'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE	'FERRET_CMN:XMEM_SUBSC.CMN'
	INCLUDE 'FERRET_CMN:XONEDIM.CMN'	! geometric constants
	INCLUDE 'FERRET_CMN:XCONTEXT.CMN'
	INCLUDE 'FERRET_CMN:XGFDL_MASKS.CMN'	! land/water masks
#endif

* calling argument declarations:
	INTEGER	mwk, mtk, madvec
* subscript ranges from memory variable table ...
	REAL       tk( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit ),
     .		   wk( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,m2lot:m2hit ),
     .		advec( m3lox:m3hix,m3loy:m3hiy,m3loz:m3hiz,m3lot:m3hit )

* internal variable declarations:
	INTEGER	i_lo, i_hi, j_lo, j_hi, i, j, k, l
	REAL	bad_wk, bad_tk, bad_advec, up_dwtdz, dn_dwtdz, dwtdz_neg,
     .		tdwdz
	LOGICAL	  bad_components

* --- end of introductory code ---
* limits for calculation
	i_lo = mr_lo_s1(madvec)
	i_hi = mr_hi_s1(madvec)
	j_lo = mr_lo_s2(madvec)
	j_hi = mr_hi_s2(madvec)

* flag(s) for bad or missing values
	bad_wk    = mr_bad_data ( mwk )
	bad_tk    = mr_bad_data ( mtk )
	bad_advec = mr_bad_data ( madvec )

	DO 2000 l = mr_lo_s4(madvec), mr_hi_s4(madvec)
	DO 2000 k = mr_lo_s3(madvec), mr_hi_s3(madvec)

* south to north loop through east-west lines
	DO 1000 j = j_lo, j_hi

	   IF ( j .LE. 2  .OR.  j .GE. jmtm1 ) THEN
	      DO 100 i = i_lo, i_hi
 100	      advec( i,j,k,l ) = bad_advec
	      GOTO 1000
	   ENDIF

* calculate minus vert advection component of total advection in flux form
* note on sign: increasing k is decreasing z
* note on k levels: The surface (w=0) is at k=1 in GFDL code but is
*		    omitted from the GFDL output. In this code k=1 represents
*		    the first level of non-zero data (GFDL k=2).
*		    The k=1 level of the S-T and U-V grids is therefore ABOVE
*		    the k=1 level of W in this code.  The "up" and "dn" prefixes
*		    on the variable names should be thought of relative to the
*		    T level which is experiencing advective heat flux.

      DO 824 i = i_lo, i_hi

* check that all of the required component fields are available at this point
* depending on depth, some of the components may be dummies
	IF     ( k .EQ. 1 )  THEN
	   bad_components =	wk( i,j,k  ,l ) .EQ. bad_wk
     .			   .OR. tk( i,j,k  ,l ) .EQ. bad_tk
     .			   .OR. tk( i,j,k+1,l ) .EQ. bad_tk
	ELSEIF ( k .EQ. KM ) THEN
	   bad_components =	wk( i,j,k-1,l ) .EQ. bad_wk
     .			   .OR. wk( i,j,k  ,l ) .EQ. bad_wk
     .			   .OR. tk( i,j,k-1,l ) .EQ. bad_tk
     .			   .OR. tk( i,j,k  ,l ) .EQ. bad_tk
	ELSE
	   bad_components =	wk( i,j,k-1,l ) .EQ. bad_wk
     .			   .OR. wk( i,j,k  ,l ) .EQ. bad_wk
     .			   .OR. tk( i,j,k-1,l ) .EQ. bad_tk
     .			   .OR. tk( i,j,k  ,l ) .EQ. bad_tk
     .			   .OR. tk( i,j,k+1,l ) .EQ. bad_tk
	ENDIF
	IF ( bad_components ) THEN
	   advec( i,j,k,l ) = bad_advec
	   GOTO 824
	ENDIF

	IF ( k .EQ. 1 ) THEN
	   up_dwtdz = 0.0
	ELSE
	   up_dwtdz = -(wk(i,j,k-1,l) * (tk(i,j,k-1,l) + tk(i,j,k,l)) )
     .		    * DZ2R(K)					    ! 3075 mod
	ENDIF

	IF ( k .GE. kmt(i,j) ) THEN
	   dn_dwtdz = 0.0
	ELSE
	   dn_dwtdz = (wk(i,j,k,l)*(tk(i,j,k,l)+tk(i,j,k+1,l)))*DZ2R(K)! 3079 mod
	ENDIF

	dwtdz_neg = up_dwtdz + dn_dwtdz

* calculate actual vert advection by subtracting t*dW/dZ ...
	IF ( k .EQ. 1 ) THEN
	   tdwdz = tk(i,j,k,l) * (              - wk(i,j,k,l)) * dz2r(k) * 2.0
	ELSE
	   tdwdz = tk(i,j,k,l) * (wk(i,j,k-1,l) - wk(i,j,k,l)) * dz2r(k) * 2.0
	ENDIF
	advec(i,j,k,l) = ( dwtdz_neg + tdwdz ) * cmonthly

 824  CONTINUE	    							! 3080

 1000	CONTINUE
 2000	CONTINUE

	RETURN
	END

	SUBROUTINE TM_GET_205_RUN_LINE ( filename, expno, col_head,
     .					 table_row, status )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* This routine will read a row from a file storing information about the
* model runs (and maybe other data sets). It will return column heading
* names, the row of experiment information, and a status key.
*
* Arguments:
*	filename  - file to read from
*	expno     - experiment number for desired info
*	col_head  - a string containing column information (Bottom line)
*	table_row - a string containing experiment information
*	status    - return status
*
* Written 04/26/88 by M. Verschell for PMEL/TMAP
*
* revision 0.00 - 04/27/88
* revision 0.01 - 02/20/89 - Clarified error message 9100
* revision 0.02 -  1/91 *sh* syntax changes to accomodate DEC RISC compiler
*               - and added TM_INQ_PATH with TMAP_RUNS
*
* IBM Port 14apr94 *kob* : READONLY not allowed in file open statments.  Added
*			   an "#ifdef READONLY_ALLOWED"
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* Include files
	include 'tmap_errors.parm'
        include 'xsys_names.cmn_text'
        external xsys_names_data

* Argument definitions
	CHARACTER*(*)	filename, expno, col_head, table_row
	INTEGER*4	status

* Local Definitions 
	CHARACTER*132	TM_INQ_PATH, buffer
	INTEGER*4	lunit, explen
	INTEGER*4	TM_LENSTR1
	integer		flen	!  for RISC compiler
	character*4	buff4

* for RISC compiler: can't concatenate with CHAR*(*) variable
	flen = MIN( LEN(filename), 132 )	! 132 is buffer size

* locate the data base file (use "buffer" to store the path name temporarily)
        buffer = TM_INQ_PATH( filename, tmap_model_runs, ' ',
     .                        .TRUE., status )
        IF ( status .NE. merr_ok ) GOTO 9999

* Get available logical unit
	CALL LIB_GET_LUN ( lunit )

* Look for filename and open it
	OPEN	( UNIT=lunit,
     .		  FILE=buffer,
     .		  STATUS='OLD',
#ifdef READONLY_ALLOWED
     .		  READONLY,
#endif
     .		  ERR=9000 )

* Now search for the bottom line of the column headings
  100	READ	( lunit, '(A132)', END=9100 ) buffer
	IF ( INDEX(buffer,'=====') .EQ. 0 ) THEN
          col_head = buffer
	  GOTO 100
	ENDIF

* We found the column headings, search for the experiment info
	explen = TM_LENSTR1(expno)
  110	READ	( lunit, '(A132)', END=9200 ) buffer
	IF ( INDEX(buffer(1:10),expno(1:explen)) .EQ. 0 ) GOTO 110
	table_row = buffer
	GOTO 9900

* ERROR - opening filename
 9000	buffer = filename
	CALL TM_ERRMSG ( merr_erreq, status, 'TM_GET_205_RUN_LINE',
     .			 no_descfile, no_stepfile, 'FILE='//buffer(:flen),
     .			 no_errstring, *9999 )

* ERROR - searching for column headings
 9100	buffer = filename
	CALL TM_ERRMSG ( merr_eof, status, 'TM_GET_205_RUN_LINE',
     .			 no_descfile, no_stepfile, 'FILE='//buffer(:flen)//
     .			 '. File not a correct Parameter file.',
     .			 no_errstring, *9990 )

* ERROR - searching for column headings
 9200	buffer = filename
	explen = MIN( explen, 4 )
	buff4 = expno
	CALL TM_ERRMSG ( merr_eof, status, 'TM_GET_205_RUN_LINE',
     .			 no_descfile, no_stepfile,'FILE='//buffer(:flen)//
     .			 ' Experiment "'//buff4(:explen)//'" not found',
     .			 no_errstring, *9990 )

* Status set
 9900	status = merr_ok

* Close file
 9990	CLOSE	( lunit, ERR=9000 )

* Bye bye
 9999	RETURN
	END

*           rr_diff_vx.F
*
*           Rick Romea
*           Jan. 24, 2000
*
*     Meridional momemtum diffusive term :  Am v_xx
*     Units :     cm/s/s
*     MOM2 Grid:  U   
*
*******************************************************************

      SUBROUTINE RR_diff_vx_init(id)
	IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

      CALL ef_set_desc             (id,
     .'Am(d^2v/dx^2) momentum diffusive term (cm/s^2);MOM2 U Grid')
      CALL ef_set_num_args         (id, 2)
      CALL ef_set_axis_inheritance (id, IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok     (id, NO, NO, YES, YES)

      ! Define first argument (U)

      CALL ef_set_arg_name         (id, ARG1, 'V')
      CALL ef_set_arg_desc         (id, ARG1,
     . 'Zonal velocity, on the MOM2 U Grid. ')
      CALL ef_set_arg_unit         (id, ARG1, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG1, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG1, YES, YES, YES, YES)

      !  Extend the x and y axis one point backward and forward

      CALL ef_set_axis_extend      (id, ARG1, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG1, Y_AXIS,-1,+1)

      ! Define second argument (TEMP)

      CALL ef_set_arg_name         (id, ARG2, 'TEMP')
      CALL ef_set_arg_desc         (id, ARG2,
     . 'Potential temperature, required to access MOM2 T Grid. ')
      CALL ef_set_arg_unit         (id, ARG2, 'deg-C')
      CALL ef_set_arg_type         (id, ARG2, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2, NO, NO,YES,YES)

      !  Extend the x and y axis one point backward and forward

      CALL ef_set_axis_extend      (id, ARG2, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG2, Y_AXIS,-1,+1)

      END


      SUBROUTINE RR_diff_vx_compute(id, arg_1, arg_2, result)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER        id

      REAL           bad_flag(EF_MAX_ARGS)
      REAL           bad_flag_result

      REAL           arg_1 (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .                      mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL           arg_2 (mem2lox:mem2hix, mem2loy:mem2hiy, 
     .                      mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL           result (memreslox:memreshix,memresloy:memreshiy,
     .                       memresloz:memreshiz,memreslot:memreshit)

      INTEGER        res_lo_ss (4)
      INTEGER        res_hi_ss (4)
      INTEGER        res_incr  (4)

      INTEGER        arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER        arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER        arg_incr  (4,EF_MAX_ARGS)

      INTEGER        i,  j,  k,  l
      INTEGER        i1, j1, k1, l1

      REAL*8         yU(1024)
      REAL*8         xU(1024)
      REAL*8         yT(1024)
      REAL*8         xT(1024)
      INTEGER        ilat
      INTEGER        ilon
      CHARACTER *16  ax_name(4)
      CHARACTER *16  ax_units(4)
      LOGICAL        backward(4)
      LOGICAL        modulo(4)
      LOGICAL        regular(4)

      REAL dxt, dxu, dyt
      REAL diff_fe 
      REAL csu,xjt

      INCLUDE 'rr_parameters.h'

C*********************************************************************
C
C     THIS IS THE MOM2 CODE:
C
c     dyt     = latitudinal height of "t" grid box (in cm)
c     dxt     = longitudinal width of "t" grid box at the equator (cm)
c     dxu     = longitudinal width of "u,v" grid box at the equator (cm) 
c     dyu     = latitudinal height of "u,v" grid box (cm)
C
c     dus     = yu(j) - yt(j)
c     dun     = yt(j+1) - yu(j)
c     duw     = xu(i) - xt(i)
c     due     = xt(i+1) - xu(i)
C
c     yu(j)   = latitude of the jth "u,v" point in degrees 
c     yt(j)   = latitude of the jth "t" point in degrees   
c     xt(i)   = longitude of the ith "t" point in degrees  
c     xu(i)   = longitude of the ith "u,v" point in degrees
C

c     csu     = cosine of "u" grid point latitude
c     csur    = reciprocal of "csu"
c     dxu     = longitudinal width of "u,v" grid box at the equator (cm) 
c     dxur    = reciprocal of "dxu"
c     dxt     = longitudinal width of "t" grid box at the equator (cm)
c     dxtr    = reciprocal of "dxt"

c     am      = constant lateral viscosity coeff for momentum (input)

C     DIFF_Ux(i,k,j)  =(diff_fe(i,k,j)-diff_fe(i-1,k,j))*csudxur(i,j)
C     csudxur(i,j)    = csur(j)*dxur(i)
C     diff_fe(i,k,j)  = am_csudxtr(i,j)*(u(i+1,k,j,n)-u(i,k,j,n))
C     am_csudxtr(i,j) = am*xjt(j)*csur(j)*dxtr(i+1)
C     xjt(j)          = 3.166*dyt(j)*dytr(50)-2.166
C
C
C*********************************************************************

      !  Statement functions

      dxt(i) = SNGL (xU(i)   - xU(i-1)) * Longitude_to_cm
      dxu(i) = SNGL (xT(i+1) - xT(i))   * Longitude_to_cm
      dyt(j) = SNGL (yU(j)   - yU(j-1)) * Latitude_to_cm
      csu(i) = cos(SNGL(yU(i)) * Degrees_to_radians) 
      xjt(i) = 3.166*dyt(i)/dyt_ref-2.166
      diff_fe(i,j,k,l,iLat,iLon) = am * xjt(iLat)/csu(iLat)/dxt(iLon)
     .                  *(arg_1(i+1,j,k,l) - arg_1(i,j,k,l))





      ! Get axis data

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags      (id, bad_flag,  bad_flag_result)
      CALL ef_get_coordinates    (id, ARG1, X_AXIS, 
     .                            arg_lo_ss(X_AXIS,ARG1),
     .                            arg_hi_ss(X_AXIS,ARG1), xU)
      CALL ef_get_coordinates    (id, ARG1, Y_AXIS, 
     .                            arg_lo_ss(Y_AXIS,ARG1),
     .                            arg_hi_ss(Y_AXIS,ARG1), yU)
      CALL ef_get_coordinates    (id, ARG2, X_AXIS, 
     .                            arg_lo_ss(X_AXIS,ARG2),
     .                            arg_hi_ss(X_AXIS,ARG2), xT)
      CALL ef_get_coordinates    (id, ARG2, Y_AXIS, 
     .                            arg_lo_ss(Y_AXIS,ARG2),
     .                            arg_hi_ss(Y_AXIS,ARG2), yT)

      ! Check axis units:  bail out if not lat and lon.

      CALL ef_get_axis_info      (id, ARG1, ax_name, ax_units, 
     .                                backward, modulo, regular) 
      IF     ( ax_units(1) .NE. 'deg'       .AND.
     .         ax_units(1) .NE. 'degrees_E' .AND.
     .         ax_units(1) .NE. 'longitude' .AND.
     .         ax_units(1) .NE. 'Longitude' .AND. 
     .         ax_units(1) .NE. 'LONGITUDE' ) THEN
        WRITE (6,*)'Longitude axis units =', ax_units(1) 
        !CALL ef_bail_out(id,'Longitude axis must be in degrees')
      ENDIF

      IF     ( ax_units(2) .NE. 'deg'       .AND.
     .         ax_units(2) .NE. 'degrees_N' .AND.
     .         ax_units(2) .NE. 'latitude'  .AND.
     .         ax_units(2) .NE. 'Latitude'  .AND. 
     .         ax_units(2) .NE. 'LATITUDE' ) THEN
        WRITE (6,*)'Latitude axis units =', ax_units(2) 
        !CALL ef_bail_out(id,'Latitude axis must be in degrees')
      ENDIF

      l1 = arg_lo_ss(T_AXIS,ARG1) 
      DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         
         k1 = arg_lo_ss(Z_AXIS,ARG1)
         DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

            ilat = 2  
            j1 = arg_lo_ss(Y_AXIS,ARG1) + 1
            DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

               iLon = 2
               i1 = arg_lo_ss(X_AXIS,ARG1) + 1
               DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

                  IF (arg_1(i1,  j1,  k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1+1,j1,  k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1-1,j1,  k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1,  j1+1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1+1,j1+1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1-1,j1+1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1,  j1-1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1+1,j1-1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1-1,j1-1,k1,l1) .EQ. bad_flag(ARG1) )THEN
                     result(i,j,k,l) = bad_flag_result
                  ELSE
                     result(i,j,k,l) =
     .                   (diff_fe(i1,j1,k1,l1,iLat,iLon) - 
     .                    diff_fe(i1-1,j1,k1,l1,iLat,iLon-1) ) 
     .                       /dxu(iLon)/csu(iLat)*sec_per_month
                  ENDIF
                  iLon = iLon + 1
                  i1 = i1 + arg_incr(X_AXIS,ARG1)
               ENDDO

               iLat = iLat + 1
               j1 = j1 + arg_incr(Y_AXIS,ARG1)
            ENDDO               

            k1 = k1 + arg_incr(Z_AXIS,ARG1)
         ENDDO

         l1 = l1 + arg_incr(T_AXIS,ARG1)
      ENDDO

      END

	SUBROUTINE DISPLAY_DEPENDENCY_SUB (
     .            next, level, flag, dataset, var_or_start, cat_or_end,
     .            parent_uv, uv_item, is_done )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* display the dependency tree structure that is stored in a memory work array

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V685  *sh* 11/13 
* V690  *sh* 11/13 - minor adjustments to support aux regridding variables 
* V693+ *sh* 12/14 - display regridding dependency on a separate line
*            01/15 - each regrid target gets separate line
* V698  3/16 *sh* added logic for cat_ef_time2d

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'
	include 'xvariables.cmn'
	include 'xdependency_tree.cmn'


* calling argument declarations:
        INTEGER next         (dependency_max_recs),
     .          level        (dependency_max_recs),
     .          flag         (dependency_max_recs),
     .          dataset      (dependency_max_recs),
     .          var_or_start (dependency_max_recs),
     .          cat_or_end   (dependency_max_recs),
     .          parent_uv    (dependency_max_recs),
     .          uv_item      (dependency_max_recs)
	LOGICAL is_done      (dependency_max_recs)


* internal variable declarations:
	LOGICAL tell_dset, dup, state_dflt_dataset, valid_var
	INTEGER	TM_LENSTR1,rec, ntrees, size, tree_size, tree_rec1,
     .		var, cat, tree_level, dset, uvar, item, ndone,
     .		blanks, llen, istart, iend, len2, dnamlen, tree, i
	CHARACTER*1024 GET_UNIQUE_DSET_NAME, VAR_CODE, VAR_TITLE, line_buff,
     .		dsetname

* initialize
	IF (  dependency_tree_show_fvars
     .	.AND. .NOT.dependency_tree_show_uvars ) GOTO 2000  ! show file var list only
* ... traverse forward linked list to count the number and set all as not yet displayed
	rec = 1
	ntrees = 0
 10	IF (next(rec) .GT. rec) THEN
	   ntrees = ntrees + 1
	   is_done(rec) = .FALSE.
	   rec = next(rec)
	   GOTO 10
	ENDIF
	ndone = 0

* do we need to announce the default dataset
	state_dflt_dataset = dependency_dflt_dset .NE. pdset_irrelevant

	DO 1000 tree = 1, ntrees

* find the largest tree not yet displayed
	   rec = 1
	   tree_size = 0
 20	   IF (next(rec) .GT. rec) THEN
	      size = next(rec) - rec
	      IF (.NOT.is_done(rec) .AND. (size.GT.tree_size)) THEN
	         tree_size = size
	         tree_rec1 = rec    ! starting record of the largest tree
	      ENDIF
	      rec = next(rec)
	      GOTO 20
	   ENDIF

* decide if this tree has already been displayed
	   rec = 1
 30	   IF (next(rec) .GT. rec) THEN
	      IF (is_done(rec)) THEN
	         DO 50 i = rec, next(rec)-1
	            valid_var = flag(i) .EQ. df_valid_var
     .		          .OR.  flag(i) .EQ. df_valid_aux_var
	            IF (.NOT.valid_var) GOTO 50
!                    dup = flag        (i) .EQ. flag        (tree_rec1)   ! unneeded test??
                    dup = 
     .                    dataset     (i) .EQ. dataset     (tree_rec1)
     .              .AND. var_or_start(i) .EQ. var_or_start(tree_rec1)
     .              .AND. cat_or_end  (i) .EQ. cat_or_end  (tree_rec1)
	            IF (dup) GOTO 900    ! already displayed as part of a previous tree
 50		 CONTINUE
	      ENDIF
	      rec = next(rec)
	      GOTO 30
	   ENDIF

* display one tree, record by record
	   DO 500 rec = tree_rec1, tree_rec1+tree_size-1

* initialize this record
	      tree_level = level(rec)
 	      var  = var_or_start(rec)
	      cat  = cat_or_end  (rec)
	      dset = dataset(rec)
	      uvar = parent_uv(rec)
	      item = uv_item(rec)
	      line_buff = ' '
	      blanks = 2 * (tree_level-1)

* prepare the dataset name if it needs to be documented
	      tell_dset = dset .NE. pdset_irrelevant
     .	            .AND. dset .NE. dependency_dflt_dset
	      IF ( tell_dset ) THEN
	         dsetname = '[d='
	         dsetname(4:) = GET_UNIQUE_DSET_NAME( dset )
	         dnamlen = TM_LENSTR1(dsetname) + 1
	         dsetname(dnamlen:dnamlen) = ']'
	      ENDIF

* document regridding dependencies as special, prefixed by "regrid to "
	      IF ( item .EQ. pcx_vtree_regrid_report ) THEN
	         line_buff(blanks+1:) = 'regrid to '
	         blanks = blanks + 10
	      ENDIF

* document this variable
	      IF ( flag(rec) .EQ. df_unknown_var ) THEN
	         istart = uvar_item_start(item, uvar)
	         iend   = uvar_item_end  (item, uvar)
	         line_buff(blanks+1:) = uvar_text(uvar)(istart:iend)
	         llen = (iend-istart+1) + blanks
	         IF (tell_dset) THEN
	            line_buff(llen+1:) = dsetname
	            llen = llen + dnamlen
	         ENDIF
	         line_buff(llen+1:) =
     .			' ??			<== UNKNOWN VARIABLE ******'
	      ELSEIF ( flag(rec) .EQ. df_unknown_dataset ) THEN
	         istart = uvar_item_start(item, uvar)
	         iend   = uvar_item_end  (item, uvar)
	         line_buff(blanks+1:) = uvar_text(uvar)(istart:iend)
	         llen = (iend-istart+1) + blanks
	         IF (tell_dset) THEN
	            line_buff(llen+1:) = dsetname
	            llen = llen + dnamlen
	         ENDIF
	         line_buff(llen+1:) = 
     .			' ??			<== UNKNOWN DATASET ******'
	      ELSEIF ( flag(rec) .EQ. df_unknown_grid ) THEN
	         IF ( item .EQ. pcx_vtree_regrid_report ) THEN
	            istart = var
	            iend   = cat
	         ELSE
	            istart = uvar_item_start(item, uvar)
	            iend   = uvar_item_end  (item, uvar)
	         ENDIF
	         line_buff(blanks+1:) = uvar_text(uvar)(istart:iend)
	         llen = (iend-istart+1) + blanks
	         IF (tell_dset) THEN
	            line_buff(llen+1:) = dsetname
	            llen = llen + dnamlen
	         ENDIF
	         line_buff(llen+1:) =
     .			' ??		<== UNKNOWN GRID ******'
	      ELSEIF ( flag(rec) .EQ. df_syntax_error ) THEN
	         istart = uvar_item_start(item, uvar)
	         iend   = uvar_item_end  (item, uvar)
	         line_buff(blanks+1:) = uvar_text(uvar)(istart:iend)
	         llen = (iend-istart+1) + blanks
	         IF (tell_dset) THEN
	            line_buff(llen+1:) = dsetname
	            llen = llen + dnamlen
	         ENDIF
	         line_buff(llen+1:) = '   *** WARNING: ERROR IN DEFINITION'
	      ELSEIF ( flag(rec) .EQ. df_unknown_auxvar ) THEN
	         istart = uvar_item_start(item, uvar) + var - 1
	         iend   = uvar_item_start(item, uvar) + cat - 1
	         line_buff(blanks+1:) = uvar_text(uvar)(istart:iend)
	         llen = (iend-istart+1) + blanks
	         IF (tell_dset) THEN
	            line_buff(llen+1:) = dsetname
	            llen = llen + dnamlen
	         ENDIF
	         line_buff(llen+1:) = '   (unknown auxiliary variable)'
	      ELSEIF (flag(rec) .EQ. df_defined_earlier) THEN
	         line_buff(blanks+1:) = VAR_CODE(cat, var)
	         llen = TM_LENSTR1(line_buff)
	         IF (tell_dset) THEN
	            line_buff(llen+1:) = dsetname
	            llen = llen + dnamlen
	         ENDIF
	         line_buff(llen+1:) = ' =  (defined above)'
	      ELSEIF (flag(rec) .EQ. df_recursion_error) THEN
	         line_buff(blanks+1:) = VAR_CODE(cat, var)
	         llen = TM_LENSTR1(line_buff)
	         IF (tell_dset) THEN
	            line_buff(llen+1:) = dsetname
	            llen = llen + dnamlen
	         ENDIF
	         line_buff(llen+1:) = ' =   *** WARNING: RECURSIVE DEFINITION.  See above'
	      ELSEIF (cat .EQ. cat_user_var) THEN
	         IF (.NOT.dependency_tree_show_uvars) GOTO 500
	         line_buff(blanks+1:) = VAR_CODE(cat, var)
	         llen = TM_LENSTR1(line_buff)
	         IF (tell_dset) THEN
	            line_buff(llen+1:) = dsetname
	            llen = llen + dnamlen
	         ENDIF
	         line_buff(llen+1:) = ' = ' //uvar_text(var)
	      ELSEIF (cat .EQ. cat_agg_e_var .OR. cat .EQ. cat_agg_f_var) THEN
	         IF (.NOT. dependency_tree_show_uvars) GOTO 500
	         line_buff(blanks+1:) = VAR_CODE(cat, var)
	         llen = TM_LENSTR1(line_buff)
	         IF (tell_dset) THEN
	            line_buff(llen+1:) = dsetname
	            llen = llen + dnamlen
	         ENDIF
	         line_buff(llen+1:) = '   (aggregate variable)'
	      ELSEIF (cat .EQ. cat_file_var 
     .           .OR. cat .EQ. cat_ef_time2d ) THEN
	         IF (.NOT.dependency_tree_show_fvars) GOTO 500
	         line_buff(blanks+1:) = VAR_CODE(cat, var)
	         llen = TM_LENSTR1(line_buff)
	         IF (tell_dset) THEN
	            line_buff(llen+1:) = dsetname
	            llen = llen + dnamlen
	         ENDIF
	      ELSE
* ... does this ever happen?
	         line_buff(blanks+1:) = VAR_CODE(cat, var)
	         llen = TM_LENSTR1(line_buff)
	         IF (tell_dset) THEN
	            line_buff(llen+1:) = dsetname
	            llen = llen + dnamlen
	         ENDIF
	         line_buff(llen+1:) = ' = ' //VAR_TITLE( cat )
	      ENDIF
   
* name the default dataset just once
	IF (state_dflt_dataset) THEN
	   dsetname = GET_UNIQUE_DSET_NAME( dependency_dflt_dset )
	   CALL SPLIT_LIST( pttmode_explct, show_lun, 
     .		'   in default dataset '//dsetname, 0)
	   state_dflt_dataset = .FALSE.
	ENDIF

* display a line of the tree
	      CALL SPLIT_LIST( pttmode_explct, show_lun, 
     .	      	'   '//line_buff, 0)

 500	   CONTINUE


! signal that this tree has been displayed
 900	   is_done(tree_rec1) = .TRUE.

 1000	CONTINUE
	RETURN

**************************
* special display mode to show only a simple list of unique file variables
 2000	DO 2100 rec = 1, dependency_nrows

	   var  = var_or_start(rec)
	   cat  = cat_or_end  (rec)
	   dset = dataset(rec)
	   uvar = parent_uv(rec)
	   item = uv_item(rec)
	   valid_var = flag(rec) .EQ. df_valid_var 
     .	          .OR. flag(rec) .EQ. df_valid_aux_var 

	   IF ( item .EQ. pcx_vtree_regrid_report ) THEN
* ... special prefix for regridding lines
	      line_buff = 'regrid to '
	      llen = 10
	   ELSE
	      llen = 0
	   ENDIF

* format one record
	   IF     ( valid_var
     .	 .AND.      cat       .EQ. cat_user_var       ) THEN
	      GOTO 2100					! skip user variables
	   ELSEIF ( flag(rec) .EQ. df_defined_earlier
     .	  .OR.      flag(rec) .EQ. df_recursion_error ) THEN
	      GOTO 2100					! skip irrelevant flags
	   ELSEIF ( valid_var
     .	 .AND.      cat       .EQ. cat_file_var       ) THEN
* valid file variable
* ... if this record has already been displayed do not do so again
	      DO 2050 i = 1, rec-1
                 dup = (flag(rec) .EQ. df_valid_var 
     .	           .OR. flag(rec) .EQ. df_valid_aux_var )
     .           .AND. dataset     (i) .EQ. dataset     (rec)
     .           .AND. var_or_start(i) .EQ. var_or_start(rec)
     .           .AND. cat_or_end  (i) .EQ. cat_or_end  (rec)
	         IF (dup) GOTO 2100
 2050	      CONTINUE
	      line_buff(llen+1:) = VAR_CODE(cat,var)	! valid file variable
	      llen = TM_LENSTR1(line_buff)
	      dsetname = '[d='
	      dsetname(4:) = GET_UNIQUE_DSET_NAME( dset )
	      dnamlen = TM_LENSTR1(dsetname) + 1
	      dsetname(dnamlen:dnamlen) = ']'
	      line_buff = line_buff(:llen)//dsetname
	   ELSEIF ( flag(rec) .EQ. df_unknown_var ) THEN
	      istart = uvar_item_start(item, uvar)
	      iend   = uvar_item_end  (item, uvar)
	      line_buff = '*unknown variable: '//
     .			uvar_text(uvar)(istart:iend)
	   ELSEIF ( flag(rec) .EQ. df_unknown_dataset ) THEN
	      istart = uvar_item_start(item, uvar)
	      iend   = uvar_item_end  (item, uvar)
	      line_buff = '*unknown dataset: '//
     .			uvar_text(uvar)(istart:iend)
	   ELSEIF ( flag(rec) .EQ. df_unknown_grid ) THEN
	      IF ( item .EQ. pcx_vtree_regrid_report ) THEN
	         istart = var
	         iend   = cat
	      ELSE
	         istart = uvar_item_start(item, uvar)
	         iend   = uvar_item_end  (item, uvar)
	      ENDIF
	      line_buff = '*unknown grid: '//
     .			uvar_text(uvar)(istart:iend)
	   ELSEIF ( flag(rec) .EQ. df_syntax_error ) THEN
	      istart = uvar_item_start(item, uvar)
	      iend   = uvar_item_end  (item, uvar)
	      line_buff = '   *WARNING: syntax error: '//
     .			uvar_text(uvar)(istart:iend)
	   ELSEIF ( flag(rec) .EQ. df_unknown_auxvar ) THEN
	      istart = uvar_item_start(item, uvar) + var - 1
	      iend   = uvar_item_start(item, uvar) + cat - 1
	      line_buff = '*unknown auxiliary variable: '//
     .			uvar_text(uvar)(istart:iend)
	   ENDIF

	   CALL SPLIT_LIST( pttmode_explct, show_lun, '   '//line_buff, 0)


 2100	CONTINUE

	RETURN
	END

	SUBROUTINE XEQ_ELIF

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Process the intermediate logic of an ELIF ("ELSEIF") statement in a
* multi-line IF compound statement

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V420:  4/96
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V693+ *sh* 12/14 Simplified blocks skipped by IF using ifstk_skipping

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'command.parm'
	include 'errmsg.parm'
	include 'gfdl_vms.parm'
	include 'xcontext.cmn'
	include 'xcontrol.cmn'
	include 'xprog_state.cmn'

* local variable declarations
	LOGICAL TRUE_OR_FALSE, condition
	INTEGER	STR_CASE_BLIND_COMPARE,
     .		vax_code, status

* initial sanity checks
	IF ( .NOT.if_conditional ) GOTO 5010

* is this the end of the clause that has been executing?
	IF ( if_doing(ifstk) .EQ. pif_doing_clause ) THEN
	   if_doing(ifstk) = pif_skip_to_endif
	   ifstk_skipping = 0   ! skipping is controlled by this IF-nest level
	   RETURN
	ENDIF

* more sanity checks
* (not the best error message ... but this is an internal never-happen error
* since pif_skip_to_endif is supposed to be trapped outside of this)
	IF ( if_doing(ifstk) .NE. pif_skip_to_clause ) GOTO 5010

* check that something was given to "if" on
	IF ( num_args .LT. 2 ) GOTO 5100

* optional "THEN" at end of line is OK
	IF ( num_args .GT. 1 ) THEN
	   IF ( num_args .GT. 2 ) GOTO 5300
	   vax_code = STR_CASE_BLIND_COMPARE(
     .				cmnd_buff(arg_start(2):arg_end(2)),
     .				'THEN' )
	   IF (vax_code .NE. vms_str_success) GOTO 5300
	ENDIF

* determine if the condition is true or false
	condition = TRUE_OR_FALSE(cmnd_buff(arg_start(1):arg_end(1)),
     .				  status)
	IF ( status .NE. ferr_ok ) GOTO 5000

* say which IF clause to execute
	IF ( condition ) THEN
	   if_doing(ifstk) = pif_doing_clause	! ELIF TRUE THEN (do it)
	ELSE
	   if_doing(ifstk) = pif_skip_to_clause	! ELIF FALSE THE (keep looking)
	ENDIF

	RETURN
	
* error exit
* ... control stack pointer, CSP, corrected in GFD_ERROR_HANDLER
 5000	RETURN
 5010	CALL ERRMSG( ferr_invalid_command, status,
     .		'ELIF can only be used between IF and ENDIF', *5000)
 5100	CALL ERRMSG( ferr_syntax, status, 'ELIF what ?', *5000)
 5300	CALL ERRMSG( ferr_syntax, status,
     .		'Entire ELIF statement should be "ELIF expr THEN"'//
     .			pCR//cmnd_buff(:len_cmnd), *5000 )
	END

*           rr_fv.F
*
*           Rick Romea
*           Jan. 5, 2000 
*
*     Coriolis term in the u momentum equation
*     Equation :  fv
*     Units :     cm/s/s
*     MOM2 Grid:  U   
*
************************************************************************

      SUBROUTINE RR_fv_init(id)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id, arg
      arg = 1

      CALL ef_set_desc             (id,
     .  'Coriolis term fv (cm/s^2) on the MOM2 U Grid')
      CALL ef_set_num_args         (id, 1)
      CALL ef_set_has_vari_args    (id, NO)
      CALL ef_set_axis_inheritance (id, IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok     (id, YES, YES, YES, YES)
      CALL ef_set_arg_name         (id, arg, 'V')
      CALL ef_set_arg_desc         (id, arg,
     . 'Meridional velocity, on the MOM2 U Grid. ')
      CALL ef_set_arg_unit         (id, arg, 'cm/sec')
      CALL ef_set_arg_type         (id, arg, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, arg, YES, YES, YES, YES)

      END

************************************************************************

      SUBROUTINE RR_fv_compute(id, arg_1, result)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS)
      REAL bad_flag_result
      REAL arg_1  (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .             mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL result (memreslox:memreshix, memresloy:memreshiy, 
     .             memresloz:memreshiz, memreslot:memreshit)
      INTEGER  res_lo_ss (4)
      INTEGER  res_hi_ss (4)
      INTEGER  res_incr  (4)

      INTEGER  arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER  arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER  arg_incr  (4,EF_MAX_ARGS)

      INTEGER i,  j,  k,  l
      INTEGER i1, j1, k1, l1

      REAL*8     degrees_y(1024)
      INTEGER    iLat
      REAL       Coriolis

      INCLUDE 'rr_parameters.h'

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags      (id, bad_flag,  bad_flag_result)
      CALL ef_get_coordinates    (id, ARG1, Y_AXIS, 
     .                            arg_lo_ss(Y_AXIS,ARG1),
     .                            arg_hi_ss(Y_AXIS,ARG1), degrees_y)

      iLat = 1
      j1 = arg_lo_ss(Y_AXIS,ARG1)
      DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

         Coriolis = Two_Omega*
     .                SIN(SNGL(degrees_y(iLat))*Degrees_to_radians) 

         i1 = arg_lo_ss(X_AXIS,ARG1)
         DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               l1 = arg_lo_ss(T_AXIS,ARG1)
               DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

                  IF (arg_1(i1,j1,k1,l1) .EQ. bad_flag(ARG1)) THEN
                     result(i,j,k,l) = bad_flag_result
                  ELSE
                     result(i,j,k,l) =  arg_1(i1,j1,k1,l1)*Coriolis
     .                  * sec_per_month
                  ENDIF
                  l1 = l1 + arg_incr(T_AXIS,ARG1)
               ENDDO

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
            ENDDO

            i1 = i1 + arg_incr(X_AXIS,ARG1)
         ENDDO

         iLat = iLat + 1
         j1 = j1 + arg_incr(Y_AXIS,ARG1)
      ENDDO
      END

	SUBROUTINE CD_DSG_READ ( dset, ivar, var, vtype, status )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Read a netCDF3 1D DSG contiguous ragged array variable 

* V720 *sh* 4/17
* V74+ 4/18 *acm* Getting DSG grids
* V74+ 4/18 *acm* Allow for the NCEI-style datasets which are one feature
*                 per file but they put the obs variables on 2D grids, 
*                 temp(feature, nobs)
* V74+ 7/18 *acm* More on reading NCEI-type grids

* include files
        include 'netcdf.inc'
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'		! data set dimension
	include 'tmap_dtypes.parm'
#include "gt_lib.parm"
	include 'xdset_info.cmn_text'	! data set info common
	external xdset_info_data
	include 'xstep_files.cmn_text'	! step file common
	external xstep_files_data
        include 'xdset_info.cd_equiv'


* arguments:
*	dset        - internal data set # (from GT_INIT_DSET)
*	ivar        - position in common of variable information
*	var         - array to receive DSG values (output)
*	vtype       - data type of the variable
*	status      - error status upon completion (output)
*
	INTEGER		dset, ivar, vtype, status
	REAL     	var(*)

* local definitions
	LOGICAL one_by_nobs, nobs_by_one
	INTEGER sf_num, cdfid, varid, dimlen, dtype

	INTEGER ndim, iflag,
     .          start(nferdims), count(nferdims), 
     .          stride(nferdims), imap(nferdims),
     .          nvdims, vdims(nferdims), ax1len, ax2len
	CHARACTER*128 buff

* initialize
	sf_num = cd_stepfile(dset)
        cdfid  = sf_lunit(sf_num)
        varid  = cd_varid(ivar)
	dimlen = dsg_obs_dimlen(dset)
	dtype = 0    ! arg to CD_RD_R8_ARR, but not used there


* See if its a file like the NCEI ones with 1 feature and dimensions 
* for the obs variables of (obs,traj) or (traj,obs)

	one_by_nobs = .FALSE.
	nobs_by_one = .FALSE.
	CALL CD_GET_VAR_DIMS_INFO (dset, varid, buff, 
     .        nvdims, vdims, status)
	IF (nvdims.EQ.2 .AND. vtype.NE.ptype_string) THEN
	   status = NF_INQ_DIMLEN(cdfid, vdims(1), ax1len)
	   status = NF_INQ_DIMLEN(cdfid, vdims(2), ax2len)
	   IF (ax1len.EQ.1 .AND. ax2len.EQ.dimlen) one_by_nobs = .TRUE. 
	   IF (ax1len.EQ.dimlen .AND. ax2len.EQ.1) nobs_by_one = .TRUE. 
	   IF (.NOT.one_by_nobs .AND. .NOT.nobs_by_one) GOTO 5001
	ENDIF

* read the 1D variable from the file

	IF (vtype .NE. ptype_string) THEN

	   IF (nvdims.EQ.2 .AND. vtype.NE.ptype_string) THEN
	      start(1) = 1
	      start(2) = 1
	      count(1) = 1
	      count(2) = 1
	      IF (nobs_by_one) count(1) = dimlen
	      IF (one_by_nobs) count(2) = dimlen
	      CALL CD_RD_R8_BNDS( cdfid, varid, start, count, dtype,
     .                          "reading "//ds_var_code(ivar)
     .                          //" for DSG",
     .                           var, 1, 1, 1, dimlen, status )
	   ELSE
              CALL CD_RD_R8_ARR( cdfid, varid, 1, dimlen, dtype,
     .                     "reading DSG variable"//ds_var_code(ivar),
     .                      var, status )
	   ENDIF

* String data types. 

	ELSE

	   IF (one_by_nobs) THEN  ! untested so far...
	      start(1) = 1
	      start(2) = 1
	      start(3) = 1
	      count(1) = 1
	      count(2) = dimlen
	      count(3) = 1
	   ELSe
	      ndim = 1
	      iflag = 0
	      start(1) = 1
	      count(1) = dimlen
	      stride(1) = 1
	      imap(1) = 1
	   ENDIF
	   
	   CALL CD_READ_SUB(cdfid, varid, ndim, start, count,
     .		   stride, imap, var, iflag, iflag, status) 
           IF (status .EQ. NF_NOERR ) status = merr_ok
	ENDIF

! DSGTBD: scale and offset need to be applied to the variable
!    Can the logic from CD_READ be packaged into a subroutine and reused?


 5000	RETURN
* Error, should never get here - reading data on too many dimensions
 5001    CALL TM_ERRMSG
     .     ( pcdferr, status, 'CD_DSG_READ', cdfid,
     .       varid, 'Failed attempting READ', no_errstring, *5000 )


	END

 	CHARACTER*(*) FUNCTION AX_TITLE_UNITS( idim, grid, len )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* produce a title string with units suitable for an axis

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* revision 0.0 - 8/25/88
* V320: 12/19/94 - recognize millibars and decibars as special axes
*		(kludge: use "m" for meters instead of exact unit string.
*			This because of "METERS" in the old grid files around.)
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
* V695+ *sh* 3/15 - generate axis titles for TIME LAG axes in FMRC variables
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xunits.cmn_text'
	include 'ferret.parm'
	include 'xtext_info.cmn'

* calling argument declarations:
	INTEGER	idim, grid, len
	LOGICAL	GEOG_LABEL

* internal variable declarations:
        LOGICAL ITS_FMRC, ITSA_TRUEMONTH_AXIS
	INTEGER	TM_LENSTR1, i, line, ulen
	CHARACTER*46 unit_name

* check for program bug	! temp
	IF ( grid .EQ. unspecified_int4 ) STOP 'no_grd_orient'

	line = grid_line( idim, grid )

	IF ( GEOG_LABEL( idim, grid ) ) THEN
	   AX_TITLE_UNITS = axis_title( idim )
	   len = axis_title_len( idim )
* special formatting for vertical axes - 12/19/94
	   IF ( idim .EQ. z_dim ) THEN
	      IF ( line_unit_code(line) .EQ. pun_millibars 
     .        .OR. line_direction( line ) .EQ. 'DU'     ) THEN
	         AX_TITLE_UNITS = "HEIGHT"
	         len = 6
	      ENDIF
	      IF ( line_unit_code(line) .EQ. pun_meters ) THEN
	         unit_name = 'm'		! kludge for "METERS"
	      ELSE
	         unit_name = line_units(line)
	      ENDIF
	      ulen = TM_LENSTR1( unit_name )
	      AX_TITLE_UNITS = AX_TITLE_UNITS(1:len)//' ('//unit_name(:ulen)//')'
	      len = len + 3 + ulen

	   ELSE	      

              unit_name = line_units(line)
	      IF ( idim .EQ. t_dim) unit_name = 
     .          unit_name(:TM_LENSTR1(unit_name))//' since '// line_t0(line)

* If its a true-month axis then make the output unit name be day
              IF ( ITSA_TRUEMONTH_AXIS(line) ) unit_name = 'day'
              ulen = TM_LENSTR1( unit_name )
              AX_TITLE_UNITS = AX_TITLE_UNITS(:len)//' ('//unit_name(:ulen)//')'
              len = len + 3 + ulen
	   ENDIF

	ELSE
	   AX_TITLE_UNITS = ww_dim_name( idim )
	   len = 1
	   IF ( line .NE. mnormal .AND. line .NE. munknown ) THEN
	      IF ( line_units(line) .NE. ' ' ) THEN
	         ulen = TM_LENSTR1( line_units(line) )
	         AX_TITLE_UNITS = AX_TITLE_UNITS(1:1)//' ('//line_units(line)(:ulen)//')'
	         len = 4 + ulen
	      ENDIF
	   ENDIF
	ENDIF

	RETURN
	END

*
* write_webrow.F
*
* Ansley Manke
* April 2009
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
*
* This function writes a special webrowset file for LAS
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE write_webrow_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .        'Write a webrowset file with cruise numbers and IDs')
      CALL ef_set_num_args(id, 4)
      CALL ef_set_axis_inheritance_6d(id,
     .                                ABSTRACT, NORMAL,
     .                                NORMAL,   NORMAL,
     .                                NORMAL,   NORMAL)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'id')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_type (id, arg, STRING_ARG)
      CALL ef_set_arg_desc(id, arg, 'Cruise IDs (string) on X axis')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'name')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_type (id, arg, STRING_ARG)
      CALL ef_set_arg_desc(id, arg, 'Cruise name (string) on X axis')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'Cruise_Mask')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg,
     .                'Mask on X axis; =1 at start of each cruise')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'filename')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_type (id, arg, STRING_ARG)
      CALL ef_set_arg_desc(id, arg, 'Filename to write')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


      SUBROUTINE write_webrow_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_axis_limits(id, X_AXIS, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE write_webrow_compute(id, arg_1, arg_2, arg_3, arg_4,
     .                                result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif

      INTEGER id

      REAL arg_1(strdf, mem1lox:mem1hix, mem1loy:mem1hiy,
     .                  mem1loz:mem1hiz, mem1lot:mem1hit,
     .                  mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(strdf, mem2lox:mem2hix, mem2loy:mem2hiy,
     .                  mem2loz:mem2hiz, mem2lot:mem2hit,
     .                  mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(       mem3lox:mem3hix, mem3loy:mem3hiy,
     .                  mem3loz:mem3hiz, mem3lot:mem3hit,
     .                  mem3loe:mem3hie, mem3lof:mem3hif)
      REAL arg_4(strdf, mem4lox:mem4hix, mem4loy:mem4hiy,
     .                  mem4loz:mem4hiz, mem4lot:mem4hit,
     .                  mem4loe:mem4hie, mem4lof:mem4hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l, m, n
      INTEGER slen, blen, iunit, icruise, nd
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2
      CHARACTER*512 fname
      CHARACTER*100 errtxt
      CHARACTER*512 buff, buff_cname

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

C  Get file name

      CALL ef_get_arg_string(id, ARG4, fname)

      iunit = 19

       OPEN( UNIT        = iunit,
     .       FILE        = fname,
     .       FORM        = 'FORMATTED',
     .       ACCESS      = 'SEQUENTIAL',
     .       STATUS      = 'REPLACE',
     .       ERR         = 5010 )

* Write webrowset header.

      buff = "<?xml version='1.0'?>"
      slen = 21
      WRITE (iunit, 1000) buff(1:slen)
 1000 FORMAT(A)

c      buff = "<webRowSet xmlns='http://java.sun.com/xml/ns/jdbc' " //
c     .       "xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'"
c      slen = 104
c      WRITE (iunit, 1000) buff(1:slen)
c
c      buff = "xsi:schemaLocation='http://java.sun.com/xml/ns/jdbc " //
c     .       "http://java.sun.com/xml/ns/jdbc/webrowset.xsd'>"
c      slen = 99
c      WRITE (iunit, 1000) buff(1:slen)
      
      buff = "<webRowSet>"
      slen = 99
      WRITE (iunit, 1000) buff(1:slen)

      WRITE (iunit, *) '<data>'

* Write cruise ids and numbers to the webrowset file...

      j1 = arg_lo_ss(Y_AXIS,ARG1)
      k1 = arg_lo_ss(Z_AXIS,ARG1)
      l1 = arg_lo_ss(T_AXIS,ARG1)
      m1 = arg_lo_ss(E_AXIS,ARG1)
      n1 = arg_lo_ss(F_AXIS,ARG1)

* If the cruise_name is different from the cruise_id,
* write the cruise_name in parentheses after the ID.

      icruise = 0
      DO 100 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)
         IF ( arg_3(i1,j1,k1,l1,m1,n1) .NE. bad_flag(ARG3) ) THEN
            icruise = icruise + 1 
            IF ( icruise .LT. 10 ) THEN
               WRITE (iunit, 1010) icruise
            ELSE IF ( icruise .LT. 100 ) THEN
               WRITE (iunit, 1020) icruise
            ELSE IF ( icruise .LT. 1000 ) THEN
               WRITE (iunit, 1030) icruise
            ELSE
               WRITE (iunit, 1040) icruise
            ENDIF

 1010       FORMAT('<currentRow>'/'<columnValue>'/I1/'</columnValue>')
 1020       FORMAT('<currentRow>'/'<columnValue>'/I2/'</columnValue>')
 1030       FORMAT('<currentRow>'/'<columnValue>'/I3/'</columnValue>')
 1040       FORMAT('<currentRow>'/'<columnValue>'/I4/'</columnValue>')

            CALL EF_GET_STRING_ARG_ELEMENT_6D(id, ARG1, arg_1,
     .                         i1, j1, k1, l1, m1, n1, slen, buff)
            CALL EF_GET_STRING_ARG_ELEMENT_6D(id, ARG2, arg_2,
     .                         i1, j1, k1, l1, m1, n1, blen, buff_cname)
            IF ( slen .EQ. blen ) THEN
               IF ( buff(:slen) .EQ. buff_cname(:slen) ) blen = 0
            ENDIF
            IF ( blen .GT. 0 ) THEN
               buff(slen+1:slen+2) = ' ('
               slen = slen + 2
               buff(slen+1:slen+blen) = buff_cname(:blen)
               slen = slen + blen
               buff(slen+1:slen+1) = ')'
               slen = slen + 1
            ENDIF

            WRITE (iunit, 1090) buff(1:slen)
 1090       FORMAT('<columnValue>'/A/'</columnValue>'/'</currentRow>')
         ENDIF
  100 CONTINUE


* Write closing tag.
      WRITE (iunit, 1110) 
 1110 FORMAT ('</data>'/'</webRowSet>')

      CLOSE (iunit, ERR = 5020)
      i = res_lo_ss(X_AXIS)
      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      l = res_lo_ss(T_AXIS)
      m = res_lo_ss(E_AXIS)
      n = res_lo_ss(F_AXIS)
      result(i,j,k,l,m,n) = 1.

      RETURN 

 5010 CONTINUE
      WRITE(errtxt,*) 'Error opening file ', fname
      CALL EF_BAIL_OUT(id, errtxt)
      RETURN

 5020 CONTINUE
      WRITE(errtxt,*) 'Error closing file ', fname
      CALL EF_BAIL_OUT(id, errtxt)
      RETURN

      END

	SUBROUTINE SETSYM(LINE,ILEN,IER,IST)
C** 
C**    @(#)setsym.f	1.2    5/26/88
C**
C**
C***********************************************************************
C**
C**		    PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C**	Subprogram called:
C**		CALL SETSYM(LINE,ILEN,IER,IST)
C**
C**	Parameters:
C**		LINE -- Line containing symbol and value (char*2048)
C**		ILEN -- Length of LINE
C**		IER  -- Error code
C**			0 = success
C**			1 = symbol not found
C**		IST -- relative position of sym in LINE
C**
C**	Description:
C**		Parses LINE and sets the symbol defined with the value
C**		specified.
C**
C**	History:
C**	    Written:
C**		22-DEC-85	by Donald W. Denbo
C**	    Modified:
C**
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
** TMAP mod **
* *sh* 10/27/94 - modified for AIX port
*	Modification uses TM_NUMBER to determine if "value" is a number rather
*	than the ERR= branch of a READ which fails on AIX/xlf
* *jd* 11.3.94 Fixed(?) the fix -- permit read if text is a number
**************
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 

C* v552 *acm* 3/03 Longer strings: changes for multi-line labels
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long
* v695 9/15 *acm* write values to PPL* symbols using 6 digits not 4


	CHARACTER LINE*(*),VALUE*2048,SYM*120,OPR*1,ARG(4)*120
	CHARACTER FUNCT*30,FRMT*30
	LOGICAL NUM,FUNC

	LOGICAL TM_NUMBER		! ** TMAP mod 10/94 **
C
C	PARSE LINE 
C
	IST=0
	NUM=.TRUE.
	ISPC=INDEX(LINE(:ILEN),' ')
	IF(ISPC.EQ.0.)ISPC=ILEN+1
	IPARN=INDEX(LINE(:ILEN),')')
	IF(IPARN.EQ.0.OR.IPARN.GT.ISPC)THEN
	    I=ISPC-1
	ELSE
	    I=IPARN
	ENDIF
	SYM=LINE(:I)
	N=0
100	I=I+1
	IF(I.GT.ILEN)GOTO 120
	IF(LINE(I:I).EQ.' ')GOTO 100
C
C	I=START OF VALUE
C
	FUNC=LINE(I:I).EQ.'$'
C
	IF(LINE(I:I).EQ.'"')THEN
	    I=I+1
	    NUM=.FALSE.
	ENDIF
	VALUE=LINE(I:ILEN)
	N=ILEN-I+1
	IF(VALUE(N:N).EQ.'"')THEN
	    VALUE(N:N)=' '
	    N=N-1
	ENDIF
C
C	TEST FOR ALGEBRA AND DECODE IF IT HAS CORRECT SYNTAX
C
	IF(FUNC)THEN
	    FUNCT=VALUE
	    CALL UPPER(FUNCT,30)
C
C	PARSE FUNCTION ARGUEMENTS
C
	    I=INDEX(VALUE,'(')+1
	    J=INDEX(VALUE,')')-1
	    VALUE=VALUE(I:J)
	    N=J-I+1
	    K=1
300	    CALL CMLJST(VALUE,N)
	    IF(VALUE(1:1).EQ.'"')THEN
		II=INDEX(VALUE(2:),'"')
		ARG(K)=VALUE(2:II)
		I=INDEX(VALUE(II+1:),',')+II-1
		IF(I.EQ.II-1)I=N
	    ELSE
		I=INDEX(VALUE,',')-1
		IF(I.EQ.-1)I=N
		ARG(K)=VALUE(:I)
	    ENDIF
	    IF(I.LT.N)THEN
		K=K+1
		VALUE=VALUE(I+2:)
		N=N-I-1
		GOTO 300
	    ENDIF
C
C	$EDIT(symbol,arguement)
C
	    IF(FUNCT(1:3).EQ.'$ED')THEN
		CALL GETSYM(ARG(1),VALUE,N,IER)
		CALL UPPER(ARG(2),30)
		IF(INDEX(ARG(2),'UP').NE.0)THEN
		    CALL UPPER(VALUE,N)
		ENDIF
		IF(INDEX(ARG(2),'TR').NE.0)THEN
		    CALL CMLJST(VALUE,N)
		    N=LNBLK(VALUE,N)
		ENDIF
		IF(INDEX(ARG(2),'COM').NE.0)THEN
		    CALL CMPRSS(VALUE,N)
		ENDIF
		IF(INDEX(ARG(2),'COL').NE.0)THEN
		    CALL SQUISH(VALUE,1,N)
		    N=LNBLK(VALUE,N)
		ENDIF
C
C	$EXTRACT(start,length,symbol)
C
	    ELSE IF(FUNCT(1:3).EQ.'$EX')THEN
		CALL GETSYM(ARG(3),VALUE,N,IER)
		CALL RDFLT(ARG(1),X)
		I=INT(X)
		CALL RDFLT(ARG(2),X)
		J=INT(X)
		VALUE=VALUE(I:I+J)
		N=J
C
C	$INTEGER(symbol)
C
	    ELSE IF(FUNCT(1:3).EQ.'$IN')THEN
		CALL GETSYM(ARG(1),VALUE,N,IER)
		CALL RDFLT(VALUE,X)
		WRITE(VALUE,'(I10)')INT(X+0.5)
		N=10
		CALL CMLJST(VALUE,N)
		N=LNBLK(VALUE,N)
C
C	$LENGTH(symbol)
C
	    ELSE IF(FUNCT(1:3).EQ.'$LE')THEN
		CALL GETSYM(ARG(1),VALUE,N,IER)
		WRITE(VALUE,'(I10)')N
		N=10
		CALL CMLJST(VALUE,N)
		N=LNBLK(VALUE,N)
C
C	$LOCATE(substring,symbol)
C
	    ELSE IF(FUNCT(1:3).EQ.'$LO')THEN
		CALL GETSYM(ARG(2),VALUE,N,IER)
		K=LNBLK(ARG(1),30)
		I=INDEX(VALUE(:N),ARG(1)(:K))
		WRITE(VALUE,'(I10)')I
		N=10
		CALL CMLJST(VALUE,N)
		N=LNBLK(VALUE,N)
C
C	$ELEMENT(position,delimeter,symbol)
C
	    ELSE IF(FUNCT(1:3).EQ.'$EL')THEN
		CALL GETSYM(ARG(3),VALUE,N,IER)
		CALL RDFLT(ARG(1),X)
		K=INT(X)
		I=1
400		CALL CMLJST(VALUE,N)
		J=INDEX(VALUE(:N),ARG(2)(1:1))
		IF(J.EQ.0)THEN
		    IF(K.EQ.I)THEN
			J=N+1
		    ELSE
			VALUE=ARG(2)(1:1)
			N=1
			GOTO 410
		    ENDIF
		ENDIF
		IF(K.EQ.I)THEN
		    VALUE=VALUE(:J-1)
		    N=LNBLK(VALUE,J-1)
		    GOTO 410
		ELSE
		    VALUE=VALUE(J+1:)
		    N=N-J
		    I=I+1
		ENDIF
		GOTO 400
410		CONTINUE
	    ENDIF
	ELSE IF(NUM)THEN
	    I=INDEX(VALUE,' ')
	    K=I-1
	    if(k.eq.1)then
#ifdef AIX_XLF
	       IF ( .NOT.TM_NUMBER(value(:k)) ) GOTO 120! ** TMAP mod 10/94 **
#endif
		read(value(:k),'(i1)',err=120)jk
		x1=jk
	    else
	    WRITE(FRMT,999)K
999	    FORMAT('(F',I3.3,'.0)')
#ifdef AIX_XLF
	    IF ( .NOT.TM_NUMBER(value(:i-1)) ) GOTO 120	! ** TMAP mod 10/94 **
#endif
	    READ(VALUE(:I-1),FRMT,ERR=120)X1
	    endif
200	    I=I+1
	    IF(I.GT.N)GOTO 120
	    IF(VALUE(I:I).EQ.' ')GOTO 200
	    OPR=VALUE(I:I)
	    IOPR=I
210	    I=I+1
	    IF(I.GT.N)GOTO 120
	    IF(VALUE(I:I).EQ.' ')GOTO 210
	    IST=INDEX(VALUE(I:),' ')+I-2
	    K=IST-I+1
	    WRITE(FRMT,999)K
#ifdef AIX_XLF
	    IF ( .NOT.TM_NUMBER(value(i:ist)) ) GOTO 120	! ** TMAP mod 10/94 **
#endif
	    READ(VALUE(I:IST),FRMT,ERR=120)X2
	    IF(OPR.EQ.'+')THEN
		X=X1+X2
	    ELSE IF(OPR.EQ.'-')THEN
		X=X1-X2
	    ELSE IF(OPR.EQ.'*')THEN
		X=X1*X2
	    ELSE IF(OPR.EQ.'/')THEN
		X=X1/X2
	    ELSE
		GOTO 120
	    ENDIF
	    CALL PUTVAL(SYM,X,7,IER)
	    RETURN
	ENDIF
120	CALL PUTSYM(SYM,VALUE,N,IER)
	RETURN
	END
	SUBROUTINE CMPRSS(STR,LEN)
C
C	REMOVE EXTRA BLANKS
C
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 

	CHARACTER STR*(*),TEMP*2048
	LOGICAL BLANK
	K=1
	BLANK=.FALSE.
	DO 100 J=1,LEN
	    IF(STR(J:J).EQ.' ')THEN
		IF(.NOT.BLANK)THEN
		    BLANK=.TRUE.
		ELSE
		    GOTO 100
		ENDIF
	    ELSE
		BLANK=.FALSE.
	    ENDIF
	    TEMP(K:K)=STR(J:J)
	    K=K+1
100	CONTINUE
	STR=TEMP(:K-1)
	LEN=K-1
	RETURN
	END
	SUBROUTINE RDINT(STR,K)
	CHARACTER STR*(*),FRMT*30
	N=LNBLK(STR,30)
	if(n.eq.0)then
	    k=0
	    return
	endif
	WRITE(FRMT,999)N
999	FORMAT('(I',I2.2,')')
	READ(STR,FRMT)K
	RETURN
	END
	SUBROUTINE RDFLT(STR,X)
        LOGICAL TM_NUMBER                ! ** TMAP mod 11/94 **
C
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 

	CHARACTER STR*(*),FRMT*30
	N=LNBLK(STR,30)
	IF(N.EQ.0)THEN
C
C	DEFAULT VALUE IF NO NUMBER IS 1.0
C
100	    X=1.0
	    RETURN
	ENDIF
	if(n.eq.1)then
#ifdef AIX_XLF
            IF ( .NOT.TM_NUMBER(str) ) GOTO 100  ! ** TMAP mod 11/94 **
#endif
	    read(str,'(i1)',err=1000)jk
	    x=jk
	else
	WRITE(FRMT,999)N
999	FORMAT('(F',I2.2,'.0)')
#ifdef AIX_XLF
            IF ( .NOT.TM_NUMBER(str) ) GOTO 100  ! ** TMAP mod 11/94 **
#endif
	READ(STR,FRMT,ERR=1000)X
	endif

C       7/97 added following in - needed to preven reseting of x *kob*
	RETURN
C	Change above err=100 stmts to err=1000 and copy that line
C	for FORTRAN 90 on linux *jd* 1.21.97
1000	x=1.0

	RETURN
	END

	SUBROUTINE LINE_FACTS( lun, idim, grid, orient, uvar )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* print basic facts about an axis defined in memory

* New 12/15:
* last argument: uvar is positive if we are to describe the 
* grid subset for the user-variable given.

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 8/1/88 - extracted from SHOW_GRID - axis limits --> box_middle
* revision 0.1 - 8/16/88 - elimiinated units, expanded title field
* revision 0.2 - 2/6/89 - added modulo axis indicator 
* V200:  9/22/89 - added "orient" for axes without particular orientations
* SUN port 3/92 *sh* - "T" format specifiers cannot move to left
*                    - changed format 3020
* V230:  6/22/92 - allow for long axis names by truncating the title field
*        1/93 - corrected left-over bug in format 3020 from SUN port A15->A14
* V320: 12/20/94 - Put "(-)" along with "m" and "r" so it doesn't get
*		truncated now that DEPTH(units) is the label
*       12/29/94 - use SPLIT_LIST to redirect tty output for GUI
* V510 *sh* 12/99 - show units even if line has no orientation
* V68  *acm 12/11 - if npts > 1.e7 the format overflowed. Up the size.
* V697  12/15 *acm* Changes to add details on SHOW GRID uvar to indicate 
*                   compressed or subset of axes
* V697  12/15 *acm* Changes to formatting the output that shows subsets
* V698 2/16 *acm*  For ticket 1786: if mode_upcase is canceled write axis name
*                  using original upper/lowercase spelling
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.
* V72  3/17 *acm* Fix ticket 2518: The number of points reported in a subset was incorrect
* v74  *acm*  1/18 Fixing issue 1575, setting uvar_given for result of grid-changing functions
*                  that return results on abstract axes.
* v75  *acm* 3/18  Issue 1856, changes to allow for timesteps in fractional seconds
* v74  *acm* 3/18  Backing off the fix for 1575, see comments 3/16/2018
* V751 6/19 *acm* TM_FMT rewrite: formatting of lon/lat coordinate strings
* V751 6/19 *acm* For DSG data indicate the obs dimension

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
#	include "tmap_dset.parm"
	include 'implicit.parm'
	include 'xdset_info.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include 'xtext_info.cmn'
	include 'xrisc.cmn'          ! 12/94 SPLIT_LIST buffer
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
        include 'calendar.decl'
        include 'calendar.cmn'

* calling argument declarations
	INTEGER	  lun, idim, grid, orient, uvar

* local variable declarations:
	LOGICAL	BKWD_AXIS, GEOG_LABEL, ITSA_TRUEMONTH_AXIS, TM_FPEQ,
     .          calendar, original, true_month, ss_ok, its_dsg_ragged, its_dsg

	INTEGER TM_LENSTR1, TM_SUBSC, TM_GET_CALENDAR_ID, STR_SAME,
     .          lo, hi, i, line, dlen, ndec, status,nlen, naxlen, 
     .          int1, slen, i1ss, inss, cal_id, dsg_orient, obsdimlen, 
     .          feature_line
	CHARACTER AX_TITLE*32, TM_FMT*48, lo_str*28, hi_str*28, direction*1,
     .		  title*32, reg*1, modflag*1, truncated*1, frmt*80,
     .		  lo_uvar*20, hi_uvar*20, uvar_desc*40, cstr*3, countstr*20,
     .		  axname*64, buff*20
	REAL*8	TM_WORLD, lo_val8, hi_val8, pts

* local parameter declarations:
	INTEGER		sig_figs
	PARAMETER     ( sig_figs = 5 )

* pull line from grid table
	line = grid_line( idim, grid )

* is this a DSG ragged contiguous "axis"
	its_dsg_ragged = idim.NE.e_dim
     .		   .AND. line_dsg_dset(line).NE.pline_not_dsg

* line ok ?
	risc_buff = ' '
	IF ( line .EQ. munknown ) THEN
	   title = 'unknown'
	   WRITE ( risc_buff, 3010 ) title, ww_dim_name( idim )
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
	ELSEIF ( line .EQ. mnormal ) THEN
	   title = 'normal'
	   WRITE ( risc_buff, 3010 ) title, ww_dim_name( idim )
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
	ELSEIF ( line_name(line) .EQ. char_init)  THEN
	   title = 'normal'
	   WRITE ( risc_buff, 3010 ) title, ww_dim_name( idim )
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
	ELSE

* get nicely formatted limits (end box outer edges)
	   calendar = idim .EQ. t_dim .AND. GEOG_LABEL( idim, grid )	
	   lo_val8 = TM_WORLD( 1, grid, idim, box_middle )
	   IF ( calendar ) THEN
	      ndec = 5 		! accurate to minutes
	   ELSE
	      ndec = sig_figs	! 5 sig places w/out extra zeros
	      ndec = -5  ! 
	      IF (i .EQ. y_dim) ndec = -3
	   ENDIF
	   true_month = ITSA_TRUEMONTH_AXIS (line)
	   IF (true_month) ndec = 2
	   CALL TRANSLATE_TO_WORLD( lo_val8, idim, grid, ndec, lo_str )
	   hi_val8 = TM_WORLD( line_dim(line), grid, idim, box_middle )
	   IF ( calendar ) THEN
	      ndec = 5 
	   ELSE
	      ndec = sig_figs
	      ndec = -5  ! 
	      IF (i .EQ. y_dim) ndec = -3
	   ENDIF
	   IF (true_month) ndec = 2

	   CALL TRANSLATE_TO_WORLD( hi_val8, idim, grid, ndec, hi_str )

	   IF (.NOT.TM_FPEQ(lo_val8, hi_val8) .AND. STR_SAME (lo_str, hi_str) .EQ. 0) THEN
	      ndec=9
	      CALL TRANSLATE_TO_WORLD( lo_val8, idim, grid, ndec, lo_str )
	      CALL TRANSLATE_TO_WORLD( hi_val8, idim, grid, ndec, hi_str )
	   ENDIF

* axis oriented backwards ?
	   IF ( BKWD_AXIS(idim, grid) ) THEN
	      direction = '-'
	   ELSE
	      direction = ' '
	   ENDIF

* axis title
	   IF ( orient .EQ. 0 ) THEN
	      title = line_units(line)
	      IF (title .EQ. ' ') THEN
	         dlen = 1
	      ELSE
	         dlen = TM_LENSTR1(title)
	         title = '('//line_units(line)(:dlen)//')'
	         dlen = dlen + 2
	      ENDIF
	   ELSE
	      title = AX_TITLE( idim, grid, dlen )
	   ENDIF
!	   title = title(:dlen)//direction	! 12/94 removed

* regularly spaced ?

	   IF ( line_regular( line ) ) THEN
	     reg = 'r'
	   ELSE
	     reg = 'i'
	   ENDIF
	   IF (true_month) THEN
               cal_id = TM_GET_CALENDAR_ID (line_cal_name (line))
	       IF (cal_id .NE. d360) reg = 'i'
	   ENDIF

* modulo ?
	   IF ( line_modulo( line ) ) THEN
	     modflag = 'm'
	   ELSE
	     modflag = ' '
	   ENDIF

* allow for long axis names (6/92)
	   original = .FALSE.
	   CALL CHOOSE_LINE_NAME(line, original, axname)
           nlen = MAX( TM_LENSTR1(axname), 9 )

	   naxlen = INT(0.5+DLOG10(DFLOAT(line_dim(line))) ) 

* report information about the subsetting or compressing of the grid.

* FERRET DOCUMENTATION: implicit grid modifications of LET vars (e.g. @AVE)
* From merge_grid:
* There are subtlities associated with limits that are given in the UVAR
* definition.  These are classified in uvar_given under these codings:
* ("gvn" indicates lo/hi limits were given in square brackets)
* ("gnl","lo","lohi" and "xact" encode special requirements of transformations)
*
*    -1   uvlim_irrelevant- limits irrelevant: NEW=10.1
*    -2   uvlim_hidden    - limits hidden inside on another axis: NEW=FFT(v)
*     0   uvlim_gvn_gnl   - limits given in a gen'l way: NEW=U[K=1:5]
*     1   uvlim_gvn_lo    - limits that require exact lo match: NEW=U[K=1:5@IIN]
*     2   uvlim_gvn_lohi  - limits require exact lohi match: NEW=U[K=1:5@WEQ]
*     3   uvlim_gvn_xact  - limits that reduce to a pt.: NEW=U[K=1:5@AVE]
*     4   uvlim_needed    - no limit info. given
*     5   uvlim_need_lo   - no lims but transf. needs xact lo:NEW=U[K@IIN]
*     6   uvlim_need_lohi - no lims but transf. needs xact lohi:NEW=U[K=@WEQ]
*     7   uvlim_need_xact - no lims but transf. needs xact: NEW=U[K@AVE]
*   100   uvlim_unknown

* Subsets on axis, compressing transform, ... All this is
* skipped if it's a SHOW AXIS or SHOW GRID gridname

	   IF (uvar .GT. 0) THEN 
	      uvar_desc = 'full'

* Subsets orange in transform or expression
	   IF ( uvar_given(idim,uvar) .EQ. uvlim_gvn_gnl  .OR. 
     .          uvar_given(idim,uvar) .EQ. uvlim_gvn_lo   .OR. 
     .          uvar_given(idim,uvar) .EQ. uvlim_gvn_lohi )  THEN
cc	      ss_ok = .TRUE.
	      IF (uvar_lo_ss(uvar, idim) .NE. unspecified_int4) THEN
	         i1ss = uvar_lo_ss(uvar, idim)
	         inss = uvar_hi_ss(uvar, idim)
	      ELSE
cc		 ss_ok = (uvar_lo_ww(idim, uvar).NE.unspecified_val8 .AND.  
cc     .                    uvar_hi_ww(idim, uvar).NE.unspecified_val8)
cc	         IF (ss_ok) THEN
		    i1ss =  TM_SUBSC ( uvar_lo_ww(idim, uvar), grid, idim, -1 )
	            inss =  TM_SUBSC ( uvar_hi_ww(idim, uvar), grid, idim, -1 )
cc	         ENDIF
	      ENDIF

! bit of a hack; see the fix for issue 1575 in abstract-axis in is_do_gc_fcn.F
cc	      IF (ss_ok) THEN  
	       IF (i1ss .EQ. inss) THEN
	          uvar_desc = '1 pt'
	       ELSE
	          countstr = TM_FMT(FLOAT(inss-i1ss+1), 15, 20, slen)
	          uvar_desc = countstr(:slen)//' pts'
	       ENDIF
cc	      ENDIF  ! ss_ok
	   ENDIF

* Compressing
*   Single-point subsets are marked as gvn_xact (for conformability?)
*   which would result in "compressed" here. 
*   So if gvn_xact and hi=lo, call that a single-point subset.
*   This means that var[x=5@max] is also reported as point subset. 

	   IF ( uvar_given(idim,uvar) .EQ. uvlim_gvn_xact)  THEN
	      IF (uvar_lo_ss(uvar, idim) .NE. unspecified_int4) THEN
	         i1ss = uvar_lo_ss(uvar, idim)
	         inss = uvar_hi_ss(uvar, idim)
	      ELSE
	         i1ss =  TM_SUBSC ( uvar_lo_ww(idim, uvar), grid, idim, -1 )
	         inss =  TM_SUBSC ( uvar_hi_ww(idim, uvar), grid, idim, -1 )
	      ENDIF

	      IF (i1ss .EQ. inss) THEN
	         uvar_desc = '1 pt'
	      ELSE
	         uvar_desc = 'compressed'
	      ENDIF

	   ENDIF

c Compressing transfm, w/o limits

	   IF ( uvar_given(idim,uvar) .EQ. uvlim_need_xact) THEN
	      uvar_desc = 'compressed'
	   ENDIF

* Grid-changing function: uvar_given = uvar_hidden for idim

	   IF (uvar_given(idim,uvar) .EQ. uvlim_hidden )  THEN
	      uvar_desc = '(axis from grid-changing func)'
	   ENDIF

	   ENDIF !  uvar, reporting subset, compression

* Special description to flag the DSG feature orientation axis
* If the grid is pointing to th dsg_xlate_grid don't show the 
* axes other than the one in the dsg-orientation direction.

	   IF (its_dsg_ragged) THEN
	      CALL TM_DSG_FACTS( grid, dsg_orient, obsdimlen, 
     .                  feature_line, its_dsg )
     
	      IF (its_dsg_ragged .AND. idim.LE.t_dim .AND. idim.NE.dsg_orient) THEN
	         title = 'normal'
	         WRITE ( risc_buff, 3010 ) title, ww_dim_name( idim )
		 CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
		 GOTO 5000
	      ENDIF
	      IF (idim .LE. t_dim) uvar_desc = " " 
	      IF (idim .EQ. dsg_orient) uvar_desc = "Variable lengths"
	   ENDIF 

* create format adapted to name length (??)
	   int1 = 34 - (naxlen+1)
	   naxlen = naxlen + 1
	   IF (naxlen .LT. 10) THEN
	      WRITE (frmt, 3020) int1, naxlen
	   ELSE
	      WRITE (frmt, 3030) int1, naxlen
	   ENDIF

* write info (see below -- this may get over-written)
* ?? *sh* 4/17 - could we clean this up? just append the uvar_desc?
	   WRITE ( risc_buff, frmt )	axname(:nlen),
     .				title (:41-nlen),
     .				line_dim  ( line ),
     .				modflag,
     .				reg,
     .				direction,
     .				lo_str,
     .				hi_str

* If there is a subset or compression, add that information. This is
* skipped if it's a SHOW AXIS or SHOW GRID gridname
	   IF (uvar .GT. 0) THEN
	      WRITE ( risc_buff, frmt ) axname (:nlen),
     .				title (:41-nlen),
     .				line_dim  ( line ),
     .				modflag,
     .				reg,
     .				direction,
     .				lo_str,
     .				hi_str,
     .				uvar_desc
	   ENDIF
	   IF (true_month) THEN
	      dlen = TM_LENSTR1(risc_buff)
	      IF (dlen.GT.1) risc_buff = risc_buff(:dlen)//' (True Monthly)'
	   ENDIF
	   

	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

	ENDIF

 5000	RETURN

 3010	FORMAT ( T2,A8,T12,A1 )

 3020   FORMAT ('(T2,A,1X,A,T',I2,',I',I1',3A1,T39,A20,T60,A20,T80,A)')
 3030   FORMAT ('(T2,A,1X,A,T',I2,',I',I2',3A1,T39,A20,T60,A20,T80,A)')

	END

	SUBROUTINE IS_ALGEBRA(  *, *, isp_base, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* evaluate an algebraic evpression component by component on the 
* interpretation stack.  When component variables are required request them
* by return to the top of the stack processor in "request" mode (RETURN 1).

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 2/12/87
* revision 0.1 - 6/ 3/87 - corrected 'alg_stk_err' in "LIST 1"
* revision 0.2 - 7/28/87 - changed method of constant evaluation to be like
*			   vars and pseudo-vars in order to avoid stack errors
*			   from constants left on stack when this subr. exits
* revision 0.2a- 8/29/87 - context stack bug for norm trans of constant
* V200:  6/20/89 - 4D symmetric version, numerous changes
*	11/29/89 - include constants and pseudo-variables on context merges
* V312:  5/94 - array "memory" as a calling argument
* V420:  9/95 - deallocate dynamic grid (if any) at cleanup time
* V450:  1/97 - process alg_child_var and alg_grid_chg_fcn
*        7/97 - generate child var name using GCF_PARENT_UVAR
* V491   3/98 - sgi benchmarking uncovered bug in psuedo_variable processing - 
*               no valid "name" was being set up   *kob/sh*
*        4/98 - pass default context (lo_cx) to MERGE_CONTEXT *jc*
* V500: 12/98 *sh* - add cat_const_var (like "{1,3,5}")
*	 1/99 *sh* - add cat_string -- temporarily do not allow A="string"
*	 3/99 *sh* - bug fix in context passing to GC args
*		default cx must contain grid before call to
*		GCF_IMPOSE_ARG_LIM_DFLTS  - so it can check if arg
*		axes match result for (say) RESHAPE
*		This requires a "2-pass" approach ("ugly hack", below).
*	3/99 *sh* ==> NOT IMPLEMENTER (see "3/99" below)
*		call TRANSFER_CONTEXT(big_cx, lo_cx) at end of
*		EXPLICIT_UVAR, too, since changes to handling unspecified
*		limits (see COMPLETE_MISSING_LIMITS)
* V510: 8/99 *sh* - added SAMPLE*. Logic in this routine is because the
*		2nd arg to SAMPLE* controls the request for the 1st --
*		here we detect that, interchange the ordering, and
*		call IS_SAMPLE for arg 1 (Note: would have been much simpler
*		if arg order was reversed, but the function already existed
*	10/99 *sh* repair of bug introduced by 3/99 change for RESHABE, above
*		see "ugly hack" in code
*	1/00 *sh* error check bug corrected for GC functions (esp. RESHAPE) 
*	1/00 *sh* naming bug corrected for nested GC functions
*	2/00 *sh* bug in check for SAMPLE finctions -- use nitem not "3"
*	3/00 *sh* bug in ERRMSG call at 5900 - extra comma in args
* V510: 5/00 *sh* - set bad flag on user variables
*	5/00 *sh* - bug fix: ifcn not init'ed in time for MERGE_CONTEXT(big_cx)
* V530: 8/00 *sh* - added support for string arrays
*	12/00 *sh* bug fix: constants as in LET a = 5 were not deleted -- they
*		accumulated and used up mvars -- err522_too_many_vars.jnl
* V533: 7/01 *sh* - added support for functions returning different data types
*		  - alg_no_op removed to allow string IF-THEN-ELSE exprns
* v552: 4/03 *acm*  Increase length of variable names to 128 characters
*                   (variables are up to 128, so **name** needs extra space
*                   i.e. for a transformation specifier)
* v554: 1/04 *acm* Counter variables for REPEAT/RANGE=/NAME=
* V600 8/05 *acm* - Add variable type attrib_val for definitions of the form
*                   varname.attname
* v664 9/10 *acm* Check variables for NaN and replace (unless the bad-value IS NaN
* V671 7/11  *acm* Ticket 1868 IFV - masking expressions with ifValid, treating 
*		   zero as valid. 
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V694  1/15 *acm* as part of changes for ticket 2227 (handling of dimensions
*                  that are not also 1-D coordinate variables), when returning 
*                  ..dimnames, now list of all dimensions in the dataset.
* V694  5/15 *acm* Fix ticket 2291. When merging, handle variables from attribute
*                  as temp variables.
* V694 5/14  *acm* Ticket 2234. return-type error on string operations
* V697  3/16 *acm* Ticket 2367. Return-type error for user variable when expr
*                  uses a function having numeric and string versions.
* v698 5/16  *acm* ticket 2413: New attribute keywords ncoordvars, coordnames
*                  return info about coordinate-variables in datasets
* V7    5/16 *acm* See ticket 2352. For LET/D variables look for info under that dataset
* V710 9/16  *acm* ticket 2465: Parsing expressions including attribute references.
* V702 1/17 *sh* as a part of conversion to dynamic memory fixed bug that 
*                CHECK_NAN_DATA_SUB was being called on string variables
* V720: 4/17 *acm* Add direction-changing functions as a subset of grid-changing ones

	include 'tmap_dims.parm'
#include "netcdf.inc"
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'grid_chg_fcns.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'
        include 'xcontrol.cmn'
        include 'xalgebra.cmn'

* calling argument declarations:
	INTEGER	isp_base, status
!	REAL	memory( mem_blk_size, * )             ! experimental change
* normal return is for error conditions
* exit #1 is to request another grid ( stack has been pushed )
* exit #2 is to signal completion of the activity at this stack level

* internal variable declarations:
	LOGICAL	EXPLICIT_UVAR, ITSA_GCVAR, NC_GET_ATTRIB, 
     .          its_gc, its_sample, start_sampling, got_it, coordvar,
     .          reset_ss, do_err
	INTEGER KNOWN_GRID, TM_LENSTR1, GCF_PARENT_UVAR, GCF_PARENT_CHAR,
     .		GCF_FIND_FCN, GCF_ARG_EVAL_ORDER, GET_VAR_GRID,
     .		MGRID_SIZE, STR_SAME, hi_mr, hi_cx, lo_cx, big_cx,
     .		dflt_cx, start, end, saved_grid, ifcn, size,
     .		dset, lo_isp, uvar, item, itype, idim,
     .		nitem, new_mr, len_name, idig, csp1, cat, cvar, 
     .          varid, attlen, attype, maxlen, attoutflag,
     .          ndims, nvars, ngatts, recdim, ivar, vartype, 
     .          nvdims, vdims(8), nvatts, nv, iatt, all_outflag, dot,
     .          attid, slen
        REAL    counter_const, val
*                  

	CHARACTER TM_FMT*150, name*150, attname*128, aname*128, buff*10

*        ... interpretation stack setup at the time this is called ...
*	stack level		stack contents
*	isp+1	<--	level of next activity ( component to get )
*	 isp	<--	... ( current stack level )
*	isp-1		...
*	isp-2	<--	...	components of this uvar on stack
*	isp-n		...
*	lo_isp	<--	level controlling evaluation of uvar

* --- end of introductory code ---

* test to see if first time called - designate stack activity as algebra
	IF ( is_act(isp) .EQ. isact_request ) THEN
	   lo_isp = isp
	   is_phase( lo_isp ) = 0
	   is_act  ( lo_isp ) = isact_algebra
	ELSE
	   isp = isp + 1			! point to component just got
	   lo_isp = is_obj( isp )
	   hi_cx  = is_cx( isp )
	ENDIF

* convenience values
	lo_cx  = is_cx( lo_isp )
	big_cx = is_big_cx( lo_isp )
	uvar   = is_uvar( lo_isp )
	nitem  = uvar_num_items( uvar )
	dset   = cx_data_set( lo_cx )

* is it a grid-changing variable?
	its_gc = ITSA_GCVAR(uvar)
	IF ( its_gc ) THEN
	   start = uvar_item_start( nitem, uvar )  ! nitem has the fcn itself
	   end   = uvar_item_end  ( nitem, uvar )
	   ifcn = GCF_FIND_FCN( uvar_text(uvar)(start:end) )
	ENDIF

* create, initialize or merge overall context for the algebraic expression
	IF ( is_phase(lo_isp) .EQ. 0 ) THEN
	   cx_grid( lo_cx ) = KNOWN_GRID( dset ,cat_user_var, uvar )
	   IF ( mode_diagnostic )
     .			CALL DIAGNOSTIC_OUT( 'eval   ', lo_cx, point_to_cx )
	   CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   big_cx = cx_stack_ptr
	   CALL INIT_EMPTY_CONTEXT( big_cx)  ! moved from below 8/00 *sh*
	   is_big_cx( lo_isp ) = big_cx
	   is_sum   ( lo_isp ) = isalg_transfer
!	ELSEIF ( cx_category( hi_cx ) .EQ. cat_constant
!     .	   .OR. ( cx_category(hi_cx) .EQ. cat_pseudo_var
!     .		  .AND. .NOT.cx_unstand_grid(hi_cx)      )  ) THEN
!	   GOTO 100		! can't construct a context from these

* 1/97 - need a somewhat separate path through the merging of contexts when
*	dealing with grid changing variables. For non-grid-changing vars
*	we may have "LIST A", inwhich case the merged context needs to look
*	just like "A". For grid-changing variables this can never occur, since
*	they are always of the form GCFUNC(arg1, arg2, ...), but it is not
*	safe to begin the merging with TRANSFER_CONTEXT because the first
*	arg may be designated not to contribute all of its axes to the merged
*	result 
	ELSEIF ( its_gc ) THEN
	   IF ( is_sum(lo_isp) .EQ. isalg_transfer ) THEN
	      CALL MERGIFY_CX( lo_cx, uvar, big_cx, status )
!	      cx_type(big_cx) = ptype_float   ! TEMPORARY - UNTIL STRNG FCNS
	      is_sum( lo_isp ) = isalg_merge_1
	   ELSEIF ( is_sum(lo_isp) .EQ. isalg_merge_1 ) THEN
* ... this allows us to distinguish between single component and
*	multi-component expressions. "LIST A" should document "A", not "E315"
	      is_sum( lo_isp ) = isalg_merge_n
	   ENDIF
	   item = GCF_ARG_EVAL_ORDER( ifcn, is_phase(lo_isp) )
	   itype = uvar_item_type ( item, uvar )
	   start = uvar_item_start( item, uvar )
	   end   = uvar_item_end  ( item, uvar )
	   CALL MERGE_CONTEXT(	its_gc, item, lo_cx, big_cx, hi_cx,
     .				uvar_text(uvar)(start:end), status )
	   IF ( status .NE. ferr_ok ) RETURN

* pre grid-changing code - 1st arg treated differently from others
	ELSEIF ( is_sum(lo_isp) .EQ. isalg_transfer ) THEN
	   CALL TRANSFER_CONTEXT( hi_cx, big_cx )
	   is_sum( lo_isp ) = isalg_merge_1
	ELSE
	   IF (  is_sum(lo_isp) .EQ. isalg_merge_1 ) THEN
	      CALL MERGIFY_CX( lo_cx, uvar, big_cx, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
!	      cx_type(big_cx) = ptype_float   ! only GC vars allow strings (??)
	      is_sum( lo_isp ) = isalg_merge_n
	   ENDIF
	   item = is_phase(lo_isp)		! points into uvar_text
	   itype = uvar_item_type ( item, uvar )
	   start = uvar_item_start( item, uvar )
	   end   = uvar_item_end  ( item, uvar )
	   CALL MERGE_CONTEXT( its_gc, item, lo_cx, big_cx, hi_cx,
     .				uvar_text(uvar)(start:end), status )
	   IF ( status .NE. ferr_ok ) RETURN
	ENDIF

* is it a SAMPLE* function? (8/99)
	IF ( its_gc ) THEN
	   its_sample = ifcn .GE. p_samplei
     .		.AND.   ifcn .LE. p_samplen
	ELSE
	   its_sample = .FALSE.
	ENDIF
	start_sampling = .FALSE.

* ****** (continue) LOOP through expression ***********************************
* process the next item in the expression from the uvar buffer
 100	is_phase(lo_isp) = is_phase(lo_isp) + 1
	IF ( its_gc ) THEN
	   item = GCF_ARG_EVAL_ORDER( ifcn, is_phase(lo_isp) )
	ELSE
	    item = is_phase(lo_isp)		! points into uvar_text
	ENDIF
	IF ( its_sample ) THEN		! kludge for SAMPLE*
	   start_sampling = item .EQ. 1
	ENDIF  
	IF ( item .GT. nitem ) GOTO 1000
	itype = uvar_item_type ( item, uvar )
	start = uvar_item_start( item, uvar )
	end   = uvar_item_end  ( item, uvar )
	IF     ( itype .EQ. alg_constant   ) THEN
	   GOTO 200
	ELSEIF ( itype .EQ. alg_child_var   ) THEN
	   GOTO 300
	ELSEIF ( itype .EQ. alg_variable   ) THEN
	   GOTO 305
	ELSEIF ( itype .EQ. alg_pseudo_var ) THEN
	   GOTO 400
	ELSEIF ( itype .EQ. alg_function
     .	    .OR. itype .EQ. alg_operator
     .	    .OR. itype .EQ. alg_log_struct
     .	    .OR. itype .EQ. alg_log_vstruct   ) THEN
	   GOTO 500
	ELSEIF ( itype .EQ. alg_grid_chg_fcn
     .	    .OR. itype .EQ. alg_dir_chg_fcn ) THEN
	   GOTO 600
	ELSEIF ( itype .EQ. alg_const_var ) THEN
	   GOTO 700
	ELSEIF ( itype .EQ. alg_attrib_val ) THEN
	   GOTO 750
        ELSEIF ( itype .EQ. alg_string ) THEN
	   GOTO 800
	ELSEIF ( itype .EQ. alg_if_marker
     .	    .OR. itype .EQ. alg_then_marker ) THEN
	   GOTO 100
	ELSEIF ( itype .EQ. alg_counter_var ) THEN
	   GOTO 210
	ELSE
	   STOP 'unknown algebraic category'
	ENDIF

* constant - with possible transformations (eg. integrated --> 1[Z=1:100@DIN])
* ... allocate a context buffer 
 200	CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) RETURN
	hi_cx = cx_stack_ptr
	CALL CONSTANT_CONTEXT   ( uvar_text(uvar)(start:end),
     .				  lo_cx,
     .				  hi_cx,
     .				  status )
	IF ( status .NE. ferr_ok ) RETURN
* ... request this constant on the interpretation stack ( via RETURN 1 )
	CALL PUSH_INTERP_STACK( isp, status )
	IF ( status .NE. ferr_ok ) RETURN
	is_cx ( isp ) = hi_cx
	is_obj( isp ) = lo_isp	! claimed by this level
	RETURN 1
        
* counter (REPEAT/RANGE=/NAME=)
* ... allocate a context buffer, dummy constant value which is replaced
* ... later when the counter is evaluated.
 210	CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) RETURN
	hi_cx = cx_stack_ptr
        
* as in cs_command 
        
        CALL find_var_name (dset, uvar_text(uvar)(start:end), cat, cvar)
        csp1 = csp_cvar(cvar)
	counter_const = cs_phase( csp1 ) - cs_delta( csp1 )
        name = TM_FMT(counter_const, idig, 150, len_name)
	CALL CONSTANT_CONTEXT   ( name,
     .				  lo_cx,
     .				  hi_cx,
     .				  status )
	IF ( status .NE. ferr_ok ) RETURN
* ... request this constant on the interpretation stack ( via RETURN 1 )
	CALL PUSH_INTERP_STACK( isp, status )
	IF ( status .NE. ferr_ok ) RETURN
	is_cx ( isp ) = hi_cx
	is_obj( isp ) = lo_isp	! claimed by this level
	RETURN 1

* child variable: treat it just like a regular variable except that 
* its name is not found in the text. Instead generate its name from
* its position and its parent variable
* example: for the definition	LET A = 5 * GCFUNC(b,c)
*    the string "GCFUNC(b,c)" is processed as a child variable
 300	CALL GCF_CHILD_VAR_NAME( GCF_PARENT_UVAR(uvar),
     .				 GCF_PARENT_CHAR(uvar,start), name )
	len_name = TM_LENSTR1(name)
	GOTO 310

* variable: parse name, update full expression context and evaluate
* ... allocate a context buffer for components
 305	name = uvar_text(uvar)(start:end)
	len_name = end - start + 1
 310	CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) RETURN
	hi_cx = cx_stack_ptr
	IF ( .NOT. its_gc ) THEN
	   CALL GET_VAR_CONTEXT (  name(:len_name),
     .				   lo_cx,
     .				   hi_cx,
     .				   status )
	   IF ( status .NE. ferr_ok ) RETURN

	ELSE
* ... for GC variables the default context may get modified before using it
*     to get an argument (e.g. for a fcn equivalent to x=@sbx:5 we'd have
*     LIST/I=5:10 XSBX5(b) requiring I=3:12 of argument "b".
*     BUT: for RESHAPE the grid must already be known to guide this process 
* ... ugly hack: temporarily insert grid into lo_cx
	   saved_grid = cx_grid(lo_cx)
	   cx_grid(lo_cx) = GET_VAR_GRID(name(:len_name),
     .				         lo_cx,
     .				         hi_cx,
     .				         status )
	   IF ( status .NE. ferr_ok ) RETURN
	   CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   dflt_cx = cx_stack_ptr
	   CALL GCF_IMPOSE_ARG_LIM_DFLTS( name(:len_name), item,
     .					  lo_cx, dflt_cx, uvar, status )
	   IF (status .NE. ferr_ok) RETURN
	   cx_grid(lo_cx) = saved_grid		! restore HACK
	   CALL GET_VAR_CONTEXT (  name(:len_name),
     .				dflt_cx,
     .				hi_cx,
     .				status )
	   IF ( status .NE. ferr_ok ) RETURN
	   cx_stack_ptr = cx_stack_ptr - 1	! release dflt_cx
	   IF (cx_has_impl_grid(hi_cx)) THEN	! 10/99
	     CALL DEALLO_DYN_GRID(cx_grid(hi_cx))
	   ENDIF
	ENDIF
* ... request this variable on the interpretation stack ( via RETURN 1 )
	CALL PUSH_INTERP_STACK( isp, status )
	IF ( status .NE. ferr_ok ) RETURN
	is_cx ( isp ) = hi_cx
	is_obj( isp ) = lo_isp	! claimed by this level
	IF ( cx_category(hi_cx) .EQ. cat_user_var ) THEN
* ... special action if this component variable is user-defined (uvar)
	   is_uvar( isp ) = cx_variable( hi_cx )
	ENDIF
	IF ( start_sampling ) GOTO 900
	RETURN 1

* pseudo-variable: parse mods, update full expression context and evaluate
* ... allocate a context buffer for components
 400	CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) RETURN
	hi_cx = cx_stack_ptr
	CALL PSEUDO_VAR_CONTEXT ( uvar_text(uvar)(start:end),
     .				  lo_cx,
     .				  hi_cx,
     .				  idim,
     .				  status )
	IF ( status .NE. ferr_ok ) RETURN

	IF (its_gc ) THEN	! see explanation under "variable' (stmt 310)
* ... ugly hack: temporarily insert grid into lo_cx
	   saved_grid = cx_grid(lo_cx)
	   cx_grid(lo_cx) = cx_grid(hi_cx)
	   CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   dflt_cx = cx_stack_ptr
* use uvar_text as name to pass to gcf_impose...*kob* 3/98
	   CALL GCF_IMPOSE_ARG_LIM_DFLTS( uvar_text(uvar)(start:end), item,
     .					  lo_cx, dflt_cx, uvar, status )
	   IF (status .NE. ferr_ok) RETURN
	   cx_grid(lo_cx) = saved_grid		! restore HACK
	   CALL PSEUDO_VAR_CONTEXT ( uvar_text(uvar)(start:end),
     .				  dflt_cx,
     .				  hi_cx,
     .				  idim,
     .				  status )
	   IF ( status .NE. ferr_ok ) RETURN
	   cx_stack_ptr = cx_stack_ptr - 1	! release dflt_cx
	ENDIF

	IF ( cx_lo_ss(hi_cx,idim) .EQ. unspecified_int4 )  CALL ERRMSG
     .		(ferr_dim_underspec, status,uvar_text(uvar)(start:end), *5000)
! temp diag
	IF ( cx_grid(hi_cx) .EQ. unspecified_int4 ) CALL ERRMSG
     .			( ferr_internal, status, 'isalg_ps', *5000 )
* ... request this variable on the interpretation stack ( via RETURN 1 )
	CALL PUSH_INTERP_STACK( isp, status )
	IF ( status .NE. ferr_ok ) RETURN
	is_cx ( isp ) = hi_cx
	is_obj( isp ) = lo_isp	! claimed by this level
	IF ( start_sampling ) GOTO 900
	RETURN 1

* function logic structure or operator:
* ...compute new value replacing component(s) (if any) on stack
* ...and changing variable protections appropriately
* ...also pop the space they used on the context stack
 500	CALL IS_DO_OP(  itype, uvar_text(uvar)(start:end),
     .		       lo_isp, uvar_ifv(uvar), status )
	IF ( status .NE. ferr_ok ) RETURN
	GOTO 100

* grid-changing function 
* ...(internal or external GC function)
* ...in addition to the manipulations of IS_DO_OP above, this procedure
* ...has the additional flexibility that the result grid need not be
* ...inferrable from the input component grids

* 10/98 *jc*
* CALL ADD_RDC_XFORM is a test to see if we can get the right
* context onto the context which will be used for the result
 600    CALL ADD_RDC_XFORM(is_big_cx(lo_isp), status)
	CALL IS_DO_GC_FCN(  uvar, uvar_text(uvar)(start:end),
     .		       lo_isp, status )
	IF ( status .NE. ferr_ok ) RETURN
	GOTO 100

* "constant variable" (fixed array like "{1,3,5}")
* ... get the context here, then RETURN 1 to evaluate
 700	CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) RETURN
	hi_cx = cx_stack_ptr
	CALL CONST_VAR_CONTEXT ( uvar_text(uvar)(start:end),
     .				 uvar,
     .				 item,
     .				 lo_cx,
     .				 hi_cx,
     .				 status )
	IF ( status .NE. ferr_ok ) RETURN
* ... request this variable on the interpretation stack ( via RETURN 1 )
	CALL PUSH_INTERP_STACK( isp, status )
	IF ( status .NE. ferr_ok ) RETURN
	is_cx ( isp ) = hi_cx
	is_obj( isp ) = lo_isp	! claimed by this level
	IF ( cx_category(hi_cx) .EQ. cat_const_var ) THEN
* ... special action if this component variable is user-defined (uvar)
	   is_uvar( isp ) = cx_variable( hi_cx )
	ENDIF
	IF ( start_sampling ) GOTO 900
	RETURN 1

* "attrib_val" a string or float value or array of strings or floats.
* ... get the context here, then RETURN 1 to evaluate
 750	CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )

	IF ( status .NE. ferr_ok ) RETURN
	hi_cx = cx_stack_ptr

        
* set these to unspecified.  If they get set in GET_VAR_CONTEXT, 
* then do not set them to 1:attlen below.

 	cx_lo_ss(hi_cx, x_dim) = unspecified_int4
 	cx_hi_ss(hi_cx, x_dim) = unspecified_int4

	CALL GET_VAR_CONTEXT (  uvar_text(uvar)(start:end),
     .				lo_cx,
     .				hi_cx,
     .				status )
	IF ( status .NE. ferr_ok ) RETURN

* Flag to set the limits. They were not set by GET_VAR_CONTEXT, so use the
* attribute size

        reset_ss = (cx_lo_ss(hi_cx, x_dim) .EQ. unspecified_int4  .OR.
     .              cx_hi_ss(hi_cx, x_dim) .EQ. unspecified_int4 ) 

        dset = cx_data_set(hi_cx)

! See if this is a user variable and set dataset number accordingly

        dot = INDEX(uvar_text(uvar),'.')
        IF (dot .GT. 0) name = uvar_text(uvar)(1:dot-1)
        CALL FIND_VAR_NAME(pdset_irrelevant, name, cat, ivar)
        IF (  ivar .NE. munknown_var_name .AND.
     .        cat .EQ. cat_user_var) THEN
           dset = pdset_uvars

* Check whether its a LET/D variable
           CALL CD_GET_VAR_ID (dset, uvar_text(uvar)(1:dot-1), varid, status)
           IF (dset.EQ.pdset_uvars .AND. status.NE.ferr_ok) THEN
	      dset = cx_data_set(hi_cx)
	      CALL CD_GET_VAR_ID (dset, uvar_text(uvar)(1:dot-1), varid, status)
           ENDIF
           IF (status.NE.ferr_ok) do_err = .TRUE. 
        ENDIF

        IF (dset .NE. unspecified_int4 .AND. 
     .      dset .NE. pdset_irrelevant) THEN

* do_err: issue error message if attrib does not exist on varname.attname
           do_err = .TRUE.
           CALL  BREAK_VARATTNAME (  uvar_text(uvar)(start:end), dset, 
     .                            name, attname, varid, do_err, status )

* Is the *attr name* a pseudo-name for a variable: attnames, dimnames,
*  natts, type, ...

           IF (varid .GT. 0) THEN
              CALL CD_GET_VAR_INFO (dset, varid, name, vartype,
     .                nvdims, vdims, nvatts, coordvar, all_outflag, 
     .                status)

* attribute names
              IF (STR_SAME(attname, 'attnames') .EQ. 0 ) THEN
                 cx_type(hi_cx) = ptype_string
                 IF (reset_ss) THEN
                    cx_lo_ss(hi_cx, x_dim) = 1
                    cx_hi_ss(hi_cx, x_dim) = nvatts
                 ELSE
                    cx_lo_ss(hi_cx, x_dim) = MAX(1, cx_lo_ss(hi_cx, x_dim))
                    cx_hi_ss(hi_cx, x_dim) = MIN(nvatts, cx_hi_ss(hi_cx, x_dim))
                 ENDIF

* dimension names
              ELSE IF (STR_SAME(attname, 'dimnames') .EQ. 0 ) THEN 
                 cx_type(hi_cx) = ptype_string
                 IF (reset_ss) THEN
                    cx_lo_ss(hi_cx, x_dim) = 1
                    cx_hi_ss(hi_cx, x_dim) = nvdims
                 ELSE
                    cx_lo_ss(hi_cx, x_dim) = MAX(1, cx_lo_ss(hi_cx, x_dim))
                    cx_hi_ss(hi_cx, x_dim) = MIN(nvdims, cx_hi_ss(hi_cx, x_dim))
                 ENDIF
 
* # of dimensions for variable 
              ELSE IF (STR_SAME(attname, 'ndims') .EQ. 0 ) THEN
                 cx_type(hi_cx) = ptype_float
                 cx_lo_ss(hi_cx, x_dim) = 1
                 cx_hi_ss(hi_cx, x_dim) = 1

*  variable types
              ELSE IF (STR_SAME(attname, 'nctype') .EQ. 0 ) THEN
                 cx_type(hi_cx) = ptype_float
                 cx_lo_ss(hi_cx, x_dim) = 1
                 cx_hi_ss(hi_cx, x_dim) = 1

* # of attributes
               ELSE IF (STR_SAME(attname, 'nattrs') .EQ. 0 ) THEN
                cx_type(hi_cx) = ptype_float
                 cx_lo_ss(hi_cx, x_dim) = 1
                 cx_hi_ss(hi_cx, x_dim) = 1

               ELSE
           
* General attribute.
* Get attribute type and length
        
                  CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid,
     .               status)
                  IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, varid,  
     .              attid, aname, attype, attlen, attoutflag, status )

                  IF (status .NE. ferr_ok) THEN
                     RETURN ! ?? error message
                  ENDIF

                  IF (attype .EQ. NCCHAR) THEN
                     cx_type(hi_cx) = ptype_string
	          ELSE
	             cx_type(hi_cx) = ptype_float
	          ENDIF

* If the attribute we are asking for is the bad-data flag, set 
* cx_bad_data to something else, so that the value will be displayed.

                  IF (STR_SAME (attname, 'missing_value') .EQ. 0 .OR.
     .               STR_SAME (attname, '_FillValue') .EQ. 0) THEN
                     maxlen = 1
                     got_it = NC_GET_ATTRIB ( dset, varid, attname, 
     .                                .TRUE., name, maxlen, attlen, 
     .                                attoutflag, buff, val)
                     IF (got_it) cx_bad_data(hi_cx) = val/2. + 1.
                  ENDIF

                  IF (attype .EQ. NCCHAR) THEN
                     cx_lo_ss(hi_cx, x_dim) = 1
                     cx_hi_ss(hi_cx, x_dim) = 1
                  ELSE
 
* If they were not set by the var context, set the X axis limits equal 
* to the length of the array. 

                    IF (reset_ss) THEN
                        cx_lo_ss(hi_cx, x_dim) = 1
                        cx_hi_ss(hi_cx, x_dim) = attlen
                    ELSE
                       cx_lo_ss(hi_cx, x_dim) = MAX(1, cx_lo_ss(hi_cx, x_dim))
                       cx_hi_ss(hi_cx, x_dim) = MIN(attlen, cx_hi_ss(hi_cx, x_dim))
                    ENDIF
                 ENDIF

               ENDIF  ! general attribute

* If the varname is ., referring to the dataset itself, then the varid = 0. These are
* dataset attributes: varnames, attnames, dimnames, ndims, nvars, ...

           ELSE 
              IF (varid .EQ. 0) THEN
                 CALL CD_GET_DS_INFO (dset, ndims, nvars, ngatts, 
     .               recdim, status)
     
* Count number of non-coordinate variables.
                 nv = 0
                 DO 760 ivar = 1, nvars
                    CALL CD_GET_VAR_INFO (dset, ivar, name, vartype,
     .                  nvdims, vdims, nvatts, coordvar, all_outflag, 
     .                  status)
                    IF (.NOT. coordvar) nv = nv + 1
 760             CONTINUE

                 IF (STR_SAME(attname, 'varnames') .EQ. 0 ) THEN
                    cx_type(hi_cx) = ptype_string
                    IF (reset_ss) THEN
                       cx_lo_ss(hi_cx, x_dim) = 1
                       cx_hi_ss(hi_cx, x_dim) = MAX(1, nv)
                    ELSE
                       cx_lo_ss(hi_cx, x_dim) = MAX(1, cx_lo_ss(hi_cx, x_dim))
                       cx_hi_ss(hi_cx, x_dim) = MIN(nv, cx_hi_ss(hi_cx, x_dim))
                    ENDIF

* Global attributes
                 ELSE IF (STR_SAME(attname, 'attnames') .EQ. 0 ) THEN
                    cx_type(hi_cx) = ptype_string
                    IF (reset_ss) THEN
                       cx_lo_ss(hi_cx, x_dim) = 1
                       cx_hi_ss(hi_cx, x_dim) = MAX(1, ngatts)
                    ELSE
                       cx_lo_ss(hi_cx, x_dim) = MAX(1, cx_lo_ss(hi_cx, x_dim))
                       cx_hi_ss(hi_cx, x_dim) = MIN(ngatts, cx_hi_ss(hi_cx, x_dim))
                    ENDIF
                    
* # of dimensions
                 ELSE IF (STR_SAME(attname, 'ndims') .EQ. 0 ) THEN
                    cx_type(hi_cx) = ptype_float
                    cx_lo_ss(hi_cx, x_dim) = 1
                    cx_hi_ss(hi_cx, x_dim) = 1
   
* dimension names
                 ELSE IF (STR_SAME(attname, 'dimnames') .EQ. 0 ) THEN
                    cx_type(hi_cx) = ptype_string

                    IF (reset_ss) THEN
                       cx_lo_ss(hi_cx, x_dim) = 1
                       cx_hi_ss(hi_cx, x_dim) = MAX(1, ndims)
                    ELSE
                       cx_lo_ss(hi_cx, x_dim) = MAX(1, cx_lo_ss(hi_cx, x_dim))
                       cx_hi_ss(hi_cx, x_dim) = MIN(ndims, cx_hi_ss(hi_cx, x_dim))
                    ENDIF
   
* coordinate-variable names
                 ELSE IF (STR_SAME(attname, 'coordnames') .EQ. 0 ) THEN
                    cx_type(hi_cx) = ptype_string

                    IF (reset_ss) THEN
                       cx_lo_ss(hi_cx, x_dim) = 1
                       cx_hi_ss(hi_cx, x_dim) = MAX(1, nvars-nv)
                    ELSE
                       cx_lo_ss(hi_cx, x_dim) = MAX(1, cx_lo_ss(hi_cx, x_dim))
                       cx_hi_ss(hi_cx, x_dim) = MIN(ndims, cx_hi_ss(hi_cx, x_dim))
                    ENDIF

* # variables 
                 ELSE IF (STR_SAME(attname, 'nvars') .EQ. 0 ) THEN
                    cx_type(hi_cx) = ptype_float
                    cx_lo_ss(hi_cx, x_dim) = 1
                    cx_hi_ss(hi_cx, x_dim) = 1

* # coordinate variables (dimensions that ALSO have a coord. var)
               
                 ELSE IF (STR_SAME(attname, 'ncoordvars') .EQ. 0 ) THEN
                    cx_type(hi_cx) = ptype_float
                    cx_lo_ss(hi_cx, x_dim) = 1
                    cx_hi_ss(hi_cx, x_dim) = 1

* # of global attributes
                 ELSE IF (STR_SAME(attname, 'nattrs') .EQ. 0 ) THEN
                    cx_type(hi_cx) = ptype_float
                    cx_lo_ss(hi_cx, x_dim) = 1
                    cx_hi_ss(hi_cx, x_dim) = 1

* Is the reference to a global attribute? If so get its type and length

                 ELSE
                    CALL CD_GET_VAR_ID (dset, '.', varid, status)
                    CALL CD_GET_DS_INFO (dset, ndims, nvars, ngatts, 
     .               recdim, status)

* If the attribute name is in quotes remove them. Perhaps the user
* is looking for a global file attribute named the same as one of our
* pseudo- attribute names 
* (Logic for case-sensitive searching will go here...)

                    slen = TM_LENSTR1(attname)
                    IF (attname(1:1) .EQ. "'" .AND. 
     .                   attname(slen:slen) .EQ. "'" ) THEN
                       attname = attname(2:slen-1)
                       attname(slen-1:slen) = ""
                    ENDIF


                    DO 790 iatt = 1, ngatts
                       CALL CD_GET_VAR_ATT_NAME (dset, varid, iatt, name, 
     .                    status)
                       IF (STR_SAME(name, attname) .EQ. 0) THEN

                          CALL CD_GET_VAR_ATT_INFO (dset, varid, iatt, 
     .                        name, attype, attlen, attoutflag, status )

                          cx_type(hi_cx) = ptype_float
                          cx_lo_ss(hi_cx, x_dim) = 1
                          cx_hi_ss(hi_cx, x_dim) = attlen

                          IF (attype .EQ. NCCHAR) THEN
                             cx_type(hi_cx) = ptype_string
                             cx_hi_ss(hi_cx, x_dim) = 1
                          ENDIF

                       ENDIF

 790                CONTINUE

                 ENDIF
              ENDIF
           ENDIF

        ELSE
           CALL TRANSFER_CONTEXT (lo_cx, hi_cx)
        ENDIF

* ... request this variable on the interpretation stack ( via RETURN 1 )
	CALL PUSH_INTERP_STACK( isp, status )
	IF ( status .NE. ferr_ok ) RETURN
	is_cx ( isp ) = hi_cx
	is_obj( isp ) = lo_isp	! claimed by this level
	IF ( cx_category(hi_cx) .EQ. cat_attrib_val ) THEN
* ... special action if this component variable is user-defined (uvar)
	   is_uvar( isp ) = cx_variable( hi_cx )
	ENDIF
	IF ( start_sampling ) GOTO 900
	RETURN 1

* "string" in quotes in variable definition
* ... get the context here, then RETURN 1 to evaluate
 800	CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) RETURN
	hi_cx = cx_stack_ptr
	CALL STRING_CONTEXT (	uvar,
     .				item,
     .				lo_cx,
     .				hi_cx,
     .				status )
	IF ( status .NE. ferr_ok ) RETURN
* ... request this variable on the interpretation stack ( via RETURN 1 )
	CALL PUSH_INTERP_STACK( isp, status )
	IF ( status .NE. ferr_ok ) RETURN
	is_cx ( isp ) = hi_cx
	is_obj( isp ) = lo_isp	! claimed by this level
	IF ( cx_category(hi_cx) .EQ. cat_string ) THEN
* ... special action if this component variable is user-defined (uvar)
	   is_uvar( isp ) = cx_variable( hi_cx )
	ENDIF
	RETURN 1

* "SAMPLEI" (and its family)
* at this point the list of indices has been evaluated and is on the isp stack
* (at lo_isp+1). Setup "sampling" activity on the stack, using that list to
* guide obtaining the other arg
 900	CALL SETUP_SAMPLE(  is_cx(lo_isp+1), is_mr(lo_isp+1),
     .			   ifcn, big_cx, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
* ... setup to grab first chunk of sampling data
	CALL IS_SAMPLE(  *910, *5900, status ) !	RETURN 2 means all done
	GOTO 5900
 910	RETURN 1


* DONE - clean up
 1000	hi_cx = is_cx( isp )
	hi_mr = is_mr( isp )
	is_mr( lo_isp ) = hi_mr
	isp = isp - 1
	IF ( isp .NE. lo_isp ) 
     .	   CALL ERRMSG( ferr_syntax, status, 'RPN', *5000 )

* Deallocate dynamic grid if one is associated with this result
* This will (I think) only happen if a single component (no IS_DO_OP call)
* result with a dynamic grid is requested
* (This will not actually dismiss the grid -- it should always merely decrement
*  the use count)
	IF ( cx_has_impl_grid(hi_cx) ) THEN
	   CALL DEALLO_DYN_GRID(cx_grid(hi_cx))
	   cx_has_impl_grid(hi_cx) = .FALSE.
	ENDIF

* check for incomplete merged context
* this is complicated in order to have implicit user-defn'd vars like
* "LIST TEMP" get cataloged under "TEMP"
* whereas "LIST TEMP/10" gets cataloged under the implied user-defn'd var name
* and whereas the explicit "DEFINE A=TEMP" gets cataloged under "A".
* Use the isp level to determine if it's implicit - implicit always at base lev
* MERGIFY_CX "claims" a context under the user-defn'd name.
	IF ( is_sum(lo_isp) .EQ. isalg_transfer ) THEN
* ... expression entirely of unmodified pseudo-vars and constants
	   CALL TRANSFER_CONTEXT( hi_cx, big_cx )
	   IF ( cx_category(big_cx) .EQ. cat_temp_var
     .	   .OR. EXPLICIT_UVAR(uvar) ) THEN
* ... expr. like "LIST I+J" or "LIST A" after "DEFINE VAR A=I"
	      CALL MERGIFY_CX( lo_cx, uvar, big_cx, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
	   ENDIF
	ELSEIF ( is_sum(lo_isp).EQ.isalg_merge_1
     .	.AND.  ( nitem.GT.1 .OR. EXPLICIT_UVAR(uvar) )  ) THEN 
* ... expression with constants, pseudo-variables and a single variable
* ... like "LIST U/10" or single variable explicit uvars like "DEFINE NEW=U"
	   CALL MERGIFY_CX( lo_cx, uvar, big_cx, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	ENDIF

* finalize the result on the stack - it may be the result of some algebra or
* a simple variable or a constant or pseudo-variable
* "temporary variables" are the result of algebraic operations
* ... re-catalog them under their user-variable names
* explicit user-defined variables (e.g. "DEFINE VAR NEW=X"; "LIST NEW") are
* always re-cataloged under the user-defined name
* Merged context info is then passed back to the calling context.
* implicit uvars that are single pseudo-variables or constants are left as-is
* ... to be deleted as soon as used (e.g. "LIST X")
* implicit uvars that are single variables (e.g. "LIST U") need their "in-use"
* flags removed (otherwise done when they're used as operands)
* (ticket 2291) Handle variables from attribute information the same way.

	IF ( mr_type(hi_mr) .NE. ptype_string
     .	.AND. (mr_category(hi_mr) .EQ. cat_temp_var .OR.
     .	       mr_category(hi_mr) .EQ. cat_attrib_val)    ) THEN
* ... result of algebraic computation
* ... if user set the missing value flag make sure it is used
	   IF ( cx_bad_data(big_cx) .NE. mr_bad_data(hi_mr) ) THEN
	      size = MGRID_SIZE( hi_mr )
	      CALL REPLACE_BAD_DATA_SUB ( mr_bad_data(hi_mr),
     .			                  memry(hi_mr)%ptr, size,
     .                                    cx_bad_data(big_cx)  )
	   ENDIF

c Tentative fix for ticket 2234.  See also ticket 2547.
	   cx_type(big_cx) = cx_type(hi_cx)
	   CALL RE_ASSIGN_VARIABLE( hi_mr, big_cx )

	   CALL PASS_AMBIG_LIMS( lo_cx, hi_mr, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
!	ELSEIF (mr_category(hi_mr) .EQ. cat_string) THEN
!! ... string variables not yet implemented 1/99 *sh*
!	   GOTO 5100
	ELSEIF ( EXPLICIT_UVAR(uvar) ) THEN
* ... result of a simple definition like DEFINE VARIABLE UAVE=U[K=@AVE]
*	or DEFINE VARIABLE NEW=X
*       as above get the return type

	   cx_type(big_cx) = cx_type(hi_cx)  ! for 2367

	   CALL CREATE_MEM_VAR( big_cx, new_mr, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   is_mr( lo_isp ) = new_mr
	   CALL COPY_GRID( memry(hi_mr)%ptr,  hi_mr,
     .			   memry(new_mr)%ptr, new_mr )
	   CALL PASS_AMBIG_LIMS( lo_cx, new_mr, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
* component no longer needed
* 12/00 allow contstants to be deleted
	   IF ( mr_category(hi_mr) .EQ. cat_constant ) THEN
	      CALL DELETE_VARIABLE(hi_mr)
	   ELSEIF ( mr_category(hi_mr) .NE. cat_pseudo_var ) THEN
	      CALL MR_NOT_IN_USE(hi_mr)
	   ENDIF

!		This change would fix a minor bug that occurs for "enhanced"
!		CDF files and GT files (bn230_cdf.sub3), but it creates more
!		serious problems of ignoring limits restrictions (1:6) in
!			let a = temp[i=90:110:2]; list a[i=1:6]
!		see bn491_dynamic_grids
!	   CALL TRANSFER_CONTEXT( big_cx, lo_cx )	! 3/99 correct cx, too

	ELSE
	   IF ( mr_category(hi_mr) .NE. cat_pseudo_var
     .    .AND. mr_category(hi_mr) .NE. cat_constant   )
     .                                        CALL MR_NOT_IN_USE(hi_mr)
	   CALL TRANSFER_CONTEXT( big_cx, lo_cx )
	ENDIF

* if user set the missing value flag make sure it is used
	IF ( mr_category(hi_mr) .NE. cat_attrib_val
     .	.AND.mr_type    (hi_mr) .NE. ptype_string   ) THEN 
	   IF ( cx_bad_data(lo_cx) .NE. mr_bad_data(is_mr(lo_isp))) THEN  
	      new_mr = is_mr(lo_isp)
	      size = MGRID_SIZE( new_mr )
	      CALL REPLACE_BAD_DATA_SUB ( mr_bad_data(new_mr),
     .			               memry(new_mr)%ptr, size,
     .                                  cx_bad_data(lo_cx)  )
	      mr_bad_data(new_mr) = cx_bad_data(lo_cx)

	   ELSE
	      new_mr = is_mr(lo_isp)
	      size = MGRID_SIZE( new_mr )
	      CALL CHECK_NAN_DATA_SUB ( memry(new_mr)%ptr, size,
     .                                 mr_bad_data(new_mr) )
	   ENDIF
	ENDIF

* pop off context for the last component received and "big" (merged) context

	cx_stack_ptr = cx_stack_ptr - 2
	RETURN 2

* error exit
 5000	RETURN
 5100	CALL ERRMSG(ferr_not_implemented, status,
     .		'Quoted strings may only be function arguments', 
     .		*5000)
 5900	CALL ERRMSG( ferr_internal, status, 'SAMPLE* not startable',
     .		*5000)

	END	

* scat2grid_subs_mask:  Subroutines called by the scat2grid functions
* where a mask is applied.
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*

	SUBROUTINE maskxy (xx, yy, xaxis, yaxis, mask, nx, ny, flag)
	REAL xx, yy, xaxis(nx), yaxis(ny), mask(nx,ny)
	integer flag

	REAL dx2, dy2

	dx2 = (xaxis(2) - xaxis(1))/2
	dy2 = (yaxis(2) - yaxis(1))/2

        flag = 0
	DO 100 j = 1, ny
	   IF (yy.GE.yaxis(j)-dx2 .AND. yy.LT.yaxis(j)+dy2) THEN
	      DO 200 i = 1, nx
	         IF (xx.GE.xaxis(i)-dx2 .AND. xx.LT.xaxis(i)+dx2) THEN
                    IF (mask(i,j) .EQ. 1) THEN
		       flag = 1
		       RETURN
		    ENDIF
		 ENDIF
  200         CONTINUE
           ENDIF
  100   CONTINUE

        RETURN
	END

    	SUBROUTINE SHOW_REGRID_TRANSFORMS

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* show a nicely formatted list of the available regridding transforms

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V420:  11/95 - based on SHOW_TRANSFORMS
*	  1/96 - bug fix: crash on last (single transform) line
*			"num_transforms" ==> "max_regrid_trans"
*	  4/96 - branching bug detected by Sun f77 compiler
* V650  Write to show_lun which may be set to a file unit number rather than std out
* V671  6/11 *acm*  New 2D linear xy regridding, fixing ticket 1862
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V690  12/13 *sh* show auxiliary variable regridding transforms
*    Note:  this routine and SHOW_TRANSFORMS are both messy and could be
*           readily cleaned up and consolidated into 1 piece of code
*           by creating a single output routine and using logical arrays
*           to indicate which transforms to hide during SHOW TRANSFORMS


        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'xprog_state.cmn'
	include	'xalgebra.cmn'
	include 'xrisc.cmn'          ! 12/94 SPLIT_LIST buffer

* calling argument declarations:
*...

* local variable declarations:
	INTEGER n, i, i1, i2

* introductory line
	CALL SPLIT_LIST(pttmode_explct, show_lun,
     .		'regridding transforms e.g.SST[GX=x5deg@AVE]', 43)

* count number of transforms
	n=0
	DO 110 i = 1, max_regrid_trans
           IF (.NOT.alg_regrid_vizb(i)) GOTO 110
	   n = n+1
 110	CONTINUE
* locate half-way point in the list
	i = 0
	DO 112 i2 =  1, max_regrid_trans
           IF (.NOT.alg_regrid_vizb(i2)) GOTO 112
           i = i+1
	   IF ( i .GT. (n+1)/2 ) GOTO 115
 112	CONTINUE
* heading lines
 115	WRITE (risc_buff, 3050) ('code','description',i=1,2)
	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	risc_buff = ' '
        WRITE (risc_buff, 3050) ('----','-----------',i=1,2)
	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	risc_buff = ' '
 3050   FORMAT (T4,A,T16,A,T45,A,T57,A)
* list the transforms 2 per line - use 2 separate pointers
	i1 = 0
	i2 = i2 - 1
	DO 150 i = 1, (n+1)/2
* ... locate first pointer
           DO 120 i1 = i1+1, max_regrid_trans
              IF (.NOT.alg_regrid_vizb(i1)) GOTO 120
	      GOTO 121
 120	   CONTINUE
* ... locate second pointer
 121	   DO 130 i2 = i2+1,  max_regrid_trans
              IF (.NOT.alg_regrid_vizb(i2)) GOTO 130
	      GOTO 131
 130	   CONTINUE
 131	   IF ( i .LE. n/2 ) THEN
* ... write two transforms per line
              WRITE (risc_buff, 3054)
     .                 alg_regrid_code(i1), alg_regrid_title(i1),
     .                 alg_regrid_code(i2), alg_regrid_title(i2)
	   ELSE
* ... write the last transformation on a line alone
              WRITE (risc_buff, 3055)
     .                 alg_regrid_code(i1), alg_regrid_title(i1)
	   ENDIF
	   CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	   risc_buff = ' '
 150   CONTINUE

***********
* now the auxiliary regridding transforms

* introductory line
	CALL SPLIT_LIST(pttmode_explct, show_lun, ' ', 1)
	CALL SPLIT_LIST(pttmode_explct, show_lun,
     .		'auxiliary varible regridding transforms'//
     .          ' e.g.TEMP[GZ(depth)=zax@AVE]', 0)

* count number of transforms
	n=0
	DO 210 i = max_regrid_trans+1, max_auxregrid_trans
           IF (.NOT.alg_regrid_vizb(i)) GOTO 210
	   n = n+1
 210	CONTINUE
* locate half-way point in the list
	i = 0
	DO 212 i2 =  max_regrid_trans+1, max_auxregrid_trans
           IF (.NOT.alg_regrid_vizb(i2)) GOTO 212
           i = i+1
	   IF ( i .GT. (n+1)/2 ) GOTO 215
 212	CONTINUE
* heading lines
 215	WRITE (risc_buff, 3050) ('code','description',i=1,2)
	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	risc_buff = ' '
        WRITE (risc_buff, 3050) ('----','-----------',i=1,2)
	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	risc_buff = ' '
* list the transforms 2 per line - use 2 separate pointers
	i1 = max_regrid_trans
	i2 = i2 - 1
	DO 250 i = 1, (n+1)/2
* ... locate first pointer
           DO 220 i1 = i1+1, max_auxregrid_trans
              IF (.NOT.alg_regrid_vizb(i1)) GOTO 220
	      GOTO 221
 220	   CONTINUE
* ... locate second pointer
 221	   DO 230 i2 = i2+1,  max_regrid_trans
              IF (.NOT.alg_regrid_vizb(i2)) GOTO 230
	      GOTO 231
 230	   CONTINUE
 231	   IF ( i .LE. n/2 ) THEN
* ... write two transforms per line
              WRITE (risc_buff, 3054)
     .                 alg_regrid_code(i1), alg_regrid_title(i1),
     .                 alg_regrid_code(i2), alg_regrid_title(i2)
	   ELSE
* ... write the last transformation on a line alone
              WRITE (risc_buff, 3055)
     .                 alg_regrid_code(i1), alg_regrid_title(i1)
	   ENDIF
	   CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)
	   risc_buff = ' '
 250   CONTINUE


***********
 3054   FORMAT (T4,'@',A6,T16,A20,T45,'@',A6,T57,A20)
 3055   FORMAT (T4,'@',A6,T16,A20)
	RETURN

	END

      SUBROUTINE EF_GET_STRING_ARG_ELEMENT_LEN_6D
     .            (id, iarg, arg, i, j, k, l, m, n, slen)
*
* (formerly ef_get_String_arg_element_len)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*  acm 12/03  
*
* This returns the length of the I,J,K,L,M,N-th element of the string array which 
* was passed as an argument to the external function.
*
*       3/12 *kms* Added E and F dimensions, appended _6D to subroutine name
* V691+*acm* 8/14  Fix ticket 2190: long strings were being cut off.
*

      IMPLICIT NONE
      INCLUDE 'tmap_dims.parm'
      INCLUDE 'ferret.parm'
      INCLUDE 'errmsg.parm'
      INCLUDE 'xvariables.cmn'
      INCLUDE 'EF_Util.parm'

      INTEGER id, iarg, slen, i, j, k, l, m, n
      REAL arg(*)

      INTEGER max_line_len, mr, lox, hix, loy, hiy, loz, hiz,
     .                          lot, hit, loe, hie, lof, hif
      INTEGER mr_list(EF_MAX_ARGS)
      CHARACTER buff*128
      PARAMETER (max_line_len = 2048)
      
      INTEGER arg_lo_ss(nferdims,EF_MAX_ARGS),
     .        arg_hi_ss(nferdims,EF_MAX_ARGS),
     .        arg_incr (nferdims,EF_MAX_ARGS)

      CALL EF_GET_ARG_SUBSCRIPTS_6D(id, arg_lo_ss, arg_hi_ss, arg_incr)
 
* The memory resident list was cached by Ferret and must be retrieved
* to be accessible to the external function.

      CALL EF_GET_MR_LIST(mr_list)
      mr = mr_list(iarg)
      
      IF ( mr .EQ. 0 ) THEN
* Don't call during custom axis creation time
          buff = 
     .     'Use ef_get_string_arg_element_len in the compute phase'
          GOTO 5000

* Here's how you check the variable type.
* (this should never happen as checks against it are made previously) 
      ELSE IF (mr_type(mr) .NE. ptype_string) THEN
           WRITE (buff,4000) iarg
 4000      FORMAT ('Argument',I3,' is not a string')
           GOTO 5000
      ELSE

           lox = arg_lo_ss(X_AXIS,iarg)
           hix = arg_hi_ss(X_AXIS,iarg)
           loy = arg_lo_ss(Y_AXIS,iarg)
           hiy = arg_hi_ss(Y_AXIS,iarg)
           loz = arg_lo_ss(Z_AXIS,iarg)
           hiz = arg_hi_ss(Z_AXIS,iarg)
           lot = arg_lo_ss(T_AXIS,iarg)
           hit = arg_hi_ss(T_AXIS,iarg)
           loe = arg_lo_ss(E_AXIS,iarg)
           hie = arg_hi_ss(E_AXIS,iarg)
           lof = arg_lo_ss(F_AXIS,iarg)
           hif = arg_hi_ss(F_AXIS,iarg)


* Inside ef_get_string_arg_elem_len_sub, arg is a real*8 array of pointers, and
* we can call GET_STRING_ELEMENT to get the length of a string element.

           CALL EF_GET_STRING_ARG_ELEM_LEN_SUB(
     .                 lox, hix, loy, hiy, loz, hiz, lot, hit,
     .                 loe, hie, lof, hif, arg, i, j, k, l, m, n,
     .                 max_line_len, slen )

      ENDIF

      RETURN

* return an error message     
 5000 CALL EF_BAIL_OUT(id, buff)
      STOP 'EF_BAIL_OUT returned in EF_GET_STRING_ARG_ELEMENT_LEN_6D'
      END

	SUBROUTINE VIEW(X)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)view.F	1.2    5/31/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
* V720 *acm*   Ticket 2530 add WIRE/COLOR= and draw the color with pen 1

	INCLUDE 'PARAMPL5.DAT'
	INCLUDE 'HD.INC'
	INCLUDE 'CMRD.INC'
	INCLUDE 'CMRDL.INC'
	INCLUDE 'LABELS.INC'
	INCLUDE 'LABCOM.INC'
	INCLUDE 'HAB.INC'
	INCLUDE 'PEN.INC'
	INCLUDE 'PLT.INC'
	INCLUDE 'VIEW.INC'
	INCLUDE 'SYSTEM.INC'
	INCLUDE 'SWITCH.INC'

	IF(NX.EQ.0.OR.NY.EQ.0)RETURN
	call trans(0,xmin,ymin,xtm,ytm)
	call trans(0,xmax,ymax,xtx,ytx)
	IF(XYSCLE.EQ.1)THEN
	    XM=xtm
	    XMX=xtx
	ELSE
	    XM=ytm
	    XMX=ytx
	END IF
	IF(ZSCLE.NE.0)THEN
	    P1=1./ZSCLE
	ELSE
	    P1=(VEWZMX-VEWZMN)/(ytx-ytm)
	END IF
	XM=XM*P1
	XMX=XMX*P1
	YM=ytm*P1
	YMX=ytx*P1
C     TRANSFORM VIEWPOINT
	XV=(XMX-XM)*(VIEWX-xtm)/(xtx-xtm)+XM
	YV=(YMX-YM)*(VIEWY-ytm)/(ytx-ytm)+YM
	ICOUNT=ICOUNT+1

	CALL COLOR(IPEN(1))

	CALL SURFCE(X,XM,XMX,NX,YM,YMX,NY,VEWZMN,VEWZMX,
     *	XV,YV,VIEWZ)

	CALL COLOR(IPEN(0))

	RETURN
	END

	SUBROUTINE CD_QUIK_NCOPEN (dset, filename, vname,
     .	    cdfid, vid, bounds_id, units_str, cal_str, n, status)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* open a netcdf file; get the netCDF variable id and 1d array length
* of the given var name
* if that variable has a 'bounds' attribute, get its vid, too

* programmer - Steve Hankin
* NOAA/PMEL, Seattle, WA - Thermal Modeling and Analysis Program

* V695+ 10/15 *sh*
* V71  *acm* 1/17 Ticket 2493 Fix to the piece of this that checks bounds attribute.

*
* arguments:
*	dset		- (input) Ferret dataset number
*	filename	- (input) name of file to be opened
*       vname		- (input) name of variable to look for (case-sensitive)
*	cdfid		- (output) netCDF id of the open dataset
*	vid		- (output) netCDF id of the requested variable
*	bounds_id	- (output) netCDF id of the bounds variable
*	units_str	- (output) string value of the units attribute
*	cal_str		- (output) string value of the calendar attribute
*	n		- (output) length of the named variable
*	status		- (output) TMAP status code

        include 'netcdf.inc'
        include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "gt_lib.parm"
	include 'xdset_info.cmn_text'
	include 'xstep_files.cmn_text'

* Argument variable declarations
	CHARACTER*(*) filename, vname, units_str, cal_str
	INTEGER   dset, cdfid, vid, bounds_id, n, status

* Local variable declarations
	LOGICAL	CD_GET_ATTRIB, coordvar, got_it
	INTEGER	TM_LENSTR1, 
     .		vlen, vartyp, nvdim, vdims(8), nvatts, all_outflag,
     .		maxlen, attlen, tmap_status, cdfstat, blen, 
     .		dlen, elen, nb
	CHARACTER*2048   TM_INQ_PATH
	CHARACTER	varname*128, buff*128, errmsg*80, dummy*20
	REAL vals  ! potential numerical attributes


* local parameter definitions:
	LOGICAL	    do_warn
	PARAMETER ( do_warn = .TRUE. )

*initialize
	vlen = TM_LENSTR1(vname)
	maxlen = 128

* locate the file
	ds_des_name(dset) =
     .		TM_INQ_PATH(filename, 'FER_DATA', ' ',.FALSE., status)
        IF (status .NE. merr_ok)  THEN
	   tmap_status = merr_notmounted
	   GOTO 5050
	ENDIF
	dlen = TM_LENSTR1(ds_des_name(dset))

* open the file
	cdfstat = NF_OPEN(ds_des_name(dset), NF_NOWRITE, cdfid) 
	IF ( cdfstat .NE. NF_NOERR ) THEN
	   tmap_status = merr_nc_open
	   errmsg = 'unable to open file'
	   GOTO 5100
	ENDIF

* get the netCDF id of the named time axis variable
        cdfstat = NF_INQ_VARID(cdfid, vname(:vlen), vid)
	IF (cdfstat.NE.NF_NOERR) THEN
	   tmap_status = merr_unkvar
	   errmsg = 'time axis variable is missing: '//vname
	   GOTO 5100
	ENDIF

* inquire after the netCDF metadata for this variable
        cdfstat = NF_INQ_VAR(cdfid, vid, varname, vartyp, nvdim, 
     .              vdims, nvatts)
	IF (cdfstat.NE.NF_NOERR) THEN
	   tmap_status = merr_badfileatt
	   errmsg = 'unable to read attributes of '//vname
	   GOTO 5100
	ENDIF

* sanity check the 1d axis variable
	IF (nvdim .NE. 1) THEN
	   tmap_status = merr_badtimedef
	   errmsg = 'time axis variable not 1D: '//vname
	   GOTO 5100
	ENDIF

* get the axis length
	cdfstat = NF_INQ_DIM( cdfid, vdims(1), varname, n )
	IF ( cdfstat .NE. NF_NOERR ) THEN
	   tmap_status = merr_badtimedef
	   errmsg = 'unable to read time ax dim length '//vname
	   GOTO 5100
	ENDIF

* does this 1d var have a bounds attribute?
	blen = LEN(buff)  ! character array length
	got_it = CD_GET_ATTRIB( cdfid, vid, 'bounds',
     .                     do_warn, vname(:vlen), buff, attlen, blen )
	IF (.NOT.got_it) THEN
	   bounds_id = unspecified_int4
	ELSE

* ... check the bounds variable, issue any warnings.

* If bounds attribute but no bounds variable, just continue. Otherwise check the size

           cdfstat = NF_INQ_VARID(cdfid, buff(:attlen), bounds_id)	   
	   IF ( cdfstat .NE. NF_NOERR) THEN
	      bounds_id = unspecified_int4    ! invalidate the bounds variable
	   ELSE
              cdfstat = NF_INQ_VAR(cdfid, bounds_id, buff, vartyp, nvdim, 
     .              vdims, nvatts)
              cdfstat = NF_INQ_DIM( cdfid, vdims(2), dummy, nb )
	   ENDIF

	ENDIF

* get the units attribute if it exists
	blen = LEN(units_str)  ! character array length
	got_it = CD_GET_ATTRIB( cdfid, vid, 'units',
     .                  do_warn, vname(:vlen), units_str, attlen, blen )
	IF (.NOT.got_it) units_str = ' '

* get the calendar attribute if it exists
	blen = LEN(cal_str)  ! character array length
	got_it = CD_GET_ATTRIB( cdfid, vid, 'calendar',
     .                  do_warn, vname(:vlen), cal_str, attlen, blen )
	IF (.NOT.got_it) cal_str = ' '

* successful completion
 1000	status = merr_ok
 5000	RETURN

* error exits
 5050	CALL TM_ERRMSG
     .     ( tmap_status, status, 'CD_QUIK_NCOPEN',
     .       no_descfile, no_stepfile,
     .       filename, no_errstring,  *5000 )
 5100	elen = TM_LENSTR1(errmsg)
	CALL TM_ERRMSG
     .     ( tmap_status, status, 'CD_QUIK_NCOPEN',
     .       no_descfile, no_stepfile,
     .	    'in file '//ds_des_name(dset)(:dlen)//' '//errmsg,
     .	     no_errstring,  *5000 )
 5200   CALL TM_ERRMSG
     .     ( tmap_status+pcdferr, status, 'CD_QUIK_NCOPEN', cdfid, vid,
     .       no_errstring, no_errstring, *5000 )

	END

	SUBROUTINE REPORT_DEPENDENCY
     .		( cx, isp_stk_lev,  uvar, item, work, cx_status, desist )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* display a line describing a single variable of a dependency tree
* with indentation to communicate tree structure

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V685+  *sh* 9/13
* V698  3/16 *sh* added logic for cat_ef_time2d (ACTS_LIKE_FVAR)

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xdependency_tree.cmn'


* calling argument declarations:
	LOGICAL desist
	INTEGER cx, isp_stk_lev, uvar, item, cx_status, device
	INTEGER	work(dependency_max_recs, dependency_nfields)

* internal variable declarations:
	LOGICAL ACTS_LIKE_FVAR, initialize, tell_dset, its_aux
	INTEGER TM_LENSTR1, llen, cat, var, dset, blanks, 
     .		istart, iend, len2, dnamlen
	CHARACTER*1024 GET_UNIQUE_DSET_NAME, VAR_CODE, VAR_TITLE, line_buff,
     .		dsetname

	INTEGER tree_level

	PARAMETER (its_aux = .FALSE.)

* initialize
	tree_level = isp_stk_lev - dependency_root_level

! left as ifdef in case it is useful to turn this code on for future debugging
# ifdef debug_dependency_tree
	cat  = cx_category(cx)
	var  = cx_variable(cx)
	dset = cx_data_set(cx)
	IF (dset .EQ. unspecified_int4) dset = pdset_irrelevant
	line_buff = ' '
	blanks = 2 * (tree_level-1)
	initialize = tree_level .EQ. 1

* announce the default dataset at the outset
	IF (initialize .AND. dset .NE. pdset_irrelevant) THEN
	   dsetname = GET_UNIQUE_DSET_NAME( dset )
	   CALL SPLIT_LIST( pttmode_explct, show_lun, 
     .		'   in default dataset '//dsetname, 0)
	ENDIF

* prepare the dataset name if it needs to be documented
	tell_dset = dset .NE. pdset_irrelevant
     .	      .AND. dset .NE. dependency_dflt_dset
	IF ( tell_dset ) THEN
	   dsetname = '[d='
	   dsetname(4:) = GET_UNIQUE_DSET_NAME( dset )
	   dnamlen = TM_LENSTR1(dsetname)
	   dsetname(dnamlen:dnamlen) = ']'
	ENDIF

* document this variable
	IF ( cx_status .EQ. ferr_unknown_variable ) THEN
	   istart = uvar_item_start(item, uvar)
	   iend   = uvar_item_end  (item, uvar)
	   line_buff(blanks+1:) = uvar_text(uvar)(istart:iend)
	   llen = (iend-istart+1) + blanks
	   IF (tell_dset) THEN
	      line_buff(llen+1:) = dsetname
	      llen = llen + dnamlen
	   ENDIF
	   line_buff(llen+1:) = '   (unknown variable)'
	ELSEIF ( cx_status .EQ. ferr_unknown_data_set ) THEN
	   istart = uvar_item_start(item, uvar)
	   iend   = uvar_item_end  (item, uvar)
	   line_buff(blanks+1:) = uvar_text(uvar)(istart:iend)
	   llen = (iend-istart+1) + blanks
	   IF (tell_dset) THEN
	      line_buff(llen+1:) = dsetname
	      llen = llen + dnamlen
	   ENDIF
	   line_buff(llen+1:) = '   (unknown dataset)'
	ELSEIF ( cx_status .EQ. ferr_unknown_auxvar ) THEN
	   istart = uvar_item_start(item, uvar) + var - 1
	   iend   = uvar_item_start(item, uvar) + cat - 1
	   line_buff(blanks+1:) = uvar_text(uvar)(istart:iend)
	   llen = (iend-istart+1) + blanks
	   IF (tell_dset) THEN
	      line_buff(llen+1:) = dsetname
	      llen = llen + dnamlen
	   ENDIF
	   line_buff(llen+1:) = '   (unknown auxiliary variable)'
	ELSEIF (cat .EQ. cat_user_var) THEN
!	   line_buff(blanks+1:) = FULL_UVAR_NAME(var, llen)
!	   llen = llen + blanks
	   line_buff(blanks+1:) = VAR_CODE(cat, var)
	   llen = TM_LENSTR1(line_buff)
	   IF (tell_dset) THEN
	      line_buff(llen+1:) = dsetname
	      llen = llen + dnamlen
	   ENDIF
	   line_buff(llen+1:) = ' = ' //uvar_text(var)
	ELSEIF ( ACTS_LIKE_FVAR(cat) ) THEN
	   line_buff(blanks+1:) = VAR_CODE(cat, var)
	   llen = TM_LENSTR1(line_buff)
	   IF (tell_dset) THEN
	      line_buff(llen+1:) = dsetname
	      llen = llen + dnamlen
	   ENDIF
	ELSE
* ... does this ever happen?
	   line_buff(blanks+1:) = VAR_CODE(cat, var)
	   llen = TM_LENSTR1(line_buff)
	   IF (tell_dset) THEN
	      line_buff(llen+1:) = dsetname
	      llen = llen + dnamlen
	   ENDIF
	   line_buff(llen+1:) = ' = ' //VAR_TITLE( cat )
	ENDIF

	CALL SPLIT_LIST( pttmode_explct, show_lun, 
     .		'   '//line_buff, 0)
	    
# endif

* save the item in the dependency tree
	CALL STORE_DEPENDENCY(its_aux, cx, tree_level,  uvar, item, cx_status,
     .			work(1,1), work(1,2), work(1,3), work(1,4), 
     .			work(1,5), work(1,6), work(1,7), work(1,8), desist )


	RETURN
	END

*
* tax_tsetp.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Jing Y. Li 
* May 31 2006
* Finished March 24, 2009, ACM
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
* v695  *acm 2/15  Time axis may be an F axis or a T axis.
*
* This function returns time step values
*

*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*

      SUBROUTINE tax_tstep_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .        'Returns time step values based on the new time origin')
      CALL ef_set_num_args(id, 2)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 1)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 
     .           'variable with reference time or forecast axis')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'B')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_type(id, arg, STRING_ARG)
      CALL ef_set_arg_desc(id, arg, 'desired time origin')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE tax_tstep_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER mth, mtl

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

     
* Get the direction of arg 1: F or T
      IF (arg_lo_ss(T_AXIS, ARG1) .NE. ef_unspecified_int4) THEN
         mtl = arg_lo_ss(T_AXIS,ARG1)
         mth = mtl + 
     .         (arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1))
      ENDIF
      IF (arg_lo_ss(F_AXIS, ARG1) .NE. ef_unspecified_int4) THEN
         mtl = arg_lo_ss(F_AXIS,ARG1)
         mth = mtl + 
     .         (arg_hi_ss(F_AXIS,ARG1) - arg_lo_ss(F_AXIS,ARG1))
      ENDIF


*  taxdat
      CALL ef_set_work_array_dims_6d(id, 1,
     .                              mtl, 1, 1, 1, 1, 1,
     .                              mth, 1, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE tax_tstep_compute(id, arg_1, arg_2, result, taxdat)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(strdf, mem2lox:mem2hix, mem2loy:mem2hiy,
     .                  mem2loz:mem2hiz, mem2lot:mem2hit,
     .                  mem2loe:mem2hie, mem2lof:mem2hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* Ignore the Y/Z/T/E/F dimensions in the work arrays since
* they are not used and Fortran is column major
      REAL*8 taxdat(wrk1lox:wrk1hix)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER STR_SAME
      CHARACTER*20 datebuf
      CHARACTER*20 instring, t0string
      INTEGER slen, dir
      REAL*8 ddate
      CHARACTER*16 axname(6), axunits(6)
      LOGICAL bkw1(6), mod1(6), reg1(6)
      CHARACTER*16 tunit
      REAL timesincet0
      INTEGER i, j, k, l, m, n
      INTEGER l1, n1

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)
      

*     Get the new time origin (t0) string
      i = arg_lo_ss(X_AXIS, ARG2)
      j = arg_lo_ss(Y_AXIS, ARG2)
      k = arg_lo_ss(Z_AXIS, ARG2)
      l = arg_lo_ss(T_AXIS, ARG2)
      m = arg_lo_ss(E_AXIS, ARG2)
      n = arg_lo_ss(F_AXIS, ARG2)
      CALL ef_get_string_arg_element_6d(id, ARG2, arg_2,
     .                       i, j, k, l, m, n, slen, instring)

* Allow them to input the date w/o a leading 0 so that either
* 1-jan-2000 or 01-jan-0000 is ok

      IF ( STR_SAME(instring(2:2), '-') .EQ. 0 ) THEN
         WRITE (t0string, 20) instring
  20     FORMAT ('0', a19)
      ELSE
         t0string = instring
      ENDIF


* Get the direction of arg 1: F or T
      IF (arg_lo_ss(T_AXIS, ARG1) .NE. ef_unspecified_int4) THEN
         CALL ef_get_coordinates(id, ARG1, T_AXIS,
     .        arg_lo_ss(T_AXIS, ARG1), arg_hi_ss(T_AXIS, ARG1), taxdat)
         dir = T_AXIS
      ENDIF
        
      IF (arg_lo_ss(F_AXIS, ARG1) .NE. ef_unspecified_int4) THEN
         CALL ef_get_coordinates(id, ARG1, F_AXIS,
     .        arg_lo_ss(F_AXIS, ARG1), arg_hi_ss(F_AXIS, ARG1), taxdat)
         dir = F_AXIS
      ENDIF

*     Get time axis unit
      CALL ef_get_axis_info_6d(id, ARG1, axname, axunits,
     .                         bkw1, mod1, reg1)
      tunit = axunits(dir)

      IF (dir .EQ. T_AXIS) THEN
         l1 = arg_lo_ss(T_AXIS,ARG1)
         DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

*      Get the time axis value for this step
            ddate = taxdat(l1)
*      Get the date string corresponding to time ddate
            CALL ef_get_axis_dates(id, ARG1, ddate, dir, 1, datebuf)
*      Convert to time from the new origin
            CALL time_since_t0(t0string, datebuf, tunit, timesincet0)

*      Assign this time from the new origin to the results
            DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
            DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
            DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
            DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

            result(i,j,k,l,m,n) = timesincet0

 100        CONTINUE
 200        CONTINUE
 300        CONTINUE
 500        CONTINUE
 600        CONTINUE

            l1 = l1 + arg_incr(T_AXIS,ARG1)
 400     CONTINUE

      ELSE IF (dir .EQ. F_AXIS) THEN
         n1 = arg_lo_ss(F_AXIS,ARG1)
         DO 650 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

*      Get the F axis value for this step
            ddate = taxdat(n1)
*      Get the date string corresponding to time ddate
            CALL ef_get_axis_dates(id, ARG1, ddate, dir, 1, datebuf)
*      Convert to time from the new origin
            CALL time_since_t0(t0string, datebuf, tunit, timesincet0)

*      Assign this time from the new origin to the results
            DO 550 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
            DO 450 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
            DO 350 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
            DO 250 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            DO 150 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

               result(i,j,k,l,m,n) = timesincet0

 150        CONTINUE
 250        CONTINUE
 350        CONTINUE
 450        CONTINUE
 550        CONTINUE

            n1 = n1 + arg_incr(F_AXIS,ARG1)
 650     CONTINUE
      ENDIF
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*********************************************************************
*
*     Compute the time since desired t0
*
*********************************************************************
      SUBROUTINE time_since_t0(t0string, datebuf, tunit, timesincet0)
      
      CHARACTER*20 t0string, datebuf
      CHARACTER*16 tunit
      REAL timesincet0

      INTEGER secondsincet0, minutesincet0, hoursincet0
      INTEGER daysincet0, monthsincet0, yearsincet0

      CALL LOWER_CASE(tunit)

*     Compute time since t0, check time axis unit
      IF( tunit(1:3) .EQ. 'sec') THEN
          CALL second_since_t0(t0string, datebuf, secondsincet0)
          timesincet0 = secondsincet0
      ELSE IF(tunit(1:3) .EQ. 'min') THEN
          CALL minute_since_t0(t0string, datebuf, minutesincet0)
          timesincet0 = minutesincet0
      ELSE IF(tunit(1:3) .EQ. 'hou') THEN
          CALL hour_since_t0(t0string, datebuf, hoursincet0)
          timesincet0 = hoursincet0
      ELSE IF(tunit(1:3) .EQ. 'day') THEN
          CALL day_since_t0(t0string, datebuf, daysincet0)
          timesincet0 = daysincet0
      ELSE IF(tunit(1:3) .EQ. 'mon') THEN
          CALL month_since_t0(t0string, datebuf, monthsincet0)
          timesincet0 = monthsincet0
      ELSE IF(tunit(1:3) .EQ. 'yea') THEN
          CALL year_since_t0(t0string, datebuf, yearsincet0)
          timesincet0 = yearsincet0
      ELSE 
          timesincet0=0.
      ENDIF

      RETURN
      END

*******************************************************************
*     Compute second since t0
*******************************************************************
      SUBROUTINE second_since_t0(t0string, datebuf, secondsincet0)

      CHARACTER*20 t0string, datebuf
      CHARACTER*80 err_msg
      INTEGER minutesincet0, secondsincet0

      INTEGER isecond, t0second, t0hour

      t0hour = 0

      CALL minute_since_t0(t0string, datebuf, minutesincet0)
      secondsincet0 = 60*minutesincet0

*     Get t0's minute
      READ (t0string, 110, err=800) t0second

*     Get current minute
      READ (datebuf, 110, err=900) isecond

 110  FORMAT (18x, i2)

*     Adjust minutes of current date
      secondsincet0 = secondsincet0 - (60-isecond)

*     Adjust minutes of t0
      secondsincet0 = secondsincet0 + (60 - t0second)

      RETURN
*-------------
 800  CONTINUE
      WRITE (err_msg,*)
     .  'Error assigning dates/times for t0 date in tax_tstep',
     .  datebuf
      RETURN

*-------------
 900  CONTINUE
      WRITE (err_msg,*)
     .  'Error assigning dates/times for current date in tax_tstep',
     .  datebuf
      RETURN

      END


*******************************************************************
*     Compute minutes since t0
*******************************************************************
      SUBROUTINE minute_since_t0(t0string, datebuf, minutesincet0)

      CHARACTER*20 t0string, datebuf
      CHARACTER*80 err_msg
      INTEGER minutesincet0, hoursincet0

      INTEGER iminute, t0minute, t0hour

      t0hour = 0

      CALL hour_since_t0(t0string, datebuf, hoursincet0)
      minutesincet0 = 60*hoursincet0

*     Get t0's minute
      READ (t0string, 110, err=800) t0minute

*     Get current minute
      READ (datebuf, 110, err=900) iminute

 110  FORMAT (15x, i2, 3x)

*     Adjust minutes of current date
      minutesincet0 = minutesincet0 - (60-iminute)

*     Adjust minutes of t0
      minutesincet0 = minutesincet0 + (60 - t0minute)

      RETURN
*-------------
 800  CONTINUE
      WRITE (err_msg,*)
     .  'Error assigning dates/times for t0 date in tax_tstep',
     .  datebuf
      RETURN

*-------------
 900  CONTINUE
      WRITE (err_msg,*)
     .  'Error assigning dates/times for current date in tax_tstep',
     .  datebuf
      RETURN

      END

*******************************************************************
*     Compute hours since t0
*******************************************************************
      SUBROUTINE hour_since_t0(t0string, datebuf, hoursincet0)

      CHARACTER*20 t0string, datebuf
      CHARACTER*80 err_msg

      INTEGER hoursincet0, daysincet0
       
      INTEGER ihour, t0hour      

      t0hour = 0

      CALL day_since_t0(t0string, datebuf, daysincet0)
      hoursincet0 = 24*daysincet0

*     Get t0's hour
      READ (t0string, 110, err=800) t0hour

*     Get current hour
      READ (datebuf, 110, err=900) ihour

 110  FORMAT (12x, i2, 6x)

*     Adjust hours of current date
      hoursincet0 = hoursincet0 - (24-ihour)

*     Adjust hours of t0
      hoursincet0 = hoursincet0 + (24 - t0hour)
      RETURN
*-------------
 800  CONTINUE
      WRITE (err_msg,*)
     .  'Error assigning dates/times for t0 date in tax_tstep',
     .  datebuf
      RETURN

*-------------
 900  CONTINUE
      WRITE (err_msg,*)
     .  'Error assigning dates/times for current date in tax_tstep',
     .  datebuf
      RETURN

      END
*******************************************************************
*     Compute the days since t0
*     Assume that t0 is before the current year
*******************************************************************
      SUBROUTINE day_since_t0(t0string, datebuf, daysincet0)

      CHARACTER*20 t0string, datebuf
      CHARACTER*80 err_msg

      INTEGER daysincet0

      INTEGER t0day, t0year
      CHARACTER*3 t0mon

      INTEGER dayofmon, iyear 
      CHARACTER*3 cmon

      CHARACTER*3 months(12)
      INTEGER it0mon, imon
      INTEGER i, j, m
      INTEGER yrstart,yrend
      INTEGER dayofyear, ndaymo(12)

      DATA ndaymo/31,28,31,30,31,30,31,31,30,31,30,31/

      DATA months/'jan', 'feb', 'mar', 'apr', 'may', 'jun', 'jul',
     .            'aug', 'sep', 'oct', 'nov', 'dec'/

*     Get t0's year, month, and day
      READ (t0string, 110, err=800) t0day, t0mon, t0year
      
*     Get current date
      READ (datebuf, 110, err=900) dayofmon, cmon, iyear
   
 110  FORMAT (i2, 1x, a3, 1x, i4)

      CALL LOWER_CASE(t0mon)
      CALL LOWER_CASE(cmon)

*     Convert a month from string to number
      DO 50 m=1,12
          IF (t0mon .EQ. months(m)) it0mon=m
          IF (cmon .EQ. months(m)) imon=m
 50   CONTINUE

      yrstart = t0year
      yrend = iyear-1
      daysincet0 = 0

*     Total days between yrstart and yrend
      DO 200 i = yrstart, yrend

*     Check if it is a leap year
          IF ( ((mod(i,4) .EQ. 0) .AND. (mod(i,100) .NE. 0))
     .       .OR.
     .       (mod(i, 400) .EQ. 0)) THEN
                ndaymo(2) = 29
          ELSE
                ndaymo(2) = 28
          ENDIF

          daysincet0 = daysincet0 + (ndaymo(2) + 7*31 + 4*30)

 200  CONTINUE

*     ***************************
*     Adjust days of current year
*     ***************************
      IF ( ((mod(iyear,4) .EQ. 0) .AND. (mod(iyear,100) .NE. 0))
     .       .OR.
     .       (mod(iyear, 400) .EQ. 0)) THEN
          ndaymo(2) = 29
      ELSE
          ndaymo(2) = 28
      ENDIF

*     Compute day of current year
      dayofyear = dayofmon
      DO 300 j =1, imon -1
          dayofyear = dayofyear + ndaymo(j)
 300  CONTINUE

*     Add days of current year 
          daysincet0 = daysincet0 + dayofyear

*     *****************************
*     Adjust days in the year of t0
*     *****************************
      IF ( ((mod(t0year,4) .EQ. 0) .AND. (mod(t0year,100) .NE. 0))
     .       .OR.
     .       (mod(t0year, 400) .EQ. 0)) THEN
          ndaymo(2) = 29
      ELSE
          ndaymo(2) = 28
      ENDIF

*     Compute day of current year
      dayofyear = t0day
      DO 400 j =1, it0mon -1
          dayofyear = dayofyear + ndaymo(j)
 400  CONTINUE

*     Subtract days of year t0
      daysincet0 = daysincet0 - dayofyear

      RETURN

*-------------
 800  CONTINUE
      WRITE (err_msg,*)
     .  'Error assigning dates/times for timr origin in tax_tstep',
     .  t0string
      RETURN

*-------------
 900  CONTINUE
      WRITE (err_msg,*)
     .  'Error assigning dates/times for current date in tax_tstep',
     .  datebuf
      RETURN

      END

*******************************************************************
*     Compute month since t0
*******************************************************************
      SUBROUTINE month_since_t0(t0string, datebuf, monthsincet0)

      CHARACTER*20 t0string, datebuf
      CHARACTER*80 err_msg
      INTEGER monthsincet0
      CHARACTER*3 t0mon, cmon
      CHARACTER*3 months(12)
      INTEGER iyear, t0year, it0mon, imon
      INTEGER m

      DATA months/'jan', 'feb', 'mar', 'apr', 'may', 'jun', 'jul',
     .            'aug', 'sep', 'oct', 'nov', 'dec'/

*     Get t0's year, month, and day
      READ (t0string, 110, err=800) t0mon, t0year
*     Get current date
      READ (datebuf, 110, err=900) cmon, iyear

 110  FORMAT (3x, a3, 1x, i4)

      CALL LOWER_CASE(t0mon)
      CALL LOWER_CASE(cmon)
*     Convert a month from string to number
      DO 50 m=1,12
          IF (t0mon .EQ. months(m)) it0mon=m
          IF (cmon .EQ. months(m)) imon=m
 50   CONTINUE

      monthsincet0= (12-it0mon) + (iyear-t0year-1)*12 + imon

      RETURN
*-------------
 800  CONTINUE
      WRITE (err_msg,*)
     .  'Error assigning dates/times for time origin in tax_tstep: ',
     .  t0string
      RETURN
*-------------
 900  CONTINUE
      WRITE (err_msg,*)
     .  'Error assigning dates/times for current date in tax_tstep: ',
     .  datebuf
      RETURN

      END

*******************************************************************
*     Compute year since t0
*******************************************************************
      SUBROUTINE year_since_t0(t0string, datebuf, yearsincet0)

      CHARACTER*20 t0string, datebuf
      CHARACTER*80 err_msg
      INTEGER yearsincet0
      INTEGER iyear, t0year

*     Get t0's year, month, and day
      READ (t0string, 110, err=800) t0year
*     Get current date
      READ (datebuf, 110, err=900) iyear
 110  FORMAT (7x, i4)

      yearsincet0 = iyear - t0year 

      RETURN
*-------------
 800  CONTINUE
      WRITE (err_msg,*)
     .  'Error assigning dates/times for time origin in tax_tstep: ',
     .  t0string
      RETURN
*-------------
 900  CONTINUE
      WRITE (err_msg,*)
     .  'Error assigning dates/times for current date in tax_tstep: ',
     .  datebuf
      RETURN

      END

	SUBROUTINE SET_PAT_SIZE (wsid,xsize,ysize)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Sets the pattern size for patterned fill area calls -- needed
*	to keep sizes appropriate to the output device. 

*	XSIZE,YSIZE are x and y pattern size in pixels

*	J Davison JISAO/PMEL/TMAP
*	10.28.88

	real		window(4),vport(4),xres,yres
        integer         wsid,error,xform,cols,rows,xsize,ysize

********************************************************************************

*	FIND OUT THE DEVICE "RESOLUTION" IN WORLD COORDS/PIXEL
	call gqcntn (error,xform)
	call gqnt (xform,error,window,vport)

	call gqpxad (wsid,window(1),window(4),window(2),window(3),
     .	error,cols,rows)

	xres = abs((window(2) - window(1)))/real (cols)
	yres = abs((window(4) - window(3)))/real (rows)

*	SET PATTERN SIZE TO XSIZE BY YSIZE PIXELS
	call gspa (real (xsize)*xres,real (ysize)*yres)

	return
	end

*
* convolven.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
** Ansley Manke
* May 2012
*
*
* This external function convolves the component grid, com, with the weight 
* function, wt  along the I axis (see Ferret routine CONVOLVE)
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE convolven_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CHARACTER*100 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT ('Convolve N component of variable with weight function')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 2)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'COM')
      CALL ef_set_arg_desc(id, arg, 
     .  'Variable in X (and perhaps Y,Z,T,E,F) to convolve')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'WEIGHT')
      CALL ef_set_arg_desc(id, arg, 'Weight function')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE convolven_compute (id, arg_1, arg_2, result )

*
*
*  From FERRET subroutine CONVOLVE, for the i-axis.
*
* convolve the component grid, com, with the weight function, wt
* along axis idim
* note: the component context may not be of adequate size for the full
*       calculation.  Missing data flags will be inserted where computation is
*       impossible
* also: when bad data points are encountered in the component data all
*       result data depending on it are flagged as bad, too

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      REAL comp, sum, weight
      REAL xlen, ylen, zlen, tlen, elen, flen
      INTEGER i, j, k, l, m, n
      INTEGER hlo, hhi, nn, wlen
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2


      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)
      
* CONVOLVE ALONG X AXIS (arg_1) using weights (arg_2)

* Half the weighting function; weights from -hlen to hlen (now: hlo to hhi)

      xlen = (arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1) 
      ylen = (arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) + 1) 
      zlen = (arg_hi_ss(Z_AXIS,ARG2) - arg_lo_ss(Z_AXIS,ARG2) + 1) 
      tlen = (arg_hi_ss(T_AXIS,ARG2) - arg_lo_ss(T_AXIS,ARG2) + 1) 
      elen = (arg_hi_ss(E_AXIS,ARG2) - arg_lo_ss(E_AXIS,ARG2) + 1) 
      flen = (arg_hi_ss(F_AXIS,ARG2) - arg_lo_ss(F_AXIS,ARG2) + 1) 

      wlen = MAX(xlen, ylen, zlen, tlen, elen, flen)
      hhi = wlen / 2
      hlo = (-1) * hhi
      IF ( MOD(wlen,2) .EQ. 0 ) hlo = hlo + 1
 
      m1 = arg_lo_ss(E_AXIS,ARG1)
      DO 600 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
       
         l1 = arg_lo_ss(T_AXIS,ARG1)
         DO 500 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
       
            k1 = arg_lo_ss(Z_AXIS,ARG1)
            DO 400 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               j1 = arg_lo_ss(Y_AXIS,ARG1)
               DO 300 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

                  i1 = arg_lo_ss(X_AXIS,ARG1)
                  DO 200 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS) 

                     n1 = arg_lo_ss(F_AXIS,ARG1)
                     DO 700 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

                        sum = 0.0
                        i2 = arg_lo_ss(X_AXIS,ARG2)
                        j2 = arg_lo_ss(Y_AXIS,ARG2)
                        k2 = arg_lo_ss(Z_AXIS,ARG2)
                        l2 = arg_lo_ss(T_AXIS,ARG2)
                        m2 = arg_lo_ss(E_AXIS,ARG2)
                        n2 = arg_lo_ss(F_AXIS,ARG2)

                        DO 100 nn = hlo, hhi

                           IF (n1+nn .LT. arg_lo_ss(F_AXIS,ARG1)  .OR.
     .                         n1+nn .GT. arg_hi_ss(F_AXIS,ARG1) ) THEN
                              result(i,j,k,l,m,n) = bad_flag_result
                              GOTO 190
                           ELSE
                              comp = arg_1(i1,j1,k1,l1,m1,n1+nn)
                              IF ( comp .EQ. bad_flag(ARG1) ) THEN
                                 result(i,j,k,l,m,n) = bad_flag_result
                                 GOTO 190                  
                              ENDIF
                              weight = arg_2(i2,j2,k2,l2,m2,n2)
                              sum = sum + comp * weight
                           ENDIF

                           i2 = i2 + arg_incr(X_AXIS,ARG2)
                           j2 = j2 + arg_incr(Y_AXIS,ARG2)
                           k2 = k2 + arg_incr(Z_AXIS,ARG2)
                           l2 = l2 + arg_incr(T_AXIS,ARG2)
                           m2 = m2 + arg_incr(E_AXIS,ARG2)
                           n2 = n2 + arg_incr(F_AXIS,ARG2)

 100                    CONTINUE
                        result(i,j,k,l,m,n) = sum

 190                 n1 = n1 + arg_incr(F_AXIS,ARG1)
 700                 CONTINUE

                  i1 = i1 + arg_incr(X_AXIS,ARG1)
 200              CONTINUE

                  j1 = j1 + arg_incr(Y_AXIS,ARG1)
 300           CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
 400        CONTINUE

            l1 = l1 + arg_incr(T_AXIS,ARG1)
 500     CONTINUE

         m1 = m1 + arg_incr(E_AXIS,ARG1)
 600  CONTINUE


      RETURN
      END

	SUBROUTINE GEOG_LABEL_VS (buff, iunits, dir_dim, formatted_dim)

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* This routine checks the units and the setting for formatted lon/lat (time?) axes
* If the formatting has been turned off, resets iunits and flag mod_vs_x.

* 3/2017 Ansley Manke
* for ticket 2517, correct labeling of lon/lat axes for PLOT/VS plots, and turn off
* lon/lat axis formatting according to MODE long_label and MODE latit_label
* for issue 1967, if the units are simply degrees or deg with no indication of 
* longitude or latitude, do not make formatted axis.  units="degrees" may be
* a compass direction.

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xprog_state.cmn'

	INTEGER iunits, dir_dim, formatted_dim
	CHARACTER*(*) buff
	

	LOGICAL TM_HAS_STRING

	formatted_dim = no_dim

* The units code has been set by a call to TM_FMT which already checks 
* whether the units string indicated degrees temperature.

* If the units are explicitly defined as degrees east or degrees north,
* set the formatted_dim flag.

	IF (iunits .EQ. 4) THEN

	   IF (TM_HAS_STRING(buff, '_e') .OR. TM_HAS_STRING(buff, ' e') 
     .         .OR. TM_HAS_STRING(buff, 'lon')) THEN
	     IF (ax_fmt(x_dim)) formatted_dim = x_dim
	     IF (.NOT. ax_fmt(x_dim)) iunits = 0
	   ELSEIF (TM_HAS_STRING(buff, '_n') .OR. TM_HAS_STRING(buff, ' n') 
     .         .OR. TM_HAS_STRING(buff, 'lat') ) THEN
	     IF (ax_fmt(y_dim)) formatted_dim = y_dim
	     IF (.NOT. ax_fmt(y_dim)) iunits = 0
	   ELSE

* If the lon or lat label mode has been turned off, unset the units 
	      IF (.NOT. ax_fmt(dir_dim)) iunits = 0

	      iunits = 0  ! require that for VS plots the units are explicitly east or north
	   ENDIF

	ENDIF

	RETURN
	END

	CHARACTER*(*) FUNCTION CD_CHILDAX_NAME( axname, lo, hi, tlen )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Determine the name to use for a "child axis" (sub-region) of a parent axis

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 3/92
* 1/95 - allow negative subscripts.  Substitute "N" for "-"
* v4.91 - *kob* - 12/97 - added checks for axis name length
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* argument definitions:
*     axis    - original axis name
*     lo      - lo subscript
*     hi      - hi subscript
*     slen    - returned length of name

        include 'netcdf.inc'
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'xtm_grid.cmn_text'
	external xgt_grid_data

* argument declarations
      INTEGER lo, hi, tlen
      CHARACTER*(*) axname

* local variable declarations:
      INTEGER TM_LENSTR1, slen
      CHARACTER TM_LEFINT*8, int_buff*8
* 12/97
      INTEGER maxlen

      maxlen = LEN(CD_CHILDAX_NAME)

* generate "axis_nameLO_HI"
* append the low subscript limit
      tlen = TM_LENSTR1(axname)
      IF (tlen .GT. maxlen) tlen = maxlen    ! hack to prevent crash
      int_buff = TM_LEFINT(lo,slen)
      IF (int_buff(1:1) .EQ. '-') int_buff(1:1) = 'N'
      CD_CHILDAX_NAME = axname(:tlen)//int_buff
      tlen = tlen+slen
      IF (tlen .GT. maxlen) tlen = maxlen    ! hack to prevent crash


* append the high subscript limit
      int_buff = TM_LEFINT(hi,slen)
      IF (int_buff(1:1) .EQ. '-') int_buff(1:1) = 'N'
      CD_CHILDAX_NAME = CD_CHILDAX_NAME(:tlen)//'_'//int_buff
      tlen = tlen+slen+1
      IF (tlen .GT. maxlen) tlen = maxlen    ! hack to prevent crash
      RETURN
      END

	INTEGER FUNCTION FIND_DSET_NUMBER( dname )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* find the data set number of set "dname"
* dname may be either the name (without directory pathname or .DES extension)
* or the number
* check that the number is valid before exiting

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 7/25/88
* revision 0.1 - 2/16/89 - ds_open --> ds_name.EQ.char_init30 to test open-ness
* Unix/RISC port 4/25/91 *sh*: increased size of ds_name
* V300: 5/93 *sh* - if the given name includes a .des or .cdf extension ignore
*		it when matching against data sets of these types
*		(TM_CLEAN_FILENAME doesn't store these extensions)
* V420 (IBM/AIX port of V411): 10/5/95 - buffer "READ(var,*"
*Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
*	    4/97 *kob* - added ifdef for MANDATORY_FORMAT_WIDTHS on internal
*			 read because linux/nag f90 needed a format width.
* v500 *kob* 3/99 - modifications to allow datasets to start w/ a digit.
* v540 *acm* 10/01 increase length of ds_name
* v540 *acm* 10/01  remove VMS include statements
* v551 *acm* 1/03  Also check for extension .NC along with .DES, .CDF
* v580 *acm*11/04  Fix bug 1102; under linux, var[d=5coads] is read as dset=5
* V600 *acm* 2/06  fix bug 1392, cancelling datasets
* V600  4/06 *acm* - additional declarations found by Solaris compiler
* v604 *acm* 7/07 increase length of ds_name
* V680 6/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V685 *acm*  3/13 For Ensemble aggregations, call the ds_type 'ENS'
* V695 *acm*  2/15 For Forecast aggregations, call the ds_type 'FCT'
* V7   *acm*  6/12 Add Union aggregations: DEFINE DATA/AGG/U, ds_type 'UNI'
* V702  *sh*  11/16 support new syntax D=aggregation.member
* V722 *acm*  Ticket 2563: Handle the dname coming in quoted, as from repl_exprns

        IMPLICIT NONE
	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include	'ferret.parm'
	include 'gfdl_vms.parm'	
        include 'errmsg.parm'

* calling argument declarations:
	CHARACTER*(*)	dname

* internal variable declarations:
	LOGICAL		TM_DIGIT_TEST, TM_HAS_STRING,
     .		        cdf_name, des_name, full_name_used, nc_name
	INTEGER		STR_CASE_BLIND_COMPARE, TM_LENSTR1,
     .			vax_code, dset, full_len, short_len, status,
     .			agg, memb, idot, nmemb, iq
	CHARACTER	TM_INQ_PATH*2048, buff*2048
	CHARACTER*13	TM_STRING, buff13, vbuff
        REAL*8          val
	character*1 whatc

	IF ( TM_DIGIT_TEST( dname ) ) THEN

	   buff = dname				! buffer for AIX
* *kob* 3/99 - change the err= to go to 50 rather than 500 - this is so a
*              failed read a number is a clue that perhaps it is part of a name
*              of a dataset (eg 5coads) rather than just an error
* *kob* 3/30/99 - minor modification in logic forced by F90.  
c *kob* 4/97
* *acm* 11/04 current linux compiler reads a filename starting with digits
*             as just the digits with no error (10a.nc is read as dset=10)
*             Check explicitly whether the dset read is the same as buff
* *sh* 11/16 - read as a float, to allow aggregation.member syntax

	   READ (buff,*, ERR=50 ) val
*    The TM_DIGIT_TEST above (from 10/05) removes the need
*    discussed in the 11/04 comment just above.
*    Here we comment out the 11/04 logic because D=12.3 becomes D=12.300
*    which fails the packed string test
!           buff13 = TM_STRING(val)
!           CALL TM_PACK_STRING(buff13, vbuff, 1,13, short_len)
!	    vax_code = STR_CASE_BLIND_COMPARE( vbuff, buff(1:13) )
!	    IF (  vax_code .NE. vms_str_success ) GOTO 50

* decode the agg.memb syntax (pathological syntaxes already checked)
           dset = val    ! integer truncate
	   IF (FLOAT(dset) .NE. val) THEN
	      agg  = dset
* ... check for valid aggregation parent dset
	      IF ( agg .LT. 1 .OR. agg .GT. maxdsets ) GOTO 500
	      IF ( ds_name(agg) .EQ. char_init2048 ) GOTO 500
              IF (ds_type(agg).NE.'ENS'
     .	    .AND. ds_type(agg).NE.'FCT' 
     .      .AND. ds_type(agg).NE.'UNI') GOTO 500

* ... get member number
	      idot = INDEX(buff,".")
	      IF (idot .EQ. 0) GOTO 400 !cant happen. easier than ferr_internal
	      READ (buff(idot+1:),*, ERR=50 ) val
	      memb = val
	      CALL CD_GET_AGG_DSET_INFO (agg, nmemb, status)
	      IF (status .NE. ferr_ok)  CALL WARN('crptn: agg dset 1')
	      IF (memb.GT.nmemb .OR. memb.LE.0) GOTO 500
	      CALL CD_GET_AGG_DSET_MEMBER (agg, memb, dset, status)
              IF (status .NE. ferr_ok)  CALL WARN('crptn: agg dset 2')
	   ENDIF

	   GOTO 400
	ENDIF

* 5/93 locate "true" end to the given filename (.des, .cdf, and .nc are invisible)
* note: filenames are always in CAPS since they may be embedded in the var defn

           cdf_name = .FALSE.
           des_name = .FALSE.
           nc_name  = .FALSE.

 50	   full_len = TM_LENSTR1( dname )
	   IF ( full_len .GT. 4 ) THEN
	      cdf_name = dname(full_len-3:full_len) .EQ. '.cdf'
     .        .OR. dname(full_len-3:full_len) .EQ. '.CDF'
	      des_name = dname(full_len-3:full_len) .EQ. '.des'
     .        .OR. dname(full_len-3:full_len) .EQ. '.DES'
	   ELSE
	      cdf_name = .FALSE.
	      des_name = .FALSE.
	   ENDIF
	   IF ( cdf_name .OR. des_name ) THEN
	      short_len = full_len - 4
	      full_name_used = .FALSE.
	   ELSE
	      short_len = full_len
              full_name_used = .TRUE.
	   ENDIF

	   IF ( full_len .GT. 3 ) THEN
	      nc_name = dname(full_len-2:full_len) .EQ. '.nc'
     .        .OR. dname(full_len-2:full_len) .EQ. '.NC'
	   ENDIF
	   IF ( nc_name ) THEN
	      short_len = full_len - 3
	      full_name_used = .FALSE.
              cdf_name = .TRUE.
           ENDIF

* compare with filenames stored by the TMAP library
	   DO 100 dset = 1, maxdsets

	      IF ( ds_name(dset) .EQ. char_init2048) GOTO 100

* special name match checks to account for implied .cdf or .des   5/93
** what about aggregate datasets?

	      IF ( TM_HAS_STRING(ds_type(dset),'CDF')   .OR. 
     .		   TM_HAS_STRING(ds_type(dset),'ENS')   .OR. 
     .		   TM_HAS_STRING(ds_type(dset),'FCT')   .OR. 
     .		   TM_HAS_STRING(ds_type(dset),'UNI') ) THEN
	         vax_code = STR_CASE_BLIND_COMPARE( ds_name(dset),
     .						    dname(1:short_len) )
	         IF (  vax_code .EQ. vms_str_success
     .	        .AND. (cdf_name .OR. full_name_used) ) GOTO 400

	      ELSEIF ( TM_HAS_STRING(ds_type(dset),'GT')) THEN	
	         vax_code = STR_CASE_BLIND_COMPARE( ds_name(dset),
     .						    dname(1:short_len) )
	         IF (  vax_code .EQ. vms_str_success
     .	        .AND. (des_name .OR. full_name_used) ) GOTO 400

	      ELSE     ! EZ data set - any filename extension allowed
	         vax_code = STR_CASE_BLIND_COMPARE( ds_name(dset),
     .						    dname(1:full_len) )
	         IF (  vax_code .EQ. vms_str_success ) GOTO 400

	      ENDIF

 100	   CONTINUE

* Is the name a full path name?
* Ticket 2563: Did the dname come in quoted, as from repl_exprns? 
* If so remove those the quotes before searching

	   buff = dname
	   IF (dname(1:1) .EQ. '"' .AND. dname(full_len:full_len) .EQ. '"') 
     .		buff = dname(2:full_len-1)

	   DO 200 dset = 1, maxdsets

	      IF ( ds_des_name(dset) .EQ. char_init2048) GOTO 200

* special name match checks to account for implied .cdf or .des   5/93
	      IF ( TM_HAS_STRING(ds_type(dset),'CDF')) THEN
	         vax_code = STR_CASE_BLIND_COMPARE( ds_des_name(dset),
     .						    buff )
	         IF (  vax_code .EQ. vms_str_success
     .	        .AND. (cdf_name .OR. full_name_used) ) GOTO 400

	      ELSEIF ( TM_HAS_STRING(ds_type(dset),'GT')) THEN	
	         vax_code = STR_CASE_BLIND_COMPARE( ds_des_name(dset),
     .						    buff )
	         IF (  vax_code .EQ. vms_str_success
     .	        .AND. (des_name .OR. full_name_used) ) GOTO 400

	      ELSE     ! EZ data set - any filename extension allowed
	         vax_code = STR_CASE_BLIND_COMPARE( ds_des_name(dset),
     .						    buff(1:full_len) )
	         IF (  vax_code .EQ. vms_str_success ) GOTO 400

	      ENDIF

 200	   CONTINUE



* Try TM_INQ_PATH and compare with full path names

           buff = TM_INQ_PATH (buff, 'FER_DATA', '    ', .FALSE.,
     .                              status)
           IF (status .NE. ferr_ok) GOTO 500

	   DO 300 dset = 1, maxdsets

	      IF ( ds_des_name(dset) .EQ. char_init2048) GOTO 300
	      vax_code = STR_CASE_BLIND_COMPARE( ds_des_name(dset),
     .						    buff )

 300	   CONTINUE

	   GOTO 500

* check for valid number given
 400	IF ( dset .LT. 1 .OR. dset .GT. maxdsets ) GOTO 500
	IF ( ds_name(dset) .EQ. char_init2048 ) GOTO 500

* success
	FIND_DSET_NUMBER = dset
	RETURN

* no match
 500	FIND_DSET_NUMBER = unspecified_int4
	RETURN

	END

*
*  scat2grid_std_xyt.F
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* April 2011

* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE  SCAT2GRID_STD_XYT_INIT(id)

      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CHARACTER*126 buff
      WRITE (buff, 10)
   10 FORMAT ('Copmpute std putting scattered data into XYT grid by bins')
      CALL ef_set_desc(id, buff)

      CALL ef_set_num_args(id, 7)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS,  NORMAL, IMPLIED_BY_ARGS)

      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 7)

* Output grid is determined by arguments 5, 6, and 7, the result's x and y axes.

      arg = 1
      CALL ef_set_arg_name(id, arg, 'XPTS')
      CALL ef_set_arg_desc(id, arg, 
     .     'X coordinates of scattered input XYT')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'YPTS')
      CALL ef_set_arg_desc(id, arg, 
     .     'Y coordinates of scattered input XYT')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'TPTS')
      CALL ef_set_arg_desc(id, arg,
     .     'T coordinates of scattered input XYT')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
 
      arg = 4
      CALL ef_set_arg_name(id, arg, 'F')
      WRITE (buff, 20)
  20  FORMAT ('F(X,Y,T) Data at scattered input XYT')
      CALL ef_set_arg_desc(id, arg, buff)
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'XAXPTS')
      CALL ef_set_arg_desc(id, arg,
     .                   'X axis coordinates of the output grid')
      CALL ef_set_axis_influence(id, arg, YES, NO, NO, NO)

      arg = 6
      CALL ef_set_arg_name(id, arg, 'YAXPTS')
      CALL ef_set_arg_desc(id, arg,
     .                   'Y axis coordinates of the output grid')
      CALL ef_set_axis_influence(id, arg, NO, YES, NO, NO)

      arg = 7
      CALL ef_set_arg_name(id, arg, 'TAXPTS')
      WRITE (buff, 30)
  30  FORMAT ('T axis coordinates of the output grid, with same ',
     .       'units and origin as tpts')
      CALL ef_set_arg_desc(id, arg, buff)
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, YES)


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN 
      END
      
*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE SCAT2GRID_STD_XYT_WORK_SIZE(id)

      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
* 
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_dims(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER nxout, nyout, ntout, nx2, ny2, nt2, i, k
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nxout = 1 + arg_hi_ss(X_AXIS,ARG5) - arg_lo_ss(X_AXIS,ARG5)
      nyout = 1 + arg_hi_ss(Y_AXIS,ARG6) - arg_lo_ss(Y_AXIS,ARG6)
      ntout = 1 + arg_hi_ss(T_AXIS,ARG7) - arg_lo_ss(T_AXIS,ARG7)

      nx2 = nxout* 2
      ny2 = nyout* 2
      nt2 = ntout* 2

* xaxlo  output x axis
      CALL ef_set_work_array_dims (id, 1, 1, 1, 1, 1, nx2, 1, 1, 1)
* xaxhi  output x axis
      CALL ef_set_work_array_dims (id, 2, 1, 1, 1, 1, nx2, 1, 1, 1)

* yaxlo  output y axis
      CALL ef_set_work_array_dims (id, 3, 1, 1, 1, 1, ny2, 1, 1, 1)
* yaxhi  output y axis
      CALL ef_set_work_array_dims (id, 4, 1, 1, 1, 1, ny2, 1, 1, 1)

* taxlo  output t axis
      CALL ef_set_work_array_dims (id, 5, 1, 1, 1, 1, nt2, 1, 1, 1)
* taxhi  output t axis
      CALL ef_set_work_array_dims (id, 6, 1, 1, 1, 1, nt2, 1, 1, 1)

* counts
      k = 2
      CALL ef_set_work_array_dims 
     .    (id, 7, 1, 1, 1, 1, nxout, nyout, k, ntout)

      RETURN
      END

* In this subroutine we compute the result
*

      SUBROUTINE SCAT2GRID_STD_XYT_COMPUTE(id, arg_1, arg_2, arg_3, 
     .     arg_4, arg_5, arg_6, arg_7, result, xaxlo, xaxhi, 
     .     yaxlo, yaxhi, taxlo, taxhi, counts)

*  arg_1  xpts  \
*  arg_2  ypts  / Scattered x,y,t triples to be gridded.
*  arg_3  tpts /
*  arg_4  fpts /
*  arg_5  xaxis of new grid   
*  arg_6  yaxis of new grid 
*  arg_7  taxis of new grid

      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id
      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .     mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .     mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .     mem3lot:mem3hit)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz, 
     .     mem4lot:mem4hit)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz,
     .     mem5lot:mem5hit)
      REAL arg_6(mem6lox:mem6hix, mem6loy:mem6hiy, mem6loz:mem6hiz,
     .     mem6lot:mem6hit)
      REAL arg_7(mem7lox:mem7hix, mem7loy:mem7hiy, mem7loz:mem7hiz,
     .     mem7lot:mem7hit)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*  Dimension the work arrays

      REAL*8 xaxlo(wrk1lox:wrk1hix/2, wrk1loy:wrk1hiy,
     .               wrk1loz:wrk1hiz, wrk1lot:wrk1hit)
      REAL*8 xaxhi(wrk2lox:wrk2hix/2, wrk2loy:wrk2hiy,
     .               wrk2loz:wrk2hiz, wrk2lot:wrk2hit)
      REAL*8 yaxlo(wrk3lox:wrk3hix/2, wrk3loy:wrk3hiy,
     .               wrk3loz:wrk3hiz, wrk3lot:wrk3hit)
      REAL*8 yaxhi(wrk4lox:wrk4hix/2, wrk4loy:wrk4hiy, 
     .               wrk4loz:wrk4hiz, wrk4lot:wrk4hit)
      REAL*8 taxlo(wrk5lox:wrk5hix/2, wrk5loy:wrk5hiy,
     .               wrk5loz:wrk5hiz, wrk5lot:wrk5hit)
      REAL*8 taxhi(wrk6lox:wrk6hix/2, wrk6loy:wrk6hiy,
     .               wrk6loz:wrk6hiz, wrk6lot:wrk6hit)
      REAL counts(wrk7lox:wrk7hix, wrk7loy:wrk7hiy,
     .              wrk7loz:wrk7hiz, wrk7lot:wrk7hit) 

      INTEGER i, j, k, l, m, n
      INTEGER i1, i2, j1, k1, l1
      INTEGER i5, i5n, j6, j6n, l7, l7n

      INTEGER nxpts, nypts, ntpts, nscat
      INTEGER nx, ny, nt

      REAL x1, y1, xf, yf, tol, diff
      REAL xx, yy, tt, ff, c, fac
      REAL xmin, xdel, ymin, ydel, tmin, tdel

      CHARACTER*250 errtxt

*  variables for checking axis characteristics (modulo axes)

      CHARACTER ax_name(5)*16, ax_units(5)*16
      LOGICAL backward(5), modulox(5), regular(5)

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*  Check to see if output axes are modulo

      CALL ef_get_axis_info (id, 5, ax_name, ax_units, backward, 
     .                       modulox, regular)

*  Find number of points in scattered input points.  1-D arrays defining the 
*  scattered data points may lie on the X, Y, Z, or T axis of the input arguments.

      nxpts = 0
      nypts = 0
      ntpts = 0

      DO 100 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG1) .GE. 1) THEN
            i1 = arg_lo_ss(m,ARG1)
            i1n = arg_hi_ss(m,ARG1)
            if (i1n-i1 .NE. 0) nxpts = 1 + (i1n - i1)
         ENDIF
 100  CONTINUE

      DO 110 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG2) .GE. 1) THEN
            i2 = arg_lo_ss(m,ARG2)
            i2n = arg_hi_ss(m,ARG2)
            if (i2n-i2 .NE. 0) nypts = 1 + (i2n - i2)
         ENDIF
 110  CONTINUE

      DO 120 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG3) .GE. 1) THEN
            i2 = arg_lo_ss(m,ARG3)
            i2n = arg_hi_ss(m,ARG3)
            if (i2n-i2 .NE. 0) ntpts = 1 + (i2n - i2)
         ENDIF
120   CONTINUE

      IF (nxpts .NE. nypts .OR. nxpts .EQ. 0) GOTO 900
      IF (nxpts .NE. ntpts) GOTO 900
      nscat = nxpts

*  Compute number of points in output axes.

      i5 = arg_lo_ss(X_AXIS,ARG5)
      i5n = arg_hi_ss(X_AXIS,ARG5)

      j6 = arg_lo_ss(Y_AXIS,ARG6)
      j6n = arg_hi_ss(Y_AXIS,ARG6)

      l7 = arg_lo_ss(T_AXIS,ARG7)
      l7n = arg_hi_ss(T_AXIS,ARG7)

      nx = 1 + (i5n - i5)
      ny = 1 + (j6n - j6)
      nt = 1 + (l7n - l7)

*  Check that xax is a X axis and yax a Y axis and tax a T axis

      IF (i5 .EQ. ef_unspecified_int4) THEN
         WRITE (errtxt, *) 'Fifth argument must be an X axis'
         GO TO 999
      ENDIF
      IF (j6 .EQ. ef_unspecified_int4) THEN
         WRITE (errtxt, *) 'Sixth argument must be a Y axis'
         GO TO 999
      ENDIF
      IF (l7 .EQ. ef_unspecified_int4) THEN
         WRITE (errtxt, *) 'Seventh argument must be a T axis'
         GO TO 999
      ENDIF

C  Get coordinates of output axes.

      CALL EF_GET_BOX_LIMITS(id, ARG5, X_AXIS,
     .   arg_lo_ss(X_AXIS, ARG5), arg_hi_ss(X_AXIS, ARG5), xaxlo, xaxhi)

      CALL EF_GET_BOX_LIMITS(id, ARG6, Y_AXIS,
     .   arg_lo_ss(Y_AXIS, ARG6), arg_hi_ss(Y_AXIS, ARG6), yaxlo, yaxhi)

      CALL EF_GET_BOX_LIMITS(id, ARG7, T_AXIS,
     .   arg_lo_ss(T_AXIS, ARG7), arg_hi_ss(T_AXIS, ARG7), taxlo, taxhi)

      xmin = xaxlo(1,1,1,1)
      xdel = xaxhi(1,1,1,1) - xmin
      ymin = yaxlo(1,1,1,1)
      ydel = yaxhi(1,1,1,1) - ymin
      tmin = taxlo(1,1,1,1)
      tdel = taxhi(1,1,1,1) - tmin
 

*  Compute result

*  Initialize result.

        k = res_lo_ss(Z_AXIS)
        DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
           DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
              DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
                 result(i,j,k,l) = 0.0
              ENDDO
           ENDDO
        ENDDO

*  Initialize counts.

        DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
           DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
              DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
                 counts(i,j,1,L) = 0.0
                 counts(i,j,2,L) = 0.0
              ENDDO
           ENDDO
        ENDDO

*  Loop over x,y,t, placing the function values in the appropriate slots
*  in the grid. xpts and ypts may be on the X,Y,Z or T axis of ARG1 
*  and ARG2, sending them to a subroutine collapses the extra dimensions so the
*  value can be found.

        DO 300 n = 1, nscat

           CALL pickout4 (arg_1, arg_2, arg_3, arg_4, 
     .                         n, xx, yy, tt, ff)

*  If output X axis is modulo, apply modulo adjustment to that coordinate
*  of the scattered point.

           IF  (modulox(1) .AND. xx.NE.bad_flag(ARG1))
     .         CALL modscatminmax (xaxlo(1,1,1,1), xaxhi(nx,1,1,1), 1, xx)

*  Put fcn into result variable.

           k = res_lo_ss(Z_AXIS)
           IF (ff .NE. bad_flag(ARG4)) THEN

              i = INT(0.5+(xx - xmin)/xdel)
              j = INT(0.5+(yy - ymin)/ydel)
              l = INT(0.5+(tt - tmin)/tdel)

              IF ( L.GE.res_lo_ss(T_AXIS) .AND. L.LE.res_hi_ss(T_AXIS) ) THEN
                 result(i,j,k,L) = result(i,j,k,L) + ff
                 counts(i,j,1,L) = counts(i,j,1,L) + 1.0 
              ENDIF

           ENDIF  ! ff not bad

300     CONTINUE

* Compute average in each bin.

      i1 = 1
      DO 620 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
         j1 = 1
         DO 610 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            l1 = 1
            DO 600 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

               IF( counts(i,j,1,L) .GT. 1. ) THEN
                  result(i,j,k,l) = result(i,j,k,l)/counts(i,j,1,L)
               ELSE
                  result(i,j,k,l) = bad_flag_result
               ENDIF

600         CONTINUE
            j1 = j1 + 1
610      CONTINUE
         i1 = i1 + 1
620   CONTINUE

* Compute std in each bin.



*  Loop over x,y,t, accumulating square of the function values minus bin 
*  mean in the appropriate slots in the grid.

         DO 800 n = 1, nscat

            CALL pickout4 (arg_1, arg_2, arg_3, arg_4, 
     .                         n, xx, yy, tt, ff)

*  If output X axis is modulo, apply modulo adjustment to that coordinate
*  of the scattered point.

            IF  (modulox(1) .AND. xx.NE.bad_flag(ARG1))
     .         CALL modscatminmax (xaxlo(1,1,1,1), xaxhi(nx,1,1,1), 1, xx)

*  Accumulate obs-mean in cells; using counts[k=2]

         IF (ff .NE. bad_flag(ARG4)) THEN
            

           i = INT(0.5+(xx - xmin)/xdel)
           j = INT(0.5+(yy - ymin)/ydel)
           l = INT(0.5+(tt - tmin)/tdel)
           IF ( L.GE.res_lo_ss(T_AXIS) .AND. L.LE.res_hi_ss(T_AXIS) ) THEN

	      IF (result(i,j,k,l) .NE. bad_flag_result) THEN
                 IF (tt.GE.taxlo(l1,1,1,1) .AND.
     .               tt.LT.taxhi(l1,1,1,1) .AND.
     .               result(i,j,k,l) .NE. bad_flag_result) THEN
                    diff = ff - result(i,j,k,l)
                    counts(i,j,2,L) = counts(i,j,2,L) + diff*diff
                 ENDIF
	      ENDIF
           ENDIF

         ENDIF  ! ff not bad

800   CONTINUE


* Compute std in each bin.

      i1 = 1
      DO 830 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
         j1 = 1
         DO 820 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            l1 = 1
            DO 810 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

               IF( counts(i,j,1,L) .GT. 0. ) THEN
	          c = counts(i,j,1,L)
	          fac = c/(c-1)
                  result(i,j,k,l) = fac*SQRT(counts(i,j,2,L)/c)
               ELSE
                  result(i,j,k,l) = bad_flag_result
               ENDIF

810         CONTINUE
            j1 = j1 + 1
820      CONTINUE
         i1 = i1 + 1
830   CONTINUE


      RETURN

900   CONTINUE

      IF (nxpts .NE. nypts) THEN
         WRITE (errtxt,20) nxpts, nypts
      ELSE IF (nxpts .EQ. 0) THEN
         WRITE (errtxt, 30)
      ENDIF
 20   FORMAT ('Input scattered x, y have different # of points', 2I8)
 30   FORMAT ('No data in scattered x, y points')
      GOTO 999 

 999  CALL EF_BAIL_OUT(id, errtxt)

      RETURN
      END

      SUBROUTINE modscat(axmin, axmax, axmod, nscat, scatm)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY
*  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
* 
* ACM 11/00
*  Called by scat2grid* gridding functions.
*  If there is a modulo axis, apply modulo-ness to the coordinates in that 
*  direction of the scattered points.
*
* *kms* 4/2012 Modified to pass the min, max, and modulo for the axis
*              If axmin and axmax are same location after modulo, axmax
*              values will be returned as axmin.
*
*  axmin        minimum value for the modulo axis
*  axmax        maximum value for the modulo axis
*  axmod        modulo length for the modulo axis
*  nscat        number of scattered points
*  scatm        input: scattered points coordinate array for the modulo axis
*               output: updated coordinates in the modulo range (if possible)

*  Input arguments
      REAL*8 axmin, axmax, axmod
      INTEGER nscat

*  Input/output arguments
      REAL scatm(*)

*  Local variables
      INTEGER idx
      REAL*8 val

* Check this is a valid modulo axis
      IF ( (axmin .GE. axmax) .OR. (axmod .LE. 0.0D0) ) THEN
         RETURN
      ENDIF

* Convert values
      DO 100 idx = 1, nscat
*        Do the conversion in double precision
         val = scatm(idx)
         DO WHILE ( val .GE. axmax )
            val = val - axmod
         ENDDO
         DO WHILE ( val .LT. axmin )
            val = val + axmod
         ENDDO
*        Save the new value if in range
         IF ( (val .GE. axmin) .AND. (val .LE. axmax) ) THEN
            scatm(idx) = val
         ENDIF
  100 CONTINUE

      RETURN
      END

	SUBROUTINE SYMSUB(LINE,ILEN,IER,SYM,IPOS)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)symsub.f	1.2    5/26/88
C**
C**
C***********************************************************************
C**
C**		    PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C**	Subprogram called:
C**		CALL SYMSUB(LINE,ILEN,IER,SYM)
C**
C**	Parameters:
C**		LINE -- String to have symbols substituted (char*2048)
C**		ILEN -- length of LINE before and after substitution
C**		IER -- error code
C**			0 = success
C**			1 = symbol not found
C**			2 = unmatched '
C**		SYM -- Symbol not found
C**		IPOS -- position of error
C**
C**	Description:
C**		Substitutes the values of symbols found in LINE.  Only
C**		symbols of the form 'sym' are substitued.  A double '
C**		is enterpretated as a single '.
C**
C**	History:
C**	    Written: 
C**		15-DEC-1985	by Donald W. Denbo
C**	    Modified:
C**
C**
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
C* v552 *acm* 3/03 Longer strings: changes for multi-line labels.

	CHARACTER LINE*(*),STR*2048,SYM*(*),GET*2048
	IER=0
	INXT=1
100	IST=INDEX(LINE(INXT:),'''')+INXT-1
	IF(IST.EQ.INXT-1.OR.IST.GT.ILEN)RETURN
	STR=LINE(:IST-1)
	ISP=INDEX(LINE(IST+1:),'''')+IST
	IF(ISP.EQ.IST)THEN
C	    UNMATCHED '
	    IER=2
	    IPOS=IST
	    RETURN
	ELSE IF((ISP-IST).EQ.1)THEN
C	    DOUBLE '
	    STR(IST:)=LINE(ISP:ILEN)
	    ILEN=ILEN-1
	    INXT=IST+1
	ELSE
C	    EXTRACT SYMBOL AND SUBSTITUTE
	    SYM=LINE(IST+1:ISP-1)
	    CALL GETSYM(SYM,GET,NC,IER)
	    IF(IER.EQ.0)THEN
		STR(IST:)=GET(:NC)
		STR(IST+NC:)=LINE(ISP+1:ILEN)
		ILEN=ILEN-(ISP-IST+1)+NC
		INXT=IST
	    ELSE
		IPOS=IST+1
		RETURN
	    ENDIF
	ENDIF
	LINE=STR(1:ILEN)
	GOTO 100
	END

        SUBROUTINE README_DSG_IN_FERRET

* V720 *sh* 6/2017
* V720 *acm 9/2017.  On merging the trunk back to this branch, I found that
*                    both the dynamic coordinate-data changes on the trunk
*                    and this dsg work use pointer storage named "linemem".
*		     Changing linemem in the dsg branch to dsg_linemem.
*
        RETURN 
        END

* This is a dummy subroutine -- not intended ever to be called by Ferret.
* It exists as a vehicle for inserting descriptive DSG documentation
* into the code in a place that will be discovered using grep and ls

*     DSG grids, datasets and contexts
*     ================================

*** Background:

* See CF convention documentation at http://cfconventions.org/
* Chapter 9 - Discrete Sampling Geometries (DSGs)

* A netCDF DSG file contains one or more "features".
* All features in the file must be of the same type.
* Supported DSG feature type in Ferret at the time of this writing include
* only collections of time series, however it is expected that collections
* of profiles and trajectories (XY, XYT, XYZT) will shortly be supported, too.
* The 2D feature types - trajectoryProfile and timeSeriesProfile are less
* commonly seen.  The level of support they will get in Ferret is TBD.

* The challenge of supporting DSG features is that the individual features
* may be of different lengths.  This means that they cannot be efficiently
* represented as a multi-dimensional grid.  Their inherent structure is that
* of a 'ragged array'.

* In the Ferret code all DSG-specific routines have 'dsg' in their filename.
* Thus 'ls *dsg*' is a quick way to locate the key DSG logic. The associated
* variables have 'dsg' in their variable names, so 'grep dsg' should pretty
* reliably locate all of the DSG implementation details.

*** File encodings:

* CF standard defines four different storage encodings.  The two "orthogonal"
* encodings are close enough to Ferret grids that no special support
* code was deemed to be necessary. The Ferret DSG enhancements as-of 6/2017
* support only the 'contiguous ragged array' encoding.  The 'indexed ragged
* array' encoding is intended for real-time capture, and we have never (yet)
* encountered its usage. Indexed contiguous array encodings, however, could be
* added to the current code quite easily -- simply as a re-ordering of the
* observarions at the end of cd_dsg_read.F, if the encoding type is indexed.

*** Instance variables versus observation variables:

* A DSG collection is a group of sampling features.  Each individual feature
* has its own distinct length, flen.
* There are two fundamental types of variables in a DSG dataset. 'Instance' 
* variables have one value per feature -- e.g. the longitude position of
* a time series station.  'Observation' variables have flen values per feature.

* Add a command option SET DATA/FEATURE= valid only for DSG datasets, but which
* will change the view of the data, particularly for treating Trajectory datasets 
* as timeseries datasets.  Possibly there will be other use cases.

*** DSG coordinate values and ranges:

* When Ferret receives a SET DATA command to open a DSG file it identifies
* the variables containing geo-location coordinates (XYZT==lon/lat/depth/time)
* and reads them into dynamic line memory (cd_dsg_scan_vars.F).
* For as long as the dataset remains open these variable occupy memory.
* (Note: dsg_linemem is NOT included in the managed memory totals of SET MEMORY.)
* (NOTE: dsg_linemem is also distinct from the linemem and edgmem dynamic memory 
* for coordinate data. The coordinate linemem structures use the same memory 
* allocation methods and could potentially be used for dsg_linemem storage, but 
* for now at least the separate structures to make development and debugging cleaner.)
* Dataset COMMON variables (xdset_info.cmn_text: dsg_*) record which variables
* contain coordinate information and where they are stored.  So DSG coordinate
* information is available whenever it is needed: for commands LIST, PLOT, etc;
* for transformations @AVE, etc; for functions (including external fcns); and
* for pseudo-variable values (see pseudo-variable section below). When
* one of these coordinte variables is reverenced **as a Ferret variable**
* e.g. 'PLOT/VS longitude, latitude', Ferret does not read the coordinates
* from the file.  Rather, in find_mem_var.F, it creates a 'mr_table_entry_only'
* mvar that uses the pointer value from dsg_linemem.  The critical DSG 'rowSize'
* variable is handled very similarly to the coordinate variables.
* At the time of SET DATA Ferret also determines the min/max range of each
* coordinate variable.  If these are not provided with the attribute\
* 'actual_range, then Ferret will compute them and create the 'actual_range'
* attribute (cd_get_dsg_coord_extremes.F)

*** IO and Subsetting (incl. future logic):

* When Ferret reads a variable from a DSG file (cd_dsg_read.F) it always
* reads the entire variable.  It does no subsetting.  The appearance of
* subsetting is maintained by the DSG context (see section below).
* As of 6/2017 no true DSG subsetting capabilities (i.e. only reading the 
* smaller subset data volume) exist.  The future plan is to implement 
* a new command 'DEFINE DATA/SUBSET/PARENT=xxx subset=<constraint expression>'
* When this new dataset is created new, subsetted rowSize and coordinate
* variables will be stored in dsg_linemem.  When a DSG variable is thereafter
* read through this new dataset, true subsetting will occur at the IO level,
* (reduced-size memory allocated), but the variable will behave exactly as
* current DSG variables do inside of Ferret.
 
*** DSG grids:

* A DSG dataset will generate 2 grids:  the instance grid and the observations
* grid. The instance grid is a straightforward 1D grid along the E axis.  Its
* only special feature is that the associated E axis sets line_dsg_dset to
* point to the dset number of the DSG dset.  Thus the grid is tied to a
* particular dataset.  The observations grid appears to be 2D, where its 2
* axes are the E axis and the orientation axis of the feature type (e.g. T for
* a time axis collection). See the 'DSG contexts' section for more discussion.

*** DSG contexts (**important!!**):

* In a context (cx) representing a DSG variable, the normal strict association
* between the subscript values (cx_lo/hi_ss) and the world coordinate values
* (cx_lo/hi_ww) that we are accustomed to with gridded variables is broken.
* For a DSG context the subscript values always represent the size and shape
* of the data as stored in memory; and the world limits represent constraints.
* The size and shape of a stored instance variable is always a 1D array
* lying along the E axis of the same size as the E axis.  The size and shape
* of an observations variable is always a 1D array lying along the orientation
* axis of the feature type, of length equal to the length of the observation
* dimension of the netCDf file.  The world coordinate constraints may mask
* which features are relevant.  For example, if X=lo:hi has been issued to
* constrain the longitude range of a time series collection, then cx_lo/hi_ww
* on the X axis will effectively mask out any time series whose longitude
* coordinates lie outside of this longitude range.  In recognizing cache
* hits (find_mem_var.F) the WW ranges of a variable are consulted.
* In the interest of computation efficiency, the implied masking of features
* by world coordinate limits is used to reduce the amount of calculation that
* is done by some operations (transformations, regridding, etc.). Computation
* results on features that are masked out are pre-filled with the value
* dsg_masked_out_flag = -12345. If the value "-12345" were ever to show up
* mysteriously in a visible result, it would be an indication of a bug in
* application of the cx_lo/hi_ww constraints.  World constraints implicitly
* mask values at the observations level as well as at the feature instance
* level.  For example a LIST command will not show observations that lie
* outside of a requested X=lo:hi range.  However, observation-level constraints
* are not normally used to reduce the amount of computation done.  This is
* because the results of some calculations depend upon the values of
* neighboring points, even though they may be masked out.  There may be
* subtleties in this issue that have not yet been uncovered.


*** The F axis (future logic):

* The F axis of a DSG dataset lies outside the scope of the DSG concepts.  
* If an F axis were added to a DSG instance or observations grid it could
* in principle be regarded as orthogonal to the entire DSG collection.
* As such it could be used in creating, say, conceptual ensembles of the 
* DSG collection, where a variation on some analysis is different for each F
* index.  F would in effect be the lone 'gridded' axis of a DSG variable.
* Placeholders have been inserted into the code to permit this interpretation
* of an orthogonal F axis, but it has never been tested, and code additions
* would be needed. 

*** Pseudo-variables:

* When pseudo-variables X, Y, Z, or T are referenced, the values of them
* are draw from the coordinate variables stored in dsg_linemem (see section above).
* A given pseuo-variable may have the structure of an instance variable or an
* observation variable, depending upon how it is represented in the DSG file.
* For example, in a time series collection X, and Y will typically be instance
* variables, whereas T will be an observation variable. The distinction between
* instance vs observation has special implications for the pseudo-variables
* I, J, K, L, M.  Namely, the index value for observation pseudo-variables
* will restart at 1 at the start of each feature.  Thus, the L pseudo-variable
* of a time series collection will show L=1 at the start of each time series.
* The behavior of XBOX, YBOX, ZBOX, TBOX has not been fully implemented as of
* 5/2017 (see make_pseudo_var.F).  Ditto for XBOXLO, XBOXHI, etc.

	SUBROUTINE DAXIS2(XF,YF,NMX,NMY)
C** 
C**    @(#)daxis2.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*     MOD *JD* 10.91 to eliminate PLOT COMPLETE msg if in ferret
*     MOD *sh* 6/99 with changes to IGRNPT call
* v552 *acm* 3/03 Changes for multi-line labels.
* V69+  5/14 *acm* Fix for ascii font in multi-line labels, ticket 2176

	INCLUDE 'PARAMPL5.DAT'
	INCLUDE 'AXIS.INC'
	INCLUDE 'LABELS.INC'
	INCLUDE 'LABCOM.INC'
	INCLUDE 'PLT.INC'
	INCLUDE 'HAB.INC'
	INCLUDE 'LINES.INC'
	INCLUDE 'MPLOT.INC'
	INCLUDE 'TAXIS.INC'
	INCLUDE 'TICS.INC'
	INCLUDE 'TICS2.INC'
	INCLUDE 'AXISL.INC'
	INCLUDE 'XYLABP.INC'
	INCLUDE 'CMRDL.INC'
	INCLUDE 'LUNITS.INC'
	INCLUDE 'PRMCOM.INC'
	INCLUDE 'SYSTEM.INC'
	INCLUDE 'SWITCH.INC'

        include         'xinterrupt.cmn' ! 1/89 *sh*
        include         'ppl_in_ferret.cmn'

******************************************************************************


	CHARACTER OUT*255
        INTEGER TM_LENSTR, numlines, i, j

c        CHARACTER fontprefix*3, penprefix*3, newfont*3, newpen*3
c        INTEGER lnbeg(500), lnend(500), 
c        REAL line_spacing
c        line_spacing = 1.4

	CALL VECTRS
	DO 80 I=1,NLAB

* Don't go through the motions of plotting blank labels
	IF (TM_LENSTR(labs(i)) .EQ. 0) GOTO 80

	IF(RHLABS(I).LT.0.0)THEN
		HLB=HLABS
	ELSE
		HLB=RHLABS(I)
	ENDIF
	CS=COS(RLABS(I)*0.0175329252)
	SN=SIN(RLABS(I)*0.0175329252)
	IAT=0
	SHFT=0.0


        CALL tm_break_lines (labs(i), lnbeg, lnend, numlines)
        nfont = 0
        npen = 0
        fontprefix = ""
        penprefix = ""
        DO 20 j = 1, numlines
           CALL getlabfonts (labs(i), lnbeg, lnend, j, fontprefix, 
     .           npnew, nfnew, newfont, newpen, ncr)

	   NCR = lnend(j) - lnbeg(j) + 1
	   XMN=SYMWID(HLB,NCR+npen+nfont,
     .                 penprefix(1:npen)//fontprefix(1:nfont)//
     .                 LABS(I)(lnbeg(j):lnend(j)))

	   IF(USRLBS(I))THEN
	       XFUSER=1.
	       YFUSER=1.
	       YLOUSR=0.
	       XLOUSR=0.
	   ELSE
	       XFUSER=XF
	       YFUSER=YF
	       XLOUSR=XLO
	       YLOUSR=YLO
	   ENDIF
	   IF(XLABS(I).LT.1.E35)THEN
	       XL=XLABS(I)
	       YL=YLABS(I)
	       LTY=LTYPE(I)
	       IF(LTY.GT.0)THEN
		   SHFT=-XMN
	       ELSE IF(LTY.EQ.0)THEN
		   SHFT=-XMN*.5
	       ENDIF
	       CALL ARROW(XL/XFUSER+XLOUSR,YL/YFUSER+YLOUSR,
     *	       XLLABS(I)/XFUSER+XLOUSR,YLLABS(I)/YFUSER+YLOUSR,
     *	       LLTYPE(I),SHFT,XMN,CS,SN,XF,YF,HLB)
	       GOTO 70
	   ENDIF
	   ICHAR=IGRNPT(.TRUE., XL,YL)	! show the choice menu
	   LTY=-1
	   IF(ICHAR.EQ.67.OR.ICHAR.EQ.99)THEN
	       LTY=0
	       SHFT=-XMN*.5
	   ELSE IF(ICHAR.EQ.82.OR.ICHAR.EQ.114)THEN
	       LTY=1
	       SHFT=-XMN
	   ELSE IF(ICHAR.EQ.76.OR.ICHAR.EQ.70.OR.ICHAR.EQ.108
     *	   .OR.ICHAR.EQ.102)THEN
	       IAT=1
	       XL2=XL
	       YL2=YL
	       ICHARO=ICHAR
	       ICHAR=IGRNPT(.FALSE., XL,YL) ! do not show the choice menu again
	       IF(ICHAR.EQ.67.OR.ICHAR.EQ.99)THEN
		   SHFT=-XMN*.5
		   LTY=0
	       ENDIF
	       IF(ICHAR.EQ.82.OR.ICHAR.EQ.114)THEN
		   SHFT=-XMN
		   LTY=1
	       ENDIF
	       IF(ICHARO.EQ.70.OR.ICHARO.EQ.102)IAT=2
	       CALL ARROW(XL,YL,XL2,YL2,IAT,SHFT,XMN,CS,SN,XF,YF,HLB)
	       WRITE(OUT,998)I,(XL2-XLOUSR)*XFUSER,
     .               (YL2-YLOUSR)*YFUSER,IAT
998 	       FORMAT('C LLABS,',I2,2(',',1PE10.3),',',I2)
	       CALL ECHO(OUT,40)
	   ENDIF
	   XL=(XL-XLOUSR)*XFUSER
  	   YL=(YL-YLOUSR)*YFUSER
	   IF(USRLBS(I))THEN
	       WRITE(OUT,999)I,XL,YL,LTY,LABS(I)(:NCR)
999	       FORMAT('C LABS,',I2,2(',',1PE10.3),',',I2,',','"',A,'"')
	   ELSE
	       WRITE(OUT,997)I,XL,YL,LTY,LABS(I)(:NCR)
997	       FORMAT('C LABS/NOUSER,',I2,2(',',1PE10.3),',',I2,
     *                ',','"',A,'"')
	   ENDIF
	   NOUT=LNBLK(OUT,255)
	   CALL ECHO(OUT,NOUT)
70	   XL=XL/XFUSER+XLOUSR+SHFT*CS/XF + 
     .         line_spacing*(j-1)*hlb*SN/xf
	   YL=YL/YFUSER+YLOUSR+SHFT*SN/YF -
     .         line_spacing*(j-1)*hlb*CS/yf

           CALL SYMBEL(XL,YL,RLABS(i),HLB,NCR+npen+nfont,
     .                 penprefix(1:npen)//fontprefix(1:nfont)//
     .                 LABS(I)(lnbeg(j):lnend(j)))

C  Set up to use any font settings from this line on subsequent lines.

           IF (npnew.GT.0) THEN
              penprefix(1:3) = newpen(1:3)
              npen = 3
           ENDIF
           IF (nfnew.GT.0) THEN
              fontprefix(1:3) = newfont(1:3)
              nfont = 3
           ENDIF

20      CONTINUE

80	CONTINUE
	IF(PLTOPN)RETURN
	IF(IMULT.EQ.0.OR.IMCNT.EQ.MNX*MNY)THEN
	    IF(SWAIT)THEN
		CALL HABIS(IPLOT,IPAUSE,IHDCPY,INC)
	    ELSE
		CALL HABIS(IPLOT,0,IHDCPY,INC)
	    ENDIF

*     Mod is here
        if (ppl_in_ferret) then   
           call ferret_plot_complete (icount)
        else
	   IF(.NOT.QUIETF)WRITE(LTTOUT,'('' PLOT'',I8,
     *         '' COMPLETE'')')ICOUNT
	       IF(INC.EQ.27)THEN
		  CALL ATFLSH
	       ENDIF
	endif

        ENDIF
	RETURN
	END

	BLOCK DATA XREVISION_DATA

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* pre-defined program revision and name

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V314 - 9/14/94 (extracted from ferret.F)
* V400 - 3/16/95 (at the joining with the GUI)
* V402 - 7/95 symbols (4.01), VAR[G=var2[d=dset]], etc. ...
*	 8/95 - The initialization of progname_mod moved to
*		xrevision_type_data.F for auto-configuring
* V410 - 8/95 ... just a name change so that the anonymous ftp looks good
* V411 - 9/95 repaired memory leaks: XGKS (clear_vp.F) and HDF (whdf.c)
* V420 - major changes
* V430 - added IF-THEN tests and wildcards
* V440 - 8/29/96 linked with GUI
* V441 - 10/15/96 identical to 4.40 but Sun and OSF V4.40 went out in debug
*		mode. This is to differentiate from them.
* V442 - 12/06/96 *kob* - gui bug fixes and quality control checks
* V445 - 1/14/97 *sh* - more gui bug fixes and uniform version numbering
* V490 - 4/5/97 *sh* - still in development at this date
* v4.92 - 1/11/98 *kob* - upped version number from 4.91 to 4.92 for 
*                         source code release
* V500 - 12/98 *sh* - still in development as of this date
* V510 - 10/99 *sh*
* V511 - 05/00 *kob*
* V521 - *sh* minor bug fixes from V520
* V530 - 10/00 *sh* beta 1
* V534 - 9/01 *sh* alpha 1
* V550 - 7/02 *sh* alpha 1
* V551 - 2/03 *kob* beta1
* V580 - 12/04 *acm* 
* V581_01 8/12/05 *acm* minor revisions (not released)
* 5.812 10/5/05  *acm* bug fixes thru now...
* 5.813 12/13/05  *acm* fix for bug 1368
* 5.814  2/08/06  *acm* Fixes:
*                 further IF- parsing fixes, nested IF inside an IF clause that is not executed. 
*                 fix to restore scale defaults in tm_close_set.F (changes many bn outputs!)
*                 bug 1376, in labels and listings, if year is not listed because its modulo, 
*                 remove extra spaces
*                 bug 1077 had not been fixed for linux: handle arg-tests by QUERY as errors,
*                 if the test fails
*                 in NC reads, apply user-given offset to 1-D double precision variable, then 
*                 convert to single precision
* V6.00  4/25/06  Version 6.0
* V6.01  9/29/06  Version 6.01
* V6.02  1/05/07  Version 6.02
* V6.03  5/25/07  Version 6.03
* V6.04  7/02/07  Version 6.04
* V6.05  7/27/07  Version 6.05
* V6.06  8/08/07  Version 6.06 for LAS
* V6.07  8/24/07  Version 6.07 for LAS
* V6.08 10/12/07  Version 6.08
* V6.10  3/25/08  Version 6.1
* V6.11  4/02/08  Version 6.11 internal release
* V6.12  5/20/08  Version 6.12
* V6.13  8/28/08  Version 6.13
* V6.13  8/28/08  Version 6.14 GFDL see bug 1586,1038
* V6.15 11/07/08  Version 6.15 GFDL bugs 1608,1609
* V6.16 11/20/08  Version 6.16 GFDL bugs 1421,1523,1547,1522,1577 plus gif transparency
* V6.17  1/12/09  Version 6.17 GFDL bug  1476, bugs 1588, 1333, 1614 
* V6.18  1/21/09  Version 6.18 fix bug with CURV_TO_RECT, allowing subsetting
* V6.19  2/03/09  Version 6.19 fix for choosing colors and thicknesses when > 6 colors have been defined
* V6.2   5/0/09   V6.2 release
* V6.3   9/18/09  V6.3 release
* V6.4   11/20/09  V6.4 release
* V6.61   4/27/10  
* V6.62   5/14/10  release v6.62 this week: LAS changes  
* V6.64            BROWSE, bug fixes. Released 9/2010  
* V6.65  10/01/10
* V6.74   4/2011  to GFDL: double precision, netCDF4.2, fix ticket 1391 
* V6.84  12/2012  Ribbon plots, bug fixes.
* V6.9    4/2014  
* V6.91   internal, not released. Fixes on v6.9
* V6.92   internal, new color /key options any of 
*           /key=vertical,horizontal,centerlabel
* V6.921   internal, @WGT and defined axis for EZ reads
* V6.922   final tweaks to /key=centerlab, internal tag for SOCAT testing
* v6.923   fix ticket 2187
* v6.924   fix ticket 2186 
* v6.925   fix ticket 2194
* v6.926   fix ticket 2203, 2200
* v6.927   fix ticket 2205, 2206
* v6.93    release
* v6.931   to gfdl
* v6.932   to John Maurer, bug 2223 and tag v_6_9_32_GFDL23Dec
* v6.933   to GFDL tag v_6_9_33_GFDL27Jan15
* v6.94    Ferret release to go with LAS 8.4
* v6.941   Version number for post-v6.94 development
* v6.942   Version number for post-v6.94 development 5/8/2015
* v6.943   To GFDL  tag v_6_9_43_GFDL_2Jun15 tickets thru 2296
* v6.95    release for LAS8.4
* v6.951   New development
* v6.96    little release with @BIN @NBIN regrid; high-res time plots
* v6.961   To GFDL for fix to #2334
* v6.963   To GFDL in a PyFerret update, install on our servers
* v6.97 (working version)
* v7.0     7/2016
* v7.02    8/2016 Fixes graticules on time axes # 2466
* v7.02   12/2016 Merged true-monthly axis branch to the trunk
* v7.1     2/2017 Official release
* v7.11    4/19/2017 Tag before GFDL visit 4/2017
* v7.12    5/11/2017 
* v7.13    6/ 6/2017  fixes to tickets 2538, 2539
* v7.20    7/11/2017 7.20 release

        IMPLICIT NONE
	include	'xrevision.cmn'

	DATA program_name	/ 'FERRET' /
	DATA len_program_name	/  6       /
	DATA revision_level	/  7.20   /

! Note we can put a debug title in the Ferret startup header lines
! by putting a title into the Makefile: $(MAKE) "DEBUG_TITLE=beta" update
!	DATA progname_mod	/ '(GUI BETA v1)' / ! ==> xrevision_type_data.F
!	DATA len_progname_mod	/  13       /	    ! ==> xrevision_type_data.F
	END

	SUBROUTINE DISP_DATA_SET_UP(  ax1_work, ax2_work, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* set up graphics environment and obtain the data

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 1/7/87 
* revision 0.1 - 2/25/87 - changes for INTERPRETATION STACK
* revision 0.2 - 6/24/87 - changes to accomodate transposed plots
* revision 0.3 - 9/16/87 - added want_cmnd_data to CALL GET_CMND_DATA
* V200:  5/19/89 - 4D symmetrical
*         5/9/90 - allow CGRID_SIZE for axes to accomodate PLOT/VS
* V301:   1/7/94 - don't unprotect the command data cuz' GET_MEMORY is called
*		   during set-up of plots
* V312: 5/94 - array "memory" as a calling argument
* V500: 2/99 *sh* - added support for POLYGON command -- working storage needs
*       2/99 *sh* - bug fix: plot working storage based on cx(1) only
*			can overflow for PLOT v1,v2  if v2 is bigger
* V530: *sh* 9/00 - added initial data type support in get_cmnd_data 
*	*sh* 1/01 - added PLOT/STEP with special work array needs
*	          - also fixed apparent bug in loop over num_uvars_in_cmnd
* V533: *sh* 6/01 - include CGRID_SIZE in determination of axis buffer sizes
*	            only if PLOT/VS
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V69+ *acm*  9/14 Ticket 1758. Memory request uses number of blocks not words
* V702 1/17 *sh* for trac enhancement #2369 -- dynamic memory management 
* V73+ *acm* 12/17 additions for plotting several lines from a dsg dataset
* V74+ *acm*  4/18 additions for plotting trajectories from a dsg dataset
* V74+ 4/18 *acm*  Automatically do a colored trajectory plot for the command 
*                  "PLOT var" if it's a DSG trajectory set. Allow color-by-Feature-id.
* V74+ 7/18 *acm*  DSG trajectory plots colored by ID even if its a string 
* V75+ 5/19 *acm*  DSG lon/lat plots of profile or timeseries datasets
* V76  1/20 *acm* working with Point-type dsg data
* V760 *acm* 3/20 Flag for case when constraints result in no features

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'slash.parm'
	include 'command.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xdsg_context.cmn'
	include 'xprog_state.cmn'
#include "tmap_dset.parm"
	include 'xdset_info.cmn_text'
	include 'xtm_grid.cmn_text'

	
* calling argument declarations:
	INTEGER	ax1_work, ax2_work, status

* internal variable declarations:
	LOGICAL TM_ITSA_DSG_RAGGED, TM_ITSA_DSG, plot_vs, typerr
	INTEGER	MR_DIM_LEN, CX_DIM_LEN, CGRID_SIZE, TM_DSG_NFEATURES,
     .		TM_DSG_DSET_FROM_GRID,
     .		idim, ndim, dim(nferdims), mr1, cx, ivar,
     .		factor, loc, grid, dset, nfeatures, obsdimlen, 
     .		fline, dtyp, numv
	INTEGER*8 i8_ax_len
	REAL	big_val, little_val
	CHARACTER buff*4

* check for PLOT/VS -- significant in axis buffer sizes
	plot_vs = cmnd_num .EQ. cmnd_plot
     .	          .AND. qual_given(slash_plot_vs) .GT. 0

* initialize
	cxdsg_empty_set = .FALSE.

* get the requested data somehow  (and leave it protected 1/94)

	dset  = cx_data_set(cx_last)
	dtyp = ptype_float

	IF (dset .GT. pdset_irrelevant) THEN
	   IF (dsg_ragged(dset)) dtyp = ptype_native
	ENDIF
	CALL GET_PROT_CMND_DATA (  cx_last, dtyp, status )

	IF ( status .NE. ferr_ok ) GOTO 5100

	numv = num_uvars_in_cmnd


* ragged DSG data?
* For a trajectory dataset, the variable may be on the instance axis 
* (color by feature-id). If so set that up. Otherwise insist it's a
* variable on the obs axis of a ragged-array dataset

         cx = is_cx(1)
	 grid = cx_grid(cx)
	 
	 grid_is_dsg = TM_ITSA_DSG( grid )
	 IF (cmnd_num .EQ. cmnd_plot .AND. grid_is_dsg) THEN
	    IF (  qual_given(slash_plot_along) .GT. 0.AND. .NOT.plot_vs )  
     .	       CALL WARN ('PLOT/ALONG is ignored for discrete DSG data')

	    dset = TM_DSG_DSET_FROM_GRID( grid )
	    nfeatures = TM_DSG_NFEATURES( grid )	    
	    CALL TM_DSG_FACTS( grid, idim, obsdimlen, fline )

	    IF (idim.EQ.pfeatureType_Trajectory .OR. idim.EQ.pfeatureType_Point) THEN
	       plot_vs = .TRUE.
	    ELSE IF (.NOT. plot_vs) THEN
	       typerr = (cx_type(cx) .EQ. ptype_string) 
	       IF (typerr) GOTO 5200
	       IF (grid_is_dsg) CALL PLOT_DSG_DATA_SET_UP(nfeatures, obsdimlen, status)
	       IF (status .NE. ferr_ok) GOTO 5200
            ENDIF
	 ENDIF

* PLOT/ALONG -- reinterpret a multi-D data block as a collection of lines
	IF (  cmnd_num .EQ. cmnd_plot
     .	.AND. qual_given(slash_plot_along) .GT. 0
     .	.AND. .NOT.plot_vs   .AND. .NOT. grid_is_dsg  ) THEN
	   CALL PLOT_ALONG_DATA_SET_UP(status)
	   IF (status .NE. ferr_ok) GOTO 5010
	ENDIF

* PLOT/STEP needs double or triple the working storage
*    double to make connected steps, triple for disconnected
	factor = 1
	IF (cmnd_num .EQ. cmnd_plot) THEN
	   loc = qual_given( slash_plot_step )
	   IF ( loc .GT. 0  ) THEN
	      CALL EQUAL_STR_LC( cmnd_buff(qual_start(loc):qual_end(loc)),
     .                           buff, status )
              IF ( status .NE. ferr_ok ) RETURN
	      IF ( buff(1:3) .EQ. 'con' ) THEN
	         factor = 2
	      ELSE
	         factor = 3
	      ENDIF
	   ENDIF	   
	ENDIF

* compute working storage
	IF (cmnd_num .EQ. cmnd_polygon) THEN
* ... allocate buffers used to extract individual polygon coord arrays
*     set buffer size to the longest axis of 1st coord arg
*     Polygon may need extra working storage to store info about 
*     missing polygons on a time axis
	   cx = is_cx(1)
	   CALL GET_CX_DIMS(cx, ndim, dim)
	   i8_ax_len = 1
	   DO 100 idim = 1, ndim
 100	   i8_ax_len = 2* MAX(i8_ax_len,
     .			cx_hi_ss(cx,dim(idim)) - 
     .			cx_lo_ss(cx,dim(idim)) + 1 )
	ELSE
* ... allocate memory used for axes
*     make them each equal to MAX in case /TRANSPOSE or mulit-dim PLOT/VS
* (2/99: loop over all arguments to find largest requirement)
* ?? why is CGRID_SIZE needed ... could get very large ??
	   i8_ax_len = 1
	   DO 200 ivar = 1, numv
	      mr1 = is_mr( ivar )
	      CALL GET_CX_DIMS( is_cx(ivar), ndim, dim )
	      i8_ax_len = MAX( i8_ax_len,
     .			    MR_DIM_LEN( dim(1), mr1 ),
     .		            MR_DIM_LEN( dim(2), mr1 ),
     .			    factor*CX_DIM_LEN(dim(1), is_cx(ivar)),
     .			    factor*CX_DIM_LEN(dim(2), is_cx(ivar)) )
	      IF (plot_vs) i8_ax_len = MAX( i8_ax_len,
     .		            CGRID_SIZE(is_cx(ivar))  )
 200	   CONTINUE

* trajectory plot from DSG trajectory file needs obs-length 
* (color var may be feature-length).

	   IF (cmnd_num.EQ.cmnd_plot .AND. grid_is_dsg ) THEN
              i8_ax_len = obsdimlen
	   ENDIF
	ENDIF

* allocate working storage
* the somewhat odd logic is cuz we're making minimal changes to the 
* pre-dynamic memory code
	CALL CREATE_DYN_WRKSPC( i8_ax_len, ax1_work, status )
	IF ( status .NE. ferr_ok ) GOTO 5020
	CALL CREATE_DYN_WRKSPC( i8_ax_len, ax2_work, status )
	IF ( status .NE. ferr_ok ) GOTO 5010

* successful completion
	RETURN

* error exits - release the memory used for axis buffers
 5010	CALL FREE_WS_DYNMEM( ax1_work )
 5020	CALL UNPROTECT_CMND_DATA	! added 2/99
 5100	RETURN

 5200	CONTINUE
* ... copied from get_prot_cmnd_data error exit ... 
        CALL RELEASE_DYN_WORK_SPACE
        CALL DELETE_MRS_IN_PROGRESS
        CALL UNPROTECT_ALL_MRS
        CALL DEALLO_ALL_GRIDS
        CALL CLEAN_STACK
	buff = ' '

	IF (typerr) CALL ERRMSG( ferr_data_type, status,buff, *5100 )

	END

	SUBROUTINE DFLT_TRANS_ARG( idim, cx, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* if no argument was specified for the given transformation then insert
* a default

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:   6/7/89 - removed this function from GET_CONTEXT_MODS
*	 1/11/90 - added @LOC
*	  2/7/90 - corrected error detect bug for transforms without args
* V400:  5/30/95 - increased arbitrary argument limit of 1000 to 32766
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

* calling arguments
	INTEGER	idim, cx, status

* internal variable declarations
	INTEGER	i, ktrans
	REAL	arg

	include 'tmap_dims.parm'
	include 'ferret.parm'	
	include 'errmsg.parm'	
	include 'xcontext.cmn'
	include 'xalgebra.cmn'

* initialize
	ktrans = cx_trans( idim, cx )
	arg   = cx_trans_arg( idim, cx )

* identify the transformation in terms of numbering in COMMON (XALG*)
	DO 100 i = 1, num_transforms
	   IF ( ktrans .EQ. alg_trans_num(i) ) GOTO 200
 100	CONTINUE

* not found !
	status = ferr_internal
	GOTO 5100

* does it take an argument ?
 200	IF ( alg_trans_has_arg( i ) ) THEN
* yes !
	   IF ( arg .EQ. bad_val4 ) THEN
* ... insert default value
	      cx_trans_arg( idim, cx ) = alg_trans_dflt_arg(i)

	   ELSEIF ( alg_trans_its_int(i) ) THEN
* ... convert argument to integer if possible

*     Dont limit the size of this -- using very large indices is ok.
*     May need very large numbers for some @SHF operations.

c	      IF ( ABS(arg) .GT. 32766. ) THEN	! was 1000 5/95
c	         GOTO 5000
c	      ELSE
	         cx_trans_arg( idim, cx ) = INT( arg )
c	      ENDIF
	   ELSE
* ... leave it as it is
	      CONTINUE
	   ENDIF

	ELSE
* no! if the user gave an argument he/she shouldn't have
	   IF ( arg .NE. bad_val4 ) THEN
	      status = ferr_unknown_arg
	      GOTO 5100
	   ENDIF
	ENDIF

* argument of zero is illegal for some things
	IF( arg .EQ. 0.0
     .	 .AND. (   ktrans.EQ.trans_smth_box
     .	      .OR. ktrans.EQ.trans_smth_binml
     .	      .OR. ktrans.EQ.trans_fill_ave )  ) GOTO 5000

* successful completion
 1000	status = ferr_ok
	RETURN

* error exit
 5000	status = ferr_out_of_range
 5100	RETURN
	END

	SUBROUTINE TRANS_INIT_VALUE( idim, cx,
     .			             need_init, init_val, nbuffer)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine the value to use when initializing the output buffer in preparation
* for performing a transformation
* @AVE and @DIN, for example, require the result array to be initialized to
* zero so that sums can be accumulated
* @SUM needs to count up the number of good-values - an all-bad chunk contributes
* 0 to the sum; we need to know if there's no valid data over the accumulated sum.
* @AVE requires nbuffer=2, because it accumulates both weighted sum of values
* and sum of weights (to be divided in the finalize stage), whereas @DIN
* requires only nbuffer = 1


* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V702 11/16 *sh* for enhancement ticket 2428: split/gather on compressed axes
*       3/17 *sh* nbuffers must be 2 (or more) whenever there is an
*                 accumulation operation implied (e.g. summing, min, max, ...)

        IMPLICIT NONE
* calling argument declarations:
	LOGICAL need_init
	INTEGER idim, cx, nbuffer
	REAL	init_val

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'

* internal variable declarations:
	INTEGER	trans

* internal parameter declaration
        REAL            too_small
        PARAMETER     ( too_small = -1.E33 )
        REAL            too_large
        PARAMETER     ( too_large = 1.E33 )

* --- end of introductory code ---
* initiailize
	trans = cx_trans( idim, cx )

	IF ( trans .EQ. trans_average
     .  .OR. trans .EQ. trans_4d_ave   
     .  .OR. trans .EQ. trans_integ_def
     .  .OR. trans .EQ. trans_4d_int_def  ) THEN
* ... integration accumulates weights, too, so a zero accumulated weight
*     results in a missing value, instead of a zero
	   need_init = .TRUE.
	   init_val = 0.0
	   nbuffer = 2
	ELSEIF (trans .EQ. trans_4d_good_pt
     .      .OR. trans .EQ. trans_bad_pt
     .      .OR. trans .EQ. trans_4d_bad_pt
     .      .OR. trans .EQ. trans_sum
     .      .OR. trans .EQ. trans_4d_sum
     .      .OR. trans .EQ. trans_good_pt
     .      .OR. trans .EQ. trans_4d_good_pt
     .      .OR. trans .EQ. trans_bad_pt
     .      .OR. trans .EQ. trans_4d_bad_pt   ) THEN
	   need_init = .TRUE.
	   init_val = 0.0
	   nbuffer = 2
	ELSEIF ( trans .EQ. trans_variance
     .      .OR. trans .EQ. trans_4d_var
     .	    .OR. trans .EQ. trans_std_dev
     .      .OR. trans .EQ. trans_4d_std ) THEN
	   need_init = .TRUE.
	   init_val = 0.0
	   nbuffer = 3
	ELSEIF ( trans .EQ. trans_max ) THEN
	   need_init = .TRUE.
	   init_val = too_small
	   nbuffer = 2
	ELSEIF ( trans .EQ. trans_min ) THEN
	   need_init = .TRUE.
	   init_val = too_large
	   nbuffer = 2
	ELSE
* all other transformations do not require initialization
*      trans_locate - potentially could, but would need added machinery during
*                     split gather since it is locating a result that lies
*                     *between* two points
	   need_init = .FALSE.
	   init_val = unspecified_val8
	   nbuffer = 1
	ENDIF

	RETURN

	END

      SUBROUTINE CD_SET_ATT_FLAG (dset, varid, attname, iflag, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Set the attribute output flag to iflag (1 or 0)

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP

* V600 12/05 *acm* Attribute control.
* V602  2/07 *acm* Fix bug 1492, changing attributes of coordinate variables 
* V65  *acm* 1/10  Make sure parameters values are consistent with 
*                              whats in netcdf.inc from netcdf4.
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* Argument declarations

      CHARACTER*(*) attname
      INTEGER dset, varid, iflag, status

* Internal declarations

      include 'netcdf.inc'
      include 'tmap_errors.parm'
      include 'xrisc_buff.cmn'

      LOGICAL cv
      INTEGER TM_LENSTR, NCF_SET_ATT_FLAG, NCF_SET_VAR_OUT_FLAG, 
     .        flen, slen, wlen, 
     .        i, vtype, nvdims, nvatts, vdims(8), all_outflag, dset_num
      CHARACTER*128 vname

      PARAMETER (flen=size_rbuff)      ! size of attribute string

#ifdef sun
      BYTE      fhol(flen)      ! c-type Hollerith string buffer
#else
      INTEGER*1 fhol(flen)      ! c-type Hollerith string buffer
#endif 

      dset_num = dset
      IF (dset_num .LT. -2) dset_num = -2

* set output flag for this variable and attribute

      slen = TM_LENSTR( attname )
      IF (slen .GT. 0) THEN
      
         CALL TM_FTOC_STRNG( attname(1:slen), fhol, flen )
         status = NCF_SET_ATT_FLAG( dset_num, varid, fhol, iflag)

         IF (status .LT. 0) GOTO 5300

      ELSE     ! SET ATT/OUT=all or SET ATT/OUT=default

         status = NCF_SET_VAR_OUT_FLAG( dset_num, varid, iflag)

c* set flag for all attributes of this variable
c
c         CALL CD_GET_VAR_INFO (dset, varid, vname, vtype,
c     .                              nvdims, vdims, nvatts, cv, 
c     .                              all_outflag, status)
c         DO 100 i = 1, nvatts
c            CALL CD_GET_VAR_ATT_NAME (dset, varid, i, attname, status )
c
c            slen = TM_LENSTR( attname )
c            CALL TM_FTOC_STRNG( attname(1:slen), fhol, flen )
c         
c            status = NCF_SET_ATT_FLAG( dset, varid, fhol, iflag)
c            IF (status .LT. 0) GOTO 5300
c 100     CONTINUE
      ENDIF

5000  RETURN


! Error message, 
 5300 CALL CD_GET_VAR_INFO (dset, varid, vname, vtype,
     .                              nvdims, vdims, nvatts, cv, 
     .                              all_outflag, status)
      slen = TM_LENSTR( attname )
      wlen = TM_LENSTR( vname )
      risc_buff(1:slen) = attname
      risc_buff(slen+1:slen+14) = ' for variable '
      risc_buff(slen+15:slen+15+wlen) = vname
      CALL TM_ERRMSG (merr_attalready, status, 'CD_SET_ATT_FLAG',
     .           dset_num, no_stepfile, 
     .           risc_buff(1:slen+15+wlen),
     .           no_errstring, *5000)
      END

	SUBROUTINE FVN( 	psi , mpsi ,
     .				vavz, mvavz,
     .				v   , mv,
     .				vfvn, mvfvn )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute meridional flux terms on the uv grid needed in the calculation of
* both W_U ( W on uv grid columns ) and horizontal momentum advection

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 -1/21/87 extracted from SUBROUTINE CLINIC
*			with major modifications to convert i-k oriented
*			calculations to i-j oriented calculations
* V200:  7/27/89 - 4D symmetrical version
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN

#ifdef unix
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl.parm'		! parameter definitions
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xonedim.cmn'	! geometric constants
	include 'xcontext.cmn'
#else
	INCLUDE 'FERRET_CMN:FERRET.PARM'
	INCLUDE 'FERRET_CMN:GFDL.PARM'		! parameter definitions
	INCLUDE	'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE	'FERRET_CMN:XMEM_SUBSC.CMN'
	INCLUDE 'FERRET_CMN:XONEDIM.CMN'	! geometric constants
	INCLUDE 'FERRET_CMN:XCONTEXT.CMN'
#endif

* calling argument declarations:
	INTEGER	mpsi, mvavz, mv, mvfvn

* subscript ranges from memory variable table ...
	REAL     psi( m1lox:m1hix,m1loy:m1hiy,            m1lot:m1hit ),
     .		vavz( m2lox:m2hix,m2loy:m2hiy,            m2lot:m2hit ),
     .		   v( m3lox:m3hix,m3loy:m3hiy,m3loz:m3hiz,m3lot:m3hit ),
     .		vfvn( m4lox:m4hix,m4loy:m4hiy,m4loz:m4hiz,m4lot:m4hit )

* internal variable declarations:
	INTEGER	i_lo, i_hi, j_lo, j_hi, i, j, k, l
	REAL	bad_psi, bad_v, bad_vavz, factor, sfv_1, vfvn_1

* --- end of introductory code ---

* limits for calculation
	i_lo = mr_lo_s1(mvfvn)
	i_hi = mr_hi_s1(mvfvn)
	j_lo = mr_lo_s2(mvfvn)
	j_hi = mr_hi_s2(mvfvn)

* flag for bad/missing data
	bad_psi  = mr_bad_data( mpsi  )
	bad_vavz = mr_bad_data( mvavz )
	bad_v    = mr_bad_data( mv    )

* ***************************************************************
* ORIGINAL GFDL 205 CODE UPON WHICH CALCULATION IS BASED
*
* 105  C   FIND ADVECTIVE COEFFICIENT 'FVN' FOR NORTH FACE OF U,V BOX
* 106  C
* 107        DO 120 I=1,IMT
* 108        SFV(I)=(P(I+1,J+1)-P(I,J+1))*DXUR(I)*CSTR(J+1)*AMIN1(HR(I,J+1),
* 109       1 HR(I,J))
* 110   120  CONTINUE
* 111        FACTOR=DYU2R(J)*CSR(J)*CST(J+1)
* 112        DO 130 K=1,KM
* 113        DO 130 I=1,IMT
* 114        FVN(I,K)=(VP(I,K)+VCLIN(I,K))*0.5
* 115   130  CONTINUE
* 116        DO 135 K=1,KM
* 117        DO 135 I=1,IMT
* 118        FVN(I,K)=(FVN(I,K)+SFV(I))*FACTOR
* 119   135  CONTINUE
********************************************************************
	DO 2000 l = mr_lo_s4(mvfvn), mr_hi_s4(mvfvn)
	DO 2000 k = mr_lo_s3(mvfvn), mr_hi_s3(mvfvn)

C   FIND ADVECTIVE COEFFICIENT 'FUW' FOR WEST FACE OF U,V BOX
	DO 100 j = j_lo, j_hi
	   IF ( j .LT. jm ) factor = dyu2r(j) * csr(j) * cst(j+1)
	DO 100 i = i_lo, i_hi
* ... cant compute derivatives at fringes of full grid
	   IF ( i .EQ. 1 .OR. j .EQ. jm ) THEN
	      vfvn(i,j,k,l) = bad_val4
	      GOTO 100
	   ENDIF

	   IF (  psi(i  ,j+1  ,l) .EQ. bad_psi
     .	    .OR. psi(i+1,j+1  ,l) .EQ. bad_psi
     .	    .OR.   v(i  ,j  ,k,l) .EQ. bad_v
     .	    .OR.   v(i  ,j+1,k,l) .EQ. bad_v
     .	    .OR.vavz(i  ,j    ,l) .EQ. bad_vavz
     .	    .OR.vavz(i  ,j+1  ,l) .EQ. bad_vavz ) THEN

	      vfvn(i,j,k,l) = bad_val4

	   ELSE

	      sfv_1  = (psi(i+1,j+1,l)-psi(i,j+1,l)) * dxur(i) * cstr(j+1) * hr
	      vfvn_1 = ( ( v(i,j+1,k,l) - vavz(i,j+1,l) )
     .		     +   ( v(i,j,k,l  ) - vavz(i,j,l  ) ) ) * 0.5
	      vfvn(i,j,k,l)=( vfvn_1 + sfv_1 ) * factor

	   ENDIF

 100	CONTINUE
 2000	CONTINUE

	RETURN
	END

*
*  scat2grid_nobs_xy.F
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* February 9, 2005 from scat2gridgauss_xy

* Returns # observations in each grid cell when a variable is interpolated 
* onto an equally-spaced X-Y grid.  Input is scattered locations xpts, ypts
* and the desired result grid. Output is # observations in each grid cell 
* when data is gridded in x and y.  Calls routine "nobs" based on Billy
* Kessler's gaussmap-subs.f.
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE  scat2grid_nobs_xy_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CHARACTER*126 buff
      WRITE (buff, 10)
   10 FORMAT ('Count observations when gridding scattered ',
     .        'data to XY grid using Gaussian function')
      CALL ef_set_desc(id, buff)

      CALL ef_set_num_args(id, 4)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, 
     .      NORMAL, NORMAL)

      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 3)

* Output grid is determined by arguments 3 and 4, the result's x and y axes. 

      arg = 1
      CALL ef_set_arg_name(id, arg, 'XPTS')
      CALL ef_set_arg_desc(id, arg, 
     .     'X coordinates of scattered input pairs')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'YPTS')
      CALL ef_set_arg_desc(id, arg, 
     .     'Y coordinates of scattered input pairs')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'XAXPTS')
      CALL ef_set_arg_desc(id, arg, 
     .                   'X axis coordinates of a regular output grid')
      CALL ef_set_axis_influence(id, arg, YES, NO, NO, NO)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'YAXPTS')
      CALL ef_set_arg_desc(id, arg, 
     .                   'Y axis coordinates of a regular output grid')
      CALL ef_set_axis_influence(id, arg, NO, YES, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN 
      END
*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE scat2grid_nobs_xy_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
* 
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_dims(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER nxout, nyout, nx2, ny2
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nxout = 1 + arg_hi_ss(X_AXIS,ARG3) - arg_lo_ss(X_AXIS,ARG3)
      nyout = 1 + arg_hi_ss(Y_AXIS,ARG4) - arg_lo_ss(Y_AXIS,ARG4)

      nx2 = nxout* 2
      ny2 = nyout* 2

* xax  output x axis
      CALL ef_set_work_array_dims (id, 1, 1, 1, 1, 1, nx2, 1, 1, 1)

* yax  output y axis
      CALL ef_set_work_array_dims (id, 2, 1, 1, 1, 1, ny2, 1, 1, 1)

* obs  work array - counts of observations 
      CALL ef_set_work_array_dims (id, 3, 1, 1, 1, 1, 
     .                             nxout, nyout, 1, 1)

      RETURN
      END


*
* In this subroutine we compute the result
*

      SUBROUTINE  scat2grid_nobs_xy_compute(id, arg_1, arg_2, arg_3, 
     .     arg_4, result, xax, yax, obs)

*  arg_1  xpts  \Scattered x,y pairs to be gridded.
*  arg_2  ypts  / 
*  arg_3  xaxis of new grid   
*  arg_4  yaxis of new grid

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id
      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .     mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .     mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .     mem3lot:mem3hit)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz, 
     .     mem4lot:mem4hit)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      INTEGER i, j, k, l, m, n
      INTEGER i1, i2, j1, k1, l1
      INTEGER i3, i3n, j4, j4n

      INTEGER nxpts, nypts, nscat
      INTEGER nx, ny    
      INTEGER i1n, i2n

      REAL x1, y1, xf, yf
      REAL xx, yy

*  Dimension the work arrays

      REAL*8 xax(wrk1lox:wrk1hix/2, wrk1loy:wrk1hiy,
     .               wrk1loz:wrk1hiz, wrk1lot:wrk1hit)
      REAL*8 yax(wrk2lox:wrk2hix/2, wrk2loy:wrk2hiy,
     .               wrk2loz:wrk2hiz, wrk2lot:wrk2hit)
      REAL obs(wrk3lox:wrk3hix, wrk3loy:wrk3hiy,
     .               wrk3loz:wrk3hiz, wrk3lot:wrk3hit)

      CHARACTER*250 errtxt

C  variables for checking axis characteristics (modulo axes)

      CHARACTER ax_name(4)*16, ax_units(4)*16
      LOGICAL backward(4), modulox(4), moduloy(4), regular(4)

      REAL dx, dy, xxbeg, xxend, yybeg, yyend


      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)


*  Check to see if output axes are modulo

      CALL ef_get_axis_info (id, 3, ax_name, ax_units, backward, 
     .                       modulox, regular)
      CALL ef_get_axis_info (id, 4, ax_name, ax_units, backward, 
     .                       moduloy, regular)

*  Find number of points in scattered input points.  1-D arrays defining the 
*  scattered data points may lie on the X, Y, Z, or T axis of the input arguments.

      nxpts = 0
      nypts = 0

      DO 100 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG1) .GE. 1) THEN
            i1 = arg_lo_ss(m,ARG1)
            i1n = arg_hi_ss(m,ARG1)
            if (i1n-i1 .NE. 0) nxpts = 1 + (i1n - i1)
         ENDIF
 100  CONTINUE

      DO 110 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG2) .GE. 1) THEN
            i2 = arg_lo_ss(m,ARG2)
            i2n = arg_hi_ss(m,ARG2)
            if (i2n-i2 .NE. 0) nypts = 1 + (i2n - i2)
         ENDIF
 110  CONTINUE

      IF (nxpts .NE. nypts .OR. nxpts .EQ. 0) GOTO 900

      nscat = nxpts

*  Compute number of points in output axes.

      i3 = arg_lo_ss(X_AXIS,ARG3)
      i3n = arg_hi_ss(X_AXIS,ARG3)

      j4 = arg_lo_ss(Y_AXIS,ARG4)
      j4n = arg_hi_ss(Y_AXIS,ARG4)

      nx = 1 + (i3n - i3)
      ny = 1 + (j4n - j4)

*  Check that xax is a X axis and yax a Y axis

      IF (i3 .EQ. ef_unspecified_int4) THEN
         WRITE (errtxt, *) 'Third argument must be a X axis'
         GO TO 999
      ENDIF
      IF (j4 .EQ. ef_unspecified_int4) THEN
         WRITE (errtxt, *) 'Fourth argument must be a Y axis'
         GO TO 999
      ENDIF

C  Get coordinates of output axes.

      call ef_get_coordinates(id, ARG3, X_AXIS, 
     .   arg_lo_ss(X_AXIS, ARG3), arg_hi_ss(X_AXIS, ARG3), xax)

      call ef_get_coordinates(id, ARG4, Y_AXIS, 
     .   arg_lo_ss(Y_AXIS, ARG4), arg_hi_ss(Y_AXIS, ARG4), yax)

*  Set start, end, and delta for output axes. 

      x1 = xax(1,1,1,1)
      y1 = yax(1,1,1,1)

      xf = xax(nx,1,1,1)
      yf = yax(ny,1,1,1)

*  Gridbox sizes in data units
      dx = xf - x1
      IF (nx .GT. 1) dx = (xf-x1)/ REAL(nx-1)
      dy = yf - y1
      IF (ny .GT. 1) dy = (yf-y1)/ REAL(ny-1) 


*  Compute result

*  Initialize counts.

         DO j = 1, ny
            DO i = 1, nx
               obs(i,j,1,1) = 0.
            ENDDO
         ENDDO

*  Loop over x and y, compute the number of observations for the gaussian-weighted 
*  mapping onto the grid.  Lat and longitude may be on the X,Y,Z or T axis of ARG1 
*  and ARG2, sending them to a subroutine collapses the extra dimensions so the
*  value can be found.

         DO 300 n = 1, nscat

            CALL pickout2 (arg_1, arg_2, n, xx, yy)

*  If an output axis is modulo, apply modulo adjustment to that coordinate
*  of the scattered point.

            IF (modulox(1)) CALL modscat (xax, nx, 1, xx)
            IF (moduloy(2)) CALL modscat (yax, ny, 1, yy)

	    CALL nobs (xx, yy, nx, ny, x1, y1, dx, dy,
     .		       xf, yf, obs)

C ACM modulo 11/9/00  Put points within dx or dy of the end just beyond the
C                     other end, and use in the gridding computation.

            IF (modulox(1)) THEN
               IF ((xx-x1 .GE. 0.) .AND. (xx-x1 .LT. dx) ) THEN
                  xxend = xf + (xx-x1)
                  CALL nobs (xxend, yy, nx, ny, x1, y1, dx, dy,
     .                       xf, yf, obs)
               ENDIF
                     
               IF ((xf-xx .GE. 0.)  .AND. (xf-xx .LT. dx) ) THEN
                  xxbeg = x1 - (xf-xx)
                  CALL nobs (xxbeg, yy, nx, ny, x1, y1, dx, dy,
     .                       xf, yf, obs)
               ENDIF
            ENDIF

            IF (moduloy(2)) THEN
               IF ((yy-y1 .GE. 0.0) .AND.  (yy-y1  .LT. dy) ) THEN
                  yyend = yf + (yy-y1)
                  CALL nobs (xx, yyend, nx, ny, x1, y1, dx, dy,
     .                       xf, yf, obs)
               ENDIF
                     
               IF ((yf-yy .LT. 0.)  .AND.  (yf-yy .LT. dy) ) THEN
                  yybeg = y1 - (yf-yy)
                  CALL nobs (xx, yybeg, nx, ny, x1, y1, dx, dy,
     .		             xf, yf, obs)
               ENDIF
            ENDIF


 300     CONTINUE

*  Put gridded fcn into result variable.

         k = res_lo_ss(Z_AXIS)
         l = res_lo_ss(T_AXIS)

         i1 = 1
         DO 410 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
            j1 = 1
            DO 400 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

               result(i,j,k,l) = obs(i1,j1,1,1)
               j1 = j1 + 1

 400        CONTINUE
            i1 = i1 + 1
 410     CONTINUE

      RETURN

900   CONTINUE

      IF (nxpts .NE. nypts) THEN
         WRITE (errtxt,20) nxpts, nypts
      ELSE IF (nxpts .EQ. 0) THEN
         WRITE (errtxt, 30)
      ENDIF
      GOTO 999 

 999  CALL EF_BAIL_OUT(id, errtxt)
      RETURN


   20 FORMAT ('Input scattered x, y have different # of points', 2I8)

   30 FORMAT ('No data in scattered x, y points')


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      END

      SUBROUTINE CANCEL_WINDOW( status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* delete a window from the display.  If it was currently active then make the
* main window active

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 6/29/88
* V200:	12/20/89 - changed from UIS to Xwindows
*	 3/13/90 - start PPLUS if not already started, check mode_GKS
* V320:  2/28/95 - set a flag for ferret_dispatch so it can keep GUI informed
*		   of window opens/closes
* V400:  6/20/95 - remove changes from 2/28/95 -- state change on windows
*		will be detected by mismatch between wn_open AND 
*		gui_window_reported
* *js* 12.12.97 Don't allow windows to be canceled when running in batch mode
* *kob* 1.29.97 changed "can\'t" to cannot for compiler reasons
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V6.8 *acm* 7/9/2012 For batch graphics on RHEL6, change ITS_BATCH_GRAPHICS
*                     from logical to integer, then batch = ITS_BATCH_GRAPHICS().NE.0

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'
	include 'xgui.cmn'
	include	'pltcom_dat.decl'	! with sizing data, etc.
	include	'PLTCOM.DAT'	! with sizing data, etc.
	include	'gkscm1_inc.decl'	! with gks common
	include	'GKSCM1.INC'	! with gks common
        include 'plt_inc.decl'     ! batmode
        include 'PLT.INC'
	
* calling argument declarations:
	INTEGER		status

* internal variable declarations:
	LOGICAL 	TM_DIGIT
	INTEGER 	n, n_lo, n_hi, lo
	CHARACTER	buffer*24

        INTEGER         ITS_BATCH_GRAPHICS
* local parameter declarations:
	INTEGER		slash_all
	PARAMETER     ( slash_all = 0+1 )

* main window opened yet ?
	CALL START_PPLUS

* windows only from GKS
	IF ( .NOT.mode_gks ) THEN
	   CALL WARN('Windows are only available with GKS output')
	   CALL WARN('See HELP on SET MODE GKS')
	   GOTO 1000
	ENDIF
        
        if (its_batch_graphics() .NE. 0) then
           call warn('Cannot cancel window when in batch mode')
           goto 1000
        endif

* get window numbers to close
	IF ( qual_given( slash_all ) .GT. 0 ) THEN
* ... /ALL
	   n_lo = 1
	   n_hi = max_windows
	
	ELSEIF ( num_args .EQ. 0 ) THEN
* ... CANCEL WINDOW -- what window ?
	   CALL ERRMSG
     .		(ferr_invalid_command,status,'specify window # or /ALL',*5000)

	ELSE
* ... use number given
	   buffer = cmnd_buff(arg_start(1):arg_end(1)) 
	   IF ( .NOT.TM_DIGIT( buffer ) ) GOTO 5020
	   READ ( buffer, *, ERR=5020 ) n
	   n_lo = n
	   n_hi = n
	ENDIF	   

* valid number ?
 60	IF ( n_lo.LT.1 .OR. n_hi.GT.max_windows ) CALL ERRMSG
     .		( ferr_out_of_range, status, 'legal numbers are 2-8', *5000 )

* loop through all requested windows
	DO 100 n = n_lo, n_hi
	   IF ( .NOT.wn_open( n ) ) GOTO 100

* currently active ?
	   IF ( wn_active(n) ) THEN
* ... clear segments from it
	      CALL SET_VIEWPORT( mvp_dflt )
* ... deactivate it
	      CALL GDAWK( n )
	      wn_active( n ) = .FALSE.
* ... activate lowest available window, if any
	      DO 70 lo = 1, max_windows
	         IF ( lo.NE.n  .AND. wn_open(lo) ) THEN
	            CALL GACWK( lo )
	            wn_active( lo ) = .TRUE.
	            wsid = lo
	            GOTO 80
	         ENDIF
 70	      CONTINUE
	      wsid = 0		! no active window, now
	   ENDIF
	      
* close the specified window
 80	   CALL GCLWK( n, batmode )
! old UIS code
!	   CLOSE ( UNIT=n+50, ERR=5010 )
	   wn_open ( n ) = .FALSE.
	   wn_scale( n ) = wn_dflt_scale

* and set flag so that the GUI will be informed when this window is reopened 
!	   gui_window_reported(n) = .FALSE.   ! No - done in ferret_dispatch

 100	CONTINUE

* successful completion
 1000	status = ferr_ok
	RETURN

* error exit(s)
 5000	RETURN
! 5010	CALL ERRMSG(ferr_erreq,status,'closing window',*5000)
 5020	CALL ERRMSG(ferr_invalid_command,status,buffer,*5000)
	END

	SUBROUTINE TM_NEW_LINE_NAME ( suggested_name, new_name )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* If necessary creates a unique line_name based on the suggested name by
* appending a number to the end of the suggested name

* Warning: if new_name is less than 5 characters this routine may STOP
*
* revision 0.00 - 12/12/88
* V510 *sh* 4/00 - shift to dynamic grids -- check dynamic line names
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* Arguments
	CHARACTER*(*)	suggested_name, new_name
*                                           
* Parameters and commons                    
        include 'tmap_dims.parm'
        include 'xtm_grid.cmn_text'  
	external xgt_grid_data

* Local declarations
	REAL		newnum
	INTEGER*4	suglen, outlen, addlen, uselen, ilne 
	INTEGER*4	TM_LENSTR1
	CHARACTER*4	TM_FMT, add_on
*
* initialize
	suglen   = TM_LENSTR1(suggested_name)
	outlen   = LEN( new_name )
	new_name = suggested_name
	newnum   = 0.

* check for an identical name
  10	DO 100 ilne = 1, max_lines
	  IF (line_name(ilne) .EQ. new_name) GOTO 200
  100	CONTINUE

* check among the dynamic lines
	ilne = 0		! to get start of linked list
 110	CALL TM_NEXT_DYN_LINE( ilne, *199)
	   IF (line_name(ilne) .EQ. new_name) GOTO 200
	GOTO 110

* check among the newly-created lines
 199	ilne = 0		! to get start of linked list
 210	CALL TM_NEXT_TMP_LINE( ilne, *299)
	   IF (line_name(ilne) .EQ. new_name) GOTO 200
	GOTO 210

* clean bill of health - no name match
 299	RETURN
*
* yes there's a duplicate - try to "uniqueify" the name
  200	newnum = newnum + 1.
	add_on = TM_FMT(newnum, 4, 4, addlen )
	uselen  = MIN( suglen, outlen-addlen )
	IF ( uselen .LE. 0 ) STOP 'TM_NEW_LINE_NAME'
	new_name = suggested_name(:uselen)//add_on
*
* no danger of an infinite loop unless there are over 9999 names
	GOTO 10
	END

*
* strings.F
*
* Jonathan Callahan
* Feb 19th 1998
*
* This function sets the second argument to be equal
* to the first one.
*


*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* type               The argument is one of ( FLOAT_ARG, STRING_ARG )
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE strings_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,'sets result equal to input' )

      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'this arg is passed through')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE strings_compute(id, arg_1, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

	  INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CHARACTER arg_name*24, arg_title*128, arg_units*32

      CHARACTER ax_name(4)*16, ax_units(4)*16
      LOGICAL backward(4), modulo(4), regular(4)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1

      CALL ef_get_arg_info(id, 1, arg_name, arg_title, arg_units)
      CALL ef_get_axis_info(id, 1, ax_name, ax_units, backward,
     .     modulo, regular)

      WRITE(6,*) arg_name, arg_title, arg_units
      WRITE(6,*) ' axis              units          bkwd mod reg'

      DO 50 i=1, 4
      	WRITE(6,66) ax_name(i), ax_units(i), backward(i), modulo(i),
     .     regular(i)
50    CONTINUE

   66 FORMAT (a16, 2x, a16, 3i4)

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      i1 = arg_lo_ss(X_AXIS,ARG1)
      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               l1 = arg_lo_ss(T_AXIS,ARG1)
               DO 100 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

                  IF ( arg_1(i,j,k,l) .EQ. bad_flag(1) ) THEN

                     result(i,j,k,l) = bad_flag_result

                  ELSE

                     result(i,j,k,l) = arg_1(i,j,k,l)

                  END IF

                  l1 = l1 + arg_incr(T_AXIS,ARG1)
 100           CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 300     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
 400  CONTINUE
      
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	subroutine epicvar
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)epicvar.F	1.1    3/10/88
C**
C**
C***********************************************************************        C**
C**                 EPIC
C**
C***********************************************************************        C**
C**
c
c  Interprets PLOT5 EVAR command, which allows user to select EPIC variables
c  for plotting.
c
c  EVAR ?		Lists variable choices for user.
c  EVAR TIM,T		Selects x=time and y=temperature
c  EVAR			Selects x=time and y=first variable after time/date
c  EVAR STK     \_______
c  EVAR TIM STK /       Selects stick plots vs time
c  EVAR TIM,Cn          Selects x=time and y=variable in column n
c  EVAR TIM,En          Selects x=time and y=variable with EPICKEY
c                       variable code n.
c
c  Called in COMND.
c
c  Programmed by N. Soreide, May 86.
c
#ifdef unix
	include 'CMRD.INC'
	include 'CMRDL.INC'
	include 'TAXIS.INC'
	include 'COMEPV.INC'
	include 'COMEPS.INC'
#else
	include 'pplinc:CMRD.INC'
	include 'pplinc:CMRDL.INC'
	include 'pplinc:TAXIS.INC'
	include 'epicinc:COMEPV.INC'
	include 'epicinc:COMEPS.INC'
#endif
	character ev1*5,ev2*5
c
	itflg=0
	ieflg=1
c
	if (index(label(1:n),'?') .ne. 0) then
c
c  Put out parameter list if parameter1 is ?
c
	    write (5,100)
100	    format (' Pressure        P'/
     1              ' Temperature     T'/
     2              ' Salinity        SAL'/
     3              ' Sigma-T         SIG'/
     4              ' Oxygen          OX'/
     5              ' Conductivity    CO'/
     6              ' U               U'/
     7              ' V               V'/
     8              ' Dynamic Ht      DYN'/
     9              ' Time            TIM'/
     1              ' Stick Plots     STK'/)
c
c  If EVAR and no parameters, then use x=time, y=first variable after time
c
	else if (n .eq. 0) then
	    iepv1=9
	    iepv2=-1
	    if (lsctd) iepv1=-1
c
c  EVAR with parameters
c
	else
	    isp1=index(label(1:n),' ')
	    ico1=index(label(1:n),',')
	    if (isp1.eq.0 .and. ico1.eq.0) then
		write (5,101)
101		format (' EVAR command must have 2 parameters')
		return
	    else if (isp1 .eq. 0) then
		is=ico1
	    else if (ico1 .eq. 0) then
		is=isp1
	    else
		is=min0(isp1,ico1)
	    endif
	    ev1(1:)=label(1:is-1)
	    ev2(1:)=label(is+1:n)
	    call epicv (ev1,iepv1)
	    call epicv (ev2,iepv2)
	endif
c
c  If x-variable is STK, make x=TIM, and y=STK
c
	if (iepv1 .eq. 10) then
	    iepv1=9
	    iepv2=10
	endif
	return
	end

	SUBROUTINE AXIS_INTERVALS(
     .				horiz_or_vert, mr, cx, idim, curvilinear,
     .				axis, lo_ss, hi_ss, lo_world, hi_world,
     .				n_regrid, d_regrid, regrid, irregular )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* convert required points of axis to single precision and determine
* re-gridding needs for non-constant spaced points

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 6/23/87
* revision 0.1 - 2/25/88 - added 2-direction Z-axis option
* revision 0.1 - 9/20/88 - create axis with MAKE_AXIS
* V200:  5/19/89 - reorder lo/hi_ss arguments
*	10/16/89 - eliminated invalid adjustable array subscripts
*        1/28/93 - allow axes of length 1
* V450: 3/97 - support for curvilinear coordinate plots
* V552: 5/03 - If the axis is known to be regular, dont do the test on 
*              whether "regrid" is needed. (this flagged fine axes as
*              irregular when in fact they arent).
* V553: 6/03 - the calculation of d_regrid for regular axes was wrong if 
*              theres a subspan-modulo void point
* v553: 7/03 - The initial d_regrid does need to start with 
*                axis( lo_cx + 1 ) - axis( lo_cx )
*              or it may miss an irregular part of the grid; the calculation
*              should be correct and not hit the subspan-modulo void point,
*              (how to test this???)
* V600  7/05  Fix for bug 900: If the axis is subspan modulo, and if the 
*              region we are using extends beyond the core range of the 
*              axis, then we need to set it to irregular within this routine.
* V600  10/05  change to a comment only, added when fixing bug1347.
* V603   5/07  Fixes for bug 900 and 1487. If the start or end point is the 
*              modulo subspan void point, return the actual first or last axis 
*              point instead.
* V68    4/11  Allow shade, vector plots of degenerate regions - world region 
*              within a grid cell
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V698  *acm* 5/16 Ticket 1845, 2404 fix; adjusting plot-axis ends for subspan 
*		   modulo axes (as in axis_intervals.F for 2D plots).

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
        include 'xtm_grid.cmn_text'  

* calling argument declarations:
	LOGICAL	curvilinear, regrid, irregular
	INTEGER	mr, cx, idim, lo_ss, hi_ss, n_regrid
	REAL 	axis( lo_ss:hi_ss )
	REAL 	lo_world, hi_world, d_regrid
	CHARACTER*1 horiz_or_vert

* internal variable declarations:
	LOGICAL	BKWD_AXIS, TM_ITS_SUBSPAN_MODULO, TM_FPEQ, is_subspan,
     .          void_at_start, void_at_end
	INTEGER	CGRID_AXIS, TM_LENSTR1, lo_cx, hi_cx, grid, i, iaxis,
     .          ilen, ier, ist
        CHARACTER*20 buff

* initialize
	grid   = mr_grid( mr )
	lo_cx = cx_lo_ss( cx, idim )
	hi_cx = cx_hi_ss( cx, idim )

* make a single precision axis corresponding to the subscript range of the
* memory variable (mr)
	IF ( curvilinear ) THEN
* ... axis of index values (other command line args provide true coordinates)
	   DO 100 i = lo_ss, hi_ss
 100	   axis(i) = i
	ELSE
	   CALL MAKE_AXIS( grid, idim, lo_ss, hi_ss, axis(lo_ss) )
	ENDIF

* single point?  Fake up some reasonable values.
        IF ( lo_ss .EQ. hi_ss ) THEN
           d_regrid = 1.
           IF ( axis(lo_cx) .EQ. 0.0 ) THEN
              lo_world = -1.
              hi_world =  1.
           ELSE
              lo_world = axis(lo_cx) * 0.999
              hi_world = axis(lo_cx) * 1.001
	      IF ( TM_FPEQ(lo_world, hi_world) ) THEN 
                 lo_world = axis(lo_cx) * 0.99
                 hi_world = axis(lo_cx) * 1.01
	      ENDIF
           ENDIF
           RETURN
        ENDIF

* determine if regridding is needed within the (cx) region to be plotted
* ... and determine smallest grid interval
	regrid = .FALSE.		! assume it's not needed
        d_regrid = axis( lo_cx + 1 ) - axis( lo_cx )   

        iaxis = CGRID_AXIS(idim,cx)
        is_subspan = TM_ITS_SUBSPAN_MODULO( iaxis  )
        void_at_start = is_subspan .AND. (lo_ss.EQ.0)
        void_at_end  = is_subspan .AND. (hi_ss.EQ.line_dim(iaxis)+1 )

        IF (irregular .OR. is_subspan) THEN
	   DO 200 i = lo_cx+1, hi_cx-1
* ... test within precision limits that may be visible in a plot

	      IF (ABS((axis(i+1)-axis(i))/d_regrid - 1.0) .GT. 3.E-6) THEN
		   d_regrid = MIN( d_regrid, axis(i+1)-axis(i) )
		   regrid = .TRUE.

	      ENDIF
 200	   CONTINUE
	ENDIF

* regridding parameters
       lo_world = axis(lo_cx)
       hi_world = axis(hi_cx)

* If the start or end point is the modulo subspan void point, return
* the actual first or last axis point instead.
 
         IF (is_subspan) THEN
           IF (void_at_start) lo_world = axis(lo_cx+1)
           IF (void_at_end  ) hi_world = axis(hi_cx-1)
         ENDIF
 
        n_regrid = INT( 0.5+((hi_world - lo_world) / d_regrid) ) + 1

* plot vertical z axes upside down ?

	buff = horiz_or_vert//'AXIS_REVERSED 0'
	IF ( horiz_or_vert .EQ. 'Y' .AND. idim .EQ. z_dim ) THEN
	   IF ( BKWD_AXIS(idim, grid) ) THEN
	      lo_world = axis(hi_cx)
	      hi_world = axis(lo_cx)
	      d_regrid = -d_regrid
	      regrid   = .TRUE.
	      buff = horiz_or_vert//'AXIS_REVERSED 1'
	   ENDIF
	ENDIF

* Write out *_REVERSED symbol: 1 if reversed, 0 otherwise
	ilen = TM_LENSTR1(buff)
	ier = 0
	ist = 0
	CALL SETSYM (buff, ilen, ier, ist)

	RETURN
      END

	SUBROUTINE TM_PURGE_TMP_GRIDS( status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* This routine is normally called only for error conditions that occur
* in the midst of building grids and axes for netCDF files.
* The goal is to throw away all of the in-progress work on grids and
* axes, including allocations (use count increments) of axes that came
* from other data sets.

* major re-write 2/2016:
* As it was, this routine could accidentally attempt to remove tmp
*    lines twice by making a call to deallo line and then a call to deallo
*    one or more grids that used that line.
* It became two difficult to keep track of the dependencies when error occured
*    during the definition of aggregate Ferret datasets.
* The new version of this routine simply clears out the tmp lines and axes.
* If any of the tmp grid used axes from pre-existing datasets AND THE USE
* COUNTS FOR THOSE AXES HAD ALREADY BEEN BUMBED BEFORE THIS ROUTINE WAS CALLED
* then this routine could now result in a minor corruption (an axis that will
* never get deleted.)
* Possible corruption risk for legacy GT or MC datasets?
* SHOW GRID/DYNAMIC diagnositcs should reveal the corruption.


* Steve Hankin  NOAA/PMEL/TMAP

* V510 *sh* 3/00
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing
* V697 12/15 *acm* Ticket 2332: deallo lines should not be in a 1:nferdims loop
* V698 2/16 *sh*  major rewrite -- see discussion above
 
* Include files
	include 'tmap_dims.parm'
	include 'tmap_errors.parm'
#include "gt_lib.parm"
        include 'xtm_grid.cmn_text'
        include 'xio.cmn_text'
#include "tmap_dset.parm"

* Argument definitions
	INTEGER status

* Local variable declarations
	INTEGER grid, line, idim

* remove temporary grids
 100	CONTINUE
	   grid = 0	! to get start of list
	   CALL TM_NEXT_TMP_GRID(grid, *300)

	   CALL TM_RM_TMP_GRID(grid)

	GOTO 100

* remove temporary lines
 300	CONTINUE
	   line = 0		! to get start of list
 	   CALL TM_NEXT_TMP_LINE(line, *1000)

	   CALL TM_RM_TMP_LINE(line)

	GOTO 300

* successful completion
 1000	status = merr_ok	! always as of 2/2016
	RETURN

 	END

	SUBROUTINE INIT_EZ_DSET( dset_name, dset, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* initialize a data set of type "EZ" (simple ASCII or unformatted file with
* no attendant descriptor

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200: 10/20/89
*	  2/2/90 - make sure its really an EZ set
*	  2/8/90 - default /VAR is "V1"
*	 3/27/90 - cancel data set (vs warning) if /VAR or /COL is changed
*	  4/2/90 - cancel data set (vs warning) if already_init
* Unix/RISC port - filesystem specific needs - new routine to evaluate path
*                - and longer saved descriptor name
* V3.1      5/94 - added /ORDER= 
* V320  11/94 - *sh* IBM port - need to pass 4 character blank in TM_INQ_PATH
*       11/94 - title needs to be case sensitive
* V420 (V411) 10/95 - for IBM port change "READ(dset_name,*" to use '(I)'
*Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
*	    4/97 *kob* - added ifdef for MANDATORY_FORMAT_WIDTHS on internal
*			 read because linux/nag f90 needed a format width.
* V450 7/97 - Increase array var_list holding dset var names
*      7/98 *js*   Mods to support new /swap and /type qualifiers for stream
*                  datasets
* 3/99 *kob* - nag F90 wants to use eqv for logical expressions
* 5/99 *sh* - added arguments to EQUAL_PERMUTE call
* V510 *sh* 3/00 - increased allowable filename length
*	    4/00 - bump use counts on grids and axes used by this data set
* V530 *sh* 10/00 - added /FORMAT=delimited/TYPE=data_types
* V533 *sh* 7/01 - bug fix: filenames beginning with digits
* V540 *sh* 10/01 - bug fig -- process TMAP error from ez_init_dset
* 2/03 *kob* - g77 port - g77 won't allow intrinsic functions in PARAMETER
*                         statements.  use an octal constant instead 
* v604 *acm* 7/07  increase length of ds_name
* v614 *acm* 11/08 robust fix for bug 287: filenames beginning with digits. 
*                  Check if the filename contains characters other than digits.
* V64  10/09 *acm* longer string length for grid_name
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
*       *acm* 3/12 cleanup old VMS ifdef
* V687  2.14 *acm* fix ticket 2144: Make buffer for list of varnames longer
* V692  7/14 *acm* fix ticket 2182: For ez datasets opened w/o a grid spec, 
*                  count the records and define an axis
* V701  7/16 *acm* Ticket 2454. If the user gives lower-case names when opening
*                  an EZ dataset, keep those names on output, etc.

        IMPLICIT NONE
	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'tmap_errors.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'slash.parm'
	include 'xcontext.cmn'
	include 'xprog_state.cmn'
	include 'xfr_grid.cmn'

* calling argument declarations
	INTEGER		dset, status, i
	CHARACTER	dset_name*(*)

* internal variable declarations:
	INTEGER		nferdimsp1 
	PARAMETER	(nferdimsp1 = nferdims+1)
	LOGICAL		TM_DIGIT, VALID_GRID, its_delimited,
     .			have_mods, already_init, by_number, swap
	LOGICAL         have_type
	INTEGER		TM_LENSTR1, TM_DSET_NUMBER, GRID_FROM_NAME,
     .			tmap_status, loc, skip, grid, columns,
     .			order(nferdimsp1), idim, s1, slen, ndigits, nread,
     .                  ndims, nvars, ngatts, recdim
	CHARACTER	TM_INQ_PATH*2048, TM_FMT*48, var_list*2048,
     .			path_name*2048, ezform*80, title*128, grid_name*64,
     .			type*2048, ctype*16, delim*24, buff*20
	REAL		rval

* local parameter declarations
	CHARACTER*1	tab
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
#else
	PARAMETER     ( tab = CHAR(9))
#endif

* functions
	INTEGER         br_set_type
* initialize
	have_mods = .FALSE.
	swap = .FALSE.
	have_type = .FALSE.

* interpret the data set name or number given
* 3 possibilities:
*   i) dset implied from current default
*  ii) dset given by number
* iii) dset given by name  
	IF ( dset_name .EQ. ' ' ) THEN
	   by_number = .TRUE.
	   already_init = .TRUE.
	   dset = cx_data_set(cx_last)
	   GOTO 200
	ELSEIF ( TM_DIGIT(dset_name) ) THEN
* *kob* 4/97
#ifdef MANDATORY_FORMAT_WIDTHS
	   READ (dset_name,*,ERR=100) dset	! 10/95
#else
	   READ (dset_name,'(I)',ERR=100) dset	! 10/95
#endif

* Is this a dataset name that starts with a number ?
* (some compilers get an error on the above read if
*  dset_namecontains other than digits, some do not.)

	   slen = TM_LENSTR1(dset_name)
	   ndigits = 1
	   IF (dset .GE. 10) ndigits = 2
	   IF (slen .GT. ndigits) THEN
              s1 = ndigits + 1
              DO 80, i = s1,slen
	         IF (.NOT. TM_DIGIT(dset_name(i:i)) ) GOTO 100
  80	      CONTINUE
           ENDIF
	      
	   by_number = .TRUE.
	   already_init = .TRUE.
	   GOTO 200
	ENDIF

* open data set by name
 100	by_number = .FALSE.
#ifdef unix
        path_name = TM_INQ_PATH( dset_name, 'FER_DATA', '    ',
     .                                   .TRUE., TMAP_status )
#else
	path_name = TM_INQ_PATH( dset_name, 'FER_DATA', 'data.dat', .TRUE.,
     .					  TMAP_status )
#endif
	IF ( TMAP_status .EQ. merr_notmounted ) GOTO 5400
	IF ( TMAP_status .NE. merr_ok ) GOTO 5900
	dset = TM_DSET_NUMBER( path_name )
	already_init = dset .NE. unspecified_int4

 200	IF ( by_number ) THEN
	   IF   ( dset .LT. 1
     .	   .OR.   dset .GT. maxdsets
     .	   .OR.   dset .GT. max_gfdl_dsets )		GOTO 5300
	   IF ( ds_name( dset ) .EQ. char_init2048 )	GOTO 5300
	ENDIF

* already initialized ? - cancel it
	IF ( already_init ) THEN
* ... is it an EZ set ?
	   IF ( ds_type(dset) .NE. '  EZ' ) GOTO 5100
	   CALL PURGE_DSET( dset )	! remove memory-resident variables
	   CALL PURGE_ALL_UVARS		! delete (possibly dependent) uvars
* (note: this purge is unnecessarily strict - could be refined in the future)

	   CALL CANCEL_DATA_SET( dset, status )
	
	   IF ( status .NE. ferr_ok ) RETURN
	   already_init = .FALSE.
	ENDIF

* get number of columns if specified
	loc = qual_given( slash_set_data_column )
	IF ( loc .GT. 0 ) THEN
	   CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			   rval, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   columns = INT( rval )
	ELSE
	   columns = int4_init
	ENDIF

* read the file format
        loc = qual_given( slash_set_data_form )
        IF ( loc .GT. 0 ) THEN
           have_mods = .TRUE.
           CALL EQUAL_STRING( cmnd_buff(qual_start(loc):qual_end(loc)),
     .                        ezform, status )
           IF ( status .NE. ferr_ok ) RETURN
	   its_delimited = ezform(1:4) .EQ. 'DELI'
        ELSE
           ezform = char_init16
	   its_delimited = .FALSE.
        ENDIF

* the /TYPE qualifier may refer to either delimited reads or binary reads
* Note: "?TYPE" is overloaded -- used independently for STREAM and
* DELIMITED format reads
        loc = qual_given( slash_set_data_type )
	IF ( loc .EQ. 0 ) THEN
	   IF (its_delimited) THEN
	      type = ' '  ! to be determined in ez_init_dset
	   ELSE
#ifdef double_p
	      type = 'R8'  ! default for stream reads
#else
	      type = 'R4'  ! default for stream reads
#endif
	   ENDIF
	ELSE
	   CALL EQUAL_STRING( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      type, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   IF (.NOT.its_delimited) have_type = .TRUE. ! Joe's binary stream
	ENDIF

* /DELIMIT=
	loc = qual_given( slash_set_data_delimiters )
	IF ( loc .GT. 0 ) THEN
	   IF (.NOT.its_delimited) GOTO 5450
	   CALL EQUAL_DELIMIT(
     .			cmnd_buff(qual_start(loc):qual_end(loc)),
     .			delim, status )
	   IF ( status .NE. ferr_ok ) RETURN
	ELSE
	   delim = tab//','//CHAR(0)  ! NULL terminated
	ENDIF

* get list of variable names: SET DATA/EZ/VAR="..." name 
	loc = qual_given( slash_set_data_var )
	IF ( loc .EQ. 0 ) THEN
	   var_list = ' '
	ELSE
	   CALL EQUAL_STR_LC( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      var_list, status )
	   IF ( status .NE. ferr_ok ) RETURN
	ENDIF

* /SKIP
	loc = qual_given( slash_set_data_skip )
	IF ( loc .GT. 0 ) THEN
	   have_mods = .TRUE.
	   CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			   rval, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   skip = INT( rval )
	ELSE
	   skip = 0  ! was int4_init pre 10/00
	ENDIF

	CALL EZ_INIT_DSET( path_name, ezform, var_list, type, delim,
     .			   skip, columns, dset, tmap_status )
	IF ( tmap_status .NE. merr_ok ) GOTO 5900

* always process any other qualifiers given
	loc = qual_given( slash_set_data_title )
	IF ( loc .GT. 0 ) THEN
	   have_mods = .TRUE.
           CALL EQUAL_STR_LC( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      title, status )
           IF ( status .NE. ferr_ok ) RETURN
	ELSE
	   title = char_init80
	ENDIF
	loc = qual_given( slash_set_data_order )    ! 5/94
	IF ( loc .GT. 0 ) THEN
	   have_mods = .TRUE.
           CALL EQUAL_PERMUTE( cmnd_buff(qual_start(loc):qual_end(loc)),
     .                         .TRUE., .TRUE., .FALSE., order, status )
           IF ( status .NE. ferr_ok ) RETURN
	ELSE
	   DO 500 idim = 1,nferdimsp1
 500	   order(idim) = idim
	ENDIF
	loc = qual_given( slash_set_data_grid )
	IF ( loc .GT. 0 ) THEN
	   have_mods = .TRUE.
           CALL EQUAL_STRING( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      grid_name, status )
           IF ( status .NE. ferr_ok ) RETURN
	   grid = GRID_FROM_NAME( grid_name, cx_last, status )
           IF ( status .NE. ferr_ok ) RETURN
	   IF ( .NOT.VALID_GRID( grid ) ) GOTO 5500
	ELSEIF ( .NOT.already_init ) THEN

* ... insert the default defining grid for STREAM
	   if (ezform(:3) .EQ. 'STR') then
	      have_mods = .TRUE.
	      grid = mgrid_ez_dflt
	   ELSE

* ... For ascii and unformatted sets, get the datset count and define a 
*     basic x axis, not the ez abstract axis
	      CALL EZ_COUNT_DSET ( dset, ezform, nread, status )
              IF ( status .NE. ferr_ok ) RETURN
	      nread = nread - skip

	      IF (columns .GT. 1) THEN
	         CALL CD_GET_DS_INFO (dset, ndims, nvars, ngatts,
     .            recdim, status)
                 nread = nread*columns/nvars
	      ENDIF

	      buff = TM_FMT(DBLE(nread), 0, 12, slen)
	      grid_name = 'X[GX=1:'//buff(:slen)//':1]'
	      grid = GRID_FROM_NAME( grid_name, cx_last, status )
              IF ( status .NE. ferr_ok ) RETURN
	      IF ( .NOT.VALID_GRID( grid ) ) GOTO 5500
	      have_mods = .TRUE.
	   endif
	ELSE
	   grid = int4_init
	ENDIF

c       /swap
	loc = qual_given(slash_set_data_swap)
	if (loc .GT. 0) then
	   swap = .TRUE.
	END IF
	   
	IF ( have_mods ) THEN
	   CALL EZ_MOD_DSET( dset, title, ezform, grid, skip, order,
     .				tmap_status )
	   IF ( tmap_status .NE. merr_ok ) GOTO 5900
	ENDIF

* Make sure no v permutations are defined for non-stream formats,
* and don't allow /swap or /type flags 
	if (ezform(:3) .NE. 'STR') then
	   do i=1,nferdims
	      if (order(i) .eq. nferdimsp1) goto 5700
	   end do
* 3/99 *kob* - nag F90 wants to use eqv for logical expressions
	   if (swap .eqv. .TRUE. .or. have_type .eqv. .TRUE.) then
	      goto 5800
	   end if
	else
	   call toChar(type, ctype)
	   if (BR_SET_TYPE(ctype) .EQ. 0) goto 5600
	   call BR_SET_ATTS(order, swap)
	end if


* bump use counts on grids and axes used by this data set
	CALL TM_DSET_USE_GRIDS( dset )

* successful completion
	status = ferr_ok
	RETURN

* error exits
 5000	RETURN
 5050	CALL ERRMSG( ferr_erreq, status, dset_name, *5000 )
 5100	CALL ERRMSG( ferr_invalid_command, status,
     .		ds_name(dset)(:TM_LENSTR1(ds_name(dset)))//
     .		' is not an EZ data set', *5000 )
 5300	CALL ERRMSG( ferr_unknown_data_set, status,
     .		'invalid data set number for SET DATA/EZ', *5000 )
 5400	CALL ERRMSG( ferr_TMAP_error, status, ' ', *5000 )
 5450	CALL ERRMSG(ferr_invalid_command, status,
     .        '/DELIMIT only allowed for DELIMITED format', 
     .        *5000)
 5500	CALL ERRMSG( ferr_grid_definition, status, grid_name, *5000 )
 5600	call errmsg(ferr_invalid_command, status,
     .        'invalid argument for /TYPE', *5000)
 5700	CALL ERRMSG(ferr_invalid_command, status,
     .        'variable permutations only allowed for STREAM format', 
     .        *5000)
 5800	CALL ERRMSG(ferr_invalid_command, status,
     .        '/SWAP or /TYPE only allowed for STREAM format', 
     .        *5000)
 5900	CALL ERRMSG ( ferr_TMAP_error, status, ' ', *5000 ) 
	END

	SUBROUTINE CD_TRANSLATE_ERROR (cdfstat, ebuff)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Call NF_STRERROR to get the error translation from netCDF library.
* The length of the string is set in netcdf.inc at 512.
*
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files


* include files
        include 'netcdf.inc'
	include 'tmap_errors.parm'

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

c Argument definitions

	INTEGER cdfstat
	CHARACTER*(*) ebuff

c Local declararations
        INTEGER	TM_LENSTR1, STR_SAME, STR_UPCASE, 
     .		dlen, i
	REAL	val
	CHARACTER*512 upstr
	CHARACTER*48 TM_FMT, errcode

        upstr =  NF_STRERROR(cdfstat)

        ebuff = upstr

        upstr = ' '
        errcode = ' '

        i = STR_UPCASE(upstr,ebuff)
        IF (STR_SAME(upstr(1:13), 'UNKNOWN ERROR') .EQ. 0) THEN
           ebuff = 'Unknown error reading from remote dataset '
        ENDIF

        dlen = TM_LENSTR1(ebuff)

        val = cdfstat
        errcode = TM_FMT(val, 0, 10, i)
        ebuff(dlen+2:)  = '(OPeNDAP/netCDF Error code '//
     .                    errcode(1:i)//') '
        dlen = TM_LENSTR1(ebuff)

	RETURN
	END

*
* samplef_date.F
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* This function samples data along the L axis at a set of times: 
* yr,mo,da,hr,min,sec

* 5/20/99  Ansley Manke 
*         Times may be oriented along any axis; 
*         Result is abstract on the sampled axis.
* 3/1/00  ACM fixed bug in definition of the work array datebuf
* 7/2000  ACM inherit axes only from the data variable, not dates!
* 4/2001  *ACM* add error message

*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE samplef_date_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CHARACTER*100 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT 
     .  ('Returns data sampled by interpolating ',
     .   'to a set of times in F direction')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 7)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS,IMPLIED_BY_ARGS, 
     .                                IMPLIED_BY_ARGS, ABSTRACT)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 3)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'DAT_TO_SAMPLE')
      CALL ef_set_arg_desc(id, arg, 'data to sample at set of times in F')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'YR')
      CALL ef_set_arg_desc(id, arg, 'Year(s) yyyy')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'MO')
      CALL ef_set_arg_desc(id, arg, 'Month(s), integer mm')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'DAY')
      CALL ef_set_arg_desc(id, arg, 'Day(s) of month dd')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'HR')
      CALL ef_set_arg_desc(id, arg, 'Hour(s) hh')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 6
      CALL ef_set_arg_name(id, arg, 'MIN')
      CALL ef_set_arg_desc(id, arg, 'Minute(s) mm')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 7
      CALL ef_set_arg_name(id, arg, 'SEC')
      CALL ef_set_arg_desc(id, arg, 'Second(s) ss')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* loss               lo subscript for an axis
*
* hiss               hi subscript for an axis
*

      SUBROUTINE samplef_date_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER my_lo_n, my_hi_n
      INTEGER nx, ny, nz, nt, ne, nf

*     Use utility functions to get context information about the 
*     2nd argument, to set the abstract axis lo and hi indices.

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nx = arg_hi_ss(X_AXIS, ARG2) - arg_lo_ss(X_AXIS, ARG2) + 1
      ny = arg_hi_ss(Y_AXIS, ARG2) - arg_lo_ss(Y_AXIS, ARG2) + 1
      nz = arg_hi_ss(Z_AXIS, ARG2) - arg_lo_ss(Z_AXIS, ARG2) + 1
      nt = arg_hi_ss(T_AXIS, ARG2) - arg_lo_ss(T_AXIS, ARG2) + 1
      ne = arg_hi_ss(T_AXIS, ARG2) - arg_lo_ss(T_AXIS, ARG2) + 1
      nf = arg_hi_ss(T_AXIS, ARG2) - arg_lo_ss(T_AXIS, ARG2) + 1

*  Use the subscripts for ARG2 for the abstract axis limits; could be on any axis

      my_lo_n = 1
      my_hi_n = MAX(nx,ny,nz,nt,ne,nf)
      CALL ef_set_axis_limits(id, F_AXIS, my_lo_n, my_hi_n)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE samplef_date_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
*
* Set the work arrays, X/Y/Z/T/E/F dimensions
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER mfdat, mf20
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

*  Use utility functions to get context information about the 1st
*  argument, to set the work arrays for the input argument time axis..

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      mfdat = arg_hi_ss(F_AXIS, ARG1) - arg_lo_ss(F_AXIS, ARG1) + 1
      mf20 = mfdat* 20	! character*20: character*1 takes 1 byte

*  taxdat (real*8)
      CALL ef_set_work_array_dims_6d(id, 1,
     .                                1, 1, 1, 1, 1, 1,
     .                              mfdat, 1, 1, 1, 1, 1)

*  datebuf (character*20)
      CALL ef_set_work_array_dims_6d(id, 2,
     .                                1, 1, 1, 1, 1, 1,
     .                             mf20, 1, 1, 1, 1, 1)

*  date_axis
      CALL ef_set_work_array_dims_6d(id, 3,
     .           arg_lo_ss(F_AXIS,ARG1), 1, 1, 1, 1, 1,
     .           arg_hi_ss(F_AXIS,ARG1), 1, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE samplef_date_compute(id, arg_1, arg_2, arg_3,
     .                             arg_4, arg_5, arg_6, arg_7, result,
     .                            taxdat, datebuf, date_axis)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz, 
     .           mem4lot:mem4hit, mem4loe:mem4hie, mem4lof:mem4hif)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz, 
     .           mem5lot:mem5hit, mem5loe:mem5hie, mem5lof:mem5hif)
      REAL arg_6(mem6lox:mem6hix, mem6loy:mem6hiy, mem6loz:mem6hiz, 
     .           mem6lot:mem6hit, mem6loe:mem6hie, mem6lof:mem6hif)
      REAL arg_7(mem7lox:mem7hix, mem7loy:mem7hiy, mem7loz:mem7hiz, 
     .           mem7lot:mem7hit, mem7loe:mem7hie, mem7lof:mem7hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

      REAL*8 taxdat(wrk1lox:wrk1hix, wrk1loy:wrk1hiy,
     .              wrk1loz:wrk1hiz, wrk1lot:wrk1hit,
     .              wrk1loe:wrk1hie, wrk1lof:wrk1hif)
      CHARACTER*20 datebuf(wrk2lox:wrk2hix/20, wrk2loy:wrk2hiy,
     .                     wrk2loz:wrk2hiz, wrk2lot:wrk2hit,
     .                     wrk2loe:wrk2hie, wrk2lof:wrk2hif)
      REAL date_axis(wrk3lox:wrk3hix, wrk3loy:wrk3hiy,
     .               wrk3loz:wrk3hiz, wrk3lot:wrk3hit,
     .               wrk3loe:wrk3hie, wrk3lof:wrk3hif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER iarg
      INTEGER i, j, k, l, m, n
      INTEGER arg
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2
      INTEGER i3, j3, k3, l3, m3, n3
      INTEGER i4, j4, k4, l4, m4, n4
      INTEGER i5, j5, k5, l5, m5, n5
      INTEGER i6, j6, k6, l6, m6, n6
      INTEGER i7, j7, k7, l7, m7, n7
      INTEGER mnth, numtimes
      INTEGER nbot, ntop, status
      REAL ayr, amo, ada, ahr, amn, asc
      REAL byr, bmo, bda, bhr, bmn, bsc
      REAL fbot, ftop, timepoint, frac

      CHARACTER*100 errtxt

      CHARACTER*3 months(12), cmon
      DATA months/'JAN', 'FEB', 'MAR', 'APR', 'MAY', 'JUN',
     .            'JUL', 'AUG', 'SEP', 'OCT', 'NOV', 'DEC'/

  20  FORMAT (f2.0, 1x, a3, 1x, f4.0, 3(1x,f2.0))

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      iarg = 1
      CALL ef_get_coordinates (id, ARG1, F_AXIS, 
     .       arg_lo_ss(F_AXIS, ARG1), arg_hi_ss(F_AXIS, ARG1), taxdat)

      numtimes = arg_hi_ss(F_AXIS, ARG1) - arg_lo_ss(F_AXIS, ARG1) + 1
      CALL ef_get_axis_dates (id, ARG1, taxdat, F_AXIS, numtimes, datebuf)

      n1 = arg_lo_ss(F_AXIS,ARG1)
      DO 60 n = 1, numtimes
         READ (datebuf(n,1,1,1,1,1), 20, err=900) bda, cmon, byr,
     .                                            bhr, bmn, bsc
         bmo = 0
         DO 40 mnth = 1, 12
            IF ( cmon .eq. months(mnth) ) bmo = mnth
   40    CONTINUE
         CALL day_of_year(bmo, bda, byr, status, errtxt)
         IF (status .NE. 0) GO TO 1000
         bmn = bmn + bsc/ 60.
         bhr = bhr + bmn/ 60.
         bda = bda + bhr/ 24.
         date_axis(n1,1,1,1,1,1) = byr + bda / 365.2425
         n1 = n1 + arg_incr(F_AXIS,ARG1)
   60 CONTINUE

      n2 = arg_lo_ss(F_AXIS,ARG2)
      n3 = arg_lo_ss(F_AXIS,ARG3)
      n4 = arg_lo_ss(F_AXIS,ARG4)
      n5 = arg_lo_ss(F_AXIS,ARG5)
      n6 = arg_lo_ss(F_AXIS,ARG6)
      n7 = arg_lo_ss(F_AXIS,ARG7)
      DO  600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

*  Get the time to sample, whichever axis of arg_2 thru arg_7 it is on.

         CALL pickindex(arg_2, n, ayr)
         CALL pickindex(arg_3, n, amo)
         CALL pickindex(arg_4, n, ada)
         CALL pickindex(arg_5, n, ahr)
         CALL pickindex(arg_6, n, amn)
         CALL pickindex(arg_7, n, asc)

*  Check that we do have a valid time.

         nbot = 0
         IF (ayr .NE. bad_flag(ARG2) .AND. 
     .       amo .NE. bad_flag(ARG3) .AND. 
     .       ada .NE. bad_flag(ARG4) .AND. 
     .       ahr .NE. bad_flag(ARG5) .AND. 
     .       amn .NE. bad_flag(ARG6) .AND. 
     .       asc .NE. bad_flag(ARG7) ) THEN

            CALL day_of_year(amo, ada, ayr, status, errtxt)
            IF (status .NE. 0) GO TO 1000

            amn = amn + asc/ 60.
            ahr = ahr + amn/ 60.
            ada = ada + ahr/ 24.
            timepoint = ayr + ada / 365.2425

*  Search the 1st argument for the points before and after the requested time,
*  interpolate to set the result.

            DO 80 n1 = arg_lo_ss(F_AXIS,ARG1), arg_hi_ss(F_AXIS,ARG1)
               IF (timepoint .GE. date_axis(n1,1,1,1,1,1)) nbot = n1
   80       CONTINUE
            ntop = nbot + 1

            IF (nbot .GE. arg_lo_ss(F_AXIS,ARG1)  .AND. 
     .          ntop .LE. arg_hi_ss(F_AXIS,ARG1)) THEN

               fbot = date_axis(nbot,1,1,1,1,1)
               ftop = date_axis(ntop,1,1,1,1,1)
               frac = (timepoint - fbot) / (ftop - fbot)
            ENDIF

         ENDIF

*  Loop over all space and interpolate.

         m1 = arg_lo_ss(E_AXIS,ARG1)
         m2 = arg_lo_ss(E_AXIS,ARG2)
         m3 = arg_lo_ss(E_AXIS,ARG3)
         m4 = arg_lo_ss(E_AXIS,ARG4)
         m5 = arg_lo_ss(E_AXIS,ARG5)
         m6 = arg_lo_ss(E_AXIS,ARG6)
         m7 = arg_lo_ss(E_AXIS,ARG7)
         DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

         l1 = arg_lo_ss(T_AXIS,ARG1)
         l2 = arg_lo_ss(T_AXIS,ARG2)
         l3 = arg_lo_ss(T_AXIS,ARG3)
         l4 = arg_lo_ss(T_AXIS,ARG4)
         l5 = arg_lo_ss(T_AXIS,ARG5)
         l6 = arg_lo_ss(T_AXIS,ARG6)
         l7 = arg_lo_ss(T_AXIS,ARG7)
         DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         k1 = arg_lo_ss(Z_AXIS,ARG1)
         k2 = arg_lo_ss(Z_AXIS,ARG2)
         k3 = arg_lo_ss(Z_AXIS,ARG3)
         k4 = arg_lo_ss(Z_AXIS,ARG4)
         k5 = arg_lo_ss(Z_AXIS,ARG5)
         k6 = arg_lo_ss(Z_AXIS,ARG6)
         k7 = arg_lo_ss(Z_AXIS,ARG7)
         DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

            j1 = arg_lo_ss(Y_AXIS,ARG1)
            j2 = arg_lo_ss(Y_AXIS,ARG2)
            j3 = arg_lo_ss(Y_AXIS,ARG3)
            j4 = arg_lo_ss(Y_AXIS,ARG4)
            j5 = arg_lo_ss(Y_AXIS,ARG5)
            j6 = arg_lo_ss(Y_AXIS,ARG6)
            j7 = arg_lo_ss(Y_AXIS,ARG7)
            DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

               i1 = arg_lo_ss(X_AXIS, ARG1)
               i2 = arg_lo_ss(X_AXIS, ARG2)
               i3 = arg_lo_ss(X_AXIS, ARG3)
               i4 = arg_lo_ss(X_AXIS, ARG4)
               i5 = arg_lo_ss(X_AXIS, ARG5)
               i6 = arg_lo_ss(X_AXIS, ARG6)
               i7 = arg_lo_ss(X_AXIS, ARG7)
               DO  100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS) 

                  IF ( nbot .GE. arg_lo_ss(F_AXIS,ARG1) .AND. 
     .                 ntop .LE. arg_hi_ss(F_AXIS,ARG1) ) THEN
                     IF ( arg_1(i1,j1,k1,l1,m1,nbot) 
     .                          .NE. bad_flag(ARG1)     .AND.
     .                    arg_1(i1,j1,k1,l1,m1,ntop)
     .                          .NE. bad_flag(ARG1) )     THEN
                        result(i,j,k,l,m,n) = 
     .                        arg_1(i1,j1,k1,l1,m1,nbot) + 
     .                        frac * ( arg_1(i1,j1,k1,l1,m1,ntop) -
     .                                 arg_1(i1,j1,k1,l1,m1,nbot)  )
                     ELSE
                        result(i,j,k,l,m,n) = bad_flag_result
                     ENDIF
                  ELSE
                     result(i,j,k,l,m,n) = bad_flag_result
                  ENDIF

                  i1 = i1 + arg_incr(X_AXIS,ARG1)
                  i2 = i2 + arg_incr(X_AXIS,ARG2)
                  i3 = i3 + arg_incr(X_AXIS,ARG3)
                  i4 = i4 + arg_incr(X_AXIS,ARG4)
                  i5 = i5 + arg_incr(X_AXIS,ARG5)
                  i6 = i6 + arg_incr(X_AXIS,ARG6)
                  i7 = i7 + arg_incr(X_AXIS,ARG7)
  100          CONTINUE

               j1 = j1 + arg_incr(Y_AXIS,ARG1)
               j2 = j2 + arg_incr(Y_AXIS,ARG2)
               j3 = j3 + arg_incr(Y_AXIS,ARG3)
               j4 = j4 + arg_incr(Y_AXIS,ARG4)
               j5 = j5 + arg_incr(Y_AXIS,ARG5)
               j6 = j6 + arg_incr(Y_AXIS,ARG6)
               j7 = j7 + arg_incr(Y_AXIS,ARG7)
  200       CONTINUE

            k1 = k1 + arg_incr(Z_AXIS,ARG1)
            k2 = k2 + arg_incr(Z_AXIS,ARG2)
            k3 = k3 + arg_incr(Z_AXIS,ARG3)
            k4 = k4 + arg_incr(Z_AXIS,ARG4)
            k5 = k5 + arg_incr(Z_AXIS,ARG5)
            k6 = k6 + arg_incr(Z_AXIS,ARG6)
            k7 = k7 + arg_incr(Z_AXIS,ARG7)
  300    CONTINUE

            l1 = l1 + arg_incr(T_AXIS,ARG1)
            l2 = l2 + arg_incr(T_AXIS,ARG2)
            l3 = l3 + arg_incr(T_AXIS,ARG3)
            l4 = l4 + arg_incr(T_AXIS,ARG4)
            l5 = l5 + arg_incr(T_AXIS,ARG5)
            l6 = l6 + arg_incr(T_AXIS,ARG6)
            l7 = l7 + arg_incr(T_AXIS,ARG7)
  400    CONTINUE

            m1 = m1 + arg_incr(E_AXIS,ARG1)
            m2 = m2 + arg_incr(E_AXIS,ARG2)
            m3 = m3 + arg_incr(E_AXIS,ARG3)
            m4 = m4 + arg_incr(E_AXIS,ARG4)
            m5 = m5 + arg_incr(E_AXIS,ARG5)
            m6 = m6 + arg_incr(E_AXIS,ARG6)
            m7 = m7 + arg_incr(E_AXIS,ARG7)
  500    CONTINUE

* End of loop over all space; go on to next specified time

         n2 = n2 + arg_incr(F_AXIS,ARG2)
         n3 = n3 + arg_incr(F_AXIS,ARG3)
         n4 = n4 + arg_incr(F_AXIS,ARG4)
         n5 = n5 + arg_incr(F_AXIS,ARG5)
         n6 = n6 + arg_incr(F_AXIS,ARG6)
         n7 = n7 + arg_incr(F_AXIS,ARG7)
  600 CONTINUE

      RETURN 

  900 WRITE (errtxt,*) 'error reading date buffer ', 
     .                 n, datebuf(n1,1,1,1,1,1)
 1000 CALL EF_BAIL_OUT(id, errtxt)
      RETURN
      END

        SUBROUTINE DEFINE_E_AGGREGATE_GRID(agg_dset, nvars, vname,
     .     fvar, iline, ref_grid, member_sets, nsets, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Define ensemble axis and grid using that axis.
* For uvars, grid is set to unspecified_int4 when calling this.
* Will defer the grid check for later.

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP 
*
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V695+ 4/15 *acm* and *sh* -- added support for forecast aggregations
* V698 1/16 *sh* - support gappy and inconsistent length forecast members
* V698 3/16 *sh* - shift both lag axes and F-calendar to pts at low cell edge
* V710 *acm* 10/16 Ticket 2422: variables uvar_grid, uvar_data_type, uvar_aux_cat, 
*                  uvar_aux_var to be replaced with calls to LIST routines in NCF_Util.c 
* v71  12/16 *acm* Ticket 2158: working with true monthly time axes.
* v72   6/17 *acm* Variable type in aggregations should match what is in the member files
* v74  10/18 *kms* Split E and F aggregation routines

      IMPLICIT NONE
        include 'tmap_errors.parm'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
        include 'ferret.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xdset_info.cd_equiv'
        include 'xprog_state.cmn'
	include 'xtm_grid.cmn_text'  
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xfr_grid.cmn'
	include 'interp_stack.parm'
	include 'netcdf.inc'

* calling argument declarations:
        INTEGER agg_dset, nvars, fvar, iline, ref_grid,
     .          member_sets(*), nsets, status
        CHARACTER*(*) vname

* local variable declarations:
        LOGICAL ITS_FMRC_2DTIME, found_fvar, ef_ordered_time2d
        INTEGER STR_SAME, TM_LENSTR1,
     .          igrid, idim, agg_grid, nv, type, ii, iset, slen, ndim,
     .          vtype, i, varid, nv_dummy, igrid_dummy, vtype_dummy,
     .          num_indices, ef_time2d_dset, ef_time2d_grid, fvartype

* initialize
	ef_time2d_dset = ds_var_setnum(fvar)

* Get the file-variable type
        slen = TM_LENSTR1(vname)
	varid = 0
        CALL CD_GET_VAR_TYPE (ef_time2d_dset, varid, vname(:slen), 
     .                        fvartype, status)

* the 2D time variable in an E-aggregation of F-aggregations has special needs
* its grid should not have the agg axis 
        ef_ordered_time2d = ITS_FMRC_2DTIME(ef_time2d_dset, fvar)

* Define aggregate grid

      igrid = unspecified_int4
      IF (ref_grid .NE. unspecified_int4) THEN
	 CALL TM_ALLO_TMP_GRID (igrid, status)
         IF (status .NE. ferr_ok) GOTO 5000

         DO 700 idim = 1, nferdims
            grid_line(idim, igrid) = grid_line(idim,ref_grid)
 700     CONTINUE
	 IF (ef_ordered_time2d) THEN
	    ef_time2d_grid = ref_grid  ! grid of fvar (w/out agg axis)
	 ELSE
            grid_line(e_dim, igrid) = iline
	 ENDIF
* Make up a unique grid name for aggregate grid
         grid_name(igrid) = 'GEN'

	 agg_grid = igrid
      ENDIF

* ds_var slot, fill with aggregate variable in aggregate dataset.
      DO 720 nv = 1, maxvars
         IF ( STR_SAME(ds_var_code(nv),char_init) .EQ. 0 ) GOTO 725
 720  CONTINUE
*     No slots available
      CALL ERRMSG(ferr_prog_limit, status, 'too many variables', 5000)

 725	ds_var_setnum(nv)   = agg_dset
	CALL string_array_modify(ds_var_code_head, nv, 
     .         ds_var_code(fvar), LEN(ds_var_code(fvar)))
! ?? better: inherit these attibutes from members in SET_AGG_VAR_ATTS
	ds_var_title(nv)    = ds_var_title(fvar)
	IF ( ds_var_title(nv) .EQ. char_init128) 
     .       ds_var_title(nv)  = ds_var_code(nv)
	ds_var_titl_mod(nv) = ds_var_titl_mod(fvar)
	ds_var_units(nv)    = ds_var_units(fvar)
	ds_missing_flag(nv) = ds_missing_flag(fvar)	! was bad_val4
	ds_bad_flag(nv)     = ds_bad_flag(fvar)		! was bad_val4
	ds_var_type(nv)     = ds_var_type(fvar)
	cd_scale_factor(nv) = 1.
	cd_add_offset(nv)   = 0.
	cd_scaled(nv)       = .FALSE.

	IF (ref_grid .NE. unspecified_int4) THEN
	   ndim = 1
	   DO 730 idim = 1, nferdims
	      ds_grid_start(idim,nv)= ds_grid_start(idim,fvar)
	      ds_grid_end(idim,nv)  = ds_grid_end(idim,fvar)
	      ds_ordering(idim,nv)  = ds_ordering(idim,fvar)
	      IF (ds_ordering(ndim,fvar) .GT. 0) ndim = ndim + 1
 730	   CONTINUE
           ds_grid_start(e_dim,nv) = 1
           ds_grid_end(e_dim,nv) = nsets
           ds_ordering(ndim,nv) = e_dim  ! last dimension of the grid
	   ds_grid_number(nv) = agg_grid
	ENDIF

* Type should be what is in the original file
	IF (ds_var_type(nv) .EQ. ptype_string) THEN
	   type = NCCHAR
	ELSE
	   type = fvartype
	ENDIF

* Hook the aggregated variable into the linked list structures
	CALL CD_ADD_VAR( agg_dset, vname, nvars, 
     .         ds_var_title(nv), ds_var_units(nv), type, 
     .         .FALSE., ds_bad_flag(nv), status)

* Add aggregate-grid info to the lists in aggregate datset and aggregate-grid list.
* Mark user-variables with a grid number of -999.  Note if there is a LET/D variable
* that duplicates the name of a file var it is the file var that gets registered,
* even though the LET/D var has precedence during evaluation.  This allows for the
* possibility that the LET/D var may be cancelled.  But it also allows the possibility
* that the grid of the fvar is unacceptable -- a chance of a crash for a pathological
* dataset.
	dsets: DO ii = 1, nsets
	   iset = member_sets(ii)
* ... special hack for the TF_TIMES 2d time array when it is E-aggregated
	   IF (ef_ordered_time2d) THEN
	      vtype = cat_ef_time2d
	      CALL CD_ADD_AGG_VAR_INFO (agg_dset, vname, ii, vtype, 
     .                ef_time2d_dset, ef_time2d_grid, iline, fvar, status)
	      CYCLE dsets
	   ENDIF
	   found_fvar = .FALSE.
	   IF (iset .NE. pdset_dummy) THEN
* ... add this member data set as an fvar as part of this aggregated variable
	      DO nv = 1, maxvars
	         IF ( (ds_var_setnum(nv) .EQ. iset) .AND. 
     .                (STR_SAME(ds_var_code(nv), vname) .EQ. 0) ) THEN
	            igrid = ds_grid_number(nv)
		    vtype = cat_file_var
	            CALL CD_ADD_AGG_VAR_INFO (agg_dset, vname, ii, vtype, 
     .                iset, igrid, iline, nv, status)
	            found_fvar = .TRUE.
	            EXIT
	         ENDIF
	      ENDDO
	      IF (.NOT.found_fvar) THEN
* ... add this member data set as a LET/D as part of this aggregated variable
* ... optimize search using deleted_list_get_undel
!	         DO nv = 1, max_uvar      ! brute-force equivalent loop
		 CALL deleted_list_get_undel(uvar_num_items_head,
     .                              deleted_list_result(1),
     .                              max_uvar, num_indices )
	         DO i = 1, num_indices
	            nv = deleted_list_result(i)
	            IF ( uvar_num_items(nv) .EQ. uvar_deleted) CYCLE
	            IF ( (uvar_dset(nv) .EQ. iset) .AND. 
     .                   (STR_SAME(uvar_name_code(nv), vname) .EQ. 0) ) THEN
		       vtype = cat_user_var
		       CALL GET_SAVED_UVAR_GRID(nv, iset, igrid)
	               CALL CD_ADD_AGG_VAR_INFO (agg_dset, vname, ii, vtype, 
     .                   iset, igrid, iline, nv, status)
* ... bump the use count for this grid to protect it from being deleted if
*     the user changes the LET/D definition -- grid is needed during the
*     gather process (IS_STRIP & IS_AGGREGATE_GATHER).
*  ==> be sure to un-use (deallo) it when the aggregation gets canceled
*  ==> or if an error occurs prior to the complete initialization of this agg
	               CALL TM_USE_DYN_GRID(igrid)
	               EXIT
	            ENDIF
	         ENDDO
	      ENDIF
	   ELSE
* ... add the dummy data set as a part of this variable 
*     Note that the first member of the agg by common sense cannot be a dummy
	      CALL CD_ADD_AGG_VAR_INFO (agg_dset, vname, ii, vtype_dummy, 
     .             pdset_dummy, igrid_dummy, iline, nv_dummy, status)
	   ENDIF
* ... grab information from the first dataset to reuse with dummy datasets 
	   IF (ii .EQ. 1) THEN
*    ... OK_AS_AGG_VAR guarantees grid is always valid -- even for LET/D vars
              IF (igrid .EQ. unspecified_int4) 
     .           STOP 'DEFINE_E_AGGREGATE_GRID grid err'
	      nv_dummy = nv
	      igrid_dummy = igrid
	      vtype_dummy = cat_file_var
	   ENDIF
	ENDDO dsets

 5000   RETURN
	END

*
*  ave_scat2grid_t.F
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without anx fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and anx derivative works thereof, and
*  its supporting documentation for anx purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in anx publications that result from
*  the use of this software or in anx product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in anx advertising or publicity to endorse or promote anx products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with anx support, consulting,
*  training or assistance of anx kind with regard to the use, operation
*  and performance of this software nor to provide the user with anx
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND Anx EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR Anx SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR Anx DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* Sep 2004

* Inputs are a set of T coordinates and a variable on an abstract axis, and an 
* output time axis. Returns a time series which is the average of the variable, 
* based on the number of points that fall inside of each T cell. 
* From scat2grid_t.F

*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE  ave_scat2grid_t_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CHARACTER*126 buff
      WRITE (buff, 10)
   10 FORMAT (
     . 'Compute average of a variable in each cell of output time axis')
      CALL ef_set_desc(id, buff)

      CALL ef_set_num_args(id, 3)

      CALL ef_set_axis_inheritance(id, NORMAL, NORMAL, NORMAL, 
     .                             IMPLIED_BY_ARGS)

      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      CALL ef_set_num_work_arrays(id, 2)

* output grid is determined by argument 3. 

      arg = 1
      CALL ef_set_arg_name(id, arg, 'TPTS')
      CALL ef_set_arg_desc(id, arg, 
     .     'T coordinates of scattered input time coordinates')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'VPTS')
      CALL ef_set_arg_desc(id, arg, 
     .     'Variable at times in TPTS')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'TAXIS')
      CALL ef_set_arg_desc(id, arg, 
     .     'Output time axis')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, YES)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN 
      END

*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE ave_scat2grid_t_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
* 
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_dims(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER ntout, nt2
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      ntout = 1 + arg_hi_ss(T_AXIS,ARG3) - arg_lo_ss(T_AXIS,ARG3)

      nt2 = (ntout+1)* 2

* tax  output t axis
      CALL ef_set_work_array_dims (id, 1, 1, 1, 1, 1, nt2, 1, 1, 1)

* workspace for computing average; same as result T axis

      CALL ef_set_work_array_dims (id, 2, 
     .      arg_lo_ss(T_AXIS,ARG3), 1, 1, 1, 
     .      arg_hi_ss(T_AXIS,ARG3), 1, 1, 1)

      RETURN
      END

*
* In this subroutine we compute the result
*

      SUBROUTINE ave_scat2grid_t_compute(id, arg_1, arg_2, arg_3,
     .                               result, tax, counts)

*  arg_1  tpts  Scattered t values to be gridded.
*  arg_2  taxis to use for output

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id
      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .     mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .     mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .     mem3lot:mem3hit)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      INTEGER i, j, k, l, m, n
      INTEGER i1, i1n, i3, i3n, ntgrid
      INTEGER ntpts, nvpts
      REAL tt, vv
      CHARACTER*250 errtxt
      REAL factr

*  variables for checking axis characteristics (modulo axes)

      CHARACTER ax_name(4)*16, ax_units(4)*16
      LOGICAL backward(4), modulot(4), regular(4)

*  Dimension the work arrays

      REAL*8 tax(wrk1lox:wrk1hix/2, wrk1loy:wrk1hiy,
     .               wrk1loz:wrk1hiz, wrk1lot:wrk1hit)
      REAL counts(wrk2lox:wrk2hix, wrk2loy:wrk2hiy,
     .               wrk2loz:wrk2hiz, wrk2lot:wrk2hit)

      REAL*8 top_box

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*  Check to see if output axis is modulo

      CALL ef_get_axis_info (id, 3, ax_name, ax_units, backward, 
     .                       modulot, regular)

*  Find number of points in scattered input points.  1-D arrays defining the 
*  scattered data points may lie on the X, Y, Z, or T axis of the input argument

      ntpts = 0

      DO 100 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG1) .GE. 1) THEN
            i1 = arg_lo_ss(m,ARG1)
            i1n = arg_hi_ss(m,ARG1)
            if (i1n-i1 .NE. 0) ntpts = 1 + (i1n - i1)
         ENDIF
 100  CONTINUE

* Check that arguments 1 and 2 have the same number of values

      nvpts = 0

      DO 200 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG2) .GE. 1) THEN
            i1 = arg_lo_ss(m,ARG2)
            i1n = arg_hi_ss(m,ARG2)
            if (i1n-i1 .NE. 0) nvpts = 1 + (i1n - i1)
         ENDIF
 200  CONTINUE

      IF (ntpts .EQ. 0) GOTO 900
      IF (nvpts .NE. ntpts) THEN
        errtxt = 'arguments 1 and 2 must have the same number of values'
        GOTO 900
      ENDIF

*  Check tax is a T axis

      i3 = arg_lo_ss(T_AXIS,ARG3)
      i3n = arg_hi_ss(T_AXIS,ARG3)
      ntgrid = i3n - i3 + 1

      IF (i3 .EQ. ef_unspecified_int4) THEN
         WRITE (errtxt, *) 'Third argument must be a T axis'
         GO TO 999
      ENDIF

*  Get coordinates of output axis.

      call ef_get_coordinates(id, ARG3, T_AXIS, 
     .   arg_lo_ss(T_AXIS, ARG3), arg_hi_ss(T_AXIS, ARG3), tax)

*  Get cell boundaries

      CALL ef_get_box_lo_lim (id, ARG3, T_AXIS, 
     .   arg_lo_ss(T_AXIS, ARG3), arg_hi_ss(T_AXIS, ARG3), tax)

      CALL ef_get_box_hi_lim (id, ARG3, T_AXIS,
     .   arg_hi_ss(T_AXIS, ARG3), arg_hi_ss(T_AXIS, ARG3), top_box)

      L = res_hi_ss(T_AXIS)+1
      tax(L,1,1,1) = top_box

*  Compute result

*  Initialize counts

      i = res_lo_ss(X_AXIS)
      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      DO 300 L = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         result(i,j,k,l)= 0.
         counts(L,1,1,1)= 0.
 300  CONTINUE

*  Loop over input tpts

      L = res_lo_ss(T_AXIS)

      DO 500 n = 1, ntpts

        CALL pickout (arg_1, n, tt)
        CALL pickout (arg_2, n, vv)

*  If an output axis is modulo, apply modulo adjustment to that coordinate
*  of the scattered point.

        IF (modulot(4)) CALL modscat (tax, ntgrid, 1, tt)

        IF ( tt .NE. bad_flag(ARG3) .AND. 
     .       vv .NE. bad_flag(ARG2) ) THEN
           DO 400 L = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS) 
              IF (n .EQ. 1 .AND. tt .EQ. tax(L,1,1,1) ) THEN
                 result(i,j,k,l) = result(i,j,k,l) + vv
                 counts(L,1,1,1) = counts(L,1,1,1) + 1
              ELSE IF (tt .GT. tax(L,1,1,1) .AND. 
     .                 tt .LE. tax(L+1,1,1,1) ) THEN
                result(i,j,k,l) = result(i,j,k,l) + vv
                counts(L,1,1,1) = counts(L,1,1,1) + 1
              ENDIF
  400      CONTINUE

         ENDIF

 500  CONTINUE

* Compute average

      DO 600 L = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS) 
         IF (counts(L,1,1,1) .GT. 0.) THEN
           result(i,j,k,l) = result(i,j,k,l)/ counts(L,1,1,1)
         ELSE
           result(i,j,k,l) = bad_flag_result
         ENDIF
 600  CONTINUE

      RETURN

900   CONTINUE


 999  CALL EF_BAIL_OUT(id, errtxt)
      RETURN


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      END

      SUBROUTINE pickout (atim, n, val)


*  ACM 5/2003
*  Called from the ave_scat2grid_t function.
*  Pick out nth item from atim, which is really 4-D 
*  with normal axes on three of the four axes.

      REAL atim(*)
      REAL val
      INTEGER n

      val = atim(n)

      RETURN
      END

	LOGICAL FUNCTION CD_GET_ATTVAL_L ( dset, varid, attrib,
     .                                     do_warn, vname, val )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* This routine is like cd_attvalc except it checks for a yes-or-no result.
* It can return only a single value, of type LOGICAL.

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* 12/02  *acm*
* V550 *acm* 1/03 - Check for value of attribute " ", return TRUE if so.
* 
* 1/03 - *kob* g77 port - need to use risc_buff and also local var 
*                         tmp_buff for arbitrary  string concats 
* V600 *ACM* attribute control. 
* V602 *acm* make sure lena=length of attr name is defined before writing warning
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 2/10- all warnings and notes to std error not std out

*             Replace NCAINQ with CD_GET_VAR_ATT_INFO
*             Change call to CD_GET_ATTRIB to NC_GET_ATTRIB - get attrib from 
*               linked list structure
*             CD_GET_ATTVAL replaced by NC_GET_ATTRIB, which now returns  
*               strings or real values according to attrib type
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* argument definitions:
*	dset	 - dataset number for already opened CDF file
*       varid    - variable id in netCDF file
*       attrib   - attribute to search for
*	do_warn	 - logical flag to issue warning if invalid attribute
*       vname    - name of variable owning attribute (used in error msgs)
*       val      - logical result, if modulo = "T" or "NO", etc was set.

* argument declarations
      LOGICAL       do_warn
      INTEGER	    dset, varid
      CHARACTER*(*) attrib, vname
      LOGICAL       val

      include 'xio.cmn_text'
      external xio_data
      include 'netcdf.inc'
      include 'xrisc_buff.cmn'         !1/03 *kob*
      include 'tmap_errors.parm'

* internal variable declarations:
      LOGICAL NC_GET_ATTRIB
      INTEGER TM_LENSTR1, lena, attype, attlen, attoutflag,
     .        attid, status
      REAL tmp
      CHARACTER buff*132, upbuff*132, aname*128
      CHARACTER tmp_buff*2048          !1/03 *kob*	

* inquire about the attribute by name and id

      CALL CD_GET_VAR_ATT_ID (dset, varid, attrib, attid, status)
      IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, varid, attid,
     .                  aname, attype, attlen, attoutflag, status )

      lena = TM_LENSTR1( aname )

      IF ( status .EQ. merr_ok ) THEN

	IF (attype .EQ. NF_CHAR) THEN

* get a text attribute

	   CD_GET_ATTVAL_L = NC_GET_ATTRIB(dset, varid, aname(:lena),
     .                            do_warn, vname, 132, attlen,
     .                            attoutflag, buff, tmp)

	   IF (.NOT.CD_GET_ATTVAL_L) THEN
	     RETURN

	   ELSE

             CALL STR_UPCASE (upbuff, buff)	     

             IF ( upbuff .EQ. 'Y' .OR. upbuff .EQ. 'YES' .OR.
     .            upbuff .EQ. 'T' .OR. upbuff .EQ. 'TRUE' .OR.
     .            upbuff .EQ. 'ON' .OR. upbuff .EQ. ' ') THEN
	       CD_GET_ATTVAL_L = .TRUE.
               val = .TRUE.

             ELSE IF ( upbuff .EQ. 'N' .OR. upbuff .EQ. 'NO' .OR.
     .                 upbuff .EQ. 'F' .OR. upbuff .EQ. 'FALSE'.OR.
     .                 upbuff .EQ. 'OFF' ) THEN
	       CD_GET_ATTVAL_L = .TRUE.
               val = .FALSE.

             ELSE
               GOTO 5000

             ENDIF
           ENDIF

	 ELSE  ! not a char type

	   CD_GET_ATTVAL_L = .FALSE.
	 ENDIF

      ELSE ! no attribute found

	 CD_GET_ATTVAL_L = .FALSE.
      ENDIF

      RETURN

* error exit
 5000 CONTINUE
 
* *kob* 1/03 - add risc_buff - needed for g77 port
      IF (do_warn) THEN
        lena = TM_LENSTR1( attrib )
	risc_buff = attrib(:lena)
	tmp_buff = vname
	CALL WARN('Undecipherable value of netCDF attribute '//
     .        risc_buff(:TM_LENSTR1(risc_buff))//' on variable '//
     .        tmp_buff)
        CALL WARN('modulo = "'//buff(:TM_LENSTR1(buff))//'"')

      ENDIF

      CD_GET_ATTVAL_L = .FALSE.

      RETURN
      END

* 
*  expndi_by.F
* 
*  Steve Hankin
*  1/16/2001
* 
*  Expand argument 1 by inserting a gap before each valid point in 
* argument 2 along axis I
*  Argument 2 may be multidimensional
 
*  In this subroutine we provide information about
*  the function.  The user configurable information 
*  consists of the following:
* 
*  descr              Text description of the function
* 
*  num_args           Required number of arguments
* 
*  axis_inheritance   Type of axis for the result
*                        ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                        CUSTOM          - user defined axis
*                        IMPLIED_BY_ARGS - same axis as the incoming argument
*                        NORMAL          - the result is normal to this axis
*                        ABSTRACT        - an axis which only has index values
* 
*  piecemeal_ok       For memory optimization:
*                        axes where calculation may be performed piecemeal
*                        ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE expndi_by_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .       'Expand arg1 by inserting gaps before valid pts of arg 2' )

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, ABSTRACT, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'dat')
      CALL ef_set_arg_desc(id, arg, 'variable to gap-expand on I axis')
      CALL ef_set_axis_influence(id, arg, NO, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'mask')
      CALL ef_set_arg_desc(id, arg,
     .          'valid/bad points guiding gap insertions (multi-D)')
      CALL ef_set_axis_influence(id, arg, NO, YES, YES, YES)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'outsize')
      CALL ef_set_arg_desc(id, arg,
     .          'I size of result (constant)')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END






*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE expndi_by_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      REAL size

*
*     Use utility functions to get context information about the arguments.
*

      CALL ef_get_one_val(id, ARG3, size)

      CALL ef_set_axis_limits(id, X_AXIS, 1, INT(ABS(size)))
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END



* 
*  In this subroutine we compute the result
* 
      SUBROUTINE expndi_by_compute(id, arg_1, arg_2, arg_3, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy,
     .	   mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy,
     .     mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy,
     .     mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1
      INTEGER i2, j2, k2, l2
      INTEGER imax

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      imax = res_hi_ss(X_AXIS)

* pre-fill the entire output result with missing value flags
*  (since each I-sequence in mask may have different number of valid pts)
      DO 40 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         DO 30 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            DO 20 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
               DO 10 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
 10            result(i,j,k,l) = bad_flag_result
 20         CONTINUE
 30      CONTINUE
 40   CONTINUE

* fill in the points as specified by the mask
      l1 = arg_lo_ss(T_AXIS,ARG1)
      l2 = arg_lo_ss(T_AXIS,ARG2)
      DO 400 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         j2 = arg_lo_ss(Y_AXIS,ARG2)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            k2 = arg_lo_ss(Z_AXIS,ARG2)
            DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               i1 = arg_lo_ss(X_AXIS,ARG1)
               i2 = res_lo_ss(X_AXIS)
               DO 100 i=arg_lo_ss(X_AXIS,ARG2),arg_hi_ss(X_AXIS,ARG2)

                  IF ( arg_2(i,j2,k2,l2) .NE. bad_flag(2) ) THEN
                     IF (i2 .GT. imax) CALL EF_BAIL_OUT(id,
     .                  'Arg 3 size too small')
                     result(i2,j,k,l) = bad_flag_result  ! insert a gap
                     i2 = i2 + 1
                  ENDIF
                  IF (i2 .GT. imax) CALL EF_BAIL_OUT(id,
     .                'Arg 3 size too small')
                  result(i2,j,k,l) = arg_1(i1,j1,k1,l1) 

                  i1 = i1 + arg_incr(X_AXIS,ARG1)
                  i2 = i2 + 1
 100           CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
               k2 = k2 + arg_incr(Z_AXIS,ARG2)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
            j2 = j2 + arg_incr(Y_AXIS,ARG2)
 300     CONTINUE

         l1 = l1 + arg_incr(T_AXIS,ARG1)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
 400  CONTINUE
      
         
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*           rr_adv_vz.F
*
*           Rick Romea
*           March 16, 2000	     
*
*     Meridional nonlinear advective term:  -w dv/dz
*     Units :     cm/s/s
*     MOM2 Grid:  U   
*
*******************************************************************

      SUBROUTINE RR_adv_vz_init(id)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

      CALL ef_set_desc             (id,
     .'-w(dv/dz) nonlinear advective momentum term(cm/s^2);MOM2 U Grid')
      CALL ef_set_num_args         (id, 3)
      CALL ef_set_axis_inheritance (id, IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok     (id, NO, NO, NO, NO)

      ! Define first argument (V)

      CALL ef_set_arg_name         (id, ARG1, 'V')
      CALL ef_set_arg_desc         (id, ARG1,
     . 'Meridional velocity, on the MOM2 U Grid. ')
      CALL ef_set_arg_unit         (id, ARG1, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG1, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG1, YES, YES, YES, YES)
      CALL ef_set_axis_extend      (id, ARG1, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG1, Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG1, Z_AXIS,0,+1)

      ! Define second argument (W)

      CALL ef_set_arg_name         (id, ARG2, 'W')
      CALL ef_set_arg_desc         (id, ARG2,
     . 'Vertical velocity, at T cell bottom on the MOM2 Grid. ')
      CALL ef_set_arg_unit         (id, ARG2, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG2, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2, NO, NO, NO, YES)
      CALL ef_set_axis_extend      (id, ARG2, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG2, Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG2, Z_AXIS,0,+1)

      ! Define third argument (TEMP)

      CALL ef_set_arg_name         (id, ARG3, 'TEMP')
      CALL ef_set_arg_desc         (id, ARG3,
     . 'Potential temperature, required to access MOM2 T Grid. ')
      CALL ef_set_arg_unit         (id, ARG3, 'deg-C')
      CALL ef_set_arg_type         (id, ARG3, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG3, NO, NO, YES, YES)
      CALL ef_set_axis_extend      (id, ARG3, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG3, Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG3, Z_AXIS,0,+1)

      END




      SUBROUTINE RR_adv_vz_compute(id, arg_1, arg_2, arg_3, result)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER        id

      REAL           bad_flag(EF_MAX_ARGS)
      REAL           bad_flag_result
      REAL           arg_1 (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .                      mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL           arg_2 (mem2lox:mem2hix, mem2loy:mem2hiy, 
     .                      mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL           arg_3 (mem3lox:mem3hix, mem3loy:mem3hiy, 
     .                      mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL           result (memreslox:memreshix,memresloy:memreshiy,
     .                       memresloz:memreshiz,memreslot:memreshit)

      INTEGER        res_lo_ss (4)
      INTEGER        res_hi_ss (4)
      INTEGER        res_incr  (4)

      INTEGER        arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER        arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER        arg_incr  (4,EF_MAX_ARGS)

      INTEGER        i,  j,  k,  l
      INTEGER        i1, j1, k1, l1
      INTEGER        i2, j2, k2, l2

      REAL*8         yU(1024)
      REAL*8         xU(1024)
      REAL*8         zW(1024)
      REAL*8         yT(1024)
      REAL*8         xT(1024)

      INTEGER        ilat
      INTEGER        ilon
      INTEGER        iZ

      CHARACTER*16   ax_name(4)
      CHARACTER*16   ax_units(4)
      LOGICAL        backward(4)
      LOGICAL        modulo(4)
      LOGICAL        regular(4)

      REAL           dxu, dyu
      REAL           dus, dun, duw, due
      REAL           adv_fb, adv_vbu
      REAL           csu, cst
	
      INCLUDE 'rr_parameters.h'

C*********************************************************************
C
c     dzt     = vertical height of "u,v" or "t" grid box (in cm)
c     dxu     = longitudinal width of "u,v" grid box at the equator (cm) 
c     dyu     = latitudinal height of "u,v" grid box (cm)
C
c     dus     = yu(j) - yt(j)
c     dun     = yt(j+1) - yu(j)
c     duw     = xu(i) - xt(i)
c     due     = xt(i+1) - xu(i)
C
c     yu(j)   = latitude of the jth "u,v" point in degrees 
c     yt(j)   = latitude of the jth "t" point in degrees   
c     xt(i)   = longitude of the ith "t" point in degrees  
c     xu(i)   = longitude of the ith "u,v" point in degrees
C 
C*********************************************************************

      dxu(i) = SNGL (xT(i+1) - xT(i))   * Longitude_to_cm
      dyu(j) = SNGL (yT(j+1) - yT(j))   * Latitude_to_cm
      dus(j) = SNGL (yU(j)   - yT(j))   * Latitude_to_cm
      dun(j) = SNGL (yT(j+1) - yU(j))   * Latitude_to_cm
      duw(i) = SNGL (xU(i)   - xT(i))   * Longitude_to_cm
      due(i) = SNGL (xT(i+1) - xU(i))   * Longitude_to_cm

      cst(j) = cos(SNGL(yT(j)) * Degrees_to_radians) 
      csu(j) = cos(SNGL(yU(j)) * Degrees_to_radians) 

      adv_vbu(i,j,k,l,iLat,iLon) =
     . ( arg_2(i,  j,  k,l) * dus(iLat) * duw(iLon) * cst(iLat)
     . + arg_2(i+1,j,  k,l) * dus(iLat) * due(iLon) * cst(iLat) 
     . + arg_2(i,  j+1,k,l) * dun(iLat) * duw(iLon) * cst(iLat+1)
     . + arg_2(i+1,j+1,k,l) * dun(iLat) * due(iLon) * cst(iLat+1)
     .                   ) / dyu(iLat) / dxu(iLon) / csu(iLat)

      adv_fb(i1,j1,k1,l1,i2,j2,k2,l2, iLat,iLon) = 
     .       	         adv_vbu(i2,j2,k2,l2,iLat,iLon)
     .                  * (arg_1(i1,j1,k1,l1) + arg_1(i1,j1,k1+1,l1))

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags      (id, bad_flag,  bad_flag_result)
      CALL ef_get_coordinates    (id, ARG1, X_AXIS, 
     .                            arg_lo_ss(X_AXIS,ARG1),
     .                            arg_hi_ss(X_AXIS,ARG1), xU)
      CALL ef_get_coordinates    (id, ARG1, Y_AXIS, 
     .                            arg_lo_ss(Y_AXIS,ARG1),
     .                            arg_hi_ss(Y_AXIS,ARG1), yU)
      CALL ef_get_coordinates    (id, ARG2, Z_AXIS, 
     .                            arg_lo_ss(Z_AXIS,ARG2),
     .                            arg_hi_ss(Z_AXIS,ARG2), zW)
      CALL ef_get_coordinates    (id, ARG3, X_AXIS, 
     .                            arg_lo_ss(X_AXIS,ARG3),
     .                            arg_hi_ss(X_AXIS,ARG3), xT)
      CALL ef_get_coordinates    (id, ARG3, Y_AXIS, 
     .                            arg_lo_ss(Y_AXIS,ARG3),
     .                            arg_hi_ss(Y_AXIS,ARG3), yT)
      CALL ef_get_axis_info  (id, ARG1, ax_name, ax_units, 
     .                                backward, modulo, regular) 
      IF     ( ax_units(1) .NE. 'deg'       .AND.
     .         ax_units(1) .NE. 'lon'       .AND.
     .         ax_units(1) .NE. 'degrees_E' .AND.
     .         ax_units(1) .NE. 'longitude' .AND.
     .         ax_units(1) .NE. 'Longitude' .AND. 
     .         ax_units(1) .NE. 'LONGITUDE' ) THEN
        WRITE (6,*)'Longitude axis units =', ax_units(1) 
        ! CALL ef_bail_out(id,'Longitude axis must be in degrees')
      ENDIF

      IF     ( ax_units(2) .NE. 'deg'       .AND.
     .         ax_units(2) .NE. 'lat'       .AND.
     .         ax_units(2) .NE. 'degrees_N' .AND.
     .         ax_units(2) .NE. 'latitude'  .AND.
     .         ax_units(2) .NE. 'Latitude'  .AND. 
     .         ax_units(2) .NE. 'LATITUDE' ) THEN
        WRITE (6,*)'Latitude axis units =', ax_units(2) 
        ! CALL ef_bail_out(id,'Latitude axis must be in degrees')
      ENDIF
      CALL ef_get_axis_info  (id, ARG1, ax_name, ax_units, 
     .                                backward, modulo, regular) 
      IF     ( ax_units(3) .NE. 'm'           .AND.
     .         ax_units(3) .NE. 'meters'  .AND.
     .         ax_units(3) .NE. 'M'           .AND.
     .         ax_units(3) .NE. 'METERS' ) THEN
        WRITE (6,*)'Longitude axis units =', ax_units(1) 
        ! CALL ef_bail_out(id,'Z axis must be in meters')
      ENDIF 


      l1 = arg_lo_ss(T_AXIS,ARG1) 
      l2 = arg_lo_ss(T_AXIS,ARG2) 
      DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         ilat = 2  
         j1 = arg_lo_ss(Y_AXIS,ARG1) + 1
         j2 = arg_lo_ss(Y_AXIS,ARG2) + 1
         DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
         
            iLon = 2
            i1 = arg_lo_ss(X_AXIS,ARG1) + 1
            i2 = arg_lo_ss(X_AXIS,ARG2) + 1
            DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

               iZ = 1
	       k1 = arg_lo_ss(Z_AXIS,ARG1)
	       k2 = arg_lo_ss(Z_AXIS,ARG2)
               DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

                  IF (arg_1(i1,  j1,  k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1+1,j1,  k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1-1,j1,  k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1,  j1+1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1+1,j1+1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1-1,j1+1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1,  j1-1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1+1,j1-1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1-1,j1-1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_2(i2,  j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2,  j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2,  j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2-1,k2,l2) .EQ. bad_flag(ARG2)) THEN
                     result(i,j,k,l) = bad_flag_result
                  ELSE
                     IF (k1 .EQ. 1) THEN
  		         result(i,j,k,l) = ( 
     .                        adv_fb(i1,j1,k1,l1,
     .                               i2,j2,k2,l2, iLat,iLon) 
     .                             / 2.
     .                   - arg_1(i1,j1,k1,l1) *
     .                     adv_vbu(i2,j2,k2,l2,iLat,iLon)
     .                        ) /  (zW(iZ)*Meters_to_cm)
     .                         * sec_per_month
	               ELSE
			 result(i,j,k,l) = (
     .                     - ( adv_fb(i1,j1,k1-1,l1,
     .                                i2,j2,k2-1,l2,iLat,iLon)
     .                       - adv_fb(i1,j1,k1,  l1,
     .                                i2,j2,k2,  l2, iLat,iLon) )
     .                             / 2. 
     .                   + arg_1(i1,j1,k1,l1) *
     .                     ( adv_vbu(i2,j2,k2-1,l2,iLat,iLon)
     .                      - adv_vbu(i2,j2,k2,l2,iLat,iLon) )
     .                        ) / (zW(iZ-1)-zW(iZ))/Meters_to_cm 
     .                               * sec_per_month
                     ENDIF
                  ENDIF

	            iZ = iZ + 1
                  k1 = k1 + arg_incr(Z_AXIS,ARG1)
                  k2 = k2 + arg_incr(Z_AXIS,ARG2)
               ENDDO

               iLon = iLon + 1
               i1 = i1 + arg_incr(X_AXIS,ARG1)
               i2 = i2 + arg_incr(X_AXIS,ARG2)
            ENDDO

            iLat = iLat + 1
            j1 = j1 + arg_incr(Y_AXIS,ARG1)
            j2 = j2 + arg_incr(Y_AXIS,ARG2)
         ENDDO

         l1 = l1 + arg_incr(T_AXIS,ARG1)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
      ENDDO               
      END

	SUBROUTINE TRANSLATE_TO_WORLD ( val, idim, grid, ndec, string )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* convert a coordinate value to a string using appropriate lat/long/depth/time
* format.  String will be left justified within the given field width.  Number
* of decimal places of precision is specified by the argument ndec

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* revision 0.0 - 7/17/86
* revision 0.1 - 7/14/87 - allowed field widths of 3 digits
* revision 1.0 - 2/25/88 - added option for non-fancy coordinates
* revision 2.0 -  4/1/88 - incorporated time/date strings and FIELD_WIDTH
*			   and ndec<0 indicating to use significant
*			   digits instead of decimal places
* revision 2.1 - 4/13/88 - added MOD calculation to longitude
* revision 2.2 - 1/12/89 - declate TM_SECS_TO_DATE exactly *20
* revision 2.3 - 2/16/89 - TM_SECS_TO_DATE --> SECS_TO_DATE
* V200:  1/10/89 - kludge to restrict degrees to precision .001 avoid ".000001N"
* Unix/RISC port 11/91  *sh*: check for unspecified_val8 value, exit after '*'
* V230:  7/20/92 - check T0 before assuming that times can be formatted
*        7/23/92 - for modulo longitude calculations include numerical value
*                  in parentheses
* V300:   2/3/93 - bug fix negative times (dates) - should be always "fancy"
* V320: 12/20/94 - do not label "m" on Z axis -- in order to support the
*		   meteorology community with millibars, etc.
*	 1/27/95 - correct the longitude formatting of negative longitudes
* V530: *acm* 12/00 alternative calendar types; cal_id
* V533: *sh* 7/01 - bug fix: negative time steps still formatted as seconds
*		    since BC.  A leftover from an Oct. 1997 change by K.O.
*	            omitted from this documentation block
* V580 *acm* 10/01  modify the kludge to restrict degrees to precision 0.001
*                   If the calling sequence asks for more precision, allow it.
* V581 *acm*  3/05  axis-independent time coordinates are calculated with default 
*                   calendar, so do not get cal_id when converting to date string
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction. 
* v75  *acm* 3/18  Issue 1856, changes to allow for timesteps in fractional seconds
* v74+ *acm* 11/18  Issue 1902, fractional seconds only when time units are seconds
* v745 *acm* 12/18  Issue 1909, option to write dates in ISO8601 format
* v7441*acm* 12/18 Issue 1910: Allow dates in commands to be in ISO 8601 form, yyyy-mm-dd
* V751 6/19 *acm* TM_FMT rewrite: formatting of lon/lat coordinate strings

	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'errmsg.parm'
	include 'ferret.parm'

* calling argument declarations:
	INTEGER		idim, ndec, grid, line
	CHARACTER*(*)	string
	REAL*8		val

* internal variable declarations:
	CHARACTER	SECS_TO_DATE*20, TM_FMT_TRIM*48, TM_SECS_TO_DATE*20, 
     .                  code*1, xtra*32, buff*20
	INTEGER		FIELD_WIDTH, TM_GET_CALENDAR_ID, TM_LENSTR1, 
     .                  min_width, width, decim, slen, n2, cal_id, iv, 
     .                  idx, nright, status
	LOGICAL		GEOG_LABEL, fancy, use_sig_fig,
     .                  modulo, truncate, no_year
	REAL		TSTEP_TO_SECS, val4, val4_orig, fval

* valid inputs ?  (bug fix 11/91)
        IF ( val .EQ. unspecified_val8 ) THEN
           string = '*'
           RETURN
        ENDIF

* initialize
        modulo     = .FALSE.
	width	   = MIN( 30, LEN(string) )
	use_sig_fig = ndec .LT. 0
	decim	   = ABS(ndec)
	val4	   = val
        val4_orig  = val4
	code	   = ' '
        fancy      = GEOG_LABEL( idim, grid )
	truncate   = .FALSE.

! Note (2/3/93): GEOG_LABEL contains the removed logic

* adjust precision to fit into field if necessary
100	min_width = FIELD_WIDTH( val, grid, idim, decim, slen )
 
	IF ( width .LT. min_width ) THEN
	   IF ( decim .EQ. 0 ) THEN
	      string = '*'		! too narrow to format
              RETURN                    ! bug fix 11/91
	   ELSEIF ( decim .GT. ABS(ndec)) THEN
	      truncate = .TRUE.
	      decim = ABS(ndec)
	      min_width = width
	   ELSE
	      decim = decim - 1
	      GOTO 100
	   ENDIF
	ENDIF

* is it a fancy (lat/long/depth/time) position ?
	IF ( fancy ) THEN

	   IF ( idim .EQ. x_dim ) THEN
* x - longitude E/W
* ... restrict degrees to a precision of .001
c (The following doesnt always compute the correct value in double precision
c on 32-bit linux (.145 comes back as .146). Use NINT instead.)
c	      IF (ndec .LE. 3) val4 = INT(val4 * 1000.D0)/1000.D0
	      IF (ndec .LE. 3) val4 = NINT(val4 * 1000.D0)/1000.D0
	      val4 = MOD( val4, 360. )
	      IF ( val4 .LT. 0.0 ) val4 = val4 + 360.	! 1/27
              modulo = val4 .NE. val4_orig
	      IF     ( val4 .LE. 180.0 ) THEN
	         code    = 'E'			! degE
	      ELSEIF ( val4 .GT. 180.0 ) THEN
	         val4 = 360. - val4
	         code    = 'W'			! degW
	      ENDIF

	   ELSEIF ( idim .EQ. y_dim ) THEN
* y - latitude N/S
* ... restrict degrees to a precision of .001
c (The following doesnt always compute the correct value in double precision
c on 32-bit linux (.145 comes back as .146). Use NINT instead.)
c	      IF (ndec .LE. 3) val4 = INT(val4 * 1000.D0)/1000.D0
	      IF (ndec .LE. 3) val4 = NINT(val4 * 1000.D0)/1000.D0
 	      IF     ( val4 .LT. 0.0 ) THEN
	         val4 = -val4
	         code    = 'S'			! degS
	      ELSEIF ( val4 .GT. 0.0 ) THEN
	         code    = 'N'			! degN
	      ENDIF

	   ELSEIF ( idim .EQ. z_dim ) THEN
* z - depth in meters
!	      code = 'm'				! meters
	      code = ' '		! 12/94 change

	   ELSE
* t - create date/time string and exit
*  ( negative times are used in stored regions as axis-independent dates )
              IF ( val .LT. -47335449600D0 ) THEN
! HACK! negatives time steps are formatted as valid times unless they
! would be negative seconds from BC for dates later than 1-jan-1500
                 line       = grid_line( idim, grid )
!                 cal_id = TM_GET_CALENDAR_ID ( line_cal_name(line))
                 cal_id = 1  ! axis-independent dates were calculated with dflt calendar
                 string = SECS_TO_DATE( -val, cal_id )
              ELSE
                 CALL TSTEP_TO_DATE( grid, idim, val, 6, string )
		 no_year = (TM_LENSTR1(string) .LT. 19)
                 CALL TSTEP_TO_DATE( grid, idim, val, decim, string )
                 slen = TM_LENSTR1(string)
                 line       = grid_line( idim, grid )
		 cal_id = TM_GET_CALENDAR_ID ( line_cal_name(line))

		 buff = string
		 CALL CHECK_DATE_REFORMAT (string, slen, cal_id, status)
* for ISO dates keep the 4-digit year
		 IF (buff .NE. string .AND. no_year) THEN  
		    fval = TSTEP_TO_SECS( grid, idim, val )
		    string = TM_SECS_TO_DATE( fval, cal_id )
		    CALL CHECK_DATE_REFORMAT (string, slen, cal_id, status)
		 ENDIF

		 line    = grid_line( idim, grid )
                 IF (decim.GT.7 .AND. line_tunit(line) .EQ. 1.) THEN  ! units of data in seconds
                    fval = AINT(val)
                    IF (fval .NE. val) THEN
                       fval = val-fval
                       xtra = TM_FMT_TRIM(fval, 4, 16, n2)  
                       IF (width-slen .GE. n2-1) 
     .                    string = string(:slen)//xtra(2:n2)
                    ELSE 
		       string = string(:slen)//'.0'
		    ENDIF
                 ENDIF
                 
		 IF (truncate) THEN
		    string(slen-3:slen) = '***'
		 ENDIF

              ENDIF
	      RETURN
	   ENDIF
	ENDIF

* create all strings except date/time here
	IF ( use_sig_fig ) THEN
	   string = TM_FMT_TRIM( val4, decim, width, slen )
	ELSE
	   string = TM_FMT_TRIM( val4, -decim, width, slen )
	ENDIF

* Remove fractional zeros and trailing decimal point from non-exponentials

        CALL TM_CLEANUP_NUM_STRING (string, slen)
	string = string(:slen)//code

* add parenthetical remark if modulo translation has occurred
        IF ( modulo ) THEN
	   IF ( use_sig_fig ) THEN
              xtra =  TM_FMT_TRIM( val4_orig, decim, width, n2 )
	   ELSE
              xtra =  TM_FMT_TRIM( val4_orig, -decim, width, n2 )
	   ENDIF
	   CALL TM_CLEANUP_NUM_STRING (xtra, n2)

           IF ( LEN(string) .GE. slen+n2+3 ) 
     .                string = string(:slen+1)//'('//xtra(:n2)//')'
        ENDIF


	RETURN
	END

	SUBROUTINE SET_DSG_ID_LEV (dset, cx, nfeatures, dep_dat, dtype, changed_key)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user5/4/2005
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* V7.4+ ACM 7/18  DSG file development
* V7.4+ ACM 9/18  Key label intermediate variable does not need plot settings
* V7.51 6/2019 ACM Use Ampersand to separate strings. Only do up to 20 strings
* V7.51 7/2019 ACM Handle cases when the number of values is really large.
* V7.6  3/2020 ACM Need longer strings to store individual levels.
* V7.6  4/2020 ACM but there can't be arbitrarily many individual levels.
*
* for a DSG plot colored by a variable in the feature direction, set the levels 
* and key to plot with levels of 1 to nfeature, and center-labeled color bar. 
* Label the key with the value of the variable along the feature axis, values or 
* strings.  Feature-direction color plots are always treated as discrete by-level
* plots

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'plot_setup.parm'
	include 'parampl5_dat.decl'
	include 'PARAMPL5.DAT'
	include 'cont_inc.decl'	! with nlev
	include 'CONT.INC'
	include 'xvariables.cmn'
	include 'shade_vars.cmn'
	include 'xprog_state.cmn'
	include 'slash.parm'

* Argument declarations
	LOGICAL changed_key
	INTEGER	dset, cx, nfeatures, dtype
	REAL    dep_dat(*)

* Internal declarations
	LOGICAL TM_HAS_STRING, its_vertical, fmask(nfeatures), contig
	INTEGER TM_LENSTR1, TM_LENSTR, GET_OFFSET_C_STRING_LEN, 
     .		ndel, slen, alen, ier, ist, i, ic, f1, f2, 
     .		tot_len, ilev, count, status

	PARAMETER (tot_len=1500)
	CHARACTER TM_FMT*48, GET_STRING_ELEMENT*30,
     .		str_buff*128, all_keylab*(tot_len), labsym_buff*30, c*1, num_buff*12


* If the user has set /LEVELS, keep the setting

	IF (qual_given( slash_plot_levels ) .NE. 0) GOTO 5000

* Set up a levels string, /LEVEL=(f1,f2,1) and labels if there aren't too many
* TODO: allow for the mask to be non-contiguous, and set up levels (1)(8)(13)

	CALL MAKE_DSG_FEATURE_MASK(dset, cx, fmask, nfeatures )
	
* If there are too many features to label nicely along the color bar just let it use numbers. 
* make up a  nominal /lev=(1,n_shown,del)


	count = 0
	DO i = 1, nfeatures
	   IF ( fmask(i) ) count = count+1
	ENDDO

	c = "&"
	alen = 0

	f1 = 0
	f2 = 0
	contig = .TRUE.
	ilev = 0

	DO i = 1, nfeatures
	   IF ( fmask(i) ) THEN
	      ilev = ilev+1

	      IF (f1 .EQ. 0) f1 = i
	      IF (f1 .NE. 0) f2 = i
	      IF (i.GT.1) THEN
	         IF (fmask(i) .AND. .NOT.fmask(i-1)) contig = .FALSE.
	      ENDIF

*  Get string value. String them together to send to PPLUS. 
*  (Check for ampersands and replace with a space? Can't make example file 
*  with ampersands in the strings using ncgen, so leaving this out). 

	     IF (count.LT.20) THEN
	     IF (dtype .EQ.  ptype_string ) THEN
		 str_buff =  GET_STRING_ELEMENT(1,nfeatures, 1,1, 1,1, 1,1, 1,1, 1,1, 
     .				dep_dat,
     .				i, 1, 1, 1, 1, 1,
     .				30, slen)
     
c		 DO ic = 1, slen
c		    IF (str_buff(ic:ic) .EQ. c) str_buff(ic:ic) = ' '
c		 ENDDO

	     ELSE 
	        str_buff = TM_FMT(dep_dat(i), 15, 30, slen)

	     ENDIF

	      IF (alen + slen .GT. tot_len) EXIT 
	      all_keylab = all_keylab(:alen)//str_buff(:slen)//c
	      alen = TM_LENSTR1(all_keylab)
	      
	     ENDIF  ! count

	   ENDIF
	ENDDO

	alen = alen - 1  ! don't count last comma

	IF (alen .GT. 0 .AND. count.LT.20)
     .	CALL PPLCMD( from, line, 0, 'CLRKLAB '//all_keylab(:alen ), 1, 1 )

* For large numbers of levels do something nicer like (0,180,5)

	IF (contig) THEN
	   ndel = MAX(1, INT(0.5+FLOAT(count)/40.) )
	   IF (ndel .GT. 2) f1 = 0
	   WRITE (str_buff, 100) f1, f2, ndel

 100	   FORMAT( '(', 2(i3,','), i3, ')' )

* remove spaces (required by parsing in routine LEV !!)
	   slen = TM_LENSTR1(str_buff)
	   ist = 0
	   DO i = 1, slen
	      c = str_buff(i:i)
	      IF (c .NE. ' ') THEN
	         ist=ist+1
	         str_buff(ist:ist) = c
	      ENDIF
	   ENDDO
	   slen = ist

	ELSE  ! discontiguous levels
	   str_buff = ""
	   slen = 0
	   DO i = 1, nfeatures
	      IF ( fmask(i) ) THEN
	         num_buff = TM_FMT(FLOAT(i), 10, 12, ist)
		 str_buff = str_buff(:slen)//'('//num_buff(:ist)//')'
		 slen = TM_LENSTR1(str_buff)
		 IF (slen .GT. 126) EXIT
	      ENDIF
	   ENDDO

	   IF (slen .GT. 126) THEN  ! too many levels to do e.g. as LEV(1)(4)(19)(...
	      str_buff = ' '
	      str_buff = TM_FMT(FLOAT(count), 10, 12, ist)
	      slen = TM_LENSTR1(str_buff)
	   ENDIF
	ENDIF

	labsym_buff = "LEV_TEXT "//str_buff(:slen)
	slen = TM_LENSTR1(labsym_buff)
	ier = 0
	ist = 0
	CALL SETSYM (labsym_buff, slen, ier, ist)

	slen = TM_LENSTR1(str_buff)
	CALL PPLCMD( from, line, 0, 'LEV,()'//str_buff(:slen ), 1, 1 )

* Set /key=centered
	its_vertical = vertical_key
	CALL PPLCMD (from, line, 0, 'S_KEY 2', 1, 1 )
	changed_key = .TRUE.

	vertical_key = its_vertical

 5000	RETURN
	END

      SUBROUTINE GET_MODE_ARG( mode, text, arg, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* interpret the text string accompanying the SET MODE command
*	eg. SET MODE TIME:HOURS

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/18/88
* V200:   6/8/89 - added mode desperate
*	 12/6/89 - and mode GKS
*	12/20/89 - and mode Xwindows
*	  1/5/89 - and mode metafile
* Unix/RISC port - 5/91 - cant use "//" with CHAR*(*) variable
*                - and X-windows names are more general
* V230:  5/14/92 - REMOTE_X mode was replaced by the REFRESH mode
*        11/9/92 - MODE META and MODE GKS no longer take arguments - eliminate
* V300:   2/3/93 - added MODE VERIFY FULL/FILE
*	 5/12/93 - file name args to SET MODE JOURNAL and SET MODE PPLLIST
* V301:  1/12/94 - allow filename arg for mode metafile
* V320 8/94 *kob* -IBM port - had to use risc buff for string concats
*       12/29/94 - eliminate unnecessary tty error message ("12/94")
*	 1/18/94 - added SET MODE VERIFY:ALWAYS (iarg=3)
*		   (bug fix for MODE VERIFY:garbage error msgs 2/3/95)
* V500: 4/99 *sh* - added MODE STUPID:weak_cache
* V570: *acm* 5/04 - add MODE GRATICULE[:argument] 
* V600: *acm* 5/06 - add new MODE LINECOLORS:[arg]
* V610  *acm* 3/08 - add new MODE NLEVELS:argument
* V67   *acm* 3/11 - Fix for ticket 1819, size of arg for MODE DESPERATE,
*                    and allow for a floating-point input
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V698  *acm* 5/16 Ticket 2405: MODE CALENDAR:auto
* V702  *sh*  2/17 Added mode frugal

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'gfdl_vms.parm'	
	include 'xprog_state.cmn'
	include 'xtext_info.cmn'
	include 'xrisc.cmn'          ! for RISC/FORTRAN

* calling argument declarations
	INTEGER		mode, arg, status
	REAL		farg
	CHARACTER*(*)	text

* local variable declarations:
	INTEGER	STR_CASE_BLIND_COMPARE, TM_LENSTR1,
     .		vax_code, tlen, cpos, iarg

* initialize
	status = ferr_ok
	IF ( text .EQ. ' ' ) THEN
	   IF ( mode .EQ. pmode_verify ) arg = 1   ! reset to "DEFAULT"
           IF ( mode .EQ. pmode_stupid ) arg = 2   ! same as unspecified_int4
!           IF ( mode .EQ. pmode_frugal ) arg = 30
	   RETURN
	ENDIF

* decode argument according to syntax for this mode
! removed 12/94
!	IF ( mode .EQ. pmode_diagnostic
!     .	.OR. mode .EQ. pmode_interpolate ) THEN
!	   WRITE ( ttout_lun, * ) 'mode argument not yet implemented'
!	ELSEIF ( mode .EQ. pmode_long_lab

	IF ( mode .EQ. pmode_long_lab
     .	    .OR. mode .EQ. pmode_lat_lab
     .	    .OR. mode .EQ. pmode_depth_lab ) THEN
	   READ ( text, '(BN,I10)', ERR=5010 ) iarg
	   IF ( ABS(iarg) .GT. 8  ) GOTO 5010
	   arg = iarg

	ELSEIF ( mode .EQ. pmode_time_lab ) THEN
	   tlen = MIN( 7, TM_LENSTR1(text) )
	   DO 100 iarg = 1, 7
	      vax_code = STR_CASE_BLIND_COMPARE
     .		( text(:tlen), date_labels(iarg)(:tlen) )
	      IF ( vax_code .EQ. vms_str_success ) THEN
	         arg = -iarg
	         GOTO 1000
	      ENDIF
 100	   CONTINUE
	   GOTO 5010	! unknown argument

	ELSEIF ( mode .EQ. pmode_desperate ) THEN
	   READ ( text, *, ERR=5010 ) farg
	   IF (farg .GT. 1.e9 .OR. farg .LE. 0) GOTO 5030
           iarg = INT(farg)
	   arg = iarg

	ELSEIF ( mode .EQ. pmode_verify ) THEN
	   tlen = MIN( 3, TM_LENSTR1(text) )
           DO 200 iarg = 1, 3
              vax_code = STR_CASE_BLIND_COMPARE
     .          ( text(1:3), verify_modes(iarg)(1:tlen) )
              IF ( vax_code .EQ. vms_str_success ) THEN
                 arg = iarg
                 GOTO 1000
              ENDIF
 200       CONTINUE
	   GOTO 5010
	ELSEIF ( mode .EQ. pmode_journal ) THEN
 	   journal_file = text
* ... change COMMON variable lttout in PLOT to output to file
	ELSEIF ( mode .EQ. pmode_ppllist ) THEN
	   ppllist_file = text
	ELSEIF ( mode .EQ. pmode_metafile ) THEN
	   CONTINUE     ! processed in XEQ_SET in case PLOT+ not opened yet
* ... SET MODE STUPID:weak_cache
	ELSEIF ( mode .EQ. pmode_stupid ) THEN
           vax_code = STR_CASE_BLIND_COMPARE(text(1:4), 'weak' )
           IF ( vax_code .EQ. vms_str_success ) THEN
              arg = 1
              GOTO 1000
           ELSE
	      GOTO 5010
           ENDIF
* ... SET MODE GRAT:graticule argument
	ELSEIF ( mode .EQ. pmode_grat ) THEN
            mode_grat_buff = text
            
	ELSEIF ( mode .EQ. pmode_linecolors ) THEN
	   READ ( text, '(BN,I10)', ERR=5010 ) iarg
	   IF ( iarg.LT.6 ) GOTO 5010
	   arg = iarg

	ELSEIF ( mode .EQ. pmode_nlevels ) THEN
	   READ ( text, '(BN,I10)', ERR=5020 ) iarg
	   IF ( iarg.LT.1 .OR. iarg .GT. 250 ) GOTO 5020
	   arg = iarg

	ELSEIF ( mode .EQ. pmode_frugal ) THEN
	   READ ( text, '(BN,I10)', ERR=5040 ) iarg
	   IF ( iarg.LT.0 .OR. iarg.GT.90) GOTO 5040
	   arg = iarg

        ELSE
	   GOTO 5010	! mode does not accept argument
	ENDIF

* successful completion
 1000	RETURN
        
* error exit
 5000   RETURN
#ifdef NO_PASSED_CONCAT
 5010   tlen = TM_LENSTR1(text)
        risc_buff = text(:tlen)
        CALL ERRMSG( ferr_out_of_range, status,
     .   'illegal mode argument '//risc_buff, *5500 )
 5020   tlen = TM_LENSTR1(text)
        risc_buff = text(:tlen)
        CALL ERRMSG( ferr_out_of_range, status,
     .   'illegal mode argument. Must be in [1,250] '//risc_buff, *5500 )
 5030   tlen = TM_LENSTR1(text)
        risc_buff = text(:tlen)
        CALL ERRMSG( ferr_out_of_range, status,
     .   'illegal mode argument. Negative or > 1.e+9, ', *5500 )
#else
 5010   tlen = TM_LENSTR1(text)
        CALL ERRMSG( ferr_out_of_range, status,
     .   'illegal mode argument < 6 '//text(:tlen), *5500 )
 5020   tlen = TM_LENSTR1(text)
        CALL ERRMSG( ferr_out_of_range, status,
     .   'illegal mode argument. Must be in [1,250] '//text(:tlen), *5500 )
 5030   tlen = TM_LENSTR1(text)
        CALL ERRMSG( ferr_out_of_range, status,
     .   'illegal mode argument > 1.e+9, ', *5500 )
#endif
 5040   CALL ERRMSG( ferr_out_of_range, status,
     .   'illegal mode argument. Must be 0 to 90 percent '
     .          //text(:tlen), *5000 )
 5500   IF ( mode .EQ. pmode_verify ) CALL WARN(
     .          'Legal VERIFY arguments are DEFAULT, ALL, and ALWAYS')
        GOTO 5000

        END

*
* zaxreplace_rev.F
! version of zaxreplace_avg, with order of arguments 1 and 2 reversed
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* Oct 1998
* 11/2001  clarify function description
*  7/2003  Bug fix; last source point wasnt associated with a dest box
*          when the destination axis continues beyond the source range
*
*
* Replace Z axis, using weighted averaging over bins
*

*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE zaxreplace_rev_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      CHARACTER*100 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT 
     .  ('regrid V onto Z axis of ZAX based on Z values in ZVALS ',
     .    'using weighted average' )
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)

      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, YES, YES, YES, NO)

      CALL ef_set_num_work_arrays(id, 8)
      arg = 1
      CALL ef_set_arg_name(id, arg, 'ZVALS')
      CALL ef_set_arg_desc(id, arg, 
     .        'Destination Z axis values as a fcn of source Z axis')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'V')
      CALL ef_set_arg_desc(id, arg, 
     .        'Variable on native z axis')
      CALL ef_set_axis_influence(id, arg, YES, YES, NO, YES)


      arg = 3
      CALL ef_set_arg_name(id, arg, 'ZAX')
      CALL ef_set_arg_desc(id, arg, 
     .'Variable with desired z (depth) axis points')
      CALL ef_set_axis_influence(id, arg, NO, NO, YES, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE zaxreplace_rev_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_dims(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER mz1, mz3

      INTEGER iwork
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

*  Allocate double the dimension of the input arguments for work arrays
*  which will be REAL*8

      mz1 = 1 + ABS(arg_hi_ss(Z_AXIS,ARG1) - arg_lo_ss(Z_AXIS,ARG1))
      mz3 = 1 + ABS(arg_hi_ss(Z_AXIS,ARG3) - arg_lo_ss(Z_AXIS,ARG3))

      mz1 = 2* mz1
      mz3 = 2* mz3

*  zaxsrc
      iwork = 1
      CALL ef_set_work_array_dims (id, iwork, 1, 1, 1, 1, 
     .   1, 1, mz1, 1)

*  sbox_lo_lim
      iwork = 2
      CALL ef_set_work_array_dims (id, iwork, 1, 1, 1, 1, 
     .   1, 1, mz1, 1)

*  sbox_hi_lim
      iwork = 3
      CALL ef_set_work_array_dims (id, iwork, 1, 1, 1, 1, 
     .   1, 1, mz1, 1)

*  sbox_lo_new
      iwork = 4
      CALL ef_set_work_array_dims (id, iwork, 1, 1, 1, 1, 
     .   1, 1, mz1, 1)

*  sbox_hi_new
      iwork = 5
      CALL ef_set_work_array_dims (id, iwork, 1, 1, 1, 1, 
     .   1, 1, mz1, 1)

*  dbox_lo_lim
      iwork = 6
      CALL ef_set_work_array_dims (id, iwork, 1, 1, 1, 1, 
     .   1, 1, mz3, 1)

*  dbox_hi_lim
      iwork = 7
      CALL ef_set_work_array_dims (id, iwork, 1, 1, 1, 1, 
     .   1, 1, mz3, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE zaxreplace_rev_compute(id, arg_1, arg_2, arg_3, 
     .     result, zaxsrc, sbox_lo_lim, sbox_hi_lim, sbox_lo_new, 
     .     sbox_hi_new, dbox_lo_lim, dbox_hi_lim)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .     mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .     mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .     mem3lot:mem3hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER i, j, k, l
      INTEGER i1, j1, l1, i2, j2, l2, i3, j3, l3
      INTEGER ifirst, iw, nbox, nsrc
      INTEGER nsrc_lo, nsrc_hi
      REAL frac, xsrc_min, xsrc_max, xsrc_lo, xsrc_hi, xsrcdiff
      REAL wtd, arg2_val, arg2_val_last, wtd_last
      REAL*8 sum, wtdsum
      REAL dbox_lo, dbox_hi
c      CHARACTER*132 err_msg

*  Dimension work arrays

      REAL*8 zaxsrc(wrk1lox:wrk1hix, wrk1loy:wrk1hiy,
     .               wrk1loz:wrk1hiz/2, wrk1lot:wrk1hit)
      REAL*8 sbox_lo_lim(wrk2lox:wrk2hix, wrk2loy:wrk2hiy,
     .               wrk2loz:wrk2hiz/2, wrk2lot:wrk2hit)
      REAL*8 sbox_hi_lim(wrk3lox:wrk3hix, wrk3loy:wrk3hiy,
     .               wrk3loz:wrk3hiz/2, wrk3lot:wrk3hit)
      REAL*8 sbox_lo_new(wrk4lox:wrk4hix, wrk4loy:wrk4hiy,
     .               wrk4loz:wrk4hiz/2, wrk4lot:wrk4hit)
      REAL*8 sbox_hi_new(wrk5lox:wrk5hix, wrk5loy:wrk5hiy,
     .               wrk5loz:wrk5hiz/2, wrk5lot:wrk5hit)
      REAL*8 dbox_lo_lim(wrk6lox:wrk6hix, wrk6loy:wrk6hiy,
     .               wrk6loz:wrk6hiz/2, wrk6lot:wrk6hit)
      REAL*8 dbox_hi_lim(wrk7lox:wrk7hix, wrk7loy:wrk7hiy,
     .               wrk7loz:wrk7hiz/2, wrk7lot:wrk7hit)

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)


      CALL ef_get_coordinates(id, ARG1, Z_AXIS, 
     .   arg_lo_ss(Z_AXIS, ARG1), arg_hi_ss(Z_AXIS, ARG1), zaxsrc)

      CALL ef_get_box_limits(id, ARG1, Z_AXIS, arg_lo_ss(Z_AXIS, ARG1), 
     .   arg_hi_ss(Z_AXIS, ARG1), sbox_lo_lim, sbox_hi_lim)

      CALL ef_get_box_limits(id, ARG3, Z_AXIS, arg_lo_ss(Z_AXIS, ARG3), 
     .   arg_hi_ss(Z_AXIS, ARG3), dbox_lo_lim, dbox_hi_lim)

* 
*  Loop over x,y,t of the input fields
*
      ifirst = 1
      iw = 0

      i1 = arg_lo_ss(X_AXIS,ARG1)
      i2 = arg_lo_ss(X_AXIS,ARG2)
      i3 = arg_lo_ss(X_AXIS,ARG3)
      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         j2 = arg_lo_ss(Y_AXIS,ARG2)
         j3 = arg_lo_ss(Y_AXIS,ARG3)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            l1 = arg_lo_ss(T_AXIS,ARG1)
            l2 = arg_lo_ss(T_AXIS,ARG2)
            l3 = arg_lo_ss(T_AXIS,ARG3)
            DO 200 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

*

* -ACM- Note: need to think about backwards and forwards z axes: ht vs depth ?


*  Translate the source boxes to the new axis units.

               DO 500 k = arg_lo_ss(Z_AXIS,ARG2), 
     .                    arg_hi_ss(Z_AXIS,ARG2)

*  Find the point on the source axis just below the box limit.  Interpolate
*  to get the box limit in new units.

                  nbox = 1

                  DO WHILE (zaxsrc(1,1,nbox,1) .LT. 
     .                      sbox_lo_lim(1,1,k,1) )
                     nbox = nbox + 1
                  ENDDO

                  IF (nbox .eq. 1) THEN 
                     sbox_lo_new(1,1,k,1) = arg_1(i1,j1,nbox,l1)
                  ELSE
                     frac = (sbox_lo_lim(1,1,k,1) - 
     .                      zaxsrc(1,1,nbox-1,1))/
     .                   (zaxsrc(1,1,nbox,1) - zaxsrc(1,1,nbox-1,1)) 
                     sbox_lo_new(1,1,k,1) = arg_1(i1,j1,nbox-1,l1) + 
     .                      frac* 
     .                  (arg_1(i1,j1,nbox,l1) - arg_1(i1,j1,nbox-1,l1))
                  ENDIF

                  nbox = 1

                  DO WHILE (zaxsrc(1,1,nbox,1) .LT. sbox_hi_lim(1,1,k,1)
     .                      .AND.
     .                  nbox .lt. arg_hi_ss(Z_AXIS,ARG2))
                     nbox = nbox + 1
                  ENDDO

                  IF (nbox .eq. 1) THEN 
                     sbox_hi_new(1,1,k,1) = arg_1(i1,j1,nbox,l1) 
                  ELSE
                     frac = (sbox_hi_lim(1,1,k,1) - 
     .                       zaxsrc(1,1,nbox-1,1))/
     .                  (zaxsrc(1,1,nbox,1) - zaxsrc(1,1,nbox-1,1)) 
                     sbox_hi_new(1,1,k,1) = arg_1(i1,j1,nbox-1,l1) + 
     .                      frac* 
     .                   (arg_1(i1,j1,nbox,l1) - arg_1(i1,j1,nbox-1,l1))
                  ENDIF

  500          CONTINUE 

* For each z line accumulate weighted source points and weights to get
* the average value.   Loop through the each destination grid box.


               sum = 0.
               wtdsum = 0.
               DO 100 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

*  Find the first and last source point in this destination box

                  nsrc_lo = 1
                  nsrc_hi = 1

                  DO WHILE 
     .                  (sbox_lo_new(1,1,nsrc_lo,1) .LT. 
     .                      dbox_lo_lim(1,1,k,1) )
                     nsrc_lo = nsrc_lo + 1
                     IF (nsrc_lo .GT. arg_hi_ss(Z_AXIS, ARG1)) GO TO 11
                  ENDDO
  11              CONTINUE

*  Find any portion of the source box lying in the destination box.

                  DO WHILE 
     .                  (sbox_lo_new(1,1,nsrc_hi,1) .LE. 
     .                      dbox_hi_lim(1,1,k,1) )
                     nsrc_hi = nsrc_hi + 1
                     IF (nsrc_hi .GT. arg_hi_ss(Z_AXIS, ARG1)) GO TO 22
                  ENDDO
  22              CONTINUE

                  nsrc_hi = nsrc_hi - 1

*  No source boxes within this destination box.

                  IF (nsrc_hi .LT. nsrc_lo) THEN
                     IF (wtdsum .NE. 0.) THEN
                        result(i,j,k,l) = sum / wtdsum
                     ELSE
                        result(i,j,k,l) = bad_flag_result
                     ENDIF
                     GO TO 160
                  ENDIF

                  DO 90 nsrc = nsrc_lo, nsrc_hi

*  Get fraction of this source box lying within the destination box. 

	               xsrc_min = sbox_lo_new(1,1,nsrc,1)
	               xsrc_max = sbox_hi_new(1,1,nsrc,1)

                       dbox_hi = dbox_hi_lim(1,1,k,1)
                       dbox_lo = dbox_lo_lim(1,1,k,1)

	               xsrc_lo = MAX(xsrc_min, dbox_lo)
	               xsrc_hi = MIN(xsrc_max, dbox_hi)

                       xsrcdiff = xsrc_max - xsrc_min
                       wtd = 0.
                       IF (xsrcdiff .NE. 0.) 
     .                     wtd = (xsrc_hi - xsrc_lo)/xsrcdiff

                       arg2_val = arg_2(i2,j2,nsrc,l2)
                       IF (arg2_val .ne. bad_flag(ARG2)) THEN
	                  sum   = sum  + wtd * arg2_val
                          wtdsum  = wtdsum + wtd

                          arg2_val_last = arg2_val
                          wtd_last = wtd

                       ENDIF
  
  90              CONTINUE

* If we had any good data, calculate the average.

                  IF (wtdsum .NE. 0.) THEN
                     result(i,j,k,l) = sum / wtdsum

*  Start next average with remaining weighted part of the last box with
*  was not within the destination box.

                     sum = (1.- wtd_last)* arg2_val_last
                     wtdsum = 1.- wtd_last
                  ELSE 
                     result(i,j,k,l) = bad_flag_result
                     sum = 0.
                     wtdsum = 0.
                  ENDIF

 160              CONTINUE

 100           CONTINUE

               l1 = l1 + arg_incr(T_AXIS,ARG1)
               l2 = l2 + arg_incr(T_AXIS,ARG2)
               l3 = l3 + arg_incr(T_AXIS,ARG3)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
            j2 = j2 + arg_incr(Y_AXIS,ARG2)
            j3 = j3 + arg_incr(Y_AXIS,ARG3)
 300     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
         i2 = i2 + arg_incr(X_AXIS,ARG2)
         i3 = i3 + arg_incr(X_AXIS,ARG3)
 400  CONTINUE

      
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* fft_phas.F
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* Dec 1998
*
* v5.50  *acm* 10/02 Simplify the error message for missing data when the 
*                    input is a simple 1-D time series.
* V5.53  *acm*  6/03 Correct the frequency axis:  why was there a factor of
*                     1.001 in freqn = 1.001*yquist?
*
* This function computes fft phase spectrum for each time series.  Result
* time axis is a custom axis in period 1./time  The input variable must have
* the time axis specified explicitly in the function call e.g. 
*    LET sstp = fft_phas(ssttim[l=1:492])
* and the time axis must be regular.

*  Note current limitations as of 1-Jan-2000
*   - Will have a utility to get the length of the input time axis at the
*     point when the custom freq axis is set up, to use in computing the
*     length of the frequency axis.  Currently need to specify explicitly, 
*     in the function call e.g. fft_phas(sst[l=1:400]).

*  NOTE:
*  IT IS GENERALLY ADVISABLE TO INCLUDE EXPLICIT LIMITS WHEN WORKING WITH
*  FUNCTIONS THAT REPLACE AXES. FOR EXAMPLE, THE CONSIDER THE FUNCTION
*  SORTL(v). THE EXPRESSION
*       LIST/L=6:10 SORTL(v)
*  IS NOT EQUIVALENT TO
*       LIST SORTL(v[L=6:10])
*  THE FORMER WILL LIST THE 6TH THROUGH 10TH SORTED INDICES FROM THE ENTIRE
*  L RANGE OF VARIABLE V. THE LATTER WILL LIST ALL OF THE INDICES THAT
*  RESULT FROM SORTING v[L=6:10].
*  
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE fft_phas_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

c      CALL ef_version_test(ef_version)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
*                                                                      V
      CALL ef_set_desc(id, 'Computes fft phase, WITH CORRECTED FREQ AXIS' )

      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, CUSTOM)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      CALL ef_set_num_work_arrays(id, 4)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 
     .'Variable with regular time axis. Specify time explicitly e.g. fft_phas(v[l=1,96])')

      CALL ef_set_axis_influence(id, arg, YES, YES, YES, NO)


*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END


      SUBROUTINE fft_phas_custom_axes(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                      
*
*     Use utility functions to get grid information about the 
*     argument; use this info to determine the custom axis lo/hi/del 

      INTEGER nfreq_lo_l, nfreq_hi_l

      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

      INTEGER arg
      INTEGER nfreq, nd

      REAL yquist, freq1, freqn
            
      CHARACTER outunits*32
      REAL boxsize(1)
         
      CHARACTER ax_name(4)*16, ax_units(4)*16
      LOGICAL backward(4), modulo(4), regular(4)

      arg = 1
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      CALL ef_get_axis_info(id, arg, ax_name, ax_units, backward,
     .     modulo, regular)

      CALL ef_get_box_size(id, arg, T_AXIS, arg_lo_ss(T_AXIS,arg), 
     .               arg_lo_ss(T_AXIS,arg), boxsize)
     

      IF ( arg_hi_ss(T_AXIS,arg) - arg_lo_ss(T_AXIS,arg) .EQ. 0 ) THEN
         nfreq_lo_l = 1
         nfreq_hi_l = 2
      ELSE
         nfreq_lo_l = arg_lo_ss(T_AXIS,arg)
         nfreq_hi_l = arg_hi_ss(T_AXIS,arg)
      ENDIF

      nd = abs(nfreq_hi_l - nfreq_lo_l) + 1

C  The FFT code returns frequencies W(k) for k=1 to N/2, with N/2 rounded down


C  Set label for the frequency axis CYC/units.

      outunits = 'CYC/' // ax_units(T_AXIS)

      CALL ef_set_freq_axis (id, T_AXIS, nd, boxsize(1), outunits, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE fft_phas_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER ntime, nfreq

      INTEGER arg
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


*     Use utility functions to get context information about the argument.

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nfreq = 1

      arg = 1
      ntime = arg_hi_ss(T_AXIS,arg) - arg_lo_ss(T_AXIS,arg) + 1

C  The FFT code returns frequencies W(k) for k=1 to N/2, with N/2 rounded down

      nfreq = ntime/ 2
      if (ntime .ne. nfreq*2) nfreq = (ntime+1)/2 ! see fft_phasACK comments in rfftf

      CALL ef_set_axis_limits(id, T_AXIS, 1, nfreq)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE fft_phas_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
* 
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_dims(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER mtdat, mtwork
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      mtdat = 1 + arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1)

      mtwork = 2.5* mtdat + 15
  
* a
      CALL ef_set_work_array_dims (id, 1, 1, 1, 1, 1, mtdat, 1, 1, 1)

* b
      CALL ef_set_work_array_dims (id, 2, 1, 1, 1, 1, mtdat, 1, 1, 1)

* wft
      CALL ef_set_work_array_dims (id, 3, 1, 1, 1, 1, mtwork, 1, 1, 1)

* ts
      CALL ef_set_work_array_dims (id, 4, 1, 1, 1, 1, mtdat, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE fft_phas_compute(id, arg_1, result, a, b, wft, ts)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id, arg

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      CHARACTER ax_name(4)*16, ax_units(4)*16
      LOGICAL backward(4), modulo(4), regular(4)

*  Dimension work arrays

      REAL a(wrk1lox:wrk1hix, wrk1loy:wrk1hiy,
     .               wrk1loz:wrk1hiz, wrk1lot:wrk1hit)
      REAL b(wrk2lox:wrk2hix, wrk2loy:wrk2hiy,
     .               wrk2loz:wrk2hiz, wrk2lot:wrk2hit)
      REAL wft(wrk3lox:wrk3hix, wrk3loy:wrk3hiy,
     .               wrk3loz:wrk3hiz, wrk3lot:wrk3hit)
      REAL ts(wrk4lox:wrk4hix, wrk4loy:wrk4hiy,
     .               wrk4loz:wrk4hiz, wrk4lot:wrk4hit)

      REAL aa, bb,  rad
      INTEGER nd, nf
      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1

      CHARACTER*80 err_msg

   40 FORMAT ('fft_phas encountered missing data at (i,j,k,l)', 4I5)
   50 FORMAT ('FFTA encountered missing data at L=', I5)

      rad = 180.0/ 3.141592654

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)


*  number of time points.

      arg = 1
      nd = (arg_hi_ss(T_AXIS,arg) - arg_lo_ss(T_AXIS,arg) + 1)
      nf = nd/ 2

*  Check that the time axis is regular.

      CALL ef_get_axis_info (id, 1, ax_name, ax_units, backward,
     .     modulo, regular)

      IF (.NOT. regular(T_AXIS)) THEN
            WRITE (err_msg, *) 'Time axis must be a regular axis'
            GO TO 999
      ENDIF

*  Set WFT for fft; prime factorization of ND and trig functions.

      CALL rffti (nd, wft)

      i1 = arg_lo_ss(X_AXIS,ARG1)
      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

* Calculate the FFT for each time series which have no missing data.
* Make a simple message if we have a 1-D input time series.

               l1 =arg_lo_ss(T_AXIS,ARG1)
               DO 100 l = 1, nd
                  IF (arg_1(i1,j1,k1,l1) .EQ. bad_flag(ARG1)) THEN
                     WRITE (err_msg, 40) i1,j1,k1,l

                     IF (i1 .EQ. ef_unspecified_int4 .AND.
     .                   j1 .EQ. ef_unspecified_int4 .AND.
     .                   k1 .EQ. ef_unspecified_int4 )
     .                     WRITE (err_msg, 50) l

                     GO TO 999 
                  ENDIF

                  ts(l,1,1,1) = arg_1(i1,j1,k1,l1)
                  l1 = l1 + arg_incr(T_AXIS,ARG1)
 100           CONTINUE


               l1 = arg_lo_ss(T_AXIS,ARG1)
               l = res_lo_ss(T_AXIS)

               CALL four_re (nd, ts, a, b, wft)

               DO 110 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS) 
                   aa = a(l,1,1,1)
                   bb = b(l,1,1,1)
                   result(i,j,k,l) = rad* ATAN2(-1.*bb, aa)
 110           CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 300     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
 400  CONTINUE

      RETURN

 999  CALL ef_bail_out (id, err_msg)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END
      

      SUBROUTINE HFLUX ( vel, mvel, sst, msst, air, mair,
     .			 sens, msens,  evap, mevap )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute heat flux into sea surface
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 2.0 - 3/7/86	major modifications from GFDLCONT Rev 5.4 to convert
*			i-k oriented calculations to i-j oriented calculations
* revision 2.1 -4/4/88 - air temp is pre-computed for various parameterizations
* V200:  7/27/89 - 4D symmetrical version
*	10/11/89 - array declarations using XMEM_SUBSC.CMN (reordered args)

* capitalized code is lifted from the GFDL model
*
* equations used:
*	Q = SW - LW - QS - QE
* where
*	Q is heat flux
*	SW-LW (C5) is short wave down less long wave up
*	QS is sensible heating: = ro*Cd*Cp*V*(Tsst-Tair)
*	QE is evaporative cooling: = ro*L*Cd*V*(qradi(Tsst) - R*qradi(Tair) )
*	where
*		qs(T) = 0.622es(T)/PA and
*		qe(T) = 6.11*exp[L/Rv * (1/273 - 1/T) ]

* note: in the original GFDL version of this subroutine the surface Q flux was
*	imbedded in the array TDIF with suitable constants so that the surface
*	flux appeared to be diffusing from level k=0 of the ocean.  Several of
*	the variables went under non-explicit EQUIVALENCE names so that the
*	effective calculation (where "qflux" is the surface heat flux) became:
* 		tdif(i,1)= sst + dzz(1)/bvdc(i) * qflux(i)	- in HFLUX
*		delta_T  = bvdc(i)*eeh(1) * (tdif(i,1)-sst(1))	- in TRACER 3106
*	where	eeh(1)   = 1/(dz(1)*dzz(1))

#ifdef unix
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl.parm'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xonedim.cmn'	! geometric constants
	include 'xcontext.cmn'
	include 'xdset_parms.cmn'
#else
	INCLUDE 'FERRET_CMN:FERRET.PARM'
	INCLUDE 'FERRET_CMN:GFDL.PARM'
	INCLUDE 'TMAP_FORMAT:TMAP_DIMS.PARM'
	INCLUDE	'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE	'FERRET_CMN:XMEM_SUBSC.CMN'
	INCLUDE 'FERRET_CMN:XONEDIM.CMN'	! geometric constants
	INCLUDE 'FERRET_CMN:XCONTEXT.CMN'
	INCLUDE 'FERRET_CMN:XDSET_PARMS.CMN'
#endif

* calling argument declarations:
	INTEGER	mair, mvel, msst, msens, mevap
	REAL	 vel( m1lox:m1hix,m1loy:m1hiy,            m1lot:m1hit ),
     .		 sst( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,m2lot:m2hit ),
     .		 air( m3lox:m3hix,m3loy:m3hiy,            m3lot:m3hit ),
     .		sens( m4lox:m4hix,m4loy:m4hiy,            m4lot:m4hit ),
     .		evap( m5lox:m5hix,m5loy:m5hiy,            m5lot:m5hit )

* internal variable declarations:
	INTEGER	i_lo, i_hi, j_lo, j_hi, i, j, l, dset
	REAL	bad_air, bad_sst, bad_vel, bad_sens, bad_evap, vel1,
     .		d1, d2, windmin
	REAL	R, RO, EL, CD, PA, CP, C1, C2, rap

* --- end of introductory code ---
* initialize
	dset    = mr_data_set( msens )
	windmin = dp_min_wind( dset )

* limits for calculation
	i_lo = mr_lo_s1(msens)
	i_hi = mr_hi_s1(msens)
	j_lo = mr_lo_s2(msens)
	j_hi = mr_hi_s2(msens)

* flag for bad/missing data
	bad_air  = mr_bad_data( mair )
	bad_vel  = mr_bad_data( mvel )
	bad_sst  = mr_bad_data( msst )
	bad_sens = mr_bad_data( msens )
	bad_evap = mr_bad_data( mevap )

C     SET CONSTANTS							!  769
C									!  770
      R=.8
      RO=1.2E-3			! (of air) gm/cm**3
      EL=595.			! cal/gm
      CD=1.4E-3
      PA=1013.25		! millibars
      CP=.24			! cal/gm-deg
      C1=RO*CD*EL*.662/PA
      C2=RO*CD*CP
	rap = 1. / (ro * cd)	! translated from RAP assignment below

	DO 2000 l = mr_lo_s4(msens), mr_hi_s4(msens)

	DO 300 j = j_lo, j_hi
	DO 300 i = i_lo, i_hi

* check air, SST and wind stress
	IF ( air(i,j  ,l) .EQ. bad_air
     .	.OR. sst(i,j,1,l) .EQ. bad_sst
     .	.OR. vel(i,j  ,l) .EQ. bad_vel ) GOTO 290

C     CALC WIND MAGNITUDE FROM STRESS					!  803
C(     DON'T ALLOW WIND MAGNITUDE < 488 CM/SEC (.40DYNES/CM**2)		!  811)
C   don't allow wind magnitude < windmin
C     TO APPROX HIGH FREQ DISTURBANCES IN ITCZ				!  812
      vel1=RAP*VEL(i,j,l)					!  808 mod
      vel1=SQRT(vel1)						!  809 mod
      IF (vel1.LT.windmin) vel1=windmin				!  815 mod
50    CONTINUE							!  816
C								!  817
C     SATURATION VAPOR PRESSURES ... LATENT HEATING		!  818
C								!  819
      d1   =9.4051-2353./( air(i,j  ,l) + 273.16 )		!  820 mod
      d2   =9.4051-2353./( SST(i,j,1,l) + 273.16 )		!  821 mod
      d2   =10.**d2						!  822 mod
      d1   =10.**d1						!  823 mod
      d1   =d2-R*d1						!  824 mod
      d1   =C1*d1						!  825 mod
	sens(i,j,l) =-c2 * vel1 * (sst(i,j,1,l)-air(i,j,l))     ! sensible heat
	evap(i,j,l) =-d1 * vel1				! evaporative heat
	GOTO 300
	
* cannot do calculation at this point
 290	      sens(i,j,l) = bad_sens
	      evap(i,j,l) = bad_evap

 300	continue

 2000	CONTINUE

	RETURN
	END

*
* tax_units.F
*
* Jing Y. Li 
* May 4th 2006
*
* This function returns year specified by the first argument (variable 
* containing time values) from the second argument (variable from which time 
* encoding will be inferred).
*

*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*
* 2006-05-11 It only works with the unit nameing convention in xunits_data.F

      SUBROUTINE tax_units_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

      CALL ef_version_test(ef_version)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     . 'Returns units of time axis coordinate values, in seconds' )
   
      CALL ef_set_num_args(id, 1)

      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)

      CALL ef_set_axis_reduction(id, REDUCED, REDUCED, REDUCED, REDUCED)

      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'variable with reference time axis')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE tax_units_compute(id, arg_1, result)

*      INCLUDE 'tax.h' 
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INCLUDE 'xunits.cmn_text'
      EXTERNAL xunits_data

      INTEGER iun
      INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)

      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)


* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      INTEGER iyear, day_of_mon
      CHARACTER*3 cmon
      CHARACTER*16 axname(4), axunits(4)
      LOGICAL bkw1(4), mod1(4), reg1(4)

      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*     Get axis information
      CALL ef_get_axis_info(id, ARG1, axname, axunits, bkw1, mod1, reg1)

      i1 = arg_lo_ss(X_AXIS,ARG1)
      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

           k1 = arg_lo_ss(Z_AXIS,ARG1)
           DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

              l1 = arg_lo_ss(T_AXIS,ARG1)
              DO 100 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

                DO 99 iun=pun_1st_time, pun_last_time 
*                  print *, un_name(iun)

                  CALL LOWER(axunits(4))
                  IF( ( un_name(iun) .EQ. axunits(4))           .OR.
     .                ( un_name(iun)(1:2) .EQ. axunits(4)(1:2)) .OR.
     .                ( (un_name(iun) .EQ. 'yr')                .AND. 
     .                  (axunits(4) .EQ. 'year') ) )THEN

                    result(i,j,k,l) = un_convert(iun) 
                  END IF
 99             CONTINUE

                l1 = l1 + arg_incr(T_AXIS,ARG1)
 100          CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 300     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
 400  CONTINUE


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END

****************************************************************
*
      SUBROUTINE LOWER(TEXT)
      CHARACTER*(*) TEXT
*
*     Converts a string to lowercase.
*
      EXTERNAL LENGTH
      INTEGER  LENGTH
      CHARACTER*1 LETTER
      INTEGER ISHIFT,I
      ISHIFT=ICHAR('a')-ICHAR('A')
      DO 10 I=1,LENGTH(TEXT)
        LETTER=TEXT(I:I)
        IF('A'.LE.LETTER.AND.LETTER.LE.'Z') THEN
          TEXT(I:I)=CHAR(ICHAR(LETTER)+ISHIFT)
        END IF
   10 CONTINUE
      RETURN
      END

***************************************************************
*
      INTEGER FUNCTION LENGTH(TEXT)
      CHARACTER*(*) TEXT
*
*     Computes the length of a string without trailing blanks.
*
      INTEGER I

      DO 1 I=LEN(TEXT),1,-1
        IF(TEXT(I:I).NE.' ') THEN
          GO TO 2
        END IF
    1 CONTINUE
      I=1
    2 CONTINUE
      LENGTH=I

      RETURN
      END

*
* length_of_strings.F
*
* Ansley Manke
* May 2002
*
* Returns length of strings in input array.
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )


      SUBROUTINE length_of_strings_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V


      CALL ef_set_desc(id,
     . 'Demo Function:Returns the lengths of strings in A' )

      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_result_type(id, FLOAT_RETURN)

      arg = 1
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_desc(id, arg, 'Array of strings')
      CALL ef_set_arg_type (id, arg, STRING_ARG)


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


* In this subroutine we compute the result
*
      SUBROUTINE length_of_strings_compute(id, arg_1, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* Single precision Ferret: string arg and result need to be twice the length.
      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(strdf,mem1lox:mem1hix, mem1loy:mem1hiy, 
     .     mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l
      INTEGER i1, j1, k1, l1
      INTEGER atype, iarg, slen
      CHARACTER*100 errmsg

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      CALL ef_get_arg_type (id, 1, atype)
      IF (atype .NE. STRING_ARG) THEN
        errmsg = 'must call with string argument'
        GO TO 5000
      ENDIF

      iarg = 1

      i1 = arg_lo_ss(X_AXIS,ARG1)
      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)


         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               l1 = arg_lo_ss(T_AXIS,ARG1)
               DO 100 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

                  CALL EF_GET_STRING_ARG_ELEMENT_LEN (id, ARG1, arg_1, 
     .                 i1,j1,k1,l1,  slen)

                  result(i,j,k,l) = slen

                  l1 = l1 + arg_incr(T_AXIS,ARG1)
 100           CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 300     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
 400  CONTINUE

      RETURN 
 5000 CALL EF_BAIL_OUT(id,errmsg)

      RETURN

      END

	SUBROUTINE GET_AUX_VAR_CONTEXT
     .		      ( var_cx,
     .			aux_var_cx, 
     .			aux_arg_num,
     .			status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* this routine gets the context of the auxiliary variable (e.g."depth")
* within parenthese in the format   VAR[gz(depth)=zax@ave]
*  

* it is performed in two steps: first get the context of the main variable
* VAR.  Then use the context of the parent variable as the default for the
* auxiliary variable ("depth")


* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V685 - new based upon GET_VAR_CONTEXT
* V695+ *sh* 3/15 - support joint TF -- var[gt(time2d)calt,gf(time2d)=lagf]


	IMPLICIT NONE

	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
        include 'tmap_dims.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include 'xprog_state.cmn'
	include 'xtext_info.cmn'
        include 'xdset_info.cmn_text'
	external xdset_info_data
        include 'xtm_grid.cmn_text'
        external xgt_grid_data

* calling argument declarations:
	INTEGER	 var_cx, aux_var_cx, aux_arg_num, status

* internal variable declarations:
	INTEGER	 TM_LENSTR1, AUX_AXIS_FROM_ARG,
     .		 the_axis, var_axis, aux_var_axis, i, j, idim
	CHARACTER*128 VAR_CODE, var_name, aux_var_name

* initialize
	status = ferr_ok

* copy the var_context to form the base for the aux_var context
	CALL TRANSFER_CONTEXT(var_cx, aux_var_cx)	

* remove regridding requests - aux vars must always be on native grids
	cx_has_impl_grid( aux_var_cx ) = .FALSE.
	cx_unstand_grid ( aux_var_cx ) = .FALSE.
	cx_grid		( aux_var_cx ) = unspecified_int4  ! cannot assume parent grid 

* which auxiliary var is the subject of interest?
* e.g. for "temp[gz(depth)=zax]" the argument "depth" is found in the z dim
* note that for joint TF regridding, this will return T_dim
	the_axis = AUX_AXIS_FROM_ARG(var_cx, aux_arg_num)

* pull the auxiliary variable identity from the parent context
	cx_category(aux_var_cx) = cx_aux_cat(the_axis, var_cx)
	cx_variable(aux_var_cx) = cx_aux_var(the_axis, var_cx)

* remove traces of further aux var dependency
	cx_naux         ( aux_var_cx ) = 0
	DO idim = 1, nferdims
	   cx_aux_cat (idim,aux_var_cx) = unspecified_int4  ! just bookkeeping
	   cx_aux_var (idim,aux_var_cx) = unspecified_int4  ! just bookkeeping
	   cx_aux_stat(idim,aux_var_cx) = paux_stat_na
	ENDDO

* insert bad data flag for variable
	CALL GET_CONTEXT_BAD_FLAG( aux_var_cx )

* insert data type for variable
	CALL KNOWN_DATA_TYPE( aux_var_cx )

* determine the defining grid of the auxiliary variable
	CALL GET_CONTEXT_GRID ( aux_var_cx, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
! check <0 to trap "hack" from GET_CONTEXT_MODS
	IF ( cx_grid(aux_var_cx) .EQ. unspecified_int4
     .	.OR. cx_grid(    var_cx) .EQ. unspecified_int4
     .  .OR. cx_grid(    var_cx) .LE. 0                  ) RETURN 
! return here is only reasonable during getgrid phase.  Not during eval phase.

* set up the axes of the aux variable
* only the regridding axis(s) of the aux grid may differ from the parent
	DO 500 idim = 1, nferdims
	   aux_var_axis = grid_line(idim,cx_grid(aux_var_cx))
	   var_axis     = grid_line(idim,cx_grid(    var_cx))
!3/15 	   IF (idim .EQ. the_axis) THEN  ! logic not adequate for joint TF
 	   IF (cx_aux_stat(idim,var_cx) .NE. paux_stat_na) THEN !ok logic? 3/15

	      IF (aux_var_axis .EQ. mnormal) GOTO 5300 
* ... set up to get the full index range on the regrid axes of the aux var
              cx_lo_ss ( aux_var_cx, idim )  = unspecified_int4
              cx_hi_ss ( aux_var_cx, idim )  = unspecified_int4
              cx_lo_ww ( idim, aux_var_cx )  = unspecified_val8
              cx_hi_ww ( idim, aux_var_cx )  = unspecified_val8
              cx_by_ss ( idim, aux_var_cx )  = .FALSE.       !for bookkeeping
              cx_given( idim, aux_var_cx )   = .FALSE.
	   ELSEIF (aux_var_axis .EQ. var_axis) THEN
	      GOTO 500		! already fleshed out through TRANSFER_CONTEXT
	   ELSEIF (aux_var_axis .NE. mnormal) THEN
	      GOTO 5400
	   ENDIF
	   CALL FLESH_OUT_AXIS( idim, aux_var_cx, status )  ! always ferr_ok
	   IF (status .NE. ferr_ok) 
     .	      CALL ERRMSG( ferr_internal, status, 'aux_var_ax', *5000)
 500	CONTINUE

	RETURN

* error exit
 5000	RETURN
 5300	aux_var_name = VAR_CODE(cx_category(aux_var_cx),
     .			        cx_variable(aux_var_cx) )
	var_name     = VAR_CODE(cx_category(var_cx),
     .			        cx_variable(var_cx) )
	i = TM_LENSTR1(aux_var_name)
	j = TM_LENSTR1(    var_name)
	CALL ERRMSG( ferr_invalid_command, status,
     .          'auxiliary variable '//
     .		aux_var_name(:i)//' lacks the '//
     .		ww_dim_name(the_axis)//' axis '//
     .	        'it needs to regrid '//var_name(:j), *5000 )
 5400	aux_var_name = VAR_CODE(cx_category(aux_var_cx),
     .			        cx_variable(aux_var_cx) )
	var_name     = VAR_CODE(cx_category(var_cx),
     .			        cx_variable(var_cx) )
	i = TM_LENSTR1(aux_var_name)
	j = TM_LENSTR1(    var_name)
	CALL ERRMSG( ferr_invalid_command, status,
     .          'auxiliary variable '//
     .		aux_var_name(:i)//' has a '//
     .		ww_dim_name(idim)//' axis '//
     .	        'not found on variable '//var_name(:j), *5000 )
	END

	SUBROUTINE SET_AX_SIZES( xfrac, yfrac,
     .			         xspc_lo, yspc_lo, xspc_hi, yspc_hi )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* adjust PPLUS AXLEN and ORIGIN commands to fit current plot size
* xfrac and yfrac allow viewports to specify fractions of the window size

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V230:  11/5/92 - removed from SET_PLOT_SIZE for auto-viewports
* V301:  11/3/93 - set PLOT+ symbols VP_WIDTH and VP_HEIGHT
* V540 *sh* 9/01 - white space limits passed as arguments
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'plot_setup.parm'
        include 'xplot_setup.cmn'      ! 10/91 for saved_ppl_yax
        include 'plt_inc.decl'     ! with width/height
        include 'PLT.INC'

* calling argument declarations:
        REAL*4 xfrac, yfrac, xspc_lo, yspc_lo, xspc_hi, yspc_hi

* internal variable declarations:
	INTEGER slen
	REAL	xaxlen, yaxlen, xsize, ysize
	CHARACTER TM_FMT*48, buff*24

* calculate plot size
	xsize = xfrac*width
	ysize = yfrac*height
        xaxlen = MAX( 0.001, xsize - (xspc_lo+xspc_hi) )
        yaxlen = MAX( 0.001, ysize - (yspc_lo+yspc_hi) )

* tell axis lengths to PPLUS
	WRITE ( buff, 3000 ) xaxlen, yaxlen
	CALL PPLCMD ( from, line, 0, 'AXLEN '//buff, 1, 1 )
 3000	FORMAT(2F12.3)

* define viewport size symbols to PLOT+ (11/93)
	xsize  = MAX( 0.001, xsize )
	ysize  = MAX( 0.001, ysize )
	buff = TM_FMT(xsize,-3,8,slen) 
	CALL PPLCMD ( from, line, 0, 'SET VP_WIDTH '//buff, 1, 1 )
	buff = TM_FMT(ysize,-3,8,slen) 
	CALL PPLCMD ( from, line, 0, 'SET VP_HEIGHT '//buff, 1, 1 )

* unsave previous values and set the origin
        saved_ppl_yax = .FALSE.
	WRITE ( buff, 3000 ) xspc_lo, yspc_lo
	CALL PPLCMD ( from, line, 0, 'ORIGIN '//buff, 1, 1 )

	RETURN
	END

      SUBROUTINE copyscat (ax, nax, nrng, nscat, scatm, scat1, scat2)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* ACM 11/00
*  Called by scat2gridlaplace* gridding functions.
*  If there is a modulo axis, mirror the points within nrng of each 
*  end beyond the opposite end.  Modifies nscat, scatm, scat1, and scat2.

*  ax		modulo axis
*  nax		number of points in the modulo axis
*  nrng		gridding parameter -- range of grid points used in gridding
*  nscat	input: number of scattered points;
*               output: updated number of points
*  scatm	input: scattered points coordinate array in the direction of the modulo axis;
*               output: extended coordinates
*  scat1	input: scattered points other coordinate array;
*               output: extended coordinates
*  scat2	input: scattered points function values;
*               output: extended function values

      IMPLICIT NONE
      REAL scatm(*), scat1(*), scat2(*)
      REAL*8 ax(*)
      INTEGER nscat, nscatout, nrng, i, nax
      REAL ax1, axf, del, scatpt, cut, diff

      ax1 = ax(1)
      axf = ax(nax)
      del = (ax(nax) - ax(1))/ float(nax-1)
      cut = nrng* del

      nscatout = nscat
      DO 100 i = 1, nscat
         scatpt = scatm(i)
         diff = axf - scatpt
         IF (diff .GE. 0. .AND. diff .LT. cut) THEN
            nscatout = nscatout + 1
c            scatm(nscatout) = ax1 - diff
            scatm(nscatout) = ax1 + diff
            scat1(nscatout) = scat1(i)
            scat2(nscatout) = scat2(i)
         ENDIF

         diff = scatpt - ax1
         IF (diff .GE. 0. .AND. diff .LT. cut) THEN
            nscatout = nscatout + 1
c            scatm(nscatout) = axf + diff
            scatm(nscatout) = axf - diff
            scat1(nscatout) = scat1(i)
            scat2(nscatout) = scat2(i)
         ENDIF

  100 CONTINUE

      nscat = nscatout
      RETURN
      END

	CHARACTER*(*) FUNCTION FULL_VAR_TITLE( cx, do_units, tlen )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* create a title for a memory variable including:
* i)   the variable's title, 
* ii)  modifications to the title ( either mods given as a part of the name or
*      remarks about transformations performed on the variable )

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 5/12/87
* revision 0.1 - 8/29/87 - added parend around title mod
* revision 0.2 - 4/11/88 - added units
* V200:   1/3/89 - mr --> cx
* V500: *kob* 3/99 - up VAR_UNITS from 32 to 64 
*       *acm* 3/12 cleanup ifdefs and unnecessary include files


* calling argument declarations:
	LOGICAL	do_units
	INTEGER	cx, tlen

* internal variable declarations:
	CHARACTER*200	VAR_TITLE, VAR_TITLE_MOD, PAREN_SURROUND
	CHARACTER	VAR_UNITS*64
	INTEGER		TM_LENSTR1, maxlen, slen

	include 'ferret.parm'

* initialize
	maxlen	= LEN( FULL_VAR_TITLE )

* title
	FULL_VAR_TITLE = VAR_TITLE( cx )
	tlen	       = TM_LENSTR1( FULL_VAR_TITLE )

* units
	IF (do_units) THEN
	   FULL_VAR_TITLE = FULL_VAR_TITLE(:tlen) // ' ' //
     .		PAREN_SURROUND( VAR_UNITS(cx), slen )
	   tlen = MIN( maxlen, tlen+1+slen)
	ENDIF

* mods to title
	FULL_VAR_TITLE = FULL_VAR_TITLE(:tlen) //
     .		PAREN_SURROUND( VAR_TITLE_MOD(cx), slen )

* if it wont fit indicate that with a "*" at the end
	tlen = MIN( maxlen, tlen+slen )
	IF ( tlen .EQ. maxlen ) FULL_VAR_TITLE(maxlen:maxlen) = '*'

	RETURN
	END

      SUBROUTINE CD_GET_VAR_INFO (dset, ivar, vname, vartype, 
     .            nvdims, vdims, nvatts, coordvar, outflag, cdfstat)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Read the linked list structure for netcdf variable information: given
* dset and ivar return variable name (in its original upper/lowercase 
* form), type, dimensions, number of attributes

* See also these routines which get subsets of these. 
* All of the below calls take either a variable id or variable name. 
* If the varid is < 0, it looks at the variable name and gets the varid.
*
*  The variable dimension info, 
*       SUBROUTINE CD_GET_VAR_DIMS_INFO (dset, ivar, vname, nvdims, 
*     .        vdims, status)
*
*  The logical flag true if it is a coordinate variable
*       LOGICAL FUNCTION CD_ISIT_COORDVAR (dset, ivar, vname, status)
*
*  The number of attributes the variable hase
*      SUBROUTINE CD_GET_VAR_NATTS (dset, ivar, vname, nvatts, status)
*
*  The flag, output-all-attributes
*      SUBROUTINE CD_GET_VAR_OUTFLAG (dset, ivar, vname, outflag, status)
*
*  The variable type, netCDF type 
*     SUBROUTINE CD_GET_VAR_TYPE (dset, varid, vname, vtype, status)
*
*  The variable name as it appears in the input file or variable definition,
*  including the original upper- or lower-case spelling
*      SUBROUTINE CD_GET_VAR_VARNAME (dset, varid, vname, status)
*
*
* NOTE
* 5/21/2020 
* Note that data types greater than NF_DOUBLE have been added.
* The numeric ones of these seem to work fine for us, but NF_STRING
* does not. CD_SCAN_VARS and CD_DSG_SCAN_VARS have traps to issue
* an error if datasets have variables with type.

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP

* V600 6/05 *acm* Attribute control.
* V602  2/07 *acm* Fix bug 1492, changing attributes of coordinate variables 
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V698 *sh* 1/16 -- added status check/warning, since not checked by callers
* V74+ 4/18 *acm* Getting DSG grids

* Argument declarations

      CHARACTER*(*) vname
      INTEGER dset, ivar, vartype, nvdims, vdims(*), nvatts, 
     .        outflag, cdfstat, dset_num
      LOGICAL coordvar

* Internal declarations

#include "gt_lib.parm"
      INCLUDE 'netcdf.inc'
      INCLUDE 'tmap_errors.parm'
      INCLUDE 'tmap_dims.parm'

      INTEGER TM_LENSTR1, NCF_INQ_VAR, slen, flen, rev(8), i, ndx, istat
      PARAMETER (flen=512)      ! size of variable name string

#ifdef sun
      BYTE      fhol(flen)      ! c-type Hollerith string buffer
#else
      INTEGER*1 fhol(flen)      ! c-type Hollerith string buffer
#endif 

      nvdims = 0
      nvatts = 0
      coordvar = .FALSE.
      cdfstat = atom_not_found

      DO i = 1, nferdims
         vdims(i) = line_0
      ENDDO

      IF (dset .EQ. unspecified_int4) RETURN
      IF (ivar .LT. 0) RETURN

      dset_num = dset
      cdfstat = NCF_INQ_VAR(dset_num, ivar, fhol, slen, vartype, 
     .            nvdims, nvatts, coordvar, outflag, rev)
      IF (cdfstat .NE. pcd_ferr_ok) GOTO 5000  ! not found
      slen = MIN(slen, flen)


* Return vname in original upper/lower case
      CALL TM_CTOF_STRNG ( fhol, vname, slen )

* These dims are 0,1,2,3. For Fortran want 1,2,3,4, so add 1
* Also, the dims are in C order t,z,y,x. Reverse the order, for 
* opposite array ordering of Fortran vs c

      DO 100 i = 1, nvdims
	  ndx = nvdims - i + 1
	  vdims(i) = rev(ndx) + 1
 100  CONTINUE   

5000  RETURN
      END

	SUBROUTINE ALINE_SUB (x,nxs,a_line,axmin,aymin,axmax,aymax)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Modified PPLMOD_PLTIT and PPLMOD_PLOTXY to execute the ALINE command 
*	where a line is drawn of a particular type as specified.
*	J Davison 10.4.89

*  v5.4 *acm* 10/18/01  When plotting SYM=DOT clear buffer at end: doit_makedot
*                       Remove VMS include statements
* V73  3/18 *kms*  For clarity, append MD to makedot.cmn values IPT, XDOT, 
*                  and YDOT; make MDOT (99) a makedot.cmn parameter DOTSYMIM

*****************************************************
* local variable declarations for PLTIT (for TMAP)
	REAL  	x
	INTEGER nxs
* TMAP include files with explicit type declarations:
	include 'parampl5_dat.decl'
	include 'PARAMPL5.DAT'

CCCCC	VIRTUAL X(NXS)		(*jd* 12.96 for linux port) 
	dimension X(NXS)     

	real 		cs,sn,xt,yt,oldx(4)
	real		axmin,aymin,axmax,aymax
	integer  	icnt,im,j,ibase,iy,a_line
	logical		old_swait


C	KTYPE = 1 -XY  0 -Z  2-VECTOR
	include 'lines_inc.decl'
	include 'LINES.INC'
	include 'pen_inc.decl'
	include 'PEN.INC'
	include 'axis_inc.decl'
	include 'AXIS.INC'
	include 'hd_inc.decl'
	include 'HD.INC'
	include 'taxis_inc.decl'
	include 'TAXIS.INC'
	include 'axisl_inc.decl'
	include 'AXISL.INC'
	include 'plt_inc.decl'
	include 'PLT.INC'
	include 'pltl_inc.decl'
	include 'PLTL.INC'
	include 'mplot_inc.decl'
	include 'MPLOT.INC'
	include 'cmrd_inc.decl'
	include 'CMRD.INC'
	include 'prmcom_inc.decl'
	include 'PRMCOM.INC'
	include 'miss_inc.decl'
	include 'MISS.INC'
	include 'switch_inc.decl'
	include 'SWITCH.INC'
	include 'system_inc.decl'
	include 'SYSTEM.INC'
	include 'cont_inc.decl'  !added to get ivcomp v1.1
	include 'CONT.INC'  !added to get ivcomp v1.1
        include 'gkscm2.cmn' ! jd 3.22.89
        INCLUDE 'makedot.cmn'    ! 10/01 *acm*

	CALL COLOR(IPEN(0))

	oldx(1) 	= x(1)
	x(1) 		= axmin
	oldx(2) 	= x(2)
	x(2) 		= axmax

	oldx(3)		= x(nxs/2+1)
	x(nxs/2+1) 	= aymin
	oldx(4)		= x(nxs/2+2)
        x(nxs/2+2) 	= aymax

	IBASE=0
	IY=NXS/2
	CS=COS(VANG*.01745329252)
	SN=SIN(VANG*.01745329252)
!	ZT=YF/XF
	ICNT=1

	old_swait = swait
	swait = .false.
	CALL MARKH(HMARK(a_line))
	CALL COLOR(IPEN(a_line))

c acm  Put back to old PPL  ACM 8/2000
c acm	IF(ITYPE(a_line).GE.4 .and. .not.gks_open)THEN ! JD 3.22.89 NEW PPL
c acm!	IF(ITYPE(a_line).GE.4) THEN ! OLD PPL (PRE JD 89 GKS)

	IF(ITYPE(a_line).GE.4) THEN ! OLD PPL (PRE JD 89 GKS)
	   CALL DASHSZ(DN1(a_line),UP1(a_line),DN2(a_line),UP2(a_line))
	   CALL DASHES
	ELSE
	   CALL VECTRS
	END IF

	IF(ITYPE(a_line).EQ.3)CALL POINTS

	CALL TRANS(1,X(IBASE+1),X(IY+IBASE+1),XT,YT)                
	CALL PLOT(XT,YT,0,0)
	IF (ITYPE(a_line).NE.0.AND.ITYPE(a_line).NE.4) 
     .	CALL MARK(IMARK(a_line))
	IM=0
	IF (ITYPE(a_line).EQ.1.OR.ITYPE(a_line).EQ.3)IM=IMARK(a_line)
	DO 60 J=1,2
	   CALL TRANS(1,X(J),X(IY+J),XT,YT)
	   CALL PLOT(XT,YT,1,0)
60      CALL MARK(IM)
	IF (ITYPE(a_line).EQ.2.OR.ITYPE(a_line).EQ.5) 
     .	CALL MARK(IMARK(a_line))
 	CALL COLOR(IPEN(0))

	x(1) 		= oldx(1)
	x(2) 		= oldx(2)

	x(nxs/2+1) 	= oldx(3)
        x(nxs/2+2) 	= oldx(4)

	swait = old_swait

!	CALL SCALE(XF,YF,XORG,YORG,XLO,YLO)
C
	CALL WINDOW(0.,0.,0.,0.)
C
!	IF(ITFLG.EQ.1)THEN
!	    XHI=XTI
!	    XLO=XTL
!	ELSE IF(ITFLG.EQ.-1)THEN
!	    YHI=XTI
!	    YLO=XTL
!	ENDIF


c          IF (imark(a_line) .GE. DOTSYMIM) THEN
c             CALL doit_makedot(IPTMD,XDOTMD,YDOTMD)
c             IPTMD = 0
c          ENDIF

	RETURN
	END

	SUBROUTINE INITIALIZE

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* initialize run-time variables and I/O in preparation to begin execution
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/26/86
* revision 0.1 - 12/11/86 - explicit OPEN of SYS_OUTPUT with 255 byte RECL
*			    and 255 byte RECL on journal file OPEN
* revision 0.2 - 1/30/87 - modified for mr_protected declared as INTEGER
*			   and RADIUS made a parameter in FERRET.PARM
* revision 0.3 - 5/1/87  - EXTERNAL *CONTROL and no LIST file opened
* revision 0.4 - 9/14/87 - added VMS calls to turn on line recall
* revision 0.5 - 11/30/87- added call to enable ^C interrupts
* revision 0.6 - 2/18/88 - converted X axes to "regular" format
* revision 0.7 - 5/2/88  - changed GFDL.JNL to GFDL_JOURNAL (logical) and added
*			   ERR= branch to OPEN
* revision 0.8 - 6/29/88  - changed GFDL_JOURNAL to FERRET_JOURNAL
*			    and today_time in hours:minutes, only
*			    determine mode (interactive) here
* revision 0.9 - 7/21/88 - memory initialization done by INIT_MEMORY
* revision 1.0 - 8/12/88 - added FERRET_INIT optioal initialization file
* revision 1.1 -11/22/88 - new TM IO library
* revision 1.2 - 2/2/89  - allow program to continue w/out journal file
* V200:  6/22/89 - define special grids at run time
*	 12/6/89 - initialize mode_GKS and mode_wait
* Unix/RISC port - 1/91 ... several OS dependencies fixed
*                - 9/91 - fixed err handling when journal file cant be opened
*                - 10/91 - hook to enable PLOT+ braindead features
*                - 10/91 -   FER_INIT ==> .ferret
* V230:  5/14/92 - on SGI (with no backing store) set REFRESH mode
* V300:  5/12/93 - split journal file init into another file
*		 - relocated sgi IFDEF to default REFRESH to ON
*       10/25/93 - default MODE REFRESH ON for **all** systems
*	 2/24/94 - small change due to mode_state as a 2D variable
*	 3/14/94 - base initial state of mode refresh on "ifdef X_REFRESH"
* V312:  5/19/94 - significant portions of routine removed to new MAIN program
* V313: 10/27/94 - *sh* AIX port: avoid the routine name "time"
* V420:  9/19/95 - call TM_INIT_DYN_GRIDS for dynamic (implicit) grid creation
* Linux port *kob* 3/96 - had to add calls to use F90 data and time routine
*		     rather than f77 default routines.
* V602  2/07 *acm* Fix bug 1492, changing attributes of coordinate variables 
*                  Use pseudo-dataset of user-defined axes to keep track of attributes.
* V65   2/10 *acm*- Changes for CLOCK symbols that work with gfortran as well as g77.
*                   see special_symbol.F
* V68   1/12 *acm* declarations changes for double-precision ferret.
*       3/12 *acm* cleanup ifdefs and unnecessary include files
* V698  3/16 *acm* Removed Philander-Seigel code including diagnostic 
*                  variables, pre-defined axes and grids, cat_calc_var.

        include 'tmap_errors.parm'  ! error codes
	include 'tmap_dims.parm'
	include 'xio.cmn_text'
        include 'xdset_info.cmn_text'
	external xio_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'gfdl_vms.parm'
	include	'errmsg.parm'
	include	'gfdl.parm'			! from phil/sieg
	include	'xonedim.cmn'		! from phil.sieg
	include 'xprog_state.cmn'
        include 'xalgebra.cmn'
	include 'xvariables.cmn'
	include 'xtoday.cmn'

* local variable declarations:
	LOGICAL	GKS_WINDOWS, fexist
	INTEGER	TM_LENSTR1, ito, ifrom, mem_blk, mr, iset, status
      integer icount, irate, imax
	REAL	DTIME, radian, cm2deg
	REAL*4  TArray(2), dtime_res


*************** I/O ************************************************************
	interactive = .TRUE.

* determine default GKS usage based on system logon device
	mode_GKS = GKS_WINDOWS()
	mode_wait = .NOT.mode_GKS	! no wait after plot on window device

* turn on segment-based screen refresh or screen updates dont always work
#ifdef X_REFRESH
      CALL TM_SET_FREE_EVENT(1)
      mode_state( pmode_xwindows, 1 ) = .TRUE.
#else
      mode_state( pmode_xwindows, 1 ) = .FALSE.
#endif
        CONTINUE

* set up special grids
	CALL DEFINE_SPECIAL_GRIDS   ! label 1000 moved here 9/91 *sh*

* initialize dynamic grid management
	CALL TM_INIT_DYN_GRIDS

*************** TODAY'S DATE ***************************************************


#ifdef AIX_XLF
	CALL AIX_DATE( today_date )
	CALL AIX_TIME( today_time )
#elif F90_DATE_TIME
	CALL FDATE(today_date)
	CALL FTIME(today_time)
#else
*	CALL DATE( today_date )
*	CALL TIME( today_time )
* *kob*  try new routine for y2k fix
	CALL GET_DATE_AND_TIME (today_date, today_time)
#endif
	today_time = today_time(:5)	! w/out seconds

* DTIME returns a real number which is the running time for this 
* process since the last call to DTIME. TIMEARRAY(1) reports the user time, 
* and TIMEARRAY(2) supports the system time. Argument 2 is the sum of the two.
* Call the routine to initialize the result. It can be updated by evaluating 
* the symbol DELTA_CPU. See special_symbol.F

      dtime_res = DTime(TArray)
      cpu_last = 0.0  ! in common xtoday.cmn

* ALso a special symbol CLOCK_SECS, the delta seconds in clock time since Ferret
* session is initialized.  Save clock_start_count to subtract from the value
* when this symbol is updated.

      CALL System_Clock(icount, irate, imax)
      clock_start_count = icount

* initialize pseudo-dataset in linked-list structure which will contain all 
* user variables and their attributes.
* Also another pseudo-dataset to contain user-defined coordinate variables (axes). 

        iset  = -1;
        CALL ncf_init_uvar_dset( iset )
        iset  = -2;
        CALL ncf_init_uax_dset( iset )

*************** STATE VARIABLES ************************************************
* see BLOCK DATA initialization of COMMON/ XPROG_STATE /

*********************** GRIDS **************************************************
c	CALL GFDL_TERMS

	RADIAN=57.29578							! 1027
	cm2deg = radian / radius

*************** MISCELLANEOUS **************************************************
* TMAP librabry routine errors to same output unit as other errors
	lunit_errors = err_lun

*************** INITIALIZE SPECIAL CHARACTERS *************************
*
*       Initialize special characters in COMMON - needed for g77 port to
*         comply with other compilers *kob*  3/03
	pCR = CHAR(15)

*************** BRAINDEAD PLOT+ ******************************************
        CALL PPL_BDEAD

        CALL string_array_init(alg_pvar_head,
     .                         num_pseudo_vars,
     .                         8,
     .                         alg_pvar(1))

        CALL string_array_init(countervar_name_head,
     .                         num_counter_vars,
     .                         128,
     .                         countervar_name(1))

        CALL string_array_init(uvar_name_code_head,
     .                         max_uvar,
     .                         128,
     .                         uvar_name_code(1))

        CALL string_array_init(ds_var_code_head,
     .                         maxvars,
     .                         128,
     .                         ds_var_code(1))

        CALL deleted_list_init(uvar_num_items_head,
     .                         uvar_num_items(1),
     .                         max_uvar,
     .                         uvar_deleted)

	RETURN

	END

        SUBROUTINE RESET_LABSIZ (ywid, ywidt, abssz, noylab)

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* 11/2011 ACM Fixing ticket 1896:
*
* Use origin and label-size info that is in common to possibly
* reset the axis-label size for a vertical axis, so the labels dont
* run off the edge.

* 5/12  Fix the way the size is rescaled.
*       Issue a note when the label size is reset.
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long

	REAL ywid, ywidt, abssz
	LOGICAL noylab

        include 'axis_inc.decl'
        include 'AXIS.INC'
        include 'labcom_inc.decl'
        include 'LABCOM.INC'

	REAL xl, frac, dhylab
	CHARACTER*100 note
	CHARACTER*120 argsym
	INTEGER i1, i2, len

* This is irrelevant if there is no margin anyway (viewport defined with /AXES
* up against the edge of the page.)
	IF (xorg .LT. 1.e-6) RETURN

        dhylab = 2.5*hylab
	IF (noylab) dhylab = 0.
        xl = xorg-(ywid+ywidt+dhylab)
        IF (xl.LT.0) THEN
	   frac = xorg/(ywid+ywidt+dhylab)

	   IF (frac .LT. 0) frac = 0.5  ! margin is too small for this method. Punt.
	   WRITE (note, 100) abssz, abssz* frac
	   CALL WARN (note)
	   abssz = abssz* frac

	i1 = 1
	i2 = 1
 1710   CALL LSTSYM(argsym,note,len,i1,i2)	! get next symbol
	IF(i2.EQ.0)THEN
           IF(argsym(:12) .EQ. 'LAST_GO_FILE')THEN
	      CALL WARN (note)
	   ELSE
              GOTO 1710
	   ENDIF
	      CALL LSTSYM(argsym,note,len,i1,i2) 
	   ENDIF
	ENDIF

 100	FORMAT ('Adjusting Y-axis label size from ', f5.3, ' to ', f5.3, 
     .          ', to avoid running off page. ')
	RETURN
	END

	INTEGER FUNCTION DO_FILL_AVE_DSG ( idim, haf, dset, nfeatures, maxobs,
     .				com, com_mr, com_cx,
     .				res, res_mr, res_cx)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* fill along axis idim by a running mean window
* for data on Distributed Sampling Geometries grids
*
* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Science Data Integration Group
* 2/2019
* V76   1/20 *acm* Orientation of Point-type data set to e_dim

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include	'xprog_state.cmn'
	include 'xdyn_linemem.cmn_text'
	include 'xdset_info.cmn_text'
	include 'xdsg_context.cmn'

* calling argument declarations:
	INTEGER	idim, haf, dset, nfeatures, maxobs, 
     .          com_mr, com_cx, res_mr, res_cx
	REAL	com   (*),
     .          res   (*)

* internal variable declarations:
	LOGICAL	fmask(nfeatures), omask(maxobs)
	INTEGER	i, ii,ii_com, ifeature, iobs, flen, base, 
     .		orientation, row_size_lm, dsg_fmt_grid, dsg_coord_lm, i1
	REAL	bad_res, bad_com, sum, cnt, val

* initialize
	bad_res = mr_bad_data( com_mr )

* initialize
	orientation = dsg_orientation(dset)

	IF (dsg_row_size_var(dset) .GT. 0) row_size_lm = dsg_loaded_lm(dsg_row_size_var(dset))
	bad_res = mr_bad_data( res_mr )
	bad_com = mr_bad_data( com_mr )

* get feature mask and dsg grid and coordinate information
        CALL MAKE_DSG_FEATURE_MASK(dset, res_cx, fmask, nfeatures)

	row_size_lm  = dsg_loaded_lm(dsg_row_size_var(dset))
	dsg_fmt_grid = dsg_xlate_grid(dset)
	orientation  = dsg_orientation(dset)
	dsg_coord_lm = cxdsg_coord_lm(orientation)

* ****** PERFORM THE COMPUTATION *****
	IF (idim.EQ.orientation .AND. orientation.LE.t_dim) THEN 

* *** true ragged array processing:

	   base = 0    ! obs index at end of preceding feature

* ... loop over the features
	   ftrloop: DO ifeature = 1, nfeatures 

	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
              iobs = base

* ... have the user's WW constraints removed this feature?
	      IF (.NOT.fmask(ifeature)) THEN
	         DO i = 1, flen
	            iobs = iobs + 1   ! index in the contig ragged array
	            res(iobs) = bad_res
		 ENDDO
                 base = base + flen
                 CYCLE  ftrloop
              ENDIF

* ... get observation-level mask for this feature
	      CALL MAKE_DSG_OBS_MASK(dset, com_cx, ifeature, base,
     .				     omask, flen)

* ... loop over the observations within each feature
	      oloop: DO i = 1, flen
	         iobs = iobs + 1   ! index in the contig ragged array
	         res(iobs) = bad_res
	         IF (.NOT.omask(i)) CYCLE oloop

* ... the input data value

                 val = com(iobs)

	         IF ( val .NE. bad_com ) THEN

		    res(iobs) = val

	         ELSE
		 
	            cnt = 0
	            sum = 0.0
	            DO ii = -haf, haf
	               ii_com = i + ii + base
	               IF ( ii_com.LE.base .OR. ii_com.GT.flen+base ) CYCLE
	               val = com(ii_com)
	               IF ( val .NE. bad_res ) THEN
	                  cnt = cnt + 1
	                  sum = sum + val
	               ENDIF
	            ENDDO

	            IF ( cnt .GT. 0 ) THEN
	               res(iobs) = sum / cnt
	            ELSE
	              res(iobs) = bad_res
	            ENDIF

	         ENDIF

              ENDDO  oloop

              base = base + flen

	   ENDDO  ftrloop

	ELSE

* *** a simple list of instances:

	   DO ifeature = 1, nfeatures 

* ... have the user's WW constraints removed this feature?
	      
	      IF (.NOT.fmask(ifeature)) THEN
	         res(ifeature) = bad_res
		 CYCLE
	      ENDIF

* ... the input data in the nfeature direction
              val = com(ifeature)

	      IF ( val .NE. bad_com ) THEN
	         res(ifeature) = val
	      ELSE
	      
	         cnt = 0
	         sum = 0.0
	         DO ii = -haf, haf
	            ii_com = ifeature + ii
	            IF ( ii_com.LT.1 .OR. ii_com.GT.nfeatures ) CYCLE
	            IF ( .NOT.fmask(ii_com) ) CYCLE
	            val = com(ii_com)
	            IF ( val .NE. bad_res ) THEN
	               cnt = cnt + 1
	               sum = sum + val
	            ENDIF
	         ENDDO

	         IF ( cnt .GT. 0 ) THEN
	            res(ifeature) = sum / cnt
	         ELSE
	            res(ifeature) = bad_res
	         ENDIF

	      ENDIF

           ENDDO  ! ifeature

	ENDIF     ! simple list of instances


* always success
	DO_FILL_AVE_DSG = ferr_ok
	RETURN

	END

	SUBROUTINE SAVE_FRAME_NAME(fname, clen)
	implicit none

	include 'tmap_dims.parm'
	include 'xprog_state.cmn'

	integer clen

#ifdef sun
	byte fname(clen) 
#else   
	integer*1 fname(clen)
#endif  
	call tm_ctof_strng(fname, frame_file, clen)

	return
	end

*
* student_t_cutoff.F
*
* Ansley Manke
* April 4, 2005
*

* This function returns the upper cutoff point of the Student T distribution 
*  (P.341 Koopmans .The Spectral Analysis of Time Series)
*  From Rick Romea's student_t.F


      SUBROUTINE student_t_cutoff_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

      CALL ef_set_desc(id, 'Return student-t cutoff' )

      CALL ef_set_num_args(id, 2)

      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'P')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 'Confidence Limit')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'DF')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 'Degrees of freedom')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE student_t_cutoff_compute(id, arg_1, arg_2, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

	  INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, 
     .           mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1, p, df
      REAL GetStudentT

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      i1 = arg_lo_ss(X_AXIS,ARG1)
      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               l1 = arg_lo_ss(T_AXIS,ARG1)
               DO 100 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

                  IF ( arg_1(i,j,k,l) .EQ. bad_flag(1) .OR.
     .                 arg_2(i,j,k,l) .EQ. bad_flag(2)) THEN

                     result(i,j,k,l) = bad_flag_result

                  ELSE

                     p = arg_1(i,j,k,l)
                     df = arg_2(i,j,k,l)

                     IF (P.NE.90 .AND. P.NE.95 .AND. P.NE.99)
     .                   CALL EF_BAIL_OUT(id,'P must be 90,95 or 99')
                     IF (df .LE. 0)
     .                   CALL EF_BAIL_OUT(id,'DF must be positive')

                     result(i,j,k,l) = GetStudentT(p, df)

                  END IF

                  l1 = l1 + arg_incr(T_AXIS,ARG1)
 100           CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 300     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
 400  CONTINUE
      
      RETURN 
      END

	!******************************************
	! 
	! Get the upper cutoff point of the Student T distribution 
	! (P.341 Koopmans .The Spectral Analysis of Time Series)
	!
	!******************************************
	   
c	REAL FUNCTION GetStudentT(P,Nf)
	REAL FUNCTION GetStudentT(P,df)
        IMPLICIT NONE

        INTEGER Nf,P,df  
 
	REAL ST_90(15)
	REAL ST_95(15)
	REAL ST_99(15)
	REAL T
	DATA ST_90/2.92,2.132,1.943,1.86,1.812,1.782,1.761,1.746,
     .           1.734,1.725,1.717,1.711,1.706,1.701,1.697/
	DATA ST_95/4.303,2.776,2.447,2.306,2.228,2.179,2.145,2.12,
     .           2.101,2.086,2.074,2.064,2.056,2.048,2.042/
  	DATA ST_99/9.925,4.604,3.707,3.355,3.169,3.055,2.977,2.921,
     .           2.878,2.845,2.819,2.797,2.779,2.763,2.75/


c        df=Nf*2
        nf = df/2
        IF (df .EQ. 1) nf = 1

	IF(df.GT.120)THEN
     	  IF(P.EQ.90)THEN
		T=1.645
          ELSEIF(P.EQ.95)THEN
		T=1.96
	  ELSE  !  P.EQ.99
		T=2.576
	  ENDIF
	ELSEIF(df.GT.80)THEN
	  IF(P.EQ.90)THEN
		T=1.658
          ELSEIF(P.EQ.95)THEN
		T=1.98
	  ELSE  !  P.EQ.99
		T=2.617
	  ENDIF
	ELSEIF(df.GT.50)THEN
	  IF(P.EQ.90)THEN
		T=1.671
          ELSEIF(P.EQ.95)THEN
		T=2.
	  ELSE  !  P.EQ.99
		T=2.66
	  ENDIF
	ELSEIF(df.GT.30)THEN
	  IF(P.EQ.90)THEN
		T=1.684
          ELSEIF(P.EQ.95)THEN
		T=2.021
	  ELSE  !  P.EQ.99
		T=2.704
	  ENDIF
	ELSE ! df <= 30
	  IF(P.EQ.90)THEN
	    T=ST_90(Nf)
          ELSEIF(P.EQ.95)THEN
	    T=ST_95(Nf)
	  ELSE  !  P.EQ.99
	    T=ST_99(Nf)
	  ENDIF
	ENDIF
	GetStudentT=T
	END

	SUBROUTINE CD_DSG_SCAN_VARS(dset, cdfid, errstr, status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user5/4/2005
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Setup the special variables and axes that are needed for a DSG dataset

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V720  4/17 *sh* 
* V74+  4/18 *acm* Getting DSG grids
* V74+ 4/18 *acm* Allow for the NCEI-style datasets which are one feature
*                 per file but they put the obs variables on 2D grids, 
*                 temp(feature, nobs)
* V74+ 4/18 *acm* Handle datasets with multiple varibles that have axis attributes
*                 in the same direction.  
* V74+ 6/18 *acm* Better handling/reporting of grid errors or inconsistencies
* V74+ 7/18 *acm* More on DSG attribute and grid errors. Correctly deallocate axes
* V74+ 7/18 *acm* Use axis attribute and secondarily standard_name to find coordinate
*                 variables. Improve checks for presence of coord vars. remove redundant
*                 calls in the second loop over nvars.
* V74+ 7/18 *acm* If no rowsize variable, for a single-feature file, synthesize one.
* V74+ 7/18 *acm* Better handling of grids of char variables
* V74+ 8/18 *acm* For timeseries or trajectory plots, ignore an invalid Z-coordinate
*                 variable as a coordinate
* V74+ 10/18 *acm* Add a test for whether row-size sums to the obs length 
* V74+  2/19 *acm* Set dsg_obs_dim using the dimension of the coordinate variable in the  
*                  direction of the feature-type instead of time. Some of the NCEI 
*                  examples have a single time per profile, so obs varies in z not t
* V75+  5/19 *acm* Test the value of cf_role attribute for validity before using it.
* v751 *acm*  6/19 Allow for longer strings as attribute values
* V76  1/20 *acm* working with Point-type dsg data 
* V76  3/20 *acm* Improve notes about ambiguous coord info.
* v7.6 *acm* 5/20 Issue 1876: can read string-typed data, write as char.
* V7.6 *acm* 6/20 Issue 1980: When possible open invalid DSG datasets anyway with NOTES.

* argument definitions:
*       dset    - pointer to TMAP data set
*	cdfid   - id of currently open CDF file
*	status	- return status

* include files
        include 'netcdf.inc'
	include 'tmap_errors.parm'
#include "gt_lib.parm"
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "tmap_dtypes.parm"
	include 'xdset_info.cmn_text'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xbuild_grids.cmn'
	external xdset_info_data
        include 'xdset_info.cd_equiv'
        include 'xio.cmn_text'
	include 'xtext_info.cmn' 

* argument declarations:
	INTEGER	      dset, cdfid, status
	CHARACTER*(*) errstr

* local variable declarations:
*  ivtm - TMAP library variable ID
*  ivcd - netCDF file variable ID
	LOGICAL NC_GET_ATTRIB, TM_LEGAL_NAME,
     .		got_it, got_axis, got_stdname, coordvar, got_a_variable,
     .		has_DSG_row_size, has_DSG_coordinates,
     .		has_DSG_feature_id, need_coord(4), udsg_err
	INTEGER STR_UPCASE, TM_LENSTR1,
     .		NCF_INQ_DS, STR_CASE_BLIND_COMPARE, STR_SAME,
     .		ivcd, ivtm, vartyp, nvdim, vdims(8), nvatts, all_outflag,
     .		i, maxlen, vlen, slen, eax_len, ax_len, ax2_len, is_dim,
     .		cdfstat, attlen, attoutflag, istat, las_pos, first_pos,
     .		dset_num, ndims, nvars, ngatts, recdim, idim,
     .		ax_att_var(4), ax_att_provisional(4), isend, ivtm1, orient
	CHARACTER    vname*128, buff*1028, buff1*128, name*8, axdim*1, lunits*64, dir_code*2
	REAL	vals(2), global_bad

	CHARACTER*20 CD_DSG_FEATURENAME
	CHARACTER*2  direc(4)
	CHARACTER*5  dirname(4)

* local parameter definitions:
	LOGICAL	    do_warn
	INTEGER     str_eq
	PARAMETER ( str_eq = 0,
     .		    do_warn = .TRUE. )

	DATA	direc(1) / 'XY' /,
     .		direc(2) / 'XY' /,
     .		direc(3) / 'Z ' /,
     .		direc(4) / 'T' /
	DATA	dirname(1) / 'lon ' /,
     .		dirname(2) / 'lat ' /,
     .		dirname(3) / 'vert' /,
     .		dirname(4) / 'time' /

* initialize

	has_DSG_row_size    = .FALSE.
	has_DSG_coordinates = .FALSE.
	has_DSG_feature_id  = .FALSE.
        maxlen = 1028
	eax_len = 0
	las_pos = 1
	global_bad = -1.E34
	dsg_instance_axis = int4_init
	udsg_err = .FALSE.

* The feature-id variable is identified by having a feature_id attribute
* according to the feature type

* get the vital statistics for the data set 
        dset_num = dset
        istat = NCF_INQ_DS (dset_num, ndims, nvars, ngatts, recdim )
	orient = dsg_orientation(dset) 

* First find probable coordinate variabes - if the axis attribute is
* present these will be the coords even if other variables have units
* indicating an axis direction. This to distinguish e.g between deplooyment
* time and location vs the observation times and locations.

* Prioritize attributes for direction: 
*  axis attribute: X, Y, Z, T
*  standard_name:  time, longitude, latitude, height/depth 
*         (distinguish from e.g. time_coverage_start or  geospatial_lon_min)
* When these are found, use units to nail down the direction.
*
* Check: need lon, lat, time for all feature types. Profiles need depth/height.

	DO idim = 1, 4
	   ax_att_var(idim) = int4_init
	   ax_att_provisional(idim) = int4_init
	   need_coord(idim) = .TRUE.
	   IF (idim.EQ.z_dim .AND. orient.NE.z_dim) need_coord(z_dim) = .FALSE.
	ENDDO

        DO ivcd = 1, nvars
           CALL CD_GET_VAR_INFO (dset, ivcd, vname, vartyp,
     .                 nvdim, vdims, nvatts, coordvar, 
     .                 all_outflag, status)
	   
           vlen = TM_LENSTR1(vname)
	   got_axis = NC_GET_ATTRIB( dset, ivcd, 'axis',
     .                 do_warn, vname(:vlen), maxlen, attlen, attoutflag, 
     .                 buff, vals )

	   got_stdname = NC_GET_ATTRIB( dset, ivcd, 'standard_name',
     .                 do_warn, vname(:vlen), maxlen, attlen, attoutflag, 
     .                 buff, vals )

           IF (got_stdname) THEN  ! is it a direction?
	      IF (STR_SAME (buff, 'time')      .EQ. 0 .OR. 
     .            STR_SAME (buff, 'longitude') .EQ. 0 .OR.
     .            STR_SAME (buff, 'latitude')  .EQ. 0 .OR.
     .            STR_SAME (buff, 'depth')     .EQ. 0 .OR. 
     .            STR_SAME (buff, 'altitude')  .EQ. 0 ) THEN

	      ELSE 
	         got_stdname = .FALSE.
	      ENDIF
           ENDIF
	   
	   IF (got_axis .OR. got_stdname) THEN  ! look at units for direction
	   
              lunits = ''
              got_it = NC_GET_ATTRIB( dset, ivcd, 'units',
     .                 do_warn, vname(:vlen), maxlen, attlen, attoutflag, 
     .                 buff, vals )
              IF ( got_it) lunits = buff(:64)

              CALL CD_GET_LINE_DIRECTION (dset, ivcd,
     .             vname(:vlen), lunits, do_warn, .TRUE., dir_code)
              status = STR_UPCASE(axdim, dir_code(1:1))

              IF (dir_code .EQ. 'NA') CYCLE

              is_dim = 0
	      IDIMLOOP: DO idim = 1, 4
                 ! 'X','Y','Z','T'
                 IF (axdim .EQ. ww_dim_name(idim)) is_dim = 1
                 IF (idim .EQ. 1 .AND. axdim .EQ. 'W') is_dim = 2
                 IF (idim .EQ. 2 .AND. axdim .EQ. 'S') is_dim = 2
                 IF (idim .EQ. 3 .AND. (axdim .EQ. 'U' .OR. axdim .EQ. 'D')) is_dim = 2
                 IF (idim .EQ. 4 .AND. (dir_code .EQ. 'TI')) is_dim = 2

*    Prioritize variable with standard name or axis attrib

                 IF (is_dim .GT. 0) THEN

                    IF (ax_att_var(idim).NE.int4_init .AND.got_axis) THEN 
* ... corrupted file:  two variables claiming to be same coordinate
                       ivtm = ax_att_var(idim)
		       CALL CD_GET_VAR_VARNAME (dset, ivtm, buff, status)
		       IF (axdim .EQ. 'W') axdim = 'E'
		       IF (axdim .EQ. 'S') axdim = 'N'
		       IF (axdim .EQ. 'U' .OR. axdim .EQ. 'D') axdim = 'Z'
		       CALL WARN('Ambiguous DSG coordinate info. '//
     .                        'Multiple variables claiming to be '//
     .                         ww_dim_name(idim)//' axis: '// buff(:TM_LENSTR1(buff) )//
     .                         ', '// vname(:vlen) //'. Using '//
     .                         buff(:TM_LENSTR1(buff))//'.'   )
                    ELSE
		       IF (got_axis .AND. is_dim.EQ.2) ax_att_var(idim) = ivcd
		       IF (got_stdname .AND. .NOT.got_axis) ax_att_provisional(idim) = ivcd
		       IF (got_axis .AND. is_dim.EQ.1) ax_att_provisional(idim) = ivcd
                    ENDIF
		    EXIT IDIMLOOP

                 ENDIF ! is_dim
              ENDDO  IDIMLOOP
     
           ENDIF  ! got axis or std name
	   
	   IF (vartyp.LT.nf_byte .OR. vartyp.GT.nf_string) GOTO 5700

        ENDDO ! ivcd

* Are there required directions not yet found?  Try any found from std name, otherwise
* this is an error.

	DO idim = 1, 4
	   IF (ax_att_var(idim).EQ.int4_init) 
     .             ax_att_var(idim) = ax_att_provisional(idim)
	ENDDO

	vname = ' '
	slen = 1
	DO idim = 1, 4
	   IF (ax_att_var(idim).EQ.int4_init .AND. need_coord(idim)) THEN
	      IF (slen .EQ. 1) THEN
	         vname(slen:) = dirname(idim)
		 slen = slen+4
              ELSE
	         vname(slen:) = ', '//dirname(idim)
                 slen = slen+6
	      ENDIF
	   ENDIF
	ENDDO
	IF (slen .GT. 1) THEN
	   buff1 = CD_DSG_FEATURENAME(orient)
	   vlen = TM_LENSTR1( buff1 ) 
	   errstr = 'Required coordinate variables not found. '//
     .	          buff1(:vlen)//
     .            ' file is missing directions: '//vname(:slen) 
	   status = merr_dsg_struc
	   GOTO 5500
	ENDIF
	
	got_a_variable = .FALSE.
	dsg_instance_dim = no_dim

*** process the key instance variables in the file
        ivcdloop: DO ivcd = 1,nvars

* get the vital statistics for this variable
           CALL CD_GET_VAR_INFO (dset, ivcd, vname, vartyp,
     .                 nvdim, vdims, nvatts, coordvar, 
     .                 all_outflag, status)
           IF ( status .NE. merr_ok ) GOTO 5400
           vlen = TM_LENSTR1(vname)

           IF (vartyp .EQ. NF_CHAR) THEN
              nvdim = nvdim - 1
	      vdims(1) = vdims(2)
	      IF (nvdim .GT. 1)  vdims(2) = vdims(3)
	   ENDIF


****
* register the variable as a dependent variable in the dataset
	   CALL CD_GET_1_DEP_VAR ( dset, cdfid, ivcd, las_pos, global_bad, 
     .				   ivtm, status )
	   IF (status .NE. merr_ok) GOTO 5400
	   IF ( ivtm .NE. 0 ) THEN
	      las_pos = ivtm	! optimizes next hunt for slot
	      IF (.NOT.got_a_variable) THEN
	         first_pos = ivtm
	         got_a_variable = .TRUE.
	      ENDIF
	   ENDIF

	   IF (nvdim.EQ.0) CYCLE  ivcdloop  ! scalar variables

****
* Check for the feature-id variable and store it so it can be read.
* Ideally would read the id's for use in labels and possibly masks. ?

* It is identified by its "cf_role" attribute, with value feature_id, eg. 
*  :cf_role = "trajectory_id" ;
* Compare the value: invalid to have a cf_role with value other than 
* e.g. trajectory_id for one of the valid feature-types.

	   got_it = NC_GET_ATTRIB( dset, ivcd, 'cf_role',
     .                 do_warn, vname(:vlen), maxlen, attlen, attoutflag, 
     .                 buff, vals )
	   IF (got_it) THEN
	      
	      buff1 = CD_DSG_FEATURENAME ( orient ) ! compare with buff...
	      buff1 = buff1(:TM_LENSTR1(buff1))//'_id'

	      IF (STR_SAME (buff, buff1) .EQ. 0) THEN
	         has_DSG_feature_id = .TRUE.
	         dsg_feature_var(dset) = ivtm 

	         cdfstat = NF_INQ_DIMLEN(cdfid, vdims(1), eax_len)
	         dsg_instance_dim = vdims(1)
	         CYCLE  ivcdloop

* check other valid feature types (if use/feature= then the type may not match)
	      ELSE

	         DO idim = 1, 4
		    IF (idim .EQ. 2) CYCLE 
		    buff1 = CD_DSG_FEATURENAME ( idim ) 
		    buff1 = buff1(:TM_LENSTR1(buff1))//'_id'
	            IF (STR_SAME (buff, buff1) .EQ. 0) THEN
		       has_DSG_feature_id = .TRUE.
		       dsg_feature_var(dset) = ivtm 

		       cdfstat = NF_INQ_DIMLEN(cdfid, vdims(1), eax_len)
		       dsg_instance_dim = vdims(1)
	               CYCLE  ivcdloop
		    ENDIF
		 ENDDO

		 CALL WARN('Invalid cf_role attribute ignored on variable '//
     .               vname(:vlen) )
	      ENDIF

	   ELSE
	      IF (vartyp .EQ. NF_CHAR) CYCLE ! no string var coords or rowSize
	   ENDIF 

! DSGTBD - currently code is very rigid about what a DSG file can have
! DSGTBD - can have scalars, instance vars and obs vars.  Else reject as a DSG.
! - NCEI template for single feature does not include a RowSize variable.
!          Create one on the fly, of length 1, value npts.

! The NCEI templates all have the obs variables on grids of (obs, traj) where traj = 1.
! Allow for this case but not other multi-dimensioned variables.

	   cdfstat = NF_INQ_DIMLEN(cdfid, vdims(1), ax_len)

	   IF (nvdim .GT. 1) THEN
	      cdfstat = NF_INQ_DIMLEN(cdfid, vdims(2), ax2_len)
	      IF (ax2_len .GT. 1) THEN
	         errstr = 'DSG ragged array: observation variables must be 1-D '//vname(:vlen)
	         IF (status .NE. merr_dsg_grid) status = merr_dsg_struc
	         GOTO 5500
	      ENDIF
	   ENDIF

* the DSG row size variable is identified by its "sample_dimension" attribute
           got_it = NC_GET_ATTRIB( dset, ivcd, 'sample_dimension',
     .                 do_warn, vname(:vlen), maxlen, attlen, attoutflag, 
     .                 buff, vals )
	   IF (got_it) THEN
	      cdfstat = NF_INQ_DIMLEN(cdfid, dsg_instance_dim, ax_len)
	      IF (ax_len.EQ.0) THEN
* ... first encounter with instance axis
	         dsg_instance_dim = vdims(1)
	         cdfstat = NF_INQ_DIMLEN(cdfid, dsg_instance_dim, eax_len)
	      ENDIF
	      dsg_row_size_var(dset) = ivtm
	      dsg_row_size_varid(dset) = ivcd
	      CALL CD_GET_DSG_INSTANCE_VAR(dset, cdfid, ivcd, ivtm,
     .                 vdims, nvdim, eax_len, pdsg_row_size,
     .                 dsg_loaded_lm(ivtm), errstr, status)
	      IF (status .NE. merr_ok) THEN
	         IF (status .NE. merr_dsg_grid) status = merr_dsg_struc
	         GOTO 5500
	      ENDIF
	      has_DSG_row_size = .TRUE.

* ... the sample_dimension attribute provides the name of the obs dimension.
*     Get its id number from its name.
	      slen = TM_LENSTR1(buff)
	      cdfstat = NF_INQ_DIMID ( cdfid, buff(:slen), dsg_obs_dim)
	      IF ( cdfstat .NE. NF_NOERR )  GOTO 5400
	      CYCLE 
	   ENDIF

* the DSG coordinate arrays

	   DO idim = 1, 4
	      IF (ax_att_var(idim) .NE. ivcd) CYCLE

	      IF (dsg_coord_var(idim,dset) .EQ. int4_init) THEN

		 CALL CD_GET_DSG_INSTANCE_VAR(dset, cdfid, ivcd, 
     .	             ivtm,vdims, nvdim, ax_len, idim, 
     .	             dsg_loaded_lm(ivtm), errstr, status)
		 IF (status .EQ. 0) THEN 
		     CYCLE  ! corrupted var, ignore as a coord
		 ENDIF

		 IF (status .NE. merr_ok) THEN
		    IF (status .NE. merr_dsg_grid) status = merr_dsg_struc
		    GOTO 5500
		 ENDIF
		 dsg_coord_var(idim,dset) = ivtm
		 IF (idim .EQ. orient)
     .			has_DSG_coordinates = .TRUE.

		 EXIT 
	      ENDIF
	   ENDDO
	   CYCLE ivcdloop  ! unrecognized DSG axis orientation. 

	ENDDO ivcdloop

* A valid DSG contiguous ragged dataset must have a rowSize variable
* and coordinates on the dsg_orientation axis. If they erroneously set
* the /FEATURETYPE to an invalid direction, that's an error. Otherwise
* continue without dsg-ness.

	IF (.NOT.has_DSG_coordinates .AND. dsg_user_direction.NE.int4_init) GOTO 5100

* Point type data does not have a RowSize variable and may not have a feature-id variable.
* All the variables are on the instance axis, so find that axis in the first variable
* and nominally set the feature-id variable to the time variable and obs_dimlen to e-axis length

	IF (dsg_feature_type(dset) .EQ. pfeatureType_Point) THEN
	   IF (.NOT. has_DSG_feature_id ) THEN
	      
              ivcd = 1
	      CALL CD_GET_VAR_INFO (dset, ivcd, vname, vartyp,
     .                 nvdim, vdims, nvatts, coordvar, 
     .                 all_outflag, status)
              IF ( status .NE. merr_ok ) GOTO 5400

              IF (vartyp .EQ. NF_CHAR) THEN
                 nvdim = nvdim - 1
	         vdims(1) = vdims(2)
	         IF (nvdim .GT. 1)  vdims(2) = vdims(3)
	      ENDIF
	      cdfstat = NF_INQ_DIMLEN(cdfid, vdims(1), eax_len)

	      has_DSG_feature_id = .TRUE.
	      dsg_feature_var(dset) = dsg_coord_var(t_dim,dset) 
	      dsg_instance_dim = vdims(1)
	      dsg_obs_dimlen(dset) = eax_len
	      dsg_row_size_var(dset) = 1

	   ENDIF
	   
	ENDIF


* Single-feature files may not have the RowSize variable (NCEI standard unfortunately)
* Use the length of the feature-id variable, and the length of the time axis
* to set things up. Construct a dataset-variable ferRowSize.

	IF (.NOT. has_DSG_row_size ) THEN
	   IF (has_DSG_feature_id) THEN
	      CALL CD_GET_VAR_DIMS_INFO (dset, dsg_feature_var(dset), vname, nvdim, 
     .            vdims, status)
	
	      IF (dsg_instance_dim .EQ. no_dim) THEN
	          cdfstat = NF_INQ_DIMLEN(cdfid, vdims(1), eax_len)
	          IF (eax_len .EQ. 1) dsg_instance_dim = vdims(1)
	      ENDIF

	      IF (eax_len.EQ.1 .OR. dsg_feature_type(dset).EQ.pfeatureType_Point) THEN
	      
* ... instance axis is the 'feature' axis - may already be set

	         DO ivtm = 1, maxvars
	            IF ( STR_SAME(ds_var_code(ivtm),char_init) .EQ. 0 ) exit
		 ENDDO
	         ds_var_setnum(ivtm)   = dset
		 vname = 'ferRowSize'
	         CALL string_array_modify(ds_var_code_head, ivtm, 
     .               vname, 10)

	         ds_var_title(ivtm)    = 'synthesized rowsize'
	         ds_var_titl_mod(ivtm) = ' '
	         ds_var_units(ivtm)    = 'count'
	         ds_missing_flag(ivtm) = global_bad
	         ds_bad_flag(ivtm)     = global_bad
	         ds_var_type(ivtm)     = ptype_float

	         ds_grid_start(e_dim,ivtm) = 1
	         ds_grid_end(e_dim,ivtm)   = eax_len
		 
		 ivcd = nvars + 1
		 cd_scale_factor(ivtm) = 1.
		 cd_add_offset(ivtm)   = 0.
		 cd_scaled(ivtm)       = .FALSE.
		 cd_varid(ivtm)       = ivcd  

* Add the synthesized variable to the linked list structure
		 nvdim = 1  ! and vdims is as for feature-id var, gotten above.
		 
		 vname = 'ferRowSize'
		 coordvar = .FALSE.

! use ivtm not ivcd, so that  cd_varid(ivtm) = ivtm is correct?
		 CALL CD_ADD_VAR( dset, vname, ivcd, ds_var_title(ivtm), 
     .             ds_var_units(ivtm), NCFLOAT, coordvar, ds_bad_flag(ivtm), status)

!! check:     
		 CALL CD_GET_VAR_INFO (dset, ivcd, buff, vartyp,
     .                 nvdim, vdims, nvatts, coordvar, 
     .                 all_outflag, status)

* Point data has neither a Rowsize variable nor an OBS axis. Synthesize
* rowsize as an axis that's 1:npoints, each value being 1, and an obs
* axis of length npoints

	         IF (dsg_feature_type(dset) .EQ. pfeatureType_Point) THEN


* Don't need to allocate memory for the synthesized Obs axis
* just use the basic-axis call in CD_DSG_SETUP_PTDATA (?)

	            DO ivtm1 = ivtm, maxvars
	               IF ( STR_SAME(ds_var_code(ivtm1),char_init) .EQ. 0 ) exit
		    ENDDO

		    CALL CD_DSG_SETUP_PTDATA (dset, eax_len, 
     .                 dsg_loaded_lm(ivtm), dsg_loaded_lm(ivtm1), status)
	         ELSE
		    isend = -1*ivcd
		    CALL CD_GET_DSG_INSTANCE_VAR(dset, cdfid, isend, ivtm,
     .                 vdims, nvdim, eax_len, pdsg_row_size,
     .                 dsg_loaded_lm(ivtm), errstr, status)
	         ENDIF

		 IF (status .NE. merr_ok) THEN
		    IF (status .NE. merr_dsg_grid) status = merr_dsg_struc
		    GOTO 5500
		 ENDIF

	         dsg_row_size_var(dset) = ivtm
	         dsg_row_size_varid(dset) = unspecified_int4
	         has_DSG_row_size = .TRUE.

* ... Set dsg_obs_dim using dimension of the coordinate variable in the direction of the feature-type
*     For point data just nominally use the first variable with a direction.

	         idim = orient
		 IF (idim .EQ. e_dim) THEN
		    DO idim = 1, 4
		       IF (ax_att_var(idim) .NE. int4_init) EXIT  ! from loop
		    ENDDO
		 ENDIF
		 CALL CD_GET_VAR_DIMS_INFO (dset, ax_att_var(idim),  
     .             vname, nvdim, vdims, status)
	         IF (nvdim .EQ. 1) THEN
		    dsg_obs_dim = vdims(1)
		 ELSE
		    DO idim = 1, nvdim
		       IF (vdims(idim) .NE. dsg_instance_dim) dsg_obs_dim = vdims(idim)
		    ENDDO
		 ENDIF

	      ENDIF

	   ENDIF

	   IF ( .NOT.has_DSG_feature_id .OR. (eax_len.GT.1 .AND.  
     .             dsg_feature_type(dset).NE.pfeatureType_Point) ) THEN
	      errstr = 'Row Size variable w/ sample_dimension attribute not found. ' 
	      status = merr_dsg_struc
	      GOTO 5500
	   ENDIF

	ENDIF


*   * * * * * * * * * * * * * * * * * * * * * * * * 
* pass through the variable names making sure that case-sensitive
* duplicates (e.g. 'var' and 'VAR') retain case and that names which
* would be illegal variable names to Ferret are retained in original form
	IF (got_a_variable) THEN
	  DO 310 ivtm = first_pos,las_pos
	    IF (ds_var_setnum(ivtm) .NE. dset) GOTO 310
	    IF (.NOT.TM_LEGAL_NAME(ds_var_code(ivtm))) GOTO 310  ! leave as-is
* ... see if this name case-blind duplicates any other in the data set
	    DO 300 i = first_pos,las_pos
* ... *kob* v541 8/02 - need to also check and make sure we are still dealing with the
*     same dataset.  if not, when variables from different data sets are interleaved 
*     in ds_var_code this can cause Ferret to not properly upcase variables from 
*     one dset that have the same name as variables in another dset. 
	      IF ( i .EQ. ivtm .OR. ds_var_setnum(i) .NE. dset) GOTO 300
	      istat = STR_CASE_BLIND_COMPARE(ds_var_code(ivtm),
     .                                       ds_var_code(i)    )
	      IF ( istat .EQ. str_eq ) GOTO 310                  ! leave as-is
 300	    CONTINUE
* ... (finally) upcase the name
*	  istat = STR_UPCASE( ds_var_code(ivtm), ds_var_code(ivtm) )
          CALL STRING_ARRAY_MODIFY_UPCASE(ds_var_code_head,ivtm,
     .                                    ds_var_code(ivtm),
     .                                    LEN(ds_var_code(ivtm)))
 310    CONTINUE
	ENDIF


* Checklist:
*  coordinate variables for at least, X, Y, T. (checked above)
*  feature-id variable
*  row-size variable  (checked above)

	IF (.NOT. has_DSG_feature_id) THEN
	   errstr = 'Feature-ID variable not found or '//
     .      'invalid value of cf_role attribute'
	   status = merr_dsg_struc
	   GOTO 5500
	ENDIF

*  No mask is set, but initialize the memory location to unspecified_int4
	dsg_msk_lm(dset) = unspecified_int4

* check the time data: is it monotonically increasing?  For now this is
* an error; later perhaps we'll sort unsorted data internally? This checks 
* for strict monotonic.  Could perhaps use tm_check_coords-type logic

* The routine also checks that rowsize sums to the observation-axis length

	IF ( dsg_feature_type(dset).NE.pfeatureType_Point) 
     .     CALL CD_DSG_CHECK_TIMECOORD ( eax_len,  dsg_obs_dimlen(dset),
     .     dsg_loaded_lm(dsg_row_size_var(dset)), 
     .     dsg_loaded_lm(dsg_coord_var(t_dim,dset)), errstr, status )

	IF (status .NE. merr_ok) THEN
	   IF (status .NE. merr_dsg_grid) status = merr_dsg_struc
	   GOTO 5500
	ENDIF
	
* successful completion
	status = merr_ok
 5000	RETURN

* Invalid DSG: Clean up initialization as DSG and go back, try to 
* initialize it as a non-DSG file

 5500   CONTINUE
	udsg_err = (.NOT.udsg_err .AND. dsg_user_direction .NE. int4_init)
	buff1 = CD_DSG_FEATURENAME(dsg_user_direction)

	IF (dsg_instance_axis .NE. int4_init) CALL TM_DEALLO_DYN_LINE(dsg_instance_axis)
	DO idim = 1, nferdims
	   IF (ds_basic_axes(idim,dset) .NE. int4_init)
     .        CALL TM_DEALLO_DYN_LINE(ds_basic_axes(idim,dset) )
	ENDDO
	CALL CD_RELEASE_DSG_INSTANCE_VARS(dset)
	DO  i = 1, maxvars
	   IF (ds_var_setnum(i) .EQ. dset) ds_var_setnum(i) = set_not_open
	ENDDO
	dsg_ragged(dset) = .FALSE.


* hard errors

* It's an error if they try USE/FEATURE= on invalid DSG dataset
	IF (udsg_err) THEN
	   buff = 'Requested USE/FEATURE='//buff1(:vlen)//
     .        ', but dataset is not a valid DSG file '
	   CALL TM_ERRMSG (merr_invalid, status, 'CD_DSG_SCAN_VARS',
     .         no_descfile, no_stepfile,
     .         buff, no_errstring, *5000)
        ENDIF

	GOTO 5000
  
 5100   buff1 = CD_DSG_FEATURENAME(dsg_user_direction)
	buff = 'USE/FEATURE='//buff1(:vlen)//
     .     ' ... must have observations along '//direc(dsg_user_direction)
	udsg_err = .TRUE.
	CALL TM_ERRMSG (merr_dsg_grid, status, 'CD_DSG_SCAN_VARS',
     .     no_descfile, no_stepfile, buff, no_errstring, *5500)

 5400   CALL TM_ERRMSG (merr_invalid, status, 'CD_DSG_SCAN_VARS',
     .     no_descfile, no_stepfile,
     .     buff, no_errstring, *5500)


 5700   CALL TM_ERRMSG
     .     ( merr_notsupport, status, 'CD_SCAN_VARS', dset_num,
     .         no_stepfile, 
     .         'String Data Type not implemented: variable '//vname(:vlen),
     .         no_errstring,*5500)

	RETURN
	END

      SUBROUTINE DO_INTERNAL_GC_FCN( 
     .				fcn, num_com, com_cx,
     .				com1, mr1, pdim1, typ1,
     .				com2, mr2, pdim2, typ2,
     .				com3, mr3, pdim3, typ3,
     .				com4, mr4, pdim4, typ4,
     .				com5, mr5, pdim5, typ5,
     .				com6, mr6, pdim6, typ6,
     .				com7, mr7, pdim7, typ7,
     .				com8, mr8, pdim8, typ8,
     .				com9, mr9, pdim9, typ9,
     .				res, mres, pdimr, typr,
     .                          res_cx, status )

* This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute a grid changing function

* the addition (or major modification) of an internal grid-changing function
* requires changes to these routines:
*	grid_chg_fcns.parm	- parameters to number the functions
*	XGRID_CHG_FCNS_DATA	- description of the function and args
*	DO_INTERNAL_GC_FCN	- code to execute the function
* (opt)	GCF_GET_IMPOSED_AXES	- return the "imposed" axes, if any
* (opt)	GCF_IMPOSE_RESULT_LIMS	- fill in limits of "imposed" axes, if any

* V450:  1/97 - new, based on operate.F, but for grid changing functions
*        7/97 - complete the ZAXREPLACE function
*       7/25/97 - increase number of args from 4 to 9
*               - add function PPLGRID
*       10/30/97 - fixed bug in UNRAVEL introduced in 7/25 changes
*                       "m5lox" --> "m10lox", etc.
*       11/12/97 - bug fix in ZAXREPLACE when destination field has missing
*                       values. New routine EXTRACT_Z_AXIS
* V491:  4/98 - fixed bugs in ZAXREPLACE: see err491_zaxreplace.jnl
*       need to guide calculation with  cx lims rather than mr lims of args
*       (see EXTRACT_Z_LINE) and
*       need to recognize the missing value flags of the first arg
* V500:  1/99 *sh* comandeered the TIMES2 function for string argument testing
*               renamed it to ECHO
*       2/99 changed UNRAVEL to XUNRAVEL. Added YUNRAVEL, ZUNRAVEL, TUNRAVEL
*       3/99 - made ECHO into a 2 argument function
* V510: 8/99 *sh* - added SAMPLE* functions (just copy arg 2 to result here --
*               the work is done in IS_ALGEBRA and IS_SAMPLE
* V533: *sh* 6/01 - arguments and result may be string or float
*                 - added SPAWN function
* V540: *sh* 12/01 - added STRCMP function
* V541: *kob* 6/02 - Add STRLEN, UPCASE,DNCASE,STRINDEX, STRRINDEX
*                        SUBSTRING, STRCAT, STRFLOAT 
*                    internal string handling functions   
* V552: *acm* 4/02 - Allow for zero-length strings in STRRINDEX fcn:
*                    STRRINDEX ("my string", "") had caused Ferret to hang.
* V580:10/04 *acm* Fix for bug 1037. In zaxreplace, before the loop calling 
*                  hunt_r4, set the initial guess for ndx_lo to 1 not 0. 
* V581  3/05 *acm* increase buffer length max_cmnd_len to 2048. 
*       3/05 *acm& Change call to strfloat, to return bad-flag if input 
*                  string cannot be converted to float.
* V600  5/06 *acm* In the fix to STRRINDEX, wrong indices in com2 
*                  CALL C_STRLEN(com2(1,i2,j2,k2,l2),ii) led to a crash
*                  when applying STRRINDEX to a list of strings.
* V68   1/12 *acm* call C_SUBSTR with integers for offset and length.
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
*       2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V68   3/12 *KMS/ACM* see 6D branch: working on string bugs. Remove overloading
*                   of argument/return-type variable and predimensional (data size)
*                   array parameter (pointer size to one in double-precision Ferret).
* V68   5/12 *acm* Add ESEQUENCE, FSEQUENCE, SAMPLEM, SAMPLEN
* V693 10/14 *acm* ticket 2210: check for negative arguments to SUBSTRING

* keep max_cmnd_len for SPAWN at 2048 while Ferret command buffer
*      increases to 20480
* V702 1/17 *sh* for trac enhancement #2369 -- dynamic memory management 

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
        include 'grid_chg_fcns.parm'
	include 'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xcontext.cmn'

* calling argument declarations:
	INTEGER	fcn, num_com, com_cx(9), status,
     .		mr1, mr2, mr3, mr4, mr5, mr6, mr7, mr8, mr9, mres,
     .          pdim1, pdim2, pdim3, pdim4, pdim5, pdim6, pdim7,
     .          pdim8, pdim9, pdimr,
     .          typ1, typ2, typ3, typ4, typ5, typ6, typ7, typ8, typ9,
     .          typr, res_cx
	REAL com1( pdim1,m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .             m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .       com2( pdim2,m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .             m2lot:m2hit,m2loe:m2hie,m2lof:m2hif ),
     .       com3( pdim3,m3lox:m3hix,m3loy:m3hiy,m3loz:m3hiz,
     .             m3lot:m3hit,m3loe:m3hie,m3lof:m3hif ),
     .       com4( pdim4,m4lox:m4hix,m4loy:m4hiy,m4loz:m4hiz,
     .             m4lot:m4hit,m4loe:m4hie,m4lof:m4hif ),
     .       com5( pdim5,m5lox:m4hix,m5loy:m5hiy,m5loz:m5hiz,
     .             m5lot:m5hit,m5loe:m5hie,m5lof:m5hif ),
     .       com6( pdim6,m6lox:m4hix,m6loy:m6hiy,m6loz:m6hiz,
     .             m6lot:m6hit,m6loe:m6hie,m6lof:m6hif ),
     .       com7( pdim7,m7lox:m4hix,m7loy:m7hiy,m7loz:m7hiz,
     .             m7lot:m7hit,m7loe:m7hie,m7lof:m7hif ),
     .       com8( pdim8,m8lox:m4hix,m8loy:m8hiy,m8loz:m8hiz,
     .             m8lot:m8hit,m8loe:m8hie,m8lof:m8hif ),
     .       com9( pdim9,m9lox:m4hix,m9loy:m9hiy,m9loz:m9hiz,
     .             m9lot:m9hit,m9loe:m9hie,m9lof:m9hif ),
     .       res( pdimr,m10lox:m10hix,m10loy:m10hiy,m10loz:m10hiz,
     .            m10lot:m10hit,m10loe:m10hie,m10lof:m10hif )

* internal variable declarations:
	INTEGER CX_DIM_LEN,  CGRID_SIZE,
     .		count, size, icom, idim, ii,
     .		cx1, cx2, cx3,
     .           i,   j,   k,   l,   m,   n,
     .           i1,  j1,  k1,  l1,  m1,  n1,
     .           i2,  j2,  k2,  l2,  m2,  n2,
     .           i3,  j3,  k3,  l3,  m3,  n3,
     .          di1, dj1, dk1, dl1, dm1, dn1,
     .          di2, dj2, dk2, dl2, dm2, dn2,
     .          di3, dj3, dk3, dl3, dm3, dn3,
     .          si1, sj1, sk1, sl1, sm1, sn1,
     .          si2, sj2, sk2, sl2, sm2, sn2,
     .          si3, sj3, sk3, sl3, sm3, sn3,
     .          ind(nferdims)
        INTEGER klo, khi, ndx_lo, ioff, ilen
        INTEGER coded_pointer, uvar, item, start, end   ! for TIMES2
        INTEGER*8 i8_size
	REAL    bad_res, bad1, bad2, bad3,
     .          zval, frac
        REAL*8  TM_WORLD
        INTEGER max_cmnd_len
        PARAMETER ( max_cmnd_len = 2048 )
        CHARACTER GET_STRING_ELEMENT*(max_cmnd_len), buff*(max_cmnd_len)
	CHARACTER*10 TM_FMT, argval
        INTEGER nnew, slen, narg

* equivalence conveniences
* "inc" is the increments for each axis of each component
* "lo"  is the starting subscript (minus 1) for each axis of each component
	INTEGER	inc(nferdims,3), lo(nferdims,3)
	EQUIVALENCE
     .      (lo(1,1), si1), (lo(2,1), sj1), (lo(3,1), sk1),
     .      (lo(4,1), sl1), (lo(5,1), sm1), (lo(6,1), sn1),
     .      (lo(1,2), si2), (lo(2,2), sj2), (lo(3,2), sk2),
     .      (lo(4,2), sl2), (lo(5,2), sm2), (lo(6,2), sn2),
     .      (lo(1,3), si3), (lo(2,3), sj3), (lo(3,3), sk3),
     .      (lo(4,3), sl3), (lo(5,3), sm3), (lo(6,3), sn3),
     .      (inc(1,1),di1), (inc(2,1),dj1), (inc(3,1),dk1),
     .      (inc(4,1),dl1), (inc(5,1),dm1), (inc(6,1),dn1),
     .      (inc(1,2),di2), (inc(2,2),dj2), (inc(3,2),dk2),
     .      (inc(4,2),dl2), (inc(5,2),dm2), (inc(6,2),dn2),
     .      (inc(1,3),di3), (inc(2,3),dj3), (inc(3,3),dk3),
     .      (inc(4,3),dl3), (inc(5,3),dm3), (inc(6,3),dn3)

* initialization supported for up to three arguments; need to
* extend if a function is ever created with more than three
        IF ( num_com .GT. 3 ) THEN
           STOP '**ERROR: DO_INTERNAL_GC_FCN num_com > 3'
        ENDIF

* initialize commonly used variables
        status = ferr_ok
	cx1 = com_cx(1)
	cx2 = com_cx(2)
	cx3 = com_cx(3)

* flag(s) for bad or missing values
	bad1 = mr_bad_data ( mr1 )
	bad2 = mr_bad_data ( mr2 )
	bad3 = mr_bad_data ( mr3 )
	bad_res = mr_bad_data( mres )

* compute the delta increment for each axis of each component
	DO 10 icom = 1, num_com
	DO 10 idim = 1, nferdims
	   IF ( CX_DIM_LEN(idim,com_cx(icom)) .EQ. 1 ) THEN
	      inc(idim,icom) = 0
	   ELSE
	      inc(idim,icom) = 1
	   ENDIF
 10	CONTINUE

* compute the starting subscript for each axis of each component
* (pre-decrement by 1 delta for looping ahead)
* NOTE: 
	DO 20 icom = 1, num_com
	DO 20 idim = 1, nferdims
 20	lo(idim,icom) = cx_lo_ss(com_cx(icom),idim) - inc(idim,icom)

* select the function
	GOTO ( 1100,1200,1300,1400,1500,1600,1700,1800,1900,2000,
     .	       2100,2200,2300,2400,2500,2600,2700,2800,2900,3000,
     .	       3100,3200,3300,3400,3500,3600 ) fcn


* "XSEQUENCE" - reshape/flatten the input into a line in X
 1100	IF (typr .EQ. pfcn_rtn_float) THEN
          i2 = m10lox
	  DO 1110 n = cx_lo_s6(cx1), cx_hi_s6(cx1)
	  DO 1110 m = cx_lo_s5(cx1), cx_hi_s5(cx1)
	  DO 1110 l = cx_lo_s4(cx1), cx_hi_s4(cx1)
	  DO 1110 k = cx_lo_s3(cx1), cx_hi_s3(cx1)
	  DO 1110 j = cx_lo_s2(cx1), cx_hi_s2(cx1)
	  DO 1110 i = cx_lo_s1(cx1), cx_hi_s1(cx1)
	     IF ( com1(1,i,j,k,l,m,n) .EQ. bad1 ) THEN
	        res(1,i2,m10loy,m10loz,m10lot,m10loe,m10lof)
     .             = bad_res
	     ELSE
	        res(1,i2,m10loy,m10loz,m10lot,m10loe,m10lof)
     .             = com1(1,i,j,k,l,m,n)
	     ENDIF
	     i2 = i2 + 1
 1110     CONTINUE
        ELSE
          i2 = m10lox
	  DO 1160 n = cx_lo_s6(cx1), cx_hi_s6(cx1)
	  DO 1160 m = cx_lo_s5(cx1), cx_hi_s5(cx1)
	  DO 1160 l = cx_lo_s4(cx1), cx_hi_s4(cx1)
	  DO 1160 k = cx_lo_s3(cx1), cx_hi_s3(cx1)
	  DO 1160 j = cx_lo_s2(cx1), cx_hi_s2(cx1)
	  DO 1160 i = cx_lo_s1(cx1), cx_hi_s1(cx1)
	     CALL COPY_C_STRING(com1(1,i,j,k,l,m,n),
     .                 res(1,i2,m10loy,m10loz,m10lot,m10loe,m10lof))
	     i2 = i2 + 1
 1160	  CONTINUE
        ENDIF
	RETURN


* "TIMES2" (a.k.a. "ECHO") - debugging function
* ECHO the string that was passed in
* here is how you check the variable type
 1200   IF (mr_category(mr1) .NE. cat_string)
     .     WRITE (6,*) "ERROR: argument is not a string after all!"
* here is how you decode the string
        coded_pointer = mr_variable(mr1)
* ... note that the uvar number and item number of the string are
*     packed together in the coded_pointer value
        IF ( coded_pointer .GT. 0 ) THEN
* ... as of V5.0 should always come here
           uvar = coded_pointer/1000
           item = coded_pointer - 1000*uvar
           start = uvar_item_start( item, uvar )
           end   = uvar_item_end  ( item, uvar )
* ... echo string
           WRITE (6,'(1X,A)') 
     .          'You said: '//uvar_text(uvar)(start:end)
* ... compute result from arg 2
**** WARNING: This assumes com2 and res dimensions start and end at the same values ****
	   DO 1205 n = mr_lo_s6(mres), mr_hi_s6(mres)
	   DO 1205 m = mr_lo_s5(mres), mr_hi_s5(mres)
	   DO 1205 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   DO 1205 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   DO 1205 j = mr_lo_s2(mres), mr_hi_s2(mres)
	   DO 1205 i = mr_lo_s1(mres), mr_hi_s1(mres)
	      IF ( com2(1,i,j,k,l,m,n) .EQ. bad2 ) THEN
	         res(1,i,j,k,l,m,n) = bad_res
	      ELSE
	         res(1,i,j,k,l,m,n) = com2(1,i,j,k,l,m,n) * 2.0
	      ENDIF
 1205      CONTINUE
        ELSE
* ... for future grids of strings
           STOP 'illegal string argument encoding'
!          pointer to array of strings encoded in memory(k,blk)
!          string = EXTRACT_FROM_STRING_GRID(memory(k,blk),i,j,k,l)
        ENDIF
        RETURN


* "RESHAPE" - reshape argument 1 into the grid of arg 2. Start output
* at the i,j,k,l,m,n point given in arg 2. It is commonly useful for taking
* monthly data and recasting it as a 12 month Z axis by a yearly axis
 1300   DO 1310 idim = 1, nferdims
 1310	   ind(idim) = cx_lo_ss(cx1,idim)
	size = CGRID_SIZE(cx1)
	count = 0	! total points xferred - used to prevent grid overflow

	IF (typr .EQ. pfcn_rtn_float) THEN

	  DO 1350 n = mr_lo_s6(mres), mr_hi_s6(mres)
	  DO 1350 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  DO 1350 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  DO 1350 k = mr_lo_s3(mres), mr_hi_s3(mres)
	  DO 1350 j = mr_lo_s2(mres), mr_hi_s2(mres)
	  DO 1350 i = mr_lo_s1(mres), mr_hi_s1(mres)

	     count = count + 1
	     IF ( count .GT. size ) THEN
	        res(1,i,j,k,l,m,n) = bad_res
             ELSEIF ( com1(1,ind(1),ind(2),ind(3),ind(4),ind(5),ind(6))
     .                .EQ. bad1 ) THEN
	        res(1,i,j,k,l,m,n) = bad_res
	     ELSE
	        res(1,i,j,k,l,m,n) = 
     .                com1(1,ind(1),ind(2),ind(3),ind(4),ind(5),ind(6))
	     ENDIF

* ... increment the subscripts of the input argument
	     DO 1320 idim = 1, nferdims
	        IF (ind(idim) .LT. cx_hi_ss(cx1,idim) ) THEN
	           ind(idim) = ind(idim) + 1
	           GOTO 1350
	        ELSE
	           ind(idim) =  cx_lo_ss(cx1,idim)
	        ENDIF
 1320	     CONTINUE

 1350	  CONTINUE

        ELSE

	  DO 1390 n = mr_lo_s6(mres), mr_hi_s6(mres)
	  DO 1390 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  DO 1390 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  DO 1390 k = mr_lo_s3(mres), mr_hi_s3(mres)
	  DO 1390 j = mr_lo_s2(mres), mr_hi_s2(mres)
	  DO 1390 i = mr_lo_s1(mres), mr_hi_s1(mres)

	     count = count + 1
	     CALL COPY_C_STRING(
     .              com1(1,ind(1),ind(2),ind(3),ind(4),ind(5),ind(6)),
     .              res(1,i,j,k,l,m,n) )

* ... increment the subscripts of the input argument
	     DO 1360 idim = 1, nferdims
	        IF (ind(idim) .LT. cx_hi_ss(cx1,idim) ) THEN
	           ind(idim) = ind(idim) + 1
	           GOTO 1390
	        ELSE
	           ind(idim) =  cx_lo_ss(cx1,idim)
	        ENDIF
 1360	     CONTINUE

 1390	  CONTINUE

        ENDIF
	RETURN


* "ZAXREPLACE(V,ZVALS,ZAX)" - regrid a sigma-coordinate-style (layered)
* variable, V, onto a depth axis, ZAX, guided by the depths in ZVALS
* ... sanity check -- V and ZVALS must match in vertical structure
 1400   IF ( (cx_lo_s3(cx1) .NE. cx_lo_s3(cx2))
     . .OR.  (cx_hi_s3(cx1) .NE. cx_hi_s3(cx2)) ) CALL ERRMSG
     .		(ferr_limits, status,
     .		 'Z limits of data and depth fields must match', *5000)

* ... allocate a work array for a single profile of Z depths
        i8_size = m2hiz-m2loz+1
	CALL GET_DYN_WORK_SPACE( i8_size, status )
        IF ( status .NE. ferr_ok ) GOTO 5000


* ... loop over the X,Y,T,E,F range of the input fields
	n1 = sn1
	n2 = sn2
	DO 1450 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	 DO 1450 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 1450 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   l1 = l1 + dl1
	   l2 = l2 + dl2
	   j1 = sj1
	   j2 = sj2
	   DO 1450 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    i1 = si1
	    i2 = si2
	    DO 1450 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2

* ... extract the vertical profile at this I,J,L location
             CALL EXTRACT_Z_LINE ( com2, bad2, i2, j2, l2, m2, n2,
     .               cx_lo_s3(cx2), cx_hi_s3(cx2), 
     .               m2lox, m2hix, m2loy, m2hiy, m2loz, m2hiz,
     .               m2lot, m2hit, m2loe, m2hie, m2lof, m2hif,
     .               workmem(plegacy_work_buffer)%ptr, klo, khi )

             IF ( klo .LT. 1 ) THEN

* ... no valid data in component 2 at this location
	        DO 1405 k = mr_lo_s3(mres), mr_hi_s3(mres)
 1405              res(1,i,j,k,l,m,n) = bad_res

             ELSE

* loop over the desired output Z-axis points
!               ndx_lo = 0    ! no guess for location of first depth
                ndx_lo = 1    ! fixes bug where if zval equals 1st point in axis
                              ! we got no match.
	        DO 1410 k = mr_lo_s3(mres), mr_hi_s3(mres)

* ... next Z axis value (com3) to locate
#ifdef double_p
                   zval = TM_WORLD(k,cx_grid(cx3),z_dim,box_middle)
#else
                   zval = SNGL(TM_WORLD(k,cx_grid(cx3),z_dim,box_middle))
#endif
* ... search the Z field (com2) for the index just below this value
* ... note that ndx_lo is always referenced to a starting index of 1
                   CALL HUNT_R4(workmem(plegacy_work_buffer)%ptr,
     .                          klo, khi, zval, ndx_lo, frac)
                   IF ( frac .LT. 0.0 ) THEN
* ... no luck -- the Z axis value we seek is outside the range in com2
                      res(1,i,j,k,l,m,n) = bad_res
                   ELSEIF ( com1(1,i1,j1,sk1+ndx_lo,l1,m1,n1)
     .                      .EQ. bad1 ) THEN
                      res(1,i,j,k,l,m,n) = bad_res
                   ELSEIF ( frac .EQ. 1.0 ) THEN      ! exactly on point
                      res(1,i,j,k,l,m,n) =
     .                   com1(1,i1,j1,sk1+ndx_lo,l1,m1,n1)
                   ELSEIF ( com1(1,i1,j1,sk1+ndx_lo+1,l1,m1,n1)
     .                      .EQ. bad1 ) THEN
                      res(1,i,j,k,l,m,n) = bad_res
                   ELSE
* ... interpolate data com1 field to get result
                      res(1,i,j,k,l,m,n) = 
     .                   frac  * com1(1,i1,j1,sk1+ndx_lo,  l1,m1,n1)
     .              + (1-frac) * com1(1,i1,j1,sk1+ndx_lo+1,l1,m1,n1)
                   ENDIF
 1410           CONTINUE

             ENDIF

 1450	CONTINUE
        CALL RELEASE_DYN_WORK_SPACE
        RETURN


* "YSEQUENCE" - reshape/flatten the input into a line in Y
 1500	IF (typr .EQ. pfcn_rtn_float) THEN
	  j2 = m10loy
	  DO 1510 n = cx_lo_s6(cx1), cx_hi_s6(cx1)
	  DO 1510 m = cx_lo_s5(cx1), cx_hi_s5(cx1)
	  DO 1510 l = cx_lo_s4(cx1), cx_hi_s4(cx1)
	  DO 1510 k = cx_lo_s3(cx1), cx_hi_s3(cx1)
	  DO 1510 j = cx_lo_s2(cx1), cx_hi_s2(cx1)
	  DO 1510 i = cx_lo_s1(cx1), cx_hi_s1(cx1)
	     IF ( com1(1,i,j,k,l,m,n) .EQ. bad1 ) THEN
	        res(1,m10lox,j2,m10loz,m10lot,m10loe,m10lof)
     .             = bad_res
	     ELSE
	        res(1,m10lox,j2,m10loz,m10lot,m10loe,m10lof)
     .             = com1(1,i,j,k,l,m,n)
	     ENDIF
	     j2 = j2 + 1
 1510	  CONTINUE
        ELSE
	  j2 = m10loy
	  DO 1560 n = cx_lo_s6(cx1), cx_hi_s6(cx1)
	  DO 1560 m = cx_lo_s5(cx1), cx_hi_s5(cx1)
	  DO 1560 l = cx_lo_s4(cx1), cx_hi_s4(cx1)
	  DO 1560 k = cx_lo_s3(cx1), cx_hi_s3(cx1)
	  DO 1560 j = cx_lo_s2(cx1), cx_hi_s2(cx1)
	  DO 1560 i = cx_lo_s1(cx1), cx_hi_s1(cx1)
	     CALL COPY_C_STRING(com1(1,i,j,k,l,m,n),
     .                 res(1,m10lox,j2,m10loz,m10lot,m10loe,m10lof))
	     j2 = j2 + 1
 1560	  CONTINUE
        ENDIF
	RETURN


* "ZSEQUENCE" - reshape/flatten the input into a line in Z
 1600	IF (typr .EQ. pfcn_rtn_float) THEN
	  k2 = m10loz
	  DO 1610 n = cx_lo_s6(cx1), cx_hi_s6(cx1)
	  DO 1610 m = cx_lo_s5(cx1), cx_hi_s5(cx1)
	  DO 1610 l = cx_lo_s4(cx1), cx_hi_s4(cx1)
	  DO 1610 k = cx_lo_s3(cx1), cx_hi_s3(cx1)
	  DO 1610 j = cx_lo_s2(cx1), cx_hi_s2(cx1)
	  DO 1610 i = cx_lo_s1(cx1), cx_hi_s1(cx1)
	     IF ( com1(1,i,j,k,l,m,n) .EQ. bad1 ) THEN
	        res(1,m10lox,m10loy,k2,m10lot,m10loe,m10lof)
     .             = bad_res
	     ELSE
	        res(1,m10lox,m10loy,k2,m10lot,m10loe,m10lof)
     .             = com1(1,i,j,k,l,m,n)
	     ENDIF
	     k2 = k2 + 1
 1610	  CONTINUE
        ELSE
	  k2 = m10loz
	  DO 1660 n = cx_lo_s6(cx1), cx_hi_s6(cx1)
	  DO 1660 m = cx_lo_s5(cx1), cx_hi_s5(cx1)
	  DO 1660 l = cx_lo_s4(cx1), cx_hi_s4(cx1)
	  DO 1660 k = cx_lo_s3(cx1), cx_hi_s3(cx1)
	  DO 1660 j = cx_lo_s2(cx1), cx_hi_s2(cx1)
	  DO 1660 i = cx_lo_s1(cx1), cx_hi_s1(cx1)
	     CALL COPY_C_STRING(com1(1,i,j,k,l,m,n),
     .                 res(1,m10lox,m10loy,k2,m10lot,m10loe,m10lof))
	     k2 = k2 + 1
 1660	  CONTINUE
        ENDIF
	RETURN


* "TSEQUENCE" - reshape/flatten the input into a line in T
 1700	IF (typr .EQ. pfcn_rtn_float) THEN
	  l2 = m10lot
	  DO 1710 n = cx_lo_s6(cx1), cx_hi_s6(cx1)
	  DO 1710 m = cx_lo_s5(cx1), cx_hi_s5(cx1)
	  DO 1710 l = cx_lo_s4(cx1), cx_hi_s4(cx1)
	  DO 1710 k = cx_lo_s3(cx1), cx_hi_s3(cx1)
	  DO 1710 j = cx_lo_s2(cx1), cx_hi_s2(cx1)
	  DO 1710 i = cx_lo_s1(cx1), cx_hi_s1(cx1)
	     IF ( com1(1,i,j,k,l,m,n) .EQ. bad1 ) THEN
	        res(1,m10lox,m10loy,m10loz,l2,m10loe,m10lof)
     .             = bad_res
	     ELSE
	        res(1,m10lox,m10loy,m10loz,l2,m10loe,m10lof)
     .             = com1(1,i,j,k,l,m,n)
	     ENDIF
	     l2 = l2 + 1
 1710	  CONTINUE
        ELSE
	  l2 = m10lot
	  DO 1760 n = cx_lo_s6(cx1), cx_hi_s6(cx1)
	  DO 1760 m = cx_lo_s5(cx1), cx_hi_s5(cx1)
	  DO 1760 l = cx_lo_s4(cx1), cx_hi_s4(cx1)
	  DO 1760 k = cx_lo_s3(cx1), cx_hi_s3(cx1)
	  DO 1760 j = cx_lo_s2(cx1), cx_hi_s2(cx1)
	  DO 1760 i = cx_lo_s1(cx1), cx_hi_s1(cx1)
	     CALL COPY_C_STRING(com1(1,i,j,k,l,m,n),
     .                 res(1,m10lox,m10loy,m10loz,l2,m10loe,m10lof))
	     l2 = l2 + 1
 1760	  CONTINUE
        ENDIF
	RETURN

	
* "ESEQUENCE" - reshape/flatten the input into a line in E
 1800	IF (typr .EQ. pfcn_rtn_float) THEN
	  m2 = m10loe
	  DO 1810 n = cx_lo_s6(cx1), cx_hi_s6(cx1)
	  DO 1810 m = cx_lo_s5(cx1), cx_hi_s5(cx1)
	  DO 1810 l = cx_lo_s4(cx1), cx_hi_s4(cx1)
	  DO 1810 k = cx_lo_s3(cx1), cx_hi_s3(cx1)
	  DO 1810 j = cx_lo_s2(cx1), cx_hi_s2(cx1)
	  DO 1810 i = cx_lo_s1(cx1), cx_hi_s1(cx1)
	     IF ( com1(1,i,j,k,l,m,n) .EQ. bad1 ) THEN
	        res(1,m10lox,m10loy,m10loz,m10lot,m2,m10lof)
     .             = bad_res
	     ELSE
	        res(1,m10lox,m10loy,m10loz,m10lot,m2,m10lof)
     .             = com1(1,i,j,k,l,m,n)
	     ENDIF
	     m2 = m2 + 1
 1810	  CONTINUE
        ELSE
	  m2 = m10loe
	  DO 1860 n = cx_lo_s6(cx1), cx_hi_s6(cx1)
	  DO 1860 m = cx_lo_s5(cx1), cx_hi_s5(cx1)
	  DO 1860 l = cx_lo_s4(cx1), cx_hi_s4(cx1)
	  DO 1860 k = cx_lo_s3(cx1), cx_hi_s3(cx1)
	  DO 1860 j = cx_lo_s2(cx1), cx_hi_s2(cx1)
	  DO 1860 i = cx_lo_s1(cx1), cx_hi_s1(cx1)
	     CALL COPY_C_STRING(com1(1,i,j,k,l,m,n),
     .                 res(1,m10lox,m10loy,m10loz,m10lot,m2,m10lof))
	     m2 = m2 + 1
 1860	  CONTINUE
        ENDIF
	RETURN

	
* "FSEQUENCE" - reshape/flatten the input into a line in F
 1900	IF (typr .EQ. pfcn_rtn_float) THEN
	  n2 = m10lof
	  DO 1910 n = cx_lo_s6(cx1), cx_hi_s6(cx1)
	  DO 1910 m = cx_lo_s5(cx1), cx_hi_s5(cx1)
	  DO 1910 l = cx_lo_s4(cx1), cx_hi_s4(cx1)
	  DO 1910 k = cx_lo_s3(cx1), cx_hi_s3(cx1)
	  DO 1910 j = cx_lo_s2(cx1), cx_hi_s2(cx1)
	  DO 1910 i = cx_lo_s1(cx1), cx_hi_s1(cx1)
	     IF ( com1(1,i,j,k,l,m,n) .EQ. bad1 ) THEN
	        res(1,m10lox,m10loy,m10loz,m10lot,m10loe,n2)
     .             = bad_res
	     ELSE
	        res(1,m10lox,m10loy,m10loz,m10lot,m10loe,n2)
     .             = com1(1,i,j,k,l,m,n)
	     ENDIF
	     n2 = n2 + 1
 1910	  CONTINUE
        ELSE
	  n2 = m10lof
	  DO 1960 n = cx_lo_s6(cx1), cx_hi_s6(cx1)
	  DO 1960 m = cx_lo_s5(cx1), cx_hi_s5(cx1)
	  DO 1960 l = cx_lo_s4(cx1), cx_hi_s4(cx1)
	  DO 1960 k = cx_lo_s3(cx1), cx_hi_s3(cx1)
	  DO 1960 j = cx_lo_s2(cx1), cx_hi_s2(cx1)
	  DO 1960 i = cx_lo_s1(cx1), cx_hi_s1(cx1)
	     CALL COPY_C_STRING(com1(1,i,j,k,l,m,n),
     .                 res(1,m10lox,m10loy,m10loz,m10lot,m10loe,n2))
	     n2 = n2 + 1
 1960	  CONTINUE
        ENDIF
	RETURN


* "SAMPLEI", "SAMPLEJ", "SAMPLEK", "SAMPLEL" , "SAMPLEM", "SAMPLEN"- 
* just copy arg 2 to result
* setup for sampling done elsewhere
 2000   CONTINUE        ! SAMPLEI
 2100   CONTINUE        ! SAMPLEJ
 2200   CONTINUE        ! SAMPLEK
 2300   CONTINUE        ! SAMPLEL
 2400   CONTINUE        ! SAMPLEN
 2500   CONTINUE        ! SAMPLEN
	IF (typr .EQ. pfcn_rtn_float) THEN
**** WARNING: This assumes com2 and res dimensions start and end at the same values ****
	  DO 2510 n = cx_lo_s6(cx2), cx_hi_s6(cx2)
	  DO 2510 m = cx_lo_s5(cx2), cx_hi_s5(cx2)
	  DO 2510 l = cx_lo_s4(cx2), cx_hi_s4(cx2)
	  DO 2510 k = cx_lo_s3(cx2), cx_hi_s3(cx2)
	  DO 2510 j = cx_lo_s2(cx2), cx_hi_s2(cx2)
	  DO 2510 i = cx_lo_s1(cx2), cx_hi_s1(cx2)
	     IF ( com2(1,i,j,k,l,m,n) .EQ. bad2 ) THEN
	        res(1,i,j,k,l,m,n) = bad_res
	     ELSE
	        res(1,i,j,k,l,m,n) = com2(1,i,j,k,l,m,n)
	     ENDIF
 2510	  CONTINUE
        ELSE
**** WARNING: This assumes com2 and res dimensions start and end at the same values ****
	  DO 2560 n = cx_lo_s6(cx2), cx_hi_s6(cx2)
	  DO 2560 m = cx_lo_s5(cx2), cx_hi_s5(cx2)
	  DO 2560 l = cx_lo_s4(cx2), cx_hi_s4(cx2)
	  DO 2560 k = cx_lo_s3(cx2), cx_hi_s3(cx2)
	  DO 2560 j = cx_lo_s2(cx2), cx_hi_s2(cx2)
	  DO 2560 i = cx_lo_s1(cx2), cx_hi_s1(cx2)
	     CALL COPY_C_STRING(com2(1,i,j,k,l,m,n),
     .                           res(1,i,j,k,l,m,n))
 2560	  CONTINUE
        ENDIF
	RETURN


* SPAWN function - perform a Unix system command
 2600	CONTINUE
* ... get the command string to be executed
        IF (CGRID_SIZE(cx1) .NE. 1) CALL ERRMSG(ferr_invalid_command,
     .      status, 'SPAWN can only execute a single command', *5000)
        buff = GET_STRING_ELEMENT(m1lox, m1hix, m1loy, m1hiy,
     .              m1loz, m1hiz, m1lot, m1hit, m1loe, m1hie,
     .              m1lof, m1hif,  com1, m1lox, m1loy, m1loz,
     .              m1lot, m1loe, m1lof, max_cmnd_len, slen)
        IF (slen .EQ. max_cmnd_len) CALL ERRMSG(ferr_invalid_command,
     .       status, 'SPAWN command too long -- 2048 char max', *5000)
* ... execute the command and store the results
        CALL STORE_SYS_STRINGS(buff, res_cx, mres, 1, nnew, status)
        RETURN


* STRCMP function
 2700	CONTINUE
	n1 = sn1
	n2 = sn2
	DO 2750 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	 DO 2750 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 2750 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   l1 = l1 + dl1
	   l2 = l2 + dl2
	   k1 = sk1
	   k2 = sk2
	   DO 2750 k = mr_lo_s3(mres), mr_hi_s3(mres)
	    k1 = k1 + dk1
	    k2 = k2 + dk2
	    j1 = sj1
	    j2 = sj2
	    DO 2750 j = mr_lo_s2(mres), mr_hi_s2(mres)
	     j1 = j1 + dj1
	     j2 = j2 + dj2
	     i1 = si1
	     i2 = si2
	     DO 2750 i = mr_lo_s1(mres), mr_hi_s1(mres)
	      i1 = i1 + di1
	      i2 = i2 + di2
              CALL C_STRCMP(com1(1,i1,j1,k1,l1,m1,n1),
     .                      com2(1,i2,j2,k2,l2,m2,n2), ii)
              res(1,i,j,k,l,m,n) = ii
 2750   CONTINUE
        RETURN


* *kob* 3/02 STRLEN function
 2800	CONTINUE
	n1 = sn1
	DO 2850 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 m1 = sm1
	 DO 2850 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  l1 = sl1
	  DO 2850 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   l1 = l1 + dl1
	   k1 = sk1
	   DO 2850 k = mr_lo_s3(mres), mr_hi_s3(mres)
	    k1 = k1 + dk1
	    j1 = sj1
	    DO 2850 j = mr_lo_s2(mres), mr_hi_s2(mres)
	     j1 = j1 + dj1
	     i1 = si1
	     DO 2850 i = mr_lo_s1(mres), mr_hi_s1(mres)
	      i1 = i1 + di1
              CALL C_STRLEN(com1(1,i1,j1,k1,l1,m1,n1), ii)
              res(1,i,j,k,l,m,n) = ii
 2850   CONTINUE
        RETURN

* *kob* 3/02 UPCASE function
 2900	CONTINUE
	n1 = sn1
	DO 2950 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 m1 = sm1
	 DO 2950 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  l1 = sl1
	  DO 2950 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   l1 = l1 + dl1
	   k1 = sk1
	   DO 2950 k = mr_lo_s3(mres), mr_hi_s3(mres)
	    k1 = k1 + dk1
	    j1 = sj1
	    DO 2950 j = mr_lo_s2(mres), mr_hi_s2(mres)
	     j1 = j1 + dj1
	     i1 = si1
	     DO 2950 i = mr_lo_s1(mres), mr_hi_s1(mres)
	      i1 = i1 + di1
              CALL C_UPCASE(com1(1,i1,j1,k1,l1,m1,n1),
     .                      res(1,i,j,k,l,m,n))
 2950   CONTINUE
        RETURN


* *kob* 3/02 STRINDEX function
 3000	CONTINUE
	n1 = sn1
	n2 = sn2
	DO 3050 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	 DO 3050 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 3050 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   l1 = l1 + dl1
	   l2 = l2 + dl2
	   k1 = sk1
	   k2 = sk2
	   DO 3050 k = mr_lo_s3(mres), mr_hi_s3(mres)
	    k1 = k1 + dk1
	    k2 = k2 + dk2
	    j1 = sj1
	    j2 = sj2
	    DO 3050 j = mr_lo_s2(mres), mr_hi_s2(mres)
	     j1 = j1 + dj1
	     j2 = j2 + dj2
	     i1 = si1
	     i2 = si2
	     DO 3050 i = mr_lo_s1(mres), mr_hi_s1(mres)
	      i1 = i1 + di1
	      i2 = i2 + di2
              CALL C_STRINDEX(com1(1,i1,j1,k1,l1,m1,n1),
     .                        com2(1,i2,j2,k2,l2,m2,n2), ii)
              res(1,i,j,k,l,m,n) = ii
 3050   CONTINUE
        RETURN

* *kob* 3/02 STRRINDEX function
 3100	CONTINUE
	n1 = sn1
	n2 = sn2
	DO 3150 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	 DO 3150 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 3150 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   l1 = l1 + dl1
	   l2 = l2 + dl2
	   k1 = sk1
	   k2 = sk2
	   DO 3150 k = mr_lo_s3(mres), mr_hi_s3(mres)
	    k1 = k1 + dk1
	    k2 = k2 + dk2
	    j1 = sj1
	    j2 = sj2
	    DO 3150 j = mr_lo_s2(mres), mr_hi_s2(mres)
	     j1 = j1 + dj1
	     j2 = j2 + dj2
	     i1 = si1
	     i2 = si2
	     DO 3150 i = mr_lo_s1(mres), mr_hi_s1(mres)
	      i1 = i1 + di1
	      i2 = i2 + di2
              CALL C_STRLEN(com2(1,i2,j2,k2,l2,m2,n2), ii)
              IF (ii .LE. 0) THEN
                 CALL C_STRLEN(com1(1,i1,j1,k1,l1,m1,n1), ii)
                 res(1,i,j,k,l,m,n) = ii
              ELSE
                 CALL C_STRRINDEX(com1(1,i1,j1,k1,l1,m1,n1),
     .                            com2(1,i2,j2,k2,l2,m2,n2), ii)
                 res(1,i,j,k,l,m,n) = ii
              ENDIF
 3150   CONTINUE
        RETURN

* *kob* 3/02 DNCASE function
 3200	CONTINUE
	n1 = sn1
	DO 3250 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 m1 = sm1
	 DO 3250 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  l1 = sl1
	  DO 3250 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   l1 = l1 + dl1
	   k1 = sk1
	   DO 3250 k = mr_lo_s3(mres), mr_hi_s3(mres)
	    k1 = k1 + dk1
	    j1 = sj1
	    DO 3250 j = mr_lo_s2(mres), mr_hi_s2(mres)
	     j1 = j1 + dj1
	     i1 = si1
	     DO 3250 i = mr_lo_s1(mres), mr_hi_s1(mres)
	      i1 = i1 + di1
              CALL C_DNCASE(com1(1,i1,j1,k1,l1,m1,n1),
     .                      res(1,i,j,k,l,m,n))
 3250   CONTINUE
        RETURN

 3300	CONTINUE
* *kob* STRCAT function 3/02
	n1 = sn1
	n2 = sn2
	DO 3350 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	 DO 3350 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 3350 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   l1 = l1 + dl1
	   l2 = l2 + dl2
	   k1 = sk1
	   k2 = sk2
	   DO 3350 k = mr_lo_s3(mres), mr_hi_s3(mres)
	    k1 = k1 + dk1
	    k2 = k2 + dk2
	    j1 = sj1
	    j2 = sj2
	    DO 3350 j = mr_lo_s2(mres), mr_hi_s2(mres)
	     j1 = j1 + dj1
	     j2 = j2 + dj2
	     i1 = si1
	     i2 = si2
	     DO 3350 i = mr_lo_s1(mres), mr_hi_s1(mres)
	      i1 = i1 + di1
	      i2 = i2 + di2
              CALL C_STRCAT(com1(1,i1,j1,k1,l1,m1,n1),
     .                      com2(1,i2,j2,k2,l2,m2,n2),
     .                      res(1,i,j,k,l,m,n))
 3350   CONTINUE
        RETURN

 3400	CONTINUE
* *kob* SUBSTRING function 3/02
	n1 = sn1
	n2 = sn2
	n3 = sn3
	DO 3450 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 n3 = n3 + dn3
	 m1 = sm1
	 m2 = sm2
	 m3 = sm3
	 DO 3450 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  m3 = m3 + dm3
	  l1 = sl1
	  l2 = sl2
	  l3 = sl3
	  DO 3450 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   l1 = l1 + dl1
	   l2 = l2 + dl2
	   l3 = l3 + dl3
	   k1 = sk1
	   k2 = sk2
	   k3 = sk3
	   DO 3450 k = mr_lo_s3(mres), mr_hi_s3(mres)
	    k1 = k1 + dk1
	    k2 = k2 + dk2
	    k3 = k3 + dk3
	    j1 = sj1
	    j2 = sj2
	    j3 = sj3
	    DO 3450 j = mr_lo_s2(mres), mr_hi_s2(mres)
	     j1 = j1 + dj1
	     j2 = j2 + dj2
	     j3 = j3 + dj3
	     i1 = si1
	     i2 = si2
	     i3 = si3
	     DO 3450 i = mr_lo_s1(mres), mr_hi_s1(mres)
	      i1 = i1 + di1
	      i2 = i2 + di2
	      i3 = i3 + di3
* Convert the offset and length to integers
              ioff = com2(1,i2,j2,k2,l2,m2,n2)
              ilen = com3(1,i3,j3,k3,l3,m3,n3)
* argument checking:
	      IF (ioff.LT.0) THEN
	         narg = 2
		 GOTO 5100
	      ENDIF
	      IF (ilen.LT.0)  THEN
	         narg = 3
		 GOTO 5100
	      ENDIF
              CALL C_SUBSTR(com1(1,i1,j1,k1,l1,m1,n1),
     .                      ioff, ilen, res(1,i,j,k,l,m,n))
 3450   CONTINUE
        RETURN

* *kob* 5/02 STRFLOAT function
 3500	CONTINUE
	n1 = sn1
	DO 3550 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 m1 = sm1
	 DO 3550 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  l1 = sl1
	  DO 3550 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   l1 = l1 + dl1
	   k1 = sk1
	   DO 3550 k = mr_lo_s3(mres), mr_hi_s3(mres)
	    k1 = k1 + dk1
	    j1 = sj1
	    DO 3550 j = mr_lo_s2(mres), mr_hi_s2(mres)
	     j1 = j1 + dj1
	     i1 = si1
	     DO 3550 i = mr_lo_s1(mres), mr_hi_s1(mres)
	      i1 = i1 + di1
              CALL C_STRFLOAT(com1(1,i1,j1,k1,l1,m1,n1),
     .                        res(1,i,j,k,l,m,n), bad_res)
 3550   CONTINUE
        RETURN


* Undefined functions
 3600   CONTINUE
	STOP '**ERROR: GC FUNCTION NOT IMPLEMENTED'


* error exits
 5000	RETURN
 5100	argval = TM_FMT(FLOAT(narg), 2, 40, slen)
	CALL ERRMSG(ferr_out_of_range, status,
     .   'Negative argument to function. Argument '//
     .    argval(:slen)//' : SUBSTRING', *5000 )

	END

c     
c     efcn_get_workspace_addr.F
c     
c     Jonathan Callahan
c     September 1998
c     

c     
c     This subroutine is called by efcn_compute_ inside EF_ExternalUtil.c. 
c     When workspace is requested by an external function it is created 
c     inside of efcn_compute_ but efcn_compute_ doesn't know how to access
c     variuos Ferret common areas.  (And I don't want to bother with
c     the C/Fortran column major/row major stuff).  This subroutine accesses
c     the common areas and passes back the appropriate address to efcn_compute_.
c     

      SUBROUTINE EFCN_GET_WORKSPACE_ADDR(memory, work_blk, workspace)

      INCLUDE 'tmap_dims.parm'
      INCLUDE 'ferret.parm'
      INCLUDE 'xvariables.cmn'

      INTEGER work_blk
      REAL memory( mem_blk_size, max_mem_blks ), workspace

      workspace = memory(work_blk, 1)

      RETURN 
      END

*
* list_good.F
*
* Ansley Manke
* April 1, 2005
*
* This function lists the good values of a variable with its location.
*

      SUBROUTINE list_good_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg
      CHARACTER*100 descrip

      WRITE (descrip, 1000)
      CALL ef_set_desc(id, descrip)

 1000 FORMAT(
     .  'List the value and location of valid data. ',
     .  'Return number of valid values')

      CALL ef_set_num_args(id, 1)
      CALL ef_set_num_work_arrays(id, 4)

      CALL ef_set_axis_inheritance(id, ABSTRACT, 
     .     NORMAL, NORMAL, NORMAL)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 'Variable')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

      SUBROUTINE list_good_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id
  
      call ef_set_axis_limits(id, X_AXIS, 1, 1)

      RETURN 
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE list_good_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_dims(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER m1, m2

      INTEGER iwork
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

*  Allocate double the dimension of the input arguments for work arrays
*  to hold coordinate values which will be REAL*8

*  xaxsrc

      iwork = 1

      m1 = 1
      m2 = 2*(1 + ABS(arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1)))
      IF (arg_lo_ss(X_AXIS,ARG1) .EQ. ef_unspecified_int4) THEN
         m1 = 1
         m2 = 1
      ENDIF

      CALL ef_set_work_array_dims (id, iwork, m1,1,1,1, m2,1,1,1)

*  yaxsrc

      iwork = 2
      
      m1 = 1
      m2 = 2*(1 + ABS(arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1)))
      IF (arg_lo_ss(Y_AXIS,ARG1) .EQ. ef_unspecified_int4) THEN
         m1 = 1
         m2 = 1
      ENDIF

      CALL ef_set_work_array_dims (id, iwork, 1,m1,1,1, 1,m2,1,1)

*  zaxsrc

      iwork = 3

      m1 = 1
      m2 = 2*(1 + ABS(arg_hi_ss(Z_AXIS,ARG1) - arg_lo_ss(Z_AXIS,ARG1)))
      IF (arg_lo_ss(Z_AXIS,ARG1) .EQ. ef_unspecified_int4) THEN
         m1 = 1
         m2 = 1
      ENDIF

      CALL ef_set_work_array_dims (id, iwork, 1,1,m1,1, 1,1,m2,1)

*  taxsrc

      iwork = 4

      m1 = 1
      m2 = 2*(1 + ABS(arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1)))
      IF (arg_lo_ss(t_AXIS,ARG1) .EQ. ef_unspecified_int4) THEN
         m1 = 1
         m2 = 1
      ENDIF

      CALL ef_set_work_array_dims (id, iwork, 1,1,1,m1, 1,1,1,m2)

      RETURN 
      END
      
*
* In this subroutine we compute the result
*
      SUBROUTINE list_good_compute(id, arg_1, result, 
     .                xaxsrc, yaxsrc, zaxsrc, taxsrc)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

	  INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL*8 xaxsrc(wrk1lox:wrk1hix/2, wrk1loy:wrk1hiy,
     .               wrk1loz:wrk1hiz, wrk1lot:wrk1hit)
      REAL*8 yaxsrc(wrk2lox:wrk2hix, wrk2loy:wrk2hiy/2,
     .               wrk2loz:wrk2hiz, wrk2lot:wrk2hit)
      REAL*8 zaxsrc(wrk3lox:wrk3hix, wrk3loy:wrk3hiy,
     .               wrk3loz:wrk3hiz/2, wrk3lot:wrk3hit)
      REAL*8 taxsrc(wrk4lox:wrk4hix, wrk4loy:wrk4hiy,
     .               wrk4loz:wrk4hiz, wrk4lot:wrk4hit/2)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER i1,j1,k1,l1
      REAL xx, yy, zz, tt, count

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      CALL ef_get_coordinates(id, ARG1, X_AXIS, 
     .   arg_lo_ss(X_AXIS, ARG1), arg_hi_ss(X_AXIS, ARG1), xaxsrc)

      CALL ef_get_coordinates(id, ARG1, Y_AXIS, 
     .   arg_lo_ss(Y_AXIS, ARG1), arg_hi_ss(Y_AXIS, ARG1), yaxsrc)

      CALL ef_get_coordinates(id, ARG1, Z_AXIS, 
     .   arg_lo_ss(Z_AXIS, ARG1), arg_hi_ss(Z_AXIS, ARG1), zaxsrc)

      CALL ef_get_coordinates(id, ARG1, T_AXIS, 
     .   arg_lo_ss(T_AXIS, ARG1), arg_hi_ss(T_AXIS, ARG1), taxsrc)

      i = res_lo_ss(X_AXIS)
      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      l = res_lo_ss(T_AXIS)

c1000  FORMAT (4x, 4i10/, 4x, 4g15.8/  g15.8)
1000  FORMAT (4i10, 4x,  g15.8)

      print *, ' '
      print *, ' good data from variable'
      print *, '       I         J         K         L          VALUE'   
c      print *, '         X         Y         Z         T'
c      print *, ' VALUE'
      print *, ' '

      count = 0
      DO 400 l1 = arg_lo_ss(T_AXIS,ARG1),arg_hi_ss(T_AXIS,ARG1)
      DO 300 k1 = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)
      DO 200 j1 = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)
      DO 100 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)         

         IF (arg_1(i1,j1,k1,l1) .NE. bad_flag(ARG1)) THEN
           xx = ef_unspecified_int4
           IF (i1 .NE. ef_unspecified_int4) xx =  xaxsrc(i1,1,1,1)
           yy = ef_unspecified_int4
           IF (j1 .NE. ef_unspecified_int4) yy =  yaxsrc(1,j1,1,1)
           zz = ef_unspecified_int4
           IF (k1 .NE. ef_unspecified_int4) zz =  zaxsrc(1,1,k1,1)
           tt = ef_unspecified_int4
           IF (L1 .NE. ef_unspecified_int4) tt =  taxsrc(1,1,1,L1)
           PRINT 1000, i1, j1, k1, l1, 
c     .                 xx, yy, zz, tt,
     .                 arg_1(i1,j1,k1,l1)
           count = count + 1
         ENDIF

 100  CONTINUE
 200  CONTINUE
 300  CONTINUE
 400  CONTINUE

      result(i,j,k,l) = count

      print *, ' '
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* ycat_str.F
*
* Ansley Manke
* Nov 2008
*
* This function returns the values of the two variables,
* concatenated into one long list on an abstract y axis. Other 
* axes are unchanged.
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE ycat_str_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg
      CHARACTER*100 descrip

      CALL ef_version_test(ef_version)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V


      WRITE (descrip, 100)
      CALL ef_set_desc(id, descrip)
  100 FORMAT ('Concatenates the Y values of two string variables ',
     .        'into one list on an abstract Y axis')

      CALL ef_set_num_args(id, 2)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     ABSTRACT, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_type (id, arg, STRING_ARG)

      CALL ef_set_arg_desc(id, arg, 'First variable to concatenate')
      CALL ef_set_axis_influence(id, arg, YES, NO, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'B')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_type (id, arg, STRING_ARG)

      CALL ef_set_arg_desc(id, arg, 'Second variable to concatenate')
      CALL ef_set_axis_influence(id, arg, YES, NO, YES, YES)
      
      CALL ef_set_result_type(id, STRING_RETURN)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END



      SUBROUTINE ycat_str_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER ny

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      ny = (arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1) + 1) +  
     .     (arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) + 1)

      call ef_set_axis_limits(id, Y_AXIS, 1, ny)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE ycat_str_compute(id, arg_1, arg_2, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

	  INTEGER id

      REAL arg_1(2,mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(2,mem2lox:mem2hix, mem2loy:mem2hiy, 
     .           mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL result(2,memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l, slen
      INTEGER i1,j1,k1,l1, i2,j2,k2,l2
      CHARACTER*512 buff

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      j = res_lo_ss(Y_AXIS)
      DO 400 j1 = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)

         i = res_lo_ss(X_AXIS)
         DO 300 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)

            k = res_lo_ss(Z_AXIS)
            DO 200 k1 = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)

               l = res_lo_ss(T_AXIS)
               DO 100 l1 = arg_lo_ss(T_AXIS,ARG1),arg_hi_ss(T_AXIS,ARG1)

                  CALL EF_GET_STRING_ARG_ELEMENT(id, ARG1, arg_1,
     .                       i1,j1,k1,l1, slen,buff)
                  CALL EF_PUT_STRING (buff, slen, result(1,i,j,k,l))

                  l = l + res_incr(T_AXIS)
 100           CONTINUE

               k = k + res_incr(Z_AXIS)
 200        CONTINUE

            i = i + res_incr(X_AXIS)
 300     CONTINUE

         j = j + res_incr(Y_AXIS)
 400  CONTINUE
      
* concatenate in Y - dont restart count of index J

      DO 410 j2 = arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS,ARG2)

         i = res_lo_ss(X_AXIS)
         DO 310 i2 = arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS,ARG2)

            k = res_lo_ss(Z_AXIS)
            DO 210 k2 = arg_lo_ss(Z_AXIS,ARG2), arg_hi_ss(Z_AXIS,ARG2)

               l = res_lo_ss(T_AXIS)
               DO 110 l2 = arg_lo_ss(T_AXIS,ARG2),arg_hi_ss(T_AXIS,ARG2)

                  CALL EF_GET_STRING_ARG_ELEMENT(id, ARG2, arg_2,
     .                       i2,j2,k2,l2, slen,buff)
                  CALL EF_PUT_STRING (buff, slen, result(1,i,j,k,l))

                  l = l + res_incr(T_AXIS)
 110           CONTINUE

               k = k + res_incr(Z_AXIS)
 210        CONTINUE

            i = i + res_incr(X_AXIS)
 310     CONTINUE

         j = j + res_incr(Y_AXIS)
 410  CONTINUE
      
      
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	SUBROUTINE CS_SEMICOLON( cmnd_line, * )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* this routine is called to save a group of commands separated by semicolons
* and bump the FERRET "control stack" to place that group of commands in
* control

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V3.00 - 2/1/93
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
 
        IMPLICIT NONE
* calling argument declarations:
	CHARACTER*(*)	cmnd_line
* RETURN 1 - always taken

* internal variable declarations:
	INTEGER	TM_LENSTR1, status

	include 'tmap_dims.parm'
	include 'errmsg.parm'
	include 'ferret.parm'
	include 'command.parm'
	include 'xprog_state.cmn'
	include 'xcontrol.cmn'

* allocate next spot on the control stack
* ... but leave the stack in place in case of errors in this routine
	CALL STACK_PTR_UP( csp, cs_max, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* load the command group
	cs_text (csp) = cmnd_line
        cs_phase(csp) = 0    ! points before the first character
        cs_limit(csp) = TM_LENSTR1( cmnd_line )

* and tell 'em who owns this level
	cs_cmnd_num( csp ) = cmnd_semicolon

* tell 'em we've taken over and start workin'
	cs_in_control = .TRUE.
	input_source  = input_from_cs
	RETURN 1

* error exit
* ... control stack pointer, CSP, corrected in ERRMSG
 5000	RETURN
	END

	SUBROUTINE CHIN(IN,NCH,ITERM)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)chin.F	1.1    3/10/88
* v552 *acm* 3/03 Longer strings: changes for multi-line labels.
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
#ifdef unix
	include 'PLTCOM.DAT'
#else
	include 'pplinc:PLTCOM.DAT'
#endif
#ifdef unix
	integer IN(NCH)
	character inc*2048
C
	IF(FILET(1:8).NE.'/dev/tty')RETURN
	read(*,999)inc
999	format(a)
	do 10 i=1,nch
	in(i)=ichar(inc(i:i))
10	continue
#else
        BYTE IN(NCH),IOSB(4)
        DIMENSION IPAR(6)
        include '($IODEF)'
C
        IF(FILET(1:3).NE.'TI:'.and.FILET(1:3).NE.'TT:')RETURN
        CALL SYS$ASSIGN('TT',CHAN,,)
	CALL SYS$QIOW(,%VAL(CHAN),%VAL(IO$_TTYREADALL .OR. IO$M_NOECHO),,,,
     *	IN,%VAL(NCH),,,,)
        CALL SYS$DASSGN(%VAL(CHAN))
#endif
	RETURN
	END

*     rr_diff_tz.F
*
*           Rick Romea
*           Jan. 24, 2000  
*
*     Zonal momentum diffusive term :  [Az T_z]_z
*     Units :     oC/s
*     MOM2 Grid :  T   
*
*******************************************************************

      SUBROUTINE RR_diff_tz_init(id)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

      CALL ef_set_desc             (id,
     .'d(Az dT/dz)/dz momentum diffusive term (oC/s);MOM2 T Grid')
      CALL ef_set_num_args         (id, 5)
      CALL ef_set_axis_inheritance (id, IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok     (id, NO, NO, NO, NO)

      CALL ef_set_arg_name         (id, ARG1, 'U')
      CALL ef_set_arg_desc         (id, ARG1,
     . 'Zonal velocity, on the MOM2 U Grid. ')
      CALL ef_set_arg_unit         (id, ARG1, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG1, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG1, YES, YES, YES, YES)
      CALL ef_set_axis_extend      (id, ARG1, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG1, Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG1, Z_AXIS,0,+1)

      CALL ef_set_arg_name         (id, ARG2, 'V')
      CALL ef_set_arg_desc         (id, ARG2,
     . 'Meridional velocity, on the MOM2 U Grid. ')
      CALL ef_set_arg_unit         (id, ARG2, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG2, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2,YES,YES,YES,YES)
      CALL ef_set_axis_extend      (id, ARG2, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG2, Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG2, Z_AXIS,0,+1)

      CALL ef_set_arg_name         (id, ARG3, 'TEMP')
      CALL ef_set_arg_desc         (id, ARG3,
     . 'Potential temperature, on MOM2 T Grid. ')
      CALL ef_set_arg_unit         (id, ARG3, 'deg-C')
      CALL ef_set_arg_type         (id, ARG3, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG3, NO, NO,YES,YES)
      CALL ef_set_axis_extend      (id, ARG3, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG3, Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG3, Z_AXIS,0,+1)

      CALL ef_set_arg_name         (id, ARG4, 'SALT')
      CALL ef_set_arg_desc         (id, ARG4,
     . 'Salinity, on MOM2 T Grid. ')
      CALL ef_set_arg_unit         (id, ARG4, '(ppt-35)/1000')
      CALL ef_set_arg_type         (id, ARG4, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG4, NO, NO,YES,YES)
      CALL ef_set_axis_extend      (id, ARG4, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG4, Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG4, Z_AXIS,0,+1)

      CALL ef_set_arg_name         (id, ARG5, 'HFLX')
      CALL ef_set_arg_desc         (id, ARG5,
     . 'Surface heat flux.')
      CALL ef_set_arg_unit         (id, ARG5, 'cal/cm^2/sec')
      CALL ef_set_arg_type         (id, ARG5, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG5, NO, NO, NO,YES)
      CALL ef_set_axis_extend      (id, ARG5, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG5, Y_AXIS,-1,+1)

      END 


      SUBROUTINE RR_diff_tz_compute(id, 
     .             arg_1,arg_2,arg_3,arg_4,arg_5,result)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'
      
      INTEGER        id

      REAL           bad_flag(EF_MAX_ARGS)
      REAL           bad_flag_result

      REAL           arg_1  (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .                       mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL           arg_2  (mem2lox:mem2hix, mem2loy:mem2hiy, 
     .                       mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL           arg_3  (mem3lox:mem3hix, mem3loy:mem3hiy, 
     .                       mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL           arg_4  (mem4lox:mem4hix, mem4loy:mem4hiy, 
     .                       mem4loz:mem4hiz, mem4lot:mem4hit)
      REAL           arg_5  (mem5lox:mem5hix, mem5loy:mem5hiy, 
     .                       mem5loz:mem5hiz, mem5lot:mem5hit)
      REAL           result (memreslox:memreshix,memresloy:memreshiy,
     .                       memresloz:memreshiz,memreslot:memreshit)
      INTEGER        res_lo_ss (4)
      INTEGER        res_hi_ss (4)
      INTEGER        res_incr  (4)

      INTEGER        arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER        arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER        arg_incr  (4,EF_MAX_ARGS)

      INTEGER        i,  j,  k,  l
      INTEGER        i1, j1, k1, l1
      INTEGER        i2, j2, k2, l2
      INTEGER        i3, j3, k3, l3
      INTEGER        i4, j4, k4, l4
      INTEGER        i5, j5, k5, l5

      REAL*8         zT(1024)
      REAL*8         zU(1024)
  
      INTEGER        iZ

      REAL get_dzw,diff_fb,diff_cbt
      REAL rhom1z,riu,Ri,Potential_density

      INCLUDE 'rr_parameters.h'

c  MOM2:  diff_fb(i,k,j)=diff_cbt(i,k,j)/dzw(k)*(t(i,k,j)-t(i,k+1,j))
c         diff_cbt = diffusion coefficient at bottom of "t" cells (cm**2/s)
c         dzw(k) = zT(k+1)-zT(k)

      diff_fb(i,j,k,l,iZ) = diff_cbt/get_dzw(iZ,zT) 
     .                 *(arg_3(i,j,k,l)-arg_3(i,j,k+1,l)) ! arg_3 = T

c  MOM2:  rhom1z(i,k,j) = ro(i,k,j) - ro(i,k+1,j)

      rhom1z(i3,j3,k3,l3,i4,j4,k4,l4) =
     .        Potential_density(arg_3(i3,j3,k3  ,l3),   ! arg_3 = T
     .                          arg_4(i4,j4,k4  ,l4))   ! arg_4 = S
     .      - Potential_density(arg_3(i3,j3,k3+1,l3),
     .                          arg_4(i4,j4,k4+1,l4)) 

c  MOM2:    grav    = gravity (cm/sec**2)
c  MOM2:    epsln   = small value: 1.e-25
     
      ! rr_parameters.h :
      !    REAL gravity = 980.6  cm/sec**2 
      !    REAL epsln = 1.e-25
 
c  MOM2:
c     riu(i,k,j) = -grav/4.*dzw(k)*(rhom1z(i,k,j+1) + rhom1z(i+1,k,j+1) +
c    &                            rhom1z(i,k,j)   + rhom1z(i+1,k,j)) /
c    &  ((u(i,k,j,1)-u(i,k+1,j,1))**2+(u(i,k,j,2)-u(i,k+1,j,2))**2 +  epsln) 

      riu (i1,j1,k1,l1,
     .     i2,j2,k2,l2,
     .     i3,j3,k3,l3,
     .     i4,j4,k4,l4, iZ) =  - gravity/4. * get_dzw(iZ,zT) * (
     .                  rhom1z(i3  ,j3+1,k3,l3,i4  ,j4+1,k4,l4) + 
     .                  rhom1z(i3+1,j3+1,k3,l3,i4+1,j4+1,k4,l4) +
     .                  rhom1z(i3  ,j3  ,k3,l3,i4  ,j4  ,k4,l4) + 
     .                  rhom1z(i3+1,j3  ,k3,l3,i4+1,j4  ,k4,l4) ) /
     .               ( (arg_1(i1,j1,k1,l1)-arg_1(i1,j1,k1+1,l1))**2 + !arg_1=U
     .                 (arg_2(i2,j2,k2,l2)-arg_2(i2,j2,k2+1,l2))**2   !arg_2=V
     .                        + epsln )

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags      (id, bad_flag,  bad_flag_result)
      CALL ef_get_coordinates    (id, ARG1, Z_AXIS, 
     .                            arg_lo_ss(Z_AXIS,ARG1),
     .                            arg_hi_ss(Z_AXIS,ARG1), zU)
      CALL ef_get_coordinates    (id, ARG3, Z_AXIS, 
     .                            arg_lo_ss(Z_AXIS,ARG3),
     .                            arg_hi_ss(Z_AXIS,ARG3), zT)

      l1 = arg_lo_ss(T_AXIS,ARG1) 
      l2 = arg_lo_ss(T_AXIS,ARG2) 
      l3 = arg_lo_ss(T_AXIS,ARG3) 
      l4 = arg_lo_ss(T_AXIS,ARG4) 
      l5 = arg_lo_ss(T_AXIS,ARG5)
      DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         j1 = arg_lo_ss(Y_AXIS,ARG1) + 1
         j2 = arg_lo_ss(Y_AXIS,ARG2) + 1
         j3 = arg_lo_ss(Y_AXIS,ARG3) + 1
         j4 = arg_lo_ss(Y_AXIS,ARG4) + 1
         j5 = arg_lo_ss(Y_AXIS,ARG5) + 1
         DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            i1 = arg_lo_ss(X_AXIS,ARG1) + 1
            i2 = arg_lo_ss(X_AXIS,ARG2) + 1
            i3 = arg_lo_ss(X_AXIS,ARG3) + 1
            i4 = arg_lo_ss(X_AXIS,ARG4) + 1
            i5 = arg_lo_ss(X_AXIS,ARG5) + 1
            DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
               iZ = 1
               k1 = arg_lo_ss(Z_AXIS,ARG1)
               k2 = arg_lo_ss(Z_AXIS,ARG2)
               k3 = arg_lo_ss(Z_AXIS,ARG3)
               k4 = arg_lo_ss(Z_AXIS,ARG4)
               k5 = arg_lo_ss(Z_AXIS,ARG5)
               DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

                  IF (arg_1(i1,  j1,  k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1,  j1,k1+1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1+1,j1,  k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1-1,j1,  k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1,  j1+1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1+1,j1+1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1-1,j1+1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1,  j1-1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1+1,j1-1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1-1,j1-1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_2(i2,  j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2,  j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2,  j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_3(i3,  j3,  k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3+1,j3,  k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3-1,j3,  k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3,  j3+1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3+1,j3+1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3-1,j3+1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3,  j3-1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3+1,j3-1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3-1,j3-1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_4(i4,  j4,  k4,l4) .EQ. bad_flag(ARG4) .OR.
     .                arg_4(i4+1,j4,  k4,l4) .EQ. bad_flag(ARG4) .OR.
     .                arg_4(i4-1,j4,  k4,l4) .EQ. bad_flag(ARG4) .OR.
     .                arg_4(i4,  j4+1,k4,l4) .EQ. bad_flag(ARG4) .OR.
     .                arg_4(i4+1,j4+1,k4,l4) .EQ. bad_flag(ARG4) .OR.
     .                arg_4(i4-1,j4+1,k4,l4) .EQ. bad_flag(ARG4) .OR.
     .                arg_4(i4,  j4-1,k4,l4) .EQ. bad_flag(ARG4) .OR.
     .                arg_4(i4+1,j4-1,k4,l4) .EQ. bad_flag(ARG4) .OR.
     .                arg_4(i4-1,j4-1,k4,l4) .EQ. bad_flag(ARG4) .OR.
     .                (iZ .EQ. 1 .AND. 
     .                    arg_5(i5,j5,k5,l5).EQ. bad_flag(ARG5))
     .                  )THEN
                     result(i,j,k,l) = bad_flag_result
                  ELSE



c  MOM2:   rit(i,k,j)=(riu(i,k,j)+riu(i-1,k,j)+riu(i,k,j-1)+riu(i-1,k,j-1))/4

                     Ri = (Riu(i1,  j1,  k1,l1, i2,  j2,  k2,l2,
     .                         i3,  j3,  k3,l3, i4,  j4,  k4,l4,iZ) 
     .                 +   Riu(i1-1,j1,  k1,l1, i2-1,j2,  k2,l2,
     .                         i3-1,j3,  k3,l3, i4-1,j4,  k4,l4,iZ) 
     .                 +   Riu(i1,  j1-1,k1,l1, i2,  j2-1,k2,l2,
     .                         i3,  j3-1,k3,l3, i4,  j4-1,k4,l4,iZ) 
     .                 +   Riu(i1-1,j1-1,k1,l1, i2-1,j2-1,k2,l2,
     .                         i3-1,j3-1,k3,l3, i4-1,j4-1,k4,l4,iZ) 
     .                      )/4.



             ! Compute diffusion coefficient

             ! REAL fricmx=maximum diffusion coefficient=50 cm**2/s 
             ! REAL diff_cbt_limit=largest diffusion coefficient=50 cm**2/sec 
             ! REAL diff_cbt_back=background diffusion coefficient=0.1 cm**2/s
             ! REAL wndmix = min value for diffusion coefficient at surface to 
             !               simulate high freq wind mixing = 10 cm**2/sec 
             ! REAL Meters_to_cm = Convert: m --> cm = 100.
             ! REAL sec_per_month = Time conversion :  Convert: month --> sec
             !                      NOTE: sec_per_month currently set = 1, 
             !                      so the function returns 
             !                      oC/s, not oC/month

c MOM2:   check stability: if(rit(i,k,j).lt.0.)diff_cbt(i,k,j,1)=diff_cbt_limit
c                      diff_cbt(i,k,j,1) = fricmx*t2**3 + diff_cbt_back
c                               t2 = 1/(1 + 5*rit(i,k,j))
c         surface effect at top grid point:
c                    if(diff_cbt(i,1,j,1).lt.wndmix)diff_cbt(i,1,j,1)=wndmix

                     IF(Ri.lt.0.)THEN
                        ! PRINT*,'WARNING::Ri<0.-->unstable'
                        diff_cbt = diff_cbt_limit  ! unstable
                     ELSE
                        diff_cbt = fricmx/(1.+5.*Ri)**3
     .                                      + diff_cbt_back
                        IF(iZ.EQ.1.AND.diff_cbt.lt.wndmix)THEN
                           !PRINT*,'surface flux pegged at wndmix'
                           diff_cbt=wndmix   ! surface
                        ENDIF
                     ENDIF


c  MOM2:
c      DIFF_Tz(i,k,j) = (diff_fb(i,k-1,j) - diff_fb(i,k,j)) / dzt(k)
c         diff_fb(i,0,j)  = stf(i,j,n)
c     dzt    = thickness of "t" grid cells (cm)
c     dzw(0) = zT(1)
c     stf     = surface heat flux (cal/cm2/sec)
c     Note: units: result(i,j,k,l)
c        stf = Heat Flux/rho/Cp =(cal/cm2/sec)/(1 g/cm3)/(1. cal/g/oC)
c            = oC-cm/sec

                    IF (iZ.EQ.1) THEN  ! Top term is wind stress term
                      result(i,j,k,l) = (   arg_5(i5,j5,k5,l5)  ! arg_5 = HFLX
     .                                  -  diff_fb(i1,j1,k1,l1,iZ)  )
     .                /(SNGL(zT(1)+zT(2))/2.*Meters_to_cm)
     .                         * sec_per_month 
                    ELSE
                       result(i,j,k,l) = ( diff_fb(i1,j1,k1-1,l1,iZ-1)
     .                                  -  diff_fb(i1,j1,k1,l1,iZ) )
     .                /(SNGL(zT(iZ+1)-zT(iZ-1))/2. * Meters_to_cm)
     .                         * sec_per_month 
                    ENDIF


!          GOTO 1009 
          PRINT*
          PRINT*
          PRINT*,'i,j,k,l     = ', i,j,k,l
          PRINT*,'i1,j1,k1,l1 = ', i1,j1,k1,l1
          PRINT*,'i2,j2,k2,l2 = ', i2,j2,k2,l2
          PRINT*,'i3,j3,k3,l3 = ', i3,j3,k3,l3
          PRINT*,'i4,j4,k4,l4 = ', i4,j4,k4,l4
          PRINT*,'i5,j5,k5,l5 = ', i5,j5,k5,l5
          PRINT*,'iZ             = ',iZ
          PRINT*,'zT(iZ)         = ',zT(iZ)
          PRINT*,'get_dzw(iZ,zT) = ',get_dzw(iZ,zT)
          PRINT*,'T(i3,j3,k3  ,l3) = ', arg_3(i3,j3,k3  ,l3)
          PRINT*,'S(i4,j4,k4  ,l4) = ', arg_4(i4,j4,k4  ,l4)
          PRINT*,'T(i3,j3,k3+1,l3) = ', arg_3(i3,j3,k3+1,l3)
          PRINT*,'S(i4,j4,k4+1,l4) = ', arg_4(i4,j4,k4+1,l4) 
          PRINT*,'T(i3+1,j3,k3  ,l3) = ', arg_3(i3+1,j3,k3  ,l3)
          PRINT*,'S(i4+1,j4,k4  ,l4) = ', arg_4(i4+1,j4,k4  ,l4)
          PRINT*,'T(i3+1,j3,k3+1,l3) = ', arg_3(i3+1,j3,k3+1,l3)
          PRINT*,'S(i4+1,j4,k4+1,l4) = ', arg_4(i4+1,j4,k4+1,l4) 
          PRINT*,'T(i3,j3+1,k3  ,l3) = ', arg_3(i3,j3+1,k3  ,l3)
          PRINT*,'S(i4,j4+1,k4  ,l4) = ', arg_4(i4,j4+1,k4  ,l4)
          PRINT*,'T(i3,j3+1,k3+1,l3) = ', arg_3(i3,j3+1,k3+1,l3)
          PRINT*,'S(i4,j4+1,k4+1,l4) = ', arg_4(i4,j4+1,k4+1,l4) 
          PRINT*,'T(i3+1,j3+1,k3  ,l3) = ', arg_3(i3+1,j3+1,k3  ,l3)
          PRINT*,'S(i4+1,j4+1,k4  ,l4) = ', arg_4(i4+1,j4+1,k4  ,l4)
          PRINT*,'T(i3+1,j3+1,k3+1,l3) = ', arg_3(i3+1,j3+1,k3+1,l3)
          PRINT*,'S(i4+1,j4+1,k4+1,l4) = ', arg_4(i4+1,j4+1,k4+1,l4) 
          PRINT*,'Potential_density(1) = ',
     .           Potential_density(arg_3(i3,j3,k3  ,l3),   ! arg_3 = T
     .                             arg_4(i4,j4,k4  ,l4))   ! arg_4 = S
          PRINT*,'Potential_density(2) = ',
     .           Potential_density(arg_3(i3,j3,k3+1,l3),
     .                             arg_4(i4,j4,k4+1,l4)) 
          PRINT*,'rhom1z(1) = ',rhom1z(i3  ,j3+1,k3,l3,i4  ,j4+1,k4,l4)  
          PRINT*,'rhom1z(2) = ',rhom1z(i3+1,j3+1,k3,l3,i4+1,j4+1,k4,l4) 
          PRINT*,'rhom1z(3) = ',rhom1z(i3  ,j3  ,k3,l3,i4  ,j4  ,k4,l4)  
          PRINT*,'rhom1z(4) = ',rhom1z(i3+1,j3  ,k3,l3,i4+1,j4  ,k4,l4) 
          PRINT*,'Riu(1) = ',Riu(i1, j1, k1,l1, i2, j2, k2,l2,
     .                         i3,  j3,  k3,l3, i4,  j4,  k4,l4,iZ)
          PRINT*,'Riu(2) = ',Riu(i1-1,j1,  k1,l1, i2-1,j2,  k2,l2,
     .                         i3-1,j3,  k3,l3, i4-1,j4,  k4,l4,iZ)
          PRINT*,'Riu(3) = ',Riu(i1,  j1-1,k1,l1, i2,  j2-1,k2,l2,
     .                         i3,  j3-1,k3,l3, i4,  j4-1,k4,l4,iZ)
          PRINT*,'Riu(4) = ',Riu(i1-1,j1-1,k1,l1, i2-1,j2-1,k2,l2,
     .                         i3-1,j3-1,k3,l3, i4-1,j4-1,k4,l4,iZ) 
          PRINT*,'Ri     = ',Ri
          PRINT*,'HFLX   = ',arg_5(i5,j5,k5,l5)
          PRINT*,'diff_cbt = ',diff_cbt
          PRINT*,'diff_fb  = ',diff_fb(i1,j1,k1,l1,iZ)
          PRINT*,'result   = ',result(i,j,k,l)
          PRINT*,'SNGL(zT(1)+zT(2))/2.*Meters_to_cm',
     .           SNGL(zT(1)+zT(2))/2.*Meters_to_cm
          PRINT* 
          PRINT*,'*******************************************'
          PRINT*
 1009     CONTINUE

                  ENDIF
                  iZ = iZ + 1 
                  k1 = k1 + arg_incr(Z_AXIS,ARG1)
                  k2 = k2 + arg_incr(Z_AXIS,ARG2)
                  k3 = k3 + arg_incr(Z_AXIS,ARG3)
                  k4 = k4 + arg_incr(Z_AXIS,ARG4)
                  k5 = k5 + arg_incr(Z_AXIS,ARG5)
               ENDDO
               i1 = i1 + arg_incr(X_AXIS,ARG1)
               i2 = i2 + arg_incr(X_AXIS,ARG2)
               i3 = i3 + arg_incr(X_AXIS,ARG3)
               i4 = i4 + arg_incr(X_AXIS,ARG4)
               i5 = i5 + arg_incr(X_AXIS,ARG5)
            ENDDO
            j1 = j1 + arg_incr(Y_AXIS,ARG1)
            j2 = j2 + arg_incr(Y_AXIS,ARG2)
            j3 = j3 + arg_incr(Y_AXIS,ARG3)
            j4 = j4 + arg_incr(Y_AXIS,ARG4)
            j5 = j5 + arg_incr(Y_AXIS,ARG5)
         ENDDO               
         l1 = l1 + arg_incr(T_AXIS,ARG1)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
         l3 = l3 + arg_incr(T_AXIS,ARG3)
         l4 = l4 + arg_incr(T_AXIS,ARG4)
         l5 = l5 + arg_incr(T_AXIS,ARG5)      
      ENDDO
      END




      REAL FUNCTION Potential_density(T,S) ! Density at one Bar 
      IMPLICIT NONE
      REAL T ! Potential Temperature  
      REAL S ! ( SALINITY(ppt) - 35) / 1000 
      REAL Pressure / 1.0 / ! Bar
      REAL Sppt ! Salinity (ppt)     
      Sppt = 1.e3*S+35.  ! Convert S: -->  ppt
      CALL RR_unesco(T,Sppt,Pressure,Potential_density)
      Potential_density = Potential_density*1.e-3  ! Convert:kg/m^3-->g/cm^3
      END						

      REAL FUNCTION get_dzw(iZ,zT) 
      IMPLICIT NONE
      INCLUDE 'rr_parameters.h'
      INTEGER iZ
      REAL*8 zT(iZ+1)
      IF(iZ.EQ.0)THEN
	get_dzw=SNGL(zT(1))*Meters_to_cm 
      ELSE
        get_dzw=SNGL(zT(iZ+1)-zT(iZ))*Meters_to_cm
      ENDIF
      END

	SUBROUTINE NETCDF4_LIST_SETTINGS (status)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or 'bug fixes'.
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP 'AS IS' AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Get the settings for netcdf4 output datasets and store them in common.

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Thermal Modeling and Analysis Program
*
* revision 0.0 - 1/13/2010
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

* Read info from qualilifiers for LIST netCDF4: NCFORMAT,
* XCHUNK,YCHUNK,ZCHUNK,TCHUNK,ECHUNK,FCHUNK,DEFLATE,SHUFFLE,ENDIAN

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'slash.parm'
	include 'xcontext.cmn'
	include 'xprog_state.cmn'
	include 'errmsg.parm'
        include 'netcdf4_settings.cmn'

* calling argument declarations
	INTEGER		status

* internal variable declarations
	INTEGER  STR_SAME, loc, slen
	CHARACTER buff*128

* initialize netcdf4-type stuff. If there has been a 
* SET LIST/NCFORMAT/ENDIAN/DEFLATE/SHUFFLE then these contain those values,
* otherwise they are set to the defaults

	netcdf4_type = netcdf4_type_set
	xchunk_size  = xchunk_size_set
	ychunk_size  = ychunk_size_set
	zchunk_size  = zchunk_size_set
	tchunk_size  = tchunk_size_set
	echunk_size  = echunk_size_set
	fchunk_size  = fchunk_size_set
	deflate_lev  = deflate_lev_set
	shuffle_flag = shuffle_flag_set
	endian_code  = endian_code_set

* /NCFORMAT for netCDF4 types ?
* NETCDF4 and CLASSIC, or 4=NETCDF4, 3=CLASSIC, 64BIT_OFFSET(?)

        loc = qual_given( slash_list_ncformat )
	IF (loc .GT. 0) THEN 
	   CALL EQUAL_STRING(
     .                   cmnd_buff(qual_start(loc):qual_end(loc)),
     .                   buff, status )              
           IF ( status .NE. ferr_ok ) GOTO 5000
	   IF (STR_SAME(buff(1:3), 'CLA') .EQ. 0) THEN
              netcdf4_type = 3
	   ELSEIF (STR_SAME(buff(1:1), '3') .EQ. 0) THEN
              netcdf4_type = 3
	   ELSEIF (STR_SAME(buff(1:7), 'NETCDF4') .EQ. 0) THEN
              netcdf4_type = 4
	   ELSEIF (STR_SAME(buff(1:1), '4') .EQ. 0) THEN
              netcdf4_type = 4
	   ELSEIF (STR_SAME(buff(1:3), '64B' ) .EQ. 0) THEN ! NF_64BIT_OFFSET
              netcdf4_type = 6
	   ELSEIF (STR_SAME(buff(1:1), '6' ) .EQ. 0) THEN
              netcdf4_type = 6
           ELSE
	      GOTO 5100
	   ENDIF
	ENDIF

* /XCHUNK,YCHUNK,ZCHUNK,TCHUNK,ECHUNK,FCHUNK for netCDF4 chunking?

	loc = qual_given( slash_list_xchunk )
	IF (loc .GT. 0) THEN 
	   CALL EQUAL_STRING(
     .                   cmnd_buff(qual_start(loc):qual_end(loc)),
     .                   buff, status )              
           READ (buff, *) xchunk_size
	   IF (xchunk_size .LE. 0) GOTO 5200
	ENDIF
 
        loc = qual_given( slash_list_ychunk )
	IF (loc .GT. 0) THEN 
	   CALL EQUAL_STRING(
     .                   cmnd_buff(qual_start(loc):qual_end(loc)),
     .                   buff, status )
           IF ( status .NE. ferr_ok ) GOTO 5000
           READ (buff, *) ychunk_size
	   IF (ychunk_size .LE. 0) GOTO 5200
	ENDIF

        loc = qual_given( slash_list_zchunk )
	IF (loc .GT. 0) THEN 
	   CALL EQUAL_STRING(
     .                   cmnd_buff(qual_start(loc):qual_end(loc)),
     .                   buff, status )
           IF ( status .NE. ferr_ok ) GOTO 5000
           READ (buff, *) zchunk_size
	   IF (zchunk_size .LE. 0) GOTO 5200
	ENDIF
	
        loc = qual_given( slash_list_tchunk )
	IF (loc .GT. 0) THEN 
	   CALL EQUAL_STRING(
     .                   cmnd_buff(qual_start(loc):qual_end(loc)),
     .                   buff, status )
           IF ( status .NE. ferr_ok ) GOTO 5000
           READ (buff, *) tchunk_size
	   IF (tchunk_size .LE. 0) GOTO 5200
	ENDIF
	
        loc = qual_given( slash_list_echunk )
	IF (loc .GT. 0) THEN 
	   CALL EQUAL_STRING(
     .                   cmnd_buff(qual_start(loc):qual_end(loc)),
     .                   buff, status )
           IF ( status .NE. ferr_ok ) GOTO 5000
           READ (buff, *) echunk_size
	   IF (echunk_size .LE. 0) GOTO 5200
	ENDIF
	
        loc = qual_given( slash_list_fchunk )
	IF (loc .GT. 0) THEN 
	   CALL EQUAL_STRING(
     .                   cmnd_buff(qual_start(loc):qual_end(loc)),
     .                   buff, status )
           IF ( status .NE. ferr_ok ) GOTO 5000
           READ (buff, *) fchunk_size
	   IF (fchunk_size .LE. 0) GOTO 5200
	ENDIF

* DEFLATE 
* Can set compression level though all indicatins are that value=1 is best
* deflate=0 means no deflate

        loc = qual_given( slash_list_DEFLATE )
	IF (loc .GT. 0) THEN 
	   CALL EQUAL_STRING(
     .                   cmnd_buff(qual_start(loc):qual_end(loc)),
     .                   buff, status )
           IF ( status .NE. ferr_ok ) GOTO 5000
	   IF (STR_SAME(buff, ' ' ) .EQ. 0) THEN 
	      deflate_lev = 1
	   ELSE
              READ (buff, *) deflate_lev
	   ENDIF
	   IF (deflate_lev .LT. 0 .OR. deflate_lev.GT.9) GOTO 5300
	ENDIF

* SHUFFLE 
* Shuffle = 0 or 1

	loc = qual_given( slash_list_shuffle )
	IF (loc .GT. 0) THEN 
	   CALL EQUAL_STRING(
     .                   cmnd_buff(qual_start(loc):qual_end(loc)),
     .                   buff, status )
           IF ( status .NE. ferr_ok ) GOTO 5000
	   IF (STR_SAME(buff, ' ' ) .EQ. 0) THEN 
	      shuffle_flag = 1
	   ELSE
              READ (buff, *) shuffle_flag
	   ENDIF
	   IF (shuffle_flag .NE. 0 .AND. shuffle_flag.NE.1) GOTO 5400
	ENDIF

! ENDIAN: native, little, big

        loc = qual_given( slash_list_endian )
	IF (loc .GT. 0) THEN 
	   CALL EQUAL_STRING(
     .                   cmnd_buff(qual_start(loc):qual_end(loc)),
     .                   buff, status )
           IF ( status .NE. ferr_ok ) GOTO 5000
	   IF (STR_SAME(buff, ' ' ) .EQ. 0) THEN 
	      endian_code = 0 
	   ELSEIF (STR_SAME(buff(1:3), 'LIT') .EQ. 0) THEN
              endian_code = 1 ! nf_endian_little
	   ELSEIF (STR_SAME(buff(1:3), 'BIG') .EQ. 0) THEN
              endian_code = 2 ! nf_endian_big
	   ELSEIF (STR_SAME(buff(1:3), 'NAT') .EQ. 0) THEN
              endian_code = 0 ! nf_endian_native
	   ELSE
              GOTO 5500
	   ENDIF
	   
	ENDIF

* Check for illegal compression or chunking requested on netCDF3 or 
* 64BIT_OFFSET and restore defaults

	IF (netcdf4_type .EQ. 3) THEN
	   buff = 'NetCDF Classic'
	   slen = 14
	ENDIF
	IF (netcdf4_type .EQ. 6) THEN
	   buff = 'NetCDF 64BIT_OFFSET'
           slen = 19
	ENDIF

	IF (netcdf4_type.EQ.3 .OR. netcdf4_type.EQ.6) THEN
	   IF (deflate_lev .NE. 0) THEN
	      deflate_lev = 0
	      CALL WARN(
     . buff(:slen)//' style cannot set compression, ignoring /DEFLATE')
	   ENDIF

	   IF (shuffle_flag .NE. 0) THEN
	      shuffle_flag = 0
	      CALL WARN(
     . buff(:slen)//' style cannot set compression, ignoring /SHUFFLE')
	   ENDIF

	   IF (xchunk_size .NE. 0 .OR. ychunk_size .NE. 0 .OR. 
     .         zchunk_size .NE. 0 .OR. tchunk_size .NE. 0.OR. 
     .         echunk_size .NE. 0 .OR. fchunk_size .NE. 0) THEN
	      xchunk_size = 0
	      ychunk_size = 0
	      zchunk_size = 0
	      tchunk_size = 0
	      echunk_size = 0
	      fchunk_size = 0
	      CALL WARN(
     . buff(:slen)//' style cannot set chunking, ignoring /*CHUNK')
	   ENDIF

	   IF (endian_code .NE. 0) THEN
	      endian_code = 0
	      CALL WARN(
     . buff(:slen)//' style cannot set Endian, ignoring /ENDIAN')
	   ENDIF
	
	ENDIF

	status = ferr_ok

 1000	CONTINUE
	RETURN

* error messages

 5000	CALL ERRMSG( ferr_invalid_command, status,
     .  'Error reading parameters in netcdf4_list_settings', *1000 )
 5100	CALL ERRMSG( ferr_invalid_command, status,
     . '/NCFORMAT may take values NETCDF4, CLASSIC, 4, 3, 64BIT_OFFSET', 
     . *1000 )
 5200	CALL ERRMSG( ferr_invalid_command, status,
     .		'/*CHUNK= values must be > 0', *1000 )
 5300	CALL ERRMSG( ferr_invalid_command, status,
     .		'/DEFLATE level must be between 0 and 9', *1000 )
 5400	CALL ERRMSG( ferr_invalid_command, status,
     .		'/SHUFFLE must take the value 0 or 1', *1000 )
 5500	CALL ERRMSG( ferr_invalid_command, status,
     . '/ENDIAN may be NATIVE, LITTLE or BIG', *1000 )
	END

*
* index_to_grid.F
*
* Jonathan Callahan
* Feb 25th 2002
*
* This function reads in tuples (i,j,val) which correspond
* to the FORTRAN indices of the value.  Some sites use this
* method to compress data for gridded fields.
*
* The fourth argument contains the destination grid.
*
* The tuples are assumed to already be defined on an abstract
* X and real Z and T axes.  The examples I have seen so far
* are model output at a single level and multiple timesteps.
* The tuple output only corresponds to the X and Y axes and 
* is used instead of assigning bad flags or masks.
*
* Note that the FORTRAN indices I and J DO NOT correspond
* to the Ferret indices I and J.  The following interpretation
* is made:
*
* FORTRAN I = row number = FERRET J = latitude (perhaps oriented N->S)
* FORTRAN J = col number = FERRET I = longitude


*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE index_to_grid_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     . 'puts (I,J,VAL) tuples on grid of D' )

      CALL ef_set_num_args(id, 4)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'I')
      CALL ef_set_arg_desc(id, arg, 'Fortran I index (row) of VAL ')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'J')
      CALL ef_set_arg_desc(id, arg, 'Fortran J index (column) of VAL')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'VAL')
      CALL ef_set_arg_desc(id, arg, 'Value at grid cell [I,J]')
      CALL ef_set_axis_influence(id, arg, NO, NO, YES, YES)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'D')
      CALL ef_set_arg_desc(id, arg, 'destination grid taken from D')
      CALL ef_set_axis_influence(id, arg, YES, YES, NO, NO)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE index_to_grid_compute(id, arg_1, arg_2, arg_3, arg_4,
     .                                 result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy,
     .     mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy,
     .     mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy,
     .     mem4loz:mem4hiz, mem4lot:mem4hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER i3,j3,k3,l3

      INTEGER index_i,index_j

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)


* First -- populate the result with bad flags.

      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
               DO 100 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

                     result(i,j,k,l) = bad_flag_result

 100           CONTINUE
 200        CONTINUE
 300     CONTINUE
 400  CONTINUE
      

* Second -- Loop over the K and L axes.
*           Put the values where they belong.
*
*           Assumption: I,J,VAL are on the same grid.
*           Assumption: I is the row # and is associated with a latitude
*           Assumption: J is the col # and is associated with a longitude

      i = res_lo_ss(X_AXIS)
      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      l = res_lo_ss(T_AXIS)

* Note: there should not be a Y axis on argument 3
      j3 = arg_lo_ss(Y_AXIS,ARG3)

      l3 = arg_lo_ss(T_AXIS,ARG3)
      DO 700 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         k3 = arg_lo_ss(Z_AXIS,ARG3)
         DO 600 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

            DO 500 i3=arg_lo_ss(X_AXIS,ARG3), arg_hi_ss(X_AXIS,ARG3)
               index_i = i - 1 + arg_2(i3,j3,k3,l3) 
               index_j = j - 1 + arg_1(i3,j3,k3,l3)
               result(index_i,index_j,k,l) = arg_3(i3,j3,k3,l3)
 500        CONTINUE

            k3 = k3 + arg_incr(Z_AXIS,ARG3)
 600     CONTINUE
         l3 = l3 + arg_incr(T_AXIS,ARG3)
 700  CONTINUE
      
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	SUBROUTINE  W_ON_TS( uk  , muk,
     .			     vk  , mvk,
     .			     w_t , mw_t )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* compute W ( vertical velocity ) on TEMP/SALT columns via zero divergence 
* condition

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 7/22/87
* V200:  7/27/89 - 4D symmetrical version
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN

#ifdef unix
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'gfdl.parm'		! parameter definitions
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xonedim.cmn'	! geometric constants
	include 'xcontext.cmn'
#else
	INCLUDE 'FERRET_CMN:FERRET.PARM'
	INCLUDE 'FERRET_CMN:GFDL.PARM'		! parameter definitions
	INCLUDE	'FERRET_CMN:XVARIABLES.CMN'
	INCLUDE	'FERRET_CMN:XMEM_SUBSC.CMN'
	INCLUDE 'FERRET_CMN:XONEDIM.CMN'	! geometric constants
	INCLUDE 'FERRET_CMN:XCONTEXT.CMN'
#endif

* calling argument declarations:
	INTEGER	muk, mvk, mw_t

* subscript ranges from memory variable table ...
	REAL     uk( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit ),
     .		 vk( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,m2lot:m2hit ),
     .		w_t( m3lox:m3hix,m3loy:m3hiy,m3loz:m3hiz,m3lot:m3hit )

* internal variable declarations:
	INTEGER	i_lo, i_hi, j_lo, j_hi, k_lo, k_hi, l_lo, l_hi, i, j, k, l
	REAL	bad_uk, bad_vk, bad_w_t, fact1, fact2, fact3, factor
	REAL	fvn, fvst, fuw(2:imtp1)

* --- end of introductory code ---

* limits for calculation
	i_lo = mr_lo_s1(mw_t)
	i_hi = mr_hi_s1(mw_t)
	j_lo = mr_lo_s2(mw_t)
	j_hi = mr_hi_s2(mw_t)
	k_lo = mr_lo_s3(mw_t)
	k_hi = mr_hi_s3(mw_t)
	l_lo = mr_lo_s4(mw_t)
	l_hi = mr_hi_s4(mw_t)

* flag for bad/missing data
	bad_uk   = mr_bad_data( muk )
	bad_vk	 = mr_bad_data( mvk )
	bad_w_t  = mr_bad_data( mw_t )

* ***************************************************************
* ORIGINAL GFDL 205 CODE UPON WHICH CALCULATION IS BASED
*
* 2966 C
* 2967 C   FIND ADVECTIVE COEFFICIENTS FOR WEST AND NORTH FACES OF T,S BOXES
* 2968 C
* 2969       FACT1=CSTR(J)*DYTR(J)
* 2970       FACT2=DYTR(J)*CSTR(J)*CS(J)
* 2971       DO 690 K=1,KM
* 2972       DO 690 I=1,IMT
* 2973       FUW(I,K)=(U(I-1,K)*DYU(J)+UM(I-1,K)*DYU(J-1))*FACT1
* 2974       FVN(I,K)=(V(I,K)*DXU2D(I,K)+V(I-1,K)*DXU2D(I-1,K))
* 2975      1 *FACT2*DXT4R2D(I,K)
* 2976  690  CONTINUE
* 2977       IF (NERGY.NE.0) W=0.
* 2978 C
* 2979 C   COMPUTE VERTICAL VELOCITY IN T,S COLUMNS
* 2980 C
* 2981       DO 700 I=1,IMT
* 2982       W(I,1)=0.0
* 2983  700  CONTINUE
* 2984       DO 710 K=1,KM
* 2985       DO 710 I=1,IMT
* 2986       W(I,K+1)=C2DZ2D(I,K)*((FUW(I+1,K)-FUW(I,K))*DXT4R2D(I,K)+FVN(I,K)
* 2987      1    -FVST(I,K))
* 2988  710  CONTINUE
* 2989       DO 712 K=1,KM
* 2990       DO 712 I=1,IMT
* 2991       W(I,K+1)=W(I,K)+W(I,K+1)
* 2992  712  CONTINUE

* 3250 C   SET ADVECTIVE COEFFICIENT FOR NEXT CALL
* 3251 C
* 3252       FACTOR=CST(J)*DYT(J)*CSTR(J+1)*DYTR(J+1)
* 3253       DO 990 K=1,KM
* 3254       DO 990 I=1,IMT
* 3255       FVST(I,K)=FVN(I,K)*FACTOR
* 3256  990  CONTINUE

*******************************************************************
C   COMPUTE VERTICAL VELOCITY IN TEMP/SALT COLUMNS
* south to north loop through east-west lines
	DO 1000 j = j_lo, j_hi

	IF ( j .EQ. 1  .OR.  j .EQ. jm ) THEN
	   DO 100 l = l_lo, l_hi
	   DO 100 k = k_lo, k_hi
	   DO 100 i = i_lo, i_hi
 100	   w_t(i,j,k,l) = bad_w_t
	   GOTO 1000
	ENDIF

C   FIND ADVECTIVE COEFFICIENTS FOR SOUTH AND NORTH FACES OF T,S BOXES	! 2967

      FACT1 = CSTR(j)*DYTR(j)	    				! 2969 mod
      FACT2 = fact1 * CS(j)	 	   			! 2970 mod
      fact3 = fact1 * cs(j-1)

      DO 900 l = l_lo, l_hi
      DO 900 k = k_lo, k_hi

      DO 690 I= MAX(2,i_lo), MIN(imt,i_hi)+1			! 2972 mod
	IF ( uk(i-1,j  ,k,l) .EQ. bad_uk
     .  .OR. uk(i-1,j-1,k,l) .EQ. bad_uk ) THEN
	   fuw(i) = bad_val4
	ELSE
           FUW(I)=(Uk(i-1,j,k,l)*DYU(j)+Uk(I-1,j-1,k,l)*DYU(j-1))*FACT1	! 2973 mod
	ENDIF
 690  CONTINUE	    							! 2976


C   COMPUTE VERTICAL increment to w VELOCITY IN T,S COLUMNS
      DO 710 I = MAX(2,i_lo), MIN(imtm1,i_hi)
	IF ( fuw(i  ) .EQ. bad_val4
     .  .OR. fuw(i+1) .EQ. bad_val4 ) THEN
	   w_t(i,j,k,l) = bad_w_t

	ELSEIF ( vk(i  ,j  ,k,l) .EQ. bad_vk
     .  .OR.     vk(i-1,j  ,k,l) .EQ. bad_vk
     .	.OR.     vk(i-1,j-1,k,l) .EQ. bad_vk ) THEN
	   w_t(i,j,k,l) = bad_w_t

	ELSE
	   FVN  = (Vk(I,j  ,k,l)*DXU(I)+Vk(I-1,j  ,k,l)
     .				*DXU(I-1))*FACT2*DXT4R(I)		! 2975 
	   FVST = (Vk(I,j-1,k,l)*DXU(I)+Vk(I-1,j-1,k,l)
     .				*DXU(I-1))*FACT3*DXT4R(I)
	   w_t(I,j,k,l)=C2DZ(K)*( (FUW(I+1)-FUW(I))*DXT4R(I) + FVN-FVST )
	ENDIF
 710  CONTINUE

* mask out edges ?
	IF ( i_lo .EQ. 1   ) w_t(1  ,j,k,l) = bad_w_t
	IF ( i_hi .EQ. imt ) w_t(imt,j,k,l) = bad_w_t

 900	CONTINUE
 1000	CONTINUE


* now add this dW to w's from above
	DO 255 l = l_lo, l_hi
	DO 255 k = 2   , k_hi
	DO 255 j = j_lo, j_hi
	DO 255 i = i_lo, i_hi

	   IF ( w_t(i,j,k-1,l) .EQ. bad_w_t ) THEN

	      w_t(i,j,k,l) = bad_val4

	   ELSE

	      w_t(i,j,k,l) = w_t(i,j,k-1,l) + w_t(i,j,k,l)

	   ENDIF

 255	CONTINUE

	RETURN
	END

*
* samplek_multi.F
*
* Ansley Manke
* Dec 1998
*
* This function samples data along the K axis using a set of indices
* 4/5/99  Ansley Manke 
*         Indices may be oriented along any axis; 
*         Result is abstract on the sampled axis.
* 4/19  Reverse the order of arguments to be consistent with the
*       SAMPLEL etc functions.
* 4/19  See issue 1924: reworking sample-multi functions
* 4/12/19 See issue 1924: both args must have axis in the sample direction.

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
      SUBROUTINE samplek_multi_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg
*                                                                     V
      CHARACTER*100 fcn_desc
      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns data sampled according to K indices which ',
     .        'may vary in IJLMN')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 2)

      CALL ef_set_axis_inheritance_6d(id,
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)

      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'DAT_TO_SAMPLE')
      CALL ef_set_arg_desc(id, arg, 'data to sample using K indices')
      CALL ef_set_axis_influence_6d(id, arg, YES, YES, NO, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'K_INDICES')
      CALL ef_set_arg_desc(id, arg, 'ordered indices')
      CALL ef_set_axis_influence_6d(id, arg, YES, YES, YES, YES, YES, YES)


      RETURN 
      END

* Compute the result
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
      SUBROUTINE samplek_multi_compute(id, arg_1, arg_2, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

* Declarations
      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .      mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .     mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .     memresloz:memreshiz, memreslot:memreshit,
     .      memresloe:memreshie, memreslof:memreshif)

      INTEGER res_lo_ss(6), res_hi_ss(6), res_incr(6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS), arg_hi_ss(6,EF_MAX_ARGS),
     .     arg_incr(6,EF_MAX_ARGS)

      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2
      INTEGER idim, p1, sampl_ax
      REAL aindex
      CHARACTER adir(6)*1, dir_string*12, errstr*100, dat_shape*8
      DATA adir /'X', 'Y', 'Z', 'T', 'E', 'F'/

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* Both arguments must have an axis in the sample direction

      sampl_ax = Z_AXIS

      dir_string = adir(sampl_ax)
      IF (arg_hi_ss(sampl_ax, ARG1) .EQ. ef_unspecified_int4) GOTO 999
      IF (arg_hi_ss(sampl_ax, ARG2) .EQ. ef_unspecified_int4) GOTO 999

* Initialize the result
      result = bad_flag_result

* Now do the sampling

      n1 = arg_lo_ss(F_AXIS, ARG1)
      n2 = arg_lo_ss(F_AXIS, ARG2)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS) 
     
      m1 = arg_lo_ss(E_AXIS, ARG1)
      m2 = arg_lo_ss(E_AXIS, ARG2)
      DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS) 

      l1 = arg_lo_ss(T_AXIS, ARG1)
      l2 = arg_lo_ss(T_AXIS, ARG2)
      DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS) 

      j1 = arg_lo_ss(Y_AXIS,ARG1)
      j2 = arg_lo_ss(Y_AXIS,ARG2)
      DO 300 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

      i1 = arg_lo_ss(X_AXIS,ARG1)
      i2 = arg_lo_ss(X_AXIS,ARG2)
      DO 200 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

      k2 = arg_lo_ss(Z_AXIS,ARG2)
      DO 100 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

*  Get the index to sample.
	 
	 aindex = arg_2(i2,j2,k2,l2,m2,n2)
         p1 = aindex

* Set the result. Check that we do have an index of ARG_1.
* If the indices don't lie in range the result is missing.

	 IF (aindex .EQ. bad_flag(ARG1))  CYCLE

	 IF ( p1.GE.arg_lo_ss(sampl_ax,ARG1) .AND. 
     .        p1.LE.arg_hi_ss(sampl_ax,ARG1) ) THEN
           
            IF (arg_1(i1,j1,p1,l1,m1,n1) .NE. bad_flag(ARG1)) 
     .        result(i,j,k,l,m,n) = arg_1(i1,j1,p1,l1,m1,n1)

	 ENDIF

         k2 = k2 + arg_incr(Z_AXIS,ARG2)
 100  CONTINUE

      i1 = i1 + arg_incr(X_AXIS,ARG1)
      i2 = i2 + arg_incr(X_AXIS,ARG2)
 200  CONTINUE

      j1 = j1 + arg_incr(Y_AXIS,ARG1)
      j2 = j2 + arg_incr(Y_AXIS,ARG2)
 300  CONTINUE

      l1 = l1 + arg_incr(T_AXIS,ARG1)
      l2 = l2 + arg_incr(T_AXIS,ARG2)
 400  CONTINUE

      m1 = m1 + arg_incr(E_AXIS,ARG1)
      m2 = m2 + arg_incr(E_AXIS,ARG2)
 500  CONTINUE

      n1 = n1 + arg_incr(F_AXIS,ARG1)
      n2 = n2 + arg_incr(F_AXIS,ARG2)
 600  CONTINUE

      RETURN

 999  CONTINUE
      errstr = 'Both arguments must have an axis in '//dir_string 
      CALL ef_bail_out(id, errstr)

      RETURN
      END

*
* curv_range.F
*
* Ansley Manke
* March 2005
*
* This function finds the indices of the bounding box for taking 
* a subset of a variable defined on a curvilinear grid.
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE curv_range_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      CHARACTER*120 descr

      WRITE (descr, 100)
      CALL ef_set_desc(id, descr )

  100 FORMAT (
     . 'find i,j bounds for subset of a variable in curvilinear ',
     . 'coordinates' )

      CALL ef_set_num_args(id, 7)
      CALL ef_set_axis_inheritance(id, ABSTRACT, 
     .     NORMAL, NORMAL, NORMAL)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'LONGITUDES')
      CALL ef_set_arg_desc(id, arg, 
     .             '2-D longitudes of curvilinear grid')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'LATITUDES')
      CALL ef_set_arg_desc(id, arg, 
     .             '2-D latitudes of curvilinear grid')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'xrange_lo')
      CALL ef_set_arg_desc(id, arg, 'Minimum of longitude range')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'xrange_hi')
      CALL ef_set_arg_desc(id, arg, 'Maximum of longitude range')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'yrange_lo')
      CALL ef_set_arg_desc(id, arg, 'Minimum of latitude range')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 6
      CALL ef_set_arg_name(id, arg, 'yrange_hi')
      CALL ef_set_arg_desc(id, arg, 'Maximum of latitude range')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 7
      CALL ef_set_arg_name(id, arg, 'modulo flag for X coordinates')
      CALL ef_set_arg_desc(id, arg, '1= X modulo; 0= X not modulo')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


      SUBROUTINE curv_range_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_axis_limits(id, X_AXIS, 1, 4)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE curv_range_compute(id, arg_1, arg_2, 
     .           arg_3, arg_4, arg_5, arg_6, arg_7, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id, arg

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, 
     .           mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, 
     .           mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, 
     .           mem4loz:mem4hiz, mem4lot:mem4hit)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, 
     .           mem5loz:mem5hiz, mem5lot:mem5hit)
      REAL arg_6(mem6lox:mem6hix, mem6loy:mem6hiy, 
     .           mem6loz:mem6hiz, mem6lot:mem6hit)
      REAL arg_7(mem7lox:mem7hix, mem7loy:mem7hiy, 
     .           mem7loz:mem7hiz, mem7lot:mem7hit)

      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l
      INTEGER ilo, ihi, jlo, jhi, nrep, irep
      REAL small, xrange_lo, xrange_hi, yrange_lo, yrange_hi, xx, xxp, 
     .     yy, yyp, big, xadd, xmin, xmax, xmin_field, xmax_field, 
     .     ymin_field, ymax_field, xmod, xdiff_lo, xdiff_hi, ydiff_lo, 
     .     ydiff_hi
      LOGICAL xmodulo, found_range
      CHARACTER*100 errmsg

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      arg = 3
      CALL ef_get_one_val(id, arg, xrange_lo)
      arg = 4
      CALL ef_get_one_val(id, arg, xrange_hi)
      arg = 5
      CALL ef_get_one_val(id, arg, yrange_lo)
      arg = 6
      CALL ef_get_one_val(id, arg, yrange_hi)
      arg = 7
      CALL ef_get_one_val(id, arg, xmod)
      xmodulo = (xmod .GT. 0.)

c curv_range_test
c* Set the values to some particular ones, to see if this is the function being executed.
c
c      j = res_lo_ss(Y_AXIS)
c      k = res_lo_ss(Z_AXIS)
c      l = res_lo_ss(T_AXIS)
c
c      result(1,j,k,l) = 11
c      result(2,j,k,l) = 22
c      result(3,j,k,l) = 33
c      result(4,j,k,l) = 44
c      RETURN

* See if the user asked for the whole range of arg_1 and arg_2 


      big = MAX (1.e34, ABS(bad_flag(ARG1)) )
      big = MAX (big, ABS(bad_flag(ARG2)) )
      xmin_field = big
      xmax_field = -1.* big
      ymin_field = big
      ymax_field = -1.* big
      DO 53 i = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)
      DO 52 j = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)
      DO 51 k = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)
      DO 50 l = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)
      
         xmin_field = MIN(xmin_field, arg_1(i,j,k,l))
         xmax_field = MAX(xmax_field, arg_1(i,j,k,l))
         ymin_field = MIN(ymin_field, arg_2(i,j,k,l))
         ymax_field = MAX(ymax_field, arg_2(i,j,k,l))

 50   CONTINUE
 51   CONTINUE
 52   CONTINUE
 53   CONTINUE

      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      l = res_lo_ss(T_AXIS)

! use the range of the data field to decide how much precision 
! to require for **requested range equals the data range**

      small = 0.01* (xmax_field - xmin_field)
      small = MIN(small, 0.01* (ymax_field - ymin_field) )

      IF (small .LE. 0) THEN  ! if x or y range is 0 use the other direction
         small = 0.01* (xmax_field - xmin_field)
         small = MAX(small, 0.01* (ymax_field - ymin_field) )
      ENDIF

      IF (small .LE. 0) small = 1.e-4

      xdiff_lo = ABS(xmin_field - xrange_lo) 
      xdiff_hi = ABS(xmax_field - xrange_hi) 
      ydiff_lo = ABS(ymin_field - yrange_lo) 
      ydiff_hi = ABS(ymax_field - yrange_hi) 

      IF (xdiff_lo .LT. small .AND. ydiff_lo .LT. small  .AND.
     .    xdiff_hi .LT. small .AND. ydiff_hi .LT. small) THEN 
         result(1,j,k,l) = arg_lo_ss(X_AXIS, ARG1)
         result(2,j,k,l) = arg_hi_ss(X_AXIS, ARG1)
         result(3,j,k,l) = arg_lo_ss(Y_AXIS, ARG2)
         result(4,j,k,l) = arg_hi_ss(Y_AXIS, ARG2)
         RETURN
      ENDIF

      IF (ydiff_lo .LT. small .AND. ydiff_hi .LT. small .AND. 
     .     xmodulo) THEN
         nrep = NINT((xrange_lo-xmin_field)/360.)
         xdiff_lo = ABS(xmin_field+360.*nrep - xrange_lo)
         nrep = NINT((xrange_hi-xmax_field)/360.)
         xdiff_hi = ABS(xmax_field+360.*nrep - xrange_hi)
         IF (xdiff_lo .LT. small .AND. xdiff_hi .LT. small ) THEN
            result(1,j,k,l) = arg_lo_ss(X_AXIS, ARG1)
            result(2,j,k,l) = arg_hi_ss(X_AXIS, ARG1)
            result(3,j,k,l) = arg_lo_ss(Y_AXIS, ARG2)
            result(4,j,k,l) = arg_hi_ss(Y_AXIS, ARG2)
            RETURN
         ENDIF
      ENDIF

* If the requested range is larger than the data, return whole range

      IF (.NOT. xmodulo) THEN  
         IF (xrange_lo.LT.xmin_field .AND. xrange_hi.GT.xmax_field .AND.
     .       yrange_lo.LT.ymin_field .AND. yrange_hi.GT.ymax_field)THEN
            result(1,j,k,l) = arg_lo_ss(X_AXIS, ARG1)
            result(2,j,k,l) = arg_hi_ss(X_AXIS, ARG1)
            result(3,j,k,l) = arg_lo_ss(Y_AXIS, ARG2)
            result(4,j,k,l) = arg_hi_ss(Y_AXIS, ARG2)
            RETURN
         ENDIF
      ELSE

* If x is to be treated as modulo, use the code below to determine the indices, but
* if the Y range is larger than the data, use the data min and/or max for y range.
         IF (yrange_lo .LT. ymin_field) yrange_lo = ymin_field
         IF (yrange_hi .GT. ymax_field) yrange_hi = ymax_field
      ENDIF



* Find range of I,J for which arg_1 is in xrange_lo, xrange_hi
* and arg_2 is in yrange_lo, yrange_hi

      ilo = arg_hi_ss(X_AXIS, ARG1)
      ihi = arg_lo_ss(X_AXIS, ARG1)
      jlo = arg_hi_ss(Y_AXIS, ARG2)
      jhi = arg_lo_ss(y_AXIS, ARG2)

      big = ABS(bad_flag(ARG1) )
      xmin = big
      xmax = -1.* big
      found_range = .FALSE.

      DO 400 i = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)
      DO 300 j = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)
      DO 200 k = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)
      DO 100 l = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)

         xx = arg_1(i,j,k,l)
         yy = arg_2(i,j,k,l)
         IF ( xx .EQ. bad_flag(1) ) GOTO 5500
         IF ( yy .EQ. bad_flag(2) ) GOTO 5500

         IF ( xx .GE. xrange_lo  .AND. xx .LE. xrange_hi .AND.
     .        yy .GE. yrange_lo  .AND. yy .LE. yrange_hi ) THEN
            found_range = .TRUE.
            ilo = MIN(i,ilo)
            ihi = MAX(i,ihi)
            jlo = MIN(j,jlo)
            jhi = MAX(j,jhi)
            xmin = MIN(xmin, xx)
            xmax = MAX(xmin, xx)
         ENDIF

 100  CONTINUE
 200  CONTINUE
 300  CONTINUE
 400  CONTINUE

* If no range found, is the range strictly between two adjacent points
* in either direction?

      IF (.NOT. found_range .AND. 
     .    xrange_lo.GE.xmin_field .AND. xrange_hi.LE.xmax_field .AND.
     .    yrange_lo.GE.ymin_field .AND. yrange_hi.LE.ymax_field ) THEN
     
         ilo = arg_hi_ss(X_AXIS, ARG1)
         ihi = arg_lo_ss(X_AXIS, ARG1)
         jlo = arg_hi_ss(Y_AXIS, ARG2)
         jhi = arg_lo_ss(y_AXIS, ARG2)

         DO 401 i = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)-1
         DO 301 j = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)-1
         DO 201 k = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)
         DO 101 l = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)

            xx = arg_1(i,j,k,l)
            xxp = arg_1(i+1,j,k,l)
            yy = arg_2(i,j,k,l)
            yyp = arg_2(i,j+1,k,l)

            IF ( xx .GE. xrange_lo  .AND. xx .LE. xrange_hi .AND.
     .           yrange_lo .GE. yy .AND. yrange_hi .LT. yyp) THEN
               found_range = .TRUE.
               ilo = min(i, ilo)
               ihi = MAX(i, ihi)
               jlo = min(j, jlo)
               jhi = MAX(j+1, jhi)
            ENDIF

            IF ( yy .GE. yrange_lo  .AND. yy .LE. yrange_hi .AND.
     .           xrange_lo .GE. xx .AND. xrange_hi .LT. xxp) THEN
               found_range = .TRUE.
               ilo = min(i, ilo)
               ihi = MAX(i+1, ihi)
               jlo = min(j, jlo)
               jhi = MAX(j, jhi)
            ENDIF

            IF ( xrange_lo .GE. xx .AND. xrange_hi .LT. xxp .AND.
     .           yrange_lo .GE. yy .AND. yrange_hi .LT. yyp) THEN
               found_range = .TRUE.
               ilo = min(i, ilo)
               ihi = MAX(i+1, ihi)
               jlo = min(j, jlo)
               jhi = MAX(j+1, jhi)
            ENDIF

 101     CONTINUE
 201     CONTINUE
 301     CONTINUE
 401     CONTINUE
      ENDIF

      IF (xmodulo) THEN
         IF (xmin .EQ. big) xmin = xmin_field
         IF (xmax .EQ. -1.*big) xmax = xmax_field
 
* Does the range found cover the requested xrange_lo,xrange_hi range?
* If not we will need some modulo repetitions.

         IF (xmin .GT. xrange_lo) THEN
            nrep = NINT((xmin-xrange_lo)/360)
            xadd = 0.
            DO 501 irep = 1, nrep
               xadd = xadd - 360.

* Previous loop found no overlap of x coordinates and desired output range.
* start over with xmax, xmin find whole range

               IF (xmin .GT. xrange_hi) THEN
                  xmin =  big 
                  xmax = -1. * big   
               ENDIF
     
               ilo = arg_hi_ss(X_AXIS, ARG1)
               ihi = arg_lo_ss(X_AXIS, ARG1)
               jlo = arg_hi_ss(Y_AXIS, ARG2)
               jhi = arg_lo_ss(y_AXIS, ARG2)

               DO 402 i = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)
               DO 302 j = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)
               DO 202 k = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)
               DO 102 l = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)

                  xx = arg_1(i,j,k,l) + xadd
                  yy = arg_2(i,j,k,l)

                  IF ( xx .GE. xrange_lo  .AND. xx .LE. xrange_hi  .AND.
     .                 yy .GE. yrange_lo  .AND. yy .GE. yrange_hi ) THEN
                     found_range = .TRUE.
                     ilo = MIN(i,ilo)
                     ihi = MAX(i,ihi) 
                     jlo = MIN(j,jlo)
                     jhi = MAX(j,jhi) 
                     xmin = MIN(xmin, xx)
                     xmax = MAX(xmin, xx)
                  ENDIF

 102           CONTINUE
 202           CONTINUE
 302           CONTINUE
 402           CONTINUE

               IF (.NOT. found_range) THEN
               
                  ilo = arg_hi_ss(X_AXIS, ARG1)
                  ihi = arg_lo_ss(X_AXIS, ARG1)
                  jlo = arg_hi_ss(Y_AXIS, ARG2)
                  jhi = arg_lo_ss(y_AXIS, ARG2)

                  DO 403 i = arg_lo_ss(X_AXIS,ARG1), 
     .               arg_hi_ss(X_AXIS,ARG1)-1
                  DO 303 j = arg_lo_ss(Y_AXIS,ARG1), 
     .               arg_hi_ss(Y_AXIS,ARG1)
                  DO 203 k = arg_lo_ss(Z_AXIS,ARG1), 
     .               arg_hi_ss(Z_AXIS,ARG1)
                  DO 103 l = arg_lo_ss(T_AXIS,ARG1), 
     .               arg_hi_ss(T_AXIS,ARG1)

                  xx = arg_1(i,j,k,l) + xadd
                  xxp = arg_1(i+1,j,k,l) + xadd
                  yy = arg_2(i,j,k,l)

                  IF ( xrange_lo .GE. xx .AND. xrange_hi .LT. xxp  .AND.
     .                 yy .GE. yrange_lo  .AND. yy .GE. yrange_hi ) THEN
                     found_range = .TRUE.
                     ilo = MIN(i,ilo)
                     ihi = MAX(i+1,ihi) 
                     jlo = MIN(j,jlo)
                     jhi = MAX(j,jhi) 
                     xmin = MIN(xmin, xx)
                     xmax = MAX(xmin, xxp)
                  ENDIF

 103              CONTINUE
 203              CONTINUE
 303              CONTINUE
 403              CONTINUE
               ENDIF

               IF (xmin .EQ. big) xmin = xmin_field + xadd
               IF (xmax .EQ. -1.*big) xmax = xmax_field + xadd

 501        CONTINUE

* If no range found, is the range strictly between two adjacent points
* in either direction?

            IF (.NOT. found_range .AND. 
     .     xrange_lo.GE.xmin_field .AND. xrange_hi.LE.xmax_field .AND.
     .     yrange_lo.GE.ymin_field .AND. yrange_hi.LE.ymax_field ) THEN
                       
               ilo = arg_hi_ss(X_AXIS, ARG1)
               ihi = arg_lo_ss(X_AXIS, ARG1)
               jlo = arg_hi_ss(Y_AXIS, ARG2)
               jhi = arg_lo_ss(y_AXIS, ARG2)

               DO 404 i =arg_lo_ss(X_AXIS,ARG1),arg_hi_ss(X_AXIS,ARG1)-1
               DO 304 j =arg_lo_ss(Y_AXIS,ARG1),arg_hi_ss(Y_AXIS,ARG1)-1
               DO 204 k =arg_lo_ss(Z_AXIS,ARG1),arg_hi_ss(Z_AXIS,ARG1)
               DO 104 l =arg_lo_ss(T_AXIS,ARG1),arg_hi_ss(T_AXIS,ARG1)

                  xx = arg_1(i,j,k,l)+xadd
                  xxp = arg_1(i+1,j,k,l)+xadd
                  yy = arg_2(i,j,k,l)
                  yyp = arg_2(i,j+1,k,l)
      
                  IF ( xx .GE. xrange_lo  .AND. xx .LE. xrange_hi .AND.
     .              yrange_lo .GE. yy .AND. yrange_hi .LT. yyp) THEN
                     found_range = .TRUE.
                     ilo = min(i, ilo)
                     ihi = MAX(i, ihi)
                     jlo = min(j, jlo)
                     jhi = MAX(j+1, jhi)
                  ENDIF

                  IF ( yy .GE. yrange_lo  .AND. yy .LE. yrange_hi .AND.
     .                 xrange_lo .GE. xx .AND. xrange_hi .LT. xxp) THEN
                     found_range = .TRUE.
                     ilo = min(i, ilo)
                     ihi = MAX(i+1, ihi)
                     jlo = min(j, jlo)
                     jhi = MAX(j, jhi)
                  ENDIF

                  IF ( xrange_lo .GE. xx .AND. xrange_hi .LT. xxp .AND.
     .                 yrange_lo .GE. yy .AND. yrange_hi .LT. yyp) THEN
                     found_range = .TRUE.
                     ilo = min(i, ilo)
                     ihi = MAX(i+1, ihi)
                     ilo = min(i, ilo)
                     ihi = MAX(i+1, ihi)
                  ENDIF

 104           CONTINUE
 204           CONTINUE
 304           CONTINUE
 404           CONTINUE
            ENDIF

         ENDIF
   
         IF (xmax .LT. xrange_hi) THEN
            nrep = NINT((xrange_hi-xmax)/360.)
            xadd = 0.
               DO 502 irep = 1, nrep
               xadd = xadd + 360.

* Previous loop found no overlap of x coordinates and desired output range.
* start over with xmax, xmin find whole range

               IF (xmax .LT. xrange_lo) THEN
                  xmin =  big 
                  xmax = -1. * big   
               ENDIF

               ilo = arg_hi_ss(X_AXIS, ARG1)
               ihi = arg_lo_ss(X_AXIS, ARG1)
               jlo = arg_hi_ss(Y_AXIS, ARG2)
               jhi = arg_lo_ss(y_AXIS, ARG2)

               DO 405 i = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)
               DO 305 j = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)
               DO 205 k = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)
               DO 105 l = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)

                  xx = arg_1(i,j,k,l) + xadd
                  yy = arg_2(i,j,k,l)

                  IF ( xx .GE. xrange_lo  .AND. xx .LE. xrange_hi  .AND.
     .                 yy .GE. yrange_lo  .AND. yy .GE. yrange_hi ) THEN
                     found_range = .TRUE.
                     ilo = MIN(i,ilo)
                     ihi = MAX(i,ihi) 
                     jlo = MIN(j,jlo)
                     jhi = MAX(j,jhi) 
                     xmin = MIN(xmin, xx)
                     xmax = MAX(xmin, xx)
                  ENDIF

 105           CONTINUE
 205           CONTINUE
 305           CONTINUE
 405           CONTINUE
 
               IF (.NOT. found_range) THEN
               
                  ilo = arg_hi_ss(X_AXIS, ARG1)
                  ihi = arg_lo_ss(X_AXIS, ARG1)
                  jlo = arg_hi_ss(Y_AXIS, ARG2)
                  jhi = arg_lo_ss(y_AXIS, ARG2)

                  DO 406 i = arg_lo_ss(X_AXIS,ARG1), 
     .               arg_hi_ss(X_AXIS,ARG1)-1
                  DO 306 j = arg_lo_ss(Y_AXIS,ARG1), 
     .               arg_hi_ss(Y_AXIS,ARG1)
                  DO 206 k = arg_lo_ss(Z_AXIS,ARG1), 
     .               arg_hi_ss(Z_AXIS,ARG1)
                  DO 106 l = arg_lo_ss(T_AXIS,ARG1), 
     .               arg_hi_ss(T_AXIS,ARG1)

                     xx = arg_1(i,j,k,l) + xadd
                     xxp = arg_1(i+1,j,k,l) + xadd
                     yy = arg_2(i,j,k,l)
                     yyp = arg_2(i,j+1,k,l)

                     IF ( xrange_lo.GE.xx .AND. xrange_hi.LT.xxp.AND.
     .                    yrange_lo.GE.yy .AND. yrange_hi.LT.yyp ) THEN
                        found_range = .TRUE.
                        ilo = MIN(i,ilo)
                        ihi = MAX(i+1,ihi) 
                        jlo = MIN(j,jlo)
                        jhi = MAX(j,jhi) 
                        xmin = MIN(xmin, xx)
                        xmax = MAX(xmin, xxp)
                     ENDIF

 106              CONTINUE
 206              CONTINUE
 306              CONTINUE
 406              CONTINUE
               ENDIF
 
               IF (xmin .EQ. big) xmin = xmin_field + xadd
               IF (xmax .EQ. -1.*big) xmax = xmax_field + xadd

 502        CONTINUE


* If no range found, is the range strictly between two adjacent points
* in either direction?

            IF (.NOT. found_range .AND.
     .    xrange_lo.GE.xmin_field .AND. xrange_hi.LE.xmax_field .AND.
     .    yrange_lo.GE.ymin_field .AND. yrange_hi.LE.ymax_field ) THEN
     
               ilo = arg_hi_ss(X_AXIS, ARG1)
               ihi = arg_lo_ss(X_AXIS, ARG1)
               jlo = arg_hi_ss(Y_AXIS, ARG2)
               jhi = arg_lo_ss(y_AXIS, ARG2)

               DO 407 i =arg_lo_ss(X_AXIS,ARG1),arg_hi_ss(X_AXIS,ARG1)-1
               DO 307 j =arg_lo_ss(Y_AXIS,ARG1),arg_hi_ss(Y_AXIS,ARG1)-1
               DO 207 k =arg_lo_ss(Z_AXIS,ARG1),arg_hi_ss(Z_AXIS,ARG1)
               DO 107 l =arg_lo_ss(T_AXIS,ARG1),arg_hi_ss(T_AXIS,ARG1)

                  xx = arg_1(i,j,k,l)+xadd
                  xxp = arg_1(i+1,j,k,l)+xadd
                  yy = arg_2(i,j,k,l)
                  yyp = arg_2(i,j+1,k,l)
      
                  IF ( xx .GE. xrange_lo  .AND. xx .LE. xrange_hi .AND.
     .              yrange_lo .GE. yy .AND. yrange_hi .LT. yyp) THEN
                     found_range = .TRUE.
                     ilo = min(i, ilo)
                     ihi = MAX(i, ihi)
                     jlo = min(j, jlo)
                     jhi = MAX(j+1, jhi)
                  ENDIF

                  IF ( yy .GE. yrange_lo  .AND. yy .LE. yrange_hi .AND.
     .                 xrange_lo .GE. xx .AND. xrange_hi .LT. xxp) THEN
                     found_range = .TRUE.
                     ilo = min(i, ilo)
                     ihi = MAX(i+1, ihi)
                     jlo = min(j, jlo)
                     jhi = MAX(j, jhi)
                  ENDIF

                  IF ( xrange_lo .GE. xx .AND. xrange_hi .LT. xxp .AND.
     .                 yrange_lo .GE. yy .AND. yrange_hi .LT. yyp) THEN
                     found_range = .TRUE.
                     ilo = min(i, ilo)
                     ihi = MAX(i+1, ihi)
                     ilo = min(i, ilo)
                     ihi = MAX(i+1, ihi)
                  ENDIF

 107           CONTINUE
 207           CONTINUE
 307           CONTINUE
 407           CONTINUE
            ENDIF


         ENDIF

      ENDIF  ! xmodulo


* Return two cells out from the computed result, one to be sure we cover
* the entire requested range (the coords may be cell centers or bounds, and
* a second because the mapping in curv_to_rect uses neighbors around each
* location to compute the result.

      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      l = res_lo_ss(T_AXIS)

      DO 600 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
         result(i,j,k,l) = bad_flag_result
 600  CONTINUE

      IF (found_range) THEN
         result(1,j,k,l) = MAX(ilo-2, arg_lo_ss(X_AXIS, ARG1) )
         result(2,j,k,l) = MIN(ihi+2, arg_hi_ss(X_AXIS, ARG1) )
      ENDIF

      IF (found_range) THEN
         result(3,j,k,l) = MAX(jlo-2, arg_lo_ss(Y_AXIS, ARG2) )
         result(4,j,k,l) = MIN(jhi+2, arg_hi_ss(Y_AXIS, ARG2) )
      ENDIF

      RETURN 

 5500 WRITE (errmsg, 1000) 'X', i, j
 1000 FORMAT (A1, 
     . ' coordinates missing where valid value needed, at I,J=', 2i5)

      CALL EF_BAIL_OUT(id, errmsg)

 5600 WRITE (errmsg, 1000) 'Y', i, j
      CALL EF_BAIL_OUT(id, errmsg)


      RETURN
      END

	SUBROUTINE IS_AGGREGATE_GRID(uvar, dset, cx, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* examine members of an aggregate datset, getting grids for 
* elements that are user-defined (LET/D) variables. Use the 
* interpretation stack in order to determine a defining grid for the
* overall aggregate dataset.
* Detailed description of the underlying logic is in MERGE_CONTEXT
* Note: When pseudo-variables are used (eg. LIST U/Z[K=1:3]) the grids for them
*	may not be known until all other components are examined.  In this
*	case a 2nd pass is required

* programmer - Ansley Mankek (from is_uvar_grid)
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* V6.83 *acm* 11/30/2012 If variable isn't a file variable, get the right definition.

* V685  4/13 *acm* Better grid handling.
* V685 10/13 *acm* Fix ticket 1098, error defining ensemble when LET/D variables are present.

* calling argument declarations:
* uvar and dset point to the variable in the aggregate dataset
* And cx_orig points to the context for that variable.

	INTEGER	uvar, dset, cx, status

* internal variable declarations:
	LOGICAL its_dynamic
	INTEGER NCF_GET_AGG_COUNT, TM_LENSTR1, STR_SAME, KNOWN_GRID,
     .		cx_orig, agg_cx, hi_cx, big_cx, isp_orig, agg_dset, 
     .		agg_len, imemb, fer_uvar, memb_dset, memb_grid, iline, 
     .		nv, test_grid, this_grid, len_name, agg_dim, gnum, var,
     .		varid, idim, i, igrid, lo_cx, slen

	CHARACTER vname*512, buff*512, nm*3

#include "netcdf.inc"
	include	'tmap_errors.parm'
	include 'tmap_dims.parm'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'
	include	'xfr_grid.cmn'
	include	'xdset_parms.cmn'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xdset_info.cd_equiv'

*        ... interpretation stack setup at the time this is called ...
*	stack level		stack contents
*	isp+1	<--	level to get grids for components
*	 isp	<--	current level: evaluate user-variable grid

* --- end of introductory code ---

* initialize

	agg_dim = e_dim
	test_grid = unspecified_int4

	agg_dset = dset
	status = NCF_GET_AGG_COUNT (agg_dset, agg_len)

	agg_cx = cx

	vname = uvar_text(uvar)
	len_name = TM_LENSTR1(vname)

* are we pointing at a "LET var = [some expr with an agg var]"
* If so then the vname is not in the agg dset. Find the 
* var in the list of uvar_code, and get the right uvar_text
* (this is a hack, something is wrong with my stack handling)

	CALL CD_GET_VAR_ID (agg_dset, vname, varid, status)
	IF (status .NE. ferr_ok) THEN 
	   DO 30, i = uvar, 1, -1
 	      IF (STR_SAME(vname, uvar_name_code(i)) .EQ. 0) THEN
	         vname =  uvar_text(i)
	         len_name = TM_LENSTR1(vname)
	         CALL CD_GET_VAR_ID (agg_dset, vname, varid, status)
	         IF (status .NE. ferr_ok) GOTO 5010 
	         GOTO 40
               ENDIF
   30	   CONTINUE
	   GOTO 5010 
   40	   CONTINUE
	ENDIF

	DO 90 imemb = 1, agg_len

* See if the previous two members have matching grids (except for ensemble direction)
	   IF (test_grid.NE.unspecified_int4 .AND. test_grid.NE.this_grid) THEN
	      DO 80 idim = 1, nferdims
	         IF ( (idim .NE. agg_dim) .AND. 
     .	              (grid_line(idim,this_grid) .NE. grid_line(idim,test_grid)) ) GOTO 5300

   80	      CONTINUE
	   ENDIF

	   CALL CD_GET_AGG_VAR_INFO (agg_dset, vname, imemb, 
     .         fer_uvar, memb_dset, memb_grid, iline, nv, status)
	   IF (fer_uvar .EQ. cat_user_var .AND. memb_grid .EQ. unspecified_int4) 
     .           memb_grid = KNOWN_GRID(memb_dset, cat_user_var, nv) 
	   IF (memb_grid .NE. unspecified_int4) THEN
	      test_grid = memb_grid
	      this_grid = memb_grid
	      GOTO 90
	   ENDIF

* Get ready to call is_uvar_grid. 
* pre-load the variable info onto the CX stack

	   cx_orig = cx_stack_ptr
	   CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   lo_cx  = is_cx( isp )
	   hi_cx = cx_stack_ptr
	   CALL GET_VAR_CONTEXT (  vname(:len_name),
     .				lo_cx,
     .				hi_cx,
     .				status )

	   cx_data_set(hi_cx) = memb_dset
	   cx_grid(hi_cx) = memb_grid
	   cx_variable(hi_cx) = nv
	   cx_category(hi_cx) = cat_user_var

* pre-load the variable info onto the IS stack
	   isp_orig = isp
	   CALL PUSH_INTERP_STACK( isp, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   is_cx   ( isp ) = hi_cx
	   is_uvar ( isp ) = nv
	   is_act  ( isp ) = isact_get_grid

* initialize the stacks - (repeated for each component)

 100	   CALL IS_GRID_MODE( status )
           hi_cx = is_big_cx(isp) + 1  ! ???
	   IF ( status .NE. ferr_ok ) GOTO 5000

* evaluate the grid by merging component grids
*  ... exit 100 is to evaluate the grid for a component uvar
*  ... exit 300 means that a grid has been obtained
*  ... "normal" return indicates an error has occurred
 200	   CALL IS_UVAR_GRID( *100, *300, status )
	   GOTO 5000

* a grid has been obtained.  Are we done ?
 300	   IF ( isp .EQ. isp_orig ) THEN
* ... yes - clean up and go home
              this_grid = cx_grid(hi_cx) 
	      IF ( cx_stack_ptr .NE. cx_orig ) WRITE (6,*) 'agg_v_gd'	! temp
	      GOTO 90
	   ELSE
* ... no - go back for more
	      GOTO 200
	   ENDIF

 90	CONTINUE

* Test that the grids match for the last aggregate member (except for ensemble direction)

	IF (test_grid.NE.unspecified_int4 .AND. test_grid.NE.this_grid) THEN
	   DO 180 idim = 1, nferdims
	      IF ( (idim .NE. agg_dim) .AND. 
     .	           (grid_line(idim,this_grid) .NE. grid_line(idim,test_grid)) ) GOTO 5300
 180	CONTINUE
	ENDIF

* Define the aggregrate grid here. Need a new context?  Should this be done when
* we get back to is_uvar_grid?

	big_cx = is_big_cx( isp )
	
	igrid = cx_grid(big_cx)
	DO 400 idim = 1, nferdims
	   grid_line(idim, igrid) = grid_line(idim,test_grid)
  400	CONTINUE
	grid_line(agg_dim, igrid) = iline

* catalog this result checking for matching previously existing grid
	CALL TM_GET_LIKE_DYN_GRID(igrid, its_dynamic, gnum, 
     .				grd_stk_ptr, status ) 

* set context for aggregate grid
	cx_grid(agg_cx) = gnum
	uvar_grid( uvar, dset ) = gnum 

	cx_grid(agg_cx) = gnum
	cx_data_set(agg_cx) = agg_dset
	cx_category(agg_cx) = cat_aggregate_var

	uvar_grid( uvar, dset ) = gnum 
	uvar_dset( uvar ) = dset
	uvar_need_dset( uvar ) = .TRUE.

	var = cx_variable(agg_cx)
	ds_grid_number(var) = gnum 

* Get ds_grid_start, ds_grid_end, ds_ordering from the last file variable

	IF (test_grid .NE. unspecified_int4) THEN
	   DO 720 nv = 1, maxvars
	       IF (ds_grid_number(nv) .EQ. test_grid)  GOTO 725
 720	   CONTINUE
 725	   CONTINUE
        ENDIF

	IF (nv .GT. maxvars) GOTO 5010

        DO 730 idim = 1, nferdims
	   ds_grid_start(idim,var)= ds_grid_start(idim,nv)
	   ds_grid_end(idim,var)  = ds_grid_end(idim,nv)
	   ds_ordering(idim,var)  = ds_ordering(idim,nv)
 730	CONTINUE
        ds_ordering(agg_dim,var) = agg_dim
        ds_grid_start(agg_dim,var) = 1
        ds_grid_end(agg_dim,var) = line_dim(iline)

	is_cx(isp) = agg_cx
	is_uvar ( isp ) = uvar

* Now we have the grid for the variable in the agg. dataset. Store the grid 
* number for future use.

CC dont think this is right. should be the MEMBER grids not the aggregate var grid.
	DO 800 imemb = 1, agg_len
	   CALL CD_PUT_AGG_MEMB_GRID (agg_dset, vname, imemb, gnum, status)
 800	CONTINUE

	RETURN

* error exit
 5000	CALL DEALLO_ALL_GRIDS
	RETURN
 5300	CALL ERRMSG( ferr_aggregate_error, status,
     .   'grids for LET/D variables do not match for aggregate dataset'
     .   //vname,*5000 )
 5010	vname = uvar_text(uvar)
	CALL ERRMSG( ferr_aggregate_error, status,
     .   'error defining grid for variable in aggregate dataset'
     .   //vname,*5000 )

	END	

	SUBROUTINE CLEAR_VP

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* clear full window or single viewport of it depending on plot state variables
* (this routine to hide FERRET common from PPLUS)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 -  1/20/89
* V200:  3/22/90 - check if WSID NE 0 before clearing wkstn (for CANC WIND/ALL)
* V411:  9/5/95 - use CLEAR_WINDOW to clear the full screen
*	(to avoid the XGKS memory leak from GCLRWK)
*        9/9/97 - if batch is active, just clear workstation since XGKS
*        doesn't delete metafile segments, and it avoids gdelseg warnings
*        1.30.99 *js* Eliminated change of 9/9/97, since it caused memory
*          leak and we don't seem to get warnings anymore.
* V602:  1/2007 *acm* When writing metafiles in batch mode, we do want to
*        skip the call to GDSG. The segments are in fact deleted by gclosews 
*        (gclwk called in pltit when closing one plot and opening a new one)
*        and that results in the error message when gdsg is called here.
* V68   *acm* 4/11 change how flag meta_batch is computed (different Makefile)

	include 'xplot_state.cmn'		! viewport info
	include 'gkscm1_inc.decl'	! with wsid
	include 'GKSCM1.INC'	! with wsid

* internal variable declarations:
	INTEGER	ivp, iseg
	LOGICAL ITS_BATCH_GRAPHICS, ITS_META_GRAPHICS,
     .   its_meta, batch, meta_batch

        its_meta = ITS_META_GRAPHICS()
        batch = ITS_BATCH_GRAPHICS()
	meta_batch = .FALSE.
        IF (batch) THEN
           IF (its_meta) meta_batch = .TRUE.
        ENDIF
	IF ( vp_num .EQ. mvp_dflt ) THEN

*  clear entire screen
	   IF ( wsid .NE. 0 ) THEN
* explicitly delete segments to avoid XGKS memory leak
	      DO 110 ivp =  mvp_dflt, max_viewport
		 if (.NOT.meta_batch .AND. vp_seg0(ivp) .NE. 0 ) THEN 
	            DO 100 iseg = vp_seg0(ivp)+1 , vp_segn(ivp)
 100	            CALL GDSG( iseg ) 
	         ENDIF
*  and mark segment as deleted
	         vp_seg0(ivp) = 0
	         vp_segn(ivp) = 0
 110	      CONTINUE

	      CALL GCLRWK(WSID,0)
	   ENDIF

	ELSE

* clear viewport only - delete segments
	   DO 200 iseg = vp_seg0(vp_num)+1 , vp_segn(vp_num)
 200	   CALL GDSG( iseg ) 
* immediate update of screen to reflect deleted segments
	   CALL GUWK( wsid, 1 )
	ENDIF

	vp_seg0( vp_num ) = curr_seg_name

	RETURN
	END

      subroutine free_time
c
c  this routine calls atc_update every fourth time to refresh a GKS graphics
c  window.
c
c  kob 5/92
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* 4/94 *sh* change "atc_update" to "PROCESS_X_EVENTS" to accomodate
*	Solaris/XGKS update needs (failure to redraw window)
*
* IBM PORT 14apr94 *kob* : IBM wouldn't allow c-like logical statment
*		 	  had to use ".NEQV" instead.
* IBM PORT 2jun94 *kob*  : Above change incorrect.  A mistake was made, the
*			   comparison should be done with .NE.		
      integer count
!      static count
      save count
      data count /0/


      if (mod(count+1,8) .NE. 0) then
         count = count +1
      else
c  call atc_update to refresh screen
!         call atc_update            ! 4/94
         call PROCESS_X_EVENTS       ! 4/94   
         count = 0
      endif

      return 

      end

	program drwmarks
	character val*3
	character text*30
	data text/'Plot Marks'/
	call rotate(-90.0)
	call pltype(0)
	call size(10.5,8.2)
	call scale(1.,1.,1.,0.,0.,-8.2)
	sze=.21
	call markh(sze)
c	call erase
	call opndev(.true.,.true.)
	im=0
	x=1.8+2*1.4-symwid(sze,10,text)*0.5
	call symbel(x,8.0,0.0,sze,10,text)
	do 10 j=1,5
	do 20 i=1,18
	x=1.8+(j-1)*1.4
	y=7.5-i*0.4
	write(val,999)im
999	format(i2,'=')
	s=x-symwid(sze,3,val)
	call symbel(s,y,0.0,sze,3,val)
	call plot(x+0.25,y+sze*0.5,0,0)
	call mark(im)
	im=im+1
	if(im.gt.88)goto 100
20	continue
10	continue
100	call clsdev(.true.,.true.)
c	call pltend
	call exit
	end

	INTEGER FUNCTION GCF_PARENT_CHAR( child_uvar, start )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Given the starting character number of this uvar within it immediate parent
* return the starting character number of this uvar within its ancestor

*    Note that the ancestor may be a grand-parent or great-grand
*    For example, in the expression
*        A = FCN1(v1+v2) + B
*    where FCN1 is a grid changing function then "FCN1(v1+v2)" will be a
*    child of "A" and "v1+v2" will be a grand-child. The routine INIT_UVAR
*    will have designated "A" as the parent of "v1+v2". The purpose of
*    this routine would be to return the uvar of "A" when given the child_uvar
*    whose definition is "v1+v2"

* V510: *sh* 1/00
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

* calling argument declarations
	INTEGER		start, child_uvar

* internal variable declarations
	INTEGER   uvar, c, offset

	include	'tmap_dims.parm'
	include 'ferret.parm'
	include 'xvariables.cmn'

* initialize
	uvar = child_uvar
	c = start

	IF (uvar_parent(uvar) .NE. 0) THEN
	   
* compute the character address of this function within its parent
	   READ (uvar_name_code(uvar)(3:5),'(I3)',ERR=5000) offset
	   c = c + offset - 1

	ENDIF

* end of the lineage -- this parent has no parent
	GCF_PARENT_CHAR = c
	RETURN

* funky error exit
 5000	 GCF_PARENT_CHAR = 0	! will generate an error downstream

	   RETURN

	END

	SUBROUTINE TM_CHOOSE_READ ( dset_num, varpos,
     .		a_lo_x, a_lo_y, a_lo_z, a_lo_t, a_lo_e, a_lo_f,
     .		a_hi_x, a_hi_y, a_hi_z, a_hi_t, a_hi_e, a_hi_f,
     .		use_lo, use_hi, stride,
     .		data_grid, file_num, status )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Reads a N-D block of data (3D, 2D being degenerate cases w/ 1 dimension being
* 1 time series) from TMAP data sets.
*
* written 10/02/88 by M. Verschell for PMEL/TMAP
*                     
* revision 0.00 - 10/02/88 - initial incarnation
* revision 0.10 - 11/01/88 - name change from TM_READ, passed var position in
*			     common rather than variable name.
* revision 0.20 - 12/06/89 - changed arrays for dimensions to single variables
*   3/92 - added CDF file reads using CD_READ (calling arg list chgd 10/92)
*   3/93 - treat ECDF (EPIC) like CDF
* V500 5/99 *sh* - added strides to CD_READ call
* 4/03 *acm* - Use STR_SAME to compare strings
*       *acm* 3/12 removing use of old GT and TS data formats

* include files
        include 'tmap_dims.parm'                ! data set dimension
        include 'tmap_errors.parm'              ! err code parm defs
#include "gt_lib.parm"
        include 'xtm_grid.cmn_text'             ! grid info
        external xgt_grid_data
        include 'xdset_info.cmn_text'   ! data set info common
        external xdset_info_data
        include 'xdset_info.cd_equiv'


* arguments:
*	dset_num    - internal data set # (from TM_INIT_DSET)
*	varpos      - position in common of variable information
* 	actual_dims - "a_" full dimensions of data_grid array passed
*	use_dims    - indices of model data block desired
*	data_grid   - array containing model data (output)
*	file_num    - file number (output)
*	status      - error status upon completion (output)
*
	INTEGER		dset_num, varpos, file_num, status,
     .			a_lo_x, a_lo_y, a_lo_z, a_lo_t, a_lo_e, a_lo_f,
     .			a_hi_x, a_hi_y, a_hi_z, a_hi_t, a_hi_e, a_hi_f,
     .			use_lo(nferdims), use_hi(nferdims), stride(nferdims)
        REAL            data_grid(a_lo_x:a_hi_x,
     .                            a_lo_y:a_hi_y,
     .                            a_lo_z:a_hi_z,
     .                            a_lo_t:a_hi_t,
     .                            a_lo_e:a_hi_e,
     .                            a_lo_f:a_hi_f)
*
* local definitions
	INTEGER*4	STR_SAME, lcnt, lline, ivar, tcnt, pcnt
	INTEGER*4	tmp_lo(nferdims), tmp_hi(nferdims)
	REAL*8		tstep, TM_WORLD

        is_mc = .FALSE.

* Is it a MC data set?
  	IF (STR_SAME(ds_type(dset_num), '  MC') .EQ. 0) THEN
            is_mc = .TRUE.
	    CALL MC_READ  ( dset_num, varpos,
     .			a_lo_x, a_lo_y, a_lo_z, a_lo_t, a_lo_e, a_lo_f,
     .			a_hi_x, a_hi_y, a_hi_z, a_hi_t, a_hi_e, a_hi_f,
     .			use_lo, use_hi, stride,
     .			data_grid, file_num, status )
	    IF (status .NE. merr_ok) GOTO 9999
	ELSEIF (STR_SAME(ds_type(dset_num), 'CDF') .EQ. 0
     .    .OR.  STR_SAME(ds_type(dset_num), 'ECDF') .EQ. 0) THEN
* It's a CDF or an EPIC CDF data set
          CALL CD_READ( dset_num, varpos,
     .			a_lo_x, a_lo_y, a_lo_z, a_lo_t, a_lo_e, a_lo_f,
     .			a_hi_x, a_hi_y, a_hi_z, a_hi_t, a_hi_e, a_hi_f,
     .                  use_lo, use_hi, stride,
     .                  data_grid, cd_stepfile(dset_num),status)
	  IF (status .NE. merr_ok) GOTO 9999
        ELSE

          CALL TM_ERRMSG(merr_notsupport, status, 'TM_CHOOSE_READ',
     .                  dset_num, no_stepfile,
     .                  'Unknown data set type: '//ds_type(dset_num),
     .                  no_errstring, *9999)
	ENDIF
	status = merr_ok

 9999	RETURN
	END

*           rr_flux_uy.F
*
*           Rick Romea
*           Jan. 24, 2000
*
*     Computes the zonal nonlinear advective flux term:  -dvu/dy
*     Units :     cm/s/s
*     MOM2 Grid:  U   
*
*******************************************************************

      SUBROUTINE RR_flux_uy_init(id)
	IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

      CALL ef_set_desc             (id,
     .'-d(vu)/dy advective momentum: flux-form (cm/s^2);MOM2 U Grid')
      CALL ef_set_num_args         (id, 3)
      CALL ef_set_axis_inheritance (id, IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok     (id, NO, NO, YES, YES)

      ! Define first argument (U)

      CALL ef_set_arg_name         (id, ARG1, 'U')
      CALL ef_set_arg_desc         (id, ARG1,
     . 'Zonal velocity, on the MOM2 U Grid. ')
      CALL ef_set_arg_unit         (id, ARG1, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG1, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG1, YES, YES, YES, YES)
      CALL ef_set_axis_extend      (id, ARG1, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG1, Y_AXIS,-1,+1)

      ! Define second argument (V)

      CALL ef_set_arg_name         (id, ARG2, 'V')
      CALL ef_set_arg_desc         (id, ARG2,
     . 'Meridional velocity, on the MOM2 U Grid. ')
      CALL ef_set_arg_unit         (id, ARG2, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG2, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2,YES,YES,YES,YES)
      CALL ef_set_axis_extend      (id, ARG2, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG2, Y_AXIS,-1,+1)

      ! Define third argument (TEMP)

      CALL ef_set_arg_name         (id, ARG3, 'TEMP')
      CALL ef_set_arg_desc         (id, ARG3,
     . 'Potential temperature, required to access MOM2 T Grid. ')
      CALL ef_set_arg_unit         (id, ARG3, 'deg-C')
      CALL ef_set_arg_type         (id, ARG3, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG3, NO, NO,YES,YES)
      CALL ef_set_axis_extend      (id, ARG3, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG3, Y_AXIS,-1,+1)

      END


      SUBROUTINE RR_flux_uy_compute(id, arg_1, arg_2, arg_3, result)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'
      INTEGER        id
      REAL           bad_flag(EF_MAX_ARGS)
      REAL           bad_flag_result
      REAL           arg_1 (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .                      mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL           arg_2 (mem2lox:mem2hix, mem2loy:mem2hiy, 
     .                      mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL           arg_3 (mem3lox:mem3hix, mem3loy:mem3hiy, 
     .                      mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL           result (memreslox:memreshix,memresloy:memreshiy,
     .                       memresloz:memreshiz,memreslot:memreshit)
      INTEGER        res_lo_ss (4)
      INTEGER        res_hi_ss (4)
      INTEGER        res_incr  (4)

      INTEGER        arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER        arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER        arg_incr  (4,EF_MAX_ARGS)

      INTEGER i,j,k,l,i1,j1,k1,l1,i2,j2,k2,l2
      REAL*8 yU(1024),xU(1024),yT(1024),xT(1024)
      INTEGER ilat,ilon
      REAL dxt, dyt, dxu, dyu, dus, dun, duw, due
      REAL adv_vnt, adv_vnu, adv_fn, csu
      INCLUDE 'rr_parameters.h'

      dxt(i) = SNGL (xU(i)   - xU(i-1)) * Longitude_to_cm
      dyt(j) = SNGL (yU(j)   - yU(j-1)) * Latitude_to_cm
      dxu(i) = SNGL (xT(i+1) - xT(i))   * Longitude_to_cm
      dyu(j) = SNGL (yT(j+1) - yT(j))   * Latitude_to_cm
      dus(j) = SNGL (yU(j)   - yT(j))   * Latitude_to_cm
      dun(j) = SNGL (yT(j+1) - yU(j))   * Latitude_to_cm
      duw(i) = SNGL (xU(i)   - xT(i))   * Longitude_to_cm
      due(i) = SNGL (xT(i+1) - xU(i))   * Longitude_to_cm

      adv_vnt(i,j,k,l,iLon) = (arg_2(i,j,k,l)*dxu(iLon) + 
     .        arg_2(i-1,j,k,l)*dxu(iLon-1)) /2./ dxt(iLon)
      adv_vnu(i,j,k,l,iLat,iLon) =
     . ((adv_vnt(i,  j,  k,l,iLon) * duw(iLon)
     . + adv_vnt(i+1,j,  k,l,iLon) * due(iLon))*dus(iLat+1)     
     . +(adv_vnt(i,  j+1,k,l,iLon) * duw(iLon)
     . + adv_vnt(i+1,j+1,k,l,iLon) * due(iLon))*dun(iLat))
     .                     / dyt(iLat+1) / dxu(iLon)
      adv_fn (i1,j1,k1,l1,i2,j2,k2,l2,iLat,iLon) = 
     .                	adv_vnu(i2,j2,k2,l2,iLat,iLon)
     .                  *(arg_1(i1,j1,k1,l1) + arg_1(i1,j1+1,k1,l1))

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags      (id, bad_flag,  bad_flag_result)
      CALL ef_get_coordinates    (id, ARG1, X_AXIS, 
     .                            arg_lo_ss(X_AXIS,ARG1),
     .                            arg_hi_ss(X_AXIS,ARG1), xU)
      CALL ef_get_coordinates    (id, ARG1, Y_AXIS, 
     .                            arg_lo_ss(Y_AXIS,ARG1),
     .                            arg_hi_ss(Y_AXIS,ARG1), yU)
      CALL ef_get_coordinates    (id, ARG3, X_AXIS, 
     .                            arg_lo_ss(X_AXIS,ARG3),
     .                            arg_hi_ss(X_AXIS,ARG3), xT)
      CALL ef_get_coordinates    (id, ARG3, Y_AXIS, 
     .                            arg_lo_ss(Y_AXIS,ARG3),
     .                            arg_hi_ss(Y_AXIS,ARG3), yT)
      l1 = arg_lo_ss(T_AXIS,ARG1) 
      l2 = arg_lo_ss(T_AXIS,ARG2) 
      DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         k1 = arg_lo_ss(Z_AXIS,ARG1)
         k2 = arg_lo_ss(Z_AXIS,ARG2)
         DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
            ilat = 2  
            csu = cos(SNGL(yU(iLat))*Degrees_to_radians) 
            j1 = arg_lo_ss(Y_AXIS,ARG1) + 1
            j2 = arg_lo_ss(Y_AXIS,ARG2) + 1
            DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
               iLon = 2
               i1 = arg_lo_ss(X_AXIS,ARG1) + 1
               i2 = arg_lo_ss(X_AXIS,ARG2) + 1
               DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
                  IF (arg_1(i1,  j1,  k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1+1,j1,  k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1-1,j1,  k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1,  j1+1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1+1,j1+1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1-1,j1+1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1,  j1-1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1+1,j1-1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1-1,j1-1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_2(i2,  j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2,  j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2,  j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2-1,k2,l2) .EQ. bad_flag(ARG2)
     .                  )THEN
                          result(i,j,k,l) = bad_flag_result
                  ELSE
                     result(i,j,k,l) =
     .             - (adv_fn(i1,j1,  k1,l1,i2,  j2,k2,l2,iLat,  iLon)- 
     .                adv_fn(i1,j1-1,k1,l1,i2,j2-1,k2,l2,iLat-1,iLon)) 
     .                     /2./dyu(iLat)/csu*sec_per_month
                  ENDIF
                  iLon = iLon + 1
                  i1 = i1 + arg_incr(X_AXIS,ARG1)
                  i2 = i2 + arg_incr(X_AXIS,ARG2)
               ENDDO
               iLat = iLat + 1
               j1 = j1 + arg_incr(Y_AXIS,ARG1)
               j2 = j2 + arg_incr(Y_AXIS,ARG2)
            ENDDO               
            k1 = k1 + arg_incr(Z_AXIS,ARG1)
            k2 = k2 + arg_incr(Z_AXIS,ARG2)
         ENDDO
         l1 = l1 + arg_incr(T_AXIS,ARG1)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
      ENDDO
      END

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*DECK MESH
      SUBROUTINE MESH (DX,DY)
      INTEGER  IM, JM, NX, NY
      PARAMETER (IM=160,JM=100,NX= 1,NY=3)
	INTEGER l, m, n
      REAL DX(IM),DY(JM)
      REAL XMAX(NX),XMIN(NX),XWID(NX)
      REAL YMAX(NY),YMIN(NY),YWID(NY)
	INTEGER	ID(NX), JD(NY)
      DATA XMAX/1.0/
      DATA XMIN/1.0/
      DATA XWID/160.0/
      DATA YMAX/2.3333334,.3333334,2.8666667/
      DATA YMIN/3*.3333334/
      DATA YWID/20.,20.,40./
      DATA ID/1/
      DATA JD/-1,2*1/
      M=1
      DO 5 L=1,NX
      CALL CMESH (DX(M),XMAX(L),XMIN(L),XWID(L),N,ID(L))
      M=M+N
    5 CONTINUE
      M=1
      DO 8 L=1,NY
      CALL CMESH (DY(M),YMAX(L),YMIN(L),YWID(L),N,JD(L))
      M=M+N
    8 CONTINUE
      RETURN
      END

	BLOCK DATA XUNITS_DATA

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* unit names and conversion factors

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.00 - 04/15/88
* revision 0.01 - 11/21/88 - variable initialization changed to char_initXX
* revision 0.02 - 01/12/90 - added mb (kludge - not really convertible) *sh*
* revision 0.03 - 07/23/92 - added "layer" and "level" (unconvertible units)
*             (to eliminate error msg for these commonly used units)
* revision 0.04 - 12/19/94 - made mb non-convertible (1.0 instead of 0.01)
*			     and added unconvertible decibars
* 9/26/95 - interchanged the values (order) of pun_meters and pun_millibars
*		because TM_UNIT_ID was incorrectly interpreting "mbar"
* *kob* 10/96   - Linux port.  Linux didn't like tabs between "include"
*                 and what was being included.  removed them
* V5 *kob* 3/99 - add gregorian_ye[ar], year360, year366 units and also added
*              year365 as an alternate unit to the common year.
*    *sh* 7/99 - add alias "dbar" and change "month" definition to 1/12
*		 of 365.2425 day year 
*    *kob* 11/99 - add alternate unit "year" which is equal to a 
*                  gregorian_year
* *sh* 12/99 - add "degree" as an alternate name since exact match is now
*	required on names
* V510: 3/00 *sh* - added "minute" and "month"
* V520: 6/00 *sh* bug fix: exact matching in TM_UNIT_ID broke "seconds" match
*		         - add "hr" as an abbreviation for hours
*       1 day later: ops -- "hour" should be the standard, not "hr"
* V530: 2/01 *acm* add units for alternative calendars, secs per various
*		   years and 1/12 of those for "month"
* V532: 5/01 *sh* - added "metre"
* V554: 2/04 *acm*  default year length is 365.2425 days
* V570 *acm* 5/04  Add the calendar ALL_LEAP = 366_DAY, and units for the corresp. month.

* local variable declarations
!	INTEGER	i

	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'xunits.cmn_text'


	DATA	un_name   ( 0)	/ ' '	/,	! FOR UNIDENTIFIED UNITS
     .		un_convert( 0)	/ 1.0 /

	DATA	un_name( 1)	/ 'cm'		/,
     .		un_name( 2)	/ 'km'		/,
     .		un_name(pun_meters)	/ 'm'		/,
     .		un_name(pun_degrees)	/ 'deg'		/,
     .		un_name( 5)	/ 'ft'		/,
     .		un_name( 6)	/ 'in'		/,
     .		un_name( 7)	/ 'mile'	/,
     .		un_name( 8)	/ 'mm'		/,
     .		un_name(pun_millibars)	/ 'mb'		/,
     .		un_name(pun_decibars)	/ 'dbar'	/,
     .		un_name(11)	/ char_init12	/,
     .		un_name(12)	/ char_init12	/,
     .		un_name(13)	/ char_init12	/,
     .		un_name(14)	/ 'level' 	/,
     .		un_name(15)	/ 'layer'	/

	DATA	un_name( -1)	/ 'sec'		/,
     .		un_name( -2)	/ 'min'		/,
     .		un_name( -3)	/ 'hour'	/,
     .		un_name( -4)	/ 'day'		/,
     .		un_name( -5)	/ 'mon'		/,
     .		un_name( -6)	/ 'yr'		/,
     .		un_name( -7)	/ 'M2 cycles'	/,
     .		un_name( -8)	/ 'year366'     /,
     .		un_name( -9)	/ 'year360'     /,
     .		un_name(-10)	/ 'gregorian_ye'/
     .		un_name(-11)	/ 'noleap_ye'/
     .		un_name(-12)	/ 'julian_ye'/
     .		un_name(-13)	/ 'mon_noleap'/
     .		un_name(-14)	/ 'mon_360'/
     .		un_name(-15)	/ 'mon_julian'/

	DATA	un_convert( 1)	/ .01		/,
     .		un_convert( 2)	/ 1000.		/,
     .		un_convert(pun_meters)	/ 1.0		/,
     .		un_convert( 4)	/ deg2m		/,
     .		un_convert( 5)	/ 0.3048	/,
     .		un_convert( 6)	/ 0.0254	/,
     .		un_convert( 7)	/ 1609.		/,
     .		un_convert( 8)	/ .001		/,
     .		un_convert(pun_millibars)	/ 1.0 /,! not convertible 12/94
     .		un_convert(pun_decibars)	/ 1.0 /,! kludge: not cnvertble
     .		un_convert(11)	/ real4_init	/,
     .		un_convert(12)	/ real4_init	/,
     .		un_convert(13)	/ real4_init	/,
     .		un_convert(14)	/ 1.0    	/, ! kludge for not convertible
     .		un_convert(15)	/ 1.0    	/  ! kludge for not convertible

	DATA	un_convert( -1)	/ 1.0		/,
     .		un_convert( -2)	/ 60.		/,
     .		un_convert( -3)	/ 3600.		/, ! sec per hour
     .		un_convert( -4)	/ 86400.	/, ! sec per day
     .		un_convert( -5)	/ 2629746.	/, ! 1/12 of 365.2425 year

c     .		un_convert( -6)	/ 31536000.	/, ! sec per 365 day year (OLD default)
     .		un_convert( -6)	/ 31556952.	/  ! sec per 365.2425 year

     .		un_convert( -7)	/ 44712.	/, ! sec per M2 cycle
     .		un_convert( -8)	/ 31622400.	/, ! sec per 366 day year
     .		un_convert( -9)	/ 31104000.	/, ! sec per 360 day year
     .		un_convert(-10)	/ 31556952.	/  ! sec per 365.2425 year

     .		un_convert(-11)	/ 31536000.	/ ! sec per 365.0 day year
     .		un_convert(-12)	/ 31557600.	/ ! sec per 365.25 day year

     .		un_convert(-13)	/ 2628000.	/ ! 1/12 of sec per 365 day year
     .		un_convert(-14)	/ 2592000.	/ ! 1/12 of sec per 360 day year
     .		un_convert(-15)	/ 2629800.	/ ! 1/12 of sec per 365.25 day year
     .		un_convert(-16)	/ 2635200.	/ ! 1/12 of sec per 366 day year

	DATA	un_alt_name ( 1) / 'centim'	/,
     .		un_alt_subsc( 1) / 1 /,
     .
     .		un_alt_name ( 2) / 'kilom'	/,
     .		un_alt_subsc( 2) / 2 /,
     .
     .		un_alt_name ( 3) / 'milim'	/,
     .		un_alt_subsc( 3) / 8 /,
     .
     .		un_alt_name ( 4) / 'lat'	/,
     .		un_alt_subsc( 4) / pun_degrees /,
     .
     .		un_alt_name ( 5) / 'lon'	/,
     .		un_alt_subsc( 5) / pun_degrees /,
     .
     .		un_alt_name ( 6) / 'feet'	/,
     .		un_alt_subsc( 6) / 5 /,
     .
     .		un_alt_name ( 7) / 'foot'	/,
     .		un_alt_subsc( 7) / 5 /,
     .
     .		un_alt_name ( 8) / 'meter'	/,! after all other "xxxxmeters"
     .		un_alt_subsc( 8) / pun_meters /,
     .
     .		un_alt_name ( 9) / 'year365'/,
     .		un_alt_subsc( 9) / -6 /,
     .
     .		un_alt_name (10) / 'millibar'	/,
     .		un_alt_subsc(10) / pun_millibars /,
     .
     .		un_alt_name (11) / 'decibar'	/,
     .		un_alt_subsc(11) / pun_decibars /,
     .
     .		un_alt_name (12) / 'common_year'/,
     .		un_alt_subsc(12) / -6 /,
     .
     .		un_alt_name (13) / 'mbar'	/,
     .		un_alt_subsc(13) / pun_millibars /,
     .
     .		un_alt_name (14) / 'year'	/,
     .		un_alt_subsc(14) / -10 /,
     .
     .		un_alt_name (15) / 'degree'	/,
     .		un_alt_subsc(15) / pun_degrees /,
     .
     .		un_alt_name (16) / 'month'	/,
     .		un_alt_subsc(16) / -5 /,
     .
     .		un_alt_name (17) / 'minute'	/,
     .		un_alt_subsc(17) / -2 /,
     .
     .		un_alt_name (18) / 'second'	/,
     .		un_alt_subsc(18) / -1 /,
     .
     .		un_alt_name (19) / 'hr'		/,
     .		un_alt_subsc(19) / -3 /,
     .
     .		un_alt_name (20) / 'metre'	/, ! those Brits ...
     .		un_alt_subsc(20) /  pun_meters /
!     .		un_alt_name (20) / char_init12	/,
!     .		un_alt_subsc(20) / 0 /

	END

	SUBROUTINE DO_POINTS(	action, idim,
     .				com, com_mr, com_cx,
     .				res, res_mr, res_cx )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine the number of good and number of bad points along the given axis

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V230:   2/3/92 - based on DO_AVE_INT
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V71 *acm* 12/16 this routine now performs accumulation, possibly continuing
*                 over several chunks, so keep adding to the count in res(). 
*                 Initialization and finalizing called separately from IS_TRANS

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xunits.cmn_text'
	external xunits_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data

* internal variable declarations:
	LOGICAL	good_un
	INTEGER i, j, k, l, m, n, pt, ngd, nbd
	REAL	bad_com, bad_res

* calling argument declarations:
	INTEGER	action, idim, com_mr, com_cx, res_mr, res_cx
	REAL    com( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          res( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif )

* --- end of introductory code ---

* initialize
        pt   = cx_lo_ss( res_cx, idim )
	bad_com = mr_bad_data( com_mr )
        bad_res = mr_bad_data( res_mr )
	good_un  = action .EQ. isact_good_pt

* ALONG X AXIS
	IF ( idim .EQ. x_dim ) THEN
	   DO 110 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 110 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 110 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 110 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 110 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
              ngd = 0
              nbd = 0
	      DO 100 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_com ) THEN
                    nbd = nbd + 1
                 ELSE
                    ngd = ngd + 1
                 ENDIF
 100	      CONTINUE
              IF ( good_un ) THEN
                 res(pt,j,k,l,m,n) = res(pt,j,k,l,m,n) + ngd
              ELSE
                 res(pt,j,k,l,m,n) = res(pt,j,k,l,m,n) + nbd
              ENDIF
 110	   CONTINUE

* ALONG Y AXIS
	ELSEIF ( idim .EQ. y_dim ) THEN
	   DO 210 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 210 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 210 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 210 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 210 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
              ngd = 0
              nbd = 0
	      DO 200 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_com ) THEN
                    nbd = nbd + 1
                 ELSE
                    ngd = ngd + 1
                 ENDIF
 200	      CONTINUE
              IF ( good_un ) THEN
                 res(i,pt,k,l,m,n) = res(i,pt,k,l,m,n) + ngd
              ELSE
                 res(i,pt,k,l,m,n) = res(i,pt,k,l,m,n) + nbd
              ENDIF
 210	   CONTINUE

* ALONG Z AXIS
	ELSEIF ( idim .EQ. z_dim ) THEN
	   DO 310 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 310 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 310 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 310 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 310 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
              ngd = 0
              nbd = 0
	      DO 300 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_com ) THEN
                    nbd = nbd + 1
                 ELSE
                    ngd = ngd + 1
                 ENDIF
 300	      CONTINUE
              IF ( good_un ) THEN
                 res(i,j,pt,l,m,n) = res(i,j,pt,l,m,n) + ngd
              ELSE
                 res(i,j,pt,l,m,n) = res(i,j,pt,l,m,n) + nbd
              ENDIF
 310	   CONTINUE

* ALONG T AXIS
	ELSEIF ( idim .EQ. t_dim ) THEN
	   DO 410 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 410 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 410 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 410 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 410 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
              ngd = 0
              nbd = 0
	      DO 400 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_com ) THEN
                    nbd = nbd + 1
                 ELSE
                    ngd = ngd + 1
                 ENDIF
 400	      CONTINUE
              IF ( good_un ) THEN
                 res(i,j,k,pt,m,n) = res(i,j,k,pt,m,n) + ngd
              ELSE
                 res(i,j,k,pt,m,n) = res(i,j,k,pt,m,n) + nbd
              ENDIF
 410	   CONTINUE

* ALONG E AXIS
	ELSEIF ( idim .EQ. e_dim ) THEN
	   DO 510 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 510 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 510 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 510 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 510 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
              ngd = 0
              nbd = 0
	      DO 500 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_com ) THEN
                    nbd = nbd + 1
                 ELSE
                    ngd = ngd + 1
                 ENDIF
 500	      CONTINUE
              IF ( good_un ) THEN
                 res(i,j,k,l,pt,n) = res(i,j,k,l,pt,n) + ngd
              ELSE
                 res(i,j,k,l,pt,n) = res(i,j,k,l,pt,n) + nbd
              ENDIF
 510	   CONTINUE

* ALONG F AXIS
	ELSEIF ( idim .EQ. f_dim ) THEN
	   DO 610 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 610 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 610 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 610 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 610 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
              ngd = 0
              nbd = 0
	      DO 600 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_com ) THEN
                    nbd = nbd + 1
                 ELSE
                    ngd = ngd + 1
                 ENDIF
 600	      CONTINUE
              IF ( good_un ) THEN
                 res(i,j,k,l,m,pt) = res(i,j,k,l,m,pt) + ngd
              ELSE
                 res(i,j,k,l,m,pt) = res(i,j,k,l,m,pt) + nbd
              ENDIF
 610	   CONTINUE

	ENDIF

	RETURN
	END

	   SUBROUTINE MEAN_STD (dat, nsize, bad, need_std, dmean, dstd)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*

C** Return the mean and optionally standard deviation for the 1-D series

* calling argument declarations:

	LOGICAL need_std
	INTEGER nsize
	REAL dat(*), bad, dmean, dstd

* internal variable declarations:
	REAL sum, dev

	REAL x, xmean, sum2, xdelta
	INTEGER i, n, n2

* Initialize

	dmean = bad
	dstd = bad

c Compute data mean.

        sum = 0.0
        n = 0
        DO i = 1, nsize
	   x = dat(i)
	   IF ( x .NE. bad) THEN
	      sum = sum + x
              n = n + 1
	   ENDIF
        ENDDO

        IF (n .EQ. 0) GOTO 5000
	dmean = sum/DBLE(n)

        IF (need_std) THEN

* Compute variance. See http://en.wikipedia.org/wiki/Algorithms_for_calculating_variance

* On-line algorithm with mean subtracted first. Noted as the most robust.
* Since we always compute the mean first anyway, use it.

	   n = 0
	   xmean = 0.D0
	   sum2 = 0.D0
 
	   DO i = 1, nsize
	   x = dat(i)
	      IF ( x .NE. bad) THEN
	         n = n + 1
	         x = x - dmean
	         xdelta = x - xmean
	         xmean = xmean + xdelta/DBLE(n)
	         sum2 = sum2 + xdelta*(x - xmean)  ! This expression uses the new value of mean
 	      ENDIF
	   ENDDO

	   dstd = SQRT(sum2/DBLE(n - 1))

        ENDIF

 5000	RETURN

	END

	SUBROUTINE XEQ_ANNOTATE

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Put an annotation (moveable label) onto an existing plot

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP/SDIG 
*
* revision 0.0 - 4/6/2015
* V697 12/15 *acm* Fix ticket 2350: handling annotation label text 
*                  that's numeric

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'slash.parm'
	include 'xplot_state.cmn'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
	include 'plot_setup.parm'
	include 'xplot_setup.cmn'
	
* local variable declarations:
	LOGICAL user, norm, nouser
	INTEGER	TM_LENSTR1,
     .		rlen, nchar, status
	REAL	xloc, yloc, halign, angle, size

	CHARACTER TM_FMT*48, buff*20, labtxt*2048

* initialize 

	size = 0.2

* Get the text, treating the text as the label string (even if say, 
* it's a comma-separated list).

	IF (num_items .LT. 1) THEN
	   GOTO 5500
	ELSE 
	   labtxt = cmnd_buff(item_start(1):item_end(num_items))
	ENDIF

* Get settings

	CALL SET_ANNOTATION (user, nouser, norm, xloc, yloc, halign, 
     .         angle, size, status)
	IF (status .NE. ferr_ok) GOTO 5000

	IF (nouser .OR. norm) THEN
	   buff = 'NOUSER'
	ELSE
	   buff = 'USER'
	ENDIF

* Create the %LABEL command

	ppl_buff = '%LABEL/'//buff
	rlen = TM_LENSTR1(ppl_buff)

	ppl_buff = ppl_buff(:rlen)//' '//TM_FMT(xloc, 12, 16, nchar)
	rlen = TM_LENSTR1(ppl_buff)

	ppl_buff = ppl_buff(:rlen)//','//TM_FMT(yloc, 12, 16, nchar)
	rlen = TM_LENSTR1(ppl_buff)

	ppl_buff = ppl_buff(:rlen)//','//TM_FMT(halign, 12, 16, nchar)
	rlen = TM_LENSTR1(ppl_buff)

	ppl_buff = ppl_buff(:rlen)//','//TM_FMT(angle, 12, 16, nchar)
	rlen = TM_LENSTR1(ppl_buff)

	ppl_buff = ppl_buff(:rlen)//','//TM_FMT(size, 12, 16, nchar)
	rlen = TM_LENSTR1(ppl_buff)

	ppl_buff = ppl_buff(:rlen)//', "'//labtxt//'"'
	rlen = TM_LENSTR1(ppl_buff)

* ... pass a the command to PPLUS

	CALL PPLCMD (' ',' ',0,ppl_buff(:rlen),1,1)

 5000	RETURN
 5500	CALL ERRMSG( ferr_invalid_command, status,
     .		'ANNOTATE command missing text for the annotation', *5000 )

	END

	SUBROUTINE TRANSFER_AXIS ( idim, source, dest )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* transfer region and transformation information about one axis from one
* context buffer to another

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  5/31/89 - extracted from TRANSFER_CONTEXT
* $Id: transfer_axis.F 15046 2012-10-19 21:52:08Z ansley $ 
*       - *kob* need to now copy cx_calender as well
* v580 *acm* 11/04 transfer cx_cal_id, the calendar ID used when  
*                  computing world coordinates
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction.
* V683  *acm*10/12 Improve handling of F axes and info about the calendar of the grid.

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'

	INTEGER	source, dest, idim

	cx_lo_ss ( dest, idim )   = cx_lo_ss ( source, idim )
	cx_hi_ss ( dest, idim )   = cx_hi_ss ( source, idim )
	cx_lo_ww ( idim, dest )   = cx_lo_ww ( idim, source )
	cx_hi_ww ( idim, dest )   = cx_hi_ww ( idim, source )
	cx_trans ( idim, dest )   = cx_trans ( idim, source )
	cx_by_ss ( idim, dest )   = cx_by_ss ( idim, source )
	cx_given ( idim, dest )   = cx_given ( idim, source )
	cx_trans_arg(idim, dest)  = cx_trans_arg(idim, source)
* 8/97 *kob* 	
	IF (idim .EQ. t_dim) THEN
           cx_calendar(dest) = cx_calendar(source)
           cx_cal_id(dest) = cx_cal_id(source)
        ENDIF


	RETURN
	END

*
* transpose_zt.F
*
* 
* 
*
* This function sets the second argument to be equal
* to the first one with the Z and T axes switched.
*


*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument''s axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE transpose_zt_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id, 'transposes Z and T axes of given variable')
      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                ABSTRACT,        ABSTRACT,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'VAR')
      CALL ef_set_arg_desc(id, arg, 'variable to transpose in Z and T')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, NO, NO, YES, YES)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


      SUBROUTINE transpose_zt_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER my_lo_z, my_hi_z, my_lo_t, my_hi_t, nz, nt

*     Set the abstract Z and T axes.

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nz = arg_hi_ss(Z_AXIS, ARG1) - arg_lo_ss(Z_AXIS, ARG1) + 1
      nt = arg_hi_ss(T_AXIS, ARG1) - arg_lo_ss(T_AXIS, ARG1) + 1

*     The below has the effect of translating any sub-matrix so that
*     the indices will always begin at 1 as expected for an abstract axis.

      my_lo_z = 1
      my_hi_z = nt
      my_lo_t = 1
      my_hi_t = nz

      CALL ef_set_axis_limits(id, Z_AXIS, my_lo_z, my_hi_z)
      CALL ef_set_axis_limits(id, T_AXIS, my_lo_t, my_hi_t)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 

      END


*
* In this subroutine we compute the result
*
      SUBROUTINE transpose_zt_compute(id, arg_1, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1
      CHARACTER*100 errtxt

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* check to make sure both axis have points to transpose
      IF ( (arg_lo_ss(T_AXIS, ARG1) .EQ. ef_unspecified_int4) .OR. 
     .     (arg_hi_ss(T_AXIS, ARG1) .EQ. ef_unspecified_int4)) THEN
         WRITE(errtxt,*) 'T axis cannot be a normal axis'
         GOTO 999
      ENDIF
      IF ( (arg_lo_ss(Z_AXIS, ARG1) .EQ. ef_unspecified_int4) .OR. 
     .     (arg_hi_ss(Z_AXIS, ARG1) .EQ. ef_unspecified_int4) ) THEN
         WRITE(errtxt,*) 'Z axis cannot be a normal axis'
         GOTO 999
      ENDIF

      n1 = arg_lo_ss(F_AXIS, ARG1)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

      m1 = arg_lo_ss(E_AXIS, ARG1)
      DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

      l1 = arg_lo_ss(T_AXIS, ARG1)
      DO 400 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS) 

      k1 = arg_lo_ss(Z_AXIS, ARG1)
      DO 300 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS) 

      j1 = arg_lo_ss(Y_AXIS, ARG1)
      DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

      i1 = arg_lo_ss(X_AXIS, ARG1)
      DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         IF ( arg_1(i1,j1,k1,l1,m1,n1) .NE. bad_flag(ARG1) ) THEN
            result(i,j,k,l,m,n) = arg_1(i1,j1,k1,l1,m1,n1)
         ELSE
            result(i,j,k,l,m,n) = bad_flag_result
         ENDIF

         i1 = i1 + arg_incr(X_AXIS, ARG1)
 100  CONTINUE

         j1 = j1 + arg_incr(Y_AXIS, ARG1)
 200  CONTINUE

         k1 = k1 + arg_incr(Z_AXIS, ARG1)
 300  CONTINUE

         l1 = l1 + arg_incr(T_AXIS, ARG1)
 400  CONTINUE

         m1 = m1 + arg_incr(E_AXIS, ARG1)
 500  CONTINUE

         n1 = n1 + arg_incr(F_AXIS, ARG1)
 600  CONTINUE

      RETURN 

 999  CALL EF_BAIL_OUT(id, errtxt)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	SUBROUTINE MAKE_PSEUDO_VAR ( cx, idim, pvar, mr, lo_ss, hi_ss )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* create a "pseudo-variable" - numerical grid of data based solely on the
* underlying grid (not involving external data)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/2/87
* V200:  6/20/89 - 4D-symmetrical version
* V530   1/01 - *sh* - added XBOXLO, XBOXHI and family ...
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
*       *acm*      more 4s that should have been nferdims
*      *acm* 4/12 Add new MODE FOURDEE to allow E,F,M,N,etc as user-vars
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.
*                 (no actual changes, just modernizing the code a bit.)
* V720 *sh* 5/17 support for DSG coordinates as pseduo-variables

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include	'xalgebra.cmn'
	include	'xdset_info.cmn_text'
	include 'xdyn_linemem.cmn_text'

* calling argument declarations:
	INTEGER	cx, mr, idim, lo_ss, hi_ss
	REAL	pvar( lo_ss:hi_ss )

* internal variable declarations:
	LOGICAL	TM_ITSA_DSG, its_dsg
	INTEGER	TM_DSG_DSET_FROM_GRID, TM_DSG_NFEATURES,
     .		grid, dset, pv, i, iaxis,
     .		dsg_var, dsg_lm, iobs, nobs, ifeature, nfeatures
	REAL	BOX_SIZE, TM_WORLD

* initialize

* defining grid for output data
	grid = cx_grid( cx )
	its_dsg = idim .NE. f_dim .AND. TM_ITSA_DSG(grid)

	IF (its_dsg) THEN
	   dset = TM_DSG_DSET_FROM_GRID(grid)
	   IF (idim .EQ. e_dim) THEN
	      dsg_var = dsg_row_size_var(dset)
	   ELSE
	      dsg_var = dsg_coord_var(idim, dset)
	   ENDIF
	   dsg_lm = dsg_loaded_lm(dsg_var)
	ELSE
	   dset = cx_data_set( cx )
	ENDIF

	pv = (mr_variable(mr)-1) / nferdims  + 1

	IF ( pv .GT. nferdims+1 )  STOP 'MK_PSEUDO_VAR'	! diag

	GOTO (  100, 200, 300, 400, 500 ) pv

* "I", "J", "K", "L", "M", "N"
 100	IF (its_dsg) THEN
	   nfeatures = TM_DSG_NFEATURES(grid)
	   IF (lm_size(dsg_lm) .EQ. nfeatures) THEN
* ... DSG instance indices
	      DO ifeature = lo_ss, hi_ss   ! always 1 to nfeatures
	         pvar(ifeature) = ifeature
	      ENDDO
	   ELSE
* ... DSG obs indices - start from 1 on each feature
	      dsg_var = dsg_row_size_var(dset)
	      dsg_lm  = dsg_loaded_lm(dsg_var)
	      i = 0
	      DO ifeature = 1, nfeatures
	         nobs = dsg_linemem(dsg_lm)%ptr(ifeature)
	         DO iobs = 1, nobs
	            i = i + 1
	            pvar( i ) = iobs
	         ENDDO
	      ENDDO
	   ENDIF
	ELSE
	   DO i = lo_ss, hi_ss
	      pvar( i ) = i
	   ENDDO
	ENDIF
	RETURN

* "X", "Y", "Z", "T", "E", "F"
* TM_WORLD returns days if it is a true-month time axis
 200	IF (its_dsg) THEN
!DSGTBD: more efficient would be to just retuen the pointer dsg_linemem(dsg_lm)%ptr
!  an example of how to do this is found in FIND_MEM_VAR
!  In IS_PSEUDO would need to trap the X,Y,Z,T pseudo-variable case
	   DO i = lo_ss, hi_ss   ! always full DSG obs or instance dimension
	      pvar(i) = dsg_linemem(dsg_lm)%ptr(i)
	   ENDDO
	ELSE
	   DO i = lo_ss, hi_ss
	      pvar( i ) = TM_WORLD( i,grid,idim,box_middle )
	   ENDDO
	ENDIF
	RETURN

* "XBOX", "YBOX", "ZBOX", "TBOX", "EBOX", "FBOX"
!DSGTBD: BOX, BOXLO, and BOXHI are useful values to return for the coordinates
! that are observation variable, but not for the coordinates that are instance
! variables.
!       Currently these are trapped as errors in PSEUDO_VAR_CONTEXT
 300	DO i = lo_ss, hi_ss
	   pvar( i ) = BOX_SIZE( i, grid, idim )
	ENDDO
	RETURN

* "XBOXLO", "YBOXLO", "ZBOXLO", "TBOXLO", "EBOXLO", "FBOXLO"
!DSGTBD: e.g. the low value of XBOXLO for a trajectory feature can be returned
!    as the midpoint between X-observation and X-previous-observation
 400	DO i = lo_ss, hi_ss
	   pvar( i ) =  TM_WORLD( i,grid,idim,box_lo_lim )
	ENDDO
	RETURN

* "XBOXHI", "YBOXHI", "ZBOXHI", "TBOXHI", "EBOXHI", "FBOXHI"
 500	DO i = lo_ss, hi_ss
	   pvar( i ) =  TM_WORLD( i,grid,idim,box_hi_lim )
	ENDDO
	RETURN

	END

	SUBROUTINE ATTR_CONTEXT (lo_cx, hi_cx, start, end, uvar, status)

* Setup for returning attribute information as variables
* 4/22/2020 Don't include "ferRowSize" virtual variable in ..varnames

        IMPLICIT NONE
	include 'tmap_dims.parm'
#include "netcdf.inc"
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'
        include 'xcontrol.cmn'
        include 'xalgebra.cmn'


* calling argument declarations:
	INTEGER lo_cx, hi_cx, start, end, uvar, status

* internal variable declarations:
	LOGICAL	NC_GET_ATTRIB, reset_ss, do_err, got_it, coordvar
	REAL	val
	INTEGER TM_LENSTR1, STR_SAME, 
     .		dset, dot, cat, nv, slen, maxlen, varid,
     .		ndims, nvars, ngatts, recdim, ivar, vartype, 
     .		nvdims, vdims(8), nvatts, all_outflag, attoutflag, 
     .		attlen, attype, attid, iatt
	CHARACTER name*150, attname*128, aname*128, buff*10

* set these to unspecified.  If they get set in GET_VAR_CONTEXT, 
* then do not set them to 1:attlen below.

 	cx_lo_ss(hi_cx, x_dim) = unspecified_int4
 	cx_hi_ss(hi_cx, x_dim) = unspecified_int4

	CALL GET_VAR_CONTEXT (  uvar_text(uvar)(start:end),
     .				lo_cx,
     .				hi_cx,
     .				status )
	IF ( status .NE. ferr_ok ) RETURN

* Flag to set the limits. They were not set by GET_VAR_CONTEXT, so use the
* attribute size

        reset_ss = (cx_lo_ss(hi_cx, x_dim) .EQ. unspecified_int4  .OR.
     .              cx_hi_ss(hi_cx, x_dim) .EQ. unspecified_int4 ) 

        dset = cx_data_set(hi_cx)

! See if this is a user variable and set dataset number accordingly

        dot = INDEX(uvar_text(uvar),'.')
        IF (dot .GT. 0) name = uvar_text(uvar)(1:dot-1)
        CALL FIND_VAR_NAME(pdset_irrelevant, name, cat, ivar)
        IF (  ivar .NE. munknown_var_name .AND.
     .        cat .EQ. cat_user_var) THEN
           dset = pdset_uvars

* Check whether its a LET/D variable
           CALL CD_GET_VAR_ID (dset, uvar_text(uvar)(1:dot-1), varid, status)
           IF (dset.EQ.pdset_uvars .AND. status.NE.ferr_ok) THEN
	      dset = cx_data_set(hi_cx)
	      CALL CD_GET_VAR_ID (dset, uvar_text(uvar)(1:dot-1), varid, status)
           ENDIF
           IF (status.NE.ferr_ok) do_err = .TRUE. 
        ENDIF

        IF (dset .EQ. unspecified_int4 .OR. 
     .      dset .EQ. pdset_irrelevant) THEN
           CALL TRANSFER_CONTEXT (lo_cx, hi_cx)

	   GOTO 5000
        ENDIF

* do_err: issue error message if attrib does not exist on varname.attname
        do_err = .TRUE.
        CALL  BREAK_VARATTNAME (  uvar_text(uvar)(start:end), dset, 
     .                         name, attname, varid, do_err, status )

* Is the *attr name* a pseudo-name for a variable: attnames, dimnames,
*  natts, type, ...

        IF (varid .GT. 0) THEN
           CALL CD_GET_VAR_INFO (dset, varid, name, vartype,
     .             nvdims, vdims, nvatts, coordvar, all_outflag, 
     .             status)

* attribute names
           IF (STR_SAME(attname, 'attnames') .EQ. 0 ) THEN
              cx_type(hi_cx) = ptype_string
              IF (reset_ss) THEN
                 cx_lo_ss(hi_cx, x_dim) = 1
                 cx_hi_ss(hi_cx, x_dim) = nvatts
              ELSE
                 cx_lo_ss(hi_cx, x_dim) = MAX(1, cx_lo_ss(hi_cx, x_dim))
                 cx_hi_ss(hi_cx, x_dim) = MIN(nvatts, cx_hi_ss(hi_cx, x_dim))
              ENDIF

* dimension names
           ELSE IF (STR_SAME(attname, 'dimnames') .EQ. 0 ) THEN 
              cx_type(hi_cx) = ptype_string
              IF (reset_ss) THEN
                 cx_lo_ss(hi_cx, x_dim) = 1
                 cx_hi_ss(hi_cx, x_dim) = nvdims
              ELSE
                 cx_lo_ss(hi_cx, x_dim) = MAX(1, cx_lo_ss(hi_cx, x_dim))
                 cx_hi_ss(hi_cx, x_dim) = MIN(nvdims, cx_hi_ss(hi_cx, x_dim))
              ENDIF
 
* # of dimensions for variable 
           ELSE IF (STR_SAME(attname, 'ndims') .EQ. 0 ) THEN
              cx_type(hi_cx) = ptype_float
              cx_lo_ss(hi_cx, x_dim) = 1
              cx_hi_ss(hi_cx, x_dim) = 1

*  variable types
           ELSE IF (STR_SAME(attname, 'nctype') .EQ. 0 ) THEN
              cx_type(hi_cx) = ptype_float
              cx_lo_ss(hi_cx, x_dim) = 1
              cx_hi_ss(hi_cx, x_dim) = 1

* # of attributes
            ELSE IF (STR_SAME(attname, 'nattrs') .EQ. 0 ) THEN
             cx_type(hi_cx) = ptype_float
              cx_lo_ss(hi_cx, x_dim) = 1
              cx_hi_ss(hi_cx, x_dim) = 1

            ELSE

* General attribute.
* Get attribute type and length
        
               CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, status)
                  IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, varid,  
     .              attid, aname, attype, attlen, attoutflag, status )

               IF (status .NE. ferr_ok) THEN
                  GOTO 5000 ! ?? error message
               ENDIF

               IF (attype .EQ. NCCHAR) THEN
                  cx_type(hi_cx) = ptype_string
               ELSE
                  cx_type(hi_cx) = ptype_float
               ENDIF

* If the attribute we are asking for is the bad-data flag, set 
* cx_bad_data to something else, so that the value will be displayed.

               IF (STR_SAME (attname, 'missing_value') .EQ. 0 .OR.
     .            STR_SAME (attname, '_FillValue') .EQ. 0) THEN
                  maxlen = 1
                  got_it = NC_GET_ATTRIB ( dset, varid, attname, 
     .                                .TRUE., name, maxlen, attlen, 
     .                                attoutflag, buff, val)
                  IF (got_it) cx_bad_data(hi_cx) = val/2. + 1.
               ENDIF

               IF (attype .EQ. NCCHAR) THEN
                  cx_lo_ss(hi_cx, x_dim) = 1
                  cx_hi_ss(hi_cx, x_dim) = 1
               ELSE
 
* If they were not set by the var context, set the X axis limits equal 
* to the length of the array. 

                 IF (reset_ss) THEN
                     cx_lo_ss(hi_cx, x_dim) = 1
                     cx_hi_ss(hi_cx, x_dim) = attlen
                 ELSE
                    cx_lo_ss(hi_cx, x_dim) = MAX(1, cx_lo_ss(hi_cx, x_dim))
                    cx_hi_ss(hi_cx, x_dim) = MIN(attlen, cx_hi_ss(hi_cx, x_dim))
                 ENDIF
               ENDIF

            ENDIF  ! general attribute

* If the varname is ., referring to the dataset itself, then the varid = 0. These are
* dataset attributes: varnames, attnames, dimnames, ndims, nvars, ...

        ELSE !  varid = 0
           CALL CD_GET_DS_INFO (dset, ndims, nvars, ngatts, recdim, status)
     
* Count number of non-coordinate variables.
* Don't inclde a variable we created ferRowSize for some DSG files.

           nv = 0
           DO ivar = 1, nvars
              CALL CD_GET_VAR_INFO (dset, ivar, name, vartype, nvdims, 
     .                  vdims, nvatts, coordvar, all_outflag, status)
              IF (.NOT. coordvar .AND. name.NE.'ferRowSize') nv = nv + 1
           ENDDO

           IF (STR_SAME(attname, 'varnames') .EQ. 0 ) THEN
              cx_type(hi_cx) = ptype_string
              IF (reset_ss) THEN
                 cx_lo_ss(hi_cx, x_dim) = 1
                 cx_hi_ss(hi_cx, x_dim) = MAX(1, nv)
              ELSE
                 cx_lo_ss(hi_cx, x_dim) = MAX(1, cx_lo_ss(hi_cx, x_dim))
                 cx_hi_ss(hi_cx, x_dim) = MIN(nv, cx_hi_ss(hi_cx, x_dim))
              ENDIF

* Global attributes
           ELSE IF (STR_SAME(attname, 'attnames') .EQ. 0 ) THEN
              cx_type(hi_cx) = ptype_string
              IF (reset_ss) THEN
                 cx_lo_ss(hi_cx, x_dim) = 1
                 cx_hi_ss(hi_cx, x_dim) = MAX(1, ngatts)
              ELSE
                 cx_lo_ss(hi_cx, x_dim) = MAX(1, cx_lo_ss(hi_cx, x_dim))
                 cx_hi_ss(hi_cx, x_dim) = MIN(ngatts, cx_hi_ss(hi_cx, x_dim))
              ENDIF
                    
* # of dimensions
           ELSE IF (STR_SAME(attname, 'ndims') .EQ. 0 ) THEN
              cx_type(hi_cx) = ptype_float
              cx_lo_ss(hi_cx, x_dim) = 1
              cx_hi_ss(hi_cx, x_dim) = 1
   
* dimension names
           ELSE IF (STR_SAME(attname, 'dimnames') .EQ. 0 ) THEN
              cx_type(hi_cx) = ptype_string

              IF (reset_ss) THEN
                 cx_lo_ss(hi_cx, x_dim) = 1
                 cx_hi_ss(hi_cx, x_dim) = MAX(1, ndims)
              ELSE
                 cx_lo_ss(hi_cx, x_dim) = MAX(1, cx_lo_ss(hi_cx, x_dim))
                 cx_hi_ss(hi_cx, x_dim) = MIN(ndims, cx_hi_ss(hi_cx, x_dim))
              ENDIF
   
* coordinate-variable names
           ELSE IF (STR_SAME(attname, 'coordnames') .EQ. 0 ) THEN
              cx_type(hi_cx) = ptype_string

              IF (reset_ss) THEN
                 cx_lo_ss(hi_cx, x_dim) = 1
                 cx_hi_ss(hi_cx, x_dim) = MAX(1, nvars-nv)
              ELSE
                 cx_lo_ss(hi_cx, x_dim) = MAX(1, cx_lo_ss(hi_cx, x_dim))
                 cx_hi_ss(hi_cx, x_dim) = MIN(ndims, cx_hi_ss(hi_cx, x_dim))
              ENDIF

* # variables 
           ELSE IF (STR_SAME(attname, 'nvars') .EQ. 0 ) THEN
              cx_type(hi_cx) = ptype_float
              cx_lo_ss(hi_cx, x_dim) = 1
              cx_hi_ss(hi_cx, x_dim) = 1

* # coordinate variables (dimensions that ALSO have a coord. var)
               
           ELSE IF (STR_SAME(attname, 'ncoordvars') .EQ. 0 ) THEN
              cx_type(hi_cx) = ptype_float
              cx_lo_ss(hi_cx, x_dim) = 1
              cx_hi_ss(hi_cx, x_dim) = 1

* # of global attributes
           ELSE IF (STR_SAME(attname, 'nattrs') .EQ. 0 ) THEN
              cx_type(hi_cx) = ptype_float
              cx_lo_ss(hi_cx, x_dim) = 1
              cx_hi_ss(hi_cx, x_dim) = 1

* Is the reference to a global attribute? If so get its type and length

           ELSE
              CALL CD_GET_VAR_ID (dset, '.', varid, status)
              CALL CD_GET_DS_INFO (dset, ndims, nvars, ngatts, 
     .            recdim, status)

* If the attribute name is in quotes remove them. Perhaps the user
* is looking for a global file attribute named the same as one of our
* pseudo- attribute names 
* (Logic for case-sensitive searching will go here...)

              slen = TM_LENSTR1(attname)
              IF (attname(1:1) .EQ. "'" .AND. attname(slen:slen) .EQ. "'" ) THEN
                 attname(slen:) = " "
                 attname = attname(2:)
              ENDIF

              DO iatt = 1, ngatts
                 CALL CD_GET_VAR_ATT_NAME (dset, varid, iatt, name, status)
                 IF (STR_SAME(name, attname) .EQ. 0) THEN

                    CALL CD_GET_VAR_ATT_INFO (dset, varid, iatt, 
     .                     name, attype, attlen, attoutflag, status )

                    cx_type(hi_cx) = ptype_float
                    cx_lo_ss(hi_cx, x_dim) = 1
                    cx_hi_ss(hi_cx, x_dim) = attlen

                    IF (attype .EQ. NCCHAR) THEN
                       cx_type(hi_cx) = ptype_string
                       cx_hi_ss(hi_cx, x_dim) = 1
                    ENDIF

                 ENDIF

              ENDDO

           ENDIF  ! global att or .ncoords etc

        ENDIF  ! varid > 0 or = 0

	RETURN
 5000	RETURN
	END

	INTEGER FUNCTION CD_WRITE_bndsdim ( cdfid, status )


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* Create a netCDF dimension for the second dimension of a bounds 
* coordinate variable

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* (from cd_write_strdim.F)

* V570 *acm* 5/04 
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files


* argument definitions:
*     cdfid   - netCDF id number for already opened CDF file
*     status  - return status

* include files
        include 'netcdf.inc'
	include 'tmap_errors.parm'
	include 'cdf_tmap.parm'
#include "gt_lib.parm"

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

* argument declarations
      INTEGER cdfid, status

* local variable declarations:
      CHARACTER dimname*128
      INTEGER cdfstat, clen, nlen, dimid, nbnds

* initialize
      dimname = 'bnds'
      nbnds = 2
      nlen = 4

* is the dimension already defined ?
#ifdef usingDODSf2cUnderscore
      cdfstat = NF_INQ_DIMID_(cdfid, dimname(:nlen), dimid )
#else
      cdfstat = NF_INQ_DIMID (cdfid, dimname(:nlen), dimid )
#endif

      IF ( cdfstat .EQ. NF_NOERR ) THEN
* ... yes. make sure defn is consistent

* v5.40 *kob* - add ifdef to check whether or not to append an underscore
*               to the v3 routine name.  This necessary because DODS netcdf
*               fortran jackets can be configured assuming f2c, which appends
*               an additional underscore to routine names already containing
*               and underscore.  The real solution is to configure dods 
*               correctly, but the below may be necessary when linked with
*               unidata-built dods libraries

#ifdef usingDODSf2cUnderscore
	cdfstat = NF_INQ_DIMLEN_(cdfid, dimid, clen)
#else
	cdfstat = NF_INQ_DIMLEN(cdfid, dimid, clen)
#endif
	IF (clen .NE. nbnds) GOTO 5100
      ELSE
* ... no. define it
        CALL CD_SET_MODE(cdfid, pcd_mode_define, status)
        IF ( status .NE. merr_ok ) RETURN
#ifdef usingDODSf2cUnderscore
        cdfstat = NF_DEF_DIM_( cdfid, dimname(:nlen), nbnds, dimid )
#else
        cdfstat = NF_DEF_DIM( cdfid, dimname(:nlen), nbnds, dimid )
#endif

        IF ( cdfstat .NE. NF_NOERR ) GOTO 5200
      ENDIF

* successful completion
      status = merr_ok
      CD_WRITE_BNDSDIM = dimid
      RETURN

* error messages
 5100 CALL TM_ERRMSG
     . ( merr_linepredef, status, 'CD_WRITE_BNDSDIM', unspecified_int4,
     .   unspecified_int4,
     .  'dimension '//dimname(:nlen)//' doesnt match CDF file',
     .  no_errstring, *5900 )

 5200        CALL TM_ERRMSG
     .     ( cdfstat+pcdferr, status, 'CD_WRITE_BNDSDIM', cdfid,
     .       unspecified_int4, 'Failed creating dimension '
     .       //dimname(:nlen), no_errstring, *5900 )

* error exit
 5900   RETURN
	END

*  separate_str.F
* 
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* Ansley Manke June 2013
* Given a data variable and a ROWSIZE indicating trajectory length,
* Insert a bad-value between trajectories.
*
*
*  In this subroutine we provide information about
*  the function.  The user configurable information 
*  consists of the following:
* 
*  descr              Text description of the function
* 
*  num_args           Required number of arguments
* 
*  axis_inheritance   Type of axis for the result
*                        ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                        CUSTOM          - user defined axis
*                        IMPLIED_BY_ARGS - same axis as the incoming argument
*                        NORMAL          - the result is normal to this axis
*                        ABSTRACT        - an axis which only has index values
* 
*  piecemeal_ok       For memory optimization:
*                        axes where calculation may be performed piecemeal
*                        ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE separate_str_init(id)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     . 'Insert a bad-value between features, string variable' )

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id, ABSTRACT, NORMAL, NORMAL, 
     .                                             NORMAL, NORMAL, NORMAL)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_desc(id, arg, 'variable to sample on I axis')
      CALL ef_set_axis_influence_6d(id, arg, YES, NO, NO, NO, NO, NO)
      CALL ef_set_arg_type (id, arg, STRING_ARG)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'Rowsize')
      CALL ef_set_arg_desc(id, arg,
     .          'array with per-feature row lengths')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'FixLongitudes')
      CALL ef_set_arg_desc(id, arg,
     .          'ignored (included for parity with numeric fcn)')
      CALL ef_set_axis_influence_6d(id, arg, NO, NO, NO, NO, NO, NO)

      CALL ef_set_result_type (id, STRING_RETURN)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END




      SUBROUTINE separate_str_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*     Use utility functions  to get context information about the arguments.
*     indices.


      INTEGER arg_lo_ss(6,EF_MAX_ARGS), arg_hi_ss(6,EF_MAX_ARGS),
     .     arg_incr(6,EF_MAX_ARGS)

      INTEGER nx, nr, lo_lim, hi_lim

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      nx = arg_hi_ss(X_AXIS, ARG1) - arg_lo_ss(X_AXIS, ARG1) + 1

* will add a point for each row

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      nr = MAX( (arg_hi_ss(E_AXIS, ARG2) - arg_lo_ss( E_AXIS, ARG2) + 1), 
     .          (arg_hi_ss(E_AXIS, ARG2) - arg_lo_ss( E_AXIS, ARG2) + 1) )

      lo_lim = 1
      hi_lim = nx + nr - 1
      CALL ef_set_axis_limits(id, X_AXIS, lo_lim, hi_lim)



*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END



*  In this subroutine we compute the result
* 
      SUBROUTINE separate_str_compute(id, arg_1, arg_2, arg_3, result)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)

! We just know this is on the X axis and will be passed in and out correct.y.
      REAL result(memreslox:memreshix)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(6), res_hi_ss(6), res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, i1, ir, k, m, slen
      INTEGER nx, ne, msum, rend
      REAL fixlon, tol, nothing
      LOGICAL ifix
      CHARACTER*512 buff

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      k = res_lo_ss(Z_AXIS)  ! index for unused dimensions

      nx = arg_hi_ss(X_AXIS, ARG1) - arg_lo_ss(X_AXIS, ARG1) + 1
      ne = arg_hi_ss(E_AXIS, ARG2) - arg_lo_ss(E_AXIS, ARG2) + 1

      CALL ef_get_one_val(id, arg3, fixlon)
      ifix =  (fixlon .GT. 0.8)
      tol = 200.

      i1 = 1
      ir = 1
      msum = 0
      DO m = arg_lo_ss(E_AXIS,ARG2), arg_hi_ss(E_AXIS, ARG2)
         rend = arg_2(k,k,k,k,m,k)
	 msum = msum + rend
	 IF (msum .GT. nx) msum = nx+1
	 DO i = i1, msum

	    CALL ef_get_string_arg_element_6d(id, ARG1, arg_1,
     .                       i,k,k,k,k,k, slen,buff)
	    CALL ef_put_string (buff, slen, result(ir) )
  
	    ir = ir + 1
	    IF (ir .GT. res_hi_ss(X_AXIS)) GOTO 9000
	 ENDDO
	 i1 = msum+1
	 buff = ' '
	 slen = 1
	 CALL ef_put_string (buff, slen, result(ir) )
	 ir = ir + 1
	 IF (ir .GT. res_hi_ss(X_AXIS)) GOTO 9000
      ENDDO

 9000 RETURN
c 999  CALL EF_BAIL_OUT(id, errtxt)
      RETURN

      END

      subroutine pplldx(icode,xt,yt,npts,tstrt,tref,xdt,pplmem)


C**
C**    @(#)pplldx.F	1.2    9/8/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
C v7.2 *acm* 2/2017 ticket 2246 Allow drawing formatted time axes on a PLOT/VS; 
C                this needed changes when time axis is vertical
c
c	icode	0 use both x and y
c		1 use x only
c		2 use y only
c		7 use y only, do not translate. For ribbon plots on vertical
c		              time axis, loading the color variable still 
c		              drawing the axis vertically
c
c                  When saving polygon data, save npts per polygon with 
c                  the data, not in the array lleng(): unlimited # polygons

c               3 use both x and y, for polygons 
c		4 use x only, for polygons
c		5 use y only, for polygons
c
c	xt	x data
c	yt	y data
c	npts	number of xt and yt points
c	tstrt	start time, corresponds to a value of xt=1.0
c 	tref	added 11.95, a reference time (~tstart) ferret will set
c	xdt	sample rate in minutes for x
c	pplmem  data buffer for PPLUS data
c
c	tstrt and xdt are used only for TAXIS,ON.
c
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*............. I changed the logicals on the includes - no impact ...sh
* revised for FERRET
* from PPLUS :

*	Directory PMEL:[PLOT5.LIBRARY.PLOT]

*	PPLLDX.FOR;1              7  25-AUG-1987 15:24

* search for "FERRET" to find all revisions
* *sh* 9/21/88 - rev 1.0 for FERRET 1.10+
*	- extensive changes to code that determines time axis limits
*	  previous version was based on a "minutes since 1970" calculation
*	  that blew up on dates preceeding 1970.  Replaced with a "minutes
*	  since BC" calculation
* *sh* 2/20/89- rev 1.1 for FERRET 1.20
*	- corrected bug in FERRET code: tmin,tstop calculation for linen>1
*	- reference ALL time axes to the same T0='0101010000' date
*	  instead of using T0 from first line (else overlays don't work)
*       - added LIMITS screening - permitting different bad data indicators
*	  in each data set
* Note: calling PPLLDX modifies the XEQ and YEQ limits
*	Mod *jd* 12.23.92 for MAC FERRET to change 8 args to 6 in stmnmx call
* *sh* 10/25/93 - for version 3.01 of FERRET
*	- corrected bug if Y axis was the time axis - data was not put through
*	  the time/date translation pipeline
* *sh*jd* 7.31.95 
*	- Fixes bug where small axis ranges result in round off error 
*	  creation.  Use TRANSLATE to catch.
* *jd* 11.27.95 Mod for 4 digit year
* *jd* 11.28.95 Add additional arg "tref" so reference time can be set
*	        by Ferret, now that 1901 is insufficient
* *jd* 11.30.95 Fix bug (again? see 10/25/93) where Y axis time axis
*		limits are not computed
* V510 *sh* 3/00 - allow loading of up to NPOLYGON lines (instead of NLINES)
*		 - the X or Y inputs no longer both flagged as bad if either is
* V540 *acm*9/01 - changes for dynamic pplus buffer, call PPLLDX via pplldx_envelope.c
*                  which checks pplmem_nsize (new name for NSIZE) and allocates 
*                  more if needed.
*      *acm* 10/01 Remove VMS includes
* V541 *acm*  4/02 Explicitly set itstart to be all 14 character places of tref:
*                  itstrt = tref(1:14) Otherwise we only get the first 10 (why??)
* V553 *acm*  6/03  For polygons, store the # of points in each polygon in the PPLUS
*                   memory buffer, rather than in lleng.  This way the number of
*                   polygons that may be plotted is unlimited. Mark this with the
*                   value of icode (first argument to pplldx_envelope)
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus
*      *kms* 5/12 Always use generic REAL instead of specific SNGL 
*                 (SNGL must have a double-precision or complex argument)
* V695  *acm*  9/15 Changes for hour:min labeling on time axes
* V697  *acm*  1/16 Ticket 2344: if there was a time-plot underlay, use its time scaling

* FERRET 9-21-88: replaced include files to make all declarations explicit
! original:

!	include 'pplinc:parampl5.dat'
!	include 'pplinc:hd.inc'
!	include 'pplinc:lines.inc'
!	include 'pplinc:data.inc'
!	include 'pplinc:axisl.inc'
!	include 'pplinc:taxis.inc'
!	include 'pplinc:cmrdl.inc'
!	include 'pplinc:ppldat.inc'

	include 'parampl5_dat.decl'
	include 'PARAMPL5.DAT'
	include 'hd_inc.decl'
	include 'HD.INC'
	include 'lines_inc.decl'
	include 'LINES.INC'
	include 'taxis_inc.decl'
	include 'TAXIS.INC'
	include 'cmrdl_inc.decl'
	include 'CMRDL.INC'
	include 'data_inc.decl'
	include 'DATA.INC'
	include 'axisl_inc.decl'
	include 'AXISL.INC'
	include 'PPLDAT.INC'

	include 'miss_inc.decl'
	include 'MISS.INC'

* 	Add external stmt for linux port
	external range


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

c
! original:
!	dimension xt(*),yt(*),stop(3),temp(3),start(3)
!	character tstrt*10
!	integer*4 mtmin,tstart,tstop,time,tmin

        REAL pplmem(*)

#ifdef double_p
	REAL*8 xt(*),yt(*), xdt
#else
	REAL xt(*),yt(*), xdt
#endif
	CHARACTER BC2WHOI*14, tstrt*(*), tref*(*)
	REAL*8	WHOI2BC, DIFF, tstart, tstop, time, tmin, off, rate, 
     .		dxmin, dxmax, dymin, dymax, xymin, xymax, dtd
	INTEGER	icode, npts, i, ix, iy
	REAL	xs, ys
	LOGICAL  TM_FPEQ_SNGL
	LOGICAL  flip			!  FERRET mod 10/93

	REAL	    bad_flag
	PARAMETER ( bad_flag = -3.E33 )

	logical	translate 

* end of 9-21 FERRET declaration changes

* mod to SAVE certain variables *jd* 6.5.91
        SAVE        tstart,tmin,tstop

c
	dtd = dt

	if(linen.eq.0)call rsmnmx
	linen=linen+1
	jtype=1
	nx=npts
	ny=1
	flip = itflg .EQ. -1		!  FERRET mod 10/93

	translate = ABS(itflg).eq.1 .AND. itstrt(1:1).NE.' '

* Hack, plot/vs/ribbon on a time axis
	IF (icode .EQ. 7) THEN
	   icode = 2
	   translate = .FALSE.
	ENDIF

	if (translate) then	
c
c	time axis is on.
c ** acm mod 9/01  Compare tref(1:1) rather than just tref. After
c **               passing thru c routine, a blank tref is somehow different??

c    ticket 2344: if there was a time-plot underlay, use its delta-t
	    IF (dt_save .NE. 0) THEN
	       dtd = dt_save
	       dt = dt_save
	    ENDIF

	    if(linen.eq.1)then
		iform='LDX'
		if(iautot.eq.1 .AND. tref(1:1).NE.' ') itstrt=tref(1:14) 
	    endif		
c
c	calculate offset and rate for time data
c
	    off=diff(itstrt,tstrt)/dtd+1.0
	    rate=xdt/dtd
**	else
**	    off=1.0
**	    rate=1.0
	endif
c
c	load data
c

C 8/2015 compute min and max in double precision, then translate

	dxmin=1.0e36
	dxmax=-dxmin
	dymin=dxmin
	dymax=dxmax

	ix=ibase-1
	iy=ix+pplmem_nsize/2
	if(icode.eq.0 .OR. icode.EQ.3) THEN
	    do 100 i=1,npts

	        xs = REAL(xt(i))
	        ys = REAL(yt(i))
	        IF ( flip ) THEN

	          IF ( yeq .AND. TM_FPEQ_SNGL(ys,cmyeq) ) THEN
	             pplmem(iy+i) = bad_flag

		  elseif (translate) then
		     pplmem(iy+i)=(yt(i)-1.0)*rate+off
		  else
		     pplmem(iy+i)=yt(i)
		  endif

	          IF ( xeq .AND. TM_FPEQ_SNGL(xs,cmxeq)) THEN
	             pplmem(ix+i) = bad_flag
	          ELSE
		     pplmem(ix+i)=xt(i)
	          ENDIF

	        ELSE
	          IF ( yeq .AND. TM_FPEQ_SNGL(ys,cmyeq) ) THEN
	             pplmem(iy+i) = bad_flag
	          ELSE
		     pplmem(iy+i)=yt(i)
	          ENDIF

	          IF ( xeq .AND. TM_FPEQ_SNGL(xs,cmxeq) ) THEN
	             pplmem(ix+i) = bad_flag
	          ELSEIF (translate) then
		     pplmem(ix+i)=(xt(i)-1.0)*rate+off
	          ELSE
		     pplmem(ix+i)=xt(i)
		  ENDIF

		ENDIF

		  IF ( .NOT.(xeq .AND. TM_FPEQ_SNGL(xs,cmxeq)) ) THEN
		     dxmin = MIN(dxmin, xt(i))
		     dxmax = MAX(dxmax, xt(i))
		  ENDIF
		  IF ( .NOT.(yeq .AND. TM_FPEQ_SNGL(ys,cmyeq)) ) THEN
		     dymin = MIN(dymin, yt(i))
		     dymax = MAX(dymax, yt(i))
		  ENDIF

100	    continue

            if (flip) THEN
	       IF (translate) then
		   dymin = (dymin-1.0)*rate+off
		   dymax = (dymax-1.0)*rate+off
	       ENDIF
	    ELSE
	       IF (translate) then
		   dxmin = (dxmin-1.0)*rate+off
		   dxmax = (dxmax-1.0)*rate+off
	       ENDIF
	    ENDIF

	else if(icode.eq.1)then
	    do 200 i=1,npts
	        xs = REAL(xt(i))
	        IF ( ( xeq .AND. TM_FPEQ_SNGL(xs,cmxeq) ) ) THEN
	           pplmem(ix+i) = bad_flag
	           pplmem(iy+i) = i     ! 3/00 mod
	           GOTO 200
	        ENDIF
		pplmem(iy+i)=i
	        if (translate) then
		   pplmem(ix+i)=(xt(i)-1.0)*rate+off
	        else
		   pplmem(ix+i)=xt(i)
	        endif
		
	        IF ( .NOT.(xeq .AND. TM_FPEQ_SNGL(xs,cmxeq)) ) THEN
		   dxmin = MIN(dxmin, xt(i))
		   dxmax = MAX(dxmax, xt(i))
	        ENDIF

200	    continue
	else
	    do 300 i=1,npts
	        ys = REAL(yt(i))
	        IF ( ( yeq .AND. TM_FPEQ_SNGL(ys,cmyeq) ) ) THEN
	           pplmem(ix+i) = bad_flag
	           pplmem(iy+i) = bad_flag
	           GOTO 300
	        ENDIF
		if (translate) then
		   pplmem(ix+i)=(float(i)-1.0)*rate+off
	        else
		   pplmem(ix+i)=float(i)
	        endif
		pplmem(iy+i)=yt(i)
		
		IF ( .NOT.(yeq .AND. TM_FPEQ_SNGL(ys,cmyeq)) ) THEN
		   dymin = MIN(dymin, yt(i))
		   dymax = MAX(dymax, yt(i))
		ENDIF
300	    continue
	endif
* FERRET mod 2/89 - replace bad data LIMITS flags
	cmxeq = bad_flag
	cmyeq = bad_flag
c
c	some variable definitions
c
c	tmin    time for xmin (endpoint of this line in minutes since BC)
c	tstop   time for xmax (endpoint of this line in minutes since BC)
c	itmin   earliest tmin for all lines (in WHOI format)
c	itmax   latest  tstop for all lines (in WHOI format)
c	itstart reference start time (if iautot the first lines tstrt) (???)
c

	if(translate)then  		! 11.30.95 WAS:	if(itflg.eq.1)then
		if(itflg.eq.1) then 	! 11.30.95 for both x and y
		   xymin  = dxmin
		   xymax  = dxmax
	        else 			! gotta be -1
		   xymin  = dymin
		   xymax  = dymax
		endif

	    if(linen.eq.1)then
		tstart = WHOI2BC( itstrt )		! t=1 of time axis

		tmin=tstart+(xymin-1.0)*dtd		! start of plot axis
		itmin = BC2WHOI( tmin )

		tstop=tstart+(xymax-1.0)*dtd		! end of plot axis
		itmax = BC2WHOI( tstop )

	    else

		tmin=tstart+(xymin-1.0)*dtd
		tstop=tstart+(xymax-1.0)*dtd

		time = WHOI2BC( itmin )
		if(tmin.lt.time)  itmin = BC2WHOI( tmin )   ! chg. plot start
c
		time = WHOI2BC( itmax )
		if(tstop.gt.time) itmax = BC2WHOI( tstop )   ! chg. plot end
	    endif
	endif
* end of FERRET 9-21 changes
        
	pbuf=1
c 8/2015 Should stmnmx use double precisison xmin,xmax, ...?  Seems ok as single.
	xmin = dxmin
	xmax = dxmax
	ymin = dymin
	ymax = dymax
	call stmnmx(pplmem,pplmem_nsize,xmin,xmax,ymin,ymax)

	lnum = linen
        IF (icode .LE. 2) THEN
           lleng(linen)=npts
 	   if(linen.ge.NPOLYGON)then
	       linen=NPOLYGON - 1
	   else
	       ibase=ibase+lleng(linen)
	   endif
        ELSE
           ibase = ibase + npts
        ENDIF

	return
	end

	SUBROUTINE LABDRW(XF,YF,IFX,IFY)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)labdrw.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
C *acm* v552 3/03 Longer strings and changes for multi-line labels.
* V69+  5/14 *acm* Fix for ascii font in multi-line labels, ticket 2176
* V694  *acm*  1/15 Changes to allow two time axes on plot (F-T)
* V7    *acm* 6/16 Ticket 2434: command qualifiers /DEGMINSEC= /HALFSPAC
*                  DEGMINSEC=1 for Deg-Min axis labels, =2 for Deg-Min-Sec. Default = 1
*                  /HALFSPAC adds a half space between the degree sign and E/W or N/S


	INCLUDE 'PARAMPL5.DAT'
	INCLUDE 'AXIS.INC'
	INCLUDE 'LABELS.INC'
	INCLUDE 'LABCOM.INC'
	INCLUDE 'PLT.INC'
	INCLUDE 'PLTL.INC'
	INCLUDE 'HAB.INC'
	INCLUDE 'LINES.INC'
	INCLUDE 'MPLOT.INC'
	INCLUDE 'TAXIS.INC'
	INCLUDE 'TICS.INC'
	INCLUDE 'TICS2.INC'
	INCLUDE 'AXISL.INC'
	INCLUDE 'AXLWID.INC'

	CHARACTER IFX*(*),IFY*(*)
        INTEGER j, lablen, numlines, slen
        REAL htnew, wid

c        INTEGER lnbeg(500), lnend(500)
c        CHARACTER fontprefix*3, penprefix*3, newfont*3, newpen*3
c        REAL line_spacing

c        line_spacing = 0.4

        lablen = 2048

C	DRAW LABELS
	IF(MAKEP.EQ.'VIEW')GOTO 40
	IF(LABELY.EQ.0.OR.(ITFLG.EQ.-1.OR.ITFLG.EQ.2))GOTO 20

C  Y label. center each line 

        CALL tm_break_lines (ylab, lnbeg, lnend, numlines)

* Adjust x position for multi-line label or when making
* extra space between the degree-sign and N/S or E/W
        IF(LABELY.LT.0.)THEN 
           XL=XLO-(YWID+HYLAB)/XF
           xl = xl - (numlines-1)*hylab/xf
	   IF (ydspac .GT. 0) xl = xl - 0.5*ydspac*hylab/xf
        ELSE
           XL=XHI+(YWID+2.*HYLAB)/XF
        ENDIF

        nfont = 0
        npen = 0
        fontprefix = ""
        penprefix = ""
        DO 10 j = 1, numlines
           CALL getlabfonts (ylab, lnbeg, lnend, j, fontprefix, 
     .           npnew, nfnew, newfont, newpen, nchr)

	   YL=YLO+(YLEN-SYMWID(HYLAB, NCHR+npen+nfont,
     .                 penprefix(1:npen)//fontprefix(1:nfont)//
     .                 ylab(lnbeg(j):lnend(j)) ))*.5/YF

	   CALL SYMBEL(XL, YL, 90., HYLAB, NCHR+npen+nfont,
     .                 penprefix(1:npen)//fontprefix(1:nfont)//
     .                 ylab(lnbeg(j):lnend(j)))

           XL= xl + line_spacing*HYLAB/XF

C  Set up to use any font settings from this line on subsequent lines.

           IF (npnew.GT.0) THEN
              penprefix(1:3) = newpen(1:3)
              npen = 3
           ENDIF
           IF (nfnew.GT.0) THEN
              fontprefix(1:3) = newfont(1:3)
              nfont = 3
           ENDIF

10      CONTINUE


C  X label

20	IF(LABELX.EQ.0.OR.(ITFLG.EQ.1.OR.ITFLG.EQ.2))GOTO 40
        CALL tm_break_lines (xlab, lnbeg, lnend, numlines)

	IF(LABELX.LT.0)THEN
	    YL=YLO-(XWID+2.*HXLAB)/YF
	ELSE
	    YL=YHI+(XWID+HXLAB)/YF
            IF (numlines .GT. 1) yl = yl + 
     .           line_spacing*(numlines-1)* hxlab/yf
	ENDIF

        nfont = 0
        npen = 0
        fontprefix = ""
        penprefix = ""

        DO 30 j = 1, numlines
cc For fixing bug 1582: missing label on horizontal axis. 
cc This crept in with multi-line labels. no need for IF(LABELX.LT.0) here.
cc	IF(LABELX.LT.0)THEN

           CALL getlabfonts (xlab, lnbeg, lnend, j, fontprefix, 
     .           npnew, nfnew, newfont, newpen, nchr)

	   XL=XLO+(XLEN-SYMWID(HXLAB,NCHR+npen+nfont,
     .                 penprefix(1:npen)//fontprefix(1:nfont)//
     .                 xlab(lnbeg(j):lnend(j)) ))*.5/XF

	   CALL SYMBEL(XL,YL,0.,HXLAB, NCHR+npen+nfont,
     .                 penprefix(1:npen)//fontprefix(1:nfont)//
     .                 xlab(lnbeg(j):lnend(j)))

           yl = yl - line_spacing* hxlab/yf

C  Set up to use any font settings from this line on subsequent lines.

           IF (npnew.GT.0) THEN
              penprefix(1:3) = newpen(1:3)
              npen = 3
           ENDIF
           IF (nfnew.GT.0) THEN
              fontprefix(1:3) = newfont(1:3)
              nfont = 3
           ENDIF

cc        ENDIF
30      CONTINUE

C  Main label

40      CALL tm_break_lines (lab1, lnbeg, lnend, numlines)

* Adjust character size for the length of the longest line
* This may have already been done in box_label, but not if
* title was set by a PPL TITLE command.

        htnew = hlab1
        wid = 0.
        DO 330 k = 1, numlines
           slen = lnend(k) - lnbeg(k) + 1
	   wid = MAX(wid, SYMWID(htnew, slen, lab1(lnbeg(k):lnend(k))))
  330   CONTINUE

* xsize in call to box_label is .75* x axis length

        htnew = htnew * MIN(1., 1.25* .75*xlen/wid)

C	Determine starting y position of main label

        ITFLG2=0
        IF(ITFLG.EQ.1.OR.ITFLG.EQ.2)ITFLG2=1
	IF (LABELX .GE. 0) THEN
	  YTEMP = XWID - 1.9*ABS(XCSIZE) + 2.5*htnew
	ELSE
	  YTEMP = XWID + 2.0*HXLAB * (1-ITFLG2)
     .	          + 2.5*htnew
	ENDIF
	YL=YLO-YTEMP/YF

        nfont = 0
        npen = 0
        fontprefix = ""
        penprefix = ""

        DO 50 j = 1, numlines
           CALL getlabfonts (lab1, lnbeg, lnend, j, fontprefix, 
     .           npnew, nfnew, newfont, newpen, nchr)
	   XL=XLO+(XLEN-
     .          SYMWID(htnew,NCHR,lab1(lnbeg(j):lnend(j))))*.5/XF

	   CALL SYMBEL(XL,YL,0.,htnew, NCHR+npen+nfont,
     .                 penprefix(1:npen)//fontprefix(1:nfont)//
     .                 lab1(lnbeg(j):lnend(j)))

           yl = yl - line_spacing* htnew/yf

C  Set up to use any font settings from this line on subsequent lines.

           IF (npnew.GT.0) THEN
              penprefix(1:3) = newpen(1:3)
              npen = 3
           ENDIF
           IF (nfnew.GT.0) THEN
              fontprefix(1:3) = newfont(1:3)
              nfont = 3
           ENDIF
50      CONTINUE

70	RETURN
	END

      SUBROUTINE TAXIS1(TLO,ITIME1,ITIME2,DT,NSMTIC,LABEL,IDDB,IMDB,
     1    TFACT,Y,YFACT,CSIZE,yacross,vgrat,vcolor,vline,color0)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* revised for TMAP
* from PPLUS :
*	Directory PMEL:[PLOT5.PPLV11.PLOTLIB]TAXIS1.FOR

* search for "TMAP" to find all revisions
* *sh*  - 1/23/89 added interrupt detection
*		  ... no explicit declarations (too much trouble !) so it must
*		      be compiled with /WARNINGS=NODECLARATIONS

* *jd* Mod for 4 digit years
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 

C *acm* 24/01/00 Y2k Bug -- Put century at start when comparing 
C                 ITIME to ITIME2 at loop 10
C *acm* 03/04  new arguments and code for plotting graticule lines across plot. 
C V65  *acm*  1/10 New time-axis style for DAY and MONTH, DMY: adds the
C                  year to DAY,MONTH or to MONTH.
* *acm* - 8/16   ticket 1787: restore pen 0 correctly after graticule

C**
C**    @(#)taxis1.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     THIS ROUTINE PLOTS A TIME AXIS AND LABELS IT WITH THE DAY OF THE M
C     AND THE MONTH.
C     VARIBLES:
C         TLO=X VALUE CORRESPONDING TO THE START TIME.
C         ITIME1 = START TIME (IE.  7708190000)
C                  WE RESTRICT THE PERMISSIBLE START TIMES TO BE
C                  EVEN DAYS.  (THAT IS THE LAST 6 DIGITS OF ITIME1
C                  MUST BE 0)
C         ITIME2 = END TIME (IE   7709070000)
C                  THIS IS THE FIRST DAY NOT TO BE PLOTTED, AND IT
C                  MUST BE AN EVEN DAY.
C         DT = SAMPLING RATE IN MINUTES.
C         NSMTIC = NUMBER OF SMALL TICS TO MAKE EACH DAY.
C                = 23 FOR HOURLY TICS.
C                = 11 FOR BIHOURLY TICS.
C                   ETC.
C         LABEL > 0 IF LABELS ARE TO BE DRAWN ABOVE THE AXIS.
C               = 0 IF NO LABELS ARE TO BE DRAWN.
C               < 0 IF LABEL ARE TO BE DRAWN BELOW THE AXIS.
C         IABS(LABEL) = 1 FOR LABELS OF THE STYLE
C                  1..........1..........1..........1..........1
C                       3           4          5        6
C                                      JUN
C         IABS(LABEL) = 2 FOR LABELS OF THE STYLE
C                  1..........1..........1..........1..........1
C                     JUN  3     JUN  4      JUN  5    JUN  6
C         IDDB = PRINT LABELS OF DAYS DIVIBLE BY THIS NUMBER ONLY.
C                IF(IDDB = 0) PRINT NO DAY LABELS.
C         IMDB = PRINT LABELS OF MONTHS DIVISIBLE BY THIS NUMBER ONLY.
C                IF(IMDB = 0) PRINT NO MONTH LABELS.
C                THIS VARIBLE ONLY APPLYS WHEN IABS(LABEL) = 1
C         TFACT = (LENGTH OF T AXIS IN INCHES)/(LENGTH OF T AXIS IN USER
C         Y = Y COORDINATE OF TIME AXIS.
C         YFACT = (LENGTH OF Y AXIS IN INCHES)/(LENGTH OF Y AXIS IN USER
C         CSIZE = SIZE TO DRAW DAY LABELS.
C                 MONTH LABELS WILL BE 1.5 TIMES AS LARGE.
C
C     THERE WAS A MODIFICATION TO THIE IN JUNE 1980.  THE
C     SOLE PURPOSE FOR THIS MODIFICATION WAS TO IMPROVE 'S
C     EFFICIENCY.
C
	CHARACTER ITIME3*14
	CHARACTER SYM*21,ITIME1*(*),ITIME*14,ITIME2*(*),MON*3,DAY*2,
     .		  YEAR*4, BUFF*8
	COMMON/TICS/TSMX,TLX,TSMY,TLY,IX,IY
	COMMON/AXLWID/XWID,YWID

* Parameters for drawing tics across plot

        REAL yacross
        REAL dash1_1, dash1_2, dash1_3, dash1_4
        REAL dash2_1, dash2_2, dash2_3, dash2_4
        REAL vgrat(4,2)        ! line type: 0=tics only, <0=line, >0=dash lengths 
        INTEGER vcolor(*)      ! pen number for graticule lines
	INTEGER color0	       ! pen number to restore 
        LOGICAL vline, do_line   ! If true, do the lines across.
        LOGICAL solid1, solid2   ! solid lines across at tics
        LOGICAL dashed1, dashed2 ! dashed lines across at tics

        INTEGER ltic, color1, color2

	include 'xinterrupt.cmn'
        include 'century.cmn'  ! with MONYRLAB flag
        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'lines_inc.decl'
        include 'LINES.INC'
        INCLUDE 'pen_inc.decl'  ! with IPEN(1)
        INCLUDE 'PEN.INC'

C     CHECK THE PARAMETERS PASSED TO THE SUBROUTINE.
	IF(ITIME1(7:10).NE.'0000')STOP ',1'
	IF(ITIME2(7:10).NE.'0000')STOP  ',1'

C set up for plotting graticules across at tic marks
        
        solid1 = (vgrat(1,1).LT.0 .AND. vgrat(2,1).LT.0 .AND.  
     .            vgrat(3,1).LT.0 .AND.  vgrat(4,1).LT.0 )
        solid2 = (vgrat(1,2).LT.0 .AND. vgrat(2,2).LT.0 .AND.  
     .            vgrat(3,2).LT.0 .AND.  vgrat(4,2).LT.0 )
        dashed1 = (vgrat(1,1).GT.0 .OR. vgrat(2,1).GT.0 .OR.  
     .            vgrat(3,1).GT.0 .OR.  vgrat(4,1).GT.0 )
        dashed2 = (vgrat(1,2).GT.0 .OR. vgrat(2,2).GT.0 .OR.  
     .            vgrat(3,2).GT.0 .OR.  vgrat(4,2).GT.0 )

	do_line = vline

        color1 = vcolor(1)
        color2 = vcolor(2)

        IF (dashed1) THEN
           dash1_1 = vgrat(1,1)
           dash1_2 = vgrat(2,1)
           dash1_3 = vgrat(3,1)
           dash1_4 = vgrat(4,1)
        ENDIF
        IF (dashed2) THEN
           dash2_1 = vgrat(1,2)
           dash2_2 = vgrat(2,2)
           dash2_3 = vgrat(3,2)
           dash2_4 = vgrat(4,2)
        ENDIF

C
C     SET PARAMETERS.

*     *jd Number of arguments of TIME3 calls reduced to 6.  TIME3 uses only
*     the first 6, 'seconds' are not handled.  Done for MAC 7.92

 
      TIC = 1440./DT
      NTIC = NSMTIC + 1
	IF(NSMTIC.LT.0)THEN
		IHVY=-8
		INML=-7
	ELSE
		IHVY=-9
		INML=-8
		TDIST = TIC/NTIC
	ENDIF
	IF(LABEL+IX.EQ.0)THEN
		YTEMP=0.0
	ELSE
		YTEMP=TLX*0.5
	ENDIF
	IF(IDDB.NE.0)THEN
	FIDDB=0.0
	ELSE
	FIDDB=-1.4
	ENDIF
      IF(LABEL.LT.0) THEN
      YTEMP1=Y-(1.4*CSIZE+YTEMP)/YFACT
      YTEMP2=Y-((4.0+FIDDB)*CSIZE+YTEMP)/YFACT
      ELSE
      YTEMP1=Y+(0.4*CSIZE+YTEMP)/YFACT
      YTEMP2=Y+((2.5+FIDDB)*CSIZE+YTEMP)/YFACT
      ENDIF
	IF(LABEL.NE.0)XWID=(4.0+FIDDB)*CSIZE+YTEMP

      CALL PLOT(TLO,Y,0,0)
	IF(IDAY.EQ.1)THEN
	   CALL PLOTT7(TLO,Y,TFACT,YFACT,1,IHVY)
	ELSE
	   CALL PLOTT7(TLO,Y,TFACT,YFACT,1,INML)
	ENDIF

      T=TLO
      ITIME=ITIME1
      CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
      TMON=T

c ----  count number of large tics. If no large tics will be drawn
c ----  then will want to draw graticule lines at the small ones.

C      LOOP like loop 10 below
      ltic = 0
  110 CONTINUE
      IF ( interrupted ) RETURN		! TMAP interrupt
      
      CALL TIME1(1,ITIME,2,' ',I3,ITIME3,1440.)
      CALL TIME3(ITIME3,IYR3,IMON3,IDAY3,IHR3,IMIN3,ISEC3,ICEN3)

      ITIME=ITIME3
      IF(ITIME(13:14)//ITIME(1:12) .LT. 
     .       ITIME2(13:14)//ITIME2(1:12) ) THEN
         IF (IDAY3.EQ.1) ltic = ltic + 1  !It is a large tic.
         GO TO 110
      ENDIF

! IF no large tics, and if graticules at just the large tics were
! requested, then plot graticules at the small tics

      IF (ltic .EQ. 0) THEN   
           IF ( (.NOT.solid2) .AND. (solid1) ) THEN
              solid2 = solid1
              color2 = color1
           ENDIF
           IF ( (.NOT.dashed2) .AND. (dashed1) ) THEN 
              dashed2 = dashed1
              dash2_1 = dash1_1
              dash2_2 = dash1_2
              dash2_3 = dash1_3
              dash2_4 = dash1_4
              color2 = color1
           ENDIF
      ENDIF

      ITIME=ITIME1
      CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)

c ----

C      LOOP:
   10     CALL PLOT(T,Y,0,0)
	  IF ( interrupted ) RETURN		! TMAP interrupt

*    do not draw a graticule line along the upper axis
	  do_line = ( ITIME3(13:14)// ITIME3(1:10).LT.
     .	              ITIME2(13:14)//ITIME2(1:10)) 

          DO 20 I=1,NSMTIC
              CALL PLOTT7(T+FLOAT(I)*TDIST,Y,TFACT,YFACT,1,-7)
              

                 IF ((solid2.OR.dashed2) .AND. do_line) THEN ! make line across
                    CALL COLOR(color2)
                    IF (dashed2) THEN
                       CALL DASHSZ(dash2_1,dash2_2,dash2_3,dash2_4)
                       CALL DASHES
                    ENDIF
                    CALL PLOT(T+FLOAT(I)*TDIST,y,0,0) 
                    CALL PLOT(T+FLOAT(I)*TDIST,yacross,1,0)
                    CALL PLOT(T+FLOAT(I)*TDIST,Y,0,0) 
                    CALL COLOR(color0)
                    CALL VECTRS
                 ENDIF

   20         CONTINUE
          CALL TIME1(1,ITIME,2,' ',I3,ITIME3,1440.)
          CALL TIME3(ITIME3,IYR3,IMON3,IDAY3,IHR3,IMIN3,ISEC3,ICEN3)	
	  
*    do not draw a graticule line along the upper axis
	  do_line = ( ITIME3(13:14)// ITIME3(1:10).LT.
     .	              ITIME2(13:14)//ITIME2(1:10)) 

          IF(IDAY3.EQ.1)THEN
	      CALL PLOTT7(T+TIC,Y,TFACT,YFACT,1,IHVY)
               
                 IF ((solid1.OR.dashed1) .AND. do_line) THEN ! make line across
                    CALL COLOR(color1)
                    IF (dashed1) THEN
                       CALL DASHSZ(dash1_1,dash1_2,dash1_3,dash1_4)
                       CALL DASHES
                    ENDIF
                    CALL PLOT(t+tic,y,0,0) 
                    CALL PLOT(t+tic,yacross,1,0)
                    CALL PLOT(t+tic,Y,0,0) 
                    CALL COLOR(color0)
                    CALL VECTRS
                 ENDIF

	ELSE

              IF ((solid2.OR.dashed2) .AND. do_line) THEN ! make line across
                 CALL COLOR(color2)
                 IF (dashed2) THEN
                    CALL DASHSZ(dash2_1,dash2_2,dash2_3,dash2_4)
                    CALL DASHES
                 ENDIF
                 CALL PLOT(t+tic,y,0,0) 
                 CALL PLOT(t+tic,yacross,1,0)
                 CALL PLOT(t+tic,Y,0,0) 
                 CALL COLOR(color0)
                 CALL VECTRS
              ENDIF
	      CALL PLOTT7(T+TIC,Y,TFACT,YFACT,1,INML)

	ENDIF
C         THE LABELS
         CALL TIME3(ITIME,IYR,IMON,IDAY,IHR,IMIN,ISEC,ICEN)
         IF(IDDB.EQ.0.OR.LABEL.EQ.0) GO TO 50
         IF(IDAY.NE.IDDB*(IDAY/IDDB)) GO TO 50
             CALL TIME2(ITIME,SYM)
	READ(SYM,30) MON,DAY
30	FORMAT(6X,A3,1X,A2,1X,A4)
	IF(DAY(1:1).EQ.' ')THEN
		NC=1
		DAY=DAY(2:2)
	ELSE
		NC=2
	ENDIF
	IF(IABS(LABEL).EQ.1)THEN
        TSYM=T+(TIC-SYMWID(CSIZE,NC,DAY)/TFACT)*.5
        CALL SYMBEL(TSYM,YTEMP1,0.,CSIZE,NC,DAY)
	ELSE
	WRITE(SYM,40)MON,DAY
40	FORMAT(A3,' ',A2)
        TSYM=T+(TIC-SYMWID(CSIZE,6,SYM)/TFACT)*.5
        CALL SYMBEL(TSYM,YTEMP1,0.,CSIZE,6,SYM)
	ENDIF
   50   CONTINUE
          IF(IMDB.EQ.0.OR.IABS(LABEL).NE.1) GO TO 70
              IF(IMON.EQ.IMON3) GO TO 70
              IF(IMON.NE.IMDB*(IMON/IMDB)) GO TO 60
C             ELSE:
	IF(T-TMON.GT.4320./DT)THEN
           CALL TIME2(ITIME,SYM)
           READ(SYM,30)MON,DAY,YEAR
           IF (monyrlab) THEN
	      WRITE (buff, 100) mon, year
 100	      FORMAT (A3, ' ', A4)
              TSYM=TMON+(T+TIC-TMON-SYMWID(1.5*CSIZE,8,BUFF)/TFACT)*.5
	      CALL SYMBEL(TSYM,YTEMP2,0.,1.5*CSIZE,8,buff)
	   ELSE
              TSYM=TMON+(T+TIC-TMON-SYMWID(1.5*CSIZE,3,MON)/TFACT)*.5
	      CALL SYMBEL(TSYM,YTEMP2,0.,1.5*CSIZE,3,MON)
	   ENDIF
	ENDIF
   60         TMON=T+TIC
   70     CONTINUE
          ITIME=ITIME3
          T=T+TIC
c          IF(ITIME.LT.ITIME2) GO TO 10

          IF(ITIME(13:14)//ITIME(1:12) .LT. 
     .       ITIME2(13:14)//ITIME2(1:12) ) GO TO 10
	     IF(IMDB.EQ.0) RETURN

*     Draw complete time axis
          CALL PLOT(TLO,Y,0,0)
          CALL PLOT(T,Y,1,0)

	     
	IF(IABS(LABEL).EQ.1.AND.IMON.EQ.IMDB*(IMON/IMDB)
     .	.AND.IDAY3.GE.4)THEN
           CALL TIME2(ITIME,SYM)
	   READ(SYM,30)MON,DAY, year
           IF (monyrlab) THEN
	      WRITE (buff, 100) mon, year
              TSYM=TMON+(T+TIC-TMON-SYMWID(1.5*CSIZE,8,BUFF)/TFACT)*.5
	      CALL SYMBEL(TSYM,YTEMP2,0.,1.5*CSIZE,8,buff)
	   ELSE
              TSYM=TMON+(T+TIC-TMON-SYMWID(1.5*CSIZE,3,MON)/TFACT)*.5
	      CALL SYMBEL(TSYM,YTEMP2,0.,1.5*CSIZE,3,MON)
	   ENDIF
     	ENDIF
      RETURN
      END

*
* zaxreplace_zlev.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* august 2004
* V580:10/04 *acm* Fix for bug 1037. Before the loop calling hunt_r4,
*                  set the initial guess for nsrc_lo to 1 not 0.  
*       4/06 *acm* as an external function this file included hunt_r4
*                  from the Ferret code. Linking this statically, no need
*                  for this any more.*
*
*
* Replace Z axis, where input Z axis is layer and 
* second argument is layer thickness
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE zaxreplace_zlev_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CHARACTER*100 descr

      CALL ef_set_desc(id,
     .        'regrid V onto Z axis of ZAX based on layer thickness')
      CALL ef_set_num_args(id, 3)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_num_work_arrays(id, 1)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'V')
      CALL ef_set_arg_desc(id, arg,
     .        'Variable on native Z axis')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, NO, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'THICKNESS')
      WRITE (descr, 20)
   20 FORMAT ('Thickness corresponding to input Z axis layers ',
     .        'in units of output Z axis')
      CALL ef_set_arg_desc(id, arg, descr)
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'ZAX')
      CALL ef_set_arg_desc(id, arg,
     .        'Variable with desired Z (depth) axis points')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, YES, NO, NO, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE zaxreplace_zlev_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER nz
      INTEGER iwork

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nz = 1 + ABS(arg_hi_ss(Z_AXIS,ARG2) - arg_lo_ss(Z_AXIS,ARG2))

*  zdepth
      iwork = 1
      CALL ef_set_work_array_dims_6d(id, iwork,
     .                                1, 1, 1, 1, 1, 1,
     .                               nz, 1, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE zaxreplace_zlev_compute(id, arg_1, arg_2, arg_3,
     .                                   result, zdepth)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz,
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* Ignore the Y/Z/T/E/F dimensions in the work arrays since
* they are not used and Fortran is column major
      REAL zdepth(wrk1lox:wrk1hix)

* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable''s axes.

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, l1, m1, n1
      INTEGER i2, j2, l2, m2, n2
      INTEGER i3, j3, l3, m3, n3
      INTEGER nsrc_lo, klo, khi
      REAL sum, lasthalf, frac, zval, zmin, zmax

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      klo = arg_lo_ss(Z_AXIS, ARG2)
      khi = arg_hi_ss(Z_AXIS, ARG2)

*
*  Loop over x,y,t,e,f of the input fields
*
      n1 = arg_lo_ss(F_AXIS,ARG1)
      n2 = arg_lo_ss(F_AXIS,ARG2)
      n3 = arg_lo_ss(F_AXIS,ARG3)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

      m1 = arg_lo_ss(E_AXIS,ARG1)
      m2 = arg_lo_ss(E_AXIS,ARG2)
      m3 = arg_lo_ss(E_AXIS,ARG3)
      DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

      l1 = arg_lo_ss(T_AXIS,ARG1)
      l2 = arg_lo_ss(T_AXIS,ARG2)
      l3 = arg_lo_ss(T_AXIS,ARG3)
      DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

      j1 = arg_lo_ss(Y_AXIS,ARG1)
      j2 = arg_lo_ss(Y_AXIS,ARG2)
      j3 = arg_lo_ss(Y_AXIS,ARG3)
      DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

      i1 = arg_lo_ss(X_AXIS,ARG1)
      i2 = arg_lo_ss(X_AXIS,ARG2)
      i3 = arg_lo_ss(X_AXIS,ARG3)
      DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

* Compute depths at this location and time. Depth coordinate is at
* half of the current grid cell, plus half of the previous grid cell.
         sum = 0.0
         lasthalf = 0.0
         DO 310 k = klo, khi
            IF ( arg_2(i2,j2,k,l2,m2,n2) .NE. bad_flag(ARG2) ) THEN
               sum = sum + lasthalf + 0.5 * arg_2(i2,j2,k,l2,m2,n2)
               lasthalf = 0.5 * arg_2(i2,j2,k,l2,m2,n2)
            ENDIF
* If there are any layer thickness, fill the end of the array with
* the sum of thicknesses up to the deepest.
            zdepth(k) = sum
  310    CONTINUE

         zmin = zdepth(klo)
         zmax = zdepth(khi)

* For each z line interpolate.
*        set to one instead of zero
*        fixes bug where we got no match if zval equals first point in axis
         nsrc_lo = 1

         DO 390 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

            IF ( sum .EQ. 0.0 ) THEN

               result(i,j,k,l,m,n) = bad_flag_result

            ELSE

* ... next Z axis value (arg3) to locate
               zval = arg_3(i3,j3,k,l3,m,n3)

* ... search the Z field (arg_2) for the index just below this value
* ... note that nsrc_lo is always referenced to a starting index of 1
               IF ( (zval .LT. zmin) .OR. (zval .GT. zmax) ) THEN
                  frac = -999.0
               ELSE
                  CALL HUNT_R4 (zdepth,1,khi,zval,nsrc_lo,frac)
               ENDIF

* ... interpolate data arg_1 field to get result
               IF ( frac .LT. 0.0 ) THEN

* ... no luck -- the Z axis value we seek is outside the range in com2
                  result(i,j,k,l,m,n) = bad_flag_result

               ELSEIF ( arg_1(i1,j1,nsrc_lo,l1,m1,n1)
     .                              .EQ. bad_flag(ARG1) ) THEN

                  result(i,j,k,l,m,n) = bad_flag_result

               ELSEIF ( frac .EQ. 1.0 ) THEN         ! exactly on point

                  result(i,j,k,l,m,n) = arg_1(i1,j1,nsrc_lo,l1,m1,n1)

               ELSEIF ( arg_1(i1,j1,nsrc_lo+1,l1,m1,n1)
     .                              .EQ. bad_flag(ARG1) ) THEN

                  result(i,j,k,l,m,n) = bad_flag_result

               ELSE

                  result(i,j,k,l,m,n) =
     .                        frac  * arg_1(i1,j1,nsrc_lo,  l1,m1,n1) +
     .                  (1. - frac) * arg_1(i1,j1,nsrc_lo+1,l1,m1,n1)

               ENDIF

            ENDIF  ! IF ( sum .EQ. 0.0 ) THEN
 390        CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
         i2 = i2 + arg_incr(X_AXIS,ARG2)
         i3 = i3 + arg_incr(X_AXIS,ARG3)
 100  CONTINUE

         j1 = j1 + arg_incr(Y_AXIS,ARG1)
         j2 = j2 + arg_incr(Y_AXIS,ARG2)
         j3 = j3 + arg_incr(Y_AXIS,ARG3)
 200  CONTINUE

         l1 = l1 + arg_incr(T_AXIS,ARG1)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
         l3 = l3 + arg_incr(T_AXIS,ARG3)
 400  CONTINUE

         m1 = m1 + arg_incr(E_AXIS,ARG1)
         m2 = m2 + arg_incr(E_AXIS,ARG2)
         m3 = m3 + arg_incr(E_AXIS,ARG3)
 500  CONTINUE

         n1 = n1 + arg_incr(F_AXIS,ARG1)
         n2 = n2 + arg_incr(F_AXIS,ARG2)
         n3 = n3 + arg_incr(F_AXIS,ARG3)
 600  CONTINUE

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN
      END

	SUBROUTINE TM_NOTE ( string, lunit )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* display a warning message to the operator

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* revision 0.0 2/92 for TMAP library (from FERRET rouitine "WARN")
* *sh* 2/28/95 - allow message to be sent to alternative location
* *js* 12.12.97- changed to use tm_split_list
* 1/03 - *kob* g77 port - Need to use risc_buff for arbitrary concatenations
* 12/13 *sh* - enhancement to support multi-line outputs in one call by
*	embedding pCR characters into string as line separators
*       Note that the Ferret stack of output calls could use some cleanup since
*	Ferret lib routines call TMAP_FORMAT lib TM_SPLIT_MESSAGE which in turn
*	calls back into Ferret lib to SPLIT_LIST
*	WRITE_MULTI is a Ferret lib routine that has the functionality we need.
*	But it calls TM_SPLIT_MESSAGE. By calling it here we add to the mess 

* calling argument declarations:
        INTEGER lunit
	CHARACTER*(*)	string

* internal variable declarations:
	INTEGER		TM_LENSTR1, slen

#ifdef unix
	include 'xalt_messages.cmn_text'
	include 'xrisc_buff.cmn'
#else
	INCLUDE 'TMAP_FORMAT:XALT_MESSAGES.CMN'
#endif

* string length
	slen = TM_LENSTR1( string )

* do it
	IF ( alt_messages ) THEN
	   CALL TM_ALTERNATE_NOTE( string, lunit )
	ELSE
c	   WRITE ( lunit, 3000 ) string(:slen)
c 3000	   FORMAT ( ' *** NOTE: ',A )
	   risc_buff = string
	   CALL WRITE_MULTI(lunit, ' *** NOTE: '//risc_buff)
	ENDIF

	RETURN
	END

      subroutine day_of_year(amo, ada, ayr, status, err_msg)

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
C  ACM 
C  Find sequential day of the year corresponding to month, day, year. 
C  Return sequential day in variable ada.
C  4/2001  *ACM* add error message
C   3/12   *kms* remove leap day from appropriate century years

      IMPLICIT NONE

      REAL daymo(12)           ! Number of days in each month
      DATA daymo/31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31/
      REAL amo, ada, ayr
      INTEGER iyr, imo, i, status
      CHARACTER*(*) err_msg

      status = 0
      iyr = ayr
      IF ( (MOD(iyr, 400) .EQ. 0) .OR.
     .     ( (MOD(iyr, 4) .EQ. 0) .AND. 
     .       (MOD(iyr, 100) .NE. 0) ) ) THEN
         daymo(2) = 29
      ENDIF

      imo = amo
      IF (imo .LT. 1  .OR.  imo .GT. 12) THEN
         WRITE (err_msg,*) 'Month less than 1 or greater than 12', imo
         GO TO 1000
      ENDIF

      IF (ada .LT. 0  .OR. ada .GT. daymo(imo)) THEN
         WRITE (err_msg,10) ada, imo
   10    FORMAT ('Day ', F4.0, ' out of range for month', I3)
         GO TO 1000
      ENDIF

      DO 100 i = 1, imo-1
         ada = ada + daymo(i)
  100 CONTINUE

      daymo(2) = 28  ! value otherwise incorrectly saved
      RETURN

1000  status = 1
      daymo(2) = 28  
      RETURN
      END

 	SUBROUTINE XEQ_DEFINE

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute the DEFINE command

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 9/22/87
* revision 1.0 - 7/27/88 - added DEFINE GRID and DEFINE AXIS code
* revision 1.1 - 8/31/88 - added DEFINE VIEWPORT
* revision 1.2 -11/21/88 - new TM library: FIND_LIKE_GRID-->TM_FIND_LIKE_GRID
*					   TRANSFER_GRID --> TM_COPY_GRID
*					   READ_GRIDFILE --> TM_READ_GRIDFILE
*					         UNIT_ID --> TM_UNIT_ID
*					  FIND_LIKE_AXIS -->TM_FIND_LIKE_LINE
*                                       FIND_LINE_NUMBER --> TM_GET_LINENUM
*					      BREAK_DATE --> TM_BREAK_DATE
*			using TM_FIND_LINE_SLOT and TM_FIND_GRID_SLOT
*			and include files XUNITS and XGRID are from TMAP_FORMAT
* revision 1.3 - 1/15/89 - changed default T0 for time axes from 1-JAN-1800 to
*			   15-JAN-1901 for PPLUS WHOI format limitations
* V200:  6/29/89 - reordered lo/hi_ss arguments
*		 - added DEFINE VARIABLE
*		 - DEFINE AX: allow calendar time axis using time steps
*		 - added DEFINE AXIS/FROM_VARIABLE
*		 - DEFINE AXIS&GRID check for legal name
*		 - DEFINE VARIABLE accepts infix notation
*	 3/19/90 - fixed logic bugs when redefining axes and grids
*		 - eliminated warnings for duplicated definitions
*	 3/22/90 - don't check axis units if units are unknown
*	 4/24/90 - DEFINE VAR bug for var names of >8 chars
*	  5/2/90 - DEFINE REG/DX= name tried to work from cx_last instead of
*		   previous region "name"
* Unix/RISC 3/12/91 (incidental) LET/TITLE now preserves lower case letters
*                - DEFINE GRID/FILE=name changed to case sensitive name
* V230:   6/8/92 - added DEFINE ALIAS (bug fixes 7/29)
*         7/6/92 - added DEFINE AXIS/DEPTH (units="m" used to determine up/dn)
*        7/24/92 - bug fix: DEFINE REGION was behaving like /DEFAULT always
*                - delete uvars and uvar grids when @ regions are redefined
*       10/22/92 - added units on uvars
*       11/12/92 - added qualifiers /TEXT, /XLIMITS, /YLIMITS to DEFINE VIEW
*                  and made it auto-scale the axes
*	 3/29/93 - restore the old-style functioning of DEFINE VIEW/SIZE
* V300:  4/22/93 - fix handling of enclosing quotes on DEFINE ALIAS
* V301:	11/03/93 - added DEFINE AXIS/NPOINTS
*	11/25/93 - bug fix: DEFINE AXIS/FROM/T0= expr
*	 1/19/94 - added DEFINE VARIABLE/QUIET
* V313:  ?? *kob* - IBM port shortened a couple lines and removed a couple tabs
*	11/06/94 *sh* - inserted the bug fixes that had already been made in
*		   the checked out version of this routine as follows:
* V320: 5/94 - array "memory" as a calling argument
*	8/94 - replaced calls to TM_FIND_LINE_SLOT and TM_FIND_GRID_SLOT with
*		ALLO_MANAGED_GRID/AXIS to that deleted slots would be reused
* V320: 12/29/94 - use SPLIT_LIST to redirect tty output for GUI
* V400:  6/22/95 - added DEFINE SYMBOL name = value
* V420:  7/95 - Added support for  LET/D=dset var = ...
*	 11/95 - check to see if DEFINE AXIS/FROM actually has REGULAR points
*	       - default for T0 set at start of start century (not always 1900)
*	  2/96 - allow color to separate lo/high viewport limits (bug 2/12)
*	  2/96 - fixed bug introduced 11/96. Code used a non-existent variable
*		 called "regular" which was not caught by the compiler
*      2/29/96 - bug: same var name couldn't be used in multiple dsets
*	  4/96 - bug: tabs around "=" not handled right in LET A = expr
* V430:7/10/96 - allow axes with units that contradict their orientations
*		 Issue a warning
*Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
* V450:  11/96 - Using reformulated version of INIT_UVAR (RPN not called
*		 from here). Part of changes to support external function.
*	  1/97 - Issue warning if DEFINE AXIS/UNIT=MONTH is used
*       - add check on cx_calendar rather than cx_lo/hi_ww to indicate whether time
*         is date or timesteps
* V491+ - 7/98 *sh* - allow case-sensitive var name in DEFINE GRID/LIKE=varname
* V500 - 4/16/99 *sh* use DELETE_USER_VAR to delete old definition when uvar
*	name is redefined ... else child vars to not get removed
*	 4/20/99 *sh* added DEFINE AXIS/EDGES
*	 4/28/99 *sh* allow DEFINE AXIS with repeated values -> microadjust
*	 7/99 *sh* - changed def'n of "month" so change warning message
* V510 - 8/99 *sh* - allow DEFINE GRID /LIKE=user_var /X=user_var (bump use
*			counts on dynamic axes
*	12/99 *sh* - allow new syntax DEFINE AXIS name=expression
*			infer units from formatted (say) X=130e:80W
*		and use routine name_equal_string in multiple places
*	2/00 *sh* - on LET cmnd when replacing an existing variable definition
*		allow for possible child vars ==> delete old BEFORE init_uvar
*		is called on new
*	3/00 *sh* - remove backslash escape characters from DEFINE SYMBOL
*	     *sh* - allow automatic generation of T0=1-jan-0000
*	4/00 *sh* - set use counts when defining grids and axes
*	5/00 *sh* - support for LET/BAD=
* V530: *sh* 9/00 - added initial data type support in get_cmnd_data 
* v530  *acm* 2/01 - DEFINE AXIS/CALENDAR  calendar name for alternative 
*                    calendar types.
*	*sh* 4/01 - bug fix: DEFINE AXIS/FROM_DATA must check if n=1
* V531: *sh* 5/01 - changed text of "unknown axis units" message
*		  - during DEFINE GRID defer purging duplicate-name grid
*		    until after new static one is defined -- else dynamic
*		    axes that are needed can get wiped out
*	*sh* 6/01 - increase buff1 size for DEFINE AXIS/LIKE=expr
* V540:	*sh* 9/01 - added DEFINE VIEWPORT/AXES
* V540: *acm*12/01 -bug fix: consolidate arguments broken up by command parser 
*                   back into a single arg with call to all_1_arg
* V541: *acm*8/02  Changes to recover line_mem storage when irregular
*                  axis is cancelled; redefine line_mem pointer before 
*                  call to purge_mr_axis.
* V542: *sh* 7/02 - added support for sub-span modulo axes
* V550: *acm*10/02- Change reg_name to char*24, to match cx_name
* V551: *acm*  2/03 - On DEFINE AXIS/x name=expr, only reset num_args when
*                     the expression is a const array {  }  (fixes bug w/ more
*                     complex expr, for example "DEF AX/X  xax = a/2 + b/2")
* 2/03 *kob* - g77 port - g77 won't allow intrinsic functions in PARAMETER
*                         statements.  use an character constant instead 
* v552: *acm* 4/03 Bug Fix: checking length of variable name. Length now 128
* V553  *acm* 6/03 Use 'XX' or 'YY' for line_direction for non-lat/lon axes. 
* v554 *acm* 11/03 reg_name had NOT been changed to *24, to match cx_name
* v554 *acm* 11/03 Adjust definition of npoints, checking to see if the upper
*                  limit of the axis is include in the upper grid box. (bug 673)
* v554 *acm* 11/03 def axis/units=yr  was not the same as def axis/units=year
*                  Change this so yr and year mean a year in whatever calendar 
*                  we are using.
* v554 *acm* 3/4   The adjustment in definition of npoints needs fuzzy comparison
*                  not strict .GE. (under g77 linux)
* V570 *acm* 5/04  Add the calendar name 365_DAY as equivalent for NOLEAP, and add 
*                  the calendar ALL_LEAP = 366_DAY.
* V570 *acm* 5/05  Changes for CF bounds 
*                  syntax for user-specified bounds:
*                  DEFINE AXIS/X/BOUNDS xax={1,2,5}, {0.5,1.5,1.5,3,3,6}
*                  DEFINE AXIS/Z/BOUNDS zax=zcoord,zbnd
* V580 *acm* 10/05 correct misspelling in statement 5582
* V580 *acm* 11/04 Use cx_cal_id to keep track of which calendar used
*                  when cx_lo_ww and cx_hi_ww are computed.
* V581 *acm*  3/05 Catch case where errors in def axis/start:lo:del, before
*                  trying to call RESET_SECS_FROM_BC (bug1203)
* V581 *acm*  5/05 For OPeNDAP HDF files, do not check whether axis name is legal.
*                  If it was given in quotes, skip the quotes when finding it in
*                  the list of axis names.
* V600 *acm* 3/06  fixing bugs 439&1390, new arg to get_new_cx.
* V600 *acm* 3/06  Fix bug 1400: Add more convenient syntax for user-specified bounds:
*                  Bounds can be either 2*N or N+1 values, or three lists of length N:
*                  coords, lo_bound, hi_bound
*                  DEFINE AXIS/X/BOUNDS xax={1,2,5}, {0.5,1.5,3,6}
*                  DEFINE AXIS/Z/BOUNDS zax=zcoord, zbnd
*                  DEFINE AXIS/Z/BOUNDS zax={1,2,5}, {0.5,1.5,3}, {1.5,3,6}
*                  
* V600 *acm* 3/06  Fix bug 1401: See the comment: a single point is always "regular" --
*                  causes incorrect treatment of the axis if the axis has BOUNDS!!
* V600 *acm*  8/05 DEFINE ATTRIBUTE[/type=][/D=] varname[d=].attname = <numeric scalar or 
*                  vector, or string>
* V600 *acm*  9/06 Fixes to bug 1443; tm_check_bnds is changed so it works differently
*                  for a regular axis. Here we need to set line_regular to false when
*                  defining the axis from data. It may later be set to true if the data is
*                  in fact regular.
* V601 *acm* 9/06  fixing bug 1439 long symbol values; change length of err_string to 2048
* V601 *acm*11/06 Fix bug 1470: on a DEFINE AXIS command which is redefining an axis, change
*                 values in the attribute structure for the axis.
* V602  2/07 *acm* Fix bug 1492, changing attributes of coordinate variables 
* V603  5/07 *acm* Fix bug 1511: if DEFINE AXIS or DEFINE ATT change a time
*                  origin, include the origin in the units attribute as "since t0"
*                  If units attribute is changed for a time axis, get the time
*                  origin if it exists and append it to the units string.
* V606  8/07 *acm* DEFINE AXIS/QUIET
* V606  8/07 *acm* Send informational and error messages that are returned from 
*                  commands via SPLIT_LIST to std error rather than std out.
* V62   2/09 *acm* Pass the original upper/lowercase spelling of user-defined variable
*                  names to init_uvar; name to be saved in the attribute structure, for 
*                  use when writing out user-defined variables when MODE UPCASE_OUTPUT 
*                  is cancelled.
* V62 *acm*  2/09 - Save original upper/lowercase spelling of axis names 
*                   in line_name_orig for CANCEL MODE UPCASE
* V62 *acm*  3/09  Fix bug 1645: Define an axis with a very large number of NPOINTS.
*                  This works if the value of NPOINTS can be specified as an integer.
* V64 *acm* 11/09  Fix to bug 1511 slightly wrong: dont use line_t0 from
*                  a previous definition of a time axis.
* V65 *acm*  2/10  Minor change to error message
* V664  8/10 *kms* Add DEFINE PYFUNC /NAME=<alias> python.module.name
* V67   1/11 *acm* User-defined attributes are set to /OUTPUT=1  by default.
*                  Write the calendar attribute, even if its the default Gregorian
* V68 *acm* 1/12   Use the same micro-adjusting scheme as we are implementing for 
*                  reading netCDF files (ticket 1910). Reset micro-adjust size if needed.
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction. 
* V68  *acm* 5/12  Add DEFINE DATA/AGGREGATE
* V683 *acm*11/12  If DEFINE AXIS data not monotonic, add the index location 
*                  to the error message
* V685 *acm* 1/13  Fix ticket 2026: dont automatically mark a 1-point longitude
*                  axis as modulo.
* V685 *adm*  1/13 DEFINE VARIABLE/REMOTE. Require /D= to accompany /REMOTE.
* V685 *acm*  4/13 Add /HIDDEN on DEF DATA/AGG
* V685 *acm* 10/13 Fix ticket 2096, DEFINE GRID with check on units
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long
* V687 *acm*  1/14 Fixing ticket 2135; grid_use_cnt on DEFINE DATA/AGG datasets
* V690 *sh*   1/14 Formatting improvement to DEFINE ATTRIB error message
* V693+ 11/14 *sh* renaming 'sigma' as 'layerz' throughout
*                  prevent IF, ELIF, ELSE, and ENDIF from being aliased
* V695  *acm* 2/15 cx_calendar stores info about calendar formatting of T and F axes
* V695+  *sh* 4/15 error msgs from INIT_AGGREGATE_SET already given.  Remove.
* V695  *acm* 6/15 Change the error message when coordinates are decreasing.
* V695  *acm* 6/16 New subcommand DEFINE ANNOTATION
* V695 *acm*  9/15 Fix #2317: length of name sent to FIND_DSET_NUMBER
* V695 *sh*  10/15 add DEFINE DATA/AGG/T
*                  rename routine INIT_AGGREGATE_DSET to INIT_EF_AGGREGATE_DSET
* V697 12/15 *acm* Fix ticket 2336: consistent application of CAN MODE UPCASE
* V698 1/16 *sh*   Allow DEFINE DATA/AGG w/out a name -- auto-name from script
* V698 2/16 *acm*  For ticket 1786: if mode_upcase is canceled write axis name
*                  using original upper/lowercase spelling
* V698  2/16 *acm* For ticket 2352: variables defined with LET/D are
*                  added to that dataset in the attribute structure.
*       3/16 *sh*  bug fix use GO_FILE rather than LAST_GO_FILE as AGG name
* V698  4/16 *acm* Fix ticket 2380: use /T0 to indicate a T axis, only if 
*                  direction is otherwise undefined.
* V698  4/16 *acm* Allow DEFINE VAR/BAD=nan
* V698  4/16 *acm* Fix ticket 2400: DEFINE AXIS/EDGES had bugs in testing for
*                  regular axis, and in setting the axis start when regular.
* V698  5/16 *acm* for ticket 1432, could write a note when axis definition is a 
*                  supbspan modolo axis with length almost the modulo length.
*                  (commented out for now.)
* V698  5/16 *acm* Ticket 2416 allow all output types for DEFINE ATT.
* V7    5/16 *acm* See ticket 2352. For LET/D variables look for info under that dataset
* V7   *acm*  6/12 Add Union aggregations: DEFINE DATA/AGG/U
* V710 12/16 *acm* Ticket 2158: working with true monthly time axes.
*                  Add DEFINE AXIS /MONTHLY /LIKE=
* V710  4/16 *acm* new TM_UNITS_CAL to account for calendar in units id
* V702 12/16 *acm* handling modulo true-month axes added after merge back to trunk.
* V7022 1/17 *acm* ticket 2497, Back off the auto-detection of monthly axes.
* 1/13/2017 *acm* Do the repeated-coordinates checking in the new routine
*                 TM_CHECK_COORDS, also called by cd_get_1_axis, to consistently
*                 handle almost-equal coordinates, differing by machine precision.
* 1/24/2017 *acm* Ticket 2504: If Ferret is computuing axis bounds, set them such 
*                 that the axis lies within the given modulo length.

	include	'tmap_errors.parm'
#	include	"tmap_dset.parm"
	include	'tmap_dims.parm'
	include 'xunits.cmn_text'
	external xunits_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'rpn.parm'
	include 'gfdl_vms.parm'	
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xtext_info.cmn'
	include 'xcommand.cmn'
        include 'xgrid_chg_fcns.cmn'
	include 'xinterrupt.cmn'
	include 'calendar.decl'
	include 'calendar.cmn'	
        include 'netcdf.inc'
        include 'xrisc.cmn'


* local parameter declarations:
	INTEGER	    slash_dflt,
     .		    slash_file,
     .		    slash_like,
     .		    slash_units,
     .		    slash_x0,
     .		    slash_t0,
     .		    slash_name,
     .		    slash_from,
     .		    slash_depth,
     .		    slash_modulo,
     .		    slash_npoints,
     .		    slash_edges,
     .		    slash_calendar,
     .		    slash_monthly,
     .		    slash_def_ax_like,
     .		    slash_text,
     .		    slash_xlimits,
     .		    slash_ylimits,
     .		    slash_size,
     .		    slash_origin,
     .		    slash_clip,
     .		    slash_let_title,
     .		    slash_let_units,
     .		    slash_let_quiet,
     .		    slash_let_dset,
     .		    slash_let_bad,
     .		    slash_let_remote,
     .		    slash_define_vp_by_ax,
     .              slash_bounds,
     .              slash_def_att_type,
     .              slash_def_att_dset,
     .              slash_def_att_output,
     .              slash_def_att_quiet,
     .              slash_def_ax_quiet,
     .              slash_pyfunc_name,
     .              slash_def_aggregate,
     .              slash_def_agg_title,
     .              slash_def_agg_quiet,
     .              slash_def_agg_t,
     .              slash_def_agg_e,
     .              slash_def_agg_f,
     .              slash_def_agg_hide,
     .              slash_def_annot_nlab,
     .              slash_def_agg_u

	LOGICAL	    explct_defn
	PARAMETER ( slash_dflt   = 1 + 12,
     .		    slash_file   = 1 + 6,
     .		    slash_like   = 1 + 7,
     .		    slash_units  = 1 + 7,
     .		    slash_x0     = 0,	! slash_x minus 1
     .		    slash_t0     = 1 + 8,
     .		    slash_name	 = 1 + 9,
     .		    slash_from	 = 1 + 10,
     .		    slash_depth	 = 1 + 11,
     .		    slash_modulo = 1 + 12,
     .		    slash_npoints= 1 + 13,
     .		    slash_edges  = 1 + 14,
     .		    slash_calendar = 1 + 15,
     .		    slash_bounds = 1+16,
     .		    slash_def_ax_quiet = 1+17,
     .		    slash_monthly= 1 + 18,
     .		    slash_def_ax_like  = 1+19,
     .		    slash_text   = 1 + 0,
     .		    slash_xlimits= 1 + 1,
     .		    slash_ylimits= 1 + 2,
     .		    slash_size   = 1 + 3,
     .		    slash_origin = 1 + 4,
     .		    slash_clip   = 1 + 5,
     .		    slash_let_title  = 1 + 0,
     .		    slash_let_units  = 1 + 1,
     .		    slash_let_quiet  = 1 + 2,
     .		    slash_let_dset   = 1 + 3,
     .		    slash_let_bad    = 1 + 4,
     .		    slash_let_remote = 1 + 5,
     .		    slash_define_vp_by_ax = 1 + 6,
     .              slash_def_att_type    = 1 + 1,
     .              slash_def_att_dset    = 1 + 0,
     .              slash_def_att_output  = 1 + 2,
     .              slash_def_att_quiet   = 1 + 3,
     .              slash_pyfunc_name = 1,
     .              slash_def_aggregate = 1 + 0,
     .              slash_def_agg_t     = 1 + 4,
     .              slash_def_agg_e     = 1 + 5,
     .              slash_def_agg_f     = 1 + 6,
     .              slash_def_agg_title = 1 + 7,
     .              slash_def_agg_quiet = 1 + 8,
     .              slash_def_agg_hide  = 1 + 9,
     .              slash_def_agg_u     = 1 + 10,
     .              slash_def_annot_nlab = 10,		! must be slash_annotate_siz+1
     .		    explct_defn  = .FALSE. )

* calling argument declarations:

* local variable declarations:

	LOGICAL	  TM_DIGIT, TM_LEGAL_NAME, TM_LINE_MATCH, TM_GRID_MATCH,
     .		  TM_FPEQ, TM_DFPEQ, TM_CHECK_BNDS, MATCH_NAME,
     .            NC_GET_ATTRIB, TM_LEGAL_NAME_OP, TM_HAS_STRING,
     .            ITSA_1LINEIF, MATCH4, GO_FILE_INPUT, IS_AGG_MEMBER, 
     .            MATCH_TEMPLATE, TM_ITS_SUBSPAN_MODULO,
     .            dup_name, delta_given, create, irreg, its_reg, its_edges, 
     .            its_calendar, its_modulo, has_repeated, has_bounds,
     .            new_att, new_att_modulo, got_it, orient_t, agg_quiet,
     .            letdset, its_remote, agg_hide, def_att_quiet, purge_all,
     .            user, norm, nouser, t_regular, use_strict, have_expr, 
     .            original, true_month, line_allocated, truemonth_noted,
     .            is_double, misordered, bnds_or_edges, okmod
	INTEGER   REGION_NUMBER, GRID_FROM_NAME, VIEWPORT_NUMBER, STR_UPCASE,
     .		  CX_DIM_LEN, ALIAS_ID,
     .		  TM_GET_LINENUM, TM_LENSTR1, 
     .		  TM_GET_GRIDNUM, TM_UNIT_ID, TM_UNITS_CAL, 
     .		  ALLO_MANAGED_AXIS, ALLO_MANAGED_GRID, FIND_DSET_NUMBER,
     .            TM_GET_CALENDAR_ID, STR_SAME,
     .		  tmap_status, npoints, i, 
     .		  status, idim, vax_code, islot, iunit, iline, cat, var,
     .		  orient, mods_cx, cx, mr, n, i1, i2, i3, i4, i5, i6, pos,
     .		  grid, iqual, ax_grid, ivp, qp, iseg, uvar, dset, slen, s1,
     .		  old_line, old_grid, frst_pt, dim(nferdims), ndim, natom,
     .		  at_type  (maxatoms), at_id  (maxatoms),
     .		  at_start (maxatoms), at_end (maxatoms), cal_id, 
     .            dflt_cal_id, nmonths, ndays, d_before_mon(12), 
     .            mon_by_d(366), d_in_mon(12), len_cal, n2, n3, s2len,
     .            prev_cal_id, j, num_indices, varid, attype_spec,
     .            attoutflag, attlen, coordvar, 
     .            dset_to_add, dir, type, attype, attid, ibuff, i0,  
     .            agg_dim, nagfiles, ivar, item, nlab, ierr, nlen,  
     .            llen, line, dstart, units, npts, ipt1, ipte

	REAL	  rbuff, bad_flag, yeardays, 
     .            val, dummy, val_buf, xloc, yloc, halign, angle, size,
     .            epsilon

	REAL*4	  r4_unspec, scale, xlovp, ylovp,  xhivp, yhivp,
     .            xoei,  yoei,   xcei,  ycei
	REAL*8	  SECS_FROM_BC, TM_WW_AXLEN,
     .		  bc_to_t0, start, new_ww, delta, end, secs2start,
     .            micro_adj, axwwlen, rmod_len, secsperyear, small, 
     .            new_att_modulo_len, madj, firs_coord, last_coord, timefac
	CHARACTER TM_FMT*16, TM_CLEAN_FILENAME*512,SECS_TO_DATE_OUT*11,
     .            reg_name*24, buff1*128, buff2*512, buff3*512, 
     .            buffsym*120, cal_name*32, buff*512,
     .            basic_orients(nferdims)*2, err_string*2048, replmsg*24,
     .		  mon_names(12)*3, varname*512, attname*128, t2*2,
     .            new_att_units*128, new_att_calendar*128,
     .            new_att_t0*128, dcode*2, axdir*1, t0string*128, 
     .            ustring*128, reserved_flow_name(3)*4, is_nan*3,
     .            buff4*16, buff5*16, datestr*11, likename*64

        CHARACTER*1 tab
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
#else
	PARAMETER     ( tab = CHAR(9))
#endif

	DATA	  basic_orients / 'WE','SN','UD','TI','E','F' /,
     .		  replmsg/'Replacing definition of '/
        DATA      reserved_flow_name / 'ELIF','ELSE','ENDI' /

* statement function - value between 0 and 1
	REAL x, vx, vy
	LOGICAL OUTSIDE_0_1
	OUTSIDE_0_1( x ) = x.LT.0.0 .OR. x.GT.1.0

* select subcommand
	GOTO ( 100,200,300,400,500,600,700,800,900,1000,1100,1200 ) subcmnd_num

* DEFINE  '    ' - (no action)
* arrival at this point usually means an illegal subcommand was given
* and was assumed to be an argument by the command parser
 100	IF ( num_args .GE. 1 ) THEN
	   CALL ERRMSG( ferr_invalid_subcmnd, status,
     .			cmnd_buff( arg_start(1):arg_end(1) ), *5000 )
	ELSE
	   CALL ERRMSG( ferr_invalid_command, status,
     .			'DEFINE what ?', *5000 )
	ENDIF

**************************************************************************
* DEFINE REGION
* ... command syntax ok ?
 200	IF ( num_args .EQ. 0 ) THEN
	   CALL ERRMSG( ferr_invalid_command, status,
     .			'DEFINE what region ?', *5000 )
	ENDIF

* get the name of the region to be defined
	reg_name = cmnd_buff(arg_start(1):arg_end(1))

* is this region already defined ?
	islot = REGION_NUMBER( reg_name )
        create = islot .EQ. unspecified_int4

* delta context specifiers (DX=,DY=, etc), if any
	CALL GET_DELTA_CONTEXT( 14, delta_given, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

	IF ( delta_given .AND. .NOT.create ) THEN
* modify a previously defined region
* minor bug: normal non-delta location qualifiers are ignored in this case
	   CALL TRANSFER_CONTEXT( islot, cx_buff )
	   CALL APPLY_DELTA_CONTEXT( cx_buff, reg_name, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000

	ELSE
* assemble the context based on the last command context
	   CALL GET_NEW_CX( cx_last, cx_buff, .TRUE., status )
	   IF ( status .NE. ferr_ok ) GOTO 5000

* ... apply delta limits to the default from last command
	   IF ( delta_given ) THEN
	      CALL APPLY_DELTA_CONTEXT( cx_buff, 'DEFAULT', status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
	   ENDIF

* ... if this region was not previously defined find a slot
	   IF ( create ) THEN
	      DO 240 islot = 0, min_context, -1
	         IF ( cx_name(islot) .EQ. unspecified_name4 ) GOTO 245!fix 7/92
 240	      CONTINUE
* ... no free slots
	      CALL ERRMSG( ferr_prog_limit,status,
     .			   'Cancel or redefine a region',*5000 )
	   ENDIF

* ... if "/DEFAULT" was implied or given then flag for saving all dimensions
*     that are defined
 245       IF ( num_qualifiers .EQ. 0 
     .     .OR. qual_given( slash_dflt ) .GT. 0 ) THEN
	      DO 210 idim = 1, nferdims
	         IF (cx_by_ss(idim,cx_buff)
     .		   .AND. cx_lo_ss(cx_buff,idim) .NE. unspecified_int4
     .	        .OR..NOT.cx_by_ss(idim,cx_buff)
     .		   .AND. cx_lo_ww(idim,cx_buff) .NE. unspecified_val8)
     .				cx_given( idim, cx_buff ) = .TRUE.
 210	      CONTINUE
* ... else flag only the dimensions named
	   ENDIF
	ENDIF

* all unmodified axes must be set to unspecified
	DO 230 idim = 1, nferdims
 230	IF ( .NOT.cx_given(idim,cx_buff) ) CALL DEL_CX_DIM( idim, cx_buff )

* LET-defined variables may involve now-redefined @regions so wipe out
* previously computed values and grids that may be obsolete(7/92)
        IF ( .NOT.create ) THEN
           CALL PURGE_ALL_UVARS
           CALL DELETE_ALL_UVAR_GRIDS
        ENDIF

* save it for posterity
 	CALL TRANSFER_CONTEXT( cx_buff, islot )
	cx_name( islot ) = reg_name
	RETURN

**************************************************************************
* DEFINE GRID
* ... DEFINE GRID/X/Y/Z/T/E/F /FILE /LIKE
 300	iqual = qual_given( slash_file )
	IF ( iqual .GT. 0 ) THEN
* ... note "err_string" is used to save space - this is not an error
	   CALL EQUAL_STR_LC( cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .			      err_string, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   CALL TM_READ_GRIDFILE( err_string, tmap_status )
	   IF ( tmap_status .NE. merr_ok ) GOTO 5305
	   RETURN
	ENDIF

* DEFINE GRID gridname - what is "gridname" ?
	IF ( num_args .NE. 1 ) GOTO 5300

* must be a unique name
	vax_code = STR_UPCASE( buff3, cmnd_buff(arg_start(1):arg_end(1)) ) 
	IF ( .NOT.TM_LEGAL_NAME(buff3) ) GOTO 5100
	old_grid = TM_GET_GRIDNUM( buff3 ) 
	dup_name = old_grid .NE. unspecified_int4
	IF (dup_name .AND. old_grid .GT. max_grids ) GOTO 5310

* was a /LIKE= given ? ... set up a grid template
	iqual = qual_given( slash_like )
	IF ( iqual .GT. 0 ) THEN
	   CALL EQUAL_STR_LC( cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .			      buff1, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   grid = GRID_FROM_NAME( buff1, cx_last, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   CALL TM_COPY_GRID( grid, mgrid_buff )
	ELSE
	   DO 310 idim = 1, nferdims
	      grid_line    (idim, mgrid_buff) = mnormal
              grid_out_prod(idim, mgrid_buff) = .TRUE.
 310	   CONTINUE	
	   grid_rotation( mgrid_buff ) = 0.0
	ENDIF

* axes named with /X=line_grid_or_var, /Y= ...
	DO 320 idim = 1, nferdims
	   iqual = qual_given( idim )
	   IF ( iqual .GT. 0 ) THEN
	      CALL EQUAL_STRING( cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .				 buff1, status )
	      IF ( status .NE. ferr_ok ) RETURN
	      iline = TM_GET_LINENUM( buff1 )
	      IF ( iline .NE. unspecified_int4 ) THEN
* ... line given by name - don't allow inappropriate units
 	         orient_t = idim.EQ.t_dim .OR. idim.EQ.f_dim
		 iunit = line_unit_code ( iline )
 	         IF ( iunit.NE.0 ) THEN
 	            IF ( (  orient_t .AND.
     .		     (iunit.LT.pun_1st_time .OR. iunit.GT.pun_last_time) )
     .	            .OR. (  (.NOT.orient_t) .AND.
     .		     (iunit.LT.pun_1st_len  .OR. iunit.GT.pun_last_len ) )
     .	            .OR. (  idim.EQ.z_dim .AND.
     .	              iunit.EQ.pun_degrees )     ) GOTO 5330
	         ENDIF
	         grid_line(idim, mgrid_buff) = iline
	      ELSE
* ... line implied through grid or variable name
	         ax_grid = GRID_FROM_NAME( buff1, cx_last, status )
	         IF ( status .NE. ferr_ok ) RETURN
	         IF ( ax_grid .EQ. unspecified_int4 ) GOTO 5320
	         grid_line(idim, mgrid_buff) = grid_line( idim, ax_grid )
	      ENDIF
	   ENDIF
 320	CONTINUE

* check for repeated definitions and illegal redefinitions
	IF ( dup_name ) THEN
	   IF ( TM_GRID_MATCH( old_grid,mgrid_buff ) ) THEN
	      RETURN					! dup name/dup def
	   ENDIF
	ENDIF

* find a slot to store the new grid
	status = ALLO_MANAGED_GRID( grid )
	IF ( status .NE. merr_ok ) GOTO 5000

* save the grid and name it (8/99 - also bump use counts of dynamic axes)
 340	CALL TM_COPY_GRID_W_LINE_USE( mgrid_buff, grid )
	grid_name( grid ) = buff3

* purge old duplicate-name grid.  We deferred until after new static grid
* was defined so new dynamic axes weren't wiped out
	IF ( dup_name ) THEN
* ... redefinition makes all past assumptions incorrect
	   CALL SPLIT_LIST(pttmode_ops, err_lun,
     .			replmsg//'grid '//grid_name(old_grid), 0)
	   CALL PURGE_MR_GRID( old_grid, status )
	   IF ( status .NE. merr_ok ) GOTO 5000
* ... deallocate dynamic axes used in previous definition of this grid
	   DO 350 idim = 1,nferdims
	      CALL TM_DEALLO_DYN_LINE( grid_line(idim,old_grid) )
 350	   CONTINUE
	   grid_name( old_grid ) = char_init16
	ENDIF

	RETURN

**************************************************************************
* DEFINE VARIABLE
* find name to define
* 2 syntaxes are allowed: "DEFINE VAR NAME=TEXT", "DEFINE VAR NAME TEXT"
* in the latter be careful that "TEXT" may contain "="
 400	purge_all = .FALSE.  ! initialize
        IF ( num_args .LT. 1 ) GOTO 5300
	CALL NAME_EQUAL_STRING( buff1, pos, status )
	CALL NAME_EQUAL_STRING_LC( varname, pos, status )
	IF ( status .NE. ferr_ok )  GOTO 5000
	IF ( pos .EQ. 0 ) GOTO 5400
	IF ( .NOT.TM_LEGAL_NAME(buff1) ) GOTO 5410
	IF ( .NOT.TM_LEGAL_NAME_OP(buff1) ) GOTO 5430
        IF ( TM_LENSTR1(buff1) .GT. 128 ) GOTO 5410
	CALL FIND_VAR_NAME ( pdset_irrelevant, buff1, cat, var )
	IF (  var .NE. munknown_var_name
     .	.AND. cat .EQ. cat_pseudo_var    ) GOTO 5420

* /D=xxx: has the user requested a data-set-specific definition?
	iqual = qual_given( slash_let_dset )
	letdset = ( iqual .GT. 0 ) 
	IF (letdset) THEN
	   CALL EQUAL_STRING( cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .			      buff3, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   IF ( buff3 .EQ. ' ' ) THEN
	      dset = pdset_irrelevant	! "/D", alone for default-to-dset
	      buff3 = 'No current data set'	! ... for error reporting
	      IF ( dset .EQ. unspecified_int4) GOTO 5470
	   ELSE
	      dset = FIND_DSET_NUMBER( buff3 )
	      IF ( dset .EQ. unspecified_int4) GOTO 5470
	   ENDIF
	ELSE
	   dset = unspecified_int4
	ENDIF

* title given ?  (preserves lower case via EQUAL_STR_LC 3/91)
	buff3 = ' '
	iqual = qual_given( slash_let_title )
	IF ( iqual .GT. 0 ) THEN
	   CALL EQUAL_STR_LC( cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .			      buff3, status )
	   IF ( status .NE. ferr_ok ) RETURN
	ENDIF

* units given ?
	buff2 = ' '
	iqual = qual_given( slash_let_units )
	IF ( iqual .GT. 0 ) THEN
	   CALL EQUAL_STR_LC( cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .			      buff2, status )
	   IF ( status .NE. ferr_ok ) RETURN
	ENDIF

* bad flag given ?
	iqual = qual_given( slash_let_bad )

* acm 4/16 - allow /bad=NaN
	IF ( iqual .GT. 0 ) THEN

           CALL EQUAL_STRING (cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .                         is_nan, status)
           IF ( status .NE. ferr_ok ) RETURN     ! *sh* 1/14 added status check
           IF (is_nan .EQ. ' ') GOTO 5400
           IF (TM_HAS_STRING(is_nan, 'NaN')) THEN
              CALL SET_NAN(bad_flag)
           ELSE
              CALL EQUAL_VAL(  cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .                     bad_flag, status )
              IF ( status .NE. ferr_ok ) RETURN
           ENDIF

	   IF ( status .NE. ferr_ok ) RETURN
	ELSE
	   bad_flag = bad_val4
	ENDIF

* LET/REMOTE ?

	its_remote = .FALSE.
	iqual = qual_given( slash_let_remote )
	IF ( iqual .GT. 0 ) THEN
	   IF (.NOT. letdset) GOTO 5480
	   its_remote = .TRUE.
	ENDIF

* break the expression into atoms and identify them

        t2 = cmnd_buff(pos:pos+1)
        IF (t2 .EQ. '..') cmnd_buff(pos:pos+1) = 'aa'
	CALL ALG_BREAK_UP( cmnd_buff(pos:len_cmnd),at_start,at_end,natom,
     .			   err_string,status )
        cmnd_buff(pos:pos+1) = t2

	IF ( status .NE. ferr_ok ) GOTO 5440

* cannot use [d= in the remote var-- the expression is evaluated on the
* remote server; same dsets not open there.
	IF (its_remote.AND. TM_HAS_STRING(cmnd_buff(pos:len_cmnd), 'd=') )
     .                                                         GOTO 5490

	CALL ALG_ID( cmnd_buff(pos:len_cmnd), natom, at_start, at_end,
     .		     at_type, at_id, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* if this definition replaces a variable of the same name in this data set
	IF ( dset .GT. pdset_irrelevant ) THEN
	   CALL FIND_VAR_NAME ( dset, buff1, cat, var )
* ... purge cached calculations (8/95)
	   IF ( cat .EQ. cat_file_var
     .	  .AND. var .NE. munknown_var_name ) CALL PURGE_ALL_UVARS
* ... purge any aggregations that utilize this dataset as a member
*     Note: this is a little stricter than need be, as there is a
*     chance that the specific variable may not be a member of the agg, even
*     though the dataset is.  But this will be a rare situation ...
*     ... arguments i and got_it are ignored
           IF (IS_AGG_MEMBER(dset, 1, i, got_it)) CALL PURGE_DSET(dset)
	ENDIF

* if this is a global foreground definition that replaces any variable
* then purge cached calculations (8/95)
	IF ( dset .EQ. unspecified_int4 ) THEN
	   CALL FIND_VAR_NAME ( dset, buff1, cat, var )
	   IF ( var .NE. munknown_var_name ) CALL PURGE_ALL_UVARS
	ENDIF

* do we need to delete a previous definition of this same-named var ?
* Note: need to purge old defs ALSO if the same name is now redefined in a 
*	new data set -- expressions using this name chg interpretation  
*	DO 410 i1 = 1, max_uvar
*	   IF ( uvar_num_items(i1) .EQ. uvar_deleted ) GOTO 410
*	   vax_code = STR_CASE_BLIND_COMPARE( uvar_name_code(i1), buff1 )
*	   IF ( vax_code .EQ. vms_str_success ) THEN
        CALL string_array_find_caseblind(uvar_name_code_head,
     .                                   buff1,
     .                                   LEN(buff1),
     .                                   string_array_result(1),
     .                                   max_uvar,
     .                                   num_indices)        
        DO 410 j = 1, num_indices
              i1 = string_array_result(j)
              IF ( uvar_num_items(i1) .EQ. uvar_deleted ) GOTO 410
* ... delete only if same name in same data set
	      IF ( uvar_dset(i1) .EQ. dset ) THEN
	         CALL DELETE_USER_VAR(i1, dset)
	      ENDIF
* ... reuse of name  makes all stored uvars possibly invalid
*     Also invalidates any memory-cached results that used aux of this name
	      purge_all = .TRUE.
*	   ENDIF
 410	CONTINUE

* if this name is used as the target of an aux (curvilinear) coordinate var
* (re)defining it may invalidate cached results
        CALL GET_FVARS_LIST_BY_ATTNAME_AND_VAL
     .	  (patnam_layerz, buff1, max_uvar,
     .     string_array_result, deleted_list_result, num_indices)
        purge_all = purge_all .OR. (num_indices .GT. 0)
        IF (.NOT.purge_all) THEN
           CALL GET_UVARS_LIST_BY_ATTNAME_AND_VAL
     .	        (patnam_layerz, buff1, max_uvar,
     .           string_array_result, deleted_list_result, num_indices)
           purge_all = purge_all .OR. (num_indices .GT. 0)
        ENDIF

* purge user variables and aux var dependencies if needed
        IF (purge_all) CALL PURGE_ALL_UVARS !not done above for pdset_irrelevan


* now file the expression in the user-defined variable area
	CALL INIT_UVAR ( buff1, cmnd_buff(pos:len_cmnd), buff3, buff2, dset,
     .			 bad_flag, explct_defn, uvar,
     .			 at_type, at_id, at_start, at_end,
     .			 natom, 1, len_cmnd-pos+1, varname, 
     .			 its_remote, status )
	IF ( status .NE. ferr_ok ) RETURN

* is there at least one slot blank ?
	DO 430 i1 = 1, max_uvar
 430	IF ( uvar_num_items(i1) .EQ. uvar_deleted ) RETURN

* no - not allowed to fill the last slot !
*	uvar_num_items(uvar) = uvar_deleted
        CALL deleted_list_modify(uvar_num_items_head, uvar,
     .                       uvar_deleted )
	CALL ERRMSG( ferr_prog_limit, status,
     .		'too many user-defined variables'//pCR//
     .		'cancel or redefine some variables', *5000 )

**************************************************************************
* DEFINE AXIS
* ... /FILE=
 500	IF ( qual_given( slash_file ) .GT. 0 ) GOTO 300 ! like DEFINE GRID/FILE

* initialize	
	buff2 = ' '

* DEFINE AXIS - what is "axisname" ?
	iqual = qual_given( slash_name )
	IF ( iqual .GT. 0 ) THEN
	   CALL EQUAL_STRING( cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .			      buff3, status )
	   CALL EQUAL_STR_LC( cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .			      varname, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   pos = arg_start(1)	! cmnd arg is the expression to eval
	ELSE	   
	   IF ( num_args .LT. 1 ) GOTO 5300
	   CALL NAME_EQUAL_STRING( buff3, pos, status )
	   CALL NAME_EQUAL_STRING_LC( varname, pos, status )

	   IF ( status .NE. ferr_ok )  GOTO 5000

	   IF ( pos .GT. 0 ) THEN

* consolidate arguments broken up by command parser back into a single arg
              IF (cmnd_buff(pos:pos) .EQ. '{') THEN
                 CALL ALL_1_ARG
	         num_args = 1	 ! used by GET_CMND_DATA
              ENDIF
	      arg_start(1) = pos ! skip over "name ="
	   ELSE
	      CONTINUE ! pos=0 signals that no expression was given
	   ENDIF
	ENDIF

* DEFINE AXIS - modulo ?
	iqual = qual_given( slash_modulo )
        new_att_modulo = .FALSE.
        new_att_modulo_len = -1.
	its_modulo = iqual .GT. 0 
	IF ( its_modulo ) THEN
           new_att_modulo = .TRUE.
	   CALL EQUAL_VAL( cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .			      rbuff, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   IF (rbuff .EQ.  unspecified_val4) THEN
	      rmod_len = 0.0D0
	   ELSE
	      rmod_len = ABS(rbuff)  ! ABS to tolerate negatives
              new_att_modulo_len = rmod_len
	   ENDIF
	ELSE
	   rmod_len = 0.0D0
	ENDIF


* is this to be a regular or irregular definition?
	irreg = qual_given(slash_name) .GT. 0
     .	  .OR. (qual_given(slash_name) .EQ. 0
     .		.AND. pos .GT. 0)	! /NAME=XXX or "NAME= expression"

* must be a unique name
c	IF ( .NOT.TM_LEGAL_NAME( buff3 ) ) GOTO 5100
        slen = TM_LENSTR1( buff3)
        s1 = 1
        IF (buff3(1:1) .EQ. "'" .AND. buff3(slen:slen) .EQ. "'") THEN
           s1 = 2
           slen = slen - 1
        ENDIF
	old_line = TM_GET_LINENUM( buff3(s1:slen) )
	dup_name = old_line .NE. unspecified_int4

* get the X,Y,Z,T,E,F regions
	CALL STACK_PTR_UP ( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	mods_cx = cx_stack_ptr
	CALL INIT_CONTEXT_MODS( mods_cx )
	CALL GET_CONTEXT_MODS (	cx_last,
     .				cmnd_buff,
     .				mods_cx,
     .				max_qual_list,
     .				num_qualifiers,
     .				qual_start,
     .				qual_end,
     .				unknown_qual_ok,
     .				status	)
	IF ( status .NE. ferr_ok ) GOTO 5000

* /LIKE

	line_allocated = .FALSE.

	iqual = qual_given( slash_def_ax_like )
	IF ( iqual .GT. 0 ) THEN
	  
	   i1 = STR_UPCASE(likename,cmnd_buff(item_start(i):item_end(i)))
*  ... first look in the static lines
	   DO line = 1, max_lines
	      IF ( interrupted ) CALL ERRMSG
     .			( ferr_interrupt, status, ' ', *5000 )
	      IF ( line_name(line) .EQ. char_init16 ) CYCLE 
	      IF ( line_name(line)(1:1) .EQ. '(' ) CYCLE 
	      IF (MATCH_TEMPLATE(line_name(line),likename)) GOTO 450
 	   ENDDO 

*  ... then the dynamic lines
              line = 0
 435          CALL TM_NEXT_DYN_LINE( line, *440)
                 IF ( interrupted ) CALL ERRMSG
     .			( ferr_interrupt, status, ' ', *5000 )
                 IF (MATCH_TEMPLATE(line_name(line),likename)) GOTO 450
	         GOTO 435
 440          CONTINUE
           GOTO 5760
 450	   CONTINUE

* find a space to catalog it
	   status = ALLO_MANAGED_AXIS( iline )
	   IF ( status .NE. merr_ok ) GOTO 5000
	   line_allocated = .TRUE.

* copy the line definition
	   CALL TM_COPY_LINE ( line, iline )

	ENDIF

* orientation must be uniquely defined

	orient = unspecified_int4
	DO 510 idim = 1, nferdims
	   IF ( qual_given(slash_x0+idim) .GT. 0 ) THEN   !!!!!!!!
	      IF ( orient .NE. unspecified_int4 ) GOTO 5510
	      orient = idim
	   ENDIF
 510	CONTINUE

	IF ( irreg  .AND. orient.EQ.unspecified_int4) THEN
* ... orientation may be inferred from clues if irregular coord syntax is used
*     (Tkt 2380: only if direction undefined - may already know its a T or F axis)
	    IF ( qual_given(slash_depth) .GT. 0 ) orient = z_dim
	    IF ( qual_given(slash_T0)    .GT. 0 ) orient = t_dim
	ENDIF
        IF ( qual_given(slash_depth) .GT. 0
     . .AND. orient .NE. z_dim            ) GOTO 5505

* if orientation is unclear then assume it is X
	IF ( orient .EQ. unspecified_int4 ) THEN
	   CALL WARN (
     .	     "Orientation not specified via /X,/Y,/Z,.... X assumed.")
	   orient = x_dim
	ENDIF
	orient_t = orient.EQ.t_dim .OR. orient.EQ.f_dim

* release context stack space
	CALL STACK_PTR_DN ( cx_stack_ptr, cx_stack_ptr_base, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* /EDGES?
	its_edges =  qual_given( slash_edges ) .GT. 0

* /BOUNDS?
	has_bounds =  qual_given( slash_bounds ) .GT. 0
        IF (has_bounds .AND. its_edges) GOTO 5730

	bnds_or_edges = has_bounds .OR. its_edges

* is it a calendar axis definition?
	its_calendar =  orient_t .AND. cx_calendar(orient,mods_cx)

* /MONTHLY - set the true_month flag, time axes only. (what about F axes?)
	true_month = qual_given( slash_monthly ) .GT. 0

	IF (true_month .AND. orient.NE.t_dim) GOTO 5820

* /UNITS = DEGREES,METERS, ... SECONDS (or supply defaults)
        buff1 = ' '
        new_att_units = ' ' 
	iqual = qual_given( slash_units )
	IF ( iqual .GT. 0 ) THEN
	   CALL EQUAL_STRING( cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .			      buff1, status )
	   IF ( status .NE. ferr_ok ) RETURN
           new_att_units = buff1

	ELSEIF ( cx_formatted(orient)
     .	   .AND. (orient.EQ.x_dim .OR. orient.EQ.y_dim) ) THEN
	   buff1 = 'degrees'	! infer from input like "X=130E:80W"
	ELSEIF ( orient_t
* 8/97 *kob* use cx_calender to check if time is date rather than time step
     .  .AND.  (  qual_given( slash_t0 ) .GT. 0
     .		.OR. cx_calendar(orient,mods_cx))) THEN
	    IF ( .NOT. true_month ) buff1 = 'HOURS'
	ELSE
	   buff1 = 'NONE'
	ENDIF

* /MONTHLY

	timefac = 1.
	IF ( true_month ) THEN
	   IF (qual_given(slash_units) .GT. 0) THEN
	      IF (STR_SAME(buff1,      ' '   ) .EQ. 0 .OR.
     .		  STR_SAME(buff1(1:4), 'NONE') .EQ. 0 .OR.
     .		  STR_SAME(buff1(1:3), 'MON' ) .EQ. 0) THEN
	         buff1 = 'TRUMONTH'
	      ELSE
	         GOTO 5770
	      ENDIF
	   
	   ENDIF

* Do not allow /BOUNDS, /NPOINTS, irregular, 

	   IF (has_bounds) GOTO 5780 
	   IF (irreg) GOTO 5790

* maybe later allow def axis/monthly/npoints=120/t0=1-jan-2001.  Not allowed now.
	   IF (qual_given(slash_npoints) .GT. 0) GOTO 5800

* Check that any delta given in /t=LO:HI:DELTA has value of 1
* Should be able to handle that...

	   delta = cx_delta (orient,mods_cx)
	   IF ( delta.EQ.unspecified_val8 .OR. delta.LE.0.D0) GOTO 5810

	   buff1 = 'TRUMONTH'

* Edges is implied.  Issue a note if they didn't give /EDGES
	   
	   truemonth_noted = .FALSE.
	   IF (.NOT. its_edges) THEN
	      CALL WARN ('True monthly axis has an implicit /EDGES qualifier')
	      truemonth_noted = .TRUE.
	   ENDIF
	   its_edges = .TRUE.
	   
* Will use a default if t0 not given

	   IF (qual_given( slash_T0 ) .EQ. 0) THEN
	      IF (its_calendar) THEN 
	         CALL WARN (
     .          'True monthly axis, T0 not specified. Using start of first year of axis')
	      ELSE
	         CALL WARN (
     .          'True monthly axis, T0 not specified. Using 01-jan-0000')
	      ENDIF
	      truemonth_noted = .TRUE.
	   ENDIF

	ENDIF

* *acm* other calendar names* /CALENDAR = GREGORIAN, NOLEAP, JULIAN, 360_DAY, ALL_LEAP
*       Gregorian is the default, also may be called STANDARD.
*       NOLEAP may also be called 365_DAY.
*       ALL_LEAP may also be called 366_DAY

        cal_name = 'GREGORIAN'		! default
        new_att_calendar = " "
        dflt_cal_id = TM_GET_CALENDAR_ID (cal_name)
	iqual = qual_given( slash_calendar )
	IF ( iqual .GT. 0 ) THEN
	   CALL EQUAL_STRING( cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .			      cal_name, status )
	   IF ( status .NE. ferr_ok ) RETURN
           new_att_calendar = cal_name
	ELSEIF ( orient_t  .AND.  
     .         ( qual_given(slash_T0) .GT. 0  .OR. 
     .           cx_calendar(orient,mods_cx)) ) THEN
	   cal_name = 'GREGORIAN'
	ENDIF

* 9/01 CF conventions have adopted the name 360_day for a 360-day year.

        IF (cal_name .EQ. '360') cal_name = '360_DAY' 
        IF (cal_name .EQ. 'D360') cal_name = '360_DAY' 
        IF (cal_name .EQ. 'STANDARD') cal_name = 'GREGORIAN' 
        IF (cal_name(1:6) .EQ. 'COMMON') cal_name = 'NOLEAP' 
        IF (cal_name(1:6) .EQ. '365_DA') cal_name = 'NOLEAP' 
        IF (cal_name(1:6) .EQ. '366_DA') cal_name = 'ALL_LEAP' 

        cal_id = TM_GET_CALENDAR_ID (cal_name)
	IF (cal_id .LE. 0  .OR. cal_id .GT. max_calendars ) GO TO 5720
        CALL TM_GET_CALENDAR_ATTRIBUTES (cal_id, nmonths, 
     .                 ndays, yeardays, mon_names, d_in_mon, 
     .                 d_before_mon, mon_by_d)
        IF (new_att_calendar .NE. " ") new_att_calendar = cal_name

* True-month calendar:
* If no time origin given, by default the monthly axis origin will be 
* the beginning of the first month of the axis, if calendar date range 
* given, or 1-jan-0000

	IF (true_month) THEN
	   IF (qual_given( slash_T0 ) .EQ. 0) THEN
	      IF (its_calendar) THEN
	         start = ABS(cx_lo_ww(orient,mods_cx))
	         datestr = SECS_TO_DATE_OUT (start, cal_id, .FALSE., 1)
                 buff2 = '01-JAN-'//datestr(1:4)
	      ELSE
	         buff2 = '01-JAN-0000'
	      ENDIF
	   ENDIF

	ENDIF 

* interpret the line units
	IF ( buff1 .EQ. 'NONE' .OR. buff1 .EQ. ' ' ) THEN
	   buff1 = ' '
	   iunit = 0
	   
	ELSE
	   iunit = TM_UNIT_ID( buff1 )
	   IF ( iunit .EQ. 0 ) THEN
	       CALL WARN('(fyi) units are not subject to auto-conversion: '
     .			//buff1)

C /calendar=/unit=year gets length of year in that calendar 
C                      (true_month flag unused for yr axis)
           ELSEIF (iunit .EQ. -6 .OR. iunit .EQ. -10) THEN
	      iunit = TM_UNITS_CAL( iunit, cal_id, true_month )

C /units=months  is 1/12 of the length of the year
	   ELSEIF (iunit .EQ. -5) THEN    ! 1/97: "-5" is "MONTHS"
              WRITE (err_string,3540) yeardays
	      IF (cal_id .EQ. GREGORIAN) 
     .            WRITE (err_string,3544) yeardays
 
* Named calendar with unit=month or year gets length according to calendar's year length.

	      iunit = TM_UNITS_CAL( iunit, cal_id, true_month )

*  Append calendar name to units string.
              IF (cal_id .NE. GREGORIAN) THEN
		 slen = TM_LENSTR1 (buff1)
		 len_cal = TM_LENSTR1 (cal_name)
		 buff1 = buff1(:slen)//'('//cal_name(:len_cal)//')'
              ENDIF
	      
* issue a note about monthly axes

	      IF (true_month) THEN
	         WRITE (err_string,3546) 
		 IF (.NOT. truemonth_noted) CALL WARN (err_string) 
	      ELSE
	         CALL WARN (err_string)
	      ENDIF
	      
 3540         FORMAT 
     .        ('/UNIT=MONTHS  ... using 1/12 of ',F6.2,' days')
 3544         FORMAT 
     .        ('/UNIT=MONTHS is ambiguous ... using 1/12 of '
     .                                           ,F8.4,' days')
 3546         FORMAT ('True monthly axis')

	   ELSE

* ... Issue warning for inappropriate units like HOURS on X ax
*     and render the units unconvertible
 	      IF ( (  orient_t .AND.
     .		   ( iunit.LT.pun_1st_time .OR. iunit.GT.pun_last_time ) )
     .	      .OR. (  .NOT.orient_t .AND.
     .		   ( iunit.LT.pun_1st_len  .OR. iunit.GT.pun_last_len  ) )
     .	      .OR. (  orient.EQ.z_dim .AND.
     .	             iunit.EQ.pun_degrees )  ) THEN	! 7/96
	         CALL WARN
     .		   ('Units appear to conflict with orientation:'
     .			//' no conversions possible')
	         iunit = 0
	      ENDIF	      
	   ENDIF
 	ENDIF

* find a space to catalog it (may already be done above with DEF AX/LIKE=)
	IF (.NOT. line_allocated) THEN
	   status = ALLO_MANAGED_AXIS( iline )
	   IF ( status .NE. merr_ok ) GOTO 5000
	ENDIF

* was /NPOINTS given ?
* Read as an INTEGER then it can be really large and retain accuracy.
	iqual = qual_given( slash_npoints )
	IF ( iqual .GT. 0 ) THEN
	   CALL EQUAL_val_int( cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .			      ibuff, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   IF ( ibuff .LE. 0 ) GOTO 5582
	   npoints = ibuff
	ELSE
	   npoints = unspecified_int4
	ENDIF

* GET THE AXIS POINTS: IRREGULAR (from_variable) or regular
	IF ( irreg ) THEN
           line_regular( iline ) = .FALSE.  ! this may be reset to true later.
* ... get axis points from a memory variable
	   CALL GET_CMND_DATA (  cx_last, ptype_float, status )
	   IF ( status .NE. ferr_ok ) RETURN
           IF ( num_uvars_in_cmnd .NE. 1 .AND.
     .         (.NOT. has_bounds) ) GOTO 5580
           cx = is_cx(1)
* ... make sure it's an line (not a point,plane,etc.) of data
	   CALL GET_CX_DIMS( cx, ndim, dim )
	   IF ( ndim .GT. 1 ) GOTO 5580
	   idim = dim(1)
	   n    = CX_DIM_LEN( idim, cx )

* ... Checks on the bounds specification
           IF (has_bounds) THEN
              its_reg = .FALSE.
	      IF ( num_uvars_in_cmnd .LT. 2 .OR. 
     .             num_uvars_in_cmnd .GT. 3) GOTO 5580
              cx = is_cx(2)
	      mr = is_mr(2)
* ... make sure it's an line (not a point,plane,etc.) of data
	      CALL GET_CX_DIMS( cx, ndim, dim )
	      IF ( ndim .GT. 1 ) GOTO 5580
* ... check dimension if given as coords, lo_bnds, hi_bnds
              cx = is_cx(3)
	      mr = is_mr(3)
	      CALL GET_CX_DIMS( cx, ndim, dim )
	      IF ( ndim .GT. 1 ) GOTO 5580
* ... make sure the bounds have dimension 2*N or N+1
              idim = dim(1)
              n2   = CX_DIM_LEN( idim, is_cx(2) )
              IF (num_uvars_in_cmnd .EQ. 3) 
     .           n3 = CX_DIM_LEN( idim, is_cx(3) )
              IF (n2 .EQ. 2*n) THEN
                 n2 = 2*n
              ELSEIF (n2 .EQ. n+1) THEN
                 n2 = n+1
              ELSEIF (num_uvars_in_cmnd .EQ. 3) THEN
                 IF (n2 .NE. n3) GOTO 5745
			 IF (n2 .NE. n) GOTO 5745
              ELSE
                 GOTO 5740
              ENDIF
	   ENDIF

* ... reset cx to read the coordinates first
           cx = is_cx(1)
	   mr = is_mr(1)
	   CALL GET_CX_DIMS( cx, ndim, dim )
	   idim = dim(1)
	   n    = CX_DIM_LEN( idim, cx )

* ... original start of free line memory
	   frst_pt = next_line_mem_pos
* ... allocate some storage for the coordinates
	   IF (frst_pt+2*n+1 .GT. maxlinestore) GOTO 5590
	   
* ... If they gave upper- and lower-bounds we need to store all that,
*     at least temporarily.  IF its too big suggest edges.
	   IF (has_bounds .AND. frst_pt+3*n .GT. maxlinestore) THEN 
	      IF (num_uvars_in_cmnd .EQ. 2 .AND. n2.EQ.2*n) GOTO 5592
	      IF (num_uvars_in_cmnd .EQ. 3) GOTO 5592
	   ENDIF

* ... store coordinate positions (error status already checked)
           IF (has_bounds) THEN
              CALL NON_ARRAY_SUBSC( is_mr, 2 )
           ELSE
              CALL NON_ARRAY_SUBSC( mr, 1 )
           ENDIF

	   IF (its_edges) THEN
* ... "/edges" definition - 4/99
	      n = n - 1  ! edges array is one longer than points
	      IF (n .LE. 0) GOTO 5520
	      CALL EXTRACT_DP_LINE( cx, memry(mr)%ptr,
     .				 line_mem(frst_pt+n), idim, n+1 )
	      npoints = n


* ... monotonic?
	      DO 527 i1 = frst_pt+n+1, frst_pt+n+n
	         IF (.NOT. TM_FPEQ( line_mem(i1-1), line_mem(i1) ).AND. 
     .               line_mem(i1-1) .GT. line_mem(i1)) GOTO 5570
 527	      CONTINUE

* ... are there repeated values?

	      has_repeated = .FALSE.
	      is_double = .TRUE.
	      misordered = .FALSE. 

	      use_strict = .FALSE.  ! unused for DEFINE AXIS
	      micro_adj = 1E-6 *
     .		(line_mem(frst_pt+n+n) - line_mem(frst_pt+n))

	      CALL TM_CHECK_COORDS (frst_pt+n, frst_pt+n+n, is_double, 
     .                              use_strict, has_repeated, misordered, 
     .                              micro_adj, epsilon, epsilon)
	      IF (misordered) GOTO 5560
	      IF (has_repeated) 
     .		CALL WARN('Axis has repeated values -- micro-adjusting ...')

* ... store points: midway between box boundaries ...

	      has_repeated = .FALSE.
	      DO 528 i1 = frst_pt+1, frst_pt+n
	         line_mem(i1-1) = (line_mem(i1+n-1)+line_mem(i1+n)) * 0.5
 528	      CONTINUE

* Fix ticket 2400: Def of start was pointing to the lower grid cell edge not the
* lower coordinate. The loop start and stop were one off, so most axes detected
* as irregular as the last comparison took us beyond the upper edge of the axis.

	      its_reg = .TRUE.	! until proven otherwise
	      start = line_mem(frst_pt)
              delta = line_mem(frst_pt+1) - start
              DO 530 i1 = frst_pt+n+1,frst_pt+2*n
#ifdef double_p
		 IF (.NOT.TM_FPEQ( (delta),
     .               (line_mem(i1)-line_mem(i1-1))) )
     .						its_reg = .FALSE.
#else
                 IF (.NOT.TM_FPEQ( SNGL(delta),
     .               SNGL(line_mem(i1)-line_mem(i1-1))) )
     .						its_reg = .FALSE.
#endif
 530	      CONTINUE

	   ELSE

* NOT EDGES -- POINTS

	      CALL EXTRACT_DP_LINE( cx, memry(mr)%ptr,
     .				 line_mem(frst_pt), idim, n )
	      IF ( npoints .EQ. unspecified_int4 ) npoints = n

* ... a single point is always "regular" (unless definition has BOUNDS!!)
	      IF (n .EQ. 1 .AND. .NOT.has_bounds) THEN
	         start = line_mem(frst_pt)
	         delta = 1
	         its_reg = .TRUE.
	         GOTO 560
	      ENDIF
	      
* ... monotonic?	      

	      DO 532 i1 = frst_pt+1, frst_pt+npoints-1
	         IF (.NOT. TM_FPEQ( line_mem(i1-1), line_mem(i1) ).AND. 
     .               line_mem(i1-1) .GT. line_mem(i1)) GOTO 5570
 532	      CONTINUE

* ... are there repeated values?

	      has_repeated = .FALSE.
	      is_double = .TRUE.
	      misordered = .FALSE. 

	      use_strict = .FALSE.  ! unused for DEFINE AXIS
	      micro_adj = 1E-6 *
     .		(line_mem(frst_pt+n-1) - line_mem(frst_pt))

	      CALL TM_CHECK_COORDS (frst_pt, frst_pt+npoints-1, is_double, 
     .                              use_strict, has_repeated, misordered, 
     .                              micro_adj, epsilon, epsilon)
	      IF (misordered) GOTO 5560
	      IF (has_repeated) 
     .		CALL WARN('Axis has repeated values -- micro-adjusting ...')

* Bounds specified by user

              IF (has_bounds) THEN

                 cx = is_cx(2)
                 mr = is_mr(2)

	         CALL EXTRACT_DP_LINE2( cx, memry(mr)%ptr,
     .	  	    line_mem(next_line_mem_pos + n), idim, n2 )

* If given as coords, lo_bounds, hi_bounds, then
* 1) check that lo_bounds{i+1} = hi_bounds{i}
* 2) If ok, add the upper high bound to the list and treat 
*    this as the case where we give the bounds as N+1 values

                 IF (num_uvars_in_cmnd .EQ. 3) THEN
                    cx = is_cx(3)
                    mr = is_mr(3)
                    CALL EXTRACT_DP_LINE2( cx, memry(mr)%ptr,
     .	 	       line_mem(next_line_mem_pos + n+n2), idim, n3 )
                    DO i = 1, n3-1
                       IF (line_mem(next_line_mem_pos + n+i) .NE.
     .                      line_mem(next_line_mem_pos + 2*n+i-1) ) 
     .                     GOTO 5750
                    ENDDO
                    line_mem(next_line_mem_pos + 2*n) = 
     .                    line_mem(next_line_mem_pos + 3*n-1)
                    n2 = n+1
                 ENDIF

* Check that bounds enclose points, and that they are contiguous
	         line_subsc1 ( iline ) = frst_pt
                 line_dim    ( iline ) = npoints
                 IF (.NOT. TM_CHECK_BNDS (iline, n2, .TRUE., buff3) ) GO TO 5750

              ELSE

*... create bounds equidistant between grid points

*    ... store initial box lower bound (start of axis)
	         line_mem(frst_pt+npoints) = line_mem(frst_pt) -
     .			0.5 * ( line_mem(frst_pt+1) - line_mem(frst_pt) )
*    ... mid-axis box boundaries ...
	         DO 539 i1 = frst_pt+1, frst_pt+npoints-1
	            line_mem(i1+npoints) = (line_mem(i1-1)+line_mem(i1)) * 0.5
 539	         CONTINUE
*    ... upper-most box bound (end of axis)
	         i2 = frst_pt+npoints-1	! last box point
	         line_mem(i2+npoints+1) = line_mem(i2) +
     .			0.5 * ( line_mem(i2) - line_mem(i2-1) )
	         its_reg = .TRUE.	! until proven otherwise
	         start = line_mem(frst_pt)
                 delta = line_mem(frst_pt+1) - start
                 DO 550 i1 = frst_pt+2,frst_pt+npoints-1
#ifdef double_p
                    IF (.NOT.TM_FPEQ( (delta),
     .                  (line_mem(i1)-line_mem(i1-1))) )
     .                       its_reg = .FALSE.
#else
		    IF (.NOT.TM_FPEQ( SNGL(delta),
     .                  SNGL(line_mem(i1)-line_mem(i1-1))) )
     .                       its_reg = .FALSE.
#endif
 550	         CONTINUE
              ENDIF

	   ENDIF

* ... check to see if it was regularly spaced after all
 560	   IF ( its_reg ) THEN
	      line_start    ( iline ) = start
	      line_delta    ( iline ) = delta
	      line_regular  ( iline ) = .TRUE.
	      line_subsc1   ( iline ) = unspecified_int4
	   ELSE	      
* ... save irregular line data
	      line_subsc1 ( iline ) = frst_pt
	      line_start  ( iline ) = line_mem(frst_pt)
	      line_delta  ( iline ) = unspecified_val8
              line_dim    ( iline ) = npoints   ! need this here so TM_CHECK_BNDS works.
	      line_regular( iline ) = .FALSE.

	   ENDIF
	ELSE

* ... start,end,delta specification for a REGULAR axis.  
* acm These are properties of the line, so reset according to the calendar.
*     Need to do this only when it came in as a date string; these are flagged
*     as negative in TRANSLATE_LIMIT

	   start = cx_lo_ww(orient,mods_cx)
	   end   = cx_hi_ww(orient,mods_cx)
           prev_cal_id = cx_cal_id(mods_cx)
           IF (prev_cal_id .EQ. unspecified_int4) prev_cal_id = 1

	   IF ( orient_t  .AND.  cal_id .NE. prev_cal_id .AND.
     .          start .LT. 0.  .AND.  start .NE. unspecified_val8.AND.
     .          end   .LT. 0.  .AND.  end   .NE. unspecified_val8) THEN
	      CALL RESET_SECS_FROM_BC (-start, new_ww, prev_cal_id, 
     .                                 cal_id, status)
	      start = -1. * new_ww

	      CALL RESET_SECS_FROM_BC (-end, new_ww, prev_cal_id, 
     .                                 cal_id, status)
	      IF ( status .NE. ferr_ok ) RETURN

	      end = -1. * new_ww
              cx_cal_id(mods_cx) = cal_id
	   ENDIF

	   IF ( its_edges ) THEN
	     IF ( npoints .EQ. unspecified_int4 ) THEN
	       delta = cx_delta (orient,mods_cx)
	       IF ( delta.EQ.unspecified_val8 .OR. delta.LE.0.D0) GOTO 5520
	       
* Check for delta of 1 on true-month axis (for now)
	       IF (true_month .AND. delta .NE. 1) GOTO 5810 

	       IF ( .NOT.its_calendar ) THEN
	          npoints = ( (end - start) / delta ) + 0.9999
	       ENDIF
	     ELSE
	       delta = (end - start) / npoints
	       IF (its_calendar) delta = -1 * delta/un_convert(iunit)
	       IF ( delta .LE. 0.0D0 ) GOTO 5520
	     ENDIF
	     IF ( its_calendar ) THEN
	       start = start - (delta/2.0)*un_convert(iunit)
	       end   = end   + (delta/2.0)*un_convert(iunit)
	     ELSE
	       start = start + delta/2.0
	       end   = end   - delta/2.0
	     ENDIF

	   ELSE
	     IF ( npoints .EQ. unspecified_int4 ) THEN
	       delta = cx_delta (orient,mods_cx)
	       IF ( delta.EQ.unspecified_val8 .OR. delta.LE.0.D0) GOTO 5520
	       IF ( .NOT.its_calendar ) THEN
	          npoints = INT(( (end - start) / delta ) + 1.9999)
                  small = MIN(1.e-9, delta)
		  IF (start + delta* (npoints-1) - 0.5*delta .GT. end+small) 
     .              npoints = npoints-1
	       ENDIF
	     ELSEIF ( npoints .EQ. 1 ) THEN
	       IF ( end .NE. start ) GOTO 5530
	       delta = 1.D0
	     ELSE
	       delta = (end - start) / (npoints-1)
	       IF (its_calendar) delta = -1 * delta/un_convert(iunit)
	       IF ( delta .LE. 0.0D0 ) GOTO 5520
	     ENDIF
	   ENDIF

	   line_start    ( iline ) = start
	   line_delta    ( iline ) = delta
	   line_regular  ( iline ) = .TRUE.
	   line_subsc1   ( iline ) = unspecified_int4
	ENDIF

* /T0 = date (or supply default)
	iqual = qual_given( slash_T0 )
        new_att_t0 = ' '
	IF (true_month .AND. buff2 .NE. ' ') iqual = 1
	IF ( iqual .GT. 0 ) THEN
	   IF (buff2 .EQ. ' ') 
     .       CALL EQUAL_STRING( cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .			      buff2, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   CALL TM_BREAK_DATE( buff2, cal_id, i1,i2,i3,i4,i5,i6, 
     .                         status )
	   IF ( buff2 .EQ. ' ' .OR. status .NE. ferr_ok ) GOTO 5540
           new_att_t0 = buff2
	ELSE
	   
	   WRITE (buff2,3550) mon_names(1)
 3550      FORMAT ('15-', A3, '-1901')		! default
	   IF (its_calendar ) THEN
	      i1 = 20
 580	      bc_to_t0 = SECS_FROM_BC( buff2, cal_id, status )      
	      IF ( status .NE. ferr_ok ) GOTO 5540
	      IF ( bc_to_t0 + start .GT. 0 ) THEN	! start is before T0?
	         IF ( i1 .LT. 0 ) GOTO 5540
	         i1 = i1 - 1
	         WRITE (buff2,3560) mon_names(1), i1
 3560	         FORMAT('01-',A3,'-',I2.2,'00')
	         GOTO 580
	      ENDIF
	   ENDIF

	ENDIF

* Combine new attribute units and/or time origin to express
* the units attribute as units since time-origin

        IF (orient_t) THEN
           IF (new_att_units .NE. ' ') THEN
              i1 = TM_LENSTR1(new_att_units)
              IF (new_att_t0 .NE. ' ') 
     .            new_att_units = new_att_units(1:i1)//' since ' 
     .            // new_att_t0
           ENDIF
        ENDIF

* save the line in memory - but don't catalog its name
	line_dim      ( iline ) = npoints
	line_units    ( iline ) = buff1	   
	line_t0       ( iline ) = buff2
	line_cal_name ( iline ) = cal_name
	line_unit_code( iline ) = iunit
	line_direction( iline ) = 'NA'
	IF ( orient_t ) line_tunit(iline) = un_convert( iunit )



* is it a formattable axis ?
	IF ( orient .EQ. x_dim ) THEN
	   line_direction( iline ) = 'XX'
           IF (iunit .EQ. pun_degrees) THEN
	      line_direction( iline ) = 'WE'
	      line_units( iline ) = 'degrees_east'
	   ENDIF

	ELSEIF ( orient .EQ. y_dim  ) THEN
           line_direction( iline ) = 'YY'
	   IF (iunit .EQ. pun_degrees) THEN
	      line_direction( iline ) = 'SN'
	      line_units( iline ) = 'degrees_north'
	   ENDIF

	ELSEIF ( orient .EQ. z_dim ) THEN
           IF ( qual_given( slash_depth ) .GT. 0 ) THEN
	      line_direction( iline ) = 'UD'    ! GEOG_LABEL requires "meters"
           ELSE
	      line_direction( iline ) = 'DU'
           ENDIF

	ELSEIF ( orient .EQ. e_dim ) THEN
           line_direction( iline ) = 'EE'

* TODO: let  F axes have time units
	ELSEIF ( orient .EQ. f_dim ) THEN
           line_direction( iline ) = 'FF'
	   IF (.NOT.irreg  .AND. its_calendar ) THEN
	      line_direction(iline) = 'FI'
	      bc_to_t0 = SECS_FROM_BC( line_t0(iline), cal_id, status)
	      line_dim  (iline) = (start-end) / (line_tunit(iline)*delta) + 1.9999
	      line_start(iline) = (-line_start(iline)-bc_to_t0)/line_tunit(iline)

	   ENDIF
	   IF ( qual_given(slash_T0).GT.0 ) line_direction(iline) = 'FI'

* ... time axis specified as date strings  (ELSEIF mod 11/93 *sh*)
	ELSEIF (.NOT.irreg  .AND. its_calendar ) THEN
	   line_direction(iline) = 'TI'
	   bc_to_t0 = SECS_FROM_BC( line_t0(iline), cal_id, status)
	   line_dim  (iline) = (start-end) / (line_tunit(iline)*delta) + 1.9999
	   line_start(iline) = (-line_start(iline)-bc_to_t0)/line_tunit(iline)

* ... time axis specified as time step values with T0 given
	ELSEIF ( orient.EQ.t_dim .AND. qual_given(slash_T0).GT.0 ) THEN
	   line_direction(iline) = 'TI'
	ELSEIF ( orient.EQ.t_dim .AND. line_direction(iline) .EQ. 'NA') THEN
	   line_direction(iline) = 'TT'
	ENDIF

* ... true-month calendar given without calendar date range, fill in
*     start, count, direction.

	IF (true_month .AND. .NOT.its_calendar) THEN
	    line_start(iline) = cx_lo_ww(orient,mods_cx) - delta/2
	    line_direction(iline) = 'TI'
	    line_dim(iline) = 1 + 
     .       ( cx_hi_ww(orient,mods_cx) - cx_lo_ww(orient,mods_cx) )/ delta
	ENDIF

* automatic longitude modulo
	axwwlen = TM_WW_AXLEN(iline)
	IF (line_direction(iline) .EQ. 'WE' ) THEN
	  IF (axwwlen .LE. 360.D0 .AND. (npoints.GT.1)) THEN
	     its_modulo = .TRUE.
	     IF (rmod_len .EQ. 0.0D0)  rmod_len = 360.D0
	     new_att_modulo = .TRUE.
	     new_att_modulo_len = rmod_len
	  ELSE IF (.NOT.has_bounds .AND. .NOT.line_regular(iline)) THEN 
	    CALL TM_ADJUST_BOUNDS(iline, 360.0, axwwlen, its_modulo)
	     IF (its_modulo) THEN
	        rmod_len = 360.D0
	        new_att_modulo = .TRUE.
	        new_att_modulo_len = rmod_len
	     ENDIF   
	  ENDIF

*  Calendar modulo
	ELSEIF (.NOT.its_modulo .AND. 
     .          (line_direction(iline) .EQ. 'TI' .OR.
     .           line_direction(iline) .EQ. 'FI') ) THEN
	  secsperyear = DBLE(cals_yeardays(cal_id)) * (24.D0 * 60.D0 * 60.D0)
	  bc_to_t0 = SECS_FROM_BC( line_t0(iline), cal_id, status)
	  CALL TM_WW_AX_1_N(iline, start, end)
	  secs2start = bc_to_t0 + start*line_tunit(iline)
	  
* Set the conversion factor for true-month, months to days
	   grid_line(t_dim, dgrid_buff) = iline
	   CALL TM_MONTH_TIME_FACTOR (dgrid_buff, true_month, timefac)

	  IF (true_month) secs2start = secs2start/ timefac

	  IF ( (secs2start .LE. secsperyear)
     .	 .AND. (axwwlen*line_tunit(iline) .LE. secsperyear) ) THEN
	     its_modulo = .TRUE.
	     IF (rmod_len .EQ. 0.0D0)  rmod_len =
     .				       timefac* secsperyear/line_tunit(iline)
	     new_att_modulo = .TRUE.
	     new_att_modulo_len = rmod_len

* Is this an axis where we added bounds?  If so they might be adjustable
* to make the axis modulo

           ELSEIF (.NOT.line_regular(iline) .AND. .NOT.bnds_or_edges) THEN  
	      delta = end - start
              IF ( (secs2start .LE.  2*secsperyear)
     .	           .AND. (delta*line_tunit(iline) .LE. secsperyear) ) THEN
	         CALL TM_ADJUST_BOUNDS(iline, 
     .                        secsperyear/line_tunit(iline), axwwlen, okmod)
	         IF (okmod) THEN
		    its_modulo = .TRUE.
	            rmod_len = axwwlen
	            new_att_modulo = .TRUE.
	            new_att_modulo_len = rmod_len
		 ENDIF
              ENDIF
	  ENDIF

	ENDIF

* Ticket 2504: If the coordinates on an irregular axis lie within the modulo 
* length but bounds that were automatically computed from coordinate midpoints 
* make the axis too long, reset the bounds so the axis is the modulo length.
* (may have been done for special cases above)

	IF (its_modulo .AND. .NOT.bnds_or_edges .AND. rmod_len.GT.0.) THEN
	   CALL TM_ADJUST_BOUNDS(iline, rmod_len, axwwlen, okmod)
	   IF (.NOT.okmod) its_modulo = .FALSE.
	ENDIF

* set modulo and sanity check it

	line_modulo( iline) = its_modulo
	line_modulo_len( iline ) = rmod_len
	IF (rmod_len .NE. 0.0D0) THEN
	   IF (axwwlen .GT. rmod_len) THEN
             IF (TM_DFPEQ(axwwlen, rmod_len)) THEN
	       line_modulo_len( iline ) = 0.0
             ELSE
               GOTO 5525
	     ENDIF
           ENDIF
	ENDIF


* If the user said /monthly and /modulo, store the modulo length in months

	IF (true_month .AND. its_modulo) THEN
	   axwwlen = TM_WW_AXLEN(iline)  ! months, make it an integer
	   IF (INT(axwwlen+0.5) .LE. 12.) THEN
	      rmod_len = DFLOAT(INT(axwwlen+0.5))
	      axwwlen = rmod_len
	   ENDIF
	   line_modulo_len(iline) = rmod_len
	ENDIF

* Write a note when subspan modulo axis length within a grid cell of modulo length
c	CALL TM_WARN_SUBSPAN (iline)


* ... Was it a true-month axis (defined in the classic way without the /MONTHLY qualifier)?
* 1/13/2017 ticket 2497, Back off this auto-detection of monthly axes for now.

c	IF (.NOT. true_month .AND. irreg .AND. .NOT.line_modulo( iline)) THEN
c           units = TM_UNIT_ID( line_units(iline) )
c	   CALL TM_CHECK_MONTHLY_AXIS (line_mem(frst_pt), line_dim(iline), 
c     .              cal_id, line_t0(iline), units, line_units(iline),
c     .              start, delta, line_tunit(iline), true_month)
c	   IF (true_month) THEN
c	      line_regular(iline) = .TRUE.
c	      line_start  (iline) = start !* line_tunit(iline)/ un_convert(pun_day)
c	      line_delta  (iline) = delta
c	      line_subsc1 (iline) = unspecified_int4
c	      last_coord = line_start(iline) + DBLE(npts-1)*line_delta(iline)
c	      firs_coord = start
c	      line_unit_code (iline) = units
c	      line_tunit  (iline) = un_convert(units)
c	      its_edges = .FALSE.
c	      irreg = .FALSE.
c	   ENDIF
c	ENDIF


* ... coordinate pointer for next line to save
* Bounds are stored as edges, so increase by N coordinates and N+1 edges

* acm move this to before purge_mr_axis, which also resets next_line_mem_pos
*     after it deletes old_line.

	IF (irreg .AND. .NOT.line_regular(iline))
     .			next_line_mem_pos = frst_pt + 2*n+1
* check for redefinitions
	IF ( dup_name ) THEN
	   IF ( TM_LINE_MATCH( old_line, iline ) ) THEN
	      RETURN					! dup name/dup def
	   ELSE
* ... redefinition makes all past assumptions incorrect

* Dont write message if DEF AX/QUIET
	      IF (qual_given( slash_def_ax_quiet ) .EQ. 0 ) THEN
	         original = .TRUE.
	         CALL CHOOSE_LINE_NAME(old_line, original, buff)
	         CALL SPLIT_LIST(pttmode_ops, err_lun,
     .			replmsg//'axis '//buff, 0)
	      ENDIF

* ... Check the attribute structure for this axis name and change 
*     attribute values as needed.  

	      CALL REDEFINE_AX_ATT (line_name(old_line), new_att_units, 
     .           new_att_t0, new_att_calendar, new_att_modulo,
     .           new_att_modulo_len, line_direction(iline), 
     .           line_regular(iline) )

	      CALL PURGE_MR_AXIS( old_line, iline, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
	      CALL TM_DEALLO_DYN_LINE( old_line )

	   ENDIF

        ELSE

* Add newly defined axis to the user-variable dset of the linked-list structure.
* Save the original upper-or lower-case spelling
           
           dset_to_add = pdset_coordvars  ! user-defined coordinate variable dataset.

           err_string = varname
           type = NCDOUBLE
           coordvar = 1
           varid = 0		 ! Will be returned with variable ID
           bad_flag = bad_val4   ! coord vars dont have missing, but set to something
           CALL CD_ADD_COORD_VAR( dset_to_add, varname, varid,  
     .         line_units(iline), type, coordvar, bad_flag, status)
           IF ( status .NE. ferr_ok ) GOTO 5600
         
* Get direction (also used to set axis direction, below). Set the
* point_spacing attribute. If the axis is a time axis, by default this
* is not written to the file as the axis may be the record axis.

           dcode = line_direction(iline)
           IF (dcode .EQ. 'XX' .OR. dcode .EQ. 'WE') dir = 1
           IF (dcode .EQ. 'YY' .OR. dcode .EQ. 'SN') dir = 2
           IF (dcode .EQ. 'ZZ' .OR. dcode .EQ. 'UD' .OR. dcode .EQ. 'DU') dir = 3
           IF (dcode .EQ. 'TT' .OR. dcode .EQ. 'TI') dir = 4
           IF (dcode .EQ. 'EE') dir = 5
           IF (dcode .EQ. 'FF' .OR. dcode .EQ. 'FI') dir = 6

           attname = 'point_spacing'
           attype = NCCHAR
           attoutflag = 1
	   its_reg = .NOT.irreg .AND. .NOT.true_month
	   IF (true_month .AND. cal_name .EQ. '360_DAY') its_reg = .TRUE.
           IF ( its_reg ) THEN
              attlen = 4
              CALL CD_PUT_NEW_ATTR (dset_to_add, varid, attname, 
     .        attype, attlen, attoutflag, 'even', dummy, status) 
           ELSE
              attlen = 6
              CALL CD_PUT_NEW_ATTR (dset_to_add, varid, attname, 
     .        attype, attlen, attoutflag, 'uneven', dummy, status) 
           ENDIF

* Axis attribute, with coordinate direction

           attname = 'axis'
           attype = NCCHAR
           attoutflag = 1

           dcode = line_direction(iline)
           IF (dcode .EQ. 'XX' .OR. dcode .EQ. 'WE') axdir = 'X'
           IF (dcode .EQ. 'YY' .OR. dcode .EQ. 'SN') axdir = 'Y'
           IF (dcode .EQ. 'ZZ' .OR. dcode .EQ. 'UD' .OR. 
     .                              dcode .EQ. 'DU') axdir = 'Z'
           IF (dcode .EQ. 'TT' .OR. dcode .EQ. 'TI') axdir = 'T'
           IF (dcode .EQ. 'EE') axdir = 'E'
           IF (dcode .EQ. 'FF' .OR. dcode .EQ. 'FI') axdir = 'F'
           attlen = 1
           CALL CD_PUT_NEW_ATTR (dset_to_add, varid, attname, 
     .           attype, attlen, attoutflag, axdir, dummy, status) 

* Set the axis direction

           dir = 0
           IF (axdir .EQ. 'X') dir = 1
           IF (axdir .EQ. 'Y') dir = 2
           IF (axdir .EQ. 'Z') dir = 3
           IF (axdir .EQ. 'T') dir = 4
           IF (axdir .EQ. 'E') dir = 5
           IF (axdir .EQ. 'F') dir = 6
           CALL CD_SET_ATT_AXDIR (dset_to_add, varid, dir, status)

* Bounds on irregular axis output by default.

           IF (.NOT.its_reg) THEN
              attname = 'bounds'
              attype = NCCHAR
              attoutflag = 1

              attlen = TM_LENSTR1(buff3)
              attlen = attlen + 5
              buff2 = buff3(:slen)//'_bnds'
              CALL CD_PUT_NEW_ATTR (dset_to_add, varid, attname, 
     .           attype, attlen, attoutflag, buff2, dummy, status) 
           ENDIF

* Modulo attribute

           IF ( line_modulo(iline) ) THEN
              attname = 'modulo'
              attype = NCDOUBLE
              attoutflag = 1
              attlen = 1
              CALL CD_PUT_NEW_ATTR_DP (dset_to_add, varid, attname, 
     .           attype, attlen, attoutflag, buff1, line_modulo_len(iline), status) 
           ENDIF

* Positive down. 

           IF (line_direction(iline) .EQ. 'UD') THEN
              attname = 'positive'
              attype = NCCHAR
              attoutflag = 1
              attlen = 4
              CALL CD_PUT_NEW_ATTR (dset_to_add, varid, attname, 
     .           attype, attlen, attoutflag, 'down', dummy, status) 
           ENDIF

* Do not write positive=up. This is the default Ferret behavior
           IF (line_direction(iline) .EQ. 'DU') THEN
              attname = 'positive'
              attype = NCCHAR
              attoutflag = 0
              attlen = 2
              CALL CD_PUT_NEW_ATTR (dset_to_add, varid, attname, 
     .           attype, attlen, attoutflag, 'up', dummy, status) 
           ENDIF

           IF (line_direction(iline)(1:1) .EQ. 'T' .OR.
     .         line_direction(iline)(1:1) .EQ. 'F') THEN
              IF (its_calendar) THEN
                 attname = 'calendar'
                 attype = NCCHAR
                 attoutflag = 1
                 attlen = TM_LENSTR1(cal_name)

                 CALL CD_PUT_NEW_ATTR (dset_to_add, varid, attname, 
     .             attype, attlen, attoutflag, cal_name, 
     .             dummy, status) 

                 attname = 'time_origin'
                 attype = NCCHAR
                 attoutflag = 1
                 attlen = TM_LENSTR1(line_t0(iline))
                 CALL CD_PUT_NEW_ATTR (dset_to_add, varid, attname, 
     .               attype, attlen, attoutflag, line_t0(iline), 
     .               dummy, status) 

              ENDIF
 
           ENDIF

	ENDIF

* now catalog it in memory by saving its name
	line_name( iline ) = buff3
	line_name_orig( iline ) = varname
	RETURN

**************************************************************************
* DEFINE VIEWPORT
 600	IF ( num_args .NE. 1 ) GOTO 5300
 
	r4_unspec = unspecified_val4
* check out viewport name
	buff1 = cmnd_buff( arg_start(1):arg_end(1) )
	ivp = VIEWPORT_NUMBER( buff1 )
	IF ( ivp .EQ. unspecified_int4 ) THEN
* ... new name - find an unused slot
	   DO 610 ivp = 1, max_viewport
 610	   IF ( vp_name(ivp) .EQ. unspecified_name4 ) GOTO 620
	   GOTO 5610	! no free slots
	ELSE
* ... name in use - flag segments in this viewport as deleted
	   IF ( ivp .EQ. mvp_dflt ) GOTO 5640
	   CALL SPLIT_LIST(pttmode_ops, err_lun,
     .			'Re-defining viewport '//vp_name(ivp), 0)
	   DO 614 iseg = vp_seg0(ivp)+1 , vp_segn(ivp)
 614	   CALL GDSG( iseg ) 
	   vp_seg0 ( ivp ) = 0
	   vp_segn ( ivp ) = 0
	ENDIF

* pre-set all values to defaults
 620	vp_size ( ivp ) = 1.0
	vp_xorg ( ivp ) = 0.0
	vp_yorg ( ivp ) = 0.0
	vp_xclip( ivp ) = r4_unspec   ! old style  3/29/93
	vp_yclip( ivp ) = r4_unspec   ! old style  3/29/93
	vp_seg0 ( ivp ) = 0
	vp_segn ( ivp ) = 0

* /AXES
* 10/01 *kob* - add ".GT. 0" in below logical check
	vp_by_axis(ivp) = qual_given( slash_define_vp_by_ax ) .GT. 0

***************** OLD CODE (retained for greater upwards compatibility)
* /ORIGIN = x,y
	qp = qual_given( slash_origin )
	IF ( qp .GT. 0 ) THEN
	   IF (vp_by_axis(ivp)) GOTO 5660
	   CALL EQUAL_STRING( cmnd_buff(qual_start(qp):qual_end(qp)),
     .			   buff2, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   IF ( .NOT.TM_DIGIT(buff2) .OR. INDEX(buff2,',').EQ.0 ) GOTO 5630
	   READ ( buff2, *, ERR=5630 ) vp_xorg(ivp), vp_yorg(ivp)
	   vx = vp_xorg(ivp)
	   vy = vp_yorg(ivp)
	   IF ( OUTSIDE_0_1(vx) .OR. OUTSIDE_0_1(vy) )
     .	      							   GOTO 5620
	ENDIF

* /SIZE=q
	qp = qual_given( slash_size )
	IF ( qp .GT. 0 ) THEN
	   IF (vp_by_axis(ivp)) GOTO 5660
	   CALL EQUAL_VAL( cmnd_buff(qual_start(qp):qual_end(qp)),
     .			   val_buf, status )
	   vp_size(ivp) = val_buf
	   IF ( status .NE. ferr_ok ) RETURN
	   IF ( val_buf .LT. 0.0 ) GOTO 5620
           vp_size(ivp) = -1. * vp_size(ivp)    ! flag for old-style viewports
           CALL WARN (
     .          'The /SIZE qualifier will force Ver. 2.2 behavior'
     .	        //' for DEFINE VIEWPORT')
	ENDIF

* /CLIP = x,y
	qp = qual_given( slash_clip )
	IF ( qp .GT. 0 ) THEN
	   IF (vp_by_axis(ivp)) GOTO 5660
	   CALL EQUAL_STRING( cmnd_buff(qual_start(qp):qual_end(qp)),
     .			   buff2, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   IF ( .NOT.TM_DIGIT(buff2) .OR. INDEX(buff2,',').EQ.0 ) GOTO 5630
	   READ ( buff2, *, ERR=5630 ) vp_xclip(ivp), vp_yclip(ivp)
	   IF ( vp_xclip(ivp).LE.vp_xorg(ivp) .OR. vp_xclip(ivp).GT.1.0
     .	   .OR. vp_yclip(ivp).LE.vp_yorg(ivp) .OR. vp_yclip(ivp).GT.1.0 )
     .	      							   GOTO 5620
	ENDIF

***************** END OF OLD CODE (retained for greater upwards compatibility)

* default clipping at 1,1 in new style viewports  (immaterial, I think ...)
	IF ( qual_given(slash_size) .EQ. 0 ) THEN
	   IF ( vp_xclip(ivp).EQ.r4_unspec) THEN
	      vp_xclip(ivp) = 1.0
	      vp_yclip(ivp) = 1.0
	   ENDIF
	ENDIF

* /XLIMITS = xlow,xhigh 
	qp = qual_given( slash_xlimits )
	IF ( qp .GT. 0 ) THEN
	   CALL EQUAL_STRING( cmnd_buff(qual_start(qp):qual_end(qp)),
     .			   buff2, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   i1 = TM_LENSTR1(buff2)
	   pos = MAX( INDEX(buff2,','), INDEX(buff2,':') )
	   IF ( pos.LE.1 .OR. pos.EQ.i1 ) GOTO 5630
	   IF (.NOT.TM_DIGIT(buff2) )  GOTO 5630
	   READ ( buff2(1:pos-1), *, ERR=5630 ) vp_xorg(ivp)
	   IF (.NOT.TM_DIGIT(buff2(pos+1:i1))  ) GOTO 5630
	   READ ( buff2(pos+1:i1), *, ERR=5630 ) vp_xclip(ivp)
	   vx = vp_xorg(ivp)
	   vy = vp_xclip(ivp)
	   IF ( OUTSIDE_0_1(vx) .OR. OUTSIDE_0_1(vy)
     .     .OR. vp_xorg(ivp) .GE. vp_xclip(ivp) )  GOTO 5620
	ENDIF

* /YLIMITS = ylow,yhigh 
	qp = qual_given( slash_ylimits )
	IF ( qp .GT. 0 ) THEN
	   CALL EQUAL_STRING( cmnd_buff(qual_start(qp):qual_end(qp)),
     .			   buff2, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   pos = MAX( INDEX(buff2,','), INDEX(buff2,':') )
	   i1 = TM_LENSTR1(buff2)
	   IF ( pos.LE.1 .OR. pos.EQ.i1 ) GOTO 5630
	   IF (.NOT.TM_DIGIT(buff2) )  GOTO 5630
	   READ ( buff2(:pos-1), *, ERR=5630 ) vp_yorg(ivp)
	   IF (.NOT.TM_DIGIT(buff2(pos+1:i1))  ) GOTO 5630
	   READ ( buff2(pos+1:i1), *, ERR=5630 ) vp_yclip(ivp)
	   vx = vp_yorg(ivp)
	   vy = vp_yclip(ivp)
	   IF ( OUTSIDE_0_1(vx) .OR. OUTSIDE_0_1(vy)
     .     .OR. vp_yorg(ivp) .GE. vp_yclip(ivp) )  GOTO 5620
	ENDIF

* /TEXT=q 
	qp = qual_given( slash_text )
	IF ( qp .GT. 0 ) THEN
	   IF ( qual_given(slash_size) .GT. 0 ) GOTO 5650
	   CALL EQUAL_VAL( cmnd_buff(qual_start(qp):qual_end(qp)),
     .			   val_buf, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   vp_size(ivp) = val_buf
	   IF ( val_buf .LT. 0.001 ) GOTO 5620
	ELSEIF ( qual_given(slash_size) .EQ. 0 ) THEN     ! auto-sizing
           vp_size(ivp) = SQRT( (vp_xclip(ivp)-vp_xorg(ivp))
     .                        * (vp_yclip(ivp)-vp_yorg(ivp)) )
	   IF (vp_by_axis(ivp)) THEN
* ... vieport size is inferred from users axis limits and depends upon scale
* ... iterate a few times to approximate the correct scale factor
	      DO i1 = 1, 3
	        scale = 1.0 / SQRT( ABS(vp_size(ivp)) )
	        CALL VP_AXLIM2LIM( scale,
     .				   vp_xorg(ivp),  vp_yorg(ivp),
     .				   vp_xclip(ivp), vp_yclip(ivp),
     .                             xlovp, ylovp,  xhivp, yhivp,
     .                             xoei,  yoei,   xcei,  ycei )
	        vp_size(ivp) = SQRT((xhivp-xlovp) * (yhivp-ylovp))
	     ENDDO
	   ENDIF
	ENDIF

* successfully defined viewport
	vax_code = STR_UPCASE( vp_name(ivp), buff1 )

* if re-defining the current viewport then it takes immediate effect
	IF ( ivp .EQ. vp_num ) CALL SET_VIEWPORT( ivp )
	RETURN

**************************************************************************
* DEFINE ALIAS
 700	IF ( num_args .LT. 1 ) GOTO 5300
	CALL NAME_EQUAL_STRING( buff1, pos, status )
	IF ( status .NE. ferr_ok )  GOTO 5000
	IF ( pos .EQ. 0 ) GOTO 5400
	IF ( .NOT.TM_LEGAL_NAME(buff1) ) GOTO 5410

* determine the name of the command being aliased
        DO i1 =  pos, arg_end(num_args)
           IF (cmnd_buff(i1:i1) .EQ. ' '
     .    .OR. cmnd_buff(i1:i1) .EQ. tab ) THEN
              i2 = i1 - 1   ! last char of command being aliased
              GOTO 705
           ENDIF
        ENDDO
        i2 = arg_end(num_args)

* prevent IF, ELIF, ELSE and ENDIF from being aliased, as this would mess
* up flow control in PROCESS_IF and elsewhere
* ... special test for IF command, cuz 1-line IFs are OK to alias 
 705    IF ( MATCH4(cmnd_buff(pos:i2),i2-pos+1,'IF',2) ) THEN
           i1 = STR_UPCASE (risc_buff, cmnd_buff)
           IF (.NOT.ITSA_1LINEIF(risc_buff(pos:arg_end(num_args)),
     .                           arg_end(num_args)-pos+1)) GOTO 5200
        ENDIF
        DO i1 = 1, 3
           IF (MATCH4(cmnd_buff(pos:i2),i2-pos+1,
     .                reserved_flow_name(i1),4   )) GOTO 5200
        ENDDO

* find a slot to save this alias
        i1 = ALIAS_ID( buff1 )
        IF ( i1 .EQ. unspecified_int4 ) THEN
	   DO 710 i1 = num_predefined_alias+1, total_num_alias
	      IF ( alias_name(i1) .EQ. unspecified_name4 ) GOTO 720
 710	   CONTINUE
           GOTO 5710
        ENDIF

* save the alias
 720    vax_code = STR_UPCASE( alias_name(i1), buff1 ) 
        alias(i1) = cmnd_buff(pos:arg_end(num_args))
        alias_len(i1) = TM_LENSTR1( alias(i1) )
	RETURN


**************************************************************************
* DEFINE SYMBOL
 800	IF ( num_args .LT. 1 ) GOTO 5300
	CALL NAME_EQUAL_STRING( buff1, pos, status )
	IF ( status .NE. ferr_ok )  GOTO 5000
	IF ( pos .EQ. 0 ) GOTO 5400
	IF ( .NOT.TM_LEGAL_NAME(buff1) ) GOTO 5410

* if this symbol already exists then delete it
        buffsym = buff1
	CALL GETSYM( buffsym, err_string, i2, i1 )
	IF ( i1 .EQ. 0 ) CALL DELSYM(buffsym,i1)

* remove backslash escape characters 
! OLD COMMENT: exactly 255 for PPL; no longer the case as of Ferret v6.01
	err_string = cmnd_buff(pos:arg_end(num_args))   
	CALL DE_ESCAPE_STRING( err_string, slen )

* define the symbol
	CALL PUTSYM( buffsym, err_string, slen, i2)
! ... no check on returned error code (could be "internal error")
	RETURN

**************************************************************************
* DEFINE ATTRIBUTE /D= /TYPE= /OUTPUT /QUIET
 900	IF ( num_args .LT. 1 ) GOTO 5900
	CALL NAME_EQUAL_STRING_VATT ( buff1, pos, status )
	IF ( status .NE. ferr_ok )  GOTO 5000
	IF ( pos .EQ. 0 ) GOTO 5400
	IF ( INDEX(buff1,'..') .EQ. 1 ) THEN
           ivar = 0  ! global attr.
           varname = '.'
	ELSE
           IF ( .NOT.TM_LEGAL_NAME(buff1) ) GOTO 5100
        ENDIF

* ... get dset number if present:  DEF ATT/D=dset ...
	iqual = qual_given( slash_def_att_dset ) 
        IF ( iqual .GT. 0 ) THEN
	   CALL EQUAL_STRING( cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .			      buff2, status )  
	   IF ( status .NE. ferr_ok ) RETURN
	   IF ( buff2 .NE. ' ' ) THEN
	      dset = FIND_DSET_NUMBER( buff2 )
	      IF ( dset .EQ. unspecified_int4) THEN
	         CALL WARN('Unknown data set: '
     .		 //buff2(:TM_LENSTR1(buff2)))
	         RETURN
	      ENDIF
	   ENDIF
	ENDIF

*...DEF ATT/TYPE=string or float  get attribute type if present 
*   5/16 allow other types on output.
	iqual = qual_given( slash_def_att_type) 
        attype_spec = ptype_unknown
        IF ( iqual .GT. 0 ) THEN
	   CALL EQUAL_STRING( cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .			      buff2, status )  
	   IF ( status .NE. ferr_ok ) RETURN
	   IF ( STR_SAME (buff2(1:3), 'str') .EQ. 0) THEN
	      attype_spec =  2   ! NCCHAR
           ELSE IF (STR_SAME (buff2(1:3), 'flo') .EQ. 0) THEN
              attype_spec = 5   ! NCFLOAT
           ELSE IF (STR_SAME (buff2(1:3), 'byt') .EQ. 0) THEN
              attype_spec = 1   ! NCBYTE
           ELSE IF (STR_SAME (buff2(1:3), 'sho') .EQ. 0) THEN
              attype_spec = 3   ! NCSHORT
           ELSE IF (STR_SAME (buff2(1:3), 'int') .EQ. 0) THEN
              attype_spec = 4   ! NCLONG, or in c, NC_INT (4-byte integer)
           ELSE IF (STR_SAME (buff2(1:3), 'dou') .EQ. 0) THEN
              attype_spec = 6   ! NCDOUBLE
           ELSE 
              GO TO 5940
	   ENDIF
	ENDIF

* ... DEFINE ATT/OUTPUT varname.attname.  By default output flag is set to 1
      attoutflag = 1
      iqual = qual_given( slash_def_att_output ) 
      IF ( iqual .GT. 0 ) attoutflag = 1 

* ... DEFINE ATT/QUIET varname.attname
      attoutflag = 1
      def_att_quiet = qual_given( slash_def_att_quiet ) .GT. 0

* get the requested data somehow

        IF (arg_start(1) .LT. pos) arg_start(1) = pos
	CALL GET_PROT_CMND_DATA (  cx_last, ptype_native, status )
        mr = is_mr(1)

        IF ( status .NE. ferr_ok ) THEN      ! 8/6/92
           list_fmt_type = plist_default ! restore for next command
	   list_format_given = .FALSE.
           RETURN
        ENDIF

!! ?? get dataset from varname.attname
* ... evaluate the context without computing the expression to get the dataset

	item = 1
        buff = cmnd_buff(item_start(item):item_end(item)) ! same as buff1?

	CALL GET_NEW_CX( cx_last, cx_cmnd, .TRUE., status )
        IF ( status .NE. ferr_ok ) GOTO 5000
 
        IF (buff(1:1) .EQ. '(') THEN
           dset = cx_data_set(cx_cmnd)   ! initial value to try; will return dset
           CALL ISIT_COORD_VAR ( buff, dset, varname, coordvar, status )
           IF ( status .NE. ferr_ok ) THEN 
              dset = pdset_coordvars  ! a user-defined axis (coordinate variable)
              CALL ISIT_COORD_VAR ( buff, dset, varname, 
     .              coordvar, status )
              IF ( status .NE. ferr_ok ) THEN
                 dset = cx_data_set(cx_cmnd)
                 GOTO 5920
              ENDIF
           ENDIF
        ELSE

* Get the dataset if given as [d=]
            IF (iqual .EQ. 0) iqual = 1
	    IF ( INDEX(buff,'[') .GT. 0 ) THEN
               dset = pdset_irrelevant	! default (not used ...)
               CALL PARSE_NAM_DSET(buff,
     .			 cx_last, dset, cat, var, mods_cx, status)
            ELSE
              cx = is_cx( 1 )
              IF (cx .EQ. 0 .OR. cx .EQ. unspecified_int4)
     .             cx = cx_cmnd
             dset = cx_data_set(cx)
          ENDIF
	ENDIF

* See if the variable is a user-defined variable.
        IF (dset .EQ. pdset_irrelevant .OR. 
     .     dset .EQ. unspecified_int4) THEN

           varname = buff1(1:INDEX(buff1,".")-1)
           CALL FIND_VAR_NAME(pdset_irrelevant, varname, cat, var)
           IF (  var .NE. munknown_var_name .AND.
     .           cat .EQ. cat_user_var) THEN
              dset = pdset_uvars

* Check whether its a LET/D variable
              CALL CD_GET_VAR_ID (dset, varname, varid, status)
              IF (dset.EQ.pdset_uvars .AND. status.NE.ferr_ok) THEN
                 dset = cx_data_set(cx_cmnd)
                 CALL CD_GET_VAR_ID (dset, varname, varid, status)
		 IF (status.NE.ferr_ok) dset = pdset_uvars
              ENDIF
              
           ELSE
              dset = cx_data_set(cx_cmnd) 
           ENDIF
        ENDIF

*  break up varname.attname.  

        CALL BREAK_VARNAME( buff1, dset, varname, attname, 
     .                               varid, status )
        IF (status .NE. ferr_ok) goto 5920

        CALL ADD_ATTRIBUTE(  memry(mr)%ptr, mr, 
     .         buff1, dset, attype_spec, attoutflag, new_att, status )
        IF (status .NE. ferr_ok) GOTO 6500

* Change attribute value
        IF (.NOT. new_att) THEN
           CALL EDIT_ATTRIBUTE(  memry(mr)%ptr, mr, 
     .               buff1, dset, attype_spec, def_att_quiet, status )
           IF (status .NE. ferr_ok) GOTO 6500
        ENDIF


* If the time origin was changed or added, also change units to say
* "units since time origin" using the new time origin info.
        
        iline = TM_GET_LINENUM( varname )

        IF (iline .NE. unspecified_int4) THEN
           slen = TM_LENSTR1(attname)
           IF (MATCH_NAME (attname,  slen, 'TIME_ORIGIN', 11)  .AND.
     .            ( line_direction(iline)(1:1) .EQ. 'T' .OR.
     .              line_direction(iline)(1:1) .EQ. 'F' ) ) THEN
              CALL CD_GET_VAR_ATT_ID (dset, varid, 'UNITS', attid, status)
              IF (status .NE. ferr_ok) GOTO 5960
              got_it = NC_GET_ATTRIB ( dset, varid, 'units',
     .                                 .TRUE., varname, 128,
     .                                 attlen, attoutflag, ustring, 
     .                                 val_buf )
              got_it = NC_GET_ATTRIB ( dset, varid, 'time_origin',
     .                                 .TRUE., varname, 128,
     .                                 attlen, attoutflag, t0string, 
     .                                 val_buf )
              vax_code = STR_UPCASE (buff2, ustring)
              slen = INDEX(buff2, 'SINCE')
              IF (slen .GT. 0) THEN
                 slen = slen - 2
              ELSE
                 slen = TM_LENSTR1(ustring)
              ENDIF
              buff3 = ustring(1:slen) // ' since ' // t0string
              attlen = TM_LENSTR1(buff3)
   
              ustring = 'units'
              CALL CD_REPLACE_ATTR (dset, varid, ustring, NCCHAR, 
     .            attlen, buff3, val_buf, status)
              IF (status .NE. ferr_ok) GOTO 6500
           ENDIF

* If the units were changed on a time axis, add "since time origin"
           
           slen = TM_LENSTR1(attname)
           IF (MATCH_NAME (attname,  slen, 'UNITS', 5)  .AND.
     .        ( line_direction(iline)(1:1) .EQ. 'T' .OR.
     .          line_direction(iline)(1:1) .EQ. 'F' ) ) THEN
              CALL CD_GET_VAR_ATT_ID (dset, varid, 'TIME_ORIGIN', 
     .                 attid, status)
              IF (status .EQ. ferr_ok) THEN 
                 got_it = NC_GET_ATTRIB ( dset, varid, 'time_origin',
     .                                   .TRUE., varname, 128,
     .                                   attlen, attoutflag, t0string, 
     .                                   val_buf )
                 got_it = NC_GET_ATTRIB ( dset, varid, 'units',
     .                                   .TRUE., varname, 128,
     .                                   attlen, attoutflag, ustring, 
     .                                   val_buf )
   
                 vax_code =  STR_UPCASE (buff2, ustring)
                 slen = INDEX(buff2, 'SINCE')
                 IF (slen .GT. 0) THEN
                    slen = slen - 2
                 ELSE
                    slen = TM_LENSTR1(ustring)
                 ENDIF
                 buff3 = ustring(1:attlen) // ' since ' // t0string
                 attlen = TM_LENSTR1(buff3)
   
                 CALL CD_REPLACE_ATTR (dset, varid, attname, NCCHAR, 
     .               attlen, buff3, val_buf, status)
                 IF (status .NE. ferr_ok) GOTO 6500
           ENDIF
        ENDIF
        ENDIF ! (axis .NE. unspecified_int4)

* Update attribute information used by plotting etc (ds_units, ...)
            CALL FIND_VAR_NAME (dset, varname, cat, uvar)
            IF (cat .EQ. cat_user_var .OR. cat .EQ. cat_file_var)
     .           CALL UPDATE_ATTRIBUTES (dset, varname, uvar, status)
            IF (status .NE. ferr_ok) GOTO 6500
	RETURN

**************************************************************************
* DEFINE PYFUNC /NAME=<alias> python.module.name

 1000   IF ( num_args .LT. 1 ) GOTO 6000
        IF ( num_args .GT. 1 ) GOTO 6010

        iqual = qual_given(slash_pyfunc_name)
        IF ( iqual .GT. 0 ) THEN
*           get the function name from /name=<alias>
            CALL EQUAL_STRING(cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .                        buff1, status)
            IF ( status .NE. ferr_ok ) GOTO 5000
            IF ( .NOT. TM_LEGAL_NAME(buff1) ) GOTO 6020
        ELSE
*           create the function name from the last component of python.module.name
            i1 = 0
 1010       i2 = INDEX(cmnd_buff(arg_start(1)+i1:arg_end(1)), '.')
            IF ( i2 .GT. 0 ) THEN
               i1 = i1 + i2
               GOTO 1010
            ENDIF
            vax_code = STR_UPCASE(buff1, 
     .                       cmnd_buff(arg_start(1)+i1:arg_end(1)))
        ENDIF

*       Make sure the scan for standard external functions has been performed
        CALL EFCN_SCAN(gfcn_num_internal)

        i1 = TM_LENSTR1(buff1)
        buff = cmnd_buff(arg_start(1):arg_end(1))
        i2 = arg_end(1) - arg_start(1) + 1
        CALL CREATE_PYEFCN(buff1, i1, buff, i2, err_string, slen)
        IF ( SLEN .GT. 0 ) GOTO 6030

        RETURN

	
**************************************************************************
* DEFINE DATA /AGGREGATE /TITLE= /QUIET
* find name to define
* DEFINE DATA/AGGREGATE/TITLE ENSNAME=D1,D2,D3
* where D1,D2 can be already-open Ferret dataset numbers, or dataset specs
* that would allow Ferret to open the datset.

1100	IF ( num_args .NE. 1 ) GOTO 5350


* define data valid only with /AGGREGATE
	iqual = qual_given( slash_def_aggregate )
        IF ( iqual .EQ. 0 ) GOTO 6100

* Did they say /QUIET

	iqual = qual_given( slash_def_agg_quiet )
        agg_quiet = ( iqual .GT. 0 )

* Is there a /TITLE ?
	iqual = qual_given( slash_def_agg_title )
	buff2 = char_init
	IF ( iqual .GT. 0 ) THEN
	   CALL EQUAL_STR_LC( cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .			      buff2, status )
	   IF ( status .NE. ferr_ok ) RETURN
	ENDIF

* Is there a /T ?
	agg_dim = unspecified_int4
	IF (qual_given( slash_def_agg_t ) .GT. 0) agg_dim = t_dim

* Is there a /E ?
	IF (qual_given( slash_def_agg_e ) .GT. 0) THEN
           IF (agg_dim .EQ. unspecified_int4) THEN
              agg_dim = e_dim
           ELSE
              GOTO 5510
           ENDIF
        ENDIF

* Is there a /F 
	IF (qual_given( slash_def_agg_f ) .GT. 0) THEN
           IF (agg_dim .EQ. unspecified_int4) THEN
              agg_dim = f_dim
           ELSE
              GOTO 5510
           ENDIF
        ENDIF

* Is there a /U  (ag_dim will be set to unspecified_int4)

	IF (qual_given( slash_def_agg_u ) .GT. 0) THEN
           IF (agg_dim .EQ. unspecified_int4) THEN
              agg_dim = f_dim + 1
           ELSE
              GOTO 5510
           ENDIF
        ENDIF

* default aggregation orientation
	IF (agg_dim .EQ. unspecified_int4) agg_dim = t_dim


* define data/hide
	agg_hide = qual_given( slash_def_agg_hide ) .GT. 0

* Get the name of the dataset we are creating
* get it case-sensitive, cuz other dataset names are (they are filenames)
!!!! ******** *sh* NOTE:  CODE SHOULD BE IMPROVED HERE *******
! The DEFINE DATA command has introduced a new and ambiguous set of parsing
! rules, because the argument to the right of the equals may be either a list
! of names (optionally quoted) intermixed with numbers **OR** an expression
! that evaluates to a 1D array of text strings.  A crude heuristic is used a
! few lines below (see have_expr) to determine which of these.  We should
! instead write a new parser to do this task reliebly
! ************************************************************
	CALL NAME_EQUAL_STRING_LC( buff1, pos, status )
	IF ( status .NE. ferr_ok )  GOTO 5000
! hack: do not accept name unless it was followed by an equals sign
! to do so results in a corrupted item list ... could be fixed if important
        IF (pos .GT. 0) THEN
           i = INDEX(cmnd_buff(:pos), "=")
           IF (i.eq.0) pos = 0
        ENDIF

* was a name given?  Or implied through its absence?
	IF ( pos .EQ. 0 ) THEN
* ... "name =" was not supplied
           pos = arg_start(1)    ! point to start of argument list
           IF ( GO_FILE_INPUT() ) THEN
*     ... take name of the GO file exectuting this command
              buffsym = 'GO_FILE'
              CALL GETSYM( buffsym, buff3, slen, ierr )  ! get .agg file path
	         IF (slen.EQ.0 .OR. ierr.EQ.1) CALL ERRMSG
     .                  ( ferr_internal, status, 'xeq_define_go_file', *5000)
              buff1 = TM_CLEAN_FILENAME(buff3 )     ! get dname from dpath
           ELSE
*     ... assign a default name
              IF (agg_dim.EQ.t_dim) THEN
                 buff1 = 'TSERIES'
              ELSEIF (agg_dim.EQ.e_dim) THEN
                 buff1 = 'ENSEMBLE'
              ELSEIF (agg_dim.EQ.f_dim) THEN       
                 buff1 = 'FMRC'
              ELSEIF (agg_dim.EQ.f_dim+1) THEN       
                 buff1 = 'UNION'
              ENDIF
              buff3 = buff1    ! use dname as dpath, too
           ENDIF
        ELSE
* ... "name =" was supplied
	   IF ( .NOT.TM_LEGAL_NAME(buff1) ) GOTO 5410
	   IF ( .NOT.TM_LEGAL_NAME_OP(buff1) ) GOTO 5430
           IF ( TM_LENSTR1(buff1) .GT. 128 ) GOTO 5410
! *sh* 11/15 - As-is the parsing of the "name=item1, item2, ..."
* The routine NAME_EQUAL_STRING parses out the "name" as the first item of
* a list and returns the start position of the next item in the list
           item_start(1) = pos
           buff3 = buff1    ! use dname as dpath, too
        ENDIF

* which syntax has been used?
*      DEFINE DATA/AGG agname = data1, data2, data3, ...
*  or
*      DEFINE DATA/AGG agname = <string_array_expression>
* we will determine this through heuristics
        have_expr = INDEX(cmnd_buff(pos:),"{") .GT. 0
     .         .OR. INDEX(cmnd_buff(pos:),"(") .GT. 0
        IF (.NOT.have_expr) THEN
           IF ( num_items .EQ. 1
     .     .AND.INDEX(cmnd_buff(item_start(1):item_end(1)),'.').EQ.0
     .     .AND.INDEX(cmnd_buff(item_start(1):item_end(1)),'/').EQ.0
     .                                                            ) THEN 
              CALL FIND_VAR_NAME(pdset_irrelevant,
     .                           cmnd_buff(item_start(1):item_end(1)),
     .                           cat, var)      
              have_expr = var .NE. munknown_var_name
           ENDIF
        ENDIF

        IF (have_expr ) THEN
* ... get array of string names from a memory variable
           CALL ALL_1_ARG
	   num_args = 1	 ! used by GET_CMND_DATA
	   arg_start(1) = pos ! skip over "name ="
	   CALL GET_CMND_DATA (  cx_last, ptype_string, status )
	   IF ( status .NE. ferr_ok ) RETURN
           IF ( num_uvars_in_cmnd .NE. 1 ) GOTO 6400
           cx = is_cx(1)
* ... make sure it's an line (not a point,plane,etc.) of data
	   CALL GET_CX_DIMS( cx, ndim, dim )
	   IF ( ndim .GT. 1 ) GOTO 6400
	   idim = dim(1)
	   nagfiles = CX_DIM_LEN( idim, cx )
           mr = is_mr(1)
        ELSE
           nagfiles = num_items
           mr = dummy_mr
        ENDIF

*   buff1=dname, buff2=dtitle, buff3=dpath
        IF (agg_dim .EQ. t_dim) THEN
           t_regular  = .FALSE.   ! ToDo /REGULART -- not yet implemented
           use_strict = .FALSE.   ! ToDo ?? T coordinate micro-adjustment ??
           CALL INIT_T_AGGREGATE_DSET(memry(mr)%ptr,
     .                  nagfiles, have_expr, buff1, buff3, buff2, 
     .                  t_regular, use_strict, dset, status)
        ELSEIF (agg_dim .EQ. f_dim+1) THEN
	   agg_dim = unspecified_int4
	   CALL INIT_U_AGGREGATE_DSET (memry(mr)%ptr,
     .                  nagfiles, have_expr, buff1, buff3, buff2, dset,
     .                  agg_quiet, agg_hide, agg_dim, status)
        ELSE
	   CALL INIT_EF_AGGREGATE_DSET (memry(mr)%ptr,
     .                  nagfiles, have_expr, buff1, buff3, buff2, dset,
     .                  agg_quiet, agg_hide, agg_dim, status)

        ENDIF
	IF (status .NE. ferr_ok) GOTO 5000

* Make this the current dataset
	cx_data_set( cx_last ) =  dset

	RETURN


**************************************************************************
* DEFINE ANNOTATION /USER/NORM/NOUSER/XPOS/YPOS/HALIGN/VALIGN/ANGLE/SIZE/NLAB label_text
* qualifiers in the same order as ANNOTATE/USER/...
*
* Find label text

1200	IF ( num_args .LT. 1 ) GOTO 6200

	item = 1
	buff1 = cmnd_buff(item_start(item):item_end(item))

* ...DEFINE ANNOTATION/NLAB 
c ?? if nlab=0, use next avail slot?
	iqual = qual_given( slash_def_annot_nlab )
	IF ( iqual .GT. 0  ) THEN
	   CALL EQUAL_VAL( cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .			      val, status )
	   buff2 = 'NLAB'
	   IF ( status .NE. ferr_ok ) GOTO 6300
	   IF ( val.EQ.unspecified_val4 .OR. val.LT.0) GOTO 6300
	   nlab = INT(val)
	ELSE
	   nlab = 0
	ENDIF

* initialize 

	size = 0.12

* Get settings

	CALL SET_ANNOTATION (user, nouser, norm, xloc, yloc, halign, 
     .         angle, size, status)
        IF (status .NE. ferr_ok) GOTO 5000 

	CALL PUT_ANNOTATION (user, nouser, norm, xloc, yloc, halign, 
     .         angle, size, nlab, buff1, status)
        IF (status .NE. ferr_ok) GOTO 5000 

	RETURN
**************************************************************************

* error exit
 5000	RETURN
 5100 	CALL ERRMSG( ferr_syntax,status,'illegal name: '//buff3,*5000 )
 5200 	CALL ERRMSG( ferr_invalid_command ,status,
     .          'cannot alias IF, ELIF, ELSE and ENDIF',*5000 )
 5300	CALL ERRMSG( ferr_invalid_command, status,
     .		'DEFINE what name?', *5000 )
 5350	CALL ERRMSG( ferr_syntax, status,
     .		'Should be "NAME = dset1, dset2, dset3, ..."', *5000 )
 5305	CALL ERRMSG( ferr_TMAP_error, status, ' ', *5000 )
 5310	CALL ERRMSG( ferr_grid_definition, status,
     .		'name already in use:'//buff3(:TM_LENSTR1(buff3)), *5000 )
 5320	CALL ERRMSG( ferr_grid_definition, status,
     .		'unknown grid or axis:'//buff1(:TM_LENSTR1(buff1)), *5000 )
 5330	CALL ERRMSG( ferr_grid_definition, status,
     .		'inappropriate orientation for '//ww_dim_name(idim)//
     .		' axis:'//buff1(:TM_LENSTR1(buff1)), *5000 )
 5400 	CALL ERRMSG( ferr_syntax, status,
     .			buff1(:TM_LENSTR1(buff1))//' = ???', *5000 )
 5410   CALL ERRMSG( ferr_syntax,status,'illegal name: '//buff1,*5000 )
 5420   CALL ERRMSG( ferr_syntax,status,'cannot define: '//buff1,*5000 )
 5430   CALL ERRMSG( ferr_syntax,status,'illegal name, matches an operator: '
     .			//buff1,*5000 )
 5440	CALL ERRMSG( ferr_syntax, status,
     .			cmnd_buff(pos:len_cmnd)//pCR//err_string, *5000 )
 5470	CALL ERRMSG( ferr_unknown_data_set, status,
     .			buff3(:TM_LENSTR1(buff3)), *5000 )
 5480   CALL ERRMSG( ferr_syntax,status,
     .	  '/REMOTE variable definition must also specify /D=',*5000 )
 5490   CALL ERRMSG( ferr_syntax,status,
     .	  '/REMOTE variable expression may not contain [d= ',*5000 )
 5505	CALL ERRMSG( ferr_invalid_command, status,
     .		'DEFINE AXIS/DEPTH needs /Z=lo:hi:del', *5000 )
 5510	CALL ERRMSG( ferr_invalid_command, status,
     .		'Conflicting /X,/Y,/Z/T/E or /F axis orientations given',
     .								*5000 )
 5520	CALL ERRMSG( ferr_grid_definition, status,
     .			'error in start,end,delta', *5000 )
 5525	CALL ERRMSG( ferr_grid_definition, status,
     .			'Axis length exceeds modulo length', *5000 )
 5530	CALL ERRMSG( ferr_grid_definition, status,
     .			'NPOINTS=1 incompatible with limits given', *5000 )
 5540	CALL ERRMSG( ferr_grid_definition, status,
     .		'/T0='//buff2(:TM_LENSTR1(buff2)), *5000 )
 5550	CALL ERRMSG( ferr_grid_definition, status,
     .		'inappropriate units:'//buff1(:TM_LENSTR1(buff1)), *5000 )
 5560	CALL ERRMSG( ferr_grid_definition, status,
     .		'unrepairable repeated axis coords', *5000 )
 5570	buff1 = TM_FMT(FLOAT(i1-frst_pt+1), 14, 16, slen)
	CALL ERRMSG( ferr_grid_definition, status,
     .		'data for DEFINE AXIS/FROM_VARIABLE is not monotonically increasing at index '
     .		//buff1(:slen), *5000 )
 5580	CALL ERRMSG( ferr_grid_definition, status,
     .		'data for DEFINE AXIS/FROM_VARIABLE is ambiguous', *5000 )
 5582	CALL ERRMSG( ferr_grid_definition, status,
     .		'illegal argument for DEFINE AXIS/NPOINTS', *5000 )
 5590	CALL ERRMSG( ferr_prog_limit, status,
     .		'axis coordinate storage exhausted - issue CANCEL AXIS/ALL', *5000  )
 5592	CALL ERRMSG( ferr_prog_limit, status,
     .		'axis coordinate storage exhausted -  '//
     .		'use /EDGES not /BOUNDS to save space', *5000 )
 5600   slen = TM_LENSTR1(buff3)
        CALL ERRMSG( ferr_syntax, status,
     .               'error initializing '//buff3(:slen), *5000 )
 5610	CALL ERRMSG( ferr_prog_limit, status,
     .		'redefine or cancel an existing viewport', *5000 )
 5620 	CALL ERRMSG( ferr_out_of_range, status,
     .			cmnd_buff(qual_start(qp):qual_end(qp)), *5000 )
 5630 	CALL ERRMSG( ferr_syntax, status,
     .			cmnd_buff(qual_start(qp):qual_end(qp)), *5000 )
 5640 	CALL ERRMSG( ferr_invalid_command, status,
     .			'cannot re-define FULL viewport', *5000 )
 5650 	CALL ERRMSG( ferr_syntax, status,
     .	'DEFINE VIEWPORT/SIZE and /TEXT are mutually exclusive', *5000 )

 5660 	CALL ERRMSG( ferr_syntax, status,
     .	'DEFINE VIEWPORT/AXES cannot be used with obsolete /ORIGIN'
     .  //', /CLIP/ or /SIZE', *5000 )

 5710	CALL ERRMSG( ferr_prog_limit, status,
     .		'use CANCEL ALIAS to reclaim space', *5000 )
 5720	err_string = 'Invalid calendar name. Names are'
        DO 5721 i1=1, max_calendars
           len_cal = TM_LENSTR1(err_string)
           slen = TM_LENSTR1(allowed_calendars(i1))
           err_string = err_string(:len_cal)//', '//
     .                   allowed_calendars(i1)(:slen)
           len_cal = len_cal + slen
 5721   CONTINUE
        CALL ERRMSG( ferr_syntax, status,err_string, *5000 )

5730	CALL ERRMSG( ferr_syntax,status,
     .     'cannot have /BOUNDS and /EDGES together ',*5000 )

5740	buff1 = TM_FMT(FLOAT( n), 14, 16, slen)
        buff2 = TM_FMT(FLOAT(n2), 14, 16, s2len)
        CALL ERRMSG( ferr_grid_definition, status,
     .     'dimension of bounds ('// buff2(:s2len)//
     .     ') must be 2*N or N+1, N=number of axis coordinates ('//
     .     buff1(:slen) //')', *5000 )
5745	buff1 = TM_FMT(FLOAT( n), 14, 16, slen)
        buff2 = TM_FMT(FLOAT(n2), 14, 16, s2len)
        CALL ERRMSG( ferr_grid_definition, status,
     .     'dimension of upper&lower bounds ('// buff2(:s2len)//
     .     ') must be N, N=number of axis coordinates ('//
     .     buff1(:slen) //')', *5000 )

5750	CALL ERRMSG( ferr_grid_definition, status,
     .   'BOUNDS specified do not correctly enclose coordinate points', 
     .   *5000 )
5760	CALL ERRMSG( ferr_grid_definition, status,
     .   'DEFINE AXIS/LIKE= Axis not found '//likename(:TM_LENSTR1(likename)),
     .   *5000 )
5770	CALL ERRMSG( ferr_grid_definition, status,
     .   'DEFINE AXIS/MONTHLY specify /UNITS=month or omit /UNITS (MONTH is default)', 
     .   *5000 )
5780	CALL ERRMSG( ferr_grid_definition, status,
     .   'DEFINE AXIS/MONTHLY True-month axis: /BOUNDS not allowed. Use /T=lo:hi:del', *5000 )
5790	CALL ERRMSG( ferr_grid_definition, status,
     .    'DEFINE AXIS/MONTHLY True-month axis: Definition /FROMDATA not allowed. '//
     .    'Use /T=LO:HI:DEL', *5000 )
5800	CALL ERRMSG( ferr_grid_definition, status,
     .   'DEFINE AXIS/MONTHLY True-month axis: /NPOINTS not allowed. Use /T=lo:hi:del', *5000 )
5810	CALL ERRMSG( ferr_grid_definition, status,
     .   'DEFINE AXIS/MONTHLY True-month axis delta-t must be 1', *5000 )
5820	CALL ERRMSG( ferr_grid_definition, status,
     .   'DEFINE AXIS/MONTHLY True-month axis: needs /T=lo:hi:del', *5000 )
5830	CALL ERRMSG( ferr_grid_definition, status,
     .   'DEFINE AXIS/MONTHLY month boundaries cannot be day '//datestr(1:2)//
     .   '. Day does not exist in all months.', *5000 )
5840	CALL ERRMSG( ferr_grid_definition, status,
     .   'DEFINE AXIS/MONTHLY must use calendar-time definition', *5000 )
5900	CALL ERRMSG( ferr_invalid_command, status,
     .		'DEFINE what name.attribute?', *5000 )
5920    slen = TM_LENSTR1(varname)
        IF (dset .GT. 0) THEN
           CALL ERRMSG( ferr_invalid_command, status,
     .		'variable or axis undefined or not in dataset '//
     .            varname(:slen), *5000 )
        ELSE
           CALL ERRMSG( ferr_invalid_command, status,
     .		'variable or axis does not exist '//
     .           varname(:slen), *5000 )
        ENDIF
           
5930    buff1 = 'string'
        IF (at_type(1) .EQ.ptype_float) buff1 = 'float'
        slen = 6
        buff2 = 'string'
        if (attype_spec .EQ. ptype_float) buff2 = 'float'
        CALL ERRMSG( ferr_invalid_command, status,
     .		'TYPE specified does not match type of values'//
     .           cmnd_buff(pos:len_cmnd)//' is '// buff1(:slen)//
     .           'TYPE given is '// buff2(:slen), *5000 )

5940  slen = TM_LENSTR1(buff2)
      CALL ERRMSG( ferr_invalid_command, status,
     .	buff2(:slen)//' not allowed as argument of DEF ATT/TYPE='//pCR//
     .  'Must be STRING or FLOAT ',*5000 )

5960  slen = TM_LENSTR1(buff1)
      CALL ERRMSG( ferr_invalid_command, status,
     .   'cannot set T0 unless Units are also set'//
     .    buff1(:slen), *5000 )

 6000 CALL ERRMSG(ferr_invalid_command, status,
     .  'No Python module named in DEFINE PYFUNC command', *5000)

 6010 CALL ERRMSG(ferr_invalid_command, status,
     .  'More than one Python module named in DEFINE PYFUNC command',
     .   *5000)

 6020 CALL ERRMSG(ferr_syntax, status, 'illegal name: '//buff1, *5000)

 6030 CALL ERRMSG(ferr_invalid_command,status,err_string(1:slen),*5000)

 6100 CALL ERRMSG(ferr_syntax, status, 
     .    'DEFINE DATA valid only with /AGGREGATE: ', *5000)

! 6110 CALL ERRMSG(ferr_aggregate_error, status, 
!     .    'Aggregate dataset not defined', *5000)

 6200	CALL ERRMSG( ferr_invalid_command, status,
     .		'No text given for DEFINE ANNOTATION', *5000 )

 6300	CALL ERRMSG( ferr_invalid_command, status,
     .		'/NLAB missing or invalid value', *5000 )
 6400   CALL ERRMSG( ferr_grid_definition, status,
     .	    '"DEFINE DATA/AGGREGATE agname =" requires a list of names',
     .          *5000 )

 6500  slen = TM_LENSTR1(varname)
       CALL ERRMSG (ferr_internal, status,
     . 'Error defining attribute on variable '//varname(:slen), *5000)

	END

	SUBROUTINE FIND_MR_SLOT( mr, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* locate an unused slot in the memory variable table and assign it to the
* hash pile associated with the given context (cx)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 7/21/88
* V200:  6/12/89 - delete priorities handled through linked lists
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V702 *sh* 1/17 - split half of the code into the new HOOK_MR_SLOT
*                  as part of the new dynamic memory management

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'

* calling argument declarations:
	INTEGER mr, status

* internal variable declarations:

*****

* start with the first entry on the free mr list
	mr = mv_flink( 0 )

* if it isn't free, then free the most vulnerable mr on the delete chain
	IF ( mr .EQ. 0 ) THEN
	   mr = mr_del_blink(0)
	   IF ( mr .EQ. 0 ) GOTO 5010
	   CALL DELETE_VARIABLE( mr )
	ENDIF

* remove it from the free list to indicate 
*    ... remove from free list head
!	mr = mv_flink( 0 )
	mv_flink( 0 ) = mv_flink( mr )

* successful completion
	status = ferr_ok
 5000	RETURN

* error exit : no space available (empty delete chain)
 5010	CALL ERRMSG( ferr_too_many_vars, status,' ', *5000 )
	END

	SUBROUTINE GET_CONTEXT_MODS
     .		      ( dflt_cx,
     .			text_buff,
     .			mods_cx,
     .			max_list_len,
     .			list_len,
     .			it_start,
     .			it_end,
     .			report_unknown,
     .			status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* interpret a list of coordinate limit specifiers and other special qualifiers
* and put the interpreted list of modifications into the buffer mods_cx
* note: no initialization is done except on those dimensions that are modified

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 6/25/86
* revision 1.0 - 3/2/87  - changed to "/n=lo:hi@XXX" syntax
* revision 1.1 - 3/20/87 - changes for new TMAP library
* revision 1.2 - 4/28/87 - allowed X=@NUL syntax and "relative" notation
* revision 1.3 - 6/25/87 - if x=@AVE and y=@AVE then do AAV ("area average")
*			 - also corrected bug for qualifiers with first letter
*			   of x,y,z,t,i,j,k,l,d or g
* revision 1.4 - 8/18/87 - added decoding of transformation argument and special
*			   check that @SHF is applied only to subscripts
* revision 1.5 - 8/29/87 - added GFDL_VMS.PARM
* revision 1.6 - 9/14/87  - oddness check for @SBX
*			    and reverse order of lo>hi instead of error
*			    and /X with no position is ignored
* revision 1.7 - 9/23/87  - allow 4 character region names from cx_name
* revision 1.8 - 3/3/88   - forbid @SHF with world coords to avoid loosing
*			    transformation in FINISH_1_CONTEXT_MO*
* revision 1.9 - 3/23/88  - added processing of date/time strings
* revision 2.0 - 7/25/88  - added /G= decoding (requiring dflt_cx)
*			    and /D=dset_name (instead of number)
* revision 2.1 - 9/28/88  - bug fix: re-ordering date string test wrong
* revision 2.2 -11/22/88  - new io library FIND_GRID_NUMBER -->TM_GET_GRIDNUM
* revision 2.3 - 1/4/89   - added regridding transformations
*			  - corrected bugs in VAR[Q=xxx] (Q syntax) and @FAV
* revision 2.4 - 3/14/89  - distinguish between X=160E:160W and X=160W:160E
*			    using "formatted" flag in TRANSLATE_LIMIT
* revision 2.5 - 4/24/89  - bug fix:  iend --> namelen
* V200:  6/28/89 - eliminated %%_relative, added grid_needs_dset
*	10/20/89 - check for x=lo::hi (colon2_pos error)
*	 2/16/90 - more detailed error reporting
* Unix/RISC port - 1/91 - cant use "//" with CHAR*(*) variable
*                - 8/91 added Hanning,Partzen and Welch smoothers to err msg
* V230: 1/21/92 - coach user to use SHOW TRANSFORMS for transform errors
*       8/10/92 - allow multiple specifications of same axis eg u[@zlim,z=@trn]
*       8/22/92 - incorporated GX=grid@trn regridding notation (major chges)
*               - fixed improper error messages using risc_buff
*               - do not impose area average regridding h--> GET_CONTEXT_GRID
*               - trap G=pseudo-var error
* V320:12/29/94 - use SPLIT_LIST to redirect tty output for GUI
* V400: 3/20/95 - ignore any region info that contains grave accents.  This
*		  is because this routine is called **during** the process
*		  of evaluating the grave accent expressions.
* V402: 7/95	- Allow nested [] of the form vname1[G=vname2[D=dset]]
* V420: 9/95	- Support for implicit grid (e.g. var[gx=axis_name]
*	    Note: This change also altered slightly the interpretation of the
*		  regridding qualifiers.  "gx=salt" now means to pull only
*		  the X axis from the variable SALT --> an implicit grid
* 	(IBM/AIX port of V411): 10/5/95 - buffer "READ(var,*"
*	1/9/96  - (for modulo regridding) decode regrid transform names
*		  in excess of 3 characters
*	2/13/96 - allow GX=lo:hi:delta equivalent to X=lo:hi:delta
*	2/23/96 - fix bugs left in check added 8/10/92 that miscode
*		   [Y=@DDF,J=1] --> added "set_implicitly" in addition to
*		   already existing "first_time"
* V430:  7/1/96 - incorporate 4D transformations: AVE, VAR, DIN, NDG, NBD
*	7/10/96 - allow axes of unknown orientation to be used in a GX=axis
* Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
* V450:  7/17/97 - GX=grid_name does not generate X-only regridding
*       8/97 - *kob* - set cx_calendar to show whether a time was entered
*                      as a date string.
*                    - also check cx_calender rather than fmat_lo or fmat_hi
* V491:  3/2/98 *sh* - increased length of "name" to accomodate
*                    e.g. gt="1-jan-1990:12:00":"15-jan-1990:12:00":120
*                    and allow special check for leading quotation mark
* V510: 8/99 *sh* - allow g=uvar and return encoded char pos of uvar
*	12/99 *sh* - save info about formatting of inputs in cx_formatted
*	12/99 *sh* - added ugly hack to allow multiple axes as in "GXY=gg"
*	12/99 *sh* bug fix: g=user_var failed if user_var was pure abstract
*	3/00  *sh* - remove old trap for mixed dates and time steps
*	4/00  *sh* - since netCDF uses dynamic grids now, DEALLOC will
*		     deallocate axes within implicit grids. Accomodate that.
* V520: 6/00 *sh* bug fix: cx_grid_needs_dset is not set correctly when the
*		           syntax is X[Gx=var[D=dset]]
* V530: 3/01 *acm* - Pass calendar ID, if available, to TRANSLATE_LIMIT
* V532 5/01 *sh*: minor bug fix: detect extra colon in "i=1:5:2:"
* V533:6/01 *sh* bug fix: cx_grid_needs_dset is not set correctly when the
*			  g=var and var is a uvar with self-contained dset 
*
* *kob* 2/03 - replace call to intrinsic func CHAR with its octal
*              constant equivalent - needed for g77 port
* V552 3/03 *acm* - variable "name" may be the name of a dataset, 
*                    increase its length from 48 to 512 characters.
* V552 5/03 *acm* - bug fixes for parsing mulit-axis regrids, when uvar is
*                   not loaded [gxy=var]  and [gxy=var[d=dset]]
* v554 11/03*acm* - changing a comment, only. 
* v5.80 *acm* 11/04 use cx_cal_id to store the calendar used when
*                   computing world coordinates.
* v6.12 *acm*  7/08 Fix bug 1585: allow for alternative calendars. See if 
*                   there is a calendar definition for the grid and axis, 
*                   and set the calendar ID before translating the date string 
*                   to an axis coordinate.
* V6.8  *acm* 3/12 remove block that checks for qual_given(slash_T0). Neither 
*                  slash_t0 nor orient are defined here.
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V6.90 *sh* 12/13 support for auxiliary regridding variables:
*                  temp[gz(depth)=zax@ave]
*		   including special interpretation of gz(depth)=100 (a point)
*		   ensure that the same axis region isn't set twice (line 200)
*		   Detect 'layerz' and 'curvi' automation flags
*	           Note that errors will be silent in dependency_tree_mode
*		   Set cx_g_eq_regrid logical (used to be local "regrid_dims")
* V6.91+ *acm* 8/14 Fix ticket 2189
* V693+ *sh* 12/14 keep track of regridding using cx_vtree* for ticket #2195
*                  also fix err693_undetected_regrid_dset.jnl
* V695  *acm* 2/15 cx_calendar stores info about calendar formatting of T and F axes
* V695+ *sh* 2/15 add support for _DQ_ 
* V698+ *sh* 5/15 bug fix: allow blanks before aux varname e.g. "gz( depth)"
* V698+ *sh* 6/15 bug fix: all axes to allow [g*(aux)=pt], not just z_dim
* V698+ *acm* 2/16 Ticket 2362: Change /D= qualifier to /DATASET=
* V751  *acm* 5/19 Ticket 1931; don't try to translate the delta value in LO:HI:DEL
*                  from a formatted string.  It's just a number.

* specifiers may give coordinate in subscript units (/I,/J,/K,/L) or
* may give coordinate in "world" units (/X,/Y,/Z,/T)
* the specifiers may be of any of the following forms:
*	/q=val			specifies a single value
*	/q=val_1:val_2		specifies a range of values
*	/q=val_1:val_2:val_inc	specifies a range and an increment
*	/q=val_1:val_2@XXX	specifies a range with a transformation XXX
*	/q=@XXX			specifies a transformation XXX, only

* this routine also handles the items modifying a var name in square brackets
*        D=dset_or_var
*        Gxyzt = var_grid_or_axis@XXXX
*  ... and added v6.85:
*	 Gxyzt(varx,vary,...)=var_grid_or_axis@XXXX ! regrid with aux vars


* logical arguments:
*	report_unknown 	  if .TRUE. then unknown specifiers are errors

        IMPLICIT NONE
	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'xdset_info.cmn_text'
	include	'xtm_grid.cmn_text'
	external xdset_info_data
	include 'errmsg.parm'	
	include 'ferret.parm'	
	include 'gfdl_vms.parm'	
	include 'interp_stack.parm'
	include 'xalgebra.cmn'
	include 'xprog_state.cmn'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xtext_info.cmn'
	include 'xdependency_tree.cmn'
	include 'xrisc.cmn'		! for RISC/FORTRAN

* calling arguments:
	CHARACTER*(*)	text_buff
	INTEGER		mods_cx, status, max_list_len, list_len, ict,
     .			dflt_cx, it_start(max_list_len), it_end(max_list_len)
	LOGICAL		report_unknown

* internal variables:
	LOGICAL		INVALID_R8_TO_I4, TM_DIGIT, MATCH4,
     .			atsin, colon, colon2, atcolon, first_time(nferdims),
     .			morph_gx_to_x(nferdims), set_implicitly(nferdims),
     .			fmat_lo, fmat_hi, logical_dummy, single_char,
     .			has_g_eq_unkn_uvar, gdset_included, has_auxvar
	INTEGER		ATOM_POS, STR_CASE_BLIND_COMPARE, STR_UPCASE,
     .			TM_GET_GRIDNUM, KNOWN_GRID, FIND_DSET_NUMBER,
     .			REGION_NUMBER, TM_GET_LINENUM, TM_AXIS_DIRECTION,
     .			TM_LENSTR1,
     .			equal_pos, colon_pos, atsin_pos, atcolon_pos, grid,
     .			suborval, lo_start, lo_end, namlen, rgdim,
     .			hi_start, hi_end, item, idim, del_start, del_end,
     .			colon2_pos, vax_code, istart, iend, itrans,
     .			dset, variable, category, name_end, next_char, i,
     .			impl_grid, axis, other, naxes, aux_arg_namlen,
     .			aux_lparen_pos, aux_rparen_pos, aux_arg_count,
     .			iqual,this_dim
	CHARACTER*(1)	UPPER_CASE, region_qual(nferdims,2),
     .			letter, letter2
	CHARACTER	name*512, comment*12, transnam*6, buff*32, 
     .                  cal_name*32, letters*3
	REAL*8		temp
	INTEGER		dstart, dend, lbrac, state, gdset, itest, nend, ii


* internal parameter declarations:
	CHARACTER*1	tab
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
#else
	PARAMETER     ( tab = CHAR(9))
#endif
	INTEGER		looking_for_D, looking_for_eq, looking_for_name,
     .			done_looking, cal_id, TM_GET_CALENDAR_ID
	PARAMETER     ( looking_for_D = 1,
     .			looking_for_eq = 2,
     .			looking_for_name = 3,
     .			done_looking = 9)

	DATA (region_qual(idim,1),idim=1,nferdims) / 'I','J','K','L','M','N' /,
     .       (region_qual(idim,2),idim=1,nferdims) / 'X','Y','Z','T','E','F' /
!     .       other_qual(1) / 'D' /,	! /DATA_SET=
!     .       other_qual(2) / 'G' /	! /GRID=
!     .       other_qual(3) / 'S' /	! var[z=100,LAYERZ]
!     .       other_qual(4) / 'C' /	! var[x=140e,Y=0,CURVILINEAR]

* local parameter declarations (as in xeq_define)
	INTEGER	    slash_calendar
	PARAMETER ( slash_calendar = 1 + 15)

* initialize
	dset = cx_data_set( dflt_cx)
        axis = unspecified_int4
        grid = unspecified_int4
        DO 10 idim = 1, nferdims
	   morph_gx_to_x(idim)  = .FALSE.
	   set_implicitly(idim) = .FALSE.
!	   cx_g_eq_regrid(idim) = .FALSE.   ! initialize *inside* of 500 loop 6/2015
	   first_time(idim)     = .TRUE.
 10	CONTINUE
	has_g_eq_unkn_uvar = .FALSE.
	cx_vtree_regrid_ntarget = 0

* check in advance for the use of pre-specified ("/@") limits and D=
* (the results of D= may be relevant in G=var)
	DO 50 item = 1, list_len
	   istart = it_start(item)
	   iend   = it_end  (item)
	   risc_buff  = text_buff(istart:iend)		! for RISC/FORTRAN
	   len_rbuff  = MIN(size_rbuff, iend-istart+1)	! for RISC/FORTRAN
	   letter = text_buff(istart:istart)
	   IF (letter .EQ. '@') THEN
	      IF ( iend .EQ. istart ) GOTO 5015
* ... pre-specified limit has been requested
	      ict = REGION_NUMBER( text_buff( istart+1:iend) )
	      IF ( ict .EQ. unspecified_int4 ) GOTO 5100
* ... set predefined context limits as defaults
 20	      DO 30 idim = 1, nferdims
	         IF ( cx_given( idim, ict ) ) THEN
	            cx_lo_ss ( mods_cx, idim ) = cx_lo_ss ( ict, idim )
	            cx_hi_ss ( mods_cx, idim ) = cx_hi_ss ( ict, idim )
	            cx_lo_ww ( idim, mods_cx ) = cx_lo_ww ( idim, ict )
	            cx_hi_ww ( idim, mods_cx ) = cx_hi_ww ( idim, ict )
* kob 9/97 - set cx_calendar as well
		    IF (idim .EQ. t_dim .OR. idim .EQ. f_dim) 
     .                 cx_calendar(idim,mods_cx) = cx_calendar(idim,ict)
	            cx_trans ( idim, mods_cx ) = cx_trans   ( idim, ict )
	            cx_trans_arg(idim, mods_cx ) = cx_trans_arg(idim, ict )
	            cx_by_ss ( idim, mods_cx ) = cx_by_ss( idim, ict )
	            cx_given ( idim, mods_cx ) = cx_given( idim, ict )
!                    first_time(idim) = .FALSE.	! pre 2/23/96
                    set_implicitly(idim) = .TRUE.
	         ENDIF
 30	      CONTINUE
	   ELSEIF (letter.EQ.'d' .OR. letter.EQ.'D' ) THEN
	      IF ( iend .EQ. istart ) GOTO 5015
* Match any portion of DATASET=
               
	      equal_pos = ATOM_POS( text_buff(istart:iend), '=' )
	      IF ( equal_pos .EQ. atom_not_found
     .	         .OR. equal_pos .EQ. atom_illegal_pos ) GOTO 50
              namlen = equal_pos-1
	      IF (namlen.GT.1) THEN
	         name = text_buff(istart:istart+namlen-1)
		 IF (.NOT. MATCH4(name, namlen, 'DATA', 4) ) GOTO 50
	      ENDIF
	      
* We just want to go on if there is a grave-accent expression, e.g. 
*  `var,r=dsetnum` inside the "d="
	      do ii = istart+2,iend
	         IF (  text_buff(ii:ii) .EQ. '`') GOTO 50
	      enddo

* ... D=data_set given

	      equal_pos = equal_pos + istart - 1
	      name = text_buff(equal_pos+1:iend)
	      namlen = iend-equal_pos
	      dset = FIND_DSET_NUMBER( name )
	      IF ( dset .EQ. unspecified_int4 ) GOTO 5040
	      cx_data_set( mods_cx ) = dset
	      cx_dset_gvn( mods_cx ) = .TRUE.
	   ENDIF
 50	CONTINUE

* Get calendar type from the command line

        cal_name = 'GREGORIAN'		! default
        name = " "
        cal_id = TM_GET_CALENDAR_ID (cal_name)
	iqual = qual_given( slash_calendar )
	IF ( iqual .GT. 0 ) THEN
	   CALL EQUAL_STRING( cmnd_buff(qual_start(iqual):qual_end(iqual)),
     .			      cal_name, status )
	   IF ( status .NE. ferr_ok ) RETURN
           name = cal_name
	ENDIF

* 9/01 CF conventions have adopted the name 360_day for a 360-day year.

	IF (name .EQ. '360') cal_name = '360_DAY' 
	IF (name .EQ. 'D360') cal_name = '360_DAY' 
	IF (name .EQ. 'STANDARD') cal_name = 'GREGORIAN' 
	IF (name(1:6) .EQ. 'COMMON') cal_name = 'NOLEAP' 
	IF (name(1:6) .EQ. '365_DA') cal_name = 'NOLEAP' 
	IF (name(1:6) .EQ. '366_DA') cal_name = 'ALL_LEAP' 
	cal_id = TM_GET_CALENDAR_ID (cal_name)

* loop through list of other ( non /@ ) items provided
	DO 500 item = 1, list_len
	   istart = it_start( item )
	   iend   = it_end  ( item )
	   risc_buff  = text_buff(istart:iend)		! 8/92
	   len_rbuff  = MIN(size_rbuff, iend-istart+1)	! 8/92
	   letter = UPPER_CASE(text_buff(istart:istart))! 8/92
	   has_auxvar = .FALSE.				! 12/13

* ... 6/2015 initialize this inside of 500 loop to allow [gx(xaux)=xax,gy(yaux)=yax]
           DO idim = 1, nferdims
	      cx_g_eq_regrid(idim) = .FALSE.
	   ENDDO

* ignore any region information that contains grave accents
	   IF ( INDEX(risc_buff,'`') .GT. 0 ) GOTO 500

* identify 'LAYERZ' and 'CURVI' qualifiers
	   IF (MATCH4(risc_buff,len_rbuff,
     .			  'LAYE',   4          ) ) THEN
	      cx_aux_given(z_dim,mods_cx) = .TRUE.
	      GOTO 500
	   ELSEIF (MATCH4(risc_buff,len_rbuff,
     .			  'CURV',   4          ) ) THEN
	      cx_aux_given(x_dim,mods_cx) = .TRUE.
	      cx_aux_given(y_dim,mods_cx) = .TRUE.
	      GOTO 500
	   ENDIF

* all other valid specifiers are single characters or double character
* regrid specifiers of the form G*, when * is I,J,K,L,M,N,X,Y,Z,T,E or F.
* Is this ?
	   IF ( iend .GT. istart ) THEN
              letter2 = text_buff(istart+1:istart+1) ! 8/92
	      IF (  letter2 .EQ. ' '
     .	       .OR. letter2 .EQ. '='
     .	       .OR. letter2 .EQ. tab ) THEN
* ... is it a region specifier (single character) ?
                 single_char = .TRUE.
	         naxes = 1
                 DO 54 suborval = 1,2
	         DO 54 idim     = 1,nferdims
	            IF ( letter.EQ.region_qual(idim,suborval) ) GOTO 200
 54              CONTINUE
                 GOTO 100     ! not a region specifier
              ELSE                                    ! 8/92
                 single_char = .FALSE.
                 letter2 = UPPER_CASE(letter2)
                 DO 60 suborval = 1,2
	         DO 60 idim     = 1,nferdims
	            IF ( letter2.EQ.region_qual(idim,suborval) ) GOTO 100
 60 	         CONTINUE
                 GOTO 190   ! ... not a recognized qualifier
              ENDIF
	   ENDIF

* maybe its /D= (data_set) or /G= (grid#)
 100	   IF ( letter.EQ.'D' ) GOTO 500 ! already done
	   IF ( letter.NE.'G' ) GOTO 190

!* only T and F axes may be simultaneously used in auxvar regridding
!	   IF (cx_unstand_grid(mods_cx) .AND. cx_naux(mods_cx).NE. 0) THEN
!	     name = 'only T and F regrids may be combined when using'
!	     IF (idim.NE.t_dim .AND. idim.NE.f_dim) GOTO 5300
!	     DO rgdim = 1, nferdims
!	        IF (cx_g_eq_regrid(rgdim)) THEN
!	          IF (rgdim.NE.t_dim .AND. rgdim.NE.f_dim) GOTO 5300
!	        ENDIF
!	     ENDDO
!	   ENDIF  

* G= or G*= non-standard grid specifier ...
* full format is (e.g.) GX=SALT@AVE (atsin and beyond optional)
* (7/95) or may also include data set for grid as in G=vname[D=dset]
* (3/13) or may also have aux vars as in Gxy(curvx,curvy)=vname[D=dset]@ave
	   equal_pos = ATOM_POS( text_buff(istart:iend), '=' )
	   IF ( equal_pos .EQ. atom_not_found
     .	   .OR. equal_pos .EQ. atom_illegal_pos ) GOTO 5020
	   equal_pos = equal_pos + istart - 1
	   name = text_buff(equal_pos+1:iend)
	   namlen = iend-equal_pos
	   atsin_pos = ATOM_POS( name, '@' )
	   comment = '@ttt syntax'			! ... for error message
	   IF ( atsin_pos .EQ. atom_illegal_pos ) GOTO 5020	   
	   atsin = atsin_pos .NE. atom_not_found
!           IF (.NOT.(single_char.OR.atsin)) GOTO 5026 !8/92 GX=TEMP forbidden
	   IF ( atsin ) THEN
	      name_end = atsin_pos - 1
	   ELSE
	      name_end = namlen
	   ENDIF
	   nend = name_end

* allow multiple axes at once as in "GXY=ggg" (12/99 hack)
* ... or "GXY(curvx,curvy)=ggg"  (3/13)
	   IF (.NOT.single_char) THEN
* count the number of axis specifiers and identify them
	      DO 102 i = istart+1, equal_pos
                 letter2 = text_buff(i:i)
		 IF (  letter2 .EQ. ' '
     .	          .OR. letter2 .EQ. '='
     .            .OR. letter2 .EQ. '('
     .	          .OR. letter2 .EQ. tab ) THEN
	            GOTO 103
	         ELSE
*   .... identify the axis that is being regridded
                    DO suborval = 1,2
	            DO idim     = 1,nferdims
	               IF ( letter2.EQ.region_qual(idim,suborval) ) THEN
	                  IF (cx_g_eq_regrid(idim)) THEN
	                     name = 'auxiliary axis named more than once in'
	                     GOTO 5300
	                  ELSE
	                     cx_g_eq_regrid(idim) = .TRUE.
	                     GOTO 102
	                  ENDIF
	               ENDIF
		    ENDDO
	            ENDDO
	            GOTO 5400    ! logic corruption -- should never happen
	         ENDIF
 102          CONTINUE
	      GOTO 5400          ! logic corruption -- should never happen
 103	      naxes = i - istart - 1
c	      next_char = istart + naxes - 1
	      next_char = istart
	      has_auxvar = letter2 .EQ. '('
	      this_dim = idim  ! 1/2014 hack cuz idim isn't reliable
	   ENDIF

* if auxiliary regridding variables have been given, parse em here
	   IF (has_auxvar) THEN
* ... first check for valid usage
!	     IF (naxes .GT. 1) THEN
!		name =
!     .		'this Ferret version doesnt support multi aux regrid args' 
!	        GOTO 5300
!	     ENDIF
!	     IF (idim .NE. z_dim
!     .	   .AND. idim .NE. t_dim
!     .	   .AND. idim .NE. f_dim  ) THEN
!		name =
!     .		'only the Z, T, and F axes can be used in' 
!	        GOTO 5300
!	     ENDIF

	     aux_lparen_pos = i
	     aux_rparen_pos = INDEX(text_buff(i:equal_pos), ')' )
	     IF (aux_rparen_pos .EQ. 0) THEN
	        name = 'unpaired parentheses in'
	        GOTO 5300
	     ELSEIF (aux_rparen_pos .LT. 3) THEN
	        name = 'empty parentheses in'
	        GOTO 5300
	     ENDIF
	     aux_rparen_pos = aux_rparen_pos + i - 1
* ... infer the aux argument count in the parens from the number of commas
	     aux_arg_count = 1
	     aux_arg_namlen = 0
	     IF (idim.EQ.t_dim .OR. idim.EQ.f_dim) THEN
	        rgdim = idim
	     ELSE
*    ... x,y arguments must be in collating order as in gxy(argx,argy)=
	        DO rgdim = 1, nferdims
	           IF (cx_g_eq_regrid(rgdim)) GOTO 704   ! should use "EXIT"
	        ENDDO
	     ENDIF
* (5/15) ... skip leading white space
 704	     DO i = aux_lparen_pos+1, aux_rparen_pos
	        IF (text_buff(i:i) .NE. ' ') EXIT
	     ENDDO
	     cx_aux_arg_start(rgdim, mods_cx) = i
	     cx_aux_arg_end  (rgdim, mods_cx) = i-1
	     cx_aux_stat     (rgdim, mods_cx) = paux_stat_used
	     DO 104 i = aux_lparen_pos+1, aux_rparen_pos-1
	        IF (text_buff(i:i) .EQ. ' ') GOTO 104
	        IF (text_buff(i:i) .NE. ',') THEN
*    ... add one character to the name length
	          aux_arg_namlen = aux_arg_namlen + 1
	          cx_aux_arg_end(rgdim,mods_cx) =
     .				cx_aux_arg_end(rgdim,mods_cx) + 1
	        ELSE
*    ... start of a new argument name
	          IF (aux_arg_namlen .EQ. 0) THEN
	            name = 'missing auxiliary variable name in'
	            GOTO 5300
	          ENDIF
	          aux_arg_count = aux_arg_count + 1
*    ... match this arg to its axis from the "gxy" syntax
	          DO rgdim = rgdim+1, nferdims
	             IF (cx_g_eq_regrid(rgdim)) THEN
	                cx_aux_arg_start(rgdim, mods_cx) = i+1
	                cx_aux_arg_end  (rgdim, mods_cx) = i
	                GOTO 104
	             ENDIF
	          ENDDO
*    ... there are more arguments than there were axes named in "gxy"
	          name = 'no. of auxliary variables must match no. of axes in'
	          GOTO 5300
	        ENDIF
 104	     CONTINUE
	     IF (aux_arg_namlen .EQ. 0) THEN
	        name = 'missing auxiliary variable name in'
	        GOTO 5300
	     ELSEIF (aux_arg_count .NE. naxes) THEN
	        name = 'no. of auxliary variables must match no. of axes in'
	        GOTO 5300
	     ENDIF
	     cx_naux(mods_cx) = cx_naux(mods_cx) + naxes
	   ENDIF

* initialize for next axis as in "GXY="
 105	   IF (.NOT.single_char) THEN
	      next_char = next_char + 1
	      IF ( next_char-istart .GT. naxes ) GOTO 500
              letter2 = UPPER_CASE( text_buff(next_char:next_char) )
              DO 107 suborval = 1,2
	      DO 107 idim     = 1,nferdims
	         IF ( letter2.EQ.region_qual(idim,suborval) ) GOTO 109
 107	      CONTINUE
              GOTO 190   ! ... not a recognized qualifier
 109	      CONTINUE
	   ENDIF

* decipher the grid name (or variable name) (or axis name - 9/95)
*11111111111
           IF ( name_end .GT. 0 ) THEN
* ... first see if grid has been given as a LOW:HI:DELTA  2/96
*	Note: this trap is a kludge -- it is a hack to allow GX=lo:hi:delta
*	      equivalent to X=lo:hi:delta because it is natural for users
*	      to confuse these two
*       3/98: for T axis with GT="1-JAN-1990" first character may be a quote
	      i = 1		                                     ! 3/98
	      IF ((idim.EQ.t_dim .OR. idim.EQ.f_dim) ) THEN
	         IF (name(1:1) .EQ. '"'   ) i = 2 ! 3/98
	         IF (name(1:4) .EQ. '_DQ_') i = 5 ! 2/15 
	      ENDIF
	      IF ( TM_DIGIT(name(i:i)) .AND. .NOT.single_char ) THEN
	         IF (.NOT.first_time(idim) ) GOTO 5200
	         IF (naxes .GT. 1) GOTO 5205	! cannot say GXY=lo:hi:delta
	         morph_gx_to_x(idim) = .TRUE.
* 1/2014
* ... treat gx=lo:hi:delta@ave as an implicit ax regrid like x=lo:hi:delta@ave
*     similarly treat gz(depth)=0:100:10 as an implicit axis
*     and also gz(depth)=100 as a single point axis
*     but gz(depth)=0:100@ave is a special case where we need to parse the
*     ""@ave" as a regridding transform, before we can behave like x=lo:hi:del
	         this_dim = idim   ! 1/2014 hack cuz idim isn't reliable
	         IF (.NOT.(has_auxvar.AND.atsin)) THEN
	            GOTO 201
	         ELSE
	            GOTO 170
	         ENDIF
	      ENDIF
* ... see if grid has been given by grid name
              grid = TM_GET_GRIDNUM( name(:name_end) )
*22222222222222
* ... logic for implicit grids added here 7/97
	      IF ( grid .NE. unspecified_int4 ) THEN
	         IF ( single_char ) THEN	! g=grid_name
	            IF ( cx_grid(mods_cx) .NE. unspecified_int4
     .	           .AND. cx_grid(mods_cx) .NE. grid ) GOTO 5022
 	            cx_grid( mods_cx ) = grid
	         ELSE
	            IF (.NOT.cx_has_impl_grid(mods_cx)) THEN
	               CALL ALLO_GRID_TO_CX(mods_cx,impl_grid,status)
	               IF ( status .NE. ferr_ok ) GOTO 5000
	            ENDIF
	            grid_line(idim,impl_grid) = grid_line(idim,grid)
		 ENDIF
	         cx_unstand_grid(mods_cx) = .TRUE.
*22222222222222
	      ELSE
* ... no ... then maybe it's a variable name (or an axis name -- 9/95)
* 	     if "[D=dset]" is not given then assume it is in the default dset
* note: as of FERRET 2.3 g=user_var is still forbidden.  This restriction can
*	be lifted by adding code in IS_USER_VAR to inspect for simultaneous
*	cx_unstand_dset and cx_data_set=unspecified after determining variable
*	or pseudo-variable context.  A new hi_cx has to be set up for the g=
*	user variable and then RETURN to get that component
*    7/95: allow embedded data set info "vname[D=dset]"
*    5/03: bug fix: [gxy=var[d=dset]] failed because name_end was reset in this
*                   section, but is needed when we go back for next axis: use nend

	         lbrac = INDEX(name(:name_end),"[")
*33333333333333333
	         IF (lbrac .GT. 0) THEN
* ... find closing right bracket		
	            IF ( lbrac .EQ. name_end ) GOTO 5056
	            dend = INDEX(name(lbrac+1:name_end),"]")
	            IF ( dend .EQ. 0 ) GOTO 5056
	            nend = lbrac-1		! variable name end
	            dend   = dend + lbrac - 1	! embedded data set name end
* ... parse "[D=dset]"
	            state = looking_for_D
	            DO 112 i = lbrac+1,dend
	               IF ( name(i:i) .EQ. ' '
     .		       .OR. name(i:i) .EQ. tab ) THEN
	                  CONTINUE
	               ELSEIF ( state .EQ. looking_for_D ) THEN
	                  IF ( name(i:i) .EQ. 'd'
     .		          .OR. name(i:i) .EQ. 'D' ) THEN
	                     state = looking_for_eq
	                  ELSE
	                     GOTO 5056
	                  ENDIF
	               ELSEIF ( state .EQ. looking_for_eq ) THEN
	                  IF ( name(i:i) .EQ. '=' ) THEN
	                     state = looking_for_name
	                  ELSE
	                     GOTO 5056
	                  ENDIF
	               ELSE	! 1st non-white character after the "=" 
	                  dstart = i
	                  state = done_looking
	                  GOTO 114
	               ENDIF
 112	            CONTINUE
 114	            IF ( state .NE. done_looking ) GOTO 5056

* What if it's x[d=1,i=1:3]  ?  dend is pointing at the last bracket.
		    ii = dend
	            DO 113 i = dstart+1,dend
		       IF ( name(i:i) .EQ. ',' ) THEN
		          ii = i-1
			  GOTO 115
		       ENDIF
 113	            CONTINUE
 115		    CONTINUE
		    dend = ii

	            gdset = FIND_DSET_NUMBER( name(dstart:dend) )
	            IF (gdset .EQ. unspecified_int4) GOTO 5058   ! added 1/201
	            gdset_included = .TRUE.
*33333333333333333
	         ELSE
	            gdset = dset
	            gdset_included = .FALSE.
*33333333333333333
	         ENDIF
* ... end of 7/95 additions
* ... which variable (from which to borrow grid)?
	         CALL FIND_VAR_NAME( gdset, name(:nend),
     .                               category, variable )
	         IF ( category .EQ. cat_pseudo_var ) GOTO 5055
*33333333333333333
	         IF ( variable .NE. munknown_var_name ) THEN
	            IF (dependency_tree_mode) THEN
* ... bookkeeping for determining the dependency tree (VTREE)
	               cx_vtree_regrid_ntarget = cx_vtree_regrid_ntarget + 1
	               cx_vtree_unknown_grid(cx_vtree_regrid_ntarget)
     .								= .FALSE. 
	               cx_vtree_var_or_start(cx_vtree_regrid_ntarget) 
     .								= variable
	               cx_vtree_cat_or_end  (cx_vtree_regrid_ntarget)
     .								= category
	               cx_vtree_regrid_dset (cx_vtree_regrid_ntarget)
     .								= gdset
	            ENDIF
	            grid = KNOWN_GRID(gdset,category,variable)
		    cx_grid_needs_dset = .NOT.cx_dset_gvn( mods_cx )
* ... 6/00 bug fix for syntax X[gx=var[d=dset]] -- look for [d=...]
	            IF ( cx_grid_needs_dset )  cx_grid_needs_dset
     .					       = .NOT.gdset_included
* ... 6/01 bug fix for grid from uvar with self-contained data set 
	            IF (cx_grid_needs_dset .AND. category.EQ.cat_user_var)
     .			cx_grid_needs_dset = uvar_need_dset(variable)
* ... 8/99 -- allow G=uvar where uvar may be unknown at this point
		    IF ( grid     .EQ. unspecified_int4
     .		   .AND. category .EQ. cat_user_var ) THEN	! g=??uvar??
	              IF (cx_grid(mods_cx) .NE. unspecified_int4 .AND.
     .                  naxes .GT. 1) THEN

* ... 3/03 -- Have we already encoded start/end limits of the uvar name on a  
*             previous reference to the same uvar?  Needed for [gxy=uvar]

                         itest = unspecified_int4 - (equal_pos+1 + 2000*iend)
                         IF (cx_grid(mods_cx) .NE. itest ) GOTO 5022
                      ENDIF

		      has_g_eq_unkn_uvar = .TRUE.
*       HACK!: encode the start/end limits of the uvar name into the grid !!!
		      cx_grid(mods_cx) = unspecified_int4
     .				 - (equal_pos+1 + 2000*iend)
		      IF (cx_has_impl_grid(mods_cx)) THEN
*       A any previous gx= info becomes irrelevant
	                 CALL INIT_GRID( cx_impl_grid(mods_cx),
     .		                        '(implicit)', unspecified_int4 )
		         cx_has_impl_grid(mods_cx) = .FALSE.
			 cx_impl_grid(mods_cx) = unspecified_int4
		         CALL DEALLO_GRID(status)
			 IF (status .NE. ferr_ok) CALL ERRMSG
     .				( ferr_internal, status, 'g=uvar', *5000) 
	              ENDIF
* ... end of 8/99
	            ELSEIF ( single_char ) THEN	! g=name
	               IF ( cx_grid(mods_cx) .NE. unspecified_int4
     .	              .AND. cx_grid(mods_cx) .NE. grid ) GOTO 5022
 	               cx_grid( mods_cx ) = grid
	            ELSEIF (.NOT.has_g_eq_unkn_uvar) THEN
	               IF (.NOT.cx_has_impl_grid(mods_cx)) THEN
	                  CALL ALLO_GRID_TO_CX(mods_cx,impl_grid,status)
	                  IF ( status .NE. ferr_ok ) GOTO 5000
	               ENDIF
	               grid_line(idim,impl_grid) = grid_line(idim,grid)
	            ENDIF
*33333333333333333
	         ELSEIF ( single_char ) THEN
	            IF (dependency_tree_mode) THEN
	              cx_vtree_regrid_ntarget = cx_vtree_regrid_ntarget + 1
	              cx_vtree_unknown_grid(cx_vtree_regrid_ntarget)
     .							= .TRUE.
	              cx_vtree_var_or_start(cx_vtree_regrid_ntarget)
     .							= equal_pos + 1
	              cx_vtree_cat_or_end  (cx_vtree_regrid_ntarget)
     .							= equal_pos + name_end
	              cx_vtree_regrid_dset (cx_vtree_regrid_ntarget)
     .							= unspecified_int4
	            ELSE
	               GOTO 5050		! (G=axis_name not allowed)
	            ENDIF
*33333333333333333
	         ELSE
* ... as a last resort maybe it is an axis name (9/95)
c	            axis = TM_GET_LINENUM( name(:nend) )
	            axis = TM_GET_LINENUM( name(:name_end) )
		    IF ( axis .EQ. unspecified_int4 ) THEN
	              IF (dependency_tree_mode) THEN
* ... 12/14 hack to let an unknown grid error condition slip through if we
*	are merely evaluating the dependency tree.
	                 cx_vtree_regrid_ntarget = cx_vtree_regrid_ntarget + 1
	                 cx_vtree_unknown_grid(cx_vtree_regrid_ntarget)
     .							= .TRUE.
	                 cx_vtree_var_or_start(cx_vtree_regrid_ntarget)
     .							= equal_pos + 1
	                 cx_vtree_cat_or_end  (cx_vtree_regrid_ntarget)
     .							= equal_pos + name_end
	                 cx_vtree_regrid_dset (cx_vtree_regrid_ntarget)
     .							= unspecified_int4
*       It is normal for LET-defined variables
*	that the grid may remain unknown until the children grids
*	are determined, so hopefully it is OK here, too.  If not then we
*	might try inserting an innocuous grid, such as
!	                IF (cx_grid(mods_cx) .EQ. unspecified_int4)
!     .			    cx_grid(mods_cx) = EZ or ABSTRACT
	              ELSE
	                GOTO 5050		! final defeat 
	              ENDIF
	            ELSEIF ( TM_AXIS_DIRECTION(axis) .NE. idim
     .		       .AND. TM_AXIS_DIRECTION(axis) .NE. 0 ) THEN	! 7/96
	               GOTO 5052
	            ELSEIF (.NOT.has_g_eq_unkn_uvar) THEN
	               IF (.NOT.cx_has_impl_grid(mods_cx) ) THEN
	                  CALL ALLO_GRID_TO_CX(mods_cx,impl_grid,status)
	                  IF ( status .NE. ferr_ok ) GOTO 5000
	               ENDIF
	               grid_line(idim,impl_grid) = axis
	            ENDIF
*33333333333333333
	         ENDIF
	         cx_unstand_grid(mods_cx) = .TRUE.
*22222222222222
	      ENDIF
*11111111111
           ENDIF
* ... explicit transformations given ?
 170	   IF ( atsin ) THEN
	      IF ( namlen-atsin_pos .LT. 3 ) GOTO 5020		! 3+ char trans
	      transnam = ' '
 	      vax_code = STR_UPCASE(transnam,name(atsin_pos+1:namlen))
	      IF (cx_naux(mods_cx) .EQ. 0) THEN
* ... identify the ordinary regridding transformation
	         DO 180 itrans = 1, max_regrid_trans
	            IF ( transnam .EQ. alg_regrid_code( itrans ) ) GOTO 182
 180		 CONTINUE
	      ELSE
* ... identify the auxiliary variable regridding transformation
	         DO 181 itrans = max_regrid_trans+1, max_auxregrid_trans
		    IF ( transnam .EQ. alg_regrid_code( itrans ) ) GOTO 182
 181		 CONTINUE
	      ENDIF
	      comment = '?? transform'
	      GOTO 5020			! unknown regrid transform
* ... trap (temporary?) for use of "@AVE" on auxiliary regridding
 182	      IF (itrans .EQ. pauxrgrd_average) THEN
!	         CALL WARN_OCCASIONALLY(
!     .		   'Box-averaging not available for auxiliary variable '//
!     .		   'regridding.'//pCR//
!     .		   '           Using @PLAVE instead, '//
!     .		   'e.g. gz(depth)=0:100@plave', 10, 101)
	         itrans = pauxrgrd_pwlave
	      ENDIF
              IF ( single_char ) THEN   ! apply transform to all axes
                 DO 184 idim = 1, nferdims
 184             IF ( cx_regrid_trans(idim,mods_cx)
     .           .EQ. unspecified_int4 ) cx_regrid_trans(idim,mods_cx)
     .                                 = itrans
              ELSE                      ! apply transform to specified axis
                 cx_regrid_trans( idim, mods_cx ) = itrans
              ENDIF
!              cx_unstand_grid( mods_cx ) = .TRUE.
	   ENDIF
! this 201 branch is a hack to allow the syntax "gz(depth)=lo:hi@ave" to
!     use the preceding code to read the transformation
	   IF ( has_auxvar ) THEN
	      IF (morph_gx_to_x(this_dim) ) GOTO 201 ! 1/2014
	   ENDIF
	   IF (.NOT.single_char) GOTO 105	! back for another axis
	   GOTO 500

* can't identify it
 190 	IF ( text_buff(istart:istart)
     .		.EQ. '@') GOTO 500	! "/@anything" already processed
	IF ( report_unknown ) THEN
	   GOTO 5010			! unknown specifier is error
	ELSE
	   GOTO 500			! ignore unknown specifier
	ENDIF

* trap attempts to define the same axis region twice
 200	IF (.NOT.first_time(idim)) GOTO 5220
	IF ( morph_gx_to_x(idim) ) GOTO 5200

* specified by value or subscript ?
 201	cx_by_ss( idim, mods_cx ) = suborval .EQ. 1

* syntax check: look for "=", ":" and "@"
* ... "="
	equal_pos = ATOM_POS( text_buff(istart:iend), '=' )
	IF ( equal_pos .EQ. atom_not_found   ) GOTO 500	 ! ignore "/Q" w/out "="
	IF ( equal_pos .EQ. atom_illegal_pos ) GOTO 5010
	equal_pos = equal_pos + istart - 1

* ... find first non-blank following "="
	DO 250 lo_start = equal_pos+1, iend
	   IF ( text_buff(lo_start:lo_start) .NE. ' '
     .	  .AND. text_buff(lo_start:lo_start) .NE. tab ) GOTO 260
 250	CONTINUE
	GOTO 5010		! just "X=" and nothing more

* ... "@"
 260	atsin_pos = ATOM_POS( text_buff(istart:iend), '@' )
	IF ( atsin_pos .EQ. atom_illegal_pos ) GOTO 5130
	atsin	  = atsin_pos .NE. atom_not_found
	atsin_pos = atsin_pos + istart - 1
	IF ( atsin_pos + 3 .GT. iend ) GOTO 5130
	IF ( atsin ) THEN
	   del_end = atsin_pos - 1
	ELSE
	   del_end = iend
	ENDIF

* ... ":"
	colon_pos = ATOM_POS( text_buff( istart:del_end ), ':' )
	IF ( colon_pos .EQ. atom_illegal_pos ) GOTO 5140
	colon  = colon_pos .NE. atom_not_found
	IF ( colon ) THEN
	   colon_pos = colon_pos + istart - 1
	   lo_end	 = colon_pos - 1
	ELSE
	   colon2	 = .FALSE.
	   lo_end	 = del_end
	ENDIF

*  ... second ":"
	IF ( colon ) THEN
	   colon2_pos = ATOM_POS(text_buff( colon_pos+1:del_end ), ':' )
	   IF ( colon2_pos .EQ. atom_illegal_pos
     .	   .OR. colon2_pos .EQ. 1		 ) GOTO 5150
	   colon2 = colon2_pos .NE. atom_not_found
	   IF ( colon2 ) THEN
	      colon2_pos = colon2_pos + colon_pos
	      hi_end     = colon2_pos - 1
	     IF (INDEX(text_buff(colon2_pos+1:del_end),':').GT.0)
     .							GOTO 5150
	   ELSE
	      hi_end     = del_end
	   ENDIF
	   hi_start	 = colon_pos + 1
	   del_start	 = colon2_pos + 1
	ENDIF

*  ... GX=lo:hi is legal ONLY with a delta supplied
	IF ( morph_gx_to_x(idim) ) THEN
	    IF ( has_auxvar ) THEN
*         GZ(depth)=pt and gz(depth)=lo:hi@plave are allowed.
*         GZ(depth)=lo:hi is not allowed
             IF (colon .AND. .NOT.colon2 .AND. .NOT.atsin) GOTO 5210
	    ELSE
	      IF (.NOT.colon2)				   GOTO 5210
	    ENDIF
	ENDIF

* ... ":" following @ (as in @SHF:-1) ?
	IF ( atsin ) THEN
	   atcolon_pos = ATOM_POS( text_buff(atsin_pos+1:iend), ':' )
	   IF ( atcolon_pos .EQ. atom_illegal_pos ) GOTO 5160
	   atcolon = atcolon_pos .NE. atom_not_found
	   IF ( atcolon ) atcolon_pos = atcolon_pos + atsin_pos
	ELSE
	   atcolon = .FALSE.
	ENDIF

* make allowances for quotation marks here and there (kludge!)
* watch for empty strings! (10/95)
* add _DQ_ support 2/15
	IF (     text_buff(lo_start:lo_start) .EQ. '"' ) THEN
	   lo_start = lo_start + 1
	ELSEIF ( text_buff(lo_start:lo_start) .EQ. '_'
     .      .AND.lo_start+3 .LE. iend                  ) THEN
	   IF (  text_buff(lo_start:lo_start+3) .EQ. '_DQ_' )
     .	   lo_start = lo_start + 4
	ENDIF
 	IF (     text_buff(lo_end  :lo_end  ) .EQ. '"' ) THEN
	   lo_end   = lo_end   - 1
	ELSEIF ( text_buff(lo_end  :lo_end  ) .EQ. '_'
     .     .AND. lo_end-3 .GE. istart                  ) THEN
	   IF (  text_buff(lo_end-3:lo_end  ) .EQ. '_DQ_' )
     .	   lo_end   = lo_end   - 4
	ENDIF
 
	IF ( colon ) THEN
	   IF (     text_buff(hi_start:hi_start) .EQ. '"' ) THEN
	      hi_start = hi_start + 1
	   ELSEIF ( text_buff(hi_start:hi_start) .EQ. '_' 
     .        .AND. hi_start+3 .LE. iend                  ) THEN
	      IF (  text_buff(hi_start:hi_start+3) .EQ. '_DQ_' ) 
     .	      hi_start = hi_start + 4
	   ENDIF
	   IF (     text_buff(hi_end  :hi_end  ) .EQ. '"' ) THEN
	      hi_end   = hi_end   - 1
	   ELSEIF ( text_buff(hi_end  :hi_end  ) .EQ. '_' 
     .         .AND. hi_end-3 .GE. istart                 ) THEN
	      IF (  text_buff(hi_end-3:hi_end  ) .EQ. '_DQ_' ) 
     .	      hi_end   = hi_end   - 4
	   ENDIF
	   IF ( hi_start .GT. hi_end ) GOTO 5165
	ENDIF

	IF ( colon2 ) THEN
	   IF (    text_buff(del_start:del_start  ) .EQ. '"') THEN
	      del_start = del_start+1
	   ELSEIF (text_buff(del_start:del_start  ) .EQ. '_'
     .       .AND. del_start+3 .LE. iend                    ) THEN
	      IF  (text_buff(del_start:del_start+3) .EQ. '_DQ_') 
     .	      del_start = del_start+4
	   ENDIF
	   IF (    text_buff(del_end :del_end    ) .EQ. '"' ) THEN
	      del_end   = del_end - 1
	   ELSEIF (text_buff(del_end :del_end    ) .EQ. '_'
     .     .AND. del_end-3 .GE. istart                      ) THEN
	      IF  (text_buff(del_end-3:del_end   ) .EQ. '_DQ_')
     .	      del_end   = del_end - 4
	   ENDIF
	   IF ( del_start .GT. del_end ) GOTO 5165
	ENDIF

* two specifications of region in same block of region info?
        IF ( .NOT.first_time(idim) ) THEN  ! 2/23/92
	   GOTO 5220
        ELSEIF ( .NOT.set_implicitly(idim) ) THEN  ! 8/92 modified 2/23/92
* ... initialize this dimension if it's the first reference to it
	   cx_given ( idim, mods_cx ) = .TRUE.
	   cx_delta ( idim, mods_cx ) =  unspecified_val8
        ENDIF

*  See if we can find out the calendar, if grid/axis is known
        IF (cal_id .EQ. 0) THEN
           IF (grid .EQ. unspecified_int4  .AND.  
     .	       axis .EQ. unspecified_int4)  THEN 
              cal_id = 1
	   ELSE
	      IF (axis .EQ. unspecified_int4) axis = grid_line(t_dim, grid)
	      cal_id = TM_GET_CALENDAR_ID ( line_cal_name(axis) )
	   ENDIF
	ENDIF

* is there a first value given ?
	IF ( lo_start .GT. lo_end ) THEN
	   fmat_lo = .FALSE.
	ELSE
	   CALL TRANSLATE_LIMIT
     .		      ( text_buff(lo_start:lo_end), idim,
     .			cx_by_ss( idim, mods_cx ),
     .			cx_lo_ww ( idim, mods_cx ),
     .			fmat_lo, cal_id, status )
	   IF ( status .NE. ferr_ok ) RETURN

* ACM 11/04 save calendar used to compute world coordinates
           IF (idim .EQ. t_dim .OR. idim .EQ. f_dim) cx_cal_id(mods_cx) = cal_id

* kob 8/97 - set cx_calender to true/false depending on whether date is
*            a formated string or not
	   IF (idim .EQ. t_dim .OR. idim .EQ. f_dim) 
     .			cx_calendar(idim,mods_cx) = fmat_lo
	ENDIF

* is there a second value given ?
	IF ( colon ) THEN
	   CALL TRANSLATE_LIMIT
     .		      ( text_buff(hi_start:hi_end), idim,
     .			cx_by_ss( idim, mods_cx ),
     .			cx_hi_ww ( idim, mods_cx ),
     .			fmat_hi, cal_id, status )
	   IF ( status .NE. ferr_ok ) RETURN
* ... formatted longitudes: add 360 degrees if necessary
	   IF ( idim .EQ. x_dim
     .	 .AND.  ( fmat_hi .OR. fmat_lo )
     .   .AND.  cx_hi_ww(idim,mods_cx) .LE. 
     .				cx_lo_ww(idim,mods_cx) ) THEN
	      IF ( cx_hi_ww(idim,mods_cx) .LE. 
     .				cx_lo_ww(idim,mods_cx) - 360.D0 ) THEN
	         GOTO 5030
	      ELSE
	         cx_hi_ww(idim,mods_cx)
     .			 = cx_hi_ww( idim, mods_cx ) + 360.D0
	      ENDIF
	   ENDIF
!	ELSEIF ( first_time(idim) ) THEN   ! 8/92 ELSE --> ELSEIF
	ELSEIF ( lo_start .LE. lo_end ) THEN ! replaced 8/92 check 2/23/96
! ... 2/23/96 set hi=lo iff a lo value, only, was just given
	   cx_hi_ww( idim, mods_cx ) = cx_lo_ww( idim, mods_cx )
	   fmat_hi = fmat_lo
	ENDIF	

* save the formatting information (12/99)
	cx_formatted(idim) = fmat_lo .OR. fmat_hi
	
* is there a third value given ?  (possibly implying a dynamic axis)
* Issue 1931: can't be a formatted string in the third value that 
* would need translating.  It's just delta in the units of the axis.
	IF ( colon2 ) THEN
	   READ ( text_buff(del_start:del_end),* , ERR=5000 ) cx_delta(idim, mods_cx)
	   IF ( status .NE. ferr_ok ) RETURN

* get the dynamic regridding transformation, e.g. x=lo:hi:del@tran
	   IF ( atsin .AND. .NOT.has_auxvar ) THEN
	      comment = '?? transform'
	      risc_buff = text_buff(atsin_pos:atsin_pos+3)
	      len_rbuff = 4
	      DO 300 itrans = 1, max_regrid_trans
	         vax_code = STR_CASE_BLIND_COMPARE(
     .				text_buff( atsin_pos+1:atsin_pos+3 ) ,
     .				alg_regrid_code(itrans)		) 
	      IF ( vax_code .EQ. vms_str_success )GOTO 310
 300	      CONTINUE
	      GOTO 5020			! unknown regridding transformation
 310	      cx_regrid_trans(idim,mods_cx) = itrans
	   ENDIF

	ELSE
* get the axis transformation, e.g. x=lo:hi@tran
* ... but not gz(depth)=0:100@ave, which was handled as an aux var regrid
	   IF ( atsin .AND. .NOT.has_auxvar) THEN
	      DO 320 itrans = 1, num_transforms
	         vax_code = STR_CASE_BLIND_COMPARE(
     .				text_buff( atsin_pos+1:atsin_pos+3 ) ,
     .				alg_trans_text( itrans )		) 
	      IF ( vax_code .EQ. vms_str_success )GOTO 330
 320	      CONTINUE
	      GOTO 5170	! unknown transformation
 330	      cx_trans( idim, mods_cx ) = alg_trans_num( itrans )
!	   ELSEIF ( first_time(idim) ) THEN   ! 8/92 set default first time
	   ELSE				      ! replaced 8/92 check 2/23/96
	      cx_trans( idim, mods_cx ) = trans_no_transform
	   ENDIF

* get the argument for the transformation, if given
	   IF ( atcolon ) THEN
	      buff = text_buff(atcolon_pos+1:iend)
	      READ ( buff,* , ERR=5180 ) cx_trans_arg( idim, mods_cx )
	   ENDIF

* make sure the argument - explicit or implicit - is correct
	   IF ( atsin ) THEN
	      CALL DFLT_TRANS_ARG( idim, mods_cx, status )
	      IF ( status .NE. ferr_ok ) GOTO 5035
	   ENDIF
	ENDIF
	
* 12/13
* interpret gz(depth)=100 (a point) as a regrid to a dynamic axis of length 1
* similarly gz(depth)=0:100@ave is an implied regrid to a single point axis
	IF (has_auxvar) THEN
* ... identify the axis being regridding in this qualifier
	  DO rgdim = 1, nferdims
	     IF (cx_g_eq_regrid(rgdim)) THEN
* set up for dynamic axis by inserting a special cx_delta signal
	        IF (cx_lo_ww(rgdim,mods_cx) .EQ. unspecified_val8) CYCLE
	        IF (cx_delta(rgdim,mods_cx) .NE. unspecified_val8) CYCLE
	        IF (cx_lo_ww(rgdim,mods_cx) .EQ. cx_hi_ww(rgdim,mods_cx)
     .	       .OR. cx_regrid_trans(rgdim,mods_cx) .EQ. pauxrgrd_pwlave)
     .					cx_delta(rgdim,mods_cx) = pauto_1pt_ax
	     ENDIF
	   ENDDO
	ENDIF

* make sure low limit is less than high
* ... date strings: stored negatively as seconds since BC
* 8/97 *kob* check cx_calendar rather than if fmat_hi or fmat_lo is set to 
*            see if time is a date

* 11/03 *acm* Why do we swap the limits when hi > lo?  This means that
*             repeat/i=3:1:1 executes the same as repeat/i=1:3:1 and
*             list var[i=180:10:10] the same as list var[i=10:180:10]

	IF (  (idim.EQ.t_dim .OR. idim.EQ.f_dim) .AND. cx_calendar(idim,mods_cx) ) THEN
	   IF ( cx_hi_ww(idim,mods_cx) .GT. 
     .				cx_lo_ww(idim,mods_cx) ) THEN
	      temp = cx_lo_ww( idim, mods_cx )
	      cx_lo_ww( idim, mods_cx ) = cx_hi_ww( idim, mods_cx )
	      cx_hi_ww( idim, mods_cx ) = temp
	   ENDIF
* ... all other limits
	ELSEIF ( cx_hi_ww(idim,mods_cx) .LT. 
     .				cx_lo_ww(idim,mods_cx) ) THEN
	   temp = cx_lo_ww( idim, mods_cx )
	   cx_lo_ww( idim, mods_cx ) = cx_hi_ww( idim, mods_cx )
	   cx_hi_ww( idim, mods_cx ) = temp
	ENDIF

* if coordinates were given by subscript check 'em and convert 'em
	IF ( cx_by_ss( idim, mods_cx )
     . .AND. cx_lo_ww(idim,mods_cx) .NE. unspecified_val8 ) THEN
	   IF ( INVALID_R8_TO_I4( cx_lo_ww( idim, mods_cx ) )
     .	.OR. INVALID_R8_TO_I4( cx_hi_ww(idim,mods_cx) )) GOTO 5030
	   IF ( cx_delta( idim, mods_cx ) .NE. unspecified_val8
     .	.AND.INVALID_R8_TO_I4( cx_delta  (idim,mods_cx) )) GOTO 5030
	   cx_lo_ss(mods_cx,idim) = NINT( cx_lo_ww(idim,mods_cx) )
	   cx_hi_ss(mods_cx,idim) = NINT( cx_hi_ww(idim,mods_cx) )
	   cx_lo_ww( idim, mods_cx ) = unspecified_val8
	   cx_hi_ww( idim, mods_cx ) = unspecified_val8
* 9/97 *kob* cx_calendar must reflect these changes as well	  
	   IF (idim .EQ. t_dim .OR. idim .EQ. f_dim) 
     .                cx_calendar(idim,mods_cx) = .FALSE.
	ENDIF

* SPECIAL CASES for individual axes
* ... @AAV given explicitly
	IF (  cx_trans(idim,mods_cx) .EQ. trans_4d_ave
     .  .OR.  cx_trans(idim,mods_cx) .EQ. trans_4d_int_def
     .  .OR.  cx_trans(idim,mods_cx) .EQ. trans_4d_good_pt
     .  .OR.  cx_trans(idim,mods_cx) .EQ. trans_4d_bad_pt
     .  .OR.  cx_trans(idim,mods_cx) .EQ. trans_4d_sum
     .  .OR.  cx_trans(idim,mods_cx) .EQ. trans_4d_var
     .  .OR.  cx_trans(idim,mods_cx) .EQ. trans_reduced ) GOTO 5190

* flag this dimension as specified (8/92)
        first_time(idim) = .FALSE.

500	CONTINUE

* SPECIAL CASES for entire context
* If grid qualifiers were given then a grid name from at least 1 was mandatory
        IF ( cx_unstand_grid(mods_cx)
     . .AND. .NOT.dependency_tree_mode
     . .AND. .NOT.cx_has_impl_grid(mods_cx)
     . .AND. cx_grid(mods_cx) .EQ. unspecified_int4 ) GOTO 5024

* @AVE or @DIN applied to both X and Y performed as a 2D integral (for COSINE
* factors) 
* 7/96: average, variance, def. int, ngd, and nbg may be 2, 3, or 4D calcs
*     substitute the 4D transform for the one specified
	DO 610 i = 1, num_4d_trans
	   other = 0
	   DO 600 idim = 1, nferdims	   
	      IF ( cx_trans(idim,mods_cx) .EQ. alg_1d_to_4d(i) ) THEN
	         IF ( other .EQ. 0 ) THEN
	            other = idim		! found 1 axis
	         ELSE
	            cx_trans(other,mods_cx) = alg_4d_trans(i)
	            cx_trans( idim,mods_cx) = alg_4d_trans(i)
	         ENDIF
	      ENDIF
 600	   CONTINUE
 610	CONTINUE

* TF regridding syntax may be gt(tf_times)=TF_CAL_T,gf(tf_times)=TF_LAG_F in which case
* what appears as two distinct auxiliary variables is really only one
	IF (cx_naux(mods_cx) .GT. 1) THEN
	   IF ( cx_aux_arg_start(t_dim,mods_cx) .NE. unspecified_int4
     .    .AND. cx_aux_arg_start(f_dim,mods_cx) .NE. unspecified_int4 ) 
     .					cx_naux(mods_cx) = cx_naux(mods_cx) - 1
	ENDIF

* same is true for indefinite integrals but never been used yet ...
	IF (  cx_trans(x_dim,mods_cx) .EQ. trans_integ_indef
     .	.AND. cx_trans(y_dim,mods_cx) .EQ. trans_integ_indef )
     .		CALL SPLIT_LIST(pttmode_bull, ttout_lun, 
     .		' @IIN on X and @IIN on Y computed as 1D integrals', 49)

	status = ferr_ok
	RETURN

* error exits
* ... clear implicit grids so axes within them don't get deallocated
 5000	IF (cx_has_impl_grid(mods_cx)) CALL INIT_GRID(
     .		cx_impl_grid(mods_cx), '(implicit)',
     .          unspecified_int4 )
	RETURN
 5010	CALL ERRMSG( ferr_syntax, status, risc_buff(:len_rbuff), *5000 )
 5015	risc_buff = text_buff(istart-1:iend)		! for RISC/FORTRAN
	len_rbuff = MIN(48, iend-istart)		! for RISC/FORTRAN
 	CALL ERRMSG( ferr_syntax, status,
     .		'incomplete specification: '//risc_buff(:len_rbuff), *5000 )
 5020	CALL ERRMSG( ferr_regrid, status,
     .		risc_buff(:len_rbuff)//' : '//comment,*5000 )
 5022	CALL ERRMSG( ferr_regrid, status,
     .		risc_buff(:len_rbuff)//' - more than 1 target grid',
     .          *5000 )
 5024	CALL ERRMSG( ferr_regrid, status, 'no target grid specified',
     .          *5000 )
 5030	CALL ERRMSG
     .		( ferr_out_of_range, status, risc_buff(:len_rbuff), *5000 )
 5035	CALL ERRMSG
     .		( status, status, risc_buff(:len_rbuff), *5000 )
 5040	CALL ERRMSG
     .		( ferr_unknown_data_set, status, risc_buff(:len_rbuff), *5000 )
 5050	CALL ERRMSG
     .		( ferr_unknown_grid, status, risc_buff(:len_rbuff), *5000 )
 5052	CALL ERRMSG
     .		( ferr_regrid, status,
     .		'Axis orientation not matching request:'//
     .		risc_buff(:len_rbuff), *5000 )
 5055	CALL ERRMSG( ferr_unknown_grid, status,	risc_buff(:len_rbuff)//
     .			' --> g=user-or-pseudo-var not allowed', *5000 )
 5056	CALL ERRMSG( ferr_syntax, status, 
     .	 'invalid nested brackets: '//risc_buff(:len_rbuff),*5000)
 5058	CALL ERRMSG
     .		( ferr_unknown_data_set, status, name(dstart:dend), *5000 )
 5060	CALL ERRMSG( ferr_invalid_command, status, 
     .	 'use @SHF only with IJK or L: '//risc_buff(:len_rbuff),*5000)
 5100	CALL ERRMSG( ferr_syntax, status, 
     .	 'unknown region name: '//risc_buff(:len_rbuff),*5000)
 5110	CALL ERRMSG( ferr_syntax, status, 
     .	 'What data set ?: '//risc_buff(:len_rbuff),*5000)
 5112	CALL ERRMSG( ferr_syntax, status, 
     .	 'What calendar ?: '//risc_buff(:len_rbuff),*5000)
 5120	CALL ERRMSG( ferr_syntax, status, 
     .	 'What grid ?: '//risc_buff(:len_rbuff),*5000)
 5130   CALL ERRMSG( ferr_syntax, status, 
     .	 risc_buff(:len_rbuff)//pCR//
     .	'"@" must precede a valid transformation like "Z=0:50@AVE"'
     .	//pCR//'Use SHOW TRANSFORMS for a list of legal transformations',
     .  *5000)
 5140	CALL ERRMSG( ferr_syntax, status, 
     .	 risc_buff(:len_rbuff)//pCR//
     .	'":" is used incorrectly. A correct example is "Z=0:50".' ,*5000)
 5150	CALL ERRMSG( ferr_syntax, status, 
     .	 risc_buff(:len_rbuff)//pCR//
     .	'":" is used incorrectly. A correct example is "L=1:100:10".',
     .	*5000)
 5160	CALL ERRMSG( ferr_syntax, status, 
     .	 risc_buff(:len_rbuff)//pCR//
     .	'":" is used incorrectly. A correct example is "L=@SBX:5".',
     .	*5000)
 5165	CALL ERRMSG( ferr_syntax, status, risc_buff(:len_rbuff), *5000)
 5170   CALL ERRMSG( ferr_syntax, status, 
     .	 'Unknown transformation:'//risc_buff(:len_rbuff)//pCR//
     .	 'Use SHOW TRANSFORMS for a list of legal transformations',
     .  *5000)
 5180	CALL ERRMSG( ferr_syntax, status, 
     .	 'Invalid transformation argument:'//risc_buff(:len_rbuff),
     .	*5000)
 5190	CALL ERRMSG( ferr_syntax, status, 
     .	 'transformation reserved for FERRET internal use:'//pCR//
     .	 risc_buff(:len_rbuff), *5000)
 5200	CALL ERRMSG( ferr_syntax, status, 
     .	'used GX=lo:hi:delta with X=lo:hi (ditto for Y,Z, or T)'
     .	 //pCR//
     .	 risc_buff(:len_rbuff), *5000)
 5205	CALL ERRMSG( ferr_syntax, status, 
     .	'lo:hi:delta must be given separately for each axis' //pCR//
     .	 risc_buff(:len_rbuff), *5000)
 5210	CALL ERRMSG( ferr_syntax, status, 
     .	'GX=lo:hi:delta with no delta (or ditto for Y,Z, or T)'
     .	 //pCR//
     .	 risc_buff(:len_rbuff), *5000)
 5220	CALL ERRMSG( ferr_syntax, status, 
     .	'multiple specifications on '//ww_dim_name(idim)//' axis'
     .	 //pCR//
     .	 risc_buff(:len_rbuff), *5000)
 5300	CALL ERRMSG( ferr_syntax, status, 
     .  name(:TM_LENSTR1(name))//' regrid of style gz(depth)=zax'
     .	 //pCR//
     .	 risc_buff(:len_rbuff), *5000)
 5400	CALL ERRMSG( ferr_internal, status, 
     .  'get_context_mods logic corrptn', *5000)
	END

	LOGICAL FUNCTION TM_Check_box_loc (nline)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Checks to make sure a data point is enclosed by its box on an axis
*
* revision 0.00 - 05/26/88 - by M. Verschell for PMEL/TMAP
* V63  *acm* 10/09 Changes for gfortran build
*
* Argument
	INTEGER*4	nline
*
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
*
	INTEGER*4	ipt1, npts, ibx1, i, nothing
	LOGICAL		TM_DFPEQ
	REAL*8 a,b1,b2
*
	ipt1 = line_subsc1(nline)
	npts = line_dim(nline)
	ibx1 = ipt1 + npts

	DO 100 i=0,npts-1
	  a = line_mem(ipt1+i)
	  b1 = line_mem(ibx1+i)
	  b2 = line_mem(ibx1+i+1)
	  IF (a .LT. b1 .OR. a .GT. b2) THEN
            IF (TM_DFPEQ(a,b1) .OR. TM_DFPEQ(a,b2) ) THEN
               nothing = 0
            ELSE
	       TM_Check_box_loc = .FALSE.
	    ENDIF
	    RETURN
	  ENDIF
  100	CONTINUE

	TM_Check_box_loc = .TRUE.
	RETURN
	END

c     
c     efcn_rqst_mr_ptrs.F
c     
c     Steve hankin
c     19 Jan., 2017
c     

c     
c     This subroutine is called by efcn_compute_ inside EF_ExternalUtil.c. 
c     It passes the c pointers for the function arguments and result 
c     from their storage in FORTRAN90 pointers back to c

        SUBROUTINE EFCN_RQST_MR_PTRS(nargs, mr_list, mr_res)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'

* calling argument declarations:
	INTEGER	nargs, mr_list(nargs), mr_res

* internal variable declarations
        INTEGER i

* pass the arg pointers to c
        DO i = 1, nargs
           CALL EFCN_PASS_ARG_PTR(i, memry(mr_list(i))%ptr )
        ENDDO

* pass the result pointer to c
        CALL EFCN_PASS_RES_PTR(memry(mr_res)%ptr)

        RETURN 
        END

	SUBROUTINE MERGE_GRID(	iarg, its_gc, com_text,
     .				mrg_cx, com_cx, uvar, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* combine the grid from a new component into the grid information from the
* already-merged components
* compute: 1) the aggregate grid (as a collection of 4 axes)
*	   2) uvar_given - which tells how limits must be specified for each
*		axis of the aggregate grid
*  e.g. DEFINE VAR NEW = U[K=1]+TEMP[K=@AVE] where the 2 variables are on
*					     different axes in all 4 dimensions
*	The aggregate grid will be from U in X,Y and T since it is the first
*	variable in the expression and from TEMP in Z since that axis is neede
*	to label the result properly.
*       UVAR_GIVEN will be "needed" on X,Y and T and "need_exact" on Z since
*	NEW should be re-used from memory-resident storage only when the stored
*	Z limits match the requested exactly.
* note: components are merged in the reverse of the order of computation

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  6/28/89 - complete re-write
* 	 3/27/90 - re-word warning message a bit
* RISC/Unix port *sh* 11/91: eliminate VMS-specific HELP coaching line
* V230:  1/27/92 - changed uvlim_*_hi (unused) to uvlim_*_lohi to describe
*                  @WEQ - exaxt limits required but a range of data
*                - also added @RSUM (like @IIN)
* V400: 11/9/94	 - use CALL WARN to display "Ambiguous coord"  message
* V420: 9/95	 - Support for implicit grids: deallocate after it is used
*	10/95	 - support for implicit axes: pass along use-count 
*		   responsibility (TM_USE_LINE) for implicit axis to merged
*		   grid since component will get deallocated
*	 1/96	 - use INHERITED_LIMITS to ensure that modulo regridding
*		   limits (embedded inside of expression) are not passed on
*		   e.g. "5 + A[gt=climatology@MOD]" where A=SST[T=lo:hi] 
*	2/27/96	 - axes for which cx_lo_ww was undefined were ignored.
*		   This eliminated consideration of the Y
*		   axis of LAT_ARG in r*lat_arg/LAT_REF	where
*		   LAT_ARG = Y[Y=90S:90N:15]; r = 6; lat_ref = 45
*		   The perverted logic sequence is explained at "2/27"
* V430:	 5/96	 - fixing a bug that seems to have been here all along?????
*		   the logic of this routine is based on cx_given, ignoring
*		   limits given INSIDE of component definitions. Thus 
*			let depth_z=h[x=110w,z=@iin]-h[x=110w]/2
*			let r0=depth_z-x[g=gdepth]
*		   resulted in an "Ambiguous axis" warning, ignoring the X=110W
*		   Added variable expl_com_lims to the code
* V450: 1/97	 - changes to accomodate grid changing functions.
*		   MERGIFY_GRID is no
*		   longer used.  The first component is handled in a manner
*		   symmetrical with respect to the others.
*		   Process a component even though it has unspecified ww lims.
*		   Allow a com and a mrg axis both to be normal (axis_choice).
*		   Maintain cx_given for the merged data set.
*		   Added a row to the ax_choice table to deal with merged
*			axis that was "uvlim_irrelevant"
* V491:   2/23/98 - 1/97 check at line 400 for unspec cx_lo_ww introduced a bug
*                 in cases like LET p=i[i=1:5]; LET q=i[i=1:5]; LET pq=p*q;
*                 uvar_given for pq was set to uvlim_irrelevant instead of 
*                 uvlim_gvn_gnl
*         2/28/98 - further repair to resolve problem that re-appeared in
*                 err490_l_ave.jnl: use "expl_com_lim" (explicit component
*                 limits) **consistently** instead of cx_given to know whether
*                 a new component does or does not possess its own limits
* V500: *sh* 6/99 -- BUG COMMENT ONLY!! NOT FIXED. See err500_expl_lims.jnl
*		  and find "6/99" in code below
* V510: *sh* 12/99 - support for uvlim_hidden (EF caching)
*	*sh* 12/99 - set the uvar_lo/hi limits along with uvar_given
*	*sh* 12/99 - bug fix: rules for merging embodied in joint_match were
*			wrong when new component is xact
*	*sh*  4/00 - all grids and axes now maintain use counts 
* V520  *sh* 6/00 - complete the support for uvlim_hidden. Was treated just
*		    like uvlim_irrelevant in determining uvar_given
* V533  *sh* 7/01 - determine data type of result
* V64+ *acm 12/09 - Fix bug 1710: In the grid axis selection table, ax_choice(4,1)
*                   changed from Not Possible to Not Applicable
*      *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing
* v685 *acm* 4/13   Call WARN for warning message
* v685 *acm* 5/13   Fix ticket 2051, setting uvar_given(idim,uvar) when the
*                   user-variable has multiple sub-expressions
* v690 *sh* 2/14  Determine the curvilinear (aux var) dependencies of the merged
*		  expression
* V694+*acm*5/15  Fix for ticket 2273: return= shape, *size for expressions built 
*                 of other exprns.
* V695 *acm* 6/16 Fix ticket 1602. Do not substitute abstract axes for normal axes
*                 when merging a constant.
* V72  *acm* 6/17 For the above change, ticket 1602, and also for comment #3 of 2313, 
*                 do the check differently. If the the grid of the component is 
*                 all-abstract (and the variable is a constant), do not add abstract 
*                 axes to the merged grid.

	include 'tmap_dims.parm'
	include 'grid_chg_fcns.parm'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'ferret.parm'
	include 'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'
	include	'xtext_info.cmn'
	include	'xfr_grid.cmn'

* calling argument declarations
	LOGICAL		its_gc
	INTEGER		iarg, mrg_cx, com_cx, uvar, status
	CHARACTER	com_text*(*)

* local variable declarations
	LOGICAL		INHERITED_LIMITS, ITSA_PURE_SUM_VAR,
     .			same, nest, expl_com_lim, abstgrid, normabst, var_is_const
	INTEGER		CX_DIM_LEN, TM_LENSTR1, REGION_CLASS,
     .			NEST_REGION_CLASS,  WHICH_GCFCN, GCF_RTN_TYPE,
     .			mrg_grd, mrg_ax, mrg_len, com_grd, com_ax, com_len,
     .			idim, i, icom, imrg, com_uvar, com_class, mrg_class,
     .			uv_class, ax_choice(6,5), joint_match(0:3,0:3),
     .			lims_gvn, gcfcn, axis_source(nferdims), uvar_test,
     .			naux, blen, mabstract, iline
	CHARACTER	VAR_CODE*128, buff*128

* local parameter declarations
	INTEGER		EXP,   IMP,   WRN1,   NP,   NA,  WRN2
	PARAMETER     ( EXP=1, IMP=2, WRN1=3, NP=4, NA=5, WRN2=6 ) 
	INTEGER		gnl,   lo,   lohi,   xact
	PARAMETER     ( gnl=0, lo=1, lohi=2, xact=3 )

* FERRET DOCUMENTATION: merging grids for an expression
*
* procedure:
* the important considerations are
*	o whether merged/component axes are same axis
*	o whether merged/component axes are "irrelevant"
*	o whether merged/comonent data spans are 1 or >1
*	o whether merged/component region is given explicitly or implicitly
*	o whether merged context depends on default data set

* combinations of explicitly and implicitly defined data will take the axis
* of the implicit component(s)
* e.g. W[K=1:3] + U will have the Z/K axis from component U

* when successfully completed the merged axis will be 
*	1) the axis from the first component with region IMPLICITLY defined
*	      ... or failing that ...
*	2) the axis fom the first component with explicit region >1
*	      ... or failing that ...
*	3) the axis from the first component with any explicit region
* If all components are normal to this axis the result, too, will be normal

* * * * * * * * GRID AXIS SELECTION TABLE * * *
*			  C O M P O N E N T
*	       1      2     3       4     5       6  
*                   expl_com_lim       .NOT.expl_com_lim 
*                same          diff      same   diff 
*  size:       1     >1      1     >1
*	    ------------------------------------------
*1       1  | EXP  |  *** | EXP | EXP |  IMP  | IMP  |
*    given  ------------------------------------------
*2      >1  | ***  |  NA  | NA  | WRN1|  IMP  | IMP  |
*           ------------------------------------------
*3.NOT.given| NA   |  NA  | NA  | NA  |  NA   | WRN2 |
*           ------------------------------------------
*4  normal  | NA** |  *** | EXP | EXP |  NA*  | IMP  | (NA* was *** pre 1/97, NA** was *** pre 12/09)
*           ------------------------------------------
*5  irrelev | EXP  |  EXP | EXP | EXP |  IMP  | IMP  |   (new row, 1/97)
*           ------------------------------------------
* EXP  - impose axis and explicit limits from component
* IMP  - impose axis from component with implicit limits
* ***  - impossible to occur
* NA   - not applicable in determining grid (but still relevant in uvar_given)


* * * DETERMINING UVAR_GIVEN * * *
* There are subtlities associated with limits that are given in the UVAR
* definition.  These are classified in uvar_given under these codings:
* ("gvn" indicates lo/hi limits were given in square brackets)
* ("gnl","lo","lohi" and "xact" encode special requirements of transformations)
*	uvlim_irrelevant- limits irrelevant: NEW=10.1
*	uvlim_hidden	- limits hidden inside on another axis: NEW=FFT(v)
*	uvlim_gvn_gnl	- limits given in a gen'l way: NEW=U[K=1:5]
*	uvlim_gvn_lo	- limits that require exact lo match: NEW=U[K=1:5@IIN]
*	uvlim_gvn_lohi	- limits require exact lohi match: NEW=U[K=1:5@WEQ]
*	uvlim_gvn_xact	- limits that reduce to a pt.: NEW=U[K=1:5@AVE]
*	uvlim_needed	- no limit info. given
*	uvlim_need_lo	- no lims but transf. needs xact lo:NEW=U[K@IIN]
*	uvlim_need_lohi	- no lims but transf. needs xact lohi:NEW=U[K=@WEQ]
*	uvlim_need_xact - no lims but transf. needs xact: NEW=U[K@AVE]
* note: i) uvlim_***_xact requires both limits to match exactly in order to
*	   reuse memory-resident data

* * * * DETERMINING UVAR_GIVEN WITH MULTIPLE COMPONENTS IN EXPRESSION * * *
*		---  aggregate of previous components ---
*			gnl	lo	lohi	  xact
*		------------------------------------------
* N C |	gnl	|	gnl	lo	lohi	gnl/xact |
* E O |	lo	|	 lo	lo	lohi	 lo/xact |
* W M |	lohi	|      lohi	lohi	lohi   lohi/xact |
*   P |	xact	|      lohi	lohi    lohi	  xact	 |
*		------------------------------------------
* in this table the rows refer to the context qualifiers of new components
* (i.e. what is given in square brackets).  The result of the table and
* the columns are a generalization of the same concept applied to an aggregate
* of components in an expression
* gnl  == no match required e.g. "U"		or "U[K=1:5]"
* lo   == match lo limit    e.g. "U[K=@IIN]"	or "U[K=1:5@IIN]"
* lohi == match lohi limit  e.g. "U[K=@WEQ]" 
* xact == match both limits e.g. "U[K=@AVE]"	(b case in a/b above)
*	  or neither limit e.g. "U[K=1:5@AVE]"	(a case in a/b above)
* "xact" is special because it refers to transformations that reduce a range
*	of data to a point (like averaging).  If limits are included ("gvn")
* 	it becomes self-documenting and axis-independent.

	DATA	(ax_choice(i,1),i=1,6) / EXP,NP ,EXP,EXP, IMP,IMP  /,
     .		(ax_choice(i,2),i=1,6) / NP ,NA ,NA ,WRN1,IMP,IMP  /,
     .		(ax_choice(i,3),i=1,6) / NA ,NA ,NA ,NA , NA ,WRN2 /,  
     .		(ax_choice(i,4),i=1,6) / NA ,NP ,EXP,EXP, NA ,IMP  /,
     .		(ax_choice(i,5),i=1,6) / EXP,EXP,EXP,EXP, IMP,IMP  /
! pre 1/97 .	(ax_choice(i,4),i=1,6) / NP , NP, EXP, EXP, NP , IMP  /
! pre 12/09.	(ax_choice(i,4),i=1,6) / NP , NP ,EXP, EXP, NA ,IMP  /,

	DATA	(joint_match(i,0),i=0,3) /  gnl,   lo, lohi, gnl  /,
     .		(joint_match(i,1),i=0,3) /   lo,   lo, lohi, lo   /,
     .		(joint_match(i,2),i=0,3) / lohi, lohi, lohi, lohi /,
     .		(joint_match(i,3),i=0,3) / lohi, lohi, lohi, xact /

**************************************************************************
* is this a grid changing variable? (1/97)
	
	IF (its_gc) THEN
	   gcfcn = WHICH_GCFCN(uvar)
	   CALL GCF_GET_AXIS_SRCS(gcfcn, iarg, axis_source)
	ENDIF

* initialize
	mrg_grd = cx_grid( mrg_cx )
	com_grd = cx_grid( com_cx )

* do we have nested user-defined variables ?
	nest = cx_category( com_cx ) .EQ. cat_user_var
	IF ( nest ) THEN
	   com_uvar = cx_variable( com_cx )
	   var_is_const = uvar_item_type( uvar_num_items(com_uvar), com_uvar )
     .          .EQ. alg_constant
	ENDIF

* Is the com_grd all  abstract ?  If so we won't add abstract axes willy-nilly
* to the grid
	mabstract = grid_line( 1, mgrid_abstract )
	normabst = .TRUE.
	DO idim = 1, nferdims
	   iline = grid_line(idim,com_grd)
	   IF (iline.NE.mabstract) normabst = .FALSE.
	ENDDO

* for merged context to be data set independent all components must be so
	IF ( cx_category(com_cx) .EQ. cat_pseudo_var ) THEN
* ... pseudo-vars are merged only if explicit "G=".  Was it G=var or G=grid ?
	   cx_dset_gvn(mrg_cx) = cx_dset_gvn(mrg_cx)
     .				.AND. .NOT.cx_grid_needs_dset
	ELSE
	   cx_dset_gvn(mrg_cx) = cx_dset_gvn(mrg_cx) .AND.
     .	(cx_dset_gvn(com_cx).OR.cx_data_set(com_cx).EQ.pdset_irrelevant)
	ENDIF

* data type of result
	IF (its_gc) THEN
* ... can get result data type only when types of all arguments are known
*     cuz it may be inherited from an argument
	  IF (iarg .EQ. 1) THEN
	    i = GCF_RTN_TYPE(gcfcn, com_cx)
	    IF (i .EQ. pfcn_rtn_string) THEN
	      cx_type(mrg_cx) = ptype_string
	    ELSE
	      cx_type(mrg_cx) = ptype_float
	    ENDIF
	  ENDIF
	ELSE
	  IF (uvar_num_items(uvar) .EQ. 1) THEN 
	    cx_type(mrg_cx) = cx_type(com_cx)   ! v="a" or v=5

* ... special HACK to allow string addition: "a" + "b"
	  ELSEIF (ITSA_PURE_SUM_VAR(uvar)) THEN
	    IF (cx_type(mrg_cx) .EQ. unspecified_int4) THEN
	        cx_type(mrg_cx) = cx_type(com_cx)  ! inherit first arg type
	    ELSEIF (cx_type(mrg_cx) .NE. cx_type(com_cx)) THEN
	        cx_type(mrg_cx) = ptype_float      ! unmatched arg types
	    ENDIF

	  ELSE
	    cx_type(mrg_cx) = ptype_float       ! expression float unless GC
	  ENDIF
	ENDIF

* loop through the axes

* 2/2014 - pass the aux var dependencies from the component to the merged result
* merged result will contain a conflict wherever components point to different
* aux variables for the same axis
	naux = 0
	DO idim = 1, nferdims
	   IF (cx_aux_var(idim,com_cx) .NE. unspecified_int4) THEN
	      naux = naux + 1
	      IF (cx_aux_stat(idim,mrg_cx).EQ.paux_stat_conflict ) THEN
* ... if previous merges had a conflict, it doesn't go away
	         CONTINUE
	      ELSEIF (cx_aux_stat(idim,mrg_cx).EQ.paux_stat_na) THEN
	         cx_aux_var (idim,mrg_cx) = cx_aux_var (idim,com_cx)
	         cx_aux_cat (idim,mrg_cx) = cx_aux_cat (idim,com_cx)
	         cx_aux_stat(idim,mrg_cx) = cx_aux_stat(idim,com_cx)
	      ELSEIF ( ( cx_aux_var(idim,mrg_cx)
     .	            .NE. cx_aux_var(idim,com_cx) ) 
     .		  .OR. ( cx_aux_cat(idim,mrg_cx)
     .		    .NE. cx_aux_cat(idim,com_cx) )  ) THEN
	         cx_aux_stat(idim,mrg_cx) = paux_stat_conflict
	         cx_aux_var (idim,mrg_cx) = unspecified_int4
	         cx_aux_cat (idim,mrg_cx) = unspecified_int4
	         IF (mode_diagnostic) THEN
* ... "Z axis auxiliary coordinates of expression in conflict.
*     "Variable TEMP coordinates are from DEPTH1"
*     "Other components indicate DEPTH2 
	             buff = ww_dim_name(idim)//
     .	' axis auxiliary coordinates of expression are in conflict.'
	             CALL SPLIT_LIST(pttmode_explct, ttout_lun, buff, 0)
	             buff = 'Variable '//VAR_CODE(cx_category(com_cx),
     .						  cx_variable(com_cx))
	             blen = TM_LENSTR1(buff)
	             buff(blen+1:) = 'coordinates are from '//
     .			VAR_CODE(cx_aux_cat(idim,com_cx),
     .				 cx_aux_var(idim,com_cx) )//'.'
	             CALL SPLIT_LIST(pttmode_explct, ttout_lun, buff, 0)
	             buff = 'Other components indicate '//
     .			VAR_CODE(cx_aux_cat(idim,mrg_cx),
     .				 cx_aux_var(idim,mrg_cx) )//'.'
	             CALL SPLIT_LIST(pttmode_explct, ttout_lun, buff, 0)
	          ENDIF
	       ELSEIF (cx_aux_stat(idim,mrg_cx).EQ.paux_stat_needed) THEN
* ... new compoonent uses same aux as previously merged
	         cx_aux_stat(idim,mrg_cx) = paux_stat_needed
	       ENDIF
	   ELSEIF (cx_aux_stat(idim,mrg_cx) .NE. paux_stat_na
     .	     .AND. cx_aux_stat(idim,mrg_cx) .NE. paux_stat_passed ) THEN
	       naux = naux + 1
	   ENDIF
	   IF (cx_aux_stat(idim,com_cx) .EQ. paux_stat_needed)
     .			cx_aux_stat(idim,mrg_cx) = paux_stat_needed
	ENDDO
	cx_naux(mrg_cx) = naux

* pass the axes and theirimplied dependencies to the merged result
	DO 500 idim = 1, nferdims

* get axes and lengths of data along them
	   com_ax  = grid_line ( idim, com_grd )
	   mrg_ax  = grid_line ( idim, mrg_grd )
	   com_len = CX_DIM_LEN( idim, com_cx  )
	   mrg_len = CX_DIM_LEN( idim, mrg_cx  )

* arg of grid-changing function?
	IF (its_gc ) THEN
	   IF (    axis_source(idim).EQ.pgc_ignore_axis) THEN
	      GOTO 500
	   ELSEIF (axis_source(idim).EQ.pgc_impose_axis) THEN
* ... imposed axes are handled later by GCF_IMPOSE_AXES
	      GOTO 500
	   ELSE
* ... it is evidently, a mergible axis ... continue on
	      CONTINUE
	   ENDIF	      
	ENDIF

* ignore axes with unknown limits
* 2/27/96 - kludge bug fix
* Dynamic axes and the logic inadequacies of FLESH_OUT_AXIS have
* created a problem. This check, which was here previously,
*	   IF ( cx_lo_ww(idim,com_cx) .EQ. unspecified_val8 ) GOTO 500
* was supposed to check if an axis has anything relevant to contribute. That
* logic was based on the fact that during grid determination subscript limits
* of 1:1,1:1,1:1,1:1 are supplied. Then FLESH_OUT_AXIS fills in the WW limits.
* But as the 7/92 "kludge" in FLESH_OUT_AXIS explains the logic is not reliable
* during grid determination. (A correct fix in that routine is to have a
* global Boolean indicating if Ferret is in its grid determination phase.)
* As a result, FLESH_OUT_AXIS may set the limits to unspecified ... counting
* on them to be filled in by the variable definition, itself. (Correct
* behavior for context determination, but not for grid determination).
* These unspecified limits were causing the axis to be ignored.
* On 2/27 we change this logic to use uvar_given to determine if this
* axis should be ignored.

* Made a special exception for mrg_ax being mnormal. In that case, even
* the unspecified limits are relevant. This is a poorly understood kludge
* fix to accomodate the fact that the grid is now initially set at all mnormal.
	   IF ( cx_lo_ww(idim,com_cx) .EQ. unspecified_val8
     .    .AND. mrg_ax .NE. mnormal				) THEN
	      IF ( cx_category(com_cx) .NE. cat_user_var ) GOTO 500
	      lims_gvn = uvar_given(idim, cx_variable(com_cx))
	      IF ( lims_gvn.GT. uvlim_gvn_xact
     .        .OR. lims_gvn.LT. uvlim_gvn_gnl ) GOTO 500
	   ENDIF

* 5/96 *sh*: have the limits of the new component been supplied?
* Previously the code simply used cx_given(idim,com_cx) to decide this
* but in doing so it missed the possibility that limits were given deeper
* inside of the component definition.
* Now we use expl_com_lim instead.
* 1/97: avoid uvlim_irrelevant mistakenly implying expl_com_lims is TRUE
*       by performing a more careful check on uvar_given than was done
	   expl_com_lim = cx_given(idim,com_cx)
	   IF ( nest ) expl_com_lim = expl_com_lim .OR. 
     .		    (     uvar_given(idim,com_uvar).LE.uvlim_gvn_xact     
     .		    .AND. uvar_given(idim,com_uvar).GE.uvlim_gvn_gnl  )
* (NOTE: might a similar test be needed on mrg_cx?)

* new axis same as merged one ?
	   same = com_ax .EQ. mrg_ax
! 5/96	   IF ( cx_given(idim,com_cx) .AND. cx_given(idim,mrg_cx) )
	   IF ( expl_com_lim .AND. cx_given(idim,mrg_cx) )
     .	      same  = same
     .		.AND. cx_lo_ss(com_cx,idim) .EQ. cx_lo_ss(mrg_cx,idim)
     .		.AND. cx_hi_ss(com_cx,idim) .EQ. cx_hi_ss(mrg_cx,idim)

* determine pointers into logic table
! 5/96	   IF ( cx_given(idim,com_cx) ) THEN
	   IF ( expl_com_lim ) THEN
	      IF ( same ) THEN
	        icom = 1
	      ELSE
	        icom = 3
	      ENDIF
	   ELSE
	      IF ( same ) THEN
	        icom = 5
	      ELSE
	        icom = 6
	      ENDIF
	   ENDIF
	   IF ( uvar_given(idim,uvar) .EQ. uvlim_irrelevant
     .	   .OR.  uvar_given(idim,uvar) .EQ. uvlim_hidden  ) THEN
	      imrg = 5
	   ELSEIF ( mrg_ax .EQ. mnormal ) THEN
	      imrg = 4
	   ELSEIF ( cx_given(idim,mrg_cx) ) THEN
	      IF ( mrg_len .EQ. 1 ) THEN
	        imrg = 1
	      ELSE
	        imrg = 2
	      ENDIF
	   ELSE
	      imrg = 3
	   ENDIF
! 6/99 NEXT LINE IS NOT AN ADEQUATE TEST!! com_len may in relity be GT 1, but
! buried within a uvar def'n. uvar_given tells that limits are buried, but
! NOT whether the limits are GT 1.
!  example: "v" in  SST[x=180] + v, where v=X[GX=xax,I=1:10]
	   IF ( com_len.GT.1 .AND. icom.LT.5 ) icom = icom + 1

* update the merged cx_given value (added 1/97)
	cx_given(idim,mrg_cx) = cx_given(idim,mrg_cx)
     .			  .AND. expl_com_lim

* Do not substitute an abstract axis for normal axes in the grid 
* when merging a constant

	IF (com_ax.EQ.mabstract .AND. mrg_ax.EQ.mnormal) THEN
c	   IF (.NOT. (normabst) .AND. var_is_const) GOTO 400
	   IF (normabst .AND. var_is_const) GOTO 400
	ENDIF

* take appropriate merging action
*		  EXP  IMP WRN1   ***   NA  WRN2
	   GOTO ( 100, 200,  90, 9000, 400, 190 ) ax_choice(icom,imrg)

* give a warning before imposing ambiguous explicit limits
* (use grid name as a flag to prevent multiple warnings)
 90	   IF ( grid_name(mrg_grd) .EQ. 'UVAR' ) CALL WARN
     .			('Ambiguous coordinates on '//
     .			ww_dim_name(idim)//' axis: '//
     .			uvar_text(uvar)(:TM_LENSTR1(uvar_text(uvar))))
	   grid_name(mrg_grd) = 'AMBG'

* impose explicit limits from component that gave them (e.g. U[K=5])
 100	   CALL TM_USE_LINE(com_ax)
	   CALL TM_DEALLO_DYN_LINE(mrg_ax)
	   grid_line( idim, mrg_grd ) = com_ax
	   cx_lo_ss( mrg_cx, idim ) = cx_lo_ss( com_cx, idim )
	   cx_hi_ss( mrg_cx, idim ) = cx_hi_ss( com_cx, idim )
	   GOTO 400

* give a warning before imposing ambiguous implicit limits

 190	   IF ( grid_name(mrg_grd) .EQ. 'UVAR'
     .		.OR. grid_name(mrg_grd) .EQ. 'AMBG' ) CALL WARN
     .			('Ambiguous coordinates on '//
     .			ww_dim_name(idim)//' axis: '//
     .			uvar_text(uvar)(:TM_LENSTR1(uvar_text(uvar))))
	   grid_name(mrg_grd) = 'AMBG'

* impose an axis with implicit coordinates (inferred from the context)
 200	   CALL TM_USE_LINE(com_ax)
	   CALL TM_DEALLO_DYN_LINE(mrg_ax)
	   grid_line( idim, mrg_grd ) = com_ax

* save implications about how limits are given in thi uvar_given(idim,uvar) .EQ. uvlim_s component
* if the component is a user-defined variable then consider the implications
* of its definition
* com_class encodes the way limits are given in this component
* uv_class is an intermediate for computing uvar_lim
* ... first the a/b option in the joint_limit_match table

* ... first screen out irrelevant cases
* 2/23/98 - for a component which is a user var, uvar_given tells if it
*           is irrelevant  
*        For a component which is not, cx_lo_ww was already used prior to 2/98
 400	   IF ( nest ) THEN
	      IF (uvar_given(idim,com_uvar).EQ.uvlim_irrelevant) THEN
	         GOTO 500
* (6/0) ... pass hidden limits if no specification preceded it
	      ELSEIF (uvar_given(idim,com_uvar).EQ.uvlim_hidden) THEN
	         IF ( uvar_given(idim,uvar).EQ.uvlim_irrelevant )
     .				uvar_given(idim,uvar) = uvlim_hidden
	         GOTO 500
	      ENDIF
	   ELSE
	      IF (cx_lo_ww(idim,com_cx) .EQ. unspecified_val8) GOTO 500 ! 1/97
	   ENDIF

* If a previous component gave us uvlim_need_xact, we just kept that setting. 
* for the entire expression. This was the cause of ticket 2051. Use 
* uvlim_need_lohi instead for the tests below.

*  For 2273, we do not want to change the value of uvar_test here. The 
*  examples in ticket 2051 still give correct resu;ts, but the RETURN= examples 
*  in the report for 2273 did not.  Perhaps changes for the `RETURN=isready` 
*  have allowed cause  this to work better?

cc	   IF ( uvar_given(idim,uvar) .EQ. uvlim_need_xact ) GOTO 500
	   uvar_test =  uvar_given(idim,uvar)

* get limits-region class of new component
	   IF ( nest ) THEN
	      com_class = NEST_REGION_CLASS( idim, com_cx, com_uvar )
	   ELSE
	      com_class = REGION_CLASS( idim, com_cx )
	   ENDIF

	   IF ( uvar_given(idim,uvar) .EQ. uvlim_irrelevant 
     .	   .OR. uvar_given(idim,uvar) .EQ. uvlim_hidden) THEN ! 1/97
* nothing meaningful has been merged in so far
	      uv_class = com_class				   ! 1/97
	   ELSE
* get limits-region class of so-far-merged components
	      mrg_class = MOD( uvar_test, 4 )
* how does the new component effect the merged class ?
	      uv_class = joint_match( mrg_class, com_class )
	   ENDIF

* if the new component or any previous lacks given limits so does the result
* e.g. LIST/K=1:5 U - U[K=3]
* (the /K limits are lacking in the overall expression)
!    2/28/98: replaced:  	   .OR. .NOT.cx_given(idim,com_cx)
	   IF ( uvar_given(idim,uvar).GE. uvlim_needed
     .	   .OR. .NOT.expl_com_lim
     .	   .OR. .NOT.INHERITED_LIMITS(idim,com_cx) ) THEN
	      uvar_given(idim,uvar) = uv_class + uvlim_needed
	   ELSE
	      uvar_given(idim,uvar) = uv_class
	      IF ( cx_given(idim,com_cx) ) THEN
	         CALL TRANSFER_CX_AXIS_TO_UV( idim, com_cx, uvar)
	      ELSEIF ( expl_com_lim ) THEN
	         CALL TRANSFER_UV_AXIS_TO_UV( idim, com_uvar, uvar)
	      ENDIF
	   ENDIF
	
 500	CONTINUE

* deallocate any implicit (temporary) grid that was created for this context
	IF ( cx_has_impl_grid(com_cx) ) THEN
	   IF ( mode_diagnostic )  CALL DIAG_OP
     .		('dealloc ', isact_class_impl_grid, com_grd, 0)
	   cx_has_impl_grid(com_cx) = .FALSE.
	   CALL TM_DEALLO_DYN_GRID( com_grd )
	ENDIF

* successfully merged
	status = ferr_ok
	RETURN

* error exit
 5000	RETURN
 9000	CALL ERRMSG( ferr_internal, status, 'mrg_grd_err', *5000 )
	END

	SUBROUTINE PERMUTE_PTR_SUB( src_cx, perm,
     .		src, slox, shix, sloy, shiy, sloz, shiz, 
     .		slot, shit, sloe, shie, slof, shif,
     .		dst, dlox, dhix, dloy, dhiy, dloz, dhiz, 
     .		dlot, dhit, dloe, dhie, dlof, dhif )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* permute the 4D data from the source grid into the destination grid
* - 24 possible permutations  (!4)
* note: can probably be done in a more condensed form using EQUIVALENCES and
* perm to set up the loop indices. PERMUTE_SUB, likewise.

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V533: 6/01 *sh*
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'

* calling argument declarations:
	INTEGER src_cx, perm(nferdims),
     .		slox, shix, sloy, shiy, sloz, shiz, 
     .		slot, shit, sloe, shie, slof, shif,
     .		dlox, dhix, dloy, dhiy, dloz, dhiz, 
     .		dlot, dhit, dloe, dhie, dlof, dhif
	REAL*8  src( slox:shix,sloy:shiy,sloz:shiz,slot:shit,sloe:shie,slof:shif ),
     .		dst( dlox:dhix,dloy:dhiy,dloz:dhiz,dlot:dhit,dloe:dhie,dlof:dhif )

* internal variable declarations:
	INTEGER	loi, loj, lok, lol, lom, lon, 
     .		hii, hij, hik, hil, him, hin, 
     .		i, j, k, l, m, n, idim
	INTEGER	lo(nferdims), hi(nferdims), ii(nferdims)
	EQUIVALENCE
     .		(lo(1), loi), (hi(1), hii), (ii(1), i),
     .		(lo(2), loj), (hi(2), hij), (ii(2), j),
     .		(lo(3), lok), (hi(3), hik), (ii(3), k),
     .		(lo(4), lol), (hi(4), hil), (ii(4), l),
     .		(lo(5), lom), (hi(5), him), (ii(5), m),
     .		(lo(6), lon), (hi(6), hin), (ii(6), n)

* --- end of introductory code ---

* initialize - save loop limits as unsubscripted variables
	DO 100 idim = 1, nferdims
	   lo(idim) = cx_lo_ss(src_cx,idim)
	   hi(idim) = cx_hi_ss(src_cx,idim)
 100	CONTINUE

	DO 200  n = lon, hin
	DO 200  m = lom, him
	DO 200  l = lol, hil
	DO 200  k = lok, hik
	DO 200  j = loj, hij
	DO 200  i = loi, hii
	   CALL COPY_C_STRING( src(i,j,k,l,m,n),
     .		dst(ii(perm(1)),ii(perm(2)),ii(perm(3)),ii(perm(4)),
     .		ii(perm(5)),ii(perm(6))))
 200	CONTINUE

	RETURN
	END 

	SUBROUTINE SHOW_ATTRIBUTE ( varname, coordvar, attname, attype, 
     .                    attlen, attstr, attvals, attoutflag, sho_out) 
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute SHOW ATTRIBUTE for a single variable and attribute name

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP
*
* V600 6/05 *acm* Attribute control.
* V650  Write to show_lun which may be set to a file unit number rather than std out
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'xtext_info.cmn'
        include 'xprog_state.cmn'
        include 'xinterrupt.cmn'
        include 'netcdf.inc'

* calling argument declarations
        LOGICAL coordvar, sho_out
	INTEGER	attype, attlen, attoutflag
	REAL attvals(*)
	CHARACTER varname*(*), attname*(*), attstr*(*)

* local parameter declarations:
	LOGICAL	    full_precision
	PARAMETER ( full_precision = .TRUE. )

* local variable declarations:
	INTEGER  TM_LENSTR1, slen, llen, vlen, i, status
        CHARACTER TM_FMT*14, vbuff*14, buff*2048, punc*2

* local parameter declarations:
	INTEGER		sig_figs
	PARAMETER     ( sig_figs = 7 )   ! was 5 1/95

        slen = 2
        vlen = TM_LENSTR1(varname)
        llen = TM_LENSTR1(attname)
        buff = ' '//varname(:vlen)//'.'//attname(:llen)//' '
        slen = slen + llen + vlen + 1
        IF (coordvar) THEN
           buff = ' ('//varname(:vlen)//').'//attname(:llen)//' '
           slen = slen + 2
        ENDIF

* if character type, write the attribute name with its string value

        IF (attype .EQ. NCCHAR) THEN

           buff = buff(:slen)//'= '//attstr(:attlen)
           slen = slen + 3 + attlen

           IF (sho_out) THEN
              IF (attoutflag .EQ. 0) buff = buff(:slen)//'    0'
              IF (attoutflag .EQ. 1) buff = buff(:slen)//'    1'
              slen = slen + 5
           ENDIF
        
           CALL SPLIT_LIST(pttmode_explct, show_lun,
     .		           buff, slen)

* If numeric, write the value(s)

        ELSE
           
           punc = '= '
	   DO 100 i = 1, attlen
	      IF ( interrupted ) CALL ERRMSG
     .		   ( ferr_interrupt, status, ' ', *1000 )
	   
              vbuff = TM_FMT(attvals(i), sig_figs, 14, llen )
              buff = buff(:slen)//punc//vbuff(:llen)
              slen = slen + 2 + llen
              punc = ', '

 100	   CONTINUE
 
           IF (sho_out) THEN
              IF (attoutflag .EQ. 0) buff = buff(:slen)//'    0'
              IF (attoutflag .EQ. 1) buff = buff(:slen)//'    1'
              slen = slen + 5
           ENDIF

           CALL SPLIT_LIST(pttmode_explct, show_lun, buff, slen)

	ENDIF      

* successful completion
 1000	RETURN
	END

	SUBROUTINE DSG_FEATURE_KEYS (var1, nmv, cx_list, 
     .		key_feature_id, this_no_range, overlay, nokey)
   
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Put keys for multi-line plot for a DSG dataset.

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'plot_setup.parm'
	include 'xplot_setup.cmn'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'  
	include 'xcontext.cmn'

* calling argument declarations:
	LOGICAL this_no_range(*), overlay, nokey
	INTEGER var1, nmv, cx_list(*), key_feature_id(*)

* internal variable declarations:
	LOGICAL user_title
	INTEGER	TM_LENSTR1, 
     .		ipl, nline_in_mem, slen, style, 
     .		justify, i
	
	CHARACTER*2040	plot_title
	CHARACTER	TM_FMT*48, buff1*16, fnum*12
	REAL		xkeypos, ykeypos, xkeysize, ykeysize, 
     .			lab_ht, labsize, val


* * * * * * *    - - - TITLES - - -   * * * * * * * * *

	nline_in_mem = 0
	IF ( overlay ) THEN
! TODO...

	ELSE

* ... keys for the dependent vars, or if one, only the title or axis label
	   DO 600 ipl = var1, nmv
	      nline_in_mem = nline_in_mem + 1
	      IF (ipl .GT. max_key_entries) CYCLE
	      IF ( use_keys .AND. (.NOT. nokey) .AND.nmv.GT.var1) THEN
		 val = key_feature_id(ipl)
		 fnum = TM_FMT(val, 8, 10, slen)
		 plot_title = 'Feature '//fnum(:slen)
		 slen = slen + 8
	      ENDIF
              IF (this_no_range(ipl) .AND. mode_nodata_lab) THEN
                 plot_title(slen+1:slen+14) = ' No Valid Data'
                 slen = slen + 14
              ENDIF
	      IF ( nmv .EQ. 1 .OR. user_title ) THEN
	    
	         !?
	      ELSE
                 IF (.NOT. nokey) THEN
	            CALL KEY_LOC( overlay, xkeypos, ykeypos, xkeysize, ykeysize,
     .			       lab_ht, style, justify, plot_title(:slen) )
	            CALL PUT_KEY( nline_in_mem, plot_title(:slen),
     .			       xkeypos, ykeypos, xkeysize, ykeysize,
     .			       lab_ht, style,
     .			       lab_loc_absolute, lab_loc_absolute )
	         ENDIF
	      ENDIF

 600	   CONTINUE

	ENDIF  ! overlay
	
	RETURN
	END

	SUBROUTINE LIST_DSG_DATA ( dset, cx_list, mr_list, nvar,
     .				   heading, nfeatures, nobs )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* List data from a single DSG feature collection


* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V720 4/17 *sh*
* V74+ 6/18 *acm* initial improvements for header for the listing
* V74+ 7/18 *acm* Better handling of string vars - still needs more work.
* V75+ 4/19 *acm* Longer string buffer to contain feature-id strings.
*                 Need comprehensive update to string-lenghts of names and attributes 
* V75+ 4/19 *acm* Note any transformation applied.
* V75+ 4/19 *acm* Changes to SUBSET listing in header
* V751 7/19 *acm* Changes to units and transforms listed in the header for all vars.
* V751 7/18 *acm* Call single routine for DSG feature-type names
* V76  1/20 *acm* Point-type DSG datasets do not have a feature-id variable
* V76  3/20 *acm* Tweak to column-header line so names don't run together
* v7.6 *acm* 5/20 Issue 1876: can read string-typed data.

        include 'netcdf.inc'
	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xtm_grid.cmn_text'
	include 'xdset_info.cmn_text'
	include 'xdyn_linemem.cmn_text'
	include 'xcontext.cmn'
	include 'xprog_state.cmn'
	include 'xvariables.cmn'
	include 'slash.parm'
	include 'xrisc.cmn'          ! SPLIT_LIST buffer

* calling argument declarations:
	LOGICAL heading
	INTEGER dset, nvar, nfeatures, cx_list(nvar), mr_list(nvar)

* internal parameter declarations:
	INTEGER maxlen
	PARAMETER (maxlen = 20)   ! length of buffer str
             

* internal variable declarations:
	LOGICAL  ITSA_DSG_POINTS, 
     .		process_feature(nfeatures), process_obs(nobs), its_dsg, 
     .		has_mask, norow, its_point_data, do_blank
	LOGICAL instance_coord(4), relevant_coord(4),
     .		instance_var(nvar), point_var(nvar), 
     .		instance_vars_only, point_vars_only, 
     .		ftr_label, constraint_labels, all_bad
	INTEGER CGRID_SIZE, TM_LENSTR1, DSG_WHATS_IT,
     .		GET_OFFSET_C_STRING_LEN, CX_DIM_LEN, GET_MAX_STRING_LEN,
     .		i, j, ifeature, ivar, iobs, nobs, idim, cx, grid, slen,
     .		orientation, obsdimlen, coord_lm(4), fvar_varid, base, ptr,
     .		bufflen, line, mr,  gxlate, row_size_lm, clen, nblank,
     .		feature_line, prec_digits(nvar), col_width(nvar), iwd, 
     .		alen, slen1, slen2, vname_len, list_dsg_digits, dtype, 
     .		vdims(2), idlen, ilen, ipad, idwid, data_len, nleft, nright,
     .		nok, direc(nvar), min_width, vstrlen, paren, trans, status
	REAL	value, small, big, biggest
	CHARACTER LEFINT*8, VAR_CODE*128, TM_FMT*48, VAR_UNITS*64,
     .		FMT*20, AX_TITLE*32, SANITARY_VAR_CODE*128, CD_DSG_FEATURENAME*20,
     .		strbuff*128, line_buff*10000, vcode(nvar)*128,  
     .		col_head_format*32, pstr*15, feature_idname*32, buff*128,
     .		good_fmt(max_intrp)*10, bad_fmt*10

	CHARACTER*255	VAR_TITLE, VAR_TITLE_MOD, PAREN_SURROUND, vname_buff

	PARAMETER (vstrlen=40)  ! length of vstr
	CHARACTER vstr*40


* coordinate listing field widths
	INTEGER coord_width(4)
     
	DATA coord_width/11, 10, 8, 20/
	CHARACTER*20 coord_head(4)
	DATA coord_head(1)/'  LONGITUDE         '/,
     .	     coord_head(2)/'  LATITUDE          '/,
     .	     coord_head(3)/'   DEPTH            '/,
     .	     coord_head(4)/'            TIME    '/

* initialize

        norow = qual_given(slash_list_norow) .GT. 0

* comma or tab delimited? 

        IF (list_fmt_type.EQ.plist_comma_del .OR. 
     .       list_fmt_type.EQ.plist_tab_del ) THEN
	   CALL LIST_DSG_COMMA_TAB (dset, cx_list, mr_list, nvar,
     .				   heading, nfeatures, nobs )
	   GOTO 5000
	ENDIF

	gxlate = dsg_xlate_grid(dset)
	cx = cx_list(1)
	grid = cx_grid(cx)
	its_dsg = .TRUE.
	CALL TM_DSG_FACTS( grid,
     .			   orientation, obsdimlen, feature_line, its_dsg )
	IF (.NOT. its_dsg) GOTO 5200
	row_size_lm = dsg_loaded_lm(dsg_row_size_var(dset))

	its_point_data = ITSA_DSG_POINTS(cx)
	IF (its_point_data) orientation = pfeatureType_Point

	feature_idname = 'feature'

	IF (orientation.GE.pfeatureType_Trajectory .AND. orientation.LE.pfeatureType_Point) THEN
	   strbuff = CD_DSG_FEATURENAME(orientation)
	   feature_idname = strbuff(:tm_lenstr1(strbuff)) // '-id'
	ENDIF

* determine precision for outputting values

	list_dsg_digits = list_digits

	i = qual_given( slash_list_precision ) 
	IF ( i .GT. 0 ) THEN
	   CALL EQUAL_VAL( cmnd_buff(qual_start(i):qual_end(i)),
     .                     value, status )
           IF ( status .NE. ferr_ok ) GOTO 5100
	   list_dsg_digits = MAX(1.,MIN(value, 16.))	! 1 to 16
	ENDIF

!DSGTBD: style consideration: some of the info summarized here may be needed
!        also in plotting, other types of listing, etc.  Perhaps factor this
!        code and create a subroutine or two that can be re-used making
!        greater simplicity setting up plots.

* are there any observation vars?  Or is this all instance vars?
	point_vars_only    = .TRUE.   ! a hack to list E=@AVE result
	instance_vars_only = .TRUE.   ! a hack to list instance vars only
	ftr_label = .TRUE.


* Point-type data has its length along the E axis
	IF (orientation .EQ. pfeatureType_Point) THEN
	   point_vars_only = .FALSE.
	   instance_vars_only = .FALSE.
	   ftr_label = .FALSE.
	   DO ivar = 1, nvar
	      point_var(ivar) = CGRID_SIZE(cx) .EQ. 1
	   ENDDO

	ELSE

	   DO ivar = 1, nvar
	      cx = cx_list(ivar)
	      grid = cx_grid(cx)
	      instance_var(ivar) = DSG_WHATS_IT(grid) .EQ. pdsg_instance
	      point_var(ivar) = CGRID_SIZE(cx) .EQ. 1
	      IF (.NOT.point_var(ivar)   ) point_vars_only    = .FALSE.
	      IF (.NOT.instance_var(ivar)) instance_vars_only = .FALSE.
	   ENDDO

	ENDIF

********** as in list_multi ***

* get direction of each variable in the dsg file

	DO ivar = 1, nvar
	   
	   cx = cx_list(ivar)
	   mr = mr_list(ivar)
	   direc(ivar) = no_dim

	   DO idim = 1, nferdims
	      IF ( cx_hi_ss(cx,idim) .GT. cx_lo_ss(cx,idim) ) 
     .	          direc(ivar) = idim
	   ENDDO
	
	ENDDO

	DO ivar = 1, nvar

* ... determine numeric format to fit nicely in each field
* ... first find largest value to be printed - routine applies 
*     feature-mask to narrow the amount of data

	   IF ( mr_type(mr_list(ivar)) .NE. ptype_string ) THEN
	   
	      mr = mr_list(ivar)
	      cx = cx_list(ivar)

	      IF (point_var(ivar)) THEN
* ... compressed feature result
	         small = memry(mr)%ptr(1)
		 big = small
		 IF ( small .NE. mr_bad_data(mr_list(ivar)) ) nok = 1

	      ELSE

	         CALL MINMAX_DSG ( dset, cx, nfeatures, direc(ivar), 
     .			   memry(mr_list(ivar))%ptr, 
     .			   mr_bad_data(mr_list(ivar)), small, big, nok)
	      ENDIF

	      all_bad = nok .EQ. 0

* . . . how many digits right and left of decimal point ?
	      biggest = MAX( ABS( small ), big )
	      CALL GET_SIG_DIGITS( biggest, list_dsg_digits, nleft, nright )
	      nleft = MAX( 1, nleft )			! at least "0" to left
	   ENDIF

* ... field must be wide enough to accomodate the variable code heading
*     (to a max of 8 characters)
	   min_width = 8

* . . . determine FORTRAN format for listing of this variable
	   IF ( mr_type(mr_list(ivar)) .EQ. ptype_string ) THEN
	      col_width(ivar) =  min_width
	      good_fmt(ivar) = '(A)'  ! not used
	   ELSEIF ( all_bad ) THEN
	      col_width(ivar) =  min_width	
	   ELSE
	      CALL VAR_DATA_FMT( nleft, nright, list_dsg_digits, min_width,
     .			         col_width(ivar), good_fmt(ivar), bad_fmt )

	   ENDIF

	   data_len = data_len + col_width(ivar)
	ENDDO

*************


* The varid of the feature-id variable
 
	IF (orientation .NE. pfeatureType_Point) THEN
	   line_buff = SANITARY_VAR_CODE(cat_file_var, dsg_feature_var(dset) )
	   CALL CD_GET_VAR_ID  (dset, line_buff, fvar_varid, status)
	ENDIF

* which dimensions are relevant to show

	IF (.NOT.norow) THEN
	   DO idim = 1, 4
	      line = grid_line(idim, gxlate)
	      relevant_coord(idim) =  line.NE.mnormal .AND. .NOT.point_vars_only
	      IF (relevant_coord(idim)) THEN
	         ivar = dsg_coord_var(idim,dset)
	         coord_lm(idim) = dsg_loaded_lm(ivar)  ! line memory table indices
	         instance_coord(idim) = line_dim(line) .EQ. nfeatures
* ... it causes confusion to show observation coordinates if the variables
*     requested are all instance variables
*     e.g. for time series, what is the time of the rowSize variable?
	         IF (instance_vars_only .AND. .NOT.instance_coord(idim))
     .		      relevant_coord(idim) = .FALSE.
	      ENDIF
	   ENDDO
	ENDIF

* create a mask showing which features to list
	IF (point_vars_only) THEN
	   process_feature(1) = .TRUE.    ! E axis reduced to 1 point
	   ftr_label = (nfeatures .EQ. 1) ! if compressed along ftr dir, don't list feature lab
	ELSE
	   CALL MAKE_DSG_FEATURE_MASK(dset, cx, process_feature, nfeatures)
	ENDIF
	IF (norow) ftr_label = .FALSE.
	IF (orientation .EQ. pfeatureType_Point) ftr_label = .FALSE.

* Header

	IF (heading) THEN 

* data set name and title
	   CALL GET_DSET_NAME( dset, line_buff, alen )
	   CALL SPLIT_LIST(pttmode_explct, list_lun,
     .		'   DATA SET: '//line_buff(:alen), 0)
 3020	   FORMAT( 13X,A)
* ... title of data set
	   CALL GET_DSET_TITLE( dset, line_buff, alen )
	   IF ( alen .GT. 1 ) CALL SPLIT_LIST(pttmode_explct, list_lun,
     .		'   '//line_buff(:alen), 0)

* ... Is a feature mask set on this dataset?
	   IF (dsg_msk_lm(dset) .NE. unspecified_int4) THEN 
	      risc_buff = 'Mask on features has been set: '
	      slen1 = TM_LENSTR1( risc_buff ) + 1
	      
	      CALL GET_DSG_MASK_TITLE (dset, risc_buff(slen1+1:), has_mask, slen2)

	      slen1 = TM_LENSTR1( risc_buff ) 
	      IF (slen2 .EQ. 0) slen1 = slen1 - 1

	      IF (slen1 .GT. 0)  CALL SPLIT_LIST(pttmode_explct, list_lun, risc_buff(:slen1), 0) 
	   ENDIF ! feature-mask

* ... region information
* ... which axes require labels

	   constraint_labels = .FALSE.
	   DO idim = 1, 4
	      IF ( relevant_coord(idim) .AND. 
     .	   	   cx_lo_ww( idim,cx_cmnd ) .NE. unspecified_val8 ) 
     .		   constraint_labels = .TRUE. 
	   ENDDO
	   IF ( cx_lo_ww( e_dim, cx_cmnd ).NE.unspecified_val8
     .          .OR. cx_lo_ss( cx_cmnd, e_dim ).NE.unspecified_int4 ) 
     .		constraint_labels = .TRUE. 

	   IF (constraint_labels) THEN 
	      line_buff = '   SUBSET   :'
	      slen = 13
	      DO idim = 1, 4
	         IF ( relevant_coord(idim) ) THEN
	            IF ( cx_lo_ww( idim,cx_cmnd ) .NE. unspecified_val8 ) THEN 
	               CALL ASCII_LIMITS( cx, idim, buff, slen1 )
	               col_head_format = AX_TITLE( idim, gxlate, alen )
	               line_buff(slen+1:) = ' '//col_head_format(:alen)//': '//buff(:slen1)
	               slen = TM_LENSTR1( line_buff ) 
		       CALL SPLIT_LIST( pttmode_explct, list_lun, line_buff, slen)
		       line_buff = '     '
		       slen = 13

	            ENDIF
	         ENDIF

	      ENDDO
	      
	   ENDIF
		 
* ... e-direction
	   IF ( cx_lo_ww( e_dim, cx_cmnd ).NE.unspecified_val8
     .       .OR. cx_lo_ss( cx_cmnd, e_dim ).NE.unspecified_int4 ) THEN 
	      CALL ASCII_LIMITS( cx, idim, risc_buff, slen1 )
	      col_head_format = AX_TITLE( idim, grid, alen )
	      CALL SPLIT_LIST( pttmode_explct, list_lun,
     .			line_buff(:slen)//' '//col_head_format( :alen )//': '
     .			//risc_buff(1:slen1), 0)

	   ENDIF

* ... then variable titles and any special limits or data set for a variable

	   strbuff = VAR_CODE( cat_file_var, dsg_feature_var(dset))
	   vname_len = TM_LENSTR1( strbuff )
	   alen = 10
	   vname_len = MAX(vname_len, alen)

	   DO ivar = 1, nvar
	      cx = cx_list(ivar)
	      strbuff = VAR_CODE( cx_category(cx),cx_variable(cx))
	      alen = TM_LENSTR1( strbuff )
	      vname_len = MAX(vname_len, alen)
	   ENDDO

	   WRITE(FMT,2020) vname_len
2020	   FORMAT ("(1x, A", I0, ",' is ', A)")

	   vname_buff = VAR_CODE( cat_file_var, dsg_feature_var(dset))
	   risc_buff = ' '


	   IF (orientation .NE. pfeatureType_Point) THEN
	      WRITE ( risc_buff, FMT ) 
     .           vname_buff(:vname_len), feature_idname(:TM_LENSTR1(feature_idname))
	      IF (.NOT.norow) CALL SPLIT_LIST(pttmode_explct, list_lun, risc_buff, 0)
	   ENDIF

	   DO ivar = 1, nvar
	      cx = cx_list(ivar)
	      strbuff = VAR_CODE( cx_category(cx),cx_variable(cx))
	      alen = TM_LENSTR1( strbuff )
	      vname_buff   = VAR_TITLE( cx )
	      clen   = TM_LENSTR1( vname_buff )
	      buff = PAREN_SURROUND(VAR_UNITS(cx), slen1)
	      IF (INDEX( buff, '(# of points)') .GT. 0) slen1 = 0
	      vname_buff   = vname_buff(:clen)//' '//buff(:slen1)
   	   	      
	      clen = clen+1+slen1

* Add anything about regridding, or axis description, but not transforms, which are done below.
	      buff   =  PAREN_SURROUND(VAR_TITLE_MOD(cx),slen2)
	      IF (INDEX(buff, "regrid").GT.0 .OR. INDEX(buff, "(axis").GT.0) 
     .	   	           vname_buff = vname_buff(:clen)//' '//buff(:slen2)
	      clen = clen+1+slen2

	      risc_buff = ' '
	      WRITE ( risc_buff, FMT ) strbuff(:vname_len), vname_buff(:clen)
              slen1 = TM_LENSTR1(risc_buff)

* Was there a transformation?
*     buff describes any transformation done on the obs axis for each feature. 
	
	      buff = ' '
	      DO idim = 1, 4
	         IF ( cx_lo_ww( idim,cx ) .NE. unspecified_val8 ) THEN 
	            CALL ASCII_LIMITS( cx, idim, line_buff, slen1 )
	            col_head_format = AX_TITLE( idim, grid, alen )
	            trans = cx_trans( idim, cx )
	            IF ( trans .NE. trans_no_transform ) THEN
	               clen = INDEX( line_buff(1:slen1), '(', .TRUE.)  ! last paren in string
	               IF (clen.GT.0) THEN
	                  buff = line_buff(clen:slen1) 			  
			  clen = TM_LENSTR1( buff )

* Put "each feature" in the label except for "closest distance" trans which are not done per feature

			  slen1 = TM_LENSTR1( risc_buff )

			  IF ( INDEX( buff, 'closest ') .GT. 0 ) THEN
			     risc_buff(slen1+1:slen+clen) = ' '
			     risc_buff(slen1+1:) = ' '//buff(:clen)
			  ELSE
			     risc_buff(slen1+1:) = ' '//buff(:clen-1)// ', each '//
     .	   	            feature_idname(:TM_LENSTR1(feature_idname))//')'
			  ENDIF

		       ENDIF
	            ENDIF

	         ENDIF
	      ENDDO



	      CALL SPLIT_LIST(pttmode_explct, list_lun, risc_buff, 0)

	   ENDDO  ! nvar


	ENDIF  ! heading

* Column header line. List this even if they said /nohead.
	slen = 0
	line_buff = ' '
	     
	IF (.NOT.norow) THEN
	   
	   strbuff =  VAR_CODE( cat_file_var, dsg_feature_var(dset))
	   IF (orientation .EQ. pfeatureType_Point) strbuff = ' '
	   clen = TM_LENSTR1(strbuff)

	   line_buff = '    FEATURE  '//strbuff(:clen)
	   slen = 23

	   DO idim = 1, 4
	      IF (relevant_coord(idim)) THEN
		 line_buff(slen+1:) = coord_head(idim)
	         slen = slen + coord_width(idim)
	      ENDIF
	   ENDDO

	ENDIF

	DO ivar = 1, nvar
	   cx = cx_list(ivar)
	   strbuff = VAR_CODE( cx_category(cx),cx_variable(cx))
	   clen = TM_LENSTR1(strbuff)
	   nblank = MAX(col_width(ivar)-clen, 1)
	   line_buff(slen+nblank:slen+nblank) = ' '
	   line_buff(slen+nblank+1:) = strbuff  
	   slen = slen + col_width(ivar)
	ENDDO

	IF (.NOT.heading .AND. norow .AND. nvar.EQ.1) line_buff = ' '
	CALL SPLIT_LIST(pttmode_explct, list_lun, line_buff, 0)

* get string length for ID variable - if its a string. 
* use strbuff and bufflen as dummy variables here

	pstr = '               '
	idlen = 5
	ipad = 0

	IF (.NOT.norow) THEN
	   CALL CD_GET_VAR_TYPE (dset, fvar_varid, strbuff, dtype, status)
	   IF (dtype .EQ. NF_CHAR) THEN
	      CALL CD_GET_VAR_DIMS_INFO (dset, fvar_varid, strbuff, bufflen, 
     .           vdims, status)
              CALL CD_GET_DS_DIMS (dset, vdims(1), strbuff, idlen, status)
	      ipad =(8-idlen)/2 
	      ipad = INT( (5-idlen)/2 )
	      ipad = MAX(1, INT( (5-idlen)/2 ) )
	   ENDIF
	ENDIF

*  ***** LIST THE DATA ******
	base = 0    ! obs index at end of preceding feature

* ... loop over the features
	DO ifeature = 1, nfeatures 
	   nobs = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
	   IF (orientation .EQ. pfeatureType_Point) nobs = 1

* ... have the user's constraints removed this feature?
	   IF (.NOT.process_feature(ifeature)) GOTO 500

	   IF ((heading .OR. base.GT.0) .AND. .NOT.norow) THEN
	      do_blank = (.NOT.point_vars_only .AND. .NOT.instance_vars_only)
	      IF (orientation .EQ. pfeatureType_Point) do_blank = .FALSE.
	      IF (do_blank) CALL SPLIT_LIST(pttmode_explct, list_lun, ' ', 1)
	   ENDIF

* ... each line starts with the feature number and Feature ID
	   buff = pstr
	   IF (.NOT.norow) WRITE(buff, 3100) ifeature
 3100	   FORMAT(I6, 2x)
	   ilen = 8

* Read the feature-id value. If it's numeric turn it into a string

	   IF (ftr_label) THEN
	      idwid = 15
	      CALL CD_READ_ONE ( dset, fvar_varid, ifeature, dtype, value, 
     .                                 strbuff, bufflen, status )

	      IF (dtype .EQ. NF_CHAR .OR. dtype.EQ.NF_STRING) THEN
	         bufflen = MIN(idlen, bufflen)
	         IF (bufflen .LT. idwid) THEN
	            ipad = INT(idwid-bufflen)
	         ENDIF
	      ELSE
	         strbuff = '  '//TM_FMT(value, 8, 12, bufflen)
	         bufflen = MAX(12,bufflen)
	         ipad = 3
	      ENDIF

* if compressed along the e dimension don't include the feature-id value.
	   ELSE
	      strbuff = '               '
	      pstr = ' '
	      ipad = 0
	      bufflen = 15
	   ENDIF

	   bufflen = MIN(32-ilen-ipad, bufflen)
	   buff(ilen+1:) = pstr(:ipad)//strbuff(:bufflen)
	   ilen = ilen + bufflen + ipad
	   IF (norow) ilen = 0


* ... get observation-level mask for this feature
	   CALL MAKE_DSG_OBS_MASK(dset, cx, ifeature, base,
     .				  process_obs, nobs)

* ... loop over the observations within each feature
	   DO iobs = 1, nobs
	      ptr = base + iobs  ! pointer (index) into the ragged contig array

* ... have the user's constraints removed this observation?
	      IF (.NOT.process_obs(iobs)) CYCLE
*             Appending space just to get rid of a nonsense compiler warning
	      line_buff = buff(:ilen)//' '
	      slen = ilen

* ... insert the relevant formatted coordinates
	      IF (.NOT. norow) THEN
	         DO idim = 1, 4
	            IF ( relevant_coord(idim) ) THEN
	               IF (instance_coord(idim)) THEN
* ... feature coordinate
	                  value = dsg_linemem(coord_lm(idim))%ptr(ifeature)
	               ELSE
* ... obs coordinate
	                  value = dsg_linemem(coord_lm(idim))%ptr(ptr)
	               ENDIF
		       IF (ABS(value) .GE. ABS(bad_val4)) THEN
		          strbuff = '*'
		       ELSE
	                  CALL TRANSLATE_TO_WORLD( value, idim, gxlate, 
     .					     ax_dec_pt(idim), strbuff)
	               ENDIF
		       clen = TM_LENSTR1(strbuff)
		       paren = INDEX((strbuff), "(")
		       IF (paren .GT. 0) clen = MIN(clen,paren-1)
	               nblank = MAX(coord_width(idim)-clen, 1)
	               line_buff(slen+nblank+1:) = strbuff(:clen)
	               slen = slen + coord_width(idim)
	            ENDIF
	         ENDDO

	      ENDIF ! .not. norow

* ... insert the formatted data
	      bufflen = slen
	      DO ivar = 1, nvar
	         mr = mr_list(ivar)

		 
	         IF ( mr_type(mr) .EQ. ptype_string ) THEN
                    vstr = '                '
                    vstr(1:1) = '"'

	            IF (point_var(ivar)) THEN
* ... compressed feature result
	               iwd = 0
	           ELSEIF (instance_var(ivar)) THEN
* ... feature value
	               iwd = ifeature - 1
	            ELSE
* ... obs value
	               iwd = ptr - 1
	            ENDIF

	            slen = GET_OFFSET_C_STRING_LEN(mr_c_pointer(mr),
     .					 iwd )
	            slen = MIN(slen, vstrlen-2)  ! fixed length of vstr...
		    CALL GET_OFFSET_C_STRING(mr_c_pointer(mr),
     .				   iwd,
     .				   vstr(2:),
     .				   slen    )
                    vstr(slen+2:slen+2) = '"'    


	         ELSE

	           IF (point_var(ivar)) THEN
* ... compressed feature result
	               value = memry(mr)%ptr(1)
	            ELSEIF (instance_var(ivar)) THEN
* ... feature value
	               value = memry(mr)%ptr(ifeature)
	            ELSE
* ... obs value
	               value = memry(mr)%ptr(ptr)
	            ENDIF
	            IF (value .EQ. mr_bad_data(mr)) THEN
	               vstr = "..."
	            ELSE
	               WRITE(vstr, good_fmt(ivar)) value
	            ENDIF

		 ENDIF

* remove leading blanks   (better way to handle this?)
		 DO i = 1, vstrlen
                    IF ( vstr( i:i ) .NE. ' ' ) ExIT
		 ENDDO
		 CALL TM_PACK_STRING(vstr, vstr, 1, i, clen)
	         clen = TM_LENSTR1(vstr)


	         nblank = MAX(col_width(ivar)-clen, 1)
	         line_buff(bufflen+nblank+1:) = vstr
	         bufflen = bufflen + col_width(ivar)
	      ENDDO

* ... write out the line
	      CALL SPLIT_LIST(pttmode_explct, list_lun, line_buff, 0)

* ... write only a single line from each feature if there are no ragged arrays
	      IF (instance_vars_only) EXIT	! list just one "obs" line
	   ENDDO

 500	   base = base + nobs
	   IF (point_vars_only) EXIT		! list just one "feature" line
	ENDDO   ! loop over features

 5000	RETURN
 5100	CALL ERRMSG( ferr_invalid_command, status,
     .		'Error getting value from LIST/PRECISION= ',
     .		*5000 )
 5200	CALL ERRMSG( ferr_grid_definition, status,
     .		'Data grid is not a DSG grid ',
     .		*5000 )
	END

	SUBROUTINE GCF_GET_ALT_FCN_DIR_ARG( gcfcn, idir_args )

* return the argument that sets a direction indicating 
* an alternative function.


        IMPLICIT NONE
	include	'tmap_dims.parm'
	include 'ferret.parm'
	include 'grid_chg_fcns.parm' 
	include 'xgrid_chg_fcns.cmn'

* calling argument declarations
	INTEGER		gcfcn, idir_args(*)

	INTEGER idim

	DO idim = 1, nferdims
	   idir_args(idim) = gfcn_dir_args (idim, gcfcn)
	ENDDO

	RETURN
	END

	INTEGER FUNCTION ALIAS_ID( string )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* identify the given string as an alias - retunr unspecified_int4 if not

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V230:  7/29/92 - from ALIAS_COMMAND
* V320:  8/18/94 - *KOB* IBM port - changed declaration of MATCH4 from	
*				    integer to logical
* V603   5/07    - *acm* Just return if the test string is length 0.
* V685+ 12/13    - *acm* bounds checking; return if len(string) is 0.

        IMPLICIT NONE
* calling argument declarations:
	CHARACTER string*(*)

* internal variable declarations:
	INTEGER	TM_LENSTR1, TM_LENSTR, alen, i,
     .          len_test, len_mchars
	LOGICAL	MATCH4

	include 'ferret.parm'
	include 'xcommand.cmn'

* length of test string
	IF (LEN(string) .EQ. 0) GOTO 200

        alen = TM_LENSTR1( string )
        len_test = TM_LENSTR(string(:alen))
        IF (len_test .EQ. 0) GOTO 200
* against possible aliases
	DO 100 i = 1, total_num_alias
           IF ( alias(i) .EQ. unspecified_name4 ) GOTO 100
           len_mchars = TM_LENSTR(alias_name(i)(:4))
	   IF ( MATCH4(string(:alen),len_test,
     .          alias_name(i),len_mchars) ) THEN
              ALIAS_ID = i
	      RETURN
	   ENDIF
 100	CONTINUE

* no match
 200    ALIAS_ID = unspecified_int4
	RETURN
	END

      SUBROUTINE GET_VIEW_SIZE( vxsize, vysize, is_viewport )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine the X and Y size of the current viewport in Denbo inches
* This routine is to be called directly from PLOT+.
* It requires an External declaration in the main program to ensure
* that it is loaded at link time.

* Further, this routine supports a kludge:
* PLOT+ "should" really be aware only of the current viewport.
* The ASIZE,BSIZE known by PLOT+ should be the vaules that
* this routine is computing.  Currently, PLOT+ creates the full window and
* FERRET creates and modifies windows by communicating with PLOT+.

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* Unix/RISC port - 10/91
* V300:  4/19/93 - old style vp's: use ABS() for negative vp_size
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus.

	include 'ferret.parm'
	include 'xplot_state.cmn'
	include	'plt_inc.decl'	! with sizing data,etc.
	include	'PLT.INC'	! with sizing data, etc.

* calling argument declarations:
	LOGICAL is_viewport
	REAL*4 vxsize, vysize

* internal variable declarations:
	REAL	vxmax, vymax, scale

* initialize to full plot size
        vxsize = width
        vysize = height
	is_viewport = .FALSE.

* If viewports are active compute fraction of plot size in viewport
	IF ( vp_num .NE. mvp_dflt ) THEN

	   is_viewport = .TRUE.

           IF ( vp_xclip(vp_num) .EQ. unspecified_val4 ) THEN
              vxmax = 1.0
              vymax = 1.0
           ELSE
              vxmax = vp_xclip(vp_num)
              vymax = vp_yclip(vp_num)
           ENDIF
           scale = 1.0 / SQRT( ABS(vp_size(vp_num)) )
           vxsize = scale * vxsize * (vxmax - vp_xorg(vp_num))
           vysize = scale * vysize * (vymax - vp_yorg(vp_num))
	ENDIF

	RETURN
	END

*
* percent_good_t.F
*
* Jonathan Callahan
* Feb 19th 1998
*
*     returns % good data at each time step
*     SET REGION information is observed when computing the result
*

*
* In this subroutine we provide information about
* the function.  The user configurable information
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* axis_reduction     Are the result axes 'reduced' with respect to the
*                    argument axes from which they are inherited?
*                       ( RETAINED, REDUCED )
*                       RETAINED        - result axis has same extent as argument axis
*                       REDUCED         - result axis is reduced to a point
*                >>> The axis_reduction defaults to RETAINED and only needs
*                >>> to be applied when the result is reduced to a point but
*                >>> SET REGION information should still be applied to the
*                >>> external function arguments. (e.g. a function returning a status flag)
*                >>> In such a case the result axes should be IMPLIED_BY_ARGS
*                >>> and REDUCED.  (as opposed to NORMAL and RETAINED)
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
*
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result
*


      SUBROUTINE percent_good_t_init(id)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

      CALL ef_version_test(ef_version)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .     '(demonstration function) returns % good data at each time')
      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, YES, NO, NO)
      CALL ef_set_axis_reduction_6d(id, REDUCED,  REDUCED, REDUCED,
     .                                  RETAINED, REDUCED, REDUCED)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_desc(id, arg, 'data to be checked')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE percent_good_t_compute(id, arg_1, result)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable's axes.

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,  j,  k,  l,  m,  n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER good, total

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*
* Note that we are looping on the argument subscripts rather than
* the result subscripts. (Looping on result subscripts is the usual
* way).  That's because the result has axes which are normal and the
* loop count on those normal axes will be one (res_incr will be zero).
*

* Only one index value for the result X, Y, Z, E, and F axes
      i = res_lo_ss(X_AXIS)
      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      m = res_lo_ss(E_AXIS)
      n = res_lo_ss(F_AXIS)

* Outer loop over T axis
      l = res_lo_ss(T_AXIS)
      DO 400 l1 = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)

* Sum over all other axes of the argument
       good = 0
       total = 0

       DO 600 n1 = arg_lo_ss(F_AXIS,ARG1), arg_hi_ss(F_AXIS,ARG1)

        DO 500 m1 = arg_lo_ss(E_AXIS,ARG1), arg_hi_ss(E_AXIS,ARG1)

         DO 300 k1 = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)

          DO 200 j1 = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)

           DO 100 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)

            total = total + 1
            IF ( arg_1(i1,j1,k1,l1,m1,n1) .NE. bad_flag(ARG1) ) THEN
               good = good + 1
            END IF

 100       CONTINUE

 200      CONTINUE

 300     CONTINUE

 500    CONTINUE

 600   CONTINUE

* Assign the result for this time step
       result(i,j,k,l,m,n) = (good * 100.0) / total

       l = l + res_incr(T_AXIS)
 400  CONTINUE

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END

	SUBROUTINE TM_CHECK_COORDS (line, npts, is_double, use_strict, 
     .                              has_repeated, misordered, micro, 
     .                              epsilon, depsilon)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*.
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Ferret v7.1 *acm* 1/13/2017
* V72   6/17 *acm* for trac enhancement #767 -- dynamic coordinate storage
* V744 10/18 *acm* Issue #1898 -- correctly define first_delta, checking non-dp coordinatse
* V745  2/19 *acm* Make sure index i0 isn't out of the index range

* This routine replaces identical logic in cd_get_1_axis and xeq_define, 
* checking for repeated coordinates and doing micro-adjusting if possible.
*
* Check if coordinates in coordinate array have repeated coordintes as in cd_get_1_axis 
* or xeq_define.Apply micro-adjusging to correct this, unless flag use_strict is set.

* Arguments
* line  coordinates for the line
* is_double, for netCDF files, flag is true if the coordinates in the file are double precision.
* use_strict, for netCDF files, flag is true if the user requested /STRICT; do not do micro-adjusting
* micro      If positive, use this value for the micro-adjustment, otherwise compute it.

* Returns:
*  has_repeated		True if coordinates found to be repeating.
*  misordered		True if coordinates cannot be fixed
*  epsilon		For single-precision input coordinates, the epsilon used to compare coordinates
*  depsilon		For double-precision input coordinates,    ""            ""


        include 'tmap_dims.parm'
        include 'xtm_grid.cmn_text'
        external xgt_grid_data
        include 'xio.cmn_text'
        external xio_data

* argument declarations

	LOGICAL is_double, has_repeated, misordered, use_strict
	INTEGER	npts
	REAL	line(*), micro, epsilon, depsilon

* Local variable declarations
	LOGICAL TM_DFPEQ_TOL, TM_FPEQ_EPS
	REAL	dfirst_delta, first_delta, micro_adj, madj, delta, zero
	REAL epsilon_21, depsilon_42
	INTEGER i, i0, i1, i2, i3, vlen

* Initialize
	epsilon_21 =  2.**(-21) 
	depsilon_42 =  2.**(-42) 
	
	has_repeated = .FALSE.
	misordered = .FALSE.

* Set epsilon value for comparing coordinates

	epsilon = 0.
	depsilon = 0.

	IF (npts .LT. 2) RETURN

        IF (is_double) THEN

           dfirst_delta = line(2) - line(1)
	   IF (dfirst_delta .LT. depsilon_42) THEN
	      DO i = 2, npts
                dfirst_delta = line(i) - line(i-1) 
		IF (dfirst_delta .GE. depsilon_42) EXIT  ! from loop
	      ENDDO
	      IF (dfirst_delta .LT. depsilon_42) THEN
	         misordered = .TRUE.
		 GOTO 1000
	      ENDIF
	   ENDIF
           depsilon = depsilon_42 * 2.*(ABS(line(npts)) / dfirst_delta )
           depsilon = depsilon_42 * 2.*(ABS(line(1)) / dfirst_delta )

        ELSE

           first_delta = line(2) - line(1)
           epsilon = epsilon_21 * 2.*(ABS(line(npts)) / first_delta )
           epsilon = epsilon_21 * 2.*(ABS(line(1)) / first_delta )
	   
	   IF (first_delta .LT. epsilon_21) THEN
	      DO i = 1, npts
                first_delta = line(i+1) - line(i) 
		IF (first_delta .GE. epsilon_21) EXIT  ! from loop
	      ENDDO
	      IF (first_delta .LT. epsilon_21) THEN
	         misordered = .TRUE.
		 GOTO 1000
	      ENDIF
	   ENDIF

	ENDIF

* If repeated values, apply micro-adjusting. 
* Or report as a warning if the user requested /STRICT.

	IF (micro .GT. 0.) THEN
	   micro_adj = micro
	ELSE
	   micro_adj = 1E-7 * (line(npts) - line(1))
	ENDIF

* ... are there repeated values?
	 
	IF (is_double) THEN
	   zero = 0.
	   DO 110 i1 = 2, npts
              delta = line(i1) - line(i1-1)
              IF (TM_DFPEQ_TOL(delta, zero, depsilon) ) THEN
	          has_repeated = .TRUE.
		  GOTO 130
	      ENDIF
 110       CONTINUE

	ELSE
           zero = 0.0
	   DO 120 i1 = 2, npts
	      delta = line(i1) - line(i1-1)
	      IF (TM_FPEQ_EPS(epsilon, delta, zero) ) THEN
	          has_repeated = .TRUE.
		  GOTO 130
	      ENDIF
 120       CONTINUE

	ENDIF

 130	CONTINUE

* We are done if repeated values not found, or if the user asked for /STRICT

	IF (.NOT. has_repeated .OR. use_strict) GOTO 1000

* ... make micro-adjustments if axis has repeated values (4/99)

        IF (micro_adj .EQ. 0.) THEN
           i1 = 1
           misordered = .TRUE.
           GOTO 1000
        ENDIF

        i0 = 1

* --- adjust coordinates coming in as double-precision

        IF (is_double) THEN

           DO 170  i1 = 2, npts
	    
               delta = line(i1) - line(i1-1)
               IF (TM_DFPEQ_TOL(delta, zero, depsilon) ) THEN
*    ... locate end of repeating block
                  DO 140 i2 = i1, npts
                        delta = line(i2) - line(i1)
                        IF ( delta .GT. depsilon ) GOTO 150
 140              CONTINUE
                  i2 = npts + 1    ! one beyond last value
                  i0 = i1 - 2
                  i3 = i2 - 1
*    ... micro-adjust repeating values from i1 to i2-1
 150              CONTINUE

                  delta = line(i2)-line(i1)
                  IF (.NOT.TM_DFPEQ_TOL(delta, zero, depsilon) .AND. 
     .                 line(i2).GT.line(i1)) THEN
                     i0 = i1-1
                     i3 = i2
                  ENDIF

* Check and readjust the size of micro_adj if too small

                  madj = micro_adj
                  IF (i0.GT.0) THEN 

                     IF (micro_adj*(i2-i1+1) .GT. 
     .                   line(i3) - line(i0) ) THEN
                        madj = (line(i3)-line(i0))/(i2-i1+1)
                        IF (madj .EQ. 0.)  THEN
	                   misordered = .TRUE.
	                   GOTO 1000
	                ENDIF
	             ENDIF
		     
		  ENDIF 


                  DO 160 i3 = i1, i2-1
                     line(i3) = line(i3) + (i3-i1+1)* madj
 160              CONTINUE
                  
                  delta = line(i2)-line(i2-1)
                  IF ( i2 .LT. npts .AND. .NOT.TM_DFPEQ_TOL(delta, zero, depsilon) .AND.
     .		      (line(i2-1) .GE. line(i2)))  THEN
	             misordered = .TRUE.
	             GOTO 1000
                  ENDIF
              ENDIF
 170       CONTINUE


* --- adjust coordinates coming in as single-precision
	ELSE ! single

           DO 270  i1 = 2, npts
	    
              delta = line(i1) - line(i1-1)
              IF (TM_FPEQ_EPS(epsilon, delta, zero) ) THEN
*    ... locate end of repeating block
                 DO 240 i2 = i1, npts
                    delta = line(i2) - line(i1)
                    IF (delta .GT. epsilon) GOTO 250
 240             CONTINUE
                 i2 = npts + 1    ! one beyond last value
                 i0 = i1 - 2
                 i3 = i2 - 1
*    ... micro-adjust repeating values from i1 to i2-1
 250             CONTINUE

                 delta = line(i2)-line(i1)
                 IF (.NOT.TM_FPEQ_EPS(epsilon, delta, zero) .AND. 
     .               line(i2).GT.line(i1)) THEN
                    i0 = i1-1
                    i3 = i2
                 ENDIF

* Check and readjust the size of micro_adj if too small
                 madj = micro_adj
                 IF (micro_adj*(i2-i1+1) .GT. 
     .               line(i3) - line(i0) ) THEN
                    madj = (line(i3)-line(i0))/(i2-i1+1)
                    IF (madj .EQ. 0.)  THEN
	                   misordered = .TRUE.
	                   GOTO 1000
                    ENDIF
                  ENDIF
                  DO 260 i3 = i1, i2-1
                     line(i3) = line(i3) + (i3-i1+1)* madj
 260              CONTINUE
                  
		  
                  delta = line(i2)-line(i2-1)
                  IF ( i2 .LT. npts .AND. .NOT.TM_FPEQ_EPS(epsilon, delta, zero) .AND.
     .		      (line(i2-1) .GE. line(i2)))  THEN
                     misordered = .TRUE.
	             GOTO 1000
                 ENDIF
              ENDIF  
 270       CONTINUE

	ENDIF ! single or double

 1000	CONTINUE
	RETURN

	END

	SUBROUTINE SHOW_REGION( cx )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute SHOW REGION for a single context

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 9/23/87
* revision 0.1 - 3/23/88 - enlarged cx_DIM_STR to accomodate date/time strings
* V200:  5/19/89 - reordered lo/hi_ss args
* Unix/RISC port - 2/27/91 - mystery error with version of FORTRAN compiler
*		          eliminated using temporary buffer for cx_dim_str
* V320: 12/29/94 - use SPLIT_LIST to redirect tty output for GUI
* V550: *acm*10/02- Changed cx_name to char*24, so use TM_LENSTR1 with it.
*       *ACM*11/02- Did NOT need the above change with TM_LENSTR1.
* v554: *acm* 11/03 call SPLIT_LIST with open string length; region names now up to 24 long.
* V650  Write to show_lun which may be set to a file unit number rather than std out
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V6.8  acm  6/12 Implement mode_6d_lab, set by default. If cancelled, the 
*                 various SHOW commnands will not list info for E,F dimensions.
* V7    acm  6/16 Ticket 2437: Deprecating mode_6d_lab. 
*		  Adjust output to 6-D or 4-D grids

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'
	include 'xcontext.cmn'
	include 'xtext_info.cmn'

* calling argument declarations
	INTEGER	cx

* local parameter declarations:
	LOGICAL	    full_precision
	PARAMETER ( full_precision = .TRUE. )

* local variable declarations:
	INTEGER  idim, slen, listdims
	CHARACTER cx_DIM_STR*48

* If mode 6d_lab has been cancelled, we will list info only for 
* the first 4 dimensions. (If they've set an E or F region, just
* don't show it.)

	listdims = nferdims
	IF ( .NOT. mode_6d_lab) listdims = 4

* write region name
	IF ( cx .EQ. cx_last ) THEN
	   CALL SPLIT_LIST(pttmode_explct, show_lun,
     .				'default region:',0)
	ELSE
	   CALL SPLIT_LIST(pttmode_explct, show_lun,
     .		'region '//cx_name(cx),0)
	ENDIF

* describe each axis - produce lines as complex as:"X=lo:hi@xxx:nn (transform)"
	DO 100 idim = 1, listdims
* axis unspecified ?
	   IF (  cx_by_ss(idim,cx)
     .	        .AND. cx_lo_ss (cx,idim) .EQ. unspecified_int4
     .	   .OR..NOT.cx_by_ss(idim,cx)
     .		.AND.  cx_lo_ww (idim,cx) .EQ. unspecified_val8) THEN
	      CALL SPLIT_LIST(pttmode_explct, show_lun,
     .				'        '//ww_dim_name(idim)//
     .				'/'//ss_dim_name(idim)//' is unspecified',
     .				26 )
	   ELSE

* write it out
	      CALL SPLIT_LIST(pttmode_explct, show_lun,'        '
     .		//CX_DIM_STR(idim,cx,':',full_precision,slen),0)

	   ENDIF

 100	CONTINUE	      

	RETURN
	END

*
* tax_times.F
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* axis_reduction     Are the result axes 'reduced' with respect to the 
*                    argument axes from which they are inherited?
*                       ( RETAINED, REDUCED ) 
*                       RETAINED        - result axis has same extent as argument axis
*                       REDUCED         - result axis is reduced to a point
*                >>> The axis_reduction defaults to RETAINED and only needs
*                >>> to be applied when the result is reduced to a point but
*                >>> SET REGION information should still be applied to the
*                >>> external function arguments. (e.g. a function returning a status flag)
*                >>> In such a case the result axes should be IMPLIED_BY_ARGS
*                >>> and REDUCED.  (as opposed to NORMAL and RETAINED)
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE tax_times_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

      CALL ef_version_test(ef_version)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     . '(demonstration function) returns % good data at each time' )

      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_axis_reduction(id, REDUCED, REDUCED, REDUCED,
     .     RETAINED)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'data to be checked')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE tax_times_compute(id, arg_1, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

	  INTEGER id, good, total

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*
* Note that we are looping on the argument subscripts rather than
* the result subscripts. (Looping on result subscripts is the normal 
* way).  That's because the result has axes which are normal and the
* loop count on those normal axes will be one.
*
      l = res_lo_ss(T_AXIS)
      DO 100 l1=arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)
 
      good = 0
      total = 0

      i = res_lo_ss(X_AXIS)
      DO 400 i1=arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)
 
         j = res_lo_ss(Y_AXIS)
         DO 300 j1=arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)
 
            k = res_lo_ss(Z_AXIS)
            DO 200 k1=arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)
 
                  total = total + 1

                  IF ( arg_1(i1,j1,k1,l1) .NE. bad_flag(1) ) THEN
 
                     good = good + 1
 
                  END IF
 
               k = k + res_incr(Z_AXIS)
 200        CONTINUE
 
            j = j + res_incr(Y_AXIS)
 300     CONTINUE
 
         i = i + res_incr(X_AXIS)
 400  CONTINUE
      
         result(i,j,k,l) = (good * 100.0) / total

         l = l + res_incr(T_AXIS)
 100  CONTINUE


 
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	SUBROUTINE AXIS_FORMAT( x_or_y, idim, grid, lo_val, hi_val,
     .				del_val, curvilinear, cx_curv,
     .				its_calendar, calendar_both, 
     .				tstyle, no_labels, imposed_lab, tscale, toff )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* set up PPLUS to properly label the axis tics and titles

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 6/23/87
* revision 1.0 - 2/25/88 - added grid to call; allowed non-geographic axes
* revision 2.0 - 4/12/88 - added time axis set-ups and decimal place calcs.
*			   and units on axis labels (via AX_TITLE)
*			   x/y axis labels through PUT_LABEL call
* revision 2.1 -  5/7/88 - increased format sizes
* revision 2.2 -  9/8/88 - added position relative flags to PUT_LABEL call
* revision 2.3 - 9/21/88 - suppress year on time axis for climatological sets
*			 - added control over time axis tics (TXLINT)
*			 - fixed PPLUS (TAXIS3) bug permitting "day"-style
*			   time axes (TXTYPE) - return "tstyle"
* revision 2.31 - 1/9/89 - doc chg: climatological axis in TAXIS_STYLE
* V200:  10/13/89 - corrected FORMAT 3010 to allow dt_min=1/60
* 	   1/4/90 - modified PUT_LABEL call
* Unix/RISC port - 4/91 *sh*: RISC f77 can't handle CHAR fcn in WRITE list
* V313: *sh* AIX port.  Replace "FOR ()" with "FOR,()" so AIX space-squeezing
*		filter doesn't corrupt this routine
* V400: 6/23/95 - *sh* use risc_buff instead of ppl_buff when calling PUT_LABEL
*		because PUT_LABEL uses ppl_buff internally 
* V420: 11/27/95 - 4-digit PLOT+ YEARS!!  also, new arg its_calendar
*	11/28/95 - changes to TAXIS_STYLE call for Y-oriented calendar axes
* 12/96 *kob* - Linux Port - had to move variable assignments off of
*               declaration line.
* V450: 3/97 - support for curvilinear coordinate plots
*		added args curvilinear and cx_curv
* V500: 6/99 *sh* - save time axis infor to be used by PLOT/VS overlays
* V510 *sh* 3/00 - added no_labels argument so /NOLABELS avoided xlab & ylab
* V533 *sh* 7/01 - avoid using risc_buff -- conflict with PUT_LABEL
* V580 *acm* 12/04 Fix bug 1129; formatting axis for small lon/lat ranges
* V602 *acm*  3/07 Fix bug 1498: do not computes n_res but leave it hard-wired
*                to 15; else the axis labels may not match data values
* V62+ *acm* 6/09 Allow use_nice for more lon/lat axes; allows for long 
*                 strings in the degree-minute-seconds labeling
* V64+ *acm*12/09 Fix bugs (crash!)for plots with very small ranges in lon and lat
*                 See the benchmark test err64_very_small_latlon.jnl, based on a 
*                 report by Jean Newman.
*       *acm* 3/12 6D Ferret: Add E and F dimensions 
*                  A time axis may be a T axis or F axis, so idim is 
*                  now an arg to TSTEP_TO_SECS, TSTEP_TO_DATE
* V694  *acm* 1/15 Changes to allow two time axes on plot (F-T)
* V695+ *sh*  3/15 Added argument "imposed_lab" to disambiguate F and T axes
* V695  *acm* 9/15 Do not plot the labell TIME - on vertical axes with HH:MM
*		   labeling; it interferes with the time/date labels
* V7    *acm* 6/16 Ticket 2434: command qualifiers /DEGMINSEC= /HALFSPAC
*                  DEGMINSEC=1 for Deg-Min axis labels, =2 for Deg-Min-Sec. Default = 1
*                  /HALFSPAC adds a half space between the degree sign and E/W or N/S
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.
* V73+ 1/18 *acm*  Changes for Issue 1009; precsision in time info sent to pplus for 2D plots
*                  Set scaling for axis coords and box edges
* V743 7/18 *acm* Issue 1888: The resetting of time for 1009 need not happen unless the 
*                 time coordinates really need all that precision.

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
        include 'xunits.cmn_text'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'ferret.parm'
	include 'plot_setup.parm'
	include 'xplot_setup.cmn'
	include 'xplot_state.cmn'
* needed to position the imposed labels
	include 'axis_inc.decl'		! axis lengths
        include 'AXIS.INC'              ! axis lengths
* special equivalence needed only with risc compiler: bug fix
	include 'xrisc.cmn'     ! for f77 bug
        CHARACTER rbuff(4)*14
        EQUIVALENCE ( rbuff, risc_buff )

* calling argument declarations:
	LOGICAL		its_calendar, calendar_both, curvilinear, no_labels
	INTEGER		idim, grid, cx_curv
	CHARACTER	x_or_y*1, tstyle*3
	CHARACTER*(*)	imposed_lab
	REAL*8		lo_val, hi_val, del_val, tscale, toff

* parameter definitions:
	INTEGER		pyear_only
	PARAMETER     ( pyear_only = 1 )

* internal variable declarations:
	LOGICAL		GEOG_LABEL, GEOG_VAR,ITSA_TRUEMONTH_AXIS,
     .			use_nice, special, rescale_time
	INTEGER		TM_LENSTR1, TM_LENSTR, dlen, places, ndec, dummy
	CHARACTER	AX_TITLE*32, WHOI_DATE*14, VAR_TITLE*128,
     .			INTERNAL_WHOI_DATE*14,
     .			fmt*4, buff*200, tsetting*2
	REAL		res_del, dt_min, time_unit, frac
	REAL*8		TSTEP_TO_SECS
	INTEGER		n_res
	REAL*4		x1, x2, uminr, umaxr, dint  ! for call to RANGE

	PARAMETER 	(n_res = 15)

* initiailize
	tstyle = ' '
	rescale_time = .FALSE.
	tscale = 1.0
	toff = 0.0

* decimal places needed for axis:
* ... sufficient digits to resolve the tic interval differences and
*     still display the largest axis labels
*  res_del - labels will be accurate enough to resolve this delta value

	res_del = ABS( hi_val - lo_val ) / n_res
	CALL GET_PREC_DIGITS( hi_val, lo_val, res_del, places, ndec )

* format to use
* frac - Will time precision be accurate enough to resolve this delta value?
	use_nice = places .LE. 7
	IF (idim.EQ.t_dim .OR.  idim.EQ.f_dim) THEN
  	   time_unit = line_tunit( grid_line(idim,grid) )
	   frac = res_del/ ABS( (hi_val+lo_val)/2 )
	   rescale_time = (time_unit.EQ.1 .AND. places.GT.7 .AND. frac.LT. 1.e-5)
	ENDIF

	IF ( use_nice ) THEN
	   IF ( ndec .EQ. 0 ) THEN
	      fmt = 'I7'
	   ELSE
	      WRITE ( fmt, 3000 ) ndec
 3000	      FORMAT ('F8.',I1)
	   ENDIF
	ENDIF

* default format to use has no special formatting
	IF ( use_nice )  CALL PPLCMD ( from, line, 0,
     .				x_or_y//'FOR,('//fmt//')', 1, 1 )
	IF ( rescale_time ) THEN
	   fmt = 'I7'
	   CALL PPLCMD ( from, line, 0,
     .				x_or_y//'FOR,('//fmt//')', 1, 1 )
	ENDIF

******* special axis formats ********
	special = ((idim.EQ.t_dim .OR.  idim.EQ.f_dim) .AND. its_calendar)
     .       .OR. ((idim.NE.t_dim .AND. idim.NE.f_dim) .AND. 
     .             GEOG_LABEL( idim, grid ))
	IF (curvilinear) THEN
	   special = (idim.NE.t_dim .AND. idim.NE.f_dim) .AND. 
     .             GEOG_VAR( idim, cx_curv )
	ENDIF
	IF ( special ) THEN
	   IF (idim .EQ. x_dim .OR. idim.EQ. y_dim) 
     .        use_nice = places .LE. 8
     
	   IF ( use_nice ) THEN
	      IF ( ndec .EQ. 0 ) THEN
	         fmt = 'I7'
	      ELSE
	         WRITE ( fmt, 3000 ) ndec
	      ENDIF
	   ENDIF
	   IF (idim.EQ.t_dim .OR.  idim.EQ.f_dim) THEN
* labels formatted in calendar dates
* .. convert units of time axis from seconds to minutes
	      time_unit = line_tunit( grid_line(idim,grid) )
	      IF (ITSA_TRUEMONTH_AXIS(grid_line(idim,grid))) time_unit = un_convert(pun_day)  
	      dt_min = time_unit / 60.

* scale and off if time requires a lot of precision

	      IF (rescale_time) THEN
	         IF (time_unit .EQ. 1) THEN 
	            dt_min = 1
	            tscale = 1/60.
	         ENDIF
	         toff = -1.*lo_val
	      ENDIF

* ... TAXIS command
	      tsetting = 'ON'
	      IF (calendar_both) tsetting = 'BO'
	      IF ( x_or_y .EQ. 'Y' ) THEN
	         WRITE ( ppl_buff, 3010 ) dt_min, tsetting
	      ELSE
	         WRITE ( ppl_buff, 3012 ) dt_min, tsetting
	      ENDIF
	      CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
 3010	      FORMAT ('TAXIS/YAXIS ',G13.5,',',A2)
 3012	      FORMAT ('TAXIS ',G13.5,',',A2)

* ... TIME command (time axis limits)
              rbuff(1) = WHOI_DATE(grid, idim, lo_val )      ! f77 bug
              rbuff(2) = WHOI_DATE(grid, idim, hi_val )
              rbuff(3) = WHOI_DATE(grid, idim, 1.0D0  )

	      IF (rescale_time) THEN 
	         rbuff(3) = rbuff(1)

	         x1 = (lo_val + toff) * tscale
	         x2 = (hi_val + toff) * tscale
	         CALL RANGE( x1, x2, 10, uminr, umaxr, dint )
	         WRITE ( ppl_buff, '(3(E14.7,1X))' ) x1, x2, dint
	         CALL PPLCMD ( from, line, 0, 
     .                          x_or_y//'AXIS '//ppl_buff , 1, 1 )
	      ENDIF

	      WRITE ( ppl_buff, 3020 )	'W'//rbuff(1),
     .					'W'//rbuff(2),
     .					'W'//rbuff(3)
 3020	      FORMAT ('TIME ',A15,',',A15,',',A15)
	      CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
* ... save info for PLOT/VS/OVER
	      saved_dt_min = dt_min
	      saved_t1_date =  INTERNAL_WHOI_DATE(grid, idim, 1.0D0 )

* ... This will be used in polygon overlays on a time axis
	      IF (rescale_time) saved_bb_date =  INTERNAL_WHOI_DATE(grid, idim, lo_val ) 

* ... The XAXIS_MIN, XAXIS_MAx symbols already set in axis_ends are not changed; used in LAS,
*     they are translated by LAS using the time axis info from the original dataset
*     and they have enough precision.

* ... TXTYPE and TXLINT commands (time axis style)
	      IF (no_labels) THEN
	         buff = ' '
	      ELSE
	         buff = imposed_lab
	      ENDIF
	      CALL TAXIS_STYLE(	x_or_y, TSTEP_TO_SECS( grid, idim, lo_val ),
     .				TSTEP_TO_SECS( grid, idim, hi_val ),
     .				tstyle, buff )

	   ELSEIF ( idim .EQ. x_dim .AND. use_nice) THEN
* longitude format for axis tic labling
	      ppl_buff = 
     .		x_or_y//'FOR,('//fmt(:TM_LENSTR1(fmt))//',''''LONE'''')' 
	      CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )

	      CALL LON_LAT_FMT (idim, x_or_y)

	   ELSEIF ( idim .EQ. y_dim  .AND. use_nice) THEN
* latitude format for axis tic labling
	      ppl_buff = 
     .		x_or_y//'FOR,('//fmt(:TM_LENSTR1(fmt))//',''''LAT'''')' 
	      CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )

	      CALL LON_LAT_FMT (idim, x_or_y)

	   ENDIF

	ENDIF

* lat/long or x/y axis label
	IF ( no_labels ) RETURN
        IF (curvilinear ) THEN
	   buff = VAR_TITLE( cx_curv)
	   dlen = TM_LENSTR1(buff)
	ELSE
	   IF (its_calendar.AND. TM_LENSTR(imposed_lab) .EQ.0) THEN ! skip label of TIME
	      buff = ' '
	      dlen = 1
	   ELSE
 	      buff = AX_TITLE( idim, grid, dlen )	! risc_buff as of 6/95
	   ENDIF
	ENDIF
	IF ( x_or_y .EQ. 'X' ) THEN
	   CALL PUT_LABEL( ppl_xlab, dummy, dummy, dummy,
     .			   0.12, buff(:dlen), dummy, dummy )
	ELSE
	   CALL PUT_LABEL( ppl_ylab, dummy, dummy, dummy,
     .			   0.12, buff(:dlen), dummy, dummy )
	ENDIF

	RETURN
      END

	SUBROUTINE PURGE_ALL_UVARS

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* eliminate all stored user variables from memory

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V200:  6/29/89
* Unix/RISC port - 11/91 - bug fix: re-initialization of uvars was not complete
*                          for redetermination of grid

* V420 - use new routine DEALLO_UVAR_GRIDS to both deallocate dynamic
*	 grids associated with a uvar and clean out any memory-cached 
*	 results that may depend on this grid
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* v690 *sh* also purge any file vars that depend upon uvars as aux vars 
* V745 *acm*  3/19 Issue 1916. For issue 1916: Pull out guts into a 
*        subroutine that can also be called in cancel mem
 

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xvariables.cmn'

* internal variable declarations:
	INTEGER	uvar, i, j, num_indices

*	DO 500 uvar = 1, max_uvar                      
*	   IF ( uvar_num_items( uvar ) .EQ. uvar_deleted ) GOTO 500  
        CALL deleted_list_get_undel(uvar_num_items_head, 
     .                          deleted_list_result(1),
     .                          max_uvar, num_indices )
        DO 500 j = 1, num_indices
           uvar = deleted_list_result(j)

* eliminate all memory resident instances of this variable
* and restore initial defaults

	   CALL PURGE_ALL_UVARS_SUB (uvar)

 500	CONTINUE

	CALL PURGE_AUX_VAR_DEPENDENTS

	RETURN
	END

*
* transpose_xz.F
*
* 
* 
*
* This function sets the second argument to be equal
* to the first one.
*


*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE transpose_xz_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

      CALL ef_version_test(ef_version)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     . 'transposes x and z axes of given variable' )

      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance(id, ABSTRACT, 
     .     IMPLIED_BY_ARGS, ABSTRACT, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'VAR')
      CALL ef_set_arg_desc(id, arg, 'variable transposed in X and Z')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES,YES)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


      SUBROUTINE transpose_xz_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      INTEGER my_lo_x, my_hi_x, my_lo_z, my_hi_z,nx,nz
      CHARACTER*100 errtxt

      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

*
*     Use utility functions to get context information about the arguments.
*     Set the abstract X and Y axes.
*

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nx = arg_hi_ss(X_AXIS, ARG1) - arg_lo_ss(X_AXIS, ARG1) + 1
      nz = arg_hi_ss(Z_AXIS, ARG1) - arg_lo_ss(Z_AXIS, ARG1) + 1
      
*     The below has the effect of translating any sub-matrix so that
*     the indices will always begin at 1

      my_lo_x = 1
      my_hi_x = nx
      my_lo_z = 1
      my_hi_z = nz



      CALL ef_set_axis_limits(id, X_AXIS, my_lo_z, my_hi_z)
      CALL ef_set_axis_limits(id, Z_AXIS, my_lo_x, my_hi_x)


*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 

 999   CONTINUE

       CALL EF_BAIL_OUT(id, errtxt)

      END




*
* In this subroutine we compute the result
*
      SUBROUTINE transpose_xz_compute(id, arg_1, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

	  INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1
      CHARACTER*100 errtxt

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)


* check to make sure both axis have points to transpose
      IF ((arg_lo_ss(Z_AXIS, ARG1) .EQ. ef_unspecified_int4) .OR. 
     .     (arg_hi_ss(Z_AXIS, ARG1) .EQ. ef_unspecified_int4)) THEN
         write(errtxt,*) 'Z axis cannot be a normal axis'
         GOTO 999
      ELSEIF  ((arg_lo_ss(X_AXIS, ARG1) .EQ. ef_unspecified_int4) .OR. 
     .        (arg_hi_ss(X_AXIS, ARG1) .EQ. ef_unspecified_int4)) THEN
         write(errtxt,*) 'X axis cannot be a normal axis'
         GOTO 999
      ENDIF

      l1 = arg_lo_ss(T_AXIS, ARG1)
      DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         j1 = arg_lo_ss(Y_AXIS, ARG1)
         DO 300 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            i1 = arg_lo_ss(X_AXIS, ARG1)
            DO 200 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS) 
               k1 = arg_lo_ss(Z_AXIS, ARG1)
                DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS) 
                   IF (arg_1(i1,j1,k1,l1) .ne. bad_flag(ARG1)) THEN
                      result(i,j,k,l) = arg_1(i1,j1,k1,l1)
                   ELSE
                      result(i,j,k,l) = bad_flag_result
                   ENDIF
                   k1 = k1 + arg_incr(Z_AXIS, ARG1)
 100            CONTINUE
                i1 = i1 + arg_incr(X_AXIS, ARG1)
 200         CONTINUE
             j1 = j1 + arg_incr(Y_AXIS, ARG1)
 300      CONTINUE
          l1 = l1 + arg_incr(T_AXIS, ARG1)
 400   CONTINUE
       RETURN 
       
 999   CONTINUE

       CALL EF_BAIL_OUT(id, errtxt)
      
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

      SUBROUTINE RR_w_Qiao_init(id)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

      CALL ef_set_desc             (id,'w integral from Qiao (1997)')
      CALL ef_set_num_args         (id, 5)
      CALL ef_set_axis_inheritance (id, IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS)

      CALL ef_set_arg_name         (id, ARG1, 'u4') 
      CALL ef_set_arg_desc         (id, ARG1, 'u4')
      CALL ef_set_arg_unit         (id, ARG1, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG1, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG1, YES, YES, YES, YES)
      CALL ef_set_axis_extend      (id, ARG1, Z_AXIS,0,+1) 
 
      CALL ef_set_arg_name         (id, ARG2, 'u1')
      CALL ef_set_arg_desc         (id, ARG2, 'u1')
      CALL ef_set_arg_unit         (id, ARG2, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG2, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2,  NO, YES, YES, YES)

      CALL ef_set_arg_name         (id, ARG3, 'u3')
      CALL ef_set_arg_desc         (id, ARG3, 'u3')
      CALL ef_set_arg_unit         (id, ARG3, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG3, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG3,  NO, YES, YES, YES)

      CALL ef_set_arg_name         (id, ARG4, 'v2')
      CALL ef_set_arg_desc         (id, ARG4, 'v2')
      CALL ef_set_arg_unit         (id, ARG4, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG4, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG4, YES,  NO, YES, YES)

      CALL ef_set_arg_name         (id, ARG5, 'v5')
      CALL ef_set_arg_desc         (id, ARG5, 'v5')
      CALL ef_set_arg_unit         (id, ARG5, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG5, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG5, YES,  NO, YES, YES)

      END


      SUBROUTINE RR_w_Qiao_compute(id,arg_1,arg_2,arg_3,arg_4,
     .                             arg_5,result)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER        id
      REAL           arg_1 (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .                      mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL           arg_2 (mem2lox:mem2hix, mem2loy:mem2hiy, 
     .                      mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL           arg_3 (mem3lox:mem3hix, mem3loy:mem3hiy, 
     .                      mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL           arg_4 (mem4lox:mem4hix, mem4loy:mem4hiy, 
     .                      mem4loz:mem4hiz, mem4lot:mem4hit)
      REAL           arg_5 (mem5lox:mem5hix, mem5loy:mem5hiy, 
     .                      mem5loz:mem5hiz, mem5lot:mem5hit)
      REAL           result (memreslox:memreshix,memresloy:memreshiy,
     .                       memresloz:memreshiz,memreslot:memreshit)
      INTEGER        res_lo_ss (4)
      INTEGER        res_hi_ss (4)
      INTEGER        res_incr  (4)
      INTEGER        arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER        arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER        arg_incr  (4,EF_MAX_ARGS)

      INTEGER        i,  j,  k,  l
      INTEGER        i5, j5, k5, l5
      INTEGER        i4, j4, k4, l4
      INTEGER        i3, j3, k3, l3
      INTEGER        i2, j2, k2, l2

      REAL*8         zW(1024)
      INTEGER        iZ
      REAL           dx, dy, dz, sum

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_coordinates    (id, ARG1, Z_AXIS, 
     .                            arg_lo_ss(Z_AXIS,ARG1),
     .                            arg_hi_ss(Z_AXIS,ARG1), zW)

      dx = 425.2e5  ! 4 degrees of longitude in cm (at the equator)
      dy = 212.7e5  ! 2 degrees of latitude in cm

      ! Single index

      i  = res_lo_ss(X_AXIS)
      i2 = arg_lo_ss(X_AXIS,ARG2) 
      i3 = arg_lo_ss(X_AXIS,ARG3) 
      i4 = arg_lo_ss(X_AXIS,ARG4) 
      i5 = arg_lo_ss(X_AXIS,ARG5)

      j  = res_lo_ss(Y_AXIS)
      j2 = arg_lo_ss(Y_AXIS,ARG2) 
      j3 = arg_lo_ss(Y_AXIS,ARG3) 
      j4 = arg_lo_ss(Y_AXIS,ARG4) 
      j5 = arg_lo_ss(Y_AXIS,ARG5)

      l2 = arg_lo_ss(T_AXIS,ARG2) 
      l3 = arg_lo_ss(T_AXIS,ARG3) 
      l4 = arg_lo_ss(T_AXIS,ARG4) 
      l5 = arg_lo_ss(T_AXIS,ARG5) 
      DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         iZ = 1
         k2 = arg_lo_ss(Z_AXIS,ARG2)
         k3 = arg_lo_ss(Z_AXIS,ARG3)
         k4 = arg_lo_ss(Z_AXIS,ARG4)
         k5 = arg_lo_ss(Z_AXIS,ARG5)

         sum  = 0.

         DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

           IF(k.EQ.1)THEN
              dz = 100. * (zW(1)+zW(2))/2.
           ELSE
              dz = 100. * (zW(iZ+1)-zW(iZ-1))/2.
           ENDIF

           !  ARG_1 = u4 
           !  ARG_2 = u1
           !  ARG_3 = u3
           !  ARG_4 = v2
           !  ARG_5 = v5
 
           sum = sum - (
     .        (ARG_3(i3,j3,k3,l3)-ARG_2(i2,j2,k2,l2))/dx +
     .        (ARG_4(i4,j4,k4,l4)-ARG_5(i5,j5,k5,l5))/dy ) * dz 

           result(i,j,k,l) = sum

           iZ = iZ + 1
           k2 = k2 + arg_incr(Z_AXIS,ARG2)
           k3 = k3 + arg_incr(Z_AXIS,ARG3)
           k4 = k4 + arg_incr(Z_AXIS,ARG4)
           k5 = k5 + arg_incr(Z_AXIS,ARG5)
         ENDDO 

         l5 = l5 + arg_incr(T_AXIS,ARG5)
         l4 = l4 + arg_incr(T_AXIS,ARG4)
         l3 = l3 + arg_incr(T_AXIS,ARG3)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
      ENDDO               
      END				

	SUBROUTINE PLOT_DSG_CHECK_LON360 (dset, cx, array, bad_flag, npts,
     .      nfeatures, lo, hi, user_hlim)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the follon_loing
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Checking for longitude crossing the dateline or prime meridian within each
* trajectory, adding or subtracting 360 so that if possible the data does not 
* jump to new branch degrees within the path.
* If the user hasn't set /HLIM, and if the longitudes are in -180:180, also 
* check whether the LON360 data has a smaller range, and if so substitute lon360.
* (this could be extended to also see if 0:360 data might better be shown as
*  -180:180 longitudes. Not doing this now, because ERDDAP puts out -180:180.)

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - SDIG program
* 4/24/2018
* V74+ 4/18 *acm*  Handle missing-data in the longitudes
* V75+ 6/19 *acm*  simpler, more-robust corrections


	include 'tmap_dims.parm'
        include 'ferret.parm'
	include 'xprog_state.cmn'
	include 'xdset_info.cmn_text'
	include 'xdyn_linemem.cmn_text'

	LOGICAL	user_hlim
	INTEGER dset, cx, npts, nfeatures  ! if not dsg, nfeatures will be 0.

	REAL	array(*), bad_flag, lo, hi

* internal variable declarations:
        LOGICAL process_feature(nfeatures)
	INTEGER i, idim, irow_l, irow_f, nobs, ifeature, row_size_lm
	REAL	tol, add, del, a_add, lon_lo, lon_hi, val_mod
	CHARACTER TM_FMT*48

* initialize

	IF (.NOT. grid_is_dsg) RETURN
	idim = 1
	CALL DSG_COORD_LIMS(dset, idim, lo, hi)
 
	CALL MAKE_DSG_FEATURE_MASK(dset, cx, process_feature, nfeatures)
                  
	tol = 160.
	add = 360. 

* See if the delta-longitude is large, working within each feature.

	row_size_lm = dsg_loaded_lm(dsg_row_size_var(dset))

	irow_f = 1
	irow_l = 0

	DO ifeature = 1, nfeatures 
	   nobs = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
	   irow_l = irow_f + nobs - 1

	   IF (process_feature(ifeature)) THEN

*  Correct the big-delta by adding or subtracting 360 and check
*  that this keeps it all within range 

	      a_add = 0.
	      DO i = irow_f+1, irow_l
	         IF ( array(i)   .EQ. bad_flag ) CYCLE
	         array(i) = array(i) + a_add

	         IF ( array(i-1) .EQ. bad_flag ) CYCLE

	         del = array(i) - array(i-1)

	         IF (ABS(del) .GT. tol) THEN

		    IF (a_add .NE. 0) THEN
		       array(i) = array(i) - a_add
		       del = array(i) - array(i-1)
		       IF (ABS(del) .LT. tol) THEN
		          a_add = 0
			  CYCLE
		       ENDIF
		    ENDIF

	            IF (del .LT. 0) a_add = add
	            IF (del .GT. 0) a_add = -1*add
	            array(i) = array(i) + a_add
	         ENDIF
		 lo = MIN(lo, array(i))
		 hi = MAX(hi, array(i))
	      ENDDO

	   ENDIF

	   irow_f = irow_l + 1
	ENDDO

* Check whether the lon360 range would be smaller, if there are any lon < 0.
	IF (user_hlim .OR. lo.GE.0.) GOTO 5000

* Get the lo and hi values in lon360

	lon_lo = arbitrary_large_val8
	lon_hi = arbitrary_small_val8

	irow_f = 1
	irow_l = 0

	DO ifeature = 1, nfeatures 
	   nobs = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
	   irow_l = irow_f + nobs - 1

	   IF (process_feature(ifeature)) THEN

	      DO i = irow_f, irow_l
	         IF ( array(i) .EQ. bad_flag ) CYCLE

	         val_mod = array(i)
		 IF (val_mod .LT. 0) val_mod = 360+val_mod
		 lon_lo = MIN(lon_lo, val_mod)
	         lon_hi = MAX(lon_hi, val_mod)
	      
	      ENDDO

	   ENDIF

	   irow_f = irow_l + 1
	ENDDO


	IF (lon_hi-lon_lo .LT. hi-lo) THEN
	
	   lo = lon_lo
	   hi = lon_hi

	   irow_f = 1
	   irow_l = 0

	   DO ifeature = 1, nfeatures 
	      nobs = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
	      irow_l = irow_f + nobs - 1

	      IF (process_feature(ifeature)) THEN
	      
	         DO i = irow_f, irow_l
	            IF ( array(i) .EQ. bad_flag ) CYCLE
	            IF (array(i) .LT. 0.) array(i) = 360+array(i)
	         ENDDO

	      ENDIF

	      irow_f = irow_l + 1
	   ENDDO

	ENDIF
	   

 5000	RETURN
        END

	SUBROUTINE XYLIN_REGRID( cx_lims,
     .				 dst_lox, dst_hix, dst_loy, dst_hiy,
     .				 src, msrc, dst, mdst, src_cx, dst_cx, 
     .			         isrc_lo, isrc_hi,
     .			         iss12, coefi, jss12, coefj, work)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* 	Using data values from src organized on grid src_grid, interpolate to
* 	values dst on grid dst_grd.

* 	msrc and mdst point to data structures in COMMON/XVARIABLES/ which

* 	specify the subscript bounds of src and dst within their 
* 	respective grids.

* 	Both src and dst are assumed to be 2 dimensional structures
* 	lying in the same plane - given by mr_DIM1 and mr_DIM2.

*	ss12i and sst12j hold the indices of nearest grid nodes on src_grd 
*       for nodes on dst_grd. coefi and coefj hold the interpolation coefficients.

* First just replicate what Ferret has always done: first linear regrid in y then
* in x.  Also program a bilinear regridding - this will let us do more to fill in
* gaps in the future, but we will need to figure out how to decide what the handling
* of missing data should be.

* programmer - Ansley Manke, from xyave_regrid.F
* NOAA/PMEL, Seattle, WA - TMAP
*
* 6/22/2011
*                    The XY linear regridding matches past Ferret behavior, 
*                    not using bilinear regridding for now
* V68  *acm* 1/12   use TM_FPEQ for double-precision ferret.
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm);
*                   removed unused bilinear interpolation code.
* V702 *sh* 3/2017 Dynamic memory revealed a bug in array "work" dimensioning
*		   It was dimensioned using the mr size instead of the cx
*		   which is wrong when a larger object is re-used from cache
*                  To address it we turned isrc_lo, isrc_hi into call arguments

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'
	include	'xmem_subsc.cmn'
	include 'xvariables.cmn'

* calling argument declarations:
	INTEGER	cx_lims, msrc, mdst, dst_lox, dst_hix,
     .          dst_loy, dst_hiy, src_cx, dst_cx,
     .	        isrc_lo, isrc_hi 
	INTEGER	iss12(dst_lox:dst_hix+1), jss12(dst_loy:dst_hiy+1)

	REAL    src( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          dst( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif ),
     .		coefi( dst_lox:dst_hix ), coefj(dst_loy:dst_hiy)
        REAL    work(isrc_lo:isrc_hi,dst_loy:dst_hiy)  ! srcx by dsty

* local variable declarations:

        LOGICAL	TM_FPEQ
	INTEGER	dim1, dim2, src_grid, dst_grid,
     .          i, j, k, l, m, n, iss, jss,
     .                            jsrc_lo, jsrc_hi,
     .          idst_lo ,idst_hi, jdst_lo, jdst_hi
	REAL	bad_src, bad_dst, c1i, c1j, c2i, c2j, 
     .          z1, z2
********************************************************************************

* initialize

* source and destination grids
	src_grid = mr_grid( msrc )
	dst_grid = mr_grid( mdst )
	dim1     = x_dim
	dim2     = y_dim

* limits for calculation
!        isrc_lo = cx_lo_ss(src_cx,dim1)	! 3/17 passed as arg
!        isrc_hi = cx_hi_ss(src_cx,dim1)	! 3/17 passed as arg
        jsrc_lo = cx_lo_ss(src_cx,dim2)
        jsrc_hi = cx_hi_ss(src_cx,dim2)

        idst_lo = cx_lo_s1(cx_lims)
        idst_hi = cx_hi_s1(cx_lims)
        jdst_lo = cx_lo_s2(cx_lims)
        jdst_hi = cx_hi_s2(cx_lims)

* flag for bad/missing data
        bad_src = mr_bad_data(msrc)
        bad_dst = mr_bad_data(mdst)

* DETERMINE (LOWER) src_grd INDEX OF NEAREST NEIGHBORS ON src_grd AXES
* FOR NODES ON dst_grd AXES, AND COMPUTE FRACTIONAL POSITIONS OF dst_grd
* NODES WITH RESPECT TO src_grd.
	CALL GET_LINEAR_COEF( isrc_lo, isrc_hi, src_grid,
     .			   idst_lo, idst_hi, dst_grid,
     .			   dim1, iss12, coefi )
	CALL GET_LINEAR_COEF( jsrc_lo, jsrc_hi, src_grid,
     .			   jdst_lo, jdst_hi, dst_grid,
     .			   dim2, jss12, coefj)

C LINEAR INTERPOLATION IN Y THEN X

* loop over Z, T, E, and F ranges of 6-D data
	DO 300 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
	DO 300 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
	DO 300 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
	DO 300 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)

* first in J direction.

	   DO 210 j = jdst_lo,jdst_hi

* interpolation coefficients
	      jss = jss12(j)
	      c2j = coefj(j)
	      c1j = 1.0 - c2j

* special case: exact overlap of source and dest points
	      IF ( TM_FPEQ(c1j,1.) ) THEN
	         DO 200 i = isrc_lo, isrc_hi
 200	            work(i,j) = src(i,jss,k,l,m,n)
	         GOTO 210
	      ENDIF

* regular interpolation
	      DO 205 i = isrc_lo, isrc_hi

* surrounding source data points
	         z1 = src(i,jss  ,k,l,m,n)
	         z2 = src(i,jss+1,k,l,m,n)

* interpolate
	         IF (z1 .EQ. bad_src .OR. z2 .EQ. bad_src ) THEN
		    work(i,j) = bad_dst
	         ELSE
	            work(i,j) = c1j*z1 + c2j*z2
	         ENDIF

 205	      CONTINUE
 210	   CONTINUE

* Now interpolate that in the x direction.

	   DO 110 i = idst_lo, idst_hi

* interpolation coefficients
	      iss = iss12(i)
	      c2i = coefi(i)
	      c1i = 1.0 - c2i

* special case: exact overlap of source and dest points
	      IF ( TM_FPEQ(c1i,1.) ) THEN
	         DO 100 j = jdst_lo, jdst_hi
 100	         dst(i,j,k,l,m,n) = work(iss,j)
	         GOTO 110
	      ENDIF

* regular interpolation
	      DO 105 j = jdst_lo, jdst_hi

* surrounding source data points
	         z1 = work(iss  ,j)
	         z2 = work(iss+1,j)

* interpolate
	         IF (z1 .EQ. bad_src .OR. z2 .EQ. bad_src ) THEN
		    dst(i,j,k,l,m,n) = bad_dst
	         ELSE
	            dst(i,j,k,l,m,n) = c1i*z1 + c2i*z2
	         ENDIF

 105	      CONTINUE
 110	   CONTINUE

 300	CONTINUE

	RETURN
	END

	SUBROUTINE XEQ_PPLUS

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* access program PPLUS ( the underlying graphics package ) directly - either
* by sending a single command to it or by entering the PPLUS command interpreter

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 1/7/87
* revision 0.1 - 9/8/88 - added /RESET option
* revision 0.2 - 1/31/89 - added PPLUS interruptibility
* Unix/RISC port - 10/9/91 - check to see if user changes ylen or yorg
* V500 *sh* 6/99 - for commands %LABEL and %WHERE define PLOT+ symbols
*			mode verify output, and journal file comments
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
* V6.85 *acm* 3/13 Fix ticket 2049; check we can open palette file
* V6.86 *acm* 1/14 In above fix, let there be spaces before the file spec.
* V7.4 *acm* 1/18 for issue 1854 if mem pointers for curvi coord data have 
*                 been temporarily reset, restore to prev values
* 
        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include	'plot_setup.parm'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'
	include 'xplot_setup.cmn'    ! added 10/9/91
        include 'axis_inc.decl'  ! added 10/9/91 for ylen,yorg
        include 'AXIS.INC'            ! added 10/9/91 for ylen,yorg
	include 'xgrinpt.cmn'	! 6/99 w/ mouse input
	include 'xvariables.cmn'
	
* local variable declarations:
	LOGICAL	ver_out, jnl_out
	INTEGER TM_LENSTR1, STR_UPCASE, i, slen, start, status
        REAL temp_ylen, temp_yorg
	CHARACTER*16 vbuff
	CHARACTER TM_INQ_PATH*2048, fname*128, sfile*2048

* local parameter declarations:
	INTEGER		slash_reset
	PARAMETER     ( slash_reset = 0+1 )

* turn on PLOT+ ?
	CALL START_PPLUS

* save ylen and yorg in case the user manually changes those values in PLOT+
* 10/9/91 addition 
        temp_ylen = ylen
        temp_yorg = yorg

* Check for a PPL SHASET SPECTRUM command, and verify the palette file can be opened.
	IF ( num_args .GT. 0 ) THEN
           IF ( INDEX(cmnd_buff(arg_start(1):len_cmnd),'SPECTRUM') .GT. 0 ) THEN
	      start = INDEX(cmnd_buff,'SPECTRUM=') + 10
              fname = cmnd_buff(start:len_cmnd)
              CALL TM_PACK_STRING( fname, fname, 1, 128, slen )
	      slen = TM_LENSTR1(fname)
              sfile = TM_INQ_PATH (fname(:slen),'FER_PALETTE','.spk',
     .        	 .false.,status)
              IF (status .NE. ferr_ok) go to 5300 
           ENDIF

           IF ( INDEX(cmnd_buff(arg_start(1):len_cmnd),'PATTERN') .GT. 0 ) THEN
	      start = INDEX(cmnd_buff,'PATTERN=') + 9
              fname = cmnd_buff(start:len_cmnd)
              CALL TM_PACK_STRING( fname, fname, 1, 128, slen )
	      slen = TM_LENSTR1(fname)
              sfile = TM_INQ_PATH (fname(:slen),'FER_PALETTE','.pat',
     .        	 .false.,status)
              IF (status .NE. ferr_ok) go to 5300 
           ENDIF

        ENDIF

	IF ( qual_given( slash_reset ) .GT. 0 ) THEN
* ... reset plot environment to defaults
	   CALL DISP_RESET
	ELSEIF ( num_args .GT. 0 ) THEN
* ... pass a single command to PLOT5
	   CALL PPLCMD (' ',' ',0,cmnd_buff(arg_start(1):len_cmnd),1,1)
	ELSE
* ... enter PPLUS interactively
	   CALL PPLCMD ( '/dev/tty', ' ', 0, ' ', 1, 0 )
	   ppl_interrupted = .FALSE.			! since interactive
	ENDIF

* check to see if mouse input was done -- take action if so (6/99)
	IF (has_new_mouse) THEN
	   jnl_out = mode_journal .AND. jrnl_lun .NE. unspecified_int4
	   ver_out = mode_verify 
* ... define symbols and output them as comments to user and journal file
	   vbuff = ' '
	   WRITE ( vbuff, '(1PG16.7)' ) xmouse
           WRITE ( ppl_buff, 3100 ) 'X', vbuff
           CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
	   WRITE ( ppl_buff, 3200 ) 'X', vbuff
	   slen = TM_LENSTR1(ppl_buff)
           IF (jnl_out) WRITE (jrnl_lun,'(A)') ppl_buff(:slen)
	   IF (ver_out) CALL SPLIT_LIST(pttmode_ops, ttout_lun,
     .					ppl_buff, slen )

	   vbuff = ' '
	   WRITE ( vbuff, '(1PG16.7)' ) ymouse
           WRITE ( ppl_buff, 3100 ) 'Y', vbuff
           CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
	   WRITE ( ppl_buff, 3200 ) 'Y', vbuff
	   slen = TM_LENSTR1(ppl_buff)
           IF (jnl_out) WRITE (jrnl_lun,'(A)') ppl_buff(:slen)
	   IF (ver_out) CALL SPLIT_LIST(pttmode_ops, ttout_lun,
     .					ppl_buff, slen )
 

	   vbuff = ' '
	   WRITE ( vbuff, '(I3)' ) wmouse
           WRITE ( ppl_buff, 3100 ) 'W', vbuff
           CALL PPLCMD ( from, line, 0, ppl_buff, 1, 1 )
	   WRITE ( ppl_buff, 3200 ) 'W', vbuff
	   slen = TM_LENSTR1(ppl_buff)
           IF (jnl_out) WRITE (jrnl_lun,'(A)') ppl_buff(:slen)
	   IF (ver_out) CALL SPLIT_LIST(pttmode_ops, ttout_lun,
     .					ppl_buff, slen )

* ... house-keeping
	   has_new_mouse = .FALSE.		! RESET !!
	   IF (jnl_out) THEN
#ifdef AIX_XLF
              CALL FLUSH(jrnl_lun)
#endif
#ifdef solaris
              CALL FLUSH(jrnl_lun)
#endif
	   ENDIF
	ENDIF

	i = STR_UPCASE( vbuff, cmnd_buff(arg_start(1):arg_end(1)))
	IF (( INDEX(vbuff,'SHADE')   .GT. 0 ) .OR.
     .      ( INDEX(vbuff,'CONTOUR') .GT. 0 ) .OR.
     .      ( INDEX(vbuff,'FILL')    .GT. 0 ) .OR.
     .      ( INDEX(vbuff,'WIRE')    .GT. 0 )    ) THEN 
	   CALL DECREMENT_PLOT_GRID  ! see ticket 883
	ENDIF

	IF (( INDEX(vbuff,'SHADE')   .GT. 0 ) .OR.
     .      ( INDEX(vbuff,'CONTOUR') .GT. 0 ) .OR.
     .      ( INDEX(vbuff,'FILL')    .GT. 0 ) .OR.
     .      ( INDEX(vbuff,'PLOT')    .GT. 0 ) .OR.
     .      ( INDEX(vbuff,'POLY')    .GT. 0 ) .OR.
     .      ( INDEX(vbuff,'WIRE')    .GT. 0 )    ) THEN 
	   IF (iaxset .EQ. 1) THEN   ! If /AXES was used on prev. plot call, reset defaults
	      CALL PPL_AXES_RESTORE
	      CALL PPLCMD ( from, line, 0, 'AXSET,1,1,1,1', 1, 1 )
	      CALL PPLCMD ( from, line, 0, 'AXLABP -1,-1', 1, 1)
	      iaxset = 0
	   ENDIF
	ENDIF

	IF (( INDEX(vbuff,'SHADE')   .GT. 0 ) .OR.
     .      ( INDEX(vbuff,'CONTOUR') .GT. 0 ) .OR.
     .      ( INDEX(vbuff,'FILL')    .GT. 0 ) .OR.
     .      ( INDEX(vbuff,'VECTOR')  .GT. 0 ) .OR.
     .      ( INDEX(vbuff,'POLY')    .GT. 0 ) .OR.
     .      ( INDEX(vbuff,'WIRE')    .GT. 0 )    ) THEN 
	   CALL RESTORE_CURVI   
	ENDIF     

* check to see if ylen or yorg has been changed
* if so, parameters saved prior to distorting yaxis are invalidated
        IF ( ylen .NE. temp_ylen ) ppl_saved_yaxlen = ylen
        IF ( yorg .NE. temp_yorg ) ppl_saved_yorg   = yorg

 1000	RETURN

 3100   FORMAT('SET ',A1,'MOUSE ', A)       ! "SET ?MOUSE position_string"
 3200	FORMAT(' !-> DEFINE SYMBOL ',A1,'MOUSE = ',A)
 
 5300   CALL ERRMSG (ferr_file_not_found, status, 
     .          'unable to open "' //
     .	fname(:slen)//'.spk" to set plot colors or pattern.', *1000)

	END

	SUBROUTINE STORE_DEPENDENCY
     .		( its_aux, cx, tree_lev,  uvar, item, cx_status,
     .		  next, level, flag, dataset, var_or_start, cat_or_end,
     .		  parent_uv, uv_item, desist )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* store a line describing a single variable of a dependency tree
* and send feedback if a duplication or a recursion has been detected that
* indicates further analysis of this tree level should desist

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V685  *sh* 10/13 
* V690  *sh* 11/13 - fixed problem in aux regridding variable dependencies
*                    by adding a new calling arg
* V693+ *sh* 1/21/15 - store regridding dependency lines
* V720  acm* 6/2017  Fix for ticket 2533, reporting ok for regridding to 
*                    undefined variable

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'gfdl_vms.parm'  ! for vms_str_success
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xdependency_tree.cmn'


* calling argument declarations:
	LOGICAL	its_aux, desist
	INTEGER cx, tree_lev, uvar, item, cx_status
	INTEGER	next         (dependency_max_recs),
     .		level        (dependency_max_recs),
     .		flag         (dependency_max_recs),
     .		dataset         (dependency_max_recs),
     .		var_or_start (dependency_max_recs),
     .		cat_or_end   (dependency_max_recs),
     .		parent_uv    (dependency_max_recs),
     .		uv_item      (dependency_max_recs)

*	next         - forward link connecting starts of trees 
*	level        - the child generation level in the tree
*	flag         - special conditions (see xdependency_tree parameters
*	var_or_start - variable number if known variable
*                      or start character of uvar item if unknown
*	cat_or_end   - category number if known variable
*                      or end   character of uvar item if unknown
*	parent_uv    - uvar number of parent variable (used when unknown var)
*	uv_item      - uvar item number within parent (used when unknown var)


* internal variable declarations:
	LOGICAL	known_var, dup, in_target_defn, direct_parentage,
     .		aux_broken_chain
	INTEGER	var, cat, dset, df_flag, row, current_lev, i,
     .		this_flag, nrg
	INTEGER STR_CASE_BLIND_COMPARE, vax_code

* initialize
	cat    = cx_category(cx)
	var    = cx_variable(cx)
	dset   = cx_data_set(cx)
	desist = .FALSE.

* Fix for ticket 2533, if known_var when bad status, and pcx_vtree_regrid_report,
* regridding to an undefined variable was reported ready

	known_var = cx_status .EQ. ferr_ok
cc     .         .OR. cx_status .EQ. pcx_vtree_regrid_report 
!     .	      .OR.  cx_status .EQ. ferr_unknown_auxvar  ! ???

* set up regrid target reports
	IF ( cx_status .EQ. pcx_vtree_regrid_report ) THEN
	  IF (cx_vtree_regrid_ntarget .EQ. 0 ) RETURN  ! ?for SST[G=SST] case?
	  nrg = 1
	ENDIF

* increment pointer to the next item to be stored
 10	row = dependency_nrows + 1
	dependency_nrows = row

* determine flag to save
	IF ( cx_status .EQ. pcx_vtree_regrid_report ) THEN
* ... special treatment for regridding report (12/14)
*     cx_vtree_unknown_grid tells if this is an unknown target error report
*     if its an error then cx_vtree_var_or_start / _cat_or_end hold "[]" posn
*     if not an error then cx_vtree_var_or_start / _cat_or_end hold
*         var & cat        if the regrid points to a target variable
*     or  unspecified_int4 if the regrid points to a named grid or axis
*     we do not report named grid or axis regridding.  Not a dependency.
*     Multiple target regrid variables get recorded in cx_vtree_regrid_ntarget
	   dset = cx_vtree_regrid_dset(nrg)
	   IF ( cx_vtree_unknown_grid(nrg)      ) THEN
	      this_flag = df_unknown_grid
	   ELSE
	      this_flag = df_valid_var
	   ENDIF
	ELSEIF ( cx_status .EQ. ferr_unknown_variable ) THEN
	   this_flag = df_unknown_var
	ELSEIF ( cx_status .EQ. ferr_unknown_data_set ) THEN
	   this_flag = df_unknown_dataset
	ELSEIF ( cx_status .EQ. ferr_unknown_auxvar ) THEN
	   this_flag = df_unknown_auxvar
	ELSEIF ( cx_status .EQ. ferr_unknown_grid ) THEN
	   this_flag = df_unknown_grid
	ELSEIF ( cx_status .NE. ferr_ok ) THEN
	   this_flag = df_syntax_error
	ELSEIF ( its_aux ) THEN
	   this_flag = df_valid_aux_var
	ELSE
	   this_flag = df_valid_var
	ENDIF
	 
* store the things that are always valid
	IF (dset .EQ. unspecified_int4) dset = pdset_irrelevant
	next (row) = 0		! for clean housekeeping, not used
	level(row) = tree_lev
	dataset (row) = dset
	flag(row) = this_flag

* store things differently depending upon whether variable is known
	IF ( cx_status .EQ. ferr_unknown_auxvar ) THEN
	   var_or_start(row) = uvar_item_start(item, uvar)
     .					  + var - 1
	   cat_or_end  (row) = uvar_item_start(item, uvar)
     .					  + cat - 1
	   parent_uv   (row) = uvar
	   uv_item     (row) = item
	ELSEIF ( cx_status .EQ. pcx_vtree_regrid_report ) THEN
	   var_or_start(row) = cx_vtree_var_or_start(nrg)
	   cat_or_end  (row) = cx_vtree_cat_or_end(nrg)
	   parent_uv   (row) = uvar
	   uv_item     (row) = pcx_vtree_regrid_report
	ELSEIF ( cx_status .NE. ferr_ok ) THEN
	   var_or_start(row) = uvar_item_start(item, uvar)
	   cat_or_end  (row) = uvar_item_end  (item, uvar)
	   parent_uv   (row) = uvar
	   uv_item     (row) = item
	ELSE
	   var_or_start(row) = var
	   cat_or_end  (row) = cat
	   parent_uv   (row) = unspecified_int4
	   uv_item     (row) = unspecified_int4
	ENDIF

* check for duplications:
* 1. in-line duplication
*  Where there are multiple references to any var in same definition as in
*    LET target = b + b 
*  it is not necessary to report the variable b twice
* 2. back-reference duplication
*  Where there are multiple references to a user-defined vaiable in separate
*  definitions as in
*    LET target = b + c
*    LET b = c
*    LET c = d
*    LET d = 1
*  it is not necessry to report the dependencies of c twice.  The variable
*  in_target_defn is used to track case 2 duplication (this) versus case 1
* 3. recursion
*  The existence of recursion is apparent through a duplicated defnition
*    that lies in the direct line of decent from another, as in this example
*    where "P" indicates a parent and "S" indicates a sibling variable
*    LET P0 = P1 + S1
*    LET P1 = P2 + S2
*    LET P2 = P3 + S3
*  LET P3 = S1 would not create a recursion, but LET P3 = P1 would
*  As we look backwards in the dependency tree the direct descendent parent is
*  always the very first one at the next lower level.
	IF (  known_var
     .	.AND. row .GT. dependency_current_tree_start ) THEN

* look for case 1:  twin sibling var that need not be reported
	   DO 100 i = row-1, dependency_current_tree_start, -1
	      IF     ( level(i) .GT. tree_lev ) THEN
	         GOTO 100                 ! inside of a child variable - ignore
	      ELSEIF ( level(i) .LT. tree_lev ) THEN
	         GOTO 110		  ! gone beyond start of this variable
	      ENDIF
* ...  flag cannot be used in the dup test because it gets reset for df_defined_earlier
*      since parent_uv is set to unspecified_int4 only for df_valid_var it serves
*      as a signal that the flag had been valid before it was reset to defined_earlier
	      IF ( cx_status .EQ. pcx_vtree_regrid_report 
     .	     .AND. flag(row) .EQ. df_unknown_grid         ) THEN
* ... ugly case of duplicate unknown grid target: "myvar[gx=mybad,gy=mybad]"
	        dup =   parent_uv(i)    .EQ. parent_uv(row)
     .		  .AND. flag(i)         .EQ. flag(row) 
	        IF (dup) THEN
	           vax_code = STR_CASE_BLIND_COMPARE(
     .			uvar_text(uvar)(var_or_start( i ):cat_or_end( i )),
     .			uvar_text(uvar)(var_or_start(row):cat_or_end(row)) )
	           dup = vax_code .EQ. vms_str_success
	        ENDIF
	      ELSE
	        dup =   parent_uv(i)    .EQ. parent_uv(row)
     .            .AND. dataset(i)      .EQ. dataset(row)
     .		  .AND. var_or_start(i) .EQ. var_or_start(row)
     .		  .AND. cat_or_end  (i) .EQ. cat_or_end  (row)
	      ENDIF
	      IF (dup) THEN
* ... found a twin -- do not report it
	         desist = .TRUE.
	         row = row - 1
	         dependency_nrows = row
	         GOTO 500
	      ENDIF
 100	   CONTINUE

* look for cases 1 and 3
 110	   in_target_defn = .NOT.its_aux    ! TRUE while we are inside the defn of target
	   aux_broken_chain = .FALSE.
	   current_lev = tree_lev
	   DO 200 i = row-1, dependency_current_tree_start, -1
	      IF ( flag(i) .EQ. df_valid_aux_var ) THEN
	         aux_broken_chain = .TRUE.    ! the chain of dependency stops at an aux var dependency
	         direct_parentage = .FALSE.
	      ENDIF
	      IF ( level(i) .LT. current_lev ) THEN
	         in_target_defn = .FALSE.
! doesnt this need to break the direct_parentage line permanently for all above?
! finding recursion through an aux var connection is still a problem, even if the parent is a uservar
! XXXXXXXXXXX   FIX PROBLEM:  FALSE RECURSIONS FROM AUX VAR DIRECT PARENTAGE
	         IF (.NOT.aux_broken_chain) direct_parentage = .TRUE.
	         current_lev = level(i)
	      ELSE
	         direct_parentage = .FALSE.  ! never true while in_target_defn
	      ENDIF
* ...  flag cannot be used in the dup test because it gets reset for df_defined_earlier
*      since parent_uv is set to unspecified_int4 only for df_valid_var it serves
*      as a signal that the flag had been valid before it was reset to defined_earlier
	      dup =   parent_uv(i)    .EQ. parent_uv(row)
     .          .AND. dataset(i)      .EQ. dataset(row)
     .		.AND. var_or_start(i) .EQ. var_or_start(row)
     .		.AND. cat_or_end  (i) .EQ. cat_or_end  (row)
	      IF (dup) THEN
* ... the row we are adding is already in the dependency tree
*     so desist in the analysis of this variable
	         IF (in_target_defn .AND. level(i).EQ.tree_lev) THEN
* ... case 1: twin sibling var need not be reported
*	SHOULD NEVER ARRIVE HERE
	            CALL WARN("crptn_store_dep")
	         ELSEIF (direct_parentage) THEN
* ... case 3: a recursive definition has been found
	            flag(row) = df_recursion_error
	            desist = .TRUE.
	            GOTO 500
	         ELSEIF (cat_or_end(i) .EQ. cat_user_var) THEN
* ... case 2: uvar used in separate vars needs only a cross-ref the second time
	            flag(row) = df_defined_earlier
	            desist = .TRUE.
	            GOTO 500
	         ENDIF
	      ENDIF
 200	   CONTINUE

	ENDIF

* maintain the forward link pointer
 500	next (dependency_current_tree_start) = row+1
	next (row+1) = row+1

* maintain global flag for status of tree
	IF (flag(row) .GT. dependency_status) THEN
	   dependency_status     = flag(row)
	   dependency_status_rec = row
	ENDIF

* if more regridding dependencies to report, loop back
	IF  ( cx_status .EQ. pcx_vtree_regrid_report 
     .	.AND. nrg .LT. cx_vtree_regrid_ntarget        ) THEN
	   nrg = nrg + 1
	   GOTO 10
	ENDIF

	RETURN
	END

	SUBROUTINE CD_GET_TMAP_PARMS ( dset, cdfid, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* read special TMAP global attributes from the open netCDF file
* these attributes are:
* TMAP_expnum = "0056"
* TMAP_slice = "  SA"
* TMAP_source = "PHIL/SEIG"
* TMAP_subsource = "TROPICAL PACIFIC"
* TMAP_**anything_else**  = auxiliary parameter

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 3/92
* 10/96 *kob* - Linux port - had to move variable assignments off of
*		declaration line.
* V600 *ACM* attribute control. 
*             Replace NCINQ with NCF_INQ_DS
*             Change call to CD_GET_ATTRIB to NC_GET_ATTRIB - get attrib 
*             from linked list structure
* V602  2/07 *acm* Fix bug 1492, changing attributes of coordinate variables 
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing

* argument definitions:
*       dset    - pointer to TMAP data set
*       cdfid   - returned pointer to open CDF file
*	status	- return status

* argument declarations:
	INTEGER	      dset, cdfid, dset_num, status

* include files


        include 'netcdf.inc'
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
        include 'tmap_errors.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
        include 'xio.cmn_text'
        external xio_data

* local variable declarations:
* *kob* explicit definitions not allowed on decl line in linux...
*       moved it to parameter line 10/96
      LOGICAL NC_GET_ATTRIB, got_it, do_warn
      PARAMETER (do_warn = .TRUE.)

      INTEGER NCF_INQ_DS,
     .        nparm, iatt,  ndims, nvars, ngatts, recdim, 
     .        i, varid, maxlen, attlen, attoutflag
      CHARACTER*13 TM_STRING
      CHARACTER    name*128, tmap_att*128, buff*2048
      REAL vals(10)

      INTEGER tt                ! nice short name
      EQUIVALENCE (tt,lunit_errors)

* initialize
        nparm = 0
        DO 10 i = 1, num_parm
           ds_parm_name(i, dset) = ' '
           ds_parm_text(i, dset) = ' '
 10     CONTINUE
	ds_source_class(dset)	= ' '
	ds_source(dset)		= ' '
	ds_subsource(dset)	= ' '
	ds_expnum(dset)		= ' '
	ds_modnum(dset)		= ' '

* get number of global attributes from stored linked list structure

        dset_num = dset
        IF (dset_num .LT. -2) dset_num = -2
        status = NCF_INQ_DS (dset_num, ndims, nvars, ngatts, recdim )

* get global attribute pseudo-variable id

        IF (ngatts .GT. 0) THEN
           CALL CD_GET_VAR_ID (dset, '.', varid, status)

* loop through global attributes looking for ones beginning with TMAP
           DO 100 iatt = 1, ngatts

* get global attribute name
              name = ' '
              CALL CD_GET_VAR_ID (dset, '.', varid, status )
              CALL CD_GET_VAR_ATT_NAME( dset, varid, iatt, name, status)
              IF ( name(:5) .NE. 'TMAP_' ) GOTO 100

* get its value
              maxlen = 2048
              got_it = NC_GET_ATTRIB ( dset, varid, name, do_warn, 
     .                      '.', maxlen, attlen, attoutflag, 
     .                      buff, vals)

* what is it ?
              tmap_att = name(6:)
              IF ( tmap_att(:6) .EQ. 'expnum' ) THEN
                 ds_expnum(dset) = buff
              ELSEIF ( tmap_att(:5) .EQ. 'slice' ) THEN    ! "modnum" in GT sets
                 ds_modnum(dset) = buff
              ELSEIF ( tmap_att(:6) .EQ. 'source' ) THEN
                 ds_source(dset) = buff
              ELSEIF ( tmap_att(:9) .EQ. 'subsource' ) THEN
                 ds_subsource(dset) = buff
              ELSE
                 nparm = nparm + 1
                 IF ( nparm .GT. num_parm ) GOTO 5100
                 ds_parm_name(nparm, dset) = tmap_att
                 ds_parm_text(nparm, dset) = buff
              ENDIF

 100       CONTINUE
        ENDIF

* successful completion
 1000   status = merr_ok
        RETURN

* error exit
 5100      CALL TM_NOTE( 'maximum number of TMAP CDF attributes '
     .          //'exceeded: '//TM_STRING(DBLE(num_parm)), tt )
           GOTO 1000   ! not fatal
 5200      CALL TM_NOTE( 'dataset not found', tt )
           RETURN

           END

	LOGICAL FUNCTION ITS_FMRC_2DTIME (dset, fvar)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Return boolean indicating whether the passed variable is in fact
* the 2D FMRC time matrix of the dataset

* V698 2/16 *sh*

      IMPLICIT NONE
#include "tmap_dset.parm"
!#include "gt_lib.parm"     ! str_match
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'xdset_info.cmn_text'
	include 'xdset_info.cd_equiv'
	include 'xtm_grid.cmn_text'

* calling argument declarations:
	INTEGER dset, fvar

* local variable declarations:
	LOGICAL NC_GET_ATTRIB, got_it
	INTEGER STR_CASE_BLIND_COMPARE, grid, vid, istat, status

	INTEGER str_match
        PARAMETER (str_match = 0)

* Getting info back from the attribute-handling structure
        INTEGER maxlen
        PARAMETER (maxlen = 128)
	CHARACTER*(maxlen) buff
	INTEGER varid, t2did, tline, g2d, globalid, ref_id, attlen,
     .		attype, attoutflag
        REAL    attvals(10)

* initialize
	grid = ds_grid_number(fvar)

* it must be 2D in the TF plane
	IF (grid_line(x_dim,grid) .NE. mnormal
     . .OR. grid_line(y_dim,grid) .NE. mnormal
     . .OR. grid_line(z_dim,grid) .NE. mnormal
     . .OR. grid_line(e_dim,grid) .NE. mnormal ) GOTO 2000
	IF (grid_line(t_dim,grid) .EQ. mnormal
     . .OR. grid_line(f_dim,grid) .EQ. mnormal ) GOTO 2000

* it must have a _CoordinateAxisType='Time' attribute
* ... get the List id of the variable
        CALL CD_GET_VAR_ID (dset, ds_var_code(fvar), vid, status)
        IF (status .NE. ferr_ok) GOTO 5100
* ... get the attribute val
        got_it = NC_GET_ATTRIB ( dset, vid, '_CoordinateAxisType',
     .                              .TRUE., ds_var_code(fvar), maxlen,
     .                              attlen, attoutflag, buff, attvals )
	IF (.NOT.got_it) GOTO 2000
	istat = STR_CASE_BLIND_COMPARE(buff, 'time')

* final test
        ITS_FMRC_2DTIME = istat .EQ. str_match
	RETURN

* nope - this aint it
 2000	ITS_FMRC_2DTIME = .FALSE.
	RETURN

* error bail out
 5000	RETURN
 5100	CALL ERRMSG(ferr_internal, status, 'its_fmrc_2dtime!',
     .		 *5000)     ! error not trapped
	END

	SUBROUTINE CD_OPEN_OUT(cdfname, append, cdfid, clobber, 
     .                          netcdf4_type, status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Open a netCDF file for output
* if appending then the file must already exist
* leave it in definition mode

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 3/92
*               10/92 - leave mode as opened (report via CD_SET_MODE)
* V450 11/96 - added argument "clobber" *sh*
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V67  *acm* 4/11  Fix ticket 1832, open file correctly for NetCDF4.1.2 and higher.
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* argument definitions:
*       cdfname - desired output file name
*       append  - logical control to create or append
*       cdfid   - returned pointer to open CDF file
*	clobber	- Boolean to say if existing file can be clobbered
*	status	- return status

* argument declarations:
        LOGICAL  append, clobber
        INTEGER	 cdfid, netcdf4_type, status
        CHARACTER*(*) cdfname
	

* include files
        include 'netcdf.inc'
        include 'cdf_tmap.parm'
        include 'tmap_errors.parm'
#include "gt_lib.parm"

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

* local variable declarations:
      LOGICAL file_exists, do_append
      INTEGER cstat, clobber_mode, cdfstat, cdftype

* initialize netCDF
* does it exist already ?
      INQUIRE ( FILE = cdfname, EXIST = file_exists )
      do_append = append .AND. file_exists

* open or create the file
      IF ( do_append ) THEN
	 cdfstat = NF_OPEN( cdfname, NF_WRITE, cdfid )
         IF ( cdfstat .NE. NF_NOERR ) GOTO 5100

         CALL CD_SET_MODE( cdfid, pcd_reset_data, status )
         IF ( status .NE. merr_ok ) RETURN
      ELSE
	 IF (clobber) THEN
	   clobber_mode =   NF_CLOBBER
	 ELSE
	   clobber_mode =   NF_NOCLOBBER
	 ENDIF

* ... let netCDF detect the error if the file already exists

         IF (netcdf4_type .EQ. 3) THEN 
	    cdftype = NF_CLASSIC_MODEL

            cdfstat = NF_CREATE(cdfname, clobber_mode, cdfid)
         ELSE

            IF (netcdf4_type .EQ. 4) cdftype = NF_NETCDF4
            IF (netcdf4_type .EQ. 6) cdftype = NF_64BIT_OFFSET
            cdfstat = NF_CREATE(cdfname, OR(clobber_mode,cdftype), cdfid)

         ENDIF

         IF ( cdfstat .NE. NF_NOERR ) GOTO 5100
         CALL CD_SET_MODE( cdfid, pcd_reset_define, status )
         IF ( status .NE. merr_ok ) RETURN
      ENDIF

* successful completion
	status = merr_ok
	RETURN

* error messages
 5100 CALL TM_ERRMSG
     .     ( cdfstat+pcdferr, status, 'CD_OPEN_OUT', unspecified_int4,
     .     no_varid, 'could not open CDF output file: ',
     .     cdfname, *5000 )

* error exit
 5000 RETURN
	END

	CHARACTER*(*) FUNCTION TM_FMT_SNGL_DIGITS
     .            ( val, digits, max_len, str_len )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* convert the value val to a formatted string, left justified, not exceeding
* max_len in length and if digits < 0, have the number of digits after the
* decimal point exactly specified by digits, e.g. for digits=-2, 0 is 0.00. 
* For consistent labels on color keys, called by key.F

* programmer - Ansley Manke, from tm_fmt_digits.F
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* 1/13/2012
* Single-precision version of TM_FMT_DIGITS, to be called from PPLUS.


* calling arguments:
* val		- REAL*4 value to be converted
* digits	- IF >0 maximum number of significant digits desired
*	        - ELSE  EXACT number of decimal places desired
* max_len	- longest allowable length for string to be returned
* str_len	- (returned) actual length of the string generated

* calling argument declarations:
	INTEGER		digits, max_len, str_len
	REAL*4		val

* internal variable declarations:
	LOGICAL		exp_fmt, negative, fixed_pt
	INTEGER		slen, sig_left, sig_full, nleft, nright, full,
     .			sig_max, full10, xtra, sig_needed, pow10,
     .			chk10, chk10_save, waste
	REAL*4		aval, l10
	CHARACTER*10	fmt

* local parameters:
	INTEGER		TM_CHECK_NAN, TM_CHECK_INF, max_int_len, sig_min
	REAL*4		eps, one_m_eps
	PARAMETER     ( max_int_len = 8,
     .			sig_min     = 1,		! minimum sig. digits
     .			eps         = 0.6E-7,		! 1/95 - was 1.E-7
     .			one_m_eps   = 1.0 - eps )

* special treatment for exact zero
	IF ( val .EQ. 0.0 .AND.  digits .GE. 0) GOTO 1000

* initialize
	negative = val .LT. 0.0
	fixed_pt = digits .LE. 0
	aval     = ABS( val )
	TM_FMT_SNGL_DIGITS   = ' '
	exp_fmt  = .FALSE.

* maximum length of output string (at least 1 character long)
	slen = MIN( LEN(TM_FMT_SNGL_DIGITS), max_len )
	slen = MAX( 1, slen )

* If the value is NaN, set the string here
        IF ( TM_CHECK_NAN(aval) .EQ. 1   ) THEN
           IF (slen .GE. 3) THEN
              TM_FMT_SNGL_DIGITS  = 'NaN'
              str_len = 3
           ELSE
              TM_FMT_SNGL_DIGITS = '*'
              str_len = 1
           ENDIF
	   RETURN
        ENDIF

* If the value is NaN, or Inf, set the string here
        IF ( TM_CHECK_INF(val)  .EQ. 1   ) THEN
           IF (slen .GE. 3) THEN
              TM_FMT_SNGL_DIGITS  = 'Inf'
              str_len = 3
           ELSE
              TM_FMT_SNGL_DIGITS = '*'
              str_len = 1
           ENDIF
	   RETURN
        ENDIF

* location of leftmost digit (.01-->-1, 0.1-->0, 1.0-->1, etc.)
 10	l10      = LOG10(aval)
           IF (aval .EQ. 0.) l10 = 0.
           IF ( l10 .GE. 0.0 ) THEN
	   pow10 = INT(l10) + 1
	ELSE
	   pow10 = INT( l10 * one_m_eps )  ! eps for machine round-off problems
	ENDIF
	chk10_save = pow10

* compute total significant digits requested
 50	IF ( fixed_pt ) THEN
	   sig_max = pow10 + ABS(digits)
	ELSE
	   sig_max = digits
	ENDIF

* significant digits to left of the decimal point
	sig_left = MAX( pow10, 0 )

* actual characters to the left of the decimal point
	nleft = MAX( sig_left, 1 )
	IF ( negative ) nleft = nleft + 1	! minus sign

* compute "wasted" space needed for minus signs, left zeros and decimal points
	waste = nleft - sig_left			! sign and left zero
	IF ( sig_max .GT. sig_left ) waste = waste + 1	! decimal point
	IF ( pow10 .LT. 0 ) waste = waste + ABS(pow10)	! leading zeros

* modify # significant digits: cannot request more digits than the integer
* word size or the "unwasted" string length
* but at lease sig_min digits
	sig_full = MAX( sig_min, MIN( sig_max, max_int_len, slen-waste ) )

* create an integer with all the possible digits
* (1-eps factor is because VAX Fortran formats round 100.5-->100 whereas VAX 
* NINT function rounds 100.5 -->101)
* Note: On DEC/OSF f77 the integer calculation blows up when compiled with -g
*       It was observed with sig_full=4, pow10=-6, aval=6.27833E-07
* 	Kludge work-around is to use the floating point calculation for cases
*	where sig_full+pow10 is too large (10 or larger crashes, expermentally)
! pre-1/95	full = NINT( aval * 10.**(sig_full-pow10) * one_m_eps )
! pre-3/95	full = NINT( aval * (10**(sig_full-pow10)) * one_m_eps )
* 9/95 ... it turns out that for large values (e.g. 2.16E8) that pow10
* can be larger than sig_full givin 10**(negative) --> zero (integer calc)
* so the IF condition has had a check added for this
! 12/95: The value 9.9995 displayed with 4 sig_full=4 generates (F5.3) and
! blows up because 9.9995 rounds to 10.000 on OSF Fortran. This occurs because
! full is computed to be 9999 when the one_m_eps factor is included. Since the
! comments just above indicate that one_m_eps was included to fix a VAX bug
! we have removed this logic to an ifdef: NINT_WRITE_UNMATCH

# ifdef NINT_WRITE_UNMATCH
	IF ( sig_full-pow10 .LT. 10
     .	.AND. sig_full      .GT. pow10 ) THEN
	   full = NINT( aval * (10**(sig_full-pow10)) * one_m_eps )
	ELSE
	   full = NINT( aval * 10.**(sig_full-pow10) * one_m_eps )
	ENDIF
# else
	IF ( sig_full-pow10 .LT. 10
     .	.AND. sig_full      .GT. pow10 ) THEN
	   full = NINT( aval * (10**(sig_full-pow10))  )
	ELSE
	   full = NINT( aval * 10.**(sig_full-pow10)  )
	ENDIF
# endif

* special check: eg. 99.9 --> 100.0 , changing leftmost digit
	IF ( full .EQ. 10**sig_full ) THEN
	   pow10 = pow10 + 1
	   GOTO 50
	ENDIF

* get number of digits remaining after trimming off right hand zeros
	full10 = 10 ** (sig_full-sig_min)
	DO 100 sig_needed = sig_min, sig_full
	   IF ( MOD(full, full10) .EQ. 0 ) GOTO 200
	   full10 = full10 / 10
 100	CONTINUE
	sig_needed = sig_full

* * * * CREATE A FORMAT STRING AND WRITE THE RESULT * * *
* EXACT ZERO - fixed point numbers that would be 0.000...
 200	IF ( fixed_pt .AND. sig_min-pow10 .GT. slen-waste ) THEN
	   GOTO 1000

* EXPONENTIAL STRING
* numbers too small for fixed point (eg. 0.0000025 represented as 0.0)
* or too big for the string length  (eg. 150000 can't fit in 4 spaces)
* or with integer parts big enuf to ovflow the integer size (eg.123456789.123)
* must be written in exponential format
	ELSEIF ( sig_min-pow10 .GT. slen-waste
     .	.OR. nleft .GT. slen 
     .	.OR. nleft .GT. max_int_len ) THEN
	   IF ( negative ) THEN
	      xtra = 6
	   ELSE
	      xtra = 5
	   ENDIF
	   IF ( slen .LE. xtra ) THEN
	      TM_FMT_SNGL_DIGITS  = '******'
	      str_len = slen
	   ELSE
	      str_len = MIN( slen, sig_needed+xtra)
	      WRITE ( fmt, 3000 ) str_len, str_len-(xtra+1)
 3000	      FORMAT( '(1PG',I2,'.',I2,')' )
	      WRITE ( TM_FMT_SNGL_DIGITS, fmt ) val
	   ENDIF

* INTEGER STRING
* numbers whose needed digits are all on the left (eg. -2.0001 in 4 characters)
* or whose length is too long to add a decimal point (eg. 25.5 in 3 characters)
* may/must be represented as integers
	ELSEIF ( digits .GE. 0 .AND. 
     .           (sig_left .GE. sig_needed .OR. nleft .GE. slen-1) ) THEN
* ... check if nearest integer will alter formatting (e.g. 99.6-->100)
	   aval = NINT(aval)
	   l10      = LOG10(aval)
           IF (aval .EQ. 0.) l10 = 0.
	   IF ( l10 .GE. 0.0 ) THEN
	      chk10 = INT(l10) + 1
	   ELSE
	      chk10 = INT( l10 * one_m_eps )  ! eps for machine round-off problems
	   ENDIF
	   IF ( chk10 .NE. chk10_save ) GOTO 10
	   str_len = nleft
	   IF (str_len .LE. 0) str_len = 1  ! as in tm_fmt.F just to be sure.
	   WRITE ( fmt, 3100 ) str_len
 3100	   FORMAT ( '(I',I2,')' )
	   WRITE ( TM_FMT_SNGL_DIGITS, fmt ) NINT(val)

* FIXED POINT STRING
	ELSE
	   nright = MIN( sig_needed-pow10, slen-(nleft+1) )
	   IF (digits .LT. 0) nright = MAX( nright, ABS(digits) )
	   str_len = nleft + nright + 1
	   WRITE ( fmt, 3200 ) str_len, nright
 3200	   FORMAT ( '(F',I2,'.',I2,')' )
	   WRITE ( TM_FMT_SNGL_DIGITS, fmt ) val
	   IF (slen .GE. 3) THEN 
	       IF (TM_FMT_SNGL_DIGITS(1:3) .EQ. ' -.') THEN
		  TM_FMT_SNGL_DIGITS(1:3) = '-0.'	! 8/96 for aix&hp
	       ELSEIF (TM_FMT_SNGL_DIGITS(1:1) .EQ. ' ') THEN
                  TM_FMT_SNGL_DIGITS(1:1) = '0'
	       ENDIF	
	   ENDIF
	ENDIF
	RETURN

* return exact zero
 1000	TM_FMT_SNGL_DIGITS  = '0'
	str_len = 1
	RETURN

      END
 

	BLOCK DATA XPROG_STATE_DATA

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

*
* variable declarations for COMMON/ XPROG_STATE /
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/26/86
* revision 0.1 - 3/18/87 - new TMAP library:
*			   eliminated TMAP_DIMS.PARM and data_set_open
* revision 0.2 - 5/1/87  - added FRAME and LIST output files
* revision 0.3 - 5/19/87 - added mode_ignore_err, mode_stupid and 
*			   err_lun = ttout_lun to take
*			   advantage of 255 byte RECLEN in ttout_lun OPEN
* revision 0.4 - 8/26/87 - added mode_calendar for date/time format time output
*			   and variables for unformatted listing
* revision 0.4 - 10/5/87 - revised list_ options and added mode_gaps_ok
* revision 0.5 - 2/25/88 - added mode_geographical
* revision 0.6 - 3/7/88  - added list_TMAP
* revision 0.7 - 3/23/88 - calendar and geog modes --> long,lat,depth,time
*			   added font_ASCII
* revision 0.8 - 4/15/88 - added mode_state_last
* revision 0.9 - 6/22/88 - GFDL.MGM --> FERRET.MGM
* revision 1.0 -  7/1/88 - added logical interactive and mode segment
* revision 1.1 -  8/2/88 - added mode wait (wait after plots  - for terminals)
* revision 1.2 - 8/11/88 - changed default MODE VERIFY to CANCEL
* revision 1.3 -  1/9/89 - added MODE SCREEN (how to handle missing data)
* revision 1.4 -  2/2/89 - eliminated MODE GAPS_OK (for new TM library)
*			 - added MODE JOURNAL
*			 - changed MODE SCREEN to MODE REJECT
* revision 1.5 - 4/24/89 - MODE INTERPOLATE defaults to "FALSE" to minimize
*			   encountering its bugs !!!
* V200:   6/8/89 - added mode_desperate
*	11/29/89 - added mode_rpn
*	 12/8/89 - added mode_GKS, saved_dset, saved_abstract_grid
*	12/20/89 - added mode_xwindows
*	  1/3/89 - added mode_metafile
* Unix/RISC port - 2/91 - changes to logical unit numbers: standard err and out
*                - 10/91 - mode verify to default to true
* V230:  5/14/92 - replaced mode REMOTE_X with mode REFRESH
*         6/9/92 - replaced list_* logicals with list_fmt_type
*        11/9/92 - eliminated arguments from MODES GKS and META
*        1/14/93 - meta_device --> frame_compress
* V300:   2/3/93 - added argument FULL to MODE VERIFY
* V300:  5/12/93 - added mode ppllist and journal_file
*	 6/16/93 - added mode GUI
*	25/10/93 - default state for mode refresh set to TRUE
* V301: 26/ 1/94 - larger MODE DESPERATE argument to reflect larger memory
*	 2/24/94 - incorporated a stack of past SET MODE states
*	 3/14/94 - set default state of mode refresh (xwindows) to .FALSE.
* V310:  11/4/94 - eliminated MODE REJECT (never implemented)
* V400:  7/10/94 - added list_format for LIST/HEADING=enhanced
*
*        6/15/95 -*kob* added ifdef for STDERR_UNIT_SEVEN because stderr on
*                  HP machines was 7 instead of 0
* V420:	 4/28/96 - added initialization for IF-stack (ifstk)
* V450:	 11/19/96 - eliminated MODE POLISH
* V510 5/00 *sh* - added denig_x/ylim_msg_done
* V540 11/01 *sh* - initialize last_cmnd_buff
* V550:12/02 *acm*- new MODE LOGO and MODE LABELS
* V570: *acm* 5/04 - add MODE GRATICULE[:argument] 
* v580 10/04 *acm* - add flag silent_err for SHOW VAR/XML This is set for  
*                    SHOW VAR/XML when checking for user variables not  
*                    relevant to the context
* V600: *acm* 5/06 - add new MODE LINECOLORS:[arg],Flag no_plot_yet
* V600  *acm* 6/06 - add new MODE UPCASE_OUTPUT
* V610  *acm* 3/08 - add new MODE NLEVELS
* V614  *acm* 10/08 - add new MODE NODATA_LAB
* V6.2  *acm*  5/09 - new default number levels is 30 pmode_nlevels
*                If this is changed, also change it in ppl/plot/ppldata.F
* V6.7  *kms* 8/11 - moved one_cmnd_mode here since needed outside ferret_dispatch.F
*       *kms*  2/12 Add pmode_ensemble_lab, pmode_forecast_lab,
*                   mode_ensemble_lab, and mode_forecast_lab;
*                   include tmap_dims.parm for nferdims needed by xprog_state.cmn
*       *acm* 4/12 Add new MODE FOURDEE to allow E,F,M,N,etc as user-vars
*       *acm* 4/12 Remove MODE FOURDEE, using _E, _F, _M, _N instead, throughout.
* V6.8  acm  6/12 Instead of mode_ensemble_lab, mode_forecast_lab, use mode_F_LAB, 
*                 which will be on by default. If canceled, the various SHOW and 
*                 LIST commands, etc, will not list info for E,F dimensions.
* V683  *acm* 8/12 - add new MODE SHRINK_YLAB
* V683  *acm* 8/12 - frame file FERRET.MGM  > ferret.gif
* V685  *sh* 11/13 - added allowed_err for SH VAR/TREE
* V690  *sh* 12/13 - added mode_curvilinear, mode_sigma
* V694 11/14 *sh* renaming 'sigma' as 'layerz' throughout
* V695  *acm* 5/13 - Ticket 2281: mode_e_lab and mode_f_lab to act as mode_lon_lab, etc, 
*                    precision of E and F labeling. The values are equivalenced to 
*                    ax_dec_pt(MODE_6D_LAB still turns on and off the listing of all 
*                    6 dimensions on SHOW commands.)
* V698  4/16 *acm* For ticket 2399: Apply MODE CALENDAR settings to F axes too
* V702  3/17 *sh* new mode FRUGAL
*                 SPAWN command returns spawn_status
* v720 7/17 *acm* ticket 2552 Make SPAWN_STATUS return the return status, so 0=succcess
*                 SPAWN_STATUS returns the status value, used for SPAWN_OK and SPAWN_STATUS

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'movies.parm'
	include 'xprog_state.cmn'

* internal variable declarations:
	INTEGER	i

* for getting commands
	DATA	prompt		/'yes? '/,
     .		prompt_len	/ 5 	/

	DATA	input_source	/ input_from_tty /,
     .		mouse_input 	/.FALSE./,
     .          one_cmnd_mode   /.FALSE./

	DATA	last_cmnd_buff/' '/,
     .		len_last_cmnd/1/

* I/O logical unit numbers
	DATA	ttin_lun	/ 5	/,	! Unix standard input
     .		ttout_lun	/ 6	/,	! Unix standard output
     .		list_lun	/ 6	/,	! same as ttout to start
     .		jrnl_lun	/ 20	/,
#ifdef STDERR_UNIT_SEVEN
     .		err_lun		/ 7	/,	! HP Unix standard error
#else
     .		err_lun		/ 0	/,	! Unix standard error
#endif
     .		cmnd_lun	/ 21	/

* for SET REDIRECT
        DATA    redirect_stdout_flags  / redirect_none /,
     .          redirect_stderr_flags  / redirect_none /

* for SET MODE
	DATA	(mode_state( pmode_diagnostic  ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.FALSE.   /,
     .		(mode_state( pmode_verify      ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.TRUE.   /,   ! 10/91
     .		(mode_state( pmode_interpolate ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.FALSE.   /,
     .		(mode_state( pmode_ignore_err  ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.FALSE.   /,
     .		(mode_state( pmode_stupid      ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.FALSE.   /,
     .		(mode_state( pmode_journal     ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.TRUE.    /,
     .		(mode_state( pmode_long_lab    ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.TRUE.    /,
     .		(mode_state( pmode_lat_lab     ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.TRUE.    /,
     .		(mode_state( pmode_depth_lab   ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.TRUE.    /,
     .		(mode_state( pmode_time_lab    ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.TRUE.    /,
     .		(mode_state( pmode_E_LAB      ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.TRUE.    /,
     .		(mode_state( pmode_F_LAB      ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.TRUE.    /
	DATA	(mode_state( pmode_font_ascii  ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.TRUE.    /,
     .		(mode_state( pmode_segment     ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.TRUE.    /,
     .		(mode_state( pmode_wait        ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.FALSE.   /,
     .		(mode_state( pmode_reject      ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.FALSE.   /,
     .		(mode_state( pmode_desperate   ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.FALSE.   /,
     .		(mode_state( pmode_rpn         ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.FALSE.   /,
     .		(mode_state( pmode_GKS         ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.FALSE.   /,	! irrelevant
     .		(mode_state( pmode_xwindows    ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.FALSE.   /
	DATA	(mode_state( pmode_metafile    ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.FALSE.   /,
     .		(mode_state( pmode_ppllist     ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.FALSE.   /,
     .		(mode_state( pmode_gui        ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.FALSE.   /,
     .		(mode_state( pmode_logo        ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.TRUE.   /,
     .		(mode_state( pmode_labels      ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.TRUE.   /,
     .		(mode_state( pmode_grat      ,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.FALSE.   /,
     .		(mode_state( pmode_linecolors,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.TRUE.   /,
     .		(mode_state( pmode_upcase_output,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.TRUE.   /,
     .		(mode_state( pmode_nlevels,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.TRUE.   /,
     .		(mode_state( pmode_nodata_lab,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.TRUE.   /,
     .		(mode_state( pmode_shrink_ylab,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.FALSE.   /
     .		(mode_state( pmode_curvilinear,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.FALSE.   /
     .		(mode_state( pmode_layerz,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.FALSE.   /
     .		(mode_state( pmode_6d_lab,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.TRUE.   /
     .		(mode_state( pmode_frugal,i), i=1,mode_stack_size)
     .					/ mode_stack_size*.TRUE.   /

	DATA	mode_name ( pmode_diagnostic  )	/ 'DIAGNOSTIC  ' /,
     .		mode_name ( pmode_verify      )	/ 'VERIFY      ' /,
     .		mode_name ( pmode_interpolate )	/ 'INTERPOLATE ' /,
     .		mode_name ( pmode_ignore_err  )	/ 'IGNORE_ERROR' /,
     .		mode_name ( pmode_stupid      )	/ 'STUPID'	 /,
     .		mode_name ( pmode_journal     )	/ 'JOURNAL'	 /,
     .		mode_name ( pmode_long_lab    )	/ 'LONG_LABEL'   /,
     .		mode_name ( pmode_lat_lab     )	/ 'LATIT_LABEL'  /,
     .		mode_name ( pmode_depth_lab   )	/ 'DEPTH_LABEL'  /,
     .		mode_name ( pmode_time_lab    )	/ 'CALENDAR'     /,
     .		mode_name ( pmode_E_LAB)	/ 'E_LABEL'      /,
     .		mode_name ( pmode_F_LAB)	/ 'F_LABEL'      /,
     .		mode_name ( pmode_font_ascii  )	/ 'ASCII_FONT'   /,
     .		mode_name ( pmode_segment     )	/ 'SEGMENT'      /,
     .		mode_name ( pmode_wait        )	/ 'WAIT'         /,
     .		mode_name ( pmode_reject      )	/ pmode_unused   /,
     .		mode_name ( pmode_desperate   )	/ 'DESPERATE'    /,
     .		mode_name ( pmode_rpn         )	/ pmode_unused /,
     .		mode_name ( pmode_gks         )	/ 'GKS'          /,
     .		mode_name ( pmode_xwindows    )	/ 'REFRESH'      /,
     .		mode_name ( pmode_metafile    )	/ 'METAFILE'     /,
     .		mode_name ( pmode_ppllist     )	/ 'PPLLIST'      /,
     .		mode_name ( pmode_gui         )	/ 'GUI'          /,
     .		mode_name ( pmode_logo        )	/ 'LOGO'         /,
     .		mode_name ( pmode_labels      )	/ 'LABELS'       /,
     .		mode_name ( pmode_grat        )	/ 'GRATICULE'    /,
     .		mode_name ( pmode_linecolors  )	/ 'LINECOLORS'   /,
     .		mode_name ( pmode_upcase_output)/ 'UPCASE_OUTPUT'/,
     .		mode_name ( pmode_nlevels     ) / 'NLEVELS'      /,
     .		mode_name ( pmode_nodata_lab  ) / 'NODATA_LAB'   /,
     .		mode_name ( pmode_shrink_ylab ) / 'SHRINK_YLAB'  /,
     .		mode_name ( pmode_curvilinear ) / 'CURVILINEAR'  /,
     .		mode_name ( pmode_layerz      ) / 'LAYERZ'       /,
     .		mode_name ( pmode_6d_lab      ) / '6D_LAB'       /,
     .		mode_name ( pmode_frugal      ) / 'FRUGAL'	 /,
     .		mode_name ( 36     ) / pmode_unused /,
     .		mode_name ( 37     ) / pmode_unused /,
     .		mode_name ( 38     ) / pmode_unused /,
     .		mode_name ( 39     ) / pmode_unused /,
     .		mode_name ( 40     ) / pmode_unused /

	DATA	(mode_arg  ( pmode_diagnostic  ,i), i=1,mode_stack_size)
     .				/ mode_stack_size*99 /,
     .		(mode_arg  ( pmode_verify      ,i), i=1,mode_stack_size)
     .				/ mode_stack_size*1 /,
     .		(mode_arg  ( pmode_interpolate ,i), i=1,mode_stack_size)
     .				/ mode_stack_size*unspecified_int4 /,
     .		(mode_arg  ( pmode_ignore_err  ,i), i=1,mode_stack_size)
     .				/ mode_stack_size*unspecified_int4 /,
     .		(mode_arg  ( pmode_stupid      ,i), i=1,mode_stack_size)
     .				/ mode_stack_size*unspecified_int4 /,
     .		(mode_arg  ( pmode_journal     ,i), i=1,mode_stack_size)
     .				/ mode_stack_size*unspecified_int4 /,
     .		(mode_arg  ( pmode_long_lab    ,i), i=1,mode_stack_size)
     .				/ mode_stack_size* 1 /, ! 1 decimal place
     .		(mode_arg  ( pmode_lat_lab     ,i), i=1,mode_stack_size)
     .				/ mode_stack_size* 1 /, ! 1 decimal place
     .		(mode_arg  ( pmode_depth_lab   ,i), i=1,mode_stack_size)
     .				/ mode_stack_size*-4 /, ! 4 sig. digs. less 0's
     .		(mode_arg  ( pmode_time_lab    ,i), i=1,mode_stack_size)
     .				/ mode_stack_size*-5 /, ! dd-mmm-yyyy:hh:mm
     .		(mode_arg  ( pmode_e_lab     ,i), i=1,mode_stack_size)
     .				/ mode_stack_size*1 / 
     .		(mode_arg  ( pmode_f_lab     ,i), i=1,mode_stack_size)
     .				/ mode_stack_size*-5 /  ! dd-mmm-yyyy:hh:mm
	DATA	(mode_arg  ( pmode_font_ascii  ,i), i=1,mode_stack_size)
     .				/ mode_stack_size*unspecified_int4 /,
     .		(mode_arg  ( pmode_segment     ,i), i=1,mode_stack_size)
     .				/ mode_stack_size*unspecified_int4 /,
     .		(mode_arg  ( pmode_wait        ,i), i=1,mode_stack_size)
     .				/ mode_stack_size*unspecified_int4 /,
     .		(mode_arg  ( pmode_reject      ,i), i=1,mode_stack_size)
     .				/ mode_stack_size*unspecified_int4 /,
     .		(mode_arg  ( pmode_desperate   ,i), i=1,mode_stack_size)
     .				/ mode_stack_size*320000 /,
     .		(mode_arg  ( pmode_rpn         ,i), i=1,mode_stack_size)
     .				/ mode_stack_size*unspecified_int4 /,
     .		(mode_arg  ( pmode_gks         ,i), i=1,mode_stack_size)
     .				/ mode_stack_size*unspecified_int4 /,
     .		(mode_arg  ( pmode_xwindows    ,i), i=1,mode_stack_size)
     .				/ mode_stack_size*unspecified_int4 /,
     .		(mode_arg  ( pmode_metafile    ,i), i=1,mode_stack_size)
     .				/ mode_stack_size*unspecified_int4 /,
     .		(mode_arg  ( pmode_ppllist     ,i), i=1,mode_stack_size)
     .				/ mode_stack_size*unspecified_int4 /
	DATA	(mode_arg  ( pmode_gui        ,i), i=1,mode_stack_size)
     .				/ mode_stack_size*unspecified_int4 /,
     .		(mode_arg  ( pmode_logo        ,i), i=1,mode_stack_size)
     .				/ mode_stack_size*unspecified_int4 /,
     .		(mode_arg  ( pmode_labels      ,i), i=1,mode_stack_size)
     .				/ mode_stack_size*unspecified_int4 /,
     .		(mode_arg  ( pmode_grat      ,i), i=1,mode_stack_size)
     .				/ mode_stack_size*unspecified_int4 /,
     .		(mode_arg  ( pmode_linecolors,i), i=1,mode_stack_size)
     .				/ mode_stack_size*6 /,
     .		(mode_arg  ( pmode_upcase_output,i), i=1,mode_stack_size)
     .				/ mode_stack_size*unspecified_int4 /,
     .		(mode_arg  ( pmode_nlevels,i), i=1,mode_stack_size)
     .				/ mode_stack_size*30 /,
     .		(mode_arg  ( pmode_nodata_lab,i), i=1,mode_stack_size)
     .				/ mode_stack_size*unspecified_int4 /,
     .		(mode_arg  ( pmode_shrink_ylab,i), i=1,mode_stack_size)
     .				/ mode_stack_size*unspecified_int4 /
     .		(mode_arg  ( pmode_curvilinear,i), i=1,mode_stack_size)
     .				/ mode_stack_size*unspecified_int4 /
     .		(mode_arg  ( pmode_layerz,i), i=1,mode_stack_size)
     .				/ mode_stack_size*unspecified_int4 /
     .		(mode_arg  ( pmode_6d_lab,i), i=1,mode_stack_size)
     .				/ mode_stack_size*unspecified_int4 /
     .		(mode_arg  ( pmode_frugal,i), i=1,mode_stack_size)
     .				/ mode_stack_size*30 /

* If the value of nlevels is changed, also change NLEV in plot/ppldata.F


* for MODE WAIT
	DATA	ppl_wait / 'NOWAIT' /

* for LIST
	DATA	list_format_given / .FALSE. /
	DATA	list_format	  / '(5(1PG12.5))' /
!	DATA	list_redirected	  / .FALSE. /   ! unused
!	DATA	list_dsf	  / .FALSE. /	! equiv to list_fmt_type
!	DATA	list_TMAP	  / .FALSE. /	! unused
!	DATA	list_unformatted  / .FALSE. /   ! unused
	DATA	list_fmt_type     / plist_default /
	DATA	list_append	  / .FALSE. /
	DATA	list_heading	  / .TRUE.  /
	DATA	list_file	  / 'AUTO'	 /
	DATA	list_outtype	  / 'DFLT'	 /
	DATA	list_digits	  / default_output_precision /

* for FRAME
	DATA	frame_file	  / 'ferret.gif' /
        DATA    frame_compress    / 'RLE' /  ! matching pframe_hdf_runlen

* other filenames
	DATA	journal_file	  / 'ferret.jnl'  /
	DATA	ppllist_file	  / 'ppllist.out' /

* stack pointer for nested IF statements
	DATA	ifstk		 / 0 /
     .		if_conditional	 / .FALSE. /

* for issuing messages about the denigrated status of qualifiers
	DATA	denig_xylim_msg_done / .FALSE. /
	DATA	denig_pen_msg_done / .FALSE. /

* auto layerz and curvilinear states
	DATA	mode_auto_curvi       /.FALSE./,
     .		mode_auto_curvi_last  /.FALSE./,
     .		mode_auto_layerz      /.FALSE./,
     .		mode_auto_layerz_last /.FALSE./

* miscellaneous
	DATA	saved_dset		/ unspecified_int4 /
	DATA	saved_abstract_grid	/ unspecified_int4 /
	DATA	xwind_node		/ ' ' /
	DATA	mode_grat_buff		/ ' ' /
        DATA    silent_err              / .FALSE. /  ! will set true for SHOW VAR/XML
        DATA    allowed_err             / .FALSE. /  ! briefly set true in SHOW VAR/TREE
        DATA    grat_on                 / .FALSE. /
        DATA    num_linecolors          / 6 /
        DATA    spawn_status            / 0 /        ! last cmnd was successful

	END

	SUBROUTINE RPN ( text,
     .			 at_typ_in,atom_id,atom_start,atom_end,
     .			 natom_infx, natom_pstfx, pstfx_order,
     .			 status,err_msg)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Routine to take an infix expression in the character variable text and 
*	convert to a postfix format.

*	J Davison TMAP/JISAO/PMEL/NOAA
*	10.20.87
* V200: 11/20/89 - *sh* changed include directories
*		- fixed bug in expr_start,expr_end to give pre-RPN string ends
*		- added arguments exp_at1, exp_atn 1st and last atom per expr'n
*		- eliminate nesting of WHERE-THEN-ELSE but allow W-T w/out ELSE
*	 3/20/90 - beef up error message resulting from monadic "-"
*	  5/3/90 - bug fix: exp_ndx max check
* V450	   11/96 - major reorg - this routine now works on only a single
*		   expression at a time and returns the permutation array
*		 - Also, support for alg_grid_chg_fcn
* Linux Port - kob- 4/97 - logic change in if statement to prevent an overflow
*			   error when looking at atom_id array.
* V532 5/01 *sh* - improve error message about unknon function in FCN(a)
* V533 7/01 *sh* - insert alg_if_marker and alg_then_marker instead of no_op
*		   to enable IF cond THEN string1 ELSE string2 
* V671 7/11  *acm* Ticket 1868 IFV - masking expressions with ifValid, treating 
*		   zero as valid. 
* V720: 4/17 *acm* add direction-changing functions as a subset of grid-changing ones

        IMPLICIT NONE
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'rpn.parm'
	include 'xalgebra.cmn'

	integer		at_typ_in(maxatoms),atom_id(maxatoms),
     .			atom_start(maxatoms),atom_end(maxatoms),
     .			natom_infx, natom_pstfx,
     .			pstfx_order(maxatoms),
     .			status

	character*(*)	text,err_msg

	integer		PRCD, GCF_NUM_ARGS, atom_type(maxatoms),
     .			inf_ptr,pos_ndx,stk_ndx,stack(maxatoms),
     .			fcn_ndx,i,arg_cnt(max_fcn),
     .			atom_cnt,inf_prc,tmp_ptr,las_ptr,
     .			ndx, narg,
     .			wte_ndx,wte_cnt(max_wte+1)
	
	logical		OK_JUXTAPO

********************************************************************************

*	INITIALIZE ALL POINTERS AND INDICES
	inf_ptr		= added_left_paren
	pos_ndx 	= 0
	stk_ndx		= 1
	stack(stk_ndx)	= added_left_paren
	
	fcn_ndx		= 0
	do 10 i = 1,max_fcn
	   arg_cnt(i) 	= 1
10	continue

! 11/96 - obsolete lines dealing with multiple expressions
!	exp_ndx		= 1
!	exp_start(1)	= 1
!	exp_at1(1)	= 1	! 1st atom of RPN
!	exp_end(1)	= 0
!	do 20 i = 2,max_exp
!	   exp_end(i)   = 0
!20	continue

	wte_ndx 	= 1
	do 25 i = 1,max_wte+1
	   wte_cnt(i)   = 0
25	continue

*	TRANSFER THE ATOM TYPE LIST TO A WORKING ARRAY WITH TERMINATOR (11/96)
	DO 30 ndx = 1, natom_infx
 30	atom_type(ndx) = at_typ_in(ndx)
	atom_cnt = natom_infx + 1
	atom_type(atom_cnt) = alg_finished	! terminator

*	EXAMINE EACH ATOM IN INFIX STRING, PUT ON STACK OR IN POSTFIX STRING
40	do 60 ndx = 1, atom_cnt
	   las_ptr = inf_ptr
	   inf_ptr = ndx

	   if (.not. OK_JUXTAPO (las_ptr,inf_ptr,atom_type,atom_id)) goto 5200
	   if (atom_type(inf_ptr) .eq. alg_grid_chg_fcn
     .	  .OR. atom_type(inf_ptr) .eq. alg_dir_chg_fcn
     .	  .OR. atom_type(inf_ptr) .eq. alg_function )
     .						fcn_ndx = fcn_ndx + 1
	
	   if (atom_type(inf_ptr) .eq. alg_log_struct .OR.
     .         atom_type(inf_ptr) .EQ. alg_log_vstruct ) then

*	      KEEP TRACK OF WHERE-THEN-ELSE CLAUSE VALIDITY
* ... when "WHERE" is encountered increase the nesting level, wte_ndx
* *kob* - linux port 4/97 change logic from ( .NOT.(A .OR. B) to 
*  	                  ( .NOT.A .AND. .NOT.B )
	      if (atom_id(inf_ptr) .eq. where) then
		 if (.not. (las_ptr  .eq. added_left_paren)) THEN
	      	    if (.not. (atom_type(las_ptr) .eq. alg_punctuation
     .		    .and.
     .		    atom_id(las_ptr) .eq. left_paren)) goto 5100
		    endif
		 wte_ndx = wte_ndx + 1
	         IF (wte_ndx .GT. 2 ) GOTO 5150
	      end if

* ... bump the WHERE-THEN-ELSE pointer, wte_cnt, is it the right logic item ?
	      wte_cnt(wte_ndx) = wte_cnt(wte_ndx) + 1
	      if (wte_cnt(wte_ndx) .ne. atom_id(inf_ptr)) 	     goto 5100

* ... decrement the W-T-E nesting level when ELSE is encountered
!	      if (wte_cnt(wte_ndx) .eq. else) then
!	         wte_cnt(wte_ndx) = 0
!	         wte_ndx          = wte_ndx - 1
!	      	 if (wte_ndx .lt. 1) 				     goto 5100
!	      end if
	   end if

	   inf_prc = PRCD (inf_flg,inf_ptr,atom_type,atom_id)
50	   if (inf_prc .gt. PRCD (stk_flg,stack(stk_ndx),atom_type,atom_id))
     .								          then
*	      PUT THIS ATOM ONTO STACK AND CONTINUE 
	      stk_ndx 	     = stk_ndx + 1
	      stack(stk_ndx) = inf_ptr
	   else
*	      POP OFF THE TOP OF THE STACK AND LOOK AT IT
	      tmp_ptr = stack(stk_ndx)
	      stk_ndx = stk_ndx - 1
	      if (stk_ndx .eq. 0) then
	         if (.not.( (inf_ptr .eq. atom_cnt) .or. 
     .		            (atom_type(inf_ptr) .eq. alg_punctuation .and. 
     .		             atom_id  (inf_ptr) .eq. comma) ))       goto 5300
	      end if

*	      PLACE ATOM OF HIGHER PRECEDENCE IN POSTFIX STRING
	      if (inf_prc .lt. PRCD (stk_flg,tmp_ptr,atom_type,atom_id))  then
		 pos_ndx	 = pos_ndx + 1 
		 pstfx_order(pos_ndx) = tmp_ptr

*		 ENSURE FUNCTION HAS RIGHT # OF ARGUMENTS
	         if (atom_type(tmp_ptr) .eq. alg_function) then
*                   ==> standard internal Ferret function
	            narg = alg_num_fcn_args(atom_id(tmp_ptr))
		    if (arg_cnt(fcn_ndx) .ne. narg)  goto 5400
		    arg_cnt(fcn_ndx) = 1
		    fcn_ndx 	     = fcn_ndx - 1
	         ELSEif (atom_type(tmp_ptr) .eq. alg_grid_chg_fcn .OR.
     .		         atom_type(tmp_ptr) .eq. alg_dir_chg_fcn ) then
*                   ==> grid changing Ferret function
*		        variable arguments?
	            narg = GCF_NUM_ARGS( atom_id(tmp_ptr) )
	            if ( narg .GE. 0 ) THEN
		       if (arg_cnt(fcn_ndx) .ne. narg)  goto 5400
	            else
		       if (arg_cnt(fcn_ndx) .LT. ABS(narg))  goto 5400
	            ENDIF
		    arg_cnt(fcn_ndx) = 1
		    fcn_ndx 	     = fcn_ndx - 1
	         end if

! 11/96 - obsolete lines dealing with multiple expressions
!		 if (exp_end(exp_ndx) .ne. 0) then
!*		    LAST EXPRESSION IS COMPLETE AND NEW ONE IS BEING BUILT
!		    exp_ndx	       = exp_ndx + 1
!	            IF ( exp_ndx .GE. max_exp ) GOTO 5600	! fix *sh* 5/90
!!		    exp_start(exp_ndx) = atom_start(pstfx_order(pos_ndx)) ! old
!* ... exp_start for expr'n n is determined at the end of expr'n n-1
!		    exp_at1  (exp_ndx) = pos_ndx	! 1st atom of RPN
!		 end if
		 goto 50
	      else
*	         PARENTHESIS MATCH OR LEFT PARENTHESIS AND A COMMA

	         if (atom_type(inf_ptr) .eq. alg_punctuation .and.
     .               atom_id  (inf_ptr) .eq. comma)			  then

*	            RETURN LEFT PARENTHESIS TO STACK
	            stk_ndx	   = stk_ndx + 1
	            stack(stk_ndx) = tmp_ptr

*	            COMMA INDICATES NEW FUNCTION ARGUMENT OR END OF EXPRESSION
	            if (fcn_ndx .ne. 0) then
		       arg_cnt(fcn_ndx) = arg_cnt(fcn_ndx) + 1
	            else
	               GOTO 5600
! 11/96 - obsolete lines dealing with multiple expressions
!!		       exp_end(exp_ndx) = atom_end(pstfx_order(pos_ndx)) ! old
!		       exp_end(exp_ndx) = atom_end(las_ptr)
!		       exp_atn(exp_ndx) = pos_ndx	! last atom of RPN
!	               exp_start(exp_ndx+1) = atom_start(inf_ptr+1)
	            end if
	         end if 
	      end if
	   end if
60	continue
! 11/96 - obsolete lines dealing with multiple expressions
!!	exp_end(exp_ndx) = atom_end(pstfx_order(pos_ndx))	! old
!	exp_end(exp_ndx) = atom_end(atom_cnt-1)
!	exp_atn(exp_ndx) = pos_ndx			! last atom of RPN

	if (wte_ndx .gt. 1) then
* ... "WHERE" is a no-op at RPN execution time
	   DO 64 i = 1, atom_cnt
 64	   IF ( ((atom_type(i) .EQ. alg_log_struct) .OR. 
     .           (atom_type(i) .EQ. alg_log_vstruct) )
     .	  .AND. atom_id(i)   .EQ. where ) at_typ_in(i) = alg_then_marker
	   IF (wte_cnt(2) .eq. where) THEN
	      goto 5100
	   ELSEIF ( wte_cnt(2) .EQ. pelse ) THEN
* ... WHERE-THEN-ELSE --> THEN becomes a no-op
	      DO 66 i = 1, atom_cnt
 66	      IF ( ((atom_type(i) .EQ. alg_log_struct) .OR. 
     .              (atom_type(i) .EQ. alg_log_vstruct) )
     .	     .AND. atom_id(i)   .EQ. pthen ) at_typ_in(i) = alg_if_marker
	   ENDIF
	end if

	if (stk_ndx .eq. 0) then

*	DONE - RETURN THE pstfx_order ARRAY
	   natom_pstfx = pos_ndx
	   status = ferr_ok
	   return

! 11/96 - obsolete lines dealing with reordering input arrays
!*	   REARRANGE TEXT ACCORDING TO PSTFX_ORDER ARRAY POSTFIX ORDERING
!	   do 70 i = 1,pos_ndx
!	      tmp_atom_type(i) 	= atom_type(pstfx_order(i))
!	      tmp_atom_id(i)   	= atom_id(pstfx_order(i))
!	      tmp_atom_start(i)	= atom_start(pstfx_order(i))
!	      tmp_atom_end(i)	= atom_end(pstfx_order(i))
!70	   continue
!
!	   do 80 i = 1,pos_ndx
!	      atom_type(i)	= tmp_atom_type(i)
!	      atom_id(i)	= tmp_atom_id(i)
!	      atom_start(i)	= tmp_atom_start(i)
!	      atom_end(i)	= tmp_atom_end(i)
!80	   continue
!	   
!	   i			= pos_ndx + 1
!	   atom_type(i)		= atom_type(atom_cnt)
!	   atom_id(i)		= atom_id(atom_cnt)
!	   atom_start(i)	= atom_start(atom_cnt)
!	   atom_end(i)		= atom_end(atom_cnt)

	else
	   goto 5500
	end if

** error exits
 5000	status = ferr_syntax
	return

*	WHERE-THEN-ELSE CLAUSE ORDER IS INCORRECT
 5100	err_msg = 'There is an error in if-then-else clause order'
	GOTO 5000

*	WHERE-THEN-ELSE CLAUSES ARE NESTED
 5150	err_msg = 'Cannot use multiple IFs in an expression'
	GOTO 5000


*	DISALLOWED JUXTAPOSITION OF ATOM TYPES AT LAS_PTR & INF_PTR
 5200	if (las_ptr .eq. added_left_paren) then
     	   err_msg = text(atom_start(inf_ptr):atom_end(inf_ptr))//
     .	   ' may not start an expression'  
	else if (inf_ptr .eq. atom_cnt) then
     	   err_msg = text(atom_start(las_ptr):atom_end(las_ptr))//
     .	   ' may not end an expression'  
	else if (atom_type(inf_ptr).eq.alg_punctuation
     .     .and. atom_id  (inf_ptr).eq.left_paren       ) then
     	   err_msg = 'unknown function "'//
     .			text(atom_start(las_ptr):atom_end(las_ptr))//'"'
	else
	   err_msg = text(atom_start(las_ptr):atom_end(las_ptr))//' before '
     .	   //text(atom_start(inf_ptr):atom_end(inf_ptr))//' is illegal'  
	   IF (text(atom_start(inf_ptr):atom_end(inf_ptr)).EQ.'-' ) THEN
	      i = (atom_end(las_ptr)-atom_start(las_ptr)+1)
     .		+ (atom_end(inf_ptr)-atom_start(inf_ptr)+1) + 19
	      IF ( inf_ptr+1 .EQ. atom_cnt ) THEN
	         err_msg = err_msg(:i)//pCR//
     .		'and "-" may not end expression'
	      ELSEIF ( atom_type(inf_ptr+1) .EQ. alg_constant ) THEN
	         err_msg = err_msg(:i)//pCR//
     .		'negative constants need to be enclosed in parentheses'
	      ELSE
	         err_msg = err_msg(:i)//pCR//
     .		'Monadic minus sign isnt allowed.  Use "(-1)*"'
	      ENDIF
	   ENDIF
	end if
	GOTO 5000

*	MISMATCHED PARENTHESIS NEAR ATOM INF_PTR
 5300	err_msg = 'There is a mismatch of parentheses near '//
     .	text(atom_start(las_ptr):atom_end(las_ptr))
	GOTO 5000

*       INCORRECT NUMBER OF ARGUMENTS IN FUNCTION TMP_PTR
 5400	err_msg = 'The '//text(atom_start(tmp_ptr):atom_end(tmp_ptr))//
     .  ' function has an incorrect number of arguments'
	GOTO 5000

*	MISMATCHED PARENTHESIS NEAR ATOM STACK(STK_NDX)
 5500	if (stack(stk_ndx) .eq. added_left_paren) then
	   err_msg = 'There is a mismatch of parentheses near '//
     .     text(atom_start(stack(stk_ndx+1)):atom_end(stack(stk_ndx+1)))
	else
	   err_msg = 'There is a mismatch of parentheses near '//
     .     text(atom_start(stack(stk_ndx)):atom_end(stack(stk_ndx)))
	end if
	GOTO 5000
 5600	err_msg = 'Definition contains multiple expressions'
	GOTO 5000

! 5600	write ( err_msg, 5610 ) max_exp
! 5610	FORMAT ('Number of expressions in line must be less than',I4)
!	GOTO 5000
	end

	SUBROUTINE CD_RD_R8_ARR( cdfid, varid, start, n, dtype, errstr,
     .                           dvals, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* read a series of values from a netCDF variable and return them as 
* double prec.
* The variable must be a simple array (e.g. an axis)

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 2/92
* V6.1 3/08 ACM If the data type is double and we return without converting 
*           the data, we still need to set status to merr_ok.
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* argument definitions:
*	cdfid	 - netCDF id number for already opened CDF file
*       varid    - variable id in netCDF file
*       start    - start subscript of netCDF variable to return
*       n        - number of values to return
*	dtype    - data type of variable
*       errstr   - identifying string to be printed with error messages
*       dvals    - double precision values returned
*       status   - TMAP library return status

* argument declarations
      INTEGER cdfid, varid, start, n, dtype, status
      REAL*8  dvals(n)
      CHARACTER*(*) errstr

      include 'netcdf.inc'
      include 'tmap_errors.parm'
      
! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"


* internal variable declarations:
      INTEGER cdfstat

* read the value
* NF_ routines convert to desired output data type.

#ifdef usingDODSf2cUnderscore
      cdfstat = NF_GET_VARA_DOUBLE_(cdfid, varid, start, n, dvals)
#else
      cdfstat = NF_GET_VARA_DOUBLE(cdfid, varid, start, n, dvals)
#endif

      IF ( cdfstat .NE. NF_NOERR ) CALL TM_ERRMSG
     .     ( cdfstat+pcdferr, status, 'CD_RD_R8_ARR', cdfid, varid,      
     .       errstr, no_errstring, *5000 )

      status = merr_ok

 5000 RETURN
      END

	LOGICAL FUNCTION TM_FPEQ_EPS ( eps, a, b )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* test to see if REAL*4 floating point numbers are equal to within
* "reasonable" accuracy
* REAL*4 (F_floating) machine error on the VAX is "approximately one part in
* 2**23" or 1.2E-7.  Allow 4.E-7 as machine error after many typical roundoffs.
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

*
* revision 0.00 - 11/21/85
* revision 0.10 - 10/23/87 - all variables explicitly declared
*
* 8/08 *acm* See Bug 1483
*      *kms*  3/12 modified to actually use the maximum absolute error
*

* calling arguments:
        REAL eps, a, b

* local variables
        REAL abmin, diffeps

* determine the maximum relative error
        abmin = MIN( ABS(a), ABS(b) )
        diffeps = abmin * ABS(eps)
* if close to zero, set the maximum absolute error
        IF ( diffeps .LT. ABS(eps) ) diffeps = ABS(eps)

        TM_FPEQ_EPS = ( ABS(a-b) .LE. diffeps )

	RETURN
	END

	SUBROUTINE SHOW_LINE_XML( lun, line)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* display basic facts about the given line in xml-style format 

* programmer - Ansley Manke, based on show_line.F
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* 6-Aug-2003
* V581 *acm* 6/05 - For fix to bug 1271, add flag line_shift_origin
*            and restore original t0 on output
* V600 *acm* 2/06 - Fix for bug 1394, send do_err flag to TM_DATE_REFORMAT
* V602 *acm*11/06 - Fix bug 1468, wrong string was written instead of the
*                   calendar name.
* V6.1  2/2008 *acm* Use attribute structure to get all attributes for the axis.
* V612  8/2008 *acm* Revert to old xml style output for infile_datatype and 
*                    ferret_datatype attributes
* V616  1/2009 *acm* Fixing LAS ticket 481, new style of xml output
* V631 11/09 *acm* For XML-formatted output check for and replace the strings < > and &
*                  with &lt; etc.
* V650  Write to show_lun which may be set to a file unit number rather than std out
* V67  *acm* 2/11 XML fixes. New attribute formatting, ![CDATA] escape, upper/lowercase handling.
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
*      *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
*      *acm* 3/13 Dont show axes with names in parentheses e.g. (AX004)
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.

	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xunits.cmn_text'
	external xunits_data
	include	'ferret.parm'
	include 'xprog_state.cmn'
	include 'xtext_info.cmn'
	include 'calendar.decl'
	include 'calendar.cmn'
	include 'xrisc.cmn'
        include 'errmsg.parm'
        include 'netcdf.inc'
	include 'xdset_info.cmn_text'

* calling argument declarations
	INTEGER 	lun, line

* local variable declarations:

	LOGICAL		TM_ITS_SUBSPAN_MODULO, NC_GET_ATTRIB, GEOG_LABEL, 
     .                  ITSA_TRUEMONTH_AXIS,
     .			got_it, calendar, bounds_done, do_bounds
	INTEGER		idim, orient, slen, iset, dset, alen, igrid
	INTEGER		TM_LENSTR1, TM_GET_CALENDAR_ID, cal_id, status
	CHARACTER	TM_FMT*32, buff*80, outbuff*20

        LOGICAL         new
        INTEGER         STR_SAME, 
     .                  ivar, llen, varid, vtype, nvatts, blen, i, len_attbuff, 
     .                  attoutflag, attid,  attlen, attype, iatt
        CHARACTER       vname*128, attname*128, attbuff*2048, 
     .                  outstring*2048, atype*10
	REAL            vals(100)

C New form for attribute output, list values separately.


 2020	FORMAT ('<attribute name="', A, '" type="char">' )
 2030	FORMAT ('<attribute name="', A, '" type="short">' )
 2040   FORMAT ('<attribute name="', A, '" type="', A,'">' )
 2050   FORMAT ('   <value>', A, '</value>')
 2055   FORMAT ('   <value><![CDATA[', A, ']]></value>')
 2060   FORMAT ('</attribute>')
 2080	FORMAT ( '</axis>' )

* determine orientation

	DO 100 idim = 1, nferdims+1
	   IF ( line_direction(line) .EQ. axis_orients( idim ) ) THEN
	      orient = idim
	      GOTO 110
	   ENDIF
 100	CONTINUE
        IF (line_direction(line) .EQ. 'XX') THEN
           orient = 1
           idim = 1
           GOTO 110
        ENDIF
        IF (line_direction(line) .EQ. 'YY') THEN
           orient = 2
           idim = 2
           GOTO 110
        ENDIF
        IF (line_direction(line) .EQ. 'TT') THEN
           orient = 4
           idim = 4
           GOTO 110
        ENDIF
        IF (line_direction(line) .EQ. 'EE') THEN  !! ??
           orient = 5
           idim = 5
           GOTO 110
        ENDIF
        IF (line_direction(line) .EQ. 'FF') THEN
           orient = 6
           idim = 6
           GOTO 110
        ENDIF

	orient = 0
	idim   = 1			! use X slot for non-oriented
 110	IF ( idim .EQ. 7 ) idim = 3	! DU --> UD on Z axis

        ! Oriengation still not defined. Look for the axis in the grids
        IF (orient .EQ. 0) THEN
	   DO 130 igrid = 1, max_dyn_grids
	   DO 120 idim = 1, nferdims
	      IF ( line .EQ. grid_line(idim,igrid) ) THEN
	         orient = idim
	         GOTO 140
	      ENDIF
 120	   CONTINUE
 130	   CONTINUE
        ENDIF

 140	CONTINUE
        IF (orient .EQ. 0) RETURN  ! axis has no direction and is not used.

* create a dummy grid with this axis
* (kludge to use existing code that works with grids)
	grid_line(idim, mgrid_buff) = line

* report basic facts using code from SHOW_GRID
	CALL LINE_FACTS_XML( lun, idim, mgrid_buff, orient, status )
        IF (status .NE. ferr_ok) GOTO 1000

* report /T0= for formatted time axis
	IF ( line_direction(line) .EQ. 'TI' ) THEN
	   calendar = GEOG_LABEL(idim, igrid)
           IF (calendar) THEN
	      buff = line_cal_name (line)
	      cal_id = TM_GET_CALENDAR_ID (buff)

              IF (line_shift_origin(line)) THEN
                 buff = '01-JAN-0001 00:00:00'
              ELSE
                 buff = line_t0(line)
              ENDIF

* Make sure it is formatted as  2000-11-01 00:00:00
              CALL TM_DATE_REFORMAT (buff, 1, cal_id, outbuff, 2, 
     .        .TRUE., status) 
              CALL ESCAPE_FOR_XML(outbuff, outstring, slen)
              WRITE ( risc_buff, 2020 ) 'time_origin'
	      CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
	      WRITE (risc_buff, 2055) outstring(1:slen)
	      CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
              WRITE ( risc_buff, 2060 ) 
	      CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

* report the calendar of a time axis

              buff = line_cal_name(line)
              CALL ESCAPE_FOR_XML(buff, outstring, slen)
              WRITE ( risc_buff, 2020 ) 'calendar'
	      CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
              WRITE ( risc_buff, 2055 ) outstring(1:slen)
	      CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
              WRITE ( risc_buff, 2060 )
	      CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
	   ENDIF
	ENDIF

* if line is subspan modulo, report its modulo cycle length
	IF ( line_modulo(line) .AND. TM_ITS_SUBSPAN_MODULO(line) ) THEN
#ifdef double_p
	   buff = TM_FMT( (line_modulo_len(line)),7,32,slen)
#else
	   buff = TM_FMT( SNGL(line_modulo_len(line)),7,32,slen)
#endif
           CALL ESCAPE_FOR_XML(buff, outstring, slen)
	   WRITE (risc_buff, 2030) 'modulo_length'
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
	   WRITE ( risc_buff, 2050 ) outstring(1:slen)
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
	   WRITE ( risc_buff, 2060 )
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
	ENDIF

* Get the dataset (show line/xml only used for axes in datasets)

        vname = line_name_orig(line)
	DO 300 iset = 1, maxdsets
	   IF ( ds_name(iset) .EQ. char_init1024) GOTO 400
           CALL CD_GET_VAR_ID (iset, vname, varid, status)
           IF (status .EQ. ferr_ok) GOTO 50
  300   CONTINUE

* Try user-defined axes, may want to get some attributes (F-TDS variables)
  400   CONTINUE
        iset = -2
        CALL CD_GET_VAR_ID (iset, vname, varid, status)
	IF (status .NE. ferr_ok) GOTO 1000

   50   dset = iset

* other attributes
        CALL CD_GET_VAR_TYPE (dset, varid, vname, vtype, status)
        CALL CD_GET_VAR_NATTS (dset, varid, vname, nvatts, status)

* Data type of the axis in the file...

        WRITE (risc_buff, 2020) 'infile_datatype'
        CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
        IF (vtype .EQ. ncbyte ) THEN
	   buff = 'BYTE'
        ELSE IF (vtype .EQ. ncchar ) THEN
           buff = 'CHAR'
        ELSE IF (vtype .EQ. ncshort ) THEN
           buff = 'SHORT'
        ELSE IF (vtype .EQ. nclong ) THEN
           buff = 'LONG'
        ELSE IF (vtype .EQ. ncfloat ) THEN
           buff = 'FLOAT'
        ELSE IF (vtype .EQ. ncdouble ) THEN
           buff = 'DOUBLE'
        ENDIF
        CALL ESCAPE_FOR_XML(buff, outstring, slen)
        WRITE ( risc_buff, 2055 ) outstring(1:slen)
        CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
        WRITE ( risc_buff, 2060 )
        CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

* All attributes not already listed.

	bounds_done = .FALSE.

        DO 200 iatt = 1, nvatts
           CALL CD_GET_VAR_ATT_INFO (dset, varid, iatt, attname, 
     .              attype, attlen, attoutflag, status )

           new = .TRUE.
           new = (STR_SAME(attname,    'direction')     .NE. 0) .AND. 
     .              (STR_SAME(attname, 'units')         .NE. 0) .AND. 
     .              (STR_SAME(attname, 'length')        .NE. 0) .AND. 
     .              (STR_SAME(attname, 'positive')      .NE. 0) .AND. 
     .              (STR_SAME(attname, 'modulo')        .NE. 0) .AND. 
     .              (STR_SAME(attname, 'modulo_length') .NE. 0) .AND. 
     .              (STR_SAME(attname, 'start')         .NE. 0) .AND. 
     .              (STR_SAME(attname, 'end')           .NE. 0) .AND. 
     .              (STR_SAME(attname, 'time_origin')   .NE. 0) .AND. 
     .              (STR_SAME(attname, 'calendar')      .NE. 0) .AND.  
     .              (STR_SAME(attname, 'point_spacing') .NE. 0) .AND. 
     .              (STR_SAME(attname, 'infile_datatype') .NE. 0)

	if (.NOT.new) new = (STR_SAME(attname, 'long_name') .EQ. 0)

           IF (new) THEN
              blen = 2048  ! len of attbuff
              got_it = NC_GET_ATTRIB (dset, varid, attname, 
     .                                .TRUE., vname, blen, attlen, 
     .                                attoutflag, attbuff, vals)
              IF (attlen .GT. 0) THEN

	      IF (STR_SAME(attname, 'edges')  .EQ. 0) THEN
	         attname = 'bounds'
	         slen = TM_LENSTR1(vname)
	         attbuff = vname(1:slen)//'_bnds'
              ENDIF

              CALL ESCAPE_FOR_XML(attname, outstring, slen)
	      IF (STR_SAME(attname, 'bounds') .EQ. 0) bounds_done = .TRUE.

* Original type of the attribute
              IF (attype .EQ. NCCHAR)   atype = 'char'
              IF (attype .EQ. NCBYTE)   atype = 'byte'
              IF (attype .EQ. NCSHORT)  atype = 'int'
              IF (attype .EQ. NCLONG)   atype = 'int'
              IF (attype .EQ. NCFLOAT)  atype = 'float'
              IF (attype .EQ. NCDOUBLE) atype = 'double'
              alen = TM_LENSTR1(atype)

	      WRITE (risc_buff, 2040) attname(1:slen), atype(1:alen)
              CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

              IF (attype .NE. NCCHAR) THEN
                 slen = 1
                 attbuff = ' '
                 DO 150 i = 1, attlen
                    buff = TM_FMT(vals(i), 7, 14, llen)
                    CALL ESCAPE_FOR_XML (buff, outstring, llen)
	            WRITE ( risc_buff, 2050 ) outstring(1:llen)  ! was slen
	            CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
 150             CONTINUE
              ELSE 
                 CALL ESCAPE_FOR_XML (attbuff, outstring, llen)
                 WRITE ( risc_buff, 2055 ) outstring(1:llen)
                 CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
              ENDIF

	      WRITE ( risc_buff, 2060 )
	      CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

           ENDIF  ! attlen GT 0
           ENDIF

 200    CONTINUE

* Write a bounds attribute for unevenly-spaced axes even if the intput file
* didnt have a bounds or edges attribute.

	do_bounds = ITSA_TRUEMONTH_AXIS(line) .OR. .NOT.line_regular( line )
	IF ( (.NOT.bounds_done) .AND. do_bounds ) THEN
	   attname = 'bounds'
	   atype = 'char'
	   slen = TM_LENSTR1(attname)
	   alen = TM_LENSTR1(atype)

	   WRITE (risc_buff, 2040) attname(1:slen), atype(1:alen)
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

	   slen = TM_LENSTR1(vname)
	   attbuff = vname(1:slen)//'_bnds'

	   CALL ESCAPE_FOR_XML (attbuff, outstring, llen)
	   WRITE ( risc_buff, 2050 ) outstring(1:llen)
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)


	   WRITE ( risc_buff, 2060 )
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
	ENDIF

* closer tag

 1000   CONTINUE
	IF (status .LT. 0) THEN
	   status = ferr_ok
	ELSE
           WRITE ( risc_buff, 2080 ) 
   	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
	ENDIF

	RETURN
	END

	PROGRAM BINARY
	INTEGER*2 ASCII(128),ICNT,IBASE,IRAST,ILEN
	BYTE X(5000),Y(5000)
	READ(5,987)ICNT,IBASE,IRAST
987	FORMAT(1X,I2,2I4)
	IF(ICNT.EQ.99)THEN
	READ(5,985)(ASCII(IJ),IJ=1,128)
	ILEN=ASCII(128)
	ELSE
	READ(5,985)(ASCII(IJ),IJ=1,ICNT+1)
	ILEN=ASCII(ICNT+1)
	DO 1010 IJ=ICNT+1,128
1010	ASCII(IJ)=1
	ENDIF
985	FORMAT(1X,20I4)
	READ(5,984)(X(IJ),IJ=1,ILEN)
	READ(5,984)(Y(IJ),IJ=1,ILEN)
984	FORMAT(1X,40I2)
	CLOSE(5)
	WRITE(6)ICNT,IBASE,IRAST,ILEN
	WRITE(6)(ASCII(I),I=1,127)
	WRITE(6)(X(I),I=1,ILEN)
	WRITE(6)(Y(I),I=1,ILEN)
	CLOSE(6)
	END

	SUBROUTINE SUB_2_GRIDS_SUB (
     .		plus, plox, phix, ploy, phiy, ploz, phiz, plot, phit, 
     .		ploe, phie, plof, phif, bad_plus,
     .		mnus, mlox, mhix, mloy, mhiy, mloz, mhiz, mlot, mhit, 
     .		mloe, mhie, mlof, mhif, bad_mnus,
     .		rslt, rlox, rhix, rloy, rhiy, rloz, rhiz, rlot, rhit, 
     .		rloe, rhie, rlof, rhif, bad_rslt )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* subtract 2 grids producing a third

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200: 10/12/89
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'

* calling argument declarations:
	INTEGER	plox, phix, ploy, phiy, ploz, phiz, plot, phit, 
     .		ploe, phie, plof, phif,
     .		mlox, mhix, mloy, mhiy, mloz, mhiz, mlot, mhit, 
     .		mloe, mhie, mlof, mhif,
     .		rlox, rhix, rloy, rhiy, rloz, rhiz, rlot, rhit, 
     .		rloe, rhie, rlof, rhif
	REAL    plus( plox:phix,ploy:phiy,ploz:phiz,plot:phit,ploe:phie,plof:phif ),
     .		mnus( mlox:mhix,mloy:mhiy,mloz:mhiz,mlot:mhit,mloe:mhie,mlof:mhif ),
     .		rslt( rlox:rhix,rloy:rhiy,rloz:rhiz,rlot:rhit,rloe:rhie,rlof:rhif )
	REAL	bad_plus, bad_mnus, bad_rslt

* internal variable declarations:
	INTEGER	i, j, k, l, m, n

* --- end of introductory code ---

	DO 100 n = rlof, rhif
	DO 100 m = rloe, rhie
	DO 100 l = rlot, rhit
	DO 100 k = rloz, rhiz
	DO 100 j = rloy, rhiy
	DO 100 i = rlox, rhix

	   IF (  plus(i,j,k,l,m,n) .NE. bad_plus
     .	   .AND. mnus(i,j,k,l,m,n) .NE. bad_mnus ) THEN

	      rslt(i,j,k,l,m,n) = plus(i,j,k,l,m,n) - mnus(i,j,k,l,m,n)

	   ELSE

	      rslt(i,j,k,l,m,n) = bad_rslt

	   ENDIF

 100	CONTINUE

	RETURN
	END 

*
*  scat2grid_minmax_xyt.F
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* April 2011
* 1/16/2016 Correctly work with irregular grids

* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE  scat2grid_minmax_xyt_init(id)

      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CHARACTER*126 buff
      WRITE (buff, 10)
   10 FORMAT 
     .  ('Compute min/max per bin, putting scattered data into XYT grid')
      CALL ef_set_desc(id, buff)

      CALL ef_set_num_args(id, 7)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS,  ABSTRACT, IMPLIED_BY_ARGS)

      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 6)

* Output grid is determined by arguments 5, 6, and 7, the result's x and y axes.

      arg = 1
      CALL ef_set_arg_name(id, arg, 'XPTS')
      CALL ef_set_arg_desc(id, arg, 
     .     'X coordinates of scattered input XYT')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'YPTS')
      CALL ef_set_arg_desc(id, arg, 
     .     'Y coordinates of scattered input XYT')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'TPTS')
      CALL ef_set_arg_desc(id, arg,
     .     'T coordinates of scattered input XYT')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
 
      arg = 4
      CALL ef_set_arg_name(id, arg, 'F')
      WRITE (buff, 20)
  20  FORMAT ('F(X,Y,T) Data at scattered input XYT')
      CALL ef_set_arg_desc(id, arg, buff)
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'XAXPTS')
      CALL ef_set_arg_desc(id, arg,
     .                   'X axis coordinates of the output grid')
      CALL ef_set_axis_influence(id, arg, YES, NO, NO, NO)

      arg = 6
      CALL ef_set_arg_name(id, arg, 'YAXPTS')
      CALL ef_set_arg_desc(id, arg,
     .                   'Y axis coordinates of the output grid')
      CALL ef_set_axis_influence(id, arg, NO, YES, NO, NO)

      arg = 7
      CALL ef_set_arg_name(id, arg, 'TAXPTS')
      WRITE (buff, 30)
  30  FORMAT ('T axis coordinates of the output grid, with same ',
     .       'units and origin as tpts')
      CALL ef_set_arg_desc(id, arg, buff)
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, YES)


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN 
      END
      
*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* loss               lo subscript for an axis
* hiss               hi subscript for an axis
*

      SUBROUTINE scat2grid_minmax_xyt_result_limits(id)

      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'


      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CALL ef_set_axis_limits(id, Z_AXIS, 1, 2)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE scat2grid_minmax_xyt_work_size(id)

      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
* 
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_dims(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER nxout, nyout, ntout, i, k
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nxout = 1 + arg_hi_ss(X_AXIS,ARG5) - arg_lo_ss(X_AXIS,ARG5)
      nyout = 1 + arg_hi_ss(Y_AXIS,ARG6) - arg_lo_ss(Y_AXIS,ARG6)
      ntout = 1 + arg_hi_ss(T_AXIS,ARG7) - arg_lo_ss(T_AXIS,ARG7)

* xaxlo  output x axis
      CALL ef_set_work_array_dims (id, 1, 1, 1, 1, 1, nxout, 1, 1, 1)
* xaxhi  output x axis
      CALL ef_set_work_array_dims (id, 2, 1, 1, 1, 1, nxout, 1, 1, 1)

* yaxlo  output y axis
      CALL ef_set_work_array_dims (id, 3, 1, 1, 1, 1, nyout, 1, 1, 1)
* yaxhi  output y axis
      CALL ef_set_work_array_dims (id, 4, 1, 1, 1, 1, nyout, 1, 1, 1)

* taxlo  output t axis
      CALL ef_set_work_array_dims (id, 5, 1, 1, 1, 1, ntout, 1, 1, 1)
* taxhi  output t axis
      CALL ef_set_work_array_dims (id, 6, 1, 1, 1, 1, ntout, 1, 1, 1)

      RETURN
      END

* In this subroutine we compute the result
*

      SUBROUTINE scat2grid_minmax_xyt_compute(id, arg_1, arg_2, arg_3, 
     .     arg_4, arg_5, arg_6, arg_7, result, xaxlo, xaxhi, 
     .     yaxlo, yaxhi, taxlo, taxhi)

*  arg_1  xpts  \
*  arg_2  ypts  / Scattered x,y,t triples to be gridded.
*  arg_3  tpts /
*  arg_4  fpts /
*  arg_5  xaxis of new grid   
*  arg_6  yaxis of new grid 
*  arg_7  taxis of new grid

      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id
      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .     mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .     mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .     mem3lot:mem3hit)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz, 
     .     mem4lot:mem4hit)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz,
     .     mem5lot:mem5hit)
      REAL arg_6(mem6lox:mem6hix, mem6loy:mem6hiy, mem6loz:mem6hiz,
     .     mem6lot:mem6hit)
      REAL arg_7(mem7lox:mem7hix, mem7loy:mem7hiy, mem7loz:mem7hiz,
     .     mem7lot:mem7hit)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*  Dimension the work arrays

      REAL*8 xaxlo(wrk1lox:wrk1hix)
      REAL*8 xaxhi(wrk2lox:wrk2hix)
      REAL*8 yaxlo(wrk3lox:wrk3hix)
      REAL*8 yaxhi(wrk4lox:wrk4hix)
      REAL*8 taxlo(wrk5lox:wrk5hix)
      REAL*8 taxhi(wrk6lox:wrk6hix)

      INTEGER i, j, k, l, m, n
      INTEGER i1, i2, j1, k1, l1
      INTEGER i5, i5n, j6, j6n, l7, l7n

      INTEGER nxpts, nypts, ntpts, nscat
      INTEGER nx, ny, nt, i1n, i2n

      REAL x1, y1, xf, yf
      REAL xx, yy, tt, ff, a1, a2, big

      CHARACTER*250 errtxt

*  variables for checking axis characteristics (modulo axes)

      CHARACTER ax_name(5)*16, ax_units(5)*16
      LOGICAL backward(5), modulox(5), regular(5)

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*  Check to see if output axes are modulo

      CALL ef_get_axis_info (id, 5, ax_name, ax_units, backward, 
     .                       modulox, regular)

*  Find number of points in scattered input points.  1-D arrays defining the 
*  scattered data points may lie on the X, Y, Z, or T axis of the input arguments.

      nxpts = 0
      nypts = 0
      ntpts = 0

      DO 110 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG1) .GE. 1) THEN
            i1 = arg_lo_ss(m,ARG1)
            i1n = arg_hi_ss(m,ARG1)
            if (i1n-i1 .NE. 0) nxpts = 1 + (i1n - i1)
         ENDIF
 110  CONTINUE

      DO 120 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG2) .GE. 1) THEN
            i2 = arg_lo_ss(m,ARG2)
            i2n = arg_hi_ss(m,ARG2)
            if (i2n-i2 .NE. 0) nypts = 1 + (i2n - i2)
         ENDIF
 120  CONTINUE

      DO 130 m = X_AXIS, T_AXIS
         IF (arg_lo_ss(m,ARG3) .GE. 1) THEN
            i2 = arg_lo_ss(m,ARG3)
            i2n = arg_hi_ss(m,ARG3)
            if (i2n-i2 .NE. 0) ntpts = 1 + (i2n - i2)
         ENDIF 
 130  CONTINUE

      IF (nxpts .NE. nypts .OR. nxpts .EQ. 0) GOTO 900
      IF (nxpts .NE. ntpts) GOTO 900
      nscat = nxpts

*  Compute number of points in output axes.

      i5 = arg_lo_ss(X_AXIS,ARG5)
      i5n = arg_hi_ss(X_AXIS,ARG5)

      j6 = arg_lo_ss(Y_AXIS,ARG6)
      j6n = arg_hi_ss(Y_AXIS,ARG6)

      l7 = arg_lo_ss(T_AXIS,ARG7)
      l7n = arg_hi_ss(T_AXIS,ARG7)

      nx = 1 + (i5n - i5)
      ny = 1 + (j6n - j6)
      nt = 1 + (l7n - l7)

*  Check that xax is a X axis and yax a Y axis and tax a T axis

      IF (i5 .EQ. ef_unspecified_int4) THEN
         WRITE (errtxt, *) 'Fifth argument must be an X axis'
         GO TO 999
      ENDIF
      IF (j6 .EQ. ef_unspecified_int4) THEN
         WRITE (errtxt, *) 'Sixth argument must be a Y axis'
         GO TO 999
      ENDIF
      IF (l7 .EQ. ef_unspecified_int4) THEN
         WRITE (errtxt, *) 'Seventh argument must be a T axis'
         GO TO 999
      ENDIF

C  Get coordinates of output axes.

      CALL EF_GET_BOX_LIMITS(id, ARG5, X_AXIS,
     .   arg_lo_ss(X_AXIS, ARG5), arg_hi_ss(X_AXIS, ARG5), xaxlo, xaxhi)

      CALL EF_GET_BOX_LIMITS(id, ARG6, Y_AXIS,
     .   arg_lo_ss(Y_AXIS, ARG6), arg_hi_ss(Y_AXIS, ARG6), yaxlo, yaxhi)

      CALL EF_GET_BOX_LIMITS(id, ARG7, T_AXIS,
     .   arg_lo_ss(T_AXIS, ARG7), arg_hi_ss(T_AXIS, ARG7), taxlo, taxhi)

*  Compute result

*  Initialize result.

        big = ABS(bad_flag_result)

        k = res_lo_ss(Z_AXIS)
        DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
           DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
              DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
                 result(i,j,1,l) = big
                 result(i,j,2,l) = -1.*big
              ENDDO
           ENDDO
        ENDDO


*  Loop over x,y,t, placing the min and max function values in the cells.

         DO 300 n = 1, nscat

            CALL pickout4 (arg_1, arg_2, arg_3, arg_4, 
     .                         n, xx, yy, tt, ff)

*  If output X axis is modulo, apply modulo adjustment to that coordinate
*  of the scattered point.

            IF  (modulox(1) .AND. xx.NE.bad_flag(ARG1))
     .         CALL modscatminmax (xaxlo(1), xaxhi(nx), 1, xx)

*  Put fcn into result variable.

            IF (ff .NE. bad_flag(ARG4)) THEN 

            l1 = 1
            DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
              IF ( tt .GE. taxlo(l1) .AND. tt .LT. taxhi(l1) ) THEN 

            j1 = 1
            DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
              IF ( yy .GE. yaxlo(j1) .AND. yy .LT. yaxhi(j1) ) THEN 

            i1 = 1
            DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
               IF ( xx .GE. xaxlo(i1) .AND. xx .LT. xaxhi(i1) ) THEN 

                  result(i,j,1,L) = MIN(ff, result(i,j,1,L))
                  result(i,j,2,L) = MAX(ff, result(i,j,2,L))

               ENDIF 

            i1 = i1 + 1
 100        CONTINUE

            ENDIF 
            j1 = j1 + 1
 200        CONTINUE

            ENDIF 
            l1 = l1 + 1
 400        CONTINUE

           ENDIF  ! ff not bad 


300   CONTINUE

* Now set the missing-value flag for locations that had no data. 

      i1 = 1
      DO 620 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
         j1 = 1
         DO 610 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            l1 = 1
            DO 600 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

               IF( result(i,j,1,l) .EQ. big) THEN
                  result(i,j,1,l) = bad_flag_result
               ENDIF

600         CONTINUE
            j1 = j1 + 1
610      CONTINUE
         i1 = i1 + 1
620   CONTINUE


      RETURN

900   CONTINUE

      IF (nxpts .NE. nypts) THEN
         WRITE (errtxt,20) nxpts, nypts
      ELSE IF (nxpts .EQ. 0) THEN
         WRITE (errtxt, 30)
      ENDIF
 20   FORMAT ('Input scattered x, y have different # of points', 2I8)
 30   FORMAT ('No data in scattered x, y points')
      GOTO 999 

 999  CALL EF_BAIL_OUT(id, errtxt)

      RETURN
      END

*
* sortj_str.F
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
* V6.2 *acm* SORTI for strings
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
*
* This function sorts data on Y axis in increasing order.  
* Returns index of sorted values.
*
*  NOTE:
*  IT IS GENERALLY ADVISABLE TO INCLUDE EXPLICIT LIMITS WHEN WORKING WITH
*  FUNCTIONS THAT REPLACE AXES. FOR EXAMPLE, THE CONSIDER THE FUNCTION
*  sortj_str(v). THE EXPRESSION
*  	LIST/L=6:10 sortl_str(v)
*  IS NOT EQUIVALENT TO
*  	LIST sortj_str(v[L=6:10])
*  THE FORMER WILL LIST THE 6TH THROUGH 10TH SORTED INDICES FROM THE ENTIRE
*  L RANGE OF VARIABLE V. THE LATTER WILL LIST ALL OF THE INDICES THAT
*  RESULT FROM SORTING v[L=6:10].
*  
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE sortj_str_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CHARACTER*120 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns indices of string data, sorted on the J axis ',
     .        'in increasing order, null strings at the end')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 1)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, ABSTRACT,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 2)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'STR')
      CALL ef_set_arg_desc(id, arg, 'String variable to sort in J')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, NO, YES, YES, YES, YES)
      CALL ef_set_arg_type(id, arg, STRING_ARG)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END


*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE sortj_str_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER my_lo, my_hi

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      my_lo = 1
      my_hi = arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1) + 1

      CALL ef_set_axis_limits(id, Y_AXIS, my_lo, my_hi)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE sortj_str_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
* 
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER mydat

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      mydat = 1 + arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1)

* sort_dat (256 * 4 bytes = 1024 byte string, but only use first 512 for safety sake)
      CALL ef_set_work_array_dims_6d(id,   1,
     .                                1,   1, 1, 1, 1, 1,
     .                            mydat, 256, 1, 1, 1, 1)

* sort_indx
      CALL ef_set_work_array_dims_6d(id, 2,
     .                                1, 1, 1, 1, 1, 1,
     .                            mydat, 1, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE sortj_str_compute(id, arg_1, result,
     .                             sort_dat, sort_indx)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif

      INTEGER id

      REAL arg_1(strdf, mem1lox:mem1hix, mem1loy:mem1hiy, 
     .                  mem1loz:mem1hiz, mem1lot:mem1hit,
     .                  mem1loe:mem1hie, mem1lof:mem1hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* Ignore the Y/Z/T/E/F dimensions in the work arrays since
* they are not used and Fortran is column major
      CHARACTER*512 sort_dat(wrk1lox:wrk1hix)
      REAL sort_indx(wrk2lox:wrk2hix)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER nsrt, slen, jj
      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      n1 = arg_lo_ss(F_AXIS, ARG1)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

      m1 = arg_lo_ss(E_AXIS, ARG1)
      DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

      l1 = arg_lo_ss(T_AXIS, ARG1)
      DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         k1 = arg_lo_ss(Z_AXIS, ARG1)
         DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

            i1 = arg_lo_ss(X_AXIS, ARG1)
            DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

               nsrt = 0

               j1 = arg_lo_ss(Y_AXIS, ARG1)
               DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

                  nsrt = nsrt + 1
                  CALL EF_GET_STRING_ARG_ELEMENT_6D(id, ARG1, arg_1,
     .                    i1, j1, k1, l1, m1, n1, slen, sort_dat(nsrt))
                  IF (slen .LE. 0) THEN
                     nsrt = nsrt - 1
                  ELSE
                     sort_indx(nsrt) = j1
                  ENDIF

                  j1 = j1 + arg_incr(Y_AXIS,ARG1)
 200           CONTINUE

*
* Sort based on sort_dat.  sort_indx goes along for the ride,
* elements moved when elements of sort_dat moved.
*
               IF (nsrt .GT. 1) CALL HEAP2_STR (sort_dat, 
     .                                   sort_indx, nsrt)

* Put sorted indices in the array first, then bad flags.

               j = res_lo_ss(Y_AXIS)
               DO 220 jj = 1, nsrt
                  result(i,j,k,l,m,n) = sort_indx(jj)
                  j = j + 1
 220           CONTINUE

               DO 240 j = res_lo_ss(Y_AXIS)+nsrt, res_hi_ss(Y_AXIS)
                  result(i,j,k,l,m,n) = bad_flag_result
 240           CONTINUE

               i1 = i1 + arg_incr(X_AXIS, ARG1)
 100        CONTINUE

            k1 = k1 + arg_incr(Z_AXIS, ARG1)
 300     CONTINUE

         l1 = l1 + arg_incr(T_AXIS, ARG1)
 400  CONTINUE

         m1 = m1 + arg_incr(E_AXIS, ARG1)
 500  CONTINUE

         n1 = n1 + arg_incr(F_AXIS, ARG1)
 600  CONTINUE

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

	SUBROUTINE GET_FER_COMMAND( called_string, status, * )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* renamed to GET_FER_COMMAND for gfortran build, which has a call, "GET_COMMAND"
*
* get next command line and decode it placing information in COMMON
* source of command may be calling argument string, operator, command file,
* or internal macro command (e.g. REPEAT or semicolon command group)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 3/26/86
* revision 0.1 - 3/4/87  - changed /star to /@
* revision 1.0 - 4/30/87 - allowed for control by CS (control stack)
* revision 1.1 - 8/11/87 - changer ^Z treatment from keyboard
* revision 1.2 - 9/14/87 - added SMG_ routines for VMS line recall
* revision 1.3 - 11/30/87- interrupt handling
* revision 1.4 - 2/25/88 - corrected bug in EOF on non-keyboard input
* revision 1.5 - 1/24/89 - allow for interrupts of PPLUS operations
* revision 1.6 - 2/2/89  - check to see if journal file exists
* V200:   2/8/90 - left justify text
* Unix/RISC port - 1/91 - cant use "/star" in documentation
*			- also ifdef'ed the VMS line recall routines
* V230:  1/27/92 - replaced double ^D exit with Unix-like "q" (QUIT)
*        8/26/92 - interpret command beginning with "?" as "HELP"
* V300:   2/2/93 - implemented semicolon-separated command groups
*	  5/6/93 - implemented "$" command arguments
*	 6/16/93 - added mode_gui input
* V301:  2/24/94 - small change due to mode_arg as a 2D variable
*	 3/14/94 - under mode refresh (xwindows) tweak the X event loop before 
*		   each new command (important under GO control)
* V313: 31/10/94 - on AIX systems the output jrnl_lun buffer must be flushed.
*			... dont know why ...
* V320:  5/19/94 - accept calling argument string (from GUI control program)
*	 	   cleanup from last command removed to CLEANUP_LAST_CMND
* 	10/24/94 - abnormal return when command file finishes in mode_gui
*       12/29/94 - use SPLIT_LIST to redirect tty output for GUI
*	 1/18/95 - added MODE VERIFY:ALWAYS
*		 - and double EOF from the command line is a QUIT (else
*			redirected command files go into a loop)
*        2/24/95 - send GUI output to journal fiie
* V400: 3/20/95 - pass "memory" to parse_command for preliminary pass in which
*		  grave accent expressions are evaluated
* V420:  3/8/96 - add FLUSH on Solaris to keep the journal file up to date
*	4/28/96 - call PROCESS_IF for multi-line IF's

* v500: 5/24/99 *kob* - Have to insert call to NAG F90_UNIX module in
*                       order to use the Fortan Flush.  USE command has
*                       to come right after subroutine name
*     : 5/34/99 *kob* - call FLUSH for all systems
* V530: *sh* 1/01 - suppress verify output during skipped IF lines 
*       *sh* 3/01 - do not call PARSE_COMMA_LIST if arg1 quoted
* V531: *sh* 4/01 - chenge prompt for continuation line
*	*sh* 5/01 - ignore DOS carriage returns in journal files
* *kob* 2/03 - replace call to intrinsic func CHAR with its octal
*              constant equivalent - needed for g77 port
* *kob* 4/06 - back off my_readline call - needed for 64-bit port
* v603 *acm* 5/07 Housekeeping: initialize arg_start and arg_end
*                 before call to parse_command
* V6.7 *kms* 8/11 add check for one-command mode before prompting
*                 user for the next command
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V690 *sh* 2/14 initialize max_context, now a variable to support aux vars
* V693+ *sh* 12/14 moved arg_start/end inits into PARSE_COMMAND (housekeeping)
*                 Moved other house-keeping from PARSE_COMMAND here
*	            1) Trim leading "yes? " and "...? "
*                   2) Trim bang-comments off.
*                   3) Do not call PARSE_COMMAND for pure comments.
*		    4) Process continuation lines
*                 Issue warning if GO file EOF found while in the midst of IF
* V697 12/15 *acm* Ticket 2337 Increase length of cmnd buffer to 20480
* V697 12/15 *acm* Ticket 2341 Check that cmnd_len hasn't been set to 0.
* V697 2/16 *acm* DO NOT Increase length of cmnd buffer to 20480 but keep 
*                 other related changes when reporting errors in long command lines
* V7+  6/16 *acm* Ticket 2446: Include the script name in warnings about 
*                 unclosed IF blocks
* V75+ 4/19 *acm* Issue 1927 (and 228!) initialize qual_given before parsing.
*          

        IMPLICIT NONE

#ifdef MIXING_NAG_F90_AND_C
	USE F90_UNIX
#endif

* calling argument declarations:
	INTEGER		status
	CHARACTER*(*)	called_string

* internal variable declarations:
	LOGICAL re_verify, do_verify, arg1_quoted,
     .		pure_comment, appending_cmnd 
	INTEGER	TM_LENSTR, TM_LENSTR1,
     .		iqual, ilist, cmnd_len, error_count,
     .          has_more, i, cmnd_len_w_cmnt, i1, i2
	CHARACTER prefix*5, raw_cmnd_buff*2048
	CHARACTER symbuff*32, scriptname*512

* local parameter declarations
        CHARACTER*1 backslash, tab
	CHARACTER*5 dprefix
	PARAMETER ( dprefix = ' !-> ') 
#ifdef NO_INTRINSIC_IN_PARAMETER
        PARAMETER ( backslash = o'134' )
	PARAMETER ( tab = o'011' )
#else
        PARAMETER ( backslash = char(92) )
	PARAMETER ( tab = CHAR(9) )
#endif

	include 'tmap_dims.parm'
	include 'errmsg.parm'
	include 'ferret.parm'
	include 'command.parm'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'
	include 'xcontrol.cmn'
	include 'xinterrupt.cmn'
	include 'xcontext.cmn'
	include 'xgui.cmn'

* initialize
	gui_status = ferr_ok	! start w/ a clean bill o' health
	error_count = 0
	max_context = max_noframe_context  ! 2/2014
	len_cmnd_copy = 0
	appending_cmnd = .FALSE.
        do_verify = .FALSE.


* initialize the qualifiers -- otherwise REPL_EXPRNS tries to take
* quals from previous commands into account. See tickets 228, 1927 

        DO iqual = 1, max_qual_list
	   qual_given( iqual ) = 0
	ENDDO

* if a command was given then execute it immediately
	IF ( called_string .NE. ' ' ) THEN
	   cmnd_buff = called_string
	   cmnd_len_w_cmnt = TM_LENSTR( cmnd_buff )
	   IF (   mode_journal
     .	    .AND. jrnl_lun .NE. unspecified_int4
     .	    .AND. cmnd_len_w_cmnt .GT. 0
     .	    .AND. cmnd_buff(1:1) .NE. backslash ) then
	      WRITE (jrnl_lun,'(A)') cmnd_buff(1:cmnd_len_w_cmnt)

* *kob* 5/99 - Flush buffer
	      CALL FLUSH(jrnl_lun)

	   ENDIF
	   GOTO 1000
	ENDIF

* select source for input
* If in one-command mode but asking to prompt user for the next
* command, then we got here from reaching the end of a go file
* or a multi-command line.  So return to the first alternative
* since the user is never prompted by ferret in one-command mode.
 20     IF ( one_cmnd_mode .AND. (input_source .EQ. 1) ) THEN
           RETURN 1
        ENDIF
        GOTO (100,200,300) input_source


************** OPERATOR AS SOURCE OF COMMAND LINE ****************************

 100	IF (mode_gui) THEN

* operator using mouse input device
	   CALL MOUSE_COMMAND (cmnd_buff)
	   cmnd_len_w_cmnt = TM_LENSTR( cmnd_buff )

	ELSE

* operator sitting at his keyboard
!	   WRITE (ttout_lun,3000) prompt(1:prompt_len)
! 3000	   FORMAT (1X,A,$)	! vms
! 3000	   FORMAT (A,$)         ! unix
!	   READ  ( ttin_lun,'(A)',END=2000 ) cmnd_buff
!	   cmnd_len_w_cmnt = TM_LENSTR( cmnd_buff )

           error_count = error_count + 1
           IF (error_count .GT. 2) THEN
* orderly shutdown on multiple errors
              cmnd_buff = 'EXIT /PROGRAM'
           ELSE IF ( appending_cmnd ) THEN
              CALL TM_FRIENDLY_READ('...? ',cmnd_buff,*20)
           ELSE
              CALL TM_FRIENDLY_READ(prompt(:prompt_len),cmnd_buff,*20)
           ENDIF
* clear interrupted if Ctrl-C was entered while typing command
           INTERRUPTED = .FALSE.
           cmnd_len_w_cmnt = TM_LENSTR( cmnd_buff )
           error_count = 0      ! in case comment or blank line returns here

	ENDIF

* echo command line to journal file

	IF (   mode_journal
     .	 .AND. jrnl_lun .NE. unspecified_int4
     .	 .AND. cmnd_len_w_cmnt .GT. 0
     .	 .AND. cmnd_buff(1:1) .NE. backslash ) then
	   WRITE (jrnl_lun,'(A)') cmnd_buff(1:cmnd_len_w_cmnt)

* *kob* 5/99 - Flush buffer
	   CALL FLUSH(jrnl_lun)
	      
	ENDIF
	do_verify = .FALSE.
	GOTO 1000

*************** COMMAND FILE AS SOURCE OF COMMAND LINE ***********************

 200	READ  (cmnd_lun, '(A)', END=210) cmnd_buff

	cmnd_len_w_cmnt = TM_LENSTR1( cmnd_buff )
	IF (cmnd_buff(cmnd_len_w_cmnt:cmnd_len_w_cmnt) .EQ. pCR ) THEN
	    cmnd_buff(cmnd_len_w_cmnt:cmnd_len_w_cmnt) = ' '
	    IF (cmnd_len_w_cmnt .GT. 1) cmnd_len_w_cmnt = 
     .					            cmnd_len_w_cmnt - 1
	ENDIF
        IF ( cmnd_buff(1:1) .EQ. backslash ) THEN
           cmnd_buff(1:1) = ' '
	   do_verify = .FALSE.
        ELSE
	   do_verify = mode_verify
        ENDIF
	prefix = ' '
	GOTO 1000
* end of command file - return to next lower control stack level
* if we were in the midst of an open IF block, issue a warning
* Include the script name in the note.
 210	IF (if_conditional) THEN
	   IF (csp .LE. if_cs(ifstk) ) THEN
	      symbuff = 'GO_FILE'
	      CALL GETSYM( symbuff, scriptname, i2, i1 )
	      IF (i1 .EQ. 0) THEN
	         CALL WARN('Unclosed IF statement ... assuming ENDIF, in script '//scriptname(:i2) )
	      ELSE
	         CALL WARN('Unclosed IF statement ... assuming ENDIF')
	      ENDIF
	   ENDIF
	ENDIF
	CALL POP_CS
	IF ( csp.EQ.0 .AND. mode_gui ) THEN		! GUI code ...
	   gui_status = ferr_ok	! a clean bill o' health at GO termination
	   RETURN 1
	ELSE
	   GOTO 20
	ENDIF

*************** COMMAND STACK AS SOURCE OF COMMAND LINE ***********************

 300	CALL CS_COMMAND( cmnd_buff, *20 )
	cmnd_len_w_cmnt = TM_LENSTR1( cmnd_buff )
	do_verify =  mode_verify .AND. mode_arg(pmode_verify,1).GE.2
	prefix = dprefix


*********** SAVE THE RAW COMMAND TO USE FOR ECHOING *************
 1000	raw_cmnd_buff = cmnd_buff

*********** TRIM "yes?" and "...?" FROM START OF LINE
	DO WHILE (cmnd_buff(1:5) .EQ. 'yes? '
     .       .OR. cmnd_buff(1:5) .EQ. '...? ' )
	   IF ( cmnd_len_w_cmnt .LT. 6 ) THEN
	     cmnd_buff = ' '
	     cmnd_len_w_cmnt = 1
	   ELSE
	     cmnd_buff = cmnd_buff(6:cmnd_len_w_cmnt)
	     cmnd_len_w_cmnt = cmnd_len_w_cmnt - 5
	   ENDIF
	ENDDO

*********** TRIM COMMAND BUFF TO EXCLUDE BANG_COMMENTS  ********************
* find length of command line ("!" is a valid terminator to permit comments)
	cmnd_len = cmnd_len_w_cmnt   ! dflt len if no comment found
	pure_comment = .FALSE.
	IF (cmnd_len .LE. 0) pure_comment = .TRUE.
	IF (cmnd_buff(1:1) .EQ. '!'
     . .OR. cmnd_buff(1:1) .EQ. '*'
     . .OR. cmnd_buff(1:1) .EQ. ' ' .AND. cmnd_len .EQ. 1) THEN
	   pure_comment = .TRUE.
	ELSE
* ... search forward in the command string for the first non-escaped "!"
	   DO i = 2, cmnd_len_w_cmnt
	      IF  ( cmnd_buff(i  :i  ) .EQ. '!' 
     .	      .AND. cmnd_buff(i-1:i-1) .NE. backslash ) GOTO 1005
	   ENDDO
* ... no bang comment found
	   GOTO 1010
* ... found "!".  Now search backwards for the last non-white character
 1005	   pure_comment = .TRUE. ! default until non-white char found
           DO cmnd_len = i-1, 1, -1
              IF (  cmnd_buff(cmnd_len:cmnd_len) .NE. ' '
     .        .AND. cmnd_buff(cmnd_len:cmnd_len) .NE. tab ) THEN
	         pure_comment = .FALSE.
	         GOTO 1010
	      ENDIF
	   ENDDO
* ... nothing but blanks preceding the comment bang
	   pure_comment = .TRUE.
	ENDIF

*********** ECHO THE COMMAND WITH ITS COMMENTS ***********************
 1010	IF (.NOT.if_conditional .AND. do_verify ) THEN
* ... echoing in IF blocks is handled by PROCESS_IF
	   IF (prefix .EQ. ' ') THEN
* ... separate SPLIT_LIST call to avoid single char ' ' prefix
	      CALL SPLIT_LIST(pttmode_ops, ttout_lun,
     .				 cmnd_buff, cmnd_len_w_cmnt)
	   ELSE
	      CALL SPLIT_LIST(pttmode_ops, ttout_lun,
     .			prefix//cmnd_buff, cmnd_len_w_cmnt+5 )
	   ENDIF
	ENDIF

*********** IF WE ONLY HAVE A COMMENT GET A FRESH STRING *************
	IF (pure_comment .AND. .NOT.appending_cmnd) GOTO 20

*********** WIPE OUT COMMENT AND LEFT JUSTIFY  ********************
	IF (pure_comment) THEN
	   cmnd_buff = ' '
	   cmnd_len = 1
	ELSEIF (cmnd_len_w_cmnt .GT. cmnd_len) THEN
	   cmnd_buff(cmnd_len+1:cmnd_len_w_cmnt) = ' '
	ENDIF
	IF ( .NOT.appending_cmnd ) THEN
	   CALL LEFT_JUST( cmnd_buff, cmnd_buff, cmnd_len )
           IF ( cmnd_buff(1:1) .EQ. '?' ) THEN   ! "?" should be an ALIAS!!
	      cmnd_buff = 'HELP'    ! 8/92
	      cmnd_len = 4
	   ENDIF
	ENDIF

********** INCOMPLETE (CONTINUED) CMND LINE -- MUST GET MORE ***************
	IF (cmnd_buff(cmnd_len:cmnd_len) .EQ. backslash) THEN
* ... save this line as a partial command
	   IF (appending_cmnd) THEN
	      cmnd_copy = cmnd_copy(:len_cmnd_copy) // cmnd_buff(:cmnd_len)
	      len_cmnd_copy = len_cmnd_copy + cmnd_len
	      IF (len_cmnd_copy .GT. cmnd_buff_len) GOTO 5005
	   ELSE
	      cmnd_copy = cmnd_buff(:cmnd_len)
	      len_cmnd_copy = cmnd_len
	   ENDIF
* ... wipe out the backslash in the stored copy
	   cmnd_copy(len_cmnd_copy:len_cmnd_copy) = ' '
	   len_cmnd_copy = len_cmnd_copy - 1
* ... go back for more
	   appending_cmnd = .TRUE.
	   GOTO 20
	ENDIF

*************** ASSEMBLE COMPLETED CONTINUATION LINES ********************
	IF (appending_cmnd) THEN
	   IF ( len_cmnd_copy+cmnd_len .GE. cmnd_buff_len ) GOTO 5005 
	   cmnd_buff = cmnd_copy(:len_cmnd_copy) // cmnd_buff(:cmnd_len)
	   cmnd_len = len_cmnd_copy + cmnd_len
	   appending_cmnd = .FALSE.
	ENDIF

*********** WHEN WITHIN AN IF BLOCK, COMMANDS MAY BE SKIPPED ****************
	IF (if_conditional) CALL PROCESS_IF(cmnd_buff, cmnd_len,
     .			            do_verify, prefix, raw_cmnd_buff, *20)

*************** PARSE THE COMMAND LINE ***************************************
* 1/14 the command string now has no continuations and no comments
	CALL PARSE_COMMAND (  cmnd_buff,
     .			     max_arg_list, max_qual_list,
     .			     len_cmnd, cmnd_num, subcmnd_num, 
     .			     num_qualifiers, qualifier_list,
     .			     qual_start, qual_end,
     .			     num_args, arg_start, arg_end,
     .			     err_lun, re_verify, arg1_quoted, status	)
	IF ( status   .NE. ferr_ok ) RETURN 1	! messages already displayed
	IF ( cmnd_num .EQ. 0 ) GOTO 20
	IF ( re_verify ) THEN
	   cmnd_len = TM_LENSTR1( cmnd_buff )
	   IF ( mode_verify ) CALL SPLIT_LIST(pttmode_ops, ttout_lun,
     .					' !-> '//cmnd_buff, cmnd_len+5 )
	ENDIF

*************** PROCESS SEMICOLON-SEPARATED COMMAND GROUPS ********************
        IF ( cmnd_num .EQ. cmnd_semicolon )
     .       CALL CS_SEMICOLON( cmnd_buff, *20)

*************** REORGANIZE LIST OF QUALIFIERS GIVEN TO INTERNAL ORDER   ********

	DO iqual = 1, max_qual_list
	   qual_given( iqual ) = 0
	ENDDO
	DO ilist = 1, num_qualifiers
	   IF ( cmnd_buff( qual_start(ilist):qual_start(ilist) ) .NE. '@' )
     .				qual_given( qualifier_list( ilist ) ) = ilist
	ENDDO

*************** BREAK APART ITEMS SEPARATED BY COMMAS IN FIRST ARGUMENT ********

	IF ( num_args .GT. 0 ) THEN
	   IF ( arg1_quoted ) THEN
	      num_items = 1
	      item_start(1) = arg_start(1)
	      item_end(1)   = arg_end(1)
	   ELSE
	      CALL PARSE_COMMA_LIST
     .		      ( cmnd_buff, arg_start(1), arg_end(1), max_item_list,
     .			num_items, item_start, item_end, status )
	      IF ( status .NE. ferr_ok ) RETURN 1
	   ENDIF
	ELSE
	   num_items = 0
	ENDIF
	
	RETURN

* error exits
 5005	CALL ERRMSG( ferr_syntax, status,
     .			'command line too long -- exceeds 2048', *9000 )
! 2048 must match cmnd_buff_len
 9000	RETURN 1


	END

	SUBROUTINE GET_AVE_LIMS( src_lo, src_hi, src_grid,
     .				 dst_lo, dst_hi, dst_grid,
     .				 idim, subsc )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* for regridding axis idim from source grid to destination grid:
* determine source grid boxes containing destination box edges

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 -  1/9/89
* V230: 8/23/92 - bug fix: time axes require special treatment
* V312:	 6/7/94 - use TDST_WORLD for simpler, faster date conversions
* V510: *sh* 1/00 - modify axis end point behavior so that partially filled
*		destination cells also get processed
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction.

	include 'ferret.parm'
	include 'errmsg.parm'

* calling argument declarations:
	INTEGER src_lo, src_hi, dst_lo, dst_hi, src_grid, dst_grid, idim
	INTEGER subsc(dst_lo:dst_hi+1)

* internal variable declarations:
	INTEGER	ISUBSCRIPT, ii, status
	REAL*8	TM_WORLD, TDEST_WORLD, xdst, xmin, xmax

* initialize
	IF ( idim .EQ. t_dim .OR. idim .EQ. f_dim ) THEN
*	  TDST_WORLD gives dates from the source axis as they would be
*	  encoded on the destination axis 
*   ==>	  ALL TIME/DATE CALCULATIONS ARE DONE IN THE SOURCE AXIS ENCODING
	   CALL TDEST_WORLD_INIT ( dst_grid, src_grid, idim, status ) ! src<->dst
	   IF ( status .NE. ferr_ok ) RETURN   ! note - status not passed!!!
	ENDIF
	xmin = TM_WORLD( src_lo, src_grid, idim, box_lo_lim )
	xmax = TM_WORLD( src_hi, src_grid, idim, box_hi_lim )

* find lower bounds of destination grid boxes on source axis
	DO 100 ii = dst_lo, dst_hi

	   xdst = TDEST_WORLD( ii, dst_grid, idim, box_lo_lim )

	   IF ( xdst .LT. xmin .OR. xdst .GT. xmax ) THEN

* ... destination point doesn't lie within source grid bounds
	      subsc( ii ) = unspecified_int4

	   ELSE

	      subsc(ii) = ISUBSCRIPT( xdst, src_grid, idim, round_up)

	   ENDIF

 100	CONTINUE

* correct first destination point if has a partial fill
	IF ( subsc(dst_lo) .EQ. unspecified_int4 ) THEN
	   xdst = TDEST_WORLD( dst_lo, dst_grid, idim, box_hi_lim )
	   IF ( xmin .LT. xdst )  THEN
	      subsc( dst_lo ) = src_lo
	   ENDIF
	ENDIF


* find upper bound of top destination grid box on source axis
	   xdst = TDEST_WORLD( dst_hi, dst_grid, idim, box_lo_lim )
	   IF ( xdst .GE. xmax ) THEN
	      subsc( dst_hi+1 ) = unspecified_int4
           ELSE
	      subsc( dst_hi+1 ) = src_hi
	   ENDIF

	RETURN
	END	

*  rr_geopotential_height.F
*
*     Rick Romea
*     Jan. 20, 2000
*
*  Geopotential height (cm) = 
*      Geopotential meters (m^2/s^2) / gravity (9.8 m/s^2) * 100
*  
************************************************************************

      SUBROUTINE RR_geopotential_height_init(id)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

      CALL ef_set_desc             (id,' Geopotential height (cm)')
      CALL ef_set_num_args         (id, 2)
      CALL ef_set_axis_inheritance (id, IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS)
      CALL ef_set_axis_reduction   (id, RETAINED,
     .                                  RETAINED,         
     .                                  REDUCED,
     .                                  RETAINED)          
      CALL ef_set_arg_name         (id, ARG1, 'TEMP')
      CALL ef_set_arg_desc         (id, ARG1, 'In Situ Temperature')
      CALL ef_set_arg_unit         (id, ARG1, 'oC')
      CALL ef_set_arg_type         (id, ARG1, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG1, YES,YES,YES,YES)

      CALL ef_set_arg_name         (id, ARG2, 'SALT')
      CALL ef_set_arg_desc         (id, ARG2, 'Salinity')
      CALL ef_set_arg_unit         (id, ARG2, 'psu')
      CALL ef_set_arg_type         (id, ARG2, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2, YES,YES,YES,YES)

      END

c*******************************************************************

      SUBROUTINE RR_geopotential_height_compute(id,arg_1,arg_2,result)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS)
      REAL bad_flag_result
      REAL arg_1  (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .             mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2  (mem2lox:mem2hix, mem2loy:mem2hiy, 
     .             mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL result (memreslox:memreshix, memresloy:memreshiy, 
     .             memresloz:memreshiz, memreslot:memreshit)

      INTEGER  res_lo_ss (4)
      INTEGER  res_hi_ss (4)
      INTEGER  res_incr  (4)

      INTEGER  arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER  arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER  arg_incr  (4,EF_MAX_ARGS)

      INTEGER  i,  j,  k,   l
      INTEGER  i1, j1, k1, l1
      INTEGER  i2, j2, k2, l2

      REAL*8   zT(1024)

      INTEGER  iZ

      CHARACTER *16  ax_name(4)
      CHARACTER *16  ax_units(4)
      LOGICAL        backward(4)
      LOGICAL        modulo(4)
      LOGICAL        regular(4)

      REAL       Rho  ! function for density
      REAL       dz,anomaly
      INCLUDE 'rr_parameters.h'

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags      (id, bad_flag,  bad_flag_result)

      ! Check that upper z grid point is the surface z grid point
	
      IF (arg_lo_ss(Z_AXIS,ARG1) .NE. 1) THEN
        CALL ef_bail_out(id,'TEMP:Upper grid point must be 1')
      ENDIF
      IF (arg_lo_ss(Z_AXIS,ARG2) .NE. 1) THEN
        CALL ef_bail_out(id,'SALT:Upper grid point must be 1')
      ENDIF
 
      ! Get Z grid coordinates

      CALL ef_get_coordinates    (id, ARG1, Z_AXIS, 
     .                            arg_lo_ss(Z_AXIS,ARG1),
     .                            arg_hi_ss(Z_AXIS,ARG1), zT)

      ! check axis units

      CALL ef_get_axis_info  (id, ARG1, ax_name, ax_units, 
     .                                backward, modulo, regular) 
      IF     ( ax_units(3) .NE. 'm'       .AND.
     .         ax_units(3) .NE. 'meters'  .AND.
     .         ax_units(3) .NE. 'M'       .AND.
     .         ax_units(3) .NE. 'METERS'  .AND.
     .         ax_units(3) .NE. 'meters_z' ) THEN
        WRITE (6,*)'Z axis units =', ax_units(3) 
        !CALL ef_bail_out(id,'Z axis must be in meters')
      ENDIF

      l1 = arg_lo_ss(T_AXIS,ARG1)
      l2 = arg_lo_ss(T_AXIS,ARG2)
      DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

        j1 = arg_lo_ss(Y_AXIS,ARG1) 
        j2 = arg_lo_ss(Y_AXIS,ARG2) 
        DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

           i1 = arg_lo_ss(X_AXIS,ARG1) 
           i2 = arg_lo_ss(X_AXIS,ARG2) 
           DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
              
              ! This is a dummy axit, since z is reduced
              DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

                 result(i,j,k,l) = 0.  ! initialize at the surface
                 iZ = 1
                 k2 = arg_lo_ss(Z_AXIS,ARG2)
                 DO k1 = arg_lo_ss(Z_AXIS,ARG1), 
     .                   arg_hi_ss(Z_AXIS,ARG1),
     .                    arg_incr(Z_AXIS,ARG1)     
                   IF (arg_1(i1,j1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                 arg_2(i2,j2,k2,l2) .EQ. bad_flag(ARG2) ) THEN
                     result(i,j,k,l) = bad_flag_result
                     GOTO 1 ! Bail from this z-integration
                   ELSE

                     anomaly = 
     .                   1. / Rho( arg_1(i1,j1,k1,l1),
     .                           arg_2(i2,j2,k2,l2), SNGL(zT(iZ))) 
     .                -  1. / Rho(  0.,  35.,  SNGL(zT(iZ)))   
           
                     IF(k1.EQ.1)THEN  ! Top z-grid point
                       dz = (SNGL(zT(iZ+1)) + SNGL(zT(iZ)))   / 2.
                     ELSEIF(k1.EQ.arg_hi_ss(Z_AXIS,ARG1))THEN ! Bottom z-point
                       dz = (SNGL(zT(iZ))   - SNGL(zT(iZ-1))) / 2.    
                     ELSE ! middle gridpoints
                       dz = (SNGL(zT(iZ+1)) - SNGL(zT(iZ-1))) / 2.
                     ENDIF
                     result(i,j,k,l)=result(i,j,k,l)+anomaly*dz*1.e5
                   ENDIF

	           iZ = iZ + 1
                   k2 = k2 + arg_incr(Z_AXIS,ARG2)
                 ENDDO
              ENDDO 
 1	      CONTINUE
              i1 = i1 + arg_incr(X_AXIS,ARG1)
              i2 = i2 + arg_incr(X_AXIS,ARG2)
           ENDDO

           j1 = j1 + arg_incr(Y_AXIS,ARG1)
           j2 = j2 + arg_incr(Y_AXIS,ARG2)
         ENDDO

      l1 = l1 + arg_incr(T_AXIS,ARG1)
      l2 = l2 + arg_incr(T_AXIS,ARG2)
      ENDDO

      END



        REAL FUNCTION RHO(temperature,salinity,pressure)

* The 1980 UNESCO International Equation of State (IES80)
* *sh* 8/5/92 - adapted from C version supplied by John Osborne, PMEL

*       This calculates rho (density kg/m^3) at salinity, 
*	temperature, and pressure.  This will be potential density if 
*	temperature is potential temperature.  The routine uses the high 
*	pressure equation of state from Millero et al. 1980 and the one-
*	atmosphere equation of state from Millero and Poisson 1981 as
*	reported in Gill 1982.  The notation follows Millero et al. 1980
*	and Millero and Poisson 1981.
*	
*	Note: the routine takes p in decibars and converts to bars for
*	the calculations.
*	
*  Gill, A.E., 1982, Atmosphere-Ocean Dynamics, Academic Press, Inc., 662 pp. 
*	
*	Input Units:
*			S: psu	T: deg. C  p: decibars.
*			
*	Output Units:
*			rho: kg/m^3
*			
*	Check values:
*			rho = 999.96675 	for S = 0,  T = 5,  p = 0
*			rho = 1027.675465 	for S = 35, T = 5,  p = 0
*			rho = 1062.538172 	for S = 35, T = 25, p = 10000.

        REAL salinity, temperature, pressure
	REAL S, T, p, rootS
	REAL a, b, c, d, e
	REAL Aw, Bw, Kw
	REAL A2, B2, C2, Kzero, K
	REAL rhoW, rhoZero
	S = salinity
	T = temperature
	p = pressure / 10.
	rootS = SQRT (S)
	rhoW = ((((6.536332e-09 * T - 1.120083e-06) * T + 1.001685e-04)
     .		* T - 9.095290e-03) * T + 6.793952e-02) * T + 999.842594
	A2 = (((5.3875e-09 * T - 8.2467e-07) * T + 7.6438e-05)
     .		* T - 4.0899e-03) * T + 8.24493e-01
	B2 = (-1.6546e-06 * T + 1.0227e-04) * T - 5.72466e-03
	C2 = 4.8314e-04
	rhoZero	= (C2 * S + B2 * rootS + A2) * S + rhoW
	IF ( pressure .EQ. 0.0 ) THEN
	   RHO=rhoZero
	   RETURN
        ENDIF
	a = ((-6.1670e-05*T+1.09987e-02)*T-6.03459e-01)*T+54.6746
	b = (-5.3009e-04 * T + 1.6483e-02) * T + 7.944e-02
	c = (-1.6078e-06 * T - 1.0981e-05) * T + 2.2838e-03
	d = 1.91075e-04
	e = (9.1697e-10 * T + 2.0816e-08) * T - 9.9348e-07
	Aw = ((-5.77905e-07*T+1.16092e-04)*T+1.43713e-03)*T+3.239908
	Bw = (5.2787e-08 * T - 6.12293e-06) * T + 8.50935e-05
	Kw = (((-5.155288e-05 * T + 1.360477e-02) * T - 2.327105)
     .		* T + 148.4206) * T + 19652.21
	Kzero = (b * rootS + a) * S + Kw
	K = ((e * p + d * rootS + c) * S + Bw * p + Aw) * p + Kzero
	RHO = rhoZero / (1.0 - (p / K))
	END

	SUBROUTINE CDF_SET_SCALE (dset, varid, do_warn, scalefac, addoff, ferr_ok, status)

	INTEGER dset, varid, ferr_ok, status
	LOGICAL do_warn
	REAL scalefac, addoff


	LOGICAL NC_GET_ATTRIB, got_it
	INTEGER attid, attype, attlen, attoutflag, buff_size
	REAL vals

	CHARACTER attname*128, varcode*128, buff*128

	IF (varid .LE. 0) GOTO 5000

	buff_size = 128
	scalefac = 1.
	addoff = 0.
	
* If the variable is to be written scaled, set the scale and offset
*  values that will be written as attributes and sent to CD_WRITE_VAR. 

	      
	attname = 'scale_factor'
	CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid, 
     .                  status)
	IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, 
     .                  varid, attid, attname, attype, attlen, attoutflag, 
     .                  status )

	IF (status.EQ.ferr_ok .AND. attid.GT.0 .AND. attoutflag.EQ.1) THEN
	   got_it = NC_GET_ATTRIB (dset, varid, attname,
     .                  do_warn, varcode, buff_size, attlen, 
     .                  attoutflag, buff, vals)
	   	scalefac = vals
	ENDIF

	attname = 'add_offset'
	CALL CD_GET_VAR_ATT_ID (dset, varid, attname, attid,  status)
	IF (attid .GT. 0) CALL CD_GET_VAR_ATT_INFO (dset, 
     .                  varid, attid, attname, attype, attlen, attoutflag, 
     .                  status )

	IF (status.EQ.ferr_ok .AND. attid.GT.0 .AND. attoutflag.EQ.1) THEN
	   got_it = NC_GET_ATTRIB (dset, varid, attname,
     .                  do_warn, varcode, buff_size, attlen, 
     .                  attoutflag, buff, vals)
	   addoff = vals
	ENDIF

 5000	RETURN
	END

*
* ecat_str.F
*
* Ansley Manke
* May 2012

* This function returns the values of the two variables,
* concatenated into one long list on an abstract E axis. Other
* axes are unchanged.
*
*
* In this subroutine we provide information about
* the function.  The user configurable information
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
*
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument''s axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result
*


      SUBROUTINE ecat_str_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* *********************************************************************S*
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CHARACTER*100 descrip

      WRITE (descrip, 100)
  100 FORMAT ('Concatenates the E values of two string variables ',
     .        'into one list on an abstract E axis')
      CALL ef_set_desc(id, descrip)

      CALL ef_set_num_args(id, 2)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, 
     .                                ABSTRACT, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_result_type(id, STRING_RETURN)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_type (id, arg, STRING_ARG)
      CALL ef_set_arg_desc(id, arg, 'First variable to concatenate')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, NO, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'B')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_type (id, arg, STRING_ARG)
      CALL ef_set_arg_desc(id, arg, 'Second variable to concatenate')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, NO, YES)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


      SUBROUTINE ecat_str_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER nm

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nm = (arg_hi_ss(E_AXIS,ARG1) - arg_lo_ss(E_AXIS,ARG1) + 1) +
     .     (arg_hi_ss(E_AXIS,ARG2) - arg_lo_ss(E_AXIS,ARG2) + 1)

      CALL ef_set_axis_limits(id, E_AXIS, 1, nm)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE ecat_str_compute(id, arg_1, arg_2, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif

      INTEGER id

      REAL arg_1(strdf, mem1lox:mem1hix, mem1loy:mem1hiy,
     .                  mem1loz:mem1hiz, mem1lot:mem1hit,
     .                  mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(strdf, mem2lox:mem2hix, mem2loy:mem2hiy,
     .                  mem2loz:mem2hiz, mem2lot:mem2hit,
     .                  mem2loe:mem2hie, mem2lof:mem2hif)

      REAL result(strdf, memreslox:memreshix, memresloy:memreshiy,
     .                   memresloz:memreshiz, memreslot:memreshit,
     .                   memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable''s axes.

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l, m, n, slen
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2
      CHARACTER*512 buff

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      m = res_lo_ss(E_AXIS)
      DO 500 m1 = arg_lo_ss(E_AXIS,ARG1), arg_hi_ss(E_AXIS,ARG1)

         n = res_lo_ss(F_AXIS)
         DO 600 n1 = arg_lo_ss(F_AXIS,ARG1), arg_hi_ss(F_AXIS,ARG1)

         l = res_lo_ss(T_AXIS)
         DO 400 l1 = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)

         k = res_lo_ss(Z_AXIS)
         DO 300 k1 = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)

         j = res_lo_ss(Y_AXIS)
         DO 200 j1 = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)

         i = res_lo_ss(X_AXIS)
         DO 100 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)

            CALL EF_GET_STRING_ARG_ELEMENT_6D(id, ARG1, arg_1,
     .                             i1, j1, k1, l1, m1, n1, slen, buff)
            CALL EF_PUT_STRING(buff, slen, result(1,i,j,k,l,m,n))

            i = i + res_incr(X_AXIS)
 100     CONTINUE

            j = j + res_incr(Y_AXIS)
 200     CONTINUE

            k = k + res_incr(Z_AXIS)
 300     CONTINUE

            l = l + res_incr(T_AXIS)
 400     CONTINUE

            n = n + res_incr(F_AXIS)
 600     CONTINUE

         m = m + res_incr(E_AXIS)
 500  CONTINUE

* concatenate in E - dont restart count of index M

         DO 510 m2 = arg_lo_ss(E_AXIS,ARG2), arg_hi_ss(E_AXIS,ARG2)

         n = res_lo_ss(F_AXIS)
         DO 610 n2 = arg_lo_ss(F_AXIS,ARG2), arg_hi_ss(F_AXIS,ARG2)

         l = res_lo_ss(T_AXIS)
         DO 410 l2 = arg_lo_ss(T_AXIS,ARG2), arg_hi_ss(T_AXIS,ARG2)

         k = res_lo_ss(Z_AXIS)
         DO 310 k2 = arg_lo_ss(Z_AXIS,ARG2), arg_hi_ss(Z_AXIS,ARG2)

         j = res_lo_ss(Y_AXIS)
         DO 210 j2 = arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS,ARG2)

         i = res_lo_ss(X_AXIS)
         DO 110 i2 = arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS,ARG2)

            CALL EF_GET_STRING_ARG_ELEMENT_6D(id, ARG2, arg_2,
     .                             i2, j2, k2, l2, m2, n2, slen, buff)
            CALL EF_PUT_STRING(buff, slen, result(1,i,j,k,l,m,n))

            i = i + res_incr(X_AXIS)
 110     CONTINUE

            j = j + res_incr(Y_AXIS)
 210     CONTINUE

            k = k + res_incr(Z_AXIS)
 310     CONTINUE

            l = l + res_incr(T_AXIS)
 410     CONTINUE

            n = n + res_incr(F_AXIS)
 610     CONTINUE

         m = m + res_incr(E_AXIS)
 510  CONTINUE

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END

        SUBROUTINE ASSIGN_T_AGG_AXIS(given_taxis, tmatch, toverlap,
     .         dset_num, nagfiles, memb_filename, memb_tstep_start,
     .         memb_tstep_end, memb_nstep_start, memb_nsteps,
     .         memb_order, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY
*  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE.
*

*  Use the given time axis, after validating, as the aggregation axis.
*  Fill in the file time metadata and assign the ordering of the member
*  files according to this time axis.

        IMPLICIT NONE
        include 'tmap_errors.parm'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
        include 'ferret.parm'
        include 'xdset_info.cmn_text'
        external xdset_info_data
        include 'xdset_info.cd_equiv'
        include 'xprog_state.cmn'
        include 'xtm_grid.cmn_text'
        include 'xunits.cmn_text'
        include 'errmsg.parm'
        include 'xvariables.cmn'
        include 'xcontext.cmn'
        include 'xfr_grid.cmn'
        include 'interp_stack.parm'
        include 'calendar.decl'
        include 'calendar.cmn'
        include 'netcdf.inc'


* arguments:

*       given_taxis      - time axis number to use (input)
*       tmatch           - method of matching times to given_taxis (input, can be empty);
*                          eg, '@ASN', '@BIN', '@XACT', '@XACT:0.001'
*       toverlap         - allowed number of overlapping time values per datset (input);
*                          negative (such as unspecified_int4) == unlimited
*       dset_num         - dataset number 1st file -- to become the T agg (input)
*       nagfiles         - number of files in the aggregation (input)
*       memb_filename    - array of filenames (input)
*       memb_tstep_start - array of first timestep in each file (output)
*       memb_tstep_end   - array of last timestep in each file (output)
*       memb_nstep_start - array of time axis indices of the first step (output)
*       memb_nsteps      - array of number of timesteps in each file (output)
*       memb_order       - sorted ordering index of files (output)
*       status           - return status (output)
*

* Argument definitions
        INTEGER given_taxis, toverlap, dset_num, nagfiles,
     .          memb_nstep_start(nagfiles), memb_nsteps(nagfiles),
     .          memb_order(nagfiles), status
        REAL*8  memb_tstep_start(nagfiles), memb_tstep_end(nagfiles)
        CHARACTER*512 memb_filename(nagfiles)
        CHARACTER*(*) tmatch

* local variable declarations:
        LOGICAL need_t0_adjust
        INTEGER TM_LENSTR1, TM_GET_CALENDAR_ID,
     .          taxis, agg_nsteps, nsteps, dtype, vlen,
     .          idx, ifile, istep, ivar, iline, plen, flen,
     .          cdfid, vid, bounds_id, gg, numover,
     .          agg_unit_code, file_unit_code, agg_cal_id
        REAL*8  TM_WORLD_AX, T0_ADJUST, GET_LINE_COORD,
     .          depsilon, epsil, aggstep, tstep, lobnd, upbnd,
     .          memb_sort(nagfiles)
        CHARACTER LEFINT*20, vname*64, units_str*128, numbuff*20,
     .            calendar_str*128, agg_t0_str*20, file_t0_str*20

        PARAMETER( depsilon = 2.0**(-42) )

*       Get the time axis name from the first file
*       (assumes rest of the files use the same name for the axis)
        taxis          = ds_time_axis(dset_num)
        IF (taxis .EQ. mnormal) GOTO 5020  ! no time axis?
        vname          = line_name_orig(taxis)
        vlen           = TM_LENSTR1(vname)

        agg_nsteps    = line_dim(given_taxis)
        dtype         = unspecified_int4   ! irrelevant from older netCD
        agg_unit_code = line_unit_code(given_taxis)
        agg_T0_str    = line_T0(given_taxis)
        agg_cal_id    = TM_GET_CALENDAR_ID(line_cal_name(given_taxis))

*       The allowed difference for an exact match (epsil) is in units of the given time axis
        IF ( tmatch .EQ. '@ASN' ) THEN
           GOTO 1000
        ELSE IF ( tmatch .EQ. '@BIN' ) THEN
           epsil = -1.0
        ELSE IF ( tmatch .EQ. '@XACT' ) THEN
           epsil = depsilon
        ELSE IF ( tmatch(1:6) .EQ. '@XACT:' ) THEN
           READ(tmatch(7:), *, ERR=5050) epsil
           IF ( epsil .LT. 0.0 ) GOTO 5050
        ELSE IF ( tmatch .EQ. ' ' ) THEN
           epsil = depsilon
*          Default is to try @XACT; if not successful, try @BIN; if not successful, use @ASN
        ELSE
           GOTO 5050
        ENDIF

        DO ifile = 1, nagfiles
*          Read the length of the time axis from the file to be aggregated
           CALL CD_QUIK_NCOPEN(dset_num, memb_filename(ifile),
     .                         vname(:vlen), cdfid, vid, bounds_id,
     .                         units_str, calendar_str, nsteps, status)
           IF (status .NE. merr_ok) GOTO 5010

*          Check to see if calendar, units, and T0 are consistent with the agg axis
           CALL CD_GET_T0(memb_filename(ifile), units_str,
     .                    calendar_str, agg_cal_id,
     .                    file_unit_code, file_t0_str, status)
           IF (status .NE. merr_ok) THEN
*             Only @ASN can be used
              IF ( tmatch .EQ. ' ' ) GOTO 1000
              GOTO 5010
           ENDIF
           need_t0_adjust = (file_unit_code .NE. agg_unit_code)
     .                 .OR. (file_T0_str .NE. agg_T0_str)
           IF (need_t0_adjust) THEN
              CALL T0_ADJUST_INIT(agg_cal_id, file_unit_code,
     .                file_t0_str, agg_unit_code, agg_t0_str, status)
              IF (status .NE. ferr_ok) THEN
*                Only @ASN can be used
                 IF ( tmatch .EQ. ' ' ) GOTO 1000
                 GOTO 5020
              ENDIF
           ENDIF

*          Grab a temporary dynamic axis slot for the file time axis
           CALL TM_ALLO_TMP_LINE(iline, status)
           CALL GET_LINE_DYNMEM(nsteps, iline, status)
           IF (status .NE. ferr_ok) GOTO 5010

*          Read the array of time steps from the file
           CALL CD_RD_R8_ARR(cdfid, vid, 1, nsteps, dtype,
     .              vname(:vlen), linemem(iline)%ptr, status)
           IF ( status .NE. merr_ok ) THEN
              CALL FREE_LINE_DYNMEM(iline)
              GOTO 5010
           ENDIF

*          Adjust the time step values to the agg-chosen "<units> since <T0>"
           IF ( need_t0_adjust ) THEN
              DO istep = 1, nsteps
                 tstep = GET_LINE_COORD(linemem(iline)%ptr, istep)
                 CALL PUT_LINE_COORD(linemem(iline)%ptr, istep,
     .                               T0_ADJUST(tstep))
              ENDDO
           ENDIF

  100      tstep = GET_LINE_COORD(linemem(iline)%ptr, 1)
           IF ( epsil .GE. 0.0 ) THEN
*             Match the time axis coordinates "exactly", with a tolerance of epsil

              IF ( line_regular(given_taxis) ) THEN
                 DO idx = 1, agg_nsteps
                    aggstep = line_start(given_taxis) +
     .                        (idx-1) * line_delta(given_taxis)
                    IF ( ABS(tstep - aggstep) .LE. epsil ) THEN
                       memb_nstep_start(ifile) = idx
                       GOTO 200
                    ENDIF
                 ENDDO
                 IF ( tmatch .EQ. ' ' ) THEN
*                   Try @BIN; previous file matches still valid
                    epsil = -1.0
                    GOTO 100
                 ENDIF
                 CALL FREE_LINE_DYNMEM(iline)
                 GOTO 5020
  200            DO istep = 2, nsteps
                    tstep = GET_LINE_COORD(linemem(iline)%ptr, istep)
                    idx = idx + 1
                    IF ( idx .GT. agg_nsteps ) THEN
*                      Only @ASN can be used
                       CALL FREE_LINE_DYNMEM(iline)
                       IF ( tmatch .EQ. ' ' ) GOTO 1000
                       GOTO 5040
                    ENDIF
                    aggstep = line_start(given_taxis) +
     .                        (idx-1) * line_delta(given_taxis)
                    IF ( ABS(tstep - aggstep) .GT. epsil ) THEN
                       IF ( tmatch .EQ. ' ' ) THEN
*                         Try @BIN; previous file matches still valid
                          epsil = -1.0
                          GOTO 100
                       ENDIF
                       CALL FREE_LINE_DYNMEM(iline)
                       GOTO 5020
                    ENDIF
                 ENDDO
              ELSE
                 DO idx = 1, agg_nsteps
                    aggstep = GET_LINE_COORD(linemem(given_taxis)%ptr,idx)
                    IF ( ABS(tstep - aggstep) .LE. epsil ) THEN
                       memb_nstep_start(ifile) = idx
                       GOTO 300
                    ENDIF
                 ENDDO
                 IF ( tmatch .EQ. ' ' ) THEN
*                   Try @BIN; previous file matches still valid
                    epsil = -1.0
                    GOTO 100
                 ENDIF
                 CALL FREE_LINE_DYNMEM(iline)
                 GOTO 5020
  300            DO istep = 2, nsteps
                    tstep = GET_LINE_COORD(linemem(iline)%ptr, istep)
                    idx = idx + 1
                    IF ( idx .GT. agg_nsteps ) THEN
*                      Only @ASN can be used
                       CALL FREE_LINE_DYNMEM(iline)
                       IF ( tmatch .EQ. ' ' ) GOTO 1000
                       GOTO 5040
                    ENDIF
                    aggstep = GET_LINE_COORD(linemem(given_taxis)%ptr,idx)
                    IF ( ABS(tstep - aggstep) .GT. epsil ) THEN
                       IF ( tmatch .EQ. ' ' ) THEN
*                         Try @BIN; previous file matches still valid
                          epsil = -1.0
                          GOTO 100
                       ENDIF
                       CALL FREE_LINE_DYNMEM(iline)
                       GOTO 5020
                    ENDIF
                 ENDDO
              ENDIF

           ELSE
*             Match the time axis coordinates by cell boundaries

              IF ( line_regular(given_taxis) ) THEN
                 DO idx = 1, agg_nsteps
                    lobnd = line_start(given_taxis) +
     .                      (idx-1.5) * line_delta(given_taxis)
                    upbnd = line_start(given_taxis) +
     .                      (idx-0.5) * line_delta(given_taxis)
                    IF ( (tstep.GE.lobnd) .AND. (tstep.LT.upbnd) ) THEN
                       memb_nstep_start(ifile) = idx
                       GOTO 400
                    ENDIF
                 ENDDO
*                Only @ASN can be used
                 CALL FREE_LINE_DYNMEM(iline)
                 IF ( tmatch .EQ. ' ' ) GOTO 1000
                 GOTO 5020
  400            DO istep = 2, nsteps
                    tstep = GET_LINE_COORD(linemem(iline)%ptr, istep)
                    idx = idx + 1
                    IF ( idx .GT. agg_nsteps ) THEN
*                      Only @ASN can be used
                       CALL FREE_LINE_DYNMEM(iline)
                       IF ( tmatch .EQ. ' ' ) GOTO 1000
                       GOTO 5040
                    ENDIF
                    lobnd = line_start(given_taxis) +
     .                      (idx-1.5) * line_delta(given_taxis)
                    upbnd = line_start(given_taxis) +
     .                      (idx-0.5) * line_delta(given_taxis)
                    IF ( (tstep.LT.lobnd) .OR. (tstep.GE.upbnd) ) THEN
*                      Only @ASN can be used
                       CALL FREE_LINE_DYNMEM(iline)
                       IF ( tmatch .EQ. ' ' ) GOTO 1000
                       GOTO 5020
                    ENDIF
                 ENDDO
              ELSE
                 DO idx = 1, agg_nsteps
                    lobnd = GET_LINE_COORD(lineedg(given_taxis)%ptr,idx)
                    upbnd = GET_LINE_COORD(lineedg(given_taxis)%ptr,idx+1)
                    IF ( (tstep.GE.lobnd) .AND. (tstep.LT.upbnd) ) THEN
                       memb_nstep_start(ifile) = idx
                       GOTO 500
                    ENDIF
                 ENDDO
*                Only @ASN can be used
                 CALL FREE_LINE_DYNMEM(iline)
                 IF ( tmatch .EQ. ' ' ) GOTO 1000
                 GOTO 5020
  500            DO istep = 2, nsteps
                    tstep = GET_LINE_COORD(linemem(iline)%ptr, istep)
                    idx = idx + 1
                    IF ( idx .GT. agg_nsteps ) THEN
*                      Only @ASN can be used
                       CALL FREE_LINE_DYNMEM(iline)
                       IF ( tmatch .EQ. ' ' ) GOTO 1000
                       GOTO 5040
                    ENDIF
                    lobnd = GET_LINE_COORD(lineedg(given_taxis)%ptr,idx)
                    upbnd = GET_LINE_COORD(lineedg(given_taxis)%ptr,idx+1)
                    IF ( (tstep.LT.lobnd) .OR. (tstep.GE.upbnd) ) THEN
*                      Only @ASN can be used
                       CALL FREE_LINE_DYNMEM(iline)
                       IF ( tmatch .EQ. ' ' ) GOTO 1000
                       GOTO 5020
                    ENDIF
                 ENDDO
              ENDIF

           ENDIF
           CALL FREE_LINE_DYNMEM(iline)

*          Assign the time steps for this file using the given axis coordinates
           idx = memb_nstep_start(ifile)
           IF ( line_regular(given_taxis) ) THEN
              memb_tstep_start(ifile) = line_start(given_taxis) +
     .                   line_delta(given_taxis) * (idx-1)
              memb_tstep_end(ifile) = line_start(given_taxis) +
     .                   line_delta(given_taxis) * (idx+nsteps-1)
           ELSE
              memb_tstep_start(ifile) =
     .             GET_LINE_COORD(linemem(given_taxis)%ptr, idx)
              memb_tstep_end(ifile) =
     .             GET_LINE_COORD(linemem(given_taxis)%ptr, idx+nsteps-1)
           ENDIF
           memb_nsteps(ifile) = nsteps

        ENDDO

*       Get the ordering of the files according to the start time
        DO ifile = 1, nagfiles
           memb_sort(ifile) = memb_tstep_start(ifile)
        ENDDO
        CALL SORT_TSERIES_DSETS(nagfiles, memb_order, memb_sort)

*       Check for time overlaps between datasets.  Just use the time coordinate
*       indices for the given T axis instead of actual time coordinates
        DO ifile = 2, nagfiles
           numover = memb_nstep_start(memb_order(ifile-1)) + 
     .               memb_nsteps(memb_order(ifile-1)) -
     .               memb_nstep_start(memb_order(ifile))
           IF ( numover .GT. 0 ) THEN
              plen = TM_LENSTR1(memb_filename(memb_order(ifile-1)))
              flen = TM_LENSTR1(memb_filename(memb_order(ifile)))
              IF ( toverlap .EQ. 0 ) THEN
*                The standard/default of no overlaps allowed
                 IF ( tmatch .EQ. ' ' ) GOTO 1000
                 CALL ERRMSG(ferr_aggregate_error, status,
     .                'Time axes overlap for '//
     .                memb_filename(memb_order(ifile-1))(1:plen)//
     .                ' and '//
     .                memb_filename(memb_order(ifile))(1:flen), *5000)
              ELSEIF ( numover .GE. memb_nsteps(memb_order(ifile)) ) THEN
*                Too problematic if the prior dataset time axis completely 
*                covers this dataset time axis; only @ASN can be used.
                 IF ( tmatch .EQ. ' ' ) GOTO 1000
                 CALL ERRMSG(ferr_aggregate_error, status, 
     .                'Time axis for '//
     .                memb_filename(memb_order(ifile-1))(1:plen)//
     .                'completely covers the time axis for '//
     .                memb_filename(memb_order(ifile))(1:flen), *5000)
              ELSEIF ( numover .GE. memb_nsteps(memb_order(ifile-1)) ) THEN
*                Too problematic if this dataset time axis completely 
*                covers the prior dataset time axis; only @ASN can be used.
                 IF ( tmatch .EQ. ' ' ) GOTO 1000
                 CALL ERRMSG(ferr_aggregate_error, status, 
     .                'Time axis for '//
     .                memb_filename(memb_order(ifile))(1:flen)//
     .                'completely covers the time axis for '//
     .                memb_filename(memb_order(ifile-1))(1:plen), *5000)
              ELSEIF ( (toverlap .GE. 0) .AND. (toverlap .LT. numover) ) THEN
*                Partial overlap is not acceptable; only @ASN can be used
                 IF ( tmatch .EQ. ' ' ) GOTO 1000
                 numbuff = LEFINT(numover, idx)
                 CALL ERRMSG(ferr_aggregate_error, status,
     .                'Excessive ('//numbuff(1:idx)//') overlaps '//
     .                'in time axes for '//
     .                memb_filename(memb_order(ifile-1))(1:plen)//
     .                ' and '//
     .                memb_filename(memb_order(ifile))(1:flen), *5000)
              ENDIF


*             Partial overlap acceptable; truncate the time range of the prior dataset
              idx = memb_nstep_start(memb_order(ifile-1))
              nsteps = memb_nsteps(memb_order(ifile-1)) - numover
              IF ( line_regular(given_taxis) ) THEN
                 memb_tstep_end(memb_order(ifile-1)) = line_start(given_taxis) +
     .                line_delta(given_taxis) * (idx+nsteps-1)
              ELSE
                 memb_tstep_end(memb_order(ifile-1)) =
     .                GET_LINE_COORD(linemem(given_taxis)%ptr, idx+nsteps-1)
              ENDIF
              memb_nsteps(memb_order(ifile-1)) = nsteps

*             Let the user know about the truncation
              numbuff = LEFINT(numover, idx)
              CALL WARN('Ignored last '//numbuff(1:idx)//
     .                  ' timesteps of '//
     .                  memb_filename(memb_order(ifile-1))(1:plen)//
     .                  ' due to overlap with '//
     .                  memb_filename(memb_order(ifile))(1:flen))
           ENDIF
        ENDDO

        IF ( tmatch .EQ. ' ' ) THEN
           IF ( epsil .LT. 0.0 ) THEN
              CALL WARN('Time axis coordinates matched using @BIN')
           ELSE
              CALL WARN('Time axis coordinates matched using @XACT')
           ENDIF
        ENDIF
        GOTO 4000

*       Blindly associate the time steps contiguously onto the given time axis
*       in the order the data files were provided
 1000   istep = 0
        DO ifile = 1, nagfiles
*          Read the length of the time axis from the file to be aggregated
           CALL CD_QUIK_NCOPEN(dset_num, memb_filename(ifile),
     .                         vname(:vlen), cdfid, vid, bounds_id,
     .                         units_str, calendar_str, nsteps, status)
           IF (status .NE. merr_ok) GOTO 5010
           IF ( (istep + nsteps) .GT. agg_nsteps ) GOTO 5040
           memb_nstep_start(ifile) = istep + 1
*          Record times from the given time axis
           IF ( line_regular(given_taxis) ) THEN
              memb_tstep_start(ifile) = line_start(given_taxis) +
     .                   line_delta(given_taxis) * istep
              memb_tstep_end(ifile) = line_start(given_taxis) +
     .                   line_delta(given_taxis) * (istep+nsteps-1)
           ELSE
              memb_tstep_start(ifile) =
     .            GET_LINE_COORD(linemem(given_taxis)%ptr, istep+1)
              memb_tstep_end(ifile) =
     .            GET_LINE_COORD(linemem(given_taxis)%ptr, istep+nsteps)
           ENDIF
           memb_nsteps(ifile) = nsteps
           istep = istep + nsteps
           memb_order(ifile) = ifile
        ENDDO
        IF ( tmatch .EQ. ' ' ) THEN
           CALL WARN('Time axis coordinates matched using @ASN')
        ENDIF

*       Correct all time-dependent variables in this aggregate dataset
 4000   ds_time_axis(dset_num) = given_taxis
        DO ivar = 1, maxvars
           IF ( ds_var_setnum(ivar) .EQ. dset_num ) THEN
              gg = ds_grid_number(ivar)
              IF ( grid_line(t_dim,gg) .EQ. taxis .OR.
     .             grid_line(t_dim,gg) .EQ. given_taxis ) THEN
                 ds_grid_end(t_dim,ivar) = agg_nsteps
              ENDIF
              IF ( grid_line(t_dim,gg) .EQ. taxis ) THEN
*                Was this grid modified in this loop an instant ago?
*                Note: Should use the dset var LIST!   Super-inefficient nested loop
                 DO idx = 1, ivar-1
                    IF ( ds_var_setnum(idx) .EQ. dset_num ) THEN
                       IF (ds_grid_number(idx) .EQ. gg) GOTO 4100
                    ENDIF
                 ENDDO
                 grid_line(t_dim,gg) = given_taxis
*                "use" the given time axis; "un-use" the one from the file
                 CALL TM_USE_LINE(given_taxis)
                 CALL TM_DEALLO_DYN_LINE(taxis)
              ENDIF
           ENDIF
 4100      CONTINUE
        ENDDO
        IF ( .NOT.line_regular(taxis) ) CALL FREE_LINE_DYNMEM(taxis)

        status = ferr_ok
 5000   RETURN

 5010   CALL ERRMSG(ferr_TMAP_error, status, ' ', *5000)
 5020   CALL ERRMSG(ferr_aggregate_error, status,
     .   'Given time axis invalid for the aggregation', *5000)
 5040   CALL ERRMSG(ferr_aggregate_error, status,
     .   'Given time axis not long enough for the aggregation', *5000)
 5050   idx = TM_LENSTR1(tmatch)
        CALL ERRMSG(ferr_aggregate_error, status,
     .   'Invalid time axis assocation "'//tmatch(1:idx)//'"', *5000)

        END

        SUBROUTINE BUILD_T_AGG_AXIS(dset_num, nagfiles, memb_filename,
     .             memb_tstep_start, memb_tstep_end, memb_nstep_start,
     .             memb_nsteps, memb_order, status)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*


*  Modify the time axis that was defined by the first file of the T-agg
*  through the inclusion time information from all of the member files
*  in the aggregation.  Fill in the file time metadata while creating
*  the aggregated time axis and assign the ordering of the member files
*  according to this time axis.


* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - TMAP 
*
* V695+ 10/15 *sh* -- based upon DEFINE_EF_AGGREGATE_GRID
* V67    5/16 *acm*   Fixes for member sets with single-point time axes having bounds
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.
* V7022 1/17 *acm* ticket 2497, Back off the auto-detection of monthly axes.
* V71   2/17 *acm* ticket 2507, When agg axis matches an existing one, fix swapping 
*                  of axis into grids - the swap axis may be in multiple grids.
* V71   2/17 *acm* ticket 2507, further fix for when several variables have the same grid.
* V72 8/17 *acm*   For trac enhancement #767 -- dynamic coordinate storage
* V74 1/18 *acm*   Issue 1853 correctly handle aggregations of one timestep

        IMPLICIT NONE
        include 'tmap_errors.parm'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xdset_info.cd_equiv'
        include 'xprog_state.cmn'
	include 'xtm_grid.cmn_text'
	include 'xunits.cmn_text' 
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xfr_grid.cmn'
	include 'interp_stack.parm'
	include 'calendar.decl'
	include 'calendar.cmn'
	include 'netcdf.inc'


* arguments:

*	dset_num	 - dataset number 1st file -- to become the T agg
*	nagfiles	 - number of files in the aggregation (input)
*	memb_filename	 - array of filenames (input)
*	memb_tstep_start - array of first timestep in each file (output)
*	memb_tstep_end	 - array of last  timestep in each file (output)
*       memb_nstep_start - array of time axis indices of the first step (output)
*	memb_nsteps	 - array of N timesteps in each file (output)
*	memb_order	 - sorted ordering index of files (output)
*	status		 - return status (output)
*

* Argument definitions
        INTEGER dset_num, nagfiles, memb_nstep_start(nagfiles), 
     .          memb_nsteps(nagfiles), memb_order(nagfiles), status
        REAL*8  memb_tstep_start(nagfiles), memb_tstep_end(nagfiles)
        CHARACTER*512 memb_filename(nagfiles)


* local variable declarations:
	LOGICAL TM_DFPEQ_TOL, ITSA_TRUEMONTH_AXIS, need_midpoints, need_T0_adjust,
     .		swap_axes, true_month, memb_true_month
	INTEGER TM_LENSTR1, TM_GET_CALENDAR_ID, TM_FIND_LIKE_DYN_LINE,
     .		memb_tline(nagfiles), taxis, nsteps, dtype, vlen, blen,
     .		i, ifile, istep, ivar, TMAP_status,
     .		cdfid, vid, bounds_id, gg, ilo, ihi, l, imemb,
     .		startpts(2), numpts(2), d1s, d1e, d2s, d2e,
     .		agg_unit_code, file_unit_code, agg_cal_id, pre_exist, 
     .		nsteps_trumon, iline, sumstep, bigline
	REAL	TM_WORLD_AX, T0_ADJUST, GET_LINE_COORD, TM_WW_AXLEN,
     .		SECS_FROM_BC, 
     .		tt, delta, highest_tstep, dfirst_delta, 
     .		depsilon, start, tunit, hdel, tstep, tedge, tn, 
     .		memb_sort(nagfiles), axwwlen, bc_to_t0, secsperyear, 
     .		secs2start, timefac
	CHARACTER LEFINT*20, lname*20, vname*64, bname*12, units_str*128,
     .		  calendar_str*128, agg_t0_str*20, file_t0_str*20

	PARAMETER (depsilon = 2.**(-42)) 

* initialize
	DO i = 1, nagfiles 
	   memb_tline(i) = unspecified_int4
	ENDDO

* initialize using information from the first file of the aggregation
	taxis          = ds_time_axis(dset_num)
	IF (taxis .EQ. mnormal) GOTO 5050   ! no time axis?
	nsteps         = line_dim(taxis) ! n steps in first file ... will grow
	vname          = line_name_orig(taxis)
	vlen           = TM_LENSTR1(vname)
	dtype          = unspecified_int4  ! irrelevant from older netCD
	need_midpoints = .FALSE.           ! assume cell edges are provided
	agg_unit_code  = line_unit_code(taxis)
	agg_T0_str     = line_T0(taxis)
	agg_cal_id     = TM_GET_CALENDAR_ID (line_cal_name(taxis))

* note that this routine is called under a promise that
* dset_num is the *only* dataset that uses the time axis pointed to by
* ds_time_axis.  Thus our procedure here will be to define the aggregated T
* axis in as a new axis and then replace the pointers to the old axis with the
* new. 

* Was the first file found to have a true-monthly time axis?
* (see old versions of this in SVN and update them, if we want to do true-month axis handling.)

	true_month = .FALSE.

* Put the first datasets timesteps into a new line. We will put the final
* aggregated time axis into the line taxis at the end.

	CALL TM_ALLO_TMP_LINE(iline, status)
	memb_tline(1) = iline
	CALL GET_LINE_DYNMEM (nsteps, iline, status)
	IF (status .NE. ferr_ok) GOTO 5100

        IF ( line_regular(taxis) ) THEN
* ... convert the so-far regular 1st file axis into a forced-irregular axis

	   line_regular(taxis) = .FALSE.
	   
	   DO istep = 1, nsteps
	      CALL PUT_LINE_COORD ( linemem(iline)%ptr, istep, line_start(taxis)
     .		+ (istep-1)* line_delta(taxis) )
	   ENDDO

	   IF (nsteps .EQ. 1) THEN
	      CALL PUT_LINE_COORD ( lineedg(iline)%ptr, 1, 
     .		       line_start(taxis) - line_delta(taxis)/2. )
	      CALL PUT_LINE_COORD ( lineedg(iline)%ptr, 2, 
     .		       line_start(taxis) + line_delta(taxis)/2. )
	   ELSE
	      line_delta(iline) = unspecified_val8
	      need_midpoints = .TRUE.
	   ENDIF
	
        ELSE
	    CALL COPY_LINE_COORDS (linemem(taxis)%ptr, linemem(iline)%ptr, nsteps)
	    CALL COPY_LINE_COORDS (lineedg(taxis)%ptr, lineedg(iline)%ptr, nsteps+1)
	ENDIF

**
* Loop through the files of the aggregation, appending time step values.
* insert the metadata of the first file (so far opened as netCDF dataset)
	   ifile = 1
	   memb_nsteps     (ifile) = nsteps
	   memb_tstep_start(ifile) = GET_LINE_COORD (linemem(iline)%ptr, 1)
	   memb_tstep_end  (ifile) = GET_LINE_COORD (linemem(iline)%ptr, nsteps)

	      DO ifile = 2, nagfiles
* ... first read the length of the time axis from the file to be aggregated
	         CALL CD_QUIK_NCOPEN (dset_num, memb_filename(ifile),
     .				      vname(:vlen),
     .				      cdfid, vid, bounds_id,
     .				      units_str, calendar_str,
     .				      nsteps, TMAP_status)
	         IF (TMAP_status .NE. merr_ok) GOTO 5010
* ... check to see if calendar, units, and T0 are consistent with the agg axis
	         CALL CD_GET_T0(memb_filename(ifile), units_str, calendar_str,
     .                  agg_cal_id, file_unit_code, file_t0_str, status)
	         need_T0_adjust = (file_unit_code .NE. agg_unit_code)
     .			     .OR. (file_T0_str    .NE. agg_T0_str)
	         IF (need_t0_adjust) CALL T0_ADJUST_INIT ( agg_cal_id,
     .				          file_unit_code, file_t0_str,
     .					  agg_unit_code,  agg_t0_str, status )
	         memb_nsteps(ifile) = nsteps

* grab a temporary dynamic axis slot for it
	         CALL TM_ALLO_TMP_LINE(iline, status)
		 memb_tline(ifile) = iline

		 CALL GET_LINE_DYNMEM (nsteps, iline, status)
		 IF (status .NE. ferr_ok) GOTO 5100

* ... read the array of time steps from the file
	         CALL CD_RD_R8_ARR(cdfid, vid,1, nsteps,dtype,vname(:vlen),
     .				   linemem(iline)%ptr, status)
	         IF ( status .NE. merr_ok ) GOTO 5010

* ... adjust the time step values to the agg-chosen "<units> since <T0>"
	         IF (need_T0_adjust) THEN
	            DO istep = 1, nsteps
		       tstep = GET_LINE_COORD (linemem(iline)%ptr, istep)
	               CALL PUT_LINE_COORD ( linemem(iline)%ptr, istep, T0_ADJUST(tstep))
	            ENDDO
	         ENDIF

	         memb_tstep_start(ifile) = GET_LINE_COORD (linemem(iline)%ptr, 1)
	         memb_tstep_end  (ifile) = GET_LINE_COORD (linemem(iline)%ptr, nsteps)

	         IF (bounds_id .EQ. unspecified_int4) THEN
* ... cell boundaries NOT available in this file
*     if not available in any one file, they are effectively missing
	            need_midpoints = .TRUE.

	         ELSEIF (.NOT. need_midpoints) THEN
* ... cell boundaries ARE available in this file
*     store them in high line memory, backwards ordered
	            bname = 'bounds array'
                    blen = 12
*     in CF the bounds are stored 2D Nx2, whereas in Ferret they are simply N+1
*     so two reads are needed
*       read #1) the lower bound array and 
*       read #2) the topmost upper bound (a single point)
*     the cells are *assumed* to be contiguous -- no checking done

*     #1) read the lower box bound values (nsteps values)
                    startpts(1) = 1
                    startpts(2) = 1
                    numpts(1) = 1
                    numpts(2) = nsteps

                    d1s = startpts(1)
                    d1e = numpts(1)
                    d2s = startpts(2)
                    d2e = numpts(2)

                    CALL CD_RD_R8_BNDS( cdfid, bounds_id,
     .			  startpts, numpts, dtype, bname(:blen),
     .                    lineedg(iline)%ptr,  
     .                    d1s, d1e, d2s, d2e, status )
                    IF ( status .NE. merr_ok ) GOTO 5010

*     #2) read the highest upper box bound value (a single value)
                    startpts(1) = 2
                    startpts(2) = nsteps
                    numpts(1) = 1
                    numpts(2) = 1

                    d1s = startpts(1)
                    d1e = numpts(1)
                    d2s = startpts(2)
                    d2e = numpts(2)

                    CALL CD_RD_R8_BNDS( cdfid, bounds_id,
     .			  startpts, numpts, dtype,  bname(:blen),
     .                    tedge,  
     .                    d1s, d1e, d2s, d2e, status )
                    IF ( status .NE. merr_ok ) GOTO 5010
		    CALL PUT_LINE_COORD ( lineedg(iline)%ptr, nsteps+1, tedge)

* ... adjust the bounds values to the agg-wide "<units> since <T0>"
	            IF (need_T0_adjust) THEN
	               DO istep = 1, nsteps+1
		          tstep = GET_LINE_COORD (lineedg(iline)%ptr, istep)
	                  CALL PUT_LINE_COORD ( lineedg(iline)%ptr, istep, T0_ADJUST(tstep))
	               ENDDO
	            ENDIF
	         ENDIF
	         CALL CD_CLOSE_SET ( cdfid, status)
	         IF ( status .NE. merr_ok ) GOTO 5010
	      ENDDO    ! end of member file loop

* START: check over and finalize the aggregation time axis

* Get the ordering of the files according to the start time
           nsteps = 0
	   DO i = 1, nagfiles
	      memb_sort(i) = memb_tstep_start(i)
              nsteps = nsteps + memb_nsteps(i)
	   ENDDO
           CALL SORT_TSERIES_DSETS(nagfiles, memb_order, memb_sort)

* combine the coordinates for all lines in order
 
           CALL TM_ALLO_TMP_LINE(bigline, status)
	   CALL GET_LINE_DYNMEM (nsteps, bigline, status)
	   IF (status .NE. ferr_ok) GOTO 5100
	   line_dim(bigline) = nsteps

	   i = 1
	   ifile = memb_order(i)
	   iline = memb_tline(ifile)
           memb_nstep_start(ifile) = 1
	   sumstep = memb_nsteps(ifile)

           CALL COPY_LINE_COORDS (linemem(iline)%ptr, linemem(bigline)%ptr, sumstep)

* Copy the edges, (but not the uppermost one?  Or, as we fill them in, check the upper
* bound from each member set matches or not inconsistent with the lower of the next??
           IF (.NOT. need_midpoints) 
     .        CALL COPY_LINE_COORDS (lineedg(iline)%ptr, lineedg(bigline)%ptr, sumstep)

C check for overlap?
c	   tlast = GET_LINE_COORD (linemem(bigline)%ptr, istep)   ! last time coordinate
c	   elast = GET_LINE_COORD (lineedg(bigline)%ptr, istep+1) ! upper gridcell edge
C check for overlap???

	   DO i = 2, nagfiles
	      ifile = memb_order(i)
	      iline = memb_tline(ifile)
              memb_nstep_start(ifile) = sumstep + 1

	      DO istep = 1, memb_nsteps(ifile)
	         sumstep = sumstep + 1
	         tstep =  GET_LINE_COORD (linemem(iline)%ptr, istep)
	         CALL PUT_LINE_COORD ( linemem(bigline)%ptr, sumstep, tstep)

		 IF (.NOT.need_midpoints) THEN
	            tstep =  GET_LINE_COORD (lineedg(iline)%ptr, istep)
	            CALL PUT_LINE_COORD ( lineedg(bigline)%ptr, sumstep, tstep)
		 ENDIF

	      ENDDO

	   ENDDO

* Uppermost cell edge.

	   IF (.NOT.need_midpoints) THEN
	      tstep =  GET_LINE_COORD (lineedg(iline)%ptr, memb_nsteps(nagfiles)+1)
	      CALL PUT_LINE_COORD ( lineedg(bigline)%ptr, sumstep+1, tstep)
	   ENDIF

* deal with cell boundaries
* ... compute time midpoints if not supplied
	   IF (need_midpoints) 
     .        CALL TM_IRREGAX_MID( linemem(bigline)%ptr, lineedg(bigline)%ptr, nsteps )

* We have now gathered all the coordinates. Re-allocate taxis and put them there,
* so all the grid setup remains as is

	   CALL FREE_LINE_DYNMEM (taxis)
	   CALL GET_LINE_DYNMEM (nsteps, taxis, status)
	   IF (status .NE. ferr_ok) GOTO 5100

           CALL COPY_LINE_COORDS (linemem(bigline)%ptr, linemem(taxis)%ptr, sumstep)
           CALL COPY_LINE_COORDS (lineedg(bigline)%ptr, lineedg(taxis)%ptr, sumstep+1)
	   CALL TM_DEALLO_DYN_LINE(bigline)
	   CALL FREE_LINE_DYNMEM (bigline)

	   line_dim(taxis) = nsteps

* if the coordinates have been saved as irregular we must now
*  check to see if the coords may be regular after all

	   IF (nsteps .GT. 1) dfirst_delta = GET_LINE_COORD (linemem(taxis)%ptr, 2) -
     .           GET_LINE_COORD (linemem(taxis)%ptr, 1)

*  ... first sanity check monotonicity and bounds bracketing
	   IF (nsteps.EQ.1) GOTO 100

	   tt  = GET_LINE_COORD (linemem(taxis)%ptr, 1)
	   tedge = GET_LINE_COORD (lineedg(taxis)%ptr, 1)

* Use this double loop to report errors relative to the member datasets
	   istep = 1
	   DO i = 1, nagfiles
	      ifile = memb_order(i)
	      DO l = 1, memb_nsteps(ifile)  ! timestep within member files
	         IF (i.EQ.1 .AND. l.EQ.1) THEN 
	            CYCLE       ! 1st point on axis		
	         ELSE
	            istep = istep + 1
	            tn = GET_LINE_COORD (linemem(taxis)%ptr, istep)
	            tedge = GET_LINE_COORD (lineedg(taxis)%ptr, istep)
	            IF (tn .LE. tt) GOTO 5300
	            IF (tn .LE. tedge) GOTO 5400
	            tt = tn
		 ENDIF
	      ENDDO
	   ENDDO

	   ifile = memb_order(nagfiles)  ! for error message

*   check regularity of cell positions 

	   DO istep = 1, nsteps-1
	      delta = GET_LINE_COORD (linemem(taxis)%ptr, istep+1) - 
     .		      GET_LINE_COORD (linemem(taxis)%ptr, istep)
	      IF (.NOT.TM_DFPEQ_TOL(dfirst_delta, delta, depsilon) )
     .								GOTO 200
	   ENDDO

*   check regularity of cell bounds
	   DO istep = 1, nsteps-1
	      delta = GET_LINE_COORD (lineedg(taxis)%ptr, istep+1) - 
     .		      GET_LINE_COORD (lineedg(taxis)%ptr, istep)
	      IF (.NOT.TM_DFPEQ_TOL(dfirst_delta, delta, depsilon) )
     .								GOTO 200
	   ENDDO

* It's regular after all!  - change from irregular designation
 100	   CONTINUE
	   line_regular(taxis) = .TRUE.
	   line_start  (taxis) = GET_LINE_COORD (linemem(taxis)%ptr, 1) 
	   IF (nsteps .GT. 1) line_delta(taxis) = dfirst_delta
	   CALL FREE_LINE_DYNMEM (taxis)

* END: check over and finalize the time axis

* does this new time axis match an existing one?
 200	pre_exist = TM_FIND_LIKE_DYN_LINE( taxis )
	swap_axes = pre_exist .NE. unspecified_int4
	IF (swap_axes) THEN
	   ds_time_axis(dset_num) = pre_exist
	   IF (.NOT.line_regular(taxis) ) CALL FREE_LINE_DYNMEM (taxis)
	ENDIF

* correct all time-dependent variables in this dataset
*  ... the upper L limit was set based upon the first file, alone
*  ... and the time axis might just have been swapped for a pre-existing one
*      (ticket 2507, do not wipe out info needed for further grids once the
*       first grid found has its axis swapped.)

	DO ivar = 1, maxvars
	   IF ( ds_var_setnum(ivar) .EQ. dset_num ) THEN
	      gg  = ds_grid_number(ivar)
	      IF (grid_line(t_dim,gg).EQ.taxis .OR. grid_line(t_dim,gg).EQ.pre_exist) THEN
	         ds_grid_end(t_dim,ivar) = nsteps
	         IF (swap_axes) THEN
* ... was this grid modified in this loop an instant ago?
*     note: Shoud use the dset var LIST!   Super-inefficient nested loop
	            DO i = 1, ivar-1
	               IF ( ds_var_setnum(i) .EQ. dset_num ) THEN
	                  IF (ds_grid_number(i) .EQ. gg) GOTO 500 !already done
	               ENDIF
	            ENDDO
	            grid_line(t_dim,gg) = pre_exist
* ... "use" the pre-existing one; "un-use" the new one
	            CALL TM_USE_LINE(pre_exist)
	            CALL TM_DEALLO_DYN_LINE(taxis)
	            ds_time_axis(dset_num) = pre_exist
	         ENDIF
	      ENDIF
	   ENDIF
 500	   CONTINUE
	ENDDO
	IF (swap_axes) THEN
*          ??? should be FREE_LINE_DYNMEM ??? - but already done above
*	   IF (.NOT.line_regular(taxis)) CALL TM_DEALLO_DYN_LINE(taxis)
	   bigline = pre_exist
	ENDIF

* Is the axis we have created a monthly axis?  IF so store it as such.
* when and if we implement this go back to SVN for the code, and 
* modify it for dynamic-coordinate-memory.

* Should this axis be treated as a modulo axis?
	
	taxis = ds_time_axis(dset_num)
	axwwlen = 0.
        axwwlen = TM_WW_AXLEN(taxis)

	secsperyear = DBLE(cals_yeardays(agg_cal_id)) * (24.D0 * 60.D0 * 60.D0)
	bc_to_t0 = SECS_FROM_BC( line_t0(taxis), agg_cal_id, status)
	CALL TM_WW_AX_1_N(taxis, start, tstep)
	secs2start = bc_to_t0 + start*line_tunit(taxis)
	
* Set the conversion factor for true-month, months to days
	 grid_line(t_dim, dgrid_buff) = taxis
	 CALL TM_MONTH_TIME_FACTOR (dgrid_buff, true_month, timefac)
	IF (true_month) secs2start = secs2start/ timefac

	line_modulo(taxis) = .FALSE.
	line_modulo_len( taxis ) = 0.

	IF ( (secs2start .LE. secsperyear)
     .	 .AND. (axwwlen*line_tunit(taxis) .LE. secsperyear) ) THEN
	   line_modulo(taxis) = .TRUE.
	   line_modulo_len( taxis ) = timefac* secsperyear/line_tunit(taxis)

	ENDIF



* Free the temporary line memory used for member datasets

 5000	CONTINUE	
	DO i = 1, nagfiles
	   IF (memb_tline(i) .NE. unspecified_int4) THEN
	      CALL TM_DEALLO_DYN_LINE(memb_tline(i))
	      CALL FREE_LINE_DYNMEM (memb_tline(i))
	   ENDIF
	ENDDO

 	RETURN
 5010	CALL ERRMSG( ferr_TMAP_error, status, ' ', *5000 )
 5050	CALL ERRMSG( ferr_grid_definition, status,
     .		'first file of aggregation has no time axis '
     .		//memb_filename(1), *5000 )
 5100	CALL ERRMSG(ferr_insuff_memory,status,
     .	        'unable to define T aggregation axis', *5000)
 5300	lname = LEFINT(l, blen)
	CALL ERRMSG( ferr_grid_definition, status,
     .		'time axis is not monotonic at L='
     .		//lname(:blen)//' of file '//memb_filename(ifile), *5000 )
 5400	lname = LEFINT(l, blen)
	CALL ERRMSG( ferr_grid_definition, status,
     .   'Time bounds do not enclose time step coordinate at L='
     .		//lname(:blen)//' of file '//memb_filename(ifile), *5000 )

	END

	subroutine epictlim (xdate,xtime,xdat2,xtim2)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)epictlim.F	1.1    3/10/88
C**
C**
C***********************************************************************        C**
C**                 EPIC
C**
C***********************************************************************        C**
C**
c
c  Called by PLOT5's RDSEQ.  Input is starting xdate,xtime and
c  ending xdat2,xtim2 for EPIC time series.  Output is itmin,itmax
c  which is range of times for all time series currently in buffer.
c
c  Programmed by N. Soreide, May 86.
c
#ifdef unix
	include 'AXISL.INC'
	include 'TAXIS.INC'
	include 'DATA.INC'
#else
	include 'pplinc:axisl.inc'
	include 'pplinc:taxis.inc'
	include 'pplinc:data.inc'
#endif
c
	if (linen .eq. 1) then
c
c  First series in buffer
c
	    call epictimc (xdate,xtime,itmin)
	    if (iautot .eq. 1) itstrt=itmin
	    call epictimc (xdat2,xtim2,itmax)
	else
c
c  Find time range minimum
c
	    read (itmin,100) xd,xt
100	    format (f6.0,f4.0)
	    if (xdate .lt. xd) then
	        call epictimc (xdate,xtime,itmin)
	    else if (xdate.eq.xd .and. xtime.lt.xt) then
		call epictimc (xdate,xtime,itmin)
	    endif
c
c  Find time range maximum
c
	    read (itmax,100) xd,xt
	    if (xdat2 .gt. xd) then
		call epictimc (xdat2,xtim2,itmax)
	    else if (xdat2.eq.xd .and. xtim2.gt.xt) then
		call epictimc(xdat2,xtim2,itmax)
	    endif
	endif
	return
	end

	SUBROUTINE DEFINE_EF_AGGREGATE_GRID (agg_dset,
     .		tcoordname, nvars, vname, fvar, iline,
     .		tf_lag_t, ref_grid, agg_dim, member_sets, nsets)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Define ensemble or forecast axis and grid using that axis.
* For uvars, grid is set to
* unspecified_int4 when calling this. Will defer the grid check for later.

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP 
*
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V695+ 4/15 *acm* and *sh* -- added support for forecast aggregations
* V698 1/16 *sh* - support gappy and inconsistent length forecast members
* V698 3/16 *sh* - shift both lag axes and F-calendar to pts at low cell edge
* V710 *acm* 10/16 Ticket 2422: variables uvar_grid, uvar_data_type, uvar_aux_cat, 
*                  uvar_aux_var to be replaced with calls to LIST routines in NCF_Util.c 
* v71  12/16 *acm* Ticket 2158: working with true monthly time axes.
* v72   6/17 *acm* Variable type in aggregations should match what is in the member files

      IMPLICIT NONE
        include 'tmap_errors.parm'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xdset_info.cd_equiv'
        include 'xprog_state.cmn'
	include 'xtm_grid.cmn_text'  
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xfr_grid.cmn'
	include 'interp_stack.parm'
	include 'netcdf.inc'

* calling argument declarations:
	INTEGER agg_dset, nvars, fvar, iline, tf_lag_t, ref_grid,
     .		agg_dim, member_sets(*), nsets
	CHARACTER*(*) vname, tcoordname

* local variable declarations:
	LOGICAL	NC_GET_ATTRIB, ITS_FMRC_2DTIME, its_dynamic, itsa_uvar,
     .		has_edges, has_gaps, found_fvar, ef_ordered_time2d, true_month
	INTEGER STR_SAME, TM_LENSTR1,
     .		big_cx, igrid, idim, agg_grid, nv, type, ii, iset, slen, 
     .		ndim, vtype, i2, i, status,
     .		npts, nT, nF, lagF, ipt, iline2, memb_grid, it2d,
     .		gap_size, max_gap_size, l,
     .		axcalt, axlagf, gg, ipt1, ipte, fax,
     .		nv_dummy, igrid_dummy, vtype_dummy, num_indices,
     .		ef_time2d_dset, ef_time2d_grid, iaxis, fvartype
	REAL*8  TDEST_WORLD, TM_WORLD_AX, fdelta

* Getting info back from the attribute-handling structure
        INTEGER maxlen
        PARAMETER (maxlen = 128)
	CHARACTER*(maxlen) dimname, buff, name1
	INTEGER varid, t2did, tline, g2d, globalid, ref_id, attlen,
     .		attype, attoutflag
        REAL    attvals(10)

* initialize
	tline = unspecified_int4
	has_gaps = .FALSE.
	ef_ordered_time2d = .FALSE.
	ef_time2d_dset = ds_var_setnum(fvar)

* Get the file-variable type
        slen = TM_LENSTR1(vname)
	varid = 0
        CALL CD_GET_VAR_TYPE (ef_time2d_dset, varid, vname(:slen), 
     .                        fvartype, status)

* the 2D time variable in an E-aggregation of F-aggregations has special needs
* its grid should not have the agg axis 
	IF (agg_dim .EQ. E_dim) THEN
	   ef_ordered_time2d = ITS_FMRC_2DTIME(ef_time2d_dset, fvar)
	ENDIF

* Define aggregate grid

      igrid = unspecified_int4
      IF (ref_grid .NE. unspecified_int4) THEN
	 CALL TM_ALLO_TMP_GRID (igrid, status)
         IF (status .NE. ferr_ok) GOTO 5000

         DO 700 idim = 1, nferdims
            grid_line(idim, igrid) = grid_line(idim,ref_grid)
 700     CONTINUE
	 tline = grid_line(t_dim, igrid)
	 IF (ef_ordered_time2d) THEN
	    ef_time2d_grid = ref_grid  ! grid of fvar (w/out agg axis)
	 ELSE
	    grid_line(agg_dim, igrid) = iline
	 ENDIF
* for FMRC agg the shared T axis is a time lag 
	 IF (tf_lag_t .NE. unspecified_int4) THEN
	    grid_line(t_dim, igrid) = tf_lag_t 
	 ENDIF
* Make up a unique grid name for aggregate grid
         IF (agg_dim .EQ. e_dim) grid_name(igrid) = 'GEN'
         IF (agg_dim .EQ. f_dim) grid_name(igrid) = 'GFN'
! as temps all have same name -- duplicates are resolved in AGG_CLEAN_GRIDS
!         CALL TM_NEW_GRID_NAME( grid_name(igrid), buff )
!         grid_name(igrid) = buff

	 agg_grid = igrid
      ENDIF

* ds_var slot, fill with aggregate variable in aggregate dataset.
      itsa_uvar = .FALSE.
      DO 720 nv = 1, maxvars
	      IF ( STR_SAME(ds_var_code(nv),char_init) .EQ. 0 ) GOTO 725
 720	CONTINUE
 725	ds_var_setnum(nv)   = agg_dset
	CALL string_array_modify(ds_var_code_head, nv, 
     .         ds_var_code(fvar), LEN(ds_var_code(fvar)))
! ?? better: inherit these attibutes from members in SET_AGG_VAR_ATTS
	ds_var_title(nv)    = ds_var_title(fvar)
	IF ( ds_var_title(nv) .EQ. char_init128) 
     .       ds_var_title(nv)  = ds_var_code(nv)
	ds_var_titl_mod(nv) = ds_var_titl_mod(fvar)
	ds_var_units(nv)    = ds_var_units(fvar)
	ds_missing_flag(nv) = ds_missing_flag(fvar)	! was bad_val4
	ds_bad_flag(nv)     = ds_bad_flag(fvar)		! was bad_val4
	ds_var_type(nv)     = ds_var_type(fvar)
	cd_scale_factor(nv) = 1.
	cd_add_offset(nv)   = 0.
	cd_scaled(nv)       = .FALSE.

	IF (ref_grid .NE. unspecified_int4) THEN
	   ndim = 1
	   DO 730 idim = 1, nferdims
	      ds_grid_start(idim,nv)= ds_grid_start(idim,fvar)
	      ds_grid_end(idim,nv)  = ds_grid_end(idim,fvar)
	      ds_ordering(idim,nv)  = ds_ordering(idim,fvar)
	      IF (ds_ordering(ndim,fvar) .GT. 0) ndim = ndim + 1
 730	   CONTINUE
	   ds_grid_start(agg_dim,nv)= 1
	   ds_grid_end(agg_dim,nv)  = nsets
	   ds_ordering(ndim,nv)     = agg_dim  ! last dimension of the grid
* ... limit T axis length to the T length of the F aggregation
           IF (agg_dim.EQ.f_dim .AND. tf_lag_t.NE.unspecified_int4)
     .		ds_grid_end(t_dim,nv) = line_dim(tf_lag_t)

	   ds_grid_number(nv) = agg_grid
	ENDIF

* Type should be what is in the original file
	IF (ds_var_type(nv) .EQ. ptype_string) THEN
	   type = NCCHAR
	ELSE
	   type = fvartype
	ENDIF

* Hook the aggregated variable into the linked list structures
	CALL CD_ADD_VAR( agg_dset, vname, nvars, 
     .         ds_var_title(nv), ds_var_units(nv), type, 
     .         .FALSE., ds_bad_flag(nv), status)
        IF (nvars .EQ. 1) name1 = vname

* If this is a forecast aggregation, then the 2D time var has been defined (or 
* will be, just below). Add a coordinates attribute to variables in the FMRC 
* dataset which now have a 2D forecast-time coordinate variable. 
* Also add an attribute (name to be finalized), _ftime2d pointing to TIME2D
	     
	IF (agg_dim.EQ.f_dim .AND. grid_line(t_dim, agg_grid).NE.int4_init) THEN
	   buff = " "
	   slen = 0
	   DO 2200 idim = nferdims, 1, -1 
	      IF (grid_line(idim, agg_grid) .NE. int4_init) THEN
	         dimname = line_name(grid_line(idim, agg_grid))
		 IF (idim .EQ. t_dim) dimname = tcoordname
	         IF (slen.EQ.0) THEN
		    buff = dimname(:TM_LENSTR1(dimname) )
		 ELSE
 	            buff = buff(:slen)//' '//dimname(:TM_LENSTR1(dimname) )
                 ENDIF
		 slen = TM_LENSTR1(buff)
	      ENDIF
 2200	   CONTINUE
	   CALL CD_GET_VAR_ID (agg_dset, vname, varid, status)
	   slen = TM_LENSTR1(buff)
	   attoutflag = 1
	   attype = NCCHAR
	   CALL CD_PUT_NEW_ATTR (agg_dset, varid, 'coordinates', attype, 
     .             slen, attoutflag, buff, 0., status )

	   slen = TM_LENSTR1(tcoordname)
	   attoutflag = 1
	   attype = NCCHAR
	   CALL CD_PUT_NEW_ATTR (agg_dset, varid, '_ftime2d', attype, 
     .             slen, attoutflag, tcoordname, 0., status )

	ENDIF

* Add aggregate-grid info to the lists in aggregate datset and
* aggregate-grid list.   Mark user-variables with a grid number of -999
* Note if there is a LET/D variable that duplicates the name of a file var
* it is the file var that gets registered, even though the LET/D var has
* precedence during evaluation.  This allows for the possibility thatthe LET/D
* var may be cancelled. BUT it also allows the possibility that the grid
* of the fvar is unacceptable -- a chance of a crash for a pathological dataset
	dsets: DO ii = 1, nsets
	   iset = member_sets(ii)
* ... special hack for the TF_TIMES 2d time array when it is E-aggregated
	   IF (ef_ordered_time2d) THEN
	      vtype = cat_ef_time2d
	      CALL CD_ADD_AGG_VAR_INFO (agg_dset, vname, ii, vtype, 
     .                ef_time2d_dset, ef_time2d_grid, iline, fvar, status)
	      CYCLE dsets
	   ENDIF
	   found_fvar = .FALSE.
	   IF (iset .NE. pdset_dummy) THEN
* ... add this member data set as an fvar as part of this aggregated variable
	      DO nv = 1, maxvars
	         IF ( (ds_var_setnum(nv) .EQ. iset) .AND. 
     .                (STR_SAME(ds_var_code(nv), vname) .EQ. 0) ) THEN
	            igrid = ds_grid_number(nv)
		    vtype = cat_file_var
	            CALL CD_ADD_AGG_VAR_INFO (agg_dset, vname, ii, vtype, 
     .                iset, igrid, iline, nv, status)
	            found_fvar = .TRUE.
	            EXIT
	         ENDIF
	      ENDDO
	      IF (.NOT.found_fvar) THEN
* ... add this member data set as a LET/D as part of this aggregated variable
* ... optimize search using deleted_list_get_undel
!	         DO nv = 1, max_uvar      ! brute-force equivalent loop
		 CALL deleted_list_get_undel(uvar_num_items_head,
     .                              deleted_list_result(1),
     .                              max_uvar, num_indices )
	         DO i = 1, num_indices
	            nv = deleted_list_result(i)
	            IF ( uvar_num_items(nv) .EQ. uvar_deleted) CYCLE
	            IF ( (uvar_dset(nv) .EQ. iset) .AND. 
     .                   (STR_SAME(uvar_name_code(nv), vname) .EQ. 0) ) THEN
		       vtype = cat_user_var

		       CALL GET_SAVED_UVAR_GRID(nv, iset, igrid)
	               CALL CD_ADD_AGG_VAR_INFO (agg_dset, vname, ii, vtype, 
     .                   iset, igrid, iline, nv, status)
* ... bump the use count for this grid to protect it from being deleted if
*     the user changes the LET/D definition -- grid is needed during the
*     gather process (IS_STRIP & IS_AGGREGATE_GATHER).
*  ==> be sure to un-use (deallo) it when the aggregation gets canceled
*  ==> or if an error occurs prior to the complete initialization of this agg
	               CALL TM_USE_DYN_GRID(igrid)
	               EXIT
	            ENDIF
	         ENDDO
	      ENDIF
	   ELSE
* ... add the dummy data set as a part of this variable 
*     Note that the first member of the agg by common sense cannot be a dummy
	      CALL CD_ADD_AGG_VAR_INFO (agg_dset, vname, ii, vtype_dummy, 
     .             pdset_dummy, igrid_dummy, iline, nv_dummy, status)
	   ENDIF
* ... grab information from the first dataset to reuse with dummy datasets 
	   IF (ii .EQ. 1) THEN
*    ... OK_AS_AGG_VAR guarantees grid is always valid -- even for LET/D vars
	      IF (igrid .EQ. unspecified_int4) STOP 'DEFINE_EF_AGG grid err'
	      nv_dummy = nv
	      igrid_dummy = igrid
	      vtype_dummy = cat_file_var
	   ENDIF
	ENDDO dsets

 
************* FMRC setup **************************************************
* Define 2D time variable and then the special axes needed for FMRC dataset
* The code that follows should be executed only once for an FMRC aggregation
* We use the test of whether the tcoordname variable is already defined
* to bail out if the code has already been run 
* (cleaner code might be possible by removing the code below to a separate
* subroutine that is called just once before processing the individual vars
* of the aggregations)
	IF (agg_dim.EQ.f_dim .AND. tline.NE.unspecified_int4) THEN

	   CALL CD_GET_VAR_ID (agg_dset, tcoordname, t2did, status)
	   IF (status .EQ. ferr_ok) GOTO 4000  ! BAIL OUT -- already defined

	   igrid = 0
!	   CALL TM_NEXT_TMP_GRID (igrid, 760)   ! not needed
  760	   CALL TM_ALLO_TMP_GRID (igrid, status)
	   IF (status .NE. ferr_ok) GOTO 5000
	   CALL TM_NEW_GRID_NAME ( 'FTI', buff )
           grid_name(igrid) = buff
	   g2d = igrid

* ds_var slot, define TIME2D

	   DO 770 nv = 1, maxvars
	      IF ( STR_SAME(ds_var_code(nv),char_init) .EQ. 0 ) GOTO 775
 770	   CONTINUE
 775	   ds_var_setnum(nv)   = agg_dset
	   CALL string_array_modify(ds_var_code_head, nv, 
     .         tcoordname, LEN(tcoordname))
	   ds_var_title(nv)    = 'Forecast time step matrix'
	   ds_var_titl_mod(nv) = ' '
	   ds_var_type(nv)     = ptype_float
	   ds_missing_flag(nv) = bad_val4
	   ds_bad_flag(nv)     = bad_val4
	   cd_scale_factor(nv) = 1.
	   cd_add_offset(nv)   = 0.
	   cd_scaled(nv)       = .FALSE.
* ... re-assemble units = 'days since 15-jan-1982' from units and t0
	   slen = TM_LENSTR1(line_units(tline))
	   ds_var_units(nv)    = line_units(tline)(:slen) // ' since '
     .			      // line_t0(tline)

	   IF (g2d .NE. unspecified_int4) THEN
	      DO 780 idim = 1, nferdims
	         grid_line(idim, g2d) = 0   ! presumably =mpsnorm ??
	         ds_grid_start(idim,nv) = 1
	         ds_grid_end(idim,nv) = 1
	         ds_ordering(idim,nv) = 0
 780	      CONTINUE

	      grid_line(t_dim, g2d) = grid_line(t_dim,agg_grid)
	      grid_line(f_dim, g2d) = iline

	      ds_grid_start(t_dim,nv) = 1
	      ds_grid_end(t_dim,nv) = line_dim(tf_lag_t)  ! limit to agg dim
	      ds_ordering(1,nv) = t_dim

	      ds_grid_start(f_dim,nv) = 1
	      ds_grid_end(f_dim,nv) = nsets
	      ds_ordering(2,nv) = agg_dim

	      ds_grid_number(nv) = g2d
	   ENDIF

* ... save the sequence number of this variable, so we can cache it later
	   it2d = nv

	   type = NCDOUBLE
	   nvars = nvars + 1
      
	   CALL CD_ADD_VAR( agg_dset, tcoordname, nvars, 
     .         ds_var_title(nv), ds_var_units(nv), type, 
     .         .FALSE., ds_bad_flag(nv), status)

* Add the aggregate-grid info with CALL CD_ADD_AGG_VAR_INFO
* save the grid of the member datasets so we can get back the
* right time axis for each member, but set member dataset to 0
* because the 2d Time variable is not in the member sets.

	   DO 790 ii = 1, nsets
              iset = member_sets(ii)
	      DO 795 i2 = 1, maxvars
	         IF ( (ds_var_setnum(i2) .EQ. iset) .AND. 
     .                (STR_SAME(ds_var_code(i2), name1) .EQ. 0) ) 
     .            igrid = ds_grid_number(i2)
 795	      CONTINUE

	      iset = pagg_promotion_indicator_dset
	      vtype = cat_agg_f_var 
	      CALL CD_ADD_AGG_VAR_INFO (agg_dset, tcoordname, ii, vtype, 
     .             iset, igrid, iline, nv, status)
 790	   CONTINUE

* Give the time2D variable _CoordinateAxisType, _ftime2d and calendar atts

	   CALL CD_GET_VAR_ID (agg_dset, tcoordname, t2did, status)
	   attype = NCCHAR
	   CALL CD_PUT_NEW_ATTR (agg_dset, t2did, '_CoordinateAxisType', 
     .       attype, 4, attoutflag, 'Time', 0., status )
!	   CALL CD_PUT_NEW_ATTR (agg_dset, t2did, '_ftime2d', 
!     .       attype, 4, attoutflag, 'self', 0., status )
	   slen = TM_LENSTR1(line_cal_name(tline))
	   attoutflag = 1
	   attype = NCCHAR
	   CALL CD_PUT_NEW_ATTR (agg_dset, t2did, 'calendar', attype, 
     .       slen, attoutflag, line_cal_name(tline), 0., status )

* an FMRC needs 4 axes:
* 2 are the native axes of the data grids in compressed block FMRC form
*   - native T: a lag axis of time steps between each successive forecast
*   - native F: a calendar axis of times at which each run was initiated
* 2 are target regridding axes:
*   - target T: a calendar axis of the target times being forecast
*   - target F: a lag (lead) axis of time steps prior to the target time

* first define the two target axes
* Assemble the 2D time array in line_mem and call CD_MAKE_FMRC_AXES
* Save it at the start of available line storage memory
* Also save the time box edge positions in line_mem above the 2d array
* line_mem contents will be:  2d_times, 2d_lo_lims, hi_lim_of_last_time
	   nT = line_dim(grid_line(t_dim,agg_grid))
	   nF = line_dim(grid_line(f_dim,agg_grid))

	   npts = nT * nF
	   ipt1 = next_line_mem_pos
	   ipt  = ipt1
	   IF ((ipt+2*npts+1).GT.maxlinestore) GOTO 5100

* ... loop over the member data sets, copying their time steps
	   DO ii = 1, nsets
	      IF (member_sets(ii) .EQ. pdset_dummy) THEN
* ... insert a series of missing time values in the 2d time array
	         has_gaps = .TRUE.
	         DO i2 = 1, nT
	            line_mem(ipt)      = unspecified_val8
	            line_mem(ipt+npts) = unspecified_val8
	            ipt = ipt + 1
	         ENDDO
	      ELSE
* ... insert the series of time step values from this forecast
	         CALL CD_GET_AGG_VAR_INFO (agg_dset, vname, ii, 
     .                vtype, iset, memb_grid, iline2, nv, status)
	         IF (status .NE. ferr_ok) GOTO 5200
* ... iline2 should be equal to iline -- no importance; not used
* ... if the first member has a LET/D var, use time axis info from another var
	         IF (memb_grid .EQ. unspecified_int4) memb_grid = igrid_dummy
* set up to translate all times to the T0 of the first member
	         CALL TDEST_WORLD_INIT (memb_grid, ref_grid, t_dim, status)
	         IF (status .NE. ferr_ok) GOTO 5000 
	         DO i2 = 1, nT
	            line_mem(ipt) = TDEST_WORLD(i2, memb_grid, t_dim, box_middle)
	            line_mem(ipt+npts) =
     .				 TDEST_WORLD(i2, memb_grid, t_dim, box_lo_lim)
	            ipt = ipt + 1
	         ENDDO
	      ENDIF
	   ENDDO
	   line_mem(ipt1+2*npts) = TDEST_WORLD(nT, memb_grid, t_dim, box_hi_lim)

* ... if there were gaps in the forecast time array, fill 'em
*     always compute lagF - the number of time steps between forecasts
	   CALL FILL_FMRC_TIME_GAPS(has_gaps,
     .				    line_mem(ipt1),
     .				    line_mem(ipt1+npts),
     .				    nT,nF, lagF, status)
	   IF (status .NE. ferr_ok) GOTO 5000

* save the 2D time step array in c memory cache
* to be recovered as needed by FIND_MEM_VAR
	   CALL CACHE_FULL_ARRAY(line_mem(ipt1), npts,
     .						ds_var_c_cache_ptr(it2d))

!***** TEST ****
!	   CALL RECOVER_CACHED_ARRAY(line_mem(ipt1+72), npts,
!     .						ds_var_c_cache_ptr(it2d))


* make the FMRC regrid target axes: T-calendar and F-lag 
* (t2did still holds the id of the tccordname 2d time array)
	   has_edges = .TRUE.
	   CALL CD_MAKE_FMRC_AXES (agg_dset, has_edges, t2did, tcoordname,
     .			ds_var_type(nv), npts, nT, nF,
     .			axcalt, axlagf, status)
	   IF (status .NE. merr_ok) GOTO 5000

*****
* define the F calendar axis
	   ipt1 = next_line_mem_pos
	   IF ((ipt1+2*nF+1).GT.maxlinestore) GOTO 5100

! per Andrew W., this axis has been shifted 1/2 cell to the left
! so that the F coordinate lies on the low limit (initialization time) of
! the 1st time coordinate from each forecast
! Only the coordinates need be got from the FMRC members. The bounds are
! simply midpoints between them.

* Get the F-step values -- lower bounds of the L=1 cells
*   ... copying them from the axcalt axis
	   l = 1
	   DO ipt = ipt1, ipt1+nsets-1
	      line_mem(ipt) = TM_WORLD_AX(l, axcalt, box_lo_lim )
	      l = l + lagF
	   ENDDO

* Fill in the F-cell bounds just after the F-step values
* ... we will base the axis extreme edges on the average cell width --
*     only an approximate anwser for unequally spaced monthly time units
	   Fdelta = ( line_mem(ipt1+nsets-1) - line_mem(ipt1)) / (nsets-1) 
*   ... the lower limit of the first point
	   line_mem(ipt1+nsets) = line_mem(ipt1) - Fdelta/2
*   ... the midpoints between the F-steps
	   DO ipt = ipt1+1, ipt1+nsets-1
	      line_mem(ipt+nsets) = (line_mem(ipt) + line_mem(ipt-1))/2
	   ENDDO
*   ... the upper limit of the last point
	   line_mem(ipt1+2*nsets) = line_mem(ipt1+nsets-1) + Fdelta/2

! THIS GIANT BLOCK OF COMMENTED CODE used to populate the F axis coords
! It would get the timestep values of the L=1
! output of each model run, and the corresponding cell bounds
! It has been replaced with the much simpler block of code above

!* ... similar drill to above but need to do again, because cell bounds
!*     are needed in axis definition
!* ... loop over the member data sets, inserting the 1st time step of each
!*     Both the time point and one of the cell bounds needs to be inserted
!	   max_gap_size = 0
!	   DO ii = 1, nsets
!	      IF (member_sets(ii) .NE. pdset_dummy) THEN
!	         CALL CD_GET_AGG_VAR_INFO (agg_dset, vname, ii, 
!     .                vtype, iset, memb_grid, iline2, nv, status)
!	         IF (status .NE. ferr_ok) GOTO 5200
!	         CALL TDEST_WORLD_INIT (memb_grid, ref_grid, t_dim, status)
!	         IF (status .NE. ferr_ok) GOTO 5000 
!	         line_mem(ipt)    = TDEST_WORLD(1, memb_grid, t_dim,
!     .								box_middle )
!	         line_mem(ipt+nF) = TDEST_WORLD(1, memb_grid, t_dim,
!     .								box_lo_lim )
!	         gap_size = 0
!	      ELSE
!	         gap_size = gap_size + 1
!	         IF (gap_size .GT. max_gap_size) max_gap_size = gap_size
!	         CALL RECOVER_CACHED_2D_ARRAY_POINT(line_mem(ipt), 
!     .			nT, nF, 1, ii, ds_var_c_cache_ptr(it2d))
!	         IF (gap_size .EQ. 1) THEN
!*      ... the previous forecast is still active in the loop
!	            line_mem(ipt+nF) = TDEST_WORLD(1, memb_grid, t_dim,
!     .								 box_hi_lim )
!	         ELSE
!*      ... leave a gap in the time cell bounds -- fill in right after this
!	            line_mem(ipt+nF) = unspecified_val8
!	         ENDIF
!	      ENDIF
!	      ipt = ipt + 1
!	   ENDDO
!	   line_mem(ipt+nF) = TDEST_WORLD(1, memb_grid, t_dim, box_hi_lim )
!
!* ... if there were gaps wider than 1 missing forecast, we need to fill in
!*     some missing time cell bounds
!	   IF (max_gap_size .GT. 1) THEN
!	      ii = 1
!	      ipt  = ipt1 + nF
!	      DO WHILE (ii .LT. nsets)
!	         ii  = ii  + 1
!	         ipt = ipt + 1
!	         IF (line_mem(ipt) .EQ. unspecified_val8) THEN
!*       ... fill in a gap by linear interpolation
!*           note that this is exactly right for equally spaced coordinates
!*           but only approximate for monthly.  After improved support for 
!*           monthly
!	            gap_size = 0
!	            i2 = ii+1
!	            DO WHILE (i2 .LE. nsets+1)
!	               gap_size = gap_size + 1
!	               IF (line_mem(ipt+gap_size) .NE. unspecified_val8) EXIT
!	            ENDDO
!*       ... fill the gap
!	            DO i = ipt, ipt+gap_size-1
!	               line_mem(ipt) = line_mem(ipt-1)
!     .				+ (i-ipt+1)
!     .				* (line_mem(ipt+gap_size)-line_mem(ipt-1))
!     .				/ (gap_size+1)
!	            ENDDO
!	         ENDIF
!	      ENDDO
!	   ENDIF

* ... make the native F-calendar axis from the pointstime steps  in line_mem
	   CALL CD_MAKE_FMRC_FCAL_AXIS (agg_dset, iline, 
     .					nF, axcalt, status)
	   IF (status .NE. merr_ok) GOTO 5000

* ... put attribute _CoordinateAxistype = 'RunTime' onto the F-calendar axis
! cannot put attribute onto axis, because axis isn't in dataset List structure
! this is part of a larger problem that the newly created axes of aggregations
! have not yet been inserted into any List structures ... so their attributes
! cannot be manipulated
!          CALL CD_ADD_COORD_VAR( pdset_coord_vars, stuff (add new axis) ...
!          IF ( status .NE. ferr_ok ) GOTO 5600
!	   slen = TM_LENSTR1(line_name(iline))
!	   CALL CD_GET_VAR_ID (pdset_coord_vars,
!     .		'('//line_name(iline)(:slen)//')', varid, status)
!	   attoutflag = 1
!	   attype = NCCHAR
!	   CALL CD_PUT_NEW_ATTR (pdset_coord_vars, varid, '_CoordinateAxistype',
!     .		   attype, 7, attoutflag, 'RunTime', 0., status )

* ... assign global attributes pointing to the target regrid axes
*    (CF requires variable attributes, but they are helpful as globals, too)
	   CALL CD_GET_VAR_ID (agg_dset, '.', globalid, status)
	   slen = TM_LENSTR1(line_name(axcalt))
	   CALL CD_PUT_NEW_ATTR (agg_dset, globalid, '_cal_t_ax', attype, 
     .             slen, attoutflag, line_name(axcalt), 0., status )
	   CALL CD_PUT_NEW_ATTR (agg_dset, globalid, '_lag_f_ax', attype, 
     .             slen, attoutflag, line_name(axlagf), 0., status )

* make the regrid target axes non-temporary and set use counts to 1
	   CALL TM_RE_ALLO_TMP_LINE(axcalt)
	   CALL TM_USE_LINE(axcalt)
	   CALL TM_RE_ALLO_TMP_LINE(axlagf)
	   CALL TM_USE_LINE(axlagf)

	ENDIF  ! end of forecast aggregation special coordinate creation


* F-agg atts _cal_t_ax and _lag_f_a_x point to the special regridding axes
 4000	IF (agg_dim.EQ.f_dim) THEN
	   slen = TM_LENSTR1(line_name(axcalt))
	   attoutflag = 1
	   attype = NCCHAR
	   CALL CD_PUT_NEW_ATTR (agg_dset, varid, '_cal_t_ax', attype, 
     .             slen, attoutflag, line_name(axcalt), 0., status )
	   CALL CD_PUT_NEW_ATTR (agg_dset, varid, '_lag_f_ax', attype, 
     .             slen, attoutflag, line_name(axlagf), 0., status )
	ENDIF


 5000	RETURN
 5100	CALL ERRMSG(ferr_insuff_memory,status,
     .	        'unable to define forecast aggregation', *5000)
 5200	CALL ERRMSG(ferr_internal, status, 'define_ef_aggregate_grid!',
     .		 *5000)
 5300	CALL ERRMSG(ferr_aggregate_error, status,
     .		'no suitable file vars in 1st aggregation member', *5000)
	END

*
* fcat.F
*
* Ansley Manke
* May 2012
*
* This function returns the T values of the two variables,
* concatenated into one long list on an abstract t axis. Other 
* axes are unchanged.
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument''s axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE fcat_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CHARACTER*100 descrip

      WRITE (descrip, 100)
  100 FORMAT ('Concatenates the F values of two variables into one ',
     .        'list on an abstract F axis')
      CALL ef_set_desc(id, descrip)

* Tell Ferret to run the following instead, if the arguments are strings.
      CALL ef_set_alt_fcn_name(id, 'FCAT_STR')

      CALL ef_set_num_args(id, 2)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, ABSTRACT)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'First variable to concatenate')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'B')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'Second variable to concatenate')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


      SUBROUTINE fcat_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER nm

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nm = (arg_hi_ss(F_AXIS,ARG1) - arg_lo_ss(F_AXIS,ARG1) + 1) +  
     .     (arg_hi_ss(F_AXIS,ARG2) - arg_lo_ss(F_AXIS,ARG2) + 1)

      call ef_set_axis_limits(id, F_AXIS, 1, nm)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE fcat_compute(id, arg_1, arg_2, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      n = res_lo_ss(F_AXIS)
      DO 600 n1 = arg_lo_ss(F_AXIS,ARG1), arg_hi_ss(F_AXIS,ARG1)

         m = res_lo_ss(E_AXIS)
         DO 500 m1 = arg_lo_ss(E_AXIS,ARG1), arg_hi_ss(E_AXIS,ARG1)

         l = res_lo_ss(T_AXIS)
         DO 400 l1 = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)

         k = res_lo_ss(Z_AXIS)
         DO 300 k1 = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)

         j = res_lo_ss(Y_AXIS)
         DO 200 j1 = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)

         i = res_lo_ss(X_AXIS)
         DO 100 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)

            IF ( arg_1(i1,j1,k1,l1,m1,n1) .EQ. bad_flag(ARG1) ) THEN
               result(i,j,k,l,m,n) = bad_flag_result
            ELSE
               result(i,j,k,l,m,n) = arg_1(i1,j1,k1,l1,m1,n1)
            ENDIF

            i = i + res_incr(X_AXIS)
 100     CONTINUE

            j = j + res_incr(Y_AXIS)
 200     CONTINUE

            k = k + res_incr(Z_AXIS)
 300     CONTINUE

            l = l + res_incr(T_AXIS)
 400     CONTINUE
            m = m + res_incr(E_AXIS)
 500     CONTINUE

         n = n + res_incr(F_AXIS)
 600  CONTINUE


* concatenate in F - dont restart count of index N

      DO 610 n2 = arg_lo_ss(F_AXIS,ARG2), arg_hi_ss(F_AXIS,ARG2)

         m = res_lo_ss(E_AXIS)
         DO 510 m2 = arg_lo_ss(E_AXIS,ARG2), arg_hi_ss(E_AXIS,ARG2)

         l = res_lo_ss(T_AXIS)
         DO 410 l2 = arg_lo_ss(T_AXIS,ARG2), arg_hi_ss(T_AXIS,ARG2)

         k = res_lo_ss(Z_AXIS)
         DO 310 k2 = arg_lo_ss(Z_AXIS,ARG2), arg_hi_ss(Z_AXIS,ARG2)

         j = res_lo_ss(Y_AXIS)
         DO 210 j2 = arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS,ARG2)

         i = res_lo_ss(X_AXIS)
         DO 110 i2 = arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS,ARG2)

            IF ( arg_2(i2,j2,k2,l2,m2,n2) .EQ. bad_flag(ARG2) ) THEN
               result(i,j,k,l,m,n) = bad_flag_result
            ELSE
               result(i,j,k,l,m,n) = arg_2(i2,j2,k2,l2,m2,n2)
            ENDIF

            i = i + res_incr(X_AXIS)
 110     CONTINUE

            j = j + res_incr(Y_AXIS)
 210     CONTINUE

            k = k + res_incr(Z_AXIS)
 310     CONTINUE

            l = l + res_incr(T_AXIS)
 410     CONTINUE

            m = m + res_incr(E_AXIS)
 510     CONTINUE

         n = n + res_incr(F_AXIS)
 610     CONTINUE


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	SUBROUTINE SYMCNV(SYM,SYS)
C** 
C**    @(#)symcnv.f	1.2    5/26/88
C**
C**
C***********************************************************************
C**
C**		    PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C**	Subprogram called:
C**		CALL SYMCNV(SYM,SYS)
C**
C**	Parameters:
C**		SYM -- Symbol name (char*120)
C**		SYS -- Symbol is SYSTEM type (logical)
C**
C**	Description:
C**		Converts the symbol name to upper case and evaluates the
C**		form SYM(#) to SYM#.
C**
C**	History:
C**	    Written:
C**		15-DEC-1985	by Donald W. Denbo
C**	    Modified:
C**
C**

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*       *jd* 11.94 - modified for AIX port
*       Modification uses TM_NUMBER to determine if "value" is a number rather
*       than the ERR= branch of a READ which fails on AIX/xlf
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
* v580 *acm* 9/04 Longer strings: changes for multi-line labels; symbols may be *2048.
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long

        LOGICAL TM_NUMBER      

	LOGICAL SYS,SYS2
	CHARACTER SYM*(*),FRMT*120,SYM2*120,VALUE*2048
	INTEGER symlen
	PARAMETER (symlen = 120)
	SYS=.FALSE.
	IF(SYM(1:1).EQ.'*')THEN
	    SYS=.TRUE.
	    FRMT=SYM(2:)
	    SYM=FRMT
	ENDIF
200	I=INDEX(SYM,'(')+1
	J=INDEX(SYM,')')-1
	CALL UPPER(SYM,symlen)
	IF(I.EQ.1.OR.J.EQ.-1)RETURN
	if(i.eq.j)then

#ifdef AIX_XLF
            IF ( .NOT.TM_NUMBER(sym(i:j)) ) GOTO 100  ! TMAP mod
#endif
	    read(sym(i:j),'(i1)',err=100)jk
	    frmt=sym(i:j)
	else
	WRITE(FRMT,999)J-I+1
999	FORMAT('(E',I2.2,'.0)')
#ifdef AIX_XLF
            IF ( .NOT.TM_NUMBER(sym(i:j)) ) GOTO 100  ! TMAP mod
#endif
	READ(SYM(I:J),FRMT,ERR=100)X
	WRITE(FRMT,998)IFIX(X+0.5)
998	FORMAT(I2.2)
	endif
	IF(FRMT(1:1).EQ.'0')THEN
	    SYM(I-1:)=FRMT(2:)
	ELSE
	    SYM(I-1:)=FRMT
	ENDIF
	RETURN
100	SYM2=SYM(I:J)
	ILEN=J-I+1
	CALL CMLJST(SYM2,ILEN)
	SYS2=SYM2(1:1).EQ.'*'
	IF(SYS2)THEN
	    FRMT=SYM2(2:)
	    SYM2=FRMT
	ENDIF
	CALL GTSYM2(SYM2,VALUE,NC,SYS2,IER)
	IF(IER.NE.0)THEN
	    SYM(I:)=' '
	    RETURN
	ELSE
	    SYM(I:)=VALUE(:NC)
	    SYM(I+NC:)=')'
	ENDIF
	GOTO 200
	END

      SUBROUTINE GET_SAVED_UVAR_DTYPE( uvar, dset, uvdtype )
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*

* return the uvdtype that has been saved for this
* uvar (a LET expression), when evaluated in the given dset

* V710 10/16 *acm* new routine created to avoid the 2d uvar_data_type array
* V710 *acm* 10/16 Ticket 2422: variables uvar_grid, uvar_data_type, uvar_aux_cat, 
*                  uvar_aux_var to be replaced with calls to LIST routines in NCF_Util.c 

        IMPLICIT NONE
        include 'ferret.parm'
        include 'tmap_dims.parm'
        include 'xvariables.cmn'

* calling argument declarations
        INTEGER uvar, dset, uvdtype

* internal variable declarations
        INTEGER NCF_GET_UVAR_GRID, status,
     .          c_list_dset, context_dset, uvgrid

* c_list_dset  - dset value relevant in C LIST structures of NCF_Util.c
* context_dset - dset for which grid of this uvar has been determined

        IF ( uvar_dset(uvar) .GT. pdset_irrelevant) THEN
* ... LET/D= variable
          c_list_dset  = uvar_dset(uvar) ! the dset that owns this LET/D
          context_dset = uvar_dset(uvar) ! only one dset is possible
        ELSE
* ... global LET variable
          c_list_dset  = pdset_uvars  ! fake dataset of global uvars
          context_dset = dset
        ENDIF

* get the grid and dtype
        status = NCF_GET_UVAR_GRID( c_list_dset, uvar, context_dset, 
     .                              uvgrid, uvdtype)

* error return? Should we return the status??
        IF (status .EQ. atom_not_found) uvdtype = unspecified_int4

        RETURN
        END

	SUBROUTINE GTQUAL(LINE,ILEN,IER,IPOS)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)gtqual.F	1.2    5/26/88
C**
C**
C***********************************************************************
C**
C**		    PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C**	Subprogram called:
C**		CALL GTQUAL(LINE,ILEN,IER,IPOS)
C**
C**	Parameters:
C**		LINE -- Input line containing qualifiers (char*2048)
C**		ILEN -- Length of command portion
C**		IER  -- Error code =0 no error
C**       =3 qualifier not found
C**		IPOS -- Position of bad qualifier
C**
C**	Description:
C**		GTQUAL parses the command and qualifiers and sets the
C**		appropriate flag in the switch common blocks
C**
C**	History:
C**	    Written: 
C**		2-AUG-86	by Donald W. Denbo
C**	    Modified:
C**
C**
C       Mod *JD* 3.22.91 to permit use of / in command qualifiers for unix.
C       Not a complete fix as will screw up unix paths elsewhere in PPL
C* v552 *acm* 3/03 Longer strings: changes for multi-line labels

	INCLUDE 'SWITCH.INC'

	CHARACTER LINE*(*)
	LOGICAL TEST
C
C	SET DEFULTS
C
	IER=0
	IDONE=LNBLK(LINE,2048)
C       Mod to allow Ferret to work in Unix as is -- using "/" for
C       qualifiers -- test mode only J Davison 3.22.91  3 ifdefs commented out
C*JD*#ifdef unix
C	ILEN = INDEX(LINE,':')-1
C#else
	ilen = index(line,'/')-1
C#endif
	IF(ILEN.LE.0)ILEN=IDONE
	DO 10 I=1,NFLAGS
10	FLAG(I)=DEFLTS(I)
C
C	PARSE LINE
C
	N=0
	IS=1
C*JD*#ifdef  unix
C20	ISLSH = INDEX(LINE(IS:),':')+IS-1
C#else
20	islsh = index(line(is:),'/')+is-1
C#endif
	IF(ISLSH.GE.IS)THEN
C
C	QUALIFIER FOUND
C
C*JD*#ifdef unix
C	    IEND = INDEX(LINE(ISLSH+1:),':')+ISLSH
C#else
	    iend = index(line(islsh+1:),'/')+islsh
C#endif
	    IF(IEND.LE.ISLSH)IEND=IDONE+1
	    TEST=LINE(ISLSH+1:ISLSH+2).NE.'NO'
	    IF(TEST)THEN
		ISLSH=ISLSH+1
	    ELSE
		ISLSH=ISLSH+3
	    ENDIF
	    LLEN=IEND-ISLSH
C
C	CHECK FOR LEGAL QUALIFIER
C
	    DO 30 J=1,NFLAGS
	    IF(LLEN.LT.SMIN(J))GOTO 30
	    IF(LINE(ISLSH:IEND-1).EQ.SWITCH(J)(1:LLEN))GOTO 31
30	    CONTINUE
	    IER=3
	    IPOS=ISLSH
	    RETURN
31	    FLAG(J)=TEST
	    IS=IEND
	    GOTO 20
	ENDIF
	RETURN
	END

 	SUBROUTINE XEQ_SHADE

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute the SHADE command

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 8/2/88 - dummy template version
* revision 0.1 - 8.29.88 J Davison
*              - Modification of XEQ_CONTOUR version 0.9
* revision 0.2 - 9/21/88 - *sh* /NOLABEL processing changed:
*		 do_labels(in DISP_SET_UP) --> no_labels(in PUT_LABEL)
* revision 0.3 - 5/1/89  - PPL LEVELS not cleared for no_range if /LEVELS_SAME
*		 - this logic, do_key and vertical_key moved before /SET_UP
* V200:  5/19/89 - 4D symmetrical
*	  1/4/89 - using keys for labelling
*	 3/13/90 - check status from DISP_PREP
* Unix/RISC port - 2/26/91 - changed an INCLUDE statement to upper case
*       10/22/92 - removed dependence on shade_vars.cmn using PPLCMND(SHAKEY)
* V230:  11/9/92 - protect colors before doing a color overlay
*                - default for KEY is off on overlays
* V300:  3/11/93 - added /SPECTRUM=
* V301:	  1/7/94 - bug fix: (see DISP_DATA_SET_UP) must unprotect plot data
* 	 1/10/94 - change to DISP_SET_UP call to accomodate CONTOUR/PEN
* V312: 5/94 - array "memory" as a calling argument
* V320:   1/20/94 - changes to SAVE_FRAME call reflecting C-based procedures
* 12/96 *kob* - Linux Port - had to move variable assignments off of
*               declaration line.
* V450:  5/29/97 - added /NOAXES qualifier (useful in curvilinear plots)
* V491:  12.98   - added /PATTERN qualifier *jd*
* V510 12/99 *sh* - allow all-missing data plots
* V530: *acm*6/01 - add arguments is_logh, is_logv to DISP_SET_UP call.
*                  (only used for PLOT command)
*      *acm* 7/01 - Add /AXES=TOP,BOT,LEFT,RIGHT
*		    & call ax_on_off to implement /NOAXES.
*      *acm* 10/01  remove VMS includes
* V540 *acm*  2/02  restore persistence of PPL AXSET settings
* V541 *acm*  3/02  Make PPL AXSET settings persist, but not settings
*                   done with qualifiers /AXES= or /NOAXES
*      *acm*  4/02  If this is an overlay, and there is no valid data, 
*                   do not put "No Valid Data" across the middle of the plot.
*                   Instead (in disp_set_up) add this information to the
*                   variable name in the key below the plot.
* v541 *acm*  5/02 add option to control outline on the shade key boxes 
*                   /KEY=continuous
* V550: *acm*11/02 add argument is_shade to DISP_SET_UP call, allocate
*                  PPLUS memory for cells array in cellarray calls.
* V552: *acm* 5/03 add argument use_cell to DISP_SET_UP call, so it can be
*                  passed on to PPLUS
* v554: *acm* 2/04 add /HGRAT /VGRAT to draw optional graticule lines at tic marks
* v580 *acm* 6/15/04 In the workaround which does a PPL LEV command for data with
*                    a single value, need to give the PPL command the value with  
*                    more precision.
* V581 *acm* 5/05  fix bug 1249: /KEY=CONT. Need to use EQUAL_STR to get the
*                  argument to /KEY, then compare to see if it equals uppercase 'CON'
* V602 *acm* 11/06 Fix bug 1472: Where single-level color plot is requested, use levels (1) 
*                  setting rather than sending the data value; avoids precision problems.
* V603 *acm*  5/07 Fix bug 904: if SHADE/LINE, then set iautoc and NLEV2 to re-use the
*                  contour levels from the shade plot.
* V609: *acm* 2/08 - add SHADE/TRIM
* V6.11 4/08 *acm* Fixes for bug 1571; call to PPL_AXES_RESTORE moved to DISP_INIT
* V614  *acm* 10/08 - add new MODE NODATA_LAB to control the NO VALID DATA label.
*                  Put it on plots only when this mode is set.
* V6.2  *acm* 11/08Fix bug 1609: If the plot is an overlay then do not process /AXES=
*                  or /NOAXES. Axes are never drawn for overlays anyway.
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
*                  A time axis may be a T axis or F axis
* V6.85 *acm* 3/13 Fix ticket 2049; check we can open palette file
* V6.92 *acm* 6/14 New color /key options: any of /key=horizontal,centerlabel
* V697 *acm* 12/15 Fixes for bug 2327 move call of PPL_AXES_RESTORE back to end of plot routines
* v697 *acm* 12/15 Ticket 2331, add flag changed_key to common, to restore the color key
*                  style after a color plot and also after SHADE/SET; SHADE.
* V7    *acm* 6/16 Ticket 2434: command qualifiers /DEGMINSEC= /HALFSPAC
*                  DEGMINSEC=1 for Deg-Min axis labels, =2 for Deg-Min-Sec. Default = 1
*                  /HALFSPAC adds a half space between the degree sign and E/W or N/S
* V702 1/17 *sh* for trac enhancement #2369 -- dynamic memory management 
* V74  1/18 *am* for issue #1854, extra argument to DISP_SET_UP
* v744 *acm* 11/18 Issue 1786: graticule lines & axes drawn if PLOT/OVER/AXES given

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'plot_setup.parm'
	include 'slash.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'
	include 'xplot_setup.cmn'
        include 'parampl5_dat.decl'     ! with inclen
        include 'PARAMPL5.DAT'  ! with inclen
        include 'cont_inc.decl' ! with iautoc and nlev
        include 'CONT.INC'


* calling argument declarations:

* internal variable declarations:
	LOGICAL	  TM_HAS_STRING, 
     .            no_range, overlay, transpz, no_labels, do_key,
     .            spectrum, set_up, noaxes, axes, pattern, no_data,
     .		  is_logh, is_logv, is_shade, use_cell, inc_grid

	INTEGER	  TM_LENSTR1, TM_LENSTR, STR_UPCASE, status, slen, sp, patt,
     .		  ax1_work, ax2_work, i, nparm, num_it, 
     .		  loc, s1, s2, it_start(4), it_end(4), iax(4),
     .            density, i1, loch, locv
        INTEGER	  grid, mvx
	REAL	  only_val, aspect, val
	PARAMETER ( aspect = 0.0)			!kob 12/96

	CHARACTER TM_FMT*48, TM_INQ_PATH*2048, 
     .                  fname*128, buff*25, sfile*2048

* internal parameter declarations:
	LOGICAL		norm_dims_only, not_vector
	PARAMETER     ( norm_dims_only  = .FALSE.,
     .			not_vector	= .FALSE. )

* set up the graphics environment and get the data
	CALL START_PPLUS
	CALL DISP_DATA_SET_UP(  ax1_work, ax2_work, status )
	IF ( status .NE. ferr_ok ) GOTO 5100

* initialize
	overlay   = qual_given( slash_shad_over_plot ).GT.0 .AND. twodee_on
	no_labels = qual_given( slash_shad_nolabels  ).GT.0
	transpz   = qual_given( slash_shad_transpz   ).GT.0
        sp        = qual_given( slash_cont_spectrum  )
	set_up	  = qual_given( slash_shad_set_up    ).GT.0

* On overlays don't draw axes unless specificially requested with /AXES
* (e.g.so graticule lines can be overlaid on a final plot.)

	noaxes    = qual_given( slash_noaxes         ).GT.0
	IF (overlay) THEN
	   noaxes = .FALSE.
	   axes = .FALSE.
	ENDIF
	axes      = qual_given( slash_shad_axes      ).GT.0

	is_logh   = .FALSE.	  ! Not valid quals
	is_logv   = .FALSE.	  ! for shade
        spectrum  = sp .GT. 0 
        patt      = qual_given( slash_shad_pattern   )
        pattern   = patt .GT. 0
        shade_trim = qual_given( slash_shad_trim   ) .GT.0
	
	IF ( .NOT.overlay ) CALL DISP_INIT(no_labels,is_cx,num_uvars_in_cmnd)
* ... default orientation for YT and ZT contours has time on horizontal
	IF ( (plot_axis(2).EQ.t_dim .OR. plot_axis(2).EQ.f_dim) .AND. 
     .		plot_axis(1).NE.x_dim ) transpz = .NOT.transpz
	CALL DISP_PREP( status )
	IF ( status .NE. ferr_ok ) GOTO 5000

        is_shade = .TRUE.
        density = 0	! not used; vec/flow needs it in set up


* ... SHADE/hgrat[=dash or line] default is dash
*     hgrat line type: 0=tics only, 1=dash 2=line

	loch = qual_given(slash_shad_hgrat)

* ... SHADE/vgrat[=dash or line] default is dash
*     vgrat line type: 0=tics only, 1=dash 2=line

	locv = qual_given(slash_shad_vgrat)

        IF (loch .EQ. 0  .AND. locv .EQ. 0) THEN
           loch = qual_given(slash_shad_grat)
           locv = qual_given(slash_shad_grat)
        ENDIF

        CALL set_graticules(loch, locv, status)

* ... /DEGMINSEC[=1 or 2] Request deg/min or deg/min/sec axis labels
	loc = qual_given( slash_shad_dms )
        dms = 0
	IF ( loc .GT. 0) THEN
	   CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      val, status )
           dms = 1
           IF (val .GT. 0) THEN
	      dms = val
	      IF (dms .GT. 2) GOTO 5470
	   ENDIF
	ENDIF

* ... /HALFSPACE Request deg/min or deg/min/sec axis labels
	loc = qual_given( slash_shad_halfsp )
	IF ( loc .GT. 0) THEN
	   CALL EQUAL_VAL( cmnd_buff(qual_start(loc):qual_end(loc)),
     .			      val, status )
           lonlatspace = 1
           IF (val .GE. 0) lonlatspace = val
	ENDIF

* set up the axes and title and load the data into PPLUS
	inc_grid = set_up
	CALL DISP_SET_UP   (    
     .				not_vector,
     .				is_shade,
     .				use_cell,
     .				aspect,
     .				overlay,
     .				transpz,
     .				no_labels,
     .				no_range,
     .				only_val,
     .                          density,
     .				is_logh,
     .				is_logv,
     .				is_mr,
     .				num_uvars_in_cmnd,
     .				is_cx,
     .				is_uvar,
     .				workmem(ax1_work)%ptr,
     .				workmem(ax2_work)%ptr,
     .				-1, 			! auto pen select,
     .				inc_grid,
     .				set_up,
     .				status )
	   IF ( status .NE. ferr_ok ) GOTO 5000

* is there no valid input data?
           no_data =  no_range .AND. only_val.EQ.bad_val4

* PPLUS blows up setting auto contour levels if all data have same value
* But, do not let this be rounded off, or we cannot find the color when matching 
* this value in get_ndx, called by fillpol

* The initial fix below had precision problems when the value in only_val was
* of high precision, sometimes causing polygons to go unfilled (bug 1472).  
* Instead, make a ppl lev 1 setting, as is done in disp_prep.F

c	   IF ( no_range .AND. qual_given( slash_shad_lev_same ) .EQ. 0 )
c    .          CALL PPLCMD ( from, line, 0, 
c    .          'LEV () ('//TM_FMT(only_val, 8, 20, slen)//')' , 1, 1 )

	   IF ( no_range .AND. qual_given( slash_shad_lev_same ) .EQ. 0 ) THEN
              iautoc = 1  
c              nlev = 1
	   ENDIF

* default key
	   do_key =  (qual_given(slash_shad_key)  .GT. 0)
     .		.OR. ( (qual_given(slash_shad_line) .EQ. 0)
     .           .AND. .NOT.overlay
     .           .AND. .NOT.no_data )
	   IF (qual_given(slash_shad_nokey) .gt. 0) do_key = .FALSE.
	   
* Double check: is there no valid input data?
	   IF ( no_data ) do_key = .FALSE.

           IF ( do_key ) THEN
              CALL PPLCMD ( from, line, 0, 'SHAKEY 1,1', 1, 1 )

* ... /KEY[=continuous,horizontal,centerlabel ?

              loc = qual_given( slash_shad_key )
	      changed_key = .FALSE.

              IF ( loc .GT. 0) THEN
		 CALL EQUAL_STRING( cmnd_buff(qual_start(loc):qual_end(loc)),
     .                        buff, status )
                 IF ( status .NE. ferr_ok ) GOTO 5000
		 IF (TM_LENSTR(buff) .GT. 0) THEN
	         changed_key = .FALSE.
	         IF ( TM_HAS_STRING(buff, 'CON') ) THEN
                    changed_key = .TRUE.
                    CALL PPLCMD (from, line, 0, 'S_KEY 1', 1, 1 )
                 ENDIF
	         IF ( TM_HAS_STRING(buff, 'CEN') ) THEN
                    changed_key = .TRUE.
                    CALL PPLCMD (from, line, 0, 'S_KEY 2', 1, 1 )
                 ENDIF
	         IF ( TM_HAS_STRING(buff, 'HOR') ) THEN
                    changed_key = .TRUE.
                    CALL PPLCMD (from, line, 0, 'S_KEY 3', 1, 1 )
                 ENDIF
                 IF (.NOT. changed_key) GOTO 5460
		 ENDIF

              ENDIF

           ELSE
              CALL PPLCMD ( from, line, 0, 'SHAKEY 0,1', 1, 1 )

c when it's an overlay, 'No Valid Data' is part of the plot key,
c done in disp_set_up. If mode_nodata_lab is false then leave this off.

              IF (.NOT. overlay .AND. no_data .AND. mode_nodata_lab) 
     .                  CALL PUT_LABEL( ppl_movlab, 0.5, 0.5,
     .                  ppl_centered, letsize_title,
     .                  'No Valid Data',
     .                  lab_loc_axlen_times, lab_loc_axlen_times )
           ENDIF

* protect colors already on-screen before a color overlay
           IF ( overlay ) CALL PPL_SHASET( 'PROTECT' )

* save old and reset to new color spectrum if requested
           IF ( spectrum ) THEN
              CALL EQUAL_STR_LC( cmnd_buff(qual_start(sp):qual_end(sp)),
     .             fname, status )
              IF ( status .NE. ferr_ok ) RETURN
              IF ( fname .EQ. ' ' ) fname = 'default'
	      
	      slen = TM_LENSTR1(fname)
              sfile = TM_INQ_PATH (fname(:slen),'FER_PALETTE','.spk',
     .        	 .false.,status)
              IF (status .NE. ferr_ok) go to 5300 

              CALL PPL_SHASET( 'SAVE' )
              CALL PPL_SHASET( 'SPECTRUM='//fname(1:TM_LENSTR1(fname)) )
           ENDIF

* save old and set to new pattern if requested (a la spectrum)
           IF ( pattern ) THEN
              CALL EQUAL_STR_LC( 
     .             cmnd_buff(qual_start(patt):qual_end(patt)),
     .             fname, status )
              IF ( status .NE. ferr_ok ) RETURN
              IF ( fname .EQ. ' ' ) fname = 'default'
	      
	      slen = TM_LENSTR1(fname)
              sfile = TM_INQ_PATH (fname(:slen),'FER_PALETTE','.pat',
     .        	 .false.,status)
              IF (status .NE. ferr_ok) go to 5300 

              CALL PPL_PATSET( 'SAVE' )
              CALL PPL_PATSET( 'PATTERN='//fname(1:TM_LENSTR1(fname)) )
           ENDIF

* turn off axes? 
	IF ( noaxes ) THEN 
           DO 300 i = 1, 4
              iax(i) = 0
 300       ENDDO
        ENDIF

* turn on (one or more) axes? (7/11/01)

* ... PLOT/AXES=(TOP,BOTTOM,LEFT,RIGHT)
	IF ( axes ) THEN
           loc = qual_given( slash_shad_axes )
	   CALL EQUAL_STR_LC( cmnd_buff(qual_start(loc):qual_end(loc)),
     .                        buff, status )
           IF ( status .NE. ferr_ok ) GOTO 5000

	   IF ( buff .NE. ' ' ) THEN

* Get arguments, if any.  Otherwise turn on all axes
              slen = TM_LENSTR1(buff)
              s1 = 1
              s2 = slen
              IF (buff(1:1) .EQ. '(' )THEN
                  s1 = 2
                  s2 = slen-1
                  IF ( buff(slen:slen) .NE. ')' ) GOTO 5440
              ENDIF

              nparm = 4
              CALL parse_comma_list ( buff, s1, s2, nparm, 
     .             num_it, it_start, it_end, status)

              IF (status .EQ. ferr_ok .AND. it_start(1) .GT. it_end(1)) THEN	! /AXES=()
                 DO 400 i = 1, 4
                    iax(i) = 0
 400             ENDDO
              ELSE IF (status .NE. ferr_ok .OR. num_it .LT. nparm) THEN
                 GOTO 5440
              ELSE
                 DO 500 i = 1, nparm
                    READ (buff(it_start(i):it_end(i)), *) iax(i)
                    IF (iax(i) .LT. 0  .OR.  iax(i) .GT. 1) GOTO 5450
 500             CONTINUE
              ENDIF
           ELSE		! turn on all axes
	      DO 600 i = 1, 4
		 iax(i) = 1
 600	      CONTINUE
           ENDIF
              
	ENDIF

*  Turn off or on axes, including time axes.
        IF (axes .OR. noaxes) CALL ax_on_off (iax, overlay)

* /set_up only requested ?
	   IF ( set_up ) GOTO 1000

* shade it 
	   IF ( overlay ) THEN
	      if (qual_given(slash_shad_line) .gt. 0) then
		 CALL PPLCMD ( ' ', ' ', 0,
     .			'SHADE/OVER/' //ppl_wait//' ' , 1, 1 )
	         IF ( ppl_interrupted ) GOTO 1000
	         iautoc = 0 ! reuse levels from last plot
	         nlev = nlev2
		 CALL PPLCMD ( ' ', ' ', 0,
     .			'CONTOUR/OVER/' //ppl_wait//' ' , 1, 1 )
	      else
	         CALL PPLCMD ( ' ', ' ', 0,
     .			'SHADE/OVER/' //ppl_wait//' ' , 1, 1 )
	      end if
	   ELSE
              IF (use_cell) CALL PPLCMD (' ', ' ', 0, 'S_CELL 1', 1,1 )
	      if (qual_given(slash_shad_line) .gt. 0) then
		 CALL PPLCMD ( ' ', ' ', 0,
     .			'SHADE/LATCH/'//ppl_wait//' ', 1, 1 )
	         IF ( ppl_interrupted ) GOTO 1000
	         iautoc = 0 ! reuse levels from last plot
	         nlev = nlev2
		 CALL PPLCMD ( ' ', ' ', 0,
     .			'CONTOUR/OVER/' //ppl_wait//' ' , 1, 1 )
	      else
		 CALL PPLCMD ( ' ', ' ', 0,
     .			'SHADE/LATCH/'//ppl_wait//' ', 1, 1 )
	      end if
              IF (use_cell) CALL PPLCMD (' ', ' ', 0, 'S_CELL 0', 1,1 )

	   ENDIF

* protect the new colors and restore the original color spectrum
           IF ( spectrum ) THEN
              CALL PPL_SHASET( 'PROTECT' )
              CALL PPL_SHASET( 'SPECTRUM' )
           ENDIF

* restore the original pattern
           IF ( pattern ) THEN
              CALL PPL_PATSET( 'PATTERN' )
           ENDIF

* Mark the levels as set; if we used histogram levels it is 0

          IF (need_histo) iautoc = 1

* restore axes? (5/29/97  revised 3/2002

        IF ( axes .or. noaxes ) CALL PPL_AXES_RESTORE

* restore default key style?
        IF (changed_key ) CALL PPLCMD (from, line, 0, 'S_KEY 0', 1, 1 )

* interrupt occurred during plot ?
	IF ( ppl_interrupted ) GOTO 1000

* capture the bit map ? Well, OK...
	   IF ( qual_given( slash_shad_frame ) .GT. 0 ) THEN
	      CALL SAVE_FRAME( frame_file, "HDF", status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
	   ENDIF


* release the memory used for axis buffers
 1000 	CONTINUE
 

 	CALL FREE_WS_DYNMEM( ax1_work )
	CALL FREE_WS_DYNMEM( ax2_work )
	CALL UNPROTECT_CMND_DATA			! 1/94
 5100	RETURN

* error exits
 5000	GOTO 1000
 5300   CALL ERRMSG (ferr_file_not_found, status, 
     .          'unable to open "' //
     .	fname(:slen)//'.spk" to set plot colors or pattern.', *1000)
 5440	CALL ERRMSG( ferr_syntax, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .	'AXES[=(TOP,BOTTOM,LEFT,RIGHT)] takes 4 arguments or no argument', *1000 )
 5450	CALL ERRMSG( ferr_out_of_range, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .		'AXES arguments must be 0 or 1', *1000 )
 5460	CALL ERRMSG( ferr_syntax, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .		'Unrecognized argument to KEY command', *1000 )
 5470	CALL ERRMSG( ferr_syntax, status, 
     .		cmnd_buff(qual_start(loc):qual_end(loc))//pCR//
     .		'Argument to DegMinSec qualifier must be 1 or 2', *1000 )
	END

	SUBROUTINE XEQ_MESSAGE

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute the MESSAGE command

* MESSAGE text of message	- displays message, prompts for <CR> and waits
* MESSAGE/QUIET text		- displays message and waits for <CR>
* MESSAGE/CONTINUE text		- displays message and continues

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 9/10/86
* V230:  7/30/92 - bug fix: avoid final quote ("hello" comes out 'hello"' now)
*        8/11/92 - allow blank messages (blank line on output)
*       12/15/92 - pause w/ TM_FRIENDLY_READ so SGI's w/out backing store work
*                - and fix non-functioning of /QUIET on Unix (was .NOT.integer)
* V300:  4/22/93 - fix treatment of enclosing quotes with ALL_1_ARG
*	 6/16/93 - different prompts, etc. for GUI control
*		 - interrupt if GUI interrupt sequence is received
* V314	8/25/94 *kob* IBM port - need to correct syntax error
* V320: 12/29/94 - use SPLIT_LIST to redirect tty output for GUI
*	 2/28/95 - SPLIT_GUI_MESSAGE --> TM_SPLIT_MESSAGE
* Linux Port - *kob* 12/96 - had to put single quotes around hello 
*			     in comment up above - linux f90 freaked out.
*       10.28.98 *js* Don't pause for messages if in server mode
* V510 5/00 *sh* - added MESSAGE/JOURNAL
* V520 6/00 *sh* - added MESSAGE/ERROR
* V650 3/10 *acm - added MESSAGE//OUTFILE= /APPEND /CLOBBER

        IMPLICIT NONE
	include 'ferret.parm'
	include 'tmap_dims.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'
        include 'xrisc.cmn'
        include 'xgui.cmn'
	include 'xplot_state.cmn'

* local parameter declarations
	INTEGER		slash_continue, slash_quiet, slash_journal,
     .			slash_error, slash_file, slash_append, 
     .			slash_clobber
	PARAMETER     (	slash_continue	  = 1,
     .			slash_quiet	  = 2,
     .			slash_journal	  = 3,
     .			slash_error	  = 4,
     .			slash_file	  = 5,
     .			slash_append	  = 6,
     .			slash_clobber	  = 7)
	
* local variable declarations
	LOGICAl append, clobber
	INTEGER status, wsid, slen, rlen, sho_file
	PARAMETER (slen=1024)
	CHARACTER tmpfile*1024
#ifdef sun
        BYTE      ctmpfile(slen)
#else
        INTEGER*1 ctmpfile(slen)
#endif
	LOGICAL is_server

* treat all text as a single argument
	CALL ALL_1_ARG

* write the message if one has been supplied
	IF ( num_args .EQ. 1 ) THEN

* ... message to stderr
	   IF ( qual_given( slash_error ) .GT. 0 ) THEN
	      WRITE (err_lun, '(A)')
     .				cmnd_buff(arg_start(1):arg_end(1))
	      RETURN

* ... message to a named file
	   ELSEIF ( qual_given( slash_file ) .GT. 0 ) THEN
	      sho_file = qual_given( slash_file )
	      clobber = qual_given( slash_clobber ) .GT. 0
	      append = qual_given( slash_append ) .GT. 0

	      IF (sho_file .GT. 0) CALL OPEN_SHOW_FILE (show_lun, 
     .                       sho_file, clobber, append, status)
	      IF (status .NE. ferr_ok ) GOTO 2000
	      CALL TM_SPLIT_MESSAGE( show_lun,
     .				cmnd_buff(arg_start(1):arg_end(1)) )
     
* ... close the file
	      CLOSE ( UNIT = show_lun, ERR = 2000 )
	      
* ... message logged in journal file
	   ELSEIF ( qual_given( slash_journal ) .GT. 0 ) THEN
	      IF (mode_journal .AND. jrnl_lun.NE.unspecified_int4) THEN
	         WRITE (jrnl_lun, '(A)')
     .				cmnd_buff(arg_start(1):arg_end(1))
	         RETURN
	      ELSE
	         RETURN   ! journal file isn't open
	      ENDIF

* ... message to operator
	   ELSE
	      CALL TM_SPLIT_MESSAGE( ttout_lun,
     .				cmnd_buff(arg_start(1):arg_end(1)) )

	   ENDIF

* no message supplied. Just send a CR
        ELSEIF ( qual_given(slash_continue) .GT. 0
     .	 .AND.  .NOT.mode_gui ) THEN
              WRITE ( ttout_lun, * ) 
        ENDIF

* continue or wait ?
	IF ( qual_given( slash_continue ) .GT. 0
     .	.OR. mode_gui) RETURN

	IF  (IS_SERVER()) then

 	   return
	end if


* prompt for <CR> ?
* (in gui mode ferret_dispatch will send a flag back to the GUI)
	IF ( qual_given( slash_quiet ) .EQ. 0 ) THEN
	   WRITE ( ttout_lun, * ) ' Hit Carriage Return to continue'
	ENDIF

* wait for continue signal (use TM_FRIENDLY_READ 12/92)
        CALL TM_FRIENDLY_READ(' ', risc_buff, *1000 )

* check for interrupt character signal "^>"
 1000	IF ( risc_buff(1:1) .EQ. gui_char
     . .AND. risc_buff(2:2) .EQ. '>' )  CALL ERRMSG( ferr_interrupt,
     .						     status, ' ', *2000 )

 2000	RETURN
	END

	BLOCK DATA XALGEBRA_DATA

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* data initialization of algebraic operators and functions used by program GFDL

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 7/9/86
* revision 1.0 - 12/9/86 - *sh*
*		added functions and pseudo-variables
* revision 1.1 - 6/22/87 - added SHF and AAV
* revision 2.0 - 9/22/87 - eliminated geog* --> into XCONTEXT
* revision 2.1 - 6/23/88 - added FAV - filling missing data with average
* revision 2.2 - 1/3/89  - added regridding transformations
* V200:  6/6/89-8/3/89 - added XY integrating, binomial smoothing, IGNORE0, EXP
*	11/22/89 - reworked expression syntax for in-fix notation
*	 1/12/90 - added info about the arguments of transformations
*	 3/19/90 - added ATAN,ATAN2,ASIN,ACOS
*	 3/29/90 - added RANDU,RANDN
* for Unix/RISC port 9/91 - added @SHN,@SPZ,@SWL
*                         - "integ'd" --> "integ" to avoid "'" in PPLUS
* V230: 1/3/92 - added @SUM, @WEQ, @RSUM, @VAR, @NBD, @NGD
*              - fleshed out trans_title for use with SHOW TRANSFORMATIONS
*      3/23/92 - added @FLN and @FNR
*       7/2/92 - changed @FLN and @FNR defaults to 1 (edge) from 3 (window)
*       8/5/92 - added new functions RHO and THETA
*      8/22/92 - added @ASN regridding
*     10/22/92 - RHO --> RHO_UN, THETA --> THETA_UN
* V300: 9/2/93 - reordered transforms for SHOW TRANS and QUERY TRANS
* V320:  11/94 - added DAYS1900 function
* V420:  10/95 - added regridding transforms: min,max,var,ngd,nbd,npt,sum 
*	 11/95 - added modulo regridding: "@MOD"
* V430:   7/96 - incorporate 4D transformations: AVE, VAR, DIN, NDG, NBD
* V450:   7/97 - added function descriptions
* V455    9/97 - added transforms @CDA,CDB,CIA,CIB
* V490   10/97 - added regrid transform @XACT (removed unimplemented g=@NRS)
*	       - changed title for g=@ASN from "1 to 1" to "index assn"
* V491    4/98 - *kob* modified documentation order for function days1900
*                      to correct year-month-day
* V500   10/98 - *jc* added @RDC
*         1/00 - *acm* Change alg_fcn_descr to "since 1900" (was 1990)
*         1/00 - *acm* Corrected the order of argument listing for THETA_FO to 
*                      match how the function is actually called.
* V530   1/01 - *sh* - added XBOXLO, XBOXHI and family ...
*	 3/01 - *sh* - adde g=ax@nrst
* V533   6/01 - *sh* - added transformation @EVNT
* 2/03 *kob* - g77 port - g77 will not allow intrinsic functions in PARAMETER
*                         statements.  use character constant instead
* V554 1/04  *acm* - additions for /RANGE repeat loop control; alg_cvar, countervar_name
* V603 5/07  *acm* - added MODNBD modulo regridding statistic
* V66+ 4/10  *acm* - change pressure to reference pressure for RHO_UN as 
*                    suggested by James Orr and Billy Kessler
* V6.7 1/11  *acm* - fix ticket 1788, initializing alg_trans_*
* V671  6/11 *acm*  New 2D linear xy regridding, fixing ticket 1862
* V671 7/11  *acm* Ticket 1868 IFV - masking expressions with ifValid, treating 
*		   zero as valid. 
*      2/12  *kms* Add M, N, E, F, EBOX, FBOX, EBOXLO, FBOXLO, EBOXHI, and FBOXHI
*                  pseudo-variables
*       *acm* 4/12 Add new MODE FOURDEE to allow E,F,M,N,etc as user-vars
* V690 12/13 *sh* added auxiliary regridding transforms
* v695+ 3/15 *sh* added pauxrgrd_fmrc for T-F orthoganalization
* V695 *acm* 10/15 Fix #2319: @STD as a multi-D transform
* V696 *acm* 11/15 Added @BIN and @NBIN regridding transforms
* V696 *acm8 11/15 Clarify descriptions for @BIN, @NBIN, @AVE, @NGD, @SUM regridding
* V720: 6/17 *acm* Ticket 2346: new @IIN regridding transform

        IMPLICIT NONE
	include	'ferret.parm'
	include	'xalgebra.cmn'

	CHARACTER*1	rubout
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( rubout = o'177' )
#else
	PARAMETER     ( rubout = CHAR(127) )
#endif
	INTEGER	i

* single character operators:
	DATA alg_op(  1 ) / '+' /,
     .	     alg_op(  2 ) / '-' /,
     .	     alg_op(  3 ) / '*' /,
     .	     alg_op(  4 ) / '/' /,
     .	     alg_op(  5 ) / '^' /,
     .	     alg_op(  6 ) / 'AND' /,
     .	     alg_op(  7 ) / 'OR' /,
     .	     alg_op(  8 ) / 'GT' /,
     .	     alg_op(  9 ) / 'GE' /,
     .	     alg_op( 10 ) / 'LT' /,
     .	     alg_op( 11 ) / 'LE' /,
     .	     alg_op( 12 ) / 'EQ' /,
     .	     alg_op( 13 ) / 'NE' /,
     .	     alg_op( 14 ) / '%' /,	! undefined
     .	     alg_op( 15 ) / '%' /,	! undefined
     .	     alg_op( 16 ) / '%' /,	! undefined
     .	     alg_op( 17 ) / '%' /,	! undefined
     .	     alg_op( 18 ) / '%' /	! undefined

* functions:
	DATA alg_fcn		(  1 ) / 'EXP'      /,
     .	     alg_num_fcn_args	(  1 ) / 1 	    /,
     .	     alg_fcn_descr	(  1 ) / 'exponential e(X)' 	    /,
     .	     alg_fcn_arg_ptr    (  1 ) / 1	    /,
     .	     alg_arg_name     (  1 ) / 'X'	    /,
     .	     alg_arg_units    (  1 ) / ' '	    /,
     .	     alg_arg_descr    (  1 ) / ' '	    /,
     .	     alg_fcn		(  2 ) / 'LOG'      /,
     .	     alg_num_fcn_args	(  2 ) / 1 	    /
     .	     alg_fcn_descr	(  2 ) / 'base 10 log(X)' 	    /,
     .	     alg_fcn_arg_ptr    (  2 ) / 2	    /,
     .	     alg_arg_name     (  2 ) / 'X'	    /,
     .	     alg_arg_units    (  2 ) / ' '	    /,
     .	     alg_arg_descr    (  2 ) / ' '	    /,
     .	     alg_fcn		(  3 ) / 'MAX'      /,
     .	     alg_num_fcn_args	(  3 ) / 2	    /,
     .	     alg_fcn_descr	(  3 ) /
     .			'point-by-point greater of A and B' 	    /,
     .	     alg_fcn_arg_ptr    (  3 ) / 3	    /,
     .	     alg_arg_name     (  3 ) / 'A'	    /,
     .	     alg_arg_units    (  3 ) / ' '	    /,
     .	     alg_arg_descr    (  3 ) / ' '	    /,
     .	     alg_arg_name     (  4 ) / 'B'	    /,
     .	     alg_arg_units    (  4 ) / ' '	    /,
     .	     alg_arg_descr    (  4 ) / ' '	    /,
     .       alg_fcn		(  4 ) / 'MIN'      /,
     .	     alg_num_fcn_args 	(  4 ) / 2	    /,
     .	     alg_fcn_descr	(  4 ) /
     .			'point-by-point lesser of A and B' 	    /,
     .	     alg_fcn_arg_ptr    (  4 ) / 5	    /,
     .	     alg_arg_name     (  5 ) / 'A'	    /,
     .	     alg_arg_units    (  5 ) / ' '	    /,
     .	     alg_arg_descr    (  5 ) / ' '	    /,
     .	     alg_arg_name     (  6 ) / 'B'	    /,
     .	     alg_arg_units    (  6 ) / ' '	    /,
     .	     alg_arg_descr    (  6 ) / ' '	    /,
     .       alg_fcn		(  5 ) / 'INT'      /,
     .	     alg_num_fcn_args	(  5 ) / 1	    /,
     .	     alg_fcn_descr	(  5 ) / 'truncate to integer' 	    /,
     .	     alg_fcn_arg_ptr    (  5 ) / 7	    /,
     .	     alg_arg_name     (  7 ) / 'X'	    /,
     .	     alg_arg_units    (  7 ) / ' '	    /,
     .	     alg_arg_descr    (  7 ) / ' '	    /,
     .       alg_fcn		(  6 ) / 'ABS'      /,
     .	     alg_num_fcn_args	(  6 ) / 1	    /,
     .	     alg_fcn_descr	(  6 ) / 'absolute value' 	    /,
     .	     alg_fcn_arg_ptr    (  6 ) / 8	    /,
     .	     alg_arg_name     (  8 ) / 'X'	    /,
     .	     alg_arg_units    (  8 ) / ' '	    /,
     .	     alg_arg_descr    (  8 ) / ' '	    /,
     .       alg_fcn		(  7 ) / 'SIN'      /,
     .	     alg_num_fcn_args	(  7 ) / 1 	    /,
     .	     alg_fcn_descr	(  7 ) / ' ' 	    /,
     .	     alg_fcn_arg_ptr    (  7 ) / 9	    /,
     .	     alg_arg_name     (  9 ) / 'theta'	    /,
     .	     alg_arg_units    (  9 ) / 'radians'	    /,
     .	     alg_arg_descr    (  9 ) / 'angle'	    /,
     .       alg_fcn		(  8 ) / 'COS'      /,
     .	     alg_num_fcn_args	(  8 ) / 1 	    /,
     .	     alg_fcn_descr	(  8 ) / ' ' 	    /,
     .	     alg_fcn_arg_ptr    (  8 ) / 10	    /,
     .	     alg_arg_name     ( 10 ) / 'theta'	    /,
     .	     alg_arg_units    ( 10 ) / 'radians'	    /,
     .	     alg_arg_descr    ( 10 ) / 'angle'	    /,
     .       alg_fcn		(  9 ) / 'TAN'      /,
     .	     alg_num_fcn_args	(  9 ) / 1 	    /,
     .	     alg_fcn_descr	(  9 ) / ' ' 	    /,
     .	     alg_fcn_arg_ptr    (  9 ) / 11	    /,
     .	     alg_arg_name     ( 11 ) / 'theta'	    /,
     .	     alg_arg_units    ( 11 ) / 'radians'	    /,
     .	     alg_arg_descr    ( 11 ) / 'angle'	    /,
     .       alg_fcn		( 10 ) / 'LN'       /,
     .	     alg_num_fcn_args	( 10 ) / 1 	    /,
     .	     alg_fcn_descr	( 10 ) / 'natural logarithm(X)'     /,
     .	     alg_fcn_arg_ptr    ( 10 ) / 12	    /,
     .	     alg_arg_name     ( 12 ) / 'X'	    /,
     .	     alg_arg_units    ( 12 ) / ' '	    /,
     .	     alg_arg_descr    ( 12 ) / ' '	    /
	DATA
     .       alg_fcn		( 11 ) / 'MOD'      /,
     .	     alg_num_fcn_args	( 11 ) / 2 	    /,
     .	     alg_fcn_descr	( 11 ) / 'modulo A using base B'  /,
     .	     alg_fcn_arg_ptr    ( 11 ) / 13	    /,
     .	     alg_arg_name     ( 13 ) / 'A'	    /,
     .	     alg_arg_units    ( 13 ) / ' '	    /,
     .	     alg_arg_descr    ( 13 ) / ' '	    /,
     .	     alg_arg_name     ( 14 ) / 'B'	    /,
     .	     alg_arg_units    ( 14 ) / ' '	    /,
     .	     alg_arg_descr    ( 14 ) / ' '	    /,
     .       alg_fcn		( 12 ) / 'MISSING'  /,
     .	     alg_num_fcn_args	( 12 ) / 2 	    /,
     .	     alg_fcn_descr	( 12 ) /
     .				'substitute B where A is missing' /,
     .	     alg_fcn_arg_ptr    ( 12 ) / 15	    /,
     .	     alg_arg_name     ( 15 ) / 'A'	    /,
     .	     alg_arg_units    ( 15 ) / ' '	    /,
     .	     alg_arg_descr    ( 15 ) / ' '	    /,
     .	     alg_arg_name     ( 16 ) / 'B'	    /,
     .	     alg_arg_units    ( 16 ) / ' '	    /,
     .	     alg_arg_descr    ( 16 ) / ' '	    /,
     .       alg_fcn		( 13 ) / 'IGNORE0'  /,
     .	     alg_num_fcn_args	( 13 ) / 1 	    /,
     .	     alg_fcn_descr	( 13 )
     .				/ 'substitute missing value for zeros' /,
     .	     alg_fcn_arg_ptr    ( 13 ) / 17	    /,
     .	     alg_arg_name     ( 17 ) / 'X'	    /,
     .	     alg_arg_units    ( 17 ) / ' '	    /,
     .	     alg_arg_descr    ( 17 ) / ' '	    /,
     .       alg_fcn		( 14 ) / 'ATAN'	    /,
     .	     alg_num_fcn_args	( 14 ) / 1 	    /,
     .	     alg_fcn_descr	( 14 ) / 'arctan(X) in radians'    /,
     .	     alg_fcn_arg_ptr    ( 14 ) / 18	    /,
     .	     alg_arg_name     ( 18 ) / 'X'	    /,
     .	     alg_arg_units    ( 18 ) / ' '	    /,
     .	     alg_arg_descr    ( 18 ) / ' '	    /,
     .       alg_fcn		( 15 ) / 'ATAN2'    /,
     .	     alg_num_fcn_args	( 15 ) / 2 	    /,
     .	     alg_fcn_descr	( 15 ) /
     .			'arctan(A/B) in radians,  -pi<result<=pi'   /,
     .	     alg_fcn_arg_ptr    ( 15 ) / 19	    /,
     .	     alg_arg_name     ( 19 ) / 'A'	    /,
     .	     alg_arg_units    ( 19 ) / ' '	    /,
     .	     alg_arg_descr    ( 19 ) /
     .		'if A>0 result>0, if A=0 B determines result'	    /,
     .	     alg_arg_name     ( 20 ) / 'B'	    /,
     .	     alg_arg_units    ( 20 ) / ' '	    /,
     .	     alg_arg_descr    ( 20 ) /
     .	'if A=0&B>0 res=0, if A=0&B<0 res=pi, if B=0 ABS(res)=pi/2' /,
     .       alg_fcn		( 16 ) / 'ASIN'     /,
     .	     alg_num_fcn_args	( 16 ) / 1 	    /,
     .	     alg_fcn_descr	( 16 ) / 'arcsin(X) in radians'     /,
     .	     alg_fcn_arg_ptr    ( 16 ) / 21	    /,
     .	     alg_arg_name     ( 21 ) / 'X'	    /,
     .	     alg_arg_units    ( 21 ) / ' '	    /,
     .	     alg_arg_descr    ( 21 ) /
     .			'ABS(X) must be less than or equal to 1'    /,
     .       alg_fcn		( 17 ) / 'ACOS'     /,
     .	     alg_num_fcn_args	( 17 ) / 1 	    /
     .	     alg_fcn_descr	( 17 ) / 'arccos(X) in radians'     /,
     .	     alg_fcn_arg_ptr    ( 17 ) / 22	    /,
     .	     alg_arg_name     ( 22 ) / 'X'	    /,
     .	     alg_arg_units    ( 22 ) / ' '	    /,
     .	     alg_arg_descr    ( 22 ) /
     .			'ABS(X) must be less than or equal to 1'    /,
     .       alg_fcn		( 18 ) / 'RANDU'    /,
     .	     alg_num_fcn_args	( 18 ) / 1 	    /
     .	     alg_fcn_descr	( 18 )
     .		/ 'random uniform [0,1] seeded from 1st value of A' /,
     .	     alg_fcn_arg_ptr    ( 18 ) / 23	    /,
     .	     alg_arg_name     ( 23 ) / 'A'	    /,
     .	     alg_arg_units    ( 23 ) / ' '	    /,
     .	     alg_arg_descr    ( 23 ) /
     .			'field of random values will have shape of A'/,
     .       alg_fcn		( 19 ) / 'RANDN'    /,
     .	     alg_num_fcn_args	( 19 ) / 1 	    /,
     .	     alg_fcn_descr	( 19 )
     .			/ 'random normal seeded from 1st value of A' /,
     .	     alg_fcn_arg_ptr    ( 19 ) / 24	    /,
     .	     alg_arg_name     ( 24 ) / 'A'	    /,
     .	     alg_arg_units    ( 24 ) / ' '	    /,
     .	     alg_arg_descr    ( 24 ) /
     .			'field of random values will have shape of A'/
	DATA
     .       alg_fcn		( 20 ) / 'RHO_UN'   /,
     .	     alg_num_fcn_args	( 20 ) / 3 	    /,
     .	     alg_fcn_descr	( 20 ) /
     .		'UNESCO state equation (density) for ocean H2O (kg/m^3)'/,
     .	     alg_fcn_arg_ptr    ( 20 ) / 25	    /,
     .	     alg_arg_name     ( 25 ) / 'salt'	    /,
     .	     alg_arg_units    ( 25 ) / 'psu'	    /,
     .	     alg_arg_descr    ( 25 ) / 'salinity'   /,
     .	     alg_arg_name     ( 26 ) / 'temp'	    /,
     .	     alg_arg_units    ( 26 ) / 'deg. C'	    /,
     .	     alg_arg_descr    ( 26 ) / 'temperature'/,
     .	     alg_arg_name     ( 27 ) / 'p'	    /,
     .	     alg_arg_units    ( 27 ) / 'decibars'   /,
     .	     alg_arg_descr    ( 27 ) / 'reference pressure'   /,
     .       alg_fcn		( 21 ) / 'THETA_FO' /,
     .	     alg_num_fcn_args	( 21 ) / 4 	    /
     .	     alg_fcn_descr	( 21 ) /
     .			'Fofonoff (1977) potential temperature'/,
     .	     alg_fcn_arg_ptr    ( 21 ) / 28	    /,
     .	     alg_arg_name     ( 28 ) / 'salt'	    /,
     .	     alg_arg_units    ( 28 ) / 'psu'	    /,
     .	     alg_arg_descr    ( 28 ) / 'salinity'   /,
     .	     alg_arg_name     ( 29 ) / 'temp'	    /,
     .	     alg_arg_units    ( 29 ) / 'deg. C'	    /,
     .	     alg_arg_descr    ( 29 ) / 'temperature'/,
     .	     alg_arg_name     ( 30 ) / 'p'	    /,
     .	     alg_arg_units    ( 30 ) / 'decibars'   /,
     .	     alg_arg_descr    ( 30 ) / 'pressure'   /,
     .	     alg_arg_name     ( 31 ) / 'ref'	    /,
     .	     alg_arg_units    ( 31 ) / 'decibars'   /,
     .	     alg_arg_descr    ( 31 ) / 'reference pressure' /,
     .       alg_fcn		( 22 ) / 'DAYS1900'  /,
     .	     alg_num_fcn_args	( 22 ) / 3 	    /
     .	     alg_fcn_descr	( 22 ) 
     .	     / 'days elapsed since 1-Jan-1900 (standard calendar)'/,
     .	     alg_fcn_arg_ptr    ( 22 ) / 32	    /,
     .	     alg_arg_name     ( 32 ) / 'year'	    /,
     .	     alg_arg_units    ( 32 ) / ' '	    /,
     .	     alg_arg_descr    ( 32 ) / ' '	    /,
     .	     alg_arg_name     ( 33 ) / 'month'	    /,
     .	     alg_arg_units    ( 33 ) / ' '	    /,
     .	     alg_arg_descr    ( 33 ) / ' '	    /,
     .	     alg_arg_name     ( 34 ) / 'day'	    /,
     .	     alg_arg_units    ( 34 ) / ' '	    /,
     .	     alg_arg_descr    ( 34 ) / ' '	    /,
     .       alg_fcn		( 23 ) / 'RANDU2'    /,
     .	     alg_num_fcn_args	( 23 ) / 2 	    /
     .	     alg_fcn_descr	( 23 )
     .		/ 'random uniform [0,1), Alternate algorithm' /,
     .	     alg_fcn_arg_ptr    ( 23 ) / 35	    /,
     .	     alg_arg_name     ( 35 ) / 'A'	    /,
     .	     alg_arg_units    ( 35 ) / ' '	    /,
     .	     alg_arg_descr    ( 35 ) /
     .			'field of random values will have shape of A'/,
     .	     alg_arg_name     ( 36 ) / 'ISEED'	    /,
     .	     alg_arg_units    ( 36 ) / ' '	    /,
     .	     alg_arg_descr    ( 36 ) / 
     .         '-1=sys clock, 0=continue w/ previous seed, N>0 user-defined seed'/,
     .       alg_fcn		( 24 ) / 'RANDN2'    /,
     .	     alg_num_fcn_args	( 24 ) / 2 	    /,
     .	     alg_fcn_descr	( 24 )
     .			/ 'random normal, Alternate algorithm' /,
     .	     alg_fcn_arg_ptr    ( 24 ) / 37	    /,
     .	     alg_arg_name     ( 37 ) / 'A'	    /,
     .	     alg_arg_units    ( 37 ) / ' '	    /,
     .	     alg_arg_descr    ( 37 ) /
     .			'field of random values will have shape of A'/,
     .	     alg_arg_name     ( 38 ) / 'ISEED'	    /,
     .	     alg_arg_units    ( 38 ) / ' '	    /,
     .	     alg_arg_descr    ( 38 ) /
     .         '-1=sys clock, 0=continue w/ previous seed, N>0 user-defined seed'/
	DATA (alg_fcn(i),i=23,num_functions)/ 3*unspecified_name4 /  

* logical structures:
	DATA alg_struct(  1 ) / 'IF' /,		! formerly "WHERE"
     .	     alg_struct(  2 ) / 'THEN' /,
     .	     alg_struct(  3 ) / 'ELSE' /

* logical if-valid structures:
	DATA alg_vstruct(  1 ) / 'IFV' /,	
     .	     alg_vstruct(  2 ) / 'THEN' /,
     .	     alg_vstruct(  3 ) / 'ELSE' /

* punctuation:
	DATA alg_punct(  1 ) / ',' /,
     .	     alg_punct(  2 ) / '(' /,
     .	     alg_punct(  3 ) / ')' /

* pseudo_variables:
* Keep the classic 4D variables together, then the
* ones for 6D. Lets us set mode fourdee to use M,N etc as
* user variables.

        DATA alg_pvar_head     / 0 /
        DATA alg_pvar_padding  / 0 /
	DATA alg_pvar	(  1 ) / 'I       ' /,
     .       alg_pvar	(  2 ) / 'J       ' /,
     .       alg_pvar	(  3 ) / 'K       ' /,
     .       alg_pvar	(  4 ) / 'L       ' /,
     .       alg_pvar	(  5 ) / '_M      ' /,
     .       alg_pvar	(  6 ) / '_N      ' /,
     .       alg_pvar	(  7 ) / 'X       ' /,
     .       alg_pvar	(  8 ) / 'Y       ' /,
     .       alg_pvar	(  9 ) / 'Z       ' /,
     .       alg_pvar	( 10 ) / 'T       ' /,
     .       alg_pvar	( 11 ) / '_E      ' /,
     .       alg_pvar	( 12 ) / '_F      ' /
     .       alg_pvar	( 13 ) / 'XBOX    ' /,
     .       alg_pvar	( 14 ) / 'YBOX    ' /,
     .       alg_pvar	( 15 ) / 'ZBOX    ' /,
     .       alg_pvar	( 16 ) / 'TBOX    ' /,
     .       alg_pvar	( 17 ) / 'EBOX    ' /,
     .       alg_pvar	( 18 ) / 'FBOX    ' /,
     .       alg_pvar	( 19 ) / 'XBOXLO  ' /,
     .       alg_pvar	( 20 ) / 'YBOXLO  ' /,
     .       alg_pvar	( 21 ) / 'ZBOXLO  ' /,
     .       alg_pvar	( 22 ) / 'TBOXLO  ' /,
     .       alg_pvar	( 23 ) / 'EBOXLO  ' /,
     .       alg_pvar	( 24 ) / 'FBOXLO  ' /,
     .       alg_pvar	( 25 ) / 'XBOXHI  ' /,
     .       alg_pvar	( 26 ) / 'YBOXHI  ' /,
     .       alg_pvar	( 27 ) / 'ZBOXHI  ' /,
     .       alg_pvar	( 28 ) / 'TBOXHI  ' /,
     .       alg_pvar	( 29 ) / 'EBOXHI  ' /,
     .       alg_pvar	( 30 ) / 'FBOXHI  ' /
! allow _I,_J,_K,_L,_X,_Y,_Z,_T which will be translated to just I,J,...Z,T.
	DATA alg_pvar	( 31 ) / '_I      ' /,
     .       alg_pvar	( 32 ) / '_J      ' /,
     .       alg_pvar	( 33 ) / '_K      ' /,
     .       alg_pvar	( 34 ) / '_L      ' /,
     .       alg_pvar	( 35 ) / '_M      ' /,
     .       alg_pvar	( 36 ) / '_N      ' /,
     .       alg_pvar	( 37 ) / '_X      ' /,
     .       alg_pvar	( 38 ) / '_Y      ' /,
     .       alg_pvar	( 39 ) / '_Z      ' /,
     .       alg_pvar	( 40 ) / '_T      ' /
        DATA alg_cvar        /60*unspecified_name4/
        DATA countervar_name_head / 0 /
        DATA countervar_name_padding / 0 /
        DATA countervar_name /60*unspecified_name4/

	DATA
     .		alg_trans_text ( 1 )	/ 'AV4' 		/, 
     .		alg_trans_title( 1 )	/ '4D ave'		/,
     .		alg_trans_num  ( 1 )	/ trans_4d_ave		/,
     .		alg_trans_its_int ( 1)	/ .FALSE.		/,
     .		alg_trans_has_arg ( 1)	/ .FALSE.		/,
     .		alg_trans_dflt_arg( 1)	/ bad_val4		/,	
     .		alg_trans_text ( 2 )	/ 'IN4' 		/, 
     .		alg_trans_title( 2 )	/ '4D integ.'		/,
     .		alg_trans_num  ( 2 )	/ trans_4d_int_def	/,
     .		alg_trans_its_int ( 2 )	/ .FALSE.		/,
     .		alg_trans_has_arg ( 2 )	/ .FALSE.		/,
     .		alg_trans_dflt_arg( 2 )	/ bad_val4		/,
     .		alg_trans_text ( 3 )	/ 'ITP' 		/, 
     .		alg_trans_title( 3 )	/ 'interpolated'	/,
     .		alg_trans_num  ( 3 )	/ trans_interpolate	/,
     .		alg_trans_its_int ( 3 )	/ .FALSE.		/,
     .		alg_trans_has_arg ( 3 )	/ .FALSE.		/,
     .		alg_trans_dflt_arg( 3 )	/ bad_val4		/,
     .		alg_trans_text ( 4  )	/ 'AVE' 		/, 
     .          alg_trans_title( 4  )	/ 'averaged'      	/,
     .		alg_trans_num  ( 4  )	/ trans_average		/,
     .		alg_trans_its_int ( 4 )	/ .FALSE.		/,
     .		alg_trans_has_arg ( 4 )	/ .FALSE.		/,
     .		alg_trans_dflt_arg( 4 )	/ bad_val4		/,
     .		alg_trans_text ( 5 )	/ 'VAR'  		/, 
     .		alg_trans_title( 5 )	/ 'variance'    	/,
     .		alg_trans_num  ( 5 )	/ trans_variance  	/,
     .		alg_trans_its_int ( 5)	/ .FALSE.		/,
     .		alg_trans_has_arg ( 5)	/ .FALSE.		/,
     .		alg_trans_dflt_arg( 5)	/ bad_val4		/,
     .		alg_trans_text ( 6 )	/ 'SUM'  		/, 
     .		alg_trans_title( 6 )	/ 'summed'              /,
     .          alg_trans_num  ( 6 )	/ trans_sum	        /,
     .		alg_trans_its_int ( 6)	/ .FALSE.		/,
     .		alg_trans_has_arg ( 6)	/ .FALSE.		/,
     .		alg_trans_dflt_arg( 6)	/ bad_val4		/,
     .		alg_trans_text ( 7 )	/ 'RSU'  		/, 
     .		alg_trans_title( 7 )	/ 'running sum'  	/,
     .		alg_trans_num  ( 7 )	/ trans_run_sum  	/,
     .		alg_trans_its_int ( 7)	/ .FALSE.		/,
     .		alg_trans_has_arg ( 7)	/ .FALSE.		/,
     .		alg_trans_dflt_arg( 7)	/ bad_val4		/,
     .		alg_trans_text ( 8 )	/ 'SHF' 		/, 
     .		alg_trans_title( 8 )	/ 'shifted'		/,
     .		alg_trans_num  ( 8 )	/ trans_shift		/,
     .		alg_trans_its_int ( 8)	/ .TRUE.		/,
     .		alg_trans_has_arg ( 8)	/ .TRUE.		/,
     .		alg_trans_dflt_arg( 8)	/ 1.			/,
     .		alg_trans_text ( 9  )	/ 'MIN' 		/, 
     .		alg_trans_title( 9  )	/ 'minimum'		/,
     .		alg_trans_num  ( 9  )	/ trans_min		/,
     .		alg_trans_its_int ( 9)	/ .FALSE.		/,
     .		alg_trans_has_arg ( 9)	/ .FALSE.		/,
     .		alg_trans_dflt_arg( 9)	/ bad_val4		/,
     .		alg_trans_text ( 10  )	/ 'MAX' 		/, 
     .		alg_trans_title( 10  )	/ 'maximum'		/,
     .		alg_trans_num  ( 10  )	/ trans_max		/,
     .		alg_trans_its_int ( 10)	/ .FALSE.		/,
     .		alg_trans_has_arg ( 10)	/ .FALSE.		/,
     .		alg_trans_dflt_arg( 10)	/ bad_val4		/
	DATA
     .		alg_trans_text ( 11 )	/ ' '			/, ! for EXAM
     .		alg_trans_title( 11 )	/ ' '			/,
     .		alg_trans_num  ( 11 )	/ trans_no_transform	/,
     .		alg_trans_its_int ( 11)	/ .FALSE.		/,
     .		alg_trans_has_arg ( 11)	/ .FALSE.		/,
     .		alg_trans_dflt_arg( 11)	/ bad_val4		/,
     .		alg_trans_text ( 12 )	/ 'NUL'			/, ! for @NUL
     .		alg_trans_title( 12 )	/ ' '			/,
     .		alg_trans_num  ( 12 )	/ trans_no_transform	/,
     .		alg_trans_its_int ( 12)	/ .FALSE.		/,
     .		alg_trans_has_arg ( 12)	/ .FALSE.		/,
     .		alg_trans_dflt_arg( 12)	/ bad_val4		/,
     .		alg_trans_text ( 13  )	/ 'DDC' 		/, 
     .		alg_trans_title( 13 )	/ 'centered derivative'	/,
     .		alg_trans_num  ( 13 )	/ trans_deriv_cntr	/,
     .		alg_trans_its_int ( 13)	/ .FALSE.		/,
     .		alg_trans_has_arg ( 13)	/ .FALSE.		/,
     .		alg_trans_dflt_arg( 13)	/ bad_val4		/,
     .		alg_trans_text ( 14 )	/ 'DDF' 		/, 
     .		alg_trans_title( 14 )	/ 'forward derivative'	/,
     .		alg_trans_num  ( 14 )	/ trans_deriv_fwrd	/,
     .		alg_trans_its_int ( 14)	/ .FALSE.		/,
     .		alg_trans_has_arg ( 14)	/ .FALSE.		/,
     .		alg_trans_dflt_arg( 14)	/ bad_val4		/,
     .		alg_trans_text ( 15 )	/ 'DDB' 		/, 
     .		alg_trans_title( 15 )	/ 'backwards derivative'/,
     .		alg_trans_num  ( 15 )	/ trans_deriv_bkwd	/,
     .		alg_trans_its_int ( 15)	/ .FALSE.		/,
     .		alg_trans_has_arg ( 15)	/ .FALSE.		/,
     .		alg_trans_dflt_arg( 15)	/ bad_val4		/,
     .		alg_trans_text ( 16 )	/ 'DIN' 		/, 
     .		alg_trans_title( 16 )	/ 'integrated'		/,
     .		alg_trans_num  ( 16 )	/ trans_integ_def	/,
     .		alg_trans_its_int ( 16)	/ .FALSE.		/,
     .		alg_trans_has_arg ( 16)	/ .FALSE.		/,
     .		alg_trans_dflt_arg( 16)	/ bad_val4		/,
     .		alg_trans_text ( 17 )	/ 'IIN' 		/, 
     .		alg_trans_title( 17 )	/ 'indef. integ.'	/,
     .		alg_trans_num  ( 17 )	/ trans_integ_indef	/,
     .		alg_trans_its_int ( 17)	/ .FALSE.		/,
     .		alg_trans_has_arg ( 17)	/ .FALSE.		/,
     .		alg_trans_dflt_arg( 17)	/ bad_val4		/,
     .		alg_trans_text ( 18 )	/ 'SBX' 		/, 
     .		alg_trans_title( 18 )	/ 'box smoothed'	/,
     .		alg_trans_num  ( 18 )	/ trans_smth_box	/,
     .		alg_trans_its_int ( 18)	/ .TRUE.		/,
     .		alg_trans_has_arg ( 18)	/ .TRUE.		/,
     .		alg_trans_dflt_arg( 18)	/ 3.			/,
     .		alg_trans_text ( 19 )	/ 'SBN' 		/, 
     .		alg_trans_title( 19 )	/ 'binomial smoothed'	/,
     .		alg_trans_num  ( 19 )	/ trans_smth_binml	/,
     .		alg_trans_its_int ( 19)	/ .TRUE.		/,
     .		alg_trans_has_arg ( 19)	/ .TRUE.		/,
     .		alg_trans_dflt_arg( 19)	/ 3.			/,
     .		alg_trans_text ( 20 )	/ 'SWL' 		/, 
     .		alg_trans_title( 20 )	/ 'Welch smoothed'	/,
     .		alg_trans_num  ( 20 )	/ trans_smth_welch	/,
     .		alg_trans_its_int ( 20)	/ .TRUE.		/,
     .		alg_trans_has_arg ( 20)	/ .TRUE.		/,
     .		alg_trans_dflt_arg( 20)	/ 3.			/
	DATA
     .		alg_trans_text ( 21 )	/ 'SHN' 		/, 
     .		alg_trans_title( 21 )	/ 'Hanning smoothed'	/,
     .		alg_trans_num  ( 21 )	/ trans_smth_hanng	/,
     .		alg_trans_its_int ( 21)	/ .TRUE.		/,
     .		alg_trans_has_arg ( 21)	/ .TRUE.		/,
     .		alg_trans_dflt_arg( 21)	/ 3.			/,
     .		alg_trans_text ( 22 )	/ 'SPZ' 		/, 
     .		alg_trans_title( 22 )	/ 'Parzen smoothed'	/,
     .		alg_trans_num  ( 22 )	/ trans_smth_parzn	/,
     .		alg_trans_its_int ( 22)	/ .TRUE.		/,
     .		alg_trans_has_arg ( 22)	/ .TRUE.		/,
     .		alg_trans_dflt_arg( 22)	/ 3.			/,
     .		alg_trans_text ( 23 )	/ 'FAV' 		/, 
     .		alg_trans_title( 23 )	/ 'ave-filled'		/,
     .		alg_trans_num  ( 23 )	/ trans_fill_ave	/,
     .		alg_trans_its_int ( 23)	/ .TRUE.		/,
     .		alg_trans_has_arg ( 23)	/ .TRUE.		/,
     .		alg_trans_dflt_arg( 23)	/ 3			/,
     .		alg_trans_text ( 24 )	/ 'FLN' 		/, 
     .		alg_trans_title( 24 )	/ 'linear-filled'	/,
     .		alg_trans_num  ( 24 )	/ trans_fill_interp	/,
     .		alg_trans_its_int ( 24)	/ .TRUE.		/,
     .		alg_trans_has_arg ( 24)	/ .TRUE.		/,
     .		alg_trans_dflt_arg( 24)	/ 1.			/,
     .		alg_trans_text ( 25 )	/ 'FNR' 		/, 
     .		alg_trans_title( 25 )	/ 'nearest-filled'	/,
     .		alg_trans_num  ( 25 )	/ trans_fill_near	/,
     .		alg_trans_its_int ( 25)	/ .TRUE.		/,
     .		alg_trans_has_arg ( 25)	/ .TRUE.		/,
     .		alg_trans_dflt_arg( 25)	/ 1.			/,
     .		alg_trans_text ( 26 )	/ 'NGD'  		/, 
     .		alg_trans_title( 26 )	/ 'number of valid'  	/,
     .		alg_trans_num  ( 26 )	/ trans_good_pt  	/,
     .		alg_trans_its_int ( 26)	/ .FALSE.		/,
     .		alg_trans_has_arg ( 26)	/ .FALSE.		/,
     .		alg_trans_dflt_arg( 26)	/ bad_val4		/,
     .		alg_trans_text ( 27 )	/ 'NBD'  		/, 
     .		alg_trans_title( 27 )	/ 'number flagged bad' 	/,
     .		alg_trans_num  ( 27 )	/ trans_bad_pt  	/,
     .		alg_trans_its_int ( 27)	/ .FALSE.		/,
     .		alg_trans_has_arg ( 27)	/ .FALSE.		/,
     .		alg_trans_dflt_arg( 27)	/ bad_val4		/,
     .		alg_trans_text ( 28 )	/ 'LOC'			/, 
     .		alg_trans_title( 28 )	/ 'location'		/,
     .		alg_trans_num  ( 28 )	/ trans_locate		/,
     .		alg_trans_its_int ( 28)	/ .FALSE.		/,
     .		alg_trans_has_arg ( 28)	/ .TRUE.		/,
     .		alg_trans_dflt_arg( 28)	/ 0.0			/,
     .		alg_trans_text ( 29 )	/ 'WEQ'  		/, 
     .		alg_trans_title( 29 )	/ 'weighted equal'	/,
     .		alg_trans_num  ( 29 )	/ trans_wgted_eq	/,
     .		alg_trans_its_int ( 29)	/ .FALSE.		/,
     .		alg_trans_has_arg ( 29)	/ .TRUE.		/,
     .          alg_trans_dflt_arg( 29)	/ 0.0                   /,
     .		alg_trans_text ( 30 )	/ 'VA4' 		/,
     .		alg_trans_title( 30 )	/ '4D variance'		/,
     .		alg_trans_num  ( 30 )	/ trans_4d_var		/,
     .		alg_trans_its_int ( 30)	/ .FALSE.		/,
     .		alg_trans_has_arg ( 30)	/ .FALSE.		/,
     .		alg_trans_dflt_arg( 30)	/ bad_val4		/
	DATA
     .		alg_trans_text ( 31 )	/ 'NG4' 		/,
     .		alg_trans_title( 31 )	/ '4D # valid'		/,
     .		alg_trans_num  ( 31 )	/ trans_4d_good_pt	/,
     .		alg_trans_its_int ( 31)	/ .FALSE.		/,
     .		alg_trans_has_arg ( 31)	/ .FALSE.		/,
     .		alg_trans_dflt_arg( 31)	/ bad_val4		/,
     .		alg_trans_text ( 32 )	/ 'NB4' 		/,
     .		alg_trans_title( 32 )	/ '4D # bad'		/,
     .		alg_trans_num  ( 32 )	/ trans_4d_bad_pt	/,
     .		alg_trans_its_int ( 32)	/ .FALSE.		/,
     .		alg_trans_has_arg ( 32)	/ .FALSE.		/,
     .		alg_trans_dflt_arg( 32)	/ bad_val4		/
	DATA
     .		alg_trans_text ( 33 )	/ 'CDA' 		/,
     .		alg_trans_title( 33 )	/ 'closest dist above'  /,
     .		alg_trans_num  ( 33 )	/ trans_nrst_dist_abv	/,
     .		alg_trans_its_int ( 33)	/ .TRUE.		/,
     .		alg_trans_has_arg ( 33)	/ .TRUE.		/,
     .		alg_trans_dflt_arg( 33)	/ 1			/,
     .		alg_trans_text ( 34 )	/ 'CDB' 		/,
     .		alg_trans_title( 34 )	/ 'closest dist below'  /,
     .		alg_trans_num  ( 34 )	/ trans_nrst_dist_blw	/,
     .		alg_trans_its_int ( 34)	/ .TRUE.		/,
     .		alg_trans_has_arg ( 34)	/ .TRUE.		/,
     .		alg_trans_dflt_arg( 34)	/ 1			/,
     .		alg_trans_text ( 35 )	/ 'CIA' 		/,
     .		alg_trans_title( 35 )	/ 'closest index above' /,
     .		alg_trans_num  ( 35 )	/ trans_nrst_indx_abv	/,
     .		alg_trans_its_int ( 35)	/ .TRUE.		/,
     .		alg_trans_has_arg ( 35)	/ .TRUE.		/,
     .		alg_trans_dflt_arg( 35)	/ 1			/,
     .		alg_trans_text ( 36 )	/ 'CIB' 		/,
     .		alg_trans_title( 36 )	/ 'closest index below' /,
     .		alg_trans_num  ( 36 )	/ trans_nrst_indx_blw	/,
     .		alg_trans_its_int ( 36)	/ .TRUE.		/,
     .		alg_trans_has_arg ( 36)	/ .TRUE.		/,
     .		alg_trans_dflt_arg( 36)	/ 1			/,
     .		alg_trans_text ( 37 )	/ 'EVN' 		/,
     .		alg_trans_title( 37 )	/ 'event mask'		/,
     .		alg_trans_num  ( 37 )	/ trans_event_mask	/,
     .		alg_trans_its_int ( 37)	/ .FALSE.		/,
     .		alg_trans_has_arg ( 37)	/ .TRUE.		/,
     .		alg_trans_dflt_arg( 37)	/ 0.0			/,
     .		alg_trans_text ( 38 )	/ 'MED' 		/,
     .		alg_trans_title( 38 )	/ 'median smoothed'     /,
     .		alg_trans_num  ( 38 )	/ trans_smth_median	/,
     .		alg_trans_its_int ( 38)	/ .TRUE.		/,
     .		alg_trans_has_arg ( 38)	/ .TRUE.		/,
     .		alg_trans_dflt_arg( 38)	/ 3		/,
     .		alg_trans_text ( 39 )	/ 'SMX' 		/,
     .		alg_trans_title( 39 )	/ 'maximum smoothed'     /,
     .		alg_trans_num  ( 39 )	/ trans_smth_max	/,
     .		alg_trans_its_int ( 39)	/ .TRUE.		/,
     .		alg_trans_has_arg ( 39)	/ .TRUE.		/,
     .		alg_trans_dflt_arg( 39)	/ 3		/,
     .		alg_trans_text ( 40 )	/ 'SMN' 		/,
     .		alg_trans_title( 40 )	/ 'minimum smoothed'     /,
     .		alg_trans_num  ( 40 )	/ trans_smth_min	/,
     .		alg_trans_its_int ( 40)	/ .TRUE.		/,
     .		alg_trans_has_arg ( 40)	/ .TRUE.		/,
     .		alg_trans_dflt_arg( 40)	/ 3		        /,
     .		alg_trans_text ( 41 )	/ 'SM4'  		/, 
     .		alg_trans_title( 41 )	/ '4D summed'           /,
     .          alg_trans_num  ( 41 )	/ trans_4d_sum	        /,
     .		alg_trans_its_int ( 41)	/ .FALSE.		/,
     .		alg_trans_has_arg ( 41)	/ .FALSE.		/,
     .		alg_trans_dflt_arg( 41)/ bad_val4		/,
     .		alg_trans_text ( 42 )	/ 'STD'  		/, 
     .		alg_trans_title( 42 )	/ 'standard deviation'  /,
     .		alg_trans_num  ( 42 )	/ trans_std_dev  	/,
     .		alg_trans_text ( 43 )	/ 'WGT'  		/, 
     .		alg_trans_title( 43 )	/ 'weights for avg,int'  /,
     .		alg_trans_num  ( 43 )	/ trans_avg_wgt  	/,
     .		alg_trans_text ( 44 )	/ 'WG4'  		/, 
     .		alg_trans_title( 44 )	/ '4D weights, avg,int'  /,
     .		alg_trans_num  ( 44 )	/ trans_4d_avg_wgt  	/,
     .		alg_trans_text ( 45 )	/ 'SPX' 		/, 
     .		alg_trans_title( 45 )	/ 'box smooth w/missing'/,
     .		alg_trans_num  ( 45 )	/ trans_smth_box_p	/,
     .		alg_trans_its_int ( 45)	/ .TRUE.		/,
     .		alg_trans_has_arg ( 45)	/ .TRUE.		/,
     .		alg_trans_dflt_arg( 45)	/ 3.			/,
     .		alg_trans_text ( 46 )	/ 'SD4'  		/, 
     .		alg_trans_title( 46 )	/ '4D stddev'           /,
     .		alg_trans_num  ( 46 )	/ trans_4d_std  	/

        DATA    (alg_trans_num(i),i = 47, num_transforms)
     .            /14*unspecified_int4 /

	DATA
     .		alg_regrid_title( prgrd_exact )		/ ' '	/,
     .		alg_regrid_code ( prgrd_exact )		/ 'XAK'	/,	
     .		alg_regrid_vizb ( prgrd_exact )		/ .FALSE.	/,
     .		alg_regrid_title( prgrd_linear_interp )	/ 'lin. interp.'/,
     .		alg_regrid_code ( prgrd_linear_interp )	/ 'LIN'	/,
     .		alg_regrid_vizb ( prgrd_linear_interp )	/ .TRUE.	/,
     .		alg_regrid_title( prgrd_average )	/ 'area-wgtd avgd'/,
     .		alg_regrid_code ( prgrd_average )	/ 'AVE'	/,
     .		alg_regrid_vizb ( prgrd_average )	/ .TRUE. 	/,
     .		alg_regrid_title( prgrd_xy_ave )	/ 'area avgd'	/,
     .		alg_regrid_code ( prgrd_xy_ave )	/ 'AAV'	/,
     .		alg_regrid_vizb ( prgrd_xy_ave )	/ .FALSE.	/,
     .		alg_regrid_title( prgrd_xy_lin )	/ 'area intrp.' /,
     .		alg_regrid_code ( prgrd_xy_lin )	/ 'LIN'	/,
     .		alg_regrid_vizb ( prgrd_xy_lin )	/ .FALSE.	/,
     .		alg_regrid_title( prgrd_xact_pts )	/ 'exact match'	/,
     .		alg_regrid_code ( prgrd_xact_pts )	/ 'XACT'	/
     .		alg_regrid_vizb ( prgrd_xact_pts )	/ .TRUE.	/,
     .		alg_regrid_title( prgrd_associate )	/ 'index assn'	/,
     .		alg_regrid_code ( prgrd_associate )	/ 'ASN'	/,
     .		alg_regrid_vizb ( prgrd_associate )	/ .TRUE.	/,
     .		alg_regrid_title( prgrd_variance )	/ 'variance'	/,
     .		alg_regrid_code ( prgrd_variance )	/ 'VAR'	/,
     .		alg_regrid_vizb ( prgrd_variance )	/ .TRUE.	/,
     .		alg_regrid_title( prgrd_min )		/ 'minimum'	/,
     .		alg_regrid_code ( prgrd_min )		/ 'MIN'	/,
     .		alg_regrid_vizb(  prgrd_min )		/ .TRUE.	/,
     .		alg_regrid_title( prgrd_max )		/ 'maximum'	/,
     .		alg_regrid_code ( prgrd_max )		/ 'MAX'	/,
     .		alg_regrid_vizb(  prgrd_max )		/ .TRUE.	/,
     .		alg_regrid_title( prgrd_sum )		/ 'area-wgtd sum'/,
     .		alg_regrid_code ( prgrd_sum )		/ 'SUM'	/,
     .		alg_regrid_vizb(  prgrd_sum )		/ .TRUE.	/,
     .		alg_regrid_title( prgrd_good_pt )	/ '#gd pts, area wgtd' /,
     .		alg_regrid_code ( prgrd_good_pt )	/ 'NGD'	/,
     .		alg_regrid_vizb ( prgrd_good_pt )	/ .TRUE.	/,
     .		alg_regrid_title( prgrd_modulo )	/ 'modulo ave'	/,
     .		alg_regrid_code ( prgrd_modulo )	/ 'MOD'	/
     .		alg_regrid_vizb ( prgrd_modulo )	/ .TRUE.	/,
     .		alg_regrid_title( prgrd_modvar )	/ 'modulo var'	/,
     .		alg_regrid_code ( prgrd_modvar )	/ 'MODVAR'	/
     .		alg_regrid_vizb ( prgrd_modvar )	/ .TRUE.	/,
     .		alg_regrid_title( prgrd_modngd )	/ '# gd mod pts'/,
     .		alg_regrid_code ( prgrd_modngd )	/ 'MODNGD'	/
     .		alg_regrid_vizb ( prgrd_modngd )	/ .TRUE.	/,
     .		alg_regrid_title( prgrd_modnbd )	/ '#bad mod pts'/,
     .		alg_regrid_code ( prgrd_modnbd )	/ 'MODNBD'	/
     .		alg_regrid_vizb ( prgrd_modnbd )	/ .TRUE.	/,
     .		alg_regrid_title( prgrd_modsum )	/ 'modulo sum'	/,
     .		alg_regrid_code ( prgrd_modsum )	/ 'MODSUM'	/
     .		alg_regrid_vizb ( prgrd_modsum )	/ .TRUE.	/,
     .		alg_regrid_title( prgrd_modmin )	/ 'modulo min'	/,
     .		alg_regrid_code ( prgrd_modmin )	/ 'MODMIN'	/
     .		alg_regrid_vizb ( prgrd_modmin )	/ .TRUE.	/,
     .		alg_regrid_title( prgrd_modmax )	/ 'modulo max'	/,
     .		alg_regrid_code ( prgrd_modmax )	/ 'MODMAX'	/
     .		alg_regrid_vizb ( prgrd_modmax )	/ .TRUE.	/,
     .		alg_regrid_title( prgrd_nearest )	/ 'nearst coord'/,
     .		alg_regrid_code ( prgrd_nearest )	/ 'NRST'	/
     .		alg_regrid_vizb ( prgrd_nearest )	/ .TRUE.	/,
     .		alg_regrid_title( prgrd_bin )		/ 'unwgtd avg'  /,
     .		alg_regrid_code ( prgrd_bin )		/ 'BIN'		/
     .		alg_regrid_vizb ( prgrd_bin )		/ .TRUE.	/,
     .		alg_regrid_title( prgrd_nbin )		/ '#good in bin'/,
     .		alg_regrid_code ( prgrd_nbin )		/ 'NBIN'	/
     .		alg_regrid_vizb ( prgrd_nbin )		/ .TRUE.	/,
     .		alg_regrid_title( prgrd_iin )		/ '#indef integral'/,
     .		alg_regrid_code ( prgrd_iin )		/ 'IIN'	/
     .		alg_regrid_vizb ( prgrd_iin )		/ .TRUE.	/,

     .		(alg_regrid_title(i),i=prgrd_iin+1,max_regrid_trans)
     .				/7*unspecified_name4/,
     .		(alg_regrid_code (i),i=prgrd_iin+1,max_regrid_trans)
     .				/7*unspecified_name4/,
     .		(alg_regrid_vizb (i),i=prgrd_iin+1,max_regrid_trans)
     .				/7*.FALSE./


	DATA
     .		alg_regrid_title(pauxrgrd_linear)	/ 'lin. interp.'/,
     .		alg_regrid_code (pauxrgrd_linear)	/ 'LIN'	        /,
     .		alg_regrid_vizb (pauxrgrd_linear)	/ .TRUE.	/,
     .		alg_regrid_title(pauxrgrd_average)	/ 'box avgd'    /,
     .		alg_regrid_code (pauxrgrd_average)	/ 'AVE'	        /,
     .		alg_regrid_vizb (pauxrgrd_average)	/ .FALSE.	/,
     .		alg_regrid_title(pauxrgrd_pwlave )	
     .						/ 'pc-wise linear ave'  /,
     .		alg_regrid_code (pauxrgrd_pwlave )	/ 'PLAVE'      /,
     .		alg_regrid_vizb (pauxrgrd_pwlave )	/ .TRUE.	/,
     .		alg_regrid_title(pauxrgrd_thick_ave)
     .						/ 'box ave from thkness'/,
     .		alg_regrid_code (pauxrgrd_thick_ave)/ unspecified_name4 /,
     .		alg_regrid_vizb (pauxrgrd_thick_ave)	/ .FALSE.	/,
     .		alg_regrid_title(pauxrgrd_fmrc)
     .						     / 'reorg T-F array'/,
     .		alg_regrid_code (pauxrgrd_fmrc)		/ 'FMRC'/,
     .		alg_regrid_vizb (pauxrgrd_fmrc)		/ .FALSE.	/,

     .		(alg_regrid_title(i),
     .				i=pauxrgrd_fmrc+1,max_auxregrid_trans)
     .				/1*unspecified_name4/,
     .		(alg_regrid_code (i),
     .				i=pauxrgrd_fmrc+1,max_auxregrid_trans)
     .				/1*unspecified_name4/,
     .		(alg_regrid_vizb (i),
     .				i=pauxrgrd_fmrc+1,max_auxregrid_trans)
     .				/1*.FALSE./

* translation table for substituting 1D transformations with 4D transforms
	DATA	num_4d_trans/ 8 /
	DATA	alg_1d_to_4d(1) /trans_average/,
     .		alg_4d_trans(1) /trans_4d_ave/,
     .		alg_1d_to_4d(2) /trans_integ_def/,
     .		alg_4d_trans(2) /trans_4d_int_def/,
     .		alg_1d_to_4d(3) /trans_variance/,
     .		alg_4d_trans(3) /trans_4d_var/,
     .		alg_1d_to_4d(4) /trans_good_pt/,
     .		alg_4d_trans(4) /trans_4d_good_pt/,
     .		alg_1d_to_4d(5) /trans_bad_pt/,
     .		alg_4d_trans(5) /trans_4d_bad_pt/,
     .		alg_1d_to_4d(6) /trans_sum/,
     .		alg_4d_trans(6) /trans_4d_sum/,
     .		alg_1d_to_4d(7) /trans_avg_wgt/,
     .		alg_4d_trans(7) /trans_4d_avg_wgt/
     .		alg_1d_to_4d(8) /trans_std_dev/,
     .		alg_4d_trans(8) /trans_4d_std/

	END

	SUBROUTINE DO_VAR_SUB(	idim, com_lo, com_hi,
     .				com, com_mr, com_cx,
     .				res, res_mr, res_cx,
     .				box, stddev,
     .				wsum, s )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine the variance along the indicated axis
* nested with DO_VARIANCE in order to ease the dimension checking of box

* COSINE weighting not applied because this is a strictly 1D calculation
* see DO_4D_TRANS for the contrasting multi-dimensional calculation

* calculation is done in a single pass (a change 11/2016)
* using the algorithm of West (1979) as described succintly in Wikipedia
* as the "Weighted incremental algorithm" for computing variance
* see D. H. D. West (1979). Communications of the ACM, 22, 9, 532-535:
*     Updating Mean and Variance Estimates: An Improved Method
* Note that the new algorithm may treat the unequal weghting of points
* differently than the old.  The new is better to be trusted IMHO.

****
* The algorithm:
*
* These initializations already done from IS_TRANS
*    wSum = 0
*    mean = 0    ! "res" in this code
*    S =0
*
* This routine performs this loop (see Wikipedia reference)
* v,w  is the value,weight pair contributed by each grid cell
*        wSum = wSum + w
*        meanOld = mean
*        mean = meanOld + (w / wSum) * (v - meanOld)
*        S = S + w * (v - meanOld) * (v - mean)
*	
* Split/gather memory management may cause this routine to be called many times
* in the finalize step we will compute
*    variance = S / wSum
****

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V230:   3/2/92
* V420: 11/95 - converted diff and mean to DP so variance is calc in DP
*	 2/96 - fix bug introduced in 11/95: CGRID_AXIS has wrong args
* V664:  8/10 - implement robust method for computing variances
* V672+: 1/12 - previous checkin had wrong indices for result. Return to 
*               divide by n, not n+1
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
*
* v687  3/14  *acm* Option to return standard deviation
* v702 *sh* 11/16 -  mods for trac #2428 - calculation in gathered fragments
* v73+ *acm*12/17 -  issue #1849, if box size 0 skip it - resulted in missing
*                    result where result should be computed

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'

* internal variable declarations:
	LOGICAL stddev
	INTEGER CGRID_AXIS, i, j, k, l, m, n,
     .          grid, pt, lo, hi, axis
	REAL	BOX_SIZE, bad_com, bad_res
	REAL*8	TM_WORLD, dsum, bsum
	REAL*8  w, v, wsum_chunk, mean_chunk, mean_old, s_chunk

* calling argument declarations:
	INTEGER	idim, com_lo, com_hi, com_mr, com_cx, res_mr, res_cx
	REAL    com ( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .                m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          res ( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .                m2lot:m2hit,m2loe:m2hie,m2lof:m2hif ),
     .          wsum( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .                m2lot:m2hit,m2loe:m2hie,m2lof:m2hif ),
     .          s   ( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .                m2lot:m2hit,m2loe:m2hie,m2lof:m2hif ),
     .		box( com_lo:com_hi )

* --- end of introductory code ---

* initialize
	grid = mr_grid( com_mr )
	axis = CGRID_AXIS( idim, com_cx )
	pt   = cx_lo_ss( res_cx, idim )
	lo   = com_lo
	hi   = com_hi
	bad_com = mr_bad_data( com_mr )
	bad_res = mr_bad_data( res_mr )

* get and save grid box sizes (weights) just once for efficiency
	DO 100 i = lo, hi
 100	box(i)  = BOX_SIZE( i, grid, idim )
* 11/16 ... end boxes may be only partial cells
	IF  (TM_WORLD(lo, grid, idim, box_lo_lim)
     .  .LT. cx_lo_ww(idim,res_cx)                ) box(lo) = 
     .			TM_WORLD(lo, grid, idim, box_hi_lim)
     .		      - cx_lo_ww(idim,res_cx)
	IF  (TM_WORLD(hi, grid, idim, box_hi_lim)
     .  .GT. cx_hi_ww(idim,res_cx)                ) box(hi) =
     .			cx_hi_ww(idim,res_cx)
     .		      - TM_WORLD(hi, grid, idim, box_lo_lim)

!	box(lo) = TM_WORLD(lo, grid, idim, box_hi_lim)
!     .		- cx_lo_ww(idim,res_cx)
!	box(hi) = cx_hi_ww(idim,res_cx)
!     .		- TM_WORLD(hi, grid, idim, box_lo_lim)

* ALONG X AXIS
	IF ( idim .EQ. x_dim ) THEN
	   DO 210 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 210 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 210 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 210 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 210 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	      wsum_chunk = wsum(pt,j,k,l,m,n)
	      mean_chunk = res (pt,j,k,l,m,n)
	      s_chunk    = s   (pt,j,k,l,m,n)
	      DO i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	         w = box(i)
	         IF ( w .EQ. 0. ) CYCLE
	         v = com(i,j,k,l,m,n)
	         IF ( v .EQ. bad_com ) CYCLE
	         wsum_chunk = wsum_chunk + w
	         mean_old = mean_chunk
	         mean_chunk = mean_old + (w/wsum_chunk)*(v-mean_old)
	         s_chunk = s_chunk + w * (v-mean_old)*(v-mean_chunk)
	      ENDDO
	      wsum(pt,j,k,l,m,n) = wsum_chunk
	      res (pt,j,k,l,m,n) = mean_chunk
	      s   (pt,j,k,l,m,n) = s_chunk
 210	   CONTINUE

* ALONG Y AXIS
	ELSEIF ( idim .EQ. y_dim ) THEN

	   DO 310 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 310 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 310 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 310 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 310 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	      wsum_chunk = wsum(i,pt,k,l,m,n)
	      mean_chunk = res (i,pt,k,l,m,n)
	      s_chunk    = s   (i,pt,k,l,m,n)
	      DO j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	         w = box(j)
	         IF ( w .EQ. 0. ) CYCLE
	         v = com(i,j,k,l,m,n)
	         IF ( v .EQ. bad_com ) CYCLE
	         wsum_chunk = wsum_chunk + w
	         mean_old = mean_chunk
	         mean_chunk = mean_old + (w/wsum_chunk)*(v-mean_old)
	         s_chunk = s_chunk + w * (v-mean_old)*(v-mean_chunk)
	      ENDDO
	      wsum(i,pt,k,l,m,n) = wsum_chunk
	      res (i,pt,k,l,m,n) = mean_chunk
	      s   (i,pt,k,l,m,n) = s_chunk
 310	   CONTINUE


* ALONG Z AXIS
	ELSEIF ( idim .EQ. z_dim ) THEN
	   DO 410 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 410 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 410 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 410 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 410 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	      wsum_chunk = wsum(i,j,pt,l,m,n)
	      mean_chunk = res (i,j,pt,l,m,n)
	      s_chunk    = s   (i,j,pt,l,m,n)
	      DO k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	         w = box(k)
	         IF ( w .EQ. 0. ) CYCLE
	         v = com(i,j,k,l,m,n)
	         IF ( v .EQ. bad_com ) CYCLE
	         wsum_chunk = wsum_chunk + w
	         mean_old = mean_chunk
	         mean_chunk = mean_old + (w/wsum_chunk)*(v-mean_old)
	         s_chunk = s_chunk + w * (v-mean_old)*(v-mean_chunk)
	      ENDDO
	      wsum(i,j,pt,l,m,n) = wsum_chunk
	      res (i,j,pt,l,m,n) = mean_chunk
	      s   (i,j,pt,l,m,n) = s_chunk
 410	   CONTINUE

* ALONG T AXIS
	ELSEIF ( idim .EQ. t_dim ) THEN
	   DO 510 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 510 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 510 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 510 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 510 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)

	      wsum_chunk = wsum(i,j,k,pt,m,n)
	      mean_chunk = res (i,j,k,pt,m,n)
	      s_chunk    = s   (i,j,k,pt,m,n)
	      DO l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	         w = box(l)
	         IF ( w .EQ. 0. ) CYCLE
	         v = com(i,j,k,l,m,n)
	         IF ( v .EQ. bad_com ) CYCLE
	         wsum_chunk = wsum_chunk + w
	         mean_old = mean_chunk
	         mean_chunk = mean_old + (w/wsum_chunk)*(v-mean_old)
	         s_chunk = s_chunk + w * (v-mean_old)*(v-mean_chunk)
	      ENDDO
	      wsum(i,j,k,pt,m,n) = wsum_chunk
	      res (i,j,k,pt,m,n) = mean_chunk
	      s   (i,j,k,pt,m,n) = s_chunk
 510	   CONTINUE

* ALONG E AXIS
	ELSEIF ( idim .EQ. e_dim ) THEN
	   DO 610 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 610 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 610 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 610 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 610 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	      wsum_chunk = wsum(i,j,k,l,pt,n)
	      mean_chunk = res (i,j,k,l,pt,n)
	      s_chunk    = s   (i,j,k,l,pt,n)
	      DO m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	         w = box(m)
	         IF ( w .EQ. 0. ) CYCLE
	         v = com(i,j,k,l,m,n)
	         IF ( v .EQ. bad_com ) CYCLE
	         wsum_chunk = wsum_chunk + w
	         mean_old = mean_chunk
	         mean_chunk = mean_old + (w/wsum_chunk)*(v-mean_old)
	         s_chunk = s_chunk + w * (v-mean_old)*(v-mean_chunk)
	      ENDDO
	      wsum(i,j,k,l,pt,n) = wsum_chunk
	      res (i,j,k,l,pt,n) = mean_chunk
	      s   (i,j,k,l,pt,n) = s_chunk
 610	   CONTINUE

* ALONG F AXIS
	ELSEIF ( idim .EQ. f_dim ) THEN
	   DO 710 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 710 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 710 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 710 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 710 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	      wsum_chunk = wsum(i,j,k,l,m,pt)
	      mean_chunk = res (i,j,k,l,m,pt)
	      s_chunk    = s   (i,j,k,l,m,pt)
	      DO n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	         w = box(n)
	         IF ( w .EQ. 0. ) CYCLE
	         v = com(i,j,k,l,m,n)
	         IF ( v .EQ. bad_com ) CYCLE
	         wsum_chunk = wsum_chunk + w
	         mean_old = mean_chunk
	         mean_chunk = mean_old + (w/wsum_chunk)*(v-mean_old)
	         s_chunk = s_chunk + w * (v-mean_old)*(v-mean_chunk)
	      ENDDO
	      wsum(i,j,k,l,m,pt) = wsum_chunk
	      res (i,j,k,l,m,pt) = mean_chunk
	      s   (i,j,k,l,m,pt) = s_chunk
 710	   CONTINUE

	ENDIF

* success
	RETURN
	END

*
* sampleij.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Ansley Manke
* APR 1999
*
* This function samples 4-d data on the x and y axes indicated by args 2 and 3
* 4/5/99  Ansley Manke 
*         Result is abstract on the x axis, normal on the y axis,
*         and keeps the z and t axes of the input 4-d data.
* 4/9/09  The function never tested for the bad-flag of the input variable.
* 1/29/16 Ticketn2358: Clarify the function description and argument descriptions
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE sampleij_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CHARACTER*100 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT 
     .  ('Returns data sampled by matching coordinates at a subset of ',
     .   'grid points, defined by (XPTS, YPTS)')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 3)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                ABSTRACT,        NORMAL,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 2)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'DAT_TO_SAMPLE')
      CALL ef_set_arg_desc(id, arg, 'variable (x,y,z,t,e,f) to sample')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'XPTS')
      CALL ef_set_arg_desc(id, arg, 'X coordinates of grid points')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'YPTS')
      CALL ef_set_arg_desc(id, arg, 'Y coordinates of grid points')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* loss               lo subscript for an axis
*
* hiss               hi subscript for an axis
*

      SUBROUTINE sampleij_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER nx

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nx = arg_hi_ss(X_AXIS, ARG2) - arg_lo_ss(X_AXIS, ARG2) + 1

      CALL ef_set_axis_limits(id, X_AXIS, 1, nx)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END
*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE sampleij_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*
      INTEGER mxl, myl, mxh, myh
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      mxl = arg_lo_ss(X_AXIS,ARG1)
      myl = arg_lo_ss(Y_AXIS,ARG1)

*  Allocate double the length of the axes for REAL*8 work arrays.
      mxh = arg_hi_ss(X_AXIS,ARG1) * 2
      myh = arg_hi_ss(Y_AXIS,ARG1) * 2

*  xaxdat
      CALL ef_set_work_array_dims_6d(id, 1,
     .                              mxl, 1, 1, 1, 1, 1,
     .                              mxh, 1, 1, 1, 1, 1)

*  yaxdat
      CALL ef_set_work_array_dims_6d(id, 2,
     .                              myl, 1, 1, 1, 1, 1,
     .                              myh, 1, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE sampleij_compute(id, arg_1, arg_2, arg_3, result, 
     .       xaxdat, yaxdat)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

      REAL*8 xaxdat(wrk1lox:wrk1hix/2, wrk1loy:wrk1hiy,
     .              wrk1loz:wrk1hiz, wrk1lot:wrk1hit,
     .              wrk1loe:wrk1hie, wrk1lof:wrk1hif)
      REAL*8 yaxdat(wrk2lox:wrk2hix/2, wrk2loy:wrk2hiy,
     .              wrk2loz:wrk2hiz, wrk2lot:wrk2hit,
     .              wrk2loe:wrk2hie, wrk2lof:wrk2hif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      LOGICAL TM_FPEQ, its_dsg

      INTEGER i,  j,  k,  l,  m,  n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2
      INTEGER i3, j3, k3, l3, m3, n3
      INTEGER imatch, jmatch
      REAL xgrid, ygrid, a
      CHARACTER*255 err_msg

* Does the variable come from a Discrete Sampling Geometries dataset?  

      CALL EF_GET_ITS_DSG(id, ARG1, its_dsg )
      IF (its_dsg) THEN
         err_msg = 
     . 'Data is from a Discrete Sampling Geometries (DSG) dataset. Function does not apply.'
       GOTO 999
      ENDIF

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      IF ((arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2)) .GT. 0  .OR.
     .    (arg_hi_ss(Z_AXIS,ARG2) - arg_lo_ss(Z_AXIS,ARG2)) .GT. 0  .OR.
     .    (arg_hi_ss(T_AXIS,ARG2) - arg_lo_ss(T_AXIS,ARG2)) .GT. 0  .OR.
     .    (arg_hi_ss(E_AXIS,ARG2) - arg_lo_ss(E_AXIS,ARG2)) .GT. 0  .OR.
     .    (arg_hi_ss(F_AXIS,ARG2) - arg_lo_ss(F_AXIS,ARG2)) .GT. 0) THEN
         WRITE (err_msg, 10)
         GO TO 999
      ENDIF

      IF ((arg_hi_ss(Y_AXIS,ARG3) - arg_lo_ss(Y_AXIS,ARG3)) .GT. 0  .OR.
     .    (arg_hi_ss(Z_AXIS,ARG3) - arg_lo_ss(Z_AXIS,ARG3)) .GT. 0  .OR.
     .    (arg_hi_ss(T_AXIS,ARG3) - arg_lo_ss(T_AXIS,ARG3)) .GT. 0  .OR.
     .    (arg_hi_ss(E_AXIS,ARG3) - arg_lo_ss(E_AXIS,ARG3)) .GT. 0  .OR.
     .    (arg_hi_ss(F_AXIS,ARG3) - arg_lo_ss(F_AXIS,ARG3)) .GT. 0) THEN
         WRITE (err_msg, 20)
         GO TO 999
      ENDIF

   10 FORMAT ('SAMPLEIJ expects Argument 2 to be a list of X ',
     .       'coordinates whose ''grid'' consists of an X axis only')
   20 FORMAT ('SAMPLEIJ expects Argument 3 to be a list of Y ',
     .       'coordinates whose ''grid'' consists of an X axis only')
         

*  Get x and y coordinates of the data array.

      CALL ef_get_coordinates(id, ARG1, X_AXIS, 
     .   arg_lo_ss(X_AXIS, ARG1), arg_hi_ss(X_AXIS, ARG1), xaxdat)
      CALL ef_get_coordinates(id, ARG1, Y_AXIS, 
     .   arg_lo_ss(Y_AXIS, ARG1), arg_hi_ss(Y_AXIS, ARG1), yaxdat)

      i2 = arg_lo_ss(X_AXIS,ARG2)
      j2 = arg_lo_ss(Y_AXIS,ARG2)
      k2 = arg_lo_ss(Z_AXIS,ARG2)
      l2 = arg_lo_ss(T_AXIS,ARG2)
      m2 = arg_lo_ss(E_AXIS,ARG2)
      n2 = arg_lo_ss(F_AXIS,ARG2)

      i3 = arg_lo_ss(X_AXIS,ARG3)
      j3 = arg_lo_ss(Y_AXIS,ARG3)
      k3 = arg_lo_ss(Z_AXIS,ARG3)
      l3 = arg_lo_ss(T_AXIS,ARG3)
      m3 = arg_lo_ss(E_AXIS,ARG3)
      n3 = arg_lo_ss(F_AXIS,ARG3)

*  For each (xpt,ypt) pair, search the data array arg_1 and match its (x,y)
*  coordinates.  Keep the result in result(i_point,_,k,l,m,n) for all 
*  k,l,m,n in the data array.

      j = res_lo_ss(Y_AXIS)
      DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         imatch = ef_unspecified_int4
         jmatch = ef_unspecified_int4

         IF ( arg_2(i2,j2,k2,l2,m2,n2) .NE. bad_flag(ARG2) .AND.
     .        arg_3(i3,j3,k3,l3,m3,n3) .NE. bad_flag(ARG3) ) THEN

            DO 110 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1) 
               xgrid = xaxdat(i1,1,1,1,1,1)
               IF ( TM_FPEQ(xgrid, arg_2(i2,j2,k2,l2,m2,n2)) ) THEN
                   imatch = i1
               ENDIF
  110       CONTINUE

            DO 120 j1 = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1) 
               ygrid = yaxdat(j1,1,1,1,1,1)
               IF ( TM_FPEQ(ygrid, arg_3(i3,j3,k3,l3,m3,n3)) ) THEN
                  jmatch = j1
               ENDIF
  120       CONTINUE

         ENDIF

         IF ( (imatch .NE. ef_unspecified_int4) .AND.
     .        (jmatch .NE. ef_unspecified_int4) ) THEN

            n1 = arg_lo_ss(F_AXIS,ARG1)
            DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

            m1 = arg_lo_ss(E_AXIS,ARG1)
            DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

            l1 = arg_lo_ss(T_AXIS,ARG1)
            DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

               k1 = arg_lo_ss(Z_AXIS,ARG1)
               DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

                  a = arg_1(imatch,jmatch,k1,l1,m1,n1)
                  IF ( a .NE. bad_flag(ARG1) ) THEN
                     result(i,j,k,l,m,n) = 
     .                     arg_1(imatch,jmatch,k1,l1,m1,n1)
                  ELSE
                     result(i,j,k,l,m,n) = bad_flag_result
                  ENDIF

                  k1 = k1 + arg_incr(Z_AXIS,ARG1)
 300           CONTINUE

               l1 = l1 + arg_incr(T_AXIS,ARG1)
 400        CONTINUE

               m1 = m1 + arg_incr(E_AXIS,ARG1)
 500        CONTINUE

               n1 = n1 + arg_incr(F_AXIS,ARG1)
 600        CONTINUE

         ELSE

*  Data coordinates do not match (xpts,ypts) coordinates

            n1 = arg_lo_ss(F_AXIS,ARG1)
            DO 650 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

            m1 = arg_lo_ss(E_AXIS,ARG1)
            DO 550 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

            l1 = arg_lo_ss(T_AXIS,ARG1)
            DO 450 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

               k1 = arg_lo_ss(Z_AXIS,ARG1)
               DO 350 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

                  result(i,j,k,l,m,n) = bad_flag_result

                  k1 = k1 + arg_incr(Z_AXIS,ARG1)
 350           CONTINUE

               l1 = l1 + arg_incr(T_AXIS,ARG1)
 450        CONTINUE

               m1 = m1 + arg_incr(E_AXIS,ARG1)
 550        CONTINUE

               n1 = n1 + arg_incr(F_AXIS,ARG1)
 650        CONTINUE

         ENDIF


         i2 = i2 + arg_incr(X_AXIS,ARG2)
         i3 = i3 + arg_incr(X_AXIS,ARG3)
 100  CONTINUE

      RETURN

 999  CALL ef_bail_out (id, err_msg)
      RETURN

      END

        SUBROUTINE CD_GET_T0(filename, units_string, calendar_string,
     .                  agg_cal_id, unit_code, t0_string, status)
 
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*.
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Given the a CF time units string of the form "<time units> since <T0>"
* (or a historical bevvy of alternative formats from per cd_get_1_axis)
* extract the units and T0 string and convert T0 into a standard Vax format of
* dd-mon-yyyy:hh:mm:ss, where "mon" is a 3-letter month name

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V695+  10/15 *sh* new routine extracted from code in cd_get_1_axis
* V698  4/16 *acm* new TM_UNITS_CAL to account for calendar in units id

* argument definitions:
*       filename (input)
*               - name of file being processed
*       units_string (input)
*               - string associated with the units attribute in a CF file
*       calendar_string (input)
*               - string associated with the calendar attribute in a CF file
*       agg_cal_id (input) - id calendar used by file1 of the aggregation
*       unit_code(output)  - time units of this file
*       t0_string (output) - T0 string in standard Vax form
*       status    (output) - return status

* include files
        include 'tmap_errors.parm'
#include "gt_lib.parm"
        include 'calendar.decl'
        include 'errmsg.parm'
        include 'xio.cmn_text'

* argument declarations
        INTEGER  status, unit_code, agg_cal_id
        CHARACTER*(*) filename, units_string, calendar_string, t0_string

* local variable declarations:
        LOGICAL ok_cal, yyyymmdd_time, true_month
        INTEGER TM_LENSTR1, TM_UNIT_ID, TM_UNITS_CAL, 
     .           TM_GET_CALENDAR_ID, STR_UPCASE,
     .           flen, clen, slen, istat, since_T0
        CHARACTER cal_name*32, tunits*32, dbuf*3, buff*128
        REAL*8 TM_SECS_FROM_BC, 
     .         days_neg4713, days_1901_may68, secs_to_1901, secs_to_1968 

        INTEGER tt  ! nice short name
        EQUIVALENCE (tt,lunit_errors)

* parameter declarations
        REAL*8          psecs_per_day
        PARAMETER     ( psecs_per_day = 60.*60.*24. )

* initialize
        flen = TM_LENSTR1(filename)
        clen = TM_LENSTR1(calendar_string)
        t0_string = ' '

* check that the calendar of this file is consistent with the given agg_cal_id
* warning only if it is not
        IF (calendar_string .EQ. ' ') THEN
           cal_name= 'GREGORIAN'   ! default
        ELSE
           cal_name = calendar_string
        ENDIF
        CALL CD_GET_CALENDAR_NAME(cal_name, ok_cal)
        IF (ok_cal) ok_cal= agg_cal_id.EQ.TM_GET_CALENDAR_ID (cal_name)
        IF (.NOT.ok_cal) CALL TM_NOTE("calendar attribute "//
     .       calendar_string(:clen)//" in file "//filename(:flen)//
     .       " is inconsistent with file 1 of aggregation. Ignored", tt)

* units_string typ will contain "tunits since T0_date"
        buff = units_string
        since_T0 = MAX( INDEX(buff,'since'), INDEX(buff,'SINCE') )
        yyyymmdd_time = buff(1:15) .EQ. 'yyyymmddhhmmss'

        IF ( since_T0 .GT. 2 ) THEN
           tunits = buff(:since_T0-1)  ! just the "units" name
           istat = STR_UPCASE( dbuf, buff(1:3) )
           slen = TM_LENSTR1(buff)
           IF ( slen .GT. since_T0 + 5) THEN
              IF (buff(since_T0+6:since_T0+10) .EQ. '-4713' .AND.
     .            dbuf .EQ. 'DAY')  THEN

c  This is the simple conversion; but we will reset the origin to 1901.
c               buff = 'DAYS since 1968-05-23 00:00:00'
c               days_neg4713 = 2440000.D0

                 buff = 'DAYS since 1901-01-15 00:00:00'
                 secs_to_1901 = TM_SECS_FROM_BC 
     .                        (GREGORIAN, 1901,1,15,0,0,0,status)
                 secs_to_1968 = TM_SECS_FROM_BC 
     .                        (GREGORIAN, 1968,5,23,0,0,0,status)
                 days_1901_may68 = (secs_to_1968 - secs_to_1901)/
     .                             psecs_per_day
                 days_neg4713 = 2440000.D0 - days_1901_may68
              ENDIF
              CALL TM_DATE_REFORMAT(buff(since_T0+6:),pdate_numslashnum,
     .                            agg_cal_id, t0_string,
     .                            pdate_vax, .FALSE., status )

c fix for bug 1394
c If the part after since is not a date/time, just keep the whole
c string as the units.  i.e., "days_since_event".
              IF ( status .NE. merr_ok ) THEN   
                 tunits = buff(:slen)
                 t0_string = ' '
                 status = merr_ok
              ENDIF
           ELSE
              T0_string = ' '        ! no T0 is present
           ENDIF
        ELSEIF ( yyyymmdd_time ) THEN
           tunits = 'days'
           t0_string  = 'yyyymmdd' ! relevant?  untested code as of 11/2015
        ELSE
           tunits = buff
           t0_string = ' '
        ENDIF

* decode the units
        unit_code = TM_UNIT_ID( tunits )

* Named calendar with unit=year gets length of year in that calendar.
      IF (unit_code .EQ. -6 .OR. unit_code .EQ. -10) THEN
         IF (agg_cal_id .EQ. d360) unit_code = -9
         IF (agg_cal_id .EQ. julian) unit_code = -12
	 IF (agg_cal_id .EQ. noleap) unit_code = -11
	 IF (agg_cal_id .EQ. all_leap) unit_code = -8
      ENDIF

* Named calendar with unit=month gets length of month in that calendar.
      IF (unit_code .EQ. -5) THEN
         IF (agg_cal_id .EQ. d360) unit_code = -14
         IF (agg_cal_id .EQ. julian) unit_code = -15
	 IF (agg_cal_id .EQ. noleap) unit_code = -13
      ENDIF

* Named calendar with unit=month or year gets length according to calendar's year length.

        true_month = .FALSE. ! initialize
	unit_code = TM_UNITS_CAL( unit_code, agg_cal_id, true_month )

        IF ( unit_code.EQ.0 .AND. tunits .NE. ' ' ) GOTO 5100

* successful completion
        status = merr_ok
        RETURN

* error exits
 5000   RETURN
 5100   CALL TM_ERRMSG (merr_badlinedef, status, 'CD_GET_T0',
     .                  no_descfile, filename(:flen),
     .                  'unintelligible units '//units_string,
     .                  no_errstring, *5000)
        END

	SUBROUTINE CREATE_AGG_DSET (agg_dset, dname, dpath, dtitle,
     .               nsets, dset1, agg_dim, iline, status)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP 
*
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V685 *acm*  3/13 For Ensemble aggregations, call the ds_type 'ENS'
* V695 *acm*  2/15 For Forecast aggregations, call the ds_type 'FCT'
* V695+ *sh*  11/15 Correct bugs in setting of aggregate dset title
* V698  *sh*  1/16 pass explicit path name (for "USE file.agg" compatibility)
* V7   *acm*  6/12 Add Union aggregations: DEFINE DATA/AGG/U

* calling argument
*   agg_dset	- dataset number of the aggregation (input)
*   dname	- name of the aggregated dataset (input)
*   dpath	- pathname of the aggregated dataset (input)
*   dtitle	- optional title string (input)
*   nsets	- number of datasets in the aggregation (input)
*   dset1	- dataset number of first (pattern) dataset in agg (input)
*   agg_dim	- idim number (5 or 6) of aggregation dimension (input)
*   iline	- ??
*   status	- return status (output)

      IMPLICIT NONE
        include 'tmap_errors.parm'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
	include 'xstep_files.cmn_text'
	include	'ferret.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xdset_info.cd_equiv'
        include 'xprog_state.cmn'
	include 'xtm_grid.cmn_text'  
	include 'errmsg.parm'
	include 'netcdf.inc'
	include 'xvariables.cmn'
	include 'xtext_info.cmn'

* calling argument declarations:
	CHARACTER*(*)	dname, dpath, dtitle
	INTEGER		agg_dset, nsets, dset1, agg_dim, iline, status

* local variable declarations:
	INTEGER TM_LENSTR, TM_LENSTR1, ALLO_MANAGED_AXIS,
     .		type, coordvar, varid, big_cx, nlen, istep
	CHARACTER LEFINT*20, ntext*20
	REAL	bad_flag

	CALL CD_INIT_AGG_DSET (agg_dset, dname, status)

	IF (status .NE. ferr_ok) GOTO 5300 

* Set the dataset type and title (can add other directions)
	IF (agg_dim .EQ. e_dim ) ds_type(agg_dset) = 'ENS'
	IF (agg_dim .EQ. f_dim ) ds_type(agg_dset) = 'FCT'
	IF (agg_dim .EQ. unspecified_int4 ) ds_type(agg_dset) = 'UNI'

	ds_name(agg_dset) = dname
	ds_des_name(agg_dset) = dpath

	IF (dtitle(1:2).EQ.char_init .OR. TM_LENSTR(dtitle).EQ.0) THEN
	   ntext = LEFINT(nsets, nlen)
	   IF (agg_dim.EQ.e_dim) THEN
	      ds_title(agg_dset) = "Ensemble"
	   ELSEIF (agg_dim.EQ.f_dim) THEN
	      ds_title(agg_dset) = "Forecast"
	   ELSE
	      ds_title(agg_dset) = "Union"
	   ENDIF
	   IF (agg_dim .EQ. unspecified_int4) THEN
	      ds_title(agg_dset) = 
     .	        'Union of variables from member datasets'
	   ELSE
	      ds_title(agg_dset) = ds_title(agg_dset)(:8)//' series of '
     .		//ntext(:nlen)//' datasets patterned on '//
     .		ds_name(dset1)
	   ENDIF
     
	ELSE
	   ds_title(agg_dset) = dtitle
	ENDIF
	ds_mod_title(agg_dset) = ' '
 
* assign a stepfile to this dataset (needed for consistency with other dsets)
        DO istep = 1,maxstepfiles
          IF (sf_setnum(istep) .EQ. set_not_open) THEN
	     sf_name  (istep) = dname
	     sf_setnum(istep) = agg_dset
             GOTO 100
          ENDIF
	ENDDO
* No room left for new stepfiles
       GOTO 5400
 
* create the aggregate axis
 100	IF (agg_dim .NE. unspecified_int4) 
     .		CALL CREATE_AGG_AXIS (nsets, agg_dim, iline, status)
	IF (status .NE. ferr_ok) GOTO 5300 

	RETURN
	
 5000   RETURN	
 5300   status = ferr_TMAP_error
	GOTO 5000
 5400	CALL ERRMSG(ferr_internal, status, 'create_agg_dset', *5000)
	END

	DOUBLE PRECISION FUNCTION TSTEP_TO_SECS( grid, idim, tstep )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* convert a time step value relevant on a particular grid, "grid" into an
* absolute time measured in seconds from 1-JAN-0000:00:00:00

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 7/27/88
* V320: 12/94 - bug fix: not based on TSTEP_TODATE because the returned
*	"date" string blanks out years 0000 and 0001 ==> cannot distinguish
* V530: *acm* 12/00 add calendar types; cal_id
*       *acm* 3/12 6D Ferret: Add E and F dimensions 
*                  A time axis may be a T axis or F axis, so idim is now an arg.
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.

        IMPLICIT NONE
	include 'tmap_dims.parm'
        include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xunits.cmn_text'
        include 'ferret.parm'

* calling argument declarations:
	INTEGER	grid, idim
	REAL*8	tstep

* internal variable declarations:
	LOGICAL		ITSA_TRUEMONTH_AXIS
	INTEGER		TM_GET_CALENDAR_ID, axis, status, cal_id,
     .                  prev_cal_id
!	CHARACTER*20	date
	REAL*8		SECS_FROM_BC, start_secs, offset_secs,
     .                  tstep_new, unit_convert

* internal parameter declarations:
	INTEGER		seconds
	PARAMETER     ( seconds = 6 )

* determine time axis of grid
	axis = grid_line( idim, grid )

* valid time axis ?
	IF ( line_direction( axis ) .EQ. 'TI'. OR.  
     .       line_direction( axis ) .EQ. 'FI' ) THEN

* determine time axis of grid

	   cal_id = TM_GET_CALENDAR_ID ( line_cal_name(axis) )

! pre 12/94 algorithm
!* convert time step to date of format dd-mmm-yyyy:hh:mm:ss
!	   CALL TSTEP_TO_DATE ( grid, tstep, seconds, date )
!
!* convert date to seconds since 1-JAN-0000:00:00:00
!	   TSTEP_TO_SECS = SECS_FROM_BC( date, status )

* First find the offset from 01-JAN-0000 00:00:00 from the descriptor file
	   start_secs = SECS_FROM_BC( line_t0(axis), cal_id, status )

* If the tstep is negative, it was computed in default calendar
c (looked at this as part of fix to 1365, but it it correct in general?)
c           prev_cal_id = 1
c           tstep_new = tstep
c           IF (tstep .LT. 0) THEN
c              IF (prev_cal_id .NE. cal_id) 
c     .            CALL reset_secs_from_bc (-tstep, 
c     .		     tstep_new, prev_cal_id, cal_id, status)
c           ENDIF

* Find the number of seconds since start of data set for this time step

	   unit_convert = line_tunit(axis)
	   IF (ITSA_TRUEMONTH_AXIS(axis)) unit_convert =  un_convert(pun_day)

	   offset_secs = tstep* unit_convert

* Total seconds to this time step since 01-JAN-0000 00:00:00
	   TSTEP_TO_SECS = start_secs + offset_secs

	ELSE

* not a valid time axis
	   TSTEP_TO_SECS = tstep

	ENDIF
	RETURN
	END

* 
*  cmprsi_by.F
* 
*  Steve Hankin
*  12/27/2000
* 
*  Compress argument 1 along axis I by the mask given in argument 2
*  Argument 2 may be multidimensional
 
*  In this subroutine we provide information about
*  the function.  The user configurable information 
*  consists of the following:
* 
*  descr              Text description of the function
* 
*  num_args           Required number of arguments
* 
*  axis_inheritance   Type of axis for the result
*                        ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                        CUSTOM          - user defined axis
*                        IMPLIED_BY_ARGS - same axis as the incoming argument
*                        NORMAL          - the result is normal to this axis
*                        ABSTRACT        - an axis which only has index values
* 
*  piecemeal_ok       For memory optimization:
*                        axes where calculation may be performed piecemeal
*                        ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE cmprsi_by_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,'Compress arg1 by (multi-D) mask in arg 2' )

      CALL ef_set_num_args(id, 2)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, ABSTRACT, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'dat')
      CALL ef_set_arg_desc(id, arg, 'variable to compress on I axis')
      CALL ef_set_axis_influence(id, arg, NO, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'mask')
      CALL ef_set_arg_desc(id, arg,
     .          'valid/bad points guiding compression (multi-D)')
      CALL ef_set_axis_influence(id, arg, NO, YES, YES, YES)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END






*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE cmprsi_by_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER my_hi_i, lmsk
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

*
*     Use utility functions to get context information about the arguments.
*

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      my_hi_i = arg_hi_ss(X_AXIS,1) - arg_lo_ss(X_AXIS,1) + 1

      lmsk    = arg_hi_ss(X_AXIS,2) - arg_lo_ss(X_AXIS,2) + 1
      IF ( lmsk .LT. my_hi_i ) my_hi_i = lmsk

      CALL ef_set_axis_limits(id, X_AXIS, 1, my_hi_i)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END



* 
*  In this subroutine we compute the result
* 
      SUBROUTINE cmprsi_by_compute(id, arg_1, arg_2, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy,
     .	   mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy,
     .     mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1
      INTEGER i2, j2, k2, l2
      INTEGER nout, ilo

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      ilo = res_lo_ss(X_AXIS)

* pre-fill the entire output result with missing value flags
*  (since each I-sequence in mask may have different number of valid pts)
      DO 40 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         DO 30 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            DO 20 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
               DO 10 i=ilo, res_hi_ss(X_AXIS)
 10            result(i,j,k,l) = bad_flag_result
 20         CONTINUE
 30      CONTINUE
 40   CONTINUE

* fill in the points as specified by the mask
      l1 = arg_lo_ss(T_AXIS,ARG1)
      l2 = arg_lo_ss(T_AXIS,ARG2)
      DO 400 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         j2 = arg_lo_ss(Y_AXIS,ARG2)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            k2 = arg_lo_ss(Z_AXIS,ARG2)
            DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               nout = 0
               i1 = arg_lo_ss(X_AXIS,ARG1)
               i2 = arg_lo_ss(X_AXIS,ARG2)
               DO 100 i=ilo, res_hi_ss(X_AXIS)

                  IF ( arg_2(i2,j2,k2,l2) .NE. bad_flag(2) ) THEN
                     IF ( arg_1(i1,j1,k1,l1) .EQ. bad_flag(1)  ) THEN
                        result(ilo+nout,j,k,l) = bad_flag_result
                     ELSE
                        result(ilo+nout,j,k,l) = arg_1(i1,j1,k1,l1) 
                     END IF
                     nout = nout + 1
                  ENDIF

                  i1 = i1 + arg_incr(X_AXIS,ARG1)
                  i2 = i2 + arg_incr(X_AXIS,ARG2)
 100           CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
               k2 = k2 + arg_incr(Z_AXIS,ARG2)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
            j2 = j2 + arg_incr(Y_AXIS,ARG2)
 300     CONTINUE

         l1 = l1 + arg_incr(T_AXIS,ARG1)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
 400  CONTINUE
      
         
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* fc_isubset.F
*
* Ansley Manke 11/28/2011
* See ticket 1897
*
* This function returns a subset of data given start indices and
* sizes of features in a 1D array.
*

*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE fc_isubset_init(id)

      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

      CALL ef_version_test(ef_version)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id, 'Returns a subset of a feature collection' )

      CALL ef_set_num_args(id, 4)
      CALL ef_set_axis_inheritance(id, CUSTOM, NORMAL, NORMAL, NORMAL)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'index_list')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 
     .     'starting indices of features of interest')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'lengths')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 
     .     'lengths of the features of interest')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'nx')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 
     .      'length of result (sum of lengths in arg 2)')
      CALL ef_set_arg_unit(id, arg, ' ')

      arg = 4
      CALL ef_set_arg_name(id, arg, 'FullData')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 
     .     'input data: 1D list from which to select features')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

      SUBROUTINE fc_isubset_result_limits(id)

      INCLUDE 'EF_Util.cmn'

      INTEGER id


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

* Get the size of the output axis from arg 3

      INTEGER nx, iarg
      REAL val

      iarg = 3
      CALL ef_get_one_val(id, iarg, val)
      nx = INT(val)

      call ef_set_axis_limits(id, X_AXIS, 1, nx)


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


      SUBROUTINE fc_isubset_custom_axes(id)

      INCLUDE 'EF_Util.cmn'

      INTEGER id


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

* Get the size of the output axis from arg 3

      INTEGER nx, iarg
      REAL val

      iarg = 3
      CALL ef_get_one_val(id, iarg, val)
      nx = INT(val)

      CALL ef_set_custom_axis (id, X_AXIS, 1., val, 1., 'X', NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE fc_isubset_compute(id, arg_1, arg_2, arg_3, arg_4, result)

      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

	  INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, 
     .           mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, 
     .           mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, 
     .           mem4loz:mem4hiz, mem4lot:mem4hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1
      INTEGER i2, j2, k2, l2
      INTEGER i4, j4, k4, l4
      INTEGER m, n, count
      CHARACTER*100 errtxt

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)


* check that the lists are 1D

      errtxt = 'Argument 1 must be a 1D list'
      n = arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 1
      DO i = Y_AXIS, T_AXIS
         m = arg_hi_ss(i,ARG1) - arg_lo_ss(i,ARG1) + 1 
         IF (n.GT.1 .AND. m.GT.1) GOTO 9000
         n = MAX(n,m)
      ENDDO

      errtxt = 'Argument 2 must be a 1D list'
      n = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1
      DO i = Y_AXIS, T_AXIS
         m = arg_hi_ss(i,ARG2) - arg_lo_ss(i,ARG2) + 1
         IF (n.GT.1 .AND. m.GT.1) GOTO 9000
         n = MAX(n,m)
      ENDDO
      
* Put the requested features into the result

      i2=arg_lo_ss(X_AXIS,ARG2)
      j2=arg_lo_ss(Y_AXIS,ARG2)
      k2=arg_lo_ss(Z_AXIS,ARG2)
      l2=arg_lo_ss(T_AXIS,ARG2)

      i = res_lo_ss(X_AXIS)

      DO 500 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)
      DO 500 j1 = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)
      DO 500 k1 = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)
      DO 500 l1 = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)
         IF ( arg_1(i1,j1,k1,l1) .EQ. bad_flag(1) ) GOTO 600  ! done
         IF ( arg_2(i2,j2,k2,l2) .EQ. bad_flag(2) ) GOTO 600

	 i4 = INT(arg_1(i1,j1,k1,l1))     ! start index
         count = INT(arg_2(i2,j2,k2,l2))  ! number to put

         l4 = arg_lo_ss(T_AXIS,ARG4)
         DO 400 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
	    k4 = arg_lo_ss(Z_AXIS,ARG2)
            DO 300 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
               j4 = res_lo_ss(Y_AXIS)
	       DO 200 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

                  DO 100 n = 1, count
                     result(i,j,k,l) = arg_4(i4,j4,k4,l4)
                     i4 = i4 + 1
                     i = i + 1
 100              CONTINUE
 
                  j4 = j4 + arg_incr(Y_AXIS,ARG4)
 200           CONTINUE
               k4 = k4 + arg_incr(Z_AXIS,ARG4)
 300        CONTINUE

            l4 = l4 + arg_incr(T_AXIS,ARG4)
 400     CONTINUE

      i2 = i2 + arg_incr(X_AXIS,ARG2)
      j2 = j2 + arg_incr(Y_AXIS,ARG2)
      k2 = k2 + arg_incr(Z_AXIS,ARG2)
      l2 = l2 + arg_incr(T_AXIS,ARG2)
 500  CONTINUE

 600  CONTINUE
      
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
 9000 CALL EF_BAIL_OUT(id, errtxt)
      END

	SUBROUTINE SYMBOL_COMMAND( buffer, clen, did_sub, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* check to see if any PLOT+ symbols were used and replace the first one with
* the "value" string if so

* replacing only the first allows the calling routine to trap recursions
* and makes the logic simpler ... it is not optimal, however, for performance

* note that additional logic in this routine allows it to detect nested 
* PLOT+ symbols (e.g. "($lab_($lab_title))" where lab_title="4" would first
* translate to "($lab_4)" and then resolve this symbol

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V400: *sh* 6/1/95 - based on ALIAS_COMMAND
* V420: *sh* 10/9/95 - added PPL$XPIXEL and PPL$YPIXEL
*	      11/95 - bug fix: single character symbols not translated
*	       3/96 - allow the same coaching (string substitution) options
*			for editing symbols that exists for numbered
*			"dollar arguments" to GO files
* V430	*kob* 11/96 - Need to avoid passing a concatenated string as
*		      on argument to COACHED_STR_SUB routine for sgi. 
*		      added crptd_cat_argument ifdef and set it to true
*		      for sgi
* Linux Port *kob* 12/96 - had to remove a single quote from a comment line
* 
* v491b2 - *kob* 3/98 - fixed sgi only bug introduced by 11/96 change.  erroneously
*                       reused "clen" argument..changed it to clen2
*      *js* 4/99 - yet another Ferret hack to add a byteorder symbol -- value
*                can be BIG or LITTLE
* v500 5/99 *kob* - bug fix:  erroneous error trap for single character symbol 
*                             replacement
* V522 7/00 *sh* - hack to add symbol "FERRET_VERSION"
*	         - call upon the new routine SPECIAL_SYMBOL
* 2/03 *kob* - g77 port - g77 won't allow intrinsic functions in PARAMETER
*                         statements.  use an octal constant instead 
* 9/06 *acm* 6.01  fixing bug 1439 long symbol values; change length of symval to 2048
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long

        IMPLICIT NONE
* calling argument declarations:
	LOGICAL	  did_sub
	INTEGER	  clen, status
	CHARACTER buffer*(*)

*11/96 *kob*
#ifdef sgi
#  define crptd_cat_argument
#endif


* internal variable declarations:
	LOGICAL coaching
	INTEGER	STR_UPCASE, lenbuff, spos, epos, nchar, ierr,
     .		i, i2, coach_start, coach_end, sym_end
	CHARACTER symname*120, c1*1,
     .					symval*2048
!     .					symval*255 ! to match PPLUS

* internal parameter declarations:
	CHARACTER*1     tab
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
#else
	PARAMETER     ( tab = CHAR(9))
#endif


* 11/96 *kob*
#ifdef crptd_cat_argument
	INTEGER clen2
	CHARACTER cat_argument*48
#endif 

	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xcommand.cmn'
	include 'xrisc.cmn'

* initialize
	did_sub = .FALSE.
	status = ferr_ok

* immediate exit if there are no symbols in the line
	spos = INDEX( buffer(:clen), '($' )
	IF ( spos .EQ. 0 ) RETURN

* initialize to continue
	risc_buff = buffer	! ready for error messages (f77 "//" Unix bug)
	lenbuff = LEN( buffer )

* locate the closing parenthesis
* but watching out for a nested "($" as in the commens above
	epos = spos + 2
100	CONTINUE
* ... check for nested symbols
	   IF ( epos .LE. clen-2 ) THEN
	      IF ( buffer(epos:epos+1) .EQ. '($' ) THEN
	         spos = epos	! new starting point
	         epos = epos + 2
	         GOTO 100
	      ENDIF
	   ENDIF
* ... check for closing parenthesis	         
	   IF ( buffer(epos:epos) .EQ. ')' ) GOTO 110
	   epos = epos + 1
	IF ( epos .LE. clen ) GOTO 100
	GOTO 5100	! no closing paren was supplied
 110	sym_end = epos - 1

* 3/96 identify and locate any "coaching" text that accompanies the symbol
* ... look for a character between '!' and '&' in the ASCII table
*     but not a dollar sign
	coaching = .FALSE.
	DO 150 i = spos+2, epos-1
	   c1 =  buffer(i:i)
	   IF (c1.GE.'!' .AND. c1.LE.'&' .AND. c1.NE.'$') THEN
	      coaching = .TRUE.
	      sym_end = i - 1
	      coach_start = i + 1
	      GOTO 151		! break out of loop
	   ENDIF
 150	CONTINUE
 151	CONTINUE

* if coaching text was supplied then locate the coaching end
	IF ( coaching ) THEN
* ... locate the terminating coach character (if supplied)
	   coach_end = epos - 1			! default if no closing char
	   DO 170 i = coach_start, epos-1
	      IF ( c1 .EQ.  buffer(i:i) ) THEN
* ... make sure there is only white space filling out the parens
	        DO 160 i2 = i+1, epos-1
 160	        IF ( buffer(i2:i2) .NE. ' '
     .	      .AND.  buffer(i2:i2) .NE. tab ) GOTO 5300
	        coach_end = i-1
	        GOTO 171
	      ENDIF
 170	   CONTINUE
 171	   CONTINUE
	ENDIF

* translate the symbol name
* ierr=0 means success;   ierr=1 means symbol not found
 	IF ( spos+2 .LE. sym_end ) THEN 	! 11/95 bug fix: "LT" --> "LE"
!	   symname = buffer(spos+2:sym_end)	! change case for PPL$XPIXEL
	   ierr = STR_UPCASE( symname, buffer(spos+2:sym_end) )	! 10/95
* ... check for special internal Ferret symbols 
	   CALL SPECIAL_SYMBOL(0, symname, symval, nchar)
	   IF (nchar .EQ. 0) THEN
* ... translate a standard PLOT+ symbol
	      CALL GETSYM(symname, symval, nchar, ierr)
	      IF ( ierr .EQ. 1 ) nchar = 0	! use NULL string if undefined
	   ENDIF
	ELSE
	   nchar = 0
	ENDIF

* perform the coached text substitution, if requested
	IF ( coaching ) THEN
* 4/99 *kob* bug fix  - change below to .GT. from .GE
	   IF (coach_start .GT. coach_end) GOTO 5400
*11/96 *kob* - concatenation w/in procedure call corrupted on sgis. !kob 12/96
#ifdef crptd_cat_argument	
	   cat_argument = 'symbol '//buffer(spos+2:sym_end)
	   clen2 = MIN(48,7 + sym_end-spos-1)
	   CALL COACHED_STR_SUB( cat_argument(:clen2),
     .		symval, buffer(coach_start:coach_end), risc_buff,
     .		nchar, status ) 
#else
	   CALL COACHED_STR_SUB( 'symbol '//buffer(spos+2:sym_end),
     .		symval, buffer(coach_start:coach_end), risc_buff,
     .		nchar, status ) 
#endif
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   symval = risc_buff(:nchar)
	ENDIF

* substitute the value text for the symbol name and the enclosing quotes
        IF ( clen + (nchar-(epos-spos+1)) .GT. lenbuff ) THEN
           GOTO 5200					! too big to fit
        ELSE
* ... place the "value" string into risc_buff
	   IF ( nchar .EQ. 0 ) THEN
	      risc_buff = ' '
	      nchar = 1
	   ELSE
*             Appending space just to get rid of a nonsense compiler warning
	      risc_buff = symval(:nchar)//' '
	   ENDIF
* ... append onto it anything to the right of the symbol in the cmnd buffer
	   IF ( epos .LT. clen ) THEN
	      risc_buff(nchar+1:) = buffer(epos+1:)
	      nchar = nchar + (clen-epos)
	   ENDIF
* ... replace the symbol name and all that is to the right	   
           buffer(spos:) = risc_buff(:nchar)
           clen = (spos-1) + nchar
        ENDIF

* successful substitution
	did_sub = .TRUE.

* error exits
 5000	RETURN
 5100	CALL ERRMSG( ferr_syntax, status, 'no closing symbol paren: '//
     .		risc_buff(spos:clen), *5000)
 5200	CALL ERRMSG( ferr_invalid_command, status,
     .		'symbol substitution makes line too long'//pCR//
     .		symname(:epos-spos-2)//' = '//symval(:nchar), *5000)
 5300	CALL ERRMSG( ferr_syntax, status,
     .		'stray characters at symbol end: '//
     .		risc_buff(spos:epos), *5000)
 5400	CALL ERRMSG( ferr_syntax, status,
     .		'empty argument replacement string: '//
     .		risc_buff(spos:epos), *5000)
	END

	SUBROUTINE TM_deallo_dyn_grid( grid )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Deallocate a grid from the dynamic grid area (above max_grids)

* Steve Hankin  NOAA/PMEL/TMAP

* 9/13/95 for Ferret version 4.2
* V510 *sh* 4/00 - remove actual deallocation of grid to tm_deallo_dyn_grid_sub
*		 - this routine can now be called for static grids, too
*		 - deallocate lines only for dynamic grids, since static grids
*		   do not get deleted when their use count falls to zero
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing

* Include files
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'tmap_errors.parm'
	include 'xtm_grid.cmn_text'
		include 'xio.cmn_text'

* Argument definitions
	INTEGER grid

* Local definitions
	INTEGER idim

* deallocate the grid, itself
	CALL TM_DEALLO_DYN_GRID_SUB(grid)

* if the grid was actually removed, then also deallocate the axes that it used
* Check first that the grid number is in range

	IF ( grid .GT. max_grids) THEN
        IF ( grid_use_cnt(grid) .EQ. 0 ) THEN

*release claim to any dynamic lines this may use
	   DO 100 idim = 1, nferdims
	      CALL TM_DEALLO_DYN_LINE( grid_line(idim,grid))
 100	   CONTINUE

	ENDIF
	ENDIF

* successful completion
	RETURN

	END

	LOGICAL FUNCTION CD_GET_BOUNDS ( cdfid, ivar, lo, hi, tmrecdim,
     .                                   status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Get the bounds of the hyperslab of the given netCDF variable relative
* to its parent grid in the TMAP Common

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 3/92
*
* 15apr94 *kob* Need to initialzie cd_get_bounds in case of error 
*		exit
*
* 2jun94 *kob* cd_get_bounds needs to be initialazed with boolean .FALSE.
* 		instead of 0.
* 10/96 *kob* - Linux port - had to move variable assignments off of
*		declaration line.
* V500 4/99 *kob*: increase size of vname and buff from 24 to 64
* V533 *sh* 6/01 - add support for string variables (NF_CHAR)
* V500 4/99 *kob*: increase size of vname and buff from 24 to 64
* V552 *acm* 5/03   increase vname and buff to 128 chars 
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing
* TODO: initially leave this as 4D -- what to do with old files that have 4 slab min/max?

* argument definitions:
*	cdfid   - id of currently open CDF file
*       ivar    - CDF variable ID of the desired variable
*       lo      - array of (nferdims) lower bounds subscripts
*       hi      - array of (nferdims) upper bounds subscripts
*       tmrecdim- returned axis (1-nferdims) which is CDF record dimension (or 0)
*       status  - returned TMAP status

* include files
        include 'netcdf.inc'
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "gt_lib.parm"
	include 'cd_lib.parm'
        include 'xio.cmn_text'
        external xio_data

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"


* argument declarations:
	INTEGER	 cdfid, ivar, lo(nferdims), hi(nferdims), tmrecdim, status

* local variable declarations:
* *kob* explicit definitions not allowed on decl line in linux...
*       moved it to parameter line 10/96
      LOGICAL CD_GET_ATTVAL, got_lo, got_hi,
     .        do_warn
      PARAMETER (do_warn = .TRUE. )
      INTEGER TM_LENSTR1,
     .        ndims, nvars, cdfstat, vbacklo, vbackhi, idim,
     .        vartyp, nvdim, vdims(8), nvatts, vlen,
     .        ngatts, npts, recdim
      REAL    r4_lo(nferdims), r4_hi(nferdims)
      CHARACTER vname*128, buff*128

      INTEGER tt  ! nice short name
      EQUIVALENCE (tt,lunit_errors)

* initialize
        tmrecdim = 0   ! may be changed, below
* ibm compiler didn't like initializing cd_get_bounds to 0, so *kob* 
* changed it to .false.  2jun94
	CD_GET_BOUNDS = .FALSE.     !in case of error exit
* get the vital statistics for the CDF file
#ifdef usingDODSf2cUnderscore
        cdfstat = NF_INQ_( cdfid, ndims, nvars, ngatts, recdim)
#else
        cdfstat = NF_INQ( cdfid, ndims, nvars, ngatts, recdim)
#endif

* if it is a character variable, then the first dimension of it is the strlen
        IF (vartyp .EQ. NF_CHAR) THEN
	   DO idim = 1, 5
	      vdims(idim) = vdims(idim+1)
	   ENDDO
	   nvdim = nvdim - 1
	ENDIF

* get the vital statistics for this variable
#ifdef usingDODSf2cUnderscore
        cdfstat = NF_INQ_VAR_(cdfid, ivar, vname, vartyp, nvdim,
     .              vdims, nvatts)
#else
        cdfstat = NF_INQ_VAR (cdfid, ivar, vname, vartyp, nvdim,
     .              vdims, nvatts)
#endif
        vlen = TM_LENSTR1(vname)


* get the lower bounds
        got_lo = CD_GET_ATTVAL( cdfid, ivar, 'slab_min_index',
     .           do_warn,vname(:vlen),r4_lo,nferdims,vbacklo )
        IF ( got_lo ) THEN
          DO 100 idim = 1, 4
 100      lo(idim) = r4_lo(idim) !fp->int
	  IF (nferdims .GT. 4) THEN
          DO 110 idim = 5, nferdims
 110         lo(idim) = unspecified_int4
	  ENDIF
        ENDIF

* get the upper bounds
        got_hi = CD_GET_ATTVAL( cdfid, ivar, 'slab_max_index',
     .           do_warn,vname(:vlen),r4_hi, nferdims, vbackhi )

        IF ( got_hi ) THEN
          DO 200 idim = 1, 4
 200      hi(idim) = r4_hi(idim) !fp->int
	  IF (nferdims .GT. 4) THEN
             DO 220 idim = 5, nferdims
 220         hi(idim) = unspecified_int4
	  ENDIF
        ENDIF

* check for consistency
        IF ( got_lo .NEQV. got_hi ) GOTO 5200
        IF ( got_lo .AND. (vbacklo.NE.4.OR.vbackhi.NE.4) ) GOTO 5300
        IF ( .NOT.got_lo ) GOTO 1000
        IF ( recdim .EQ. -1 ) GOTO 1000     ! no record axis in file ?

* the record dimension of the variable may have a flag, only
* if so substitute the full size of the record dimension
        DO 300 idim = 1, 4
           IF ( hi(idim) .EQ. pcdf_recdim ) THEN
              IF ( tmrecdim .NE. 0 ) GOTO 5100
              tmrecdim = idim
           ENDIF
 300    CONTINUE
        IF ( tmrecdim .NE. 0 ) THEN
#ifdef usingDODSf2cUnderscore
	   cdfstat = NF_INQ_DIM_( cdfid, recdim, buff, npts )
#else
	   cdfstat = NF_INQ_DIM( cdfid, recdim, buff, npts )
#endif
	   lo(tmrecdim) = 1
           hi(tmrecdim) = npts
        ENDIF

* check for reasonable slab limits
        DO 400 idim = 1, 4
           IF ( idim .EQ. tmrecdim ) GOTO 400
           IF ( lo(idim).LE.0 .OR. hi(idim).LE.0
     .     .OR. lo(idim) .GT. hi(idim) )           GOTO 5400
 400    CONTINUE

* successful completion
 1000   CD_GET_BOUNDS = got_lo
        status = merr_ok
        RETURN

* error exits
 5100   CALL TM_ERRMSG(pcdferr+pcdferrmax,
     .         status, 'CD_GET_BOUNDS', cdfid, ivar, 
     .         'More than one record dimension in "slab_min_index": '
     .         //vname(:vlen), no_errstring, *5000 )

 5200    CALL TM_ERRMSG(pcdferr+pcdferrmax,
     .         status, 'CD_GET_BOUNDS', cdfid, ivar,
     .         'Must give both min and max "slab_m**_index" values: '
     .         //vname(:vlen),  no_errstring, *5000 )

 5300    CALL TM_ERRMSG(pcdferr+pcdferrmax,
     .         status, 'CD_GET_BOUNDS', cdfid, ivar,
     .         'Must be exactly 4 "slab_m**_index" values: '
     .         //vname(:vlen),  no_errstring, *5000 )

 5400    CALL TM_ERRMSG(pcdferr+pcdferrmax,
     .         status, 'CD_GET_BOUNDS', cdfid, ivar,
     .         'Non-positive or disordered "slab_m**_index" values: '
     .         //vname(:vlen),  no_errstring, *5000 )

 5000   RETURN
	END

	SUBROUTINE CD_READ ( dset, ivar,
     .		a_lo_x, a_lo_y, a_lo_z, a_lo_t, a_lo_e, a_lo_f,
     .		a_hi_x, a_hi_y, a_hi_z, a_hi_t, a_hi_e, a_hi_f,
     .		use_lo, use_hi, stride,
     .		var, sf_num, status )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Reads a 4D block of data (lower D being a degenerate case with dimensions
* being 1 point thick) from a netCDF file
*
* replaced "elif" syntax with
*       else
*          if
*  for SGI port  - kob 4/8/92
*
* written 2/92 by Steve Hankin for PMEL/TMAP

* bug fix 10/92 - modulo reads require use_lo/hi .NE. dimensioned lo/hi
*         11/92 - allow 24 character variable names
* 5/94 - allow reading of DOUBLE variables using routine cd_rd_r8_as_r4.c
* 8/94 - modulo error message (5400) prints wrong axis
* 2/95 - small change to allow negative ds_ordering to represent reversed axis
* 10/96 *kob* - Linux port - had to move variable assignments off of
*		declaration line.
* 5/99 *sh* (V5.0) - implement strides, reversals, and permutations 
* 3/00 *kob* (v5.1) - use netcdf v3 calls to read double precision data
*		rather than having to call cd_rd_r8_as_r4 
* V510 6/00 *sh* - remove obsolete code left behind by 3/00 fix
*		 - if variable is scalar fill in trans and grid_dims
* V521 7/00 *kob* - modify calculation of totsize to take any striding into
*                   account.
* v531 5/01 *kob* - fix erroneous error report referencing cd_rd_r8_as_r4
* v552 4/03 *acm* - Changes for SET VAR/SCALEFAC/OFFSET: apply new scale
*                   and offset.
* V600 11/05 *acm*  Fix bug 491 properly -- send missing value to tm_scale
*                   so that missing data is NOT scaled by scale and offset attrs.
* V600  6/06 *acm*  needed call to CD_GET_VAR_INFO to define vname for NC_GET_ATTRIB
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V67  *acm* 1/11  Choose between routinesi from the NetCDF API: varm if permutations,
*                  vars if strides but no perm, var if no strides or perm.
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing

* include files
        include 'netcdf.inc'
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'		! data set dimension
#include "gt_lib.parm"
	include 'xdset_info.cmn_text'	! data set info common
	external xdset_info_data
	include 'xstep_files.cmn_text'	! step file common
	external xstep_files_data
        include 'xdset_info.cd_equiv'
#ifdef sun
        include 'xmachine_byte.cmn'
#else
        include 'xmachine_int1.cmn'
#endif


* arguments:
*	dset        - internal data set # (from GT_INIT_DSET)
*	ivar        - position in common of variable information
*       actual_dims - "a_" full dimensions of data_grid array passed
*	use_lo      - low indices of model data block desired
*	use_hi      - high indices of model data block desired
*	stride	    - every nth point to be read from disk file
*	var         - array containing model data (output)
*	sf_num      - stepfile number (returned from GT_FIND_TSTEP (output)
*	status      - error status upon completion (output)
*
	INTEGER		dset, ivar, sf_num, status, ndim,
     .		a_lo_x, a_lo_y, a_lo_z, a_lo_t, a_lo_e, a_lo_f,
     .		a_hi_x, a_hi_y, a_hi_z, a_hi_t, a_hi_e, a_hi_f,
     .			use_lo(nferdims), use_hi(nferdims), stride(nferdims)
	REAL     	var(a_lo_x:a_hi_x,
     .                      a_lo_y:a_hi_y,
     .                      a_lo_z:a_hi_z,
     .                      a_lo_t:a_hi_t,
     .                      a_lo_e:a_hi_e,
     .                      a_lo_f:a_hi_f)


* local definitions
* *kob* explicit definitions not allowed on decl line in linux...
*       moved it to parameter line 10/96
	LOGICAL      NC_GET_ATTRIB, 
     .               do_warn, already_scaled, got_it, tf2, 
     .               coordvar
        INTEGER      TM_LENSTR1,
     .               cdfid, varid, idim, lasdim, cdfstat, dim, idim2,
     .               start(nferdims), filsize(nferdims), totsize, 
     .               dim_lo(nferdims),dim_hi(nferdims), imap(nferdims), 
     .		     trans(nferdims), memsize(nferdims), count(nferdims),
     .		     grid_dims(nferdims), fildim, memdim, filstride(nferdims),
     .               maxlen, attlen, attoutflag, vtype, nvdims, nvatts, 
     .               outflag, dlen, err_status, i, permuted, strided
        REAL vdims(10), val
	CHARACTER*1	dimnam(nferdims)
	CHARACTER*13	TM_STRING
        CHARACTER*128   buff, vname
	DATA  		dimnam/'I','J','K','L','M','N'/
	CHARACTER*1024 ebuff, upstr  ! for nf_ error message
	CHARACTER*10 TM_FMT, errcode

* special equivalence (cannot include in tmap_format/xdset_info.cd_equiv 
* because "BYTE" isn't supported on DECstation)
* 10/96 reorder the if def because linux cpp didn't like it

#ifdef unix
#ifdef sun
      BYTE cd_data_type(maxvars)
#else
      INTEGER*1 cd_data_type(maxvars)
#endif
#else
      BYTE cd_data_type(maxvars)
#endif
      EQUIVALENCE ( ds_precision, cd_data_type )

* initialize
        cdfid = sf_lunit(sf_num)
        varid = cd_varid(ivar)
        dim_lo(1) = a_lo_x
        dim_lo(2) = a_lo_y
        dim_lo(3) = a_lo_z
        dim_lo(4) = a_lo_t
        dim_lo(5) = a_lo_e
        dim_lo(6) = a_lo_f
        dim_hi(1) = a_hi_x
        dim_hi(2) = a_hi_y
        dim_hi(3) = a_hi_z
        dim_hi(4) = a_hi_t
        dim_hi(5) = a_hi_e
        dim_hi(6) = a_hi_f
	permuted  = 0
	strided  = 0
        do_warn = .TRUE.

* check for error conditions
        DO 10 idim = 1, nferdims
	   IF ( use_lo(idim) .LT. ds_grid_start(idim,ivar) .OR.
     .	        use_hi(idim) .GT. ds_grid_end(idim,ivar) ) GOTO 5200
	   IF ( use_lo(idim) .GT. use_hi(idim)
     .    .OR.  use_lo(idim) .LT. dim_lo(idim)
     .    .OR.  use_hi(idim) .GT. dim_hi(idim) ) GOTO 5300
 10     CONTINUE

* summarize the axis permutation specification in ds_order
        lasdim = 0
	ndim = 0
        DO 20 idim = 1, nferdims
           IF ( ds_ordering(idim,ivar) .EQ. 0 ) GOTO 20
	   ndim = ndim + 1
           IF ( ABS(ds_ordering(idim,ivar)) .LE. lasdim )
     .          permuted = 1
           lasdim = ABS(ds_ordering(idim,ivar))
 20     CONTINUE
* ... sort the list of relevant axes into grid_dims
	DO 30 idim = 1, nferdims
	   trans(idim) =  ABS(ds_ordering(idim,ivar))
	   grid_dims(idim) = trans(idim)
 30	CONTINUE
	IF ( trans(1) .EQ. 0 ) THEN
* ... trap for scalar (no dimension) netCDF variables
	   trans(1) = 1
	   grid_dims(1) = 1
	ENDIF
	DO 34 idim = 1, ndim
	   DO 32 idim2 = idim+1, ndim
	      IF (grid_dims(idim) .GT. grid_dims(idim2)) THEN
	         dim = grid_dims(idim)
	         grid_dims(idim ) = grid_dims(idim2)
	         grid_dims(idim2) = dim
	      ENDIF
 32	   CONTINUE
 34	CONTINUE

* check for an attempt to read into a sub-portion of a grid
* (fully supported in GT and TS libs but only partially supported here)
* it is supported if the sub-region is contiguous - i.e. the sub-limits
* are along the slowest axis of non-unity size
        DO 60 idim = 1, nferdims
           IF ( dim_lo(idim) .NE. use_lo(idim)
     .     .OR. dim_hi(idim) .NE. use_hi(idim) ) THEN
              DO 50 idim2 = idim+1, nferdims
 50           IF ( dim_lo(idim2) .NE. dim_hi(idim2) ) GOTO 5400
           ENDIF
 60     CONTINUE

* determine size from the low/hi limits requested
* and compute lower corner relative to the hyper slab in the  netCDF file
* skip unused dimensions resulting from NORMAL axes
        DO 100 idim = 1, ndim
           fildim = trans(idim)
	   memdim = grid_dims(idim)
           filsize(fildim) = use_hi(memdim) - use_lo(memdim) + 1
	   count(fildim)   = (filsize(fildim)-1)/stride(memdim) + 1
           start(fildim)   = use_lo(memdim) - 
     .                         ds_grid_start(memdim,ivar) + 1
	   filstride(fildim) = stride(memdim)
           IF (stride(memdim) .GT. 1) strided = 1
 100    CONTINUE

*  compute the memory array size (for cases where strides are used)
*  note: transposed compared to filsize
* *kob* 7/00 - totsize calculation now takes striding into account
	totsize = 1
	DO 200 idim = 1, nferdims
	   memsize(idim) =  (use_hi(idim)-use_lo(idim))/stride(idim) + 1
	   totsize = totsize * memsize(idim)
 200	CONTINUE

* compute the map vector (for strides, reversals, and permutations)
	DO 210 idim = 1, nferdims
 210	imap(idim) = 0
* for netCDF V3 the imap array is set up in number of array elements, not bytes
	imap(trans(1)) = 1

	DO 220 idim = 2,ndim
	   imap(trans(idim)) = imap(trans(idim-1))
     .			     * (1 + (memsize(grid_dims(idim-1))-1))
 220	CONTINUE
* ... compress the gaps out of the map -- e.g. XYT ==> has a zero in imap(3)
*     and other arrays
	idim2 = 0
	DO 225 idim = 1, nferdims
	   IF (imap(idim) .EQ. 0) GOTO 225
	   idim2 = idim2 + 1
	   imap(idim2)      = imap(idim)
	   filsize(idim2)   = filsize(idim)
	   start(idim2)     = start(idim)
	   count(idim2)     = count(idim)
	   filstride(idim2) = filstride(idim)
 225	CONTINUE

* read the data
* v5.1 *kob* - Major revision.  Use nc v3 call to read data and convert values
*              to real/float.  Should work for all datatypes.
* v5.11 *kob* - add ifdef to check whether or not to append an underscore
*               to the v3 routine name.  This necessary because DODS netcdf
*               fortran jackets were configured assuming f2c, which appends
*               an additional underscore to routine names already containing
*               and underscore.  The real solution is to configure dods 
*               correctly, but for now, this kludge is applied
* v5.33 *sh* - actual reading is buried in a C subroutine
* V600  *acm*- Fix bug 419 (incompletely fixed before) send missing data
*              flag to TM_SCALE so that bad data is not scaled.
* V600  *acm* -Hack to let us read double precision data to be used to 
*              create an axis, by specifying an offset and reading the
*              data as double precision, applying the offset and THEN
*              converting to single precision.
*      ... when compiling as double precision, the data is read as double
*      ... and it will be scaled below.  So we just skip this hack.

        already_scaled = .FALSE.
        status = merr_ok
#ifndef double_p 

        IF (ds_var_scaleit( ivar ) ) THEN   ! reads data as double precision, if available.
           CALL CD_READ_SCALE(cdfid, varid, ndim, 
     .             ds_var_off(ivar), ds_var_scale(ivar), 
     .             ds_bad_flag(ivar),
     .             start, count,
     .		   filstride, imap,
     .             var(use_lo(1),
     .                 use_lo(2),
     .                 use_lo(3),
     .                 use_lo(4),
     .                 use_lo(5),
     .                 use_lo(6)), 
     .             permuted, strided, already_scaled, cdfstat, status)
           IF ( cdfstat .NE. NF_NOERR ) GOTO 5500           

           IF (status .NE. merr_ok) THEN   ! try to read as single precision floats
           
	      CALL CD_READ_SUB(cdfid, varid, ndim, start, count,
     .		   filstride, imap,
     .             var(use_lo(1),
     .                 use_lo(2),
     .                 use_lo(3),
     .                 use_lo(4),
     .                 use_lo(5),
     .                 use_lo(6)), permuted, strided, cdfstat)
	      IF ( cdfstat .NE. NF_NOERR ) GOTO 5500
           ENDIF

        ELSE
#endif
	   CALL CD_READ_SUB(cdfid, varid, ndim, start, count,
     .		   filstride, imap,
     .             var(use_lo(1),
     .                 use_lo(2),
     .                 use_lo(3),
     .                 use_lo(4),
     .                 use_lo(5),
     .                 use_lo(6)), permuted, strided, cdfstat)
	   IF ( cdfstat .NE. NF_NOERR ) GOTO 5500
#ifndef double_p
        ENDIF
#endif

* if data has mean or range removed rescale it.
* Do not scale missing data.

* Check for the scale factors again here (done on SET DATA in cd_get_1_dep_var,
* but the user may have reset the attributes by now.) If this is a file in a 
* descriptor file, and if scaling values exist for the variable, then do not reset 
* scale factors again here.
* Ticket 1980: initialize the scale attributes in case they don't exist.

        IF (.NOT.is_mc .OR. .NOT.cd_scaled(ivar)) THEN
           maxlen = 2
	   cd_scale_factor(ivar) = 1.
           CALL CD_GET_VAR_INFO (dset, varid, vname, vtype, nvdims,
     .         vdims, nvatts, coordvar, outflag, status)
           got_it = NC_GET_ATTRIB( dset, varid, 'scale_factor',
     .                     do_warn, vname, maxlen, attlen, 
     .                     attoutflag, buff, cd_scale_factor(ivar))
           maxlen = 2
	   cd_add_offset(ivar) = 0.
           tf2    = NC_GET_ATTRIB( dset, varid, 'add_offset',
     .                     do_warn, vname, maxlen, attlen, 
     .                     attoutflag, buff, cd_add_offset(ivar))

           cd_scaled(ivar) = got_it .OR. tf2
        ENDIF

        IF ( cd_scaled( ivar ) ) CALL TM_SCALE(
     .       cd_scale_factor(ivar), cd_add_offset(ivar),
     .       ds_bad_flag(ivar), var, totsize )

* if user has asked for new offset and/or scale, apply those, but
* not to any missing data.

        IF ( ds_var_scaleit(ivar) .AND. (.NOT. already_scaled) )
     .    CALL TM_SCALE_NOBAD(
     .       ds_var_scale(ivar), ds_var_off(ivar), var, totsize,
     .       ds_bad_flag(ivar), ds_missing_flag(ivar) )

* If its an Epic file, the missing-flag is not in the file, and
* precision conversion means they won't match. Fill the missing data
* with the right double precision values.
        IF (ds_type(dset) .EQ. 'ECDF') THEN 
           CALL TM_BAD_EPIC(var, totsize, ds_bad_flag(ivar) )
        ENDIF

* successful completion
	status = merr_ok
	RETURN

* error messages
 5100      CALL TM_ERRMSG
     .     ( cdfstat+pcdferr, status, 'CD_READ', cdfid,
     .       varid, 'Failed attempting READ', no_errstring, *5900 )

 5200      CALL TM_ERRMSG (merr_outofgrid, status, 'CD_READ',
     .     dset, no_stepfile, 'variable '//
     .     ds_var_code(ivar)(:TM_LENSTR1(ds_var_code(ivar)))//
     .     ' requested '//
     .	   dimnam(idim)//'='//TM_STRING(DBLE(use_lo(idim)))//'-'//
     .	   TM_STRING(DBLE(use_hi(idim))), no_errstring, *5900)

 5300      CALL TM_ERRMSG(merr_badsubscr, status, 'CD_READ',
     .     dset, no_stepfile, 'for requested '//dimnam(idim)//
     .     ' subscripts', no_errstring, *5900)

 5400      CALL TM_ERRMSG(merr_notsupport, status, 'CD_READ',
     .     dset, no_stepfile,
     .     'modulo or random access on netCDF mid-dimension: '//
     .     dimnam(idim), ' ', *5900)

 5500	IF ( status .EQ. -1 ) THEN
 
	   CALL TM_ERRMSG( cdfstat+pcdferr, status, 'CD_READ',
     .	             cdfid, varid,
     .		    'unable to allocate memory for doub. prec. read',
     .		     no_errstring, *5900 )
	ELSE
	
           IF (cdfstat .LT. NF_NOERR) THEN
	      err_status = merr_nc_open 
	      CALL CD_TRANSLATE_ERROR (cdfstat, ebuff)
           ELSE IF (cdfstat .EQ. nf_interrupt) THEN
	      err_status = merr_read_interrupt
      
	      CALL CD_GET_VAR_INFO (dset, varid, vname, vtype, nvdims,
     .          vdims, nvatts, coordvar, outflag, status)

	      ebuff = 'Reading variable '//vname(:TM_LENSTR1(vname))//
     .          ', interrupted from command line'
           ENDIF

           CALL TM_ERRMSG
     .     ( err_status, status, 'CD_READ', dset,
     .        no_stepfile, ebuff, no_errstring, *5900 )

	ENDIF

 5900	RETURN
	END

	SUBROUTINE POP_CS

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* POP the contral stack turning control over to the next lower level, if any

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* revision 0.0 - 4/29/87
* V230: restore original context following REPEAT command
* V300 - 2/2/93 - added semicolon-separated command groups
* V420 - added IF (single risc_buff version controls input source)
*      - generate warning if multi-risc_buff IF is unclosed
* V500 4/99 *sh* - remove the informative message about an unclosed IF
*    This is not an error in IF cond THEN stmt; QUIT ENDIF 
* V530:  8/00 *sh* - when restoring the original context after a REPEAT it
*	is necessary to set the unsaved region (as per cx_by_ss) to unspecified
*	(The need to do this represents a bug somewhere up the risc_buff -- region
*		information is used without regard to cx_by_ss)
*	see err522_repeat_leftover.jnl
* V554 1/04 *acm* - add cs_repeatname for named /RANGE loop control; reset repeat controls.
* v560 3/04 *acm    reset last_cmnd_buff  when resetting repeat controls.
*      6/04 ywei    change MATCH_NAME function
* v5.80 *acm* 11/04 use cx_cal_id to store the calender used when
*                   computing world coordinates; restore cx_cal_id
*                   along with  the rest of the context after a REPEAT
* V600  4/06 *acm* - additional declarations found by Solaris compiler
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V687  3/14 *acm* for ticket 2044, write note ! Exit from <script>
* V687  3/14 *acm* for ticket 2044, write note ! Exit_GO only if SET REDIRECT is turned on.
* V693+ 12/14 *sh* rolling back 4/99 change: an unclosed IF needs a warning
*                  and handle nested unclosed IFs 
* v6932 12/14 *sh* unclosed IF warning moved to GET_FER_COMMAND
* V695  *acm* 2/15 cx_calendar stores info about calendar formatting of T and F axes
* V698  *sh* 3/16 maintain GO_FILE as the currently active GO file

        IMPLICIT NONE
* internal variable declarations:
	INTEGER	LIB_FREE_LUN,TM_LENSTR1,stat,axis,ivar,cvar,csp_to,ll,
     .          slen, plen
        INTEGER i, j, ier, num_indices

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'command.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'
	include 'xcontrol.cmn'
	include 'xcontrol.equiv'
        include 'xcontext.cmn'
        include 'xalgebra.cmn'
        include 'xvariables.cmn'
	include	'xrisc.cmn'

* internal error ?
	IF ( csp .LT. 1 ) STOP 'csp_undflw'

* popping out of a stack level with an unclosed IF statement is a form of error
* we will issue a warning and then implicitly close the IF
	IF (if_conditional) THEN
	   IF (csp .LE. if_cs(ifstk) ) THEN
	      ifstk_skipping = 0
* ... set ifstk to the level it was at the previous csp
	      DO i = ifstk, 1, -1
                 IF (csp .GT. if_cs(i)) THEN
	            ifstk = i
	            GOTO 5  ! if_conditional remains true
	         ENDIF
	      ENDDO
	      ifstk = 0
	      if_conditional = .FALSE.
	   ENDIF
	ENDIF

* clean up old level
 5	IF ( cs_cmnd_num( csp ) .EQ. cmnd_go ) THEN

* ... Write note with script name, only if SET REDIRECT is turned on.
	   IF (redirect_stdout_flags .NE. redirect_none) THEN
              risc_buff = '! Exit_GO '
              CALL SPLIT_LIST(pttmode_explct, ttout_lun, risc_buff, ll)
	   ENDIF

* ... close input GO file
	   CLOSE( UNIT = cmnd_lun, ERR = 10 )
 10	   stat = LIB_FREE_LUN( cmnd_lun )

* reset the GO_FILE symbol to the parent GO file, if any
	   ier = 0
	   j = 0
           CALL SETSYM ('GO_FILE n/a', 11, ier, j)
	   DO i = csp-1,1,-1
              IF ( cs_cmnd_num(i) .EQ. cmnd_go) THEN
	        ll = TM_LENSTR1(cs_go_filename(i))
              	CALL SETSYM ('GO_FILE '//cs_go_filename(i), 8+ll, ier, j)
                EXIT
              ENDIF
           ENDDO


	ELSEIF ( cs_cmnd_num( csp ) .EQ. cmnd_repeat ) THEN
* ... restore context prior to REPEAT loop (along repeat axis only)
           axis = cs_axis( csp )
           cx_by_ss(axis,cx_last) = cs_save_by_ss( csp )

           IF (axis .eq. t_dim .OR. axis .eq. f_dim) THEN
              cx_calendar(axis,cx_last) = .FALSE.
              cx_cal_id(cx_last) = unspecified_int4
           ENDIF

           IF ( cs_save_by_ss( csp ) ) THEN
              cx_lo_ss (cx_last,axis) = cs_save_lo( csp )
              cx_hi_ss (cx_last,axis) = cs_save_hi( csp )
              cx_lo_ww (axis,cx_last) = unspecified_val8
              cx_hi_ww (axis,cx_last) = unspecified_val8
           ELSE
              cx_lo_ww (axis,cx_last) = cs_save_lo( csp )
              cx_hi_ww (axis,cx_last) = cs_save_hi( csp )
              cx_lo_ss (cx_last,axis) = unspecified_int4
              cx_hi_ss (cx_last,axis) = unspecified_int4
              cx_cal_id (cx_last) = cs_save_cal(csp) 
           ENDIF

* clean up counter variable 

           cvar = 0
*           len_test = TM_LENSTR(cs_repeatname(csp))
*	   DO 20 ivar =  num_counter_vars, 1, -1
*              len_mchars = TM_LENSTR(countervar_name(ivar))
*	      IF ( MATCH_NAME( cs_repeatname(csp), len_test,
*     .           countervar_name(ivar), len_mchars ) ) THEN
*                cvar = ivar
*                GOTO 1000
*              ENDIF
*  20	   CONTINUE
*1000       CONTINUE
 	CALL string_array_find(countervar_name_head,
     .                         cs_repeatname(csp),
     .                         LEN(cs_repeatname(csp)),
     .                         string_array_result(1),
     .                         max_uvar,
     .                         num_indices)
        IF(num_indices.GT.0) THEN
              cvar = string_array_result(1)
        ENDIF

           IF (cvar .GT. 0) THEN
*              countervar_name(cvar) = unspecified_name4
              CALL string_array_modify(countervar_name_head,
     .                                 cvar,
     .                                 unspecified_name4,
     .                                 LEN(unspecified_name4))

              alg_cvar( cvar ) = unspecified_name4
              cs_repeatname( csp ) = unspecified_name4
              csp_cvar( csp ) = unspecified_int4
              last_cmnd_buff = ' '
           ENDIF

	ENDIF
	csp = csp - 1

* now who gets control ?
	IF ( csp .EQ. 0 ) THEN
* ... the operator
	   cs_in_control = .FALSE.
	   input_source  = input_from_tty
	ELSE
* ... the next stack level down
	   IF    ( cs_cmnd_num( csp ) .EQ. cmnd_go     ) THEN
	      input_source = input_from_file
	      cmnd_lun = cs_lun( csp )
	   ELSEIF ( cs_cmnd_num( csp ) .EQ. cmnd_semicolon
     .         .OR. cs_cmnd_num( csp ) .EQ. cmnd_if
     .         .OR. cs_cmnd_num( csp ) .EQ. cmnd_repeat ) THEN
	      input_source = input_from_cs
	   ELSE
	      STOP 'cs_stk_??'
	   ENDIF
	ENDIF
		   
	RETURN
	END

	LOGICAL FUNCTION TM_HAS_STRING( string, substring )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* check in a case-independent search to see if "substring" is in "string"
* note: string and substring can be at most 2048 characters

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.00 - 02/11/88
* revision 0.01 - 05/03/88 - made temp strings CHAR*255 (this is the max length
*			     that will work correctly (MAV)
* revision 0.10 - 01/20/91 - replaced VAX runtim library reference with INDEX
*                            FORTRAN intrinsic function
* V530 *sh* 11/00 - more graceful behavior if 255 max is exceeded
* V553 *acm* 8/03 - allow up to 2048 characters in the strings.

* calling argument declarations
	CHARACTER*(*)	string, substring

* local variable declarations
	INTEGER	STR_UPCASE, TM_LENSTR1,
     .		vms_stat, sublen, strlen
	CHARACTER*2048 up_string, up_sub

* length of substring
	sublen = TM_LENSTR1( substring )
	strlen = TM_LENSTR1( string )
	IF (sublen .GT. 2048) THEN
	   TM_HAS_STRING = .FALSE.
	   RETURN
	ENDIF

* convert to upper case
	vms_stat = STR_UPCASE( up_string, string )
	vms_stat = STR_UPCASE( up_sub, substring(:sublen) )

* find the substring
	TM_HAS_STRING = INDEX( up_string, up_sub(:sublen) ) .GT. 0

	RETURN
	END

      SUBROUTINE escape_for_xml(string, outstring, slen)
      
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* When writing xml, the string inside the tags may not contain > < or &.
* Replace these characters in the input string with the appropriate 
* replacement string, as outlined here:
*
* http://www.w3.org/TR/REC-xml/
* The ampersand character (&) and the left angle bracket (<) MUST NOT 
* appear in their literal form, except when used as markup delimiters, 
* or within a comment, a processing instruction, or a CDATA section. If 
* they are needed elsewhere, they MUST be escaped using either numeric 
* character references or the strings " &amp; " and " &lt; " respectively. 
* The right angle bracket (>) may be represented using the string " &gt; ", 
* and MUST, for compatibility, be escaped using either " &gt; " or a character 
* reference when it appears in the string " ]]>> " in content, when that string 
* is not marking the end of a CDATA section. 

* V631 11/09 *acm* 

      IMPLICIT NONE
* calling argument declaration
      CHARACTER*(*) string, outstring 
      INTEGER slen 

* Local declarations
      INTEGER TM_LENSTR1, i, nchar, lenrepl(3), blen, loc
      CHARACTER*1 rchar(3)
      CHARACTER*6 repl(3)
      
      DATA rchar(1)  /'<'/
      DATA rchar(2)  /'>'/
      DATA rchar(3)  /'&'/
      DATA repl(1)  /'&lt;'/
      DATA repl(2)  /'&gt;'/
      DATA repl(3)  /'&amp;'/

      DATA lenrepl/4,4,5/

      nchar = 3 
      slen = TM_LENSTR1(string)
      loc = 1

      outstring(1:1) = string(loc:loc)
      blen = 1

      DO 90 i = 1, nchar
         IF (string(loc:loc) .EQ. rchar(i)) THEN
            outstring = repl(i)
            blen = lenrepl(i)
         ENDIF
  90     CONTINUE

      loc = loc + 1

      DO WHILE (loc .LE. slen)
         DO 100 i = 1, nchar
            IF (string(loc:loc) .EQ. rchar(i)) THEN
               outstring = outstring(1:blen)//repl(i)
               blen = blen + lenrepl(i)
               GOTO 200
            ENDIF
  100    CONTINUE

*  Not replaced, just keep the orig. character

         outstring = outstring(1:blen)//string(loc:loc)
         blen = blen + 1

  200    CONTINUE

         loc = loc + 1

      ENDDO

      slen = blen
      
      RETURN
      END

	SUBROUTINE CD_STORE_DSET_ATTRS ( dset, cdfid, status)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* After a netCDF file is open, get dataset, variable, and attribute information
* storing in linked list structure.

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP 

* V600 6/05 *acm* Attribute control.
* v604 *acm* 7/07 increase length of ds_name, ds_des_name
* v62  *acm* 6/08 cleanup; no need for the variable called buff.
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* argument definitions:
*       dset    - pointer to TMAP data set
*       cdfid   - returned pointer to open CDF file (or cache)
*	status	- return status

* argument declarations:
	INTEGER	      dset, cdfid, status

* include files
        include 'netcdf.inc'
        include 'tmap_errors.parm'
	include 'tmap_dims.parm'
	include 'xstep_files.cmn_text'
        external xstep_files_data
	include 'xdset_info.cmn_text'
	external xdset_info_data
        include 'xdset_info.cd_equiv'

* local variable declarations:
      INTEGER NCF_ADD_DSET, TM_LENSTR1, i, j, cdfstat

* For saving dataset information in linked list

      INTEGER NCF_GET_DSNUM, llen, slen1, slen2
      PARAMETER (slen1=2048)      ! size of ds_name string
      PARAMETER (slen2=2048)      ! size of ds_des_name string (should this be even longer??)

#ifdef sun
      BYTE      fhol_dsname(slen1)      ! c-type Hollerith string buffer
      BYTE      fhol_dspath(slen2)
#else
      INTEGER*1 fhol_dsname(slen1)      ! c-type Hollerith string buffer
      INTEGER*1 fhol_dspath(slen2)
#endif

* Successfully opened the dataset (stepfile). 
* Save dataset info in GLOBAL_NCdsetList for attribute handling

      llen = TM_LENSTR1( ds_name(dset) )
      CALL TM_FTOC_STRNG( ds_name(dset)(1:llen), fhol_dsname, slen1 )
      llen = TM_LENSTR1( ds_des_name(dset) )
      CALL TM_FTOC_STRNG( ds_des_name(dset)(1:llen), fhol_dspath, slen2 )

      cdfstat = NCF_ADD_DSET (cdfid, dset, fhol_dsname, fhol_dspath) 
      IF ( cdfstat .EQ. merr_badfileatt ) THEN
         CALL WARN (
     .   'attribute type mismatch or other attribute reading error '//
     .    ds_des_name(dset)(1:llen)) 
      ELSE IF ( cdfstat .NE. merr_ok ) THEN
         GOTO 5100
      ENDIF

* successful completion
	status = merr_ok
	RETURN

* error messages
 5100   CALL TM_ERRMSG
     .     ( cdfstat+pcdferr, status, 'CD_STORE_DSET_ATTRS', cdfid,
     .        no_varid, 'is this a CDF file ?', no_errstring, *5900 )
* erase any record of tampering with this data set
 5900   CALL TM_CLOSE_SET( dset, i )

* error exit
	RETURN
	END

	subroutine uninit(pname,switch,sflag,smap,ns,
     *	    name,nmap,nin,nout)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)uninit.f	1.1    3/10/88
C** v552 *acm* 3/03 Longer strings: changes for multi-line labels.
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
c
c	subroutine uses iargc and getarg to determine what switches 
c	have been set
c
c	pname	- calling program name (as called) char
c	switch	- list of legal switches char*1
c	sflag	- value of switch .true. if set
c	smap	- points to name associated with switch int
c	ns	- number of switches
c	name	- list for non-switch arguements char(nin)*(*)
c	nmap	- points to the switch associated with name
c	nin	- length of name
c	nout	- number of name at output
c
c
	character pname*(*),switch(ns)*1,name(nin)*(*),arg*2048
	logical sflag(ns)
	integer smap(ns),nmap(nin)
c
c
	do 10 i=1,ns
	    sflag(i)=.false.
	    smap(i)=0
10	continue
	do 20 i=1,nin
	    name(i)=' '
	    nmap(i)=0
20	continue
c
c	get program name and number of args
c
	call getarg(0,pname)
	iarg=iargc()
c
c	parse arguement list
c
	nout=0
	ilast=0
	do 30 i=1,iarg
	    call getarg(i,arg)
	    if(arg(1:1).eq.'-')then
		k=lnblnk(arg)
		do 40 kk=2,k
		    do 50 j=1,ns
			if(arg(kk:kk).eq.switch(j))then
			    sflag(j)=.true.
			    ilast=j
			    goto 40
			endif
50		     continue
40		continue
	    else
		nout=nout+1
		if(nout.gt.nin)goto 30
		if(ilast.ne.0)then
		    smap(ilast)=nout
		    nmap(nout)=ilast
		    ilast=0
		endif
		name(nout)=arg
	    endif
30	continue
	return
	end

	INTEGER FUNCTION GCF_RTN_TYPE( gcfcn, arg1_cx )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* return the data type of the result of this function call

* V533: *sh* 6/01
* V620: *acm* 3/09 hook up the call to EFCN_GET_RTN_TYPE to get back
*             the type of string functions (see bug 1621)
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include 'ferret.parm'
	include 'grid_chg_fcns.parm'   ! for place-holder behavior
        include 'EF_Util.parm'
	include 'xcontext.cmn'
	include 'xgrid_chg_fcns.cmn'

* Upon entry to this routine the context stack should be organized as
*         default context (var=uvar, region=(1:1,1:1,1:1,1:1) for base var)
* big_cx: the merged grid context
*         argument N context
*         argument N-1 context
*         ...
*   -->   argument 1 context

* calling argument declarations
	INTEGER		gcfcn, arg1_cx

* internal variable declarations
!	INTEGER	GCF_ARG_EVAL_ORDER
	INTEGER	EFCN_GET_NUM_REQD_ARGS, EFCN_GET_RTN_TYPE,
     .          iarg, cx, i, itype
        INTEGER EF_cx_list(EF_MAX_ARGS), narg

	IF ( gcfcn .LE. gfcn_num_internal ) THEN

* internal grid-changing function
	   GCF_RTN_TYPE = gfcn_rtn_type(gcfcn)

* ... inherit the return type from the indicated argument
	   IF (GCF_RTN_TYPE .LT. 0) THEN
	     iarg = ABS(GCF_RTN_TYPE)
!	     cx = arg1_cx-(GCF_ARG_EVAL_ORDER(gcfcn,iarg)-1)
	     cx = arg1_cx-(iarg-1)
	     IF (cx_type(cx) .EQ. ptype_string) THEN
	       GCF_RTN_TYPE = pfcn_rtn_string
	     ELSE
	       GCF_RTN_TYPE = pfcn_rtn_float
	     ENDIF
	   ENDIF

	ELSE

* external function
*   ... create a context list array
           narg = EFCN_GET_NUM_REQD_ARGS(gcfcn)
           DO 300 i = 1, narg
              EF_cx_list(i) = cx_stack_ptr - i + 1
 300       CONTINUE

	   itype = EFCN_GET_RTN_TYPE (gcfcn)
	   GCF_RTN_TYPE = itype

	ENDIF

	RETURN

	END

*
* samplexyt.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without anx fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and anx derivative works thereof, and
*  its supporting documentation for anx purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in anx publications that result from
*  the use of this software or in anx product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in anx advertising or publicity to endorse or promote anx products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with anx support, consulting,
*  training or assistance of anx kind with regard to the use, operation
*  and performance of this software nor to provide the user with anx
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND Anx EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR Anx SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR Anx DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Ansley Manke
*  -------------------------------------------------------------------
*
* This function samples 4-d data at the x, y, t locations indicated by 
* args 2, 3,4
* 1/18/08  Ansley Manke 
*         Result is abstract on the x axis, normal on the y and t axes,
*         and keeps the z axes of the input 4-d data.
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE samplexyt_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      CHARACTER*100 fcn_desc
      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns data sampled at a set of (X,Y,T) points, ',
     .   'using linear interpolation')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 4)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, ABSTRACT, 
     .     NORMAL, IMPLIED_BY_ARGS, NORMAL)

      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      CALL ef_set_num_work_arrays(id, 5)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'DAT_TO_SAMPLE')
      CALL ef_set_arg_desc(id, arg, 'variable (x,y,z,t) to sample')
      CALL ef_set_axis_influence(id, arg, NO, NO, YES, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'XPTS')
      CALL ef_set_arg_desc(id, arg, 'X values of sample points')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'YPTS')
      CALL ef_set_arg_desc(id, arg, 'Y values of sample points')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'TPTS')
      CALL ef_set_arg_desc(id, arg, 'T values of sample points')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* loss               lo subscript for an axis
*
* hiss               hi subscript for an axis
*

      SUBROUTINE samplexyt_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER my_lo_l, my_hi_l
      INTEGER nx, ny, nz, nt

*     Use utility functions to get context information about the 
*     1st argument, to set the abstract axis lo and hi indices.

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nx = arg_hi_ss(X_AXIS, ARG2) - arg_lo_ss(X_AXIS, ARG2) + 1
      ny = arg_hi_ss(Y_AXIS, ARG2) - arg_lo_ss(Y_AXIS, ARG2) + 1
      nz = arg_hi_ss(Z_AXIS, ARG2) - arg_lo_ss(Z_AXIS, ARG2) + 1
      nt = arg_hi_ss(T_AXIS, ARG2) - arg_lo_ss(T_AXIS, ARG2) + 1

      my_lo_l = 1
      my_hi_l = max(nx,ny,nz,nt)

      CALL ef_set_axis_limits(id, X_AXIS, my_lo_l, my_hi_l)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END
*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE samplexyt_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_lens(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER mxh, myh, mth, mxl, myl, mtl

      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

* Allocate double the length of the axes for REAL*8 work arrays.
* For x and t axes allow yet one more point for handling modulo axes

      mxl = arg_lo_ss(X_AXIS,ARG1)
      myl = arg_lo_ss(Y_AXIS,ARG1)
      mtl = arg_lo_ss(T_AXIS,ARG1)

      mxh = mxl + 
     .     2* (arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 2)
      myh = myl + 
     .     2* (arg_hi_ss(Y_AXIS,ARG1)  - arg_lo_ss(Y_AXIS,ARG1) + 1)
      mth = mtl + 
     .     2* (arg_hi_ss(T_AXIS,ARG1)  - arg_lo_ss(T_AXIS,ARG1) + 2)

*  xaxdat
      CALL ef_set_work_array_dims (id, 1, mxl, 1, 1, 1, mxh, 1, 1, 1)

*  yaxdat
      CALL ef_set_work_array_dims (id, 2, myl, 1, 1, 1, myh, 1, 1, 1)

*  taxdat
      CALL ef_set_work_array_dims (id, 3, mtl, 1, 1, 1, mth, 1, 1, 1)

*  taxdatlo
      CALL ef_set_work_array_dims (id, 4, mtl, 1, 1, 1, mth, 1, 1, 1)

*  taxdathi
      CALL ef_set_work_array_dims (id, 5, mtl, 1, 1, 1, mth, 1, 1, 1)


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*

      SUBROUTINE samplexyt_compute(id, arg_1, arg_2, arg_3, arg_4, 
     .      result, xaxdat, yaxdat, taxdat, taxdatlo, taxdathi)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .     mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .     mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz,
     .     mem3lot:mem3hit)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz,
     .     mem4lot:mem4hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .      memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable's axes.

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      COMMON /STOR/ mxdat, mydat
      INTEGER mxdat, mydat
      INTEGER nx, nxx, nxy, nxz, nxt
      INTEGER ny, nyx, nyy, nyz, nyt
      INTEGER nt, ntx, nty, ntz, ntt
      INTEGER ndimx, ndimy, ndimt

*  Set up work arrays

      REAL*8 xaxdat(wrk1lox:wrk1lox+(wrk1hix-wrk1lox)/2,wrk1loy:wrk1hiy,
     .               wrk1loz:wrk1hiz, wrk1lot:wrk1hit)
      REAL*8 yaxdat(wrk2lox:wrk2lox+(wrk2hix-wrk2lox)/2,wrk2loy:wrk2hiy,
     .               wrk2loz:wrk2hiz, wrk2lot:wrk2hit)
      REAL*8 taxdat(wrk3lox:wrk3lox+(wrk3hix-wrk3lox)/2,wrk3loy:wrk3hiy,
     .               wrk3loz:wrk3hiz, wrk3lot:wrk3hit)
      REAL*8 taxdatlo(wrk4lox:wrk4lox+(wrk4hix-wrk4lox)/2,wrk4loy:wrk4hiy,
     .               wrk4loz:wrk4hiz, wrk4lot:wrk4hit)
      REAL*8 taxdathi(wrk5lox:wrk5lox+(wrk5hix-wrk5lox)/2,wrk5loy:wrk5hiy,
     .               wrk5loz:wrk5hiz, wrk5lot:wrk5hit)

      INTEGER i, j, k, l
      INTEGER i1,j1,k1,l1
      INTEGER i2,j2,k2,l2
      INTEGER i3,j3,k3,l3
      INTEGER i4,j4,k4,l4

      LOGICAL ok
      INTEGER STR_UPCASE, ic, imatch, jmatch, lmatch
      INTEGER ibot, itop, jbot, jtop, lbot, ltop
      REAL fxbot, fxtop, fbb, ftb, fbt, ftt
      REAL xbot, xtop, ybot, ytop, tbot, ttop
      REAL frac, tfrac_lo, tfrac_hi, aa, bb
      CHARACTER err_msg*255, test_str*16

C  variables for checking axis characteristics (modulo axes)

      CHARACTER ax_name(4)*16, ax_units(4)*16
      LOGICAL backward(4), modulo(4), regular(4)
      INTEGER xlo, xhi, ylo, yhi, tlo, thi
      REAL dx, dt, delmodx, delmodt, xpt, ypt, tpt

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      nxx = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1
      nxy = arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) + 1
      nxz = arg_hi_ss(Z_AXIS,ARG2) - arg_lo_ss(Z_AXIS,ARG2) + 1
      nxt = arg_hi_ss(T_AXIS,ARG2) - arg_lo_ss(T_AXIS,ARG2) + 1
      nx = max(nxx, nxy, nxz, nxt)

      nyx = arg_hi_ss(X_AXIS,ARG3) - arg_lo_ss(X_AXIS,ARG3) + 1
      nyy = arg_hi_ss(Y_AXIS,ARG3) - arg_lo_ss(Y_AXIS,ARG3) + 1
      nyz = arg_hi_ss(Z_AXIS,ARG3) - arg_lo_ss(Z_AXIS,ARG3) + 1
      nyt = arg_hi_ss(T_AXIS,ARG3) - arg_lo_ss(T_AXIS,ARG3) + 1
      ny = max(nyx, nyy, nyz, nyt)

      ntx = arg_hi_ss(X_AXIS,ARG4) - arg_lo_ss(X_AXIS,ARG4) + 1
      nty = arg_hi_ss(Y_AXIS,ARG4) - arg_lo_ss(Y_AXIS,ARG4) + 1
      ntz = arg_hi_ss(Z_AXIS,ARG4) - arg_lo_ss(Z_AXIS,ARG4) + 1
      ntt = arg_hi_ss(T_AXIS,ARG4) - arg_lo_ss(T_AXIS,ARG4) + 1
      nt = max(ntx, nty, ntz, ntt)

      ndimx = 0
      ndimy = 0
      ndimt = 0
      DO 110 i = X_AXIS,T_AXIS
         IF (arg_hi_ss(i,ARG2) - arg_lo_ss(i,ARG2) .GT.0) 
     .       ndimx = ndimx + 1
         IF (arg_hi_ss(i,ARG3) - arg_lo_ss(i,ARG3) .GT.0) 
     .       ndimy = ndimy + 1
         IF (arg_hi_ss(i,ARG4) - arg_lo_ss(i,ARG4) .GT.0) 
     .       ndimt = ndimt + 1
  110 CONTINUE

      IF (nx.NE.ny  .OR.  nx.NE.nt  .OR.
     .    ndimx.GT.1  .OR. ndimy.GT.1  .OR.  ndimt.GT.1) THEN
         WRITE (err_msg, 10)
         GO TO 999
      ENDIF

   10 FORMAT(
     . 'Arguments 2, 3, and 4 must be 1-dimensional ',
     . 'lists of equal length')

*  Get x, y, t coordinates of the data to be sampled.

      CALL ef_get_coordinates(id, ARG1, X_AXIS,
     .   arg_lo_ss(X_AXIS, ARG1), arg_hi_ss(X_AXIS, ARG1), xaxdat)
      CALL ef_get_coordinates(id, ARG1, Y_AXIS,
     .   arg_lo_ss(Y_AXIS, ARG1), arg_hi_ss(Y_AXIS, ARG1), yaxdat)
      CALL ef_get_coordinates(id, ARG1, T_AXIS,
     .   arg_lo_ss(T_AXIS, ARG1), arg_hi_ss(T_AXIS, ARG1), taxdat)
      CALL ef_get_box_lo_lim(id, ARG1, T_AXIS,
     .   arg_lo_ss(T_AXIS, ARG1), arg_hi_ss(T_AXIS, ARG1), taxdatlo)
      CALL ef_get_box_hi_lim(id, ARG1, T_AXIS,
     .   arg_lo_ss(T_AXIS, ARG1), arg_hi_ss(T_AXIS, ARG1), taxdathi)

      i2 = arg_lo_ss(X_AXIS,ARG2)
      j2 = arg_lo_ss(Y_AXIS,ARG2)
      k2 = arg_lo_ss(Z_AXIS,ARG2)
      l2 = arg_lo_ss(T_AXIS,ARG2)

      i3 = arg_lo_ss(X_AXIS,ARG3)
      j3 = arg_lo_ss(Y_AXIS,ARG3)
      k3 = arg_lo_ss(Z_AXIS,ARG3)
      l3 = arg_lo_ss(T_AXIS,ARG3)

      i4 = arg_lo_ss(X_AXIS,ARG4)
      j4 = arg_lo_ss(Y_AXIS,ARG4)
      k4 = arg_lo_ss(Z_AXIS,ARG4)
      l4 = arg_lo_ss(T_AXIS,ARG4)

*  Check to see if input x axis is modulo

      CALL ef_get_axis_info (id, ARG1, ax_name, ax_units, backward, 
     .                       modulo, regular)

      xlo = arg_lo_ss(X_AXIS,ARG1)
      xhi = arg_hi_ss(X_AXIS,ARG1)
      ylo = arg_lo_ss(Y_AXIS,ARG1)
      yhi = arg_hi_ss(Y_AXIS,ARG1)
      tlo = arg_lo_ss(T_AXIS,ARG1)
      thi = arg_hi_ss(T_AXIS,ARG1)

      IF ( modulo(1) ) THEN
         ic = STR_UPCASE (test_str, ax_units(1))
         ok = (test_str(1:3) .EQ. 'DEG' .OR. regular(1))
         IF (.NOT. ok) THEN
            err_msg = 'cannot handle MODULO axis that is not regular'
            go to 999
         ELSE
            dx = xaxdat(xlo+1,1,1,1) - xaxdat(xlo,1,1,1)
            delmodx = xaxdat(xhi,1,1,1) - xaxdat(xlo,1,1,1) + dx
            xaxdat(xhi+1,1,1,1) = xaxdat(xlo,1,1,1)
            IF (ok) delmodx = 360.
         ENDIF
      ENDIF
      IF ( modulo(4) ) THEN
         ic = STR_UPCASE (test_str, ax_units(4))
         ok = (regular(4))
         IF (.NOT. ok) THEN
            err_msg = 'cannot handle MODULO T axis that is not regular'
            go to 999
         ELSE
            dt = taxdathi(tlo,1,1,1) - taxdatlo(tlo,1,1,1)
            delmodt = taxdat(thi,1,1,1) - taxdat(tlo,1,1,1) + dt
            taxdat(thi+1,1,1,1) = taxdat(tlo,1,1,1)
         ENDIF
      ENDIF

*  For each (xpt,ypt,tpt) triple, 
*  1) search the time coordinates of arg 1 for the nearest Time match
*  2) search the data array arg_1 for the nearest higher (x,y) grid 
*     coordinates.  Interpolate in 2 directions for the result.

      i2 = arg_lo_ss(X_AXIS,ARG2)
      j2 = arg_lo_ss(Y_AXIS,ARG2)
      k2 = arg_lo_ss(Z_AXIS,ARG2)
      l2 = arg_lo_ss(T_AXIS,ARG2)

      i3 = arg_lo_ss(X_AXIS,ARG3)
      j3 = arg_lo_ss(Y_AXIS,ARG3)
      k3 = arg_lo_ss(Z_AXIS,ARG3)
      l3 = arg_lo_ss(T_AXIS,ARG3)

      j = res_lo_ss(Y_AXIS)
      l = res_lo_ss(T_AXIS)
      DO 500 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         ibot = ef_unspecified_int4	! Check if xpt points in xax range.
         imatch = 0

	 xpt = arg_2(i2,j2,k2,l2)
	 ypt = arg_3(i3,j3,k3,l3)
	 tpt = arg_4(i3,j3,k3,l3)

         IF (xpt .EQ. bad_flag(ARG2) .OR. ypt .EQ. bad_flag(ARG3) 
     .       .OR. tpt .EQ. bad_flag(ARG4) ) THEN
            DO 700 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
               result(i,j,k,l) = bad_flag_result
  700       CONTINUE

         ELSE
* Find location of TPT in grid
            Lbot = ef_unspecified_int4	! Check if tpt point in tax range.
            Lmatch = 0
            DO 600 i4 = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(t_AXIS,ARG1)
               IF (tpt .GE. taxdatlo(i4,1,1,1)) Lbot = i4
               IF (tpt .EQ. taxdat(i4,1,1,1)) Lmatch = i4
 	       IF (modulo(4)) THEN
	          DO WHILE (tpt .GE. taxdathi(thi,1,1,1) ) 
                     tpt = tpt - delmodt
	          ENDDO
	          DO WHILE (tpt .LT. taxdatlo(tlo,1,1,1) )
		     tpt = tpt + delmodt
	          ENDDO
	       ENDIF

  600       CONTINUE

* Check that tpt is not beyond the upper end of the time axis range.
            IF (tpt .GT. taxdathi(arg_hi_ss(t_AXIS,ARG1),1,1,1)) 
     .	       Lbot = ef_unspecified_int4

	    IF (Lbot .EQ. ef_unspecified_int4) THEN
               DO 800 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
                  result(i,j,k,l) = bad_flag_result
  800          CONTINUE
               GOTO 400

            ELSE

               IF (lmatch .NE. 0) then
                  ltop = lbot
               ELSE
                  ltop = lbot + 1
                  ltop = lbot  ! when using cell bounds taxdatlo, taxdathi
               ENDIF
               IF (lbot .EQ. ef_unspecified_int4) ltop = lbot

               tbot = taxdatlo(lbot,1,1,1)
               ttop = taxdathi(ltop,1,1,1)

               IF (ltop .GE. arg_hi_ss(T_AXIS,ARG1)) 
     .               ltop = arg_hi_ss(T_AXIS,ARG1)
               IF (ttop .LT. tbot) THEN
                  lbot = arg_hi_ss(T_AXIS,ARG1)
                  ltop = arg_lo_ss(T_AXIS,ARG1)
                  tbot = tbot - delmodt
                  IF (tpt .GT. ttop) tpt = tpt - delmodt
               ENDIF
               
               IF (ttop .EQ. tbot) THEN 
                  tfrac_lo = 1.
               ELSE
                  tfrac_lo = (ttop - tpt )/ (ttop - tbot)
               ENDIF
               tfrac_hi = 1. - tfrac_lo
 
            ENDIF
            DO 100 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)
               IF (xpt .GE. xaxdat(i1,1,1,1)) ibot = i1
               IF (xpt .EQ. xaxdat(i1,1,1,1)) imatch = i1

cbf      may be some derivation from the exact value can be allowed:
cbf      if (xpt - xaxdat(i1,1,1,1)).le.eps)   imatch = i1

*  Locate the X point within the range of modulo X axis 

 	       IF (modulo(1)) THEN
	          DO WHILE (xpt .GE. xaxdat(xhi,1,1,1) ) 
                     xpt = xpt - delmodx
	          ENDDO
	          DO WHILE (xpt .LT. xaxdat(xlo,1,1,1) )
		     xpt = xpt + delmodx
	          ENDDO
	       ENDIF

  100       CONTINUE
            i1 = arg_hi_ss(X_AXIS,ARG1)
            IF (xpt .GT. xaxdat(i1,1,1,1)) THEN
               IF (.NOT. modulo(1)) 
     .             ibot = ef_unspecified_int4		! ARG_2 XPT outside of range 
		           				! (non modulo)
            ENDIF

cbf       for matching the next neighbour is not of interest
            IF (imatch .NE. 0) then
               itop = ibot
            ELSE
               itop = ibot + 1
            ENDIF

            IF (ibot .EQ. ef_unspecified_int4) THEN
               itop = ibot
            ELSE

               xbot = xaxdat(ibot,1,1,1)
               xtop = xaxdat(itop,1,1,1)
c ---
               IF (modulo(1) .AND. xtop .LT. xbot) THEN
                  ibot = arg_hi_ss(X_AXIS,ARG1)
                  itop = arg_lo_ss(X_AXIS,ARG1)
                  xbot = xbot - delmodx
                  IF (xpt .GT. xtop) xpt = xpt - delmodx
               ENDIF
c ---
            ENDIF


cbf        analogously in y direction
            jbot = ef_unspecified_int4	! Check if ypt points in yax range.
            jmatch = 0

   	    ypt = arg_3(i3,j3,k3,l3)
            DO 200 j1 = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)
               IF (ypt .GE. yaxdat(j1,1,1,1) ) jbot = j1
            IF (ypt .EQ. yaxdat(j1,1,1,1) ) jmatch = j1
cbf         IF (ypt - yaxdat(j1,1,1,1) ) .LE. eps) jmatch = j1

  200       CONTINUE
            j1 = arg_hi_ss(Y_AXIS,ARG1)
            IF (arg_3(i3,j3,k3,l3) .GE. yaxdat(j1,1,1,1) ) THEN
                jbot = ef_unspecified_int4		! ARG_3 YPT outside of range 
						        ! (non modulo)

            ENDIF

            IF (jmatch .NE. 0) then
                jtop = jbot
            ELSE
               jtop = jbot + 1
            ENDIF
            IF (jbot .EQ. ef_unspecified_int4) jtop = jbot
            IF (jtop .GE. arg_hi_ss(Y_AXIS,ARG1)) 
     .                           jtop = arg_hi_ss(Y_AXIS,ARG1)        !10/2001 acm

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            DO 333 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               l1 = arg_lo_ss(T_AXIS,ARG1)
               l2 = arg_lo_ss(T_AXIS,ARG2)
               l3 = arg_lo_ss(T_AXIS,ARG3)

*  First interpolate in x, getting values of the fcn at (x,jbot) and (x,jtop)

               IF (ibot .EQ. ef_unspecified_int4  .OR.  
     .		      jbot .EQ. ef_unspecified_int4) THEN
                  result(i,j,k,l) = bad_flag_result
               ELSE 

                  aa = arg_1(ibot,jbot,k1,lbot)
                  bb = arg_1(ibot,jbot,k1,ltop)
                  fbb = aa* tfrac_lo + bb* tfrac_hi

                  aa = arg_1(itop,jbot,k1,lbot)
                  bb = arg_1(itop,jbot,k1,ltop)
                  ftb = aa* tfrac_lo + bb* tfrac_hi

                  aa = arg_1(ibot,jtop,k1,lbot)
                  bb = arg_1(ibot,jtop,k1,ltop)
                  fbt = aa* tfrac_lo + bb* tfrac_hi

                  aa = arg_1(itop,jtop,k1,lbot)
                  bb = arg_1(itop,jtop,k1,ltop)
                  ftt = aa* tfrac_lo + bb* tfrac_hi

                  IF (fbb .NE. bad_flag(ARG1)  .AND.
     .                ftb .NE. bad_flag(ARG1)  .AND.
     .                fbt .NE. bad_flag(ARG1)  .AND.
     .                ftt .NE. bad_flag(ARG1) ) THEN

cbf    for matching x-axis no interpolation is need
                     IF (imatch .NE. 0) THEN
                        fxbot = fbb
                        fxtop = fbt
                     ELSE
                        frac = (xpt - xbot )/ (xtop - xbot)
                        fxbot = fbb + frac* (ftb - fbb)
                        fxtop = fbt + frac* (ftt - fbt)
                     ENDIF

*  Now interpolate in y, getting value at (x,y)

                     IF (jbot .GE. arg_lo_ss(Y_AXIS,ARG1)  .AND.
     .                   jtop .LE. arg_hi_ss(Y_AXIS,ARG1) ) THEN
                        ybot = yaxdat(jbot,1,1,1)
                        ytop = yaxdat(jtop,1,1,1)

                        IF (jmatch .NE. 0) THEN
                             result(i,j,k,l) = fxbot
                        ELSE
                            frac = (ypt - ybot)/ (ytop-ybot)
                            result(i,j,k,l) = fxbot + frac* 
     .                                         (fxtop - fxbot)
                        ENDIF
                     ELSE
                        result(i,j,k,l) = bad_flag_result
                     ENDIF

                  ELSE
                     result(i,j,k,l) = bad_flag_result
                  ENDIF	   ! fbb,ftp, etc not bad flags

	       ENDIF  ! itop, jtop not ef_unspecified_int4

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
 333        CONTINUE

         ENDIF  ! xpt and ypt not bad values
 400     CONTINUE
         i2 = i2 + arg_incr(X_AXIS,ARG2)
         j2 = j2 + arg_incr(Y_AXIS,ARG2)
         k2 = k2 + arg_incr(Z_AXIS,ARG2)
         l2 = l2 + arg_incr(T_AXIS,ARG2)

         i3 = i3 + arg_incr(X_AXIS,ARG3)
         j3 = j3 + arg_incr(Y_AXIS,ARG3)
         k3 = k3 + arg_incr(Z_AXIS,ARG3)
         l3 = l3 + arg_incr(T_AXIS,ARG3)
         j = j + res_incr(Y_AXIS)
500   CONTINUE


      RETURN
 999  CALL ef_bail_out (id, err_msg)

      END

	subroutine efile (datafile,dat,leof)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)efile.f	1.1.1.1    7/30/88
C**
C**
C***********************************************************************        C**
C**                 EPIC
C**
C***********************************************************************        C**
C**
c
c  Reads lines of a Time Series or CTD-type EPIC file and returns
c  the line itself (line), the data file specifications (datafile) and the
c  data type info (dat).  If eof is encountered, leof is set to true.
c
c  Programmed by N. Soreide, Apr 86.
c
	common /epiclun/ lun1,lun11,lun21
c
c  Internal COMMON block
c
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 

	common /cefile/ ndiski,ndiskf,ndiri,ndirf,nfili,nfilf,ifirst 
	logical leof,lrim
	character direct*20, filename*22, disk*4
	character line*132, dat*(*), datafile*(*)
	common /comerd/ line
	data nline /132/
#ifdef unix
	external init_cefile
#else
	data ifirst /1/
#endif
	data lrim/.true./
c
	if (lun11 .eq. 0) lun11=11
C
	if (.not. lrim ) then
	    read (lun11, 102, end=310) datafile
	    datafile=datafile(1:lenstr(datafile))
	    return
310	    leof = .true.
	return
	endif
c
210	read (lun11, 102, end=300)line
102	format (a)
c
	if (ifirst .eq. 1) then
		ndat = index (line(1:nline), 'DAT ')
		if (ndat .ne. 0) then
			read (lun11, 102) line
			read (lun11, 102) line
			dat(1:3)=line(ndat:ndat+2)
		endif
		ndiri=index(line(1:nline), 'DIRECT')
		if (ndiri .eq. 0) go to 210
		ndiski=index (line(1:nline), 'DISK')
		nfili = index (line(1:nline), 'FILE')
		read(lun11, 102) line(1:nline)
		read(lun11, 102) line(1:nline)
		nfilf=nline
		ifirst = 0
	endif
c
		if (index(line,'[') .eq. 0) goto 210
		filename(1:) = line(nfili:nfilf)
		nfirblk=index(filename(1:),' ')
		if (nfirblk .ne. 0) filename(1:)=filename(1:nfirblk)
		ndirf = index (line(ndiri:nline),']') + ndiri - 1
		direct(1:) = line(ndiri:ndirf)
		if (ndiski .eq. 0) then
			disk(1:) = 'DH:'
		else
			ndiskf = index (line(ndiski:nline),' ') + ndiski - 1
			disk(1:) = line (ndiski:ndiskf)
		endif
		nk=lenstr(disk)
		nd=lenstr(direct)
		nf=lenstr(filename)
c
c  Check for "[" at start of directory name
c
		if (direct(1:1) .ne. '[') go to 210
c
		datafile=disk(1:nk)//direct(1:nd)//filename(1:nf)
	return
300	if (ifirst .eq. 0) then
	    leof = .true.
	    ifirst = 1
	    return
	else
	    rewind lun11
	    lrim = .false.
	    read (lun11,102)datafile
	    datafile=datafile(1:lenstr(datafile))
	    return
	endif
	end

#ifdef unix
	block data init_cefile

	common /cefile/ ndiski,ndiskf,ndiri,ndirf,nfili,nfilf,ifirst 
	data ifirst /1/
	end
#endif

      SUBROUTINE TEKPAS
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)tekpaus.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     CALL TEKPAS
C
C     THIS SUBROUTINE SETS ALPHAS MODE AND SUSPENDS EXECUTION
C     TO ALLOW THE USER TO INSPECT THE PLOTTED OUTPUT.  EXECU-
C     TION RESUMES WHEN A CHARACTER IS ENTERED FROM THE KEY-
C     BOARD.  THIS CHARACTER IS DISCARDED.  ON THE HP PLOTTER,
C     IN ADDITION TO SETTING ALPHAS MODE, TEKPAS TERMINATES
C     THE CURRENT PLOT AND SENDS FURTHER OUTPUT TO THE TERMINAL.
C     TEKPAS HAS NO EFFECT ON THE ZETA AND GERBER PLOTTERS.
C
C
#ifdef unix
	include 'PLTCOM.DAT'
#else
	include 'pplinc:PLTCOM.DAT'
#endif
C
C     CHECK THE PLOT TYPE.
C
      IF(PTYPE .EQ. 1 .OR. IABS(PTYPE) .GE. 2)THEN
C
C     PAUSE UNTIL THE USER RESPONDS.
C
        CALL PAGE
        CALL CHOUT(BEL,1)
        CALL CHOUT(BEL,1)
	CALL CHDMP
        CALL CHIN(IN,1,0)
      ENDIF
C
C     SET ALPHAS MODE.
C
      CALL ALPHAS
      RETURN
C
      END

	SUBROUTINE DISP_INIT( no_labels, cx_list, ncx )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* initialize the underlying plot package (PPLUS) for a fresh plot
* (this routine is not called for an overlayed plot)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 6/30/87 - extracted from DISP_SET_UP
* revision 0.1 - 7/21/87 - added XAXIS, YAXIS and WINDOW initialization
* revision 0.2 - 7/28/87 - removed LEV () to DISP_PREP, added documentation
* revision 0.3 - 8/26/87 - added TXTYPE YR
* revision 0.4 - 6/28/88 - added  AXLEN and AXSET
* revision 0.5 - 8/26/88 - removed SIZE
* revision 1.0 -  9/8/88 - removed all major re-setting to DISP_RESET 
* revision 1.1 - 1/26/89 - bug fix: 24-->13 for length of "date time" string 
* V200:   1/4/89 - major changes for plots with keys and joint contexts
* V230:   6/8/92 - added WIRE command (requiring WINDOW OFF) so set WINDOW dflt
*        7/22/92 - initialize ul_dolab so that /OVERLAYs following /NOLABEL
*                  will have predictable results
*        11/9/92 - unprotect colors if this is a fresh plot in a full window
*        1/28/93 - added args to plotify_grp_cx to promote thin regions to 2D
*       12/10/93 - set only the small tic size - do not mess with large tics
* V301:	 1/24/94 - turn on metafiles here instead of in XEQ_SET & START_PPLUS 
*	           (resolve problem of metafiles created with wrong name)
* V310:  3/21/94 - squeeze unneeded blanks from "FERRET Ver.3.10"
* v500:  1/26/99 - *kob* commented out PPLCMD call for aline, because this call
*                  was moved to disp_prep.F so reinitialization could occur for 
*                  plot overlays.
* v533:  6/27/01 - *acm* call PPLCMD to initialize AXTYPE,1,1 (not log axis) and
*		   initialize h_logaxis, v_logaxis to FALSE
* v533:  7/11/01 - *acm* call AXSET,1,1,1,1  to set to the default state of all axes on.
*      *acm* 10/01  remove VMS includes
* v540 *acm*  2/02 Do not call AXSET,1,1,1,1 - want PPL AXSET settings to persist
* V550 *acm* 12/02 use mode_labels and mode_logo to control labels and/or logo
* v552 *acm*  3/03 new param IAXSET to restore axes after PLOT/AXES/set plot.
* v552 *acm*  4/03 Delete symbols XAXIS_MIN, XAXIS_MAX, etc.  If they've
*                  been set by a previous plot, they dont get reset on plots
*                  like plot/vs xpts,ypts
* v580 *acm* 11/04 Fix bug 1009. Distinguish between axes which really have one 
*                  point, and those for which the hi and lo subscripts on the axes 
*                  are undefined. When undefined return zero from CX_DIM_LEN_ZERO in
*                  GET_CX_DIMS_ZERO. These axes are listed last in the heirarchy in 
*                  array plot_axis().  This means we can plot a variable with just 
*                  one point in their range (if /HLIMITS or /VLIMITS are used to give 
*                  PPLUS a range to draw).
* V600 *acm* 8/05 - Allow more digits in xrevision number
* V600 *acm* 5/06 - flag no_plot_yet for applying mode_linecolors setting ...
* V6.11 4/08 *acm* Fixes for bug 1571; call to PPL_AXES_RESTORE moved to DISP_INIT
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long
* V686 *acm* 12/13 set up the label symbols LABNUM_E and LABNUM_F
* V695+ *sh*  3/15 remove movable label rotations (left behind by FMRC annotations)
* V697 *acm* 12/15 Fixes for bug 2327 move call of PPL_AXES_RESTORE back to end of plot routines
* V697  *acm*  1/16 Ticket 2344: if there was a time-plot underlay, use its
*                   delta-t for time overlay plots. TAXUND restores the default.
* V697  *acm*  1/16 Ticket 2344: if there was a time-plot underlay, use the underlay's 
*                   time scaling for time overlay plots. TAXUND restores the default.
* V73+ 1/18 *acm*  Changes for Issue 1009; precsision in time info sent to pplus for 2D plots
*                  Initialize the information stored for this scaling
* V74+ 54/18 *acm*  Noticed that symbols LAB1, LAB6 etc labels persisted from 
*                   prev. plots, also LABKEY. Delete them
* V7.4+ *acm*  8/18 DSG-enabled Ferret: colorkey labels may be strings from the IDs
* V7.4+ *acm*  9/18 All moveable labels should be reset

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'plot_setup.parm'
	include 'xplot_setup.cmn'
	include 'xplot_state.cmn'
	include 'xprog_state.cmn'
	include 'xrevision.cmn'
        include 'axis_inc.decl'  ! with iaxset
        include 'AXIS.INC'
	include 'xbox_bounds.cmn'

* calling argument declarations:
	LOGICAL no_labels
	INTEGER ncx, cx_list(ncx)

* internal variable declarations:
	CHARACTER	TM_FMT*48, LEFINT*4, buffer*40, buffsym*30, show_str*12
        INTEGER         i, idim, ier, nc, slen

* open metafile for this new plot
	CALL SEND_PLTYPE( mode_metafile )        ! added 1/94

* PLOT5 re-initialization (to forget previous states)
	CALL PPLCMD ( from, line, 0, 'XFOR', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'YFOR', 1, 1 )
 	CALL PPLCMD ( from, line, 0, 'XLAB', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'YLAB', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'XAXIS', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'YAXIS', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'LABS ', 1, 1 )
* 1/99 *kob* comment out call for aline as this was moved to disp_prep instead
*	CALL PPLCMD ( from, line, 0, 'ALINE ', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'TAXIS OFF', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'TAXUND 0', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'TITLE', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'TICS .125', 1, 1 )    ! chg 12/93
	CALL PPLCMD ( from, line, 0, 'WINDOW ON', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'AXTYPE 1,1', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'XVALOFF 0', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'YVALOFF 0', 1, 1 )
	CALL PPLCMD ( from, line, 0, 'CLRKLAB', 1, 1 )

* clear rotations from first 50 moveable labels
	DO i = 1, 50
	   CALL PPLCMD ( from, line, 0, 'RLABS '//LEFINT(i,slen) , 1, 1)
	ENDDO

* if the axis min and max symbols already exist then delete them

        buffsym = 'XAXIS_MIN'
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
        buffsym = 'XAXIS_MAX'
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
        buffsym = 'YAXIS_MIN'
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
        buffsym = 'YAXIS_MAX'
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
        buffsym = 'X_REVERSED '
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
        buffsym = 'Y_REVERSED '
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)

* If LABNUM symbols exist from a previous plot, delete them.

        buffsym = 'LABNUM_X '
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
        buffsym = 'LABNUM_Y '
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
        buffsym = 'LABNUM_Z '
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
        buffsym = 'LABNUM_T '
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
        buffsym = 'LABNUM_E '
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
        buffsym = 'LABNUM_F '
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
           
        buffsym = 'LABNUM_DSET '
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
        buffsym = 'LABNUM_ASPECT '
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
        buffsym = 'LABNUM_YEAR '
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
        buffsym = 'LABNUM_DATITL '
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
        buffsym = 'LABNUM_OFFSET '
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
        buffsym = 'LABNUM_DODS '
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
        buffsym = 'LABNUM_CALEND '
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
        buffsym = 'LABKEY '
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)

        buffsym = 'LAB1 '
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
        buffsym = 'LAB2 '
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
        buffsym = 'LAB3 '
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
        buffsym = 'LAB4 '
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
        buffsym = 'LAB5 '
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
        buffsym = 'LAB6 '
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
        buffsym = 'LAB7 '
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
        buffsym = 'LAB8 '
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)
        buffsym = 'LAB9 '
	CALL GETSYM( buffsym, buffer, nc, ier )
	IF ( ier .EQ. 0 ) CALL DELSYM(buffsym,nc)


* free the color table on a full window
        IF ( vp_num .EQ. mvp_dflt ) CALL PPL_SHASET( 'RESET' )

        saved_bb_date = ' '
        bb_x_fac  = 1.
        bb_x_off  = 0.
        bb_y_fac  = 1.
        bb_y_off  = 0.

* initialize labels and keys
	nvect_on   = 0
	ncont_on   = 0
	nlabs_on   = 0
	nline_on   = 0
	nkeys_on   = 0
	novkeys_on = 0
	novkeys_ll = 0
	onedee_on  = .FALSE.
	twodee_on  = .FALSE.
	ovkey_ll_full = .FALSE.
	h_logaxis = .FALSE.
	v_logaxis = .FALSE.
        no_plot_yet = .FALSE.

        DO 200 idim = 1, nferdims
 200    ul_dolab(idim) = .TRUE.

* set up full context of plot (possibly multiple variables to plot)
	CALL GRP_CX_DOC( cx_list, ncx, cx_plot, key_doc )
	CALL GET_CX_DIMS_ZERO( cx_list(1), nplot_axis, plot_axis )
	CALL PLOTIFY_GRP_CX( cx_list, ncx )
	
        IF (.NOT.mode_labels ) no_labels = .FALSE.  ! Apply MODE LABELS setting
	
	IF ( no_labels ) RETURN

* set up positions for labels and keys  (including ul_dolab)
	CALL SETUP_KEYS( ncx )

* put program name and revision number onto plot
* ... "FERRET debug Ver. x.xx"   (or "FERRET Ver. 3.10"  3/94) 
        IF (mode_logo) THEN             ! Apply MODE LOGO setting
           show_str = TM_FMT(revision_level, 5, 12, slen)
	   IF ( progname_mod .NE. ' ' ) THEN
	      WRITE ( buffer, 3010) program_name(:len_program_name),
     .	  			 progname_mod(:len_progname_mod),
     .				 show_str(1:slen)
 3010	      FORMAT(A,1X,A,' Ver.',A)
	   ELSE
	      WRITE ( buffer, 3011) program_name(:len_program_name),
     .				 show_str(1:slen)
 3011	      FORMAT(A,' Ver. ',A)
	   ENDIF
	   CALL PUT_LABEL(	ppl_movlab, 0.0, 1.2, ppl_centered,
     .			letsize_logo,
     .			buffer(:len_program_name+len_progname_mod+11),
     .			lab_loc_axlen_plus, lab_loc_axlen_plus )
* ... "NOAA/PMEL TMAP"
	   CALL PUT_LABEL(	ppl_movlab, 0.0, 1.1, ppl_centered,
     .			letsize_logo,
     .			'NOAA/PMEL TMAP',
     .			lab_loc_axlen_plus, lab_loc_axlen_plus )
* ... "8-SEP-1988 11:05"
	   CALL PUT_LABEL(	ppl_movlab, 0.0, 1.0, ppl_centered,
     .			letsize_logo,
     .			'''date'' ''time''',
     .			lab_loc_axlen_plus, lab_loc_axlen_plus )
        ENDIF ! mode_logo

	RETURN
	END

	SUBROUTINE BAD_EDGES( cx, x, mx )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* context cx contains the limits of the valid data within array X
* fill the edges of array X with bad-data flags

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:   8/3/89
*	10/16/89 - modified array declarations via call to *_SUB
* V533: *sh* 6/01 - added string support
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'

* calling argument declarations:
	INTEGER cx, mx
	REAL    x( * )

* --- end of introductory code ---

	IF (mr_type(mx) .EQ. ptype_string) THEN
	   CALL BAD_PTR_EDGES_SUB( cx, x,
     .			    mr_lo_s1(mx), mr_hi_s1(mx),
     .			    mr_lo_s2(mx), mr_hi_s2(mx),
     .			    mr_lo_s3(mx), mr_hi_s3(mx),
     .			    mr_lo_s4(mx), mr_hi_s4(mx),
     .			    mr_lo_s5(mx), mr_hi_s5(mx),
     .			    mr_lo_s6(mx), mr_hi_s6(mx) )
	ELSE
	   CALL BAD_EDGES_SUB( cx, x,
     .			    mr_lo_s1(mx), mr_hi_s1(mx),
     .			    mr_lo_s2(mx), mr_hi_s2(mx),
     .			    mr_lo_s3(mx), mr_hi_s3(mx),
     .			    mr_lo_s4(mx), mr_hi_s4(mx),
     .			    mr_lo_s5(mx), mr_hi_s5(mx),
     .			    mr_lo_s6(mx), mr_hi_s6(mx),
     .			    mr_bad_data(mx) )
	ENDIF

	RETURN
	END 

      SUBROUTINE SET_VIEWPORT( ivp )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* set up the output viewport within the current window

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 -  8/31/88
* revision 0.1 -  9/29/88 - allow separate GKS normaliz. trans. for each window
* V200: 11/30/89 - pass viewport flag to PPLUS
*	  4/2/90 - clear screen with CLEAR_WINDOW
* Unix/RISC port - 2/91 - special cases for GKSDEFS include file
* V230:  11/4/92 - added call to SET_AX_SIZES to auto-size viewport axes
*        11/9/92 - incorporated SHASET PROTECT to save color tables
*        3/29/93 - restore the old-style functioning of DEFINE VIEW/SIZE
* V540: 9/01 *sh* - DEF VIEW/AXES: viewports based on *axis* positions
* V580: 11/04 *acm* New symbols for viewport scaling
* V602: *acm* 1/07 Changes for metafile-batch mode
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'
	include 'xplot_setup.cmn'
	include	'pltcom_dat.decl' ! with sizing data, etc.
	include	'PLTCOM.DAT'	         ! with sizing data, etc.
        include 'plt_inc.decl'     ! with width/height
        include 'PLT.INC'
	include	'ppl_in_ferret.cmn'	! with ppl_in_ferret
	include	'gkscm1_inc.decl'	! with gks common
	include	'GKSCM1.INC'	! with gks common
!	include 'gksdefs.bnd'		! with gclip
C  clipping indicator (lines from VMS SYS$LIBRARY:GKSDEFS.BND)
	INTEGER*4  GNCLIP,GCLIP
	DATA       GNCLIP,GCLIP/  0,    1/
	
* calling argument declarations:
	INTEGER	ivp

* internal variable declarations:
	LOGICAL clip, newstyle_vp
	INTEGER	iseg, i, old_vp, istate
	REAL	fctx, fcty, xclip, yclip
	REAL*4  rzero, arg1, arg2, arg3, arg4, r4_unspec, scale, 
     .          xov, yov, xcv, ycv, xfrac, yfrac,
     .          xcei, ycei, xoei, yoei

* main window opened yet ?
	IF ( .NOT.pplus_started ) CALL START_PPLUS

* only works under GKS
	IF ( .NOT. gksopn ) RETURN

	rzero = 0.0

* make this the new viewport
	old_vp = vp_num
	vp_num = ivp

* emulate the obsolete /SIZE qualifier?
	newstyle_vp = vp_size(ivp) .GT. 0.0

	IF ( old_vp .EQ. mvp_dflt .OR. vp_num .EQ. mvp_dflt ) THEN
* return to full screen - clear away everything
	   CALL CLEAR_WINDOW( wsid )
	   DO 100 i = mvp_dflt, max_viewport
	      vp_seg0(i) = 0
	      vp_segn(i) = 0
 100	   CONTINUE
	ELSE
* set new viewport - delete any segments showing in this viewport
	   DO 200 iseg = vp_seg0(vp_num)+1, vp_segn(vp_num)
 200	   CALL GDSG( iseg ) 
           CALL PPL_SHASET( 'PROTECT' ) ! protect the colors already on-screen
	ENDIF

* indicate where new segments in this viewport of this window begin
	vp_seg0( vp_num ) = curr_seg_name
	vp_segn( vp_num ) = curr_seg_name

* pass viewport flag to PPLUS
	PPL_viewports_active = vp_num .NE. mvp_dflt

* For viewport/AXES viewports, update ASIZE and BSIZE here,
* or else the first viewport plotted is in the wrong place.
        IF (vp_by_axis(vp_num)) THEN
           CALL GQOPS (istate)  ! In batch mode the graphics may not be active now. 
           IF (istate .GE. 2) CALL SIZE (width,height)
        ENDIF

* NDC space goes 0 to fctx and 0 to fcty (corresponding to PLOT+ SIZE command)
	IF(ASIZE.GT.BSIZE)THEN
	   FCTY=BSIZE/ASIZE
	   FCTX=1.0
	ELSE
	   FCTX=ASIZE/BSIZE
	   FCTY=1.0
	ENDIF

* decode clipping
	r4_unspec = unspecified_val4
	clip = vp_xclip(vp_num) .NE. r4_unspec
	IF ( clip ) THEN
	   xclip = vp_xclip( vp_num )
	   yclip = vp_yclip( vp_num )
	ELSE
	   xclip = 1.0
	   yclip = 1.0
	ENDIF

* determine the scale factor to be applied to the axis length to create
* the "text_prominence" effect
	scale = 1.0 / SQRT( ABS(vp_size(vp_num)) )

* ... V5.22 default behaviors (viewport not specified by axis)
        xoei = xwhitelo  ! ppl xorigin
        yoei = ywhitelo  ! ppl yorigin
        xcei = xwhitehi  ! white space to right of X axis
        ycei = ywhitehi  ! white space for docmtn at top of plot
        xov = vp_xorg(vp_num)
        xcv = xclip
        yov = vp_yorg(vp_num)
        ycv = yclip
        IF (vp_by_axis(vp_num)) THEN
          CALL VP_AXLIM2LIM( scale, xov, yov, xcv, ycv, xov, yov, xcv, ycv, 
     .                       xoei, yoei, xcei, ycei)
        ENDIF
* set viewport in NDC to limits requested

	arg1 = fctx*xov
	arg2 = fctx*xcv
	arg3 = fcty*yov
	arg4 = fcty*ycv
	CALL GSVP(wsid, arg1, arg2, arg3, arg4 )

* set world coordinate window to preserve 1:1 aspect
	arg1 = ( xcv-xov )*asize*scale
	arg2 = ( ycv-yov )*bsize*scale
	CALL GSWN(wsid, rzero, arg1, rzero, arg2 )

	IF ( newstyle_vp ) THEN

* auto-size the axes to fit the plot window
           xfrac = scale*(xcv-xov)
           yfrac = scale*(ycv-yov)

           CALL SET_AX_SIZES( xfrac, yfrac,
     .                        xoei, yoei, xcei, ycei )

* Set more symbols describing the viewport

           CALL SET_VP_SYMBOLS (scale, vp_size(vp_num), xfrac, yfrac,
     .			        xoei, yoei, xcei, ycei,
     .                          xov,  yov,  xcv,  ycv)

	   CALL GSELNT(wsid)     ! no clipping 11/92 (below) for PPL BOX ON 

	ELSE
* emulate old-style, non-automated viewports
* select normalization transformation and turn on clipping
	   CALL GSELNT(wsid)
	   IF ( clip ) THEN
	      CALL GSCLIP(gclip)
	   ELSE
	      CALL GSCLIP(gnclip)
	   ENDIF
	ENDIF

* success
	RETURN
	END

      SUBROUTINE FRMT(XMIN,XMAX,IPRES,IF) 
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)frmt.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
* V530 *sh* 11/00 - added extra digits for E formats with close-spaced
*       range -- like [9080,1020]
*      *sh* 12/00 -- further tweak to use E format less often
* V541 *acm* 3/02 -- bug fix: For small negative numbers, if label is negative 
*                    need one more decimal place (ib)
* V600 *acm* 1/06   prevent values of LOG10(0.0)
* V68  *acm* 12/11  fix ticket 1907: precision of labels where axis range is in (-1,1)
* V685 *acm* 7/13  Ticket 1990: fixes for number of digits. More precision needed 
*                 (Lavelle examples) 

      CHARACTER*(*) IF 

      INTEGER nt
      REAL    scale, xhi, xlo, x1, x2, pow

C     THIS SUBROUTINE CHOOSE THE FORMAT   NOT ANSI STANDARD 

      xhi = xmax
      xlo = xmin
      scale = 0

      DX=ABS(XMAX-XMIN)
      IF(DX.EQ.0.)DX=ABS(XMAX)
      IF(DX.EQ.0.)DX=10000.0 
      XX=ABS(XMAX) 
      IF(XX.LT.ABS(XMIN))XX=ABS(XMIN) 
      IF(XX.GE.100000..OR.XX.LT..001)GOTO 100 

C When the range lies between -1 and 1, and their order
C of magnitudes are not the same, the method didnt give enough
C precision. Make the computation on scaled numbers, and
C adjust back when creating the format.  (bug 1907)

      IF (ABS(xhi) .LT. 1. .AND. ABS(xlo) .LT. 1.) THEN
         scale = 1.
	 IF (xlo .EQ. 0.) xlo = xhi
	 IF (xhi .EQ. 0.) xhi = xlo
	 IF (xhi .EQ. 0.) THEN
	    xhi = 1000.
	    xlo = 1000.
	 ENDIF
         X1 = ABS(ALOG10(ABS(xhi)))
         X2 = ABS(ALOG10(ABS(xlo)))
	 nt = IFIX(MAX(x1,x2))
	 pow = 10.0 ** nt
	 xhi = pow*xhi
	 xlo = pow*xlo
      ENDIF

      DX=ABS(xhi-xlo)
      IF(DX.EQ.0.)DX=ABS(xhi)
      IF(DX.EQ.0.)DX=10000.0 
      XX=ABS(xhi) 
      IF(XX.LT.ABS(xlo))XX=ABS(xlo) 
      IF(XX.GE.100000..OR.XX.LT..001)GOTO 100 
200   IP=ABS(IPRES) 
      ID=IP-IFIX(ALOG10(DX)+.5) 
      IF(ID.LT.0)ID=0 
      IB=IFIX(ALOG10(XX*1.00001)) 
      IF (xlo .LT. 0 ) ib = ib + 1
      IF (scale .NE. 0) id = id + nt

* If delta is small, we need more precision.
      IF (DX.LT.0.1) THEN
         NT = NINT(ABS(ALOG10(DX)) + 0.5)
	 IF (NT .GE. ID) ID = NT + 1
      ENDIF


      WRITE(IF,999)IB+ID+3,ID 
999   FORMAT('(F',I2,'.',I1,')')
      RETURN 
100   IF(IPRES.LT.0)GOTO 200 

* increased digits for ranges like [9080,1020] - 11/00
        IF (XX .NE. 0.) ip = MAX(ipres,
     .       (IFIX(ALOG10(xx*1.00001)) +1) - IFIX(ALOG10(dx)) )
        
      ID=ip-1 
      IF(ID.LT.0)ID=0 
      WRITE(IF,998) ID+7,ID 
998   FORMAT('(1PE',I2,'.',I1,')') 
      RETURN 
      END 

	SUBROUTINE TM_I4_TO_R4( input, vals, n)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* convert an array of INTEGER*4 values into REAL
* use backwards loop so input and output can be same array

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 2/92
* replaced "elif" syntax with
*	else
*	   if
*  for SGI port	 - kob 4/8/92
*
* argument declarations
      INTEGER n
      INTEGER*4 input(n)
      REAL  vals(n)

* local variable declarations
      INTEGER i

      DO 100 i = n, 1, -1
 100  vals(i) = input(i)

      RETURN
      END

***************************************************************

	SUBROUTINE TM_I2_TO_R4( input, vals, n)

* convert an array of INTEGER*2 values into REAL
* use backwards loop so input and output can be same array

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 2/92

* argument declarations
      INTEGER n
      INTEGER*2 input(n)
      REAL  vals(n)

* local variable declarations
      INTEGER i

      DO 100 i = n, 1, -1
 100  vals(i) = input(i)

      RETURN
      END

***************************************************************
	SUBROUTINE TM_I1_TO_R4( input, vals, n)

* convert an array of INTEGER*4 values into REAL
* use backwards loop so input and output can be same array

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 2/92

* argument declarations
      INTEGER n
      REAL  vals(n)
#ifdef sun
      BYTE input(n)
#else
#	if unix
      		INTEGER*1 input(n)
#	else
      		BYTE input(n)
#	endif
#endif

* local variable declarations
      INTEGER i

      DO 100 i = n, 1, -1
 100  vals(i) = input(i)

      RETURN
      END

	SUBROUTINE FREE_MEMORY ( mblk, num_blocks )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* return a contiguous region of bulk memory to the free list merging it with
* the surrounding free regions if they are contiguous
* ( return the merged size via COMMON in mr_del_last_size )
* see documentation in XVARIABLES.CMN

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 4/1/86
* revision 1.0 - 7/21/88 - complete re-write using linked list
* V200:  6/12/89 - use doubly linked list; return mr_del_last_*
*	 8/1/89  - corrected bug: mr_del_last* not set for not contig at all
* V312: 5/94 - array "memory" as a calling argument
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'

* calling argument declarations:
	INTEGER	mblk, num_blocks, mem_blk, i

* internal variable declarations:
	INTEGER	prev, next, nex2
	LOGICAL	contig_above, contig_below

! temp diag
	IF ( num_blocks .NE. mblk_size( mblk ) ) STOP ' FREE_MEMORY'

!* as a diagnostic test - fill unused memory with a flag
! removed 5/18/94 as "memory" is no longer in COMMON 
!	IF ( mode_diagnostic ) THEN
!	   DO 50 mem_blk = mblk, mblk+num_blocks-1
!	   DO 50 i = 1, mem_blk_size
! 50	   memory( i,mem_blk ) = bad_val4
!	ENDIF

* find the position of "mblk" in the ordered free memory list
	prev = 0
	next = mblk_flink( prev )
 100	IF ( next .EQ. 0 ) THEN
* ... end of list - this mblk value must be greater than anything in the list
	   GOTO 200
	ELSEIF ( next .LT. mblk ) THEN
* ... keep looking further in the list
	   prev = next
	   next = mblk_flink( next )
	   GOTO 100
	ENDIF
* ... found it - prev<mblk and next>mblk
	nex2 = mblk_flink( next )

* will the new region merge contiguously above or below ?
 200	contig_above = mblk + num_blocks .EQ. next
	contig_below = prev + mblk_size(prev) .EQ. mblk
     .		 .AND. prev .NE. 0

* insert the freed bulk memory region into the free list
	IF ( contig_above .AND. contig_below ) THEN
	   mr_del_last_mblk   = prev
	   mr_del_last_size   = mblk_size( prev )
     .			      + num_blocks
     .			      + mblk_size( next )
	   mblk_size ( prev ) = mr_del_last_size
	   mblk_flink( prev ) = nex2
	   mblk_blink( nex2 ) = prev
	   mblk_flink( mblk ) = unspecified_int4	! temp diag
	   mblk_blink( mblk ) = unspecified_int4	! temp diag
	   mblk_size ( mblk ) = unspecified_int4	! temp diag
	   mblk_flink( next ) = unspecified_int4	! temp diag
	   mblk_blink( next ) = unspecified_int4	! temp diag
	   mblk_size ( next ) = unspecified_int4	! temp diag

	ELSEIF ( contig_above ) THEN
	   mr_del_last_mblk   = mblk
	   mr_del_last_size   = num_blocks + mblk_size( next )
	   mblk_size ( mblk ) = mr_del_last_size
	   mblk_flink( mblk ) = nex2
	   mblk_blink( mblk ) = prev
	   mblk_blink( nex2 ) = mblk
	   mblk_flink( prev ) = mblk
	   mblk_flink( next ) = unspecified_int4	! temp diag
	   mblk_blink( next ) = unspecified_int4	! temp diag
	   mblk_size ( next ) = unspecified_int4	! temp diag

	ELSEIF ( contig_below ) THEN
	   mr_del_last_mblk   = prev
	   mr_del_last_size   = mblk_size( prev ) + num_blocks
	   mblk_size ( prev ) = mr_del_last_size
	   mblk_flink( mblk ) = unspecified_int4	! temp diag
	   mblk_blink( mblk ) = unspecified_int4	! temp diag
	   mblk_size ( mblk ) = unspecified_int4	! temp diag

	ELSE
	   mr_del_last_mblk   = mblk
	   mr_del_last_size   = num_blocks
	   mblk_flink( mblk ) = next
	   mblk_blink( mblk ) = prev
	   mblk_flink( prev ) = mblk
	   mblk_blink( next ) = mblk

	ENDIF
	RETURN
	END

      SUBROUTINE OPERATE (	operation, num_com, ifv, com_cx,
     .				com1, mr1,
     .				com2, mr2,
     .				com3, mr3,
     .				com4, mr4,
     .				res, mres )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* perform an operation involving portions of 0,1,2 or 3 input grids
* and producing an entire result grid

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  6/20/89-8/3/89 - based on GRID_OPERATION
*		 - 4-D symmetric where components may have differing dims
*		 - eliminated derivatives (now "@" transformations)
*		 - added IGNORE0 and EXP
*	10/11/89 - modified array declarations using XMEM_SUBSC.CMN
*	10/26/89 - corrected bad flag bug by introducing bad_res
*	11/28/89 - reordering of functions for change to in-fix notation
*	 3/19/90 - added ATAN,ATAN2,ASIN,ACOS
*	 3/29/90 - added RANDU,RANDN
* Unix/RISC port - 10/91 - corrected improper calculation of MISSING func
*                          for cases where arg1 was ok but arg2 was bad
* V230:  8/5/92 - added new functions RHO_UN and THETA_UN
*               - upped to 4 the number of function arguments allowed
*       8/19/92 - LOG and LN args must be positive
*                 EXP arg is limited to (approx.) 77
*                 RHO salinity arg must be non-negative
*	6/93	- correct subscript bug introduced 8/19/92
* V320: 11/94   - added new function DAY1900(year, month, day)
* Linux Port  12/96 *kob* - had to pass 0.0 to RANDU and RANDN rather 
*			    than the 0 that was being passed. F90 
*			    complained about inconsistent datatypes
* v491: 4/98 *kob* - had to fix incorrect array references using i1,j1,k1 for
*                    arrays com2, com3
* V510 *sh* 1/00 - fixed argument checks on DAYS1900
*                - allow pre-1900, forbid month>12
*      5/00 *sh* - bug fix in line checking month>12
* v5.40*acm* add comment: days1900 returns days since 1-jan-1900, STANDARD CALENDAR
* V600 4/06  *acm*  return the result from days_from_day0 in dummy, for 64-bit build
* V671 7/11  *acm* Ticket 1868 IFV - masking expressions with ifValid, treating 
*		   zero as valid.
* V672 9/11  *acm* add RANDU2,RANDN2.  The way RANDN works, with SAVEd variables,
*                  it's not going to work well as an external function.
* V6.8 for double-precision Ferret do the RANDU calculation
*      with a real*4 argument. Gives consistent results with single-p.
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include 'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xcontext.cmn'

* calling argument declarations:
	LOGICAL ifv
	INTEGER	operation, num_com, com_cx(4), mr1, mr2, mr3, mr4, mres
	REAL    com1( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .		com2( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,m2lot:m2hit,m2loe:m2hie,m2lof:m2hif ),
     .		com3( m3lox:m3hix,m3loy:m3hiy,m3loz:m3hiz,m3lot:m3hit,m3loe:m3hie,m3lof:m3hif ),
     .		com4( m4lox:m4hix,m4loy:m4hiy,m4loz:m4hiz,m4lot:m4hit,m4loe:m4hie,m4lof:m4hif ),
     .		 res( m5lox:m5hix,m5loy:m5hiy,m5loz:m5hiz,m5lot:m5hit,m5loe:m5hie,m5lof:m5hif )

* internal variable declarations:
	LOGICAL	first
	INTEGER CX_DIM_LEN, op, i, j, k, l, m, n, icom, idim,
     .		i1, j1, k1, l1, m1, n1, i2, j2, k2, l2, m2, n2, 
     .		i3, j3, k3, l3, m3, n3, i4, j4, k4, l4, m4, n4, 
     .		di1, dj1, dk1, dl1, dm1, dn1, 
     .		di2, dj2, dk2, dl2, dm2, dn2,
     .		di3, dj3, dk3, dl3, dm3, dn3, 
     .		di4, dj4, dk4, dl4, dm4, dn4,
     .		si1, sj1, sk1, sl1, sm1, sn1, 
     .		si2, sj2, sk2, sl2, sm2, sn2,
     .		si3, sj3, sk3, sl3, sm3, sn3, 
     .		si4, sj4, sk4, sl4, sm4, sn4, 
     .		inseed
	REAL	RANDU, RANDN, RANDN2, RHO_UNESCO, THETA_FOFF,
     .		DAYS_FROM_DAY0,
     .          bad1, bad2, bad3, bad4, bad_res, dummy,
     .          op_repl
	REAL*4  R_IN

* equivalence conveniences. Arrays are (idim, icom)
* "inc" is the increments for each axis of each component 
* "lo"  is the starting subscript (minus 1) for each axis of each component
	INTEGER	inc(nferdims,4), lo(nferdims,4)
	EQUIVALENCE
     .	(lo(1,1),si1), (lo(2,1),sj1), (lo(3,1),sk1), (lo(4,1),sl1), (lo(5,1),sm1), (lo(6,1),sn1), 
     .	(lo(1,2),si2), (lo(2,2),sj2), (lo(3,2),sk2), (lo(4,2),sl2), (lo(5,2),sm2), (lo(6,2),sn2), 
     .	(lo(1,3),si3), (lo(2,3),sj3), (lo(3,3),sk3), (lo(4,3),sl3), (lo(5,3),sm3), (lo(6,3),sn3), 
     .	(lo(1,4),si4), (lo(2,4),sj4), (lo(3,4),sk4), (lo(4,4),sl4), (lo(5,4),sm4), (lo(6,4),sn4),
     .	(inc(1,1),di1),(inc(2,1),dj1),(inc(3,1),dk1),(inc(4,1),dl1),(inc(5,1),dm1),(inc(6,1),dn1), 
     .	(inc(1,2),di2),(inc(2,2),dj2),(inc(3,2),dk2),(inc(4,2),dl2),(inc(5,2),dm2),(inc(6,2),dn2), 
     .	(inc(1,3),di3),(inc(2,3),dj3),(inc(3,3),dk3),(inc(4,3),dl3),(inc(5,3),dm3),(inc(6,3),dn3), 
     .	(inc(1,4),di4),(inc(2,4),dj4),(inc(3,4),dk4),(inc(4,4),dl4),(inc(5,4),dm4),(inc(6,4),dn4)

* internal parameter declarations:
	REAL*8          pdays_by_1900
	PARAMETER     ( pdays_by_1900 = 59958230400.0 / (60.*60.*24.) )

* flag(s) for bad or missing values
	bad1 = mr_bad_data ( mr1 )
	bad2 = mr_bad_data ( mr2 )
	bad3 = mr_bad_data ( mr3 )
	bad4 = mr_bad_data ( mr4 )
	bad_res = mr_bad_data( mres )

* For operations, e.g.  IF var GT a THEN b, create a mask of 1's and 0's.
* but for expressions using IFV, the mask needs to be 1's and bad-values.
* If its an IFV expression then use the corresponding THEN and ELSE.

        op = operation
	op_repl = 0.
	IF (ifv) THEN
	   op_repl = bad_res
	   IF (op .EQ. 45) op = 47
	   IF (op .EQ. 46) op = 48
        ENDIF

* compute the delta increment for each axis of each component
	DO 10 icom = 1, num_com
	DO 10 idim = 1, nferdims
	   IF ( CX_DIM_LEN(idim,com_cx(icom)) .EQ. 1 ) THEN
	      inc(idim,icom) = 0
	   ELSE
	      inc(idim,icom) = 1
	   ENDIF
 10	CONTINUE

* compute the starting subscript for each axis of each component
* (pre-decrement by 1 delta for looping ahead)
	DO 20 icom = 1, num_com
	DO 20 idim = 1, nferdims
 20	lo(idim,icom) = cx_lo_ss(com_cx(icom),idim) - inc(idim,icom)

* operators, functions, logic structures
	GOTO (   100, 200, 300, 400, 500, 600, 700, 800, 900,1000,
     .		1100,1200,1300,1400,1500,1600,1700,1800,
     .
     .		1900,2000,
     .		2100,2200,2300,2400,2500,2600,2700,2800,2900,3000,
     .		3100,3200,3300,3400,3500,3600,3700,3800,3900,4000,
     .		4100,4200,4300,
     .
     .		4400,4500,4600,4700,4800		   ) op

* ----------------------------------------------------------------------------
* ------- OPERATORS -------------
*
* "+"
 100	n1 = sn1
	n2 = sn2
	DO 110 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	  DO 110 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 110 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  k1 = sk1
	  k2 = sk2
	   DO 110 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   j1 = sj1
	   j2 = sj2
	    DO 110 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    i1 = si1
	    i2 = si2
	     DO 110 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2

	     IF ( com1(i1,j1,k1,l1,m1,n1) .EQ. bad1
     .	     .OR. com2(i2,j2,k2,l2,m2,n2) .EQ. bad2 ) THEN
	        res(i,j,k,l,m,n) = bad_res
	     ELSE
	        res(i,j,k,l,m,n) = com1(i1,j1,k1,l1,m1,n1) + com2(i2,j2,k2,l2,m2,n2)
	     ENDIF

 110	CONTINUE
	RETURN

* "-"
 200	n1 = sn1
	n2 = sn2
	DO 210 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	  DO 210 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 210 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  k1 = sk1
	  k2 = sk2
	   DO 210 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   j1 = sj1
	   j2 = sj2
	    DO 210 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    i1 = si1
	    i2 = si2
	     DO 210 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2

	   IF ( com1(i1,j1,k1,l1,m1,n1) .EQ. bad1
     .	   .OR. com2(i2,j2,k2,l2,m2,n2) .EQ. bad2 ) THEN
	      res(i,j,k,l,m,n) = bad_res
	   ELSE
	      res(i,j,k,l,m,n) = com1(i1,j1,k1,l1,m1,n1) - com2(i2,j2,k2,l2,m2,n2)
	   ENDIF

 210	CONTINUE
	RETURN
* "*"
 300	n1 = sn1
	n2 = sn2
	DO 310 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	  DO 310 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 310 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  k1 = sk1
	  k2 = sk2
	   DO 310 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   j1 = sj1
	   j2 = sj2
	    DO 310 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    i1 = si1
	    i2 = si2
	     DO 310 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2

	   IF ( com1(i1,j1,k1,l1,m1,n1) .EQ. bad1
     .	   .OR. com2(i2,j2,k2,l2,m2,n2) .EQ. bad2 ) THEN
	      res(i,j,k,l,m,n) = bad_res
	   ELSE
	      res(i,j,k,l,m,n) = com1(i1,j1,k1,l1,m1,n1) * com2(i2,j2,k2,l2,m2,n2)
	   ENDIF

 310	CONTINUE
	RETURN

* "/"
 400	n1 = sn1
	n2 = sn2
	DO 410 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	  DO 410 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 410 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  k1 = sk1
	  k2 = sk2
	   DO 410 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   j1 = sj1
	   j2 = sj2
	    DO 410 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    i1 = si1
	    i2 = si2
	     DO 410 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2

	     IF ( com1(i1,j1,k1,l1,m1,n1) .EQ. bad1
     .	     .OR. com2(i2,j2,k2,l2,m2,n2) .EQ. bad2
     .	     .OR. com2(i2,j2,k2,l2,m2,n2) .EQ. 0.0   ) THEN
	        res(i,j,k,l,m,n) = bad_res
	     ELSE
	        res(i,j,k,l,m,n) = com1(i1,j1,k1,l1,m1,n1) / com2(i2,j2,k2,l2,m2,n2)
	     ENDIF

 410	CONTINUE
	RETURN

* "^"
 500	n1 = sn1
	n2 = sn2
	DO 510 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	  DO 510 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 510 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  k1 = sk1
	  k2 = sk2
	   DO 510 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   j1 = sj1
	   j2 = sj2
	    DO 510 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    i1 = si1
	    i2 = si2
	     DO 510 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2

	     IF ( com1(i1,j1,k1,l1,m1,n1) .EQ. bad1
     .	     .OR. com2(i2,j2,k2,l2,m2,n2) .EQ. bad2
     .	     .OR.    ( com1(i1,j1,k1,l1,m1,n1) .EQ. 0.0
     .	         .AND. com2(i2,j2,k2,l2,m2,n2) .LT. 0.0 ) ) THEN
	        res(i,j,k,l,m,n) = bad_res
	     ELSEIF ( com2(i2,j2,k2,l2,m2,n2).EQ.FLOAT(INT(com2(i2,j2,k2,l2,m2,n2))) ) THEN
	        res(i,j,k,l,m,n) = com1(i1,j1,k1,l1,m1,n1) ** INT(com2(i2,j2,k2,l2,m2,n2))
	     ELSEIF ( com1(i1,j1,k1,l1,m1,n1) .LT. 0.0 )	THEN
	        res(i,j,k,l,m,n) = bad_res
	     ELSE
	        res(i,j,k,l,m,n) = com1(i1,j1,k1,l1,m1,n1) ** com2(i2,j2,k2,l2,m2,n2)
	     ENDIF

 510	CONTINUE
	RETURN

* "AND" - logical AND of 2 masks (any non-zero data regarded as .TRUE.)
 600    n1 = sn1
	n2 = sn2
	DO 610 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	  DO 610 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 610 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  k1 = sk1
	  k2 = sk2
	   DO 610 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   j1 = sj1
	   j2 = sj2
	    DO 610 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    i1 = si1
	    i2 = si2
	     DO 610 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2

	     IF ( com1(i1,j1,k1,l1,m1,n1) .EQ. bad1
     .	     .OR. com2(i2,j2,k2,l2,m2,n2) .EQ. bad2 ) THEN
	        res(i,j,k,l,m,n) = bad_res
	     ELSE
	        IF ( com1(i1,j1,k1,l1,m1,n1).NE.0.0
     .	       .AND. com2(i2,j2,k2,l2,m2,n2).NE.0.0 ) THEN
		   res(i,j,k,l,m,n) = 1.0
	        ELSE
	  	 res(i,j,k,l,m,n) = op_repl
	        ENDIF
	     ENDIF
 610	CONTINUE
	RETURN

* "OR" - logical OR of 2 masks (any non-zero data regarded as .TRUE.)
 700	n1 = sn1
	n2 = sn2
	DO 710 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	  DO 710 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 710 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  k1 = sk1
	  k2 = sk2
	   DO 710 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   j1 = sj1
	   j2 = sj2
	    DO 710 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    i1 = si1
	    i2 = si2
	     DO 710 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2

	     IF ( com1(i1,j1,k1,l1,m1,n1) .EQ. bad1
     .	     .OR. com2(i2,j2,k2,l2,m2,n2) .EQ. bad2 ) THEN
	        res(i,j,k,l,m,n) = bad_res
	     ELSE
	        IF ( com1(i1,j1,k1,l1,m1,n1).NE.0.0
     .	        .OR. com2(i2,j2,k2,l2,m2,n2).NE.0.0 ) THEN
	  	   res(i,j,k,l,m,n) = 1.0
	        ELSE
		   res(i,j,k,l,m,n) = op_repl
	        ENDIF
	     ENDIF
 710	CONTINUE
	RETURN

* "GT" - mask of 1's where grid 1 exceeds grid 2, 0's elsewhere
* "GT" - mask of 1's where grid 1 exceeds grid 2, bad-val elsewhere
 800 	n1 = sn1
	n2 = sn2
	DO 810 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	  DO 810 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 810 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  k1 = sk1
	  k2 = sk2
	   DO 810 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   j1 = sj1
	   j2 = sj2
	    DO 810 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    i1 = si1
	    i2 = si2
	     DO 810 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2

	     IF ( com1(i1,j1,k1,l1,m1,n1) .EQ. bad1
     .	     .OR. com2(i2,j2,k2,l2,m2,n2) .EQ. bad2 ) THEN
	        res(i,j,k,l,m,n) = bad_res
	     ELSE
	      IF ( com1(i1,j1,k1,l1,m1,n1) .GT. com2(i2,j2,k2,l2,m2,n2) ) THEN
	  	   res(i,j,k,l,m,n) = 1.0
	        ELSE
		   res(i,j,k,l,m,n) = op_repl
	        ENDIF
	     ENDIF
 810	CONTINUE
	RETURN

* "GE" - mask of 1's where grid 1 exceeds or equals grid 2, 0's elsewhere
* "GE" - mask of 1's where grid 1 exceeds or equals grid 2, bad elsewhere
 900 	n1 = sn1
	n2 = sn2
	DO 910 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	  DO 910 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 910 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  k1 = sk1
	  k2 = sk2
	   DO 910 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   j1 = sj1
	   j2 = sj2
	    DO 910 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    i1 = si1
	    i2 = si2
	     DO 910 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2

	   IF ( com1(i1,j1,k1,l1,m1,n1) .EQ. bad1
     .	   .OR. com2(i2,j2,k2,l2,m2,n2) .EQ. bad2 ) THEN
	      res(i,j,k,l,m,n) = bad_res
	   ELSE
	      IF ( com1(i1,j1,k1,l1,m1,n1) .GE. com2(i2,j2,k2,l2,m2,n2) ) THEN
		 res(i,j,k,l,m,n) = 1.0
	      ELSE
		 res(i,j,k,l,m,n) = op_repl
	      ENDIF
	   ENDIF
 910	CONTINUE
	RETURN

* "LT" - mask of 1's where grid 1 is less than grid 2, 0's elsewhere
* "LT" - mask of 1's where grid 1 is less than grid 2, bad elsewhere
 1000 	n1 = sn1
	n2 = sn2
	DO 1010 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	  DO 1010 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 1010 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  k1 = sk1
	  k2 = sk2
	   DO 1010 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   j1 = sj1
	   j2 = sj2
	    DO 1010 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    i1 = si1
	    i2 = si2
	     DO 1010 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2

	   IF ( com1(i1,j1,k1,l1,m1,n1) .EQ. bad1
     .	   .OR. com2(i2,j2,k2,l2,m2,n2) .EQ. bad2 ) THEN
	      res(i,j,k,l,m,n) = bad_res
	   ELSE
	      IF ( com1(i1,j1,k1,l1,m1,n1) .LT. com2(i2,j2,k2,l2,m2,n2) ) THEN
		 res(i,j,k,l,m,n) = 1.0
	      ELSE
		 res(i,j,k,l,m,n) = op_repl
	      ENDIF
	   ENDIF
 1010	CONTINUE
	RETURN

* "LE" - mask of 1's where grid 1 is less than or equal to grid 2, 0's elsewhere
* "LE" - mask of 1's where grid 1 is less than or equal to grid 2, bad elsewhere
 1100	n1 = sn1
	n2 = sn2
	DO 1110 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	  DO 1110 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 1110 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  k1 = sk1
	  k2 = sk2
	   DO 1110 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   j1 = sj1
	   j2 = sj2
	    DO 1110 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    i1 = si1
	    i2 = si2
	     DO 1110 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2

	   IF ( com1(i1,j1,k1,l1,m1,n1) .EQ. bad1
     .	   .OR. com2(i2,j2,k2,l2,m2,n2) .EQ. bad2 ) THEN
	      res(i,j,k,l,m,n) = bad_res
	   ELSE
	      IF ( com1(i1,j1,k1,l1,m1,n1) .LE. com2(i2,j2,k2,l2,m2,n2) ) THEN
		 res(i,j,k,l,m,n) = 1.0
	      ELSE
		 res(i,j,k,l,m,n) = op_repl
	      ENDIF
	   ENDIF
 1110	CONTINUE
	RETURN

* "EQ" - mask of 1's where grids are equal, 0's elsewhere
* "EQ" - mask of 1's where grids are equal, bad elsewhere
 1200	n1 = sn1
	n2 = sn2
	DO 1210 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	  DO 1210 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 1210 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  k1 = sk1
	  k2 = sk2
	   DO 1210 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   j1 = sj1
	   j2 = sj2
	    DO 1210 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    i1 = si1
	    i2 = si2
	     DO 1210 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2

	   IF ( com1(i1,j1,k1,l1,m1,n1) .EQ. bad1
     .	   .OR. com2(i2,j2,k2,l2,m2,n2) .EQ. bad2 ) THEN
	      res(i,j,k,l,m,n) = bad_res
	   ELSE
	      IF ( com1(i1,j1,k1,l1,m1,n1) .EQ. com2(i2,j2,k2,l2,m2,n2) ) THEN
		 res(i,j,k,l,m,n) = 1.0
	      ELSE
		 res(i,j,k,l,m,n) = op_repl
	      ENDIF
	   ENDIF
 1210	CONTINUE
	RETURN

* "NE" - mask of 1's where grids are not equal, 0's elsewhere
 1300	n1 = sn1
	n2 = sn2
	DO 1310 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	  DO 1310 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 1310 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  k1 = sk1
	  k2 = sk2
	   DO 1310 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   j1 = sj1
	   j2 = sj2
	    DO 1310 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    i1 = si1
	    i2 = si2
	     DO 1310 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2

	   IF ( com1(i1,j1,k1,l1,m1,n1) .EQ. bad1
     .	   .OR. com2(i2,j2,k2,l2,m2,n2) .EQ. bad2 ) THEN
	      res(i,j,k,l,m,n) = bad_res
	   ELSE
	      IF ( com1(i1,j1,k1,l1,m1,n1) .NE. com2(i2,j2,k2,l2,m2,n2) ) THEN
		 res(i,j,k,l,m,n) = 1.0
	      ELSE
		 res(i,j,k,l,m,n) = op_repl
	      ENDIF
	   ENDIF
 1310	CONTINUE
	RETURN

 1400	CONTINUE
 1500	CONTINUE
 1600	CONTINUE
 1700	CONTINUE
 1800	CONTINUE
	STOP 'OPERATOR NOT IMPLEMENTED'
* -----------------------------------------------------------------------------
* -------- FUNCTIONS ------------

* "EXP" - exponential function
 1900	DO 1910 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 DO 1910 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  DO 1910 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   DO 1910 k = mr_lo_s3(mres), mr_hi_s3(mres)
	    DO 1910 j = mr_lo_s2(mres), mr_hi_s2(mres)
	     DO 1910 i = mr_lo_s1(mres), mr_hi_s1(mres)

	   IF ( com1(i,j,k,l,m,n) .EQ. bad1
     .     .OR. com1(i,j,k,l,m,n) .GT. 77.0 ) THEN    ! 8/92
	      res(i,j,k,l,m,n) = bad_res
	   ELSE
	      res(i,j,k,l,m,n) = EXP(com1(i,j,k,l,m,n))
	   ENDIF
 1910	CONTINUE
	RETURN

* "LOG"
 2000	DO 2010 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 DO 2010 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  DO 2010 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  DO 2010 k = mr_lo_s3(mres), mr_hi_s3(mres)
	    DO 2010 j = mr_lo_s2(mres), mr_hi_s2(mres)
	     DO 2010 i = mr_lo_s1(mres), mr_hi_s1(mres)

	   IF ( com1(i,j,k,l,m,n) .EQ. bad1
     .    .OR.  com1(i,j,k,l,m,n) .LE. 0.0 ) THEN    ! 8/92
	      res(i,j,k,l,m,n) = bad_res
	   ELSE
	      res(i,j,k,l,m,n) = LOG10( com1(i,j,k,l,m,n) )
	   ENDIF
 2010	CONTINUE
	RETURN

* "MAX"
 2100	n1 = sn1
	n2 = sn2
	DO 2110 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	  DO 2110 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 2110 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  k1 = sk1
	  k2 = sk2
	   DO 2110 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   j1 = sj1
	   j2 = sj2
	    DO 2110 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    i1 = si1
	    i2 = si2
	     DO 2110 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2

	   IF ( com1(i1,j1,k1,l1,m1,n1) .EQ. bad1
     .	   .OR. com2(i2,j2,k2,l2,m2,n2) .EQ. bad2 ) THEN
	      res(i,j,k,l,m,n) = bad_res
	   ELSE
	      res(i,j,k,l,m,n) = MAX( com1(i1,j1,k1,l1,m1,n1), com2(i2,j2,k2,l2,m2,n2) )
	   ENDIF

 2110	CONTINUE
	RETURN

* "MIN"
 2200	n1 = sn1
	n2 = sn2
	DO 2210 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	  DO 2210 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 2210 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  k1 = sk1
	  k2 = sk2
	   DO 2210 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   j1 = sj1
	   j2 = sj2
	    DO 2210 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    i1 = si1
	    i2 = si2
	     DO 2210 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2

	   IF ( com1(i1,j1,k1,l1,m1,n1) .EQ. bad1
     .	   .OR. com2(i2,j2,k2,l2,m2,n2) .EQ. bad2 ) THEN
	      res(i,j,k,l,m,n) = bad_res
	   ELSE
	      res(i,j,k,l,m,n) = MIN( com1(i1,j1,k1,l1,m1,n1), com2(i2,j2,k2,l2,m2,n2) )
	   ENDIF
 2210	CONTINUE
	RETURN

* "INT"
 2300	DO 2310 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 DO 2310 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  DO 2310 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   DO 2310 k = mr_lo_s3(mres), mr_hi_s3(mres)
	    DO 2310 j = mr_lo_s2(mres), mr_hi_s2(mres)
	     DO 2310 i = mr_lo_s1(mres), mr_hi_s1(mres)

	   IF ( com1(i,j,k,l,m,n) .EQ. bad1 ) THEN
	      res(i,j,k,l,m,n) = bad_res
	   ELSE
	      res(i,j,k,l,m,n) = INT( com1(i,j,k,l,m,n) )
	   ENDIF
 2310	CONTINUE
	RETURN

* "ABS"
 2400	DO 2410 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 DO 2410 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  DO 2410 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   DO 2410 k = mr_lo_s3(mres), mr_hi_s3(mres)
	    DO 2410 j = mr_lo_s2(mres), mr_hi_s2(mres)
	     DO 2410 i = mr_lo_s1(mres), mr_hi_s1(mres)

	   IF ( com1(i,j,k,l,m,n) .EQ. bad1 ) THEN
	      res(i,j,k,l,m,n) = bad_res
	   ELSE
	      res(i,j,k,l,m,n) = ABS( com1(i,j,k,l,m,n) )
	   ENDIF
 2410	CONTINUE
	RETURN

* "SIN"
 2500	DO 2510 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 DO 2510 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  DO 2510 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   DO 2510 k = mr_lo_s3(mres), mr_hi_s3(mres)
	    DO 2510 j = mr_lo_s2(mres), mr_hi_s2(mres)
	     DO 2510 i = mr_lo_s1(mres), mr_hi_s1(mres)

	   IF ( com1(i,j,k,l,m,n) .EQ. bad1 ) THEN
	      res(i,j,k,l,m,n) = bad_res
	   ELSE
	      res(i,j,k,l,m,n) = SIN( com1(i,j,k,l,m,n) )
	   ENDIF
 2510	CONTINUE
	RETURN

* "COS"
 2600	DO 2610 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 DO 2610 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  DO 2610 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   DO 2610 k = mr_lo_s3(mres), mr_hi_s3(mres)
	    DO 2610 j = mr_lo_s2(mres), mr_hi_s2(mres)
	     DO 2610 i = mr_lo_s1(mres), mr_hi_s1(mres)

	   IF ( com1(i,j,k,l,m,n) .EQ. bad1 ) THEN
	      res(i,j,k,l,m,n) = bad_res
	   ELSE
	      res(i,j,k,l,m,n) = COS( com1(i,j,k,l,m,n) )
	   ENDIF
 2610	CONTINUE
	RETURN

* "TAN"
 2700	DO 2710 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 DO 2710 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  DO 2710 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   DO 2710 k = mr_lo_s3(mres), mr_hi_s3(mres)
	    DO 2710 j = mr_lo_s2(mres), mr_hi_s2(mres)
	     DO 2710 i = mr_lo_s1(mres), mr_hi_s1(mres)

	   IF ( com1(i,j,k,l,m,n) .EQ. bad1 ) THEN
	      res(i,j,k,l,m,n) = bad_res
	   ELSE
	      res(i,j,k,l,m,n) = TAN( com1(i,j,k,l,m,n) )
	   ENDIF
 2710	CONTINUE
	RETURN

* "LN"
 2800	DO 2810 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 DO 2810 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  DO 2810 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   DO 2810 k = mr_lo_s3(mres), mr_hi_s3(mres)
	    DO 2810 j = mr_lo_s2(mres), mr_hi_s2(mres)
	     DO 2810 i = mr_lo_s1(mres), mr_hi_s1(mres)

	   IF ( com1(i,j,k,l,m,n) .EQ. bad1
     .    .OR.  com1(i,j,k,l,m,n) .LE. 0.0 ) THEN    ! 8/92
	      res(i,j,k,l,m,n) = bad_res
	   ELSE
	      res(i,j,k,l,m,n) = LOG( com1(i,j,k,l,m,n) )
	   ENDIF
 2810	CONTINUE
	RETURN

* "MOD"
 2900	n1 = sn1
	n2 = sn2
	DO 2910 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	  DO 2910 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 2910 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  k1 = sk1
	  k2 = sk2
	   DO 2910 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   j1 = sj1
	   j2 = sj2
	    DO 2910 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    i1 = si1
	    i2 = si2
	     DO 2910 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2

	   IF ( com1(i1,j1,k1,l1,m1,n1) .EQ. bad1
     .	   .OR. com2(i2,j2,k2,l2,m2,n2) .EQ. bad2 ) THEN
	      res(i,j,k,l,m,n) = bad_res
	   ELSE
	      res(i,j,k,l,m,n) = MOD( com1(i1,j1,k1,l1,m1,n1), com2(i2,j2,k2,l2,m2,n2) )
	   ENDIF
 2910	CONTINUE
	RETURN

* "MISSING" - replace missing value flag with values in grid 2
 3000	n1 = sn1
	n2 = sn2
	DO 3010 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	  DO 3010 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 3010 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  k1 = sk1
	  k2 = sk2
	   DO 3010 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   j1 = sj1
	   j2 = sj2
	    DO 3010 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    i1 = si1
	    i2 = si2
	     DO 3010 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2

	   IF ( com1(i1,j1,k1,l1,m1,n1) .NE. bad1 ) THEN
              res(i,j,k,l,m,n) = com1(i1,j1,k1,l1,m1,n1)
           ELSEIF ( com2(i2,j2,k2,l2,m2,n2) .NE. bad2 ) THEN
              res(i,j,k,l,m,n) = com2(i2,j2,k2,l2,m2,n2)
           ELSE
              res(i,j,k,l,m,n) = bad_res
           ENDIF

 3010	CONTINUE
	RETURN

* "IGNORE0" - replace zeros with bad flags
 3100	DO 3110 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 DO 3110 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  DO 3110 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   DO 3110 k = mr_lo_s3(mres), mr_hi_s3(mres)
	    DO 3110 j = mr_lo_s2(mres), mr_hi_s2(mres)
	     DO 3110 i = mr_lo_s1(mres), mr_hi_s1(mres)

	   IF ( com1(i,j,k,l,m,n) .EQ. bad1 ) THEN
	      res(i,j,k,l,m,n) = bad_res
	   ELSEIF ( com1(i,j,k,l,m,n) .EQ. 0 ) THEN
	      res(i,j,k,l,m,n) = bad_res
	   ELSE
	      res(i,j,k,l,m,n) = com1(i,j,k,l,m,n)
	   ENDIF
 3110	CONTINUE
	RETURN

* "ATAN"
 3200	DO 3210 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 DO 3210 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  DO 3210 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   DO 3210 k = mr_lo_s3(mres), mr_hi_s3(mres)
	    DO 3210 j = mr_lo_s2(mres), mr_hi_s2(mres)
	     DO 3210 i = mr_lo_s1(mres), mr_hi_s1(mres)

	   IF ( com1(i,j,k,l,m,n) .EQ. bad1 ) THEN
	      res(i,j,k,l,m,n) = bad_res
	   ELSE
	      res(i,j,k,l,m,n) = ATAN( com1(i,j,k,l,m,n) )
	   ENDIF
 3210	CONTINUE
	RETURN

* "ATAN2" - 2 argument arc tangent
 3300	n1 = sn1
	n2 = sn2
	DO 3310 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	  DO 3310 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 3310 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  k1 = sk1
	  k2 = sk2
	   DO 3310 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   j1 = sj1
	   j2 = sj2
	    DO 3310 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    i1 = si1
	    i2 = si2
	     DO 3310 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2

	   IF ( com1(i1,j1,k1,l1,m1,n1) .EQ. bad1
     .	   .OR. com2(i2,j2,k2,l2,m2,n2) .EQ. bad2 ) THEN
	      res(i,j,k,l,m,n) = bad_res
	   ELSEIF ( com1(i1,j1,k1,l1,m1,n1) .EQ. 0.0
     .	   .AND.    com2(i2,j2,k2,l2,m2,n2) .EQ. 0.0 ) THEN
	      res(i,j,k,l,m,n) = bad_res	! indeterminant
	   ELSE
	      res(i,j,k,l,m,n) = ATAN2( com1(i1,j1,k1,l1,m1,n1),com2(i2,j2,k2,l2,m2,n2) )
	   ENDIF

 3310	CONTINUE
	RETURN

* "ASIN"
 3400	DO 3410 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 DO 3410 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  DO 3410 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   DO 3410 k = mr_lo_s3(mres), mr_hi_s3(mres)
	    DO 3410 j = mr_lo_s2(mres), mr_hi_s2(mres)
	     DO 3410 i = mr_lo_s1(mres), mr_hi_s1(mres)

	   IF ( com1(i,j,k,l,m,n) .EQ. bad1
     .     .OR. com1(i,j,k,l,m,n) .LT. -1.
     .     .OR. com1(i,j,k,l,m,n) .GT. +1. ) THEN
	      res(i,j,k,l,m,n) = bad_res
	   ELSE
	      res(i,j,k,l,m,n) = ASIN( com1(i,j,k,l,m,n) )
	   ENDIF
 3410	CONTINUE
	RETURN

* "ACOS"
 3500	DO 3510 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 DO 3510 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  DO 3510 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   DO 3510 k = mr_lo_s3(mres), mr_hi_s3(mres)
	    DO 3510 j = mr_lo_s2(mres), mr_hi_s2(mres)
	     DO 3510 i = mr_lo_s1(mres), mr_hi_s1(mres)

	   IF ( com1(i,j,k,l,m,n) .EQ. bad1
     .     .OR. com1(i,j,k,l,m,n) .LT. -1.
     .     .OR. com1(i,j,k,l,m,n) .GT. +1. ) THEN
	      res(i,j,k,l,m,n) = bad_res
	   ELSE
	      res(i,j,k,l,m,n) = ACOS( com1(i,j,k,l,m,n) )
	   ENDIF
 3510	CONTINUE
	RETURN

* "RANDU" - random uniform
* use the first value as the seed
 3600	first = .TRUE.
	DO 3610 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 DO 3610 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  DO 3610 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   DO 3610 k = mr_lo_s3(mres), mr_hi_s3(mres)
	    DO 3610 j = mr_lo_s2(mres), mr_hi_s2(mres)
	     DO 3610 i = mr_lo_s1(mres), mr_hi_s1(mres)

	   IF ( com1(i,j,k,l,m,n) .EQ. bad1 ) THEN
	      res(i,j,k,l,m,n) = bad_res
	   ELSEIF ( first ) THEN
* ... note: floating point representation is passed as seed integer
              R_IN = REAL(com1(i,j,k,l,m,n))  ! for possibly double-prec. arg
	      res(i,j,k,l,m,n) = RANDU( R_IN )
	      first = .FALSE.
	   ELSE
              R_IN = 0.
	      res(i,j,k,l,m,n) = RANDU(R_IN)			!kob 12/96
	   ENDIF
 3610	CONTINUE
	RETURN

* "RANDN" - random normal
* use the first value as the seed
 3700	first = .TRUE.
	DO 3710 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 DO 3710 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  DO 3710 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   DO 3710 k = mr_lo_s3(mres), mr_hi_s3(mres)
	    DO 3710 j = mr_lo_s2(mres), mr_hi_s2(mres)
	     DO 3710 i = mr_lo_s1(mres), mr_hi_s1(mres)

	   IF ( com1(i,j,k,l,m,n) .EQ. bad1 ) THEN
	      res(i,j,k,l,m,n) = bad_res
	   ELSEIF ( first ) THEN
* ... note: floating point representation is passed as seed integer
              R_IN = REAL(com1(i,j,k,l,m,n))  ! for possibly double-prec. arg
	      res(i,j,k,l,m,n) = RANDN( R_IN )
	      first = .FALSE.
	   ELSE
              R_IN = 0.
	      res(i,j,k,l,m,n) = RANDN(R_IN)			!kob 12/96
	   ENDIF
 3710	CONTINUE
	RETURN

* "RHO" - UNESCO equation of state:
* rho = rho(salinity, temperature, pressure)
* three components - each may be a different XYZT shape
 3800	n1 = sn1
	n2 = sn2
	n3 = sn3
	DO 3810 n = mr_lo_s6(mres), mr_hi_s6(mres)
	n1 = n1 + dn1
	n2 = n2 + dn2
	n3 = n3 + dn3
	m1 = sm1
	m2 = sm2
	m3 = sm3
	 DO 3810 m = mr_lo_s5(mres), mr_hi_s5(mres)
	 m1 = m1 + dm1
	 m2 = m2 + dm2
	 m3 = m3 + dm3
	  l1 = sl1
	  l2 = sl2
	  l3 = sl3
	  DO 3810 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  l3 = l3 + dl3
	  k1 = sk1
	  k2 = sk2
	  k3 = sk3
	   DO 3810 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   k3 = k3 + dk3
	   j1 = sj1
	   j2 = sj2
	   j3 = sj3
	    DO 3810 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    j3 = j3 + dj3
	    i1 = si1
	    i2 = si2
	    i3 = si3
	     DO 3810 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2
	     i3 = i3 + di3

	   IF ( com1(i1,j1,k1,l1,m1,n1) .EQ. bad1
     .     .OR. com2(i2,j2,k2,l2,m2,n2) .EQ. bad2
     .     .OR. com3(i3,j3,k3,l3,m3,n3) .EQ. bad3
     .     .OR. com1(i1,j1,k1,l1,m1,n1) .LT. 0.0   ) THEN  ! salt>0 8/92
              res(i,j,k,l,m,n) = bad_res
           ELSE
              res(i,j,k,l,m,n) = RHO_UNESCO( com1(i1,j1,k1,l1,m1,n1),
     .                                   com2(i2,j2,k2,l2,m2,n2),
     .                                   com3(i3,j3,k3,l3,m3,n3) )
           ENDIF

 3810	CONTINUE
	RETURN

* "THETA" - potential temperature from BRYDEN,H.,1973,DEEP-SEA RES
*           and FOFONOFF,N,M,1977,DEEP-SEA RES
* theta = theta(salinity, temperature, pressure,reference_pressure)
* three components - each may be a different XYZT shape
 3900	n1 = sn1
	n2 = sn2
	n3 = sn3
	n4 = sn4
	DO 3910 n = mr_lo_s6(mres), mr_hi_s6(mres)
	n1 = n1 + dn1
	n2 = n2 + dn2
	n3 = n3 + dn3
	n4 = n4 + dn4
	m1 = sm1
	m2 = sm2
	m3 = sm3
	m4 = sm4
	 DO 3910 m = mr_lo_s5(mres), mr_hi_s5(mres)
	 m1 = m1 + dm1
	 m2 = m2 + dm2
	 m3 = m3 + dm3
	 m4 = m4 + dm4
	  l1 = sl1
	  l2 = sl2
	  l3 = sl3
	  l4 = sl4
	  DO 3910 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  l3 = l3 + dl3
	  l4 = l4 + dl4
	  k1 = sk1
	  k2 = sk2
	  k3 = sk3
	  k4 = sk4
	   DO 3910 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   k3 = k3 + dk3
	   k4 = k4 + dk4
	   j1 = sj1
	   j2 = sj2
	   j3 = sj3
	   j4 = sj4
	  DO 3910 j = mr_lo_s2(mres), mr_hi_s2(mres)
	  j1 = j1 + dj1
	  j2 = j2 + dj2
	  j3 = j3 + dj3
	  j4 = j4 + dj4
	  i1 = si1
	  i2 = si2
	  i3 = si3
	  i4 = si4
	   DO 3910 i = mr_lo_s1(mres), mr_hi_s1(mres)
	   i1 = i1 + di1
	   i2 = i2 + di2
	   i3 = i3 + di3
	   i4 = i4 + di4

	   IF ( com1(i1,j1,k1,l1,m1,n1) .EQ. bad1
     .     .OR. com2(i2,j2,k2,l2,m2,n2) .EQ. bad2
     .     .OR. com3(i3,j3,k3,l3,m3,n3) .EQ. bad3
     .     .OR. com4(i4,j4,k4,l4,m4,n4) .EQ. bad4 ) THEN
              res(i,j,k,l,m,n) = bad_res
           ELSE
              res(i,j,k,l,m,n) = THETA_FOFF( com1(i1,j1,k1,l1,m1,n1),
     .                                   com2(i2,j2,k2,l2,m2,n2),
     .                                   com3(i3,j3,k3,l3,m3,n3),
     .                                   com4(i4,j4,k4,l4,m4,n4) )
           ENDIF

 3910	CONTINUE
	RETURN

* "DAYS1900(year, month, day)" - number of days since 1900
* three components - each may be a different XYZT shape
* *** note: returns days since 1-jan-1900, on the STANDARD CALENDAR

 4000	n1 = sn1
	n2 = sn2
	n3 = sn3
	DO 4010 n = mr_lo_s6(mres), mr_hi_s6(mres)
	n1 = n1 + dn1
	n2 = n2 + dn2
	n3 = n3 + dn3
	m1 = sm1
	m2 = sm2
	m3 = sm3
	 DO 4010 m = mr_lo_s5(mres), mr_hi_s5(mres)
	 m1 = m1 + dm1
	 m2 = m2 + dm2
	 m3 = m3 + dm3
	  l1 = sl1
	  l2 = sl2
	  l3 = sl3
	  DO 4010 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  l3 = l3 + dl3
	  k1 = sk1
	  k2 = sk2
	  k3 = sk3
	   DO 4010 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   k3 = k3 + dk3
	   j1 = sj1
	   j2 = sj2
	   j3 = sj3
	    DO 4010 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    j3 = j3 + dj3
	    i1 = si1
	    i2 = si2
	    i3 = si3
	     DO 4010 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2
	     i3 = i3 + di3

* 4/98, 2nd references to com2, com3 incorrectly used i1,etc for array references
*       fixed that up - kob
	   IF ( com1(i1,j1,k1,l1,m1,n1) .EQ. bad1
     .     .OR. com2(i2,j2,k2,l2,m2,n2) .EQ. bad2
     .     .OR. com3(i3,j3,k3,l3,m3,n3) .EQ. bad3
     .     .OR. com2(i2,j2,k2,l2,m2,n2) .GT. 12.0
     .     .OR. com2(i2,j2,k2,l2,m2,n2) .LT. 1.0
     .     .OR. com3(i3,j3,k3,l3,m3,n3) .LT. 0.0    ) THEN
              res(i,j,k,l,m,n) = bad_res
           ELSE
              res(i,j,k,l,m,n) = DAYS_FROM_DAY0( pdays_by_1900,
     .					     INT(com1(i1,j1,k1,l1,m1,n1)),
     .                                       INT(com2(i2,j2,k2,l2,m2,n2)),
     .                                       INT(com3(i3,j3,k3,l3,m3,n3)),
     .                                       dummy)
           ENDIF

 4010	CONTINUE
	RETURN


* "RANDU2" - random uniform 
* Call the gfortran RANDOM_SEED and RANDOM_SEED functions.
* See ticket 1886 for discussions of RANDU
*
* iseed = 0   use previous seed - don't reinitialize
* iseed = -1 initialize using system clock
* iseed = integer > 0 initialize using that integer: results will be repeatable

 4100	CONTINUE
	n2 = sn2
	m2 = sm2
	l2 = sl2
	k2 = sk2
	j2 = sj2
	i2 = si2
        inseed = INT(com2(i2,j2,k2,l2,m2,n2))
        CALL INIT_RANDOM_SEED(inseed)
	DO 4110 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 DO 4110 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  DO 4110 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   DO 4110 k = mr_lo_s3(mres), mr_hi_s3(mres)
	    DO 4110 j = mr_lo_s2(mres), mr_hi_s2(mres)
	     DO 4110 i = mr_lo_s1(mres), mr_hi_s1(mres)

	   IF ( com1(i,j,k,l,m,n) .EQ. bad1 ) THEN
	      res(i,j,k,l,m,n) = bad_res
	   ELSE
	      CALL RANDOM_NUMBER(res(i,j,k,l,m,n))
	   ENDIF
 4110	CONTINUE
	RETURN

* "RANDN2" - random normal using gfortran RANDOM_SEED and RANDOM_SEED functions.
* seed set as for RANDU2
 4200	CONTINUE
	n2 = sn2
	m2 = sm2
	l2 = sl2
	k2 = sk2
	j2 = sj2
	i2 = si2
	first = .TRUE.
        inseed = INT(com2(i2,j2,k2,l2,m2,n2))
	DO 4210 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 DO 4210 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  DO 4210 l = mr_lo_s4(mres), mr_hi_s4(mres)
	   DO 4210 k = mr_lo_s3(mres), mr_hi_s3(mres)
	    DO 4210 j = mr_lo_s2(mres), mr_hi_s2(mres)
	     DO 4210 i = mr_lo_s1(mres), mr_hi_s1(mres)

	   IF ( com1(i,j,k,l,m,n) .EQ. bad1 ) THEN
	      res(i,j,k,l,m,n) = bad_res
	   ELSEIF ( first ) THEN
	      res(i,j,k,l,m,n) = RANDN2( inseed )
	      first = .FALSE.
	   ELSE
	      res(i,j,k,l,m,n) = RANDN2(0)
	   ENDIF

 4210	CONTINUE
	RETURN

 4300	CONTINUE
	STOP 'FUNCTION NOT IMPLEMENTED'

* ----------------------------------------------------------------------------
* ------- LOGIC STRUCTURES -------------
*
 4400	CONTINUE
* "THEN" - comes from IF (condition) THEN (choice)   ... no "ELSE" given
* component 1 is the condition.  component 2 is the choice
 4500	n1 = sn1
	n2 = sn2
	DO 4510 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	  DO 4510 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 4510 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  k1 = sk1
	  k2 = sk2
	   DO 4510 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   j1 = sj1
	   j2 = sj2
	    DO 4510 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    i1 = si1
	    i2 = si2
	     DO 4510 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2

	   IF ( com1(i1,j1,k1,l1,m1,n1) .NE. bad1
     .	  .AND. com1(i1,j1,k1,l1,m1,n1) .NE. 0.0
     .	  .AND. com2(i2,j2,k2,l2,m2,n2) .NE. bad2	 ) THEN
	      res(i,j,k,l,m,n) = com2(i2,j2,k2,l2,m2,n2)
	   ELSE
	      res(i,j,k,l,m,n) = bad_res
	   ENDIF

 4510	CONTINUE
	RETURN
* "ELSE" - comes from IF (condition) THEN (choice1) ELSE (choice2)
* component 1 is the condition.  components 2 and 3 are the choices
 4600	n1 = sn1
	n2 = sn2
	n3 = sn3
	DO 4610 n = mr_lo_s6(mres), mr_hi_s6(mres)
	n1 = n1 + dn1
	n2 = n2 + dn2
	n3 = n3 + dn3
	m1 = sm1
	m2 = sm2
	m3 = sm3
	 DO 4610 m = mr_lo_s5(mres), mr_hi_s5(mres)
	 m1 = m1 + dm1
	 m2 = m2 + dm2
	 m3 = m3 + dm3
	  l1 = sl1
	  l2 = sl2
	  l3 = sl3
	  DO 4610 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  l3 = l3 + dl3
	  k1 = sk1
	  k2 = sk2
	  k3 = sk3
	   DO 4610 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   k3 = k3 + dk3
	   j1 = sj1
	   j2 = sj2
	   j3 = sj3
	    DO 4610 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    j3 = j3 + dj3
	    i1 = si1
	    i2 = si2
	    i3 = si3
	     DO 4610 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2
	     i3 = i3 + di3

	   IF ( com1(i1,j1,k1,l1,m1,n1) .NE. bad1
     .	  .AND. com1(i1,j1,k1,l1,m1,n1) .NE. 0.0 ) THEN
	      IF ( com2(i2,j2,k2,l2,m2,n2) .NE. bad2 ) THEN
	         res(i,j,k,l,m,n) = com2(i2,j2,k2,l2,m2,n2)
	      ELSE
	         res(i,j,k,l,m,n) = bad_res
	      ENDIF
	   ELSE
	      IF ( com3(i3,j3,k3,l3,m3,n3) .NE. bad3 ) THEN
	         res(i,j,k,l,m,n) = com3(i3,j3,k3,l3,m3,n3)
	      ELSE
	         res(i,j,k,l,m,n) = bad_res
	      ENDIF
	   ENDIF
 4610	CONTINUE
	RETURN

* "THEN" - comes from IFV (condition) THEN (choice)   ... no "ELSE" given
* component 1 is the condition.  component 2 is the choice
 4700	n1 = sn1
	n2 = sn2
	DO 4710 n = mr_lo_s6(mres), mr_hi_s6(mres)
	 n1 = n1 + dn1
	 n2 = n2 + dn2
	 m1 = sm1
	 m2 = sm2
	  DO 4710 m = mr_lo_s5(mres), mr_hi_s5(mres)
	  m1 = m1 + dm1
	  m2 = m2 + dm2
	  l1 = sl1
	  l2 = sl2
	  DO 4710 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  k1 = sk1
	  k2 = sk2
	   DO 4710 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   j1 = sj1
	   j2 = sj2
	    DO 4710 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    i1 = si1
	    i2 = si2
	     DO 4710 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2

	   IF ( com1(i1,j1,k1,l1,m1,n1) .NE. bad1
     .	  .AND. com2(i2,j2,k2,l2,m2,n2) .NE. bad2	 ) THEN
	      res(i,j,k,l,m,n) = com2(i2,j2,k2,l2,m2,n2)
	   ELSE
	      res(i,j,k,l,m,n) = bad_res
	   ENDIF

 4710	CONTINUE
	RETURN
* "ELSE" - comes from IFV (condition) THEN (choice1) ELSE (choice2)
* component 1 is the condition.  components 2 and 3 are the choices
 4800	n1 = sn1
	n2 = sn2
	n3 = sn3
	DO 4810 n = mr_lo_s6(mres), mr_hi_s6(mres)
	n1 = n1 + dn1
	n2 = n2 + dn2
	n3 = n3 + dn3
	m1 = sm1
	m2 = sm2
	m3 = sm3
	 DO 4810 m = mr_lo_s5(mres), mr_hi_s5(mres)
	 m1 = m1 + dm1
	 m2 = m2 + dm2
	 m3 = m3 + dm3
	  l1 = sl1
	  l2 = sl2
	  l3 = sl3
	  DO 4810 l = mr_lo_s4(mres), mr_hi_s4(mres)
	  l1 = l1 + dl1
	  l2 = l2 + dl2
	  l3 = l3 + dl3
	  k1 = sk1
	  k2 = sk2
	  k3 = sk3
	   DO 4810 k = mr_lo_s3(mres), mr_hi_s3(mres)
	   k1 = k1 + dk1
	   k2 = k2 + dk2
	   k3 = k3 + dk3
	   j1 = sj1
	   j2 = sj2
	   j3 = sj3
	    DO 4810 j = mr_lo_s2(mres), mr_hi_s2(mres)
	    j1 = j1 + dj1
	    j2 = j2 + dj2
	    j3 = j3 + dj3
	    i1 = si1
	    i2 = si2
	    i3 = si3
	     DO 4810 i = mr_lo_s1(mres), mr_hi_s1(mres)
	     i1 = i1 + di1
	     i2 = i2 + di2
	     i3 = i3 + di3

	   IF ( com1(i1,j1,k1,l1,m1,n1) .NE. bad1 ) THEN
	      IF ( com2(i2,j2,k2,l2,m2,n2) .NE. bad2 ) THEN
	         res(i,j,k,l,m,n) = com2(i2,j2,k2,l2,m2,n2)
	      ELSE
	         res(i,j,k,l,m,n) = bad_res
	      ENDIF
	   ELSE
	      IF ( com3(i3,j3,k3,l3,m3,n3) .NE. bad3 ) THEN
	         res(i,j,k,l,m,n) = com3(i3,j3,k3,l3,m3,n3)
	      ELSE
	         res(i,j,k,l,m,n) = bad_res
	      ENDIF
	   ENDIF
 4810	CONTINUE

	RETURN

* error exits
! 9000	RETURN
	END

	SUBROUTINE ROW_COORD_FMT( idim, cx, lo_ss, hi_ss, del_ss,
     .				  fmt, decimal, row_ww, cleft )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* prepare a format suitable to label the subscripts and world coords at the
* left edge of each row of data.  The style will be (e.g.)
* "1.17N / 49:  26.31  26.06  26.01  26.04  26.14"

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V200:   7/9/90 - extracted from LIST_CMND_DATA
* V313:  31/10/94 - commas are mandatory in FORMAT statement on IBM/AIX
*		    changed format 3000 for all cases
* V540:  11/01 - allow for the possibility of non-positive (modulo) subscripts 
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction. 

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'

* calling argument declarations:
	INTEGER idim, cx, lo_ss, hi_ss, del_ss, decimal, row_ww, cleft
	CHARACTER*(*) fmt

* local variable declarations:
	LOGICAL	GEOG_LABEL, date_str
	INTEGER DATE_PREC, FIELD_WIDTH,
     .		grid, j, places, row_ss, row_ss_lo, numbers
	REAL	BOX_SIZE, small
	REAL*8	TM_WORLD

* initialize
	row_ww = 1			! fallback ...
	IF ( cx .LE. 0 ) GOTO 500	! fallback format is "I / nnn:"
	grid = cx_grid( cx )

* how large is the smallest "delta" world coordinate to represent ?
	small = +1.E33
	DO 100 j = lo_ss, hi_ss, del_ss
	   small = MIN( small, BOX_SIZE( j, grid, idim ) )
 100	CONTINUE	      

* what precision is needed to represent this delta and world range ?
	date_str = (idim .EQ. t_dim .OR. idim .EQ. f_dim) .AND.
     .		     GEOG_LABEL(idim,grid) 
	IF ( date_str ) THEN
	   decimal = DATE_PREC( grid, idim, small )
	ELSE
	   CALL GET_PREC_DIGITS(	cx_lo_ww(idim,cx),
     .					cx_hi_ww(idim,cx),
     .					small, places, decimal )
	ENDIF
	decimal = decimal + 1		! add 1 more, arbitrarily

* how many columns to fit the largest world coordinate ?
	row_ww = 0
	DO 200 j = lo_ss, hi_ss, del_ss
	   row_ww = MAX ( row_ww, FIELD_WIDTH
     .				  ( TM_WORLD(j,grid,idim,box_middle),
     .				    grid, idim, decimal, numbers ) )
 200	CONTINUE

* how many digits in the largest subscript ?
 500	IF ( hi_ss .NE. 0 ) THEN 
	  row_ss     = INT( LOG10(REAL(ABS(hi_ss))) ) + 1
	  IF (hi_ss .LT. 0) row_ss    = row_ss    + 1
	ELSE
	  row_ss   = 2
	ENDIF
	IF ( lo_ss .NE. 0 ) THEN 
	  row_ss_lo  = INT( LOG10(REAL(ABS(lo_ss))) ) + 1
	  IF (lo_ss .LT. 0) row_ss_lo = row_ss_lo + 1
	ELSE
	  row_ss_lo = 2
	ENDIF
	IF (row_ss_lo .GT. row_ss) row_ss = row_ss_lo

	WRITE ( fmt, 3000 ) row_ss + 1	! blank before digits
! 3000	FORMAT ( '('' /''I',I1,''':'')' ) 	! pre-AIX
 3000	FORMAT ( '('' /'',I',I1,',',''':'')' )	! typical: (' /',I3,':') 

* total columns needed at left
	cleft = row_ww + 4 + row_ss		! "$ / ss:"

	RETURN
	END

*           rr_adv_uz.F
*
*           Rick Romea
*           March 16, 2000	
*
*     Zonal nonlinear advective term:  -w du/dz
*     Units :     cm/s/s
*     MOM2 Grid:  U   
*
*******************************************************************

      SUBROUTINE RR_adv_uz_init(id)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

      CALL ef_set_desc             (id,
     .'-w(du/dz) nonlinear advective momentum term(cm/s^2);MOM2 U Grid')
      CALL ef_set_num_args         (id, 3)
      CALL ef_set_axis_inheritance (id, IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS, 
     .                                  IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok     (id, NO, NO, NO, NO)

      ! Define first argument (U)

      CALL ef_set_arg_name         (id, ARG1, 'U')
      CALL ef_set_arg_desc         (id, ARG1,
     . 'Zonal velocity, on the MOM2 U Grid. ')
      CALL ef_set_arg_unit         (id, ARG1, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG1, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG1, YES, YES, YES, YES)
      CALL ef_set_axis_extend      (id, ARG1, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG1, Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG1, Z_AXIS,0,+1)

      ! Define second argumen (W)

      CALL ef_set_arg_name         (id, ARG2, 'W')
      CALL ef_set_arg_desc         (id, ARG2,
     . 'Vertical velocity, at T cell bottom on the MOM2 Grid. ')
      CALL ef_set_arg_unit         (id, ARG2, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG2, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2, NO, NO, NO, YES)
      CALL ef_set_axis_extend      (id, ARG2, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG2, Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG2, Z_AXIS,0,+1)

      ! Define third argument (TEMP)

      CALL ef_set_arg_name         (id, ARG3, 'TEMP')
      CALL ef_set_arg_desc         (id, ARG3,
     . 'Potential temperature, required to access MOM2 T Grid. ')
      CALL ef_set_arg_unit         (id, ARG3, 'deg-C')
      CALL ef_set_arg_type         (id, ARG3, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG3, NO, NO, YES, YES)
      CALL ef_set_axis_extend      (id, ARG3, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG3, Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG3, Z_AXIS,0,+1)

      END




      SUBROUTINE RR_adv_uz_compute(id, arg_1, arg_2, arg_3, result)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER        id

      REAL           bad_flag(EF_MAX_ARGS)
      REAL           bad_flag_result
      REAL           arg_1 (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .                      mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL           arg_2 (mem2lox:mem2hix, mem2loy:mem2hiy, 
     .                      mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL           arg_3 (mem3lox:mem3hix, mem3loy:mem3hiy, 
     .                      mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL           result (memreslox:memreshix,memresloy:memreshiy,
     .                       memresloz:memreshiz,memreslot:memreshit)

      INTEGER        res_lo_ss (4)
      INTEGER        res_hi_ss (4)
      INTEGER        res_incr  (4)

      INTEGER        arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER        arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER        arg_incr  (4,EF_MAX_ARGS)

      INTEGER        i,  j,  k,  l
      INTEGER        i1, j1, k1, l1
      INTEGER        i2, j2, k2, l2

      REAL*8         yU(1024)
      REAL*8         xU(1024)
      REAL*8         zW(1024)
      REAL*8         yT(1024)
      REAL*8         xT(1024)

      INTEGER        ilat
      INTEGER        ilon
      INTEGER        iZ

      CHARACTER*16   ax_name(4)
      CHARACTER*16   ax_units(4)
      LOGICAL        backward(4)
      LOGICAL        modulo(4)
      LOGICAL        regular(4)

      REAL           dxt, dyt, dxu, dyu
      REAL           dus, dun, duw, due
      REAL           adv_fb, adv_vbu
      REAL           csu, cst

      INCLUDE 'rr_parameters.h'

C*********************************************************************
C
c     dzt     = vertical height of "u,v" or "t" grid box (in cm)
c     dyt     = latitudinal height of "t" grid box (in cm)
c     dxt     = longitudinal width of "t" grid box at the equator (cm)
c     dxu     = longitudinal width of "u,v" grid box at the equator (cm) 
c     dyu     = latitudinal height of "u,v" grid box (cm)
C
c     dus     = yu(j) - yt(j)
c     dun     = yt(j+1) - yu(j)
c     duw     = xu(i) - xt(i)
c     due     = xt(i+1) - xu(i)
C
c     yu(j)   = latitude of the jth "u,v" point in degrees 
c     yt(j)   = latitude of the jth "t" point in degrees   
c     xt(i)   = longitude of the ith "t" point in degrees  
c     xu(i)   = longitude of the ith "u,v" point in degrees
C 
C*********************************************************************

      dxt(i) = SNGL (xU(i)   - xU(i-1)) * Longitude_to_cm
      dyt(j) = SNGL (yU(j)   - yU(j-1)) * Latitude_to_cm
      dxu(i) = SNGL (xT(i+1) - xT(i))   * Longitude_to_cm
      dyu(j) = SNGL (yT(j+1) - yT(j))   * Latitude_to_cm
      dus(j) = SNGL (yU(j)   - yT(j))   * Latitude_to_cm
      dun(j) = SNGL (yT(j+1) - yU(j))   * Latitude_to_cm
      duw(i) = SNGL (xU(i)   - xT(i))   * Longitude_to_cm
      due(i) = SNGL (xT(i+1) - xU(i))   * Longitude_to_cm

      cst(j) = cos(SNGL(yT(j)) * Degrees_to_radians) 
      csu(j) = cos(SNGL(yU(j)) * Degrees_to_radians) 

      adv_vbu(i,j,k,l,iLat,iLon) =
     . ( arg_2(i,  j,  k,l) * dus(iLat) * duw(iLon) * cst(iLat)
     . + arg_2(i+1,j,  k,l) * dus(iLat) * due(iLon) * cst(iLat) 
     . + arg_2(i,  j+1,k,l) * dun(iLat) * duw(iLon) * cst(iLat+1)
     . + arg_2(i+1,j+1,k,l) * dun(iLat) * due(iLon) * cst(iLat+1)
     .                   ) / dyu(iLat) / dxu(iLon) / csu(iLat)

      adv_fb(i1,j1,k1,l1,i2,j2,k2,l2, iLat,iLon) = 
     .       	         adv_vbu(i2,j2,k2,l2,iLat,iLon)
     .                  * (arg_1(i1,j1,k1,l1) + arg_1(i1,j1,k1+1,l1))

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags      (id, bad_flag,  bad_flag_result)
      CALL ef_get_coordinates    (id, ARG1, X_AXIS, 
     .                            arg_lo_ss(X_AXIS,ARG1),
     .                            arg_hi_ss(X_AXIS,ARG1), xU)
      CALL ef_get_coordinates    (id, ARG1, Y_AXIS, 
     .                            arg_lo_ss(Y_AXIS,ARG1),
     .                            arg_hi_ss(Y_AXIS,ARG1), yU)
      CALL ef_get_coordinates    (id, ARG2, Z_AXIS, 
     .                            arg_lo_ss(Z_AXIS,ARG2),
     .                            arg_hi_ss(Z_AXIS,ARG2), zW)
      CALL ef_get_coordinates    (id, ARG3, X_AXIS, 
     .                            arg_lo_ss(X_AXIS,ARG3),
     .                            arg_hi_ss(X_AXIS,ARG3), xT)
      CALL ef_get_coordinates    (id, ARG3, Y_AXIS, 
     .                            arg_lo_ss(Y_AXIS,ARG3),
     .                            arg_hi_ss(Y_AXIS,ARG3), yT)
      CALL ef_get_axis_info  (id, ARG1, ax_name, ax_units, 
     .                                backward, modulo, regular) 
      IF     ( ax_units(1) .NE. 'deg'       .AND.
     .         ax_units(1) .NE. 'lon'       .AND.
     .         ax_units(1) .NE. 'degrees_E' .AND.
     .         ax_units(1) .NE. 'longitude' .AND.
     .         ax_units(1) .NE. 'Longitude' .AND. 
     .         ax_units(1) .NE. 'LONGITUDE' ) THEN
        WRITE (6,*)'Longitude axis units =', ax_units(1) 
        !CALL ef_bail_out(id,'Longitude axis must be in degrees')
      ENDIF

      IF     ( ax_units(2) .NE. 'deg'       .AND.
     .         ax_units(2) .NE. 'lat'       .AND.
     .         ax_units(2) .NE. 'degrees_N' .AND.
     .         ax_units(2) .NE. 'latitude'  .AND.
     .         ax_units(2) .NE. 'Latitude'  .AND. 
     .         ax_units(2) .NE. 'LATITUDE' ) THEN
        WRITE (6,*)'Latitude axis units =', ax_units(2) 
        !CALL ef_bail_out(id,'Latitude axis must be in degrees')
      ENDIF
      CALL ef_get_axis_info  (id, ARG1, ax_name, ax_units, 
     .                                backward, modulo, regular) 
      IF     ( ax_units(3) .NE. 'm'           .AND.
     .         ax_units(3) .NE. 'meters'  .AND.
     .         ax_units(3) .NE. 'M'           .AND.
     .         ax_units(3) .NE. 'METERS' ) THEN
        WRITE (6,*)'Longitude axis units =', ax_units(1) 
        !CALL ef_bail_out(id,'Z axis must be in meters')
      ENDIF 

      l1 = arg_lo_ss(T_AXIS,ARG1) 
      l2 = arg_lo_ss(T_AXIS,ARG2) 
      DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         ilat = 2  
         j1 = arg_lo_ss(Y_AXIS,ARG1) + 1
         j2 = arg_lo_ss(Y_AXIS,ARG2) + 1
         DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            iLon = 2
            i1 = arg_lo_ss(X_AXIS,ARG1) + 1
            i2 = arg_lo_ss(X_AXIS,ARG2) + 1
            DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
	       iZ = 1
               k1 = arg_lo_ss(Z_AXIS,ARG1)
               k2 = arg_lo_ss(Z_AXIS,ARG2)
               DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
                  IF (arg_1(i1,  j1,  k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1+1,j1,  k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1-1,j1,  k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1,  j1+1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1+1,j1+1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1-1,j1+1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1,  j1-1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1+1,j1-1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1-1,j1-1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_2(i2,  j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2,  j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2,  j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2-1,k2,l2) .EQ. bad_flag(ARG2)) THEN
                     result(i,j,k,l) = bad_flag_result
                  ELSE
                     IF (iZ .EQ. 1) THEN
  		         result(i,j,k,l) = ( 
     .                        adv_fb(i1,j1,k1,l1,
     .                               i2,j2,k2,l2, iLat,iLon) 
     .                             / 2.
     .                   - arg_1(i1,j1,k1,l1) *
     .                     adv_vbu(i2,j2,k2,l2,iLat,iLon)
     .                        ) / (zW(iZ)*Meters_to_cm)
     .                            * sec_per_month
	               ELSE
			 result(i,j,k,l) = (
     .                     - ( adv_fb(i1,j1,k1-1,l1,
     .                                i2,j2,k2-1,l2,iLat,iLon)
     .                       - adv_fb(i1,j1,k1,  l1,
     .                                i2,j2,k2,  l2, iLat,iLon))
     .                             / 2. 
     .                   + arg_1(i1,j1,k1,l1) *
     .                     ( adv_vbu(i2,j2,k2-1,l2,iLat,iLon)
     .                      - adv_vbu(i2,j2,k2,l2,iLat,iLon) )
     .                        ) / (zW(iZ-1)-zW(iZ))/Meters_to_cm
     .                          * sec_per_month
                     ENDIF
                  ENDIF
                  iZ = iZ + 1
                  k1 = k1 + arg_incr(Z_AXIS,ARG1)
                  k2 = k2 + arg_incr(Z_AXIS,ARG2)
               ENDDO
               iLon = iLon + 1
               i1 = i1 + arg_incr(X_AXIS,ARG1)
               i2 = i2 + arg_incr(X_AXIS,ARG2)
            ENDDO
            iLat = iLat + 1
            j1 = j1 + arg_incr(Y_AXIS,ARG1)
            j2 = j2 + arg_incr(Y_AXIS,ARG2)
         ENDDO
         l1 = l1 + arg_incr(T_AXIS,ARG1)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
      ENDDO               
      END				

	SUBROUTINE EXTRACT_LINE_SUB( cx, line,
     .		src, slox, shix, sloy, shiy, sloz, shiz, 
     .		slot, shit, sloe, shie, slof, shif )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* extract a single line of data from a memory variable grid.  Determine
* which line to extract from the given context

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  10/16/89 - based on EXTRACT_LINE
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'

* calling argument declarations:
	INTEGER	cx, slox, shix, sloy, shiy, sloz, shiz, 
     .		slot, shit, sloe, shie, slof, shif
	REAL    src( slox:shix,sloy:shiy,sloz:shiz,slot:shit,sloe:shie,slof:shif ),
     .		line(*)

* internal variable declarations:
	INTEGER	i, j, k, l, m, n, iout

* extract the line
	iout = 0
	DO 200 n = cx_lo_s6(cx), cx_hi_s6(cx)
	DO 200 m = cx_lo_s5(cx), cx_hi_s5(cx)
	DO 200 l = cx_lo_s4(cx), cx_hi_s4(cx)
	DO 200 k = cx_lo_s3(cx), cx_hi_s3(cx)
	DO 200 j = cx_lo_s2(cx), cx_hi_s2(cx)
	DO 200 i = cx_lo_s1(cx), cx_hi_s1(cx)

	   iout = iout + 1
	   line( iout ) = src( i,j,k,l,m,n )

 200	CONTINUE

	RETURN
	END

c     
c     efcn_set_work_array_dims.F
c     
c     Jonathan Callahan
c     Sep 22nd 1998
c     

c     
c     This subroutine is called by efcn_compute_ inside EF_ExternalUtil.c. 
c     It sets all of the dimensioning information for the work spaces in 
c     ef_mem_subsc.cmn.
c     

      SUBROUTINE EFCN_SET_WORK_ARRAY_DIMS(iarray, xlo, ylo, zlo, tlo,
     .           elo, flo, xhi, yhi, zhi, thi, ehi, fhi)

      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER iarray, xlo, ylo, zlo, tlo, elo, flo,
     .                xhi, yhi, zhi, thi, ehi, fhi

      IF (iarray .EQ. 1) THEN
         wrk1lox = xlo
         wrk1loy = ylo
         wrk1loz = zlo
         wrk1lot = tlo
         wrk1loe = elo
         wrk1lof = flo

         wrk1hix = xhi
         wrk1hiy = yhi
         wrk1hiz = zhi
         wrk1hit = thi
         wrk1hie = ehi
         wrk1hif = fhi

      ELSE IF (iarray .EQ. 2) THEN
         wrk2lox = xlo
         wrk2loy = ylo
         wrk2loz = zlo
         wrk2lot = tlo
         wrk2loe = elo
         wrk2lof = flo

         wrk2hix = xhi
         wrk2hiy = yhi
         wrk2hiz = zhi
         wrk2hit = thi
         wrk2hie = ehi
         wrk2hif = fhi

      ELSE IF (iarray .EQ. 3) THEN
         wrk3lox = xlo
         wrk3loy = ylo
         wrk3loz = zlo
         wrk3lot = tlo
         wrk3loe = elo
         wrk3lof = flo

         wrk3hix = xhi
         wrk3hiy = yhi
         wrk3hiz = zhi
         wrk3hit = thi
         wrk3hie = ehi
         wrk3hif = fhi

      ELSE IF (iarray .EQ. 4) THEN
         wrk4lox = xlo
         wrk4loy = ylo
         wrk4loz = zlo
         wrk4lot = tlo
         wrk4loe = elo
         wrk4lof = flo

         wrk4hix = xhi
         wrk4hiy = yhi
         wrk4hiz = zhi
         wrk4hit = thi
         wrk4hie = ehi
         wrk4hif = fhi

      ELSE IF (iarray .EQ. 5) THEN
         wrk5lox = xlo
         wrk5loy = ylo
         wrk5loz = zlo
         wrk5lot = tlo
         wrk5loe = elo
         wrk5lof = flo

         wrk5hix = xhi
         wrk5hiy = yhi
         wrk5hiz = zhi
         wrk5hit = thi
         wrk5hie = ehi
         wrk5hif = fhi

      ELSE IF (iarray .EQ. 6) THEN
         wrk6lox = xlo
         wrk6loy = ylo
         wrk6loz = zlo
         wrk6lot = tlo
         wrk6loe = elo
         wrk6lof = flo

         wrk6hix = xhi
         wrk6hiy = yhi
         wrk6hiz = zhi
         wrk6hit = thi
         wrk6hie = ehi
         wrk6hif = fhi

      ELSE IF (iarray .EQ. 7) THEN
         wrk7lox = xlo
         wrk7loy = ylo
         wrk7loz = zlo
         wrk7lot = tlo
         wrk7loe = elo
         wrk7lof = flo

         wrk7hix = xhi
         wrk7hiy = yhi
         wrk7hiz = zhi
         wrk7hit = thi
         wrk7hie = ehi
         wrk7hif = fhi

      ELSE IF (iarray .EQ. 8) THEN
         wrk8lox = xlo
         wrk8loy = ylo
         wrk8loz = zlo
         wrk8lot = tlo
         wrk8loe = elo
         wrk8lof = flo

         wrk8hix = xhi
         wrk8hiy = yhi
         wrk8hiz = zhi
         wrk8hit = thi
         wrk8hie = ehi
         wrk8hif = fhi

      ELSE IF (iarray .EQ. 9) THEN
         wrk9lox = xlo
         wrk9loy = ylo
         wrk9loz = zlo
         wrk9lot = tlo
         wrk9loe = elo
         wrk9lof = flo

         wrk9hix = xhi
         wrk9hiy = yhi
         wrk9hiz = zhi
         wrk9hit = thi
         wrk9hie = ehi
         wrk9hif = fhi

      ELSE IF (iarray .EQ. 10) THEN
         wrk10lox = xlo
         wrk10loy = ylo
         wrk10loz = zlo
         wrk10lot = tlo
         wrk10loe = elo
         wrk10lof = flo

         wrk10hix = xhi
         wrk10hiy = yhi
         wrk10hiz = zhi
         wrk10hit = thi
         wrk10hie = ehi
         wrk10hif = fhi

      ELSE IF (iarray .EQ. 11) THEN
         wrk11lox = xlo
         wrk11loy = ylo
         wrk11loz = zlo
         wrk11lot = tlo
         wrk11loe = elo
         wrk11lof = flo

         wrk11hix = xhi
         wrk11hiy = yhi
         wrk11hiz = zhi
         wrk11hit = thi
         wrk11hie = ehi
         wrk11hif = fhi

      ELSE IF (iarray .EQ. 12) THEN
         wrk12lox = xlo
         wrk12loy = ylo
         wrk12loz = zlo
         wrk12lot = tlo
         wrk12loe = elo
         wrk12lof = flo

         wrk12hix = xhi
         wrk12hiy = yhi
         wrk12hiz = zhi
         wrk12hit = thi
         wrk12hie = ehi
         wrk12hif = fhi

      END IF


      RETURN 
      END

	SUBROUTINE PARSE(LINE,ILEN,ICOM,LAB,N,IST)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)parse.f	1.2    5/26/88
C**
C**
C***********************************************************************
C**
C**		    PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C**	Subprogram called:
C**		CALL PARSE(LINE,ILEN,ICOM,LAB,N)
C**
C**	Parameters:
C**		LINE -- Line to be parsed   (char*2048)
C**		ILEN -- Length of ILEN
C**		ICOM -- Command from LINE   (char*2048)
C**		LAB -- rest of LINE  (char*2048)
C**		N -- Length of LAB
C**		IST -- Start position of LAB
C**
C**	Description:
C**		Remove the command from LINE and places the rest of LINE
C**		in LAB.
C**
C**	History:
C**	    Written: 
C**		22-DEC-85	by Donald W. Denbo
C**	    Modified:
C**
C*
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
C * v552 *acm* 3/03 Longer strings: changes for multi-line labels
C v580 *acm* 8/04 Change use of 256 to buflen+1, 
C                 where buflen is defined in cmndlen.inc
C V693+ *sh* 2/15 Treat surrounding _DQ_ same as double quote characters

        INCLUDE 'cmndlen.inc'

	CHARACTER ICOM*(*),LAB*(*),LINE*(*)
	ICOM=' '
	LAB=' '
C
C	Search for the fist space or comma
C
	N=0
	IST=0
	ISPC=INDEX(LINE,' ')
	IF(ISPC.EQ.0)ISPC=buflen+1
	ICMA=INDEX(LINE,',')
	IF(ICMA.EQ.0)ICMA=buflen+1
	I=MIN0(ISPC,ICMA,buflen+1,ILEN+1)
	ICOM=LINE(:I-1)
	CALL UPPER(ICOM,2048)
100	I=I+1
	IF(I.GT.ILEN)RETURN
	IF(LINE(I:I).EQ.' ')GOTO 100
	IF(LINE(I:I).EQ.'"')THEN
	   I=I+1
	ELSEIF (LINE(I:I).EQ.'_'
     .   .AND. I+3 .LE. ILEN    ) THEN
	   IF (LINE(I:I+3).EQ.'_DQ_') I=I+4
	ENDIF
C
C get the label (argument)
C
	LAB=LINE(I:)
	IST=I
	N=ILEN-I+1
	IF(LAB(N:N).EQ.'"')THEN
	    LAB(N:N)=' '
	    N=N-1
	ELSEIF (LAB(N:N).EQ.'_'
     .	  .AND. N-3 .GE.1      ) THEN
	    IF (LAB(N-3:N).EQ.'_DQ_') THEN
	      LAB(N-3:N) = ' '
	      N=N-4
	    ENDIF
	ENDIF
	RETURN
	END

	SUBROUTINE IS_PSEUDO(  *, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* create a gridded "pseudo-variable" (eg. "X" or "K")

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/2/87
* V200:  6/26/89 - 4-D symmetric version
*	10/16/89 - changed adj. array bounds for MAKE_PSEUDO_VAR call
*	11/30/89 - added diagnostic output
* V312: 5/94 - array "memory" as a calling argument
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
*       *acm* 4/12 Add new MODE FOURDEE to allow E,F,M,N,etc as user-vars
*       *sh*  2/17 pre-check for 99999999 in order to issue nicer error message
* v74   *acm* 3/18 Introduce parameter abstractax_len replacing 99999999
* Vxx *sh* 5/17 DSG support

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'
	include	'xalgebra.cmn'

* calling argument declarations:
	INTEGER	status

* internal variable declarations:
	LOGICAL TM_ITSA_DSG, its_dsg
	INTEGER	CX_DIM_LEN, mr, cx, idim, pvlen, lo, hi

* --- end of introductory code ---
* initialize
	cx = is_cx( isp )

* remove regridding flag 
* for pseudo-vars it just means the grid was explicitly specified - there
* is no regridding)
	cx_unstand_grid( cx ) = .FALSE.

* Get the direction of the pseudo-variable.
	idim = MOD( cx_variable(cx)-1, nferdims ) + 1

* check for DSG
	its_dsg = idim .NE. f_dim .AND. TM_ITSA_DSG(cx_grid(cx))

* pre-check to make sure limits were given
	pvlen = CX_DIM_LEN(idim, cx)
	IF (pvlen .EQ. abstractax_len) GOTO 5100

* reserve and catalog space for the result
	CALL CREATE_TEMP_MEM_VAR( cx, mr, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	is_mr( isp ) = mr

* diagnostic output
	IF (mode_diagnostic) CALL DIAGNOSTIC_OUT('pseudo ',mr,point_to_mr)

* fill the space with the desired data
	IF (its_dsg) THEN
	   lo = 1
	   hi = mr_size(mr)
	ELSE
	   lo = mr_lo_ss(mr,idim)
	   hi = mr_hi_ss(mr,idim)
	ENDIF

	CALL MAKE_PSEUDO_VAR( cx, idim, memry(mr)%ptr, mr, lo, hi)

	RETURN 1

* error exit
 5000	RETURN

 5100	CALL ERRMSG(ferr_limits,status,
     .         "Limits must be provided for pseudo-variable.", *5000)
     .		
	END	

	SUBROUTINE DEPEND_STAT_VAR_SUB ( string,
     .			next,         level,      flag,      dataset,
     .			var_or_start, cat_or_end, parent_uv, uv_item )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* get a string describing the variable that was the source of the dependency tree
* status flag

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V685+  *sh* 11/13 

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xvariables.cmn'
	include 'xdependency_tree.cmn'

* calling argument declarations:
	INTEGER	next         (dependency_max_recs),
     .		level        (dependency_max_recs),
     .		flag         (dependency_max_recs),
     .		dataset      (dependency_max_recs),
     .		var_or_start (dependency_max_recs),
     .		cat_or_end   (dependency_max_recs),
     .		parent_uv    (dependency_max_recs),
     .		uv_item      (dependency_max_recs)
	CHARACTER(*) string

*	next         - forward link connecting starts of trees 
*	level        - the child generation level in the tree
*	flag         - special conditions (see xdependency_tree parameters
*	var_or_start - variable number if known variable
*                      or start character of uvar item if unknown
*	cat_or_end   - category number if known variable
*                      or end   character of uvar item if unknown
*	parent_uv    - uvar number of parent variable (used when unknown var)
*	uv_item      - uvar item number within parent (used when unknown var)


* internal variable declarations:
	INTEGER	row, uvar, istart, iend
	CHARACTER VAR_CODE*128

* initialize
	row    = dependency_status_rec
	uvar   = parent_uv(row)
	istart = var_or_start(row)
	iend   = cat_or_end(row)

* get the string showing the cause of the error
	IF (flag(row) .EQ. df_recursion_error) THEN
	   string = VAR_CODE(iend, istart)    ! (cat, var)
	ELSE
	   string = uvar_text(uvar)(istart:iend)
	ENDIF

	RETURN
	END

        SUBROUTINE CD_RELEASE_DSG_INSTANCE_VARS(dset)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*.
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Release the memory occupied by DSG instance variables

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* v720 4/2017 *sh*
* V74+ 7/18 *acm* Handle case of rowsize variable that we have synthesized 
*                 when there's not one in the file. 


* include files
        include 'netcdf.inc'
        include 'tmap_errors.parm'
        include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
        include 'xbuild_grids.cmn'
        include 'xdset_info.cmn_text'

* argument declarations
        INTEGER  dset

* internal variable declarations
        INTEGER idim, ivar

* if dsg_row_size_var is negative, there is no rowsize varible, but 
* otherwise it's a valid single-feature dataset.

        ivar = dsg_row_size_var(dset)
        IF (ivar .NE. int4_init .AND. ivar.GT. 0) THEN
           IF (dsg_loaded_lm(ivar) .NE. int4_init) CALL TM_FREE_LM_DYNMEM(dsg_loaded_lm(ivar))
           dsg_row_size_var(dset) = int4_init
           dsg_loaded_lm(ivar)    = int4_init
        ENDIF

        DO idim = 1, 4
          ivar = dsg_coord_var(idim,dset)
          IF (ivar .NE. int4_init) THEN
             IF (dsg_loaded_lm(ivar) .NE. int4_init) CALL TM_FREE_LM_DYNMEM(dsg_loaded_lm(ivar))
             dsg_coord_var(idim,dset) = int4_init
             dsg_loaded_lm(ivar)      = int4_init
          ENDIF
        ENDDO

* was a feature-mask set? deallocate that.
	IF (dsg_msk_lm(dset).NE.int4_init .AND. dsg_msk_lm(dset).NE.unspecified_int4) THEN
	   CALL FREE_LINE_DYNMEM( dsg_msk_lm(dset) )
	   CALL TM_DEALLO_DYN_LINE( dsg_msk_lm(dset) )
	   dsg_msk_lm(dset) = int4_init
	ENDIF


* Reset a couple more settings regarding dsg datasets

        dsg_orientation(dset) = int4_init
        dsg_user_direction = int4_init

* always successful completion
        RETURN

        END

	INTEGER FUNCTION DO_AVERAGE(	idim, arg,
     .					com, com_mr, com_cx,
     .					res, res_mr, res_cx,
     .					box	)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* average the component grid into the result grid
* (done by calling a single routine used for both averaging and integrating)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  6/1/89
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V702 *sh* 11/16 mods for trac #2428 - calculation in gathered fragments
*                 pass address of buffer area, where weights are accumulated

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xprog_state.cmn'

* calling argument declarations:
	INTEGER	idim, com_mr, com_cx, res_mr, res_cx
	REAL	arg, com(*), res(*), box(*)

* internal variable declarations:
	INTEGER CGRID_SIZE, size

* diagnostic mode output: " doing --> VAR_NAME[x=lo:hi@TRN:n,D=#]"
	IF ( mode_diagnostic ) 	CALL DIAG_OP
     .				( 'doing', isact_class_trans, res_cx, idim )

* get size of result array to locate buffer area just beyond
	size = CGRID_SIZE(res_cx)

	CALL DO_AVE_INT( isact_average, idim,
     .			 cx_lo_ss(com_cx,idim), cx_hi_ss(com_cx,idim),
     .			 com, com_mr, com_cx,
     .			 res, res_mr, res_cx,
     .			 box, res(size+1) )

	DO_AVERAGE = ferr_ok

	RETURN
	END

	SUBROUTINE SET_GKS_METAFILE

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	J Davison JISAO/PMEL/TMAP
*	3.15.89

*	For GKS plots (pltype = 3 or 4) captures WS type and whether to open a
*	GKS metafile, or not.  Opens GKS if not open, and activates/deactivates
*	metafile WS.

*       *JD* 4.22.91 No need for metafile wstype w new metafile translator
*	*jd* 3.10.92 Mod to handle ATC GKS methods
*	*jd* 10.7.92 Mod to use wstype default (GKS3Dwstype) in DEC
*	*jd* 2.24.93 Mod to add PPLP version numbers in metafile
*	*jd* 8.10.93 Mod to add XGKS options for WS types
*	*jd* 10.26.93 Mod to eliminate version number from xgks
*       *jd* 12.8.93 Mod to put line color rep info into metafile for xgks
*	*sh* 3.4.97 Mod to support metafile-only (no X) output through a
*		cuckoo's egg implantation of meta_wsid in place of wsid
*       *js* 7.25.97 Added 'C' callable save_metafile_name to save string
*               in variable 'meta_file'
*       *acm* 2.08 Added 'C' callable get_metafile_name to retrieve string
*               in variable 'meta_file' and return it.
* v552 *acm* 3/03 Longer strings.
* V608 *acm*10/07  true batch mode for metafiles; flag meta_batch
*         distinguises this case from other batch modes.
* V610  *acm* 3/08 Fixes for metafile batch mode
* V68   *acm* 4/11 change how flag meta_batch is computed (different Makefile)
* V6.8 *acm* 7/9/2012 For batch graphics on RHEL6, change ITS_BATCH_GRAPHICS
*                     from logical to integer, then batch = ITS_BATCH_GRAPHICS().NE.0

	include 'pltcom_dat.decl'
	include 'PLTCOM.DAT'
	include 'cmrdl_inc.decl'
	include 'CMRDL.INC'
	include 'gkscm1_inc.decl'
	include 'GKSCM1.INC'
	include 'gkscm2.cmn'
	include 'ws_types.cmn'
	INCLUDE 'parampl5_dat.decl'
	INCLUDE 'PARAMPL5.DAT'
        INCLUDE 'pen_inc.decl'  ! with num_line_colors
        INCLUDE 'PEN.INC'

	integer		beg,end,defws,ndx,type,error
	real		red,green,blue
	character*2048	str
	character*5	kdefws

	INTEGER ITS_META_GRAPHICS, ITS_BATCH_GRAPHICS
        LOGICAL its_meta, batch, meta_batch

#ifdef unix
        logical         xwindows
#else
        integer         trnlnm,xwindows
	character*256	name
	external	trnlnm
#endif

*************************************************************************

*	DETERMINE IF WINDOWING IS X OR NOT
#ifdef unix
        xwindows = .true.
#else
	xwindows = trnlnm ( 'DECW$LOGICAL_NAMES', 'DECW$SYSTEM_DEFAULTS',
     .						 name, namelen )
#endif

* Metafile output only?
        its_meta = ITS_META_GRAPHICS() .NE. 0
        batch = ITS_BATCH_GRAPHICS() .NE. 0
	meta_batch = .FALSE.
        IF (batch) THEN
           IF (its_meta) meta_batch = .TRUE.
        ENDIF

*	MASSAGE COMMAND STRING OF FORM "WS=xxx,META"
	call upnsquish (label,str,end)	 	 	   	

*	OPEN GKS AND WS IF NOT ALREADY OPEN
	if (gksopn) goto 10

*	DEFINE DEFAULT WS TYPE
#ifdef unix
#   ifdef atc_gks
	call getenv ('atcGKSwstype',kdefws)
#   elif xgks
	call getenv ('XGKSwstype',kdefws)
#   else
	call getenv ('GKS3Dwstype',kdefws)
#   endif
# else
*	USE TRNLNM CALL FOR VMS
#endif

#ifdef atc_gks
	if (kdefws .ne. ' ') then
	   read (unit=kdefws,fmt='(i5)') defws
	else
	   defws = ws_xwindow
	endif
#elif xgks
	if (kdefws .ne. ' ') then
	   read (unit=kdefws,fmt='(i5)') defws
	else
	   defws = ws_xwindow
	endif

#else
        defws = 0
#endif

*	EXTRACT WS INFO FROM PLTYPE STRING ARGUMENT
	beg = index (str,'WS')

*	USE DEFAULT IF WS TYPE NOT SPECIFIED BELOW
	if (beg .eq. 0) then
	   wstype = defws

	else
	   if (index (str(beg+3:beg+6),'VSII') .ne. 0) then
	      if (xwindows) then
		 wstype = ws_xwindow
	      else 
		 wstype = ws_uis
	      end if
	   else if (index (str(beg+3:beg+9),'TEK4014') .ne. 0) then
	      wstype = ws_tek4014
	   else if (index (str(beg+3:beg+9),'TEK4107') .ne. 0) then
	      wstype = ws_tek4107
	   end if
	end if
	call open_gks_ws

*	EXTRACT METAFILE CMD FROM PLTYPE STRING ARGUMENT
10	beg = index (str,'META')

	if (beg .ne. 0) then
*	   METAFILE SHOULD BE OPEN AND ACTIVE

	   if (.not. meta_open) call open_metafile
	   if (.not. meta_open) return

	   if (.not.meta_actv) then
	      if (.not. meta_clsplt) then 
		 call gacwk (meta_wsid)
#ifndef xgks
		 call meta_version
#endif
#ifdef xgks
*               ALLOW NO WHITE LINES IN METAFILE (FOR NOW)
                call gqcr (wsid,1,type,error,red,green,blue)
                if (error .eq. 0) then
                   if (red   .eq. 1.0 .and.
     .                 green .eq. 1.0 .and.
     .                 blue  .eq. 1.0) then
                      call gscr (meta_wsid,1,0.0,0.0,0.0)
                    else
                      call gscr (meta_wsid,1,red,green,blue)
                    endif
                else
                   call gscr (meta_wsid,1,0.0,0.0,0.0)
                endif

		do ndx = 2,num_line_colors
		   call gqcr (wsid,ndx,type,error,red,green,blue)	
		   if (batch .or. error .eq. 0) then
		      call gscr (meta_wsid,ndx,red,green,blue)
		   else
		      call gscr (meta_wsid,ndx,0.0,0.0,0.0)
		   endif
		end do
#endif
	      endif
! 3/97: although the metafile is in fact opened we are going to make it
! look like the output workstation to all other software layers
c	      IF ( batch .AND. (.NOT.meta_batch)) THEN
	      IF ( batch) THEN
	         meta_actv = .false.
	         meta_open = .false.
	      ELSE
	         meta_actv = .true.
	      ENDIF
	   end if
	else
*	   IF NO "META" IN PLTYPE CMD DEACTIVATE METAFILE FOR NOW IF ACTIVE
	   if (meta_actv) then
	      if (.not. meta_clsplt) call gdawk (meta_wsid)
	      meta_actv = .false.
	   end if
	end if

	return
	end


	subroutine save_metafile_name(mname, clen, bat_mode)
	implicit none
	include 'gkscm2.cmn'
	
	include         'plt_inc.decl'
        include         'PLT.INC'

	integer clen, bat_mode

#ifdef sun
	byte mname(clen) 
#else   
	integer*1 mname(clen)
#endif  
	call tm_ctof_strng(mname, meta_file, clen)

	batmode = bat_mode
	return
	end
	

	subroutine get_metafile_name(filename)
	implicit none
	include 'gkscm2.cmn'
        character*(*) filename

	filename = meta_file
	return
	end
	

* 
*  closest_in_zlist.F
* 
*  Steve Hankin
*  12/27/2000
* 
*  Compress argument 1 along axis I by the mask given in argument 2
*  Argument 2 may be multidimensional
 
*  In this subroutine we provide information about
*  the function.  The user configurable information 
*  consists of the following:
* 
*  descr              Text description of the function
* 
*  num_args           Required number of arguments
* 
*  axis_inheritance   Type of axis for the result
*                        ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                        CUSTOM          - user defined axis
*                        IMPLIED_BY_ARGS - same axis as the incoming argument
*                        NORMAL          - the result is normal to this axis
*                        ABSTRACT        - an axis which only has index values
* 
*  piecemeal_ok       For memory optimization:
*                        axes where calculation may be performed piecemeal
*                        ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE closest_in_zlist_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .          'Find the value in zlist that is closest to target' )

      CALL ef_set_num_args(id, 2)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'target')
      CALL ef_set_arg_desc(id, arg,
     .          'value(s) to look for - Z-increasing sorted')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'zlist')
      CALL ef_set_arg_desc(id, arg,
     .          'set of candidate values - Z-increasing sorted')
      CALL ef_set_axis_influence(id, arg, YES, YES, NO, YES)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END






*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE closest_in_zlist_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V


*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END



* 
*  In this subroutine we compute the result
* 
      SUBROUTINE closest_in_zlist_compute(id, target, zlist, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL target(mem1lox:mem1hix, mem1loy:mem1hiy,
     .	   mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL zlist(mem2lox:mem2hix, mem2loy:mem2hiy,
     .     mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .     memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1
      INTEGER i2, j2, k2, l2, k2lo
      REAL dlo, dhi

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* pre-check that the zlist array has no missing values
      DO 10 l = arg_lo_ss(T_AXIS,ARG2), arg_hi_ss(T_AXIS,ARG2)
      DO 10 k = arg_lo_ss(Z_AXIS,ARG2), arg_hi_ss(Z_AXIS,ARG2)
      DO 10 j = arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS,ARG2)
      DO 10 i = arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS,ARG2)
        IF (zlist(i,j,k,l) .EQ. bad_flag(2)) CALL
     .             EF_BAIL_OUT(id, 'Missing value found in zlist')
 10   CONTINUE

* pre-check that the zlist array is z-sorted
      DO 25 l = arg_lo_ss(T_AXIS,ARG2), arg_hi_ss(T_AXIS,ARG2)
      DO 25 j = arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS,ARG2)
      DO 25 i = arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS,ARG2)
        IF (arg_hi_ss(Z_AXIS,ARG2) .GT.  arg_lo_ss(Z_AXIS,ARG2)) THEN
          DO 20 k = arg_lo_ss(Z_AXIS,ARG2)+1, arg_hi_ss(Z_AXIS,ARG2)
            IF (zlist(i,j,k,l) .LT.zlist(i,j,k-1,l) ) CALL
     .             EF_BAIL_OUT(id, 'Unsorted values in zlist')
 20       CONTINUE
        ENDIF
 25   CONTINUE

* pre-check that the target array is z-sorted
      DO 35 l = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)
      DO 35 j = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)
      DO 35 i = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)
        IF (arg_hi_ss(Z_AXIS,ARG1) .GT.  arg_lo_ss(Z_AXIS,ARG1)) THEN
          DO 32 k = arg_lo_ss(Z_AXIS,ARG1)+1, arg_hi_ss(Z_AXIS,ARG1)
            IF (target(i,j,k,l) .EQ. bad_flag(1)) THEN
               DO 30 k2 = k+1, arg_hi_ss(Z_AXIS,ARG1)
                 IF (target(i,j,k2,l) .NE. bad_flag(1)) CALL EF_BAIL_OUT
     .                 (id, 'Z-unsorted missing values in target array')
 30            CONTINUE
               GOTO 35
            ENDIF
            IF (target(i,j,k,l) .LT.target(i,j,k-1,l) ) CALL
     .             EF_BAIL_OUT(id, 'Z-unsorted values in target array')
 32      CONTINUE
        ENDIF
 35   CONTINUE

* fill in the points as specified by the mask
      l1 = arg_lo_ss(T_AXIS,ARG1)
      l2 = arg_lo_ss(T_AXIS,ARG2)
      DO 400 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

        j1 = arg_lo_ss(Y_AXIS,ARG1)
        j2 = arg_lo_ss(Y_AXIS,ARG2)
        DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

          i1 = arg_lo_ss(X_AXIS,ARG1)
          i2 = arg_lo_ss(X_AXIS,ARG2)
          DO 200 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

            k2lo = arg_lo_ss(Z_AXIS,ARG2)  ! best prospect for zlist < target
            DO 100 k1=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
              IF (target(i1,j1,k1,l1) .EQ. bad_flag(1)) THEN
                 result(i,j,k1,l) = bad_flag_result
                 GOTO 100
              ENDIF
* ... find first value in zlist greater than the target
              DO 50 k2 = k2lo+1, arg_hi_ss(Z_AXIS,ARG2)
                IF (zlist(i2,j2,k2,l2) .GE. target(i1,j1,k1,l1)) THEN
                  dlo = target(i1,j1,k1,l1) - zlist(i2,j2,k2lo,l2)
                  dhi = zlist(i2,j2,k2,l2)  - target(i1,j1,k1,l1)
                  IF ( ABS(dlo) .LE. ABS(dhi) ) THEN
                     result(i,j,k1,l) = zlist(i2,j2,k2lo,l2)
                  ELSE
                     result(i,j,k1,l) = zlist(i2,j2,k2,l2)
                  ENDIF
                  GOTO 100
                ELSE
                  k2lo = k2
                ENDIF
 50           CONTINUE

              result(i,j,k1,l) = zlist(i2,j2,k2lo,l2) ! top value in zlist
 100        CONTINUE

            i1 = i1 + arg_incr(X_AXIS,ARG1)
            i2 = i2 + arg_incr(X_AXIS,ARG2)
 200      CONTINUE

          j1 = j1 + arg_incr(Y_AXIS,ARG1)
          j2 = j2 + arg_incr(Y_AXIS,ARG2)
 300    CONTINUE

        l1 = l1 + arg_incr(T_AXIS,ARG1)
        l2 = l2 + arg_incr(T_AXIS,ARG2)
 400  CONTINUE
      
         
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	CHARACTER*(*) FUNCTION AUX_VAR_UNITS( cx, idim )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* return units text string for an auxiliary variable

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V698+ *sh* 5/15 - derived from var_units.F
* V698  3/16 *acm* Removed Philander-Seigel code including diagnostic 
*                  variables, pre-defined axes and grids, cat_calc_var.
* V698  3/16 *sh* added logic for cat_ef_time2d  (ACTS_LIKE_FVAR)

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include	'xdset_info.cmn_text'
	external xdset_info_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xtext_info.cmn'
	include	'xcontext.cmn'
	include	'xvariables.cmn'

* calling argument declarations
	INTEGER	cx, idim

* internal variable declarations
	LOGICAL UNIT_CHG_AX, ACTS_LIKE_FVAR
	INTEGER	category, variable, status

* initialize
	category = cx_aux_cat( idim, cx )
	variable = cx_aux_var( idim, cx )

	IF (variable .EQ. unspecified_int4) THEN
	   AUX_VAR_UNITS = 'bad units'
	   CALL ERRMSG( ferr_internal, status, 'aux var cx err', *5000 )
	ENDIF

* select units by category of variable
	IF     ( ACTS_LIKE_FVAR(category) ) THEN

	   AUX_VAR_UNITS = ds_var_units( variable )

	ELSEIF ( category .EQ. cat_user_var ) THEN

	   AUX_VAR_UNITS = uvar_units( variable )

	ELSEIF ( category .EQ. cat_pseudo_var 
     .	   .OR.  category .EQ. cat_constant
     .	   .OR.  category .EQ. cat_string
     .	   .OR.  category .EQ. cat_const_var
     .	   .OR.  category .EQ. cat_counter_var
     .	   .OR.  category .EQ. cat_attrib_val ) THEN

	   AUX_VAR_UNITS = ' '

	ELSE

	   AUX_VAR_UNITS = 'unit_err'

	ENDIF

 5000	RETURN
	END

	SUBROUTINE SHOW_MEM_USAGE_LINE ( prefix, mem, do_words)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* display a single line about memory usage with nice formatting

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V702  1/17 
* V751 *acm* 6/19 Issue 1903: memory set and reported in terms of bytes
*             First line may also show the total in words - if do_words flag.

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xprog_state.cmn'
	include 'xrisc.cmn'

* calling argument declarations:
	LOGICAL do_words
	INTEGER*8 mem
	CHARACTER*(*)	prefix

* internal variable declarations:
	INTEGER TM_LENSTR1, wlen, blen, i1, prelen
	CHARACTER TM_FMT*48,
     .		  word_unit*16, word_str*12,
     .		  byte_unit*3, byte_str*12

        IF (mem .GT. 1000000) THEN
           word_str = TM_FMT( mem/1.E6, 8, 12, wlen)
           word_unit = ' megawords'
           i1 = 10
        ELSE 
           word_str = TM_FMT( FLOAT(mem), 8, 12, wlen)
           word_unit = ' words'
           i1 = 6
        ENDIF


	IF (mem .EQ. 0) byte_unit = ' '
	CALL MEM_TO_BYTES (mem, byte_str, blen, byte_unit)

	prelen = TM_LENSTR1(prefix)
	
        IF (do_words) THEN
	   risc_buff = '    '//prefix(:prelen)//': '//
     .		    byte_str(:blen)//' '//byte_unit//'  ('//
     .		    word_str(:wlen)//word_unit(:i1)//')'
        ELSE
	   risc_buff = '    '//prefix(:prelen)//': '//
     .		    byte_str(:blen)//' '//byte_unit
	ENDIF

	CALL SPLIT_LIST(pttmode_explct, show_lun, risc_buff, 0)

	RETURN
	END

	LOGICAL FUNCTION MATCH4 (test_string,len_test,model_string,len_model)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* check to see if test string is same as model string for as many characters
* as it is given (to a max of 4)
* model string must be all upper case - test string ignores case
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/24/86
*
* V5.80 *acm* 7/6/04 If either string is a single blank character, then
*                    len_to_test = 0 and MATCH4 was set true for all values 
*                    of the other string.  Check for lengths of zero.
* V6.96 *acm* 11/18/15 Declare model_string as *(*) to fix run-time error Ubuntu: Fortran runtime error: 
*                     Actual string length is shorter than the declared one for dummy argument 'model_string' (2/4)


	INTEGER		TM_LENSTR, len_model, len_test, len_to_test, i

	CHARACTER*1	UPPER_CASE
	CHARACTER*(*)	model_string
	CHARACTER*(*)	test_string
        LOGICAL         result

*	len_model = TM_LENSTR( model_string )
*	len_test  = TM_LENSTR( test_string(1:LEN(test_string)) )

* if model string is fewer than 4 characters the test string must not be longer
	IF (      len_model .LT. 4
     .	    .AND. len_test  .GT. len_model ) GOTO 200

        IF (len_test .EQ. 0 .AND. len_model .NE. 0) GOTO 200 
        IF (len_test .NE. 0 .AND. len_model .EQ. 0) GOTO 200 

	len_to_test = MIN( len_test, len_model )

*	DO 100 i = 1,len_to_test
*	IF ( model_string(i:i) .NE. UPPER_CASE( test_string(i:i) ) ) GOTO 200
* 100	CONTINUE
        CALL tm_match_captial_name(test_string, model_string, 
     .          len_to_test, result)

        IF(.NOT.result) GOTO 200
* it matches
	MATCH4 = .TRUE.
	RETURN

* it doesn't match
 200	MATCH4 = .FALSE.
	RETURN

	END

*
* curv_range.F
*
* Ansley Manke
* March 2005
*
* This function finds the indices of the bounding box for taking 
* a subset of a variable defined on a curvilinear grid.
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE curv_range_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      CHARACTER*120 descr

      WRITE (descr, 100)
      CALL ef_set_desc(id, descr )

  100 FORMAT (
     . 'find i,j bounds for subset of a variable in curvilinear ',
     . 'coordinates' )

      CALL ef_set_num_args(id, 7)
      CALL ef_set_axis_inheritance_6d(id,
     .                                ABSTRACT, NORMAL,
     .                                NORMAL,   NORMAL,
     .                                NORMAL,   NORMAL)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'LONGITUDES')
      CALL ef_set_arg_desc(id, arg, 
     .             '2-D longitudes of curvilinear grid')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'LATITUDES')
      CALL ef_set_arg_desc(id, arg, 
     .             '2-D latitudes of curvilinear grid')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'xrange_lo')
      CALL ef_set_arg_desc(id, arg, 'Minimum of longitude range')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'xrange_hi')
      CALL ef_set_arg_desc(id, arg, 'Maximum of longitude range')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'yrange_lo')
      CALL ef_set_arg_desc(id, arg, 'Minimum of latitude range')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 6
      CALL ef_set_arg_name(id, arg, 'yrange_hi')
      CALL ef_set_arg_desc(id, arg, 'Maximum of latitude range')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 7
      CALL ef_set_arg_name(id, arg, 'modulo flag for X coordinates')
      CALL ef_set_arg_desc(id, arg, '1= X modulo; 0= X not modulo')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


      SUBROUTINE curv_range_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_axis_limits(id, X_AXIS, 1, 4)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE curv_range_compute(id, arg_1, arg_2, 
     .           arg_3, arg_4, arg_5, arg_6, arg_7, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz, 
     .           mem4lot:mem4hit, mem4loe:mem4hie, mem4lof:mem4hif)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz, 
     .           mem5lot:mem5hit, mem5loe:mem5hie, mem5lof:mem5hif)
      REAL arg_6(mem6lox:mem6hix, mem6loy:mem6hiy, mem6loz:mem6hiz, 
     .           mem6lot:mem6hit, mem6loe:mem6hie, mem6lof:mem6hif)
      REAL arg_7(mem7lox:mem7hix, mem7loy:mem7hiy, mem7loz:mem7hiz, 
     .           mem7lot:mem7hit, mem7loe:mem7hie, mem7lof:mem7hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER arg, i, j, k, l, m, n
      INTEGER ilo, ihi, jlo, jhi, nrep, irep
      REAL small, xrange_lo, xrange_hi, yrange_lo, yrange_hi, xx, xxp, 
     .     yy, yyp, big, xadd, xmin, xmax, xmin_field, xmax_field, 
     .     ymin_field, ymax_field, xmod, xdiff_lo, xdiff_hi, ydiff_lo, 
     .     ydiff_hi
      LOGICAL xmodulo, found_range
      CHARACTER*100 errmsg

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      arg = 3
      CALL ef_get_one_val(id, arg, xrange_lo)
      arg = 4
      CALL ef_get_one_val(id, arg, xrange_hi)
      arg = 5
      CALL ef_get_one_val(id, arg, yrange_lo)
      arg = 6
      CALL ef_get_one_val(id, arg, yrange_hi)
      arg = 7
      CALL ef_get_one_val(id, arg, xmod)
      xmodulo = (xmod .GT. 0.)

c curv_range_test
c* Set the values to some particular ones, to see if this is the function being executed.
c
c      j = res_lo_ss(Y_AXIS)
c      k = res_lo_ss(Z_AXIS)
c      l = res_lo_ss(T_AXIS)
c
c      result(1,j,k,l) = 11
c      result(2,j,k,l) = 22
c      result(3,j,k,l) = 33
c      result(4,j,k,l) = 44
c      RETURN

* See if the user asked for the whole range of arg_1 and arg_2 


      big = MAX (1.e34, ABS(bad_flag(ARG1)) )
      big = MAX (big, ABS(bad_flag(ARG2)) )
      xmin_field = big
      xmax_field = -1.* big
      ymin_field = big
      ymax_field = -1.* big
      DO 50 n = arg_lo_ss(F_AXIS,ARG1), arg_hi_ss(F_AXIS,ARG1)
      DO 50 m = arg_lo_ss(E_AXIS,ARG1), arg_hi_ss(E_AXIS,ARG1)
      DO 50 l = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)
      DO 50 k = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)
      DO 50 j = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)
      DO 50 i = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)
      
         xmin_field = MIN(xmin_field, arg_1(i,j,k,l,m,n))
         xmax_field = MAX(xmax_field, arg_1(i,j,k,l,m,n))
         ymin_field = MIN(ymin_field, arg_2(i,j,k,l,m,n))
         ymax_field = MAX(ymax_field, arg_2(i,j,k,l,m,n))

 50   CONTINUE

      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      l = res_lo_ss(T_AXIS)
      m = res_lo_ss(E_AXIS)
      n = res_lo_ss(F_AXIS)

! use the range of the data field to decide how much precision 
! to require for **requested range equals the data range**

      small = 0.01* (xmax_field - xmin_field)
      small = MIN(small, 0.01* (ymax_field - ymin_field) )

      IF (small .LE. 0) THEN  ! if x or y range is 0 use the other direction
         small = 0.01* (xmax_field - xmin_field)
         small = MAX(small, 0.01* (ymax_field - ymin_field) )
      ENDIF

      IF (small .LE. 0) small = 1.e-4

      xdiff_lo = ABS(xmin_field - xrange_lo) 
      xdiff_hi = ABS(xmax_field - xrange_hi) 
      ydiff_lo = ABS(ymin_field - yrange_lo) 
      ydiff_hi = ABS(ymax_field - yrange_hi) 

      IF (xdiff_lo .LT. small .AND. ydiff_lo .LT. small  .AND.
     .    xdiff_hi .LT. small .AND. ydiff_hi .LT. small) THEN 
         result(1,j,k,l,m,n) = arg_lo_ss(X_AXIS, ARG1)
         result(2,j,k,l,m,n) = arg_hi_ss(X_AXIS, ARG1)
         result(3,j,k,l,m,n) = arg_lo_ss(Y_AXIS, ARG2)
         result(4,j,k,l,m,n) = arg_hi_ss(Y_AXIS, ARG2)
         RETURN
      ENDIF

* Make sure the requested range at least overlaps the range of 
* longitude coordinates

      IF (xmodulo) THEN
         DO WHILE (xrange_lo .GT. xmax_field)
            xrange_lo = xrange_lo - 360
            xrange_hi = xrange_hi - 360
         ENDDO
         DO WHILE (xrange_hi .LT. xmin_field)
            xrange_lo = xrange_lo + 360
            xrange_hi = xrange_hi + 360
         ENDDO
      ENDIF


      IF (ydiff_lo .LT. small .AND. ydiff_hi .LT. small .AND. 
     .     xmodulo) THEN
         nrep = NINT((xrange_lo-xmin_field)/360.)
         xdiff_lo = ABS(xmin_field+360.*nrep - xrange_lo)
         nrep = NINT((xrange_hi-xmax_field)/360.)
         xdiff_hi = ABS(xmax_field+360.*nrep - xrange_hi)
         IF (xdiff_lo .LT. small .AND. xdiff_hi .LT. small ) THEN
            result(1,j,k,l,m,n) = arg_lo_ss(X_AXIS, ARG1)
            result(2,j,k,l,m,n) = arg_hi_ss(X_AXIS, ARG1)
            result(3,j,k,l,m,n) = arg_lo_ss(Y_AXIS, ARG2)
            result(4,j,k,l,m,n) = arg_hi_ss(Y_AXIS, ARG2)
            RETURN
         ENDIF
      ENDIF

* If the requested range is larger than the data, return whole range

      IF (.NOT. xmodulo) THEN  
         IF (xrange_lo.LT.xmin_field .AND. xrange_hi.GT.xmax_field .AND.
     .       yrange_lo.LT.ymin_field .AND. yrange_hi.GT.ymax_field)THEN
            result(1,j,k,l,m,n) = arg_lo_ss(X_AXIS, ARG1)
            result(2,j,k,l,m,n) = arg_hi_ss(X_AXIS, ARG1)
            result(3,j,k,l,m,n) = arg_lo_ss(Y_AXIS, ARG2)
            result(4,j,k,l,m,n) = arg_hi_ss(Y_AXIS, ARG2)
            RETURN
         ENDIF
      ELSE

* If x is to be treated as modulo, use the code below to determine the indices, but
* if the Y range is larger than the data, use the data min and/or max for y range.
         IF (yrange_lo .LT. ymin_field) yrange_lo = ymin_field
         IF (yrange_hi .GT. ymax_field) yrange_hi = ymax_field
      ENDIF



* Find range of I,J for which arg_1 is in xrange_lo, xrange_hi
* and arg_2 is in yrange_lo, yrange_hi

      ilo = arg_hi_ss(X_AXIS, ARG1)
      ihi = arg_lo_ss(X_AXIS, ARG1)
      jlo = arg_hi_ss(Y_AXIS, ARG2)
      jhi = arg_lo_ss(y_AXIS, ARG2)

      big = ABS(bad_flag(ARG1) )
      xmin = big
      xmax = -1.* big
      found_range = .FALSE.

      DO 100 n = arg_lo_ss(F_AXIS,ARG1), arg_hi_ss(F_AXIS,ARG1)
      DO 100 m = arg_lo_ss(E_AXIS,ARG1), arg_hi_ss(E_AXIS,ARG1)
      DO 100 l = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)
      DO 100 k = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)
      DO 100 j = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)
      DO 100 i = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)

         xx = arg_1(i,j,k,l,m,n)
         yy = arg_2(i,j,k,l,m,n)
         IF ( xx .EQ. bad_flag(1) ) GOTO 5500
         IF ( yy .EQ. bad_flag(2) ) GOTO 5500

         IF ( xx .GE. xrange_lo  .AND. xx .LE. xrange_hi .AND.
     .        yy .GE. yrange_lo  .AND. yy .LE. yrange_hi ) THEN
            found_range = .TRUE.
            ilo = MIN(i,ilo)
            ihi = MAX(i,ihi)
            jlo = MIN(j,jlo)
            jhi = MAX(j,jhi)
            xmin = MIN(xmin, xx)
            xmax = MAX(xmin, xx)
         ENDIF

 100  CONTINUE

* If no range found, is the range strictly between two adjacent points
* in either direction?

      IF (.NOT. found_range .AND. 
     .    xrange_lo.GE.xmin_field .AND. xrange_hi.LE.xmax_field .AND.
     .    yrange_lo.GE.ymin_field .AND. yrange_hi.LE.ymax_field ) THEN
     
         ilo = arg_hi_ss(X_AXIS, ARG1)
         ihi = arg_lo_ss(X_AXIS, ARG1)
         jlo = arg_hi_ss(Y_AXIS, ARG2)
         jhi = arg_lo_ss(y_AXIS, ARG2)

         DO 200 n = arg_lo_ss(F_AXIS,ARG1), arg_hi_ss(F_AXIS,ARG1)
         DO 200 m = arg_lo_ss(E_AXIS,ARG1), arg_hi_ss(E_AXIS,ARG1)
         DO 200 l = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)
         DO 200 k = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)
         DO 200 j = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)-1
         DO 200 i = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)-1

            xx = arg_1(i,j,k,l,m,n)
            xxp = arg_1(i+1,j,k,l,m,n)
            yy = arg_2(i,j,k,l,m,n)
            yyp = arg_2(i,j+1,k,l,m,n)

            IF ( xx .GE. xrange_lo  .AND. xx .LE. xrange_hi .AND.
     .           yrange_lo .GE. yy .AND. yrange_hi .LT. yyp) THEN
               found_range = .TRUE.
               ilo = min(i, ilo)
               ihi = MAX(i, ihi)
               jlo = min(j, jlo)
               jhi = MAX(j+1, jhi)
            ENDIF

            IF ( yy .GE. yrange_lo  .AND. yy .LE. yrange_hi .AND.
     .           xrange_lo .GE. xx .AND. xrange_hi .LT. xxp) THEN
               found_range = .TRUE.
               ilo = min(i, ilo)
               ihi = MAX(i+1, ihi)
               jlo = min(j, jlo)
               jhi = MAX(j, jhi)
            ENDIF

            IF ( xrange_lo .GE. xx .AND. xrange_hi .LT. xxp .AND.
     .           yrange_lo .GE. yy .AND. yrange_hi .LT. yyp) THEN
               found_range = .TRUE.
               ilo = min(i, ilo)
               ihi = MAX(i+1, ihi)
               jlo = min(j, jlo)
               jhi = MAX(j+1, jhi)
            ENDIF

 200     CONTINUE
      ENDIF

      IF (xmodulo) THEN
         IF (xmin .EQ. big) xmin = xmin_field
         IF (xmax .EQ. -1.*big) xmax = xmax_field
 
* Does the range found cover the requested xrange_lo,xrange_hi range?
* If not we will need some modulo repetitions.

         IF (xmin .GT. xrange_lo) THEN
            nrep = NINT((xmin-xrange_lo)/360)
            xadd = 0.
            DO 380 irep = 1, nrep
               xadd = xadd - 360.

* Previous loop found no overlap of x coordinates and desired output range.
* start over with xmax, xmin find whole range

               IF (xmin .GT. xrange_hi) THEN
                  xmin =  big 
                  xmax = -1. * big   
               ENDIF
     
               ilo = arg_hi_ss(X_AXIS, ARG1)
               ihi = arg_lo_ss(X_AXIS, ARG1)
               jlo = arg_hi_ss(Y_AXIS, ARG2)
               jhi = arg_lo_ss(y_AXIS, ARG2)

               DO 320 n = arg_lo_ss(F_AXIS,ARG1), arg_hi_ss(F_AXIS,ARG1)
               DO 320 m = arg_lo_ss(E_AXIS,ARG1), arg_hi_ss(E_AXIS,ARG1)
               DO 320 l = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)
               DO 320 k = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)
               DO 320 j = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)
               DO 320 i = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)

                  xx = arg_1(i,j,k,l,m,n) + xadd
                  yy = arg_2(i,j,k,l,m,n)

                  IF ( xx .GE. xrange_lo .AND. xx .LE. xrange_hi .AND.
     .                 yy .GE. yrange_lo .AND. yy .GE. yrange_hi ) THEN
                     found_range = .TRUE.
                     ilo = MIN(i,ilo)
                     ihi = MAX(i,ihi) 
                     jlo = MIN(j,jlo)
                     jhi = MAX(j,jhi) 
                     xmin = MIN(xmin, xx)
                     xmax = MAX(xmin, xx)
                  ENDIF

 320           CONTINUE

               IF (.NOT. found_range) THEN
               
                  ilo = arg_hi_ss(X_AXIS, ARG1)
                  ihi = arg_lo_ss(X_AXIS, ARG1)
                  jlo = arg_hi_ss(Y_AXIS, ARG2)
                  jhi = arg_lo_ss(y_AXIS, ARG2)

                  DO 340 n = arg_lo_ss(F_AXIS,ARG1), 
     .                       arg_hi_ss(F_AXIS,ARG1)
                  DO 340 m = arg_lo_ss(E_AXIS,ARG1), 
     .                       arg_hi_ss(E_AXIS,ARG1)
                  DO 340 l = arg_lo_ss(T_AXIS,ARG1), 
     .                       arg_hi_ss(T_AXIS,ARG1)
                  DO 340 k = arg_lo_ss(Z_AXIS,ARG1), 
     .                       arg_hi_ss(Z_AXIS,ARG1)
                  DO 340 j = arg_lo_ss(Y_AXIS,ARG1), 
     .                       arg_hi_ss(Y_AXIS,ARG1)
                  DO 340 i = arg_lo_ss(X_AXIS,ARG1), 
     .                       arg_hi_ss(X_AXIS,ARG1)-1

                     xx = arg_1(i,j,k,l,m,n) + xadd
                     xxp = arg_1(i+1,j,k,l,m,n) + xadd
                     yy = arg_2(i,j,k,l,m,n)

                     IF ( xrange_lo .GE. xx  .AND.
     .                    xrange_hi .LT. xxp .AND.
     .                    yy .GE. yrange_lo  .AND.
     .                    yy .GE. yrange_hi ) THEN
                        found_range = .TRUE.
                        ilo = MIN(i,ilo)
                        ihi = MAX(i+1,ihi) 
                        jlo = MIN(j,jlo)
                        jhi = MAX(j,jhi) 
                        xmin = MIN(xmin, xx)
                        xmax = MAX(xmin, xxp)
                     ENDIF

 340              CONTINUE
               ENDIF

               IF (xmin .EQ. big) xmin = xmin_field + xadd
               IF (xmax .EQ. -1.*big) xmax = xmax_field + xadd

 380        CONTINUE

* If no range found, is the range strictly between two adjacent points
* in either direction?

            IF (.NOT. found_range .AND. 
     .          xrange_lo .GE. xmin_field .AND.
     .          xrange_hi .LE. xmax_field .AND.
     .          yrange_lo .GE. ymin_field .AND.
     .          yrange_hi .LE. ymax_field ) THEN
                       
               ilo = arg_hi_ss(X_AXIS, ARG1)
               ihi = arg_lo_ss(X_AXIS, ARG1)
               jlo = arg_hi_ss(Y_AXIS, ARG2)
               jhi = arg_lo_ss(y_AXIS, ARG2)

               DO 400 n=arg_lo_ss(F_AXIS,ARG1),arg_hi_ss(F_AXIS,ARG1)
               DO 400 m=arg_lo_ss(E_AXIS,ARG1),arg_hi_ss(E_AXIS,ARG1)
               DO 400 l=arg_lo_ss(T_AXIS,ARG1),arg_hi_ss(T_AXIS,ARG1)
               DO 400 k=arg_lo_ss(Z_AXIS,ARG1),arg_hi_ss(Z_AXIS,ARG1)
               DO 400 j=arg_lo_ss(Y_AXIS,ARG1),arg_hi_ss(Y_AXIS,ARG1)-1
               DO 400 i=arg_lo_ss(X_AXIS,ARG1),arg_hi_ss(X_AXIS,ARG1)-1

                  xx = arg_1(i,j,k,l,m,n)+xadd
                  xxp = arg_1(i+1,j,k,l,m,n)+xadd
                  yy = arg_2(i,j,k,l,m,n)
                  yyp = arg_2(i,j+1,k,l,m,n)
      
                  IF ( xx .GE. xrange_lo  .AND. xx .LE. xrange_hi .AND.
     .              yrange_lo .GE. yy .AND. yrange_hi .LT. yyp) THEN
                     found_range = .TRUE.
                     ilo = min(i, ilo)
                     ihi = MAX(i, ihi)
                     jlo = min(j, jlo)
                     jhi = MAX(j+1, jhi)
                  ENDIF

                  IF ( yy .GE. yrange_lo  .AND. yy .LE. yrange_hi .AND.
     .                 xrange_lo .GE. xx .AND. xrange_hi .LT. xxp) THEN
                     found_range = .TRUE.
                     ilo = min(i, ilo)
                     ihi = MAX(i+1, ihi)
                     jlo = min(j, jlo)
                     jhi = MAX(j, jhi)
                  ENDIF

                  IF ( xrange_lo .GE. xx .AND. xrange_hi .LT. xxp .AND.
     .                 yrange_lo .GE. yy .AND. yrange_hi .LT. yyp) THEN
                     found_range = .TRUE.
                     ilo = min(i, ilo)
                     ihi = MAX(i+1, ihi)
                     ilo = min(i, ilo)
                     ihi = MAX(i+1, ihi)
                  ENDIF

 400           CONTINUE
            ENDIF

         ENDIF
   
         IF (xmax .LT. xrange_hi) THEN
            nrep = NINT((xrange_hi-xmax)/360.)
            xadd = 0.
               DO 580 irep = 1, nrep
               xadd = xadd + 360.

* Previous loop found no overlap of x coordinates and desired output range.
* start over with xmax, xmin find whole range

               IF (xmax .LT. xrange_lo) THEN
                  xmin =  big 
                  xmax = -1. * big   
               ENDIF

               ilo = arg_hi_ss(X_AXIS, ARG1)
               ihi = arg_lo_ss(X_AXIS, ARG1)
               jlo = arg_hi_ss(Y_AXIS, ARG2)
               jhi = arg_lo_ss(y_AXIS, ARG2)

               DO 520 n = arg_lo_ss(F_AXIS,ARG1), arg_hi_ss(F_AXIS,ARG1)
               DO 520 m = arg_lo_ss(E_AXIS,ARG1), arg_hi_ss(E_AXIS,ARG1)
               DO 520 l = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)
               DO 520 k = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)
               DO 520 j = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)
               DO 520 i = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)

                  xx = arg_1(i,j,k,l,m,n) + xadd
                  yy = arg_2(i,j,k,l,m,n)

                  IF ( xx .GE. xrange_lo .AND. xx .LE. xrange_hi .AND.
     .                 yy .GE. yrange_lo .AND. yy .GE. yrange_hi ) THEN
                     found_range = .TRUE.
                     ilo = MIN(i,ilo)
                     ihi = MAX(i,ihi) 
                     jlo = MIN(j,jlo)
                     jhi = MAX(j,jhi) 
                     xmin = MIN(xmin, xx)
                     xmax = MAX(xmin, xx)
                  ENDIF

 520           CONTINUE
 
               IF (.NOT. found_range) THEN
               
                  ilo = arg_hi_ss(X_AXIS, ARG1)
                  ihi = arg_lo_ss(X_AXIS, ARG1)
                  jlo = arg_hi_ss(Y_AXIS, ARG2)
                  jhi = arg_lo_ss(y_AXIS, ARG2)

                  DO 540 n = arg_lo_ss(F_AXIS,ARG1), 
     .                       arg_hi_ss(F_AXIS,ARG1)
                  DO 540 m = arg_lo_ss(E_AXIS,ARG1), 
     .                       arg_hi_ss(E_AXIS,ARG1)
                  DO 540 l = arg_lo_ss(T_AXIS,ARG1), 
     .                       arg_hi_ss(T_AXIS,ARG1)
                  DO 540 k = arg_lo_ss(Z_AXIS,ARG1), 
     .                       arg_hi_ss(Z_AXIS,ARG1)
                  DO 540 j = arg_lo_ss(Y_AXIS,ARG1), 
     .                       arg_hi_ss(Y_AXIS,ARG1)
                  DO 540 i = arg_lo_ss(X_AXIS,ARG1), 
     .                       arg_hi_ss(X_AXIS,ARG1)-1

                     xx = arg_1(i,j,k,l,m,n) + xadd
                     xxp = arg_1(i+1,j,k,l,m,n) + xadd
                     yy = arg_2(i,j,k,l,m,n)
                     yyp = arg_2(i,j+1,k,l,m,n)

                     IF ( xrange_lo.GE.xx .AND. xrange_hi.LT.xxp.AND.
     .                    yrange_lo.GE.yy .AND. yrange_hi.LT.yyp ) THEN
                        found_range = .TRUE.
                        ilo = MIN(i,ilo)
                        ihi = MAX(i+1,ihi) 
                        jlo = MIN(j,jlo)
                        jhi = MAX(j,jhi) 
                        xmin = MIN(xmin, xx)
                        xmax = MAX(xmin, xxp)
                     ENDIF

 540              CONTINUE
               ENDIF
 
               IF (xmin .EQ. big) xmin = xmin_field + xadd
               IF (xmax .EQ. -1.*big) xmax = xmax_field + xadd

 580        CONTINUE


* If no range found, is the range strictly between two adjacent points
* in either direction?

            IF (.NOT. found_range .AND.
     .          xrange_lo .GE. xmin_field .AND.
     .          xrange_hi .LE. xmax_field .AND.
     .          yrange_lo .GE. ymin_field .AND. 
     .          yrange_hi .LE. ymax_field ) THEN
     
               ilo = arg_hi_ss(X_AXIS, ARG1)
               ihi = arg_lo_ss(X_AXIS, ARG1)
               jlo = arg_hi_ss(Y_AXIS, ARG2)
               jhi = arg_lo_ss(y_AXIS, ARG2)

               DO 600 n =arg_lo_ss(F_AXIS,ARG1),arg_hi_ss(F_AXIS,ARG1)
               DO 600 m =arg_lo_ss(E_AXIS,ARG1),arg_hi_ss(E_AXIS,ARG1)
               DO 600 l =arg_lo_ss(T_AXIS,ARG1),arg_hi_ss(T_AXIS,ARG1)
               DO 600 k =arg_lo_ss(Z_AXIS,ARG1),arg_hi_ss(Z_AXIS,ARG1)
               DO 600 j =arg_lo_ss(Y_AXIS,ARG1),arg_hi_ss(Y_AXIS,ARG1)-1
               DO 600 i =arg_lo_ss(X_AXIS,ARG1),arg_hi_ss(X_AXIS,ARG1)-1

                  xx = arg_1(i,j,k,l,m,n)+xadd
                  xxp = arg_1(i+1,j,k,l,m,n)+xadd
                  yy = arg_2(i,j,k,l,m,n)
                  yyp = arg_2(i,j+1,k,l,m,n)
      
                  IF ( xx .GE. xrange_lo  .AND. xx .LE. xrange_hi .AND.
     .              yrange_lo .GE. yy .AND. yrange_hi .LT. yyp) THEN
                     found_range = .TRUE.
                     ilo = min(i, ilo)
                     ihi = MAX(i, ihi)
                     jlo = min(j, jlo)
                     jhi = MAX(j+1, jhi)
                  ENDIF

                  IF ( yy .GE. yrange_lo  .AND. yy .LE. yrange_hi .AND.
     .                 xrange_lo .GE. xx .AND. xrange_hi .LT. xxp) THEN
                     found_range = .TRUE.
                     ilo = min(i, ilo)
                     ihi = MAX(i+1, ihi)
                     jlo = min(j, jlo)
                     jhi = MAX(j, jhi)
                  ENDIF

                  IF ( xrange_lo .GE. xx .AND. xrange_hi .LT. xxp .AND.
     .                 yrange_lo .GE. yy .AND. yrange_hi .LT. yyp) THEN
                     found_range = .TRUE.
                     ilo = min(i, ilo)
                     ihi = MAX(i+1, ihi)
                     ilo = min(i, ilo)
                     ihi = MAX(i+1, ihi)
                  ENDIF

 600           CONTINUE
            ENDIF


         ENDIF

      ENDIF  ! xmodulo


* Return two cells out from the computed result, one to be sure we cover
* the entire requested range (the coords may be cell centers or bounds, and
* a second because the mapping in curv_to_rect uses neighbors around each
* location to compute the result.

      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      l = res_lo_ss(T_AXIS)
      m = res_lo_ss(E_AXIS)
      n = res_lo_ss(F_AXIS)

      DO 700 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
         result(i,j,k,l,m,n) = bad_flag_result
 700  CONTINUE

      IF (found_range) THEN
         result(1,j,k,l,m,n) = MAX(ilo-2, arg_lo_ss(X_AXIS, ARG1) )
         result(2,j,k,l,m,n) = MIN(ihi+2, arg_hi_ss(X_AXIS, ARG1) )
      ENDIF

      IF (found_range) THEN
         result(3,j,k,l,m,n) = MAX(jlo-2, arg_lo_ss(Y_AXIS, ARG2) )
         result(4,j,k,l,m,n) = MIN(jhi+2, arg_hi_ss(Y_AXIS, ARG2) )
      ENDIF

      RETURN 

 5500 WRITE (errmsg, 1000) 'X', i, j
 1000 FORMAT (A1, 
     . ' coordinates missing where valid value needed, at I,J=', 2i5)

      CALL EF_BAIL_OUT(id, errmsg)

 5600 WRITE (errmsg, 1000) 'Y', i, j
      CALL EF_BAIL_OUT(id, errmsg)


      RETURN
      END

	SUBROUTINE REPORT_AUX_DEPENDENCY
     .		( cx, isp_stk_lev,  uvar, item, work, cx_status, desist )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* store a line describing a single variable of a dependency tree
* this routine is identical to REPORT_DEPENDENCY except that it passes a special
* flag to indicate that it is not a full-fledged dependency of definition.
* The key difference is that the parent of the aux variable is not being *defined*
* when this reference to the aux var occurs, so the check for recursive
* definitions should not look further up the tree

* for example, in
*let depth = z[g=temp]+ 0*temp[k=1]
*    LET tempz = temp[gz(depth)=zpts]
*    VTREE=all
*       TEMPZ = TEMP[GZ(DEPTH)=ZPTS]
*         TEMP
*           DEPTH = Z[G=TEMP]+ 0*TEMP[K=1]
*             TEMP
* The final line is an identical reference to TEMP repeated, but not a recursion


* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V690  *sh* 11/13 

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xdependency_tree.cmn'


* calling argument declarations:
	LOGICAL desist
	INTEGER cx, isp_stk_lev, uvar, item, cx_status, device
	INTEGER	work(dependency_max_recs, dependency_nfields)

* internal variable declarations
	INTEGER	tree_level
	LOGICAL its_aux

	PARAMETER (its_aux = .TRUE.)

* initialize
	tree_level = isp_stk_lev - dependency_root_level

* save the item in the dependency tree
	CALL STORE_DEPENDENCY(its_aux, cx, tree_level,  uvar, item, cx_status,
     .			work(1,1), work(1,2), work(1,3), work(1,4), 
     .			work(1,5), work(1,6), work(1,7), work(1,8), desist )


	RETURN
	END

	SUBROUTINE CD_GET_GENERIC_BOUNDS
     .       ( cdfid, ivar, grid, tmlo, cdflo, cdfhi, tmrecdim, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Get the bounds of the hyperslab of the given netCDF variable
* from its (generic) dimension limits

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 3/92
*  1/95 *sh*: synchronize the start coordinates of the axes in the CDF file
*		with the coordinates from the grid being written
*  11/96 *kob* - Linux Port - had to use F90 intrinsic function TRANSFER
*			    - to properly pass cvdim variable (not array)
*		   	      to the NCVINQ routine.
* V500 4/99 *kob*: increase size of vname and axnam from 24 to 64
*	- for wacky DODS variables
* V533 *sh* 6/01 - add support for string variables (NF_CHAR)
* V500 4/99 *kob*: increase size of vname and axnam from 24 to 64
* V552 *acm* 5/03   increase vname to 128 chars 
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing
* V686 4/13 *acm* Fix ticket 2064: use single-precision comparisons
* v694 1/15 *acm* for ticket 2227: if a dimension from a nc file is not also a 
*                 1-D coordinate var, don't write the axis Ferret creates
* V698  4/16 *acm* Fix ticket 2241: If file has dimension but not a coordinate 
*                  variable, do not write the coordinate variable, ONLY IF writing 
*                  the full-span in that direction.

* argument definitions:
*	cdfid   - id of currently open CDF file
*       ivar    - CDF variable ID of the desired variable
*       grid    - TMAP grid number
*       tmlo    - lo subscript limits from TMAP grid
*       cdflo   - array of (nferdims) lower bounds subscripts (returned)
*       cdfhi   - array of (nferdims) upper bounds subscripts
*       tmrecdim- returned axis (1-nferdims) which is CDF record dimension (or 0)

* include files

        include 'netcdf.inc'
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "gt_lib.parm"
        include 'cd_lib.parm'
        include 'xio.cmn_text'
        external xio_data
        include 'xtm_grid.cmn_text'
        external xgt_grid_data


! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

* argument declarations:
	INTEGER	 cdfid, ivar, grid, tmlo(*), cdflo(*), cdfhi(*),
     .		tmrecdim, status

* local variable declarations:
      LOGICAL CD_USE_RECDIM, TM_FPEQ_SNGL, no_file_coords
      INTEGER TM_LENSTR1, TM_SUBSC, 
     .        idim, vartyp, nvdim,
     .        ndims, cdfstat, vdims(8), nvatts,
     .	      cvartyp, ncvdims, cvdim, npts, alen, axid, offset
* 4/99 *kob* 
      CHARACTER vname*128, axnam*128
      REAL*8 TM_WORLD, file_val, mem_val
      REAL*4 sfval, smval

* determine if this variable uses the record dimension
        IF ( CD_USE_RECDIM( cdfid, ivar, status ) ) THEN
            tmrecdim = t_dim
         ELSE
            tmrecdim = 0
         ENDIF

* get the vital statistics for this variable
#ifdef usingDODSf2cUnderscore
        cdfstat = NF_INQ_VAR_(cdfid, ivar, vname, vartyp, nvdim,
     .              vdims, nvatts)
#else
        cdfstat = NF_INQ_VAR (cdfid, ivar, vname, vartyp, nvdim,
     .              vdims, nvatts)
#endif

* if it is a character variable, then the first dimension of it is the strlen
        IF (vartyp .EQ. NF_CHAR) THEN
	   DO idim = 1, nferdims+1
	      vdims(idim) = vdims(idim+1)
	   ENDDO
	   nvdim = nvdim - 1
	ENDIF

* get the lo/hi bounds
        ndims = 0
        DO 100 idim = 1, nferdims
           IF ( grid_line(idim,grid) .NE. mpsnorm
     .    .AND. tmlo(idim) .NE. unspecified_int4  ) THEN
              ndims = ndims + 1
!              cdfhi(idim) = CD_AXLEN( cdfid, vdims(ndims), status )
* 1/95: get info about the coordinate variable (previously w/ CD_AXLEN)
* and then synchronize the start subscript in the output file with the axis
* position on the grid being written (this permits writing into files that
* lack the cdfhi/max_limits machinery)

* ... get the size and name of the dimension
#ifdef usingDODSf2cUnderscore
              cdfstat = NF_INQ_DIM_( cdfid, vdims(ndims), axnam, npts )
#else
	      cdfstat = NF_INQ_DIM ( cdfid, vdims(ndims), axnam, npts )
#endif
	      alen = TM_LENSTR1( axnam )

* If the dimension is not also a 1-D coord var, and if we're writing the full 
* span, then we are not writing coords, so dont check them.
              
	      IF (line_dim_only(grid_line(idim,grid)) .AND.
     .            line_dim(grid_line(idim,grid)) .EQ. npts) THEN
	          cdflo(idim) = 1
	          cdfhi(idim) = npts
	          GOTO 100
	      ENDIF

* ... time axis as a record axis will be synchronized in another routine
	      IF ( idim .EQ. tmrecdim ) THEN
	          cdflo(idim) = 1
	          cdfhi(idim) = npts
	          GOTO 100
	      ENDIF

* ... find the coordinate variable by this name
#ifdef usingDODSf2cUnderscore
              cdfstat = NF_INQ_VARID_( cdfid, axnam(:alen), axid )
#else
              cdfstat = NF_INQ_VARID ( cdfid, axnam(:alen), axid )
#endif
	      no_file_coords = cdfstat .NE. NF_NOERR

* ... determine the first coordinate value
              IF ( no_file_coords ) THEN
	         file_val = 1.0D0	! like abstract axis
	      ELSE
* ... get the vital statistics of the coordinate variable
#ifdef usingDODSf2cUnderscore
                 cdfstat = NF_INQ_VAR_(cdfid, axid, axnam, 
     .			cvartyp, ncvdims,
#else
		 cdfstat = NF_INQ_VAR(cdfid, axid, axnam, 
     .			cvartyp, ncvdims,
#endif
#ifdef FORTRAN_90
     .			TRANSFER(cvdim,cvdim,1), nvatts)
#else
     .                  cvdim, nvatts)
#endif
* ... read the first coordinate
                 CALL CD_RD_R8_1( cdfid, axid, 1, cvartyp,
     .                      'axis: '//axnam(:alen), file_val, status )
	         IF ( status .NE. merr_ok ) GOTO 5000
	      ENDIF

* ... locate the first file coordinate on the TMAP grid axis
	      offset = TM_SUBSC ( file_val, grid, idim, 1 )

* ... check that the starting alignment is "exact"
	      mem_val = TM_WORLD ( offset, grid, idim, box_middle )

	      sfval = SNGL(file_val)
	      smval = SNGL(mem_val)
	      IF (.NOT.TM_FPEQ_SNGL(sfval, smval)) GOTO 5100

* .. here are the synchronized subscripts
              cdflo(idim) = offset
              cdfhi(idim) = offset + npts - 1

* ... safety check - make sure the upper axis limit is also exact
*     (no check is made for points in between)
	      IF ( no_file_coords ) THEN
	         file_val = npts
	      ELSE
                 CALL CD_RD_R8_1( cdfid, axid, npts, cvartyp,
     .                      'axis: '//axnam(:alen), file_val, status )
	         IF ( status .NE. merr_ok ) GOTO 5000
	      ENDIF
	      offset = TM_SUBSC ( file_val, grid, idim,  cdfhi(idim) )
	      mem_val = TM_WORLD ( offset, grid, idim, box_middle )
	      
	      sfval = SNGL(file_val)
	      smval = SNGL(mem_val)
	      IF (.NOT.TM_FPEQ_SNGL(sfval, smval)) GOTO 5100

           ELSE
              cdflo(idim) = 1
              cdfhi(idim) = 1
           ENDIF
 100    CONTINUE

* successful completion
	status = merr_ok
        RETURN

* error exits
 5000	RETURN
 5100  CALL TM_ERRMSG
     .      ( merr_badlinedef, status, 'CD_GET_GENERIC_BOUNDS',
     .	      no_descfile, no_stepfile,
     .       'file coords dont match variable coords on axis '
     .       //axnam(:alen),
     .       no_errstring , *5000 )

	END

	SUBROUTINE IS_DEPENDENCIES( *, *, work, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* this routine is derived from IS_UVAR_GRID
* see that routine for a discussion of how it is implemented
* instead of evaluating the grid of a uvar, this routine traces through the
* same path and reports out the dependencies
* It also handles dependencies created by
*  o auxiliary variables used in uaxvar regridding
*  o aggregated variables created using DEFINE AGGREGATION

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V690 9/13 *sh*  -- with provisions for aux variables tested and refined
* V693+ 12/14 *sh* - repair improper handling of dynamic grids
*       later same month: tweak the repair to fix bug #2225
*	and always report TWO (or more) dependency lines when regridding occurs
* V695+ 2/15 *sh* - report target of regrid even if auxvar is involved 
* V720  3/17 *acm*  clean up long commented-out code referring to aggregations 

* calling argument declarations:
	INTEGER	status
	INTEGER work(*)
* normal return is for error conditions
* exit #1 is to request dependencies of a component ( stack has been pushed )
* exit #2 is to signal that the dependencies of a uvar have been traced

* internal variable declarations:
	LOGICAL	ITSA_GCVAR, its_gc, 
     .		get_aux_vars, delayed_by_auxvars, desist
	INTEGER TM_LENSTR1, GCF_PARENT_UVAR, GCF_PARENT_CHAR, 
     .		NCF_GET_AGG_COUNT,
     .		iaux, auxcnt, hi_cx, lo_cx, aux_cx, start, iend,
     .		i, dset, uvar, item, itype, idim, nitem, var, len_name, 
     .          memb_cx, agg_dset, agg_len, var_status,
     .		imemb, fer_uvar, memb_dset, memb_grid, iline, nv

	CHARACTER VAR_CODE*128, name*512, varcode*128

#include "netcdf.inc"
	include	'tmap_errors.parm'
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xdependency_tree.cmn'

*        ... interpretation stack setup at the time this is called ...
*	stack level		stack contents
*	isp+1	<--	level to get grids for components
*	 isp	<--	current level: evaluate uvar or var/auxvar dependencies

* --- end of introductory code ---

* initialize
	lo_cx  = is_cx( isp )
	uvar   = is_uvar( isp )
	dset   = cx_data_set( lo_cx )
	nitem  = uvar_num_items( uvar )
	its_gc = ITSA_GCVAR(uvar)
!	has_uvar_gc = has_uvar_gc .OR. its_gc  ! for repl_exprns fixing bug 1523
* if aux var dependencies have just been reported, then we have to yet to 
* report user variable dependencies
* e.g.	in
*   LET V = a + b
*   SHOW VAR/DEP v[gz(depth)=zpts]
* after reporting that V depends on depth, we need to report on "V=a+b"
	delayed_by_auxvars = is_sum(isp) .NE. 0
	IF (delayed_by_auxvars) is_phase(isp) = is_phase(isp) - 1

****
* Handle auxiliary variables
	get_aux_vars = is_act(isp) .EQ. isact_auxvar_regrid
	IF  ( get_aux_vars ) THEN
 10	   is_phase(isp) = is_phase(isp) + 1
	   iaux = is_phase(isp)
	   IF (iaux .GT. cx_naux(lo_cx) ) THEN
	      is_sum(isp-1) = 1  ! signal completion of aux vars
	      GOTO 1000  ! we have finished reporting aux vars
	   ENDIF
	   CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   aux_cx = cx_stack_ptr
* ... in GET_VAR_CONTEXT valid_aux_var was set. Tells if aux varname is known
	   IF (.NOT. cx_valid_aux(iaux, lo_cx) ) THEN
* ... find the idim value where this aux var info is stored
	      auxcnt = 0
	      DO 12 idim = 1, nferdims
	         IF ( cx_aux_arg_start(idim, hi_cx)
     .		 .NE. unspecified_int4)  auxcnt = auxcnt + 1
	         IF (auxcnt .EQ. iaux) GO to 14
 12	      CONTINUE
	      CALL ERRMSG( ferr_internal, 'is_dependencies', *5000)
* ... extract the start and end of the text string for the unknown auxvar
 14	      cx_variable(aux_cx) = cx_aux_arg_start(idim, hi_cx) 
	      cx_category(aux_cx) = cx_aux_arg_end (idim, hi_cx) 
	      status = ferr_unknown_auxvar
	   ELSE
* ... get full context for a known auxiliary variable
	      CALL GET_AUX_VAR_CONTEXT( hi_cx, aux_cx, iaux, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
 	   ENDIF
	   CALL REPORT_AUX_DEPENDENCY( aux_cx, isp, uvar, item,
     .				       work, status, desist     )
           IF (.NOT.desist
     .    .AND. cx_category(aux_cx) .EQ. cat_user_var) THEN
* ... if its a uvar go show dependencies INSIDE of the aux variable definition
              CALL PUSH_INTERP_STACK( isp, status )
              IF ( status .NE. ferr_ok ) RETURN
              is_cx   ( isp ) = aux_cx
              is_uvar ( isp ) = cx_variable( aux_cx )
              is_act  ( isp ) = isact_algebra
              RETURN 1
	   ELSE
	      cx_stack_ptr = cx_stack_ptr - 1
	      GOTO 10	! do next aux var
           ENDIF
	ENDIF

****
* Handle aggregate variables
	IF ( is_act(isp) .EQ. isact_aggregate_gather ) THEN
	   agg_dset = dset
	   status = NCF_GET_AGG_COUNT (agg_dset, agg_len)
	   var = cx_variable(lo_cx)
 20	   is_phase(isp) = is_phase(isp) + 1
	   imemb = is_phase(isp)
	   IF (imemb .GT. agg_len ) THEN
	      GOTO 1000  ! we have finished reporting aux vars
	   ENDIF
* .. set up a stack level w/ info about the next aggregation member
	   CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   memb_cx = cx_stack_ptr
	   CALL TRANSFER_CONTEXT(lo_cx, memb_cx)
	   varcode = VAR_CODE(cx_category(hi_cx), var)
	   CALL CD_GET_AGG_VAR_INFO (agg_dset, varcode, imemb, 
     .            fer_uvar, memb_dset, memb_grid, iline, nv, status)
	   cx_category(memb_cx) = fer_uvar
	   cx_data_set(memb_cx) = memb_dset
	   cx_variable(memb_cx) = nv
	   status = ferr_ok
	   CALL REPORT_DEPENDENCY(memb_cx, isp, uvar, item,
     .				  work, status, desist )
           IF (.NOT.desist
     .	  .AND. cx_category(memb_cx) .EQ. cat_user_var) THEN
* ... if its a uvar go show dependencies
              CALL PUSH_INTERP_STACK( isp, status )
              IF ( status .NE. ferr_ok ) RETURN
              is_cx   ( isp ) = memb_cx
              is_uvar ( isp ) = cx_variable( memb_cx )
              is_act  ( isp ) = isact_algebra
              RETURN 1
	   ELSE
	      cx_stack_ptr = cx_stack_ptr - 1
	      GOTO 20	! do next aggregation member
           ENDIF
	ENDIF


****
* Handle user-defined variable (uvar)
* is_act(isp) is equal to isact_aggregate_gather
* process the next item in the expression from the uvar buffer (last to first)
 100	is_phase(isp) = is_phase(isp) + 1
* ... for showing dependencies traverse in natural, forward order
!	item = nitem - is_phase(isp)	+ 1	! reverse-ordered pointer
	item = is_phase(isp)
	IF ( item .GT. nitem ) GOTO 1000	! have processed entire def'n
	itype = uvar_item_type ( item, uvar )
	start = uvar_item_start( item, uvar )
	iend   = uvar_item_end  ( item, uvar )
	IF     ( itype .EQ. alg_pseudo_var  ) THEN
	   GOTO 100
	ELSEIF ( itype .EQ. alg_const_var   ) THEN
	   GOTO 100
	ELSEIF ( itype .EQ. alg_child_var   ) THEN
	   GOTO 300
	ELSEIF ( itype .EQ. alg_variable    ) THEN
	   GOTO 305
	ELSEIF ( itype .EQ. alg_attrib_val  ) THEN
	   GOTO 100
	ELSEIF ( itype .EQ. alg_string      ) THEN
	   GOTO 100
	ELSEIF ( itype .EQ. alg_constant    ) THEN
	   GOTO 100
	ELSEIF ( itype .EQ. alg_counter_var   ) THEN
	   GOTO 100
	ELSEIF ( itype .EQ. alg_then_marker ) THEN  ! marks where the IF was
	   GOTO 100
	ELSE
	   GOTO 100
	ENDIF

* ==================================

 300	CALL GCF_CHILD_VAR_NAME( GCF_PARENT_UVAR(uvar),
     .				 GCF_PARENT_CHAR(uvar,start), name )
	len_name = TM_LENSTR1(name)
	GOTO 310

* variable: parse name, get full expression context
 305	name = uvar_text(uvar)(start:iend)
	len_name = iend-start+1
 310	CALL STACK_PTR_UP( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	hi_cx = cx_stack_ptr
	CALL GET_VAR_CONTEXT (  name(:len_name),
     .				lo_cx,
     .				hi_cx,
     .				var_status )

* some house-keeping if a regridding dependency was detected
	IF ( cx_unstand_grid(hi_cx)
     . .AND. dependency_tree_mode ) THEN 
	  DO i = 1, cx_vtree_regrid_ntarget
	    IF (cx_vtree_unknown_grid(i)) THEN
* ... point to character position of "[]" relative to full uvar_text
	      cx_vtree_var_or_start(i) = cx_vtree_var_or_start(i) + start - 1
	      cx_vtree_cat_or_end  (i) = cx_vtree_cat_or_end  (i) + start - 1
	    ENDIF
	  ENDDO
	ENDIF

* have we returned here after reporting auxvar dependencies?
* if so we have already reported this variable
	IF (delayed_by_auxvars) THEN
	   delayed_by_auxvars = .FALSE.
	   is_sum(isp) = 0
	   GOTO 900
	ENDIF

* report the variable just parsed -- known or unknown or with syntax errors
*   note that auxvar errors are dealt with in the auxvar block above
	IF ( var_status .NE. ferr_unknown_auxvar ) THEN
	   CALL REPORT_DEPENDENCY( hi_cx, isp, uvar, item,
     .				   work, var_status, desist )
* ... a special lines to report regridding dependency
	   IF (cx_unstand_grid(hi_cx) )
     .	   CALL REPORT_DEPENDENCY( hi_cx, isp+1, uvar, item,
     .				   work, pcx_vtree_regrid_report, desist )
	ENDIF

* if the variable used auxiliary variables for regridding set up new isp
* level and go report them (before reporting on uvar dependencies)
	IF  ( .NOT.desist
     .	.AND. cx_unstand_grid(hi_cx)
     .	.AND. cx_naux(hi_cx) .GT. 0 ) THEN
	   CALL PUSH_INTERP_STACK( isp, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   is_phase( isp ) = 0
	   is_cx   ( isp ) = hi_cx
	   is_uvar ( isp ) = is_uvar(isp - 1)
	   is_act  ( isp ) = isact_auxvar_regrid
	   is_sum  ( isp ) = 0    ! set to 1 only when returning after auxvars
	   RETURN 1
	ELSEIF (var_status .EQ. ferr_unknown_variable ) THEN
	   cx_stack_ptr = cx_stack_ptr - 1
	   GOTO 100
	ENDIF

* if the variable is a uvar set up a new isp level and report the dependencies
 900	   IF (.NOT.desist
     .	 .AND. cx_category(hi_cx) .EQ. cat_user_var) THEN
	   IF (its_gc) is_phase(isp) = is_phase(isp) - 1  ! WILL NEED WORK!!
* ... load the new variable info onto the IS stack
	   CALL PUSH_INTERP_STACK( isp, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   is_cx   ( isp ) = hi_cx
	   is_uvar ( isp ) = cx_variable( hi_cx )
	   is_act  ( isp ) = isact_algebra
	   is_sum  ( isp ) = 0    ! flag that we are not returning from auxvars
	   RETURN 1
* if the variable is an aggregation from multiple datasets set up new isp
* level and report the ensemble members 
	ELSEIF  ( .NOT.desist
     .	    .AND. (cx_category(hi_cx) .EQ. cat_agg_e_var .OR. 
     .	           cx_category(hi_cx) .EQ. cat_agg_f_var) ) THEN
	   CALL PUSH_INTERP_STACK( isp, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   is_phase( isp ) = 0
	   is_cx   ( isp ) = hi_cx
	   is_uvar ( isp ) = is_uvar(isp - 1)
	   is_act  ( isp ) = isact_aggregate_gather
	   is_sum  ( isp ) = 0    ! set to 1 only when returning after auxvars
	   RETURN 1
* nothing more to do about the variable that was just reported
	ELSE
	   cx_stack_ptr = cx_stack_ptr - 1
	   GOTO 100
	ENDIF
	
* clean up: release context and isp stack space
 1000	CONTINUE
! this is in effect a precautionary "assert"
	IF (cx_has_impl_grid(cx_stack_ptr)) THEN
	   CALL WARN('crptn_is_dependencies')
           CALL DEALLO_GRID(i)
	ENDIF
! commented out (removed) 12/31 in favor of related code in GET_VAR_CONTEXT
!* ... if a dynamic grid was created for this variable release it
!*     Note that this fix is not fully understood.  In IS_DEPENDENCIES
!*     we don't actually care about grid allocations and use counts, however
!*     dynamic grids get created by GET_VAR_CONTEXT, etc. so we have to clean up
!	IF ( cx_has_impl_grid(cx_stack_ptr)
!     . .AND. cx_grid(cx_stack_ptr).NE. unspecified_int4 ) THEN
!	   CALL DEALLO_DYN_GRID(cx_grid(cx_stack_ptr))
!	   cx_has_impl_grid(cx_stack_ptr) = .FALSE.
!	ENDIF
	cx_stack_ptr = cx_stack_ptr - 1
	isp = isp - 1

! unclear -- is there special stuff to do for remote uvar definitions?
* Is it a LET/REMOTE variable?
* ! do we need to find a slot in rvar_uvar, and index the rvars with "rvar", 
* !or just use same indexing as for regular user-vars?
!        IF (uvar_remote(uvar)) THEN
!
!	   CALL CD_DSET_REMOTEOK(dset, ok_remote)
!	   IF (ok_remote) THEN
!	      uvar_remote(uvar) = .TRUE. 
!	      rvar_uvar(uvar) = uvar  
!	      rvar_dset(uvar) = dset
!c	      rvar_on_server(uvar) = .FALSE. 
!	   ELSE
!	      uvar_remote(uvar) = .FALSE. 
!	   ENDIF
!	ENDIF

	RETURN 2

* error exit
 5000	CALL DEALLO_ALL_GRIDS
	RETURN
! 9000	CALL ERRMSG( ferr_internal, status, 'is_uvar_grid', *5000 )

	END	

	SUBROUTINE REGRID_TO_DSG_LIMS( dst_cx, src_cx, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* given a context describing data to be regridded to a destination DSG grid
* from a traditional grid, set up the range of source data needed 
* When called the source context should be a copy of the destination context 

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* V720 *sh* 5/17
* V76  1/20 *acm* working with Point-type dsg data 

	include 'tmap_dims.parm'
	include 'implicit.parm'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'
	include	'xtext_info.cmn'
	include 'xdset_info.cmn_text'

* calling argument declarations:
	INTEGER	src_cx, dst_cx, status

* internal variable declarations:
	INTEGER	KNOWN_GRID, CGRID_AXIS, TM_LENSTR1, TM_DSG_DSET_FROM_GRID,
     .		idim, src_var, src_cat, slen, orient,
     .		src_grid, dsg_grid, dsg_dset, xlate_grid
	REAL*8	TDEST_CONVERT
	CHARACTER*32 VAR_CODE, vname

* initialize
	src_cat = cx_category(src_cx)
	src_var = cx_variable(src_cx)
	dsg_grid = cx_grid(dst_cx)
	dsg_dset = TM_DSG_DSET_FROM_GRID(dsg_grid)
	xlate_grid = dsg_xlate_grid(dsg_dset)
	
	orient = dsg_orientation(dsg_dset)

* install the native grod for the source data
	src_grid = KNOWN_GRID( cx_data_set(src_cx),
     .					src_cat,
     .					src_var	)
	cx_grid(src_cx) = src_grid
	cx_unstand_grid( src_cx ) = .FALSE.

* Get the limits of gridded source data needed.
* Every axis of the source data must be specified in some way,
* either through the WW limits of the destination DSG context
* or through a LET definition on the source data.
* For example, if the DSG has only XYT axes, and the source grid is XYZT
* then source_var[G=my_dsg] is an error.  The error can be resolved by the user
* by issuing LET var_atZ0 = source_var[Z=0] and regridding var_atZ0[G=my_dsg]
	DO idim = 1, 4
	   IF (cx_regrid_trans(idim,dst_cx) .EQ. unspecified_int4) THEN
	      IF (CGRID_AXIS(idim,src_cx) .NE. mnormal) THEN
	         IF (src_cat .EQ. cat_file_var
     .		  .OR.  (src_cat .EQ. cat_user_var
     .		   .AND. uvar_given(idim,src_var) .GE. uvlim_needed) )
     .								GOTO 5100
	      ENDIF
	      cx_by_ss(idim,src_cx) = .TRUE.
	      cx_lo_ss(src_cx,idim) = unspecified_int4
	      cx_hi_ss(src_cx,idim) = unspecified_int4
	   ELSE
	      cx_regrid_trans(idim,src_cx) = unspecified_int4
	      cx_by_ss(idim,src_cx) = .FALSE.
	      IF (idim .EQ. t_dim) THEN
* ... need to convert from dest time encoding to source time encoding
! DSGTBD The equivalent time conversion code in RQST_REGRID is very much longer
!  It has a lot of logic pertaining to calendars. I see that tdest_world_init.F
!  has code that seems to support calendars.  Am I doing something wrong here?
	         CALL TDEST_WORLD_INIT (xlate_grid, src_grid, t_dim, status )
	         IF (status .NE. ferr_ok) GOTO 5000
	         cx_lo_ww(idim,src_cx) = TDEST_CONVERT(cx_lo_ww(idim,dst_cx))
	         cx_hi_ww(idim,src_cx) = TDEST_CONVERT(cx_hi_ww(idim,dst_cx))
	      ELSE
	         cx_lo_ww(idim,src_cx) = cx_lo_ww(idim,dst_cx)
	         cx_hi_ww(idim,src_cx) = cx_hi_ww(idim,dst_cx)
	      ENDIF
	      cx_by_ss(idim,src_cx) = .FALSE.
	      CALL CONFINE_AXIS( idim, src_cx, status )
	      IF (status .NE. ferr_ok) GOTO 5000
	   ENDIF
	   CALL FLESH_OUT_AXIS( idim, src_cx, status )
* ... the ss limits are now correct but the ww limits are the DSG dset limts
*     Call FLESH_OUT_AXIS again to shift WW limits to align with grid box edges
! 5/17 *sh* I have never tried this trick approach.  If there are problems
!     on modulo axes of whatever, then we need to go step by step here using
!     ISUBSCRIPT's rounding capabilities to make sure we get both correct
!     index values and world coordinate limits
	   cx_by_ss(idim,src_cx) = .TRUE.
	   CALL FLESH_OUT_AXIS( idim, src_cx, status )
	   IF (status .NE. ferr_ok) GOTO 5000
	ENDDO

	IF (orient .EQ. e_dim) THEN
	   cx_lo_ss(src_cx,orient) = unspecified_int4
	   cx_hi_ss(src_cx,orient) = unspecified_int4
	   cx_lo_ww(orient,src_cx) = unspecified_val8
	   cx_hi_ww(orient,src_cx) = unspecified_val8
	ENDIF

* success
	RETURN

* error exit
 5000	RETURN
 5100   vname = VAR_CODE(cx_category(src_cx),cx_variable(src_cx))
	slen = TM_LENSTR1(vname) 
	CALL ERRMSG( ferr_regrid, status,
     .          ww_dim_name(idim)//' axis of '//vname(:slen)
     .		//' requires a point location for regridding', *5000)

	END

      SUBROUTINE PLTYPE(ICODE)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
*	Modified 3.15.89 J Davison JISAO/PMEL/TMAP
*	For GKS plots (pltype = 3 or 4) captures decision to write to
*	GKS metafile, and sets up GKS as required.
*
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     PLTTER DEPENDENT ROUTINE
C     THIS ROUTINE MUST BE MODIFIED EVERY TIME NEW PLT DEVICES ARE ADDE
C     OR OLD ONES ARE DELETED.
C
C
C     CALL PLTYPE(ICODE)
C
C     THIS SUBROUTINE SELECTS THE DEVICE OR DEVICES THAT WILL BE
C     USED FOR PLTTING.
C
C     THE VARIOUS COMBINATIONS OF PLTTING DEVICES THAT CAN BE
C     DRIVEN BY COMPLT AND THE ASSOCIATED PLT TYPES ARE LISTED
C     BELOW:
C	 GKS AND ZETA PLOTTER               -    4
C        GKS ONLY                           -    3
C        TEKTERMINAL AND ZETA PLOTTER       -    2
C        TEKTERMINAL ONLY                   -    1
C        ZETA PLOTTER ONLY                  -    0
C	 HP7475 PLOTTER ONLY		    -   -1
C	 HP7475 PLOTTER AND TEKTERMINAL     -   -2
C
C
	integer	icode

#ifdef unix
	include 'pltcom_dat.decl'
	include 'PLTCOM.DAT'
	include 'cmrdl_inc.decl'
	include 'CMRDL.INC'
#else
	INCLUDE 'TMAP_PPLV11INC:PLTCOM_DAT.DECL'
	INCLUDE 'PPLV11INC:PLTCOM.DAT'
	INCLUDE 'TMAP_PPLV11INC:CMRDL_INC.DECL'
	INCLUDE 'PPLV11INC:CMRDL.INC'
#endif

	IF(PLTFLG)THEN
	    PEN=.FALSE.
	    IF(PTYPE.LT.0)THEN
		A=0.
		B=0.
		CALL HPABMV
		CALL ZBUFFT('SP0;',4)
		OLDHTA=0
		CALL HFLUSH
	    ELSE IF(PTYPE.EQ.0.OR.PTYPE.EQ.2.OR.PTYPE.EQ.4)THEN
		CALL ZABMV
		CALL BINFSH
	    ENDIF
	    PLTFLG=.FALSE.
	ENDIF
      PTYPE = ICODE
C
C     CHECK FOR A LEGAL PLT TYPE.
C
      IF(IABS(PTYPE) .GT. 4)PTYPE = 0

*     DETERMINE IF METAFILE WILL BE USED IN GKS, OPEN GKS IF NOT OPEN
	if ((ptype .eq. 3 .or. ptype .eq. 4) .and. icom(1:6) .ne. 'CLSPLT') 
     .		call set_gks_metafile		
C
C
C     REINITIALIZE THE TEKTERMINAL TYPE IN CASE THIS IS NOT THE
C     FIRST TIME THIS SUBROUTINE HAS BEEN CALLED.
C
      CALL TKTYPE(4010)
C
C     INTIALIZE THE PRINTRONIX RASTER BUFFER IF NEEDED.
C
      RETURN
C
      END

	SUBROUTINE CURV_COORD_SUB( xi, yj, npt, xfield, yfield,
     .				   xinv, yinv, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* convert the incoming coordinate arrays (xi,yj), which are "fractional
* indices" into true (X,Y) world coordinates by bi-linear interpolation
* in the coordinate arrays, xfield, yfield

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V450: 
* V58+:  1/2005 ACM see if the longitude coordinates around x have
*                   crossed a branch cut, and if so correct the
*                   interpolants.
* V612: 7/08 *acm*  Fix bug 1589; if the units of the coordinates are not degrees
*                   then dont try to see if we are near the branch cut.
* V63   9/09 *acm* Fix bug 1688: curvlinear plots when the curv. coords are NOT
*                  longitude and latitude.
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus.
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V687 *acm* 3/14 tickets 2151 and 2147: allow missing coordinate data in 3-arg 
*                 and 4-arg plot commands. 

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include	'xvariables.cmn'
	include	'xcurvilinear.cmn'

* calling argument declarations:
	INTEGER npt, status
#ifdef double_p
	REAL*4  xinv, yinv, xlo, xhi
	REAL*8	xi(npt), yj(npt),
     .		xfield(xpos_loss_dim1:xpos_hiss_dim1,
     .		       xpos_loss_dim2:xpos_hiss_dim2),
     .		yfield(ypos_loss_dim1:ypos_hiss_dim1,
     .		       ypos_loss_dim2:ypos_hiss_dim2)
#else
	REAL	xfield(xpos_loss_dim1:xpos_hiss_dim1,
     .		       xpos_loss_dim2:xpos_hiss_dim2),
     .		yfield(ypos_loss_dim1:ypos_hiss_dim1,
     .		       ypos_loss_dim2:ypos_hiss_dim2)
	REAL    xi(npt), yj(npt),
     .		xinv, yinv, xlo, xhi
#endif


* internal variable declarations:
	INTEGER xlo_dim1, xhi_dim1, xlo_dim2, xhi_dim2,
     .		ylo_dim1, yhi_dim1, ylo_dim2, yhi_dim2, i
	REAL xfrac, yfrac, xit, yjt,
     .	     x11, x12, x21, x22,
     .	     y11, y12, y21, y22, aa
	CHARACTER*1 dim
        LOGICAL TM_FPEQ, lo, hi

        REAL branch_test, lon_degrees

	curv_missing = .FALSE.
        branch_test = 190.
        lon_degrees = 360.

	DO 100 i = 1, npt

* transfer coordinate pair to temporary variables
	xit = xi(i)
	yjt = yj(i)

* clip to the limits of the axis subscripts
	IF ( .NOT.(dim1_modulo.OR.dim1_edges) ) THEN
	   IF (xit .LT. minss_dim1) xit = minss_dim1
	   IF (xit .GT. maxss_dim1) xit = maxss_dim1
	ENDIF
	IF ( .NOT.(dim2_modulo.OR.dim2_edges) ) THEN
	   IF (yjt .LT. minss_dim2) yjt = minss_dim2
	   IF (yjt .GT. maxss_dim2) yjt = maxss_dim2
	ENDIF

* determine the surrounding index values for both coordinates
* (only the X component for now ... Y conponent later)
	xlo_dim1 = INT(xit)
	IF ( FLOAT(xlo_dim1) .EQ. xit ) THEN
	   xhi_dim1 = xlo_dim1
	ELSE
	   IF (xit .LT. 0.) xlo_dim1 = xlo_dim1 - 1  ! neg val to round down
	   xhi_dim1 = xlo_dim1 + 1
	ENDIF
	xlo_dim2 = INT(yjt)
	IF ( FLOAT(xlo_dim2) .EQ. yjt ) THEN
	   xhi_dim2 = xlo_dim2
	ELSE
	   IF (yjt .LT. 0.) xlo_dim2 = xlo_dim2 - 1  ! neg val to round down
	   xhi_dim2 = xlo_dim2 + 1
	ENDIF

* determine the interpolation coefficients
	xfrac = xit - xlo_dim1
	yfrac = yjt - xlo_dim2

* apply modulo wrapping
* Note: this logic assumes that modulo wrapping is applied to indices
*   that are at most one point beyond the edge of the coordinate fields.
*   This is consistent with the index requirements of CONTOUR and SHADE
* e.g. an input of xi=0.5 would result in xlo_dim1=N, xhi_dim1=1
	IF ( dim1_modulo ) THEN
	   IF ( xlo_dim1 .LT. minss_dim1 ) xlo_dim1 = maxss_dim1
	   IF ( xlo_dim1 .GT. maxss_dim1 ) xlo_dim1 = minss_dim1
	   IF ( xhi_dim1 .LT. minss_dim1 ) xhi_dim1 = maxss_dim1
	   IF ( xhi_dim1 .GT. maxss_dim1 ) xhi_dim1 = minss_dim1
	ENDIF
	IF ( dim2_modulo ) THEN
	   IF ( xlo_dim2 .LT. minss_dim2 ) xlo_dim2 = maxss_dim2
	   IF ( xlo_dim2 .GT. maxss_dim2 ) xlo_dim2 = minss_dim2
	   IF ( xhi_dim2 .LT. minss_dim2 ) xhi_dim2 = maxss_dim2
	   IF ( xhi_dim2 .GT. maxss_dim2 ) xhi_dim2 = minss_dim2
	ENDIF

* Propagate the X indices to the Y field (to be modified next)
	ylo_dim1 = xlo_dim1
	yhi_dim1 = xhi_dim1
	ylo_dim2 = xlo_dim2
	yhi_dim2 = xhi_dim2

* Set up for degenerate coordinate fields (single point on an axis)
* e.g.  SHADE vals2D xpos1d ypos1d
	IF (xspan_1_dim1) THEN
	   xlo_dim1 = minss_dim1
	   xhi_dim1 = xlo_dim1
	ENDIF
	IF (xspan_1_dim2) THEN
	   xlo_dim2 = minss_dim2
	   xhi_dim2 = xlo_dim2
	ENDIF
	IF (yspan_1_dim1) THEN
	   ylo_dim1 = minss_dim1
	   yhi_dim1 = ylo_dim1
	ENDIF
	IF (yspan_1_dim2) THEN
	   ylo_dim2 = minss_dim2
	   yhi_dim2 = ylo_dim2
	ENDIF

* The indexing of the X and Y fields may each be offset from the indices given
	xlo_dim1 = xlo_dim1 + xpos_off0_dim1
	xhi_dim1 = xhi_dim1 + xpos_off0_dim1
	xlo_dim2 = xlo_dim2 + xpos_off0_dim2
	xhi_dim2 = xhi_dim2 + xpos_off0_dim2

	ylo_dim1 = ylo_dim1 + ypos_off0_dim1
	yhi_dim1 = yhi_dim1 + ypos_off0_dim1
	ylo_dim2 = ylo_dim2 + ypos_off0_dim2
	yhi_dim2 = yhi_dim2 + ypos_off0_dim2

* get the interpolants
*	        (x,y)22           (x,y)22
*	
*	             	 (ix,jy)
*	
*	        (x,y)11           (x,y)12

	x11 = xfield(xlo_dim1, xlo_dim2)
	x12 = xfield(xhi_dim1, xlo_dim2)
	x21 = xfield(xlo_dim1, xhi_dim2)
	x22 = xfield(xhi_dim1, xhi_dim2)

	y11 = yfield(ylo_dim1, ylo_dim2)
	y12 = yfield(yhi_dim1, ylo_dim2)
	y21 = yfield(ylo_dim1, yhi_dim2)
	y22 = yfield(yhi_dim1, yhi_dim2)

* check that all of the needed interpolants exist3/24/2014
	IF ( TM_FPEQ(x11,badxcurv)
     .	.OR. TM_FPEQ(x12,badxcurv)
     .	.OR. TM_FPEQ(x21,badxcurv)
     .	.OR. TM_FPEQ(x22,badxcurv)) THEN
	   dim = 'X'
	   GOTO 5100
	ELSEIF (
     .	     TM_FPEQ(y11,badycurv)
     .	.OR. TM_FPEQ(y12,badycurv)
     .	.OR. TM_FPEQ(y21,badycurv)
     .	.OR. TM_FPEQ(y22,badycurv) ) THEN
	   dim = 'Y'
	   GOTO 5100
	ENDIF

C Check to see if any of the longitudes have crossed a branch cut.
C add or subtract local coordinates to correct for this. Puts all 
C coordinates on the same branch as x11

       IF (units_degrees) THEN

          IF (ABS(x11-x12) .GT. branch_test) THEN
              IF (x11 .GT. x12) THEN
                 x12 = x12 + lon_degrees
              ELSE
                 x12 = x12 - lon_degrees
              ENDIF
           ENDIF
           IF (ABS(x11-x21) .GT. branch_test) THEN
              IF (x11 .GT. x21) THEN
                 x21 = x21 + lon_degrees
              ELSE
                 x21 = x21 - lon_degrees
              ENDIF
           ENDIF
           IF (ABS(x11-x22) .GT. branch_test)   THEN
              IF (x11 .GT. x22) THEN
                 x22 = x22 + lon_degrees
              ELSE
                 x22 = x22 - lon_degrees
              ENDIF
           ENDIF

        ENDIF ! units_degrees

* perform the interpolation
	xi(i) = (x11*(1.-xfrac) + x12*(xfrac)) * (1.-yfrac)
     .	      + (x21*(1.-xfrac) + x22*(xfrac)) * (yfrac)
	yj(i) = (y11*(1.-xfrac) + y12*(xfrac)) * (1.-yfrac)
     .	      + (y21*(1.-xfrac) + y22*(xfrac)) * (yfrac)

 100	CONTINUE

* Check longitudes for a branch point

        IF (units_degrees) THEN
           x11 = xi(1)
           DO 108 i = 2, npt
              aa = ABS(x11-xi(i))
              IF (ABS(x11-xi(i)) .GT. branch_test) THEN
                 IF (x11 .GT. xi(i)) THEN
                    xi(i) = xi(i) + lon_degrees
                 ELSE
                    xi(i) = xi(i) - lon_degrees
                 ENDIF
              ENDIF
 108       ENDDO
        ENDIF ! units_degrees

* possibly invert the sign of the coordinates (used for descending Z axis)
	IF ( xinv .EQ. -1. ) THEN
	   DO 110  i = 1, npt
 110	   xi(i) = -1.*xi(i)
	ENDIF
	IF ( yinv .EQ. -1. ) THEN
	   DO 120  i = 1, npt
 120	   yj(i) = -1.*yj(i)
	ENDIF

* successful completion
	status = 0  ! (like ferr_ok but for PLOT+)
	RETURN

* error exit
 5000	RETURN
 5100	CONTINUE
	curv_missing = .TRUE.
	GOTO 5000
c	CALL ERRMSG( ferr_out_of_range, status,
c     .		dim//' coordinates'//pCR//
c     .		'missing value where val is needed', *5000)

	END 

*
* dates.F
*
*
* This function tests ef_get_axis_dates

* In this subroutine we provide information about
* the function.  The user configurable information
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
*
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result
*


      SUBROUTINE dates_init(id)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

      CALL ef_version_test(ef_version)

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CALL ef_set_desc(id,
     .        'Demo function: Returns a string array of dates derived ' //
     .        'from the time axis and the given offsets')
      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_result_type(id, STRING_RETURN)
      CALL ef_set_num_work_arrays(id, 1)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'Offsets')
      CALL ef_set_arg_desc(id, arg,
     .        'Variable on a time axis, containing offsets from the ' //
     .        'coordinates of the axis, in the units of the axis')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN
      END


*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE dates_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work array X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER array_num, nt

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nt = arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1) + 1

* The work array does not have to dimensioned along the time axis,
* but could be if it makes the code clearer.  Later we just treat it
* as a one-dimensional array, so just dimension along the first axis.

* taxdat  time axis coordinates
*         This is going to be a double precision array
*         so allocate twice the size of the time axis
*         in case REAL is REAL*4
      array_num = 1
      CALL ef_set_work_array_dims_6d(id, array_num,
     .                                1, 1, 1, 1, 1, 1,
     .                           2 * nt, 1, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE dates_compute(id, arg_1, result, taxdat)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

* String arrays are always viewed as double precision arrays
* Thus the initial dimension of one or two depending on whether
* REAL is REAL*8 or REAL*4
      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)

      REAL result(strdf, memreslox:memreshix, memresloy:memreshiy,
     .                   memresloz:memreshiz, memreslot:memreshit,
     .                   memresloe:memreshie, memreslof:memreshif)

* Ignore the unused singleton final dimensions in the work arrays
      REAL*8 taxdat(wrk1lox:wrk1hix/2)

* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable's axes.

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER i,  j,  k,  l,  m,  n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER taxnum, slen, idx, dim
      REAL*8 newtime
      CHARACTER*20 datebuf
      CHARACTER*255 errtxt

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* Make sure the argument has a time axis
      IF ( (arg_lo_ss(T_AXIS, ARG1) .EQ. ef_unspecified_int4) .AND.
     .     (arg_hi_ss(T_AXIS, ARG1) .EQ. ef_unspecified_int4) ) THEN
         errtxt = 'Offsets does not have a time axis'
         GOTO 999
      ENDIF
      dim = T_AXIS

* Get the time axis coordinates
      CALL ef_get_coordinates(id, ARG1, T_AXIS, arg_lo_ss(T_AXIS, ARG1),
     .                        arg_hi_ss(T_AXIS, ARG1), taxdat)

* Loop through the argument time offsets, assigning the result time strings
      n1 = arg_lo_ss(F_AXIS,ARG1)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

       m1 = arg_lo_ss(E_AXIS,ARG1)
       DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

*       taxdat indices start at 1 (given in dates_work_size)
        taxnum = 1
        l1 = arg_lo_ss(T_AXIS,ARG1)
        DO 400 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         k1 = arg_lo_ss(Z_AXIS,ARG1)
         DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

          j1 = arg_lo_ss(Y_AXIS,ARG1)
          DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

           i1 = arg_lo_ss(X_AXIS,ARG1)
           DO 100 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

            IF ( arg_1(i1,j1,k1,l1,m1,n1) .NE. bad_flag(ARG1) ) THEN

               newtime = taxdat(taxnum) + arg_1(i1,j1,k1,l1,m1,n1)

*              Convert newtime into a date string.
*              ef_get_axis_dates can work with an array of times,
*              returning an array of date strings; here we just do one
               CALL ef_get_axis_dates(id, ARG1, newtime, dim, 1, datebuf)

*              Get the actual length of the string
               DO 15 idx = 20, 1, -1
                  IF ( datebuf(idx:idx) .NE. ' ' ) THEN
                     slen = idx
                     GOTO 25
                  ENDIF
  15           CONTINUE

*              Empty string if we get here
               slen = 0

  25           CONTINUE

            ELSE

*              Use an empty string as the undefined value
               datebuf = ' '
               slen = 0

            ENDIF

*           Put the date string (or empty string) into the string array
            CALL ef_put_string(datebuf, slen, result(1,i,j,k,l,m,n))

            i1 = i1 + arg_incr(X_AXIS,ARG1)
 100       CONTINUE

           j1 = j1 + arg_incr(Y_AXIS,ARG1)
 200      CONTINUE

          k1 = k1 + arg_incr(Z_AXIS,ARG1)
 300     CONTINUE

         taxnum = taxnum + 1
         l1 = l1 + arg_incr(T_AXIS,ARG1)
 400    CONTINUE

        m1 = m1 + arg_incr(E_AXIS,ARG1)
 500   CONTINUE

       n1 = n1 + arg_incr(F_AXIS,ARG1)
 600  CONTINUE

      RETURN

 999  CALL EF_BAIL_OUT(id, errtxt)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END

	SUBROUTINE SUB_2_GRIDS( plus, mplus, mnus, mmnus, rslt, mrslt )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* subtract 2 grids producing a third

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 6/25/87
* V200:  7/26/89 - 4D symmetrical version
*	10/12/89 - use ..._SUB - avoid adjustable dimensioning with array
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include	'xvariables.cmn'

* calling argument declarations:
	INTEGER mplus, mmnus, mrslt
	REAL    plus( * ), mnus( * ), rslt( * )

* --- end of introductory code ---

	CALL SUB_2_GRIDS_SUB(
     .			  plus, mr_lo_s1(mplus), mr_hi_s1(mplus),
     .				mr_lo_s2(mplus), mr_hi_s2(mplus),
     .				mr_lo_s3(mplus), mr_hi_s3(mplus),
     .				mr_lo_s4(mplus), mr_hi_s4(mplus),
     .				mr_lo_s5(mplus), mr_hi_s5(mplus),
     .				mr_lo_s6(mplus), mr_hi_s6(mplus),
     .				mr_bad_data( mplus ),
     .			  mnus, mr_lo_s1(mmnus), mr_hi_s1(mmnus),
     .				mr_lo_s2(mmnus), mr_hi_s2(mmnus),
     .				mr_lo_s3(mmnus), mr_hi_s3(mmnus),
     .				mr_lo_s4(mmnus), mr_hi_s4(mmnus),
     .				mr_lo_s5(mmnus), mr_hi_s5(mmnus),
     .				mr_lo_s6(mmnus), mr_hi_s6(mmnus),
     .				mr_bad_data( mmnus ),
     .			  rslt, mr_lo_s1(mrslt), mr_hi_s1(mrslt),
     .				mr_lo_s2(mrslt), mr_hi_s2(mrslt),
     .				mr_lo_s3(mrslt), mr_hi_s3(mrslt),
     .				mr_lo_s4(mrslt), mr_hi_s4(mrslt),
     .				mr_lo_s5(mrslt), mr_hi_s5(mrslt),
     .				mr_lo_s6(mrslt), mr_hi_s6(mrslt),
     .				mr_bad_data( mrslt )			)


	RETURN
	END 

	SUBROUTINE CD_RD_EP_ARR(cdfid,t1id,t2id,t0,tunit,n,darr,status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* read an array of time values from a 2-integer EPIC time axis
* and return it as double precision time relative to t0

* NOTE:  This routine could be grestly optimized for performance.
*     This version calls CD_RD_EP_1 for each point.
*     Instead it could break apart T0 only once and use array reads to read
*     The double integers directly into the returned double precision array
*     The integers could then be re-arranged into pairs and converted to 
*     TMAP times in place.

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 3/92

* argument definitions:
*	cdfid	 - netCDF id number for already opened CDF file
*       t1id     - netCDF variable id of "time"
*       t2id     - netCDF variable id of "time2"
*       t0       - T0 string for the time axis
*       tunit    - number of seconds per axis time unit
*       n        - number of time values to return
*       darr     - double precision array returned
*       status   - TMAP library return status

* argument declarations
      INTEGER cdfid, t1id, t2id, n, status
      REAL tunit
      REAL*8  darr(n)
      CHARACTER*(*) t0

#ifdef unix
      include 'tmap_errors.parm'
#else
      INCLUDE 'TMAP_FORMAT:TMAP_ERRORS.PARM'
#endif

* internal variable declarations:
      INTEGER i

      DO 100 i = 1, n
 100  CALL CD_RD_EP_1(cdfid,t1id,t2id,t0,tunit,i,darr(i),status)

      RETURN

      END

	SUBROUTINE DEFINE_U_AGGREGATE_VAR (agg_dset, iset, nvars, vname, 
     .         fvar, itsa_uvar, nsets, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Save variable in the Union aggregation.  Check that the variable name
* is not already in the aggregation.

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - SDIG

* V7   5/12 *acm* Union aggregations: DEFINE DATA/AGG/U
* V710 *acm* 10/16 Ticket 2422: variables uvar_grid, uvar_data_type, uvar_aux_cat, 
*                  uvar_aux_var to be replaced with calls to LIST routines in NCF_Util.c 

      IMPLICIT NONE
        include 'tmap_errors.parm'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xdset_info.cd_equiv'
        include 'xprog_state.cmn'
	include 'xtm_grid.cmn_text'  
	include 'errmsg.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xfr_grid.cmn'
	include 'interp_stack.parm'
	include 'netcdf.inc'

* calling argument declarations:
	LOGICAL itsa_uvar
	INTEGER agg_dset, iset, nvars, fvar, nsets, status
	CHARACTER*(*) vname

* local variable declarations:
	INTEGER STR_SAME, TM_LENSTR1, DIR_LINE,
     .		big_cx, idim, nv, nu, type, slen, igrid, vtype, 
     .		i, num_indices, varid, iline, imemb, itype
	INTEGER igrid_test
	CHARACTER*48 TM_FMT, fset

* Is this variable already in the union aggregation? If so, do not add it.

      CALL CD_GET_VAR_ID (agg_dset, vname, varid, status)
      IF (varid .GT. 0) GOTO 5100

* ds_var slot, fill with next variable in Union dataset.
      IF (.NOT. itsa_uvar) THEN
	DO 720 nv = 1, maxvars
	      IF ( STR_SAME(ds_var_code(nv),char_init) .EQ. 0 ) GOTO 725
 720	CONTINUE
 725	ds_var_setnum(nv)   = agg_dset
	CALL string_array_modify(ds_var_code_head, nv, 
     .         ds_var_code(fvar), LEN(ds_var_code(fvar)))
! ?? better: inherit these attibutes from members in SET_AGG_VAR_ATTS
	ds_var_title(nv)    = ds_var_title(fvar)
	IF ( ds_var_title(nv) .EQ. char_init128) 
     .       ds_var_title(nv)  = ds_var_code(fvar)
	ds_var_titl_mod(nv) = ds_var_titl_mod(fvar)
	ds_var_units(nv)    = ds_var_units(fvar)
	ds_missing_flag(nv) = ds_missing_flag(fvar)	! was bad_val4
	ds_bad_flag(nv)     = ds_bad_flag(fvar)		! was bad_val4
	ds_var_type(nv)     = ds_var_type(fvar)
	cd_scale_factor(nv) = 1.
	cd_add_offset(nv)   = 0.
	cd_scaled(nv)       = .FALSE.

	DO 730 idim = 1, nferdims
	   ds_grid_start(idim,nv)= ds_grid_start(idim,fvar)
	   ds_grid_end(idim,nv)  = ds_grid_end(idim,fvar)
	   ds_ordering(idim,nv)  = ds_ordering(idim,fvar)
 730	CONTINUE
	ds_grid_number(nv)       = ds_grid_number(fvar)
	
* Type should be NCFLOAT or NCCHAR
	IF (ds_var_type(nv) .EQ. ptype_string) THEN
	   type = NCCHAR
	ELSE
	   type = NCFLOAT
	ENDIF

* Add the aggregated variable to the linked list structure
	CALL CD_ADD_VAR( agg_dset, vname, nvars, ds_var_title(nv), 
     .         ds_var_units(nv), type, .FALSE., ds_bad_flag(nv), status)

* Store the dataset number of this variable.

	   igrid = ds_grid_number(nv)
	   vtype = cat_file_var
	   imemb = nvars
	   iline = unspecified_int4
	   
	   CALL CD_GET_VAR_ID (iset, vname, varid, status)
	   CALL CD_ADD_AGG_VAR_INFO (agg_dset, vname, imemb, 
     .          vtype, iset, igrid, iline, fvar, status)

      ELSE ! done with file vars

* User Variables
* ... optimize search using deleted_list_get_undel

	CALL deleted_list_get_undel(uvar_num_items_head,
     .                              deleted_list_result(1),
     .                              max_uvar, num_indices )
	DO i = 1, num_indices
	   nu = deleted_list_result(i)
	   IF ( uvar_num_items(nu) .EQ. uvar_deleted) CYCLE
	   IF ( (uvar_dset(nu) .EQ. iset) .AND. 
     .         (STR_SAME(uvar_name_code(nu), vname) .EQ. 0) ) THEN
	      vtype = cat_user_var
	      
	      DO 740 nv = 1, maxvars
	      IF ( STR_SAME(ds_var_code(nv),char_init) .EQ. 0 ) EXIT ! from loop
 740	      CONTINUE
	      ds_var_setnum(nv)   = agg_dset
c	      ds_var_code(nv)     = uvar_name_code(nu)
	      CALL string_array_modify(ds_var_code_head, nv, 
     .                            uvar_name_code(nu), LEN(uvar_name_code(nu)))
	      ds_var_title(nv)    = uvar_title(nu)
	      IF ( ds_var_title(nv) .EQ. char_init128) 
     .            ds_var_title(nv)  = uvar_text(nu)    
	      IF ( ds_var_title(nv) .EQ. ' ') 
     .            ds_var_title(nv)  = uvar_text(nu)     
	      ds_var_titl_mod(nv) = ' '
	      ds_var_units(nv)    = uvar_units(nu)
	      ds_missing_flag(nv) = uvar_bad_data(nu)
	      ds_bad_flag(nv)     = uvar_bad_data(nu)

	      cd_scale_factor(nv) = 1.
	      cd_add_offset(nv)   = 0.
	      cd_scaled(nv)       = .FALSE.

	      CALL GET_UVAR_GRID( nu, iset, status )
	      CALL GET_SAVED_UVAR_GRID(nu, iset, igrid)

	      ds_grid_number(nv) = igrid
	      DO idim = 1, nferdims
	         iline = grid_line( idim, igrid )
	         ds_grid_start(idim,nv)= 1
	         ds_grid_end(idim,nv)  = line_dim(iline)
	         ds_ordering(idim,nv)  = DIR_LINE(line_direction(iline))
	      ENDDO
* Type  ??
	      
	      CALL GET_SAVED_UVAR_DTYPE(nu, iset, itype)
	      IF (itype .EQ. unspecified_int4) itype = ptype_unknown
	      ds_var_type(nv)  = itype

	      IF (ds_var_type(nv) .EQ. ptype_string) THEN
	         type = NCCHAR
	      ELSE
	         type = NCFLOAT
	      ENDIF

* Hook the aggregated variable into the linked list structures
	      CALL CD_ADD_VAR( agg_dset, vname, nvars, uvar_title(nu), 
     .         uvar_units(nu), type, .FALSE., uvar_bad_data(nu), status)

* Store the info of this variable. The member dataset stored is the 
* LET/D= datset where it was defined.

	      CALL GET_UVAR_GRID( nu, iset, status )
	      CALL GET_SAVED_UVAR_GRID(nu, iset, igrid)
	      vtype = cat_user_var
	      imemb = nvars
	      iline = unspecified_int4
	      
	      CALL CD_ADD_AGG_VAR_INFO (agg_dset, vname, imemb, 
     .          vtype, iset, igrid, iline, nu, status)

* ... bump the use count for this grid to protect it from being deleted if
*     the user changes the LET/D definition -- grid is needed during the
*     gather process (IS_STRIP & IS_AGGREGATE_GATHER).
*  ==> be sure to un-use (deallo) it when the aggregation gets canceled
*  ==> or if an error occurs prior to the complete initialization of this agg
	      CALL TM_USE_DYN_GRID(igrid)
	      EXIT
	   ENDIF
	ENDDO

	ENDIF  ! itsa_uvar 

 5000	RETURN
 5100	fset = TM_FMT(DBLE(iset), 0, 8, slen)
	CALL WARN('Variable '//vname(:TM_LENSTR1(vname))//
     .		' from dataset '//fset(:slen)//
     .		' is already in the union dataset. Skipping it')
	nvars = nvars - 1
	status = ferr_ok
	RETURN
	END

      SUBROUTINE CHECK(U,NAPTS,UMIN,UMAX)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)check.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     CALL CHECK(U,NPTS,UMIN,UMAX)
C
C     THIS SUBROUTINE CHECKS AN ARRAY OF FLOATING-POINT NUMBERS
C     AND RETURNS THE ALGEBRAIC MINIMUM AND MAXIMUM.
C
C     THE VARIOUS PARAMETERS AND THEIR DEFINITIONS ARE LISTED
C     BELOW:
C        U      - ARRAY CONTAINING THE FLOATING-POINT NUMBERS
C                 TO BE CHECKED.
C        NPTS   - NUMBER OF ENTRIES IN THE ARRAY.
C        UMIN   - MINIMUM VALUE IN THE ARRAY.
C        UMAX   - MAXIMUM VALUE IN THE ARRAY.
C
C
      DIMENSION U(1)
C
      IF(NAPTS .EQ. 0)RETURN
      NPTS = IABS(NAPTS)
C
C     INITIALIZE THE MINIMUM AND MAXIMUM TO THE FIRST ENTRY.
C
      UMIN = U(1)
      UMAX = U(1)
      IF(NPTS .EQ. 1)RETURN
C
C     CHECK THE REST OF THE ENTRIES FOR ALGEBRAICALLY SMALLER
C     AND LARGER VALUES.
C
      DO 10 I=2,NPTS
      IF(U(I) .LT. UMIN)UMIN = U(I)
   10 IF(U(I) .GT. UMAX)UMAX = U(I)
      RETURN
C
      END

*
* findhi.F
*
* Ansley Manke
* July 02, 2001
*
* This function locates local extrema, returning "highs".
*
* 1/21/01 change order of axes: result is on X axis, J index
*         gives component of result (x,y,z)
*         And change arguments 2 and 3 to RANGE rather than # Grid cells
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE findhi_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      CHARACTER*120 fcn_descr

      WRITE (fcn_descr,100) 
      CALL ef_set_desc(id, fcn_descr)
  100 FORMAT('Find local maxima of var, return',
     .        ' HIGHS on X axis. j=1 xpos,j=2 ypos,j=3 HI value')

      CALL ef_set_num_args(id, 3)
      CALL ef_set_axis_inheritance(id, ABSTRACT, ABSTRACT, 
     .			IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)

      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 4)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 'var in X, Y and optionally Z, T')
      CALL ef_set_axis_influence(id, arg, NO, NO, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'XRANGE')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 
     .'Find local maxima in neighborhood +- XRANGE, data units')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'YRANGE')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 
     .'Find local maxmia in neighborhood +- YRANGE, data units')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE findhi_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER my_lo, my_hi, nx, ny

      INTEGER arg
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

*
*     Use utility functions to get context information about the argument.
*

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      CALL ef_set_axis_limits(id, Y_AXIS, 1, 3)

      my_lo = 1
      my_hi = 1

      arg = 1
      nx = arg_hi_ss(X_AXIS,arg) - arg_lo_ss(X_AXIS,arg) + 1
      ny = arg_hi_ss(Y_AXIS,arg) - arg_lo_ss(Y_AXIS,arg) + 1
      my_hi = nx* ny	! an absolute upper bound

      CALL ef_set_axis_limits(id, X_AXIS, my_lo, my_hi)
      my_lo = 1
      my_hi = 1

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE findhi_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_dims(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER mx1, my1, mxy, mydim

      INTEGER iwork
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      mx1 = 1 + arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1)
      my1 = 1 + arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1)

      mydim = 3
      mxy = mx1 * my1

*  xyfield
      iwork = 1
      CALL ef_set_work_array_dims (id, iwork, 1, 1, 1, 1, 
     .   mx1, my1, 1, 1)

*  zmaxlist
      iwork = 2
      CALL ef_set_work_array_dims (id, iwork, 1, 1, 1, 1, 
     .   mydim, mxy, 1, 1)

*  xax
      iwork = 3
      CALL ef_set_work_array_dims (id, iwork, 1, 1, 1, 1, 
     .   2*mx1, 1, 1, 1)

*  yax
      iwork = 4
      CALL ef_set_work_array_dims (id, iwork, 1, 1, 1, 1, 
     .   2*my1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE findhi_compute(id, arg_1, arg_2, arg_3, result, 
     .                          xyfield, zmaxlist, xax, yax)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

	  INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, 
     .           mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, 
     .           mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l, i1,j1, k1, l1, arg, nx, ny, nzmax, ip, jp,
     .        neigh_x, neigh_y
      REAL    dx, dy, xrange, yrange

*  Dimension the work arrays.

      REAL xyfield(wrk1lox:wrk1hix, wrk1loy:wrk1hiy,
     .               wrk1loz:wrk1hiz, wrk1lot:wrk1hit)
      REAL zmaxlist(wrk2lox:wrk2hix, wrk2loy:wrk2hiy,
     .               wrk2loz:wrk2hiz, wrk2lot:wrk2hit)
      REAL*8 xax(wrk3lox:wrk3hix/2, wrk3loy:wrk3hiy,
     .               wrk3loz:wrk3hiz, wrk3lot:wrk3hit)
      REAL*8 yax(wrk4lox:wrk4hix/2, wrk4loy:wrk4hiy,
     .               wrk4loz:wrk4hiz, wrk4lot:wrk4hit)

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)


*  Get the axis coordinates
      arg = 1
      CALL ef_get_coordinates(id, arg, X_AXIS, arg_lo_ss(X_AXIS,arg),
     .   arg_hi_ss(X_AXIS,arg), xax)
      CALL ef_get_coordinates(id, arg,Y_AXIS, arg_lo_ss(Y_AXIS,arg),
     .   arg_hi_ss(Y_AXIS,arg), yax)

      nx = arg_hi_ss(X_AXIS,arg) - arg_lo_ss(X_AXIS,arg) + 1
      ny = arg_hi_ss(Y_AXIS,arg) - arg_lo_ss(Y_AXIS,arg) + 1

      dx = xax(2,1,1,1) - xax(1,1,1,1)
      dy = yax(2,1,1,1) - yax(1,1,1,1)

*  Get the parameters neigh_x, neigh_y, to determine the region in which relative 
*  mins are found: 
C A RELATIVE MINIMUM (OR MAXIMUM) IS DEFINED TO BE THE LOWEST (OR HIGHEST) 
C POINT WITHIN A CERTAIN NEIGHBORHOOD OF THE POINT.  THE NEIGHBORHOOD USED 
C HERE IS + OR - neigh_x IN THE X DIRECTION AND + OR - neigh_y IN THE Y 
C DIRECTION

      CALL ef_get_one_val (id, ARG2, xrange)
      neigh_x = MAX(1, INT (xrange/dx))
      CALL ef_get_one_val (id, ARG3, yrange)
      neigh_y = MAX(1, INT (yrange/dy))

*  For each level and each time, call maxminmax to get the maxima.
*  Determine the coordinates of the max's and put with the max value
*  into the result

      k1 = arg_lo_ss(Z_AXIS,ARG1)
      DO 400 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

         l1 = arg_lo_ss(T_AXIS,ARG1)
         DO 300 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

            j1 = arg_lo_ss(Y_AXIS,ARG1)
	    DO 200 j = 1, ny
               i1 = arg_lo_ss(X_AXIS,ARG1)
               DO 100 i = 1, nx
                  xyfield(i,j,1,1) = arg_1(i1,j1,k1,l1)
                  i1 = i1 + arg_incr(X_AXIS,ARG1)
  100          CONTINUE
               j1 = j1 + arg_incr(Y_AXIS,ARG1)
  200       CONTINUE

            CALL MAXMINMAX (xyfield, nx, nx, ny, neigh_x, neigh_y, 
     .                      bad_flag(ARG1), zmaxlist, nzmax)

C  result(i,1,k,l) = X index of max
C  result(i,2,k,l) = Y index of max
C  result(i,3,k,l) = z value at max

            DO 210 i = 1, nzmax
               ip = INT(zmaxlist(1,i,1,1))
               jp = INT(zmaxlist(2,i,1,1))
               result(i,1,k,l) = xax(ip,1,1,1)
               result(i,2,k,l) = yax(jp,1,1,1)
               result(i,3,k,l) = zmaxlist(3,i,1,1)
 210        CONTINUE

C  Fill end of result with missing-data flags

            DO 230 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
               DO 220 i = nzmax+1, res_hi_ss(X_AXIS)
                  result(i,j,k,l) = bad_flag_result
 220           CONTINUE
 230        CONTINUE

            l1 = l1 + arg_incr(T_AXIS,ARG1)
 300     CONTINUE

         k1 = k1 + arg_incr(Z_AXIS,ARG1)
 400  CONTINUE
      
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

      SUBROUTINE set_open_levels
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or 'bug fixes'.
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP 'AS IS' AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* V630  *acm* 9/09 Introduction of syntax for variance-based and histogram levels
* V65 *acm   2/10 If Open-ended levels were used, symbol LEV_OPNLEVS saves 
* the /LEV command needed to duplicate the levels
* v663 *acm* 7/10 Fix bug where min value was not inside the lowest level.
* v671 *acm* 6/11 For centered levels if there is (-inf) force (inf) and vice versa.
* v673 *acm* 10/11 Fix cut-and-paste bug on first setting of nlev3.
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus

      include 'parampl5_dat.decl'
      include 'PARAMPL5.DAT'
      include 'axis_inc.decl'
      include 'AXIS.INC'
      include 'plt_inc.decl'
      include 'PLT.INC'
      include 'miss_inc.decl'
      include 'MISS.INC'
      include 'hd_inc.decl'
      include 'HD.INC'
      include 'cont_inc.decl'
      include 'CONT.INC'
      include 'errmsg.parm'

      LOGICAL         TM_FPEQ_SNGL
      REAL    dz, fm, znp, zmp, dzf, znpf, zmpf, 
     .        znpclo,zmpclo, dzc, dzclo, dzchi, 
     .        twostd, density_factor
      INTEGER TM_LENSTR1, m, jj, nlevf, nlevc, nlev3, half_ncoarse, 
     .        slen, llen, dlen, hlen, if1, if2, i, k

      CHARACTER*10 TM_FMT_SNGL, lo_str, del_str, hi_str

      EXTERNAL RANGE

      IF (USE_HIST) THEN  ! compute levels based on histograms.
        GOTO 3000
      ENDIF

! (approx) number of fine and coarse levels.

      nlevf = 0.8* nlev
      nlevc = MAX(0.1*FLOAT(nlev), 1.)

      IF (centered) THEN

	 twostd = 2.* zstd
	 znp = -1*twostd
	 zmp = twostd
	 CALL RANGE(znp,zmp,nlevf,znpf,zmpf,dzf)  ! fine levels

! Create centered fine levels surrounded by centered coarse levels.

         density_factor = 4.
         dzc = dzf* density_factor
	 half_ncoarse = nlevc/2

	 znpclo = lev_mean + znpf - dzc* half_ncoarse
	 zmpclo = lev_mean + znpf
	 znpchi = lev_mean + zmpf
	 zmpchi = lev_mean + zmpf + dzc* half_ncoarse

         IF (zmax .LT. znpclo  .OR.  zmin .GT. zmpchi) THEN

	    zmp = 0.6* MAX( ABS(zmin), ABS(zmax) )
	    znp = -1* zmp
	    CALL RANGE(znp,zmp,nlevf,znpf,zmpf,dzf)  ! fine levels

! Create centered fine levels surrounded by centered coarse levels.

            density_factor = 4.
            dzc = dzf* density_factor
	    half_ncoarse = nlevc/2

	    znpclo = lev_mean + znpf - dzc* half_ncoarse
	    zmpclo = lev_mean + znpf
	    znpchi = lev_mean + zmpf
	    zmpchi = lev_mean + zmpf + dzc* half_ncoarse

         ENDIF

      ELSE  ! not centered

         znp = zmean - zstd
         zmp = zmean + zstd

         CALL RANGE(znp,zmp,nlevf,znpf,zmpf,dzf)  ! fine levels

         znp = zmean - 2.* zstd
         zmp = zmean - zstd
         IF (znp .LT. zmin) znp = zmin
         IF (zmp .LT. zmin) zmp = znpf
         CALL RANGE(znp,zmp,nlevc,znpclo,zmpclo,dzclo)  ! coarse levels

         znp = zmean + zstd
         zmp = zmean + 2.* zstd
         IF (zmp .GT. zmax) zmp = zmpf
         IF (znp .GT. zmax) znp = zmax
         CALL RANGE(znp,zmp,nlevc,znpchi,zmpchi,dzchi)  ! coarse levels
         dzc = (dzclo + dzchi)/ 2  ! are they always equal??

      ENDIF  ! centered or not centered

      lev_str = ' '
      slen = 0

c Set jj as in plotz based on fine levels.
      
      IF (zmpf-znpf .EQ. 0) then
         jj = nsigc
      ELSE
         jj = nsigc - IFIX(ALOG10(ABS(zmpf-znpf)) + .5)
      ENDIF 
      IF (jj .LE. 0) jj= -1

      ! -inf
      IF (zmin .LT. znpclo) THEN
         neginf = .TRUE.
         ilev = 2
	 lev_str = '(-inf)'
	 slen = 6
      ELSE 
         ilev = 1
      ENDIF

      nlev2 =1 

      nlev3 = NINT((zmpclo-znpclo)/ dzc) + 1
      nlev2 = nlev2 + nlev3

      do 101 i = 1, nlev3 

         ldig(ilev) = -1
         zlev(ilev) = znpclo + dzc* FLOAT(i-1)
         IF (zlev(ilev) .GT. znpf) goto 102

         ldig(ilev) = jj
	 IF (centered) THEN
	    ilev = ilev + 1
         ELSE
	    IF (zlev(ilev) .GT. zmax) GOTO 2000

         IF (zlev(ilev)+ dzc* FLOAT(i) .GE. zmin) 
     .	    ilev = ilev + 1
         ENDIF

 101  CONTINUE 
 102  CONTINUE 

      IF (neginf) THEN
         zlev(1) = MIN( zlev(2), zmin-1. )
         ldig(1) = ldig(2)
      ENDIF

      nlev3 = NINT((zmpf-znpf)/ dzf) + 1
      nlev2 = nlev2 + nlev3

      IF (zlev(ilev-1) .GT. znpf) ilev = ilev - 1
      IF (ilev.GT.1 .AND. zlev(ilev-1).GT.znpf) ilev = ilev - 1

      i1 = 1
      IF (ilev .GT. 1) THEN
         zlev(ilev) = znpf + dzf* FLOAT(i1-1)
         DO WHILE ((zlev(ilev) .LT. zlev(ilev-1)) ) 
	    i1 = 2
	    zlev(ilev) = znpchi + dzc* FLOAT(i1-1)
	 ENDDO
      ENDIF 

      IF (zlev(1) .GT. znpf) THEN
	 ilev = 1
	 i1 = 2
      ENDIF

      lo_str = TM_FMT_SNGL(znpclo, 3, 10, llen)
      del_str = TM_FMT_SNGL(dzc, 3, 10, dlen)
      IF (ilev .GT. 1) THEN
         hi_str = TM_FMT_SNGL(zlev(ilev-1), 3, 10, hlen)
      ELSE
         hi_str = TM_FMT_SNGL(zlev(ilev), 3, 10, hlen)
	 IF (zlev(ilev) .EQ. 0) hi_str = 
     .         TM_FMT_SNGL(zlev(ilev-1), 3, 10, hlen)
      ENDIF
      lev_str = lev_str(:slen)//'('//lo_str(:llen)//
     .          ','//hi_str(:hlen)//','//del_str(:dlen)//')'
      slen = TM_LENSTR1(lev_str)
      if1 = ilev

      DO 103 i=i1,nlev3 

         ldig(ilev) = -1
         zlev(ilev) = znpf + dzf* FLOAT(i-1)
         IF (zlev(ilev) .GT. znpchi) goto 104

         ldig(ilev) = jj

	 IF (centered) THEN
	    ilev = ilev + 1
         ELSE
	    IF (zlev(ilev) .GT. zmax) GOTO 2000

         IF (zlev(ilev)+ dzf* FLOAT(i) .GE. zmin) 
     .	    ilev = ilev + 1
         ENDIF

 103  CONTINUE 
 104  CONTINUE 

* If min is still less than the lowest lev, add an open level
* at the start of the list.

      IF (zlev(1) .GT. zmin) THEN
         neginf = .TRUE.
	 DO i = ilev, 2, -1
	    zlev(i) = zlev(i-1)
	    ldig(i) = ldig(i-1)
	 ENDDO
	 
         zlev(1) = zmin-1.
	 ilev = ilev + 1
      ENDIF
      nlev3 = NINT((zmpchi-znpchi)/ dzc) + 1
      nlev2 = nlev2 + nlev3

      IF (zlev(ilev-1) .GT. znpchi) ilev = ilev - 1
      IF (zlev(ilev-1) .GT. znpchi) ilev = ilev - 1

      if2 = ilev
      IF (centered) if2 = ilev-1
      lo_str = TM_FMT_SNGL(zlev(if1), 3, 10, llen)
      del_str = TM_FMT_SNGL(dzf, 3, 10, dlen)
      hi_str = TM_FMT_SNGL(zlev(if2), 3, 10, hlen)
      IF (zlev(if2) .EQ. 0.) hi_str = TM_FMT_SNGL(zlev(if2-1), 3, 10, hlen)
      lev_str = lev_str(:slen)//'('//lo_str(:llen)//
     .          ','//hi_str(:hlen)//','//del_str(:dlen)//')'
      slen = TM_LENSTR1(lev_str)
      if1 = ilev

      i1 = 1
      IF (ilev .GT. 1) THEN
         zlev(ilev) = znpchi + dzc* FLOAT(i1-1)
         DO WHILE ((zlev(ilev) .LT. zlev(ilev-1)) ) 
	    i1 = 2
	    zlev(ilev) = znpchi + dzc* FLOAT(i1-1)
	 ENDDO
      ENDIF 

      DO 105 i=i1,nlev3 

         ldig(ilev) = -1
         zlev(ilev) = znpchi + dzc* FLOAT(i-1)
         ldig(ilev) = jj

	 IF (centered) THEN
	    ilev = ilev + 1
	 ELSE
	    IF (zlev(ilev) .GT. zmax) GOTO 2000

            IF (zlev(ilev)+ dzc* FLOAT(i) .GE. zmin) 
     .	       ilev = ilev + 1
         ENDIF

 105  CONTINUE 

 2000 CONTINUE

      lo_str = TM_FMT_SNGL(zlev(if1), 3, 10, llen)
      del_str = TM_FMT_SNGL(dzc, 3, 10, dlen)
      hi_str = TM_FMT_SNGL(zlev(ilev-1), 3, 10, hlen)
      IF (zlev(ilev-1) .EQ. 0) 
     .          hi_str = TM_FMT_SNGL(zlev(ilev-2), 3, 10, hlen)
      lev_str = lev_str(:slen)//'('//lo_str(:llen)//
     .          ','//hi_str(:hlen)//','//del_str(:dlen)//')'
      slen = TM_LENSTR1(lev_str)
      if1 = ilev

* If needed then add (inf)
* If centered and there is (-inf) then add (inf)

      nlev2 = ilev
      IF ((zmax .GT. zmpchi) .OR. (centered .AND. neginf)) THEN
         posinf = .TRUE.
         zlev(nlev2) = MAX (zlev(nlev2-1)+1, zmax + 1. )
	 lev_str = lev_str(:slen)//'(inf)'
         slen = TM_LENSTR1(lev_str)
      ELSE   
         zlev(nlev2) = zmpchi
      ENDIF

      IF ((centered .AND. posinf) .AND.(.NOT.neginf)) THEN
         neginf = .TRUE.
	 DO 106 i = nlev2, 1, -1
           ldig(i+1) = ldig(i)
           zlev(i+1) = zlev(i)
 106     CONTINUE 
	 nlev2 = nlev2 + 1
	 zlev(1) =  MIN (zlev(1)-1, zmin - 1. )
	 lev_str = '(-inf)'//lev_str(:slen)
         slen = TM_LENSTR1(lev_str)
      ENDIF

      ldig(nlev2) = ldig(nlev2-1)

      IF (centered .AND. (.NOT.posinf)) THEN
         IF (zlev(nlev2) .EQ. zlev(nlev2-1)) THEN
	    ilev = ilev - 1
	    nlev2 = nlev2 - 1
	 ENDIF
      ENDIF

* if centered and there is (inf) then add (-inf) if its not there.

      IF ( (centered .AND. posinf) .AND. (.NOT.neginf) ) THEN
         DO 107 i=ilev,1,-1
            ldig(i+1) = ldig(i)
            zlev(i+1) = zlev(i)
 107     CONTINUE 
         ilev = ilev + 1
	 nlev2 = ilev
	 neginf = .TRUE.
	 lev_str = '(-inf)'//lev_str(:slen)
         slen = TM_LENSTR1(lev_str)
      ENDIF

* If a min or max was explicitly set, then chop off the 
* levels with that setting.

 3000 CONTINUE
      IF (set_min) THEN
         neginf = .FALSE.
         IF (lev_min .LT. zlev(1)) THEN
            zlev(1) = lev_min
         ELSE
            index = 1
            DO i = nlev2, 1, -1
               IF (lev_min .LE. zlev(i)) index = i
            ENDDO
            IF (index .GT. 1) THEN
               DO 108 i = index, nlev2
                  zlev(i-index+1) = zlev(i)
                  ldig(i-index+1) = ldig(i)
 108           CONTINUE 
               nlev2 = nlev2-index+1
            ENDIF
         ENDIF
      ENDIF

      IF (set_max) THEN
         posinf = .FALSE.
         IF (lev_max .LT. zlev(nlev2)) THEN
            zlev(nlev2) = lev_max
         ELSE
            index = nlev2
            DO i = 1, nlev2
                  IF (lev_max .GE. zlev(i)) index = i
            ENDDO
            IF (index .LT. nlev2) nlev2 = index
         ENDIF
      ENDIF

* Remove duplicate levels
      levcount = nlev2
      zlast = zlev(1)
      do 530 i = 2, nlev2 
         IF ( TM_FPEQ_SNGL(zlev(i), zlast) .AND. i.LT.levcount ) THEN
            do 520 k = i,levcount
               zlev(k-1) = zlev(k)
               ldig(k-1) = ldig(k)
 520        CONTINUE
            levcount = levcount-1
         ENDIF
         zlast = zlev(i)
 530  CONTINUE
      nlev2 = levcount

* Finally, because of rounding when computing nlev3, when making centered 
* levels there can still be different numbers of levels above and below 
* zero. Force centered levels.

      IF (centered) THEN
         i1 = 1
	 i2 = nlev2
	 IF (neginf) i1 = 2
	 IF (posinf) i2 = nlev2-1
	 IF (.NOT. TM_FPEQ_SNGL(ABS(zlev(i1)), zlev(i2) ) ) THEN
	    IF (ABS(zlev(i1)) .GT. zlev(i2)) THEN
	       DO 109 i = nlev2+1, i2+1, -1
	         zlev(i) = zlev(i-1)
                 ldig(i) = ldig(i-1)
 109	       CONTINUE
	       zlev(nlev2) = ABS(zlev(i1))
               ldig(nlev2) = ldig(i1)
	    ELSE
	       DO 110 i = nlev2+1, i1, -1
	         zlev(i) = zlev(i-1)
                 ldig(i) = ldig(i-1)
 110	       CONTINUE
	       zlev(nlev2) = -1.*zlev(i2)
	       ldig(nlev2) = ldig(i2)

	    ENDIF
	    nlev2 = nlev2 + 1
	 ENDIF
      ENDIF

* Set lwgt - as in lev.F
      DO 111 i = 1, nlev2
         IF (zlev(i).GT.0.) THEN
            lwgt(i) = 1
         ELSE
            lwgt(i) = 3
         ENDIF
	 IF (TM_FPEQ_SNGL(zlev(i), 0.)) lwgt(i) = 2 
 111  CONTINUE

      RETURN
      END

        PROGRAM DRWFNT
        CHARACTER FONT(21)*2,NUM*6,STR*4,NAME(21)*30,NME*30
        CHARACTER NA*7
        DATA FONT/'SR','DR','TR','CR','AS','AC','CS','TI','GE',
     *  'IR','SS','CI','II','SG','CG','IG','GG','GI',
     *  'CC','AR','AG'/
        DATA NAME/'Simplex Roman','Duplex Roman','Triplex Roman',
     *  'Complex Roman','ASCII Simplex Roman','ASCII Complex Roman',
     *	'Complex Script','Triplex Italic',
     *  'Gothic English','Indexical Complex Roman',
     *  'Simplex Script','Complex Italic',
     *  'Indexical Complex Italic','Simplex Greek','Complex Greek',
     *  'Indexical Complex Greek','Gothic German','Gothic Italian',
     *  'Complex Cyrillic','Cartographic Roman',
     *  'Cartographic Greek'/
        DATA NA/'@SRn.a.'/
        CALL PLTYPE(0)
        CALL SIZE(10.5,8.2)
        SZE=0.21
        DO 100 IFNT=21,1,-1
        CALL ERASE
C
C       DRAW BOX
C
        X=5.5
        Y1=8.25
        Y2=0.25
        DO 110 I=1,7
        CALL PLOT(Y1,X,0,0)
        CALL PLOT(Y2,X,1,0)
        X=X-0.75
        IF(Y1.EQ.0.25)THEN
                Y2=Y1
                Y1=8.25
        ELSE
                Y2=Y1
                Y1=0.25
        ENDIF
110     CONTINUE
        Y=8.25
        X1=5.5
        X2=1.0
        DO 120 I=1,17
        CALL PLOT(Y,X1,0,0)
        CALL PLOT(Y,X2,1,0)
        Y=Y-0.5
        IF(X1.EQ.1.0)THEN
                X2=X1
                X1=5.5
        ELSE
                X2=X1
                X1=1.0
        ENDIF
120     CONTINUE
C
C       DRAW CHARACTERS
C
        WRITE(STR,999)FONT(IFNT)
999     FORMAT('@',A2)
        WRITE(NME,997)NAME(IFNT)
997     FORMAT('@SR',A25)
        CALL SYMBEL(8.35,5.5,-90.0,.14,28,NME)
        DO 130 I=1,6
        DO 130 J=1,16
        ICH=(I-1)*16+J+31
        X=5.5-(I-1)*0.75
        Y=8.25-J*0.5
        IF((IFNT.NE.5.AND.IFNT.NE.6).AND.
     *	    (ICH.EQ.92.OR.ICH.EQ.94.OR.ICH.EQ.95.OR.ICH.EQ.64))THEN
                S=X-0.375+SYMWID(.10,7,NA)*0.5
                CALL SYMBEL(Y+0.2,S,-90.,.10,7,NA)
        ELSE
                STR(4:4)=CHAR(ICH)
                WRITE(NUM,998)ICH
998             FORMAT('@SR',I3)
                CALL SQUISH(NUM,1,6)
                CALL SYMBEL(Y+0.4,X-0.02,-90.,0.07,6,NUM)
                S=X-0.37+SYMWID(SZE,4,STR)*0.5
                CALL SYMBEL(Y+0.15,S,-90.,SZE,4,STR)
        ENDIF
130     CONTINUE
        CALL PLTEND
100     CONTINUE
        CALL EXIT
        END

	SUBROUTINE TM_MAKE_NEW_DYN_GRID ( ingrid, outgrid,  status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
** V7.2 *acm* 4/2017 
* Rreate a new dynamic grid and copy the definition of ingrid to it.
* Returns "outgrid" with the number of the new dynamic grid.
* This is used for the new class of direction-changing functions as a subset 
* of grid-changing fcns. An entirely grid is defined for these at grid 
* initialization time; it will be changed according to the function and the
* directions chosen in the function call.

* Arguments
	INTEGER	 ingrid, outgrid, status
*
* INCLUDE FILES
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'tmap_errors.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data

	CALL TM_ALLO_DYN_GRID( outgrid, status )
	IF (status .NE. merr_ok) GOTO 9000
	CALL TM_COPY_GRID_W_LINE_USE( ingrid, outgrid )

* name it "(Gnnn)"
	WRITE ( grid_name(outgrid), 3000 ) outgrid - max_grids
 3000	FORMAT('(G',I3.3,')')		! restricted to 3 digits

* successful completion
	status = merr_ok
 9000	RETURN
	END

      SUBROUTINE setlab_syms (zlevels, nlevels)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or 'bug fixes'.
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP 'AS IS' AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*  v5.5  *acm* 11/2002 New symbols to save levels
* v552 *acm* 3/03 Longer strings: changes for multi-line labels.
* V581 *acm* 3/05 fix bug 1205: If delta was set by user (with SHADE/LEV=.4d), then 
*                 use the given delta rather than trying to compute it for LEV_DEL
* V62 *acm*  5/08 Fix bug 1581. NLEV used is acutally one less
* V65 *acm   2/10 If Open-ended levels were used, symbol LEV_OPNLEVS saves 
* the /LEV command needed to duplicate the levels
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long
* V698 *acm*  2/16 Fix the LEV_DEL computation which was wrong for irregular levels.
*                  Clear out-of-date symbols, for variance-based or histogram
*                  levels on previous plots
* V720 *acm*  7/17 Ticket 2250: precision errors when data has very small values
* V74+  *acm* 3/18 Issue 1607.  /KEY=centerlab
* V74+  *acm* 6/18 Add the symbol LEV_ALL for a list of all levels used
* V751  *acm* 6/19 Changes to TM_FMT. Clean off excess .00 from the strings

*    LEV_MIN  - lowest level used on last CONTOUR, SHADE, or FILL call.
*    LEV_MAX -  highest level used last
*    LEV_DEL - either the value or 'irregular'
*    LEV_NUM - Number of levels used
*    LEV_ALL - list of all the levels used

*    (LEV_TEXT - full text string of last levels used, set in routine LEV.F)

	include 	'parampl5_dat.decl'
	include 	'PARAMPL5.DAT'
	include		'cont_inc.decl'
	include		'CONT.INC'
        include         'shade_vars.cmn'

* Calling argument declarations

      REAL zlevels(*)
      INTEGER nlevels

* Internal arguments

      REAL zmax, zmin, dz, diff, eps
      REAL*8 zmaxD, zminD

      CHARACTER ppl_buff*2048, TM_FMT_SNGL_TRIM*48, TM_FMT_TRIM*48, 
     .          buff*10, symbuff*30, buffmin*10, buffmax*10, 
     .         comma*2

     
	CHARACTER symbuff30*30, title*32

      INTEGER TM_LENSTR1, STR_SAME, i, ier, ilen, slen, nc, nl
      LOGICAL TM_FPEQ_EPS_SNGL, reglevs

* Lowest and highest Z level

      zmin = zlevels(1)
      buffmin = TM_FMT_SNGL_TRIM(zmin, -2, 10, slen)
      IF (neginf) buffmin = 'open-ended'

      zmax = zlevels(nlevels)
      buffmax = TM_FMT_SNGL_TRIM(zmax, -2, 10, slen)
      IF (posinf) buffmax = 'open-ended'

* An epsilon for equal-sized deltas, need not be too tight a test
      eps = 0.01* (zmax - zmin)/FLOAT(nlevels)

      IF ( STR_SAME(buffmin, buffmax).EQ.0 .AND. .NOT.neginf .AND.
     .    .NOT.TM_FPEQ_EPS_SNGL(eps, zmin, zmax) ) THEN
	 zminD = zmin
         zmaxD = zmax 
	 buffmin = TM_FMT_TRIM(zminD, 4, 10, slen)
	 buffmax = TM_FMT_TRIM(zmaxD, 4, 10, slen)
      ENDIF

      ppl_buff = 'LEV_MIN '//buffmin
      ilen = TM_LENSTR1(ppl_buff)
      ier = 0
      ist = 0
      CALL SETSYM (ppl_buff, ilen, ier, ist)


      ppl_buff = 'LEV_MAX '//buffmax
      ilen = TM_LENSTR1(ppl_buff)
      ier = 0
      ist = 0
      CALL SETSYM (ppl_buff, ilen, ier, ist)

* Number of levels used 

      zmax = MAX(nlevels-1,1)
      buff = TM_FMT_SNGL_TRIM(zmax, -2, 10, slen)

      ppl_buff = 'LEV_NUM '//buff
      ilen = TM_LENSTR1(ppl_buff)
      ier = 0
      ist = 0
      CALL SETSYM (ppl_buff, ilen, ier, ist)
      
* If set_delta is .true. the delta value has been set
* elsewhere. use the delta given.

      IF (set_delta) THEN
	 dz = delta
         buff = TM_FMT_SNGL_TRIM(dz, -2, 10, slen)

* Otherwise, check if levels are regularly spaced 

      ELSE


         dz = zlevels(2) - zlevels(1)
      
         IF (nlevels .EQ. 1) THEN
            buff = 'none'
         ELSE IF (nlevels .EQ. 2) THEN
            buff = TM_FMT_SNGL_TRIM(dz, -2, 10, slen)
         ELSE
            reglevs = .TRUE.
            DO 100 i=3,nlevels
               diff = ABS( zlevels(i)-zlevels(i-1) )
               reglevs = TM_FPEQ_EPS_SNGL(eps, diff, dz)
	       IF (.NOT.reglevs) GOTO 110
  100       CONTINUE
  110       IF (reglevs) THEN
               buff = TM_FMT_SNGL_TRIM(dz, -2, 10, slen)
            ELSE
               buff = 'irregular'
            ENDIF
         ENDIF

      ENDIF

      IF (STR_SAME(buff, '0') .EQ. 0 .AND. reglevs) THEN
	 zminD = zlevels(1)
         zmaxD = zlevels(2)
	 zminD = zmaxD - zminD
	 buff = TM_FMT_TRIM(zminD, 4, 10, slen)
      ENDIF

      ppl_buff = 'LEV_DEL '//buff
      ilen = TM_LENSTR1(ppl_buff)
      ier = 0
      ist = 0
      CALL SETSYM (ppl_buff, ilen, ier, ist)
 
* If Open-ended levels were used, symbol LEV_OPNLEVS saves the /LEV 
* command needed to duplicate the levels

      symbuff = 'LEV_OPNLEVS'
      CALL GETSYM( symbuff, ppl_buff, ist, ier )
      IF ( ier .EQ. 0 ) THEN
         IF (STR_SAME(lev_str, 'none').EQ.0 .OR. 
     .       STR_SAME(lev_str, 'histogram').EQ.0) THEN 
            CALL DELSYM(symbuff,ier)
	 ENDIF
      ENDIF

      IF (STR_SAME(lev_str, 'none').NE.0 .AND. 
     .    STR_SAME(lev_str, 'histogram').NE.0) THEN
         ilen = TM_LENSTR1(lev_str)
         ppl_buff = 'LEV_OPNLEVS '//lev_str
         ilen = TM_LENSTR1(ppl_buff)
         ier = 0
         ist = 0
         CALL SETSYM (ppl_buff, ilen, ier, ist)
      ENDIF


* Were the levels specified as /KEY=CENTERLAB?

      IF (center_key_labels) THEN 
         ppl_buff = 'LEV_CENTERED_LABELS on'
      ELSE
         ppl_buff = 'LEV_CENTERED_LABELS off'
      ENDIF 
      ilen = TM_LENSTR1(ppl_buff)
      ier = 0
      ist = 0
      CALL SETSYM (ppl_buff, ilen, ier, ist)

* A list of all the levels
     
      symbuff = 'LEV_ALL'
      CALL GETSYM( symbuff, ppl_buff, ist, ier )
      IF ( ier .EQ. 0 ) CALL DELSYM(symbuff,ier)

      ppl_buff = 'LEV_ALL '
      ilen = 13
      comma = ','
      nc = 1
      DO i=1, nlevels
         IF (i .EQ. nlevels) THEN
	    comma = ' '
	    nc = 1
	 ENDIF
         zminD = zlevels(i)
	 buff = TM_FMT_TRIM(zminD, 4, 10, slen)
	 ppl_buff = ppl_buff(:ilen+1)//buff(:slen)//comma

	 ilen = ilen + slen + nc
      ENDDO
      ier = 0
      ist = 0
      CALL SETSYM (ppl_buff, ilen, ier, ist)


* Delete any LEV_HISTO_LEVELS symbol that may be left over from a previous plot

      IF (.NOT. USE_HIST) THEN
         symbuff = 'LEV_HISTO_LEVELS'
         CALL GETSYM( symbuff, ppl_buff, ist, ier )
         IF (ier .EQ. 0) CALL DELSYM(symbuff,ier)
      ENDIF

      RETURN
      END

	SUBROUTINE BOXES_DSG (orientation, flen, unit, 
     .		dsgcoords, latitudes, box)

        INCLUDE 'tmap_dims.parm'
	INCLUDE	'ferret.parm'

	INTEGER orientation, flen
	REAL	unit, dsgcoords(*), latitudes(*), box(*)

* orientation - is the dsg-grid orientation
* flen        - is the lenght of this feature
* dsgcoords   - are the coordinates in the dsg-orientation direction: longitudes
*               for trajectory datasets, depth/alt for profiles, time for timeseries
* latitudes   - for trajectories, the latitude data, otherwise unused.
* box         - box-sizes, returned 
* 

* Local declarations
	INTEGER i
	REAL	coord, cnext, upper, lower, km2m
	CHARACTER*80 errstr


	IF (flen .EQ. 1) THEN
	   box(1) = 0.
	   GOTO 5000
	ENDIF

* Weighted computation:
*   For trajectories the distance along the lon-lat line between points
*   and integrals with great-circle-distance weighting. For integrals,
*   convert to meters.
*   In Z and T use distance between, constructing a box

	IF ( (orientation .EQ. x_dim) ) THEN

* EARTH_DEL routine returns distance in Km, return units of meters if units are used.
	   km2m = 1000.
 
	   CALL EARTH_DEL( dsgcoords, latitudes, flen, 
     .                     bad_val4, bad_val4, box, errstr)
	   box(1) = box(2)
	   IF (unit .NE. 1.) unit = km2m
	      
	ELSE

* Get and save box sizes for all feature coordinates
* Profile coords may run lowest to highest so use ABS

	   coord = dsgcoords(1)
	   cnext = dsgcoords(2)
	   box(1) = ABS(cnext-coord)  
	   lower = (cnext+coord)/2

	   DO i = 2, flen - 1
	      coord = dsgcoords(i)
	      cnext = dsgcoords(i+1)

	      upper = (cnext+coord)/2
	      box(i) = ABS(upper-lower)  

	      lower = upper
	   ENDDO
           box(flen) = ABS(cnext - coord)  

	ENDIF

 5000	RETURN
	END

	SUBROUTINE SHADE (z, cells)


*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*	Modified of PLOTZ to get data into proper grids for 
*	SHADE command

*	J Davison 8.26.88
*
*	Mod JD 4.18.90 to allow data all of the same value to be shaded. 
*       MOD *JD* To permit use of centered levels and specify the delta Z
*       value as well.  Added variables to CONT.INC common 8.3.95  
*	   *jd 8.28 fix bug in dz specification
*	*jd* 2.96 Change centered option so that data not spanning zero
*			is centered as well.
*	*jd* 5.96 Fix bug where if shade/lev=N option is used with constant 
*	field, no shade results
*       *jd* 1.98 Fix bug: shade misses top level, when top level is lt 0.
* V510 4/00 *sh - corrected faulty logic for centered levels (delta wrong)
* V550 11/02*acm* To use cellarray calls for rectangular shade plots, pass 
*                 cells in as a work array.  Remove VAX includes
* V550 12/02*acm* After levels are set, call setlab_syms to create the LEVELS symbols
* V552  3/03*acm* Check for too many levels, as is done for FILL and CONTOUR plots.
* v552  6/03*acm* Rename the array used for cellarray call.
* v554  3/04*acm* In the section marked correction for rounding errors, under g77 
*                 on linux this incorrectly uses low-order bits to reset NLEV2
* v570  4/04*acm* The fix above went too far.  Use TM_FPEQ to see if
*                 values are equal or close.  Also fixes this adjustment
*                 when the range has negative values; was always incorrect.
* v580  8/04*acm* Fix bug 957 shade/lev=1 of a constant field needs zlev(1) to be set.
* v581  4/05*acm* For cellarray plots JTYPE had erroneously been set to 1 (?!)
* v581 *acm* 3/05 open levels (-INF) (INF)
* v611 *acm* 4/08 Fix bug 1567: Set jj as in PLOTZ so SHADE/LINE gets labels with 
*                 enough precision
* v68  *acm* 4/08 Allow shade, vector plots of degenerate regions - world region 
*              within a grid cell
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus


	include		'parampl5_dat.decl'
	include		'PARAMPL5.DAT'

	include		'axis_inc.decl'
	include		'AXIS.INC'
	include		'plt_inc.decl'
	include		'PLT.INC'
	include		'miss_inc.decl'
	include		'MISS.INC'
	include		'hd_inc.decl'
	include		'HD.INC'
	include		'cont_inc.decl'
	include		'CONT.INC'
	include		'zgrid_inc.decl'
	include		'ZGRID.INC'
	include		'zgridd_inc.decl'
	include		'ZGRIDD.INC'
        include         'errmsg.parm'
        include         'shade_vars.cmn'

	real		dx,dy,dz,z(nx,ny),znp,zmp

	integer		status, i, j, cells(*), slen1, slen2
        CHARACTER       TM_FMT*48, buff1*20, buff2*20, err_msg*40

C       Add external stmt for linux port *jd* 12.96 RANGE is intrinsic fcn
        external range

******************************************************************************

C
C  Set the contour/color levels

        CALL SET_LEVELS_SHADE_FILL (status)
	IF (status .NE. ferr_ok) GOTO 5000

C       DRAW
C
C       from ppl/include/PPL.INC:
C
C       JTYPE: = 2 2-d irregular rectangular grid
C              = 1 1-d set
C              = 0 2-d regular rectangular grid (integer)
C              =-1 2-d second component of a vector regular grid
C              =-2 2-d second component of a vector irregular grid
C

C  WHY HAD JTYPE BEEN SET TO 1 HERE??!! 

c        IF (use_cell) JTYPE = 1
        IF (use_cell) JTYPE = 0

C       If it's a 2-d irregular grid, the irregular grid values
C       are also stored in the Z array.  Pass them to shade_sub.
	
	IF (JTYPE.EQ.2 .OR. JTYPE.EQ.-2) THEN

	   CALL SHADE_SUB(Z,Z(1,NY+1),Z(1,NY+2),XX(IZSE-NX-1),
     .        YY(IZSE-NY-1), cells)

C       For all other plot types fill in XX() and YY() by
C       multiplying the index value by the DX or DY delta values.

	ELSE

	   DX = (XMAX - XMIN)/(NX - 1)
	   DY = (YMAX - YMIN)/(NY - 1)
	   IF (NX .EQ. 1) DX = 1.
	   IF (NY .EQ. 1) DY = 1.

	   DO 500 I=1,NX
	      XX(IZLEN+I)=DX*(I-1)+XMIN
 500	   CONTINUE
	   DO 510 J=1,NY
	      YY(IZLEN+J)=DY*(J-1)+YMIN
 510	   CONTINUE

c *kob* 8/97 had to move the continuation marker to col 5 - it was in col 8
c       this bombed aix compiler, though it seems to work on others
	   CALL SHADE_SUB(Z,XX(IZLEN+1),YY(IZLEN+1),XX(IZLEN+NX+1),
     1	       YY(IZLEN+NY+1), cells)

	ENDIF

	RETURN

C  Error exit when too many levels specified.
C  Arrays LWGT, LDIG, and ZLEV are length ICNLEV=500

 5000   ii = ICNLEV
        buff1 = TM_FMT(DBLE(ICNLEV), 0, 20, slen1)
        buff2 = TM_FMT(DBLE(NLEV2), 0, 20, slen2)
        err_msg = '# of shade levels > '// buff1(1:slen1) //
     .          '  (' // buff2(1:slen2) // ')'
        CALL errmsg (ferr_out_of_range, status, err_msg, *5002)
 5002   RETURN
	END

	SUBROUTINE PUSH_INTERP_STACK( level, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* push the interpretation stack pointer to the next higher level and copy
* the most common objects to the new level

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 2/19/87
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* v690  2/2014 *sh* stack max limited to max_usable_intrp to fit aux frames at top
* v698+ 6/2015 *sh* is_sum changed from REAL to INTEGER
 
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xvariables.cmn'

* calling argument declarations:
	INTEGER		level, status

* internal variable declarations:
	INTEGER	source_level

* save level from which to copy stack info.
	source_level = level

* push the stack pointer
	CALL STACK_PTR_UP( isp, max_usable_intrp, status )
	IF ( status .NE. ferr_ok ) RETURN

* copy some stack info
	is_obj    ( isp ) = is_obj      ( source_level )
	is_uvar   ( isp ) = is_uvar     ( source_level )
	is_cx     ( isp ) = is_cx       ( source_level )
	is_aux_ptr( isp ) = is_aux_ptr  ( source_level )

* ! temp - blank out rest of stack to avoid undetected bugs
	is_act      ( isp ) = unspecified_int4
	is_big_cx   ( isp ) = unspecified_int4
	is_phase    ( isp ) = unspecified_int4
	is_axis     ( isp ) = unspecified_int4
	is_mr       ( isp ) = unspecified_int4
	is_sum      ( isp ) = -777

	RETURN
	END

	SUBROUTINE IS_UNION_MEMBER(  *, *, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* return the union member just read.

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - SDIG
*
* V7   5/12 *acm* Union aggregations: DEFINE DATA/AGG/U

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'
	include 'xtm_grid.cmn_text'   ! for grid_line

* calling argument declarations:
	INTEGER	status
* normal return is for error conditions
* exit #2 is to signal completion of the activity at this stack level

*   ... interpretation stack setup at the time this is called ...
*	stack level		stack contents
*	isp+1	<--	level of last activity ( component just computed )
*	 isp	<--	current stack level (for gathering )

* internal variable declarations:
	INTEGER NCF_GET_ATTR_FROM_ID, 
     .		com_mr, res_mr, com_cx, res_cx, com_isp, res_isp,
     .		res_grid, res_cat, res_var, imemb, memb_dset, iline,
     .		varid, attlen, maxlen, agg_dset, slen

	CHARACTER*128 VAR_CODE, agg_vname, memb_vname, buff
	CHARACTER LEFINT*6

* --- end of introductory code ---

* initialize
	res_isp    = isp
	com_isp    = isp + 1
	res_mr     = is_mr( res_isp )
	com_mr     = is_mr( com_isp )
	res_cx     = is_cx( res_isp )
	com_cx     = is_cx( com_isp )
        agg_dset   = cx_data_set(res_cx)
	res_grid   = cx_grid(res_cx)
	res_cat    = cx_category(res_cx)
	res_var    = cx_variable(res_cx)

* diagnostic mode output: " doing aggregate gather VAR_NAME[x=lo:hi@TRN:n,D=#]"
* Put in the agg- index value just for this output

	IF ( mode_diagnostic ) THEN
	   CALL DIAG_OP
     .	    ( 'doing', isact_get_union_member, com_cx, no_dim )
	ENDIF

* create mem. result from result cx 
	IF ( res_mr .EQ. unspecified_int4 ) THEN
	   CALL CREATE_MEM_VAR( res_cx, res_mr, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
	   is_mr( res_isp ) = res_mr
	ENDIF

* copy data just received into the result
* bad data flag differences are resolved during this COPY operation
	CALL COPY_INTO( memry(com_mr)%ptr, com_mr, com_cx,
     .			memry(res_mr)%ptr, res_mr )

* ... remove the component protection that signaled we needed it here
	IF (cx_data_set(com_cx) .NE. pdset_dummy) THEN
	   CALL MR_NOT_IN_USE( com_mr )
* ... delete it altogether (avoid memory clogging) unless its in use elsewhere
	   IF (mr_protected(com_mr) .EQ. mr_not_protected) 
     .					CALL DELETE_VARIABLE( com_mr )
	ELSE
	   CALL DELETE_VARIABLE( com_mr )   ! delete dummy (missing vals) 
	ENDIF

* we are done 
* ... yes - pop com_cx from context stack

	IF ( is_phase(isp) .EQ. is_sum(isp) ) THEN
	   cx_stack_ptr = cx_stack_ptr - 1
	   RETURN 2
	ENDIF

**************************************


* error exit
 5000	RETURN
	END	

	SUBROUTINE TM_BREAK_STR ( instring, outstrings, numwords )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* This subroutine will "break up" the variable instring into 'numwords'
* strings and place them in the character array outstrings. The breaks
* occur at spaces and tabs.
*
* revision 0.00 - 05/15/87
*
* Arguments
	INTEGER		numwords
	CHARACTER*(*)	instring, outstrings(numwords)
*
	INTEGER		inlen, outlen, wcnt, nblnk, i, nchar

	inlen  = LEN(instring)
	outlen = LEN(outstrings(1))
	wcnt = 0
	nblnk = 1

* Locate next non-blank character (start of a word)
100	DO 200 i=nblnk,inlen
	  IF (instring(i:i) .NE. ' ') THEN
	    nchar = i
	    GOTO 300
	  ENDIF
200	CONTINUE
* no non-blank characters left
	GOTO 9900

* locate the next blank character (end of a word)
300	DO 400 i = nchar,inlen
	  IF (instring(i:i) .EQ. ' ') THEN
* end of word found
	    nblnk = i
	    GOTO 500
	  ENDIF
400	CONTINUE
* non blank characters left
	nblnk = inlen + 1

500	wcnt = wcnt + 1
	outstrings(wcnt) = instring(nchar:nblnk-1)
	IF (wcnt .LT. numwords) GOTO 100
* if at end of string loop at 100 will catch it

9900	RETURN
	END

	BLOCK DATA XUNITS_DATA

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* unit names and conversion factors

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.00 - 04/15/88
* revision 0.01 - 11/21/88 - variable initialization changed to char_initXX
* revision 0.02 - 01/12/90 - added mb (kludge - not really convertible) *sh*
* revision 0.03 - 07/23/92 - added "layer" and "level" (unconvertible units)
*             (to eliminate error msg for these commonly used units)
* revision 0.04 - 12/19/94 - made mb non-convertible (1.0 instead of 0.01)
*			     and added unconvertible decibars
* 9/26/95 - interchanged the values (order) of pun_meters and pun_millibars
*		because TM_UNIT_ID was incorrectly interpreting "mbar"
* *kob* 10/96   - Linux port.  Linux didn't like tabs between "include"
*                 and what was being included.  removed them
* V5 *kob* 3/99 - add gregorian_ye[ar], year360, year366 units and also added
*              year365 as an alternate unit to the common year.
*    *sh* 7/99 - add alias "dbar" and change "month" definition to 1/12
*		 of 365.2425 day year 
*    *kob* 11/99 - add alternate unit "year" which is equal to a 
*                  gregorian_year
* *sh* 12/99 - add "degree" as an alternate name since exact match is now
*	required on names
* V510: 3/00 *sh* - added "minute" and "month"
* V520: 6/00 *sh* bug fix: exact matching in TM_UNIT_ID broke "seconds" match
*		         - add "hr" as an abbreviation for hours
*       1 day later: ops -- "hour" should be the standard, not "hr"
* V530: 2/01 *acm* add units for alternative calendars, secs per various
*		   years and 1/12 of those for "month"
* V532: 5/01 *sh* - added "metre"
* V554: 2/04 *acm*  default year length is 365.2425 days
* V570 *acm* 5/04  Add the calendar ALL_LEAP = 366_DAY, and units for the corresp. month.
* V71 12/16 *acm* Ticket 2158: working with true monthly time axes.

* local variable declarations
!	INTEGER	i

	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'xunits.cmn_text'


	DATA	un_name   ( 0)	/ ' '	/,	! FOR UNIDENTIFIED UNITS
     .		un_convert( 0)	/ 1.0 /

	DATA	un_name( 1)	/ 'cm'		/,
     .		un_name( 2)	/ 'km'		/,
     .		un_name(pun_meters)	/ 'm'		/,
     .		un_name(pun_degrees)	/ 'deg'		/,
     .		un_name( 5)	/ 'ft'		/,
     .		un_name( 6)	/ 'in'		/,
     .		un_name( 7)	/ 'mile'	/,
     .		un_name( 8)	/ 'mm'		/,
     .		un_name(pun_millibars)	/ 'mb'		/,
     .		un_name(pun_decibars)	/ 'dbar'	/,
     .		un_name(11)	/ char_init12	/,
     .		un_name(12)	/ char_init12	/,
     .		un_name(13)	/ char_init12	/,
     .		un_name(14)	/ 'level' 	/,
     .		un_name(15)	/ 'layer'	/

	DATA	un_name( -1)	/ 'sec'		/,
     .		un_name( -2)	/ 'min'		/,
     .		un_name( -3)	/ 'hour'	/,
     .		un_name( -4)	/ 'day'		/,
     .		un_name( -5)	/ 'mon'		/,
     .		un_name( -6)	/ 'yr'		/,
     .		un_name( -7)	/ 'M2 cycles'	/,
     .		un_name( -8)	/ 'year366'     /,
     .		un_name( -9)	/ 'year360'     /,
     .		un_name(-10)	/ 'gregorian_ye'/
     .		un_name(-11)	/ 'noleap_ye'/
     .		un_name(-12)	/ 'julian_ye'/
     .		un_name(-13)	/ 'mon_noleap'/
     .		un_name(-14)	/ 'mon_360'/
     .		un_name(-15)	/ 'mon_julian'/
     .          un_name(-16)    / 'mon_alleap'/

     .		un_name(-17)	/ 'tmon_gregorian'/
     .		un_name(-18)	/ 'tmon_noleap'/
     .		un_name(-19)	/ 'tmon_360'/
     .		un_name(-20)	/ 'tmon_julian'/
     .		un_name(-21)	/ 'mon_alleap'/

	DATA	un_convert( 1)	/ .01		/,
     .		un_convert( 2)	/ 1000.		/,
     .		un_convert(pun_meters)	/ 1.0		/,
     .		un_convert( 4)	/ deg2m		/,
     .		un_convert( 5)	/ 0.3048	/,
     .		un_convert( 6)	/ 0.0254	/,
     .		un_convert( 7)	/ 1609.		/,
     .		un_convert( 8)	/ .001		/,
     .		un_convert(pun_millibars)	/ 1.0 /,! not convertible 12/94
     .		un_convert(pun_decibars)	/ 1.0 /,! kludge: not cnvertble
     .		un_convert(11)	/ real4_init	/,
     .		un_convert(12)	/ real4_init	/,
     .		un_convert(13)	/ real4_init	/,
     .		un_convert(14)	/ 1.0    	/, ! kludge for not convertible
     .		un_convert(15)	/ 1.0    	/  ! kludge for not convertible

	DATA	un_convert( -1)	/ 1.0		/,
     .		un_convert( -2)	/ 60.		/,
     .		un_convert( -3)	/ 3600.		/, ! sec per hour
     .		un_convert( -4)	/ 86400.	/, ! sec per day
     .		un_convert( -5)	/ 2629746.	/, ! 1/12 of 365.2425 year

c     .		un_convert( -6)	/ 31536000.	/, ! sec per 365 day year (OLD default)
     .		un_convert( -6)	/ 31556952.	/  ! sec per 365.2425 year

     .		un_convert( -7)	/ 44712.	/, ! sec per M2 cycle
     .		un_convert( -8)	/ 31622400.	/, ! sec per 366 day year
     .		un_convert( -9)	/ 31104000.	/, ! sec per 360 day year
     .		un_convert(-10)	/ 31556952.	/  ! sec per 365.2425 year

     .		un_convert(-11)	/ 31536000.	/, ! sec per 365.0 day year
     .		un_convert(-12)	/ 31557600.	/, ! sec per 365.25 day year

     .		un_convert(-13)	/ 2628000.	/, ! 1/12 of sec per 365 day year
     .		un_convert(-14)	/ 2592000.	/, ! 1/12 of sec per 360 day year
     .		un_convert(-15)	/ 2629800.	/, ! 1/12 of sec per 365.25 day year
     .		un_convert(-16)	/ 2635200.	/, ! 1/12 of sec per 366 day year

     .		un_convert(-17)	/ 2629746.	/, ! 1/12 of sec per 365.2425 year
     .		un_convert(-18)	/ 2628000.	/, ! 1/12 of sec per 365 day year
     .		un_convert(-19)	/ 2592000.	/, ! 1/12 of sec per 360 day year
     .		un_convert(-20)	/ 2629800.	/, ! 1/12 of sec per 365.25 day year
     .		un_convert(-21)	/ 2635200.	/  ! 1/12 of sec per 366 day year


	DATA	un_alt_name ( 1) / 'centim'	/,
     .		un_alt_subsc( 1) / 1 /,
     .
     .		un_alt_name ( 2) / 'kilom'	/,
     .		un_alt_subsc( 2) / 2 /,
     .
     .		un_alt_name ( 3) / 'milim'	/,
     .		un_alt_subsc( 3) / 8 /,
     .
     .		un_alt_name ( 4) / 'lat'	/,
     .		un_alt_subsc( 4) / pun_degrees /,
     .
     .		un_alt_name ( 5) / 'lon'	/,
     .		un_alt_subsc( 5) / pun_degrees /,
     .
     .		un_alt_name ( 6) / 'feet'	/,
     .		un_alt_subsc( 6) / 5 /,
     .
     .		un_alt_name ( 7) / 'foot'	/,
     .		un_alt_subsc( 7) / 5 /,
     .
     .		un_alt_name ( 8) / 'meter'	/,! after all other "xxxxmeters"
     .		un_alt_subsc( 8) / pun_meters /,
     .
     .		un_alt_name ( 9) / 'year365'/,
     .		un_alt_subsc( 9) / -6 /,
     .
     .		un_alt_name (10) / 'millibar'	/,
     .		un_alt_subsc(10) / pun_millibars /,
     .
     .		un_alt_name (11) / 'decibar'	/,
     .		un_alt_subsc(11) / pun_decibars /,
     .
     .		un_alt_name (12) / 'common_year'/,
     .		un_alt_subsc(12) / -6 /,
     .
     .		un_alt_name (13) / 'mbar'	/,
     .		un_alt_subsc(13) / pun_millibars /,
     .
     .		un_alt_name (14) / 'year'	/,
     .		un_alt_subsc(14) / -10 /,
     .
     .		un_alt_name (15) / 'degree'	/,
     .		un_alt_subsc(15) / pun_degrees /,
     .
     .		un_alt_name (16) / 'trumonth'	/,! use days
     .		un_alt_subsc(16) / -5 /,
     .
     .		un_alt_name (17) / 'month'	/,
     .		un_alt_subsc(17) / -5 /,
     .
     .		un_alt_name (18) / 'minute'	/,
     .		un_alt_subsc(18) / -2 /,
     .
     .		un_alt_name (19) / 'second'	/,
     .		un_alt_subsc(19) / -1 /,
     .
     .		un_alt_name (20) / 'hr'		/,
     .		un_alt_subsc(20) / -3 /,
     .
     .		un_alt_name (21) / 'metre'	/, ! those Brits ...
     .		un_alt_subsc(21) /  pun_meters /
!     .		un_alt_name (21) / char_init12	/,
!     .		un_alt_subsc(21) / 0 /

	END

      SUBROUTINE SURF(V,A,XMIN,XMAX,M,YMIN,YMAX,N,ZMIN,ZMAX,
     1DX,DY,DZ)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* revised for TMAP
* from PPLUS :
*	Directory PMEL:[PLOT5.PPLV11.PLOTLIB]SURF.FOR

* search for "TMAP" to find all revisions
* *sh*  - 1/23/89 added interrupt detection
*		  ... no explicit declarations (too much trouble !) so it must
*		      be compiled with /WARNINGS=NODECLARATIONS
C**
C**    @(#)surf.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C SURF IS A FRONT END ROUTINE FOR SURFCE TO EVALUATE A FUNCTION
C OF TWO VARIABLES AND STORE THE RESULTS IN AN ARRAY TO PASS TO
C SURFCE.  THE CALLING STRING IS:
C V    - THE FUNCTION NAME--MUST BE A FUNCTION OF (X,Y)
C A    - A SINGLE DIMENSIONED ARRAY OF LENGTH M*N
C XMIN - MINIMUM VALUE OF X.
C XMAX - MAXIMUM VALUE OF X.
C M    - THE NUMBER OF X VALUES I.E. THE NUMBER OF ROWS.
C YMIN - MINIMUM VALUE OF Y.
C YMAX - MAXIMUM VALUE OF Y.
C N    - THE NUMBER OF Y VALUES I.E. THE NUMBER OF COLUMNS.
C ZMIN - MINIMUM VALUE OF Z
C ZMAX - THE MAXIMUM VALUE OF Z
C DX   - THE X COORDINATE OF THE VIEW POINT.
C DY   - THE Y COORDINATE OF THE VIEW POINT.
C DZ   - THE Z COORDINATE OF THE VIEW POINT.
C
C THE FUNCTION IS EVALUATED AND STORED IN THE ARRAY A COLUMNWISE
C WITH THE FIRST LOCATION FILLED WITH F(XMIN,YMIN).  THE X VALUE INCREAS
C GOING DOWN A COLUMN AND THE Y VALUE INCREASES GOING ACROSS A ROW.
	external v
      DIMENSION A(1)

* Mod to specify external references for SCALE and RANGE * Linux *jd* 12.96
	external scale, size


      DLTAX=(XMAX-XMIN)/(M-1)
      DLTAY=(YMAX-YMIN)/(N-1)
      Y=YMIN
      IDX=1
      DO 20 J=1,N
      X=XMIN
      DO 10 I=1,M
      A(IDX)=V(X,Y)
      IDX=IDX+1
      X=X+DLTAX
   10 CONTINUE
      Y=Y+DLTAY
   20 CONTINUE
      CALL SURFCE(A,XMIN,XMAX,M,YMIN,YMAX,N,ZMIN,ZMAX,
     1DX,DY,DZ)
      RETURN
C**  THIS PROGRAM VALID ON FTN4 AND FTN5 **
      END
C*F45V1P0*
      SUBROUTINE SURFCE(F,XMIN,XMAX,M,YMIN,YMAX,N,
     1ZM,ZMX,DX,DY,DZ)
C SURFCE WILL PRODUCE A PERSPECTIVE DRAWING OF A FUNCTION OF
C 2 VARIABLES.  THE CALLING PARAMETERS ARE:
C
C  F   - A TWO DIMENSIONAL ARRAY OF DATA POINTS
C      - IT IS ASSUMED THAT THERE WILL BE M ROWS
C      - AND N COLUMNS.  IT IS ASSUMMED THAT THE ARRAY IS SET UP
C      - COLUMNWISE WITH F(1) CORRESPONDING TO FUN(XMIN,YMIN).
C      - THE COLUMNS MUST GO IN INCREASING X VALUES GOING DOWN
C      - AND INCREASING Y VALUES GOING ACROSS.
C  XM  - THE MINIMUM X VALUE
C  XMX - THE MAXIMUM X VALUE
C  M   - THE NUMBER OF INTERVALS IN THE X DIRECTION
C  YM  - THE MINIMUM Y VALUE
C  YMX - THE MAXIMUM Y VALUE
C  N   - THE NUMBER OF INTERVALS IN THE Y DIRECTION
C  ZM  - THE MINIMUM Z VALUE
C  ZMX - THE MAXIMUM Z VALUE
C  DX  - THE X COORDINATE OF THE VIEW POINT
C  DY  - THE Y COORDINATE OF THE VIEW POINT
C  DZ  - THE Z COORDINATE OF THE VIEW POINT
C
C  THE LABELED COMMON BLOCK USED IS FOR COMMUNICATION
C BETWEEN THE SUBROUTINES HIDE, TRANSF, AND INTERCEPT
C NONE OF THE VARIABLES NEED TO BE INITIALIZED BY
C THE CALLING PROGRAM.
C THIS SET OF SUBROUTINES WAS WRITTEN AT O.S.U. 10-1972
C BY JEFF BALLANCE.  THE FORMULAS WERE GOTTEN FROM THE REFERENCE:
C
C ^THE PERSPECTIVE REPRESENTATION OF FUNCTIONS OF TWO VARIABLES,^
C J.ACM (VOL. 15, NO. 2) APRIL 1968. PP. 193-204.
      DIMENSION F(1)
#ifdef unix
	include 'plt_inc.decl'
	include 'PLT.INC'
	include 'miss_inc.decl'
	include 'MISS.INC'
	include 'axis_inc.decl'
	include 'AXIS.INC'
#else
	INCLUDE 'TMAP_PPLV11INC:PLT_INC.DECL'
	INCLUDE 'PPLV11INC:PLT.INC'
	INCLUDE 'TMAP_PPLV11INC:MISS_INC.DECL'
	INCLUDE 'PPLV11INC:MISS.INC'
	INCLUDE 'TMAP_PPLV11INC:AXIS_INC.DECL'
	INCLUDE 'PPLV11INC:AXIS.INC'
#endif
	LOGICAL SKIP
      COMMON /LAB1/ CX,CY,CZ,QX,QY,QZ,DCQ,CALPHA,CBETA,CGAMMA,
     1DSAOB,IFLG,XTEST,YTEST,ZTEST,DLTAX1,DLTAY1,DLTAX,DLTAY
     2,ZMIN,ZMAX,XM,YM,DLTAXI,DLTAYI,MM,NN

* TMAP interrupt flag
#ifdef unix
	include 'xinterrupt.cmn'
#else
	INCLUDE 'tmap_pplv11inc:tmap_xinterrupt.cmn'
#endif

* Mod to specify external references for SCALE and RANGE * Linux *jd* 12.96
	external scale, size

C  INITIALIZE SOME THINGS IN THE COMMON BLOCK
      CX=DX
      CY=DY
      CZ=DZ
      ZMIN=ZM
      ZMAX=ZMX
      XM=XMIN
      YM=YMIN
      MM=M
      NN=N
C COMPUTE THE EDGES CLOSEST TO THE VIEW POINT.
      XTEST=CX
      IF(XMAX.LT.XTEST) XTEST=XMAX
      IF(XTEST.LT.XMIN) XTEST=XMIN
      YTEST=CY
      IF(YMAX.LT.YTEST) YTEST=YMAX
      IF(YTEST.LT.YMIN) YTEST=YMIN
      ZTEST=CZ
      IF(ZMAX.LT.ZTEST) ZTEST=ZMAX
      IF(ZTEST.LT.ZMIN) ZTEST=ZMIN
C COMPUTE THE CENTER OF THE CUBE--THIS WILL BE POINT
C ON THE LINE OF SIGHT THROUGH WHICH THE PERSPECTIVE
C PLANE IS DEVELOPED PERPENDICULAR TO THE LINE OF
C SIGHT.
      QX=0.5*(XMAX+XMIN)
      QY=0.5*(YMAX+YMIN)
      QZ=0.5*(ZMAX+ZMIN)
C COMPUTE THE LENGTH OF LINE CQ
      CXQ=QX-CX
      CYQ=QY-CY
      CZQ=QZ-CZ
      T=CXQ*CXQ+CYQ*CYQ+CZQ*CZQ
      DCQ=SQRT(T)
C COMPUTE COS(ALPHA),COS(BETA),COS(GAMMA) WHERE
C (ALPHA,BETA,GAMMA) ARE THE ANGLES MADE WITH
C X,Y,Z AXIS RESPECTIVELY BY CQ.
      CALPHA=CXQ/DCQ
      CBETA=CYQ/DCQ
      CGAMMA=CZQ/DCQ
C COMPUTE SIN(GAMMA)--IF ZERO USE DIFFERENT FORMULA
C TO CALCULATE TRANSFORMED X AND Y WHICH USE SIN(BETA)
      DSAOB=SQRT(T-CZQ*CZQ)/DCQ
      IFLG=1
      IF(DSAOB.NE.0.0) GO TO 10
      IFLG=2
      DSAOB=SQRT(T-CYQ*CYQ)/DCQ
   10 DSAOB=1.0/DSAOB
C DETERMINE MAX AND MIN OF PERSPECTIVE PLANE
	XM1=1.E30
	YM1=XM1
	XMX1=-XM1
	YMX1=XMX1
      X=XMIN
      DO 40 I=1,2
      Y=YMIN
      DO 30 J=1,2
      Z=ZMIN
      DO 20 K=1,2
      CALL TRANSF(X,Y,Z,XX,YY)
      IF(XX.LT.XM1) XM1=XX
      IF(XMX1.LT.XX) XMX1=XX
      IF(YY.LT.YM1) YM1=YY
      IF(YMX1.LT.YY) YMX1=YY
      Z=ZMAX
   20 CONTINUE
      Y=YMAX
   30 CONTINUE
      X=XMAX
   40 CONTINUE
      CALL SIZE(WIDTH,HEIGHT)
C      SCAL=(WIDTH-1.0)/(XMX1-XM1)
C THE SCALE FACTORS ARE CHOSEN TO BE THE SAME.
C      SCAL1=(HEIGHT-1.0)/(YMX1-YM1)
C      IF(SCAL1.LT.SCAL) SCAL=SCAL1
C      CALL SCALE(SCAL,SCAL,0.50,0.50,XM1,YM1)
	XF=XLEN/(XMX1-XM1)
	YF=YLEN/(YMX1-YM1)
	IF(YF.LT.XF)XF=YF
	CALL SCALE(XF,XF,XORG,YORG,XM1,YM1)
C DRAW LABEL FOR PLOT
C DETERMINE DLTAX AND DLTAY
      DLTAX=(XMAX-XMIN)/(M-1)
      DLTAY=(YMAX-YMIN)/(N-1)
      DLTAXI=1.0/DLTAX
      DLTAYI=1.0/DLTAY
C DO LINES PARALLEL TO X-AXIS FIRST
      DLTAX1=DLTAX
	DLTAX2=0.
	DLTAY1=DLTAX2
      DLTAY2=DLTAY
C DO HORIZONTAL AND THEN VERTICAL LINES
      M1=M-1
      N1=N
      IDXINC=M
	IDXINT=1
	INC=IDXINT
	IDX=INC
      DO 90 I=1,2
	XXM=XMIN
	X=XXM
	YYM=YMIN
	Y=YYM
C LOOP THROUGH OUTER LOOP
C MOVE TO THE FIRST POINT OF EACH LINE WITH THE PEN UP.
      DO 80 J=1,N1
      Z=F(IDX)
	IF(ZLE.AND.(Z.LE.CMZLE).OR.
     *	   ZEQ.AND.(Z.EQ.CMZEQ).OR.
     *	   ZGE.AND.(Z.GE.CMZGE))THEN
	    SKIP=.TRUE.
	ELSE
	    SKIP=.FALSE.
	    CALL HIDE(X,Y,Z,PHI,F)
	    CALL TRANSF(X,Y,Z,XX,YY)
	    CALL PLOT(XX,YY,0,0)
	ENDIF
C LOOP THROUGH INNER LOOP
      DO 70 K=1,M1
	IF ( interrupted ) RETURN		! TMAP interrupt
      PHIO=PHI
      ZOLD=Z
      X=X+DLTAX1
      Y=Y+DLTAY1
      IDX=IDX+INC
      Z=F(IDX)
	IF(ZLE.AND.(Z.LE.CMZLE).OR.
     *	   ZEQ.AND.(Z.EQ.CMZEQ).OR.
     *	   ZGE.AND.(Z.GE.CMZGE))THEN
	    SKIP=.TRUE.
	ELSE
	    IF(SKIP)THEN
C
C	MOVE WITH PEN UP
C
		SKIP=.FALSE.
		CALL HIDE(X,Y,Z,PHI,F)
		CALL TRANSF(X,Y,Z,XX,YY)
		CALL PLOT(XX,YY,0,0)
	    ELSE
		CALL MOVES(X,Y,Z,ZOLD,PHIO,PHI,F)
	    ENDIF
	ENDIF
   70 CONTINUE
	XXM=XXM+DLTAX2
	X=XXM
	YYM=YYM+DLTAY2
	Y=YYM
	IDXINT=IDXINT+IDXINC
	IDX=IDXINT
   80 CONTINUE
	DLTAY2=0.
	DLTAX1=DLTAY2
      DLTAY1=DLTAY
      DLTAX2=DLTAX
C SET UP FOR MOVING IN OTHER DIRECTION
      M1=N-1
      N1=M
	IDXINC=1
	IDXINT=IDXINC
	IDX=IDXINT
      INC=M
   90 CONTINUE
C DRAW BASE
	DLTAX2=DLTAX
	DLTAX1=DLTAX2
      DLTAY1=0.
      DLTAY2=DLTAY
      X=XMIN
      Y=YMIN
      Z=ZMIN
      CALL HIDE(X,Y,Z,PHI,F)
      CALL TRANSF(X,Y,Z,XX,YY)
      CALL PLOT(XX,YY,0,0)
C MOVE PEN TO XMIN,YMIN,ZMIN AND BEGIN
      M1=MM-1
      IDX=M
      TEMP=N*M
      DO 100 K=1,2
      DO 110 I=1,2
      DO 120 J=1,M1
      PHIO=PHI
      X=X+DLTAX1
      Y=Y+DLTAY1
      CALL MOVES(X,Y,Z,Z,PHIO,PHI,F)
120   CONTINUE
C DRAW VERT SEGMENT OF THE BASE
      PHIO=PHI
      ZOLD=Z
      Z=F(IDX)
	IF(ZLE.AND.(Z.LE.CMZLE).OR.
     *	   ZEQ.AND.(Z.EQ.CMZEQ).OR.
     *	   ZGE.AND.(Z.GE.CMZGE))Z=(ZMAX+ZMIN)*0.5
	DLTAY1=0.
	DLTAX1=DLTAY1
      CALL TRANSF(X,Y,ZOLD,XX,YY)
C MOVE PEN TO CORNER
      CALL PLOT(XX,YY,0,0)
C PLOT LINE
      CALL MOVES(X,Y,Z,ZOLD,PHIO,PHI,F)
C MOVE PEN BACK
      CALL PLOT(XX,YY,0,0)
C SET NEW VALUES
      PHI=PHIO
      DLTAX1=0.
      DLTAY1=DLTAY2
      M1=N-1
      IDX=TEMP
      Z=ZMIN
110   CONTINUE
	DLTAX1=-DLTAX
	DLTAX2=DLTAX1
      DLTAY2=-DLTAY
      DLTAY1=0.
      IDX=1+(N-1)*M
      TEMP=1
      M1=MM-1
100   CONTINUE
      RETURN
C**  THIS PROGRAM VALID ON FTN4 AND FTN5 **
      END
C*F45V1P0*
      SUBROUTINE MOVES(X,Y,Z,ZOLD,PHIO,PHI,F)
      DIMENSION F(1)

* Mod to specify external references for SCALE and RANGE * Linux *jd* 12.96
	external scale, size


C MOVES PEN TO NEW POINT ( X,Y,Z )
C SEE IF THE POINT IS HIDDEN
      CALL HIDE(X,Y,Z,PHI,F)
C TEST IF BOTH VIEWABLE OR NOT
      IF(PHI.EQ.PHIO) GO TO 60
C TEST FOR ONE VIEWABLE FROM TOP AND ONE FROM BOTTOM
      IF(ABS(PHI).EQ.ABS(PHIO)) GO TO 50
C O.K. ONE IS HIDEN AND OTHER NOT. FIND LEFT HAND
C INTERCEPT.
      CALL INTCEP(X,Y,Z,Z-ZOLD,F,X1,Y1,Z1,PHIO,-1.0)
      CALL TRANSF(X1,Y1,Z1,XX,YY)
      IPEN=ABS(PHIO)
      CALL PLOT(XX,YY,IPEN,0)
      GO TO 60
C WE HAVE HIDDEN PART IN MIDDLE--VIEWABLE FROM TOP
C ON ONE SIDE AND VIEWABLE FROM BOTTOM ON OTHER END
   50 CALL INTCEP(X,Y,Z,Z-ZOLD,F,X1,Y1,Z1,PHIO,-1.0)
      CALL TRANSF(X1,Y1,Z1,XX,YY)
      CALL PLOT(XX,YY,1,0)
C FIND RIGHT HAND INTERCEPT
      CALL INTCEP(X,Y,Z,Z-ZOLD,F,X1,Y1,Z1,PHI,1.0)
      CALL TRANSF(X1,Y1,Z1,XX,YY)
      CALL PLOT(XX,YY,0,0)
C MOVE TO POINT
   60 IF(PHI.EQ.0.0) GO TO 70
      CALL TRANSF(X,Y,Z,XX,YY)
      CALL PLOT(XX,YY,1,0)
70    RETURN
C**  THIS PROGRAM VALID ON FTN4 AND FTN5 **
      END
C*F45V1P0*
      SUBROUTINE HIDE(X,Y,Z,PHI,F)
C HIDE TESTS TO SEE IF THE POINT (XB,YB,ZB) IS HIDDEN
C FROM VIEW OF (CX,CY,CZ).  THIS IS DONE BY TRAVETSING
C THE LINE FROM (XB,YB,ZB) TO (CX,CY,CZ) TO SEE IF THE
C LINE INTERSECTS THE SURFCE.
C
C THE CALLING PARAMETERS ARE:
C  X   - THE X VALUE OF THE POINT
C  Y   - THE Y VALUE OF THE POINT
C  Z   - THE Z VALUE OF THE POINT
C  PHI - VARIABLE WITH THE FOLLOWING VALUES UPON RETURN
C         0 IF THE POINT IS HIDDEN
C        -1 IF THE POINT IS VIEWABLE FROM BELOW
C         1 IF THE POINT IS VIEWABLE FROM ABOVE
C  F   - THE ARRAY OF VALUES.
      DIMENSION F(1)
#ifdef unix
	include 'miss_inc.decl'
	include 'MISS.INC'
#else
	INCLUDE 'TMAP_PPLV11INC:MISS_INC.DECL'
	INCLUDE 'PPLV11INC:MISS.INC'
#endif
      COMMON/LAB1/CX,CY,CZ,QX,QY,QZ,DCQ,CALPHA,CBETA,CGAMMA,
     1DSAOB,IFLG,XTEST,YTEST,ZTEST,DLTAX1,DLTAY1,DLTAX,DLTAY
     2,ZMIN,ZMAX,XMIN,YMIN,DLTAXI,DLTAYI,M,N
      DIMENSION CVIEW(3),VLTEST(3),POINT(3),CVPDST(3),DIST(3)
      DIMENSION TEST(3)
      EQUIVALENCE (CX,CVIEW(1)),(XB,POINT(1)),(YB,POINT(2)),
     1(ZB,POINT(3)),(XDIST,DIST(1)),(YDIST,DIST(2)),(ZDIST,
     2DIST(3)),(CXXB,CVPDST(1)),(CYYB,CVPDST(2)),(CZZB,
     3CVPDST(3)),(XTEST,TEST(1))

* Mod to specify external references for SCALE and RANGE * Linux *jd* 12.96
	external scale, size

C COMPUTE DX,DY,DZ OF THE LINE OF VIEW
      XB=X
      YB=Y
      ZB=Z
      DO 5 J=1,3
	VLTEST(J)=TEST(J)-POINT(J)
	TEMP=VLTEST(J)
      IF(TEST(J).NE.0.0) TEMP=TEMP/TEST(J)
      IF(ABS(TEMP).LT.1.0E-6) VLTEST(J)=0.0
	CVPDST(J)=CVIEW(J)-POINT(J)
	TEMP=CVPDST(J)
      IF(CVIEW(J).NE.0.0) TEMP=TEMP/CVIEW(J)
      IF(ABS(TEMP).LT.1.0E-6) CVPDST(J)=0.0
    5 CONTINUE
C MUST FIND THE POINT AT WHICH THE LINE OF SIGHT INTERSECTS
C THE CUBE.
      DO 20 J=1,3
      DIST(J)=0.0
      IF(CVPDST(J).EQ.0.0) GO TO 20
      DIST(J)=VLTEST(J)
      RATIO=DIST(J)/CVPDST(J)
      DO 10 I=1,3
      IF(I.EQ.J) GO TO 10
	DIST(I)=RATIO*CVPDST(I)
	TEMP=DIST(I)
      IF(CVPDST(I).NE.0.0) TEMP=TEMP/CVPDST(I)
      IF(ABS(TEMP).LT.1.0E-6) DIST(I)=0.0
      IF(ABS(VLTEST(I)).LT.ABS(DIST(I))) GO TO 20
   10 CONTINUE
      GO TO 30
   20 CONTINUE
   30 IF(XDIST.EQ.0.0) GO TO 40
C WE ARE NOT VIEWING ALONG LINE PARALLEL TO Y-Z PLANE
	IDX=ABS(XDIST)/DLTAX+1.0
	INUM=IDX
      DX=XDIST/IDX
      DY=YDIST/XDIST*DX
      IF(ABS(DLTAY).LT.ABS(DY)) GO TO 50
      GO TO 60
C SEE IF ABOVE POINT
   40 IF(YDIST.NE.0.0) GO TO 50
C WE ARE RIGHT ABOVE OR BELOW POINT
      PHI=SIGN(1.,CZZB)
      RETURN
50	IDY=ABS(YDIST)/DLTAY+1.0
	INUM=IDY
      DY=YDIST/IDY
      DX=XDIST/YDIST*DY
C STEP ALONG THE LINE OF SIGHT IN HALF STEPS.
   60 DX=DX*0.5
      DY=DY*0.5
      INUM=INUM+INUM
      DZ=ZDIST*SQRT((DX*DX+DY*DY)/(XDIST*XDIST+YDIST*YDIST))
      XB=XB+DX
      YB=YB+DY
      ZB=ZB+DZ
C COMPUTE THE INDICES OF THE GRID POINTS CONTAINING THE POINT.
	FI=(XB-XMIN)*DLTAXI+1.0
	I=FI
	FJ=(YB-YMIN)*DLTAYI+1.0
	J=FJ
      I1=FI+0.995
      J1=FJ+0.995
C MAKE SURE THE INDICES DON"T GET TOO LARGE.
      IF(I1.GT.M) I1=M
      IF(J1.GT.N) J1=N
C COMPUTE THE LINEAR ARRAY INDICES.
      MI=(J-1)*M
      MI1=(J1-1)*M
      IDX=MI+I
      IDX1=MI+I1
      IDX2=MI1+I
      IDX3=MI1+I1
C USE A TWO STAGE LINEAR INTERPOLATION.
      XFACT=(XB-(XMIN+(I-1)*DLTAX))*DLTAXI
C
C**	ADD TEST FOR DATA TO BE IGNORED IN THE HIDE ALGORITHM
C
C	IF(ZLE.AND.(F(IDX).LE.CMZLE).OR.
C     *	   ZEQ.AND.(F(IDX).EQ.CMZEQ).OR.
C     *	   ZGE.AND.(F(IDX).GE.CMZGE))GOTO
C	IF(ZLE.AND.(F(IDX1).LE.CMZLE).OR.
C     *	   ZEQ.AND.(F(IDX1).EQ.CMZEQ).OR.
C     *	   ZGE.AND.(F(IDX1).GE.CMZGE))GOTO
C	IF(ZLE.AND.(F(IDX2).LE.CMZLE).OR.
C     *	   ZEQ.AND.(F(IDX2).EQ.CMZEQ).OR.
C     *	   ZGE.AND.(F(IDX2).GE.CMZGE))GOTO
C	IF(ZLE.AND.(F(IDX3).LE.CMZLE).OR.
C     *	   ZEQ.AND.(F(IDX3).EQ.CMZEQ).OR.
C     *	   ZGE.AND.(F(IDX3).GE.CMZGE))GOTO
      Z1=F(IDX)+(F(IDX1)-F(IDX))*XFACT
      Z2=F(IDX2)+(F(IDX3)-F(IDX2))*XFACT
      ZZ=Z1+(Z2-Z1)*(YB-(YMIN+(J-1)*DLTAY))*DLTAYI
C TEST THE FIRST DIFFERENCE TO MAKE SURE
C WE AREN"T JUST ON THE BOUNDARY.  IF SO WE WANT THE POINT TO BE VIEWABL
C BUT WITH THE SAME PHI VALUE AS THE LAST POINT I.E. + OR - 1.  BUT IF
C THE LAST POINT WAS HIDDEN WE WANT THE CURRENT POINT VIEWABLE, SO THE
C SIGN OF THE LAST PHI IS USED.  THIS CASE ONLY OCCURS WHEN
C WE ARE ON THE BOUNDARY CLOSEST TO THE VIEWING POINT.
      ARG=ZB-ZZ
      IF(ARG.EQ.0.0) GO TO 90
	PHIOLD=SIGN(1.,ARG)
	PHI=PHIOLD
C COMPUTE THE INDICES INCREMENT.
      DFI=DX*DLTAXI
      DFJ=DY*DLTAYI
      DO 70 K=2,INUM
C MOVE ALONG THE LINE OF SIGHT.
      XB=XB+DX
      YB=YB+DY
      ZB=ZB+DZ
C INCREMENT THE INDICES.
      FI=FI+DFI
      FJ=FJ+DFJ
C COMPUTE THE INDICES OF THE GRID ABOUT THE POINT.
      I=FI+0.005
      J=FJ+0.005
      I1=FI+0.995
      J1=FJ+0.995
C MAKE SURE THE INDICES DON"T GET TOO LARGE.
      IF(I1.GT.M) I1=M
      IF(J1.GT.N) J1=N
C COMPUTE THE LINEAR ARRAY INDICES
      MI=(J-1)*M
      MI1=(J1-1)*M
      IDX=MI+I
      IDX1=MI+I1
      IDX2=MI1+I
      IDX3=MI1+I1
C USE A TWO STAGE INTERPOLATION.
      XFACT=(XB-(XMIN+(I-1)*DLTAX))*DLTAXI
C
C**	ADD TEST FOR DATA TO BE IGNORED IN THE HIDE ALGORITHM
C
	IF(ZLE.AND.(F(IDX).LE.CMZLE).OR.
     *	   ZEQ.AND.(F(IDX).EQ.CMZEQ).OR.
     *	   ZGE.AND.(F(IDX).GE.CMZGE))GOTO 70
	IF(ZLE.AND.(F(IDX1).LE.CMZLE).OR.
     *	   ZEQ.AND.(F(IDX1).EQ.CMZEQ).OR.
     *	   ZGE.AND.(F(IDX1).GE.CMZGE))GOTO 70
	IF(ZLE.AND.(F(IDX2).LE.CMZLE).OR.
     *	   ZEQ.AND.(F(IDX2).EQ.CMZEQ).OR.
     *	   ZGE.AND.(F(IDX2).GE.CMZGE))GOTO 70
	IF(ZLE.AND.(F(IDX3).LE.CMZLE).OR.
     *	   ZEQ.AND.(F(IDX3).EQ.CMZEQ).OR.
     *	   ZGE.AND.(F(IDX3).GE.CMZGE))GOTO 70
      Z1=F(IDX)+(F(IDX1)-F(IDX))*XFACT
      Z2=F(IDX2)+(F(IDX3)-F(IDX2))*XFACT
      ZZ=Z1+(Z2-Z1)*(YB-(YMIN+(J-1)*DLTAY))*DLTAYI
      PHI=SIGN(1.,ZB-ZZ)
C TEST THE VIEWABLILITY OF THE POINT, IF THE PHI"S ARE DIFFERENT
C THE POINT IS NOT VIEWABLE.
      IF(PHI.NE.PHIOLD) GO TO 80
   70 CONTINUE
      RETURN
C THE POINT IS NOT VIEWABLE
   80 PHI=0.0
      RETURN
   90 PHI=SIGN(1.,PHIOLD)
      RETURN
C**  THIS PROGRAM VALID ON FTN4 AND FTN5 **
      END
C*F45V1P0*
      SUBROUTINE INTCEP(X,Y,Z,DLTAZ,F,X1,Y1,Z1,PHI,DIR)
C INTERCEPT COMPUTES THE INTERCEPT OF THE LINES OF
C SIGHT WITH THE FIRST VIEWABLE POINT ALONG THE LINE
C CONNECTING THE POINTS.  THE CALLING PARAMETERS ARE
C
C  X   - THE X VALUE OF NEXT POINT
C  Y   - THE Y VALUE OF NEXT POINT
C  F   - THE FUNCTION NAME
C  Z   - THE Z VALUE OF NEXT POINT
C  DLTAZ - THE DIFFERENCE IN THE TWO Z VALUES ALONG LINE OF
C      - INTERPOLATION.
C  X1  - THE X COORDINATE OF THE INTERCEPT POINT
C  Y1  - THE Y COORDINATE OF THE INTERCEPT POINT
C  Z1  - THE Z COORDINATE OF THE INTERCEPT POINT
C  PHI - THE VIEWABLE VALUE WE WISH THE INTERCEPT
C        POINT TO HAVE
C  DIR - THIS VARIABLE WILL HAVE THE VALUE -1.0 IF
C        PHI IS FROM LAST POINT AND 1.0 IF NEXT.
      DIMENSION F(1)
      COMMON/LAB1/CX,CY,CZ,QX,QY,QZ,DCQ,CALPHA,CBETA,CGAMMA,
     1DSAOB,IFLG,XTEST,YTEST,ZTEST,DLTAX1,DLTAY1,DLTAX,DLTAY
     2,ZMIN,ZMAX,XMIN,YMIN,DLTAXI,DLTAYI,M,N
      DELX=DLTAX1*0.5
      DELY=DLTAY1*0.5
      DELZ=DLTAZ*0.5
      X1=X-DELX
      Y1=Y-DELY
      Z1=Z-DELZ
      DO 20 I=1,5
      DELX=DELX*0.5
      DELY=DELY*0.5
      DELZ=DELZ*0.5
      CALL HIDE(X1,Y1,Z1,PHIN,F)
      IF(PHIN.EQ.PHI) GO TO 10
C MOVE IN DIRECTION OF PHI
      X1=X1+DIR*DELX
      Y1=Y1+DIR*DELY
      Z1=Z1+DIR*DELZ
      GO TO 20
C MOVE AWAY FROM PHI
   10 X1=X1-DIR*DELX
      Y1=Y1-DIR*DELY
      Z1=Z1-DIR*DELZ
   20 CONTINUE
      RETURN
C**  THIS PROGRAM VALID ON FTN4 AND FTN5 **
      END
C*F45V1P0*
      SUBROUTINE TRANSF(X,Y,Z,XX,YY)
C THE ROUTINE TRANSF TRANSFORMS THE (X,Y,Z) TRIPLE INTO (X,Y) PAIR IN
C THE VIEWING PLANE.  THE CALLING ARGUMENTS ARE:
C  X  - THE X COORDINATE OF THE TRIPLE
C  Y  - THE Y COORDINATE OF THE TRIPLE
C  Z  - THE Z COORDINATE OF THE TRIPLE
C  XX - THE X COORDINATE OF THE VIEWING PLANE POINT.
C  YY - THE Y COORDINATE OF THE VIEWING PLANE POINT.
      COMMON/LAB1/CX,CY,CZ,QX,QY,QZ,DCQ,CALPHA,CBETA,CGAMMA,DSAOB,IFLG
     1,XTEST,YTEST,ZTEST,DLTAX1,DLTAY1,DLTAX,DLTAY
     2,ZMIN,ZMAX,XMIN,YMIN,DLTAXI,DLTAYI,M,N

* Mod to specify external references for SCALE and RANGE * Linux *jd* 12.96
	external scale, size


 


      CXX=X-CX
      CYY=Y-CY
      CZZ=Z-CZ
      RK=DCQ/(CXX*CALPHA+CYY*CBETA+CZZ*CGAMMA)
      IF(IFLG.EQ.2) GO TO 10
      XX=((CX+RK*CXX-QX)*CBETA-(CY+RK*CYY-QY)*CALPHA)*DSAOB
      YY=(CZ+RK*CZZ-QZ)*DSAOB
      RETURN
   10 XX=((QX-CX-RK*CXX)*CGAMMA+(CZ+RK*CZZ-QZ)*CALPHA)*DSAOB
      YY=(CY+RK*CYY-QY)*DSAOB
      RETURN
C**  THIS PROGRAM VALID ON FTN4 AND FTN5 **
      END

	SUBROUTINE TM_TRANSLATE_AXIS (string, idim, answer, status)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* convert an ascii representation of an axis limit into a floating point 
* representation using special format rules
*
* programmer - Mark Verschell
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V530: *acm* 12/00 add calendar types; cal_id for time axes

* possible formats for world coordinate values:
*   x coord:  #  or #E  or  #W  for East, East, and West respectively
*   y coord:  #  or #S  or  #N  for South, South, and North respectively
*   z coord:  #
*   t coord:  #  or dd-mmm-yyyy@hh:mm:ss  eg 14-JAN-1986@11:15
*
* revision 0.00 - 12/13/88 - from TRANSLATE_LIMITS by Steve Hankin
* V530: *acm* 12/00 add calendar types; cal_id 
*
* 1/03 *kob* - g77 port - g77 won't allow intrinsic functions in PARAMETER
*                         statements.  use an character constant instead
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* Include files
	include 'tmap_errors.parm'
#include "gt_lib.parm"

* calling argument declarations:
	CHARACTER*(*)	string
	INTEGER		status, idim
	REAL*8		answer

* internal variable declarations:
	INTEGER*4	end_pos, dy, mnth, yr, hr, mnt, scnd
	INTEGER*4	TM_LENSTR1
	INTEGER		TM_GET_CALENDAR_ID, cal_id

	REAL*8		TM_SECS_FROM_BC

* internal parameter declarations:
	CHARACTER*1     tab 
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
#else
	PARAMETER     ( tab = CHAR(9))
#endif


	end_pos = TM_LENSTR1( string )

	IF ( idim .NE. t_dim ) THEN
* /X /Y or /Z
	  CALL TM_TRANSLATE_LAT_LONG ( string(1:end_pos), idim, answer,
     .	                               status )
	  IF ( status .NE. merr_ok ) GOTO 9990		! already reported

	ELSE
* /T
* ... is it a timestep?
	  READ (string(1:end_pos),*,ERR=200) answer
	  GOTO 1000
* ... is it a date/time string? (store as seconds for further processing)

  200	  CONTINUE
	  cal_id = 1
          CALL TM_BREAK_DATE(string, cal_id, dy, mnth, yr, hr, 
     .                       mnt, scnd, status)

	  IF ( status .NE. merr_ok ) GOTO 9990 		! Report in call routine
	  answer = -1.D0*TM_SECS_FROM_BC(cal_id, 
     .                                   dy,mnth,yr,hr,mnt,scnd,status)
	  IF (status .NE. merr_ok) GOTO 9990
	ENDIF

* successful completion
 1000	status = merr_ok

 9990	RETURN
	END

	SUBROUTINE LINE_FACTS_XML( lun, idim, grid, orient, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*

* display basic facts about the given line in xml-style format 

* programmer - Ansley Manke, based on line_facts.F
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* 6-Aug-2003

* 2/2005     bug 1171: the code checked line_regular instead
*            of line_modulo for modulo attribute!
* V581*acm*  6/05 - For fix to bug 1271, add flag line_shift_origin
*            and restore original t0 on output
* V600 *acm* 2/06 - Fix for bug 1394, send do_err flag to TM_DATE_REFORMAT
* V602 *acm* 1/07 - add <direction> output -- I J K L for the axis.
* V616  1/2009 *acm* Fixing LAS ticket 481, new style of xml output
* V631 11/09 *acm* For XML-formatted output check for and replace the strings < > and &
*                  with &lt; etc.
* V67  *acm* 2/11 XML fixes. New attribute formatting, ![CDATA] escape, upper/lowercase handling.
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*      *acm* 3/13 Dont show axes with names in parentheses e.g. (AX004)
* V698 2/16 *acm*  For ticket 1786: if mode_upcase is canceled write axis name
*                  using original upper/lowercase spelling
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.

	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include 'xtext_info.cmn'
	include 'xrisc.cmn'          ! 12/94 SPLIT_LIST buffer
        include 'errmsg.parm'
	include 'xdset_info.cmn_text'
	include 'netcdf.inc'

* calling argument declarations
	INTEGER	  lun, idim, grid, orient

* local variable declarations:
	LOGICAL	BKWD_AXIS, GEOG_LABEL, ITSA_TRUEMONTH_AXIS,
     .          calendar, new, got_it, coordvar, original
	INTEGER TM_LENSTR, TM_LENSTR1, TM_GET_CALENDAR_ID, 
     .          STR_SAME, line, slen, llen, ndec, cal_id, status,
     .            varid, vtype, nvdims, vdims(8), nvatts, blen, i, 
     .            len_attbuff, attoutflag, all_outflag, attid, 
     .            attlen, attype, iatt, iset, dset, alen
	CHARACTER TM_FMT*16, show_str*16, lo_str*20, hi_str*20, 
     .            title*32, outbuff*20, aname*128,
     .            attname*128, attbuff*2048, buff*20, outstring*2048,
     .            atype*10, axname*64

	REAL*8	TM_WORLD, lo_val8, hi_val8
	REAL      vals(100), fval

* local parameter declarations:
	INTEGER		sig_figs
	PARAMETER     ( sig_figs = 5 )

 2010	FORMAT ( '<axis name="', A8, 5x, A1, '">' )
 2020	FORMAT ( '<axis name="', A, '">' )
 2030	FORMAT ( '<attribute name="', A, '" type="char">' )
 2040	FORMAT ( '<attribute name="', A, '" type="short">' )
 2050	FORMAT ( '<attribute name="', A, '" type="double">' )
 2060   FORMAT ('   <value><![CDATA[', A, ' since ', A, ']]></value>')
 2070   FORMAT ('   <value>', A, '</value>')
 2075   FORMAT ('   <value><![CDATA[', A, ']]></value>')
 2080   FORMAT ('</attribute>')

* pull line from grid table
	line = grid_line( idim, grid )

* line ok ?
	risc_buff = ' '

	IF ( line .EQ. munknown ) THEN
	   title = 'unknown'
	   WRITE ( risc_buff, 2010 ) title, ww_dim_name( idim )
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
           status = 0
	ELSEIF ( line .EQ. mnormal ) THEN
	   title = 'normal'
	   WRITE ( risc_buff, 2010 ) title, ww_dim_name( idim )
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
           status = 0
	ELSE

	   original = .TRUE.
	   CALL CHOOSE_LINE_NAME(line, original, axname)

* header
	   IF (axname(1:1) .EQ. '(') GOTO 5000

           CALL ESCAPE_FOR_XML (axname, outstring, slen)
	   WRITE ( risc_buff, 2020 ) outstring(1:slen)

	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

* axis units, including ... since start date if time axis

* direction I,J,K, or L

           buff = ss_dim_name(idim)
           CALL ESCAPE_FOR_XML(buff, outstring, slen)
           WRITE ( risc_buff, 2030 ) 'direction'
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
           WRITE ( risc_buff, 2075 ) outstring(1:slen)
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
           WRITE ( risc_buff, 2080 )
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

* Units. Report since time origin for formatted time axis

           slen = TM_LENSTR(line_units(line))
           IF (line_units(line)(1:2) .NE. char_init 
     .           .AND. slen.GT.0) THEN
              
              WRITE ( risc_buff, 2030 ) 'units'
	      CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
              CALL ESCAPE_FOR_XML (line_units(line), outstring, slen)
              WRITE (risc_buff, 2075) outstring(1:slen)

              IF ( line_direction(line) .EQ. 'TI' ) THEN
              
	         buff = line_cal_name (line)
	         cal_id = TM_GET_CALENDAR_ID (buff)

	         IF (line_shift_origin(line)) THEN
	            buff = '01-JAN-0001 00:00:00'
	         ELSE
	            buff = line_t0(line)
	         ENDIF

	         CALL TM_DATE_REFORMAT (buff, 1, cal_id, outbuff, 2, 
     .               .TRUE., status) 
                 llen = TM_LENSTR1(outbuff)
                 WRITE (risc_buff, 2060) outstring(1:slen), outbuff(:llen)

              ENDIF
	      CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
              WRITE ( risc_buff, 2080 )
	      CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

           ENDIF

* line dimension

           show_str = TM_FMT(FLOAT(line_dim(line)), 7,16,slen)
	   CALL ESCAPE_FOR_XML (show_str, outstring, slen)
           WRITE ( risc_buff, 2040 ) 'length'
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
           WRITE ( risc_buff, 2070 ) outstring(1:slen)
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
           WRITE ( risc_buff, 2080 )
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)


* start and end

	   calendar = ( idim .EQ. t_dim .AND. GEOG_LABEL(idim, grid) )

           lo_val8 = TM_WORLD( 1, grid, idim, box_middle )
	   IF ( calendar ) THEN
	      ndec = 5 		! accurate to minutes
 	      CALL TRANSLATE_TO_WORLD( lo_val8, idim, grid, ndec, lo_str )
              CALL TM_DATE_REFORMAT (lo_str, 1, cal_id, outbuff, 2,
     .                               .TRUE., status)
              lo_str = outbuff
	   ELSE
	      ndec = -sig_figs	! 5 sig places w/out extra zeros
	      fval = lo_val8
	      lo_str = TM_FMT(fval, 7,16,slen)
	   ENDIF

	   hi_val8 = TM_WORLD( line_dim(line), grid, idim, box_middle )
	   IF ( calendar ) THEN
	      ndec = 5 
	      CALL TRANSLATE_TO_WORLD( hi_val8, idim, grid, ndec, hi_str )
              CALL TM_DATE_REFORMAT (hi_str, 1, cal_id, outbuff, 2,
     .                               .TRUE., status) 
              hi_str = outbuff
	   ELSE
	      ndec = -sig_figs
	      fval = hi_val8
	      hi_str = TM_FMT(fval, 7, 16, slen)
	   ENDIF

* Write the start and end; if dates then format them as for time origin.

           WRITE ( risc_buff, 2050 ) 'start'
           CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
           CALL ESCAPE_FOR_XML (lo_str, outstring, slen)

           WRITE ( risc_buff, 2070 ) outstring(1:slen)
           CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
           WRITE ( risc_buff, 2080 )
           CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

           WRITE ( risc_buff, 2050 ) 'end' 
           CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
           CALL ESCAPE_FOR_XML (hi_str, outstring, slen)

           WRITE ( risc_buff, 2070 ) outstring(1:slen)
           CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
           WRITE ( risc_buff, 2080 )
           CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

* axis oriented backwards ?
	   IF ( BKWD_AXIS(idim, grid) ) THEN
              WRITE ( risc_buff, 2030 ) 'positive'
	      CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
              WRITE ( risc_buff, 2075 ) 'down'
	      CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
              WRITE ( risc_buff, 2080 )
	      CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
	   ENDIF

* regularly spaced ?
           WRITE ( risc_buff, 2030 ) 'point_spacing'
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
	   IF ( line_regular( line ) .AND. .NOT.ITSA_TRUEMONTH_AXIS(line) ) THEN
              WRITE ( risc_buff, 2075 ) 'even'
	      CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
           ELSE
              WRITE ( risc_buff, 2070 ) 'uneven'
	      CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
           ENDIF
           WRITE ( risc_buff, 2080 )
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

* modulo ?
           WRITE ( risc_buff, 2030 ) 'modulo'
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
	   IF ( line_modulo( line ) ) THEN
              WRITE ( risc_buff, 2075 ) 'yes' 
           ELSE
              WRITE ( risc_buff, 2070 ) 'no'
           ENDIF
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)
           WRITE ( risc_buff, 2080 )
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

* All attributes not already listed.

1000    CONTINUE
        status = ferr_ok
	ENDIF
	RETURN
 5000	status = -1
	RETURN
	END

*
* tax_day.F
*
* Jing Y. Li 
* May 4th 2006
*
* This function returns day specified by the first argument (variable 
* containing time values) from the second argument (variable from which time 
* encoding will be inferred).
*

*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE tax_day_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

      CALL ef_version_test(ef_version)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     . 'Returns days of month of time axis coordinate values' )
   
*      CALL ef_set_num_work_arrays(id,1)

      CALL ef_set_num_args(id, 2)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 'time steps to convert')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'B')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 'variable with reference time axis')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE tax_day_compute(id, arg_1, arg_2, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy,
     .           mem2loz:mem2hiz, mem2lot:mem2hit)

      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      CHARACTER*20 datebuf
      INTEGER iyear, day_of_mon
      CHARACTER*3 cmon
      CHARACTER*80 err_msg
      REAL*8 ddate

      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      i1 = arg_lo_ss(X_AXIS,ARG1)
      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

           k1 = arg_lo_ss(Z_AXIS,ARG1)
           DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

              l1 = arg_lo_ss(T_AXIS,ARG1)
              DO 100 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

                  ddate = arg_1(i1,j1,k1,l1)

*     Get the datebuf corresponding to time ddate for the variable ARG2
                  CALL ef_get_axis_dates(id,ARG2,ddate,1,datebuf)
*                  print *, datebuf
                  
*     If datebuf is in form "DD-MON-YEAR HH:MM:SS". Read date and time.
                  READ (datebuf,110,err=900) day_of_mon, cmon, iyear
     
                  result(i,j,k,l) = day_of_mon 

                  l1 = l1 + arg_incr(T_AXIS,ARG1)
 100          CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 300     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
 400  CONTINUE

 110  FORMAT (i2, 1x, a3, 1x, i4) 

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
  900 CONTINUE

      WRITE (err_msg,*) 
     .  'Error assigning dates/times to timestamp for tax_day',  
     .  datebuf

      RETURN
      END

	INTEGER FUNCTION GCF_PARENT_UVAR( child_uvar )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* return the uvar number of the ancestor of this (child) uvar
*    Note that the ancestor may be a grand-parent or great-grand
*    For example, in the expression
*        A = FCN1(v1+v2) + B
*    where FCN1 is a grid changing function then "FCN1(v1+v2)" will be a
*    child of "A" and "v1+v2" will be a grand-child. The routine INIT_UVAR
*    will have designated "A" as the parent of "v1+v2". The purpose of
*    this routine would be to return the uvar of "A" when given the child_uvar
*    whose definition is "v1+v2"

* V450: 7/7/97
* V510: *sh* 1/00 -- simply corrected documentation
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

* calling argument declarations
	INTEGER		child_uvar

* internal variable declarations
	INTEGER   uvar

	include	'tmap_dims.parm'
	include 'ferret.parm'
	include 'xvariables.cmn'

* initialize
	uvar = child_uvar

 100	CONTINUE
	IF (uvar_parent(uvar) .NE. 0) THEN
* ... get the parent of this uvar
	   uvar = uvar_parent(uvar)       ! a child becomes a parent
	   GOTO 100
	ELSE
* ... end of the line -- this uvar has no parent
	   GCF_PARENT_UVAR = uvar
	   RETURN
	ENDIF

	END

      SUBROUTINE key_annotate (px, py, lab_digits, height, lohi, vh)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Label the color key with high and low values at each end
* (only if they're valid values) 
** V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus
* V685 *acm* 5/13  changes for ribbon plots

*  kpx		corners of box of color in colorbar
*  kpy
*  lab_digits	digits used in key labels
*  height	size of label
*  lohi		1 = lo, 2 = hi
*  vh		1 = vert, 2 = horiz

      INCLUDE 	'parampl5_dat.decl'
      INCLUDE 	'PARAMPL5.DAT'
      INCLUDE   'cont_inc.decl'
      INCLUDE	'CONT.INC'           ! with cont_key
      INCLUDE	'axis_inc.decl' 
      INCLUDE	'AXIS.INC'           ! with xorg, yorg
      INCLUDE	'PLTL.INC'           ! with makep
      INCLUDE	'hd_inc.decl'
      INCLUDE	'HD.INC'             ! with zmin, zmax

* Calling arguments
      REAL px(*),py(*), h_inc, height
      INTEGER lab_digits, lohi, vh

* Internal declerations
      INTEGER maxlen, slen, ldigits
      REAL x1, x2, x3, x4, y1, y2, y3, y4
      REAL delx, xx, yy, xxx, yyy
      CHARACTER*20 TM_FMT_SNGL_DIGITS, text

* If min and max values havent been set then return.
      IF (zmin .EQ. 1e33 .OR. zmax .EQ. -1*1e33) RETURN

* save px and py values
      y1 = py(1)
      y2 = py(2)
      y3 = py(3)
      y4 = py(4)

      x1 = px(1)
      x2 = px(2)
      x3 = px(3)
      x4 = px(4)

* Annotate min and max on vertical colorbar
      IF (lohi .EQ. 1 .AND. vh .EQ. 1 .AND. 
     .    zmin .NE. 1e33) THEN
         px(1) = px(1) +  (x3 - x1)/2.

         maxlen = 20
         ldigits = lab_digits+1
         text = TM_FMT_SNGL_DIGITS (zmin,ldigits,maxlen,slen)
	 xx = px(1)/1000.0 - xorg - (slen/2)* height
         yy = py(1)/1000.0 - yorg - 2.1* height
	 
      ENDIF

      IF (lohi .EQ. 2 .AND. vh .EQ. 1 .AND. 
     .    zmax .NE. -1*1e33) THEN
         px(1) = px(1) +  (x3 - x1)/2.

         maxlen = 20
         ldigits = lab_digits+1
         text = TM_FMT_SNGL_DIGITS (zmax,ldigits,maxlen,slen)
	 xx = px(1)/1000.0 - xorg - (slen/2)* height
         yy = py(3)/1000.0 - yorg + 1.1* height
	 
      ENDIF

* Annotate min and max on horizontal colorbar
      IF (lohi .EQ. 1 .AND. vh .EQ. 2) THEN
         py(1) = py(1) +  (y3 - y1)/2.

         maxlen = 20
         ldigits = lab_digits+1
         text = TM_FMT_SNGL_DIGITS (zmin,ldigits,maxlen,slen)
	 xx = px(1)/1000.0 - xorg - (slen+1)* height
         yy = py(1)/1000.0 - yorg - 0.5* height
	 
      ENDIF

* Annotate max
      IF (lohi .EQ. 2 .AND. vh .EQ. 2) THEN
         py(3) = y2 + (y1 - y2)/2.

         maxlen = 20
         ldigits = lab_digits+1
         text = TM_FMT_SNGL_DIGITS (zmax,ldigits,maxlen,slen)
	 xx = px(3)/1000.0 - xorg + 0.5* height
         yy = py(3)/1000.0 - yorg - 0.5* height
	 
      ENDIF

* FILL AND SHADE USE DIFFERENT COORD SYSTEMS -- *jd* 6.4.93
      if (makep .eq. 'SHADE' .or. makep .eq. 'FILLPOL' .OR.
     .         makep .EQ. 'POLYGON' .or. makep .eq. 'RIBPLOT') then
	 call point_convert (xx,yy,xxx,yyy)
      else if (makep .eq. 'FILL') then
         xxx = xx
	 yyy = yy
      endif

      call symbel (xxx,yyy,0.,height,slen,text(1:slen))

* Restore px, py

      py(1) = y1
      py(2) = y2
      py(3) = y3
      py(4) = y4

      px(1) = x1
      px(2) = x2
      px(3) = x3
      px(4) = x4

      RETURN
      END

	subroutine fixtim (it1,it2,itnew1,itnew2,itype)
C** 
C**    @(#)fixtim.f	1.1    3/10/88
C**
C**
C***********************************************************************        C**
C**                 EPIC
C**
C***********************************************************************        C**
C**
c
c  Input:
c	it1,it2 = input range of times in PLOT5's WHOI format (yyddmmhhmm)
c	itype   = PLOT5 axis type 0 even hours		ending     00
c                                 1 even days		ending   0000
c                                 3 even months		ending 010000
c                                 4 even minutes
c  Output:
c	itnew1,itnew2 = range of times which suit the input axis type and
c                       include the input range of times (yymmddhhmm)
c
c  Uses subroutines TIME1 (sequence # <--> WHOI times and NUMDM1
c  (# days in month) from PLOT5's MILELIB.
c
c  Programmed by N. Soreide, May 86.

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Mod J Davison 11.21.95 For 4 digit years
C *kob* 04/07/96 passed in character strings had to be declared 
C                with "*(*)" for the linux port 
C 
C *acm* 4/22/02  replace ALL places lower than the desired round-off
C                with 00.  e.g. if 950115013303 is to be expressed
C                in even hours, make it 950115010000 not 950115010003
C       3/19     issue 1920 and related. Compute the time it2new using
C                rather than reusing one that may be a few seconds off
C    

c
	character*(*) it1,it2,itnew1,itnew2
	character*14 cdum
c
	if (itype .eq. 3) then
	    itnew1=it1(1:4)//'01000000'//it1(13:14)

	    if (it2(5:10) .eq. '010000') then
		itnew2=it2
	    else
		dt=1440.
		nm=numdm1(it2)
		read (it2(5:6),*) id
		iseq=nm-id+2
		call time1 (1, it2(1:6)//'000000'//it2(13:14), iseq,
     1		                cdum, idum, itnew2, dt)
	    endif

	else if (itype .eq. 1) then
	    itnew1=it1(1:6)//'000000'//it1(13:14)
	    if (it2(7:12) .eq. '000000') then
		itnew2=it2
	    else
		dt=1440.
		iseq=2
		call time1 (1, it2(1:6)//'000000'//it2(13:14), iseq,
     1		                cdum, idum, itnew2, dt)
	    endif
	else if (itype .eq. 0) then
	    itnew1=it1(1:8)//'0000'//it1(13:14)
	    if (it2(9:10) .eq. '00') then
		itnew2=it2
	    else
		dt=60.
		iseq=2
		call time1 (1, it2(1:8)//'0000'//it2(13:14), iseq,
     1		                cdum, idum, itnew2, dt)
	    endif

	else if (itype .eq. 4) then
	    itnew1=it1(1:10)//'00'//it1(13:14)
	    if (it2(11:12) .eq. '00') then
		itnew2=it2
	    else
		dt=1.
		iseq=2
		call time1 (1, it2(1:10)//'00'//it2(13:14), iseq,
     1		                cdum, idum, itnew2, dt)
	    endif

	endif
	return
	end

	SUBROUTINE DO_4D_WGT( action,
     .				com, com_mr, com_cx,
     .				res, res_mr, res_cx,
     .				boxes )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* perform a multi-axis transformation

* multi-axis transformations are those special cases where sequential
* application of single-axis transforms may yield improper results. For
* example, averaging within a circular region would give inappropriate
* results if carried out sequentially: the first axis of averaging would
* be correct but the second axis would weight each averaged row from the
* first axis equally, despite the fact that they represented different
* numbers of data points.

* Return weights as for avg/integral on the grid

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA 
* 7/2014

* V692 7/14 *acm* new transform @WGT, ticket 2180
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.

	IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xunits.cmn_text'
	external xunits_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data

* internal variable declarations:
	LOGICAL GEOG_COS_FACTOR, ITSA_TRUEMONTH_AXIS,
     .		point, yes_ax(nferdims), no_ax(nferdims),need_cos, one_y
	INTEGER idim, i, j, ir, jr, kr, lr, mr, nr, ic, jc, kc, lc, mc, nc,
     .		grid, nbd, ngd, com_lo(nferdims), com_hi(nferdims),
     .		box_offset(nferdims), offset, ind_lo, ind_hi, cos_offset
	REAL	BOX_SIZE, unit, bad_com, bad_res, box, mean, diff,
     .		xbox, ybox, zbox, tbox, ebox, fbox,
     .		yc, yh, yh_2, bb, ybxlo, ybxhi
	REAL*8	TM_WORLD, dsum, bsum

* calling argument declarations:
	INTEGER	action, com_mr, com_cx, res_mr, res_cx
	REAL    com ( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .                m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          res ( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .                m2lot:m2hit,m2loe:m2hie,m2lof:m2hif ),
     .		boxes(*)

* equivalences
	LOGICAL yes_xax, yes_yax, yes_zax,
     .          yes_tax, yes_eax, yes_fax,
     .          no_xax,  no_yax,  no_zax,
     .          no_tax,  no_eax,  no_fax

     	INTEGER	ioffset, joffset, koffset, loffset, moffset, noffset,
     .		i_lo, j_lo, k_lo, l_lo, m_lo, n_lo,
     .		i_hi, j_hi, k_hi, l_hi, m_hi, n_hi

	EQUIVALENCE ( yes_ax(1), yes_xax ),
     .		    ( yes_ax(2), yes_yax ),
     .		    ( yes_ax(3), yes_zax ),
     .		    ( yes_ax(4), yes_tax ),
     .		    ( yes_ax(5), yes_eax ),
     .		    ( yes_ax(6), yes_fax ),
     .		    (  no_ax(1),  no_xax ),
     .		    (  no_ax(2),  no_yax ),
     .		    (  no_ax(3),  no_zax ),
     .		    (  no_ax(4),  no_tax ),
     .		    (  no_ax(5),  no_eax ),
     .		    (  no_ax(6),  no_fax ),
     .		    ( box_offset(1), ioffset ),
     .		    ( box_offset(2), joffset ),
     .		    ( box_offset(3), koffset ),
     .		    ( box_offset(4), loffset ),
     .		    ( box_offset(5), moffset ),
     .		    ( box_offset(6), noffset ),
     .		    (  com_lo(1),  i_lo ),
     .		    (  com_lo(2),  j_lo ),
     .		    (  com_lo(3),  k_lo ),
     .		    (  com_lo(4),  l_lo ),
     .		    (  com_lo(5),  m_lo ),
     .		    (  com_lo(6),  n_lo ),
     .		    (  com_hi(1),  i_hi ),
     .		    (  com_hi(2),  j_hi ),
     .		    (  com_hi(3),  k_hi ),
     .		    (  com_hi(4),  l_hi ),
     .		    (  com_hi(5),  m_hi ),
     .		    (  com_hi(6),  n_hi )

* --- end of introductory code ---

* initialize
	grid = mr_grid( com_mr )
	bad_com = mr_bad_data( com_mr )
	bad_res = mr_bad_data( res_mr )
        point = .FALSE.
	one_y = .FALSE.

* determine the axes to be transformed
	DO 10 idim = 1, nferdims
	  yes_ax(idim) = cx_trans(idim,res_cx) .EQ. action
	  no_ax (idim) = .NOT.yes_ax(idim)
 10	CONTINUE

* get and save grid box sizes (weights) just once for efficiency
* ... save all axes in one long array with offsets to find the starts
* Note that "cx_lo_ss(com_cx,idim)" is subtracted so offsets pre-compensate
*    for the axes starting above index = 1

	offset = 0
	DO 90 idim = 1, nferdims
	  IF (yes_ax(idim)) THEN
	    box_offset(idim) = offset - cx_lo_ss(com_cx,idim) + 1 ! pre-comp'ed
	    offset = offset + 
     .	             cx_hi_ss(com_cx,idim)-cx_lo_ss(com_cx,idim)+1
	  ELSE
	    box_offset(idim) = -9999
	  ENDIF
 90	CONTINUE
! COS(latitudes) also stored in the box array (8/96)
	cos_offset = offset - cx_lo_s2(com_cx) + 1

* ... save the box sizes
	DO 100 idim = 1, nferdims
	  ind_lo = cx_lo_ss(com_cx,idim)
	  ind_hi = cx_hi_ss(com_cx,idim)
	  offset = box_offset(idim)
	  IF (yes_ax(idim)) THEN
            point = .FALSE.
	    IF ( ind_lo .EQ. ind_hi ) THEN    ! 8/92
              boxes(ind_lo+offset) = cx_hi_ww(idim,res_cx)
     .				 - cx_lo_ww(idim,res_cx)
              point = boxes(ind_lo+offset) .EQ. 0.0
            ELSE
* ... partial box at lower end
	      boxes(ind_lo+offset) = TM_WORLD(ind_lo, grid, idim, box_hi_lim)
     .				 - cx_lo_ww(idim,res_cx)

* ... complete boxes mid-axis
	      DO 40 i = ind_lo+1, ind_hi-1
 40	      boxes(i+offset)  = BOX_SIZE( i, grid, idim )
* ... partial box at upper end
	      boxes(ind_hi+offset) = cx_hi_ww(idim,res_cx)
     .		   - TM_WORLD(ind_hi, grid, idim, box_lo_lim)
            ENDIF
* ... perform integrations on standard units if possible
            unit = 1.
	    unit = un_convert( line_unit_code(grid_line(idim,grid)) )
	    IF (ITSA_TRUEMONTH_AXIS(grid_line(idim,grid))) 
     .		  unit = un_convert(pun_day)

	    DO 50 i = ind_lo, ind_hi
 	      boxes(i+offset) = boxes(i+offset) * unit
 50         continue
 	    IF (point) boxes(ind_lo+offset) = 1.
	  ENDIF
 100	CONTINUE

* impose cosine factors if latitude and longitude are involved
* 5/97 - only use COS(y) if X integration is involved and Y axis lims are VALID
* 3/06 - apply Andrew*s suggested correction for XY integ., bug1348
* 6/06   fix the correction; boxes(i+offset) is in meters, so convert back to 
*        degrees, then radians. Compute the factor, and then convert to meters.
C See this thread:
C http://www.pmel.noaa.gov/maillists/tmap/ferret_users/fu_2009/msg00506.html
C And also ticket 1348. The surface area of sphere depends only on h
C http://mathworld.wolfram.com/Zone.html. Fix for @DIN too.

	need_cos = GEOG_COS_FACTOR( y_dim,grid )
     .		.AND. yes_xax
     .	 	.AND. cx_lo_s2(com_cx) .NE. unspecified_int4
        one_y = (cx_lo_ww(y_dim,res_cx) .EQ. cx_hi_ww(y_dim,res_cx))

	IF ( need_cos ) THEN
	   DO 120 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)

C Compute the y boxes if there is a y axis; the computation may be 
C avgs in other directions but we need the ybox size at a given y
C The top and bottom boxes extend only to the coordinate locations,
C (Unless there is just one grid cell in the y direction.)

#ifdef double_p
	      ybxlo = deg2rad* 
     .                TM_WORLD(j, grid, y_dim, box_lo_lim)
	      ybxhi = deg2rad* 
     .                TM_WORLD(j, grid, y_dim, box_hi_lim)
#else
	      ybxlo = deg2rad* 
     .                SNGL( TM_WORLD(j, grid, y_dim, box_lo_lim) )
	      ybxhi = deg2rad* 
     .                SNGL( TM_WORLD(j, grid, y_dim, box_hi_lim) )
#endif
	      IF (j .EQ. cx_lo_s2(com_cx) .AND. .NOT.one_y)
     .                ybxlo = deg2rad* cx_lo_ww(y_dim,res_cx)

	      IF (j .EQ. cx_hi_s2(com_cx) .AND. .NOT.one_y)
     .                ybxhi = deg2rad* cx_hi_ww(y_dim,res_cx)
	      
	      yh = ybxhi-ybxlo  
	      boxes(j+cos_offset) = ABS( SIN(ybxhi) - SIN(ybxlo) )/yh

 120       CONTINUE
	ELSE
	   DO 121 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
 121	      boxes(j+cos_offset)  = 1.0
	ENDIF

* do the transformation: return box size 

* Set default box size for untransformed axes
* (multiplying  by 1.0 to have nil effect)
	xbox = 1.0
	ybox = 1.0
	zbox = 1.0
	tbox = 1.0
	ebox = 1.0
	fbox = 1.0

* Loop over the component data, returning box sizes

	n_lo = cx_lo_s6(res_cx)
	n_hi = cx_hi_s6(res_cx)
	m_lo = cx_lo_s5(res_cx)
	m_hi = cx_hi_s5(res_cx)
	l_lo = cx_lo_s4(res_cx)
	l_hi = cx_hi_s4(res_cx)
	k_lo = cx_lo_s3(res_cx)
	k_hi = cx_hi_s3(res_cx)
	j_lo = cx_lo_s2(res_cx)
	j_hi = cx_hi_s2(res_cx)
	i_lo = cx_lo_s1(res_cx)
	i_hi = cx_hi_s1(res_cx)

* Set the range of loop indices for the component data on the transformed axes
	DO 150 idim = 1, nferdims
	  IF (yes_ax(idim)) THEN
	    com_lo(idim) = cx_lo_ss(com_cx,idim)
	    com_hi(idim) = cx_hi_ss(com_cx,idim)
	  ENDIF
 150	CONTINUE
	
	DO 220 nc = n_lo, n_hi
	IF (yes_fax) fbox = boxes(nc+noffset)
	DO 220 mc = m_lo, m_hi
	IF (yes_eax) ebox = boxes(mc+moffset)
	DO 220 lc = l_lo, l_hi
	IF (yes_tax) tbox = boxes(lc+loffset)
	DO 220 kc = k_lo, k_hi
	IF (yes_zax) zbox = boxes(kc+koffset)
	DO 220 jc = j_lo, j_hi
	IF (yes_yax) ybox = boxes(jc+joffset)
	DO 220 ic = i_lo, i_hi
	IF (yes_xax) xbox = boxes(ic+ioffset)

	    box = xbox * ybox * zbox * tbox * ebox * fbox
	    IF (need_cos) box = box * boxes(jc+cos_offset)
	    res(ic,jc,kc,lc,mc,nc) = box

 220	CONTINUE

	RETURN

	END

	SUBROUTINE PURGE_MR_AXIS( old_axis, new_axis, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* eliminate all stored mrs that use a given axis
* and replace all references within grids to the old axis with the new axis

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  8/4/89 - from PURGE_USER_VAR
*Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
* V450: 11/14/97 - check dynamic grids as well as static grids
*		(err450_redefine_axis_in_dyn_grid.jnl)
* V510 4/00 *sh* - netCDF data sets using dynamic grids, too
* V541 6/02 *acm*  call PACK_LINE_STORAGE to recover line_mem storage when irregular
*                  axis is cancelled.
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* v695 4/15 *acm*  Fix ticket 2271: If the record axis was redefined, we need
*                  to store that info in the record-axis storage

        IMPLICIT NONE
        include 'tmap_dims.parm'
#	include	"tmap_dset.parm"
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'tmap_errors.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xdset_info.cmn_text'


* calling argument declaration:
	INTEGER	old_axis, new_axis, status

* internal variable declarations:
	INTEGER	TM_GET_LINENUM, grid, idim, num_protected_axes, iset
	CHARACTER	I6*6

* the lowest axes are protected
	num_protected_axes = TM_GET_LINENUM( 'EZ' )  ! top protected axis
	IF ( old_axis .LE. num_protected_axes ) GOTO 5200

* only regular axes may be re-defined
* (to avoid dealing with messy memory pointers)
!	IF ( .NOT. line_regular( old_axis ) ) GOTO 5100

* delete all variables in memory that are based on grids using this axis
	DO 100 grid = 1, max_dyn_grids
	  IF (grid_name(grid) .EQ. char_init16) GOTO 100

	  DO 50 idim = 1, nferdims
	     IF ( grid_line(idim,grid) .EQ. old_axis ) THEN
	         CALL PURGE_MR_GRID( grid, status ) 
	         IF ( status .NE. ferr_ok ) RETURN
	         GOTO 100
	     ENDIF
 50	  CONTINUE

 100	CONTINUE

* now we are safe from errors: replace the old axis with the new one
* 4/00: - check among dynamic grids, too -- though there would at present never
*	be a replacement of one of these axes
	DO 250 grid = 1, max_dyn_grids
	  IF (grid_name(grid) .EQ. char_init16) GOTO 250

	  DO 200 idim = 1, nferdims
	     IF ( grid_line(idim,grid) .EQ. old_axis ) THEN
	         grid_line(idim,grid) = new_axis
	     ENDIF
 200	  CONTINUE

 250	CONTINUE
	line_use_cnt(new_axis) = line_use_cnt(old_axis)

* check for the axis in the list of record axes; replace the old with the new
	DO 300 iset = 1, maxdsets
	   IF (ds_time_axis(iset) .EQ. old_axis) ds_time_axis(iset) = new_axis
 300	CONTINUE

* delete the old axis
	IF ( .NOT.line_regular(old_axis) ) THEN
           CALL PACK_LINE_STORAGE(old_axis)
c	   WRITE ( I6,'(I6)' ) line_dim(old_axis)
c	   CALL WARN( I6//' words of axis coordinate storage lost' )
c	   line_subsc1( old_axis ) = unspecified_int4
	ENDIF
	line_use_cnt(old_axis) = 0
	line_name( old_axis ) = char_init16

	status = ferr_ok
	RETURN

* error exit
 5000	RETURN
! 5100	CALL ERRMSG( ferr_grid_definition, status,
!     .		'cannot delete axes with irregular points: '
!     .		//line_name(old_axis),
!     .		*5000 )
 5200	CALL ERRMSG( ferr_grid_definition, status,
     .		'protected axis: '//line_name(old_axis), *5000 )
	END

        SUBROUTINE TM_CHECK_EDGES_ATTRIB (cdfid, iaxis, vname, vlen, 
     .                                    ename, edgid, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* V570 5/2004 *acm*
* Check the edges attribute, issue any warnings
* V600 *acm* 10/05 should not have npts as an argument; npts from cd_get_1_axis
*                  was being reset  as npts bounds or edges, which is npts+1
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.

        INCLUDE 'tmap_dims.parm'
        INCLUDE 'xtm_grid.cmn_text'
        INCLUDE 'xio.cmn_text'
        INCLUDE 'tmap_errors.parm'
        INCLUDE 'netcdf.inc'

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

* argument declarations
      INTEGER cdfid, iaxis, vlen, edgid, status
      CHARACTER*(*) ename, vname

* Local variable declarations
      INTEGER TM_LENSTR1
      INTEGER elen, cdfstat, soft_err, vartype, nvdims,
     .          vdims(8), nvatts, npts
      CHARACTER*132 buff, vbuff

* does the variable pointed to really exist ?

        elen = TM_LENSTR1(ename)
	cdfstat = NF_INQ_VARID(cdfid, ename(:elen), edgid)
        IF (cdfstat.NE.NF_NOERR) THEN
           soft_err = 11
           GOTO 5000
        ENDIF

* get the vital statistics of the edges variable
        cdfstat = NF_INQ_VAR (cdfid, edgid, ename(:elen), vartype,
     .               nvdims, vdims, nvatts)
        IF ( nvdims .NE. 1 ) THEN
           soft_err = 12
           GOTO 5000
        ENDIF

* get axis length:
	cdfstat = NF_INQ_DIM (cdfid, vdims, buff, npts)
        IF (cdfstat.NE.NF_NOERR) GOTO 5100   ! should never happen

* check for error conditions
        IF ( npts .NE. line_dim(iaxis)+1 ) THEN
           soft_err = 13
           GOTO 5000
        ENDIF

        status = merr_ok
        RETURN

* error messages

 5000   CALL TM_NOTE( 'netCDF parent axis definition error', lunit_errors )
        buff = ename
        vbuff = vname
        IF ( soft_err .EQ. 1 ) THEN
           CALL TM_NOTE(
     .    '"true_size" attribute must have only max/min axis coords: '
     .       //vbuff(:vlen), lunit_errors )
        ELSEIF ( soft_err .EQ. 11 ) THEN
           CALL TM_NOTE('Edges definition "'//buff(:elen)//
     .                   '" points to no existing axis', lunit_errors )
        ELSEIF ( soft_err .EQ. 12 ) THEN
           CALL TM_NOTE('Edges definition "'//buff(:elen)//
     .                   '" is not 1D', lunit_errors )
        ELSEIF ( soft_err .EQ. 13 ) THEN
           CALL TM_NOTE('Edges "'//buff(:elen)//
     .          '" must be 1 pt longer than '//vbuff(:vlen), lunit_errors )
        ENDIF
        IF ( soft_err .LE. 10 ) THEN
           CALL TM_NOTE( 'Axis definition ignored', lunit_errors )
        ELSE
           CALL TM_NOTE( 'Edge definitions ignored', lunit_errors )
        ENDIF
        status = merr_ok + 1
        RETURN

 5100   status = pcdferr
        RETURN

        END

	SUBROUTINE EVAL_CONTEXT ( dflt_cx, expression, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* "evaluate context of expression"
* calculate grid and completed context based on the expression given
* without actually evaluating the expression

* NOTE THAT THIS ROUTINE CAN RETURN WRONG REGION INFORMATION FOR THE SPECIAL
* case of expressions like
*	let a = XSEQUENCE(J[j=1:3])
*	`a[i=100:200]`
* where explicit limits are given that do not match returns on ABSTRACT axes
* or on enhanced-header CDF files with incomplete axis regions included


* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V510: 3/00 - based on EVAL_EXPR
* V532: 5/01 *sh* - move the interpretation of region limits from the command
*		    line external to this routine

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
	include 'xfr_grid.cmn'

* calling argument declarations
	INTEGER	dflt_cx, status
	CHARACTER*(*) expression

* local variable declarations
	INTEGER		cx_expr
	CHARACTER	EXPR_NAME*8

* initialize grid stack pointer (pushes down from top)
	grd_stk_ptr = max_grids

* delete any memory left-overs from last command
!	CALL DELETE_MRS_IN_PROGRESS

* store expression in the uvar list names as "EX#1"
	CALL DELETE_OLD_EXPR
	CALL BREAK_UP_EXPR( expression, num_uvars_in_cmnd, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	IF ( num_uvars_in_cmnd .NE. 1 ) CALL ERRMSG
     .			(ferr_invalid_command,status,expression,*5000)

* reserve a context slot to hold a fresh command context
	cx_stack_ptr = cx_stack_ptr + 1
	cx_expr = cx_stack_ptr

* evaluate the expression
	CALL TRANSFER_CONTEXT( dflt_cx, cx_expr )
	CALL INTERP_CONTEXT( 1, cx_expr, EXPR_NAME(1), status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* success
	RETURN

* error exit
 5000	RETURN
	END

	REAL FUNCTION CX_WW_POS( idim, cx, isubsc ) 

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* return a single value representing the position of a context along an axis
* if the axis has been reduced to a point by, say, averaging then return the
* midpoint.
* If no reasonable position can be found then return bad_val4

*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'

* calling argument declarations:
	INTEGER		idim, cx, isubsc

* internal variable declarations:
	INTEGER	grid
	REAL*8	TM_WORLD

* initialize
	grid = cx_grid(cx)

	IF ( cx_lo_ss(cx,idim) .NE. unspecified_int4 ) THEN
* ... send back exact position
	   CX_WW_POS = TM_WORLD(isubsc,grid,idim,box_middle)
	ELSEIF ( cx_lo_ww(idim,cx) .NE. unspecified_val8 ) THEN
* ... send back midpoint of range
	   CX_WW_POS = (cx_lo_ww(idim,cx)+cx_hi_ww(idim,cx)) / 2.
	ELSE
* ... no valid position ...
	   CX_WW_POS = bad_val4
	ENDIF

	RETURN
	END

	SUBROUTINE CD_AXNAME_TO_WRITE (cdfid, idim, name, nlen, cdfstat)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - SDIG group
* revision 0.0 - 9/16
* For Ticket 2459
* v7.6 2/2020 *acm* write files with dimensions that are not coordinate variables

* Given cdfid for an open netCDF file we are writing, the dimension direction,
* and an axis name, return the name for writing, perhaps with a direction 
* appended. If there is already an axis with the same name but a different 
* direction. nlen on input is the length of name, on output
* it will be the length of the resulting name.

        include 'netcdf.inc'
	include 'tmap_dims.parm'
	include 'xtext_info.cmn'  ! with ww_dim_name

* Declare netcdf function names. 
* The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

	INTEGER cdfstat, cdfid, idim, nlen
	CHARACTER*(*) name

	INTEGER   cvarid, local_status, dimid
	CHARACTER buff*5, axis_dir*1


	local_status = NF_INQ_VARID( cdfid, name(:nlen), cvarid)

	buff = ' '
	IF (local_status .EQ. NF_NOERR) THEN
           local_status = NF_GET_ATT_TEXT (cdfid, cvarid, 'axis', buff)
	ENDIF

* If we change the axis name, mark status as 'dimension not found' in the
* file, then Ferret will go on and write the axis with the new name.

	IF (local_status .EQ. NF_NOERR) THEN
	    CALL STR_UPCASE(axis_dir, buff(:1))
	    IF (axis_dir .NE. ww_dim_name(idim))  THEN
	       name = name(:nlen)//ww_dim_name(idim)
	       nlen = nlen+1
	       cdfstat = NF_EBADDIM
	    ENDIF
	ENDIF

* Is this axis already in the file?  Then we are done.

	local_status = NF_INQ_VARID( cdfid, name(:nlen), cvarid)

	IF (local_status .EQ. NF_NOERR) THEN
	   cdfstat = NF_NOERR

* or, is it a dimension but not a coordinate variable?

	ELSE
	   local_status = NF_INQ_DIMID( cdfid, name(:nlen), dimid)
	   IF (local_status .EQ. NF_NOERR) cdfstat = NF_NOERR
	ENDIF
	   
	RETURN
	END

	SUBROUTINE BREAK_VARNAME( text, dset_in, varname, attname, 
     .                            varid, status )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Break up a name of the form varname.attname
* Check whether the variable exists within the dataset
* stored in linked-list structure of nc datasets.

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V600 6/05 *acm* Attribute control.
* V600  4/06 *acm* - additional declarations found by Solaris compiler
* V604 6/07 *acm* Fix bug 1518 If we didnt find the varid in the dataset,
*                 it may  be a user var(as in break_varattname, where the bug
*                 occurred, but make the same change here.)
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V6.94 3/15 *acm* Fix ticket 2249: attribute handling for user-defined variables
* V698 *acm* 1/16 change remaining dset=-1 to the parameter dset=pdset_uvars

        include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'	
	include 'rpn.parm'
	include 'xprog_state.cmn'
	include 'xrisc.cmn'
	include 'gfdl_vms.parm'	

* calling argument declaration:
	INTEGER		dset_in, varid, dset_try, status
	CHARACTER*(*)	text, varname, attname

* internal variable declarations:
        LOGICAL coordvar
	INTEGER	TM_LENSTR, TM_LENSTR1, STR_SAME,
     .         dset, tlen, vlen, dot, vartype, nvdims, nvatts, 
     .         vdims(8), all_outflag, first, second, dotdot
        CHARACTER*128 err_string

* Break text at dot: varname.attname

        dset = dset_in
        IF (dset .EQ. unspecified_int4) dset = pdset_uvars   ! try user variables.

        risc_buff = text
        tlen = MIN( size_rbuff, TM_LENSTR(text) )

        IF (tlen .LE. 1 .OR. INDEX(risc_buff,'.') .EQ. 0 ) THEN
           varname = risc_buff
           attname = ""
           GOTO 1000
        ENDIF

        dot = INDEX(risc_buff,'.')
        dotdot = INDEX(risc_buff,'..')
        IF (dotdot .GT. 0) dot = dotdot + 1

* is the name in quotations? If so then it may contain a dot and not
* be varname.attname See if its all within quotes, if so this is a 
* variable name containg a dot.

	first = INDEX(risc_buff(1:tlen), "'" )
	second = INDEX(risc_buff(2:tlen), "'" )
        IF (dot .GT. first .AND. dot .LT. second) THEN
           varname = risc_buff
           attname = ""
           status = ferr_not_attribute
           GOTO 5000
        ENDIF

        tlen = MIN(tlen, LEN(varname))
        tlen = MIN(tlen, LEN(attname))

        varname = risc_buff(:dot-1)
        attname = risc_buff(dot+1:tlen)

* Is the dot a decimal point within an expression, as in LIST a[y=0.5:9.5]
* or LIST a[gx=sst[d=1],y=1.5] Look for opening bracket in varname and
* closing bracket in attname.

        IF ((INDEX(varname,'[') .GT. 0)  .AND. 
     .      (INDEX(attname,']') .GT. 0)) THEN
           varname = risc_buff
           attname = ""
           GOTO 1000
        ENDIF

! varname.attname[d=1]  is ok
! varname[d=1].attname  is not ok

        IF ( INDEX(varname,'[') .GT. 0 ) GOTO 5100 

* Is the varname the keyword . referring to the dataset?
        IF (STR_SAME (varname, '.') .EQ. 0) THEN
           varid = 0
           GOTO 1000
        ENDIF
          
* Check that the dset contains the variable (varid=0 refers to . the 
* pseudovariable that refers to global attributes)

        CALL CD_GET_VAR_ID (dset, varname, varid, status)

* If we didnt find the name in the dataset, it may be a  user var,
* which just depends on that data set

        IF (status  .NE. ferr_ok) THEN
           dset_try = pdset_uvars
           CALL CD_GET_VAR_ID (dset_try, varname, varid, status)
           IF (status .EQ. ferr_ok) dset_in = pdset_uvars
           IF (status .EQ. ferr_ok) dset = pdset_uvars
        ENDIF


        IF (status .NE. ferr_ok) THEN
           status = ferr_unknown_variable
           GOTO 5200
        ENDIF

        vlen = TM_LENSTR1(varname)

        IF (status .NE. ferr_ok .AND. 
     .     (STR_SAME(varname(:vlen), '.') .NE. 0) ) THEN
           status = ferr_unknown_variable
           GOTO 5200
        ENDIF

        CALL CD_GET_VAR_INFO (dset, varid, varname, vartype, nvdims, 
     .                vdims, nvatts, coordvar, all_outflag, status) 

        IF (status .EQ. ferr_ok .AND. 
     .      (coordvar .AND. INDEX( risc_buff(:dot-1), '(' ) .EQ. 0) ) THEN
           status = ferr_syntax
           err_string = "enclose coordinate variables in parentheses"
           GOTO 5300
        ENDIF

        IF ( INDEX(attname,'.') .GT. 0 ) GOTO 5100

* successful completion. 

 1000	status = ferr_ok
	RETURN

* error exits
 5000	CONTINUE
	RETURN
 5100	CALL ERRMSG( ferr_syntax, status, risc_buff(:tlen), *5000 )
 5200	CALL ERRMSG( status, status, risc_buff(:tlen),  *5000 )
 5300	CALL ERRMSG( status, status, risc_buff(:tlen)//pCR//err_string, 
     .               *5000 )

	END

	SUBROUTINE GET_CMND_DATA (  dflt_cx, dtype, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* calculate grid(s) of data based on the expression given or implied.
* Expression(s) are in user-variable (uvar) structures.
* Implied expression is left from last command

* a sample command may look like:
*	prompt> CONTOUR/Z=50 TEMP[X=160E:160W]
* the "Z=50"		is a "command  qualifier" or "command  context modifier"
* the "X=160E:160W"	is a "variable qualifier" or "variable context modifier"
* contexts are transferred, modified and used in the following manner:
*   i)	skeletal context ( without grid-related info.) is specified in the call
*	Usually it is based on SET REGION,DTA_SET,etc. ( cx_last )
*  ii)	this context is modified by the command qualifiers given to produce a 
*	new skeletal context to be used for the evaluation of the current 
*	command ( cx_cmnd )
*  iii)	as the expression is evaluated each variable, as it is encountered,
*	begins with cx_cmnd and modifies it by the variable
*	qualifiers to produce the context at which the variable is to be
*	evaluated.

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V230:  7/27/92 - split into two separate routines, GET_PROT_CMND_DATA and
*                  and UUNPROTECT_CMND_DATA so that memory management can be
*                  used during command (e.g. LIST command needs to create
*                  permutations)
* V312: 5/94 - array "memory" as a calling argument
* V530 *sh* 9/00 - added initial support for multiple data types
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

        IMPLICIT NONE
	include 'errmsg.parm'

* calling argument declarations
	INTEGER	dflt_cx, dtype, status

* local variable declarations
* ...

        CALL GET_PROT_CMND_DATA(  dflt_cx, dtype, status )
        IF ( status .NE. ferr_ok ) RETURN

        CALL UNPROTECT_CMND_DATA

	RETURN
	END

	SUBROUTINE SHOW_DATA_SET_XML( lun, dset )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Output the name and list variables in the data set in xml-style format

* programmer - Ansley Manke, based on show_data_set_vars.F
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* 6-Aug-2003
* V5.80 13-Sep-2004 *acm* Add data-set specific user variables to the listing
*       30-Sep-2004 *acm* Move listing of dataset info to show_data.F, show any
*                         dataset-specific user-defined variables, use the
*                         tag <var name> rather than <vname>
*       13-Oct-2004 *acm* for consistent XML, write <var name="VNAME" />
* V67  *acm* 2/11 XML fixes. New attribute formatting, ![CDATA] escape, upper/lowercase handling.
* V698 2/16 *acm*  For ticket 1786: if mode_upcase is canceled write axis name
*                  using original upper/lowercase spelling

	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'ez_lib.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xez_info.cmn_text'
	external xez_info_data
	include	'ferret.parm'
	include	'xvariables.cmn'
	include	'xtext_info.cmn'
	include	'xprog_state.cmn'
	include	'xrisc.cmn'
	include 'errmsg.parm'

* calling argument declarations:
	INTEGER	lun, dset
	
* local variable declarations:
	LOGICAL coordvar
	INTEGER TM_LENSTR, TM_LENSTR1, ivar, iset, slen, varid, 
     .		vtype, nvdims, outflag, vdims(8), nvatts, status
        CHARACTER varname*150

 2040   FORMAT ('<var name="', A, '" />' )

* List the variables in the set

	risc_buff = ' '

	DO 400 ivar = 1, maxvars
	   IF ( ds_var_setnum(ivar) .NE. dset ) GOTO 400
           IF ( ds_var_code(ivar) .EQ. '-' ) GOTO 400
  
* ... output variable code. Get the original upper- or lower-case spelling

*           slen = TM_LENSTR1(ds_var_code(ivar))
           CALL string_array_get_strlen1(ds_var_code_head, ivar, slen)

           varname = ds_var_code(ivar)
           CALL CD_GET_VAR_ID (dset, varname, varid, status)
           IF (status .EQ. ferr_ok) 
     .        CALL CD_GET_VAR_INFO (dset, varid, varname, vtype, nvdims,
     .           vdims, nvatts, coordvar, outflag, status)
           slen = TM_LENSTR1(varname)
           WRITE ( risc_buff, 2040 ) varname(1:slen)
	   CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

 400	CONTINUE


* show the data-set-specific user-defined variables

	DO 600 ivar = 1, max_uvar
	   IF (uvar_num_items(ivar) .EQ. uvar_deleted  ) GOTO 600
	   IF (uvar_dset(ivar) .EQ. dset) THEN

* ... output variable name

	      varname = uvar_name_code(ivar)
	      iset = pdset_uvars
	      CALL CD_GET_VAR_ID (dset, varname, varid, status)
	      IF (status .EQ. ferr_ok) 
     .          CALL CD_GET_VAR_INFO (dset, varid, varname, vtype, nvdims,
     .           vdims, nvatts, coordvar, outflag, status)

	      slen = TM_LENSTR1(varname)
	      WRITE ( risc_buff, 2040 ) varname(1:slen)
	      CALL SPLIT_LIST(pttmode_explct, lun, risc_buff, 0)

           ENDIF
 600	CONTINUE

      RETURN
      END

*
* samplexy_curv_avg.F
*
* Ansley Manke
* 4/03 
* ???  Note: does not currently deal with modulo data  ???
* 1/06 Remove calls to SIGN to compile with f90 on IRIX.

* This function samples 4-d curvlinear data on the x and y axes 
* indicated by args 4 and 5
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE samplexy_curv_avg_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      CHARACTER*100 fcn_desc
      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns data sampled at a set of (X,Y) points, ',
     .   'using unweighted averaging')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 5)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, ABSTRACT, 
     .     NORMAL, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)

      CALL ef_set_num_work_arrays(id, 1)

      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'DAT_TO_SAMPLE')
      CALL ef_set_arg_desc(id, arg, 'variable (x,y,z,t) to sample')
      CALL ef_set_axis_influence(id, arg, NO, NO, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'DAT_LON')
      CALL ef_set_arg_desc(id, arg, 'longitudes of input variable')
      CALL ef_set_axis_influence(id, arg, NO, NO, YES, YES)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'DAT_LAT')
      CALL ef_set_arg_desc(id, arg, 'latitudes of input variable')
      CALL ef_set_axis_influence(id, arg, NO, NO, YES, YES)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'XPTS')
      CALL ef_set_arg_desc(id, arg, 'X values of sample points')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'YPTS')
      CALL ef_set_arg_desc(id, arg, 'Y values of sample points')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* loss               lo subscript for an axis
*
* hiss               hi subscript for an axis
*

      SUBROUTINE samplexy_curv_avg_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER my_lo_l, my_hi_l
      INTEGER nx, ny, nz, nt

*     Use utility functions to get context information about the 
*     1st argument, to set the abstract axis lo and hi indices.

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nx = arg_hi_ss(X_AXIS, ARG4) - arg_lo_ss(X_AXIS, ARG4) + 1
      ny = arg_hi_ss(Y_AXIS, ARG4) - arg_lo_ss(Y_AXIS, ARG4) + 1
      nz = arg_hi_ss(Z_AXIS, ARG4) - arg_lo_ss(Z_AXIS, ARG4) + 1
      nt = arg_hi_ss(T_AXIS, ARG4) - arg_lo_ss(T_AXIS, ARG4) + 1

      my_lo_l = 1
      my_hi_l = max(nx,ny,nz,nt)

      CALL ef_set_axis_limits(id, X_AXIS, my_lo_l, my_hi_l)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE samplexy_curv_avg_work_size(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays,  X/Y/Z/T dimensions
*
* ef_set_work_array_lens(id,array #,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi)
*
      INTEGER nx, ny

      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

*  workspace for saving locations of xpt in arg2 array.

      nx = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) 
      ny = arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) 

*  xlocations
      CALL ef_set_work_array_dims (id, 1, 1, 1, 1, 1, nx*ny, 2, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END
*
* In this subroutine we compute the result
*



      SUBROUTINE samplexy_curv_avg_compute(id, arg_1, arg_2, arg_3, arg_4, 
     .       arg_5, result, xlocations)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .     mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .     mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz,
     .     mem3lot:mem3hit)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz,
     .     mem4lot:mem4hit)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz,
     .     mem5lot:mem5hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .      memresloz:memreshiz, memreslot:memreshit)


* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable's axes.

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      COMMON /STOR/ mxdat, mydat
      INTEGER mxdat, mydat
      INTEGER nx, nxx, nxy, nxz, nxt
      INTEGER ny, nyx, nyy, nyz, nyt
      INTEGER ndimx, ndimy
      INTEGER nx1, nx2, nx3, ny1, ny2, ny3

*  Set up work arrays

      REAL xlocations(wrk1lox:wrk1lox+(wrk1hix-wrk1lox),wrk1loy:wrk1hiy,
     .                wrk1loz:wrk1hiz, wrk1lot:wrk1hit)
      REAL ylocations(2)

      INTEGER i, j, k, l
      INTEGER i1,j1,k1,l1
      INTEGER i2,j2,k2,l2
      INTEGER i3,j3,k3,l3
      INTEGER i4,j4,k4,l4
      INTEGER i5,j5,k5,l5

      LOGICAL need_modulo
      INTEGER ibot, itop, jbot, jtop
      INTEGER nloc, iloc, ptloc, icross
      REAL xpt, ypt, ydiff, yd
      REAL xptmin, xptmax, xcoordmin, xcoordmax
      REAL fbb, ftb, fbt, ftt
      REAL sum, count
      CHARACTER*255 err_msg

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

C Check that first 3 args are on the same grid.

      nx1 = arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 1
      nx2 = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1
      nx3 = arg_hi_ss(X_AXIS,ARG3) - arg_lo_ss(X_AXIS,ARG3) + 1
      ny1 = arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 1
      ny2 = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1
      ny3 = arg_hi_ss(X_AXIS,ARG3) - arg_lo_ss(X_AXIS,ARG3) + 1

      IF (nx1 .NE. nx2 .OR. nx2 .NE. nx3 .OR. nx1 .NE. nx3) THEN
         err_msg ='Arguments 1, 2, and 3 must have the same XY grid'
         GO TO 999
      ENDIF
      IF (ny1 .NE. ny2 .OR. ny2 .NE. ny3 .OR. ny1 .NE. ny3) THEN
         err_msg ='Arguments 1, 2, and 3 must have the same XY grid'
         GO TO 999
      ENDIF

C Check that sample x and y are simple lists of points - same length

      nxx = arg_hi_ss(X_AXIS,ARG4) - arg_lo_ss(X_AXIS,ARG4) + 1
      nxy = arg_hi_ss(Y_AXIS,ARG4) - arg_lo_ss(Y_AXIS,ARG4) + 1
      nxz = arg_hi_ss(Z_AXIS,ARG4) - arg_lo_ss(Z_AXIS,ARG4) + 1
      nxt = arg_hi_ss(T_AXIS,ARG4) - arg_lo_ss(T_AXIS,ARG4) + 1
      nx = max(nxx, nxy, nxz, nxt)

      nyx = arg_hi_ss(X_AXIS,ARG5) - arg_lo_ss(X_AXIS,ARG5) + 1
      nyy = arg_hi_ss(Y_AXIS,ARG5) - arg_lo_ss(Y_AXIS,ARG5) + 1
      nyz = arg_hi_ss(Z_AXIS,ARG5) - arg_lo_ss(Z_AXIS,ARG5) + 1
      nyt = arg_hi_ss(T_AXIS,ARG5) - arg_lo_ss(T_AXIS,ARG5) + 1
      ny = max(nyx, nyy, nyz, nyt)

      ndimx = 0
      ndimy = 0
      DO 110 i = X_AXIS,T_AXIS
         IF(arg_hi_ss(i,ARG4) - arg_lo_ss(i,ARG4) .GT.0) ndimx=ndimx + 1
         IF(arg_hi_ss(i,ARG5) - arg_lo_ss(i,ARG5) .GT.0) ndimy=ndimy + 1
  110 CONTINUE

      IF (nx .NE. ny   .OR.  ndimx .GT. 1  .OR. ndimy .GT.1) THEN
         err_msg = 
     .  'Arguments 4 and 5 must be 1-dimensional lists of equal length'
         GO TO 999
      ENDIF
      
* Initialize result

      DO 104 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
         DO 103 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            DO 102 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
               DO 101 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

                     result(i,j,k,l) = bad_flag_result

 101           CONTINUE
 102        CONTINUE
 103     CONTINUE
 104  CONTINUE

* Get range of arg_2, longitude coordinates, and arg_4, xpts to sample.
* is modulo-ing needed?

      xcoordmin = ABS(bad_flag(ARG2))
      xcoordmax = -1. * xcoordmin

      k2 = arg_lo_ss(Z_AXIS,ARG2)
      l2 = arg_lo_ss(T_AXIS,ARG2)

      DO 106 j2 = arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS,ARG2)
      DO 105 i2 = arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS,ARG2)
         IF (arg_2(i2,j2,k2,l2) .NE. bad_flag(ARG2)) THEN
            xcoordmin = MIN(arg_2(i2,j2,k2,l2), xcoordmin)
            xcoordmax = MAX(arg_2(i2,j2,k2,l2), xcoordmax)
         ELSE
            err_msg =
     .      'Arg 2, curvilinear X coordinates, contains missing values'
            GOTO 999
         ENDIF
  105 CONTINUE
  106 CONTINUE


      xptmin = ABS(bad_flag(ARG4))
      xptmax = -1.* xptmin
      DO 204 l4 = arg_lo_ss(T_AXIS,ARG4), arg_hi_ss(T_AXIS,ARG4)
      DO 203 k4 = arg_lo_ss(Z_AXIS,ARG4), arg_hi_ss(Z_AXIS,ARG4)
      DO 202 j4 = arg_lo_ss(Y_AXIS,ARG4), arg_hi_ss(Y_AXIS,ARG4)
      DO 201 i4 = arg_lo_ss(X_AXIS,ARG4), arg_hi_ss(X_AXIS,ARG4)

         IF (arg_4(i4,j4,k4,l4) .NE. bad_flag(ARG4)) THEN
            xptmin = MIN(arg_4(i4,j4,k4,l4), xptmin)
            xptmax = MAX(arg_4(i4,j4,k4,l4), xptmax)
         ELSE
            err_msg =
     .      'Arg 2, sample x points, contains missing values'
            GOTO 999
         ENDIF
  201 CONTINUE
  202 CONTINUE
  203 CONTINUE
  204 CONTINUE

      IF (xptmin .LT. xcoordmin) THEN
         need_modulo = .TRUE.
         add_xcoord = -360.
      ENDIF
      IF (xptmax .GT. xcoordmax) THEN
         need_modulo = .TRUE.
         add_xcoord = 360.
      ENDIF
 
*  For each (xpt,ypt) pair, search the data arrays arg2,arg3
*  for the nearest higher (x,y) lat-lon coordinates.  Interpolate 
*  arg_1 in 2 directions for the result.

      i4 = arg_lo_ss(X_AXIS,ARG4)
      j4 = arg_lo_ss(Y_AXIS,ARG4)
      k4 = arg_lo_ss(Z_AXIS,ARG4)
      l4 = arg_lo_ss(T_AXIS,ARG4)

      i5 = arg_lo_ss(X_AXIS,ARG5)
      j5 = arg_lo_ss(Y_AXIS,ARG5)
      k5 = arg_lo_ss(Z_AXIS,ARG5)
      l5 = arg_lo_ss(T_AXIS,ARG5)

      j = res_lo_ss(Y_AXIS)
      DO 600 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

* Find all locations of xpt in arg_2, longitudes of data

         xadd = 0.
	 xpt = arg_4(i4,j4,k4,l4)
         IF (need_modulo .AND. 
     .       ((xpt .LT. xcoordmin) .OR.(xpt .GT. xcoordmax)) )
     .    xadd = add_xcoord

         k2 = arg_lo_ss(Z_AXIS,ARG2)
         l2 = arg_lo_ss(T_AXIS,ARG2)

         nloc = 0

         DO 200 j2 = arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS,ARG2)
            i2 = arg_lo_ss(X_AXIS,ARG2)
            xcoord = arg_2(i2,j2,k2,l2) + xadd
c               icross = SIGN(1, (xpt - xcoord) )
            icross = 1
            IF ((xpt - xcoord) .LT. 0.) icross = -1

            DO 100 i2 = arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS,ARG2)
c               iloc = SIGN(1, (xpt-xcoord) )
               xcoord = arg_2(i2,j2,k2,l2) + xadd

               iloc = 1
               IF ((xpt-xcoord) .LT. 0. ) iloc = -1

               IF (icross .NE. iloc)THEN
                  nloc = nloc + 1
                  xlocations(nloc,1,1,1) = MAX(i2-1,1)
                  xlocations(nloc,2,1,1) = j2
c                  icross = SIGN(1, (xpt - xcoord) )
                  icross = 1
                  IF ((xpt - xcoord) .LT. 0.) icross = -1
               ENDIF
  100       CONTINUE

  200    CONTINUE

* Which of those locations is nearest ypt in arg_3, latitudes of data?

         ypt = arg_5(i5,j5,k5,l5)
         ydiff = ABS(bad_flag_result)
         ptloc = 1

         k3 = arg_lo_ss(Z_AXIS,ARG3)
         l3 = arg_lo_ss(T_AXIS,ARG3)

         DO 300 iloc = 1, nloc
            i3 = xlocations(iloc,1,1,1)
            j3 = xlocations(iloc,2,1,1)
            IF (arg_3(i3,j3,k3,l3) .EQ. bad_flag(ARG3)) THEN
               err_msg =
     .      'ARG 3, curvilinear Y coordinates, contains missing values'
               GOTO 999
            ENDIF

            yd = ABS(ypt - arg_3(i3,j3,k3,l3))

            IF ( yd .LT. ydiff ) THEN
               ylocations(1) = i3
               ylocations(2) = j3
               ydiff = yd
               ptloc = iloc
            ENDIF
  300   CONTINUE

        ibot = xlocations(ptloc,1,1,1)
        jbot = xlocations(ptloc,2,1,1)
        IF (ibot .GE. arg_hi_ss(X_AXIS,ARG1) ) ibot = ibot - 1
        IF (jbot .GE. arg_hi_ss(Y_AXIS,ARG1) ) jbot = jbot - 1

        itop = ibot + 1
        jtop = jbot + 1

*  First interpolate in x, getting values of the fcn at (x,jbot)  and (x,jtop)


         IF (ibot .GE. arg_lo_ss(X_AXIS,ARG1)  .AND. 
     .              itop .LT. arg_hi_ss(X_AXIS,ARG1) ) THEN

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            k2 = arg_lo_ss(Z_AXIS,ARG2)
            k3 = arg_lo_ss(Z_AXIS,ARG3)
            DO 500 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               l1 = arg_lo_ss(T_AXIS,ARG1)
               l2 = arg_lo_ss(T_AXIS,ARG2)
               l3 = arg_lo_ss(T_AXIS,ARG3)
               DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
      
                  fbb = arg_1(ibot,jbot,k1,l1) 
                  ftb = arg_1(itop,jbot,k1,l1)
                  fbt = arg_1(ibot,jtop,k1,l1)
                  ftt = arg_1(itop,jtop,k1,l1)

                  count = 0.
                  sum = 0.
                  IF (fbb .NE. bad_flag(ARG1)) THEN
                     count = count + 1.
                     sum = sum + fbb
                  ENDIF
                  IF (ftb .NE. bad_flag(ARG1)) THEN
                     count = count + 1.
                     sum = sum + ftb
                  ENDIF
                  IF (fbt .NE. bad_flag(ARG1)) THEN
                     count = count + 1.
                     sum = sum + fbt
                  ENDIF
                  IF (ftt .NE. bad_flag(ARG1)) THEN
                     count = count + 1.
                     sum = sum + ftt
                  ENDIF

*  If any data present, set the value at (x,y)

                  IF (count .GT. 0.) THEN
                     result(i,j,k,l) = sum/count
                  ELSE
                     result(i,j,k,l) = bad_flag_result
                  ENDIF

                  l1 = l1 + arg_incr(T_AXIS,ARG1)
                  l2 = l2 + arg_incr(T_AXIS,ARG2)
                  l3 = l3 + arg_incr(T_AXIS,ARG3)

 400           CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
               k2 = k2 + arg_incr(Z_AXIS,ARG2)
               k3 = k3 + arg_incr(Z_AXIS,ARG3)
 500       CONTINUE

         ENDIF  ! IF (ibot .GE. ...  .AND. itop .LT.  ...

         i4 = i4 + arg_incr(X_AXIS,ARG4)
         j4 = j4 + arg_incr(Y_AXIS,ARG4)
         k4 = k4 + arg_incr(Z_AXIS,ARG4)
         l4 = l4 + arg_incr(T_AXIS,ARG4)

         i5 = i5 + arg_incr(X_AXIS,ARG5)
         j5 = j5 + arg_incr(Y_AXIS,ARG5)
         k5 = k5 + arg_incr(Z_AXIS,ARG5)
         l5 = l5 + arg_incr(T_AXIS,ARG5)
600   CONTINUE

      RETURN
 999  CALL ef_bail_out (id, err_msg)

      END

	SUBROUTINE PLOTIFY_GRP_CX( cx_list, ncx )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* modify the joint context and document flags for a plot so that information
* which is implicitly documented via the plotting axes is not duplicated in
* the plot labels

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V200:	  1/5/90
* V230:   6/9/92 - added WIRE command
*        7/22/92 - turn off in-plane key info e.g. xy plane: VECT u,v[g=temp]
*  1/28/93 - for SHADE, CONTOUR and VECTOR return a 2D region if possible
* V500: *sh* added POLYGON command
* v68  *acm* 4/08 Allow shade, vector plots of degenerate regions - world region 
*              within a grid cell
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'command.parm'
	include	'slash.parm'
	include	'xcontext.cmn'
	include	'xplot_setup.cmn'
	include	'xprog_state.cmn'

* calling argument declarations
        INTEGER ncx, cx_list(ncx)

* internal variable declarations
	INTEGER	idim, cx, icx, ndim, ifix, pdim

* for PLOT/VS and WIRE the along-axis limits do need to be displayed
        IF ( cmnd_num .EQ. cmnd_wire
     . .OR.  cmnd_num .EQ. cmnd_polygon
     . .OR. (cmnd_num .EQ. cmnd_plot
     . .AND. qual_given(slash_plot_vs).GT.0) ) RETURN

* 1/93
* for SHADE, CONTOUR, and VECTOR promote 0 and 1D regions to 2D if possible
        IF ( cmnd_num .EQ. cmnd_contour
     . .OR.  cmnd_num .EQ. cmnd_shade
     . .OR.  cmnd_num .EQ. cmnd_vector ) THEN
           ndim = nplot_axis + 1
           DO 200 ifix = ndim, 2
              DO 150 idim = 1, nferdims
* axis already included in nplot_axis ?
                 DO 100 pdim = 1, nplot_axis
                    IF ( idim .EQ. plot_axis(pdim) ) GOTO 150
 100             CONTINUE
                 DO 110 icx = 1, ncx
                    cx = cx_list(icx)
                    cx = cx_cmnd

* suitable dimensions must have valid ww coords and indices
                    IF ( cx_lo_ss(cx,idim) .EQ. unspecified_int4
     .              .OR. cx_lo_ww(idim,cx) .EQ. unspecified_val8
     .              .OR. cx_lo_ww(idim,cx) .GE. cx_hi_ww(idim,cx) )
     .                                                    GOTO 150
 110             CONTINUE
* found a suitable dimension to promote the plot context with
                 plot_axis(ifix) = idim
                 nplot_axis = nplot_axis + 1
                 GOTO 200
 150          CONTINUE
 200       CONTINUE
        ENDIF

* limits along the plot axes are implicitly documented
	DO 300 pdim = 1, nplot_axis
	   idim = plot_axis(pdim)
	   cx_lo_ww(idim,cx_plot) = unspecified_val8
	   cx_hi_ww(idim,cx_plot) = unspecified_val8
	   key_doc(idim) = .FALSE.      ! 7/92
* ... but transformations along the plot axes are not
	   key_doc(idim+pdoc_offset_xform) = .TRUE.
 300	CONTINUE

	RETURN
	END

	INTEGER FUNCTION GCF_FIND_FCN( name )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* return the ID number of a grid changing function based on its name 

* V450: 12/96
*       97.07.16 *jc* adding code to allow call to efcn_get_id()
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

* calling argument declarations
	CHARACTER name*(*)

* internal variable declarations
	INTEGER         STR_MATCH, llen, TM_LENSTR1
	INTEGER efcn_scan, efcn_get_id, efcn_already_have_internals

* internal parameter declarations:
        INTEGER      slen
        PARAMETER  ( slen = 40 )
 
#ifdef sun
        BYTE      fhol(slen)    ! c-type Hollerith string buffer
#else
        INTEGER*1 fhol(slen)    ! c-type Hollerith string buffer
#endif

 
	include	'tmap_dims.parm'
	include 'ferret.parm'
	include 'xgrid_chg_fcns.cmn'

* check the internal grid changing functions first

	GCF_FIND_FCN = STR_MATCH ( name,
     .                               gfcn_name, gfcn_num_internal )

        IF ( GCF_FIND_FCN .NE. atom_not_found ) THEN
	   RETURN
	ENDIF


* no match. so check external functions
	IF ( efcn_scan(gfcn_num_internal) .EQ. 0 ) THEN

	   GCF_FIND_FCN = unspecified_int4
	   RETURN

	ELSE

*       true string length
*       convert to a null-terminated Hollerith
*       call the external functions library routine to see if it is external

	   llen = TM_LENSTR1( name )
	   CALL TM_FTOC_STRNG( name(:llen), fhol, slen )
	   GCF_FIND_FCN = efcn_get_id( fhol )

	   IF (GCF_FIND_FCN .EQ. ATOM_NOT_FOUND ) THEN
	      GCF_FIND_FCN = unspecified_int4
	   ELSE
*       chances are we're going to want to do something with this function
	      if ( efcn_already_have_internals(gcf_find_fcn) .eq. 0 ) then
		 call efcn_gather_info(gcf_find_fcn)
	      endif
	   ENDIF

	ENDIF	   
	
	RETURN

	END
 

	SUBROUTINE CLEAN_STACK

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* following an error during stack computation restore the stack variables
* to a "clean" state

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* Unix/RISC port - version 0.0 - 9/25/91 *sh*
* this corrects a bug in the VMS version, too: SET GRID following an error
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

	include		'tmap_dims.parm'
	include		'ferret.parm'
	include 	'xvariables.cmn'

* unset is_cx(1) reflecting last data access as a failure
      is_cx(1) = unspecified_int4

	RETURN
	END

	SUBROUTINE CREATE_AGG_DSET (agg_dset, dname, dpath, dtitle,
     .               nsets, dset1, agg_dim, iline, status)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP 
*
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V685 *acm*  3/13 For Ensemble aggregations, call the ds_type 'ENS'
* V695 *acm*  2/15 For Forecast aggregations, call the ds_type 'FCT'
* V695+ *sh*  11/15 Correct bugs in setting of aggregate dset title
* V698  *sh*  1/16 pass explicit path name (for "USE file.agg" compatibility)
* V7   *acm*  6/12 Add Union aggregations: DEFINE DATA/AGG/U

* calling argument
*   agg_dset	- dataset number of the aggregation (input)
*   dname	- name of the aggregated dataset (input)
*   dpath	- pathname of the aggregated dataset (input)
*   dtitle	- optional title string (input)
*   nsets	- number of datasets in the aggregation (input)
*   dset1	- dataset number of first (pattern) dataset in agg (input)
*   agg_dim	- idim number (5 or 6) of aggregation dimension (input)
*   iline	- ??
*   status	- return status (output)

      IMPLICIT NONE
        include 'tmap_errors.parm'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
	include 'xstep_files.cmn_text'
	include	'ferret.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xdset_info.cd_equiv'
        include 'xprog_state.cmn'
	include 'xtm_grid.cmn_text'  
	include 'errmsg.parm'
	include 'netcdf.inc'
	include 'xvariables.cmn'
	include 'xtext_info.cmn'

* calling argument declarations:
	CHARACTER*(*)	dname, dpath, dtitle
	INTEGER		agg_dset, nsets, dset1, agg_dim, iline, status

* local variable declarations:
	INTEGER TM_LENSTR, TM_LENSTR1,
     .		type, coordvar, varid, big_cx, nlen, istep
	CHARACTER LEFINT*20, ntext*20
	REAL	bad_flag

	CALL CD_INIT_AGG_DSET (agg_dset, dname, status)

	IF (status .NE. ferr_ok) GOTO 5300 

* Set the dataset type and title (can add other directions)
	IF (agg_dim .EQ. e_dim ) ds_type(agg_dset) = 'ENS'
	IF (agg_dim .EQ. f_dim ) ds_type(agg_dset) = 'FCT'
	IF (agg_dim .EQ. unspecified_int4 ) ds_type(agg_dset) = 'UNI'

	ds_name(agg_dset) = dname
	ds_des_name(agg_dset) = dpath

	IF (dtitle(1:2).EQ.char_init .OR. TM_LENSTR(dtitle).EQ.0) THEN
	   ntext = LEFINT(nsets, nlen)
	   IF (agg_dim.EQ.e_dim) THEN
	      ds_title(agg_dset) = "Ensemble"
	   ELSEIF (agg_dim.EQ.f_dim) THEN
	      ds_title(agg_dset) = "Forecast"
	   ELSE
	      ds_title(agg_dset) = "Union"
	   ENDIF
	   IF (agg_dim .EQ. unspecified_int4) THEN
	      ds_title(agg_dset) = 
     .	        'Union of variables from member datasets'
	   ELSE
	      ds_title(agg_dset) = ds_title(agg_dset)(:8)//' series of '
     .		//ntext(:nlen)//' datasets patterned on '//
     .		ds_name(dset1)
	   ENDIF
     
	ELSE
	   ds_title(agg_dset) = dtitle
	ENDIF
	ds_mod_title(agg_dset) = ' '
 
* assign a stepfile to this dataset (needed for consistency with other dsets)
        DO istep = 1,maxstepfiles
          IF (sf_setnum(istep) .EQ. set_not_open) THEN
	     sf_name  (istep) = dname
	     sf_setnum(istep) = agg_dset
             GOTO 100
          ENDIF
	ENDDO
* No room left for new stepfiles
       GOTO 5400
 
* create the aggregate axis
 100	IF (agg_dim .NE. unspecified_int4) 
     .		CALL CREATE_AGG_AXIS (nsets, agg_dim, iline, status)
	IF (status .NE. ferr_ok) GOTO 5300 

	RETURN
	
 5000   RETURN	
 5300   status = ferr_TMAP_error
	GOTO 5000
 5400	CALL ERRMSG(ferr_internal, status, 'create_agg_dset', *5000)
	END

	SUBROUTINE DSG_COORDS_UPDN (npts, coords, bad, ascending, status)
	      

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Are the coordinates in ascending or decending order?

* NOAA/PMEL, Seattle, WA - Science Data Integration Group
* V751 8/19 *acm* 

        IMPLICIT NONE
	include 'ferret.parm'
	include 'errmsg.parm'

* calling argument declarations:
	LOGICAL ascending
	INTEGER npts, status
	REAL	coords(*), bad

* internal variable declarations:
        INTEGER i, ic, change
	REAL	val0

	status = ferr_ok

* ... find first valid value

	ic = 1
	DO i = 1, npts
	   val0 = coords(1)
	   ic = i
	   IF (val0 .NE. bad) EXIT
	ENDDO

* ... all bad, or only the last one valid (shouldn't happen)
	IF (ic .EQ. npts) RETURN

* ... Are the values ascending or descending? 
*     If they change more than once, that's an error

	change = 0
	DO i = ic+1, npts
	   IF (coords(i).LT.val0 .AND. ascending) THEN
	      ascending = .FALSE.
	      change = change+1
	      IF (change .GT. 1) GOTO 5100
	   ENDIF

	   IF (coords(i).GT.val0 .AND. .NOT.ascending) THEN
	      ascending = .TRUE.
	      change = change+1
	      IF (change .GT. 1) GOTO 5100
	   ENDIF
	   val0 = coords(i)
	ENDDO

 5000	RETURN

 5100	CALL ERRMSG( ferr_regrid, status,
     .		'Z coordinates within profiles are not monotonic', *5000)
	END

	SUBROUTINE SETUP_GATHER( aclass, res_cx, src_cx, lo_isp,
     .				  axis, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* GATHER CHECK !!!
* This routine is called, to determine if a split/gather operation is needed,
* and if so to create the context descriping the "chunks" to
* be gathered and the axis (or axes) along which gathering will occur

* If the grid we are about to request (hi_cx) is going to exceed reasonable
* size limits then try to split the calculation into fragments.
* For example, TEMP[I=1:100@DIN,J=1:100@AVE,K=1:25@AVE,L=1:100@AVE]
* the required data is 100x100x25x100 - TOO BIG !!
* after the L and K transforms have been split off we will have
* TEMP[I=1:100@DIN,J=1:100@AVE,K=1:25,L=1:100] which is a reasonable 2500 pts.
* after the next strip, however, the request will be 100 times larger.  At this
* time we would be better to split up the context, say, along the L axis so
* that each requested component is a manageable size.
* Similarly, modulo regrids may involve source data greatly in excess
* of the result

* NOTE that this routine does a precice job for a single transformation
* (including "4d" transforms) and modulo regridding. Where it is weak is
* when a single expression contains more than one transform -- e.g.
* "V[x=@ave,t=@sum]" or "V[gt=clim@mod,x=@ave]".  In general such syntaxes
* should be discouraged.
* V702  3/17 *sh* Code extracted from IS_STRIP and several refinements added
* V720 5/17 *sh* added support for DSG regridding splits
*      fixed undetected bug in POTENT_AX_LIMS call for min_mem_used below
* V7.21 9/17 *acm Fix ticket 2561. Multiple transformations and multiple-axis 
*                 transformations on the split axis.stk/setup_gath
* V740  3/18 *acm* Introduce parameter abstractax_len for abstract axis length 99999999
* V740  3/18 *acm* Fix issue 1964: unending loop on scatter/gather when grid length
*                  returned as abstract-axis length

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'
	include	'xalgebra.cmn'
	include	'xax_speed.cmn'
        include 'xtm_grid.cmn_text'

* calling arguments:
*  res_cx - (input) (aka lo_cx) context of the result, including
*                   the transform (e.g. @AVE)
*  src_cx - (inout) (aka hi_cx) On input the full context that must
*                   be processed in order for Ferret to compute the transform.
*                   On output it is the context of the first chunk
*  axis   - (inout) If splitting occurs it may not be along the transform axis 
 
* calling argument declarations:
	INTEGER	aclass, res_cx, src_cx, lo_isp, axis, status

* internal variable declarations:
	LOGICAL ITSA_MODULO_REGRID, TM_ITSA_DSG,
     .		itsa_uvar, split_on_compressed_ax, dup_split,
     .		inadequate_split_length, use_caution, no_axis_found,
     .		multiax_trans(nferdims),
     .		ax_splittable(nferdims),
     .		ax_compressed(nferdims),
     .		its_dsg
	INTEGER	POTENT_SIZE, CGRID_UVAR_SIZE, CGRID_SIZE_MAX,
     .		i, i1, i2, dset, var, cat, big_cx, split_ax, ax_trans,
     .		frag, lo_ss, hi_ss, trans, nbuffers, ax1, ax2,
     .		split_ax_len, ncomp, nsplittable,
     .		n_dfrnt_xforms, ax_len(nferdims)
	INTEGER*8 available_mem, set_aside_mem, free_mem,
     .		deferred_essential_mem, min_mem_used, res_size, src_size,
     .		ax_min_mem(nferdims)
	REAL	rsrc_size, reduction_factor_needed

******
* logic in this routine goes in 4 phases
* 0. Initialize: amount of memory available, the size of the result, etc.
* 1. Determine if splitting is needed              (exit if no)
* 2. Find the slowest single axis split that fits  (skip to step 4 if found)
* 3. Find the slowest 2-axis split that fits       (skip to step 4 if found)
*      If no solution so far, reduce the memory held in reserve and goto 2
* 4. Setup the split/gather
******

* initialize
	dset = cx_data_set( res_cx )
	var  = cx_variable( res_cx )
	cat  = cx_category( res_cx )
	itsa_uvar = cat .EQ. cat_user_var
	use_caution = mode_state(pmode_frugal,1)
	status = ferr_ok
	IF ( aclass.EQ.isact_class_trans ) THEN
	   its_dsg = .FALSE.
	ELSE
	   its_dsg = TM_ITSA_DSG(cx_grid(res_cx))
	ENDIF

* if we are returning here as part of a multi-axis split, then the isp stack
* level just above us will also be isact_gather.  If so, learn the amount of
* memory of memory that the previous axes have committed
	IF (lo_isp .LT. 2) RETURN ! should never happen. Playing it safe.
	IF (is_act(lo_isp-1) .EQ. isact_gather) THEN
	   deferred_essential_mem = is_deferred_mem(lo_isp-1)
	ELSE
	   deferred_essential_mem = 0
	ENDIF	

****************************************************************
* ***** PHASE 1. Determine if splitting is needed   (exit if no)

* how much memory will be needed for the full source data of the transform?
	IF ( aclass.EQ.isact_class_trans ) THEN 
!	   src_size = CGRID_SIZE( src_cx )
! ... have to use POTENT_SIZE because of cases like V[X=@SUM,T=@AVE]
	   src_size = POTENT_SIZE( res_cx )
	   trans  = cx_trans( axis, res_cx )
	ELSE					! modulo regrid
! ... FIXME: CGRID_SIZE_MAX is buggy, and a calc like POTENT_SIZE is needed
!            if modulo regridding and @AVE are combined on a single variable
!        For a regrid to DSG the source data size calc should be correct
	   src_size = CGRID_SIZE_MAX( src_cx )	! unknown lims get len=line_dim
	   trans = trans_no_transform
	ENDIF

* If it has an abstract axis, just nominally set a size.  The actual limits
* will be evaluated as the computation proceeds.

	IF (src_size .EQ. FLOAT(abstractax_len)) THEN
	   src_size = 1000
	ENDIF 

* locate other axes of a multi-axis transform (e.g. xy average)
* and determine how many *different* compressing transforms there are
	n_dfrnt_xforms = 0
        DO i = 1, nferdims
           multiax_trans(i) = cx_trans(i, res_cx) .EQ. trans
	   IF (.NOT.multiax_trans(i)
     .    .AND. (cx_trans(i,res_cx) .GT. trans_compress_code) )
     .		n_dfrnt_xforms = n_dfrnt_xforms + 1
        ENDDO

* how many result buffers are needed?
* ... to split/gather on a compressed axis requires
*     1) the result
*     2) the accumulation buffer (e.g. @ave requires a running sum)
*     3) additional accumulation buffer for @VAR
* ... modulo regrids require 3 buffers, plus one more for modvar (see IS_TRANS)
*     If split/gather occurs on the compressed axis, then the buffers are
*     part of the result size.  If the split/gather occurs on another axis
*     then the buffers are part of the chunk size (the "source" data - src)
	IF (aclass .EQ. isact_class_trans) THEN
	   IF (trans .EQ. trans_variance) THEN
	      nbuffers = 3
	   ELSE
	      nbuffers = 2
	   ENDIF
	ELSEIF (its_dsg) THEN
	   nbuffers = 2  !   really, 1.5 since DSG result usually much smaller
	ELSE
	   IF (cx_regrid_trans(axis,res_cx) .EQ. prgrd_modvar) THEN
	      nbuffers = 4   ! see IS_REGRID
	   ELSE
	      nbuffers = 3
	   ENDIF
	ENDIF

*  ...to compute a user variable often requires temporary vars and other
*     component vars to be held in memory at once as function arguments
*     As a default cautious assumption we will allow a uvar to use only
*     1/4 as much memory, figuring there may be 4 of them in memory at once
*     NOTE: This is the crudest heuristic used in this memory management (3/17)
*     It forces Ferret to use much less memory on a uvar, even if its
*     definition is simply V=fvar, which needs no extra memory at all because
*     it uses RE_ASSIGN_VARIABLE in IS_ALGEBRA.  The best improvement I have
*     been able to come up with for this would be that during get_grid phase
*     in addition to a grid we compute a "max_significant_stack_depth" for
*     each uvar.  This would count only the fvars and uvars (not constants and
*     pseudo-vars which are small) that need to be on the stack simultaneously
*     In pyramids of definitions, the stack requirements of child vars would
*     need to factor into this calculation (heuristically, cuz the exact stack
*     max cannot be determined in this simple way).
	IF (itsa_uvar) THEN
	   ncomp = 4   ! a pretty cautious choice
	ELSE
	   ncomp = 1
	ENDIF
* ... if there are multiple transforms on the expression, each acts like
*     another component to be evaluated (at least I think so ...)
	ncomp = ncomp + n_dfrnt_xforms

* how much memory is there that is not already committed
	free_mem = max_mem_allowed
     .		- (permanent_mem + essential_mem + deferred_essential_mem)

* ... if the available memory is so small that even the result cannot fit, 
*     abort now where we can give the most informative error report
*     Note that IS_STRIP (and this routine) gets called up a second time
*     whenever an uncompressed axis has been chosen for splitting.  At that
*     time deferred_committed_mem will reflect the size of the result buffer
*     from the first pass.
	res_size = CGRID_UVAR_SIZE( res_cx )   ! size of result
	IF (free_mem .LE. res_size) GOTO 5100 

* how much memory to set aside as hedge against running out?
	IF (use_caution) THEN
	   set_aside_mem = (mode_arg(pmode_frugal,1)/100.) * free_mem
	   available_mem = free_mem - set_aside_mem
	ELSE
	   available_mem = free_mem
	ENDIF

* do we need to split up the calculation ?
	IF ( ((ncomp*src_size)+(nbuffers*res_size))
     .	 .LE. available_mem                           ) RETURN

****************************************************************
* ***** PHASE 2. Find the best single axis split    (skip 3 if yes)

* Init phase 2 variables
 100	nsplittable       = 0
	inadequate_split_length = .FALSE.

* Loop through the potential spliattable axes, giving preference to
* axes of slower access
	DO i = nferdims, 1, -1
	   IF ( dset.GT.pdset_irrelevant .AND. dset.LE.maxdsets ) THEN
              split_ax = ds_ax_speed(i, dset)
	   ELSE
	      split_ax = i
	   ENDIF

	   ax_splittable(split_ax) = .FALSE.  ! default until proven other

* Cannot split/gather on axes that are transformed with an algorithm
*       that depends upon looking at neighboring data points (well, not so
*       easily, anyway). smoothers, fillers, @LOC, etc.
	   ax_trans = cx_trans(split_ax,res_cx)
	   IF    (ax_trans .NE. trans_no_transform) THEN
	      IF (ax_trans .LE. trans_compress_code
     .       .OR. ax_trans .EQ. trans_locate        ) CYCLE
	   ENDIF

* Cannot split along a modulo regrid axis
	   IF ( ITSA_MODULO_REGRID(res_cx,split_ax) ) CYCLE

* Beware user-defined vars with limits specified in definition
	   IF ( itsa_uvar ) THEN
	      IF ( uvar_given(split_ax,var) .NE. uvlim_needed ) CYCLE
	   ENDIF

! 5/17 bug fix: was "axis" instead of "split_ax" here
	   IF (its_dsg) THEN
	      CALL POTENT_AX_LIMS(src_cx, split_ax, lo_ss, hi_ss)
	   ELSE
! 5/17 quite likely could get lims from src_cx, but if it aint broke ...
	      CALL POTENT_AX_LIMS(res_cx, split_ax, lo_ss, hi_ss)
	   ENDIF
	   split_ax_len = hi_ss - lo_ss + 1
	   IF (split_ax_len .EQ. 1) CYCLE

* The only compressed axes allowed for splitting are THE trans
* If there is more than one compressing transform (e.g. V[z=@AVE,T=@VAR])
* reordering them may give a wrong result due to non-linearity
* If res_cx includes other compressing transformations
* INTERP_STACK & IS_STRIP will return us here for those in turn
	   split_on_compressed_ax = ax_trans .GT. trans_compress_code
	   IF (split_on_compressed_ax
     .    .AND. .NOT.multiax_trans(split_ax)  )   CYCLE

* When there are multiple transformations in the expression and 
* multiple-axis transformations on the split axis, the gather 
* was returning only the last chunk of the split.

	   IF (split_on_compressed_ax .AND. n_dfrnt_xforms .GT. 1) CYCLE

* By how much does the source data exceed the available space?
* For a compressing calculation like @AVE
*     available_mem must hold   [nbuffers*res_size+src_size]  at one time
* If we split along the compressed axis there must be room for the result
* with its buffers and a chunk of source data reduced along the compressed axis
* ==> mem_used     = nbuffers*res_size + src_size/reduction_factor
* The maximum reduction factor is when we split into chunks of a single index
* ==> min_mem_used = nbuffers*res_size + src_size/split_ax_len
* If we split along an uncompressed axis, each chunk of the calculation
* acts like a smaller version of the full transformation, where the length
* of the split axis has been reduced
* ==> mem_used     = res_size + (nbuffers*res_size+src_size)/reduction_factor
* ==> min_mem_used = res_size + (nbuffers*res_size+src_size)/split_ax_len
	   rsrc_size = src_size    ! force calculations into floating point
	   IF (split_on_compressed_ax) THEN
	      min_mem_used = nbuffers*res_size
     .			   + (ncomp*rsrc_size)/split_ax_len
	   ELSEIF (its_dsg) THEN
	      min_mem_used = res_size
     .			   + (ncomp*rsrc_size)/split_ax_len
	   ELSE
! NOTE:  MODULO REGRIDDING has not ben thought through carefully
	      min_mem_used = res_size
     .			   + (nbuffers*res_size+ncomp*rsrc_size)/split_ax_len
	   ENDIF

* We found a splittable axis!
* If this axis is long enough to do the job, then use it
	   IF (available_mem .GE. min_mem_used ) GOTO 1000

* save a summary of this axis to use later if a multi-axis split is needed
	   nsplittable = nsplittable + 1
	   ax_splittable(split_ax) = .TRUE.
	   ax_compressed(split_ax) = split_on_compressed_ax
	   ax_len       (split_ax) = split_ax_len
	   ax_min_mem   (split_ax) = min_mem_used
	ENDDO

****************************************************************
* ***** PHASE 3. Find the best multiple axis split

* Done looping through the axes with no axis long enough to do the job, alone.
	inadequate_split_length = .TRUE.

* Now the hard case -- select the best two axes to split on:
* Splitting on multiple axes means that we will be returning here again
* When we split along the compressed axis the transform gets removed from
* the individual chunks, so further splitting of the chunk becomes impossible
* Therefore we must choose to split on an uncompressed axis first

* The optimal strategy is to choose the two slowest axes that together will
* provide the required requction factor.
* ax1 is the axis that will be chosen for splitting, so it must be uncompressed
	IF (nsplittable .GE. 2) THEN
	   DO i1 = nferdims, 1, -1
	      IF ( dset.GT.pdset_irrelevant .AND. dset.LE.maxdsets ) THEN
                 ax1 = ds_ax_speed(i1, dset)
	      ELSE
	         ax1 = i1
	      ENDIF

	      IF (.NOT.ax_splittable(ax1)) CYCLE
	      IF (ax_compressed(ax1)) CYCLE

	      DO i2 = nferdims, 1, -1
	         IF ( dset.GT.pdset_irrelevant .AND. dset.LE.maxdsets ) THEN
                    ax2 = ds_ax_speed(i2, dset)
	         ELSE
	            ax2 = i2
	         ENDIF

	         IF (ax2 .EQ. ax1) CYCLE
	         IF (.NOT.ax_splittable(ax2)) CYCLE

* ... can these two axes together provide the needed reduction in size?
*     the minimum memory needed for the 2-level nested gather is
*     ax_min_mem(ax1) + ax_min_mem(ax2)/ax_len(ax1)
	         IF (available_mem .GE. ncomp*
     .		     (ax_min_mem(ax1) + ax_min_mem(ax2)/ax_len(ax1))  ) THEN
* ... we found a 2-level split/gather that will work
	            split_ax = ax1
	            split_on_compressed_ax = .FALSE.
	            GOTO 1000
	         ENDIF
	      ENDDO
	   ENDDO
	ENDIF

* We did not find two axes that can fit this transformation into avail_mem
* Try again with less caution, if wiggle room still exists
	IF (use_caution) GOTO 2000

* Boy, we're in a tough spot. 
* No answer was found that was guaranteed to fit into available_mem
* Instead choose a strategy that represents a reasonable college try
* ... Whatever axis we choose, at this point we are guaranteed that the frag
*     size will be 1 (else we wouldn;t be at this point)
*     so there is no reason to adjust available_mem back to its cautious level
* Choose an uncompressed axis if one is available, because it can be
* part of a 2-axis split.  Choose the longest one.  It reduces the most.
	no_axis_found = .TRUE.
	DO i = 1, nferdims
	   IF (.NOT.ax_splittable(i)) CYCLE
	   IF (ax_compressed(i)) CYCLE
* ... found an uncompressed axis
	   IF (no_axis_found) THEN
	      split_ax = i
	      no_axis_found = .FALSE.
	   ELSEIF (ax_len(i) .GT. ax_len(split_ax)) THEN
	      split_ax = i
	   ENDIF
	ENDDO

* If no uncompressed axis is available, then choose the longest compressed axis
	IF (no_axis_found) THEN
	   DO i = 1, nferdims
	      IF (.NOT.ax_splittable(i)) CYCLE
* ... found an uncompressed axis
	      IF (no_axis_found) THEN
	         split_ax = i
	         no_axis_found = .FALSE.
	      ELSEIF (ax_len(i) .GT. ax_len(split_ax)) THEN
	         split_ax = i
	      ENDIF
	   ENDDO
	ENDIF

* skunked?
	IF (no_axis_found) RETURN ! mod regrid w no other axes available?

	split_on_compressed_ax = ax_compressed(split_ax)
!	GOTO 1000

****************************************************************
* ***** PHASE 4. Setup the split/gather

* OK - lets divvie this baby up into chunks!
* save the default context so it can be re-used at each chunk
* a compressed axis is represented as lo/hi_ss=-999, which is not what we want
* so if splitting on a compressed axis, store src_cx
 1000	axis = split_ax
	IF (split_on_compressed_ax .OR. its_dsg) THEN
* ... when splitting on a compressed axis the stack activity remains the 
*     compressing transform.  It is IS_TRANS, instead of IS_GATHER, that
*     will control the fetching of fragment after fragment
	   CALL CREATE_NEW_CONTEXT( src_cx, big_cx, status )	! pushes stack
	   is_phase( lo_isp ) = isphase_initialize_transform
	ELSE
	   aclass = isact_class_gather
	   is_act(lo_isp) = isact_gather
	   CALL CREATE_NEW_CONTEXT( res_cx, big_cx, status )	! pushes stack
	ENDIF
	IF ( status .NE. ferr_ok ) GOTO 5000
	is_big_cx( lo_isp ) = big_cx
* cancel result pointer to indicate no result yet
	is_mr( lo_isp ) = unspecified_int4
* determine the number of subscripts that can be processed in each chunk
	IF (its_dsg) THEN
	   CALL POTENT_AX_LIMS(src_cx, axis, lo_ss, hi_ss)
	ELSE
! 5/17 quite likely could get lims from src_cx, but if it aint broke ...
	   CALL POTENT_AX_LIMS(res_cx, axis, lo_ss, hi_ss)
	ENDIF
	split_ax_len = hi_ss - lo_ss + 1
	IF (split_on_compressed_ax) THEN
	   reduction_factor_needed = ncomp*rsrc_size
     .				   / (available_mem-nbuffers*res_size)
	ELSE
	   reduction_factor_needed = (nbuffers*res_size + ncomp*rsrc_size)
     .				   / (available_mem-res_size)
	ENDIF
	frag = split_ax_len / reduction_factor_needed
	IF (frag .LT. 1) frag = 1
	is_sum( lo_isp ) = frag
* set the subscript range for the first gather fragment
	CALL TRANSFER_CONTEXT( big_cx, src_cx )
	cx_hi_ss(src_cx,axis) = lo_ss + frag - 1
	cx_by_ss(axis,src_cx) = .TRUE.
	CALL FLESH_OUT_AXIS( axis, src_cx, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* diagnostic output about split on compressed axis
*    (this is a "dummy" interp stack activity in the sense that is_act is
*     never actually given this activity.  It exists only to generate an
*     informative diagnostic report)
	IF ( mode_diagnostic
     .	.AND. (split_on_compressed_ax.OR.its_dsg) ) THEN
	   CALL DIAG_OP('strip', isact_class_cmp_gather_dummy, big_cx, axis)
	   CALL DIAG_OP('doing', isact_class_cmp_gather_dummy, src_cx, axis)
	ENDIF

* at this point we have obligated the use of memory for the result,
* but we have not yet actually created the memory objects.
* That will occur in IS_TRANS during its initiailzation phase.
* So here we plant a record of what we have obligated into the stack, so that
* when multi-axis strip-gather operations are needed, the next (nested) call
* to this routine will know of the deferred memory allocations
* We only alert to deferred memory usage if the frag we have selected is
* inadequate to fillfill the memory reduction with a single axis split
	IF (inadequate_split_length) THEN
	   IF (split_on_compressed_ax) THEN
	      is_deferred_mem(lo_isp) = nbuffers*res_size
	   ELSE
	      is_deferred_mem(lo_isp) = res_size
	   ENDIF
	ELSE
	      is_deferred_mem(lo_isp) = 0
	ENDIF

* store diagnostic information about the splitting (see SHOW MEM split)
	IF (nsplits .LE. max_splits) THEN
	   IF (nsplits .EQ. 0) THEN
	      dup_split = .FALSE.
	   ELSE
	      dup_split = var     .EQ. split_var  (nsplits)
     .             .AND. cat      .EQ. split_cat  (nsplits)
     .             .AND. trans    .EQ. split_trans(nsplits)
     .             .AND. split_ax .EQ. split_axis (nsplits)
	   ENDIF
	   IF (dup_split) THEN
	      split_repeats(nsplits) = split_repeats(nsplits) + 1
	   ELSE
	      nsplits = nsplits + 1
	      split_var  (nsplits) = var
	      split_cat  (nsplits) = cat
	      split_axis (nsplits) = split_ax
	      split_trans(nsplits) = trans
	      split_frag(nsplits)  = frag
	      split_repeats(nsplits) = 1
	   ENDIF
	ENDIF

* successful completion
	RETURN

* prepare to go back for another pass
* ... pass 1 tries to succeed with mode_frugal percent held in reserve
* ... pass 2 tries again half that much in reserve
* ... pass 3 tries again using all available memory
 2000	available_mem = available_mem + 0.500001*set_aside_mem
	IF (available_mem .GE. free_mem) THEN
	   available_mem = free_mem
	   use_caution = .FALSE.
	ENDIF
	GOTO 100

* error exits
 5000	RETURN
 5100	CALL ERRMSG( ferr_insuff_memory,status,
     .	    'Requested result is larger than the available memory', *5110)
 5110	CALL SHOW_ABORTED_MEM_STATE(res_size)
	GOTO 5000

	END

	SUBROUTINE MR_NOT_IN_USE ( mr )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* release one claim of being required for calculations from variable mr
* if this release leaves the variable unneeded for any calculations then return
* it to the deletable variable chain

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  6/12/89
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
*        12/16 *sh* Bug fix - check if already *in* delete chain before adding
*		added diagnostic sanity checks
* V702: *sh* 1/17 issue error message on inappropriate calls to this routine
*		  immediate return on protected variables
*                 (have LOAD/TEMP code in XEQ_LOAD to remove permanance)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xvariables.cmn'

* calling argument declarations:
	INTEGER mr

* internal variable declarations:
	INTEGER last_head, status


	IF ( mr_protected(mr) .GT. mr_not_protected ) THEN
	   mr_protected(mr) = mr_protected(mr) - 1
* ... if no one needs this variable any longer it is no longer "essential"
	   IF ( mr_protected(mr) .EQ. mr_not_protected ) THEN
	      essential_mem = essential_mem - mr_size(mr)
	   ENDIF

	ELSEIF ( mr_protected(mr) .LT. mr_not_protected ) THEN
* ... mr_temporary variables can end up here during immediate mode evaluations
*     see the list of possible mr_* states in ferret.parm
	   RETURN

	ELSE
* ... over-freeing of the mr -- should never happen
	   CALL ERRMSG( ferr_internal, status, 'xtra MR_NOT_IN_USE', *5000)
	ENDIF

* possibly insert the variable at the head of the deletion priority chain
	IF ( mr_protected(mr) .EQ. mr_not_protected ) THEN

* 12/16 - sanity check if it is already in the deletion chain before
*         attempting to insert it again. Doubly inserting can occur
*         only if this routine is called more often than it should be
*         signaling an internal error
	   IF (mr_del_flink(mr) .NE. unspecified_int4 ) THEN
	      CALL ERRMSG( ferr_internal, status, 'MR_NOT_IN_USE', *5000)
	   ELSE

	   last_head = mr_del_flink(0)
	   mr_del_blink(mr) = 0
	   mr_del_flink(mr) = last_head
	   mr_del_flink(0)  = mr
	   mr_del_blink(last_head) = mr

	   ENDIF
	ENDIF

 5000	RETURN
	END

      SUBROUTINE CD_GET_LINE_DIRECTION (dset, ivar,
     .     vname, linunits, do_warn, full, dir_code)
     

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

*  code to determine the direction of a coordinate axis. Pulled out of cd_get_1_axis
*  V683 ACM 9/2012
*
*  V692 ACM 7/2014 A cf_role attribute indicates the E direction.
*  V694 ACM 2/2015 Ensemble axis may have a standard-name attribute "realization"
*  V694 ACM 4/2015 Fix ticket 2260: set X axis when standard_name is "longitude"
*  V72+ ACM 10/2015 If using axis names, compare the right # of characters
*  V73+ ACM 12/2016 Change arguments slightly. Instead of passing in iaxis
*                   and setting dir_code, set a 2-letter code
*  V73+ ACM  1/2018 issue 1851: If direction is reduced down to using axis names, 
*                   see if there were unrelated units that should trump the name
*  V76  ACM 12/2019 Issue 1962: We let axes named X, Y, Z, T determine direction,
*                   if otherwise undetermined. Also allow single-letter names
*                   I, J, K, L to indicate direction.
* 
* Arguments
*  dset		Ferret dataset number
*  ivar		varid
*  vname	variable name
*  linunits	variable units
*  do_warn	Turn warnings on or off
*  full		True to use units, false to stop after looking for at the 
*               axis, coordinate_axis, CoordinateAxisType, cf_role, long_name, 
*               and standard_name.  If false, it does look for a time origin in the units
*  dir_code     return: two-letter direction code, either XX,YY,... or WE, SN, UD, DU, TI
*

*      include files: 
      
        IMPLICIT NONE
        include 'netcdf.inc'
        include 'tmap_errors.parm'
        include 'tmap_dims.parm'
#include "tmap_dset.parm"
        include 'xtm_grid.cmn_text'
        external xgt_grid_data
        include 'xunits.cmn_text'
        external xunits_data
        include 'errmsg.parm'


* calling arguments
      LOGICAL do_warn, full
      INTEGER dset, ivar, idir
      CHARACTER*(*) vname, linunits, dir_code

* local declarations
      LOGICAL TM_HAS_STRING, NC_GET_ATTRIB, got_it, yyyymmdd_time
      CHARACTER*1 axis_dir*1, vupcase*128

      INTEGER STR_UPCASE, STR_CASE_BLIND_COMPARE, TM_LENSTR1, 
     .	      TM_UNIT_ID, i, units, attlen, attoutflag, attype, iatt,  
     .        vlen, slen,maxlen, istat, since_T0, epic_t2var, status

      REAL val, dummy

      INTEGER bufflen
      PARAMETER (bufflen = 256)
      CHARACTER*256 buff, upbuff
      INTEGER     str_eq, no_units
      PARAMETER ( str_eq = 0, no_units = 0 )

* (could check for the record axis and if so, set it to T)

* Use attributes to try to determine the orientation and 
* direction of the axis

      dir_code = 'NA'

      vlen = TM_LENSTR1(vname)

* ... First check for an AXIS attribute

      axis_dir = char_init01
      maxlen = 1
      got_it = NC_GET_ATTRIB(dset, ivar, 'axis',
     .             do_warn, vname(:vlen), maxlen, attlen, 
     .             attoutflag, axis_dir, val)
      IF (got_it) THEN
         CALL CD_GET_VAR_ATT_ID (dset, ivar, 'axis', iatt, status)
         CALL CD_GET_VAR_ATT_INFO (dset, ivar, iatt, buff, attype, 
     .     attlen, attoutflag, status )
         IF (attype .NE. NCCHAR) got_it = .FALSE.
      ENDIF
      IF (got_it) THEN
         istat = STR_UPCASE( axis_dir, axis_dir )
         IF (axis_dir.EQ.'T' .OR. axis_dir.EQ.'L' .OR.
     .             axis_dir.EQ.'t' .or. axis_dir.eq.'l') THEN 
            dir_code = 'TI'  ! time
          ELSE IF (axis_dir.EQ.'X' .OR. axis_dir.EQ.'I' .OR.
     .             axis_dir.eq.'x' .or. axis_dir.eq.'i') THEN
            dir_code = 'XX'
         ELSE IF (axis_dir.EQ.'Y' .OR. axis_dir.EQ.'J' .OR.
     .            axis_dir.eq.'y' .or. axis_dir.eq.'j') THEN
            dir_code = 'YY'
         ELSE IF (axis_dir.EQ.'Z' .OR. axis_dir.EQ.'K' .OR.
     .            axis_dir.eq.'z' .or. axis_dir.eq.'k') THEN
            dir_code = 'DU'
         ELSE IF (axis_dir.EQ.'E' .OR. axis_dir.EQ.'M' .OR.
     .            axis_dir.eq.'e' .or. axis_dir.eq.'m') THEN
            dir_code = 'EE'
         ELSE IF (axis_dir.EQ.'F' .OR. axis_dir.EQ.'N' .OR.
     .            axis_dir.eq.'f' .or. axis_dir.eq.'n') THEN
            dir_code = 'FF'
         ENDIF
      ELSE
         axis_dir = char_init01
      ENDIF


* ... check for a CARTESIAN_AXIS attribute, if still undetermined

      IF (dir_code .EQ. 'NA') THEN

         maxlen = 1
         got_it = NC_GET_ATTRIB(dset, ivar, 'cartesian_axis',
     .              do_warn, vname(:vlen), maxlen, attlen, 
     .              attoutflag, axis_dir, val)
         IF (got_it) THEN
            CALL CD_GET_VAR_ATT_ID (dset, ivar, 'cartesian_axis', iatt, status)
            CALL CD_GET_VAR_ATT_INFO (dset, ivar, iatt, buff, attype, 
     .     attlen, attoutflag, status )
            IF (attype .NE. NCCHAR) got_it = .FALSE.
         ENDIF

         IF (got_it) THEN
            IF (axis_dir.EQ.'T' .OR. axis_dir.EQ.'L' .OR.
     .          axis_dir.EQ.'t' .or. axis_dir.eq.'l') THEN 
               dir_code = 'TI'  ! time
            ELSE IF (axis_dir.EQ.'X' .OR. axis_dir.EQ.'I' .OR.
     .               axis_dir.eq.'x' .or. axis_dir.eq.'i') THEN
            dir_code = 'WE'
            ELSE IF (axis_dir.EQ.'Y' .OR. axis_dir.EQ.'J' .OR.
     .               axis_dir.eq.'y' .or. axis_dir.eq.'j') THEN
             dir_code = 'SN'
            ELSE IF (axis_dir.EQ.'Z' .OR. axis_dir.EQ.'K' .OR.
     .               axis_dir.eq.'z' .or. axis_dir.eq.'k') THEN
               dir_code = 'DU'
            ELSE IF (axis_dir.EQ.'E' .OR. axis_dir.EQ.'M' .OR.
     .            axis_dir.eq.'e' .or. axis_dir.eq.'m') THEN
               dir_code = 'EE'
            ELSE IF (axis_dir.EQ.'F' .OR. axis_dir.EQ.'N' .OR.
     .            axis_dir.eq.'f' .or. axis_dir.eq.'n') THEN
               dir_code = 'FF'
            ENDIF
         ELSE
            axis_dir = char_init01
         ENDIF
      ENDIF

* ... check for a cf_role attribute, if still undetermined.
*     Put these axes in the E direction. This attribute may
*     be on a non-coordinate variable. Those are found in 
*     cd_get_generic_grids.

      IF (dir_code .EQ. 'NA') THEN

         maxlen = 20
         got_it = NC_GET_ATTRIB(dset, ivar, 'cf_role',
     .              do_warn, vname(:vlen), maxlen, attlen, 
     .              attoutflag, buff, val)
         IF (got_it) dir_code = 'EE'
      ENDIF

* ... check for a _CoordinateAxisType attribute, if still undetermined

      IF (dir_code .EQ. 'NA') THEN

         maxlen = 20
         got_it = NC_GET_ATTRIB(dset, ivar, '_CoordinateAxisType',
     .              do_warn, vname(:vlen), maxlen, attlen, 
     .              attoutflag, buff, val)
         IF (got_it) THEN
            CALL CD_GET_VAR_ATT_ID (dset, ivar,
     .        '_CoordinateAxisType', iatt, status)
            CALL CD_GET_VAR_ATT_INFO (dset, ivar, iatt, upbuff, attype, 
     .        attlen, attoutflag, status )
            IF (attype .NE. NCCHAR) got_it = .FALSE.
         ENDIF

         IF (got_it) THEN
	    i = STR_UPCASE(upbuff, buff)
            IF (upbuff.EQ.'TIME') THEN 
               dir_code = 'TI'  ! time
            ELSE IF (upbuff.EQ.'LON' .OR. upbuff.EQ.'GEOX') THEN
            dir_code = 'WE'
            ELSE IF (upbuff.EQ.'LAT' .OR. upbuff.EQ.'GEOY') THEN
             dir_code = 'SN'
            ELSE IF (upbuff.EQ.'HEIGHT') THEN
               dir_code = 'UD'
            ELSE IF (upbuff.EQ.'PRESSURE') THEN
               dir_code = 'DU'
            ELSE IF (upbuff.EQ.'ENSEMBLE') THEN
               dir_code = 'EE'
            ELSE IF (upbuff.EQ.'RUNTIME') THEN
               dir_code = 'FF'
            ENDIF
	 
	    IF (upbuff.EQ.'HEIGHT' .OR. 
     .               upbuff.EQ.'PRESSURE') THEN
               maxlen = 20
               got_it = NC_GET_ATTRIB(dset, ivar, 
     .              'CoordinateZisPositive',
     .              do_warn, vname(:vlen), maxlen, attlen, 
     .              attoutflag, buff, val)
               IF (got_it) THEN
	          i = STR_UPCASE(upbuff, buff)
	          IF (upbuff.EQ.'UP')
     .             dir_code = 'DU'
	          IF (upbuff.EQ.'DOWN')
     .             dir_code = 'UD'
               ENDIF
            ENDIF
         ENDIF

      ENDIF

* ... next check units
               
* If this is called by cd_get_1_axis, we have incoming units from 
* line_units(iaxis) already. Otherwise, get basic units.

* Time ax may contain "tunits since T0_date"

      since_T0 = MAX( INDEX(linunits,'since'), INDEX(buff,'SINCE') )
      IF (since_t0 .GT. 2) dir_code = 'TI'

      IF (linunits .EQ. char_init16) THEN

         linunits = ' '   ! default
         maxlen = bufflen
         got_it = NC_GET_ATTRIB( dset, ivar, 'units', do_warn,
     .                        vname(:vlen), maxlen, attlen, attoutflag, 
     .                        buff, val)

         since_T0 = MAX( INDEX(buff,'since'), INDEX(buff,'SINCE') )
         yyyymmdd_time = buff(1:15) .EQ. 'yyyymmddhhmmss'

         IF ( since_T0 .GT. 2 ) THEN
            linunits = buff(:since_T0-1)  ! just the "tunits" part 
         ELSEIF ( yyyymmdd_time ) THEN
            linunits = 'days'
	    dir_code = 'TI'
         ELSE
            IF (got_it) linunits = buff
         ENDIF

* EPIC time axes are encoded as 2 integers in variables TIME and TIME2
         IF ( vupcase .EQ. 'TIME' ) THEN
            CALL CD_GET_VAR_ID ( dset, 'time2', epic_t2var, status)
	    IF ( status .EQ. merr_ok ) linunits = 'Days'     ! arbitrary
         ENDIF
      ENDIF
      
* Skip this for DSG files.  Looking not just at axes but other vars
* which may be e.g. degrees heading.

      IF (full) THEN

* ... decode the units

      units = TM_UNIT_ID( linunits )
      istat = STR_UPCASE( vupcase, vname )


      IF (dir_code .EQ. 'NA' .OR. 
     .    dir_code .EQ. 'XX' .OR.
     .    dir_code .EQ. 'YY' .OR.
     .    dir_code .EQ. 'FF') THEN

      IF ( units .LT. 0 ) THEN
	 IF (dir_code .EQ. 'FF') THEN
	    dir_code = 'FI'  ! forecast time
	 ELSE
            dir_code = 'TI'  ! time
	 ENDIF

      ELSEIF ( units .EQ. 4 ) THEN     ! degrees
        IF  ( TM_HAS_STRING(linunits, 'NORTH')
     .   .OR. TM_HAS_STRING(linunits, 'SOUTH')
     .   .OR. TM_HAS_STRING(linunits, 'degreeN')   ! Check all CF_compliant 
     .   .OR. TM_HAS_STRING(linunits, 'degreesN')  ! options
     .   .OR. TM_HAS_STRING(linunits, 'degree_N')  ! Case independent
     .   .OR. TM_HAS_STRING(linunits, 'degrees_N')
c     .   .OR. TM_HAS_STRING(linunits, 'degreesS') ! But this matches all degrees
     .   .OR. TM_HAS_STRING(linunits, 'degree_S')
     .   .OR. TM_HAS_STRING(linunits, 'degrees_S')
     .   .OR. TM_HAS_STRING(linunits, 'LAT') ) THEN 
            dir_code = 'SN'
        ELSEIF ( TM_HAS_STRING(linunits, 'EAST')
     .   .OR. TM_HAS_STRING(linunits, 'WEST')
     .   .OR. TM_HAS_STRING(linunits, 'degreeE')
     .   .OR. TM_HAS_STRING(linunits, 'degreesE')
     .   .OR. TM_HAS_STRING(linunits, 'degree_E')
     .   .OR. TM_HAS_STRING(linunits, 'degrees_E')
     .   .OR. TM_HAS_STRING(linunits, 'degreeW')
     .   .OR. TM_HAS_STRING(linunits, 'degreesW')
     .   .OR. TM_HAS_STRING(linunits, 'degree_W')
     .   .OR. TM_HAS_STRING(linunits, 'degrees_W')
     .   .OR. TM_HAS_STRING(linunits, 'LON') ) THEN 
            dir_code = 'WE'
        ELSEIF ( dir_code .EQ. 'XX') THEN
                        dir_code = 'WE'
        ELSEIF ( dir_code .EQ. 'YY') THEN
                        dir_code = 'SN'
        ENDIF

      ELSEIF ( units .EQ. pun_millibars
     .   .OR.  units .EQ. pun_decibars ) THEN 
         dir_code = 'UD'
      ELSEIF ( units .EQ. 14
     .   .OR.  units .EQ. 15   ) THEN         ! layer or level
         dir_code = 'UD'
* ... then check stray clues
         ELSEIF ( TM_HAS_STRING(linunits, 'LAT') ) THEN
         dir_code = 'SN'
      ELSEIF ( TM_HAS_STRING(linunits, 'LON') ) THEN
         dir_code = 'WE'
      ENDIF
      ENDIF

      IF (units .EQ. 4) THEN    ! degrees
         IF (dir_code .EQ. 'NA' ) THEN
            IF ( vupcase(1:1) .EQ. 'Y'
     .      .OR. INDEX(vupcase, 'LAT') .GT. 0 ) THEN
               dir_code = 'SN'
            ELSEIF ( vupcase(1:1) .EQ. 'X'
     .      .OR. INDEX(vupcase, 'LON') .GT. 0 ) THEN
               dir_code = 'WE'
! 8/97: "Y" anywhere in name as a last ditch attempt to id it
            ELSEIF ( INDEX(vupcase, 'Y')   .GT. 0 ) THEN
               dir_code = 'SN'
            ELSE
               dir_code = 'WE'
            ENDIF
         ENDIF
	 IF (dir_code .EQ. 'WE') THEN
	    linunits = 'degrees_east'
	    slen = TM_LENSTR1(linunits)
	    dummy = 1.
	    CALL CD_REPLACE_ATTR (dset, ivar, 'units', NF_CHAR, slen,
     .            linunits, dummy, status)
	 ENDIF
	 IF (dir_code .EQ. 'SN') THEN
	    linunits = 'degrees_north'
	    slen = TM_LENSTR1(linunits)
	    dummy = 1.
	    CALL CD_REPLACE_ATTR (dset, ivar, 'units', NF_CHAR, slen,
     .            linunits, dummy, status)
	 ENDIF
      ENDIF

      ENDIF  ! full

! See if the long-name contains a string that indicates a z axis
      maxlen = bufflen
      got_it = NC_GET_ATTRIB( dset,ivar,'long_name',
     .           do_warn, vname(:vlen), maxlen, attlen, attoutflag, 
     .           buff, val)
      IF ( got_it .AND. dir_code .EQ. 'NA' ) THEN
         IF (STR_CASE_BLIND_COMPARE('elev',buff(:4)) .EQ. str_eq) 
     .           dir_code = 'DU'
         IF (STR_CASE_BLIND_COMPARE('height',buff(:6)) .EQ. str_eq) 
     .           dir_code = 'DU'
         IF (STR_CASE_BLIND_COMPARE('level',buff(:5)) .EQ. str_eq) 
     .           dir_code = 'DU'
         IF (STR_CASE_BLIND_COMPARE('layer',buff(:5)) .EQ. str_eq) 
     .           dir_code = 'DU'
         IF (STR_CASE_BLIND_COMPARE('depth',buff(:5)) .EQ. str_eq) 
     .           dir_code = 'UD'
         IF (STR_CASE_BLIND_COMPARE('latitude',buff(:8)) .EQ. str_eq) 
     .           dir_code = 'SN'
         IF (STR_CASE_BLIND_COMPARE('longitude',buff(:9)) .EQ. str_eq) 
     .           dir_code = 'WE'
      ENDIF

* the attribute "positive=down", etc. may help
      maxlen = bufflen
      got_it = NC_GET_ATTRIB( dset, ivar, 'positive', do_warn, 
     .                        vname(:vlen), maxlen, attlen, attoutflag, 
     .                        buff, val)
      IF ( got_it ) THEN
         IF (STR_CASE_BLIND_COMPARE('west',buff(:4))
     .                                     .EQ.str_eq) THEN
            dir_code = 'WE'
         ELSEIF( STR_CASE_BLIND_COMPARE('east',buff(:4))
     .                                     .EQ.str_eq) THEN
            dir_code = 'WE'
         ELSEIF( STR_CASE_BLIND_COMPARE('up',buff(:2))
     .                                     .EQ.str_eq) THEN
            dir_code = 'DU'
         ELSEIF( STR_CASE_BLIND_COMPARE('down',buff(:4))
     .                                     .EQ.str_eq) THEN
            dir_code = 'UD'
         ENDIF
      ENDIF


* Basic standard names
* Look for time, longitude, latitude, depth and height names.
* Forecast time axes have a standard-name attribute "forecast_reference_time"
* Ensemble axis may have a standard-name attribute "realization"

      maxlen = bufflen
      got_it = NC_GET_ATTRIB( dset, ivar, 'standard_name', do_warn, 
     .                        vname(:vlen), maxlen, attlen, attoutflag, 
     .                        buff, val)
      IF ( got_it ) THEN
         IF (STR_CASE_BLIND_COMPARE(
     .      'time',buff(:4))
     .                                     .EQ.str_eq) THEN
            dir_code = 'TI'
         ENDIF 
         IF (STR_CASE_BLIND_COMPARE(
     .      'longitude',buff(:9))          .EQ.str_eq .OR. 
     .      STR_CASE_BLIND_COMPARE(
     .      'grid_longitude',buff(:19))    .EQ.str_eq) THEN
            dir_code = 'WE'
         ENDIF 
         IF (STR_CASE_BLIND_COMPARE(
     .      'latitude',buff(:8))           .EQ.str_eq .OR.
     .      STR_CASE_BLIND_COMPARE(
     .      'grid_latitude',buff(:18))     .EQ.str_eq) THEN
            dir_code = 'SN'
         ENDIF 
	 
         IF (STR_CASE_BLIND_COMPARE(
     .      'depth',buff(:5))
     .                                     .EQ.str_eq) THEN
            dir_code = 'UD'
         ENDIF 
	 
         IF (STR_CASE_BLIND_COMPARE(
     .      'altitude',buff(:8))
     .                                     .EQ.str_eq) THEN
            dir_code = 'DU'
         ENDIF 
         IF (STR_CASE_BLIND_COMPARE(
     .      'forecast_reference_time',buff(:24))
     .                                     .EQ.str_eq) THEN
            dir_code = 'FI'
         ENDIF 
         IF (STR_CASE_BLIND_COMPARE(
     .      'realization',buff(:24))
     .                                     .EQ.str_eq) THEN
            dir_code = 'EE'
         ENDIF 
      ENDIF


* Standard_names indicating a sigma-axis in Z, and standard names 
* for geophysical axes, longitude, latitude, altitude etc. Note 
* that there seem to be some standard names related to sigma
* coordinates that may not indicate a vertical axis, so simply 
* matching sigma and coordinate is probably not safe.

      maxlen = bufflen
      got_it = NC_GET_ATTRIB( dset, ivar, 'standard_name', do_warn, 
     .                        vname(:vlen), maxlen, attlen, attoutflag, 
     .                        buff, val)
      IF ( got_it ) THEN
         IF (STR_CASE_BLIND_COMPARE(
     .      'atmosphere_hybrid_height_coordinate',buff(:35))
     .                                     .EQ.str_eq) THEN
            dir_code = 'DU'
         ENDIF 
         IF (STR_CASE_BLIND_COMPARE(
     .      'atmosphere_hybrid_sigma_pressure_coordinate',buff(:43))
     .                                     .EQ.str_eq) THEN
            dir_code = 'DU'
         ENDIF
         IF (STR_CASE_BLIND_COMPARE(
     .      'atmosphere_hybrid_height_coordinate',buff(:35))
     .                                     .EQ.str_eq) THEN
            dir_code = 'DU'
         ENDIF
         IF (STR_CASE_BLIND_COMPARE(
     .      'atmosphere_ln_pressure_coordinate',buff(:33))
     .                                     .EQ.str_eq) THEN
            dir_code = 'DU'
         ENDIF
         IF (STR_CASE_BLIND_COMPARE(
     .      'atmosphere_sigma_coordinate',buff(:27))
     .                                     .EQ.str_eq) THEN
            dir_code = 'DU'
         ENDIF
         IF (STR_CASE_BLIND_COMPARE(
     .      'atmosphere_sleve_coordinate',buff(:27))
     .                                     .EQ.str_eq) THEN
            dir_code = 'DU'
         ENDIF
         IF (STR_CASE_BLIND_COMPARE(
     .      'land_ice_sigma_coordinate',buff(:25))
     .                                     .EQ.str_eq) THEN
            dir_code = 'DU'
         ENDIF
         IF (STR_CASE_BLIND_COMPARE(
     .      'ocean_s_coordinate',buff(:19))
     .                                     .EQ.str_eq) THEN
            dir_code = 'UD'
         ENDIF
         IF (STR_CASE_BLIND_COMPARE(
     .      'ocean_sigma_coordinate',buff(:22))
     .                                     .EQ.str_eq) THEN
            dir_code = 'UD'
         ENDIF
         IF (STR_CASE_BLIND_COMPARE(
     .      'ocean_sigma_z_coordinate',buff(:24))
     .                                     .EQ.str_eq) THEN
            dir_code = 'UD'
         ENDIF
         IF (STR_CASE_BLIND_COMPARE(
     .      'ocean_double_sigma_coordinate',buff(:29))
     .                                     .EQ.str_eq) THEN
            dir_code = 'UD'
         ENDIF

      ENDIF  ! end of std names

* Still punting on axis names. If it's single-letter X, Y, Z, T,
* or  single-letter I, J, K, L,
* or starts with XAX, YAX, etc. then give it that direction.

      IF (dir_code .EQ. 'NA' .AND. vlen .EQ. 1) THEN
         IF ( vupcase(1:1) .EQ. 'X') dir_code = 'XX'
         IF ( vupcase(1:1) .EQ. 'Y') dir_code = 'YY'
         IF ( vupcase(1:1) .EQ. 'Z') dir_code = 'DU'
         IF ( vupcase(1:1) .EQ. 'T') dir_code = 'TI'

         IF ( vupcase(1:1) .EQ. 'I') dir_code = 'XX'
         IF ( vupcase(1:1) .EQ. 'J') dir_code = 'YY'
         IF ( vupcase(1:1) .EQ. 'K') dir_code = 'DU'
         IF ( vupcase(1:1) .EQ. 'L') dir_code = 'TI'
      ENDIF
      IF (dir_code.EQ.'NA') THEN
         IF (vupcase(1:3).EQ.'XAX') dir_code = 'XX'
         IF (vupcase(1:3).EQ.'YAX') dir_code = 'YY'
         IF (vupcase(1:3).EQ.'ZAX') dir_code = 'DU'
         IF (vupcase(1:3).EQ.'TAX') dir_code = 'TI'
      ENDIF

* If the name indicates a direction in obvious ways, use it.  But if there
* was a units string that did NOT dictate a direction, leave undefined.

      IF (full .AND. dir_code.EQ.'NA' .AND. units.EQ.no_units) THEN
         IF (vupcase(1:3).EQ.'LON') dir_code = 'WE'
         IF (vupcase(1:3).EQ.'LAT') dir_code = 'SN'
         IF (vupcase(1:4).EQ.'TIME') dir_code = 'TI'
         IF (vupcase(1:4).EQ.'DATE') dir_code = 'TI'
         IF (vupcase(1:3).EQ.'DEP') dir_code = 'UD'
         IF (vupcase(1:3).EQ.'ALT') dir_code = 'DU'
         IF (vupcase(1:4).EQ.'ELEV') dir_code = 'DU'
         IF (vupcase(1:3).EQ.'HEI') dir_code = 'DU'
         IF (vupcase(1:5).EQ.'LAYER') dir_code = 'DU'
         IF (vupcase(1:5).EQ.'LEVEL') dir_code = 'DU'
      ENDIF

 5000 RETURN
      END

	INTEGER FUNCTION DO_LOCATE( idim, arg,
     .				 com, com_mr, com_cx,
     .				 res, res_mr, res_cx,
     .				 buff	)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* find the world coordinate at which the component grid equals the argument

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  1/11/90
* V230:  1/22/92 - fixed bug of missing exact equality
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include	'xprog_state.cmn'

* calling argument declarations:
	INTEGER	idim, com_mr, com_cx, res_mr, res_cx
	REAL	arg, buff(*),
     .          com( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          res( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif )

* internal variable declarations:
	LOGICAL	first_pt, first_lt
	INTEGER i, j, k, l, m, n, pt, ss1, grid
	REAL	bad_res, ww1, ww2, del, com1, com2
	REAL*8	TM_WORLD

* diagnostic mode output: " doing --> VAR_NAME[x=lo:hi@TRN:n,D=#]"
	IF ( mode_diagnostic ) 	CALL DIAG_OP
     .				( 'doing', isact_class_trans, res_cx, idim )

* initialize
	grid = cx_grid( com_cx )
	pt   = cx_lo_ss( res_cx, idim )
	bad_res = mr_bad_data( res_mr )

* ALONG X AXIS
	IF ( idim .EQ. x_dim ) THEN
	   DO 110 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 110 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 110 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 110 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 110 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	      first_pt = .TRUE.
	      DO 100 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_res ) GOTO 100
                 IF ( com(i,j,k,l,m,n) .EQ. arg ) THEN
                    res(pt,j,k,l,m,n) = TM_WORLD(i, grid, idim, box_middle)
	            GOTO 110
	         ELSEIF ( first_pt ) THEN
	           first_pt = .FALSE.
		   first_lt = com(i,j,k,l,m,n) .LT. arg
	           ss1 = i
		 ELSEIF ( first_lt .EQV. (com(i,j,k,l,m,n).LT.arg) ) THEN
	           ss1 = i
		 ELSE
* ... found a "zero-crossing"
	            ww1 = TM_WORLD ( ss1, grid, idim, box_middle )
	            ww2 = TM_WORLD ( i,   grid, idim, box_middle )
	            com1 = com(ss1,j,k,l,m,n)
	            com2 = com(i  ,j,k,l,m,n)
	            del = com2 - com1
	            res(pt,j,k,l,m,n) =
     .                 ( ww2*(arg-com1) + ww1*(com2-arg) ) / del
	            GOTO 110
	         ENDIF
 100	      CONTINUE
* ... no zero-crossing found
	      res(pt,j,k,l,m,n) = bad_res
 110	   CONTINUE

* ALONG Y AXIS
	ELSEIF ( idim .EQ. y_dim ) THEN
	   DO 210 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 210 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 210 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 210 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 210 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	      first_pt = .TRUE.
	      DO 200 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_res ) GOTO 200
                 IF ( com(i,j,k,l,m,n) .EQ. arg) THEN
	            res(i,pt,k,l,m,n) = TM_WORLD( j, grid, idim, box_middle )
	            GOTO 210
	         ELSEIF ( first_pt ) THEN
	           first_pt = .FALSE.
		   first_lt = com(i,j,k,l,m,n) .LT. arg
	           ss1 = j
		 ELSEIF ( first_lt .EQV. (com(i,j,k,l,m,n).LT.arg) ) THEN
	           ss1 = j
		 ELSE
* ... found a "zero-crossing"
	            ww1 = TM_WORLD ( ss1, grid, idim, box_middle )
	            ww2 = TM_WORLD ( j,   grid, idim, box_middle )
	            com1 = com(i,ss1,k,l,m,n)
	            com2 = com(i,j  ,k,l,m,n)
	            del = com2 - com1
	            res(i,pt,k,l,m,n) =
     .                 ( ww2*(arg-com1) + ww1*(com2-arg) ) / del
	            GOTO 210
	         ENDIF
 200	      CONTINUE
* ... no zero-crossing found
	      res(i,pt,k,l,m,n) = bad_res
 210	   CONTINUE

* ALONG Z AXIS
	ELSEIF ( idim .EQ. z_dim ) THEN
	   DO 310 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 310 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 310 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 310 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 310 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	      first_pt = .TRUE.
	      DO 300 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_res ) GOTO 300
                 IF ( com(i,j,k,l,m,n) .EQ. arg ) THEN
	            res(i,j,pt,l,m,n) = TM_WORLD ( k, grid, idim, box_middle )
	            GOTO 310
	         ELSEIF ( first_pt ) THEN
	           first_pt = .FALSE.
		   first_lt = com(i,j,k,l,m,n) .LT. arg
	           ss1 = k
		 ELSEIF ( first_lt .EQV. (com(i,j,k,l,m,n).LT.arg) ) THEN
	           ss1 = k
		 ELSE
* ... found a "zero-crossing"
	            ww1 = TM_WORLD ( ss1, grid, idim, box_middle )
	            ww2 = TM_WORLD ( k,   grid, idim, box_middle )
	            com1 = com(i,j,ss1,l,m,n)
	            com2 = com(i,j,k  ,l,m,n)
	            del = com2 - com1
	            res(i,j,pt,l,m,n) =
     .                 ( ww2*(arg-com1) + ww1*(com2-arg) ) / del
	            GOTO 310
	         ENDIF
 300	      CONTINUE
* ... no zero-crossing found
	      res(i,j,pt,l,m,n) = bad_res
 310	   CONTINUE

* ALONG T AXIS
	ELSEIF ( idim .EQ. t_dim ) THEN
	   DO 410 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 410 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 410 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 410 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 410 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	      first_pt = .TRUE.
	      DO 400 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_res ) GOTO 400
                 IF ( com(i,j,k,l,m,n) .EQ. arg ) THEN
	            res(i,j,k,pt,m,n) = TM_WORLD( l, grid, idim, box_middle )
	            GOTO 410
	         ELSEIF ( first_pt ) THEN
	           first_pt = .FALSE.
		   first_lt = com(i,j,k,l,m,n) .LT. arg
	           ss1 = l
		 ELSEIF ( first_lt .EQV. (com(i,j,k,l,m,n).LT.arg) ) THEN
	           ss1 = l
		 ELSE
* ... found a "zero-crossing"
	            ww1 = TM_WORLD ( ss1, grid, idim, box_middle )
	            ww2 = TM_WORLD ( l,   grid, idim, box_middle )
	            com1 = com(i,j,k,ss1,m,n)
	            com2 = com(i,j,k,l,  m,n)
	            del = com2 - com1
	            res(i,j,k,pt,m,n) =
     .                 ( ww2*(arg-com1) + ww1*(com2-arg) ) / del
	            GOTO 410
	         ENDIF
 400	      CONTINUE
* ... no zero-crossing found
	      res(i,j,k,pt,m,n) = bad_res
 410	   CONTINUE

* ALONG E AXIS
	ELSEIF ( idim .EQ. e_dim ) THEN
	   DO 510 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	   DO 510 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 510 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 510 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 510 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	      first_pt = .TRUE.
	      DO 500 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_res ) GOTO 500
                 IF ( com(i,j,k,l,m,n) .EQ. arg ) THEN
	            res(i,j,k,l,pt,n) = TM_WORLD( m, grid, idim, box_middle )
	            GOTO 510
	         ELSEIF ( first_pt ) THEN
	           first_pt = .FALSE.
		   first_lt = com(i,j,k,l,m,n) .LT. arg
	           ss1 = m
		 ELSEIF ( first_lt .EQV. (com(i,j,k,l,m,n).LT.arg) ) THEN
	           ss1 = m
		 ELSE
* ... found a "zero-crossing"
	            ww1 = TM_WORLD ( ss1, grid, idim, box_middle )
	            ww2 = TM_WORLD ( m,   grid, idim, box_middle )
	            com1 = com(i,j,k,l,ss1,n)
	            com2 = com(i,j,k,l,  m,n)
	            del = com2 - com1
	            res(i,j,k,l,pt,n) =
     .                 ( ww2*(arg-com1) + ww1*(com2-arg) ) / del
	            GOTO 510
	         ENDIF
 500	      CONTINUE
* ... no zero-crossing found
	      res(i,j,k,l,pt,n) = bad_res
 510	   CONTINUE

* ALONG F AXIS
	ELSEIF ( idim .EQ. f_dim ) THEN
	   DO 610 m = cx_lo_s5(com_cx), cx_hi_s5(com_cx)
	   DO 610 l = cx_lo_s4(com_cx), cx_hi_s4(com_cx)
	   DO 610 k = cx_lo_s3(com_cx), cx_hi_s3(com_cx)
	   DO 610 j = cx_lo_s2(com_cx), cx_hi_s2(com_cx)
	   DO 610 i = cx_lo_s1(com_cx), cx_hi_s1(com_cx)
	      first_pt = .TRUE.
	      DO 600 n = cx_lo_s6(com_cx), cx_hi_s6(com_cx)
	         IF ( com(i,j,k,l,m,n) .EQ. bad_res ) GOTO 600
                 IF ( com(i,j,k,l,m,n) .EQ. arg ) THEN
	            res(i,j,k,l,m,pt) = TM_WORLD( n, grid, idim, box_middle )
	            GOTO 610
	         ELSEIF ( first_pt ) THEN
	           first_pt = .FALSE.
		   first_lt = com(i,j,k,l,m,n) .LT. arg
	           ss1 = n
		 ELSEIF ( first_lt .EQV. (com(i,j,k,l,m,n).LT.arg) ) THEN
	           ss1 = n
		 ELSE
* ... found a "zero-crossing"
	            ww1 = TM_WORLD ( ss1, grid, idim, box_middle )
	            ww2 = TM_WORLD ( n,   grid, idim, box_middle )
	            com1 = com(i,j,k,l,m,ss1)
	            com2 = com(i,j,k,l,m,n)
	            del = com2 - com1
	            res(i,j,k,l,m,pt) =
     .                 ( ww2*(arg-com1) + ww1*(com2-arg) ) / del
	            GOTO 610
	         ENDIF
 600	      CONTINUE
* ... no zero-crossing found
	      res(i,j,k,l,m,pt) = bad_res
 610	   CONTINUE

	ENDIF

	DO_LOCATE = ferr_ok

	RETURN
	END

	SUBROUTINE TM_READ ( dset_num, variable,
     .		a_lo_x, a_lo_y, a_lo_z, a_lo_t, a_lo_e, a_lo_f,
     .		a_hi_x, a_hi_y, a_hi_z, a_hi_t, a_hi_e, a_hi_f,
     .		use_lo, use_hi, stride,
     .		data_grid, file_num, status )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Determines if a read request for a nferdims-D block of data (3D, 2D being degenerate
* cases w/ 1 dimension being 1 time series) from TMAP data sets contains a 
* modulo axis. Arranges calls to TM_CHOOSE_READ accordingly.
*
* written 10/24/88 by M. Verschell for PMEL/TMAP
*
* revision 0.00	- 10/24/88 - initial incarnation
* revision 0.01 - 12/15/88 - changed variable to *(*) from *8
* revision 0.10 - 01/24/89 - Bug fixes to fully implement modulo axis
* revision 0.11 - 02/08/89 - Bug fix to 2nd modulo read IF-test
* revision 0.20 - 02/08/89 - TM_READ now finds modulo axis and checks for 1 only
* revision 0.30 - 12/06/89 - changed arrays for dimensions to single variables
* revision 0.40 - 02/27/90 - multiple modulo axis provided only 1 used in read
* revision 0.41 - 4/91 *sh* Unix/RISC port: upcase the variable code and use
*                           in error message
* revision 0.5  - 11/92 *sh* increased variable name lengths to 24 characters
* *sh* 7/98 V4.91 - want to allow case-sensitive variables in single quotes
*       so dont upcase the variable name when comparing (why was it
*       upcased, anyway??)
* V500 4/99 *kob*: increase upcase_var 24 --> 64 chars matching passed vname
*      5/99 *sh* - added strides to CD_READ call
* V552 5/03 *acm*: increase size of upcase_var from 64 to 128 chars
* V602 9/06 *jli*  Changes for native strides
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing
*
* include files
	include 'tmap_dims.parm'		! data set dimension
#include "gt_lib.parm"
	include 'tmap_errors.parm'		! err code parm defs
	include 'xtm_grid.cmn_text'		! grid info
		include 'xdset_info.cmn_text'	! data set info common
	external xdset_info_data

* arguments:
*	dset_num    - internal data set # (from TM_INIT_DSET)
*	variable    - name of desired variable in data set
*	actual_dims - "a_" full dimensions of data_grid array passed
*	use_dims    - indices of model data block desired
*	data_grid   - array containing model data (output)
*	file_num    - file number (output)
*	status      - error status upon completion (output)
*
	CHARACTER*(*)	variable
	INTEGER		dset_num, file_num, status
	INTEGER		a_lo_x, a_lo_y, a_lo_z, a_lo_t, a_lo_e, a_lo_f, 
     .                  a_hi_x, a_hi_y, a_hi_z, a_hi_t, a_hi_e, a_hi_f,
     .			use_lo(*), use_hi(*), stride(*)
        REAL            data_grid(a_lo_x:a_hi_x,
     .                            a_lo_y:a_hi_y,
     .                            a_lo_z:a_hi_z,
     .                            a_lo_t:a_hi_t,
     .                            a_lo_e:a_hi_e,
     .                            a_lo_f:a_hi_f)

* local definitions
        INTEGER         STR_UPCASE, TM_LENSTR1, n, num_indices

	INTEGER		lcnt, modline, ivar, varpos, pcnt, istat,
     .			i, j, k, l, in, jn, kn, ln, vargrid, thisline,
     .			Dstart, Dend, Drange,
     .			Rstart, Rend, Rrange,
     .			Tstart, Tend, Trange
	INTEGER		i_lo, j_lo, k_lo, l_lo, m_lo, n_lo, 
     .			i_hi, j_hi, k_hi, l_hi, m_hi, n_hi,
     .			iadj, jadj, kadj, ladj, madj, nadj
	INTEGER		tmp_lo(nferdims), tmp_hi(nferdims), 
     .			adj_lo(nferdims), adj_hi(nferdims),
     .			adj(nferdims), actual_lo(nferdims), 
     .			actual_hi(nferdims)
        CHARACTER*128    upcase_var
	EQUIVALENCE	(tmp_lo(1),i_lo),
     .			(tmp_lo(2),j_lo),
     .			(tmp_lo(3),k_lo),
     .			(tmp_lo(4),l_lo),
     .			(tmp_lo(5),m_lo),
     .			(tmp_lo(6),n_lo)
	EQUIVALENCE	(tmp_hi(1),i_hi),
     .			(tmp_hi(2),j_hi),
     .	  		(tmp_hi(3),k_hi),
     .			(tmp_hi(4),l_hi),
     .			(tmp_hi(5),m_hi),
     .			(tmp_hi(6),n_hi)
	EQUIVALENCE	(adj(1),iadj),
     .			(adj(2),jadj),
     .			(adj(3),kadj),
     .			(adj(4),ladj),
     .			(adj(5),madj),
     .			(adj(6),nadj)

* initialize

	actual_lo(1) = a_lo_x
	actual_lo(2) = a_lo_y
	actual_lo(3) = a_lo_z
	actual_lo(4) = a_lo_t
	actual_lo(5) = a_lo_e
	actual_lo(6) = a_lo_f
	actual_hi(1) = a_hi_x
	actual_hi(2) = a_hi_y
	actual_hi(3) = a_hi_z
	actual_hi(4) = a_hi_t
	actual_hi(5) = a_hi_e
	actual_hi(6) = a_hi_f
!        istat = STR_UPCASE( upcase_var, variable )     ! 4/91
        upcase_var = variable     ! 7/98

* check for valid variable and get variable number
*	DO 100 ivar = 1,maxvars
*	  IF ((ds_var_setnum(ivar) .EQ. dset_num) .AND.
*     .	    (ds_var_code(ivar) .EQ. upcase_var)) THEN
*	    varpos = ivar
*	    GOTO 110
*	  ENDIF
*  100	CONTINUE

        CALL string_array_find_exact(ds_var_code_head,
     .                               upcase_var,
     .                               LEN(upcase_var),
     .                               string_array_result1(1),
     .                               maxvars,
     .                               num_indices)
        DO 100 n = 1, num_indices
            ivar = string_array_result1(n)
            IF ( ds_var_setnum(ivar) .EQ. dset_num) THEN
	        varpos = ivar
	        GOTO 110
            ENDIF
  100	CONTINUE
	GOTO 9000

* Is it a Modulo set - If not call TM_CHOOSE_READ w/o modification
* if it is - get the modulo line, and make sure at this time there's only 1
* axis needing a modulo read call.
  110	vargrid = ds_grid_number(varpos)
	modline = 0
	DO 120 lcnt = 1,nferdims
	  thisline = grid_line(lcnt,vargrid)
	  IF (thisline .EQ. mpsunkn .OR. thisline .EQ. mpsnorm) GOTO 120
	  IF (line_modulo(thisline)) THEN

	    IF (use_lo(lcnt) .GE. 1 .AND.
!     .	        use_hi(lcnt) .LE. line_dim(thisline)) GOTO 120
     .         use_hi(lcnt) .LE. ds_grid_end(lcnt,varpos)) GOTO 120

	    IF (modline .NE. 0) GOTO 9100
	    modline = lcnt
	  ENDIF
  120	CONTINUE
	
	IF (modline .EQ. 0) THEN
	  CALL TM_CHOOSE_READ ( dset_num, varpos,
     .		a_lo_x, a_lo_y, a_lo_z, a_lo_t, a_lo_e, a_lo_f,
     .		a_hi_x, a_hi_y, a_hi_z, a_hi_t, a_hi_e, a_hi_f,
     .		use_lo, use_hi, stride,
     .		data_grid, file_num, status )
	  IF (status .NE. merr_ok) GOTO 9999

* It's modulo : Set-up
* D = Defining Axis    : the axis that the data is stored on
* R = Requested Axis   : the axis requested by the user (not necessarily in the
*                        range of the Defining axis)
* T = Transformed Axis : the R axis translated by a MOD function so that it
*                        starts somewhere in the Defining axis
	ELSE
	  Dstart = 1
	  Drange = line_dim(grid_line(modline,vargrid))
	  Dend = Drange - Dstart + 1
	  Rstart = use_lo(modline)
	  Rend = use_hi(modline)
	  Rrange = Rend - Rstart + 1
	  Tstart = MOD(Rstart-1,Drange) + 1
	  IF (Tstart .LE. 0) Tstart = Tstart + Drange
	  Tend = Tstart + Rrange - 1
	  Trange = Rrange

* Read #1 - always done
	  DO 130 pcnt = 1,nferdims
	    tmp_lo(pcnt) = use_lo(pcnt)
	    tmp_hi(pcnt) = use_hi(pcnt)
	    adj_lo(pcnt) = actual_lo(pcnt)
	    adj_hi(pcnt) = actual_hi(pcnt)
  130	  CONTINUE
	  tmp_lo(modline) = Tstart
	  tmp_hi(modline) = MIN(Dend,Tend)
	  adj_lo(modline) = actual_lo(modline) - (Rstart - Tstart)
	  adj_hi(modline) = actual_hi(modline) - (Rstart - Tstart)
	  CALL TM_CHOOSE_READ ( dset_num, varpos,
     .		adj_lo(1),adj_lo(2),adj_lo(3),adj_lo(4),adj_lo(5),adj_lo(6),
     .		adj_hi(1),adj_hi(2),adj_hi(3),adj_hi(4),adj_hi(5),adj_hi(6),
     .		tmp_lo, tmp_hi, stride,
     .		data_grid, file_num, status )
	  IF (status .NE. merr_ok) GOTO 9999

* Read #2 - optional depending on length & position of Requested grid
	  IF (Tend .GT. Dend .AND. Tstart .NE. 1) THEN
	    tmp_lo(modline) = Dstart
	    tmp_hi(modline) = MIN(Tstart-1,Tend-Drange)
	    adj_lo(modline) = adj_lo(modline) - Drange
	    adj_hi(modline) = adj_hi(modline) - Drange
	    CALL TM_CHOOSE_READ ( dset_num, varpos,
     .		adj_lo(1),adj_lo(2),adj_lo(3),adj_lo(4),adj_lo(5),adj_lo(6),
     .		adj_hi(1),adj_hi(2),adj_hi(3),adj_hi(4),adj_hi(5),adj_hi(6),
     .		tmp_lo, tmp_hi, stride,
     .		data_grid, file_num, status )
	    IF (status .NE. merr_ok) GOTO 9999
	  ENDIF

* Data duplication (NOTE: tmp_lo,tmp_hi are equivalenced with i,j,k,l _lo & _hi)
*                  (NOTE: adj is equivalenced with i,j,k,l _adj)
	  IF (Trange .GT. Drange) THEN
	    tmp_lo(modline) = Rstart+Drange
	    tmp_hi(modline) = Rend
	    DO 140 pcnt = 1,nferdims
	      adj(pcnt) = 0
  140	    CONTINUE
	    adj(modline) = Drange
	    DO 180 ln = l_lo,l_hi
	      l = ln - ladj
	      DO 170 kn = k_lo,k_hi
	        k = kn - kadj
	        DO 160 jn = j_lo,j_hi
	          j = jn - jadj
	          DO 150 in = i_lo,i_hi
	            i = in - iadj
	            data_grid(in,jn,kn,ln,-999,-999) = 
     .			   data_grid(i,j,k,l,-999,-999)	
  150	          CONTINUE
  160	        CONTINUE
  170	      CONTINUE
  180	    CONTINUE
	  ENDIF
	ENDIF
	status = merr_ok
	GOTO 9999

* ERRORS
* note: use upcase_var instead of "variable" to avoid RISC // prob. w/ CHAR*(*)
 9000   l = TM_LENSTR1(upcase_var)
	CALL TM_ERRMSG (merr_unkvar, status, 'TM_READ',
     .			dset_num, no_stepfile,
     .			'VAR='//upcase_var(:l), no_errstring, *9999)
Cf77     .			'VAR='//variable, no_errstring, *9999)
 9100	CALL TM_ERRMSG (merr_notsupport, status, 'TM_READ',
     .			dset_num, no_stepfile,
     .			'only 1 axis at a time can have a modulo read',
     .			no_errstring, *9999)

 9999	RETURN
	END

      SUBROUTINE AXIS(XALOW,XAHIGH,XAORG,YALOW,YAHIGH,YAORG,XATIC,
     * YATIC,NATICX,NATICY)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)axis.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     CALL AXIS(XLOW,XHIGH,XORG,YLOW,YHIGH,YORG,XTIC,YTIC,NSTICX,
C    * NSTICY)
C
C     THIS SUBROUTINE DRAWS A SET OF X AND Y AXES IN THE PLOTTING
C     AREA.  BOTH LARGE AND SMALL TICK MARKS MAY BE DRAWN ON THE
C     AXES AT REGULAR INTERVALS.
C
C     THE VARIOUS PARAMETERS AND THEIR DEFINITIONS ARE LISTED
C     BELOW:
C        XLOW   - MINIMUM VALUE OF THE X-AXIS IN USER'S UNITS.
C        XHIGH  - MAXIMUM VALUE OF THE X-AXIS IN USER'S UNITS.
C        XORG   - VALUE OF X AT WHICH THE Y-AXIS CROSSES THE
C                 X-AXIS IN USER'S UNITS.
C        YLOW   - MINIMUM VALUE OF THE Y-AXIS IN USER'S UNITS.
C        YHIGH  - MAXIMUM VALUE OF THE Y-AXIS IN USER'S UNITS.
C        YORG   - VALUE OF Y AT WHICH THE X-AXIS CROSSES THE
C                 Y-AXIS IN USER'S UNITS.
C        XTIC   - DISTANCE BETWEEN LARGE TICK MARKS ON THE X-AXIS
C                 IN USER'S UNITS.
C        YTIC   - DISTANCE BETWEEN LARGE TICK MARKS ON THE Y-AXIS
C                 IN USER'S UNITS.
C        NSTICX - NUMBER OF SMALL TICK MARKS BETWEEN EACH OF THE
C                 LARGE TICK MARKS ON THE X-AXIS.
C        NSTICY - NUMBER OF SMALL TICK MARKS BETWEEN EACH OF THE
C                 LARGE TICK MARKS ON THE Y-AXIS.
C
C     AXIS MAKES SEVERAL CHECKS ON THE PARAMETERS TO MAKE SURE
C     THAT THEY ARE VALID.  THEY ARE ALTERED INTERNALLY IF NECES-
C     SARY.
C
C
C     TRANSFER THE PARAMETERS TO NEW VARIABLES.
C
      XLOW = XALOW
      XHIGH = XAHIGH
      XORG = XAORG
      YLOW = YALOW
      YHIGH = YAHIGH
      YORG = YAORG
      XTIC = ABS(XATIC)
      YTIC = ABS(YATIC)
      NSTICX = NATICX
      NSTICY = NATICY
C
C     CHECK THE PARAMETERS TO MAKE SURE THAT THEY ARE VALID.
C
      IF(XLOW .GT. XHIGH)THEN
        TEMP = XLOW
        XLOW = XHIGH
        XHIGH = TEMP
      ENDIF
      IF(YLOW .GT. YHIGH)THEN
        TEMP = YLOW
        YLOW = YHIGH
        YHIGH = YLOW
      ENDIF
      IF(XORG .LT. XLOW)XORG = XLOW
      IF(YORG .LT. YLOW)YORG = YLOW
      IF(XORG .GT. XHIGH)XORG = XHIGH
      IF(YORG .GT. YHIGH)YORG = YHIGH
      IF(NSTICX .LT. 0)NSTICX = 0
      IF(NSTICY .LT. 0)NSTICY = 0
C
C     SET VECTRS MODE.
C
      CALL VECTRS
C
C     START AT THE ORIGIN.
C
      X = XORG
      Y = YORG
      CALL PLOT(X,Y,0,0)
C
C     IF THERE ARE NO TICK MARKS ON THE Y-AXIS, DRAW THE ENTIRE
C     AXIS.
C
      IF(YTIC .EQ. 0.0)THEN
        CALL PLOT(X,YLOW,0,0)
        CALL PLOT(X,YHIGH,1,0)
        CALL PLOT(X,Y,0,0)
      ELSE
C
        SMY = YTIC / FLOAT(NSTICY + 1)
C
        IF(YLOW .LT. YORG)THEN
C
C     DRAW THE NEGATIVE Y-AXIS.
C
   10     IF(NSTICY .EQ. 0)GO TO 30
          DO 20 J=1,NSTICY
          Y = Y - SMY
          IF(Y .LT. YLOW)GO TO 40
   20     CALL PLOT(X,Y,1,5)
   30     Y = Y - SMY
          IF(Y .LT. YLOW)GO TO 40
          CALL PLOT(X,Y,1,6)
          GO TO 10
   40     CALL PLOT(X,YLOW,1,0)
          Y = YORG
          CALL PLOT(X,Y,0,0)
        ENDIF
C
        IF(YHIGH .GT. YORG)THEN
C
C     DRAW THE POSITIVE Y-AXIS.
C
   50     IF(NSTICY .EQ. 0)GO TO 70
          DO 60 J=1,NSTICY
          Y = Y + SMY
          IF(Y .GT. YHIGH)GO TO 80
   60     CALL PLOT(X,Y,1,5)
   70     Y = Y + SMY
          IF(Y .GT. YHIGH)GO TO 80
          CALL PLOT(X,Y,1,6)
          GO TO 50
   80     CALL PLOT(X,YHIGH,1,0)
          Y = YORG
          CALL PLOT(X,Y,0,0)
        ENDIF
      ENDIF
C
C     IF THERE ARE NO TICK MARKS ON THE X-AXIS, DRAW THE ENTIRE
C     AXIS.
C
      IF(XTIC .EQ. 0.0)THEN
        CALL PLOT(XLOW,Y,0,0)
        CALL PLOT(XHIGH,Y,1,0)
        CALL PLOT(X,Y,0,0)
      ELSE
C
        SMX = XTIC / FLOAT(NSTICX + 1)
C
        IF(XLOW .LT. XORG)THEN
C
C     DRAW THE NEGATIVE X-AXIS.
C
   90     IF(NSTICX .EQ. 0)GO TO 110
          DO 100 J=1,NSTICX
          X = X - SMX
          IF(X .LT. XLOW)GO TO 120
  100     CALL PLOT(X,Y,1,7)
  110     X = X - SMX
          IF(X .LT. XLOW)GO TO 120
          CALL PLOT(X,Y,1,8)
          GO TO 90
  120     CALL PLOT(XLOW,Y,1,0)
          X = XORG
          CALL PLOT(X,Y,0,0)
        ENDIF
C
        IF(XHIGH .GT. XORG)THEN
C
C     DRAW THE POSITIVE X-AXIS.
C
  130     IF(NSTICX .EQ. 0)GO TO 150
          DO 140 J=1,NSTICX
          X = X + SMX
          IF(X .GT. XHIGH)GO TO 160
  140     CALL PLOT(X,Y,1,7)
  150     X = X + SMX
          IF(X .GT. XHIGH)GO TO 160
          CALL PLOT(X,Y,1,8)
          GO TO 130
  160     CALL PLOT(XHIGH,Y,1,0)
          X = XORG
          CALL PLOT(X,Y,0,0)
        ENDIF
      ENDIF
C
C     THE AXES ARE COMPLETE.
C
      RETURN
C
      END

*           rr_adv_sz.F
*
*           Rick Romea
*           Jan. 24, 2000      
*
*     Zonal nonlinear advective term:  - w dS/dz
*     Units :  (SALINITY(ppm) - 0.035) / s
*     MOM2 Grid:  T   
*
*******************************************************************

      SUBROUTINE RR_adv_sz_init(id)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

      CALL ef_set_desc             (id,
     .'-w(dS/dz) nonlinear term (SALT/s);MOM2 T Grid.')
      CALL ef_set_num_args         (id,3)
      CALL ef_set_axis_inheritance (id,IMPLIED_BY_ARGS, 
     .                                 IMPLIED_BY_ARGS, 
     .                                 IMPLIED_BY_ARGS, 
     .                                 IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok     (id, NO, NO, NO, NO)
      CALL ef_set_arg_name         (id,ARG1,'U')
      CALL ef_set_arg_desc         (id,ARG1,
     . 'Zonal velocity, on the MOM2 U Grid. ')
      CALL ef_set_arg_unit         (id,ARG1,'cm/sec')
      CALL ef_set_arg_type         (id,ARG1,FLOAT_ARG)
      CALL ef_set_axis_influence   (id,ARG1,YES,YES,YES,YES)
      CALL ef_set_axis_extend      (id,ARG1,X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id,ARG1,Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id,ARG1,Z_AXIS,0,+1)

      CALL ef_set_arg_name         (id,ARG2,'W')
      CALL ef_set_arg_desc         (id,ARG2,
     . 'Vertical velocity, at T cell bottom on the MOM2 Grid.')
      CALL ef_set_arg_unit         (id,ARG2,'cm/sec')
      CALL ef_set_arg_type         (id,ARG2,FLOAT_ARG)
      CALL ef_set_axis_influence   (id,ARG2,NO,NO,NO,YES)
      CALL ef_set_axis_extend      (id,ARG2,X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id,ARG2,Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id,ARG2,Z_AXIS,0,+1)

      CALL ef_set_arg_name         (id,ARG3,'SALT')
      CALL ef_set_arg_desc         (id,ARG3,
     . 'Salinity, on the MOM2 T Grid.')
      CALL ef_set_arg_unit         (id,ARG3,'(ppt-35)/1000')
      CALL ef_set_arg_type         (id,ARG3,FLOAT_ARG)
      CALL ef_set_axis_influence   (id,ARG3, NO, NO,YES,YES)
      CALL ef_set_axis_extend      (id,ARG3,X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id,ARG3,Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id,ARG3,Z_AXIS,0,+1)
      END




      SUBROUTINE RR_adv_sz_compute(id, arg_1, arg_2, arg_3, result)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER        id

      REAL           bad_flag(EF_MAX_ARGS)
      REAL           bad_flag_result
      REAL           arg_1 (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .                      mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL           arg_2 (mem2lox:mem2hix, mem2loy:mem2hiy, 
     .                      mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL           arg_3 (mem3lox:mem3hix, mem3loy:mem3hiy, 
     .                      mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL           result (memreslox:memreshix,memresloy:memreshiy,
     .                       memresloz:memreshiz,memreslot:memreshit)

      INTEGER        res_lo_ss (4)
      INTEGER        res_hi_ss (4)
      INTEGER        res_incr  (4)

      INTEGER        arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER        arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER        arg_incr  (4,EF_MAX_ARGS)

      INTEGER        i,  j,  k,  l
      INTEGER        i2, j2, k2, l2
      INTEGER        i3, j3, k3, l3

      REAL*8         yU(1024)
      REAL*8         xU(1024)
      REAL*8         zW(1024)
      REAL*8         yT(1024)
      REAL*8         xT(1024)

      INTEGER        ilat
      INTEGER        ilon
      INTEGER        iZ

      CHARACTER*16   ax_name(4)
      CHARACTER*16   ax_units(4)
      LOGICAL        backward(4)
      LOGICAL        modulo(4)
      LOGICAL        regular(4)

      REAL           adv_fb         

      INCLUDE 'rr_parameters.h'

      adv_fb(i2,j2,k2,l2,i3,j3,k3,l3) =  arg_2(i2,j2,k2,l2)
     .                  * (arg_3(i3,j3,k3,l3) + arg_3(i3,j3,k3+1,l3))

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags      (id, bad_flag,  bad_flag_result)
      CALL ef_get_coordinates    (id, ARG1, X_AXIS, 
     .                            arg_lo_ss(X_AXIS,ARG1),
     .                            arg_hi_ss(X_AXIS,ARG1), xU)
      CALL ef_get_coordinates    (id, ARG1, Y_AXIS, 
     .                            arg_lo_ss(Y_AXIS,ARG1),
     .                            arg_hi_ss(Y_AXIS,ARG1), yU)
      CALL ef_get_coordinates    (id, ARG2, Z_AXIS, 
     .                            arg_lo_ss(Z_AXIS,ARG2),
     .                            arg_hi_ss(Z_AXIS,ARG2), zW)
      CALL ef_get_coordinates    (id, ARG3, X_AXIS, 
     .                            arg_lo_ss(X_AXIS,ARG3),
     .                            arg_hi_ss(X_AXIS,ARG3), xT)
      CALL ef_get_coordinates    (id, ARG3, Y_AXIS, 
     .                            arg_lo_ss(Y_AXIS,ARG3),
     .                            arg_hi_ss(Y_AXIS,ARG3), yT)
      CALL ef_get_axis_info  (id, ARG1, ax_name, ax_units, 
     .                                backward, modulo, regular) 
      IF     ( ax_units(1) .NE. 'deg'       .AND.
     .         ax_units(1) .NE. 'lon'       .AND.
     .         ax_units(1) .NE. 'degrees_E' .AND.
     .         ax_units(1) .NE. 'longitude' .AND.
     .         ax_units(1) .NE. 'Longitude' .AND. 
     .         ax_units(1) .NE. 'LONGITUDE' ) THEN
        WRITE (6,*)'Longitude axis units =', ax_units(1) 
        !CALL ef_bail_out(id,'Longitude axis must be in degrees')
      ENDIF

      IF     ( ax_units(2) .NE. 'deg'       .AND.
     .         ax_units(2) .NE. 'degrees_N' .AND.
     .         ax_units(2) .NE. 'lat'       .AND.
     .         ax_units(2) .NE. 'latitude'  .AND.
     .         ax_units(2) .NE. 'Latitude'  .AND. 
     .         ax_units(2) .NE. 'LATITUDE' ) THEN
        WRITE (6,*)'Latitude axis units =', ax_units(2) 
        !CALL ef_bail_out(id,'Latitude axis must be in degrees')
      ENDIF
      CALL ef_get_axis_info  (id, ARG1, ax_name, ax_units, 
     .                                backward, modulo, regular) 
      IF     ( ax_units(3) .NE. 'm'           .AND.
     .         ax_units(3) .NE. 'meters'  .AND.
     .         ax_units(3) .NE. 'M'           .AND.
     .         ax_units(3) .NE. 'METERS' ) THEN
        WRITE (6,*)'Longitude axis units =', ax_units(1) 
        !CALL ef_bail_out(id,'Z axis must be in meters')
      ENDIF 

      l2 = arg_lo_ss(T_AXIS,ARG2) 
      l3 = arg_lo_ss(T_AXIS,ARG3) 
      DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         ilat = 2  
         j2 = arg_lo_ss(Y_AXIS,ARG2) + 1
         j3 = arg_lo_ss(Y_AXIS,ARG3) + 1
         DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            iLon = 2
            i2 = arg_lo_ss(X_AXIS,ARG2) + 1
            i3 = arg_lo_ss(X_AXIS,ARG3) + 1
            DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
	       iZ = 1
               k2 = arg_lo_ss(Z_AXIS,ARG2)
               k3 = arg_lo_ss(Z_AXIS,ARG3)
               DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
                  IF (arg_2(i2,  j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2,  j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2,  j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_3(i3,  j3,  k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3+1,j3,  k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3-1,j3,  k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3,  j3+1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3+1,j3+1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3-1,j3+1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3,  j3-1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3+1,j3-1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3-1,j3-1,k3,l3) .EQ. bad_flag(ARG3)) THEN
                     result(i,j,k,l) = bad_flag_result
                  ELSE
                     IF (iZ .EQ. 1) THEN
                        result(i,j,k,l) = (  
     .                       arg_2(i2,j2,k2,l2)
     .                  * (arg_3(i3,j3,k3,l3) + arg_3(i3,j3,k3+1,l3))
     .                           / 2. 
     .                       - arg_3(i3,j3,k3,l3) * 
     .                              arg_2(i2,j2,k2,l2)  
     .                    ) / (zW(iZ)*Meters_to_cm)     
     .                     * sec_per_month
                     ELSE
                        result(i,j,k,l) =  ( 
     .                      - (adv_fb(i2,j2,k2-1,l2,i3,j3,k3-1,l3)
     .                        - adv_fb(i2,j2,k2,l2,i3,j3,k3,l3)) / 2.
     .                      + arg_3(i3,j3,k3,l3) * (
     .                          arg_2(i2,j2,k2-1,l2) - 
     .                              arg_2(i2,j2,k2,l2) ) 
     .                     )  /(zW(iZ-1)-zW(iZ))/Meters_to_cm        
     .                     * sec_per_month
                     ENDIF
                  ENDIF
                  iZ = iZ + 1
                  k2 = k2 + arg_incr(Z_AXIS,ARG2)
                  k3 = k3 + arg_incr(Z_AXIS,ARG3)
               ENDDO
               iLon = iLon + 1
               i2 = i2 + arg_incr(X_AXIS,ARG2)
               i3 = i3 + arg_incr(X_AXIS,ARG3)
            ENDDO
            iLat = iLat + 1
            j2 = j2 + arg_incr(Y_AXIS,ARG2)
            j3 = j3 + arg_incr(Y_AXIS,ARG3)
         ENDDO
         l2 = l2 + arg_incr(T_AXIS,ARG2)
         l3 = l3 + arg_incr(T_AXIS,ARG3)
      ENDDO               
      END

      SUBROUTINE GET_INPUT_VARNAME (varattname, varname)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
      
* Return the varname part of an varattname, without any parentheses or brackets

* V600 6/05 *acm* Attribute control.
* V600  4/06 *acm* - additional declarations found by Solaris compiler

        IMPLICIT NONE
        INCLUDE 'xrisc.cmn'
        INCLUDE 'errmsg.parm'

* calling argument declarations

      CHARACTER*(*) varattname, varname

* local variable declarations

      INTEGER TM_LENSTR1, slen, itmp, status

      slen = TM_LENSTR1(varattname)
      IF (varattname(1:1) .EQ. '(' .AND.
     .    INDEX(varattname(1:slen), ')' ) .GT. 1 ) THEN

         varname = varattname(2:slen)

* locate the end of the parentheses

         itmp = INDEX(varname,')')
         IF ( itmp .GT. slen ) GOTO 5200		! unpaired parentheses
         varname(itmp:slen) = ' '

* Remove square brackets
         IF ( INDEX(varname,'[') .GT. 0 ) THEN
            slen = INDEX(varname,'[') 
            varname(slen:) = ' ' 
         ENDIF
      ENDIF

* error exits
 5000 RETURN
 5200 status = ferr_syntax
      risc_buff = varattname
      CALL ERRMSG( status, status, 'no closing parentheses'//
     .	           risc_buff(:slen), *5000 )
      END

	SUBROUTINE CREATE_AGG_AXIS (len, line_dir, iline, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Define an axis for the aggregation direction (Ensemble or Forecast). If more
* than one aggregation axis is defined, TM_NEW_LINE_NAME makes a unique name.

* original: *acm*
* V695+ *sh* 5/15 - set up calendar axis attributes from 1st member dset
* V698 *sh* 1/16 - use TM_ALLO_TMP_LINE to create axis, so its use counts get 
*			set and it gets deallocated automatically
*      *sh* 2/16 - if a pre-existing identical axis exists, re-use it
*                  else we cannot aggregate the aggs (for EF and FE aggs)
*      *sh* 4/16 - put special E and F units onto agg axes

      IMPLICIT NONE
        include 'tmap_errors.parm'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xdset_info.cd_equiv'
        include 'xprog_state.cmn'
	include 'xtm_grid.cmn_text'  
	include 'errmsg.parm'
	include 'xunits.cmn_text'

	
* calling argument declarations:
	INTEGER	len, line_dir, iline, status

* local variable declarations:
	INTEGER TM_FIND_LIKE_DYN_LINE, pre_exist
	CHARACTER*64 newname

* create the ensemble or forecast axis
	CALL TM_ALLO_TMP_LINE (iline, status)
	IF ( status .NE. ferr_ok ) GOTO 5000

* save the line in memory - but don't catalog its name
	IF (line_dir .EQ. e_dim) THEN
	   CALL TM_NEW_LINE_NAME ( 'ENSEMBLE', newname )
	   line_direction( iline ) = 'EE'
	   line_units( iline ) = plag_ax_units_e
	ENDIF
	IF (line_dir .EQ. f_dim) THEN
	   CALL TM_NEW_LINE_NAME ( 'RUN', newname )
	   line_direction( iline ) = 'FI'
	   line_units( iline ) = plag_ax_units_f
	ENDIF

	line_name     ( iline ) = newname
	line_name_orig( iline ) = newname
	line_start    ( iline ) = 1.0D0
!	line_start    ( iline ) = 0.5D0     ! something to consider ...3/16
	line_delta    ( iline ) = 1.0D0
	line_dim      ( iline ) = len
	line_regular  ( iline ) = .TRUE.
	line_modulo   ( iline ) = .FALSE.
	line_unit_code( iline ) = 0			! unknown units
	line_shift_origin( iline ) = .FALSE.

!	line_direction( iline ) = 'NA'
!	IF (line_dir .EQ. x_dim) THEN
!	   line_direction( iline ) = 'WE'
!	   line_name     ( iline ) = 'LONGUITUDE'
!	ELSEIF (line_dir .EQ. y_dim) THEN
!	   line_direction( iline ) = 'SN'
!	   line_name     ( iline ) = 'LATITUDE'
!	ELSEIF (line_dir .EQ. z_dim) THEN
!	   line_direction( iline ) = 'UD'
!	   line_name     ( iline ) = 'DEPTH'
!	ELSEIF (line_dir .EQ. t_dim) THEN
!	   line_direction( iline ) = 'TI'
!	   line_name     ( iline ) = 'TIME'
!	ELSEIF (line_dir .EQ. e_dim) THEN
!	   line_direction( iline ) = 'EE'
!	   line_name     ( iline ) = 'ENSEMBLE'
!	ELSEIF (line_dir .EQ. f_dim) THEN
!	   line_direction( iline ) = 'FI'
!	   line_name     ( iline ) = 'FORECAST'
!	ENDIF
	line_name_orig( iline ) = line_name ( iline )

! this code not needed.  AGG_CLEAN_GRIDS takes care of removing dups
!* now check to see if an identical axis already exists.  If so, then
!* use the pre-existing one, instead
!	pre_exist = TM_FIND_LIKE_DYN_LINE( iline )
!	IF (pre_exist .NE. unspecified_int4) THEN
!	   line_name (iline) = char_init16   ! deallo'd in tm_garb_collect
!!	   CALL TM_DEALLO_DYN_LINE(iline)
!	   iline = pre_exist
!	ENDIF

 5000   RETURN	
 5300   status = ferr_TMAP_error
	RETURN

	END

      SUBROUTINE UPDATE_ATTRIBUTES (dset, vname, uvar, status)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP

* V600 6/05 *acm* Attribute control.
* V670  2/11 *acm*   Fixes for inheriting attributes.
* V698  2/16 *acm* For ticket 2352: variables defined with LET/D are
*                  added to that dataset in the attribute structure.
* V720 *acm* 5/17 Implement specific calls in place of CD_GET_VAR_INFO

* Get the attribute information from the linked-list structure that is needed 
* to do a plot.


	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'ferret.parm'
        include 'errmsg.parm'
	include 'xcontext.cmn'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
	include 'xplot_state.cmn'
	include 'xtext_info.cmn'
	include 'xdset_info.cmn_text'
        include 'xdset_info.cd_equiv'
	external xdset_info_data

* Argument declarations

      INTEGER uvar, dset
      CHARACTER*(*) vname

* Local variable declarations
      LOGICAL NC_GET_ATTRIB, got_it, do_warn, uvflag
      INTEGER TM_LENSTR1, varid,
     .        attlen, attoutflag, status, vlen, maxlen
      REAL tmp
      CHARACTER*128 buff

      vlen = TM_LENSTR1(vname)
      CALL CD_GET_VAR_ID (dset, vname, varid, status)
      IF (status .NE. ferr_ok) GOTO 1100

* get the needed info for this variable

      CALL CD_GET_VAR_UVFLAG (dset, varid, uvflag, status)
      IF (status .NE. ferr_ok) GOTO 1200

      do_warn = .TRUE.

* Get long_name, units, missing_value

      IF (dset .EQ. unspecified_int4) RETURN
      IF (dset .GT. pdset_irrelevant) THEN

         maxlen = 128
         got_it = NC_GET_ATTRIB( dset, varid, 'long_name',
     .                     .NOT.do_warn, vname(:vlen), maxlen, attlen, 
     .                     attoutflag, ds_var_title(uvar), tmp )

         maxlen = 128
         got_it = NC_GET_ATTRIB( dset, varid, 'long_name_mod',
     .                     .NOT.do_warn, vname(:vlen), maxlen, attlen, 
     .                     attoutflag, ds_var_titl_mod(uvar), tmp )

         maxlen = 64
         got_it = NC_GET_ATTRIB( dset, varid, 'units',
     .                     do_warn, vname(:vlen), maxlen, attlen, 
     .                     attoutflag, ds_var_units(uvar), tmp )

         maxlen = 1
         got_it = NC_GET_ATTRIB( dset, varid, 'missing_value',
     .                do_warn, vname(:vlen), maxlen, attlen,
     .                attoutflag, buff, ds_bad_flag(uvar) )

       ENDIF
* For user variable update these in uvar_title, etc.

       IF (dset.EQ.pdset_uvars .OR. uvflag) THEN
         maxlen = 128
         got_it = NC_GET_ATTRIB( dset, varid, 'long_name',
     .                     .NOT.do_warn, vname(:vlen), maxlen, attlen, 
     .                     attoutflag, uvar_title(uvar), tmp )

         maxlen = 64
         got_it = NC_GET_ATTRIB( dset, varid, 'units',
     .                     do_warn, vname(:vlen), maxlen, attlen, 
     .                     attoutflag, uvar_units(uvar), tmp )

         maxlen = 1
         got_it = NC_GET_ATTRIB( dset, varid, 'missing_value',
     .                do_warn, vname(:vlen), maxlen, attlen,
     .                attoutflag, buff, uvar_bad_data(uvar) )

      ENDIF

* successful completion - variable attributes updated
 1000 status = ferr_ok
 5000 RETURN
 1100 CALL ERRMSG
     .       ( ferr_unknown_variable, status, vname, *5000 )
 1200 CALL ERRMSG
     .       ( ferr_internal, status, 'varinfo: '//vname(:vlen), *5000 )
      END

*
* str_missing.F
*
* Ansley Manke
* 8-Feb-2011
*
* This function replaces the strings in argument 2 with the string in argument 3
* according to a mask, arg 1.
* STR_MISSING(mask, default_string, replacement_string)
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE str_missing_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CHARACTER*100 fcn_desc

 10   FORMAT ('Replace the strings in arg2 with the string in arg3 ',
     .       'according to a mask, arg1.')

      WRITE (fcn_desc, 10) 
      CALL ef_set_desc(id, fcn_desc)


      CALL ef_set_num_args(id, 3)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     . IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_result_type(id, STRING_RETURN)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'MASK')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 
     .  'mask: substitute arg3 in arg2 where mask=1')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)
      CALL ef_set_arg_type (id, arg, FLOAT_ARG)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'STR')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'string array')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)
      CALL ef_set_arg_type (id, arg, STRING_ARG)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'REPL')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'Scalar string to substitute')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)
      CALL ef_set_arg_type (id, arg, STRING_ARG)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE str_missing_compute(id, arg_1, arg_2, 
     .                                   arg_3, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result


* Single precision Ferret: string arg and result need to be twice the length.
      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(strdf,mem2lox:mem2hix, mem2loy:mem2hiy, 
     .           mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL arg_3(strdf,mem3lox:mem3hix, mem3loy:mem3hiy, 
     .     mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1
      INTEGER i2, j2, k2, l2
      INTEGER i3, j3, k3, l3
      INTEGER iarg, slen2, slen3
      CHARACTER text2*2048, text3*2048

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* Get replacement string
      i3=arg_lo_ss(X_AXIS, ARG3)
      j3=arg_lo_ss(Y_AXIS, ARG3)
      k3=arg_lo_ss(Z_AXIS, ARG3)
      l3=arg_lo_ss(T_AXIS, ARG3)

      CALL ef_get_string_arg_element(id, ARG3, arg_3,
     .     i3,j3,k3,l3,slen3,text3)

      i1 = arg_lo_ss(X_AXIS,ARG1)
      i2 = arg_lo_ss(X_AXIS,ARG2)
      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         j2 = arg_lo_ss(Y_AXIS,ARG2)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

            k1 = arg_lo_ss(Z_AXIS,ARG1)
            k2 = arg_lo_ss(Z_AXIS,ARG2)
            DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

               l1 = arg_lo_ss(T_AXIS,ARG1)
               l2 = arg_lo_ss(T_AXIS,ARG2)
               DO 100 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
                  iarg = 2
 	          CALL EF_GET_STRING_ARG_ELEMENT (id, iarg, arg_2, 
     .                                      i2,j2,k2,l2, slen2, text2)
                  IF (arg_1(i1,j1,k1,l1) .EQ. 1) THEN
		     text2 = text3
		     slen2 = slen3
		  ENDIF
                  CALL EF_PUT_STRING (text2, slen2, result(i,j,k,l))

                  l1 = l1 + arg_incr(T_AXIS,ARG1)
                  l2 = l2 + arg_incr(T_AXIS,ARG2)
 100           CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
               k2 = k2 + arg_incr(Z_AXIS,ARG2)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
            j2 = j2 + arg_incr(Y_AXIS,ARG2)
 300     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
         i2 = i2 + arg_incr(X_AXIS,ARG2)
 400  CONTINUE
 

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	SUBROUTINE GET_AXIS_SPEED( dset )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* order the axes X,Y,Z and T into array ds_ax_speed with the fastest (axis of
* records) in position 1, the slowest in position 6, and the others
* ordered from fast to slow if possible.
* normal axes will be regarded as fast (but slower than the record axis)

* e.g. the variable TAUX ordered X,Y in a GT set would produce X,Z,Y,T

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  6/8/89
* V230:  3/2/92  - netCDF support
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 removing use of old GT and TS data formats
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V685 *acm*  3/13 For Ensemble aggregations, call the ds_type 'ENS'
* V695 *acm*  2/15 For Forecast aggregations, call the ds_type 'FCT'
* V698 *acm* 1/16 Allow for Epic CDF files, ds_type = 'ECDF'
* V7.6 *acm* 1/20 ds_time_axis initialized with int4_init

        IMPLICIT NONE
* calling argument declarations:
	INTEGER	dset

* internal variable declarations:
	INTEGER	idim, i, slowdim, igrid, ivar, nexdim, int4_init

	include 'tmap_dims.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xtm_grid.cmn_text'
	include 'ferret.parm'
	include 'xax_speed.cmn'
	
	int4_init = -7777

* insert default assumptions
	DO 100 idim = 1, nferdims
 100	ds_ax_speed( idim, dset ) = idim

* netCDF
	IF( ds_type(dset) .EQ. 'CDF' .OR. 
     .      ds_type(dset) .EQ. 'ECDF' .OR. 
     .      ds_type(dset) .EQ. 'ENS'.OR. 
     .      ds_type(dset) .EQ. 'FCT') THEN
* ... "record" axis is slowest (stored in ds_time_axis)
* ... locate it in a grid to see what role it plays
           IF (ds_time_axis(dset).EQ.unspecified_int4 .OR. ds_time_axis(dset).EQ.int4_init) RETURN
           DO 410 ivar = 1, maxvars
              IF ( ds_var_setnum(ivar) .NE. dset ) GOTO 410
              igrid = ds_grid_number(ivar)
              DO 400 idim = 1, nferdims
 400          IF (grid_line(idim,igrid).EQ.ds_time_axis(dset)) GOTO 450
 410       CONTINUE
           RETURN

* ... we found the record axis in a grid
 450       slowdim = idim
           ds_ax_speed(6,dset) = slowdim
           nexdim = 1
	   DO 460 idim = 1, nferdims-1
              IF ( idim .EQ. slowdim ) nexdim = nexdim + 1
              ds_ax_speed(idim,dset) = nexdim
              nexdim = nexdim + 1
 460       CONTINUE

	ENDIF

	RETURN
	END

*
* add_9.F
*
* Jonathan Callahan
* Feb 19th 1998
*
* Returns the sum of nine arguments.
*


*
* In this subroutine we provide information about
* the function.  The user configurable information
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
*
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result
*


      SUBROUTINE add_9_init(id)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

      CALL ef_version_test(ef_version)

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id, '(demonstration function) adds 9 arguments')
      CALL ef_set_num_args(id, 9)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, YES, YES, YES, YES, YES, YES)

* All arguments should be on the same grid

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'B')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'C')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'D')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'E')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

      arg = 6
      CALL ef_set_arg_name(id, arg, 'F')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

      arg = 7
      CALL ef_set_arg_name(id, arg, 'G')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

      arg = 8
      CALL ef_set_arg_name(id, arg, 'H')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

      arg = 9
      CALL ef_set_arg_name(id, arg, 'I')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE add_9_compute(id, arg_1, arg_2, arg_3, arg_4, arg_5,
     .                         arg_6, arg_7, arg_8, arg_9, result)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz,
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz,
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz,
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz,
     .           mem4lot:mem4hit, mem4loe:mem4hie, mem4lof:mem4hif)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz,
     .           mem5lot:mem5hit, mem5loe:mem5hie, mem5lof:mem5hif)
      REAL arg_6(mem6lox:mem6hix, mem6loy:mem6hiy, mem6loz:mem6hiz,
     .           mem6lot:mem6hit, mem6loe:mem6hie, mem6lof:mem6hif)
      REAL arg_7(mem7lox:mem7hix, mem7loy:mem7hiy, mem7loz:mem7hiz,
     .           mem7lot:mem7hit, mem7loe:mem7hie, mem7lof:mem7hif)
      REAL arg_8(mem8lox:mem8hix, mem8loy:mem8hiy, mem8loz:mem8hiz,
     .           mem8lot:mem8hit, mem8loe:mem8hie, mem8lof:mem8hif)
      REAL arg_9(mem9lox:mem9hix, mem9loy:mem9hiy, mem9loz:mem9hiz,
     .           mem9lot:mem9hit, mem9loe:mem9hie, mem9lof:mem9hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable's axes.

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,  j,  k,  l,  m,  n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2
      INTEGER i3, j3, k3, l3, m3, n3
      INTEGER i4, j4, k4, l4, m4, n4
      INTEGER i5, j5, k5, l5, m5, n5
      INTEGER i6, j6, k6, l6, m6, n6
      INTEGER i7, j7, k7, l7, m7, n7
      INTEGER i8, j8, k8, l8, m8, n8
      INTEGER i9, j9, k9, l9, m9, n9

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      n1 = arg_lo_ss(F_AXIS,ARG1)
      n2 = arg_lo_ss(F_AXIS,ARG2)
      n3 = arg_lo_ss(F_AXIS,ARG3)
      n4 = arg_lo_ss(F_AXIS,ARG4)
      n5 = arg_lo_ss(F_AXIS,ARG5)
      n6 = arg_lo_ss(F_AXIS,ARG6)
      n7 = arg_lo_ss(F_AXIS,ARG7)
      n8 = arg_lo_ss(F_AXIS,ARG8)
      n9 = arg_lo_ss(F_AXIS,ARG9)
      DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

       m1 = arg_lo_ss(E_AXIS,ARG1)
       m2 = arg_lo_ss(E_AXIS,ARG2)
       m3 = arg_lo_ss(E_AXIS,ARG3)
       m4 = arg_lo_ss(E_AXIS,ARG4)
       m5 = arg_lo_ss(E_AXIS,ARG5)
       m6 = arg_lo_ss(E_AXIS,ARG6)
       m7 = arg_lo_ss(E_AXIS,ARG7)
       m8 = arg_lo_ss(E_AXIS,ARG8)
       m9 = arg_lo_ss(E_AXIS,ARG9)
       DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

        l1 = arg_lo_ss(T_AXIS,ARG1)
        l2 = arg_lo_ss(T_AXIS,ARG2)
        l3 = arg_lo_ss(T_AXIS,ARG3)
        l4 = arg_lo_ss(T_AXIS,ARG4)
        l5 = arg_lo_ss(T_AXIS,ARG5)
        l6 = arg_lo_ss(T_AXIS,ARG6)
        l7 = arg_lo_ss(T_AXIS,ARG7)
        l8 = arg_lo_ss(T_AXIS,ARG8)
        l9 = arg_lo_ss(T_AXIS,ARG9)
        DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

         k1 = arg_lo_ss(Z_AXIS,ARG1)
         k2 = arg_lo_ss(Z_AXIS,ARG2)
         k3 = arg_lo_ss(Z_AXIS,ARG3)
         k4 = arg_lo_ss(Z_AXIS,ARG4)
         k5 = arg_lo_ss(Z_AXIS,ARG5)
         k6 = arg_lo_ss(Z_AXIS,ARG6)
         k7 = arg_lo_ss(Z_AXIS,ARG7)
         k8 = arg_lo_ss(Z_AXIS,ARG8)
         k9 = arg_lo_ss(Z_AXIS,ARG9)
         DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

          j1 = arg_lo_ss(Y_AXIS,ARG1)
          j2 = arg_lo_ss(Y_AXIS,ARG2)
          j3 = arg_lo_ss(Y_AXIS,ARG3)
          j4 = arg_lo_ss(Y_AXIS,ARG4)
          j5 = arg_lo_ss(Y_AXIS,ARG5)
          j6 = arg_lo_ss(Y_AXIS,ARG6)
          j7 = arg_lo_ss(Y_AXIS,ARG7)
          j8 = arg_lo_ss(Y_AXIS,ARG8)
          j9 = arg_lo_ss(Y_AXIS,ARG9)
          DO 200 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

           i1 = arg_lo_ss(X_AXIS,ARG1)
           i2 = arg_lo_ss(X_AXIS,ARG2)
           i3 = arg_lo_ss(X_AXIS,ARG3)
           i4 = arg_lo_ss(X_AXIS,ARG4)
           i5 = arg_lo_ss(X_AXIS,ARG5)
           i6 = arg_lo_ss(X_AXIS,ARG6)
           i7 = arg_lo_ss(X_AXIS,ARG7)
           i8 = arg_lo_ss(X_AXIS,ARG8)
           i9 = arg_lo_ss(X_AXIS,ARG9)
           DO 100 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

            IF ( arg_1(i1,j1,k1,l1,m1,n1) .EQ. bad_flag(ARG1) .OR.
     .           arg_2(i2,j2,k2,l2,m2,n2) .EQ. bad_flag(ARG2) .OR.
     .           arg_3(i3,j3,k3,l3,m3,n3) .EQ. bad_flag(ARG3) .OR.
     .           arg_4(i4,j4,k4,l4,m4,n4) .EQ. bad_flag(ARG4) .OR.
     .           arg_5(i5,j5,k5,l5,m5,n5) .EQ. bad_flag(ARG5) .OR.
     .           arg_6(i6,j6,k6,l6,m6,n6) .EQ. bad_flag(ARG6) .OR.
     .           arg_7(i7,j7,k7,l7,m7,n7) .EQ. bad_flag(ARG7) .OR.
     .           arg_8(i8,j8,k8,l8,m8,n8) .EQ. bad_flag(ARG8) .OR.
     .           arg_9(i9,j9,k9,l9,m9,n9) .EQ. bad_flag(ARG9) ) THEN

               result(i,j,k,l,m,n) = bad_flag_result

            ELSE

               result(i,j,k,l,m,n) = arg_1(i1,j1,k1,l1,m1,n1) +
     .                               arg_2(i2,j2,k2,l2,m2,n2) +
     .                               arg_3(i3,j3,k3,l3,m3,n3) +
     .                               arg_4(i4,j4,k4,l4,m4,n4) +
     .                               arg_5(i5,j5,k5,l5,m5,n5) +
     .                               arg_6(i6,j6,k6,l6,m6,n6) +
     .                               arg_7(i7,j7,k7,l7,m7,n7) +
     .                               arg_8(i8,j8,k8,l8,m8,n8) +
     .                               arg_9(i9,j9,k9,l9,m9,n9)

            ENDIF

            i1 = i1 + arg_incr(X_AXIS,ARG1)
            i2 = i2 + arg_incr(X_AXIS,ARG2)
            i3 = i3 + arg_incr(X_AXIS,ARG3)
            i4 = i4 + arg_incr(X_AXIS,ARG4)
            i5 = i5 + arg_incr(X_AXIS,ARG5)
            i6 = i6 + arg_incr(X_AXIS,ARG6)
            i7 = i7 + arg_incr(X_AXIS,ARG7)
            i8 = i8 + arg_incr(X_AXIS,ARG8)
            i9 = i9 + arg_incr(X_AXIS,ARG9)
 100       CONTINUE

           j1 = j1 + arg_incr(Y_AXIS,ARG1)
           j2 = j2 + arg_incr(Y_AXIS,ARG2)
           j3 = j3 + arg_incr(Y_AXIS,ARG3)
           j4 = j4 + arg_incr(Y_AXIS,ARG4)
           j5 = j5 + arg_incr(Y_AXIS,ARG5)
           j6 = j6 + arg_incr(Y_AXIS,ARG6)
           j7 = j7 + arg_incr(Y_AXIS,ARG7)
           j8 = j8 + arg_incr(Y_AXIS,ARG8)
           j9 = j9 + arg_incr(Y_AXIS,ARG9)
 200      CONTINUE

          k1 = k1 + arg_incr(Z_AXIS,ARG1)
          k2 = k2 + arg_incr(Z_AXIS,ARG2)
          k3 = k3 + arg_incr(Z_AXIS,ARG3)
          k4 = k4 + arg_incr(Z_AXIS,ARG4)
          k5 = k5 + arg_incr(Z_AXIS,ARG5)
          k6 = k6 + arg_incr(Z_AXIS,ARG6)
          k7 = k7 + arg_incr(Z_AXIS,ARG7)
          k8 = k8 + arg_incr(Z_AXIS,ARG8)
          k9 = l9 + arg_incr(Z_AXIS,ARG9)
 300     CONTINUE

         l1 = l1 + arg_incr(T_AXIS,ARG1)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
         l3 = l3 + arg_incr(T_AXIS,ARG3)
         l4 = l4 + arg_incr(T_AXIS,ARG4)
         l5 = l5 + arg_incr(T_AXIS,ARG5)
         l6 = l6 + arg_incr(T_AXIS,ARG6)
         l7 = l7 + arg_incr(T_AXIS,ARG7)
         l8 = l8 + arg_incr(T_AXIS,ARG8)
         l9 = l9 + arg_incr(T_AXIS,ARG9)
 400    CONTINUE

        m1 = m1 + arg_incr(E_AXIS,ARG1)
        m2 = m2 + arg_incr(E_AXIS,ARG2)
        m3 = m3 + arg_incr(E_AXIS,ARG3)
        m4 = m4 + arg_incr(E_AXIS,ARG4)
        m5 = m5 + arg_incr(E_AXIS,ARG5)
        m6 = m6 + arg_incr(E_AXIS,ARG6)
        m7 = m7 + arg_incr(E_AXIS,ARG7)
        m8 = m8 + arg_incr(E_AXIS,ARG8)
        m9 = m9 + arg_incr(E_AXIS,ARG9)
 500   CONTINUE

       n1 = n1 + arg_incr(F_AXIS,ARG1)
       n2 = n2 + arg_incr(F_AXIS,ARG2)
       n3 = n3 + arg_incr(F_AXIS,ARG3)
       n4 = l4 + arg_incr(F_AXIS,ARG4)
       n5 = n5 + arg_incr(F_AXIS,ARG5)
       n6 = n6 + arg_incr(F_AXIS,ARG6)
       n7 = n7 + arg_incr(F_AXIS,ARG7)
       n8 = n8 + arg_incr(F_AXIS,ARG8)
       n9 = n9 + arg_incr(F_AXIS,ARG9)
 600  CONTINUE

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN
      END

	SUBROUTINE RESET_UVAR_GRIDS

* Clear stored user grid info before or after a
* grave-accent evaluation.

* 3/2019  Ansley Manke

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xtm_grid.cmn_text'


	INTEGER i, uvar, dset, idim
	REAL	GET_LINE_COORD, rval

	IF (.NOT. cx_only) RETURN

	DO i = 1, uvar_cxo_len

	   rval = GET_LINE_COORD ( linemem(uvar_cx_only_lm)%ptr, i )
	   uvar = rval
	   rval = GET_LINE_COORD ( lineedg(uvar_cx_only_lm)%ptr, i )
	   dset = rval

	   IF (uvar .LE. 0) CYCLE
	   
	   DO idim = 1, nferdims
	      uvar_given ( idim, uvar ) = uvlim_irrelevant

	      uvar_lo_ss ( uvar, idim )  = unspecified_int4   !for bookkeeping
	      uvar_hi_ss ( uvar, idim )  = unspecified_int4
	      uvar_lo_ww ( idim, uvar )  = unspecified_val8
	      uvar_hi_ww ( idim, uvar )  = unspecified_val8
	      uvar_by_ss ( idim, uvar )  = .FALSE.          

	   ENDDO

* remove all of the grids associated with this uvar. 
* DEALLO_UVAR_GRIDS does the free operation

	   CALL DEALLO_UVAR_GRIDS(uvar) 
c	   CALL NCF_FREE_UVAR_GRID_LIST( dset, uvar)


	ENDDO

	RETURN
	END

	SUBROUTINE TAXIS_STYLE( x_or_y, lo_bc, hi_bc, tstyle, imposed_lab )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* set up PPLUS to properly format a time axis

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 9/22/88 - extracted from AXIS_FORMAT
* revision 0.1 -  1/9/89 - added climatological axis logic
* 12/10/93 - set only the small tic size - do not mess with large tics
* V420: 11/95 - accomodate century long time axes
*	      - and 4-digit PLOT+ years!!
*	      - added "x_or_y" argument for Y axis calendar axes
*	      - added TXTYPE MULTIYR
* V510: 5/00 *sh* - extend formatting to 1000's of years axes
* V650  1/10 *acm*- Define a symbol TXTYPE_SETTING which can be used in
*               scripts when deciding whether to set the axis style as DMY
** V650  1/10 *acm*-  Bug 670 fixed: added TXTYPE MULTIYR, multi-decade
* V66    7/10 *kms* - undiscovered bug fixed: 'TXTYPE_SETTING' was used 
*                     directly instead of buff30 in call to GETSYM
* V686 *acm* 11/13 Allow symbol names to be up to 120 characters long
* V695+ *sh*  3/15 Added argument "imposed_lab" to disambiguate F and T axes
* V695  *acm*  9/15 Changes for hour:min labeling on time axes
* V710  *acm* 11/16 Ticket 2483: Fix the axis-end symbols that are defined 
*                   for time axis plots

	include 'ferret.parm'
	include 'plot_setup.parm'
	include 'tmap_dims.parm'
	include 'xplot_setup.cmn'
        include 'axis_inc.decl'	! with axis lengths
        include 'AXIS.INC'      ! with axis lengths	

* calling argument declarations:
	CHARACTER	x_or_y*1, tstyle*3
	CHARACTER*(*)	imposed_lab
	REAL*8		lo_bc, hi_bc

* parameter definitions:
	INTEGER		pmax_tax
	REAL*8		psecs_at_2_yrs
	PARAMETER     ( pmax_tax   = 16,
     .			psecs_at_2_yrs = 60.*60.*24.*365.*2. )

* internal variable declarations:
	LOGICAL		climatology, its_x
	INTEGER		TM_LENSTR1, TM_LENSTR, itax, hi_int, slen, ilen, i1, i2
	CHARACTER	ppl_cmnd*128, tstyle_long*10, buff30*30, buff*10
	REAL		hrs, hrsper8, axlen

* time axis style table
	INTEGER		tax_loint( pmax_tax ),	! PPL TXLINT lo,...
     .			tax_hiint( pmax_tax )	! PPL TXLINT ...,hi
	REAL		tax_hours( pmax_tax )	! bounds: range-->style
	CHARACTER*10	tax_style( pmax_tax )	! PPL TXTYPE value

	DATA	tax_hours(1)	/   12.	/,	! < 24 hour long axis with partial days, see label 510 for HR type
     .		tax_style(1)	/  'HR'/,
     .		tax_loint(1)	/    3	/,
     .		tax_hiint(1)	/    1	/
	DATA	tax_hours(2)	/  144.	/,	! 24 hour to 6 day long axis
     .		tax_style(2)	/ 'DAY'	/,
     .		tax_loint(2)	/    6	/,
     .		tax_hiint(2)	/    1	/
	DATA	tax_hours(3)	/  768.	/,	! 6 to 32 day long axis
     .		tax_style(3)	/ 'MON'	/,
     .		tax_loint(3)	/    1	/,
     .		tax_hiint(3)	/    1	/
	DATA	tax_hours(4)	/ 2880.	/,	! 32 day to 4 month long axis
     .		tax_style(4)	/ 'MON'	/,
     .		tax_loint(4)	/    5	/,
     .		tax_hiint(4)	/    1	/
	DATA	tax_hours(5)	/43200.	/,	! 4 month to 5 year long axis
     .		tax_style(5)	/  'YR'	/,
     .		tax_loint(5)	/    1	/,
     .		tax_hiint(5)	/    1	/
	DATA	tax_hours(6)	/84000./,	! 5 to 10 year long axis
     .		tax_style(6)	/  'YR'	/,
     .		tax_loint(6)	/    3	/,
     .		tax_hiint(6)	/    1	/
	DATA	tax_hours(7)	/144000./,	! 10 to 17 year long axis
     .		tax_style(7)	/  'YR'	/,
     .		tax_loint(7)	/    0	/,
     .		tax_hiint(7)	/    2	/
* ... eliminate small tics beyond here
	DATA	tax_hours(8)	/172800./,	! 17 to 20 year long axis
     .		tax_style(8)	/  'YR MULTIYR'	/,
     .		tax_loint(8)	/    0	/,
     .		tax_hiint(8)	/    2	/
	DATA	tax_hours(9)	/432000./,	! 20 to 50 year long axis
     .		tax_style(9)	/  'YR MULTIYR'	/,
     .		tax_loint(9)	/    0	/,
     .		tax_hiint(9)	/    5	/
	DATA	tax_hours(10)	/864000./,	! 50 to 100 year long axis
     .		tax_style(10)	/  'YR MULTIDC'	/,
     .		tax_loint(10)	/    0	/,
     .		tax_hiint(10)	/   10	/
	DATA	tax_hours(11)	/1728000.	/, ! 100 to 200 yr long axis
     .		tax_style(11)	/  'YR MULTIDC'	/,
     .		tax_loint(11)	/    0	/,
     .		tax_hiint(11)	/   20	/
	DATA	tax_hours(12)	/4320000.	/, ! 200 to 500 yr long axis
     .		tax_style(12)	/  'YR MULTIDC'	/,
     .		tax_loint(12)	/    0	/,
     .		tax_hiint(12)	/   50	/
	DATA	tax_hours(13)	/8640000.	/, ! 500 to 1000 yr long axis
     .		tax_style(13)	/  'YR MULTIDC'	/,
     .		tax_loint(13)	/    0	/,
     .		tax_hiint(13)	/   100	/
	DATA	tax_hours(14)	/17280000.	/, ! 1000 to 2000 yr long axis
     .		tax_style(14)	/  'YR MULTIDC'	/,
     .		tax_loint(14)	/    0	/,
     .		tax_hiint(14)	/   200	/
	DATA	tax_hours(15)	/43200000.	/, ! 2000 to 5000 yr long axis
     .		tax_style(15)	/  'YR MULTIDC'	/,
     .		tax_loint(15)	/    0	/,
     .		tax_hiint(15)	/   500	/
	DATA	tax_hours(16)	/    0.	/,    ! greater than 5000 yr long axis
     .		tax_style(16)	/  'YR MULTIDC'	/,
     .		tax_loint(16)	/    0	/,
     .		tax_hiint(16)	/   1000	/

* time axis orientation
	its_x = x_or_y .EQ. 'X'

* axis length
	IF ( its_x ) THEN
	   axlen = xlen
	ELSE
	   axlen = ylen
	ENDIF

*	
	ilen = TM_LENSTR(imposed_lab)

* regard axis as climatological if it starts in year 0000 or 0001 and
* extends less than 2 years
	climatology = lo_bc .LE. psecs_at_2_yrs
     .		.AND. (hi_bc-lo_bc).LT.psecs_at_2_yrs

* get axis length in hours from times since BC in seconds
	hrs = ( hi_bc - lo_bc ) / 3600.

* how many hours if the axis were 8 in length ?
	hrsper8 = 8./axlen * hrs

* select style based on axis length
	DO 500 itax = 1, pmax_tax
	   IF ( hrsper8 .LE. tax_hours( itax ) ) GOTO 510
 500	CONTINUE	         
	itax = pmax_tax


* TXTYPE and TXLINT commands (time axis style)
 510	tstyle_long = tax_style( itax )
	IF (hrs .LE. 36) tstyle_long = 'HR'
	IF (hrs .LE.  2) tstyle_long = 'MIN'
	tstyle = tstyle_long	! 3 character, only
	CALL PPLCMD ( from, line, 0, 'TXTYPE '//tstyle_long, 1, 1 )

* ---
* Define a symbol TXTYPE_SETTING
* if this symbol already exists then delete it
        buff30 = 'TXTYPE_SETTING'
	CALL GETSYM( buff30, buff, i2, i1 )
	IF ( i1 .EQ. 0 ) CALL DELSYM(buff30,i1)

* define the symbol
	slen = TM_LENSTR1(tstyle_long)
	CALL PUTSYM( buff30, tstyle_long, slen, i2)
* ---

* ... suppress year display on climatological axes
	hi_int = tax_hiint(itax)
	IF ( climatology ) THEN
	   IF ( tstyle(:2) .EQ. 'YR' ) hi_int = 0 ! suppress year axis label
	   tstyle = 'CLM'			  ! suppress "YEAR:" label
	ENDIF
	WRITE ( ppl_cmnd, 3030 ) tax_loint(itax), hi_int
 3030	FORMAT ('TXLINT',2I6)
	CALL PPLCMD ( from, line, 0, ppl_cmnd, 1, 1 )

* special "imposed" labels (used to disambiguate T and F axes)
	IF (ilen.GT.0 .AND. imposed_lab .NE. ' ') THEN
	   slen = TM_LENSTR1(imposed_lab)
	   IF ( its_x ) THEN
* ... lower left corner along the horizontal page edge
              CALL PUT_LABEL( ppl_movlab,
     .			      0.5-xorg, letsize_label-yorg,
     .                        ppl_left_just, letsize_label,
     .                        '@AS'//imposed_lab(:slen),
     .                        lab_loc_absolute, lab_loc_absolute )
	   ELSE
* ... lower left corner, rotated along the vertical page edge
              CALL PUT_LABEL( ppl_movlab,
     .			      2*letsize_label-xorg,0.5-yorg,
     .                        ppl_left_just, letsize_label,
     .                        '@AS'//imposed_lab(:slen),
     .                        lab_loc_absolute, lab_loc_absolute )

* ... rotate it
	      WRITE ( buff30, 3100 )	nlabs_on
 3100	      FORMAT ('RLABS ',I4, ',90')
	      CALL PPLCMD ( from, line, 0, buff30, 1, 1 )
	   ENDIF
	ENDIF

	RETURN
	END

	SUBROUTINE TM_CTOF_STRNG ( cstrng, fstrng, clen )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* convert a null-terminated Hollerith (suitable for passing to a c routine) to
* a FORTRAN-style character string 
* normally the c string should be at least 1 byte longer than the FORTRAN
*    string to accomodate the null terminator

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for DECstation computer under Ultrix operating system
*
* rev 0.0 -   5/6/91
*  Sun Port 1/30/92 -kob-  added ifdef sun because uses BYTE where DECstation uses
*                          INTEGER*1
*
* IBM PORT 14apr94 *kob* : IBM compiler fussy about argument types
*
* Linux port 10/96 *kob*: for some reason, cstrng was declared as a 
*			  type byte even if the machine was not a 
*			  sun...this is wrong and I changed it back
* calling arguments:
* cstrng - BYTE (INTEREG*1) string (passed by pointer)
* fstrng - CHARACTER string (passed by descriptor)
* clen   - length of passed Hollerith array

#ifdef unix
* calling argument declarations:
        INTEGER clen
        CHARACTER*(*) fstrng
#ifdef sun
        BYTE      cstrng(clen)
#else
	INTEGER*1 cstrng(clen)			!*kob* 10/96
c	BYTE      cstrng(clen)			
#endif

* internal variable declarations:
	INTEGER	i, flen
#ifdef AIX_XLF
	INTEGER one_char
#endif

* initialize
        flen = LEN(fstrng)
        fstrng = ' '

* copy from null-terminated Hollerith to CHARACTER
        DO 100 i = 1, MIN(clen, flen)
           IF ( cstrng(i) .EQ. 0 ) RETURN
#ifdef AIX_XLF
*use temp storage for IBM fussy IBM compiler
	one_char = cstrng(i)
 100	fstrng(i:i) = CHAR(one_char)
#else
 100    fstrng(i:i) = CHAR(cstrng(i))
#endif
	RETURN
#else
        STOP 'TM_FTOC_STRNG is for Unix systems, only'
#endif
	END

	SUBROUTINE CD_ENCODE_URL ( urlbuff, ebuff, status)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP 

* 
* V6.85 2/13 
* argument definitions:
*       urlbuff - url to encode
*       ebuff   - result enocded url
*	status	- return status

* argument declarations:
	INTEGER	      status
	CHARACTER*(*) urlbuff, ebuff

	INTEGER url_encode


        include 'netcdf.inc'
        include 'tmap_errors.parm'


        INTEGER   TM_LENSTR1, llen, slen
        PARAMETER (slen=2048)

#ifdef sun
        BYTE        fhol_url(slen)      ! c-type Hollerith string buffer
	BYTE      fhol_eurl(slen)
#else
	INTEGER*1 fhol_url(slen)      ! c-type Hollerith string buffer
	INTEGER*1 fhol_eurl(slen)
#endif

* Save dataset info in GLOBAL_NCdsetList for attribute handling

        llen = TM_LENSTR1( urlbuff )
        CALL TM_FTOC_STRNG( urlbuff(1:llen), fhol_url, slen )

        status = url_encode(fhol_url, fhol_eurl, llen)         
        IF (status .EQ. 0) THEN
           CALL TM_CTOF_STRNG (fhol_eurl, ebuff, llen) 
	   status = merr_ok
	ENDIF

* successful completion
	
	RETURN
	END

        PROGRAM DRWSYM
        CHARACTER FONT*2,NUM*6,STR*5,NAME*30,NME*30
	DIMENSION ILEN
	DATA ILEN/88/
	DATA FONT/'MK'/
	DATA NAME/'Plot Marks'/
        CALL PLTYPE(0)
        CALL SIZE(8.2,10.5)
        SZE=0.21
        CALL ERASE
C
C       DRAW BOX
C
        X=0.
        Y1=7.5
        Y2=0.
        DO 110 I=1,10
        CALL PLOT(X,Y1,0,0)
        CALL PLOT(X,Y2,1,0)
        X=X+0.75
        IF(Y1.EQ.0.)THEN
                Y2=Y1
                Y1=7.5
        ELSE
                Y2=Y1
                Y1=0.
        ENDIF
110     CONTINUE
        Y=7.5
        X1=0.
        X2=6.75
        DO 120 I=1,11
        CALL PLOT(X1,Y,0,0)
        CALL PLOT(X2,Y,1,0)
        Y=Y-0.75
        IF(X1.EQ.0.)THEN
                X2=X1
                X1=6.75
        ELSE
                X2=X1
                X1=0.
        ENDIF
120     CONTINUE
C
C       DRAW CHARACTERS
C
        WRITE(STR,999)FONT
999     FORMAT('@',A2)
        WRITE(NME,997)NAME
997     FORMAT('@SR',A25)
        CALL SYMBEL(0.,7.6,0.0,.14,28,NME)
	ICH=1
        DO 130 I=1,9
        DO 130 J=1,10
        X=(I-1)*0.75
        Y=7.5-J*0.75
        WRITE(NUM,998)ICH
998     FORMAT('@SR',I2.2)
        STR(4:5)=NUM(4:5)
        CALL SYMBEL(X+0.02,Y+0.65,0.,0.07,6,NUM)
        S=X+.375-SYMWID(SZE,5,STR)*0.5
        CALL SYMBEL(S,Y+0.270,0.,SZE,5,STR)
	ICH=ICH+1
	IF(ICH.GT.ILEN)GOTO 140
130     CONTINUE
140     CALL PLTEND
        CALL EXIT(0)
        END

	SUBROUTINE CONVOLVE_P_DSG (idim, hlen, wt, dset, nfeatures,
     .				com, com_mr, com_cx,
     .				res, res_mr, res_cx )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* convolve the component grid, com, with the weight function, wt
* along axis idim
* Since this is a DSG the convolution may be only along the 
* "orientation" axis (e.g. T on a Tseries collection) or the
* "instance" axis (always E)
* note: the use of WW constraints on a DSG expression, such as a time range
*       on  a time series collection may result in gaps created in the
*	individual features.  To avoid convolving across these gaps, the
*	observation-level constraints are ignored here. They will be still
*	be used as a mask during commands such as LIST
* also: when bad data points are encountered in the component data all
*	result data depending on it are flagged as bad, too

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V720 *sh* 5/2017 - based upon COPNVOLVE.F
* V76   1/20 *acm* Orientation of Point-type data set to e_dim

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include	'xdset_info.cmn_text'
	include 'xdyn_linemem.cmn_text'

* calling argument declarations:

	INTEGER	idim, hlen, dset, nfeatures, com_mr, com_cx, res_mr, res_cx
	REAL	wt(-hlen:hlen),
     .          com   ( m1lox:m1hix ),
     .          res   (*)

* internal variable declarations:
	LOGICAL fmask(nfeatures)
	INTEGER	i, ii, base, flen, ifeature, iobs,
     .		orientation, row_size_lm
	REAL	bad_com, bad_res, comp, sum, wsum

* initialize
	bad_com = mr_bad_data( res_mr )
	bad_res = mr_bad_data( com_mr )

* DSG-specific initialize
	orientation = dsg_orientation(dset)
	row_size_lm = dsg_loaded_lm(dsg_row_size_var(dset))

* get feature mask
        CALL MAKE_DSG_FEATURE_MASK(dset, res_cx, fmask, nfeatures)

* ****** PERFORM THE COMPUTATION *****

	IF (idim.EQ.orientation .AND. orientation.LE.t_dim) THEN 
* *** true ragged array processing:
* convolve independently along each feature
*     Work with all data in the feature. WW coordinate masking etc  
*     will be applied beforelisting or plotting

           base = 0    ! obs index at end of preceding feature
* ... loop over the features
	   DO ifeature = 1, nfeatures 

	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length

* ... have the user's constraints removed this feature?
	      IF (.NOT.fmask(ifeature)) THEN
                 base = base + flen
                 CYCLE
              ENDIF

* ... loop over the observations within each feature
              iobs = base
	      DO i = 1, flen
	         iobs = iobs + 1
		 res(iobs) = bad_res

* ... convolve the neighboring points with the weights
	         sum = 0.0
		 wsum = 0.0
	         DO ii = -hlen, hlen

* ... test limits of component data before using
                    IF ( i+ii .GE. 1
     .             .AND. i+ii .LE. flen ) THEN
                       comp = com(iobs+ii)
                    ELSE
	               CYCLE
                    ENDIF

	            IF ( comp .NE. bad_com ) THEN
	               sum = sum + comp*wt(ii)
	               wsum = wsum + wt(ii)
	            ENDIF
	         ENDDO
	         IF (wsum .GT. 0) THEN
	            res(iobs) = sum/wsum
	         ELSE
	            res(iobs) = bad_res
	         ENDIF
	      ENDDO
	      base = base + flen
           ENDDO

	ELSE

* *** a simple list of instances:
* IT IS NOT CLEAR THAT A USE CASE EXISTS for convolving along the instance
* (feature) axis of a DSG.  But we allow it anyway.
* Process all features -- ignoring mask -- for the reasons stated in the intro
	   DO i = 1, nfeatures 
	      sum = 0.0
	      wsum = 0.0
	      res(i) = bad_res

	      DO ii = -hlen, hlen
* ... test limits of component data before using
                 IF ( i+ii .GE. 1
     .          .AND. i+ii .LE. nfeatures ) THEN
                    comp = com(i+ii)
                 ELSE
                    CYCLE
                 ENDIF

	         IF (  comp.NE.bad_com .AND.comp.NE.dsg_masked_out_flag ) THEN
	            sum = sum + comp* wt(ii)
	         ENDIF
	      ENDDO
	      IF (wsum .GT. 0) THEN
	         res(i) = sum/wsum
	      ELSE
	         res(i) = bad_res
	      ENDIF
	   ENDDO
	ENDIF

	RETURN
	END

	SUBROUTINE INIT_T_AGG_MC_DSET
     .		(dset_num, nagfiles, memb_order, memb_filename,
     .		 memb_tstep_start, memb_tstep_end, memb_nstep,
     .		 use_strict, status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*
* Initialize a multifile netCDF ("MC") T-aggregated dataset
*    - information equivalent to reading stepfile information from descriptor
*      file is passed in through the argument list
*    - call cd_init_dset on first file of data set to set up all 
*      common information for the dataset, such as variables, etc
*    - assemble the T-aggregate dataset and associate this
*      time axis with the parent grids
*
* V695+ *sh* 10/15 - new, hack-built from MC_INIT_DSET
* V698 *sh*   2/16 - member files may be disordered

* arguments:
*	dset_num	- number assigned to this data set (input)
*	nagfiles	- number of files in the aggregation (input)
*	memb_order	- sequence ordering of member (input)
*	memb_filename	- array of filenames (input)
*	memb_tstep_start- array of first timestep in each file (input)
*	memb_tstep_end	- array of last  timestep in each file (input)
*	memb_nstep	- array of N timesteps in each file (input)
*	use_strict	- (not impl.) flag for coord micro-adjustment (input)
*	status		- return status (output)

* Argument definitions
	LOGICAL		use_strict
	INTEGER		nagfiles, dset_num, status
	INTEGER		memb_nstep(nagfiles), memb_order(nagfiles)
	REAL		memb_tstep_start(nagfiles), memb_tstep_end(nagfiles)
	CHARACTER*512	memb_filename(nagfiles)

* Parameter and common files

	include 'tmap_errors.parm'		! error codes
#include "tmap_dset.parm"	
	include 'tmap_dims.parm'		! data set dimensions
!#include "gt_lib.parm"
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xio.cmn_text'
        external xio_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xdset_info.cmn_text'		! data set common
	external xdset_info_data
	include 'xstep_files.cmn_text'		! step file common
	external xstep_files_data
	include 'xdset_info.cd_equiv'		! has mc_init_stepfile

* Define variables from Set File namelist records

	include 'descript.def'


* Internal declarations

	CHARACTER*13	TM_STRING
	INTEGER		ivar, stp_pos,
     .			istep, i, nrecperstep, epos, first_file,
     .			stp_cnt, min_pos, max_pos,istat,
     .			lline, file_reclen, preceding_steps
	REAL*8		file_trange, steps_in_file

* simulate reading of step records - one per file to be aggregated
	istep = 0

* Initialize some STEPFILE variables
	s_aux_set_num = 0       ! irrelevant?
	s_regvarflag  = ' '     ! irrelevant
	s_index       = ' '	! irrelevant
	file_reclen = unspecified_int4  ! irrelevant?
	s_delta	      = 0	! used to determine if regular time steps
        preceding_steps = 0

* * * * * * top of stepfile loop * * * * *
	DO i = 1, nagfiles
	  istep = memb_order(i)

* calculate time range per file and check for even number per file
	  file_trange = memb_tstep_end(istep)-memb_tstep_start(istep)
	  steps_in_file = memb_nstep(istep)
	  s_delta = file_trange / steps_in_file

* Find the next storage position for stepfiles in common
	  IF (i .EQ. 1) THEN
* ... stepfile of first file in member list was assigned during netCDF init
	     DO stp_cnt = 1,maxstepfiles
	       IF (sf_setnum(stp_cnt) .EQ. dset_num) GOTO 100
	     ENDDO
	     GOTO 5100     ! should never happen
	  ELSE  
	     DO stp_cnt = stp_pos,maxstepfiles
	       IF (sf_setnum(stp_cnt) .EQ. set_not_open) GOTO 100
	     ENDDO
* No room left for new stepfiles
	     CALL TM_ERRMSG ( merr_filim, status, 'MC_AGG_INIT',
     .			   dset_num, no_stepfile,
     .			   'MAX='//TM_STRING(DBLE(maxstepfiles)),
     .			   no_errstring, *9900)
	   ENDIF

* store values in common
 100	  sf_setnum(stp_cnt) = dset_num
	  sf_name  (stp_cnt) = memb_filename(istep)
	  sf_1step (stp_cnt) = memb_tstep_start(istep)
	  sf_lastep(stp_cnt) = memb_tstep_end(istep)
* sf_ndxs and sf_ndxe contain the L limits for each file on the agg T axis
	  sf_ndxs  (stp_cnt) = preceding_steps + 1
	  sf_ndxe  (stp_cnt) = preceding_steps + steps_in_file
          preceding_steps = sf_ndxe(stp_cnt)
	  sf_delta(stp_cnt) = s_delta
!	  sf_aux_set_num(stp_cnt) = s_aux_set_num
	  sf_lunit(stp_cnt) = file_not_open
	  sf_index(stp_cnt) = s_index
	  sf_reclen(stp_cnt) = file_reclen !???uninited var in MC_INIT_DSET
	  IF (s_regvarflag .EQ. ' ') sf_regvars(stp_cnt) = .TRUE.
!	  IF (last_delta .EQ. -999.) last_delta = s_delta  ! relevant?
	  IF (s_delta .NE. 0) THEN
	    sf_regtimes(stp_cnt) = .TRUE.		   ! relevant?
	  ELSE
	    sf_regtimes(stp_cnt) = .FALSE.
	  ENDIF

* time-independent fields are read from the first file in the member list
	  IF (i .EQ. 1) mc_init_stepfile(dset_num) = stp_cnt

* prepare for next file
	  stp_pos = stp_cnt+1

	ENDDO  
* * * * end of stepfile loop * * * * *


* summarize certain stepfile info at the dataset level
	ds_1step(dset_num)  = memb_tstep_start(memb_order(1))
	ds_lastep(dset_num) = memb_tstep_end(memb_order(nagfiles))
	IF (ds_regsteps(dset_num)) THEN
	  ds_delstep(dset_num)  = line_delta(ds_time_axis(dset_num))
	ELSE
	  ds_delstep(dset_num) = 0.
	ENDIF
	status = merr_ok

	RETURN


* errors
 9900	status = ferr_TMAP_error
 5000	RETURN
 5100	CALL ERRMSG( ferr_internal, status, 'init_t_agg_mc_dset', *5000)
	END

	INTEGER FUNCTION REGION_CLASS( idim, cx )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine the region-limits class of a component in an expression
* the region-limits class encodes how limits must be specified in order to
* match with memory-resident data.  (It is uvar_given without the 
* "need"/"given" information.)

* note: the classes that exist as of FERRET 2.00 are complete
*	class 3 ("xact") assumes that any time both upper and lower limits must 
*	match then this must be a compressing transformation.  There should
*	really be a class "xact" to insist on exact match, uncompressed and a
*	class "pt" that compresses as well.  This would require updating the
*	tables in NEST_REGION_CLASS and MERGE_GRID.

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  7/18/89
* V230:  1/27/92 - changed uvlim_*_hi (unused) to uvlim_*_lohi to describe
*                  @WEQ - exaxt limits required but a range of data
*                - also added @RSUM (like @IIN)
* V533: *sh* 6/01 - added trans_event_mask
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V692 7/14 *acm* ticket 2183: handle @WGT transform as for integrals

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include	'xcontext.cmn'

* calling argument declarations
	INTEGER	idim, cx

	IF ( cx_trans( idim, cx ) .GT. trans_compress_code ) THEN
	   REGION_CLASS = 3    ! uvlim_*_xact
	ELSEIF ( cx_trans( idim,cx ) .EQ. trans_integ_indef
     .      .OR. cx_trans( idim,cx ) .EQ. trans_run_sum
     .      .OR. cx_trans( idim,cx ) .EQ. trans_avg_wgt
     .      .OR. cx_trans( idim,cx ) .EQ. trans_4d_avg_wgt
     .      .OR. cx_trans( idim,cx ) .EQ. trans_event_mask ) THEN
	   REGION_CLASS = 1    ! uvlim_*_lo
	ELSEIF ( cx_trans( idim,cx ) .EQ. trans_wgted_eq ) THEN
           REGION_CLASS = 2    ! uvlim_*_lohi
	ELSEIF ( cx_given( idim, cx )
     .	   .AND. cx_lo_ss(cx,idim) .EQ. cx_hi_ss(cx,idim) ) THEN
* ... e.g. U[K=3] ... defines a fixed point
	   REGION_CLASS = 3
	ELSE
	   REGION_CLASS = 0  
	ENDIF

	RETURN
	END

*
* tax_times.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* axis_reduction     Are the result axes 'reduced' with respect to the 
*                    argument axes from which they are inherited?
*                       ( RETAINED, REDUCED ) 
*                       RETAINED        - result axis has same extent as argument axis
*                       REDUCED         - result axis is reduced to a point
*                >>> The axis_reduction defaults to RETAINED and only needs
*                >>> to be applied when the result is reduced to a point but
*                >>> SET REGION information should still be applied to the
*                >>> external function arguments. (e.g. a function returning a status flag)
*                >>> In such a case the result axes should be IMPLIED_BY_ARGS
*                >>> and REDUCED.  (as opposed to NORMAL and RETAINED)
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument''s axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE tax_times_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     .        'returns percent good (x,y,z) data at each (t,e,f) step')
      CALL ef_set_num_args(id, 1)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_axis_reduction_6d(id, REDUCED,  REDUCED,  REDUCED,
     .                                  RETAINED, RETAINED, RETAINED)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'data to be checked')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE tax_times_compute(id, arg_1, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER good, total
      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*
* Note that we are looping on the argument subscripts rather than
* the result subscripts. (Looping on result subscripts is the normal 
* way).  That is because the result has axes which are normal and the
* loop count on those normal axes will be one.
*
      n = res_lo_ss(F_AXIS)
      DO 600 n1 = arg_lo_ss(F_AXIS,ARG1), arg_hi_ss(F_AXIS,ARG1)
 
      m = res_lo_ss(T_AXIS)
      DO 500 m1 = arg_lo_ss(E_AXIS,ARG1), arg_hi_ss(E_AXIS,ARG1)
 
      l = res_lo_ss(T_AXIS)
      DO 400 l1 = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)
 
         good = 0
         total = 0

         DO 300 k1 = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)
         DO 200 j1 = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)
         DO 100 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)
 
            IF ( arg_1(i1,j1,k1,l1,m1,n1) .NE. bad_flag(ARG1) ) THEN
               good = good + 1
            ENDIF
            total = total + 1
 
 100     CONTINUE
 200     CONTINUE
 300     CONTINUE
 
         i = res_lo_ss(X_AXIS)
         j = res_lo_ss(Y_AXIS)
         k = res_lo_ss(Z_AXIS)
         IF ( total .GT. 0. ) THEN
            result(i,j,k,l,m,n) = (good * 100.0) / total
         ELSE
            result(i,j,k,l,m,n) = bad_flag_result
         ENDIF

         l = l + res_incr(T_AXIS)
 400  CONTINUE

         m = m + res_incr(E_AXIS)
 500  CONTINUE

         n = n + res_incr(F_AXIS)
 600  CONTINUE

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

	SUBROUTINE CHECK_NEG_TAXIS( dset )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* check to make sure that the time axis of the data set doesn't have any
* negative time step values

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  6/11/90
* Unix/RISC port:  07/91 - allow normal time axis
*                  10/91 - briefer warning
* V230 - simplified (less intimidating) message
*      7/20/92 - don't issue warning unless T0 is valid
*              - (cleaned up unused variables)
* V530  1/01 *acm* cal_id for alternative calendar axis types
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

* calling argument declarations:
	INTEGER	dset

* internal variable declarations:
        LOGICAL TM_DATE_OK
	INTEGER	i, grid, line
        INTEGER TM_GET_CALENDAR_ID, cal_id
	DOUBLE PRECISION TM_WORLD

	include 'ferret.parm'
	include 'tmap_dims.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data

* base it on first variable in data set
	DO 100 i = 1, maxvars
 100	IF ( ds_var_setnum(i) .EQ. dset ) GOTO 110
	RETURN	! no vars in set

* check lowest time step value on axis
 110	grid = ds_grid_number(i)
        line = grid_line(t_dim, grid )

* allow time-independent grids (7/91)
        IF ( line .EQ. mnormal ) RETURN

* no warning for non-date axes - this way time can be a regular ol' axis

        cal_id = TM_GET_CALENDAR_ID (line_cal_name(line) )
        IF ( .NOT.TM_DATE_OK( line_t0(line), cal_id) ) RETURN

	IF ( TM_WORLD(1,grid,t_dim,box_middle) .LT. 0.0D0 ) THEN
	   CALL WARN('Negative values in time axis'//
     .               ' may not be formatted properly: '//
     .		     ds_name(dset) )

	ELSEIF ( TM_WORLD(1,grid,t_dim,box_lo_lim) .LT. 0.0D0 ) THEN
	   CALL WARN('Negative values at start of time axis'//
     .               ' may be improperly formatted: '//
     .		     ds_name(dset) )
	ENDIF

	RETURN
	END

	CHARACTER*(*) FUNCTION TM_CLEAN_FILENAME ( pathname )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* remove the directory path and the extension from a full pathname leaving
* only the filename

*  written 6/92 by S.H. for PMEL/TMAP
* 5/93 - *sh* modified so endings other than .cdf and .des are returned
* v5.32 *kob* - CYGWIN Prob - when running under Win32/Cygwin, have to
*  3/01         to check to see if file from which a clean filename is
*               being extracted is a DODS file.  If it is, we have to use
*               the "typical" unix path separator of "/" rather than the
*               CYGWIN path separator of "\".  Otherwise we don't get a 
*               clean filename extracted from the dataset.  This will 
*               cause problems in find_dset_number and find_dset_name
* 2/03 - *acm*  clean off .nc as well as .cdf and .des
*               Note this may change the names of dynamic grids, which are
*               generated from dataset names

#include "gt_lib.parm"

* argument
	CHARACTER*(*) pathname

* local variable
        INTEGER idot, islash, plen
* *kob* 3/01 Insert Cygwin specific variables
#ifdef __CYGWIN__
	CHARACTER DODSPathSeparator
	LOGICAL DODS_file
	PARAMETER (DODSPathSeparator='/')
	DATA DODS_file  / .FALSE. /
#endif

* initialize
        plen = LEN( pathname )

* locate the last dot in the name
        DO 100 idot = plen, 1, -1
 100    IF ( pathname(idot:idot) .EQ. '.' ) GOTO 190
        idot = plen + 1    ! no dot
 190    idot = idot - 1

* 5/93 other than .des or .cdf should not be cleaned off 
	IF ( plen-idot .EQ. 4 ) THEN
	   IF (   pathname(idot+1:plen) .NE. '.cdf'
     .      .AND. pathname(idot+1:plen) .NE. '.des' ) idot = plen
	ELSEIF ( plen-idot .EQ. 3 ) THEN
	   IF (   pathname(idot+1:plen) .NE. '.nc' ) idot = plen
	ELSE
	   idot = plen
	ENDIF

* locate the last slash in the name
* *kob* 3/01 - if under cygwin, have to check if the file is a DODS
*              file - if so, use proper path separator
#ifdef __CYGWIN__
	DODS_file = INDEX(pathname,'://') .GT. 0
        DO 200 islash = plen, 1, -1
 	   IF (DODS_file) THEN
	      IF ( pathname(islash:islash) .EQ. DODSPathSeparator ) GOTO 290
	   ELSE
	      IF ( pathname(islash:islash) .EQ. PathSeparator ) GOTO 290
 200	   ENDIF
	   islash = 0		! no slash
 290	   islash = islash + 1
#else   
        DO 200 islash = plen, 1, -1
 200    IF ( pathname(islash:islash) .EQ. PathSeparator ) GOTO 290
        islash = 0    ! no slash
 290    islash = islash + 1
#endif
* check for pathological name
        IF ( islash .GT. idot ) idot = plen
	
        TM_CLEAN_FILENAME = pathname(islash:idot)

	RETURN
	END

      FUNCTION NPBT(MTIME2,MTIME1,NMBP,JFLAG)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)npbt5.f	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C         NPBT RETURNS THE NUMBER OF DATA POINTS BETWEEN TWO
C         MILITARY TIMES, GIVEN THE SAMPLING RATE IN MINUTES.
C
C         MTIME2: THE LATER OF THE TWO TIMES.
C         MTIME1: THE EARLIER OF THE TWO TIMES.
C         NMBP:   THE NUMBER OF MINUTES BETWEEN POINTS(SAMPLING RATE).
C         JFLAG:  0: COMPUTE THE NUMBER OF WHOLE SAMPLE INTERVALS
C                 BETWEEN THE TIMES.
C                 1: COMPUTE THE NUMBER OF WHOLE SAMPLE INTERVALS
C                 THAT INCLUDES THE TIMES.

C
	REAL MTIME1(3),MTIME2(3)
	INTEGER*4 MTMIN,MNDF
      MNDF=MTMIN(MTIME2)-MTMIN(MTIME1)
      NPBT=MNDF/NMBP
      IF(JFLAG.EQ.1) NPBT=NPBT+1
      RETURN
      END

	CHARACTER*(*) FUNCTION CD_AXIS_OUTNAME ( dset, grid, idim, nlen )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine the netCDF name to use for writing the indicated axis of this grid

* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 11/06
* V62   2/09 *acm* When writing user-defined variables and when MODE UPCASE_OUTPUT is
*                  cancelled, get the original upper/lowercase spelling of the axis name.
* V63   9/09 *acm* Fixing bug 1686: if line_name_orig is not set, use line_name
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files
* V6.85+ 12/13*acm* catch up to 6-D Ferret
* V710 9/16 *acm* Use ww_dim_name from xtext_info.cmn
* v751 *acm*  6/19 Allow for longer strings as attribute values (line_name is length 64)


* argument definitions:
*     dset    - dset (if netcdf file, for getting name and attribute 
*               info from linked-list structure  
*     grid    - TMAP grid id
*     idim    - axis orientation (1-nferdims)
*     nlen    - length of name

* include files
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
        include 'netcdf.inc'
	include 'xtext_info.cmn'  ! with ww_dim_name

* argument declarations
      INTEGER dset, grid, idim, nlen

* local variable declarations:
      LOGICAL TM_ABSTRACT_AXIS, NC_GET_ATTRIB, coordvar, got_it
      INTEGER TM_LENSTR1, STR_SAME, iaxis, varid, nvatts, status, 
     .  attlen, maxlen, attoutflag, alen
      REAL val

      CHARACTER varname*130, buff*64, attname*128

* initialize
      iaxis = grid_line(idim, grid)
      buff = ' '

* basic name straight from the grid

      varname = line_name(iaxis)
      nlen = TM_LENSTR1( varname )

* Get information, if it exists, from linked-list structure, including
* original upper/lowercase form of axis name. Also restore the original
* name if the axis name was changed on inupt. (If name matched an existing 
* line name, then Ferret has changed the name for uniqueness.)

* Do not try to get the axis name if its in parentheses. These names are
* dynamic axis names.

      status = merr_ok + 1
      IF (varname(1:1) .NE. '(') 
     .   CALL CD_GET_VAR_ID (dset, varname, varid, status)  
     
      got_it = .FALSE.
      IF (status.EQ.merr_ok .AND. varid.GT.0) THEN
         attname = 'orig_file_axname' 
         alen = 18

         maxlen = 64
         got_it = NC_GET_ATTRIB(dset, varid, attname(1:alen),
     .                       .FALSE., varname(1:nlen), maxlen, attlen, 
     .                       attoutflag, buff, val)

         IF ( got_it ) THEN
            CD_AXIS_OUTNAME = buff
            nlen = TM_LENSTR1( buff )
         ELSE 
            CD_AXIS_OUTNAME = line_name_orig(iaxis)
	    IF (STR_SAME(line_name_orig(iaxis), char_init) .EQ. 0) 
     .        CD_AXIS_OUTNAME = line_name(iaxis)
            nlen = TM_LENSTR1( CD_AXIS_OUTNAME )
	    IF (nlen .LE. 1  .OR.  varname(1:1) .EQ. '(' ) THEN
               CD_AXIS_OUTNAME = varname
	       nlen = TM_LENSTR1( CD_AXIS_OUTNAME )
	    ENDIF
         ENDIF

      ELSE

         CD_AXIS_OUTNAME = line_name_orig(iaxis)
         IF (STR_SAME(line_name_orig(iaxis), char_init) .EQ. 0) 
     .        CD_AXIS_OUTNAME = line_name(iaxis)
         nlen = TM_LENSTR1( CD_AXIS_OUTNAME )
	 IF (nlen .LE. 1  .OR.  varname(1:1) .EQ. '(' ) THEN
            CD_AXIS_OUTNAME = varname
	    nlen = TM_LENSTR1( CD_AXIS_OUTNAME )
	 ENDIF

      ENDIF

* if it's an abstract axis make a special name
      IF ( TM_ABSTRACT_AXIS( iaxis ) ) THEN
         CD_AXIS_OUTNAME = ww_dim_name(idim)//'AX'
         nlen = 3

* if it's a dynamic axis and if we didnt recover the 
* original name from the linked-list information,
* remove the parentheses

      ELSEIF ( line_name(iaxis)(1:1) .EQ. '(' .AND.
     .         .NOT.got_it ) THEN
	 IF ( nlen .LE. 2) nlen = 3			! should never happen
         CD_AXIS_OUTNAME = line_name(iaxis)(2:nlen-1)
	 nlen = nlen - 2
      ENDIF

      nlen = TM_LENSTR1( CD_AXIS_OUTNAME )

      RETURN
      END

	SUBROUTINE IS_RECONCILE(  *, *, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* reconcile any conflicts between the component requested and the one received
* for example, LIST/I=3:7  test[i=2:5]

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V420: 11/95
* V500 *kob* 3/99- up VAR_CODE  to 64 chars 
* V552 *acm* 4/03- up VAR_CODE  to 128 chars 
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'
	include	'xtext_info.cmn'

* calling argument declarations:
	INTEGER	status
* normal return is for error conditions
* exit #1 is to request another grid ( stack has been pushed )
* exit #2 is to signal completion of the activity at this stack level

*   ... interpretation stack setup at the time this is called ...
*	stack level		stack contents
*	isp+1	<--	level of last activity ( component just computed )
*	 isp	<--	current stack level (for moduloing )

* internal variable declarations:
	LOGICAL	by_ss(nferdims), given(nferdims)
	INTEGER i, mr, com_cx, res_cx,	com_isp, res_isp,
     .		com_lo, com_hi, res_lo(nferdims), res_hi(nferdims)
	CHARACTER VAR_CODE*128, qual*1

* --- end of introductory code ---

* initialize
	res_isp    = isp		! result (what the user requested)
	com_isp    = isp + 1		! component (what we have received)
	res_cx     = is_cx( res_isp )
	com_cx     = is_cx( com_isp )
	mr	   = is_mr( com_isp )

* defaults
	is_mr( res_isp ) = mr
	is_cx( res_isp ) = res_cx

* save the key ingredients from the requesting context (res_cx)
* (FLESH_OUT_AXIS has already been applied so world coords need not be used)
	DO 10 i = 1, nferdims
	   res_lo(i) =  cx_lo_ss(res_cx,i)
	   res_hi(i) =  cx_hi_ss(res_cx,i)
	   by_ss(i)  =  cx_by_ss(i,res_cx)
	   given(i)  =  cx_given(i,res_cx)
 10	CONTINUE

* transfer the full context (which includes data set, etc.)
	CALL TRANSFER_CONTEXT( com_cx, res_cx )

* check each axis for possible reconciliation
	DO 100 i = 1, nferdims
	   IF ( given(i) ) THEN
	      com_lo = cx_lo_ss(com_cx,i)
	      com_hi = cx_hi_ss(com_cx,i)
	      IF ( com_lo    .EQ. unspecified_int4
     .	      .OR. res_lo(i) .EQ. unspecified_int4 ) GOTO 100
	      IF (res_lo(i).NE.com_lo .OR. res_hi(i).NE.com_hi) THEN

* unreconcilable limits
	         IF (res_lo(i).GT.com_hi .OR. res_hi(i).LT.com_lo) THEN
	            IF ( by_ss(i) ) THEN
	               qual = ss_dim_name(i) 
	            ELSE
	               qual = ww_dim_name(i) 
	            ENDIF
	            CALL WARN('Invalid '//qual//
     .			' axis limits ignored: '//
     .			 VAR_CODE(cx_category(res_cx),cx_variable(res_cx)) )

	         ELSE
* diagnostic mode output: " doing reconcile VAR_NAME[x=lo:hi,D=#]"
	            IF ( mode_diagnostic ) 	CALL DIAG_OP
     .				( 'doing',isact_class_reconcile, com_cx, i )

* trim to limits that satisfy both component and result
	            cx_lo_ss(res_cx,i) = MAX(com_lo, res_lo(i))
	            cx_hi_ss(res_cx,i) = MIN(com_hi, res_hi(i))
	            cx_by_ss(i, res_cx) = .TRUE.
	            CALL FLESH_OUT_AXIS(i, res_cx, status )
	            IF ( status .NE. ferr_ok ) GOTO 5000
	         ENDIF
	      ENDIF
	   ENDIF
 100	CONTINUE

* success -- clean up
	cx_stack_ptr = cx_stack_ptr - 1 ! pop com_cx  from context stack
	CALL MR_NOT_IN_USE( mr )	! remove memory protection on component
	RETURN 2

* error exits
 5000	CALL MR_NOT_IN_USE( mr )	! remove memory protection on component
	RETURN
	END	

*  piecewise1.F
* 
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* Ansley Manke June 2013
* implements stl2, Piecewise linear approximations of fewest line segments
* described in http://www.computer.org/csdl/proceedings/afips/1972/5079/00/50790187.pdf
* and a somewhat later version of the code, found at
* http://www.netlib.org/toms/510
*
*
*  In this subroutine we provide information about
*  the function.  The user configurable information 
*  consists of the following:
* 
*  descr              Text description of the function
* 
*  num_args           Required number of arguments
* 
*  axis_inheritance   Type of axis for the result
*                        ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                        CUSTOM          - user defined axis
*                        IMPLIED_BY_ARGS - same axis as the incoming argument
*                        NORMAL          - the result is normal to this axis
*                        ABSTRACT        - an axis which only has index values
* 
*  piecemeal_ok       For memory optimization:
*                        axes where calculation may be performed piecemeal
*                        ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE piecewise1_init(id)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     . 'Return indices to sample from piecewise linear interpolation of 1 var' )

      CALL ef_set_num_args(id, 3) 
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, ABSTRACT, NORMAL, 
     .                                              NORMAL,   NORMAL)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 4)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'V1')
      CALL ef_set_arg_desc(id, arg, 'variable to sample')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'Control parameter')
      CALL ef_set_arg_desc(id, arg,
     .          'Control parameter (e.g. 6 for ntol=rest=cont=1)')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'Tol1')
      CALL ef_set_arg_desc(id, arg, 'Tolerance for V1')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)


*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE piecewise1_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER my_hi_i
      INTEGER arg_lo_ss(4,EF_MAX_ARGS),
     .        arg_hi_ss(4,EF_MAX_ARGS),
     .        arg_incr (4,EF_MAX_ARGS)

*
*     Use utility functions to get context information about the arguments.
*

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      my_hi_i = arg_hi_ss(X_AXIS,1) - arg_lo_ss(X_AXIS,1) + 1

      CALL ef_set_axis_limits(id, X_AXIS, 1, my_hi_i)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

      
*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE piecewise1_work_size(id)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
* 
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims(id, array #,
*                           xlo, ylo, zlo, tlo, 
*                           xhi, yhi, zhi, thi)
*

      INTEGER arg_lo_ss(4,EF_MAX_ARGS),
     .        arg_hi_ss(4,EF_MAX_ARGS),
     .        arg_incr (4,EF_MAX_ARGS)
      INTEGER npts, iwork

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      npts = 1 + arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1)
  
* input x-axis coordinates
      iwork = 1
      CALL ef_set_work_array_dims(id, iwork,
     .                                1, 1, 1, 1,
     .                             npts, 1, 1, 1)

* internal computation, u1 for y1
      iwork = 2
      CALL ef_set_work_array_dims(id, iwork,
     .                                1, 1, 1, 1,
     .                             npts, 1, 1, 1)

* internal computation, v
      iwork = 3
      CALL ef_set_work_array_dims(id, iwork,
     .                                1, 1, 1, 1,
     .                           2*npts, 1, 1, 1)

* internal computation, w
      iwork = 4
      CALL ef_set_work_array_dims(id, iwork,
     .                                1, 1, 1, 1,
     .                           2*npts, 1, 1, 1)
*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*  In this subroutine we compute the result
* 
      SUBROUTINE piecewise1_compute(id, arg_1, arg_2, arg_3, 
     .         result, xpts, u1, v, w)

      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit)

* Ignore the Y/Z/T/E/F dimensions in the work array since
* they are not used and Fortran is column major

      REAL xpts(wrk1lox:wrk1hix)

      REAL u1(wrk2lox:wrk2hix)
      REAL  v(wrk3lox:wrk3hix)
      REAL  w(wrk4lox:wrk4hix)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4),
     .        res_hi_ss(4),
     .        res_incr (4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS),
     .        arg_hi_ss(4,EF_MAX_ARGS),
     .        arg_incr (4,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i,  k
      INTEGER nx, nout1, ip
      REAL val, tol, bad_y
      CHARACTER*100 errtxt

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* Control parameter IP

      CALL ef_get_one_val(id, ARG2, val)
      IP = INT(val)

* Tolerances

      CALL ef_get_one_val(id, ARG3, tol)

*  Set x coordinate - abstract axis.

      nx = arg_hi_ss(X_AXIS, ARG1) - arg_lo_ss(X_AXIS, ARG1) + 1
      DO 50 i = 1, nx
         xpts(i) = i
  50  CONTINUE

      k = res_lo_ss(Z_AXIS)  ! index for unused dimensions

* STL2 modified to truncate result to next lowest integer

      bad_y = bad_flag(ARG1)
      CALL STL2(xpts, arg_1, tol, nx, bad_y, bad_flag_result, 
     .   result, v, w, nout1, IP)
      IF (nout1 .GT. res_hi_ss(X_AXIS)) THEN
        write (errtxt,*) 'call to STL2 returns too many data', nout1
	 GOTO 999
      ENDIF

      DO 100 i = nout1+1, res_hi_ss(X_AXIS)
        result(i,k,k,k) = bad_flag_result
 100  CONTINUE

      RETURN
 999  CALL EF_BAIL_OUT(id, errtxt)
      RETURN

      END

	INTEGER FUNCTION ATOM_POS ( string, atom )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* find the position of the atom within the string
* if the atom is the last character in the string this represents an error

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 10/23/86
* revision 0.1 - 3/23/88  - bypass embedded quotated strings during search
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
* 2/15 *sh* add support for _DQ_
*	    now ATOM_POS cannot be used to search for "_" unless modified

        IMPLICIT NONE
	include 'ferret.parm'

* calling argument declarations:
	CHARACTER*(*)	string
	CHARACTER*1	atom

* internal variable declarations:
	INTEGER		pos, slen, i

* initialize
	slen = LEN( string )
	pos  = 1

* loop top
 100	CONTINUE

* quotated string ?
	IF ( string(pos:pos) .EQ. '"' ) THEN
	   DO 110 pos = pos+1, slen
	      IF ( string(pos:pos) .EQ. '"' ) GOTO 200
 110	   CONTINUE
* ... unclosed quotation mark - flag it as a syntax error
	   ATOM_POS = atom_illegal_pos
	   RETURN

* _DQ_ -quotated string ?
	ELSEIF ( string(pos:pos) .EQ. '_' 
     .	  .AND. pos+3 .LE. slen      ) THEN
	   IF ( string(pos:pos+3) .EQ. '_DQ_' ) THEN
	      DO i = pos+4, slen-3
	         IF ( string(i:i+3) .EQ. '_DQ_' ) THEN
	            pos = i + 3
	            GOTO 200
	         ENDIF
	      ENDDO
	   ELSE
	      GOTO 200  ! as-is this routine cannot be used to search for "_"
	   ENDIF
* ... unclosed quotation mark - flag it as a syntax error
	   ATOM_POS = atom_illegal_pos
	   RETURN

* found it ?
	ELSEIF ( string(pos:pos) .EQ. atom ) THEN
	   IF ( pos .EQ. slen ) THEN
	      ATOM_POS = atom_illegal_pos
	   ELSE
	      ATOM_POS = pos
	   ENDIF
	   RETURN
	ENDIF

* keep on looking ?
 200	IF ( pos .LT. slen ) THEN
	   pos = pos + 1
	   GOTO 100
	ENDIF

* no joy
	ATOM_POS = atom_not_found
	RETURN
	END

	SUBROUTINE CD_NF_GET_VAR_GRID ( dset, vname, gridlines, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Just do an nf_get_varid for a variable that has been defined with LET/REMOTE.
* Call this after the dataset has been redefined with the encoded variable
* definitions.
*
* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Thermal Modeling and Analysis Program
* 2/2013  Ferret v6.85
*
* arguments:
*	dset	- data set number 

        include 'netcdf.inc'
        include 'tmap_errors.parm'
	include 'tmap_dims.parm'
	include 'xstep_files.cmn_text'
	external xstep_files_data
        include 'xtm_grid.cmn_text'


* Argument variable declarations
	INTEGER   dset, gridlines(*), status
	CHARACTER*(*) vname

* Local variable declarations
	INTEGER STR_SAME, TM_LENSTR1, 
     .		cdfid, varid, ndims, dimids(nferdims),
     .		idim, igrid, dimlen, outgrid(nferdims), slen
	CHARACTER*500 buff, errbuff

	cdfid = sf_lunit(dset)

#ifdef usingDODSf2cUnderscore 
	status = NF_INQ_VARID_(cdfid, vname, varid) 
	status = NF_INQ_VARNDIMS_(cdfid, varid, ndims) 
	status = NF_INQ_VARDIMID _(cdfid, varid, dimids) 
#else
	status = NF_INQ_VARID(cdfid, vname, varid)
	status = NF_INQ_VARNDIMS(cdfid, varid, ndims)
	status = NF_INQ_VARDIMID (cdfid, varid, dimids)
#endif
	
	IF ( status .NE. NF_NOERR ) GOTO 5100

	DO 100 igrid = 1, nferdims
	   outgrid(igrid) = 0
  100	CONTINUE

	DO 300 idim = 1, ndims
#ifdef usingDODSf2cUnderscore 
	   status = NF_INQ_DIMNAME_(cdfid, dimids(idim), buff)
	   status = NF_INQ_DIMLEN_ (cdfid, dimids(idim), dimlen)
#else
	   status = NF_INQ_DIMNAME (cdfid, dimids(idim), buff)
	   status = NF_INQ_DIMLEN  (cdfid, dimids(idim), dimlen)
#endif
	   DO 200 igrid = 1, nferdims
	      IF (STR_SAME ( buff, line_name_orig(gridlines(igrid)) ) .EQ. 0) THEN
     	        outgrid(igrid) = gridlines(igrid)
	      ENDIF
  200	   CONTINUE
  300	CONTINUE

	DO 400 igrid = 1, nferdims
	   gridlines(igrid) = outgrid(igrid)
  400	CONTINUE

* successful completion
        status = merr_ok
 5000	RETURN

* error messages
 5100   CONTINUE

        CALL CD_TRANSLATE_ERROR (status, errbuff)
	slen = TM_LENSTR1(errbuff)

        buff = 'Unable to get varid for LET/REMOTE variable: '//
     .    errbuff(:slen)

        CALL TM_ERRMSG
     .     ( merr_badfileatt, status, 'CD_NF_GET_VAR_GRID', dset,
     .        no_stepfile, buff, no_errstring, *5000 )
	END

	SUBROUTINE EARTH_DEL (lons, lats, num, bad_lon, bad_lat, result, errtxt)

* Ansley Manke 2/27/2019
* This computation is pulled out of what was the external function earth_distance, for general
* use for instance in transformations for DSG data.

* Compute the point-to-point-distance in Km along the path given by longitudes, latitudes

* lons, lats	1-D arrays with the longitude and latitude values
* num		Number of data points
* bad_lon	Bad-data flags on input
* bad_lat
* result	result array
* errtxt	Error message if bad-data found in the locations

	INTEGER num
	REAL lons(*), lats(*), result(*), bad_lon, bad_lat
	CHARACTER*(*) errtxt

	INTEGER i
	REAL	dlo, dhi, ed_pd, ed_rearth, 
     .		ed_lat1, ed_lat2, ed_lon1, ed_lon2, 
     .		ed_x1, ed_x2, ed_y1, ed_y2, 
     .		ed_z1, ed_z2, ed_d1, ed_angle

* To first point, no distance
	
	result(1) = 0.
	IF (num .EQ. 1) RETURN

* initialize

	errtxt = ' '
	ed_pd = 4.*atan(1.)/180.
	ed_rearth = 6371.2 

* At each i, compute the distance from the previous point to this one

* pre-check that the location arrays have no missing values

	DO i = 1, num
	   IF (lons(i) .EQ. bad_lon) THEN
	      errtxt = 'missing value found in longitudes'
	   ENDIF
	ENDDO
    
	DO i = 1, num
	   IF (lats(i) .EQ. bad_lat) THEN
	      errtxt = 'missing value found in latitudes'
	   ENDIF
	ENDDO
	

	DO i = 2, num
	
	   result(i) = 0.
	   IF (lons(i) .EQ. bad_lon) CYCLE
	   IF (lats(i) .EQ. bad_lat) CYCLE

	   ed_lat1 = 90 - lats(i-1)
	   ed_lat2 = 90 - lats(i)
	   ed_lon1 = lons(i-1)
	   ed_lon2 = lons(i)

	   ed_x1 = SIN( ed_pd*ed_lat1 )* COS( ed_pd* ed_lon1 )
	   ed_y1 = SIN( ed_pd*ed_lat1 )* SIN( ed_pd* ed_lon1 )
	   ed_z1 = COS( ed_pd*ed_lat1 )
	   ed_x2 = SIN( ed_pd*ed_lat2 )* COS( ed_pd* ed_lon2 )
	   ed_y2 = SIN( ed_pd*ed_lat2 )* SIN( ed_pd* ed_lon2 )
	   ed_z2 = COS( ed_pd*ed_lat2 )

	   ed_d1 = (ed_x1 - ed_x2)**2 + (ed_y1 - ed_y2)**2  +  (ed_z1 - ed_z2)**2
	   ed_angle = ACOS(1 - ed_d1/2)	   ! angular distance between the points

	   result(i) = ed_rearth* ed_angle

	ENDDO

 5000	RETURN
	END

*
* zcat_str.F
*
* Ansley Manke
* Nov 2008
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
*
* This function returns the values of the two variables,
* concatenated into one long list on an abstract Z axis. Other 
* axes are unchanged.
*
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument''s axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE zcat_str_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CHARACTER*100 descrip

      WRITE (descrip, 100)
  100 FORMAT ('Concatenates the Z values of two string variables ',
     .        'into one list on an abstract Z axis')
      CALL ef_set_desc(id, descrip)

      CALL ef_set_num_args(id, 2)
      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                ABSTRACT,        IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_result_type(id, STRING_RETURN)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_type (id, arg, STRING_ARG)
      CALL ef_set_arg_desc(id, arg, 'First variable to concatenate')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, NO, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'B')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_type (id, arg, STRING_ARG)
      CALL ef_set_arg_desc(id, arg, 'Second variable to concatenate')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, NO, YES, YES, YES)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


      SUBROUTINE zcat_str_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER nz

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nz = (arg_hi_ss(Z_AXIS,ARG1) - arg_lo_ss(Z_AXIS,ARG1) + 1) +
     .     (arg_hi_ss(Z_AXIS,ARG2) - arg_lo_ss(Z_AXIS,ARG2) + 1)

      CALL ef_set_axis_limits(id, Z_AXIS, 1, nz)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE zcat_str_compute(id, arg_1, arg_2, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif

      INTEGER id

      REAL arg_1(strdf, mem1lox:mem1hix, mem1loy:mem1hiy,
     .                  mem1loz:mem1hiz, mem1lot:mem1hit,
     .                  mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(strdf, mem2lox:mem2hix, mem2loy:mem2hiy,
     .                  mem2loz:mem2hiz, mem2lot:mem2hit,
     .                  mem2loe:mem2hie, mem2lof:mem2hif)

      REAL result(strdf, memreslox:memreshix, memresloy:memreshiy,
     .                   memresloz:memreshiz, memreslot:memreshit,
     .                   memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information
* for the result axes.  The 'arg_' arrays will contain the indexing
* information for each variable''s axes.

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l, m, n, slen
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2
      CHARACTER*512 buff

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      k = res_lo_ss(Z_AXIS)
      DO 300 k1 = arg_lo_ss(Z_AXIS,ARG1), arg_hi_ss(Z_AXIS,ARG1)

         n = res_lo_ss(F_AXIS)
         DO 600 n1 = arg_lo_ss(F_AXIS,ARG1), arg_hi_ss(F_AXIS,ARG1)

         m = res_lo_ss(E_AXIS)
         DO 500 m1 = arg_lo_ss(E_AXIS,ARG1), arg_hi_ss(E_AXIS,ARG1)

         l = res_lo_ss(T_AXIS)
         DO 400 l1 = arg_lo_ss(T_AXIS,ARG1), arg_hi_ss(T_AXIS,ARG1)

         j = res_lo_ss(Y_AXIS)
         DO 200 j1 = arg_lo_ss(Y_AXIS,ARG1), arg_hi_ss(Y_AXIS,ARG1)

         i = res_lo_ss(X_AXIS)
         DO 100 i1 = arg_lo_ss(X_AXIS,ARG1), arg_hi_ss(X_AXIS,ARG1)

            CALL EF_GET_STRING_ARG_ELEMENT_6D(id, ARG1, arg_1,
     .                             i1, j1, k1, l1, m1, n1, slen, buff)
            CALL EF_PUT_STRING(buff, slen, result(1,i,j,k,l,m,n))

            i = i + res_incr(X_AXIS)
 100     CONTINUE

            j = j + res_incr(Y_AXIS)
 200     CONTINUE

            l = l + res_incr(T_AXIS)
 400     CONTINUE

            m = m + res_incr(E_AXIS)
 500     CONTINUE

            n = n + res_incr(F_AXIS)
 600     CONTINUE

         k = k + res_incr(Z_AXIS)
 300  CONTINUE

* concatenate in Z - dont restart count of index K

      DO 310 k2 = arg_lo_ss(Z_AXIS,ARG2), arg_hi_ss(Z_AXIS,ARG2)

         n = res_lo_ss(F_AXIS)
         DO 610 n2 = arg_lo_ss(F_AXIS,ARG2), arg_hi_ss(F_AXIS,ARG2)

         m = res_lo_ss(E_AXIS)
         DO 510 m2 = arg_lo_ss(E_AXIS,ARG2), arg_hi_ss(E_AXIS,ARG2)

         l = res_lo_ss(T_AXIS)
         DO 410 l2 = arg_lo_ss(T_AXIS,ARG2), arg_hi_ss(T_AXIS,ARG2)

         j = res_lo_ss(Y_AXIS)
         DO 210 j2 = arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS,ARG2)

         i = res_lo_ss(X_AXIS)
         DO 110 i2 = arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS,ARG2)

            CALL EF_GET_STRING_ARG_ELEMENT_6D(id, ARG2, arg_2,
     .                             i2, j2, k2, l2, m2, n2, slen, buff)
            CALL EF_PUT_STRING(buff, slen, result(1,i,j,k,l,m,n))

            i = i + res_incr(X_AXIS)
 110     CONTINUE

            j = j + res_incr(Y_AXIS)
 210     CONTINUE

            l = l + res_incr(T_AXIS)
 410     CONTINUE

            m = m + res_incr(E_AXIS)
 510     CONTINUE

            n = n + res_incr(F_AXIS)
 610     CONTINUE

         k = k + res_incr(Z_AXIS)
 310  CONTINUE

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN
      END

	CHARACTER*(*) FUNCTION LOHI_STRING( lo,hi,idim,grid,
     .                                      to_word,ndec,slen )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* create a string describing a world coordinate range
* for example: 160E:140W or 10m (if lo depth = hi)

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 -  1/10/89 - extracted from LOHI_WORLD 0.3
* V200:  2/27/90 - allowed unspecified limits as "???"
* V230:  2/10/92 - SUN port: must use a temporary string, strbuf, instead of
*                  routine name LOHI_STRING internally.
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
* V751 6/19 *acm* TM_FMT rewrite: formatting of lon/lat coordinate strings

        IMPLICIT NONE
	include	'ferret.parm'

* calling argument declarations
	INTEGER	idim, grid, ndec, slen
	CHARACTER*(*) to_word
	REAL*8	lo, hi

* internal variable declarations:
	LOGICAL need_more
	INTEGER	STR_SAME, sub_len, full_len
        CHARACTER*80 strbuf       ! needed for SUN FORTRAN

* initialize
	full_len = LEN( LOHI_STRING )
	strbuf = ' '

* always put in lower limit
	IF ( lo .NE. unspecified_val8 ) THEN
	   CALL TRANSLATE_TO_WORLD( lo, idim, grid, ndec, strbuf )
	ELSE
	   strbuf = '???'
	ENDIF
	CALL LEFT_JUST( strbuf, strbuf, slen )
	sub_len = slen

* put in upper limit if different from lower
	IF ( hi .NE. lo ) THEN
	   strbuf = strbuf(:slen) // to_word	! either " to " or ":"
	   slen = MIN( full_len, slen + LEN(to_word) + 1 )
	   CALL TRANSLATE_TO_WORLD( hi, idim, grid, ndec, strbuf(slen:) )

	   need_more = ( STR_SAME(strbuf(1:sub_len) , strbuf(slen:full_len)) .EQ. 0)

	   CALL LEFT_JUST( strbuf(slen:), strbuf(slen:), sub_len )
           slen = MIN( full_len, slen + sub_len - 1 )
	ENDIF
	
        LOHI_STRING = strbuf

	RETURN
	END

      SUBROUTINE DO_EXTERNAL_GC_FCN( 
     .				fcn, num_com, com_mr, com_cx,
     .				com1, mr1,
     .				com2, mr2,
     .				com3, mr3,
     .				com4, mr4,
     .				com5, mr5,
     .				com6, mr6,
     .				com7, mr7,
     .				com8, mr8,
     .				com9, mr9,
     .				res, mres,
     .                          status )

* execute a grid changing function

* the addition (or major modification) of an internal grid-changing function
* requires changes to these routines:
*	grid_chg_fcns.parm	- parameters to number the functions
*	XGRID_CHG_FCNS_DATA	- description of the function and args
*	DO_INTERNAL_GC_FCN	- code to execute the function
* (opt)	GCF_GET_IMPOSED_AXES	- return the "imposed" axes, if any
* (opt)	GCF_IMPOSE_RESULT_LIMS	- fill in limits of "imposed" axes, if any

* V450:  1/97 - new, based on operate.F, but for grid changing functions
*        7/97 - complete the ZAXREPLACE function
*       7/25/97 - increase number of args from 4 to 9
*               - add function PPLGRID
* V500: 10/26/98 - *jc* add CREATE_PERMUTATION section
*        7/99 *sh* check status on retun from efvn_compute
* V510: *sh* 3/00 - bug fix: com_mr was passed instead of mr_perm to the EFs
*                 - eliminated old code as marked by jon
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V710 *acm*  1/17 Ticket 1480: Flag sent to CREATE_PERMUTATION; in 
*        xeq_list we maybe doing an adjustment for modulo length of an 
*        axis, always FALSE here.

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include 'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xcontext.cmn'

* calling argument declarations:
	INTEGER	fcn, num_com, com_mr(10), com_cx(9), status,
     .       mr1, mr2, mr3, mr4, mr5, mr6, mr7, mr8, mr9, mres
	REAL com1( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .             m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .       com2( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .             m2lot:m2hit,m2loe:m2hie,m2lof:m2hif ),
     .       com3( m3lox:m3hix,m3loy:m3hiy,m3loz:m3hiz,
     .             m3lot:m3hit,m3loe:m3hie,m3lof:m3hif ),
     .       com4( m4lox:m4hix,m4loy:m4hiy,m4loz:m4hiz,
     .             m4lot:m4hit,m4loe:m4hie,m4lof:m4hif ),
     .       com5( m5lox:m4hix,m5loy:m5hiy,m5loz:m5hiz,
     .             m5lot:m5hit,m5loe:m5hie,m5lof:m5hif ),
     .       com6( m6lox:m4hix,m6loy:m6hiy,m6loz:m6hiz,
     .             m6lot:m6hit,m6loe:m6hie,m6lof:m6hif ),
     .       com7( m7lox:m4hix,m7loy:m7hiy,m7loz:m7hiz,
     .             m7lot:m7hit,m7loe:m7hie,m7lof:m7hif ),
     .       com8( m8lox:m4hix,m8loy:m8hiy,m8loz:m8hiz,
     .             m8lot:m8hit,m8loe:m8hie,m8lof:m8hif ),
     .       com9( m9lox:m4hix,m9loy:m9hiy,m9loz:m9hiz,
     .             m9lot:m9hit,m9loe:m9hie,m9lof:m9hif ),
     .       res( m10lox:m10hix,m10loy:m10hiy,m10loz:m10hiz,
     .            m10lot:m10hit,m10loe:m10hie,m10lof:m10hif )

* internal variable declarations:
        REAL bad_flag_array(10)

        LOGICAL is_permuted(9)
        INTEGER i, mr, perm(nferdims), mr_perm(9)

* internal parameter declarations:
	REAL*8          pdays_by_1900
	PARAMETER     ( pdays_by_1900 = 59958230400.0 / 
     .       (60.*60.*24.) )


* initialize
        status = ferr_ok

* initialize all of the possible passed arguments just for good housekeeping
        DO 5 i= 1, 9
            bad_flag_array(i)  = mr_bad_data ( dummy_mr )
 5      CONTINUE

* In order to pass arguments to the external function as continguous 
* pieces of  we need to use CREATE_PERMUTATION.  
* Otherwise, cached variables will be passed through without being 
* pared down to the desired context.

* 1/2017 New flag sent to CREATE_PERMUTATION; in xeq_list we may
*        be doing an adjustment for modulo length of an axis, always
*        FALSE here.

       DO 10 i=1, nferdims
          perm(i) = i
 10    CONTINUE

       DO 100 i=1, num_com

          CALL CREATE_PERMUTATION(   com_cx(i), com_mr(i),
     .         perm, mr_perm(i), .FALSE., status )
          IF ( status .NE. ferr_OK ) GOTO 5000
          is_permuted(i) = mr_perm(i) .NE. com_mr(i)

          CALL NON_ARRAY_SUBSC( mr_perm, 1 )

          bad_flag_array(i)  = mr_bad_data ( mr_perm(i) )

 100   CONTINUE

* store the restricted limits as known by mr_perm instead of com_mr
        CALL NON_ARRAY_SUBSC( mr_perm, num_com )

        bad_flag_array(10) = mr_bad_data ( mres )

        CALL EFCN_COMPUTE(fcn, num_com, com_cx, mr_perm, mres, 
     .      bad_flag_array,  status)
        IF (status .NE. ferr_ok) CALL ERRMSG(ferr_ef_error, status,
     .          'error in external function', *190)

 
! bug fix 1/17 -- only delete the temporary variables created *here*
* clean temporary, permuted results from memory cache
 190    DO i = 1, num_com
          IF (is_permuted(i)) THEN
            mr = mr_perm(i)
            CALL DELETE_VARIABLE( mr )
          ENDIF
        ENDDO

* error exits
 5000	RETURN
	END

	SUBROUTINE COPY_PTR_INTO_MAPPED_SUB( cxs, axis, hilim,
     .		sorted_indices, index_map,
     .		src, slox, shix, sloy, shiy, sloz, shiz, 
     .		slot, shit, sloe, shie, slof, shif,
     .		dst, dlox, dhix, dloy, dhiy, dloz, dhiz, 
     .		dlot, dhit, dloe, dhie, dlof, dhif  )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* copy string data from source grid into dstination grid using limits of source
* context (i.e. dstination grid is ASSUMED) big enough to hold data

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V533 *sh* 6/01
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include	'xcontext.cmn'

* calling argument declarations:
	INTEGER cxs, axis, hilim,
     .		slox, shix, sloy, shiy, sloz, shiz, 
     .		slot, shit, sloe, shie, slof, shif,
     .		dlox, dhix, dloy, dhiy, dloz, dhiz, 
     .		dlot, dhit, dloe, dhie, dlof, dhif 
	REAL	sorted_indices(hilim), index_map(hilim)
	REAL*8  src( slox:shix,sloy:shiy,sloz:shiz,slot:shit,sloe:shie,slof:shif ),
     .		dst( dlox:dhix,dloy:dhiy,dloz:dhiz,dlot:dhit,dloe:dhie,dlof:dhif )

* internal variable declarations:
	INTEGER	i, j, k, l, m, n, pointer, src_index, dst_index, isorted,
     .		src_index_2

* --- end of introductory code ---

* initialize
* ... skip missing value flags at the upper end of the sorted_indices
	DO 10 pointer = hilim, 1, -1
	   IF (sorted_indices(pointer) .NE. bad_val4) GOTO 50
 10	CONTINUE
	RETURN	! all of the indices are missing values


**** Mapped copy along X axis
 50	IF ( axis .EQ. x_dim ) THEN

* ... initialize
	   src_index = cx_hi_s1(cxs)
* ... if the input data has no range (-999:-999) then match on sorted_indices=1
	   IF (src_index .EQ. unspecified_int4) THEN
	      src_index_2 = 1
	   ELSE
	      src_index_2 = src_index
	   ENDIF

 100	   CONTINUE	! find where src_index belongs in the result
	   DO 150 isorted = pointer, 1, -1
	      IF (src_index_2 .EQ. sorted_indices(isorted)) THEN
* ... copy a source point to the destination
	         dst_index = index_map(isorted)
	         DO 110 n = cx_lo_s6(cxs), cx_hi_s6(cxs)
	         DO 110 m = cx_lo_s5(cxs), cx_hi_s5(cxs)
	         DO 110 l = cx_lo_s4(cxs), cx_hi_s4(cxs)
	         DO 110 k = cx_lo_s3(cxs), cx_hi_s3(cxs)
	         DO 110 j = cx_lo_s2(cxs), cx_hi_s2(cxs)
 110		 CALL COPY_C_STRING( src(src_index,j,k,l,m,n),
     .				     dst(dst_index,j,k,l,m,n) )
	      ELSEIF (src_index .GT. sorted_indices(isorted)) THEN
	         src_index   = src_index   - 1
	         src_index_2 = src_index_2 - 1
	         IF ( src_index .LT. cx_lo_s1(cxs) ) THEN
	            RETURN	! that's all this comonent is gonna supply
	         ELSE
	            pointer = isorted	! (just for efficiency)
	            GOTO 100
	         ENDIF
	      ENDIF
 150	   CONTINUE

	ELSEIF ( axis .EQ. y_dim ) THEN
**** Mapped copy along Y axis

* ... initialize
	   src_index = cx_hi_s2(cxs)
* ... if the input data has no range (-999:-999) then match on sorted_indices=1
	   IF (src_index .EQ. unspecified_int4) THEN
	      src_index_2 = 1
	   ELSE
	      src_index_2 = src_index
	   ENDIF

 200	   CONTINUE	! find where src_index belongs in the result
	   DO 250 isorted = pointer, 1, -1
	      IF (src_index_2 .EQ. sorted_indices(isorted)) THEN
* ... copy a source point to the destination
	         dst_index = index_map(isorted)
	         DO 210 n = cx_lo_s6(cxs), cx_hi_s6(cxs)
	         DO 210 m = cx_lo_s5(cxs), cx_hi_s5(cxs)
	         DO 210 l = cx_lo_s4(cxs), cx_hi_s4(cxs)
	         DO 210 k = cx_lo_s3(cxs), cx_hi_s3(cxs)
	         DO 210 i = cx_lo_s1(cxs), cx_hi_s1(cxs)
 210		 CALL COPY_C_STRING( src(i,src_index,k,l,m,n),
     .				     dst(i,dst_index,k,l,m,n) )
	      ELSEIF (src_index .GT. sorted_indices(isorted)) THEN
	         src_index   = src_index   - 1
	         src_index_2 = src_index_2 - 1
	         IF ( src_index .LT. cx_lo_s2(cxs) ) THEN
	            RETURN	! that's all this comonent is gonna supply
	         ELSE
	            pointer = isorted	! (just for efficiency)
	            GOTO 200
	         ENDIF
	      ENDIF
 250	   CONTINUE

	ELSEIF ( axis .EQ. z_dim ) THEN
**** Mapped copy along Z axis

* ... initialize
	   src_index = cx_hi_s3(cxs)
* ... if the input data has no range (-999:-999) then match on sorted_indices=1
	   IF (src_index .EQ. unspecified_int4) THEN
	      src_index_2 = 1
	   ELSE
	      src_index_2 = src_index
	   ENDIF

 300	   CONTINUE	! find where src_index belongs in the result
	   DO 350 isorted = pointer, 1, -1
	      IF (src_index_2 .EQ. sorted_indices(isorted)) THEN
* ... copy a source point to the destination
	         dst_index = index_map(isorted)
	         DO 310 n = cx_lo_s6(cxs), cx_hi_s6(cxs)
	         DO 310 m = cx_lo_s5(cxs), cx_hi_s5(cxs)
	         DO 310 l = cx_lo_s4(cxs), cx_hi_s4(cxs)
	         DO 310 j = cx_lo_s2(cxs), cx_hi_s2(cxs)
	         DO 310 i = cx_lo_s1(cxs), cx_hi_s1(cxs)
 310		 CALL COPY_C_STRING( src(i,j,src_index,l,m,n),
     .				     dst(i,j,dst_index,l,m,n) )
	      ELSEIF (src_index .GT. sorted_indices(isorted)) THEN
	         src_index   = src_index   - 1
	         src_index_2 = src_index_2 - 1
	         IF ( src_index .LT. cx_lo_s3(cxs) ) THEN
	            RETURN	! that's all this comonent is gonna supply
	         ELSE
	            pointer = isorted	! (just for efficiency)
	            GOTO 300
	         ENDIF
	      ENDIF
 350	   CONTINUE

	ELSEIF ( axis .EQ. t_dim ) THEN
**** Mapped copy along T axis

* ... initialize
	   src_index = cx_hi_s4(cxs)
* ... if the input data has no range (-999:-999) then match on sorted_indices=1
	   IF (src_index .EQ. unspecified_int4) THEN
	      src_index_2 = 1
	   ELSE
	      src_index_2 = src_index
	   ENDIF

 400	   CONTINUE	! find where src_index belongs in the result
	   DO 450 isorted = pointer, 1, -1
	      IF (src_index_2 .EQ. sorted_indices(isorted)) THEN
* ... copy a source point to the destination
	         dst_index = index_map(isorted)
	         DO 410 n = cx_lo_s6(cxs), cx_hi_s6(cxs)
	         DO 410 m = cx_lo_s5(cxs), cx_hi_s5(cxs)
	         DO 410 k = cx_lo_s3(cxs), cx_hi_s3(cxs)
	         DO 410 j = cx_lo_s2(cxs), cx_hi_s2(cxs)
	         DO 410 i = cx_lo_s1(cxs), cx_hi_s1(cxs)
 410		 CALL COPY_C_STRING( src(i,j,k,src_index,m,n),
     .				     dst(i,j,k,dst_index,m,n) )
	      ELSEIF (src_index .GT. sorted_indices(isorted)) THEN
	         src_index   = src_index   - 1
	         src_index_2 = src_index_2 - 1
	         IF ( src_index .LT. cx_lo_s4(cxs) ) THEN
	            RETURN	! that's all this comonent is gonna supply
	         ELSE
	            pointer = isorted	! (just for efficiency)
	            GOTO 400
	         ENDIF
	      ENDIF
 450	   CONTINUE

	ELSEIF ( axis .EQ. e_dim ) THEN
**** Mapped copy along E axis

* ... initialize
	   src_index = cx_hi_s5(cxs)
* ... if the input data has no range (-999:-999) then match on sorted_indices=1
	   IF (src_index .EQ. unspecified_int4) THEN
	      src_index_2 = 1
	   ELSE
	      src_index_2 = src_index
	   ENDIF

 500	   CONTINUE	! find where src_index belongs in the result
	   DO 550 isorted = pointer, 1, -1
	      IF (src_index_2 .EQ. sorted_indices(isorted)) THEN
* ... copy a source point to the destination
	         dst_index = index_map(isorted)
	         DO 510 n = cx_lo_s6(cxs), cx_hi_s6(cxs)
	         DO 510 l = cx_lo_s4(cxs), cx_hi_s4(cxs)
	         DO 510 k = cx_lo_s3(cxs), cx_hi_s3(cxs)
	         DO 510 j = cx_lo_s2(cxs), cx_hi_s2(cxs)
	         DO 510 i = cx_lo_s1(cxs), cx_hi_s1(cxs)
 510		 CALL COPY_C_STRING( src(i,j,k,l,src_index,n),
     .				     dst(i,j,k,l,dst_index,n) )
	      ELSEIF (src_index .GT. sorted_indices(isorted)) THEN
	         src_index   = src_index   - 1
	         src_index_2 = src_index_2 - 1
	         IF ( src_index .LT. cx_lo_s5(cxs) ) THEN
	            RETURN	! that's all this comonent is gonna supply
	         ELSE
	            pointer = isorted	! (just for efficiency)
	            GOTO 500
	         ENDIF
	      ENDIF
 550	   CONTINUE

	ELSEIF ( axis .EQ. f_dim ) THEN
**** Mapped copy along F axis

* ... initialize
	   src_index = cx_hi_s6(cxs)
* ... if the input data has no range (-999:-999) then match on sorted_indices=1
	   IF (src_index .EQ. unspecified_int4) THEN
	      src_index_2 = 1
	   ELSE
	      src_index_2 = src_index
	   ENDIF

 600	   CONTINUE	! find where src_index belongs in the result
	   DO 650 isorted = pointer, 1, -1
	      IF (src_index_2 .EQ. sorted_indices(isorted)) THEN
* ... copy a source point to the destination
	         dst_index = index_map(isorted)
	         DO 610 m = cx_lo_s5(cxs), cx_hi_s5(cxs)
	         DO 610 l = cx_lo_s4(cxs), cx_hi_s4(cxs)
	         DO 610 k = cx_lo_s3(cxs), cx_hi_s3(cxs)
	         DO 610 j = cx_lo_s2(cxs), cx_hi_s2(cxs)
	         DO 610 i = cx_lo_s1(cxs), cx_hi_s1(cxs)
 610		 CALL COPY_C_STRING( src(i,j,k,l,m,src_index),
     .				     dst(i,j,k,l,m,dst_index) )
	      ELSEIF (src_index .GT. sorted_indices(isorted)) THEN
	         src_index   = src_index   - 1
	         src_index_2 = src_index_2 - 1
	         IF ( src_index .LT. cx_lo_s6(cxs) ) THEN
	            RETURN	! that's all this comonent is gonna supply
	         ELSE
	            pointer = isorted	! (just for efficiency)
	            GOTO 600
	         ENDIF
	      ENDIF
 650	   CONTINUE

	ELSE
	   STOP 'COPY_INTO_MAPPED_SUB: axis!!'

	ENDIF

* success
* the index map has been completely traversed -- destination var is complete
	RETURN
	END 

	SUBROUTINE ALG_BREAK_UP( text,at_start,at_end,natom,
     .                               err_string,status )
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* lexical analyzer to break up algebraic expressions into atoms of known
* type.  Possibly more than one expression separated by commas

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V200: 11/24/89
* V402: 7/95 - Allow nested [] of the form vname1[G=vname2[D=dset]]
* V495: 7/7/98 - allow variable names in single quotes - add new state S10
*                and new character class 11 (single quote)
*       7/23 - fixed problem missed the first time. brackets: 'X'[stuff]
* V500: 12/98 - allow {1,3,5} notation for lists of constants
*	 1/99 - allow strings in double quotes (as fcn args)
* V530: //8/00 *sh* - allow {"string", "string"}
* V600:  3/06 *acm* - fix bug 1395: string 1.0e-4+0*8 tried to inlcude plus sign 
*                     and the 0 following it as part of the exponent. Define a new 
*                     state, in which we are interpreting an exponent and getting 
*                     the exponent value itself. Now this becomes like interpreting 
*                     a constant.
* V600:  5/05  *acm* For attribute control, allow . inside names: 
*                    change next_stat(10,4) to 4 -- 
* V685:  7/13  *acm* Bug 2084. If a string starts with . and is not numeric, make an atom.
*                    It'll generally be an error.
* V693+ 12/14 *sh* allow _QD_ and _SQ_ for quotation alternatives 
*                 Filled in state=13 (interpreting exponent) DATA inits 
*	          Hoping I did so correctly ...
* v694  6/15  *acm* fixes for 2296 -- quotes and curly braces {"{a}"}

	include	'ferret.parm'
	include 'errmsg.parm'
	include 'rpn.parm'

* calling argument declaration:
	INTEGER		at_start(maxatoms), at_end(maxatoms), natom, status
	CHARACTER*(*)	text, err_string

* internal variable declarations:
	LOGICAL		TM_DIGIT_TEST, was_operand, atom_open,
     .			requires_closure(num_state),
     .                      have_exp_digits
	INTEGER		ALG_CLASS, TM_LENSTR1,
     .			tlen, p, state, last_state, last_last_state, class,
     .			i, next_state(num_class,num_state),
     .			brkt_nest_level, pn, 
     .			curly_brace_nest, q_in_curly_brace


* possible states of lexical analysis
*	S1 - looking for start of atom
*	S2 - + or - found following operator (*sh* following name ??)
*	S3 - interpreting constant
*	S4 - interpreting name (variable or function, ...)
*	S5 - found last character of atom
*	S6 - ignoring characters inside []
*	S7 - just missed last character of atom
*	S8 - interpreting exponent
*	S9 - inside of nested []	(mod 7/95)
*       S10- inside of single quote pair
*	S11- ignoring characters inside {}
*	S12- inside of double quote pair
*	S13- interpreting exponent, found exponential value
*	S14- interpreting "_" as a possible quote signal
*	S15- inside of _DQ_ (alt double quote) pair
*	S16- inside of _SQ_ (alt single quote) pair


*	-1 ==> Syntax Error
*	-2 ==> Illegal Character
*	-9 ==> **lex state error

* classes of characters
*	C1 - + -
*	C2 - digits
*	C3 - letters
*	C4 - [
*	C5 - ]
*	C6 - * / ^ , (
*	C7 - )
*	C8 - blank tab
*	C9 - E
*	C10- .
*       C11- '
*	C12- {
*	C13- }
*	C14- "
*	C15- _
*	C16- all others

*	... CHARACTER CLASS: next_state(class, last_state) ...
*              C1 C2 C3 C4 C5 C6 C7 C8 C9 C10C11C12C13C14C15C16
	DATA (next_state(i,1),i=1,num_class)
     .        / 2, 3, 4,-1,-1, 5, 5, 1, 4,  3,10,11,-1,12,14,-2/
	DATA (next_state(i,2),i=1,num_class)
     .        / 7, 3, 7, 7, 7, 7, 7, 7, 7,  3, 7, 7, 7, 7,14,-2/
	DATA (next_state(i,3),i=1,num_class)
     .        / 7, 3, 3,-1,-1, 7, 7, 7, 8,  3, 7,-1,-1, 7,14,-2/
	DATA (next_state(i,4),i=1,num_class)
     .        / 7, 4, 4, 6,-1, 7, 7, 7, 4,  4, 7,-1,-1, 7,14,-2/
	DATA (next_state(i,5),i=1,num_class)
     .        /-9,-9,-9,-9,-9,-9,-9,-9,-9, -9,-9,-9,-9,-9,14,-2/
	DATA (next_state(i,6),i=1,num_class)
     .        / 6, 6, 6, 9, 5, 6, 6, 6, 6,  6, 6, 6, 6, 6,14, 6/
	DATA (next_state(i,7),i=1,num_class)
     .        /-9,-9,-9,-9,-9,-9,-9,-9,-9, -9,-9,-9,-9,-9,14,-2/
	DATA (next_state(i,8),i=1,num_class)
     .        / 8,13, 7, 7, 7, 7, 7, 7, 7,  7, 7, 7, 7, 7,14,-2/
	DATA (next_state(i,9),i=1,num_class)
     .        / 9, 9, 9, 9, 9, 9, 9, 9, 9,  9, 9, 9, 9, 9, 9, 9/
	DATA (next_state(i,10),i=1,num_class)
     .        /10,10,10,10,10,10,10,10,10, 10,10,10,10,10,10,10/
	DATA (next_state(i,11),i=1,num_class)
     .        /11,11,11,11,11,11,11,11,11, 11,11,11, 5,11,11,11/
	DATA (next_state(i,12),i=1,num_class)
     .        /12,12,12,12,12,12,12,12,12, 12,12,12,12,12,12,12/
	DATA (next_state(i,13),i=1,num_class)
     .        /-1,-1,-1,-1,-1,-1,-1,-1,-1, -1,-1,-1,-1,-1,-1,-1/
	DATA (next_state(i,14),i=1,num_class)
     .        /14,14,14,14,14,14,14,14,14, 14,14,14,14,14,14,14/
	DATA (next_state(i,15),i=1,num_class)
     .        /15,15,15,15,15,15,15,15,15, 15,15,15,15,15,14,15/
	DATA (next_state(i,16),i=1,num_class)
     .        /16,16,16,16,16,16,16,16,16, 16,16,16,16,16,14,16/


* which states are not valid on exit (e.g. unclosed braces)
	DATA requires_closure(1 )/.FALSE./ !S1 - looking for start of atom
	DATA requires_closure(2 )/.FALSE./ !S2 - + or - following operator
	DATA requires_closure(3 )/.FALSE./ !S3 - interpreting constant
	DATA requires_closure(4 )/.FALSE./ !S4 - interpreting name
	DATA requires_closure(5 )/.FALSE./ !S5 - found last character of atom
	DATA requires_closure(6 )/.TRUE. / !S6 - ignoring characters inside []
	DATA requires_closure(7 )/.FALSE./ !S7 - just missed last character
	DATA requires_closure(8 )/.FALSE./ !S8 - interpreting exponent
	DATA requires_closure(9 )/.TRUE. / !S9 - inside of nested []
	DATA requires_closure(10)/.TRUE. / !S10- inside of single quote pair
	DATA requires_closure(11)/.TRUE. / !S11- ignoring characters inside {}
	DATA requires_closure(12)/.TRUE. / !S12- inside of double quote pair
	DATA requires_closure(13)/.FALSE./ !S13- interpreting exponent
	DATA requires_closure(14)/.TRUE. / !S14- inside of _QD_ quote pair
	DATA requires_closure(15)/.TRUE. / !S15- inside of _SQ_ quote pair

* initialize
*    "was_operand" flags the character of the previous atom to distinguish the
*     operator "-" in "X-5" from the negative sign "-" in "X+-5"
	tlen = TM_LENSTR1( text )
	natom = 0
	p = 0
	state = 1
	last_state = 1
	was_operand = .FALSE.
	atom_open = .FALSE.
        have_exp_digits = .FALSE.
	brkt_nest_level = 0
	curly_brace_nest = 0
	q_in_curly_brace = 0

* advance to next character
 5	p = p + 1
	IF ( p .GT. tlen ) THEN
	   IF ( natom .EQ. 0 ) GOTO 9999
	   IF (requires_closure(state)) GOTO 5400
* ... SUCCESS - DONE
	   status = ferr_ok
	   at_end(natom) = tlen
	   RETURN
	ENDIF
	   
* check next character
 10	last_last_state = last_state  ! so "_" can morph to a letter
	last_state = state
	class = ALG_CLASS( text(p:p) )

* determine lexical analysis state to determine next action
 50	state = next_state( class, last_state )

	IF ( state .EQ. -2 ) GOTO 5100
	IF ( state .EQ. -1 ) GOTO 5200
	IF ( state .EQ. -9 ) GOTO 5900
	IF ( state .EQ. 1  ) GOTO 5	! just keep looking

*  "+" or "-" at start of atom is operator if last atom was an operand
	IF ( was_operand .AND. last_state.EQ.1 .AND. class.EQ.1 ) state = 5

* will this act like an operator or an operand for the next atom ?
	IF ( state.EQ.7 .OR. class.EQ.8 .OR. class.EQ.13) THEN
* ... last "significant" character hasn't changed
	   CONTINUE
	ELSEIF ( class.EQ.1 .OR. class .EQ.6 ) THEN
	   was_operand = .FALSE.
	ELSE
	   was_operand = .TRUE.
	ENDIF

* begin new atom, possibly.
	IF ( .NOT.atom_open ) THEN
	   IF ( natom .EQ. maxatoms-1 ) GOTO 5300
           IF (class .EQ. 10 ) THEN  ! var.attribute?
              atom_open = .TRUE.
              pn = MIN(p+1,tlen)
	      IF ( TM_DIGIT_TEST(text(p:pn)) ) THEN  ! looks like a number...
                 natom = natom + 1
                 at_start(natom) = p 
              ELSE
* this is a var.attr, so continue as though we are parsing a string
                 class = 3
                 state = 4
                 last_state = 4
* Non-numeric text starting with a dot. Start the atom.
		 IF (p.EQ.1) THEN
                    natom = natom + 1
                    at_start(natom) = p
                    atom_open = .TRUE.
                 ENDIF
              ENDIF
           ELSE
              natom = natom + 1
              at_start(natom) = p
              atom_open = .TRUE.
           ENDIF
	ENDIF

* Curly braces inside quotes inside curly braces
* Hack to work around the case in ticket 2296

	IF (class.EQ.13 .AND. state.EQ.5 .AND. curly_brace_nest.GT.0) state = 11

* take appropriate action
*		S1  S2  S3  S4  S5  S6  S7  S8   S9  S10 S11  S12  S13  S14 S15  S16
	GOTO (9999,100,100,100,500,100,700,100, 900,1000,1100,1200,1300,1400,100,100)
     .								state

* continue to next character
 100	GOTO 5

* flag the last character of an atom - begin search for next atom
 500	at_end(natom) = p
	state = 1
	
* reset - previous atoms may have had a quote not a pair of quotes inside curly braces
	curly_brace_nest = 0
	q_in_curly_brace = 0

	atom_open = .FALSE.
	GOTO 5
	
* flag the last character of an atom one back - begin search for next atom
 700	at_end(natom) = p-1
	last_state = 1
	atom_open = .FALSE.
	GOTO 50

* nested "[]" (mod 7/95)
* this probably violates the theoretical underpinnings of the finite state
* engine but ... what the heck, it's an easy hack
* stay in this state until the matching "]" is found
 900	IF (class .EQ. 4) THEN		! increase nesting
	   brkt_nest_level = brkt_nest_level + 1
	ELSEIF ( class .EQ. 5 ) THEN	! decrease nesting
	   brkt_nest_level = brkt_nest_level - 1
	   IF ( brkt_nest_level .EQ. 0 ) state = 6	! <== leave state 
	ENDIF
	GOTO 5

* single-quoted strings (mod 7/98)
* this probably violates the theoretical underpinnings of the finite state
* engine but ... what the heck, it's an easy hack
* stay in this state until the matching \' is found
* Note: this crude code cannot deal with nested quotations or escaped quotes
*    Also, quoted names inside of square brackets will not be handled here
 1000	IF (class .EQ. 11) THEN		! quote found
	   IF (last_state .EQ. 10) THEN      
	      state = 4                 ! closing quote (?why not GOTO 500?)
*       ... note that we may still be interpreting names like 'X'[stuff]
	   ELSE
	      atom_open = .TRUE.        ! opening quote
	   ENDIF
	ELSE          
	   CONTINUE                     ! inside of quote
	ENDIF
	GOTO 5

* Curly braces inside quotes inside curly braces
* Hack to work around the case in ticket 2296
 1100	IF (class .EQ. 14 .AND. q_in_curly_brace.EQ.0) ! quote inside curly braces
     .    q_in_curly_brace = q_in_curly_brace + 1

	IF (class.EQ.12 .AND. q_in_curly_brace.GT.0)   ! further curly brace start found
     .    curly_brace_nest = curly_brace_nest + 1

	IF (class.EQ.13 .AND. curly_brace_nest.GT.0) THEN  !  curly brace end found
	   curly_brace_nest = curly_brace_nest - 1
	   state = 11
	ENDIF
	GOTO 5

* double-quoted strings (mod 1/99)
* this probably violates the theoretical underpinnings of the finite state
* engine but ... what the heck, it's an easy hack
* stay in this state until the matching \" is found
* Note: this crude code cannot deal with nested quotations or escaped quotes
 1200	IF (class .EQ. 14) THEN		! quote found
           IF (last_state .EQ. 11 .AND. q_in_curly_brace.GT.0) THEN
	      state = 11
	      q_in_curly_brace = q_in_curly_brace - 1
	   ENDIF
	   IF (last_state .EQ. 12) THEN      
	      GOTO 500                 ! closing quote found
*       ... note that we may still be interpreting names like 'X'[stuff]
	   ELSE
	      atom_open = .TRUE.        ! opening quote
	   ENDIF
	ELSE          
	   CONTINUE                     ! inside of quote
	ENDIF
	GOTO 5

* digit part of exponent
 1300	state = 3
	GOTO 5

* "_" underscore -- possible indicator of _DQ_ or _SQ_ 
 1400	IF ( p .GT. tlen-3 ) THEN
	   GOTO 1410                ! cant be _DQ_ or _SQ_
	ELSEIF (text(p:p+3) .EQ. p_DQ_quote) THEN
	   IF (atom_open. AND. p.EQ.at_start(natom)) THEN
* ... start of _DQ_ enclosed string
	      p = p+3
	      state = 15
	      GOTO 5
	   ELSEIF (last_state .EQ. 15) THEN
* ... this is a closing quote.  We have been inside of _DQ_ enclosed string
	      p = p+3
	      GOTO 500
	   ELSE
* ... the characters "_DQ_", but not start or end of string
	      GOTO 1410
	   ENDIF
	ELSEIF (text(p:p+3) .EQ. p_SQ_quote) THEN
	   IF (atom_open. AND. at_start(natom) .EQ. p) THEN
* ... start of _SQ_ enclosed string
	      p = p+3
	      state = 16
	      GOTO 5
	   ELSEIF (last_state .EQ. 16) THEN
* ... this is a closing quote.  We have been inside of _SQ_ enclosed string
	      p = p+3
	      state = 4 ! we may have _SQ_X_SQ_[stuff]
	      GOTO 5
	   ELSE
* ... the characters "_SQ_", but not start or end of string
	      GOTO 1410
	   ENDIF
	ENDIF

* ...  go back and try again, treating this underscore like any other letter
 1410	   last_state = last_last_state  ! needed?  playing it safe ...
	   class = 3  ! a letter
	   GOTO 50


* error exits
 5000	status = ferr_syntax
 5005	RETURN
 5100	err_string = 'illegal character: '//text(p:p)
	GOTO 5000 
 5200	err_string = text(MAX(1,p-6):MIN(tlen,p+2))
	GOTO 5000
 5300	err_string = '['//text(MAX(1,p-8):p)//' ]'
	status = ferr_expr_too_complex
	GOTO 5005
 5400	err_string = 'unclosed quotation, parenthesis, or bracket'
	GOTO 5000
 5900	err_string = '*** lex state'
	status = ferr_internal
	GOTO 5005
 9999	STOP 'ALG_BREAK_UP'
	END

      SUBROUTINE NXTHDR(ITAPEI)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)nxthdr.f	1.1    3/10/88
C**
C**
C***********************************************************************        C**
C**                 EPIC
C**
C***********************************************************************        C**
C**
C  THIS SUBROUTINE WILL READ IN THE NEXT HEADER IN A MULTI HEADER 
C  FILE. IT WILL PLACE THE DATA IN ARRAY BUFFER.
C
C  PROGRAMMED 10/84 NY M.VERSCHELL
C
      CHARACTER*80 BUFFER(8)
      COMMON /comnxt/ BUFFER
C  
C  READ IN NEXT HEADER
C
      READ (ITAPEI,END=99) BUFFER(1)
      GOTO 100
   99 READ (ITAPEI,END=9000) BUFFER(1)
  100 DO 150 J=2,8
      READ (ITAPEI,END=9000) BUFFER(J)
  150 CONTINUE 
	RETURN
C
C  HERE BEGINS THE ERROR HANDLING CODE
C
 9000 WRITE (6,9100) NERROR
 9100 FORMAT(1X,'FORTRAN RUN TIME ERROR #',I2)
      IF (NERROR .EQ. -1) WRITE (6,9200)
 9200 FORMAT(1X,'END OF FILE READ BEFORE ALL OF HEADER READ')
      IF (NERROR .EQ. 29) WRITE (6,9300)
 9300 FORMAT(1X,'TAPE 1 NOT ASSIGNED (FOR001.DAT NOT FOUND)')
      IF (NERROR .EQ. 61) WRITE (6,9400)
 9400 FORMAT(1X,'ERROR IN CONVERSION OF NCAST OR NDATA')
      STOP
      END

*
* list_value_xml.F
*
* Ansley Manke
* May 24, 2011
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
* V691+*acm* 8/14  Fix ticket 2190: long strings were being cut off.
*
* This function writes a string value to an xml string, and with a given tag 
* and option to enclose it in CDATA escape. e.g.
*
*		<label><![CDATA[Z (m):]]></label>
*		<value><![CDATA[0]]></value>
*
* it then lists the string to the named file.
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE list_value_xml_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CHARACTER*120 fcn_descr

      WRITE (fcn_descr,100) 
      CALL ef_set_desc(id, fcn_descr)
  100 FORMAT('write a string in xml format with specified ',
     .       'tag and optional CDATA escape sequence')

      CALL ef_set_num_args(id, 4)
      CALL ef_set_axis_inheritance_6d(id,
     .                                ABSTRACT, NORMAL,
     .                                NORMAL,   NORMAL,
     .                                NORMAL,   NORMAL)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'tag')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_type (id, arg, STRING_ARG)
      CALL ef_set_arg_desc(id, arg, 'tag to open and close with')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'value')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'single string value to write')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)
      CALL ef_set_arg_type (id, arg, STRING_ARG)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'cdata_flag')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 
     .'enter 1 to request CDATA escape, 0 otherwise')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'outputfile')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_desc(id, arg, 'the filename to write to')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)
      CALL ef_set_arg_type (id, arg, STRING_ARG)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE list_value_xml_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER arg, my_lo, my_hi

      arg = 1
      my_lo = 1
      my_hi = 1
      CALL ef_set_axis_limits(id, X_AXIS, my_lo, my_hi)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END


*
* In this subroutine we compute the result
*
      SUBROUTINE list_value_xml_compute(id, arg_1, arg_2, arg_3, 
     .           arg_4, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif

      INTEGER id

      REAL arg_1(strdf,
     .           mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(strdf,
     .           mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)
      REAL arg_4(strdf,
     .           mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz, 
     .           mem4lot:mem4hit, mem4loe:mem4hie, mem4lof:mem4hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER i, j, k, l, m, n
      INTEGER TM_LENSTR1, vlen, tlen, slen, flen, iunit
      CHARACTER*2048 outstring, first, second, third
      CHARACTER*2048 outfile
      CHARACTER*50 tag
      CHARACTER*2048 value
      CHARACTER*100 errtxt
      INTEGER cdata_flag

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      i = arg_lo_ss(X_AXIS,ARG1)
      j = arg_lo_ss(Y_AXIS,ARG1)
      k = arg_lo_ss(Z_AXIS,ARG1)
      l = arg_lo_ss(T_AXIS,ARG1)
      m = arg_lo_ss(E_AXIS,ARG1)
      n = arg_lo_ss(F_AXIS,ARG1)
*     Get the tag (string)
      CALL ef_get_string_arg_element_6d(id, ARG1, arg_1,
     .                                  i,j,k,l,m,n,tlen,tag)

      i = arg_lo_ss(X_AXIS,ARG2)
      j = arg_lo_ss(Y_AXIS,ARG2)
      k = arg_lo_ss(Z_AXIS,ARG2)
      l = arg_lo_ss(T_AXIS,ARG2)
      m = arg_lo_ss(E_AXIS,ARG2)
      n = arg_lo_ss(F_AXIS,ARG2)
*     Get the value (string)
      CALL ef_get_string_arg_element_6d(id, ARG2, arg_2,
     .                                  i,j,k,l,m,n,vlen,value)
      i = arg_lo_ss(X_AXIS,ARG3)
      j = arg_lo_ss(Y_AXIS,ARG3)
      k = arg_lo_ss(Z_AXIS,ARG3)
      l = arg_lo_ss(T_AXIS,ARG3)
      m = arg_lo_ss(E_AXIS,ARG3)
      n = arg_lo_ss(F_AXIS,ARG3)
      cdata_flag = INT(arg_3(i,j,k,l,m,n))


      i = arg_lo_ss(X_AXIS,ARG4)
      j = arg_lo_ss(Y_AXIS,ARG4)
      k = arg_lo_ss(Z_AXIS,ARG4)
      l = arg_lo_ss(T_AXIS,ARG4)
      m = arg_lo_ss(E_AXIS,ARG4)
      n = arg_lo_ss(F_AXIS,ARG4)
*     Get the filename (string)
      CALL ef_get_string_arg_element_6d(id, ARG4, arg_4,
     .                                  i,j,k,l,m,n,flen,outfile)

*		<value><![CDATA[0]]></value>
*		<value>0</value>

1000  FORMAT('<',a, '><![CDATA[')
1010  FORMAT(a, ']]></', a, '>')
1020  FORMAT(a, '>')
1030  FORMAT('<',a, '>')
1040  FORMAT(a, '</')
1050  FORMAT(a, '>')
1060  FORMAT(a)

      IF (cdata_flag .EQ. 1) THEN
         write (first,  1000) tag(1:tlen)
         write (second, 1010) value(1:vlen)
         write (third , 1020) tag(1:tlen)
	 tlen = TM_LENSTR1(first)
	 vlen = TM_LENSTR1(second)
	 slen = TM_LENSTR1(third)
         outstring = first(1:tlen)//second(1:vlen)//third(1:slen)
	 vlen = tlen+vlen+slen
      ELSE
         write (first,  1030) tag(1:tlen)
         write (second, 1040) value(1:vlen)
         write (third , 1050) tag(1:tlen)
	 tlen = TM_LENSTR1(first)
	 vlen = TM_LENSTR1(second)
	 slen = TM_LENSTR1(third)
         outstring = first(1:tlen)//second(1:vlen)//third(1:slen)
	 vlen = tlen+vlen+slen
      ENDIF
      vlen = TM_LENSTR1(outstring)

      iunit = 19
      OPEN( UNIT        = iunit,
     .      FILE        = outfile(1:flen),
     .      FORM        = 'FORMATTED',
     .      ACCESS      = 'APPEND',
     .      ERR         = 5010 )

      WRITE (iunit, 1060) outstring(1:vlen)
      CLOSE (iunit, ERR = 5020 )

      i = res_lo_ss(X_AXIS)
      j = res_lo_ss(Y_AXIS)
      k = res_lo_ss(Z_AXIS)
      l = res_lo_ss(T_AXIS)
      m = res_lo_ss(E_AXIS)
      n = res_lo_ss(F_AXIS)
      result(i,j,k,l,m,n) = 1

      RETURN

 5010 CONTINUE
      WRITE(errtxt,*) 'Error opening file ', outfile(1:flen)
      CALL EF_BAIL_OUT(id, errtxt)
 5020 CONTINUE
      WRITE(errtxt,*) 'Error closing file ', outfile(1:flen)
      CALL EF_BAIL_OUT(id, errtxt)
      RETURN

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* samplexy_curv.F
*
* Ansley Manke
* 4/03 
* ???  Note: does not currently deal with modulo data  ???
* 1/06 Remove calls to SIGN to compile with f90 on IRIX.

* This function samples 4-d curvlinear data on the x and y axes 
* indicated by args 4 and 5
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE samplexy_curv_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      CHARACTER*100 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns data sampled at a set of (X,Y) points, ',
     .        'using linear interpolation')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 5)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id,
     .                                ABSTRACT,        NORMAL,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)
      CALL ef_set_num_work_arrays(id, 1)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'DAT_TO_SAMPLE')
      CALL ef_set_arg_desc(id, arg, 'variable (x,y,z,t,e,f) to sample')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'DAT_LON')
      CALL ef_set_arg_desc(id, arg, 'longitudes of input variable')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'DAT_LAT')
      CALL ef_set_arg_desc(id, arg, 'latitudes of input variable')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 4
      CALL ef_set_arg_name(id, arg, 'XPTS')
      CALL ef_set_arg_desc(id, arg, 'X values of sample points')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 5
      CALL ef_set_arg_name(id, arg, 'YPTS')
      CALL ef_set_arg_desc(id, arg, 'Y values of sample points')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* loss               lo subscript for an axis
*
* hiss               hi subscript for an axis
*

      SUBROUTINE samplexy_curv_result_limits(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)
      INTEGER my_lo, my_hi
      INTEGER nx, ny, nz, nt, ne, nf

*     Use utility functions to get context information about the 
*     fourth argument, to set the abstract axis lo and hi indices.

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

      nx = arg_hi_ss(X_AXIS, ARG4) - arg_lo_ss(X_AXIS, ARG4) + 1
      ny = arg_hi_ss(Y_AXIS, ARG4) - arg_lo_ss(Y_AXIS, ARG4) + 1
      nz = arg_hi_ss(Z_AXIS, ARG4) - arg_lo_ss(Z_AXIS, ARG4) + 1
      nt = arg_hi_ss(T_AXIS, ARG4) - arg_lo_ss(T_AXIS, ARG4) + 1
      ne = arg_hi_ss(E_AXIS, ARG4) - arg_lo_ss(E_AXIS, ARG4) + 1
      nf = arg_hi_ss(F_AXIS, ARG4) - arg_lo_ss(F_AXIS, ARG4) + 1

      my_lo = 1
      my_hi = max(nx,ny,nz,nt,ne,nf)

      CALL ef_set_axis_limits(id, X_AXIS, my_lo, my_hi)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we request an amount of storage to be supplied
* by Ferret and passed as an additional argument.
*
      SUBROUTINE samplexy_curv_work_size(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

*
* Set the work arrays, X/Y/Z/T/E/F dimensions
*
* ef_set_work_array_dims_6d(id, array #,
*                           xlo, ylo, zlo, tlo, elo, flo,
*                           xhi, yhi, zhi, thi, ehi, fhi)
*

      INTEGER nx, ny
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)

*  workspace for saving locations of xpt in arg2 array.

      nx = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) 
      ny = arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) 

*  xlocations
      CALL ef_set_work_array_dims_6d(id, 1,
     .                                1, 1, 1, 1, 1, 1,
     .                            nx*ny, 2, 1, 1, 1, 1)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END



*
* In this subroutine we compute the result
*
      SUBROUTINE samplexy_curv_compute(id, arg_1, arg_2, arg_3, arg_4, 
     .                                 arg_5, result, xlocations)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)
      REAL arg_4(mem4lox:mem4hix, mem4loy:mem4hiy, mem4loz:mem4hiz, 
     .           mem4lot:mem4hit, mem4loe:mem4hie, mem4lof:mem4hif)
      REAL arg_5(mem5lox:mem5hix, mem5loy:mem5hiy, mem5loz:mem5hiz, 
     .           mem5lot:mem5hit, mem5loe:mem5hie, mem5lof:mem5hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

      REAL xlocations(wrk1lox:wrk1hix, wrk1loy:wrk1hiy,
     .                wrk1loz:wrk1hiz, wrk1lot:wrk1hit,
     .                wrk1loe:wrk1hie, wrk1lof:wrk1hif)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER nx, nxx, nxy, nxz, nxt, nxe, nxf
      INTEGER ny, nyx, nyy, nyz, nyt, nye, nyf
      INTEGER ndimx, ndimy
      INTEGER nx1, nx2, nx3, ny1, ny2, ny3
      INTEGER i, j, k, l, m, n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2
      INTEGER i3, j3, k3, l3, m3, n3
      INTEGER i4, j4, k4, l4, m4, n4
      INTEGER i5, j5, k5, l5, m5, n5
      INTEGER ibot, itop, jbot, jtop
      INTEGER nloc, iloc, ptloc, icross
      LOGICAL need_modulo
      REAL ylocations(2)
      REAL xpt, ypt, ydiff, yd, add_xcoord, xadd, xcoord
      REAL xcoord_diff, xcoordlast, tol
      REAL xptmin, xptmax, xcoordmin, xcoordmax
      REAL fxbot, fxtop, fbb, ftb, fbt, ftt
      REAL xbot, xtop, ybot, ytop
      REAL xfrac, yfrac
      CHARACTER*255 err_msg
      parameter (tol = 140.)

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

C Check that first 3 args are on the same grid.

      nx1 = arg_hi_ss(X_AXIS,ARG1) - arg_lo_ss(X_AXIS,ARG1) + 1
      nx2 = arg_hi_ss(X_AXIS,ARG2) - arg_lo_ss(X_AXIS,ARG2) + 1
      nx3 = arg_hi_ss(X_AXIS,ARG3) - arg_lo_ss(X_AXIS,ARG3) + 1
      ny1 = arg_hi_ss(Y_AXIS,ARG1) - arg_lo_ss(Y_AXIS,ARG1) + 1
      ny2 = arg_hi_ss(Y_AXIS,ARG2) - arg_lo_ss(Y_AXIS,ARG2) + 1
      ny3 = arg_hi_ss(Y_AXIS,ARG3) - arg_lo_ss(Y_AXIS,ARG3) + 1
      IF ( (nx1 .NE. nx2) .OR. (nx1 .NE. nx3) .OR.
     .     (ny1 .NE. ny2) .OR. (ny1 .NE. ny3) ) THEN
         err_msg ='Arguments 1, 2, and 3 must have the same XY grid'
         GO TO 999
      ENDIF

      IF ( (arg_hi_ss(Z_AXIS,ARG2) .GT. arg_lo_ss(Z_AXIS,ARG2)) .OR.
     .     (arg_hi_ss(T_AXIS,ARG2) .GT. arg_lo_ss(T_AXIS,ARG2)) .OR.
     .     (arg_hi_ss(E_AXIS,ARG2) .GT. arg_lo_ss(E_AXIS,ARG2)) .OR.
     .     (arg_hi_ss(F_AXIS,ARG2) .GT. arg_lo_ss(F_AXIS,ARG2)) .OR.
     .     (arg_hi_ss(Z_AXIS,ARG3) .GT. arg_lo_ss(Z_AXIS,ARG3)) .OR.
     .     (arg_hi_ss(T_AXIS,ARG3) .GT. arg_lo_ss(T_AXIS,ARG3)) .OR.
     .     (arg_hi_ss(E_AXIS,ARG3) .GT. arg_lo_ss(E_AXIS,ARG3)) .OR.
     .     (arg_hi_ss(F_AXIS,ARG3) .GT. arg_lo_ss(F_AXIS,ARG3)) ) THEN
         err_msg ='Arguments 2 and 3 must be defined only on X and Y'
         GO TO 999
      ENDIF

C Check that sample x and y are simple lists of points - same length

      nxx = arg_hi_ss(X_AXIS,ARG4) - arg_lo_ss(X_AXIS,ARG4) + 1
      nxy = arg_hi_ss(Y_AXIS,ARG4) - arg_lo_ss(Y_AXIS,ARG4) + 1
      nxz = arg_hi_ss(Z_AXIS,ARG4) - arg_lo_ss(Z_AXIS,ARG4) + 1
      nxt = arg_hi_ss(T_AXIS,ARG4) - arg_lo_ss(T_AXIS,ARG4) + 1
      nxe = arg_hi_ss(E_AXIS,ARG4) - arg_lo_ss(E_AXIS,ARG4) + 1
      nxf = arg_hi_ss(F_AXIS,ARG4) - arg_lo_ss(F_AXIS,ARG4) + 1
      nx = max(nxx, nxy, nxz, nxt, nxe, nxf)

      nyx = arg_hi_ss(X_AXIS,ARG5) - arg_lo_ss(X_AXIS,ARG5) + 1
      nyy = arg_hi_ss(Y_AXIS,ARG5) - arg_lo_ss(Y_AXIS,ARG5) + 1
      nyz = arg_hi_ss(Z_AXIS,ARG5) - arg_lo_ss(Z_AXIS,ARG5) + 1
      nyt = arg_hi_ss(T_AXIS,ARG5) - arg_lo_ss(T_AXIS,ARG5) + 1
      nye = arg_hi_ss(E_AXIS,ARG5) - arg_lo_ss(E_AXIS,ARG5) + 1
      nyf = arg_hi_ss(F_AXIS,ARG5) - arg_lo_ss(F_AXIS,ARG5) + 1
      ny = max(nyx, nyy, nyz, nyt, nye, nyf)

      ndimx = 0
      ndimy = 0
      DO 10 i = X_AXIS,F_AXIS
         IF ( arg_hi_ss(i,ARG4) .GT. arg_lo_ss(i,ARG4) ) ndimx=ndimx + 1
         IF ( arg_hi_ss(i,ARG5) .GT. arg_lo_ss(i,ARG5) ) ndimy=ndimy + 1
   10 CONTINUE

      IF ( (nx .NE. ny) .OR. (ndimx .GT. 1) .OR. (ndimy .GT.1) ) THEN
         err_msg = 
     .  'Arguments 4 and 5 must be 1-dimensional lists of equal length'
         GO TO 999
      ENDIF
      
* Initialize result

      DO 15 n=res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
      DO 15 m=res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
      DO 15 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
      DO 15 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
      DO 15 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
      DO 15 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
         result(i,j,k,l,m,n) = bad_flag_result
  15  CONTINUE

* Get range of arg_2, longitude coordinates, and arg_4, xpts to sample.
* is modulo-ing needed?  Also checking for bad values.

*     Z/T/E/F axes of arg_2 are normal or singleton
      n2 = arg_lo_ss(F_AXIS,ARG2)
      m2 = arg_lo_ss(E_AXIS,ARG2)
      l2 = arg_lo_ss(T_AXIS,ARG2)
      k2 = arg_lo_ss(Z_AXIS,ARG2)

      xcoordmin = ABS(bad_flag(ARG2))
      xcoordmax = -1. * xcoordmin

      DO 20 j2 = arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS,ARG2)
      DO 20 i2 = arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS,ARG2)
         IF (arg_2(i2,j2,k2,l2,m2,n2) .NE. bad_flag(ARG2)) THEN
            xcoordmin = MIN(arg_2(i2,j2,k2,l2,m2,n2), xcoordmin)
            xcoordmax = MAX(arg_2(i2,j2,k2,l2,m2,n2), xcoordmax)
         ELSE
            err_msg =
     .      'Arg 2, curvilinear X coordinates, contains missing values'
            GOTO 999
         ENDIF
   20 CONTINUE

      xptmin = ABS(bad_flag(ARG4))
      xptmax = -1.* xptmin

      DO 40 n4 = arg_lo_ss(F_AXIS,ARG4), arg_hi_ss(F_AXIS,ARG4)
      DO 40 m4 = arg_lo_ss(E_AXIS,ARG4), arg_hi_ss(E_AXIS,ARG4)
      DO 40 l4 = arg_lo_ss(T_AXIS,ARG4), arg_hi_ss(T_AXIS,ARG4)
      DO 40 k4 = arg_lo_ss(Z_AXIS,ARG4), arg_hi_ss(Z_AXIS,ARG4)
      DO 40 j4 = arg_lo_ss(Y_AXIS,ARG4), arg_hi_ss(Y_AXIS,ARG4)
      DO 40 i4 = arg_lo_ss(X_AXIS,ARG4), arg_hi_ss(X_AXIS,ARG4)
         IF (arg_4(i4,j4,k4,l4,m4,n4) .NE. bad_flag(ARG4)) THEN
            xptmin = MIN(arg_4(i4,j4,k4,l4,m4,n4), xptmin)
            xptmax = MAX(arg_4(i4,j4,k4,l4,m4,n4), xptmax)
         ELSE
            err_msg =
     .      'Arg 4, sample X points, contains missing values'
            GOTO 999
         ENDIF
   40 CONTINUE

      IF (xptmin .LT. xcoordmin) THEN
         need_modulo = .TRUE.
         add_xcoord = -360.
      ENDIF
      IF (xptmax .GT. xcoordmax) THEN
         need_modulo = .TRUE.
         add_xcoord = 360.
      ENDIF

* Check once for bad values so we do not have to worry about this issue

*     Z/T/E/F axes of arg_3 are normal or singleton
      n3 = arg_lo_ss(F_AXIS,ARG2)
      m3 = arg_lo_ss(E_AXIS,ARG2)
      l3 = arg_lo_ss(T_AXIS,ARG2)
      k3 = arg_lo_ss(Z_AXIS,ARG2)

      DO 30 j3 = arg_lo_ss(Y_AXIS,ARG3), arg_hi_ss(Y_AXIS,ARG3)
      DO 30 i3 = arg_lo_ss(X_AXIS,ARG3), arg_hi_ss(X_AXIS,ARG3)
         IF (arg_3(i3,j3,k3,l3,m3,n3) .EQ. bad_flag(ARG3)) THEN
            err_msg =
     .      'Arg 3, curvilinear Y coordinates, contains missing values'
            GOTO 999
         ENDIF
   30 CONTINUE

      DO 50 n5 = arg_lo_ss(F_AXIS,ARG5), arg_hi_ss(F_AXIS,ARG5)
      DO 50 m5 = arg_lo_ss(E_AXIS,ARG5), arg_hi_ss(E_AXIS,ARG5)
      DO 50 l5 = arg_lo_ss(T_AXIS,ARG5), arg_hi_ss(T_AXIS,ARG5)
      DO 50 k5 = arg_lo_ss(Z_AXIS,ARG5), arg_hi_ss(Z_AXIS,ARG5)
      DO 50 j5 = arg_lo_ss(Y_AXIS,ARG5), arg_hi_ss(Y_AXIS,ARG5)
      DO 50 i5 = arg_lo_ss(X_AXIS,ARG5), arg_hi_ss(X_AXIS,ARG5)
         IF (arg_5(i5,j5,k5,l5,m5,n5) .EQ. bad_flag(ARG5)) THEN
            err_msg =
     .      'Arg 5, sample Y points, contains missing values'
            GOTO 999
         ENDIF
   50 CONTINUE

*  For each (xpt,ypt) pair, search the data arrays arg2,arg3
*  for the nearest higher (x,y) lat-lon coordinates.  Interpolate 
*  arg_1 in 2 directions for the result.

      i4 = arg_lo_ss(X_AXIS,ARG4)
      j4 = arg_lo_ss(Y_AXIS,ARG4)
      k4 = arg_lo_ss(Z_AXIS,ARG4)
      l4 = arg_lo_ss(T_AXIS,ARG4)
      m4 = arg_lo_ss(E_AXIS,ARG4)
      n4 = arg_lo_ss(F_AXIS,ARG4)

      i5 = arg_lo_ss(X_AXIS,ARG5)
      j5 = arg_lo_ss(Y_AXIS,ARG5)
      k5 = arg_lo_ss(Z_AXIS,ARG5)
      l5 = arg_lo_ss(T_AXIS,ARG5)
      m5 = arg_lo_ss(E_AXIS,ARG5)
      n5 = arg_lo_ss(F_AXIS,ARG5)

* Y-axis is normal to the result
      j = res_lo_ss(Y_AXIS)

      DO 700 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

* Find all locations of xpt in arg_2, longitudes of data
* When a change of sign corresponds with crossing a branch cut, that
* is not saved as a location where xpt-minus-coordinate changes sign.

         xadd = 0.
         xpt = arg_4(i4,j4,k4,l4,m4,n4)
         IF (need_modulo .AND. 
     .       ((xpt .LT. xcoordmin) .OR.(xpt .GT. xcoordmax)) )
     .      xadd = add_xcoord

         nloc = 0
         i2 = arg_lo_ss(X_AXIS,ARG2)
	 j2 = arg_lo_ss(Y_AXIS,ARG2)
	 xcoordlast = arg_2(i2,j2,k2,l2,m2,n2) + xadd

         DO 200 j2 = arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS,ARG2)
            i2 = arg_lo_ss(X_AXIS,ARG2)
            xcoord = arg_2(i2,j2,k2,l2,m2,n2) + xadd
            icross = 1
            IF ((xpt - xcoord) .LT. 0.) icross = -1

            DO 100 i2 = arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS,ARG2)
               xcoord = arg_2(i2,j2,k2,l2,m2,n2) + xadd
	       xcoord_diff = ABS(xcoordlast-xcoord)
	       IF (xcoord_diff .GE. tol) icross = -1*icross

               iloc = 1

               IF ((xpt-xcoord) .LT. 0.) iloc = -1

               IF (icross .NE. iloc)THEN
                  nloc = nloc + 1
                  xlocations(nloc,1,1,1,1,1) =
     .                       MAX(i2-1,arg_lo_ss(X_AXIS,ARG2))
                  xlocations(nloc,2,1,1,1,1) = j2
                  icross = 1
                  IF ((xpt - xcoord) .LT. 0.) icross = -1
               ENDIF
	       xcoordlast = xcoord 
  100       CONTINUE

  200    CONTINUE

* Which of those locations is nearest ypt in arg_3, latitudes of data?

         ypt = arg_5(i5,j5,k5,l5,m5,n5)
         ydiff = ABS(bad_flag_result)
         ptloc = 1

         DO 250 iloc = 1, nloc
            i3 = xlocations(iloc,1,1,1,1,1)
            j3 = xlocations(iloc,2,1,1,1,1)

            yd = ABS(ypt - arg_3(i3,j3,k3,l3,m3,n3))
            IF ( yd .LT. ydiff ) THEN
               ylocations(1) = i3
               ylocations(2) = j3
               ydiff = yd
               ptloc = iloc
            ENDIF
  250    CONTINUE

         ibot = xlocations(ptloc,1,1,1,1,1)
         jbot = xlocations(ptloc,2,1,1,1,1)
         IF (ibot .EQ. arg_hi_ss(X_AXIS,ARG1) ) ibot = ibot - 1
         IF (jbot .EQ. arg_hi_ss(Y_AXIS,ARG1) ) jbot = jbot - 1

         itop = ibot + 1
         jtop = jbot + 1

         IF ( ibot .GE. arg_lo_ss(X_AXIS,ARG1) .AND.
     .        itop .LE. arg_hi_ss(X_AXIS,ARG1) .AND.
     .        jbot .GE. arg_lo_ss(Y_AXIS,ARG1) .AND.
     .        jtop .LE. arg_hi_ss(Y_AXIS,ARG1) ) THEN

            xbot = arg_2(ibot,jbot,k2,l2,m2,n2) + xadd
            xtop = arg_2(itop,jbot,k2,l2,m2,n2) + xadd
            xfrac = (xpt - xbot) / (xtop - xbot)

            ybot = arg_3(ibot,jbot,k3,l3,m3,n3)
            ytop = arg_3(ibot,jtop,k3,l3,m3,n3)
            yfrac = (ypt - ybot) / (ytop - ybot)

            n1 = arg_lo_ss(F_AXIS,ARG1)
            DO 600 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)

            m1 = arg_lo_ss(E_AXIS,ARG1)
            DO 500 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)

            l1 = arg_lo_ss(T_AXIS,ARG1)
            DO 400 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

               k1 = arg_lo_ss(Z_AXIS,ARG1)
               DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

                  fbb = arg_1(ibot,jbot,k1,l1,m1,n1)
                  ftb = arg_1(itop,jbot,k1,l1,m1,n1)
                  fbt = arg_1(ibot,jtop,k1,l1,m1,n1)
                  ftt = arg_1(itop,jtop,k1,l1,m1,n1)

                  IF ( fbb .NE. bad_flag(ARG1)  .AND.
     .                 ftb .NE. bad_flag(ARG1)  .AND.
     .                 fbt .NE. bad_flag(ARG1)  .AND.
     .                 ftt .NE. bad_flag(ARG1) ) THEN

*  First interpolate in x, getting values of the fcn at (x,jbot)  and (x,jtop)
                     fxbot = fbb + xfrac * (ftb - fbb)
                     fxtop = fbt + xfrac * (ftt - fbt)

*  Now interpolate in y, getting value at (x,y)
                     result(i,j,k,l,m,n) = fxbot + yfrac*(fxtop-fxbot)
                  ENDIF

                  k1 = k1 + arg_incr(Z_AXIS,ARG1)
 300           CONTINUE

               l1 = l1 + arg_incr(T_AXIS,ARG1)
 400        CONTINUE

               m1 = m1 + arg_incr(E_AXIS,ARG1)
 500        CONTINUE

               n1 = n1 + arg_incr(F_AXIS,ARG1)
 600        CONTINUE

         ENDIF  ! IF (ibot .GE. ...  .AND. itop .LE.  ...

* Only one of the ARG4 and one of the ARG5 actually increments
         i4 = i4 + arg_incr(X_AXIS,ARG4)
         j4 = j4 + arg_incr(Y_AXIS,ARG4)
         k4 = k4 + arg_incr(Z_AXIS,ARG4)
         l4 = l4 + arg_incr(T_AXIS,ARG4)
         m4 = m4 + arg_incr(E_AXIS,ARG4)
         n4 = n4 + arg_incr(F_AXIS,ARG4)

         i5 = i5 + arg_incr(X_AXIS,ARG5)
         j5 = j5 + arg_incr(Y_AXIS,ARG5)
         k5 = k5 + arg_incr(Z_AXIS,ARG5)
         l5 = l5 + arg_incr(T_AXIS,ARG5)
         m5 = m5 + arg_incr(E_AXIS,ARG5)
         n5 = n5 + arg_incr(F_AXIS,ARG5)
 700  CONTINUE

      RETURN

 999  CALL ef_bail_out (id, err_msg)

      END

	SUBROUTINE GET_VAR_CONTEXT
     .		      ( full_var_name, 
     .			default_cx,
     .			var_cx,
     .			status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* given a full variable specification of the form:
*			(eg.) TEMP[X=170E:170W,K=+1D,T=188979]
* return in var_cx context information describing the exact variable instance
* including variable, data set, grid, region and plane

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 10/15/86
* revision 0.1 - 3/23/87 - added new TMAP library: time axes, file var. names,
*						   bad data flag
*			 - context mods from var name applied IN PARSE_VAR_NAME
* revision 0.2 - 5/5/88  - FINISH_CONTEXT_MODS --> FLESH_OUT_CONTEXT
*			   added CONFINE_CONTEXT
* V200:  6/22/89 - eliminated GT_CONTEXT_PLANE
*		 - added oversizing of contexts
*		 - added test for irrelevant data set
* V500: 10/20/98 *jc* - added ADD_RDC_XFORM
* V510: 8/99 *sh* - g=unknown_uvar is allowed now. If happening, then skip
*	final steps of context getting
* V533: 6/01 *sh* - set data type
* V603: 5/07 *acm*  Fix for bug 1475, before confine_axis check cx_by_ss(idim,cx)
*                   If .true. check for transformation reducing range to a pt
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* V685 4/13 *sh* parse the auxiliary regridding context terms ("*aux*"), too
*	         and don't report errors in dependency_tree_mode
* V690 12/13 *sh* bug fix when variable name unrecognized in VTREE mode
* V693 10/14 *acm* fix ticket 2206: If the grid number is a placeholder, don't 
*                 go call flesh_out_axis etc (See the comment in get_context_mods, where
*                 the grid is an encoding of the start/end limits of the regrid spec)
* V695+ 5/15 *sh* report unrecognized aux var unless in dependency_tree_mode

	IMPLICIT NONE

	include	'ferret.parm'
	include	'errmsg.parm'
        include 'tmap_dims.parm'
	include 'xfr_grid.cmn'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'
        include 'xdset_info.cmn_text'
        include 'xdependency_tree.cmn'
	include 'xtm_grid.cmn_text' 
        external xdset_info_data
#        include "tmap_dset.parm"

* calling argument declarations:
	INTEGER		default_cx, var_cx, status
	CHARACTER*(*)	full_var_name

* internal variable declarations:
	LOGICAL		unreported_error
	INTEGER		mods_cx, idim, i, istart, iend, cat, var, iarg,
     .			ignore

* initialize
	unreported_error = .FALSE.
	CALL TRANSFER_CONTEXT ( default_cx, var_cx )

* find a context slot for the modifications that may be attached to the var name
	CALL STACK_PTR_UP ( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	mods_cx = cx_stack_ptr
	CALL INIT_CONTEXT_MODS ( mods_cx )

* get variable and attached modifications
	IF ( dependency_tree_mode ) allowed_err = .TRUE.  ! SHOW VAR/TREE
	CALL PARSE_VAR_NAME ( full_var_name, var_cx, mods_cx, status )
	allowed_err = .FALSE.
	IF ( status .NE. ferr_ok ) THEN
* ... when merely determining a dependency tree unknow var is OK
	   IF ( dependency_tree_mode ) THEN
	      cx_variable(var_cx) = unspecified_int4
	      cx_category(var_cx) = unspecified_int4
	      unreported_error = .TRUE.
	   ELSE
	      GOTO 5000
	   ENDIF
	ENDIF

* in dependency tree mode bail out of implicit grid created by GET_CONTEXT_MODS
	IF ( dependency_tree_mode ) THEN
	   IF (cx_has_impl_grid(var_cx)) THEN
	      IF (cx_impl_grid(var_cx).NE.grd_stk_ptr )
     .				CALL WARN('crptn_get_var_ctxt')
	      grid_name(grd_stk_ptr) = char_init16
	      grd_stk_ptr = grd_stk_ptr + 1
	      cx_has_impl_grid(var_cx) = .FALSE.
	   ENDIF
	ENDIF

* if explicit auxiliary regridding variables were detected, identify them
	IF (cx_naux(var_cx).GT.0 .AND. .NOT.cx_implicit_aux(var_cx)) THEN
	   iarg = 0
* ... cx_naux always matches the number of valid cx_aux_arg_start values
	   DO idim = 1, nferdims
	      IF (cx_aux_arg_start(idim, var_cx) .NE. unspecified_int4) THEN
	         iarg = iarg + 1
	         cx_valid_aux(iarg,var_cx) = .TRUE.
* ... make sure there are no square brackets
* ... sq brtk contents like D= would require hard dependencies on the aux vars
	         DO i = cx_aux_arg_start(idim,var_cx),
     .		        cx_aux_arg_end  (idim,var_cx) 
	            IF (full_var_name(i:i) .EQ. '[') GOTO 5100
                 ENDDO
* ... identify the aux variable name
* ... btw note: cx_aux_arg_start is EQUIV to cx_aux_var. Ditto cx_aux_cat.
	         istart = cx_aux_arg_start(idim,var_cx)
	         iend   = cx_aux_arg_end  (idim,var_cx)
	         CALL FIND_VAR_NAME( cx_data_set(var_cx),
     .				     full_var_name(istart:iend),
     .				     cat,
     .				     var )
	         IF (var .NE. munknown_var_name) THEN
	            cx_aux_cat (idim,var_cx) = cat
	            cx_aux_var (idim,var_cx) = var
	            cx_aux_stat(idim,var_cx) = paux_stat_used
	         ELSEIF ( dependency_tree_mode ) THEN
	            cx_valid_aux(iarg,var_cx) = .FALSE. ! a name not found
	            IF (.NOT. unreported_error) THEN
	               status = ferr_unknown_auxvar
		       unreported_error = .TRUE.
	            ENDIF
	         ELSE
	            GOTO 5200
	         ENDIF	
	      ENDIF
	   ENDDO
	ENDIF
	IF (unreported_error) THEN
	   CALL STACK_PTR_DN(cx_stack_ptr,cx_stack_ptr_base,ignore) ! mods_cx
	   GOTO 5000
	ENDIF

* below here is work that is needed for evaluations;  not for dependency tree
	IF ( dependency_tree_mode ) GOTO 100  ! 12/31

* 8/99 If G=unknown_user_var was given then exit now.
* It is recognizable because the text position is encoded in the grid number.
* This should happen ONLY when this is called from IS_UVAR_GRID
	IF ( cx_unstand_grid(var_cx)
     . .AND. cx_grid(var_cx) .LT. unspecified_int4 ) GOTO 100

* apply the hidden @RDC transform if appropriate
	CALL ADD_RDC_XFORM( var_cx, status)
	IF ( status .NE. ferr_ok ) GOTO 5000

* insert bad data flag for variable
	CALL GET_CONTEXT_BAD_FLAG( var_cx )

* insert data type for variable
	CALL KNOWN_DATA_TYPE( var_cx )

* determine the defining grid
	CALL GET_CONTEXT_GRID ( var_cx, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* can't do more if the grid isn't known
	IF ( cx_grid(var_cx) .LE. unspecified_int4 ) GOTO 100

* data set info may be irrelevant
* indicate that now so memory searches will be correct
	IF ( cx_category(var_cx) .EQ. cat_user_var ) THEN
	   IF ( .NOT.uvar_need_dset(cx_variable(var_cx)) ) THEN
	      cx_data_set(var_cx) = pdset_irrelevant
*  ... flag that all data set info is contained within the variable
	      cx_dset_gvn(var_cx) = .TRUE.
	   ENDIF
	ENDIF

c Fix for bug 1475
c FLESH_OUT_AXIS has a check for whether there is a transformation that
c reduces the range to a point and if so sets cx_by_ss(idim,cx)=.FALSE.

** NOTE: This change causes bug 1748 because then the index range for the
** transform doesn't get checked in confine_context.

* flesh out the context on each axis with grid-related positions
* seeing if cx_by_ss(idim,cx) should really be in effect
	DO 11 idim = 1, nferdims
	   IF ( cx_by_ss(idim,var_cx) ) THEN
              CALL FLESH_OUT_AXIS( idim, var_cx, status )
	      IF ( status .NE. ferr_ok ) GOTO 5000
           ENDIF
 11	CONTINUE

* confine limits to grid
	CALL CONFINE_CONTEXT ( var_cx, status )
	IF ( status .NE. ferr_ok ) GOTO 5000

* flesh out the context on each axis with grid-related positions
	DO 10 idim = 1, nferdims
	   CALL FLESH_OUT_AXIS( idim, var_cx, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
 10	CONTINUE

* enlarge the context ? (contour plots need data extending beyond plot region)
	IF ( cx_ovsiz( var_cx) .NE. ovsiz_off ) CALL OVSIZ_CX( var_cx )

* relinquish the stack space used for the modifications
 100	CALL STACK_PTR_DN ( cx_stack_ptr, cx_stack_ptr_base, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	RETURN

* error exit
 5000	RETURN

 5100	CALL ERRMSG( ferr_syntax, status,
     .          'square bracket modifiers may not be used with '//
     .          'auxiliary regridding variables:'//pCR
     .		//full_var_name, *5000 )

 5200	CALL ERRMSG( ferr_unknown_auxvar, status,
     .          'regridding variable "'//
     .		full_var_name(istart:iend)//
     .          '" in '//full_var_name, *5000 )

	END

	SUBROUTINE DIAG_OP( doing, act_class, cx, idim )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* write a diagnostic line describing the operation in progress

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V200:  6/6/89 - extracted from IS_STRIP
* V230: 8/22/92 - document regridding transformation
*       11/4/92 - expanded user variable name length
* v320:   12/94 - added modulo reading as a stack operation
*      12/29/94 - use SPLIT_LIST to redirect tty output for GUI
*	2/21/95 - added isact_reverse 
* V420   9/8/95 - support for implicit grid allocation/deallocation
*	  11/95 - support for context reconciliation (isact_class_reconcile)
*	   1/96 - bug fix: implicit grid kludge use of cx for gridnum crashes
*		- use "strip" to determine if reconcilliation axis is relevant
* V500 *kob* 3/99- up VAR_CODE and var decls from 8 to 64 chars
* V510 *sh* 8/99 - added isact_class_sample
* V541 *sh*  2/02 - added isact_class_subspan_fill
* V552 *acm* 4/03- up VAR_CODE decl from 64 to 128 chars
* v552 *acm* 4/03  up VAR_TRANS to 150 characters (variables are up to 128, plus
*                  space for the transformation specifier)
* V64  10/09 *acm* longer string length for grid_name: limit length written to diag output
* V680  5/12 *acm* Add dataset ID to diagnostic output
* V680  6/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V6.8  acm  6/12 Implement mode_6d_lab, set by default. If cancelled, the 
*                 output will not list info for E,F dimensions.
* V690  1/14 *sh* report 3-argument var-getting operation
*		  allow for "false 1 point" regridding
* V7    acm  6/16 Ticket 2437: Deprecating mode_6d_lab. 
*		  Adjust output to 6-D or 4-D grids
* V701  acm  7/16 Avoid writing nulls when changing from 6-D to 4-D output
* V702 *sh* 11/16 report gathering on compressed axis
* V702  sh   1/17 Output total_mem along with gather diagnostics
*                 Increase field sizes for long axes


* calling argument declarations:
        IMPLICIT NONE
	INTEGER	act_class, idim, cx
	CHARACTER*(*) doing

* internal variable declarations:
	LOGICAL	FOUR_D_GRID
	INTEGER	TM_LENSTR1, CGRID_SIZE,
     .		slen, clen, ii, i, listdims, chunk_size
	INTEGER*8 available_mem
	CHARACTER*3   ALG_TRANS_CODE
	CHARACTER*128 VAR_CODE,  var
	CHARACTER*150 VAR_TRANS, out_buff

	include	'tmap_dims.parm'
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'interp_stack.parm'
	include	'xvariables.cmn'
	include	'xcontext.cmn'
	include	'xprog_state.cmn'
	include	'xtext_info.cmn'
        include 'xalgebra.cmn'
	include 'xrisc.cmn'		! 12/94 SPLIT_LIST buffer

	listdims = nferdims
	IF ( .NOT. mode_6d_lab) listdims = 4

* initialize
! 1/96 - kludge of using cx for grid # causes this extra IF -- awful!
	IF( act_class .NE. isact_class_impl_grid ) THEN
	   var = VAR_CODE( cx_category(cx), cx_variable(cx) )
           slen = TM_LENSTR1( var )
	ENDIF

* TRANSFORMATION
* output: "VAR_NAME[x=lo:hi@TRN:n,D=#]"
	risc_buff = ' '
	IF ( act_class .EQ. isact_class_trans ) THEN
	   out_buff = VAR_TRANS(idim,cx,slen)
	   WRITE( risc_buff, 3010 ) doing, out_buff(:slen)
 3010      FORMAT (1X,A5,' --> ',A)
	   CALL SPLIT_LIST(pttmode_ops, ttout_lun, risc_buff, 0 )

* REGRIDDING (4/14 - incl false 1pt regridding)
	ELSEIF( act_class .EQ. isact_class_regrid ) THEN
	   IF (cx_aux_stat(idim,cx) .EQ. paux_stat_false_1pt_regrid ) THEN
	      WRITE ( risc_buff, 3019 ) doing,
     .		       var(1:slen),
     .		       ww_dim_name(idim),
     .                 alg_regrid_code(cx_regrid_trans(idim,cx))
 3019	      FORMAT (1X,A5,' false regrid of ',A,' --> ',A1,'@',A)
	   ELSE
	      WRITE ( risc_buff, 3020 ) doing, ww_dim_name(idim),
     .		       var(1:slen), grid_name(cx_grid(cx))(:16),
     .                 alg_regrid_code(cx_regrid_trans(idim,cx))
 3020	      FORMAT (1X,A5,' regrid on ',A1,': ',A,' --> ',A,' @',A)
	   ENDIF
	   CALL SPLIT_LIST(pttmode_ops, ttout_lun, risc_buff, 0 )

* SPLITTING/GATHERING
	ELSEIF( act_class .EQ. isact_class_gather ) THEN
	   chunk_size = CGRID_SIZE(cx)
	   available_mem = max_mem_allowed-(permanent_mem+essential_mem)
	   WRITE ( risc_buff, 3030 ) doing, var(1:slen),
     .                  ww_dim_name( idim ),
     .			cx_lo_ss(cx,idim), cx_hi_ss(cx,idim),
     .			cx_data_set(cx), chunk_size, available_mem
 3030	   FORMAT
     . (1X,A5,' gathering ',A,' on ',A1,' axis:',2I9,' dset:',I4, 
     .  I14,'=request', I14, '=availableMem')
	   CALL SPLIT_LIST(pttmode_ops, ttout_lun, risc_buff, 0 )

* COMPRESSED AXIS SPLITTING/GATHERING
	ELSEIF( act_class .EQ. isact_class_cmp_gather_dummy ) THEN
	   chunk_size = CGRID_SIZE(cx)
	   available_mem = max_mem_allowed-(permanent_mem+essential_mem)
	   WRITE ( risc_buff, 3031 ) doing, var(1:slen),
     .                  ww_dim_name( idim ),
     .			cx_lo_ss(cx,idim), cx_hi_ss(cx,idim),
     .			cx_data_set(cx), chunk_size, available_mem
 3031	   FORMAT
     . (1X,A5,' gather/compress ',A,' on ',A1,' axis:',2I9,' dset:',I4, 
     .  I14,'=request', I14, '=availableMem')
	   CALL SPLIT_LIST(pttmode_ops, ttout_lun, risc_buff, 0 )

* SAMPLING (SAMPLE* functions)
	ELSEIF( act_class .EQ. isact_class_sample ) THEN
	   WRITE ( risc_buff, 3035 ) doing, var(1:slen),
     .                  ss_dim_name( idim ),
     .			cx_lo_ss(cx,idim), cx_hi_ss(cx,idim),
     .			cx_data_set(cx)
 3035	   FORMAT
     . (1X,A5,' sampling ',A,' on ',A1,' axis:',2I9,' dset:',I4)
	   CALL SPLIT_LIST(pttmode_ops, ttout_lun, risc_buff, 0 )

* ASSEMBLING MODULO COMPONENTS
	ELSEIF( act_class .EQ. isact_class_modulo ) THEN
	   WRITE ( risc_buff, 3040 ) doing, var(1:slen),
     .                  ww_dim_name( idim ),
     .			cx_lo_ss(cx,idim), cx_hi_ss(cx,idim),
     .			cx_data_set(cx)
 3040	   FORMAT 
     . (1X,A5,' moduloing ',A,' on ',A1,' axis:',2I9,' dset:',I4)
	   CALL SPLIT_LIST(pttmode_ops, ttout_lun, risc_buff, 0 )

* reversed axis reads
	ELSEIF( act_class .EQ. isact_class_reverse ) THEN
	   WRITE ( risc_buff, 3050 ) doing, var(1:slen),
     .                  ww_dim_name( idim ),
     .			cx_lo_ss(cx,idim), cx_hi_ss(cx,idim),
     .			cx_data_set(cx)
 3050	   FORMAT
     . (1X,A5,' reversing ',A,' on ',A1,' axis:',2I9,' dset:',I4)
	   CALL SPLIT_LIST(pttmode_ops, ttout_lun, risc_buff, 0 )

* implicit grid allocation/deallocation
	ELSEIF( act_class .EQ. isact_class_impl_grid ) THEN
* ... special case: "cx" is actually the grid number !!!

	   IF ( FOUR_D_GRID(cx) ) listdims = 4
	   DO 500 ii = 1, listdims
	      i = grid_line(ii,cx)
	      IF ( i .GT. 0 ) THEN
	         WRITE (out_buff((ii-1)*10+1:ii*10),'(A)') line_name(i)(:10)
	      ELSEIF ( i .EQ. 0 ) THEN
	         WRITE (out_buff((ii-1)*10+1:ii*10),'(A)') 'NORMAL    '
	      ELSE
	         out_buff((ii-1)*10+1:ii*10) = '(invalid) '
	      ENDIF
 500	   CONTINUE

	   IF (listdims .EQ. 6)
     .	     WRITE ( risc_buff, 3060 ) doing, grid_name(cx)(:16), 
     .	           out_buff(:60)
	   IF (listdims .EQ. 4)
     .	     WRITE ( risc_buff, 3060 ) doing, grid_name(cx)(:16), 
     .	           out_buff(:40)

 3060	   FORMAT (1X,A,' dynamic grid ',2A)
	   CALL SPLIT_LIST(pttmode_ops, ttout_lun, risc_buff, 0 )

	ELSEIF( act_class .EQ. isact_class_reconcile ) THEN
	   IF ( doing .EQ. 'strip' ) THEN
* ... idim has no meaningful value when stripping reconciliation
	      out_buff = ' '
	      clen = 1
	   ELSE
	      out_buff = ' on '//ww_dim_name(idim)//' axis'
	      clen = 10
	   ENDIF
	   WRITE ( risc_buff, 3070 ) doing, out_buff(:clen),
     .				     var(1:slen)
 3070	   FORMAT (1X,A5,' limits reconciliation',A,': ',A)
	   CALL SPLIT_LIST(pttmode_ops, ttout_lun, risc_buff, 0 )

* subspan modulo axis void filling
	ELSEIF( act_class .EQ. isact_class_subspan_fill ) THEN
	   WRITE ( risc_buff, 3080 ) doing, var(1:slen),
     .                  ww_dim_name( idim ),
     .			cx_lo_ss(cx,idim), cx_hi_ss(cx,idim),
     .			cx_data_set(cx)
 3080	   FORMAT 
     . (1X,A5,' modulo-void-filling ',A,' on ',A1,' axis:',2I9,' dset:',I4)
	   CALL SPLIT_LIST(pttmode_ops, ttout_lun, risc_buff, 0 )


* SPLITTING/GATHERING
	ELSEIF( act_class .EQ. isact_class_aggregate_gather ) THEN
	   WRITE ( risc_buff, 3090 ) doing, var(1:slen),
     .                  ww_dim_name( idim ),
     .			cx_lo_ss(cx,idim), cx_hi_ss(cx,idim),
     .			cx_data_set(cx)
 3090	   FORMAT
     . (1X,A5,' aggregate gathering ',A,' on ',A1,' axis:',2I9,' dset:',I4)
	   CALL SPLIT_LIST(pttmode_ops, ttout_lun, risc_buff, 0 )

* getting arguments needed for curvilinear plotting
	ELSEIF( act_class .EQ. isact_class_aux_plot_vars ) THEN
	   WRITE ( risc_buff, 3100 ) doing, var(1:slen),
     .                  ww_dim_name( idim ),
     .			cx_lo_ss(cx,idim), cx_hi_ss(cx,idim),
     .			cx_data_set(cx)
 3100	   FORMAT
     . (1X,A5,' getting aux vars ',A,' on ',A1,' axis:',2I9,' dset:',I4)
	   CALL SPLIT_LIST(pttmode_ops, ttout_lun, risc_buff, 0 )

	ELSE
	   CALL WARN( 'CORRUPTION!  unkn_act_cls' )

	ENDIF

	RETURN
	END

******************************************************************
*
*           RR_cross_spectrum_abs.F
*
*             Rick Romea   Oct.8, 2000
*
*
* Cross-spectral program
*
* INPUT:
* arg_1  X1 (I, J, L=1:N) Real time series 1 		
* arg_2  X2 (I, J, L=1:N) Real time series 2	
* arg_3  Nf   Number of frequencies per band 	 
* arg_4  P    Percentage level for significance (90, 95 or 99)
*
*        handed along:  Number of data points N
*       		Sampling interval of data points
*
* OUTPUT:  ANSWER (I,J,K=1:11,L=1:Nb)
*
* ANSWER (I,J,K=1,L=Nb)	 Power in  band1	         
* ANSWER (I,J,K=2,L=Nb)	 Power in band2	                 
* ANSWER (I,J,K=3,L=Nb)	 Series 1: Upper confidence level	
* ANSWER (I,J,K=4,L=Nb)  Series 1: Lower confidence level	
* ANSWER (I,J,K=5,L=Nb)	 Series 2: Upper confidence level	
* ANSWER (I,J,K=6,L=Nb)	 Series 2: Lower confidence level	
* ANSWER (I,J,K=7,L=Nb)  Coherence-squared in each band	
* ANSWER (I,J,K=8,L=Nb)  Phase in each band 	
* ANSWER (I,J,K=9,L=Nb) Significant coherence squared
* ANSWER (I,J,K=10,L=Nb) Upper confidence level for phase
* ANSWER (I,J,K=11,L=Nb) Lower confidence level for phase
*
*       handed along: 	Number of bands	 Nb
*                       frequency axis
*
******************************************************************

      SUBROUTINE RR_cross_spectrum_abs_init(id)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id

      PRINT*,'START INIT'

      CALL ef_set_desc(id,'Computes auto and cross-spectrum')
      CALL ef_set_num_args(id,4)
 
      ! x and y unchanged
      ! on output:  z-axis is ABSTRACT:  has k=1:12
      ! on output:  t-axis is CUSTOM: converted to frequency axis

      CALL ef_set_axis_inheritance(id,
     .   IMPLIED_BY_ARGS,IMPLIED_BY_ARGS,ABSTRACT, ABSTRACT)   
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      !  Set a work array

      CALL ef_set_num_work_arrays  (id, 8)

      ! Describe the input arguments

      ! arg_1  X1 (I, J, L=1:N) Real time series 1 		

      CALL ef_set_arg_name         (id, ARG1, 'S1')
      CALL ef_set_arg_desc         (id, ARG1, 'Series 1')
      CALL ef_set_arg_unit         (id, ARG1, ' ')
      CALL ef_set_arg_type         (id, ARG1, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG1, YES,YES,NO,NO)

      ! arg_2  X2 (I, J, L=1:N) Real time series 2	

      CALL ef_set_arg_name         (id, ARG2, 'S2')
      CALL ef_set_arg_desc         (id, ARG2, 'Series 2')
      CALL ef_set_arg_unit         (id, ARG2, ' ')
      CALL ef_set_arg_type         (id, ARG2, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2, YES,YES,NO,NO)

      ! arg_3  Nf Number of frequencies per band 	 
      !  scalar
      
      CALL ef_set_arg_name         (id, ARG3, 'Nf')
      CALL ef_set_arg_desc         (id, ARG3, 
     .                  'Number of frequencies per band')
      CALL ef_set_arg_unit         (id, ARG3, ' ')
      CALL ef_set_arg_type         (id, ARG3, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG3, NO,NO,NO,NO)

      ! arg_4  P  Percentage level for significance (90, 95 or 99)
      !  scalar

      CALL ef_set_arg_name         (id, ARG4, 'P')
      CALL ef_set_arg_desc         (id, ARG4,
     .       'Percentage level for significance (90, 95 or 99)')
      CALL ef_set_arg_unit         (id, ARG4, ' ') 
      CALL ef_set_arg_type         (id, ARG4, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG4, NO,NO,NO,NO)

      PRINT*,'INIT DONE'
 
      END


C************************************************************************

      SUBROUTINE  RR_cross_spectrum_abs_work_size(id)
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'
      INTEGER id
      INTEGER Npts
      INTEGER arg_lo_ss(4,EF_MAX_ARGS),arg_hi_ss(4,EF_MAX_ARGS),
     .                                 arg_incr(4,EF_MAX_ARGS)


      PRINT*,'START WORK_SIZE'
       
      !  Get the number of points in the time series = Npts

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr) 
      Npts = arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1) + 1 

      PRINT*,'NPTS = ',Npts

      ! ef_set_work_array_dims(id,iarray,xlo,ylo,zlo,tlo,xhi,yhi,zhi,thi) 
      CALL ef_set_work_array_dims(id,1,1,1,1,1,1,1,1,4*Npts+1) 
      CALL ef_set_work_array_dims(id,2,1,1,1,1,1,1,1,Npts) 
      CALL ef_set_work_array_dims(id,3,1,1,1,1,1,1,1,Npts) 
      CALL ef_set_work_array_dims(id,4,1,1,1,1,1,1,1,Npts) 
      CALL ef_set_work_array_dims(id,5,1,1,1,1,1,1,1,Npts) 
      CALL ef_set_work_array_dims(id,6,1,1,1,1,1,1,1,Npts) 
      CALL ef_set_work_array_dims(id,7,1,1,1,1,1,1,1,Npts) 
      CALL ef_set_work_array_dims(id,8,1,1,1,1,1,1,1,2*Npts) 
      
      PRINT*,'END WORK_SIZE'
      END



C****************************************************************

      SUBROUTINE RR_cross_spectrum_abs_result_limits(id)
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'
      INTEGER id

      INTEGER arg_lo_ss(4,EF_MAX_ARGS), 
     .        arg_hi_ss(4,EF_MAX_ARGS),
     .         arg_incr(4,EF_MAX_ARGS)

      INTEGER Nb,Npts,Nf
      REAL    rNf


      PRINT*,'START RESULT_LIMITS'

      ! TIME AXIS

         !  Get the (integer) number of frequencies per band = Nf.

         CALL ef_get_one_val(id, ARG3, rNf)  
         Nf=NINT(rNf)

      PRINT*,'Nf = ',Nf

         !  Get the number of points in the time series = Npts.

         CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr) 

         Npts = arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1) + 1 
     
      PRINT*,'NPTS = ',Npts


         ! Number of bands

         Nb = Npts/(2*Nf)

      PRINT*,'Nb = ',Nb

         CALL ef_set_axis_limits(id, T_AXIS, 1, Nb)

      ! ABSTRACT Z AXIS

         CALL ef_set_axis_limits(id, Z_AXIS, 1, 11)

      PRINT*,'END RESULT_LIMITS'

      END

C************************************************************

      SUBROUTINE RR_cross_spectrum_abs_compute(id,S1,S2,arg_3,arg_4,
     .                                ANSWER,WSAVE,a1,a2,b1,b2,X1,X2,C)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'
      INTEGER id
      REAL S1  (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .          mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL S2  (mem2lox:mem2hix, mem2loy:mem1hiy, 
     .          mem2loz:mem2hiz, mem2lot:mem1hit)
      REAL arg_3(mem3lox:mem3hix, mem3loy:mem3hiy, 
     .          mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL arg_4  (mem4lox:mem4hix, mem4loy:mem4hiy, 
     .          mem4loz:mem4hiz, mem4lot:mem4hit)
      REAL ANSWER (memreslox:memreshix, memresloy:memreshiy, 
     .             memresloz:memreshiz, memreslot:memreshit)
      INTEGER  res_lo_ss (4)
      INTEGER  res_hi_ss (4)
      INTEGER  res_incr  (4)

      INTEGER  arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER  arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER  arg_incr  (4,EF_MAX_ARGS)

      INTEGER i,  j,  l
      INTEGER i1, j1, l1
      INTEGER i2, j2, l2

      REAL    WSAVE(wrk1lot:wrk1hit)
      REAL       a1(wrk2lot:wrk2hit)
      REAL       b1(wrk3lot:wrk3hit)
      REAL       a2(wrk4lot:wrk4hit)
      REAL       b2(wrk5lot:wrk5hit)
      REAL       X1(wrk6lot:wrk6hit)
      REAL       X2(wrk7lot:wrk7hit)
      COMPLEX     C(wrk8lot:wrk8hit)

      INTEGER Npts,Nf,Nb,kk
      REAL rNf,alpha,P,Coh2sig,lower,upper,PP,QQ,theta,GetStudentT  
      EXTERNAL GetStudentT

      PRINT*,'START COMPUTE'

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
         
      !  Get the number of points in the time series = Npts.

      Npts = arg_hi_ss(T_AXIS,ARG1) - arg_lo_ss(T_AXIS,ARG1) + 1 


      PRINT*,'NPTS = ',Npts

      !  Get the (integer) number of frequencies per band = Nf.

      CALL ef_get_one_val(id, ARG3, rNf)  
      Nf=NINT(rNf)
         
      PRINT*,'Nf = ',Nf

      ! Number of bands

      Nb = Npts/(2*Nf)


      PRINT*,'Nb = ',Nb

      ! Set up the cosine matrix

      PRINT*,'START CFFTI'

      CALL CFFTI(Npts,WSAVE)

      PRINT*,'END CFFTI'

      !  Significance level for coherence at P% with 2*Nf degrees of freedom
      !  Ref: R.O.R.Y.Thompson, Coherence Significance Levels, AMS, 1979

      CALL ef_get_one_val(id, ARG4, P)  
      alpha = 1.-P/100.
      Coh2sig= 1.-alpha**(1./FLOAT(Nf-1))


      !  Confidence intervals for the power spectral estimates
      !
      !   IF Gxx is the 'true' autospectral value, based on the 
      !    band-averaged estimate <Gxx>, 
      !    then, for Nf number of frequencies in band, 
      !    we can say with P certainty that
      !
      !  lower * <Gxx>  <=  Gxx  <=  upper * <Gxx> 
      !
      !       (Bendat & Piersol, p.286)  

      PRINT*,'START Confindence Intervals'
      
      CALL SpectralConfidenceIntervals(Nf,NINT(P),lower,upper)

      PRINT*,'lower = ',lower
      PRINT*,'upper = ',upper

      ! START

      i1 = arg_lo_ss(X_AXIS,ARG1)
      i2 = arg_lo_ss(X_AXIS,ARG2)
      DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
        j1 = arg_lo_ss(Y_AXIS,ARG1)
        j2 = arg_lo_ss(Y_AXIS,ARG2)
        DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

           ! Copy the arrays
           
           l=1 
           DO l1=arg_lo_ss(T_AXIS,ARG1),arg_hi_ss(T_AXIS,ARG1)
              X1(l)=S1(i1,j1,1,l1)
              l=l+1
           ENDDO
            
           l=1 
           DO l2=arg_lo_ss(T_AXIS,ARG2),arg_hi_ss(T_AXIS,ARG2)
              X2(l)=S1(i2,j2,1,l2)
              l=l+1
           ENDDO

           ! Compute the raw spectral estimates

           PRINT*,'FFT - 1'

           CALL FFTreal(Npts,X1,a1,b1,WSAVE,C)

           PRINT*,'FFT - 2'

           CALL FFTreal(Npts,X2,a2,b2,WSAVE,C)

           ! Compute the auto-spectra, coherence-squared and the phase
          
           ! Band average


           PRINT*, 'START BAND AVERAGE'

           DO L=1,Nb
	      ANSWER(I,J,1,L)=0.  
	      ANSWER(I,J,2,L)=0.  
	      PP=0.  
	      QQ=0. 	
 
               DO kk=2+(L-1)*Nf,L*Nf+1
                   ANSWER(I,J,1,L) = ANSWER(I,J,1,L)
     .                        + a1(kk)*a1(kk) + b1(kk)*b1(kk)
	   	   ANSWER(I,J,2,L) = ANSWER(I,J,2,L)
     .                        + a2(kk)*a2(kk) + b2(kk)*b2(kk)
                   PP = PP + a1(kk)*a2(kk) + b1(kk)*b2(kk)
                   QQ = QQ + a2(kk)*b1(kk) - a1(kk)*b2(kk)

	       ENDDO

               !  Power spectrum for Series 1
   	      
               ANSWER(I,J,1,L) = 4.*ANSWER(I,J,1,L)/FLOAT(Nf)

               !  Power spectrum for Series 2	

               ANSWER(I,J,2,L) = 4.*ANSWER(I,J,2,L)/FLOAT(Nf)
   	      

               PP = 4.*PP/FLOAT(Nf)
   	       QQ = 4.*QQ/FLOAT(Nf)

               !  Coherence-squared in each band

	       ANSWER(I,J,7,L) = (PP*PP+QQ*QQ)
     .                     / (ANSWER(I,J,1,L)*ANSWER(I,J,2,L))

                !  Phase in each band 

	        IF(QQ.EQ.0..AND.PP.EQ.0.)THEN
	           ANSWER(I,J,8,L)=0.
	        ELSE
	           ANSWER(I,J,8,L)=ATAN2(-QQ,PP)
	        ENDIF

                ! Compute significant coherence in each band 
	        ! (currently constant for constant Nf)

                ANSWER(I,J,9,L)=Coh2sig 

                ! Compute Confidence limits for the phase
                ! theta = +- phase error (rad) at P significance 
	        !         with 2*Nf degrees of freedom
	        ! (P.285 Koopmans .The Spectral Analysis of Time Series)
                
                IF(ANSWER(I,J,7,L).EQ.0.)THEN
                  theta=3.14159              
                ELSE
                  theta = ASIN(  SQRT(  (1.-ANSWER(I,J,7,L)) / 
     .                                    ANSWER(I,J,7,L) / 
     .                                     FLOAT(2*Nf-2)   )
     .                * GetStudentT(NINT(P),Nf)   )  
                ENDIF
                ANSWER (I,J,10,L) = ANSWER(I,J,8,L)+theta ! Upper confidence level for phase
                ANSWER (I,J,11,L) = ANSWER(I,J,8,L)-theta ! Lower confidence level for phase

                ! Confidence levels on the autospectrum 

                ANSWER (I,J,3,L) = upper*ANSWER(I,J,1,L) ! Series 1: Upper confidence level	
                ANSWER (I,J,4,L) = lower*ANSWER(I,J,1,L) ! Series 1: Lower confidence level	
                ANSWER (I,J,5,L) = upper*ANSWER(I,J,2,L) ! Series 2: Upper confidence level	
                ANSWER (I,J,6,L) = lower*ANSWER(I,J,2,L) ! Series 2: Lower confidence level	

                PRINT*, 'END BAND AVERAGE'

	   ENDDO

           j1 = j1 + arg_incr(Y_AXIS,ARG1)
           j2 = j2 + arg_incr(Y_AXIS,ARG2) 
         ENDDO
         i1 = i1 + arg_incr(X_AXIS,ARG1)
         i2 = i2 + arg_incr(X_AXIS,ARG2)
      ENDDO
      END


	!******************************************
	!
	!  Confidence intervals for the power spectral estimates
	!
	!******************************************
	! 
        ! Nf = number of frequencys in band	(input)
	! P  = percent level for significance (eg 90,95 0r 99 ) INPUT
	! lower = lower bound (output)
	! upper = upper bound (output)
	!
        !   IF Gxx is the 'true' autospectral value, based on the 
	!    band-averaged estimate <Gxx>, 
	!    then, for Nf number of frequencys in band,
	!    we can say with 90% certainty that
	!
        !  lower * <Gxx>  <=  Gxx  <=  upper * <Gxx> 
	!
	!  lower = df/chi squared (df,alpha/2)
	!  upper = df/chi squared (df,1-alpha/2)
	!
        ! df = degrees of freedom = 2*number of frequencys in band
	!
	! chi squared (n,alpha/2) -->  P=100*(1-alpha)
	!
	!  P  	alpha	alpha/2	 1-alpha/2
	!  90    0.1     0.05	   0.95
	!  95    0.05	 0.025	   0.975
	!  99	 0.01	 0.005	   0.995
	!
	! Bendat & Piersol, p.286
	! Bendat & Piersol, p.524 (table)

      SUBROUTINE SpectralConfidenceIntervals(Nf,P,lower,upper)
      IMPLICIT NONE
      INTEGER Nf,P,df
      REAL lower,upper
	
	!   P  	alpha	alpha/2	 1-alpha/2
	!  90    0.1     0.05	   0.95
	!  95    0.05	 0.025	   0.975
	!  99	 0.01	 0.005	   0.995
      
      REAL chi_05(15) 
      REAL chi_025(15)	  
      REAL chi_005(15)
      REAL chi_95(15)	  
      REAL chi_975(15)  
      REAL chi_995(15)  
	
      DATA chi_005 /10.6,14.86,18.55,21.96,25.19,28.3,31.3,34.27,37.16,
     .               40.,42.8,45.56,48.29,50.99,53.67/		  
      DATA chi_025 /7.38,11.14,14.45,17.53,20.48,23.34,26.12,28.85,
     .               31.53,34.17,36.78,39.36,41.92,44.46,46.98/	  
      DATA chi_05 /5.99,9.49,12.59,15.51,18.31,21.03,23.68,26.30,28.87,
     .             31.41,33.92,36.42,38.88,41.34,43.77/
      DATA chi_95 /.103,.711,1.64,2.73,3.94,5.23,6.57,7.96,8.39,10.85,
     .             12.34,13.85,15.38,16.93,18.49/
      DATA chi_975 /.0506,.484,1.24,2.18,3.25,4.4,5.63,6.91,8.23,9.59,
     .              10.98,12.4,13.84,15.31,16.79/
      DATA chi_995 /.01,.207,.676,1.34,2.16,3.07,4.07,5.14,6.26,7.43,
     .              8.64,9.89,11.16,12.46,13.79/

       df=Nf*2

	IF(df.GT.100)THEN
	  IF(P.EQ.90)THEN 
	    lower=FLOAT(df)/146.57
          upper=FLOAT(df)/95.7
        ELSEIF(P.EQ.95)THEN
		lower=FLOAT(df)/152.21
          upper=FLOAT(df)/91.58
	  ELSE  !  P.EQ.99
	  	lower=FLOAT(df)/163.65
          upper=FLOAT(df)/83.85
	  ENDIF
	ELSEIF(df.GT.50)THEN
	  IF(P.EQ.90)THEN
        	lower=FLOAT(df)/79.08
          upper=FLOAT(df)/43.19
        ELSEIF(P.EQ.95)THEN
	   	lower=FLOAT(df)/83.8
          upper=FLOAT(df)/40.48
	  ELSE  !  P.EQ.99
	   	lower=FLOAT(df)/91.95
          upper=FLOAT(df)/35.53
	  ENDIF
	ELSEIF(df.GT.30)THEN
	  IF(P.EQ.90)THEN
	   	lower=FLOAT(df)/55.76
          upper=FLOAT(df)/26.51
        ELSEIF(P.EQ.95)THEN
	   	lower=FLOAT(df)/59.34
          upper=FLOAT(df)/24.43
	  ELSE  !  P.EQ.99
	   	lower=FLOAT(df)/66.77
          upper=FLOAT(df)/20.71
	  ENDIF
	ELSE ! df <= 30
	  IF(P.EQ.90)THEN
	   	lower=FLOAT(df)/chi_05(Nf)
          upper=FLOAT(df)/chi_95(Nf)
        ELSEIF(P.EQ.95)THEN
	   	lower=FLOAT(df)/chi_025(Nf)
          upper=FLOAT(df)/chi_975(Nf)
	  ELSE  !  P.EQ.99
	   	lower=FLOAT(df)/chi_005(Nf)
          upper=FLOAT(df)/chi_995(Nf)
	  ENDIF
	ENDIF
	END

	!******************************************
	! 
	! Get the upper cutoff point of the Student T distribution 
	! (P.341 Koopmans .The Spectral Analysis of Time Series)
	!
	!******************************************
	   
	REAL FUNCTION GetStudentT(P,Nf)
        IMPLICIT NONE
	INTEGER Nf,P,df  
	REAL ST_90(15)
	REAL ST_95(15)
	REAL ST_99(15)
	REAL T
	DATA ST_90/2.92,2.132,1.943,1.86,1.812,1.782,1.761,1.746,
     .           1.734,1.725,1.717,1.711,1.706,1.701,1.697/
	DATA ST_95/4.303,2.776,2.447,2.306,2.228,2.179,2.145,2.12,
     .           2.101,2.086,2.074,2.064,2.056,2.048,2.042/
  	DATA ST_99/9.925,4.604,3.707,3.355,3.169,3.055,2.977,2.921,
     .           2.878,2.845,2.819,2.797,2.779,2.763,2.75/

	IF(P.NE.90.AND.P.NE.95.AND.P.NE.99)THEN
           P=90 
	   WRITE(6,*)'WARNING::P must be 90,95 or 99' 
           WRITE(6,*)'         in SUBROUTINE PhaseConfidenceLimits'
           WRITE(6,*)'  '
           WRITE(6,*)'P set to 90%'
	ENDIF
 
        df=Nf*2

	IF(df.GT.120)THEN
     	  IF(P.EQ.90)THEN
		T=1.645
          ELSEIF(P.EQ.95)THEN
		T=1.96
	  ELSE  !  P.EQ.99
		T=2.576
	  ENDIF
	ELSEIF(df.GT.80)THEN
	  IF(P.EQ.90)THEN
		T=1.658
          ELSEIF(P.EQ.95)THEN
		T=1.98
	  ELSE  !  P.EQ.99
		T=2.617
	  ENDIF
	ELSEIF(df.GT.50)THEN
	  IF(P.EQ.90)THEN
		T=1.671
          ELSEIF(P.EQ.95)THEN
		T=2.
	  ELSE  !  P.EQ.99
		T=2.66
	  ENDIF
	ELSEIF(df.GT.30)THEN
	  IF(P.EQ.90)THEN
		T=1.684
          ELSEIF(P.EQ.95)THEN
		T=2.021
	  ELSE  !  P.EQ.99
		T=2.704
	  ENDIF
	ELSE ! df <= 30
	  IF(P.EQ.90)THEN
	    T=ST_90(Nf)
        ELSEIF(P.EQ.95)THEN
	    T=ST_95(Nf)
	  ELSE  !  P.EQ.99
	    T=ST_99(Nf)
	  ENDIF
	ENDIF
	GetStudentT=T
	END


        !******************************************
	!
	! FFT OF A REAL PERIODIC SEQUENCE
	! 
	!******************************************
     	!
        !   N         = number of data points (input)
	!   X(N)      = real input time series	(input)
	!   a(N),b(N) = normalized Fourier coefficients (output)
	!
	!  Spectral estimates are:  S(k) = a(k) + i b(k)
	!
	!                                     i = sqrt(-1)
	!
	!
	!            S(k)=THE SUM FROM n=1,...,N OF
	!  
        !                X(n)/N*EXP(-2*PI*i*k*n/N)
	!		   so:
	!                a(k) = (1/N) * THE SUM FROM n=1,...,N OF
	!		              X(n) * cos(2*PI*k*n/N) 
	!	
	!		 b(k) = (1/N) * THE SUM FROM n=1,...,N OF  
	!                           - X(n) * sin(2*PI*k*n/N)	
	!
	! T = N dt  is the fundamental period
	! 
        ! Frequencies are: f(k) = (k-1)/T  ;  k=1,..,N
	! 
	! Frequency interval between spectral estimates: 
	!
	!            df = 1/T  = 1/(N dt)
	!
	! Nyquist frequency is at: 
	!
	!            Nyquist = 1/(2dt) = N/(2T); k = N/2 + 1
	!
	!           So:  S[1] = mean of the time series
	!                S[2] = S[N]
	!                S[3] = S[N-1]
	!                S[k] = S[N-k+1]
	!
	!           Note: S[(N/2+1] is set = 0
	!               
	SUBROUTINE FFTreal(Nin,X,a,b,WSAVE,C)
	IMPLICIT NONE
	INTEGER Nin,N,i
	REAL X(*),a(*),b(*),WSAVE(*)
	COMPLEX C(*)

        ! Check if N is even

	IF(MOD(Nin,2).EQ.0)THEN
	  N=Nin
	ELSE
	  N=Nin-1
	ENDIF
	
	! load complex array

	DO i=1,N
	  C(i)=CMPLX(X(i),0.)
	ENDDO

	! Compute the transform

	CALL CFFTF(N,C,WSAVE)

	! load and normalize the a and b arrays

	DO i=1,N
	  a(i)=REAL(C(i))/FLOAT(N)
	  b(i)=AIMAG(C(i))/FLOAT(N)
	ENDDO
	  
	! Set values at the nyquist to zero 

	a(N/2+1)=0.
	b(N/2+1)=0.

	END

C *********************************************************************
C *********************************************************************
C *********************************************************************
C *********************************************************************
C *********************************************************************


	!******************************************
	!
	!  Canned FFT Routines
	!
	!******************************************

      subroutine cfftf (n,c,wsave)

C  FORWARD COMPLEX DISCRETE FFT OF A COMPLEX PERIODIC SEQUENCE
C
C     EQUIVALENTLY, CFFTF COMPUTES THE FOURIER COEFFICIENTS 
C     OF A COMPLEX PERIODIC SEQUENCE.
C
C     THE TRANSFORM IS NOT NORMALIZED. TO OBTAIN A NORMALIZED TRANSFORM
C     THE OUTPUT MUST BE DIVIDED BY N. OTHERWISE A CALL OF CFFTF
C     FOLLOWED BY A CALL OF CFFTB WILL MULTIPLY THE SEQUENCE BY N.
C
C     THE ARRAY WSAVE WHICH IS USED BY SUBROUTINE CFFTF MUST BE
C     INITIALIZED BY CALLING SUBROUTINE CFFTI(N,WSAVE).
C
C     INPUT PARAMETERS
C
C
C     N      THE LENGTH OF THE COMPLEX SEQUENCE C. THE METHOD IS
C            MORE EFFICIENT WHEN N IS THE PRODUCT OF SMALL PRIMES. N
C
C     C      A COMPLEX ARRAY OF LENGTH N WHICH CONTAINS THE SEQUENCE
C
C     WSAVE   A REAL WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 4N+1
C             IN THE PROGRAM THAT CALLS CFFTF. THE WSAVE ARRAY MUST BE
C             INITIALIZED BY CALLING SUBROUTINE CFFTI(N,WSAVE) AND A
C             DIFFERENT WSAVE ARRAY MUST BE USED FOR EACH DIFFERENT
C             VALUE OF N. THIS INITIALIZATION DOES NOT HAVE TO BE
C             REPEATED SO LONG AS N REMAINS UNCHANGED THUS SUBSEQUENT
C             TRANSFORMS CAN BE OBTAINED FASTER THAN THE FIRST.
C             THE SAME WSAVE ARRAY CAN BE USED BY CFFTF AND CFFTB.
C
C     OUTPUT PARAMETERS
C
C     C      FOR J=1,...,N
C
C                C(J)=THE SUM FROM K=1,...,N OF
C
C                      C(K)*EXP(-I*J*K*2*PI/N)
C
C                            WHERE I=SQRT(-1)
C
C     WSAVE   CONTAINS INITIALIZATION CALCULATIONS WHICH MUST NOT BE
C             DESTROYED BETWEEN CALLS OF SUBROUTINE CFFTF OR CFFTB
C
      real       c(*)       ,wsave(*)

* INTERNAL VARIABLE DECLARATIONS

      integer n, iw1, iw2

      if (n .eq. 1) return
      iw1 = n+n+1
      iw2 = iw1+n+n
      call cfftf1 (n,c,wsave,wsave(iw1),wsave(iw2))
      end

      subroutine cfftf1 (n,c,ch,wa,ifac)

C***REFER TO CFFTF
C***ROUTINES CALLED  PASSF,PASSF5,PASSF3,PASSF2,PASSF4

      real       ch(*)      ,c(*)       ,wa(*)      ,ifac(*)

* INTERNAL VARIABLE DECLARATIONS

      INTEGER i, n, nf, na, l1, iw, k1, ip, l2, ido, idot, idl1, 
     .        ix2, ix3, ix4, nac, n2

      nf = ifac(2)
      na = 0
      l1 = 1
      iw = 1
      do 116 k1=1,nf
         ip = ifac(k1+2)
         l2 = ip*l1
         ido = n/l2
         idot = ido+ido
         idl1 = idot*l1
         if (ip .ne. 4) go to 103
         ix2 = iw+idot
         ix3 = ix2+idot
         if (na .ne. 0) go to 101
         call passf4 (idot,l1,c,ch,wa(iw),wa(ix2),wa(ix3))
         go to 102
  101    call passf4 (idot,l1,ch,c,wa(iw),wa(ix2),wa(ix3))
  102    na = 1-na
         go to 115
  103    if (ip .ne. 2) go to 106
         if (na .ne. 0) go to 104
         call passf2 (idot,l1,c,ch,wa(iw))
         go to 105
  104    call passf2 (idot,l1,ch,c,wa(iw))
  105    na = 1-na
         go to 115
  106    if (ip .ne. 3) go to 109
         ix2 = iw+idot
         if (na .ne. 0) go to 107
         call passf3 (idot,l1,c,ch,wa(iw),wa(ix2))
         go to 108
  107    call passf3 (idot,l1,ch,c,wa(iw),wa(ix2))
  108    na = 1-na
         go to 115
  109    if (ip .ne. 5) go to 112
         ix2 = iw+idot
         ix3 = ix2+idot
         ix4 = ix3+idot
         if (na .ne. 0) go to 110
         call passf5 (idot,l1,c,ch,wa(iw),wa(ix2),wa(ix3),wa(ix4))
         go to 111
  110    call passf5 (idot,l1,ch,c,wa(iw),wa(ix2),wa(ix3),wa(ix4))
  111    na = 1-na
         go to 115
  112    if (na .ne. 0) go to 113
         call passf (nac,idot,ip,l1,idl1,c,c,c,ch,ch,wa(iw))
         go to 114
  113    call passf (nac,idot,ip,l1,idl1,ch,ch,ch,c,c,wa(iw))
  114    if (nac .ne. 0) na = 1-na
  115    l1 = l2
         iw = iw+(ip-1)*idot
  116 continue
      if (na .eq. 0) return
      n2 = n+n
      do 117 i=1,n2
         c(i) = ch(i)
  117 continue
      end

      subroutine cffti (n,wsave)

C   INITIALIZE FOR CFFTF AND CFFTB
C     *****************************************************************
C
C     SUBROUTINE CFFTI(N,WSAVE)
C
C     *****************************************************************
C
C     SUBROUTINE CFFTI INITIALIZES THE ARRAY WSAVE WHICH IS USED IN
C     BOTH CFFTF AND CFFTB. THE PRIME FACTORIZATION OF N TOGETHER WITH
C     A TABULATION OF THE TRIGONOMETRIC FUNCTIONS ARE COMPUTED AND
C     STORED IN WSAVE.
C
C     INPUT PARAMETER
C
C     N       THE LENGTH OF THE SEQUENCE TO BE TRANSFORMED
C
C     OUTPUT PARAMETER
C
C     WSAVE   A WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 4*N+15
C             THE SAME WORK ARRAY CAN BE USED FOR BOTH CFFTF AND CFFTB
C             AS LONG AS N REMAINS UNCHANGED. DIFFERENT WSAVE ARRAYS
C             ARE REQUIRED FOR DIFFERENT VALUES OF N. THE CONTENTS OF
C             WSAVE MUST NOT BE CHANGED BETWEEN CALLS OF CFFTF OR CFFTB
C

      real       wsave(*)

* INTERNAL VARIABLE DECLARATIONS

      integer  n, iw1, iw2

      if (n .eq. 1) return
      iw1 = n+n+1
      iw2 = iw1+n+n
      call cffti1 (n,wsave(iw1),wsave(iw2))
      end

      subroutine cffti1 (n,wa,ifac)
C***REFER TO CFFTI
C***ROUTINES CALLED  (NONE)

      real       wa(*)      ,ifac(*)    ,ntryh(4)

* INTERNAL VARIABLE DECLARATIONS

      integer n, nl, nf, j, ntry, nq, nr, i, ib, l1, k1, ip, ld, l2, 
     .        ido, idot, ipm,i1,ii
      real    argh, wldc, wlds, arg, dl1c, dl1s, dc, ds, tpi, wldch

      data ntryh(1),ntryh(2),ntryh(3),ntryh(4)/3,4,2,5/
      nl = n
      nf = 0
      j = 0
  101 j = j+1
      if (j-4) 102,102,103
  102 ntry = ntryh(j)
      go to 104
  103 ntry = ntry+2
  104 nq = nl/ntry
      nr = nl-ntry*nq
      if (nr) 101,105,101
  105 nf = nf+1
      ifac(nf+2) = ntry
      nl = nq
      if (ntry .ne. 2) go to 107
      if (nf .eq. 1) go to 107
      do 106 i=2,nf
         ib = nf-i+2
         ifac(ib+2) = ifac(ib+1)
  106 continue
      ifac(3) = 2
  107 if (nl .ne. 1) go to 104
      ifac(1) = n
      ifac(2) = nf
      tpi = 6.28318530717959
      argh = tpi/float(n)
      i = 2
      l1 = 1
      do 110 k1=1,nf
         ip = ifac(k1+2)
         ld = 0
         l2 = l1*ip
         ido = n/l2
         idot = ido+ido+2
         ipm = ip-1
         wldc = 1.
         wlds = 0.
         arg = float(l1)*argh
         dl1c = cos(arg)
         dl1s = sin(arg)
         do 109 j=1,ipm
            i1 = i
            wa(i-1) = 1.
            wa(i) = 0.
            ld = ld+l1
            wldch = wldc
            wldc = dl1c*wldc-dl1s*wlds
            wlds = dl1s*wldch+dl1c*wlds
            dc = wldc
            ds = wlds
            do 108 ii=4,idot,2
               i = i+2
               wa(i-1) = dc*wa(i-3)-ds*wa(i-2)
               wa(i) = ds*wa(i-3)+dc*wa(i-2)
  108       continue
            if (ip .le. 5) go to 109
            wa(i1-1) = wa(i-1)
            wa(i1) = wa(i)
  109    continue
         l1 = l2
  110 continue
      end


      subroutine cfftb (n,c,wsave)

C INVERSE FFT OF A COMPLEX PERIODIC SEQUENCE
C     *****************************************************************
C
C     SUBROUTINE CFFTB(N,C,WSAVE)
C
C     *****************************************************************
C
C     SUBROUTINE CFFTB COMPUTES THE BACKWARD COMPLEX DISCRETE FOURIER
C     TRANSFORM (THE FOURIER SYNTHESIS). EQUIVALENTLY , CFFTB COMPUTES
C     A COMPLEX PERIODIC SEQUENCE FROM ITS FOURIER COEFFICIENTS.
C     THE TRANSFORM IS DEFINED BELOW AT OUTPUT PARAMETER C.
C
C     A CALL OF CFFTF FOLLOWED BY A CALL OF CFFTB WILL MULTIPLY THE
C     SEQUENCE BY N.
C
C     THE ARRAY WSAVE WHICH IS USED BY SUBROUTINE CFFTB MUST BE
C     INITIALIZED BY CALLING SUBROUTINE CFFTI(N,WSAVE).
C
C     INPUT PARAMETERS
C
C
C     N      THE LENGTH OF THE COMPLEX SEQUENCE C. THE METHOD IS
C            MORE EFFICIENT WHEN N IS THE PRODUCT OF SMALL PRIMES.
C
C     C      A COMPLEX ARRAY OF LENGTH N WHICH CONTAINS THE SEQUENCE
C
C     WSAVE   A REAL WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 4N+1
C             IN THE PROGRAM THAT CALLS CFFTB. THE WSAVE ARRAY MUST BE
C             INITIALIZED BY CALLING SUBROUTINE CFFTI(N,WSAVE) AND A
C             DIFFERENT WSAVE ARRAY MUST BE USED FOR EACH DIFFERENT
C             VALUE OF N. THIS INITIALIZATION DOES NOT HAVE TO BE
C             REPEATED SO LONG AS N REMAINS UNCHANGED THUS SUBSEQUENT
C             TRANSFORMS CAN BE OBTAINED FASTER THAN THE FIRST.
C             THE SAME WSAVE ARRAY CAN BE USED BY CFFTF AND CFFTB.
C
C     OUTPUT PARAMETERS
C
C     C      FOR J=1,...,N
C
C                C(J)=THE SUM FROM K=1,...,N OF
C
C                      C(K)*EXP(I*J*K*2*PI/N)
C
C                            WHERE I=SQRT(-1)
C
C     WSAVE   CONTAINS INITIALIZATION CALCULATIONS WHICH MUST NOT BE
C             DESTROYED BETWEEN CALLS OF SUBROUTINE CFFTF OR CFFTB

C***ROUTINES CALLED  CFFTB1

      real c(*), wsave(*)

* INTERNAL VARIABLE DECLARATIONS

      integer n, iw1, iw2
      if (n .eq. 1) return
      iw1 = n+n+1
      iw2 = iw1+n+n
      call cfftb1 (n,c,wsave,wsave(iw1),wsave(iw2))
      return
      end

      subroutine cfftb1 (n,c,ch,wa,ifac)

C***REFER TO CFFTB
C***ROUTINES CALLED  PASSB,PASSB5,PASSB3,PASSB2,PASSB4

      real       ch(*)      ,c(*)       ,wa(*)      ,ifac(*)

* INTERNAL VARIABLE DECLARATIONS

      integer n, nf, na, l1, iw, k1, ip, l2, ido, idot, idl1,
     .        ix2, ix3, ix4, nac, n2, i

      nf = ifac(2)
      na = 0
      l1 = 1
      iw = 1
      do 116 k1=1,nf
         ip = ifac(k1+2)
         l2 = ip*l1
         ido = n/l2
         idot = ido+ido
         idl1 = idot*l1
         if (ip .ne. 4) go to 103
         ix2 = iw+idot
         ix3 = ix2+idot
         if (na .ne. 0) go to 101
         call passb4 (idot,l1,c,ch,wa(iw),wa(ix2),wa(ix3))
         go to 102
  101    call passb4 (idot,l1,ch,c,wa(iw),wa(ix2),wa(ix3))
  102    na = 1-na
         go to 115
  103    if (ip .ne. 2) go to 106
         if (na .ne. 0) go to 104
         call passb2 (idot,l1,c,ch,wa(iw))
         go to 105
  104    call passb2 (idot,l1,ch,c,wa(iw))
  105    na = 1-na
         go to 115
  106    if (ip .ne. 3) go to 109
         ix2 = iw+idot
         if (na .ne. 0) go to 107
         call passb3 (idot,l1,c,ch,wa(iw),wa(ix2))
         go to 108
  107    call passb3 (idot,l1,ch,c,wa(iw),wa(ix2))
  108    na = 1-na
         go to 115
  109    if (ip .ne. 5) go to 112
         ix2 = iw+idot
         ix3 = ix2+idot
         ix4 = ix3+idot
         if (na .ne. 0) go to 110
         call passb5 (idot,l1,c,ch,wa(iw),wa(ix2),wa(ix3),wa(ix4))
         go to 111
  110    call passb5 (idot,l1,ch,c,wa(iw),wa(ix2),wa(ix3),wa(ix4))
  111    na = 1-na
         go to 115
  112    if (na .ne. 0) go to 113
         call passb (nac,idot,ip,l1,idl1,c,c,c,ch,ch,wa(iw))
         go to 114
  113    call passb (nac,idot,ip,l1,idl1,ch,ch,ch,c,c,wa(iw))
  114    if (nac .ne. 0) na = 1-na
  115    l1 = l2
         iw = iw+(ip-1)*idot
  116 continue
      if (na .eq. 0) return
      n2 = n+n
      do 117 i=1,n2
         c(i) = ch(i)
  117 continue
      end

      subroutine passb (nac,ido,ip,l1,idl1,cc,c1,c2,ch,ch2,wa)

C***REFER TO CFFTB
C***ROUTINES CALLED  (NONE)

      real       ch(ido,l1,ip)          ,cc(ido,ip,l1)          ,
     1                c1(ido,l1,ip)          ,wa(*)      ,c2(idl1,ip),
     2                ch2(idl1,ip)

* INTERNAL VARIABLE DECLARATIONS

      integer nac, ido, ip, l1, idl1, idot, nt, ipp2, ipph, idp, j, 
     .        jc, k, i, idl, inc, l, lc, ik, idlj, idij, idj
      real    war, wai

      idot = ido/2
      nt = ip*idl1
      ipp2 = ip+2
      ipph = (ip+1)/2
      idp = ip*ido
C
      if (ido .lt. l1) go to 106
      do 103 j=2,ipph
         jc = ipp2-j
         do 102 k=1,l1
            do 101 i=1,ido
               ch(i,k,j) = cc(i,j,k)+cc(i,jc,k)
               ch(i,k,jc) = cc(i,j,k)-cc(i,jc,k)
  101       continue
  102    continue
  103 continue
      do 105 k=1,l1
         do 104 i=1,ido
            ch(i,k,1) = cc(i,1,k)
  104    continue
  105 continue
      go to 112
  106 do 109 j=2,ipph
         jc = ipp2-j
         do 108 i=1,ido
            do 107 k=1,l1
               ch(i,k,j) = cc(i,j,k)+cc(i,jc,k)
               ch(i,k,jc) = cc(i,j,k)-cc(i,jc,k)
  107       continue
  108    continue
  109 continue
      do 111 i=1,ido
         do 110 k=1,l1
            ch(i,k,1) = cc(i,1,k)
  110    continue
  111 continue
  112 idl = 2-ido
      inc = 0
      do 116 l=2,ipph
         lc = ipp2-l
         idl = idl+ido
         do 113 ik=1,idl1
            c2(ik,l) = ch2(ik,1)+wa(idl-1)*ch2(ik,2)
            c2(ik,lc) = wa(idl)*ch2(ik,ip)
  113    continue
         idlj = idl
         inc = inc+ido
         do 115 j=3,ipph
            jc = ipp2-j
            idlj = idlj+inc
            if (idlj .gt. idp) idlj = idlj-idp
            war = wa(idlj-1)
            wai = wa(idlj)
            do 114 ik=1,idl1
               c2(ik,l) = c2(ik,l)+war*ch2(ik,j)
               c2(ik,lc) = c2(ik,lc)+wai*ch2(ik,jc)
  114       continue
  115    continue
  116 continue
      do 118 j=2,ipph
         do 117 ik=1,idl1
            ch2(ik,1) = ch2(ik,1)+ch2(ik,j)
  117    continue
  118 continue
      do 120 j=2,ipph
         jc = ipp2-j
         do 119 ik=2,idl1,2
            ch2(ik-1,j) = c2(ik-1,j)-c2(ik,jc)
            ch2(ik-1,jc) = c2(ik-1,j)+c2(ik,jc)
            ch2(ik,j) = c2(ik,j)+c2(ik-1,jc)
            ch2(ik,jc) = c2(ik,j)-c2(ik-1,jc)
  119    continue
  120 continue
      nac = 1
      if (ido .eq. 2) return
      nac = 0
      do 121 ik=1,idl1
         c2(ik,1) = ch2(ik,1)
  121 continue
      do 123 j=2,ip
         do 122 k=1,l1
            c1(1,k,j) = ch(1,k,j)
            c1(2,k,j) = ch(2,k,j)
  122    continue
  123 continue
      if (idot .gt. l1) go to 127
      idij = 0
      do 126 j=2,ip
         idij = idij+2
         do 125 i=4,ido,2
            idij = idij+2
            do 124 k=1,l1
               c1(i-1,k,j) = wa(idij-1)*ch(i-1,k,j)-wa(idij)*ch(i,k,j)
               c1(i,k,j) = wa(idij-1)*ch(i,k,j)+wa(idij)*ch(i-1,k,j)
  124       continue
  125    continue
  126 continue
      return
  127 idj = 2-ido
      do 130 j=2,ip
         idj = idj+ido
         do 129 k=1,l1
            idij = idj
            do 128 i=4,ido,2
               idij = idij+2
               c1(i-1,k,j) = wa(idij-1)*ch(i-1,k,j)-wa(idij)*ch(i,k,j)
               c1(i,k,j) = wa(idij-1)*ch(i,k,j)+wa(idij)*ch(i-1,k,j)
  128       continue
  129    continue
  130 continue
      end

      subroutine passb2 (ido,l1,cc,ch,wa1)

C***REFER TO CFFTB
C***ROUTINES CALLED  (NONE)

      real       cc(ido,2,l1)           ,ch(ido,l1,2)           ,
     1                wa1(*)

* INTERNAL VARIABLE DECLARATIONS

      integer ido, l1, k, i
      real    tr2, ti2

      if (ido .gt. 2) go to 102
      do 101 k=1,l1
         ch(1,k,1) = cc(1,1,k)+cc(1,2,k)
         ch(1,k,2) = cc(1,1,k)-cc(1,2,k)
         ch(2,k,1) = cc(2,1,k)+cc(2,2,k)
         ch(2,k,2) = cc(2,1,k)-cc(2,2,k)
  101 continue
      return
  102 do 104 k=1,l1
         do 103 i=2,ido,2
            ch(i-1,k,1) = cc(i-1,1,k)+cc(i-1,2,k)
            tr2 = cc(i-1,1,k)-cc(i-1,2,k)
            ch(i,k,1) = cc(i,1,k)+cc(i,2,k)
            ti2 = cc(i,1,k)-cc(i,2,k)
            ch(i,k,2) = wa1(i-1)*ti2+wa1(i)*tr2
            ch(i-1,k,2) = wa1(i-1)*tr2-wa1(i)*ti2
  103    continue
  104 continue
      end

      subroutine passb3 (ido,l1,cc,ch,wa1,wa2)

C***REFER TO CFFTB
C***ROUTINES CALLED  (NONE)

      real       cc(ido,3,l1)           ,ch(ido,l1,3)           ,
     1                wa1(*)     ,wa2(*)

* INTERNAL VARIABLE DECLARATIONS

      integer ido, l1, k, i
      real taur, taui, tr2, cr2, ti2, ci2, cr3, ci3, dr2, dr3, di2, di3

      data taur,taui /-.5,.866025403784439/
      if (ido .ne. 2) go to 102
      do 101 k=1,l1
         tr2 = cc(1,2,k)+cc(1,3,k)
         cr2 = cc(1,1,k)+taur*tr2
         ch(1,k,1) = cc(1,1,k)+tr2
         ti2 = cc(2,2,k)+cc(2,3,k)
         ci2 = cc(2,1,k)+taur*ti2
         ch(2,k,1) = cc(2,1,k)+ti2
         cr3 = taui*(cc(1,2,k)-cc(1,3,k))
         ci3 = taui*(cc(2,2,k)-cc(2,3,k))
         ch(1,k,2) = cr2-ci3
         ch(1,k,3) = cr2+ci3
         ch(2,k,2) = ci2+cr3
         ch(2,k,3) = ci2-cr3
  101 continue
      return
  102 do 104 k=1,l1
         do 103 i=2,ido,2
            tr2 = cc(i-1,2,k)+cc(i-1,3,k)
            cr2 = cc(i-1,1,k)+taur*tr2
            ch(i-1,k,1) = cc(i-1,1,k)+tr2
            ti2 = cc(i,2,k)+cc(i,3,k)
            ci2 = cc(i,1,k)+taur*ti2
            ch(i,k,1) = cc(i,1,k)+ti2
            cr3 = taui*(cc(i-1,2,k)-cc(i-1,3,k))
            ci3 = taui*(cc(i,2,k)-cc(i,3,k))
            dr2 = cr2-ci3
            dr3 = cr2+ci3
            di2 = ci2+cr3
            di3 = ci2-cr3
            ch(i,k,2) = wa1(i-1)*di2+wa1(i)*dr2
            ch(i-1,k,2) = wa1(i-1)*dr2-wa1(i)*di2
            ch(i,k,3) = wa2(i-1)*di3+wa2(i)*dr3
            ch(i-1,k,3) = wa2(i-1)*dr3-wa2(i)*di3
  103    continue
  104 continue
      end

      subroutine passb4 (ido,l1,cc,ch,wa1,wa2,wa3)

C***REFER TO CFFTB
C***ROUTINES CALLED (NONE)

      real       cc(ido,4,l1)           ,ch(ido,l1,4)           ,
     1                wa1(*)     ,wa2(*)     ,wa3(*)

* INTERNAL VARIABLE DECLARATIONS

      integer ido, l1, k, i
      real    ti1, ti2, ti3, ti4, tr1, tr2, tr3, tr4, 
     .        cr2, cr3, cr4, ci2, ci3, ci4

      if (ido .ne. 2) go to 102
      do 101 k=1,l1
         ti1 = cc(2,1,k)-cc(2,3,k)
         ti2 = cc(2,1,k)+cc(2,3,k)
         tr4 = cc(2,4,k)-cc(2,2,k)
         ti3 = cc(2,2,k)+cc(2,4,k)
         tr1 = cc(1,1,k)-cc(1,3,k)
         tr2 = cc(1,1,k)+cc(1,3,k)
         ti4 = cc(1,2,k)-cc(1,4,k)
         tr3 = cc(1,2,k)+cc(1,4,k)
         ch(1,k,1) = tr2+tr3
         ch(1,k,3) = tr2-tr3
         ch(2,k,1) = ti2+ti3
         ch(2,k,3) = ti2-ti3
         ch(1,k,2) = tr1+tr4
         ch(1,k,4) = tr1-tr4
         ch(2,k,2) = ti1+ti4
         ch(2,k,4) = ti1-ti4
  101 continue
      return
  102 do 104 k=1,l1
         do 103 i=2,ido,2
            ti1 = cc(i,1,k)-cc(i,3,k)
            ti2 = cc(i,1,k)+cc(i,3,k)
            ti3 = cc(i,2,k)+cc(i,4,k)
            tr4 = cc(i,4,k)-cc(i,2,k)
            tr1 = cc(i-1,1,k)-cc(i-1,3,k)
            tr2 = cc(i-1,1,k)+cc(i-1,3,k)
            ti4 = cc(i-1,2,k)-cc(i-1,4,k)
            tr3 = cc(i-1,2,k)+cc(i-1,4,k)
            ch(i-1,k,1) = tr2+tr3
            cr3 = tr2-tr3
            ch(i,k,1) = ti2+ti3
            ci3 = ti2-ti3
            cr2 = tr1+tr4
            cr4 = tr1-tr4
            ci2 = ti1+ti4
            ci4 = ti1-ti4
            ch(i-1,k,2) = wa1(i-1)*cr2-wa1(i)*ci2
            ch(i,k,2) = wa1(i-1)*ci2+wa1(i)*cr2
            ch(i-1,k,3) = wa2(i-1)*cr3-wa2(i)*ci3
            ch(i,k,3) = wa2(i-1)*ci3+wa2(i)*cr3
            ch(i-1,k,4) = wa3(i-1)*cr4-wa3(i)*ci4
            ch(i,k,4) = wa3(i-1)*ci4+wa3(i)*cr4
  103    continue
  104 continue
      end

      subroutine passb5 (ido,l1,cc,ch,wa1,wa2,wa3,wa4)

C***REFER TO CFFTB
C***ROUTINES CALLED  (NONE)

      real       cc(ido,5,l1)           ,ch(ido,l1,5)           ,
     1                wa1(*)     ,wa2(*)     ,wa3(*)     ,wa4(*)

* INTERNAL VARIABLE DECLARATIONS

      integer ido, l1, k, i
      real tr2, tr4, tr5, tr11, tr12, ti2, ti3, ti4, ti5, ti11, ti12, 
     .     cr2, cr3, cr4, cr5, ci2, ci3, ci4, ci5, dr4, dr5, 
     .     di2, di3, di4, di5, tr3, dr3, dr2

      data tr11,ti11,tr12,ti12 /.309016994374947,.951056516295154,
     1-.809016994374947,.587785252292473/
      if (ido .ne. 2) go to 102
      do 101 k=1,l1
         ti5 = cc(2,2,k)-cc(2,5,k)
         ti2 = cc(2,2,k)+cc(2,5,k)
         ti4 = cc(2,3,k)-cc(2,4,k)
         ti3 = cc(2,3,k)+cc(2,4,k)
         tr5 = cc(1,2,k)-cc(1,5,k)
         tr2 = cc(1,2,k)+cc(1,5,k)
         tr4 = cc(1,3,k)-cc(1,4,k)
         tr3 = cc(1,3,k)+cc(1,4,k)
         ch(1,k,1) = cc(1,1,k)+tr2+tr3
         ch(2,k,1) = cc(2,1,k)+ti2+ti3
         cr2 = cc(1,1,k)+tr11*tr2+tr12*tr3
         ci2 = cc(2,1,k)+tr11*ti2+tr12*ti3
         cr3 = cc(1,1,k)+tr12*tr2+tr11*tr3
         ci3 = cc(2,1,k)+tr12*ti2+tr11*ti3
         cr5 = ti11*tr5+ti12*tr4
         ci5 = ti11*ti5+ti12*ti4
         cr4 = ti12*tr5-ti11*tr4
         ci4 = ti12*ti5-ti11*ti4
         ch(1,k,2) = cr2-ci5
         ch(1,k,5) = cr2+ci5
         ch(2,k,2) = ci2+cr5
         ch(2,k,3) = ci3+cr4
         ch(1,k,3) = cr3-ci4
         ch(1,k,4) = cr3+ci4
         ch(2,k,4) = ci3-cr4
         ch(2,k,5) = ci2-cr5
  101 continue
      return
  102 do 104 k=1,l1
         do 103 i=2,ido,2
            ti5 = cc(i,2,k)-cc(i,5,k)
            ti2 = cc(i,2,k)+cc(i,5,k)
            ti4 = cc(i,3,k)-cc(i,4,k)
            ti3 = cc(i,3,k)+cc(i,4,k)
            tr5 = cc(i-1,2,k)-cc(i-1,5,k)
            tr2 = cc(i-1,2,k)+cc(i-1,5,k)
            tr4 = cc(i-1,3,k)-cc(i-1,4,k)
            tr3 = cc(i-1,3,k)+cc(i-1,4,k)
            ch(i-1,k,1) = cc(i-1,1,k)+tr2+tr3
            ch(i,k,1) = cc(i,1,k)+ti2+ti3
            cr2 = cc(i-1,1,k)+tr11*tr2+tr12*tr3
            ci2 = cc(i,1,k)+tr11*ti2+tr12*ti3
            cr3 = cc(i-1,1,k)+tr12*tr2+tr11*tr3
            ci3 = cc(i,1,k)+tr12*ti2+tr11*ti3
            cr5 = ti11*tr5+ti12*tr4
            ci5 = ti11*ti5+ti12*ti4
            cr4 = ti12*tr5-ti11*tr4
            ci4 = ti12*ti5-ti11*ti4
            dr3 = cr3-ci4
            dr4 = cr3+ci4
            di3 = ci3+cr4
            di4 = ci3-cr4
            dr5 = cr2+ci5
            dr2 = cr2-ci5
            di5 = ci2-cr5
            di2 = ci2+cr5
            ch(i-1,k,2) = wa1(i-1)*dr2-wa1(i)*di2
            ch(i,k,2) = wa1(i-1)*di2+wa1(i)*dr2
            ch(i-1,k,3) = wa2(i-1)*dr3-wa2(i)*di3
            ch(i,k,3) = wa2(i-1)*di3+wa2(i)*dr3
            ch(i-1,k,4) = wa3(i-1)*dr4-wa3(i)*di4
            ch(i,k,4) = wa3(i-1)*di4+wa3(i)*dr4
            ch(i-1,k,5) = wa4(i-1)*dr5-wa4(i)*di5
            ch(i,k,5) = wa4(i-1)*di5+wa4(i)*dr5
  103    continue
  104 continue
      end

      subroutine passf (nac,ido,ip,l1,idl1,cc,c1,c2,ch,ch2,wa)

C***REFER TO CFFTF
C***ROUTINES CALLED  (NONE)

      real       ch(ido,l1,ip)          ,cc(ido,ip,l1)          ,
     1                c1(ido,l1,ip)          ,wa(*)      ,c2(idl1,ip),
     2                ch2(idl1,ip)

* INTERNAL VARIABLE DECLARATIONS

      integer nac, ido, ip, l1, idl1, idot, nt, ipp2, ipph, idp, j, jc,
     .        k, i, idl, inc, l, lc, ik, idlj, idij, idj
      real    war, wai

      idot = ido/2
      nt = ip*idl1
      ipp2 = ip+2
      ipph = (ip+1)/2
      idp = ip*ido
C
      if (ido .lt. l1) go to 106
      do 103 j=2,ipph
         jc = ipp2-j
         do 102 k=1,l1
            do 101 i=1,ido
               ch(i,k,j) = cc(i,j,k)+cc(i,jc,k)
               ch(i,k,jc) = cc(i,j,k)-cc(i,jc,k)
  101       continue
  102    continue
  103 continue
      do 105 k=1,l1
         do 104 i=1,ido
            ch(i,k,1) = cc(i,1,k)
  104    continue
  105 continue
      go to 112
  106 do 109 j=2,ipph
         jc = ipp2-j
         do 108 i=1,ido
            do 107 k=1,l1
               ch(i,k,j) = cc(i,j,k)+cc(i,jc,k)
               ch(i,k,jc) = cc(i,j,k)-cc(i,jc,k)
  107       continue
  108    continue
  109 continue
      do 111 i=1,ido
         do 110 k=1,l1
            ch(i,k,1) = cc(i,1,k)
  110    continue
  111 continue
  112 idl = 2-ido
      inc = 0
      do 116 l=2,ipph
         lc = ipp2-l
         idl = idl+ido
         do 113 ik=1,idl1
            c2(ik,l) = ch2(ik,1)+wa(idl-1)*ch2(ik,2)
            c2(ik,lc) = -wa(idl)*ch2(ik,ip)
  113    continue
         idlj = idl
         inc = inc+ido
         do 115 j=3,ipph
            jc = ipp2-j
            idlj = idlj+inc
            if (idlj .gt. idp) idlj = idlj-idp
            war = wa(idlj-1)
            wai = wa(idlj)
            do 114 ik=1,idl1
               c2(ik,l) = c2(ik,l)+war*ch2(ik,j)
               c2(ik,lc) = c2(ik,lc)-wai*ch2(ik,jc)
  114       continue
  115    continue
  116 continue
      do 118 j=2,ipph
         do 117 ik=1,idl1
            ch2(ik,1) = ch2(ik,1)+ch2(ik,j)
  117    continue
  118 continue
      do 120 j=2,ipph
         jc = ipp2-j
         do 119 ik=2,idl1,2
            ch2(ik-1,j) = c2(ik-1,j)-c2(ik,jc)
            ch2(ik-1,jc) = c2(ik-1,j)+c2(ik,jc)
            ch2(ik,j) = c2(ik,j)+c2(ik-1,jc)
            ch2(ik,jc) = c2(ik,j)-c2(ik-1,jc)
  119    continue
  120 continue
      nac = 1
      if (ido .eq. 2) return
      nac = 0
      do 121 ik=1,idl1
         c2(ik,1) = ch2(ik,1)
  121 continue
      do 123 j=2,ip
         do 122 k=1,l1
            c1(1,k,j) = ch(1,k,j)
            c1(2,k,j) = ch(2,k,j)
  122    continue
  123 continue
      if (idot .gt. l1) go to 127
      idij = 0
      do 126 j=2,ip
         idij = idij+2
         do 125 i=4,ido,2
            idij = idij+2
            do 124 k=1,l1
               c1(i-1,k,j) = wa(idij-1)*ch(i-1,k,j)+wa(idij)*ch(i,k,j)
               c1(i,k,j) = wa(idij-1)*ch(i,k,j)-wa(idij)*ch(i-1,k,j)
  124       continue
  125    continue
  126 continue
      return
  127 idj = 2-ido
      do 130 j=2,ip
         idj = idj+ido
         do 129 k=1,l1
            idij = idj
            do 128 i=4,ido,2
               idij = idij+2
               c1(i-1,k,j) = wa(idij-1)*ch(i-1,k,j)+wa(idij)*ch(i,k,j)
               c1(i,k,j) = wa(idij-1)*ch(i,k,j)-wa(idij)*ch(i-1,k,j)
  128       continue
  129    continue
  130 continue
      end

      subroutine passf2 (ido,l1,cc,ch,wa1)

C***REFER TO CFFTF
C***ROUTINES CALLED  (NONE)

      real       cc(ido,2,l1)           ,ch(ido,l1,2)           ,
     1                wa1(*)

* INTERNAL VARIABLE DECLARATIONS

      integer ido, l1, k, i
      real    tr2, ti2

      if (ido .gt. 2) go to 102
      do 101 k=1,l1
         ch(1,k,1) = cc(1,1,k)+cc(1,2,k)
         ch(1,k,2) = cc(1,1,k)-cc(1,2,k)
         ch(2,k,1) = cc(2,1,k)+cc(2,2,k)
         ch(2,k,2) = cc(2,1,k)-cc(2,2,k)
  101 continue
      return
  102 do 104 k=1,l1
         do 103 i=2,ido,2
            ch(i-1,k,1) = cc(i-1,1,k)+cc(i-1,2,k)
            tr2 = cc(i-1,1,k)-cc(i-1,2,k)
            ch(i,k,1) = cc(i,1,k)+cc(i,2,k)
            ti2 = cc(i,1,k)-cc(i,2,k)
            ch(i,k,2) = wa1(i-1)*ti2-wa1(i)*tr2
            ch(i-1,k,2) = wa1(i-1)*tr2+wa1(i)*ti2
  103    continue
  104 continue
      end

      subroutine passf3 (ido,l1,cc,ch,wa1,wa2)

C***REFER TO CFFTF
C***ROUTINES CALLED  (NONE)

      real       cc(ido,3,l1)           ,ch(ido,l1,3)           ,
     1                wa1(*)     ,wa2(*)

* INTERNAL VARIABLE DECLARATIONS

      integer ido, l1, k, i
      real taur, taui, tr2, cr2, ti2, ci2, cr3, ci3, dr2, dr3, di2, di3

      data taur,taui /-.5,-.866025403784439/
      if (ido .ne. 2) go to 102
      do 101 k=1,l1
         tr2 = cc(1,2,k)+cc(1,3,k)
         cr2 = cc(1,1,k)+taur*tr2
         ch(1,k,1) = cc(1,1,k)+tr2
         ti2 = cc(2,2,k)+cc(2,3,k)
         ci2 = cc(2,1,k)+taur*ti2
         ch(2,k,1) = cc(2,1,k)+ti2
         cr3 = taui*(cc(1,2,k)-cc(1,3,k))
         ci3 = taui*(cc(2,2,k)-cc(2,3,k))
         ch(1,k,2) = cr2-ci3
         ch(1,k,3) = cr2+ci3
         ch(2,k,2) = ci2+cr3
         ch(2,k,3) = ci2-cr3
  101 continue
      return
  102 do 104 k=1,l1
         do 103 i=2,ido,2
            tr2 = cc(i-1,2,k)+cc(i-1,3,k)
            cr2 = cc(i-1,1,k)+taur*tr2
            ch(i-1,k,1) = cc(i-1,1,k)+tr2
            ti2 = cc(i,2,k)+cc(i,3,k)
            ci2 = cc(i,1,k)+taur*ti2
            ch(i,k,1) = cc(i,1,k)+ti2
            cr3 = taui*(cc(i-1,2,k)-cc(i-1,3,k))
            ci3 = taui*(cc(i,2,k)-cc(i,3,k))
            dr2 = cr2-ci3
            dr3 = cr2+ci3
            di2 = ci2+cr3
            di3 = ci2-cr3
            ch(i,k,2) = wa1(i-1)*di2-wa1(i)*dr2
            ch(i-1,k,2) = wa1(i-1)*dr2+wa1(i)*di2
            ch(i,k,3) = wa2(i-1)*di3-wa2(i)*dr3
            ch(i-1,k,3) = wa2(i-1)*dr3+wa2(i)*di3
  103    continue
  104 continue
      end

      subroutine passf4 (ido,l1,cc,ch,wa1,wa2,wa3)

C***REFER TO CFFTF
C***ROUTINES CALLED  (NONE)

      real       cc(ido,4,l1)           ,ch(ido,l1,4)           ,
     1                wa1(*)     ,wa2(*)     ,wa3(*)

* INTERNAL VARIABLE DECLARATIONS

      integer ido, l1, k, i
      real    ti1, ti2, tr4, ti3, tr1, tr2, ti4, tr3, cr3, ci3, 
     .        cr2, cr4, ci2, ci4

      if (ido .ne. 2) go to 102
      do 101 k=1,l1
         ti1 = cc(2,1,k)-cc(2,3,k)
         ti2 = cc(2,1,k)+cc(2,3,k)
         tr4 = cc(2,2,k)-cc(2,4,k)
         ti3 = cc(2,2,k)+cc(2,4,k)
         tr1 = cc(1,1,k)-cc(1,3,k)
         tr2 = cc(1,1,k)+cc(1,3,k)
         ti4 = cc(1,4,k)-cc(1,2,k)
         tr3 = cc(1,2,k)+cc(1,4,k)
         ch(1,k,1) = tr2+tr3
         ch(1,k,3) = tr2-tr3
         ch(2,k,1) = ti2+ti3
         ch(2,k,3) = ti2-ti3
         ch(1,k,2) = tr1+tr4
         ch(1,k,4) = tr1-tr4
         ch(2,k,2) = ti1+ti4
         ch(2,k,4) = ti1-ti4
  101 continue
      return
  102 do 104 k=1,l1
         do 103 i=2,ido,2
            ti1 = cc(i,1,k)-cc(i,3,k)
            ti2 = cc(i,1,k)+cc(i,3,k)
            ti3 = cc(i,2,k)+cc(i,4,k)
            tr4 = cc(i,2,k)-cc(i,4,k)
            tr1 = cc(i-1,1,k)-cc(i-1,3,k)
            tr2 = cc(i-1,1,k)+cc(i-1,3,k)
            ti4 = cc(i-1,4,k)-cc(i-1,2,k)
            tr3 = cc(i-1,2,k)+cc(i-1,4,k)
            ch(i-1,k,1) = tr2+tr3
            cr3 = tr2-tr3
            ch(i,k,1) = ti2+ti3
            ci3 = ti2-ti3
            cr2 = tr1+tr4
            cr4 = tr1-tr4
            ci2 = ti1+ti4
            ci4 = ti1-ti4
            ch(i-1,k,2) = wa1(i-1)*cr2+wa1(i)*ci2
            ch(i,k,2) = wa1(i-1)*ci2-wa1(i)*cr2
            ch(i-1,k,3) = wa2(i-1)*cr3+wa2(i)*ci3
            ch(i,k,3) = wa2(i-1)*ci3-wa2(i)*cr3
            ch(i-1,k,4) = wa3(i-1)*cr4+wa3(i)*ci4
            ch(i,k,4) = wa3(i-1)*ci4-wa3(i)*cr4
  103    continue
  104 continue
      end

      subroutine passf5 (ido,l1,cc,ch,wa1,wa2,wa3,wa4)

C***REFER TO CFFTF
C***ROUTINES CALLED  (NONE)

      real       cc(ido,5,l1)           ,ch(ido,l1,5)           ,
     1                wa1(*)     ,wa2(*)     ,wa3(*)     ,wa4(*)

* INTERNAL VARIABLE DECLARATIONS

      integer ido, l1, k, i
      real    tr11, ti11, tr12, ti12, ti5, ti2, ti4, ti3, tr5, tr2, 
     .        tr4, tr3, cr2, ci2, cr3, ci3, cr5, ci5, cr4, ci4, dr3, 
     .        dr4, di3, di4, dr5, dr2, di5, di2

      data tr11,ti11,tr12,ti12 /.309016994374947,-.951056516295154,
     1-.809016994374947,-.587785252292473/
      if (ido .ne. 2) go to 102
      do 101 k=1,l1
         ti5 = cc(2,2,k)-cc(2,5,k)
         ti2 = cc(2,2,k)+cc(2,5,k)
         ti4 = cc(2,3,k)-cc(2,4,k)
         ti3 = cc(2,3,k)+cc(2,4,k)
         tr5 = cc(1,2,k)-cc(1,5,k)
         tr2 = cc(1,2,k)+cc(1,5,k)
         tr4 = cc(1,3,k)-cc(1,4,k)
         tr3 = cc(1,3,k)+cc(1,4,k)
         ch(1,k,1) = cc(1,1,k)+tr2+tr3
         ch(2,k,1) = cc(2,1,k)+ti2+ti3
         cr2 = cc(1,1,k)+tr11*tr2+tr12*tr3
         ci2 = cc(2,1,k)+tr11*ti2+tr12*ti3
         cr3 = cc(1,1,k)+tr12*tr2+tr11*tr3
         ci3 = cc(2,1,k)+tr12*ti2+tr11*ti3
         cr5 = ti11*tr5+ti12*tr4
         ci5 = ti11*ti5+ti12*ti4
         cr4 = ti12*tr5-ti11*tr4
         ci4 = ti12*ti5-ti11*ti4
         ch(1,k,2) = cr2-ci5
         ch(1,k,5) = cr2+ci5
         ch(2,k,2) = ci2+cr5
         ch(2,k,3) = ci3+cr4
         ch(1,k,3) = cr3-ci4
         ch(1,k,4) = cr3+ci4
         ch(2,k,4) = ci3-cr4
         ch(2,k,5) = ci2-cr5
  101 continue
      return
  102 do 104 k=1,l1
         do 103 i=2,ido,2
            ti5 = cc(i,2,k)-cc(i,5,k)
            ti2 = cc(i,2,k)+cc(i,5,k)
            ti4 = cc(i,3,k)-cc(i,4,k)
            ti3 = cc(i,3,k)+cc(i,4,k)
            tr5 = cc(i-1,2,k)-cc(i-1,5,k)
            tr2 = cc(i-1,2,k)+cc(i-1,5,k)
            tr4 = cc(i-1,3,k)-cc(i-1,4,k)
            tr3 = cc(i-1,3,k)+cc(i-1,4,k)
            ch(i-1,k,1) = cc(i-1,1,k)+tr2+tr3
            ch(i,k,1) = cc(i,1,k)+ti2+ti3
            cr2 = cc(i-1,1,k)+tr11*tr2+tr12*tr3
            ci2 = cc(i,1,k)+tr11*ti2+tr12*ti3
            cr3 = cc(i-1,1,k)+tr12*tr2+tr11*tr3
            ci3 = cc(i,1,k)+tr12*ti2+tr11*ti3
            cr5 = ti11*tr5+ti12*tr4
            ci5 = ti11*ti5+ti12*ti4
            cr4 = ti12*tr5-ti11*tr4
            ci4 = ti12*ti5-ti11*ti4
            dr3 = cr3-ci4
            dr4 = cr3+ci4
            di3 = ci3+cr4
            di4 = ci3-cr4
            dr5 = cr2+ci5
            dr2 = cr2-ci5
            di5 = ci2-cr5
            di2 = ci2+cr5
            ch(i-1,k,2) = wa1(i-1)*dr2+wa1(i)*di2
            ch(i,k,2) = wa1(i-1)*di2-wa1(i)*dr2
            ch(i-1,k,3) = wa2(i-1)*dr3+wa2(i)*di3
            ch(i,k,3) = wa2(i-1)*di3-wa2(i)*dr3
            ch(i-1,k,4) = wa3(i-1)*dr4+wa3(i)*di4
            ch(i,k,4) = wa3(i-1)*di4-wa3(i)*dr4
            ch(i-1,k,5) = wa4(i-1)*dr5+wa4(i)*di5
            ch(i,k,5) = wa4(i-1)*di5-wa4(i)*dr5
  103    continue
  104 continue
      end 

*
* compressj.F
*
* Ansley Manke
* August 1998
*
* This function compresses data on J axis, ending with missing data.
*
*  NOTE:
*  IT IS GENERALLY ADVISABLE TO INCLUDE EXPLICIT LIMITS WHEN WORKING WITH
*  FUNCTIONS THAT REPLACE AXES. FOR EXAMPLE, THE CONSIDER THE FUNCTION
*  COMPRESSL(v). THE EXPRESSION
*  	LIST/L=6:10 COMPRESSL(v)
*  IS NOT EQUIVALENT TO
*  	LIST COMPRESSL(v[L=6:10])
*  THE FORMER WILL LIST THE 6TH THROUGH 10TH COMPRESSED INDICES FROM THE ENTIRE
*  L RANGE OF VARIABLE V. THE LATTER WILL LIST ALL OF THE INDICES THAT
*  RESULT FROM COMPRESSING v[L=6:10].
*  
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE compressj_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg

***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V
      CHARACTER*100 fcn_desc
      WRITE (fcn_desc, 10)
   10 FORMAT ('Returns data, compressed along the J axis: Missing ',
     .        'points moved to the end')
      CALL ef_set_desc(id, fcn_desc)

      CALL ef_set_num_args(id, 1)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, ABSTRACT, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)

      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'DAT')
      CALL ef_set_arg_desc(id, arg, 'variable to compress in J')
      CALL ef_set_axis_influence(id, arg, YES, NO, YES, YES)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END


*
* In this subroutine we provide information about the lo and hi
* limits associated with each abstract or custom axis.   The user 
* configurable information consists of the following:
*
* lo_ss               lo subscript for an axis
*
* hi_ss               hi subscript for an axis
*

      SUBROUTINE compressj_result_limits(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id

* **********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER my_lo_l, my_hi_l

      INTEGER arg
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)

*
*     Use utility functions to get context information about the arguments.
*

      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)

      my_lo_l = 1
      my_hi_l = 1

      arg = 1

      my_hi_l = arg_hi_ss(Y_AXIS,arg) - arg_lo_ss(Y_AXIS,arg) + 1


      CALL ef_set_axis_limits(id, Y_AXIS, my_lo_l, my_hi_l)
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE compressj_compute(id, arg_1, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,EF_MAX_ARGS), arg_hi_ss(4,EF_MAX_ARGS),
     .     arg_incr(4,EF_MAX_ARGS)


***********************************************************************
*                                           USER CONFIGURABLE PORTION |
*                                                                     |
*                                                                     V

      INTEGER id
      INTEGER nbad, m_indx
      INTEGER m, nsrt
      INTEGER i, j, k, l
      INTEGER i1, j1, k1, l1

*  Get subscript ranges

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)


      i1 = arg_lo_ss(X_AXIS, ARG1)
      DO 500 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         k1 = arg_lo_ss(Z_AXIS, ARG1)
         DO 400 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

            l1 = arg_lo_ss(T_AXIS, ARG1)
            DO 300 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

               nsrt = 0
               nbad = 0

               j1 = arg_lo_ss(Y_AXIS,ARG1)
               DO 100 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

                  IF (arg_1(i1,j1,k1,l1) .NE. bad_flag(1)) THEN
                     nsrt = nsrt + 1
                     result(i,nsrt,k,l) = arg_1(i1,j1,k1,l1)

                  ELSE
                     nbad = nbad + 1
                  END IF

                  j1 = j1 + arg_incr(Y_AXIS,ARG1)
 100           CONTINUE
      
*
* Compress argument, putting bad data at the end.
*
               DO 200 m = 1, nbad
                  m_indx = m + nsrt
                  result(i,m_indx,k,l) = bad_flag_result
 200           CONTINUE

               l1 = l1 + arg_incr(T_AXIS, ARG1)
 300        CONTINUE

            k1 = k1 + arg_incr(Z_AXIS, ARG1)
 400     CONTINUE

         i1 = i1 + arg_incr(X_AXIS, ARG1)
 500  CONTINUE
*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

	INTEGER FUNCTION ISUBSCR_CX ( world_coord, grid, idim, 
     .                                cx ,round_code )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* 9/97 *kob*   - NEW ROUTINE
*              - needed in order to implement new method of handling negative
*                time steps.  this routine is nearly identicle to ISUBSCRIPT 
*                except it will use cx_calendar to determine if t dimension
*                is a date or a time step.
* V541: *sh* 2/02 - added support for subspan modulo axes
* V600: *acm*6/06 - fix bug1419. for modulo axes, index at the end of the last 
*                   cell may round up to the next modulo replication 
* V600 *acm* 6/06 - fix declarations, found by solaris compiler
* V612 *acm* 8/08 - Bug 1594. For 64-bit, when translating to within axis 
*                   limits, the comparison IF (wcoord .GT. aend) yielded FALSE 
*                   when in fact the coordinate values should be equal. Use 
*                   TM_FFPEQ to test for equality first.
* V673: *acm* 10/11 Bug 1888. Single-precision calculations in the block starting
*                   * quick sol'n if axis points are regularly spaced
*                   did not give enough accuracy for axes defined in terms of 
*                   seconds.  Convert all this to double-precision calculations.
*       *acm* 4/12 6D Ferret: time axis may be in t or f direction. The time 
*                  dimension is now an arg to SECS_TO_TSTEP.
* V683: *acm* 10/12 Fix ticket 1973. If the coordinate value is on the boundary
*                   of the grid cell, precicision could cause the wrong index 
*                   to be returned.
* V683  *acm*10/12 Improve handling of F axes and info about the calendar of the grid.
* V695  *acm* 2/15 cx_calendar stores info about calendar formatting of T and F axes
* V71 12/16 *acm* For ticket 2158: working with true monthly time axes.

	include 'tmap_dims.parm'
#      include "tmap_dset.parm"
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include 'xcontext.cmn'

* calling argument declarations:
	INTEGER	grid, idim, round_code, cx
	REAL*8	world_coord

* internal variable declarations:
	LOGICAL	TM_DFPEQ, TM_ITS_SUBSPAN_MODULO, TM_FPEQ_SNGL, 
     .		ITSA_TRUEMONTH_AXIS, is_regular, calendar, true_month
	INTEGER	lo_look, hi_look, axis, ibot, itop, look,
     .		line_len, isubsc, num_mod
	REAL*8	SECS_TO_TSTEP, TM_WORLD, TM_WW_AXLEN,
     .		wwindex, wcoord, half_way, start, aend, span, 
     .		first, last, dsubsc, timefac
	REAL*4  delsubsc, half

* initialize
        isubsc = 0

* which axis are we on ?
	axis    = grid_line ( idim, grid )
	line_len = line_dim( axis )

* check for peculiar calls
	IF (  axis .EQ. mnormal
     .	 .OR. axis .EQ. munknown ) THEN
	   ISUBSCR_CX = axis
	   RETURN
	ELSEIF ( world_coord .EQ. unspecified_val8 ) THEN
	   ISUBSCR_CX = unspecified_int4
	   RETURN
	ENDIF

* time expressed as seconds since BC ?
	calendar = (idim .EQ. t_dim .OR. idim .EQ. f_dim) .AND. cx_calendar(idim,cx) 
	IF (idim.EQ.f_dim .AND. (line_t0(axis) .EQ. char_init20)) calendar = .FALSE.

	IF ( calendar ) THEN
* no negative needeed on world_coord, because it is not being passed 
* in as negative *kob*  9/97
	   wcoord = SECS_TO_TSTEP( grid, idim, world_coord )
	ELSE
	   wcoord = world_coord
	ENDIF

* special consideration for sub-span modulo axis outside its core range
	IF (TM_ITS_SUBSPAN_MODULO(axis) ) THEN
	   CALL TM_WW_AX_1_N(axis, start, aend)
	   IF ( wcoord.LT.start .OR. wcoord.GT.aend ) THEN
	      line_len = line_len + 1
	      is_regular = .FALSE.
	   ELSE
	      is_regular = line_regular(axis) .AND. .NOT.ITSA_TRUEMONTH_AXIS(axis)

	   ENDIF
	ELSE
	   is_regular = line_regular(axis) .AND. .NOT.ITSA_TRUEMONTH_AXIS(axis)
	ENDIF

* initialize pointers for axes with irregularly spaced points
	IF ( .NOT.is_regular ) THEN
	   ibot  = 1
	   itop  = line_len
	ENDIF

* Modulo axis: translate world coord to within axis range
	IF ( line_modulo( axis ) ) THEN
* ... begin by computing axis limits as outer edges of end boxes
	   span = TM_WW_AXLEN(axis)
	   CALL TM_WW_AXLIMS(axis, start, aend)
	    
	   IF ( ITSA_TRUEMONTH_AXIS(axis) ) THEN 
	      CALL TM_MONTH_TIME_FACTOR (grid, true_month, timefac)
	      start = start * timefac
	      aend = aend * timefac
	      span = span * timefac
	   ENDIF

	   IF (TM_ITS_SUBSPAN_MODULO(axis)) THEN
	      span = line_modulo_len(axis)
	      aend = start + span
	   ENDIF

* ... now translate to within axis limits saving modulo number

           IF (.NOT.TM_DFPEQ(wcoord, aend) .AND. (wcoord .GT. aend)) THEN
	      num_mod = ( wcoord - start ) / span
! 10/92 bug fix: if wcoord is an exact multiple of length (e.g. wccord=24.
!       start=0., span=12.) then modulo remap to top of ax rather than bottom
              IF ( wcoord .EQ. start+num_mod*span )
     .                          num_mod = num_mod - 1
	   ELSEIF ( wcoord .LT. start ) THEN
	      num_mod = ( wcoord - aend  ) / span		! (negative)
	   ELSE
	      num_mod = 0
	   ENDIF
	   wcoord = wcoord - num_mod*span
	ENDIF

* get positions of first and last points on axis
        
        IF ( is_regular ) THEN
	   first = line_start( axis )
	   last  = first + line_delta(axis) * (line_len-1) !4/94 was *line_len
        ELSE
           first = TM_WORLD(       1, grid, idim, box_middle)
           last  = TM_WORLD(line_len, grid, idim, box_middle)
	ENDIF

* immediate solutions for given point beyond axis ends
	IF ( wcoord .LE. first .AND. (.NOT.line_modulo(axis)) ) THEN
	   isubsc = 1
	ELSEIF ( wcoord .GE. last .AND. (.NOT.line_modulo(axis)) ) THEN
	   isubsc = line_len

* quick sol'n if axis points are regularly spaced
* Fixing bug 1973 - See if the input was the box_lo or box_hi 
* using a test, is the computed index location halfway between 
* two integers, and if so return the correct index.

	ELSEIF ( is_regular ) THEN
	   dsubsc = (wcoord-first)/line_delta(axis)
	   isubsc = INT( dsubsc )

	   half_way = line_delta(axis)/2.
	   half = 0.5

	   IF ( round_code .EQ. round_up ) THEN
	      delsubsc = ABS( REAL(dsubsc)-FLOAT(isubsc) )
	      IF ( TM_FPEQ_SNGL(delsubsc, half) )
     .         dsubsc = (wcoord+half_way-first)/line_delta(axis)
	   ENDIF  
	   IF ( round_code .EQ. round_dn ) THEN
	      delsubsc = ABS( REAL(dsubsc)-FLOAT(isubsc) )
	      IF ( TM_FPEQ_SNGL(delsubsc, half) )
     .         dsubsc = (wcoord-half_way-first)/line_delta(axis)
	   ENDIF  

	   dsubsc = dsubsc + .5  ! to get the right result from INT()
	   isubsc = INT( dsubsc )

	   IF ( TM_DFPEQ(dsubsc,DBLE( isubsc )) ) THEN
* ...... value is on box boundary
	      IF     ( round_code .EQ. round_up ) THEN
	         isubsc = isubsc + 1
	      ELSEIF ( round_code .EQ. round_dn ) THEN
	         CONTINUE
	      ELSE
	         STOP 'ISUBSCR_CX round code'
	      ENDIF
	   ELSE
* ...... value is not on box boundary
	      isubsc = isubsc + 1
	   ENDIF

	ELSE
* binary search if axis points are irregularly spaced
* initialize search
	   lo_look  = ibot - 1
	   hi_look  = itop + 1	
	   look     = ( lo_look + hi_look ) / 2

* top of search loop
 100       wwindex = TM_WORLD(look, grid, idim, box_middle)
	   IF ( wcoord .GE. wwindex ) THEN

* answer is somewhere above current "look" position
* keep looking at higher values setting this as new low limit for search
	      lo_look = look
	      look = ( look + hi_look + 1 ) / 2

	   ELSE
* answer is somewhere below current "look" position
* keep looking at lower values setting this as new high limit for search
	      hi_look = look
	      look = ( look + lo_look ) / 2

	   ENDIF

* have we narrowed it to a 1 point range ?
	   IF ( hi_look - lo_look .LE. 1 ) THEN

* yes - we found it - choose box containing it
* ... box boundary between lo_look and hi_look
	      half_way = TM_WORLD(hi_look, grid, idim, box_lo_lim)

* value on box boundary ?
	      IF ( TM_DFPEQ( half_way, wcoord ) ) THEN
	         IF     ( round_code .EQ. round_up ) THEN
		    isubsc = hi_look
	         ELSEIF ( round_code .EQ. round_dn ) THEN
		    isubsc = lo_look
	         ELSE
	            STOP 'ISUBSCR_CX round code'
	         ENDIF

* no. value in upper half of box ?
	      ELSEIF ( wcoord .GE. half_way ) THEN
	         isubsc = hi_look

* no. value must be in lower half of box
	      ELSE
	         isubsc = lo_look

	      ENDIF
	   ELSE

* no - keep looking
	      GOTO 100
	   ENDIF
	ENDIF

* add modulo axis correction
	IF ( line_modulo(axis) ) THEN
	   ISUBSCR_CX = isubsc + num_mod*line_len
	ELSE
	   ISUBSCR_CX = isubsc
           IF (isubsc .GT. line_len) ISUBSCR_CX = line_len
	ENDIF
        
* If still not found, apply quick solutions for given point beyond axis ends
        IF (isubsc .EQ. 0) THEN
	   IF ( wcoord .LE. first ) THEN
	      ISUBSCR_CX = 1
	   ELSEIF ( wcoord .GE. last) THEN
	      ISUBSCR_CX = line_len
	   ENDIF
        ENDIF

	RETURN
	END

        SUBROUTINE CD_GET_DSG_COORD_EXTREMES(dset, ivcd,  ivtm,
     .                             idim, coord_min, coord_max, status)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*.
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Return the extreme values of the indicated DSG coordinate variable
* If the variable has an "actual_range" attributes use it.
* Otherwise compute the values from the data.
* Then retain the results in actual_range.

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* v720 4/2017 *sh*
* V74+ 4/18 *acm* Dealing with variables that do not have actual_range attribs.
* V74+ 7/18 *acm* Allow for range min = max for vertical, elsewhere this will
*                  be allowed unless its a profile set.
* V74+ 7/18 *acm* Argument idim used for testing which coordinates are required
* v751 *acm*  6/19 Allow for longer strings as attribute values


* argument definitions:
*       dset      - dataset number for already opened CDF file
*       ivcd      - netCDF variable id number         ("cd" for "netCDF")
*       ivtm      - XDSET_INFO COMMON variable number ("tm" for "TMAP")
*	idim	  - direction of this coordinate variable
*       status    - return status

* include files
        include 'netcdf.inc'
        include 'tmap_errors.parm'
        include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
        include 'xbuild_grids.cmn'
        include 'xdset_info.cmn_text'
        external xdset_info_data
        include 'xio.cmn_text'
        external xio_data
        include 'xdyn_linemem.cmn_text'
        include 'xtm_grid.cmn_text'

* argument declarations
        INTEGER  dset, ivcd, ivtm, idim, status
        REAL     coord_min, coord_max

* local variable declarations:
        LOGICAL NC_GET_ATTRIB, got_it
        INTEGER TM_LENSTR1, i, lm, attlen, attoutflag, vtype, vlen
        CHARACTER    buff*128, vname*128
        REAL    vals(2), coord, bad

* local parameter definitions:
        INTEGER     maxlen
	LOGICAL	    do_warn
	PARAMETER ( maxlen = 128,
     .              do_warn = .TRUE. )

* initialize
        vname = ds_var_code(ivtm)   ! may be >8 chars, but its just for err msg
	vlen = TM_LENSTR1(vname)

* is there an 'actual_range' attribute?

       got_it = NC_GET_ATTRIB( dset, ivcd, 'actual_range',
     .                 do_warn, vname, maxlen, attlen, attoutflag, 
     .                 buff, vals )

* maybe we're done -- either cuz the file contained the actual_range
* attribute, or because this routine has been called earlier to compute it

        IF (got_it) THEN
           IF (vals(2) .LT. vals(1))  GOTO 5001  ! should do more checking than this?
           coord_min = vals(1)
           coord_max = vals(2)
           status = merr_ok
           RETURN
        ENDIF

        lm = dsg_loaded_lm(ivtm)
        bad = ds_bad_flag(ivtm)

! DSGTBD: need to deal with unmatched missing_value and _FillValue
        coord_min = arbitrary_large_val8
        coord_max = arbitrary_small_val8

        DO i = 1, lm_size(lm)
           coord = dsg_linemem(lm)%ptr(i)
           IF (coord .EQ. bad) CYCLE
           IF (coord .LT. coord_min) coord_min = coord
           IF (coord .GT. coord_max) coord_max = coord
        ENDDO

! Invalid coordinates are important if they are in the feature-type direction
! or if its the time coordinate

        IF (coord_min.EQ.arbitrary_large_val8) THEN
	   IF (idim .EQ. t_dim) GOTO 5002
	   IF (idim .EQ. y_dim .AND. dsg_orientation(dset).EQ. x_dim) GOTO 5002
	   IF (idim .EQ. dsg_orientation(dset) ) GOTO 5002
        ELSE

! Store the attribute actual_range

           CALL CD_GET_VAR_TYPE (dset, ivcd, vname, vtype, status)

           attlen = 2
           attoutflag = 1
           vals(1) = coord_min
           vals(2) = coord_max
           CALL CD_PUT_NEW_ATTR (dset, ivcd, 'actual_range', 
     .        vtype, attlen, attoutflag, buff, vals, status) 

           status = merr_ok
        ENDIF

 5000   RETURN

 5001	CONTINUE
        CALL TM_NOTE("Corrupted coordinate in DSG file actual_range attribute for: "
     .                  //vname(:vlen), lunit_errors )
 5002	CONTINUE
        CALL TM_NOTE("Corrupted coordinate in DSG file. No valid data in: "
     .                  //vname(:vlen), lunit_errors )
        status = 0 

	END

	subroutine CONSEG_SECTION(xc, yc, nx, ny, nxs, nys, px, py, z, 
     .    xf, xoff, yf, yoff, zlev, ndecl, lwgtl, lclr, nlev, hgt, 
     .    narc, ang, ilo, ihi, jlo, jhi, xadd, lmin, lmax)

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* 
C  v581 5/2005 *acm* From conseg.F for one modulo replication of a contour plot
C  v67  2/2011 *acm* Fix ticket 1799; do contouring in larger sections.

	include 'MISS.INC'

	dimension zz(285,285),z(nxs,nys),px(nx),py(ny)
	dimension zlev(2),ndecl(2),lwgtl(2),lclr(2)
        integer izz, lseg

        izz = 285
        lseg = (izz-1)-2

C       Calculate the beginning and ending index values (iam,ibm) and
C       the number of index values (nxx) along the X axis in this 
C       zz() subregion.

	ia = 1 
 40	ib = min0(ia+lseg,nx) 
	lrem = nx-ib 
	if (lrem*(lseg-lrem)) 60,60,50 
 50	ib = (1+ia+nx)/2 
 60	iam = max0(ia-1,1) 
	ibm = min0(ib+1,nx) 
	lxm = ibm-iam 
	iim = 1+(ia-iam)
	nxx = (ib-ia)+1 
	
	
C       Calculate the beginning and ending index values (jam,jbm) and
C       the number of index values (nyy) along the Y axis in this 
C       zz() subregion.

	ja=1 
 80	jb = min0(ja+lseg,ny) 
	lrem = ny-jb 
	if (lrem*(lseg-lrem)) 100,100,90 
 90	jb = (1+ja+ny)/2 
 100	jam = max0(ja-1,1) 
	jbm = min0(jb+1,ny) 
	lym = jbm-jam 
	jjm = 1+(ja-jam)
	nyy = (jb-ja)+1 
	
	
C       Check all the z values for "goodness" and replace the bad ones with 1.e35 ?
C       Fill in the zz() subregion with values from z().

	do 130 i=iam,ibm 
	   ii =  i-iam+1 
	   do 120 j=jam,jbm 
	      jj =  j-jam+1 
	      if ((zle.and.z(i,j).le.cmzle).or.
     1	   (zeq.and.z(i,j).eq.cmzeq).or.
     2	   (zge.and.z(i,j).ge.cmzge)) then
		 zz(ii,jj)=1.e35
	      else
		 zz(ii,jj)=z(i,j)
	      endif
 120	   continue
 130	continue
	   

C       Actually contour the zz() subregion.

	call contur(zz,izz,izz,px(iam),py(jam),nxx,nyy,xf,xoff,
     .    yf,yoff,zlev,ndecl,lwgtl,lclr,nlev,hgt,narc,ang,xc,yc,
     .    xadd,lmin,lmax) 

C       This is the Y axis loop

	ja = jb 
	if (ja-ny) 80,160,160

C       This is the X axis loop

 160	ia = ib 
	if (ia-nx) 40,170,170 

 170	return 
	end 

	SUBROUTINE GET_NEW_CX ( dflt_cx, new_cx, apply_cx, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* using the default context supplied and the context modifiers given with the
* command produce a new context

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 9/22/87 - code stoled from GET_CMND_DATA
* revision 0.1 - 7/27/88 - added dflt_cx to get_context_mods call
* V200:  5/19/89 - transforms not permitted on command line
* V530:  8/00 *sh* - added data type sensitivity
* V600 *acm* 3/06  fixing bugs nferdims39&1390, use apply_cx to say whether
*                  to apply command context to grave-accent expressions.
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'xcontext.cmn'
	include 'xprog_state.cmn'

* calling argument declarations
	INTEGER		dflt_cx, new_cx, status
        LOGICAL         apply_cx

* local variable declarations
	INTEGER		idim, cmnd_mods_cx
	CHARACTER	ALG_TRANS_CODE*3

* de-allocate old context space
	cx_stack_ptr = cx_stack_ptr_base

* start with the default context for the evaluation of this expression
	CALL TRANSFER_CONTEXT ( dflt_cx, new_cx )

* create a clean stack slot to receive the command context modifications
	cmnd_mods_cx = cx_stack_ptr + 1
	CALL INIT_CONTEXT_MODS ( cmnd_mods_cx )

* translate the command context modifiers into the modifications buffer
	CALL GET_CONTEXT_MODS ( dflt_cx,
     .				cmnd_buff,
     .				cmnd_mods_cx,
     .				max_qual_list,
     .				num_qualifiers,
     .				qual_start,
     .				qual_end,
     .				unknown_qual_ok,
     .				status	)
	IF ( status .NE. ferr_ok ) GOTO 5000

* transformation given on command line ?
	DO 100 idim = 1, nferdims
 100	IF (cx_trans(idim,cmnd_mods_cx) .NE. trans_no_transform)
     .        GOTO 5010

        IF (apply_cx) THEN

* modify the command context with the given modifiers
	   CALL APPLY_CONTEXT_MODS
     .			( cmnd_mods_cx, new_cx, replace_context, status )
	   IF ( status .NE. ferr_ok ) GOTO 5000
        ENDIF

* set default data type

	cx_type(new_cx) = unspecified_int4

	RETURN

* error exit
 5000	RETURN
 5010	CALL ERRMSG( ferr_syntax, status,
     .	'transforms not permitted on command: @'//
     .		ALG_TRANS_CODE( cx_trans(idim,cmnd_mods_cx) ), *5000 )
	END

	SUBROUTINE TM_GARB_COL_GRIDS (dset)


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* set use counts for grids and axes. Remove temporaries.

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 2/92
* V5.0 *sh* 7/99 - with the change in definition to char_init this routine
*		may **for the first time** be doing work!!
*		Found a logic bug in the loop that re-assigns ds_grid_number
* V5.1 *sh* 4/00 - using dynamic grids and axes
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing

* argument definitions:
*	dset - the current data set

* include files
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'xtm_grid.cmn_text'
	        include 'xdset_info.cmn_text'
        external xdset_info_data

* calling argument declarations:
      INTEGER dset

* local variable declarations:
      INTEGER igrid, iaxis, idim

* reset the use counts of all newly-created grids to zero
* (They are set to 1 when allocated, but we set them to zero to put them
*  on a par with grids not created by this dtaa set, but used by it)
*  recatalog the grids defined by this data set
	igrid = 0		! to get start of linked list
 10	CALL TM_NEXT_TMP_GRID( igrid, *19)
	   grid_use_cnt(igrid) = 0
	   GOTO 10
 19	CONTINUE

* bump the use counts of grids used by variables in this data set
	CALL TM_DSET_USE_GRIDS( dset )

*  recatalog the grids defined by this data set
 100	igrid = 0		! to get start of linked list
	   CALL TM_NEXT_TMP_GRID( igrid, *199)

* ... bump use counts on all lines used by these grids
	   IF ( grid_name(igrid) .NE. char_init ) THEN
	      DO 110 idim = 1, nferdims
 110	      CALL TM_USE_LINE( grid_line(idim,igrid) )

!* ... a use count of zero indicates that this explicit parent grid is not used
!*	set its use count to 1 to indicate that it uses itself
!	      IF ( grid_use_cnt(igrid) .EQ. 0 ) grid_use_cnt(igrid) = 1

* ... recatalog as a valid dynamic grid
	      CALL TM_RE_ALLO_TMP_GRID( igrid )

	   ELSE
	      CALL TM_USE_DYN_GRID( igrid )  ! to avoid error trap
	      CALL TM_DEALLO_DYN_GRID_SUB( igrid )

	   ENDIF

	   GOTO 100
 199	CONTINUE


* recatalog the axes defined by this data set -- use counts are zero so far
 300	iaxis = 0	! to get start of linked list
	   CALL TM_NEXT_TMP_LINE( iaxis, *1000)

* ... add to list of valid dynamic lines
	   IF ( line_name(iaxis) .NE. char_init16 ) THEN

* ... a use count of zero indicates that this axis was defined but never used
*	(as, for example, in the file climatological_axes.cdf)
*	Flag it is a keeper -- requiring explicit deletion
	      IF ( line_use_cnt(iaxis) .EQ. 0 )
     .					line_keep_flag( iaxis ) = .TRUE.

	      CALL TM_RE_ALLO_TMP_LINE( iaxis )

	   ELSE
	      CALL TM_USE_LINE( iaxis )  ! to avoid error trap
	      CALL TM_DEALLO_DYN_LINE( iaxis )

	   ENDIF

	GOTO 300


* successful completion
 1000	RETURN

	END

	SUBROUTINE LEVSRT
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)levsrt.F	1.1    3/10/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C***
* v581 *acm* 3/05 open levels (-INF) (INF)

	INCLUDE 'parampl5_dat.decl'
	INCLUDE 'PARAMPL5.DAT'
        INCLUDE 'cont_inc.decl'
	INCLUDE 'CONT.INC'

        integer lstart, lend

	LOGICAL BLNK

        lstart = 1
        IF (neginf) lstart = lstart + 1
        lend = nlev
        IF (posinf) lend = lend - 1
c        IF (lstart+1 .GT. lend) GOTO 320

300	BLNK=.FALSE.

	DO 310 I=lstart+1,lend
	IF(ZLEV(I-1).GT.ZLEV(I))THEN
		BLNK=.TRUE.
		Z=ZLEV(I)
		J=LDIG(I)
		K=LWGT(I)
		JC=LCLR(I)
		ZLEV(I)=ZLEV(I-1)
		LDIG(I)=LDIG(I-1)
		LWGT(I)=LWGT(I-1)
		LCLR(I)=LCLR(I-1)
		ZLEV(I-1)=Z
		LDIG(I-1)=J
		LWGT(I-1)=K
		LCLR(I-1)=JC
	ENDIF
310	CONTINUE
	IF(BLNK)GOTO 300
320	RETURN
	END

	PROGRAM PPLUS
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
C**    @(#)pplus.F	1.2    9/8/88
C**
C**
C***********************************************************************
C**
C**                 PLOT+ Scientific Graphics System
C**
C***********************************************************************
C**
C**
C
C     Mod *JD* 3.5.91 to use unit 6 rather than 5 for unix terminal lun
C     Had problem with buffered output.  See also opnppl
C v552 *acm* 3/03 Longer strings: changes for multi-line labels

	INCLUDE 'PLT.INC'
	INCLUDE 'SYSTEM.INC'
	INCLUDE 'SWITCH.INC'
C
	CHARACTER FROM*80,TEMP*2048,LINE*2048,TYPE*81
	CHARACTER COMBUF(5)*2048,FILE*81,DTE*24
	DATA COMBUF/5*' '/,FILE/'echo.file'/

C
C	TURN ON LOGGING AND DO PPLUS LOGGING
C
	LOGITF=.TRUE.
	CALL LOGGER('PPLUS')
C
C	INITIALIZE PLOT5+ AND SET LOGICAL UNITS
C
	ICODE=1
#ifdef unix

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
*     Mod *JD* 3.91 Original has unit 5 for tty  -- change to 6
C	CALL OPNPPL(FILE,23,1,16,24,5,1,2,11,21)
	CALL OPNPPL(FILE,23,1,16,24,6,1,2,11,21)
#else
        CALL OPNPPL(FILE,23,1,6,24,5,20,22,11,21)
#endif
C
C	CHECK FOR STARTUP FILE
C
#ifdef unix
	call getenv('PPL$STARTUP',type)
	len=lnblk(type,81)
	IF(len.ge.1)THEN
#else
        STATUS=LIB$GET_SYMBOL('PPL$STARTUP',TYPE,LEN)
        IF(STATUS.EQ.1)THEN
#endif
C
C	    TURN OFF ECHO AND RUN PLOT5+
C
	    ECHOF=.FALSE.
	    LINE=' '
#ifdef unix
	    from=type(1:len)
#else
	    CALL WLDFLE('SY:.PPC',TYPE(1:LEN),FROM,STATUS,IFLAG)
#endif
	    CALL PPLCMD(FROM,LINE,IS,COMBUF,5,0)
	    ECHOF=.TRUE.
	ENDIF
C
C	CHECK FOR COMMAND LINE COMMAND
C
#ifdef unix
	ic=iargc()
	if(ic.ge.1)then
	    istp=1
	    do 1 i=1,ic
		call getarg(i,temp)
		len=lnblk(temp,2048)
		if(istp.eq.1)then
		    line=temp(:len)
		    istp=len+1
		else
		    line(istp:)=' '//temp(:len)
		    istp=istp+len+1
		endif
1	    continue
	else
	    line=' '
	    istp=1
	endif
	istp=istp-1
#else
        STAT=LIB$GET_FOREIGN(LINE,,ISTP)
#endif
	IS=1
#ifdef unix
	IF(INDEX(LINE(:ISTP),':Q').EQ.0)THEN
*     Mod *JD* 3.19 to write to unit 6, not 5, as in the original
C           WRITE(5,'(''  PLOT PLUS  V 1.1  05-MAR-88 (unix)'')') 
            WRITE(6,'('' PLOTPLUS  V 1.1 March 91 (unix)'')') 
	    CALL FDATE(DTE)
C *JD*      WRITE(5,9999)DTE  
	    WRITE(6,9999)DTE 
9999	    FORMAT(2x,A24) 
#else
        IF(INDEX(LINE(:ISTP),'/Q').EQ.0)THEN
            WRITE(LTTOUT,'('' PLOTPLUS  V 1.1 March 91 (vms)'')') 
            CALL DATE(DTE)
            CALL TIME(TME)
            WRITE(5,9999)DTE,TME 
9999        FORMAT(1x,A11,A15) 
#endif
	ENDIF
	IF(LINE.EQ.' '.OR.ISTP.EQ.0)THEN
C
C	NO COMMAND ON LINE
C
#ifdef unix
	    FROM='/dev/tty'
#else
	    FROM='TT:'
#endif
	    LINE=' '
	ELSE
	    TEMP=LINE(IS:ISTP)
	    ISPC=INDEX(TEMP,' ')
	    IF(ISPC.GT.0)THEN
		FROM=TEMP(:ISPC-1)
		LINE=TEMP(ISPC+1:)
		IS=ISTP-IS+1-ISPC
	    ELSE
		FROM=TEMP
		LINE=' '
		IS=0
	    ENDIF
	    TEMP=FROM
	    DEFLTS(1)=.TRUE.
	    CALL GTQUAL(TEMP,ITLEN,IER,IPOS)
	    ECHOF=SECHO
	    DEBUGF=SDEBUG
	    IF(SLATCH)THEN
		SLATCH=.FALSE.
		DO 100 I=1,NFLAGS
100		DEFLTS(I)=FLAG(I)
	    ENDIF
#ifdef unix
	    from=temp(1:itlen)
#else
	    CALL WLDFLE('SY:.PPC',TEMP(1:ITLEN),FROM,STATUS,IFLAG)
#endif
	    TERMF=.FALSE.
	    DEFLTS(1)=.FALSE.
	ENDIF

C
C	RUN PLOT5+ INTERACTIVE
C
	CALL PPLCMD(FROM,LINE,IS,COMBUF,5,0)
C
C	IF PPLCMD RETURNS THEN EXIT 
C
	CALL CLSPPL
C *kob* 4/99 minor mod - add (0) to exit call
	CALL EXIT(0)
	END

	SUBROUTINE CD_WRITE_ATTRIB(cdfid,vname,att,string,append,status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Write a character string attribute to a netCDF file
* If the variable is equal to the parameter pcdf_global then make it a
* global attribute.

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 3/92
*               10/92: set into define mode
* 10/2005 NOTE: do not change this for the attribute-access changes. 
*               This routine accesses the newly-created file using 
*               netcdf calls as always. The values sent in come from
*               the linked-list structure but output is all the same.
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files
* V697 12/15 *acm* Increased length of command-line string and risc_buff buffer
* V697  2/16 *acm* DO NOT increase length of command-line string and risc_buff buffer

* argument definitions:
*     cdfid   - netCDF id number for already opened CDF file
*     vname   - name of previously created netCDF variable
*     att     - name of attribute
*     string  - what the attribute is set equal to
*     append  - append to or replace the existing string, if any
*     status  - return status

* include files
        include 'netcdf.inc'
	include 'tmap_errors.parm'
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
	include 'cdf_tmap.parm'
#include "gt_lib.parm"
	include 'cd_lib.parm'
        include 'xio.cmn_text'
        external xio_data
        include 'xrisc_buff.cmn'

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

* argument declarations
      LOGICAL append
      INTEGER cdfid, status
      CHARACTER*(*) vname, att, string

* local variable declarations:
      INTEGER TM_LENSTR1, 
     .        vlen, alen, slen, tlen, cdfstat, varid, attype, attlen, 
     .        len_app, bufflen
     
      CHARACTER buff*10240

      INTEGER tt  ! nice short name
      EQUIVALENCE (tt,lunit_errors)

      bufflen = 10240

* initialize
      vlen = TM_LENSTR1( vname )
      alen = TM_LENSTR1( att )
      slen = LEN( string )
      tlen = TM_LENSTR1(string)
      attype = 0 
      attlen = 0 
      cdfstat = NF_NOERR
      
* locate the variable id
      IF ( vname .EQ. pcdf_global ) THEN
         varid = NF_GLOBAL
      ELSE
#ifdef usingDODSf2cUnderscore
         cdfstat = NF_INQ_VARID_(cdfid, vname(:vlen), varid)
#else
         cdfstat = NF_INQ_VARID(cdfid, vname(:vlen), varid)
#endif
         IF ( cdfstat .NE. NF_NOERR ) GOTO 5100
      ENDIF

* does the attribute already exist ?
#ifdef usingDODSf2cUnderscore
      cdfstat = NF_INQ_ATT_(cdfid, varid, att(:alen), attype, attlen)
#else
      cdfstat = NF_INQ_ATT(cdfid, varid, att(:alen), attype, attlen)
#endif

      IF ( cdfstat .EQ. NF_NOERR ) THEN
         IF ( attype.NE.NF_BYTE .AND. attype.NE.NF_CHAR ) GOTO 5200
         IF ( attlen+tlen .GT. bufflen .AND. append ) THEN
            buff = att
            CALL TM_NOTE( 'CDF attribute '//buff(:alen)//
     .           ' is too long', tt )
            IF ( attlen .GT. bufflen ) THEN
               CALL TM_NOTE( 'no text could be appended', tt )
               GOTO 1000
            ELSE
               CALL TM_NOTE( 'it may be truncated', tt )
            ENDIF
         ENDIF
         IF ( attlen .GT. bufflen .AND. (.NOT.append) ) THEN
            buff = att
            CALL TM_NOTE( 'CDF attribute '//buff(:alen)//
     .           ' is too long', tt )
            CALL TM_NOTE( 'it may be truncated', tt )
         ENDIF
      ENDIF

* put CDF into define mode so attributes can be written
      CALL CD_SET_MODE(cdfid, pcd_mode_define, status)
      IF ( status .NE. merr_ok ) RETURN

      IF ( cdfstat.EQ.NF_NOERR .AND. append ) THEN
* append to the attribute
#ifdef usingDODSf2cUnderscore
	 cdfstat = NF_GET_ATT_TEXT_(cdfid, varid, att(:alen), buff)
#else
	 cdfstat = NF_GET_ATT_TEXT (cdfid, varid, att(:alen), buff)
#endif
         IF ( cdfstat .NE. NF_NOERR ) THEN
            buff = att
            CALL TM_NOTE( 'Error getting CDF attribute in existing file '
     .        , tt)
            GOTO 1000
         ENDIF
            
         risc_buff = string
         len_app = bufflen - attlen - 1
#ifdef usingDODSf2cUnderscore
         IF (len_app .GT. 0) THEN
            cdfstat = NF_PUT_ATT_TEXT_(cdfid, varid, att(:alen),
     .             attlen+slen, buff(:attlen)//risc_buff(1:slen))
         ELSE
            cdfstat = NF_PUT_ATT_TEXT_(cdfid, varid, att(:alen),
     .             attlen+slen, buff(:attlen))
         ENDIF
#else
         IF (len_app .GT. 0) THEN
            cdfstat = NF_PUT_ATT_TEXT (cdfid, varid, att(:alen),
     .             attlen+slen, buff(:attlen)//risc_buff(1:slen))
         ELSE
            cdfstat = NF_PUT_ATT_TEXT (cdfid, varid, att(:alen),
     .             attlen+slen, buff(:attlen))
         ENDIF
#endif
      ELSE
* write the attribute
#ifdef usingDODSf2cUnderscore
         cdfstat = NF_PUT_ATT_TEXT_(cdfid, varid, att(:alen),
     .             slen, string)
#else
         cdfstat = NF_PUT_ATT_TEXT (cdfid, varid, att(:alen),
     .             slen, string)
#endif
      ENDIF
      IF ( cdfstat .NE. NF_NOERR ) GOTO 5300

* successful completion
 1000 status = merr_ok
      RETURN

 5100 CALL TM_ERRMSG
     . ( merr_unkvar, status, 'CD_WRITE_ATTRIB', unspecified_int4,
     .   unspecified_int4,
     .  'variable doesnt exist in CDF file',
     .  vname(:vlen), *5900 )

 5200 WRITE (risc_buff, *) 'incompatible data type of CDF attribute ',
     .                      att(:alen)
      alen = TM_LENSTR1(risc_buff)
      CALL TM_ERRMSG
     . ( merr_gridpredef, status, 'CD_WRITE_ATTRIB', unspecified_int4,
     .   unspecified_int4, risc_buff(:alen), 
     .   no_errstring, *5900 )

 5300 CALL TM_ERRMSG
     . ( cdfstat+pcdferr, status, 'CD_WRITE_ATTRIB', unspecified_int4,
     . no_varid, 'cannot write to CDF output file',
     . no_errstring, *5900 )

* error exit
 5900   RETURN
	END

	CHARACTER*(*) FUNCTION FULL_UVAR_NAME(uvar, len)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* append to the given user variable name the data set information
*	var[D=dset_name]

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V402:
* V420:  4/96 - document "(/D default)" on pdset_irrelevant variables
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
* V698 2/16 *acm*  For ticket 1786: if mode_upcase is canceled write axis name
*                  using original upper/lowercase spelling
* V698  2/16 *acm* For ticket 2352: variables defined with LET/D are
*                  added to that dataset in the attribute structure
* V720 *acm* 5/17 Implement specific calls in place of CD_GET_VAR_INFO

        IMPLICIT NONE
* calling argument declarations:
	INTEGER	uvar

* local variable declarations:

	INTEGER TM_LENSTR1, len, len2
	INTEGER dset, varid, status

	include 'tmap_dims.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'ferret.parm'
	include	'xvariables.cmn'
	include	'xprog_state.cmn'
	include 'errmsg.parm'

* variable name and definition
*	len = TM_LENSTR1(uvar_name_code(uvar))
        CALL string_array_get_strlen1(uvar_name_code_head,uvar,len)
	FULL_UVAR_NAME = uvar_name_code(uvar)(:len)

* Get the original upper/lowercase spelling if mode upcase is canceled.
	IF (.NOT.mode_upcase_output) THEN  ! get original variable name
	   dset = pdset_uvars
	   CALL CD_GET_VAR_ID (dset, uvar_name_code(uvar), varid, status)
	   IF (status .NE. ferr_ok) THEN
              dset = uvar_dset(uvar)
	      CALL CD_GET_VAR_ID (dset, uvar_name_code(uvar), varid, status)
	   ENDIF
	   IF (status .EQ. ferr_ok) 
     .      CALL CD_GET_ID_VARNAME (dset, varid, FULL_UVAR_NAME, status)
	ENDIF

	IF (uvar_dset(uvar) .GT. pdset_irrelevant) THEN
	   len2 = TM_LENSTR1(ds_name(uvar_dset(uvar)))
	   FULL_UVAR_NAME = FULL_UVAR_NAME(:len)//'[D='//
     .			ds_name(uvar_dset(uvar))(:len2)//']'
	   len = len + len2 + 4
	ELSEIF (uvar_dset(uvar) .EQ. pdset_irrelevant) THEN
	   FULL_UVAR_NAME = FULL_UVAR_NAME(:len)//' (/D default)'
	   len = len + 13
	ENDIF
	IF (uvar_remote(uvar)) THEN
	   FULL_UVAR_NAME = FULL_UVAR_NAME(:len)//' (/REMOTE)'
	   len = len + 10
	ENDIF

	RETURN
	END

      SUBROUTINE RESET_AXIS (dset, varid, varname, attname, attbuff, 
     .     val, status) 


*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* execute the SET command

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA 
* 3/20/2006
* V600  4/06 *acm* - additional declarations found by Solaris compiler
*
* Set axis attributes as in SET AXIS; called by edit_attribute.F
* doing SET ATT axname.attribute=

	include 'tmap_dims.parm'
	include 'tmap_errors.parm'
#	include "tmap_dset.parm"
        include 'xtm_grid.cmn_text'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'xunits.cmn_text'
	include 'xvariables.cmn'
        include 'calendar.decl'
        include 'calendar.cmn'

* Argument declarations

      CHARACTER*(*) varname, attname, attbuff
      INTEGER dset, varid, status
      REAL val

* Internal declarations

      REAL*8  TM_WW_AXLEN, axwwlen
      INTEGER STR_SAME, TM_GET_LINENUM, TM_LENSTR1, TM_UNIT_ID, 
     .        TM_GET_CALENDAR_ID, axis, i, since_T0, units, cal_id, 
     .        year, month, day, hour, minute, second, slen
      LOGICAL TM_HAS_STRING, its_changed, ok_cal
      CHARACTER*128 buff1

        buff1 = attname
 	axis = TM_GET_LINENUM( varname)
        IF ( axis .EQ. unspecified_int4 ) GOTO 5100
* MODULO
	IF ( STR_SAME(buff1, 'modulo') .EQ. 0) THEN
	   IF (val .EQ. unspecified_val4) THEN
	      val = 0.0
	   ELSE
	      val = ABS(val)  ! ABS to tolerate negatives
	   ENDIF
	   its_changed = .NOT.line_modulo(axis)
     .		    .OR.  val .NE. line_modulo_len(axis)
           line_modulo( axis ) = .TRUE.
	   line_modulo_len( axis ) = val

* ... wipe memory clear of stored variables - this could change all definitions
*      ( could be more selective for efficiency by checking to see where this
*      axis gets used )
	   IF ( its_changed ) THEN
              DO 100 i = 1,max_mr_avail
 100          IF ( mr_protected( i ) .NE. mr_deleted ) 
     .                                CALL DELETE_VARIABLE( i )
           ENDIF

           RETURN
        ENDIF

* DEPTH
	IF ( STR_SAME(buff1, 'depth') .EQ. 0) THEN
           IF ( line_direction(axis) .EQ. 'DU' ) THEN
	      line_direction(axis) = 'UD'
           ENDIF

           RETURN
        ENDIF


* POSITIVE
	IF ( STR_SAME(buff1, 'positive') .EQ. 0) THEN
           IF ( STR_SAME(attbuff,'up') .EQ. 0) THEN
	      line_direction(axis) = 'DU'
           ELSE IF ( STR_SAME(attbuff,'down') .EQ. 0) THEN
	      line_direction(axis) = 'UD'
           ELSE
              GOTO 5200
           ENDIF

           RETURN
        ENDIF

* CALENDAR 

        IF (STR_SAME(buff1, 'calendar') .EQ. 0) THEN
           IF ( line_direction(axis) .EQ. 'TI' ) THEN

              ok_cal = .FALSE.

              IF (attbuff(1:3) .EQ. '360') attbuff = '360_DAY' 
              IF (attbuff(1:3) .EQ. 'STA') attbuff = 'GREGORIAN' 
              IF (attbuff(1:3) .EQ. 'PRO') attbuff = 'GREGORIAN' 
              IF (attbuff(1:3) .EQ. 'COM') attbuff = 'NOLEAP' 
              IF (attbuff(1:3) .EQ. '365') attbuff = 'NOLEAP' 
              IF (attbuff(1:3) .EQ. '366') attbuff = 'ALL_LEAP' 

              DO 200 i = 1, mxcals
                 IF (attbuff(1:3) .EQ. allowed_calendars(i)(1:3) ) THEN
                    ok_cal = .TRUE.
                    line_cal_name(axis) = allowed_calendars(i)
                 ENDIF
200          CONTINUE

              IF (.NOT. ok_cal) GOTO 5300

           ENDIF

           RETURN
        ENDIF

* TIME 0RIGIN 

        IF (STR_SAME(buff1, 'time_origin') .EQ. 0) THEN
           IF ( line_direction(axis) .EQ. 'TI' .OR.
     .          line_direction(axis) .EQ. 'TT' ) THEN

              CALL TM_BREAK_DATE (attbuff, 1, year, month, day,
     .				  hour, minute, second, status)
              IF ( status .NE. ferr_ok ) GOTO 5400
              line_t0(axis) = attbuff
              line_direction(axis) = 'TI'

           ENDIF

           RETURN
        ENDIF

*  UNITS
* Note we do not change line direction with a resetting of units; line
* direction UD, DU, WE, SN stay as they were when they were input.

        IF (STR_SAME(buff1, 'units') .EQ. 0) THEN

           since_T0 = MAX( INDEX(attbuff,'since'), 
     .        INDEX(attbuff,'SINCE') )
           IF (since_T0 .GT. 0) GOTO 5500

           line_units(axis) = attbuff

* ... decode the units (code lifted from cd_get_1_axis)

           units = TM_UNIT_ID( line_units(axis) )

* Named calendar with unit=year gets length of year in that calendar.

           cal_id = TM_GET_CALENDAR_ID (line_cal_name(axis))
           IF (units .EQ. -6 .OR. units .EQ. -10) THEN
              IF (cal_id .EQ. d360) units = -9
              IF (cal_id .EQ. julian) units = -12
              IF (cal_id .EQ. noleap) units = -11
              IF (cal_id .EQ. all_leap) units = -8
           ENDIF

           line_unit_code(axis) = units
           IF  ( units.EQ.0 .AND. line_units(axis) .NE. ' ' ) THEN
              CALL WARN ('Units  not recognized: '//line_units(axis))
              CALL WARN ('They will not be convertible:')
           ENDIF
           IF ( units .GE. 0 ) THEN
              line_tunit(axis) = real4_init
           ELSE
              line_tunit(axis) = un_convert(line_unit_code(axis))
           ENDIF

* See if we are resetting from a generic XX or YY axis to a geographic one.

           IF (line_direction(axis) .EQ. 'XX') THEN
              IF ( units .EQ. 4 .AND. 
     .              TM_HAS_STRING(line_units(axis), 'deg')
     .             .OR. TM_HAS_STRING(line_units(axis), 'lon') ) THEN 
                 line_direction(axis) = 'WE'

* Should we set axis to modulo?
                 axwwlen = TM_WW_AXLEN(axis)
                 IF ( axwwlen .LE. 360.D0 ) THEN
                    line_modulo(axis) = .TRUE.
                    IF (line_modulo_len(axis) .EQ. 0.0D0)
     .                    line_modulo_len(axis) = 360.D0
                 ENDIF

              ENDIF
           ENDIF

           IF (line_direction(axis) .EQ. 'YY') THEN
              IF ( units .EQ. 4 .AND. 
     .                  TM_HAS_STRING(line_units(axis), 'deg')
     .             .OR. TM_HAS_STRING(line_units(axis), 'lat') ) THEN 
                    line_direction(axis) = 'SN'
              ENDIF
           ENDIF

* recheck units and see if we are resetting from a geographic axis to a 
* non-geographic one or a calendar to non-calendar.

           IF (line_direction(axis) .EQ. 'WE' .OR. 
     .         line_direction(axis) .EQ. 'XX' ) THEN
              IF ( units .NE. 4 ) THEN 
                 line_direction(axis) = 'XX'
                 IF (units .LT. 0) THEN
                    CALL WARN ('Units  not recognized for X axis: '
     .                 //line_units(axis))
                    CALL WARN ('They will not be convertible')
                 ENDIF
              ENDIF
           ENDIF

           IF (line_direction(axis) .EQ. 'SN' .OR. 
     .         line_direction(axis) .EQ. 'YY' ) THEN
              IF ( units .NE. 4 ) THEN 
                 line_direction(axis) = 'YY'
                 IF (units .LT. 0) THEN
                    CALL WARN ('Units  not recognized for Y axis: '
     .                 //line_units(axis))
                    CALL WARN ('They will not be convertible')
                 ENDIF
              ENDIF
           ENDIF

           IF (line_direction(axis) .EQ. 'DU' .OR. 
     .         line_direction(axis) .EQ. 'UD' ) THEN
               IF (units .LT. 0) THEN
                 CALL WARN ('Units  not recognized for Z axis: '
     .                 //line_units(axis))
                 CALL WARN ('They will not be convertible')
              ENDIF
           ENDIF

           IF (line_direction(axis) .EQ. 'TI' .OR. 
     .         line_direction(axis) .EQ. 'TT' ) THEN
              IF ( units .GE. 0 ) THEN 
                 line_direction(axis) = 'TT'
                 CALL WARN ('Units  not recognized for T axis: '
     .                 //line_units(axis))
                 CALL WARN ('They will not be convertible')
              ENDIF
           ENDIF


        ENDIF

	RETURN

* error exits

 5000	RETURN

 5100 buff1 = varname
      slen = TM_LENSTR1(buff1)
      CALL ERRMSG( ferr_invalid_command, status,
     .		 'unknown axis: '//buff1(1:slen),
     .               *5000 )
 5200 CALL ERRMSG( ferr_syntax, status,
     . 	         'positve may take the value UP or DOWN ',
     .               *5000 )
      
 5300 buff1 = attbuff
      slen = TM_LENSTR1(buff1)
      CALL ERRMSG( ferr_invalid_command, status,
     .	         'invalid calendar name: '
     .           //buff1(1:slen), 
     .               *5000 )

 5400 buff1 = attbuff
      slen = TM_LENSTR1(buff1)	
      CALL ERRMSG( ferr_syntax, status,
     .	         'invalid date string: '
     .           //buff1(1:slen), 
     .               *5000 )

 5500 CALL ERRMSG( ferr_syntax, status,
     .	         'specify TIME ORIGIN separately from UNITS ',
     .               *5000 )
      END

*
* tax_year.F
*
*
* This function returns time step values
*

*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*

      SUBROUTINE tax_tstep_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     . 'Returns time step values based on the new time origin' )
   
      CALL ef_set_num_args(id, 2)

      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 'variable with reference time axis')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'B')
      CALL ef_set_arg_unit(id, arg, ' ')
      CALL ef_set_arg_type(id, arg, STRING_ARG)

      CALL ef_set_arg_desc(id, arg, 'desired time origin')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE tax_tstep_compute(id, arg_1, arg_2, result)

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(2, mem2lox:mem2hix, mem2loy:mem2hiy,
     .           mem2loz:mem2hiz, mem2lot:mem2hit)

      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      CHARACTER*32 datebuf
      INTEGER iyear, dayofmon, hour, minute, second, prec, dlen
      CHARACTER*3 cmon
      CHARACTER*80 err_msg
      
      CHARACTER*20 t0string
      INTEGER t0year, t0day
      CHARACTER*3 t0mon

      REAL*8 ddate

      CHARACTER*16 axname(4), axunits(4)
      LOGICAL bkw1(4), mod1(4), reg1(4)
      CHARACTER*16 tunit

      REAL timesincet0

      INTEGER i,j,k,l
      INTEGER i1, j1, k1, l1
      INTEGER i2, j2, k2, l2

*     'dd-MMM-yyyy HH:mm:ss' or 'yyyy-MM-dd HH:mm:ss' date format
      prec = 6

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

*     Get the time origin (t0) string
      i2 = arg_lo_ss(X_AXIS, ARG2)
      j2 = arg_lo_ss(Y_AXIS, ARG2)
      k2 = arg_lo_ss(Z_AXIS, ARG2)
      l2 = arg_lo_ss(T_AXIS, ARG2)
 
*     Get the desired time origin
      CALL ef_get_string_arg_element(id, ARG2, arg_2,
     .     i2, j2, k2, l2, dlen, t0string)

*     Get time axis unit
      CALL ef_get_axis_info(id, ARG1, axname, axunits, bkw1, mod1, reg1)

      i1 = arg_lo_ss(X_AXIS,ARG1)
      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

           k1 = arg_lo_ss(Z_AXIS,ARG1)
           DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

              l1 = arg_lo_ss(T_AXIS,ARG1)
              DO 100 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

                ddate = arg_1(i1,j1,k1,l1)

*     Get the string-date for each time
                CALL ef_get_axis_dates(id,ARG1,ddate,1,prec,dlen,datebuf)
                tunit = axunits(4)
                CALL time_since_t0(t0string,datebuf,tunit,timesincet0)
                result(i,j,k,l) = timesincet0

                l1 = l1 + arg_incr(T_AXIS,ARG1)
 100          CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 300     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
 400  CONTINUE

 110  FORMAT (i2, 1x, a3, 1x, i4)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 

 800  CONTINUE
      WRITE (err_msg,*)
     .  'Error for reading t0string in tax_tstep ',
     .  t0string

      RETURN

      END

*********************************************************************
*
*     Compute the time since desired t0
*
*********************************************************************
      SUBROUTINE time_since_t0(t0string, datebuf, tunit, timesincet0)
      
      CHARACTER*20 t0string, datebuf
      CHARACTER*16 tunit
      REAL timesincet0

      INTEGER secondsincet0, minutesincet0, hoursincet0
      INTEGER daysincet0, monthsincet0, yearsincet0

      CALL LOWER(tunit)

*     Compute time since t0, check time axis unit
      IF( tunit(1:3) .EQ. 'sec') THEN
          CALL second_since_t0(t0string, datebuf, secondsincet0)
          timesincet0 = secondsincet0
      ELSE IF(tunit(1:3) .EQ. 'min') THEN
          CALL minute_since_t0(t0string, datebuf, minutesincet0)
          timesincet0 = minutesincet0
      ELSE IF(tunit(1:3) .EQ. 'hou') THEN
          CALL hour_since_t0(t0string, datebuf, hoursincet0)
          timesincet0 = hoursincet0
      ELSE IF(tunit(1:3) .EQ. 'day') THEN
          CALL day_since_t0(t0string, datebuf, daysincet0)
          timesincet0 = daysincet0
      ELSE IF(tunit(1:3) .EQ. 'mon') THEN
          CALL month_since_t0(t0string, datebuf, monthsincet0)
          timesincet0 = monthsincet0
      ELSE IF(tunit(1:3) .EQ. 'yea') THEN
          CALL year_since_t0(t0string, datebuf, yearsincet0)
          timesincet0 = yearsincet0
      ELSE 
          timesincet0=0.
      ENDIF

      RETURN
      END

*******************************************************************
*     Compute second since t0
*******************************************************************
      SUBROUTINE second_since_t0(t0string, datebuf, secondsincet0)

      CHARACTER*20 t0string, datebuf
      INTEGER minutesincet0, secondsincet0

      INTEGER isecond, t0second

      t0hour = 0

      CALL minute_since_t0(t0string, datebuf, minutesincet0)
      secondsincet0 = 60*minutesincet0

*     Get t0's minute
      READ (t0string, 110, err=800) t0second

*     Get current minute
      READ (datebuf, 110, err=900) isecond

 110  FORMAT (18x, i2)

*     Adjust minutes of current date
      secondsincet0 = secondsincet0 - (60-isecond)

*     Adjust minutes of t0
      secondsincet0 = secondsincet0 + (60 - t0second)

      RETURN
*-------------
 800  CONTINUE
      WRITE (err_msg,*)
     .  'Error assigning dates/times for t0 date in tax_tstep',
     .  datebuf
      RETURN

*-------------
 900  CONTINUE
      WRITE (err_msg,*)
     .  'Error assigning dates/times for current date in tax_tstep',
     .  datebuf
      RETURN

      END


*******************************************************************
*     Compute minutes since t0
*******************************************************************
      SUBROUTINE minute_since_t0(t0string, datebuf, minutesincet0)

      CHARACTER*20 t0string, datebuf
      INTEGER minutesincet0, hoursincet0

      INTEGER iminute, t0minute

      t0hour = 0

      CALL hour_since_t0(t0string, datebuf, hoursincet0)
      minutesincet0 = 60*hoursincet0

*     Get t0's minute
      READ (t0string, 110, err=800) t0minute

*     Get current minute
      READ (datebuf, 110, err=900) iminute

 110  FORMAT (15x, i2, 3x)

*     Adjust minutes of current date
      minutesincet0 = minutesincet0 - (60-iminute)

*     Adjust minutes of t0
      minutesincet0 = minutesincet0 + (60 - t0minute)

      RETURN
*-------------
 800  CONTINUE
      WRITE (err_msg,*)
     .  'Error assigning dates/times for t0 date in tax_tstep',
     .  datebuf
      RETURN

*-------------
 900  CONTINUE
      WRITE (err_msg,*)
     .  'Error assigning dates/times for current date in tax_tstep',
     .  datebuf
      RETURN

      END

*******************************************************************
*     Compute hours since t0
*******************************************************************
      SUBROUTINE hour_since_t0(t0string, datebuf, hoursincet0)

      CHARACTER*20 t0string, datebuf
      INTEGER hoursincet0, daysincet0
       
      INTEGER ihour, t0hour      

      t0hour = 0

      CALL day_since_t0(t0string, datebuf, daysincet0)
      hoursincet0 = 24*daysincet0

      print *, daysincet0

*     Get t0's hour
      READ (t0string, 110, err=800) t0hour

*     Get current hour
      READ (datebuf, 110, err=900) ihour

 110  FORMAT (12x, i2, 6x)

*     Adjust hours of current date
      hoursincet0 = hoursincet0 - (24-ihour)

*     Adjust hours of t0
      hoursincet0 = hoursincet0 + (24 - t0hour)
      RETURN
*-------------
 800  CONTINUE
      WRITE (err_msg,*)
     .  'Error assigning dates/times for t0 date in tax_tstep',
     .  datebuf
      RETURN

*-------------
 900  CONTINUE
      WRITE (err_msg,*)
     .  'Error assigning dates/times for current date in tax_tstep',
     .  datebuf
      RETURN

      END
*******************************************************************
*     Compute the days since t0
*     Assume that t0 is before the current year
*******************************************************************
      SUBROUTINE day_since_t0(t0string, datebuf, daysincet0)

      CHARACTER*20 t0string, datebuf
      INTEGER daysincet0

      INTEGER t0day, t0year
      CHARACTER*3 t0mon

      INTEGER dayofmon, iyear 
      CHARACTER*3 cmon

      CHARACTER*3 months(12)
      INTEGER it0mon, imon
      INTEGER i, j, m
      INTEGER yrstart,yrend
      INTEGER dayofyear, ndaymo(12)

      DATA ndaymo/31,28,31,30,31,30,31,31,30,31,30,31/

      DATA months/'jan', 'feb', 'mar', 'apr', 'may', 'jun', 'jul',
     .            'aug', 'sep', 'oct', 'nov', 'dec'/

*     Get t0's year, month, and day
      READ (t0string, 110, err=800) t0day, t0mon, t0year
      
*     Get current date
      READ (datebuf, 110, err=900) dayofmon, cmon, iyear
   
 110  FORMAT (i2, 1x, a3, 1x, i4)

      CALL LOWER(t0mon)
      CALL LOWER(cmon)

      print *, t0mon, cmon

*     Convert a month from string to number
      DO 50 m=1,12
          IF (t0mon .EQ. months(m)) it0mon=m
          IF (cmon .EQ. months(m)) imon=m
 50   CONTINUE

      print *, imon, it0mon

      yrstart = t0year
      yrend = iyear-1
      daysincet0 = 0

*     Total days between yrstart and yrend
      DO 200 i = yrstart, yrend

*     Check if it is a leap year
          IF ( ((mod(i,4) .EQ. 0) .AND. (mod(i,100) .NE. 0))
     .       .OR.
     .       (mod(i, 400) .EQ. 0)) THEN
                ndaymo(2) = 29
          ELSE
                ndaymo(2) = 28
          ENDIF

          daysincet0 = daysincet0 + (ndaymo(2) + 7*31 + 4*30)

 200  CONTINUE

*     ***************************
*     Adjust days of current year
*     ***************************
      IF ( ((mod(iyear,4) .EQ. 0) .AND. (mod(iyear,100) .NE. 0))
     .       .OR.
     .       (mod(iyear, 400) .EQ. 0)) THEN
          ndaymo(2) = 29
      ELSE
          ndaymo(2) = 28
      ENDIF

*     Compute day of current year
      dayofyear = dayofmon
      DO 300 j =1, imon -1
          dayofyear = dayofyear + ndaymo(j)
 300  CONTINUE

*     Add days of current year 
          daysincet0 = daysincet0 + dayofyear

*     *****************************
*     Adjust days in the year of t0
*     *****************************
      IF ( ((mod(t0year,4) .EQ. 0) .AND. (mod(t0year,100) .NE. 0))
     .       .OR.
     .       (mod(t0year, 400) .EQ. 0)) THEN
          ndaymo(2) = 29
      ELSE
          ndaymo(2) = 28
      ENDIF

*     Compute day of current year
      dayofyear = t0day
      DO 400 j =1, it0mon -1
          dayofyear = dayofyear + ndaymo(j)
 400  CONTINUE

*     Subtract days of year t0
      daysincet0 = daysincet0 - dayofyear

      RETURN

*-------------
 800  CONTINUE
      WRITE (err_msg,*)
     .  'Error assigning dates/times for timr origin in tax_tstep',
     .  t0string
      RETURN

*-------------
 900  CONTINUE
      WRITE (err_msg,*)
     .  'Error assigning dates/times for current date in tax_tstep',
     .  datebuf
      RETURN

      END

*******************************************************************
*     Compute month since t0
*******************************************************************
      SUBROUTINE month_since_t0(t0string, datebuf, monthsincet0)

      CHARACTER*20 t0string, datebuf
      INTEGER monthsincet0
      CHARACTER*3 t0mon, cmon
      CHARACTER*3 months(12)
      INTEGER iyear, t0year, it0mon, imon
      INTEGER m

      DATA months/'jan', 'feb', 'mar', 'apr', 'may', 'jun', 'jul',
     .            'aug', 'sep', 'oct', 'nov', 'dec'/

*     Get t0's year, month, and day
      READ (t0string, 110, err=800) t0mon, t0year
*     Get current date
      READ (datebuf, 110, err=900) cmon, iyear

 110  FORMAT (3x, a3, 1x, i4)

      CALL LOWER(t0mon)
      CALL LOWER(cmon)
*     Convert a month from string to number
      DO 50 m=1,12
          IF (t0mon .EQ. months(m)) it0mon=m
          IF (cmon .EQ. months(m)) imon=m
 50   CONTINUE

      monthsincet0= (12-it0mon) + (iyear-t0year-1)*12 + imon

      RETURN
*-------------
 800  CONTINUE
      WRITE (err_msg,*)
     .  'Error assigning dates/times for time origin in tax_tstep: ',
     .  t0string
      RETURN
*-------------
 900  CONTINUE
      WRITE (err_msg,*)
     .  'Error assigning dates/times for current date in tax_tstep: ',
     .  datebuf
      RETURN

      END

*******************************************************************
*     Compute year since t0
*******************************************************************
      SUBROUTINE year_since_t0(t0string, datebuf, yearsincet0)

      CHARACTER*20 t0string, datebuf
      INTEGER yearsincet0
      INTEGER iyear, t0year

*     Get t0's year, month, and day
      READ (t0string, 110, err=800) t0year
*     Get current date
      READ (datebuf, 110, err=900) iyear
 110  FORMAT (7x, i4)

      yearsincet0 = iyear - t0year 

      RETURN
*-------------
 800  CONTINUE
      WRITE (err_msg,*)
     .  'Error assigning dates/times for time origin in tax_tstep: ',
     .  t0string
      RETURN
*-------------
 900  CONTINUE
      WRITE (err_msg,*)
     .  'Error assigning dates/times for current date in tax_tstep: ',
     .  datebuf
      RETURN

      END


****************************************************************
*
      SUBROUTINE LOWER(TEXT)
      CHARACTER*(*) TEXT
*
*     Converts a string to lowercase.
*
      EXTERNAL LENGTH
      INTEGER  LENGTH
      CHARACTER*1 LETTER
      INTEGER ISHIFT,I
      ISHIFT=ICHAR('a')-ICHAR('A')
      DO 10 I=1,LENGTH(TEXT)
        LETTER=TEXT(I:I)
        IF('A'.LE.LETTER.AND.LETTER.LE.'Z') THEN
          TEXT(I:I)=CHAR(ICHAR(LETTER)+ISHIFT)
        END IF
   10 CONTINUE
      RETURN
      END

***************************************************************
*
      INTEGER FUNCTION LENGTH(TEXT)
      CHARACTER*(*) TEXT
*
*     Computes the length of a string without trailing blanks.
*
      INTEGER I

      DO 1 I=LEN(TEXT),1,-1
        IF(TEXT(I:I).NE.' ') THEN
          GO TO 2
        END IF
    1 CONTINUE
      I=1
    2 CONTINUE
      LENGTH=I

      RETURN
      END

	SUBROUTINE MINSMOOTHER(	idim, wlen, 
     .				com, com_mr, com_cx,
     .				res, res_mr, res_cx, 
     .				list )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Compute the minimum of the requested length, along axis idim
* note: the component context may not be of adequate size for the full
*	calculation.  Missing data flags will be inserted where computation is
*	impossible. If there is any data present in the window, the minimum
*       is computed based on that data. Minima are computed with the data
*       that is available in partial windows at the edges of the domain. 

* programmer - ansley manke based on convolve.
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'

* calling argument declarations:
	INTEGER	idim, wlen, com_mr, com_cx, res_mr, res_cx
	REAL	com( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .               m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .          res( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .               m2lot:m2hit,m2loe:m2hie,m2lof:m2hif ),
     .          list(*)

* internal variable declarations:
	LOGICAL TM_ITS_SUBSPAN_MODULO, has_mod_void
	INTEGER	TM_MODULO_LINE_DIM, CGRID_AXIS, 
     .		i, j, k, l, m, n, ii, ndx, lo_lim, hi_lim,
     .          lo_sub(nferdims), hi_sub(nferdims), hlen,
     .		lo_modlim, hi_modlim, nmod, nmod_prev, 
     .		modlen
	REAL    bad_com, bad_res, comp, cmin

* internal (convenience) equivalences
	INTEGER	lo_s1, lo_s2, lo_s3, lo_s4, lo_s5, lo_s6,
     .          hi_s1, hi_s2, hi_s3, hi_s4, hi_s5, hi_s6
	EQUIVALENCE (lo_s1, lo_sub(1)) , (lo_s2, lo_sub(2)),
     .		    (lo_s3, lo_sub(3)) , (lo_s4, lo_sub(4)),
     .		    (lo_s5, lo_sub(5)) , (lo_s6, lo_sub(6)),
     .		    (hi_s1, hi_sub(1)) , (hi_s2, hi_sub(2)),
     .		    (hi_s3, hi_sub(3)) , (hi_s4, hi_sub(4)),
     .		    (hi_s5, hi_sub(5)) , (hi_s6, hi_sub(6))

* initialize
	bad_com = mr_bad_data( res_mr )
	bad_res = mr_bad_data( com_mr )
	lo_lim = cx_lo_ss(com_cx,idim)
	hi_lim = cx_hi_ss(com_cx,idim) 
	nmod_prev = -99999

	hlen = wlen/2
	IF ( MOD(wlen,2) .EQ. 0)  hlen = (wlen+1)/2

* compute limits within which calculation is possible
	DO 10 ii = 1, nferdims
	   lo_sub(ii) = cx_lo_ss(res_cx,ii)
	   hi_sub(ii) = cx_hi_ss(res_cx,ii)
 10	CONTINUE

* it this a subspan modulo axis?
	has_mod_void = TM_ITS_SUBSPAN_MODULO( CGRID_AXIS(idim,com_cx) )
	IF (has_mod_void) THEN
	   modlen = TM_MODULO_LINE_DIM( CGRID_AXIS(idim,com_cx) )
	   has_mod_void = lo_lim.LE.0 .OR. hi_lim.GE.modlen
	ENDIF

* ... though treating each axis separately is to avoid testing inside the loop
* SMOOTH ALONG X AXIS
	IF ( idim .EQ. x_dim ) THEN
	   DO 110 n = lo_s6, hi_s6
	   DO 110 m = lo_s5, hi_s5
	   DO 110 l = lo_s4, hi_s4
	   DO 110 k = lo_s3, hi_s3
	   DO 110 j = lo_s2, hi_s2
	   DO 110 i = lo_s1, hi_s1
	      IF (has_mod_void) THEN
*  ... do not allow smoothing across the modulo void
	         IF (i.GE.1) THEN  ! get # of modulos to curr index
	            nmod = (i-1)/modlen 
	         ELSE
	            nmod = i/modlen - 1
	         ENDIF
	         IF ( nmod .NE. nmod_prev ) THEN
	            nmod_prev = nmod
	            lo_modlim = nmod*modlen + 1
	            hi_modlim = (nmod+1) * modlen
	            lo_lim = MAX( lo_modlim, cx_lo_ss(com_cx,idim) )
	            hi_lim = MIN( hi_modlim, cx_hi_ss(com_cx,idim)  )
	         ENDIF
	      ENDIF
	      ndx = 0
	      cmin = ABS(bad_com)
	      DO 100 ii = -hlen, hlen
* test limits of component data before using
                 IF ( i+ii .GE. lo_lim
     .          .AND. i+ii .LE. hi_lim ) THEN
                    comp = com(i+ii,j,k,l,m,n)
                 ELSE
                    comp = bad_com
                 ENDIF

	         IF ( comp .NE. bad_com ) THEN
		    cmin = MIN(cmin, comp)
		    ndx = ndx + 1
	         ENDIF
 100	      CONTINUE

	      IF (ndx .EQ. 0) THEN 
                res(i,j,k,l,m,n) = bad_res
                GOTO 110
	      ELSE
                res(i,j,k,l,m,n) = cmin
	      ENDIF

 110	   CONTINUE

* SMOOTH ALONG Y AXIS
	ELSEIF ( idim .EQ. y_dim ) THEN
	   DO 210 n = lo_s6, hi_s6
	   DO 210 m = lo_s5, hi_s5
	   DO 210 l = lo_s4, hi_s4
	   DO 210 k = lo_s3, hi_s3
	   DO 210 j = lo_s2, hi_s2
	      IF (has_mod_void) THEN
*  ... do not allow smoothing across the modulo void
	         IF (j.GE.1) THEN  ! get # of modulos to curr index
	            nmod = (j-1)/modlen 
	         ELSE
	            nmod = j/modlen - 1
	         ENDIF
	         IF ( nmod .NE. nmod_prev ) THEN
	            nmod_prev = nmod
	            lo_modlim = nmod*modlen + 1
	            hi_modlim = (nmod+1) * modlen
	            lo_lim = MAX( lo_modlim, cx_lo_ss(com_cx,idim) )
	            hi_lim = MIN( hi_modlim, cx_hi_ss(com_cx,idim)  )
	         ENDIF
	      ENDIF
	   DO 210 i = lo_s1, hi_s1
	      ndx = 0
	      cmin = ABS(bad_com)

	      DO 200 ii = -hlen, hlen
* test limits of component data before using
                 IF ( j+ii .GE. lo_lim
     .          .AND. j+ii .LE. hi_lim ) THEN
                    comp = com(i,j+ii,k,l,m,n)
                 ELSE
                    comp = bad_com
                 ENDIF

	         IF ( comp .NE. bad_com ) THEN
	            cmin = MIN(cmin, comp)
		    ndx = ndx + 1
	         ENDIF
 200	      CONTINUE

	      IF (ndx .EQ. 0) THEN 
                res(i,j,k,l,m,n) = bad_res
                GOTO 210
	      ELSE 
                res(i,j,k,l,m,n) = cmin
	      ENDIF

 210	   CONTINUE

* SMOOTH ALONG Z AXIS
	ELSEIF ( idim .EQ. z_dim ) THEN
	   DO 310 n = lo_s6, hi_s6
	   DO 310 m = lo_s5, hi_s5
	   DO 310 l = lo_s4, hi_s4
	   DO 310 k = lo_s3, hi_s3
	      IF (has_mod_void) THEN
*  ... do not allow smoothing across the modulo void
	         IF (k.GE.1) THEN  ! get # of modulos to curr index
	            nmod = (k-1)/modlen 
	         ELSE
	            nmod = k/modlen - 1
	         ENDIF
	         IF ( nmod .NE. nmod_prev ) THEN
	            nmod_prev = nmod
	            lo_modlim = nmod*modlen + 1
	            hi_modlim = (nmod+1) * modlen
	            lo_lim = MAX( lo_modlim, cx_lo_ss(com_cx,idim) )
	            hi_lim = MIN( hi_modlim, cx_hi_ss(com_cx,idim)  )
	         ENDIF
	      ENDIF

	   DO 310 j = lo_s2, hi_s2
	   DO 310 i = lo_s1, hi_s1
	      ndx = 0
	      cmin = ABS(bad_com)
	      DO 300 ii = -hlen, hlen
* test limits of component data before using
                 IF ( k+ii .GE. lo_lim
     .          .AND. k+ii .LE. hi_lim ) THEN
                    comp = com(i,j,k+ii,l,m,n)
                 ELSE
                    comp = bad_com
                 ENDIF

	         IF ( comp .NE. bad_com ) THEN
	            cmin = MIN(cmin, comp)
		    ndx = ndx + 1
	         ENDIF
 300	      CONTINUE

	      IF (ndx .EQ. 0) THEN 
                res(i,j,k,l,m,n) = bad_res
                GOTO 310
	      ELSE
                res(i,j,k,l,m,n) = cmin
	      ENDIF
 310	   CONTINUE

* SMOOTH ALONG T AXIS
	ELSEIF ( idim .EQ. t_dim ) THEN
	   DO 410 n = lo_s6, hi_s6
	   DO 410 m = lo_s5, hi_s5
	   DO 410 l = lo_s4, hi_s4
	      IF (has_mod_void) THEN
*  ... do not allow smoothing across the modulo void
	         IF (l.GE.1) THEN  ! get # of modulos to curr index
	            nmod = (l-1)/modlen 
	         ELSE
	            nmod = l/modlen - 1
	         ENDIF
	         IF ( nmod .NE. nmod_prev ) THEN
	            nmod_prev = nmod
	            lo_modlim = nmod*modlen + 1
	            hi_modlim = (nmod+1) * modlen
	            lo_lim = MAX( lo_modlim, cx_lo_ss(com_cx,idim) )
	            hi_lim = MIN( hi_modlim, cx_hi_ss(com_cx,idim)  )
	         ENDIF
	      ENDIF
	   DO 410 k = lo_s3, hi_s3
	   DO 410 j = lo_s2, hi_s2
	   DO 410 i = lo_s1, hi_s1
	      ndx = 0
	      cmin = ABS(bad_com)
	      DO 400 ii = -hlen, hlen
* test limits of component data before using
                 IF ( l+ii .GE. lo_lim
     .          .AND. l+ii .LE. hi_lim ) THEN
                    comp = com(i,j,k,l+ii,m,n)
                 ELSE
                    comp = bad_com
                 ENDIF

	         IF ( comp .NE. bad_com ) THEN
	            cmin = MIN(cmin, comp)
		    ndx = ndx + 1
	         ENDIF
 400	      CONTINUE

	      IF (ndx .EQ. 0) THEN 
                res(i,j,k,l,m,n) = bad_res
                GOTO 410
	      ELSE 
                res(i,j,k,l,m,n) = cmin
	      ENDIF
 410	   CONTINUE

* SMOOTH ALONG E AXIS
	ELSEIF ( idim .EQ. e_dim ) THEN
	   DO 510 n = lo_s6, hi_s6
	   DO 510 m = lo_s5, hi_s5
	      IF (has_mod_void) THEN
*  ... do not allow smoothing across the modulo void
	         IF (m.GE.1) THEN  ! get # of modulos to curr index
	            nmod = (m-1)/modlen 
	         ELSE
	            nmod = m/modlen - 1
	         ENDIF
	         IF ( nmod .NE. nmod_prev ) THEN
	            nmod_prev = nmod
	            lo_modlim = nmod*modlen + 1
	            hi_modlim = (nmod+1) * modlen
	            lo_lim = MAX( lo_modlim, cx_lo_ss(com_cx,idim) )
	            hi_lim = MIN( hi_modlim, cx_hi_ss(com_cx,idim)  )
	         ENDIF
	      ENDIF
	   DO 510 l = lo_s4, hi_s4
	   DO 510 k = lo_s3, hi_s3
	   DO 510 j = lo_s2, hi_s2
	   DO 510 i = lo_s1, hi_s1
	      ndx = 0
	      cmin = ABS(bad_com)
	      DO 500 ii = -hlen, hlen
* test limits of component data before using
                 IF ( m+ii .GE. lo_lim
     .          .AND. m+ii .LE. hi_lim ) THEN
                    comp = com(i,j,k,l,m+ii,n)
                 ELSE
                    comp = bad_com
                 ENDIF

	         IF ( comp .NE. bad_com ) THEN
	            cmin = MIN(cmin, comp)
		    ndx = ndx + 1
	         ENDIF
 500	      CONTINUE

	      IF (ndx .EQ. 0) THEN 
                res(i,j,k,l,m,n) = bad_res
                GOTO 510
	      ELSE 
                res(i,j,k,l,m,n) = cmin
	      ENDIF
 510	   CONTINUE

* SMOOTH ALONG F AXIS
	ELSEIF ( idim .EQ. f_dim ) THEN
	   DO 610 n = lo_s6, hi_s6
	      IF (has_mod_void) THEN
*  ... do not allow smoothing across the modulo void
	         IF (n.GE.1) THEN  ! get # of modulos to curr index
	            nmod = (n-1)/modlen 
	         ELSE
	            nmod = n/modlen - 1
	         ENDIF
	         IF ( nmod .NE. nmod_prev ) THEN
	            nmod_prev = nmod
	            lo_modlim = nmod*modlen + 1
	            hi_modlim = (nmod+1) * modlen
	            lo_lim = MAX( lo_modlim, cx_lo_ss(com_cx,idim) )
	            hi_lim = MIN( hi_modlim, cx_hi_ss(com_cx,idim)  )
	         ENDIF
	      ENDIF
	   DO 610 m = lo_s5, hi_s5
	   DO 610 l = lo_s4, hi_s4
	   DO 610 k = lo_s3, hi_s3
	   DO 610 j = lo_s2, hi_s2
	   DO 610 i = lo_s1, hi_s1
	      ndx = 0
	      cmin = ABS(bad_com)
	      DO 600 ii = -hlen, hlen
* test limits of component data before using
                 IF ( n+ii .GE. lo_lim
     .          .AND. n+ii .LE. hi_lim ) THEN
                    comp = com(i,j,k,l,m,n+ii)
                 ELSE
                    comp = bad_com
                 ENDIF

	         IF ( comp .NE. bad_com ) THEN
	            cmin = MIN(cmin, comp)
		    ndx = ndx + 1
	         ENDIF
 600	      CONTINUE

	      IF (ndx .EQ. 0) THEN 
                res(i,j,k,l,m,n) = bad_res
                GOTO 610
	      ELSE 
                res(i,j,k,l,m,n) = cmin
	      ENDIF
 610	   CONTINUE

	ENDIF

	RETURN
	END

	SUBROUTINE AVE_REGRID_1_AXIS( cx_lims, axis, trans,
     .				 dst_lox, dst_hix, dst_loy, dst_hiy,
     .				 src, msrc, dst, mdst, ss21, src_cx,
     .                           dst_cx, wksize )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* 	Using data values from src organized on grid src_grid, regrid to
* 	grid dst_grid by averaging withing boxes along one axis

* 	msrc and mdst point to data structures in COMMON/XVARIABLES/ which

* 	specify the subscript bounds of src and dst within their 
* 	respective grids.

*	ss21 holds the indices of source grid boxes (on src_grid) for box
*	limits on dst_grid.

* 	programmer - Steve Hankin
* 	NOAA/PMEL,Seattle,WA - Tropical Modeling and Analysis Program

* note: the conversion to 4D is of the Q&D variety.  Optimization is possible
*	by providing additional work space and pre-computing the box sizes
*	along the X and Y axes

* V312:	 6/7/94 - use TDST_WORLD for simpler, faster date conversions
*	speed other axes, too, by not using AXIS_DISTANCE (units divide out)
* V420: 10/95 - handles regridding by @VAR, as well
*	 1/96 - handles @SUM and @NGD as well
* V510: *sh* 1/00 variance of a grid box with only a single value
*	contributing is undefined
* v541: *acm* 3/02 In some cases the source indices include a range
*                  outside the destination indices, so ddist < 0.  Test
*                  for this and only have a contribution to the avg from 
*                  portions of the source axis that overlap the dest box.
* v552  *acm* 4/03 Use src_lo_ss and src_hi_ss for the range on the src
*                  axis, as a more complete fix of the above bug.
* v570 *acm* 5/04 Range of subscripts might be negative, and contain 
*                 -111 among them. Allow regridding, using the flag 
*                 ok_neg111 to distinguish this case from the flag 
*                 unspecified_int4.
* v580 *acm* 11/04 Fix the definition of ok_neg111; if -111 is at
*                  either end of the interval we cannot distinguish
*                  it as a valid index from its use as the bad flag.
* NOTE: -111 in the above was the value of unspecified_int4 (now -999)
*      *kms*  2/12 Add E and F dimensions (use nferdims in tmap_dims.parm)
* v685 *acm* 06/13 Fix ticket 2070: regridding when source cell encloses 
*                  dest cell.
* v685 *acm*  7/13 Fix bug in F axis loop, and fix nonX directions in the
*                  code for source cell enclosing dest cell.

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'
	include 'xmem_subsc.cmn'
	include 'xvariables.cmn'

* calling argument declarations:
	INTEGER cx_lims, axis, trans, msrc, mdst,
     .          dst_lox, dst_hix, dst_loy, dst_hiy , wksize
	INTEGER ss21(wksize)

	REAL    src( m1lox:m1hix,m1loy:m1hiy,m1loz:m1hiz,
     .	             m1lot:m1hit,m1loe:m1hie,m1lof:m1hif ),
     .	        dst( m2lox:m2hix,m2loy:m2hiy,m2loz:m2hiz,
     .	             m2lot:m2hit,m2loe:m2hie,m2lof:m2hif )

* local variable declarations:

        LOGICAL         ok_neg111, src_encloses
        INTEGER		dstss,srcss,src_grid,dst_grid,i,j,k,l,m,n
	INTEGER	     	srcss_lo,srcss_hi, dstss_lo,dstss_hi, ncontrib,
     .                  src_cx, dst_cx

	REAL		ddist, bad_src, bad_dst
	REAL*8		TM_WORLD, TDEST_WORLD, sum, distance, dev,
     .			xsrc_min, xsrc_max, xsrc_lo, xsrc_hi,
     .			xdst_lo, xdst_hi
******************************************************************************

* initialize
	src_grid = mr_grid( msrc )
	dst_grid = mr_grid( mdst )

* limits for calculation
        srcss_lo = mr_lo_ss(msrc,axis)
        srcss_hi = mr_hi_ss(msrc,axis)

* Range of subscripts might be negative, and contain the value of unspecified_int4 
* among them.  ok_neg111 distinguishes between this and the flag unspecified_int4.

        ok_neg111 = srcss_lo .LT. unspecified_int4 .AND.
     .              srcss_hi .GT. unspecified_int4

        dstss_lo = cx_lo_ss(cx_lims,axis)
        dstss_hi = cx_hi_ss(cx_lims,axis)

* flag for bad/missing data
        bad_src = mr_bad_data(msrc)
        bad_dst = mr_bad_data(mdst)

* determine the source grid boxes containing the destination box edges
	CALL GET_AVE_LIMS( srcss_lo, srcss_hi, src_grid,
     .			   dstss_lo, dstss_hi, dst_grid,
     .			   axis, ss21 )

* along X axis
        IF ( axis .EQ. x_dim ) THEN
           DO 190 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
           DO 190 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
           DO 190 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
           DO 190 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
           DO 190 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)

* loop through the each destination grid box
	   DO 160 dstss = dstss_lo,dstss_hi
	      srcss_lo = ss21(dstss-dstss_lo+1)
	      srcss_hi = ss21(dstss-dstss_lo+2)

*  check if requested region is out of source range
              IF ( (srcss_lo .EQ. unspecified_int4
     .	     .OR.  srcss_hi .EQ. unspecified_int4)
     .       .AND. .NOT.(ok_neg111) ) THEN
	         dst(dstss,j,k,l,m,n) = bad_dst
	         goto 160
	      ENDIF

	      xdst_lo = TM_WORLD(dstss, dst_grid, axis, box_lo_lim )
	      xdst_hi = TM_WORLD(dstss, dst_grid, axis, box_hi_lim )

* add all partial or complete boxes of data from the source grid

* IF source box completely encloses the dest box, then srcss_lo=srcss_hi
* and we can just stick the source point into the destination (for avg or var)
	      sum = 0.0D0
	      distance = 0.0D0
	      DO 110 srcss = srcss_lo, srcss_hi

* ... ignore missing source data
	         IF ( src(srcss, j, k, l, m, n) .EQ. bad_src ) GOTO 110

	         xsrc_min = TM_WORLD(srcss,src_grid,axis,box_lo_lim)
	         xsrc_max = TM_WORLD(srcss,src_grid,axis,box_hi_lim)

	        src_encloses = 
     .               (xdst_lo.GT.xsrc_min .AND. xdst_hi.LT.xsrc_max) 

	         xsrc_lo = MAX(xsrc_min,xdst_lo)
	         xsrc_hi = MIN(xsrc_max,xdst_hi )

	         ddist   = xsrc_hi-xsrc_lo

* ... contribution from this source box
                 IF (ddist .GT. 0.) THEN
	            distance  = distance + ddist
	            IF (trans .EQ. prgrd_sum ) THEN
	               sum   = sum  + src(srcss, j, k, l, m, n)
     .			         * ddist/(xsrc_max-xsrc_min)
	            ELSEIF (trans .EQ. prgrd_good_pt ) THEN
	               sum   = sum  + ddist/(xsrc_max-xsrc_min)
	            ELSE	! average or variance
	               sum   = sum  + ddist * src(srcss, j, k, l, m, n)
	            ENDIF
                 ENDIF

 110	      CONTINUE

	      IF ( trans.EQ.prgrd_good_pt ) THEN
	         dst(dstss, j, k, l, m, n) = sum
	      ELSEIF ( distance .EQ. 0.0 ) THEN
	         dst(dstss, j, k, l, m, n) = bad_dst
	      ELSEIF ( trans.EQ.prgrd_sum ) THEN
	         dst(dstss, j, k, l, m, n) = sum
	      ELSE
* ... divide by distance to get average
	         dst(dstss, j, k, l, m, n) = sum / distance
		 IF (src_encloses) dst(dstss,j,k,l,m,n) = 
     .			         src(srcss_lo,j,k,l,m,n)
	      ENDIF


 160	   CONTINUE
 190	   CONTINUE

* along Y axis
        ELSEIF ( axis .EQ. Y_dim ) THEN

           DO 290 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
           DO 290 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
           DO 290 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
           DO 290 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
           DO 290 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* loop through the each destination grid box
	   DO 260 dstss = dstss_lo,dstss_hi
	      srcss_lo = ss21(dstss-dstss_lo+1)
	      srcss_hi = ss21(dstss-dstss_lo+2)

*  check if requested region is out of source range
              IF ( (srcss_lo .EQ. unspecified_int4
     .	     .OR.  srcss_hi .EQ. unspecified_int4)
     .       .AND. .NOT.(ok_neg111) ) THEN
	         dst(i,dstss,k,l,m,n) = bad_dst
	         goto 260
	      ENDIF

	      xdst_lo  = TM_WORLD(dstss, dst_grid, axis, box_lo_lim )
	      xdst_hi  = TM_WORLD(dstss, dst_grid, axis, box_hi_lim )

* add all partial or complete boxes of data from the source grid

* IF source box completely encloses the dest box, then srcss_lo=srcss_hi
* and we can just stick the source point into the destination (for avg or var)
	      sum = 0.0D0
	      distance = 0.0D0
	      DO 210 srcss = srcss_lo, srcss_hi

* ... ignore missing source data
	         IF ( src(i, srcss, k, l, m, n) .EQ. bad_src ) GOTO 210

	         xsrc_min = TM_WORLD(srcss,src_grid,axis,box_lo_lim)
	         xsrc_max = TM_WORLD(srcss,src_grid,axis,box_hi_lim)

	        src_encloses = 
     .               (xdst_lo.GT.xsrc_min .AND. xdst_hi.LT.xsrc_max) 

	         xsrc_lo = MAX(xsrc_min,xdst_lo)
	         xsrc_hi = MIN(xsrc_max,xdst_hi)

	         ddist   = xsrc_hi-xsrc_lo

* ... contribution from this source box
                 IF (ddist .GT. 0.) THEN
	            distance  = distance + ddist
	            IF (trans .EQ. prgrd_sum ) THEN
	               sum   = sum  + src(i, srcss, k, l, m, n)
     .			         * ddist/(xsrc_max-xsrc_min)
	            ELSEIF (trans .EQ. prgrd_good_pt ) THEN
	               sum   = sum  + ddist/(xsrc_max-xsrc_min)
	            ELSE	! average or variance
	               sum   = sum  + ddist * src(i, srcss, k, l, m, n)
	            ENDIF
                 ENDIF

 210	      CONTINUE

	      IF (trans.EQ.prgrd_good_pt ) THEN
	         dst(i, dstss, k, l, m, n) = sum
	      ELSEIF ( distance .EQ. 0.0 ) THEN
	         dst(i, dstss, k, l, m, n) = bad_dst
	      ELSEIF (trans.EQ.prgrd_sum ) THEN
	         dst(i, dstss, k, l, m, n) = sum
	      ELSE
* ... divide by distance to get average
	         dst(i, dstss, k, l, m, n) = sum / distance
		 IF (src_encloses) dst(i,dstss,k,l,m,n) = 
     .			         src(i,srcss_lo,k,l,m,n)
	      ENDIF

 260	   CONTINUE
 290	   CONTINUE

* along Z axis
        ELSEIF ( axis .EQ. z_dim ) THEN

           DO 390 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
           DO 390 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
           DO 390 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
           DO 390 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
           DO 390 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* loop through the each destination grid box
	   DO 360 dstss = dstss_lo,dstss_hi
	      srcss_lo = ss21(dstss-dstss_lo+1)
	      srcss_hi = ss21(dstss-dstss_lo+2)

*  check if requested region is out of source range
              IF ( (srcss_lo .EQ. unspecified_int4
     .	     .OR.  srcss_hi .EQ. unspecified_int4)
     .       .AND. .NOT.(ok_neg111) ) THEN
	         dst(i,j,dstss,k,m,n) = bad_dst
	         goto 360
	      ENDIF

	      xdst_lo = TM_WORLD(dstss, dst_grid, axis, box_lo_lim )
	      xdst_hi = TM_WORLD(dstss, dst_grid, axis, box_hi_lim )

* add all partial or complete boxes of data from the source grid

* IF source box completely encloses the dest box, then srcss_lo=srcss_hi
* and we can just stick the source point into the destination (for avg or var)
	      sum = 0.0D0
	      distance = 0.0D0
	      DO 310 srcss = srcss_lo, srcss_hi

* ... ignore missing source data
	         IF ( src(i, j, srcss, l, m, n) .EQ. bad_src ) GOTO 310

	         xsrc_min = TM_WORLD(srcss,src_grid,axis,box_lo_lim)
	         xsrc_max = TM_WORLD(srcss,src_grid,axis,box_hi_lim)

	        src_encloses = 
     .               (xdst_lo.GT.xsrc_min .AND. xdst_hi.LT.xsrc_max) 

	         xsrc_lo = MAX(xsrc_min,xdst_lo)
	         xsrc_hi = MIN(xsrc_max,xdst_hi )

	         ddist   = xsrc_hi-xsrc_lo

* ... contribution from this source box
                 IF (ddist .GT. 0.) THEN
	            distance  = distance + ddist
	            IF (trans .EQ. prgrd_sum ) THEN
	               sum   = sum  + src(i, j, srcss, l, m, n)
     .			         * ddist/(xsrc_max-xsrc_min)
	            ELSEIF (trans .EQ. prgrd_good_pt ) THEN
	               sum   = sum  + ddist/(xsrc_max-xsrc_min)
	            ELSE	! average or variance
	               sum   = sum  + ddist * src(i, j, srcss, l, m, n)
	            ENDIF
                 ENDIF

 310	      CONTINUE

	      IF ( trans.EQ.prgrd_good_pt ) THEN
	         dst(i, j, dstss, l, m, n) = sum
	      ELSEIF ( distance .EQ. 0.0 ) THEN
	         dst(i, j, dstss, l, m, n) = bad_dst
	      ELSEIF (trans.EQ.prgrd_sum ) THEN
	         dst(i, j, dstss, l, m, n) = sum
	      ELSE
* ... divide by distance to get average
	         dst(i, j, dstss, l, m, n) = sum / distance
		 IF (src_encloses) dst(i,j,dstss,l,m,n) = 
     .			         src(i,j,srcss_lo,l,m,n)
	      ENDIF

 360	   CONTINUE
 390	   CONTINUE

* along T axis
        ELSEIF ( axis .EQ. T_dim ) THEN

           DO 490 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
           DO 490 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
           DO 490 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
           DO 490 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
           DO 490 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* loop through the each destination grid box
	   DO 460 dstss = dstss_lo,dstss_hi
	      srcss_lo = ss21(dstss-dstss_lo+1)
	      srcss_hi = ss21(dstss-dstss_lo+2)

*  check if requested region is out of source range
              IF ( (srcss_lo .EQ. unspecified_int4
     .	     .OR.  srcss_hi .EQ. unspecified_int4)
     .       .AND. .NOT.(ok_neg111) ) THEN
	         dst(i,j,k,dstss,m,n) = bad_dst
	         goto 460
	      ENDIF

* USE SOURCE GRID TIME/DATE ENCODINGS FOR ALL CALCULATIONS 6/94
* initialization of TDEST_WORLD is done from GET_AVE_LIMS

	      xdst_lo = TDEST_WORLD(dstss, dst_grid, axis, box_lo_lim)
	      xdst_hi = TDEST_WORLD(dstss, dst_grid, axis, box_hi_lim)

* add all partial or complete boxes of data from the source grid

* IF source box completely encloses the dest box, then srcss_lo=srcss_hi
* and we can just stick the source point into the destination (for avg or var)
	      sum = 0.0D0
	      distance = 0.0D0
	      DO 410 srcss = srcss_lo, srcss_hi

* ... ignore missing source data
	         IF ( src(i, j, k, srcss, m, n) .EQ. bad_src ) GOTO 410

	         xsrc_min = TM_WORLD(srcss,src_grid,axis,box_lo_lim)
	         xsrc_max = TM_WORLD(srcss,src_grid,axis,box_hi_lim)

	        src_encloses = 
     .               (xdst_lo.GT.xsrc_min .AND. xdst_hi.LT.xsrc_max) 

	         xsrc_lo = MAX(xsrc_min,xdst_lo)
	         xsrc_hi = MIN(xsrc_max,xdst_hi)

	         ddist   = xsrc_hi - xsrc_lo

* ... contribution from this source box
                 IF (ddist .GT. 0.) THEN
	            distance  = distance + ddist
	            IF (trans .EQ. prgrd_sum ) THEN
	               sum   = sum  + src(i, j, k, srcss, m, n)
     .			         * ddist/(xsrc_max-xsrc_min)
	            ELSEIF (trans .EQ. prgrd_good_pt ) THEN
	               sum   = sum  + ddist/(xsrc_max-xsrc_min)
	            ELSE	! average or variance
	               sum   = sum  + ddist * src(i, j, k, srcss, m, n)
	            ENDIF
	         ENDIF 

 410	      CONTINUE

	      IF ( trans.EQ.prgrd_good_pt ) THEN
	         dst(i, j, k, dstss, m, n) = sum
	      ELSEIF ( distance .EQ. 0.0 ) THEN
	         dst(i, j, k, dstss, m, n) = bad_dst
	      ELSEIF (trans.EQ.prgrd_sum ) THEN
	         dst(i, j, k, dstss, m, n) = sum
	      ELSE
* ... divide by distance to get average
	         dst(i, j, k, dstss, m, n) = sum / distance
		 IF (src_encloses) dst(i,j,k,dstss,m,n) = 
     .			         src(i,j,k,srcss_lo,m,n)
	      ENDIF

 460	   CONTINUE
 490	   CONTINUE

* along E axis
        ELSEIF ( axis .EQ. e_dim ) THEN

           DO 590 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
           DO 590 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
           DO 590 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
           DO 590 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
           DO 590 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* loop through the each destination grid box
	   DO 560 dstss = dstss_lo,dstss_hi
	      srcss_lo = ss21(dstss-dstss_lo+1)
	      srcss_hi = ss21(dstss-dstss_lo+2)

*  check if requested region is out of source range
              IF ( (srcss_lo .EQ. unspecified_int4
     .	     .OR.  srcss_hi .EQ. unspecified_int4)
     .       .AND. .NOT.(ok_neg111) ) THEN
	         dst(i,j,k,l,dstss,n) = bad_dst
	         goto 560
	      ENDIF

* USE SOURCE GRID TIME/DATE ENCODINGS FOR ALL CALCULATIONS 6/94
* initialization of TDEST_WORLD is done from GET_AVE_LIMS

	      xdst_lo = TDEST_WORLD(dstss, dst_grid, axis, box_lo_lim)
	      xdst_hi = TDEST_WORLD(dstss, dst_grid, axis, box_hi_lim)

* add all partial or complete boxes of data from the source grid

* IF source box completely encloses the dest box, then srcss_lo=srcss_hi
* and we can just stick the source point into the destination (for avg or var)
	      sum = 0.0D0
	      distance = 0.0D0
	      DO 510 srcss = srcss_lo, srcss_hi

* ... ignore missing source data
	         IF ( src(i, j, k, l, srcss, n) .EQ. bad_src ) GOTO 510

	         xsrc_min = TM_WORLD(srcss,src_grid,axis,box_lo_lim)
	         xsrc_max = TM_WORLD(srcss,src_grid,axis,box_hi_lim)

	        src_encloses = 
     .               (xdst_lo.GT.xsrc_min .AND. xdst_hi.LT.xsrc_max) 

	         xsrc_lo = MAX(xsrc_min,xdst_lo)
	         xsrc_hi = MIN(xsrc_max,xdst_hi)

	         ddist   = xsrc_hi - xsrc_lo

* ... contribution from this source box
                 IF (ddist .GT. 0.) THEN
	            distance  = distance + ddist
	            IF (trans .EQ. prgrd_sum ) THEN
	               sum   = sum  + src(i, j, k, l, srcss, n)
     .			         * ddist/(xsrc_max-xsrc_min)
	            ELSEIF (trans .EQ. prgrd_good_pt ) THEN
	               sum   = sum  + ddist/(xsrc_max-xsrc_min)
	            ELSE	! average or variance
	               sum   = sum  + ddist * src(i, j, k, l, srcss, n)
	            ENDIF
	         ENDIF
 510	      CONTINUE

	      IF ( trans.EQ.prgrd_good_pt ) THEN
	         dst(i, j, k, l, dstss, n) = sum
	      ELSEIF ( distance .EQ. 0.0 ) THEN
	         dst(i, j, k, l, dstss, n) = bad_dst
	      ELSEIF (trans.EQ.prgrd_sum ) THEN
	         dst(i, j, k, l, dstss, n) = sum
	      ELSE
* ... divide by distance to get average
	         dst(i, j, k, l, dstss, n) = sum / distance
		 IF (src_encloses) dst(i,j,k,l,dstss,n) = 
     .			         src(i,j,k,l,srcss_lo,n)
	      ENDIF

 560	   CONTINUE
 590	   CONTINUE

* along F axis
        ELSEIF ( axis .EQ. f_dim ) THEN

           DO 690 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
           DO 690 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
           DO 690 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
           DO 690 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
           DO 690 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* loop through the each destination grid box
	   DO 660 dstss = dstss_lo,dstss_hi
	      srcss_lo = ss21(dstss-dstss_lo+1)
	      srcss_hi = ss21(dstss-dstss_lo+2)

*  check if requested region is out of source range
              IF ( (srcss_lo .EQ. unspecified_int4
     .	     .OR.  srcss_hi .EQ. unspecified_int4)
     .       .AND. .NOT.(ok_neg111) ) THEN
	         dst(i,j,k,l,m,dstss) = bad_dst
	         goto 660
	      ENDIF

* USE SOURCE GRID TIME/DATE ENCODINGS FOR ALL CALCULATIONS 6/94
* initialization of TDEST_WORLD is done from GET_AVE_LIMS

	      xdst_lo = TDEST_WORLD(dstss, dst_grid, axis, box_lo_lim)
	      xdst_hi = TDEST_WORLD(dstss, dst_grid, axis, box_hi_lim)

* add all partial or complete boxes of data from the source grid

* IF source box completely encloses the dest box, then srcss_lo=srcss_hi
* and we can just stick the source point into the destination (for avg or var)
	      sum = 0.0D0
	      distance = 0.0D0
	      DO 610 srcss = srcss_lo, srcss_hi

* ... ignore missing source data
	         IF ( src(i, j, k, l, m, srcss) .EQ. bad_src ) GOTO 610

	         xsrc_min = TM_WORLD(srcss,src_grid,axis,box_lo_lim)
	         xsrc_max = TM_WORLD(srcss,src_grid,axis,box_hi_lim)

	        src_encloses = 
     .               (xdst_lo.GT.xsrc_min .AND. xdst_hi.LT.xsrc_max) 

	         xsrc_lo = MAX(xsrc_min,xdst_lo)
	         xsrc_hi = MIN(xsrc_max,xdst_hi)

	         ddist   = xsrc_hi - xsrc_lo

* ... contribution from this source box
                 IF (ddist .GT. 0.) THEN
	            distance  = distance + ddist
	            IF (trans .EQ. prgrd_sum ) THEN
	               sum   = sum  + src(i, j, k, l, m, srcss)
     .			         * ddist/(xsrc_max-xsrc_min)
	            ELSEIF (trans .EQ. prgrd_good_pt ) THEN
	               sum   = sum  + ddist/(xsrc_max-xsrc_min)
	            ELSE	! average or variance
	               sum   = sum  + ddist * src(i, j, k, l, m, srcss)
	            ENDIF
	         ENDIF
 610	      CONTINUE

	      IF ( trans.EQ.prgrd_good_pt ) THEN
	         dst(i, j, k, l, m, dstss) = sum
	      ELSEIF ( distance .EQ. 0.0 ) THEN
	         dst(i, j, k, l, m, dstss) = bad_dst
	      ELSEIF (trans.EQ.prgrd_sum ) THEN
	         dst(i, j, k, l, m, dstss) = sum
	      ELSE
* ... divide by distance to get average
	         dst(i, j, k, l, m, dstss) = sum / distance
		 IF (src_encloses) dst(i,j,k,l,m,dstss) = 
     .			         src(i,j,k,l,m,srcss_lo)
	      ENDIF

 660	   CONTINUE
 690	   CONTINUE

* TODO: along E and F axes?

        ENDIF

	IF (trans .NE. prgrd_variance) RETURN

**************************************************************
**************************************************************
**************************************************************
* pass 2:  determine variance
**************************************************************
**************************************************************
**************************************************************
	
* along X axis
        IF ( axis .EQ. x_dim ) THEN
           DO 1190 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
           DO 1190 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
           DO 1190 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
           DO 1190 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
           DO 1190 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)

* loop through the each destination grid box
	   DO 1160 dstss = dstss_lo,dstss_hi

	      IF ( dst(dstss, j, k, l, m, n) .EQ. bad_dst ) GOTO 1160

	      srcss_lo = ss21(dstss-dstss_lo+1)
	      srcss_hi = ss21(dstss-dstss_lo+2)

	      xdst_lo = TM_WORLD(dstss, dst_grid, axis, box_lo_lim)
	      xdst_hi = TM_WORLD(dstss, dst_grid, axis, box_hi_lim)

* add all partial or complete boxes of data from the source grid
	      sum = 0.0D0
	      distance = 0.0D0
	      ncontrib = 0
	      DO 1110 srcss = srcss_lo, srcss_hi

* ... ignore missing source data
	         IF ( src(srcss, j, k, l, m, n) .EQ. bad_src ) GOTO 1110

	         xsrc_lo = MAX( TM_WORLD(srcss,src_grid,axis,box_lo_lim),
     .                          xdst_lo )
	         xsrc_hi = MIN( TM_WORLD(srcss,src_grid,axis,box_hi_lim),
     .                          xdst_hi )
	         ddist   = xsrc_hi-xsrc_lo

* ... contribution from this source box
 	         IF (ddist .GT. 0.0) THEN
	           ncontrib = ncontrib + 1
	           distance  = distance + ddist
	           dev = DBLE(src(srcss, j, k, l, m, n)) -
     .                   DBLE(dst(dstss, j, k, l, m, n))
	           sum = sum  + ddist * dev*dev
	         ENDIF

 1110	      CONTINUE

* ... divide by weight to get variance
	      IF (ncontrib .GT. 1) THEN
	         dst(dstss, j, k, l, m, n) = sum / distance
	      ELSE
	         dst(dstss, j, k, l, m, n) = bad_dst
	      ENDIF

 1160	   CONTINUE
 1190	   CONTINUE

* along Y axis
        ELSEIF ( axis .EQ. Y_dim ) THEN

           DO 1290 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
           DO 1290 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
           DO 1290 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
           DO 1290 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
           DO 1290 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* loop through the each destination grid box
	   DO 1260 dstss = dstss_lo,dstss_hi

	      IF ( dst(i, dstss, k, l, m, n) .EQ. bad_dst ) GOTO 1260

	      srcss_lo = ss21(dstss-dstss_lo+1)
	      srcss_hi = ss21(dstss-dstss_lo+2)

	      xdst_lo = TM_WORLD(dstss, dst_grid, axis, box_lo_lim)
	      xdst_hi = TM_WORLD(dstss, dst_grid, axis, box_hi_lim)

* add all partial or complete boxes of data from the source grid
	      sum = 0.0D0
	      distance = 0.0D0
	      ncontrib = 0
	      DO 1210 srcss = srcss_lo, srcss_hi

* ... ignore missing source data
	         IF ( src(i, srcss, k, l, m, n) .EQ. bad_src ) GOTO 1210

	         xsrc_lo = MAX( TM_WORLD(srcss,src_grid,axis,box_lo_lim),
     .                          xdst_lo )
	         xsrc_hi = MIN( TM_WORLD(srcss,src_grid,axis,box_hi_lim),
     .                          xdst_hi )
	         ddist   = xsrc_hi-xsrc_lo

* ... contribution from this source box
	         IF (ddist .GT. 0.0) THEN 
	           ncontrib = ncontrib + 1
	           distance  = distance + ddist
	           dev = DBLE(src(i, srcss, k, l, m, n)) -
     .                   DBLE(dst(i, dstss, k, l, m, n))
	           sum   = sum  + ddist * dev*dev
	         ENDIF

 1210	      CONTINUE

* ... divide by weight to get variance
	      IF (ncontrib .GT. 1) THEN
	         dst(i, dstss, k, l, m, n) = sum / distance
	      ELSE
	         dst(i, dstss, k, l, m, n) = bad_dst
	      ENDIF

 1260	   CONTINUE
 1290	   CONTINUE

* along Z axis
        ELSEIF ( axis .EQ. z_dim ) THEN

           DO 1390 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
           DO 1390 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
           DO 1390 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
           DO 1390 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
           DO 1390 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* loop through the each destination grid box
	   DO 1360 dstss = dstss_lo,dstss_hi

	      IF ( dst(i, j, dstss, l, m, n) .EQ. bad_dst ) GOTO 1360

	      srcss_lo = ss21(dstss-dstss_lo+1)
	      srcss_hi = ss21(dstss-dstss_lo+2)

	      xdst_lo = TM_WORLD(dstss, dst_grid, axis, box_lo_lim)
	      xdst_hi = TM_WORLD(dstss, dst_grid, axis, box_hi_lim)

* add all partial or complete boxes of data from the source grid
	      sum = 0.0D0
	      distance = 0.0D0
	      ncontrib = 0
	      DO 1310 srcss = srcss_lo, srcss_hi

* ... ignore missing source data
	         IF ( src(i, j, srcss, l, m, n) .EQ. bad_src ) GOTO 1310

	         xsrc_lo = MAX( TM_WORLD(srcss,src_grid,axis,box_lo_lim),
     .                          xdst_lo )
	         xsrc_hi = MIN( TM_WORLD(srcss,src_grid,axis,box_hi_lim),
     .                          xdst_hi )
	         ddist   = xsrc_hi-xsrc_lo

* ... contribution from this source box
 	         IF (ddist .GT. 0.0) THEN
	           ncontrib = ncontrib + 1
	           distance  = distance + ddist
	           dev = DBLE(src(i, j, srcss, l, m, n)) -
     .                   DBLE(dst(i, j, dstss, l, m, n))
	           sum = sum  + ddist * dev*dev
	         ENDIF

 1310	      CONTINUE

* ... divide by weight to get variance
	      IF (ncontrib .GT. 1) THEN
	         dst(i, j, dstss, l, m, n) = sum / distance
	      ELSE
	         dst(i, j, dstss, l, m, n) = bad_dst
	      ENDIF

 1360	   CONTINUE
 1390	   CONTINUE

* along T axis
        ELSEIF ( axis .EQ. T_dim ) THEN

           DO 1490 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
           DO 1490 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
           DO 1490 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
           DO 1490 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
           DO 1490 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* loop through the each destination grid box
	   DO 1460 dstss = dstss_lo,dstss_hi

	      IF ( dst(i, j, k, dstss, m, n) .EQ. bad_dst ) GOTO 1460

	      srcss_lo = ss21(dstss-dstss_lo+1)
	      srcss_hi = ss21(dstss-dstss_lo+2)

* USE SOURCE GRID TIME/DATE ENCODINGS FOR ALL CALCULATIONS 6/94
* initialization of TDEST_WORLD is done from GET_AVE_LIMS

	      xdst_lo = TDEST_WORLD(dstss, dst_grid, axis, box_lo_lim)
	      xdst_hi = TDEST_WORLD(dstss, dst_grid, axis, box_hi_lim)

* add all partial or complete boxes of data from the source grid
	      sum = 0.0D0
	      distance = 0.0D0
	      ncontrib = 0
	      DO 1410 srcss = srcss_lo, srcss_hi

* ... ignore missing source data
	         IF ( src(i, j, k, srcss, m, n) .EQ. bad_src ) GOTO 1410

	         xsrc_lo = MAX( TM_WORLD(srcss,src_grid,axis,box_lo_lim),
     .                          xdst_lo )
	         xsrc_hi = MIN( TM_WORLD(srcss,src_grid,axis,box_hi_lim),
     .                          xdst_hi )
	         ddist   = xsrc_hi - xsrc_lo
                 IF (ddist .LT. 0.) ddist = 0.

* ... contribution from this source box
 	         IF (ddist .GT. 0.0) THEN
	           ncontrib = ncontrib + 1
	           distance  = distance + ddist
	           dev = DBLE(src(i, j, k, srcss, m, n)) -
     .                   DBLE(dst(i, j, k, dstss, m, n))
	           sum = sum  + ddist * dev*dev
	         ENDIF

 1410	      CONTINUE

* ... divide by weight to get variance
	      IF (ncontrib .GT. 1) THEN
	         dst(i, j, k, dstss, m, n) = sum / distance
	      ELSE
	         dst(i, j, k, dstss, m, n) = bad_dst
	      ENDIF

 1460	   CONTINUE
 1490	   CONTINUE

* along E axis
        ELSEIF ( axis .EQ. e_dim ) THEN

           DO 1590 n = cx_lo_s6(cx_lims), cx_hi_s6(cx_lims)
           DO 1590 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
           DO 1590 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
           DO 1590 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
           DO 1590 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* loop through the each destination grid box
	   DO 1560 dstss = dstss_lo,dstss_hi

	      IF ( dst(i, j, k, l, dstss, n) .EQ. bad_dst ) GOTO 1560

	      srcss_lo = ss21(dstss-dstss_lo+1)
	      srcss_hi = ss21(dstss-dstss_lo+2)

* USE SOURCE GRID TIME/DATE ENCODINGS FOR ALL CALCULATIONS 6/94
* initialization of TDEST_WORLD is done from GET_AVE_LIMS

	      xdst_lo = TDEST_WORLD(dstss, dst_grid, axis, box_lo_lim)
	      xdst_hi = TDEST_WORLD(dstss, dst_grid, axis, box_hi_lim)

* add all partial or complete boxes of data from the source grid
	      sum = 0.0D0
	      distance = 0.0D0
	      ncontrib = 0
	      DO 1510 srcss = srcss_lo, srcss_hi

* ... ignore missing source data
	         IF ( src(i, j, k, l, srcss, n) .EQ. bad_src ) GOTO 1510

	         xsrc_lo = MAX( TM_WORLD(srcss,src_grid,axis,box_lo_lim),
     .                          xdst_lo )
	         xsrc_hi = MIN( TM_WORLD(srcss,src_grid,axis,box_hi_lim),
     .                          xdst_hi )
	         ddist   = xsrc_hi - xsrc_lo
                 IF (ddist .LT. 0.) ddist = 0.

* ... contribution from this source box
 	         IF (ddist .GT. 0.0) THEN
	           ncontrib = ncontrib + 1
	           distance  = distance + ddist
	           dev = DBLE(src(i, j, k, l, srcss, n)) -
     .                   DBLE(dst(i, j, k, l, dstss, n))
	           sum = sum  + ddist * dev*dev
	         ENDIF

 1510	      CONTINUE

* ... divide by weight to get variance
	      IF (ncontrib .GT. 1) THEN
	         dst(i, j, k, l, dstss, n) = sum / distance
	      ELSE
	         dst(i, j, k, l, dstss, n) = bad_dst
	      ENDIF

 1560	   CONTINUE
 1590	   CONTINUE


* along F axis
        ELSEIF ( axis .EQ. f_dim ) THEN

           DO 1690 m = cx_lo_s5(cx_lims), cx_hi_s5(cx_lims)
           DO 1690 l = cx_lo_s4(cx_lims), cx_hi_s4(cx_lims)
           DO 1690 k = cx_lo_s3(cx_lims), cx_hi_s3(cx_lims)
           DO 1690 j = cx_lo_s2(cx_lims), cx_hi_s2(cx_lims)
           DO 1690 i = cx_lo_s1(cx_lims), cx_hi_s1(cx_lims)

* loop through the each destination grid box
	   DO 1660 dstss = dstss_lo,dstss_hi

	      IF ( dst(i, j, k, l, m, dstss) .EQ. bad_dst ) GOTO 1660

	      srcss_lo = ss21(dstss-dstss_lo+1)
	      srcss_hi = ss21(dstss-dstss_lo+2)

* USE SOURCE GRID TIME/DATE ENCODINGS FOR ALL CALCULATIONS 6/94
* initialization of TDEST_WORLD is done from GET_AVE_LIMS

	      xdst_lo = TDEST_WORLD(dstss, dst_grid, axis, box_lo_lim)
	      xdst_hi = TDEST_WORLD(dstss, dst_grid, axis, box_hi_lim)

* add all partial or complete boxes of data from the source grid
	      sum = 0.0D0
	      distance = 0.0D0
	      ncontrib = 0
	      DO 1610 srcss = srcss_lo, srcss_hi

* ... ignore missing source data
	         IF ( src(i, j, k, l, m, srcss) .EQ. bad_src ) GOTO 1610

	         xsrc_lo = MAX( TM_WORLD(srcss,src_grid,axis,box_lo_lim),
     .                          xdst_lo )
	         xsrc_hi = MIN( TM_WORLD(srcss,src_grid,axis,box_hi_lim),
     .                          xdst_hi )
	         ddist   = xsrc_hi - xsrc_lo
                 IF (ddist .LT. 0.) ddist = 0.

* ... contribution from this source box
 	         IF (ddist .GT. 0.0) THEN
	           ncontrib = ncontrib + 1
	           distance  = distance + ddist
	           dev = DBLE(src(i, j, k, l, m, srcss)) -
     .                   DBLE(dst(i, j, k, l, m, dstss))
	           sum = sum  + ddist * dev*dev
	         ENDIF

 1610	      CONTINUE

* ... divide by weight to get variance
	      IF (ncontrib .GT. 1) THEN
	         dst(i, j, k, l, m, dstss) = sum / distance
	      ELSE
	         dst(i, j, k, l, m, dstss) = bad_dst
	      ENDIF

 1660	   CONTINUE
 1690	   CONTINUE
        ENDIF

	RETURN
	END

*     rr_av.F   ----    Rick Romea     Jun. 6, 2000
*
*     Vertical diffusion coefficient: Az (Units = cm^2/s)
*
*******************************************************************

      SUBROUTINE RR_av_init(id)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INTEGER id
      CALL ef_set_desc(id,'Vertical diffusion coefficient:Az (cm^2/s)')
      CALL ef_set_num_args(id,4)
      CALL ef_set_axis_inheritance(id,IMPLIED_BY_ARGS, 
     . IMPLIED_BY_ARGS,IMPLIED_BY_ARGS,IMPLIED_BY_ARGS)

      CALL ef_set_arg_name         (id, ARG1, 'U')
      CALL ef_set_arg_desc         (id, ARG1,
     . 'Zonal velocity, on the MOM2 U Grid. ')
      CALL ef_set_arg_unit         (id, ARG1, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG1, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG1, YES, YES, YES, YES)
      CALL ef_set_axis_extend      (id, ARG1, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG1, Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG1, Z_AXIS,0,+1)

      CALL ef_set_arg_name         (id, ARG2, 'V')
      CALL ef_set_arg_desc         (id, ARG2,
     . 'Meridional velocity, on the MOM2 U Grid. ')
      CALL ef_set_arg_unit         (id, ARG2, 'cm/sec')
      CALL ef_set_arg_type         (id, ARG2, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG2,YES,YES,YES,YES)
      CALL ef_set_axis_extend      (id, ARG2, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG2, Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG2, Z_AXIS,0,+1)

      CALL ef_set_arg_name         (id, ARG3, 'TEMP')
      CALL ef_set_arg_desc         (id, ARG3,
     . 'Potential temperature, on MOM2 T Grid. ')
      CALL ef_set_arg_unit         (id, ARG3, 'deg-C')
      CALL ef_set_arg_type         (id, ARG3, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG3, NO, NO,YES,YES)
      CALL ef_set_axis_extend      (id, ARG3, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG3, Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG3, Z_AXIS,0,+1)

      CALL ef_set_arg_name         (id, ARG4, 'SALT')
      CALL ef_set_arg_desc         (id, ARG4,
     . 'Salinity, on MOM2 T Grid. ')
      CALL ef_set_arg_unit         (id, ARG4, '(ppt-35)/1000')
      CALL ef_set_arg_type         (id, ARG4, FLOAT_ARG)
      CALL ef_set_axis_influence   (id, ARG4, NO, NO,YES,YES)
      CALL ef_set_axis_extend      (id, ARG4, X_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG4, Y_AXIS,-1,+1)
      CALL ef_set_axis_extend      (id, ARG4, Z_AXIS,0,+1)

      END 


      SUBROUTINE RR_av_compute(id,arg_1,arg_2,arg_3,arg_4,result)
      IMPLICIT NONE
      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'
      
      INTEGER        id

      REAL           bad_flag(EF_MAX_ARGS)
      REAL           bad_flag_result

      REAL           arg_1  (mem1lox:mem1hix, mem1loy:mem1hiy, 
     .                       mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL           arg_2  (mem2lox:mem2hix, mem2loy:mem2hiy, 
     .                       mem2loz:mem2hiz, mem2lot:mem2hit)
      REAL           arg_3  (mem3lox:mem3hix, mem3loy:mem3hiy, 
     .                       mem3loz:mem3hiz, mem3lot:mem3hit)
      REAL           arg_4  (mem4lox:mem4hix, mem4loy:mem4hiy, 
     .                       mem4loz:mem4hiz, mem4lot:mem4hit)
      REAL           result (memreslox:memreshix,memresloy:memreshiy,
     .                       memresloz:memreshiz,memreslot:memreshit)

      INTEGER        res_lo_ss (4)
      INTEGER        res_hi_ss (4)
      INTEGER        res_incr  (4)

      INTEGER        arg_lo_ss (4,EF_MAX_ARGS)
      INTEGER        arg_hi_ss (4,EF_MAX_ARGS)
      INTEGER        arg_incr  (4,EF_MAX_ARGS)

      INTEGER        i,  j,  k,  l
      INTEGER        i1, j1, k1, l1
      INTEGER        i2, j2, k2, l2
      INTEGER        i3, j3, k3, l3
      INTEGER        i4, j4, k4, l4

      REAL*8         zT(1024)
      INTEGER        iZ
      REAL get_dzw,dzw,dzt,rhom1z,Ri,Potential_density

      INCLUDE 'rr_parameters.h'

      ! visc_cbu_back = 1.
      ! wndmix = 10.
      ! visc_cbu_limit = fricmx
      ! fricmx = 50.
      ! gravity = 980.6

c*********************************************************************
c     THIS IS THE MOM2 CODE:
c
c     dzt     = thickness of "t" grid cells (cm)
c     dztr(k) = reciprocal of "dzt"
c     dzw(k)  = vertical resolution of "w" grid cells (in cm)
c     dzwr(k) = reciprocal of "dzw"
c     visc_cbu       = viscosity coefficient at bottom of "u" cells (cm**2/s)
c     visc_cbu_back  = background viscosity (cm**2/s)  =  1.
c     fricmx         = maximum viscosity    (cm**2/s)  = 50.
c     visc_cbu_limit = largest viscosity (cm**2/sec) = fricmx
c     wndmix         = min value for mixing at surface to 
c                     simulate high freq wind mixing. (cm**2/sec)  = 10.
c     smf     = surface momentum flux (dynes/cm**2)
c                smf(1) = taux     smf(2) = tauy
c     grav    = gravity (cm/sec**2)
c     epsln   = small value: 1.e-25
c
c      t1                = 1./(1. + 5.*riu(i,k,j))
c      visc_cbu(i,k,j)   = fricmx*t1**2 + visc_cbu_back
c      if(riu(i,k,j).lt.0.)visc_cbu(i,k,j)=visc_cbu_limit ! unstable
c      if(visc_cbu(i,1,j).lt.wndmix)visc_cbu(i,1,j)=wndmix ! surface
c
c      riu(i,k,j) = -grav/4.*dzw(k)*(rhom1z(i,k,j+1) + rhom1z(i+1,k,j+1) +
c     &                            rhom1z(i,k,j)   + rhom1z(i+1,k,j)) /
c     &  ((u(i,k,j,1)-u(i,k+1,j,1))**2+(u(i,k,j,2)-u(i,k+1,j,2))**2 +  epsln) 
c      rhom1z(i,k,j) = ro(i,k,j) - ro(i,k+1,j)
c      do ks=1,2
c        call statec (t(1,1,1,1,tlev), t(1,1,1,2,tlev), ro(1,1,jsmw)
c     &,              max(js,jsmw), je, istrt-1, iend+1, ks)
c*********************************************************************

      !  Statement functions

      dzw(iZ) =  get_dzw(iZ,zT) * Meters_to_cm
      dzt(iZ) = (dzw(iZ-1) + dzw(iZ)) / 2.
      rhom1z(i3,j3,k3,l3,i4,j4,k4,l4) =
     .        Potential_density(arg_3(i3,j3,k3  ,l3),
     .                          arg_4(i4,j4,k4  ,l4))
     .      - Potential_density(arg_3(i3,j3,k3+1,l3),
     .                          arg_4(i4,j4,k4+1,l4)) 

      CALL ef_get_res_subscripts (id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts (id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags      (id, bad_flag,  bad_flag_result)
      CALL ef_get_coordinates    (id, ARG3, Z_AXIS, 
     .                            arg_lo_ss(Z_AXIS,ARG3),
     .                            arg_hi_ss(Z_AXIS,ARG3), zT)

      l1 = arg_lo_ss(T_AXIS,ARG1) 
      l2 = arg_lo_ss(T_AXIS,ARG2) 
      l3 = arg_lo_ss(T_AXIS,ARG3) 
      l4 = arg_lo_ss(T_AXIS,ARG4) 
      DO l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
         j1 = arg_lo_ss(Y_AXIS,ARG1) + 1
         j2 = arg_lo_ss(Y_AXIS,ARG2) + 1
         j3 = arg_lo_ss(Y_AXIS,ARG3) + 1
         j4 = arg_lo_ss(Y_AXIS,ARG4) + 1
         DO j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
            i1 = arg_lo_ss(X_AXIS,ARG1) + 1
            i2 = arg_lo_ss(X_AXIS,ARG2) + 1
            i3 = arg_lo_ss(X_AXIS,ARG3) + 1
            i4 = arg_lo_ss(X_AXIS,ARG4) + 1
            DO i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
               iZ = 1
               k1 = arg_lo_ss(Z_AXIS,ARG1)
               k2 = arg_lo_ss(Z_AXIS,ARG2)
               k3 = arg_lo_ss(Z_AXIS,ARG3)
               k4 = arg_lo_ss(Z_AXIS,ARG4)
               DO k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
                  IF (arg_1(i1,  j1,  k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1+1,j1,  k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1-1,j1,  k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1,  j1+1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1+1,j1+1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1-1,j1+1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1,  j1-1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1+1,j1-1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_1(i1-1,j1-1,k1,l1) .EQ. bad_flag(ARG1) .OR.
     .                arg_2(i2,  j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2,  k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2,  j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2+1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2,  j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2+1,j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_2(i2-1,j2-1,k2,l2) .EQ. bad_flag(ARG2) .OR.
     .                arg_3(i3,  j3,  k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3+1,j3,  k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3-1,j3,  k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3,  j3+1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3+1,j3+1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3-1,j3+1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3,  j3-1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3+1,j3-1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_3(i3-1,j3-1,k3,l3) .EQ. bad_flag(ARG3) .OR.
     .                arg_4(i4,  j4,  k4,l4) .EQ. bad_flag(ARG4) .OR.
     .                arg_4(i4+1,j4,  k4,l4) .EQ. bad_flag(ARG4) .OR.
     .                arg_4(i4-1,j4,  k4,l4) .EQ. bad_flag(ARG4) .OR.
     .                arg_4(i4,  j4+1,k4,l4) .EQ. bad_flag(ARG4) .OR.
     .                arg_4(i4+1,j4+1,k4,l4) .EQ. bad_flag(ARG4) .OR.
     .                arg_4(i4-1,j4+1,k4,l4) .EQ. bad_flag(ARG4) .OR.
     .                arg_4(i4,  j4-1,k4,l4) .EQ. bad_flag(ARG4) .OR.
     .                arg_4(i4+1,j4-1,k4,l4) .EQ. bad_flag(ARG4) .OR.
     .                arg_4(i4-1,j4-1,k4,l4) .EQ. bad_flag(ARG4)
     .                  )THEN
                     result(i,j,k,l) = bad_flag_result
                  ELSE
                     Ri = - gravity/4. * dzw(iZ) * (
     .                  rhom1z(i3  ,j3+1,k3,l3,i4  ,j4+1,k4,l4) + 
     .                  rhom1z(i3+1,j3+1,k3,l3,i4+1,j4+1,k4,l4) +
     .                  rhom1z(i3  ,j3  ,k3,l3,i4  ,j4  ,k4,l4) + 
     .                  rhom1z(i3+1,j3  ,k3,l3,i4+1,j4  ,k4,l4) ) /
     .               ( (arg_1(i1,j1,k1,l1)-arg_1(i1,j1,k1+1,l1))**2 +
     .                 (arg_2(i2,j2,k2,l2)-arg_2(i2,j2,k2+1,l2))**2 
     .                        + epsln )
                     IF(Ri.lt.0.25)THEN
                        result(i,j,k,l) = visc_cbu_limit  ! unstable
                     ELSE
                        result(i,j,k,l) = fricmx/(1.+5.*Ri)**2
     .                                      + visc_cbu_back
                     ENDIF
                     IF(k1.EQ.1.AND.result(i,j,k,l).lt.wndmix)
     .                   result(i,j,k,l)=wndmix ! surface
                  ENDIF
                  iZ = iZ + 1 
                  k1 = k1 + arg_incr(Z_AXIS,ARG1)
                  k2 = k2 + arg_incr(Z_AXIS,ARG2)
                  k3 = k3 + arg_incr(Z_AXIS,ARG3)
                  k4 = k4 + arg_incr(Z_AXIS,ARG4)
               ENDDO
               i1 = i1 + arg_incr(X_AXIS,ARG1)
               i2 = i2 + arg_incr(X_AXIS,ARG2)
               i3 = i3 + arg_incr(X_AXIS,ARG3)
               i4 = i4 + arg_incr(X_AXIS,ARG4)
            ENDDO
            j1 = j1 + arg_incr(Y_AXIS,ARG1)
            j2 = j2 + arg_incr(Y_AXIS,ARG2)
            j3 = j3 + arg_incr(Y_AXIS,ARG3)
            j4 = j4 + arg_incr(Y_AXIS,ARG4)
         ENDDO               
         l1 = l1 + arg_incr(T_AXIS,ARG1)
         l2 = l2 + arg_incr(T_AXIS,ARG2)
         l3 = l3 + arg_incr(T_AXIS,ARG3)
         l4 = l4 + arg_incr(T_AXIS,ARG4)
      ENDDO
      END


      REAL FUNCTION Potential_density(T,S)
      IMPLICIT NONE
      REAL T ! Potential Temperature  
      REAL S ! ( SALINITY(ppt) - 35) / 1000 
      REAL Pressure / 1.0 / ! Bar
      REAL Sppt ! Salinity (ppt)     
      Sppt = 1.e3*S+35.  ! Convert S: -->  ppt
      CALL RR_unesco(T,Sppt,Pressure,Potential_density)
      Potential_density = Potential_density*1.e-3  ! Convert:kg/m^3-->g/cm^3
      END				  

      REAL FUNCTION get_dzw(iZ,zT) 
      IMPLICIT NONE
      INTEGER iZ
      REAL*8 zT(iZ+1) 
      IF(iZ.EQ.0)THEN
	get_dzw=SNGL(zT(1))
      ELSE
        get_dzw=SNGL(zT(iZ+1)-zT(iZ))
      ENDIF
      END

	SUBROUTINE SET_CTRL_C (CTRLC_AST)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* turn on facility to trap keyboard interrupts
* the interrupt handler defined here simply sets the common variable
* "interrupted" to .TRUE.

* on VMS:
* queue a VMS "asynchronous system trap" to catch user interrupts via ^C
* note that this routine must be called again following each interrupt
* this code is based on page 8-47 of Guide to Programming on VAX/VMS (Fortran)

* on Unix:
* use routine "SIGNAL" to define the interrupt handler

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.00 - 11/27/87 SH based on QINTERRUPT from program PRNT 8/2/85
* Unix/RISC port 3/18/91

* V313 - 11/1/94 - AIX port: use "SIGNAL_" instead of "SIGNAL" and
*		must reset signal handler after every use

* v4.20	- 1/30/96 - modified ifdef logic for determining call to
*		    signal handler.  Turns out solaris also needs
*		    to call the signal handler each time.  *kob*
* 12/96 *kob* - Linux Port - had to move variable assignments off of
*               declaration line. Used DATA rather than PARAMETER
*		statement because variable modified later in routine
*	      - put a ! in front of "D" for disabled lines
* 1/03 *kob* - g77 port - g77 needs to call SIGNAL with only two arguments
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

* argument: CTRLC_AST
*	name of routine to be called if operator hits ^C
*	(or call with argument %VAL(0) to return to normal VMS ^C processing)

* include the following lines in the routine requiring ^C interrupts:
*	INCLUDE 'XINTERRUPT.CMN'
*
*	IF ( interrupt ) THEN ...

        IMPLICIT NONE
	EXTERNAL	CTRLC_AST
	LOGICAL		first_call
        DATA	 	first_call/.TRUE./    !kob 12/96

#if defined AIX_XLF 
      INTEGER SIGNAL_, old_handler, sigint
#else
      INTEGER SIGNAL, old_handler, sigint
#endif
* (see unix man signal or the include file < signal.h >)
      PARAMETER ( sigint = 2 )

      include 'xinterrupt.cmn'


*set up new defines *kob* 1/96
#ifdef AIX_XLF 
# define call_handler_each_time
#endif
#ifdef solaris
# define call_handler_each_time
#endif

! "D" lines to disable disabled
!D     GOTO 888
* use newly named condition tests *kob* 1/96
#ifdef call_handler_each_time
#  ifdef NEED_SIGNAL_UNDERSCORE
      old_handler = SIGNAL_( 2, CTRLC_AST, -1 )    ! on AIX call every time
#  elif defined G77_SIGNAL
      old_handler = SIGNAL( 2, CTRLC_AST)    !! on solaris call every time
#  else
      old_handler = SIGNAL( 2, CTRLC_AST, -1 )    ! on solaris call every time

#  endif
#else
#  ifdef NEED_SIGNAL_UNDERSCORE
      IF (first_call) old_handler = SIGNAL_( 2, CTRLC_AST, -1 )
#  elif defined G77_SIGNAL
      old_handler = SIGNAL( 2, CTRLC_AST)    
#  else 
      IF (first_call) old_handler = SIGNAL( 2, CTRLC_AST, -1 )
#  endif	
#endif
!D 888 CONTINUE

* ************************ ALL SYSTEMS ************************
* system is ready - set flag to indicate no interrupt yet
	INTERRUPTED = .FALSE.
        first_call = .FALSE.

	RETURN
	END

***********************************************************

	SUBROUTINE CTRLC_AST

* this routine is called when ^C is entered if AST is queued

	include 'xinterrupt.cmn'	! COMMON/XINTERRUPT/

	interrupted = .TRUE.

	RETURN
	END	

	SUBROUTINE CD_DIM_ONLY (cdfid, name, nlen, dim_only)

* include files

	include 'netcdf.inc'

	INTEGER cdfid, nlen
	LOGICAL dim_only
	CHARACTER*(*) name

	INTEGER cdfstat, dimid, axid


	dim_only = .FALSE.

#ifdef usingDODSf2cUnderscore
	cdfstat = NF_INQ_DIMID_( cdfid, name(:nlen), dimid)
#else
	cdfstat = NF_INQ_DIMID( cdfid, name(:nlen), dimid)
#endif

* already defined ? (limited consistency checking)
	IF ( cdfstat .EQ. NF_NOERR ) THEN

* ... is there a coordinate variable by the same name ?
#ifdef usingDODSf2cUnderscore
	   cdfstat = NF_INQ_VARID_( cdfid, name(:nlen), axid )
#else
	   cdfstat = NF_INQ_VARID( cdfid, name(:nlen), axid )
#endif

* The dimension matches but there is no coord var. 
* This lets us append variables to a DSG file.

	   dim_only = cdfstat .EQ. nf_enotvar

	ENDIF

	RETURN
	END

	SUBROUTINE BREAK_VARATTNAME( text, dset_in, varname, attname, 
     .                               varid, do_err, status )
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Break up a name of the form varname.attname
* Check whether the variable and attribute exist within the dataset
* stored in linked-list structure of nc datasets.

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V600 6/05 *acm* Attribute control.
* V601 11/06*acm* Instead of looking to see if the Ferret axis name and the
*                 axis name in the attribute structure differ because Ferret
*                 needed to rename an axis on file initialization for uniqueness;
*                 we use the Ferret name throughout, restoring it only on output.
* V604 6/07 *acm* Fix bug 1518 If we didnt find the varid in the dataset, it may 
*                 be a user var
* V611 5/08 *acm* Fix bug 1578; dataset specifiers applied correctly var[d=1].attname
* v6.7 1/11 *acm* Fix ticket 1768; do not write nulls when writing err msgs 
*                 with attname.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* v698 5/16  *acm* ticket 2413: New attribute keywords ncoordvars, coordnames
*                  return info about coordinate-variables in datasets

        include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'	
	include 'rpn.parm'
	include 'xprog_state.cmn'
	include 'xrisc.cmn'
	include 'gfdl_vms.parm'	

* calling argument declaration:
        LOGICAL         do_err
	INTEGER		dset_in, status
	CHARACTER*(*)	text, varname, attname

* internal variable declarations:
        LOGICAL TM_DIGIT, coordvar, attok
	INTEGER	TM_LENSTR, TM_LENSTR1, STR_SAME, STR_CASE_BLIND_COMPARE,
     .          dset, tlen, alen, vlen, dot, dotdot, varid, attlen, 
     .          attype, end_att, short_len, attid, vartype, nvdims, 
     .          nvatts, vdims(8), vax_code, ndims, nvars, ngatts, 
     .          recdim, iatt, attoutflag, all_outflag, first, second
        REAL*8 val
        CHARACTER*128 err_string, buff

	CHARACTER*13	TM_STRING, buff13, vbuff
        CHARACTER*1 c

* Break text at dot: varname.attname

        dset = dset_in
        IF (dset .EQ. unspecified_int4) dset = pdset_uvars   ! try user variables.

        tlen = TM_LENSTR(text)

        tlen = MIN(tlen, LEN(varname))
        tlen = MIN(tlen, LEN(attname))

        IF (tlen .LT. 1 .OR. INDEX(text,'.') .EQ. 0 ) THEN
           varname = text
           attname = ""
           status = ferr_not_attribute
           GOTO 1000
        ENDIF

        dot = INDEX(text,'.')
        dotdot = INDEX(text,'..')
        IF (dotdot .GT. 0) dot = dotdot + 1

        IF (dot .EQ. 1  .AND.  tlen .EQ. 1) THEN
           varname = text
           attname = ""
           status = ferr_not_attribute
           GOTO 1000
        ENDIF

* is the name in quotations? If so then it may contain a dot and not
* be varname.attname See if its all within quotes, if so this is a 
* variable name containg a dot.

	first = INDEX(text(1:tlen), "'" )
	second = INDEX(text(2:tlen), "'" )
        IF (dot .GT. first .AND. dot .LT. second) THEN
           varname = text
           attname = ""
           status = ferr_not_attribute
           GOTO 5000
        ENDIF

        varname = text(:dot-1)
        attname = text(dot+1:tlen)

* Is the dot a decimal point within an expression, as in LIST a[y=0.5:9.5]
* or LIST a[gx=sst[d=1],y=1.5] Look for opening bracket in varname and
* closing bracket in attname.

        IF ((INDEX(varname,'[') .GT. 0)  .AND. 
     .      (INDEX(attname,']') .GT. 0)) THEN
           varname = text
           attname = ""
           GOTO 1000
        ENDIF

* If attname has brackets on it, remove this part for the next tests

       alen = TM_LENSTR1(attname)
       end_att = alen
       IF (INDEX(attname,'[') .GT. 0) THEN
          end_att = INDEX(attname,'[')
          attname(end_att:alen) = ' '
       ENDIF

* Is the varname the keyword ., representing the dataset? Check that the 
* attname request is valid.

       IF (STR_SAME (varname, '.') .EQ. 0) THEN
          attok = .FALSE.
          IF (STR_SAME(attname, 'varnames') .EQ. 0 ) THEN
             attok = .TRUE.
          ELSE IF (STR_SAME(attname, 'dimnames') .EQ. 0 ) THEN
             attok = .TRUE.
          ELSE IF (STR_SAME(attname, 'coordnames') .EQ. 0 ) THEN
             attok = .TRUE.
          ELSE IF (STR_SAME(attname, 'attnames') .EQ. 0 ) THEN
             attok = .TRUE.
          ELSE IF (STR_SAME(attname, 'ndims') .EQ. 0 ) THEN
             attok = .TRUE.
          ELSE IF (STR_SAME(attname, 'nattrs') .EQ. 0 ) THEN
             attok = .TRUE.
          ELSE IF (STR_SAME(attname, 'nvars') .EQ. 0 ) THEN
             attok = .TRUE. 
          ELSE IF (STR_SAME(attname, 'ncoordvars') .EQ. 0 ) THEN
             attok = .TRUE. 

* Is the reference to a global attribute?

          ELSE
             CALL CD_GET_VAR_ID (dset, '.', varid, status)
             CALL CD_GET_DS_INFO (dset, ndims, nvars, ngatts, 
     .               recdim, status)

             DO 100 iatt = 1, ngatts
                CALL CD_GET_VAR_ATT_NAME (dset, varid, iatt, buff, 
     .                    status)
                IF (STR_SAME(buff, attname) .EQ. 0) attok = .TRUE.
 100         CONTINUE
          ENDIF

          IF (attok) THEN
             varid = 0
             GOTO 1000
          ELSE

* is the attribute name in quotations? If so then test without them now: When the
* above keywords, attnames, etc, are in the file as attribute names, then 
* they must be enclosed in quotes

             alen = TM_LENSTR1(attname)
             IF  (attname(1:1) .EQ. "'" .AND. 
     .            attname(alen:alen) .EQ. "'") THEN

                CALL CD_GET_VAR_ATT_ID (dset, varid, attname, 
     .              attid, status)
                IF (status .EQ. ferr_ok) GOTO 1000
             ENDIF
	     
             CALL CD_GET_VAR_ATT_ID (dset, varid, attname, 
     .              attid, status)
             IF (status .EQ. ferr_ok) GOTO 1000
 
             attok = .FALSE.
             IF (status .EQ. atom_not_found) status = 
     .               ferr_unknown_attribute
             vlen = TM_LENSTR1(varname)
             err_string = 'attribute '//attname(:alen)//
     .                       ' not found for dataset '
             GOTO 5200

          ENDIF

       ENDIF
          
* Check that the dset contains the variable; . is varid=0
        
* Is the variable name in quotations?
        
        vlen = TM_LENSTR1(varname)
        IF (varname(1:1) .EQ. "'" .AND. varname(vlen:vlen) .EQ. "'") THEN
           status = 3  ! just for debugging
        ENDIF 

        CALL CD_GET_VAR_ID (dset, varname, varid, status)

* If we didnt find the name in the dataset, it may be a  user var,
* which just depends on that data set

        IF (status  .NE. ferr_ok) THEN
           dset = pdset_uvars
           CALL CD_GET_VAR_ID (dset, varname, varid, status)
           IF (status .EQ. ferr_ok) dset = pdset_uvars
        ENDIF

        IF (status .NE. ferr_ok .AND. 
     .      (STR_SAME(varname(:vlen), '.') .NE. 0) ) THEN
           status = ferr_unknown_variable
           err_string = " "
           GOTO 5200
        ENDIF

  90    CONTINUE
        CALL CD_GET_VAR_INFO (dset, varid, buff, vartype, nvdims, 
     .                vdims, nvatts, coordvar, all_outflag, status) 
        varname = buff  ! get varname in original upper- or lowercase form

        IF ( INDEX(attname,'.') .GT. 0 ) THEN
           GOTO 5100
        ENDIF

       IF (coordvar .AND. INDEX( text(:dot-1), '(' ) .EQ. 0 ) THEN
          status = ferr_syntax
          err_string = "enclose coordinate variable name in parentheses"
          GOTO 5300
       ENDIF

       err_string = 'attribute '//attname(:alen)//
     .              ' not found for variable '// varname(:vlen)

* Is the attribute specified by a number? (check as in find_dset_number)
	IF ( TM_DIGIT( attname ) ) THEN

	   buff = attname(:alen)

#ifdef MANDATORY_FORMAT_WIDTHS
	   READ (buff,*, ERR=5200 ) attid
#else
	   READ (buff, '(I)', ERR=5200 ) attid
#endif
           val = attid
           buff13 = TM_STRING(val)
           CALL TM_PACK_STRING(buff13, vbuff, 1, 13, short_len)
	   vax_code = STR_CASE_BLIND_COMPARE( vbuff, buff(1:13) )
	   IF (  vax_code .NE. vms_str_success ) GOTO 5200

* Check that this var has this attribute.  
           IF (attid .LT. 1   .OR.  attid .GT. nvatts) GOTO 5200
           CALL CD_GET_VAR_ATT_NAME (dset, varid, attid, attname, 
     .              status)
	ELSE

           CALL CD_GET_VAR_ATT_ID(dset, varid, attname, attid, status)
           IF (status .NE. ferr_ok .OR. attid .EQ. 0) THEN

* See if it is a pseudo-attribute attnames, ndims, etc.

              IF (STR_SAME(attname, 'attnames') .EQ. 0 ) THEN 
                 attok = .TRUE.
              ELSE IF (STR_SAME(attname, 'dimnames') .EQ. 0 ) THEN
                 attok = .TRUE.
              ELSE IF (STR_SAME(attname, 'ndims') .EQ. 0 ) THEN
                 attok = .TRUE.
              ELSE IF (STR_SAME(attname, 'nctype') .EQ. 0 ) THEN
                 attok = .TRUE.
              ELSE IF (STR_SAME(attname, 'nattrs') .EQ. 0 ) THEN
                 attok = .TRUE.
              ELSE

* is the attribute name in quotations? If so then remove them, and test
* for the name with case-sensitivity. When the above keywords, attnames, 
* etc, are in the file as attribute names, then they must be enclosed in 
* quotes to be accessed.

                 alen = TM_LENSTR1(attname)
                 IF  (attname(1:1) .EQ. "'" .AND. 
     .                attname(alen:alen) .EQ. "'") THEN
                    
                    CALL CD_GET_VAR_ATT_ID (dset, varid, attname,
     .                 attid, status ) 
                    IF (status .EQ. ferr_ok) GOTO 1000
                 ENDIF
 
                 attok = .FALSE.
                 IF (status .EQ. atom_not_found) status = 
     .               ferr_unknown_attribute
                 vlen = TM_LENSTR1(varname)
                 err_string = 'attribute '//attname(:alen)//
     .                       ' not found for variable '//
     .                        varname(:vlen)
                 GOTO 5200
              ENDIF
           ENDIF

       ENDIF

* successful completion
        dset_in = dset
 1000	status = ferr_ok

	RETURN

* error exits. ADD_ATTRIBUTE uses this routine to see if an attribute is already
* defined, and if not, creates the attribute.  In that case we do not want the 
* error msg.

 5000	CONTINUE
	RETURN
 5100	CALL ERRMSG( ferr_syntax, status, text(:tlen), *5000 )
        RETURN

 5200	IF (do_err) THEN
           buff = text(:tlen)
           CALL ERRMSG( status, status, buff(:tlen)//pCR//err_string, 
     .               *5000 )
        ELSE
           RETURN
        ENDIF

 5300	CALL ERRMSG( status, status, err_string, *5000 )
        RETURN

	END

	SUBROUTINE PURGE_MR_GRID( grid, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* eliminate all stored mrs on the given grid

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:  8/4/89
*	12/6/89 - purge mgrid_abstract_last, too
* Unix/RISC port - 4/25/91 *sh*: longer ds_name
*Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
* V500 *sh* 7/99 - issue warning, only, if grid is in-use in a data set
* V510: 5/00 *sh* - BUG fix: special grids exceed "6"
* v540 *acm* 10/01 increase length of ds_name
* v540 *acm* 10/01  remove VMS include statements
* v604 *acm* 7/07 increase length of ds_name
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V695+ *sh 3/15 - bug fix.  Grid name was not displayed with warnings
* V698  3/16 *acm* Removed Philander-Seigel code including diagnostic 
*                  variables, pre-defined axes and grids, cat_calc_var.

        IMPLICIT NONE
        include 'tmap_dims.parm'
#	include	"tmap_dset.parm"
	include	'tmap_errors.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'xfr_grid.cmn'
	include 'xvariables.cmn'

* calling argument declaration:
	INTEGER	grid, status

* internal variable declarations:
	INTEGER	TM_LENSTR1,
     .		mr, ivar, dset, glen, done_dset
!	INTEGER	TM_LENSTR1, mr, ivar, cvar, dset, glen, done_dset

* the lowest grids are protected
	IF ( grid .LE. mgrid_fabstract ) GOTO 5200

* initialize
	done_dset = 0

* make sure grid is not used by any file variables
	DO 10 ivar = 1, maxvars
	   dset = ds_var_setnum( ivar )
	   IF ( dset .EQ. set_not_open ) GOTO 10
	   IF ( ds_grid_number(ivar) .EQ. grid
     .	  .AND. dset .NE. done_dset ) THEN
	      glen = TM_LENSTR1(grid_name(grid))
	      CALL WARN('grid '//grid_name(grid)(:glen)//
     .		' used by data set '//ds_name(dset))
	      CALL WARN
     .		('Redefinition may alter apparent contents of data set')
	      CALL PURGE_DSET(dset)
	      done_dset = dset
	   ENDIF
 10	CONTINUE

* the coast is clear
* ...clear out the memory variables
	DO 100 mr = 1, max_mrs
	   IF ( mr_protected( mr ) .EQ. mr_deleted ) GOTO 100
	   IF ( mr_grid ( mr )     .NE. grid	   ) GOTO 100
	   CALL DELETE_VARIABLE( mr )
 100	CONTINUE

* and wipe out all user-defined variables (they may depend on it indirectly)
	CALL PURGE_ALL_UVARS

* success
	status = ferr_ok
	RETURN

* error exit
 5000	RETURN
 5200	CALL ERRMSG( ferr_grid_definition, status,
     .		'protected grid: '//grid_name(grid), *5000 )
	END

	SUBROUTINE CD_RD_EP_1(cdfid,t1id,t2id,t0,tunit,index,dval,status)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* read a single time value from a 2-integer EPIC time axis
* and return it as a double precision time relative to t0

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 3/92
* V5.0 2/99 *sh* - corrected declaration error - "sec" is float
*		Note that fractional seconds are lost!
* V530 1/01 *acm* add calendar_id in TM_BREAK_DATE, TM_SECS_FROM_BC
*		  calendar is assumed Gregorian for epic data
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V66+ *acm* 4/10  Made incorrect call to NF_GET_VAR1_DOUBLE, should have becn
*                  NF_GET_VAR1_INT.
* V665 *acm* 11/10 Fix arguments to second call to NF_GET_VAR1_INT. 
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* argument definitions:
*	cdfid	 - netCDF id number for already opened CDF file
*       t1id     - netCDF variable id of "time"
*       t2id     - netCDF variable id of "time2"
*       t0       - T0 string for the time axis
*       tunit    - number of seconds per axis time unit
*       index    - subscript of time axis to return
*       dval     - double precision value returned
*       status   - TMAP library return status

* argument declarations
      INTEGER cdfid, t1id, t2id, index, status
      REAL tunit
      REAL*8  dval
      CHARACTER*(*) t0

      include 'netcdf.inc'
      include 'tmap_errors.parm'

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

* internal variable declarations:
      INTEGER jday, msec, cdfstat, mon, day, yr, hour, min,
     .        t0year, t0mon, t0day, t0hour, t0min, t0sec
      INTEGER 	cal_id
	REAL	      sec					! 2/99
      REAL*8          TM_SECS_FROM_BC
      REAL*8          date_secs, start_secs, offset_secs

* break apart the T0 offset date.  Hardwire the calendar type to Gregorian.
      cal_id = 1
      CALL TM_BREAK_DATE (t0, cal_id, t0year, t0mon,
     .                      t0day, t0hour, t0min, t0sec, status)
      IF (status .NE. merr_ok) GO TO 5000

* read the 2 integer values
#ifdef usingDODSf2cUnderscore
      cdfstat = NF_GET_VAR1_INT_(cdfid, t1id, index, jday)

#else
      cdfstat = NF_GET_VAR1_INT (cdfid, t1id, index, jday)
#endif

      IF ( cdfstat .NE. NF_NOERR ) CALL TM_ERRMSG
     .     ( cdfstat+pcdferr, status, 'CD_RD_EP_TIME', cdfid, t1id,
     .       'EPIC time', no_errstring, *5000 )
#ifdef usingDODSf2cUnderscore
      cdfstat = NF_GET_VAR1_INT_(cdfid, t2id, index, msec)
#else
      cdfstat = NF_GET_VAR1_INT(cdfid, t2id, index, msec)
#endif

      IF ( cdfstat .NE. NF_NOERR ) CALL TM_ERRMSG
     .     ( cdfstat+pcdferr, status, 'CD_RD_EP_TIME', cdfid, t2id,
     .       'EPIC time2', no_errstring, *5000 )

* convert the 2 EPIC integers to a date
      CALL TM_EP_TIME_CONVRT( jday, msec,
     .                        mon, day, yr, hour, min, sec)

* determine seconds from BC for each part
      start_secs = TM_SECS_FROM_BC (cal_id, t0year, t0mon, t0day,
     .                              t0hour, t0min, t0sec,status)
      IF (status .NE. merr_ok) GO TO 5000
      date_secs  = TM_SECS_FROM_BC (cal_id, yr  , mon, day,
     .                              hour, min, NINT(sec),status)  ! NINT 2/99
      IF (status .NE. merr_ok) GO TO 5000

* Find the number of seconds since T0
      offset_secs = date_secs - start_secs

* Divide by time step increment to get # of time step
      dval = offset_secs/tunit

      status = merr_ok
      RETURN

* error exit
 5000 RETURN

      END

	LOGICAL FUNCTION ITSA_MODULO_GCF( cx, idim )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine whether a particular axis of a grid changing variable should have
* modulo applied to the RESULT of the function rather than to the arguments,
* as is normal for non-GC uvars

* This function ASSUMES that the passed context refers to a grid-changing uvar

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V450: 2/97
*       97.07.16 *jc* adding code to query external functions
* V63  *acm* 10/09 Changes for gfortran build
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include	'tmap_dims.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'
	include 'xgrid_chg_fcns.cmn'

* calling argument declarations:
	INTEGER	cx, idim, axis_will_be(nferdims)

* internal variable declarations:
	INTEGER	 WHICH_GCFCN, gcfcn

* get grid-changing function
	gcfcn = WHICH_GCFCN( cx_variable(cx) )

* get axis sources
	IF ( gcfcn .GT. gfcn_num_internal ) THEN

	   call efcn_get_axis_will_be(gcfcn, axis_will_be)
	   ITSA_MODULO_GCF = axis_will_be(idim)
     .	           .EQ. pgc_axis_supplied_herein 

	ELSE

	   ITSA_MODULO_GCF = gfcn_axis_will_be(idim,gcfcn)
     .	           .EQ. pgc_axis_supplied_herein 

	ENDIF

	RETURN
	END

	SUBROUTINE CD_DODS_CONTROL ( dset, cdfid, remote_dods_id, cdfstat )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Remote DODS file open has just been simulated using a local cache
* Now pass control over to the remote file to create the illusion that
* it was legitimately opened

* Programmer Steve Hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* revision 0.0 - 11/96
* Linux Port - 6/97 - reorder if def logic when setting cd_data_type to 
*		      BYTE or INTEGER*1
*		    - use a cpp include for tmap_dset.parm
* V65  *acm* 1/10  Change all netcdf2-style calls and parameter names to 
*                  netcdf3-style calls, which are also consistent with netcdf4.
* V65  *acm* 1/10  Add #ifdef usingDODSf2cUnderscore, for 32-bit linux build
*                  linked with OPeNDAP library.
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* argument definitions:
*    dset - data set number
*    cdfid -  NetCDF open id for cache file
*    remote_dods_id - NetCDF open id for remote DODS file
*    cdfstat - return cdfstat

* argument declarations:
	INTEGER	dset, cdfid, remote_dods_id, cdfstat

* include files
        include 'netcdf.inc'
#include "gt_lib.parm"
	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'tmap_errors.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
        include 'xdset_info.cd_equiv'
	include 'xtm_grid.cmn_text'
	include 'xstep_files.cmn_text'

! Declare netcdf function names. 
! The ones without trailing underscore are declared in netcdf.inc
#include "netcdf_declareUnderscore.inc"

* special equivalence (not in tmap_format/xdset_info.cd_equiv because "BYTE"
* isn't supported on DECstation)
* reorder loop logic because linux cpp didn't like it *kob* 10/96

#  ifdef NEED_BYTE
      BYTE cd_data_type(maxvars)
#   else
      INTEGER*1 cd_data_type(maxvars)
#   endif

	EQUIVALENCE ( ds_precision, cd_data_type )

* local variable declarations:
	LOGICAL CD_GET_ATTRIB, CD_GET_ATTVAL,
     .	got_it, do_warn
	INTEGER tmvar, grid, idim, line, istep, attlen
	REAL	val

* local data initialization
	DATA do_warn/ .TRUE. /

* loop through the variables in this data set
	DO 100 tmvar = 1, maxvars
	   IF ( ds_var_setnum(tmvar) .NE. dset ) GOTO 100

* get the correct NetCDF data type from attributes in the cache file
	   got_it = CD_GET_ATTVAL( cdfid, cd_varid(tmvar),
     .			'netcdf_data_type', do_warn, ' ', val, 1, cdfstat )
	   IF ( .NOT. got_it ) GOTO 5100
	   cd_data_type(tmvar) = val

* get the correct NetCDF variable id from attributes in the cache file
	   got_it = CD_GET_ATTVAL( cdfid, cd_varid(tmvar),
     .			'netcdf_var_id', do_warn, ' ', val, 1, cdfstat )
	   IF ( .NOT. got_it ) GOTO 5100
	   cd_varid(tmvar) = val

* restore the full span of the grids to the variables
	   grid = ds_grid_number(tmvar)
	   DO 50 idim = 1, 4
	      line = grid_line(idim,grid)
	      IF (line .NE. mpsnorm) ds_grid_end(idim,tmvar)
     .				     = line_dim( line )
 50	   CONTINUE

 100	CONTINUE

* get the full URL back again (cache name was substituted in ds_des_name)
	got_it = CD_GET_ATTRIB( cdfid, NF_GLOBAL, 'DODS_URL',
     .                     do_warn, ' ', ds_des_name(dset), attlen, 128 )
	IF ( .NOT. got_it ) GOTO 5100

* close the cache file and substitute the remote file in its place

	cdfstat = NF_CLOSE ( cdfid )

* insert the remote file info in place of the cache info
	istep = cd_stepfile(dset)
	sf_lunit(istep) = remote_dods_id
	cdfid = remote_dods_id
	sf_name(istep) = ds_des_name(dset)

* successful completion
      cdfstat = merr_ok
      RETURN

* error exit
 5100	CALL TM_ERRMSG( merr_dsetnf, cdfstat, 'CD_DODS_CONTROL',
     .                   dset, no_stepfile,
     .                   'DODS cache file lacks necessary attributes',
     .                   no_errstring, *5900)
 5900	CALL CD_ABORT_GRIDS

	cdfstat = NF_CLOSE ( remote_dods_id )
 5990	RETURN
	END

	SUBROUTINE DO_RUN_SUM_DSG  (idim, dset, nfeatures, 
     .					   com, com_mr, com_cx,
     .					   res, res_mr, res_cx)


*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* sum the component along axis idim producing a "running sum"
* for data on Distributed Sampling Geometries grids

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Science Data Integration Group
* 2/2019
* V76   1/20 *acm* Orientation of Point-type data set to e_dim


        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'interp_stack.parm'
	include	'xprog_state.cmn'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xunits.cmn_text'
	external xunits_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xdyn_linemem.cmn_text'
	include 'xdset_info.cmn_text'
	include 'xdsg_context.cmn'

* calling argument declarations:
	INTEGER	idim, dset, com_mr, com_cx, res_mr, res_cx, 
     .		nfeatures
	REAL	com   ( * ),
     .          res   ( * )

* internal variable declarations:
	LOGICAL fmask(nfeatures)
	INTEGER i, grid, iaxis, ii, ifeature, iobs, 
     .          flen, base, orientation, row_size_lm
	REAL	bad_com, bad_res, val, dsum

* initialize
	grid = mr_grid( com_mr )
	bad_com = mr_bad_data( com_mr )
	bad_res = mr_bad_data( res_mr )

* DSG-specific initialize

        CALL MAKE_DSG_FEATURE_MASK(dset, com_cx, fmask, nfeatures)
	row_size_lm  = dsg_loaded_lm(dsg_row_size_var(dset))
	orientation  = dsg_orientation(dset)

* Shift

	IF (idim.EQ.orientation .AND. orientation.LE.t_dim) THEN 

* *** true ragged array processing:
* sum independently along each feature 
*     Work with all data in the feature. WW coordinate masking etc  
*     will be applied before listing or plotting

           base = 0    ! obs index at end of preceding feature

* ... loop over the features
	   ftrloop: DO ifeature = 1, nfeatures 

	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length

* ... have the user's constraints removed this feature?
	      IF (.NOT.fmask(ifeature)) THEN
                 base = base + flen
                 CYCLE ftrloop
              ENDIF

* ... loop over the observations within each feature
              iobs = base

* Single item in the feature, return the single value

	      IF (flen .EQ. 1) THEN 
	          iobs = iobs + 1 
		  
                  val = com(iobs)
	          IF ( val .EQ. bad_com ) THEN
		     res(iobs) = bad_res
	          ELSE
		     res(iobs) = val
		  ENDIF

		  base = base + flen
		  CYCLE ftrloop 

	      ENDIF

* ... loop over the observations within each feature, if obs is not masked 
*     then sum it.

	      dsum = 0.0D0	! data sum

	      iobs = base
	      DO i = 1, flen
	         iobs = iobs + 1   ! index in the contig ragged array

                 val = com(iobs)

* ... reject all data after a bad point
	         IF ( val .EQ. bad_com ) THEN
		    DO ii = i, flen
		       res(iobs) = bad_res
		       iobs = iobs+1
		    ENDDO
		    EXIT   ! flen loop - done with this feature
	         ENDIF

		 dsum = dsum + val
		 res(iobs) = dsum
	      ENDDO

	      base = base + flen

	   ENDDO ftrloop

	ELSE  

* *** a simple list of instances:
* Work along the feature-number axis

	   dsum = 0.0D0	! data

	   DO ifeature = 1, nfeatures 

* ... have the user's constraints removed this feature?
	      IF (.NOT.fmask(ifeature)) CYCLE

* ... the input data value
              val = com(ifeature)

* ... reject all data after a bad point
	      IF ( val .EQ. bad_com ) THEN
		 DO ii = ifeature, nfeatures
		    res(ii) = bad_res
		 ENDDO
		 EXIT   ! ifeature loop
	      ENDIF

*    add next value

	      dsum = dsum + val
	      res(ifeature) = dsum

           ENDDO


	ENDIF  ! obs vs feature

	
	RETURN
	END

	SUBROUTINE SANITY_CHECK_MEMORY(tag)

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administrations (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* diagnostic report on memory usage and integrity check
* note that this routine could be streamlined -- the linked lists are
* traversed two separate times.  Since this code is only run in diagnostic
* situations we have not troubled to mske it nicer.

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
*
* V702: *sh* 11/16 This is an expanded version of CHECK_MEMORY intended 
*      for use with -D debug copilations
*            1/17 - output to stdout for easier debugging

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'ferret.parm'
	include 'xvariables.cmn'
	include 'xprog_state.cmn'
	include 'xwork_space.cmn'

* calling argument declarations:
	INTEGER	lun
	CHARACTER*(*) tag

* internal variable declarations:
	LOGICAL mv_accounted_for(max_mrs)
	INTEGER	mv, mvfree, mvused, mvuncached, mvwork,
     .		nmvlost, n, pile, last, msize, test_next,
     .		ninuse, navail, nperm, mbperm, ntemp, ndel,
     .		ninprogress, ntable_entries, 
     .		slen, nn, i, ws, s1, s2
	INTEGER*8 sum, mem_in_use
	CHARACTER LEFINT*10, buff*40, b12*12
	PARAMETER (b12 = '            ')    !kob 12/96

************************************
* check Ferret variable memory allocations
        mem_in_use = 0
        DO mv = 1, max_mrs
           mem_in_use = mem_in_use + mr_size(mv)
        ENDDO
        IF (mem_in_use .NE. total_mem) THEN
	      CALL WARN('***** corrupted total mem size: '
     .                  //LEFINT(mem_in_use,slen) )
        ENDIF

* 11/16 brute force check of memory table list integrity
	DO mv = 1, max_mrs
	   mv_accounted_for(mv) = .FALSE.
	ENDDO
* ... free list (only forward mv links)
	n = 0
	mvfree = 0
	mv = mv_flink( 0 )	! base pointer for free slots
 10	IF ( mv .NE. 0 ) THEN
	   n = n + 1  ! number of passes
	   IF (n .GT. max_mrs + 5) THEN
	      CALL TM_NOTE('SANITY ERR: Trapped in free list ...'
     .				, ttout_lun)
	   ENDIF
	   IF (mv_accounted_for(mv)) THEN
	      CALL TM_NOTE('SANITY ERR: free mr list is corrupted: '
     .	   		//LEFINT(mv,slen)//tag, ttout_lun)   ! loop forever
	   ENDIF
	   mv_accounted_for(mv) = .TRUE.
	   mvfree = mvfree + 1
	   mv = mv_flink(mv)
	   GOTO 10
	ENDIF
* ... hash piles (cached mvars)
	mvused = 0
	DO 14 pile = 1, pmv_npiles
	   last = -pile
	   mv = mv_flink( last )	! base pointer for slots in this hash #
	   n = 0
 12	   IF ( mv .GT. 0 ) THEN
	      n = n + 1  ! number of passes
	      IF (n .GT. max_mrs + 5) THEN
	         CALL TM_NOTE('SANITY ERR: Trapped in hash pile ...'
     .			//LEFINT(-pile,slen), ttout_lun) 
	      ENDIF
	      IF (mv_accounted_for(mv)) THEN
	         CALL TM_NOTE
     .			('SANITY ERR: cached mr slot found in multiple lists: '
     .	   			//LEFINT(mv,slen)//LEFINT(-pile,slen)//tag,
     .				ttout_lun) 
	      ENDIF
	      IF (mv_blink(mv) .NE. last) THEN
	         CALL TM_NOTE ('SANITY ERR: hash pile back link error: '
     .	   			//LEFINT(mv,slen)//LEFINT(-pile,slen)//tag,
     .				ttout_lun) 
	      ENDIF
	      mv_accounted_for(mv) = .TRUE.
	      mvused = mvused + 1
	      last = mv
	      mv = mv_flink(mv)
	      GOTO 12
	   ENDIF
 14	CONTINUE
* ... work space mvars
	n = 0
	mvwork = 0
	last = pmv_work_var_pile
	mv = mv_flink( last )	! base pointer for slots in this hash #
 16	IF ( mv .GT. 0 ) THEN
	   n = n + 1  ! number of passes
	   IF (n .GT. max_mrs + 5) THEN
	      CALL TM_NOTE('SANITY ERR: Trapped in work space chain ...',
     .				ttout_lun) 

	   ENDIF
	   IF (mv_accounted_for(mv)) THEN
	      CALL TM_NOTE
     .		('SANITY ERR: work var mr slot found in multiple lists: '
     .	   			//LEFINT(mv,slen)//tag, ttout_lun) 
	   ENDIF
	   IF (mv_blink(mv) .NE. last) THEN
	      CALL TM_NOTE('SANITY ERR: work var back link error: '
     .	   			//LEFINT(mv,slen)//tag, ttout_lun)
	   ENDIF
	   mv_accounted_for(mv) = .TRUE.
	   mvwork = mvwork + 1
	   last = mv
	   mv = mv_flink(mv)
	   GOTO 16
	ENDIF
* ... uncached mvars
	n = 0
	mvuncached = 0
	last = pmv_nocache_pile
	mv = mv_flink( last )	! base pointer for slots in this hash #
 18	IF ( mv .GT. 0 ) THEN
	   n = n + 1  ! number of passes
	   IF (n .GT. max_mrs + 5) THEN
	      CALL TM_NOTE('SANITY ERR: Trapped in uncached chain ...',
     .				ttout_lun)	
	   ENDIF
	   IF (mv_accounted_for(mv)) THEN
	      CALL TM_NOTE
     .		('SANITY ERR: uncached mr slot found in multiple lists: '
     .	   			//LEFINT(mv,slen)//tag, ttout_lun)
	   ENDIF
	   IF (mv_blink(mv) .NE. last) THEN
	      CALL TM_NOTE('SANITY ERR: uncached back link error: '
     .	   			//LEFINT(mv,slen)//tag, ttout_lun)
	   ENDIF
	   mv_accounted_for(mv) = .TRUE.
	   mvuncached = mvuncached + 1
	   last = mv
	   mv = mv_flink(mv)
	   GOTO 18
	ENDIF
	IF (mvused+mvfree+mvwork+mvuncached .NE. max_mr_avail) THEN
	   CALL TM_NOTE
     .		('SANITY ERR: number of mr slots doesnt tally', ttout_lun)
	ENDIF
	DO mv = 1, max_mr_avail
	   IF( .NOT.mv_accounted_for(mv)) THEN
	      CALL TM_NOTE('SANITY ERR: mr unaccounted in any list: '
     .	   			//LEFINT(mv,slen)//tag, ttout_lun)
	   ENDIF
	ENDDO

* ... the deletion priority chain
	n = 0
	last = 0
	mv = mr_del_flink(last)
 19	IF ( mv .NE. 0 ) THEN
	   n = n + 1  ! number of passes
	   IF (n .GT. max_mrs + 5) THEN
	      CALL TM_NOTE('SANITY ERR: Trapped in deleted chain ...'
     .				//tag, ttout_lun)
	      STOP 
	   ENDIF
	   IF (mr_del_blink(mv) .NE. last) THEN
	      CALL TM_NOTE ('SANITY ERR: deletion chain back link error: '
     .	   			//LEFINT(mv,slen)//tag, ttout_lun)
	   ENDIF
	   last = mv
	   mv = mr_del_flink(mv)
	   GOTO 19
	ENDIF


************************************

* check slots in memory variable table
* ... free table slots
	mvfree = 0
	mv     = mv_flink( 0 )	! base pointer for free slots
 200	IF ( mv .NE. 0 ) THEN

* * * * integrity check * * * * * * * * * * * * * * * * * * * *
	   IF ( mr_protected(mv) .NE. mr_deleted ) THEN
	      CALL TM_NOTE('SANITY ERR: improperly deleted: '
     .				//LEFINT(mv,slen)//tag, ttout_lun)
	   ENDIF
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	   mvfree = mvfree + 1
	   mv = mv_flink( mv )
	   GOTO 200
	ENDIF

* * * * SUMMARIZE MEMORY TABLE SLOTS IN USE * * * *
* check all the variables in all the hash piles
	mvused = 0
	DO 310 pile = 1, pmv_npiles
	   last = -pile
	   mv = mv_flink( last )	! base pointer for slots in this hash #
 300	   IF ( mv .GT. 0 ) THEN
	      IF ( mr_protected(mv) .EQ. mr_deleted
     .	      .OR. mv_blink(mv) .NE. last ) THEN
	          CALL TM_NOTE('SANITY ERR: improperly cataloged: '
     .				//LEFINT(mv,slen)//tag, ttout_lun)
	      ENDIF
	      mvused = mvused + 1
	      last   = mv
	      mv     = mv_flink(mv)
	      GOTO 300
	   ENDIF
 310	CONTINUE

* check non-cached variables (10/99)
	last = pmv_nocache_pile
	mv = mv_flink( last )	! base pointer for slots in this hash #
 350	IF ( mv .GT. 0 ) THEN
	   IF ( mr_protected(mv) .EQ. mr_deleted
     .	   .OR. mr_protected(mv) .EQ. mr_in_progress
     .	   .OR. mv_blink(mv) .NE. last ) THEN
	      CALL TM_NOTE('SANITY ERR: uncached variable error: '
     .				//LEFINT(mv,slen)//tag, ttout_lun)
	   ENDIF
	   mvused = mvused + 1
	   last   = mv
	   mv     = mv_flink(mv)
	   GOTO 350
	ENDIF

* check work storage allocated by GET_WORK_MR
	last = pmv_work_var_pile
	mv = mv_flink( last )	! base pointer for slots in this hash #
 370	IF ( mv .GT. 0 ) THEN
	   IF ( mr_protected(mv) .NE. mr_in_progress
     .	   .OR. mv_blink(mv) .NE. last ) THEN
	      CALL TM_NOTE('SANITY ERR: table work storage variable error: '
     .				//LEFINT(mv,slen)//tag, ttout_lun)
	   ENDIF
	   mvused = mvused + 1
	   last   = mv
	   mv     = mv_flink(mv)
	   GOTO 370
	ENDIF

* * * * integrity check * * * * * * * * * * * * * * * * * * * *
* make sure no table slots or memory blocks have been lost
	nmvlost = max_mr_avail - ( mvfree+mvused )
	IF ( nmvlost .NE. 0 ) THEN
	   CALL TM_NOTE('SANITY ERR: lost table slots: '
     .				//LEFINT(nmvlost,slen)//tag, ttout_lun)
	ENDIF

* * * * integrity check * * * * * * * * * * * * * * * * * * * * *
* variable deletion priority chain
	navail = 0
	mv = mr_del_flink(0)
 400	IF ( mv .NE. 0 ) THEN
	   navail = navail + 1
	   IF ( mr_protected(mv) .NE. mr_not_protected ) THEN
	      CALL TM_NOTE('SANITY ERR: Protected variables deleted',
     .				ttout_lun)
	   ENDIF
	   mv = mr_del_flink(mv)
	   GOTO 400
	ENDIF
	ninuse = 0
	ndel   = 0
	nperm  = 0
	ntemp  = 0
        ninprogress = 0
	ntable_entries = 0
	DO 410 mv = 1, max_mr_avail
	   IF ( mr_protected(mv) .GT. 0 ) THEN
	      ninuse = ninuse + 1
	   ELSEIF ( mr_protected(mv) .EQ. mr_perm_protected ) THEN
	      nperm  = nperm  + 1
	   ELSEIF ( mr_protected(mv) .EQ. mr_deleted ) THEN
	      ndel = ndel + 1
	   ELSEIF ( mr_protected(mv) .EQ. mr_temporary ) THEN
	      ntemp = ntemp + 1
	   ELSEIF ( mr_protected(mv) .EQ. mr_in_progress ) THEN
	      ninprogress = ninprogress + 1
	   ELSEIF ( mr_protected(mv) .EQ. mr_table_entry_only ) THEN
	      ntable_entries = ntable_entries + 1
	   ENDIF
 410	CONTINUE
	nmvlost = max_mr_avail
     .		- (ninuse+navail+nperm+ndel+ntemp+ninprogress+ntable_entries)
	IF ( nmvlost .NE. 0 ) THEN
	   CALL TM_NOTE( 'SANITY ERR: Unaccountable var protection: '
     .				//LEFINT(nmvlost,slen)//tag, ttout_lun)
	ENDIF
	n = ndel - mvfree
	IF ( n .NE. 0 ) THEN
	   CALL TM_NOTE( 'SANITY ERR: Deleted vars unaccountable: '
     .				//LEFINT(nmvlost,slen)//tag, ttout_lun)
	ENDIF

* * * * * * dynamic memory sanity check * * * * *
	sum = 0
	DO mv = 1, max_mr_avail
	   s1 = mr_size(mv)
	   s2 = SIZE(memry(mv)%ptr) 
	   sum = sum + s1
	   IF ( mr_protected(mv) .NE. mr_table_entry_only) THEN
              IF (s1 .NE. s2) THEN
	         CALL TM_NOTE( 'SANITY ERR: Dynamic mem size error: '
     .			//LEFINT(mv,slen)//LEFINT(s1,slen)
     .			//LEFINT(s2,slen)//tag, ttout_lun)
	      ENDIF
	   ELSE
              IF (s1 .NE. 0) THEN
	         CALL TM_NOTE( 'SANITY ERR: Table entry size error: '
     .			//LEFINT(mv,slen)//LEFINT(s1,slen)
     .			//LEFINT(s2,slen)//tag, ttout_lun)
	      ENDIF
	   ENDIF
	ENDDO
	IF (sum .NE. total_mem) THEN
	   CALL TM_NOTE( 'SANITY ERR: Dynamic mem total: '
     .			//LEFINT(sum,slen)//LEFINT(total_mem,slen)//tag,
     .			 ttout_lun)
	ENDIF

* work storage
	DO ws = 1, max_ws
	   s1 = ws_size(ws)
	   s2 = SIZE(workmem(ws)%ptr) 
           IF (s1 .NE. s2) THEN
	      CALL TM_NOTE( 'SANITY ERR: Dynamic work space size error: '
     .			//LEFINT(ws,slen)//LEFINT(s1,slen)
     .			//LEFINT(s2,slen)//tag, ttout_lun)
	   ENDIF
	ENDDO

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	RETURN
	END

	SUBROUTINE MINMAX_DSG ( dset, cx, nfeatures, idim, array,  
     .        bad_flag, lo, hi, nok )

*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine the minimum and maximum values within a REAL array
* for data on Discrete Sampling Geometries grid. Return the overall 
* min and max of the data after feature-masking

* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Science Data Integration Group
* 3/2019
* V76   1/20 *acm* Orientation of Point-type data set to e_dim

        IMPLICIT NONE
	include	'ferret.parm'
        include 'tmap_dims.parm'
	include 'xdyn_linemem.cmn_text'
	include 'xdset_info.cmn_text'
	include 'xdsg_context.cmn'

* calling argument declarations:
	INTEGER	dset, cx, nfeatures, idim, n, nok
	REAL    array(*), bad_flag, lo, hi

* internal variable declarations:
	LOGICAL fmask(nfeatures)
	INTEGER i, ifeature, iobs, flen, base, 
     .          orientation, row_size_lm

* DSG-specific initialize

        CALL MAKE_DSG_FEATURE_MASK(dset, cx, fmask, nfeatures)
	row_size_lm  = dsg_loaded_lm(dsg_row_size_var(dset))
	orientation  = dsg_orientation(dset)

* initialize
	lo = arbitrary_large_val4
	hi = arbitrary_small_val4
	nok = 0

	IF (idim.EQ.orientation .AND. orientation.LE.t_dim) THEN 

* *** true ragged array processing:
*     return the overall min and max of the data after feature-masking

           base = 0    ! obs index at end of preceding feature

* ... loop over the features
	   ftrloop: DO ifeature = 1, nfeatures 

	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length

* ... have the user's constraints removed this feature?
	      IF (.NOT.fmask(ifeature)) THEN
                 base = base + flen
                 CYCLE ftrloop
              ENDIF

* ... loop over the observations within each feature
              iobs = base

	      iobs = base
	      DO i = 1, flen
	         iobs = iobs + 1   ! index in the contig ragged array

	         IF ( array(iobs) .EQ. bad_flag ) CYCLE
	         IF ( array(iobs) .LT. lo ) lo = array(iobs)
	         IF ( array(iobs) .GT. hi ) hi = array(iobs)
	         nok = nok + 1
	      ENDDO

	      base = base + flen

	   ENDDO ftrloop

	ELSE  

* *** a simple list of instances:
* Work along the feature-number axis

	   DO ifeature = 1, nfeatures 

* ... have the user's constraints removed this feature?
	      IF (.NOT.fmask(ifeature)) CYCLE

	      IF ( array(ifeature) .EQ. bad_flag ) CYCLE
	      IF ( array(ifeature) .LT. lo ) lo = array(ifeature)
	      IF ( array(ifeature) .GT. hi ) hi = array(ifeature)
	      nok = nok + 1
           ENDDO


	ENDIF  ! obs vs feature
	
	RETURN
	END

    	SUBROUTINE PROMOTE_AGG_GLOBAL_ATTS(agg_dset, nsets, member_sets, 
     .               agg_dim, iline, nvars, status)

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promoted any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* assign global attributes to the Ensemble aggregation 
* Promote the attribute to a variable on the aggregate-axis. 
* programmer -Ansley Manke from set_agg_var_atts
* NOAA/PMEL, Seattle, WA - Science Data Integration Group
*
* Issue 1667
* V741 *acm* 5/18 
* Notes
* 1. Global atts that match a file-variable name from the ensemble are
*    promoted as "name_g_".  
* 2. Does it make sense to do the same for forecast sets? If so then what 
*    about ensembles of Forecasts and FMRC's of ensembles?  Any issues?

        IMPLICIT NONE
        INCLUDE 'tmap_dims.parm'
#include "tmap_dset.parm"
        INCLUDE 'ferret.parm'
        INCLUDE 'errmsg.parm'      
        INCLUDE 'xprog_state.cmn'
        INCLUDE 'xvariables.cmn'
        INCLUDE 'xcontext.cmn'
        INCLUDE 'xdset_info.cmn_text'
	external xdset_info_data
	include 'xdset_info.cd_equiv'
	include 'xtm_grid.cmn_text' 
        INCLUDE 'netcdf.inc'

* calling arguments
*  agg_dset     - dset no of the aggregation (input)
*  nsets        - number of member datasets in aggregation (input)
*  member_sets  - list of member dataset numbers (input)
*  agg_dim      - direction of the aggregatin, just for a note
*  status       - return status (output)

* calling argument declarations
	INTEGER agg_dset, nsets, member_sets(*), agg_dim,  
     .         iline, nvars, status

* Local variable declarations
        INTEGER maxlen
        PARAMETER (maxlen = 2048)

        LOGICAL NC_GET_ATTRIB, TM_LEGAL_NAME, got_it, first_memb
        INTEGER TM_LENSTR1, STR_SAME, TM_FIND_LIKE_GRID,
     .          vlen, iref, rmemb, varid, ngatts, 
     .          imemb, attype, attlen, attoutflag, m_attid, m_attype, 
     .          m_attlen, m_attoutflag, i, ii, i1, ia, j, iatt, idim, 
     .          iset, igrid, ngrid, nv, nv1, ivar, vtype, num_indices, 
     .          slen, itype, max_attlen

        REAL    attvals(100)
	CHARACTER attname*128, vname*1, buff*128, label*8, add_name*128
        CHARACTER*(maxlen) attstr

* initialize

*     ... assign a label to use later 

* Promote global attributes from Ensembles. 
* Currently do not promote global attributes from members of an FMRC aggregation

        IF (agg_dim .EQ. e_dim) THEN
	   label = 'Ensemble'
c        ELSE IF (agg_dim .EQ. f_dim) THEN
c	   label = 'FMRC'
        ELSE
	   RETURN
	ENDIF


* Define the grid for the promoted variables

	igrid = 0
	CALL TM_ALLO_TMP_GRID (igrid, status)
	IF (status .NE. ferr_ok) GOTO 5000
	DO idim = 1, nferdims
	   grid_line(idim, igrid) = mnormal
	ENDDO
	grid_line(agg_dim, igrid) = iline

* dup names resolved later
	IF (agg_dim .EQ. e_dim) grid_name(igrid) = 'GGE'
	IF (agg_dim .EQ. f_dim) grid_name(igrid) = 'GGF'

* Define variables in the aggregation from the member-dataset global attributes.

* varid for global attributes is 0
        vname = '.'
	vlen = 1
	varid = 0
	first_memb = .TRUE.

	nv1 = 0  ! mark the 1st variable added
	DO nv = 1, maxvars
	   IF ( STR_SAME(ds_var_code(nv),char_init) .EQ. 0 ) EXIT
	ENDDO
	nv1 = nv - 1

* Loop over member sets. Make a variable which is the member-set names
* and variables with all global attributes in the collection, including
* ones present only in some member sets. iref is the current reference set, 
* checking if it has attributes that others, so far, haven't included.

	memberloop: DO iref = 1, nsets

	IF (member_sets(iref) .EQ. pdset_dummy) CYCLE memberloop
	rmemb = member_sets(iref)

* Get number of global attributes from the reference set
        CALL CD_GET_VAR_NATTS (rmemb, varid, vname(:vlen),
     .                         ngatts, status)

* First put in a promoted varaible that's the dataset name
	ia = 0
	IF (.NOT.first_memb) ia = 1

**** loop through the attribute list from the reference variable
        attloop: DO iatt = ia, ngatts

* Add a variable to the global set to contain the short-names of the members
* (store the name in attname)

	   IF (iatt .EQ. 0) THEN 

	      attname = 'member_dset'
	      attype = NCCHAR

	   ELSE

* All global attributes

              max_attlen = 0
	      CALL CD_GET_VAR_ATT_NAME (rmemb, varid, iatt, attname, status)

* get the reference attribute info
              CALL CD_GET_VAR_ATT_INFO (rmemb, varid, iatt, attname, 
     .               attype, attlen, attoutflag, status )
              IF (status .NE. ferr_ok) GOTO 5200

* If this is not a legal name, skip it.  (e.g. attribute 'aggregate name')

              IF (.NOT.TM_LEGAL_NAME(attname) ) CYCLE attloop 

* numeric attributes?

              IF ( attype .NE. NCCHAR ) THEN
	         max_attlen = MAX(attlen, max_attlen)
              ENDIF

* get the reference attribute value and info
              got_it = NC_GET_ATTRIB ( rmemb, varid, attname,
     .                              .TRUE., vname(:vlen), maxlen,
     .                              attlen, attoutflag,
     .                              attstr, attvals )
              IF (.NOT.got_it) GOTO 5200

	   ENDIF  ! iatt .EQ. 0

	   first_memb = .FALSE.

* Find the global attribute in other sets, check for type mismatch
* and check that we can get the attribute.  In each pass treating each
* member file as iref - look for attributes not yet found


           DO imemb = 1, nsets
	   
	      IF (imemb .EQ. iref) CYCLE

* ... skip over dummy members
              IF (member_sets(imemb) .EQ. pdset_dummy) CYCLE
	      iset = member_sets(imemb)

* ... iatt = 0 getting dataset names

	      IF (iatt .EQ. 0) THEN 

	         attname = 'member_dset'

	      ELSE	

* ... get the attribute info for the member

                 CALL  CD_GET_VAR_ATT_ID (iset, varid, attname, 
     .                                m_attid, status)

                 IF (status .NE. ferr_ok) CYCLE 

* Have we already defined a promoted variable from this attribute?
	         IF (iref .GT. 1) THEN
	            CALL string_array_find_caseblind(ds_var_code_head,
     .                                   attname,
     .                                   LEN(attname),
     .                                   string_array_result(1),
     .                                   max_uvar,
     .                                   num_indices)

	            IF (num_indices .GE. 1) THEN
                       DO j = 1, num_indices
                          i1 = string_array_result(j)
* ... We already have promoted this attr. Move to next attr in set # iref 
*     (check later whether this name is a variable name in member sets)
                          IF (ds_var_setnum(i1) .EQ. agg_dset) THEN
			     IF (ds_var_title(i1)(:12) .EQ. 'Global Att *')
     .                          CYCLE attloop
                          ENDIF
                       ENDDO
	            ENDIF
	         ENDIF

	         CALL CD_GET_VAR_ATT_INFO (iset, varid,
     .                                  m_attid, attname, m_attype, 
     .                                  m_attlen, m_attoutflag, status )
		
* is one numeric and the other char? Skip the attrib.

                 IF (attype.EQ.NCCHAR .AND. m_attype.NE.NCCHAR ) CYCLE attloop
                 IF (attype.NE.NCCHAR .AND. m_attype.EQ.NCCHAR ) CYCLE attloop
		 
* check that we can get the attribute value for the member
                 got_it = NC_GET_ATTRIB (iset, varid,
     .                              attname,
     .                              .TRUE., vname(:vlen), maxlen,
     .                              m_attlen, m_attoutflag,
     .                              attstr, attvals )

                 IF (.NOT. got_it) CYCLE 
		 
                 IF ( m_attype .NE. NCCHAR ) THEN
	            max_attlen = MAX(m_attlen, max_attlen)
                 ENDIF

              ENDIF ! iatt.EQ.0 getting dataset names

           ENDDO  ! Getting attrib info from all sets


* Create a variable in the aggregate dataset 
* ds_var slot, fill with aggregate variable in aggregate dataset.

	   nv = nv + 1

           add_name = attname
	   IF (iatt.EQ.0) THEN
	      buff = "Member dataset names in "//label(:TM_LENSTR1(label))

           ELSE

              buff = "Global Att *"//attname(:TM_LENSTR1(attname))//"* in "//
     .		label(:TM_LENSTR1(label))

* ... check whether there are file variables with the same name as the global attr
              dsetcheck: DO ii = 1, nsets
                 iset = member_sets(ii)

                 IF (iset .EQ. pdset_dummy) CYCLE dsetcheck

* ... check whether there is a ensemble file variable with the same name as the global attr

* Is there already an ensemble variable with this name?
                 CALL string_array_find_caseblind(ds_var_code_head,
     .                                   add_name,
     .                                   LEN(add_name),
     .                                   string_array_result(1),
     .                                   max_uvar,
     .                                   num_indices)

                 IF (num_indices .GE. 1) THEN
                    DO j = 1, num_indices
                       i1 = string_array_result(j)
                       IF (ds_var_setnum(i1) .EQ. agg_dset) THEN
			  IF (ds_var_title(i1)(:12) .NE. 'Global Att *') THEN

* ... Matches a file var. Rename the attribute we are promoting. 
*    
*     Note its possible to construct files that fail with this. If there's a
*     varaible and global att named sst, we promte the global one as "sst_g_".
*     If there are also global atts named "sst_g_" then that's a conflict.
*     Try a couple of combinations, otherwise just issue a note and skip this one.
				
			     add_name = attname(:TM_LENSTR1(attname))//"_g_"
			     CALL TEST_PROMOTE_NAME (add_name, agg_dset, nsets, member_sets, status)
			     IF (status .NE. ferr_ok) THEN
				CALL WARN ( "Not promoting global attribute "//
     .                                   attname(:TM_LENSTR1(attname))//" due to name collisions")
			        CYCLE attloop
			     ENDIF

			  ELSE

* ... We have already promoted this attr. Move to next attr in set # iref 
			     CYCLE attloop

			  ENDIF
                       ENDIF

                    ENDDO
                 ENDIF

              ENDDO dsetcheck

	   ENDIF

	   ds_var_title(nv) =  buff

* Now add a user-defined variable to the aggregated dset 

           ds_var_setnum(nv)   = agg_dset
           CALL string_array_modify_upcase(ds_var_code_head, nv, 
     .           add_name, LEN(add_name))

           ds_var_titl_mod(nv) = " "
           ds_var_units(nv)    = " "
           ds_missing_flag(nv) = bad_val4
           ds_bad_flag(nv)     = bad_val4

* Will turn a multi-valued numeric global attribute into a set
* of lists of numbers written to strings
	   IF (m_attype .NE. NCCHAR) THEN
	      IF (max_attlen .GT. 1) attype = NCCHAR
	   ENDIF

           IF (attype .EQ. NCCHAR) THEN 
              ds_var_type(nv)  = ptype_string
           ELSE
	      ds_var_type(nv)  = ptype_float
	   ENDIF
	   cd_scale_factor(nv) = 1.
	   cd_add_offset(nv)   = 0.
	   cd_scaled(nv)       = .FALSE.

	   DO idim = 1, nferdims
              ds_grid_start(idim,nv)= 1
              ds_grid_end(idim,nv)  = 1
              ds_ordering(idim,nv)  = int4_init
	   ENDDO
	   ds_grid_start(agg_dim,nv)= 1
	   ds_grid_end(agg_dim,nv)  = nsets
	   ds_ordering(1,nv)        = agg_dim  ! last dimension of the grid

	   ds_grid_number(nv) = igrid

* Hook the aggregated variable into the linked list structures
	      
	   nvars = nvars + 1
	   CALL CD_ADD_VAR( agg_dset, add_name, nvars, 
     .            ds_var_title(nv), ds_var_units(nv), attype, 
     .            .FALSE., ds_bad_flag(nv), status)

	   DO imemb = 1, nsets
              iset = member_sets(imemb)
              IF (iset .EQ. pdset_dummy) CYCLE
              itype = cat_agg_gpromote
              CALL CD_ADD_AGG_VAR_INFO (agg_dset, add_name, imemb, itype, 
     .             iset, igrid, iline, nv, status)
	   ENDDO

        ENDDO attloop

        ENDDO memberloop

* success
* (status may have been set to atom_not_found on a missing attribute.
*  Set to ferr_ok.)

	status = ferr_ok
 5000	CONTINUE

	RETURN

 5200   CALL ERRMSG (ferr_internal, status,
     .               'attListCrptn: '//attname(:vlen),*5000)
	END


	SUBROUTINE TEST_PROMOTE_NAME (testname, agg_dset, nsets, member_sets, status)
        INCLUDE 'errmsg.parm'      


	CHARACTER*(*) testname
	INTEGER	agg_dset, nsets, member_sets(*), status


	INTEGER STR_SAME, ngatts, iset, imemb, iatt, varid
	CHARACTER attname*128, vname*1

	
* varid for global attributes is 0
        vname = '.'
	varid = 0

	DO iset = 1, nsets

* Get number of global attributes from the member set
           imemb = member_sets(iset)
	   CALL CD_GET_VAR_NATTS (imemb, varid, vname(:1),
     .                         ngatts, status)

           DO iatt = 1, ngatts
	      CALL CD_GET_VAR_ATT_NAME (imemb, varid, iatt, attname, status)
	      IF ( STR_SAME(testname, attname) .EQ. 0 ) THEN
	         status = ferr_aggregate_error
	         GOTO 5000
	      ENDIF
	   ENDDO


	ENDDO

	status = ferr_ok

 5000	RETURN
	END

	SUBROUTINE ERRMSG ( status_in, status_out, err_string, * )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* display explanatory message of error, transfer error code to output variable,
* and always take alternate return to serve as error branch in
* calling program
* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 3/31/86 - heavily based on TM_ERRMSG
* revision 0.1 -  4/2/86 - changed FORMAT for ERR = messages
* revision 0.2 - 4/29/87 - depending on mode_ignore_err possibly return
*			   control of program to interactive mode
* revision 0.3 - 5/14/87 - saves "last_error"
* revision 0.4 - 11/30/87- handles interrupts
* revision 0.5 - 1/12/89 - prefix error messages with "**ERROR:"
*			 - eliminated non-standard "_" format
* V200:  6/21/89 - check to see if "HELP CUE" is requested
*	11/14/89 - special processing of Panasonic "ODR" errors
*	11/27/89 - multiple line messages
* Unix/RISC port - 1/91 - cant use "//" with CHAR*(*) variable
*			- different processing of ferr_erreq
*                 11/91 - "HELP" cues only relevant on VMS
* V230:  7/21/92 - improved formatting of Unix system messages using PERROR arg
*        11/4/92 - trim line end blanks from first line of message
*         2/3/93 - display command line if control stack is "up"
* V300:  4/30/93 - added ferr_silent (for GO arguments with own error text)
*	 7/93 - added changes for GUI-based control
* V301:	11/93 - the SUN f77 also has a bug with "//" on char*(*) variables.
*		It doesn't show up as a compiler error message - instead it
*		causes "RETURN 1" to do a normal return
* V320: 2/28/95 - SPLIT_GUI_MESSAGE --> TM_SPLIT_MESSAGE
* V420: 4/28/96 - close out all open IF blocks on error
* 12/96 - LINUX Port - *kob*
*		     - had to insert a "!" in column 1 of a purely comment line
*		     - had to remove a single quote from comment line - 
*			compiler did not like it...
*		      - added ifdef to use linux perror c routine rather than
*			fortran perror.  3.11.97
* *kob* 1/00 - v5.30 - add xplot_setup for animate logical.  if ctrl-c
*                      interrupt during animation, clean things up
* arguments:
*	status	- error code from calling program
*	status_out	- error code (echoed) back to calling program
*	err_string	- error text supplied from calling program - typically
*				a filename or variable name
* *acm 1/02  -v5.41  -- Check for mode ignore_error before closing out all open 
*                       IF blocks on error  (at label 1000)
* *acm* 10/04 v5.80  -- Check flag silent_err. This is set for SHO VAR/XML when
*                       checking for user variables not relevant to the context
* *acm* 10/04 v5.80  -- New code ferr_nomessge for use when user-given error msg 
*                       in coached string substitution
* *acm* 11/05 V600   -- New symbol FER_LAST_ERROR contains all the text normally
*                       written to std out. 
* *acm*  5/06 V600   -- Concatenate multiple lines for FER_LAST_ERROR with backslash.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* *sh* 11/13 V685    -- if allowed_err, then quickly exit
* V697 12/15 *acm* Ticket 2337 Increase length of cmnd buffer to 20480
*                  Handle longer error strings when defining the buffer symbuf
* V697 2/16 *acm* DO NOT Increase length of cmnd buffer to 20480 but keep related
*                   changes here
* V7.6 1/20 *acm*  See issue 1966: Sketch out adding the script-name when error message written.


        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'
	include 'xcontrol.cmn'
	include 'xerrmsg_text.cmn'
        include 'xrisc.cmn'
        include 'xgui.cmn'
	include 'xplot_setup.cmn'
	include 'command.parm'


* ^C handling routine
	EXTERNAL CTRLC_AST

* calling argument declarations:
	INTEGER		status_in,status_out
	CHARACTER*(*)	err_string

* internal variable declarations:
	LOGICAL 	help_cue, multiline
	INTEGER		TM_LENSTR1, len_text, len_string, status,
     .			cr_pos, ier, ist, len_symbuf, ics, indx, 
     .			ib, cs_lev
        INTEGER		max_len_symbuf
	PARAMETER	(max_len_symbuf=1028)
        CHARACTER*1028  symbuf  ! for symbol FER_LAST_ERROR
        CHARACTER*30    ndnt
	      
* see if "HELP CUE" was requested
	help_cue = status_in .GT. ghelp_cue
	IF ( help_cue ) THEN
	   status = status_in - ghelp_cue
	ELSE
	   status = status_in
	ENDIF

* initialize
	last_error = status			! save it for "HELP"
	status_out = status			! transfer error code to output
	IF (allowed_err) GOTO 500		! error condition ignored
	gui_status = status

* initialize string for symbol FER_LAST_ERROR

         symbuf = ' '
         len_symbuf = 1

         risc_buff = err_string     ! DEC f772.1 cannot use // with char*(*)

* display error message 
	IF ( status .GT. greport .AND. (.NOT.silent_err) ) THEN
	   len_text = TM_LENSTR1( err_text(status - greport) ) 
	   IF ( err_string .EQ. ' ' ) THEN
	      CALL TM_SPLIT_MESSAGE( err_lun, ' **ERROR: '//
     .				err_text(status-greport)(:len_text) )
     
              IF (len_symbuf + len_text + 10 .GT. max_len_symbuf) 
     .			len_symbuf = len_symbuf - (len_text + 10)
	      symbuf(len_symbuf:) = ' **ERROR: '//
     .				err_text(status-greport)(:len_text)
              len_symbuf = len_symbuf + len_text + 10

	   ELSE
* ... multiple lines ?
	      cr_pos = INDEX( err_string, pCR )
	      multiline = cr_pos .NE. 0
	      IF ( multiline ) THEN
	         len_string = TM_LENSTR1( err_string(:cr_pos-1) )  ! 11/92 mod
	      ELSE
	         len_string = TM_LENSTR1( err_string )
	      ENDIF

              IF (err_text(status-greport) .EQ. ' ') THEN
 	         CALL TM_SPLIT_MESSAGE( err_lun, ' **ERROR: '//
     .			        risc_buff(:len_string) )
!     .				': '//err_string(:len_string) )  !11/93 SUN bug

                 IF (len_symbuf + len_string + 10 .GT. max_len_symbuf) 
     .			len_symbuf = len_symbuf - (len_string + 10)
		 symbuf(len_symbuf:) = ' **ERROR: '//
     .			        risc_buff(:len_string) 
                 len_symbuf = len_symbuf + len_string + 10

              ELSE
                 ier = status
                 ier = greport
                 ier = status - greport
                 len_text = TM_LENSTR1(err_text(status-greport))
	         CALL TM_SPLIT_MESSAGE( err_lun, ' **ERROR: '//
     .				err_text(status-greport)(:len_text)//
     .				': '//risc_buff(:len_string) )
!     .				': '//err_string(:len_string) )  !11/93 SUN bug

                 
                 IF (len_symbuf + len_text + len_string + 13 .GT. max_len_symbuf )
     .			len_symbuf = len_symbuf - (len_text + len_string + 13)
                 IF (len_text + len_string + 13 .GT. max_len_symbuf) THEN
		   len_symbuf = max_len_symbuf - len_text - 16
		   symbuf =' **ERROR: '//
     .				err_text(status-greport)(:len_text)//
     .				': '//risc_buff(:len_symbuf)//'...'
                   len_symbuf = max_len_symbuf
		 ELSE
		    symbuf(len_symbuf:) =' **ERROR: '//
     .				err_text(status-greport)(:len_text)//
     .				': '//risc_buff(:len_string) 
                    len_symbuf = len_symbuf + len_text + len_string + 13
		 ENDIF
              ENDIF
    
	      IF ( multiline ) THEN
                 CALL WRITE_MULTI(err_lun, err_string(cr_pos+1:))
                 len_string = TM_LENSTR1(err_string(cr_pos+1:))
		 IF (len_symbuf + len_string + 2 .GT. max_len_symbuf) 
     .			len_symbuf = len_symbuf -(len_string + 2)
                 symbuf(len_symbuf:len_symbuf) = '\\'
                 symbuf(len_symbuf+1:) = err_string(cr_pos+1:)
                 len_symbuf = len_symbuf + len_string + 2
                 DO WHILE (INDEX( symbuf, pCR ) .GT. 0)
                   cr_pos = INDEX( symbuf, pCR )
                   symbuf(cr_pos:cr_pos) = '\\'
                 ENDDO
              ENDIF

	   ENDIF
 3000	   FORMAT (' **ERROR: ',3A)

	ELSEIF ( status .EQ. ferr_ODR_error ) THEN
	   len_string = TM_LENSTR1( err_string )
	   WRITE (err_lun,3100) err_string(:len_string)

           IF (len_symbuf + len_string + 1  .GT. max_len_symbuf) 
     .			len_symbuf = len_symbuf - (len_string + 1)
	   symbuf(len_symbuf:) =err_string(:len_string)
           len_symbuf = len_symbuf + len_string + 1

 3100	   FORMAT (' **Panasonic error: ',A)

* error requiring no message ?
	ELSEIF ( status .GT. gnoreport ) THEN
	   GOTO 1000

* error message from ERR= branch ?
	ELSEIF ( status .EQ. ferr_erreq ) THEN

	   len_string = TM_LENSTR1( risc_buff )
#ifdef F90_SYSTEM_ERROR_CALLS
	   call linux_perror('**ERROR: '//risc_buff(:len_string) )
#else
           CALL PERROR( '**ERROR: '//risc_buff(:len_string) )
#endif

* interrupt processing ? Re-store ^C interrupt handler
	ELSEIF ( status .EQ. ferr_interrupt ) THEN
	   CALL TM_SPLIT_MESSAGE( ttout_lun, '** INTERRUPTED! **')
	   CALL SET_CTRL_C( CTRLC_AST )
* *kob*	if animating during an interrupt, lets clean up
	   IF (animate .EQV. .TRUE.) THEN
	      animate = .FALSE.
	      CALL SWAP_ACTIVE_WINDOW
	   ENDIF
	ELSEIF ( status .EQ. ferr_interrupt ) THEN
* silent error code ?
	ELSEIF ( status .EQ. ferr_silent ) THEN
	   CONTINUE        ! quietly!

	ELSE
* unrecognized error code ?
	   CALL TM_SPLIT_MESSAGE( err_lun, 'unknown error code:')              
           symbuf(len_symbuf:) = 'unknown error code:'
           len_symbuf = MAX(max_len_symbuf, len_symbuf + 19)

	END IF

* close out all open IF blocks on error (4/96)
* but only if we're not ignoring errors (4/02)
 1000	IF ( .NOT.mode_ignore_err) then
           ifstk = 0
	   if_conditional = .FALSE.
        ENDIF

* if program was under internal control ( from the control stack ) this error
* indicates that control is to be returned to the operator
	IF ( cs_in_control ) THEN
* ... display the offending command
           IF (len_cmnd .GT. max_len_symbuf) THEN
              len_cmnd = MIN(len_cmnd, max_len_symbuf)
	      IF (status.NE.ferr_silent) CALL TM_SPLIT_MESSAGE( err_lun,
     .					cmnd_buff(1:len_cmnd)//'...')
           ELSE
	      IF (status.NE.ferr_silent) CALL TM_SPLIT_MESSAGE( err_lun,
     .					cmnd_buff(1:len_cmnd))
           ENDIF

	   cs_lev = csp

           IF ( status.EQ.ferr_interrupt
     .    .OR. .NOT.mode_ignore_err    ) THEN
* ... collapse the control stack back to simple operator control
 1100	      IF ( csp .GT. 0 ) THEN
	         CALL POP_CS
	         GOTO 1100
	      ENDIF
* ... inform the operator.  If running in -script mode, exit from Ferret.
	      CALL TM_SPLIT_MESSAGE( err_lun,
     .   'Command file, command group, or REPEAT execution aborted')
              IF (its_script) THEN
	         CALL TM_SPLIT_MESSAGE( err_lun, 'ERROR RUNNING SCRIPT')
	         status = 1
		 CALL EXIT(status)
	      ENDIF
	   ENDIF

* Add the script name including any arguments
	   ist = 0
	   DO ics = cs_lev, 1, -1
	      IF (cs_cmnd_num(ics) .EQ. cmnd_go) THEN
		 indx = TM_LENSTR1(cs_text(ics))
		 IF (ist .EQ. 0) CALL TM_SPLIT_MESSAGE( err_lun,
     .		 'Executed by script: *** GO '//cs_text(ics)(1:indx)//' ***')
		 ist = ist + 1
	      ENDIF
	   ENDDO

	ENDIF

* prompt with Help cue ?
* HELP command doesnt function on Unix systems

* Generate symbol containing the whole error message

* was there an external function error
         IF ( len_eftext .GT. 0) THEN
            symbuf(len_symbuf:) = '. Bailing out of external function '
     .         //efname(:len_efname)//'\\'
            len_symbuf = MIN(max_len_symbuf, len_symbuf + len_efname + 36)
            symbuf(len_symbuf:) = ef_errtext(:len_eftext)
            len_symbuf = MIN(max_len_symbuf, len_symbuf + len_eftext)
         ENDIF

* TMAP_error was saved in FER_LAST_ERROR already. Otherwise save
* the string in the symbol

         IF (status_in .NE. ferr_TMAP_error) THEN
            ier = 0
            ist = 0
            CALL SETSYM ('FER_LAST_ERROR '//symbuf, 14+len_symbuf, 
     .                 ier, ist)

         ENDIF

         len_eftext = 0

* take alternate RETURN always
  500	RETURN 1

	END



c! If want tree of script calls, along with the "Running script" message
c!	   IF (ist .GT. 1) THEN
c!	      CALL TM_SPLIT_MESSAGE( err_lun, 'Tree of script calls: ')
c!
c!	      ndnt = '                '
c!	      ib = 1
c!	      len_text = 1
c!	      DO ics = 1, cs_lev
c!
c!                 IF (cs_cmnd_num(ics) .EQ. cmnd_go) THEN
c!                    indx = TM_LENSTR1(cs_text(ics))
c!                    risc_buff = ndnt(:ib)// cs_text(ics)(:indx)//'.jnl'
c!		      CALL TM_SPLIT_MESSAGE( err_lun,risc_buff(:indx+ib+4) )
c!                    ib = ib + 3
c!                 ENDIF
c!              ENDDO
c!
c!           ENDIF

	SUBROUTINE COPY_PTR_GRID_SUB (
     .		src, slox, shix, sloy, shiy, sloz, shiz, 
     .		     slot, shit, sloe, shie, slof, shif,
     .		dst, dlox, dhix, dloy, dhiy, dloz, dhiz, 
     .		     dlot, dhit, dloe, dhie, dlof, dhif )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* support routine for COPY_GRID with unsubscripted limits

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V533: 6/01 *sh*
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include 'ferret.parm'

* calling argument declarations:
	INTEGER slox, shix, sloy, shiy, sloz, shiz, 
     .		slot, shit, sloe, shie, slof, shif,
     .		dlox, dhix, dloy, dhiy, dloz, dhiz, 
     .		dlot, dhit, dloe, dhie, dlof, dhif
	REAL*8  src( slox:shix,sloy:shiy,sloz:shiz,slot:shit,sloe:shie,slof:shif ),
     .		dst( dlox:dhix,dloy:dhiy,dloz:dhiz,dlot:dhit,dloe:dhie,dlof:dhif )

* internal variable declarations:
	INTEGER	i, j, k, l, m, n

* --- end of introductory code ---

	DO 100 n = dlof, dhif
	DO 100 m = dloe, dhie
	DO 100 l = dlot, dhit
	DO 100 k = dloz, dhiz
	DO 100 j = dloy, dhiy
	DO 100 i = dlox, dhix

	   CALL COPY_C_STRING( src(i,j,k,l,m,n), dst(i,j,k,l,m,n))

 100	CONTINUE

	RETURN
	END 

*
* tax_jday.F
*
*
* This function returns day of current year specified by the first argument 
* (variable containing time values) from the second argument (variable from 
* which time encoding will be inferred).
*

*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE tax_jday_init(id)

      INCLUDE 'ferret_cmn/EF_Util.cmn'

      INTEGER id, arg


* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      CALL ef_set_desc(id,
     . 'Returns days of year of time axis coordinate values' )
   
      CALL ef_set_num_args(id, 2)
      CALL ef_set_axis_inheritance(id, IMPLIED_BY_ARGS, 
     .     IMPLIED_BY_ARGS, IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok(id, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'A')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 'time steps to convert')
      CALL ef_set_axis_influence(id, arg, YES, YES, YES, YES)

      arg = 2
      CALL ef_set_arg_name(id, arg, 'B')
      CALL ef_set_arg_unit(id, arg, ' ')

      CALL ef_set_arg_desc(id, arg, 'variable with reference time axis')
      CALL ef_set_axis_influence(id, arg, NO, NO, NO, NO)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
      END
*
* In this subroutine we compute the result
*
      SUBROUTINE tax_jday_compute(id, arg_1, arg_2, result) 

      INCLUDE 'ferret_cmn/EF_Util.cmn'
      INCLUDE 'ferret_cmn/EF_mem_subsc.cmn'

      INTEGER id

      REAL bad_flag(1:EF_MAX_ARGS), bad_flag_result
      REAL arg_1(mem1lox:mem1hix, mem1loy:mem1hiy, 
     .           mem1loz:mem1hiz, mem1lot:mem1hit)
      REAL arg_2(mem2lox:mem2hix, mem2loy:mem2hiy,
     .           mem2loz:mem2hiz, mem2lot:mem2hit)

      REAL result(memreslox:memreshix, memresloy:memreshiy,
     .            memresloz:memreshiz, memreslot:memreshit)

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable's axes. 

      INTEGER res_lo_ss(4), res_hi_ss(4), res_incr(4)
      INTEGER arg_lo_ss(4,1:EF_MAX_ARGS), arg_hi_ss(4,1:EF_MAX_ARGS),
     .     arg_incr(4,1:EF_MAX_ARGS)

* **********************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      CHARACTER*20 datebuf
      INTEGER iyear, imon, day_of_mon, day_of_year, prec, dlen
      CHARACTER*3 cmon
      CHARACTER*80 err_msg

      REAL*8 ddate

      INTEGER i,j,k,l,m 
      INTEGER i1, j1, k1, l1

*     'dd-MMM-yyyy' or 'yyyy-MM-dd' date format - this will fail if the latter
      prec = 3

      CALL ef_get_res_subscripts(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

      imon = 0
      i1 = arg_lo_ss(X_AXIS,ARG1)
      DO 400 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         j1 = arg_lo_ss(Y_AXIS,ARG1)
         DO 300 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)

           k1 = arg_lo_ss(Z_AXIS,ARG1)
           DO 200 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)

              l1 = arg_lo_ss(T_AXIS,ARG1)
              DO 100 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)

                ddate = arg_1(i1,j1,k1,l1)

*     Get the string-date for each time
                CALL ef_get_axis_dates(id,ARG2,ddate,1,prec,dlen,datebuf)
                READ (datebuf, 110, err=900) 
     .               day_of_mon, cmon, iyear
                CALL juldate(cmon, day_of_mon, iyear, day_of_year)
                result(i,j,k,l) = day_of_year 

                l1 = l1 + arg_incr(T_AXIS,ARG1)
 100          CONTINUE

               k1 = k1 + arg_incr(Z_AXIS,ARG1)
 200        CONTINUE

            j1 = j1 + arg_incr(Y_AXIS,ARG1)
 300     CONTINUE

         i1 = i1 + arg_incr(X_AXIS,ARG1)
 400  CONTINUE

 110  FORMAT (i2, 1x, a3, 1x, i4) 

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
* **********************************************************************

      RETURN 
  900 CONTINUE

      WRITE (err_msg,*) 
     .  'Error assigning dates/times to timestamp for tax_jday',  
     .  datebuf

      RETURN
      END
      
      SUBROUTINE juldate(cmon, day_of_mon, iyear, day_of_year)

*     Convert day of month to day of year

      INTEGER i, iyear
      CHARACTER*3 cmon
      CHARACTER*3 months(12)
      INTEGER day_of_mon, day_of_year, imon, ndaymo(12)

      DATA months/'JAN', 'FEB', 'MAR', 'APR', 'MAY', 'JUN', 'JUL',
     .            'AUG', 'SEP', 'OCT', 'NOV', 'DEC'/

      DATA ndaymo/31,28,31,30,31,30,31,31,30,31,30,31/

      imon = 0
      DO 100 i=1,12
          IF(cmon .EQ. months(i)) imon = i 
 100  CONTINUE

*     Check if it is a leap year
      IF ( ((mod(iyear,4) .EQ. 0) .AND. (mod(iyear,100) .NE. 0)) 
     .     .OR.
     .     (mod(iyear, 400) .EQ. 0)) THEN
          ndaymo(2) = 29
      END IF

      day_of_year = day_of_mon
      DO 200 i =1, imon -1
          day_of_year = day_of_year + ndaymo(i) 
 200  CONTINUE

      RETURN
      END
*                                                                      ^
*                                                                      |
*                                                                      |
* **********************************************************************

*
* date1900.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Steve Hankin
* Dac, 2000
*  5/2007 *acm* Fixing bug 1510. Return the result from date_decode as
*               an argument rather than a return from function; under
*               64-bit the return always yielded 0.
* V68  *acm* 1/12  ifdef double_p for double-precision ferret.
* V69+ *acm* 9/14 Make DATE1900 accept an array of date strings, 
*                 returning an array of coordinates
* V76  *acm* 5/20 Let it work on an array in any grid direction
*
* In this subroutine we provide information about
* the function.  The user configurable information 
* consists of the following:
*
* descr              Text description of the function
*
* num_args           Required number of arguments
*
* axis_inheritance   Type of axis for the result
*                       ( CUSTOM, IMPLIED_BY_ARGS, NORMAL, ABSTRACT )
*                       CUSTOM          - user defined axis
*                       IMPLIED_BY_ARGS - same axis as the incoming argument
*                       NORMAL          - the result is normal to this axis
*                       ABSTRACT        - an axis which only has index values
*
* piecemeal_ok       For memory optimization:
*                       axes where calculation may be performed piecemeal
*                       ( YES, NO )
* 
*
* For each argument we provide the following information:
*
* name               Text name for an argument
*
* unit               Text units for an argument
*
* desc               Text description of an argument
*
* axis_influence     Are this argument's axes the same as the result grid?
*                       ( YES, NO )
*
* axis_extend       How much does Ferret need to extend arg limits relative to result 
*


      SUBROUTINE date1900_init (id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V
      CHARACTER*120 fcn_desc

      WRITE (fcn_desc, 10)
   10 FORMAT ('Convert date strings into Julian days since 1-Jan-1900 ',
     .        '(integer days using Gregorian calendar)')
      CALL ef_set_desc(id, fcn_desc)  

      CALL ef_set_num_args(id, 1)

      CALL ef_set_axis_inheritance_6d(id,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
      CALL ef_set_piecemeal_ok_6d(id, YES, NO, NO, NO, NO, NO)

      CALL ef_set_num_work_arrays(id, 0)


      arg = 1
      CALL ef_set_arg_type(id, arg, STRING_ARG)
      CALL ef_set_arg_name (id, arg, 'formatted date')
      CALL ef_set_arg_desc(id, arg,
     .         'dd-MMM-yy or dd-MMM-yyyy  (e.g. "20-Dec-00")')
      CALL ef_set_axis_influence_6d(id, arg,
     .                               YES, YES, YES, YES, YES, YES)

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN 
      END

*
* In this subroutine we compute the result
*
      SUBROUTINE date1900_compute (id, arg_1, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER strdf
#ifdef double_p
      PARAMETER (strdf = 1)
#else
      PARAMETER (strdf = 2)
#endif

      INTEGER id

      REAL arg_1(strdf,
     .           mem1lox:mem1hix, mem1loy:mem1hiy, mem1loz:mem1hiz, 
     .           mem1lot:mem1hit, mem1loe:mem1hie, mem1lof:mem1hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)

     

* After initialization, the 'res_' arrays contain indexing information 
* for the result axes.  The 'arg_' arrays will contain the indexing 
* information for each variable''s axes. 

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

************************************************************************
*                                            USER CONFIGURABLE PORTION |
*                                                                      |
*                                                                      V

      INTEGER slen, i, j, k, l, m, n
      CHARACTER str_date*12
      REAL res
      INTEGER TM_LENSTR1

      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

C  result and arg_1 have same array dimension limits

      DO 100 n=res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
      DO 100 m=res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
      DO 100 l=res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
      DO 100 k=res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
      DO 100 j=res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
      DO 100 i=res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)

         CALL ef_get_string_arg_element_6d(id, ARG1, arg_1,
     .                       i, j, k, l, m, n, slen, str_date)

* make it a null-terminated string
         slen = MIN(TM_LENSTR1(str_date)+1,12)
         str_date(slen:slen) = CHAR(0)

         CALL DATE_DECODE(str_date, res)
         IF ( res .EQ. -1E34 ) THEN
            result(i, j, k, l, m, n) = bad_flag_result
         ELSE
            result(i, j, k, l, m, n) = res
         ENDIF

 100  CONTINUE

*                                                                      ^
*                                                                      |
*                                            USER CONFIGURABLE PORTION |
************************************************************************

      RETURN 
      END

	SUBROUTINE TM_DATE_REFORMAT( indate,  inform, cal_id, 
     .				     outdate, outform, do_err, status)
*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* This function will convert a date in format inform into a date in
* format outform

* *sh* 2/13/95
* *acm* needs cal_id to pass to tm_break_fmt_date
* V600 *acm* 2/06 - Fix for bug 1394, send do_err flag to tm_break_date
* v745 *acm* 12/18 Issue 1909, option to write dates in ISO8601 format
* v7441*acm* 12/18 Issue 1910: Allow dates in commands to be in ISO 8601 form, yyyy-mm-dd
* v744+*acm*  1/19 Handle date strings that are short, e.g. year only. (Comes up in tests
*                  only in DSG-data listings.)
*
* Arguments:
*	indate	 - input date string
*	inform	 - code for input format
*       cal_id id for calendar type of input date
*	outdate	 - output date string
*	outform	 - code for output format
*	status   - returning status
*
        LOGICAL         do_err
	CHARACTER*(*)	indate, outdate
	INTEGER		inform, outform, status, cal_id 
*
* Inclusions
*
	include 'tmap_errors.parm'
	include 'errmsg.parm'
#include "gt_lib.parm"


*
* Local definitions
*
	LOGICAL TM_DIGIT_TEST, no_hms, has_hms, has_hm, has_h
	INTEGER	TM_LENSTR1, year, month, day, hour, minute, dlen, idot, noyear
	REAL	second
	CHARACTER errdate*26, endtxt*10
	
* Remove text representing fractional seconds, and store that info
	dlen = TM_LENSTR1(indate)

* maybe the string is just a year, "2018". If so we're done.
	IF (dlen .LE. 4) THEN  
	   IF (TM_DIGIT_TEST(indate)) THEN
	      outdate = indate
	      GOTO 4000
	   ELSE
	      GOTO 5100
	   ENDIF
	ENDIF

	idot = INDEX(indate, '.')
	IF (idot .GT. 0) THEN
	   idot = INDEX(indate, '.')
	   endtxt = indate(idot:dlen)
	   dlen = idot - 1
	ENDIF

* Break up the input date string to its various components
	CALL TM_BREAK_FMT_DATE ( inform, indate(:dlen), cal_id, year, 
     .                        month, day, hour, minute, second, 
     .                        do_err, status )
	IF ( status .NE. merr_ok ) GOTO 5000

* Keep the same resolution, e.g. if they gave 00:00:00 keep that,
* but if the input string is HH:MM don't output HH:MM:00

* The lengths below need adjusting if the incoming date has no
* year, e.g. 16-JAN "12:00:00"

	noyear = 0
	IF (inform .EQ. pdate_vax .AND. indate(7:7) .EQ. " ") noyear = 4

	no_hms  = (dlen .LE. 11-noyear)
	has_hms = (dlen .GE. 19-noyear)
	has_hm  = (.NOT.has_hms .AND. dlen.GE.16-noyear)
	has_h   = (.NOT.has_hm  .AND. .NOT.has_hms .AND. dlen.GE.13-noyear)


* Do a few sanity checks. Return a message for an incorrectly written iso-8601 date

	IF (month.LT.0 .OR. month.GT.12)  GOTO 5100
	IF (day.LT.0 .OR. day.GT.31)  GOTO 5100

	CALL TM_MAKE_FMT_DATE ( outform, outdate, year, month, day,
     .				   hour, minute, second, dlen )

	dlen = TM_LENSTR1(outdate)
	IF (idot .GT. 0) THEN
	   outdate = outdate(:TM_LENSTR1(outdate))//endtxt(:TM_LENSTR1(endtxt))
	ELSE

* Trim extra :00 's 
	   IF (no_hms) outdate = outdate(:dlen-9)
	   IF (has_h)  outdate = outdate(:dlen-6)
	   IF (has_hm) outdate = outdate(:dlen-3)
	ENDIF

* Finished
 4000	status = merr_ok
	RETURN

* Errors
 5100	CONTINUE
        IF (do_err) 
     .       CALL ERRMSG( ferr_syntax, status, 
     .             indate(:dlen)//' invalid date or not valid in this calendar ', *5000)
	
 5000	RETURN

	END

	SUBROUTINE APPLY_DELTA_CONTEXT ( cx, reg_name, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* apply delta coordinate limits of the FORM DX
* to the indicated context

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:   5/2/90 - extracted from GET_DELTA_CONTEXT
* Unix/RISC port - 1/91 - cannot use "//" with char*(*)
*       *acm* 3/12 cleanup ifdefs and unnecessary include files
*       *acm* 3/12 Add E and F dimensions (use nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'errmsg.parm'	
	include 'ferret.parm'	
	include 'xcontext.cmn'
	include 'xdelta_context.cmn'
	include 'xtext_info.cmn'
	include 'xrisc.cmn'

* calling arguments:
	INTEGER		cx, status
	CHARACTER*(*)	reg_name

* internal variables:
	INTEGER		idim
	LOGICAL		INVALID_R8_TO_I4

* initialize fixed length string for RISC
        risc_buff = reg_name
        len_rbuff = MIN( size_rbuff, LEN(reg_name) )

	DO 100 idim = 1, nferdims

	   IF ( .NOT.dcx_given(idim) ) GOTO 100

* apply delta limits from common
	   IF ( dcx_by_ss(idim) .NEQV. cx_by_ss(idim,cx) ) THEN
	      IF ( cx_lo_ss(cx,idim).EQ.unspecified_int4
     .	     .AND. cx_lo_ww(idim,cx).EQ.unspecified_val8 ) THEN
	         GOTO 5500
	      ELSE
	         GOTO 5300
	      ENDIF
	   ENDIF
	   IF ( dcx_by_ss(idim) ) THEN
	      IF ( cx_lo_ss(cx,idim) .EQ. unspecified_int4 ) GOTO 5500
	      IF ( INVALID_R8_TO_I4( dcx_lo(idim) )
     .        .OR. INVALID_R8_TO_I4( dcx_hi(idim) )) GOTO 5400
	      cx_lo_ss(cx,idim) = cx_lo_ss(cx,idim) + NINT( dcx_lo(idim) )
	      cx_hi_ss(cx,idim) = cx_hi_ss(cx,idim) + NINT( dcx_hi(idim) )
	   ELSE
	      IF ( cx_lo_ww(idim,cx) .EQ. unspecified_val8 ) GOTO 5500
	      cx_lo_ww(idim,cx) = cx_lo_ww(idim,cx) + dcx_lo(idim)
	      cx_hi_ww(idim,cx) = cx_hi_ww(idim,cx) + dcx_hi(idim)
	   ENDIF

* flag that this axis was specified
	   cx_given(idim,cx) = .TRUE.

 100	CONTINUE

* success
	status = ferr_ok
	RETURN

* error exits
 5000	RETURN
 5300	CALL ERRMSG( ferr_relative_coord, status, 
     .		     'must be a subscript or a world position'//pCR//
     .		     'as in the original '//ww_dim_name(idim)//
     .		     ' axis of region '//risc_buff(:len_rbuff), *5000)
 5400	CALL ERRMSG( ferr_out_of_range, status,
     .		     'delta value is too large to be a subscript', *5000)
 5500	CALL ERRMSG( ferr_relative_coord, status,
     .		     ww_dim_name(idim)//' axis coordinate is unspecified'//
     .		     pCR//'on region '//risc_buff(:len_rbuff), *5000)

	END

	SUBROUTINE PLOT_DSG_DATA_SET_UP( nfeatures, nobs_total, status )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* modify the interpretation of the command data so it looks like
* a collection of 1D lines in the "feature-type" direction
* this will be accomplished by generating a list of contexts, each for a
* single line, each pointing to the same, shared memory-resident array
* Ideas similar to PLOT/ALONG and LIST command for DSG data.

* programmer - Ansley Manke
*
* V7.3+ *acm* 12/2017
* V7.6  *acm* 11/2019  Allow for the possibility of 0 obs in a feature.
*                      If this is the case, skip it.
* V760 *acm* 3/20 Set up for case when constraints result in no features

	include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'errmsg.parm'
	include 'slash.parm'
	include 'command.parm'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xprog_state.cmn'
	include 'xplot_setup.cmn'
	include 'xtm_grid.cmn_text'
	include 'xtext_info.cmn'
	include 'xdset_info.cmn_text'
	include 'xdyn_linemem.cmn_text'
	include 'xdsg_context.cmn'
	
* calling argument declarations:
	INTEGER	nfeatures, nobs_total, status

* internal variable declarations:
	LOGICAL process_feature(nfeatures), process_obs(nobs_total), 
     .		relevant_coord(4), has_keys, its_dsg, multi_var
	INTEGER	CGRID_SIZE, DSG_WHATS_IT, TM_DSG_DSET_FROM_GRID,
     .		iline, nlines, idim, the_dim, ndim, max_feature_lines, cx0, 
     .		the_cx, slen, tlen, cx, grid, feature_line, orientation, 
     .		obsdimlen, dset, gxlate, igrid, ifeature, coord_lm(4), 
     .		ivar, row_size_lm, nobs, irow_f, irow_l, iaxis, ic, 
     .		irow_start, irow_end, base, icxvar
	REAL	value, val_last, val_edge, vdel
	CHARACTER buff1, LEFINT*8, buff8*8,  buff*256

* initialize
	cx = is_cx(1)
	grid = cx_grid(cx)
	dset = TM_DSG_DSET_FROM_GRID( grid )

* get the plot orientation 4=timeseries,3=profile,1=trajectory
* for 1-D plots, plotting trajectory on an unraveled axis 
* (possibly point, which is feature type 0, would be treated as a 1 here? Collection of points)
* Trajectories as plot/vs/ribbon plots are set up elsewhere.

	its_dsg = .TRUE.
	CALL TM_DSG_FACTS( grid,
     .			   orientation, obsdimlen, feature_line, its_dsg )
	IF (.NOT. its_dsg) GOTO 5500
	gxlate = dsg_xlate_grid(dset)
	row_size_lm = dsg_loaded_lm(dsg_row_size_var(dset))

* ... unrecognized orientation	         
	IF (orientation .EQ. 0) GOTO 5200  ! ??

* If its an instance var, this can be plotted as an ordinary line plot in E.

	IF (DSG_WHATS_IT(grid) .EQ. pdsg_instance .OR.  CGRID_SIZE(cx) .EQ. 1) THEN
	   grid_is_dsg = .FALSE.
	   GOTO 5000
	ENDIF

* which dimensions are relevant in the grid will label the plot
* with ranges of orthogional directions
	DO idim = 1, 4
	   iline = grid_line(idim, gxlate)
	   relevant_coord(idim) =  (iline .NE. mnormal)
	   IF (relevant_coord(idim)) THEN
	      ivar = dsg_coord_var(idim,dset)
	      coord_lm(idim) = dsg_loaded_lm(ivar)  ! line memory table indices
	   ENDIF
	ENDDO

* create a mask showing which features to plot
	CALL MAKE_DSG_FEATURE_MASK(dset, cx, process_feature, nfeatures)

* how many individual lines have been requested?

	nlines = 0
	
	DO ifeature = 1, nfeatures 

* ... have the user's constraints removed this feature?
	   IF (.NOT.process_feature(ifeature)) CYCLE
	   nobs = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
	   IF (nobs .GT. 0) nlines = nlines+1

	ENDDO

* Multi-feature DSG data can only plot one variable

	multi_var = .FALSE.
	IF (num_uvars_in_cmnd .GT.1) THEN 
	   IF (nlines .GT. 1) GOTO 5100
	   multi_var = .TRUE.
	ENDIF


* ... If the mask or constraints results in no data selected, load nominal 
*     data so a blank plot can be drawn.

	IF (nlines .EQ. 0) THEN
	
           nobs = 2
           nlines = 1
           iline = 1
           the_cx = is_cx(1)

           is_mr(iline) = is_mr(1)  ! a single mr shared by all

* Define a new set of coordinates, the lo and hi in the current context

           igrid = unspecified_int4
           CALL TM_ALLO_TMP_GRID (igrid, status)
           IF (status .NE. ferr_ok) GOTO 5000

           CALL TM_COPY_GRID_W_LINE_USE (grid, igrid)
           CALL TM_DEALLO_DYN_LINE( grid_line(orientation, grid) )

           CALL TM_ALLO_TMP_LINE(iaxis, status)
           CALL GET_LINE_DYNMEM (nobs, iaxis, status)
	   IF (status .NE. ferr_ok) GOTO 5000
	   
           grid_line(orientation, igrid) = iaxis
           cx_grid(the_cx) = igrid
           CALL TM_USE_LINE(iaxis)

* Inherit axis properties
           CALL TM_COPY_LINE (grid_line(orientation,grid), iaxis)
           line_regular(iaxis) = .FALSE.

* rename the axis. 
           CALL TM_NEW_LINE_NAME ( line_name(iaxis), buff )
           line_name(iaxis) = buff

           irow_start = 1
           irow_end   = 2

           ic = irow_start
           CALL PUT_LINE_COORD(linemem(iaxis)%ptr, ic, cxdsg_constrain_lo(orientation))

           ic = irow_end
           CALL PUT_LINE_COORD(linemem(iaxis)%ptr, ic, cxdsg_constrain_hi(orientation))

           cx_feature(the_cx) = 1

           DO idim = 1, t_dim
              cx_lo_ss(the_cx,idim) = unspecified_int4
              cx_hi_ss(the_cx,idim) = unspecified_int4
           ENDDO

* ... set up the feature-axis positions 
           cx_by_ss(orientation, the_cx) = .TRUE.
           cx_lo_ss(the_cx,orientation) = irow_start
           cx_hi_ss(the_cx,orientation) = irow_end

           cxdsg_empty_set = .TRUE.
           cxdsg_orient = dsg_orientation(dset)  ! for making label
	   
	ENDIF  ! nlines .EQ. 0

        IF (cxdsg_empty_set) GOTO 333

* have plot keys been requested?
	has_keys = qual_given(slash_plot_nokey) .EQ. 0
     .       .AND. qual_given(slash_plot_title) .EQ. 0

* how many individual lines are allowed
* (max_key_entries smaller than max_line_on_plot)
	max_feature_lines = max_noframe_context - is_cx(1) + 1
	IF (max_feature_lines .GT. max_line_on_plot) max_feature_lines =
     .						   max_line_on_plot

c A message is written in PLOT_SET_UP
	IF (has_keys .AND. nlines.GT.max_key_entries) has_keys = .FALSE.
	
	IF (nlines .GT. max_feature_lines) THEN
	   buff8 = LEFINT( nlines,  slen  )
	   CALL WARN('Too many Feature lines. Request would plot '
     .			// buff8(:slen) )
	   buff8 = LEFINT( max_feature_lines,  slen  )
	   CALL WARN('Plotting first '// buff8(:slen) )
	ENDIF

* populate the contexts

	CALL TRANSFER_CONTEXT( is_cx(1), cx_buff )

	cx0 = is_cx(1) - 1
        iline = 0
	irow_f = 1
	irow_l = 0

	DO ifeature = 1, nfeatures 
	   nobs = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length
	   IF (nobs .EQ. 0)  GOTO 222
	   irow_l = irow_f + nobs - 1
	   IF (.NOT.process_feature(ifeature)) GOTO 222
	   iline = iline + 1

* ... get observation-level mask for this feature

           base = irow_f - 1
	   CALL MAKE_DSG_OBS_MASK(dset, cx, ifeature, base,
     .				  process_obs(irow_f), nobs)

	   is_mr(iline) = is_mr(1)  ! a single mr shared by all

	   the_cx = cx0 + iline
	   is_cx(iline) = the_cx
	   CALL TRANSFER_CONTEXT( cx_buff, the_cx )

* Define a new set of coordinates, as if an axis of the original total length,
* but the coordinates at indices irow_f through irow_l will contain the coordinates 
* from the feature that we want. Define a grid to contain this axis.

	   igrid = unspecified_int4
	   CALL TM_ALLO_TMP_GRID (igrid, status)
	   IF (status .NE. ferr_ok) GOTO 5000

	   CALL TM_COPY_GRID_W_LINE_USE (grid, igrid)
	   CALL TM_DEALLO_DYN_LINE( grid_line(orientation, grid) )

	   CALL TM_ALLO_TMP_LINE(iaxis, status)
	   CALL GET_LINE_DYNMEM (nobs_total, iaxis, status)
	   IF (status .NE. ferr_ok) GOTO 5000
	   
	   grid_line(orientation, igrid) = iaxis
	   cx_grid(the_cx) = igrid
	   CALL TM_USE_LINE(iaxis)

* Inherit axis properties
	   CALL TM_COPY_LINE (grid_line(orientation,grid), iaxis)
	   line_regular(iaxis) = .FALSE.

* rename the axis. (Is this necessary? Nice for debugging anyway)
	   CALL TM_NEW_LINE_NAME ( line_name(iaxis), buff )
	   line_name(iaxis) = buff

* Find first and last valid points for this feature applying the user's context 
* This just masks the range of the independent variable. Still need to apply the 
* process_obs mask to the independent variable when plotting.

	   irow_start = 0
	   irow_end = 0

	   DO ic = irow_f, irow_l
	      IF (.NOT.process_obs(ic) .AND. irow_start.EQ. 0) THEN
	         CYCLE
	      ELSE 
	         irow_start = ic
		 EXIT ! from loop
              ENDIF
	   ENDDO

	   DO ic = irow_l, irow_f, -1
	      IF (.NOT.process_obs(ic) .AND. irow_end.EQ. 0) THEN
	         CYCLE
	      ELSE 
	         irow_end = ic
		 EXIT ! from loop
              ENDIF
	   ENDDO

	   IF (irow_start.EQ.0 .OR. irow_end.EQ.0) CYCLE  ! shouldnt happen.

* Put the coordinates from this feature-line into the locations
* on the orientation-axis corresponding to our index range.

	   DO ic = irow_start, irow_end
	      value = dsg_linemem(coord_lm(orientation))%ptr(ic)
	      CALL PUT_LINE_COORD(linemem(iaxis)%ptr, ic, value)
	      IF (ic .GT. irow_start) THEN
	         vdel = (value-val_last)/2.
		 val_edge = value - vdel
		 CALL PUT_LINE_COORD(lineedg(iaxis)%ptr, ic, val_edge)
	      ENDIF
	      val_last = value
	   ENDDO
	   IF (ic .GT. irow_start+1) THEN 
	      val_edge = value + vdel
	      CALL PUT_LINE_COORD(lineedg(iaxis)%ptr, ic, val_edge)
	   ENDIF

*** To be able to recover the feature number, so keys can be labeled?

	   cx_feature(the_cx) = ifeature
	   
* ... set up the feature-axis positions 
	   cx_by_ss(orientation, the_cx) = .TRUE.
	   cx_lo_ss(the_cx,orientation) = irow_start
	   cx_hi_ss(the_cx,orientation) = irow_end

* ... prepare for the next feature

 222	   irow_f = irow_l + 1

	ENDDO


  333	CONTINUE

* make the rest of Ferret believe that all these lines were asked for
	IF (.NOT. multi_var) THEN
	   num_uvars_in_cmnd = nlines
	ELSE

* multi-variable, 1-feature plot, all the contexts are the same as the first
* but keep cx_variable, so that the labels will be correct

	   DO ivar = 2, num_uvars_in_cmnd
	      icxvar = cx_variable(is_cx(ivar))
	      CALL TRANSFER_CONTEXT( is_cx(1), is_cx(ivar) )
	      cx_variable(is_cx(ivar)) = icxvar  
	   ENDDO
	ENDIF

* successful completion
	RETURN

* error exit2
 5000	RETURN
 5100	CALL ERRMSG(ferr_invalid_command, status,
     .           "For multi-variable PLOT of discrete DSG data, select just one feature", *5000)
 5200   CALL ERRMSG(ferr_invalid_command, status,
     .          "PLOT discrete data, unrecognized Feature type direction", *5000)
 5300	CALL ERRMSG(ferr_invalid_command, status,
     .		"Plot discrete DSG data: variable is not a list of observations", *5000)
 5400	CALL ERRMSG(ferr_invalid_command, status,
     .		"Plot discrete DSG data: too many lines", *5000)
 5500	CALL ERRMSG( ferr_grid_definition, status,
     .		'Data grid is not a DSG grid ',
     .		*5000 )

	END

	SUBROUTINE KEY_LOC( overlay, xpos, ypos, xsize, ysize,
     .			    lab_ht, style, justify, string )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* find a location, size and style in which to put the next key

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V200:	  1/2/90
* v552 *acm* 3/03 multi-line strings in key labels.
* V68  *acm* 1/12  changes for double-precision ferret, single-precision pplus.
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V76  *acm* 11/19 Issue 1960: Place keys for overlay lines in multiple columns 
*                  below plot before resorting to putting them inside the plot box.

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'plot_setup.parm'
	include	'xplot_setup.cmn'
	include 'axis_inc.decl'		! axis lengths
	include 'AXIS.INC'		! axis lengths
        include 'parampl5_dat.decl'
        include 'PARAMPL5.DAT'
        include 'labels_inc.decl'
        include 'LABELS.INC'            ! multi-line string

* calling argument declarations
	LOGICAL overlay
	INTEGER	style, justify
	REAL	xpos, ypos, xsize, ysize, lab_ht
        CHARACTER*(*) string

* internal variable declarations
	INTEGER	colmn, numlines
	REAL dylen

	dylen = ylen

* See if the label has more than one line

        CALL tm_break_lines (string, lnbeg, lnend, numlines)

	IF ( overlay ) THEN

* is there room for this overlay label at the lower left ?
* test the location of the last line of this key label
* Add more labels to column before going to next column. (This is
* inconsistent with legend on a plot with multiple vars on the command
* line, but more consistent with previous PLOT/OVER behavior.)

	   key_ncolmn = 3
	   IF (novkeys_on .EQ. 0) THEN
	      key_xspace = (xlen+ xwhitelo + xwhitehi)/ FLOAT(key_ncolmn)
	      novkeys_icol = 0
	      colmn = 0
	      ypos = ovkey_yorigin + ovkey_yspace
	      ovkey_ypos_nxt = ypos
	   ELSE
	      ypos= ovkey_ypos_nxt
	   ENDIF

	   ysize = ovkey_yspace

	   xpos = ovkey_xorigin + colmn*key_xspace
	   ypos = ypos - ovkey_yspace

	   IF (ABS(ypos - ovkey_yspace* FLOAT(numlines-1)) .GT. yorg) THEN
	      IF (colmn .EQ. 0) novkeys_ll = novkeys_on ! number of lines in one columnn
	      colmn = colmn + 1
	      ypos = ovkey_yorigin 
	      ypos = ypos - ovkey_yspace  ! move down, make room for axis label
	      xpos = ovkey_xorigin + colmn*key_xspace
	      IF (colmn .GE. key_ncolmn) THEN
	         ovkey_ll_full = .TRUE.
	         novkeys_on = novkeys_ll
	         ovkey_ypos_nxt = 0
	      ENDIF
	   ENDIF
	   IF (ABS(ovkey_ypos_nxt).LT.yorg .AND. .NOT.ovkey_ll_full) 
     .            ovkey_ypos_nxt = ypos - ovkey_yspace* FLOAT(numlines-1)

	   IF ( ovkey_ll_full ) THEN
* ... no - try to put the label within the plot rectangle at the left
	      xsize  = ovkey_xspace * 0.8
	      xpos   = 0.1
	      lab_ht = ovkey_labht  * 0.8
	      ysize = ovkey_yspace  * 0.8	      
	      ypos = 0.1 +
     .            (numlines-1+novkeys_on-novkeys_ll)*ovkey_yspace*0.8
	      ovkey_ypos_nxt = ypos
	      IF (ABS(ypos+lab_ht) .GT. dylen ) xpos = -999.	! off screen
	   ELSE
* ... yes - it will fit in first key_ncolmn columns.
	      xsize  = ovkey_xspace
	      lab_ht = ovkey_labht
	   ENDIF
	   novkeys_on = novkeys_on + numlines

	ELSE
* locate a regular (non-overlay) key below the axis
	   xsize = key_xsize
	   ysize = key_ysize
	   lab_ht = key_labht
	   colmn = MOD( nkeys_on,key_ncolmn )	! from 0 to n-1
	   xpos = key_xorigin + colmn*key_xspace
	   ypos = key_yorigin - INT(nkeys_on/key_ncolmn)*key_yspace
	   nkeys_on = nkeys_on + numlines
	ENDIF

* style and justify aren't really used in FERRET version 2.00
	style   = ppl_sidebyside
	justify = ppl_left_just	

	RETURN
	END

	CHARACTER*(*) FUNCTION GNAME_FROM_NUMBER( dset, grid, len )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* given a grid number return the name of the first file variable in this dset
* that is defined on this grid.  If the variable is from a different
* data set than the one passed in the call qualify the variable name with
* [D=name]
* If no variables are defined on this grid then return the name of the grid
* itself.

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 8/1/88
*Linux Port 1/97 *kob* - Added a preprocessor include for tmap_dset.parm
*			  because it needed a preprocessor.
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

        IMPLICIT NONE
	include 'tmap_dims.parm'
#	include "tmap_dset.parm"
	include 'xdset_info.cmn_text'
	external xdset_info_data
	include	'xtm_grid.cmn_text'
	external xgt_grid_data
	include	'ferret.parm'
	include	'errmsg.parm'

* calling argument declarations:
	INTEGER		dset, grid, len

* local variable declarations:
	LOGICAL	in_set
	INTEGER	TM_LENSTR1, var, dset2, slen

* search for a file variable on both the right grid and data set
	DO 100 var = 1, maxvars
	   IF ( ds_var_setnum (var) .EQ. set_not_open ) GOTO 100

	   IF ( ds_grid_number(var) .EQ. grid
     .	  .AND. ds_var_setnum (var) .EQ. dset ) GOTO 400

 100	CONTINUE

* no luck - search for a file variable on the right grid in another data set
	DO 200 var = 1, maxvars
	   IF ( ds_var_setnum (var) .EQ. set_not_open ) GOTO 200

	   IF ( ds_grid_number(var) .EQ. grid ) GOTO 300

 200	CONTINUE

		         
* no luck again - no file variables are defined on this grid - return grid name
	GNAME_FROM_NUMBER = grid_name( grid )
	GOTO 500

* right grid but another data set
 300	dset2 = ds_var_setnum(var)
        CALL string_array_get_strlen1(ds_var_code_head, var, slen)
	GNAME_FROM_NUMBER = 
     .           ds_var_code(var)(:slen)//
     .		'[D='//ds_name(dset2)(:TM_LENSTR1(ds_name(dset2)))//']'
	GOTO 500

* right grid and variable
 400	GNAME_FROM_NUMBER = ds_var_code(var)

* measure the string	   
 500	len = TM_LENSTR1( GNAME_FROM_NUMBER )
	RETURN
	END

	SUBROUTINE TM_CLEANUP_NUM_STRING (string, slen)

* Remove fractional zeros and trailing decimal point from non-exponentials
* Returns string and its new length.


* Ansley Manke
* NOAA/PMEL, Seattle, WA - Science Data Integration Gropu
*
* 6/24/2019

	INTEGER slen
	CHARACTER*(*) string

	INTEGER nright, idx

        IF ( (INDEX(string, '.') .GT. 0) .AND.
     .       (INDEX(string, 'E') .EQ. 0) ) THEN
           nright = slen
           DO idx = nright,1,-1
              IF (string(idx:idx) .EQ. '0') THEN
                 string(idx:idx) = ' '
                 slen = slen - 1
              ELSE
                 EXIT
              ENDIF
           ENDDO
           IF (string(slen:slen) .EQ. '.') THEN
              string(slen:slen) = ' '
              slen = slen - 1
           ENDIF
        ENDIF

	RETURN
	END

	SUBROUTINE EQUAL_VAL( string, val, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* from a string of the form "name=value", return the value
* if the string is simply "name" then return unspecified value

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 4/14/88
* revision 0.1 -  9/8/88 - explicit check for digit so words beginning with T
*			   aren't treated as .TRUE. by VAX Fortran 
* V420: 10/95 - need to buffer "READ(*)" for AIX bort
*       *acm* 3/12 cleanup ifdefs and unnecessary include files

        IMPLICIT NONE
* calling argument declarations
	INTEGER		status
	REAL		val
	CHARACTER*(*)	string

* internal variable declarations
	LOGICAL		TM_DIGIT
	INTEGER 	equal_pos, slen
#ifdef AIX_XLF
	CHARACTER	buff*64
#endif

	include 'ferret.parm'
	include 'errmsg.parm'

* initialize
	slen	  = LEN( string )
	equal_pos = INDEX( string, '=' )

	IF ( equal_pos .EQ. 0 ) THEN
	   val = unspecified_val4		! "name", alone

	ELSEIF ( equal_pos .EQ. slen ) THEN	
	   GOTO 5000				! "name ="

	ELSEIF ( string(equal_pos+1:) .EQ. ' ' ) THEN
	   GOTO 5000				! "name =    "

	ELSEIF ( .NOT.TM_DIGIT(string(equal_pos+1:)) ) THEN
	   GOTO 5000				! "name = text"

	ELSE
#ifdef AIX_XLF
	   buff = string(equal_pos+1:)
	   READ ( buff, *, ERR=5000 ) val
#else
	   READ ( string(equal_pos+1:), *, ERR=5000 ) val
#endif
	ENDIF

* success
	status = ferr_ok
 1000	RETURN

* syntax error
 5000	CALL ERRMSG( ferr_syntax, status, string, *1000 )
	END

	SUBROUTINE WRITE_MULTI( lun, string )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* write multiple lines of the form line//CR//line... to unit lun

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V200: 11/27/89
* 	 2/20/90 - corrected string length bug for more-than 2 lines
* V300: adapted for output to GUI displa
* V314: 8/22/94 *kob* IBM port - need to use risc buff for char. concat 
* V320: 2/28/95 - SPLIT_GUI_MESSAGE --> TM_SPLIT_MESSAGE
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)

        IMPLICIT NONE
	include 'tmap_dims.parm'
	include 'ferret.parm'
#ifdef NO_PASSED_CONCAT
	include 'xrisc.cmn'
#endif

* calling argument declarations:
	INTEGER		lun
	CHARACTER*(*)	string

* internal variable declarations:
	LOGICAL 	multiline
	INTEGER		TM_LENSTR1, cr_pos, c1, clast

* initialize
	c1 = 1
	
* multiple lines ?
 100	cr_pos = INDEX( string(c1:), pCR )
	multiline = cr_pos .NE. 0

* get last character of line
	IF ( multiline ) THEN
	   clast = c1 + cr_pos - 2
	ELSE
	   clast = (c1-1) + TM_LENSTR1( string(c1:) )		! mod 2/90
	ENDIF

* write one line
#ifdef NO_PASSED_CONCAT
	risc_buff = string(c1:clast)
	CALL TM_SPLIT_MESSAGE(lun, '          '//risc_buff)
#else
	CALL TM_SPLIT_MESSAGE(lun, '          '//string(c1:clast))
#endif

* more ?
	IF ( multiline ) THEN
	   c1 = clast + 2
	   GOTO 100
	ENDIF

* no. done
	RETURN
	END

*
* dsg_fmask.F
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Ansley Manke
* Aug 2018
*
* This function defines a mask on the long, observations axis for variables
* in a Discrete Sampling Geometries ragged-array dataset.  The mask is based
* on a selection of some values of a feature-length variable.


      SUBROUTINE dsg_fmask_str_init(id)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'

      INTEGER id, arg

      CALL ef_set_desc(id, 
     . 'Returns a mask of length nobs based on values '//
     . 'in feature variable of ragged array dataset')

      CALL ef_set_num_args(id, 4)
      CALL ef_set_has_vari_args(id, NO)
      CALL ef_set_axis_inheritance_6d(id, 
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS,
     .                                IMPLIED_BY_ARGS, IMPLIED_BY_ARGS)
c     .                                IMPLIED_BY_ARGS, NORMAL,
c     .                                NORMAL,          NORMAL,
c     .                                NORMAL,          NORMAL)

      CALL ef_set_piecemeal_ok_6d(id, NO, NO, NO, NO, NO, NO)

      arg = 1
      CALL ef_set_arg_name(id, arg, 'obsvar')
      CALL ef_set_arg_desc(id, arg, 'A variable on the long, observation axis (1-D)')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              YES, YES, YES, YES, YES, YES)
c     .                              YES, NO, NO, NO, NO, NO)


      arg = 2
      CALL ef_set_arg_name(id, arg, 'rowsize')
      CALL ef_set_arg_desc(id, arg, 'The Rowsize variable, length of each feature')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

      arg = 3
      CALL ef_set_arg_name(id, arg, 'Fvar')
      CALL ef_set_arg_type (id, arg, STRING_ARG)

      CALL ef_set_arg_desc(id, arg, 
     . 'A string variable of length feature-number, from which the mask id computed')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)
     

      arg = 4
      CALL ef_set_arg_name(id, arg, 'subset')
      CALL ef_set_arg_type (id, arg, STRING_ARG)

      CALL ef_set_arg_desc(id, arg, 
     . 'Set of strings: mask is 1 where Fvar matches these, else missing.'//
     . 'Mask is true for reatures matching these')
      CALL ef_set_axis_influence_6d(id, arg,
     .                              NO, NO, NO, NO, NO, NO)

*                                                                     ^
*                                                                     |
*                                           USER CONFIGURABLE PORTION |
***********************************************************************

      RETURN 
      END

* * *

      SUBROUTINE dsg_fmask_str_compute(id, var, rowsize, fvar, subset, result)

      IMPLICIT NONE
      INCLUDE 'EF_Util.cmn'
      INCLUDE 'EF_mem_subsc.cmn'

      INTEGER id

      REAL var(*)
      REAL rowsize(mem2lox:mem2hix, mem2loy:mem2hiy, mem2loz:mem2hiz, 
     .           mem2lot:mem2hit, mem2loe:mem2hie, mem2lof:mem2hif)
      REAL fvar(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)
      REAL subset(mem3lox:mem3hix, mem3loy:mem3hiy, mem3loz:mem3hiz, 
     .           mem3lot:mem3hit, mem3loe:mem3hie, mem3lof:mem3hif)

      REAL result(memreslox:memreshix, memresloy:memreshiy, 
     .            memresloz:memreshiz, memreslot:memreshit,
     .            memresloe:memreshie, memreslof:memreshif)
	
*

      INTEGER res_lo_ss(6),
     .        res_hi_ss(6),
     .        res_incr (6)
      INTEGER arg_lo_ss(6,EF_MAX_ARGS),
     .        arg_hi_ss(6,EF_MAX_ARGS),
     .        arg_incr (6,EF_MAX_ARGS)

      REAL bad_flag(EF_MAX_ARGS), bad_flag_result

      LOGICAL ismatch
      INTEGER nobs, sum, nf, nr, ilo, ihi, slen
      INTEGER i,  j,  k,  l,  m,  n
      INTEGER i1, j1, k1, l1, m1, n1
      INTEGER i2, j2, k2, l2, m2, n2
      INTEGER i3, j3, k3, l3, m3, n3
      INTEGER i4, j4, k4, l4, m4, n4
      CHARACTER*48 fstring, test


      CALL ef_get_res_subscripts_6d(id, res_lo_ss, res_hi_ss, res_incr)
      CALL ef_get_arg_subscripts_6d(id, arg_lo_ss, arg_hi_ss, arg_incr)
      CALL ef_get_bad_flags(id, bad_flag, bad_flag_result)

* Check arguments: For valid DSG files this will have already
* been checked but the function could be called for other data.
* nobs = sum of rowsize. 
* rowsize and fvar must be the same length 
  
      nobs = 0
      DO i =  X_AXIS, F_AXIS
         nobs = MAX(nobs, arg_hi_ss(i,ARG1)-arg_lo_ss(i,ARG1)+1)
      ENDDO

      sum = 0
      nr = 0

      DO 100 i2 = arg_lo_ss(X_AXIS,ARG2), arg_hi_ss(X_AXIS,ARG2)
      DO 100 j2 = arg_lo_ss(Y_AXIS,ARG2), arg_hi_ss(Y_AXIS,ARG2)
      DO 100 k2 = arg_lo_ss(Z_AXIS,ARG2), arg_hi_ss(Z_AXIS,ARG2)
      DO 100 l2 = arg_lo_ss(T_AXIS,ARG2), arg_hi_ss(T_AXIS,ARG2)
      DO 100 m2 = arg_lo_ss(E_AXIS,ARG2), arg_hi_ss(E_AXIS,ARG2)
      DO 100 n2 = arg_lo_ss(F_AXIS,ARG2), arg_hi_ss(F_AXIS,ARG2)
	 IF ( rowsize(i2,j2,k2,l2,m2,n2) .NE. bad_flag(ARG2)) THEN
	    sum = sum + rowsize(i2,j2,k2,l2,m2,n2)
	    nr = nr + 1
	 ELSE
	    GOTO 9100
	 ENDIF
  100 CONTINUE
      IF (sum .NE. nobs) GOTO 9200

      nf = 0
      DO 200 i3 = arg_lo_ss(X_AXIS,ARG3), arg_hi_ss(X_AXIS,ARG3)
      DO 200 j3 = arg_lo_ss(Y_AXIS,ARG3), arg_hi_ss(Y_AXIS,ARG3)
      DO 200 k3 = arg_lo_ss(Z_AXIS,ARG3), arg_hi_ss(Z_AXIS,ARG3)
      DO 200 l3 = arg_lo_ss(T_AXIS,ARG3), arg_hi_ss(T_AXIS,ARG3)
      DO 200 m3 = arg_lo_ss(E_AXIS,ARG3), arg_hi_ss(E_AXIS,ARG3)
      DO 200 n3 = arg_lo_ss(F_AXIS,ARG3), arg_hi_ss(F_AXIS,ARG3)
         nf = nf + 1
  200 CONTINUE
      IF (nf .NE. nr) GOTO 9300


* Initialize the result
      DO 300 n = res_lo_ss(F_AXIS), res_hi_ss(F_AXIS)
      DO 300 m = res_lo_ss(E_AXIS), res_hi_ss(E_AXIS)
      DO 300 l = res_lo_ss(T_AXIS), res_hi_ss(T_AXIS)
      DO 300 k = res_lo_ss(Z_AXIS), res_hi_ss(Z_AXIS)
      DO 300 j = res_lo_ss(Y_AXIS), res_hi_ss(Y_AXIS)
      DO 300 i = res_lo_ss(X_AXIS), res_hi_ss(X_AXIS)
         result(i,j,k,l,m,n) = bad_flag_result
  300 CONTINUE
      
* Compute the mask: 1 for all values in features that match the test

      DO 500 i4 = arg_lo_ss(X_AXIS,ARG4), arg_hi_ss(X_AXIS,ARG4)
      DO 500 j4 = arg_lo_ss(Y_AXIS,ARG4), arg_hi_ss(Y_AXIS,ARG4)
      DO 500 k4 = arg_lo_ss(Z_AXIS,ARG4), arg_hi_ss(Z_AXIS,ARG4)
      DO 500 l4 = arg_lo_ss(T_AXIS,ARG4), arg_hi_ss(T_AXIS,ARG4)
      DO 500 m4 = arg_lo_ss(E_AXIS,ARG4), arg_hi_ss(E_AXIS,ARG4)
      DO 500 n4 = arg_lo_ss(F_AXIS,ARG4), arg_hi_ss(F_AXIS,ARG4)
         
	 CALL EF_GET_STRING_ARG_ELEMENT_6D (id, ARG4, subset,
     .                    i4, j4, k4, l4, m4, n4, slen, test)

	 nr = 0
         DO 400 i3 = arg_lo_ss(X_AXIS,ARG3), arg_hi_ss(X_AXIS,ARG3)
         DO 400 j3 = arg_lo_ss(Y_AXIS,ARG3), arg_hi_ss(Y_AXIS,ARG3)
         DO 400 k3 = arg_lo_ss(Z_AXIS,ARG3), arg_hi_ss(Z_AXIS,ARG3)
         DO 400 l3 = arg_lo_ss(T_AXIS,ARG3), arg_hi_ss(T_AXIS,ARG3)
         DO 400 m3 = arg_lo_ss(E_AXIS,ARG3), arg_hi_ss(E_AXIS,ARG3)
         DO 400 n3 = arg_lo_ss(F_AXIS,ARG3), arg_hi_ss(F_AXIS,ARG3)
             nr = nr + 1
             CALL EF_GET_STRING_ARG_ELEMENT_6D(id, ARG3, fvar,
     .                    i3, j3, k3, l3, m3, n3, slen, fstring)
             IF (test .EQ. fstring) THEN
	        CALL DSG_ROW_LIMITS_SUB (rowsize, nr, ilo, ihi)
		CALL PUT_ROW_MASK_SUB (result, ilo, ihi)
		GOTO 444
             ENDIF
  400    CONTINUE

  444	 CONTINUE
  500 CONTINUE

      RETURN

 9100 CALL EF_BAIL_OUT (id, 'The Rowsize variable may not contain missing data')
 9200 CALL EF_BAIL_OUT (id, 'The sum of Rowsize must equal the length of argument 1')
 9300 CALL EF_BAIL_OUT (id, 'The length of the Rowsize and Fvar must be equal')

      END

      SUBROUTINE DSG_ROW_LIMITS_SUB (rowsize, nr, ilo, ihi)

* Return the low and high index limits for row nr of rowsize 

      REAL    rowsize(*)
      INTEGER nr, ilo, ihi

      INTEGER i

      IF (nr .EQ. 1) THEN
         ilo = 1
	 ihi = rowsize(1)
      ELSE

         ilo = 1
         DO i = 2, nr
            ilo = ilo + rowsize(i-1) 
	 ENDDO
	 ihi = ilo + rowsize(nr)
      ENDIF

      RETURN
      END

      SUBROUTINE PUT_ROW_MASK_SUB (result, ilo, ihi)

* Put 1 into the result for the index limits, avoids all the
* 6-D looping.

      REAL result(*)
      INTEGER ilo, ihi

      INTEGER i
      DO i = ilo, ihi
         result(i) = 1.
      ENDDO

      RETURN
      END

	SUBROUTINE MASK_DSG_OBSVAR (nfeatures, process_feature, 
     .        process_obs, rowsize, dset, cx, source_data, put_data, 
     .        nmasked)
     
* 
*  This software was developed by the Science Data Integration Group (SDIG) 
*  of the National Oceanographic and AtmosphericAdministration's (NOAA) 
*  Pacific Marine Environmental Lab(PMEL) as part of Ferret/PyFerret
*  5/1/2019
*
* Apply observation-level masking for data representing one or more 
* features of a Discrete Sampling Geometries dataset.


* V75+ 6/19 *acm*  Return the total number obs after masking

	LOGICAL process_feature(*), process_obs(*)
	INTEGER nfeatures, dset, cx, nmasked 
	REAL	rowsize(*), source_data(*), put_data(*)

	INTEGER base, fobs, ifeature, nobsf, iobs

	nmasked = 0
	base = 0     ! obs index at end of preceding feature
	fobs = 0     
	DO ifeature = 1, nfeatures
	   nobsf = rowsize(ifeature)  ! feature length
	   IF (process_feature(ifeature)) THEN

* ... apply observation-level mask for this feature
	      CALL MAKE_DSG_OBS_MASK(dset, cx, ifeature, base, process_obs, nobsf)
	      DO iobs = 1, nobsf
		 fobs = fobs+1
	         IF (process_obs(iobs)) THEN
		    nmasked = nmasked+1
		    put_data(nmasked) = source_data(fobs)		    
	         ENDIF
	      ENDDO   
	   ELSE
	      fobs = fobs + nobsf
	   ENDIF
	   
	   base = base + nobsf
	ENDDO

	RETURN
	END
	

	SUBROUTINE DSG_ID_CX(cx_in, nfeatures)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL), 
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software, 
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting, 
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL, 
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* When a plot is colored by a feature-variable we extend the value
* ifeature along the obs axis. The group-context used for plot labels
* thinks that the plot is along the E axis but it is along the obs direction 
* Set the cx_plot index and/or world limits.

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* V741 8/18 *acm* color-by-feature

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'xcontext.cmn'

* calling argument declarations:
	INTEGER cx_in, nfeatures

* When color-by-id, the feature-direction context has not been set in cx_plot.
* get it from the command context, where the user may have set a limit on E or M

	IF ( cx_lo_ss(cx_cmnd, e_dim) .NE. unspecified_int4) THEN
 	   cx_lo_ss(cx_plot, e_dim) = cx_lo_ss(cx_cmnd, e_dim)
	   cx_hi_ss(cx_plot, e_dim) = cx_hi_ss(cx_cmnd, e_dim)
	   cx_lo_ww(e_dim, cx_plot) = cx_lo_ss(cx_cmnd, e_dim)
	   cx_hi_ww(e_dim, cx_plot) = cx_hi_ss(cx_cmnd, e_dim)
	ELSE
 	   
	   IF ( cx_lo_ww(e_dim, cx_cmnd) .NE. unspecified_val8) THEN
	      cx_lo_ww(e_dim, cx_plot) = cx_lo_ww(e_dim, cx_cmnd)
	      cx_hi_ww(e_dim, cx_plot) = cx_lo_ww(e_dim, cx_cmnd)
	      cx_lo_ss(cx_plot, e_dim) = cx_lo_ww(e_dim, cx_cmnd)
	      cx_hi_ss(cx_plot, e_dim) = cx_lo_ww(e_dim, cx_cmnd)
	   ELSE	   
	      cx_lo_ss(cx_plot, e_dim) = 1
	      cx_hi_ss(cx_plot, e_dim) = nfeatures
	      cx_lo_ww(e_dim, cx_plot) = 1
	      cx_hi_ww(e_dim, cx_plot) = nfeatures
	   ENDIF

	ENDIF

* When color-by-id, the time context has not been set in cx_plot.
* get it from the context passed in

	IF ( cx_lo_ss(cx_plot, t_dim) .EQ. unspecified_int4) THEN
	   IF ( cx_lo_ss(cx_in, t_dim) .NE. unspecified_int4) THEN
 	      cx_lo_ss(cx_plot, t_dim) = cx_lo_ss(cx_in, t_dim)
	      cx_hi_ss(cx_plot, t_dim) = cx_hi_ss(cx_in, t_dim)
	   ENDIF
	ENDIF
 	   
	IF ( cx_lo_ww(t_dim, cx_plot) .EQ. unspecified_val8 
     .     .OR. cx_lo_ww(t_dim, cx_plot) .EQ. unspec_val8_2) THEN
	   IF ( cx_lo_ww(t_dim, cx_in) .NE. unspecified_val8) THEN
	      cx_lo_ww(t_dim, cx_plot) = cx_lo_ww(t_dim, cx_in)
	      cx_hi_ww(t_dim, cx_plot) = cx_hi_ww(t_dim, cx_in)
	   ENDIF
	ENDIF

	RETURN
	END

	CHARACTER*(*) FUNCTION COMPOUND_TITLE( cx_list, ncx, tlen )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* create a full title for a plot 
* - possibly with more than one variable documented

* support routines:
*	VAR_TITLE	   - gets gets a simple title string for variable
*			     eg. "TEMPERATURE"
*	VAR_UNITS	   - gets a string with the units for this variable
*	VAR_TITLE_MOD	   - gets a modification to the title string, if any
*			     eg. "( averaged in X )"
*	FULL_VAR_TITLE	   - VAR_TITLE//VAR_UNITS//VAR_TITLE_MOD with parens
*			     eg. "TEMPERATURE ( averaged in X )"

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V200:   1/4/89 - from COMPOUND_PLOT_TITLE: major re-write without colors
* V71  *acm* 2/17  More on ticket 2231. New argument to FULL_VAR_TITLE to control units labels

        IMPLICIT NONE
* calling argument declarations:
	INTEGER	ncx, cx_list(ncx), tlen

* internal variable declarations:
	CHARACTER*200	FULL_VAR_TITLE
	LOGICAL		do_units
	INTEGER		slen, maxlen, i

	include 'ferret.parm'

* maximum title length
	maxlen = LEN( COMPOUND_TITLE )

	do_units = .TRUE.

* initialize to the first variable context
	COMPOUND_TITLE = FULL_VAR_TITLE( cx_list(1), do_units, tlen )

* add any remaining variables separated by commas
	DO 100 i = 2, ncx
	   COMPOUND_TITLE = COMPOUND_TITLE(:tlen)//' , '//
     .			    FULL_VAR_TITLE( cx_list(i), do_units, slen )
	   tlen = MIN( maxlen, tlen+slen+3 )
 100	CONTINUE

* in case it was too long give an indication
	IF ( tlen .EQ. maxlen ) COMPOUND_TITLE(tlen:tlen) = '*'

	RETURN
	END

	SUBROUTINE GET_FVAR_ATT_VAL(dset, var, attname, maxlen, vals, nvals)

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* Convenience routine to easily get the numerical value(s) attached to
* the attribute named attname on variable ivar.
* This routine should be used only when the attribute is 
* known to exist, and to be numerical (rather than string)

* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V720 5/17 *sh*

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xtm_grid.cmn_text'
	include 'xdset_info.cmn_text'
	include 'xdset_info.cd_equiv'
#include "tmap_dset.parm"

* calling arguments
*	dset	(input)  dataset number in XDSET_INFO
*	var	(input)  var number in XDSET_INFO
*	attname	(input)  name of numerical attribute
*	maxlen	(input)  maximum number of values that may be returned
*	vals	(output) value(s) found on attribute
*	nval	(output) number of values returned

* calling argument declarations:
	INTEGER dset, var, nvals, maxlen
	CHARACTER*(*) attname
	REAL vals(maxlen)

* internal variable declarations:
        LOGICAL NC_GET_ATTRIB, got_it
        INTEGER vid, attoutflag, status
        CHARACTER    buff*8, vname*128

* local parameter definitions:
	LOGICAL	    do_warn
	PARAMETER ( do_warn = .TRUE. )

* get the name and id of the variable

	vname = ds_var_code(var)
	vid = cd_varid(var)

* get the values  ('got_it' should always be true)
* DSGTBD: I think I could have made this more efficient by calling either
*     NC_GET_ATTRIB_FLOAT or NC_GET_ATTRIB_DP instead
        got_it = NC_GET_ATTRIB( dset, vid, attname,
     .				do_warn, vname, maxlen, nvals, attoutflag, 
     .				buff, vals )

	RETURN
	END

	SUBROUTINE PARSE_NAM_DSET( full_var_name, default_cx,
     .				       dset, cat, var, mods_cx, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* given a full variable specification of the form:
*			(eg.) TEMP[D=n,G=gname] (with optional region info)
* return context information describing variable and data set

* NOTE: THIS ROUTINE MAY CREATE AN IMPLICIT GRID that needs to be managed
*	Check cx_has_impl_grid(mods_cx) in calling routine

* Note that "dset" is both an input and output:  on input it is the
*		default data set to be searched.  On output it is the
*		data set that is correct.

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V402: 7/95 - extracted from PARSE_NAM_DSET_GRD (w/out the grid part)
* V450: 1/97 - use local variables instead of xPROG_STATE vars for item_start
*		etc. to avoid conflict. (But share the max_item_list parameter
*		from the COMMON area.
* V500: *sh* 3/99 -- added comment WATCH IMPLICIT GRID MANAGEMENT
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
* V687  *acm* 3/14 ticket 2133. Check for attribute name before looking for variable

        IMPLICIT NONE
	include 'tmap_dims.parm'	
	include	'ferret.parm'
	include	'errmsg.parm'
	include	'xcontext.cmn'
	include	'xprog_state.cmn'

* calling argument declarations:
	INTEGER		default_cx, dset, cat, var, mods_cx, status
	CHARACTER*(*)	full_var_name

* internal variable declarations:
	INTEGER		IGRID, var_cx, stk_stat,
     .			full_name_len, left_bracket, right_bracket,
     .			name_len, brac_nest, i, dot
 	LOGICAL		name_only
* 1/97 addition
	INTEGER	num_it, it_start(max_item_list), it_end(max_item_list)


* set up error flag in case we fail
	var = munknown_var_name

* variable context level
	CALL STACK_PTR_UP ( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) GOTO 5000
	var_cx = cx_stack_ptr
	CALL TRANSFER_CONTEXT ( default_cx, var_cx )

* modifications context level
	CALL STACK_PTR_UP ( cx_stack_ptr, max_context, status )
	IF ( status .NE. ferr_ok ) GOTO 4950
	mods_cx = cx_stack_ptr
	CALL INIT_CONTEXT_MODS ( mods_cx )

* separate simple name from possible modifiers
	full_name_len = LEN   ( full_var_name )
	left_bracket  = INDEX ( full_var_name, '[' )
	name_only     = left_bracket .EQ. 0
	IF ( name_only ) THEN
	   name_len = full_name_len
	ELSE
	   name_len = left_bracket - 1
* ... hunt for matching right bracket
	   brac_nest = 1
	   right_bracket = 0	! default to catch syntax errors
	   DO 200 i = left_bracket+1,full_name_len
	      IF ( full_var_name(i:i) .EQ. "[" ) THEN
	         brac_nest = brac_nest + 1
	      ELSEIF ( full_var_name(i:i) .EQ. "]" ) THEN
	         brac_nest = brac_nest - 1
	         IF ( brac_nest .EQ. 0 ) THEN
	            right_bracket = i
	            GOTO 210
	         ENDIF
	      ENDIF
 200	   CONTINUE
 210	   IF (   right_bracket .LE. left_bracket + 1
     .	     .OR. name_len      .LE. 0			) GOTO 5100
	ENDIF

* break up the "[...,...,...]" into comma-separated arguments
	IF ( .NOT.name_only ) THEN
	   CALL PARSE_COMMA_LIST (	full_var_name,
     .					left_bracket  + 1,
     .					right_bracket - 1,
     .					max_item_list,
     .					num_it,
     .					it_start,
     .					it_end,
     .					status		)
	   IF ( status .NE. ferr_ok ) GOTO 4900
	ELSE
	   num_it = 0
	ENDIF

*interpret the list of items - unknown items represent errors
	CALL GET_CONTEXT_MODS (	default_cx,
     .				full_var_name,
     .				mods_cx,
     .				max_item_list,
     .				num_it,
     .				it_start,
     .				it_end,
     .				unknown_qual_bad,
     .				status	)
	IF ( status .NE. ferr_ok ) GOTO 4900

* apply data set to context if specified
	IF ( cx_data_set( mods_cx ) .NE. unspecified_int4 )
     .		cx_data_set( var_cx ) = cx_data_set( mods_cx )
	IF (dset.EQ.unspecified_int4 .OR. cx_dset_gvn(mods_cx))
     .		dset = cx_data_set( var_cx )

* identify the simple variable name
* (var = munknown_var_name will flag failure for the whole routine)
* Look for a dot, indicating a varname.attname.

	dot = INDEX(full_var_name(1:name_len),'.')
	IF (dot .GT. 0) name_len = dot-1

	CALL FIND_VAR_NAME( dset, full_var_name(1:name_len), cat, var )

* relinquish the stack space used for the variable
 4900	CALL STACK_PTR_DN( cx_stack_ptr, cx_stack_ptr_base, stk_stat )

* relinquish the stack space used for the modifications
 4950	CALL STACK_PTR_DN( cx_stack_ptr, cx_stack_ptr_base, stk_stat )
	RETURN

* error exit
 5000	RETURN
 5100	CALL ERRMSG( ferr_syntax, status, full_var_name, *4900 )
 5200	CALL ERRMSG( ferr_unknown_variable, status, full_var_name, *4900 )
! 5300	CALL ERRMSG
!     .		( ferr_unknown_data_set, status,'for '//full_var_name, *4900 )
	END

	LOGICAL FUNCTION ITSA_1LINEIF( cmnd, slen )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine whether the given command string is a one-line IF command of the
* form
*      IF 0_or_1 THEN command_which_include_ELSE [ENDIF optional]

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program

* V693+  *sh* 12/14  (borrowing code from PROCESS_IF.F

        IMPLICIT NONE
* calling argument declarations
	CHARACTER*(*) cmnd
	INTEGER	slen

* local variable declarations
	INTEGER i, pos_then

        CHARACTER*1     tab
#ifdef NO_INTRINSIC_IN_PARAMETER
	PARAMETER     ( tab = o'011' )
#else
	PARAMETER     ( tab = CHAR(9))
#endif


* NOTE: this code **ASSUMES*
*  1) that the starting characters of the command string are "IF "
*  2) that there is no bang-comment string
*  3) that the string is already up-cased


* the test is simply that the command contains "THEN" and there is further
* text found after it

	pos_then = INDEX(cmnd(:slen), 'THEN')
	IF ( pos_then .GT. 0 ) THEN
	   DO i = pos_then+4, slen
              IF (cmnd(i:i).NE. ' ' .AND. cmnd(i:i).NE. tab) GOTO 100
	   ENDDO
* ... no characters found after THEN -- this is not a one-liner
	ENDIF

	ITSA_1LINEIF = .FALSE.
	RETURN

* we found a "THEN" and we also found more text after it
 100	ITSA_1LINEIF = .TRUE.
	RETURN

	END

	SUBROUTINE EQUAL_FORMAT( string, status )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* from a string of the form "FORMAT=xxxx" determine the listing format and
* save the information in COMMON

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system

* V200:   9/1/89
*	 10/1/90 - "BIBO" --> "EPIC"
* V230:  6/92 - use common variable list_fmt_type
*       10/92 - improve test for I format by checking for digit following "i"
*       11/92 - get lower case format
* V301:  1/94 - extracted code into CHECK_FORMAT
* V320: 12/94 - added /FORMAT=STREAM
* V420:  9/95 - added /FORMAT=COMMA-DELIMITED and /FORMAT=TAB-DELIMITED
* V450: 11/96 - added /FORMAT=CACHE for DODS caching
* V554   9/03 *acm* - add output in /DODS binary format
* V602 *jli* 8/06 - add plist_xml
* V602 *acm* 1/07 - use risc_buff rather than local variable buff, for solution to bug 1482
*       *acm* 3/12 6D Ferret (common uses nferdims in tmap_dims.parm)
*                  Do not use GT format
* V745 *acm* 12/18  added plist_dsg for CF-DSG format


        IMPLICIT NONE
* calling argument declarations
	INTEGER		status
	CHARACTER*(*)	string

* internal variable declarations
	INTEGER	STR_UPCASE, vax_code
	CHARACTER upcase3*3

	include 'tmap_dims.parm'
	include 'ferret.parm'
	include 'errmsg.parm'
	include 'xprog_state.cmn'
        include 'xrisc.cmn'

* SET LIST/FORMAT=(FORTRAN_FORMAT),'UNFORMATTED','EPIC','TMAP','GT','STREAM', 'DODS'

* remove old specs
	list_format_given = .FALSE.

        CALL EQUAL_STR_LC( string, risc_buff, status )   ! lower case 11/92
        IF ( status .NE. ferr_ok ) RETURN
	IF ( risc_buff .NE. ' ' ) list_format = risc_buff

* special interpretations
        vax_code = STR_UPCASE( upcase3, list_format(1:3) )
        IF (     upcase3 .EQ. 'UNF' ) THEN
           list_fmt_type = plist_unformatted
        ELSEIF ( upcase3 .EQ. 'EPI' ) THEN
           list_fmt_type = plist_epic
        ELSEIF ( upcase3 .EQ. 'TMA' ) THEN
           GOTO 5010
        ELSEIF ( upcase3 .EQ. 'GT' ) THEN
           GOTO 5010
        ELSEIF ( upcase3 .EQ. 'CDF' ) THEN
           list_fmt_type = plist_cdf
        ELSEIF ( upcase3 .EQ. 'STR' ) THEN
           list_fmt_type = plist_stream
        ELSEIF ( upcase3 .EQ. 'COM' ) THEN
           list_fmt_type = plist_comma_del
        ELSEIF ( upcase3 .EQ. 'TAB' ) THEN
           list_fmt_type = plist_tab_del
        ELSEIF ( upcase3 .EQ. 'CAC' ) THEN
           list_fmt_type = plist_cdf_cache
        ELSEIF ( upcase3 .EQ. 'DOD' ) THEN
           list_fmt_type = plist_dods
        ELSEIF ( upcase3 .EQ. 'XML' ) THEN
           list_fmt_type = plist_xml
        ELSEIF ( upcase3 .EQ. 'DSG' ) THEN
           list_fmt_type = plist_dsg
        ELSE

* ... check out user-specified format
	   CALL CHECK_FORMAT( list_format, status )
	   IF ( status .NE. ferr_ok ) RETURN
	   list_format_given = .TRUE.
           list_fmt_type = plist_formatted
	ENDIF

* success
	status = ferr_ok
	RETURN

* syntax error
 5000	RETURN
 5010   CALL ERRMSG( ferr_invalid_subcmnd, status,
     .          'File type no longer supported '//upcase3, *5000 )

	END

	SUBROUTINE CHECK_MEMBER_SETS (agg_dim, nsets, memb_dsetnames,
     .				      member_sets, status)
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
* Programmer Ansley Manke
* NOAA/PMEL, Seattle, WA - TMAP 
*
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V685 *acm*  3/13 For Ensemble aggregations, call the ds_type 'ENS'
* V695 *acm*  2/15 For Forecast aggregations, call the ds_type 'FCT'
* V695+ *sh*  5/15 removed block of code from here to INIT_AGGREGATE_DSET
*                  notably, the call to GET_AXIS_SPEED
* V698+ *sh* 11/15 add ok_re_use_existing to TM_INIT_DSET call
*            12/15 pass dataset names and nsets *into* this routine
*	           if dataset not already open, then open it hidden
*	      2/16 allow "-" as an indicator of a dummy dataset
*	      3/16 check for illegal Unix filenames
*	      4/16 defer checking aggs build of aggs to OK_AS_AGG_VAR
* V741 *acm* 5/18 Promoting global attributes to a variable in ensembles:
*                 File extensions for member sets were not being stripped off 

* calling arguments
*   agg_dim             - axis of the aggregation being created
*   nsets		- number of datasets to be aggregated (input)
*   memb_dsetnames	- array of names of the datasets (input)
*   member_sets		- array of open dataset numbers (output)
*   status		- return status

        IMPLICIT NONE
        include 'tmap_errors.parm'
#include "tmap_dset.parm"
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include 'xdset_info.cmn_text'
	external xdset_info_data
        include 'xprog_state.cmn'
	include 'xtm_grid.cmn_text'  
	include 'errmsg.parm'
	include 'netcdf.inc'
	include 'xvariables.cmn'
	include 'xcontext.cmn'
	include 'xfr_grid.cmn'
	include 'xdiag_ctrl.cmn_text'

* calling argument declarations:
	INTEGER agg_dim, nsets, member_sets(nsets), status
	CHARACTER*(*), memb_dsetnames(nsets)

* local variable declarations:
	LOGICAL TM_DIGIT, tregular, use_strict
	INTEGER TM_LENSTR, i, ich, buff_len, dset, iset, perm(nferdims)
	CHARACTER buff1*512

* local parameter definitions
	LOGICAL ok_re_use_existing
	PARAMETER ( ok_re_use_existing = .TRUE.)

	DO 100 iset = 1, nsets
	   member_sets(iset) = unspecified_int4
  100	CONTINUE

	DO 110 i = 1, nferdims
	   perm(i) = unspecified_int4
  110	CONTINUE

* Check on the aggregate-member datasets. (code taken from xeq_set)
* Open them if they're not already open.

	tregular = .FALSE.
	use_strict = .FALSE.

	DO iset = 1, nsets

	   buff1 = memb_dsetnames(iset)
	   buff_len = TM_LENSTR(buff1)

* check for legal Unix filename
* could use tm_legal_unix_name.F, but it is old and overly strict
* the netCDF library will refuse an illegal name, but it will not give a nice
* message
* can easily add more to this test as needed
	   IF (INDEX(buff1(:buff_len)," ") .GT. 0) GOTO 5050

	   IF (buff1 .EQ. "-") THEN
* dummy dataset indicator
	      IF (iset .EQ. 1) GOTO 5100
	      member_sets(iset) = pdset_dummy
	      CYCLE
	   ENDIF

* check to see if data set was referred to by number
* 9/95 - replaced "*" with "(I)" read from separate buffer
	   IF ( TM_DIGIT(buff1) ) THEN

* avoid crash due to single character "+" or "."
	      IF (buff_len.EQ.1
     .      .AND.(buff1(1:1).LT.'0' .OR. buff1(1:1).GT.'9')) GOTO 740

              DO ich = 1, buff_len
		IF ( .NOT. TM_DIGIT(buff1(ich:ich))) GOTO 740
	      ENDDO
	      READ (buff1,*) dset
#ifdef MANDATORY_FORMAT_WIDTHS
	      READ (buff1,*,ERR=740) dset
#else
	      READ (buff1,'(I)',ERR=740) dset
#endif
* ... check for valid number given
	      IF   ( dset .LT. 1
     .	      .OR.   dset .GT. maxdsets )	  GOTO 5200
	      IF (ds_name(dset).EQ.char_init2048) GOTO 5200
	      GOTO 750
	   ENDIF

* no! it wasn't given by number so open the data set
 740       ds_dset_type = 'CDF'   ! used and cleared in tm_init_dset

* initialize a TMAP-supported data set
 	   CALL TM_INIT_DSET( buff1(:buff_len), ok_re_use_existing,
     .			      perm, dset, tregular, use_strict, mode_dsg, status )
	   
           IF ( status .NE. merr_no_action ) THEN  ! merr_no_action = already init'ed
	      IF ( status .NE. ferr_ok ) GOTO 5300 ! error in file or url
	      ds_hide(dset) = .TRUE.   ! hide unless previously opened
	   ENDIF

 750	   member_sets(iset) = dset

	ENDDO

	status = ferr_ok

 5000   RETURN	

* Error exits: 
 5050	CALL ERRMSG( ferr_invalid_command, status,
     .		'corrupted filename: '//buff1(:buff_len), *5000 )
 5100	CALL ERRMSG( ferr_invalid_command, status,
     .		'1st aggregate member may not be missing', *5000)
 5200	CALL ERRMSG( ferr_unknown_data_set, status,
     .		'dset '//buff1(:buff_len),         *5000 )
 5300	CALL ERRMSG( ferr_TMAP_error, status, ' ', *5000 )

	END

	SUBROUTINE DO_POINTS_DSG(	action, idim, 
     .				dset, nfeatures, maxobs,
     .				com, com_mr, com_cx,
     .				res, res_mr, res_cx )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* determine the number of good and number of bad points along the given axis

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* V230:   2/3/92 - based on DO_AVE_INT
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V71 *acm* 12/16 this routine now performs accumulation, possibly continuing
*                 over several chunks, so keep adding to the count in res(). 
*                 Initialization and finalizing called separately from IS_TRANS
* V76   1/20 *acm* Orientation of Point-type data set to e_dim

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'interp_stack.parm'
	include	'xcontext.cmn'
	include	'xvariables.cmn'
	include	'xmem_subsc.cmn'
	include 'xunits.cmn_text'
	external xunits_data
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xdyn_linemem.cmn_text'
	include 'xdset_info.cmn_text'

* calling argument declarations:
	INTEGER	action, idim, dset, nfeatures, maxobs, com_mr, com_cx, res_mr, res_cx
	REAL    com   (*),
     .          res   (*)  ! E=@AVE will have -999:-999

* internal variable declarations:
	LOGICAL	good_un, fmask(nfeatures), omask(maxobs)
	INTEGER i, pt, flen, base, ifeature, iobs, ok, cnt,
     .          orientation, row_size_lm
	REAL	bad_com, bad_res, val


* --- end of introductory code ---


* initialize
        pt   = cx_lo_ss( res_cx, idim )
	bad_com = mr_bad_data( com_mr )
        bad_res = mr_bad_data( res_mr )
	good_un  = action .EQ. isact_good_pt

	orientation = dsg_orientation(dset)

	IF (dsg_row_size_var(dset) .GT. 0) row_size_lm = dsg_loaded_lm(dsg_row_size_var(dset))
	bad_res     = mr_bad_data( res_mr )

* get feature mask
        CALL MAKE_DSG_FEATURE_MASK(dset, res_cx, fmask, nfeatures)


* ****** PERFORM THE COMPUTATION *****
	IF (idim.EQ.orientation .AND. orientation.LE.t_dim) THEN


* *** true ragged array processing:
* compress each feature into a single value 
           base = 0    ! obs index at end of preceding feature
* ... loop over the features
	   DO ifeature = 1, nfeatures 

	      res(ifeature) = bad_res ! initialize

	      ok = 0   ! number of valid component values found
	      cnt = 0  ! count points not masked

	      flen = dsg_linemem(row_size_lm)%ptr(ifeature)  ! feature length

* ... have the user's WW constraints removed this feature?
	      IF (.NOT.fmask(ifeature)) THEN
                 base = base + flen
                 CYCLE
              ENDIF

* ... get observation-level mask for this feature
	      CALL MAKE_DSG_OBS_MASK(dset, com_cx, ifeature, base,
     .				     omask, flen)
	
* ... loop over the observations within each feature
              iobs = base
	      DO i = 1, flen
	         iobs = iobs + 1   ! index in the contig ragged array

	         IF (.NOT.omask(i)) CYCLE
		 cnt = cnt + 1	   

* ... the input data value
                 val = com(iobs)

	         IF ( val .EQ. bad_com ) CYCLE
	         ok = ok + 1.
              ENDDO

	      IF (good_un) THEN
	         res(ifeature) = ok
              ELSE
                 res(ifeature) = cnt - ok
              ENDIF 
	      
	      base = base + flen
           ENDDO

	ELSE

* *** a simple list of instances:
* look along the instance (feature) axis resulting in just a single value

	   ok = 0   ! number of valid component values found
	   cnt = 0  ! count points not masked
	   DO ifeature = 1, nfeatures 

* ... have the user's WW constraints removed this feature?
	      IF (.NOT.fmask(ifeature)) CYCLE
	      cnt = cnt + 1

* ... the input data value
              val = com(ifeature)

	      IF ( val .EQ. bad_res ) CYCLE
	      ok = ok + 1.
           ENDDO
	   
	   IF (good_un) THEN
	      res(1) = ok
	   ELSE
              res(1) = cnt - ok
	   ENDIF 

	ENDIF

	RETURN
	END

#! /bin/csh -f
# Fgo go_file_template    
# determine if files matching go_file_template are currently on-line by
# searching the paths in FER_GO

# 8/92 bug fix: on SUNs /bin/test can accept only one arg.  Use nonomatch
# to resolve the list of files matching template and pass only one name to test
#
# utterly modified for osf port.  11.8.93 *kob* Allow inclusion of 
#  "-help", "-l", and "-more" options.  Also allows for desired file
# to end in ".jnl"
# 21mar94 *kob* Solaris port -----
#		  /bin/test doesn't exist on solaris (sunos 5.x) so had to 
#		  do a check for that OS and then point it to /usr/ucb/test
# 5may94 *kob* 	Ultrix bug - no /usr/bin/grep
#		 should have been /bin/grep
# 30may97 *kob* Linux port - test is in /usr/bin/test
# 19mar01 *acm* Eliminate hard-coded paths, set path as sugg by J.Sirott (added
#               /usr/ucb as well. for TEST definition)

set path = ($path /bin /usr/bin /sbin /usr/sbin /opt/bin /opt/sbin /usr/ucb) 

#check for proper amount of args.  One arg is the filename or template. 
if ($#argv == 0 || $#argv > 2) then
  echo " "
  echo "Usage: Fgo [-help] [-l] [-more]  go_file[_template]"
  echo "Type Fgo -help for a full description"
  echo " "
  exit 1
endif

# print out help message
if ('$argv[1]' =~ *h*) then
usage:
  echo " "
  echo "Usage:"
  echo "        Fgo [-help] [-l] [-more]  go_file[_template]"
  echo  " "
  echo "where options include: "
  echo "   -help	print this message, option not valid with any other"
  echo "   -l		generate long listing, without description of tool"
  echo "   -more	more files matching given template"
  echo " "
  echo "These options precede either the go file, if it is known,"
  echo "or a go file template.  All files found matching the given template"
  echo "are then listed, or more'd if the -more option is passed. All options"
  echo "are mutually exclusive. To see all of the Go tools/journal files"
  echo "available, enter: "
  echo "       Fgo '*'"
  echo "It is important to have the single quotes around the asterisk."
  echo " " 
  exit 1
endif

#set some variables
set num_args = $#argv
set nonomatch
set found = 0

# ACM eliminate this and replace $TEST with just test throughout
#check for sunos 5.x
#if (`uname` =~ *Sun* && `uname -r` =~ *5.*) then
#	set TEST = /usr/ucb/test
#else if (`uname` =~ *inux* ) then
#	set TEST = /usr/bin/test
#else
#	set TEST = /bin/test
#endif

# check to see if file 
# check to see if file contains .jnl or not
if ($argv[$num_args] =~ *.jnl*) then
	set tag = 1
else
	set tag = 0
endif


# if there is only one argument, it must be the file name, otherwise it
# is a usage error
if ($num_args == 1) then
#check for usage error
  if ($argv[1] =~ *-l* || $argv[1] =~ *-hel* || $argv[1] =~ *-mor*) goto usage
  foreach fpath ($FER_GO)
	cd $fpath
# check for existance of an extension.  If no extension, apply .jnl default
	if ($tag) then
		set flist = *$argv*
	else
		set flist = *$argv*.jnl
	endif
	test -f $flist[1]
	if ($status == 0) then   
      		echo "* * * * * * * * in $fpath"
		foreach file ($flist)
		echo `ls $file`: `egrep '[ ][dD][eE][sS][cC][rR][iI][p	P][tT][iI][oO][nN]:[ ]' $file ` | sed -e "s/\![ ][dD][eE][sS][cC][rR][iI][pP][tT][iI][oO][nN]:[ ]//"
		end
		set found = 1
      		echo " " 
   	endif
   end
	goto the_end
#if num_args is two, then we either have to do an ls -l, or a more.
#cannot do both.
else if ( $num_args == 2 ) then
#do a long listing
	switch ($argv[1]) 
	  case '*l*' :
		foreach fpath ($FER_GO)
   			cd $fpath
   			set flist = *$argv[2]*
    			test -f $flist[1] >& /dev/null
    			if ($status == 0) then    
      			   echo "* * * * * * * * in $fpath"
			   if ($tag) then
      			   	ls -l $argv[2]
			   else	
				ls -l *$argv[2]*.jnl
			   endif
      			   set found = 1
      		 	   echo " " 
   			endif
		end
	     breaksw
	  case '*mor*':
# more each file we come across which matches the template.
		foreach fpath ($FER_GO)
   			cd $fpath
   			set flist = *$argv[2]*
    			test -f $flist[1] >& /dev/null
			if ($status == 0) then    
      			   echo "* * * * * * * * in $fpath"
			   if ($tag) then
      			   	more $argv[2]
			   else	
				more *$argv[2]*.jnl
			   endif
      			   set found = 1
      		 	   echo " " 
   			endif
		end
	     breaksw
	  default:
	     go to usage
	endsw	     
 	goto the_end
endif


the_end:
if ( $found == 0 ) then
   if ($tag) then
	   echo "No files matching $argv are on line"
   else
	   echo "No files matching $argv.jnl are on line"
   endif
endif

#! /bin/csh -f
# Fpalette file_template    
# determine if FERRET palette files matching template are currently on-line
# by searching the paths in FER_DESCR

# 8/92 bug fix: on SUNs /bin/test can accept only one arg.  Use nonomatch
# to resolve the list of files matching template and pass only one name to test
#
# utterly modified for osf port.  1.29.94 *kob* Allow inclusion of 
#  "-help", "-l", and "-more" options.  Also allows for desired file
# to end in ".spk"
# 21mar94 *kob* Solaris port -----
#		  /bin/test doesn't exist on solaris (sunos 5.x) so had to 
#		  do a check for that OS and then point it to /usr/ucb/test
# 18may94 *kob* removed the "ls -1" and made it "ls" because of lack of "-1"
#		option on SGI's
# 30may97 *kob* Linux port - test is in /usr/bin/test


#check for proper amount of args.  One arg is the filename or template. 
if ($#argv == 0 || $#argv > 2) then
  echo " "
  echo "Usage: Fpalette [-help] [-l] [-more]  palette_file[_template]"
  echo "Type Fpalette -help for a full description"
  echo " "
  exit 1
endif

# print out help message
if ("$argv[1]" =~ *hel* || "$argv[1]" == "-h") then
usage:
  echo " "
  echo "Usage:"
  echo "        Fpalette [-help] [-l] [-more]  palette_file[_template]"
  echo  " "
  echo "where options include: "
  echo "   -help	print this message, option not valid with any other"
  echo "   -l		generate long listing, without description of palette"
  echo "   -more	display files matching given template using more"
  echo " "
  echo "These options precede either the palette file, if it is known,"
  echo "or a palette file template.  Files found matching the given template"
  echo "are then listed, or more'd if the -more option is passed. All options"
  echo "are mutually exclusive. To see all of the Palette  files"
  echo "available, enter: "
  echo "       Fpalette '*'"
  echo "It is important to have the single quotes around the asterisk."
  echo " " 
  exit 1
endif

# set some variables
set num_args = $#argv
set nonomatch
set found = 0
#set some commands that seem to wander on various systems
set GREP = /bin/grep
set EGREP = /usr/bin/egrep
set SED = /bin/sed


#check for sunos 5.x
if (`uname` =~ *Sun* && `uname -r` =~ *5.*) then
	set TEST = /usr/ucb/test
else if (`uname` =~ *inux* ) then
	set TEST = /usr/bin/test
        set EGREP = /bin/egrep
else
	set TEST = /bin/test
endif


# check to see if file contains .spk or not
if ("$argv[$num_args]" =~ *.spk*) then
	set tag = 1
else
	set tag = 0
endif

# if there is only one argument, it must be the file name, otherwise it
# is a usage error
if ($num_args == 1) then
#check for usage error
  if ("$argv[1]" =~ *-l* || "$argv[1]" =~ *-hel* || "$argv[1]" =~ *-m*) goto usage
  foreach path ($FER_PALETTE)
	cd $path
# check for existance of an extension.  If no extension, apply .spk default
	if ($tag) then
		set flist = *$argv*
	else
		set flist = *$argv*.spk
	endif
	$TEST -f $flist[1]
	if ($status == 0) then   
      		echo "* * * * * * * * in $path"
		foreach file ($flist)
      		 echo `/bin/ls $file`: `$EGREP '[ ][dD][eE][sS][cC][rR][iI][pP][tT][iI][oO][nN]:[ ]' $file ` | $SED -e "s/\![ ][dD][eE][sS][cC][rR][iI][pP][tT][iI][oO][nN]:[ ]//"
		end
		set found = 1
      		echo " " 
   	endif
   end
	goto the_end
#if num_args is two, then we either have to do an ls -l, or a more.
#cannot do both.
else if ( $num_args == 2 ) then
#do a long listing
	switch ($argv[1]) 
	  case '*l*' :
		foreach path ($FER_PALETTE)
   			cd $path
   			set flist = *$argv[2]*
    			$TEST -f $flist[1] >& /dev/null
    			if ($status == 0) then    
      			   echo "* * * * * * * * in $path"
			   if ($tag) then
      			   	/bin/ls -l $argv[2]
			   else	
				/bin/ls -l *$argv[2]*.spk
			   endif
      			   set found = 1
      		 	   echo " " 
   			endif
		end
	     breaksw
	  case '*-m*':
# more each file we come across which matches the template.
		foreach path ($FER_PALETTE)
   			cd $path
   			set flist = *$argv[2]*
    			$TEST -f $flist[1] >& /dev/null
			if ($status == 0) then    
      			   echo "* * * * * * * * in $path"
			   if ($tag) then
      			   	/bin/more $argv[2]
			   else	
				/bin/more *$argv[2]*.spk
			   endif
      			   set found = 1
      		 	   echo " " 
   			endif
		end
	     breaksw
	  default:
	     goto usage
	endsw	     
 	goto the_end
endif


the_end:
if ( $found == 0 ) then
   if ($tag) then
	   echo "No files matching $argv are on line"
   else
	   echo "No files matching $argv.spk are on line"
   endif
endif

#! /bin/csh -f
# sort a list of names given as arguments into increasing
# order based on their ~nnn~ version number extensions
# at most one name should be without ~nnn~

# example usage:  Fsort metafile.plt*
# example in context:	animate `Fsort metafile.plt*`
# ... or in a more complex example
#	animate start_frame `Fsort series1.plt*` `Fsort series2.plt*` end_frame

echo $argv | nawk -f $FER_DIR/bin/Fsort.nawk

# Note:
# Here is an alternative version that uses sort for the "tilda" filenames
# and sed to put the filename with no tilda version number at the end:
# ls !* | sort -t\~ +1n | sed -e '/\~/\!h' -e '/\~/\!d' -e '$p' -e '$x'

s/M4_CHARSTAR_4M/CHARSTAR/g
s/M4_DOUBLESTAR_4M/DOUBLESTAR/g
s/M4_FLOATSTAR_4M/FLOATSTAR/g
s/M4_INTSTAR_4M/INTSTAR/g
s/M4_NAMEF_4M/NAMEF/g
s/M4_STRING_4M/STRING/g
s/M4_STRINGD_4M/STRINGD/g
s/M4_STRINGF_4M/STRINGF/g
s/M4_STRINGL_4M/STRINGL/g
s/M4_STRINGX_4M/STRINGX/g
s/M4_REALX_4M/REALX/g
s/M4_INTEGERX_4M/INTEGERX/g
s/M4_FUNCTIONX_4M/FUNCTIONX/g
s/M4_DOUBLEX_4M/DOUBLEX/g
s/M4_VARARGS_4M/VARARGS/g
s/M4_VOIDSTAR_4M/VOIDSTAR/g
s/M4_FUNCTION_4M/FUNCTION/g
s/M4_changecom_4M/changecom/g
s/M4_changequote_4M/changequote/g
s/M4_decr_4M/decr/g
s/M4_define_4M/define/g
s/M4_defn_4M/defn/g
s/M4_divert_4M/divert/g
s/M4_divnum_4M/divnum/g
s/M4_dnl_4M/dnl/g
s/M4_dumpdef_4M/dumpdef/g
s/M4_errprint_4M/errprint/g
s/M4_eval_4M/eval/g
s/M4_format_4M/format/g
s/M4_ifdef_4M/ifdef/g
s/M4_ifelse_4M/ifelse/g
s/M4_include_4M/include/g
s/M4_incr_4M/incr/g
s/M4_index_4M/index/g
s/M4_len_4M/len/g
s/M4_m4exit_4M/m4exit/g
s/M4_m4wrap_4M/m4wrap/g
s/M4_maketemp_4M/maketemp/g
s/M4_popdef_4M/popdef/g
s/M4_pushdef_4M/pushdef/g
s/M4_shift_4M/shift/g
s/M4_sinclude_4M/sinclude/g
s/M4_substr_4M/substr/g
s/M4_syscmd_4M/syscmd/g
s/M4_sysval_4M/sysval/g
s/M4_traceoff_4M/traceoff/g
s/M4_traceon_4M/traceon/g
s/M4_translit_4M/translit/g
s/M4_undefine_4M/undefine/g
s/M4_undivert_4M/undivert/g
s/M4_unix_4M/unix/g

/#FORTC_LINE/ {
    s//#line/
    N
    s/\n/ /
    s/$/ M4_FORTC_FILE/
}

#! /bin/csh -f
#! *sh* 10/91
#! Fhelp
#! enter the Ferret Users Guide at the indicated line number
#! If no line number is given then coach on usage

# no argument given: explain the ropes
if ($#argv == "0") then
     echo ' '
     echo '	*** Fhelp - Interactive help for FERRET ***'
     echo ' '
     echo '	Fhelp enters the FERRET Users Guide at a given line number'
     echo '	      or at the first occurrence of a given string'
     echo ' '
     echo '		Correct usage is:  Fhelp line_number'
     echo '		              or   Fhelp string'
     echo '	             For example:  Fhelp "getting started"'
     echo ' '
     echo '	When reading the Users Guide use standard "more" commands:'
     echo '	? = help   b = back 1 page   CR = next line  space = next page'
     echo ' '
     echo ' '
     echo '	Also available: Fapropos'
     echo '	Fapropos scans the FERRET Users Guide for a character string'
     echo '	and reports the lines where it occurs'
     echo ' '
     echo '		Correct usage is:  Fapropos  string'
     echo ' '
      exit
endif

# too many arguments: explain the syntax
if ( $#argv >= 2 ) then
     echo " "
     echo "	*** Syntax error in command entered ***"
     echo " "
     echo "		Correct usage is:  Fhelp line_number"
     echo " "
     echo ' '
     echo '	Use Fapropos to scan the FERRET Users Guide for a character string'
     echo '	and determine the lines where it occurs'
     echo ' '
     echo '		Correct usage is:  Fapropos  string'
     exit
endif

# did user enter a line number or a string
    echo $argv[1] | grep -s '^[0-9]*$'

# enter the FERRET manual 2 lines before the requested line
if ( $status == 0 ) then

#  line number
   @ argv[1] -= 2
   more -d +$argv[1] $FER_DIR/doc/ferret_users_guide.txt
   exit
else
#  string: use grep for case-insensitive search
   set line = `grep -in "$argv[1]" $FER_DIR/doc/ferret_users_guide.txt | head -1 | sed 's/^\([0-9]*\):.*$/\1/' `
   @ line -= 2
   more -d +{$line} $FER_DIR/doc/ferret_users_guide.txt

endif

#! /bin/sh
# run individually each of the benchmark tests listed in TEST_SCRIPTS

if [ $# -ne 2 ]; then
   echo ""
   echo "Usage:  $0  Ferret  ExtFuncsDir"
   echo "where:"
   echo "       Ferret is the ferret executable or pyferret script to use"
   echo "       ExtFuncsDir is the external functions directory to use"
   echo "           (if '.', bn_all_ef.jnl will not be run)"
   echo ""
   exit 1
fi

fver="$1"
efdir="$2"

PS1='$ '
export PS1

cleanuponerror() {
   rm -f ./.ferret
   exit 129 
}

if [ -n "$SKIP_REMOTE" ]; then
   test_scripts_file="TEST_SCRIPTS_NOREMOTE"
else
   test_scripts_file="TEST_SCRIPTS"
fi

# allow tests to be commented out by beginning with the line with a '!'
# remove bn_all_ef.jnl from the list if $efdir is "."
if [ "$efdir" = "." ]; then
   jnl_scripts=`grep -v '^!' $test_scripts_file | grep '\.jnl$' | grep -v "bn_all_ef\.jnl"`
else
   jnl_scripts=`grep -v '^!' $test_scripts_file | grep '\.jnl$'`
fi
py_scripts=`grep -v '^!' $test_scripts_file | grep '\.py$'`

# Get the machine type for the stream file testing
if [ `uname -s` = "Linux" -a `uname -m` = "x86_64" ]; then
    machine="x86_64-linux"
elif [ `uname -s` = "Linux" -a `uname -m` = "i686" ]; then
    machine="linux"
elif [ `uname -s` = "Darwin" -a `uname -m` = "x86_64" ]; then
    machine="x86_64-darwin"
else
    echo "Unknown machine type"
    exit 1
fi

date_stamp=`date +'%d%h%yAT%H%M'|tr '[A-Z]' '[a-z]'`
log_file="all_${date_stamp}.${machine}_log"
err_file="all_${date_stamp}.${machine}_err"
ncdump_file="all_${date_stamp}.${machine}_ncdump"

# Make sure things are clean for this run
rm -f $log_file $err_file $ncdump_file
rm -f ferret.jnl* bat.plt* `cat TRASH_FILES`
rm -fr subdir tmp

touch $log_file $ncdump_file
touch F.cdf snoopy.dat

# set up the binary unformatted stream test file as a machine-specific link
machine_stream="data/stream10by5_${machine}.unf"
if [ -r  $machine_stream ]; then
   rm -f stream_data_link.unf
   ln -s $machine_stream stream_data_link.unf
else
   echo "File $machine_stream does not exist." >> $log_file
   echo "Benchmark bn420_stream will fail." >> $log_file
   echo "To create $machine_stream compile make_stream_file.F and run the executable" >> $log_file
   echo "(You may need to use the compile flag -Dreclen_in_bytes)" >> $log_file
   echo "Then rename stream10by5.unf to $machine_stream" >> $log_file
   echo "File $machine_stream does not exist."
   echo "Benchmark bn420_stream will fail."
   echo "To create $machine_stream compile make_stream_file.F and run the executable"
   echo "Then rename stream10by5.unf to $machine_stream"
fi

# set up proper stream testing jnl file - depends on endianness
# pretty much everything is little endian now
rm -f bn_test_stream.jnl
ln -s v5jnls/bn_test_stream_little.jnl bn_test_stream.jnl
# ln -s v5jnls/bn_test_stream_big.jnl bn_test_stream.jnl

echo "Testing log output in $log_file"
echo "Testing errors in $err_file" 
echo "Testing ncdump output in $ncdump_file"

if ! echo "$fver" | grep -q "pyferret"; then
   ispyferret=0
#  command-line options for ferret
   feropts="-nojnl -gif -noverify -server"
#  -server sets line buffering for C I/O
#  GFORTRAN_UNBUFFERED_PRECONNECTED=1 removes buffering of Fortran I/O
   GFORTRAN_UNBUFFERED_PRECONNECTED=1
   export GFORTRAN_UNBUFFERED_PRECONNECTED
#  external functions search path
   FER_EXTERNAL_FUNCTIONS="$efdir"
   export FER_EXTERNAL_FUNCTIONS
else
   ispyferret=1
#  command-line options for pyferret
   feropts="-nojnl -quiet -nodisplay -noverify -linebuffer"
#  -linebuffer sets line buffering for C and Python I/O
#  GFORTRAN_UNBUFFERED_PRECONNECTED=1 removes buffering of Fortran I/O
   GFORTRAN_UNBUFFERED_PRECONNECTED=1
   export GFORTRAN_UNBUFFERED_PRECONNECTED
#  external functions search path
   PYFER_EXTERNAL_FUNCTIONS="$efdir"
   export PYFER_EXTERNAL_FUNCTIONS
fi

# set up a generic data environment
echo "****** Restricting Ferret paths to bench directory ******" >> $log_file
. ./bench_environment.sh

# copy default.ferret to ./.ferret so results are consistent
cp ./default.ferret ./.ferret
trap "cleanuponerror" SIGHUP SIGINT SIGQUIT SIGILL SIGABRT SIGBUS SIGFPE SIGKILL SIGSEGV SIGTERM

echo "Benchmark scripts that will be run:" >> $log_file
for script in $jnl_scripts; do
   echo "   $script" >> $log_file
done
if [ "$ispyferret" -ne 0 ]; then
   for script in $py_scripts; do
      echo "   $script" >> $log_file
   done
fi

# run each of the scripts in the list
rm -f all_ncdump.out
for script in $jnl_scripts; do

   echo "*** Running ferret script: $script" >> $log_file
   echo "*** Running ferret script: $script" >> $err_file
   echo "*** Running ferret script: $script" > all_ncdump.out
   echo "Running ferret script: $script"

   if [ $script = "bn_startupfile.jnl" ]; then
#     bn_startupfile.jnl needs the contents of ferret_startup as ./.ferret
      cp -f ferret_startup ./.ferret
   fi

   if [ $script = "bn_dollar.jnl" ]; then
      $fver $feropts -script $script hello 1>> $log_file 2>> $err_file
   else
      $fver $feropts -script $script 1>> $log_file 2>> $err_file
   fi
   if [ $? -ne 0 ]; then
      if [ "$ispyferret" -eq 0 ]; then
         echo "****** FERRET error: $script failed ******" >> $log_file
         echo "****** FERRET error: $script failed ******" >> $err_file
         echo "****** FERRET error: $script failed ******" >> all_ncdump.out
         echo "****** FERRET error: $script failed ******"
      else
         echo "****** PYFERRET error: $script failed ******" >> $log_file
         echo "****** PYFERRET error: $script failed ******" >> $err_file
         echo "****** PYFERRET error: $script failed ******" >> all_ncdump.out
         echo "****** PYFERRET error: $script failed ******"
      fi
   fi

   if [ $script = "bn_startupfile.jnl" ]; then
#     return ./.ferret to the contents of default.ferret
      cp -f default.ferret ./.ferret
   fi

#  add the contents of all_ncdump.out to $ncdump_file
   cat all_ncdump.out >> $ncdump_file
   rm -f all_ncdump.out
   rm -f ferret.gif
   rm -f ferret.png
done

if [ "$ispyferret" -ne 0 ]; then
   for script in $py_scripts; do
      echo "*** Running python script: $script" >> $log_file
      echo "*** Running python script: $script" >> $err_file
      echo "*** Running python script: $script" > all_ncdump.out
      echo "Running python script: $script"
      $fver $feropts -python < pyscripts/$script 1>> $log_file 2>> $err_file
      if [ $? -ne 0 ]; then
         echo "****** PYFERRET error: $script failed ******" >> $log_file
         echo "****** PYFERRET error: $script failed ******" >> $err_file
         echo "****** PYFERRET error: $script failed ******" >> all_ncdump.out
         echo "****** PYFERRET error: $script failed ******"
      fi
      cat all_ncdump.out >> $ncdump_file
      rm -f all_ncdump.out
   done
fi

trap - SIGHUP SIGINT SIGQUIT SIGILL SIGABRT SIGBUS SIGFPE SIGKILL SIGSEGV SIGTERM
rm -f ./.ferret

# Replace insignificant differences with constant values
cleanups="cleanups.sed"

builddir=`dirname $PWD | sed -e 's/\\//\\\\\\//g'`
echo "s/$builddir/....../g" > $cleanups

exebindir=`dirname $fver`
exeferdir=`dirname $exebindir | sed -e 's/\\//\\\\\\//g'`
echo "s/$exeferdir/....../g" >> $cleanups

timeregex=`date +%0d.%h.%Y`
echo "s/${timeregex}.[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/DD-MON-YYYY HH:MM:SS/g" >> $cleanups
echo "s/${timeregex}.[0-9][0-9]:[0-9][0-9]/DD-MON-YYYY HH:MM/g" >> $cleanups
echo "s/${timeregex}/DD-MON-YYYY/g" >> $cleanups
timeregex=`date +%0d.%h.%Y | tr [a-z] [A-Z]`
echo "s/${timeregex}.[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/DD-MON-YYYY HH:MM:SS/g" >> $cleanups
echo "s/${timeregex}.[0-9][0-9]:[0-9][0-9]/DD-MON-YYYY HH:MM/g" >> $cleanups
echo "s/${timeregex}/DD-MON-YYYY/g" >> $cleanups
timeregex=`date +%_d.%h.%Y`
echo "s/${timeregex}.[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/DD-MON-YYYY HH:MM:SS/g" >> $cleanups
echo "s/${timeregex}.[0-9][0-9]:[0-9][0-9]/DD-MON-YYYY HH:MM/g" >> $cleanups
echo "s/${timeregex}/DD-MON-YYYY/g" >> $cleanups
timeregex=`date +%_d.%h.%Y | tr [a-z] [A-Z]`
echo "s/${timeregex}.[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/DD-MON-YYYY HH:MM:SS/g" >> $cleanups
echo "s/${timeregex}.[0-9][0-9]:[0-9][0-9]/DD-MON-YYYY HH:MM/g" >> $cleanups
echo "s/${timeregex}/DD-MON-YYYY/g" >> $cleanups
# If date assigned to symbol and then symbol used elsewhere, any beginning space is dropped
timeregex=`date +%-d.%h.%Y`
echo "s/\<${timeregex}.[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/DD-MON-YYYY HH:MM:SS/g" >> $cleanups
echo "s/\<${timeregex}.[0-9][0-9]:[0-9][0-9]/DD-MON-YYYY HH:MM/g" >> $cleanups
echo "s/\<${timeregex}/DD-MON-YYYY/g" >> $cleanups
timeregex=`date +%-d.%h.%Y | tr [a-z] [A-Z]`
echo "s/\<${timeregex}.[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/DD-MON-YYYY HH:MM:SS/g" >> $cleanups
echo "s/\<${timeregex}.[0-9][0-9]:[0-9][0-9]/DD-MON-YYYY HH:MM/g" >> $cleanups
echo "s/\<${timeregex}/DD-MON-YYYY/g" >> $cleanups

timeregex=`date +%0d.%h.%y`
echo "s/${timeregex}.[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/DD-MON-YY HH:MM:SS/g" >> $cleanups
echo "s/${timeregex}.[0-9][0-9]:[0-9][0-9]/DD-MON-YY HH:MM/g" >> $cleanups
echo "s/${timeregex}\$/DD-MON-YY/g" >> $cleanups
echo "s/${timeregex}\>/DD-MON-YY/g" >> $cleanups
timeregex=`date +%0d.%h.%y | tr [a-z] [A-Z]`
echo "s/${timeregex}.[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/DD-MON-YY HH:MM:SS/g" >> $cleanups
echo "s/${timeregex}.[0-9][0-9]:[0-9][0-9]/DD-MON-YY HH:MM/g" >> $cleanups
echo "s/${timeregex}\$/DD-MON-YY/g" >> $cleanups
echo "s/${timeregex}\>/DD-MON-YY/g" >> $cleanups
timeregex=`date +%_d.%h.%y`
echo "s/${timeregex}.[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/DD-MON-YY HH:MM:SS/g" >> $cleanups
echo "s/${timeregex}.[0-9][0-9]:[0-9][0-9]/DD-MON-YY HH:MM/g" >> $cleanups
echo "s/${timeregex}\$/DD-MON-YY/g" >> $cleanups
echo "s/${timeregex}\>/DD-MON-YY/g" >> $cleanups
timeregex=`date +%_d.%h.%y | tr [a-z] [A-Z]`
echo "s/${timeregex}.[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/DD-MON-YY HH:MM:SS/g" >> $cleanups
echo "s/${timeregex}.[0-9][0-9]:[0-9][0-9]/DD-MON-YY HH:MM/g" >> $cleanups
echo "s/${timeregex}\$/DD-MON-YY/g" >> $cleanups
echo "s/${timeregex}\>/DD-MON-YY/g" >> $cleanups
# If date assigned to symbol and then symbol used elsewhere, any beginning space is dropped
timeregex=`date +%-d.%h.%y`
echo "s/\<${timeregex}.[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/DD-MON-YY HH:MM:SS/g" >> $cleanups
echo "s/\<${timeregex}.[0-9][0-9]:[0-9][0-9]/DD-MON-YY HH:MM/g" >> $cleanups
echo "s/\<${timeregex}\$/DD-MON-YY/g" >> $cleanups
echo "s/\<${timeregex}\>/DD-MON-YY/g" >> $cleanups
timeregex=`date +%-d.%h.%y | tr [a-z] [A-Z]`
echo "s/\<${timeregex}.[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/DD-MON-YY HH:MM:SS/g" >> $cleanups
echo "s/\<${timeregex}.[0-9][0-9]:[0-9][0-9]/DD-MON-YY HH:MM/g" >> $cleanups
echo "s/\<${timeregex}\$/DD-MON-YY/g" >> $cleanups
echo "s/\<${timeregex}\>/DD-MON-YY/g" >> $cleanups

timeregex=`date +%m.%d.%Y`
echo "s/${timeregex}.[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/MM-DD-YYYY HH:MM:SS/g" >> $cleanups
echo "s/${timeregex}.[0-9][0-9]:[0-9][0-9]/MM-DD-YYYY HH:MM/g" >> $cleanups
echo "s/${timeregex}/MM-DD-YYYY/g" >> $cleanups

timeregex=`date +%m.%d.%y`
echo "s/${timeregex}.[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/MM-DD-YY HH:MM:SS/g" >> $cleanups
echo "s/${timeregex}.[0-9][0-9]:[0-9][0-9]/MM-DD-YY HH:MM/g" >> $cleanups
echo "s/${timeregex}\$/MM-DD-YY/g" >> $cleanups
echo "s/${timeregex}\>/MM-DD-YY/g" >> $cleanups

timeregex=`date | sed -e 's/[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/'`
echo "s/${timeregex}/WKD MON DD HH:MM:SS ZZZ YYYY/g" >> $cleanups
timeregex=`date | tr [a-z] [A-Z] | sed -e 's/[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/'`
echo "s/${timeregex}/WKD MON DD HH:MM:SS ZZZ YYYY/g" >> $cleanups

timeregex=`date +%a.%h.%_d.%T.%Y | sed -e 's/[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/'`
echo "s/${timeregex}/WKD MON DD HH:MM:SS YYYY/g" >> $cleanups
timeregex=`date +%a.%h.%_d.%T.%Y | tr [a-z] [A-Z] | sed -e 's/[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/'`
echo "s/${timeregex}/WKD MON DD HH:MM:SS YYYY/g" >> $cleanups

timeregex=`date +%h.%_d.%T.%Y | sed -e 's/[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/'`
echo "s/${timeregex}/MON DD HH:MM:SS YYYY/g" >> $cleanups
timeregex=`date +%h.%_d.%T.%Y | tr [a-z] [A-Z] | sed -e 's/[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/[0-9][0-9]:[0-9][0-9]:[0-9][0-9]/'`
echo "s/${timeregex}/MON DD HH:MM:SS YYYY/g" >> $cleanups

echo 's/^randu2_randn2 [0-9 .-]+$/randu2_randn2      ....../' >> $cleanups
echo 's/the_time = [0-9][0-9]:[0-9][0-9]/the_time = HH:MM/g' >> $cleanups
echo 's/\(AX[0-9][0-9][0-9]\)/\(AX###\)/g' >> $cleanups
echo 's/\(G[0-9][0-9][0-9]\)/\(G###\)/g' >> $cleanups
echo 's/CURRENT_TIME = "[0-9][0-9]:[0-9][0-9]:[0-9][0-9]"/CURRENT_TIME = "HH:MM:SS"/g' >> $cleanups
echo 's/SESSION_TIME = "[0-9][0-9]:[0-9][0-9]"/SESSION_TIME = "HH:MM"/g' >> $cleanups
echo 's/SESSION_PID = "[0-9]+"/SESSION_PID = "#####"/g' >> $cleanups
echo 's/DELTA_CPU = "[0-9]\.[0-9E-]+"/DELTA_CPU = "######"/g' >> $cleanups
echo 's/DELTA_CPU = "[0-9]"/DELTA_CPU = "######"/g' >> $cleanups
echo 's/CLOCK_SECS = "[0-9]\.[0-9E-]+"/CLOCK_SECS = "######"/g' >> $cleanups
echo 's/CLOCK_SECS = "[0-9]"/CLOCK_SECS = "######"/g' >> $cleanups
echo 's/^\[\?1034h//' >> $cleanups
echo 's/Second 10K LET commands LET a = 0 takes  [0-7]\.[0-9]+  seconds/Second 10K LET commands LET a = 0 takes [0-8] seconds/' >> $cleanups
echo 's/Second 10K LET commands LET a = 0 takes  [0-8]  seconds/Second 10K LET commands LET a = 0 takes [0-8] seconds/' >> $cleanups
echo 's/10K LET commands LET a = 0 takes  [0-3]\.[0-9]+  seconds/10K LET commands LET a = 0 takes [0-4] seconds/' >> $cleanups
echo 's/10K LET commands LET a = 0 takes  [0-4]  seconds/10K LET commands LET a = 0 takes [0-4] seconds/' >> $cleanups
echo 's/5K LOAD with transform takes  [0-8]\.[0-9]+  seconds/5K LOAD with transform takes [0-9] seconds/' >> $cleanups
echo 's/5K LOAD with transform takes  [0-9]  seconds/5K LOAD with transform takes [0-9] seconds/' >> $cleanups
echo 's/DEFINE VARIABLE ten_plots = 0\.[0-9]+/DEFINE VARIABLE ten_plots = 0.######/' >> $cleanups
echo 's/DEFINE VARIABLE ten_plots = [01]$/DEFINE VARIABLE ten_plots = 0.######/' >> $cleanups
echo 's/DEFINE VARIABLE dt = 0\.[0-9]+/DEFINE VARIABLE dt = 0.######/' >> $cleanups
echo 's/DEFINE VARIABLE dt = [01]$/DEFINE VARIABLE dt = 0.######/' >> $cleanups
echo 's/DEFINE VARIABLE sumcpu =[ ]?0\.[0-9]+/DEFINE VARIABLE sumcpu = 0.######/' >> $cleanups
echo 's/DEFINE VARIABLE sumcpu =[ ]?[01]$/DEFINE VARIABLE sumcpu = 0.######/' >> $cleanups
echo 's/!-> DEFINE VARIABLE pid = [0-9][0-9]+$/!-> DEFINE VARIABLE pid = #####/' >> $cleanups
echo '/say `sumcpu`/,/sh sym CLOCK_SECS/ s/0\.[0-9]+/0.######/' >> $cleanups
echo '/say `sumcpu`/,/sh sym CLOCK_SECS/ s/[01] /0.###### /' >> $cleanups

username=`id -un`
groupname=`id -gn`
echo "s/^[0-9]+ [0-9]+ [rw-]+ [0-9]+ ${username} ${groupname} /######## ######## ---------- # user group /" >> $cleanups

sed $SED_EXTREGEX_FLAG -i_orig -f $cleanups $log_file
sed $SED_EXTREGEX_FLAG -i_orig -f $cleanups $err_file
sed $SED_EXTREGEX_FLAG -i_orig -f $cleanups $ncdump_file

# Clean-up
rm -f `cat TRASH_FILES`
rm -fr subdir tmp

# simple csh script to restrict the ferret environment when running benchmark tests
# must be sourced using 'source' into the current shell - do not make executable

setenv FER_GO ". ./v4jnls ./v5jnls ./v6jnls ./v7jnls ./genjnls $FER_GO"
setenv FER_DATA ". ./data"
setenv FER_DESCR ". ./data"
setenv FER_DSETS ". ./data"
setenv FER_GRIDS ". ./data"
setenv FER_DIR "."

#! /bin/csh -f
# Fpurge
# remove all but the current version of the indicated file(s)

# example usage:  Fpurge metafile.plt

# no argument given: explain the ropes
if ($#argv != "1") then
     echo '*** Syntax error - name 1 filename as template, only ***'
     echo '  Usage:  Fpurge  filename.extension'
     echo 'Example:  Fpurge ferret.jnl'
     exit
endif

rm {$argv[1]}.~*~

#! /bin/csh -f
# Fprint
# Script to translate metafiles generated by Ferret.  It runs either gksm2ps
# (on systems where Ferret uses xgks -- releases after Mar 1994), or mtt;
# please see the documentation on those.  It is intended to simplify sending
# plots to printers, to an output file only, or to a workstation screen.  This
# version translates to PostScript or Xwindow output.
#
# The script should work without modification to send output to the default
# printer at your site (whichever is specified in $PRINTER).
#
# The default behavior of this script is to translate metafiles to color PS (or
# grayscale) using line types appropriate for a monochrome PS printer.
#
# BUT the script should be modified to include the printers at your site.
# The section "MODIFY HERE" below contains case statements.  Each case is
# intended to be the name of a printer at your site, and the options set
# for that case determines the default action taken by the metafile translator.
# For example, whether lines are rendered in color or b&w.  The printers named
# in this template illustrate the use for supported device types.
#
# Examples of use:
#
# "Fprint metafile.plt" translates and prints 'metafile.plt' on $PRINTER
# "Fprint -P COLOR_PS metafile.plt" sends the plot to printer COLOR_PS
# "Fprint -o my_plot.ps metafile.plt" writes to a PS file named 'my_plot.ps'
# "Fprint -X metafile.plt" renders on the workstation screen.
#
# If you have questions please send email to davison@pmel.noaa.gov

# 12.15.94 Due to a bug in the DEC OSF lpr command, use of the -s (symbolic
# link, ie, don't copy the file -- used with large files) with the -r option
# (remove file after printing) cannot be done.  The file is deleted before it 
# printed.  Consequently for OSF machines, I have dropped the use of the -r 
# option and the print files will accumulate.


set err_txt = "no_err"
if ($#argv == 0 || "$argv" == "-h" || "$argv" == "-help") goto help

touch Fprint_output0.ps
rm -f Fprint_output*.ps

set output_args   	= " "
set output        	= "printer"
set printer_named	= 0
set translator_args  	= "-l cps -d cps"

set gksm2ps_files 	= ""
set mtt_files		= ""
set got_gksm2ps_files   = 0
set got_mtt_files	= 0		

set REMOVE = "-r"

# Pick off arguments til the end of argv
while ($#argv != 0)
   switch ($argv[1])
      case -P:
#        Send output to named printer  
	 shift argv      

	 set err_txt = "-P $argv[1]"
	 if (`echo $argv[1] | cut -c1` == "-") goto help
	 set output_args = "$output_args -P$argv[1]"
	 set output = "printer"

	 set fprinter = $argv[1]
	 set printer_named = 1
         shift argv

	 breaksw
      case -o:
#	 Output is to be directed to plot file and not printed
	 shift argv
      
 	 set err_txt = "-o $argv[1]"
	 if (`echo $argv[1] | cut -c1` == "-") goto help
	 set translator_args = "$translator_args -o $argv[1]"
	 set output = "file"
         shift argv

	 breaksw
      case -X:
#	 Output is to be directed to Xwindow
	 shift argv
 	 set translator_args = ""
	 set output = "Xwindow"

	 breaksw
      case -#:
#        Print N copies 
	 set output_args = "$output_args $argv[1]" 
	 shift argv      

	 set err_txt = "-# $argv[1]"
	 if (`echo $argv[1] | cut -c1` == "-") goto help
	 set output_args = "$output_args$argv[1]"
         shift argv

	 breaksw
      case -p:
#	 Page orientation: landscape or portrait
	 shift argv
	 
	 set err_txt = "-p $argv[1]"
	 if (`echo $argv[1] | cut -c1` == "-") goto help
	 if ($argv[1] != "landscape" && $argv[1] != "portrait") goto help

	 set translator_args = "$translator_args -p $argv[1]"
         shift argv

	 breaksw
      case -l:
#	 Line color: cps (color) or ps (b&w)
	 shift argv
      
	 set err_txt = "-l $argv[1]"
	 if (`echo $argv[1] | cut -c1` == "-") goto help
	 if ($argv[1] != "cps" && $argv[1] != "ps") goto help

	 set translator_args = "$translator_args -l $argv[1]"
         shift argv

	 breaksw
      case -d:
#	 Supported devices: cps (color PostScript) or phaser (TEK phaser ps)
	 shift argv
      
	 set err_txt = "-d $argv[1]"
	 if (`echo $argv[1] | cut -c1` == "-") goto help
	 if ($argv[1] != "cps" && $argv[1] != "phaser") goto help

	 set translator_args = "$translator_args -d $argv[1]"
         shift argv

	 breaksw
      case -R:
#	 Don't append to metafiles with date stamp when translation is complete
	 set translator_args = "$translator_args -R"
	 shift argv

	 breaksw
      case -C:
#	 Use CMYK color model 
	 set translator_args = "$translator_args -C"
	 shift argv

	 breaksw
      default:
	 # Everything else is passed to translator -- gotta be a file
	 if (! -e $argv[1]) then
	   echo "ERROR: $argv[1] is not a file name"
	   goto help
	 endif

	 head -n 1 $argv[1] | grep -s ^GKSM > /dev/null

	 if ($status == 0) then
	   set gksm2ps_files     = "$gksm2ps_files $argv[1]"
	   set got_gksm2ps_files = 1
	 else	 
	   set mtt_files         = "$mtt_files $argv[1]"
	   set got_mtt_files     = 1	 
	 endif

         shift argv
         breaksw
   endsw
end

if ($output != "printer" || ! $printer_named) goto xeq_translator

############################ MODIFY HERE ###################################

# Now set device characteristics for named printers
switch ($fprinter)
case COLOR_PS:
# If the printer is a color PS printer, use that device type
   set translator_args = "$translator_args -l cps -d cps"
   breaksw
case PHASER_PX_TRANSFER:
# BUT If the printer is a PHASER PX with transfer sheets, type is "phaser"
   set translator_args = "$translator_args -l cps -d phaser"
   breaksw
# The following example printers take the default options mentioned above.
case MONOCHROME_PS1:
   breaksw
case MONOCHROME_PS2:
   breaksw
case MONOCHROME_PS3:
   breaksw
default:
# The named printer is not a valid choice:
# This is the sort of message I anticipate the user getting if one names an
# unsupported printer:
#
#   echo -n "'${fprinter}' is not a valid printer."
#   if ($?PRINTER) then
#     echo " The default printer is $PRINTER."
#   else
#     echo " "
#   endif
#   echo " Available printers are COLOR_PS, PHASER_PX_TRANSFER,"
#   echo " MONOCHROME_PS1, MONOCHROME_PS2, and MONOCHROME_PS3"
#
# For now a user gets this message:
   echo " "
   echo " The Fprint script has not been set up to use the -P option"
   echo " yet -- it should work with the default printer."
   echo " "
   exit
endsw

##################### END OF "MODIFY HERE" SECTION ##########################

# Now process the metafile(s) and print the plot file if appropriate
xeq_translator:
if (`uname -s` == "OSF1") set REMOVE = ""
switch ($output)
case printer:
   if ($got_gksm2ps_files) then
      gksm2ps -o Fprint_output1$$.ps $translator_args $gksm2ps_files
      if (-e Fprint_output1$$.ps) then
         lpr -s ${REMOVE} $output_args ./Fprint_output1$$.ps
      endif
   endif

   if ($got_mtt_files) then
      mtt -o Fprint_output2$$.ps $translator_args $mtt_files
      if (-e Fprint_output2$$.ps) then
         lpr -s ${REMOVE} $output_args ./Fprint_output2$$.ps
      endif
   endif

   breaksw
case file:
   if ($got_gksm2ps_files) gksm2ps $translator_args $gksm2ps_files 
   if ($got_mtt_files)    mtt     $translator_args $mtt_files 
   breaksw
case Xwindow:
   if ($got_gksm2ps_files) gksm2ps -X $gksm2ps_files 
   if ($got_mtt_files) mtt $mtt_files

   breaksw
endsw
exit

help:
   if ("$err_txt" != "no_err") echo "ERROR: You made a syntax error near $err_txt"
   echo "Script to translate Ferret's graphics metafile(s) to PostScript"
   echo "usage: Fprint [-P printer || -o file_name || -X]"
   echo "              [-p landscape || portrait] [-# <number of copies>]"
   echo "              [-l ps || cps] [-R] metafile(s)"
   echo " "
   echo "   -P: send PostScript output to the named printer"
   echo "   -o: send PostScript output to a file and don't print the plots"
   echo "   -X: send the plots to your X Window for preview"
   echo "   -p: page orientation, landscape or portrait"
   echo "   -#: print more than one copy of the plots"
   echo "   -l: line styles, ps == monochrome, cps == color"
   echo "   -R: do not rename files with a date stamp appended (default is to stamp)"
   echo "   -C: Output a CMYK postscript file (default is RGB)" 
   echo "Examples: "
   echo "    Fprint metafile.plt*"
   echo "    Fprint -P our_color_printer -l cps -# 10 metafile.plt*"
   echo "    Fprint -p portrait -R metafile.plt.~2~"
   exit

# Fapropos.awk
# intended for use in a pipe following "grep -n"
# grep -n begins each line with nn: where nn is the line number
# Usage:  grep -n string file | awk -f this_file

BEGIN	{ FS = ":" }

# header for output
	{ if ( NR==1 ) { print " LINE       TEXT"
	                  print " ----     --------" }
	}

# formatted output lines
	{ printf "%5d: ",$1
	  for (i=2; i<=NF; i++) { printf "%s",$i }
	  printf "\n"
	}

1 i\
#line 1 M4_FORTC_FILE
s/CHARSTAR/M4_CHARSTAR_4M/g
s/DOUBLESTAR/M4_DOUBLESTAR_4M/g
s/FLOATSTAR/M4_FLOATSTAR_4M/g
s/INTSTAR/M4_INTSTAR_4M/g
s/NAMEF/M4_NAMEF_4M/g
s/STRING/M4_STRING_4M/g
s/STRINGD/M4_STRINGD_4M/g
s/STRINGF/M4_STRINGF_4M/g
s/STRINGL/M4_STRINGL_4M/g
s/STRINGX/M4_STRINGX_4M/g
s/REALX/M4_REALX_4M/g
s/INTEGERX/M4_INTEGERX_4M/g
s/FUNCTIONX/M4_FUNCTIONX_4M/g
s/DOUBLEX/M4_DOUBLEX_4M/g
s/VARARGS/M4_VARARGS_4M/g
s/VOIDSTAR/M4_VOIDSTAR_4M/g
s/POINTER/M4_POINTER_4M/g
s/FUNCTION/M4_FUNCTION_4M/g
s/changecom/M4_changecom_4M/g
s/changequote/M4_changequote_4M/g
s/decr/M4_decr_4M/g
s/define/M4_define_4M/g
s/defn/M4_defn_4M/g
s/divert/M4_divert_4M/g
s/divnum/M4_divnum_4M/g
s/dnl/M4_dnl_4M/g
s/dumpdef/M4_dumpdef_4M/g
s/errprint/M4_errprint_4M/g
s/eval/M4_eval_4M/g
s/format/M4_format_4M/g
s/ifdef/M4_ifdef_4M/g
s/ifelse/M4_ifelse_4M/g
s/include/M4_include_4M/g
s/incr/M4_incr_4M/g
s/index/M4_index_4M/g
s/len/M4_len_4M/g
s/m4exit/M4_m4exit_4M/g
s/m4wrap/M4_m4wrap_4M/g
s/maketemp/M4_maketemp_4M/g
s/popdef/M4_popdef_4M/g
s/pushdef/M4_pushdef_4M/g
s/shift/M4_shift_4M/g
s/sinclude/M4_sinclude_4M/g
s/substr/M4_substr_4M/g
s/syscmd/M4_syscmd_4M/g
s/sysval/M4_sysval_4M/g
s/traceoff/M4_traceoff_4M/g
s/traceon/M4_traceon_4M/g
s/translit/M4_translit_4M/g
s/undefine/M4_undefine_4M/g
s/undivert/M4_undivert_4M/g
s/unix/M4_unix_4M/g

#! /bin/csh -f
# Fdescr file_template    
# determine if FERRET descriptor files matching template are currently on-line
# by searching the paths in FER_DESCR

# 8/92 bug fix: on SUNs /bin/test can accept only one arg.  Use nonomatch
# to resolve the list of files matching template and pass only one name to test
# 21mar94 *kob* Solaris port -----
#		  /bin/test doesn't exist on solaris (sunos 5.x) so had to 
#		  do a check for that OS and then point it to /usr/ucb/test
# 30may97 *kob* Linux port - test is in /usr/bin/test


if ($#argv == 0 ) then
   echo "usage: Fdescr descriptor_file_template"
   exit
endif

#check for sunos 5.x
if (`uname` =~ *Sun* && `uname -r` =~ *5.*) then
	set TEST = /usr/ucb/test
else if (`uname` =~ *inux* ) then
	set TEST = /usr/bin/test
else
	set TEST = /bin/test
endif


set nonomatch
set found = 0

foreach path ($FER_DESCR)
   cd $path
   set flist = *$argv*
    $TEST -f $flist[1] >& /dev/null
    if ($status == 0) then    
      echo "* * * * * * * * in $path"
      /bin/ls -l *$argv*
      set found = 1
      echo " " 
   endif
end

if ( $found == 0 ) then
   echo "No files matching $argv are on line"
endif

# Contributed by support at BSC-CNS, Barcelona, Spain
# for build using PPC processors and SLES 9  10/2008
# They say this is the link option that I used, the 
# default one didn't work in our system


g++ -m32 -L/lib -L/usr/X11R6/lib -o ferretdods_gui \
ccr/fermain_c.o ccr/gui_init.o \
ccr/save_arg_pointers.o special/linux_routines.o dat/*.o ../fmt/src/x*.o ../ppl/plot/ppldata.o special/ferret_dispatch.o special/xmake_date_data.o special/fakes3.o special/ferret_query_f.o  special/xrevision_type_data.o special/xplatform_type_data.o \
         \
         \
        /gpfs/apps/FERRET/SRC/6.13_beta/lib/libgui.a ../list-2.1/liblist.a \
         \
        ../ppl/tmapadds/*.o  \
        ef_utility/*.o \
         \
        /gpfs/apps/FERRET/SRC/6.13_beta/lib/libxeq.a /gpfs/apps/FERRET/SRC/6.13_beta/lib/libgnl.a /gpfs/apps/FERRET/SRC/6.13_beta/lib/libferplt.a /gpfs/apps/FERRET/SRC/6.13_beta/lib/librpn.a /gpfs/apps/FERRET/SRC/6.13_beta/lib/libstk.a /gpfs/apps/FERRET/SRC/6.13_beta/lib/libdoo.a /gpfs/apps/FERRET/SRC/6.13_beta/lib/libocn.a /gpfs/apps/FERRET/SRC/6.13_beta/lib/libctx.a /gpfs/apps/FERRET/SRC/6.13_beta/lib/libfmt.a /gpfs/apps/FERRET/SRC/6.13_beta/lib/libino.a /gpfs/apps/FERRET/SRC/6.13_beta/lib/libmem.a /gpfs/apps/FERRET/SRC/6.13_beta/lib/libutl.a /gpfs/apps/FERRET/SRC/6.13_beta/lib/libdat.a /gpfs/apps/FERRET/SRC/6.13_beta/lib/libccr.a /gpfs/apps/FERRET/SRC/6.13_beta/lib/libefi.a /gpfs/apps/FERRET/SRC/6.13_beta/lib/libefn.a \
        /gpfs/apps/FERRET/SRC/6.13_beta/lib/libplt.a /gpfs/apps/FERRET/SRC/6.13_beta/lib/libpll.a /gpfs/apps/FERRET/SRC/6.13_beta/lib/libsym.a /gpfs/apps/FERRET/SRC/6.13_beta/lib/libcmp.a /gpfs/apps/FERRET/SRC/6.13_beta/lib/libour.a /gpfs/apps/FERRET/SRC/6.13_beta/lib/libepi.a /gpfs/apps/FERRET/SRC/6.13_beta/lib/libusr.a  \
         \
        /gpfs/apps/FERRET/SRC/6.13_beta/lib/tmap_lib.a \
        ../readline-4.1/libreadline.a  \
        /usr/lib/libncurses.a \
        -L/gpfs/apps/DAP/3.8.2/32/lib /gpfs/apps/NCDAP/3.7.2/32/lib/libnc-dap.a /gpfs/apps/DAP/3.8.2/32/lib/libdap.a /gpfs/apps/DAP/3.8.2/32/lib/libdapclient.a /gpfs/apps/NCDAP/3.7.2/32/lib/libnc-dap.a /gpfs/apps/DAP/3.8.2/32/lib/libdap.a /usr/lib/libxml2.a -L/gpfs/apps/DAP/3.8.2/32/lib -L/gpfs/apps/DAP/3.8.2/32/lib -lz -lpthread /gpfs/apps/CURL/7.19.0/32/lib/libcurl.a -L/usr/lib -lssl -lcrypto -ldl -lssl -lcrypto /usr/lib/libgssapi.so.1 -lcrypto -lresolv -ldl -lz -lz  -lpthread -lz /gpfs/apps/FERRET/SRC/netcdf-3.6.2/install/lib/libnetcdf.a -L/opt/ibmcmp/xlf/10.1/lib/ -lxl \
        -L/gpfs/apps/HDF4/32/lib/  -ldf -ljpeg /gpfs/apps/HDF4/32/lib/libz.a  \
        ../xgks/src/lib/libxgks.a \
        -L/usr/X11R6/lib -ldl /usr/X11R6/lib/libXpm.a  -lc /usr/X11R6/lib/libXm.a -lXt -lXext -lX11 -lXp /usr/X11R6/lib/libXmu.a -lSM       -lICE        -lc -lg2c -lstdc++ -L/opt/ibmcmp/xlf/10.1/lib/ -lxl -lrt -Wl,-relax

# frequency.awk - *sh* 8/94
# this procedure should be executed with awk -f frequency.awk input.file
# The input file should be a sorted list of records with 2 values per
# record.  The first value should be the sorting index - the second should
# be a weight to associate with that record.  The sorting index may
# contain duplicates and gaps.
# The output will be a list of consecutive integers and the corresponding
# sum of weights

# due to what appears to be a bug in awk the diagnostic print line "XXXXX"
# is needed for proper functioning.

# Here is the complete usage pipe for an unsorted list:
# sort -n myintegers.dat | awk -f TS_frequency.awk | grep -v "XXXXX"

#printf("XXXXXXXXX  %d %d\n",$1,$2)   # doesn't work w/out this ???
#
# *acm* 10/02 This line was after the else, but it's wrong: bin 1 always 0!
#	      if (ndx==1) wt=0       # index 1 used to capture garbage

BEGIN   {ndx=1
         wt=0}

	{
          if ($1 == 0 ) {
            ndx = 1
          }
          else {
            if ($1 == ndx) {
            wt = wt + $2
	    } else {
	      printf("%d   %f\n",ndx,wt)
              wt = 0
	      for (i=ndx+1; i<$1; i++) printf("%d   %f\n",i,wt)
	      ndx=$1
              wt=$2
	    }
          }
	}

#! /bin/csh
# install FERRET links in the /usr/local/bin area - eliminating the need to
# modify the PATH variable
# ver 1.0 4/92 *sh* - based on INSTALL_BIN routine

# procedure options include
# "i" (install) - copies sources, links and other files to installation area
# "r" (remove)  - removes the "i" files

ask:
echo "Install (i) or remove (r)?"
set activity = $<
switch($activity)
case "i":
  echo "Installing FERRET links"
  breaksw
case "r":
  echo "Removing FERRET links"
  breaksw
default:
  echo "You must answer i or r"
  goto ask
endsw
date

# basic definitions
set source_area = $FER_DIR/bin
set dest_area = /usr/local/bin

cd $source_area
set files = *
foreach file ($files)
  switch($activity)
  case "i":
    if ($file !~ *~ ) ln -s $source_area/$file $dest_area/$file
    breaksw
  case "r":
    rm -f $dest_area/$file
    breaksw
  endsw
end

date

#! /bin/csh -f
# Fpattern file_template    
# determine if FERRET pattern files matching template are currently on-line
# by searching the paths in FER_DESCR

# 8/92 bug fix: on SUNs /bin/test can accept only one arg.  Use nonomatch
# to resolve the list of files matching template and pass only one name to test
#
# utterly modified for osf port.  1.29.94 *kob* Allow inclusion of 
#  "-help", "-l", and "-more" options.  Also allows for desired file
# to end in ".spk"
# 21mar94 *kob* Solaris port -----
#		  /bin/test doesn't exist on solaris (sunos 5.x) so had to 
#		  do a check for that OS and then point it to /usr/ucb/test
# 18may94 *kob* removed the "ls -1" and made it "ls" because of lack of "-1"
#		option on SGI's
# 18dec98 *jcd* Hack to look for .pat (pattern) files rather than .spk

#check for proper amount of args.  One arg is the filename or template. 
if ($#argv == 0 || $#argv > 2) then
  echo " "
  echo "Usage: Fpattern [-help] [-l] [-more]  pattern_file[_template]"
  echo "Type Fpattern -help for a full description"
  echo " "
  exit 1
endif

# print out help message
if ("$argv[1]" =~ *hel* || "$argv[1]" == "-h") then
usage:
  echo " "
  echo "Usage:"
  echo "        Fpattern [-help] [-l] [-more]  pattern_file[_template]"
  echo  " "
  echo "where options include: "
  echo "   -help	print this message, option not valid with any other"
  echo "   -l		generate long listing, without description of pattern"
  echo "   -more	display files matching given template using more"
  echo " "
  echo "These options precede either the pattern file, if it is known,"
  echo "or a pattern file template.  Files found matching the given template"
  echo "are then listed, or more'd if the -more option is passed. All options"
  echo "are mutually exclusive. To see all of the Pattern  files"
  echo "available, enter: "
  echo "       Fpattern '*'"
  echo "It is important to have the single quotes around the asterisk."
  echo " " 
  exit 1
endif


# set some variables
set num_args = $#argv
set nonomatch
set found = 0
#set some commands that seem to wander on various systems
set GREP = /bin/grep
set EGREP = /usr/bin/egrep
set SED = /bin/sed


#check for sunos 5.x
if (`uname` =~ *Sun* && `uname -r` =~ *5.*) then
	set TEST = /usr/ucb/test
else if (`uname` =~ *inux* ) then
	set TEST = /usr/bin/test
        set EGREP = /bin/egrep
else
	set TEST = /bin/test
endif



# check to see if file contains .pat or not
if ("$argv[$num_args]" =~ *.pat*) then
	set tag = 1
else
	set tag = 0
endif

# if there is only one argument, it must be the file name, otherwise it
# is a usage error
if ($num_args == 1) then
#check for usage error
  if ("$argv[1]" =~ *-l* || "$argv[1]" =~ *-hel* || "$argv[1]" =~ *-m*) goto usage
  foreach path ($FER_PALETTE)
	cd $path
# check for existance of an extension.  If no extension, apply .pat default
	if ($tag) then
		set flist = *$argv*
	else
		set flist = *$argv*.pat
	endif
	$TEST -f $flist[1]
	if ($status == 0) then   
      		echo "* * * * * * * * in $path"
		foreach file ($flist)
      		 echo `/bin/ls $file`: `$EGREP '[ ][dD][eE][sS][cC][rR][iI][pP][tT][iI][oO][nN]:[ ]' $file ` | $SED -e "s/\![ ][dD][eE][sS][cC][rR][iI][pP][tT][iI][oO][nN]:[ ]//"
		end
		set found = 1
      		echo " " 
   	endif
   end
	goto the_end
#if num_args is two, then we either have to do an ls -l, or a more.
#cannot do both.
else if ( $num_args == 2 ) then
#do a long listing
	switch ($argv[1]) 
	  case '*l*' :
		foreach path ($FER_PALETTE)
   			cd $path
   			set flist = *$argv[2]*
    			$TEST -f $flist[1] >& /dev/null
    			if ($status == 0) then    
      			   echo "* * * * * * * * in $path"
			   if ($tag) then
      			   	/bin/ls -l $argv[2]
			   else	
				/bin/ls -l *$argv[2]*.pat
			   endif
      			   set found = 1
      		 	   echo " " 
   			endif
		end
	     breaksw
	  case '*-m*':
# more each file we come across which matches the template.
		foreach path ($FER_PALETTE)
   			cd $path
   			set flist = *$argv[2]*
    			$TEST -f $flist[1] >& /dev/null
			if ($status == 0) then    
      			   echo "* * * * * * * * in $path"
			   if ($tag) then
      			   	/usr/ucb/more $argv[2]
			   else	
				/usr/ucb/more *$argv[2]*.pat
			   endif
      			   set found = 1
      		 	   echo " " 
   			endif
		end
	     breaksw
	  default:
	     goto usage
	endsw	     
 	goto the_end
endif


the_end:
if ( $found == 0 ) then
   if ($tag) then
	   echo "No files matching $argv are on line"
   else
	   echo "No files matching $argv.pat are on line"
   endif
endif

##
## Environment settings for Ferret for C-shell users.
## Source this file before running ferret ('source ferret_paths.csh')
##

## The environment variable FER_DIR should be the pathname of
## the directory you created for the FERRET software.
setenv FER_DIR "/usr/local/ferret"

## The environment variable FER_DSETS should be the pathname of
## the directory you created for the FERRET demonstration data files (30+ Mbytes).
setenv FER_DSETS "${FER_DIR}/fer_dsets"


## =========== The remainder of this file should not need modification ===========
## =========== unless you want to add custom directories or sites to   ===========
## =========== the Ferret's defaults.                                  ===========


## Add ${FER_DIR}/bin to the beginning of ${PATH}
if ( "${PATH}" !~ "*${FER_DIR}/bin*" ) then
    setenv PATH "${FER_DIR}/bin:${PATH}"
    rehash
endif

## For Mac OS X, add ${FER_DIR}/dylibs to DYLD_FALLBACK_LIBRARY_PATH
if ( $?DYLD_FALLBACK_LIBRARY_PATH ) then
    if ( "${DYLD_FALLBACK_LIBRARY_PATH}" !~ "*${FER_DIR}/dylibs*" ) then
        setenv DYLD_FALLBACK_LIBRARY_PATH "${FER_DIR}/dylibs:${DYLD_FALLBACK_LIBRARY_PATH}"
    endif
else
    setenv DYLD_FALLBACK_LIBRARY_PATH "${FER_DIR}/dylibs"
endif

## Space-separated lists of directories examined when searching
## for data, descriptor, grid, go-script files without path components
setenv FER_DATA ". ${FER_DSETS}/data ${FER_DIR}/contrib"
setenv FER_DESCR ". ${FER_DSETS}/descr"
setenv FER_GRIDS ". ${FER_DSETS}/grids"
setenv FER_GO ". ${FER_DIR}/go ${FER_DIR}/examples ${FER_DIR}/contrib"

## Space-separated list of directories containing traditional
## Ferret external function files (shared-object libraries)
setenv FER_EXTERNAL_FUNCTIONS "${FER_DIR}/ext_func/libs"

## Space-separated list of directories for Ferret color palettes
setenv FER_PALETTE ". ${FER_DIR}/ppl"
## Ferret's color palettes directory (old)
setenv SPECTRA "${FER_DIR}/ppl"

## Directory for Ferret fonts
setenv FER_FONTS "${FER_DIR}/ppl/fonts"
## Directory for Ferret fonts (old)
setenv PLOTFONTS "${FER_DIR}/ppl/fonts"

## Faddpath: a tool to quickly add paths to the search lists
alias Faddpath 'if ( "\!*" != "" ) then \
                   setenv FER_GO "$FER_GO \!*" \
                   setenv FER_DATA "$FER_DATA \!*" \
                   setenv FER_DESCR "$FER_DESCR \!*" \
                   setenv FER_GRIDS "$FER_GRIDS \!*" \
                else \
                   echo "    Usage: Faddpath new_directory_1 ... " \
                endif'

## my_ferret_paths_template.sh
##
## Template for setting up a personal FERRET environment
## for bash users.
##
## Copy this file to your own directory area and
## customize it to suit your personal directory layout.
## Then source it (as below) from your .bashrc file
## AFTER you source the generic ferret_paths.sh file.
##
## example:  (in your .bashrc file)
## . /usr/local/ferret_paths.sh    (or wherever your system mgr. has put it)
## . $HOME/my_ferret_paths.sh

## These are the environment variables you may wish to customize.
## They are currently set up on the assumption that all your FERRET
## work is done in the directory $HOME/ferret .

   export FER_GO="$FER_GO $HOME/ferret"

   export FER_DATA="$FER_DATA $HOME/ferret"

   export FER_DESCR="$FER_DESCR $HOME/ferret"

   export FER_GRIDS="$FER_GRIDS $HOME/ferret"

   export FER_MODEL_RUNS="$HOME/ferret/model_runs"

# simple sh script to restrict the ferret environment when running benchmark tests
# must be sourced using '.' into the current shell - do not make executable

export FER_GO=". ./v4jnls ./v5jnls ./v6jnls ./v7jnls ./genjnls $FER_GO"
export FER_DATA=". ./data"
export FER_DESCR=". ./data"
export FER_DSETS=". ./data"
export FER_GRIDS=". ./data"
export FER_DIR="."

#! /bin/tcsh -f
#
# C-shell script to check for functions that need to be renamed
# for the 6D version
#

# list of functions that need to be renamed
set funclist = ""
set funclist = "$funclist ef_get_arg_subscripts"
set funclist = "$funclist ef_get_axis_info"
set funclist = "$funclist ef_get_res_subscripts"
set funclist = "$funclist ef_get_string_arg_element"
set funclist = "$funclist ef_get_string_arg_element_len"
set funclist = "$funclist ef_set_axis_influence"
set funclist = "$funclist ef_set_axis_inheritance"
set funclist = "$funclist ef_set_axis_reduction"
set funclist = "$funclist ef_set_piecemeal_ok"
set funclist = "$funclist ef_set_work_array_dims"
set funclist = "$funclist ef_set_work_array_lens"

# case-insensitive search for the above functions without _6d appended
foreach func ( ${funclist} )
   grep -i ${func} $argv | grep -i -v ${func}_6d
end

## my_ferret_paths_template.csh
##
## Template for setting up a personal FERRET environment
## for c-shell users.
##
## Copy this file to your own directory area and
## customize it to suit your personal directory layout.
## Then source it (as below) from your .login file
## AFTER you source the generic ferret_paths.csh file.
##
## example:  (in your .login file)
## source /usr/local/ferret_paths.csh    (or wherever your system mgr. has put it)
## source $HOME/my_ferret_paths.csh

## These are the environment variables you may wish to customize.
## They are currently set up on the assumption that all your FERRET
## work is done in the directory $HOME/ferret .

   setenv FER_GO    	"$FER_GO $HOME/ferret"

   setenv FER_DATA  	"$FER_DATA $HOME/ferret"

   setenv FER_DESCR 	"$FER_DESCR $HOME/ferret"

   setenv FER_GRIDS 	"$FER_GRIDS $HOME/ferret"

   setenv FER_MODEL_RUNS "$HOME/ferret/model_runs"

#! /bin/csh -f
#! *sh* 10/91
#! Findex
#! browse the Index of the Ferret Users Guide

# enter the Index at the top
if ($#argv == "0") then
   echo "Note: Index page numbers refer to the hard copy FERRET User's Guide"
   echo "      The on-line FERRET User's Guide is not page numbered"
   echo -n "Hit <CR> to continue ..."
   echo " " 
   set pause = $<
   more -d $FER_DIR/doc/ferret_ug_index.txt
   exit
endif

# too many arguments: explain the syntax
if ($#argv >= 2) then
     echo " "
     echo "*** Syntax error in command entered ***"
     echo " "
     echo "     Usage:  Findex    or    Findex  string"
     echo " "
     echo "     Note: multi-word strings need to be enclosed in quotations"
     echo " "
     exit
endif

# use grep for case-insensitive search
   echo "*** Index page numbers refer to the hard copy or PDF FERRET User's Guide ***"
   echo "*** The on-line document is not page numbered                     ***"
   echo "*********************************************************************"
   echo " "
   grep -i "$argv[1]" $FER_DIR/doc/ferret_ug_index.txt

#! /bin/csh
# Finstall
# Does two things:
# 1) modifies 'ferret_paths template' to specify locations of ferret software &
# demo data sets and places the result in the appropriate sourcing directory
# as 'ferret_paths'
# 2) installs ferret and gksm2ps executables and shared-object external functions from 
# tar file to $FER_DIR/bin
#
# J Davison 4.94
# NOAA PMEL TMAP
echo " This script can do two things for you to help install FERRET:"
echo " "
echo " (1) Install the FERRET executables into FER_DIR/bin from the"
echo " compressed .gz file you got (usually) via ftp.  You'll want to run this"
echo " option if you're installing FERRET for the first time, and also if"
echo " you're updating the FERRET you have with new 5/26/2009executables."
echo " "
echo " (2) Modify the shell script 'ferret_paths_template'"
echo " to set environment variables FER_DIR and FER_DSETS to the directories"
echo " at your site where the FERRET software and demonstration data are. "
echo " "
echo " The resulting file will be named 'ferret_paths' and placed in a "
echo " directory you choose.  Executing the 'source' command on that"
echo " file will set up a FERRET user's environment so that FERRET can be run."
echo " "
echo " This option usually only needs to be run if you are installing FERRET"
echo " on your system for the first time, and 'ferret_paths' is not yet set up."

### Print menu and act on choice 
menu:
echo " "
echo " Enter your choice:"
echo " (1) Install executables, (2) Customize 'ferret_paths', (3) Exit and do nothing"
echo -n " (1,2, or 3) --> "
set choice = $<

if ($choice == 1) goto install_execs
if ($choice == 2) goto ferret_paths
if ($choice == 3) exit
goto menu

### Setup the ferret_paths file ###############################################
ferret_paths:
echo " "
echo " Setup ferret_paths..."

### Get FER_DIR value
if ($?FER_DIR) then
	set fer_dir = $FER_DIR
	echo " "
	echo " The environment variable FER_DIR is currently defined as"
	echo " $FER_DIR.  This is the directory where the 'fer_environment'"
	echo " .gz file was installed." 
	echo -n " Is that correct and acceptable (y/n) [y] "
	set ans = $<
	if ($ans != 'N' && $ans != 'n' ) goto checkfer_dsets
endif

echo " "
echo " Enter the complete path of the directory where the 'fer_environment'"
echo " .gz file was installed (FER_DIR). The location recommended"
echo " in the FERRET installation guide was '/usr/local/ferret'. "

getfer_dir:
echo -n " FER_DIR --> "
set fer_dir = $<
set fer_dir = $fer_dir

echo $fer_dir | grep '^/' > /dev/null
if ($status != 0) then
        echo " Sorry, you can't use relative pathnames..."
        goto getfer_dir
endif

if (! -d $fer_dir) then
        echo " '$fer_dir' is not a directory..."
        goto getfer_dir
endif

if (`find $fer_dir/bin -name Fgo -print` == "") then
        echo " The FERRET environment files are not in $fer_dir..."
        goto getfer_dir
endif

### Get FER_DSETS value
checkfer_dsets:
echo " "
if ($?FER_DSETS) then
	set fer_dsets = $FER_DSETS 
	echo " The environment variable FER_DSETS is currently defined as"
	echo " $FER_DSETS.   This is the directory where the 'fer_dsets'"
	echo " .gz file was installed."
	echo -n " Is that correct and acceptable (y/n) [y] "
	set ans = $<
	if ($ans != 'N' && $ans != 'n' ) goto echo_getferpaths_dir
endif

getfer_dsets:
echo " Enter the complete path of the directory where the 'fer_dsets'"
echo " .gz file was installed (FER_DSETS)."
echo -n " FER_DSETS --> "
set fer_dsets = $<
set fer_dsets = $fer_dsets

echo $fer_dsets | grep '^/' > /dev/null
if ($status != 0) then
        echo " Sorry, you can't use relative pathnames..."
        goto getfer_dsets
endif

if (! -d $fer_dsets) then
        echo " '$fer_dsets' is not a directory..."
        goto getfer_dsets
endif

if (`find $fer_dsets/data -name "coads_climatology*" -print` == "") then
        echo " The FERRET demonstration data files are not in $fer_dsets..."
        goto getfer_dsets
endif

### Get directory where ferret_paths will go
echo_getferpaths_dir:
echo " "
echo " Enter the complete path of the directory where you want to place the"
echo " newly created 'ferret_paths' file, for example, '/usr/local'."

getferpaths_dir:
echo -n " desired 'ferret_paths' location --> "
set ferpaths_dir = $<
set ferpaths_dir = $ferpaths_dir

echo $ferpaths_dir | grep '^/' > /dev/null
if ($status != 0) then
        echo " Sorry, you can't use relative pathnames..."
        goto getferpaths_dir
endif

if (! -d $ferpaths_dir) then
        echo " '$ferpaths_dir' is not a directory..."
        goto getferpaths_dir
endif


### If ferret_paths exists, check to see if it's OK to replace
echo " "
if (-e $ferpaths_dir/ferret_paths) then
	echo " $ferpaths_dir/ferret_paths already exists."
	echo -n " Overwrite? (y/n) [n] "
	set ans = $<
	if ($ans != 'Y' && $ans != 'y' ) then
		echo " Exiting without modifying $ferpaths_dir/ferret_paths..."
		exit (0)
	endif
endif

### Edit the ferret_paths_template file and create ferret_paths
sed -e "/setenv FER_DIR/c\\
	 setenv FER_DIR $fer_dir"  \
    -e "/setenv FER_DSETS/c\\
	 setenv FER_DSETS $fer_dsets" $fer_dir/bin/ferret_paths_template \
	 >! $ferpaths_dir/ferret_paths

if ($status != 0) then
	echo " Unable to create $ferpaths_dir/ferret_paths..."
	exit (1)
endif

echo " >>$ferpaths_dir/ferret_paths created.<<"
echo " "
goto menu

### Install the executables ###################################################
install_execs:
echo " "
echo " Install executables..."
echo " "

### Get FER_DIR value
if ($?FER_DIR) then
	set fer_dir = $FER_DIR
	echo " The environment variable FER_DIR is currently defined as"
	echo " $FER_DIR.  This is the directory where the 'fer_environment'"
	echo " .gz file was installed." 
	echo -n " Is that correct and acceptable (y/n) [y] "
	set ans = $<
	if ($ans != 'N' && $ans != 'n' ) goto get_.gzloc
endif

echo " Enter the complete path of the directory where the 'fer_environment'"
echo " .gz file was installed (FER_DIR). The location recommended"
echo " in the FERRET installation guide was '/usr/local/ferret'. "

getfer_dir2:
echo -n " FER_DIR --> "
set fer_dir = $<
set fer_dir = $fer_dir

echo $fer_dir | grep '^/' > /dev/null
if ($status != 0) then
        echo " Sorry, you can't use relative pathnames..."
        goto getfer_dir2
endif

if (! -d $fer_dir) then
        echo " '$fer_dir' is not a directory..."
        goto getfer_dir2
endif

if (`find $fer_dir/bin -name Fgo -print` == "") then
        echo " The FERRET environment files are not in $fer_dir..."
        goto getfer_dir2
endif

### Get directory where ferret executable .gz file is supposed to be
get_.gzloc:
echo " "
echo " Enter the complete path of the directory where you put the"
echo " 'fer_executables' .gz file."

getferexec_dir:
echo -n " 'fer_executables.tar.gz' location --> "
set ferexec_dir = $<
set ferexec_dir = $ferexec_dir

echo $ferexec_dir | grep '^/' > /dev/null
if ($status != 0) then
        echo " Sorry, you can't use relative pathnames..."
        goto getferexec_dir
endif

if (! -d $ferexec_dir) then
        echo " '$ferexec_dir' is not a directory..."
        goto getferexec_dir
endif

if (! -e $ferexec_dir/fer_executables.tar.gz) then
        echo " 'fer_executables.tar.gz' is not in $ferexec_dir..."
        goto getferexec_dir
endif

### Move to exec directory and begin work
pushd $fer_dir/bin > /dev/null
echo " "
echo " Moving to $cwd..."

### Rename old execs if they exist; leave date-stamped README logging install
foreach file (ferret gksm2ps)
  if (-e $file) then
	mv $file ${file}_`/bin/date +'%d%h%y'|tr '[A-Z]' '[a-z]'`
  	if ($status != 0) goto exec_err
	echo " Renamed existing $file to ${file}_`/bin/date +'%d%h%y'|tr '[A-Z]' '[a-z]'`..."
  endif
end

echo "FERRET executables installed this date by $user" >! README_`/bin/date +'%d%h%y'|tr '[A-Z]' '[a-z]'`
if ($status != 0) goto exec_err
echo " Created README_`/bin/date +'%d%h%y'|tr '[A-Z]' '[a-z]'` log file..."
echo 

### Un.gz the exec .gz file
tar xzf $ferexec_dir/fer_executables.tar.gz 
if ($status != 0) goto exec_err
echo " Extracted FERRET executables..."

#### *kob* 5/99 move external function .so files to fer_dir/ext_func/libs
if (! -d $fer_dir/ext_func/libs) mkdir  $fer_dir/ext_func/libs
if ($status != 0) goto exec_err
if (-e add_9.so) then
  mv *.so $fer_dir/ext_func/libs
endif
if ($status != 0) goto exec_err

pushd > /dev/null
echo " Returning to $cwd..."
goto menu

### There was a problem installing the executables
exec_err:
pushd > /dev/null
echo " "
echo "There's a problem manipulating files in $fer_dir.  Check your"
echo "privileges to change files in that directory and try again."
exit (1)

##
## Environment settings for Ferret for Bourne-shell users.
## Source this file before running ferret ('. ferret_paths.sh')
##

## The environment variable FER_DIR should be the pathname of
## the directory you created for the FERRET software.
export FER_DIR="/usr/local/ferret"

## The environment variable FER_DSETS should be the pathname of
## the directory you created for the FERRET demonstration data files (30+ Mbytes).
export FER_DSETS="${FER_DIR}/fer_dsets"


## =========== The remainder of this file should not need modification ===========
## =========== unless you want to add custom directories or sites to   ===========
## =========== the Ferret's defaults.                                  ===========


## Add ${FER_DIR}/bin to the beginning of ${PATH}
if ! echo "${PATH}" | grep -q "${FER_DIR}/bin"; then
    export PATH="${FER_DIR}/bin:${PATH}"
fi

## For Mac OS X, add ${FER_DIR}/dylibs to DYLD_FALLBACK_LIBRARY_PATH
if [ ! -z "$DYLD_FALLBACK_LIBRARY_PATH" ]; then
    if ! echo "${DYLD_FALLBACK_LIBRARY_PATH}" | grep -q "${FER_DIR}/dylibs"; then
        export DYLD_FALLBACK_LIBRARY_PATH="${FER_DIR}/dylibs:${DYLD_FALLBACK_LIBRARY_PATH}"
    fi
else
    export DYLD_FALLBACK_LIBRARY_PATH="${FER_DIR}/dylibs"
fi

## Space-separated lists of directories examined when searching
## for data, descriptor, grid, go-script files without path components
export FER_DATA=". ${FER_DSETS}/data ${FER_DIR}/contrib"
export FER_DESCR=". ${FER_DSETS}/descr"
export FER_GRIDS=". ${FER_DSETS}/grids"
export FER_GO=". ${FER_DIR}/go ${FER_DIR}/examples ${FER_DIR}/contrib"

## Space-separated list of directories containing traditional
## Ferret external function files (shared-object libraries)
export FER_EXTERNAL_FUNCTIONS="${FER_DIR}/ext_func/libs"

## Space-separated list of directories for Ferret color palettes
export FER_PALETTE=". ${FER_DIR}/ppl"
## Ferret's color palettes directory (old)
export SPECTRA="${FER_DIR}/ppl"

## Directory for Ferret fonts
export FER_FONTS="${FER_DIR}/ppl/fonts"
## Directory for Ferret fonts (old)
export PLOTFONTS="${FER_DIR}/ppl/fonts"

## Faddpath: a tool to quickly add paths to the search lists
Faddpath() { if [ -n "$*" ]
             then
                 export FER_GO="$FER_GO $*"
                 export FER_DATA="$FER_DATA $*"
                 export FER_DESCR="$FER_DESCR $*"
                 export FER_GRIDS="$FER_GRIDS $*"
             else
                 echo "    Usage: Faddpath new_directory_1 ..."
             fi }

#! /bin/csh -f
# Fpatch
# Untar's the file fer_patch.tar.Z to patch in additions to the current version
# of ferret and its support files
# J Davison 6.94/8.28.95
# NOAA PMEL TMAP
echo " This script patches the current version of FERRET with enhancements to"
echo " GO scripts, documentation and other support files. "

### Print menu and act on choice 
menu:
echo " "
echo " Enter your choice:"
echo " (1) Install the patch, (2) Exit and do nothing"
echo -n " (1 or 2) --> "
set choice = $<

if ($choice == 1) goto install_patch
if ($choice == 2) exit
goto menu

### Install the patch ###################################################
install_patch:
echo " "
echo " Install patch..."
echo " "

### Get FER_DIR value
if ($?FER_DIR) then
	set fer_dir = $FER_DIR
	echo " The environment variable FER_DIR is currently defined as"
	echo " $FER_DIR." 
	echo " This is the directory where the 'fer_environment' tar file was installed." 
	echo -n " Is that correct and acceptable (y/n) [y] "
	set ans = $<
	if ($ans != 'N' && $ans != 'n' ) goto get_tarloc
        echo " "
endif

echo " Enter the complete path of the directory where the 'fer_environment'"
echo " tar file was installed (FER_DIR). The location recommended"
echo " in the FERRET installation guide was '/usr/local/ferret'. "

getfer_dir:
echo -n " FER_DIR --> "
set fer_dir = $<
set fer_dir = $fer_dir

echo $fer_dir | grep '^/' > /dev/null
if ($status != 0) then
        echo " Sorry, you can't use relative pathnames..."
        goto getfer_dir
endif

if (! -d $fer_dir) then
        echo " '$fer_dir' is not a directory..."
        goto getfer_dir
endif

if (`find $fer_dir/bin -name Fgo -print` == "") then
        echo " The FERRET environment files are not in $fer_dir..."
        goto getfer_dir
endif

### Get directory where ferret patch tar file is supposed to be
get_tarloc:
echo " "
echo " Enter the complete path of the directory where you put the"
echo " 'patch' tar file."

getferpatch_dir:
echo -n " patch tar file location --> "
set ferpatch_dir = $<
set ferpatch_dir = $ferpatch_dir

echo $ferpatch_dir | grep '^/' > /dev/null
if ($status != 0) then
        echo " Sorry, you can't use relative pathnames..."
        goto getferpatch_dir
endif

if (! -d $ferpatch_dir) then
        echo " '$ferpatch_dir' is not a directory..."
        goto getferpatch_dir
endif

### Get name of patch tar file
get_patchname:
echo " "
echo " Enter the name of this 'patch' tar file, e.g. patch_28aug95.tar.Z"
echo -n " patch tar file name --> "

set patchname = $<
set patchname = $patchname

if (! -e $ferpatch_dir/$patchname) then
        echo " '$patchname' is not in $ferpatch_dir..."
        goto get_patchname
endif

### Move to $FER_DIR directory and begin work
pushd $fer_dir > /dev/null
echo " "
echo " Moving to $cwd..."

### Untar the patch tar file
echo " "
zcat $ferpatch_dir/$patchname | tar xvpf -
if ($status != 0) goto patch_err
echo " "
echo " Extracted ${patchname}..."

echo " "
echo "This FERRET patch installed `date +'%d%h%y'|tr '[A-Z]' '[a-z]'` by $user" >! $fer_dir/${patchname}_README
if ($status != 0) goto patch_err
echo " Created $fer_dir/${patchname}_README log file..."

echo
pushd > /dev/null
echo " "
echo " Returning to $cwd..."
goto menu

### There was a problem installing the patch
patch_err:
pushd > /dev/null
echo " "
echo "There's a problem manipulating files in $fer_dir.  Check your"
echo "privileges to change files in that directory and try again."
exit (1)

#! /bin/csh -f
#! *sh* 10/91
#! Ftoc
#! browse the Table of Contents of the Ferret Users Guide

# enter the Table of Contents at the top
if ($#argv == "0") then
   more -d $FER_DIR/doc/ferret_ug_toc.txt
   exit
endif

# too many arguments: explain the syntax
if ($#argv >= 2) then
     echo " "
     echo "     *** Syntax error in command entered ***"
     echo " "
     echo "     Usage:  Ftoc    or    Ftoc  string"
     echo " "
     echo "     Note: multi-word strings need to be enclosed in quotations"
     echo " "
     exit
endif

# use grep for case-insensitive search
   grep -i "$argv[1]" $FER_DIR/doc/ferret_ug_toc.txt

#! /bin/sh
#
# shell version of run_all for Cygwin
# js

umask 002     #  make all files group deletable  3/16

# benchmark version to run ?

if [ $# = 1 ]
then
	bver=$1
else
	bver=bn500   
fi

machine="cygnus"

echo "Enter the path (including filename) to the FERRET version of choice"
read fver

# XGKS version ?  (use "xg" as the indicator)
echo $fver | grep -s "xg"
if [ $? -eq 0 ]
then
	machine="x$machine"
fi

# background info to go in the benchmark file
echo "Enter your name"
read bmarker
echo "Enter comment about this benchmark or this version of Ferret"
read bcomment

date_stamp=`date +'%d%h%yAT%H%M'|tr '[A-Z]' '[a-z]'`
log_file="all_${date_stamp}.${machine}_log"
err_file="all_${date_stamp}.${machine}_err"
plt_file="all_${date_stamp}.${machine}_plt"

# up the binary unformatted stream test file as a machine-specific link
machine_stream="stream10by5_${machine}.unf"
if [ ! -e  $machine_stream ]; then
   echo File $machine_stream does not exist.
   echo Benchmark bn420_stream will fail.
   echo To create $machine_stream compile and run make_stream_file.F
   echo Then rename stream10by5.unf to $machine_stream
   echo -n 'Continue anyway? (answer "y" for yes)'
   read answer
   if [ $answer != "y" ]
   then
    exit 0
   fi
fi
rm -f stream_data_link.unf
ln -s $machine_stream stream_data_link.unf

echo "Log output in $log_file  Errors in $err_file" 
echo "Procedure run_all to run all FERRET benchmarks" >$log_file 2>&1

echo "Running FERRET version $fver" >>$log_file 2>&1
ls -l $fver >>$log_file 2>&1
echo "Running benchmark version $bver" >>$log_file 2>&1
echo "Benchmark run by $bmarker" >>$log_file 2>&1
echo "Note: $bcomment" >>$log_file 2>&1

touch F.cdf snoopy.dat
temp_files="test.dat test.gt test.unf WV.J34K56L7 F*.cdf test*.cdf newjournal.jnl fort.41"
for file in $temp_files
do
      /bin/rm -f $file
done


# 10/97 *kob* mv last created bnplot files to the last_plot directory
#mv bnplot.* last_plot

now=`date`
echo "Beginning at $now" >>$log_file 2>&1
cp $log_file $err_file
echo "Beginning at $now"

($fver <${bver}_all_shell.jnl >>$log_file) >>$err_file 2>&1


# check status before continuing *kob* 4/98
if [ $? -ne 0 ]
then
    echo "FERRET ERROR in benchmark run ****** exiting from run.sh ******" >>$log_file
    exit 1
fi

# *kob* 11/96 - test out batch ability of ferret
#set hold_display = $DISPLAY
#setenv DISPLAY ralf
#echo "Display now set to "$DISPLAY >>$log_file 2>&1
#($fver < bn430_batch.jnl >> $log_file) >>$err_file 2>&1
#setenv DISPLAY $hold_display
#echo "Display now set to "$DISPLAY >>$log_file 2>&1

hold_display=$DISPLAY
DISPLAY=
export DISPLAY
echo "Display no longer set, about to run batch gif test"
($fver -gif <bn450_gif_shell.jnl >> $log_file) >> $err_file 2>&1
echo "Display still not set, about to run batch ps test"
($fver -batch bnplot.ps <bn450_ps_shell.jnl >> $log_file) >> $err_file 2>&1
DISPLAY=$hold_display
export DISPLAY
#echo "Display now set to "$DISPLAY >>$log_file 2>&1

now=`date`
echo  "Ended at $now" >>$err_file 2>&1
echo  "Ended at $now" >>$log_file 2>&1
echo  "Ended at $now"

# *kob* 8/96
sed 's/@ASFERRET .*Ver.*$/@ASFERRET ... whatever version number .../' <fort.41 >$plt_file


#clean_bench_log $log_file
#echo "Remember to remove metafiles, if any"

#! /bin/sh
# Copies the Homebrew .dylibs required to run the ferret executable to a
# dylibs subdirectory (creating it if not present) of the current directory.

if [ ! -d dylibs ]; then
    if [ -e dylibs ]; then
        echo "dylibs exists but is not a directory"
        exit 1
    fi
    mkdir dylibs
fi
cd dylibs

brewprefix=`brew config | awk '/HOMEBREW_PREFIX/ {print $2}'`
if [ -n "$brewprefix" ]; then
    libdir=`echo ${brewprefix}/opt/gcc/lib/gcc/*`
    echo "Copying dylib libraries from ${libdir}"
    for name in quadmath gcc_s ; do
        echo "    ${name}"
        cp -f ${libdir}/lib${name}.*.dylib .
    done
fi
